// Copyright 2014 Google Inc. All Rights Reserved.
//
// Created by postproc-cld2 4.0 on 2014-01-31 09:59:13
// From command line:
//  --nearby_probs=3.4 --extra_entries=be-Cyrl bh-Deva bs-Latn hr-Latn
//  sr-Latn gl-Latn es-Latn id-Latn ms-Latn sv-Latn  --cld2 --cc
//  --just_read_raw --quad --standard --minchars=2 --mincount=2
//  --max_items_per_langscript=6000 --flatmap --rr_alloc --freq_alloc
//  --boostcloseweakerpercent=00 --indirectbits=16 --thresh=224 --v25
//  --kentries=160 --tablename=QuadChrome0122_16 --remap=xxx-Latn=>ut-Latn
//  tw-Latn=>ak-Latn nd-Latn=>nr-Latn blu-Latn=>hmn-Latn nn-Latn=>no-Latn
//  --include=af-Latn ar-Arab be-Cyrl bg-Cyrl bs-Latn ca-Latn cs-Latn
//  cy-Latn    da-Latn de-Latn el-Grek en-Latn es-Latn et-Latn fa-Arab
//  fi-Latn fr-Latn    ga-Latn gd-Latn hi-Deva hr-Latn hu-Latn id-Latn
//  is-Latn it-Latn iw-Hebr    ja-Hani ko-Hani lg-Latn lt-Latn lv-Latn
//  mk-Cyrl ms-Latn nl-Latn no-Latn    pl-Latn pt-Latn ro-Latn ro-Cyrl
//  ru-Cyrl rw-Latn sh-Cyrl sh-Latn sk-Latn sl-Latn sr-Cyrl    sv-Latn
//  sw-Latn th-Thai tl-Latn tr-Latn uk-Cyrl vi-Latn yi-Hebr    zh-Hani zh-TW
//  zhT-Hani    sq-Latn az-Latn eu-Latn bn-Beng gl-Latn ht-Latn mt-Latn
//  sr-Latn ur-Arab    bh-Deva mr-Deva ne-Deva lg-Latn rw-Latn gd-Latn
//  ut-Latn ut-Deva    ceb-Latn blu-Latn hmn-Latn jw-Latn    so-Latn ig-Latn
//  ha-Latn yo-Latn zu-Latn --ko_english --force_to_lang_soft --nosoft_cram2
//  --nomsidlevel --shapeflatprob --langpriorpercent=10 --skipnuc
//  --noshapeforcetop --noshapeeventop --noshapesteep2 --langcounts
//  --writebin --list_items=120 --max_langs_per_item=3
//  /hdb1/cld2/probs/p90_raw_quadgrams_2014.utf8
//
// CLD2_pslangs
//
// See compact_lang_det.cc for usage
//
#include "cld2tablesummary.h"
namespace CLD2 {

// For this build date, looking up 'qpdbmrmxyzptlkuuddlrlrbas' gives AZERBAIJANI
static const uint32 kQuadChrome0122_16BuildDate = 20140131;    // yyyymmdd


// Of 390154 offered items into 163840 table entries:
// 163724 filled (41%), 558 merged (0%), 225872 dropped (57%)

// Nil-grams: 19 languages
//     GREEK MALAYALAM TELUGU TAMIL GUJARATI THAI KANNADA PUNJABI
//     GEORGIAN SINHALESE ARMENIAN LAOTHIAN KHMER DHIVEHI CHEROKEE
//     SYRIAC LIMBU ORIYA INUKTITUT

// Uni-grams: 4 languages
//     Japanese Korean Chinese ChineseT

// Words/Quads: 67 languages in range ENGLISH..HMONG:
//     ENGLISH DANISH DUTCH FINNISH FRENCH GERMAN HEBREW ITALIAN
//     NORWEGIAN POLISH PORTUGUESE RUSSIAN SPANISH SWEDISH CZECH
//     ICELANDIC LATVIAN LITHUANIAN ROMANIAN HUNGARIAN ESTONIAN
//     BULGARIAN CROATIAN SERBIAN IRISH GALICIAN TAGALOG TURKISH
//     UKRAINIAN HINDI MACEDONIAN BENGALI INDONESIAN MALAY WELSH
//     NEPALI ALBANIAN BELARUSIAN JAVANESE URDU BIHARI ARABIC CATALAN
//     BASQUE SCOTS_GAELIC SWAHILI SLOVENIAN MARATHI MALTESE
//     VIETNAMESE SLOVAK AZERBAIJANI PERSIAN BOSNIAN ZULU YIDDISH
//     SOMALI MONGOLIAN AFRIKAANS YORUBA HAUSA HAITIAN_CREOLE
//     KINYARWANDA GANDA IGBO CEBUANO HMONG

// TopLanguage  TokenCount
//  ENGLISH 2200
//  DANISH 2244
//  DUTCH 2218
//  FINNISH 2205
//  FRENCH 2207
//  GERMAN 2182
//  HEBREW 2225
//  ITALIAN 2152
//  NORWEGIAN 2233
//  POLISH 2213
//  PORTUGUESE 2226
//  RUSSIAN 2139
//  SPANISH 3167
//  SWEDISH 3274
//  CZECH 4498
//  ICELANDIC 2205
//  LATVIAN 2201
//  LITHUANIAN 2202
//  ROMANIAN 4306
//  HUNGARIAN 2209
//  ESTONIAN 2212
//  BULGARIAN 2149
//  CROATIAN 3414
//  SERBIAN 5250
//  IRISH 2247
//  GALICIAN 3148
//  TAGALOG 2091
//  TURKISH 2231
//  UKRAINIAN 2167
//  HINDI 4330
//  MACEDONIAN 2156
//  BENGALI 2231
//  INDONESIAN 4024
//  MALAY 2752
//  WELSH 2214
//  NEPALI 2183
//  ALBANIAN 2210
//  BELARUSIAN 3189
//  JAVANESE 2218
//  URDU 2212
//  BIHARI 3621
//  ARABIC 2184
//  CATALAN 2236
//  BASQUE 2241
//  SCOTS_GAELIC 2255
//  SWAHILI 2232
//  SLOVENIAN 2223
//  MARATHI 2141
//  MALTESE 2245
//  VIETNAMESE 2200
//  SLOVAK 2227
//  AZERBAIJANI 2232
//  PERSIAN 2204
//  BOSNIAN 2783
//  ZULU 2208
//  YIDDISH 2154
//  SOMALI 2233
//  MONGOLIAN 15
//  AFRIKAANS 2208
//  YORUBA 2212
//  HAUSA 2238
//  HAITIAN_CREOLE 2225
//  KINYARWANDA 2199
//  GANDA 2273
//  IGBO 2175
//  CEBUANO 2006
//  HMONG 1978



// Recognized language-script combinations [69]:
static const char* const kQuadChrome0122_16RecognizedLangScripts =
  "af-Latn ar-Arab az-Latn be-Cyrl bg-Cyrl bh-Deva bn-Beng bs-Latn "
  "ca-Latn ceb-Latn cs-Latn cy-Latn da-Latn de-Latn en-Latn es-Latn "
  "et-Latn eu-Latn fa-Arab fi-Latn fr-Latn ga-Latn gd-Latn gl-Latn "
  "ha-Latn hi-Deva hmn-Latn hr-Latn ht-Latn hu-Latn id-Latn ig-Latn "
  "is-Latn it-Latn iw-Hebr jw-Latn lg-Latn lt-Latn lv-Latn mk-Cyrl "
  "mn-Latn mr-Deva ms-Latn mt-Latn ne-Deva nl-Latn no-Latn pl-Latn "
  "pt-Latn ro-Cyrl ro-Latn ru-Cyrl rw-Latn sk-Latn sl-Latn so-Latn "
  "sq-Latn sr-Cyrl sr-Latn sv-Latn sw-Latn tl-Latn tr-Latn uk-Cyrl "
  "ur-Arab vi-Latn yi-Hebr yo-Latn zu-Latn ";

static const uint32 kQuadChrome0122_16Size = 32768;    // Bucket count
static const uint32 kQuadChrome0122_16KeyMask = 0xffff8000;    // Mask hash key

static const IndirectProbBucket4 kQuadChrome0122_16[kQuadChrome0122_16Size] = {
  // hash_indirect[4], tokens[4] in UTF-8
   {{0xe9da0002,0xe2970003,0x7c2e0004,0x20078005}},	// [000] вка_, аат_, ssbr, _huni_,
   {{0x20078006,0x64438007,0xbddb0008,0x23bf0009}},	//   _kuni_, kuni, stèr, täjä_,
   {{0xddc4000a,0x6563800b,0x52e2800c,0x02e2800d}},	//   _križ, denh, _पर्स, _पर्न,
   {{0x6443800e,0x4916000f,0x63bb8010,0x20078011}},	//   duni, _प्रो_, jiun, _muni_,
   {{0x20078012,0x3ea08013,0x27ed8014,0x63a98015}},	//   _luni_, áit_, _dhen_, dhen,
   {{0x65638016,0x64438017,0x6fdd0018,0xef1f0019}},	//   genh, funi, léct, tjük_,
   {{0x6443801a,0x3ea0801b,0x2451801c,0x2007801d}},	//   guni, šit_, _cơm_, _nuni_,
   {{0x63bb801e,0xef1f0019,0x63a9801f,0x6fdd0020}},	//   giun, rjük_, ghen, néct,
   {{0x36678021,0x65638022,0xa3ab0023,0x2fc68024}},	//   _като_, benh, कोट_, mnog_,
   {{0x2fc68025,0x64438026,0x645e0009,0x20078027}},	//   lnog_, buni, _oppi, _buni_,
   {{0x2b9c0028,0x75288029,0x63bb802a,0x6aad002b}},	//   _tích_, _iedz, biun, zzaf,
   {{0x63a9802c,0x4ea7002d,0x63bb802e,0x2252002f}},	//   chen, арга, ciun, ktyk_,
   {{0x69dc0030,0x645e0031,0xadc38032,0x6b828033}},	//   _okre, _appi, _atẹn, _inog,
   {{0x6e240034,0x75288035,0x2b988036,0x20078037}},	//   _dwib, _jedz, _vécu_, _funi_,
   {{0x75288038,0x89378039,0xddc40024,0x212c8014}},	//   _medz, _כרגע_, _friž, madh_,
   {{0x2fc6803a,0x248d003b,0x212c803c,0xf699003d}},	//   jnog_, ćem_, ladh_, _منبع_,
   {{0x6b82803b,0x2fc68025,0x7afd803e,0xafb8003f}},	// [010] _mnog, dnog_, žstv, _خطوط_,
   {{0x212c803c,0x63bb802e,0x64438040,0x20078041}},	//   nadh_, ziun, yuni, _yuni_,
   {{0x6b828042,0x69d70043,0x65638044,0x27ed8045}},	//   _onog, roxe, venh, _phen_,
   {{0x212c8046,0x69dc0047,0xa8040048,0xc7c48049}},	//   hadh_, _ekre, ізіл, осчи,
   {{0x44310019,0x75288035,0x63a9804a,0x672b804b}},	//   lsz_, _bedz, vhen, ragj,
   {{0x27ed804c,0x6443804d,0x9474004e,0x26df804f}},	//   _when_, tuni, _ادیا, _vyuo_,
   {{0x63bb8012,0x65638050,0x2fc68024,0x27ed8051}},	//   tiun, renh, bnog_, _then_,
   {{0x2fc68052,0x65638053,0xa3ab0054,0x20078055}},	//   cnog_, senh, कोच_, _runi_,
   {{0xe9d98056,0x63a98057,0x64438058,0x29188059}},	//   лки_, rhen, suni, ıran_,
   {{0x212c803c,0x63bb805a,0x63a9805b,0x2007805c}},	//   gadh_, siun, shen, _puni_,
   {{0x63a9805d,0xa3d7005e,0x6616005f,0x8d748060}},	//   phen, ाका_, _styk, _باقا,
   {{0x44310061,0x66018062,0x6fdd002a,0xd5438032}},	//   dsz_, _hilk, xéct, _fẹ̀f,
   {{0x66018063,0xeab38064,0x7e6d0065,0x67298066}},	//   _kilk, _بعض_, _csap, _meej,
   {{0x2fc68067,0x212c8068,0x67298069,0xb21b006a}},	//   znog_, cadh_, _leej, _kræf,
   {{0x1015806b,0x64a3006c,0xfce6006d,0x7e6d006e}},	//   _ابتد, пара, сово, _esap,
   {{0x69dc006f,0xee3f003e,0x260a8006,0x67298070}},	//   _skre, brý_, ादमी_, _neej,
   {{0x2fc6803a,0x0aea0071,0x3a3f802a,0x28a58072}},	// [020] vnog_, удай_, nrup_, खनवि,
   {{0xa5bb0073,0x46db8074,0x31710037,0xda0a8075}},	//   ssór, _बड़ह, _cazz_, _हंसत_,
   {{0x2fc6803a,0xaad80076,0x75288029,0x7e7b8077}},	//   tnog_, _भुरक, _redz, _arup,
   {{0xbb860013,0x43860013,0xfdb0800f,0xa3e7800f}},	//   _الحي, _الحق, जफ्फ, _मील_,
   {{0x2fc68025,0x66018078,0x65948009,0x291e8079}},	//   rnog_, _bilk, жалу, ybta_,
   {{0x69dc007a,0x3a3f806a,0xdb16007b,0x8e57007c}},	//   _ukre, drup_, ábær, מינג_,
   {{0x2fc6805c,0x3860807d,0x66018079,0xe644807e}},	//   pnog_, _ćiro_, _dilk, ğlığ,
   {{0x5214807f,0xe6448059,0x79838080,0x53988081}},	//   одит, şlığ, _annw, рвия_,
   {{0x22400082,0x212c8083,0xa92a8084,0x6fc80085}},	//   nrik_, tadh_, ліне_, rıcl,
   {{0x388e8086,0xf96a8087,0x20098088,0x44310035}},	//   ləri_, урий_, _čair_, ysz_,
   {{0x212c803c,0x22400089,0x6729808a,0xdb0d008b}},	//   radh_, hrik_, _yeej, knað,
   {{0x212c808c,0x6601808d,0x212a008e,0x96f9008f}},	//   sadh_, _zilk, _lebh_, иент_,
   {{0x4ad80076,0x212c8090,0x9f588091,0x44310092}},	//   _भुलव, padh_, _burú_, wsz_,
   {{0x44310019,0x22400093,0x66018079,0x6d4a8094}},	//   tsz_, drik_, _xilk, ngfa,
   {{0x69da8095,0x79950063,0xe8d98028,0x69c88096}},	//   mote, _rozw, _đủ_, mnde,
   {{0x7ae28097,0x67d40098,0x22400099,0xdb0d007b}},	//   _kyot, _нощу, frik_, gnað,
   {{0x7995009a,0x44310019,0xddc2809b,0x7e6d009c}},	// [030] _pozw, ssz_, dvož, _usap,
   {{0x69da809d,0x672f0063,0x69c8809e,0x6441009f}},	//   note, lacj, nnde, àlis,
   {{0xe71980a0,0x439500a1,0x388e8085,0x644100a2}},	//   ليات_, _данс, fəri_, álid,
   {{0x644700a3,0x200a00a4,0xe00b80a5,0x672f0035}},	//   muji, _dubi_, _संसद_, nacj,
   {{0x69da80a6,0x660180a7,0x63ad00a8,0x7e7b8085}},	//   kote, _pilk, mhan, _qrup,
   {{0x63ad00a9,0x69da80aa,0xcfcf00ab,0xd6580039}},	//   lhan, jote, রতিন, ציות_,
   {{0x660180ac,0x645500ad,0x672f0063,0x200a0052}},	//   _vilk, ntzi, kacj, _gubi_,
   {{0x36d580ae,0xeb9980af,0x69c880b0,0x7e7b80b1}},	//   _добр, рии_, ende, _trup,
   {{0x660180b2,0xbfa880b3,0x7e7b80b4,0x69da80b5}},	//   _tilk, _утре_, _urup, fote,
   {{0x499980b6,0xfeb880b7,0x644700b8,0x3b1f80b9}},	//   ртия_, _طاقت_, kuji, sbuq_,
   {{0xa3e900ba,0xe2a88077,0x63ad00bb,0xfbd900bc}},	//   यता_, لاین_, khan, भकाम,
   {{0x69c880bd,0x9986809a,0x14d680be,0xaa5980bf}},	//   ande, _ktoś_, _וועל_, _виду_,
   {{0x63ad00c0,0x69da80c1,0xc8e600c2,0xddc400c3}},	//   dhan, bote, _कर्म_, _asiš,
   {{0x98a580c4,0xa0a580c5,0x7bc980c6,0x63ad00c7}},	//   _миле, _малд, lneu, ehan,
   {{0x09c400c8,0x63ad00c9,0x8b9600ca,0x3b9600a9}},	//   ্তমা, fhan, орач, ојат,
   {{0x63ad00cb,0x7bc980cc,0x2fcd80cd,0x7c3a00ce}},	//   ghan, nneu, _njeg_, štro,
   {{0xa3bb00cf,0x27e000d0,0x200a00d1,0x7c2900d2}},	// [040] _अगर_, _ikin_, _subi_, ćera,
   {{0x224000d3,0x0f2280d4,0x2b4f808e,0x2b58003d}},	//   rrik_, मर्स_, _lcgc_, _گیرد_,
   {{0xc8ca00d5,0x106a00d6,0x13a800d7,0x7bc980d8}},	//   جوان_, рией_, _هندی_, kneu,
   {{0x68e380d9,0x63ad00da,0xa3ae001b,0x69da80db}},	//   _mynd, chan, _कति_, zote,
   {{0xa3d700dc,0x27e000dd,0x69da80de,0x69c68061}},	//   ाकर_, _mkin_, yote, ékek,
   {{0x672f0063,0x200a00df,0x63a400e0,0x644100e1}},	//   zacj, _tubi_, lkin, šlie,
   {{0x07a680e2,0x6d4a80e3,0x7ae280e4,0x201800e5}},	//   _давн, rgfa, _syot, _utri_,
   {{0x63a400e6,0x7bc980e7,0x81e780ab,0xd32680e8}},	//   nkin, gneu, _মূল_, цьки,
   {{0x298a80e9,0x63a400ea,0xdcfe00eb,0xb21b00ec}},	//   асно_, ikin, _kopē, _græd,
   {{0x69c880ed,0x7ae2804f,0x2a6200ee,0x27e680ef}},	//   unde, _vyot, _mpkb_, llon_,
   {{0x200480f0,0x201880f1,0xdb060019,0x672f009a}},	//   _kimi_, ëri_, _elké, tacj,
   {{0x290780f2,0x63a400f3,0x69da80f4,0x27e680f5}},	//   _egna_, jkin, sote, nlon_,
   {{0x200480f6,0x672f0063,0xd25080f7,0x69da80f8}},	//   _mimi_, racj, _أنت_, pote,
   {{0x7bc080f9,0x200480fa,0x27e680fb,0x63ad00fc}},	//   limu, _limi_, hlon_, whan,
   {{0x63ad00fd,0x27e6803b,0x63a400fe,0x261080ff}},	//   than, klon_, fkin, _lào_,
   {{0x20048100,0x2a620101,0x64550102,0x52150103}},	//   _nimi_, _bpkb_, rtzi, здат,
   {{0x26108104,0xe8108105,0xdb0b8106,0x1dbc8107}},	// [050] _nào_, _ठंडा_, _umgå, ्चात,
   {{0x63ad0108,0x7bc08109,0xddc2809a,0x6447010a}},	//   shan, himu, rtoś, puji,
   {{0x672d010b,0x660d010c,0x63a4010d,0x7bc0810e}},	//   _keaj, _huak, bkin, kimu,
   {{0x63a40039,0xf093810f,0x261080ff,0x7bc08110}},	//   ckin, ונע_, _bào_, jimu,
   {{0xa3e40105,0x7bc08111,0xa77c00be,0x660500b9}},	//   _पीट_, dimu, יראפ, _kihk,
   {{0x98a5802e,0x5a340112,0x99640113,0x7bc98114}},	//   nală_, _інст, _отсл, wneu,
   {{0xdd8e80f7,0x22490102,0x20048115,0x27e68116}},	//   اوى_, luak_, _fimi_, blon_,
   {{0xd90e0117,0xdb028118,0x7bc08119,0xb21b006a}},	//   _لیے_, _eloí, gimu, _træd,
   {{0x76428036,0xdce3811a,0x2249011b,0x68e6811c}},	//   croy, menč, nuak_, əkdi,
   {{0x661b811d,0x63a4011e,0x2004811f,0xae44803d}},	//   _ituk, zkin, _zimi_, _آپلو,
   {{0x63a40120,0x7bc08121,0x660d0122,0x7bc98123}},	//   ykin, bimu, _auak, pneu,
   {{0xf7720124,0x6d410125,0x2249011b,0x6e298126}},	//   راج_, ólan, kuak_, _kweb,
   {{0xa3ca8127,0xa3c10128,0x290780ee,0x26108129}},	//   ोवर_, ्चन_, _tgna_, _xào_,
   {{0xdd920077,0x427a812a,0x67228024,0x7c29012b}},	//   روز_, _לאנג, zboj, ćern,
   {{0x63a4012c,0x27e6812d,0x69c1812e,0x9479012f}},	//   tkin, ylon_, mile, осту_,
   {{0x69c18130,0x6f098131,0xdce38132,0xfd4c8133}},	//   lile, _ngec, jenč, _belụ,
   {{0xc64a0013,0xeb970134,0x69c18083,0x6e298135}},	// [060] _اجعل_, чит_, oile, _nweb,
   {{0x20048136,0x63a40137,0xb6bb0051,0x867b012a}},	//   _simi_, skin, _לצפי, _פריו,
   {{0x63a40138,0x036a0139,0xfce6013a,0x661b813b}},	//   pkin, _линк_, _хоно, _atuk,
   {{0xb21b013c,0x69c1813d,0x2249013e,0x2d9a0039}},	//   _dræb, hile, buak_, _hope_,
   {{0x69c1813f,0x672280eb,0x7bc08110,0xddc98140}},	//   kile, rboj, vimu, _drež,
   {{0x6d4e0141,0x26108142,0x6d5c0143,0x76428144}},	//   ngba, _vào_, nfra, rroy,
   {{0x69c18145,0x6e298146,0x27e68147,0x20048148}},	//   dile, _eweb, plon_, _timi_,
   {{0x69de0149,0x7e6400d2,0x65ab0085,0x7642814a}},	//   lope, _opip, _müha, proy,
   {{0xadc38028,0x7bc0814b,0xe944803d,0x9d46814c}},	//   _quản, rimu, وردی, _неад,
   {{0x7bc0814d,0x69c1814e,0x6d4e00f3,0x69de014f}},	//   simu, gile, jgba, nope,
   {{0x7bc08150,0x672d0151,0x290a0135,0xe8df00ff}},	//   pimu, _peaj, _mgba_, _trục_,
   {{0x37ab0152,0xeb978153,0xd36f8154,0x660d00ee}},	//   стон_, _них_, _مهم_, _puak,
   {{0x69c18155,0x6d5c0156,0x69de0157,0xe3b38158}},	//   bile, ffra, kope, _אױף_,
   {{0x72eb8159,0x69c1815a,0xe9448077,0xf9c4815b}},	//   _פֿאַ, cile, _آرشی, _تحصی,
   {{0xd5c88104,0x98a58087,0x7c29012b,0xe7e8015c}},	//   yền_, rală_, ćero, _टीका_,
   {{0x2249011e,0x660d015d,0x290a015e,0x6d4e015f}},	//   tuak_, _tuak, _agba_, agba,
   {{0xb9990160,0xdce38161,0x98a58162,0x644a0163}},	// [070] овах_, venč, pală_, _åfin,
   {{0x5c070098,0x644a8164,0x22490102,0xc1788110}},	//   _няма, kufi, ruak_, ndė_,
   {{0x3ea60029,0xddc98165,0x661b8166,0x2249011b}},	//   _ļoti_, _prež, _stuk, suak_,
   {{0x69c18167,0x6443807a,0x65770168,0x290a0032}},	//   zile, vrni, _haxh, _egba_,
   {{0x69c18169,0x7bdf016a,0xee3880e8,0xddc98088}},	//   yile, moqu, зні_, _vrež,
   {{0x7bdf00a2,0x050100ab,0xddd6016b,0xfce5816c}},	//   loqu, ্রীর_, _kryš, моло,
   {{0x6458816d,0x200e8041,0x65770168,0x6443816e}},	//   gtvi, _nufi_, _maxh, urni,
   {{0x09b7816f,0x7bcd0170,0x22158171,0x64c50115}},	//   ेच्य, nnau, мфор, _ičić,
   {{0x69c18172,0x6d5c0114,0x661b8173,0xd24e8174}},	//   tile, yfra, _utuk, لني_,
   {{0x7bcd0175,0x23c38176,0x6d410177,0x10a58178}},	//   hnau, _bèjè_, ólal, дион,
   {{0x69c18179,0x5455817a,0xe3c2017b,0xf746017c}},	//   rile, _цвет, lmış_, мено,
   {{0x69c1817d,0xd24e817e,0x7c3a017f,0xe2918180}},	//   sile, دنی_, štrk, _لذت_,
   {{0x65b00181,0xe3c20182,0x6d5c0183,0x69c18184}},	//   _lähe, nmış_, tfra, pile,
   {{0x90c58185,0x7ae60186,0x65ab0074,0x69de0187}},	//   _обле, _rykt, _püha, xope,
   {{0xfce30188,0x6d5c0189,0x7bdf018a,0xa507018b}},	//   воро, rfra, foqu, дера_,
   {{0x8ffa003d,0x320f808e,0x764b818c,0x6441018d}},	//   _برتر_, _kugy_, kugy, ália,
   {{0xd5b20019,0x2fc0018e,0x7c248115,0x3207818f}},	// [080] _لفظ_, _imig_, ćiri, _kiny_,
   {{0xb1430190,0xa0a60191,0x320f810c,0x65ab0192}},	//   кнул, мазд, _mugy_, _hühn,
   {{0xeb9a0193,0x69de0194,0xb21b006a,0x8b260195}},	//   _дин_, rope, _præc, _одне,
   {{0xfaa60196,0x46ea80b3,0x201c00eb,0xddc98197}},	//   _жамо, оден_, īvi_, _ereż,
   {{0x65b00198,0xfe6f8199,0x05d20035,0x69de019a}},	//   _tähd, لدو_, _सदाब, pope,
   {{0x6458819b,0x443a019c,0x290a019d,0x644a819e}},	//   ttvi, _kvp_, _ugba_, tufi,
   {{0xd90d019f,0x910301a0,0x443a00c3,0x443801a1}},	//   _ایم_, _апре, _jvp_, nsr_,
   {{0xda088104,0x28bd01a2,0x645881a3,0x02a681a4}},	//   _hỏi_, ्परि, rtvi, дром,
   {{0x200e81a5,0x961880ab,0x6f09016b,0x6aa401a6}},	//   _sufi_, _ডটকম_, žeck, nyif,
   {{0x6e2281a7,0xb5aa81a8,0x443800b9,0x67d201a9}},	//   mpob, _بارك_, ksr_, vāja,
   {{0x26ee81aa,0xda0880ff,0xa3ae01ab,0x65ab0192}},	//   _जरुर_, _mỏi_, कसा_, _bühn,
   {{0xdce501ac,0x67d200eb,0x733681ad,0x338381ae}},	//   _pohľ, tāja, _آرائ, _аушв,
   {{0xa3e781af,0x799c01b0,0x7bdf01b1,0x200e80b9}},	//   _मीट_, _oorw, voqu, _wufi_,
   {{0x58d481b2,0x29070110,0xdb0b81b3,0x660881b4}},	//   _полт, žnai_, _algè, _jidk,
   {{0x7bdf00a9,0x66088079,0x9f588144,0xd13981b5}},	//   toqu, _midk, _juró_, _ххі_,
   {{0x26ee81b6,0x628281b7,0x67d200eb,0x53de816f}},	//   _जरूर_, _kroo, pāja, मविश,
   {{0x7bcd01b8,0x050100ab,0xddc981b9,0x799c01ba}},	// [090] rnau, ্রের_, _preż, _borw,
   {{0x51f801bb,0xaca301bc,0x2a6680ee,0xd13101bd}},	//   дную_, _arụg, _mpob_, اما_,
   {{0x753501be,0x200901bf,0x9f9c808b,0x443a01c0}},	//   mazz, _kiai_, tíð_, _gvp_,
   {{0x753501c1,0x65b001c2,0x6e2d01c3,0xa635804a}},	//   lazz, _vähe, _kwab, енді,
   {{0x59de81c4,0x628281c5,0x6e2d008e,0x799c01c6}},	//   नकार, _nroo, _jwab, _forw,
   {{0x753501b9,0x65b00006,0x9f588144,0xba430084}},	//   nazz, _tähe, _buró_, žįst,
   {{0x76598114,0x628281c7,0x3ea981c8,0x64c50088}},	//   stwy, _aroo, šat_, _učić,
   {{0x6f0d01c9,0x9f5881ca,0x6aca81cb,0xe3c201cc}},	//   _ngac, _duró_, ापूर, pmış_,
   {{0x753501cd,0xb4bc01ce,0x020581cf,0x67f601d0}},	//   kazz, _अध्_, нзин, náje,
   {{0xf9918013,0x628280c9,0x6b9d01d1,0x7c3a017f}},	//   ابة_, _droo, _losg, štri,
   {{0xa3c101d2,0xfc3080f7,0x2011004f,0x39588014}},	//   ्चा_, _نحن_, _juzi_, òrsa_,
   {{0x6e2d01d3,0x201101d4,0x69c501d5,0x248601d6}},	//   _bwab, _muzi_, hihe, _čom_,
   {{0xee3701d7,0x628281d8,0xa68301d9,0x6b8b81da}},	//   ння_, _groo, гляд, _ingg,
   {{0xceb281db,0x753501dc,0x7c2201dd,0x236d81de}},	//   נים_, gazz, _čorb, leej_,
   {{0x77a601df,0xdb0b80e7,0x69c501e0,0x6b9d01e1}},	//   _lóxi, _algé, dihe, _bosg,
   {{0xddcd01e2,0x63a981e3,0x2009001c,0x6b9d01e4}},	//   _graž, nken, _giai_, _cosg,
   {{0x6b6301e5,0xe8df801c,0x799c01e6,0x6b8b80dd}},	// [0a0] ыкта, _khỏi_, _porw, _mngg,
   {{0x61e181e7,0x753501e8,0x236d81e9,0x63a981ea}},	//   noll, cazz, heej_, hken,
   {{0x63a981eb,0x799c01ec,0x6b9d01e4,0x03a60087}},	//   kken, _vorw, _fosg, _зино,
   {{0x201100d2,0x63a981ed,0x644e01ee,0x61e181ef}},	//   _duzi_, jken, mubi, holl,
   {{0x61e181f0,0x63a9813c,0x99800110,0xdfcf81a8}},	//   koll, dken, usių_, حين_,
   {{0x6b8b81f1,0xdd9080f7,0x63a981f2,0xda088129}},	//   _angg, شوب_, eken, _tỏi_,
   {{0x186701f3,0x316c81ac,0x201101f4,0x61e181f5}},	//   _пари_, vedz_, _guzi_, doll,
   {{0x2a66808e,0x67d201a9,0x7c38800b,0x656e01f6}},	//   _ppob_, dājo, rsvr, hebh,
   {{0x645c01f7,0x644e01f8,0xdd8f81f9,0x6d4101fa}},	//   htri, hubi, _گول_, ólak,
   {{0x6b8b81fb,0x644e01fc,0xbddb01fd,0x6e2d00b4}},	//   _engg, kubi, trèm, _rwab,
   {{0xa3d001fe,0x753501ff,0x2d8c8200,0xd8f880e8}},	//   वचा_, vazz, _inde_, ьної_,
   {{0x645a8201,0x63a98202,0xe7cf00ab,0x657a8203}},	//   _iqti, cken, রত্য, _hath,
   {{0x657a8204,0x2d9e8205,0x61e18206,0xb5fb0207}},	//   _kath, _kote_, boll, ntág,
   {{0x61e18208,0xd12f8077,0xb21b013c,0x2d9e8168}},	//   coll, _همه_, _bræn, _jote_,
   {{0xddcd0209,0x753501cd,0x6b9d020a,0xa4d400e8}},	//   _traž, razz, _posg, горі,
   {{0x657a820b,0x6e2d020c,0x3ea6820d,0x25dc820e}},	//   _lath, _twab, kyot_, मकुण,
   {{0x245a820f,0x2d8c8210,0x75350211,0x21310176}},	// [0b0] hëm_, _onde_, pazz, _pezh_,
   {{0x657a8212,0xdb0d00f7,0x2d9e8213,0x3eb30214}},	//   _nath, mhaí, _note_, ıntı_,
   {{0xb21b0215,0x644e0216,0x69c50217,0x645c0218}},	//   _græn, cubi, rihe, ctri,
   {{0x44210219,0x201c021a,0x61fe021b,0x69c5021c}},	//   _ith_, ívia_, ampl, sihe,
   {{0x2d9e821d,0xe618821e,0x3ea6821f,0x8b9a0039}},	//   _bote_, еді_, gyot_, _חברת,
   {{0x7bc28220,0xbea28221,0x2d9e8222,0x644800eb}},	//   _amou, рашк, _cote_, šdie,
   {{0x61e18223,0x657a8224,0xeb998225,0xabd58226}},	//   voll, _dath, дий_, кциј,
   {{0x2d8c8227,0x77a60228,0xc1788110,0x657a8229}},	//   _ende_, _tóxi, klės_, _eath,
   {{0x61e1822a,0x853c8084,0xddcd022b,0x98ac81a9}},	//   toll, _plėt, _braż, vadā_,
   {{0x926480f7,0x236d822c,0xb5fb0118,0x777b811b}},	//   اديم, seej_, ntád, _haux,
   {{0xb604000d,0x645c022d,0xe80b8105,0x6b8b80dd}},	//   ntář, xtri, _सूखा_, _tngg,
   {{0x2d9e822e,0x6b8b822f,0x22490230,0x61e18231}},	//   _zote_, _ungg, krak_, soll,
   {{0x2d9e822e,0x61e18232,0x44210233,0x657a8234}},	//   _yote_, poll, _ath_, _yath,
   {{0x645c0235,0xa5bb0236,0x61458237,0x644e0238}},	//   ttri, spón, _река, tubi,
   {{0xb0248104,0x44210239,0xfce6006d,0x22490102}},	//   _trườ, _cth_, тово, erak_,
   {{0x1e86023a,0xf41380ab,0x764f023b,0x2c7c81d0}},	//   _алим, _সবার_, bucy, ládá_,
   {{0xc332804c,0x6d41803a,0x2619023c,0x644e023d}},	// [0c0] יון_, _odla, _यूपी_, subi,
   {{0xb21b0022,0x3f8d823e,0xa92480e1,0xe9d7023f}},	//   _træn, _aneu_, peľň, вку_,
   {{0x657a8240,0x2d9e8241,0x7e698242,0x7aeb8243}},	//   _rath, _rote_, _apep, _lygt,
   {{0x6d418244,0xdce88038,0x2d9e8245,0x22490246}},	//   _adla, _podľ, _sote_, brak_,
   {{0x2d9e8247,0xa3c10054,0x69c38248,0xeb970249}},	//   _pote_, ्चर_, _omne, _рия_,
   {{0x245a820f,0x2fc68110,0x44210101,0x7c3a024a}},	//   tëm_, siog_, _yth_, štru,
   {{0x6da3824b,0x6aca824c,0x629d8106,0x2d9e824d}},	//   рија, ाप्र, äson, _vote_,
   {{0x2d9e822e,0x6286024e,0x657a805d,0x8fa3824f}},	//   _wote_, _krko, _wath, _касе,
   {{0xe73781a1,0xa6658250,0xcb678251,0x2d9e8252}},	//   _шет_, _مطلو, тање_, _tote_,
   {{0x2d8c8012,0x657a80f7,0x601e80eb,0x62860253}},	//   _unde_, _uath, _līme, _mrko,
   {{0x31370039,0x7f590254,0x22490255,0x1cba8061}},	//   כנים_, нанс_, zrak_, _غائب_,
   {{0x97a70256,0x69c38257,0xdb0d00f7,0x1fa70258}},	//   трол, _emne, thaí, трог,
   {{0xecdb000f,0xdddb8259,0xa2c2025a,0x629601c0}},	//   _मुजफ, _hruš, _रेल्, jxyo,
   {{0xdddb825b,0x765d025c,0xdbd1808b,0x764f018e}},	//   _kruš, rtsy, lýðs, rucy,
   {{0xd5b8025d,0xb4ad025e,0xa3d680c2,0x81d800ab}},	//   тся_, कने_, _सदा_, াতা_,
   {{0x6286012b,0x644a81a8,0x7d080061,0x9cd7825f}},	//   _brko, irfi, _sérü, דולה_,
   {{0x27e90260,0x62848084,0x443c8088,0x777b8261}},	// [0d0] _ikan_, _šioj, hsv_, _raux,
   {{0x224900ad,0x69c88262,0x645a009f,0x23b180e1}},	//   rrak_, nide, àtic, _mája_,
   {{0x290700f2,0x62860263,0x981401a8,0x4cc10264}},	//   äna_, _erko, لبنا, _শুরু,
   {{0x63b60265,0x69c88266,0x75220267,0x22490268}},	//   chyn, hide, _đozi, prak_,
   {{0x69c88269,0x2509026a,0x3f8181d0,0xadc4026b}},	//   kide, _ترکی_, ěhu_, _arẹw,
   {{0x24858101,0x2b59026c,0x6d55026d,0xf483803d}},	//   _prlm_, _hcsc_, ngza, لاعی,
   {{0x27e9026e,0x61e5026f,0x69c88270,0x25a101d0}},	//   _okan_, mohl, dide, _mohl_,
   {{0x63ad0271,0xb5fb0272,0xdb098073,0xaca3019d}},	//   nkan, ntáb, nheç, _abịd,
   {{0x443e8273,0x1a65826a,0x7e69804f,0xb5fb0118}},	//   _evt_, ایتی_, _upep, itáb,
   {{0x27e90274,0x69c88275,0x63ad0057,0x6d418276}},	//   _akan_, gide, hkan, _udla,
   {{0xcea90158,0xcb558277,0x8fa60278,0x64410279}},	//   _צי_, _مناظ, гане, šlij,
   {{0x63ad027a,0x61e5027b,0x69c8827c,0x2619827d}},	//   jkan, hohl, aide, _kèo_,
   {{0x69c880ad,0xe1ee827e,0x200d8098,0xdddb827f}},	//   bide, _гг_, _miei_, _zruš,
   {{0x27e90280,0x63ad0281,0x237d8282,0x7bc98283}},	//   _ekan_, ekan, _hawj_, lieu,
   {{0x98ac8162,0xbb460284,0x225f8285,0x63b60286}},	//   radă_, левк, ltuk_, thyn,
   {{0x7bc98287,0xc0528051,0x63ad0288,0x62860289}},	//   nieu, _הזה_, gkan, _prko,
   {{0x225f828a,0xe1fa028b,0x63b6028c,0x6abb81ec}},	// [0e0] ntuk_, ега_, rhyn, nzuf,
   {{0x63ad028d,0x237d822c,0x6e240214,0x7c3e0115}},	//   akan, _lawj_, _itib, _tvpr,
   {{0x11d70013,0xdca6028e,0x9c7c828f,0x70560290}},	//   دولة_, _сани, _tyči, انصا,
   {{0x69c88291,0x63ad0292,0xee3a8293,0x237d8282}},	//   zide, ckan, енд_, _nawj_,
   {{0xdddb8067,0x443e816d,0x56948162,0x6da68294}},	//   _sruš, _svt_, ралт, лида,
   {{0x443e8295,0xdddb8296,0x2816003d,0x644a8088}},	//   _pvt_, _pruš, _موسس, trfi,
   {{0x657e0297,0xb5fb0298,0x66160299,0xdd32029a}},	//   _maph, ltác, _luyk, zəşt,
   {{0x657e029b,0x7bc9829c,0x7f440168,0x69c8829d}},	//   _laph, gieu, _ndiq, wide,
   {{0x69c8829e,0xb5fb029f,0x237d81c0,0x6e2402a0}},	//   tide, ntác, _dawj_, _ntib,
   {{0xd6cf8277,0x657e0234,0x27e682a1,0xb33b02a2}},	//   _عقل_, _naph, loon_, _moça,
   {{0x63ad02a3,0x0c2682a4,0xdddb82a5,0x6b9b82a6}},	//   ykan, _смен, _uruš, bjug,
   {{0x27e682a7,0x7bc980e7,0x7a868019,0x644101a9}},	//   noon_, cieu, _مشتم, šlik,
   {{0xb8eb82a8,0x199482a9,0x78ba8019,0x657e0234}},	//   _रे_, _валя, sztv, _baph,
   {{0x27e682aa,0x2d9c80f1,0x63a28074,0x2a79018e}},	//   hoon_, njve_, _hoon, _rssb_,
   {{0x63a282ab,0xf36702ac,0x63ad02ad,0x27e682ae}},	//   _koon, лтан, tkan, koon_,
   {{0x764b8286,0x25a102af,0x63a282b0,0x67f600e1}},	//   yrgy, _wohl_, _joon, pája,
   {{0x6d5a82b1,0x65ab0074,0x27e681b4,0x38c90019}},	// [0f0] _octa, _lühi, doon_, ھائی_,
   {{0x63ad02b2,0x63a282b3,0x26188105,0x2bc602b4}},	//   skan, _loon, _पढ़ी_, रोबा,
   {{0x44ce8086,0x27e682b5,0x63ad02b6,0xb5fb02b7}},	//   _nə_, foon_, pkan, ptáb,
   {{0x63a282b8,0xbddb00e7,0x27e682b9,0x61fc01ec}},	//   _noon, ssèd, goon_, _ehrl,
   {{0xd9f68076,0xb5fb02ba,0x6b9b826c,0x657e0234}},	//   ुगात_, ctác, vjug, _yaph,
   {{0xdcfa82bb,0xdca582bc,0x9f42016b,0x3a2900ee}},	//   _altı, иали, roké_, mpap_,
   {{0x63a282bd,0x290502be,0x9f42026f,0x27e681b4}},	//   _boon, _àla_, soké_, boon_,
   {{0x44ce82bf,0xc24582c0,0x225f8061,0x2619827d}},	//   _də_, аник, ttuk_, _tèo_,
   {{0x63a282c1,0x7bc982c2,0x6d4502c3,0x7e6d02c4}},	//   _doon, rieu, _odha, _npap,
   {{0xb5fd803b,0x7bc982be,0x7e7b82c5,0xaca3026b}},	//   _opši, sieu, _isup, _abọd,
   {{0x7e6d02c6,0xe8f682c7,0x63a282c8,0x225f82c9}},	//   _apap, иль_, _foon, stuk_,
   {{0x6d4502ca,0x8e8602cb,0x657e02cc,0x63a281b4}},	//   _adha, агме, _saph, _goon,
   {{0x7c2502cd,0x69c702ce,0x44258088,0x2bb880f7}},	//   _athr, _omje, _htl_, _حالة_,
   {{0x63a282cf,0x44ce811c,0x291f02d0,0x27e682d1}},	//   _zoon, _yə_, _şuan_, zoon_,
   {{0x63a282d2,0x4174803d,0xab5d81b9,0x88838019}},	//   _yoon, _دانس, viżj, _ایجن,
   {{0x032602d3,0x65b001ec,0x657e0234,0x7e7b82d4}},	//   рдан, _zähl, _waph, _osup,
   {{0x3f9202d5,0x6a830087,0x98b102d6,0x442582d7}},	// [100] _inyu_, олта, _dezč_, _ltl_,
   {{0x27e682d8,0x2a6002d9,0xd94602da,0x628402db}},	//   woon_, rtib_, режи, rvio,
   {{0x7e7b802e,0xe73a82dc,0x27e682dd,0x67f601ac}},	//   _asup, вее_, toon_, nájo,
   {{0xd62a82de,0x753c0035,0xc6a682df,0xb6cb8019}},	//   воде_, larz, ирли, ھانے_,
   {{0x27e682e0,0x63a282e1,0x644182e2,0xfe7282e3}},	//   roon_, _roon, _avli, تدا_,
   {{0xbebb020f,0x27e682e4,0x224002e5,0x798181c0}},	//   mbët, soon_, msik_, jdlw,
   {{0x442582e6,0x63a282e7,0x224002e8,0x7e7b82e9}},	//   _ctl_, _poon, lsik_, _esup,
   {{0x44ce82ea,0xafe382eb,0x7bd602ec,0x67f880e1}},	//   _və_, _досл, nnyu, bíja,
   {{0x753c009a,0x6441807e,0x201802ed,0xe57a82ee}},	//   karz, _evli, _huri_, _иза_,
   {{0x1daa82ef,0x201802f0,0x63a282d8,0x65ab02f1}},	//   _कवित, _kuri_, _woon, _tühi,
   {{0x201802f2,0x63a282f3,0x753c009a,0xdcfa8176}},	//   _juri_, _toon, darz, _katč,
   {{0x201802f4,0xc4778051,0x224002f5,0x65b002af}},	//   _muri_, _כתבו_, ksik_, _wähl,
   {{0x95cb00b3,0x539b82f6,0x6d4502f7,0x442580e5}},	//   вува_, _שידו, _pdha, _ztl_,
   {{0x6d5882f8,0xdb0d0187,0x6703016f,0x753c02f9}},	//   ngva, lhaç, रेषक_, garz,
   {{0x201802fa,0xb21b013c,0x8bc702fb,0x442502fc}},	//   _nuri_, _træk, асад, ël_,
   {{0x69c702fd,0xf77f0187,0x7e6282fe,0x473502ff}},	//   _smje, moço_, ktop, _унис,
   {{0x7e628042,0x20180300,0x2fc90229,0x7c2d8301}},	// [110] jtop, _auri_, _imag_, ćari,
   {{0xdce181e2,0x201802a0,0x673d0302,0x6d450303}},	//   _galė, _buri_, lasj, _udha,
   {{0x20180304,0x4dda01c6,0x67030305,0x7e7b8306}},	//   _curi_, _תחתו, रेरक_, _ssup,
   {{0x9f058307,0x44258308,0x64550309,0x61e8803e}},	//   موضو, _rtl_, muzi, hodl,
   {{0x6455030a,0x7bcd0110,0xd244002e,0x2d810074}},	//   luzi, miau, _мэри, _kahe_,
   {{0x69c7030b,0x2d83030c,0x7bcd01e2,0x5187030d}},	//   _umje, ndje_, liau, _тума,
   {{0x2018030e,0xf773830f,0x673d0310,0x64550311}},	//   _guri_, _وار_, kasj, nuzi,
   {{0x224d8312,0x7e7b809c,0x7bcd0110,0x3219016b}},	//   trek_, _tsup, niau, _kusy_,
   {{0x20180313,0xa3af0006,0x6aad0314,0x27ed8315}},	//   _zuri_, _कवन_, nyaf, _iken_,
   {{0x224d811e,0x64550316,0x3f800317,0x2d8300f3}},	//   rrek_, kuzi, _saiu_, jdje_,
   {{0xe73a0318,0x600a0319,0x480a031a,0x7bcd031b}},	//   лен_, лном_, леон_, kiau,
   {{0x6455031c,0x25a5831d,0x753c009a,0x224d831e}},	//   duzi, _holl_, warz, prek_,
   {{0xa969831f,0x21698320,0x25a5816d,0x4ac70321}},	//   _била_, _били_, _koll_, _रेलव,
   {{0x2d8302fd,0x63bb8322,0x2fc90162,0x41268323}},	//   gdje_, lhun, _emag_, _лошо_,
   {{0x27ff8324,0x27ed8325,0xa34a0098,0x2d810326}},	//   _ohun_, _oken_, лзва_, _dahe_,
   {{0xb4e80327,0x7bcd0110,0x3f920101,0x20180314}},	//   _बडी_, giau, _unyu_, _ruri_,
   {{0xe2970328,0x17570039,0xb1460329,0x2018032a}},	// [120] бат_, _הספר_, йнал, _suri_,
   {{0x645c832b,0x2018032c,0x6455032d,0x2240032e}},	//   _årig, _puri_, buzi, rsik_,
   {{0x6c860013,0x27ff832f,0x64550330,0x63bb805d}},	//   _الجم, _bhun_, cuzi, khun,
   {{0x44440331,0x27ff8332,0xb5fb0333,0x7bcd0334}},	//   _iv_, _chun_, ntán, ciau,
   {{0x63bb8335,0x44440336,0x20180337,0xb5fb0118}},	//   dhun, _hv_, _wuri_, itán,
   {{0x6b840338,0x20180339,0x27ed833a,0x3f80833b}},	//   ldig, _turi_, _eken_, žiu_,
   {{0x7e62833c,0x31cd80c8,0x628b833d,0x44440077}},	//   stop, রকাশ, _argo, _jv_,
   {{0x63bb833e,0xd544826b,0x3a26833f,0x2d830340}},	//   ghun, _bẹ̀w, _ptop_, zdje_,
   {{0x44440341,0x67d20341,0xa5bb00f7,0xd13080f7}},	//   _lv_, nāju, spói, ومة_,
   {{0x44440342,0x361b8039,0x2fc90343,0x67240344}},	//   _ov_, _עובד, _smag_, _afij,
   {{0xd90d803d,0x673d00e8,0x2d83026c,0x63bb8345}},	//   نیه_, tasj, vdje_, bhun,
   {{0x63bb8346,0x753a80f3,0xf8b30039,0x61e88347}},	//   chun, _hetz, פשר_, sodl,
   {{0x44440348,0x673d00e8,0x6b840349,0x2d81008e}},	//   _av_, rasj, ddig, _pahe_,
   {{0x753a834a,0x6455034b,0xb21b013c,0x4444034c}},	//   _jetz, tuzi, _kræv, _bv_,
   {{0x7bcd034d,0x63a6034e,0x2d83034f,0x32190350}},	//   tiau, _bokn, rdje_, _susy_,
   {{0x44440351,0x753a8352,0x64550098,0xddc40353}},	//   _dv_, _letz, ruzi, _vpiš,
   {{0x6d488354,0x7bcd01e2,0x6e360355,0x67d201a9}},	// [130] _odda, riau, _gwyb, gāju,
   {{0x753a82af,0x213e8229,0x6b828356,0x44440357}},	//   _netz, nath_, _laog, _fv_,
   {{0xddc4003a,0x63bb8358,0x6aad0359,0x27ff80ff}},	//   _upiš, yhun, syaf, _phun_,
   {{0x25a58352,0x64c3835a,0x6d48835b,0x6b82835c}},	//   _soll_, _वेगळ, _adda, _naog,
   {{0xb5fd835d,0x25a5835e,0x9599835f,0x2c618035}},	//   _opšt, _poll_, итку_, wód_,
   {{0x4444011e,0x7afd0360,0x2bb18361,0x6b828362}},	//   _yv_, _izst, जस्थ, _aaog,
   {{0x44440363,0x65b00364,0x63bb805d,0x25a581ec}},	//   _xv_, _sähk, thun, _voll_,
   {{0x2c61809a,0x6d488365,0x27ed804a,0x628b81f4}},	//   ród_, _edda, _uken_, _prgo,
   {{0x60250110,0xb21b0366,0x25a58367,0x7d000032}},	//   _dėme, _usæd, _toll_, _kárí,
   {{0x63bb8368,0x628b8369,0x776d036a,0x3eb2804a}},	//   shun, _vrgo, _abax, øyte_,
   {{0xc952036b,0x6b84036c,0xa3e9036d,0x673b836e}},	//   ומי_, ydig, मका_, _keuj,
   {{0x628b836f,0xe3b381bd,0x661b8364,0x64438370}},	//   _trgo, _عرض_, _kuuk, msni,
   {{0x61458371,0x63a60372,0x69cf8373,0xd9458374}},	//   _дела, _rokn, éces, _дели,
   {{0x67d200eb,0xb5fb0375,0x6d410376,0x63a60377}},	//   vāju, stán, ólap, _sokn,
   {{0x8fa60003,0xd5e4019d,0xdb1d016d,0x64438378}},	//   _маке, _arị, _omsä, nsni,
   {{0x44440379,0x67d20029,0x6b84037a,0x333f80e7}},	//   _vv_, tāju, udig, naux_,
   {{0x9f5f8028,0x65b0037b,0x7983837c,0xdce381d0}},	// [140] _thuê_, _lähi, _kanw, teně,
   {{0xb5fb037d,0x4444037e,0x6b84037f,0xa7fd0380}},	//   ntál, _tv_, sdig, ntın,
   {{0xef1a8381,0xdce18029,0x79838382,0xdb060168}},	//   аме_, _dalī, _manw, _kokë,
   {{0xf1bf0065,0x6d5c0383,0x753a8384,0xbddb0385}},	//   _után_, lgra, _setz, nsèn,
   {{0x25e68076,0x3e640386,0x2b400387,0x644100e1}},	//   टवली_, nöt_, maic_, šlit,
   {{0x27388028,0x67228388,0x6b828014,0xc7b98061}},	//   ẩn_, scoj, _saog, _elő_,
   {{0xe73a8389,0x2636809a,0x68300032,0x6e29838a}},	//   _веб_, sło_, _dòdò, _eteb,
   {{0x66e6838b,0xdee6838c,0x0b8a838d,0x7983838e}},	//   _доба, _доби, рски_, _aanw,
   {{0x7983838f,0x386d0390,0xed5a8391,0xdfcf8174}},	//   _banw, _ćeri_, _воз_, _شيك_,
   {{0x6d48813c,0x6d5c0392,0x3f84804f,0x23b88036}},	//   _udda, jgra, _hamu_, _déja_,
   {{0x3f848393,0x213e8394,0x6d5c0395,0xd7fb0396}},	//   _kamu_, rath_, dgra, иум_,
   {{0xa2cb835a,0x3f848397,0x333f80e7,0x442e8398}},	//   _तेव्, _jamu_, caux_, mpf_,
   {{0xdefb0196,0x64588399,0x22948081,0x79838286}},	//   рын_, luvi, _хиля, _fanw,
   {{0x69ca839a,0x6d5c039b,0x2918039c,0xe2a98180}},	//   _umfe, ggra, _ngra_, _دامن_,
   {{0x5ba7039d,0xe0d480be,0x602181a9,0x3b280133}},	//   ораз, _מײַ_, _tēma, _ọyị_,
   {{0x6d5c0013,0x3f84839e,0xdce180eb,0xdb0f0333}},	//   agra, _namu_, _salī, _alcá,
   {{0x1ddb81fe,0xdce18029,0x2bbc0076,0x201c82f1}},	// [150] _बदलत, _palī, _ईतरा, _huvi_,
   {{0x69da839f,0x64438370,0x645883a0,0x7afd808b}},	//   nnte, ysni, kuvi, ýsti,
   {{0x65ab02af,0x6e2983a1,0xb5fb03a2,0x3f8483a3}},	//   _führ, _steb, ntám, _bamu_,
   {{0xd47a0158,0xa3af03a4,0xb5fb0019,0x2cac0106}},	//   _פארל, _कवि_, ztál, ädde_,
   {{0x333f82be,0x7afd00eb,0x3f8483a5,0x539a0039}},	//   vaux_, _uzst, _damu_, _הירו,
   {{0x644383a6,0x201c83a7,0xdb0403a8,0xa7fd0085}},	//   tsni, _ouvi_, chiñ, xtın,
   {{0x201c8358,0x333f80e7,0x21ef01ec,0x9f3583a9}},	//   _nuvi_, taux_, bühr_, _неві,
   {{0x69da83aa,0x644383ab,0x79838091,0x3a3903ac}},	//   ente, rsni, _sanw, _kwsp_,
   {{0x644380f2,0x6d5c03ad,0x798382f7,0x333f80e7}},	//   ssni, ygra, _panw, raux_,
   {{0x644381e2,0x3f8483ae,0x65b00074,0x69da83af}},	//   psni, _zamu_, _tähi, gnte,
   {{0xb5fb03b0,0x7c2d83b1,0x6d5c0289,0x798383b2}},	//   rtál, ćars, vgra, _vanw,
   {{0xb5fb03b3,0x2d8583b4,0xbebb0168,0x201c802a}},	//   stál, _hale_, rcën, _duvi_,
   {{0x2d8583b5,0xa2cb03b6,0xcaea03b7,0x19958081}},	//   _kale_, _सेल्, _झुंड_, _надя,
   {{0x2d8583b8,0xda1f0105,0x6d5c03b9,0x2d8783ba}},	//   _jale_, _बढ़त_, ugra, ndne_,
   {{0x9f9203bb,0x64a603bc,0xdb060168,0x224682d4}},	//   lší_, чава, _tokë, _zvok_,
   {{0x422603bd,0x225203be,0xa7fd03bf,0x65618122}},	//   здав, tryk_, ntıl, _lclh,
   {{0x27e003c0,0x6e4600f7,0x9f9203c1,0x6d5c03c2}},	// [160] _ijin_, _عندم, nší_, pgra,
   {{0x3f8483c3,0x2b4003c4,0xb46603c5,0x2d8581f6}},	//   _samu_, saic_, _екол, _nale_,
   {{0xe1ff00a9,0x764603c6,0x9d1b00be,0x628f01e8}},	//   _após_, lsky, _לויט, _erco,
   {{0x205503c7,0xdc9b03c8,0x3f8683c9,0x6ecd83ca}},	//   ьтур, _היטל, udou_, _देहु,
   {{0x9f9203cb,0x764603cc,0x3f8683cd,0xa3e900d4}},	//   jší_, nsky, rdou_, मकर_,
   {{0x645883ce,0x63b603cf,0xa6db007b,0x2d8583d0}},	//   tuvi, lkyn, naða, _cale_,
   {{0x80d080c8,0x69ce03d1,0x3f8483d2,0xddc98162}},	//   _সুন্, _imbe, _tamu_, _speţ,
   {{0x69dd83d3,0x63a403d4,0x645883d5,0xb21b0366}},	//   ésen, njin, ruvi, _græs,
   {{0x2d8583d6,0x201c83d7,0x7d028032,0x6b8603d8}},	//   _fale_, _suvi_, _bírí, _makg,
   {{0x764603d9,0x69da83da,0x27e00300,0x7d070036}},	//   dsky, unte, _ajin_, néré,
   {{0x69ce00dd,0x261583db,0x69da83dc,0xf99301c6}},	//   _mmbe, _फूटी_, rnte, גרת_,
   {{0x09b903dd,0x6028801b,0x78fb03de,0x2d8583df}},	//   _इत्य, _něme, מפיו, _zale_,
   {{0x69ce03e0,0x443a03e1,0x9f4b0216,0x764603e2}},	//   _ombe, _awp_, nocé_, gsky,
   {{0x7afd83e3,0x9f42016b,0x7d02826b,0x442c83e4}},	//   üste, roká_, _gírí, _ktd_,
   {{0x9f42026f,0x6b8603e5,0x7d0703e6,0x628f00c3}},	//   soká_, _bakg, déré, _srco,
   {{0x27e003e7,0x63a400f1,0xa3bc03e8,0x087783de}},	//   _gjin_, gjin, _अतः_, _זעהט_,
   {{0x3edf0135,0xdcf200eb,0x6b8603e9,0x442c81c6}},	// [170] _kpọọ_, īgāk, _dakg, _ltd_,
   {{0x6e2d03ea,0xceb200be,0xaca301bc,0xbba983eb}},	//   _itab, _סיי_, _asụg, _छक्क,
   {{0xb21b013c,0x2d8583ec,0x673f03ed,0xa3be8035}},	//   _præs, _rale_, _keqj, ीफा_,
   {{0x69ce03ee,0x64550289,0x2d8583ef,0x256f807e}},	//   _embe, mrzi, _sale_, zılı_,
   {{0xd2468065,0x644883f0,0x442c83f1,0x256f8214}},	//   _جن_, _avdi, _atd_, yılı_,
   {{0xcb120051,0x645501ed,0x9f9203f2,0x68f500e1}},	//   _שלך_, orzi, vší_, _tyzd,
   {{0x2d8583f3,0xac09827e,0x628283f4,0x2d8783f5}},	//   _vale_, онка_, _asoo, rdne_,
   {{0x2d8583f6,0x9f92001b,0x6e2d03f7,0x395e80eb}},	//   _wale_, tší_, _otab, egts_,
   {{0xfe7083f8,0x2d8583f9,0x2a6903fa,0x6e2d02a0}},	//   _مدل_, _tale_, ntab_, _ntab,
   {{0x9f9203fb,0x3ce8809a,0x27f203fc,0xab5b0192}},	//   rší_, _चुके_, _skyn_, _flüg,
   {{0x6d4383fd,0xd37180f7,0xdddb805c,0x6e2d03fe}},	//   mana, _لها_, _kruž, _atab,
   {{0x65b003ff,0x9f920400,0x2a690401,0x7bc08402}},	//   _läht, pší_, ktab_, chmu,
   {{0xb8f48403,0xa6db008b,0x443a0404,0xdcfa8162}},	//   _से_, taða, _swp_, _tată,
   {{0x79870063,0x76460405,0x65b00406,0x273c0028}},	//   _najw, rsky, _näht, ận_,
   {{0xdddb8025,0x6e2d0407,0x76460408,0x69c18409}},	//   _oruž, _etab, ssky, mhle,
   {{0x6d43840a,0x6b89840b,0x6f1b840c,0xeb97040d}},	//   hana, ndeg, _nguc, мис_,
   {{0x59e1824c,0xdb0b840e,0x63ab840f,0x63a680f2}},	// [180] _पदार, _algú, _mogn, ökni,
   {{0x6d438410,0x69c18234,0x63b60411,0x63a40412}},	//   jana, nhle, skyn, sjin,
   {{0x6d438413,0x657c0414,0x628b0106,0x7bc78084}},	//   dana, merh, ågor, _įjun,
   {{0x645c0415,0xdd8f8416,0x657c0417,0x3fbe80ab}},	//   muri, یون_, lerh, েক্ষ,
   {{0x6d438418,0xdddb8419,0x4cd300ab,0x7988831d}},	//   fana, _druž, _দুপু, yddw,
   {{0x69ce041a,0x657c02af,0x442c83ac,0x63ab8362}},	//   _umbe, nerh, _ptd_, _aogn,
   {{0x645c041b,0x442c841c,0x69c1841d,0x644d81a9}},	//   nuri, _qtd_, dhle, ņain,
   {{0x63ab841e,0xdddb841f,0x6d438420,0x6b898421}},	//   _cogn, _gruž, aana, gdeg,
   {{0x657c0422,0x645c0423,0xe7bd8424,0x52148425}},	//   kerh, huri, ्फरप, ндит,
   {{0x645c0426,0x442c808e,0x69c18427,0x657c0144}},	//   kuri, _ttd_, ghle, jerh,
   {{0x39570051,0x6e20820f,0x79888428,0x63ab8429}},	//   ושים_, _humb, rddw, _fogn,
   {{0x6e20842a,0x628281c5,0xe29a81e2,0x26c681c0}},	//   _kumb, _tsoo, _мае_, ozoo_,
   {{0xdce881e2,0xdde2042b,0x6e20842c,0x26c68144}},	//   _padė, _šušk, _jumb, nzoo_,
   {{0xceb38158,0xe0cf8416,0x645c042d,0x69c1842e}},	//   דיש_, ازی_, furi, chle,
   {{0x67d5042f,0x6e208430,0xb5fb00f7,0xdb060019}},	//   _поку, _lumb, ntái, _elkü,
   {{0x6d438431,0x2a690432,0x2cac0106,0x7c220088}},	//   zana, ttab_, ädda_, _čort,
   {{0x657c0433,0x6e208434,0x6e2d0435,0x65950436}},	// [190] berh, _numb, _utab, _запу,
   {{0x645c0437,0x6d438438,0x765d0439,0x4905801b}},	//   buri, xana, musy, हेको_,
   {{0xdddb812b,0x2a690006,0x6d43843a,0x765d043b}},	//   _pruž, stab_, vana, lusy,
   {{0x6d43843c,0x2a690242,0x93c90019,0xef1982a6}},	//   wana, ptab_, _راجہ_, _każi_,
   {{0xcb360051,0x65b0043d,0x6e20843e,0x6d43843f}},	//   _ראשי_, _täht, _cumb, tana,
   {{0x63ab8440,0xa2bf0441,0x9f4d8229,0x44210442}},	//   _sogn, लैण्, _cheò_, _kuh_,
   {{0x6d438443,0x442101d6,0x22490444,0x67298197}},	//   rana, _juh_, lsak_, _tfej,
   {{0x6d438445,0x65b002af,0x765d0446,0x26c6822c}},	//   sana, _jähr, kusy, bzoo_,
   {{0x6d438447,0x645c8448,0x6b898449,0x6e20844a}},	//   pana, _årin, rdeg, _gumb,
   {{0x645c044b,0x6d43844c,0x9f4d8362,0x6b89844d}},	//   yuri, qana, _gheò_, sdeg,
   {{0x657c044e,0xe8f9844f,0x6d4180eb,0x67248450}},	//   verh, яло_, _iela, žije,
   {{0xf0920451,0x6d418452,0x22490453,0x657c0454}},	//   אנט_, _hela, ksak_, werh,
   {{0x6d418455,0x657c0456,0x3e6980e1,0xe3c20457}},	//   _kela, terh, nút_, nlış_,
   {{0x6d418458,0x92c18459,0x9aa4845a,0xdd92045b}},	//   _jela, ığın, _جمهو, دوس_,
   {{0x6d41845c,0xfce3045d,0xddcd0087,0x6603045e}},	//   _mela, горо, _spaţ, упра,
   {{0x6d41845f,0xa2d48076,0x645c0460,0x765d0461}},	//   _lela, _बेड्, ruri, busy,
   {{0xf41280be,0x22490462,0x02060463,0xdb060242}},	// [1a0] רפן_, gsak_, езан, _alkò,
   {{0x6d418464,0x645c0465,0xe889801c,0x442100ee}},	//   _nela, puri, _kẻ_, _fuh_,
   {{0x6e208397,0x65b001ec,0xdddb8035,0x21f40192}},	//   _sumb, _fähr, _druż, fähr_,
   {{0xa2cb0466,0xfaa60467,0xfe468468,0xe6668469}},	//   _सेक्, _замо, ендо, етко,
   {{0xe889801c,0x394580eb,0x98ac0085,0x91b48035}},	//   _lẻ_, kals_, ğlıq_, ेसमै,
   {{0xe5a3846a,0x6d4182ad,0x7bd6046b,0x98ac0085}},	//   личи, _cela, liyu, şlıq_,
   {{0x6d41846c,0x8d1a8065,0xdbe3046d,0x26c681c0}},	//   _dela, _ہزار_, _béèn, szoo_,
   {{0xb5fb00f7,0x6d4182f1,0x51200054,0x8aa6846e}},	//   rtái, _eela, _बलुआ_, ерод,
   {{0xb5fb0013,0x6d41846f,0x66e38470,0x6aa40118}},	//   stái, _fela, _бота, nxif,
   {{0x64a68471,0xb5ca8065,0x39458472,0x7afd8085}},	//   _паза, _عوام_, gals_, üsta,
   {{0x815700be,0x3f890473,0xdb12007b,0x7c218474}},	//   עסטע_, _paau_, _ágæt, _gulr,
   {{0xfa888142,0x6d418102,0x765d0475,0xb5fb0476}},	//   _từ_, _zela, tusy, ntáv,
   {{0x42db00ab,0x7d278106,0x44210477,0x6d418478}},	//   _দর্শ, _årså, _suh_, _yela,
   {{0x39458479,0x661a847a,0x9f4b001b,0x4421047b}},	//   cals_, _jitk, mocí_, _puh_,
   {{0x317e80cd,0x6286047c,0xb3a4847d,0x7bd6008e}},	//   metz_, _asko, _खचाख, fiyu,
   {{0x7bc4047e,0x7bdf047f,0x22490480,0xdcf88088}},	//   ghiu, unqu, tsak_, jevč,
   {{0x66d38065,0x9f4b0388,0x443e82f7,0xd2510481}},	// [1b0] _műkö, nocí_, _lwt_, شنا_,
   {{0x661a8482,0x44210483,0xd8e70484,0x65b002af}},	//   _nitk, _tuh_, нцеп, _währ,
   {{0x62860485,0x6d470486,0x20090028,0x22490487}},	//   _esko, maja, _khai_, ssak_,
   {{0x6d41845c,0x6d470393,0x200901c0,0x7bc40488}},	//   _sela, laja, _jhai_, chiu,
   {{0x661a8489,0x6b9d048a,0xdb0b80f1,0x69dd8019}},	//   _bitk, _insg, _vogë, ések,
   {{0x6d47048b,0xb90700c8,0xdce88029,0x443e848c}},	//   naja, _পর_, _gadī, _bwt_,
   {{0x63af02a5,0xab5b02af,0x80d080ab,0x644a848d}},	//   _kocn, _glüc, _সুস্, gsfi,
   {{0xe8898028,0x69d701df,0x6d470353,0x6d41848e}},	//   _rẻ_, lixe, haja, _wela,
   {{0x6d41848f,0x39458490,0xe8898028,0x63af0491}},	//   _tela, tals_, _sẻ_, _mocn,
   {{0x6d470492,0x27fd8428,0x798a8428,0x93bc8493}},	//   jaja, llwn_, _cafw, _stăt,
   {{0x39458494,0x6d470495,0x2fc001e9,0xf9920496}},	//   rals_, daja, _plig_, ברי_,
   {{0x39458497,0xe8898028,0x20090498,0x6b8d01ed}},	//   sals_, _vẻ_, _chai_, jdag,
   {{0x63a9830b,0x6b8d03a6,0x93b68051,0xddcd0499}},	//   mjen, ddag, _שלנו_, _spaš,
   {{0xceb2804c,0x6d47049a,0x7bd600b4,0x65638129}},	//   סים_, gaja, wiyu, ngnh,
   {{0xdce880eb,0xddc280eb,0x6b8b849b,0x443e049c}},	//   _radī, ntoš, _kagg, èt_,
   {{0x63a9849d,0x63bb849e,0x6b8d049f,0x087680be}},	//   njen, nkun, gdag, _יעצט_,
   {{0x6b8b84a0,0x6d4704a1,0x3951026c,0x4b2300e8}},	// [1c0] _magg, baja, _bdzs_, рмув,
   {{0x6d470025,0x63a984a2,0xb65b007c,0x00da04a3}},	//   caja, hjen, _קדיש, وبات_,
   {{0x63bb84a4,0xdce88029,0x63a984a5,0x661a84a6}},	//   kkun, _vadī, kjen, _ritk,
   {{0x6b8b84a7,0x70530077,0x6e24004f,0x7bd600dd}},	//   _nagg, شنها, _kuib, qiyu,
   {{0x63a984a8,0x628604a9,0x661a8364,0x443e84aa}},	//   djen, _usko, _pitk, _swt_,
   {{0xb5fb04ab,0x69c504ac,0xd49a84ad,0x8d6384ae}},	//   stáv, chhe, дри_, авље,
   {{0x6b8b84af,0xb5fb001b,0xcbe684b0,0x2cb80362}},	//   _bagg, ptáv, кции, nyrd_,
   {{0x63a984b1,0x63bb84b2,0x09da8072,0x61fe04b3}},	//   gjen, gkun, यच्य, llpl,
   {{0xd00f8013,0xfbd30051,0x2009031d,0x6b8b84b4}},	//   _ذلك_, יתה_, _rhai_, _dagg,
   {{0xa3f5800d,0x661a837a,0xb4d2016f,0x200900fc}},	//   ější_, _uitk, _वधू_, _shai_,
   {{0x2d9e84b5,0x6d4704b6,0x63a984b7,0xd1388110}},	//   _inte_, vaja, bjen, rbą_,
   {{0x2d8c84b8,0x317e81ec,0x6b8b84b9,0x63bb82af}},	//   _hade_, setz_, _gagg, ckun,
   {{0x6d4704ba,0x2d8c84bb,0x6e2404bc,0xc9aa84bd}},	//   taja, _kade_, _cuib, _овде_,
   {{0x2d8c84be,0xea778039,0xa4d500e8,0x63af01f4}},	//   _jade_, _סגור_, гогі, _socn,
   {{0x6d4704bf,0x63af0052,0x80a384c0,0x6b8d03b2}},	//   raja, _pocn, _نمون, tdag,
   {{0x5f7704c1,0x2d8c84c2,0x6b8b8079,0x2009004f}},	//   _شاعر, _lade_, _xagg, _uhai_,
   {{0x2d9e84c3,0x6d4704c4,0x63af025b,0xf8e284c5}},	// [1d0] _onte_, paja, _vocn, _पशुप,
   {{0x6b8d03a6,0x63bb80ad,0x68fc04c6,0x80be0264}},	//   sdag, zkun, _byrd, ্পন্,
   {{0x44270193,0x3eb904c7,0xc953810f,0x69d704c8}},	//   _în_, lyst_, שמע_, rixe,
   {{0x2d9e84c9,0x44330183,0xb4c1009a,0x7659831d}},	//   _ante_, _itx_, ्छी_, trwy,
   {{0x6d4504ca,0x6b8b84cb,0x4ea78081,0x6b8084cc}},	//   _keha, _ragg, ържа, demg,
   {{0x6d4504cd,0xf2d20051,0x7bc284ce,0xa93404cf}},	//   _jeha, _פעם_, _alou, _верш,
   {{0x63a984d0,0x7afd04d1,0x6b8b84d2,0x7bc284d3}},	//   tjen, _hyst, _pagg, _blou,
   {{0x2d9e84d4,0xddc284d5,0x7afd04d6,0x7bc284d7}},	//   _ente_, rtoš, _kyst, _clou,
   {{0x3f9f82c1,0x63a984d8,0x7bc2800d,0xee8484d9}},	//   _inuu_, rjen, _dlou, _выхо,
   {{0x63bb84da,0xdcbb8021,0x2d8c8247,0x5fb9835a}},	//   skun, _още_, _gade_, _आवडल,
   {{0x2dd880f7,0xf74604db,0x7afd04dc,0x046784dd}},	//   _شبكة_, лено, _lyst, _штам,
   {{0xdb0f0073,0xc43a84de,0x7ae48289,0x44258087}},	//   _você, _נתני, _žite, _iul_,
   {{0x442584df,0x6d4504e0,0x7afd04e1,0x69d504e2}},	//   _hul_, _beha, _nyst, _omze,
   {{0x88c584e3,0x442584e4,0x2bcf84e5,0x7bc28067}},	//   _متعل, _kul_, तोरा, _zlou,
   {{0x224d84e6,0x7981805d,0x442584e7,0x987980be}},	//   lsek_, melw, _jul_, _טאַט,
   {{0x7afd04e8,0x2d8c04e9,0x44258006,0x7981805d}},	//   _byst, žde_, _mul_, lelw,
   {{0x7afd0114,0xdcfc026f,0x442584ea,0x6d450144}},	// [1e0] _cyst, merč, _lul_, _feha,
   {{0x6d4504eb,0x7afd04ec,0x3f8204ed,0x798184ee}},	//   _geha, _dyst, leku_, nelw,
   {{0xdb06003e,0x2d8c84ef,0xdce38110,0xb5fb04f0}},	//   _doká, _rade_, menė, rtát,
   {{0xb5fb04f1,0x2d8c84f2,0x6d45011e,0x224d8214}},	//   gráf, _sade_, _zeha, ksek_,
   {{0x2d8c84f3,0x7981805d,0x7f3b00be,0x7afd0114}},	//   _pade_, kelw, גענו, _gyst,
   {{0x7bc2801b,0x442584f4,0xd5b1801c,0x7e7b808e}},	//   _slou, _bul_, _có_, _dpup,
   {{0x442584f5,0x5b2684f6,0x2d8c8214,0x7bc284f7}},	//   _cul_, льпа, _vade_, _plou,
   {{0xb5fb04f8,0x442584f9,0x3f820499,0x539884fa}},	//   ntár, _dul_, jeku_, твия_,
   {{0x2d8c84fb,0xbebb0168,0x224d82c4,0xdb060061}},	//   _tade_, ncët, gsek_, _elkö,
   {{0xc05a8221,0x602180eb,0x442584fc,0x79818114}},	//   нім_, _lēmu, _ful_, gelw,
   {{0x291884fd,0x98be8087,0x442584fe,0x798e04ff}},	//   ära_, dată_, _gul_, _mabw,
   {{0x6d450500,0x6d4a8501,0x644e0502,0xa6db007b}},	//   _seha, lafa, dsbi, laði,
   {{0x6d450503,0x44258504,0x645c011b,0x79818505}},	//   _peha, _zul_, erri, belw,
   {{0x44258506,0xbb1b02be,0x6d4a8507,0xa6db008b}},	//   _yul_, _maît, nafa, naði,
   {{0x6d450508,0x44258509,0xb4c1050a,0x3ebf050b}},	//   _veha, _xul_, ्छे_, šut_,
   {{0xc4c4850c,0x7afd0009,0xa3cf050d,0x246e8085}},	//   _ہے_, _pyst, वों_, _cəmi_,
   {{0x6d4a850e,0x6d450074,0x645c02f9,0x5b7b80be}},	// [1f0] kafa, _teha, arri, ערמא,
   {{0x7afd050f,0x645a0510,0x98be802e,0xb5fb0061}},	//   _vyst, átic, cată_, rtás,
   {{0x7afd0063,0x2d8302a0,0xb5fb0511,0xd7c880d7}},	//   _wyst, meje_, tráf, گونه_,
   {{0x31e18512,0x645a011f,0x2d830513,0x7afd0514}},	//   _पद्ध, štic, leje_, _tyst,
   {{0x44258515,0x6d4a8516,0xa2d4800c,0x98aa01a9}},	//   _sul_, fafa, _बेल्, ējām_,
   {{0x44258085,0x2d830517,0xf483804e,0x6d4a8518}},	//   _pul_, neje_, ماعی, gafa,
   {{0x63ad0110,0xa7fd007e,0xa2d90519,0x7981851a}},	//   ojan, ntıs, _नेत्, velw,
   {{0x63ad051b,0x4425838e,0x98be8087,0xddc4051c}},	//   njan, _vul_, zată_, _spiż,
   {{0x69da851d,0x6b8f051e,0x6d4a851f,0x2b468176}},	//   fite, _macg, bafa, _deoc_,
   {{0x2d830520,0x44258521,0x27e90522,0x69c8808c}},	//   jeje_, _tul_, _ajan_, ghde,
   {{0xe73a0523,0x2d830524,0x63ad0525,0x66ca8019}},	//   кен_, deje_, kjan, _töké,
   {{0xc6000526,0x7981805d,0xb5fb0527,0x63ad0528}},	//   ोग्य_, selw, hrád, jjan,
   {{0x63ad0529,0x98be8087,0x2bc9052a,0xb5fb052b}},	//   djan, tată_, रसना, vtár,
   {{0x3f82052c,0x69c8852d,0x644e052e,0x7bc980e7}},	//   seku_, chde, tsbi, lheu,
   {{0x98be802e,0x645c052f,0xdd0e02d0,0x8c460530}},	//   rată_, urri, _dışa, ребе,
   {{0xc0528039,0x7bc980e7,0xdb0b8531,0x63ad0532}},	//   _וזה_, nheu, _logí, gjan,
   {{0x6d4a8533,0x661e0534,0x644e0535,0xeab70536}},	// [200] yafa, _tipk, ssbi, айт_,
   {{0x394782fe,0xb5fb0537,0xf0a98032,0xdebb0538}},	//   _jens_, stár, _gbàà_, _סמיל,
   {{0xa3af00d4,0x64a60539,0x63ad053a,0xdca6053b}},	//   _कवच_, _тана, bjan, _тани,
   {{0x69da853c,0x6d4a8010,0x764400b4,0x6e93053d}},	//   zite, wafa, _kwiy, _الیا,
   {{0xb8fd053e,0xe8e2853f,0x23a98540,0x6d4a8541}},	//   _ते_, _पश्च, कानद, tafa,
   {{0x44440542,0x3947809f,0xb8660019,0x6b840543}},	//   _kw_, _nens_, _پاسو, leig,
   {{0x92e280c8,0x292700e1,0xa6db008b,0x03c68544}},	//   _ধরে_, ávať_, raði, исим,
   {{0x44440545,0x69da8546,0x6d4a8547,0x0fc100ab}},	//   _mw_, wite, safa, _উদ্ধ,
   {{0x444402ec,0x27e68420,0x39478548,0x2d830549}},	//   _lw_, mnon_, _bens_, yeje_,
   {{0x444402ec,0x6b84054a,0x63ad054b,0x4973854c}},	//   _ow_, heig, zjan, ольс,
   {{0x628b854d,0x7644054e,0x3947854f,0x58d880e8}},	//   _esgo, _awiy, _dens_, удня_,
   {{0x69da8550,0x394782d8,0x27e68551,0x6d488102}},	//   site, _eens_, nnon_, _heda,
   {{0x44440552,0x63a28553,0x6d4884bf,0xd6d80554}},	//   _aw_, _inon, _keda, атр_,
   {{0x6d488025,0x44440555,0x7bc60556,0x39478557}},	//   _jeda, _bw_, _alku, _gens_,
   {{0x6d488558,0x2d830559,0xf77f055a,0x63ad055b}},	//   _meda, reje_, ança_, tjan,
   {{0x7c288025,0x6d48855c,0x4444055d,0x628b8355}},	//   _mudr, _leda, _dw_, _ysgo,
   {{0x7c28855e,0x2905055f,0xadf683eb,0x717900e5}},	// [210] _ludr, _šla_, इवान_, лбар_,
   {{0x6f098063,0x39470560,0x3947802a,0x394c8561}},	//   _rzec, úns_, _xens_, nads_,
   {{0x44440562,0x63ad0563,0x63a28564,0x6b8401a9}},	//   _gw_, pjan, _onon, beig,
   {{0x27e68565,0x2014009f,0xdc9a03de,0x63a283f7}},	//   gnon_, _èxit_, _עירל, _nnon,
   {{0x7c288566,0x69d881eb,0x44440567,0xed598568}},	//   _audr, _omve, _zw_, гол_,
   {{0x63a28569,0x44440355,0x27e6856a,0x5f0a056b}},	//   _anon, _yw_, anon_, _सरस्_,
   {{0x4444056c,0x6d48856d,0xa6db0125,0x0574803d}},	//   _xw_, _deda, maðu, تاند,
   {{0x3947856e,0x69c7056f,0x23690570,0x1dd98571}},	//   _sens_, _hlje, ngaj_, _भगवत,
   {{0xe1f98572,0x248c8573,0xdd2c0110,0xe7308019}},	//   лги_, _esdm_, vėži, _آصف_,
   {{0x6b840352,0x6d488574,0xa6db007b,0x63a28575}},	//   zeig, _geda, naðu, _enon,
   {{0xa3e80576,0x69c702ce,0x7c288577,0x7dc200e1}},	//   _बदल_, _mlje, _gudr, _dôsl,
   {{0x44440578,0x3947837a,0x7dc201ac,0x6d570579}},	//   _rw_, _wens_, _pôso, _adxa,
   {{0x34b2057a,0x7f49857b,0x69c7057c,0xa7fd02d0}},	//   ीन्द, _meeq, _olje, ttır,
   {{0x4444057d,0x6e298264,0x6e21857e,0x28b980f7}},	//   _pw_, _mueb, _jilb, _مطبخ_,
   {{0x44440282,0x6b84057f,0xdb0b8187,0xdb1d0580}},	//   _qw_, teig, _fogã, _alsà,
   {{0xf1bf001c,0x69c1800b,0x44440581,0xfd6901bc}},	//   _quán_, lkle, _vw_, _kepụ,
   {{0x69c70582,0xa7fd0214,0x6e2982d5,0xfaa30530}},	// [220] _blje, ptır, _nueb, пато,
   {{0x44440583,0x01d70013,0x69c18584,0x6b840585}},	//   _tw_, موقع_, nkle, seig,
   {{0x44440586,0x3f920587,0x6d4e0588,0x291c0589}},	//   _uw_, _kayu_, maba, äva_,
   {{0x6d4e058a,0x7bc6058b,0x78a30338,0x68fc8192}},	//   laba, _ulku, ånva, ürdi,
   {{0x6e21811e,0xa3ab858c,0x2b40058d,0x3f920041}},	//   _bilb, खान_, mbic_, _mayu_,
   {{0x6d4e058e,0x225f858f,0x3f920590,0xe1e78591}},	//   naba, druk_, _layu_, _رس_,
   {{0x2bbf0592,0x6d488593,0xb5fb026f,0x394c80eb}},	//   _एकमा, _veda, duál, vads_,
   {{0x69de0594,0x6d4e0595,0x9b6a8596,0x6d488597}},	//   lipe, haba, ушка_, _weda,
   {{0x6d4e0598,0x6d488599,0x7dcb0059,0x394c859a}},	//   kaba, _teda, _hüse, tads_,
   {{0x69de059b,0x6d4e059c,0x8c0000ab,0xfd6901bc}},	//   nipe, jaba, ্দিন_, _depụ,
   {{0x672d80ce,0x64a3859d,0x3f92059e,0x9f42016b}},	//   žaje, _нафа, _bayu_, soký_,
   {{0x4422059f,0xaad98105,0x69de0087,0x225f85a0}},	//   _nik_, _बेवक, hipe, bruk_,
   {{0x69de05a1,0x645a0091,0x394a05a2,0x3f9202f7}},	//   kipe, átin, _oebs_, _dayu_,
   {{0x6d4e05a3,0xf1bf05a4,0x4422016d,0x30a685a5}},	//   gaba, _cuál_, _aik_, _грив,
   {{0x645a05a6,0x61fa8580,0x69de05a7,0xc05a85a8}},	//   štin, motl, dipe, _сіл_,
   {{0x69c702fd,0x442205a9,0x61fa85aa,0xeda585ab}},	//   _slje, _cik_, lotl, _गच्छ,
   {{0x6d4e05ac,0x442205ad,0x69c70052,0x7c2285ae}},	// [230] baba, _dik_, _plje, _mior,
   {{0x6d4e005d,0x7c228118,0x6f0d05af,0x61fa85b0}},	//   caba, _lior, _izac, notl,
   {{0x44220022,0x2fc905b1,0x660384e8,0x6d4105b2}},	//   _fik_, _klag_, vlnk, ılad,
   {{0x1da705b3,0x6e2985b4,0xdb0b8013,0x4422013c}},	//   खावत, _pueb, _logá, _gik_,
   {{0x7bdf05b5,0x7bcd05b6,0x61fa85b7,0x6e218176}},	//   miqu, mhau, kotl, _pilb,
   {{0x7bdf05b8,0x628f0197,0xb5fb05b9,0x69de05ba}},	//   liqu, _isco, xuál, cipe,
   {{0xddcc01e2,0x224680ee,0x442200ee,0x7c2285bb}},	//   _žiūr, _awok_, _yik_, _bior,
   {{0x23c905b3,0x7bdf05bc,0x6d4e05bd,0xa91c8038}},	//   रसिद, niqu, zaba, teľn,
   {{0x6e2185be,0xb5fb05bf,0x7c2285c0,0x3e72802e}},	//   _tilb, tuál, _dior, cât_,
   {{0x80be00c8,0x8d778416,0x3f9205c1,0xe9d985c2}},	//   ্পর্, _دارا, _sayu_, рко_,
   {{0x7c228098,0x2fc905c3,0x15fa009a,0x6f0d05c4}},	//   _fior, _blag_, ृतसर_, _azac,
   {{0x7c228021,0xdd0e85c5,0x6d4e05c6,0x2d8785c7}},	//   _gior, lışm, waba, lene_,
   {{0x6d4e05c8,0x7bdf05c9,0xf8a6016f,0x7bcd05ca}},	//   taba, diqu, _गप्प, dhau,
   {{0x442205cb,0x2d8785cc,0xdb0f002a,0xdd0e83bf}},	//   _sik_, nene_, _cocí, nışm,
   {{0x6d4e05cd,0x7bdf05ce,0x628f0098,0x629d05cf}},	//   raba, fiqu, _asco, _arso,
   {{0x7bdf0557,0xb5fb05d0,0x2d8785d1,0x3f868118}},	//   giqu, trác, hene_, xeou_,
   {{0x2d8785d2,0xe9da05d3,0x6d4e05d4,0xb5fb00e1}},	// [240] kene_, ака_, paba, urác,
   {{0x27ff85d5,0x27ed80b9,0xe16600f7,0x6d4e05d6}},	//   _akun_, _ajen_, تدري, qaba,
   {{0x442205d7,0x2d87835f,0x628f05d8,0x69de05d9}},	//   _tik_, dene_, _esco, ripe,
   {{0xeb9a05da,0x7bdf05db,0xb5fb026f,0x394a05dc}},	//   _тим_, ciqu, prác, _webs_,
   {{0x7c2285dd,0xfe6f85de,0x2d8785df,0x61fa85e0}},	//   _rior, ندو_, fene_, yotl,
   {{0x69de020f,0x2d8785e1,0x443a05e2,0x7c228014}},	//   qipe, gene_, _ktp_, _sior,
   {{0x69dc00f7,0x7c2285e3,0x6fc60118,0x50b5002e}},	//   _imre, _pior, _nóco, _есту,
   {{0x78a105e4,0xa3ba80f7,0x27ed8168,0xe3bf0144}},	//   _álva, شاعر_, _gjen_, _tiñe_,
   {{0x2d8785e5,0xa91c8038,0xf41302f6,0x69dc02f7}},	//   bene_, teľo, ופה_, _kmre,
   {{0x2fc905e6,0x61e881ec,0x20068168,0x7bdf05e7}},	//   _slag_, undl, lloi_, ziqu,
   {{0x09b78307,0xeb0705e8,0x2fc9056c,0x28f885e9}},	//   تطيع_, _शर्त_, _plag_, сень_,
   {{0x93258077,0x32058039,0xea0100ff,0x7bdf05ea}},	//   _فرهن, ally_, _đập_, xiqu,
   {{0x645a005c,0x442c84fe,0x69dc05eb,0xf98f80d5}},	//   štil, _hud_, _omre, ربی_,
   {{0x63a605ec,0x72e980be,0x443a05ed,0x200005ee}},	//   _ankn, _פֿײַ, _btp_, _ekii_,
   {{0x7bdf05ef,0x69ca808e,0x442c8162,0x7bcd05f0}},	//   tiqu, _ilfe, _jud_, thau,
   {{0x5a3505f1,0x798885f2,0x3a3905f3,0x69dc05f4}},	//   знат, ledw, _ptsp_, _amre,
   {{0x7bdf03d3,0x442c85f5,0x7bcd05f6,0x2d9305f7}},	// [250] riqu, _lud_, rhau, _taxe_,
   {{0x7bdf0557,0x442c85f8,0x7bcd05f9,0xaca301bc}},	//   siqu, _oud_, shau, _apụg,
   {{0x2d8785fa,0x6e2d022c,0xf8ca85fb,0x20ca85fc}},	//   vene_, _huab, ानिय, ानिध,
   {{0x6d5a85fd,0x7e6281e0,0x2d8780d7,0x6e2d05fe}},	//   _adta, frop, wene_, _kuab,
   {{0xf77085ff,0x27ed80f1,0x2d87835f,0x7c3a8600}},	//   ضان_, _vjen_, tene_, _attr,
   {{0x442c8601,0xb2ba01c6,0x6e2d0602,0xa2ba01c6}},	//   _bud_, _המשר, _muab, _המשט,
   {{0x2d878603,0xd8380048,0x27ff81cd,0x7d1c808b}},	//   rene_, _мэт_, _tkun_, _úrsl,
   {{0x5ba98604,0x442c8197,0x2d878605,0x69ca8606}},	//   ским_, _dud_, sene_, _alfe,
   {{0xe9d98607,0x2d878608,0x64488609,0x79950234}},	//   йки_, pene_, _ewdi, _kazw,
   {{0x442c80f7,0x6ca7860a,0x69c5060b,0x2ba981cb}},	//   _fud_, _мреж, nkhe, काहा,
   {{0x6d43860c,0x442c8082,0x2a6901c5,0x6e2d0362}},	//   mbna, _gud_, huab_, _auab,
   {{0x69ca860d,0xe29f007b,0x7649860e,0x628d060f}},	//   _elfe, _orð_, _kwey, kwao,
   {{0xb9028610,0xfaa58611,0x7bcb8612,0x629800eb}},	//   _ने_, _хало, _ilgu, āvok,
   {{0xceb2804c,0x69c50613,0x79950063,0x645a005c}},	//   עים_, jkhe, _nazw, štim,
   {{0x61e18614,0xdca30615,0x64a30616,0x764983f7}},	//   mill, нари, нара, _lwey,
   {{0x61e18617,0x67298618,0x3cde8006,0x69dc0619}},	//   lill, _ngej, _कइसे_, _smre,
   {{0x61e1861a,0x443a008e,0x2737001c,0x37e180ab}},	// [260] oill, _wtp_, _ủng_, যকার,
   {{0x3ea0061b,0x443a0359,0x6d41061c,0xa96a01a8}},	//   _irit_, _ttp_, ılac, إمام_,
   {{0x7e628372,0x6e3b861d,0x55bb01c6,0x2ec4861e}},	//   wrop, _atub, _המיו, वन्त,
   {{0x442c861f,0x2d980620,0x2d8a0621,0x7e628622}},	//   _rud_, ldre_, lebe_, trop,
   {{0x61e18623,0xdfcf8624,0xc61580c8,0x2a690282}},	//   kill, دين_, াদনা_, cuab_,
   {{0x7bcb8531,0x2d980625,0xb5fb0626,0x61e18627}},	//   _algu, ndre_, hrán, jill,
   {{0xf7468628,0x200683d3,0x62828629,0xb4c6800d}},	//   _нево, ploi_, _spoo, उने_,
   {{0x7dcb062a,0x2d8a062b,0x9f5900e7,0x61e1862c}},	//   _müsa, hebe_, posé_, eill,
   {{0x63b9862d,0x61e1862e,0x60338087,0xdcfa80eb}},	//   _down, fill, _răma, _patē,
   {{0xe3bf062f,0x442c8630,0x61e18631,0x6d5a806a}},	//   _miña_, _tud_, gill, _udta,
   {{0xe3bf062f,0xb5fb0632,0x2d8a0633,0x442c8634}},	//   _liña_, frán, debe_, _uud_,
   {{0x61fe0047,0x61e18635,0x79888636,0x22400637}},	//   hopl, aill, sedw, kpik_,
   {{0x71a68638,0x61fe0639,0xe3bf0264,0x2ba9863a}},	//   _надз, kopl, _niña_, कारा,
   {{0x61e1863b,0x64550065,0x4426863c,0x2d8a063d}},	//   cill, tszi, _hio_, gebe_,
   {{0x4426863e,0x3ea00176,0x48dc016f,0xb5fb03c1}},	//   _kio_, _erit_, _गेलो_, brán,
   {{0xcf2700f7,0x3ea0006a,0x2d98063f,0x6e2d0640}},	//   _عربي, _frit_, adre_, _tuab,
   {{0x44268641,0x61eb8019,0x7c260642,0x2d8a0643}},	// [270] _mio_, _állí, _dikr, bebe_,
   {{0x2d8a0644,0x61fe00fe,0x44268645,0xeb9f0646}},	//   cebe_, gopl, _lio_, _skød_,
   {{0x7c260647,0x69c50648,0x25d800be,0x2a690069}},	//   _fikr, rkhe, _מוזן_, suab_,
   {{0x61e18649,0xb8d5064a,0x4426864b,0xe29f008b}},	//   zill, _जप_, _nio_, _eyða_,
   {{0x6ff5809a,0xcb9a0039,0x63b9864c,0xf8a9864d}},	//   jące, _וסרט, _rown, _छप्प,
   {{0xd1268013,0x06f4803d,0x6b89864e,0xbea2864f}},	//   _لم_, رسنج, weeg, ташк,
   {{0x44268025,0x6b898650,0x2ba98651,0xdb0603ec}},	//   _bio_, teeg, काला, _ankè,
   {{0x2fc68052,0x5f948652,0x44268653,0x3f8b0654}},	//   ckog_, _пист, _cio_, jecu_,
   {{0x6b898079,0x44268655,0x8d878656,0x60188009}},	//   reeg, _dio_, _нужд, _хотя_,
   {{0x61e180e7,0x26c20084,0x63b982f7,0x5555803d}},	//   uill, vyko_, _wown, _آپار,
   {{0x61e18657,0x7dd00009,0x442683a7,0xb5fb0658}},	//   rill, _jäse, _fio_, trán,
   {{0x61e18659,0x4426865a,0xdee6065b,0x66e6065c}},	//   sill, _gio_, доми, дома,
   {{0x7dd0016d,0xb5fb05e4,0xab0b803d,0x6fc6002a}},	//   _läse, rrán, _اتاق_, _hóck,
   {{0xb21b065d,0x26110105,0x7c26065e,0x61e1865f}},	//   _spæn, _दीदी_, _sikr, qill,
   {{0x2d9801b3,0x3e76006a,0x2d8a00b4,0x3b960073}},	//   rdre_, sæt_, rebe_, мјат,
   {{0x6ff60307,0x3ea00660,0xea01001c,0xe3bf0661}},	//   _تستط, _trit_, _đạp_, _piña_,
   {{0x61fe0662,0x2bbf0663,0x3b070098,0x7c260664}},	// [280] topl, _एकरा, дето_, _vikr,
   {{0x3cde8665,0xe3bf05e4,0xc98601a8,0x2fcd8162}},	//   _कइले_, _viña_, بشري, _aleg_,
   {{0x7c260666,0x61fe0667,0x8cb503eb,0x2fc68668}},	//   _tikr, ropl, _उपयो, tkog_,
   {{0xe3bf062f,0x672d8669,0x2fcd810c,0x4f0a866a}},	//   _tiña_, žajn, _cleg_, онен_,
   {{0x442680a9,0xa91c80e1,0xa248003d,0xdb0f016a}},	//   _rio_, teľk, _ریال_, _tocá,
   {{0x2fc68289,0x44268010,0x3f8b017f,0x7d1c808b}},	//   skog_, _sio_, zecu_, _úrsk,
   {{0xd49781bb,0x52b8866b,0x6da3866c,0x69ce066d}},	//   дры_, ेन्स, тија, _ilbe,
   {{0x27e000e4,0xcfaa866e,0xc1788196,0x2918066f}},	//   _nmin_, _باسم_, ynės_, ągać_,
   {{0x8cb50670,0x44268671,0x29078672,0xb5fb016a}},	//   _उपभो, _vio_, _ayna_, rtáz,
   {{0x27e00673,0x7c3e003a,0x76428674,0x290781b0}},	//   _amin_, _otpr, mpoy, _byna_,
   {{0x44268675,0xf1bf001c,0x3f8b026c,0xf99301c6}},	//   _tio_, _quái_, tecu_, דרת_,
   {{0x443e8065,0x72c68676,0x62860677,0x29078114}},	//   _itt_, _обез, _opko, _dyna_,
   {{0x441b8158,0x69ce0358,0xa3ab8105,0x3f8b017f}},	//   _וואס, _olbe, खार_, recu_,
   {{0x34950678,0x443e8679,0x27e0067a,0x7dcf8366}},	//   нагр, _ktt_, _emin_, _tøse,
   {{0xe4e400e8,0x628600eb,0xc1788084,0x7d088366}},	//   вітн, _apko, snės_, _jyds,
   {{0x69ce067b,0xcbcd00ab,0xddc9801b,0x7dd0039c}},	//   _albe, রচ্ছ, _dveř, _räse,
   {{0x6feb0063,0x5215067c,0xbbbf036d,0x6b82867d}},	// [290] jęci, едат, _एकीक, _mbog,
   {{0x443e867e,0x2fcd867f,0x64588680,0x26000072}},	//   _ott_, _sleg_, ksvi, ळवणी_,
   {{0x3cde835a,0x443e8681,0x6d470682,0x764d0683}},	//   _केले_, _ntt_, mbja, _hway,
   {{0x764d0684,0x69ce0685,0x64588686,0x7dd00106}},	//   _kway, _elbe, dsvi, _väse,
   {{0x443e8687,0xb906058c,0x6fc600f7,0x733a00be}},	//   _att_, _बे_, _dóch, _מערס,
   {{0x6b828688,0x6d550689,0x63bd068a,0x764d0247}},	//   _abog, naza, _hosn, _mway,
   {{0x26c9803a,0x6458868b,0x6aa2808e,0x63bd007b}},	//   šao_, gsvi, _arof, _kosn,
   {{0x6d55068c,0x672d068d,0xe3bf04c3,0x61e5068e}},	//   haza, _ngaj, _miño_, lihl,
   {{0x443e868f,0xb5fb0019,0x29078690,0x6aa28691}},	//   _ett_, trál, _syna_, _crof,
   {{0xf1b180f7,0x672d04b9,0x6e288197,0x63bd0692}},	//   اءة_, _agaj, _gidb, _losn,
   {{0xe3bf0693,0x764d0694,0x6aa2826b,0x6d550695}},	//   _niño_, _away, _erof, daza,
   {{0x649a8051,0x6b828324,0x63bd0696,0x64438502}},	//   _מסעד, _gbog, _nosn, mpni,
   {{0x0aeb8077,0xe1ee8098,0x6d55005d,0x34c80697}},	//   _براي_, _бг_, faza, रन्द,
   {{0x7bcf0698,0x200b0699,0x6d55069a,0x6b82812b}},	//   _alcu, alci_, gaza, _zbog,
   {{0xafe6069b,0xb042801c,0xdb86069c,0x63bd069d}},	//   _покл, _trưở, нгви, _bosn,
   {{0x6b9b869e,0x7ae4869f,0x63bd0090,0x27e0008e}},	//   ndug, _žiti, _cosn, _umin_,
   {{0x6d5506a0,0xada606a1,0x7bc98198,0x200206a2}},	// [2a0] baza, _запл, ikeu, moki_,
   {{0xdb0d0125,0x200206a3,0x7bcf0144,0x673b85ee}},	//   rkað, loki_, _elcu, _afuj,
   {{0x7dcb0457,0xb5fb016b,0x717300f7,0x7bc98198}},	//   _müsl, kráj, اهما, kkeu,
   {{0x2d9a06a4,0x48c300ab,0x601606a5,0x2ca5006a}},	//   _hape_, ্পূর, lámb, ælde_,
   {{0x2d9a06a6,0x490686a7,0x7bc986a8,0xfeb7803d}},	//   _kape_, _सुनो_, dkeu, فاوت_,
   {{0x63ab86a9,0x645886aa,0xab5b01ec,0x200206ab}},	//   _angn, tsvi, _flüs, hoki_,
   {{0x200206ac,0x2d9a06ad,0xa3ab86ae,0xb0de86af}},	//   koki_, _mape_, खां_, _फेंग,
   {{0x645883a6,0x6b9b84a7,0x8cb182f1,0x9f5901ca}},	//   rsvi, gdug, _अपरो, tosí_,
   {{0x6d5506b0,0x60e00110,0x645886b1,0x200206b2}},	//   yaza, žymė, ssvi, doki_,
   {{0x27e686b3,0x7d08867f,0x2d9a06b4,0x6b8d011b}},	//   lion_, _tyds, _nape_, zeag,
   {{0xc05786b5,0x764d06b6,0x5fc486b7,0xdddb80ce}},	//   нія_, _sway, _वकाल, _upuš,
   {{0x6d5506b8,0x6b8286b9,0x27e686ba,0x6b998326}},	//   waza, _ubog, nion_, _gawg,
   {{0xcf938158,0x26c686bb,0x6d5506bc,0x63bd06bd}},	//   נטש_, nyoo_, taza, _rosn,
   {{0x7d0306be,0xbbc902ef,0x2bc906bf,0x764d06c0}},	//   _ønsk, रस्क, रस्थ, _vway,
   {{0x6d5506c1,0x26ec8665,0x63bd06c2,0x5ff50098}},	//   raza, जपुर_, _posn, _изку,
   {{0xe3bf04c3,0x6d5a06c3,0x27e686c4,0x60160118}},	//   _viño_, ótar, jion_, táme,
   {{0x27e686c5,0x6b8d06c6,0x6d5506c7,0x497506c8}},	// [2b0] dion_, reag, paza, клас,
   {{0x601606c9,0x8cb1809a,0x63bd008e,0x6b8d06ca}},	//   ráme, _अपलो, _wosn, seag,
   {{0xc95380be,0x6fc60187,0x6f0986cb,0x61e506cc}},	//   רמע_, _sóci, _syec, rihl,
   {{0x27e686cd,0x61e5005d,0x60c50009,0x76598428}},	//   gion_, sihl, ryhm, tswy,
   {{0xa3b486ce,0xee3886cf,0x7e7d06d0,0xd35604de}},	//   ञान_, ені_, ntsp, _שישי_,
   {{0xfce581cf,0x442b06d1,0x7bc981ed,0xd5bb86d2}},	//   коло, _hic_, wkeu, ясе_,
   {{0x645a06d3,0x27e68114,0x02c986d4,0x6b9b86d5}},	//   štiv, bion_, िन्न, tdug,
   {{0x27e686d6,0x25ac802a,0x644386d7,0x443306d8}},	//   cion_, _endl_, rpni, _mux_,
   {{0x7dd000f2,0x7bc986d9,0x443306da,0x2a690066}},	//   _läsa, rkeu, _lux_, nrab_,
   {{0x644386db,0x3f8f807b,0xddc28110,0x7bc986dc}},	//   ppni, legu_, puoš, skeu,
   {{0x660386dd,0xa3c306de,0x442b06df,0x200206e0}},	//   monk, ्सा_, _oic_, toki_,
   {{0x442b06e1,0xb4bf8076,0xf77206e2,0x66038234}},	//   _nic_, ुनी_, جاد_, lonk,
   {{0x443306e3,0x200206e4,0x3f9b0609,0x7e7d06e5}},	//   _aux_, roki_, _daqu_, gtsp,
   {{0x008586e6,0x442b06e7,0x7d048214,0x27e686e8}},	//   _алко, _aic_, şise, zion_,
   {{0xdce18214,0xa50706e9,0x601886ea,0xd62706eb}},	//   _kalı, вера_, líme, торе_,
   {{0x27e682be,0x3f8f86ec,0x442b06ed,0x660386ee}},	//   xion_, jegu_, _cic_, honk,
   {{0x442b06ef,0x443302be,0x3ae80077,0x2ebd86f0}},	// [2c0] _dic_, _eux_, ربری_, ्नोत,
   {{0xb14306f1,0x261683db,0xdcfc00eb,0x7c2b86f2}},	//   инул, _पीढी_, ndrī, _ligr,
   {{0x27e686f3,0xe0d200f7,0xd6a9026a,0x27f7015b}},	//   tion_, جزء_, _قدیم_, _سفید_,
   {{0x7c2b86f4,0x2d858039,0xa3a9064a,0x442b06f5}},	//   _nigr, _able_, _गोप_, _gic_,
   {{0x27e686f6,0xa3ab823c,0x644186f7,0xc32000ab}},	//   rion_, खाई_, _atli, _ফ্রি_,
   {{0x27e686f8,0xd94306f9,0x442b0087,0x614306fa}},	//   sion_, _вери, _zic_, _вера,
   {{0xdce183bf,0x27e686fb,0x2d8e86fc,0x09e306fd}},	//   _balı, pion_, refe_, _торн,
   {{0x442006fe,0x7bd606ff,0xb5fb0700,0xd9ca8701}},	//   nmi_, nhyu, nuár, िस्ट,
   {{0x64418702,0x877b80be,0x60188661,0x3cde8074}},	//   _etli, _קאמי, gíme, _कइके_,
   {{0x79a68703,0x66038704,0xf1a68705,0x2fc00706}},	//   трие, conk, трин, _aoig_,
   {{0x799c0707,0x7bd60708,0x44200709,0x4ce080ab}},	//   _marw, khyu, kmi_, _পুরু,
   {{0x6d58870a,0x7e7d070b,0x4420070c,0x9f4b0020}},	//   lava, ttsp, jmi_, vocó_,
   {{0xb5fb0065,0x2902809a,0x4420070d,0xf40800ab}},	//   nság, łka_, dmi_, লগার_,
   {{0x6d58870e,0x442b00f1,0xdd11026f,0x4420070f}},	//   nava, _sic_, _výži, emi_,
   {{0x61e88710,0x2fd20711,0xf41480be,0x645c0106}},	//   midl, _flyg_, ָפּ_, gsri,
   {{0x6d588712,0xdce18713,0xa3dd009a,0xef670098}},	//   hava, _xalı, थों_, _ръко,
   {{0x799c0714,0x6d588715,0x2009010c,0x2b4900fe}},	// [2d0] _barw, kava, _ikai_, rbac_,
   {{0x6d588025,0x44200716,0x799c0717,0xb5fb0718}},	//   java, ami_, _carw, dság,
   {{0x2d9100b4,0x48c300ab,0x3c388019,0xd246853d}},	//   meze_, ্প্র, _név_, _گن_,
   {{0x2d910719,0x6603871a,0x4420071b,0x926b0087}},	//   leze_, wonk, cmi_, _орга_,
   {{0x645a003a,0x35a8023c,0xd2468065,0x799c0428}},	//   štit, _छोड़, _دن_, _farw,
   {{0xa3c3035a,0x6d58871c,0x3e7b82be,0x6575071d}},	//   ्सव_, gava, rêt_, ngzh,
   {{0x6603871e,0xfd500135,0xdb0b80e7,0x6b9d0122}},	//   ronk, _aghụ, _ingé, _kasg,
   {{0x7c3e803e,0x6603871f,0x7bcd0720,0x1fa48721}},	//   ípra, sonk, nkau, _круг,
   {{0x6603807a,0x2fc00722,0x6b9d0723,0x2d910724}},	//   ponk, _roig_, _masg, keze_,
   {{0x44200725,0x20090041,0x3c3880e7,0x61e88726}},	//   zmi_, _akai_, _fév_, gidl,
   {{0x7c2b8727,0x44200728,0x7bcd0364,0x80ad8540}},	//   _tigr, ymi_, kkau, टमें,
   {{0x366a0729,0xeb9f006a,0x5275872a,0x7bcd01c0}},	//   намо_, _skøn_, _буку, jkau,
   {{0x6f0d00b4,0x4420072b,0x765d072c,0x61e8872d}},	//   _cyac, vmi_, gssy, bidl,
   {{0x63bb872e,0x4095872f,0x2d9102a0,0x645c0730}},	//   ljun, _брит, geze_, tsri,
   {{0x07a60048,0x44200731,0x6b9d0732,0x6f0d0733}},	//   _байн, tmi_, _basg, _eyac,
   {{0x63bb8734,0x7bcd0735,0x44200736,0x6b9d0114}},	//   njun, gkau, umi_, _casg,
   {{0xc332836b,0xdcfa80eb,0x6d588737,0x60160511}},	// [2e0] מון_, _patī, yava, cáma,
   {{0xd05a0558,0x64410207,0xddd481ac,0x7bd602a0}},	//   ерді_, ílic, _ťažk, shyu,
   {{0x6d588738,0x63bb808b,0x2a7f82f1,0x6b9d0739}},	//   vava, kjun, htub_, _fasg,
   {{0x4444073a,0x61e8873b,0xb4c2073c,0x799c073d}},	//   _it_, zidl, ्नी_, _warw,
   {{0x6d58873e,0x4444073f,0xa3c30740,0x799c0741}},	//   tava, _ht_, ्सर_, _tarw,
   {{0x270300ff,0xb5fb0742,0x7dd001d6,0x98be8196}},	//   ổng_, trái, _mäso, lbtą_,
   {{0x6d588743,0x44440744,0x61e8827f,0x395a01e0}},	//   rava, _jt_, vidl, maps_,
   {{0x7dc68125,0x2d910745,0xb5fb01a8,0x6f090035}},	//   _aðst, zeze_, rrái, żeci,
   {{0x44440746,0x6d5e84c3,0xb4c2000d,0x0aea80f7}},	//   _lt_, ópas, ्नु_, عربي_,
   {{0x44440747,0xc27b03de,0x765d0163,0x776402f9}},	//   _ot_, עריי, vssy, _adix,
   {{0x20090748,0x28f88749,0x63bb874a,0x26e200ab}},	//   _pkai_, тень_, bjun, _গুলো_,
   {{0x09c1016f,0x2d91074b,0x2006874c,0x765d074d}},	//   _शक्य, weze_, nooi_, tssy,
   {{0x4444004c,0x61e8874e,0xa91c81ac,0x2d91074f}},	//   _at_, pidl, teľs, teze_,
   {{0x7dcb0006,0xb5fb003e,0x0cb680c8,0x23278750}},	//   _küsi, hráv, জনীত, _сочи_,
   {{0x2d910751,0x6b840752,0x6b9d0753,0xd13f809a}},	//   reze_, ffig, _pasg, łącz_,
   {{0x672d8754,0x44440755,0x2d910756,0x261a06a7}},	//   žaji, _dt_, seze_, _मीठी_,
   {{0x44440757,0x99550758,0x7bcd0759,0xf96b075a}},	// [2f0] _et_, икац, rkau, ерей_,
   {{0x2d9e875b,0x7bcd075c,0x444401c6,0x6b9d075d}},	//   _nate_, skau, _ft_, _wasg,
   {{0x6b9d0014,0x3ea904e8,0x92b50264,0x63bb875e}},	//   _tasg, _hrat_, জনে_, yjun,
   {{0xb4d100a5,0x3ea9075f,0x66070088,0x64450760}},	//   वनी_, _krat_, lojk, _ithi,
   {{0x2d9e8761,0x248c80ee,0x29180762,0xd2440087}},	//   _bate_, _apdm_, _ezra_, _гэси,
   {{0xd6580051,0x22490763,0x6da58764,0x2d9e802e}},	//   ניות_, mpak_, рика, _cate_,
   {{0xeb998765,0x2d9e8766,0x23d58767,0xa3b90768}},	//   вий_, _date_, ицир, चाप_,
   {{0xea010104,0xb5fb01df,0x3ff980be,0x2d9e838a}},	//   _đẹp_, nsáb, _ספּע, _eate_,
   {{0x22490769,0x59a686a7,0xe3b6876a,0xd7f88084}},	//   npak_, _कोहर, рбы_, _сур_,
   {{0x3a2e83a8,0x7c2f076b,0x6ff201a9,0x64450234}},	//   _cifp_, _licr, māci, _othi,
   {{0x7dd000f2,0x7c9586e2,0xf9920039,0x6607076c}},	//   _säso, _خلاص, חרי_, dojk,
   {{0x2249076d,0xf1d98651,0x7c2f0706,0x2d218072}},	//   kpak_, योजन, _nicr, मधील_,
   {{0x6445076e,0xa3b90321,0x2d9e876f,0x6ff200eb}},	//   _athi, चान_, _yate_, nāci,
   {{0x3ea9008e,0x7bc281c0,0x9fb881d0,0xe4da00d7}},	//   _drat_, _zoou, včí_, پورت_,
   {{0xb4c20770,0x3ea9010b,0xd5e4019d,0x69c38771}},	//   ्ने_, _erat_, _apị, _ione,
   {{0x6ff200eb,0xa3a90105,0x2d9e027f,0xb5fb04f0}},	//   kāci, _गोद_, žte_, dráu,
   {{0x442f8772,0x44440773,0x64450774,0x60188775}},	// [300] _mig_, _wt_, _ethi, jíma,
   {{0x44440776,0x442f8777,0xbbd28778,0xe9d70779}},	//   _tt_, _lig_, _तत्क, аку_,
   {{0x4444077a,0x673b077b,0x69c3877c,0xd91000d5}},	//   _ut_, žuje, _mone, سیر_,
   {{0xc60e83b7,0xddc28029,0x6d41877d,0x53ca0424}},	//   ित्य_, droš, _afla, _रविश,
   {{0x7c24077e,0x9f82077f,0x7ae90669,0xeb970081}},	//   mmir, _yóò_, _žetv, _тия_,
   {{0x2b4d8780,0x6d5c0781,0x69c380b4,0x442f8782}},	//   ebec_, nara, _none, _aig_,
   {{0x442f8783,0x601d02be,0xb5fb026f,0x2bdd016f}},	//   _big_, léme, práv, नोका,
   {{0xa3b905b3,0x442f8784,0x0b8a8139,0x938a8785}},	//   चाय_, _cig_, тски_, тска_,
   {{0x442f8786,0x2a6d8787,0x6d5c0788,0x3c3c0789}},	//   _dig_, greb_, kara, _lív_,
   {{0x6d5c078a,0x4e7b8051,0x64430036,0x442f878b}},	//   jara, _באמצ, _énig, _eig_,
   {{0x6607003b,0x69c3878c,0xb4c203bb,0x3137078d}},	//   vojk, _done, ्नो_, ינים_,
   {{0x6d57078e,0x41a68076,0x3ea9078f,0x0aea8790}},	//   _sexa, _कोरस, _prat_, _идей_,
   {{0xdefb0791,0x6d5c0792,0x69c38793,0x7c240669}},	//   тын_, fara, _fone, dmir,
   {{0x6d5c0794,0x442f8795,0x7c2f031d,0x3ea90796}},	//   gara, _zig_, _sicr, _vrat_,
   {{0x442f8069,0xe4a40256,0x6d570797,0x6ff20029}},	//   _yig_, орто, _vexa, zāci,
   {{0x7c240798,0x3ea90799,0x83350081,0x69c3879a}},	//   gmir, _trat_, снах, _zone,
   {{0x6d5c079b,0x8d8701a1,0x69d5001b,0xba5501a8}},	// [310] bara, _кунд, _plze, صناع,
   {{0xe29f8125,0xc1788110,0x6ff201a9,0x3958079c}},	//   æði_, ngė_, vāci, _cers_,
   {{0xd1380698,0x224902f7,0x6445079d,0x4395079e}},	//   рху_, spak_, _uthi, _ланс,
   {{0x3958079f,0x224687a0,0x6ff200eb,0x6018807b}},	//   _eers_, _otok_, tāci, tíma,
   {{0x6d4181ec,0x9f42016b,0x60160019,0xbea587a1}},	//   _pfla, niká_, zámo, салк,
   {{0x442f87a2,0xb5fb07a3,0x6ff20029,0x629d07a4}},	//   _sig_, crát, rāci, _isso,
   {{0x27e907a5,0xe3b180f7,0x22468748,0x69c387a6}},	//   _oman_, كرة_, _atok_, _rone,
   {{0x69c387a7,0x442f822c,0x27e907a8,0x2a6d87a9}},	//   _sone, _qig_, _nman_, treb_,
   {{0x69c387aa,0xdcfe01a9,0x36d4804a,0x2b4d87ab}},	//   _pone, _papī, _дотр, rbec_,
   {{0xdef887ac,0x27e90590,0x25a107ad,0x69da8039}},	//   _тыс_, _aman_, _nahl_, ghte,
   {{0x2ed00076,0x442f87ae,0x1bf905e8,0x69c387af}},	//   हन्त, _tig_, ्काल_, _vone,
   {{0x6d5c07b0,0xcdc90051,0x601607b1,0x69c380f3}},	//   wara, _אך_, rámo, _wone,
   {{0x6d5c07b2,0x69c387b3,0x539a8039,0x7bdb8079}},	//   tara, _tone, _תינו, mhuu,
   {{0x69da87b4,0x27e9011e,0x32b881a8,0x601603a8}},	//   chte, _eman_, _خدمة_, pámo,
   {{0x629d07b5,0x04460226,0xb5fb016b,0x25a104dc}},	//   _asso, себн, vrát, _dahl_,
   {{0xe29a07b6,0x9f82007b,0x2b5907b7,0x7dd007b8}},	//   лаб_, _góð_, _cesc_, _käsk,
   {{0x2b400390,0xaaa786ae,0x09360742,0xb5fb07b9}},	// [320] rcic_, कटिक, مراج, trát,
   {{0x6d5c07ba,0x2a6007bb,0x2d87826c,0x601d07bc}},	//   qara, rsib_, jfne_, réme,
   {{0xfbd207bd,0x395807be,0x629d07bf,0x6f1b85e4}},	//   _فتح_, _vers_, _esso, _azuc,
   {{0xc88507c0,0x25a107c1,0x201f87c2,0x939607c3}},	//   daşı_, _zahl_, _chui_, _اجدا,
   {{0xe5c687c4,0x248c01b9,0x69da87c5,0x201f8362}},	//   йско, ħdmu_, yhte, _dhui_,
   {{0x443a07c6,0x62840106,0x6b96057b,0xe196002e}},	//   _kup_, mtio, leyg, _урмэ,
   {{0x7bc6029b,0x224687c7,0x62840009,0x29c9802a}},	//   _koku, _stok_, ltio, _lúas_,
   {{0xd00a87c8,0x443a0067,0x6b9607c9,0xb33b0315}},	//   _себе_, _mup_, neyg, _kaça,
   {{0x7ae907ca,0x63a407cb,0x628407cc,0x7bc607cd}},	//   _þett, idin, ntio, _moku,
   {{0x7bc607ce,0x27e907cf,0x984a8098,0xb33b07d0}},	//   _loku, _sman_, ляма_, _maça,
   {{0x7dcb07d1,0xe45287d2,0xb5fb07d3,0x8b66803d}},	//   _xüsu, _رضا_, krár, _هاشم,
   {{0x628407d4,0x69da820f,0x7bc6029b,0x6d5a816d}},	//   ktio, shte, _noku, _heta,
   {{0x6d5a87d5,0x63a407d6,0x7f5d002a,0xb4d107d7}},	//   _keta, ddin, rasq, वन्_,
   {{0x27078104,0x29c9862f,0x7c3a87d8,0xd6d800e8}},	//   ống_, _dúas_, _kutr, стю_,
   {{0xdce887d9,0x6d5a87da,0x395e87db,0x69d884a2}},	//   _kadı, _meta, mats_, _ilve,
   {{0x395e87dc,0x6d5a87dd,0x27e907de,0x7c3a811b}},	//   lats_, _leta, _uman_, _mutr,
   {{0x63a2822e,0x7c3a82a5,0x200b07df,0xb33b07e0}},	// [330] _maon, _lutr, moci_, _caça,
   {{0x7c3a87e1,0x2ba905b3,0x395e87e2,0x63a407e3}},	//   _outr, _चोरा, nats_, adin,
   {{0xceeb8077,0x5335079e,0x443a07e4,0x628407e5}},	//   گران_, _мент, _gup_, atio,
   {{0x61c587e6,0xb33b07e7,0xdea1803d,0x395e87e8}},	//   _लक्ष, _faça, ویزی, hats_,
   {{0x628407e9,0x7c3a86e3,0x6d5a87ea,0x25ed835a}},	//   ctio, _autr, _beta, _अगदी_,
   {{0x313507eb,0x6d5a87ec,0x7bc6029b,0xdcf88110}},	//   _февр, _ceta, _zoku, nevė,
   {{0x7bc6029b,0x628282a3,0x395e87ed,0x7c3a8087}},	//   _yoku, _aqoo, dats_, _cutr,
   {{0x69d887ee,0x69c707ef,0x7c3a87f0,0x6d5a87f1}},	//   _alve, _hoje, _dutr, _eeta,
   {{0x69c7003a,0xe9d987f2,0x64488201,0x200b0052}},	//   _koje, ики_, _etdi, doci_,
   {{0x7dcb0352,0x29c984c3,0x395e87f3,0x7dd0016d}},	//   _müss, _rúas_, gats_, _väsk,
   {{0x29c987f4,0x69c707f5,0x63a407f6,0x645e80e1}},	//   _súas_, _moje, ydin, špir,
   {{0x6d4507f7,0x69d887f8,0x6d5a87f9,0x200b0722}},	//   _afha, _elve, _zeta, goci_,
   {{0x395e87fa,0x6d5a87fb,0xa2948112,0xd9fb016f}},	//   bats_, _yeta, _наці, ्वात_,
   {{0x7dd003ff,0x395e87fc,0x7bc6029b,0x63a40295}},	//   _käsi, cats_, _soku, wdin,
   {{0x7bc607fd,0x63a287fe,0x64a307ff,0x7dcb0800}},	//   _poku, _yaon, мара, _rüst,
   {{0xb06880d5,0x63a40801,0x29c984c3,0x7dcb0074}},	//   _اصول_, udin, _túas_, _süst,
   {{0x63a40802,0x98a583bf,0x7dcb02f1,0x224d8088}},	// [340] rdin, malı_, _püst, npek_,
   {{0x7bc6029b,0x63a40803,0x3ea006c0,0x69c70804}},	//   _woku, sdin, _isit_, _coje,
   {{0x69c70805,0x62840806,0x7bc60807,0xdbd18214}},	//   _doje, stio, _toku, _güçl,
   {{0x2d980808,0x62840809,0x510c8158,0x98a5880a}},	//   lere_, ptio, נהאַ, nalı_,
   {{0xd5ba8009,0x4e96880b,0x63a2880c,0x601d080d}},	//   иск_, تشار, _raon, néma,
   {{0x2d98080e,0x7c3a81f1,0x3ead809f,0x7e6280b9}},	//   nere_, _putr, _dret_, rsop,
   {{0x395e880f,0xaff58065,0x98a5861c,0xb4d4853f}},	//   vats_, _کہنا_, kalı_, हने_,
   {{0x2d980810,0xdce88201,0x32668811,0x9faf001b}},	//   here_, _qadı, отов, tří_,
   {{0x6d5a8812,0x395e8813,0x2d980814,0xdb1d0019}},	//   _teta, tats_, kere_, _kosá,
   {{0x2d980815,0x670e0816,0xddc2809a,0x63a2804f}},	//   jere_, _सड़क_, społ, _waon,
   {{0x2d980817,0x395e8818,0x63a282b8,0xeb9a8819}},	//   dere_, rats_, _taon, _вие_,
   {{0x395e881a,0xf8ad881b,0xb09b01c6,0x2d98038a}},	//   sats_, اکو_, ביטר, eere_,
   {{0x2d98081c,0x200b081d,0x395e881e,0xa3b9081f}},	//   fere_, roci_, pats_, चास_,
   {{0x2d980820,0xddcf0162,0x61ea8162,0x69d88821}},	//   gere_, ducţ, _umfl, _ulve,
   {{0xfbd30013,0xa1778051,0x69c70822,0xc05a821e}},	//   وتر_, _ועוד_, _roje, _тіл_,
   {{0x44220823,0x69c70824,0xb5fb0825,0x98a58826}},	//   _chk_, _soje, rráq, calı_,
   {{0x2d980827,0x69c70828,0xe1f30829,0x7c22882a}},	// [350] bere_, _poje, وسط_, _mhor,
   {{0x2d98082b,0x44220006,0xdddb882c,0x3f99082d}},	//   cere_, _ehk_, _spuž, lesu_,
   {{0xe7f78076,0x2d81082e,0x69c7026f,0x7649882f}},	//   ंचला_, _iche_, _voje, _stey,
   {{0x3ead8830,0x320c8831,0x69c7009a,0x4c9a04de}},	//   _pret_, hody_, _woje, _פברו,
   {{0xb3ba0039,0x320c866f,0x00000000,0x00000000}},	//   _המרכ, kody_, --, --,
   {{0x7c228832,0x270a0104,0x27ef8833,0x246580eb}},	//   _ahor, ờng_, sign_, tēm_,
   {{0x98a58059,0xc5f4007c,0x7c228834,0x6b898122}},	//   yalı_, ודס_, _bhor, tfeg,
   {{0x3cfc012a,0x44290835,0x2d9800b4,0x3f99005d}},	//   ילונ, nma_, zere_, jesu_,
   {{0x6aa48836,0x7c228837,0x27ed8838,0xe7af009a}},	//   _šifr, _dhor, _imen_, _जोधप,
   {{0xe9d98139,0xaca38135,0x2d810135,0xba228071}},	//   ско_, _ahụm, _nche_, ндык,
   {{0x2d980839,0x4429083a,0x7c228013,0x224d883b}},	//   vere_, kma_, _fhor, spek_,
   {{0x2d98082e,0x7c22883c,0x4429083d,0x2fc9002a}},	//   were_, _ghor, jma_, _coag_,
   {{0x2d98083e,0x4429083f,0x98a583bf,0x25a58840}},	//   tere_, dma_, ralı_, _kall_,
   {{0x44290841,0x7c22816b,0x7dd00338,0x7ddd810c}},	//   ema_, _zhor, _läsv, _hèsb,
   {{0x2d980842,0x7c298843,0x44220573,0x27ed8844}},	//   rere_, omer, _phk_, _omen_,
   {{0x2d980845,0x44290846,0x4a460847,0x7c298848}},	//   sere_, gma_, знав, nmer,
   {{0x2d980849,0x6d41084a,0xe9da084b,0x236000dd}},	// [360] pere_, ılar, бка_, raij_,
   {{0x4429084c,0xb33b02be,0x7c29884d,0xdb04084e}},	//   ama_, _faço, hmer, ndié,
   {{0x6d5e00eb,0x7c29884f,0x6d3b01c6,0x63768850}},	//   _iepa, kmer, _לתינ, nünü,
   {{0xb4b800c2,0x7c298851,0xf1ba8129,0x291d0326}},	//   चमी_, jmer, _nhơn_, ƙwan_,
   {{0x6d5e0852,0xa3b90853,0xb4e486a7,0xa7fd02d0}},	//   _kepa, चार_, _पेड़_, ksın,
   {{0x6d5e0854,0x63a60855,0x7c228039,0x25a58856}},	//   _jepa, _hakn, _shor, _call_,
   {{0x25a58698,0x7c228857,0x63a60858,0x320c83fb}},	//   _dall_, _phor, _kakn, vody_,
   {{0x6d5e0859,0x7bd6085a,0x7c29885b,0xdcf881a9}},	//   _lepa, nkyu, gmer, levī,
   {{0x63a6085c,0x320c885d,0x25a5885e,0xdb040036}},	//   _makn, tody_, _fall_, udiè,
   {{0x64a6885f,0x20030025,0x672082fd,0xdca68860}},	//   _наза, čkim_, _izmj, _нази,
   {{0x44290861,0xa3190740,0x7c298862,0x660e0079}},	//   yma_, _दर्ज_, bmer, dobk,
   {{0x7c228863,0x44290864,0x2d810865,0x443e8866}},	//   _uhor, xma_, _sche_, _iut_,
   {{0x6d5e05f8,0xe80d80ba,0xb80d86b7,0x7c3e00e7}},	//   _bepa, िकता_, िकतम_, _aupr,
   {{0x6d5e0867,0x443e8868,0x1a9b80be,0x224b80e1}},	//   _cepa, _kut_, _לידע, ícke_,
   {{0x44290869,0x7c3e002e,0xdcf881a9,0xa3b9086a}},	//   tma_, _cupr, devī, चाल_,
   {{0x4429086b,0x443e886c,0x7dcf80e8,0x63a600b9}},	//   uma_, _mut_, _høst, _cakn,
   {{0x5a3500b3,0x443e886d,0x601d086e,0x69dc0362}},	// [370] днат, _lut_, lémo, _blre,
   {{0x443e804c,0x6d5e04eb,0x7c29886f,0x2d810870}},	//   _out_, _gepa, zmer, _uche_,
   {{0x7c298428,0xf8dc86ae,0x442902d0,0x9f4f8036}},	//   ymer, मनिय, pma_, ligé_,
   {{0xc10400a0,0x6d488871,0xa7fd02d0,0x60160118}},	//   روني, _afda, zsın, támi,
   {{0xf7708872,0x443e8873,0x6da586f1,0x81bc80eb}},	//   طان_, _aut_, дила, rmēj,
   {{0x443e804c,0x60160874,0xf6508875,0x6b828876}},	//   _but_, rámi, ائن_, _acog,
   {{0x63a60877,0x25a58722,0xdca28098,0x70940878}},	//   _yakn, _vall_, ващи, _парф,
   {{0x7dd00879,0x443e811e,0x601d087a,0x25a5887b}},	//   _häst, _dut_, démo, _wall_,
   {{0x200f887c,0x6449887d,0x91e5887e,0x443e8036}},	//   mogi_, _žlič, допе, _eut_,
   {{0x7c29887f,0x443e8880,0x39e9835f,0x69ca8881}},	//   smer, _fut_, ідно_, _cofe,
   {{0x65638882,0x7bdd02bb,0xdd1c826f,0x764d0883}},	//   manh, _olsu, _záži, _atay,
   {{0x7dd00884,0x637683bf,0x5ec600ab,0x65638885}},	//   _läst, rünü, _লেগে, lanh,
   {{0x6d5e0886,0x7bcb8887,0x7c3e0888,0x799a8889}},	//   _pepa, _iogu, _supr, betw,
   {{0x7dd004b8,0x63a9888a,0x51878791,0x63a6088b}},	//   _näst, lden, _худа, _sakn,
   {{0xa3b90076,0x660e0831,0x7bcb888c,0x764d038a}},	//   चां_, robk, _kogu, _etay,
   {{0x7ae4011b,0x673b888d,0x6d5e088e,0x6563888f}},	//   tzit, _nguj, _wepa, hanh,
   {{0x7bcb803a,0x7dd004b8,0x6d5e0890,0x62898891}},	// [380] _mogu, _bäst, _tepa, nteo,
   {{0x673b81ca,0x7bcb8892,0x6b9b80f3,0x63a98198}},	//   _aguj, _logu, heug, hden,
   {{0xdb0f023e,0xd91000d7,0x765b8893,0x59c40894}},	//   _encà, ایز_, _awuy, लॉगर,
   {{0xef1a8895,0x63a98896,0x443e8897,0x200f8898}},	//   оме_, jden, _rut_, gogi_,
   {{0x443e831d,0x7dd0016d,0xd765803d,0x60188899}},	//   _sut_, _fäst, رنوی, ními,
   {{0x7dd0089a,0x63a9889b,0x443e869d,0x6b8281e8}},	//   _gäst, eden, _put_, _scog,
   {{0x7dd0089c,0x78450110,0xb4bc052a,0x601d002a}},	//   _häss, _tėva, _आपो_, xémo,
   {{0x69ca889d,0xd7648019,0x7dcf889e,0x7bcb889f}},	//   _sofe, _سنئی, _søst, _cogu,
   {{0x291808a0,0x7bcb88a1,0xa80283bf,0x1eaa803d}},	//   _hyra_, _dogu, ğıda, _بازي_,
   {{0x443e88a2,0x7abb0039,0x7dd008a3,0x601d08a4}},	//   _tut_, קציו, _mäss, témo,
   {{0x2d9c820f,0x7dd002af,0xc0578221,0x443e8074}},	//   meve_, _läss, мія_, _uut_,
   {{0x2d9c88a5,0x6aa28041,0x601d08a6,0x764088a7}},	//   leve_, _tsof, rémo, _kumy,
   {{0x442688a8,0x628988a9,0x7dd008aa,0xa2fd066f}},	//   _iho_, cteo, _näss, _एशेज_,
   {{0x2d9c80f1,0x7dd4809f,0x764088ab,0x7bcb83ed}},	//   neve_, _bàsi, _mumy, _zogu,
   {{0x442688ac,0x200f88ad,0x2bbb01a8,0x16340198}},	//   _kho_, yogi_, يارة_, теря,
   {{0x7bcb81df,0x6aad88ae,0x2ba908af,0x439408b0}},	//   _xogu, _šafi, _चोखा, касс,
   {{0xa3d68424,0x6563833e,0x4e0e8035,0x764d08b1}},	// [390] _हवन_, yanh, ाकाई_, _utay,
   {{0x2d9c88b2,0x442688b3,0x6b9b82af,0xdbd68074}},	//   jeve_, _lho_, zeug, _hääl,
   {{0x7dd000f2,0xdb0b80f2,0x2d9c88b4,0x63a988b5}},	//   _väst, _ingå, deve_, yden,
   {{0xdb0f03a8,0x442688b6,0xddcd016b,0x656380b9}},	//   _encá, _nho_, _staň, wanh,
   {{0x20030025,0x7c2d0687,0x656388b7,0x7dd00364}},	//   čkih_, mmar, tanh, _täst,
   {{0x442688b8,0x44390051,0x291800f2,0x0ea880e8}},	//   _aho_, _his_, _fyra_, ькій_,
   {{0x443908b9,0x7bcb88ba,0x44268046,0x656388bb}},	//   _kis_, _pogu, _bho_, ranh,
   {{0x442688bc,0x7c2d08bd,0x443908be,0x7e7d08bf}},	//   _cho_, nmar, _jis_, kusp,
   {{0x443908c0,0x66f38894,0x656388c1,0x2a6908c2}},	//   _mis_, _अधिक_, panh, nsab_,
   {{0x443908c3,0x3f9d88c4,0x600808c5,0x628988c6}},	//   _lis_, lewu_, zımd, rteo,
   {{0x628988c7,0x7c2d08c8,0x7bcb88c9,0xdb060168}},	//   steo, kmar, _togu, _pakë,
   {{0xf77208ca,0x44390046,0x64418012,0x656181a3}},	//   داد_, _nis_, _iuli, _helh,
   {{0x442d88cb,0x81d588cc,0x644188cd,0x213c80ee}},	//   mme_, _подх, _huli, _fgvh_,
   {{0x644188ce,0x7c2608cf,0x4439061f,0x3f8401b9}},	//   _kuli, _shkr, _ais_, żmu_,
   {{0x65618003,0x443908d0,0xb8f480c8,0xa3b48054}},	//   _melh, _bis_, _সে_, _छोड_,
   {{0x442d8179,0x644188d1,0x7c2d08d2,0xf0628081}},	//   nme_, _muli, gmar, _скъп,
   {{0x291e0025,0x443908d3,0x160f88d4,0x422608d5}},	// [3a0] _šta_, _dis_, िवार_, едав,
   {{0x442d88d6,0x443908d7,0x7c2d08d8,0xdb06001b}},	//   hme_, _eis_, amar, _jaké,
   {{0x443908d9,0x644188da,0x442d88db,0x61fe08dc}},	//   _fis_, _nuli, kme_, rnpl,
   {{0x442d88dd,0x7dd00364,0x3f8208de,0xe853003d}},	//   jme_, _täss, ngku_, انند,
   {{0x2d9c820f,0x442688df,0x442d88e0,0x245e001b}},	//   teve_, _rho_, dme_, lům_,
   {{0x443908e1,0x644188e2,0x442d88e3,0x27f2008e}},	//   _zis_, _buli, eme_, _lmyn_,
   {{0x644188e4,0x2d9c80f1,0xd49784d9,0x27e008e5}},	//   _culi, reve_, еры_, _olin_,
   {{0x644188e6,0x442681e9,0x44390069,0x69ce011e}},	//   _duli, _qho_, _xis_, _hobe,
   {{0x65618065,0x69ce08e7,0x7c39831d,0x2d9c8168}},	//   _felh, _kobe, _diwr, peve_,
   {{0x44268051,0x27e008e8,0xef1f08e9,0x442d88ea}},	//   _who_, _alin_, ngüe_, ame_,
   {{0x644188eb,0xdbd68364,0x33d6835f,0x27e008ec}},	//   _guli, _pääl, _підт, _blin_,
   {{0x7e7d04a2,0xa2e688ed,0x7c2d0079,0x442d88ee}},	//   tusp, _поед, xmar, cme_,
   {{0x443908ef,0x0cc906ce,0x644188f0,0xa3d58006}},	//   _ris_, रह्म, _zuli, _सकत_,
   {{0x443901e9,0x7afd88f1,0x644188f2,0x27e008f3}},	//   _sis_, úste, _yuli, _elin_,
   {{0x443908f4,0x7e7d08f5,0xdbd68009,0x644188f6}},	//   _pis_, susp, _tääl, _xuli,
   {{0x44390069,0xa4010264,0x75d8007e,0x69c88106}},	//   _qis_, ্ষ্য_, _ağzı, ljde,
   {{0x443908f7,0x98ac83bf,0x1b0e80ab,0x7f490216}},	// [3b0] _vis_, madı_, াইকে_, ñequ,
   {{0x443903f8,0x69da88f8,0x98ac861c,0x9f590174}},	//   _wis_, nkte, ladı_, insí_,
   {{0xd36688f9,0x69ce08fa,0xaca30133,0x27e00198}},	//   _په_, _dobe, _kpọg, _ylin_,
   {{0x443908fb,0x7e6d08fc,0x6e3a8362,0x2d83021e}},	//   _uis_, _kvap, _aitb, lgje_,
   {{0xe7e288fd,0x2fcd80c9,0x6e3a88fe,0x2fdf874c}},	//   _खतरा_, _voeg_, _bitb, _vlug_,
   {{0x69ce08ff,0x64418900,0x20048088,0x7d1a8901}},	//   _gobe, _puli, _ejmi_, _byts,
   {{0x442d8902,0x65618903,0x301b80f7,0x6441811c}},	//   tme_, _velh, _فترة_, _quli,
   {{0x7bcf0012,0x64418904,0x2242008e,0x69da8905}},	//   _jocu, _vuli, _yukk_, ekte,
   {{0x628d0906,0x1309835f,0x9f4200f1,0x65618907}},	//   ntao, ьний_, shkë_, _telh,
   {{0x7bcf0012,0x64418908,0xb63587c3,0x63ad0909}},	//   _locu, _tuli, _شفاع, hdan,
   {{0xf8e1090a,0x63ad090b,0x442d890c,0xdb1d00f7}},	//   पनिय, kdan, pme_, _cosú,
   {{0x13a7803d,0x79818114,0x6e3a890d,0x78bc8338}},	//   _سنتی_, sglw, _zitb, årva,
   {{0x63ad090e,0x69c4090f,0x21e401ec,0x3f8c009a}},	//   ddan, रामी, _höhe_, ędu_,
   {{0x7ae98065,0x7e6d012b,0x69da8910,0x827680be}},	//   mzet, _dvap, ckte, _יענע_,
   {{0xa8060098,0x69ce0911,0xc5630912,0x2bc58913}},	//   _изкл, _robe, ркск, वापा,
   {{0x63ad0914,0x7bc98915,0x63ab8916,0x6f16809a}},	//   gdan, njeu, _jagn, życi,
   {{0x69ce0917,0x7bcf0918,0xe7f780d4,0x7ae98919}},	// [3c0] _pobe, _docu, ूचना_, nzet,
   {{0xdb0d008b,0x63ab891a,0x867b01c6,0x63ad091b}},	//   rjað, _lagn, _קריו, adan,
   {{0xa50a091c,0x3d16835a,0x8fa6891d,0x1d0a091e}},	//   _цена_, _पुढे_, каже, _цени_,
   {{0x4444091f,0x69ce0920,0x63ab8921,0x78b5026c}},	//   _iu_, _wobe, _nagn, _drzv,
   {{0x44440922,0xe7f3809a,0x776403a8,0xe7378923}},	//   _hu_, _आगरा_, _meix, вец_,
   {{0x44440924,0x77640118,0x249a00b9,0x7ae98925}},	//   _ku_, _leix, _kppm_, dzet,
   {{0x44440926,0x63ab8098,0x6f098927,0x629986c0}},	//   _ju_, _bagn, _exec, _apwo,
   {{0x44440928,0x3d16835a,0xb5fb00f7,0x63ab8929}},	//   _mu_, _पुणे_, rsái, _cagn,
   {{0x4444092a,0x249a008e,0xdb028118,0x7ae98061}},	//   _lu_, _lppm_, _taoí, gzet,
   {{0x4444092b,0xbda587bd,0xdb1d0331,0x6e3a837a}},	//   _ou_, _محمو, _posú, _uitb,
   {{0x4444092c,0x601d092d,0x717b010f,0x69da892e}},	//   _nu_, lémi, וניס, rkte,
   {{0x63ab892f,0xb4c08076,0x7ec900f1,0xb5fb0073}},	//   _gagn, ुही_, _nëpë, nsáv,
   {{0x44440930,0x77640931,0x63ad05f5,0xd25080f7}},	//   _au_, _deix, vdan, _انت_,
   {{0x44440932,0x63ab8933,0x76440326,0xceb381c6}},	//   _bu_, _zagn, _duiy, ביש_,
   {{0x44440934,0xa3d68935,0x77640936,0x657a00f7}},	//   _cu_, _हवा_, _feix, ótha,
   {{0x249a00b9,0x600802d0,0x6b840937,0x63a0821e}},	//   _dppm_, rımc, ggig, nemn,
   {{0x44440938,0x63ad0939,0x27e6893a,0x628081e0}},	// [3d0] _eu_, rdan, dhon_, numo,
   {{0x4444093b,0xa2940160,0x601d093c,0x628d00e5}},	//   _fu_, рафі, démi, rtao,
   {{0x44440782,0xf1ba8104,0x6280893d,0x94d5093e}},	//   _gu_, _chơi_, humo, _сонц,
   {{0xf093893f,0x65650940,0x62808941,0x63a08942}},	//   ינע_, _hehh, kumo, jemn,
   {{0x44440943,0x63ab8944,0x628080eb,0x6008080a}},	//   _zu_, _ragn, jumo, nıma,
   {{0xee38835f,0x7ae98945,0x8d548098,0x63ab8946}},	//   вні_, vzet, атъч, _sagn,
   {{0x44440947,0x63ab8948,0x64450074,0x20020035}},	//   _xu_, _pagn, _juhi, ynki_,
   {{0x64450949,0x27e6894a,0x7ae9894b,0x3f89022c}},	//   _muhi, chon_, tzet, _ncau_,
   {{0x7ae9803b,0x63ab894c,0x23c580d4,0x7764094d}},	//   uzet, _vagn, वाबद, _reix,
   {{0x798502f7,0x7ae9894e,0x7764094f,0x7bdb8950}},	//   nghw, rzet, _seix, skuu,
   {{0x54558951,0x63ab8952,0x6d418953,0x7ae98019}},	//   _свет, _tagn, _igla, szet,
   {{0x44440954,0xdce38955,0x63a0808e,0x92b58250}},	//   _ru_, nanč, cemn, _محتا,
   {{0x644502f1,0xe7370956,0x3ea90957,0x62c78174}},	//   _auhi, лею_, _csat_, _جزاك,
   {{0x44440958,0x64450959,0x2002026c,0x7c3d0362}},	//   _pu_, _buhi, snki_, _aisr,
   {{0x444406e3,0xfce3095a,0x7764095b,0x6565008e}},	//   _qu_, боро, _teix, _dehh,
   {{0x4444095c,0xdce38110,0xfaa6095d,0x81bc81a9}},	//   _vu_, janč, лабо, smēt,
   {{0x6d41895e,0x4444095f,0xfe7200d5,0x032602fb}},	// [3e0] _ogla, _wu_, _ادب_, удан,
   {{0x44440960,0x6d41845a,0x63a08961,0xf1ba8129}},	//   _tu_, _ngla, zemn, _phơi_,
   {{0x44440962,0x81bc8029,0x27e68963,0x644502a0}},	//   _uu_, slēg, thon_, _guhi,
   {{0x2a6d8964,0x6d418965,0x4b550081,0xbe8a8966}},	//   kseb_, _agla, _върт, еске_,
   {{0x44200967,0x6d5c0968,0xcc3b00be,0x44320969}},	//   mli_, obra, _רעכט, mmy_,
   {{0x4432096a,0x6143096b,0xe9df00f7,0xc6930039}},	//   lmy_, _гера, _dtús_, צאו_,
   {{0xe0c7896c,0x4420096d,0xdb1d03ec,0x63a0896e}},	//   _از_, oli_, _ansè, temn,
   {{0x4420017b,0x02a6896f,0x44320970,0x6e3e0971}},	//   nli_, гром, nmy_, _lipb,
   {{0x060a8972,0xaf068973,0xe20b009a,0x248e81e0}},	//   _знак_, _спал, łóż_, stfm_,
   {{0x44200255,0x2a978013,0x63a08974,0x62808975}},	//   hli_, ائية_, semn, rumo,
   {{0x438680d5,0x683e8110,0x62808976,0x02170039}},	//   _ملاق, _būda, sumo, רחים_,
   {{0x273a8182,0x3f8686c0,0x64450977,0x9f590168}},	//   _günü_, ngou_, _ruhi, misë_,
   {{0xeab284e3,0x64450978,0x9f590168,0x98b8022b}},	//   _دعا_, _suhi, lisë_, _ferħ_,
   {{0x44200979,0x2fc0097a,0x44320035,0x6445097b}},	//   eli_, _enig_, emy_, _puhi,
   {{0x4420097c,0x9f5900f1,0xfaff00f1,0xa2ac897d}},	//   fli_, nisë_, _ndër_, जिक्,
   {{0x4420097e,0x61fa897f,0x81bc80eb,0xdb0f0118}},	//   gli_, litl, slēd, _incú,
   {{0x6d5c0098,0xdce381f4,0x3ea90980,0xe51b83b7}},	// [3f0] bbra, vanč, _usat_, _पुनि_,
   {{0x44200981,0x6d5c0362,0x61fa8982,0x9f590168}},	//   ali_, cbra, nitl, kisë_,
   {{0x44200983,0xa3d58006,0xdce38984,0xdb04016a}},	//   bli_, _सकल_, tanč, rdiá,
   {{0xb4c3035a,0x44200985,0x673b011f,0x9f5903ed}},	//   ्ही_, cli_, žuju, disë_,
   {{0xd90f0986,0x8d658987,0xdce38988,0xea0080ff}},	//   _کیا_, авле, ranč, _giầy_,
   {{0x3f758104,0x7dd48722,0x443d8989,0xaaa80081}},	//   ều_, _bàsq, _siw_, _съюз_,
   {{0x5ed380c8,0x463c098a,0x7aed047f,0x244a898b}},	//   _দেশে, געגע, lzat, _cùm_,
   {{0x7bcd098c,0x0b45898d,0x22468122,0x6d5c098e}},	//   njau, шнин, _buok_, zbra,
   {{0x7aed098f,0x63af0990,0x11e58991,0x4a458992}},	//   nzat, _macn, ижим, јнов,
   {{0x6d41803a,0x43758077,0xe9d98993,0x44200994}},	//   _ugla, _چهار, тко_, zli_,
   {{0xf1b20451,0x44200995,0x23c58996,0x53c580d4}},	//   קסט_, yli_, वादद, वादश,
   {{0x22958997,0x629d074c,0x6d5c0998,0xb4b18999}},	//   _видя, _opso, wbra, टटी_,
   {{0x228f0019,0x6d5c099a,0x61fa899b,0x4420099c}},	//   jük_, tbra, bitl, vli_,
   {{0x2d87899d,0x4420099e,0x200900b9,0xeaf8853d}},	//   ngne_, wli_, _ejai_, _حرمت_,
   {{0x4420099f,0x64a609a0,0x629d003a,0x6d5c09a1}},	//   tli_, шава, _apso, rbra,
   {{0x35c7800f,0xdb0400a9,0x864604ad,0x2fc0031d}},	//   लाड़, ndiç, _книж, _unig_,

   {{0x442009a2,0xade589a3,0x443209a4,0x896609a5}},	// [400] rli_, कसान_, rmy_, икаж,
   {{0x442009a6,0xd5a409a7,0x63af00f7,0x68e481d0}},	//   sli_, _الدی, _eacn, _řidi,
   {{0x18a609a8,0x161f09a9,0xb5fb09aa,0x68e489ab}},	//   раем, _मीटर_, rsát, _ƙidi,
   {{0x442009ac,0x7bdf09ad,0x244a8014,0x7e6409ae}},	//   qli_, ckqu, _rùm_, _kwip,
   {{0x63a409af,0xe5c689b0,0x614609b1,0x3f8689b2}},	//   mein, иско, _вега, rgou_,
   {{0xd49a8381,0x5d7a0158,0x672981a9,0x63af09b3}},	//   ври_, דאַק, _dzej, _zacn,
   {{0x53e689b4,0xcbe689b5,0x672989b6,0x00000000}},	//   ициа, иции, _ezej, --,
   {{0x9f5908cf,0xdb008065,0x63a409b7,0x7afb0289}},	//   risë_, lemé, nein, _žuti,
   {{0x9f5900f1,0x75e201ac,0xee3a89b8,0x6fb38290}},	//   sisë_, _rôzn, _ана_, _بمقا,
   {{0x63a40352,0xe61f00e7,0x9f5909b9,0x3e328019}},	//   hein, ntôt_, pisë_, _بہتر,
   {{0x7aed09ba,0x9f5909bb,0x3167819d,0x61fa89bc}},	//   zzat, lisé_, _denz_, ritl,
   {{0x228f084a,0x61fa89bd,0x656889be,0x6618816b}},	//   yük_, sitl, _hedh, lovk,
   {{0x61fa89bf,0x644889c0,0xf1c909c1,0x34df09c2}},	//   pitl, _hudi, रामन, नन्द,
   {{0x644889c3,0x656889c4,0x249e89c5,0x752d801b}},	//   _kudi, _jedh, _kptm_, řaze,
   {{0x63a409c6,0x403509c7,0x31578039,0xb4c309c8}},	//   fein, _лекс, _דיון_, ्हे_,
   {{0x81e880c8,0x644889c9,0x2cba09ca,0x7aed09cb}},	//   _যদি_, _mudi, _drpd_, tzat,
   {{0x6e950307,0x7bcd0364,0x4df88105,0x5e9500f7}},	// [410] _الخا, rjau, ्चाई_, _الخط,
   {{0x201909cc,0x7bcd09cd,0x228f09ce,0xa80281cc}},	//   losi_, sjau, rük_, şıla,
   {{0x63af09cf,0xea008028,0x6618826f,0x6d4509d0}},	//   _tacn, _giấy_, dovk, _igha,
   {{0x64570102,0x63a400e7,0xdce709d1,0x5f7480f7}},	//   _itxi, cein, najč, قاهر,
   {{0xef1f080a,0x2bc5816f,0xa3bc06a7,0x656880d7}},	//   zgün_, वासा, _आफत_, _bedh,
   {{0x75eb0059,0x201909d2,0xa1840150,0x7bc289d3}},	//   _düzg, hosi_, _мысл, _anou,
   {{0x201909d4,0x2d8789d5,0xddc98087,0x6d4509d6}},	//   kosi_, rgne_, _aveţ, _mgha,
   {{0xd77489d7,0x6e45803d,0x3ff980be,0x316781e8}},	//   _واقع, _هنرم, _עפּע, _senz_,
   {{0x6568822e,0x69d509d8,0x201909d9,0x316c89da}},	//   _fedh, _koze, dosi_, fadz_,
   {{0x6d4509db,0x3ead83a7,0x65688077,0x69d509dc}},	//   _ngha, _iset_, _gedh, _joze,
   {{0x27338104,0x645701e9,0x7e6409dd,0x2019047f}},	//   _ảnh_, _ntxi, _swip, fosi_,
   {{0x6d4509de,0xdb0609df,0x0cb3864a,0xfaff067f}},	//   _agha, _laká, ंटीम, _reën_,
   {{0xe9ce89e0,0x64570102,0x6d450609,0x05c30035}},	//   _ек_, _atxi, _bgha, शांब,
   {{0xc5f28158,0x9f590009,0x63a40114,0x644889e1}},	//   ִדן_, ensä_, wein, _yudi,
   {{0x764189e2,0xdcf70201,0x644889e3,0x201909e4}},	//   _mily, _baxı, _xudi, bosi_,
   {{0x6b8989e5,0x6618826f,0x776989e6,0x7ddd88f9}},	//   ngeg, zovk, _neex, _dèsi,
   {{0x63a409e7,0xb5fb03a7,0x69d509e8,0xdb008061}},	// [420] rein, rsár, _boze, temé,
   {{0xb5fb09e9,0x05aa04d9,0x458609ea,0x3ea002d5}},	//   ssár, _свой_, _угов, _ipit_,
   {{0x656889eb,0x3ead89ec,0x442f89ed,0x6008080a}},	//   _redh, _aset_, _ohg_, yıml,
   {{0x644889ee,0x656e09ef,0x76498144,0x6b89890d}},	//   _rudi, labh, _buey, jgeg,
   {{0x6448803b,0x6b8989f0,0x69c38009,0x764189f1}},	//   _sudi, dgeg, _onne, _bily,
   {{0x2d9187d9,0x644888a4,0x20190135,0x9f5902be}},	//   _özel_, _pudi, zosi_, risé_,
   {{0x270409f2,0xdcf70201,0x645c09f3,0x442f89f4}},	//   रपुर_, _yaxı, npri, _bhg_,
   {{0x69c389f5,0xdb06003e,0x656e09f6,0x65688077}},	//   _anne, _zaká, habh, _wedh,
   {{0x6ff58063,0x75eb0214,0x316c8890,0x600801cc}},	//   jący, _yüzd, tadz_, rıml,
   {{0xc05a89f7,0x64488573,0x76418114,0x69c38144}},	//   лім_, _tudi, _gily, _cnne,
   {{0x644889f8,0x645c0639,0x201909f9,0x656e0706}},	//   _uudi, jpri, tosi_, dabh,
   {{0x69c389fa,0xa3cc0740,0x61fe0214,0x442f82c4}},	//   _enne, लाफ_, hipl, _ghg_,
   {{0x201909fb,0x2d9809fc,0x442480b9,0xdce181a9}},	//   rosi_, ffre_, mlm_, _ielā,
   {{0x6d480024,0xddcd009a,0x10f98019,0x15eb00e8}},	//   ždan, _stał, ابیں_, уємо_,
   {{0xd12f896b,0x69d509fd,0x7c240609,0x645c09fe}},	//   _хх_, _roze, flir, gpri,
   {{0x68e10074,0xdb0f0216,0x61fe09ff,0x98a78196}},	//   _üldi, _hacé, eipl, _agnė_,
   {{0x69d50a00,0x27e90a01,0xdd9100f7,0x645c0a02}},	// [430] _poze, _ilan_, _قوة_, apri,
   {{0x44248106,0x672d0a03,0xdb098118,0x776981b4}},	//   hlm_, _izaj, ndeá, _seex,
   {{0x463c0158,0x7c240a04,0x69d50a05,0xdb1d0a06}},	//   _געזע, blir, _voze, _insí,
   {{0x75eb07d9,0x76418a07,0xdb0981a8,0x2b4680ff}},	//   _düze, _sily, hdeá, _ngoc_,
   {{0x442480dd,0x62350a08,0xdb2300d7,0xdb060a09}},	//   dlm_, _мему, _روسی, _taká,
   {{0x27180028,0x442f8573,0x27fd8114,0x321a0a0a}},	//   ọng_, _shg_, siwn_, copy_,
   {{0x27e90a0b,0x75eb0179,0x64428a0c,0x2bc58a0d}},	//   _olan_, _güze, _bioi, वाला,
   {{0xa9f385b3,0x8c428a0e,0xa3cc016f,0x5f948193}},	//   ेच्छ_, меще, लाय_, _нист,
   {{0xdd3a8012,0x22430a0f,0x6b898a10,0x6442802a}},	//   tăţi, _kijk_, rgeg, _dioi,
   {{0x6b898a11,0x645c0a12,0x75eb02d0,0xfaff067f}},	//   sgeg, ypri, _yüze, _reël_,
   {{0x27e906c0,0x600a0a13,0xe5c48a14,0x3ea00a15}},	//   _blan_, ином_, _эсто, _spit_,
   {{0xd9a60a16,0x64428081,0x7a30016d,0xdb1d016a}},	//   _ऑस्ट, _gioi, mäte, _ansí,
   {{0xdb0f0a17,0x8db6004a,0x11d58a18,0x51f58a19}},	//   _facé, осві, _мікр, _وستر,
   {{0x645c0a1a,0xcb368039,0x27e90a1b,0x672d069f}},	//   tpri, _ואני_, _elan_, _dzaj,
   {{0x656e0834,0x236001ed,0xdb0b816a,0x2ea681d0}},	//   rabh, tbij_, _magí, _गन्त,
   {{0x27e90a1c,0x656e0a1d,0x645c0a1e,0xf34e8870}},	//   _glan_, sabh, rpri, _hụrụ_,
   {{0xe1fa0a1f,0x23600613,0x3ea00a20,0x53368158}},	// [440] ага_, rbij_, _upit_, ַנען_,
   {{0x244e0a21,0xf6530039,0x645c0a22,0xf77f0214}},	//   _tým_, _קצת_, ppri, rkçe_,
   {{0x321a0873,0x7c240a23,0x224301ed,0xf34e8135}},	//   ropy_, plir, _dijk_, _mụrụ_,
   {{0xf34e8133,0xdb040174,0x7a300198,0xb09a83de}},	//   _lụrụ_, idiú, däte, ייער,
   {{0x7bc60a24,0xddc98a25,0x2d588a26,0xdce701a9}},	//   _inku, _sveš, биль_, majā,
   {{0xddc9801b,0x624901a1,0x8cb88a27,0x78af0198}},	//   _kteř, _džod, ्मलो, äivä,
   {{0xc0c900a9,0x9cca8a28,0x37e680e8,0x3ea981b9}},	//   _луѓе_, рыла_, _довг, ħata_,
   {{0xd00a8a29,0x68e30257,0x39478a2a,0x7dd00198}},	//   _тебе_, ønde, _agns_, _väsy,
   {{0x77628a2b,0xf34e8a2c,0x661c0a2d,0xc1a68a2e}},	//   mbox, _bụrụ_, kork, ојни,
   {{0x661c0a2f,0x64a68a30,0x68e901d0,0x776288dc}},	//   jork, _маза, _ředi, lbox,
   {{0x27e90220,0xf2df001c,0x7bc60a31,0xc9530039}},	//   _plan_, _ngân_, _onku, ומת_,
   {{0x645a8a32,0x68318a33,0x77628a34,0x6724018e}},	//   _itti, rådg, nbox, _byij,
   {{0xf7738039,0x661c0a35,0x99d381f9,0x63b60428}},	//   וקר_, fork, ستیا, ddyn,
   {{0xdcfa8214,0x2d9e8267,0x661c0a36,0xf34e8133}},	//   _hatı, _jbte_, gork, _gụrụ_,
   {{0xdcfa87d9,0x224b0a37,0x224300f3,0xdb6b02dc}},	//   _katı, _suck_, _rijk_, ирал_,
   {{0x69d88a38,0x27e90a39,0x3eb00009,0xf34e8133}},	//   _hove, _ulan_, ältä_, _zụrụ_,
   {{0x161a8a3a,0x672d0a3b,0x69d88a3c,0x2aab0a3d}},	// [450] धवार_, _uzaj, _kove, штво_,
   {{0x69d88a3e,0x645a8a3f,0x661c00dd,0x7bc60a40}},	//   _jove, _otti, cork, _enku,
   {{0x69d88039,0xef58819d,0xb4b50a41,0x90990a42}},	//   _move, _ịfụn, _эйнш, свет_,
   {{0x2bb68a43,0x6d488a44,0x224300f3,0x59c9001b}},	//   _अफगा, _agda, _wijk_, राहर,
   {{0x645a8a45,0xf1bc8076,0x68e3006a,0x9e6480e8}},	//   _atti, ्ञान, øndb, двід,
   {{0x76450101,0x7a3001ec,0xb5fb002a,0x764d02d0}},	//   _jihy, täte, lpáb, _muay,
   {{0x69c70a46,0x459c0158,0x5ed380ab,0xdcfa807e}},	//   _inje, יסגע, _দেখে, _batı,
   {{0xf7738a47,0x6e958009,0x7a300a48,0xf1c906ab}},	//   _زار_, _нибу, räte, रावन,
   {{0x81ae0a49,0x69d88613,0x645a8a4a,0xa3cc0935}},	//   কার_, _bove, _etti, लात_,
   {{0x69d88a4b,0x7e698135,0x99158a4c,0x2484819d}},	//   _cove, _iwep, зьмі, _ịmee_,
   {{0x69d88a4d,0x6d55009a,0x6c4980f7,0x661c0a4e}},	//   _dove, dcza, _الصف_, vork,
   {{0x764d0a4f,0x201d8035,0x3ebf8a50,0x69ce8a51}},	//   _buay, nowi_, _krut_, öber,
   {{0x63a98a52,0xdce881d0,0xa3b48074,0xf34e8135}},	//   meen, _oddě, _छोट_, _tụrụ_,
   {{0x63a98a53,0x7e698a54,0x225f859e,0x69d88a55}},	//   leen, _mwep, mpuk_, _gove,
   {{0xdcfa8457,0x8af00085,0xdce701a9,0xdb0f0144}},	//   _yatı, hbət, tajā, _oncó,
   {{0x24518a56,0x69c70a57,0x69d88a58,0x661c0088}},	//   _mám_, _anje, _zove, sork,
   {{0x661c0057,0x764d0a59,0x765b8a5a,0x7e698133}},	// [460] pork, _guay, _ntuy, _nwep,
   {{0x69d8862f,0x14bd885d,0x63a98a5b,0x42230073}},	//   _xove, ्माण, heen, едув,
   {{0x24518a5c,0x81ae00c8,0x63a98a5d,0x62960a5e}},	//   _nám_, কাল_, keen, styo,
   {{0x20020a5f,0x7bc6029b,0x26c00503,0x63a98a60}},	//   niki_, _unku, _krio_, jeen,
   {{0x1dc78a61,0x63a98a62,0xdb060106,0x64460a63}},	//   लांत, deen, _bakå, _iiki,
   {{0xdcfa82bb,0x68e18a64,0xf1d0801c,0xdb0f03a8}},	//   _satı, kyld, _mạch_, _encó,
   {{0x2451801c,0x645800e7,0x24778087,0x7e698870}},	//   _cám_, _évid, găm_, _ewep,
   {{0x63a98079,0x75eb0201,0x24518a65,0xa6d380ab}},	//   geen, _müza, _dám_, _দেওয়,
   {{0x644607ca,0x20020a66,0x36678a67,0x5a348a68}},	//   _miki, diki_, _нато_, мнит,
   {{0x68318370,0x64460a69,0x68e1813c,0x62840084}},	//   råde, _liki, fyld, irio,
   {{0x20020a6a,0x80df80c8,0x9b46803d,0x63a98a6b}},	//   fiki_, _ফেব্, _فناو, been,
   {{0x64460a6c,0x683f0110,0xf1d0801c,0x7bd985ee}},	//   _niki, _kūdi, _bạch_, _gowu,
   {{0x9f4d816d,0x7c228a6d,0x27e68a6e,0x69d88a6f}},	//   _umeå_, _ikor, ikon_, _tove,
   {{0x644603c3,0x4a7b812a,0x62840a70,0x5558002e}},	//   _aiki, _פרוב, drio, заря_,
   {{0x64460a71,0x2c5580eb,0x20020a72,0x6d550035}},	//   _biki, _kāda_, biki_, rcza,
   {{0x64460a73,0x683f0029,0x671e000f,0x69c702ce}},	//   _ciki, _līdz, _युवक_, _snje,
   {{0x4422013c,0xe802009a,0xf1d080ff,0x5edc8264}},	// [470] _dkk_, _लगता_, _gạch_, _মেসে,
   {{0xda0c8a74,0x2fc9022c,0x8af00085,0x20b08a75}},	//   िचित_, _hnag_, vbət, _जनाध,
   {{0x6284040e,0x64460a76,0xdb0b8065,0x7c228a77}},	//   ario, _fiki, _magá, _okor,
   {{0xdb0f05a4,0x64460a78,0x3ebf8a79,0x321e8a7a}},	//   _hací, _giki, _prut_, hoty_,
   {{0x44290a7b,0x2451826f,0x4ea781e2,0x9f4b0216}},	//   mla_, _sám_, яржа, licó_,
   {{0x44290a7c,0x20020a7d,0x7c228a7e,0x63a98079}},	//   lla_, ziki_, _akor, ween,
   {{0x58840a7f,0x44290a80,0x63a98a81,0xd5fb819d}},	//   _пыта, ola_, teen, _apụ,
   {{0x24518775,0x69dc8884,0x44290a82,0x7a300a83}},	//   _vám_, ören, nla_, mäta,
   {{0x44290695,0x3ebf845f,0x27ff8a84,0x63a98a85}},	//   ila_, _urut_, _imun_, reen,
   {{0x44290a86,0x13068364,0x81bc80eb,0x7c228a87}},	//   hla_, ьный_, blēm, _ekor,
   {{0x20020a88,0x66038a89,0xf1d0801c,0x2fc90a2a}},	//   tiki_, mink, _sạch_, _bnag_,
   {{0xad1a893f,0x3f8f859c,0x44290a8a,0x9f4b06a5}},	//   _ווער, nggu_, jla_, dicó_,
   {{0x44290a8b,0x7c298179,0x20020a8c,0x62898a8d}},	//   dla_, mler, riki_, queo,
   {{0x66038a8e,0x64460a8f,0x64a60a90,0x20020a91}},	//   nink, _siki, мага, siki_,
   {{0x27ed8a92,0x64460a93,0x80160a94,0xe6430a95}},	//   _olen_, _piki, _офиц, терп,
   {{0x7c2987d9,0xdb008a96,0x26c00a97,0x2d840214}},	//   nler, lemá, _trio_, şme_,
   {{0x41c901fe,0xec098104,0x66038a98,0xdb0f04c3}},	// [480] रांस, yến_, kink, _fací,
   {{0x64460a99,0xceb40086,0x66038a9a,0x27ed8669}},	//   _wiki, _isə_, jink, _alen_,
   {{0x44290a9b,0x64460a9c,0x7c298a9d,0x66038a9e}},	//   bla_, _tiki, kler, dink,
   {{0x62840a9f,0x44290aa0,0xe8d680be,0xbf9b0129}},	//   prio, cla_, ווער_, hiên,
   {{0x27e68aa1,0x7c298aa2,0x22478aa3,0x66038aa4}},	//   rkon_, dler, _oink_, fink,
   {{0x27e68aa5,0xa3cc009a,0x44200aa6,0x7bdd81ec}},	//   skon_, लाव_, loi_, ösun,
   {{0x7c298aa7,0xdcfe0214,0xbf9b03a7,0x27ed8aa8}},	//   fler, _kapı, diên, _flen_,
   {{0xfbdf0104,0x69dc0aa9,0x7c298aaa,0x44200aab}},	//   _liên_, _hore, gler, noi_,
   {{0xc9868aac,0x34ab0aad,0xdb0b8aae,0x6aa880d4}},	//   муни, _चन्द, _pagá, कबेर,
   {{0x44290aaf,0x645e0289,0x7c298ab0,0xfbdf001c}},	//   zla_, _otpi, aler, _niên_,
   {{0x69dc0ab1,0x442902bb,0x7c298620,0x2247879f}},	//   _more, yla_, bler, _dink_,
   {{0xe3638ab2,0xca488104,0x69dc0ab3,0x7c228ab4}},	//   _акци, _lời_, _lore, _ukor,
   {{0x8c438ab5,0x44290ab6,0xe81f800c,0x3f85017b}},	//   _реце, vla_, यकता_, ğlu_,
   {{0xbf9b03a7,0x69dc021e,0x9f4b0216,0x06e180ab}},	//   ciên, _nore, ticó_, _মেডি,
   {{0x62868ab7,0x44290ab8,0xdb0f05a4,0x76488ab9}},	//   škod, tla_, _vací, _midy,
   {{0x66038aba,0x44200abb,0x44290365,0xdb0d03a7}},	//   zink, goi_, ula_, ndaç,
   {{0x66038abc,0x63a28abd,0xdce7009a,0x5a350abe}},	// [490] yink, _mbon, dają, енат,
   {{0x69dc0abf,0x44290ac0,0x7c2987d9,0xddc40668}},	//   _core, sla_, zler, _zviž,
   {{0x66038ac1,0x69dc0ac2,0x44200ac3,0x27ed86c0}},	//   vink, _dore, boi_, _plen_,
   {{0x6d5a8ac4,0xdd0d009a,0x66038ac5,0x44290085}},	//   _afta, półp, wink, qla_,
   {{0x69dc0ac6,0x660381e2,0x63ad0ac7,0x36698ac8}},	//   _fore, tink, mean, чало_,
   {{0x63ad0ac9,0x69dc816d,0xed598aca,0x65750168}},	//   lean, örel, чок_, nazh,
   {{0xdcfe0179,0x7c298179,0xa3e38074,0x7bdd0acb}},	//   _yapı, tler, _नकद_, _kosu,
   {{0x66038acc,0x63ad0acd,0x7f85803f,0x7f4d0ace}},	//   sink, nean, _سلطن, _ngaq,
   {{0x69c403b7,0x7c298179,0x3d0605b3,0xdb008acf}},	//   राची, rler, _हेने_, temá,
   {{0x63ad0ad0,0x7c298ad1,0xdb1d016d,0xe1ff009a}},	//   hean, sler, _insä, _swój_,
   {{0x7c298214,0xbf9b0073,0x31710ad2,0xbc6880f7}},	//   pler, riên, _mezz_, _يمكن_,
   {{0x44200ad3,0x6e250ad4,0x60dc8106,0x34bd8ad5}},	//   xoi_, _akhb, ärma, ्मीद,
   {{0x7bcb8ad6,0x63ad0ad7,0x63bb8ad8,0x6d478019}},	//   _ingu, dean, mdun, _újab,
   {{0x63bb8ad9,0xf1d0801c,0x40958ada,0x65750168}},	//   ldun, _hạnh_, _зрит, gazh,
   {{0xdca30adb,0xfbdf0104,0x44200adc,0x32058add}},	//   лари, _viên_, toi_, mily_,
   {{0x63bb8ade,0xc4d28158,0x7bdd0087,0xca4880ff}},	//   ndun, נגן_, _cosu, _rời_,
   {{0x69dc003b,0x629b8a7f,0xfbdf0028,0x44200adf}},	// [4a0] _pore, ntuo, _tiên_, roi_,
   {{0xf1d08028,0x81e180ab,0x44200ae0,0x171b0039}},	//   _lạnh_, নোর_, soi_, _מופע,
   {{0x69dc0ae1,0x63ad0ae2,0x4420002e,0xdcfe08c5}},	//   _vore, bean, poi_, _tapı,
   {{0x63ad0ae3,0xca4880ff,0x76488122,0x629b8084}},	//   cean, _vời_, _sidy, ktuo,
   {{0x69dc0ae4,0x3f9a809a,0xdce70035,0xfbd3801b}},	//   _tore, ępu_, rają, थानम,
   {{0x7bcb8ae5,0xb90600c8,0x7e628ae6,0x629b8122}},	//   _angu, _বই_, rpop, dtuo,
   {{0x3f6a8ae7,0x987e801b,0x7bdd0ae8,0x7bcb808e}},	//   _ниво_, _péče_, _yosu, _bngu,
   {{0xa2c403b7,0xf1d0801c,0x76488ae9,0x63bb8420}},	//   रिप्, _cạnh_, _widy, gdun,
   {{0xa3e805e8,0x63b98aea,0x7c2084dc,0x3205816b}},	//   _भवन_, _dawn, romr, fily_,
   {{0x7bcb8aeb,0x7c208082,0xa2b18aec,0x2006811b}},	//   _engu, somr, _अनर्, lioi_,
   {{0x6815809a,0x2bb88aed,0xdb1d0106,0x63b98aee}},	//   ląda, _आसपा, _inså, _fawn,
   {{0xc02e8104,0x63a28aef,0x9cd78039,0x20d58196}},	//   _điều_, _ubon, _רואה_, džią_,
   {{0x91e68af0,0x44268af1,0x2d8507a3,0x09e68af2}},	//   _поде, _iko_, óleo_, _подн,
   {{0xa2c40af3,0x92f283bf,0x69ca8af4,0x7bdd0af5}},	//   रिन्, ığım, _unfe, _sosu,
   {{0x63ad0af6,0xe57180be,0xa25b0187,0xb4cb0af7}},	//   tean, יַן_, _crôn, लमे_,
   {{0x657500f1,0x6836002a,0xdb008366,0x44268af8}},	//   sazh, táde, remæ, _jko_,
   {{0x63ad0af9,0x62490a2f,0x75eb007e,0xa7fd02d0}},	// [4b0] rean, _džon, _yüzl, ksız,
   {{0x63ad0afa,0x99990084,0xafdb0366,0x22b202d6}},	//   sean, _rusų_, smød, _dņk_,
   {{0x63ad0afb,0x78ba01ac,0xa7758afc,0xddc982d0}},	//   pean, _štvr, влеч, _ateş,
   {{0x66070586,0x44268afd,0xe50001a2,0xdb1d0106}},	//   lijk, _nko_, ोपरि_, _anså,
   {{0x7c2d0afe,0x44390aff,0x23690087,0x212b80ff}},	//   mlar, _ihs_, mbaj_, ́ch_,
   {{0x44268b00,0x6da58b01,0xada58b02,0x7c2d0b03}},	//   _ako_, тика, такл, llar,
   {{0x1fa786b5,0x34bd8b04,0x270d009a,0x32058b05}},	//   _праг, ्मेद, सपुर_, vily_,
   {{0x7c2d0b06,0xdb008009,0x629b8b07,0xd6d880ab}},	//   nlar, kemä, ttuo, _দেওয,
   {{0x66070a0f,0x63bb8b08,0x44268b09,0x7c2d011b}},	//   kijk, rdun, _dko_, ilar,
   {{0x3d1a0063,0x7c2d080a,0x44268b0a,0x7d798077}},	//   _मुझे_, hlar, _eko_, _آمار_,
   {{0x7c2d0b0b,0x629b8b0c,0x23e780e8,0xc95204de}},	//   klar, stuo, _підв, ימי_,
   {{0x7bcb8b0d,0x6e238b0e,0x7c2d0457,0x2d81010c}},	//   _ungu, lonb, jlar, _adhe_,
   {{0x443f8b0f,0x7c2d0b10,0x442d8b11,0x26c4001b}},	//   mmu_, dlar, mle_, ímo_,
   {{0x644b8b12,0xb5fb016a,0x2fdf8118,0x3ea90b13}},	//   _higi, spán, _loug_, _dpat_,
   {{0x442d8b14,0x644b8b15,0x7c2d0b16,0x44390b17}},	//   ole_, _kigi, flar, _bhs_,
   {{0x2d810b18,0x442d8b19,0x7c2d0b1a,0x443f8b1b}},	//   _edhe_, nle_, glar, nmu_,
   {{0x442d8219,0x443f8b1c,0xdb0f00f7,0x6e238b1d}},	// [4c0] ile_, imu_, _pacá, konb,
   {{0x644b8b1e,0xf1aa0077,0x442d8b1f,0x443f8b20}},	//   _ligi, باره_, hle_, hmu_,
   {{0x7c2d0b21,0x443f8886,0x27e00b22,0x442d8b23}},	//   blar, kmu_, _koin_, kle_,
   {{0x443f8b24,0x27e00b25,0x4f0a8b26,0x442d8b27}},	//   jmu_, _join_, мнен_, jle_,
   {{0x442d8b28,0x443f8b29,0x6e238b2a,0x96968098}},	//   dle_, dmu_, fonb, треш,
   {{0x442d8b2b,0x442680b2,0x7c240b2c,0x443f8b2d}},	//   ele_, _sko_, loir, emu_,
   {{0x69ce0b2e,0x644b80b4,0x443902f7,0xeb9f00e8}},	//   _inbe, _bigi, _yhs_, _kjøp_,
   {{0x68e30b2f,0x27e00364,0xeb978b30,0x644b8b31}},	//   ände, _noin_, вић_, _cigi,
   {{0x644b8b32,0xea00801c,0x2d968b33,0x78ad8140}},	//   _digi, _nhảy_, _арес, _ćava,
   {{0x442d8b34,0x7c2d017b,0x644b8b35,0xdb0401df}},	//   ale_, zlar, _eigi, ndiñ,
   {{0x442d8b36,0x44268b37,0x7c2d0b38,0xf9930039}},	//   ble_, _tko_, ylar, ברת_,
   {{0x44268578,0x442d8b39,0x644b8b3a,0x660700f3}},	//   _uko_, cle_, _gigi, wijk,
   {{0xa3cc0b3b,0x7c24062f,0x69ce0b3c,0x4ab6800c}},	//   लाई_, doir, _onbe, _अनिव,
   {{0x44248b3d,0x82778158,0x644b8b3e,0x44390b3f}},	//   lom_, _יעדע_, _zigi, _shs_,
   {{0x7c2d084a,0x66070a0f,0x644b8314,0x2bc4097d}},	//   tlar, rijk, _yigi, _लोहा,
   {{0x69ce0b40,0xe7870b41,0xe41400e8,0xfbdf00ff}},	//   _anbe, _руко, адсь, _tiêm_,
   {{0x7c2d0b42,0x6b828010,0x3b540087,0x64408198}},	// [4d0] rlar, _mdog, ркур, immi,
   {{0x44248b43,0x2fcd8b44,0x7c2d0b45,0x442d8b46}},	//   hom_, _sneg_, slar, zle_,
   {{0x442d8b47,0x7c2d03bf,0x21a4035f,0x6836027f}},	//   yle_, plar, риєм, láda,
   {{0x7c2d0086,0x44248b48,0xb8db0b49,0x6b828b4a}},	//   qlar, jom_, _अन_, _ndog,
   {{0x442d83a6,0x6e238b4b,0x628b0b4c,0xdd0180d2}},	//   vle_, tonb, ágod, _čuđe,
   {{0x68388b4d,0x6b828b4e,0x68e88106,0x69d80019}},	//   víde, _adog, kydd, övet,
   {{0x442d8b4f,0x443f8b50,0x18b80009,0x644b8b51}},	//   tle_, tmu_, _игры_, _pigi,
   {{0x4424803a,0x442d8b52,0x5f458b53,0x62898b54}},	//   gom_, ule_, _منزل, treo,
   {{0x442d8b55,0x63bd0b56,0x644b8b57,0x11d980f7}},	//   rle_, _masn, _vigi, فوظة_,
   {{0x442d8b58,0x443f8b59,0x62898b5a,0xe0d98b5b}},	//   sle_, smu_, rreo, ево_,
   {{0x442d8b5c,0x77940077,0x27e00072,0x443f859e}},	//   ple_, لیغا, _poin_, pmu_,
   {{0x44248b5d,0xf649010f,0x69da8282,0x672d0b5e}},	//   com_, _זצ_, ajte, _byaj,
   {{0xa9a58b5f,0x7c2400e7,0x27e00198,0x7e7d0b60}},	//   _билд, voir, _voin_, gssp,
   {{0x68e88114,0x7bcf0b61,0x645c841c,0xdb040b62}},	//   bydd, _ancu, _éric, leiç,
   {{0x7c2402be,0x0c7901bb,0x7ae98b63,0xdb008b64}},	//   toir, ксты_, lyet, remå,
   {{0x63bd0b65,0x6d5c0b66,0x62490b67,0xf09281c6}},	//   _casn, scra, _džom, _הנה_,
   {{0x7ae98b68,0x43750b69,0xdb1989c4,0x7c240b6a}},	// [4e0] nyet, руст, _bawé, roir,
   {{0x7bcf0b6b,0x3c3a8168,0x764b0036,0x7c240b6c}},	//   _encu, mëve_, _égyp, soir,
   {{0x98a68b6d,0x2fd70077,0xdb040b6e,0x3c3a80f1}},	//   čiće_, _شوید_, rdiñ, lëve_,
   {{0x7880003e,0x27e08125,0x61e08b6f,0x63bd0b70}},	//   _návš, ðin_, _पक्ष, _gasn,
   {{0x4a750b71,0x44248b72,0x3c3a80f1,0x7e2a8b73}},	//   _выст, vom_, nëve_, ніка_,
   {{0x63a40b74,0x69ce02af,0xa3cc0b75,0x4424833e}},	//   lfin, _unbe, लाक_, wom_,
   {{0xa1160b76,0x98be83bf,0xdb040187,0xa3cf8a27}},	//   _صورت, yatı_, feiç, शां_,
   {{0xd90d0077,0x6440826c,0x20048b77,0x3c3a80f1}},	//   _تیم_, ummi, _ummi_, këve_,
   {{0x68e88355,0x81bc8029,0x3c3a8168,0x64408b78}},	//   wydd, klēt, jëve_, rmmi,
   {{0x49748b79,0x683881d0,0x3c3a8168,0x24588b7a}},	//   шлос, bídc, dëve_, _tém_,
   {{0x7e640b7b,0x44248b7c,0xea008028,0x48150b7d}},	//   _atip, pom_, _chạy_, имос,
   {{0x44248b7e,0x68e88b7f,0x59d2801b,0x63a400fe}},	//   qom_, rydd, ताहर, jfin,
   {{0x6b7b810f,0x63bd011f,0x5eb880ab,0x62490b80}},	//   _טראנ, _rasn, _আপডে, _džoj,
   {{0xdb070019,0x63bd00eb,0x7e7d0b81,0x6836016b}},	//   ámít, _sasn, rssp, ráda,
   {{0x63bd0b82,0x81da0264,0x683604e8,0x40350b83}},	//   _pasn, ়সা_, mádn, _кекс,
   {{0x59d28b84,0xa3cc0b85,0x75eb0214,0x683603b0}},	//   तावर, लाग_, _müzi, ládn,
   {{0x2ba68b86,0x200b0b87,0x49750b88,0xdb0600e1}},	// [4f0] क्या, mici_, илас, _taký,
   {{0xdd9103f8,0xddc98b89,0x63a40b8a,0xd91b0198}},	//   _بود_, _svež, afin, нье_,
   {{0x7afb80e5,0xfaf98084,0x155a01c6,0x273b046d}},	//   zzut, lbūt_, _בכתב, _fàní_,
   {{0x200b02a5,0xa29505e9,0x69d80b8b,0x26c90503}},	//   nici_, _камі, över, _krao_,
   {{0x442b026c,0xf8c9826b,0x7c3a0036,0xb5fd8084}},	//   _ikc_, _asẹ́_, ître, _atša,
   {{0x7bc78029,0x644f05a4,0x48770b8c,0x7ae98b8d}},	//   ējum, _hici, _مدرس, vyet,
   {{0x200b0b8e,0xdb1d006a,0x644f0b8f,0x2c5581a9}},	//   kici_, _ansø, _kici, _kādi_,
   {{0x7afb8b90,0x26c9025b,0x73e58ada,0x99908503}},	//   tzut, _orao_, роиз, _čaši_,
   {{0x200b0b91,0x645702f7,0x22158b92,0x5fab80d4}},	//   dici_, _luxi, ифор, _टॉयल,
   {{0x644f0b93,0xe1258615,0x7ae98b94,0x9f5900e5}},	//   _lici, импи, ryet, misù_,
   {{0x7ae98b95,0x200b0b96,0x387e8077,0x63a40b97}},	//   syet, fici_, gstr_, yfin,
   {{0x644f0b98,0x3c3a80f1,0x76438b99,0x200b0b9a}},	//   _nici, tëve_, lmny, gici_,
   {{0xaa678b9b,0x32638019,0xdb0603ec,0x32678237}},	//   _стек, _انتہ, _lakò, _стев,
   {{0x3c3a820f,0xd9458b9c,0x644f0029,0x442b01e0}},	//   rëve_, _кели, _aici, _akc_,
   {{0x442b0267,0x443d8069,0x7643808e,0x61e38b9d}},	//   _bkc_, _khw_, imny, _ionl,
   {{0x3ead803a,0x200b0b9e,0x4aa98b9f,0x61e38019}},	//   _opet_, cici_, _कहाव, _honl,
   {{0x63a40ba0,0x26c904c3,0x02060ba1,0x395600a9}},	// [500] rfin, _grao_, азан, ањет,
   {{0x69c18ba2,0x61e3810c,0x64570ba3,0x667b00be}},	//   ndle, _jonl, _fuxi, _שטיק,
   {{0x61e38ba4,0x03a60ba5,0x657c0ba6,0x60268ba7}},	//   _monl, _кино, marh, аджа,
   {{0xb8ce023c,0xe6668b02,0x443d831d,0xb8fe0054}},	//   _कह_, атко, _nhw_, _तप_,
   {{0x2fc007e2,0xddd6026f,0xfe468ba8,0xb8660061}},	//   _maig_, _zvyš, андо, _چارو,
   {{0x44320ba9,0x2d980baa,0x200b001b,0x2fc00bab}},	//   lly_, ngre_, zici_, _laig_,
   {{0x443d80dd,0xeb0e81a2,0xa2c40035,0x200b01cc}},	//   _bhw_, ाप्त_, रिव्, yici_,
   {{0x8aa68bac,0x25a9812b,0xe8d70039,0x317801ec}},	//   арод, đala_, _דולר_, _herz_,
   {{0x44320bad,0x78af011f,0x9f490315,0x61e380c3}},	//   ily_, čivš, _ilaç_, _bonl,
   {{0x2c0b89d7,0x44320bae,0x61e38baf,0xc05a81e2}},	//   _یعنی_, hly_, _conl, кім_,
   {{0x245c026f,0x61e38bb0,0x3a370039,0x65770168}},	//   _ním_, _donl, שרים_, _rexh,
   {{0x2fc001c0,0x2a7f8bb1,0xdb1d0176,0x683604e8}},	//   _caig_, bsub_, _fasè, sádn,
   {{0x200b0bb2,0x67010bb3,0x2fc00bb4,0x645701df}},	//   rici_, _लेखक_, _daig_, _suxi,
   {{0x644f0bb5,0xfaf98bb6,0x2b928065,0x442b0bb7}},	//   _sici, rbūt_, _ایکس, _skc_,
   {{0x6ab6890a,0x52b68bb8,0x644f0bb9,0xe7870bba}},	//   _अनुर, _अनुस, _pici, _купо,
   {{0x628d0bbb,0x3b55096b,0x26c9001c,0xd0f781c6}},	//   trao, скар, _trao_, _כמות_,
   {{0xa3a88bbc,0x657c0bbd,0xd2510bbe,0xa2c405ab}},	// [510] ख्य_, barh, سنا_, रिष्,
   {{0xf9930bbe,0x2ba6800c,0x6838801b,0x644f0114}},	//   تبر_, क्ता, vída, _wici,
   {{0x3ead8353,0x44320bbf,0x644f0bc0,0x2fc0022c}},	//   _spet_, bly_, _tici, _yaig_,
   {{0x442b0bc1,0xa2c40bc2,0x1ab686a7,0x628d0140}},	//   _ukc_, रिश्, _अनूठ, prao,
   {{0x44290bc3,0x683d02be,0x6fd8016f,0x7a3d80e7}},	//   moa_, céde, यातू, lète,
   {{0x44290bc4,0x7aed05ee,0x764389da,0xc5f400fc}},	//   loa_, myat, umny, _tuɓe_,
   {{0x22590bc5,0xfc3f0028,0xa3cc016f,0x764382f7}},	//   _husk_, _khí_, लाच_, rmny,
   {{0x44290bc6,0x5f948bc7,0x24898bc8,0x2a7f8bc9}},	//   noa_, _мист, čam_, tsub_,
   {{0x8d878bca,0xfc3f00f7,0x62808bcb,0x645c8019}},	//   _نشان, _mhí_, gsmo, _érin,
   {{0x44290bcc,0x20190bcd,0x20090bce,0x673b8bcf}},	//   hoa_, érin_, _amai_, _izuj,
   {{0x44290bd0,0x7aed008e,0x69c18bd1,0x62808a53}},	//   koa_, hyat, rdle, asmo,
   {{0xc5e9007c,0xfc3f00ff,0x44290bd2,0xfbdf0129}},	//   _אד_, _nhí_, joa_, _kiêu_,
   {{0x2fc0009f,0xdb098bd3,0x44290bd4,0xf3ff00ab}},	//   _vaig_, rdeó, doa_, ্কার_,
   {{0x61fa8bd5,0xfc3f0693,0x7aed0bd6,0x69dc8bd7}},	//   chtl, _ahí_, dyat, öret,
   {{0x40958307,0xfc3f0307,0x2fc0022c,0x44290bd8}},	//   _العر, _bhí_, _taig_, foa_,
   {{0x4429011e,0x3ce500f2,0xfc3f0028,0x7ff6026a}},	//   goa_, älva_, _chí_, _دستا,
   {{0x44320051,0x9ad381bc,0x68e305ec,0x77640609}},	// [520] rly_, _aịzi, ändn, _ifix,
   {{0xc3328051,0x245c000d,0x44320bd9,0x51560bda}},	//   לון_, _tím_, sly_, стау,
   {{0x44320bdb,0xef6582bb,0x2c5580eb,0x44290bdc}},	//   ply_, ğını_, _kādu_, boa_,
   {{0xef658059,0xea00801c,0x7c298123,0x22590bdd}},	//   şını_, _thầy_, joer, _fusk_,
   {{0x317802a6,0x673b8035,0x7aed018f,0x661a808e}},	//   _terz_, _czuj, cyat, _pjtk,
   {{0x99d60277,0x21f600f7,0x63b60bde,0x62960bdf}},	//   _اتحا, _اكسس, leyn, muyo,
   {{0xec098028,0x320c82d6,0x62960be0,0x44c780ff}},	//   yết_, vidy_, luyo, _cđ_,
   {{0x8fa38be1,0xc7a38be2,0x62808be3,0x62868be4}},	//   _насе, _ниск, tsmo, škom,
   {{0x6aa40be5,0x62960214,0x200900ee,0x6d43016b}},	//   ntif, nuyo, _rmai_, _únav,
   {{0x660e0be6,0x44290102,0x60ca82f7,0x200900b9}},	//   jibk, zoa_, _prfm, _smai_,
   {{0x7c298be7,0x201903a7,0xe1ff0118,0x44290122}},	//   boer, ério_, _otón_, yoa_,
   {{0x7aed0be8,0x6aa40590,0xf5378039,0x313704de}},	//   yyat, ktif, _פנאי_, מנים_,
   {{0x7336803d,0x657a80d7,0xf1c800d4,0x63b60be9}},	//   _ارائ, _keth, रयान, deyn,
   {{0x329b8bea,0xe1ff0118,0x77640118,0xe7cf8beb}},	//   _עבוד, _atón_, _efix, _सोनप,
   {{0x44290bec,0xf1a98077,0xfc3f0028,0x657a8bed}},	//   toa_, _خانه_, _phí_, _meth,
   {{0x645a8bee,0x657a8bef,0x317e81ec,0x200900b9}},	//   _muti, _leth, latz_, _umai_,
   {{0x44290bf0,0x645a8bf1,0x62960bf2,0x8af78085}},	// [530] roa_, _luti, guyo, _çəti,
   {{0x645a82be,0x44290bf3,0x7aed0bf4,0xa3a883eb}},	//   _outi, soa_, ryat, ख्त_,
   {{0xe8e00142,0x2bc40bf5,0xfbdf0129,0x3178809a}},	//   ười_, _लोका, _siêu_, órzy_,
   {{0x2d9e8bf6,0x317e8bf7,0x657a8286,0x473583a7}},	//   _acte_, hatz_, _aeth, онес,
   {{0x539a0051,0x657a8bf8,0x7c29838e,0x6aa40bf9}},	//   _דירו, _beth, voer, ctif,
   {{0x645a8bfa,0x25a9812b,0x63ab80b9,0xdc3c81a9}},	//   _buti, đalo_, _sbgn, kšēj,
   {{0x69d50bfb,0x645a802e,0x8ccc0b9f,0x7c29800b}},	//   _inze, _cuti, हियो, toer,
   {{0xfbdf0028,0x69c50bfc,0x7bc28036,0x657a8bfd}},	//   _tiêu_, ldhe, _caou, _eeth,
   {{0x7bc28bfe,0x6fdd016f,0x657a8bff,0x0ae68009}},	//   _daou, यानं, _feth, ждый_,
   {{0x69c50c00,0x200f8c01,0x88858758,0x657a8c02}},	//   ndhe, ligi_, олож, _geth,
   {{0xf9920bea,0x69c50046,0x645a8c03,0x7a300009}},	//   ורי_, idhe, _guti, mätt,
   {{0x7a300c04,0x200f8c05,0x777b80e7,0x26cd8c06}},	//   lätt, nigi_, _jeux, _kreo_,
   {{0xe9d98c07,0x3f890114,0x9f448168,0x69d50c08}},	//   _вкл_, _ddau_, _romë_, _onze,
   {{0x20190c09,0x317e83e4,0xdce8801b,0x63b60079}},	//   ansi_, catz_, _nedě, weyn,
   {{0x2c5580eb,0x7bc28c0a,0x69c50c0b,0x68e30192}},	//   _tādu_, _yaou, ddhe, ändl,
   {{0x69c38c0c,0x69d50352,0x7bc40358,0x62960c0d}},	//   _hane, _anze, udiu, tuyo,
   {{0xb4b683bb,0xe29a0c0e,0x69c38c0f,0x2c5580eb}},	// [540] _छन्_, раз_, _kane, _kāds_,
   {{0x69c38c10,0xea008104,0x69c50c11,0x62960c12}},	//   _jane, _thấy_, gdhe, ruyo,
   {{0x02b68aed,0xd91009a7,0x657a8c13,0x69c385d8}},	//   _अन्न, ریر_, _reth, _mane,
   {{0x69c3811e,0xd7dd016f,0x657a8c14,0x26cd8118}},	//   _lane, यायच, _seth, _breo_,
   {{0x26cd8c15,0x645a8c16,0x777b80e7,0x7bc28c17}},	//   _creo_, _suti, _deux, _raou,
   {{0x62860c18,0x7c36008b,0x63a98c19,0x7bc28c1a}},	//   _ivko, llyr, efen, _saou,
   {{0x63a98c1b,0x5fca0c1c,0xb5fb0c1d,0xf77f02d0}},	//   ffen, ियाल, mpát, yaç_,
   {{0x7a34809f,0x657a8c1e,0x69c38c1f,0x26cd802a}},	//   màti, _weth, _aane, _freo_,
   {{0x62840c20,0x69c38c21,0x2fc6849c,0x38698c22}},	//   nsio, _bane, mdog_, _čara_,
   {{0x094a8abe,0x645a8c23,0x914a8c24,0x3ebb84de}},	//   ични_, _tuti, ична_, _דצמב,
   {{0x69c38c25,0x645a8364,0x61e302af,0x4254803d}},	//   _dane, _uuti, önli, _کنتر,
   {{0x62840c26,0x2fc68c27,0x317e81ec,0x2ba68c28}},	//   ksio, ndog_, satz_, क्शा,
   {{0x3ea68c29,0x0aba8c2a,0x7a2f8aa2,0xead48791}},	//   ntot_, _خطاب_, tøtt, _холь,
   {{0x81f88c2b,0x62840c2c,0x2ba68c2d,0x200f8c2e}},	//   _دفتر_, dsio, क्रा, zigi_,
   {{0xd37b0c2f,0x64428c30,0x271c8028,0x09ac80ab}},	//   ича_, _khoi, ỉnh_, _কোথা,
   {{0x248d0c31,0x683f00eb,0x6b80804f,0xdb198144}},	//   čem_, _lūdz, namg, _hawá,
   {{0x2bbd8c32,0x34b78c33,0x27e90c34,0x4abc80d4}},	// [550] ्यता, _आन्द, _ioan_, ्टिव,
   {{0x69c3862f,0x78a50125,0x27e900ff,0xdb00841c}},	//   _xane, tthv, _hoan_, lemó,
   {{0x69c50c35,0x26cd82a5,0x7fd58084,0x7e698c36}},	//   rdhe, _sreo_, зілі, _step,
   {{0x764183ed,0x69c503ed,0x27e90c37,0xdb0b8176}},	//   _shly, sdhe, _joan_, _magò,
   {{0x2bc40076,0x200f8c38,0x7c2d0c39,0x7bda0039}},	//   _लोटा, rigi_, moar, _הקרו,
   {{0x7c2d0c3a,0x26cd8087,0xdd918c3b,0x1dcb0512}},	//   loar, _vreo_, روع_, ायित,
   {{0x7a300c3c,0x6442832f,0x69c38c3d,0x6ab90085}},	//   rätt, _bhoi, _rane, şafı,
   {{0x7a300c3c,0x69c3803d,0x57b48c3e,0x64428c3f}},	//   sätt, _sane, _обст, _choi,
   {{0xd5bb8c40,0x64428c41,0x63a98c42,0x3ebf8573}},	//   _все_, _dhoi, rfen, _usut_,
   {{0xdb0d0c43,0x63a98c44,0x7c2d0c45,0x1306862c}},	//   ndañ, sfen, hoar, яный_,
   {{0xf992093f,0x69c38074,0x6442861f,0x7c2d011e}},	//   ערט_, _vane, _fhoi, koar,
   {{0xb4d78c46,0x69c38c47,0xa3bb8c48,0x64428c49}},	//   ामी_, _wane, _خاطر_, _ghoi,
   {{0x7c2d0c4a,0x27e90c4b,0x64498c4c,0x24980c4d}},	//   doar, _doan_, mmei, wurm_,
   {{0x64498c4e,0x2c5580eb,0x57470a41,0x63af0163}},	//   lmei, _tāds_, язям_, _abcn,
   {{0x2eb88424,0x7981838a,0x33f60c4f,0x8cce8035}},	//   _इन्त, malw, пчас, थियो,
   {{0x62840665,0x644981e4,0x7c2d0c50,0x1e860c51}},	//   tsio, nmei, goar, _елим,
   {{0x2bad835a,0x9f448c52,0x62840110,0x26c00c53}},	// [560] झ्या, _tomé_, usio, _usio_,
   {{0x3f820500,0x79818c54,0x2bb8825e,0x200d8187}},	//   laku_, nalw, _आस्थ, _amei_,
   {{0x62840c55,0x23bd83dd,0xfbbd824c,0x201c83a7}},	//   ssio, ्याद, ्याम, évio_,
   {{0x3f820c56,0x61fe0c57,0x657e01e0,0x7a3001ec}},	//   naku_, shpl, _heph, täts,
   {{0x5fdd016f,0x78828019,0xb5fb0c58,0x442d8c59}},	//   यातल, _kívá, mpár, doe_,
   {{0x645e0c5a,0x7bc60c5b,0x64428c41,0xe5348c5c}},	//   _kupi, _haku, _shoi, мель,
   {{0x7bc60c5d,0x64428c5e,0x3ea68c5f,0xa2c40aed}},	//   _kaku, _phoi, stot_, रिक्,
   {{0x293700be,0x7bc60558,0x657e0c60,0xdb00802a}},	//   _זאלן_, _jaku, _leph, xemó,
   {{0x7bc60c61,0x3f820c62,0xdb0d008b,0x64a080c3}},	//   _maku, daku_, ndað, dšiš,
   {{0x7bc60590,0x657e0c63,0xeaaf880b,0x39588aa2}},	//   _laku, _neph, اعي_, ørs_,
   {{0x64428c64,0x3f820c65,0x6d5a8bb1,0x5f950c66}},	//   _thoi, faku_, _igta, минт,
   {{0x1ae68c67,0x3f820c68,0x04db8039,0x7c2d0102}},	//   _ноем, gaku_, _לקבל, xoar,
   {{0xa3c00c69,0x7c2d0087,0x79818c6a,0x63a28c6b}},	//   ंजन_, voar, balw, _icon,
   {{0x91e38c6c,0x09e38c6d,0x611484bd,0x7bc602d5}},	//   _поче, _почн, _одлу, _aaku,
   {{0x7c2d0c6e,0x7bc60c6f,0x69c8831d,0x69a18beb}},	//   toar, _baku, mdde, _खाती,
   {{0x645e0c70,0x7bc60c71,0x2c0d016f,0x69c88c72}},	//   _dupi, _caku, _सगळं_, ldde,
   {{0x4a550c73,0x7c2d0102,0x7bc60c74,0x32550c75}},	// [570] дкас, roar, _daku, двар,
   {{0x7c2d0c76,0x6838800d,0x69c88c77,0xa2bf8c78}},	//   soar, bídk, ndde, _वनस्,
   {{0x7bc60c79,0x2d830c7a,0x7c2d0c7b,0x61ea8144}},	//   _faku, maje_, poar, _mofl,
   {{0x2d9c04b8,0x27e987ca,0x2d830c7c,0x68360187}},	//   _över_, ðan_, laje_, tádi,
   {{0x6fa50c7d,0x63ad0c7e,0x69d880c9,0x62490c7f}},	//   _कानू, mfan, _onve, _džor,
   {{0x2d830c80,0x7bc60c81,0x63ad0c82,0x68360c83}},	//   naje_, _zaku, lfan, rádi,
   {{0x7bc60c84,0xb4d78054,0x645800e7,0x442d8c85}},	//   _yaku, ामे_, _évit, toe_,
   {{0xeb9980af,0x69d88c86,0x2bda8c87,0x63ad0c88}},	//   ции_, _anve, भाषा, nfan,
   {{0x442d8baf,0x69c70c89,0x64498c8a,0x79818c8b}},	//   roe_, _kaje, rmei, talw,
   {{0x63a28c8c,0x64498c8d,0x78a10106,0x442d852a}},	//   _econ, smei, _älvs, soe_,
   {{0x39458c8e,0x3f820c8f,0x02ba03e8,0x61ea8c06}},	//   ьног, taku_, _उन्न, _dofl,
   {{0x645e0c90,0xe73a0c91,0x657e0c92,0x69c70077}},	//   _rupi, жем_, _seph, _laje,
   {{0x7bd981bc,0x63bb8c93,0x63ad0c94,0x7c2d8c95}},	//   _inwu, meun, dfan, čard,
   {{0x2bbd87e6,0x69c70c96,0x2d830c97,0x3f820c98}},	//   ्यवा, _naje, gaje_, saku_,
   {{0x64a30c99,0x7bc60c9a,0xed570c9b,0x6286816b}},	//   кара, _paku, дор_, ákov,
   {{0x7bc98c9c,0xaac900d4,0x04430c9d,0x672401c0}},	//   ndeu, रिंक, весн, _txij,
   {{0x69c70c9e,0x6aa98c9f,0xc1ea0ca0,0x7bc60ca1}},	// [580] _baje, ntef, одаж_, _vaku,
   {{0x7c290025,0x7bc60ca2,0x69c70ca3,0x26d200b4}},	//   čera, _waku, _caje, _iryo_,
   {{0x106a0ca4,0xb4d7852a,0x7640001b,0x7bd98133}},	//   цией_, ामो_, ůmys, _onwu,
   {{0x63bb8ca5,0x680b066f,0x00000000,0x00000000}},	//   jeun, wędz, --, --,
   {{0xa3e1873c,0x69c88ca6,0x6d418748,0x6b840ca7}},	//   दान_, ydde, _azla, maig,
   {{0x6b840c5e,0x69c70ca8,0x7bd981bc,0x63a28ca9}},	//   laig, _gaje, _anwu, _scon,
   {{0xdb0b8125,0xd839012b,0x7e7b8caa,0x7bc98cab}},	//   _sagð, luče_, _ewup, fdeu,
   {{0x69c70025,0x6b840cac,0x2d830cad,0xd9430cae}},	//   _zaje, naig, zaje_, _реси,
   {{0x7e7b81bc,0x27e6810c,0x83fc8bcf,0x752d861c}},	//   _gwup, mjon_, _nuđe, ğaza,
   {{0x27e68caf,0x6b840cb0,0x765f0359,0x24f68cb1}},	//   ljon_, haig, _ruqy, _очер,
   {{0xdb1d026f,0x2d830cb2,0x69c88114,0x4422008e}},	//   _masá, vaje_, rdde, _ojk_,
   {{0x7e608cb3,0x68e30cb4,0xb8e6809a,0x63bb8118}},	//   _kump, ändi, _उन_, ceun,
   {{0x6b840cb5,0x19948cb6,0xd8390968,0x7c228cb7}},	//   daig, _заля, juče_, _ijor,
   {{0xc1c803bb,0x7c2d807d,0x69d88cb8,0x7e608cb9}},	//   रयोग, čare, _unve, _mump,
   {{0x2d830cba,0x7e608cbb,0x69c70cbc,0x63ad007b}},	//   raje_, _lump, _raje, tfan,
   {{0x2d830cbd,0xeac88028,0x25a98289,0x69c70cbe}},	//   saje_, _kỹ_, đali_, _saje,
   {{0x63ad0cbf,0x7e608cc0,0x79a70cc1,0x4caa80ab}},	// [590] rfan, _nump, дрее, কিটু,
   {{0xeac88028,0x2fc90cc2,0x7c228cc3,0x63ad0cc4}},	//   _mỹ_, _haag_, _ljor, sfan,
   {{0x6b840110,0x61e7816d,0x69c70cc5,0x63ad0cc6}},	//   baig, öjli, _vaje, pfan,
   {{0x69c703c3,0x66150cc7,0xd839026c,0x6b840cc8}},	//   _waje, lizk, buče_, caig,
   {{0x7e608cc9,0xb4d78cca,0xdb1d0ccb,0x644d0ccc}},	//   _cump, ाम्_, _ansö, mmai,
   {{0x7c228ccd,0x2fc903b2,0x7a2b02af,0xa5948081}},	//   _ajor, _laag_, hütz, връщ,
   {{0x271b0cce,0x63bb85f8,0x97a7846e,0xdce380eb}},	//   नपुर_, teun, _орал, manī,
   {{0x6aa981a3,0xee3f00e1,0x2d810ccf,0x75fd82d6}},	//   ttef, dtým_, _lehe_, _dèza,
   {{0xc6a48cd0,0x7bc98cd1,0x4ea48b02,0x7c228cd2}},	//   _архи, rdeu, _арха, _djor,
   {{0xddc4003b,0xb5fd8cd3,0xdb040cd4,0x63bb8cd5}},	//   _otiš, _buše, nfiá, seun,
   {{0x83fc803b,0x07a60112,0xf1b200be,0x6d418cd6}},	//   _suđe, нанн, נסט_, _uzla,
   {{0x7c228cd7,0x2fc90cd8,0xb5fd8cd9,0x60da0061}},	//   _gjor, _caag_, _duše, _átme,
   {{0x79850748,0x2fc90cda,0x2d810cdb,0xdce18084}},	//   kahw, _daag_, _behe_, _pelė,
   {{0x6a178065,0xd8390024,0x3ea2816d,0x27ff8114}},	//   _تبصر, vuče_, _åkte_, _llun_,
   {{0x62868cdc,0xb5fd811f,0x6b840cdd,0x7c29042b}},	//   škot, _guše, taig, čern,
   {{0x27ed8cde,0x83fc80d2,0x8b950cdf,0x7c3b820d}},	//   _noen_, _tuđe, круч, nlur,
   {{0xdb1d0ce0,0x64598ce1,0x22580084,0x49960162}},	// [5a0] _pasá, _miwi, _pirk_, ешет,
   {{0xe7ac01c4,0x6b84008c,0x644d0ce2,0x27ff8ce3}},	//   ट्रप, saig, amai, _alun_,
   {{0x644d0ce4,0x7d7b0039,0xdb1d0019,0x6d5e033e}},	//   bmai, _מניו, _vasá, _igpa,
   {{0x4ea68ce5,0x644d09c4,0xc6a68ce6,0x64598ce7}},	//   ерка, cmai, ерки, _niwi,
   {{0x44200ce8,0x27ed81d8,0x44320ce9,0x61f30aa2}},	//   mni_, _doen_, moy_, ådlø,
   {{0x27e68cde,0x443202b8,0xf2df00ff,0xf48700d7}},	//   sjon_, loy_, _ngây_, _تایی,
   {{0x44200cea,0x69dc0ceb,0xd9430cec,0x61430110}},	//   oni_, _inre, _бери, _бера,
   {{0x44200ced,0x2bba8013,0x44320cee,0x7e608cef}},	//   nni_, ساعة_, noy_, _tump,
   {{0x7ae404c3,0xe7e40cf0,0x64598cf1,0x61ee0cf2}},	//   nxit, गाना_, _diwi, _kobl,
   {{0xb5fd8503,0xfce68cf3,0x44320cf4,0x44200cf5}},	//   _puše, _позо, hoy_, hni_,
   {{0x44200cf6,0x7a2b02af,0x4432009c,0x61ee094d}},	//   kni_, tütz, koy_, _mobl,
   {{0x2d8101ec,0x6d5e02c4,0x44320cf7,0x7c3b8cf8}},	//   _sehe_, _agpa, joy_, clur,
   {{0xd6d80cf9,0x2d81026b,0x69dc0cfa,0x44320cfb}},	//   нтр_, _pehe_, _onre, doy_,
   {{0x44200cfc,0x2ee10cfd,0x6b82876d,0x84e4864a}},	//   eni_, _पपीत, _heog, _कपाट_,
   {{0x44200125,0xa4d80cfe,0x765a8cff,0x66150d00}},	//   fni_, ндру_, _mity, rizk,
   {{0x69dc0d01,0x44200d02,0x493b8039,0x44320d03}},	//   _anre, gni_, _מגוו, goy_,
   {{0x61ee0b7f,0x5a3500b3,0x23690d04,0x27ed8d05}},	// [5b0] _bobl, внат, rcaj_, _roen_,
   {{0x44200d06,0x27ed8d07,0x6b828d08,0x61ee0d09}},	//   ani_, _soen_, _leog, _cobl,
   {{0x44200d0a,0x44320d0b,0x61ee0d0c,0x69ca81bc}},	//   bni_, boy_, _dobl, _mafe,
   {{0x44200042,0x69dc0557,0x69ca8d0d,0x87e48d0e}},	//   cni_, _enre, _lafe, люче,
   {{0x539a0bea,0x6abc8996,0xf770845b,0xe5a58d0f}},	//   _קישו, ्टोर, صان_, вили,
   {{0x0c740077,0x44d101e2,0xdce88029,0x69ca8d10}},	//   _جدید, _ką_, _nedē, _nafe,
   {{0x6b828d11,0xdb04007b,0x27ed8a0f,0x44d10d12}},	//   _beog, leið, _toen_, _ją_,
   {{0xa1580d13,0xbbbd8d14,0x19580d15,0xc4478019}},	//   _часу_, ्येक, _часы_, ریشن_,
   {{0x24808025,0x7c3a00e7,0x7c3b8106,0x64598c53}},	//   ćima_, îtri, rlur, _viwi,
   {{0x44200d16,0x62898d17,0x64598077,0x33f183a8}},	//   zni_, rseo, _wiwi, _páxs_,
   {{0xd7dd053e,0x7bdd0d18,0x34948791,0x7c3b8d19}},	//   यांच, _onsu, _бахр, plur,
   {{0x5b1587eb,0x6b828d1a,0x2d8785d1,0xdb04008b}},	//   _имет, _geog, lane_, keið,
   {{0x6d450d1b,0x76488009,0x25de0d1c,0x2d878162}},	//   _azha, _yhdy, खाली_, oane_,
   {{0x44200d1d,0xa7fd0201,0x7bcb8d1e,0x69ca8135}},	//   wni_, qqın, _hagu, _gafe,
   {{0x6e3c0713,0x443200ab,0x59a68076,0x7bcb8d1f}},	//   rlrb, toy_, _खातर, _kagu,
   {{0x2d878c89,0x6b8284c3,0x44200d20,0x3e660d21}},	//   hane_, _xeog, uni_, _tôt_,
   {{0x61ee0d22,0x2d878d23,0x6b848074,0xdfd20065}},	// [5c0] _pobl, kane_, _õige, _ميں_,
   {{0x7bcb8d24,0xfe9b04de,0x6d5e0122,0x7ae68106}},	//   _lagu, _קיימ, _ugpa, äkti,
   {{0x2d878d25,0x7e640009,0x4432033e,0x83fc8d26}},	//   dane_, _huip, poy_, _luđa,
   {{0xdb0401fa,0x7bcb8d27,0x59e0000d,0x7e640d28}},	//   beið, _nagu, नाहर, _kuip,
   {{0xa2c1000f,0x779180d5,0x765a8d29,0xe7aa0321}},	//   रौद्, صیلا, _pity, _कानप,
   {{0x63a40d2a,0x2d878d2b,0x61ee00d2,0x68388187}},	//   lgin, gane_, _uobl, vídu,
   {{0x7bcb8d2c,0x6abc82ef,0x69ca8d2d,0xc0e30254}},	//   _bagu, ्ट्र, _rafe, _корк,
   {{0x63a40d2e,0x25ad0d2f,0x83fc8b80,0x69ca8d30}},	//   ngin, đeli_, _buđa, _safe,
   {{0x5a348d31,0xf4130bea,0x67ff00f1,0x7bcb8d32}},	//   лнит, יפה_, _bëjn, _dagu,
   {{0x2d878d33,0x683d0d34,0xbd8a80d7,0x320581c6}},	//   cane_, médi, _آنان_, ghly_,
   {{0x68388187,0xa99b00be,0xbb1b0162,0x61fa8d35}},	//   sídu, וביר, _neîn, rktl,
   {{0x3f848d36,0x7bcb8d37,0x63a401ed,0xc05801e2}},	//   _jemu_, _gagu, jgin, кія_,
   {{0x44d10d38,0x44268d39,0x69ca837a,0x8a0684fa}},	//   _są_, _ijo_, _tafe, _изде,
   {{0x7bc08006,0x27318028,0xb5fd842b,0xdb04008b}},	//   lemu, ỡng_, _kuša, veið,
   {{0x442688cf,0x6d5c81ac,0x20068d3a,0x7bcb8d3b}},	//   _kjo_, _úrad, khoi_, _yagu,
   {{0x2d878d3c,0x7bc08763,0x6aad0d3d,0x2ba689c8}},	//   zane_, nemu, ttaf, क्चा,
   {{0x20190d3e,0x2d878d3f,0x36d50d40,0xab840746}},	// [5d0] misi_, yane_, _сопр, руск,
   {{0x20190d41,0x44d10d42,0x26c9007d,0xdb04007b}},	//   lisi_, _tą_, _isao_, reið,
   {{0x44268d43,0x7bc08d44,0x21640d45,0x99640d46}},	//   _ojo_, kemu, ртуг, ртул,
   {{0x2d878d47,0xf8b3893f,0x20190d48,0x3f8485f5}},	//   wane_, ישע_, nisi_, _cemu_,
   {{0x4b7a0bea,0x539a0051,0x2d878d49,0x6aa084a8}},	//   _ראשו, _אירו, tane_, jumf,
   {{0xd1268d4a,0x44268d4b,0xa2b880bc,0x20190d4c}},	//   _هم_, _ajo_, ्बन्, hisi_,
   {{0x2d878d4d,0x20190d4e,0x645d0d4f,0x2baa06d4}},	//   rane_, kisi_, _kisi, ङ्का,
   {{0x7bc08d50,0x645d0d51,0x2bda816f,0x3f848d52}},	//   gemu, _jisi, भागा, _gemu_,
   {{0x20190d53,0x2d878d54,0x442682d6,0xe3b68d55}},	//   disi_, pane_, _djo_, убы_,
   {{0x44390d56,0xf99180f7,0x44268d57,0x6e350503}},	//   _lks_, حبة_, _ejo_, jozb,
   {{0x7bcb8d58,0x201906c0,0x63a40d59,0x7a3d823e}},	//   _tagu, fisi_, ygin, nèti,
   {{0x645d0d5a,0x2d858d5b,0xc50c83de,0xbb1b0162}},	//   _nisi, _hele_, _קלאָ, _reîn,
   {{0x443f8d5c,0xd24e803d,0xa3e70d5d,0x63a40850}},	//   mlu_, تنی_, पान_, vgin,
   {{0x443f8d5e,0x64a60d5f,0x2d858d60,0xdca60523}},	//   llu_, лага, _jele_, лаги,
   {{0x69c18d61,0x443f8d62,0x2d858d63,0x5e5680be}},	//   mele, olu_, _mele_, טישע_,
   {{0x69c18d64,0x2d858d65,0x66188503,0xeb9f0aa2}},	//   lele, _lele_, zivk, _smør_,
   {{0x645d0d66,0xe2970d67,0x443f8d68,0x9e5a0d69}},	// [5e0] _disi, лат_, ilu_, _проф_,
   {{0x69c18d6a,0x645d0d6b,0x44390d6c,0x3f848d6d}},	//   nele, _eisi, _eks_, _semu_,
   {{0x645d0d6e,0x443f8d6f,0x34aa0d70,0x27e00669}},	//   _fisi, klu_, _явно_, _knin_,
   {{0x69c18d71,0x2bab0d72,0x2d8a02ec,0x645d0d73}},	//   hele, _छाया, labe_, _gisi,
   {{0x69c18d74,0xa3d783b7,0x443f8d75,0x60060d76}},	//   kele, ायन_, dlu_, _góme,
   {{0x2d858c6e,0x69c18d77,0xb5fd812b,0x7c240087}},	//   _cele_, jele, _puša, lnir,
   {{0x3f848d78,0x69c18d79,0x7bc08d7a,0x2d858d7b}},	//   _temu_, dele, temu, _dele_,
   {{0x69ce0d7c,0x683d0d7d,0x2d8a0d7e,0x68e30a33}},	//   _habe, pédi, habe_, ånde,
   {{0x69ce0d7f,0x20048d80,0x6b8601a1,0x69c18d81}},	//   _kabe, _ilmi_, _mekg, fele,
   {{0x69c187b3,0x7bc08d82,0x27e00d83,0x69ce0102}},	//   gele, semu, _anin_, _jabe,
   {{0x69ce0d84,0x443f8d85,0x03148d86,0x7bc080dd}},	//   _mabe, blu_, _तेरह_, pemu,
   {{0x31570451,0x2d858052,0x44268d87,0x7c240024}},	//   טיין_, _zele_, _ujo_, jnir,
   {{0xa3e187e6,0xcaf68154,0x26c682f7,0x645d0d88}},	//   दार_, _حساب, nwoo_, _risi,
   {{0x20190d89,0x2d8a0d8a,0x645d0d8b,0x69ce0d8c}},	//   sisi_, gabe_, _sisi, _nabe,
   {{0x44390d8d,0xab5d84b7,0xe4e40d8e,0x02178039}},	//   _pks_, reże, бітн, _תחום_,
   {{0xfbdf0104,0x69a70006,0x33750d8f,0x6b8600b9}},	//   _thêm_, _चाही, ргар, _cekg,
   {{0x52150d90,0x65950d91,0x3f8b0d92,0x2d8a0d93}},	// [5f0] адат, _капу, macu_, babe_,
   {{0x69ce0510,0x9475026a,0x3b540d94,0x443f8d95}},	//   _cabe, _نگرا, скур, zlu_,
   {{0x69ce0d96,0x2d858205,0x443f8d97,0x44390d98}},	//   _dabe, _rele_, ylu_, _tks_,
   {{0x69c18d99,0x2d858d9a,0x8d74003d,0x3f8b0d9b}},	//   zele, _sele_, _پایا, nacu_,
   {{0x2d858d9c,0x66e58d9d,0xdee58d9e,0x69c18d9f}},	//   _pele_, рола, роли, yele,
   {{0x2bda8da0,0x69c18da1,0x69ce0da2,0x20048085}},	//   _मोबा, xele, _gabe, _elmi_,
   {{0x2d858da3,0x628282a3,0x7e718da4,0x7bcf0da5}},	//   _vele_, _awoo, _žepč, _kacu,
   {{0x69ce0da6,0xd6f70076,0x629b8da7,0x3f8b0da8}},	//   _zabe, ुनाथ_, truo, jacu_,
   {{0x69c18da9,0x2d858daa,0x443f8dab,0x4919016f}},	//   tele, _tele_, rlu_, _येतो_,
   {{0x7c878dac,0x443f81fa,0x2ba7835a,0xd24e80a0}},	//   _буде, slu_, _गावा, وني_,
   {{0x443f8dad,0xd9458d5f,0x61458dae,0x69c18daf}},	//   plu_, рени, рена, rele,
   {{0x20040db0,0xdcfe01a9,0x7bcf0db1,0x78a18db2}},	//   ómi_, _nepā, _nacu, rulv,
   {{0x91e58db3,0x248600e1,0x09e58db4,0xf38c83de}},	//   _воле, _ňom_, _волн, _טראָ,
   {{0x44d58db5,0x7a3002af,0xee370db6,0x216681a1}},	//   _kā_, sätz, иня_, _киши_,
   {{0x2d8a0db7,0x7bcf0db8,0x44d580eb,0x69ce0db9}},	//   rabe_, _bacu, _jā_, _rabe,
   {{0x3ced8d38,0x44d58dba,0x2d8a0dbb,0x31c58dbc}},	//   _अपने_, _mā_, sabe_, _वसुध,
   {{0xfaa60dbd,0x69ce0dbe,0xcb00009a,0x25db82f1}},	// [600] разо, _pabe, लैंड_, _गोभी_,
   {{0xb21b0bc5,0x69ce04b7,0xe1ff0dbf,0x2d960dc0}},	//   _svær, _qabe, _stór_, _трис,
   {{0x44d58dc1,0x61fe0dc2,0x44c78019,0x661c0dc3}},	//   _nā_, rkpl, _nő_, mirk,
   {{0x69ce0dc4,0x7bcf0dc5,0xb5fd811f,0x661c0dc6}},	//   _wabe, _gacu, _bušo, lirk,
   {{0xdfcf80f7,0x683d00e7,0x7bc40162,0x41a6864a}},	//   بين_, cédu, meiu, _खालस,
   {{0xa61380e8,0x2888004e,0x27350129,0xd0b3011c}},	//   оміч, _مصری_, ụng_, hşət,
   {{0x291e00f2,0x6da38dc7,0xb21b006a,0x7bcf018f}},	//   _äta_, ција, _tvær, _yacu,
   {{0x661c0057,0x3edf01bc,0x6d4884e8,0x07a38191}},	//   hirk, _stọọ_, _vzda, _масн,
   {{0x15f8085d,0xe5a68dc8,0x6da68dc9,0xb5fd826c}},	//   ुसार_, _визи, _виза, _kušl,
   {{0x44c78019,0x38600362,0x7cdc8162,0x99668dca}},	//   _fő_, _aiir_, _pără, штил,
   {{0x7e760dcb,0x6aa401ed,0xddc98dcc,0x88590087}},	//   _atyp, huif, _uteš, лиос_,
   {{0xa3d78054,0xb8868032,0xb5fc8372,0xeb978dcd}},	//   ायण_, _atíò, _diġe, _виц_,
   {{0xc7b38051,0x69a701b6,0x661c0359,0x3f8b0b80}},	//   חבר_, _चाली, firk, racu_,
   {{0x2723801c,0x661c0dce,0x7bcf0dcf,0x2bda8006}},	//   ằng_, girk, _sacu, _मोता,
   {{0x40948dd0,0xedf48996,0xe65400e8,0x7bcf0dd1}},	//   _البر, _अवैध_, івсь, _pacu,
   {{0x3ced0024,0x539800e8,0x41a68dd2,0x672d01c0}},	//   ćev_, ився_, _खाँस, _txaj,
   {{0x99670dd3,0x7bcf0dd4,0x79870101,0x24580009}},	// [610] ател, _vacu, _pejw, рать_,
   {{0x661c0dd5,0x3d178074,0x2aaf011c,0x7bcf0dd6}},	//   cirk, _भइले_, rüb_, _wacu,
   {{0x7bcf0dd7,0x35f8003d,0x92e700ab,0x61f80106}},	//   _tacu, _خريد_, বনে_, övla,
   {{0x44d58dc1,0x9ad3819d,0x7bc40162,0x4e9581a8}},	//   _rā_, _dịji, ceiu, مشتر,
   {{0xa3ea8dbc,0xd6d9809a,0x6b8d0dd8,0x645a0dd9}},	//   मान_, _była_, maag, ïtie,
   {{0xee38835f,0x44d58dc1,0x6b8d0dda,0x80af80ab}},	//   ані_, _pā_, laag, য়িত্,
   {{0x69c50ddb,0x93fb016f,0x70940ddc,0xcd9801c6}},	//   mehe, _एकाच_, _марф, בדות_,
   {{0x6b8d0ddd,0x69c50dde,0x53c98319,0x44d58dba}},	//   naag, lehe, угим_, _vā_,
   {{0xb5fb0118,0x60060333,0x7d06811c,0x65958162}},	//   bpáx, _nóma, _əksi, _газу,
   {{0x44d58341,0xa2058ddf,0x7ae984c3,0x26cd80e5}},	//   _tā_, спод, rxet, _iseo_,
   {{0x3f890de0,0x661c0de1,0x6b8d0de2,0x629d816b}},	//   _beau_, virk, kaag, ásob,
   {{0x69c50de3,0x661c0de4,0x76438de5,0x7e69804f}},	//   hehe, wirk, llny, _kuep,
   {{0x69c50de6,0x7e618009,0x661c0de7,0xaac60105}},	//   kehe, _kilp, tirk, _रैंक,
   {{0x63a98de8,0x998580f7,0x6006008b,0x3f9e0214}},	//   lgen, _الثو, _dóma, ştu_,
   {{0x61e38de9,0xeb9a0dea,0x63a98deb,0x61fc8dec}},	//   _innl, лив_, ogen, örle,
   {{0x63a98ded,0x644f0dee,0x78a504a8,0x6b8d0def}},	//   ngen, _chci, duhv, gaag,
   {{0x38b18df0,0x661c0df1,0x63b6031d,0x63a98df2}},	// [620] lár_, pirk, rfyn, igen,
   {{0xe3b203f8,0x69c50df3,0xb5fd826c,0x443d8192}},	//   _کرد_, gehe, _bušm, _lkw_,
   {{0xa3d78df4,0x395c016d,0x6d418df5,0x26cd8020}},	//   ाया_, ävs_, _nyla, _aseo_,
   {{0x6b8d0df6,0x20020009,0xddc281b9,0x7e618362}},	//   caag, nkki_, spoż, _ailp,
   {{0xadec0cce,0xa3e1823c,0x69c50df7,0x248d00eb}},	//   ञापन_, दाई_, behe, ņemt_,
   {{0x44d803bb,0x443d8133,0x64440df8,0x6d418df9}},	//   _kč_, _akw_, llii, _byla,
   {{0x38b18dfa,0x63a98dfb,0xdd99804a,0x7c29016b}},	//   jár_, fgen, рші_, červ,
   {{0x68158063,0x6d41831d,0x63a98dfc,0x83fc805c}},	//   ządz, _dyla, ggen, _tuđm,
   {{0x44d806c0,0xa3e0064a,0xaf068dfd,0x645c80e5}},	//   _lč_, _दफन_, _упал, _èrim,
   {{0x60060dfe,0xd9cf00ab,0xddcd01a1,0x98b88073}},	//   _róma, রাথম, _otaš, алот_,
   {{0x3f8900e7,0xeb9a8dff,0x2cbe82f7,0x26c0016a}},	//   _peau_, _бие_, _uptd_, _apio_,
   {{0xfaa681e2,0x3a3a0711,0x82a68705,0x394281a9}},	//   _гадо, hopp_, _гадж, āks_,
   {{0xab5d809a,0xa3e70e00,0x3ea68e01,0x3f890866}},	//   leżn, पास_, nuot_, _veau_,
   {{0x86270e02,0xddcd009a,0x6b8d0e03,0x9f44826b}},	//   сьме, _uważ, waag, _bomú_,
   {{0x61f50e04,0x6b8d0e05,0x9f448722,0x69c50e06}},	//   _rozl, taag, _comú_, vehe,
   {{0x321e8e07,0x69c5010c,0x27e482c4,0x93790162}},	//   lity_, wehe, _nnmn_, рбат_,
   {{0x7a3d8e08,0x69c502af,0x6b8d0e09,0xfaff0168}},	// [630] mètr, tehe, raag, _afër_,
   {{0x321e8e0a,0x44d80247,0xddab0e0b,0x32070e0c}},	//   nity_, _fč_, _стил_, óny_,
   {{0x094b03bd,0x201d8e0d,0x6b8d0e0e,0x69c50e0f}},	//   учаи_, tiwi_, paag, rehe,
   {{0x69c50352,0xb8f10e10,0x7e618e11,0xad1a0039}},	//   sehe, _वन_, _silp, _כותר,
   {{0x8d658e12,0x44290e13,0x38b18e14,0x7e698e15}},	//   овле, mna_, zár_, _quep,
   {{0x443b0e16,0xdc998e17,0x20090114,0x201d804f}},	//   loq_, атиш_, _llai_, siwi_,
   {{0xd7aa0e18,0xcc8684fa,0x63a98e19,0xb5fd80d2}},	//   _कालच, обще_, tgen, _hušk,
   {{0x5fd90e1a,0xdb0d0e1b,0x66838065,0x6b808122}},	//   _बोलल, leañ, _فیصل, gbmg,
   {{0xab2989e0,0x7e618e1c,0x23298e1d,0x3ebf8088}},	//   ропа_, _tilp, ропи_, _uput_,
   {{0xb5fd803b,0x44290e1e,0x63a9844e,0x38b18e1f}},	//   _mušk, hna_, sgen, tár_,
   {{0x29038298,0x44290e20,0x443d8573,0x3207816b}},	//   ája_, kna_, _tkw_, _vlny_,
   {{0xa3ea86d4,0x3ea08805,0xb4d58128,0x2ca78e21}},	//   माण_, šite_, िटी_, mund_,
   {{0x7c3b8e22,0x2ca78e23,0x20020009,0x38b18e24}},	//   mour, lund_, rkki_, sár_,
   {{0x27388028,0x321e8e25,0x44d80e26,0x386a81a8}},	//   ứng_, city_, _pč_, úirí_,
   {{0xed5a0dd3,0x44290e27,0x7c298e28,0xdbc7007b}},	//   ров_, fna_, oner, töðu,
   {{0x44290e29,0x683601ac,0xb5fd88ae,0xf1ac0cf0}},	//   gna_, hádz, _bušk, _चाहन,
   {{0xa3ea816f,0xdb118036,0x2ca784dc,0x6b8b8e2a}},	// [640] मात_, éfèr, hund_, _megg,
   {{0x44290e2b,0x6b8b8e2c,0xb5fd8390,0x44d80e2d}},	//   ana_, _legg, _dušk, _tč_,
   {{0x44290e2e,0xd6d98063,0x63af0364,0x7c3b86c0}},	//   bna_, _było_, ännö, kour,
   {{0x7c3b83d3,0x8c46002e,0x321e84e8,0x2d8e8e2f}},	//   jour, _феме, zity_, wafe_,
   {{0x44200e30,0xa3e7025e,0x7c3b8e31,0x628681d0}},	//   mii_, पार_, dour, škoz,
   {{0xd49a8abe,0x44200e32,0x2ba80e33,0xa6e3007b}},	//   ари_, lii_, गलवा, æðis,
   {{0x6b8b8e34,0x25a087d9,0x1db20740,0x798a8e35}},	//   _begg, ğil_, _जानत, _refw,
   {{0x44200e36,0x25a082d0,0x7c3b8e37,0x2d8e8e38}},	//   nii_, şil_, gour, safe_,
   {{0x24898a20,0x9c8780e1,0x6b8b81b4,0x6ab60035}},	//   ćama_, _počú, _degg, ntyf,
   {{0x44200e39,0x44290e3a,0xdb198247,0x2ca78e3b}},	//   hii_, zna_, _pawò, bund_,
   {{0x44290e3c,0xa3b58076,0x44200079,0x600605e4}},	//   yna_, _चॉक_, kii_, _cómo,
   {{0x44200e3d,0x44290e3e,0xf1ae852a,0x7c29826c}},	//   jii_, xna_, ज्जन, cner,
   {{0x44200962,0x44290e3f,0x77640698,0x6e3c0e40}},	//   dii_, vna_, държ, forb,
   {{0x6b8b8a0f,0x2d8c8e41,0x44290e42,0x60060118}},	//   _zegg, _jede_, wna_, _fómo,
   {{0xa3e7005e,0x69c88e43,0x48c500c8,0x44200e44}},	//   पाल_, mede, _এপ্র, fii_,
   {{0x44200e45,0x69c88e46,0x44290e47,0x7aed0e48}},	//   gii_, lede, una_, txat,
   {{0x4429088b,0x443b022b,0xd839011a,0xf96b0e49}},	// [650] rna_, roq_, juči_, арей_,
   {{0x7c2d80d2,0x69c88e4a,0xdb1182be,0x527b8158}},	//   čari, nede, éfér, ינמא,
   {{0x44200e4b,0x44290e4c,0x2d910e4d,0x683601ac}},	//   bii_, pna_, maze_, vádz,
   {{0x2d91012b,0x44200e4e,0x69c88e4f,0x98b38052}},	//   laze_, cii_, hede, žeći_,
   {{0x6b8b8e50,0x63ad0e51,0x2d8c8e52,0x3f8f8e53}},	//   _regg, mgan, _bede_, ragu_,
   {{0x69c88e54,0x63ad0e55,0x2ca78e56,0xe61880e8}},	//   jede, lgan, tund_, оді_,
   {{0xa3d784e5,0x7c3b8e57,0x69c88e58,0x2d8c8e59}},	//   ायल_, tour, dede, _dede_,
   {{0x63ad0e5a,0xb5fd8754,0x25db8e5b,0x2ca78e5c}},	//   ngan, _muši, _गोरी_, rund_,
   {{0x2ca78e5d,0x2d910e5e,0x2d8c8e5f,0x6b8b8357}},	//   sund_, kaze_, _fede_, _vegg,
   {{0x44200012,0xddc4003b,0x2d8c8e60,0x6b8b8e61}},	//   zii_, _stiž, _gede_, _wegg,
   {{0x6d450e62,0x442004be,0xb5fd8e63,0x9f448242}},	//   _nyha, yii_, _nuši, _anmè_,
   {{0x442002a3,0x69d50e64,0xdd8f8019,0x6e3c0192}},	//   xii_, _laze, _سوچ_, worb,
   {{0x63bb8710,0x44200e65,0x63ad0e66,0xdb1d016a}},	//   mfun, vii_, dgan, _masó,
   {{0x9c828db7,0x2d8c0e67,0x63bb80e3,0x44200079}},	//   ščen, úde_, lfun, wii_,
   {{0x44200e68,0xe1668077,0xa5070e69,0x63ad0e6a}},	//   tii_, _عضوی, пера_, fgan,
   {{0xc4d2893f,0xbc630e6b,0x6e3c0e6c,0x61e70e6d}},	//   עגן_, евск, sorb, _anjl,
   {{0x44200e6e,0x7e6d0e6f,0x2fc002b8,0xaabd81a2}},	// [660] rii_, _guap, _ibig_, ्बिक,
   {{0xa3e28e70,0x44200e71,0x2d910e72,0x25db8bb8}},	//   _फोन_, sii_, caze_, _गोली_,
   {{0x44200e73,0x38b50e23,0x2d8c8e74,0x7e7b8e75}},	//   pii_, går_, _rede_, _atup,
   {{0xdb1d0e76,0x83fc82a5,0xde6d001c,0x35b203db}},	//   _obsè, _tuđi, _hươn, _जाड़,
   {{0x69d50003,0xf8a88bb8,0x66fe0540,0x2d8c8e77}},	//   _faze, _कम्प, ॉनिक_, _pede_,
   {{0xd8390e78,0x69d50e79,0x6b840e7a,0x7c3b0da8}},	//   ruči_, _gaze, lbig, čure,
   {{0x2d8c8e7b,0xdb0f02be,0xe81d06a7,0x63bb8e7c}},	//   _vede_, _accè, _पगला_, ffun,
   {{0x8aa68adb,0xde6d001c,0x69c88e7d,0x32058366}},	//   прод, _lươn, wede, ekly_,
   {{0x62960e7e,0x69c88e7f,0x2d8c8e80,0xa3e18e81}},	//   nsyo, tede, _tede_, दाज_,
   {{0xdb0d03a7,0xde6d00ff,0x8afb0e82,0x6faa0305}},	//   sfaç, _nươn, צהיי, _काउं,
   {{0x6aa40e83,0x7e6d0ad4,0x63ad0e84,0xb4c80035}},	//   hrif, _suap, ygan, ोटो_,
   {{0x6aa40e85,0xe45a8e86,0x62960e87,0x4c16826a}},	//   krif, _уже_, ksyo, _عباس,
   {{0xf2068021,0x78a8806a,0x7e6d0299,0xeb9f0646}},	//   _няко, sudv, _quap, _fløj_,
   {{0xa2db0e88,0x7afd8e89,0x6aa4035f,0xde6d00ff}},	//   निस्, äste, drif, _cươn,
   {{0x63ad0e8a,0xde6d0028,0x69d50e8b,0x19bb8039}},	//   tgan, _dươn, _raze, _המוב,
   {{0x6aa4031d,0x6b84009c,0x9c7c812b,0x2d910e8c}},	//   frif, gbig, _grče, saze_,
   {{0x6aa40e8d,0x95cb0e8e,0x2ee00e8f,0xb03803c8}},	// [670] grif, _луна_, _grif_, _מנהג_,
   {{0x38b50bfa,0xde6d001c,0x20c80e90,0xb0c8052a}},	//   tår_, _gươn, रबंध, रबंग,
   {{0x7e7b8b24,0x6b840e91,0x29070e92,0x7e7c807a}},	//   _stup, bbig, ána_, _črpa,
   {{0x2c718e93,0x290704b7,0x6aa40e94,0x69d50e95}},	//   _rád_, ġna_, brif, _waze,
   {{0xdb1d0b2c,0x38b50bbd,0x7c2d0e96,0x603201a9}},	//   _obsé, sår_, mnar, nāma,
   {{0x6da58e97,0xde6d001c,0x2c71816b,0x38b50106}},	//   фика, _xươn, _pád_, pår_,
   {{0x2489805c,0x442f80dd,0x27e902d6,0xed568073}},	//   ćamo_, _pjg_, _onan_, мош_,
   {{0x7c2d0e98,0xdb0f0e99,0x1b1e80ab,0x67d4806d}},	//   nnar, _accé, _পড়ে_, _посу,
   {{0x63bb8e9a,0x7c2d0e9b,0x7bc98e9c,0xa7fd011c}},	//   rfun, inar, reeu, yqır,
   {{0x27e90e9d,0x3eab0e9e,0x6442811b,0xb5fd8e9f}},	//   _anan_, duct_, _ekoi, _aušv,
   {{0x63bb8ea0,0x07a601d9,0x7c2d007b,0x200d800b}},	//   pfun, манн, knar, _klei_,
   {{0x2ee0031d,0x81b580ab,0xe3b081a8,0xde6d00ff}},	//   _prif_, _চোখ_, _مره_, _sươn,
   {{0xa3ea88d4,0x7c2d0353,0x443f8ea1,0xe28e8ea2}},	//   मार_, dnar, mou_, _ша_,
   {{0x64498ea3,0x200d809f,0x7c2d0ea4,0x27e902d6}},	//   llei, _llei_, enar, _enan_,
   {{0x442d8021,0xe1f08ea5,0x3eb90613,0x9d430ea6}},	//   one_, _حسن_, atst_, верд,
   {{0x443f8ea7,0x7c2d0ea8,0x64498e5d,0x9c7c8ea9}},	//   nou_, gnar, nlei, _urče,
   {{0x442d8eaa,0xe1fa0eab,0xde6d0028,0x64498229}},	// [680] ine_, ога_, _tươn, ilei,
   {{0x6aa40eac,0x443f8ead,0x2b8c0028,0x6b8402a3}},	//   rrif, hou_, ếc_, sbig,
   {{0x443f8eae,0x442d8558,0x851c8105,0x64498eaf}},	//   kou_, kne_, _भेंट_, klei,
   {{0x442d8eb0,0xa2db05e8,0x798e00c9,0x443f8eb1}},	//   jne_, निश्, _webw, jou_,
   {{0x442d81d6,0x443f8eb2,0xee3a8eb3,0x20068168}},	//   dne_, dou_, онд_, rkoi_,
   {{0xa2db0eb4,0x6449844e,0x6e238129,0xb8140264}},	//   निर्, elei, ginb, াচিত_,
   {{0x443f8eb5,0xa3ea84c5,0x3e740106,0x1dc00eb6}},	//   fou_, माल_, _lät_, श्यत,
   {{0x442d8eb7,0x443f8e67,0x68e3013c,0x64498eb8}},	//   gne_, gou_, ænde, glei,
   {{0x61fc0eb9,0x3e740106,0x3f868eba,0x9ad301bc}},	//   _korl, _nät_, mbou_, tịim,
   {{0x442d8ebb,0x7c240ebc,0x4efb81c6,0x6449862c}},	//   ane_, hiir, _והמו, alei,
   {{0x443f8ebd,0x850684c0,0x442d8ebe,0x25eb8ebf}},	//   bou_, _توان, bne_, चारी_,
   {{0x443f8ec0,0x3f868ec1,0x62808ec2,0x60320ec3}},	//   cou_, nbou_, ppmo, tāma,
   {{0x64408ec4,0x61fc00c9,0x2bdf00d4,0x5bbc8ec5}},	//   momi, _oorl, _पोषा, ्जीव,
   {{0x64408ec6,0x61fc0ec7,0x8a038081,0x603201a9}},	//   lomi, _norl, _изче, rāma,
   {{0x92bb0a49,0x443f001c,0x7c240ec8,0x623381a1}},	//   _আছে_, _ưu_, fiir, _шешу,
   {{0x27e90ec9,0xfc300eca,0x69da8ecb,0x69d88cf7}},	//   _unan_, لحق_, ldte, _have,
   {{0xa3b685e8,0x69d88ecc,0x61fc0ecd,0x776d0118}},	// [690] _जान_, _kave, _borl, _igax,
   {{0x443f8ece,0x442d8ecf,0x69da8ed0,0x64408ed1}},	//   zou_, zne_, ndte, homi,
   {{0x442d8ed2,0x644081f6,0x69d88ed3,0x7c240ed4}},	//   yne_, komi, _mave, biir,
   {{0x44248025,0x27e98ed5,0x69d88257,0x443f8548}},	//   jim_, ñan_, _lave, xou_,
   {{0x442d8ed6,0x443f8ed7,0x9f4087ca,0x61fc0ed8}},	//   vne_, vou_, ðið_, _forl,
   {{0x7bc2804c,0x442d8063,0x61fc0ed9,0x7cd38085}},	//   _abou, wne_, _gorl, _hərə,
   {{0x443f8eda,0x442d8ed6,0x60060013,0x44248edb}},	//   tou_, tne_, _fómh, fim_,
   {{0x442d8012,0x200d8087,0x61ea8edc,0x61fc03bf}},	//   une_, _ulei_, _anfl, _zorl,
   {{0x442d8edd,0x64498357,0x63a68ede,0x69d88edf}},	//   rne_, rlei, ókna, _bave,
   {{0x443f83a8,0x442d8ee0,0xe1f18013,0x9c828ee1}},	//   sou_, sne_, اسة_, ščan,
   {{0xd8260ab5,0x602607eb,0x38690ee2,0x69d88ee3}},	//   едни, една, _biar_, _dave,
   {{0x64408ee4,0x7ae28ee5,0xa3b68ee6,0x61ea8ee7}},	//   comi, _frot, _जाय_, _enfl,
   {{0x7ae28ee8,0x7bcd0ee9,0x7c240eea,0x69d88eeb}},	//   _grot, deau, viir, _fave,
   {{0x69d88eec,0xa3d78eed,0xb5fd8582,0x2d9e0036}},	//   _gave, ायक_, _gušt, ûte_,
   {{0x7bd98eee,0x1b1d00ab,0xd00a0eef,0xa3b68ef0}},	//   _kawu, _ভুলে_, _неке_, _जाम_,
   {{0x69d88ef1,0xe73a0009,0x7bcd010c,0xb60201d0}},	//   _zave, _ней_, geau, _žádo,
   {{0x7c240ef2,0xf41280be,0x60060ef3,0x7cd38085}},	// [6a0] riir, אפן_, _nómi, _dərə,
   {{0x44248ef4,0xe9d70ef5,0x7c2402a3,0x7c3b0279}},	//   zim_, нку_, siir, čura,
   {{0xa3ea0381,0x7c240ef6,0x44248ef7,0x61fc01ec}},	//   _една_, piir, yim_, _vorl,
   {{0x44248ef8,0x61fc0051,0xfbae8670,0x7bd98ef9}},	//   xim_, _worl, _टाइम, _nawu,
   {{0xa3b685b3,0x600605e4,0x64408791,0x6d488efa}},	//   _जाब_, _cómi, vomi, _syda,
   {{0x44248efb,0xf2d3007c,0x7ae28168,0x7cd3811c}},	//   wim_, _געש_, _rrot, _zərə,
   {{0x8fa681e2,0x04668adb,0x7c2f00f7,0x9c7c8754}},	//   _паве, нтим, _áirí, _brča,
   {{0x6d488efc,0xb5fd8efd,0x961d0eed,0xccf304de}},	//   _vyda, _sušt, _नष्ट_, רכה_,
   {{0x44248efe,0xb5fd803a,0x64408eff,0x69d88f00}},	//   rim_, _pušt, romi, _pave,
   {{0x38690ad0,0x64408329,0x38b88f01,0x7afd8f02}},	//   _siar_, somi, tér_, ästa,
   {{0x0b8a825d,0x9f448f03,0x290a8019,0x64a38f04}},	//   _если_, _tomó_, ába_, _баха,
   {{0x7ae28f05,0x2c750f06,0x68e38858,0x929d8035}},	//   _trot, _råd_, _drnd, syła,
   {{0x7bcd0f07,0x7ae28f08,0x38b88f09,0x3869008e}},	//   veau, _urot, sér_, _viar_,
   {{0x61ea8176,0x8cd78f0a,0x44220f0b,0x64460c2e}},	//   _unfl, _मनमो, _amk_, _akki,
   {{0x248d003b,0x7bcd0f0c,0x7bd98f0d,0xf8a48f0e}},	//   ćemo_, teau, _yawu, _खटिय,
   {{0x59c600d4,0x60c7008e,0x210301d6,0x6b9601b4}},	//   _रॉबर, _rpjm, nčiť_, gayg,
   {{0x6b848006,0x2bc2816f,0xfbc28f0f,0x7bcd0f10}},	// [6b0] _õigu, व्या, व्यम, reau,
   {{0x7bcd0f11,0xa2a70f12,0x2bcf0035,0x210301d6}},	//   seau, _चिठ्, हजहा, hčiť_,
   {{0x7cd38086,0x5f958f13,0x7c228f14,0x6b9601b4}},	//   _tərə, виет, _omor, bayg,
   {{0xfbab0009,0x629d8061,0x9f49010c,0x200b01d0}},	//   _этой_, ások, _anaé_, nkci_,
   {{0x62830025,0x644d0f15,0x6aad00e5,0x79a70a2e}},	//   ćnos, mlai, quaf, _прве,
   {{0x62350f16,0x9c7c8024,0x2ab98247,0x62500074}},	//   _регу, _srča, vèb_, näol,
   {{0xda3401bb,0xdce1809a,0x644d0f17,0x7bd98f18}},	//   _серы, _oglą, olai, _pawu,
   {{0x644d0f19,0x8ca286b7,0x69c3808e,0x26c90390}},	//   nlai, _गिरो, _sbne, _opao_,
   {{0x7bdb8f1a,0x69c10f1b,0x68e38bcf,0x961d8ec3}},	//   rduu, र्थी, _srnd, _atņe,
   {{0xaca38870,0x644d0c5e,0x2fcf80e8,0x7c228f1c}},	//   _amụm, hlai, legg_, _emor,
   {{0x9c7c805c,0x76438f1d,0x644d0f1e,0x7bd98f1f}},	//   _trča, mony, klai, _tawu,
   {{0x9c7c8f20,0x645a0084,0x27ff8176,0x69c10f21}},	//   _krčn, įtik, _joun_, र्ती,
   {{0xa3b68f22,0x27ff8f23,0x9aa48f24,0xe9ce8f25}},	//   _जात_, _moun_, _ممنو, _кк_,
   {{0x44220f26,0xed5a0f27,0x7c228f28,0xc5d50a4c}},	//   _smk_, дог_, _zmor, лісь,
   {{0x799702c1,0x44220f29,0xdcfc00eb,0x27ed8f2a}},	//   daxw, _pmk_, varē, _onen_,
   {{0x644d0f2b,0x7ae9005c,0x69c18f2c,0x6b898f2d}},	//   glai, _šeta, lfle, nbeg,
   {{0xe2970f2e,0xee3a0f2f,0xab270320,0x76438f30}},	// [6c0] кат_, _они_, вота_, kony,
   {{0x644d0f31,0x69c18f32,0x6b89826c,0x175701c6}},	//   alai, nfle, hbeg, _בספר_,
   {{0x76438f33,0x644d0f34,0x27ff8176,0x62840f35}},	//   dony, blai, _boun_, spio,
   {{0x2d980f36,0x644d0f37,0x629b8084,0x6aa9804a}},	//   lare_, clai, ksuo, kref,
   {{0x76438f38,0x44320f39,0x37dc0264,0x2a6a011c}},	//   fony, mny_, ধাপর, _tibb_,
   {{0xa2a70f3a,0x4432096a,0x2d980f3b,0x76438f3c}},	//   _चित्, lny_, nare_, gony,
   {{0x61ee0106,0x44320f3d,0x69dc0f3e,0xb5fc81b9}},	//   _inbl, ony_, _iare, _jiġi,
   {{0x44320f3f,0x64598f40,0x2d980f41,0x69dc0f42}},	//   nny_, _chwi, hare_, _hare,
   {{0x69dc0f43,0x2d980f44,0x51868071,0x76438f45}},	//   _kare, kare_, куна, bony,
   {{0x69dc0f46,0x2d980f47,0x44320f48,0x2bae816f}},	//   _jare, jare_, hny_, _टाका,
   {{0x69dc0f49,0x25db8076,0x2d98088b,0x27ff8247}},	//   _mare, _गोटी_, dare_, _youn_,
   {{0x27ed07f4,0x44320f4a,0x2d930f4b,0x3ea986c2}},	//   ñen_, jny_, _sexe_, šate_,
   {{0x44320f4c,0x34cb0996,0x2d9800e5,0x63a28f4d}},	//   dny_, ाब्द, fare_, _idon,
   {{0x69dc0f4e,0xb8828f4f,0x2d980687,0x62828f50}},	//   _nare, üíst, gare_, _itoo,
   {{0x6d400b16,0x20d38c3b,0x65940f51,0xdd940f52}},	//   şman, _نتيج, расу, расы,
   {{0x76438f53,0x44320f54,0xec340f55,0x644d0f56}},	//   zony, gny_, ансь, ulai,
   {{0x2d980f57,0x644d0f58,0x81d580c8,0x76438f59}},	// [6d0] bare_, rlai, হার_, yony,
   {{0x2d980f5a,0x44320063,0xaca30135,0x69dc0f5b}},	//   care_, any_, _atụg, _care,
   {{0x69dc0f5c,0x26080063,0x24810748,0x9c7c807a}},	//   _dare, _सकती_, _uthm_, _srčn,
   {{0x63a28f5d,0x3f990f5e,0xa283003d,0xac1900e8}},	//   _ndon, nasu_, _نیرو, _чому_,
   {{0x44290f5f,0x501c0f60,0xf7708bbe,0x1dc000d4}},	//   mia_, וואו, زان_, श्वत,
   {{0x69dc0f61,0x63a28f62,0x6272809a,0x7bdd0f63}},	//   _gare, _adon, _młod, _hasu,
   {{0x7bdd0f64,0x6b898754,0x27ff826b,0x25a983bf}},	//   _kasu, tbeg, _toun_, ğal_,
   {{0x44290f65,0x2d980012,0x69dc0f66,0x6aa98f67}},	//   nia_, zare_, _zare, tref,
   {{0x7bdd0f68,0x69dc0f69,0x76438f6a,0x6113811c}},	//   _masu, _yare, pony, mələ,
   {{0x44290f6b,0x386d8f6c,0x6aa98f6d,0x61138201}},	//   hia_, _hier_, rref, lələ,
   {{0x44290f6e,0x2d980f6f,0x44320063,0x69c18f70}},	//   kia_, vare_, yny_, rfle,
   {{0x7bdd0f71,0x44290f72,0x98160154,0x6aa98f73}},	//   _nasu, jia_, ابدا, pref,
   {{0x66018f74,0x4432003e,0x7ae9005c,0xfaa58f75}},	//   _kolk, vny_, _šetn, _сало,
   {{0x4432009a,0x3e798247,0x61138085,0x98e580f7}},	//   wny_, _mèt_, hələ, _مكتو,
   {{0x2d980f3b,0x61138201,0x3f990f76,0x69dc0f77}},	//   rare_, kələ, basu_, _rare,
   {{0x44290f78,0x69dc0f79,0x2d980f7a,0x44e387d9}},	//   gia_, _sare, sare_, _mı_,
   {{0x79950f7b,0x2d980f7c,0x4432096a,0x3e7986c0}},	// [6e0] _bezw, pare_, rny_, _nèt_,
   {{0x7c298f7d,0x44290f7e,0x44320f7f,0x613a0f80}},	//   hier, aia_, sny_, нчер_,
   {{0x69dc0f81,0x386d8f82,0x61138085,0x7c298f83}},	//   _vare, _bier_, fələ, kier,
   {{0xe73a8364,0x765a80f1,0xb8dc03a4,0x3e798247}},	//   нее_, _shty, _आम_, _bèt_,
   {{0x69dc0f84,0xadf08f85,0x539b0039,0x386d8f86}},	//   _tare, चालन_, _איכו, _dier_,
   {{0x38bc0f87,0x61460f88,0x3f990f89,0x386d8f8a}},	//   pír_, _бега, zasu_, _eier_,
   {{0x7c298f8b,0x386d8f8c,0xa3bb0f8d,0x7bdd0f8e}},	//   fier, _fier_, _घाम_, _yasu,
   {{0x7c298f8f,0x3e798205,0x79950f90,0x61138201}},	//   gier, _fèt_, _zezw, cələ,
   {{0x66018f91,0x7ae40d7b,0x52148cc1,0xe7378037}},	//   _folk, nvit, идит, _бет_,
   {{0x44290f92,0xddcd0f93,0xa3b68006,0x66018f94}},	//   zia_, _staž, _जाव_, _golk,
   {{0x7c298f95,0x7c260f96,0x41c60670,0x59c60f97}},	//   bier, _omkr, र्यस, र्यर,
   {{0x7c298f98,0xaae68f99,0x386d0106,0x660180b9}},	//   cier, _مستو, öer_, _zolk,
   {{0x44268f9a,0x7bdd0f9b,0x6d4003bf,0x95cb0f9c}},	//   _imo_, _rasu, şmal, нува_,
   {{0x44290f9d,0x442681c5,0x7bdd0f9e,0x2731801c}},	//   wia_, _hmo_, _sasu, ạng_,
   {{0x44290f9f,0x7bdd0fa0,0x3f990fa1,0x317b810f}},	//   tia_, _pasu, pasu_, _ארומ,
   {{0xb4c50006,0x799a8fa2,0x44290fa3,0x6006008b}},	//   _एही_, latw, uia_, _dóms,
   {{0x59c603eb,0xafdb03ba,0x7bdf0fa4,0x7bdd0fa5}},	// [6f0] र्भर, sløs, rdqu, _vasu,
   {{0x44290fa6,0x7c298fa7,0x386d835f,0x7bdd0fa8}},	//   sia_, zier, _sier_, _wasu,
   {{0x4426877f,0x7bdd0006,0xc7958071,0x44290fa9}},	//   _omo_, _tasu, арлы, pia_,
   {{0xb4fa078d,0x20da807d,0x79950f90,0x2ee903ac}},	//   _ספרי, mšić_, _wezw, _kraf_,
   {{0x6b8d0faa,0x386d84eb,0x7c298fab,0x539a0039}},	//   mbag, _vier_, vier, _בירו,
   {{0x6b8d0fac,0x7c298063,0x61138201,0x69c7056f}},	//   lbag, wier, sələ, _ubje,
   {{0x6601844e,0x7c298fad,0x44390fae,0xb60584be}},	//   _volk, tier, _kjs_, _aláì,
   {{0x3e798205,0x66018faf,0x61138085,0x22458fb0}},	//   _tèt_, _wolk, qələ, wolk_,
   {{0x7c298fb1,0x2bc7016f,0xa3b68fb2,0x799a80b4}},	//   rier, ऱ्या, _जार_, fatw,
   {{0x7c298fb3,0x20da812b,0x5ec880ab,0xb4c50074}},	//   sier, kšić_, লিশে, _एहू_,
   {{0x63b60196,0x2bc2816f,0x3ea00fb4,0xdb09816a}},	//   ygyn, व्हा, _svit_, rfeñ,
   {{0x44268fb5,0xa4fa80be,0x6aad0fb6,0x2ee90428}},	//   _gmo_, _בלעט, kraf, _braf_,
   {{0x636b83bf,0x1f5601bb,0x799a8fb7,0x41c60fb8}},	//   _dönü, ртнё, batw, र्डस,
   {{0x91fc8341,0x81ab00c8,0x6aad0fb9,0x62898fba}},	//   rmāc, ক্ত_, draf, mpeo,
   {{0x3b960fbb,0xe946819f,0x2ee90fbc,0x4439041c}},	//   ијат, _پروی, _eraf_, _bjs_,
   {{0x3ea0812b,0xf8140077,0x6b8d0fbd,0xafdb0aa2}},	//   šiti_, _دستگ, gbag, slør,
   {{0xd4670fbe,0xb22601b5,0xada60fbf,0xa3d686b7}},	// [700] рите_, амал, _капл, ाजत_,
   {{0x7ae40fc0,0x27e00fc1,0x26060187,0xa3e601a2}},	//   rvit, _hain_, _vôos_, _योर_,
   {{0x27e00590,0x6b9b8fc2,0xdb0d016b,0x2fdf8fc3}},	//   _kain_, kaug, čkác, _baug_,
   {{0x7c260fc4,0x2fdf8069,0xbc7b0039,0xe3b20fc5}},	//   _umkr, _caug_, _שנכת, _برد_,
   {{0x2fdf81e2,0x27e00fc6,0xa3bb0075,0x2bdf0072}},	//   _daug_, _main_, _घात_, _पोटा,
   {{0x27e00fc7,0x7ae480f7,0x7aeb006a,0x44d802d6}},	//   _lain_, _áiti, ægte, _kō_,
   {{0xd49781e2,0x10a30fc8,0x18a30fc9,0x44268fca}},	//   ары_, _мирн, _марм, _pmo_,
   {{0xa6868fcb,0xeca78fcc,0x27e00fcd,0xa3c90fce}},	//   _влад, _गिरफ, _nain_, ल्प_,
   {{0x9c7c85f3,0xf1c60aed,0x41c60af3,0x7cca811c}},	//   _krčk, र्थन, र्थस, _qərb,
   {{0x1db2016f,0x2fdf81c5,0x38780168,0xdb0982d0}},	//   _जागत, _zaug_, _kurr_, zgeç,
   {{0x27e00fcf,0x44d802d6,0x2d9c80f1,0x20048fd0}},	//   _bain_, _nō_, mave_, _komi_,
   {{0xf1c6000d,0x2d9c8fd1,0x7c3b0c18,0x6286012b}},	//   र्तन, lave_, čurk, _otko,
   {{0x27e00fd2,0x799a8c53,0xeafa81f9,0x2c0b8fd3}},	//   _dain_, patw, _جرات_, _جعلی_,
   {{0x2d9c8fd4,0xa3b68fd5,0xa3c9001b,0x6aad00e5}},	//   nave_, _जाँ_, ल्न_, vraf,
   {{0x69ca81c0,0x44390fd6,0xf8da80c2,0x61fc8338}},	//   _ibfe, _pjs_, _बनिय, örlu,
   {{0x20048fd7,0x6aad0fd8,0x25ad0fd9,0xa3b68816}},	//   _nomi_, traf, şel_, जलि_,
   {{0x6b8d01f1,0x9c7c8fda,0x81e000c8,0x2fdf81e9}},	// [710] rbag, _brčk, থান_, _raug_,
   {{0xd9990f99,0x6aad0fdb,0x98da8770,0xf8da809a}},	//   انات_, rraf, _बनाए, _बनाय,
   {{0x20048915,0x2fdf8282,0x29070162,0x2d9c8fdc}},	//   _bomi_, _paug_, âna_, dave_,
   {{0x6aad002e,0x2ef58fdd,0x628981e0,0x2fdf8069}},	//   praf, йзер, ypeo, _qaug_,
   {{0x20048fde,0x7c2d0fdf,0x6d5a8fe0,0xadc40032}},	//   _domi_, miar, _azta, _atẹw,
   {{0x9c7c803b,0x929d809a,0x2d9c8fe1,0x41c600c2}},	//   _grčk, syłk, gave_, र्दस,
   {{0x2fdf81c5,0x20048fe2,0x6b9b8fe3,0x610a829a}},	//   _taug_, _fomi_, taug, nəld,
   {{0xf77f817b,0x2d828019,0xf5380039,0x3c3a81a9}},	//   _üç_, _őket_, ינוי_, tīva_,
   {{0xa3c90fe4,0x6d5a8102,0x6b9b8fe5,0x3f158fe6}},	//   ल्य_, _ezta, raug, _удас,
   {{0x6b9b81e2,0xe1f98fe7,0x7528009a,0x27e00fe8}},	//   saug, уго_, ździ, _sain_,
   {{0x7c2d0102,0xd24e803d,0x7c360fe9,0x799883ec}},	//   kiar, رچه_, ynyr, _devw,
   {{0xa3c90fea,0x60060feb,0x9f0601a8,0xa3e60035}},	//   ल्म_, _cómp, موجو, _यों_,
   {{0x27e00364,0x91e58381,0x7c2d0fec,0x201e01e2}},	//   _vain_, _голе, diar, ėti_,
   {{0x442d8fed,0xdce38182,0x26c20fee,0x44d80176}},	//   lie_, lanı, rtko_, _pō_,
   {{0x26c20063,0x27e00fef,0x94790ff0,0x60c10106}},	//   stko_, _tain_, исту_, _älmh,
   {{0x442d8ff1,0x2d9c8ff2,0x7c2d0ff3,0xdce383bf}},	//   nie_, zave_, giar, nanı,
   {{0x38a38459,0x63a68ff4,0x7c360084,0xb3440085}},	// [720] lır_, ókni, rnyr, _keçə,
   {{0x442d882e,0x81ab00c8,0x9c828353,0x20048ff5}},	//   hie_, ক্স_, ščin, _somi_,
   {{0x442d8ff6,0x999a893f,0x8c460ff7,0x38a38182}},	//   kie_, רבעט, _гене, nır_,
   {{0x442d8ff8,0x2d9a0ff9,0x68fc8106,0x6e2e0ffa}},	//   jie_, _hepe_, ärdi, libb,
   {{0x442d8ffb,0x2d9c8ffc,0x3ea20ffd,0x9c7c80cd}},	//   die_, tave_, nskt_, _trčk,
   {{0x6b828081,0x6e2e04b7,0x38a382d0,0x27e08ffe}},	//   _sfog, nibb, kır_, žin_,
   {{0x2d9c8fff,0xdcfc00eb,0x557700be,0x6ce68196}},	//   rave_, darī, זעצן_, сіле,
   {{0x442d9000,0x38a38b06,0x2d9c9001,0x6d5a801b}},	//   gie_, dır_, save_, _vzta,
   {{0xa3bb01b6,0x3866816d,0x34d40054,0x2d9c9002}},	//   _घास_, mmor_, दबुद, pave_,
   {{0x7c2d1003,0x442d9004,0x3860009f,0x38a382d0}},	//   ziar, aie_, _ahir_, fır_,
   {{0x442d9005,0x19589006,0x660509f8,0x2bca835f}},	//   bie_, раны_, _rohk, _було_,
   {{0x442d9007,0x28a99008,0x38601009,0x39570039}},	//   cie_, _किरि, _chir_, משים_,
   {{0x7c2d100a,0x291e900b,0x799e100c,0x6e2e0037}},	//   viar, szta_, kapw, fibb,
   {{0xdb0d03a7,0x6e2e038a,0xe84c01d0,0x38a38380}},	//   lgaç, gibb, ětší, bır_,
   {{0x7c2d100d,0x2d9a02f7,0xe65400e8,0x38600c41}},	//   tiar, _depe_, ївсь, _fhir_,
   {{0x388101e2,0x69c88a53,0x2d9a026b,0x38600362}},	//   _nėra_, lfde, _eepe_, _ghir_,
   {{0x7c2d011e,0xa3b68665,0x99990aac,0x24580009}},	// [730] riar, _जाई_, икат_, сать_,
   {{0x442d900e,0x6fb50416,0x7c2d100f,0xa3bb0e5b}},	//   zie_, _امکا, siar, _घाव_,
   {{0xdce39010,0xa25b0038,0x9f520242,0x3c590087}},	//   yanı, _spôs, _anyè_, _винэ_,
   {{0x9f558468,0x9c7c9011,0x28ba03b7,0x64498118}},	//   овеч, _grči, _उमरि, xoei,
   {{0x442d9012,0x38a38059,0xdce388c5,0x81ab00ab}},	//   vie_, zır_, vanı, ক্ষ_,
   {{0x442d9013,0x7aed805c,0xd9fd05e8,0x38a39014}},	//   wie_, _šato, _उचित_, yır_,
   {{0x442d9015,0xdce387c0,0xed599016,0x69d7002a}},	//   tie_, tanı, шок_, mexe,
   {{0x7cca8201,0x52a99017,0x3ea2039c,0xe0d200be}},	//   _qəra, авим_, yskt_, _קײן_,
   {{0x28e10076,0x2d83009a,0xdce38059,0x442b1018}},	//   फिकि, kcje_, ranı, _mmc_,
   {{0x442d9019,0x38a385c5,0x88c98009,0x38600079}},	//   sie_, tır_, алов_, _shir_,
   {{0x442d901a,0xdce38380,0x61e50014,0x999e81d0}},	//   pie_, panı, idhl, nitř_,
   {{0xa3b6901b,0xb901901c,0xa2b2835a,0x38a38059}},	//   _जाए_, _नई_, _आमच्, rır_,
   {{0xf77207bd,0x38a38214,0xe29981a1,0xb7da81c6}},	//   باد_, sır_, _тал_, בקרי,
   {{0x63bb901d,0x5fdc101e,0x7ae9901f,0x3ea21020}},	//   lgun, _बसवल, mvet, rskt_,
   {{0xc5f28039,0xfce31021,0xf3870133,0x7c3a1022}},	//   ודם_, моро, _ụtọa, étro,
   {{0x63bb9023,0x3ead1024,0x26df81a1,0x69de9025}},	//   ngun, šeta_, _osuo_, _óper,
   {{0x61e39026,0x9c7c817f,0xa2061027,0x81dc80ab}},	// [740] _kanl, _isče, опад, ডার_,
   {{0xe1f71028,0x63bb8458,0xe24601a8,0x915f1029}},	//   огу_, hgun, آخري, _sắp_,
   {{0x6026902a,0x9c7c8968,0x7ae9902b,0x7c2b821e}},	//   оджа, _trči, hvet, _omgr,
   {{0xb8f20d38,0x9c7c803e,0x61e3902c,0x2eed902d}},	//   _वह_, _urči, _lanl, _bref_,
   {{0x38668bbd,0xaad8805e,0x4e0e102e,0x6d418106}},	//   rmor_, _बैंक, _हवाई_, _axla,
   {{0x6ce589a3,0xb0a98540,0x7ae9816d,0x0caa8318}},	//   किंग_, _किंग, dvet, атии_,
   {{0x90c3102f,0xa3d686a7,0x7bc99030,0x69ce1031}},	//   _обре, ाजल_, ffeu, _ibbe,
   {{0x61e380c9,0x2fc001c5,0x63bb9032,0x8aa69033}},	//   _aanl, _ncig_, ggun, ород,
   {{0x8af78201,0xada68187,0x61e39034,0x7ae98061}},	//   _şərh, _маал, _banl, gvet,
   {{0x61e39035,0x32188063,0x7ae48267,0x799c0326}},	//   _canl, óry_, _šits, _jerw,
   {{0x61e39036,0x63bb8102,0x2ee01037,0x3207808e}},	//   _danl, bgun, _asif_, _dony_,
   {{0x68e3013c,0x27e69038,0x69ca1039,0x61ed8300}},	//   ændi, ndon_, स्ती, _ɗali,
   {{0x91e68a94,0xb90183bb,0x26c6903a,0x09e68293}},	//   _моде, _नै_, ntoo_, _модн,
   {{0xd3448077,0x63a0903b,0x32078118,0x61e38114}},	//   _ویژه_, lamn, _gony_, _ganl,
   {{0x81c200c8,0x70c90074,0x80c90035,0x27e68122}},	//   ্যা_, _रहेल, _रहें, kdon_,
   {{0x27e48687,0xe3ac80ab,0xb8670fd3,0x3cdd86ae}},	//   _namn_, ক্রব, _باتو, _कईसे_,
   {{0xd7630bca,0x799c103c,0xa3cc8aed,0x69d701df}},	// [750] _تنظی, _berw, श्य_, texe,
   {{0x3eb9103d,0xaaac103e,0x63a0903f,0x63bb9040}},	//   must_, _चिरक, hamn, zgun,
   {{0x21270142,0x69d71041,0x3eb90074,0x7ae98019}},	//   ành_, rexe, lust_, zvet,
   {{0x69d71042,0x69ce1043,0x60c50428,0x6b8400e5}},	//   sexe, _ebbe, rthm, ccig,
   {{0xd6db823a,0x799c1044,0x69d71045,0xfd4c80ff}},	//   рте_, _ferw, pexe, _triề,
   {{0xc27a0039,0x66088079,0x62728035,0x7ae982d0}},	//   _לרשי, _codk, _słon, vvet,
   {{0x1c0f09f2,0x32078176,0x91fc80eb,0x27e49046}},	//   _सवाल_, _rony_, rmāl, _famn_,
   {{0xd7c9803d,0x61e39047,0x3eb90074,0xa80601df}},	//   _دوره_, _sanl, kust_, _mañá,
   {{0x63bb9048,0x61e39049,0xeab181a8,0x7ae98162}},	//   rgun, _panl, رعة_, uvet,
   {{0x2ea806b7,0x6608904a,0x3eb9103d,0xa925904b}},	//   _कटौत, _godk, dust_, здол,
   {{0x7ae9904c,0x61e3904d,0xf1b200be,0xa3bb853d}},	//   svet, _vanl, עסט_, _ناشر_,
   {{0xb4e78540,0x63a0904e,0x22808247,0x5437853d}},	//   यटी_, camn, _fòk_, _برطر,
   {{0xa3e6104f,0x61e39050,0xe8039051,0xe7371052}},	//   _योग_, _tanl, _रचना_, зея_,
   {{0xa3c91053,0x321e9054,0x3e6086c0,0x59c29055}},	//   ल्स_, chty_, pòte_, _शायर,
   {{0xed5a1056,0x27e69057,0x1828003d,0xdbd9007b}},	//   сов_, ydon_, _وقتی_, tæðu,
   {{0x799c0d38,0x7c3b9058,0xaca3819d,0x6b9d1059}},	//   _serw, nnur, _anịm, _cesg,
   {{0x3cdd8063,0x799c105a,0xc86500f7,0xdbd9007b}},	// [760] _कैसे_, _perw, _تطوي, ræðu,
   {{0x6aa40057,0x6b84105b,0x09e3105c,0xe4760012}},	//   rsif, scig, ноун, _нумэ,
   {{0x799c105d,0x6b9d002a,0xa8060118,0x1b0400ab}},	//   _verw, _fesg, _gañá, _রেখে_,
   {{0x6281105e,0xdcf5009a,0x7985105f,0x799c1060}},	//   _člov, jczę, achw, _werw,
   {{0x44321061,0x799c1062,0x66088f66,0x27e69063}},	//   miy_, _terw, _podk, rdon_,
   {{0x26c68009,0xd49a8abe,0x98a61064,0x27e485ee}},	//   rtoo_, бри_, _ниге, _wamn_,
   {{0x39a68013,0x26c68079,0x628b8428,0xa3c9064a}},	//   hísí_, stoo_, _atgo, ल्व_,
   {{0xafe39065,0x44201066,0xb60380eb,0x320a008e}},	//   _посл, nhi_, īšan, _hoby_,
   {{0x27f7800d,0x44201067,0x2bce016f,0xa0678a4c}},	//   šení_, ihi_, ह्या, _хата_,
   {{0x59cf016f,0xe8e000ff,0x3eb90074,0x7de580f7}},	//   स्पर, _nhịp_, vust_, _يسلم,
   {{0x69bd8eed,0x44201068,0x69c10f1b,0x3eb900f3}},	//   _शारी, khi_, र्टी, wust_,
   {{0x44201069,0x3eb90006,0x29028289,0x443202ed}},	//   jhi_, tust_, ćka_, jiy_,
   {{0x4420106a,0x2d9e906b,0x6b9d106c,0x79850428}},	//   dhi_, _kete_, _resg, ychw,
   {{0x99ce00c8,0x2d9e906d,0x2b09801b,0x6b9d016a}},	//   রযুক, _jete_, िहरु_, _sesg,
   {{0x2d9e8205,0x61f8837a,0x3eb90074,0x248c8037}},	//   _mete_, _invl, sust_, _jtdm_,
   {{0x4420106e,0x69da906f,0x3eb91070,0x5c741071}},	//   ghi_, lete, pust_, елст,
   {{0x3eb91072,0x3a751073,0x78ba9074,0x320a1075}},	// [770] qust_, длар, lutv, _boby_,
   {{0x44200079,0xdce70214,0xa3cc8105,0xdcf50035}},	//   ahi_, sajı, श्त_, zczę,
   {{0x02d983bb,0x77610201,0x79851076,0x320a03c1}},	//   _भन्न, əlxa, rchw, _doby_,
   {{0x44201077,0x69da9078,0x798502af,0x98c582a5}},	//   chi_, hete, schw, žući_,
   {{0xa2a700cf,0x69da9079,0x7ae2907a,0x2d9e8102}},	//   _चिट्, kete, _nsot, _bete_,
   {{0x2d9e8052,0x69da907b,0x7bcd0bda,0x8afa01c6}},	//   _cete_, jete, lfau, _והשי,
   {{0x2d9e8eef,0xd0d40698,0x20f08904,0xe81e06a7}},	//   _dete_, _поръ, nđić_, _पतला_,
   {{0x3ea9025d,0xfcaa093f,0x61e70061,0xdb1b907c}},	//   _ovat_, קיפּ, _hajl, lgué,
   {{0x2d9e907d,0x61e70088,0x7aed107e,0x81e000ab}},	//   _fete_, _kajl, nvat, থার_,
   {{0xb33b07d9,0xdb1b907f,0x69da9080,0x44201081}},	//   _geçe, ngué, gete, zhi_,
   {{0x7aed02a5,0x7ae29082,0x61e71083,0x44201084}},	//   hvat, _esot, _majl, yhi_,
   {{0x44201085,0x7aed00d2,0x61e701c0,0xead2077f}},	//   xhi_, kvat, _lajl, fẹ́_,
   {{0x44321086,0x44201087,0x764e1088,0x7aed0bcf}},	//   viy_, vhi_, toby, jvat,
   {{0x61e71089,0x7a200019,0x59cf04c5,0xf1cf108a}},	//   _najl, _köte, स्मर, स्मन,
   {{0x4420108b,0x443202d6,0x442f8079,0x320a00e5}},	//   thi_, tiy_, _kmg_, _roby_,
   {{0x7a20016d,0x68fc908c,0xc1728039,0x4420010b}},	//   _möte, årde, _בחו_, uhi_,
   {{0xfaa3108d,0x4420108e,0x442f908f,0x2eff0192}},	// [780] като, rhi_, _mmg_, äuft_,
   {{0x44201090,0xe9d71091,0x601f0168,0x7cca829a}},	//   shi_, мку_, _vëme, _sərm,
   {{0xb4661092,0x2d9e9093,0x4420029b,0x25e71094}},	//   _окол, _rete_, phi_, _छोटी_,
   {{0x69da9095,0x9f401096,0x6d40017b,0xb33b0214}},	//   zete, _unió_, şmas, _seçe,
   {{0x61e71097,0xa3c8809a,0x63a41098,0xc7a384bd}},	//   _fajl, _लॉग_, main, тичк,
   {{0x3f9f9099,0x3f86907c,0x7a200106,0xd04c8085}},	//   _eeuu_, scou_, _böte, _əhəm,
   {{0x2d9e80f1,0x69da909a,0x28dd909b,0xf8d20075}},	//   _vete_, vete, _फैलि, _सहिय,
   {{0x2284109c,0x69da909d,0x2d9e909e,0x6b9600e8}},	//   _kök_, wete, _wete_, nbyg,
   {{0x2d9e909f,0x69c38580,0x427490a0,0xe45701c6}},	//   _tete_, _bcne, нгис, ויקט_,
   {{0x61e88713,0xf8d210a1,0x63a410a2,0xdb150036}},	//   uddl, _सहाय, hain, ébéc,
   {{0xd1308307,0x63a410a3,0x291890a4,0x69da90a5}},	//   امج_, kain, ára_, rete,
   {{0xe8df0028,0x7aed026f,0x63a410a6,0x7ae290a7}},	//   _cuộc_, yvat, jain, _tsot,
   {{0x63a410a8,0xd6d9809a,0x6b9610a9,0x78ba90aa}},	//   dain, _były_, dbyg, sutv,
   {{0xead210ab,0x7aed10ac,0x69da90ad,0x2ef20a53}},	//   rẹ́_, vvat, qete, _dryf_,
   {{0x61e70267,0x1bd50098,0xdb008511,0x2edb90a1}},	//   _rajl, новя, damé, _यन्त,
   {{0x63a40219,0x69ca8b6f,0x61e7025b,0x20f08088}},	//   gain, त्री, _sajl, rđić_,
   {{0xeabc80ab,0x61e70282,0x2bd08072,0x2ef210ae}},	// [790] _অনুম, _pajl, थ्या, _gryf_,
   {{0x6d4510af,0x27e910b0,0xdb0090b1,0x228410b2}},	//   _txha, _haan_, ramè, _dök_,
   {{0x63a410b3,0x7aed037b,0x588401bb,0xd13100f7}},	//   bain, svat, выча, دما_,
   {{0x201910b4,0x3cf48743,0x27e910b5,0x63a410b6}},	//   nksi_, ्मने_, _jaan_, cain,
   {{0x61e710b7,0x0f35804e,0x27e902a1,0x20190198}},	//   _tajl, رکرد, _maan_, iksi_,
   {{0x780c016f,0x27e910b8,0x68e3006a,0x64428198}},	//   _हक्क_, _laan_, ænds, _ajoi,
   {{0xf41f0106,0x25a110b9,0xafdb0163,0x00000000}},	//   _klä_, _mehl_, sløy, --,
   {{0x7cca8085,0x3eb28084,0x27e910ba,0x2d878174}},	//   _mərh, šyta_, _naan_, scne_,
   {{0x7c3a0073,0x9f9d007b,0x316300c3,0xf6b58019}},	//   étri, væði_, _hzjz_, _سماج,
   {{0x63a410bb,0xfdf38424,0x20190009,0x569490bc}},	//   zain, _आफिस_, eksi_, _рафт,
   {{0x6e350052,0x27e910bd,0x09e18264,0x200d8a53}},	//   dizb, _baan_, বালা, _koei_,
   {{0xcdc90051,0x80a0809a,0x59cf10be,0x2b408968}},	//   _לך_, _खबरे, स्तर, _žice_,
   {{0xef1710bf,0x63a410c0,0x27e910c1,0xcc3a80be}},	//   емя_, vain, _daan_, _צענט,
   {{0x63a410c2,0xfce60a13,0x645b90c3,0xc69283de}},	//   wain, ного, llui, ראם_,
   {{0x443f90c4,0x228404b8,0xa3cc90c5,0xa50a0d5f}},	//   onu_, _sök_, श्व_, чева_,
   {{0x443f90c6,0x27e910c7,0x6b898057,0x7dd38457}},	//   nnu_, _gaan_, nceg, lısı,
   {{0x34dc90c8,0x6b9610c9,0x7ae9016b,0x41b610ca}},	// [7a0] _मन्द, rbyg, _šetr, есет,
   {{0x69c190cb,0x6b9610cc,0x80c900ab,0x8e9701c6}},	//   ngle, sbyg, রবন্, _רדיו_,
   {{0x2d9810cd,0x63a410ce,0xf1c290cf,0x69c80214}},	//   mbre_, pain, _शासन, _ödem,
   {{0xa2b210d0,0x443f883d,0x7afb0bcf,0xcfb20264}},	//   ेंद्, jnu_, _šute, ট্রন,
   {{0x443f90d1,0xc87981cc,0x7cca8085,0xe8df819d}},	//   dnu_, _diş_, _tərk, diọm_,
   {{0x443f90d2,0x69c190d3,0x6aa990d4,0xa3c8864a}},	//   enu_, jgle, dsef, _लॉज_,
   {{0x69c18503,0x443f90d5,0x32430171,0x5fc6016f}},	//   dgle, fnu_, _серг, _वाढल,
   {{0x59c2886a,0x66e690d6,0x6b7b00be,0x25fe816f}},	//   _शाहर, _поба, ּרינ, लाही_,
   {{0xdcea90d7,0xe7d583bf,0x3edf0133,0x27e902d5}},	//   rafı, lığı, _kwụọ_, _raan_,
   {{0x27e910d8,0x69c190d9,0x443f90da,0x9fd000ab}},	//   _saan_, ggle, anu_, িযোগ,
   {{0x7c2410db,0x443f883d,0x27e910dc,0x39588366}},	//   khir, bnu_, _paan_, ærs_,
   {{0x645b90dd,0x69de10de,0x351b8039,0x2d980144}},	//   clui, hepe, _מובנ, ebre_,
   {{0x27e90364,0x69de10df,0x7cca8085,0x81ab0264}},	//   _vaan_, kepe, _sərh, ক্ট_,
   {{0xa3cc83b7,0x27e902a3,0x4992804e,0x63a290e0}},	//   श्र_, _waan_, _حیدر, _heon,
   {{0x644102be,0x63a290e1,0x69de10e2,0x6282810c}},	//   élio, _keon, depe, _huoo,
   {{0xe7d582bb,0x7c2410e3,0x63a290e4,0x61ea90e5}},	//   dığı, ghir, _jeon, _hafl,
   {{0xf1a48b85,0x63a2808e,0x7cca8085,0x61ea8ff4}},	// [7b0] _खजान, _meon, _dəri, _kafl,
   {{0x63a290e6,0xbbdd90e7,0x443f90e8,0x69de10e9}},	//   _leon, _मस्क, znu_, gepe,
   {{0x443f90ea,0x7c2410eb,0x47bc8264,0xb21b0163}},	//   ynu_, bhir, োজনী, _stæs,
   {{0x7c2410ec,0x61ea90ed,0x443f02f9,0x6e9590ee}},	//   chir, _lafl, _ñu_, виду,
   {{0x443f803a,0xdee590ef,0x44248013,0xb4e10054}},	//   vnu_, толи, dhm_, _धनु_,
   {{0x27e9803b,0xe6188163,0x69de10f0,0xed5987b6}},	//   žan_, нді_, cepe, мол_,
   {{0x443f812b,0x6d5a8035,0x7e7a810c,0x645b90f1}},	//   tnu_, _cyta, _ditp, tlui,
   {{0x2ef587eb,0x201f802e,0x7bdf041c,0x386901b9}},	//   _избр, _ului_, nequ, _nhar_,
   {{0x6b89807d,0x63a290f2,0x645b90f3,0x045680f7}},	//   rceg, _deon, rlui, خلية_,
   {{0x443f82a5,0x645b90f4,0x6aa990f5,0xd24e80a0}},	//   snu_, slui, rsef, يني_,
   {{0x69c190f6,0xd945828b,0xf1c6086a,0x25fe90f7}},	//   rgle, тени, र्टन, लारी_,
   {{0xe73a10f8,0x68fc8106,0x69c190f9,0xdb1b8333}},	//   дем_, årda, sgle, lguí,
   {{0x69c702fd,0x26160074,0x7dd3807e,0x69de10fa}},	//   _ocje, _नकदी_, pısı, yepe,
   {{0xdb1b8228,0xdd92003f,0x628003c9,0x61ea90fb}},	//   nguí, شور_, _émoi, _gafl,
   {{0xed570785,0xada310fc,0x7c2410fd,0x63a290fe}},	//   вор_, расл, thir, _yeon,
   {{0x1c4310ff,0x63a283a8,0x38691100,0x60d69101}},	//   ансм, _xeon, _ghar_, _יוצא_,
   {{0xb33b0073,0xeab10065,0x7c240c0b,0x248601d6}},	// [7c0] _peça, یعے_, rhir, _čomu_,
   {{0x7c241102,0xb21b1103,0xceb9000d,0x68f5026f}},	//   shir, _stær, áře_, _brzd,
   {{0x291c0ed7,0x69de1104,0xb33b00f1,0x7bdf1105}},	//   áva_, repe, _veça, bequ,
   {{0x6e219106,0x7bc6026c,0xf1c61107,0x7ae602c4}},	//   _allb, _ucku, र्जन, _tskt,
   {{0x44220459,0x63a2826c,0xdfcf80f7,0x3ead9108}},	//   _ilk_, _reon, تين_, _cvet_,
   {{0x6d5a8063,0x93f60201,0xaa461109,0x4a750009}},	//   _pyta, _şəhə, _регл, _быст,
   {{0x63a2910a,0xa3c9000c,0x3ead8214,0x98a3110b}},	//   _peon, ल्क_, _evet_, _висе,
   {{0x61ea831d,0x7bc4110c,0xa78580f7,0x6d5a910d}},	//   _safl, ngiu, _مشكو, _vyta,
   {{0x7c23002e,0x59cf000c,0xdee3910e,0x7ae40197}},	//   _înre, स्वर, _коти, nwit,
   {{0xaca401bc,0x610a8085,0x7e7a910f,0x63a28144}},	//   _ahọt, səlm, _uitp, _weon,
   {{0x859b82f6,0x9f4e026f,0x3ea01110,0x850688ca}},	//   _חשבו, čným_, _awit_, _جوان,
   {{0xc9530051,0x28c48540,0xaca40135,0x7ae41111}},	//   ימת_, लंबि, _chọt, kwit,
   {{0xd5c98074,0x05c98a74,0x7c229112,0x61ea9113}},	//   _रामज, _रामब, _ilor, _tafl,
   {{0xb8f480f7,0x6e940009,0x44221114,0x70d206a7}},	//   _مكتب, риру, _alk_, _सहूल,
   {{0x62728063,0x3869008c,0x7bdf1115,0x1dd206bf}},	//   _słow, _thar_, tequ, द्धत,
   {{0xd10f83b7,0x7bc40098,0xaca40135,0x41c6052a}},	//   ाहरण_, ggiu, _ghọt, र्घस,
   {{0x24580364,0xdb1d06c4,0x0cbf83b7,0x41cf8743}},	// [7d0] тать_, _absò, _एम्म, त्वस,
   {{0x7c229116,0x200b0503,0x4422038e,0xf7f48077}},	//   _llor, ljci_, _elk_, یسند,
   {{0x3ead9117,0x0cbd80c8,0x7c2290ab,0xe01e8105}},	//   _svet_, _আন্ত, _olor, पसंद_,
   {{0xa2c30540,0x76551118,0x787a801b,0x7ae41119}},	//   िंद्, lozy, _důvo, bwit,
   {{0xa3cc00d4,0x539a0039,0x3c3a80eb,0x03d61101}},	//   _शॉट_, _רישו, hīvs_, _גורם_,
   {{0x7c22911a,0x69c7111b,0x5187111c,0x6b8d111d}},	//   _alor, _ucje, _шума, lcag,
   {{0x6aad111e,0xb4b1009a,0x7c22911f,0x81cc0264}},	//   lsaf, _ऑटो_, _blor, _শোক_,
   {{0x20f30a20,0x30da00be,0x2fc901c0,0x69c51120}},	//   _ići_, _אַמע, _ncag_, lghe,
   {{0x2bd51121,0x32111122,0x2d8101bc,0x0a398190}},	//   ड्या, _kozy_, _oghe_, ечны_,
   {{0x2d810028,0x20f31123,0x7c229124,0xb33b0036}},	//   _nghe_, _kći_, _elor, _leço,
   {{0xe4cb9125,0x07a6035f,0x69c50083,0x1acf00ab}},	//   _زبان_, ланн, ighe, রিয়া,
   {{0x30da00be,0x27ed9126,0x7643808e,0xf3f081a8}},	//   ײַטע, _jaen_, lnny, _وأن_,
   {{0x25a59127,0x27ed9128,0x63a99129,0x9f8a8074}},	//   _kell_, _maen_, maen, _tööd_,
   {{0x27ed912a,0x2aba8039,0x7c22912b,0x63a9912c}},	//   _laen_, _נמצא, _zlor, laen,
   {{0x27ff9010,0x03e680c8,0xdcee080a,0x7643912d}},	//   _onun_, কারী_, tabı, inny,
   {{0x6b8d112e,0x61e1912f,0xf1cf9130,0x63a99131}},	//   gcag, lell, त्रन, naen,
   {{0xab661132,0xe1fa1133,0x764380dd,0x6826016a}},	// [7e0] увал, нга_, knny, _códe,
   {{0x55e61134,0x25a58698,0xdcee080a,0x787a801b}},	//   _сооб, _nell_, sabı, _půvo,
   {{0x7ae41135,0x61e18081,0x610a8085,0x20120041}},	//   swit, iell, vəlk, _koyi_,
   {{0x61e19136,0x6b8d1137,0xe29a1138,0x27ed9139}},	//   hell, ccag, _пам_, _caen_,
   {{0x61e1913a,0xdd92826a,0x6456113b,0x7e7e113c}},	//   kell, موش_, moyi, _kipp,
   {{0x69d3913d,0x7e7e04b7,0xc1e7019f,0x61e1913e}},	//   _बॉली, _jipp, _مکمل_, jell,
   {{0x61e1913f,0x25a59140,0x62861141,0x63a61142}},	//   dell, _dell_, _huko, _kekn,
   {{0x61ee1143,0x62861144,0xe4f70996,0x76438867}},	//   _habl, _kuko, ुमति_, anny,
   {{0x61ee1145,0x61e19146,0x7c2280f1,0xa3c9000c}},	//   _kabl, fell, _vlor, ल्ट_,
   {{0x628601d3,0x61e19147,0x61ee07df,0xddc89148}},	//   _muko, gell, _jabl, _hidž,
   {{0x5bc68bbe,0x61ee1149,0x64440009,0x63a9820d}},	//   _مقال, _mabl, knii, baen,
   {{0x6456114a,0x0eeb0009,0x61ee114b,0x26c2114c}},	//   joyi, ньги_, _labl, fuko_,
   {{0xcc57810f,0xb33b0036,0xddc88b80,0xe2968073}},	//   _גבאי_, _reço, _midž, _среќ,
   {{0x27ed114d,0x61e1914e,0x7e7e00e5,0xa2c3114f}},	//   žen_, cell, _cipp, िंस्,
   {{0xf9938039,0x69ca8144,0x62861150,0x63a61151}},	//   _פרק_, _icfe, _auko, _bekn,
   {{0x682607f4,0x62861152,0x60df8065,0x3756082e}},	//   _póde, _buko, őzmé, ọdụ_,
   {{0x5a350e17,0x92590003,0x765a8085,0x76439153}},	// [7f0] анат, ваат_, _okty, ynny,
   {{0x61ee1154,0x27ed81df,0x321e809a,0x6b8d1155}},	//   _cabl, _saen_, nkty_, scag,
   {{0xa3d51156,0xa3e58105,0x69c51157,0x6aad1158}},	//   _конч, _फसल_, rghe, ssaf,
   {{0x61e19159,0x765a915a,0x63a6115b,0x6272809a}},	//   zell, _akty, _gekn, _złot,
   {{0x69d8915c,0x61ee115d,0xddc881e2,0x62860578}},	//   _obve, _fabl, _didž, _guko,
   {{0x4429115e,0xf770915f,0x64599160,0x61e18bf9}},	//   lha_, سان_, _skwi, xell,
   {{0x62861161,0x6b9b8609,0x20f3005c,0x61e19162}},	//   _zuko, tbug, _ući_, vell,
   {{0x442907e1,0x62861163,0x25a58051,0x61e19164}},	//   nha_, _yuko, _well_, well,
   {{0x61e19165,0x62800036,0xcb1200be,0x25a58039}},	//   tell, _émot, ַלט_, _tell_,
   {{0x63a98573,0x60c1861c,0x6abb9166,0x26c21167}},	//   saen, tulm, rruf, vuko_,
   {{0x5d849168,0x645600a4,0xc5fa80be,0x44291169}},	//   _المل, yoyi, _שפעט, kha_,
   {{0x61e1916a,0x4375916b,0x26c200ad,0x60c1817b}},	//   sell, _култ, tuko_, rulm,
   {{0x4429116c,0x60c1916d,0x8c1a8039,0xe7d7916e}},	//   dha_, sulm, _שוני, ण्यप,
   {{0x7c29916f,0x51879170,0x26c21171,0xc9878389}},	//   lher, _суда, ruko_, _суди,
   {{0xed5a1172,0x64a60912,0xe8168076,0x26c21173}},	//   тов_, раба, _थकला_, suko_,
   {{0x44291174,0x1e86013a,0x20000974,0x6286005c}},	//   gha_, _клим, _unii_, _puko,

   {{0x7e7e1175,0x64561176,0x6272809a,0x6d5e009a}},	// [800] _tipp, royi, _głos, _wypa,
   {{0x6286003a,0xb33b0214,0x6d4100f7,0xc6930039}},	//   _vuko, _geçm, úlac, _ואז_,
   {{0x44291177,0x55bb0039,0x61ee007a,0x7c299178}},	//   bha_, _במיו, _vabl, kher,
   {{0x44291179,0x386d82be,0x6286117a,0xfa8880ff}},	//   cha_, _cher_, _tuko, _lừa_,
   {{0x4420117b,0x66f4917c,0x628600e4,0x386d917d}},	//   mki_, сплу, _uuko, _dher_,
   {{0x61ee0362,0x40960785,0x386d82af,0x9c7c8140}},	//   _uabl, _врат, _eher_, _isči,
   {{0xac26917e,0xdb008789,0x29070106,0xd943117f}},	//   ифик, damá, änat_, _дери,
   {{0x20e80059,0x7c299180,0x6aa28247,0x7c3b9181}},	//   _işi_, gher, _pwof, giur,
   {{0x787f00eb,0xf5ea9182,0x5a348081,0xdb0d008b}},	//   _būvn, _имал_, йнит, ngað,
   {{0x44201183,0x7a248362,0x387f8cdb,0x24780176}},	//   hki_, _bòta, _ziur_, _dōmi_,
   {{0x44201184,0x6e3c1185,0x7c298234,0xfa8880ff}},	//   kki_, dirb, bher, _dừa_,
   {{0x7c299186,0xb33b080a,0x44291187,0x44201188}},	//   cher, _seçm, xha_, jki_,
   {{0x22949189,0x4426918a,0x09e180c8,0x4420118b}},	//   _التس, _ilo_, বাজা, dki_,
   {{0x4420118c,0x4429022b,0x44268069,0xaadb83c8}},	//   eki_, wha_, _hlo_, _סחור,
   {{0x4429118d,0x4426918e,0xda05000f,0x6272809a}},	//   tha_, _klo_, रासत_, _włos,
   {{0xe97b8039,0xf21c8105,0x5bb80009,0x717b8039}},	//   _בנוש, _पकड़_, ился_, _בנוס,
   {{0x4429118f,0xb06602f1,0xf7731190,0x32d08129}},	// [810] rha_, svää, _باغ_, này_,
   {{0x44291191,0x44201192,0x44269193,0x69c8904a}},	//   sha_, aki_, _llo_, ngde,
   {{0xda781194,0x4f58026a,0x44201195,0x6f1d0176}},	//   рят_, _مجید_, bki_, lysc,
   {{0xa3ce023c,0xe8df0104,0xd1268117,0x44268091}},	//   _राय_, _quốc_, _ہم_, _nlo_,
   {{0x63ad1196,0xd9f8815c,0x161b016f,0x44390581}},	//   maan, ्ञात_, _नकार_, _ims_,
   {{0x63ad1197,0x6da28073,0x7c2981c6,0xe5a29198}},	//   laan, пиша, wher, пиши,
   {{0xa3ce1199,0x4426807a,0x7c29919a,0x2907119b}},	//   _राम_, _blo_, ther, ånad_,
   {{0x63ad119c,0x4369919d,0x4426919e,0x1be988ed}},	//   naan, лайн_, _clo_, удии_,
   {{0x7c3b919f,0x7c2991a0,0x44268247,0x44390558}},	//   riur, rher, _dlo_, _mms_,
   {{0x442691a1,0x442011a2,0x7c2991a3,0x63ad11a4}},	//   _elo_, zki_, sher, haan,
   {{0x63ad11a5,0x442691a6,0xfa888028,0x60c500dd}},	//   kaan, _flo_, _vừa_, nuhm,
   {{0x442691a7,0x5c7591a8,0xdb0091a9,0x7bd98314}},	//   _glo_, _улет, samá, _ubwu,
   {{0x44200805,0x63ad11aa,0xceb283de,0x28c9064a}},	//   vki_, daan, ּיל_, ांडि,
   {{0x44200063,0xe29c80be,0x7d1c03ed,0x519581a8}},	//   wki_, _ישׂר, tyrs, _الغذ,
   {{0x442011ab,0x823491ac,0x1d19035f,0x63ad11ad}},	//   tki_, _برنا, ають_, faan,
   {{0x63ad11ae,0x61b7816f,0x3eb28110,0x7bc991af}},	//   gaan, _आयुष, šyti_, ngeu,
   {{0x442011b0,0xe9da11b1,0x7ae991b2,0xd46711b3}},	// [820] rki_, лка_, nwet, сите_,
   {{0x645d11b4,0x7afd8198,0x27f201b4,0xdb0d01fa}},	//   _eksi, ästy, _hayn_, rgað,
   {{0xf77f03a7,0x63ad11b5,0x5a3a80be,0x442011b6}},	//   meça_, baan, נגעה, pki_,
   {{0x7ae991b7,0x63ad11b8,0xa967047f,0xf77f02df}},	//   kwet, caan, щиха_, leça_,
   {{0x2907016d,0x628f91b9,0x9ad38870,0x61e511ba}},	//   änar_, ícol, _dịkw, behl,
   {{0x442691bb,0x60c50359,0xd0420085,0x7cca8085}},	//   _slo_, buhm, rtlə, _bərp,
   {{0x645d0364,0x261991bc,0xd0420085,0xd4978110}},	//   _yksi, _बकरी_, stlə, бры_,
   {{0x290500ce,0x1e86845e,0x786a91bd,0x9c7c80c3}},	//   _šlag_, _глам, býva, _opče,
   {{0x59cf11be,0x09ac80ab,0x6a700106,0x69c811bf}},	//   स्कर, _খাবা, räff, _ödes,
   {{0x98a787d9,0xb33b0201,0x6d4003bf,0x23ad0084}},	//   _aynı_, _seçk, şmay, mųjų_,
   {{0x69dc11c0,0x63ad11c1,0x4426812b,0x69ce0176}},	//   _mbre, yaan, _tlo_, _mcbe,
   {{0x63ad02c1,0x442691c2,0x438680f7,0xbb8680f7}},	//   xaan, _ulo_, _الإق, _الإي,
   {{0x69dc11c3,0xf1a810a1,0x23ad0084,0x291886ae}},	//   _obre, गरान, nųjų_, ärab_,
   {{0x63ad11c4,0x7afd806a,0x44f880ff,0x41c70f3d}},	//   waan, æste, _kĩ_, _लाइस,
   {{0x43960a2c,0x786a83f2,0x2d910035,0xb425866f}},	//   _ọrụ_, zýva, rcze_, łżeń,
   {{0x682604c3,0x25bf11c5,0xa3cc91c6,0x53990198}},	//   _tóda, şul_, श्च_, рвая_,
   {{0x7b6711c7,0xb33b0086,0x63ad11c8,0xf77f0073}},	// [830] стве, _keçi, raan, beça_,
   {{0x63ad11c9,0x9c7c80fe,0x9ad3819d,0x69dc0362}},	//   saan, _isču, _sịkw, _cbre,
   {{0x63ad11ca,0x6826026f,0xf96b0196,0x44390198}},	//   paan, _módn, урай_, _tms_,
   {{0x69dc11cb,0x7c6711cc,0x63ad0079,0x160700d4}},	//   _ebre, _داخل, qaan, शावर_,
   {{0x7c2d11cd,0xa3ce0740,0x60c50a84,0x287c00be}},	//   mhar, _रात_, suhm, אנאמ,
   {{0xae038aed,0x7c2d11ce,0x69d80e88,0x313511cf}},	//   लाइन_, lhar, न्दी, _дегр,
   {{0xac0991d0,0x24098171,0xafdb006a,0x661702f9}},	//   инка_, инки_, rnøj, _moxk,
   {{0x7afd025b,0x7c2d11d1,0x601f020f,0xa4b80039}},	//   _krst, nhar, _fëmi, צלחה_,
   {{0xc7b98019,0x7bc980e7,0x20f78162,0x7afb05f3}},	//   _idő_, rgeu, _săi_, _šutj,
   {{0x394591d2,0x1ddb097d,0xaca311d3,0x7ae991d4}},	//   жног, म्मत, _atọg, rwet,
   {{0xa96991d5,0x7c2d11d6,0x216991d7,0x7bcf11d8}},	//   рина_, khar, рини_, _occu,
   {{0xe8df8028,0x3dc989ab,0xe8e0027d,0x20d191d9}},	//   hiệm_, ɗawa_, _chộp_, rái_,
   {{0x7c2d06df,0x442d8068,0x6d4111da,0xc7d681c6}},	//   dhar, mhe_, úlan, חורי_,
   {{0x443f91db,0xb33b07d9,0x442d8073,0x628b91dc}},	//   liu_, _geçi, lhe_, _iugo,
   {{0xf77f11dd,0x27e686ff,0x7afd11de,0x628391df}},	//   reça_, yeon_, _arst, _iino,
   {{0x443f91e0,0x7c2d11e1,0x644991e2,0x442d8073}},	//   niu_, ghar, nnei, nhe_,
   {{0xda0509a3,0x63ab8019,0x644991e3,0x987b03de}},	// [840] रांत_, _megn, inei, _דאקט,
   {{0x63ab91e4,0x442d8940,0x644991e5,0x628b820c}},	//   _legn, hhe_, hnei, _mugo,
   {{0x7afd11e6,0x7c2d11e7,0x442d91e8,0x443f8110}},	//   _erst, bhar, khe_, kiu_,
   {{0x81e70a49,0x307691e9,0x628391ea,0x68260019}},	//   ভাগ_, цузс, _lino, _módo,
   {{0x442d91eb,0x443f91ec,0x44f88028,0x087700be}},	//   dhe_, diu_, _sĩ_, קענט_,
   {{0x8c1f00c8,0xdcba8098,0x7c240074,0xa0a611ed}},	//   নোদন_, ащи_, lkir, _магд,
   {{0x25ba11ee,0x7a2001ec,0x291c02f1,0x443f91ef}},	//   _mdpl_, _nöti, ävad_, fiu_,
   {{0x09b48a49,0x442d91f0,0xb33b1010,0x443f91f1}},	//   জ্ঞা, ghe_, _seçi, giu_,
   {{0x63ab91f2,0x2d9691f3,0x628b80c3,0x63b90035}},	//   _degn, _дрес, _cugo, ówni,
   {{0x386691f4,0x628b803a,0x291e8110,0xfce691f5}},	//   llor_, _dugo, tyta_, _мозо,
   {{0xf9930051,0x443f91f6,0x69fb010f,0x7c240c56}},	//   ורת_, biu_, בליק, kkir,
   {{0x443f91f7,0x63ab91f8,0x291e91f9,0x628b91fa}},	//   ciu_, _gegn, ryta_, _fugo,
   {{0xe1ef91fb,0xc7b38051,0x38668087,0x628391fc}},	//   رسی_, ובר_, ilor_, _fino,
   {{0x765c11fd,0x7c2d11fe,0x628391ff,0x64409200}},	//   gory, whar, _gino, limi,
   {{0x7c2d1201,0x61e88bbd,0x7c2402a6,0xfe6e0180}},	//   thar, medl, fkir, دگي_,
   {{0x69da8a34,0x62839202,0xdb0080e1,0x38668b67}},	//   lfte, _zino, pamä, jlor_,
   {{0x7c2d1203,0xdceb03bf,0xf77f03a7,0x628b8118}},	// [850] rhar, ınız, meço_, _xugo,
   {{0x7c2d1204,0x61e8831d,0x64409205,0x443f9206}},	//   shar, nedl, himi, ziu_,
   {{0x64409207,0x7c2d1208,0xf8b1004e,0x442480b9}},	//   kimi, phar, عکس_, kkm_,
   {{0xdce50028,0x443f9209,0x6440920a,0x25ac802a}},	//   _nghĩ, xiu_, jimi, _aedl_,
   {{0x63ab920b,0x6605920c,0x443f920d,0x63a206a5}},	//   _regn, зпла, viu_, ñone,
   {{0x63ab8698,0x61e8920e,0x628b920f,0x7aed1210}},	//   _segn, jedl, _rugo, mwat,
   {{0x442d9211,0x443f9212,0x64409213,0x628b9214}},	//   the_, tiu_, fimi, _sugo,
   {{0x61f51215,0x64409216,0x3f891217,0xa2c2001b}},	//   _hazl, gimi, _ngau_, _लिम्,
   {{0x443f9218,0x63ab8125,0x62839219,0x442d84a9}},	//   riu_, _vegn, _pino, rhe_,
   {{0x442d921a,0x443f921b,0x7c24059f,0x61f50748}},	//   she_, siu_, zkir, _jazl,
   {{0x442d921c,0x63ab921d,0x61f5121e,0x6440921f}},	//   phe_, _tegn, _mazl, bimi,
   {{0x64409220,0x7aed0c56,0xe8df082e,0x628b9221}},	//   cimi, kwat, _ahịa_, _tugo,
   {{0x765c1222,0x62839223,0x249a03ac,0xd5d2852a}},	//   tory, _tino, _stpm_, _सामज,
   {{0x682604c3,0xa3ce000f,0x7aed1224,0xe8df01bc}},	//   _tódo, _राह_, dwat, _chịa_,
   {{0x32078035,0x7afb9225,0x7c241226,0x00000000}},	//   _inny_, lvut, tkir, --,
   {{0x5fc6035a,0x765c1227,0xc4830abe,0x7bcd0041}},	//   _वाटल, sory, елск, ggau,
   {{0x7c241228,0x6e461229,0x6fa20670,0x7aed122a}},	// [860] rkir, _неиз, _क्यू, gwat,
   {{0x7c240b0c,0x17570051,0x6440922b,0x2fdf8122}},	//   skir, _מספר_, zimi, _abug_,
   {{0x6440922c,0x2eff8359,0xae1b00be,0x7aed008e}},	//   yimi, _aruf_, _הויכ, awat,
   {{0x442b122d,0x4424001c,0x7aed0c2e,0x61e8922e}},	//   _glc_, _ôm_, bwat, zedl,
   {{0x61f507d9,0x6440922f,0x38669230,0xa2bd83dd}},	//   _fazl, vimi, rlor_, _शिष्,
   {{0xe29701a1,0x63a41231,0x442480ee,0x160386a7}},	//   _хар_, lbin, wkm_, लागर_,
   {{0xf8e00076,0x8fa69232,0x443d9233,0x61e89234}},	//   _नहिय, _наве, _bmw_, vedl,
   {{0x7afb01dd,0x60c89235,0x61e89236,0x329883a7}},	//   _šuti, vudm, wedl, овиќ_,
   {{0x63a41237,0x61f51238,0x6ab61239,0x06e40264}},	//   ibin, _yazl, nsyf, মিডি,
   {{0x27e003c3,0x80c0923a,0x3f808110,0xa2bd90be}},	//   _abin_, _विदे, žius_, _शिर्,
   {{0xdca3835f,0x64a38a1f,0x6608813c,0x859b8039}},	//   _захи, _заха, _indk, _השבו,
   {{0x7aed0063,0x35d28105,0x61e8923b,0x3207923c}},	//   ywat, _साड़, sedl, _enny_,
   {{0x7ae2803b,0xf77f0073,0x82fa853d,0x442b09c4}},	//   _upot, reço_, _دراز_, _rlc_,
   {{0x661a8364,0x4b7b81c6,0xa7fb123d,0xe3b08fd3}},	//   _jotk, _האדו, doñe, _سرچ_,
   {{0x7a2d840e,0x601f00f1,0x1c208105,0x61db82f6}},	//   _fútb, _sëmu, _बवाल_, _הקוד,
   {{0x63a4123e,0x7aed123f,0xd2510019,0x442b00e5}},	//   gbin, twat, ھنا_, _qlc_,
   {{0x3b541240,0xa3de8aed,0x7bcd1241,0x35d281ce}},	// [870] ектр, द्य_, rgau, _साढ़,
   {{0x24868013,0x91fc8029,0x661a807b,0x7c870012}},	//   _liom_, klām, _notk, _нуме,
   {{0x4fd59242,0x21270028,0xb33b0036,0x26cb1243}},	//   джет, ánh_, _reçu, luco_,
   {{0xa2bd9244,0x2eff80b9,0x35d303b7,0xa3de852a}},	//   _शिल्, _pruf_, _ताड़, द्म_,
   {{0xa7fb07f4,0xd6db9245,0x236681c0,0x26cb016a}},	//   coñe, сте_, _nyoj_, nuco_,
   {{0x2f238029,0x443d808e,0x992b1246,0x644d1247}},	//   _rīgā_, _smw_, _люба_, lnai,
   {{0x644d1248,0x3cf78035,0x80db8327,0xb33b03ed}},	//   onai, ंटें_, _बहें, _veçu,
   {{0x62870693,0x13b100ab,0xaca3819d,0x9f448037}},	//   _hijo, _ছাড়, _haịm, _lamù_,
   {{0x661a9249,0xb33b0214,0x2eff80b9,0x644d124a}},	//   _fotk, _geçt, _uruf_, inai,
   {{0x644d0083,0x7afb8074,0x26cb124b,0x2009124c}},	//   hnai, rvut, duco_, _anai_,
   {{0x7643924d,0xdb0b8019,0xd90f803d,0x63a4124e}},	//   miny, _megé, ایع_, ybin,
   {{0xa3ae8a3a,0x7643924f,0x59dd1250,0xeb0d1251}},	//   करण_, liny, न्तर, _सपूत_,
   {{0x629d01c5,0x7a201252,0xd0928201,0x09ac80ab}},	//   _ntso, _kött, _müəy, _খারা,
   {{0xfce600e8,0xdb2680d7,0x62871253,0x3e640061}},	//   мого, _توهی, _nijo, jött_,
   {{0x2101005c,0x91fc80eb,0x63a41254,0x7a201255}},	//   nčić_, klāj, tbin, _mött,
   {{0x27e002f7,0x628f1256,0x644d1257,0x601f0168}},	//   _ubin_, _buco, gnai, _dëms,
   {{0x76439258,0x4b7a8158,0x62871259,0xcb67125a}},	// [880] kiny, ַטעג, _bijo, дате_,
   {{0x644d125b,0x7643925c,0x62870b80,0x21010267}},	//   anai, jiny, _cijo, kčić_,
   {{0x7643925d,0x628707fc,0x2101011f,0x644d125e}},	//   diny, _dijo, jčić_, bnai,
   {{0xa7fb04c3,0x28c5925f,0x320984b9,0x3b0a0fdd}},	//   poñe, _विनि, _ɗaya_, _демо_,
   {{0x62870216,0x76438234,0x987b03de,0x628f018f}},	//   _fijo, finy, קאנט, _guco,
   {{0xd49a9260,0x59dd1261,0x62871262,0x9d450019}},	//   ори_, न्दर, _gijo, _آئین,
   {{0xf9831263,0x7a200338,0xa9670198,0x21671264}},	//   _агро, _dött, _жира_, _жири_,
   {{0xa8038098,0xb7fb801b,0x628702f9,0x00000000}},	//   _изсл, _एफएम_, _zijo, --,
   {{0x984600eb,0x7a20016d,0x76439265,0x998c8088}},	//   _dēļ_, _fött, biny, ridž_,
   {{0x7a201266,0x76439267,0x210100c3,0x20091268}},	//   _gött, ciny, bčić_, _snai_,
   {{0xa3c00576,0xa3ce016f,0x24868706,0x2d8c81a1}},	//   ीला_, रला_, _tiom_, _igde_,
   {{0x3e640065,0x699e800d,0x53468ada,0x2b40811f}},	//   zött_, _ख्री, _охла, _žicu_,
   {{0xa7741269,0x2ba480bc,0x63af0bda,0x4432126a}},	//   ключ, _ग्या, _recn, dhy_,
   {{0x68fc926b,0x26d90102,0xb8f480ab,0x764e126c}},	//   årds, rtso_, _হন_, gnby,
   {{0x236d026c,0x63af0669,0x628f126d,0x644d126e}},	//   _šej_, _pecn, _suco, tnai,
   {{0x7643926f,0x62871270,0x61f89271,0x20091272}},	//   ziny, _sijo, _havl, _unai_,
   {{0xf4841273,0x76439274,0x61f89275,0x0c840048}},	// [890] турн, yiny, _kavl, тырм,
   {{0x61f88025,0x644d1276,0x9c13819d,0x61fa9277}},	//   _javl, snai, _kọch, ndtl,
   {{0xa3ae8006,0x64dd9278,0x76438234,0x62871279}},	//   करा_, _महेश, viny, _vijo,
   {{0x4432127a,0x2c27035f,0x210102a5,0x628f01a1}},	//   chy_, _цьог, včić_, _tuco,
   {{0x4429127b,0x28c58bb8,0x7643927c,0xceeb803d}},	//   mka_, _विभि, tiny, تران_,
   {{0x4429127d,0xf7708416,0x321c816b,0x7876041c}},	//   lka_, جام_, _novy_, máve,
   {{0x764389ca,0x4429127e,0x7876127f,0x7a24823e}},	//   riny, oka_, láve, _gòti,
   {{0x44291280,0xa3d70d86,0x76439281,0x21010668}},	//   nka_, _साफ_, siny, rčić_,
   {{0x44291282,0xa3de8744,0x76439283,0x61f89284}},	//   ika_, द्ध_, piny, _bavl,
   {{0x80c08b6f,0xe9d99285,0x3eb9004a,0xa2c2064a}},	//   _विशे, чко_, dsst_, _लिस्,
   {{0x61f89286,0x68461287,0x44291288,0x186a1289}},	//   _davl, енна, kka_, зани_,
   {{0x44f18a8e,0xdb0601ac,0xb4fa81c6,0x7876128a}},	//   _iš_, _leká, _מפעי, káve,
   {{0xc2c88277,0x442f83a8,0xbbbd816f,0x93278f24}},	//   _قبول_, _ilg_, ोलीक, _تران,
   {{0x4429128b,0x7876128c,0x2d8c128d,0xf65200f7}},	//   eka_, dáve, øde_, ائح_,
   {{0xdb04128e,0x442902a3,0x7c29928f,0x1d071290}},	//   mbié, fka_, oker, нери_,
   {{0x44291291,0x1ddf816f,0x44f1816b,0x3c2e01d6}},	//   gka_, प्तत, _mš_, _býva_,
   {{0x7c29838e,0x28c5809a,0x290301b9,0x44f18bda}},	// [8a0] iker, _विडि, _arja_, _lš_,
   {{0x44291292,0xe1f70638,0x4a431293,0x7a2486c4}},	//   aka_, нгу_, гнув, _dòtw,
   {{0x442902c1,0x7c298d5b,0x4c861294,0x3ead9295}},	//   bka_, kker, _плов, _awet_,
   {{0x44291296,0x7c299297,0x6f041298,0x768b0035}},	//   cka_, jker, _kric, _użyc,
   {{0x68260510,0xdcfc0201,0x5fd18076,0xc8ec9299}},	//   _códi, marı, _हारल, _जन्म_,
   {{0xdcfc0b06,0x80db00ab,0xceb303c8,0x63b60079}},	//   ları, ণিজ্, ריג_, layn,
   {{0x3da5835f,0xa3d704e5,0x442f929a,0xdb1d0176}},	//   тріб, _साम_, _blg_, _adsè,
   {{0x6f040012,0x61f8929b,0x63b60079,0x7c29929c}},	//   _oric, _savl, nayn, gker,
   {{0x44f18267,0x53348087,0xa3ce01d0,0x661e129d}},	//   _eš_, тепт, _राई_, _oopk,
   {{0x4429129e,0x2d8c03f2,0x63b601b4,0xdb0f0580}},	//   zka_, ždej_, hayn, _decè,
   {{0x44290063,0xdcfc0214,0x6f04129f,0x403512a0}},	//   yka_, karı, _aric, венс,
   {{0x2fc080f7,0x7c2992a1,0x442912a2,0x63b601b4}},	//   óigh_, cker, xka_, jayn,
   {{0x61f892a3,0x6d480511,0x63b60079,0x44f1816b}},	//   _tavl, údan, dayn, _zš_,
   {{0x4429009a,0x6f04016d,0x787612a4,0xbe880198}},	//   wka_, _dric, váve, ессе_,
   {{0xf1b38051,0xcfb00264,0x2d8512a5,0xd12f804a}},	//   _עסק_, _কারন, äle_, _сх_,
   {{0x442912a6,0x6f0412a7,0xd6db1294,0x3ea004b7}},	//   uka_, _fric, _ето_, _ftit_,
   {{0x442912a8,0x78ba92a9,0xa3d7058c,0x06e880ab}},	// [8b0] rka_, lstv, _साठ_, পিডি,
   {{0x787612aa,0x51f80150,0x2296006a,0x7c298102}},	//   ráve, нную_, _dæk_, zker,
   {{0x78ba86d4,0xe8028076,0x7fd5902a,0x63b601b4}},	//   nstv, _रोहा_, вілі, bayn,
   {{0x644812ab,0x3ead809c,0x69d5009a,0x764706c0}},	//   édit, _pwet_, _wcze, lijy,
   {{0x141a098a,0xe8df001c,0xdb0b806a,0x799c0114}},	//   _חורב, _thỏa_, _udgø, _ffrw,
   {{0xf77400be,0xb5c285e9,0x628a92ac,0x442f802a}},	//   נקס_, айшл, _nifo, _slg_,
   {{0x7c2992ad,0xf402002e,0x442f92ae,0x9165003d}},	//   tker, _faţă_, _plg_, _شهره,
   {{0x130991d2,0x5fd891bc,0xd138809a,0x628a8915}},	//   дний_, _डायल, dzą_, _aifo,
   {{0x628a816d,0x56958081,0x3ed981a8,0x95d983a7}},	//   _bifo, _разт, _زواج_, _одат_,
   {{0x7c2992af,0xdcfc0059,0x32d986c0,0x6442811b}},	//   sker, zarı, rèy_, _emoi,
   {{0xa2bd885d,0x07a60554,0x442f92b0,0x2dd880f7}},	//   _शिक्, канн, _tlg_, _سبلة_,
   {{0x6f0412b1,0x63b602a3,0xdcfc0085,0x23c7826b}},	//   _pric, xayn, xarı, _dìjà_,
   {{0xe1ee92b2,0xfc46826f,0x539a82f6,0x628a8032}},	//   _кг_, ších_, _חינו, _fifo,
   {{0xceb2873a,0x63a992b3,0x2c4c801b,0x248b0144}},	//   שים_, lben, vědi_, _aicm_,
   {{0xdcfc1014,0xd1388035,0x78ba8dcc,0xa7fb016a}},	//   tarı, czą_, cstv, soña,
   {{0x2ae585e8,0x51848160,0x21888158,0x63a992b4}},	//   _कहाँ_, _суча, _אָפּ, nben,
   {{0xd4670572,0x787880a9,0x63b612b5,0x3b860048}},	// [8c0] тите_, níve, rayn, тлаг,
   {{0xa3d70d38,0x2296013c,0xdcfc0214,0x7d0892b6}},	//   _साथ_, _væk_, sarı, _jérô,
   {{0x63a992b7,0xd7fa92b8,0x28c904e5,0x64a612b9}},	//   kben, дул_, ांगि, _шана,
   {{0x63a9911b,0x26cf804f,0x63b60079,0xc95281c6}},	//   jben, fugo_, qayn, סמא_,
   {{0x63a98805,0x78ba826f,0x6378026b,0xfaa6111c}},	//   dben, zstv, _dúní, _јаго,
   {{0x71a30162,0x63a992ba,0x787881d0,0xaca40135}},	//   _варз, eben, díve, _nkịt,
   {{0x628a92bb,0xd94612bc,0xdb0f12bd,0x61fc12be}},	//   _rifo, _реви, _recé, _iarl,
   {{0x61fc12bf,0xdfd280f7,0x7a2d8019,0xab8692c0}},	//   _harl, _خير_, _búto, купк,
   {{0x61fc12c1,0xa3e4001b,0x26dd809a,0x97ea8085}},	//   _karl, प्य_, ctwo_, ışdı,
   {{0x682607a3,0x78ba90e8,0x61fe12c2,0x61fc12c3}},	//   _módu, tstv, ndpl, _jarl,
   {{0x3ea692c4,0xc4c592c5,0x1be212c6,0x02de02f1}},	//   lpot_, _متنو, खभाल_, नझुन,
   {{0xa3ce12c7,0x23ba92c8,0xa3d70fd5,0x6d5a8216}},	//   _राग_, _آداب_, _साध_, _ixta,
   {{0x6f0292c9,0xd138809a,0x682612ca,0x628a92cb}},	//   nvoc, szą_, _nódu, _tifo,
   {{0x78ba89cf,0x6f0292cc,0xa4d50d8e,0x67200338}},	//   pstv, ivoc, логі, ämja,
   {{0xfa778051,0xa3ce12cd,0x97320061,0x69c81238}},	//   _שעות_, _राख_, لکیا, _ödey,
   {{0x7876026f,0x3c31816b,0x54540425,0xc61f92ce}},	//   rávc, _káva_, авст, _भव्य_,
   {{0x2d9e8e1c,0x61fc12cf,0x337500c4,0x06d78264}},	// [8d0] _ofte_, _barl, угар, _দৈনি,
   {{0x35f5098d,0x61fc12d0,0x63a99123,0x394b003d}},	//   _спор, _carl, zben, وشاپ_,
   {{0x61fc12d1,0xdb0b80ab,0x787603b0,0x27ef83ba}},	//   _darl, _regí, láva, tegn_,
   {{0xdb0b8065,0xdb0612d2,0x61fc0039,0x28c586ae}},	//   _segí, _bekä, _earl, _विसि,
   {{0x6d5a8201,0x787612d3,0x7c2d12d4,0x78788187}},	//   _axta, náva, mkar, xíve,
   {{0xd77480f7,0x26cf92d5,0x78788187,0x7bc292d6}},	//   جامع, rugo_, víve, _adou,
   {{0xeb9992d7,0xd46992d8,0x7e6392d9,0x26dd8035}},	//   ний_, нике_, ronp, stwo_,
   {{0x200d8012,0x7876037d,0x787892da,0xdb0b8187}},	//   _unei_, káva, tíve, _negã,
   {{0xc7b28039,0x7c2d12db,0x05d3025a,0x9d238264}},	//   _לבן_, ikar, _तांब, বছেন_,
   {{0x78760a56,0x96f892dc,0x63a992dd,0x386912de}},	//   dáva, _جعفر_, sben, _akar_,
   {{0x7c2d12df,0x2ba492e0,0x78788187,0x9f4e001b}},	//   kkar, _ग्वा, síve, čním_,
   {{0x1ddf836d,0xddd5001b,0x2c098035,0xdb0a016b}},	//   प्रत, mozř, वाओं_, šnéh,
   {{0x91e592e1,0x28c58bbc,0x09e58abe,0x442d92e2}},	//   _боле, _विवि, _болн, mke_,
   {{0x442d92e3,0xdd920f99,0x386912e4,0xaf7683de}},	//   lke_, صور_, _ekar_, טערס_,
   {{0x442d92e5,0x7c3612e6,0x6e218668,0x09b200ab}},	//   oke_, thyr, _molb, _চালা,
   {{0x442d92e7,0x7c2d12e8,0x044312e9,0x8c4312ea}},	//   nke_, gkar, бесн, бесе,
   {{0x442d92eb,0x9b9300f7,0x248012ec,0x7c3612ed}},	// [8e0] ike_, إلكت, rmim_, rhyr,
   {{0xf1a903f8,0xe9d70003,0x05d292ee,0x3b8312ef}},	//   نامه_, лку_, _साइब, слуг,
   {{0x442d92f0,0x3ebf8012,0x61fe12f1,0x19b680be}},	//   kke_, _avut_, rdpl, רפער_,
   {{0x442d92f2,0x7c2d12f3,0x6aad81cd,0x61fc12f4}},	//   jke_, ckar, _ħafn, _warl,
   {{0x6e2192f5,0x61fc12f6,0xc7d70039,0x442d92f7}},	//   _bolb, _tarl, רוני_, dke_,
   {{0x442d8b3c,0x6e2192f8,0xccfa84ae,0x442212f9}},	//   eke_, _colb, ећи_, _hok_,
   {{0x6aa292fa,0x442212fb,0xf8c5825e,0x442d84b9}},	//   _stof, _kok_, _विषय, fke_,
   {{0x442212fc,0x25f0809a,0x7bd612fd,0x442d92fe}},	//   _jok_, _इसकी_, ngyu, gke_,
   {{0xa6ca89d7,0x628e12ff,0x5a349300,0xa3d70592}},	//   _سوال_, _kibo, инит, _सास_,
   {{0xa3e40e70,0xa2d501fe,0x2ba480d4,0xd6cf8f99}},	//   प्त_, यंत्, _ग्रा, _رقم_,
   {{0x8d939301,0x44221302,0x2907803b,0xf5938013}},	//   _المش, _ook_, _crna_, _المج,
   {{0x628e1303,0x764a9304,0x4422005f,0x557780be}},	//   _libo, lify, _nok_, _געבן_,
   {{0xa3ce09a3,0x09cc00c8,0x80c09305,0xe80b8beb}},	//   _राज_, র্যা, _विके, _सोफा_,
   {{0xe80b800f,0x7c229306,0x78761307,0x386681b0}},	//   _सोना_, _hoor, ráva, hoor_,
   {{0x16d19308,0x44221309,0x7c2d130a,0x7876130b}},	//   _सम्ब, _bok_, tkar, sáva,
   {{0x09cc00c8,0x44220214,0x26de0087,0x628e130c}},	//   র্মা, _cok_, ător_, _aibo,
   {{0x44220025,0x7c22930d,0x628e130e,0x5b15130f}},	// [8f0] _dok_, _moor, _bibo, шмат,
   {{0x7c2d00ad,0x442d9310,0x628e1311,0x7c229312}},	//   skar, zke_, _cibo, _loor,
   {{0x645a1313,0x44221314,0x764a9315,0x442d8be7}},	//   étic, _fok_, dify, yke_,
   {{0x7c229316,0xe8d784de,0x6e218f06,0x72d51317}},	//   _noor, רואר_, _solb, _комф,
   {{0x6e219318,0x44c101e2,0x64499319,0x27e9131a}},	//   _polb, lė_, viei, _mban_,
   {{0x09cc0a49,0x80aa8a49,0x7d0882a5,0xa1940071}},	//   র্বা, _কিন্, _brds, _гарч,
   {{0x44c101e2,0x442d931b,0x4422131c,0xa3dc131d}},	//   nė_, tke_, _yok_, _ठाम_,
   {{0x0c258aac,0x63ad131e,0x442d931f,0x6a6b0192}},	//   рмин, nban, uke_, rüfu,
   {{0x2907812b,0x78a49320,0x63ad1321,0x7c229322}},	//   _srna_, _čiva, iban, _door,
   {{0x442d9323,0x44c101e2,0x4a459324,0x27e91325}},	//   ske_, kė_, рнов, _aban_,
   {{0x69dd090a,0x7c2289f8,0xc32380c8,0x8e848013}},	//   _पानी, _foor, _বেশি_, _الله,
   {{0x7bc78110,0xdb0f03a7,0xd71c80ab,0x44c10110}},	//   ėjus, _mecâ, _দেয়া_, dė_,
   {{0x92b78013,0xf77208ca,0x290780dd,0x93948a47}},	//   _إحصا, تاد_, _wrna_, _اجما,
   {{0x44221326,0x63bb9327,0xbb3a8496,0x63ad1328}},	//   _sok_, laun, _בעני, eban,
   {{0x628e1329,0x6142932a,0xdb0f05e4,0x89da8039}},	//   _ribo, _меша, _decí, _יחסי,
   {{0x63ad132b,0x63bb932c,0x6f09932d,0x628e132e}},	//   gban, naun, _orec, _sibo,
   {{0xe9da0a08,0x386680f3,0x6d41046d,0xeb97002e}},	// [900] кка_, voor_, úlar, риу_,
   {{0x63ad132f,0x63bb8bb1,0x7af60114,0x787881d0}},	//   aban, haun, rwyt, díva,
   {{0xe0da1330,0xf1dd83eb,0x41dd8eb4,0xeaf28592}},	//   тве_, _मानन, _मानस, _अन्त_,
   {{0x35dc0665,0x6f099331,0xa3e7800d,0xdb0f002e}},	//   _बाड़, _brec, म्म_, _decâ,
   {{0x6f09840e,0x27ff8590,0xe7e8035a,0x764a9332}},	//   _crec, _daun_, ट्या_, tify,
   {{0x69dd0076,0x7c229333,0x6f099334,0x7d008019}},	//   _पायी, _soor, _drec, járá,
   {{0x01bb8a49,0x764a9335,0x7c229336,0x38669337}},	//   ংলাদ, rify, _poor, poor_,
   {{0x64561338,0x6f099339,0x27ff8763,0x69d8816f}},	//   nnyi, _frec, _gaun_, _माही,
   {{0x7c22933a,0xd37780d6,0x27e902f7,0xadba81a8}},	//   _voor, ичь_, _rban_, _لهذا_,
   {{0x7c2290f4,0x20120870,0x27e6933b,0x5a34933c}},	//   _woor, _anyi_, lfon_, снот,
   {{0xa3d703a4,0x78760a56,0x63ad133d,0xdca38088}},	//   _साल_, rávn, yban, _дахи,
   {{0x44c10110,0x3e7b8036,0x78a10061,0x63ad133e}},	//   vė_, rête_, _élve, xban,
   {{0x63a2933f,0xdb0f0118,0x200501d0,0xdb060032}},	//   _ifon, _pecí, ěli_, _eekú,
   {{0x20050063,0x20121340,0x44c101e2,0xa3e41053}},	//   śli_, _enyi_, tė_, प्स_,
   {{0x9c470791,0x3a7b83de,0x00000000,0x00000000}},	//   ахал, _שטוד, --, --,
   {{0x8f471317,0x27e91341,0x7055003d,0x1dd30105}},	//   _вход, _uban_, _دنبا, _ताकत,
   {{0x290a01e2,0x63ad1342,0xaa7b00e1,0xfb870e49}},	// [910] _arba_, rban, _opýt, рывн,
   {{0xe7e80063,0x39a71343,0x44c10110,0x63bb84b9}},	//   ट्ठा_, ршав, pė_, zaun,
   {{0x26141344,0x6f09803b,0x27ff8abf,0x63ad1345}},	//   दारी_, _srec, _paun_, pban,
   {{0xdd1c01d0,0x765a8168,0xe3b81346,0x785201a9}},	//   _nářa, _ajty, _ключ_, tāvi,
   {{0xe5a5917e,0x290a1347,0xd6db82dc,0x8c1a0039}},	//   били, _erba_, тте_, _עושי,
   {{0x644d1348,0x63a29349,0x14b8019f,0x6f0980e1}},	//   liai, _afon, _حدیث_, _vrec,
   {{0x27ff83f8,0x6f098114,0x44f88028,0x63bb934a}},	//   _taun_, _wrec, _cũ_, taun,
   {{0x6f098012,0x644d134b,0xed580039,0x62850706}},	//   _trec, niai, יבור_, lmho,
   {{0x869887eb,0x63bb934c,0x386d934d,0x6f098087}},	//   _вкус_, raun, _iker_, _urec,
   {{0x6ce7835f,0x629b82be,0xe4e7835f,0xe8f9934e}},	//   _віде, rquo, _відн, гло_,
   {{0xa3d71344,0x92d780c8,0x261989f2,0x9f5e000d}},	//   सला_, াবে_, पाठी_, ětí_,
   {{0x6601934f,0x44e19350,0x9b9580f7,0xaac704c5}},	//   _halk, mó_, _الإت, _लिंक,
   {{0x69c71351,0xbb858013,0x64561352,0x44e19353}},	//   _odje, _الشي, vnyi, ló_,
   {{0x69c7020f,0x6da31354,0x66018009,0x7bdd0118}},	//   _ndje, зира, _jalk, _acsu,
   {{0x44e19355,0x64a602df,0x2d8c0106,0x2ba6801b}},	//   nó_, саба, äde_, síců_,
   {{0x7c3b9356,0x69dc1357,0x644d1358,0x62999359}},	//   nhur, _scre, giai, _kuwo,
   {{0x290a003b,0xa3df8105,0x63b98114,0xd3b90a8e}},	// [920] _srba_, _तान_, _mewn, русі_,
   {{0xbf9b0073,0x26c2135a,0xa3e786ab,0xdb0f0980}},	//   ndên, msko_, म्त_, _decà,
   {{0x44e1935b,0x31ba8158,0x93f9816f,0x787d0019}},	//   jó_, רזענ, ्याच_, séve,
   {{0x387f8af9,0x44e1935c,0xe73a8364,0x644d135d}},	//   _chur_, dó_, лее_, ciai,
   {{0x26c20ed6,0x4432003e,0x7c3b935e,0x2f18935f}},	//   nsko_, mky_, dhur, роль_,
   {{0x443203cb,0x63a29360,0x40961361,0xceb303c8}},	//   lky_, _sfon, _грат, ליד_,
   {{0x660182c1,0x44e19362,0x1619000f,0xdc1180ab}},	//   _dalk, gó_, दातर_, িউনস_,
   {{0x44321363,0x44f88028,0x62999364,0x69c71365}},	//   nky_, _vũ_, _buwo, _zdje,
   {{0x8c1b004c,0x26c2135a,0x66019366,0x32669367}},	//   רופי, jsko_, _falk, йтов,
   {{0x41dd835a,0x8afb00be,0x660181b4,0x11d880f7}},	//   _माणस, נהיי, _galk, جودة_,
   {{0x04968013,0x44e185a4,0xdb0f02ba,0xdfd11368}},	//   _الصح, có_, _mecá, ويد_,
   {{0x4432026f,0xdb0b816d,0x44201369,0x6e250214}},	//   jky_, _begä, jji_, _sohb,
   {{0x44320a56,0x4420136a,0x447b8158,0x7c6580f7}},	//   dky_, dji_, _ענדע, _بالل,
   {{0x7ae4136b,0x4420136c,0x63b9809a,0x66018df6}},	//   dtit, eji_, _zewn, _xalk,
   {{0x90a6936d,0x644d136e,0x4432136f,0x59dd9370}},	//   _احتم, tiai, fky_, _मातर,
   {{0x442000f1,0xb4e90770,0x7c2606cb,0x44269371}},	//   gji_, _यही_, _cokr, _joo_,
   {{0x644d1372,0x2fc9108c,0x442681c5,0x44e18065}},	// [930] riai, _idag_, _moo_, zó_,
   {{0x442682c1,0x442000f6,0x386d832b,0x644d1373}},	//   _loo_, aji_, _sker_, siai,
   {{0x4432003e,0xda781374,0x6f0d026f,0x7d081375}},	//   bky_, сят_, _hrac, ådst,
   {{0x44200d38,0x44321376,0x6f0d1377,0x44e19378}},	//   cji_, cky_, _krac, vó_,
   {{0x443903d3,0x660188e5,0x9f0580f7,0xe610804e}},	//   _ils_, _palk, توشو, کشن_,
   {{0x44e18117,0xd1268154,0x4ac28072,0x2ba501d0}},	//   tó_, _قم_, _शिजव, गुरा,
   {{0x63b98063,0xe3b18013,0xfe708077,0x66019379}},	//   _pewn, ورة_, رده_, _valk,
   {{0x44e1937a,0x5ac9937b,0x386d80e8,0x6601937c}},	//   ró_, алим_, _uker_, _walk,
   {{0x44e1937d,0xe816816f,0xb4d601ce,0x27ed89bf}},	//   só_, णारा_, _सम्_, _iben_,
   {{0x7c3b937e,0x4432003e,0x4420137f,0x2fc91380}},	//   shur, zky_, zji_, _adag_,
   {{0x3ea9002e,0x9d559381,0x6f0d1382,0x261d015c}},	//   _atat_, _بنات, _arac, मानी_,
   {{0x186a1383,0xa4140264,0x44c581a9,0x69da9384}},	//   рами_, _সত্য_, mē_, agte,
   {{0x44321385,0x28c5825e,0x44c580eb,0x44201386}},	//   vky_, _विकि, lē_, vji_,
   {{0x44391387,0x7ae41388,0x5bb206a7,0x64a380c3}},	//   _als_, vtit, जर्व, _gđic,
   {{0x44321389,0x4426877f,0x27ed8352,0x8c0100c8}},	//   tky_, _yoo_, _oben_, _একজন_,
   {{0xd5dc023c,0x6a7002af,0x5baa07a1,0x7bdb938a}},	//   _बावज, häft, ркам_, nguu,
   {{0x4420138b,0x4432003e,0x4226138c,0x3b0700b3}},	// [940] rji_, rky_, одав, оето_,
   {{0x4439138d,0x44320a56,0x4420009a,0x6aa480f7}},	//   _els_, sky_, sji_, _éife,
   {{0x7ae4138e,0x10a6138f,0x4432003e,0x644b8370}},	//   stit, циен, pky_, _omgi,
   {{0xa2a2000f,0x7876026f,0x23e10935,0x7ae41390}},	//   _कंप्, dávk, _फायद, ptit,
   {{0x69da806a,0xa25b00e1,0xdb0f0144,0xaac7001b}},	//   ygte, _kvôl, _tecá, _लिएक,
   {{0x2d4e011b,0x44268962,0xa3e79391,0x27ed9392}},	//   _eнee_, _soo_, म्स_, _eben_,
   {{0xd4979006,0x44269393,0x672f009a,0xd5b98a4c}},	//   оры_, _poo_, zycj, ссі_,
   {{0x3cfe8267,0x7a2d9394,0x442682f7,0x68e3023e}},	//   _vstv_, _mútu, _qoo_, ànde,
   {{0x63a41395,0x44269396,0x69da1238,0x6a748580}},	//   icin, _voo_, _ötes, làfi,
   {{0x81d280c8,0x27e000fc,0x2004865f,0x26c08196}},	//   হ্ন_, _acin_, _hami_, šios_,
   {{0x20049397,0x63a41398,0x4a7b0158,0xc27b00be}},	//   _kami_, kcin, שריב, שריי,
   {{0x6f0d1399,0x200480a4,0x63a400d2,0x6e28826c}},	//   _prac, _jami_, jcin, _hodb,
   {{0x61ee139a,0x7bc0939b,0x78ad939c,0xa3e3864a}},	//   _obbl, mamu, _čave, _पॉट_,
   {{0x63a400eb,0x2004939d,0xdef801e2,0xddda8061}},	//   ecin, _lami_, цыю_, _kitű,
   {{0xdd940196,0x63a4026c,0x6594139e,0x6f0d139f}},	//   дары, fcin, дару, _wrac,
   {{0x320d017b,0x6f0d13a0,0x200493a1,0x7bc093a2}},	//   _şey_, _trac, _nami_, namu,
   {{0x6f0d13a3,0x44c581a9,0x97ea81cc,0x2aa08242}},	// [950] _urac, zē_, ışlı, _jòb_,
   {{0x7bc093a4,0x20048091,0x290e81a1,0xdb198176}},	//   hamu, _aami_, _krfa_, _dewè,
   {{0x31c40987,0x7bc093a5,0x26d913a6,0x200493a7}},	//   ьств, kamu, luso_, _bami_,
   {{0xdb1f0168,0xae190035,0x7bc093a8,0x200493a9}},	//   naqë, दावन_, jamu, _cami_,
   {{0xdefb8364,0x7bc093aa,0x81e700c8,0x63bd0029}},	//   рые_, damu, _মোঃ_, _iesn,
   {{0x46d30076,0xafdb00e8,0x386681a1,0xdcef8b80}},	//   _तिनह, rnøy, čora_, šečl,
   {{0x660513ab,0x20048970,0x19580190,0x6a7013ac}},	//   _mahk, _fami_, _дары_, räft,
   {{0x660513ad,0x629d13ae,0x443993af,0x69ca93b0}},	//   _lahk, _kuso, ós_, _adfe,
   {{0xf7498013,0x768b0063,0x6e28813c,0x629d13b1}},	//   _الذي_, _używ, _fodb, _juso,
   {{0x2bab8eed,0x629d13b2,0x36378077,0x63bd13b3}},	//   _ट्रा, _muso, _بررس, _lesn,
   {{0x216993b4,0x629d13b5,0x60c50168,0x7bc093b6}},	//   сини_, _luso, nshm, bamu,
   {{0xa3d71278,0x2489026c,0x26d90568,0x7bc093b7}},	//   _साग_, jmam_, fuso_, camu,
   {{0x660513b8,0x20040038,0xdb0b8019,0x7876016b}},	//   _bahk, ľmi_, _legú, návi,
   {{0x443f84b9,0x8b058063,0x629513b9,0x3d0813ba}},	//   lhu_, _częś, _nizo, हिले_,
   {{0x69c193bb,0xe3bf0e1b,0x60c500f1,0xc6928039}},	//   male, _coño_, jshm, תאם_,
   {{0x69c1805d,0x629d13bc,0xaac7009a,0x4ac70d86}},	//   lale, _buso, _लिखक, _लिखव,
   {{0x63a413bd,0xe36313be,0x6b6313bf,0x62950019}},	// [960] rcin, екти, екта, _bizo,
   {{0x69c193c0,0x629504b9,0x7bc080b4,0x63a413c1}},	//   nale, _cizo, zamu, scin,
   {{0x6d438024,0x443f829b,0x200486c0,0x7bcb80d2}},	//   jzna, khu_, _pami_, _odgu,
   {{0x38a18013,0xfc3200f7,0xdb0400f3,0x7bc08079}},	//   _mór_, _أحد_, ncië, xamu,
   {{0xfbd30051,0x69c193c2,0x7bc08006,0x629d02a0}},	//   _אתר_, kale, vamu, _guso,
   {{0xe8df0028,0x69c193c3,0x20048234,0x629513c4}},	//   _giữa_, jale, _wami_, _gizo,
   {{0x69c193c5,0x7bc093c6,0x2ee693c7,0xb5098072}},	//   dale, tamu, stof_, विषय_,
   {{0x7c2413c8,0x629d03ac,0xb0d1016f,0xf8c5824c}},	//   njir, _yuso, _हितग, _विजय,
   {{0x7bc093c9,0x69c193ca,0xdb060061,0x2a6c8163}},	//   ramu, fale, _nekü, todb_,
   {{0x69c193cb,0x7bc093cc,0x7f3b8039,0x62838219}},	//   gale, samu, _העמו, _chno,
   {{0x7bc08ce9,0x443f81f6,0x649581a1,0xf1dd8ad5}},	//   pamu, bhu_, _išin, _मारन,
   {{0xc48693cd,0x3157098a,0x660513ce,0x7d7b80be}},	//   _элек, ליין_, _sahk, _פראג,
   {{0x63bd13cf,0xe3bf01df,0xee870198,0x47340c6e}},	//   _resn, _soño_, зыво, еняс,
   {{0x69c193d0,0x38a18125,0xe3bf002a,0xd2508fd3}},	//   cale, _fór_, _poño_, _جنت_,
   {{0x776401df,0xa15793d1,0x26d913d2,0x7876026f}},	//   _exix, _нашу_, suso_, závi,
   {{0x26d913d3,0x31c6801b,0x629d13d4,0xab5d809a}},	//   puso_, bízí_, _puso, saże,
   {{0xdb0b8c15,0xdb0400e7,0x248913d5,0x60da80dd}},	// [970] _segú, nciè, rmam_, lutm,
   {{0x60c500f1,0x4ad493ba,0x61fa93d6,0xddc381ac}},	//   tshm, _दिनव, netl, konš,
   {{0x6ca413d7,0x63bd024a,0x787d0036,0x7c380333}},	//   _пряж, _tesn, névo, ñará,
   {{0x69c193d8,0x60c500f1,0x629d0365,0xf770803d}},	//   zale, rshm, _tuso, گام_,
   {{0x261993d9,0x61fa93da,0xe80e10c8,0x69c193db}},	//   पाली_, ketl, ियता_, yale,
   {{0xf7708bbe,0x61fa82fd,0x442b13dc,0x7876016b}},	//   دام_, jetl, _hoc_, rávi,
   {{0x443f93dd,0xc2120039,0x26c681b4,0x60c513de}},	//   thu_, _בהם_, asoo_, qshm,
   {{0xc9520051,0x442b13df,0x7bdf13e0,0xdb1d0168}},	//   _סמן_, _joc_, ngqu, _nesë,
   {{0xe82101fe,0x69c193e1,0x442b13e2,0xa3e505fc}},	//   याना_, tale, _moc_, _नान_,
   {{0x442b0012,0x443f93e3,0x38a193e4,0xa3df93e5}},	//   _loc_, shu_, _pór_, _ताव_,
   {{0x443f93e6,0xa2cf8c2d,0xda1f8072,0x3de30264}},	//   phu_, _दिव्, बाबत_, য়াল,
   {{0x69c193e7,0xcdc90051,0x442b1122,0x64408920}},	//   sale, _כך_, _noc_, chmi,
   {{0xa3d70e5b,0xdb060247,0xdb0401ed,0x09d500ab}},	//   _साज_, _lekò, rcië, স্যা,
   {{0x69c18234,0xf1ba00ff,0x7ae993e8,0x291113e9}},	//   qale, ươi_, mtet, _orza_,
   {{0x6a7d809f,0x443d815d,0x1d070c24,0x442b13ea}},	//   lèfo, _klw_, мери_, _boc_,
   {{0x998381e2,0x26c40019,0x6e21008b,0xdb1d13eb}},	//   ųjų_, ámos_, ölbr, _kesè,
   {{0x7ae993ec,0x7c2b8122,0x290313ed,0xfaff00eb}},	// [980] ntet, _mogr, _asja_, šīnu_,
   {{0x7c2b840e,0x291113ee,0x7ae993ef,0x6f040234}},	//   _logr, _brza_, itet, _isic,
   {{0x361b0158,0x442b13f0,0xeb9a13f1,0x26c90052}},	//   _וויד, _foc_, _мин_, _zvao_,
   {{0xdfcf8013,0x3ea013f2,0x61fa93f3,0x9f5906c0}},	//   ليم_, _kuit_, zetl, fesè_,
   {{0x61fa93f4,0xbefa826a,0x7ae98019,0x41dd83dd}},	//   yetl, تراض_, jtet, _मांस,
   {{0x768b0d38,0x28db03eb,0x2d9a80e8,0x6f04004f}},	//   _użyt, मूहि, øpe_, _msic,
   {{0xa3e513f5,0x61fa93f6,0x5e570158,0xe821000d}},	//   _नाम_, vetl, ויסע_, यामा_,
   {{0x7bc41149,0x09c6816f,0x442b023e,0xdb1d010c}},	//   naiu, लण्य, _xoc_, _besè,
   {{0xae1e83dd,0xa3df8999,0x68e100f2,0x3ea002be}},	//   पादन_, _तार_, _äldr, _nuit_,
   {{0x64408168,0xa68393f7,0x2fc00580,0xdb1d13f8}},	//   shmi, _алуд, _aeig_, _desè,
   {{0x61fa93f9,0xae220d86,0x6f0413fa,0x443d82df}},	//   retl, मानन_, _asic, _flw_,
   {{0x68e100f2,0x61fa93fb,0xf9930039,0x3ea013fc}},	//   _ålde, setl, כרת_, _buit_,
   {{0x5b36845b,0x69ce01ac,0x320790e4,0x27e480b9}},	//   _تعار, _odbe, _fany_, _mcmn_,
   {{0x3ea013fd,0x6b8293fe,0x32078176,0x683a8580}},	//   _duit_, _izog, _gany_, _oïdo,
   {{0xd3088104,0x2bd00006,0x442b009f,0x24868282}},	//   _hệ_, तृभा, _poc_, _khom_,
   {{0x7a3f80e7,0x3ea013ff,0x69ce1400,0xdb0606c0}},	//   _vête, _fuit_, _adbe, _rekò,
   {{0x52151401,0x661a8cfa,0x7d1c81fa,0x62989402}},	// [990] ндат, _ontk, _ársf, _kivo,
   {{0x7a3f8036,0x20090cda,0x24868609,0xdb060176}},	//   _tête, _haai_, _lhom_, _pekò,
   {{0x7ae99403,0xd308801c,0xa3df8f97,0xdb1d0061}},	//   ztet, _lệ_, _ताल_, _mesé,
   {{0xa2cf9404,0x7ae99405,0xec350158,0x6448009f}},	//   _दिल्, ytet, _נאָר_, èdit,
   {{0x66089406,0x2ee900b9,0x6b828a03,0x20091407}},	//   _badk, _jqaf_, _nzog, _maai_,
   {{0x62989408,0xa3cd064a,0x7c2b9409,0x2009067f}},	//   _nivo, रणव_, _sogr, _laai_,
   {{0x660882c1,0x6d4704b7,0xdfd58009,0x69c5140a}},	//   _dadk, nzja, _повы, mahe,
   {{0x9b05940b,0xcd980bea,0x2486940c,0x58878e11}},	//   езид, ודות_, _chom_, _цыга,
   {{0xed5881ac,0xfe0f140d,0x6298940e,0x443d8187}},	//   _veľa_, ायास_, _bivo, _vlw_,
   {{0x7ae9940f,0x66089410,0x69c51411,0x3ea01412}},	//   rtet, _gadk, nahe, _ruit_,
   {{0x7ae99413,0x09d500c8,0x61e10125,0x29119414}},	//   stet, স্থা, _öllu, íza_,
   {{0x7a320125,0x7878826f,0x2360816b,0x764380dd}},	//   _hætt, tívi, _žije_, lhny,
   {{0x69c513fa,0x200901b0,0x76551415,0x64859416}},	//   kahe, _daai_, fizy, róid,
   {{0xceb29417,0x09d50a49,0xfc3f062f,0x63a99418}},	//   רים_, স্তা, _alí_, lcen,
   {{0x75f38059,0xa8060457,0x7a32007b,0x69c51419}},	//   mızı, _alış, _mætt, dahe,
   {{0x3ea00998,0x98a701d0,0x2af382f1,0x52aa0081}},	//   _tuit_, šně_, _अहाँ_, звам_,
   {{0x9696141a,0x1e96018b,0xfd658028,0xfc3f00f7}},	// [9a0] _прош, _прор, _chuẩ, _dlí_,
   {{0x75f38457,0xa3dc141b,0xd94611f3,0x69c5141c}},	//   nızı, _ठाक_, нези, gahe,
   {{0xa3df941d,0x78ab802e,0x261d00c2,0xba3b023e}},	//   तला_, _învă, मारी_, _suïc,
   {{0xe29a141e,0x41e2016f,0x63a9941f,0xa0679420}},	//   _нам_, _पावस, jcen, наха_,
   {{0xe7379421,0x64561422,0x69c51423,0x2ca1026c}},	//   нец_, miyi, bahe, _zuhd_,
   {{0x64561424,0x69c5008e,0x20e0016f,0x63a99425}},	//   liyi, cahe, खंदळ_, ecen,
   {{0x62989426,0x24868069,0xdb1d1427,0x649581f4}},	//   _rivo, _phom_, _resé, _išij,
   {{0xdb0f0118,0x7643836e,0x64561428,0x04638a41}},	//   _recú, ahny, niyi, лтым,
   {{0xeaaf803d,0x81e700ab,0xa01b007b,0x6d4701b9}},	//   یعی_, _মোট_, llög, zzja,
   {{0xd3088028,0xc3330039,0x63a99429,0x20091384}},	//   _vệ_, טוח_, acen, _saai_,
   {{0xa3e881b6,0x7655142a,0xab5d809a,0x63a9942b}},	//   _बाप_, vizy, raża, bcen,
   {{0x236690af,0xfaa6942c,0x80d3142d,0x9cd782f6}},	//   _txoj_, _задо, _डिसे, _טובה_,
   {{0x644402a3,0x64560201,0xe667142e,0x61fe004a}},	//   dhii, diyi, етво, kepl,
   {{0x61fe142f,0x320a01b0,0x614680e7,0x2009067f}},	//   jepl, _naby_, _célé, _waai_,
   {{0xe821101b,0x5fd0816f,0x69c50006,0x61fe1430}},	//   यादा_, हणाल, vahe, depl,
   {{0x60de09ca,0x9f520e1b,0x765506c0,0x64440162}},	//   dupm, _cayó_, sizy, ghii,
   {{0xc2991431,0x69c50a74,0x3a7507b6,0x2fc68bb1}},	// [9b0] дках_, tahe, влар, daog_,
   {{0xddc71432,0x6467026f,0xbbeb003d,0x61fe1433}},	//   bojš, _špič, _کردم_, gepl,
   {{0x7a321434,0xe61f801c,0x659504bd,0x64561435}},	//   _rætt, _đô_, _јану, biyi,
   {{0x7a32065d,0x44cc800d,0x69c51436,0xd75984a3}},	//   _sætt, dě_, sahe, ولات_,
   {{0xd90f0117,0x320a1437,0x764380dd,0x61fe1438}},	//   _گیا_, _faby_, thny, bepl,
   {{0xee389439,0x7aed0019,0x20098110,0x657a943a}},	//   нні_, mtat, žai_, _byth,
   {{0x25e909f2,0xd90f0117,0x44290110,0x78ad8115}},	//   _जानी_, _دیا_, oja_, _čavo,
   {{0xeb99943b,0x764382f7,0x7aed00e5,0x6d58143c}},	//   мий_, shny, otat, _žvak,
   {{0xc864943d,0xe7db143e,0x248d943f,0x7a320366}},	//   _стри, _भाजप, rmem_, _tætt,
   {{0x44291440,0x63a99441,0x7aed1442,0x6aa281e0}},	//   hja_, scen, itat, _duof,
   {{0x44291443,0xa06a1444,0x7aed0168,0x186a1445}},	//   kja_, дана_, htat, дани_,
   {{0x44291446,0x2d8587d9,0x7c2f09c4,0x7bc29447}},	//   jja_, _izle_, _nocr, _geou,
   {{0xe28e9448,0x44291449,0x7c29944a,0xf092893f}},	//   _ва_, dja_, mjer, ינט_,
   {{0xc0a883f8,0xda110076,0x7c2984fe,0x7c3b944b}},	//   بایل_, _डोलत_, ljer, lkur,
   {{0x442f8bda,0x1fb6144c,0x7aed144d,0x4429144e}},	//   _kog_, _испр, etat, fja_,
   {{0x4429144f,0x442f9450,0x69c39451,0xe8df00ff}},	//   gja_, _jog_, _hene, _nhựa_,
   {{0x614683d3,0x442f822c,0x7aed02b8,0xe29a02df}},	// [9c0] _télé, _mog_, gtat, даа_,
   {{0x69c39452,0x644402a3,0x44291453,0x4a431454}},	//   _jene, shii, aja_, анув,
   {{0x44291455,0x7c3b9456,0x442f837a,0x2dd900be}},	//   bja_, kkur, _oog_, _אַרב,
   {{0x44290d38,0x44cc800d,0x442f9457,0xdefa8048}},	//   cja_, vě_, _nog_, дык_,
   {{0x7aed1458,0xb8659459,0xab5d809a,0x3aeb804a}},	//   ctat, دالو, ważn, jøp_,
   {{0x09cc00c8,0x649580d2,0x44cc801b,0x98a70087}},	//   র্জা, _ušij, tě_, ână_,
   {{0x77698118,0xe976003d,0xa2bf8035,0x4096945a}},	//   _exex, _شهرد, लीस्, _арат,
   {{0x442f81c5,0xdb0b8073,0x629c145b,0x7c29945c}},	//   _cog_, _negó, _hiro, gjer,
   {{0x629c145d,0xbea68098,0x657a831d,0x3f848289}},	//   _kiro, _разк, _wyth, _uzmu_,
   {{0x69c3945e,0x629c145f,0x44291460,0x656902d0}},	//   _cene, _jiro, zja_, şehi,
   {{0x69c39461,0x7aed1462,0x44291463,0x442f9464}},	//   _dene, ztat, yja_, _fog_,
   {{0x320a8775,0x76588010,0xc1730039,0xe53780be}},	//   žby_, livy, יחת_, _שטאט_,
   {{0x44291465,0x69c39466,0xada2807b,0x2fc480b9}},	//   vja_, _fene, _þúsu, _memg_,
   {{0x442f81e9,0x7c2f1467,0x629c1468,0x6f161469}},	//   _zog_, _socr, _niro, _dryc,
   {{0x442f946a,0x69c8946b,0xd49b146c,0x16df8bb8}},	//   _yog_, made, дра_, _नम्ब,
   {{0x030e146d,0x7aed146e,0x3d08035a,0x629c146f}},	//   सिंह_, ttat, हिजे_, _airo,
   {{0x629c1470,0x7aed1471,0x5b150791,0x34940254}},	// [9d0] _biro, utat, ымат, ратр,
   {{0x44291472,0x7aed1473,0x69c8888b,0xa3e5035a}},	//   sja_, rtat, nade, _नाव_,
   {{0x7aed1474,0x44291475,0xdb0b809f,0x629c1476}},	//   stat, pja_, _segü, _diro,
   {{0x4429020f,0x629c0029,0x7aed1477,0x69c89478}},	//   qja_, _eiro, ptat, hade,
   {{0x442f9479,0x7c29830b,0x4421801c,0x63ad147a}},	//   _rog_, vjer, _đh_, mcan,
   {{0x629c147b,0x64428364,0x6d580110,0x3ea48bbd}},	//   _giro, _aloi, _žvai, _dumt_,
   {{0x69c89313,0x7c29911b,0x442f947c,0x6442947d}},	//   dade, tjer, _pog_, _bloi,
   {{0x63ad147e,0x69c3947f,0x442f8282,0x13099480}},	//   ncan, _sene, _qog_, ений_,
   {{0x69c39481,0x7c299482,0x628a8013,0x442f9483}},	//   _pene, rjer, _bhfo, _vog_,
   {{0x69c89484,0x42259485,0x64429486,0x6f099487}},	//   gade, удов, _eloi, _isec,
   {{0xa2cf873c,0x569482df,0xe4e4804a,0x6a7d8980}},	//   _दिक्, _тафт, _вічн, nèfi,
   {{0x69c39488,0x64429489,0xb8cb9370,0x5fab81d0}},	//   _wene, _gloi, _कं_, _छलफल,
   {{0x63bb8397,0xa3e880cf,0x69c3948a,0x69c8948b}},	//   mbun, _बात_, _tene, bade,
   {{0xa2d88305,0xf1e2000d,0x63bb948c,0xfce6148d}},	//   _मित्, _पाइन, lbun, лого,
   {{0x629c148e,0xa3e503b6,0xdb1d01d0,0x290780fe}},	//   _riro, _नाश_, _desí, _usna_,
   {{0x7bc9948f,0x6f161490,0x6f0981dd,0x6e3c1491}},	//   naeu, _tryc, _osec, skrb,
   {{0x63bb82af,0x629c1492,0xa3e50327,0xc05301c6}},	// [9e0] ibun, _piro, _नार_, _לזה_,
   {{0x20020c14,0x629c0609,0x63ad1493,0x09d580ab}},	//   leki_, _qiro, acan, ত্রা,
   {{0x25e91370,0x291e0b67,0xa494003d,0x645a0036}},	//   _जाती_, _štab_, _نیست, étis,
   {{0x63ad0098,0x69c89494,0x61e5032f,0x629c1495}},	//   ccan, zade, aghl, _wiro,
   {{0x68e19496,0x69c89497,0x2ca58362,0xa2cf8c2d}},	//   huld, yade, _auld_, _दिग्,
   {{0x2480020f,0xd252015b,0x69c89498,0x64428635}},	//   llim_, _طنز_, xade, _sloi,
   {{0xa3e89499,0x69c8949a,0x7bc6059c,0x6f09949b}},	//   _बाद_, vade, _keku, _esec,
   {{0x2002061b,0x63bb949c,0x68e1949d,0x7658949e}},	//   jeki_, gbun, duld, sivy,
   {{0x38558698,0x6edb925f,0x38a880e7,0x20020214}},	//   _търс, _नियु, _sûr_, deki_,
   {{0x7bc6149f,0x2ca5813c,0xdd8f94a0,0x27e694a1}},	//   _leku, _fuld_, _کوم_, lgon_,
   {{0x63ad0086,0xe821053e,0x2ca594a2,0x6e9380f7}},	//   ycan, याला_, _guld_, _اللا,
   {{0x27e69341,0x69c894a3,0x7bc614a4,0x64858742}},	//   ngon_, sade, _neku, lóin,
   {{0xd90e8077,0x63ad02a5,0xb8cb86ae,0xa85781c6}},	//   زیک_, vcan, _कू_, ריכה_,
   {{0xdd20800d,0x539b812a,0x291801e4,0x25e8940d}},	//   _může, _ניגו, _orra_, च्ची_,
   {{0x68e183a7,0xdb1d002a,0x7bc614a5,0x63ad14a6}},	//   culd, _vesí, _beku, tcan,
   {{0x20020214,0x63ad0144,0xf1e2001b,0x93b5105c}},	//   ceki_, ucan, _पाउन, рбац,
   {{0x29180019,0x28da800d,0x63a2804f,0x32550f04}},	// [9f0] _arra_, _भिडि, _mgon, авар,
   {{0x200d80ee,0x61e501c0,0x63bb8162,0x6fc794a7}},	//   _saei_, ughl, zbun, ारभू,
   {{0x78ad817f,0xdfd181a8,0x648594a8,0x63ad14a9}},	//   _čavk, قيا_, dóin, pcan,
   {{0x63a294aa,0x7bc614ab,0xf8c9026b,0x64b181a9}},	//   _ngon, _geku, _aréè_, _jāie,
   {{0x260a016f,0x291814ac,0x61f882d4,0x65c582df}},	//   ायची_, _erra_, _obvl, абла,
   {{0x63a294ad,0xe61890ac,0x200214ae,0xed5994af}},	//   _agon, лді_, zeki_, кол_,
   {{0xce380039,0x7bc60085,0x2905047f,0x51840084}},	//   ראות_, _yeku, _èla_, _гута,
   {{0x201f8012,0x68e194b0,0x7afd0122,0x3dc594b1}},	//   _unui_, vuld, _kpst, _welw_,
   {{0x63bb89af,0x28c282f1,0xa3b483b7,0xc24594b2}},	//   rbun, वीसि, झड़_, иник,
   {{0x69c714b3,0x386914b4,0xdb0414b5,0x63a28102}},	//   _jeje, _ajar_, nciá, _egon,
   {{0x69c714b6,0xa96994b7,0x216994b8,0x7c2d14b9}},	//   _meje, тина_, тини_, kjar,
   {{0x7afd14ba,0x69c714bb,0xe73a14bc,0x20560cc1}},	//   _opst, _leje, вем_, ртор,
   {{0x387e86e3,0x81dd00c8,0x7c2d14bd,0x200214be}},	//   _être_, থ্য_, djar, reki_,
   {{0x7bc614bf,0x443f94c0,0x644994c1,0x69c7001b}},	//   _seku, lku_, lhei, _neje,
   {{0x7afd0029,0x776d0118,0x442d8110,0x7c2d007b}},	//   _apst, _exax, oje_, fjar,
   {{0x644994c2,0x660394c3,0x44f1801c,0xef1a066a}},	//   nhei, henk, _mơ_, _ами_,
   {{0x69c70065,0x645a02be,0x207b00be,0x68fc012b}},	// [a00] _beje, étiq, _באקא, _sprd,
   {{0xba2314c4,0x601b0364,0x442d94c5,0x7bc614c6}},	//   одук, _tämä, hje_, _weku,
   {{0x443f94c7,0x442d821e,0x69c714c8,0x6449879f}},	//   kku_, kje_, _deje, khei,
   {{0x1ae6025d,0x443f803b,0x644980f3,0x442d94c9}},	//   _комм, jku_, jhei, jje_,
   {{0x27e694ca,0x442d94cb,0x644994cc,0x644614cd}},	//   rgon_, dje_, dhei, _ilki,
   {{0x443f8029,0x69c71024,0x442214ce,0x660394cf}},	//   eku_, _geje, _hnk_, genk,
   {{0x44f18104,0x7ae414d0,0xb4e40540,0x644980f7}},	//   _cơ_, luit, _नमो_, fhei,
   {{0x644994d1,0x442d94d2,0x628194d3,0x443f80ee}},	//   ghei, gje_, ello, gku_,
   {{0x660394d4,0xd5c614d5,0x326694d6,0x765c14d7}},	//   benk, वराज, итов, kiry,
   {{0x442d94d8,0x443f94d9,0x7c2d14da,0x442214db}},	//   aje_, aku_, zjar, _lnk_,
   {{0x850684c0,0x443f94dc,0x442d8353,0x6449851e}},	//   _خوان, bku_, bje_, bhei,
   {{0x644994dd,0x442d8d38,0x386694de,0x443f87df}},	//   chei, cje_, nnor_, cku_,
   {{0x7c22811b,0xfe2214df,0x7c2d14e0,0x95cb0f9c}},	//   _inor, मांस_, vjar, кува_,
   {{0x7ae414e1,0xdbf880c8,0x644614e2,0x30a68ff7}},	//   duit, _অফিস_, _alki, _крив,
   {{0x69c714e3,0x0ed30072,0x44f18129,0xfda70a27}},	//   _reje, _तिकड, _xơ_, _खलीफ,
   {{0xe51785e8,0x69c714e4,0x386914e5,0x660394e6}},	//   थिति_, _seje, _ujar_, zenk,
   {{0x7ae414e7,0x7c2d14e8,0xdb1982af,0x499282e3}},	// [a10] guit, rjar, _gewä, _دیگر,
   {{0x443f827f,0xdb1d0207,0xe4e700e8,0x442d94e9}},	//   zku_, _cesá, _кімн, zje_,
   {{0x442d94ea,0x69c714eb,0x644981b0,0x3ea900ee}},	//   yje_, _veje, yhei, _huat_,
   {{0x3ea914ec,0x7ae414ed,0x386681e8,0x660394ee}},	//   _kuat_, buit, gnor_, wenk,
   {{0x660394ef,0x443f94f0,0x44f18028,0x442d94f1}},	//   tenk, vku_, _sơ_, vje_,
   {{0xc3320158,0x3ea90812,0x9f568061,0x2fc914f2}},	//   _צום_, _muat_, ágát_, _leag_,
   {{0x442d94f3,0x3ea914f4,0x644994f5,0x58d414f6}},	//   tje_, _luat_, thei, _морт,
   {{0xa2d881ab,0x442d81e2,0x660394f7,0x443f94f8}},	//   _मिश्, uje_, senk, uku_,
   {{0x644994f9,0xa3e8901c,0xa3e50054,0x66038a9e}},	//   rhei, _बार_, _नाई_, penk,
   {{0x442d94fa,0x644994fb,0xa2d894fc,0xaca38135}},	//   sje_, shei, _मिर्, _anụm,
   {{0x2fc90ad0,0x442d94fd,0x6f0d14fe,0x84678098}},	//   _beag_, pje_, _asac, _къде,
   {{0x3ea914ff,0x64409500,0x442d8168,0x66fa8ec3}},	//   _buat_, ckmi, qje_, bākā,
   {{0x44d3009a,0x683f00f1,0xac7480f7,0x02a78cdf}},	//   eć_, _mëdh, _بالش, _трем,
   {{0xed5a1501,0x6d4e0192,0xa3e501a2,0x7c229502}},	//   гог_, tzba, _नाउ_, _znor,
   {{0x50b590f8,0x25e9123a,0xf1ca026f,0x38669503}},	//   _услу, _जारी_, ntáž_, ynor_,
   {{0x7ae41504,0xb603827f,0x47c61505,0x68e50122}},	//   tuit, _hráč, _убив, duhd,
   {{0xab271506,0x23271507,0xe1fa1508,0x44d30035}},	// [a20] бота_, боти_, лга_, ać_,
   {{0x78a908ae,0x3ea101f4,0x15461509,0x78a0950a}},	//   _čevr, _giht_, _геом, _simv,
   {{0x0ce2950b,0xa3e88128,0x7ae4150c,0x20120300}},	//   _মন্ত, _बाल_, suit, _kayi_,
   {{0xa2d8800c,0xdd2c8110,0x32058061,0xd6cf01f9}},	//   _मिल्, _nėšt, hely_, _تقی_,
   {{0x3866950d,0xa2a20540,0x78bb10d3,0x6ecb150e}},	//   rnor_, _कंट्, _čuve, तीपु,
   {{0x6f1b82af,0x20120041,0xdb1d0366,0x6459950f}},	//   _druc, _layi_, _besæ, _amwi,
   {{0xd132045b,0x6f1b819d,0x48e31510,0xa3cc00d4}},	//   _عمر_, _eruc, _норв, _रजा_,
   {{0xf0639511,0x6f1b9512,0xe8e0001c,0xa2b48993}},	//   _експ, _fruc, _chụp_, обич,
   {{0x25e91513,0x6440807b,0x66118198,0x2fc90037}},	//   _जाली_, rkmi, ökkä, _reag_,
   {{0xd90e84c0,0x64408074,0x683f03ed,0x66fa81a9}},	//   فیت_, skmi, _zëdh, rākā,
   {{0x20121514,0x5d868013,0x5316815b,0x28f8804a}},	//   _bayi_, _الال, _گذار, шень_,
   {{0x96eb0084,0x9f991515,0x6f0d1516,0x673d062c}},	//   льга_, ивну_, _psac, tysj,
   {{0x21270129,0x3c388036,0x32059517,0x6c7b83de}},	//   ̣nh_, _févr_, bely_, _גראד,
   {{0x6d1401fe,0x1bf89518,0xe6671519,0x25a51277}},	//   डिंग_, ्जवल_, стмо, øll_,
   {{0x3211009a,0x4035151a,0x64a3817f,0x20120db1}},	//   _razy_, _мекс, _uđit, _fayi_,
   {{0x0ca8151b,0x20120326,0x6b828c2e,0x6495936f}},	//   стри_, _gayi_, _kyog, _ušit,
   {{0x5a35151c,0xe7cc8035,0x6f0d113b,0x69ca951d}},	// [a30] онат, ारनप, _usac, _kefe,
   {{0xa3e5146d,0x6b82951e,0x27ed951f,0x69ca9520}},	//   _नाक_, _myog, _scen_, _jefe,
   {{0x201200a4,0x69ca826b,0x66070088,0xa3e89521}},	//   _yayi_, _mefe, mejk, बला_,
   {{0xac190765,0x69ca9522,0x753a0192,0x06ed064a}},	//   _тому_, _lefe, ätze, _जमाव_,
   {{0x644d1523,0x69ca80c9,0xd6db8aac,0x171c00be}},	//   mhai, _oefe, уте_, ָווע,
   {{0xf7708c48,0x644d1524,0x5bb38beb,0x30a71525}},	//   ران_, lhai, ीर्व, _грав,
   {{0xb0660009,0x32059526,0x91fc80eb,0x6b828c56}},	//   ntää, vely_, rnāl, _ayog,
   {{0x69d89527,0x628504b7,0x6b829528,0x69ca85ee}},	//   _adve, llho, _byog, _aefe,
   {{0x52a691e9,0x32058e25,0x69ca9529,0x290e8118}},	//   овым_, tely_, _befe, _asfa_,
   {{0xe8f9952a,0x2012152b,0x6b8282c4,0x5f1d152c}},	//   ало_, _sayi_, _dyog, मिन्_,
   {{0x386d8db7,0x69d80073,0x644d152d,0x69ca952e}},	//   _kjer_, óvei, khai, _defe,
   {{0xdb1d0364,0x76438aa2,0x645980b4,0xa3e50107}},	//   _kesä, lkny, _umwi, _नाग_,
   {{0x644d152f,0x7bcb80eb,0x3205816b,0x7643808e}},	//   dhai, _iegu, pely_, okny,
   {{0x76439530,0x69ca9531,0xe7e607e6,0xceb283de}},	//   nkny, _gefe, _काका_, ויך_,
   {{0x69c19532,0x2d8c0370,0x7bcb8812,0x6da30ae7}},	//   mble, åde_, _kegu, дира,
   {{0x644d1523,0xe3ba067c,0x62851533,0x76a0077f}},	//   ghai, рба_, elho, _báyì,
   {{0xe7ff8b04,0x764380dd,0xd0420085,0x764b0084}},	// [a40] ोजना_, kkny, xslə, _įgyv,
   {{0x7bcb9534,0xa7fb04c3,0x69c19535,0x25fb8bb8}},	//   _legu, riñe, nble, ल्मी_,
   {{0x644d1523,0x60c70282,0x03a60e97,0x6aa381b9}},	//   bhai, _cwjm, _мино, _minf,
   {{0x644d1536,0xef1a9537,0x6edb83eb,0xa7fb002a}},	//   chai, име_, _निशु, piñe,
   {{0x7c261538,0x2f189539,0x63b40035,0x386d89c4}},	//   _inkr, соль_, ągną, _djer_,
   {{0x644402a3,0x386d813c,0x6aa3953a,0x78a407b8}},	//   lkii, _ejer_, _ninf, _liiv,
   {{0x69ca953b,0x3af4039c,0xdd9381e5,0x69c182c4}},	//   _refe, läp_, машы, dble,
   {{0x6444153c,0xdee6953d,0x69ca953e,0x69c1953f}},	//   nkii, _моби, _sefe, eble,
   {{0x7e7c1540,0x16668098,0x9e669541,0x213e8114}},	//   korp, _двам, _двад, wyth_,
   {{0x7af601e2,0x76439542,0x645f05e7,0x7bcb8091}},	//   ityt, ckny, ziqi, _eegu,
   {{0x7c261543,0x6e371544,0x3a3800b9,0x644d1545}},	//   _onkr, _roxb, _morp_, yhai,
   {{0x69ba83eb,0x6aa39546,0x644d01c5,0x7bcb9547}},	//   _श्री, _einf, xhai, _gegu,
   {{0xdefb0196,0x09d500ab,0x44269548,0x64440079}},	//   шын_, স্টা, _ino_, dkii,
   {{0x44269549,0x3f850029,0x7c26154a,0x46dc154b}},	//   _hno_, ālu_, _ankr, _बिरह,
   {{0x644d154c,0x6607154d,0x7bcb954e,0x3495154f}},	//   thai, rejk, _yegu, завр,
   {{0xe019853e,0x68e89550,0x4426808e,0x8cdc12c6}},	//   _नोंद_, mudd, _jno_, _फिरो,
   {{0xa3e89551,0x68e89552,0x644d1553,0xb0660009}},	// [a50] _बाई_, ludd, rhai, stää,
   {{0x7c260353,0x09e300ab,0x65950139,0x387f9554}},	//   _enkr, ন্না, _напу, _skur_,
   {{0xdb098013,0x3a38037a,0x68e89555,0xceb981d0}},	//   iceá, _dorp_, nudd, _stř_,
   {{0x26c90010,0x44268365,0x670081bc,0x645f1556}},	//   _kwao_, _nno_, _ịkag, qiqi,
   {{0x7bcb9557,0x645d1558,0x68e89559,0x870780d7}},	//   _regu, _imsi, hudd, تبال,
   {{0x4426955a,0x4439120b,0x68e8955b,0x2cac955c}},	//   _ano_, _hos_, kudd, _budd_,
   {{0x4439155d,0x7bcb955e,0x7643955f,0x6aa38d02}},	//   _kos_, _pegu, rkny, _rinf,
   {{0x44391560,0x387f885c,0x7643808e,0x44268706}},	//   _jos_, _ukur_, skny, _cno_,
   {{0x44391561,0x9f4f8e1b,0xab659562,0x27ff8122}},	//   _mos_, regó_, явил, _ibun_,
   {{0x44391563,0x44269564,0x7e55803f,0x68e88c2e}},	//   _los_, _eno_, _عناص, fudd,
   {{0x2cac9565,0x7bcb9566,0x3ead9567,0x69c19568}},	//   _gudd_, _tegu, _huet_, rble,
   {{0x44d7802e,0xe8df001c,0xbbaa1370,0x69c18192}},	//   mă_, _chứa_, _कलेक, sble,
   {{0x7d1e09cf,0x644b9569,0x44d7802e,0x2fcd81c0}},	//   _srps, _ilgi, lă_, _meeg_,
   {{0x2fcd956a,0x4439156b,0x68e8956c,0x629d801b}},	//   _leeg_, _aos_, budd, ůsob,
   {{0x44d78012,0x7ae9956d,0x44268114,0x78a4156e}},	//   nă_, luet, _yno_, _tiiv,
   {{0x4426040e,0x2fcd90af,0x4439156f,0x5baa1570}},	//   ño_, _neeg_, _cos_, скам_,
   {{0x44391571,0x78bb003b,0xe9da11b1,0x64440079}},	// [a60] _dos_, _čuva, йка_, rkii,
   {{0xa7fb04c3,0x64441572,0x7c399106,0x27ff8041}},	//   miña, skii, _lowr, _abun_,
   {{0xe821035a,0xe8fa12e1,0x7af61573,0xa3e50f12}},	//   याचा_, сле_, styt, _नाच_,
   {{0xa3ea800c,0x1bea809a,0x44391574,0xafdb0257}},	//   _टाइप_, _टाइल_, _gos_, lhør,
   {{0x9cf880ab,0x7bc41575,0x2fcd9576,0xdfcf80a0}},	//   _আছেন_, mbiu, _deeg_, ايه_,
   {{0x443901c5,0x644b8084,0x44268b81,0x412a1577}},	//   _zos_, _algi, _sno_, _лого_,
   {{0xe7ed035a,0x44390282,0x44d78087,0x69dc00e8}},	//   _झाला_, _yos_, gă_, _idre,
   {{0xb6038029,0x44391578,0x68e302ba,0x69ce1579}},	//   ēšan, _xos_, ánde, _hebe,
   {{0x69ce0393,0x7ae9957a,0x7ae41434,0x66e3957b}},	//   _kebe, guet, nrit, _пота,
   {{0x64aa800d,0x69ce06ec,0x78ad957c,0x25fb80d4}},	//   _přid, _jebe, _čavr, ल्दी_,
   {{0x69ce157d,0x44d78012,0x6e28813c,0x7ae402af}},	//   _mebe, că_, _indb, hrit,
   {{0x4426957e,0x69ce157f,0x68e89580,0x5f1383ca}},	//   _uno_, _lebe, rudd, _धनम्_,
   {{0x69dc0025,0x44391581,0x68e89582,0x7ae98661}},	//   _odre, _ros_, sudd, cuet,
   {{0x8cb109a3,0x69ce1583,0xc6a41584,0x6266845a}},	//   _आंदो, _nebe, ерси, _عاشق,
   {{0x92e900c8,0x44391585,0x7ae40074,0x6fcc816f}},	//   _মনে_, _pos_, erit, ारां,
   {{0x69dc1586,0x7ae41587,0x765e1588,0x69ce011b}},	//   _adre, frit, _empy, _aebe,
   {{0x44391589,0x69ce158a,0x44d78012,0xe3b007bd}},	// [a70] _vos_, _bebe, ză_, ارف_,
   {{0x19ab03a7,0x4439158b,0x6d5909ab,0x200b158c}},	//   стап_, _wos_, _ƙwad, leci_,
   {{0x69ce158d,0x4439158e,0x3947158f,0x7ae400e5}},	//   _debe, _tos_, áns_, arit,
   {{0x44d78087,0x645d01f6,0x4add8d86,0x2fcd822c}},	//   vă_, _umsi, _मिलव, _qeeg_,
   {{0x3ea58074,0x24891217,0x2fc08333,0x66171590}},	//   _pilt_, mlam_, ñiga_, _kaxk,
   {{0x69ce1591,0x44d78012,0x1dbf0f97,0x6e3a8362}},	//   _gebe, tă_, ्रित, _cotb,
   {{0x7bcf059c,0x78a2826f,0x661702a3,0x7c39809a}},	//   _kecu, ňova, _maxk, _powr,
   {{0x44d78012,0x3ea58613,0x200b120e,0xa01b016d}},	//   ră_, _wilt_, jeci_, slöj,
   {{0x44d7802e,0x4add816f,0x1dbf016f,0x7bcf1592}},	//   să_, _मिळव, ्रात, _mecu,
   {{0xe0d99593,0x39459594,0x2d85809a,0x44d78087}},	//   ово_, дног, _tyle_, pă_,
   {{0x24891595,0x69c501e4,0x7ae401ac,0x7ae98cdb}},	//   klam_, ibhe, zrit, suet,
   {{0xb9220870,0x25c601cb,0x7bcf0087,0xa7fb002a}},	//   _akpọ_, वर्ण, _necu, tiña,
   {{0x6d439596,0xba558081,0x99830196,0x00000000}},	//   lyna, _откъ, _kojų_, --,
   {{0xc87902bb,0xa7fb04c3,0x09e300ab,0xdb218216}},	//   duğu_, riña, ন্তা, _ñuño,
   {{0xbea31597,0x7bcf1598,0x9872016b,0xa7fb03a8}},	//   тарк, _becu, láč_, siña,
   {{0x69ce1599,0xd9f0159a,0xd7ff002e,0x7e63826c}},	//   _sebe, _चाहत_, şări_, hinp,
   {{0x78ae159b,0x64bc0024,0x78bc026c,0x7bcf159c}},	// [a80] _subv, _očig, _strv, _decu,
   {{0x7ae4159d,0x2489159e,0x1cba003f,0xe8df001c}},	//   rrit, alam_, _واجب_, _chữa_,
   {{0xdb1d01df,0xfbc6159f,0x7bcf15a0,0x2d9615a1}},	//   _xesú, _обно, _fecu, _юрис,
   {{0xab2a153d,0x31368158,0x248915a2,0x7d1c808b}},	//   _дома_, ונעם_, clam_, _ársi,
   {{0x69ce15a3,0x09e300ab,0x394601a9,0xe73795a4}},	//   _tebe, ন্ধা, ņos_, мец_,
   {{0x69dc15a5,0x65948162,0xdcba95a6,0x69ce0192}},	//   _udre, налу, ощи_, _uebe,
   {{0x0ee0835a,0x2df980d7,0x6935128a,0xdb060646}},	//   _निवड, سبوک_, _přeš, _afkø,
   {{0x3218008e,0x25de0d14,0xdb1d0511,0x64aa801b}},	//   _hary_, कृती_, _resú, _přib,
   {{0x41e68d13,0xa3c10074,0xc5e600ab,0x25fb95a7}},	//   міна, ुरत_, খ্যা_, ल्ही_,
   {{0xd25095a8,0xd62695a9,0x6d4395aa,0x2fc680e4}},	//   اند_, _تعري, byna, lbog_,
   {{0x6d4395ab,0xc87f0192,0xa01b0198,0x321801c6}},	//   cyna, toß_, llöi, _mary_,
   {{0xa3e8800d,0xc32a80f7,0xb9068af3,0xd5b1827d}},	//   _बाट_, _وكان_, _पि_, _tác_,
   {{0xa2d88105,0xdca395ac,0xd78b00f7,0x7bcf15ad}},	//   _मिट्, _раци, تخدم_, _recu,
   {{0x200b0025,0x386015ae,0x3eb985a4,0x7bcf079a}},	//   seci_, _emir_, _éste_, _secu,
   {{0x38b701cd,0x248915af,0x6d550037,0x320c95b0}},	//   _oħra_, tlam_, uzza, medy_,
   {{0xa7fb04c3,0xd49815b1,0xfc150071,0x28d815b2}},	//   miño, дру_, эмбэ, _डिजि,
   {{0x7bcf00eb,0x6d43809a,0x2fc6806a,0x32180a7a}},	// [a90] _vecu, zyna, dbog_, _bary_,
   {{0x321815b3,0x248915b4,0xae0082f1,0xa2b00a27}},	//   _cary_, slam_, ल्मन_, _अंर्,
   {{0xa3c38b6f,0x1bd515b5,0x24890214,0x69c5125b}},	//   ्रम_, _поня, plam_, rbhe,
   {{0x3f8904b9,0x61fe1384,0x2fc695b6,0x64bc0362}},	//   _kyau_, afpl, gbog_, _dčid,
   {{0xe4560159,0xdb028028,0xa3e88fb2,0x320c81ac}},	//   _נישט_, _ngoà, _बाज_, kedy_,
   {{0x2451827f,0x7aed03ac,0x46e082f1,0x645a01a9}},	//   _máme_, muat, _निरह, ītie,
   {{0x7aed0be5,0x82b881bc,0xc98415b7,0x7e6395b8}},	//   luat, _rịịl_, _аути, rinp,
   {{0xe7f9800d,0xdb1d0b40,0xa19415b9,0xa3c10697}},	//   _एउटा_, _besø, _расч, ुरि_,
   {{0x442b06cb,0x7e6395ba,0x2ef48098,0x25a9803d}},	//   _mnc_, pinp, _изтр, _فضای_,
   {{0x442b0122,0x291e0084,0x850f001b,0x4ae2052a}},	//   _lnc_, _štai_, ाबाट_, _पिसव,
   {{0x7aed15bb,0xa3c115bc,0xf8660a13,0x3f8909ab}},	//   huat, ुरा_, евно, _ayau_,
   {{0x7aed15bd,0x66e615be,0x9ac48372,0xdee615bf}},	//   kuat, нома, _boċċ, номи,
   {{0xe801835a,0x7aed15c0,0x7c2b95c1,0x64498192}},	//   ळ्या_, juat, _ingr, mkei,
   {{0x443d8051,0x78a995c2,0x95860088,0x442b15c3}},	//   _how_, _liev, елге, _anc_,
   {{0xa7fb062f,0x628195c4,0xda020a0d,0x26d915c5}},	//   ciño, molo, र्फत_, asso_,
   {{0x7aed022e,0x628195c6,0x78a995c7,0x7c3d00b9}},	//   fuat, lolo, _niev, _cosr,
   {{0x3b070698,0xae008e5b,0xfe720065,0x2c01809a}},	// [aa0] нето_, ल्डन_, _مدد_, व्यू_,
   {{0x9b9300f7,0x443d8039,0x98d38ad5,0xb77b01c6}},	//   الكت, _low_, _दबाए, _מאפש,
   {{0x26c0120e,0x644995c8,0x61fe016d,0x7c2b95c9}},	//   _htio_, kkei, rfpl, _ongr,
   {{0x672415ca,0x443d8051,0xdfcf8013,0x7aed09ca}},	//   _krij, _now_, ميم_, buat,
   {{0x78a995cb,0x91fc80eb,0x7bd615cc,0x7aed15cd}},	//   _diev, onāt, mayu, cuat,
   {{0x25fb901b,0x7c2b95ce,0x628195cf,0x7bd615d0}},	//   ल्ली_, _angr, jolo, layu,
   {{0xa3e40740,0xafe695d1,0x291e01fa,0x7c3d0748}},	//   _नया_, _повл, _éta_, _yosr,
   {{0x64498352,0x98a395d2,0x78a995d3,0x7bd615d4}},	//   gkei, _бисе, _giev, nayu,
   {{0x0edc01ce,0x7afb90c1,0xdb1981ec,0x68e10106}},	//   _बिगड, gtut, _gewü, _åldr,
   {{0x628195d5,0x27e015d6,0x7bd615d7,0xef178110}},	//   golo, _adin_, hayu, _яму_,
   {{0x694680fe,0xa3b3801b,0x7afb8cdb,0x320c95d8}},	//   _očeš, जुङ_, atut, redy_,
   {{0x44fa88cf,0x672415d9,0x661a826c,0xa7fb05e4}},	//   më_, _brij, _hatk, riño,
   {{0x62818042,0xff0415da,0x44fa80f1,0x672415db}},	//   bolo, лярн, lë_, _crij,
   {{0x661a8364,0x672403e9,0x27e015dc,0x442b047f}},	//   _jatk, _drij, _edin_, _snc_,
   {{0x44fa88cf,0x661a95dd,0x25a500f2,0x7c3d0805}},	//   në_, _matk, äll_, _posr,
   {{0x6d588353,0x27e0017f,0x672415de,0x7aed15df}},	//   izva, _gdin_, _frij, tuat,
   {{0xc6a715e0,0x672415e1,0x44fa80f1,0x6aaa95e2}},	// [ab0] _прои, _grij, hë_, _kiff,
   {{0x78a98029,0xda7815e3,0x44fa80f1,0x6aaa81b9}},	//   _siev, нях_, kë_, _jiff,
   {{0xdd9115e4,0x78a98029,0x7aed0867,0x44fa820f}},	//   _خود_, _piev, suat, jë_,
   {{0x644f15e5,0x648580f7,0x7aed15e6,0x44fa83ed}},	//   _ulci, hóir, puat, dë_,
   {{0x628195e7,0x661a8267,0xdb070009,0x44fa81b0}},	//   yolo, _batk, ämäs, eë_,
   {{0x443d95e8,0x628195e9,0x99d40154,0x9f4f8077}},	//   _sow_, xolo, _متفا, nggé_,
   {{0x628195ea,0x92a60063,0x648580f7,0xdd918065}},	//   volo, _dołą, dóir, گوں_,
   {{0x628195eb,0x7afb8098,0x38668087,0xed6404e8}},	//   wolo, ttut, cior_, loží_,
   {{0x644995ec,0xdd918065,0x661a8168,0x200f95ed}},	//   rkei, دوں_, _fatk, megi_,
   {{0x7afb95ee,0x644995ef,0x69d704c3,0x200f95f0}},	//   rtut, skei, naxe, legi_,
   {{0x7afb95f1,0x6aaa8806,0x672402fd,0xa3c380c2}},	//   stut, _diff, _srij, ्रद_,
   {{0x672415f2,0x20040a56,0xa3d284c5,0xd5648638}},	//   _prij, ými_, वरण_, _ступ,
   {{0x628195f3,0x6aaa95f4,0x6e3e01a1,0xddd8807a}},	//   polo, _fiff, _popb, lovš,
   {{0x672415f5,0x248d95f6,0x63bb8098,0xfce615f7}},	//   _vrij, llem_, lcun, кого,
   {{0x6b8b95f8,0x7ae995f9,0x7bd615fa,0xe81d15fb}},	//   _hygg, lret, tayu, _बोका_,
   {{0xc9528051,0x27e0015d,0x15ee0035,0x7bc98d35}},	//   _כמו_, _udin_, _जाकर_, nbeu,
   {{0xdca315fc,0x64a30110,0xcb6715fd,0x0b4315fe}},	// [ac0] рати, рата, вате_, антн,
   {{0x7bd604a7,0x7ae9802a,0x6b8b92f1,0xbea615ff}},	//   sayu, iret, _mygg, _шапк,
   {{0x661a8009,0xfe370039,0xa3c3873c,0x249f9600}},	//   _ratk, _סרטי_, ्रा_, kmum_,
   {{0x69469601,0x628700b9,0xddd8824a,0x44fa8168}},	//   _učeš, _ekjo, dovš, vë_,
   {{0x248d9602,0x92a6009a,0x69ca008b,0x38669603}},	//   dlem_, _połą, ðfes, rior_,
   {{0x44fa88cf,0x7ae98620,0x68e88114,0x629d9412}},	//   të_, dret, yrdd, ïsol,
   {{0x81d780ab,0x38668106,0x7ae99604,0x200f9605}},	//   িলা_, pior_, eret, begi_,
   {{0x44fa88cf,0x6aaa9606,0x43948b69,0x291800a4}},	//   rë_, _siff, лайс, _isra_,
   {{0x44fa88cf,0x661a8359,0x6d47009a,0x648580f7}},	//   së_, _tatk, zyja, tóir,
   {{0x91fc8029,0x5ea68b76,0x3eb985a4,0x60c49607}},	//   ciāl, _شمال, _ésta_, _čimb,
   {{0x67229608,0x248d9609,0x648580f7,0xb6a38162}},	//   lvoj, blem_, róir, _тифл,
   {{0xdb04160a,0x7ae9960b,0x4bda819f,0x648581a8}},	//   nció, bret, _آباد_, sóir,
   {{0x7336845b,0xf09f023e,0x7ae9960c,0xdb040333}},	//   _جرائ, rmà_, cret, ició,
   {{0x52d78039,0x201b00dd,0xceb383c8,0x200f960d}},	//   _יודע_, _waqi_, ייש_, zegi_,
   {{0x4fc70652,0x984f009a,0x3eac8aa2,0x201b0187}},	//   _испа, jęć_, _midt_, _taqi_,
   {{0x3eac8022,0x62870370,0x57f5160e,0x3dd88264}},	//   _lidt_, _skjo, _спит, _সাফল,
   {{0xb275160f,0x3a750162,0x2d8c9610,0x667200d7}},	// [ad0] глаш, глар, _lyde_, شگیر,
   {{0x6722803a,0x68e302ba,0x7aef809f,0x78ad01c0}},	//   dvoj, ándo, àcti, _hiav,
   {{0x200f9611,0xa3d28076,0xf1a71612,0x2d8c8366}},	//   tegi_, वरा_, тран, _nyde_,
   {{0x25ff05fc,0x69d71613,0x69ca007b,0xa01b1614}},	//   श्री_, saxe, ðfer, mlös,
   {{0x7c2f1615,0x200f9616,0x64aa801b,0xd6db9617}},	//   _incr, regi_, _přin, фте_,
   {{0xe29a8104,0xdb04040e,0x6b8b8bfa,0x644d0364}},	//   _như_, ació, _rygg, lkai,
   {{0x91fc8029,0x62851618,0x58d41619,0x30a7961a}},	//   riāl, moho, _вост, _арав,
   {{0xdb04161b,0x69d5161c,0x6285161d,0xc1720039}},	//   cció, _heze, loho, _החל_,
   {{0x69d50065,0x248d961e,0x6f098754,0xac9680f7}},	//   _keze, rlem_, _upec, دنيا_,
   {{0x7ae9961f,0x3f7a8158,0x69d51620,0x63bb9621}},	//   rret, _אָבע, _jeze, scun,
   {{0x10a600c4,0x644d0009,0x69d51622,0x2ba483db}},	//   лион, kkai, _meze, खेबा,
   {{0xcea9093f,0x69d51623,0x7ae98558,0xf99204de}},	//   _זי_, _leze, pret, מרי_,
   {{0x442f896c,0xe28e9624,0x78ad1625,0x643a81c6}},	//   _ing_, _га_, _diav, _רעננ,
   {{0x69d51626,0xa01b01ec,0x7c2f1627,0x644d0196}},	//   _neze, flös, _ancr, ekai,
   {{0xa5070fbf,0x2d8c013c,0xed5a1628,0xdb0b806a}},	//   лера_, æde_, хов_, _afgø,
   {{0x7c3b8886,0x644d1629,0x442f962a,0x78ad162b}},	//   njur, gkai, _jng_, _giav,
   {{0x69d5162c,0x28d78f97,0x33d5021e,0x2ca002f1}},	// [ae0] _beze, _भौति, ріст, rmid_,
   {{0x64560578,0x442f820d,0x62851486,0x2ca0162d}},	//   shyi, _lng_, goho, smid_,
   {{0x442f962e,0x69d5162f,0x4fea9630,0x00e61631}},	//   _ong_, _deze, емен_, ужен,
   {{0x6493029a,0x442f85ee,0xf3f98493,0x644d0196}},	//   nçil, _nng_, biţi_, ckai,
   {{0xdb040c15,0x44201632,0x62851633,0xbe8a9634}},	//   rció, mdi_, boho, нске_,
   {{0x442f9635,0x69d51636,0x20d18390,0x67229637}},	//   _ang_, _geze, kši_, rvoj,
   {{0xdb04040e,0x442f862f,0x20d18db7,0x78b502a5}},	//   pció, _bng_, jši_, _guzv,
   {{0x33269638,0x661e0110,0x26c69639,0x44de81b9}},	//   _prox_, _lapk, ppoo_, rċ_,
   {{0x76418065,0x4420163a,0x442f963b,0x78ad047f}},	//   _foly, idi_, _dng_, _riav,
   {{0x7641831d,0x78a2963c,0x644d011e,0x4420163d}},	//   _goly, lmov, zkai, hdi_,
   {{0xd48f963e,0x1994963f,0x2d8c009a,0x7413803d}},	//   _гр_, раня, żdej_, _گونا,
   {{0x4d7b8f60,0x44201640,0x78a28333,0xd0e5800c}},	//   _ארבע, jdi_, nmov, _किरण_,
   {{0xa2b005e8,0xead49641,0x44201642,0xe29a8028}},	//   _अंग्, _толь, ddi_, _thư_,
   {{0x44201643,0x98bc001b,0x2bd2940d,0x64429151}},	//   edi_, ávě_, सरवा, _hooi,
   {{0x69da9644,0x442f8355,0x644d0364,0x78a28353}},	//   mate, _yng_, tkai, kmov,
   {{0x69da9645,0x78a280ce,0x44201646,0xa01b1647}},	//   late, jmov, gdi_, rlös,
   {{0x644d0483,0x644282d8,0x90980c48,0xa01b12d2}},	// [af0] rkai, _mooi, _حضور_, slös,
   {{0x644d1648,0x629c0c3f,0x44201649,0x7d1a964a}},	//   skai, _chro, adi_, _osts,
   {{0x21270104,0x69d5164b,0x442002a3,0x3915164c}},	//   ính_, _veze, bdi_, рмер,
   {{0x644290f4,0x69d5164d,0x69da964e,0x628500b4}},	//   _nooi, _weze, hate, soho,
   {{0x7bda0496,0xfe7f023e,0x2d9c01d6,0xf6e7964f}},	//   _בקרו, buït_, _úver_, уцен,
   {{0x20d71650,0x7aed1651,0xf6259652,0x4e00864a}},	//   _مترج, mrat, рдко, ल्लई_,
   {{0xe3b18307,0x69da9653,0xa3b91094,0x76419654}},	//   يرة_, date, _चला_, _voly,
   {{0x20d1803b,0x6ee780d5,0x1309835f,0x7bcd1655}},	//   vši_, _مسئل, вний_, nbau,
   {{0x7c3b9656,0x92020054,0x69da8428,0x64429657}},	//   rjur, र्वज_, fate, _dooi,
   {{0x2480803b,0x7aed1658,0x212789da,0xf41f016d}},	//   čima_, irat, _prnh_, _skäl_,
   {{0x44201659,0x6493080a,0xdddc025b,0x27e0808b}},	//   ydi_, tçil, jorš, ðing_,
   {{0x442f965a,0x186a0153,0x20d193cf,0x6729965b}},	//   _ung_, тами_, rši_, _krej,
   {{0x69da965c,0x442001b9,0x7aed026c,0x6c8481a8}},	//   bate, vdi_, jrat, _النم,
   {{0x69da8039,0xfed780ab,0x8cb10035,0x78a284e8}},	//   cate, _সমাধ, _आंखो, zmov,
   {{0xada6165d,0xdb1207ca,0x4420011c,0x6da614b8}},	//   равл, _ágús, tdi_, рива,
   {{0x4420165e,0x3b00022b,0x6729965f,0x2b099660}},	//   udi_, ttiq_, _orej, _वहाँ_,
   {{0x44201661,0x5baa06d2,0xfe7f0722,0x62661662}},	// [b00] rdi_, ткам_, tuït_, аваа,
   {{0x2bb80076,0x09e61663,0x2243026c,0x91e600bf}},	//   _अलवा, рожн, _cojk_, роже,
   {{0x2cf49664,0x290100f7,0x44201665,0x78a29666}},	//   _इमेल_, gtha_, pdi_, tmov,
   {{0x67299667,0x69da9668,0x44201669,0x64aa928a}},	//   _brej, zate, qdi_, _přim,
   {{0x2bd301fe,0x629c0051,0x78a2826f,0x69da966a}},	//   तररा, _thro, rmov, yate,
   {{0x672988cf,0xa11600d7,0x69da966b,0x2901166c}},	//   _drej, _پورت, xate, btha_,
   {{0x69da966d,0x2508819f,0xafdb0aa2,0x320a0118}},	//   vate, ارتی_, ljøe, _ibby_,
   {{0x69da966e,0x67299554,0x6d4a966f,0x249d9670}},	//   wate, _frej, ryfa, _chwm_,
   {{0x67299671,0x69da9672,0xa2b38198,0xd1ca9673}},	//   _grej, tate, обыч, кунд_,
   {{0x38ba9674,0x6f029675,0x16639676,0x32549677}},	//   _për_, mtoc, _двум, свор,
   {{0xa3d60816,0x6f0d1678,0x672980e1,0x91a980ff}},	//   हरा_, _spac, _zrej, _đã_,
   {{0x69da9679,0x64bc0088,0xa3c38eb6,0x7aed0071}},	//   sate, _pčin, ्रः_, yrat,
   {{0x69da967a,0x98be8196,0xfe7f0980,0x00000000}},	//   pate, dytą_, duïr_, --,
   {{0x7aed07aa,0x9f4002af,0x2d840214,0x69d8007b}},	//   vrat, _weiß_, ğmen_, ðvel,
   {{0x0467167b,0x25fb9513,0x7aed0372,0x24920114}},	//   атам, ल्टी_, wrat, flym_,
   {{0x7aed167c,0x200900b9,0x6f02967d,0x69d8967e}},	//   trat, _ubai_, ktoc, _heve,
   {{0x7bcd167f,0x6f0d0397,0x64aa801b,0x69d89680}},	// [b10] rbau, _upac, _přij, _keve,
   {{0x62888114,0xe9ab07d2,0x35f50a13,0x290100b9}},	//   nodo, ندان_, _упор, ttha_,
   {{0xdfd180f7,0x69d88722,0x38690506,0x66151681}},	//   كيا_, _meve, _kmar_, mezk,
   {{0x69d89682,0x67299683,0x62889684,0x7aed1685}},	//   _leve, _prej, hodo, prat,
   {{0x53350158,0x29011686,0xdefb8198,0x48dd8074}},	//   _האָב_, stha_, тые_, _कौनो_,
   {{0x9e648cde,0xb6079687,0x69d89688,0xddc3802e}},	//   овід, рядк, _neve, dinţ,
   {{0x7ae280eb,0x62889689,0xd469968a,0x48ab81e5}},	//   _avot, dodo, лике_, _атам_,
   {{0xeb99968b,0x6729968c,0xfd5501bc,0xdd2801a9}},	//   лий_, _trej, _slaị, nēša,
   {{0x69d8968d,0x67298353,0x9f44080a,0x62888114}},	//   _beve, _urej, ümü_, fodo,
   {{0x38690727,0x2fdd822c,0x69d8968e,0x00000000}},	//   _amar_, lawg_, _ceve, --,
   {{0x69d8968f,0xf5958013,0x8d958013,0x6615011e}},	//   _deve, _الاج, _الاش, dezk,
   {{0x20560a14,0xa856038c,0x3d01809a,0x6e219690}},	//   стор, стој, mów_, _halb,
   {{0x6e219691,0x62889692,0x41a7016f,0x443f9693}},	//   _kalb, bodo, केतस, mju_,
   {{0x69d882d8,0x6615011b,0xb6cc8380,0x645b9694}},	//   _geve, gezk, _şükü, lhui,
   {{0x3d018063,0x7bd983ac,0xc69283c8,0x443f8084}},	//   nów_, _kewu, פאל_, oju_,
   {{0x645b9695,0x69d89696,0x78a38cfa,0xd5b18129}},	//   nhui, _zeve, ïnvl, _cái_,
   {{0x7bd98057,0x04431697,0x3aba80be,0x03a30d91}},	// [b20] _mewu, четн, ָמענ, зито,
   {{0x3d018d38,0x64bc0fda,0x443f8074,0x3f920300}},	//   ków_, _učio, hju_, _iyyu_,
   {{0x24891698,0x499a0a14,0x3d018035,0x645b9699}},	//   boam_, утая_, jów_, khui,
   {{0x7bd989b6,0x3d01809a,0x6e21813c,0x6f02969a}},	//   _newu, dów_, _aalb, ttoc,
   {{0x443f969b,0xf3ff80ab,0x645b969c,0x8bff80ab}},	//   dju_, ্যার_, dhui, ্যান_,
   {{0x4422059e,0x7c24169d,0x443f969e,0x6446169f}},	//   _hak_, ldir, eju_, _hoki,
   {{0x6f0296a0,0x44220988,0x644601e2,0x7bd996a1}},	//   stoc, _kak_, _koki, _bewu,
   {{0x44221308,0x7c24158a,0x644616a2,0xa3a980bc}},	//   _jak_, ndir, _joki, _गृह_,
   {{0x442216a3,0x35fa845b,0x6e2181e4,0x64460110}},	//   _mak_, _مراد_, _falb, _moki,
   {{0xc333004c,0x69d8820f,0x6e2196a4,0x6e9696a5}},	//   פות_, _qeve, _galb, _الطا,
   {{0x443f96a6,0x3d01809a,0x78b88713,0xa3b90006}},	//   bju_, ców_, _quvv, _चलल_,
   {{0x442216a7,0x443f8699,0x645b96a8,0x69de16a9}},	//   _nak_, cju_, chui, hape,
   {{0x7645003e,0x628896aa,0x69d896ab,0x69de16ac}},	//   _pohy, podo, _teve, kape,
   {{0x3dd900c8,0x7aef86a5,0x7c22810c,0xdce500e1}},	//   _তাহল, ácte, _haor, _vzhľ,
   {{0x69de16ad,0x64aa800d,0xe57300f7,0x66150102}},	//   dape, _přih, سطس_, rezk,
   {{0x386916ae,0x7c2416af,0x60c781d0,0x2fdd822c}},	//   _umar_, gdir, íjme, xawg_,
   {{0x7c2296b0,0x644616b1,0x27e903c3,0x442216b2}},	// [b30] _maor, _doki, _idan_, _dak_,
   {{0x443f84b7,0x7b7400f7,0xb9210870,0x765c16b3}},	//   zju_, أطفا, _gasị_, chry,
   {{0x7c2416b4,0xbebd96b5,0x672d03c1,0xf6520039}},	//   bdir, _trūk, _hraj, _חצי_,
   {{0x442216b6,0x7c228052,0x64bc005c,0x6e2196b7}},	//   _gak_, _naor, _očij, _salb,
   {{0x443f96b8,0x69de16b9,0xe73996ba,0x3d018035}},	//   vju_, bape, рел_, wów_,
   {{0xdb1d04b8,0x3d018063,0x6e2196bb,0xc332010f}},	//   _besö, tów_, _qalb, _קום_,
   {{0x443f96bc,0x442216bd,0xed5996be,0xf53280a9}},	//   tju_, _yak_, рой_, дејќ,
   {{0x3d018063,0x6e2182a3,0x7bdf16bf,0x7c2296c0}},	//   rów_, _walb, naqu, _caor,
   {{0x443f96c1,0x3d018063,0x6e2196c2,0x645b83b2}},	//   rju_, sów_, _talb, rhui,
   {{0xe9d985f1,0x27e916c3,0xda6580e8,0x443f96c4}},	//   шко_, _adan_, івни, sju_,
   {{0x69c196c5,0x26c9008e,0x443f96c6,0xd94596c7}},	//   rcle, _atao_, pju_, цени,
   {{0x672d16c8,0x60cd8267,0x69de16c9,0x1faa05f1}},	//   _braj, _čamd, zape, икни_,
   {{0x442216ca,0x7bdf16cb,0xb69b16cc,0x644616cd}},	//   _rak_, daqu, rtân, _roki,
   {{0x442216ce,0x8aa796cf,0x672d16d0,0xb69b16cc}},	//   _sak_, _уред, _draj, stân,
   {{0x442216d1,0xa3bd835a,0x644601ac,0x69de16d2}},	//   _pak_, _आला_, _poki, vape,
   {{0x69de16d3,0x7c228118,0xdb1d041c,0x7c240037}},	//   wape, _xaor, _lesõ, udir,
   {{0xe9da16d4,0x7c2416d5,0x20050201,0xf41282f6}},	// [b40] ика_, rdir, əli_, ופן_,
   {{0x442216d6,0x22478a53,0x7c2416d7,0x4996066c}},	//   _wak_, _jonk_, sdir, ошет,
   {{0x69de16d8,0x6da616d9,0x644616da,0x8c4616db}},	//   rape, _фина, _toki, _дене,
   {{0xdd0f0214,0x7c24011c,0x9f4800ff,0x7bdf16dc}},	//   lışt, qdir, _điêu_, caqu,
   {{0x9eaa8ba1,0xcfbc00ab,0x245c0061,0x4ea696dd}},	//   авда_, _অজান, _címe_, орка,
   {{0xe29716de,0x7c22808c,0x412a16df,0x7ae401a8}},	//   _мая_, _saor, _кого_, msit,
   {{0x910315e0,0xf9878f24,0xd90d019f,0x7ae400f7}},	//   _опре, _آب_, _میل_, lsit,
   {{0x7bc416e0,0xfd530091,0x6ee381bc,0x7ae416e1}},	//   nciu, _aifọ, _ọber, osit,
   {{0x69dc01f9,0x6fd08105,0x7ae416e2,0x224796e3}},	//   _kere, _ड्यू, nsit, _bonk_,
   {{0x245181a8,0x20000362,0x442482f7,0x7ae416e4}},	//   _lámh_, _acii_, sdm_, isit,
   {{0x69dc045c,0x224796e5,0x26c902a5,0x7bdf16e6}},	//   _mere, _donk_, _stao_, yaqu,
   {{0x69dc16e7,0x672d16e8,0x7ae416e9,0xe0cf87d2}},	//   _lere, _praj, ksit, کزی_,
   {{0x7648808e,0xfd530032,0x674701e2,0x2005066f}},	//   _kody, _fifọ, цэнз, ęli_,
   {{0x248980e1,0x7bc616ea,0x76488242,0x672d16eb}},	//   čame_, _afku, _jody, _vraj,
   {{0x7bdf00e7,0xa3c80135,0x2bc80133,0x764896ec}},	//   taqu, _ọbịa_, _ọjị_, _mody,
   {{0x672d16ed,0xd6db0364,0x69dc0081,0x67209351}},	//   _traj, _кто_, _aere, _osmj,
   {{0x69dc16ee,0x201916ef,0x7ae400e4,0x7bdf16f0}},	// [b50] _bere, mesi_, gsit, raqu,
   {{0x201916f1,0x661896f2,0x69dc079a,0x7bc401e8}},	//   lesi_, jevk, _cere, aciu,
   {{0x69dc005f,0x7bdf16f3,0xc0158009,0x7d0d8035}},	//   _dere, paqu, змещ, łasz,
   {{0x765a96f4,0x201916f5,0x78bc16f6,0x7ae416f7}},	//   _alty, nesi_, _durv, bsit,
   {{0x2ca916f8,0x27e0807b,0x69dc16f9,0x7bdd02f9}},	//   mmad_, ðina_, _fere, _iesu,
   {{0x69dc16fa,0x7bdd16fb,0x518716fc,0x2ca916fd}},	//   _gere, _hesu, _дуба, lmad_,
   {{0xdfd596fe,0x7bdd0859,0x69c516ff,0xdb1b81df}},	//   _новы, _kesu, mche, rcuí,
   {{0x69c51700,0x7bdd1701,0x0b458081,0x7d7c00be}},	//   lche, _jesu, знин, ינוו,
   {{0x2bdc0076,0x7bdd1702,0x69dc1703,0x76d580f7}},	//   बरता, _mesu, _yere, _رياض,
   {{0x69dc1704,0x7bdd1705,0x69c51706,0x09af00ab}},	//   _xere, _lesu, nche, _চ্যা,
   {{0x69c51707,0x20191708,0x2c0c0054,0xdcef8084}},	//   iche, fesi_, ड्डू_, _įdėt,
   {{0x2458837d,0x7bdd01e2,0x315600be,0x20191709}},	//   _téma_, _nesu, פירן_, gesi_,
   {{0x2451970a,0x64aa81d0,0x2905970b,0x69cc970c}},	//   _námi_, _přiv, stla_, _द्वी,
   {{0xfe79801b,0x6e25170d,0x69c5170e,0x68e7082c}},	//   _svůj_, _cahb, jche, _ovjd,
   {{0x61e18364,0x2019026e,0x386d970f,0x7bdd1710}},	//   mall, besi_, _omer_, _besu,
   {{0x7ae41711,0x20191712,0x61e19713,0x248d81b0}},	//   tsit, cesi_, lall, noem_,
   {{0x69dc1714,0x7bdd006a,0x7bc40019,0x2d9e026f}},	// [b60] _pere, _desu, rciu, ťte_,
   {{0x7bc40098,0xba231715,0x27e200dd,0x78bc0612}},	//   sciu, ндук, lakn_, _purv,
   {{0x7ae41716,0x76488110,0xda0204c5,0x7bc41717}},	//   ssit, _rody, र्गत_, pciu,
   {{0x69dc1718,0x61e19719,0x7bdd171a,0x7ae4171b}},	//   _were, hall, _gesu, psit,
   {{0x61e1971c,0x387f816d,0xddcf801b,0x69c5171d}},	//   kall, _djur_, _řeše, bche,
   {{0x69c50098,0x78bc037b,0x61e1971e,0x7bdd09b6}},	//   cche, _turv, jall, _zesu,
   {{0x2019171f,0x20c18104,0x7bdd1720,0x7c261721}},	//   yesi_, _nói_, _yesu, _kakr,
   {{0x321a009a,0x9e66826a,0x7bdd03a8,0xadc30032}},	//   lepy_, _کارن, _xesu, _diẹd,
   {{0x66188038,0x61e19722,0x6720920e,0x20191723}},	//   pevk, fall, _usmj, vesi_,
   {{0x20191724,0x61e19725,0x7aef9726,0xe3bf1727}},	//   wesi_, gall, ácta, _maña_,
   {{0x20191728,0x60cd82a5,0x6e251729,0x69c3007a}},	//   tesi_, _čamc, _rahb, žneg,
   {{0x78a4172a,0x7c26172b,0x7ac6841c,0xe3a78019}},	//   _chiv, _nakr, _еске, _کشمی,
   {{0x2bd29513,0x61e1972c,0x2019172d,0xaa7b01d0}},	//   _ध्या, ball, resi_, _svým,
   {{0x7bdd0393,0x4426972e,0x61e1972f,0x80d200ab}},	//   _sesu, _hao_, call, _হিন্,
   {{0x4426803a,0x20c1801c,0x7bdd08e5,0x20191730}},	//   _kao_, _gói_, _pesu, pesi_,
   {{0x7c260cc0,0x9584009a,0xbebd96b5,0x6e2500b9}},	//   _cakr, _łącz, _krūt, _wahb,
   {{0xd6d78a49,0x4426951e,0x69c51731,0xe3bf06a5}},	// [b70] _সম্প, _mao_, tche, _caña_,
   {{0x44269732,0x27e08125,0x69c51733,0x386d9734}},	//   _lao_, ðinn_, uche, _smer_,
   {{0x69c506f8,0x7bdd1735,0x291906e2,0xfaa801a8}},	//   rche, _tesu, تقاد_, أهلي_,
   {{0x69c51736,0x44269737,0xd75980f7,0x61e19738}},	//   sche, _nao_, يلات_, zall,
   {{0x44291739,0x4439173a,0x69c5173b,0x61e1973c}},	//   mda_, _ins_, pche, yall,
   {{0x4439173d,0x7c260491,0x5fce8327,0x61e1973e}},	//   _hns_, _zakr, हुबल, xall,
   {{0x442902a3,0x44268028,0xc10515a9,0x7c3a0174}},	//   oda_, _bao_, _توزي, _úcrá,
   {{0x4429173f,0x44268104,0x61e19740,0xf53800be}},	//   nda_, _cao_, wall, לטור_,
   {{0x61e1855b,0x27ed9741,0xdb0982d0,0x20c18129}},	//   tall, _iden_, _önüm, _sói_,
   {{0x44291742,0x81bc81a9,0x25a0928a,0x7ea01743}},	//   hda_, ldēj, řila_, köpa,
   {{0x44391744,0x44291745,0x26cd82ee,0x61e19746}},	//   _ons_, kda_, _hteo_, rall,
   {{0x61e19747,0x44291748,0xd36e8077,0x2fdf867f}},	//   sall, jda_, اهی_, _jeug_,
   {{0x442912a8,0x61e19749,0xe28e974a,0xbebd80eb}},	//   dda_, pall, _аа_, _grūt,
   {{0x4439174b,0x4429174c,0x4426822e,0x6da609b8}},	//   _ans_, eda_, _zao_, дига,
   {{0x4426822e,0x7afb84a2,0x7c260110,0x27e200dd}},	//   _yao_, luut, _pakr, pakn_,
   {{0x4429174d,0x26cd825b,0x5ed380ab,0x442680ff}},	//   gda_, _oteo_, _সিনে, _xao_,
   {{0x1e860615,0x644b974e,0xeb97174f,0x7c299750}},	// [b80] _олим, _mogi, дит_, ider,
   {{0x44391751,0x44261752,0x645d1753,0x7c26004f}},	//   _ens_, žo_, _elsi, _wakr,
   {{0x44291754,0x661c1755,0x27e00352,0x7c261756}},	//   bda_, merk, _kein_, _takr,
   {{0x7c299757,0x7afb9758,0x442902a3,0x3ebf9759}},	//   jder, kuut, cda_, _buut_,
   {{0x27e00352,0x44268028,0x2fdf81e4,0xdd8f00d7}},	//   _mein_, _rao_, _deug_, _موی_,
   {{0x4426975a,0x27ed975b,0x7c29975c,0x27e0031d}},	//   _sao_, _eden_, eder, _lein_,
   {{0xda0e80ff,0x2ee680b9,0xa3aa01d0,0xa3cb175d}},	//   _bỏng_, ssof_, गेर_, रुव_,
   {{0xe9a3175e,0x6724175f,0x644b9760,0x27e010f6}},	//   _расп, _osij, _cogi, _nein_,
   {{0x1dcf863a,0x60cd8289,0x7afb9761,0x44269762}},	//   _स्वत, _čama, guut, _vao_,
   {{0x4426822e,0x2489805c,0xdb22809a,0x64aa801b}},	//   _wao_, čama_, _źród, _přis,
   {{0x44269763,0x09f70051,0x44291764,0xd48f8012}},	//   _tao_, ומים_, yda_, _ар_,
   {{0x442902a3,0xdbd604a2,0x7afb9765,0x26c0047f}},	//   xda_, _jääd, buut, _buio_,
   {{0x27e002af,0xfe730154,0x26c00118,0x6e2880b9}},	//   _dein_, ندس_, _cuio_, _kadb,
   {{0x44390eef,0x661c1766,0x44291767,0x63a29768}},	//   _sns_, gerk, wda_, _izon,
   {{0x44290085,0x27e01769,0x44390b99,0x6fde8006}},	//   tda_, _fein_, _pns_, मरां,
   {{0xd5b8176a,0xaa7b026f,0x7af60168,0x4429176b}},	//   ься_, _zvýh, fryt, uda_,
   {{0x6e3a83b2,0xa3aa016f,0xf0940039,0xfc3f0216}},	// [b90] _ontb, गेल_, _בנק_, _chía_,
   {{0x4429176c,0x6e28976d,0x27e0011e,0x7674176e}},	//   sda_, _nadb, _zein_, _альф,
   {{0x7c29976f,0x80e080ab,0x66051770,0xdb0d016a}},	//   yder, পূর্, _ichk, rcañ,
   {{0x44291771,0x44391772,0x245c0125,0x7af61773}},	//   qda_, _uns_, _tíma_, bryt,
   {{0x6e288079,0x22940106,0x6d550061,0xa3c29774}},	//   _badb, täkt_, lyza, ंशन_,
   {{0xe5a58e8e,0xceb8809a,0x603e8087,0x6da59775}},	//   нили, _cię_, _pămâ, нила,
   {{0x63a28065,0x61e51776,0xdc3a82d0,0x2ca68706}},	//   _azon, mahl, _açıs, _bhod_,
   {{0x03259777,0x27ed8022,0x69ca9778,0x61e51779}},	//   един, _uden_, _affe, lahl,
   {{0x7c29977a,0x27e0177b,0xe61082e3,0x661c177c}},	//   rder, _rein_, _چشم_, yerk,
   {{0x27e0177d,0x7c299045,0x63a2977e,0x3945977f}},	//   _sein_, sder, _dzon, еног,
   {{0x661c088b,0x7afb9780,0x9f4200d7,0x644b838a}},	//   verk, suut, maké_, _togi,
   {{0xed56893f,0x661c1781,0xe7308065,0x6e288035}},	//   _אבער_, werk, _حصہ_, _zadb,
   {{0x661c1782,0x443e001c,0x3a2786c0,0x61e50234}},	//   terk, _đt_, _tanp_, kahl,
   {{0xe3bf1783,0x64bc1784,0x2cad9785,0x7ae99786}},	//   _baño_, _očit, lmed_, mset,
   {{0x40960676,0x61e5010b,0xa97980be,0x7ae99787}},	//   _прит, dahl, _מאַכ, lset,
   {{0x46ea0698,0xe3bf06a5,0xfc3f001c,0x7bc99788}},	//   _един_, _daño_, _phía_, nceu,
   {{0x7ae99789,0x9f4203f8,0x27450168,0x3860178a}},	// [ba0] nset, kaké_, _vënë_, _ilir_,
   {{0x7ae9978b,0x2cad978c,0x9f42026f,0x99858019}},	//   iset, hmed_, jaké_, lelő_,
   {{0x7ae99266,0xf77f041c,0x50ba0060,0x6e28978d}},	//   hset, maça_, سداد_, _radb,
   {{0xceb88610,0x27e0978e,0x2002178f,0xe3a7845b}},	//   _się_, úin_, ngki_, _مر_,
   {{0xe8050c28,0x2cad8074,0x61e51790,0x7ae99791}},	//   ष्टा_, dmed_, bahl, jset,
   {{0x7ae99792,0xf77f023e,0x9c7c80c3,0xae040072}},	//   dset, naça_, _ivči, श्चन_,
   {{0xf653010f,0x6e28807a,0x7ae99793,0xa9a301a1}},	//   רצו_, _vadb, eset, _бирд,
   {{0x7ae99794,0x25a081d0,0x2bd3001b,0x69a51795}},	//   fset, řilo_, धुपा, _करती,
   {{0x6e2883ac,0x087780be,0x3f8188c5,0x7ae99796}},	//   _tadb, _נעמט_, şhur_, gset,
   {{0x27e69797,0xdb2381a8,0x38601798,0x3eba1799}},	//   laon_, órái, _alir_, _nipt_,
   {{0x3860179a,0xd5a484e5,0x88bc801b,0x67d500e8}},	//   _blir_, _ओरिज, jvět, кону,
   {{0x248000ce,0x27e6979b,0x61e5179c,0xa3b103dd}},	//   jnim_, naon_, zahl, टेड_,
   {{0x24800025,0x64bc179d,0xe784179e,0x3ce30072}},	//   dnim_, _očis, гуро, टीने_,
   {{0xbb3b8451,0x09e380ab,0xfc3f00ff,0xe3bf0388}},	//   _מעדי, _মাথা, _chín_, _paño_,
   {{0xceb380be,0x321e9122,0x27e68bb1,0x89338481}},	//   טיש_, mety_, kaon_, _معيا,
   {{0xd49814d6,0x6d55009a,0x321e89a4,0x61e5179f}},	//   еру_, ryza, lety_, wahl,
   {{0x200c0201,0x29180037,0x09e38264,0xf77f02df}},	// [bb0] ədi_, _apra_, _মাতা, baça_,
   {{0x7afd809f,0x248017a0,0x9e6701a8,0xa15917a1}},	//   àsti, anim_, _ساخن, мазу_,
   {{0xa3e08fd5,0xdfd180f7,0x61e517a2,0xf7730019}},	//   थरा_, ليا_, rahl, _جاں_,
   {{0x24800052,0x1b1780ab,0x2918008e,0xddc88bcf}},	//   cnim_, তিতে_, _dpra_, _ćoša,
   {{0xd9ad97a3,0x321e826f,0x7c2d17a4,0x58b881a8}},	//   _घण्ट, kety_, mdar, رامج_,
   {{0x7c2d17a5,0x7ae997a6,0x442b17a7,0x644f17a8}},	//   ldar, vset, _hac_, _hoci,
   {{0x644f17a9,0x64aa800d,0x64bc17aa,0xfc3180f7}},	//   _koci, _přip, _učit, لحة_,
   {{0x2489881d,0x7ae997ab,0x63a217ac,0xf3ff02df}},	//   čamo_, tset, żone, _imãs_,
   {{0x644f17ad,0x1c4297ae,0x9f42003d,0x2cad97af}},	//   _moci, рным, paké_, rmed_,
   {{0xa77480e9,0x7ae997b0,0x248000ce,0x7c2d17b1}},	//   _случ, rset, znim_, hdar,
   {{0x320b809a,0x442b0980,0x7c2d17b2,0x09e38264}},	//   ęcy_, _oac_, kdar, _মাদা,
   {{0x442b0114,0x7c2d17b3,0x7ae997b4,0x26df8135}},	//   _nac_, jdar, pset, _kwuo_,
   {{0x7c2d17b5,0x442d8b0b,0xf8b28158,0xe813816f}},	//   ddar, mde_, ישט_, ण्या_,
   {{0xf1b1053f,0x23690035,0xa3d40072,0x99858061}},	//   जधान, dzaj_, सुन_, selő_,
   {{0x1d070dae,0xfc3f0118,0x442b17b6,0x7c2b97b7}},	//   кери_, _chío_, _bac_, _kagr,
   {{0x644f040e,0x7c2d020d,0x442b17b8,0xc48310ca}},	//   _coci, gdar, _cac_, алск,
   {{0x7c2b97b9,0xa3e317ba,0xc0530039,0x628186cb}},	// [bc0] _magr, _नजर_, _כזה_, onlo,
   {{0x248002a5,0x442d8364,0x7c2b97bb,0x60c397bc}},	//   snim_, hde_, _lagr, _kunm,
   {{0x442b0012,0x27e69049,0x442d97bd,0x7c2d17be}},	//   _fac_, taon_, kde_, bdar,
   {{0x442d97bf,0x38608013,0xd00f8eca,0x7e6197c0}},	//   jde_, óir_, قلم_, _allp,
   {{0x442d97c1,0xe1e784c0,0x442017c2,0x27e697c3}},	//   dde_, _پس_, mei_, raon_,
   {{0x442017c4,0x442d97c5,0x290c8085,0x765c17c6}},	//   lei_, ede_, ytda_, nkry,
   {{0x442d90f4,0x614317c7,0x3cfd801b,0xa8068256}},	//   fde_, _кера, रूले_, _извл,
   {{0x6abb0118,0x409597c8,0x78bb97c9,0x442b027d}},	//   _éufr, _брут, _giuv, _xac_,
   {{0x68e1013c,0x26df819d,0xd7078087,0x799c0114}},	//   _ældr, _gwuo_, _инте_, _hyrw,
   {{0x386680a9,0x7c2b97ca,0x442017cb,0x7c2d17cc}},	//   lhor_, _eagr, hei_, zdar,
   {{0x442017cd,0x26c497ce,0xdd1f81ac,0x5ec780ab}},	//   kei_, _humo_, píšt, রীদে,
   {{0xf9930051,0x386683a7,0x68e31735,0x7c2b80d7}},	//   ירת_, nhor_, ândi, _gagr,
   {{0x442017cf,0x6d588110,0x260980d4,0x321e89a4}},	//   dei_, lyva, _सामी_, pety_,
   {{0x7c2b97d0,0xdce50038,0x27e4802e,0x61e397d1}},	//   _zagr, _vyhľ, _lemn_, _genl,
   {{0x644f0a7a,0x241901bb,0x61e897d2,0x40350a08}},	//   _poci, новы_, madl, _бейс,
   {{0xfbd304c0,0x69ce0a0f,0x7c2d14e4,0x442017d3}},	//   شتر_, _afbe, udar, gei_,
   {{0x521517d4,0x386697d5,0x644f17d6,0x6d4a0706}},	// [bd0] лдат, dhor_, _voci, _àfan,
   {{0x442d97d7,0xf09f009f,0xa2c381a2,0x78bb8084}},	//   zde_, llà_, रदत्, _siuv,
   {{0xf770096c,0x442017d8,0x21270104,0x6d5d8201}},	//   _های_, bei_, ình_, _əsas,
   {{0x61e897d9,0xcfde80c8,0x24868a20,0x442017da}},	//   hadl, _ডাউন, _njom_, cei_,
   {{0x442d97db,0xd9e386a7,0x61e897dc,0xdbd102f1}},	//   vde_, _ग़लत_, kadl, _müüd,
   {{0x442d97dd,0x6abc0609,0x26c482ed,0x6a6001fa}},	//   wde_, _girf, _dumo_, _höfn,
   {{0x7c2b97de,0x2609816f,0x61e897df,0x442d97e0}},	//   _pagr, _साठी_, dadl, tde_,
   {{0x6281862d,0x61e397e1,0x290117e2,0x26c497e3}},	//   wnlo, _senl, muha_, _fumo_,
   {{0x442d97e4,0x60c397e5,0x7aed11e6,0x78660693}},	//   rde_, _sunm, nsat, _jóve,
   {{0x442d9313,0xb7bd802e,0x78660073,0x672997e6}},	//   sde_, _naţi, _móve, _isej,
   {{0x61e397e7,0x7c2b97e8,0x26c497e9,0x290117ea}},	//   _venl, _tagr, _zumo_, nuha_,
   {{0x44e181e2,0xbf9b0073,0x442017eb,0x6f1b8133}},	//   mų_, rgên, xei_, _kpuc,
   {{0x442017ec,0x7866007b,0x44e18110,0x7bdb97ed}},	//   vei_, _nóve, lų_, mbuu,
   {{0x249f97ee,0x290117ef,0x442017f0,0x38ca8077}},	//   llum_, kuha_, wei_, بایی_,
   {{0x44e181e2,0x765c17f1,0x7cd180eb,0x7afb84dc}},	//   nų_, rkry, _dārg, lrut,
   {{0x765c079f,0x78660e15,0xa3e68105,0x290117f2}},	//   skry, _bóve, _बड़ा_, duha_,
   {{0xfc3f003e,0x7aed17f3,0xcb6717f4,0x64a3076a}},	// [be0] _dní_, gsat, гате_, сата,
   {{0x442017f5,0x44e181e2,0xfeba0277,0x6b9d031d}},	//   sei_, kų_, _ثابت_, _dysg,
   {{0x44e181e2,0x629e17f6,0x442017f7,0x249f97f8}},	//   jų_, rlpo, pei_, klum_,
   {{0x8c4617f9,0x7afb97fa,0x44e18110,0x6abc17fb}},	//   _семе, krut, dų_, _wirf,
   {{0x09e800ab,0x7aed1380,0x7e788b67,0xe3b2015b}},	//   _পাঠা, csat, tivp, _درد_,
   {{0x2ca017fc,0x290117fd,0x6d588084,0xb5e20264}},	//   llid_, buha_, tyva, _বাঁচ,
   {{0x386697fe,0x2cc981ac,0x61e897ff,0x44e18110}},	//   phor_, _ľudí_, vadl, gų_,
   {{0x7afb9800,0x260981c4,0x7bdb9801,0x26c49802}},	//   frut, _साथी_, gbuu, _tumo_,
   {{0x68f5803e,0x3075831f,0x61e89803,0x41e68221}},	//   ázdn, _турс, tadl, ліна,
   {{0x471b80be,0x39148329,0xdbd10074,0xfd5d8870}},	//   _אומג, амор, _süüd, _jizọ,
   {{0x3de2150b,0x26098e18,0x69da9175,0x2ca00074}},	//   _বাংল, _साती_, rbte, klid_,
   {{0x7aed02a3,0xfc3f001c,0x7afb9804,0x3ebe9805}},	//   ysat, _phím_, brut, _hitt_,
   {{0x543b8158,0x7afb9806,0x61e89807,0xf77f03a7}},	//   _רעדא, crut, padl, raço_,
   {{0x26e5000f,0xcf9381c6,0x6d498035,0x6a60008b}},	//   _कबीर_, מטר_, ślał, _söfn,
   {{0x3ebe9808,0xf77f0073,0x6d4a07b6,0xf09f0980}},	//   _mitt_, paço_, _àfal, plà_,
   {{0x3ebe8cde,0x248d1809,0x7aed180a,0x2ca002f1}},	//   _litt_, čemo_, tsat, glid_,
   {{0x3a75180b,0x78ad180c,0xb27501a1,0x998c0b80}},	// [bf0] алар, _ihav, алаш, _ćoše_,
   {{0x7aef840e,0x7ed40013,0x5ed380c8,0x7bcd180d}},	//   ácti, _ازيا, _সিলে, scau,
   {{0x7aed180e,0x66758077,0xf1a7180f,0xc9841810}},	//   ssat, یدتر, уран, буци,
   {{0x29011811,0x2c27035f,0x7aed1812,0x2ca01813}},	//   ruha_, _сьог, psat, clid_,
   {{0xb8170768,0xe81701b6,0xf7459814,0x26009815}},	//   ध्यम_, ध्या_, рело, _राखी_,
   {{0x62830259,0x44e181e2,0x09df00ab,0x7bc28176}},	//   čnos, tų_, _ঢাকা, _agou,
   {{0x3ebe9816,0xd6580051,0x58d4153d,0x7ae29817}},	//   _ditt_, ריות_, _гост, _awot,
   {{0xeb999687,0x99840013,0x7afb9818,0x44e18110}},	//   кий_, _الفو, trut, rų_,
   {{0x6f1b8024,0x09e800ab,0xc8649819,0x6729981a}},	//   _upuc, _পাতা, _утри, _usej,
   {{0x6285181b,0x7cd18029,0x7afb981c,0x7c2f117e}},	//   nnho, _pārd, rrut, _lacr,
   {{0xa06a181d,0x61e7181e,0x888608cc,0x186a181f}},	//   вана_, _mejl, илож, вани_,
   {{0xb4c19094,0xfa2580c8,0x7cd18029,0x78ad1820}},	//   ंदी_, বাইল_, _vārd, _chav,
   {{0xe9ce9821,0x2ca01822,0x7ae29823,0x7d039824}},	//   _мк_, vlid_, _gwot, luns,
   {{0x442f9825,0x61e7000d,0x3ebe09df,0x6e239826}},	//   _hag_, _nejl, ött_, nenb,
   {{0x442f9827,0xc62800ab,0xfd5d81bc,0x7d039828}},	//   _kag_, মালা_, _rizọ, nuns,
   {{0x442f84b5,0xbc630ab5,0xa3ac8935,0x26c41829}},	//   _jag_, овск, _गरम_, ímos_,

   {{0xa3b1016f,0x62970118,0x91fc80eb,0x6e23982a}},	// [c00] टेल_, foxo, bkād, kenb,
   {{0xe9d700bf,0x442f982b,0x7ea0016d,0xd0e68fd3}},	//   ику_, _lag_, köpi, _حکیم_,
   {{0x3f9f982c,0x61e7013c,0x7d038669,0xa926182d}},	//   _ayuu_, _dejl, juns, рдел,
   {{0x442f982e,0x3ebe888b,0x7d03982f,0x60c7082c}},	//   _nag_, _sitt_, duns, _dujm,
   {{0x7c2407e1,0x61e71830,0x6e239831,0x2d9e9832}},	//   meir, _fejl, fenb, _syte_,
   {{0x7c241833,0xb4c19834,0x6e239835,0x7c2f012b}},	//   leir, ंदू_, genb, _zacr,
   {{0x394700f2,0x3ebe9836,0xddc8809a,0xafe68110}},	//   änst_, _vitt_, _podł, _вобл,
   {{0x7c24156b,0x442f9837,0x7ae28247,0x44321838}},	//   neir, _cag_, _pwot, ndy_,
   {{0x15e6000f,0x27e0807b,0x6e239839,0xd5b180ff}},	//   करार_, ðinu_, benb, _máy_,
   {{0x80ca8935,0x7d1e035f,0xf1aa0035,0x2d96983a}},	//   _संदे, _opps, _करान, _крес,
   {{0x3a370051,0x4432003e,0x442f983b,0xd57580e8}},	//   ברים_, kdy_, _fag_, _луць,
   {{0x442f983c,0x7c240ba3,0x69c3983d,0x1b1d0264}},	//   _gag_, jeir, _egne, নিতে_,
   {{0x7c24183e,0x4424983f,0x7ad486e2,0x629c1840}},	//   deir, mem_, _اقتص, _okro,
   {{0xa2c386a7,0x442f9841,0x78a2816b,0x443200e1}},	//   रदर्, _zag_, hlov, edy_,
   {{0x7c24031d,0x58871842,0x78a2816b,0xa4d5004a}},	//   feir, _выпа, klov, собі,
   {{0x44249843,0x61300117,0x78a28d11,0x7c241844}},	//   nem_, zólá, jlov, geir,
   {{0x78a29845,0x44249846,0x644d1847,0xa3b10035}},	// [c10] dlov, iem_, rjai, टें_,
   {{0x44249848,0x62851849,0xa3cb184a,0x6e23984b}},	//   hem_, unho, रुज_, xenb,
   {{0x4424984c,0x61e7013c,0x7c24184d,0x6285184e}},	//   kem_, _vejl, beir, rnho,
   {{0x7c24184f,0x60c084b9,0x27e91850,0x9ef581a8}},	//   ceir, _cimm, _jean_, مستش,
   {{0x44249851,0x6e239852,0x442f9853,0x2b470071}},	//   dem_, tenb, _rag_, _тэнг,
   {{0x64428307,0x442f9854,0x7d039855,0x672d004f}},	//   _anoi, _sag_, tuns, _msaj,
   {{0x442f9856,0x78a28b67,0x60c0807b,0x40358098}},	//   _pag_, blov, _fimm, _левс,
   {{0x44249857,0x7d039858,0x7cd180eb,0x213e00f7}},	//   gem_, runs, _pārb, _átha_,
   {{0x442f9859,0x6e23985a,0x7d03985b,0x753a8102}},	//   _vag_, penb, suns, _ertz,
   {{0x4432185c,0x442f985d,0x60c082af,0x7d038077}},	//   zdy_, _wag_, _zimm, puns,
   {{0x236d8063,0x442f8252,0x4424985e,0x2913011b}},	//   szej_, _tag_, bem_, ntxa_,
   {{0x4424985f,0x7c24184f,0x442f81c0,0x245c008b}},	//   cem_, xeir, _uag_, _tími_,
   {{0x7c240548,0x43749860,0x6d410502,0x6d5c0428}},	//   veir, _мушт, ålan, wyra,
   {{0xda0305b3,0x6d5c1861,0xa3bd1862,0x69c39863}},	//   _लागत_, tyra, ेखन_, _ugne,
   {{0x7c241864,0x78a29865,0x98a7928a,0x27e91866}},	//   teir, ylov, íně_, _fean_,
   {{0x27e91867,0x29059868,0x3fe609a5,0xe8171869}},	//   _gean_, mula_, _ужив, ध्दा_,
   {{0x2905986a,0x7c24186b,0x387d8114,0x64aa81d0}},	// [c20] lula_, reir, diwr_, _přiz,
   {{0x7c24186c,0x09e800ab,0x0f3701c6,0x200d8493}},	//   seir, _পাহা, _פריט_, _acei_,
   {{0x7d1e186d,0xed5a07ff,0xe8fa186e,0x27e900b9}},	//   _upps, _сон_, уле_, _yean_,
   {{0x4424986f,0x673b8ca3,0x3a259870,0x16058006}},	//   xem_, _bruj, help_, _राउर_,
   {{0x44249871,0x78a29872,0x29059873,0x7bc60122}},	//   vem_, rlov, hula_, _igku,
   {{0x78a29874,0x412a0cde,0x29059875,0xa3d40075}},	//   slov, _його_, kula_, सुर_,
   {{0x60c09876,0x26098701,0x7bc60122,0x9ac301b9}},	//   _timm, _सारी_, _kgku, ċċes,
   {{0x29059877,0xbf4d81d0,0x6d5900fc,0xafdb1277}},	//   dula_, _šířk, _ƙwaz, hjør,
   {{0xe7378364,0x53349878,0x673b9879,0x66e3987a}},	//   _лет_, цепт, _gruj, _нота,
   {{0x4424987b,0x3d190d38,0x6f060ebf,0x2905987c}},	//   sem_, _पहले_, dukc, fula_,
   {{0x2905987d,0x6e93987e,0x44248873,0x3a370039}},	//   gula_, _علما, pem_, זרים_,
   {{0x6ca6826a,0xc867187f,0x5edd0264,0xc95301c6}},	//   _اصطل, стои, _বিবে, למת_,
   {{0xa3bc9880,0x27e91881,0x26c1033e,0xb8ef86ae}},	//   _आणि_, _vean_, _piho_, _वू_,
   {{0x29058a40,0x63a29882,0xafdb00e8,0x161b8c28}},	//   bula_, _iyon, gjør, प्पर_,
   {{0x29059883,0x865b898a,0x63a2808e,0x280401d0}},	//   cula_, נדלי, _hyon, ásné_,
   {{0xd49b0912,0xd5d901ce,0x81c000ab,0x213f026c}},	//   ург_, _ब्रज, ীরা_, _čuh_,
   {{0x32550a13,0x672d004f,0x62889884,0x26099885}},	// [c30] овар, _usaj, ondo, _साली_,
   {{0x62889886,0x80db80ab,0x98bf0084,0xf8c9827d}},	//   nndo, _ভিত্, tytė_, _mẩn_,
   {{0x38691887,0x63a29888,0x62889447,0x09e80264}},	//   _klar_, _lyon, indo, _পাশা,
   {{0x629a9889,0xf77080d5,0x6e27188a,0x27e9988b}},	//   hoto, کام_, lejb, úan_,
   {{0xddc5835f,0x290594e6,0x2489188c,0x61f8988d}},	//   обли, zula_, mnam_, _odvl,
   {{0xe61890ac,0xdce8817b,0x38690722,0x673b81a1}},	//   йді_, _aydı, _llar_, _vruj,
   {{0xe80a00cf,0x38690201,0x69c7035f,0x2489188e}},	//   _वाला_, _olar_, _igje, onam_,
   {{0x06d880ab,0x63a28c56,0xe459988f,0x29058234}},	//   _সিরি, _byon, ржи_, vula_,
   {{0x24891890,0x29059891,0xf8c980ff,0x60ca81ec}},	//   inam_, wula_, _cẩn_, _aufm,
   {{0x29059892,0x629a9893,0x63a286c4,0x38691894}},	//   tula_, goto, _dyon, _alar_,
   {{0x6026076a,0xd8261895,0x63a29896,0x38691897}},	//   одна, одни, _eyon, _blar_,
   {{0x29059898,0x38691899,0xe73a07c4,0x27ef80dd}},	//   rula_, _clar_, аем_, nagn_,
   {{0x2905989a,0x63a28365,0x6235957b,0xde888133}},	//   sula_, _gyon, _меду, lịa_,
   {{0x2905989b,0x61ea989c,0x629a989d,0x2489189e}},	//   pula_, _gefl, coto, enam_,
   {{0xdd920a47,0x8c7a0081,0x2c6706ae,0x66010789}},	//   ذور_, ащат_, _sõda_, ólka,
   {{0x60c91482,0x69c700f1,0x69d501ed,0x2489189f}},	//   _čemp, _agje, _afze, gnam_,
   {{0xd46718a0,0x161b00d4,0xc88916a5,0x03a30729}},	// [c40] ците_, _पॉवर_, _دخول_, дито,
   {{0xae0e8aed,0xafdb054f,0x78a618a1,0x25ad06d4}},	//   _साधन_, ljøp, llkv, řela_,
   {{0x4fc698a2,0x38cb00d5,0x7cf081a8,0xc7c698a3}},	//   осла, لانی_, _mórá, осли,
   {{0xdca60e97,0x69da18a4,0x629a804f,0x09aa0072}},	//   _фами, _प्री, zoto, _करीय,
   {{0x41c9800c,0x644618a5,0x3ced0024,0x629a8010}},	//   रशास, _inki, ćeve_, yoto,
   {{0x72c30364,0x4733835f,0x6b849024,0xa3dc8072}},	//   _обяз, ьніс, _žigo, तुन_,
   {{0x629a98a6,0x26120074,0x78660118,0x68ed8035}},	//   voto, _तानी_, _nóvo, _ładn,
   {{0x69c7020f,0x7c3618a7,0x629a98a8,0x6ab298a9}},	//   _zgje, ndyr, woto, ँग्र,
   {{0x3ce9803b,0x629a82b8,0x38690362,0x3e6b8163}},	//   ćava_, toto, _rlar_, _søte_,
   {{0x2489105e,0xd25a80c4,0x24800079,0x7afd98aa}},	//   znam_, рци_, hiim_, ásta,
   {{0xaca401bc,0x2bac8424,0x628884fe,0x64460198}},	//   _alọt, _चरवा, rndo, _onki,
   {{0x0b4698ab,0x7ea00106,0x63a298ac,0x6f0298ad}},	//   _мнен, köps, _tyon, oroc,
   {{0x629a8c93,0x60c418ae,0x628f8866,0x06cc8264}},	//   poto, _diim, écoc, রীরি,
   {{0x5edd00ab,0x628e026c,0x22580102,0x644618af}},	//   _বিদে, _njbo, _nork_, _anki,
   {{0xd7fb18b0,0x64c518b1,0x60c418b2,0x6b60826b}},	//   _куп_, वदेश, _fiim, _fágú,
   {{0x38690458,0xd14b004e,0x60c418b3,0x6f0298b4}},	//   _ular_, یشان_, _giim, kroc,
   {{0x248918b5,0x3f8c0085,0x27ef98b6,0x22580d05}},	// [c50] rnam_, şdur_, vagn_, _bork_,
   {{0xe80d85b3,0x644618b7,0x9388102a,0xe817064a}},	//   _हाहा_, _enki, іста_, ध्रा_,
   {{0xf7d88133,0x47d881bc,0xb11301bc,0x7ea4823e}},	//   _ịrụp, _ịzụk, pụmk, còpi,
   {{0xb8f318b8,0xc95380be,0x6f028037,0x2ee900fc}},	//   _हं_, ומע_, froc, _kwaf_,
   {{0x442918b9,0xe73998ba,0x6f0298bb,0x872781a8}},	//   mea_, сел_, groc, تعام,
   {{0x442918bc,0x27ef9277,0xb9010264,0x9605914f}},	//   lea_, sagn_, _দি_, रलेट_,
   {{0x308588ca,0x224998bd,0x3b0900b9,0x2fc902c4}},	//   _فلسف, _đak_, luaq_, _ogag_,
   {{0x442918be,0x6f0298bf,0x2fc90420,0x68ed8035}},	//   nea_, broc, _ngag_, _łado,
   {{0x4ea7838c,0xa3bd001b,0xeda8001b,0x225818c0}},	//   _држа, ेखि_, _गर्छ, _york_,
   {{0x28cf81b6,0x442918c1,0x27ed83b2,0xcb120496}},	//   _संदि, hea_, _heen_, עלי_,
   {{0x44290bec,0xd945919d,0x60c418c2,0x98a60087}},	//   kea_, чени, _piim, зине,
   {{0x26c5822e,0xc4d28039,0x442918c3,0x60c40079}},	//   _hilo_, _נגד_, jea_, _qiim,
   {{0x442918c4,0x60c418c5,0xeb8e98c6,0x27ed98c7}},	//   dea_, _viim, _чи_, _meen_,
   {{0xc4c60013,0xd35684de,0x27ed98c8,0xbb3a82f6}},	//   كترو, _מיני_, _leen_, _לעני,
   {{0xceb28051,0xc1aa009a,0x442918c9,0x44f701b9}},	//   גים_, _करेग, fea_, għ_,
   {{0x7c2998ca,0x26c584be,0x442918cb,0x6f0298cc}},	//   neer, _lilo_, gea_, yroc,
   {{0x2ee900fc,0x20120a03,0x2d850866,0x26c58f3e}},	// [c60] _gwaf_, _icyi_, ûler_, _oilo_,
   {{0x628198cd,0x26c590ab,0x7c2998ce,0x69de8074}},	//   nilo, _nilo_, heer, _õpet,
   {{0x2366003b,0x27ed98cf,0x7c2998d0,0x35a618d1}},	//   šoj_, _been_, keer, _ханг,
   {{0x69c388fd,0x225818d2,0x442918d3,0xc18c80be}},	//   _रणनी, _work_, cea_, סטאָ,
   {{0x628198d4,0xbea68160,0x225818d5,0x7c2998d6}},	//   kilo, падк, _tork_, deer,
   {{0x6b8907ca,0x98ac880a,0x26c580c3,0xa3b10054}},	//   _þega, ılır_, _cilo_, _ओरत_,
   {{0x7c2998d7,0x628198d8,0x26c598d9,0x645998da}},	//   feer, dilo, _dilo_, _bowi,
   {{0x27ed98db,0x7c2998dc,0x629e18dd,0x67240267}},	//   _geen_, geer, lopo, _opij,
   {{0x6459809a,0x26c598de,0x61ee18df,0xd00f98e0}},	//   _dowi, _filo_, _kebl, _حلق_,
   {{0x442918e1,0x628198e2,0x25a58b64,0x26c589c4}},	//   zea_, gilo, _fyll_, _gilo_,
   {{0x7c298c56,0x764898e3,0x442918e4,0x61ee009a}},	//   beer, _indy, yea_, _mebl,
   {{0xa3e6800f,0x629e18e5,0x7c298a0f,0x27ed01df}},	//   _बजट_, hopo, ceer, úen_,
   {{0xb8d398e6,0x6a600125,0x629e18e7,0x765a98e8}},	//   _जी_, _höfu, kopo, _koty,
   {{0xcad78051,0x628198e9,0x61ee0084,0x20f8026c}},	//   _צוות_, cilo, _nebl, kči_,
   {{0x442918ea,0x765a98eb,0x20f8050b,0x629e0cd9}},	//   tea_, _moty, jči_, dopo,
   {{0xa3d4000d,0x81e900ab,0x4fc70fe6,0xea0000ff}},	//   सँग_, _যাই_, _эска, _đạn_,
   {{0x442918ec,0xe7e30d38,0x261a035a,0x245818ed}},	// [c70] rea_, _क्या_, म्ही_, чать_,
   {{0x32d2801c,0x765a98ee,0x61fc0122,0x7d0a88ae}},	//   _mây_, _noty, _cdrl, kufs,
   {{0x442918ef,0x80a404c0,0x30158009,0x26c58122}},	//   pea_, _زمین, ддер, _rilo_,
   {{0x2c090077,0x7c2998f0,0x5ee18264,0x9f4b18f1}},	//   _بعدی_, xeer, _নিবে, hací_,
   {{0x7c2998f2,0x61ee18f3,0x2ca918f4,0x67f80019}},	//   veer, _febl, mlad_, lújí,
   {{0x2ca918f5,0xe5a598f6,0x645998f7,0x7c2998f8}},	//   llad_, мили, _sowi, weer,
   {{0x64598d38,0x765a98f9,0x7c2998fa,0x27ed98fb}},	//   _powi, _doty, teer, _teen_,
   {{0x386680f2,0x61e48eef,0x32d2801c,0xccf8801b}},	//   ckor_, _đila, _bây_, _dvě_,
   {{0x7c2998fc,0x06e200c8,0x628198fd,0x32d28028}},	//   reer, _বিভি, tilo, _cây_,
   {{0x7c2998fe,0xe8f998ff,0x32d2801c,0x2ca91900}},	//   seer, оло_, _dây_, hlad_,
   {{0x62818c6e,0x2ca91901,0xa6dd00c8,0x7c299902}},	//   rilo, klad_, _বিষয়, peer,
   {{0x6d419903,0x200f9904,0x06e200ab,0x1de61905}},	//   _irla, nggi_, _বিবি, कर्ष_,
   {{0x28cf80bc,0x32d28028,0x2ca91906,0x6279816b}},	//   _संवि, _gây_, dlad_, dňov,
   {{0x5edd00c8,0x248d9907,0x7cd50110,0x753c01d0}},	//   _বিশে, lnem_, _sąra, tvrz,
   {{0x64a61908,0xddd8811f,0x248d9909,0x6da30fe7}},	//   дава, nivš, onem_, вира,
   {{0x248d990a,0x161f0bb8,0x629e190b,0x4e1f03a4}},	//   nnem_, म्बर_, wopo, म्बई_,
   {{0xa5a485e8,0x64a31444,0x3ced0067,0xf1fa190c}},	// [c80] _चुनौ, тата, ćeva_, قعات_,
   {{0x9f44803e,0x7cd180eb,0x1e83012f,0x386d8580}},	//   _nemá_, _pārl, _альм, _aler_,
   {{0x629e190d,0x85bb0065,0x2ca9190e,0x20f8190f}},	//   ropo, _واپس_, blad_, uči_,
   {{0x20d38028,0x61ee1910,0x7bcb803d,0x248d9911}},	//   _mãi_, _webl, _nggu, jnem_,
   {{0x248d9640,0x6d419912,0x629e1913,0x38669914}},	//   dnem_, _arla, popo, rkor_,
   {{0x38669915,0x2ca01916,0xa3bd0540,0x7bcb9917}},	//   skor_, loid_, ेखर_, _aggu,
   {{0x386d9918,0x9f4b03cb,0xceb30158,0xa06a9071}},	//   _fler_, vací_, דיג_, _дава_,
   {{0x38b58e23,0x7d0a81ec,0x60cd826c,0xe0438dca}},	//   gård_, rufs, _čamp, _инси,
   {{0x6d419919,0x27e6991a,0xc5f400ab,0xd62680f7}},	//   _erla, mbon_, _জানা_, _يعطي,
   {{0x20d380ff,0x78a4191b,0x27e6811b,0xd90e815b}},	//   _bãi_, _akiv, lbon_, لیت_,
   {{0x248d991c,0xddd88699,0x9f4b03c1,0x20d380ff}},	//   bnem_, civš, rací_, _cãi_,
   {{0x32d28028,0x27e68bfe,0xfe0e8424,0x20d3827d}},	//   _tây_, nbon_, _साँस_, _dãi_,
   {{0x7c22991d,0x80ca87e6,0x2ca9191e,0x2905991f}},	//   _ibor, _संके, vlad_, arla_,
   {{0x2ca91920,0x2005061c,0x6456022c,0x7ea4823e}},	//   wlad_, şli_, ejyi, còpt,
   {{0xda659921,0x6279816b,0x44220cdb,0x200f808b}},	//   _ثاني, tňov, _bbk_, yggi_,
   {{0x8af00086,0x6e3702a3,0x290c9922,0x2ca002c4}},	//   yyət, _waxb, muda_, goid_,
   {{0xfe0e8fd5,0x290c9923,0x7b180198,0x291801b9}},	// [c90] _सांस_, luda_, мотр_, _aqra_,
   {{0xd5a48117,0x248d9924,0xe3b001a8,0x627984e8}},	//   _نہ_, znem_, شرق_, sňov,
   {{0x7c229925,0x6279826f,0x38b21926,0x7cd181a9}},	//   _obor, pňov, lára_, _pārm,
   {{0xddd8812b,0x5f959927,0x5f008074,0x4422008e}},	//   vivš, ниет, _रिश्_, _gbk_,
   {{0xf6259928,0x248d8353,0x7c2d1929,0x38b5816d}},	//   едло, vnem_, mear, vård_,
   {{0x4439192a,0xddd8812b,0x7c2d192b,0x645d038a}},	//   _has_, tivš, lear, _hosi,
   {{0x44390f29,0x248d8353,0xe5a280e8,0x79a4018b}},	//   _kas_, tnem_, лиши, _арте,
   {{0x645d192c,0x7c2d192d,0x6285192e,0x387f8397}},	//   _josi, near, liho, _umur_,
   {{0x4439022c,0x248d992f,0x9985801b,0x6d4301a1}},	//   _mas_, rnem_, telů_, _šnal,
   {{0x44391930,0x7c2d008c,0x78a40e23,0x38b21931}},	//   _las_, hear, _skiv, dára_,
   {{0x290c9932,0x6d419933,0x60c99934,0x443908dc}},	//   guda_, _urla, _kiem, _oas_,
   {{0x60c98110,0x7aeb81c0,0x6a6d80e1,0x20d38129}},	//   _jiem, _twgt, _dúfa, _vãi_,
   {{0xe28e9935,0x60c985b4,0x442d9936,0x7c2d1937}},	//   _ба_, _miem, mee_, dear,
   {{0x442d9938,0x786605b4,0x60c99939,0x4422193a}},	//   lee_, _móvi, _liem, _sbk_,
   {{0x4439193b,0x6fa0146d,0x645d0114,0x27ff90ab}},	//   _bas_, _गुरू, _bosi, _odun_,
   {{0x4439193c,0x442d993d,0x60c9993e,0x7c2d193f}},	//   _cas_, nee_, _niem, gear,
   {{0x44391940,0x645d1941,0x7c39831d,0x644b80dd}},	// [ca0] _das_, _dosi, _mawr, _mngi,
   {{0x442d9942,0x27ff85a3,0x6aa1831d,0xae0e809a}},	//   hee_, _adun_, nolf, _साइन_,
   {{0x442d9943,0x26d2022e,0x44391944,0x7c2d1945}},	//   kee_, _huyo_, _fas_, bear,
   {{0x645d0870,0x60c99946,0x7c2d1947,0x78660118}},	//   _gosi, _ciem, cear, _bóvi,
   {{0x765e1948,0x442d9949,0xe818000f,0x3a380110}},	//   _kopy, dee_, _थाना_, _tarp_,
   {{0x4420194a,0x644b994b,0x27ff994c,0x27e6994d}},	//   lfi_, _angi, _edun_, sbon_,
   {{0x442d8135,0x4439194e,0x7ae4194f,0x69ce10ab}},	//   fee_, _yas_, lpit, _igbe,
   {{0x8fa69950,0x442d9951,0x44390069,0x7c3b820d}},	//   _забе, gee_, _xas_, gdur,
   {{0x7ae41952,0x7c399953,0xddcf81d0,0x44200286}},	//   npit, _dawr, řešn, ifi_,
   {{0x60c99954,0x290c9955,0x442009ca,0x644b9956}},	//   _ziem, tuda_, hfi_, _engi,
   {{0xd48f94b7,0x69ce0133,0x06d88264,0xa1949957}},	//   _бр_, _mgbe, _সিটি, танч,
   {{0x290c9958,0x7ae41959,0x7c22995a,0x442d995b}},	//   ruda_, kpit, _ubor, cee_,
   {{0x69dc040e,0x645d195c,0x26d205a4,0xc6f80221}},	//   _ofre, _rosi, _cuyo_, ннях_,
   {{0x62850144,0x2b400824,0x6e2e0061,0xb9068264}},	//   xiho, dvic_, gebb, _পি_,
   {{0x4439195d,0xa8a71264,0x4420195e,0x7c2d195f}},	//   _pas_, _прик, ffi_, tear,
   {{0x44391960,0x69dc1961,0x69ce10ab,0xa01b0106}},	//   _qas_, _afre, _agbe, rnös,
   {{0xe4ed023c,0x7c2d1962,0x60c99963,0x7cd180eb}},	// [cb0] _जबकि_, rear, _riem, _pārk,
   {{0x44391964,0x60c99965,0x7c2d1966,0x442d9967}},	//   _was_, _siem, sear, zee_,
   {{0x44391968,0x60c99969,0x442d996a,0x645d0364}},	//   _tas_, _piem, yee_, _tosi,
   {{0x443910af,0x6285196b,0x69ce0091,0xdddc0110}},	//   _uas_, siho, _egbe, mirš,
   {{0xd366996c,0x6f1d196d,0xb8d80105,0xab87196e}},	//   _ئه_, ntsc, _घी_, _чунк,
   {{0x442d996f,0x6d4a00f7,0x6f1d0192,0x60c99970}},	//   wee_, _áfac, itsc, _wiem,
   {{0x60c99971,0x442d9972,0x6e3a831d,0x78a2826c}},	//   _tiem, tee_, _datb, boov,
   {{0xdd8e8013,0x20d7007e,0x6e3a82c4,0xa8a49973}},	//   توى_, _içi_, _eatb, _брук,
   {{0x2ba705e8,0x36d5835f,0x442d8051,0x2612154b}},	//   _कुमा, _розр, ree_, _ताली_,
   {{0x6f0f1974,0x39459594,0x442d9975,0xcb1400be}},	//   ducc, вног, see_, אלץ_,
   {{0x442d9976,0x26d21977,0x44201978,0x35558277}},	//   pee_, _suyo_, yfi_, _جناز,
   {{0xcc148077,0x644b9979,0x6e2e03f7,0x60dc802a}},	//   _مذهب, _ungi, webb, írma,
   {{0xa3a8816f,0x6e2e197a,0x69c390a1,0x547a81c6}},	//   _खुप_, tebb, _रणवी, _קטנו,
   {{0x27f202a3,0x2cad8051,0x6d4500dd,0xdee3197b}},	//   _weyn_, lled_, _brha, рори,
   {{0xe5a61401,0x7afd197c,0x6e2e0698,0x6da6018b}},	//   тиви, _avst, rebb, тива,
   {{0x64be0778,0xb4ac016f,0x26d2197d,0x7f44197e}},	//   ्देश, गते_, _tuyo_, _triq,
   {{0x4420197f,0xe3631980,0x7d0e1981,0x6d4502af}},	// [cc0] rfi_, акти, subs, _erha,
   {{0x2cbf9982,0x2cad801b,0x63ab82c4,0x7ae41983}},	//   hmud_, hled_, _mygn, rpit,
   {{0x2ba70076,0x6e3c9984,0xa3ea02c7,0x7ae41985}},	//   _कुठा, _órbi, _одна_, spit,
   {{0xdee68ba1,0x66e69986,0x248202f7,0x7afb9987}},	//   води, вода, _umkm_, ksut,
   {{0x44fe01e2,0x2cad8428,0x628381d6,0x6e3a89c4}},	//   lį_, dled_, _omno, _patb,
   {{0x24921988,0x2cad822b,0xb7d280ab,0x20ee81d0}},	//   lnym_, eled_, ারেট, yři_,
   {{0x44fe01e2,0xda188076,0x660101fa,0x6e3a9989}},	//   nį_, _दाबत_, ólki, _vatb,
   {{0x2492198a,0x386002be,0x63ab8bc5,0x39470366}},	//   nnym_, _noir_, _bygn, ænse_,
   {{0x63ab8358,0x7afb998b,0xaec68196,0xa7a7998c}},	//   _cygn, gsut, _абал, _акта_,
   {{0x63ab816d,0x44fe0084,0x3860198d,0xf8ca027d}},	//   _dygn, kį_, _aoir_, _mẩu_,
   {{0xd6e200c8,0x2617998e,0x2cad8039,0x38600706}},	//   _বিষয, _नाती_, bled_, _boir_,
   {{0x2cad998f,0x38600635,0xb4ac016f,0x6f0f01e8}},	//   cled_, _coir_, गतो_, tucc,
   {{0x44269990,0xf8bf02be,0x24920dee,0x38600706}},	//   _ibo_, rmé_, dnym_, _doir_,
   {{0x6f1d1991,0x6f0f05dc,0x2c75013c,0xb7e3085d}},	//   rtsc, rucc, _måde_, _क्रम_,
   {{0x26cc9992,0x7cd180eb,0x2bc51993,0x6f1d1994}},	//   _mido_, _pāri, लेना, stsc,
   {{0x48150139,0x91f282f1,0x588701e5,0x38601995}},	//   _смис, _आजुओ_, _шыла, _goir_,
   {{0x201e0086,0x44269996,0x09bd1107,0x9cc801e5}},	// [cd0] əti_, _mbo_, ्ख्य, тыра_,
   {{0x62889997,0x7afd8510,0x7ae28010,0x99671777}},	//   nido, ásti, _mtot, ктел,
   {{0xdfd18013,0x44269998,0x60cd1999,0x6729999a}},	//   ميا_, _obo_, _kiam, _spej,
   {{0x2c750f06,0x245881ac,0x4426999b,0x60cd199c}},	//   _både_, _témy_, _nbo_, _jiam,
   {{0x60cd199d,0xb8fa199e,0x26cc8135,0x160e816f}},	//   _miam, _डू_, _bido_, _साखर_,
   {{0x4426999f,0x7c3d19a0,0xa3e58beb,0x98b3817b}},	//   _abo_, _hasr, बुन_, ıdır_,
   {{0x62888510,0x261b0665,0xc2120039,0x6ed506b7}},	//   dido, _बानी_, _להם_, _यूसु,
   {{0x394999a1,0x60cd19a2,0x248919a3,0x26cc81df}},	//   _čas_, _niam, niam_, _eido_,
   {{0x408499a4,0x291e99a5,0x89f585a8,0x7c3181a1}},	//   _турб, etta_, лянц, _čerč,
   {{0x628899a6,0x386019a7,0x442699a8,0x7afb99a9}},	//   gido, _soir_, _ebo_, rsut,
   {{0x7afb99aa,0xe73c07d9,0x78bb81c0,0x60cd0176}},	//   ssut, _küçü, _khuv, _biam,
   {{0x60cd01e4,0x05a70105,0x442690ab,0x7c8499ab}},	//   _ciam, _गड़ब, _gbo_, _куче,
   {{0x386006e3,0x7e6199ac,0x60cd19ad,0x248919ae}},	//   _voir_, _kolp, _diam, diam_,
   {{0x62889313,0x443f99af,0x443d99b0,0x26cc8118}},	//   cido, ldu_, _haw_, _xido_,
   {{0x443d99b1,0x443f99b2,0xff1400ab,0x60cd19b3}},	//   _kaw_, odu_, িবেশ_, _fiam,
   {{0x60cd19b4,0x38b90019,0x44fe0110,0x7c3d01b4}},	//   _giam, tére_, rį_, _casr,
   {{0x4bd9176a,0x443d8114,0x422619b5,0x3b071182}},	// [ce0] ться_, _maw_, лдав, лето_,
   {{0xe74719b6,0x78a619b7,0x443d8039,0x44fe0084}},	//   ções_, lokv, _law_, pį_,
   {{0x090619b8,0x9f520205,0x38b90019,0x26cc99b9}},	//   упен, _seyè_, sére_, _rido_,
   {{0x26cc99ba,0x38608125,0x78bb8548,0x443f816b}},	//   _sido_, ðir_, _chuv, jdu_,
   {{0x443f99bb,0x26cc99bc,0x443219bd,0x7e6199be}},	//   ddu_, _pido_, mey_, _bolp,
   {{0x0f370051,0x628883a8,0x7e6199bf,0x443f99c0}},	//   טרנט_, xido, _colp, edu_,
   {{0xe29707b6,0x60d50661,0xad268c2a,0x443d99c1}},	//   _сар_, _guzm, ارتو, _baw_,
   {{0xdd0401e2,0x443d8069,0x443219c2,0x7c2419c3}},	//   ūrėt, _caw_, ney_, nfir,
   {{0x62889313,0x443d99c4,0x26cc99c5,0xf743932a}},	//   tido, _daw_, _tido_, _лето,
   {{0x60cd19c6,0x59b804e5,0x7e6190dd,0xc3330051}},	//   _siam, _अरार, _golp, צות_,
   {{0x7c2419c7,0xc27b00be,0x291e8009,0x443f82a6}},	//   kfir, גריי, utta_, bdu_,
   {{0xf5378051,0x7cd18029,0x60cd0748,0x628899c8}},	//   _תנאי_, _pārv, _qiam, sido,
   {{0x443202a3,0x7c3d19c9,0x248919ca,0x442480b9}},	//   dey_, _rasr, viam_, mfm_,
   {{0xbb3b8158,0x2489009a,0x7ead80e1,0x35a986a7}},	//   _רעגי, wiam_, túpi, _चुड़,
   {{0x248919cb,0x60cd0069,0x61fa8201,0x7c2419cc}},	//   tiam_, _tiam, matl, ffir,
   {{0x61fa99cd,0x6d4899ce,0x44320079,0x644099cf}},	//   latl, _mrda, gey_, ndmi,
   {{0x248919d0,0x99900289,0x50b8006b,0xf77302e3}},	// [cf0] riam_, _čaša_, _حدود_, _داغ_,
   {{0x7cd18029,0x61fa99d1,0xbbd186b7,0x443f99d2}},	//   _kārt, natl, _हल्क, zdu_,
   {{0x394719d3,0x443f99d4,0x7c3d19d5,0x7e61867f}},	//   íns_, ydu_, _tasr, _rolp,
   {{0x26179880,0x61fa85b2,0x443219d6,0x644f19d7}},	//   _नाही_, hatl, cey_, _unci,
   {{0x6d4899d8,0xe73999d9,0x443f99da,0x61fa99db}},	//   _arda, тел_, vdu_, katl,
   {{0xa5098fe6,0x8d6580af,0x26dc00be,0x61fa99dc}},	//   века_, ивле, עקומ, jatl,
   {{0xed5999dd,0x443d8e35,0x61fa99de,0x7e6199df}},	//   той_, _paw_, datl, _volp,
   {{0x443f99e0,0x3e7419e1,0xc60680ab,0xf0bb8fd3}},	//   udu_, _mäta_, ল্লা_, _سازش_,
   {{0xa3a8823c,0x443f99e2,0xfc3f07ca,0x290c85a4}},	//   _खुद_, rdu_, _maí_, erda_,
   {{0xc6a799e3,0x61fa99e4,0xea2490ab,0x2bd185fc}},	//   _срби, gatl, ẹ́rẹ, _हलका,
   {{0x443202c1,0x3ea799e5,0x443d99e6,0xf99180f7}},	//   yey_, mont_, _taw_, تبة_,
   {{0x18a60364,0x44320079,0x443f99e7,0x92a60035}},	//   рамм, xey_, qdu_, _załą,
   {{0x61fa899b,0xa3d919e8,0x290c99e9,0xbca499ea}},	//   batl, ाशन_, arda_, _امني,
   {{0x4b7a8158,0x443219eb,0x7ae999ec,0x200c0085}},	//   _באנו, wey_, mpet, şdi_,
   {{0x44320079,0x44f38087,0x8d630615,0xa3dc98a9}},	//   tey_, nţ_, овре, तुक_,
   {{0xb05b19ed,0x673b8bcf,0xd91a8e82,0x261219ee}},	//   lmän, _osuj, _סופל, _ताकी_,
   {{0x443219ef,0x7c2419f0,0x7ae999f1,0x3ea799f2}},	// [d00] rey_, rfir, npet, kont_,
   {{0x14b8016f,0xab2719f3,0x7bdf01e8,0xf2df00ff}},	//   _आठवण, рофа_, acqu, _trân_,
   {{0xd00f19f4,0x7f498388,0x33200372,0x261b0074}},	//   _علی_, _areq, stix_, _बाती_,
   {{0x03a600e8,0x8c4610ca,0x044619f5,0x09d2801b}},	//   _вимо, _теме, _темн, _सल्य,
   {{0x27e985b4,0x61fa83bf,0x6d48812b,0xbb4300e8}},	//   ñana_, yatl, _srda, _деяк,
   {{0x2913002a,0xa01b0198,0xa3e206ae,0x290c9388}},	//   buxa_, riöi, नुर_, yrda_,
   {{0x61fa99f6,0x442499f7,0xd49a99f8,0x261795bc}},	//   vatl, tfm_, кри_, _नारी_,
   {{0x61fa80dd,0x290c8140,0xa0678dc0,0x7f4999f9}},	//   watl, vrda_, _каса_, _freq,
   {{0x7f4980f1,0xc1788110,0xa06799fa,0x3ced192c}},	//   _greq, ybės_, _тата_, ćevi_,
   {{0xaa668d91,0x7cd180eb,0x09ca00ab,0x672299fb}},	//   ртик, _pārt, _ল্যা, mtoj,
   {{0x61fa99fc,0xfce38c3e,0xd2578e11,0x6d4899fd}},	//   ratl, _дохо, рцы_, _urda,
   {{0x67228110,0x7cd181a9,0x2c78826b,0x61fa99fc}},	//   otoj, _vārt, _béde_, satl,
   {{0x67229608,0x628001e2,0xb7141194,0xab838eef}},	//   ntoj, _įmon, одящ, _мушк,
   {{0xea000104,0x61fa811c,0xfc3f041c,0x67228a14}},	//   _đến_, qatl, _saí_, itoj,
   {{0xb2bb8051,0xa5f819fe,0x28d01862,0xbd680012}},	//   _שמור, ресу_, _संचि, арте_,
   {{0x2c7500f2,0x672299ff,0xdb0f016a,0xb8670019}},	//   _båda_, ktoj, _azcá, _خاتو,
   {{0x4aba8074,0x3a750088,0xaaba8105,0x67228168}},	// [d10] _उठाव, блар, _उठाक, jtoj,
   {{0x29130118,0x6d4300fe,0x3e740338,0xe7e300ba}},	//   tuxa_, _šnau, _täta_, कुरा_,
   {{0x2ba7000d,0xc5f20039,0xdd911a00,0x61f89a01}},	//   _कुरा, _מדי_, _روح_, _mevl,
   {{0x20190455,0x31578158,0x272086c0,0x67228168}},	//   ngsi_, ייבן_, fòn_, ftoj,
   {{0xf7459a02,0xb4b300d4,0xc8d0016f,0x27209a03}},	//   село, टती_, _संघट, gòn_,
   {{0x2ca9062d,0x78a2803e,0xbb3a00be,0x14b5016f}},	//   load_, čova, _געשי, ंतवण,
   {{0xfbdb0076,0x3ea782be,0x442b1a04,0x28f802c7}},	//   _भलाम, ront_, _kbc_, _весь_,
   {{0x1ee7826a,0x7ae980ce,0x2901004f,0x4adb1a05}},	//   _نوری_, tpet, msha_, _बढाव,
   {{0x7cd18029,0x3ea78019,0x4aa9891d,0x7ae99a06}},	//   _pārs, pont_, лкин_, upet,
   {{0xfc3f800d,0x38bc9a07,0x78ad1a08,0x7aed8085}},	//   ží_, ríre_, _akav, _çatm,
   {{0x61f89a09,0x7ae99a0a,0x186a1324,0xa06a1a0b}},	//   _devl, spet, гани_, гана_,
   {{0xf9920039,0xb1138133,0x764181b4,0x29011a0c}},	//   לרי_, _kụzu, _haly, isha_,
   {{0x248d8341,0x3b098d69,0x76419a0d,0x7205803d}},	//   miem_, _село_, _kaly, _هوشم,
   {{0x78ad00d2,0x248d80eb,0x61f8874c,0xb05b0198}},	//   _ekav, liem_, _gevl, lmäl,
   {{0x442b1a0e,0xceb29a0f,0xd5b21a10,0xd9c580ab}},	//   _bbc_, פיל_, سفر_, _শ্রম,
   {{0x248d9a11,0x672281e2,0xb05b016d,0x6d4a0118}},	//   niem_, ytoj, nmäl, _áfam,
   {{0xe29a041c,0xe3ba1a12,0x045700f7,0xf1bf81d0}},	// [d20] гаа_, уба_, حلقة_, řád_,
   {{0x6f040e78,0x6f0483f2,0x248d9a13,0x76419a14}},	//   _ivic, šick, hiem_, _naly,
   {{0xfe370051,0x248d9a15,0x2b4b0326,0x64a60084}},	//   _פרטי_, kiem_, _ercc_, _гана,
   {{0x248d8341,0x91fc80eb,0x17fa80f7,0x6f041a16}},	//   jiem_, nkār, اراة_, _kvic,
   {{0x248d8029,0x501b0bea,0x76419a17,0xb4c4009a}},	//   diem_, רונו, _baly, एगी_,
   {{0x67229a18,0x1ae31a19,0xbea39a1a,0xa2e31a1b}},	//   rtoj, _хорм, пачк, _хорд,
   {{0x67228828,0x764181e2,0x261b1a1c,0x394a0580}},	//   stoj, _daly, _बासी_, _urbs_,
   {{0x248d9a1d,0x64440c56,0x7c361a1e,0x67228168}},	//   giem_, ndii, neyr, ptoj,
   {{0xa3a897ba,0x7cd181a9,0x3e799a1f,0x9e658061}},	//   _खुश_, _pārr, _sète_, _ڈالن,
   {{0x9e658013,0xc3330039,0x0665803d,0x78ad1a20}},	//   _والن, לוח_, _والپ, _skav,
   {{0xd0110199,0x6f029a21,0xa3a8852a,0x248d8ec3}},	//   ولد_, lsoc, _खुर_, biem_,
   {{0xc19b0158,0x248d9a22,0x764185ee,0x13b00264}},	//   רשטי, ciem_, _zaly, চেয়,
   {{0x61fe1a23,0x6f029a24,0x64441a25,0x5f940081}},	//   kapl, nsoc, ddii, зият,
   {{0x6f040267,0x64429a26,0x442b0df6,0x29010df6}},	//   _dvic, _haoi, _sbc_, ysha_,
   {{0x90e69a27,0x7c36008b,0xe5c40081,0x61fe1a28}},	//   _استن, feyr, зсто, dapl,
   {{0x38b902be,0xb4b3016f,0x644402d5,0x629c03ed}},	//   méro_, टते_, gdii, _ajro,
   {{0x64429a29,0x5eb800ab,0x290101b4,0xd9f901ae}},	// [d30] _maoi, _ইংরে, wsha_, инац_,
   {{0x61fe1a2a,0x7f4d1a2b,0x60c09a2c,0x2901005d}},	//   gapl, _iraq, _ahmm, tsha_,
   {{0x6f040168,0x200900b9,0x442b1a2d,0xb05b0198}},	//   _zvic, _kdai_, _tbc_, ymäl,
   {{0x6d400029,0xdd00800d,0xdb0f00e7,0x442b1a2e}},	//   āmat, štěn, _lycé, _ubc_,
   {{0x3ced02a5,0x248d9a2f,0xa3a88105,0x76418110}},	//   ćevu_, viem_, _खुल_, _paly,
   {{0xf1c88bb8,0x999e8065,0x60c0808e,0x248d8035}},	//   रधान, hető_, _ehmm, wiem_,
   {{0x248d8029,0x9f40007b,0x76419a30,0x76439a31}},	//   tiem_, _leið_, _valy, rdny,
   {{0x130982da,0x44291a32,0x6442832f,0x26d30ba3}},	//   аний_, nfa_, _caoi, _lixo_,
   {{0x6442803c,0x290a8065,0x248d9a2f,0x7aed1a33}},	//   _daoi, ában_, riem_, npat,
   {{0x248d8029,0x090580e8,0x2009004f,0x38bc84e8}},	//   siem_, опон, _adai_, míra_,
   {{0xdd9b8153,0x64428068,0x644402a3,0x6f04190f}},	//   _сша_, _faoi, ydii, _svic,
   {{0xc5e90bea,0x43759a34,0x290b9a35,0x64428c49}},	//   _יד_, _мулт, čca_, _gaoi,
   {{0x99980289,0x4429031d,0xdd1e81ac,0xe28e9a36}},	//   _marš_, dfa_, _víťa, _жа_,
   {{0x7c298e5d,0x3e708706,0xa3e586ae,0x7aed066b}},	//   lfer, _càth_, बुर_, dpat,
   {{0x26d304c3,0x7aed0858,0x61fe0214,0xa3c18540}},	//   _dixo_, epat, vapl, ंधक_,
   {{0x13ea0196,0x74161a37,0x26d30ba3,0x6f0480e1}},	//   рмай_, تورا, _eixo_, šici,
   {{0xe1fa0d69,0x26d31a38,0x7aed1066,0x7c36007b}},	// [d40] ига_, _fixo_, gpat, reyr,
   {{0x44291a39,0xf22186a7,0x63b6804a,0x41b61821}},	//   afa_, _माफ़_, _øyne, осет,
   {{0xda218e18,0x27241a3a,0x649780eb,0x05a99a3b}},	//   _मानत_, lön_, rģij, _चुलब,
   {{0x5ee180c8,0x7c2980f3,0x61fe02d0,0x4429018e}},	//   _নিজে, jfer, sapl, cfa_,
   {{0xee3a8012,0xaf369a3c,0xd00f8199,0x7c299670}},	//   инд_, ترات, ئله_, dfer,
   {{0x6442808c,0x999e8019,0x6f029a3d,0x7c298192}},	//   _saoi, zető_, rsoc, efer,
   {{0x7c299a3e,0x27241a3f,0x7cd180eb,0x61fc1384}},	//   ffer, hön_, _pārp, _ierl,
   {{0x61fc1a40,0x2c78803d,0x61e90bda,0x60c082d5}},	//   _herl, _béda_, _đeli, _uhmm,
   {{0x60dc1a41,0x7a3f8110,0x27241a42,0x61fc1a43}},	//   _hurm, kštė, jön_, _kerl,
   {{0x60dc1a44,0x61fc09a6,0x026a80e8,0x5ee18264}},	//   _kurm, _jerl, рший_, _নিচে,
   {{0x44291a45,0x3a370496,0x64428834,0x8cd61a46}},	//   yfa_, חרים_, _taoi, _मंगो,
   {{0xab2a9a47,0x26dc00ce,0x7c298118,0x6724022b}},	//   _вода_, _čvor_, cfer, _bqij,
   {{0xd90e89d7,0xa09b80be,0xe29a84ae,0x7d1c92f1}},	//   ریک_, שיכט, _кад_, _årsb,
   {{0x29070019,0x628a8234,0x25e601d0,0x63a282f9}},	//   ának_, _umfo, जुली_, _ixon,
   {{0x7e689a48,0x44291a49,0x45d41a4a,0x60dc1a4b}},	//   _modp, tfa_, дорс, _nurm,
   {{0xa01b1a4c,0xd5b80e02,0xe57180be,0x44291a4d}},	//   riös, юся_, ײַל_, ufa_,
   {{0x61fc1a4e,0x44291a4f,0x6d5a1a50,0x3a750088}},	// [d50] _berl, rfa_, ätar, плар,
   {{0x44291a51,0x4eac80ab,0x656e0061,0x68e301df}},	//   sfa_, গগুল, ínhá, índo,
   {{0x05a98540,0x60dc1a52,0x38690573,0x442900b4}},	//   _चुंब, _curm, _koar_, pfa_,
   {{0x7aed1a53,0x61fc037a,0x60dc1a54,0x63a2808e}},	//   ppat, _eerl, _durm, _oxon,
   {{0x66c01836,0x61fc1a55,0x76451a56,0xdb07861c}},	//   söke, _ferl, _kahy, ümüz,
   {{0x61fc1a57,0x60dc01b4,0x0e648558,0x3e798176}},	//   _gerl, _furm, мкін, _bèta_,
   {{0xc6940158,0x7c2982af,0x60dc1a58,0xf3ff03a7}},	//   ואס_, tfer, _gurm, _joão_,
   {{0x629a9a59,0x320102ed,0x61e50428,0xab6582ac}},	//   ento, lahy_, lchl, звил,
   {{0x7c299a5a,0x61fc084a,0x5f94835f,0xa3ce0107}},	//   rfer, _yerl, _житт, षेप_,
   {{0x61e50635,0x60dc008e,0x320110ba,0x62800196}},	//   nchl, _yurm, nahy_, _įmok,
   {{0x27e084c4,0x850580d5,0x91fc80eb,0xa92281e5}},	//   žine_, _روشن, rkāp, ндэл,
   {{0x7e688efc,0x201d81b9,0x27240009,0x629a99b0}},	//   _zodp, ngwi_, tön_, anto,
   {{0x38690012,0xacaa8117,0xc31980c8,0x31b80526}},	//   _doar_, _اپنے_, _তৈরি_, _अर्ध,
   {{0x27241a5b,0x2b4f826c,0x7645111f,0x9f5d8077}},	//   rön_, _irgc_, _cahy, gawé_,
   {{0x491283bb,0xbea3014c,0xdd921a5c,0x61e51a5d}},	//   _थियो_, харк, رور_, dchl,
   {{0x442f807d,0x61fc1a5e,0x6d4180dd,0x3869010c}},	//   _jbg_, _serl, _msla, _goar_,
   {{0x61fc0455,0x20021a5f,0xd46711b3,0x60dc1a60}},	// [d60] _perl, maki_, чите_, _surm,
   {{0x20021a61,0x6d4194f0,0x60dc1a62,0x2c71826b}},	//   laki_, _osla, _purm, _dádi_,
   {{0xceb31a63,0x61fc04eb,0x29059a64,0xd5b00065}},	//   _איז_, _verl, nsla_, _شہر_,
   {{0x20021a65,0x38cb8416,0xc6048540,0x64a61a66}},	//   naki_, مانی_, रण्य_, _хама,
   {{0x61fc1a67,0xe81f0006,0x6d419a68,0x60dc1a69}},	//   _terl, _भासा_, _asla, _wurm,
   {{0x442f810b,0x20021a6a,0x2907817f,0x7bd9819d}},	//   _abg_, haki_, _ovna_, _agwu,
   {{0xdb078a56,0x628e1a6b,0x20020041,0xe9a31663}},	//   _člán, _imbo, kaki_, _зарп,
   {{0x64461a6c,0x20020f28,0x2cad83b2,0x399b0039}},	//   _jaki, jaki_, goed_, _הילד,
   {{0x200207d9,0x6d41957a,0x6b841a6d,0x64461a6e}},	//   daki_, _esla, nzig, _maki,
   {{0x64461a6f,0x2a6a1a70,0xb05b0364,0x27e69a71}},	//   _laki, _jobb_, mmäi, lcon_,
   {{0x2bb9053f,0xa6e98028,0x24978077,0xbbb9146d}},	//   _आर्थ, _chươ, _کنند_, _आर्क,
   {{0x64461a72,0x76451a73,0x442f8338,0x63a20035}},	//   _naki, _sahy, _gbg_, żony,
   {{0x60c41a74,0x6b840a0f,0x628e0b81,0x24800168}},	//   _dhim, jzig, _ombo, dhim_,
   {{0x291a1a75,0x2c7181d0,0x64461a76,0x442208dc}},	//   kupa_, _rádi_, _aaki, _ack_,
   {{0x64461a77,0x20021a78,0x7647006a,0xa2c00b04}},	//   _baki, baki_, rdjy, वतन्,
   {{0x628e1313,0x76450397,0x64461a79,0x30a401e2}},	//   _ambo, _wahy, _caki, _прыв,
   {{0x64461a7a,0x3f9e0214,0x4e1c801b,0x76451a7b}},	// [d70] _daki, ştur_, नलाई_, _tahy,
   {{0x291a0c53,0x6d41008b,0x78af1a7c,0x60c40326}},	//   fupa_, ælas, locv, _zhim,
   {{0x7c229a7d,0x2907001b,0x2509003d,0x4422006a}},	//   _ocor, éna_, _برخی_, _fck_,
   {{0x628e1a7e,0x61e50352,0x386987ca,0xdfd180f7}},	//   _embo, schl, ðar_, نيا_,
   {{0x7c2d1a7f,0x64978162,0x2cad9384,0x36699a80}},	//   mfar, nţie, voed_, жало_,
   {{0x442f9a81,0x443b00b9,0x20021a82,0xed599a83}},	//   _sbg_, leq_, zaki_, жок_,
   {{0xa9341a84,0x20021a85,0x291a1a86,0xdd918019}},	//   _перш, yaki_, cupa_, کوں_,
   {{0xe81f1a87,0x7c2d1a88,0x14bf0c78,0x443b1a89}},	//   _भाषा_, nfar, ्षिण, neq_,
   {{0x200d9a8a,0x20021a8b,0xaca38133,0xddd48088}},	//   _idei_, vaki_, _nkụj, čaši,
   {{0x60c41a8c,0xa6e98028,0x2002054e,0xddc18493}},	//   _shim, _phươ, waki_, _colţ,
   {{0x20021a8d,0x66039a8e,0x19c59a8f,0xa0a601a1}},	//   taki_, mank, ьбом, данд,
   {{0x1620023c,0x60d60201,0x27ff9a90,0x7d1c8257}},	//   _बाहर_, _qiym, _jeun_, _årsa,
   {{0xeaae8012,0x20021a91,0xb9048a74,0x6449831d}},	//   _ай_, raki_, _भू_, mdei,
   {{0x64461a92,0x442d8352,0xa6e98104,0x7c3b9a93}},	//   _saki, lfe_, _thươ, leur,
   {{0xceb281db,0x20021a94,0x6d58017f,0x2a6a1a95}},	//   דים_, paki_, _švab, _robb_,
   {{0x64499a96,0x6b840b90,0x442d9a97,0x7c2d1a98}},	//   ndei, tzig, nfe_, gfar,
   {{0x66039a99,0x64461a9a,0xfc3f026b,0x64978087}},	// [d80] kank, _vaki, _akís_, cţie,
   {{0x64461a9b,0x7c3b9a9c,0x248000f1,0x6281805d}},	//   _waki, heur, shim_, nhlo,
   {{0x66039a9d,0x64461a9e,0x7c3b83b2,0x6f098216}},	//   dank, _taki, keur, _avec,
   {{0x291a1a9f,0x7d1c1aa0,0x22479aa1,0x7c3b8036}},	//   rupa_, murs, _lank_, jeur,
   {{0x9c7c8499,0x073a9381,0x6f099aa2,0x98a7012b}},	//   _juče, تساب_, _cvec, žića_,
   {{0x44201aa3,0x628e1aa4,0x26c59aa5,0x66039aa6}},	//   lgi_, _umbo, _chlo_, gank,
   {{0x442d9aa7,0x69dc0548,0x7c3b9aa8,0xe81f06ae}},	//   ffe_, _igre, feur, _भाला_,
   {{0x3ae400f2,0x6e3c1aa9,0x27ff9aaa,0x7c3b9aab}},	//   _köp_, herb, _geun_, geur,
   {{0x44201aac,0x22479aad,0x7ae20174,0xcf469aae}},	//   igi_, _bank_, íoth, _юнай,
   {{0x66039aaf,0x64499396,0x22478db1,0x38668338}},	//   cank, adei, _cank_, ljor_,
   {{0x7c3b85f8,0x22479ab0,0x765a9ab1,0x021704de}},	//   beur, _dank_, _inty, וחים_,
   {{0x7d1c1ab2,0xb4d80697,0x1c1d0ebf,0x38669ab3}},	//   durs, ादो_, _फाइल_, njor_,
   {{0x69dc1ab4,0x3f869ab5,0x6e3c1ab6,0x76489ab7}},	//   _ogre, nzou_, ferb, _kady,
   {{0xf98f99f4,0x62819ab8,0x64830006,0xddda800d}},	//   ابی_, chlo, _kõig, _potř,
   {{0xf1aa803d,0x76489ab9,0x7d1c1aba,0xc34880ff}},	//   _باشه_, _mady, gurs, _hổ_,
   {{0x44201abb,0x261b1551,0x66039abc,0x69dc1abd}},	//   ggi_, _बाकी_, zank, _agre,
   {{0x3ec71abe,0x66c000f2,0x443b1abf,0x439404bd}},	// [d90] _особ, söka, req_, ватс,
   {{0x27ff81b0,0x7648923c,0x68fc0114,0xc34880ff}},	//   _seun_, _nady, _bwrd, _mổ_,
   {{0x6f1d002a,0x332901b9,0x30159ac0,0x48159ac1}},	//   lusc, stax_, едер, емес,
   {{0x6d450108,0x66039ac2,0x765a9ac3,0x8c3d8087}},	//   _isha, wank, _anty, noşt,
   {{0xa3b608fd,0xb4bd009a,0x76489ac4,0xc34880ff}},	//   _चुप_, ेगी_, _bady, _nổ_,
   {{0x68fc0428,0x171c03de,0x64598362,0x764890ba}},	//   _fwrd, קווע, _snwi, _cady,
   {{0x7ce787d9,0x7bc29ac5,0x7c3b90b6,0x3f868118}},	//   _bıra, _azou, teur, azou_,
   {{0x934591c7,0x0b459537,0xc348801c,0x61ea9ac6}},	//   ение, енин, _bổ_, _affl,
   {{0x442d9ac7,0xc3488028,0x6f09825b,0x7c3b9ac8}},	//   rfe_, _cổ_, _uvec, reur,
   {{0x272982ba,0x764883ec,0xaa459ac9,0x66038079}},	//   mún_, _gady, хеол, qank,
   {{0xa3b601ce,0x02db09c8,0x9c7c9123,0x6d451aca}},	//   _चुन_, बदुन, _suče, _nsha,
   {{0x386d8216,0x6e3c02af,0xf09f0580,0x6f1d0037}},	//   _joer_, werb, gnà_, fusc,
   {{0x66019acb,0x6d451acc,0x44200059,0xda0f016f}},	//   _kelk, _asha, vgi_, ाणात_,
   {{0x7d1c1434,0x9c7c992c,0x386d867f,0xb4d81acd}},	//   turs, _vuče, _loer_, ाद्_,
   {{0x387f82bb,0x66019ace,0x7afd1acf,0xed571ad0}},	//   _olur_, _melk, _awst, нор_,
   {{0x69c3803b,0x249f8125,0x6e3c1ad1,0x04431ad2}},	//   _izne, nnum_, serb, лесн,
   {{0x6d451ad3,0xc34880ff,0x249f808b,0xb09b1101}},	// [da0] _esha, _xổ_, inum_, _מיקר,
   {{0x6d4500f1,0x387f9ad4,0x44201ad5,0xc7d701c6}},	//   _fsha, _alur_, sgi_, _אופי_,
   {{0x387f8358,0x76489ad6,0x386d9ad7,0x7cd180eb}},	//   _blur_, _rady, _boer_, _dārz,
   {{0xd7068767,0x7648820d,0x5f069ad8,0xfbc78277}},	//   езди, _sady, езда, _مت_,
   {{0x27299ad9,0x08e68a49,0x61368065,0x66019ada}},	//   gún_, _কিছু_, _külö, _belk,
   {{0x66018a56,0x7ce782bb,0x3f86802a,0xdd949adb}},	//   _celk, _sıra, rzou_, калы,
   {{0xc348801c,0x44fe001b,0x2ca01adc,0x249f807b}},	//   _sổ_, nů_, onid_, fnum_,
   {{0x249f807b,0x54548991,0x26da1add,0xf8ca00ff}},	//   gnum_, твит, _lipo_, _tẩy_,
   {{0xb05b016d,0x66019ade,0xc7a38139,0x764880e4}},	//   lläg, _felk, _битк, _tady,
   {{0xdee39adf,0xd90e8bca,0x2c7c0511,0x44fe01d0}},	//   _софи, میت_, _oído_, ků_,
   {{0x2d878d38,0xb05b00f2,0x44fe001b,0x2b9100e1}},	//   czne_, nläg, jů_, môcť_,
   {{0xc3488028,0x44fe001b,0x6fd6880a,0xbebb0168}},	//   _tổ_, dů_, _gücü, ntëv,
   {{0x44269ae0,0xb05b01ec,0xfebb01a8,0x98741ae1}},	//   _ico_, hläg, كاست_, уляц,
   {{0x66c0016d,0x6f1d1ae2,0xa01b0192,0x7aef802a}},	//   sökn, rusc, chön, ícte,
   {{0xb606026c,0x5558002e,0x26da0091,0x7ae29ae3}},	//   dušč, наря_, _dipo_, _huot,
   {{0xdcb80698,0x6f1d159c,0xb05b0338,0x6d450299}},	//   ещу_, pusc, dläg, _vsha,
   {{0x291e80df,0x64978087,0x61fb026c,0x386d800b}},	// [db0] luta_, nţia, _đulb, _roer_,
   {{0x979c004c,0x6d4510af,0x64830006,0x7ae28009}},	//   _משחק, _tsha, _sõid, _muot,
   {{0x291e81dd,0x3b0902a6,0x6d451ae4,0xf1a7153d}},	//   nuta_, ssaq_, _usha, хран,
   {{0x442681e9,0x6f0d017f,0x66018009,0x26da004f}},	//   _nco_, _kvac, _selk, _zipo_,
   {{0x54541ae5,0x7ae281e2,0xf7459ae6,0x66018009}},	//   _свят, _nuot, тело, _pelk,
   {{0x291e9ae7,0x66071ae8,0x27299ae9,0x644d1aea}},	//   kuta_, najk, rún_, ldai,
   {{0x66019aeb,0xd65802f6,0x32059aec,0x291e9aed}},	//   _velk, תיות_, valy_, juta_,
   {{0x66019aee,0x6f0d0503,0x291e9aef,0x3e740799}},	//   _welk, _ovac, duta_, _hätt_,
   {{0x7ae280ab,0x249f807b,0x32059af0,0x5ba99af1}},	//   _cuot, rnum_, taly_, ьким_,
   {{0x291e9af2,0x644d0014,0xc3320039,0x7ae28084}},	//   futa_, hdai, סוי_, _duot,
   {{0x60c98748,0xb05b1af3,0x645d1af4,0x60db804f}},	//   _khem, kläd, _onsi, _kium,
   {{0x3e7400f2,0x32059af5,0x66e61af6,0x26da1af7}},	//   _lätt_, saly_, кома, _sipo_,
   {{0x26da1af8,0x443f9af9,0x6ec58b04,0x80cb80ab}},	//   _pipo_, meu_, ितपु, িদপ্,
   {{0x6da61afa,0x443f9afb,0x291e80a4,0x644b9afc}},	//   вига, leu_, buta_, _hagi,
   {{0xceb28f60,0x291e802e,0x644b9afd,0x6f0d1afe}},	//   ייך_, cuta_, _kagi, _evac,
   {{0x443f809f,0x44fe001b,0x7f8600f7,0x224a00ee}},	//   neu_, rů_, _للبن, _sabk_,
   {{0x644b9aff,0x44fe001b,0x6b899b00,0x443f9b01}},	// [dc0] _magi, sů_, nzeg, ieu_,
   {{0x645d1b02,0x644b9b03,0x644d1a29,0xaa7b008b}},	//   _ensi, _lagi, adai, _stýr,
   {{0xaca40135,0x44e700ff,0x9c7c8b80,0x68e382df}},	//   _amụt, _gõ_, _luča, _jund,
   {{0x644b9b04,0x60db9b05,0x63a4807b,0xb05b1b06}},	//   _nagi, _cium, _þing, rläg,
   {{0x443f9b07,0x68e39b08,0x16160b86,0x60db9b09}},	//   deu_, _lund, _तयार_, _dium,
   {{0x7bc60db7,0x7ae284fa,0x7c240110,0x291e9b0a}},	//   _izku, _ruot, lgir, yuta_,
   {{0x644b9b0b,0x92de80c8,0xc5d580c8,0x60db8081}},	//   _bagi, _তবে_, _স্বপ, _fium,
   {{0x7c24199f,0x38c884c0,0x291e9b0c,0x443f809f}},	//   ngir, _سازی_, vuta_, geu_,
   {{0x7ae29b0d,0x44269b0e,0xb05b1b0f,0x394781a1}},	//   _quot, _vco_, kmär, _asns_,
   {{0x7ae29b10,0x291e80ad,0x3a279b11,0x68e39b12}},	//   _vuot, tuta_, _ccnp_, _bund,
   {{0x2004820f,0x443f9b13,0x68e39b14,0x38b90019}},	//   _kemi_, beu_, _cund, kért_,
   {{0x7ae2825d,0x291e9b15,0x443f9b16,0x200480f1}},	//   _tuot, ruta_, ceu_, _jemi_,
   {{0x6b898063,0xda3491e9,0x291e9b17,0x644082d0}},	//   czeg, _белы, suta_, memi,
   {{0x64409b18,0x27e000ad,0x291e8870,0xd9548277}},	//   lemi, _egin_, puta_, _منتخ,
   {{0x3e7404b8,0x660700d2,0x644b9b19,0x7bc60cdb}},	//   _rätt_, rajk, _yagi, _azku,
   {{0x64409b1a,0x3e7404b8,0x200480a4,0x7c241b1b}},	//   nemi, _sätt_, _nemi_, ggir,
   {{0x4ea71b1c,0xe3740196,0x644d1b1d,0x5a351354}},	// [dd0] _арна, алты, rdai, лнат,
   {{0x60c99b1e,0x443f9b1f,0xf8bf1b20,0x64409b21}},	//   _shem, zeu_, llé_, hemi,
   {{0x60db9b22,0x60c981c0,0x39151b23,0x7bc6011b}},	//   _pium, _phem, умер, _ezku,
   {{0x2bae12ee,0x443f823e,0x33200722,0x645d1b24}},	//   _झुका, xeu_, buix_, _unsi,
   {{0x644b9b25,0x443f9b26,0x20049b27,0x60db804f}},	//   _ragi, veu_, _demi_, _vium,
   {{0x644b9b28,0x9c7c805c,0xe5a595b1,0x2004826b}},	//   _sagi, _ruča, лили, _eemi_,
   {{0x644b9b29,0x443f9b2a,0x60c99b2b,0x78a29b2c}},	//   _pagi, teu_, _them, bnov,
   {{0x64409b2d,0x68e38558,0x69c7135a,0x332d84b7}},	//   gemi, _rund, _izje, ttex_,
   {{0x443f9b2e,0x2cb9008e,0x91e59b2f,0xbebb0168}},	//   reu_, _mksd_, лопе, ntës,
   {{0x443f9b30,0x68e39b31,0x644b9b32,0x20049b33}},	//   seu_, _pund, _wagi, _zemi_,
   {{0x644b9b34,0xab5b0065,0xe4e7835f,0x6b899b35}},	//   _tagi, _szül, _різн, szeg,
   {{0x9b458277,0xa35592dc,0x68e38982,0x672d0372}},	//   _منصو, _مختص, _vund, _bqaj,
   {{0x9cd68039,0xbebb00f1,0x68e39b36,0x6d571b37}},	//   _עונה_, jtës, _wund, _arxa,
   {{0x68e39b38,0x78a29b39,0x539a83c8,0x6d5c81a8}},	//   _tund, znov, _אינו, _árac,
   {{0x9c7c811f,0x78a297ff,0x64978087,0xf8bf1b3a}},	//   _mučn, ynov, nţio, blé_,
   {{0xb05b0074,0x2121008e,0xdd8f01a8,0x672d0197}},	//   smär, duhh_, سوق_, _fqaj,
   {{0x74130077,0x20048301,0xb05b016d,0x78a29b3b}},	// [de0] صولا, _remi_, pmär, vnov,
   {{0xddb615a9,0x64409b3c,0x7c241b3d,0xe3b7146c}},	//   _محجب, zemi, sgir, убу_,
   {{0x64409b3e,0x7a7a80be,0x7c240980,0xdce801a9}},	//   yemi, ערעס, pgir, ēlēt,
   {{0xe3a78077,0xdee6997b,0x644082f9,0xd70a9b3f}},	//   _هر_, годи, xemi, енде_,
   {{0xb8eb058c,0x78a29b40,0x2bba00f7,0x9c7c811a}},	//   _री_, rnov, _ساحة_, _bučn,
   {{0x91e3091c,0x09e30652,0x7d1c9b41,0x69dc8ec3}},	//   _горе, _горн, _årsk, žrei,
   {{0x644087d9,0xafdb0aa2,0x20f3026c,0x3a2a0267}},	//   temi, ndør, _aćif_, _icbp_,
   {{0x64978087,0x78a2816b,0x3ae98129,0x115b03de}},	//   sţin, čovs, _búp_, _אדלע,
   {{0x6d580da8,0xb5fc8609,0x3ae98129,0x543b03de}},	//   _šval, _anġe, _cúp_, געפא,
   {{0x7ae61b42,0x86c681a8,0x67228084,0x64409b43}},	//   _mukt, _صيان, muoj, semi,
   {{0x27e98353,0x64409b44,0x3cf800e1,0x64978087}},	//   žane_, pemi, jprv_, cţio,
   {{0xf99304de,0x64978087,0x81d600ab,0x1fdf064a}},	//   מרת_, nţil, _সভা_, नखेड,
   {{0x44ea9b45,0x67228110,0xf4878065,0x26de9b46}},	//   _hù_, nuoj, _حالی, _kito_,
   {{0xc7b382f6,0x81d49b47,0xe45f0106,0xb05b1b48}},	//   מבר_, _колх, _snö_, fläc,
   {{0x629a9b49,0x7ae61b4a,0x44ea877f,0x6ca71b4b}},	//   mito, _aukt, _jù_, граж,
   {{0x44ea9b4c,0x7ae6085c,0x26de9b4d,0x1f750a0e}},	//   _mù_, _bukt, _lito_, _влия,
   {{0x44ea8091,0x3a3807cf,0x26de8548,0x3a2a0088}},	// [df0] _lù_, _bbrp_, _oito_, _bcbp_,
   {{0x44ea83d3,0x26de9882,0x195911e9,0x7ae61b4e}},	//   _où_, _nito_, казы_, _dukt,
   {{0x60cd1b4f,0x9c7c9b50,0x81b680ab,0x2121008e}},	//   _kham, _ručn, চের_, uuhh_,
   {{0xb4fa0158,0x26de9b51,0x89340013,0xa565803d}},	//   _שפרי, _aito_, إعلا, یگان,
   {{0x629a9b52,0xde059b53,0x2489198d,0xe758804a}},	//   kito, апли, mham_, лиці_,
   {{0x44ea9b4c,0x644f1b54,0x629a9b55,0x24891b56}},	//   _bù_, _haci, jito, lham_,
   {{0x26de82b8,0x200b1b57,0x44ea9b58,0x6f1d01ec}},	//   _dito_, kaci_, _cù_, hrsc,
   {{0x644f1b59,0xaf349125,0x24891b5a,0x44ea9b5b}},	//   _jaci, _گرفت, nham_, _dù_,
   {{0x200b003b,0x26de80a4,0x9c7c9b5c,0x6b8d1b5d}},	//   daci_, _fito_, _tučn, nzag,
   {{0x644f1b5e,0x68e700f1,0x60cd0518,0x659592b8}},	//   _laci, _kujd, _aham, _казу,
   {{0x76439b5f,0xf8661594,0x44391b60,0x644f0118}},	//   meny, авно, _obs_, _oaci,
   {{0x44391b61,0x60cd1b62,0x442b1b63,0x23608267}},	//   _nbs_, _cham, _ncc_, _šije_,
   {{0x60cd1b64,0x24891916,0x6b8d017f,0xdee61631}},	//   _dham, dham_, jzag, роги,
   {{0x44391b65,0x78a98582,0x76438365,0x96200035}},	//   _abs_, _ljev, neny, बलेट_,
   {{0x442b1b66,0x7c961b67,0x75239b68,0xf4961b69}},	//   _bcc_, арац, nunz, араю,
   {{0x3d0880cf,0x44391b6a,0x644f1b6b,0x24891b6c}},	//   _सबसे_, _cbs_, _caci, gham_,
   {{0x4439011b,0x644f1b6d,0x76439b6e,0x0206028b}},	// [e00] _dbs_, _daci, keny, изан,
   {{0x442b0098,0xe1f700bf,0x75238ab4,0x61e380ee}},	//   _ecc_, игу_, kunz, _jgnl,
   {{0x2bb80105,0x26de809c,0x644f1162,0xfe3700be}},	//   _आडवा, _rito_, _faci, _דריי_,
   {{0x26de8698,0x60cd1b6f,0x6288820f,0x629a9b70}},	//   _sito_, _xham, zhdo, zito,
   {{0x78a982fd,0x26de9b71,0x44ea9b72,0x629a9b73}},	//   _djev, _pito_, _sù_, yito,
   {{0x75239b74,0x629a8118,0x76439b75,0x67228110}},	//   funz, xito, geny, ruoj,
   {{0x6d581b76,0x629a9b77,0x3218809a,0xe9671b2f}},	//   _švaj, vito, órym_, _карл_,
   {{0xc0e31421,0x7c360789,0x26de804f,0x644f03a8}},	//   _фотк, nfyr, _wito_, _xaci,
   {{0x8aa69b78,0x629a9b79,0x76439b7a,0x26de9b7b}},	//   ирод, tito, beny, _tito_,
   {{0x32078f4c,0x60cd1b7c,0xab5b0065,0xc3330bea}},	//   _ceny_, _sham, _szük, קות_,
   {{0xa3d80076,0x2d968d91,0x60cd005d,0x68e08059}},	//   ाधड_, _трас, _pham, _kimd,
   {{0x629a9b7d,0x66088041,0x859b81c6,0x5faa8072}},	//   sito, _hedk, _בשבו, _कशाल,
   {{0xc7c7117f,0x2bd29b7e,0x3eb81706,0x4fc70071}},	//   рсни, देशा, fort_, рсна,
   {{0x644f1b7f,0x6f1d1b80,0x6d5a8f28,0x60c281f6}},	//   _saci, rrsc, _krta, hlom,
   {{0xa3ea853e,0x241901bb,0x60cd1b81,0x200b1b82}},	//   _मला_, ловы_, _tham, paci_,
   {{0x6d5a805c,0x60cd1b83,0x320c8831,0x3d180fd5}},	//   _mrta, _uham, lady_, _फिरे_,
   {{0x644f1b84,0x2284016d,0x24868282,0xa3ca816f}},	// [e10] _vaci, _söka_, _mlom_, ळेच_,
   {{0x6d5a82bb,0x78a9920e,0x78bb939c,0x62868168}},	//   _orta, _sjev, _skuv, ëkoh,
   {{0x78a98499,0xbebb00f1,0x27e482f7,0x644f1b85}},	//   _pjev, rrëd, _bgmn_, _taci,
   {{0x76439b86,0x320c84e8,0x60c29b87,0x442b1b88}},	//   weny, hady_, glom, _ucc_,
   {{0x44291b89,0x6d5a8b0b,0xfd4c80ff,0x78a985f3}},	//   mga_, _arta, _thiể, _vjev,
   {{0x75238b15,0x528500f7,0x6d5a80dd,0x7bda0039}},	//   tunz, _السك, _brta, _תקשו,
   {{0x6d5a805c,0x76439b8a,0x44291b8b,0x24869b8c}},	//   _crta, reny, oga_, _blom_,
   {{0x44291b8d,0x76439b8e,0x68e08110,0x78bb9b8f}},	//   nga_, seny, _gimd, _ukuv,
   {{0x291e85a4,0x6d5a9b90,0x75239b91,0x6d5c9b92}},	//   erta_, _erta, sunz, _áran,
   {{0xf67480f7,0x6d5a826c,0x752380b4,0x25478061}},	//   _والخ, _frta, punz, _től_,
   {{0xd9459b93,0xb4e60321,0x3eb81b94,0xd00a1b95}},	//   щени, _पढे_, vort_, лене_,
   {{0x3eb802af,0xb7bd802e,0x20090162,0xb5fc8372}},	//   wort_, _acţi, _ceai_, _inġa,
   {{0xd12e84c0,0x44291a21,0x42d580e8,0x291e9b96}},	//   ومی_, dga_, _ліку, arta_,
   {{0x201e1b97,0x44291b98,0x20090362,0x24869b99}},	//   şti_, ega_, _eeai_, _zlom_,
   {{0xe8f59b9a,0x291e8289,0x22459b9b,0x2d7e042b}},	//   _استخ, crta_, melk_, _oćeš_,
   {{0x44291b9c,0x27e08796,0xb05b1b9d,0xdb23807b}},	//   gga_, žini_, llän, _þróu,
   {{0xf8b31b9e,0x3eb81b9f,0x7afb9ba0,0x24801ba1}},	// [e20] _משה_, port_, nput, rkim_,
   {{0x34d3809a,0xb05b1614,0xa96a1ba2,0x3d0882f1}},	//   दगुद, nlän, лиза_, _सबले_,
   {{0x7c299ba3,0x6608807a,0xc6930039,0x7afb89da}},	//   kger, _redk, _מאז_, hput,
   {{0x660e01b4,0x53a6161a,0x7c2981ed,0x0aea01a8}},	//   labk, _гамб, jger, _مرسي_,
   {{0x60c2815d,0x68fb1ba4,0xb05b0338,0x8c468085}},	//   rlom, _čude, klän, qişə,
   {{0x44ee0104,0xfd650028,0x6d5a808e,0xacf89ba5}},	//   _ký_, _nguồ, _prta, анку_,
   {{0x99860307,0x27e9803a,0xb05b016d,0x5d7a00be}},	//   _الأو, žana_, dlän, טאַק,
   {{0x7c299ba6,0x629e1ba7,0x6d5a9ba8,0x66089ba9}},	//   gger, lipo, _vrta, _wedk,
   {{0x44ee0104,0xeaf78077,0xc445803d,0x320a01ac}},	//   _lý_, یریت_, زیون_, _keby_,
   {{0xaa669baa,0x27328087,0x33770039,0x39149bab}},	//   стик, mân_, צעים_, омор,
   {{0x44291bac,0x27329bad,0x6d5a8102,0x44ee007b}},	//   yga_, lân_, _urta, _ný_,
   {{0x320c9bae,0x4429002a,0x9c7c8115,0x629d8036}},	//   sady_, xga_, _mučk, ésor,
   {{0x629e1baf,0x320c8690,0x9c7c8805,0xeb33804e}},	//   kipo, pady_, _lučk, _فروخ,
   {{0x442902a3,0x62819bb0,0x249900b9,0xacf91bb1}},	//   wga_, cklo, _smsm_, ингу_,
   {{0x40351056,0x787f00f1,0x629e1bb2,0x7a538591}},	//   _дейс, _lëvi, dipo, _رضوا,
   {{0x44291bb3,0xce330077,0xcd02809a,0xa0a400a9}},	//   uga_, _کودک, mość_, _најд,
   {{0x4429078a,0x660e1bb4,0x320a1bb5,0x3a7515b7}},	// [e30] rga_, babk, _beby_, олар,
   {{0x9e071bb6,0x660e02a3,0x2eb40074,0x5b7b80be}},	//   _учил, cabk, ंकृत, ארמא,
   {{0xcd02809a,0x320a1bb7,0x9c7c811f,0x7c298be7}},	//   ność_, _deby_, _vučj, yger,
   {{0x50c90107,0xf8c90bb8,0x657a148c,0xdbd982df}},	//   रतिष, रतिय, äthe, nção,
   {{0x7aed0609,0x2ca91bb8,0x320a008e,0x62819bb9}},	//   qqat, mnad_, _feby_, yklo,
   {{0x45199bba,0xcd02809a,0xee3880e8,0x9c7c80c3}},	//   ация_, kość_, йні_, _fučk,
   {{0x20c9016f,0x7bc29bbb,0x648306ae,0x22458ec3}},	//   रताध, _ayou, _lõim, velk_,
   {{0xa2b90a0d,0x2ca91bbc,0x23608267,0x7c29823e}},	//   ्तव्, nnad_, _šija_, uger,
   {{0x2d8c157a,0xb05b148c,0xf09f023e,0x200f9bbd}},	//   údez_, tlän, dià_, magi_,
   {{0x200f9bbe,0x7afb9bbf,0x7c29996d,0x78ad07b8}},	//   lagi_, rput, sger, _ajav,
   {{0x684616de,0xb05b1bc0,0xe0461bc1,0x62819bc2}},	//   онна, rlän, онни, rklo,
   {{0x660e010b,0x6d419bc3,0x200f8074,0x61fc880a}},	//   wabk, _ipla, nagi_, ırla,
   {{0x61c6024c,0x3f841bc4,0xc1c6024c,0x3b09944c}},	//   _वर्ष, ámu_, _वर्ग, _тело_,
   {{0x200f9882,0x7c2f1bc5,0x96ba069b,0x3f8c0035}},	//   hagi_, _accr, руму_, ądu_,
   {{0xa50a0ae7,0x649a1bc6,0x7ae39bc7,0x200f9bc8}},	//   реба_, атар_, _iint, kagi_,
   {{0x90c31056,0x9c7c811f,0x660e1bc9,0x248d9bca}},	//   _обще, _ručk, sabk, nhem_,
   {{0x200f8006,0x7ae39bcb,0x8c3d8201,0xab2a1bcc}},	// [e40] dagi_, _kint, mişd, роза_,
   {{0x7ae39bcd,0x6d419bce,0x9c7c9bcf,0x66c01bd0}},	//   _jint, _opla, _pučk, töku,
   {{0x629e1bd1,0x6d418069,0xdb060106,0x443d82ec}},	//   ripo, _npla, _nykö, _obw_,
   {{0x7ae391d6,0x629e1bd2,0x69c3831d,0x442f83a8}},	//   _lint, sipo, _myne, _ncg_,
   {{0xa2cb06bf,0x7ae39bd3,0x052680ab,0x249f9bd4}},	//   _तीव्, _oint, _মনের_, dium_,
   {{0x7ae39bd5,0x0576845b,0x63a481e2,0xddc18353}},	//   _nint, قاعد, _žino, _dolž,
   {{0xa2b900bc,0x200f9bd6,0x443d9bd7,0x442f838a}},	//   ्तर्, bagi_, _bbw_, _bcg_,
   {{0x69ce1bd8,0x6d5c9bd9,0x68e41bda,0x7aeb9bdb}},	//   _izbe, _áram, _niid, _bugt,
   {{0x0a6a80c4,0xcd02809a,0x926a9bdc,0xc4d30039}},	//   арни_, wość_, арна_, וגה_,
   {{0x7ae38859,0x539b0bea,0x34a708fd,0xd90e87d2}},	//   _cint, ייפו, _गद्द, نیت_,
   {{0x7ae39bdd,0x9c7c842b,0x68e41bde,0x2b4200b9}},	//   _dint, _luči, _biid, _lpkc_,
   {{0x68e402c1,0x8c468628,0x7ae39bdf,0x248d9be0}},	//   _ciid, _феде, _eint, chem_,
   {{0x98b3811f,0x68e41be1,0x629c1be2,0xf09f0722}},	//   žeća_, _diid, _omro, rià_,
   {{0x64830665,0x7d1c9be3,0x7ae39be4,0x6d5e008e}},	//   _võim, _årss, _gint, _brpa,
   {{0xd49b1be5,0x2d85027f,0x66cd81ac,0x29119be6}},	//   ара_, ále_, núka, ázat_,
   {{0xd7fb0698,0x7ae39be7,0xbca501a8,0x7aeb8c27}},	//   _тук_, _zint, أمري, _yugt,
   {{0x2d850289,0x7de705a8,0x5334047f,0x6d5e02d5}},	// [e50] šle_, _мінд, метт, _erpa,
   {{0xe7f90076,0x64830006,0x249f9be8,0xa3e70d86}},	//   ंडवा_, _kõik, zium_, _पलक_,
   {{0x7583004e,0xdcef01a9,0x37f881bc,0x2ca91be9}},	//   _غیرم, ēdēt, _ịkụz, pnad_,
   {{0x92ab00c8,0x27e900dd,0xa2cb0aed,0x66c00106}},	//   খতে_, _jgan_, _तीर्, sökt,
   {{0x200f9bea,0x69ce1beb,0x64830074,0xae1f123a}},	//   ragi_, _ezbe, _lõik, _बयान_,
   {{0xe7e3146d,0x442f9bec,0x7bda0039,0x200f9bed}},	//   _गणना_, _scg_, _לקרו, sagi_,
   {{0x7ae39bee,0x442f8118,0x200f8c2e,0x8c3d9bef}},	//   _rint, _pcg_, pagi_, yişd,
   {{0x67228025,0x27e91bf0,0x69c38035,0x8c3d82d0}},	//   broj, _ngan_, _ryne, kişe,
   {{0x69c386be,0x68e418c2,0x248d91bf,0xdd918019}},	//   _syne, _riid, rhem_, بوں_,
   {{0x27e9035a,0x248d80f1,0x7c2d0114,0x68e41bf1}},	//   _agan_, shem_, hgar, _siid,
   {{0x63ad9bf2,0x648e8362,0x7c2d0299,0x8c3d829a}},	//   _žand, _bùid, kgar, tişd,
   {{0x2eb60d72,0x628a8019,0xdb0f01b3,0x7aeb9bf3}},	//   ृत्त, _elfo, _excé, _tugt,
   {{0xe28e8abe,0x44f180a9,0x6d5e173d,0x68e40406}},	//   _за_, _há_, _srpa, _viid,
   {{0x442d854f,0x27e91bf4,0x44f190ab,0x7c3b9bf5}},	//   lge_, _egan_, _ká_, lfur,
   {{0x44f19bf6,0x2ca002f9,0xf4840180,0x68e41bf7}},	//   _já_, tiid_, واری, _tiid,
   {{0x7c2d1bf8,0x7c3b9bf9,0x768f804a,0xb5fc822b}},	//   ggar, nfur, _høyd, _anġl,
   {{0x44f19bfa,0x442d9bfb,0x20d200f7,0x2ca01bfc}},	// [e60] _lá_, ige_, ráid_, riid_,
   {{0x9c7c8eef,0x7c2d01e4,0x394302f7,0x20d201a8}},	//   _vuči, agar, _bpjs_, sáid_,
   {{0x44f19bfd,0xd7fa8530,0x66c0016d,0x867b0039}},	//   _ná_, бул_, söks, _הריו,
   {{0x67229bfe,0x9c7c826c,0xc8799bff,0x6aa181ec}},	//   troj, _tuči, _coş_, hilf,
   {{0xd00f9b9a,0x27e08009,0x442d8039,0x44f19c00}},	//   اله_, äin_, dge_, _aá_,
   {{0x44f18324,0x628504b8,0x629c1c01,0x67229c02}},	//   _bá_, ckho, _umro, rroj,
   {{0xd94312bc,0x44f19c03,0x7c3b9c04,0x61430a8e}},	//   _пери, _cá_, ffur, _пера,
   {{0x44f19c05,0x442d9c06,0xd00f866e,0x61fb0b80}},	//   _dá_, gge_, _ملف_, _đuli,
   {{0x3d088b9f,0x76900198,0x6aa18789,0x7ce79238}},	//   _सबके_, _käyd, filf, _sırt,
   {{0xaabe1c07,0x44f19c08,0x442d9c09,0x7c2d1c0a}},	//   ्तिक, _fá_, age_, zgar,
   {{0x44f19c0b,0xe8e0001c,0x7c2d1c0c,0x6f0981ec}},	//   _gá_, _ngồi_, ygar, _zwec,
   {{0xab2a96fe,0xd90e803d,0x64830074,0x7c3b8122}},	//   _года_, پیک_, _võik, cfur,
   {{0x2bdb800f,0xaabe14a7,0x7ce78214,0x4df083eb}},	//   मेदा, ्ताक, _fırs, _चलाई_,
   {{0x68fc00eb,0x1df80a14,0x2ee50192,0xddc5128a}},	//   _otrd, зеры_, ölf_, _zahř,
   {{0x291c0065,0xd23b8039,0xdb1d01d0,0x7e6880ee}},	//   ával_, _הגול, _vysí, _mndp,
   {{0x7c2d1c0d,0x5d541c0e,0xd1388196,0xb4fb8e82}},	//   ugar, экст, mtą_, מפלי,
   {{0x7c2d1c0f,0x64978162,0x768f80e8,0x386901a8}},	// [e70] rgar, cţiu, _høye, _inar_,
   {{0x09e080c8,0x7c2d1c10,0xedf88c1c,0x6ce700e8}},	//   _ম্যা, sgar, ुरोध_, _німе,
   {{0x349502cb,0xc5fb1094,0xd1388110,0x62851c11}},	//   _жанр, ्रीय_, ntą_, rkho,
   {{0x44f19c12,0x9c7c88ae,0x78a280e5,0xdbf181d0}},	//   _rá_, _kuču, giov, třík,
   {{0x291804ae,0x2d8301e2,0xb8f406a7,0x44f19c13}},	//   _evra_, lyje_, _सी_, _sá_,
   {{0x44f19c14,0xd1388110,0x61ea810c,0xb05b1c15}},	//   _pá_, ktą_, _ngfl, fläk,
   {{0x442d8813,0x2d830110,0x38690f3e,0xe61099ea}},	//   tge_, nyje_, _onar_, اشه_,
   {{0x44f19c16,0xdbf1801b,0x442d9c17,0x78a29c18}},	//   _vá_, přík, uge_, ciov,
   {{0x44f1877f,0x6aa19c19,0x7c3b9c1a,0x26c7816b}},	//   _wá_, tilf, rfur, plno_,
   {{0x44f19301,0x6d451c1b,0x66020d11,0x38691c1c}},	//   _tá_, _opha, _đoko, _anar_,
   {{0x6fd9816f,0x386900dd,0x6d450282,0xbebb03ed}},	//   बेरं, _bnar_, _npha, trën,
   {{0xc689093f,0xbe2500ab,0x6724817f,0x768b0214}},	//   _דא_, ম্মদ_, šije, _rüya,
   {{0x6d4501f6,0x2cad9c1d,0x38b904e8,0x3ea31799}},	//   _apha, mned_, néry_, fijt_,
   {{0x2cbf9c1e,0xdce38084,0xcb1281c6,0xdd920180}},	//   loud_, tynė, _ילד_, پور_,
   {{0xdee30aac,0x7afd1c1f,0x66e31c20,0xe810800d}},	//   тори, _atst, тора, ारमा_,
   {{0x69da0073,0x68ee0326,0x2cad9c21,0x78a2802a}},	//   _útei, _rubd, nned_, xiov,
   {{0x60c41c22,0x7ae71c23,0xaca3819d,0x6d450234}},	// [e80] _ikim, _bijt, _nfọm, _epha,
   {{0x2cbf85f8,0x7bc61c24,0xab5b0019,0x68ee1c25}},	//   houd_, _vyku, _gyüm, _pubd,
   {{0xceb30158,0xbebb0168,0x63a9007b,0x994a04a3}},	//   _ביז_, ytëz, _þenn, تلال_,
   {{0x2a698326,0x7aef0493,0x672b9c26,0xb4b781d0}},	//   _ɗaba_, _fuct, fugj, चको_,
   {{0x7e7a803a,0x78a29c27,0x76900009,0x3b04026b}},	//   _potp, riov, _täyd, _dépò_,
   {{0xd1389c28,0xa9261c29,0x6b840db1,0x6eeb0197}},	//   ytą_, _одгл, myig, _użbe,
   {{0x98a68e17,0x25078061,0x68fc0824,0x60c403f7}},	//   _живе, ورٹی_, _utrd, _okim,
   {{0x2cad9c2a,0x22581c2b,0x628e00e1,0x3d1103b7}},	//   gned_, _hark_, _hlbo, _तबसे_,
   {{0x6b840f18,0xb05b0338,0x628e1c2c,0x752a8326}},	//   nyig, släk, _klbo, sufz,
   {{0x6f0285a4,0x60c41c2d,0x38691c2e,0x32549138}},	//   mpoc, _akim, _snar_, хвор,
   {{0x29189c2f,0xaca4019d,0x22580039,0x6f028118}},	//   éra_, _anọt, _mark_, lpoc,
   {{0xd1389c30,0x60d6031d,0x2d830196,0x3af29c31}},	//   rtą_, _chym, vyje_, _tâp_,
   {{0xd1388d42,0x27ed1874,0x649798ad,0x00000000}},	//   stą_, ženo_, rţit, --,
   {{0x60c41c32,0x2bd5015c,0x2d830110,0x9c7c8da8}},	//   _ekim, _दरबा, tyje_, _vuču,
   {{0x7aef81ac,0x7aef1c33,0x68fb135a,0x6d581c34}},	//   íctv, _suct, _čudo, _švar,
   {{0x628e1c35,0x76570079,0x961480ab,0x2d830110}},	//   _albo, _waxy, সলিম_, ryje_,
   {{0x3f4f04b7,0x628e016b,0x7ebf01d0,0x3ea3090d}},	// [e90] _użu_, _blbo, tápě, pijt_,
   {{0xdddc00d2,0x2d830084,0x6f0d00b4,0x2fc902c4}},	//   skrš, pyje_, _iwac, _iyag_,
   {{0x6d450234,0x22581c36,0x66151c37,0x6b841a14}},	//   _upha, _dark_, mazk, ayig,
   {{0x3869840e,0xc87982bb,0x8c3d8201,0x6f0d1c38}},	//   ñar_, _kişi_, kişa, _kwac,
   {{0x59d40e18,0x7afd068f,0x24891c39,0xfc3f0061}},	//   _थरथर, _utst, mkam_, _amíg_,
   {{0x8d558425,0x644283c9,0xed599c3a,0xaa450009}},	//   етич, _aboi, зок_, ävää_,
   {{0xa2c282f1,0xaabe1c3b,0x20e8807e,0x3f898084}},	//   रकन्, ्तरक, _işin_, šau_,
   {{0x44f51c3c,0xa3ba8b9f,0x24891c3d,0xa2b90ec5}},	//   _må_, _आँख_, nkam_, ्तक्,
   {{0x27ed9c3e,0x44f50aa2,0x2cbf9c3f,0x2cad8039}},	//   _igen_, _lå_, roud_, rned_,
   {{0x2cbf9c40,0x644d1c41,0x17fa1c42,0x00000000}},	//   soud_, heai, ूर्व_, --,
   {{0x44f50cde,0x68e98063,0xa969813a,0xaca38870}},	//   _nå_, _kied, чина_, _ajụj,
   {{0xf1b203c8,0x228082d6,0x6f0d0314,0x2bb88a74}},	//   רסט_, _bòks_, _bwac, _उँचा,
   {{0xeb8e891e,0x68e99c43,0x66150748,0x6f0d05ee}},	//   _си_, _mied, fazk, _cwac,
   {{0x52398158,0x443f9c44,0x68e99c45,0x6615011e}},	//   _זײַנ, lfu_, _lied, gazk,
   {{0x49bb83f8,0xfaff020f,0x04460468,0x64599c46}},	//   _باشد_, _atë_, невн, _kawi,
   {{0x44f51c47,0x68e99c48,0x63a48110,0x60c40010}},	//   _då_, _nied, _žini, _ukim,
   {{0x6d4107d9,0x64598010,0x22581c49,0xfc3f0032}},	// [ea0] çlar, _mawi, _park_, _ajís_,
   {{0x44f50082,0x78a61c4a,0x27ed8590,0x77641c4b}},	//   _få_, likv, _agen_, _irix,
   {{0x44f50082,0x68e99c4c,0xe5a6028b,0x35c486a7}},	//   _gå_, _bied, _чини, _लुढ़,
   {{0x7e7e0502,0x6459809a,0x78a61c4d,0xb5fc822b}},	//   _hopp, _nawi, nikv, _inġi,
   {{0x7e7e0422,0xde5885e9,0x17548198,0x225806ae}},	//   _kopp, далі_, твля, _tark_,
   {{0x20120032,0x27ed8f06,0x443f874b,0x7e7e1c4e}},	//   _leyi_, _egen_, efu_, _jopp,
   {{0x80d100c8,0x52be1c4f,0x64830074,0x7e7e052e}},	//   _সংস্, ्तीस, _võiv, _mopp,
   {{0x7764062f,0x7e7e1c50,0xd4978ca4,0x44321c51}},	//   _orix, _lopp, ерь_, ngy_,
   {{0x64599c52,0x82a68d55,0x61f303ed,0x764e1c53}},	//   _dawi, ешне, _çelë, keby,
   {{0x2d96867c,0x68e980eb,0x60c28074,0x2012026b}},	//   _прес, _zied, loom, _aeyi_,
   {{0xddc88754,0x6f1b8024,0x39478b99,0x78a61c54}},	//   _hodž, _zvuc, _cpns_, fikv,
   {{0x645982b8,0x765a80b9,0xddc8817f,0x27ed04d6}},	//   _gawi, _haty, _kodž, øen_,
   {{0x44f50bfa,0x765a9c55,0x66150102,0x77641c56}},	//   _så_, _katy, tazk, _crix,
   {{0x44f50082,0x36d515d1,0x64598063,0xa6e780ff}},	//   _på_, тогр, _zawi, _nhữ,
   {{0xd5b81c57,0xb81081fe,0x66150cc7,0x7e7e1c58}},	//   ест_, ाराम_, razk, _dopp,
   {{0x77641041,0x39138098,0x3f868176,0x765a9c59}},	//   _frix, _смър, kyou_, _laty,
   {{0x68e99c5a,0x60c282a3,0x439417c8,0x77640118}},	// [eb0] _ried, doom, гатс, _grix,
   {{0x6d488022,0x765a9c5b,0x68e99c5c,0x66d2007b}},	//   _opda, _naty, _sied, lækn,
   {{0x68e99c5d,0x673d1388,0x7aea81b9,0x39470722}},	//   _pied, ltsj, _mift, ïns_,
   {{0x20d20307,0x26c5826f,0xe0df1c5e,0x7e7e00e5}},	//   háin_, _sklo_, nmò_, _zopp,
   {{0x64599c5f,0x23d50f12,0x68e99c60,0x765a9c61}},	//   _rawi, _दरिद, _vied, _baty,
   {{0x68e99c62,0x64599c63,0x945d809a,0x7aea9c64}},	//   _wied, _sawi, końc, _nift,
   {{0x68e98364,0x64599c65,0xd6580039,0x443f9c66}},	//   _tied, _pawi, גיות_, tfu_,
   {{0x2d51800d,0x67249c67,0x27ed806a,0x0b459c68}},	//   _vše_, šija, _ugen_, внин,
   {{0x645b9c69,0xe2998e9f,0x443f9c6a,0x6f1b8699}},	//   rdui, дап_, rfu_, _uvuc,
   {{0x64598010,0x09e500ab,0x765a9c6b,0x443f9c6c}},	//   _wawi, _প্যা, _gaty, sfu_,
   {{0x81c98a49,0x20120f23,0xe9d98987,0x3ea78019}},	//   লেন_, _peyi_, ько_, mint_,
   {{0x387f83d3,0x7e0a0076,0x3ea79c6d,0x64830006}},	//   _jour_, वर्ग_, lint_, _mõis,
   {{0xa4d4835f,0x80d100ab,0x087680be,0x2d879c6e}},	//   _соці, _সংশ্, דערט_, lyne_,
   {{0x9f9e0073,0x3ea79c6f,0x60c29c70,0x78a61c71}},	//   _ação_, nint_, zoom, sikv,
   {{0x69ca8355,0x2d8c1c72,0x764e1c73,0x765c1c74}},	//   _gyfe, áde_, reby, rdry,
   {{0x29059c75,0x09b000ab,0x764e1c76,0x765c1c77}},	//   mpla_, _করলা, seby, sdry,
   {{0x7e7e12f1,0xf4128158,0x753c0063,0xfce3137b}},	// [ec0] _topp, יפן_, strz, рото,
   {{0x64830074,0xddc89c78,0x386d83ba,0xdee61c79}},	//   _sõit, _rodž, _aner_, _шопи,
   {{0xfbc78077,0x386d9142,0x3ea79c7a,0xa2b31c7b}},	//   _چت_, _bner_, dint_, _आदर्,
   {{0xfbc7880b,0x2eca8bb3,0x387f80e7,0x765a9c7c}},	//   _نت_, ित्त, _cour_, _saty,
   {{0x765a8110,0x64830006,0x69d50019,0x387f9c7d}},	//   _paty, _võit, _ezze, _dour_,
   {{0x3ea79c7e,0x6f0207d9,0x649580f7,0x60c29c7f}},	//   gint_, _çocu, _láid, soom,
   {{0x82a30071,0x64b38087,0xfaa31b2f,0xc60b80ab}},	//   _тарж, răin, _таро, _রাখা_,
   {{0x44221c80,0xb4cc816f,0x69ca8428,0x70569c81}},	//   _jdk_, ळते_, _ryfe, _جنرا,
   {{0xee3a9c82,0x44221c83,0x8c3d880a,0x20d201a8}},	//   _она_, _mdk_, mişl, táin_,
   {{0x63a90110,0x3ea79c84,0x7c2900eb,0x44221c85}},	//   _ženk, cint_, _ķerm, _ldk_,
   {{0x387f873a,0x6d488add,0x63ad8125,0xe1348196}},	//   _your_, _upda, _þann, ынны,
   {{0x387f1c86,0x20d20013,0x63a481e2,0x386d04c3}},	//   ður_, sáin_, _žinu, ñer_,
   {{0x26c31c87,0x7aea84b7,0x7c229c88,0x66d2006a}},	//   tojo_, _tift, _idor, rækn,
   {{0x44f890ab,0x39580267,0x6d5c81a8,0x6fe901a9}},	//   _ké_, _osrs_, _áras, _rīcī,
   {{0x44f8877f,0x44220359,0x3958026c,0x673d006f}},	//   _jé_, _bdk_, _nsrs_, stsj,
   {{0x44f89c89,0x273b8104,0x65650267,0x80d10264}},	//   _mé_, yên_, _vrhh, _সূর্,
   {{0x44f88324,0x20191c8a,0x1af41c8b,0x26c31c8c}},	// [ed0] _lé_, masi_, иптя, pojo_,
   {{0x20d20013,0x7e5500e8,0x68ed0362,0x44f881a8}},	//   háil_, _своє, _hiad, _oé_,
   {{0x387f9c8d,0x6618826f,0x68ed0019,0x3ea79c8e}},	//   _pour_, davk, _kiad, vint_,
   {{0x64830074,0x66020da8,0xdb1d0198,0x22840106}},	//   _võis, _đoki, _pysä, _sökt_,
   {{0xfeb80288,0x9cd60f60,0x20d200f7,0x3ea79c8f}},	//   _سایت_, _תורה_, dáil_, tint_,
   {{0x44f89c90,0x645d1c91,0x0ccb8eed,0x2ca9031d}},	//   _bé_, _hasi, ात्म, liad_,
   {{0x20191c92,0x44f88013,0x88838077,0x3ea79c93}},	//   kasi_, _cé_, _پیشن, rint_,
   {{0x2366803b,0x44f89c94,0x20d20013,0x2ca9031d}},	//   _broj_, _dé_, gáil_, niad_,
   {{0x645d1c95,0x661890d3,0x44391c96,0x69da01d0}},	//   _masi, bavk, _mcs_, _úter,
   {{0x44f8877f,0x2019002e,0x4439038a,0x7c228f3e}},	//   _fé_, easi_, _lcs_, _edor,
   {{0x2019022e,0x44f8877f,0xa29f8006,0x68ed01e4}},	//   fasi_, _gé_, गोष्, _biad,
   {{0x645d1c97,0x20191c98,0x68f51c99,0x20d200f7}},	//   _nasi, gasi_, _muzd, cáil_,
   {{0x7bcb87d9,0x32458767,0x68ed1c9a,0x2ca90355}},	//   _uygu, _белг, _diad, diad_,
   {{0xed5a0b30,0xb4be1c9b,0x248d801b,0x29059c9c}},	//   ног_, ेत्_, lkem_, ppla_,
   {{0x68ed1c9d,0x2ca9031d,0x68f500d2,0x20191c9e}},	//   _fiad, fiad_, _nuzd, basi_,
   {{0x6abe0f1b,0x68ed1c9f,0x2ca9031d,0x64a31ca0}},	//   ्त्र, _giad, giad_, баса,
   {{0x6b899ca1,0xab6607ac,0x645d1ca2,0x2fcd822c}},	// [ee0] nyeg, ывал, _dasi, _nyeg_,
   {{0x248d8006,0x68ed1ca3,0x60c98deb,0x60db9ca4}},	//   hkem_, _ziad, _akem, _ahum,
   {{0x645d1ca5,0x44221ca6,0x60db9ca7,0xb05b01ec}},	//   _fasi, _tdk_, _bhum, plät,
   {{0x60db9ca8,0x44f89ca9,0x645d1caa,0xb05b1cab}},	//   _chum, _ré_, _gasi, llär,
   {{0x44f89cac,0x43751cad,0x60db8077,0x8c3d861c}},	//   _sé_, _курт, _dhum, rişl,
   {{0x44f88324,0x4ab8000c,0x645d1cae,0x248d81ed}},	//   _pé_, _आदिव, _zasi, ekem_,
   {{0x20191014,0x645d0309,0x20d20013,0x765e004f}},	//   yasi_, _yasi, táil_, _mapy,
   {{0x6f04007d,0x44f8801c,0x60db80b9,0x765e02d5}},	//   _otic, _vé_, _ghum, _lapy,
   {{0x36368277,0x2019059e,0xe80a835a,0x20d20013}},	//   _مراس, vasi_, _ह्या_, ráil_,
   {{0x44f89caf,0x20191cb0,0xfaff0168,0x20d200f7}},	//   _té_, wasi_, _orën_, sáil_,
   {{0x6f041cb1,0x68ed1cb2,0xe3af89a7,0x32638084}},	//   _atic, _piad, قری_, стыв,
   {{0x6d5a9cb3,0x68e29cb4,0x60db9cb5,0x6f1d1cb6}},	//   _ista, nmod, _xhum, tssc,
   {{0xb4c0823c,0xb4c2835a,0x2ca6813c,0x68ed1cb7}},	//   ंकी_, ृती_, _imod_, _viad,
   {{0x20191cb8,0x68ed1cb9,0x256387d9,0x645d1cba}},	//   sasi_, _wiad, _yıl_, _sasi,
   {{0x645d1cbb,0x68ed1cbc,0x6f040b87,0x201910e1}},	//   _pasi, _tiad, _etic, pasi_,
   {{0x69d89cbd,0x245802c7,0x752801ac,0x645d1cbe}},	//   _izve, лась_, ádza, _qasi,
   {{0x645d1cbf,0x2ca91cc0,0x68f51cc1,0x291e9cc2}},	// [ef0] _vasi, riad_, _suzd, lsta_,
   {{0x60db8b18,0x645d1cc3,0x60c99cc4,0x291e9276}},	//   _shum, _wasi, _skem, osta_,
   {{0x645d1cc5,0x6d5a9cc6,0x41551cc7,0x81e68264}},	//   _tasi, _nsta, рвес, যুর_,
   {{0x291e913f,0x765e009a,0x3cfb8035,0x69ce0366}},	//   ista_, _zapy, _लंबे_, _dybe,
   {{0x8335093f,0x65689cc8,0x6d5a9cc9,0x2b401cca}},	//   _דאָס_, _ardh, _asta, ctic_,
   {{0x291e9ccb,0x7aee01ec,0x83fd8019,0x68f51ccc}},	//   ksta_, _gibt, zdőd, _tuzd,
   {{0x248d8419,0xd61881a8,0x291c01d0,0x2ca68197}},	//   tkem_, اتها_, ávat_, _bmod_,
   {{0x03258abe,0x291e8106,0x9f05803d,0xac858037}},	//   адин, dsta_, _نورو, ргил,
   {{0x291e9ccd,0x6d5a8c8c,0x656880f1,0xeb998530}},	//   esta_, _esta, _erdh, тип_,
   {{0xea899cce,0x78ab8aa2,0x7aa599f8,0x64878388}},	//   тбол_, ligv, риоз, _añit,
   {{0xe807053e,0xd9459ccf,0xe0da1cd0,0x26c79cd1}},	//   _व्हा_, шени, кво_, mono_,
   {{0xaca301bc,0x6e250014,0x26c79cd2,0x290381a9}},	//   _brọd, _adhb, lono_, īja_,
   {{0xe28e8abe,0x291e9cd3,0xb8fc9cd4,0x765e06c0}},	//   _да_, asta_, _ती_, _papy,
   {{0x91e59cd5,0x6d5a8114,0x26c78365,0x539a8039}},	//   _коле, _ysta, nono_, _בינו,
   {{0xb05b08dc,0x26c7847f,0x5fd80072,0x68e29bad}},	//   rlär, iono_, _ठरवल, ymod,
   {{0xdd8f0eca,0x77860098,0x62839cd6,0x765e004f}},	//   ذوق_, _влиз, _hono, _wapy,
   {{0x6f041601,0xd3870d70,0x26c79cd7,0x23e00424}},	// [f00] _utic, айте_, kono_, पेंद,
   {{0x26c78110,0x2b401cd8,0xa01b1cd9,0x64440162}},	//   jono_, rtic_, sköt, sfii,
   {{0x2b401cda,0x628380e5,0xd83a81e5,0xf67b0158}},	//   stic_, _mono, вэл_, _סאטמ,
   {{0x2b401cdb,0x69ce003e,0x504685fa,0x650201bc}},	//   ptic_, _vybe, редб, _ọkwụ,
   {{0x26c79cdc,0xdfcf8013,0xbebb00f1,0x44fc1cdd}},	//   fono_, ويم_, rrëv, _hí_,
   {{0x44fc0324,0x62839cde,0x661c1cdf,0x68e284fe}},	//   _kí_, _nono, nark, smod,
   {{0x44fc1ce0,0xb87b000d,0xa01b0106,0xa3e3864a}},	//   _jí_, dmín, ljöe, फेस_,
   {{0x44fc1ce1,0x661c011e,0x3218008e,0x38601ce2}},	//   _mí_, hark, _hery_, _nair_,
   {{0xf749803d,0xa2c2816f,0xb7fd0424,0x321800b9}},	//   _مجله_, रकल्, _एलबम_, _kery_,
   {{0x62839ce3,0x26c79ce4,0x661c1ce5,0x7f3b825f}},	//   _cono, cono_, jark, _בעמו,
   {{0x44fc1ce6,0x6d5a9ce7,0x62839ce8,0x7c261ce9}},	//   _ní_, _usta, _dono, _odkr,
   {{0x291e9cea,0x38601ceb,0xdcee0110,0x66171cec}},	//   rsta_, _cair_, mybė, _sexk,
   {{0x44269ced,0x661c1cee,0x44fc1cef,0x38601cf0}},	//   _ido_, fark, _aí_, _dair_,
   {{0x44fc1cf1,0x661c1cf2,0x3f4280ff,0x27fe01d0}},	//   _bí_, gark, _mưu_, ětna_,
   {{0x3f428028,0x44269cf3,0x88d600ab,0xdcee0084}},	//   _lưu_, _kdo_, _সংরক, nybė,
   {{0x44fc1cf4,0x316d1cf5,0x30150187,0xd4981cf6}},	//   _dí_, _čez_, _удир, ару_,
   {{0x26c7861b,0x60cd1cf7,0x69ca8a74,0x24581cf8}},	// [f10] yono_, _ikam, _सुती, шать_,
   {{0x996713f1,0x661c1cf9,0xdcee0084,0x3b09011c}},	//   ител, cark, kybė, rpaq_,
   {{0xd3668288,0x44269cfa,0x161a8063,0x26c78098}},	//   _که_, _odo_, _नज़र_, vono_,
   {{0x776984c3,0xa3cc81a2,0x44269cfb,0x40359cfc}},	//   _prex, _शुभ_, _ndo_, седс,
   {{0x26c79cfd,0x753501b9,0x32181cfe,0x60cd0c53}},	//   tono_, luzz, _fery_, _mkam,
   {{0xc9871a02,0x51871cff,0xee3880e8,0x76551d00}},	//   _куби, _куба, ині_, nezy,
   {{0x09e50a49,0x31e500c8,0x99850013,0x01e500c8}},	//   _প্রা, _প্রশ, _الزو, _প্রদ,
   {{0x69ca9d01,0xa8a48160,0x442680f1,0xe5709a37}},	//   _सुधी, _друк, _cdo_, بطه_,
   {{0x6b8d1d02,0x26c79d03,0x661c1d04,0x201d95d7}},	//   nyag, pono_, yark, mawi_,
   {{0x60cd0b15,0x44269d05,0x81c280c8,0x38601d06}},	//   _akam, _edo_, ্ধন_, _sair_,
   {{0xb87b026f,0x69ca8441,0xec15803d,0x661c1d07}},	//   rmín, _सुदी, _هواد, vark,
   {{0x656e8307,0x44fc077f,0x201d83f8,0x62839d08}},	//   _ábha, _rí_, nawi_, _wono,
   {{0x44fc1d09,0x2d8a834a,0x6d439d0a,0xafdb013c}},	//   _sí_, _über_, ltna, lføj,
   {{0x629a9d0b,0xb05b0106,0x201d9d0c,0x7e63808e}},	//   chto, släp, hawi_, ndnp,
   {{0x7e619d0d,0x661c02a3,0x201d9d0e,0x7c9602a9}},	//   _malp, rark, kawi_, брац,
   {{0x661c1d0f,0x3860003c,0x201d9d10,0x44fc1d11}},	//   sark, _uair_, jawi_, _ví_,
   {{0xd4671194,0xc9f600f7,0x201d80ee,0xb2260e02}},	// [f20] щите_, مساع, dawi_, ймал,
   {{0x44fc1d12,0xe8108526,0x753501b9,0x2bac0072}},	//   _tí_, ार्थ_, buzz, _घेणा,
   {{0x81c98a49,0x32180051,0x3f42801c,0x75351d13}},	//   লের_, _very_, _sưu_, cuzz,
   {{0xa01b016d,0x443d9d14,0x26ca0234,0x7f4280e5}},	//   nköp, _ncw_, lobo_, ttoq,
   {{0x20020bda,0x645601cc,0x6d4380ff,0x649c8174}},	//   icki_, meyi, etna, _héig,
   {{0xa01b0364,0x2480005c,0x7e619d15,0xdcee0110}},	//   hköp, ljim_, _calp, tybė,
   {{0x201d82e7,0x7f4281b9,0x2cad9d16,0x25e39d17}},	//   bawi_, stoq, fied_, टेली_,
   {{0x69dc1d18,0x64561d19,0x44269d1a,0xdcee0084}},	//   _izre, neyi, _qdo_, rybė,
   {{0x6d698029,0x4426856c,0x57fb810f,0x26ca1d1b}},	//   _īpaš, _vdo_, _תלמו, kobo_,
   {{0x60cd1d1c,0x6d5e1d1d,0x321881ac,0xe810801b}},	//   _skam, _ospa, úry_, ारका_,
   {{0x2cad8b3c,0x44269d1e,0x67240da8,0x20f3026c}},	//   bied_, _tdo_, _avij, _ućit_,
   {{0x55778158,0x44269d1f,0x661a837b,0x629a80f1}},	//   _לעבן_, _udo_, _hetk, shto,
   {{0x6724003a,0x6d5181dd,0x29079d20,0x24800503}},	//   _cvij, čkaš, _etna_, djim_,
   {{0x672402fd,0x69dc017f,0x24868282,0x753504b7}},	//   _dvij, _ozre, _hoom_, tuzz,
   {{0x248681e9,0x59cf8aed,0x321e9d21,0xdd940048}},	//   _koom_, _सुपर, maty_, пары,
   {{0x753512bb,0x8c3d87d9,0x60cd1d22,0x6b8d1d23}},	//   ruzz, tişi, _ukam, tyag,
   {{0x6d5e1d24,0x26ca1d25,0xfbd30154,0x69dc00ee}},	// [f30] _espa, bobo_, ستر_, _azre,
   {{0x63a9095e,0x661a9d26,0x201d9d27,0xbebb0168}},	//   _žens, _netk, wawi_, rrës,
   {{0x6724120e,0x2bd50d86,0x201d9d28,0x6f160035}},	//   _zvij, _दरका, tawi_, _zwyc,
   {{0x2ec186bf,0x24868282,0x6e289d29,0x4fd58171}},	//   शक्त, _noom_, _addb, ожет,
   {{0xf1cf8105,0x643a00be,0x201b008e,0xddda81a1}},	//   _सुनन, _דערנ, _meqi_, _rotš,
   {{0x3eae8e23,0x661a80d2,0x6d439d2a,0x443d8079}},	//   gift_, _cetk, ttna, _scw_,
   {{0x7e619d2b,0x78bb8711,0x7d0201d6,0x201d876d}},	//   _valp, _tjuv, _čosk, pawi_,
   {{0x62988aa2,0xcc898bda,0x6d439d2c,0x672281c0}},	//   _alvo, рбие_, rtna, bsoj,
   {{0x6287003a,0x6d439d2d,0x7e619d2e,0x254e811c}},	//   _kojo, stna, _talp, _cəlb_,
   {{0xa9259d2f,0x24800bda,0x6f099086,0x4ea78a2e}},	//   одол, zjim_, _itec, _урба,
   {{0x6724030b,0x3f8f8355,0x2d678024,0x24868069}},	//   _svij, lygu_, _uđe_, _foom_,
   {{0x649c8174,0xa91100d4,0x6287046d,0x7de00032}},	//   _réig, डीएफ_, _lojo, _lásí,
   {{0x661a8457,0x321e9d30,0x776d00e5,0x2d851d31}},	//   _yetk, baty_, _crax, älen_,
   {{0x21699d32,0x64499d33,0xa9699d34,0xfc3f023e}},	//   _вики_, lfei, _вика_, _ací_,
   {{0x649c8307,0x26ca1d35,0xa2ba03dd,0x249902f7}},	//   _féid, robo_, ्वस्, _blsm_,
   {{0x7c3b9d36,0x24869d37,0x26ca1d38,0x2fc0022c}},	//   ngur, _xoom_, sobo_, _txig_,
   {{0x6724030b,0x62871d39,0x776d1d3a,0x52aa0471}},	// [f40] _uvij, _bojo, _grax, авам_,
   {{0x62871d3b,0x649c80f7,0x64561d3c,0x1ae31d3d}},	//   _cojo, _téig, seyi, доум,
   {{0x661a9d3e,0x6f0980e5,0xa01b0106,0x62871d3f}},	//   _retk, _atec, ljöa, _dojo,
   {{0x50ca009a,0x661a9d40,0x20ca001b,0x67228198}},	//   रविष, _setk, रविध, tsoj,
   {{0x44201d41,0x661a84c4,0x24868039,0xe8e08129}},	//   mai_, _petk, _room_, hiệt_,
   {{0x2a630267,0x24869d42,0x6b8b0106,0x6d5c02ed}},	//   _gajb_, _soom_, ägge, owra,
   {{0xd49a80c4,0x24869d43,0x661a9d44,0x69dc01a9}},	//   ири_, _poom_, _vetk, _uzre,
   {{0x44201d45,0xb19880ff,0x734a8087,0x672d9d46}},	//   nai_, _ngưỡ, ачов_, šaja,
   {{0x68fc1d47,0x61ef8085,0x649c81a8,0x1fd180ab}},	//   _hurd, əklə, _réid, ়েবস,
   {{0x68fc1d48,0x38669d49,0x7c3b9d4a,0x20e89238}},	//   _kurd, ldor_, agur, _eşit_,
   {{0x44201d4b,0x69ca946d,0xe45a835f,0x24868282}},	//   kai_, _सुशी, _вже_, _toom_,
   {{0x44201d4c,0x68fc1d4d,0x776d1d4e,0x290a0267}},	//   jai_, _murd, _prax, _mtba_,
   {{0x44201d4f,0x69ca864d,0x610180eb,0xe6671229}},	//   dai_, _सुरी, _vēla, отво,
   {{0x81c980ab,0x2455001c,0x7658804f,0x809f0035}},	//   লেই_, _ấm_, nevy, खोजे,
   {{0x44201d50,0xbd681d51,0x62870388,0x00950162}},	//   fai_, орте_, _rojo, _никэ,
   {{0x44201d52,0x776d062f,0x628700a4,0x7c209d53}},	//   gai_, _trax, _sojo, namr,
   {{0x62871d08,0x8c3d8214,0x1eab00f7,0x7bc10035}},	// [f50] _pojo, mişt, _نادي_, _ślub,
   {{0x8c3d9d54,0x7afd9d55,0x1b040264,0x68fc1d56}},	//   lişt, ísti, _লিখে_, _burd,
   {{0x44201d57,0x6f099d58,0x7c209d59,0xad27003d}},	//   bai_, _stec, kamr, _برخو,
   {{0xe8f806b5,0x649580f7,0x8c3d8087,0x68fc1d5a}},	//   ілі_, _cáil, nişt, _durd,
   {{0xb9020076,0xb4d7016f,0xcb4400a9,0x62871d5b}},	//   _नी_, िती_, _охри, _tojo,
   {{0x81cd00c8,0x7afd1d5c,0x8afa01c6,0x24678129}},	//   শেষ_, _iust, _להשי, _ốm_,
   {{0xceb40158,0x6d471d5d,0x855780d5,0x649580f7}},	//   ויס_, ntja, تیار_, _fáil,
   {{0x7af50102,0x81c28264,0x442b1d5e,0x00000000}},	//   _hizt, ্ধা_, _jdc_, --,
   {{0xbf1592dc,0x64499d5f,0x7c3b9d60,0xe3b180f7}},	//   _رواب, rfei, rgur, عرب_,
   {{0x78ad1d61,0x64499d62,0x7c3b9d63,0x44201d64}},	//   _amav, sfei, sgur, zai_,
   {{0x81cd00c8,0x44201d65,0x68fc04c3,0x644f1d66}},	//   শের_, yai_, _xurd, _obci,
   {{0xa3ac0665,0x7c2081a1,0x44201d67,0x29e1841c}},	//   _कइल_, camr, xai_, _açaí_,
   {{0x442006f7,0x7afd01e2,0xb4c9816f,0xf77201a8}},	//   vai_, _nust, ोती_, راح_,
   {{0x44201d68,0x59cf86a7,0x91fc81a9,0x200d811c}},	//   wai_, _सुथर, ndāl, əmiş_,
   {{0x44201d69,0x7c960160,0x649580f7,0x442b00e5}},	//   tai_, прац, _láim, _bdc_,
   {{0x2be292ee,0x249f80a9,0x7afd1d6a,0xa3e28074}},	//   _परमा, nhum_, _bust, _धरम_,
   {{0x7af51d6b,0x44201d6c,0x59cf8076,0x7afd1d6d}},	// [f60] _bizt, rai_, _सुतर, _cust,
   {{0x44201d6e,0x7c2080ee,0x2bce954b,0x7afd1d6f}},	//   sai_, zamr, _हँसा, _dust,
   {{0x68e40ad4,0x442b03f7,0xa3ac11bc,0x2be29d70}},	//   _khid, _fdc_, _केर_, _परभा,
   {{0x7afd1d71,0x20d21d72,0x68fc054f,0x69d51d73}},	//   _fust, máis_, _vurd, _dyze,
   {{0x7afd1d74,0x68fc034a,0x6726035f,0x672d812b}},	//   _gust, _wurd, nskj, šajn,
   {{0x425503bd,0x68fc1d75,0x63a41d76,0x543600d7}},	//   _отст, _turd, mzin, _برگر,
   {{0x7afd1d77,0x63a41d78,0x649581a8,0x321c82fe}},	//   _zust, lzin, _táil, _revy_,
   {{0x2ca0076d,0x7de70019,0xf7469b3f,0xc5f301c6}},	//   nhid_, lésé, _небо, עדה_,
   {{0x7afd062f,0x8fa39d79,0xe45703de,0x7de2826b}},	//   _xust, _зате, ליקט_, _bísí,
   {{0x63a41d7a,0x3a749d7b,0xcb1301c6,0x8f9b825f}},	//   izin, флор, עלת_, _הימי,
   {{0xa3cc8076,0x4035072a,0xade89d7c,0xfbc400ab}},	//   _शुर_, менс, टेशन_, ্ধিত,
   {{0x290a8341,0x68e41d7d,0x7bc30162,0x20d21d7e}},	//   ība_, _chid, şnui, dáis_,
   {{0x68e41d7f,0x442b1d80,0x63a400f3,0x8c3d9d81}},	//   _dhid, _rdc_, jzin, rişt,
   {{0x63a41d82,0x7afd1d83,0x442b0267,0x6d471d84}},	//   dzin, _rust, _sdc_, ttja,
   {{0xe5c4079e,0xd49b1d85,0x71f78154,0x78ad026f}},	//   есто, бра_, _عروس_, _tmav,
   {{0xb4d70e18,0xe45f0125,0x6d471d86,0x68e41d87}},	//   िते_, _mjög_, rtja, _ghid,
   {{0x6d4704a4,0x628a9d88,0xc62280ab,0xa3e71d89}},	// [f70] stja, _kofo, _নানা_, यें_,
   {{0x6f0d1d8a,0xbd020144,0x8f9c01c6,0x628a8e06}},	//   _itac, ñéca, _ליחי, _jofo,
   {{0xb5fc84b7,0x78bd1d8b,0x442b006a,0x20d21d8c}},	//   _paġn, onsv, _tdc_, cáis_,
   {{0x442b1d8d,0xddde1601,0x69d501ac,0x2ca01d8e}},	//   _udc_, _uopš, _vyze, chid_,
   {{0x644d00b9,0xf7459d8f,0x5f94804a,0x7afd03ca}},	//   mfai, фело, ницт, _uust,
   {{0x628a81a9,0x20d200f7,0x6442802a,0x644d1d90}},	//   _nofo, náir_, _acoi, lfai,
   {{0x236d0858,0x249f9670,0x7d1a9670,0x24e99d91}},	//   _šejh_, thum_, _cwts, омки_,
   {{0x644d1d92,0x649580f7,0x9f6500e1,0xfd5e801c}},	//   nfai, _táim, _štýl_, _huyề,
   {{0x7690025d,0x6f0d1d93,0x80c900ab,0x32059d94}},	//   _käyt, _ntac, রগঞ্, tcly_,
   {{0x09059baa,0x68e41d95,0xd0480085,0x20d20216}},	//   мпон, _shid, əməy, yáis_,
   {{0x63a40098,0x661e1d96,0x6e239d97,0xdd9b8087}},	//   zzin, _repk, manb, _уша_,
   {{0x644280f7,0x7de70019,0x6f1b81bc,0xf485853d}},	//   _gcoi, zésé, _kwuc, _تائی,
   {{0x644d00f7,0xe3ae89a8,0x628a9d98,0x10a31d99}},	//   dfai, _рб_, _fofo, тиян,
   {{0x76900364,0x7afd9d9a,0x12fa8039,0xddc38019}},	//   _näyt, ístu, _והסב, lenő,
   {{0x2ca00014,0x644d1d9b,0x768f804a,0x2c0b0135}},	//   thid_, ffai, _høys, _ụjọ_,
   {{0x443f9d9c,0x63a41d9d,0x672981ca,0x20d200f7}},	//   ngu_, tzin, _ovej, ráis_,
   {{0xc61d00c8,0x6e239d9e,0x7de70019,0x236d806a}},	// [f80] _তারা_, kanb, tésé, nvej_,
   {{0x248b00b9,0x2ca01d9f,0xe45f0106,0x6b8b0106}},	//   _eocm_, shid_, _sköt_, ägga,
   {{0x64a6014c,0x443f8ad4,0x81d600ab,0xc5fa02f1}},	//   _жана, kgu_, াইভ_, ंशीय_,
   {{0x765c1da0,0x753c1da1,0x38ab0035,0x644d01a8}},	//   lery, murz, _górę_, cfai,
   {{0x7c240f2b,0x201f808e,0x2b490aae,0x672981a1}},	//   mair, _deui_, ctac_, _cvej,
   {{0x7c241da2,0x64428013,0x443f9da3,0x2458801c}},	//   lair, _scoi, egu_, _ẩm_,
   {{0x26ce9da4,0xa01b007b,0x3d12016f,0xaca401bc}},	//   rofo_, fjöl, धीचे_, _naịt,
   {{0x7c241da5,0x628a82af,0x7764002a,0x2be28fb2}},	//   nair, _sofo, _osix, _परदा,
   {{0x9ce88117,0x6e239da6,0xd00f8bbe,0x648e8229}},	//   _ہوئے_, banb, _خلق_, _bùir,
   {{0x7c241da7,0x765c1da8,0x648e851e,0xee379da9}},	//   hair, jery, _cùir, _ону_,
   {{0x3a37078d,0x7c241daa,0x60cf0087,0xe873003d}},	//   ורים_, kair, tocm, نندگ,
   {{0x78a29dab,0x6f00804f,0x645b9dac,0x2baf8b99}},	//   nhov, _kumc, ceui, _जेवा,
   {{0x7c241dad,0xb90582ef,0x23e295a7,0x628a8915}},	//   dair, _बी_, _परिद, _tofo,
   {{0x44249dae,0xb4d70054,0x768f835f,0x59cf8f21}},	//   lam_, ित्_, _høyr, _सुवर,
   {{0x77641daf,0xa2cb86b7,0x20c70be2,0x3ce68069}},	//   _esix, सकर्, _осиг, _khov_,
   {{0x44249db0,0x64409db1,0x7c240c5e,0xa3e29344}},	//   nam_, ngmi, gair, _धरा_,
   {{0xf8bf0efc,0x644d1db2,0x69d880f3,0x765c02ec}},	// [f90] mné_, rfai, _hyve, bery,
   {{0x44249db3,0x386901d8,0xf8bf03cb,0xfd5e8028}},	//   ham_, _haar_, lné_, _quyề,
   {{0x44249db4,0x6729811f,0x443f9db5,0x59d482f1}},	//   kam_, _svej, ygu_, _ठुमर,
   {{0xf8bf1db6,0x3869133a,0x7c241db7,0x656500b9}},	//   nné_, _jaar_, cair, _ishh,
   {{0x38691db8,0x6e239db9,0x76900364,0xe0d880e8}},	//   _maar_, tanb, _täyt, єві_,
   {{0x81c980ab,0x451989b5,0xa01b0061,0x6d4a9dba}},	//   লেট_, пция_, gköz, ftfa,
   {{0xf8bf1dbb,0x44249dbc,0xddde0035,0x645b9dbd}},	//   kné_, fam_, _zapł, teui,
   {{0x38691dbe,0x78a28775,0x6ac79516,0xf8bf027f}},	//   _naar_, chov, रक्र, jné_,
   {{0xf8bf0a56,0x610180eb,0x254e8085,0xaca40870}},	//   dné_, _vēlm, _həll_, _saịt,
   {{0x443f831d,0x961e001b,0x236d806a,0xf1bf81d6}},	//   sgu_, _बजेट_, rvej_, ášok_,
   {{0xe9d98098,0xae748065,0x236d806a,0xf99181a8}},	//   яко_, _جھنڈ, svej_, ابخ_,
   {{0x6e21811e,0x3ce681c0,0xf8bf00e7,0x7cc180eb}},	//   _helb, _ghov_, gné_, mēro,
   {{0x386901d8,0x442f9dbf,0x9f4c080a,0x7c2400eb}},	//   _daar_, _idg_, _ölüm_, vair,
   {{0x78a2826f,0x2cbf8074,0xade406ae,0x7ce58144}},	//   zhov, lnud_, _गरदन_, sórd,
   {{0x7c241dc0,0x69d88a8e,0xf8bf1dc1,0xc692810f}},	//   tair, _gyve, bné_, נאל_,
   {{0x386902a3,0xf8bf026f,0x23ce800d,0x765c1dc2}},	//   _gaar_, cné_, _हुँद, sery,
   {{0x7c241dc3,0x765c1dc4,0xfa3607c3,0x26d11dc5}},	// [fa0] rair, pery, فراد, bozo_,
   {{0x7c241dc6,0x2be29344,0x0566046a,0x4a431dc7}},	//   sair, _परसा, _звон, лнув,
   {{0x44249dc8,0x442f979d,0x6f009dc9,0xf29683de}},	//   yam_, _odg_, _sumc, עכער_,
   {{0xafdb0bc5,0x76900009,0x38a201ac,0x44249dca}},	//   mfør, _täys, _fóre_, xam_,
   {{0xa01b0019,0x2cbf8074,0x78a29dcb,0x76450114}},	//   tköz, dnud_, rhov, _ychy,
   {{0x7d0182a3,0xf8bf03fb,0x44221dcc,0x60c401a1}},	//   _buls, zné_, _hek_, _ljim,
   {{0xb7bd802e,0xa0a680e8,0x78a2816d,0x6e218bbd}},	//   _reţe, _завд, phov, _delb,
   {{0x6d4a8e23,0x3ce6946a,0x442f85db,0xb4ca858c}},	//   rtfa, _qhov_, _cdg_, लके_,
   {{0xf8bf0ed7,0x64408006,0xe7378785,0x628e1dcd}},	//   vné_, rgmi, _пет_, _kobo,
   {{0xc3331dce,0x44248304,0x628e1dcf,0x6e219dd0}},	//   נות_, sam_, _jobo, _gelb,
   {{0xf8bf0a56,0x386914f9,0x7afd826f,0x3ce681e9}},	//   tné_, _paar_, ístr, _thov_,
   {{0x26f909a3,0x44221dd1,0xdd8f817e,0x386902a3}},	//   ंद्र_, _nek_, _دوم_, _qaar_,
   {{0xf8bf1dd2,0x6108801b,0x7af89dd3,0x60c41dd4}},	//   rné_, _děla, _tivt, _djim,
   {{0x386901d8,0xf8bf003e,0x7c2280f7,0x65650267}},	//   _waar_, sné_, _heor, _pshh,
   {{0xf8bf003e,0xf1d00128,0x7c22808e,0xafdb1dd5}},	//   pné_, _तुलन, _keor, gfør,
   {{0x11db8051,0x44221dd6,0x629a9dd7,0x7c22808e}},	//   _מחוב, _cek_, lkto, _jeor,
   {{0x628e1dd8,0x213e9a2e,0x2a7c890d,0x7c2f92ca}},	// [fb0] _bobo, luth_, _knvb_, ócri,
   {{0xd0198935,0x44221dd9,0x629a9dda,0x628e1ddb}},	//   दर्भ_, _eek_, nkto, _cobo,
   {{0x628e1ddc,0x649c8036,0xb8128264,0x2bd1052a}},	//   _dobo, _réin, _হয়ত_, _थुरा,
   {{0x6e218352,0xb4ca83bb,0x7cc180eb,0x89341ddd}},	//   _selb, लको_, vēro, اعلا,
   {{0x6e219cbc,0x7d019dde,0x4f0890ac,0x36699ddf}},	//   _pelb, _suls, енін_, дало_,
   {{0x628e02c1,0xed599016,0x44221de0,0x442f9de1}},	//   _gobo, док_, _zek_, _sdg_,
   {{0x6abf0770,0x2cbf8074,0xa158054c,0x6e219de2}},	//   ्वीर, tnud_, _пару_, _velb,
   {{0x24891de3,0x628e1de4,0x629a9de5,0x6e219de6}},	//   njam_, _zobo, ekto, _welb,
   {{0x6e219de7,0x7c229de8,0x2ef59016,0xd0498326}},	//   _telb, _deor, _азар, _sheɗ,
   {{0x3da79285,0x29030010,0xb87b01d0,0x60d60338}},	//   _преб, _kuja_, hlíd, _skym,
   {{0x10a600e8,0x98a61593,0x7c228706,0x290313de}},	//   винн, вине, _feor, _juja_,
   {{0x92c380c8,0x61fa1de9,0x2efa026c,0x7c229dea}},	//   ্ষে_, _útle, _sipf_, _geor,
   {{0xeb8e964f,0x672d026c,0xc62600ab,0xda658088}},	//   _ти_, _cvaj, _বাবা_, _авли,
   {{0x76438393,0x44221deb,0xa7fb04c3,0x66e61dec}},	//   ngny, _sek_, xeñe, тога,
   {{0xceb29a0f,0x2a6a07c7,0x44220214,0x27ff90ab}},	//   בים_, _rabb_, _pek_, _ogun_,
   {{0xafdb0257,0x7c2283a8,0x6fb601a8,0x3958018e}},	//   rfør, _xeor, _لمعا, _rprs_,
   {{0x63a99ded,0xb87b1dee,0xe8d71def,0x44221df0}},	// [fc0] nzen, rmít, _בוקר_, _vek_,
   {{0x68e99df1,0x63a981ed,0xafdb004a,0x27ff810c}},	//   _ahed, izen, pfør, _agun_,
   {{0x44221df2,0x68e98362,0x29030187,0x68fb8084}},	//   _tek_, _bhed, _cuja_, _biud,
   {{0x68fb9df3,0x7794803d,0xb87b03a8,0x649c81a8}},	//   _ciud, هیزا, lmír, _céil,
   {{0xdfd280f7,0x63a981ed,0x649c81a8,0x2d980061}},	//   جيش_, jzen, _déil, lyre_,
   {{0x63a99df4,0x7c2294ff,0x27ff80ad,0x6e9481a8}},	//   dzen, _seor, _egun_, طلبا,
   {{0xd9e605b3,0x68469d32,0x649c80f7,0x7c229df5}},	//   _करित_, _инва, _féil, _peor,
   {{0x61e307d9,0x68fb8098,0x68e98c9f,0x7afc1df6}},	//   ünle, _giud, _ghed, _hirt,
   {{0x69dc016d,0x69ca8fd5,0x7afc1df7,0x3dd28035}},	//   _hyre, _सुजी, _kirt, ływ_,
   {{0xbbe283eb,0x7afc02a3,0x60c29df8,0x5be29008}},	//   _परीक, _jirt, lnom, _परीव,
   {{0xe6be1513,0x672d0110,0x5d869df9,0x2d9803ed}},	//   ोवैज, _svaj, _جلال, jyre_,
   {{0x6f0400f7,0x60c29dfa,0x213e9dfb,0x6d5a8214}},	//   _buic, nnom, ruth_, _ipta,
   {{0x63a98d38,0x7afc0c41,0xb4be9a1c,0x59b2801b}},	//   czen, _oirt, ँची_, ुपहर,
   {{0x6f041dfc,0x7ce59dfd,0x71749ab3,0x3f8682df}},	//   _duic, móra, _مهتا, ixou_,
   {{0xddda801b,0x5c071dfe,0x69dc006f,0xb5fc81b9}},	//   _patř, вяза, _nyre, _baġi,
   {{0x7afc0013,0x3eb80083,0x672d80eb,0x2fc901c0}},	//   _airt, airt_, šaji, _txag_,
   {{0x649c80f7,0x24891dff,0xb87b1e00,0x56951246}},	// [fd0] _réil, rjam_, smís, _бапт,
   {{0x22470065,0x6d5a9e01,0x68e99e02,0x29031e03}},	//   ünk_, _opta, _shed, _puja_,
   {{0xa3e70076,0xa2ba0f21,0x2d8c03ba,0xddc89e04}},	//   येज_, ्वज्, ødet_, _andž,
   {{0x69dc1e05,0xf8d180c8,0x60c29e06,0x7afc1e07}},	//   _dyre, িষ্ঠ, gnom, _eirt,
   {{0x44291e08,0xc43a0051,0x6d5a8df1,0x68fb9e09}},	//   maa_, _אתרי, _apta, _viud,
   {{0xf7708c2a,0x44291e0a,0x64958013,0x4aa71e0b}},	//   غان_, laa_, _láit, _गतिव,
   {{0x68e99e0c,0x20d91e0d,0x200981df,0xb87b0187}},	//   _thed, néis_, ñais_, ilíb,
   {{0x44291e0e,0x63a99e0f,0x2005009a,0x7d051e10}},	//   naa_, tzen, ślij_, _muhs,
   {{0xddc183bb,0x7b758199,0xaca38133,0xe8949e11}},	//   _dalš, اطبا, _ntụl, _тать,
   {{0x63a99e12,0x44291e0e,0x45459e13,0xd90c8065}},	//   rzen, haa_, _منطق, ڈیو_,
   {{0x44291e14,0x63a99e15,0x26c30353,0xaca38135}},	//   kaa_, szen, dnjo_, _atụl,
   {{0xe73a09a8,0x44291e16,0x20d91e17,0x3da49e18}},	//   нем_, jaa_, déis_, _труб,
   {{0x442902a3,0xb8cc1e19,0x7c299e1a,0x6f040039}},	//   daa_, _गत_, maer, _quic,
   {{0x2d9800f1,0x25ef035a,0x66e3816f,0x386d867f}},	//   tyre_, _आणखी_, गतिक_, _laer_,
   {{0x09be00c8,0xada307b6,0x44291e1b,0x6da315e0}},	//   _অর্থ, барл, faa_, бира,
   {{0x38a21e1c,0x442902a3,0x7afc1e1d,0xb87b1e1e}},	//   _fóra_, gaa_, _sirt, smír,
   {{0x2d9e15d8,0x09be1664,0x38a2009a,0x7afc1e1f}},	// [fe0] šte_, ्थ्य, _góra_, _pirt,
   {{0x7c298114,0x649c80f7,0x0e661e20,0x20d91e21}},	//   haer, _réim, _скон, béis_,
   {{0x386d8358,0x44291e22,0x20d90e1b,0x7c298102}},	//   _baer_, baa_, céis_, kaer,
   {{0x7afc1e23,0x386d9e24,0x00da8eca,0x4fa69e25}},	//   _wirt, _caer_, ربات_, лиев,
   {{0xbbe2801b,0x386d9e26,0x7c299e27,0x7afc1e28}},	//   _परेक, _daer_, daer, _tirt,
   {{0x7afc01a8,0x20d901a8,0x3fcb9e29,0x78a40580}},	//   _uirt, néir_, ردنی_, _lliv,
   {{0xf9879e2a,0x2aa40065,0x64958013,0x7c2606cb}},	//   _اب_, _több_, _náis, _kekr,
   {{0xa01b1e2b,0x386d8286,0x7c299e2c,0xb4de8072}},	//   ljöv, _gaer_, gaer, णते_,
   {{0x40938064,0x649580f7,0x7c261e2d,0x26da01bc}},	//   _القر, _ráit, _mekr, _okpo_,
   {{0x415498a2,0x78a41e2e,0x59b8102e,0x629e1e2f}},	//   авос, _aliv, _आधार, nkpo,
   {{0x78a41e30,0x442902c1,0x7c2982c4,0x6e250214}},	//   _bliv, yaa_, baer, _rehb,
   {{0x44290962,0x7c26003a,0x26da0133,0xe3bf0511}},	//   xaa_, _nekr, _akpo_, _leña_,
   {{0x44291e31,0xe29a81e2,0xe0df00e5,0x91fc81a9}},	//   vaa_, _пад_, rlò_, edāt,
   {{0x44291e32,0x20d91e33,0x386d1e34,0x442680ff}},	//   waa_, téis_, žer_, _heo_,
   {{0x44291e35,0x44269e36,0x78a40609,0x254e811c}},	//   taa_, _keo_, _fliv, _bəli_,
   {{0x442682a5,0x649580f7,0x26da01bc,0x20d91e37}},	//   _jeo_, _háir, _ekpo_, réis_,
   {{0x44291e38,0x7c261e39,0x20d91e3a,0xbbe281a2}},	// [ff0] raa_, _dekr, séis_, _परोक,
   {{0x44291e3b,0x44269e3c,0x27e900ad,0x7ce58125}},	//   saa_, _leo_, _izan_, jórn,
   {{0x44291e3d,0x68ed1e3e,0x649581a8,0x64ac0162}},	//   paa_, _khad, _máir, rşir,
   {{0x44268046,0x7c2600c9,0x0467133c,0xb4c0800d}},	//   _neo_, _gekr, _стом, ूको_,
   {{0xd366896c,0xddd70201,0x68ed1e3f,0x2ca900f7}},	//   _به_, _yaxş, _mhad, mhad_,
   {{0x1eea80d5,0xca49003d,0x63ad036a,0x9a870a4c}},	//   نونی_, _جلسه_, mzan, _сумл,
   {{0x44269e40,0x63ad1e41,0x1ddb00d4,0x41e4102a}},	//   _beo_, lzan, _मुमत, _гіта,
   {{0x61fa01fa,0x68ed1e42,0x27e91e43,0x44269e44}},	//   _útla, _nhad, _ozan_, _ceo_,
   {{0x63ad1e45,0x44269e46,0xbf1587bd,0x7c2982ec}},	//   nzan, _deo_, _ضواب, raer,
   {{0xdfd88698,0x60c98a38,0xa7fb01df,0x68ed004f}},	//   _със_, _hjem, xeña, _ahad,
   {{0x008609a0,0x78a40a20,0x27e91e47,0x442681ca}},	//   ално, _pliv, _azan_, _feo_,
   {{0x7e639e48,0x672d8042,0xac198638,0x44269e49}},	//   lenp, šaju, _роду_, _geo_,
   {{0x6d439e4a,0x81bd80c8,0x63ad0669,0x249f81e0}},	//   luna, _আরও_, jzan, mkum_,
   {{0xe296806d,0x63ad1988,0xbb3a8039,0x8f9a83de}},	//   _ваш_, dzan, _יעני, דישי,
   {{0x6d439e4b,0x60db9e4c,0x68ed008c,0x20d900f7}},	//   nuna, _okum, _fhad, réir_,
   {{0x60c99351,0xa7fb040e,0x68ed1e4d,0x44269e4e}},	//   _njem, seña, _ghad, _xeo_,

   {{0xd4670572,0x3b071927,0x6d439341,0xe3bf1e4f}},	// [1000] шите_, ието_, huna, _peña_,
   {{0x29079e50,0x3ce01e51,0x60c9846d,0x248d83ba}},	//   _kuna_, sliv_, _ajem, hjem_,
   {{0x6d439e52,0x29079e53,0x249f808b,0x64599e54}},	//   juna, _juna_, kkum_, _obwi,
   {{0x3ea59e55,0x29079e56,0x26d81e57,0x315680be}},	//   _allt_, _muna_, loro_, ייען_,
   {{0x29079e58,0xe3bf04c3,0x63ad009a,0x60c98168}},	//   _luna_, _teña_, czan, _djem,
   {{0x44269e59,0x8d768416,0x60c985b4,0x64599e5a}},	//   _seo_, لاعا, _ejem, _abwi,
   {{0x6d43859c,0x290783c3,0x7d78803d,0x6e2a9e5b}},	//   guna, _nuna_, امبر_, rafb,
   {{0x26d81e5c,0xd7668065,0x60c99e5d,0x2ca01e5e}},	//   horo_, _پارٹ, _gjem, nkid_,
   {{0x44269e5f,0x64958013,0x29079e60,0xb5fc81b9}},	//   _veo_, _páir, _auna_, _raġu,
   {{0x29079e61,0x781f0e00,0x6d5e1e62,0x3a278118}},	//   _buna_, पर्क_, _oppa, _cenp_,
   {{0x26d81e63,0x44269e64,0x63ad1e65,0x27e004b9}},	//   doro_, _teo_, zzan, _ayin_,
   {{0xd83f83c1,0x7ae19e66,0x644b8122,0x6b9b9e67}},	//   _účtu_, allt, _gcgi, byug,
   {{0x6d5e1e68,0x64958013,0x61050110,0x27e0008e}},	//   _appa, _táir, _vėli, _cyin_,
   {{0x26d81e69,0x7d089e6a,0xd0650085,0x291a008e}},	//   goro_, _kuds, _əsər, kppa_,
   {{0x29078057,0x6e289e6b,0x68ed1e6c,0x3cf3016f}},	//   _guna_, _medb, _thad, ंगले_,
   {{0x1b1980c8,0x63ad1e6d,0x7d089b6c,0x7cc180eb}},	//   _দিতে_, tzan, _muds, tēri,
   {{0x26d81e6e,0x6d439e6f,0x2ca91e70,0x78bd1e71}},	// [1010] boro_, zuna, rhad_, misv,
   {{0x26d81e72,0x60c995db,0x29079e73,0x6d4397e2}},	//   coro_, _sjem, _yuna_, yuna,
   {{0xceb20159,0x2f0b8022,0x83fd8019,0x249f9e74}},	//   _זיי_, _søg_, ndőr, ykum_,
   {{0x6d438365,0x78bd1e75,0x68e29e76,0xa49b07f1}},	//   vuna, nisv, glod, _diòc,
   {{0x95e90065,0x7c2d1e77,0x7e639e78,0x7ae19e79}},	//   _جبکہ_, maar, tenp, yllt,
   {{0x7c2d1e7a,0x6d439e7b,0x7d089e7c,0x22950174}},	//   laar, tuna, _buds, _الآس,
   {{0x365c0039,0x2ca681a3,0x60c9942f,0x248d807a}},	//   דכונ, _blod_, _tjem, tjem_,
   {{0x58d49e7d,0x7c2d1e7e,0x60db9e7f,0x26d801bc}},	//   _дост, naar, _ukum, zoro_,
   {{0x290783c3,0x6d439e80,0xf77384c0,0x248d9e81}},	//   _suna_, suna, _باز_, rjem_,
   {{0x6d439e82,0x249f9e83,0x7c2d1e84,0x29000074}},	//   puna, skum_, haar, _siia_,
   {{0xf769004c,0x26d80698,0x6f0986a5,0x6f161e85}},	//   _רק_, voro_, _huec, _styc,
   {{0x26d81e86,0x7c2d1e87,0x645982a0,0x290780fe}},	//   woro_, jaar, _ubwi, _vuna_,
   {{0x442d9e88,0x6f0981ca,0x7c2d1e89,0x290002f1}},	//   mae_, _juec, daar, _viia_,
   {{0x442d9e8a,0x64499e8b,0x6f098144,0xc7d6807c}},	//   lae_, lgei, _muec, מורי_,
   {{0x26d81e8c,0x776d03a8,0xf1cf8651,0x62839e8d}},	//   roro_, _esax, _सुचन, _inno,
   {{0x7c2d1e8e,0x26d81e8f,0x64499e90,0xdd8f1e91}},	//   gaar, soro_, ngei, روق_,
   {{0x09b500c8,0x2ca000ee,0x442d8118,0xbebb00f1}},	// [1020] _জুলা, rkid_, iae_, rsër,
   {{0x442d9e92,0xe3a78065,0x2ca01e93,0xe7db8327}},	//   hae_, _ہر_, skid_, _बड़प,
   {{0x7c2d1e94,0x9e7b00be,0xed4594a0,0x04ca00f7}},	//   baar, _ענטפ, _تھ_, _مودي_,
   {{0x6c861e95,0x6e2e1e96,0x777b9e97,0x7c2d0079}},	//   _الحم, labb, _brux, caar,
   {{0x44201e98,0x3ebc8bfa,0x7d08803a,0x442d9e99}},	//   mbi_, tivt_, _suds, dae_,
   {{0xcd2909d7,0x6e2e1e9a,0x6f099e9b,0x62951e9c}},	//   _حسین_, nabb, _duec, _gozo,
   {{0x7d088359,0x61431e9d,0x649581a8,0x2b401e9e}},	//   _quds, _нера, _páip, lric_,
   {{0x62839e9f,0x5b148d91,0x6e2e1ea0,0x44201ea1}},	//   _anno, омит, habb, nbi_,
   {{0xdc9b0158,0x213e831d,0x78a2816b,0x657a8114}},	//   טיקל, wrth_, mkov, _wrth,
   {{0x290a1ea2,0x78a29ea3,0xd91a9ea4,0x6e2e1ea5}},	//   _kuba_, lkov, льм_, jabb,
   {{0xd48f9ea6,0x7c2d02a3,0x290a1ea7,0x442d82b8}},	//   _ер_, yaar, _juba_, bae_,
   {{0x442000fe,0x7d1c016b,0x62838c2e,0x2ca68122}},	//   jbi_, dprs, _enno, _ulod_,
   {{0x7c2d1ea8,0x44200805,0x2bd811bc,0xa7fb165f}},	//   vaar, dbi_, _भुला, reño,
   {{0x442d1234,0x29181ea9,0x7c2d02b5,0xae1405fc}},	//   _že_, _otra_, waar, तुलन_,
   {{0x3abb804c,0x7c2d1eaa,0x8af00201,0x6ca702eb}},	//   _תמונ, taar, ktəb, браж,
   {{0x44201eab,0x941913f1,0xfbe98326,0xd4981eac}},	//   gbi_, ржат_, _øªù_, бру_,
   {{0x7c2d1ead,0x61150201,0x78a2826f,0x6e2e1eae}},	// [1030] raar, _işlə, dkov, babb,
   {{0x7c2d1eaf,0x7d028068,0xf8bf0036,0xff5001a8}},	//   saar, _lios, lié_, _أخي_,
   {{0x290a1083,0xe3bf04c3,0x6f09957a,0x44201eb0}},	//   _cuba_, _teño_, _suec, bbi_,
   {{0x290a00a4,0x6d471eb1,0xec6b0a0e,0xfc3f128a}},	//   _duba_, muja, _срок_, _zlín_,
   {{0x7c208713,0x6d4704be,0x6d5500ad,0x44391eb2}},	//   dbmr, luja, ltza, _ids_,
   {{0x442d9eb3,0x442b1eb4,0x29071571,0x44391eb5}},	//   wae_, _hec_, ínas_, _hds_,
   {{0x6d5500ad,0x442b0101,0x290a1eb6,0x6d47007a}},	//   ntza, _kec_, _guba_, nuja,
   {{0x6e2e1eb7,0xdfd58790,0x78a287df,0x6d550102}},	//   zabb, _добы, ckov, itza,
   {{0x442d9eb8,0x290a1eb9,0x7d029eba,0x442b1ebb}},	//   rae_, _zuba_, _dios, _mec_,
   {{0xadf9000f,0x442b01a9,0x6d471ebc,0x27ed8102}},	//   ंधान_, _lec_, kuja, _izen_,
   {{0xf8bf02be,0xa88a1ebd,0x44391ebe,0x7d028046}},	//   fié_, айна_, _ods_, _fios,
   {{0x25d6893f,0x44391ebf,0x442b1ec0,0x6d4701ac}},	//   _ווען_, _nds_, _nec_, duja,
   {{0x2cad813c,0x78a99ec1,0x6e2e1ec2,0x60cd1ec3}},	//   mhed_, _mlev, tabb, _djam,
   {{0x78a99ec4,0x05db0105,0x78a2826f,0x9c130135}},	//   _llev, _मुहब, zkov, _kọwa,
   {{0x6e2e1ec5,0x78a983ff,0xde03035f,0xfc3f0118}},	//   rabb, _olev, дпри, _clío_,
   {{0x03260698,0x44201ec6,0x2cad806a,0x290a1ec7}},	//   ждан, ubi_, nhed_, _ruba_,
   {{0x78a29ec8,0x290a1ec9,0x7c2b9eca,0x3eba09ca}},	// [1040] vkov, _suba_, _megr, _tmpt_,
   {{0x44201ecb,0x645d0609,0x644f047f,0xa01b0106}},	//   sbi_, _ebsi, _ecci, ljöp,
   {{0x78a294f0,0x78a98022,0x38669ecc,0x2d780289}},	//   tkov, _blev, teor_, _uče_,
   {{0xddc89807,0x290a00b4,0x7a400091,0x803703de}},	//   _nadš, _vuba_, _bátà, ַנצע_,
   {{0x78a294f0,0xf8b30051,0x7d0281a8,0x61e38366}},	//   rkov, ושא_, _rios, _lynl,
   {{0x7d029ecd,0x290a1ece,0x877b010f,0x7b09129b}},	//   _sios, _tuba_, יאני, _džud,
   {{0x7c2b9ecf,0x78a285b7,0x27ed9ed0,0x98a69ed1}},	//   _begr, pkov, _ezen_, _диве,
   {{0x61ee012b,0x442b1ed2,0x2cad9ed3,0x78a987f1}},	//   _izbl, _xec_, ghed_, _glev,
   {{0x7cc18029,0xccf302f6,0x320d080a,0xf8bf1ed4}},	//   vērt, וכה_, _şeyi_, vié_,
   {{0x23620748,0x7d029ed5,0x290483e4,0x60cd1ed6}},	//   _mpkj_, _wios, _hima_, _sjam,
   {{0x61e38355,0xc27b010f,0x29049ed7,0x291880f1}},	//   _cynl, בריי, _kima_, ëra_,
   {{0x7c2b96a1,0xb87b00f7,0x29049ed8,0xbb8695a9}},	//   _gegr, rlío, _jima_, _ولاي,
   {{0x24869ed9,0x29189482,0x29049d96,0x81d600ab}},	//   _inom_, ūra_, _mima_, াইট_,
   {{0x26dc8289,0x6d471eda,0x442b1edb,0x6f1d0bfd}},	//   novo_, tuja, _sec_, rpsc,
   {{0xdcbb1edc,0x442b1edd,0xf8bf1ede,0x61e38114}},	//   аща_, _pec_, pié_, _gynl,
   {{0x29048353,0x62988efc,0x5b151edf,0x6d55011e}},	//   _nima_, _hovo, змат, rtza,
   {{0x442b0c79,0x62989c24,0x2486805c,0x63a09ee0}},	// [1050] _vec_, _kovo, _mnom_, nymn,
   {{0x78a9800d,0x2904826b,0x291e808e,0x78bb8088}},	//   _slev, _aima_, opta_, _smuv,
   {{0x24868052,0x29049ee1,0x89d900f7,0x26dc9ee2}},	//   _onom_, _bima_, حوار_, dovo_,
   {{0xf7718307,0x29049092,0x44391ee3,0x644f0081}},	//   فات_, _cima_, _uds_, _ucci,
   {{0x8e859ee4,0x7c2205e4,0xddc883f2,0x7c2b9ee5}},	//   згле, ñore, _radš, _regr,
   {{0xa1370077,0x7ce59ee6,0xd6db9ee7,0x31351715}},	//   _ورزش, móri, ште_, _негр,
   {{0x62871ee8,0x6f0d008c,0x78a9826c,0x2cad9ee9}},	//   _injo, _luac, _tlev, thed_,
   {{0x644d1eea,0x7cc180eb,0x78bb80b4,0x29049eeb}},	//   ngai, vērs, _umuv, _gima_,
   {{0x6f0d0013,0x2cad813c,0x649c80f7,0x61e38370}},	//   _nuac, rhed_, _réit, _synl,
   {{0xd2a98009,0x2cad8051,0x649c9eec,0x62989eed}},	//   ское_, shed_, _béis, _covo,
   {{0x62989eee,0xa9699eef,0x21699ef0,0x2b490144}},	//   _dovo, щина_, щини_, huac_,
   {{0x2009002a,0x6f0d0834,0x92cb80ab,0x67299ef1}},	//   _cgai_, _buac, লতে_, _kwej,
   {{0x61fe803e,0x291e8087,0x7ea200e7,0x2d8512f1}},	//   _úpln, apta_, _hôpi, ålen_,
   {{0x6d439ef2,0x6f0d03ac,0xe3b0826a,0x59bd047d}},	//   orna, _duac, _جرم_, ्पार,
   {{0xb7bd8087,0xf3f98087,0xa5d606a7,0x10a61ef3}},	//   _deţi, deţi_, _मुखौ, _никн,
   {{0x649c80f7,0x62871ef4,0x6ab406a7,0x5f761ef5}},	//   _héir, _anjo, ंफ्र, _فاخر,
   {{0x7ce59ef6,0x6b6309c7,0x7cd38162,0x69c3002a}},	// [1060] góri, нкта, căre, únen,
   {{0x6d410013,0x644d008c,0xe2970162,0x6d438bcf}},	//   álac, agai, пау_, krna,
   {{0xfe9b00be,0x386001b9,0xd24f1ef7,0x80669ef8}},	//   _היימ, _kbir_, انم_, звеж,
   {{0x649c8013,0x62871ef9,0xe7f3001b,0x2f10823e}},	//   _léir, _enjo, _घरमा_, _pàg_,
   {{0x44321efa,0x7c241efb,0x66e69efc,0x6d439efd}},	//   may_, mbir, пода, erna,
   {{0x7f429efe,0x44321eff,0x332001e0,0xb603816b}},	//   rroq, lay_, mpix_, _otáč,
   {{0x29048503,0x6298817f,0xacf881e2,0x490b801b}},	//   _tima_, _rovo, онку_, _ठूलो_,
   {{0x44321efa,0x26dc825b,0x7c241f00,0x649c9995}},	//   nay_, sovo_, nbir, _réis,
   {{0x62989f01,0x7d061f02,0x33200e23,0x6d438427}},	//   _povo, _miks, npix_, arna,
   {{0x44321f03,0x2cfa05fc,0x7d061f04,0x60c29f05}},	//   hay_, ्दुल_, _liks, liom,
   {{0x05db0576,0xcc128133,0x80b083eb,0xb7bd8087}},	//   _मुंब, _bọtị, ंसपे, _reţi,
   {{0x48ab19fe,0x7d061f06,0x24868bb1,0x75d381a8}},	//   стом_, _niks, _unom_, _ثيما,
   {{0x7c241f07,0x44321f08,0x6298807a,0x765c0428}},	//   dbir, day_, _tovo, ffry,
   {{0xd24f80a0,0x7c241f09,0x9c13019d,0x291e9f0a}},	//   _منه_, ebir, _lọta, ppta_,
   {{0x443201b4,0xda5b8496,0x6d4a9f0b,0xc9869f0c}},	//   fay_, _הכול, nufa, _хули,
   {{0x44321f0d,0x7ce580a9,0xb4d7023c,0x7c241f0e}},	//   gay_, tóri, ाके_, gbir,
   {{0x2d8c1f0f,0x7d061f10,0xf3f9802e,0xddde011c}},	// [1070] äder_, _diks, teţi_, _tapş,
   {{0x78ad0a56,0x290e9f11,0x6d4a9f12,0x644d1f13}},	//   _hlav, _kufa_, kufa, sgai,
   {{0x44321f14,0x7c241f15,0xa9070591,0x7ce58187}},	//   bay_, bbir, سبان, sóri,
   {{0x443202c1,0x26c31f16,0xd138102a,0x6d4a9f17}},	//   cay_, lijo_, яху_, dufa,
   {{0x3b640021,0x7eaf80e8,0x9c1301bc,0xb4e90ec5}},	//   _първ, _løpe, _dọta, यती_,
   {{0x78ad1f18,0x6d4382a5,0x26c30353,0x628704b7}},	//   _llav, trna, nijo_, _unjo,
   {{0x60c29f19,0x672480eb,0x2d571f1a,0x290e89ab}},	//   biom, ģija, nçe_, _nufa_,
   {{0xc9520039,0x60c28706,0xdb009a1f,0x6729838a}},	//   _שמן_, ciom, lymè, _twej,
   {{0x1ee7819f,0x2d570214,0x81df00ab,0x8f55803d}},	//   _فوری_, hçe_, দেশ_, _زناش,
   {{0x44321f1b,0xb4e91f1c,0x2d5702d0,0x26c31f1d}},	//   zay_, यतु_, kçe_, jijo_,
   {{0x81df150b,0x443202c1,0x26c31f1e,0x78ad1f1f}},	//   দের_, yay_, dijo_, _blav,
   {{0xcea91a63,0x443202c1,0xb4d703bb,0x78ad0018}},	//   _די_, xay_, ाको_, _clav,
   {{0x610c07d9,0x44320205,0x7d061f20,0x26c3007a}},	//   _işle, vay_, _riks, fijo_,
   {{0x44321f21,0x60c2809a,0x78ad1f22,0x7d061f23}},	//   way_, ziom, _elav, _siks,
   {{0x44321f24,0x998583f8,0xfce61f25,0x7d060077}},	//   tay_, _آلبو, дово, _piks,
   {{0x442f9f26,0x1ad580ab,0x3ce91f27,0x61fa008b}},	//   _jeg_, _হওয়া, glav_, _útli,
   {{0x442f9f28,0xa8570051,0x7c241f29,0x44321f2a}},	// [1080] _meg_, _חיפה_, rbir, ray_,
   {{0x44321f2b,0x26c30db7,0x7c241503,0x7d060242}},	//   say_, cijo_, sbir, _wiks,
   {{0x44321f2c,0xa96a045b,0x7d061f2d,0xd91000d7}},	//   pay_, تمام_, _tiks, ایر_,
   {{0x442f86c0,0x44320079,0x53ad83eb,0x7c2f1f2e}},	//   _neg_, qay_, टनाश, _gecr,
   {{0x3eac82c4,0x69d51f2f,0x7ae8805f,0x7ae385ee}},	//   _pldt_, _exze, yldt, _oknt,
   {{0xd25212dc,0x442f8006,0x6d589f30,0x60c29f31}},	//   _جنس_, _aeg_, ttva, siom,
   {{0x442f9f32,0xafdb0edd,0x20569a1b,0x443d8609}},	//   _beg_, ngør, _отар, _bdw_,
   {{0x63a402a3,0x442f8069,0x290e9f33,0x26c3007a}},	//   oyin, _ceg_, _rufa_, zijo_,
   {{0x63a41f34,0x442f9f35,0x629c1f36,0x9c13019d}},	//   nyin, _deg_, _koro, _kọra,
   {{0x68e41f37,0x629c1f38,0x395801c0,0x3b0780e7}},	//   _akid, _joro, _kqrs_, _cinq_,
   {{0x67228029,0x6da6845a,0x629c1f39,0x26c30353}},	//   lpoj, _تمام, _moro, vijo_,
   {{0x629c0397,0xa9c380e8,0x3f861f3a,0x3cfa0035}},	//   _loro, тськ, _šoua_, ्दों_,
   {{0xceeb1c12,0x26c3007a,0xe81e0035,0x7c2f1f3b}},	//   قرآن_, tijo_, पड़ा_, _recr,
   {{0x629c1f3c,0x442f80f3,0xb4d709c1,0x290e9f3d}},	//   _noro, _zeg_, ाक्_, _tufa_,
   {{0xd49b1f3e,0x26c30353,0x6f08951e,0x26ce9f3f}},	//   ора_, rijo_, _midc, info_,
   {{0xb4e91885,0x6b829f40,0x9f5500e8,0x26c3007a}},	//   यते_, _krog, _звич, sijo_,
   {{0x629c1f41,0x7ce580f7,0x7c220511,0x26c3007a}},	// [1090] _boro, mórt, ñora, pijo_,
   {{0x27e91f42,0xddc38162,0x672d04be,0x68fd1f43}},	//   _iyan_, nenţ, _iwaj, lmsd,
   {{0x610c080a,0x629c1f44,0x7c2f0214,0x2a781f45}},	//   _oğlu, _doro, _tecr, _darb_,
   {{0x6b829f46,0x2cb2031d,0x27e900a4,0x38a21f47}},	//   _orog, chyd_, _kyan_, _fóru_,
   {{0x442f9f48,0x63b60063,0x629c1f49,0xb8d78105}},	//   _reg_, czyn, _foro, _छत_,
   {{0x442f8cde,0xd3560051,0x629c1f4a,0x9c13019d}},	//   _seg_, _אישי_, _goro, _tọsa,
   {{0x26c981dd,0xddc3802e,0x201281a8,0x672d1f4b}},	//   đao_, denţ, íniú_, _lwaj,
   {{0x628a9f4c,0xf1b200be,0xeb999508,0x394c82c4}},	//   _anfo, _עסן_, зии_, duds_,
   {{0x27e9076d,0x68f60114,0x6b829f4d,0x442f9f4e}},	//   _nyan_, _rhyd, _crog, _veg_,
   {{0x442f8574,0xddc38087,0x291101d4,0x2ef49ac0}},	//   _weg_, genţ, _kuza_, _азур,
   {{0x442f9f4f,0x6b829f50,0xa6db007b,0x2a6300b9}},	//   _teg_, _erog, nuðu, _mbjb_,
   {{0x6b829f51,0x2d98809f,0x8cc10327,0xb4e9103e}},	//   _frog, _àrea_, रोमो, यतो_,
   {{0xc00000c8,0x1b1980c8,0xd85001bc,0x7ba780f7}},	//   ূর্ণ_, _দিকে_, _fọnt_, _تصام,
   {{0x539a8451,0x2f1400f2,0x27e9020d,0xafdb0366}},	//   _מינו, _väg_, _dyan_, tgør,
   {{0x629c049c,0x98a781d0,0xcc128133,0x672d0032}},	//   _roro, éně_, _kọpị, _ewaj,
   {{0x68e40067,0x629c1f52,0x63a41f53,0xfce301a1}},	//   _ukid, _soro, tyin, госо,
   {{0xca860071,0x27e91f54,0x672d0041,0xd8d700be}},	// [10a0] нгай, _gyan_, _gwaj, _רופט_,
   {{0x63b6009a,0x29111f55,0xddc18609,0x996e811c}},	//   rzyn, _buza_, _balż, nəş_,
   {{0xc8798086,0xdca61612,0x065700be,0xc8669289}},	//   _baş_, _зани, _אייך_, етли,
   {{0x60c60867,0x2ca9016d,0x7ae19f56,0x6d4e1f57}},	//   nikm, ckad_, holt, muba,
   {{0x7ae19f58,0x629c1f59,0x6d4e1f5a,0xb05b1f5b}},	//   kolt, _toro, luba, onär,
   {{0x26ce9f5c,0x7cd38087,0x7e7c0267,0x1fdf80ab}},	//   unfo_, văra, ndrp, _বৃহস,
   {{0x23668669,0x2911011f,0xddc38087,0x7ae19f5d}},	//   _spoj_, _guza_, venţ, dolt,
   {{0x91e31f5e,0x6d5c1f5f,0x67228198,0x39470118}},	//   _сосе, itra, ppoj, ánse_,
   {{0x290901e0,0x6d4e1f60,0xddc38087,0x68e29f61}},	//   _riaa_, huba, tenţ, mood,
   {{0x6d4e1f62,0x8af00085,0x394c8722,0x3f99841c}},	//   kuba, xtəl, tuds_, _àsua_,
   {{0xe3af84c0,0x6d5c0503,0x0c2685e9,0xc87983bf}},	//   لری_, jtra, _змен, _yaş_,
   {{0xeb9a81f3,0x01370039,0xe61f8028,0x6d4e1f63}},	//   _ние_, ערכת_, _đôi_, duba,
   {{0x7ae18ede,0xb4be9f64,0x28c006b7,0xdefb0009}},	//   bolt, ुची_, शोधि, зыв_,
   {{0x7ae19f65,0x68e28079,0x6d5c1f66,0x38a200f7}},	//   colt, hood, ftra, _sórt_,
   {{0x6d5c1f67,0x68e28ebc,0x45d41a0b,0x6e350968}},	//   gtra, kood, горс, razb,
   {{0xdef804b7,0x8af00085,0x7e7a808e,0x29111f68}},	//   ċċa_, stəl, _latp, _ruza_,
   {{0x68e282a3,0x2911005c,0x6d5c1f69,0x2ca91f6a}},	// [10b0] dood, _suza_, atra, rkad_,
   {{0x7e7a805c,0x644800eb,0x6d4e1f6b,0x2ca91f6c}},	//   _natp, _ēdie, buba, skad_,
   {{0x7c361f6d,0xc9841f6e,0x3f849f6f,0x6720810c}},	//   bayr, луци, _armu_, _atmj,
   {{0xc5f2078d,0x68e28079,0x90e780d7,0x7ae18061}},	//   _כדי_, good, رسان, zolt,
   {{0x44291f70,0x4c9a04de,0xef18804a,0x643603de}},	//   mba_, _חברו, емі_, _בארא_,
   {{0x44291f71,0x07a282a9,0x7bdc8457,0x8fa29f72}},	//   lba_, рашн, ğrul, раше,
   {{0x691780eb,0x44291f73,0xc87982d0,0x68e29f74}},	//   _aģen, oba_, _taş_, bood,
   {{0xfebb8077,0x44291f75,0x4c859631,0xc48581a1}},	//   _کارت_, nba_, тлив, тлик,
   {{0xe803000d,0x44291f76,0xa3de8105,0x6d4e1f77}},	//   रेमा_, iba_, _दुआ_, zuba,
   {{0x6d4e1f78,0x44291f79,0x6d5c1f7a,0x2b4d87f1}},	//   yuba, hba_, ytra, ruec_,
   {{0x26c79f7b,0x61ea8355,0x60c61f7c,0x44290019}},	//   mino_, _cyfl, tikm, kba_,
   {{0x44291f7d,0x7ae19f7e,0xf4858065,0x6d5c1f7f}},	//   jba_, solt, _جائی, vtra,
   {{0x7fd610ac,0x2d858699,0x98bf1f80,0x3f84001b}},	//   тіні, _hrle_, nutę_, ímu_,
   {{0xaa458002,0x6d5c1f81,0x44291f82,0x26c79f83}},	//   _рекл, ttra, eba_, nino_,
   {{0xed571f84,0x61ea831d,0x68e28079,0x7d0b8122}},	//   кор_, _gyfl, yood, _kigs,
   {{0x44291f85,0x6d4e1f86,0x7d0b9f87,0x26c79f88}},	//   gba_, ruba, _jigs, hino_,
   {{0x26c79f89,0x6d4e1f8a,0x7c299f8b,0x387d8428}},	// [10c0] kino_, suba, iber, ddwr_,
   {{0xb2231baa,0x44291f8c,0x68e29f8d,0x7c299f8e}},	//   имул, aba_, wood, hber,
   {{0x44291f8f,0xf8c617a3,0xa3de800d,0x644b1f90}},	//   bba_, _लगाय, _दुई_, ógic,
   {{0x64a61f91,0x7e7a9d08,0x44291f92,0x251e0135}},	//   _рама, _satp, cba_, _ọnwụ_,
   {{0xdfcf8307,0x68e29f93,0x7c299f94,0xddc39f95}},	//   ييم_, rood, dber, venš,
   {{0x26c79f96,0x656880b9,0xb87b0061,0x3ce6806a}},	//   gino_, _ppdh, llít, _skov_,
   {{0xceb30051,0x3cde98b8,0x628e1f97,0x127b00be}},	//   שיו_, खवले_, _inbo, _קאלע,
   {{0x7c299f98,0x98a38ae7,0x7d0b8267,0xb4be93e5}},	//   gber, _кисе, _cigs, ुचे_,
   {{0x26c79f99,0x2d859f9a,0x6ef20366,0xaf068196}},	//   bino_, _erle_, væbn, _апал,
   {{0x26c79f9b,0xc3330039,0x44291f9c,0x7c299f9d}},	//   cino_, סות_, zba_, aber,
   {{0x7c299f9e,0x44291f9f,0x2d85817f,0x40351fa0}},	//   bber, yba_, _grle_, ленс,
   {{0x30a71fa1,0x44290079,0x93469fa2,0x6abf03eb}},	//   тров, xba_, _анде, _एग्र,
   {{0x2d8c0e23,0x58d41194,0x44291fa3,0x64429fa4}},	//   åden_, роят, vba_, _idoi,
   {{0x41dd9094,0xddda8110,0x60c40c2e,0x442910ba}},	//   _नुकस, _natū, _emim, wba_,
   {{0x55581fa5,0x7b091fa6,0x26cd00ce,0xd3088129}},	//   каря_, _džul, đeo_, _dệt_,
   {{0x629a825b,0x628e1fa7,0x44291fa8,0xa7750012}},	//   ljto, _anbo, uba_, _блич,
   {{0x09bd06bf,0x1be30327,0x93f51fa9,0x6d4a81ec}},	// [10d0] ्प्य, _कुशल_, упац, hrfa,
   {{0x44291faa,0xf1a71fab,0xdd03007e,0x6d481fac}},	//   sba_, крен, ırıc, ádac,
   {{0x26c79fad,0xd011936d,0x81e480ab,0x7c299fae}},	//   vino_, ملا_, পের_, yber,
   {{0x673b0fda,0xf1c30110,0x26c79faf,0x7fd58196}},	//   šuju, _rašė_, wino_, лілі,
   {{0x78a089d1,0x3ea10074,0xb4c10701,0x7d0b8366}},	//   _domv, _koht_, ्ची_, _rigs,
   {{0x644284c3,0x7d0b8123,0x4df59980,0x7c299fb0}},	//   _adoi, _sigs, ляйт, wber,
   {{0x26c79fb1,0x7d0b9400,0x3ced9fb2,0xfc3f1b88}},	//   rino_, _pigs, tlev_, _flít_,
   {{0x7eb487f1,0xf7738e06,0xb87b0174,0x0cd18264}},	//   _ràpe, _پار_, ilís, াত্ত,
   {{0x26c79fb3,0x68e9846d,0x81e800ab,0x13099fb4}},	//   pino_, _iked, মেদ_, нний_,
   {{0xd7f89b67,0x3cff81c0,0x3ced9fb5,0x6b6701a9}},	//   _рус_, smuv_, slev_, mīgā,
   {{0x2455806b,0xb87b0c52,0x27fa809a,0xa0a61adb}},	//   _مناس, roín, ępne_, ганд,
   {{0xc32400ab,0x5fc502f1,0xd308827d,0x00000000}},	//   _পিসি_, _लेहल, _sệt_, --,
   {{0x7ae5043d,0x4c9a8e82,0x2a7c87f1,0x27ed8176}},	//   koht, _רבנו, _favb_, _jyen_,
   {{0x1bb888ca,0x99858061,0x7ae50198,0x63bb9fb6}},	//   _جامع_, _ملتو, joht, mzun,
   {{0x27ed8205,0x270f80bc,0xc8798214,0x8af00085}},	//   _lyen_, ादुर_, _ekşi_, stək,
   {{0x7b090858,0x60c41fb7,0x27ed8144,0x2cad9fb8}},	//   _džum, _umim, _oyen_, nked_,
   {{0x63a99fb9,0x63bb9fba,0x2f1986c0,0x27ed8db1}},	// [10e0] nyen, nzun, _nèg_, _nyen_,
   {{0xfeba0077,0xb87b016b,0x290d8300,0x68e99fbb}},	//   _ساخت_, slít, _aiea_, _aked,
   {{0xe5a61a02,0x35a60071,0x673b007a,0x6da61ac9}},	//   _сини, _санг, šujt, _сина,
   {{0x270f8076,0xd7fa9fbc,0x25a51b9d,0x68fb9fbd}},	//   ादूर_, нул_, älle_, _chud,
   {{0xe3b21fbe,0x7e7e1fbf,0xbea6854c,0x6e3884e8}},	//   _طرح_, _kapp, ладк, tavb,
   {{0x7e7e04b7,0xddc71807,0xf12400d5,0x68e981bc}},	//   _japp, lejš, _نظری, _eked,
   {{0x7e7e1fc0,0x7b09173d,0xccf8801b,0x21751fc1}},	//   _mapp, _ožuj, _opět_, _кутр,
   {{0xddc71fc2,0x24801fc3,0x26ca1fc4,0x645600fc}},	//   nejš, ndim_, hibo_, ngyi,
   {{0xa3de85e8,0x63a99fc5,0x26ca1fc6,0x1bd4802e}},	//   _दुख_, gyen, kibo_, ропя,
   {{0x7e7e1fc7,0x5a3482dc,0x9e65853d,0xf1269fc8}},	//   _napp, шнот, _نامن, льмо,
   {{0xddc88fda,0x67240091,0x23ba846d,0xd9178198}},	//   _hadž, _atij, _bàjé_, лья_,
   {{0x657a810c,0x7e7e1fc9,0x2cad8039,0x63a99fca}},	//   _isth, _aapp, cked_, byen,
   {{0xa3e401a2,0x0a948c5c,0x7e7e02f7,0x248002a6}},	//   _पुल_, _валю, _bapp, ddim_,
   {{0x4b7b80be,0x7e7e1fcb,0xddc881c8,0x29021fcc}},	//   _נאוו, _capp, _madž, amka_,
   {{0x7e7e1fcd,0xccfb04ae,0x61ee0338,0x291c04e8}},	//   _dapp, ећа_, _nybl, íval_,
   {{0xb4c10361,0x64561fce,0x38c90065,0x61f59fcf}},	//   ्चे_, ggyi, _جاتی_, üzle,
   {{0x36d50364,0x5a351fd0,0xddc880d2,0x26ca02ec}},	// [10f0] _вопр, инат, _nadž, bibo_,
   {{0x26ca1fd1,0x2f198247,0xccf8801b,0x68fb89ab}},	//   cibo_, _règ_, _zpět_, _shud,
   {{0x657a822c,0x386901b9,0x65951246,0x7ae51fd2}},	//   _nsth, _kbar_, _тану, roht,
   {{0xf77185ff,0x7e7e1fd3,0xddc71fd4,0x6b670ec3}},	//   قات_, _zapp, cejš, tīgā,
   {{0x7c2d1fd5,0x443b0086,0x69dc1fd6,0x2ab60646}},	//   mbar, maq_, _exre, _sæbe_,
   {{0x443b1fd7,0x3a29826c,0x6b6700eb,0x171c00be}},	//   laq_, _đapo_, rīgā, עווע,
   {{0x7d0f0065,0x5e5800be,0x40358530,0x68fb9fd8}},	//   _kics, טיגע_, _вебс, _thud,
   {{0x0b4585c2,0x63bb9fd9,0x443b0085,0x68fb826c}},	//   анин, tzun, naq_, _uhud,
   {{0x3f8901c0,0x2cad9fda,0x60cb9fdb,0x7c2d1fdc}},	//   _nrau_, rked_, migm, ibar,
   {{0x4e7887bd,0x2cad9fdd,0x52a99fde,0x63a99fdf}},	//   _محمد_, sked_, твом_, ryen,
   {{0x63a99fe0,0x67241fe1,0x7c2d1fe2,0x7e7e1fe3}},	//   syen, _stij, kbar, _rapp,
   {{0x254101e2,0xa3b510c5,0x7e7e1fe4,0x7645008e}},	//   dėl_, जना_, _sapp, _adhy,
   {{0x442d9fe5,0x7e7e1fe6,0xddc71fe7,0x26ca1fe8}},	//   mbe_, _papp, vejš, tibo_,
   {{0x7c3b97ec,0x442d9fe9,0x7b0901a1,0x6b8401e8}},	//   laur, lbe_, _džuk, vvig,
   {{0xceb28bea,0x3f89002e,0x3cfd81c5,0x3c420019}},	//   חים_, _erau_, _khwv_, _lévő_,
   {{0x0c261fea,0x7c2d1feb,0x442d9fec,0x3f890384}},	//   рман, gbar, nbe_, _frau_,
   {{0x442d9fed,0x3f891fee,0x24801fef,0x032308cc}},	// [1100] ibe_, _grau_, rdim_, ждун,
   {{0x236000f3,0x7c3b8010,0x6b841ff0,0x62819ff1}},	//   rtij_, haur, rvig, ndlo,
   {{0x6e3c0370,0x6aa39e72,0x7c2d1ff2,0x7c3b9ff3}},	//   marb, _monf, bbar, kaur,
   {{0x443b0086,0x442d9ff4,0x24800085,0x6e3c1ff5}},	//   caq_, jbe_, qdim_, larb,
   {{0x7d041ff6,0x442d8ee1,0x6fd680f7,0x7ccd80eb}},	//   mmis, dbe_, جزائ, _mērķ,
   {{0x44201ff7,0x7d041ff8,0x6b8b013c,0xddc89ff9}},	//   lci_, lmis, ægge, _vadž,
   {{0x40969285,0x61430972,0x38568081,0xd943151b}},	//   _крат, _мера, _възс, _мери,
   {{0x44201ffa,0x442d877f,0x387f811e,0x8fa68056}},	//   nci_, gbe_, _gaur_, _кабе,
   {{0x7d041ffb,0x44250085,0x3d16809a,0x29181ffc}},	//   imis, _əl_, _पूरे_, _hura_,
   {{0x29181ffd,0xf1eb0424,0x2ee78362,0x6d411d46}},	//   _kura_, _जुड़_, conf_, šlai,
   {{0x6e3c1ffe,0x442d9fff,0x81e800c8,0x44202000}},	//   darb, bbe_, মের_, kci_,
   {{0x3866a001,0x29182002,0x7c2d0079,0xd5778039}},	//   nfor_, _mura_, xbar, _כתבה_,
   {{0x29182003,0x7c22a004,0x7d040074,0x4ea72005}},	//   _lura_, _ifor, dmis, арва,
   {{0x44200063,0xa15886d2,0x6e3c2006,0x7d042007}},	//   eci_, _баку_, garb, emis,
   {{0x29182008,0x7c22a009,0x7d0f200a,0x78b6005f}},	//   _nura_, _kfor, _pics, _flyv,
   {{0x7d04200b,0x44220144,0x7c2d200c,0xb0350251}},	//   gmis, _cfk_, ubar, _униш,
   {{0x7c2d200d,0x443b200e,0x68ed200f,0x8afd800d}},	// [1110] rbar, raq_, _ikad, stře,
   {{0x7c2d2010,0x442da011,0x7d040009,0x29182012}},	//   sbar, zbe_, amis, _bura_,
   {{0x29182013,0xa2d81344,0x7c228503,0x44202014}},	//   _cura_, _मदर्, _ofor, bci_,
   {{0x44202015,0x38698789,0x7c9500f7,0x6d552016}},	//   cci_, ýar_, _الحص, muza,
   {{0x3cf405b3,0x29181351,0x44392017,0x6d418668}},	//   ंतरे_, _eura_, _ies_, _svla,
   {{0x7c22a018,0x44392019,0x2918201a,0x7cd3802e}},	//   _afor, _hes_, _fura_, mări,
   {{0x4439201b,0x20d20038,0x63ad201c,0x2918201d}},	//   _kes_, lšie_, lyan, _gura_,
   {{0xec798dea,0x442d81ec,0x3cfd8282,0x9c5986d2}},	//   упи_, ube_, _qhwv_, ушку_,
   {{0x7c220511,0x6d55201e,0x60db804f,0x69ce80e1}},	//   ñori, huza, _ijum, úben,
   {{0x4439201f,0x7c3ba020,0x442da021,0x2b4d809f}},	//   _les_, saur, sbe_, rrec_,
   {{0x7c22831d,0x4439031d,0x63ad2022,0x6281a023}},	//   _ffor, _oes_, hyan, rdlo,
   {{0x44392024,0x63ad2025,0x3ea5a026,0x9c14019d}},	//   _nes_, kyan, _holt_, _pọmp,
   {{0xef198063,0x20d20038,0x442006d4,0x6e3c2027}},	//   _już_, jšie_, vci_, tarb,
   {{0xed5a2028,0x63ad10c1,0x249fa029,0x6d55202a}},	//   лог_, dyan, ljum_, fuza,
   {{0x3ea58813,0x7d040006,0x78a40364,0x6e3c0456}},	//   _molt_, tmis, _toiv, rarb,
   {{0x4439202b,0x25a500f2,0x4420202c,0xfd56819d}},	//   _ces_, älla_, uci_, _albọ,
   {{0x4439202d,0x4420202e,0x7e750f4c,0x64a302a9}},	// [1120] _des_, rci_, bezp, чата,
   {{0x4420202f,0x3f8f0073,0x44392030,0x29122031}},	//   sci_, _água_, _ees_, _hiya_,
   {{0xc6930051,0x44392032,0x290001c0,0x8fc5003d}},	//   _זאת_, _fes_, _khia_, _هزین,
   {{0x92d800c8,0x44392033,0x7c3987d8,0xa14b0065}},	//   াতে_, _ges_, _newr, اسلے_,
   {{0x38668a38,0x63ad2034,0x80ca80ab,0x7cd38087}},	//   rfor_, cyan, িকল্, cări,
   {{0x7c22a035,0x60c9a036,0x291800a4,0x29120077}},	//   _sfor, _emem, _tura_, _liya_,
   {{0x05868087,0x11da00f7,0x29121142,0x237d80ee}},	//   сулм, _صورة_, _oiya_, _aswj_,
   {{0x0cb880c8,0x291204d2,0x3ce0812b,0x44390069}},	//   ুক্ত, _niya_, čivo_, _xes_,
   {{0xdfcf8013,0x99858084,0xe4fb114f,0x6d552037}},	//   _كيف_, kalų_, ्षति_, zuza,
   {{0x25618065,0x68ed08f8,0x9e66803d,0x29000870}},	//   ból_, _skad, _دارن, _ahia_,
   {{0xf09f009f,0x29122038,0x7648831d,0x7cd38087}},	//   tjà_, _biya_, _iddy, zări,
   {{0x29000028,0x63ad03c3,0x7c228aa2,0x9c14019d}},	//   _chia_, yyan, _ufor, _dọkp,
   {{0x29002039,0x7d1a8102,0x33f6936d,0x29121dd4}},	//   _dhia_, _huts, _اساس, _diya_,
   {{0x4439203a,0x7d1aa03b,0x20d201ac,0x6d55203c}},	//   _ses_, _kuts, všie_, tuza,
   {{0x443901c0,0x3b110609,0x2912203d,0x7cfe8168}},	//   _pes_, _rizq_, _fiya_, përd,
   {{0x4439203e,0x63ad203f,0x7d1aa040,0x6d551c88}},	//   _qes_, tyan, _muts, ruza,
   {{0x44392041,0xab870098,0x76489d30,0x7b141612}},	// [1130] _ves_, щувк, _oddy, здух,
   {{0x2d8ca042,0x63ad2043,0x44392044,0x20d200e1}},	//   _orde_, ryan, _wes_, ršie_,
   {{0x44392045,0x63ad2046,0x7d1aa047,0x97d8015b}},	//   _tes_, syan, _nuts, _نظیر_,
   {{0x7648831d,0x20d201ac,0x515b83c8,0x43950098}},	//   _addy, pšie_, רכאו, _дамс,
   {{0x291e0118,0xf7458087,0x63ad00b9,0x2d8c9339}},	//   _étan_, цело, qyan, _arde_,
   {{0x25618065,0x6b8d911b,0x7d1a8db1,0xa3d60a75}},	//   tól_, _šago, _buts, िपर_,
   {{0x3ea58117,0x62952048,0x2ca6a049,0x045981a8}},	//   _volt_, _inzo, _bood_, للغة_,
   {{0xc325a04a,0x25618065,0x60dba04b,0x0325a04c}},	//   омик, ról_, _ujum, один,
   {{0x2ca6a04d,0x7b09026c,0x249f807b,0x290001c0}},	//   _dood_, _džuv, rjum_, _rhia_,
   {{0x6285204e,0x291204d2,0x02c5835f,0x2900204f}},	//   ndho, _siya_, ійно, _shia_,
   {{0xe0da0b9c,0x7d1aa050,0xd4e7835f,0x2bd00ebf}},	//   иво_, _guts, _люди, _सेना,
   {{0x2ca68051,0x290010af,0x3f8d8168,0x237d81c5}},	//   _good_, _qhia_, _kreu_, _tswj_,
   {{0x443fa051,0x03a58a13,0x2bd08074,0x6d439345}},	//   mau_, _фило, _तइया, lsna,
   {{0x443fa052,0x645ba053,0x6729a054,0x6b89a055}},	//   lau_, lgui, _mtej, mveg,
   {{0x29002056,0x2d8c2057,0x62850197,0x386da058}},	//   _thia_, íde_, ddho, _ober_,
   {{0x443fa059,0x62851175,0x3f8601a1,0x645ba05a}},	//   nau_, edho, _šouu_, ngui,
   {{0x42ca0d45,0x5aca01bb,0x6b89a05b,0x6283a05c}},	// [1140] аган_, алам_, nveg, _kano,
   {{0x386d834a,0x443fa05d,0x2ca00859,0x7cd38087}},	//   _aber_, hau_, sjid_, măru,
   {{0x443fa05e,0xdca6205f,0x64a604ae,0x6729a060}},	//   kau_, _дани, _дана, _atej,
   {{0x186aa061,0x443fa062,0xa06aa063,0x7d1aa064}},	//   ради_, jau_, рада_, _ruts,
   {{0x443fa065,0x27e0a066,0x61402067,0x3f8da068}},	//   dau_, çin_, _bálá, _creu_,
   {{0x44322069,0x29068102,0x9f610019,0x27e081b9}},	//   lby_, smoa_, ését_, ħin_,
   {{0x68eb9148,0x4432206a,0x443f8114,0x672981bc}},	//   bogd, oby_, fau_, _etej,
   {{0xa3ae07e6,0x7c24206b,0x443f831d,0x5c988098}},	//   _कथा_, ncir, gau_, ския_,
   {{0x3f8da06c,0xae7a8364,0x6283a06d,0x7d1a80fc}},	//   _greu_, _всех_, _bano, _wuts,
   {{0x62839670,0x78a285a2,0x7d1aa06e,0x645b906c}},	//   _cano, ljov, _tuts, agui,
   {{0x443fa06f,0xe29a8104,0x69c12070,0x60cf0079}},	//   bau_, _chưa_, _žlez, ticm,
   {{0x78a281a1,0x6d58a071,0x44322072,0x00000000}},	//   njov, muva, jby_, --,
   {{0x44268870,0x6440a073,0x44322074,0x6d588406}},	//   _ifo_, mami, dby_, luva,
   {{0x6283a075,0x3ce98088,0x2bd08054,0xdea88041}},	//   _gano, čave_, _तेया, _ƙoƙa,
   {{0xa3d02076,0xeca709a5,0x9c8301d0,0x64408c53}},	//   _वेब_, ојан, íčov, oami,
   {{0x44322077,0xd4982078,0x6aaa01ec,0x19bb8039}},	//   gby_, ору_, öffn, _כמוב,
   {{0x628394be,0x7cd38162,0xdfd101bd,0x6d58a079}},	// [1150] _yano, căru, _سيد_, huva,
   {{0x291ca07a,0x6440a07b,0x6d58a07c,0x4424801c}},	//   _kuva_, hami, kuva, hcm_,
   {{0xceb2093f,0x6440805b,0x6729800d,0xe2a68125}},	//   _ניט_, kami, _stej, _áður_,
   {{0x5d7a00be,0x3f8d809f,0x26d1207d,0x6d589adc}},	//   _פארק, _preu_, lizo_, duva,
   {{0x6440a07e,0x443f8110,0x291ca07f,0x7b6419a5}},	//   dami, vau_, _luva_, _отре,
   {{0x8af00201,0x4426a080,0x6d43a081,0x443fa082}},	//   stər, _afo_, tsna, wau_,
   {{0x443fa083,0x60cd2084,0x645ba085,0x7d02a086}},	//   tau_, _omam, tgui, _bhos,
   {{0x6440a087,0x62838364,0x6d43a088,0x3f8da089}},	//   gami, _sano, rsna, _treu_,
   {{0x443f8355,0x6d43a08a,0x7c3d208b,0x38a2009a}},	//   rau_, ssna, _mesr, _góry_,
   {{0x60cd208c,0x443fa08d,0x78a985f8,0x6283a08e}},	//   _amam, sau_, _hoev, _qano,
   {{0x4432208f,0x6283a090,0x443fa091,0x7d028083}},	//   yby_, _vano, pau_, _fhos,
   {{0x6283a092,0x291c8b80,0x44248c53,0x7d02a093}},	//   _wano, _duva_, ccm_, _ghos,
   {{0x7d09a094,0x69c18065,0x628382b8,0x4432003e}},	//   mmes, szle, _tano, vby_,
   {{0x7d09a095,0x78bb85a4,0x26d12096,0xe29a80ff}},	//   lmes, _lluv, gizo_, _thưa_,
   {{0x4432026f,0xde032097,0x6da62098,0x443d83ec}},	//   tby_, епри, чива, _kew_,
   {{0xdca31e25,0x7d098214,0x03260009,0x61fc8214}},	//   наси, nmes, здан, ürle,
   {{0x44322099,0x26d11ea2,0xeb97209a,0x6d4101fa}},	// [1160] rby_, bizo_, пит_, álar,
   {{0x4432209b,0x09e60ae7,0xb87b209c,0x7c24209d}},	//   sby_, позн, gníf, scir,
   {{0x7d09a09e,0x6440999f,0x78a28144,0x7cfe83ed}},	//   kmes, yami, tjov, hëra,
   {{0x443d804c,0xd12f07bd,0x6440a09f,0x60cd00b9}},	//   _new_, امن_, xami, _xmam,
   {{0x6440a0a0,0x8af00085,0x2cbf80e4,0x7d09a0a1}},	//   vami, stəq, dhud_, dmes,
   {{0x6d58a0a2,0xab270698,0xd94620a3,0x33fb01c6}},	//   tuva, _хора_, _неги, _להכנ,
   {{0x7d02a0a4,0xda788038,0x6440a0a5,0x205699fa}},	//   _phos, veď_, tami, _нтар,
   {{0x6d58a0a6,0x443d808e,0x78bba0a7,0x89db01c6}},	//   ruva, _cew_, _gluv, _החלי,
   {{0x6440a0a8,0xe7378364,0x6d58a0a9,0x291c9adc}},	//   rami, _нет_, suva, _suva_,
   {{0xc333004c,0x6440a0aa,0xbebb03ed,0x6d58a079}},	//   עות_, sami, hpër, puva,
   {{0x7d02a0ab,0x2eeea0ac,0x443d8039,0x705519ea}},	//   _thos, moff_, _few_, وندا,
   {{0x443da0ad,0xf8bf01d0,0x38bb03ed,0x644085e7}},	//   _gew_, uhé_, _bëra_, qami,
   {{0x26d1022e,0xb8e503ca,0x2d8c0366,0xdcb10129}},	//   tizo_, _एत_, æden_, ểm_,
   {{0xba178013,0x2eeea0ae,0x7bc41c28,0x6b82a0af}},	//   _فيها_, noff_, dziu, _isog,
   {{0xdd940084,0x26d120b0,0x443da0b1,0x35e400e8}},	//   нары, rizo_, _yew_, ецтв,
   {{0x6aaaa0b2,0x26d120b3,0x60cd20b4,0x20d201d6}},	//   _hoff, sizo_, _umam, pšia_,
   {{0x6aaaa0b5,0x2bc70c78,0xe803064a,0xa3d009a9}},	// [1170] _koff, _रेखा, रेखा_, _वेद_,
   {{0x7b09025b,0x672d20b6,0x6aaaa0b7,0x6d488253}},	//   _ažur, _itaj, _joff, _ovda,
   {{0x2d8c0082,0x6aaaa0b8,0x7d09a0b9,0x2d8120ba}},	//   ådet_, _moff, ymes, _ushe_,
   {{0x92bf00ab,0x6d55192c,0xcfd20091,0x98a60162}},	//   ুকে_, mrza, _apẹẹ, mplă_,
   {{0x2489009c,0x7b09026c,0x629883b2,0x7feba0bb}},	//   mdam_, _džur, _onvo, حراف_,
   {{0x443d81b9,0x6b8d0314,0x248920bc,0x672d0c53}},	//   _sew_, mvag, ldam_, _mtaj,
   {{0xa3b50063,0x78a9838e,0x58d5835f,0x236920bd}},	//   जनक_, _toev, _жовт, ltaj_,
   {{0x645f01f6,0x672d20be,0xb87b0118,0xe3b9a0bf}},	//   ngqi, _otaj, alíz, жби_,
   {{0xa3e7890a,0x236920c0,0xf770803f,0x7d09a0c1}},	//   _मुख_, ntaj_, _مال_, rmes,
   {{0x88bd000d,0xeab180f7,0x25e88321,0x7d09a0c2}},	//   zpět, ئعة_, _चुकी_, smes,
   {{0x7643a0c3,0x6b82a0c4,0x41b4896b,0x672d20c5}},	//   many, _esog, есят, _ataj,
   {{0x6298a0c6,0x6d550042,0x628720c7,0x7643a0c8}},	//   _envo, drza, _lajo, lany,
   {{0xa49b0104,0x7d1e0024,0x6d55066f,0x9b94862c}},	//   _phòn, _sups, erza, _пицц,
   {{0x7643a0c9,0x62870b48,0x6aaaa0ca,0x24890dba}},	//   nany, _najo, _goff, edam_,
   {{0x672d20cb,0x9fa00cab,0x24890901,0x236918ad}},	//   _etaj, _méér_, fdam_, etaj_,
   {{0x7643a0cc,0xc10600f7,0x38bb03ed,0x7bc402f9}},	//   hany, _توبي, _tëra_, tziu,
   {{0x7643a0cd,0x52aa176e,0xcb670dc0,0x248601ac}},	// [1180] kany, овам_, мате_, ľom_,
   {{0x628720ce,0x7643a0cf,0x0f5701c6,0x63ab1d31}},	//   _cajo, jany, _קיים_, ägna,
   {{0x7643a0d0,0x7e7c20d1,0x673ba0d2,0x5e9b01c6}},	//   dany, merp, _awuj, _וביק,
   {{0x6d5c20d3,0x6aaa9c7b,0x628705ee,0x673b818e}},	//   mura, _चक्र, _eajo, _bwuj,
   {{0x7643a0d4,0x6d5c0886,0x62888355,0xb906a0d5}},	//   fany, lura, yddo, _पद_,
   {{0x395a20d6,0x7643a0d7,0x3ced0503,0x670020d8}},	//   pups_, gany, čeve_, ोगिक_,
   {{0x6d5c20d9,0xf98320da,0x6aaaa0db,0x99878196}},	//   nura, _игро, _roff, _menų_,
   {{0x2ebb0894,0x6aaaa0dc,0x2eee8748,0x7e7c20dd}},	//   _उत्त, _soff, soff_, herp,
   {{0x7643a08c,0x7eb48580,0x60c29a1f,0xda7a847f}},	//   bany, _làpi, mhom, оян_,
   {{0x3ce9803b,0xd2508077,0x764382a0,0x60c2a0de}},	//   čava_, دند_, cany, lhom,
   {{0x28f905e9,0x6288831d,0x644420df,0x7e7c20e0}},	//   зень_, rddo, kaii, derp,
   {{0x6d5c20e1,0x2369009a,0x6720a0e2,0x049381a8}},	//   dura, ytaj_, _kumj, _للمح,
   {{0x6aaaa0e3,0x6f17008e,0xfc3f0144,0x60dd20e4}},	//   _toff, _pixc, _reí_, rnsm,
   {{0x6d5c0010,0x7e7c20e5,0x62988192,0x68ef0df6}},	//   fura, gerp, _unvo, socd,
   {{0x628720e6,0x60c2805d,0x7eb487f1,0xa49b0706}},	//   _rajo, khom, _càpi, _fhòl,
   {{0x7643a0e7,0x6d4720e8,0xb4fb20e9,0x3f8481a1}},	//   zany, rsja, ्षेप_, _osmu_,
   {{0x248920ea,0x7643a0eb,0x2d9e02af,0x2d8c0aa2}},	// [1190] rdam_, yany, äter_, åder_,
   {{0x6d5c20eb,0x236920ec,0x9af500f7,0xb87b0144}},	//   bura, rtaj_, ركات, coír,
   {{0x236920ed,0x7643a0ee,0x6d5c20ef,0x6b8d20f0}},	//   staj_, vany, cura, svag,
   {{0x7643a0f1,0x2bd020f2,0xe80c20f3,0xe0df01e8}},	//   wany, _सेवा, सेवा_, nnò_,
   {{0x7643a0f4,0x7d0d20f5,0xf388801c,0x628720f6}},	//   tany, mmas, _nợ_, _tajo,
   {{0x7d0d20f7,0x442920f8,0xddde20f9,0x69c586ae}},	//   lmas, lca_, _hapš, _üheg,
   {{0x7643a0fa,0x3f8480eb,0x442907b6,0x00000000}},	//   rany, _esmu_, oca_, --,
   {{0x7d0d20fb,0x7643a0fc,0x60c2a0fd,0xb385824f}},	//   nmas, sany, chom, елил,
   {{0x7643a0fe,0x7cfe80f1,0x7d0d20ff,0x375580d7}},	//   pany, përn, imas, _سپاس,
   {{0x3eac805f,0x13068364,0x6d5c2100,0xde97806b}},	//   _godt_, нный_, yura, _تجرب,
   {{0xd12e817e,0xe4a7802e,0x98bf0110,0x644f1660}},	//   یمی_, _ордо, nutė_, _odci,
   {{0x76418117,0xf9920158,0xb4e9000d,0x7eb4809f}},	//   _hely, ארט_, मको_, _ràpi,
   {{0x44292101,0xe8df8870,0x42cd80ab,0x6d5c2102}},	//   dca_, _abịa_, রকৌশ, wura,
   {{0x91e591c7,0x09e5a103,0x6d5c2104,0xa3d0081f}},	//   _поле, _полн, tura, _वेष_,
   {{0x7641a105,0x44292106,0xa3d3864a,0x998581a8}},	//   _mely, fca_, _हेत_, _ألبو,
   {{0x44290af8,0x442b2107,0x7d0d2108,0x78ad0176}},	//   gca_, _cfc_, gmas, _goav,
   {{0x68e40133,0x245a82d0,0x42562109,0x6b8900fe}},	// [11a0] _ijid, lümü_, етет, _šegr,
   {{0x6d5c210a,0x4429210b,0x160f897d,0xb05b1b48}},	//   pura, aca_, ाधार_, nhän,
   {{0x60c2805d,0x2726001c,0x442b0140,0x8c460703}},	//   thom, _hôn_, _ffc_, _пене,
   {{0x4429210c,0x70f680f7,0x7eb00074,0x03a6210d}},	//   cca_, رسائ, _täps, _зимо,
   {{0xb87b001b,0x20d2007a,0xa2b4801b,0x74160061}},	//   lníc, jšim_, ेसम्, _سوسا,
   {{0x7cfe80f1,0x60c2966a,0x2726210e,0x7c2ba10f}},	//   tëro, shom, _môn_, _afgr,
   {{0x91e60abe,0xf388801c,0x629c2110,0x27262111}},	//   _чове, _sợ_, _inro, _lôn_,
   {{0x7ae381a1,0x75218661,0x68e401bc,0x7c29823e}},	//   _ajnt, _dulz, _njid, gcer,
   {{0xdcfa8087,0x63a42112,0x2245a113,0x69080118}},	//   _astă, nxin, falk_, iñed,
   {{0x44292114,0xf3888028,0x7641a115,0x68e4026b}},	//   zca_, _vợ_, _gely, _ajid,
   {{0x7cfe80f1,0x6d1f0424,0x1dcf0105,0x44292116}},	//   qëro, _मूंग_, _हेंत, yca_,
   {{0xb87b003e,0x8d5595e3,0x7c29a117,0x254c81d0}},	//   dníc, _штуч, ccer, měl_,
   {{0xe29aa118,0xe80c05b3,0xb05b01ec,0x68e40b80}},	//   _над_, सेला_, bhän, _djid,
   {{0x68e40133,0x4429009a,0x6f1d8037,0x6da189ab}},	//   _ejid, wca_, _èsce, mɓar,
   {{0x6f1aa119,0x7d0d211a,0x4429211b,0x212d01d0}},	//   _mitc, tmas, tca_, _čeho_,
   {{0x4429211c,0xdc88002e,0xccf80eef,0x629c211d}},	//   uca_, нсул_, ећу_, _anro,
   {{0x4429211e,0x7d0d0859,0x98bf002e,0x628aa11f}},	// [11b0] rca_, rmas, astă_, _kafo,
   {{0xa3d0035a,0xb87b03fb,0x68fd2120,0x6d4a8b81}},	//   _वेळ_, bníc, llsd, ksfa,
   {{0x395e809f,0x7641a121,0x442b2122,0xd99900f7}},	//   nuts_, _rely, _tfc_, بنات_,
   {{0x7641a123,0x5fd28074,0x64429995,0x628aa124}},	//   _sely, _देहल, _neoi, _lafo,
   {{0x81bc81a9,0x27260129,0x2bd08072,0x7eb02125}},	//   ucēj, _xôn_, _तेला, _käpp,
   {{0x7521a126,0x20d20503,0x69d5016f,0xf6538065}},	//   _pulz, všim_, _येथी, ائش_,
   {{0xada58098,0x644280f7,0x6d4aa127,0x395e8106}},	//   тайл, _beoi, gsfa, juts_,
   {{0xe7d2a128,0xeb9993f1,0x644281a8,0x3ce98796}},	//   _देवप, дии_, _ceoi, čavo_,
   {{0xb87b026f,0x26c103a7,0xe3b180f7,0x248b00b9}},	//   zníc, _olho_, شرة_, _macm_,
   {{0x290902c1,0x68f62129,0x628a8114,0x7eb0156e}},	//   _ahaa_, _skyd, _cafo, _näpp,
   {{0x395e8722,0x628aa12a,0x27260428,0xbbeb8019}},	//   guts_, _dafo, _sôn_, _کرام_,
   {{0x2d988510,0xb87b027f,0x6442a12b,0x290901bc}},	//   _área_, vníc, _geoi, _chaa_,
   {{0xb05b00f2,0x6a859630,0xb90a0424,0x773a0b79}},	//   mhäl, _алла, _मद_, ьянс_,
   {{0xb87b003e,0x395e87fa,0x7982009a,0x628a8114}},	//   tníc, buts_, łowi, _gafo,
   {{0xe643212c,0x26c100e1,0x200400e1,0xbea309a5}},	//   респ, _dlho_, ťmi_, шарк,
   {{0x248da12d,0xb87b026f,0x2726001c,0x29090133}},	//   ndem_, rníc, _tôn_, _ghaa_,
   {{0x46ea0b88,0xb87b016b,0x2c070a27,0x236d8069}},	// [11c0] _один_, sníc, _शरणं_, ntej_,
   {{0x63a40509,0x3ce001c0,0x63a68106,0x6d4803a2}},	//   rxin, sniv_, äkni, ádas,
   {{0x26d80365,0x67240198,0xae5701c6,0xc96606d2}},	//   miro_, _huij, _בסיס_, твей,
   {{0x7995009a,0x26d802ec,0x38cb9190,0x6d4a84fe}},	//   _drzw, liro_, وانی_, vsfa,
   {{0x6d5a0110,0xf093007c,0xe7d28072,0x23d08035}},	//   štad, ינא_, _देशप, _तेंद,
   {{0x26d802a0,0x248d81b9,0x6d4a848d,0x6d58816b}},	//   niro_, edem_, tsfa, trva,
   {{0xe9a3212e,0x628a808b,0x71a301a1,0x7cfe83ed}},	//   _карп, _rafo, _карз, sërm,
   {{0x7cfe80f1,0x26d800b4,0xb866826a,0x628a831d}},	//   përm, hiro_, _جاسو, _safo,
   {{0x2c6d0019,0x2004805c,0xc4d30039,0x26d8020c}},	//   lódó_, _uzmi_, יגה_, kiro_,
   {{0xbe858bbe,0x395ea12f,0x248005e1,0x69c882af}},	//   _مجمو, tuts_, heim_, tzde,
   {{0x9f4f007b,0x6442a130,0x24802131,0xc8b682f1}},	//   _ágú_, _teoi, keim_, _अकाट,
   {{0x26d82132,0x9f352133,0xe3baa134,0x68e28428}},	//   eiro_, лемі, _обе_, nnod,
   {{0x35a8800f,0x26d8106c,0x26c1022c,0x68e28118}},	//   _कपड़, firo_, _plho_, inod,
   {{0x26d82135,0xbc1b8039,0x6b842136,0x7a4801a9}},	//   giro_, _חודש, dwig, nūtē,
   {{0x1df817ae,0x2ca902f1,0x20d20bcf,0x51f380d7}},	//   веры_, tjad_, kših_, _پسور,
   {{0x20d20353,0x851b082e,0x2d1b01bc,0xa3d683ca}},	//   jših_, _ụgbọ_, _ụgbụ_, _सधा_,
   {{0x68e2803e,0xc2990e02,0x26d82137,0x3a752138}},	// [11d0] dnod, нках_, biro_, ллар,
   {{0x26d802a0,0x3f89026c,0x5a342139,0x78bd213a}},	//   ciro_, _isau_, инут, lksv,
   {{0x68e382ba,0x68e2831d,0xceb204de,0x7bc98338}},	//   éndo, fnod, _היי_, zzeu,
   {{0x61fc213b,0x78bd0bfd,0x68e28286,0x6b84018f}},	//   _dyrl, nksv, gnod, bwig,
   {{0xb9ff81b6,0x78bd0a0f,0xe9ff00ff,0x8afd81d0}},	//   _उर्फ_, iksv, _trắc_, stři,
   {{0x7d1d1010,0x7c2d17d6,0x62340992,0x7e6381c0}},	//   _hiss, lcar, _веру, ugnp,
   {{0x68e2a13c,0xc984213d,0x4519a13e,0xb05b01ec}},	//   bnod, _кути, нция_, thäl,
   {{0x7c2d213f,0x7d1d01b9,0xdb1e016b,0xa49b051e}},	//   ncar, _jiss, _švéd, _bhòi,
   {{0x7d1d2140,0x248da141,0xb05b1b48,0x26d82142}},	//   _miss, rdem_, rhäl, yiro_,
   {{0x248d8573,0x7bc981ec,0x236da143,0x27e081a8}},	//   sdem_, rzeu, rtej_, úine_,
   {{0x291e02be,0xdd918e06,0x50460071,0x186a151a}},	//   _état_, _دوا_, ленб, нани_,
   {{0x7c2d2144,0xd5ba80be,0x26d82145,0x25f700c2}},	//   jcar, _אזעל, wiro_, _एड़ी_,
   {{0xe28e8934,0x1cb88077,0x26d82146,0x7c2d2147}},	//   _ла_, _جالب_, tiro_, dcar,
   {{0x442da148,0x7c3ba149,0x7d1d214a,0x35d886a7}},	//   lce_, lbur, _aiss, _भेड़,
   {{0x649a00ae,0x6281a14b,0x26d81b19,0x7d1d1531}},	//   нтар_, melo, riro_, _biss,
   {{0x442da14c,0x7786214d,0x6281a14e,0x7d1d214f}},	//   nce_, _близ, lelo, _ciss,
   {{0x68e2811f,0x7c3ba150,0x60c42151,0xe29a0073}},	// [11e0] vnod, ibur, _ilim, наа_,
   {{0xc3328051,0x6281a152,0x7bc00201,0x21a61ddf}},	//   צוב_, nelo, _ümum, лизм,
   {{0x442d800d,0x2d9619e3,0x7d1d2153,0x25a50004}},	//   kce_, _српс, _fiss, ällt_,
   {{0x64a62154,0xdca62155,0x7c2d2156,0x7d1d2157}},	//   _сама, _сами, ccar, _giss,
   {{0x442da158,0x6281a159,0x7c3ba15a,0x6d4e215b}},	//   dce_, kelo, dbur, lsba,
   {{0x5694a15c,0x6281a15d,0x7cfe83ed,0x6d5c215e}},	//   ракт, jelo, mëri, orra,
   {{0x6281a15f,0x64462160,0x442202f7,0x628e02c4}},	//   delo, _keki, _kgk_, _iabo,
   {{0x7c3b8135,0x442fa161,0x64462162,0x628e2163}},	//   gbur, _cfg_, _jeki, _habo,
   {{0x28a80b75,0x628e2164,0xb4e4873c,0x6281a165}},	//   गानि, _kabo, _नदी_, felo,
   {{0x49749663,0x6281a166,0x442da167,0x26c7801b}},	//   алос, gelo, ace_, chno_,
   {{0x60c42168,0x442d801b,0x628e2169,0x6d41831d}},	//   _blim, bce_, _mabo, _gwla,
   {{0x442da16a,0x3866a16b,0x7cfe80f1,0x4422216c}},	//   cce_, ngor_, këri, _ngk_,
   {{0xb4c08592,0xb9098870,0x7c22a16d,0x78bd216e}},	//   ँसी_, _achọ_, _igor, rksv,
   {{0x442d0d38,0x7d1d0006,0x628e1c73,0x4422216f}},	//   _że_, _siss, _nabo, _agk_,
   {{0x64460586,0x60c404b7,0x7c2d2170,0x40350470}},	//   _beki, _flim, tcar, _кейс,
   {{0x60c42171,0x64462172,0x4422008e,0x3f890282}},	//   _glim, _ceki, _cgk_, _tsau_,
   {{0x7d1d2173,0x6d5c2174,0x628e2175,0x6d4e2176}},	// [11f0] _viss, arra, _babo, asba,
   {{0x7d1d1ab0,0x442da177,0x628e106c,0xf8bf001b}},	//   _wiss, zce_, _cabo, lké_,
   {{0x7d1d2178,0xb87b00f7,0x628e2179,0x442da17a}},	//   _tiss, nnío, _dabo, yce_,
   {{0xf8bf217b,0x7c22a17c,0x6281a17d,0x38bb0168}},	//   nké_, _ngor, zelo, _bëri_,
   {{0x442d9249,0x07a5981f,0x8fa5a17e,0x36698db3}},	//   vce_, ралн, рале, вало_,
   {{0x7c22983e,0x8d5584db,0x628e217f,0x3869a180}},	//   _agor, атич, _gabo, żar_,
   {{0x62818218,0x442d909b,0x56b800be,0x49932181}},	//   velo, tce_, רפון_, _دیار,
   {{0x628e012b,0xed64026f,0x47359ef0,0x442da182}},	//   _zabo, leží_, _внас, uce_,
   {{0x62818162,0x442da183,0xe7308f24,0x6449a184}},	//   telo, rce_, _فصل_, raei,
   {{0x442da185,0x7c3ba186,0x60c42187,0x7c22a188}},	//   sce_, sbur, _slim, _egor,
   {{0x6281a189,0xceb8809a,0x442d90d1,0xaca38133}},	//   relo, _więc_, pce_, _agụm,
   {{0x62818049,0x65638187,0x272b806a,0x8af0011c}},	//   selo, munh, _køn_, stəx,
   {{0x7bcd218a,0x6446218b,0xfaa5a18c,0x68e98168}},	//   jzau, _reki, _вало, _mjed,
   {{0x6446218d,0x41b511bc,0x98ab0029,0x7c228353}},	//   _seki, ंहास, ībā_, _zgor,
   {{0x68fba18e,0x628e218f,0xb8cc00ab,0x63bba190}},	//   _okud, _rabo, _গত_, lyun,
   {{0xf8bf2191,0x628e03c3,0xdcfc0025,0x27ffa192}},	//   cké_, _sabo, tvrđ, _oyun_,
   {{0x63bba193,0x63a9a194,0x26c581df,0x628e2195}},	// [1200] nyun, nxen, _ollo_, _pabo,
   {{0xc8798201,0x644607fb,0x68e98388,0xed4602c7}},	//   _abş_, _weki, _ajed, _кноп,
   {{0x64462196,0x44220ad4,0x63bb8573,0x27ffa197}},	//   _teki, _tgk_, hyun, _ayun_,
   {{0x7cfe820f,0x290d81df,0x26c58098,0x628e2198}},	//   përi, _chea_, _allo_, _wabo,
   {{0x628e2199,0x7cfe80f1,0x68e982ce,0x16348098}},	//   _tabo, qëri, _djed, беля,
   {{0x68e9a19a,0xf8bf01d0,0x7c22a19b,0x629801d6}},	//   _ejed, zké_, _sgor, ôvod,
   {{0x6563862f,0x91e3179e,0x09e307b6,0x20d201d6}},	//   gunh, _доре, _дорн, lšiu_,
   {{0x26c585b4,0x5fa6016f,0xb4c09513,0x320a219c}},	//   _ello_, खमाल, ँसे_, _izby_,
   {{0xef1a98a0,0x041800ab,0x63bb8019,0x63a98234}},	//   _ама_, ধুরী_, gyun, gxen,
   {{0x291f802e,0xb27381bb,0x657e00e8,0x2902219d}},	//   _ziua_, ольш, _opph, elka_,
   {{0xd90f03f8,0x2247a19e,0x26dca19f,0xadf20768}},	//   ویت_, _denk_, mivo_, _आँगन_,
   {{0x64a3a1a0,0x26dc8f20,0xddc501d0,0x5fdb8a27}},	//   _маха, livo_, _schů, _मेडल,
   {{0xdb028352,0x69c58074,0x27ed0214,0x752880dd}},	//   _groß, _ühen, çen_, _hudz,
   {{0xf8bf03cb,0x7648809a,0x2247a1a1,0x29020079}},	//   ské_, _jedy, _genk_, alka_,
   {{0xe3e88a49,0xd5b814b7,0x7528a1a2,0x2000026b}},	//   _পরিব, аст_, _judz, _eyii_,
   {{0x75288267,0xc05b035f,0x7bcd21a3,0x25de8074}},	//   _mudz, _рік_, tzau, _कइनी_,
   {{0x75288063,0x2bba0035,0x5399062c,0x2d9a0299}},	// [1210] _ludz, jącą_, ывая_, _erpe_,
   {{0x68e9a1a4,0x68fba1a5,0x69c102f1,0xd7fc01c6}},	//   _sjed, _skud, _ülek, _בהחל,
   {{0x272b8aa2,0x248481b9,0xc8ab8098,0x63a4802a}},	//   _søn_, kemm_, къде_, _áinf,
   {{0xf7719301,0x9c13019d,0xa49b0a2a,0xe0d081a8}},	//   كات_, _jọka, _chòt, وزن_,
   {{0x2bde13d9,0x644d04a2,0x2d8c83a8,0x752880eb}},	//   _नेपा, maai, _asde_, _audz,
   {{0x6563a1a6,0x644d21a7,0xb87b01d0,0x20d201a1}},	//   tunh, laai, dním, lšit_,
   {{0x68e982fd,0xa8a7a1a8,0x785782e3,0x7528a1a9}},	//   _tjed, _крак, _نیاز_, _cudz,
   {{0x68e98025,0x6563a1aa,0x224786c0,0x60dd21ab}},	//   _ujed, runh, _senk_, jism,
   {{0x1c4281bb,0xfd488133,0x7b06808b,0x6f1d8037}},	//   чным, _kemị, rðun, _èsco,
   {{0x63a984c3,0x2cad82ce,0x6563a1ac,0x628521ad}},	//   rxen, sjed_, punh, neho,
   {{0x63bb96fb,0x386d8140,0x66c201d6,0x95c8a1ae}},	//   syun, _kcer_, _dôkl, _куца_,
   {{0xe73a0ab5,0x297a012a,0x6721a1af,0x397a0039}},	//   лем_, נטרא, _hilj, נטרנ,
   {{0xeaae9156,0x443fa1b0,0x8ca4809a,0x6d450122}},	//   _ей_, mbu_, कारो, _awha,
   {{0x443fa1b1,0x6285029b,0x6b89a1b2,0x6d4502c4}},	//   lbu_, jeho, mweg, _bwha,
   {{0x80b880c8,0xdca60dd3,0x2d950ff7,0x6285013c}},	//   _আগস্, бави, ортс, deho,
   {{0x70b6800f,0x443fa1b3,0x6721a1b4,0x0c26030d}},	//   _अकेल, nbu_, _lilj, сман,
   {{0x03a30e97,0x6b89a1b5,0x78a406c0,0x443fa1b6}},	// [1220] пито, nweg, _iniv, ibu_,
   {{0x443f8609,0x62851854,0x2d9a0042,0xa49b06c4}},	//   hbu_, geho, _trpe_, _akòd,
   {{0x657e21b7,0x78a40e23,0x499a17ae,0x764895ab}},	//   _upph, _kniv, ытая_, _redy,
   {{0x764e0365,0x443f822b,0x7648a1b8,0x7528a1b9}},	//   laby, jbu_, _sedy, _rudz,
   {{0x7d0421ba,0x7528a1bb,0x5fd28074,0x4b550081}},	//   mlis, _sudz, _देखल, _мърт,
   {{0x7d0421bc,0x66fa0a74,0xf1ca800d,0xdfa580f7}},	//   llis, ृतिक_, ानमन, تحمي,
   {{0x171b0158,0x26dca1bd,0x6721a1be,0x2d9821bf}},	//   נוצע, rivo_, _dilj, nvre_,
   {{0x6cd487bd,0x7d0421c0,0x44320051,0x60dd21c1}},	//   تقبا, nlis, ncy_, xism,
   {{0xe81a1c4f,0x60c2a1b4,0x26dca1c2,0x47c680a9}},	//   नेमा_, mkom, pivo_, _убав,
   {{0x60c292f1,0x7d0421c3,0x6601835f,0x39ae8085}},	//   lkom, hlis, _fylk, ləsi_,
   {{0x443fa1c4,0x8afb00be,0x69c582f1,0x63a4a1c5}},	//   bbu_, רהיי, _ühel, _šind,
   {{0x236021c6,0x7d0421c7,0x66cb0214,0x26da21c8}},	//   krij_, jlis, _müke, _ampo_,
   {{0x4426a1c9,0xe6c48125,0xb87b026f,0x7d0401ac}},	//   _igo_, _þjóð, lník, dlis,
   {{0x7d1600e1,0xf1a69ad0,0x60dd0558,0x39ae8085}},	//   emys, _грин, sism, həsi_,
   {{0x6d5a003b,0x60c2a1ca,0xb87b00e1,0x7afaa1cb}},	//   štan, kkom, nník, mott,
   {{0xd9049fbe,0x60c2a1cc,0xf98f80f7,0x7d0421cd}},	//   _سی_, jkom, _أبو_, glis,
   {{0x2d8c013c,0x60c28370,0x764e21ce,0x644d21cf}},	// [1230] æder_, dkom, baby, raai,
   {{0x7d0421d0,0x443fa1d1,0x7afa84fa,0x325521d2}},	//   alis, zbu_, nott, івер,
   {{0x7d0421d3,0x4426a1d4,0x443fa1d5,0x6ab500ff}},	//   blis, _ogo_, ybu_, _vozf,
   {{0x4426a1d6,0x60c282b8,0x212a0083,0xb87b026f}},	//   _ngo_, gkom, _dubh_, dník,
   {{0xd366a1d7,0x672985a4,0x443f826f,0x7afaa1d8}},	//   _ته_, _quej, vbu_, kott,
   {{0x24ab00ab,0x60c2a1d9,0xa3be8dd2,0x3ce90162}},	//   _ঐতিহ, akom, ीनन_, lnav_,
   {{0x7afaa1da,0x6721a1db,0x68ed21dc,0x442682c4}},	//   dott, _vilj, _ojad, _bgo_,
   {{0x6b89a1dd,0x39ae811c,0x60c2a1de,0xa0c5a1df}},	//   tweg, cəsi_, ckom, _بيرو,
   {{0x443fa1e0,0x7b1001ec,0x44268144,0x6b89890d}},	//   rbu_, bäud, _dgo_, uweg,
   {{0x44268a2c,0x66018d38,0x443fa1e1,0xb87b05b9}},	//   _ego_, _tylk, sbu_, bník,
   {{0x00860cec,0x7d0421e2,0x6b8981ec,0xb87b04e8}},	//   олно, ylis, sweg, cník,
   {{0x2eb421e3,0xc952007c,0x9c1301bc,0x7d0402ed}},	//   ुस्त, ומט_, _tọha, xlis,
   {{0xfc4601ac,0x764e21e4,0x68ed21e5,0xbebb0168}},	//   šíka_, taby, _djad, jqës,
   {{0x4432009a,0x7afaa1e6,0x6145814f,0x7d0421e7}},	//   wcy_, cott, _дека, wlis,
   {{0x60c9a1e8,0x644ba1e9,0x7d040b81,0x764e21ea}},	//   _olem, _kegi, tlis, raby,
   {{0x78a421eb,0x764e1b19,0x0ce800ab,0xb05b1a50}},	//   _univ, saby, পত্ত, lkän,
   {{0x272f084a,0x7d0421ec,0xb87b003e,0xeb970009}},	// [1240] _gün_, rlis, zník, оит_,
   {{0xda6600f7,0x4432009a,0xdc3c9e1e,0x60dba1ed}},	//   تاري, scy_, váčk, _amum,
   {{0x7d0421ee,0x6459809a,0x60c29151,0x1d0a0703}},	//   plis, _odwi, tkom, _вени_,
   {{0xb87b003e,0x7afa8019,0x6fdb80d4,0x53a6161a}},	//   vník, zott, _मेहं, _дамб,
   {{0x39ae8085,0x2bd9a1ef,0x888d00be,0x60c9810c}},	//   rəsi_, _बेला, טראַ, _dlem,
   {{0x8f9b1b9e,0xb87b026f,0x60c2a1f0,0x66cb21f1}},	//   ייני, tník, skom, _tüke,
   {{0x2bde00ba,0xb05b016d,0x7afaa1f2,0x60c9a1f3}},	//   _नेता, dkän, vott, _flem,
   {{0x412721f4,0x60c98bc5,0xb87b1c18,0x644ba1f5}},	//   _фото_, _glem, rník, _cegi,
   {{0x7afa8065,0x2aaa9285,0x8e76a1f6,0x644ba1f7}},	//   tott, атно_, _мужч, _degi,
   {{0x7cfe80f1,0x6459a1f8,0x3ce00074,0x8af00085}},	//   tërs, _edwi, hiiv_, qsəd,
   {{0x2730a1f9,0x7afaa1fa,0xe8950087,0x644ba1fb}},	//   _hàn_, rott, пань, _fegi,
   {{0x6ab70a74,0x4426a1fc,0x2d9ea1fd,0xbebb0168}},	//   _आक्र, _ugo_, _irte_, yqës,
   {{0x6d5a0b48,0x69c10074,0x3ce902d4,0xdb2482f1}},	//   štal, _ülev, vnav_, öpäe,
   {{0x20050029,0x27308028,0xdefb0d15,0x2bd5001b}},	//   āli_, _màn_, рым_, _ठेगा,
   {{0x2730a1fe,0x6288a1ff,0xc8bc9a3b,0x2ebc80ab}},	//   _làn_, medo, ्घाट, _অগাষ,
   {{0x6288a200,0x70b98074,0x63ad2201,0x68ed2202}},	//   ledo, _आवेल, txan, _ujad,
   {{0x60c02203,0xb87b001b,0x68fd0168,0x27308129}},	// [1250] ömme, vníh, mosd, _nàn_,
   {{0x6288a204,0x63ad2205,0x21248706,0x2d9e8192}},	//   nedo, rxan, _aimh_, _orte_,
   {{0xdc3f026f,0x672d0168,0xb87b01d0,0x59ca98b1}},	//   líčk, _huaj, tníh, ानिर,
   {{0xd04f0201,0x2730a206,0x628881bc,0x26f5a207}},	//   ticə, _bàn_, hedo, ेत्र_,
   {{0x2d9ea208,0x6d488079,0xf745a209,0x23d98127}},	//   _arte_, _awda, чело, _बेंद,
   {{0x2730a20a,0x644ba20b,0x62889351,0x672d00f1}},	//   _dàn_, _segi, jedo, _muaj,
   {{0x6288a20c,0x6b8d0a0f,0x672d0168,0x2d9e812b}},	//   dedo, lwag, _luaj, _crte_,
   {{0x60dba20d,0x60c9a20e,0x6295018e,0x29190088}},	//   _umum, _ulem, _hazo, jmsa_,
   {{0x6295220f,0x6b8d2210,0x644b808b,0x7cfe8168}},	//   _kazo, nwag, _vegi, tërr,
   {{0xdd959006,0x3ed580f7,0x62952211,0x6288a212}},	//   _назы, _عقار, _jazo, gedo,
   {{0x644ba213,0x62952214,0xb05b1a50,0x236901c5}},	//   _tegi, _mazo, rkän, huaj_,
   {{0x6b8d1b86,0x62952215,0xb05b0338,0x68fd2216}},	//   kwag, _lazo, skän, gosd,
   {{0x24892217,0xe299a218,0xa3d3816f,0x6288a219}},	//   deam_, _гал_, _हेच_, bedo,
   {{0x6d5a0904,0x2cb90706,0x62889ee5,0x672d03ed}},	//   štam, _aosd_, cedo, _duaj,
   {{0x2d9e003e,0x6da31a19,0xada30071,0x764380dd}},	//   íte_, нира, нарл, ibny,
   {{0x01c300c8,0x5fbd8651,0xd7bd8072,0x2cb90706}},	//   ্পাদ, ्नाल, ्नाच, _cosd_,
   {{0x6295221a,0x672d0fe2,0x673b8282,0xe45f0106}},	// [1260] _bazo, _guaj, _ntuj, _glöm_,
   {{0x479b0051,0x0e660009,0x3f92221b,0x6295016a}},	//   _פייס, _экон, _isyu_, _cazo,
   {{0x2730a21c,0x69c1a21d,0x98b08289,0x3ebb0039}},	//   _sàn_, nyle, šači_, _הציב,
   {{0x7762a21e,0xa06aa21f,0x7ae1a220,0x6b8d2221}},	//   trox, сада_, hilt, bwag,
   {{0x7ae1a222,0xfc3f1727,0x64442223,0x65638192}},	//   kilt, _unía_, mbii, ernh,
   {{0x628897ad,0x996401d0,0x62952224,0x2b4014a9}},	//   xedo, může_, _gazo, mpic_,
   {{0x28af06b7,0x6b82a225,0x515519d9,0xb0cc1c7b}},	//   टामि, _spog, _отту, ासाग,
   {{0x2d9e8042,0x2124a226,0x6288831d,0x2730a227}},	//   _vrte_, _uimh_, wedo, _tàn_,
   {{0xfc3f82ba,0x62952228,0x66cb06ae,0xbbb88c28}},	//   ñía_, _yazo, _lüka, ेनेक,
   {{0x7ae1a229,0xb6c88065,0x7afe222a,0x7f3b8039}},	//   gilt, _بارے_, nopt, _לעמו,
   {{0x6d5a003b,0x2d9e811e,0x68fd222b,0x6b8d222c}},	//   štaj, _urte_, tosd, zwag,
   {{0xeafa0670,0x68e2a22d,0x2ca6a22e,0xab5d8035}},	//   ्तुत_, niod, _unod_, wyże,
   {{0x7ae1a22f,0xfaa68391,0x672d00f1,0x6288a230}},	//   bilt, _надо, _quaj, pedo,
   {{0x628880f1,0x0ebe8b9f,0x672d0168,0x6d552231}},	//   qedo, ्सिड, _vuaj, tsza,
   {{0x24892232,0x672504a2,0xf2978496,0x3ebe18b6}},	//   team_, _vihj, _זכור_, ötta_,
   {{0x6d552233,0x23692234,0x6b8d2235,0xfbde016f}},	//   rsza, tuaj_, twag, _नेहम,
   {{0x6d550065,0x62952236,0x68e2a237,0xa3be852a}},	// [1270] ssza, _pazo, diod, ीनि_,
   {{0x6b8d2238,0x60cd2239,0x88bd8035,0x92940162}},	//   rwag, _hlam, _ciśn, науц,
   {{0xc1788110,0x673b80dd,0x64440365,0x7d028061}},	//   ntė_, _stuj, bbii, _okos,
   {{0xa3be823c,0xc5f2004c,0x2ec5a23a,0xc1788110}},	//   ीना_, _ידי_, वस्त, itė_,
   {{0x629501e0,0x635e0162,0x644f01a9,0x041b0264}},	//   _tazo, tănţ, _ieci, _ফ্রী_,
   {{0x60cd223b,0x7d02a23c,0x25de800d,0x7afe223d}},	//   _llam, _akos, _केही_, copt,
   {{0x644f1a67,0xf6508154,0x68e2826b,0x60cd02d0}},	//   _keci, ائه_, biod, _olam,
   {{0x68e2802e,0x2ee301ed,0x387f81bf,0xe8948110}},	//   ciod, hijf_, _ubur_, _пась,
   {{0x644f223e,0x7ae1a23f,0xeb99a240,0x645d0144}},	//   _meci, tilt, цип_, _mdsi,
   {{0x78bba241,0x69c10074,0x66cf80e8,0xb05b1743}},	//   _houv, _üles, _bøke, skäl,
   {{0x78bba242,0x7ae1a243,0x44390174,0xa88a2244}},	//   _kouv, rilt, _ofs_, ойна_,
   {{0xafe6035f,0xa3ad001b,0x7ae1a245,0x15e3850a}},	//   домл, कमा_, silt, _केयर_,
   {{0x78bba246,0xb8e61c7b,0x66d0016d,0x7d09a247}},	//   _mouv, _एव_, _läke, mles,
   {{0x78bba248,0x60cd2249,0x7d09938e,0x644f224a}},	//   _louv, _elam, lles, _aeci,
   {{0xcb128051,0x644f003d,0x66d00009,0x999801a1}},	//   _שלו_, _beci, _näke, _serž_,
   {{0x78bba24b,0x7afe02d6,0x68e2802a,0xb05b224c}},	//   _nouv, wopt, xiod, shär,
   {{0x7d09a24d,0x073a00f7,0xb05b01ec,0x443902ed}},	// [1280] iles, _بسبب_, phär, _dfs_,
   {{0x244c001c,0x7d09a24e,0x273b8162,0x05000264}},	//   ếm_, hles, _mână_, ্দের_,
   {{0x27340364,0x2d9c0019,0x63a904b7,0x644f224f}},	//   _hän_, _éve_, _ġene, _feci,
   {{0x588381bb,0x78bb82be,0x7d098019,0x60cd00b9}},	//   выша, _couv, jles, _xlam,
   {{0x78bb83ec,0x2d8582d6,0xd5af80d7,0x711b03de}},	//   _douv, _aple_, یفه_, קונפ,
   {{0x273400f2,0x68e2a250,0xbea38652,0x44390299}},	//   _män_, siod, качк, _zfs_,
   {{0x2734016d,0x7d09a251,0x3d0a8072,0x26198075}},	//   _län_, fles, ातले_, येली_,
   {{0x78bba252,0x1ee88117,0x6abc007b,0x9972801b}},	//   _gouv, _کوئی_, _horf, těže_,
   {{0x66cf80e8,0x69c106ae,0x2d85a253,0x60cd0229}},	//   _søke, _üler, _eple_, _rlam,
   {{0x60cd2254,0xf743a255,0x7d1ba256,0xf7d7807c}},	//   _slam, _рефо, amus, _חומש_,
   {{0x7c398428,0xa50a8087,0xb05b1d31,0xa2d4a257}},	//   _ffwr, _дежа_, skäm, योग्,
   {{0x7d09a258,0x2bd981b6,0x22498904,0xc1788110}},	//   cles, _बेका, _đake_, rtė_,
   {{0xad1b8158,0xe81a101e,0x644f2259,0x6d588e51}},	//   _וואר, नेला_, _reci, lsva,
   {{0x644f225a,0x32078114,0x4439225b,0x63a2a25c}},	//   _seci, _fyny_, _sfs_, _iron,
   {{0x63a2a25d,0x6728a25e,0x6d58a25f,0x27fa809a}},	//   _hron, _midj, nsva, ępny_,
   {{0x60cd0812,0x629aa260,0x6ee900ce,0xc983802e}},	//   _ulam, ldto, džbe, _руши,
   {{0x66d004b8,0xbf0ea261,0x5b152262,0x63a28077}},	// [1290] _säke, िताभ_, емат, _jron,
   {{0xd251045b,0x67160996,0x78bba263,0x6abc0114}},	//   انا_, _दीपक_, _souv, _corf,
   {{0x78bba264,0x25de835a,0x7d00a265,0x44390358}},	//   _pouv, _केली_, koms, _tfs_,
   {{0x62988021,0x63a2a266,0x90158221,0x7d0904b7}},	//   _lavo, _oron, нфлі, ċess,
   {{0x6abc2267,0x8e8590ca,0xe8d803c8,0x6d5aa1ad}},	//   _forf, егле, וואר_, _avta,
   {{0x6abc031d,0x2bd986a7,0x7a318061,0x7f4d02a6}},	//   _gorf, _बेगा, _műté, _mwaq,
   {{0xdce88182,0x63a2a268,0xd5b192c8,0x7d09a269}},	//   _ardı, _aron, افع_, tles,
   {{0x273b802e,0x9f518019,0x212900b9,0x6aaa8428}},	//   _până_, ából_, _niah_, _anff,
   {{0x7d09a26a,0x65938085,0x200921e5,0x03259af6}},	//   rles, _məhə, _nyai_, ндин,
   {{0xeab18013,0x39458987,0xaad9809a,0x7dee0019}},	//   اعة_, нног, योंक, nősé,
   {{0x6298a26b,0x212900b9,0x69c5226c,0x7d1ba26d}},	//   _davo, _biah_, nyhe, pmus,
   {{0x0ef80540,0xf9da00be,0x629aa26e,0x6d438372}},	//   ंक्स_, פֿיל, adto, mpna,
   {{0x63a2a26f,0x21290359,0xbbeb9c81,0x6d43a270}},	//   _gron, _diah_, _برام_, lpna,
   {{0x248d856c,0x2734016d,0xe3b080d5,0x290b017f}},	//   leem_, _vän_, _خرم_, alca_,
   {{0x57bd83bb,0xdd92187e,0x2cbda271,0x24990493}},	//   ्नुह, دوز_, _kowd_, _basm_,
   {{0x248d879f,0x050000ab,0x91fc81a9,0x94260087}},	//   neem_, ্দ্র_, rgāt, ембе,
   {{0x38600068,0x29022272,0x6abc2273,0xc4d280be}},	// [12a0] _idir_, moka_, _porf, אגן_,
   {{0x248d8069,0x29022274,0x68e62275,0xe2972276}},	//   heem_, loka_, likd, нау_,
   {{0xa3bc04e5,0x67288699,0xa84a81a8,0x6abc2277}},	//   _अथक_, _ridj, كلام_, _vorf,
   {{0x25a5006a,0x26150816,0x26ca00b9,0x6d58a09b}},	//   ælle_, _धरती_, lkbo_, vsva,
   {{0x66e69383,0x656e2278,0x1c1c2279,0x6abc227a}},	//   нода, lubh, पेशल_, _torf,
   {{0x6456227b,0x6d58a27c,0x290200b4,0x6d41227d}},	//   layi, tsva, hoka_, ílag,
   {{0x6728a27e,0x29020365,0xe9f980ff,0x248d81c0}},	//   _vidj, koka_, _đế_, feem_,
   {{0x6298a27f,0x6d58a280,0x64562281,0x6728a282}},	//   _savo, rsva, nayi, _widj,
   {{0x29022283,0x6298a284,0x1e86a285,0x7d00a286}},	//   doka_, _pavo, _плам, roms,
   {{0x6456005d,0x656e0234,0xdce380eb,0x2fc681c0}},	//   hayi, kubh, runā, myog_,
   {{0xfbcf82e3,0x200900dd,0x29022287,0x212900b9}},	//   لتی_, _syai_, foka_, _piah_,
   {{0x63a28142,0x38600362,0x29022288,0x3cfa0035}},	//   _tron, _cdir_, goka_, ंवों_,
   {{0x09dd0b6f,0xbfa81fbc,0x6298a289,0x249900b9}},	//   _मध्य, нтре_, _tavo, _rasm_,
   {{0x38600086,0x63ad8390,0x61eb8019,0x3ebea28a}},	//   _edir_, _šang, állá, _jott_,
   {{0x2902228b,0x3a3780be,0xe29b80be,0x3eac808e}},	//   boka_, _ארום_, _זשור, _mndt_,
   {{0x3ebea28c,0x6456228d,0xade38074,0xb05b0198}},	//   _lott_, gayi, _कइसन_, kkäi,
   {{0x3a75228e,0x7dee0065,0xe7e081ce,0x66cb0059}},	// [12b0] клар, tősé, _खेला_, _yükl,
   {{0x6911a28f,0x63bd8aa2,0x3ebe81a1,0x257a83ed}},	//   gåen, øsni, _nott_, kël_,
   {{0x64562290,0xa5f92134,0x1df90009,0x7ae52291}},	//   bayi, _цену_, _цены_, riht,
   {{0xf7718124,0xa90784c1,0x248d822c,0x69c50a53}},	//   لات_, ربان, xeem_, ryhe,
   {{0x7d0d2292,0x3ebea293,0x57bd81d0,0x23c72294}},	//   mlas, _bott_, ्नेह, _díjú_,
   {{0x29022295,0x66d00338,0xdb029407,0xaca78061}},	//   zoka_, _käka, _droë, کھئے_,
   {{0x6d5a0025,0x257a80f1,0x1af42296,0x3ebe847f}},	//   štav, gël_, _спря, _dott_,
   {{0x7d0d2297,0x2fc68420,0x6b848162,0x3eac9277}},	//   nlas, byog_, _ţiga, _endt_,
   {{0x66d000f2,0x3f8901c5,0x98a80087,0x07359bc1}},	//   _läka, _npau_, _lună_, _резю,
   {{0x7d0d073b,0x3ebea298,0x78ad2299,0x248da29a}},	//   hlas, _gott_, _anav, seem_,
   {{0x2902229b,0xa06a229c,0x3de100c8,0x7d0d043c}},	//   toka_, мана_, _মুসল, klas,
   {{0x48e60381,0x6f03a29d,0xa2a1a29e,0x23690304}},	//   томв, lonc, _कोर्, kraj_,
   {{0x29020ee1,0xe28ea29f,0x2bd98105,0x6449a2a0}},	//   roka_, _ка_, _बेचा, mbei,
   {{0x6f03a2a1,0x8a059a19,0x98a80087,0x6449a2a2}},	//   nonc, _изле, _bună_, lbei,
   {{0x645622a3,0x290222a4,0xfc3f01d6,0xceb28e82}},	//   tayi, poka_, _kníh_, סיל_,
   {{0x320a0690,0x6449a2a5,0x443d808e,0x7c3b8888}},	//   _ryby_, nbei, _jfw_, ncur,
   {{0x6f039122,0x645622a6,0xa50722a7,0x6911a2a8}},	// [12c0] konc, rayi, тета_, tåen,
   {{0x6281822b,0x645622a9,0x4a431819,0x69c582f1}},	//   nflo, sayi, инув, _ühes,
   {{0x6d4182a6,0x645622aa,0x3ebea2ab,0x00000000}},	//   _ntla, payi, _rott_, --,
   {{0xf7468256,0x3ebea2ac,0x00e68081,0x2d3e0870}},	//   ведо, _sott_, ъжен, _ọgwụ_,
   {{0xd7ef8013,0x6f0380e7,0x7d0422ad,0x3ebea2ae}},	//   يكم_, fonc, mois, _pott_,
   {{0x7d0422af,0xa2a1a2b0,0x6d5a01ac,0x442f8752}},	//   lois, _कोल्, štau, _agg_,
   {{0x180f035a,0x6d5c048d,0x68e422b1,0x1ae319a5}},	//   _सर्व_, nsra, _omid, _торм,
   {{0x629c1a7b,0x7d0422b2,0x22498904,0x6d5c22b3}},	//   _haro, nois, _đaka_, isra,
   {{0x629c22b4,0xcb678fbb,0x4f268196,0x613e80eb}},	//   _karo, вање_, _адаб, _mīle,
   {{0x60c0a2b5,0x629c185c,0x629e22b6,0x02a6a2b7}},	//   _homm, _jaro, ndpo, трим,
   {{0x629c202e,0xf4848077,0x7d040364,0xd48f8ba8}},	//   _maro, _ماشی, kois, _кр_,
   {{0x629c009c,0xcfa98019,0x7793003d,0x6d5c22b8}},	//   _laro, _تاہم_, لیبا, dsra,
   {{0x248680fc,0x7d0422b9,0xb4c09130,0x98a80493}},	//   _ibom_, dois, ुसी_, _sună_,
   {{0x752b802a,0x76588010,0x60c0a2ba,0x68e422bb}},	//   _zigz, navy, _lomm, _emid,
   {{0x2fcd003b,0xd6d8035f,0xe5c411a8,0x7d0d22bc}},	//   šeg_, ття_, асто, tlas,
   {{0x60c0a2bd,0x78ad0c93,0x236922be,0x4aa6864a}},	//   _nomm, _unav, traj_, _कोतव,
   {{0x629c22bf,0x7b32809a,0x7d0d22c0,0x69c8a2c1}},	// [12d0] _baro, _dług, rlas, lyde,
   {{0x7d0d22c2,0xade38074,0xfde38074,0x629c22c3}},	//   slas, _कइलन_, _कइलस_, _caro,
   {{0x7d0d22c4,0x7d041009,0x6f0380c3,0x6f0200f7}},	//   plas, bois, vonc, _íoca,
   {{0x60c0a2c5,0xf09f22c6,0x7d0d208e,0x48e180ab}},	//   _comm, ndà_, qlas, যক্র,
   {{0x6f0385b4,0x973580d5,0x60c0a2c7,0x26c1016b}},	//   tonc, اکرا, _domm, _koho_,
   {{0x629c22c8,0x60c08b99,0x26c103e4,0x69c88646}},	//   _garo, _eomm, _joho_, kyde,
   {{0xceb40451,0x26c11ab3,0xf0758019,0x60c08372}},	//   ייס_, _moho_, _میاں_, _fomm,
   {{0x60c0a2c9,0x290901bc,0x394601a1,0x7c3b82df}},	//   _gomm, _nkaa_, ćost_, ucur,
   {{0x6449a2ca,0x7c3b8012,0x57f5a2cb,0x27e080f7}},	//   rbei, rcur, _спат, úint_,
   {{0x3ce901e9,0x68e422cc,0xa3bb0006,0x290922cd}},	//   hiav_, _smid, _अपन_, _akaa_,
   {{0x6281a2ce,0xaad98770,0x59ca90be,0x6d41a2cf}},	//   rflo, योगक, ानगर, _utla,
   {{0x6281808b,0xf7460293,0x20c201a8,0x6fa78697}},	//   sflo, лемо, _cóip_, चिपू,
   {{0x6b65a2d0,0x2d0f835a,0x7b06807b,0x4b7980be}},	//   _скла, ातील_, rður, _נאַו,
   {{0x249fa2d1,0xe2968226,0x249d81c5,0x7ae381f6}},	//   ldum_, _баш_, _hawm_, _umnt,
   {{0xa0a622d2,0x7d040009,0x249d81e9,0x69118370}},	//   _байд, tois, _kawm_, tåel,
   {{0x249f8125,0x68e422d3,0x97c61e91,0x212d8359}},	//   ndum_, _umid, _مقبو, _nieh_,
   {{0xcb67023a,0x60c0a2d4,0x237fa2d5,0xdd038084}},	// [12e0] лате_, _romm, ntuj_, ūrėj,
   {{0xda650013,0x249d90af,0x6d5a04c3,0x8f9b0039}},	//   لامي, _lawm_, átas, _טיפי,
   {{0x629c22d6,0x60c0a2d7,0x2cafa2d8,0x7d0422d9}},	//   _varo, _pomm, _ongd_, pois,
   {{0x249d81c0,0xa09a81a8,0x629c22da,0x237f9d21}},	//   _nawm_, عضاء_, _waro, ktuj_,
   {{0x629c00a4,0x44240014,0x69c88035,0x69da8216}},	//   _taro, _àm_, zyde, zzte,
   {{0xb8cba2db,0x2ca00074,0x3b0a0009,0x4e7a00be}},	//   _को_, ldid_, _чего_, גאַצ,
   {{0x60c0a2dc,0x57d001d0,0x2ca006ae,0xf8bf1a1f}},	//   _tomm, हनुह, odid_, lmée_,
   {{0x7ae8a2dd,0xbd878624,0x2ca022de,0x249d8069}},	//   widt, انين_, ndid_, _cawm_,
   {{0xc6768060,0xe646a2df,0x63a422e0,0x66d000f2}},	//   _مطاب, _безп, nvin, _räkn,
   {{0x69c88bfa,0x69da8352,0x63ad826f,0xe45f0009}},	//   tyde, tzte, _šanc, _ylös_,
   {{0x249d81c0,0x26c122e1,0xd2b70039,0x7c8689a0}},	//   _fawm_, _roho_, אלית_, _буле,
   {{0xa3e50665,0x8dfb8039,0x249d81c0,0x69c8a2e2}},	//   _भइल_, _אהבת, _gawm_, ryde,
   {{0x69da8065,0x63a40a0f,0x81bc00c8,0xf09f009f}},	//   szte, jvin, েছি_, rdà_,
   {{0x11d6803f,0x3ce68282,0x99d68277,0x539b84de}},	//   _متعد, _hmov_, _متعا, _ניוו,
   {{0x7f441883,0x58d50009,0x249d8069,0x1df8076a}},	//   _etiq, _войт, _yawm_, геры_,
   {{0x290f01a8,0x20f88084,0x2bd18b99,0x290903e4}},	//   _óga_, yčia_, दैवा, _ukaa_,
   {{0x26c10a56,0x395e8341,0x63a422e3,0x4a5520bf}},	// [12f0] _toho_, lsts_, gvin, икас,
   {{0xb05b01ec,0x66d00106,0x3ce901c0,0x2739a2e4}},	//   rkäu, _jäkl, siav_, _rèn_,
   {{0x46150077,0x66d0016d,0x6d5a22e5,0xb035a209}},	//   _خودر, _mäkl, štar, анеш,
   {{0x6d4522e6,0x237f8035,0x395ea2e7,0x5c07047f}},	//   _itha, ytuj_, ists_, _бяга,
   {{0x644d22e8,0x249d822c,0xb4c30bbc,0xb05b0198}},	//   mbai, _rawm_, ्सी_, lkäs,
   {{0x395e8029,0x644d22e9,0xddc5a2ea,0x249d8282}},	//   ksts_, lbai, ибли, _sawm_,
   {{0xa56480f7,0xfc3180f7,0xb05b0198,0x249f811c}},	//   مدين, يحة_, nkäs, tdum_,
   {{0xff1580c8,0x644d0102,0x386080f7,0xdb06010c}},	//   াদেশ_, nbai, óirt_, _arkè,
   {{0x395e87e2,0x249f8457,0x6d450122,0x7d1d010c}},	//   ests_, rdum_, _ltha, _mhss,
   {{0x752f0063,0x644d03ac,0x237f809a,0x6d4522eb}},	//   _licz, hbai, rtuj_, _otha,
   {{0x249d81e9,0x6d45022c,0x2a760039,0x25b98199}},	//   _tawm_, _ntha, בעתך_, _جهاد_,
   {{0x68eb8cfa,0x63a403c7,0x752f0035,0x25de81d0}},	//   nigd, yvin, _nicz, _केटी_,
   {{0x6d4522ec,0xb8ee000f,0xa3e50074,0x26d822ed}},	//   _atha, _शक_, _भेल_, thro_,
   {{0x443fa2ee,0x63a40197,0x7d1d0706,0x68eb8420}},	//   lcu_, vvin, _ahss, higd,
   {{0x2d53802e,0xa01b0019,0x50460037,0xddc322ef}},	//   nţe_, lföl, _кейб, обри,
   {{0x1c4622f0,0x8a14803d,0x6d450706,0x47c6004a}},	//   рнам, _اظها, _dtha, _вбив,
   {{0x6d4522f1,0x6f07017f,0x68eba2f2,0x2ca00074}},	// [1300] _etha, bojc, digd, rdid_,
   {{0x55e622f3,0xf8bf0036,0x0ea49370,0x3ce981d6}},	//   _вооб, rmée_, _गोंड, čavy_,
   {{0x765c22f4,0x2d9a095e,0x644d22f5,0xf0aa046d}},	//   mary, _uspe_, bbai, _gbàá_,
   {{0x270e8c78,0x64a622f6,0x39a58029,0x4fc68bba}},	//   ित्र_, _тама, _mēs_, исла,
   {{0x443fa2f7,0x02b580c2,0x98a622f8,0x3f82136f}},	//   dcu_, _अचंभ, nslı_, ntku_,
   {{0x765c22f9,0x5d66a2fa,0x658a8201,0x236da2fb}},	//   nary, атиз, _rəhb, drej_,
   {{0xdce18214,0x69c7806a,0x6d450706,0x290683e4}},	//   _aslı, øjel, _xtha, pooa_,
   {{0x399b012a,0x0ca78009,0x656e0c5e,0x765c22fc}},	//   _בילד, атьи_, irbh, hary,
   {{0xf743a2fd,0x765c22fe,0x225800c9,0xdb0609c4}},	//   _мето, kary, _kerk_, _arké,
   {{0x78a2a2ff,0x79a6a300,0x0f7b83c8,0xb4d203ca}},	//   ldov, арме, _באמב, वसु_,
   {{0x3a370051,0x765c01e2,0x22582301,0x6f070024}},	//   ירים_, dary, _merk_, vojc,
   {{0x60c40c64,0x1bea9508,0x395ea302,0x69de011b}},	//   _coim, _идеи_, rsts_, izpe,
   {{0x77f4a303,0x3949a304,0x60c42305,0xd7fb0530}},	//   _अशोक_, _čase_, _doim, тун_,
   {{0x0eeb2306,0x28dd82f1,0xb05b062c,0x7e78a307}},	//   тьми_, _मतभि, tkäs, ngvp,
   {{0x3f822308,0x7afda309,0xeda400e8,0xd2f88019}},	//   atku_, éste, ошто, _لکھا_,
   {{0x04c900f7,0x78a2a30a,0xdce7009a,0x60d6230b}},	//   دوري_, jdov, kują, _glym,
   {{0x644d230c,0x656e0c41,0x765c230d,0x78a281e8}},	// [1310] rbai, arbh, bary, ddov,
   {{0x6e950013,0xf1a71980,0x644d0014,0xf699230e}},	//   _الدا, ирен, sbai, _свој_,
   {{0x6d45005d,0x20f8811f,0x28cc109b,0x3ce781ab}},	//   _utha, rčin_, ासचि, _जगले_,
   {{0xa3c7a30f,0x628501a8,0x271f847d,0x273d04be}},	//   _उथल_, sfho, यग्र_, _kìn_,
   {{0x443f8289,0xa3bb152c,0x2d8300f3,0x60c02310}},	//   vcu_, _अपि_, ltje_, ömmi,
   {{0x4aa68076,0xaaa6a311,0x6b9d002a,0x236d8b80}},	//   _कोलव, _कोलक, _issg, vrej_,
   {{0x2d832312,0xad5897ae,0x443fa313,0x645b888b}},	//   ntje_, арых_, tcu_, taui,
   {{0xfdf80039,0x66cf813c,0x84f900d4,0x20f8826f}},	//   ימוש_, _køkk, ्किट_, nčil_,
   {{0x60c40068,0x68e9a314,0x443fa315,0xe3e9803d}},	//   _roim, _imed, rcu_, دکان_,
   {{0x443f8012,0x236da316,0xa01b2317,0x9f958074}},	//   scu_, rrej_, rföl, _müüa_,
   {{0x66cf813c,0x98a62318,0x60d62319,0x39e9a31a}},	//   _løkk, бине, _plym, удно_,
   {{0x236d8353,0xa01b0106,0xfd1f0129,0x693a8197}},	//   prej_, pföl, _nhì_, _kċej,
   {{0x60c40009,0xfaa581e2,0x6f1e0118,0x66cf80e8}},	//   _voim, _гало, _phpc, _nøkk,
   {{0x3f82231b,0x78a28f20,0x291f81c0,0xe7371ac9}},	//   rtku_, zdov, _lhua_, сер_,
   {{0x60c40181,0x645990e1,0x68e98106,0x3f820696}},	//   _toim, _kewi, _omed, stku_,
   {{0xeb9a10ac,0x26c5a31c,0xb05b0b8b,0xb4d20075}},	//   либ_, _lolo_, skär, वसे_,
   {{0x63bb862f,0x765c010c,0x2d8300f3,0x2258231d}},	// [1320] nxun, pary, atje_, _perk_,
   {{0x68fba31e,0x6459a31f,0xf4128451,0x78a0a320}},	//   _ajud, _lewi, לפן_, _samv,
   {{0x68fb816d,0x2722801c,0xdb042321,0x63a48118}},	//   _bjud, _hưng_, nvié, _áinv,
   {{0x225801d8,0x291fa322,0x6459831d,0x2cbfa323}},	//   _werk_, _chua_, _newi, jjud_,
   {{0x0eea835f,0x26c58038,0x7d09a324,0x96eaa325}},	//   льки_, _bolo_, does, лька_,
   {{0x527519b5,0xdb028187,0xdce70035,0x20f880c3}},	//   _мусу, _proí, rują, mčim_,
   {{0x2b46a326,0x6443009a,0x6b842327,0x64599781}},	//   _stoc_, śnie, ltig, _bewi,
   {{0x63ab82f7,0xdce70035,0xa7fb0118,0xd497a328}},	//   _brgn, pują, lañe, брь_,
   {{0x68e380f1,0xd2508013,0x6459831d,0x940d0326}},	//   ënde, ونة_, _dewi, ɓoɓi_,
   {{0x63ab006a,0x63a92329,0x6b84232a,0x6d4a8711}},	//   ågni, _šenk, itig, ppfa,
   {{0x2d98a32b,0x20120326,0x6b84232c,0x7d09a32d}},	//   _ère_, _ayyi_, htig, boes,
   {{0x2d9e8042,0x6459a32e,0x6b84232f,0x2ed10beb}},	//   _iste_, _gewi, ktig, हस्त,
   {{0xdfd80098,0x61e00085,0x765a8168,0x272280ff}},	//   бър_, _əmla, _kety, _cưng_,
   {{0x81de00c8,0xd9fa01cb,0xf40000ab,0xeaf58c33}},	//   _তখন_, ्थात_, ্ধার_, ीकृत_,
   {{0x2d9e800d,0x765aa330,0x6b8406a8,0x691881ca}},	//   _jste_, _mety, etig, víen,
   {{0x2d830a0f,0x2eeea331,0x62889de6,0x753a8db1}},	//   rtje_, hiff_, lfdo, _mutz,
   {{0x6b842332,0x2d832333,0x38690041,0x3ea12334}},	// [1330] gtig, stje_, _idar_, _taht_,
   {{0x68e9a335,0x8c1b8bea,0x290b2336,0x765aa337}},	//   _smed, רומי, loca_, _nety,
   {{0xfd1f0104,0x399aa338,0x753a8352,0x6b842339}},	//   _thì_, _jūs_, _nutz, atig,
   {{0x26c5a33a,0x7e688216,0x291f8069,0x399a81a9}},	//   _solo_, _addp, _qhua_, _mūs_,
   {{0x66048182,0x765a904a,0x4918010f,0x2d9e8102}},	//   şikl, _bety, זקאל_, _aste_,
   {{0x26c581b4,0x35c98284,0x321c9075,0x6459a33b}},	//   _qolo_, игло_, _ozvy_, _sewi,
   {{0x765a820f,0x26c5a33c,0x291fa33d,0xd05d0085}},	//   _dety, _volo_, _thua_, sisə,
   {{0x6297233e,0x9345a33f,0x645f0085,0xf9921101}},	//   lexo, оние, naqi, _קרן_,
   {{0x2d9ea340,0x8c6480f7,0xdcfc00eb,0x03a5a341}},	//   _este_, سطين, ntrā, ципо,
   {{0x05ba2342,0x399a8029,0xdddc0019,0x38692343}},	//   _उपलब, _būs_, zerű, _adar_,
   {{0xe8fa2344,0x290319b7,0x7d09a345,0x63bb8118}},	//   ило_, čkan_, poes, sxun,
   {{0x160400d4,0x297a00be,0x79850114,0x63ab8669}},	//   _शुगर_, סטרא, ithw, _trgn,
   {{0xa3bb815b,0x68fd0216,0x940580d7,0x63ab8037}},	//   _حاضر_, érda, _بوشه, _urgn,
   {{0x673b8079,0x38692346,0x63a9a347,0xa8030118}},	//   _muuj, _edar_, mven, úñas,
   {{0x63a9a348,0x62971075,0x845a2349,0x6da31ba2}},	//   lven, dexo, ират_, мира,
   {{0x63a9a34a,0x9e3c9c18,0x6aa38114,0x161e80c2}},	//   oven, _maďa, _hanf, येटर_,
   {{0xb6a60ff7,0x0aea1b69,0xab6600e8,0x6aa38300}},	// [1340] _дипл, адай_, ювал, _kanf,
   {{0x6b84234b,0x78a40282,0x63a9a34c,0x386904e8}},	//   rtig, _haiv, iven, _zdar_,
   {{0x6aa38590,0x28af000d,0x78a40198,0x9e3c80e1}},	//   _manf, _जोडि, _kaiv, _naďa,
   {{0x765aa34d,0x6aa3a34e,0xac760019,0x78a40144}},	//   _sety, _lanf, _بادش, _jaiv,
   {{0x78a40282,0x765aa34f,0x63a980f3,0x6b840079}},	//   _maiv, _pety, jven, qtig,
   {{0x63a9a350,0x78a42351,0x645d807b,0x356a9593}},	//   dven, _laiv, ðsin, арин_,
   {{0x20d7a352,0xd54780a9,0xa9672353,0xe6da8105}},	//   _için_, опје_, _мира_, _भतीज,
   {{0x66cb0459,0x6aa3826b,0xdb0b841c,0x2fcf804a}},	//   _yüks, _aanf, _urgê, bygg_,
   {{0x3949a354,0xaca401bc,0xfb868110,0xdb040580}},	//   _časa_, _ndọt, цыйн, nviï,
   {{0xcb1a80a9,0x63a4a355,0x386900b9,0x6aa38114}},	//   јќи_, _šins, _sdar_, _canf,
   {{0x09f88013,0x7afd85e4,0xaca40133,0x3f868548}},	//   صفحة_, ésta, _adọt, ltou_,
   {{0x63a9959b,0x7aef82ba,0x29030289,0x78a40037}},	//   bven, éctr, čkao_, _caiv,
   {{0x3f86a356,0x4ea72357,0x63a9802e,0x60358085}},	//   ntou_, орва, cven, _həmç,
   {{0xa3ae0df4,0x387f2358,0x3f86a359,0x66d9046d}},	//   किन_, żur_, itou_, _bìka,
   {{0x78178a74,0x290b1fea,0x7b1001ec,0x58d5091e}},	//   _तर्क_, poca_, häus, _нокт,
   {{0x628e235a,0xd5a48986,0x38690024,0x6aa3a35b}},	//   _abbo, _یہ_, _udar_, _zanf,
   {{0x28ab9a3b,0x3d0b8076,0x645f00f1,0xb87b0118}},	// [1350] _घोषि, ावते_, raqi, rhíd,
   {{0x7e990019,0x238e00eb,0x2489026c,0xb87b0118}},	//   _اندر_, dējā_, sfam_, eníx,
   {{0xdcfc0029,0x6297002a,0x39580114,0x0e9a01c6}},	//   strā, rexo, _cwrs_, _השתל,
   {{0x23668025,0x7985235c,0x6ee9235d,0x6297235e}},	//   _ovoj_, rthw, džbi, sexo,
   {{0x7d0d002e,0x68ed0a2c,0x645d235f,0xba7700f7}},	//   moas, _mmad, _iesi, _واست,
   {{0x645d2360,0x6da59ba2,0x7d0d08b0,0x60dd0168}},	//   _hesi, зика, loas, ërmj,
   {{0xb14603f8,0x645d2361,0x6aa383ec,0x68ed02f1}},	//   _فیلم_, _kesi, _ranf, _omad,
   {{0x7d0d0ca4,0xdd8e80f7,0x2ec819e8,0x66d00198}},	//   noas, اوي_, _रक्त, _väki,
   {{0x645d2362,0x3f86a363,0x6aa3a364,0x63a980e7}},	//   _mesi, ctou_, _panf, uven,
   {{0x68ed2365,0x645d2366,0x44392367,0x6721a368}},	//   _amad, _lesi, _lgs_, _uhlj,
   {{0x60db84dc,0x4efa80be,0xaf0881a8,0x3ea58366}},	//   _klum, _פלעג, _بقلم_, _ialt_,
   {{0x21060c78,0x645d2369,0x44390420,0x7522a36a}},	//   रवेश_, _nesi, _ngs_, _ghoz,
   {{0x087680be,0x78a4236b,0xe45680be,0x3ea5a36c}},	//   הערט_, _vaiv, _זינט_, _kalt_,
   {{0x4439236d,0x7529a36e,0x60dba36f,0x68ed2370}},	//   _ags_, lmez, _llum, _emad,
   {{0x60dba371,0x2cf91344,0x645d2372,0x78a42373}},	//   _olum, ्कूल_, _besi, _taiv,
   {{0x645d0baf,0x0b4604db,0x60c9a374,0x201e0201}},	//   _cesi, знан, _noem, ətin_,
   {{0x7d1604fe,0x2d8782f1,0x64442375,0xdb0b87b6}},	// [1360] rlys, htne_, rcii, _argé,
   {{0x60db88e9,0x2d87a376,0x645d1312,0x691d0866}},	//   _alum, ktne_, _eesi, néen,
   {{0x7d16006f,0x60dba377,0x2d930118,0x60c9a378}},	//   plys, _blum, _gpxe_, _boem,
   {{0xe04396d9,0x645d2379,0x7d0d237a,0xa7fb0118}},	//   енци, _gesi, coas, laña,
   {{0xdc370158,0x765e237b,0x3f86802a,0x6d45a37c}},	//   _מאכט_, _kepy, utou_, íhan,
   {{0x645d237d,0xa3e50d14,0xdee3a37e,0x2d878390}},	//   _zesi, _भेट_, ночи, ftne_,
   {{0x23668ee0,0x3f86a37f,0x645d005d,0x3ea5a380}},	//   _svoj_, stou_, _yesi, _dalt_,
   {{0x60db803a,0x2900022e,0x3f86a381,0x18a38254}},	//   _glum, _njia_, ptou_, _пасм,
   {{0x613a001b,0x3ea5804a,0x6f0e0326,0x66dd89c4}},	//   _důle, _falt_, kobc, _sèke,
   {{0x3ea5a382,0xfc3f0118,0x68ed2383,0x6da68ab2}},	//   _galt_, _maía_, _smad, _низа,
   {{0xa7fb0216,0xdd8f866e,0x1ea9a384,0x7416a385}},	//   daña, _مول_, _باقي_, _کوشا,
   {{0x69370499,0xfce3a386,0x236697aa,0x09f701c6}},	//   _kćer, _похо, _tvoj_, למים_,
   {{0x645d2387,0xa3cd8701,0x44390196,0xbff80470}},	//   _resi, रहण_, _rgs_, зеях_,
   {{0x645d2388,0x63a2a389,0xa7fb238a,0x29120365}},	//   _sesi, _ison, gaña, _ekya_,
   {{0xa3e5000f,0x56780009,0x7d0d238b,0x765e0176}},	//   _भेज_, ября_, toas, _depy,
   {{0x5fbea38c,0x68ed0079,0x7aee01ed,0xc8ab86a7}},	//   ्हाल, _umad, _ambt, _घोंट,
   {{0xd90f09d7,0x645d238d,0x7d0d002e,0xa7fb15c7}},	// [1370] _لیگ_, _vesi, roas, baña,
   {{0x60dba38e,0x7f4d238f,0x63a28c53,0x645d005d}},	//   _slum, _itaq, _mson, _wesi,
   {{0x645d2390,0x63a282f7,0x68fd2391,0x60db8e79}},	//   _tesi, _lson, onsd, _plum,
   {{0x3ce02392,0x63a2a393,0x629aa394,0x68fd2395}},	//   chiv_, _oson, heto, nnsd,
   {{0x6d4a00f1,0xdcfc0087,0x63a2a396,0x6d5a85ee}},	//   _çfar, stră, _nson, _awta,
   {{0x629aa397,0x658a8201,0x2ca92398,0x63ad2399}},	//   jeto, _təhl, ldad_, mvan,
   {{0x3ea5a39a,0xa1941182,0x63a2a39b,0x60db9d40}},	//   _valt_, _парч, _ason, _tlum,
   {{0x2d87a39c,0x60db80ee,0x63ad239d,0x66d00106}},	//   rtne_, _ulum, ovan, _häkt,
   {{0x290f8867,0x752984b7,0x63ad239e,0x2d87a39f}},	//   moga_, rmez, nvan, stne_,
   {{0xa3ae146d,0x39459fc8,0x2bdf001b,0xe3ca8144}},	//   कित_, мног, पैया, _soñó_,
   {{0x7f4d0510,0x66d00106,0x6dd5804e,0x63a2a3a0}},	//   _ataq, _mäkt, _تقاض, _eson,
   {{0x290fa3a1,0x63ad1434,0x3940811a,0x2ca682c4}},	//   noga_, kvan, _čist_, _gaod_,
   {{0x2ca923a2,0x691d00e7,0x272401ec,0xe79c02d0}},	//   ddad_, péen, höne_, _düğü,
   {{0x63ad23a3,0x2ca90144,0x6b89a3a4,0x629aa3a5}},	//   dvan, edad_, mteg, ceto,
   {{0x386d834a,0x290f812b,0x6f0e003e,0x6b89811e}},	//   _oder_, koga_, robc, lteg,
   {{0xf8e2141b,0x386d8168,0x2eda84c5,0xa7fb0144}},	//   _पतिय, _nder_, _भत्त, saña,
   {{0xfa8e801c,0x6aa701a1,0x59cb8127,0xccf28039}},	// [1380] _mừng_, _bajf, ाहवर, דכן_,
   {{0x386d80ee,0xe297002e,0xb05b1cab,0x63a6a3a6}},	//   _ader_, мау_, hjäl, ækni,
   {{0xe8208076,0xd62a01bb,0x88868a13,0xa87a00be}},	//   _बरहा_, _фоне_, длеж, ַאַר,
   {{0xa3bf86a7,0xa3cda3a7,0x61ee8118,0x657c062c}},	//   ीहा_, रहा_, úbli, murh,
   {{0x3860021e,0x6aa8831d,0x8cdb00d4,0x629aa3a8}},	//   _meir_, yddf, नसरो, yeto,
   {{0x386da3a9,0x473380e8,0x386023aa,0x629a8118}},	//   _eder_, вніс, _leir_, xeto,
   {{0xc6930051,0xe8208076,0x290fa3ab,0x657c00b9}},	//   דאו_, _बरवा_, boga_, nurh,
   {{0x248023ac,0x3eba00b9,0xdc13807e,0x629a9588}},	//   ngim_, _lnpt_, _ağır, weto,
   {{0xd90d8288,0x629aa3ad,0xa6868293,0xfa8e80ff}},	//   _این_, teto, _олад, _dừng_,
   {{0xb6cb8117,0x7b32809a,0x38600174,0x68e2936f}},	//   _والے_, _tłum, _aeir_, lhod,
   {{0x629aa3ae,0x658a8201,0x6b89a3af,0x66d018c2}},	//   reto, _məhk, ateg, _läks,
   {{0xa3de0fcc,0x63ad03bf,0x75498019,0x38600114}},	//   तना_, yvan, őszö, _ceir_,
   {{0x27e684b9,0x63a2a3b0,0x386000f7,0x9f59077f}},	//   nzon_, _uson, _deir_, ìyàn_,
   {{0xe1ef95e4,0x7ce30006,0x3eba0118,0x63ad23b1}},	//   اسی_, _kõrg, _cnpt_, vvan,
   {{0x9f34035f,0xdc3a07d9,0xc32780f7,0x290fa3b2}},	//   тері, _açık, _تكون_, yoga_,
   {{0x63ad23b3,0xadf18665,0x26cc846d,0x442223b4}},	//   tvan, _अइसन_, _lodo_, _bzk_,
   {{0x2ca91726,0x68e284c4,0x290f86ec,0xa7fb0511}},	// [1390] rdad_, dhod, voga_, maño,
   {{0x26cca3b5,0xcf2715a9,0x63ad1457,0xa7fb0216}},	//   _nodo_, _تربي, rvan, laño,
   {{0x63ad23b6,0x6b898102,0x290fa3b7,0x7e63a3b8}},	//   svan, zteg, toga_, vanp,
   {{0x63ad01ed,0xf86981a8,0x2fe402d0,0x7e6381e0}},	//   pvan, سمتي_, _örgü_, wanp,
   {{0x26cc8db7,0x6aa7069f,0xfa8e801c,0x752d23b9}},	//   _bodo_, _tajf, _rừng_, mmaz,
   {{0x752d0065,0x26cc8333,0x290fa3ba,0xaaad86a7}},	//   lmaz, _codo_, soga_, _झोंक,
   {{0x26cca3bb,0x0445a3bc,0x68e281f6,0x3d0ba3bd}},	//   _dodo_, нейн, bhod, ावले_,
   {{0x68e28f4c,0x27e682d0,0x752d22f8,0x2f16008b}},	//   chod, bzon_, nmaz, lægt_,
   {{0x7e63a3be,0x248d8669,0xe3b18c3b,0x386023bf}},	//   panp, rfem_, ارب_, _reir_,
   {{0x7c22a3c0,0x5fbe950e,0x386023c1,0x1eea8061}},	//   _dzor, ्हरल, _seir_, _فوقی_,
   {{0x6b89a3c2,0xfa8e8028,0xaca38870,0x7c22a3c3}},	//   steg, _từng_, _azụm, _ezor,
   {{0xc689073a,0x26c7803a,0x98b880eb,0x7e61a3c4}},	//   _לא_, ljno_, _kurā_, _help,
   {{0xbd2c893f,0x95228117,0x6d41a3c5,0x752d0904}},	//   _וואָ, _حکوم, _hula, dmaz,
   {{0x68e28a56,0x7d1ba3c6,0x78a9a3c7,0xd36ea3c8}},	//   zhod, llus, _laev, _اهو_,
   {{0x6d41a3c9,0x386023ca,0x7d0902a5,0x442223cb}},	//   _jula, _teir_, česn, _szk_,
   {{0x6d41a3cc,0x64a323cd,0xdca30af0,0x7693861c}},	//   _mula, ласа, ласи, lıyı,
   {{0xac070056,0x68e29dc1,0x24070c24,0xeb97023a}},	// [13a0] ента_, vhod, енти_, нит_,
   {{0xe9ff8104,0x6281a3ce,0x7d1ba3cf,0x7e6181bf}},	//   _giải_, nglo, hlus, _nelp,
   {{0x7d1ba3d0,0xae5b0051,0xd9108065,0x6d41a1b8}},	//   klus, _מכיר, لیس_, _nula,
   {{0xa01b00f2,0x38608013,0x26cca3d1,0x443da3d2}},	//   mför, úir_, _sodo_, _ngw_,
   {{0x6d41a3d3,0xa01b016d,0x26cca3d4,0x7d1b82f1}},	//   _aula, lför, _podo_, dlus,
   {{0x6d41a3d5,0x27e6a3d6,0x6e94a3d7,0x644b806a}},	//   _bula, rzon_, тику, _afgi,
   {{0x68e28efd,0x40969d85,0xa01b23d8,0x26cc8353}},	//   phod, _прат, nför, _vodo_,
   {{0x629e23d9,0x6d41a3da,0xf8bf0019,0x7ce302f1}},	//   lepo, _dula, rmék_, _võrg,
   {{0x26cc90dd,0xa2c40e70,0x6d41a3db,0x2904a3dc}},	//   _todo_, राप्, _eula, _ijma_,
   {{0x7c229234,0x6d41a3dd,0x60cd1613,0xa01b016d}},	//   _vzor, _fula, _soam, kför,
   {{0x6d41a3de,0x7c228035,0x5cd6804a,0x7d1ba3df}},	//   _gula, _wzor, _підх, blus,
   {{0x73e6a3e0,0x660907d9,0xa01b016d,0x7d1ba3e1}},	//   _поез, şekk, dför, clus,
   {{0x7c228a20,0x6d5e026b,0x6d41a3e2,0xddcc01d0}},	//   _uzor, _awpa, _zula, _čišt,
   {{0x629e23e3,0x66d0016d,0x661aa3e4,0x673a8372}},	//   jepo, _säkr, _kytk, _jitj,
   {{0xdd940048,0xa7fb128e,0x659423e5,0xa2c423e6}},	//   лары, paño, лару, रान्,
   {{0x752d0118,0x57b523e7,0x6aaa86b1,0x5183a3e8}},	//   umaz, _абит, _haff, _суша,
   {{0x752d23e9,0x6aaaa3ea,0x2f160366,0xd3711ef7}},	// [13b0] rmaz, _kaff, tægt_, شها_,
   {{0x6aaaa3eb,0x629e23ec,0xff5001a8,0x78a9852a}},	//   _jaff, gepo, _اخي_, _saev,
   {{0x073601c6,0x7d1b8428,0x317ea3ed,0x661a862c}},	//   _שאתם_, ylus, nutz_, _nytk,
   {{0x6ee200e1,0x6d41a3ee,0x98bd02d6,0x00000000}},	//   _vôbe, _rula, _ouvč_, --,
   {{0x6d41a3ef,0x07a58fe7,0x317e81ec,0x7ce30074}},	//   _sula, талн, hutz_, _võrd,
   {{0x6d419397,0xa3ae0665,0xcf9400be,0x7e6705f3}},	//   _pula, किर_, רטס_, najp,
   {{0xf2d20159,0xdcfa884a,0x6b8d0601,0x7d1b8006}},	//   _דעם_, _artı, ltag, tlus,
   {{0xdb060884,0x6281a3f0,0x24868706,0x673a890d}},	//   _erkä, wglo, _ccom_, _eitj,
   {{0x7d1ba3f1,0x7e61a3f2,0x6aaa8365,0x6b8d1162}},	//   rlus, _telp, _baff, ntag,
   {{0x6d41a3f3,0x6aaaa3f4,0x7d1ba3f5,0x9e678065}},	//   _tula, _caff, slus, _سائن,
   {{0x7d1ba3f6,0x0574a3f7,0x6d41876d,0xc0e60a41}},	//   plus, _ماند, _uula, вонк,
   {{0x63ad88ae,0xa01b0106,0x6b8d23f8,0x62819670}},	//   _šanu, vför, ktag, sglo,
   {{0xa8568039,0x66048457,0x629523f9,0x9cd681c6}},	//   כירה_, şikt, _obzo, _שונה_,
   {{0xe1f183f8,0x6b8d23fa,0x658a8201,0x6aaaa3fb}},	//   _پست_, dtag, _səhi, _gaff,
   {{0xe73723fc,0x213b23fd,0x8d6304ae,0x925881a8}},	//   тер_, _fiqh_, ивре, _أشهر_,
   {{0xa3ae023c,0xa01b23fe,0x6aaaa3ff,0x2cada400}},	//   किल_, rför, _zaff, nded_,
   {{0x93432401,0xa01b00f2,0x6b8d10c1,0xcb672402}},	// [13c0] инте, sför, gtag, кате_,
   {{0xf1fa2403,0x249fa404,0xa01b0106,0xd0f20032}},	//   وعات_, heum_, pför, _faṣẹ,
   {{0x629e2405,0xfaa31cce,0xcb1283c8,0xa2c41513}},	//   repo, рахо, סלב_, राब्,
   {{0xb91a0032,0x673aa406,0x080a80d7,0xdcfa82a6}},	//   _aifẹ_, _sitj, وزشي_, _istħ,
   {{0x2cada407,0x673aa408,0x2ca00074,0xdb0b823e}},	//   dded_, _pitj, meid_, _orgà,
   {{0xc7d70051,0x2ca02409,0xf4130039,0x63a41e8f}},	//   כוני_, leid_, _כפר_, mwin,
   {{0x6aaaa40a,0x63a4005d,0x5fa9000f,0x888482e3}},	//   _raff, lwin, _चैनल, _میان,
   {{0x4420801c,0x2ca002f1,0xfd0f81a8,0xef1f0061}},	//   _ơi_, neid_, يجي_, ttük_,
   {{0xccf30051,0x2b4600f7,0xf746a40b,0x63a4240c}},	//   יכה_, íoch_, _резо, nwin,
   {{0x2ca0240d,0x2129240e,0x2d9a0aa2,0x63ab006a}},	//   heid_, _shah_, _oppe_, ægni,
   {{0x60f9240f,0xc486a410,0x63a42411,0xfbcf8bca}},	//   ення_, _алек, hwin, متی_,
   {{0x6aaaa412,0x63a42413,0x6b8d2414,0xcd368481}},	//   _waff, kwin, ytag, _شراب,
   {{0x6aaa82a6,0x442080ff,0x2ca002f1,0x64430035}},	//   _taff, _ái_, deid_, śnik,
   {{0x29022415,0x442682a0,0x2d472416,0x6b8d2417}},	//   anka_, _izo_, _põe_, vtag,
   {{0x63a42418,0x69dca419,0x6b8085ee,0x00000000}},	//   ewin, øred, lumg, --,
   {{0x6b8d241a,0x200901c0,0x2ca0052a,0xba3781c6}},	//   ttag, _txai_, geid_, _בטוח_,
   {{0xbab902cb,0x3949807a,0x63a4241b,0x613a928a}},	// [13d0] нгах_, _časi_, gwin, _půln,
   {{0x6b8d241c,0x24730028,0x7a40026f,0xbb1900f7}},	//   rtag, ệm_, vští, رياض_,
   {{0x6b8d241d,0x2ca0241e,0x7afda41f,0x249f808e}},	//   stag, beid_, ésti, yeum_,
   {{0xf7719a00,0x44268870,0xf2df002e,0x2ca00362}},	//   مات_, _ozo_, _atât_, ceid_,
   {{0x747a0039,0x78ad02f1,0x6d452420,0x7f198110}},	//   _אנרג, _maav, _huha, ніку_,
   {{0x6d452421,0x753d2422,0x6f152423,0x3ebea424}},	//   _kuha, _hisz, nozc, _cntt_,
   {{0x4426a425,0x6d450406,0x753d0019,0x29880dc7}},	//   _azo_, _juha, _kisz, _исто_,
   {{0x644d2426,0xf3f98087,0x60dd090d,0xd9288162}},	//   ncai, laţi_, jksm, _ацул_,
   {{0xe796853d,0x2cada427,0xf4959e29,0x644d2428}},	//   _مالک, rded_, نشکد, icai,
   {{0x63ad803b,0xdb0400a9,0x62852429,0x2fd9031d}},	//   _šans, rviç, ngho, dysg_,
   {{0x63a4242a,0x5dd58875,0x4426a42b,0xa2c403dd}},	//   zwin, _حقائ, _ezo_, रात्,
   {{0xcea90bea,0x78ad002a,0x29020079,0x63a40123}},	//   _מי_, _caav, unka_, ywin,
   {{0x645ba42c,0x7f44157a,0x776081c0,0xe2a880d7}},	//   mbui, _quiq, _xwmx, راین_,
   {{0x6d45242d,0x201e00eb,0x99d581ad,0xf3f98162}},	//   _buha, āti_, _متبا, jaţi_,
   {{0xfce6242e,0x2ca00074,0x63a4242f,0xe2968098}},	//   гово, teid_, wwin, _сащ_,
   {{0x30ae80ab,0x6d452430,0x03a613f7,0x78ad1a14}},	//   _কক্স, _duha, либо, _gaav,
   {{0x68e42431,0x2ca02432,0x6d452433,0x0c262434}},	// [13e0] _ilid, reid_, _euha, уман,
   {{0xa2c42435,0x2ca00006,0x63a4044e,0x6aa1808e}},	//   राध्, seid_, rwin, nelf,
   {{0x3f822436,0x394f802e,0x6d4502a0,0x2d9a016d}},	//   luku_, _însă_, _guha, _uppe_,
   {{0x7d7b012a,0x74550698,0xa3e3809a,0x600a8110}},	//   _אנטו, _върх, नना_, ннем_,
   {{0x7d042437,0xa2c40697,0x6d452438,0x3f822439}},	//   mnis, राद्, _zuha, nuku_,
   {{0xf3f9802e,0x765c243a,0xe16601a8,0x716601a8}},	//   caţi_, nbry, _مدري, _مارك,
   {{0x91e60134,0x7d0d9234,0x3f82243b,0x68e4243c}},	//   _сове, časn, huku_, _olid,
   {{0x33749630,0x7d04138e,0x44268140,0x7981a43d}},	//   агир, nnis, _pzo_, dulw,
   {{0x7d04243e,0xd70a81f3,0x3f82126a,0x1616243f}},	//   inis, _знае_, juku_, _दुसर_,
   {{0xbda68077,0x78ad01c2,0x7d042440,0x68e42441}},	//   _محصو, _saav, hnis, _alid,
   {{0x7d040e51,0x527b00be,0x765c2280,0x6f1504e8}},	//   knis, ענטא, dbry, vozc,
   {{0x27e62442,0x33869c79,0x6d452443,0x2ba510d0}},	//   _żona_, _букв, _ruha, _ऑनला,
   {{0x44268870,0x6d450239,0x3f822444,0x60dd2445}},	//   _uzo_, _suha, guku_, rksm,
   {{0x6d452446,0x68e401f6,0x7d042447,0x02a3847f}},	//   _puha, _elid, enis, _гръм,
   {{0x59a40063,0x753d2448,0x78ad14c7,0x7afaa449}},	//   _गैलर, _pisz, _taav, mitt,
   {{0x7afaa44a,0x3f820904,0x5455244b,0x6d45244c}},	//   litt, buku_, рват, _vuha,
   {{0x753d0065,0x644d244d,0xf3f98087,0xe0208105}},	// [13f0] _visz, rcai, taţi_, _बरगद_,
   {{0x644d244e,0x7afaa44f,0x320b0d8f,0x657a0174}},	//   scai, nitt, нхен_, áthc,
   {{0x753d0065,0x7d0402af,0x658a8085,0xad27004e}},	//   _tisz, bnis, _məhs, _مرحو,
   {{0x7afaa450,0x6aa18a0f,0xe82082f1,0x3ea32126}},	//   hitt, zelf, _बरखा_, lejt_,
   {{0x62989807,0x2d910102,0xd5b88dc1,0x938b2451}},	//   _obvo, ltze_, _arā_, _ясна_,
   {{0xd9f68075,0x4b7a03de,0x60c082d6,0x261a0075}},	//   ुपात_, _באשו, _enmm, _मुडी_,
   {{0x2d8309a4,0x7afaa452,0x249900b9,0x2d91011b}},	//   nuje_, ditt, _kbsm_, ntze_,
   {{0x09e10770,0x2909004f,0x67d58a42,0x7d0d94f0}},	//   पनीय, _njaa_, _кобу, časo,
   {{0x2d830bfb,0xb4d58b9f,0xe787a453,0x645ba454}},	//   huje_, _सकी_, _љубо, rbui,
   {{0x3ae400f2,0x6442a455,0x7afaa456,0x3f820289}},	//   _köpa_, _egoi, gitt, vuku_,
   {{0x41062457,0xdeba83c8,0x7d042458,0x8a388198}},	//   изов, _שמעל, ynis, ляют_,
   {{0x3c478013,0x3f822459,0x6aa1879f,0xab9580e8}},	//   _إضاف, tuku_, self, _виді,
   {{0x3949a19f,0x7d04007d,0x7d04a45a,0xf746245b}},	//   _času_, vnis, čist, рего,
   {{0x3f82003a,0x69daa45c,0x26d30118,0x7afa847f}},	//   ruku_, byte, _coxo_, citt,
   {{0x7d04245d,0x3f82245e,0x6da602c7,0x765c245f}},	//   tnis, suku_, шива, rbry,
   {{0x3f822460,0x81bd00ab,0x26f28697,0x7ce302f1}},	//   puku_, েনা_, _अग्र_, _põra,

   {{0x26d303a8,0x7d041162,0x234800d7,0x39478580}},	// [1400] _foxo_, rnis, اسری_, _huns_,
   {{0x2d832461,0x42560dc0,0x3947867f,0x658a811c}},	//   buje_, ртат, _kuns_, _məhr,
   {{0x50669ac9,0x867b00be,0x7e7b0039,0xc6930039}},	//   атла, _בריו, _באיז, _ואת_,
   {{0xd7faa462,0xe7b30bca,0xa2c40aed,0x7afaa463}},	//   кул_, _امید, राह्, zitt,
   {{0x27e08307,0x3947862f,0x44242464,0x212d81b4}},	//   áin_, _luns_, _ám_, _dheh_,
   {{0x78a2a465,0x64428046,0xa2e60009,0xdd9aa466}},	//   seov, _sgoi, _тогд, вши_,
   {{0x35678048,0x3947a467,0x7afa95c8,0xf8bf00e7}},	//   арын_, _nuns_, vitt, llée_,
   {{0x3d10a468,0xd9432469,0x63b99670,0x658a811c}},	//   ावें_, _фети, _brwn, _bəhr,
   {{0x66768077,0x7afaa46a,0xb4d6816f,0x2b4680ff}},	//   _ندار, titt, _हवी_, _quoc_,
   {{0xf2d300be,0xf2df00ff,0x69daa46b,0x4ac90f3a}},	//   ַער_, _luân_, tyte, रायव,
   {{0x7afaa46c,0x394783a8,0x26d3241f,0x6f18a46d}},	//   ritt, _cuns_, _roxo_, movc,
   {{0x7afaa46e,0x2d83003e,0x3949811f,0x394784c3}},	//   sitt, vuje_, _čast_, _duns_,
   {{0xcb548277,0x658a8201,0x893780be,0x61ff8085}},	//   _انتظ, _təhs, ירטע_, _əylə,
   {{0x6f18a46f,0x6d48a470,0xdefb01e2,0x3ce681c0}},	//   novc, _kuda, тым_, _hlov_,
   {{0x998480f7,0x69da8168,0x272981a8,0x3ea30168}},	//   _العو, qyte, núna_, rejt_,
   {{0x6d48a471,0x3ea32472,0x657a00f7,0xf8bf2473}},	//   _muda, sejt_, átha, rmés_,
   {{0xc2991b69,0x3ea300f1,0x26d3002a,0x213f8359}},	// [1410] лках_, pejt_, _toxo_, _riuh_,
   {{0xa2c40778,0x29192474,0x68fd2475,0xddc38087}},	//   राष्, losa_, lisd, nanţ,
   {{0xf9f901a8,0x6f18936f,0x80cb81a2,0x80c38072}},	//   دفاع_, dovc, _सचदे, ळाले,
   {{0x68fd2476,0xb4d5a0d5,0x6d57011b,0x112880e8}},	//   nisd, _सके_, _itxa, аючи_,
   {{0x38691de8,0x2d9ea477,0x395a02c4,0x6d48016b}},	//   _mear_, _apte_, apps_, ídav,
   {{0x6d48a478,0xef188a8e,0x386901a8,0x9a840251}},	//   _buda, амі_, _lear_, _мусл,
   {{0x29192479,0x6d48a47a,0xa2c40c46,0x7ae700b9}},	//   kosa_, _cuda, रार्, _iljt,
   {{0x6d48a47b,0x2489247c,0xf2df001c,0xe91980e8}},	//   _duda, ngam_, _xuân_, _собі_,
   {{0xdd0205f3,0x6d48a47d,0x3940247e,0x658a811c}},	//   šuću, _euda, _riis_, _qəhr,
   {{0x3940247f,0x7645031d,0xf3ff0187,0xcac98d15}},	//   _siis_, _nghy, _leão_, угое_,
   {{0x6d48a480,0xa06a2481,0x6d5701c5,0x186a2482}},	//   _guda, лана_, _ntxa, лани_,
   {{0xcd968039,0x38692483,0x29192484,0x62889de6}},	//   _לדעת_, _cear_, gosa_, agdo,
   {{0xe8f72485,0x39400074,0x6d570cdb,0xe2999c68}},	//   сля_, _viis_, _atxa, _бал_,
   {{0x7c2b8025,0x63a9a486,0x6d48a168,0xddc38087}},	//   _izgr, mwen, _yuda, canţ,
   {{0x63a9805d,0x39402487,0x38692488,0x8db5004a}},	//   lwen, _tiis_, _fear_, ості,
   {{0x3991a489,0xf2df0028,0x6b84248a,0xb4d5954b}},	//   más_, _quân_, tuig, _सको_,
   {{0x39918117,0x60c4248b,0xe29a02df,0x63a9a48c}},	// [1420] lás_, _inim, лаа_, nwen,
   {{0x16aa00af,0xfd690133,0x20ef0326,0x7b1d823e}},	//   _свои_, _jupụ, nƙin_, cèut,
   {{0xe29702cb,0x38690051,0x63a9a48d,0xbed700be}},	//   сах_, _year_, hwen, _הויז_,
   {{0xb4d68e1a,0x6d5c0cd4,0x63a9a48e,0x6d48a48f}},	//   _हवे_, mpra, kwen, _ruda,
   {{0x6d48a490,0x351b0051,0xdefa8a41,0x64460122}},	//   _suda, _תוכנ, лык_, _igki,
   {{0x3ce6826f,0x3991a491,0x75242492,0x6ffc00eb}},	//   _slov_, kás_, lliz, mācī,
   {{0x6d5c0247,0xfe6f8060,0x29192493,0x6f18a494}},	//   npra, ردو_, yosa_, rovc,
   {{0x39918065,0x4422079f,0x3b548652,0xdbdd00e1}},	//   dás_, _kyk_, окир, zšír,
   {{0xddc3802e,0x9696813a,0x64460359,0xfd69019d}},	//   tanţ, _греш, _mgki, _bupụ,
   {{0x6d48a495,0x4974a45b,0x38690229,0x2ca4a496}},	//   _tuda, олос, _sear_, semd_,
   {{0x629c020f,0x4422079f,0xddc38087,0xba9b03de}},	//   _mbro, _lyk_, ranţ, נסטי,
   {{0x23c802f1,0x7aef8722,0x3ce6a497,0x6d5c2498}},	//   रमाद, èctr, _ulov_, dpra,
   {{0x7afe0125,0x75242499,0x6c36a3f7,0x5f94249a}},	//   kipt, dliz, _افشا, пият,
   {{0xb5fc84b7,0x39918019,0x60c4249b,0xddc3826c}},	//   _reġj, bás_, _enim, lanš,
   {{0x2919249c,0x1dbd881f,0x6d5c200b,0xf3ff02df}},	//   posa_, ्मयत, gpra, _peão_,
   {{0x99860063,0x4422249d,0xddc380eb,0x657c854f}},	//   łoś_, _byk_, nanš, _århu,
   {{0x8b5801a8,0x629c0362,0x2489249e,0x2d7301a1}},	// [1430] مجلس_, _bbro, rgam_, sće_,
   {{0x7524249f,0x2d7324a0,0x3f868118,0x442224a1}},	//   aliz, pće_, duou_, _dyk_,
   {{0x752424a2,0x66d00009,0x7f3c00be,0x1a9b80be}},	//   bliz, _näky, _געזו, ריבע,
   {{0xad270416,0x38698125,0x9bc7027e,0xfc3f01df}},	//   _درخو, úar_, _лёгк, _saíu_,
   {{0x39918065,0x7c229eb3,0x7f49a4a3,0x39580580}},	//   zás_, _nyor, _queq, _etrs_,
   {{0x7afe059c,0xab5b02af,0x8d558056,0xe739a4a4}},	//   cipt, _prüf, отич, шел_,
   {{0x6d42a4a5,0xc05b8558,0xed598150,0x63bd008e}},	//   _bioa, _біз_, шой_, _hrsn,
   {{0x6d42a4a6,0x7cfe9482,0x68e2a4a7,0x63bd025b}},	//   _cioa, tūra, ckod, _krsn,
   {{0x69dc8bc5,0x68e9a4a8,0x63a98a0f,0x63bb00fe}},	//   øren, _iled, uwen, _šunj,
   {{0x60c4003b,0x3991a4a9,0x81d480c8,0x68e9800d}},	//   _snim, tás_, _সেই_, _hled,
   {{0x3ea785ef,0x68e9a4aa,0x63a9805d,0x54558323}},	//   ment_, _kled, swen, _двет,
   {{0x2d87a4ab,0x3ea08067,0x6d5c007a,0x3ea7a4ac}},	//   mune_, đite_, vpra, lent_,
   {{0x7c228065,0x7d248009,0x7c2ba4ad,0xb05b016d}},	//   _gyor, _эффе, _uzgr, tjär,
   {{0x4422067f,0x6d5c24ae,0x68e2a4af,0x7d1ba4b0}},	//   _ryk_, tpra, zkod, lous,
   {{0x3ea782be,0x8237826a,0x7d09a4b1,0x290d802a}},	//   ient_, _ارشا, ones, _ojea_,
   {{0x395824b2,0xe45a0323,0x3ea7a4b3,0x2a6a00ee}},	//   _rtrs_, ржа_, hent_, _sebb_,
   {{0x3ea7a4b4,0xa11300f7,0x752424b5,0x2a78008e}},	// [1440] kent_, _تويت, rliz, _pdrb_,
   {{0x6d5c24b6,0x3ea7a4b7,0x63bd1b3b,0x68e9816a}},	//   ppra, jent_, _drsn, _aled,
   {{0x7afe24b8,0x3ea7a1eb,0x8c46054c,0x2d87a4b9}},	//   ript, dent_, _мене, june_,
   {{0x4fc681bb,0x3f868ece,0xa99a80be,0x2d87a4ba}},	//   жска, tuou_, יבער, dune_,
   {{0x7d1b81df,0x7d090669,0xddc38088,0xbba8886a}},	//   dous, čest, vanš, _कनेक,
   {{0x7afe08cf,0x3ea78bf9,0x68e2a4bb,0x68e9a4bc}},	//   qipt, gent_, skod, _eled,
   {{0xbb4311d2,0xc448819f,0xf9878277,0xa2cda4bd}},	//   _церк, میان_, _تب_, तान्,
   {{0xd4978012,0x7d1ba4be,0x151780f7,0xd25080d7}},	//   орь_, gous, يزية_, کند_,
   {{0x3ea7a4bf,0x39448101,0xe7a90035,0xcb0a81a4}},	//   bent_, _iims_, _चैंप, иход_,
   {{0x21268b50,0x3ea7a4c0,0xb5fc81b9,0x7d0981e8}},	//   lloh_, cent_, _leġi, anes,
   {{0x2d87a4c1,0x3958a4c2,0x6e93803d,0x7d1ba4c3}},	//   cune_, ërs_, _آلما, bous,
   {{0x7d1ba4c4,0xeb9a8a94,0x6d5aa4c5,0x6ec283ca}},	//   cous, _вид_, _itta, लाकु,
   {{0x7762011c,0x6f1c24c6,0x5ead8264,0x7c228db1}},	//   _çoxl, forc, চারে, _uyor,
   {{0x3f508028,0x6f1c0024,0x61318370,0x63a2826b}},	//   _màu_, gorc, måle, _ipon,
   {{0xd5b80abe,0x3eb30085,0xfc3f801b,0x2b4b01e8}},	//   ост_, _vaxt_, žít_, _succ_,
   {{0x3ea7a4c7,0x7d00880a,0x1fa724c8,0x63bd1b99}},	//   zent_, nims, _дрог, _prsn,
   {{0x964701e5,0x200c0201,0x3ea7a4c9,0x43940251}},	// [1450] _мэнд, şdir_, yent_, матс,
   {{0x7d09a4ca,0x6d5a919d,0x68fba4cb,0x63bd0042}},	//   znes, _otta, _smud, _vrsn,
   {{0xaca301bc,0x3ea7a4cc,0x7d00a4cd,0xdcf50035}},	//   _ahụb, vent_, kims, erzą,
   {{0x3ea7a4ce,0x63a287c6,0x76550035,0x39448980}},	//   went_, _opon, lczy, _cims_,
   {{0x6d5aa4cf,0x7d098aa2,0x98c60289,0x995401d0}},	//   _atta, vnes, šući_, _výše_,
   {{0x63ad0555,0x643a0158,0x2d87a4d0,0x2ca924d1}},	//   mwan, _לערנ, tune_, lead_,
   {{0x7d1ba4d2,0x3ea78218,0x63ad24d3,0x63a2a4d4}},	//   tous, rent_, lwan, _apon,
   {{0x3ea7a4d5,0x68fba4d6,0x2ca924d7,0x2d87a4d8}},	//   sent_, _umud, nead_, rune_,
   {{0xff538b53,0x7d1ba4d9,0x291da4da,0x6d5a82ec}},	//   _آخر_, rous, mowa_, _etta,
   {{0x2ca924db,0x63a000f2,0xdd008029,0x7d09a4dc}},	//   head_, _ämne, ētāj, snes,
   {{0x63ad24dd,0x386da4de,0x7d1ba4df,0x63a2a4e0}},	//   hwan, _keer_, pous, _epon,
   {{0x63ad24e1,0x0d848048,0x386d8079,0x23759459}},	//   kwan, _ілін, _jeer_, _فاتح,
   {{0x386d9302,0xb5fc84b7,0x63ad24e2,0x7cee8362}},	//   _meer_, _reġi, jwan, _dùrd,
   {{0x386da4e3,0x63ad24e4,0x27328087,0x248d9dff}},	//   _leer_, dwan, când_, lgem_,
   {{0x1dbd88af,0xa928826f,0x291da4e5,0x09e581e5}},	//   ्मित, ližš, kowa_, _хойн,
   {{0x2ca90706,0x7afc06d4,0x6f1c016a,0x386d837a}},	//   gead_, _smrt, sorc, _neer_,
   {{0xfc3f04c3,0x291da4e6,0x63ad24e7,0x2d8324e8}},	// [1460] _saír_, dowa_, gwan, arje_,
   {{0x290224e9,0xe81f8740,0x78b60214,0x6b96016d}},	//   lika_, _बड़ा_, _hayv, rtyg,
   {{0xb87b0876,0x5ba880d4,0x399504e1,0x6edb01c6}},	//   chís, _कन्व, gås_, _החיפ,
   {{0x29020288,0x63ad24ea,0x2fc001a3,0x3eaa0192}},	//   nika_, bwan, _krig_, lebt_,
   {{0x4cbb0051,0xdcfc0029,0x2d9824eb,0x6b898264}},	//   _הזכו, strē, ltre_, jueg,
   {{0x290224ec,0x6d4624ed,0xb4b48105,0x6b8424ee}},	//   hika_, _hika, _छोड़_, mrig,
   {{0x290224ef,0x2d9824f0,0x6d4624f1,0x291da4f2}},	//   kika_, ntre_, _kika, bowa_,
   {{0xe05591fb,0x94aa8bac,0x6eeb0201,0x6d4616f8}},	//   _قیمت_, стка_, _müba, _jika,
   {{0x290224f3,0x6d4624f4,0x6b8424f5,0x7f4a826a}},	//   dika_, _mika, nrig, _طلاق_,
   {{0x6d4624f6,0x386d8a0f,0x61e1a4f7,0x248d83a7}},	//   _lika, _zeer_, fyll, agem_,
   {{0x290224f8,0x63ad24f9,0x6b8402af,0x6d5a8b64}},	//   fika_, zwan, hrig, _utta,
   {{0xc0580a4c,0x63ad0063,0x2fc0031d,0x6b840bbd}},	//   зір_, ywan, _brig_, krig,
   {{0x613f0029,0x3869808b,0xb4db0722,0x27328087}},	//   _jūli, ðari_, _diàl, pând_,
   {{0x4426a4fa,0x6d4624fb,0xa3c209a3,0xa3c00540}},	//   _iyo_, _aika, ्मन_, ंटन_,
   {{0x26da0698,0xcb138158,0x6d4624fc,0x2902028d}},	//   _dopo_, _אלס_, _bika, bika_,
   {{0x6d4624fd,0x44268365,0xe81e123a,0x2d8300f1}},	//   _cika, _kyo_, _युवा_, rrje_,
   {{0x2d9c1918,0x6d46059c,0xa87c0051,0x386d82a3}},	// [1470] _även_, _dika, _האחר, _reer_,
   {{0x63ad0578,0x6eef8022,0x7cea003e,0x291da4fe}},	//   rwan, _købe, _výra, wowa_,
   {{0x68ed07df,0x63ad24ff,0x6d462500,0x291da501}},	//   _klad, swan, _fika, towa_,
   {{0xf1c00104,0xf77185ff,0x399500f2,0xddde001b}},	//   ương_, نات_, rås_, _nepř,
   {{0x68ed15d8,0x6eef813c,0x4426a502,0x611200eb}},	//   _mlad, _løbe, _nyo_, nāla,
   {{0x386d81d8,0x6da5a503,0x291da504,0x6d462198}},	//   _weer_, дика, sowa_, _zika,
   {{0xfe708d4a,0x68ed046d,0x4426a505,0xc9842410}},	//   اده_, _olad, _ayo_, _пути,
   {{0x7d0d2506,0x44268e4d,0x29022507,0x61120ec3}},	//   nnas, _byo_, xika_, kāla,
   {{0x248da508,0x442682a0,0xdb1d2509,0x61e18114}},	//   rgem_, _cyo_, _arsé, wyll,
   {{0x6721803b,0x68ed250a,0x7cf1250b,0x7d0d031d}},	//   _uklj, _alad, _hård, hnas,
   {{0x2902250c,0x68ed0cda,0x60db8247,0x6f038098}},	//   tika_, _blad, _koum, minc,
   {{0x68ed250d,0x61e1a50e,0x7d0d026c,0xe45f0106}},	//   _clad, ryll, jnas, _snön_,
   {{0x2902250f,0x61e18355,0x6d462510,0xdb0f2511}},	//   rika_, syll, _rika, _escé,
   {{0x2d982512,0x68ed2513,0x29022514,0x7529a515}},	//   ttre_, _elad, sika_, llez,
   {{0xceb2878d,0xf7432516,0x29022517,0x31160a0e}},	//   כים_, теро, pika_, _офис,
   {{0xd1320b76,0x2d982518,0x7d0d007b,0x60dba519}},	//   _جمع_, rtre_, gnas, _noum,
   {{0x26da251a,0xeb97251b,0xddc7251c,0x442681c0}},	// [1480] _topo_, мит_, rajš, _xyo_,
   {{0x6d46009c,0xa01b251d,0x7c26016b,0x7d0d0706}},	//   _wika, rgöt, _vykr, anas,
   {{0x6d460341,0x6f03a51e,0x644b81e8,0x810206a7}},	//   _tika, dinc, _oggi, _लगाओ_,
   {{0x6b84251f,0x61e30edd,0x236000f3,0xa3bf801b}},	//   prig, ønla, ppij_, ुमा_,
   {{0x4f579e91,0x60db8bfe,0x6f03a520,0x75298da8}},	//   وجود_, _doum, finc, dlez,
   {{0x644b8698,0x7d042521,0x75228353,0x75298010}},	//   _aggi, liis, _skoz, elez,
   {{0x1ea980f7,0x7ae30009,0xa01b2522,0x4096a523}},	//   ثاني_, önte, ngör, _орат,
   {{0x7529a524,0x2902816d,0x44268683,0x629e2525}},	//   glez, _öka_, _pyo_, lfpo,
   {{0x3866a526,0x6f0385a3,0xdb04002a,0xd00781a1}},	//   mbor_, binc, lviñ, _жете_,
   {{0x68ed077b,0x6d5e003a,0x2b47809f,0x7d040079}},	//   _slad, _otpa, _cinc_, hiis,
   {{0x6d5ea527,0x68ed0022,0x7d042528,0x7cf1104a}},	//   ípad, _plad, kiis, _håre,
   {{0x80e080c8,0x4426a529,0x7cf1006f,0x63a61384}},	//   পোর্, _tyo_, _kåre, _opkn,
   {{0x68ed0289,0x7d0402a3,0x6d5e252a,0x59b0805e}},	//   _vlad, diis, _atpa, _जनवर,
   {{0xe8df801c,0x68ed252b,0x3f99252c,0x69c101a1}},	//   _miền_, _wlad, rtsu_, _šlem,
   {{0x442d252d,0xc3488028,0xe8df801c,0x7d0d252e}},	//   _še_, _nổi_, _liền_, tnas,
   {{0x3998a52f,0x6f03a530,0x7d042531,0x30a704bd}},	//   més_, zinc, giis, _цркв,
   {{0xe667017a,0x3998a532,0x6e2883ba,0x60dba533}},	// [1490] _отно, lés_, _lydb, _roum,
   {{0x7d0d2534,0x4ac9000f,0x3f8687b1,0x35b52535}},	//   snas, राइव, drou_, _збор,
   {{0x6f03a536,0x7d042537,0x3998a538,0xa2c42539}},	//   vinc, biis, nés_, राज्,
   {{0x7d0401b4,0xa8158162,0x4f958087,0x61360144}},	//   ciis, ндеш, ерку, rálg,
   {{0x3f868ece,0x7cf100f2,0x3949253a,0x399880e7}},	//   grou_, _vård, _mias_, hés_,
   {{0x39490282,0x8ca1809a,0x6d580036,0x6b8d0c53}},	//   _lias_, क्नो, _évac, muag,
   {{0x6f03a53b,0x7bc2a53c,0x60dba53d,0xada5a53e}},	//   rinc, _arou, _toum, хайл,
   {{0x6234253f,0x60c9a540,0x39490069,0x3998a541}},	//   _ресу, _unem, _nias_, dés_,
   {{0xa2c4016f,0x7bc2a542,0x6136016b,0x7529890d}},	//   राच्, _crou, nále, rlez,
   {{0xa3c20c78,0x7529928a,0x394906ae,0xaad20b84}},	//   ्मत_, slez, _aias_, सायक,
   {{0x39492543,0x3998a544,0x2b47874a,0x290f8db1}},	//   _bias_, gés_, _vinc_, onga_,
   {{0x290f81e0,0x7bc284cc,0xf8bf003e,0x39492545}},	//   nnga_, _frou, blém_, _cias_,
   {{0x39492546,0x7bc2a547,0x2b47809f,0x7d0421e8}},	//   _dias_, _grou, _tinc_, viis,
   {{0xfbd08065,0x6136026f,0x2cad8079,0x3998a548}},	//   _ختم_, dále, leed_, bés_,
   {{0x18a615e3,0x64a62549,0x399887e2,0x7d04254a}},	//   _займ, нава, cés_, tiis,
   {{0x7cea0a56,0x2d878c41,0x2900254b,0x2cad81b4}},	//   _výro, irne_, _umia_, need_,
   {{0x7d04254c,0x6136254d,0x6b9ba54e,0xccf280be}},	// [14a0] riis, ráld, ntug, אכן_,
   {{0x7d0418dc,0x2cb90118,0x2cada54f,0x39490282}},	//   siis, _easd_, heed_, _zias_,
   {{0x39490282,0x7cf1120b,0x8886a550,0x7d042551}},	//   _yias_, _såre, ележ, piis,
   {{0xa3c206a7,0x70538077,0x3f86a552,0xdd2f001b}},	//   ्मद_, هنما, trou_, pěšn,
   {{0x39988065,0x2d87a553,0x78a42554,0x3c7701c6}},	//   zés_, erne_, _mbiv, _אתכם_,
   {{0x290fa555,0x399880e7,0x7bc48110,0x7cf10b64}},	//   anga_, yés_, _šiuo, _våre,
   {{0xf9879ddd,0x2cada556,0xc69300be,0x212b0114}},	//   _حب_, feed_, טאג_, ylch_,
   {{0xe8df8104,0x2cad8079,0x61469c8b,0x7cee8362}},	//   _tiền_, geed_, _чеба, _bùra,
   {{0x02e401ce,0xdccf8028,0x39492557,0x69c3a558}},	//   _गवाह_, _tỉnh_, _rias_, _arne,
   {{0x3998a559,0x7bc2a4de,0x93fb03c8,0x78a4255a}},	//   tés_, _vrou, פליי, _abiv,
   {{0x0d868847,0x3949255b,0xb05b0338,0xfaa38048}},	//   _член, _pias_, ndäg, ушын,
   {{0x39989b01,0xa3c21299,0xfc648bca,0x7bc2a55c}},	//   rés_, ्मा_, _شخصی, _trou,
   {{0x3998a532,0x3949255d,0xa30b8117,0xa2e69ccf}},	//   sés_, _vias_, _کرنے_, _подд,
   {{0x3998a55e,0x8c4395d2,0x26de804f,0x9f35004a}},	//   pés_, _сече, _joto_, тегі,
   {{0x394910af,0x3eba255f,0x62830511,0x7e752560}},	//   _tias_, _dapt_, ónom, razp,
   {{0x6b8d2561,0x0ccf00ab,0x81d60264,0x7cf1006f}},	//   tuag, রস্ত, িনা_, _sårb,
   {{0x60cd02a0,0x3eba002e,0x26cca562,0x7d02826c}},	// [14b0] _inam, _fapt_, _ondo_, _mmos,
   {{0x78bd04fe,0x78a415db,0x26dea563,0x6b8d2564}},	//   ldsv, _zbiv, _noto_, ruag,
   {{0x2cad82c1,0xab5b02af,0x290f8bb1,0x7d02a565}},	//   yeed_, _grün, tnga_, _omos,
   {{0x82341301,0x78bd0bcb,0xa95400e8,0xd47900be}},	//   اركا, ndsv, укці, _קאָל,
   {{0x27e68065,0x78bd0fb0,0x60cd004f,0x26dea566}},	//   gyon_, idsv, _mnam, _boto_,
   {{0x7d02a567,0xe8df8028,0x752d2568,0x26de8333}},	//   _amos, _biển_, llaz, _coto_,
   {{0x30a7a569,0xa8a799b8,0x62340ca0,0x387f808e}},	//   _прав, _прак, _беру, _tdur_,
   {{0x6b9ba56a,0x7cf58661,0x09e480ab,0x81c88264}},	//   ttug, _márg, _ফেভা, োনা_,
   {{0x249fa56b,0x2cada56c,0xf69984ae,0x69dca56d}},	//   rfum_, reed_, _овај_, ären,
   {{0x6b9ba56e,0x60cd256f,0x78bba570,0x752d237d}},	//   rtug, _anam, _hauv, hlaz,
   {{0x3f8fa571,0x6723822b,0x6b9ba572,0x60cd0144}},	//   lugu_, monj, stug, _bnam,
   {{0x6723a573,0x60cd0362,0xa3d1001b,0x69c382d4}},	//   lonj, _cnam, वमा_, _vrne,
   {{0x3ae4016d,0x78bb80e7,0xe29983a7,0x442b2574}},	//   _köpt_, _mauv, _жал_, _nyc_,
   {{0x290680ad,0x6d4ba575,0x60cd2576,0x6723a577}},	//   zioa_, _higa, _enam, nonj,
   {{0x3f8f8578,0x6d4ba578,0x27e6942a,0x752d2579}},	//   hugu_, _kiga, zyon_, flaz,
   {{0x6d4b8300,0x3f8fa57a,0xfbe700ff,0x7cfea57b}},	//   _jiga, kugu_, _thể_, tūri,
   {{0x6d4ba57c,0x69c1a57d,0x0326257e,0x442b00ee}},	// [14c0] _miga, lvle, вдан, _cyc_,
   {{0x6d4ba57f,0x394a026f,0x3f8fa580,0x6b89802a}},	//   _liga, _časy_, dugu_, ireg,
   {{0xe2971a8f,0x26dea581,0x6723a582,0x752d2583}},	//   тах_, _roto_, donj, blaz,
   {{0x26dea584,0x6b8980f3,0xe78681e2,0xa9670adb}},	//   _soto_, kreg, вуко, тица_,
   {{0xa2b2835a,0x26dea585,0xa8570039,0x75242586}},	//   _असल्, _poto_, דינה_, moiz,
   {{0x6b898620,0x6723a587,0x57fb0039,0x7bc6022b}},	//   dreg, gonj, ולנו, _irku,
   {{0x27e6a588,0x6d4ba589,0xe297258a,0x7bc081c0}},	//   syon_, _biga, _шар_, wvmu,
   {{0x399c0722,0x6abc258b,0x6b89a58c,0x753982d6}},	//   mís_, _harf, freg, _chwz,
   {{0x26de803e,0x6d4b859e,0x6b89a58d,0x6abc00a4}},	//   _toto_, _diga, greg, _karf,
   {{0x613184b8,0x78bb805c,0x60cd258e,0x78a2a58f}},	//   håll, _zauv, _snam, lfov,
   {{0xa2c30f21,0x399c2590,0x6abc2591,0x68e0a592}},	//   रयत्, nís_, _marf, _komd,
   {{0x6d4b84a7,0x7bc62593,0x7cf581ca,0x92ae00ab}},	//   _giga, _orku, _cárd, কায়_,
   {{0xe9ff8104,0x399c00f7,0x7bd601c0,0x53b6a594}},	//   _phải_, hís_, jxyu, _अनिश,
   {{0x6d4ba595,0x3d952596,0x28a4864a,0x65952597}},	//   _ziga, лигр, _गॉसि, лагу,
   {{0x5e58035f,0x7bc62598,0x2904a599,0x09e384bd}},	//   тися_, _arku, _omma_, _војн,
   {{0x5183a59a,0x60cd259b,0xc9838468,0x399c259c}},	//   _туша, _unam, _туши, dís_,
   {{0x6d408009,0x6abc259d,0xe9ff80ff,0x6d580866}},	// [14d0] imma, _barf, _thải_, _évan,
   {{0x2904a59e,0x78bb82be,0xe8df8028,0x61360125}},	//   _amma_, _sauv, _miễn_, mála,
   {{0x6abc259f,0xce330bca,0x22470884,0xd36680d7}},	//   _darf, _خودک, änk_, _گه_,
   {{0xf8bf25a0,0xfc640698,0x3f8fa5a1,0xfc3f06a5}},	//   ndé_, _върн, tugu_, _maíz_,
   {{0xd3668154,0x70848048,0x6abc25a2,0x6d4ba5a3}},	//   _ده_, ргіз, _farf, _riga,
   {{0x6d4b883a,0x6abc25a4,0x7e7880eb,0x539a04de}},	//   _siga, _garf, gavp, _אישו,
   {{0x613600f7,0x399c25a5,0xdcef81a1,0x6d4ba5a6}},	//   hála, cís_, _žeđa, _piga,
   {{0x6b89a5a7,0x2602816f,0xe3b9a4c8,0x69c7008e}},	//   treg, _वेळी_, еби_, _irje,
   {{0x6d4ba5a8,0x6723a5a9,0x032581cf,0xecc50264}},	//   _viga, ponj, лдин, _একাড,
   {{0x6b89a5aa,0xe8df8104,0x61e8831d,0x645ba5ab}},	//   rreg, _diễn_, fydl, scui,
   {{0x049587bd,0x394d8b3c,0x6d4ba5ac,0x7c2b809a}},	//   _ملاح, _kies_, _tiga, _wygr,
   {{0x6b898e67,0x69c1a5ad,0xa6e28125,0x2d910234}},	//   preg, rvle, _öðru, duze_,
   {{0x7d09a5ae,0x394d9405,0xfaa5a5af,0x7524007d}},	//   mies, _mies_, _бало, voiz,
   {{0x272981df,0x69c725b0,0xe2998320,0x24990122}},	//   múns_, _orje, _чак_, _acsm_,
   {{0x52398158,0xd33681c6,0x26ca8118,0x2d910542}},	//   _אײַנ, _גרסה_, _óboe_, guze_,
   {{0x7d09a5b1,0x399c25b2,0x394d84b7,0xa3c00540}},	//   nies, vís_, _nies_, ंटल_,
   {{0x42ca02df,0x4ab7835a,0x7cf5a5b3,0x2d8a026c}},	// [14e0] нган_, _असाव, _kárb, srbe_,
   {{0x80a005e8,0xe2970087,0xa3d48063,0x2cbd8282}},	//   ग्रे, лау_, हमत_, _lawd_,
   {{0x6abc25b4,0x869b012a,0x8cbf0327,0x7ce30074}},	//   _varf, _אייז, _लोको, _võrr,
   {{0x399c22c6,0x2cbd822c,0x6ae0801b,0x50ba8199}},	//   rís_, _nawd_, _पक्र, عداد_,
   {{0xb8dc9d01,0x394da5b5,0xdee6a5b6,0x7d09a5b7}},	//   _अस_, _dies_, лоди, dies,
   {{0x2d808029,0xd5ba9324,0x3f598580,0x394d821e}},	//   ņiem_, еси_, _dèu_, _eies_,
   {{0x7d09a5b8,0xc693025f,0x69c705f3,0xd13281a8}},	//   fies, צאה_, _grje, _همس_,
   {{0x2904a5b9,0xfc3f05e4,0x7d09a5ba,0x62838114}},	//   _umma_, _raíz_, gies, _adno,
   {{0x4e968307,0x2729862f,0xd2508013,0x12e68071}},	//   _مشار, gúns_, ينة_, гінг,
   {{0x7cf804c3,0x61e8816d,0xe8df801c,0x61360019}},	//   _fírg, tydl, _viễn_, vála,
   {{0x7d09a5bb,0x39152457,0x6eef83ba,0x28f925bc}},	//   bies, имор, _møbl, вень_,
   {{0x2d9102a0,0x8c3d802e,0x3ebe80e8,0x7d09a5bd}},	//   vuze_, teşt, _hatt_, cies,
   {{0x8cbf0063,0xead48678,0x3ebea5be,0xf8bf25bf}},	//   _लोगो, _воль, _katt_, rdé_,
   {{0x8c3d802e,0x43839ddd,0x613600f7,0xef1f07c0}},	//   reşt, _الوق, rála, mrük_,
   {{0x613625c0,0x8c3d802e,0x6d5802be,0x4a5b83c8}},	//   máln, seşt, _éval, _אדוו,
   {{0x69c700f1,0x628a0511,0xdb1981ec,0xa99b81c6}},	//   _rrje, ófon, _erwä, _נבחר,
   {{0xe8df8104,0x3a750087,0x1bd40081,0xa3e48075}},	// [14f0] _hiện_, илар, ботя, नहि_,
   {{0x6136037d,0xe8df8028,0x7d0986d7,0x3ebe8b64}},	//   náln, _kiện_, zies, _natt_,
   {{0x38600125,0xc3338051,0xa2c9016f,0x28c6904f}},	//   _yfir_, צוע_, _होण्, _रोहि,
   {{0x290b04ef,0x7cf58019,0x80d80beb,0x2fc901b0}},	//   nica_, _márc, याये, _krag_,
   {{0x394d837f,0xdb0f05e4,0x7d09a5c1,0x613603b0}},	//   _vies_, _escá, vies, káln,
   {{0x236902ee,0x7d09a5c2,0x2cbd81de,0xb4db0229}},	//   mpaj_, wies, _sawd_, _bhàg,
   {{0x7d09a5c3,0x1dc58697,0x45199bba,0x6d4f10e1}},	//   ties, विधत, кция_, _kica,
   {{0x2bc912ee,0xa2c9016f,0x6d570079,0x7cf81520}},	//   रिपा, _होत्, _muxa, _vírg,
   {{0x6e959ad0,0x3ebe81b9,0x3ced9b3b,0x2fc901c0}},	//   _визу, _fatt_, rkev_, _nrag_,
   {{0x6d4f01c5,0x7d09a5c4,0x7cf5988b,0x4255824b}},	//   _lica, sies, _bárc, штит,
   {{0x290b1f65,0x7cf80065,0x6b8d08b3,0x7cf585e4}},	//   fica_, _híre, hrag, _cárc,
   {{0xe8df8028,0x61fa0006,0x6fdc80ab,0xe0461bc1}},	//   _diện_, _ütle, _মেয়ে, инни,
   {{0xf36792b2,0x08360678,0x61360c83,0x69dc8257}},	//   _стен, рхня, báln, ører,
   {{0xfc3f046d,0x7d0600ee,0x7cf801a8,0x2fc925c5}},	//   _abío_, _smks, _míre, _drag_,
   {{0x7ae38307,0x6d4f1258,0x649a25c6,0x2d9e00e7}},	//   _iont, _bica, ктар_, îte_,
   {{0x6b8d25c7,0xb4e3816f,0xa2cd816f,0x05550012}},	//   frag, _नको_, ताक्, стря,
   {{0x6d4f25c8,0xdbd98187,0x61360019,0x42561dc7}},	// [1500] _dica, _açúc, lálo, атет,
   {{0x8ccc8063,0x68e40406,0x6d57002a,0xff7b00be}},	//   _दोनो, _hoid, _fuxa, _שטימ,
   {{0x6d4f00a9,0x613614b5,0x442f8084,0x3ebea0db}},	//   _fica, nálo, _lyg_, _ratt_,
   {{0x7ae3a5c9,0xdbdc003e,0x3ead0024,0x3ebe83e5}},	//   _lont, lšíc, đete_, _satt_,
   {{0x3ebe822b,0xc7a3964f,0x3869a5ca,0x684a0196}},	//   _patt_, жичк, ñara_, būdž,
   {{0x7ae3a5cb,0x7cf80013,0x290b002e,0xdfcf80f7}},	//   _nont, _díre, zica_, بيه_,
   {{0x442f808e,0x6ef48a2a,0x7cf80174,0x6d4f09ae}},	//   _ayg_, _càba, _tírd, _yica,
   {{0x290b062f,0x7ae3861f,0x3ea0801b,0x628303f2}},	//   xica_, _aont, řit_, ónov,
   {{0x2bc91a46,0x6136003e,0x60c2a5cc,0x3ebe80e8}},	//   रिया, táln, mdom, _tatt_,
   {{0xdbdc026f,0x60c28110,0x395825cd,0x68e40219}},	//   jšíc, ldom, _kurs_, _aoid,
   {{0x60c089ab,0x613625ce,0x7ae3a5cf,0x7e7700b9}},	//   _kamm, ráln, _dont, _rexp,
   {{0xb35689d7,0x03a68767,0x68e404c3,0x60c0a5d0}},	//   _پیدا_, _видо, _coid, _jamm,
   {{0x6d4f1155,0xe8010a43,0x7cf10b40,0x68e40187}},	//   _rica, _लेखा_, _dårl, _doid,
   {{0xe8df8028,0x6d4f25d1,0x6b8d25d2,0x6d57241f}},	//   _tiện_, _sica, vrag, _puxa,
   {{0xe5c40af2,0x5bb68ebf,0x13b699e8,0xab5b25d3}},	//   осто, _अनुव, _अनुभ, _trük,
   {{0x2fc68025,0x60c0a5d4,0x987515d1,0xb4c10074}},	//   kvog_, _namm, _улиц, ंये_,
   {{0x56950323,0xa2cb8072,0x7cf58061,0xdd2f128a}},	// [1510] _лапт, _थोड्, _jára, _těžb,
   {{0x6b8d25d5,0x60c08df6,0xf9c71fb4,0x6d4f25d6}},	//   rrag, _aamm, ищен, _wica,
   {{0x395825d7,0x6d4f25d8,0x60c08c2e,0xb4db25d9}},	//   _curs_, _tica, _bamm, _diàr,
   {{0x6b82803a,0x60c2904a,0x60c0a5da,0x395825db}},	//   _ovog, gdom, _camm, _durs_,
   {{0x7d0d009a,0x7cf58a21,0x23668282,0x60c0888b}},	//   mias, _nára, _ntoj_, _damm,
   {{0xaf0480e8,0x395825dc,0x442fa5dd,0x60c28035}},	//   опіл, _furs_, _ryg_, adom,
   {{0x7ae3a5de,0x6b8281df,0x29090009,0x645a0087}},	//   _ront, _avog, _omaa_, _ştii,
   {{0x7d0d0048,0x61360061,0x201e0087,0xeb998991}},	//   nias, gáll, ştii_, гии_,
   {{0x7ae3a5df,0x69ca831d,0xb4db0706,0x57f583a7}},	//   _pont, _arfe, _ghàe, _упат,
   {{0x81e280c8,0x7d0d25e0,0x61360510,0x6b828289}},	//   _নেই_, hias, tálo, _dvog,
   {{0x68e425e1,0x7e7c007b,0x7ae3a5e2,0x60c0a5e3}},	//   _poid, varp, _vont, _yamm,
   {{0x5f0503bb,0x7ae38288,0x26d301df,0x673e00f1}},	//   होस्_, _wont, _anxo_, _shpj,
   {{0x68e40009,0x7e7c25e4,0x6b65946c,0x69ca874c}},	//   _void, tarp, _укла, _erfe,
   {{0x7afaa5e5,0x60c2a5e6,0x61fb09ab,0x613d25e7}},	//   chtt, zdom, _ƙull, véle,
   {{0xf8bf040e,0x99858624,0xa2db25e8,0x61462118}},	//   glés_, _البو, नान्, _лека,
   {{0x6ab78a74,0x3d08016f,0x2b59002a,0x7e7c039c}},	//   _असुर, _सगळे_, _busc_, sarp,
   {{0x6d4425e9,0x60c08e51,0x7cfc8065,0xdbdc026f}},	// [1520] rmia, _ramm, _férf, pšíc,
   {{0x60c08f06,0x3f820052,0x6d4425ea,0x212d8077}},	//   _samm, msku_, smia, _akeh_,
   {{0x7cf807a3,0x7d0d25eb,0xc879880a,0x394001c0}},	//   _círc, bias, _beş_, _khis_,
   {{0x60c29c33,0x03a61630,0x27328087,0x2bbc82f1}},	//   udom, _лимо, mâni_, ्टमा,
   {{0x3f8225ec,0x44240028,0x81e600ab,0xbbb6824c}},	//   nsku_, _âm_, _বেশ_, _अनेक,
   {{0xb8ef901b,0x63a425ed,0x3ce0011a,0xe3e88019}},	//   _वो_, mtin, ljiv_, یکشن_,
   {{0x7bcba5ee,0xa3c2000c,0x6b82a5ef,0x60c088e5}},	//   _argu, ्मक_, _svog, _tamm,
   {{0xdb1d016d,0x18a38468,0x3ce0011f,0x26c30267}},	//   _ersä, _насм, njiv_, zdjo_,
   {{0x3f820025,0x241881bb,0xda7a9ebd,0xe73a8073}},	//   jsku_, ропы_, лян_, _беа_,
   {{0x3f82005c,0x4ace0327,0x3f5d00ff,0x27f98074}},	//   dsku_, _होमव, _rìu_, _üsna_,
   {{0x63a425f0,0xd2508c48,0x7bcba5f1,0x68fd03ed}},	//   htin, بند_, _ergu, ërdo,
   {{0x3a370051,0x63a425f2,0x6b828042,0x463b80be}},	//   מרים_, ktin, _tvog, _געבע,
   {{0x6d5aa5f3,0x7bcb811f,0x3946a216,0xc1a50778}},	//   _huta, _grgu, imos_, _गङ्ग,
   {{0x6d5aa5f4,0x61360019,0xdb1d0187,0x28cfa539}},	//   _kuta, nálj, _essê, _सोनि,
   {{0xc27b893f,0x6d5a8304,0x3ce6822c,0x2b59026c}},	//   _גרוי, _juta, _koov_, _susc_,
   {{0x6d5aa5f5,0x26c1018e,0xdb060019,0xa4f102d0}},	//   _muta, _waho_, _eskü, _dışı_,
   {{0x28d61a3b,0x63a425f6,0x3ce6a5f7,0x26c125f8}},	// [1530] धारि, gtin, _moov_, _taho_,
   {{0x629aa5f9,0x7d0d25fa,0xda670013,0x39468876}},	//   ngto, sias, صائي, emos_,
   {{0x7cfc8117,0xb9b50872,0x6d5aa5fb,0x9962026f}},	//   _kérd, تماع, _nuta, _píše_,
   {{0x3835a5fc,0x212b25fd,0xd011803f,0xb4db0362}},	//   онер, noch_, ولا_, _dhàc,
   {{0x6d5aa5fe,0x656880f1,0x63a425ff,0x7d1d01ed}},	//   _auta, _atdh, ctin, _ijss,
   {{0x6d5aa600,0x39838214,0x7cf58333,0x212b2601}},	//   _buta, yıs_, _cárn, hoch_,
   {{0x78ad0025,0x6d5a80a4,0x2d832602,0x212b01ac}},	//   _obav, _cuta, nsje_, koch_,
   {{0x3f8201b4,0x6d5a8314,0x2d8301ed,0x212b01d6}},	//   ysku_, _duta, isje_, joch_,
   {{0x212b2603,0xeab99d7b,0x290fa604,0x7529a605}},	//   doch_, айп_, miga_, roez,
   {{0x290f9f6a,0xf6f5817e,0xdb1d016d,0x78ad1ea2}},	//   liga_, _بزرگ, _ursä, _abav,
   {{0xd9462606,0x6d5aa607,0xf7488013,0x7ae70669}},	//   жени, _guta, _اللي_, _mojt,
   {{0x63a42608,0x3f82003a,0x290fa609,0xa4f7803d}},	//   ytin, tsku_, niga_, _دکتر_,
   {{0x3f8403cb,0xe73a0991,0x7cf58019,0xbbeb803f}},	//   ému_, ием_, _háro, _حرام_,
   {{0x7f5b82a3,0x3f82260a,0x290fa60b,0x7cf58019}},	//   _muuq, rsku_, higa_, _káro,
   {{0x3940073a,0xdd920277,0x7bc9a60c,0x290fa60d}},	//   _this_, ظور_, lveu, kiga_,
   {{0x63a4260e,0x3f820067,0x4c6a0b87,0x212b260f}},	//   ttin, psku_, риан_, coch_,
   {{0x290fa610,0x63a42611,0x6ef00074,0x130a0110}},	// [1540] diga_, utin, _läbi, анай_,
   {{0x63a42612,0x2d91009a,0xdcfc00eb,0x78ad2613}},	//   rtin, brze_, turē, _zbav,
   {{0x7cf5803e,0x5bb6800d,0x60c42614,0xfce614d6}},	//   _náro, _अन्व, _kaim, _доно,
   {{0x6d5aa615,0x63bb8870,0x63a42616,0xeb9a0c9d}},	//   _ruta, kwun, ptin, _ким_,
   {{0x3946a617,0x60c42618,0x6d5aa619,0xdb0406a8}},	//   rmos_, _maim, _suta, ntië,
   {{0x39469313,0x6d5aa61a,0x2480261b,0x60c4261c}},	//   smos_, _puta, laim_, _laim,
   {{0x2d98261d,0x290fa61e,0x6b84261f,0x7cfc83a8}},	//   nure_, biga_, lsig, _lére,
   {{0x443d82af,0x3eb801ec,0x6d5ca620,0x290fa621}},	//   _bzw_, hert_, _éram, ciga_,
   {{0x3eb82622,0x6b842623,0xa686838d,0x14a68d72}},	//   kert_, nsig, _млад, क्षण,
   {{0x6d5aa624,0x61360019,0x2d982625,0x212b01ec}},	//   _tuta, lálh, kure_, woch_,
   {{0xa2db1a3b,0xd62a8009,0x7cfca626,0x3eb82627}},	//   नात्, _тоже_, _pérd, dert_,
   {{0x60c4051e,0x613d007b,0x61360019,0x69c88106}},	//   _caim, féla, nálh, rvde,
   {{0xd83b01e5,0x60c42628,0x6b840042,0x7cf585b9}},	//   рэн_, _daim, jsig, _záro,
   {{0x6b842629,0x290f8f8e,0x2d83090d,0x3eb801e3}},	//   dsig, ziga_, tsje_, gert_,
   {{0x290f8ec8,0x6d42801c,0x7ae7262a,0x2d98262b}},	//   yiga_, _khoa, _rojt, gure_,
   {{0x24f80fe6,0x245802c7,0x7aea80eb,0x290fa62c}},	//   онсы_, жать_, žotā, xiga_,
   {{0x20020063,0x7cfc80e7,0x69de262d,0x290fa62e}},	// [1550] czki_, _gére, expe, viga_,
   {{0x3eb807f1,0xdb040036,0x2d980a03,0x28ac06a7}},	//   cert_, ntiè, bure_, ट्ठि,
   {{0x7ae7262f,0x80b000c8,0x6b8418dc,0x6d352630}},	//   _vojt, য়ার্, asig, _неоф,
   {{0x52b7a631,0x02b783ca,0x6b840079,0x7cf8002a}},	//   _अस्स, _अस्न, bsig, _tíra,
   {{0x290fa632,0x3f992633,0x69ce2634,0x6b840079}},	//   riga_, nusu_, _erbe, csig,
   {{0x290fa635,0x6d429fa4,0x7cf5a636,0xed5986c8}},	//   siga_, _ahoa, _páro, бок_,
   {{0x3f9900f6,0x290f822e,0x2bc90f97,0x6d428362}},	//   husu_, piga_, रिवा, _bhoa,
   {{0x7cf58065,0xd5ae80f7,0x6136016b,0x7bcf01a1}},	//   _váro, افي_, rálk, _krcu,
   {{0x2d982637,0x2d98816d,0x3ec48009,0x48fa80be}},	//   zure_, _åren_, östä_, _פּלא,
   {{0x61360ede,0x60c42638,0x7bc980e7,0x613d2639}},	//   máli, _saim, rveu, véla,
   {{0x3eb8263a,0x7c2280ee,0x60c4263b,0x7bc9826c}},	//   vert_, _exor, _paim, sveu,
   {{0x3ea1263c,0x3eb802af,0x7cfc91b9,0x6b84263d}},	//   _acht_, wert_, _pére, ysig,
   {{0x26c5835a,0xe28ea63e,0x68e99989,0x3eb8263f}},	//   _kalo_, _па_, _moed, tert_,
   {{0xb8f305e8,0x2d982640,0x26c58a6e,0x60c42641}},	//   _हो_, ture_, _jalo_, _waim,
   {{0x26c58b5d,0x6281a642,0x60c42643,0x57b8809a}},	//   _malo_, malo, _taim, _इन्ह,
   {{0x3ea12644,0xab66076a,0x7d1ba645,0x3eb8035f}},	//   _echt_, звал, nnus, sert_,
   {{0x7cfc8c52,0x24800c5e,0x2d9822c5,0x6d498c41}},	// [1560] _hérc, raim_, sure_, imea,
   {{0x2d980098,0x6b842646,0x26c5a647,0x6d4981a8}},	//   pure_, rsig, _nalo_, hmea,
   {{0x68fba648,0x68e9831e,0x14bd824c,0xdb040144}},	//   _blud, _boed, ्याण, ntié,
   {{0x7cfc862f,0x7cf58019,0x7e7e2649,0x00e68009}},	//   _mérc, _bárm, _hepp, яжен,
   {{0x7e7e007b,0x26c5a64a,0x68e281b9,0x68e98114}},	//   _kepp, _balo_, rjod, _doed,
   {{0x6d5e264b,0x62818503,0x6daa8201,0xf1db89c2}},	//   _kupa, jalo, _fəal, यमान,
   {{0x4343264c,0x6281a64d,0xbb43264e,0x69da00e1}},	//   _черв, dalo, _черк, _štef,
   {{0x68e9a64f,0x7e7e2650,0x7cf59984,0x7d1ba651}},	//   _goed, _lepp, _fárm, gnus,
   {{0x6d5e2652,0x26c5a653,0x613612ca,0x38668118}},	//   _lupa, _falo_, cáli, mcor_,
   {{0x6281a654,0xe3af8624,0x26c5a655,0x6d42a656}},	//   galo, اري_, _galo_, _whoa,
   {{0xd48fa657,0x386d0876,0x672e0353,0x3f86a363}},	//   _пр_, ñero_, dobj, lsou_,
   {{0x64a68048,0x26c593e0,0x3f992658,0xdca6a659}},	//   _хада, _zalo_, tusu_, _хади,
   {{0x6d5e265a,0xddc8826c,0x7e7e01e8,0x3f86a41f}},	//   _aupa, _jedž, _bepp, nsou_,
   {{0xb4db265b,0xddc881e2,0x628a813c,0x6d5e0e60}},	//   _chàn, _medž, _udfo, _bupa,
   {{0x28dd0663,0xa2a1816f,0x3f99265c,0x7e7e1ff5}},	//   यादि, _खात्, susu_, _depp,
   {{0x2eb9823c,0x645a0087,0x291ca65d,0x5d542255}},	//   _इस्त, _ştir, éval_, екст,
   {{0x68e98355,0x201e07d9,0xddc888ae,0x3f86801b}},	// [1570] _roed, ştir_, _nedž, jsou_,
   {{0x68fb80eb,0x7cf80019,0x79850234,0x7bcd8084}},	//   _slud, _hírl, tshw, _šauk,
   {{0x68fba65e,0xaaae8bc2,0x68e9a65f,0xf1c201a9}},	//   _plud, ज्यक, _poed, jušā_,
   {{0x26c580a4,0xf9900bbe,0x61362660,0x7e7e2661}},	//   _salo_, ابل_, táli, _zepp,
   {{0x2b9319f4,0x68e985f8,0x7e7e04e6,0x37ab938c}},	//   _سیاس, _voed, _yepp, стен_,
   {{0xe8da00a5,0x2bb68105,0xddc88267,0x68e98cfa}},	//   _बच्च, _अनजा, _dedž, _woed,
   {{0x68e9a26f,0x7cf80144,0x7bc28176,0x27328162}},	//   _toed, _oírl, _asou, vânt_,
   {{0xddc8826c,0xed568098,0x69da0088,0x68fb82d0}},	//   _fedž, мощ_, _šteg, _ulud,
   {{0x6d4984bc,0x26c5a662,0xa2a18aed,0xddc8a663}},	//   rmea, _talo_, _खाद्, _gedž,
   {{0xff5380f7,0x38692664,0x3cff8901,0x6d49a12b}},	//   _أخر_, _afar_, shuv_, smea,
   {{0x387f800b,0x7bc2a665,0x7aeaa666,0x7cee851e}},	//   _keur_, _esou, _doft, _cùrs,
   {{0x6281a667,0x6d5e2668,0xc689007c,0xdb040020}},	//   salo, _rupa, _כא_, rtié,
   {{0x6d5e2669,0x387fa66a,0xfaa59612,0x69dc8338}},	//   _supa, _meur_, _жало, ärer,
   {{0x387f83d3,0x3cfd81c0,0x2bbc801b,0x6ef48362}},	//   _leur_, _hlwv_, ्टरा, _càbh,
   {{0x63a9a66b,0x64a6266c,0x7cfca639,0xe7371505}},	//   lten, мава, _héra, фер_,
   {{0x249f8125,0x2056266d,0x7cf8266e,0x6eef8366}},	//   ngum_, _отпр, _víro, _købs,
   {{0xb4db0142,0xe8df8104,0xb4be009a,0x7e7e266f}},	// [1580] _thàn, _chọn_, _इसी_, _tepp,
   {{0x6138a670,0xb0c68aad,0x2d878aa2,0x63a9a671}},	//   míli, _रोजग, ksne_, iten,
   {{0xddd882a5,0x63a9a672,0x80a5103e,0x2d878c18}},	//   kavš, hten, _कामे, jsne_,
   {{0x7cf5801b,0x63a9a673,0x69c381a1,0x0cd88264}},	//   _dárk, kten, _msne, _তত্ত,
   {{0x387fa674,0xddd882a5,0x6ef48722,0x3866a675}},	//   _deur_, davš, _hàbi, rcor_,
   {{0x386687d0,0x6136007b,0xbd6a94ed,0x6b9ba676}},	//   scor_, málu, орие_, duug,
   {{0x63a9802e,0x94188201,0xf9878117,0xceb30039}},	//   eten, ərə_, _جب_, דיו_,
   {{0x7aea96f7,0x387fa677,0x67211809,0x2ca02678}},	//   _soft, _geur_, člji, ngid_,
   {{0x63a9a679,0x7aea8087,0x7cfc8036,0x290201b4}},	//   gten, _poft, _céra, dhka_,
   {{0x7aea80f1,0x78a403a8,0x69c80118,0x7cfc8036}},	//   _qoft, _aciv, _ádes, _déra,
   {{0xb4db0362,0x611c82d4,0x612802d0,0xdee38081}},	//   _bhàl, včlj, kıld, _шофи,
   {{0x61e3016d,0x63a9a67a,0xb4db0362,0x6cd3a0bb}},	//   änli, bten, _chàl, _لقما,
   {{0x628e267b,0x69c3a67c,0x63a9a67d,0x7cfc902d}},	//   _odbo, _esne, cten, _géra,
   {{0xaff980be,0x4426a67e,0xa3d2175d,0x2fd2267f}},	//   פּרי, _ixo_, विन_, _dryg_,
   {{0x6d46008e,0x9e341bcc,0xe93b07c3,0xb4db0362}},	//   _bhka, верч, _وسعت_, _fhàl,
   {{0x3ea98668,0x2b582680,0x628e0114,0x26da06c4}},	//   đati_, _airc_, _adbo, _enpo_,
   {{0x613896dc,0x7cfc8118,0x2b5800c3,0xa87c01c6}},	// [1590] cíli, _xéra, _birc_, _ואחר,
   {{0x2d8506a5,0x7bcd156e,0x28dd1869,0x31670118}},	//   áles_, rvau, यावि, ínzo_,
   {{0x63a99124,0x387f80e7,0x2d9ca681,0x68ed011b}},	//   zten, _peur_, juve_, _koad,
   {{0x78bd2682,0x63a9a445,0xf77180a0,0x09b100ab}},	//   nesv, yten, هات_, ছিলা,
   {{0x6d4d2683,0x2b580118,0x645d0420,0x68ed033e}},	//   mmaa, _firc_, _igsi, _moad,
   {{0xd246a684,0x6d4d2685,0x68ed2686,0x61360019}},	//   _من_, lmaa, _load, lált,
   {{0x62852687,0x6138a688,0xddd8811f,0x442682df}},	//   maho, zíli, tavš, _axo_,
   {{0xd658004c,0x62852689,0x6d4d06d9,0x61360019}},	//   ויות_, laho, nmaa, nált,
   {{0x3834a68a,0x60dba68b,0x7522826c,0x249f9ab2}},	//   _антр, _inum, _djoz, rgum_,
   {{0x6285049f,0xe3c88028,0x7cf5a68c,0x6442826c}},	//   naho, _dự_, _mári, _dzoi,
   {{0x4439268d,0xc332010f,0x442690e4,0x7cf581a8}},	//   _lys_, רוי_, _exo_, _lári,
   {{0xcea9004c,0xb4be101c,0x7cfca68e,0x68ed040d}},	//   _לי_, _इसे_, _hérn, _coad,
   {{0xb8e80063,0x68ed1d3a,0x6285268f,0x6d59820d}},	//   _उस_, _doad, kaho, _iiwa,
   {{0x6d46020f,0x6561a690,0x29022691,0x6d59a692}},	//   _shka, _kulh, shka_, _hiwa,
   {{0x65618073,0x6d59a693,0x6138a694,0x386b00f7}},	//   _julh, _kiwa, síli, éirí_,
   {{0x656180a9,0x6d4d2695,0x6b962696,0x6d598458}},	//   _mulh, gmaa, tryg, _jiwa,
   {{0x44260003,0x7cf5a697,0x6128080a,0xf1c9801c}},	// [15a0] ço_, _cári, rıld, _hạ_,
   {{0x60dba698,0x28ac0023,0x6d599110,0xa8570039}},	//   _anum, ट्रि, _liwa, _איפה_,
   {{0x753b826f,0x29002699,0x5ec880ab,0x61280457}},	//   kluz, _klia_, লামে, pıld,
   {{0x6d59a69a,0x6d4d0079,0x60c9816a,0x6d460198}},	//   _niwa, cmaa, _caem, _uhka,
   {{0xf1c9801c,0xe73a9505,0x6285269b,0x087700be}},	//   _lạ_, пед_, baho, גענט_,
   {{0x8f9b00be,0xe5c6a13d,0x6d5984b9,0xe8020d86}},	//   פיצי, есио, _aiwa, रैया_,
   {{0xe3c88104,0xaa430adb,0x2bd28f12,0x6d5998a8}},	//   _sự_, _берл, तिभा, _biwa,
   {{0x2d9815a0,0x6d59a69c,0x60c9808e,0xed5784ae}},	//   irre_, _ciwa, _gaem, ној_,
   {{0x53c904e5,0xd90d8416,0x6b898073,0xe8b5817b}},	//   रिएश, _بین_, gseg, lışı,
   {{0x68ed002a,0xf1c980ff,0x291203f7,0x23d283ca}},	//   _soad, _bạ_, _amya_, तिबद,
   {{0xf8dd10be,0xe8b588c5,0x7d040234,0x13170039}},	//   यालय, nışı, khis, תחיל_,
   {{0xe3c88104,0x78a2827f,0x7d04269d,0x6b89a69e}},	//   _tự_, ngov, jhis, bseg,
   {{0x66f48076,0x04578013,0x7d04269f,0x628526a0}},	//   _अवाक_, _كلمة_, dhis, yaho,
   {{0x3ea50019,0x44391c59,0x6d599f62,0x1ee7003d}},	//   ült_, _rys_, _ziwa, روزی_,
   {{0x7bc600f1,0x6d4d26a1,0x645d0122,0x29000144}},	//   _asku, tmaa, _pgsi, _flia_,
   {{0x7d0426a2,0xf98f9c12,0x23b79094,0x9a3b8039}},	//   ghis, _ابو_, _अहमद, _מתוק,
   {{0x6d4d26a3,0x61361ddd,0x60c9808e,0x54550323}},	// [15b0] rmaa, rált, _raem, тват,
   {{0x2d8ca6a4,0x6d4d26a5,0x7cf58073,0x60c9a6a6}},	//   _ovde_, smaa, _vári, _saem,
   {{0x7bc600ad,0x3949059c,0x4439079f,0x7d0426a7}},	//   _esku, _khas_, _wys_, bhis,
   {{0x7d0426a8,0x628526a9,0x4439009a,0x38c98019}},	//   chis, saho, _tys_, بائی_,
   {{0x6d5987ba,0x6561a6aa,0x2d8c826c,0x7cfc80e7}},	//   _riwa, _sulh, _avde_, _aéro,
   {{0x63ad04a7,0x6d59a6ab,0xa3c006b7,0x7cfc810c}},	//   mtan, _siwa, ूटर_, _béro,
   {{0x50b111bc,0x60c9a6ac,0x6916016b,0x656180ee}},	//   जभाष, _taem, dšen, _qulh,
   {{0x925826ad,0x7cfca6ae,0x69c726af,0x6b89a6b0}},	//   _част_, _déro, _isje, tseg,
   {{0x6d598010,0x3f8b009a,0x2d8c82d0,0xd46881a8}},	//   _viwa, jscu_, _evde_, رحيم_,
   {{0x466ba6b1,0xdb0081fa,0x6d59a6b2,0xa3d2090f}},	//   _храм_, ttmá, _wiwa, वित_,
   {{0x6b89a6b3,0x290026b4,0x63ad26b5,0x394926b6}},	//   sseg, _plia_, htan, _bhas_,
   {{0x69d51024,0xdb00826f,0x394926b7,0xdddc0088}},	//   _mrze, rtmá, _chas_, jarš,
   {{0x63ad26b8,0xaca301bc,0xc95280be,0x7529017f}},	//   jtan, _chọb, ימט_, čezl,
   {{0x69c7030b,0x78a2803a,0x2cbfa6b9,0x69d50035}},	//   _osje, zgov, leud_, _orze,
   {{0x7d0426a7,0x2d8c26ba,0x386da6bb,0x28aa06ab}},	//   this, éde_, _ofer_, _कापि,
   {{0x2cbf831d,0x6283976f,0x7aee023e,0xbddc0032}},	//   neud_, _heno, _sobt, _aṣòf,
   {{0x63ad26bc,0xa3d2024c,0x628389c4,0x7aee022c}},	// [15c0] gtan, विध_, _keno, _pobt,
   {{0x7d0426bd,0x13032063,0x6283a6be,0x386da6bf}},	//   shis, азум, _jeno, _afer_,
   {{0x62839a59,0x7d0426c0,0x63ad26c1,0x7cf808f1}},	//   _meno, phis, atan, _líri,
   {{0x63ad26c2,0xe8b5817b,0x69d50035,0x6f0190ba}},	//   btan, rışı, _drze, _allc,
   {{0x10a39593,0x7bc626c3,0x98a38a0e,0x69d526c4}},	//   ричн, _usku, риче, _erze,
   {{0x6283a6c5,0xa3d58c87,0x47338221,0x7cfca6c6}},	//   _neno, हिन_, аніс, _péro,
   {{0x91e3249a,0x78b6026f,0xe29700a9,0x27e0802e}},	//   _коре, _obyv, _јас_, ţin_,
   {{0x7cfca538,0x80ca8bb8,0x3f4f0197,0xaae001d0}},	//   _véro, _सोचे, _jżur_, नावक,
   {{0x62838c77,0xfd0f8077,0x9eaa80a9,0xf8bf00e7}},	//   _beno, تجو_, _оваа_, nnée_,
   {{0x80a50006,0x386026c7,0x7cf801a8,0xe6c581a8}},	//   _काहे, _agir_, _díri, _متمي,
   {{0x69240052,0x26dea6c8,0xe8169094,0x63ad0102}},	//   rđen, _into_, _देता_, ztan,
   {{0x63ad127a,0xd90f026a,0x2906a6c9,0x26cca6ca}},	//   ytan, تیب_, nhoa_, _hado_,
   {{0x26cca6cb,0x691626cc,0x7d02a6cd,0xd83801e5}},	//   _kado_, pšen, _ilos, вэр_,
   {{0x6283a6ce,0xd7f8176e,0xb8fa26cf,0x8c438991}},	//   _geno, тую_, _डो_, _тече,
   {{0x6288a6d0,0x26cca6d1,0xdddc026f,0x8233815b}},	//   mado, _mado_, tarš, _پروا,
   {{0x26cc8510,0x692426d2,0xd498237e,0xf8bf0118}},	//   _lado_, nđel, кру_, roés_,
   {{0x291926d3,0x63ad26d4,0x63a089ca,0xf8bf00e7}},	// [15d0] misa_, utan, numn, gnée_,
   {{0x69d50610,0x6288a6d5,0x291926d6,0x63ad26d7}},	//   _prze, nado, lisa_, rtan,
   {{0x7d02a6d8,0xc8aa0076,0x7cf5a6d9,0xf8aa0105}},	//   _olos, _कामट, _záru, _कामय,
   {{0x29190418,0x63ad26da,0x63a0a6db,0x60cd26dc}},	//   nisa_, ptan, kumn, _jaam,
   {{0x60cd26dd,0xb8cb91bc,0x26cc822e,0x7cf596a5}},	//   _maam, _खा_, _bado_, _márt,
   {{0x6288a6de,0x69d50063,0xa3d69a3b,0x248926df}},	//   jado, _trze, ाटन_, laam_,
   {{0x26cc90dd,0x291926e0,0x7cf826e1,0x69c705f3}},	//   _dado_, kisa_, _síri, _usje,
   {{0x23ab813c,0x7d028051,0x2906a6e2,0x248903b2}},	//   tøj_, _clos, choa_, naam_,
   {{0x6b8d0003,0x6283a08d,0x291926e3,0x7cfca6e4}},	//   nsag, _peno, disa_, _kérj,
   {{0x6d5d0665,0x61280059,0x26cca6e5,0xa3ab00c2}},	//   _lisa, dıla, _gado_, _गमन_,
   {{0x60cd26e6,0x628380e1,0x29192486,0x0596804e}},	//   _baam, _veno, fisa_, _مانگ,
   {{0x6d5d0668,0x7cf580f7,0x29190365,0xc19a03de}},	//   _nisa, _cárt, gisa_, עשרי,
   {{0x3ce08076,0x776404c3,0xb4db0046,0xe8f72462}},	//   कारे_, _quix, _ghài, уля_,
   {{0x6288a6e7,0xe5a60d9e,0x6d5d0091,0x7d02805c}},	//   cado, лиги, _aisa, _zlos,
   {{0x6d5d1341,0x291911b7,0x60cd26e8,0x78a980d2}},	//   _bisa, bisa_, _faam, _ocev,
   {{0x29191092,0x6d5d26e9,0x6565010c,0x6f188bcf}},	//   cisa_, _cisa, _duhh, zivc,
   {{0x612805c5,0x03261957,0x6d5d19ad,0x93aa045b}},	// [15e0] cıla, гдан, _disa, عارف_,
   {{0xf8bf02be,0x78a98333,0x656526ea,0x3cda86a7}},	//   rnée_, _acev, _fuhh, _खोने_,
   {{0x6d5d26eb,0x2d950249,0x60cd019e,0xaaa6864a}},	//   _fisa, _кряс, _yaam, _खासक,
   {{0x613d0acf,0x6d5d26ec,0xbfaa8284,0x7cfc8118}},	//   téli, _gisa, етке_, _pérm,
   {{0x6f188052,0x6288a6ed,0xb4c026ee,0x752426ef}},	//   tivc, yado, ंजी_, mniz,
   {{0xa3c101fe,0x6288a6f0,0x29190c6a,0x918607c3}},	//   ंबर_, xado, zisa_, _مجرم,
   {{0xe1e7a6f1,0x612802bb,0x7d03002e,0x6d4b826c}},	//   _اس_, zıla, _însc, _bhga,
   {{0x7cfc9fd1,0x6288a6f2,0x80d408fd,0xb88704c3}},	//   _térm, wado, _बोले, _muíñ,
   {{0x62888510,0x2904883f,0x60cd09f8,0x2919155f}},	//   tado, _ilma_, _raam, visa_,
   {{0x248900f3,0xc87987c0,0x443d8428,0x291926f3}},	//   zaam_, _inşa_, _dyw_, wisa_,
   {{0x63a0811f,0x291926f4,0x69160110,0x2258a6f5}},	//   sumn, tisa_, pšel, ärk_,
   {{0x612803bf,0x6b8d26f6,0x6b9ba6f7,0x60cd057b}},	//   tıla, ysag, brug, _qaam,
   {{0x628883f8,0x291926f8,0x60cd26f9,0x68fd26fa}},	//   pado, risa_, _vaam, rksd,
   {{0x61280182,0x6d5d0744,0x29190234,0x60cd26fb}},	//   rıla, _sisa, sisa_, _waam,
   {{0x60cd26fc,0xbcfb00e7,0xb887002a,0x69da26fd}},	//   _taam, _liée, _cuíñ, _šten,
   {{0x612807d9,0x69ca81b9,0x2fc901c0,0x6b8d26fe}},	//   pıla, _isfe, _tsag_, tsag,
   {{0x6d5d26ff,0x5b152700,0x6d4083ff,0x28aa2701}},	// [15f0] _visa, амат, ilma, _काति,
   {{0x6d5d0854,0xa3d58519,0x2bb78105,0x6b8d2702}},	//   _wisa, हित_, _अहसा, rsag,
   {{0x6b8d114e,0x6d5d2703,0x26c32704,0x06cd80ab}},	//   ssag, _tisa, mejo_, লামি,
   {{0x26c32705,0x60c28358,0xc91380ab,0xe8168c28}},	//   lejo_, geom, িক্ত_, _देहा_,
   {{0xdb042706,0xa2d0016f,0xafe5a707,0x21290299}},	//   stiá, _डोक्, ролл, _mjah_,
   {{0x26c32708,0xa3d206b7,0x26d1026c,0x6b4b02af}},	//   nejo_, विर_, ndzo_, füge,
   {{0x6ead000d,0xba740065,0x5a440a8e,0x6b828242}},	//   _जानु, _چاہت, _гэта, _awog,
   {{0x2d67811f,0x6b9ba709,0x2d9e1f3a,0x62950140}},	//   _uđem_, trug, šteg_, _hdzo,
   {{0x69d8a70a,0xf7708077,0x6287270b,0x28d91c7b}},	//   _arve, _فال_, _kejo, _बोधि,
   {{0x26c30db7,0x6b9ba70c,0x21290b99,0x98148a47}},	//   jejo_, rrug, _ajah_, _طبقا,
   {{0x6287270d,0x69d8803b,0x394d8282,0x26c3270e}},	//   _mejo, _crve, _khes_, dejo_,
   {{0x69d8803b,0x6b9b803a,0x69de81ac,0x6287270f}},	//   _drve, prug, _špec, _lejo,
   {{0x95548bca,0x21290267,0x290c0110,0x3cff81c0}},	//   _اخلا, _djah_, ėda_, mkuv_,
   {{0x7cf58065,0xe2999577,0x3ced9de3,0x6287001b}},	//   _társ, _рак_, ljev_, _nejo,
   {{0x2d988cd7,0x2cb90706,0x2d5182d4,0x21a58037}},	//   _året_, _bbsd_, _ušes_, _тийм,
   {{0x25ed8df4,0x88830081,0x94262710,0x7d09a711}},	//   _अपनी_, _длъж, амбе, nhes,
   {{0xf77207bd,0xed572712,0x26c32713,0x03a62714}},	// [1600] _باب_, рот_, bejo_, ризо,
   {{0x7d1ba715,0x7cf58511,0x752400b9,0x31679500}},	//   hius, _márq, sniz, _kunz_,
   {{0x7d1ba716,0x395f8359,0xa2a700c2,0x41aa0ae7}},	//   kius, _bius_, _चार्, твен_,
   {{0x613d2717,0x53a6217e,0x3cff81c0,0x6f1c0037}},	//   bélu, _камб, jkuv_, lirc,
   {{0x7d09a718,0x3ced85f3,0x395f823e,0x67d49f6e}},	//   dhes, djev_, _dius_, солу,
   {{0x98ab009a,0x62872719,0x63a4271a,0x7cfc8019}},	//   mocą_, _gejo, muin, _térk,
   {{0x63a4271b,0x7d1b8118,0xb23a00f7,0x4420802e}},	//   luin, fius, _شكرا_, _ţi_,
   {{0x6b828247,0x92a6009a,0x7d1b847f,0x395f8037}},	//   _pwog, _wyłą, gius, _gius_,
   {{0x6f1c271c,0x7cf5988b,0xdcef011f,0x6d40808b}},	//   kirc, _párr, žeće, rlma,
   {{0x7cfca71d,0x2d9c81d0,0x6f1c09ab,0x2fc99a1f}},	//   _méri, prve_, jirc, çage_,
   {{0x63a41581,0x7d1ba71e,0x3ced826c,0xf2d900be}},	//   huin, bius, bjev_, אַרל,
   {{0x7d09a71f,0x7d1ba720,0x63a42721,0xb4c503db}},	//   ches, cius, kuin, _एसे_,
   {{0x315780be,0x8c43a30e,0x7cf58144,0x6568a722}},	//   ייטן_, _деце, _tárr, _hudh,
   {{0x63a42723,0x65688303,0x31678037,0x46de2724}},	//   duin, _kudh, _funz_, मागह,
   {{0x26d10063,0x62872725,0x26c32726,0x518693bf}},	//   rdzo_, _rejo, rejo_, _тула,
   {{0x26c32727,0x6568a728,0x3f8f8114,0x7cfc9a90}},	//   sejo_, _mudh, ysgu_, _béri,
   {{0x63a4107f,0x2d5802c7,0x26c32729,0x62870088}},	// [1610] guin, рить_, pejo_, _pejo,
   {{0x883c0039,0x6e2d8214,0x67389351,0x7cfc80e7}},	//   _בתחו, şabi, jovj, _déri,
   {{0x75d50199,0xb4db051e,0x6738a72a,0x656888f9}},	//   _ايجا, _bhàt, dovj, _nudh,
   {{0x7cfca72b,0xa3d6873c,0xb12580ab,0xb4db0362}},	//   _féri, ाटा_, বত্ব_, _chàt,
   {{0x63a40087,0x395f823e,0xb0aa0035,0x3cff822c}},	//   cuin, _vius_, _कासग, vkuv_,
   {{0x6568a72c,0x67388639,0x16a9a349,0xa3d581ab}},	//   _budh, govj, увки_, हिस_,
   {{0x394da72d,0xa194272e,0xdcfb1a3b,0x21390168}},	//   _thes_, _марч, _एकाध_, kosh_,
   {{0x2ca9272f,0x28cf9513,0xd5d82730,0x51840cc1}},	//   ngad_, _सोचि, डितज, _фура,
   {{0x291d80f6,0x3ced8db7,0x7d1ba731,0x7d09a732}},	//   miwa_, rjev_, rius, rhes,
   {{0x291d80f6,0xddde0f20,0xfe708b76,0x7305943d}},	//   liwa_, _lepš, _قدم_, споз,
   {{0xdb0403a7,0x7d09a733,0x657701e9,0x6568a734}},	//   stiç, phes, _ntxh, _gudh,
   {{0x291d804f,0x213912ec,0x05090264,0x14ca9ab3}},	//   niwa_, gosh_, রচুর_, _مهمی_,
   {{0xeb99a306,0xdb0b806a,0xc50c80be,0x9fd60264}},	//   _сил_, _opgø, _בלאָ, সঙ্গ,
   {{0xa3c10935,0x65689d08,0x291da735,0x644ba736}},	//   ंबई_, _yudh, hiwa_, _izgi,
   {{0x7ae3a737,0x291d80f6,0x7cfca738,0x6b5004b8}},	//   _innt, kiwa_, _séri, lägg,
   {{0xb466044f,0x7cfca739,0x2ca9016d,0x291d8010}},	//   скал, _péri, ggad_, jiwa_,
   {{0x09b201fe,0x612805c5,0x68e41dde,0x291d8010}},	// [1620] ीब्य, nılm, _inid, diwa_,
   {{0x63a4125b,0x7cfc82be,0xb4db0229,0x2ca902c4}},	//   ruin, _véri, _bhàs, agad_,
   {{0x63a4273a,0x28dd016f,0x8db600e8,0x291d804f}},	//   suin, याचि, _успі, fiwa_,
   {{0x98a68cdf,0x612802d0,0x291da73b,0xb4db0a2a}},	//   сиде, kılm, giwa_, _dhàs,
   {{0x6568a73c,0x29020009,0x31b18019,0xc7a38992}},	//   _sudh, ikka_, ház_, зичк,
   {{0x61280085,0x6d44273d,0x4dbe80ab,0xa3bd00c2}},	//   dılm, llia, ্মসূ, _आहत_,
   {{0x38698052,0x6d44031d,0x6738a73e,0x291da73f}},	//   žara_, olia, rovj, biwa_,
   {{0x539894ed,0xbb748992,0x69ce01b4,0x7ae3851e}},	//   авия_, огиј, _isbe, _annt,
   {{0x2d8502ba,0x673882ce,0x656890e1,0x442f83a8}},	//   ález_, povj, _wudh, _cxg_,
   {{0x6d442362,0x78ad2740,0x68e42741,0x37be0264}},	//   hlia, _scav, _anid, ইটার,
   {{0xe3af9fbe,0xdd928077,0x6d440110,0x81b600ab}},	//   وری_, _روش_, klia, জিক_,
   {{0xd84304e8,0x00000000,0x00000000,0x00000000}},	//   _ničí_, --, --, --,
   {{0x2d910063,0xb0aa000f,0x28aa097d,0x6d440114}},	//   wsze_, _कारग, _कारि, dlia,
   {{0x291da742,0xa3d5a743,0x69dc2744,0x98be00eb}},	//   ziwa_, हिर_, _orre, ētā_,
   {{0x7af50e04,0x8cda016f,0x291da745,0x2d852746}},	//   _rozt, _पोहो, yiwa_, èle_,
   {{0x6d440698,0x2d912422,0x65628326,0x183a01bc}},	//   glia, rsze_, _jioh, ọmụm,
   {{0x290902a3,0x69dc2747,0x36d52748,0x7af50cc7}},	// [1630] _ilaa_, _arre, _допр, _pozt,
   {{0x32672134,0x2d91009a,0xaa672749,0x6d44274a}},	//   став, psze_, стак, alia,
   {{0x291d8010,0x612803bf,0x7d030162,0xdb098174}},	//   tiwa_, zılm, _înso, nteá,
   {{0xdb0980f7,0x6128080a,0x628a8061,0x6ca7274b}},	//   iteá, yılm, _lefo, _урож,
   {{0x69dc274c,0x629898a6,0x291da74d,0xcf9b84ae}},	//   _erre, _odvo, riwa_, ује_,
   {{0x7d0d0065,0x291da74e,0xab5b0019,0xe81c0074}},	//   lhas, siwa_, _csüt, _पइसा_,
   {{0x24e98698,0xace9a74f,0xceb404de,0x28aa0ebf}},	//   имки_, имка_, פיק_, _कालि,
   {{0x28d90b75,0x61280457,0x2fcd81e9,0x6abc01a1}},	//   _बोलि, tılm, _tseg_, _zbrf,
   {{0x628a9c93,0x68e42750,0xa49b0176,0x130985a5}},	//   _befo, _rnid, _alòk, иний_,
   {{0x61280182,0x69060118,0x4225a42e,0x68f60850}},	//   rılm, _cóen, ждов, _soyd,
   {{0x90c60364,0x7d0d2751,0x60c600eb,0x6d440114}},	//   обне, khas, tekm, ylia,
   {{0xf9920051,0x7bcf2752,0x612813da,0x69da2753}},	//   ורט_, _oscu, pılm, _štek,
   {{0x3c47803f,0x7529802e,0x6b500884,0x7d0d2754}},	//   _اضاف, mnez, läge, dhas,
   {{0x2bcf901c,0x26c78010,0xa3d689f2,0x628a8dfb}},	//   _तैया, neno_, ाटर_, _gefo,
   {{0x6281a755,0x7bcf002e,0x9663120c,0x2ee580b9}},	//   mblo, _ascu, дкре, _mnlf_,
   {{0x68e40510,0xd46715d1,0x7d0d2756,0x6281a757}},	//   _unid, жите_, ghas, lblo,
   {{0x2ee58079,0x8c430e8e,0x24802758,0xdb00804a}},	// [1640] _onlf_, дете, rbim_, ttmø,
   {{0x681c0029,0xc8aa0327,0xb0aa18a9,0xe29a23d7}},	//   rādī, _काँट, _काँग, раж_,
   {{0x673c2759,0x506682df,0x7d0d275a,0x26c78ef1}},	//   morj, отла, bhas, deno_,
   {{0x7d0d0870,0xdb0400f7,0x31ba80be,0x7cfc9ab3}},	//   chas, ntiú, יזענ, _yéru,
   {{0xa3ce09a3,0x765f8201,0x1eca81a1,0x7529a75b}},	//   _शनि_, əyyə, илди_, dnez,
   {{0x7d040009,0x26c780e5,0xdd9a97c8,0xa49b026b}},	//   lkis, geno_, аши_, _alòh,
   {{0xb0aa275c,0x69dc275d,0xd9a8800f,0x4c94a3e7}},	//   _कांग, _urre, _कमेट, пийс,
   {{0x61e10065,0x3ea0a75e,0x7d04275f,0x394001c0}},	//   _álla, şit_, nkis, _nkis_,
   {{0xd0078ae7,0x63b62760,0x2f0b806a,0x3946a761}},	//   _дете_, ntyn, _søge_, mlos_,
   {{0x3946840e,0x26c78828,0x2909004f,0x39400084}},	//   llos_, ceno_, _slaa_, _akis_,
   {{0xd48fa762,0x26d32763,0x7d042764,0xdb040216}},	//   _ор_, _raxo_, kkis, guié,
   {{0x394682af,0x26d32765,0x88b10180,0x657a8061}},	//   nlos_, _saxo_, ریخچ, _itth,
   {{0xc86400e8,0xdb0981a8,0xab2a86f9,0x6281a766}},	//   дтри, steá, _кода_, bblo,
   {{0x3ce681c5,0x6298812b,0x39401400,0x7c2da767}},	//   _hnov_, _udvo, _ekis_, _žarg,
   {{0x7d0d2768,0xf27b8051,0x394681e2,0x7cfc8c52}},	//   thas, _דרוש, klos_, _fért,
   {{0xdb0400f7,0x26c79620,0x394681c0,0x80a52769}},	//   ctiú, zeno_, jlos_, _काटे,
   {{0x7d0d276a,0x6b4f806a,0x394689ed,0xdb0d00f7}},	// [1650] rhas, søge, dlos_, staí,
   {{0x7d0d276b,0x657a8019,0x26c783a8,0x39468020}},	//   shas, _otth, xeno_, elos_,
   {{0xceb20451,0x69240d11,0x69160353,0x7d0401de}},	//   _איי_, rđev, ršev, bkis,
   {{0x6b50016d,0x3946a76c,0x7d04276d,0x55da00be}},	//   väge, glos_, ckis, _פֿינ,
   {{0x657a8748,0x26c7a76e,0x60dc00be,0x66e580ae}},	//   _atth, teno_, יקאנ, зола,
   {{0x6281813c,0x644f01a9,0x39468118,0xf8bf01d0}},	//   xblo, _izci, alos_, dném_,
   {{0x26c7812b,0x80ac035a,0x39468ae5,0x7bc2a76f}},	//   reno_, _झाले, blos_, _apou,
   {{0x39468c52,0x61360065,0x673c007a,0x6b5001ec}},	//   clos_, bály, zorj, räge,
   {{0x76450009,0x6281a770,0x39520428,0x26c7a771}},	//   _lyhy, tblo, _rhys_, peno_,
   {{0x386913b8,0x13098d15,0x753b928a,0x7cfca772}},	//   _agar_, сной_, souz, _sért,
   {{0x753b811f,0x7d040082,0x7bc2a1bf,0x673c007a}},	//   pouz, ykis, _epou, vorj,
   {{0x2fdf805c,0x69d083eb,0x63b60198,0xbcfb0216}},	//   _krug_, धिजी, ytyn, _sién,
   {{0x673c2773,0xb4d7864a,0x4aac0072,0x69da81c0}},	//   torj, ायी_, _चालव, avte,
   {{0x4e1f85e8,0x3f9e026f,0x7bda8039,0x657a8388}},	//   _बधाई_, čtu_, _לקנו, _ytth,
   {{0x386d0301,0x7d042774,0xdb040036,0x649a0071}},	//   žera_, tkis, quié, йтар_,
   {{0x2571807b,0x63b60009,0x673c2775,0x61fc8338}},	//   _mál_, ttyn, sorj, ärle,
   {{0xf42a01ac,0x2fdf8282,0x7d042776,0xfbdf02df}},	// [1660] _opäť_, _nrug_, rkis, _crê_,
   {{0x7d042777,0x27e02778,0xa3dc853f,0x60d62779}},	//   skis, _irin_, डित_, _haym,
   {{0x63b6277a,0x9d4624c8,0x60d6277b,0x2c75019d}},	//   styn, _неод, _kaym, _ụde_,
   {{0x2fdf8022,0x63a9a77c,0x63b6277d,0x7ae70168}},	//   _brug_, kuen, ptyn, _enjt,
   {{0x3946a77e,0xe81683a4,0x09a8800c,0x2efa01ec}},	//   rlos_, _देखा_, _कम्य, _kopf_,
   {{0x69c38fb0,0x26ca277f,0xf67a00be,0x290b00eb}},	//   _opne, nebo_, זאַמ, ībai_,
   {{0x629c2780,0x7bc2a781,0x25718118,0x3946a782}},	//   _idro, _spou, _cál_, plos_,
   {{0x27e0077f,0x399b0039,0x2571801b,0x63a995a0}},	//   _orin_, _לילד, _dál_, fuen,
   {{0x63a42783,0x63a9a784,0x628e0587,0x7cfc8125}},	//   nrin, guen, _kebo, _sérs,
   {{0xa3ab8063,0x63a42785,0x628e2786,0x877b83c8}},	//   गढ़_, irin, _jebo, _לאמי,
   {{0x63a42787,0x6446007b,0x26ca026b,0x27e02788}},	//   hrin, _lyki, debo_, _arin_,
   {{0x63a9a789,0x29068bf0,0x27e0278a,0x60d6278b}},	//   buen, nkoa_, _brin_, _caym,
   {{0xd83b01e5,0x63a9960a,0x5f940098,0x7cfc8207}},	//   сэн_, cuen, ният, _férr,
   {{0x628e14f0,0x27e0278c,0xa3e00327,0xf8bf0036}},	//   _nebo, _drin_, थिन_, diée_,
   {{0x27e0278d,0x2d9e003a,0x29068009,0x16042076}},	//   _erin_, šten_, kkoa_, रनगर_,
   {{0xca478013,0x63a4278e,0x629c031d,0xf8bf00e7}},	//   _عليه_, frin, _adro, fiée_,
   {{0x63a4278f,0xa3d58063,0x24580009,0x628e2790}},	// [1670] grin, हिए_, зать_, _bebo,
   {{0x26ca2791,0x628e1e00,0x629c01e0,0x6d428326}},	//   cebo_, _cebo, _cdro, _lkoa,
   {{0x32072792,0x65662793,0x644600b9,0x163502a9}},	//   ány_, _fikh, _eyki, _ценя,
   {{0x25e0858c,0x6ebf800d,0xf42a01ac,0x5fb103db}},	//   किनी_, ल्नु, _späť_, _जमाल,
   {{0xf8bf0036,0x2571a794,0x61360118,0x32071517}},	//   ciée_, _sál_, rálx, šny_,
   {{0x628e105d,0x290fa795,0x6d42826b,0x670d03eb}},	//   _gebo, shga_, _akoa, हसिक_,
   {{0x69da0db7,0x30a7a796,0x20020035,0x60dd8144}},	//   _štev, _нрав, zyki_, _ósmo,
   {{0x58d49697,0x629c09a4,0x63a98102,0x26d80690}},	//   _пост, _zdro, tuen, zdro_,
   {{0x2be00f97,0x2fdf808e,0x68e9a797,0x19588196}},	//   निया, _urug_, _ined, _хаты_,
   {{0x68fb82d8,0x63a9a798,0x7c26807b,0x68e980e1}},	//   _houd, ruen, úkra, _hned,
   {{0x68fba799,0x80d700ab,0x2bdb820e,0x60d6279a}},	//   _koud, ধান্, बिहा, _paym,
   {{0x27e00c6e,0x26c10267,0x2002009a,0x63a4279b}},	//   _prin_, _abho_, tyki_, yrin,
   {{0x21221083,0x63a9a79c,0x6d5b836e,0xeb8e8934}},	//   rikh_, quen, mmua, _ши_,
   {{0x6d49a79d,0x672394e4,0x2906811e,0x6566005d}},	//   llea, ninj, zkoa_, _sikh,
   {{0xdd1c026f,0x63a4279e,0x644f817f,0xed168019}},	//   _vážn, wrin, škić, _رہیں_,
   {{0x628e279f,0x27e027a0,0x6d4990a2,0x752d27a1}},	//   _sebo, _trin_, nlea, gnaz,
   {{0x6d49a7a2,0xab66096b,0x59d584c5,0xc9530039}},	// [1680] ilea, двал, धिकर, _במה_,
   {{0x290da7a3,0x63a427a4,0x03a301a1,0xf8bf0036}},	//   _alea_, rrin, тифо, riée_,
   {{0x68fba1bf,0x63a427a5,0x68e9822b,0xd46a06a1}},	//   _boud, srin, _bned, _мине_,
   {{0x6d5b822c,0x628e03fb,0xc7c68af2,0x8fa69182}},	//   jmua, _webo, дски, даде,
   {{0x628e27a6,0x68fba7a7,0x29068bf0,0x4c3601e2}},	//   _tebo, _doud, rkoa_, _цэнт,
   {{0xf8bf0019,0x291f80b9,0x2906811b,0x68e9a7a8}},	//   tnék_, _emua_, skoa_, _ened,
   {{0x626327a9,0x68fb8866,0x7afc02f9,0xdd1d136f}},	//   _авра, _foud, _iort, lášs,
   {{0x25a0a7aa,0x7afc27ab,0x68fba7ac,0xe81f84e5}},	//   čil_, _hort, _goud, _मेवा_,
   {{0x6723a7ad,0x6843a7ae,0x644e8035,0xaf2aa7af}},	//   binj, _анта, ębio, _джаз_,
   {{0x67238052,0x68fb8a0f,0xadba80f7,0xe45703de}},	//   cinj, _zoud, _وهذا_, ויפט_,
   {{0x6d49a7b0,0xf2d30039,0x36068199,0xbcfb010c}},	//   blea, דעת_, _تواف, _diéj,
   {{0x7afc011e,0xcb6a8323,0xb4db0032,0xf78702df}},	//   _lort, _даде_, _akàn, íços_,
   {{0xac978077,0x6d4082d6,0x7afc01b0,0x2d9e27b1}},	//   _آنها_, moma, _oort, štel_,
   {{0x6d409619,0x7afc160c,0xdce280c3,0x75e401bc}},	//   loma, _nort, _mioč, _ọzay,
   {{0xa3d689a3,0xdb0081ca,0x7bc601a9,0x6455866f}},	//   ाटक_, cumá, _apku, ęzie,
   {{0x6d40a7b2,0x50670abe,0x6b500106,0x66f802d0}},	//   noma, _отпа, väga, _aşkı,
   {{0x752d27b3,0xdb0d0073,0x7afc0687,0x3b550012}},	// [1690] rnaz, ntaç, _bort, екар,
   {{0x6d40a7b4,0x68fba7b5,0x291f8890,0xdb0d0187}},	//   homa, _soud, _smua_, itaç,
   {{0x6d40a7b6,0x68fba7b7,0x7afc27b8,0xda0e80a5}},	//   koma, _poud, _dort, ानित_,
   {{0x2d8301ed,0xa49b0362,0xe7f3866f,0x3835a7b9}},	//   mpje_, _clòt, _आपदा_, ннер,
   {{0x67238025,0x69da003b,0x68fb80e7,0x2575016d}},	//   tinj, _štet, _voud, _hål_,
   {{0x63ad27ba,0x7afc27bb,0xe7338bbe,0x68fb9412}},	//   muan, _gort, خصص_, _woud,
   {{0x67238db7,0x63ad14ff,0xe81fa7bc,0x6d40a7bd}},	//   rinj, luan, _मेरा_, foma,
   {{0x25750082,0x6723a7be,0xdfd597ae,0x67d5a57e}},	//   _mål_, sinj, _побы, _побу,
   {{0x6d49a7bf,0x6d5ba7c0,0x77688118,0x386da7c1}},	//   rlea, rmua, _fidx, _iger_,
   {{0xa3e0090f,0x6d49a7c2,0xcb1200be,0x7afc16bb}},	//   थित_, slea, ָלט_, _xort,
   {{0x6d498e6f,0x7648a7c3,0x7d0f0019,0x6d40a7c4}},	//   plea, _gydy, _olcs, boma,
   {{0x6d40a7c5,0xdb0980a9,0xe8f7176e,0x75d38201}},	//   coma, nteú, елю_, _nəzə,
   {{0xa3d58076,0x316927c6,0xfaa5a3d7,0x7d098c9a}},	//   हिओ_, _diaz_, _зало, mkes,
   {{0x63ad0057,0x2d9e005c,0x7d099323,0x69c705f3}},	//   duan, štem_, lkes, _opje,
   {{0x63bba7c7,0x2f1400f2,0x2d8c27c8,0xed5a0d0e}},	//   ltun, _lägg_, ède_, зов_,
   {{0x7afc27c9,0xc5f280be,0x69a48072,0x1da78035}},	//   _sort, נדן_, _किती, _गिनत,
   {{0x63bb885c,0x63ad27ca,0xfd648a2c,0x03a327cb}},	// [16a0] ntun, guan, _akwụ, лито,
   {{0x28c10054,0x7afc27cc,0x63bb8759,0x06860110}},	//   ष्ठि, _qort, itun, _ягон,
   {{0x63bba7cd,0x7afc11e6,0x6d40a7ce,0x7d09a7cf}},	//   htun, _vort, yoma, kkes,
   {{0x26da022e,0x7648831d,0x7afc27d0,0x61fca7d1}},	//   _hapo_, _rydy, _wort, ørli,
   {{0xe7e327d2,0x6d4613ed,0x63ad0144,0x7afc27d3}},	//   खिया_, _ikka, cuan, _tort,
   {{0x6b8427d4,0x6d40a7d5,0x386da7d6,0x2d8c80e4}},	//   mpig, woma, _eger_, _pwde_,
   {{0x60c427d7,0x2d9a9be6,0xceb300be,0x63bba7d8}},	//   _obim, épe_, טיג_, etun,
   {{0x63bb90f6,0x75d38085,0xc5f30039,0xd9e386a7}},	//   ftun, _xəzə, רדה_, गिनत_,
   {{0x6d40a7d9,0x63bba7da,0xd4e38009,0xdb040036}},	//   roma, gtun, ующи, triè,
   {{0x2d6e800d,0x6b4f813c,0xdb0d27db,0x26da27dc}},	//   _před_, søgn, rtaç, _napo_,
   {{0x6d4627dd,0xdb0402be,0xdb0d03a7,0x95caa7de}},	//   _okka, rriè, staç, _хлеб_,
   {{0x6d40a7df,0x69b1809a,0xdb0d0187,0xdcdf03db}},	//   qoma, _अमरी, ptaç, _पोंछ,
   {{0xb8d90576,0xa3e4800d,0xa2c106af,0xdb040118}},	//   _चा_, _पछि_, र्ड्, ntió,
   {{0x5453835f,0x6d4627e0,0x26da27e1,0xd04089ab}},	//   _світ, _akka, _capo_, _hamɓ,
   {{0x0dc81506,0x95c8028b,0x394227e2,0x26da026b}},	//   нути_, нута_, boks_, _dapo_,
   {{0x290b0341,0x63ad27e3,0x2b5827e4,0x394200b9}},	//   ības_, tuan, _ahrc_, coks_,
   {{0x8aa70153,0x69c727e5,0xfaa704fa,0x6b84076d}},	// [16b0] еред, _spje, ешен, gpig,
   {{0x60dd0a64,0x2fc902e8,0x6d460365,0x25750106}},	//   ldsm, _ipag_, _ekka, _tål_,
   {{0xf99307bd,0x799aa7e6,0x63bb9124,0x67270267}},	//   ابط_, nstw, ztun, mijj,
   {{0x60dd23ea,0x21268358,0x2fc902d5,0x2d8127e7}},	//   ndsm, gioh_, _kpag_, _ithe_,
   {{0xb8c98b3b,0x63ad27e8,0x69d5009a,0x389c00be}},	//   _गए_, quan, _wsze, ליאנ,
   {{0x6d4d1e38,0x6da5867c,0x443901e0,0x6727026c}},	//   llaa, вика, _ixs_, nijj,
   {{0x53340425,0xa3b3816f,0x68ed27e9,0x7d09956e}},	//   _серт, जून_, _onad, tkes,
   {{0x63bba7ea,0x68ff02a3,0x386d813c,0x60dd006a}},	//   ttun, _noqd, _uger_, jdsm,
   {{0x63bb8009,0x7d09a7eb,0xd9d9801b,0xa2c11869}},	//   utun, rkes, बट्ट, र्थ्,
   {{0x613d0065,0x7d098100,0x63bb8367,0x68ed27ec}},	//   mély, skes, rtun, _anad,
   {{0x63bba7ed,0x6d4d27ee,0x3f80002e,0x2d81022c}},	//   stun, klaa, _stiu_, _nthe_,
   {{0x60db809f,0xdb2689a7,0x26da27ef,0x2d9e27f0}},	//   _jaum, _یونی, _sapo_, štek_,
   {{0x889a8039,0x26da24d4,0x2f14016d,0x60db804f}},	//   וברי, _papo_, _läge_, _maum,
   {{0x4ad78117,0x4ed51b69,0xdb0402be,0xfaa5a7f1}},	//   _ساتھ_, люст, prié, _рако,
   {{0xceb29a0f,0x63a9a7f2,0x656ba7f3,0xcb1281c6}},	//   יים_, lren, _kigh, _דלג_,
   {{0x6d4d27f4,0x26da004f,0x63a9a7f5,0x656b819d}},	//   glaa, _wapo_, oren, _jigh,
   {{0x26da0110,0x656b8039,0xb46601e5,0x2d8127f6}},	// [16c0] _tapo_, _migh, ткал, _ethe_,
   {{0x656ba7f7,0x613d0019,0x68ed05f3,0x6d4d27f8}},	//   _ligh, dély, _znad, alaa,
   {{0x2be00076,0x63a9a7f9,0x644b8110,0x60db9655}},	//   निहा, hren, _lygi, _baum,
   {{0x63a982a5,0xfbab1344,0x656ba7fa,0x290027fb}},	//   kren, _चमचम, _nigh, _joia_,
   {{0x7c2da7fc,0x68438a14,0xb4c00beb,0x087700be}},	//   _žarn, анца, ूजी_, דענט_,
   {{0xa3c1009a,0x3cda8592,0x656b832f,0x7f4381e0}},	//   ूबर_, _खोजे_, _aigh, gonq,
   {{0xdb04040e,0x63a9a7fd,0x28dd92c6,0x2be0170c}},	//   stió, eren, _नोकि, निवा,
   {{0x6d59a7fe,0x290027ff,0x60dba800,0x6d442801}},	//   _chwa, _noia_, _gaum, noia,
   {{0xa7668be1,0x63a9906f,0x656ba802,0x6b9b84a7}},	//   _акад, gren, _digh, gsug,
   {{0x6d5983ac,0x68ed001b,0xbcfb0118,0x29120c2e}},	//   _ehwa, _snad, _viéi, _alya_,
   {{0xdb0404c3,0x7c2d807b,0x63a9a803,0x6727026c}},	//   ntiñ, _þarn, aren, vijj,
   {{0x0c26a804,0xe8e00028,0x799a809a,0x94268009}},	//   _имен, _trời_, rstw, _имее,
   {{0x692b000d,0x6727026c,0x60dd0cd7,0x6d441b1f}},	//   třeb, tijj, rdsm, doia,
   {{0xf8bf06a5,0x656b81bc,0x68ed0326,0x2912038a}},	//   cién_, _zigh, _wnad, _elya_,
   {{0x7e280d13,0xdb00816d,0xf62800e8,0x6d4d2805}},	//   віта_, rumä, віти_, tlaa,
   {{0xe7f3816f,0x6727026c,0x69d8a806,0x68ed01f8}},	//   _आपला_, sijj, _isve, _unad,
   {{0x54552807,0xdc550003,0x6d4d2808,0x60dba809}},	// [16d0] уват, увањ, rlaa, _raum,
   {{0x6d4d0b3c,0xf1b6a769,0xe3b001a8,0x22950481}},	//   slaa, _अमान, ترف_, الاس,
   {{0x6d4d280a,0x26d1280b,0x60dba80c,0x63a99002}},	//   plaa, mezo_, _paum, zren,
   {{0x26d1280d,0xe0df280e,0x3015a80f,0x2600001b}},	//   lezo_, ndò_, лдер, रहरी_,
   {{0xe8d90104,0x656b8051,0xd91c0158,0x251a0039}},	//   _chỉ_, _righ, וואל, _נושא,
   {{0x69d893f6,0xb87b12ca,0x60db804f,0x26d12810}},	//   _osve, ndíb, _waum, nezo_,
   {{0x99678e9f,0x60dba811,0xdb040c52,0xf8bf00e7}},	//   _атал, _taum, quiá, nnés_,
   {{0x7d0d2812,0x26d12813,0x6b9ba814,0x39490282}},	//   nkas, hezo_, tsug, _nkas_,
   {{0x26d12813,0x0b45841c,0x63a9a815,0x69ca81ec}},	//   kezo_, лнин, uren, _apfe,
   {{0xe1f98364,0x63a9a816,0x656ba817,0x25788019}},	//   его_, rren, _wigh, _fél_,
   {{0x7d0d2818,0xa2ca06af,0xaca30032,0x26d10118}},	//   kkas, _सॉफ्, _akọb, dezo_,
   {{0x38698699,0x69a48beb,0x64558085,0x61f80589}},	//   žaru_, _किरी, əzin, ävli,
   {{0x03a58258,0x53a587b6,0x7d0d2819,0x69d88580}},	//   _сило, _салб, dkas, _esve,
   {{0x6295281a,0x26d12169,0x7529a81b,0xfd65027d}},	//   _nezo, gezo_, liez, _truồ,
   {{0xdca60cec,0x64a608d5,0xc0e6281c,0xdd1d01d0}},	//   лави, лава, _бойк, lářs,
   {{0x7d0d043b,0xa3e0281d,0x7e7c0216,0x7529a81e}},	//   gkas, थिल_, scrp, niez,
   {{0x0aea1bcc,0x6295281f,0x6eac009a,0x6d442820}},	// [16e0] ндай_, _bezo, _जयपु, roia,
   {{0x7d0d0009,0xb4631a1a,0xdb00a821,0x6d442822}},	//   akas, скул, stmö, soia,
   {{0x62952823,0xd24f00f7,0x88868098,0x9abc84b7}},	//   _dezo, كنك_, глеж, fiċj,
   {{0xdb0401df,0xc0968290,0x25aa804a,0x31bc0118}},	//   rtiñ, اجات, _åbli_, ríz_,
   {{0xa3d28610,0x316da824,0xdb042825,0x6ac900ab}},	//   _हैं_, _diez_, stiñ, রয়ো,
   {{0x62952826,0x6f01a827,0xaa4602a9,0xa85701c6}},	//   _gezo, _colc, _бегл, ניסה_,
   {{0x645d8125,0x6f018098,0xceb30039,0xe5c69821}},	//   ýsin, _dolc, ציה_, усло,
   {{0xd1328b76,0x386d2828,0x78a4004f,0x75298cdb}},	//   _امر_, žeri_, _ndiv, giez,
   {{0x28dd800f,0x5b14a503,0x6f01a829,0xdb040187}},	//   _नोटि, имит, _folc, guiç,
   {{0x3946a82a,0x78a4282b,0x2578a82c,0x9bbb00be}},	//   loos_, _adiv, _tél_, עציפ,
   {{0xaac623a7,0x80de00c8,0xd2508077,0x7d0d282d}},	//   र्यक, যান্, تند_, ykas,
   {{0xdb0403a7,0x3f84808e,0xaca301bc,0x26de8a03}},	//   buiç, _ktmu_, _kwụd, _hato_,
   {{0xe8d90104,0xa3b3823c,0x26dea82e,0xed579baa}},	//   _giờ_, जूद_, _kato_, _соц_,
   {{0x7d0282a3,0x8c1b8039,0x26de82df,0xaca3019d}},	//   _hoos, _אודי, _jato_, _mwụd,
   {{0x6295282f,0xc27b893f,0x7d0289f8,0x26d12830}},	//   _rezo, _ארוי, _koos, rezo_,
   {{0x99838307,0x629aa831,0xf1a9809a,0x26dea832}},	//   _اليو, lato, _कितन, _lato_,
   {{0x62950216,0x26d10333,0x24180fe6,0x3946a833}},	// [16f0] _pezo, pezo_, готы_, doos_,
   {{0x212b034a,0x27e92834,0x7d0d2835,0x830500ab}},	//   lich_, _iran_, skas, োচ্চ_,
   {{0xe8d900ff,0xa2c12836,0x8027881b,0xc1e8084b}},	//   _nhị_, र्ष्, گرام, льце_,
   {{0x629aa837,0x212b01e4,0x32641132,0x6f01a838}},	//   hato, nich_, стув, _solc,
   {{0x26dea839,0x4ac48651,0xe8d901bc,0x35ab06a7}},	//   _bato_, वभाव, _ahị_, _छिड़,
   {{0x7ceb04b8,0x656f283a,0x66e5a83b,0xaec480e8}},	//   _förä, _hich, рока, йбіл,
   {{0x212b0063,0x26dea83c,0x6f01a09c,0x656f283d}},	//   kich_, _dato_, _volc, _kich,
   {{0x212b0775,0xdb040073,0x63ad283e,0x27e9283f}},	//   jich_, tuiç, oran, _oran_,
   {{0x656f2840,0x212b0229,0x26de83a7,0x9ed98098}},	//   _mich, dich_, _fato_, _имат_,
   {{0x656f2841,0x26de954e,0x13098009,0x03259138}},	//   _lich, _gato_, тной_, рдон,
   {{0x63ad2842,0x7529a843,0x69de826f,0xcb140039}},	//   hran, piez, _šper, מלץ_,
   {{0x656f0943,0x212b2844,0x95678698,0x75ca8201}},	//   _nich, gich_, _създ, _qəze,
   {{0x26de8091,0x63ad0289,0x248d83a7,0x5edf00ab}},	//   _yato_, jran, mbem_, মানে,
   {{0x7d02822c,0x656f2845,0x6b89a846,0x27e901ec}},	//   _zoos, _aich, mpeg, _dran_,
   {{0x63ad2847,0xde032657,0x27e92848,0x656f106c}},	//   eran, опри, _eran_, _bich,
   {{0x63ad2849,0x212b01ac,0x69c1a84a,0x7de08019}},	//   fran, cich_, mtle, lásá,
   {{0x656f284b,0x27e9284c,0x998d23e3,0x0326284d}},	// [1700] _dich, _gran_, _ćeš_, адан,
   {{0x6d5d284e,0x656f1f8b,0xfaa6284f,0x60c9a850}},	//   _ehsa, _eich, ражо, _abem,
   {{0x63ad1897,0xa2bd80bc,0x60c9838a,0xb87b016a}},	//   aran, _शान्, _bbem, ldía,
   {{0x629aa851,0x2ba6901c,0x26dea852,0xfce62853}},	//   zato, _खिला, _sato_, _томо,
   {{0x26dea854,0x7d0298d6,0xb87b05e4,0xdb09816a}},	//   _pato_, _roos, ndía, nteó,
   {{0x656f2855,0x69c1a280,0xadc30032,0x3d118091}},	//   _zich, ktle, _atẹg, _báwo_,
   {{0x656f20ba,0xfaa32856,0xdd978048,0x7de08019}},	//   _yich, _фасо, ашы_, dásá,
   {{0x629a8077,0x26de80a4,0x3d11846d,0x44f4a857}},	//   wato, _wato_, _dáwo_, спис,
   {{0x26de801b,0x2fc0022c,0x629aa858,0x69c18035}},	//   _tato_, _nqig_, tato, etle,
   {{0x68e0a859,0xe8d90104,0x5b148364,0x3178285a}},	//   _hamd, _thị_, смот, _kurz_,
   {{0x2904a85b,0x257c0013,0x13cf00c8,0xbcfb285c}},	//   _koma_, _níl_, রিয়, _miér,
   {{0x68e2a85d,0x27e90205,0x2904a85e,0x644686ae}},	//   ndod, _pran_, _joma_, ükis,
   {{0x212b285f,0x2f1400f2,0x656f2860,0xd83b0048}},	//   rich_, _säga_, _rich, тэн_,
   {{0x656f2861,0x212b01e4,0x69dc007a,0x69ce2862}},	//   _sich, sich_, _osre, _opbe,
   {{0x656f022e,0x2d8505f8,0x35e405a8,0x69c1890d}},	//   _pich, ële_, оцтв, ctle,
   {{0x2f140006,0x2904829b,0x5c750a95,0xfc3f002a}},	//   _väga_, _noma_, слат, _adía_,
   {{0x63ad2863,0x2129036e,0x656f2864,0x68e2831d}},	// [1710] uran, _imah_, _vich, ddod,
   {{0xf1da8063,0x656f02af,0x59da92ee,0x63ad2865}},	//   _बनान, _wich, _बनार, rran,
   {{0x656f0a00,0x63ad16b2,0x644f009a,0xc69202f6}},	//   _tich, sran, _wyci, _מאי_,
   {{0x2904a866,0x63ad2867,0xc8798059,0x68e08114}},	//   _coma_, pran, _başa_, _camd,
   {{0x27e9a868,0x68e0809c,0x752d2869,0x6b5d8866}},	//   ían_, _damd, miaz, lège,
   {{0x6298a86a,0x81cd80c8,0x7bdd0051,0x752d030a}},	//   _nevo, রিত_, _issu, liaz,
   {{0x63a2a86b,0xe7f38063,0x816b8071,0x692b001b}},	//   _avon, _आपका_, _араб_, vřen,
   {{0xce380bea,0x2904a86c,0x752d286d,0x25a9a304}},	//   יאות_, _goma_, niaz, čal_,
   {{0x629894f9,0xe784a86e,0x7de08065,0x3015a481}},	//   _bevo, _духо, tásá, _удар,
   {{0x69c1a86f,0xf7708013,0x6b89a870,0xc2e98065}},	//   ttle, _قال_, rpeg, اعظم_,
   {{0x7c3b0125,0x395f81c0,0x6b89a871,0x6298a872}},	//   _þurf, _khus_, speg, _devo,
   {{0xa3d281ce,0x443d81c0,0x628e807b,0xc8798850}},	//   _हैक_, _txw_, ðbor, _yaşa_,
   {{0xe28e8ae7,0x43858307,0x752d2873,0x7d1ba874}},	//   _на_, _التق, diaz, mhus,
   {{0x6298a4de,0xe7fa816f,0x7d1ba875,0x68e2a876}},	//   _gevo, ्हता_, lhus, zdod,
   {{0xba9a8051,0x63a2883d,0x7bdd19c3,0x1a65853d}},	//   _עסקי, _zvon, _assu, _دیدی_,
   {{0x31a382bb,0x6143120c,0x2bac0a27,0x6281a877}},	//   mız_, _неща, _चिदा, lclo,
   {{0x2904a878,0x68e0a879,0xed5700a9,0xdb098216}},	// [1720] _roma_, _ramd, сот_, lteñ,
   {{0xb87b287a,0x2904a87b,0x6281a87c,0x394d810c}},	//   ndín, _soma_, nclo, _akes_,
   {{0x31a38afe,0x58868084,0x7bdd0c56,0xdb0984c3}},	//   nız_, была, _essu, nteñ,
   {{0x752d287d,0x395fa87e,0x75ca8085,0x61fc85ec}},	//   ciaz, _chus_, _nəza, ärli,
   {{0xe1e789d7,0x68e2a87f,0x7d1ba880,0xc7968190}},	//   _کس_, rdod, dhus, ёрды,
   {{0x2904913b,0x44202881,0xdb04016a,0x99760049}},	//   _woma_, mzi_, briá, _гуаш,
   {{0x63a28125,0x69dc0a20,0x6d410125,0xacf891d2}},	//   _svon, _usre, élag, инку_,
   {{0x629e2882,0x7d1ba883,0x75ca8085,0x186aa884}},	//   lapo, ghus, _cəza, _баби_,
   {{0x44201167,0x7d0601e2,0xa3b383b7,0x77e20a27}},	//   nzi_, _moks, जूल_, गटोक_,
   {{0xbea3a885,0x629e2886,0x752d2887,0x6281a888}},	//   _наук, napo, ziaz, gclo,
   {{0x60f901d7,0x9cca8b71,0x14ca8009,0x8afb007c}},	//   ання_, _была_, _были_, אליז,
   {{0xeb9a87b6,0x629e02e8,0xe8d900ff,0x63a282f7}},	//   _бид_, hapo, _thọ_, _tvon,
   {{0x2571805c,0x629e2889,0x6ebf800f,0x6298a88a}},	//   _ušla_, kapo, ल्कु, _tevo,
   {{0x4420288b,0x657a94aa,0x543b80be,0x1ddc9834}},	//   dzi_, _kuth, _געדא, _मनात,
   {{0x918688ca,0x4420288c,0x50c8864a,0x752d288d}},	//   _اجتم, ezi_, रभाष, tiaz,
   {{0x2129288e,0x7a0a8085,0xa3e50327,0x2f0b821e}},	//   _umah_, rətd, पटल_, _høgt_,
   {{0x2d580153,0x60cd288f,0x752d0f92,0x657aa890}},	// [1730] сить_, _ibam, riaz, _luth,
   {{0x629e2891,0x3f890187,0x394b1e9e,0x249902c4}},	//   gapo, _itau_, locs_, _wesm_,
   {{0xe5c72300,0x395f81c0,0x44202892,0x657a89c4}},	//   _успо, _phus_, azi_, _nuth,
   {{0x63b606d5,0x764482d0,0xe1f001a8,0xfbd00061}},	//   buyn, ğiyl, عسل_, بتہ_,
   {{0x7bc413df,0x2b930bca,0x657a8051,0xb4db026b}},	//   ctiu, _ریاس, _auth, _ajàg,
   {{0x6b8d2893,0x079c0039,0xdb231a50,0x31a3807e}},	//   mpag, נסול, örän, yız_,
   {{0x4519a33f,0x6b8d2894,0xe8d90028,0x7d060214}},	//   иция_, lpag, _nhỏ_, _yoks,
   {{0x69c52895,0x75ca8085,0x394b023e,0xdb1b8118}},	//   mthe, _qəza, jocs_, rtuí,
   {{0xfc318307,0x31d184e5,0x3f8910af,0x7d1b8370}},	//   بحث_, तब्ध, _ntau_, rhus,
   {{0x657a91e8,0x693c9807,0x60cd2896,0x7d1ba897}},	//   _futh, nčen, _abam, shus,
   {{0x44202898,0x3f89048f,0xb87b2899,0x657aa89a}},	//   zzi_, _atau_, rdín, _guth,
   {{0xc6890f60,0xe56e835f,0x69c50cac,0x291d8683}},	//   _יא_, _із_, ithe, nhwa_,
   {{0x31a383bf,0x81c100ab,0xfaa58196,0x2f10851e}},	//   sız_, ্টি_, _дало, _bàgh_,
   {{0x6b8d0f33,0x212f81e4,0xe3b0a89b,0x69c5289c}},	//   dpag, high_, _سره_, kthe,
   {{0x693c816b,0x366a2748,0x78a9a67b,0xdb098661}},	//   dčen, раво_, _odev, nreí,
   {{0x7ae3a89d,0x4420011e,0x2d78017f,0x81c100ab}},	//   _hant, tzi_, _očev_, ্টা_,
   {{0x7ae3861b,0x629e049f,0x66e60003,0x7d060b40}},	// [1740] _kant, tapo, _допа, _voks,
   {{0x78a98012,0x249f81c5,0x7bc4289e,0x44200235}},	//   _adev, haum_, rtiu, rzi_,
   {{0x44200065,0x7bc4289f,0x68e428a0,0xe9da28a1}},	//   szi_, stiu, _kaid, рке_,
   {{0x6b8d28a2,0x26d828a3,0x777b8079,0x29020796}},	//   bpag, lero_, _buux, njka_,
   {{0x2ca028a4,0x657aa8a5,0x795d03f8,0x27ed9c4b}},	//   maid_, _suth, néwa, _cren_,
   {{0x26d828a6,0xfdfe0e18,0xf413004c,0x7ae3a8a7}},	//   nero_, _उपास_, _חפש_, _nant,
   {{0x63a428a8,0x27eda8a9,0x629c0029,0xd5b080f7}},	//   lsin, _eren_, _iero, رفة_,
   {{0x7ae382b5,0x68e40046,0x291da8aa,0xf1c303fb}},	//   _aant, _naid, chwa_, žší_,
   {{0x7ae3a0fc,0xa2ca0023,0x629c28ab,0xdddc01dd}},	//   _bant, स्थ्, _kero, jbrž,
   {{0x26d828ac,0xbcfb00f7,0x3d1880d7,0xdb0d0118}},	//   jero_, _mhéa, _déwa_, traé,
   {{0x7ae3a8ad,0x26d828ae,0x629c28af,0x27e028b0}},	//   _dant, dero_, _mero, _asin_,
   {{0x645c8086,0x2ca00074,0x7c65803d,0x68e428b1}},	//   ərin, jaid_, _کامل, _caid,
   {{0xb4d69344,0x26d828b2,0xc05b0558,0xb4b6a8b3}},	//   ाजी_, fero_, рін_, जली_,
   {{0xa3d785e8,0x629c1bfe,0x26d80e4d,0xf6518065}},	//   ाबर_, _nero, gero_, _آئے_,
   {{0xd49b0ae7,0x6b8d28b4,0x27e004be,0x68e428b5}},	//   ира_, wpag, _esin_, _faid,
   {{0x68e428b6,0x7ae3a8b7,0x25ad1f95,0x63a428b8}},	//   _gaid, _zant, čel_, fsin,
   {{0xbcfb0013,0x63a428b9,0x26d828ba,0x7ae3a8bb}},	// [1750] _chéa, gsin, bero_, _yant,
   {{0x68e400f6,0xbcfb0307,0xa3ac000f,0x6b8d28bc}},	//   _zaid, _dhéa, _गिर_, rpag,
   {{0xa2bd81ab,0x212f80f7,0x26c10133,0x291d805d}},	//   _शास्, tigh_, _icho_, thwa_,
   {{0xa2ca824c,0xbcfb0013,0x2ca028bd,0x69c528be}},	//   त्त्, _fhéa, caid_, rthe,
   {{0x629c28bf,0xf484003d,0x212f8c5e,0x2fc6a8c0}},	//   _fero, _تاپی, righ_, gtog_,
   {{0x291d9ae4,0x629c28c1,0x69c528c2,0x212f81a8}},	//   shwa_, _gero, pthe, sigh_,
   {{0x7ae3a8c3,0x6ecd000c,0x6d44a8c4,0x61ee01a1}},	//   _rant, द्यु, čian, _grbl,
   {{0x7ae3933b,0x27eda8c5,0x628528c6,0xd4d9835f}},	//   _sant, _tren_, lcho, ські_,
   {{0x26c105a4,0x629c0c2e,0x26d828c7,0x27eda8c8}},	//   _ocho_, _yero, yero_, _uren_,
   {{0x628528c9,0x68e428ca,0x26c1022c,0x629c28cb}},	//   ncho, _said, _ncho_, _xero,
   {{0xdb0d02ba,0x26d815a4,0x68e428cc,0x63a428cd}},	//   ntañ, vero_, _paid, zsin,
   {{0x26c128ce,0x7c2d9bcf,0x9f4481df,0x63a428cf}},	//   _acho_, _žaru, _irmá_, ysin,
   {{0x26d828d0,0x2ca00006,0x68e428d1,0x628528d2}},	//   tero_, vaid_, _vaid, kcho,
   {{0x7ae38282,0x628528d3,0x25ac026f,0xbbe9804e}},	//   _uant, jcho, ádlo_, _پرچم_,
   {{0x26d828d4,0x628528d5,0xdb0d00e7,0x68e422af}},	//   rero_, dcho, traî, _taid,
   {{0x63a428d6,0x629c28d7,0x26d828d8,0xb4e606af}},	//   tsin, _sero, sero_, पये_,
   {{0xa5070098,0xd46710ca,0x61ee1f3a,0x1d072300}},	// [1760] чета_, зите_, _srbl, чети_,
   {{0x63a428d9,0x2ca028da,0x6b50016d,0x6aa18b81}},	//   rsin, said_, vägs, nalf,
   {{0x629c28db,0x2ca017f6,0x63a41527,0xc8b50019}},	//   _vero, paid_, ssin, _علیک,
   {{0x63a428dc,0xbcfb00f7,0x629c28dd,0x00000000}},	//   psin, _théa, _wero, --,
   {{0x28c110be,0x629c28de,0x4abda23a,0x6285016b}},	//   ष्टि, _tero, ्भाव, bcho,
   {{0x656280f1,0x657e005d,0x45d4a8df,0x6285051e}},	//   _shoh, _kuph, докс, ccho,
   {{0x3981a8e0,0xc1da800f,0xdb04016d,0x7c240087}},	//   _nós_, _बनेग, rriä, lzir,
   {{0xdce428e1,0x48e38af2,0xb4d693e5,0x7d0428e2}},	//   kmič, _посв, ाजे_, njis,
   {{0xd943838d,0x7c2428e3,0xa2bd9834,0x614389b5}},	//   _чети, nzir, _शाश्, _чета,
   {{0x645c8201,0xdce42648,0xfbcf80a0,0xef178009}},	//   əril, dmič, اتي_, _ему_,
   {{0xa2c10540,0x58d90b79,0x6562a8e4,0x867581e2}},	//   र्ट्, одня_, _thoh, _жыцц,
   {{0xdb1ba8e5,0x2d570214,0x69cd86a7,0x62850690}},	//   rtuá, rçek_, _तहरी, zcho,
   {{0x506404ae,0xdb1b8187,0x75ca8085,0x6aa18c0b}},	//   етра, stuá, _məzm, balf,
   {{0x39818013,0x7c2428e6,0x6aa1823e,0xf53f021e}},	//   _fós_, dzir, calf, _sjå_,
   {{0x78a28a9e,0x6614128a,0x97579101,0x9f44128a}},	//   kaov, _čeká, פילו_, ímá_,
   {{0xd23b804c,0x7d04020f,0xe945026a,0x2a3b81c6}},	//   _לגול, gjis, _ترتی, _לעומ,
   {{0x628528e7,0x2b510267,0x3ce681a1,0x6f010061}},	// [1770] tcho, _pkzc_, _maov_, ölcs,
   {{0x212da8e8,0x501c01c6,0x628513ff,0x4424a8e9}},	//   _smeh_, _לוחו, ucho, izm_,
   {{0xceb2093f,0x628528ea,0xcb138158,0x69c887f1}},	//   _ביי_, rcho, עלע_, ntde,
   {{0x628528eb,0xf8bf28ec,0x7c240bcf,0xb4d68327}},	//   scho, ngé_, bzir, ाजो_,
   {{0xdb0d0ef3,0x31648115,0xf8bf0036,0xc615a8ed}},	//   stañ, _dhmz_, liés_, तन्य_,
   {{0x8ae4035f,0x3ea328ee,0xdb0d0187,0x6440050b}},	//   _післ, najt_, duaç, _žmig,
   {{0x3164826c,0xa3e5000d,0x77770609,0xdb0d01a8}},	//   _fhmz_, पटक_, _mixx, nraí,
   {{0xfdf80039,0x7ae728ef,0x78ad0a03,0x3d18810c}},	//   לצות_, _hajt, _ndav, _déwo_,
   {{0x6aa1a8f0,0x04778065,0x7ae7007a,0x6569a8f1}},	//   talf, _ہلاک_, _kajt, rmeh,
   {{0x394f80eb,0x398183a7,0x6569a8f2,0xc9a98198}},	//   logs_, _pós_, smeh, овое_,
   {{0xd9462606,0x7ae728f3,0x7d1d28f4,0x645c8085}},	//   дени, _majt, _olss, ərim,
   {{0xcea9004c,0x7ae728f5,0xf8bf28f6,0x3981a6f0}},	//   _כי_, _lajt, ggé_, _vós_,
   {{0xd9aa01a2,0xbcfb00e7,0xe7f0881f,0xbbeb80d7}},	//   _चट्ट, _phén, चिया_, _درام_,
   {{0xdb0980f7,0x69d500f3,0xf8bf0036,0xdce428f7}},	//   breá, _opze, fiés_, rmič,
   {{0xbb5284e3,0xdb0d0013,0xc10600f7,0x63bba8f8}},	//   _جنوب, graí, _يوتي, luun,
   {{0x2cbf8074,0x29190168,0x7d0b8061,0x2d5389b2}},	//   ngud_, ërat_, _jogs, mães_,
   {{0x3ce60038,0x7bc9a8f9,0x7d0428fa,0x63bba8fb}},	// [1780] ľov_, nteu, rjis, nuun,
   {{0xe8d90142,0xa3cf1a87,0x44630073,0x3ce600e1}},	//   _thể_, _शहर_, твув, žov_,
   {{0xaacfa3a7,0xa50a18a0,0x3ce9151e,0x7ae728fc}},	//   त्यक, _дена_, bdav_, _dajt,
   {{0xdb0d007b,0x7bc9a8fd,0x3cf90118,0x693c81d6}},	//   stað, kteu, _gnsv_, mček,
   {{0xd12f83f8,0x10a3a8fe,0x98a38991,0x87da9c12}},	//   جمن_, тичн, тиче, تباس_,
   {{0x6d448110,0x63bb8079,0xaacf8107,0x644602f9}},	//   čiam, duun, त्मक, _ixki,
   {{0x7d0ba8ff,0x60c402a5,0x98a9026c,0x69c8a900}},	//   _bogs, _ocim, _smač_, xtde,
   {{0xdb0d0073,0x7ae7251c,0x63bba901,0xfbaa862c}},	//   tuaç, _zajt, fuun, отой_,
   {{0x7d0b81e0,0x7ae701c0,0xaec6a902,0x693c928a}},	//   _dogs, _yajt, _обал, yčej,
   {{0x60c40073,0x764d8182,0x1f63a28e,0x59d205fb}},	//   _acim, şaya, _акум, _सहार,
   {{0xe1352903,0x195901bb,0xdb042904,0x81d68264}},	//   енны, заны_, friú, সিভ_,
   {{0x26dca905,0x7d0b80b9,0x27f22906,0xdb040036}},	//   levo_, _gogs, _bryn_, ssiè,
   {{0x7bc982c2,0x78a09142,0xf8bf00e7,0x69c8a907}},	//   cteu, _memv, rgé_, stde,
   {{0xdef8053b,0xdb0d2908,0x26dc80e5,0xf8bf0866}},	//   мыс_, traí, nevo_, tiés_,
   {{0xcad78051,0x7ae70019,0x3ea32909,0x7d1d02c4}},	//   _חוות_, _rajt, rajt_, _plss,
   {{0x7ae7290a,0xa2ca8d14,0xf8bf00e7,0x3ea3290b}},	//   _sajt, त्र्, riés_, sajt_,
   {{0x29190029,0x24580009,0x7ae7290c,0x60dd0123}},	// [1790] ūras_, дать_, _pajt, mesm,
   {{0x60dd290d,0x26dc9620,0xbcfb00e7,0xc8798087}},	//   lesm, jevo_, _théo, _iaşi_,
   {{0x7ae7290e,0x26dca90f,0x51840110,0x85750009}},	//   _vajt, devo_, вуча, _плох,
   {{0x25f4825e,0x60dd2910,0x2561808b,0x63b62911}},	//   ्मनी_, nesm, kóla_, bryn,
   {{0x24b600be,0x63bb8079,0xf8bf00e7,0x7ae72912}},	//   _אהרן_, xuun, chée_, _tajt,
   {{0x656d1572,0x2b0003eb,0x2f188198,0x62830088}},	//   lmah, राणु_, мочь_, žnob,
   {{0x60dd2913,0x6aa52914,0x62888216,0x9f400362}},	//   kesm, mahf, dcdo, _criù_,
   {{0x7bc9a915,0x656d2916,0x63bba917,0x3ea12918}},	//   tteu, nmah, tuun, _leht_,
   {{0x31348703,0x2fc901c0,0x656d011b,0x6d4280c3}},	//   _ретр, _nqag_, imah, _djoa,
   {{0x291f8282,0x656d2919,0x26dc847f,0x7bc9a91a}},	//   _hlua_, hmah, cevo_, rteu,
   {{0x68e99083,0x656d09ca,0xf2d200be,0x68fba91b}},	//   _kaed, kmah, נעט_, _knud,
   {{0xaacf024c,0x4acf06bf,0x7bc980e7,0x656d026c}},	//   स्तक, स्तव, pteu, jmah,
   {{0x7c3b291c,0x395e00eb,0x653a80be,0x6aa500b9}},	//   _žurn, ēts_, _צענד, kahf,
   {{0x6d5b820f,0x6446008e,0x63a9a91d,0xbcfb09c4}},	//   llua, _rxki, msen, _dhém,
   {{0xceb29a0f,0x63a9a280,0xf8bf026f,0x24f61444}},	//   טים_, lsen, riér_, нчар,
   {{0x2edc800d,0x63b60d12,0xfce30171,0x693c81ac}},	//   _यस्त, tryn, лосо, rček,
   {{0x63a9a91e,0x6d5ba91f,0x6b4b0061,0xab662920}},	// [17a0] nsen, ilua, lügy, евал,
   {{0x3ea10352,0x63a9a921,0x68fba922,0x291f8f3e}},	//   _geht_, isen, _anud, _alua_,
   {{0x64a625af,0xda0f83eb,0x81cd80ab,0x26dca923}},	//   _пана, ाहित_, রিক_, vevo_,
   {{0x92c20a49,0xc7c69b10,0x63a9a924,0x4fc68103}},	//   ্যে_, ески, ksen, еска,
   {{0xb05b0106,0x26dca925,0x98ab0087,0x6d5ba926}},	//   lfär, tevo_, lică_, dlua,
   {{0x63a997db,0x290d8176,0xde588084,0x36d4a927}},	//   dsen, _eoea_, малі_, токр,
   {{0xd91099f4,0xe3570451,0x78a6003a,0x4343014f}},	//   _پیش_, _נשלח_, kakv, _серв,
   {{0xafe69631,0x628a826c,0x26dc8267,0xd90d881b}},	//   _побл, _sffo, sevo_, _ویل_,
   {{0xcf469ae5,0x6459864c,0x26dc847f,0x60c281f6}},	//   _знай, _cywi, pevo_, mgom,
   {{0x21200455,0x9ad281bc,0x7a0a8085,0xef1981b9}},	//   _alih_, _bịag, bətl, _tuża_,
   {{0x2258813c,0x6d5ba928,0x673500f1,0x75d395a9}},	//   ærk_, blua, vizj, _ميلا,
   {{0x60c2a929,0x28c60ebf,0x98ab0087,0x67350035}},	//   ngom, _वाणि, dică_, wizj,
   {{0x60dd292a,0xac9781a8,0x2d81292b,0x64598114}},	//   resm, _أنها_, _suhe_, _gywi,
   {{0x98ab0087,0xb05b05ec,0xb6e4096b,0x60dd292c}},	//   fică_, ffär, люск, sesm,
   {{0x248901e0,0xa01b0019,0x6d408a53,0xaa57a92d}},	//   tcam_, nböz, onma, _пишу_,
   {{0x7aeaa92e,0x6d40a92f,0x81cd80c8,0x92bd00ab}},	//   _haft, nnma, রিখ_, _আসে_,
   {{0x24892930,0x7aeaa931,0x7ff701a8,0x6d40a932}},	// [17b0] rcam_, _kaft, _أسعا, inma,
   {{0xdbc78074,0x656d2933,0x24892934,0xdb098187}},	//   _tööp, smah, scam_, rreç,
   {{0x6b828098,0xc3338039,0x24891286,0xaca30133}},	//   _luog, נוע_, pcam_, _amụb,
   {{0x75242935,0x7aeaa936,0x9f5206c4,0x41d201a2}},	//   chiz, _laft, _aryè_, _सहरस,
   {{0x2571812b,0x5eaa80ab,0x3d0489c8,0x672380f1}},	//   _ušli_, চ্ছে, वाने_, thnj,
   {{0x44290010,0x6d40a937,0x141a01c6,0x63bf0037}},	//   mza_, enma, _חושב, muqn,
   {{0x7d0f0061,0xb89581a8,0x661881d6,0x777a9fa4}},	//   _kocs, _للأع, _čaká, _ditx,
   {{0x63a9a938,0x44292939,0x67238168,0x7a0a8085}},	//   tsen, oza_, shnj, rətl,
   {{0x6d5b8867,0x777a89cb,0x25a0812b,0x98ab0087}},	//   rlua, _fitx, ćila_, zică_,
   {{0x4429293a,0x765a80f1,0x7aea8bfe,0x777a8cdb}},	//   iza_, _fyty, _caft, _gitx,
   {{0x7aea8455,0x3ea7a93b,0x63a9a93c,0x7bcd0198}},	//   _daft, mant_, ssen, htau,
   {{0x3ea79702,0x63a98721,0x61f50ee1,0x27260129}},	//   lant_, psen, _mrzl, _kông_,
   {{0xa3e593d9,0x7d09920e,0x4429293d,0x88e300ab}},	//   _पनि_, mjes, jza_, যাংক,
   {{0x3ea7a93e,0x7d09a93f,0x44292940,0x98ab002e}},	//   nant_, ljes, dza_, tică_,
   {{0x7d0f2941,0x44292942,0x80d28b75,0xed5a24a4}},	//   _bocs, eza_, ण्डे, дов_,
   {{0xed431980,0x98ab0087,0x3d0483db,0x7d09a943}},	//   ансп, rică_, वाये_, njes,
   {{0x75ca8201,0xed570003,0x2726001c,0x7d0f0706}},	// [17c0] _vəzi, тот_, _nông_, _docs,
   {{0x693ca944,0x3ea7a945,0x752400b4,0x81bc80eb}},	//   nčev, jant_, shiz, dzēj,
   {{0x44290012,0x3ea7a946,0x7d1ba947,0x7d09a948}},	//   aza_, dant_, kkus, kjes,
   {{0x6ec4a6ee,0x272600ff,0x44292949,0xb87b294a}},	//   _राहु, _bông_, bza_, rdív,
   {{0x27260142,0x44290063,0xb91d01bc,0x2ba90ad5}},	//   _công_, cza_, _anyụ_, _चौपा,
   {{0x3ea7a94b,0xcf9300be,0xef19809a,0x272600ff}},	//   gant_, סטו_, _dużo_, _dông_,
   {{0x20008c6e,0x644e8085,0x7afe823e,0xdb0401df}},	//   ţii_, əbiy, _òpti, quiñ,
   {{0x7aea84dc,0x7d09a94c,0x7d1b8ec9,0xaacf909b}},	//   _saft, gjes, gkus, त्सक,
   {{0x3ea7a94d,0x6aa3a94e,0x6d408d1a,0xafe397c7}},	//   bant_, _benf, rnma, _котл,
   {{0x3ea7a94f,0x5186a950,0x2d6e801b,0xd764803d}},	//   cant_, кума, _přes_, _صنای,
   {{0xc333004c,0x691387d9,0x44292951,0xaad40c1c}},	//   שות_, _içer, zza_, ठ्यक,
   {{0x78a412f5,0x3f84a952,0x44292953,0x7bcd0084}},	//   _ceiv, _kumu_, yza_, ytau,
   {{0xead49641,0x99640071,0x3f849325,0x7c298035}},	//   _боль, ртэл, _jumu_, czer,
   {{0x7bc0a954,0x07a40048,0x3f8482ec,0x7f942218}},	//   mumu, раён, _mumu_, рарх,
   {{0x5faf0076,0x4b7b80be,0x3f848c2e,0xd37b8e82}},	//   _झटकल, _קאוו, _lumu_, _קרוט,
   {{0x44292955,0x7bcd24fb,0x3ea7a956,0xaac618b1}},	//   tza_, ttau, zant_, र्घक,
   {{0x2d580364,0x44292957,0x3ea7a958,0x8aa70b5b}},	// [17d0] тить_, uza_, yant_, вред,
   {{0xd5a48986,0x27e9026b,0x8c3d82bb,0x7bcd2959}},	//   _وہ_, _isan_, daşl, rtau,
   {{0x3ea7a95a,0x4429295b,0x68ed295c,0x8af78201}},	//   vant_, sza_, _kaad, _şəki,
   {{0x7bc0a95d,0x4429008e,0xb7d5846d,0x213901c6}},	//   kumu, pza_, _aṣaw, nish_,
   {{0x7bc0a95e,0x68ed295f,0x7d09920e,0x2ca92960}},	//   jumu, _maad, vjes, maad_,
   {{0x68ed2961,0x2ca90079,0x39ae8084,0xdce98267}},	//   _laad, laad_, kęs_, rmeč,
   {{0x3ea7a962,0x657d2963,0xed59a964,0x41e40084}},	//   rant_, _kish, нок_, _кіта,
   {{0x7983a965,0x3ea7a966,0x61fa0019,0x272600ff}},	//   _runw, sant_, _átla, _tông_,
   {{0x657d2967,0x7d09a968,0x60c98267,0xbcfb0013}},	//   _mish, rjes, _icem, _chéi,
   {{0x657d2647,0x63ad2969,0x78a4296a,0x645d296b}},	//   _lish, isan, _seiv, _mysi,
   {{0x68ed296c,0x7c298117,0xc6928158,0xa0a61ddf}},	//   _baad, szer, _האב_, ланд,
   {{0x3ea58f06,0x63ad296d,0x8c3d8182,0x657d296e}},	//   _helt_, ksan, laşm, _nish,
   {{0xb8ec131d,0x7bc0a96f,0x6d59a970,0x68ed2971}},	//   _ला_, cumu, _ikwa, _daad,
   {{0x2d85a972,0x63ad2973,0x248da974,0xf53981ac}},	//   _kule_, dsan, lcem_, liť_,
   {{0x27e92975,0x1dc6820e,0x63bb80eb,0x7ae1a976}},	//   _esan_, रूपत, lrun, melt,
   {{0x28d30076,0xaacf86de,0x68ed0ef2,0xf53981ac}},	//   ध्दि, त्रक, _gaad, niť_,
   {{0x69c1a977,0xb7be80c8,0x63ad2978,0x2fcd81c0}},	// [17e0] lule, _ইন্ট, gsan, _nqeg_,
   {{0x7ae1a979,0x29000282,0xb87b0019,0x81d680ab}},	//   nelt, _hnia_, rdít, সির_,
   {{0x2b898104,0x63bb8352,0x69c1a97a,0xe8d90028}},	//   _lúc_, hrun, nule, _nhớ_,
   {{0x645d2280,0x657d297b,0x6d598870,0x29120388}},	//   _fysi, _gish, _nkwa, _joya_,
   {{0x69c18fc4,0xf53981ac,0x7ae1a97c,0x63ad297d}},	//   hule, diť_, kelt, csan,
   {{0x6d441c30,0x6d59a97e,0x69c1a97f,0x6d5602ed}},	//   lnia, _akwa, kule, loya,
   {{0x63bb82af,0x25a082a5,0x657d0ab4,0xb87b2980}},	//   erun, ćilo_, _yish, ndír,
   {{0x69c1a981,0x7bc0a982,0x6d442983,0x39ae8110}},	//   dule, tumu, nnia, vęs_,
   {{0x68ed2984,0x63bb8a64,0xd90d8065,0x6d442985}},	//   _raad, grun, _تین_, inia,
   {{0x68ed2986,0x7bc0a987,0x29002988,0x6d562989}},	//   _saad, rumu, _ania_, hoya,
   {{0x69c19786,0x2912298a,0xdd8f8077,0x7bc0a98b}},	//   gule, _boya_, _فول_, sumu,
   {{0x68ed02c1,0x6d440069,0x2ca902a3,0x63ad298c}},	//   _qaad, jnia, xaad_, ysan,
   {{0x9cd78051,0x657d298d,0x68ed09f8,0x2900009a}},	//   _תודה_, _rish, _vaad, _dnia_,
   {{0x69dc298e,0x69c1a98f,0x2d858010,0x6d448110}},	//   _opre, bule, _yule_, čiau,
   {{0x69c1a990,0x693c8a2f,0x291200ee,0xfa558019}},	//   cule, nčes, _foya_, _پروگ,
   {{0x657d2991,0x6d562992,0x349501e5,0x636b2993}},	//   _qish, goya, раар, zünd,
   {{0x2ca91e94,0x27e91df5,0x2b89801c,0x9f400144}},	// [17f0] raad_, _usan_, _xúc_, _crió_,
   {{0x61f8811f,0xf5398038,0x6b5d8722,0x63a2a994}},	//   _krvl, ziť_, tègi, _mwon,
   {{0x6d442995,0x645d2996,0x7aee01c5,0x69dc2997}},	//   bnia, _wysi, _dabt, _cpre,
   {{0x417480f7,0x57f58568,0x2ba91513,0x645d0035}},	//   مانس, ипет, _चौथा, _tysi,
   {{0x69dc2998,0xf5398038,0x69c1a999,0x2d85a99a}},	//   _epre, viť_, zule, _sule_,
   {{0x7d0d299b,0xc5f980c8,0x2d85a99c,0xbcfb1727}},	//   ljas, _অথবা_, _pule_, _chév,
   {{0xf53981ac,0x28c603eb,0x2ba9000d,0x7c2d299d}},	//   tiť_, _वालि, _चौता, lzar,
   {{0xdb04299e,0x3ea582af,0xa3b90105,0xa3e92279}},	//   brió, _welt_, _घटा_, _मना_,
   {{0x7c2d299f,0xdcfa8029,0x7ae1a9a0,0xf53981ac}},	//   nzar, _attē, telt, riť_,
   {{0x69c1a9a1,0xadf7015c,0x63bba9a2,0x2d85837b}},	//   tule, ुमान_, rrun, _tule_,
   {{0x6d44031d,0x8e848013,0xf53981ac,0xa2ca06ce}},	//   ynia, _المه, piť_, स्ट्,
   {{0x69c1a055,0x63bba9a3,0x61f8817f,0x7ae1a9a4}},	//   rule, prun, _drvl, selt,
   {{0xe28e828b,0x53a582fb,0x6d4429a5,0x6d4481ac}},	//   _ма_, _талб, vnia, čiat,
   {{0x69c1a9a6,0xf7721ddd,0x38690239,0x6d4429a7}},	//   pule, تاج_, _dzar_, wnia,
   {{0xada61a8f,0xe8d90028,0x7aee16bb,0x442da9a8}},	//   рабл, _giữ_, _rabt, lze_,
   {{0x7aee29a9,0x06af80ab,0xef8615e0,0x7d0d1443}},	//   _sabt, চ্চি, _клип, gjas,

   {{0x69dc29aa,0x2d9829ab,0x6d4429ac,0xafe61878}},	// [1800] _spre, spre_, rnia, _топл,
   {{0x7aee02a3,0x6aa7026c,0x2561808b,0x442da9ad}},	//   _qabt, _cejf, fólk_, ize_,
   {{0x09e604fa,0xfc3f01ca,0x6d561149,0x7d0d026c}},	//   роен, _veía_, poya, bjas,
   {{0x316d83d3,0x442d8831,0xdb04188b,0x2900a38a}},	//   _chez_, kze_, trió, ñia_,
   {{0x7aee29ae,0x442da9af,0xe8d9001c,0x3d048075}},	//   _tabt, jze_, _nhờ_, वासे_,
   {{0x6b8480f7,0x442da9b0,0xd83f016b,0xe2970a42}},	//   _éigi, dze_, _účel_, _вар_,
   {{0xe1e78064,0x32070009,0x69dc00e1,0x6136017f}},	//   _بس_, änyt_, _upre, ršlj,
   {{0x7c3b02a5,0x6283a9b1,0x387f017f,0x7529a9b2}},	//   _žuri, _agno, žuri_, ghez,
   {{0x673c01c2,0x394682ba,0xe8d90028,0x6eb681a8}},	//   kirj, mnos_, _chờ_, _نصائ,
   {{0x3d0483b7,0xdb040118,0x7dfc8162,0x661c1235}},	//   वाहे_, oriñ, _păsă, kyrk,
   {{0x7980a9b3,0xdb098020,0x442d838a,0x7c2d0ca9}},	//   _kimw, gueñ, aze_, zzar,
   {{0x7529822e,0x3946a9b4,0x63a29528,0x6d4488fc}},	//   chez, nnos_, _twon, čias,
   {{0x442d8d38,0x7d02a9b5,0x63a2a9b6,0xdce88110}},	//   cze_, _inos, _uwon, _sudė,
   {{0xdced026f,0xa2c2000d,0x7bdb83c8,0xadc3826b}},	//   rmač, _लाग्, _סקוו, _alẹm,
   {{0xdb00a3fa,0xa6978039,0xeca70226,0x28d7a9b7}},	//   gsmå, שכלה_, ијан, ण्डि,
   {{0x7c2d29b8,0xdb0401df,0x80c1016f,0x39468019}},	//   tzar, driñ, _वाटे, jnos_,
   {{0x29e8002e,0x395929b9,0x7bc426f9,0x67da81a9}},	// [1810] _aşa_, moss_, guiu, nājā,
   {{0x7d0d29ba,0x3946a9bb,0xd543026b,0xa91d80c3}},	//   sjas, enos_, _bẹ́n, _miže,
   {{0x442da9bc,0x6ecd8beb,0x7c2d29bd,0x798080b4}},	//   zze_, _साबु, szar, _bimw,
   {{0x3946a9be,0xe45f0198,0xed4680d7,0x645d82f1}},	//   gnos_, _työ_, _رپ_, üsik,
   {{0x6126007b,0xa91d80ce,0x6d5d1400,0x693c81a1}},	//   _jóla, _niže, _iksa, tčer,
   {{0x66e582a9,0x39469f90,0xc69500be,0xdee59033}},	//   сока, anos_, זאַ_, соки,
   {{0x7afa008b,0xa3a9864a,0x2d680799,0x3f8917c9}},	//   _ótta, गीन_, ißen_, _luau_,
   {{0x442da9bf,0x4c698037,0x7ae508e5,0x69c51a08}},	//   tze_, лийн_, leht, muhe,
   {{0x3d080076,0xc9528bea,0x442da9c0,0x60dba9c1}},	//   हाते_, _זמן_, uze_, _ibum,
   {{0x442d8b04,0x7d028353,0x78a9a9c2,0xb87b29c3}},	//   rze_, _enos, _heev, teín,
   {{0x442da95b,0x5d8580f7,0x7529805d,0x673c007a}},	//   sze_, _الصل, phez, virj,
   {{0x612629c4,0x2d6802af,0xf09f077f,0xe8d900ff}},	//   _bóla, eßen_, gbà_, _thờ_,
   {{0xdb0981ca,0xed59807a,0x249f82df,0x3d04873c}},	//   sueñ, mož_, mbum_, वारे_,
   {{0x6d5d29c5,0x539a8051,0x612619ba,0x249fa9c6}},	//   _aksa, _עיצו, _dóla, lbum_,
   {{0xdb098c15,0x637012d2,0xd6270af0,0xe164003d}},	//   queñ, läng, боре_, _وضعی,
   {{0x6ab79094,0x2ba9000f,0x4c861d85,0x8a168039}},	//   _आयुर, _चौहा, слав, _לחצו_,
   {{0xd6c30019,0x798080b4,0x673c007a,0x63620187}},	// [1820] _کمپی, _rimw, pirj, lôni,
   {{0xadf985e8,0x27e00091,0x6ac600f7,0x6d5d17ab}},	//   ्मान_, _ipin_, إقام, _eksa,
   {{0x63700b2f,0x1efb00be,0x27ed86c4,0xed59a9c7}},	//   häng, _עלטע, _asen_, kož_,
   {{0xa2d80540,0xdb0429c8,0x78a98282,0x1d0a29c9}},	//   _नॉर्, rriñ, _ceev, _семи_,
   {{0x3946a82b,0xaab8026a,0x33b50a14,0x7bc429ca}},	//   rnos_, _نگار_, _мёрт, quiu,
   {{0x26ca29cb,0x7d028d11,0x656429cc,0x3946a720}},	//   ngbo_, _snos, llih, snos_,
   {{0x3d04800c,0xe7af009a,0x2d8229cd,0x877b03de}},	//   वाले_, _जौनप, _kike_, נאצי,
   {{0x27e029ce,0x71268277,0xf8b0803d,0x77868009}},	//   _opin_, _ارسل, _آکا_, _глаз,
   {{0x63701f0f,0x7d02807a,0xa3cb073c,0xa2d8001b}},	//   gäng, _vnos, रूप_, न्थ्,
   {{0x2d8229cf,0xaaa8036d,0x636203a7,0x7b39816b}},	//   _like_, गरिक, fôni, lňuj,
   {{0xd5b9835f,0xfbcf826a,0x712700f7,0x23a986a7}},	//   _всі_, وتی_, مرحل, चीबद,
   {{0x59c90e1a,0xa2d80023,0x7d028024,0x63701bc0}},	//   ांतर, न्त्, _unos, länd,
   {{0xa2d381fe,0xdc8e81bc,0x395929d0,0x26d829d1}},	//   _बॉक्, _dịtụ_, ross_, ffro_,
   {{0x43748077,0x4ac700d4,0x2d820300,0xe5c70a08}},	//   _بهتر, _लाइव, _aike_, йсбо,
   {{0xa3cb09c8,0xd0470085,0xe18980ff,0x2d821aad}},	//   रंभ_, _əməl, _hẳn_, _bike_,
   {{0x3eae8352,0x637012d2,0x2d820041,0x6aaaa9d2}},	//   haft_, händ, _cike_, _heff,
   {{0x2d8229d3,0x78a9a9d4,0x06e400ab,0xe50986a7}},	// [1830] _dike_, _reev, মাজি, वाति_,
   {{0x9a8706d2,0xbcfb29d5,0x2d8211ce,0x8c1b81c6}},	//   суал, _chér, _eike_, אומי,
   {{0x3cfe8076,0x78a9822c,0xa3a909f2,0xd91b99b8}},	//   _शोभे_, _peev, _गौर_, льд_,
   {{0x69c529d6,0x69c080d4,0x6aaa8198,0x5c070bac}},	//   ruhe, _विनी, _leff, _ляга,
   {{0xf7719168,0xd009a9d7,0xe8d911d3,0x6362041c}},	//   وات_, реле_, _nkọ_, zôni,
   {{0xa2d80bb8,0xb6a593b4,0x2d959016,0x6aaaa9d8}},	//   न्द्, цикл, орис, _neff,
   {{0x2129059c,0x171c0158,0xe8d919a8,0x78a9a9d9}},	//   _olah_, רווע, _akọ_, _teev,
   {{0x58d48e8e,0x60dba9da,0x6370016d,0xa63c0039}},	//   _ност, _ubum, täng, טגור,
   {{0x98178077,0x798a81ec,0x395f8102,0x6aaaa9db}},	//   _ابزا, _aufw, _ikus_, _beff,
   {{0x63700884,0xdb160009,0x63620187,0xe9d98eef}},	//   räng, styö, tôni, ако_,
   {{0x9f4901ec,0x7a699324,0x6aaaa9dc,0x637029dd}},	//   _spaß_, ринг_, _deff, säng,
   {{0x628300e1,0x637005ec,0x6362041c,0x6f05027d}},	//   ľnoh, mäne, rôni, _anhc,
   {{0x6d49a9de,0x2d8229df,0xbf87801c,0xeaaea9e0}},	//   mnea, _rike_, _điển_, _ой_,
   {{0xe299917c,0x1ddd80d4,0x321ea9e1,0xd5b800eb}},	//   _так_, _महात, byty_, šām_,
   {{0x6b83a9e2,0x395fa9e3,0x6d499b1f,0xad3a004a}},	//   _iing, _okus_, onea, ачає_,
   {{0x6d49954c,0x6b838f68,0x39b580eb,0x6b8ba9e4}},	//   nnea, _hing, mās_, _kugg,
   {{0x65640877,0x6f1729e5,0x6d498068,0x39b58029}},	// [1840] rlih, _foxc, inea, lās_,
   {{0x6b83a9e6,0x6b8ba9e7,0x6d498083,0xf77212c8}},	//   _jing, _mugg, hnea, _تاب_,
   {{0x63701918,0x39b58341,0x6b83a9e8,0xa3a98128}},	//   vänd, nās_, _ming, गीत_,
   {{0x6b83a9e9,0x752d29ea,0x69c1832f,0x80668081}},	//   _ling, chaz, irle, овеж,
   {{0x63700b2f,0x394d826c,0xbcfb0036,0x69c181ec}},	//   tänd, _djes_, _thér, hrle,
   {{0x6b83a9eb,0xd5ba84ad,0x39b58029,0x394da9ec}},	//   _ning, аси_, kās_, _ejes_,
   {{0x39b58341,0x637029ed,0x44200019,0x386d9403}},	//   jās_, ränd, lyi_, _ezer_,
   {{0x6d499581,0x6b83a9ee,0x39b580eb,0x6370016d}},	//   gnea, _aing, dās_, sänd,
   {{0x442029ef,0x6b83a9f0,0x25a9805c,0x73fa80ab}},	//   nyi_, _bing, ćala_, েন্ট_,
   {{0x37d000ab,0x2129111e,0xda7aa3e7,0xa3cb0ad5}},	//   িবার, _slah_, иян_, रंत_,
   {{0x39b580eb,0xaacf047d,0x9258a9f1,0x28f91b53}},	//   gās_, स्टक, сант_, бень_,
   {{0x394d0003,0x6b839546,0xe8d90028,0x6b8ba9f2}},	//   ões_, _eing, _phố_, _fugg,
   {{0xb97b812a,0x442002a0,0x2129026c,0x6b8ba9f3}},	//   ינטי, jyi_, _vlah_, _gugg,
   {{0x7d060110,0x4432009a,0x39b581a9,0xa49b07f1}},	//   _anks, dzy_, bās_, _enòl,
   {{0x2129015d,0x752d005d,0x39b580eb,0x612629f4}},	//   _tlah_, thaz, cās_, _gólo,
   {{0x6d40a9f5,0x6b83a9f6,0x212901bf,0x4add0a27}},	//   nima, _zing, _ulah_, न्नव,
   {{0x2d8c812b,0x6b83a9f7,0x44200019,0x61260118}},	// [1850] _lude_, _ying, gyi_, _móll,
   {{0x6d40a883,0x2d8c8a0f,0x74150019,0x6b83a9f8}},	//   hima, _oude_, _ہوجا, _xing,
   {{0x6d40a9f9,0x69c8a9fa,0x7c20831d,0x752d0234}},	//   kima, nude, hymr, phaz,
   {{0x6d4081e2,0xdb098013,0x7c208aa2,0x442000b4}},	//   jima, iseá, kymr, byi_,
   {{0x44320063,0x6d40a9fb,0x3d08000f,0x2d8ca9fc}},	//   czy_, dima, हारे_, _aude_,
   {{0x2d8ca9fd,0x78ad29fe,0x68fa00eb,0x3eba00ee}},	//   _bude_, _leav, ētdi, _xdpt_,
   {{0x6d408079,0x69c8a9ff,0x6b8b914e,0x6d498cb5}},	//   fima, jude, _sugg, tnea,
   {{0x6b83aa00,0x395f8024,0x39b580eb,0x6126002a}},	//   _sing, _ukus_, vās_, _cóll,
   {{0x6b83aa01,0x3eac806a,0x7f5c0216,0xb4e91d40}},	//   _ping, _fedt_, yorq, _यसै_,
   {{0x39b58029,0x49c994bc,0x27ffaa02,0x6d498c49}},	//   tās_, блон_, _irun_, snea,
   {{0x644d81e2,0x6b83aa03,0xc4cb009a,0x44322a04}},	//   _žaid, _ving, िलाओ, zzy_,
   {{0x69c18915,0x70c6016f,0xdce99487,0x39b580eb}},	//   rrle, वलेल, dmeć, rās_,
   {{0x3f85aa05,0x39b581a9,0x3f8d8980,0x7f5c1d5e}},	//   _kilu_, sās_, _jueu_, torq,
   {{0x2d9611c7,0x7d19aa06,0x69c8aa07,0x6b838010}},	//   зрас, _hows, bude, _uing,
   {{0x80ab0a49,0xe737138f,0x78bb805c,0x69d7022c}},	//   _কার্, чер_, _oduv, jtxe,
   {{0x80da00ab,0x3f85aa08,0x44322a09,0x78ad01ed}},	//   _বোর্, _lilu_, tzy_, _geav,
   {{0x75242a0a,0xc1db80d4,0x3b182a0b,0x7af50102}},	// [1860] rkiz, _बहुग, _porq_, _bazt,
   {{0x44321d21,0x6d40aa0c,0x39422a0d,0x3f85930c}},	//   rzy_, zima, liks_, _nilu_,
   {{0x27308104,0xe9da2a0e,0x44320063,0x68f62a0f}},	//   _hàng_, ске_, szy_, _kayd,
   {{0x3f8d81df,0xd910804e,0x39422a10,0x68f62a11}},	//   _bueu_, خیر_, niks_, _jayd,
   {{0x6d40aa12,0x68f619d4,0xa3cb0424,0x78a2aa13}},	//   vima, _mayd, रूद_, rbov,
   {{0x7af500ad,0x2d8caa14,0x273080ff,0x28d186a7}},	//   _gazt, _pude_, _màng_, _हाथि,
   {{0x91e32a15,0x6d40aa16,0x09e30811,0x7d1981e0}},	//   _поре, tima, _порн, _bows,
   {{0x539889b5,0xdb98a64e,0x69c88687,0x2cb201b4}},	//   овия_, ович_, vude, nayd_,
   {{0x27308028,0x7bc9aa17,0x7ae89b4a,0x63b6006f}},	//   _nàng_, gueu, tedt, nsyn,
   {{0x59d00063,0xaacc2a18,0x6d40aa19,0x798e0a8c}},	//   _हमार, ालिक, sima, _kubw,
   {{0xc4869895,0x6d40aa1a,0x68f60079,0x78ad0074}},	//   _елек, pima, _bayd, _peav,
   {{0x6f1aa817,0x68f601b4,0xa91d80c3,0x27308129}},	//   _hotc, _cayd, _ližn, _bàng_,
   {{0xc05b0196,0xb4e88074,0x27308028,0x69c8aa1b}},	//   сін_, मजी_, _càng_, sude,
   {{0x2730801c,0x7bc40084,0xdb098144,0x69c8aa1c}},	//   _dàng_, driu, breñ, pude,
   {{0x68f603bf,0x78ad1b17,0x7bc40074,0xa4d50b73}},	//   _fayd, _teav, eriu, мові,
   {{0x7bc40037,0x5ec58264,0x68f610ba,0x8d7405de}},	//   friu, ল্পে, _gayd, فاقا,
   {{0x6c5423e0,0xdcfa8029,0xc1580051,0x31ae80ab}},	// [1870] екту, _attī, _משהו_, _কমিশ,
   {{0x798e03f7,0x60dd2a1d,0x6f1a9e44,0x00000000}},	//   _bubw, lfsm, _notc, --,
   {{0xa3b906af,0x79a419a5,0xa2cf8540,0x69c80163}},	//   _घटक_, ерче, _दास्, _ådel,
   {{0x9c13819d,0x3f8584ef,0x81df0264,0x68f62a1e}},	//   _kọti, _silu_, তিল_, _xayd,
   {{0xe0d08f24,0x7bc4009f,0x7d199770,0x6d4d02f1}},	//   ازم_, criu, _rows, mnaa,
   {{0xdb1b8548,0x05b1016f,0xdce181b9,0x82371e29}},	//   truí, _जबाब, _kulħ, _فرزا,
   {{0x25a982a5,0x7d19809a,0x6d4d2a1f,0xc5d58a4c}},	//   ćalo_, _pows, onaa, філь,
   {{0x6d4d2a20,0x27ff826c,0xe8d9001c,0xa3e10072}},	//   nnaa, _trun_, _khổ_, _दहा_,
   {{0x47d58013,0x3f85aa21,0x68eb8bda,0x6ece016f}},	//   _زيار, _tilu_, megd, _तालु,
   {{0x81c200c8,0x29092a22,0x80d9800c,0x273080ff}},	//   ্বর_, _anaa_, फ्रे, _ràng_,
   {{0x68f62a23,0x13e600c8,0x39422a24,0x1dc68424}},	//   _payd, নিয়, tiks_, रूआत,
   {{0xd7d1aa25,0x254580eb,0x68f60085,0xe7d181a2}},	//   _समाच, tēlu_, _qayd, _समाप,
   {{0x636b080a,0x39422a26,0x69c501ec,0x7bc98036}},	//   tünl, riks_, hrhe, queu,
   {{0x27308028,0x68f60079,0x6d4d2a27,0x6569805f}},	//   _vàng_, _wayd, enaa, lleh,
   {{0x212d848f,0x4ac700d4,0xa91d8bcf,0x63700106}},	//   _oleh_, _लाजव, _nižo, jäna,
   {{0x6d4d2a28,0x273080ff,0xadf08074,0x798e018f}},	//   gnaa, _tàng_, _अईसन_, _rubw,
   {{0xd467067c,0x04432118,0x3b8601e8,0x6b8700f3}},	// [1880] дите_, ветн, длаг, _bijg,
   {{0x63b60aa2,0x212d8118,0xdcfd00eb,0xd7760b53}},	//   rsyn, _aleh_, _visā, _تابع,
   {{0x212d83ac,0x2eaa016f,0xfe7201a8,0x63b62a29}},	//   _bleh_, करीत, _جدة_, ssyn,
   {{0xeb9f0aa2,0x7bc413bf,0x2d5701b9,0x53a90072}},	//   _brød_, priu, għed_, _चौकश,
   {{0x69c503b2,0x6f1aaa2a,0x9f4907f1,0xd84f019d}},	//   arhe, _potc, _graó_, lọra_,
   {{0x212d80b9,0xdd9a9577,0x2d868114,0xa91d82d4}},	//   _eleh_, оши_, _sioe_, _fižo,
   {{0x66e00074,0xdce4016b,0x80cf001b,0xa3b0aa2b}},	//   ख्यक_, hlič, _थाले, टीन_,
   {{0x6ba5016d,0xdce4007a,0x9c1381bc,0xe73f041c}},	//   _åtgä, klič, _nọsi, mpõe_,
   {{0xf8639485,0x7c242a2c,0xd8d78158,0xa3a98072}},	//   _авто, nyir, _קומט_, गील_,
   {{0x61260125,0x394002be,0x7f4381e8,0xdce4016b}},	//   _fólk, _amis_, cinq, dlič,
   {{0x8e4a80f7,0x656981e0,0x28f92a2d,0xa2cf8cf0}},	//   _بلاك_, bleh, пень_, _दार्,
   {{0xf3888028,0x212d80ee,0xfd4f81bc,0x0c26802e}},	//   _lợi_, _xleh_, _mejọ, _омен,
   {{0x1bf289a3,0xdce4026f,0x60dd007b,0x28d1a0d5}},	//   _अनिल_, glič, rfsm, _हासि,
   {{0xf53f13c2,0x399383a7,0x4424809a,0x636f8aa2}},	//   _små_, _fãs_, mym_, lønn,
   {{0x1df811e9,0x4424aa2e,0x569402d3,0x6d4d2a2f}},	//   меры_, lym_, таст, tnaa,
   {{0xdce41024,0x7af8aa30,0xa91d8988,0xe8d9001c}},	//   blič, _havt, _rižo, _phổ_,
   {{0x4424aa31,0x4ea7143d,0x6d4d2a32,0x7af881c0}},	// [1890] nym_, _орна, rnaa, _kavt,
   {{0xdb1606c0,0x656081a8,0x2fc6aa33,0x2d9e806a}},	//   nsyè, homh, drog_, _otte_,
   {{0x69da8009,0x212d81f4,0x69cf8035,0x29d88866}},	//   ntte, _pleh_, ąceg, néa_,
   {{0x69da8364,0x3cfe80d4,0x7c2400b4,0xe8d900ff}},	//   itte, _शोले_, byir, _thổ_,
   {{0x7feb87bd,0x93270b76,0x68ebaa34,0x6370089c}},	//   تراف_, _قرآن, regd, männ,
   {{0x4424831d,0x7d1d0019,0x7af8aa35,0x7df38085}},	//   dym_, _hoss, _navt, _həsə,
   {{0x628301ac,0xf388801c,0x212d82d4,0x7f43811c}},	//   ľnos, _gợi_, _tleh_, rinq,
   {{0x6283105e,0x2fc6805c,0x7d1d0364,0x98a01487}},	//   žnos, brog_, _joss, _ilić_,
   {{0x7d1d2a36,0x7df38201,0x2d9e8006,0x3d048540}},	//   _moss, _məsə, _ette_, वाजे_,
   {{0x8c9f80d4,0x3f9f808e,0x7af88115,0x6569aa37}},	//   _ग्रो, _ituu_, _cavt, sleh,
   {{0xa96a18ba,0xcb1204de,0x63701af3,0x38690b8e}},	//   зина_, אלי_, känn, _ayar_,
   {{0x7d1d0003,0xfe6e803d,0xdce4007a,0x4424939f}},	//   _noss, _اگه_, tlič, bym_,
   {{0xb4278c2a,0x4424809a,0xdce40289,0x7d0b80d7}},	//   _تعاو, cym_, ulič, _ings,
   {{0xdb1b8e14,0x75298019,0x798981b0,0x8c1a825f}},	//   bruá, lkez, _liew, _מוני,
   {{0x7bdbaa38,0xdd920277,0x3d04816f,0x6146031a}},	//   ltuu, اور_, वाचे_, _пека,
   {{0x7989809a,0x7d1d2a39,0xdce41320,0x5ec10264}},	//   _niew, _coss, plič, শ্লে,
   {{0x7d1d2a3a,0x98a0190f,0x7bdba3df,0x68e42a3b}},	// [18a0] _doss, _alić_, ntuu, _ibid,
   {{0x7d0b82f7,0x3ced822c,0x425623d7,0x272b8163}},	//   _lngs, heev_, нтет, _sønn_,
   {{0x7d1d1260,0x3cfb0c28,0x3f920010,0xe8d9001c}},	//   _foss, _लोके_, _huyu_, _chỗ_,
   {{0x69c305e4,0x7bdbaa3c,0x2fc68d2f,0x59d206af}},	//   ánea, ktuu, trog_, दंबर,
   {{0x68e40135,0x7f469663,0xd43600f7,0xe73f0187}},	//   _mbid, недж, _أعجب, spõe_,
   {{0x69daaa3d,0xa8478b53,0x442484e8,0x57f38eef}},	//   ytte, علوم_, vym_, упшт,
   {{0x44248063,0x61262a3e,0x68e42a3f,0x63a42a40}},	//   wym_, _eóli, _obid, lpin,
   {{0x612603b0,0x7d1d01df,0x68e42a41,0x98a92a42}},	//   _fóli, _xoss, _nbid, _plač_,
   {{0x3946aa43,0x27340106,0x63a42a44,0x849780f7}},	//   mios_, _känd_, npin, رئيس_,
   {{0x656086be,0x39468196,0x68e42a45,0x3075aa46}},	//   somh, lios_, _abid, _русс,
   {{0xc3331dce,0x19590a14,0x2bc29244,0xfbc2aa47}},	//   רות_, даны_, _शिवा, _शिवम,
   {{0x3946aa48,0x69daaa49,0x98a900e1,0x6374823e}},	//   nios_, rtte, _tlač_, fànc,
   {{0x7d1d2a4a,0x629c00f1,0x7bdb80f3,0x628e04be}},	//   _ross, _ofro, ctuu, _ogbo,
   {{0x68e40146,0x6566008e,0x999e8019,0x254c81d0}},	//   _ebid, _akkh, sztő_, děli_,
   {{0x7d1d2a4b,0x39468110,0x7d0baa4c,0x80a21b7e}},	//   _poss, kios_, _yngs, _क्वे,
   {{0x9d180fe7,0x59c5800c,0xc4cb06b7,0x628e18b2}},	//   ност_, _वितर, िलेख, _agbo,
   {{0x39469984,0xeb93030f,0xf2c704ad,0xdb0d03a7}},	// [18b0] dios_, اظر_, есен, nsaç,
   {{0x69c882d8,0xdb0d2868,0x7989a180,0xd011804e}},	//   orde, trañ, _siew, یلا_,
   {{0xa2d88b6f,0x2004aa4d,0xa7fd8019,0x3946aa4e}},	//   _मान्, _armi_, _gyűj, fios_,
   {{0x68fd2a4f,0x3946aa50,0x69c88635,0x628e0135}},	//   ndsd, gios_, irde, _egbo,
   {{0x79898051,0x2ca91e7a,0x69c8aa51,0x80098019}},	//   _view, mbad_, hrde, براہ_,
   {{0x2d8b0264,0x2ca90bb1,0x3669a09a,0xb87b0144}},	//   _hice_, lbad_, мало_, leís,
   {{0x75298065,0x8d558729,0x7d0b826c,0xed59a45b}},	//   tkez, ктич, _pngs, мок_,
   {{0x394690dd,0x7bdb8198,0x68fd2a52,0x2ca92a53}},	//   cios_, ttuu, jdsd, nbad_,
   {{0x80a22a54,0x7529aa55,0x69c880c9,0x2d932a56}},	//   _क्षे, rkez, erde, _luxe_,
   {{0x2d8b003b,0x7bdbaa57,0x3eb32a58,0x69ca03a7}},	//   _lice_, rtuu, _next_, áfeg,
   {{0x7bdb8f1a,0x81df00c8,0x68fbaa59,0x27e904a7}},	//   stuu, তিক_, _kaud, _apan_,
   {{0x61460b9c,0x2eaa04c5,0xfeac877f,0x63748722}},	//   тема, कर्त, _iṣẹ_, tànc,
   {{0x69c89699,0x656d026f,0x20042a5a,0x68fbaa5b}},	//   arde, dlah, ími_, _maud,
   {{0x2d8b0083,0x27e900dd,0x80a20701,0x3946aa5c}},	//   _aice_, _dpan_, _क्रे, zios_,
   {{0xa3d4035a,0x63bd0186,0x2d8b2a5d,0x1659245b}},	//   सून_, _avsn, _bice_, ерть_,
   {{0x2be5959a,0x291f802e,0x68fbaa5e,0x394684c3}},	//   _कहां_, _noua_, _naud, xios_,
   {{0x3cf4881f,0xb87b07e0,0x63bbaa5f,0x3946a581}},	// [18c0] ्यते_, rfíc, nsun, vios_,
   {{0x63a42a60,0x6f1e02ce,0x5fb70039,0x81e480ab}},	//   rpin, _uopc, _שהיא_, নির_,
   {{0x39468511,0x63a42a61,0x68fb9482,0x2d8b0041}},	//   tios_, spin, _baud, _fice_,
   {{0x63a42a62,0x3eb81be3,0xd5b80029,0xc7c69d79}},	//   ppin, lart_, šās_, вски,
   {{0x3946aa63,0x68fbaa64,0x291f8012,0x2d802a65}},	//   rios_, _daud, _doua_, mmie_,
   {{0x394681e2,0x63bbaa66,0xfaa31957,0x2d8b0087}},	//   sios_, dsun, _варо, _zice_,
   {{0x39469f5c,0x41aa0221,0x68fb80e7,0x7afc0af6}},	//   pios_, _іван_, _faud, _iart,
   {{0x7afc2a67,0x29dc040e,0x68fbaa68,0x3eb80046}},	//   _hart, mía_, _gaud, hart_,
   {{0x29dc2868,0x63bbaa69,0x06b800ab,0x3eb82a6a}},	//   lía_, gsun, _জানি, kart_,
   {{0x68fbaa6b,0x7afc0102,0x77638118,0xc1808135}},	//   _zaud, _jart, conx, _ịghọ,
   {{0x27e901b0,0x29dc040e,0x69c880c9,0x7c3a0201}},	//   _span_, nía_, urde, _ətra,
   {{0xdca6902f,0x7afc020f,0xf8bf0019,0x64a69957}},	//   _ради, _lart, mkék_, _рада,
   {{0xb8eb0076,0xdb04040e,0xb4ae9d7c,0x29dc2a6c}},	//   _लय_, nsió, करी_, hía_,
   {{0x0ccb0b85,0xcf9380be,0x63a282b8,0x3eb82a6d}},	//   िल्म, יטש_, _iton, gart_,
   {{0xd5b80be1,0x80d3800f,0x29dc01ca,0xb8d90264}},	//   кст_, _डाले, jía_, _চা_,
   {{0x29dc02ba,0xa3e6816f,0xdb1b8073,0x7afc2a6e}},	//   día_, _पहा_, truç, _aart,
   {{0x3eb32a6f,0x3eb80502,0x5c750b01,0x656d0057}},	// [18d0] _text_, bart_, улат, rlah,
   {{0x29dc040e,0x7afc2a70,0xe4e281c4,0x69de1c33}},	//   fía_, _cart, क्ति_, ftpe,
   {{0x9a872a71,0x29dc0c15,0x2d8b0025,0xaca301bc}},	//   туал, gía_, _tice_, _alụb,
   {{0x63a2aa72,0x59c59834,0x7afc167c,0x23c2825a}},	//   _oton, _विसर, _eart, _शिंद,
   {{0xb8db8424,0x3f8c81b9,0x69dc2a73,0x63a28542}},	//   _आज_, _bidu_, _eqre, _nton,
   {{0x7afc2a74,0x29dc040e,0x44292a75,0x543a00be}},	//   _gart, bía_, mya_, _טערא,
   {{0x29dc040e,0x63a2aa76,0x74d78035,0x02af2076}},	//   cía_, _aton, _यादृ, टरीन,
   {{0x7afc2a77,0x7bc9aa78,0x16b00105,0x752d01f6}},	//   _zart, treu, _जज्ब, nkaz,
   {{0xa855a796,0x7bc980e7,0x0ed300d4,0xbab581bb}},	//   _скач, ureu, _तांड, лёны,
   {{0x63bbaa79,0x89a9891c,0x386daa7a,0x7bc9aa7b}},	//   rsun, нков_, _iyer_, rreu,
   {{0x63bbaa7c,0x44292a7d,0x3eb82a7e,0x63a2aa7f}},	//   ssun, hya_, vart_, _eton,
   {{0x7fd605e9,0x44292a80,0x7bc9802e,0x798d02f7}},	//   лігі, kya_, preu, _ciaw,
   {{0xa2e587b6,0x59c594a7,0x6721aa81,0x44290578}},	//   _болд, _विवर, _kolj, jya_,
   {{0x3cfd81c0,0x7d1baa82,0x6d49aa83,0xa03a83de}},	//   _hawv_, ljus, liea, געשפ,
   {{0xceb29a0f,0xa2d88913,0x29dc07f4,0x3cfd81c0}},	//   מים_, _मात्, xía_, _kawv_,
   {{0x7afc2a84,0xb4ce2a85,0x29dc040e,0xb4c00c33}},	//   _sart, रले_, vía_, ीले_,
   {{0x7c29aa86,0x7c3baa87,0x44292a88,0x3eb81a1f}},	// [18e0] nyer, nzur, gya_, part_,
   {{0x57fb0051,0x3cfd90af,0x7d1b8006,0x7afc00f1}},	//   _טלפו, _lawv_, hjus, _qart,
   {{0x7afc0b71,0x386d85b4,0xf77200d5,0xdce28743}},	//   _vart, _ayer_, _پاک_, _skoč,
   {{0x29dc161b,0x7afc2a89,0x44292a8a,0x3cfd8069}},	//   ría_, _wart, bya_, _nawv_,
   {{0x7afc2a8b,0x6d460182,0x29dc02ba,0x23658042}},	//   _tart, _imka, sía_, kolj_,
   {{0xa2d88fe4,0xdb04160a,0x29dc2a8c,0x78b60216}},	//   _माध्, rsió, pía_, _leyv,
   {{0xf41f825d,0x7afeaa63,0x672180ce,0x3d8a8198}},	//   ään_, _ópti, _dolj, нщин_,
   {{0xb4ae89a3,0x60c42a8d,0x3cfd8069,0x80d6016f}},	//   करे_, _ndim, _cawv_, _भाषे,
   {{0x7c299fce,0x3cfd81c0,0x6721a909,0x14d5866b}},	//   gyer, _dawv_, _folj, _धारण,
   {{0xa3b585b3,0xef83867c,0x60c42a8e,0x2365911b}},	//   _जबर_, _глуп, _adim, golj_,
   {{0xe6938307,0x6e938013,0x5e938013,0x41551016}},	//   _المد, _الما, _المط, ивос,
   {{0x44292778,0x3cfd81c0,0x7c29a42d,0x67218267}},	//   yya_, _gawv_, byer, _zolj,
   {{0x63a2aa8f,0x752d2a90,0x69c090be,0x386d0366}},	//   _uton, vkaz, _विकी, æer_,
   {{0x88bd809a,0x7bfb8039,0x7dea8085,0x4429004f}},	//   _kośc, _נפוצ, _təsd, vya_,
   {{0x2bc71834,0x4429010c,0xd2b783c8,0x6aba9a20}},	//   _लिहा, wya_, _גלות_, matf,
   {{0x44292a91,0x7982809a,0x06c600ab,0x752d01d6}},	//   tya_, jmow, শ্লি, ukaz,
   {{0x752281c0,0x44290176,0xdb04002a,0x394b2a92}},	// [18f0] _mooz, uya_, esiñ, mics_,
   {{0xd25b0ab2,0x44292a93,0x394b2a94,0x752d0010}},	//   нце_, rya_, lics_, skaz,
   {{0x3207026f,0xeb9f0edd,0xdb580009,0x7c3b81e8}},	//   íny_, _grøn_, уют_, zzur,
   {{0x20092914,0xb4ae83ca,0x394b2a95,0x7c3b8035}},	//   _krai_, करो_, nics_, yzur,
   {{0xe8d90028,0x06b800ab,0xb9658032,0x3cfd8282}},	//   _chứ_, _জাতি, _adìé, _rawv_,
   {{0x3cfd81e9,0x92940048,0x8cad01d0,0x394b1e44}},	//   _sawv_, _гарц, जरको, hics_,
   {{0x23658353,0x3cfd81c0,0x7bcd008b,0x61ed8b80}},	//   volj_, _pawv_, lrau, _ćalo,
   {{0x20090110,0x7c29aa96,0x7c3baa97,0xf8b986ae}},	//   _orai_, tyer, tzur, _उजिय,
   {{0x75ec0065,0xa3cb0540,0x36d5aa98,0x394b2a99}},	//   _közö, रंट_, _возр, dics_,
   {{0xff538013,0xef678098,0x81e800ab,0x7c298d18}},	//   _اخر_, _събо, বির_, ryer,
   {{0x394b2a9a,0x88bd809a,0xb0b983eb,0x7bcd232a}},	//   fics_, _gośc, _उजाग, hrau,
   {{0x637000f2,0x291d9ae4,0x394b0722,0x7bcd2a9b}},	//   tänk, njwa_, gics_, krau,
   {{0xa0760071,0x273989c4,0x23658b80,0xe7b389ab}},	//   рынш, _cèng_, polj_, _ƙaƙƙ,
   {{0xfaa59abe,0x82a58364,0x7bcd2a9c,0x20092a9d}},	//   _тако, _такж, drau, _drai_,
   {{0x29560698,0x63a9aa9e,0x99d700ab,0x28a721e3}},	//   _въпр, lpen, সবুক, _क्वि,
   {{0xf3888104,0x27edaa9f,0x63a9aaa0,0x2d8f82d6}},	//   _hợp_, _open_, open, _jige_,
   {{0x63a9aaa1,0x2912019d,0x7bcd2aa2,0x290012d0}},	// [1900] npen, _inya_, grau, _iaia_,
   {{0x2d8faaa3,0x60dbaaa4,0x29122aa5,0x68e9aaa6}},	//   _lige_, _acum, _hnya_, _abed,
   {{0xa2d880d4,0xe9da0604,0x80a68c2a,0xaadd858c}},	//   _मास्, тке_, لمان, _मानक,
   {{0x7bcd2aa7,0xa3e68bb8,0x3be586a7,0xdb04002a}},	//   brau, _पहल_, _कहूँ_, rsiñ,
   {{0xdefa8364,0x7982809a,0x7600aaa8,0xbcfb0091}},	//   вый_, rmow, kázá, _akéw,
   {{0x2d8f8ad0,0xd00f9a37,0x29002aa9,0xe80703eb}},	//   _aige_, بله_, _laia_, शिता_,
   {{0x636b05c5,0xd5b794ef,0x6d560079,0x2d8faaaa}},	//   rünt, асы_, onya, _bige_,
   {{0xe8d90028,0x6d562aab,0xa3ea0327,0x29002aac}},	//   _thứ_, nnya, _महा_, _naia_,
   {{0x8fa39383,0x61e90024,0x63a9aaad,0x2d8f8326}},	//   _мате, _ćeli, gpen, _dige_,
   {{0x29120a2c,0x8ca680d4,0x29020079,0x320a016b}},	//   _anya_, _ट्रो, edka_, _krby_,
   {{0x2bc29199,0x6d562aae,0x29002aaf,0x7522826c}},	//   _शिका, knya, _baia_, _tooz,
   {{0x38c9026a,0xdd8f806b,0x29002ab0,0x5fba86a7}},	//   دادی_, _قول_, _caia_, _उबाल,
   {{0xc05b0163,0xe53b8051,0x2006aab1,0x2912008e}},	//   тін_, _בתאר, nvoi_, _dnya_,
   {{0x28a70aed,0x29122ab2,0x394b2ab3,0x200902be}},	//   _क्रि, _enya_, sics_, _vrai_,
   {{0x68ff2ab4,0x68930077,0x3cdd864a,0x29002ab5}},	//   _taqd, _ویدئ, क्के_, _faia_,
   {{0x7bcd2ab6,0x20090028,0x29000102,0xc0cb0178}},	//   trau, _trai_, _gaia_, _руке_,
   {{0x39490025,0xe4f9aab7,0x3cde8035,0x44980198}},	// [1910] _imas_, ्यति_, _गाने_, рвую_,
   {{0x27340006,0x6d562ab8,0x60db8087,0xfaa70196}},	//   _täna_, anya, _scum, ршан,
   {{0x81e480ab,0xa3cb11bc,0xa2dd125f,0x63a98102}},	//   নিক_, रूज_, _पाठ्, zpen,
   {{0x2912008e,0x27398036,0x637daab9,0x21248427}},	//   _xnya_, _mène_, mène, _comh_,
   {{0x838711e9,0x2d8faaba,0x98e481a8,0x21248427}},	//   _выве, _rige_, تكنو, _domh_,
   {{0x2d8faabb,0x394901c0,0x7bc0874d,0x2d84862c}},	//   _sige_, _lmas_, dsmu, emme_,
   {{0x80c200c8,0x2cadaabc,0x78bd2abd,0x2d8f806a}},	//   ষ্ট্, tbed_, kasv, _pige_,
   {{0x2608035a,0x28a70a3a,0x68e982ee,0x58d48f27}},	//   हिती_, _क्लि, _ubed, _мост,
   {{0x7c2d2abe,0x40349ccf,0xe29982df,0x2cadaabf}},	//   nyar, _детс, лап_, rbed_,
   {{0x7de7835f,0x39492ac0,0xf5e780e8,0x29002ac1}},	//   _відд, _amas_, _відм, _saia_,
   {{0xa2d8aac2,0xe8d90028,0x291209da,0x7c2d2ac3}},	//   _मार्, _chữ_, _pnya_, hyar,
   {{0x637005ec,0x3cde86a7,0x6d9581d6,0x049581a8}},	//   räni, _गाये_, _všad, _الإح,
   {{0x290001df,0x6c8580f7,0xdced082c,0x7c2d0314}},	//   _vaia_, _الشم, jmađ, jyar,
   {{0x3949059c,0x442daac4,0xdced011c,0x6d50866f}},	//   _emas_, mye_, tmağ, ądał,
   {{0x442daac5,0xe5a60628,0x6f01aac6,0x29120359}},	//   lye_, сиби, _malc, _tnya_,
   {{0x6d4d16d5,0xdced2ac7,0x29122ac8,0xe0da04ae}},	//   giaa, rmağ, _unya_, _сви_,
   {{0x442daac9,0x7c2d0065,0x443faaca,0xec7a16d9}},	// [1920] nye_, gyar, nzu_, упа_,
   {{0xa2dd1f64,0x8a3a0009,0x7c248014,0x5fd18072}},	//   _पाण्, ляет_, _àire, _समजल,
   {{0xb4f981ab,0xd9108077,0xdce400ce,0x442d8168}},	//   ्याय_, ویس_, jlić, hye_,
   {{0x7c2d29b3,0x6d4d0a0f,0x442daacb,0x69c1aacc}},	//   byar, ciaa, kye_, isle,
   {{0xa2d8908a,0x572509a7,0x291283bf,0x442d8c97}},	//   _माल्, _طریق, ıya_, jye_,
   {{0x7d04103d,0x443f80eb,0x442daacd,0x290088fc}},	//   ldis, dzu_, dye_, žia_,
   {{0xe7f48b85,0xa2dd09c2,0xa3d40540,0x9c13819d}},	//   _इनका_, _पात्, सूर_, _gọzi,
   {{0x7d042ace,0xc0e39d51,0x442d8247,0x7bc68110}},	//   ndis, _носк, fye_, škum,
   {{0x442daacf,0x7d042ad0,0x78a2816b,0x6f01aad1}},	//   gye_, idis, mcov, _falc,
   {{0xdced012b,0x7d040009,0x78a2816b,0xd6d28bbe}},	//   vlač, hdis, lcov, _رقص_,
   {{0x69c1a10f,0x9952001b,0x442daad2,0x78bd2ad3}},	//   gsle, lář_, aye_, tasv,
   {{0x78a2803e,0x442da0d7,0xd25786b5,0x753b8010}},	//   ncov, bye_, сць_, chuz,
   {{0x7d042ad4,0x67250364,0xc8671194,0x506711b1}},	//   ddis, _pohj, стни, стна,
   {{0x6d5a2ad5,0x7bd62ad6,0xd6d80a42,0xa85781c6}},	//   étan, duyu, йтс_, מיכה_,
   {{0xdced0289,0x6d4d2ad7,0x80d88f3d,0x9577003d}},	//   slač, tiaa, डलाइ, مدرض,
   {{0x2d9a2ad8,0xdced0353,0x394903a7,0x7d042ad9}},	//   _dupe_, plač, _umas_, gdis,
   {{0xac18210d,0x241813cd,0x6d4d2ada,0xa3d40c28}},	// [1930] боту_, боты_, riaa, सूल_,
   {{0x6d4d2adb,0x70d18105,0x7c2d2adc,0x7d02aadd}},	//   siaa, हल्ल, ryar, _laos,
   {{0x7c2d059c,0x637d809f,0x442d83ec,0x4c9520da}},	//   syar, lènc, zye_, _минс,
   {{0x27308104,0x26de82ba,0x442daade,0x7bd6008e}},	//   _hành_, _acto_, yye_, buyu,
   {{0x68ed2957,0xe8d901bc,0x675402e3,0x81e480ab}},	//   _mbad, _ajị_, _ذخیر, নিট_,
   {{0x7a3f8065,0xe7368e17,0x442daadf,0xf6500065}},	//   _játé, жеш_, vye_, _آئی_,
   {{0xf7708077,0x68ed2ae0,0x6f01aae1,0x78a283f2}},	//   راه_, _obad, _valc, bcov,
   {{0x442d8247,0x443f8102,0xa159a17e,0x273080ff}},	//   tye_, tzu_, _табу_, _lành_,
   {{0x63ad2ae2,0x60c9811f,0x4ad4835a,0xe8d92ae3}},	//   npan, _idem, _दाखव, _ejị_,
   {{0x443faae4,0xa1c58676,0x68ed2ae5,0x442daae6}},	//   rzu_, обод, _abad, rye_,
   {{0x442daae7,0x2d5701cd,0x63ad008e,0x5f1d1a46}},	//   sye_, għek_, hpan, मान्_,
   {{0xa3ea09f2,0x63ad2ae8,0x69c18e1c,0x3eba2ae9}},	//   _महल_, kpan, rsle, _sept_,
   {{0x41c583b7,0x637d8722,0x3cde80d4,0x6d4b8197}},	//   _विकस, gènc, _गाते_, _imga,
   {{0x69c380eb,0x2cbfaaea,0x2a8e8085,0x6d5d01a1}},	//   _tvne, laud_, bəb_, _ajsa,
   {{0x27308028,0x7d041849,0x78bb80e7,0x6da3197b}},	//   _dành_, tdis, _oeuv, диса,
   {{0x78bbaaeb,0x2fcd0353,0x0d9917ae,0x95990a95}},	//   _neuv, šega_, стры_, стру_,
   {{0xccf2836b,0x637d809f,0x63ad1341,0x78a2816b}},	// [1940] וכן_, cènc, gpan, vcov,
   {{0x60c9960a,0x91eda0d8,0x7bd6080a,0x20000870}},	//   _adem, _जहाज_, ruyu, _isii_,
   {{0x6d4baaec,0xe1fa2aed,0x63ad01a8,0x48e10054}},	//   _omga, рге_, apan, _कामो_,
   {{0x7d0402c1,0xa50a1878,0x1d0a2aee,0x200daaef}},	//   qdis, _тема_, _теми_, _brei_,
   {{0x78a2aaf0,0x200d991f,0x60c9aaf1,0x3860811c}},	//   rcov, _crei_, _ddem, çir_,
   {{0x60c9aaf2,0x200d82af,0x7d02aaf3,0x78a2aaf4}},	//   _edem, _drei_, _saos, scov,
   {{0xa3dc825a,0x64490125,0x3f4d026c,0x27ff846d}},	//   तून_, _þeir, džul_, _esun_,
   {{0x200d81ec,0x6374823e,0x7bc40084,0x64408799}},	//   _frei_, màni, osiu, tzmi,
   {{0x81bc0a49,0x7bc42af5,0x741480f7,0x6440812b}},	//   _আমি_, nsiu, سودا, uzmi,
   {{0x290490fe,0x799c02a0,0x637d8722,0x6d4baaf6}},	//   _hama_, _kurw, vènc, _emga,
   {{0x2904aaf7,0x81e800ab,0x13b300ab,0x6abc0197}},	//   _kama_, বিক_, টওয়, _merf,
   {{0x290483c3,0x09cf00c8,0xe8d90028,0x2906aaf8}},	//   _jama_, _রহমা, _thử_, ndoa_,
   {{0x644080b9,0x6abc2af9,0x81b700fc,0x6370062c}},	//   qzmi, _oerf, ɓɓuk, näns,
   {{0x2904a9a9,0x637d87e2,0x6abc2afa,0x26dc8048}},	//   _lama_, rènc, _nerf, ngvo_,
   {{0x56940a7c,0xe8d9001c,0x637d809f,0xdcbb2296}},	//   дарт, _chợ_, sènc, ища_,
   {{0x5c992afb,0xa3ae8b75,0x27e6aafc,0x68ed13e3}},	//   ская_, _ओझा_, kton_, _ubad,
   {{0x6abc103c,0x6370016d,0x63ad2afd,0xdfdb0098}},	// [1950] _berf, jäns, upan, _тъй_,
   {{0xc7b22afe,0xd3711b9a,0x63ad2aff,0xb2ab096b}},	//   _רבי_, رها_, rpan, ртаж_,
   {{0x6abc0a38,0x78bb82be,0x2904ab00,0x63701a50}},	//   _derf, _peuv, _bama_, vänt,
   {{0x7af72b01,0x2904a827,0x61e52b02,0x644004b7}},	//   sext, _cama_, rthl, _żmie,
   {{0x290480a4,0x01e080c8,0xd009802e,0x251a04de}},	//   _dama_, ববিদ, селе_, _הורא,
   {{0x200d802e,0xe3b200be,0x69d703a8,0x27398176}},	//   _vrei_, _אױך_, puxe, _bèna_,
   {{0x27e6825d,0x67288025,0x2904ab03,0x09af80ab}},	//   aton_, _dodj, _fama_, _কিভা,
   {{0x2904ab04,0x200d802e,0x2ee12417,0x6b9d2b05}},	//   _gama_, _trei_, _lchf_, _kusg,
   {{0xdb1b841c,0x27ff83db,0x1c0e01a2,0x4ea78162}},	//   ssuí, _usun_, सियल_, _дреа,
   {{0x290483c3,0x4a45a7cb,0x6b9d2b06,0x466b8878}},	//   _zama_, знов, _musg, _крем_,
   {{0xe8038c78,0xc86900be,0x69c52b07,0x2904ab08}},	//   लिका_, _ען_, nshe, _yama_,
   {{0x6723ab09,0x7dea8085,0x21290144,0x6d4bab0a}},	//   ljnj, _məsl, _coah_, _umga,
   {{0x88bd809a,0x200f1520,0x246483ed,0x69c52b0b}},	//   _rośl, _ágil_, rëmë_, hshe,
   {{0x69c702ce,0x395f816d,0x26080072,0x2904026c}},	//   _ovje, _ljus_, हिली_, žma_,
   {{0x6b9d0352,0x69c52b0c,0x6b402b0d,0x7dea829a}},	//   _ausg, jshe, _högg, _nəsl,
   {{0xe9a89b9a,0x6d5bab0e,0x2bc713ba,0xc4d60072}},	//   _بدون_, nnua, _लिखा, धलेख,
   {{0x2904ab0f,0x42ca01e5,0x2ef82b10,0xf99301c6}},	// [1960] _rama_, йган_, perf_, _ארה_,
   {{0x799c2b11,0x7bc42462,0x63748722,0x1ddb8424}},	//   _purw, rsiu, tàni, _यमंत,
   {{0xa2dd2b12,0x6abc2b13,0x4ae2035a,0x67288067}},	//   _पार्, _verf, _पाठव, _rodj,
   {{0x2367173d,0x69c7111b,0x0edc001b,0x27e6ab14}},	//   čnja_, _dvje, _बाँड, tton_,
   {{0x67288f28,0x2904803a,0x2906ab15,0x6abc208d}},	//   _podj, _vama_, rdoa_, _terf,
   {{0x395f86c4,0x63701743,0x2904ab16,0x7d062b17}},	//   _ejus_, räns, _wama_, _haks,
   {{0x2904ab18,0x7d062b19,0x27e6ab1a,0x6728a76e}},	//   _tama_, _kaks, ston_, _vodj,
   {{0x7d062b1b,0x06c600ab,0x27e6ab1c,0x75242b1d}},	//   _jaks, শ্চি, pton_, njiz,
   {{0x7d062b1e,0x69c72b1f,0x0edc047d,0x64440365}},	//   _maks, _zvje, _बांड, nzii,
   {{0x3cde8e18,0x883b8039,0xbec280eb,0x44200722}},	//   _गावे_, _התמו, šība, ixi_,
   {{0x76438063,0x75240590,0x58d512b2,0x26cc831d}},	//   czny, kjiz, монт, _iddo_,
   {{0xf487819f,0x60c2804f,0x3ebea67f,0x44320198}},	//   _کامی, naom, _hett_, kyy_,
   {{0xfc3f2b20,0xa2dd1664,0xfc2fa0bb,0x798409c4}},	//   _afín_, _पाल्, _محو_, _dhiw,
   {{0x3da704fa,0x7d0600e4,0x2d9e8129,0x44200118}},	//   зраб, _aaks, _kute_, dxi_,
   {{0x7afaab21,0x249900b9,0x2d9eab22,0x3ebeab23}},	//   mett, _pgsm_, _jute_, _mett_,
   {{0x3ebeab24,0x69da9c61,0xb4c9000d,0xb4d7024c}},	//   _lett_, mute, ैले_, सले_,
   {{0x69c7030b,0x60cd2b25,0x69daab26,0x2d8909c4}},	// [1970] _svje, _idam, lute, rmae_,
   {{0x7afaab27,0x69c5029b,0x2bd49094,0x394d822b}},	//   nett, tshe, _दिना, _smes_,
   {{0x26c3007a,0x6d40ab28,0x6aa52b29,0x7afa847f}},	//   majo_, khma, rchf, iett,
   {{0x69c52b2a,0x7afaab2b,0x26c3007a,0xac192b2c}},	//   rshe, hett, lajo_, _дому_,
   {{0x4addab2d,0x7afaa9a4,0x69c52b2e,0xb4db0091}},	//   _मालव, kett, sshe, _alàg,
   {{0x69daab2f,0x2d9eab30,0x26c32b31,0x7afaa452}},	//   kute, _bute_, najo_, jett,
   {{0x69c7030b,0x69daab32,0x41778416,0x7afaab33}},	//   _uvje, jute, _فارس, dett,
   {{0x2d9e80ad,0x69daab34,0x60cd2b35,0xbe3c01c6}},	//   _dute_, dute, _ndam, מעות,
   {{0x7afa81dc,0xb4ad901c,0x387fab36,0x6d5b8102}},	//   fett, _कभी_, _uzur_, rnua,
   {{0x60cd2b37,0x7afaab38,0x6fd2800f,0x26c30db7}},	//   _adam, gett, _सितं, jajo_,
   {{0x2d9e9b36,0x26c30353,0x69daab39,0x7764823e}},	//   _gute_, dajo_, gute, éixe,
   {{0x6d4082af,0x2734016d,0x604301bc,0x7e7eab3a}},	//   chma, _tänk_, _ọmaj, üppe,
   {{0x7d060341,0x442004b7,0x6b40016d,0x7afaab3b}},	//   _raks, xxi_, _höge, bett,
   {{0x7afaab3c,0xdb0b816d,0x6d4f2b3d,0x26c3007a}},	//   cett, _avgö, _amca, gajo_,
   {{0x7d062b3e,0x2d962b3f,0x2d9e02be,0x7d09ab40}},	//   _paks, драс, ête_, odes,
   {{0x44200102,0xe3ba20bf,0x44320198,0x2bd495bc}},	//   txi_, жба_, tyy_, _दिमा,
   {{0x26c31220,0x7dea8201,0x7d06021e,0x73060084}},	// [1980] bajo_, _rəsm, _vaks, мпаз,
   {{0x7d098009,0x5fd306a7,0x753d0061,0x60c2804f}},	//   hdes, _तितल, _elsz, waom,
   {{0x7d062b41,0x00e6835f,0xf1a50558,0x3ebe821e}},	//   _taks, джен, ерін, _rett_,
   {{0x2d9ea36a,0x3ebe8558,0x7d09ab42,0x3cf98035}},	//   _rute_, _sett_, jdes, ्यों_,
   {{0x2d9e8c7b,0x69daab43,0x7afaab44,0x8fa38cf3}},	//   _sute_, zute, yett, ваче,
   {{0x69daab45,0xeb9f0bc5,0x437500e8,0xb86587c3}},	//   yute, _prøv_, _зуст, رانو,
   {{0x7afaab46,0x629c01dd,0x7d09874c,0x8a031285}},	//   vett, _igro, fdes, _изре,
   {{0x7afaab47,0xdc8e81bc,0x7d09ab48,0x490686a7}},	//   wett, _dịnụ_, gdes, _सोचो_,
   {{0x7afaab49,0x671e89a3,0x3ebeab4a,0x63a42b4b}},	//   tett, पादक_, _tett_, nqin,
   {{0x60c0ab4c,0x48e10076,0xf7729ddd,0x6d40ab4d}},	//   _hemm, _काहो_, _شاء_, shma,
   {{0x7afaab4e,0x60c082a6,0x7d09ab4f,0x26c30353}},	//   rett, _kemm, bdes, vajo_,
   {{0x92be80c8,0x69daab50,0x60c0822b,0x914b0d8e}},	//   ইলে_, rute, _jemm, ічна_,
   {{0xb9072b51,0x7afaab52,0x629c2b53,0x60c0ab54}},	//   _पा_, pett, _ogro, _memm,
   {{0x69daab55,0x60c0ab56,0xb8d60beb,0xdce98503}},	//   pute, _lemm, _च्_, tleć,
   {{0xe5c41285,0x26c32b57,0x2d86801c,0xf2068098}},	//   ксто, rajo_, _khoe_, _цяло,
   {{0x60c0ab58,0x9d180081,0xab5d8035,0xd7fb2b59}},	//   _nemm, мост_, duży, _дуо_,
   {{0xdce982a5,0x63adab5a,0x2139008e,0x21268da8}},	// [1990] sleć, _çant, mksh_, djoh_,
   {{0x32110063,0x68fd2b5b,0xdb098187,0x629c0362}},	//   _przy_, lesd, mpeã, _cgro,
   {{0xe8d90104,0xe8070c78,0xd25b0746,0x7d098009}},	//   _chủ_, शिका_, цца_, ydes,
   {{0xa2d8853e,0x6562820f,0x60c0ab5c,0x290b0162}},	//   _माझ्, _njoh, _cemm, ndca_,
   {{0x7ac7013a,0x60c0ab5d,0xdce40214,0x6f08810c}},	//   _осве, _demm, lliğ, _badc,
   {{0x26c10775,0xaadd8996,0xdc1480c8,0x6d9101ac}},	//   _jeho_, _माइक, িহাস_, _sťah,
   {{0x60c0ab5e,0x58d58293,0x3d108105,0x2d992b5f}},	//   _femm, _повт, _दोहे_, _kise_,
   {{0x60c0ab60,0x69c8ab61,0x28db2b62,0x7d098198}},	//   _gemm, dsde, _भागि, udes,
   {{0x2d992b63,0x47d58013,0x7d09ab64,0x6d5a02be}},	//   _mise_, _سيار, rdes, étai,
   {{0x4225838b,0x26c100e1,0x2d992b65,0xdce402d0}},	//   едов, _neho_, _lise_, kliğ,
   {{0x78a4a354,0x4ae21391,0x9f8a8009,0x443980eb}},	//   žive, _पासव, töön_, šs_,
   {{0x2d992b66,0x68fd2b67,0x186a0956,0xa06a02ee}},	//   _nise_, gesd, зами_, зама_,
   {{0x2d8dab68,0x26c102c4,0x98a481a9,0x66052b69}},	//   mmee_, _beho_, _jomā_, _ashk,
   {{0xa3578077,0x613a823e,0x2d992b6a,0xa3d401d0}},	//   _تخصص, _aïll, _aise_, संघ_,
   {{0xe6170554,0xf53f0370,0xa3e2123a,0x2d992b6b}},	//   ндр_, _blå_, नून_, _bise_,
   {{0x6283803a,0x68e42b6c,0x6d95811f,0x2d99117d}},	//   _izno, _ucid, _ošam, _cise_,
   {{0x4ad384e5,0x2d992b6d,0xe7da80c8,0x7bc9ab6e}},	// [19a0] _दयाव, _dise_, _ধন্য, nseu,
   {{0x60c0ab6f,0x394001c5,0xe8d9001c,0xd83f05b9}},	//   _semm, _hlis_, _phủ_, íček_,
   {{0xdebb010f,0x53368158,0xda1f8ebf,0x60c0808e}},	//   _ממיל, ענען_, यमित_, _pemm,
   {{0xe1ff809a,0xeb9a2b70,0x5976803d,0x7bd58035}},	//   łów_, _ним_, رداز, ązuj,
   {{0x6d562b71,0x7bcfab72,0x63a4011c,0xed50803d}},	//   miya, ácul, qqin, یپت_,
   {{0x6d562b73,0x629c003b,0xe8d92b74,0x9e068087}},	//   liya, _ugro, _thủ_, ечил,
   {{0x7bcbab75,0xe3630f2e,0xceb30051,0x60c0ab76}},	//   _avgu, _скри, ניה_, _temm,
   {{0xe2970bac,0x6d562b77,0x60c62b78,0x6d442b79}},	//   _час_, niya, jakm, nhia,
   {{0xe3af84c0,0x60c609da,0x69de2b7a,0xdce402d0}},	//   یری_, dakm, lupe, zliğ,
   {{0x6d562b7b,0xfd1f0028,0x39402b7c,0x3f9a0573}},	//   hiya, _nhìn_, _alis_, _nipu_,
   {{0x6d562b7d,0x6d440590,0x4dd6ab7e,0x68fd2b7f}},	//   kiya, khia, _ستاس, tesd,
   {{0xfc668098,0x6d562b80,0x88bd809a,0x68e2ab81}},	//   _пълн, jiya, _dośw, ngod,
   {{0x6d562b82,0x54338154,0xb4bc801b,0x557780be}},	//   diya, _مرور, अरी_, _װעגן_,
   {{0x2d992b83,0xb9c68013,0xae0d0076,0xa3ea01ce}},	//   _sise_, _كتبه, हिलन_, _महज_,
   {{0x2d990052,0x63a2ab84,0xe8d90a2c,0x6d562b85}},	//   _pise_, _huon, _ahụ_, fiya,
   {{0x63a280f6,0x6d562b86,0x6d4414ed,0xdce40214}},	//   _kuon, giya, ghia, rliğ,
   {{0x2ca901b4,0x63a28198,0x26c12b87,0x656094f2}},	// [19b0] rcad_, _juon, _teho_, inmh,
   {{0xaa671519,0x63a2ab88,0x5f950eef,0x3a2b027d}},	//   нтек, _muon, _шипт, _đểđă,
   {{0x6d562b89,0x63a2ab8a,0xda6700f7,0xcad781c6}},	//   biya, _luon, رائي, תובת_,
   {{0x6d442b8b,0xa2dd0f8d,0x6d561cee,0x637d8247}},	//   chia, _पाक्, ciya, vènm,
   {{0x7c8418f6,0x63a2965a,0xdee5951a,0x7d0d008b}},	//   _буре, _nuon, воли, mdas,
   {{0x98a90267,0xbec280eb,0x7d0d2b8c,0x68e28118}},	//   _mlađ_, šīna, ldas, agod,
   {{0xae14023c,0x7bdf0388,0xc1790110,0x7764802a}},	//   डियन_, luqu, ntės_, éixa,
   {{0x63a2ab8d,0x7d0d2b8e,0x2734016d,0xacbb00e7}},	//   _buon, ndas, _hänt_, _goût,
   {{0x2d8d8b3c,0x27340106,0x6b400106,0x63a280ff}},	//   rmee_, _känt_, _höga, _cuon,
   {{0x6d562b8f,0x7bc9ab90,0x63a2ab91,0x78ad0722}},	//   ziya, rseu, _duon, _afav,
   {{0x216a2061,0xa96a18b0,0xd9460b01,0x7bc9ab92}},	//   дини_, дина_, вени, sseu,
   {{0x26c7ab93,0x7afe1919,0x8fa62b94,0x6d562b95}},	//   lano_, zept, каме, xiya,
   {{0xeb8ea64c,0xf9928158,0x7d0d2b96,0xa3a8835a}},	//   _ви_, ירט_, ddas, _खूप_,
   {{0x26c7ab97,0x7529a3e3,0x41d120f2,0x9a15ab98}},	//   nano_, ljez, _हिंस, _афиш,
   {{0x6d562b99,0x6d44031d,0xb87b0020,0x65c32b9a}},	//   tiya, thia, rgía, ибра,
   {{0xe8d90028,0x26c7ab9b,0x7d0d2b9c,0xb4dc2a85}},	//   _phụ_, hano_, gdas, ठले_,
   {{0x26c78f45,0x7d0b849f,0x7afe002e,0x644982af}},	// [19c0] kano_, _mags, tept, nzei,
   {{0x6d4401c5,0x6d562b9d,0x60c40357,0x7c2680f2}},	//   shia, siya, _heim, äkri,
   {{0xb6d90158,0x60c41203,0x7dea8085,0x3ed900be}},	//   _אַרט, _keim, _təsi, _אַרא,
   {{0xa3e201b6,0x7d0b84d2,0x7afe2b9e,0x7989ab9f}},	//   नंद_, _nags, sept, _chew,
   {{0xb90aaba0,0x26c7aba1,0x79898077,0x87e38198}},	//   _मा_, fano_, _dhew, ающе,
   {{0x6a861b2f,0x4add816f,0x3d16020e,0xdbdb808b}},	//   _алга, _मागव, _पोते_, _ráðg,
   {{0x2d9c0065,0x63a2aba2,0x248080eb,0x7d0b95b6}},	//   _éves_, _suon, _šim_, _bags,
   {{0x3d19852a,0x644981ec,0x6b9c01b4,0x6b448176}},	//   भागे_, fzei, _hirg, _mòge,
   {{0x7d0b92fa,0x07a684a9,0x46ea81a1,0x6b9c2ba3}},	//   _dags, _разн, _одан_, _kirg,
   {{0xdced003b,0x39468073,0x63a2aba4,0x7d0d0019}},	//   plać, lhos_, _vuon, zdas,
   {{0x2bd48f85,0x53d4816f,0x7d0d07c0,0x7d0baba5}},	//   _दिवा, _दिवश, ydas, _fags,
   {{0x394680a9,0xdd968277,0x63a2aba6,0xa9210085}},	//   nhos_, _شجاع, _tuon, _şöbə,
   {{0x93468e97,0x14d7812a,0xf7730c2a,0xdb098013}},	//   _инде, _יואל_, لاس_, speá,
   {{0x69d300d4,0x5333aba7,0x6b9c2ba8,0xf09381c6}},	//   _डिली, _вешт, _nirg, ינר_,
   {{0x752f0063,0xa4d5035f,0x7e86801b,0x2fc02ba9}},	//   _pocz, лові, _úspě, _ewig_,
   {{0xb4cd016f,0x60c42baa,0xe7d280d4,0xd7d2970c}},	//   रणे_, _geim, _सिंप, _सिंच,
   {{0x65940a4c,0x24580364,0x7d0d2bab,0xdd940084}},	// [19d0] рату, вать_, rdas, раты,
   {{0x26c79041,0x7d0d01e0,0x7cde0087,0x79899c80}},	//   xano_, sdas, tărâ, _shew,
   {{0x26c7abac,0x6b9c2bad,0xfaa40f27,0xe659002e}},	//   vano_, _dirg, ршун, _чинч_,
   {{0x69da808c,0x26c7abae,0x06d800ab,0x7d009b77}},	//   irte, wano_, দ্দি, jems,
   {{0x26c7abaf,0x7d0080d2,0x3869abb0,0x69da81ec}},	//   tano_, dems, çar_, hrte,
   {{0x386981cd,0x6b9c2bb1,0xa03c0039,0x7d0babb2}},	//   ħar_, _girg, ועדפ, _sags,
   {{0x78a48025,0x7d0b97ef,0xa3a88b85,0xa2b8801b}},	//   živa, _pags, _खूब_, ोरन्,
   {{0xf3ffabb3,0x3946abb4,0xb4ad835a,0x97c58013}},	//   ção_, chos_, कडे_, _مقرو,
   {{0xeb998db4,0x26c7abb5,0x69daabb6,0x290dabb7}},	//   нии_, pano_, erte, _iaea_,
   {{0x64498352,0x4add8023,0x60c42bb8,0x753b801b}},	//   rzei, _माओव, _seim, skuz,
   {{0x7d0babb9,0x52d000c8,0x2bc486b7,0x6449abba}},	//   _tags, স্কৃ, लीबा, szei,
   {{0xe4cb803d,0x26c59920,0xb87b2bbb,0x2e3a80be}},	//   _آبان_, _helo_, rgín, _אגענ,
   {{0x69daabbc,0xb4df816f,0xdb0f0511,0xfd1f00ff}},	//   arte, तली_, _etcé, _chìm_,
   {{0x25a581cd,0xe8e081d0,0x26c5805c,0x200900ee}},	//   _kull_, _पञ्च, _jelo_, _dsai_,
   {{0x26c5abbd,0x60c42bbe,0x16098aed,0x68e98904}},	//   _melo_, _teim, विटर_, _oced,
   {{0x2d8b09a4,0x2cad8039,0xf8a80105,0x61e1abbf}},	//   _chce_, nced_, _गलिय, mull,
   {{0x61e1898c,0xc9530051,0x7bcd1849,0xac860d45}},	// [19e0] lull, _למה_, gsau, угал,
   {{0x7d00a1d1,0x29022bc0,0x491c000d,0x68e989b2}},	//   zems, leka_, याको_, _aced,
   {{0x61e1abc1,0xe0da94d6,0xaca401bc,0x248600e1}},	//   null, еве_, _alụs, ťom_,
   {{0x29022bc2,0x69ce9d3a,0x9fca8009,0x26ca2bc3}},	//   neka_, ábei, егда_, labo_,
   {{0x6b9c0029,0x26c5abc4,0x7e7e2bc5,0x2d802bc6}},	//   _tirg, _belo_, _hypp, mlie_,
   {{0x61e1820f,0x26c5a354,0x26ca2bc7,0x643b00be}},	//   kull, _celo_, nabo_, _טעכנ,
   {{0x21200025,0x26c5abc8,0x394681e0,0x63a60267}},	//   _onih_, _delo_, phos_, _hukn,
   {{0x9d220a49,0x29020499,0x61e1abc9,0xa534802e}},	//   _নতুন_, jeka_, dull, рнич,
   {{0x7866abca,0x26c5abcb,0x26ca1486,0x7d00abcc}},	//   _сказ, _felo_, kabo_, rems,
   {{0x25a5abcd,0x69da807a,0x3d19816f,0x26c5abce}},	//   _full_, trte, _मोठे_, _gelo_,
   {{0x61e1abcf,0x63a62bd0,0x037701c6,0x26ca2bd1}},	//   gull, _lukn, רתית_, dabo_,
   {{0x26c58db7,0x613f13de,0x7dea8201,0x29020555}},	//   _zelo_, _gëll, _dəst, geka_,
   {{0x3f9eabd2,0x54368bbe,0x63a602c4,0x26c5abd3}},	//   _kitu_, _حرار, _nukn, _yelo_,
   {{0x26ca2bd4,0x3f9e800e,0xa29485e9,0x26c58118}},	//   gabo_, _jitu_, _калі, _xelo_,
   {{0x1df801bb,0x2902005d,0x61e1abd5,0x3f9e8074}},	//   леры_, beka_, cull, _mitu_,
   {{0x2d800b91,0x20090041,0x7bcd2bd6,0x29022bd7}},	//   glie_, _tsai_, tsau, ceka_,
   {{0x20092bd8,0x5c990a14,0x36d5242e,0x3b551b2f}},	// [19f0] _usai_, ткая_, _копр, акар,
   {{0xd4982bd9,0x7bcd2bda,0x3ea10122,0x6d5a0585}},	//   урс_, rsau, _ught_, étar,
   {{0x7bcd2bdb,0x798d2bdc,0x2d800de0,0x7dea8085}},	//   ssau, _khaw, blie_, _xəst,
   {{0x26c58503,0x30158012,0x98c780f7,0x25a5abdd}},	//   _selo_, идер, اغان, _rull_,
   {{0xf7719301,0x26c58003,0x25a58098,0xd0098012}},	//   يات_, _pelo_, _sull_, теле_,
   {{0x290220b3,0x3f9e80eb,0x61e1abde,0xddc88084}},	//   zeka_, _citu_, yull, _dydž,
   {{0x6b400352,0x3f9e80ad,0xed5983fb,0x26c5abdf}},	//   _mögl, _ditu_, tiž_, _velo_,
   {{0xd6580051,0xb4df8b86,0x613f00f1,0x61e1a450}},	//   טיות_, तले_, _qëll, vull,
   {{0xa3e591bc,0xa3dc8076,0x934590ff,0x26c59117}},	//   बंध_, तंग_, иние, _telo_,
   {{0x61e1abe0,0x2902022e,0x3f9e8877,0x44292be1}},	//   tull, weka_, _gitu_, ixa_,
   {{0x29022be2,0x69261b67,0x7c42811f,0x656401b4}},	//   teka_, амна, _čvrš, ynih,
   {{0x273d0104,0x798d01c5,0x5c7591c7,0x60cb97ea}},	//   _hình_, _chaw, _клет, nagm,
   {{0x29022be3,0x798d2be4,0x6d498ad0,0x26ca2be5}},	//   reka_, _dhaw, mhea, tabo_,
   {{0x61e1abe6,0x29021e98,0x63a62be7,0x644d00dd}},	//   pull, seka_, _rukn, dzai,
   {{0x273d0104,0x26ca2be8,0x63a62be9,0x3f8400eb}},	//   _mình_, rabo_, _sukn, ēmu_,
   {{0x20560d31,0x63a62bea,0x26ca0f8e,0x59da86ae}},	//   _втор, _pukn, sabo_, _भितर,
   {{0x6f03ab42,0x7c3b9437,0x78a92944,0x7c298980}},	// [1a00] kenc, nyur, ževc, nxer,
   {{0x6f03abeb,0xdcfb811f,0x973c80fe,0x6d958084}},	//   jenc, dluč, _kiće, _išau,
   {{0x6f03abec,0x6edb0039,0xa3e5a6ee,0x2d801a1f}},	//   denc, _בחיפ, बूत_, plie_,
   {{0xebe6119d,0xaae2035a,0x3f9e835e,0xdb060168}},	//   _комп, _पाकक, _situ_, _kukë,
   {{0x6d498782,0x273d0104,0x7d042bed,0xe81911bc}},	//   dhea, _bình_, meis, दिया_,
   {{0x7d042bee,0x2612abef,0x69c38039,0xed5900e1}},	//   leis, थिली_, _owne, ďže_,
   {{0x3f9e8010,0x6fd280d4,0x645d808b,0xbd6a898d}},	//   _vitu_, _सिकं, úsin, крие_,
   {{0x6d4984bc,0xc0e3a386,0x7d040009,0x2b582bf0}},	//   ghea, _моск, neis, _hmrc_,
   {{0x3f9eabf1,0x6f03abf2,0xdee6abf3,0x798d2bf4}},	//   _titu_, benc, _вози, _rhaw,
   {{0x7d041276,0x798d00a4,0x79828051,0x973c9487}},	//   heis, _shaw, llow, _biće,
   {{0x6d498083,0x7d0407ac,0x6b400106,0x798d1236}},	//   bhea, keis, _rögl, _phaw,
   {{0x6d498782,0x798d022c,0x7bc286c0,0x85568061}},	//   chea, _qhaw, _twou, _خیبر_,
   {{0x58870196,0x7522abf5,0x442904b7,0x3202801b}},	//   рына, _inoz, xxa_, ňky_,
   {{0x6d462bf6,0x6d40abf7,0x973c80c3,0xc05800e8}},	//   _alka, lkma, _fiće, рію_,
   {{0xd378803a,0x798d01e9,0x69c38355,0xdcfbabf8}},	//   moć_, _thaw, _gwne, zluč,
   {{0x929b8051,0x7d042bf9,0x644d00ad,0x44292bfa}},	//   _ביות, geis, tzai, txa_,
   {{0xf8bf2bfb,0xdfd100f7,0xfaa72bfc,0x69d8016b}},	// [1a10] mbé_, _عيد_, ашен, áven,
   {{0x6d462bfd,0xd378825b,0x44292bfe,0x6f0384c3}},	//   _elka, noć_, rxa_, xenc,
   {{0x3f83003b,0x387f9142,0x7d0f2bff,0x98bf8699}},	//   mlju_, _syur_, _tacs, _smuđ_,
   {{0x6d498362,0xae1a0039,0x6d40ac00,0x3e1603de}},	//   xhea, _עורכ, jkma, _פֿיל_,
   {{0xd3788d26,0x6b818114,0x1b0f00ab,0xf807a240}},	//   koć_, yllg, সাবে_, рчен,
   {{0xd246803f,0x38ad8032,0x7522ac01,0x6d409151}},	//   _فن_, _bóró_, _anoz, ekma,
   {{0x6d49954c,0x6f03ac02,0xed59a53f,0x60cb820d}},	//   thea, renc, лок_, pagm,
   {{0x23672bea,0x7c29ac03,0x61e5005d,0x6f03ac04}},	//   čnju_, txer, muhl, senc,
   {{0x273d0104,0x68fb99a8,0x973c8088,0x63ad2c05}},	//   _tình_, _ibud, _siće, nqan,
   {{0x6aa4817b,0x6d49ac06,0x60c998f0,0x973c811f}},	//   _şifr, shea, _heem, _piće,
   {{0x7d042c07,0xdce9ac08,0x60c9ac09,0x6d4980f5}},	//   yeis, sleđ, _keem, phea,
   {{0x7522826c,0x973c81a1,0xa3e201a2,0xfc339c81}},	//   _gnoz, _viće, नूँ_, _وحش_,
   {{0x442983d3,0x8d748872,0x7d042c0a,0x057480f7}},	//   _ça_, _بالا, veis, _بالد,
   {{0x63bb8dab,0x2cbf86be,0x02398b76,0x7d0402af}},	//   mpun, lbud_, _مثبت_, weis,
   {{0x68fbac0b,0x7d042c0c,0x78a90db7,0x19b59e91}},	//   _obud, teis, ževa, _احتج,
   {{0x60c9ac0d,0x90c61dc7,0x68fb8135,0x2b5800c3}},	//   _neem, _убие, _nbud, _smrc_,
   {{0x3f830a20,0x63bbac0e,0x44260073,0xa3e20beb}},	// [1a20] blju_, npun, ão_, नूं_,
   {{0x29122c0f,0x7d040406,0xd24f003d,0xe6462c10}},	//   _haya_, seis, کنم_, _геоп,
   {{0x29122c11,0x60c9ac12,0x993a8221,0x2cbf81bf}},	//   _kaya_, _beem, ляду_, kbud_,
   {{0xc6930051,0x2912059c,0x63bbac13,0x68fb8362}},	//   _מאת_, _jaya_, kpun, _cbud,
   {{0x8ff78013,0xe73a8785,0xdfcf80f7,0xbcfb026b}},	//   مرور_, лед_, فين_, _ajéw,
   {{0x6d59ac14,0x68fba0c4,0x63bbac15,0x29122c16}},	//   _amwa, _ebud, dpun, _laya_,
   {{0x60c981c0,0x200dac17,0xceb303c8,0x8f9b0e82}},	//   _feem, _esei_, ליג_, ניצי,
   {{0x29122c18,0x63bba525,0xfc4684e8,0x60c9ac19}},	//   _naya_, fpun, šími_, _geem,
   {{0x63bb900c,0x6d40ac1a,0x61fb01a1,0x2906aaa0}},	//   gpun, rkma, _ćuli, meoa_,
   {{0xdb042c1b,0x68ed14ed,0x29122c1c,0x6d40ac1d}},	//   mpió, _scad, _aaya_, skma,
   {{0x291200a4,0x3f83003a,0x7c248110,0x8e8680f7}},	//   _baya_, vlju_, _šird, _الاه,
   {{0x291200ee,0x60c981c0,0xddcb01b9,0x73e681e2}},	//   _caya_, _xeem, ġiżl, _годз,
   {{0x291203c3,0x637d823e,0x27e6833e,0x3f830bcf}},	//   _daya_, tènt, nuon_, tlju_,
   {{0xc90580c2,0x83030264,0x2e1806c4,0xf8bf0061}},	//   _रस्म_, _উচ্চ_, _bčf_, sbé_,
   {{0x2c748019,0x29122c1e,0x2bc483eb,0x44b601bc}},	//   _دیکھ_, _faya_, लीरा, _ọsụ_,
   {{0x29122c1f,0x52838013,0x78a4920e,0x27e68420}},	//   _gaya_, _عليك, živj, kuon_,
   {{0xfd4f0028,0x994800a0,0x26ce85ee,0x3f830390}},	// [1a30] _khiế, _دليل_, kafo_, plju_,
   {{0x63ad2c20,0x3949016b,0x60c9ac21,0x27e6ac22}},	//   rqan, _hlas_, _seem, duon_,
   {{0x39492c23,0x56952c24,0x27ff802e,0x29122c25}},	//   _klas_, _фант, _spun_, _yaya_,
   {{0x61e52c26,0x2cbf8338,0x63bbac27,0x399b2c28}},	//   ruhl, xbud_, ypun, _būsi_,
   {{0xb4e501ab,0x63ad2c29,0x6aa90162,0x9f999abe}},	//   नली_, qqan, _şefu, авду_,
   {{0x70b52c2a,0x60c98c2e,0x3949016a,0xfd4f00ff}},	//   ंडुल, _weem, _llas_, _nhiế,
   {{0x60c9ac2b,0x27ff80b9,0x39492c2c,0x2cbfac2d}},	//   _teem, _wpun_, _olas_, tbud_,
   {{0x63bb803a,0x2bd4901c,0x68fbac2e,0x6d4d2c2f}},	//   tpun, _दिखा, _ubud, nhaa,
   {{0x29122c30,0x6fe081fe,0x69da04b8,0x2cbf81a3}},	//   _raya_, _नियं, _åter, rbud_,
   {{0x2912048f,0xfd4f0104,0x6d4d2c31,0x63bbac32}},	//   _saya_, _chiế, hhaa, rpun,
   {{0x63bbac33,0x29120695,0x7cd98019,0x39492c34}},	//   spun, _paya_, _نواز_, _blas_,
   {{0x78a902a5,0x6d598578,0x39492c35,0x7c248a20}},	//   ževn, _umwa, _clas_, _šire,
   {{0x6d4d2c36,0x291215c7,0x224d01d0,0x232984dd}},	//   dhaa, _vaya_, _řekl_, _воли_,
   {{0x39492c37,0x6da62c38,0x6569ac39,0x973c81a1}},	//   _elas_, жива, lneh, _kića,
   {{0x63abac3a,0xa3e58105,0xad5a2c3b,0x29122c3c}},	//   _hugn, बूर_, арах_, _taya_,
   {{0x63a3aabd,0x6569ac3d,0x6d4d2c3e,0x6d430087}},	//   _hinn, nneh, ghaa, _înal,
   {{0x63a3ac3f,0x443fac40,0x442d9daf,0xe5770a18}},	// [1a40] _kinn, nyu_, nxe_, ізу_,
   {{0x6fe081fe,0x63a3ac41,0x261a81ce,0x7c2480f7}},	//   _निबं, _jinn, _मछली_, _áire,
   {{0x64a60eab,0x443f8397,0x63ab816d,0x2d8c2c42}},	//   _мана, hyu_, _lugn, ïdes_,
   {{0x63a3ac43,0x6d4d2c44,0x443fac45,0xdce4017f}},	//   _linn, chaa, kyu_, onič,
   {{0xee02ac46,0xd70a8162,0x63ab82d5,0xc8cc801b}},	//   लब्ध_, инде_, _nugn, ारबट,
   {{0x1754a45b,0xfaa60703,0xd04e0085,0x501b04de}},	//   явля, _фаво, ükəs, יונו,
   {{0x79460063,0xd946879e,0x6146a7cb,0x6283835f}},	//   _równ, _деви, _дева, _nyno,
   {{0x6d4401e2,0x63abac47,0x7d162c48,0xdb040511}},	//   nkia, _bugn, ndys, mpiñ,
   {{0x63a3a4de,0xdce40052,0x443fac49,0xeb0682c7}},	//   _binn, jnič, gyu_, очно,
   {{0x63a3861f,0x6d5f036a,0x63abac4a,0xba548251}},	//   _cinn, ziqa, _dugn, звој,
   {{0x442d84c3,0x39492c4b,0x62838114,0x6d440198}},	//   axe_, _plas_, _cyno, kkia,
   {{0x63a38125,0x62838114,0x80b5064a,0x2ca682c4}},	//   _einn, _dyno, ंडें, _ugod_,
   {{0x63a39808,0xfd4f0104,0xcb6a80a9,0x61e18118}},	//   _finn, _thiế, _каде_, arll,
   {{0x63a3ac4c,0x628e0b80,0xdced0bcf,0xf48781f9}},	//   _ginn, _ozbo, vlađ, _بامی,
   {{0x26ccac4d,0x6d5f2c4e,0x6d4d044e,0x661e0369}},	//   _medo_, tiqa, thaa, _crpk,
   {{0xb4e52c4f,0x39492c50,0x91b780d5,0x63a3ac51}},	//   नले_, _ulas_, _بطور_, _zinn,
   {{0xe8731125,0x6d4d2c52,0x6d5f0748,0x628e2c53}},	// [1a50] _زندگ, rhaa, riqa, _azbo,
   {{0x6d4d2c54,0x26cc8267,0xce950098,0x2bdd909b}},	//   shaa, _nedo_, _напъ, _मिसा,
   {{0x60cd059c,0x6cea9344,0xdced0289,0x2fc900e4}},	//   _keam, _टांग_, slađ, _hwag_,
   {{0xdd868065,0x6d5f00b9,0x26d12c55,0x60c2ac56}},	//   _سو_, qiqa, lazo_, gbom,
   {{0xf48419b8,0x880780d5,0x6d5d2c57,0x2be20075}},	//   _журн, تظام, _imsa, _पिया,
   {{0x26d12c58,0x60cd0635,0x26ccac59,0x61e88234}},	//   nazo_, _leam, _cedo_, kudl,
   {{0x63a3ac5a,0xc33203c8,0x6569ac39,0x63ab8079}},	//   _rinn, _אום_, tneh, _sugn,
   {{0x60cd0af6,0x26d1016a,0x442d89cb,0x63abac5b}},	//   _neam, hazo_, txe_, _pugn,
   {{0x6569ac5c,0xb4bb901c,0x399b0029,0xb4ab9a3b}},	//   rneh, _अभी_, _jūsu_, _खली_,
   {{0x399b0029,0xdce42c5d,0x442d84c3,0x6d932c5e}},	//   _mūsu_, vnič, rxe_, lçad,
   {{0x63a3ac5f,0x6d442c60,0xd9100065,0x98b00668}},	//   _vinn, ykia, ہیں_, šača_,
   {{0xdce4003b,0x6d93055a,0x63abac61,0x60cd01a8}},	//   tnič, nçad, _tugn, _ceam,
   {{0x6d4bac62,0x60cd1581,0x661e0253,0xe81e92ee}},	//   _ilga, _deam, _srpk, पिया_,
   {{0x26cc1cef,0x7d099196,0x6d5d2c63,0x61e8ac64}},	//   údo_, lees, _amsa, budl,
   {{0x614623cd,0x65c60098,0xd9461634,0x60dbac65}},	//   _нека, ябва, _неки, _odum,
   {{0x60cd2c66,0x7d09ac67,0x2a3a8039,0xdce41607}},	//   _geam, nees, _לעצמ, pnič,
   {{0x26d12c68,0x6d442c69,0x2900019d,0x2fc90428}},	// [1a60] bazo_, rkia, _ibia_, _gwag_,
   {{0xe8190540,0x7d098009,0x78a9847f,0x8afc809a}},	//   दिरा_, hees, _agev, mięc,
   {{0x6d4bac6a,0x2366011f,0x7d09ac6b,0x7ae32c6c}},	//   _olga, đoj_, kees, ónta,
   {{0xdb042509,0xfaf88ec3,0x39b797c9,0x26ccac6d}},	//   rpiñ, lnīt_, _găse_, _sedo_,
   {{0x2d821f26,0x98a70a20,0x8afc809a,0x26cc97e9}},	//   _ikke_, šića_, nięc, _pedo_,
   {{0x6d93041c,0x60dbac6e,0x6d4ba0a5,0xa2bb0c9a}},	//   açad, _edum, _alga, शुद्,
   {{0x78ad803a,0x26ccac6f,0x6440a1f5,0x7d09ac70}},	//   žava, _vedo_, wymi, fees,
   {{0x7d09ac71,0x3f878289,0x6440ac72,0x5bb882ff}},	//   gees, alnu_, tymi, олия_,
   {{0x6fb685ff,0x7bd62c73,0x60cd2c74,0x26d12bd7}},	//   _رمضا, nsyu, _ream, yazo_,
   {{0x290010ec,0x60cd2c75,0xff24803d,0x656082a6}},	//   _abia_, _seam, _تبری, simh,
   {{0x628781cd,0xc3330039,0x60cd0074,0x7bd600dd}},	//   żjon, תות_, _peam, hsyu,
   {{0x39468110,0xf8cc850d,0x26d10010,0x7bd6076d}},	//   nkos_, ारिय, wazo_, ksyu,
   {{0x61e8ac76,0x315783c8,0x60cd2c77,0x26d12c78}},	//   sudl, ליטן_, _veam, tazo_,
   {{0xd7f81b69,0x973c8b80,0x2d8205ee,0xe8d904be}},	//   чую_, _mićo, _akke_, _imọ_,
   {{0x50ccac79,0x8afb8051,0x26d12c7a,0xf8cc8a74}},	//   ाराष, _להגי, razo_, ाराय,
   {{0x2d5801a0,0x6b40007b,0xe8d900ff,0x2fc902c4}},	//   пись_, _mögu, _thự_, _twag_,
   {{0x26d1062f,0x6728911b,0xb0c3097d,0x6b40007b}},	// [1a70] pazo_, _ondj, _व्यग, _lögu,
   {{0x29190267,0xe1ab83db,0x399203a8,0xe9ff8129}},	//   ldsa_, _घूँघ, ráse_, _hoại_,
   {{0x7f3c0039,0xdb0b8687,0x62868035,0x22470061}},	//   _לעזו, _utgå, ękow, ánk_,
   {{0x67288088,0xbcfb0693,0x3946861b,0x6d5d2c7b}},	//   _andj, _ejér, gkos_, _umsa,
   {{0xdb1b85b4,0x24869352,0x29d88028,0x6d932c7c}},	//   spué, _nyom_, hĩa_, rçad,
   {{0xe9ff8104,0x7d09ac7d,0xdb0286a5,0x69d88081}},	//   _loại_, wees, _otoñ, _ovve,
   {{0x7d09ac7e,0xed5981bb,0x290b2c7f,0x673a85f3}},	//   tees, жой_, keca_, _dotj,
   {{0x656d2c80,0x63af007d,0x25de8697,0xe3b9ac81}},	//   nnah, _kucn, _गिरी_, оби_,
   {{0x69d8a35a,0x2bdd835a,0x394dac82,0x290b2c83}},	//   _avve, _मिळा, _iles_, deca_,
   {{0x990608fd,0xe9d98256,0x7d09ac84,0x4a459383}},	//   षज्ञ_, око_, sees, днов,
   {{0x7d09ac85,0x63a700f3,0x779082e3,0xdb0381d0}},	//   pees, _mijn, _حیوا, _jiné,
   {{0x69d803a7,0xe6c601a2,0x6b40016d,0x2ec60c2d}},	//   ávei, वर्ज, _högt, वर्त,
   {{0x7d5680be,0xdb038866,0x69d8ac86,0x656d0df6}},	//   _קינד_, _liné, _evve, dnah,
   {{0x394dac87,0x6265997b,0x7763ac88,0x63a72c89}},	//   _lles_, _овла, ninx, _nijn,
   {{0x8fa31814,0x8afc809a,0x394d808e,0x656d232a}},	//   таре, sięc, _oles_, fnah,
   {{0x19870098,0x63af0bcf,0xa1870081,0x8afc8035}},	//   _общи_, _bucn, _обща_, pięc,
   {{0x7984022e,0x63a70a0f,0x2486822c,0x63af00c3}},	// [1a80] _ikiw, _bijn, _xyom_, _cucn,
   {{0x394d802e,0x7bd60057,0xdb098876,0x395fac8a}},	//   _ales_, rsyu, mpeó, _amus_,
   {{0xdb03ac8b,0x69c1ac8c,0x6b52013c,0x656d0079}},	//   _ciné, nple, _lægg, bnah,
   {{0x39468110,0x395f802a,0x2004ac8d,0x656d01b4}},	//   ukos_, _cmus_, _ppmi_, cnah,
   {{0x3946ac8e,0x63a700f3,0x6b40007b,0x77638118}},	//   rkos_, _fijn, _sögu, finx,
   {{0x394d8e67,0xd5ba83bc,0x39468612,0xdb03ac8f}},	//   _eles_, оси_, skos_, _finé,
   {{0x44222c90,0x53a700d4,0x394d9699,0x09d800ab}},	//   _hrk_, _कूटश, _fles_, _সহকা,
   {{0xb4e883eb,0x69c19c11,0x63a701ed,0x2d800037}},	//   बले_, dple, _zijn, noie_,
   {{0xd90d8bca,0xa2a203dd,0x64440365,0x25a69139}},	//   _دین_, _कृत्, nyii, _viol_,
   {{0x79842c91,0x5a349071,0x25f68035,0x628f8035}},	//   _akiw, енот, _एमपी_, ęcon,
   {{0x6b4000f2,0x290b2c92,0x656d02a3,0x212900dd}},	//   _högs, teca_, ynah, _pnah_,
   {{0x1c468544,0x78a4936f,0x79960286,0x2d4707b6}},	//   _онем, živu, _chyw, _põem_,
   {{0xb8d705fb,0x6d43002e,0x290b2c93,0x59ce016f}},	//   _जल_, _înai, reca_, हीतर,
   {{0x290b02a5,0x2bb501fe,0x63af011f,0x5ee080ab}},	//   seca_, _अंबा, _rucn, প্রে,
   {{0xd9f281b6,0x27e6ac94,0x290b2c95,0x3da701e2}},	//   _अमित_, hron_, peca_, драб,
   {{0xa3e58076,0x994402bb,0x63af10d3,0x656d2c96}},	//   बूक_, mış_, _pucn, unah,
   {{0x63a71696,0xdb039c81,0x994407c0,0x6f170144}},	// [1a90] _pijn, _siné, lış_, _taxc,
   {{0x656d2c97,0x442214fb,0xdb038144,0xa3e68128}},	//   snah, _drk_, _piné, _बटन_,
   {{0x27e685a4,0x39920019,0x21f888f9,0x994408c5}},	//   eron_, lása_, néh_, nış_,
   {{0x63a700f3,0x26de833e,0x7c22ac98,0x6b448176}},	//   _wijn, _adto_, _oror, _dògi,
   {{0x7d0d2c99,0x80278013,0x78ad82a5,0x5ed380ab}},	//   meas, برام, žavo, _সাবে,
   {{0xf77381bd,0xae03016f,0x7d02ac9a,0x7d0d2c9b}},	//   خاص_, _लहान_, _abos, leas,
   {{0x753d2233,0x27e6ac9c,0x776388e9,0xc17788ca}},	//   _kosz, aron_, rinx, _قدرت,
   {{0x7643ac9d,0x7d0d2c9e,0x92942c9f,0x7c22aca0}},	//   ryny, neas, _расц, _bror,
   {{0x7996031d,0x76438198,0x99858061,0xf8b28e82}},	//   _rhyw, syny, _élő_, _תשמ_,
   {{0x7d0d2ca1,0x6b4000f2,0x39920019,0x69c1aca2}},	//   heas, _högr, dása_, tple,
   {{0x26c78353,0x7d0d0009,0x7c22a7a3,0xe1f6802e}},	//   mbno_, keas, _eror, нгэ_,
   {{0x361a8039,0x69c1aca3,0xaca38135,0x7c22802a}},	//   _מועד, rple, _arụm, _fror,
   {{0x2d802ca4,0x69c1aca5,0x291e001b,0xdb060c83}},	//   voie_, sple, ěta_, _luká,
   {{0x6d4f11b9,0xcc3a893f,0x7d1b8006,0x6b40007b}},	//   _alca, _מענט, ldus, _lögr,
   {{0x236580f2,0xd0408201,0x7d0d1995,0xd5b21a00}},	//   milj_, _demə, feas, افر_,
   {{0x7d1b8665,0xdb0985e4,0x7984004f,0x7d198326}},	//   ndus, mpeñ, _ukiw, _jaws,
   {{0x03260d9e,0x6b52013c,0xec770012,0x490000c2}},	// [1aa0] ндан, _læge, епт_, ष्णो_,
   {{0xaca4019d,0xb4db0362,0x44220d55,0x27e69532}},	//   _nzụt, _blàs, _vrk_, vron_,
   {{0x00e694b8,0xb4db023e,0x2d73025b,0x7d0d2ca6}},	//   ежен, _clàs, mćen_, beas,
   {{0x27e6aca7,0x61e30065,0xaca40133,0xe0d29459}},	//   tron_, ánla, _azụt, ازا_,
   {{0x14d70051,0x673e2ca8,0x7d1baca9,0x27e6acaa}},	//   _אוכל_, _kopj, ddus, uron_,
   {{0x7bc42cab,0xf0930158,0x7c24a771,0x27e6acac}},	//   mpiu, אנד_, _širo, rron_,
   {{0x99440201,0x39920019,0x38728087,0x6b6680e7}},	//   xış_, zása_, _ţară_, _légè,
   {{0x78a90024,0xe9a38e63,0xdd9781e5,0x69dc27f5}},	//   ževi, _басп, ншы_, _ivre,
   {{0x3076938f,0x7d19acad,0x6b818352,0x4420009f}},	//   _чувс, _daws, folg, nvi_,
   {{0x994403bf,0x44202cae,0xf063acaf,0x973c81a1}},	//   tış_, ivi_, _скуп, _mićk,
   {{0x44202cb0,0xdb072cb1,0x2fc01670,0x7d1982ed}},	//   hvi_, _dijè, _atig_, _faws,
   {{0x4420003a,0x39920065,0x99441014,0x613f00f1}},	//   kvi_, tása_, rış_, _pëlq,
   {{0x53b5016f,0xa49b06c0,0x656282c4,0x23658b80}},	//   _अंधश, _abòn, _imoh, bilj_,
   {{0x7d19809a,0x44200088,0x7c2d8904,0xadf489c1}},	//   _zaws, dvi_, _šarg, _इमान_,
   {{0x6f1aacb2,0x753d1b35,0x3ea52cb3,0x7d0d2cb4}},	//   _matc, _posz, ält_, teas,
   {{0x69daacb5,0xdb06026f,0x2bb51d7c,0x3ceb00c2}},	//   mste, _ruká, _अंदा, टलें_,
   {{0x97a7028b,0x69dc1fcb,0xb4db0a2a,0x442001fa}},	// [1ab0] _прол, _avre, _blàr, gvi_,
   {{0x6f1aacb6,0x7d1b8b80,0x69daa6a1,0x2009008e}},	//   _natc, zdus, oste, _ipai_,
   {{0x64410201,0x69daa7d0,0x44202cb7,0x7d0d2cb8}},	//   _əliy, nste, avi_, peas,
   {{0x69daacb9,0x3f832cba,0xf99f06c0,0x6b818061}},	//   iste, loju_, nmè_, zolg,
   {{0xb90992c7,0x7d19acbb,0x69dc2cbc,0x41748290}},	//   _मय_, _raws, _evre, دالس,
   {{0x65628122,0x2d8686cb,0xdcfb86d3,0xdce9826c}},	//   _amoh, _akoe_, rouč, rneč,
   {{0x6b81acbd,0xc8f58698,0xda0512ee,0x69daacbe}},	//   volg, _извъ, _रहित_, jste,
   {{0x26d300f1,0xab640380,0x387e0035,0x7c2000c3}},	//   _lexo_, rmüş, ętrz_, _šmri,
   {{0x69daacbf,0x81c300ab,0x6d498bc6,0x290facc0}},	//   este, _এটি_, rkea, mega_,
   {{0x26d30207,0x69daacc1,0x290facc2,0x656295d7}},	//   _nexo_, fste, lega_, _emoh,
   {{0x2bd18740,0x2fc023ea,0x28c3016f,0x291b19e7}},	//   _दौरा, _stig_, _व्हि, _baqa_,
   {{0x290f8db7,0x291dacc3,0x81c300c8,0x186a245b}},	//   nega_, ndwa_, _এটা_, дами_,
   {{0x3959020f,0x3de380ab,0x2d8d8748,0x61e8acc4}},	//   ërsa_, _মহিল, mlee_, ardl,
   {{0x290facc5,0xdf15035f,0x2d8dacc6,0x3f8306ec}},	//   hega_, льсь, llee_, goju_,
   {{0x290f8db7,0x5ed400c8,0x26d30118,0x628a8428}},	//   kega_, _তাদে, _dexo_, _gyfo,
   {{0x290facc7,0x44202cc8,0xa2a21299,0x25ab0037}},	//   jega_, tvi_, _कृष्, _cicl_,
   {{0xd4671a19,0xc4d28158,0x290f8006,0x6da30012}},	// [1ac0] вите_, יגן_, dega_, рита,
   {{0x212d81f1,0x7bdb8009,0x39400362,0x7bc40048}},	//   _aneh_, isuu, _hois_, rpiu,
   {{0x26d800b4,0xab5b02af,0x2d8dacc9,0xe8fa81e2}},	//   maro_, _stüc, klee_, дле_,
   {{0x290facca,0x26d8009c,0x6f1a8aff,0xd7e6902a}},	//   gega_, laro_, _satc, віко,
   {{0xa41c80c8,0x394003d3,0x3166a75d,0x212d807a}},	//   _তথ্য_, _mois_, rioz_, _dneh_,
   {{0x6d932ccb,0x69da92cf,0xbcfb000d,0x26d81aae}},	//   nçan, yste, _jmén, naro_,
   {{0x670423e6,0x6f0307d9,0x69dc0067,0x52750087}},	//   श्यक_, _önce, _uvre, _буту,
   {{0x290f82a5,0x6f1a8039,0xe297186e,0x38c889a7}},	//   cega_, _watc, _рас_, _ساری_,
   {{0xa8878071,0xd175876a,0x98a39d32,0x69daaccc}},	//   _айта_, _сыры, _вите, wste,
   {{0x69da8574,0x39400068,0x5fdc0321,0x26d82ccd}},	//   tste, _aois_, _बिजल, jaro_,
   {{0x394002be,0xe7378f2e,0x69daacce,0x26d82ccf}},	//   _bois_, _шеф_, uste, daro_,
   {{0x69da8faf,0x26d303aa,0x7c2d8668,0xbcfb00e7}},	//   rste, _sexo_, _šare, _amén,
   {{0x39402cd0,0x69da8456,0xc0ab0875,0x50642cd1}},	//   _dois_, sste, بادل_, атра,
   {{0x26d82cd2,0x4426acd3,0x973c8669,0x628aacd4}},	//   garo_, _iro_, _bići, _tyfo,
   {{0x394003d3,0x3f832cd5,0xe8d90870,0x26d301df}},	//   _fois_, roju_, _akụ_, _vexo_,
   {{0x2d84acd6,0x4426acd7,0x63ad81e8,0x6e2505f3}},	//   nome_, _kro_, _èanc, _vrhb,
   {{0x290facd8,0x26d82cd9,0x27e096f2,0x26d3002a}},	// [1ad0] vega_, baro_, šinj_, _texo_,
   {{0x9952003e,0x26d80314,0x61e30019,0x2d8d80b9}},	//   máš_, caro_, ánlo, zlee_,
   {{0x6d5c81e2,0x290facda,0x02a719b8,0x2d84acdb}},	//   _įran, tega_, трам, kome_,
   {{0x4426acdc,0xe5350009,0x2d848084,0xa6cf8264}},	//   _oro_, _семь, jome_, _রাইট,
   {{0xb4c12cdd,0x4426acde,0x290facdf,0xdee58790}},	//   ुरी_, _nro_, rega_, голи,
   {{0x290f8665,0x6d4d02c1,0x20d18104,0x77848112}},	//   sega_, lkaa, ại_, аліз,
   {{0x7bc2ace0,0x2d84ace1,0x80d280ab,0xfd1181a8}},	//   _atou, fome_, _হার্, مجة_,
   {{0xdb0d160a,0x6d4d1e0a,0x7d1d2ce2,0x2d84ace3}},	//   mpañ, nkaa, _jass, gome_,
   {{0x7d1d291e,0x4426ace4,0x39402ce5,0x98a008ae}},	//   _mass, _cro_, _rois_, _inić_,
   {{0x7d1d2ce6,0x7bdbace7,0x96ca8540,0xdced0024}},	//   _lass, rsuu, _स्पॉ, dnač,
   {{0x4426ace8,0x39402ce9,0x6d4d2cea,0xd9460468}},	//   _ero_, _pois_, kkaa, гени,
   {{0x7d1d2ceb,0x44268428,0x2d848039,0x6d4d2cec}},	//   _nass, _fro_, come_, jkaa,
   {{0xeb8eaced,0x4426acee,0x26d82cef,0x39402cf0}},	//   _ги_, _gro_, taro_, _vois_,
   {{0x973c80fe,0x06e580ab,0x6569acf1,0x59d0801b}},	//   _pići, প্রি, lieh, थीहर,
   {{0x7d1d2cf2,0xfce6210d,0x26d82cf3,0xa50a1ed1}},	//   _bass, лово, raro_, нева_,
   {{0x7d1d2cf4,0x291e0029,0x39990065,0x6d4d2cf5}},	//   _cass, ētas_, tése_, gkaa,
   {{0x2e178201,0x5f76003d,0x25a02cf6,0x69c380c3}},	// [1ae0] _dəfə_, _مادر, rmil_, _htne,
   {{0x6d5602a0,0x46f604fa,0xdcf49487,0x7c24acf7}},	//   shya, _счит, _čačk, _širk,
   {{0x7d1d2cf8,0x29d18796,0x6d4d01b4,0xdb0a849c}},	//   _fass, nša_, bkaa, _difè,
   {{0x3940808b,0x631400ab,0x79862cf9,0x6d932cfa}},	//   ðis_, সাইট_, nokw, nçal,
   {{0x6f1e0117,0xe3b207d2,0x61fe2cfb,0x799b8077}},	//   _kapc, _درج_, stpl, _dhuw,
   {{0x779180d5,0x7c240842,0x9c12819d,0x798981bc}},	//   قیقا, mvir, _dọlf, _ekew,
   {{0xe297028b,0x5fe0823c,0x29d1a354,0xdced07df}},	//   _бар_, _निकल, jša_, znač,
   {{0x442693d9,0x69de2cfc,0x74149a37,0x68e40135}},	//   _pro_, mspe, لوبا, _ndid,
   {{0x7c242cfd,0x69de2cfe,0x136a9182,0x7f41acff}},	//   nvir, lspe, ешни_, _folq,
   {{0xa3e5901c,0x93fb012a,0xbcfb02be,0xe3bf81df}},	//   _फिर_, עליי, _amél, íña_,
   {{0x19590a7f,0xe1350364,0xaa94a6b1,0x69de2d00}},	//   ваны_, анны, ринч, nspe,
   {{0x25f38076,0x4426ad01,0x69de00f7,0x63ae02d6}},	//   ्झरी_, _tro_, ispe, _libn,
   {{0x44268353,0x68e40114,0x644682f1,0x27e00176}},	//   _uro_, _ddid, äkid, _cvin_,
   {{0x7d1d2d02,0x2b8f02af,0x69de2d03,0x7c290bda}},	//   _sass, rück_, kspe, _šero,
   {{0x7d042d04,0xd9048065,0x6d4d0a81,0xe5c40081}},	//   ffis, _ٹی_, tkaa, йсто,
   {{0x6298803b,0xb4c12d05,0x69de0e23,0x7d1d022b}},	//   _izvo, ुरे_, dspe, _qass,
   {{0x6d4d02c1,0x81b680c8,0x7afd9f3a,0x69c89fcd}},	// [1af0] rkaa, _ছবি_, đstv, lpde,
   {{0x7d1d2d06,0x6d4d2d07,0x656982af,0x6e288370}},	//   _wass, skaa, zieh, _ordb,
   {{0x7d1d2d08,0x5ed380ab,0x69de2d09,0x63ae01b4}},	//   _tass, _সালে, gspe, _dibn,
   {{0xf8bf02be,0xa3e585fc,0x973c8390,0x7ff59459}},	//   ncé_, _फिल_, _miću, لستا,
   {{0x6d93055a,0x6e289995,0x69de0162,0xdb0d0333}},	//   nçam, _ardb, aspe, spañ,
   {{0x6d5801e2,0xb8ec80d4,0x99d712c8,0x79860234}},	//   _įvai, _श्_, _مترا, zokw,
   {{0xb8db80c8,0x8d558a13,0x6569ad0a,0xf8c980e7}},	//   _আজ_, итич, tieh, _créé_,
   {{0xf1a48554,0x754595ac,0x29d1811f,0xdce40289}},	//   _грун, рниз, vša_, rnić,
   {{0x1c4297ae,0xdb0f11b9,0x656984dc,0x6e288192}},	//   жным, _lucí, rieh, _erdb,
   {{0x7bdf0187,0xe787ad0b,0x60d62d0c,0x6569ad0d}},	//   isqu, _субо, _seym, sieh,
   {{0x4a758048,0x29d1ad0e,0x5efe809a,0x291f82f1}},	//   рыпт, uša_, _शॉट्_, _kaua_,
   {{0xb4e401fe,0xdb0385e4,0xfe708591,0x60260a41}},	//   _नये_, _diná, _عدل_, адма,
   {{0xb4c3885d,0x291f804f,0x6d93061c,0x2f248061}},	//   ्री_, _maua_, rçal, ségű_,
   {{0xfaa59597,0x2d8b001b,0xdb038e93,0x2909019d}},	//   _кало, _akce_, _finá, _ebaa_,
   {{0x7d042d0f,0x597604d9,0xbea61229,0x6d930722}},	//   tfis, _выпу, равк, pçal,
   {{0x7c2401e2,0x2c09809a,0x27e08805,0x29092d10}},	//   tvir, _वहां_, šini_, _gbaa_,
   {{0xdee62657,0xab662bd9,0x7d04007b,0x5ee080c8}},	// [1b00] _копи, авал, rfis, প্টে,
   {{0x68fbad11,0x69de2a33,0x212000b9,0xb4c384c5}},	//   _acud, tspe, _haih_, ्रु_,
   {{0xbd8a003f,0x399c80f7,0xa3b60999,0xf8ba00d4}},	//   _لندن_, híse_, _चूर_, _इलाय,
   {{0xb4db0028,0x4fc6ab3f,0x6d430087,0x628e016b}},	//   _hoàn, аска, _înap, _vybo,
   {{0x628e2d12,0x63ae2d13,0x779482e3,0x27e08834}},	//   _wybo, _tibn, میرا, éin_,
   {{0x7c2480f7,0x69de2d14,0x2d922d15,0x7bc6062c}},	//   _áiri, pspe, llye_, _itku,
   {{0x91e302a4,0x25af81a1,0xdb0e0168,0xcb67002e}},	//   _море, _bigl_, _libë, _таре_,
   {{0x27e98341,0x7c2d8052,0x399c81a8,0xa534aba7}},	//   šana_, _šara, físe_, снич,
   {{0xef1a8abe,0x60cdad16,0x973c80d2,0xf8bf00e7}},	//   _има_, ñame, _siću, ndée_,
   {{0x3b5491b3,0x3944ad17,0xd00f80f7,0x316b0035}},	//   скор, _homs_, _تلك_, wicz_,
   {{0xe81e825e,0x44e880ab,0x7c2901b9,0x291f8c53}},	//   पिका_, ক্ষক_, _ġerm, _yaua_,
   {{0x7bc6003a,0x26dcad18,0x2b0606f0,0xbc6789a7}},	//   _otku, lavo_, स्तु_, امین_,
   {{0xb4d2ad19,0x7afc00d2,0xf8bf2d1a,0x1b1d0264}},	//   वरी_, _ocrt, rcé_, নাতে_,
   {{0xe78727f1,0x200501b9,0x26dc8611,0xdb0e13de}},	//   румо, ċli_, navo_, _dibë,
   {{0xd5b81e25,0x139b84de,0x539b8039,0x629880d2}},	//   ист_, _שבוע, _שיוו, _uzvo,
   {{0x394487fa,0x3a2d2d1b,0x48670081,0x00000000}},	//   _noms_, _čep_, _въоб, --,
   {{0x9fe180ab,0x798d2d1c,0xe7ee0105,0x3f87880a}},	// [1b10] _মঙ্গ, _ikaw, _जिया_, yonu_,
   {{0xf2c7096b,0x7bdf02be,0x26dcad1d,0x68fb847f}},	//   рсан, rsqu, javo_, _scud,
   {{0xd1b80065,0x26dc8110,0x6f150216,0x79a786fd}},	//   لانا_, davo_, mezc, арде,
   {{0x3944ad1e,0x8c48017b,0xc10580f7,0xdb0e06c0}},	//   _coms_, _bağı, صوتي, _libè,
   {{0xdc350159,0x656d010c,0x2cbf811c,0x80c68327}},	//   _האָט_, miah, vcud_, ाड़े,
   {{0x8c480182,0x656d2d1f,0x6f152d20,0x6dbc007a}},	//   _dağı, liah, nezc, _očal,
   {{0xb87b17ad,0x6b52006a,0x291fad21,0xb345841c}},	//   laíd, _mægl, _taua_, _loçã,
   {{0x798d01c5,0xb4c38f21,0xe3bf81df,0x656d2d22}},	//   _nkaw, ्रे_, íño_, niah,
   {{0x69c7120e,0x21200590,0x26dc807a,0x442b0197}},	//   _htje, _raih_, bavo_, _jrc_,
   {{0xda0e0540,0x798d2d23,0x26dc81e8,0x442b2d24}},	//   _सहमत_, _akaw, cavo_, _mrc_,
   {{0xe69580f7,0x39920019,0x442b026c,0x6f150e1b}},	//   _الاد, lási_, _lrc_, dezc,
   {{0x6721ad25,0xf65282f6,0x8c48080a,0x7bc9ad26}},	//   _halj, _מצב_, _yağı, ppeu,
   {{0x656d2d27,0x4ca580ab,0x6721ad28,0xe81b03a4}},	//   diah, _গ্রু, _kalj, _पैदा_,
   {{0x20022d29,0x69c702ce,0x6721808e,0x6d5bad2a}},	//   rtki_, _otje, _jalj, lhua,
   {{0xceb281db,0xed5a1628,0xa6e3007b,0x20022d2b}},	//   לים_, гов_, íðar, stki_,
   {{0x6d5b80fc,0x26dc8517,0x7afc0267,0xc21281c6}},	//   nhua, zavo_, _scrt, _זהה_,
   {{0x64a30084,0x657603a6,0x7c3bad2c,0xdcfb8380}},	// [1b20] зата, rnyh, nxur, zluğ,
   {{0x39448b3c,0x7c2bad2d,0xb05b016d,0x6721ad2e}},	//   _soms_, _mrgr, rbät, _nalj,
   {{0x260184c3,0x442b009f,0x6d5b8748,0x26dc8084}},	//   jóo_, _erc_, khua, vavo_,
   {{0x00da803f,0x3f8a0136,0xd91080d5,0x6d5b8282}},	//   ابات_, lobu_, بیر_, jhua,
   {{0xdcfb82a5,0x7d160079,0xdb0e00e7,0x5ec980ab}},	//   jluđ, meys, _libé, _রয়ে,
   {{0xa09b0158,0x06d880c8,0x6d4606cb,0x7d162d2f}},	//   ניסט, _সাহি, _hoka, leys,
   {{0x6d462d30,0x7c2b8114,0x60c415a0,0x3944ad31}},	//   _koka, _argr, _ofim, _toms_,
   {{0x2fda83f8,0x75242d32,0x6d462d33,0x6fb68077}},	//   _مورد_, ndiz, _joka, _همرا,
   {{0x7524004f,0x6d462d34,0x3eaa8388,0x67218168}},	//   idiz, _moka, _ºbto_, _falj,
   {{0x6d462d35,0x69c103d3,0xd00f8eca,0x8c1b0039}},	//   _loka, _élec, _سلم_, נויי,
   {{0xd9151006,0x60c904c3,0x61150fe6,0x60dd0102}},	//   одны, ñemo, одну, tasm,
   {{0x27e0805c,0xf53f016d,0x6d5bad36,0xd7fb0198}},	//   šinu_, _ihåg_, chua, луг_,
   {{0xbfb68104,0x588701e5,0x60dd2d37,0xc05803a9}},	//   _điểm_, сына, rasm, бір_,
   {{0x3f8a2d38,0x26da0144,0xac9784a3,0x3c778e82}},	//   gobu_, _cepo_, _انها_, _פתגם_,
   {{0x26da2d39,0x6f1505a4,0x656d00e1,0x39920019}},	//   _depo_, rezc, tiah, zási_,
   {{0x22ae8086,0x6d408247,0x7d160079,0x6a4a8085}},	//   mək_, njma, geys, rəfd,
   {{0x6d9303d3,0x69c71277,0xb4b9000f,0x656d2d3a}},	// [1b30] nçai, _stje, _चली_, riah,
   {{0x656d01ac,0xb87b25a7,0x6b4d8144,0x6d5bad3b}},	//   siah, raíd, _púgi, zhua,
   {{0xfbda88fd,0x644d0239,0x821500f7,0x7d1601b4}},	//   _मौसम, syai, تواص, beys,
   {{0x39920065,0x6d5ba928,0x6dbc005c,0x752281ac}},	//   tási_, xhua, _očaj, _naoz,
   {{0x672198c5,0x261b8076,0x6d4080d2,0xf8078087}},	//   _palj, _मनही_, djma, счен,
   {{0x7c2d811f,0x44292d3c,0xf41f0198,0x2fc90122}},	//   _šaro, mva_, _isä_, _mtag_,
   {{0x6721803a,0x69c7120e,0xe81b175d,0x67238052}},	//   _valj, _utje, _पैसा_, rdnj,
   {{0x60c2ad3d,0xdd9180f7,0x44292d3e,0xd65804de}},	//   ccom, بوع_, ova_, מיות_,
   {{0xe3b693cd,0x7bcd2d3f,0x6721ad40,0x27e080f7}},	//   обы_, npau, _talj, áint_,
   {{0x44292d41,0x6d5bad42,0x98ad80e1,0x60dbad43}},	//   iva_, shua, _hneď_, _heum,
   {{0xe2999289,0x44278416,0x44290406,0x60db80dd}},	//   ран_, _گراف, hva_, _keum,
   {{0x4429003a,0xfd5681bc,0x6d5b81c0,0x7d1601b4}},	//   kva_, _mgbọ, qhua, xeys,
   {{0x6d462d44,0x2bb50d14,0xdce9ad45,0x26da0c53}},	//   _roka, _अंगा, nieč, _pepo_,
   {{0x6d462d46,0x7c29ad47,0xbf9b0073,0x83fd8019}},	//   _soka, mver, stên, rződ,
   {{0x22ae8086,0x3f8a026f,0x614617f4,0x7d162d48}},	//   cək_, robu_, _мека, teys,
   {{0xdce98110,0x7c29a7d1,0x9f468118,0xb05b0338}},	//   kieč, over, iroá_, rbär,
   {{0x06d900c8,0x7d162d49,0xfd5699a8,0x7bcd13d2}},	// [1b40] _তারি, reys, _agbọ, gpau,
   {{0x68e9ad4a,0x75241b68,0x1b1780ab,0x7c29ad4b}},	//   _aded, sdiz, তাকে_, iver,
   {{0x7c299103,0x44292d4c,0xe8220ebf,0x8afc809a}},	//   hver, ava_, मिका_, mięt,
   {{0x60c29c33,0x7c29ad4d,0x629c1f95,0xf1a9803d}},	//   ucom, kver, _vzro, مانه_,
   {{0xb4d62d4e,0x7c29ad4f,0x88169a37,0x68e9ad50}},	//   हरी_, jver, تباط, _dded,
   {{0x05ea9d2f,0x60c2ad51,0xe3a78591,0x8afc809a}},	//   афии_, scom, _زر_, nięt,
   {{0xd6d98cde,0xda0e090a,0x629c003a,0xd5b78364}},	//   сті_, _सहित_, _uzro, осы_,
   {{0x7c290042,0x29002d52,0x7c29ad53,0x60db8706}},	//   _šeri, _ncia_, fver, _geum,
   {{0x7c29ad54,0x8d5b03de,0xb054819d,0x8b6681a8}},	//   gver, יכקי, ọọrụ_, قادم,
   {{0xb4d613d9,0x3f76809a,0xa3dc2207,0xeb4a9cad}},	//   हरु_, dług_, णीय_, рчик_,
   {{0x2b4783d3,0x06d900ab,0x79952d55,0x2c0600ab}},	//   _donc_, _তালি, зинф, রিয়ে_,
   {{0x81bc8341,0xb4b9023c,0x22ae8201,0x212682f7}},	//   lvēk, _चले_, rək_, ndoh_,
   {{0x2006ad56,0x22ae829a,0x32058833,0x69c807b6}},	//   ntoi_, sək_, atly_, _édef,
   {{0x6d9326e1,0xdefb0110,0x21248229,0x7c3b0580}},	//   nçav, шым_, _lamh_, _àuri,
   {{0xb4d60b6f,0xd25080f7,0xc4db04ae,0x3205ad57}},	//   हरू_, _سنة_, иђа_, ctly_,
   {{0xb87b0187,0x395d81c0,0x6ecb170c,0x200683ed}},	//   raíb, xhws_, _त्रु, ktoi_,
   {{0x29192d58,0x4c940198,0x0cab2d59,0x94ab14c4}},	// [1b50] mesa_, дитс, ртви_, ртва_,
   {{0x29192d5a,0x60dbad5b,0x6f188904,0x7bcd00c6}},	//   lesa_, _seum, jevc, rpau,
   {{0x3915885f,0x44292d5c,0x7bcd0110,0x9268108d}},	//   змер, sva_, spau, орца_,
   {{0x68fd1887,0xdb0b8106,0xdb1bad5d,0x28f88749}},	//   ngsd, _utgö, rqué, жець_,
   {{0x25a90ecb,0x67250074,0x39490118,0xdb1b85c9}},	//   mmal_, _kahj, _moas_, squé,
   {{0x7c29ad5e,0x9a87143d,0x3949056c,0x25a92d5f}},	//   vver, _дубл, _loas_, lmal_,
   {{0xd90f8065,0x2006ad60,0x7c29890d,0x316f8118}},	//   _لیا_, atoi_, wver, pigz_,
   {{0x25a902af,0x29192d61,0x67252d62,0xea0000ff}},	//   nmal_, jesa_, _lahj, _hiếp_,
   {{0x29192d63,0xc10480f7,0x7c2980e7,0x657e80e7}},	//   desa_, _توقي, uver, épha,
   {{0x63bd2d64,0x25a901ec,0x67252d65,0x7d09888b}},	//   _musn, hmal_, _nahj, sfes,
   {{0x29192d66,0x39490548,0x25a92d67,0x29000144}},	//   fesa_, _boas_, kmal_, _pcia_,
   {{0x3949062f,0x29192d68,0x7c29ad69,0x9f42001b}},	//   _coas_, gesa_, pver, mské_,
   {{0xdb03ad6a,0x9f4203fb,0x63bb01df,0x44298548}},	//   _minú, lské_, _éunh, _éa_,
   {{0x00000000,0x00000000,0x00000000,0x00000000}},	//   --, --, --, --,
   {{0x9f4203cb,0x6da62d6b,0x2bb5000f,0x442f82f7}},	//   nské_, зива, _अंजा, _hrg_,
   {{0xf9920077,0x7ae1ad6c,0x63bd031d,0xb4d617ba}},	//   _ثبت_, lalt, _busn, हरे_,
   {{0x29c18028,0x27e9ad6d,0xaaba0a47,0xf48400d7}},	// [1b60] _hóa_, šanj_, مدار_, ذاری,
   {{0xdb0b8118,0x8b230d55,0x442f8362,0xed160035}},	//   _augú, ндуе, _mrg_, _łódź_,
   {{0x63b50da8,0x9f42016b,0xb6bb01c6,0xdb1989c4}},	//   _dizn, jské_, _לציי, _cuwé,
   {{0x7ae1ad6e,0x2d8081ac,0xa6d880ab,0x63bd2d6f}},	//   halt, čiek_, _সাইট, _fusn,
   {{0x18188077,0x7ae1a2d2,0x98a68162,0x29c1ad70}},	//   تراک_, kalt, чиде, _lóa_,
   {{0xbb4a0013,0x7bcb2d11,0x291902ec,0x2006ad71}},	//   _الآن_, ígue, zesa_, rtoi_,
   {{0x7ae18fe0,0x442f848d,0x6f188da8,0x29192d72}},	//   dalt, _arg_, revc, yesa_,
   {{0x6d4408de,0xd90d826a,0x7cf6880a,0x442f89ca}},	//   njia, _نیم_, dürü, _brg_,
   {{0x9f5900f2,0x29192d73,0x06e200ab,0x63bd0df6}},	//   ltså_, vesa_, _বানি, _xusn,
   {{0x27e6ad74,0x442f8573,0x44222d75,0x7ae1ad76}},	//   mson_, _drg_, _msk_, galt,
   {{0x442f82d8,0xc333036b,0x29192d77,0x6d5604b9}},	//   _erg_, גות_, tesa_, kkya,
   {{0x463b80be,0x26de876d,0x7ae194c7,0x68e28c53}},	//   _לעבע, _heto_, aalt, naod,
   {{0x7ae1ad78,0x26de80f1,0x24aa80ab,0x63602d79}},	//   balt, _keto_, _গ্রহ, _göng,
   {{0x27e683d3,0x7c22ad7a,0xd3708077,0x7ae1ad7b}},	//   ison_, _isor, _جهت_, calt,
   {{0x29192d7c,0x39920019,0x63b50289,0x2cb9008e}},	//   pesa_, tást_, _rizn, _pgsd_,
   {{0x26dead7d,0x9cfa8264,0x5d9901e2,0x3f8e9fb6}},	//   _leto_, _আসুন_, ікаў_, hofu_,
   {{0x68ed2d7e,0x68e2ad7f,0xa49b0032,0x27e68b80}},	// [1b70] _idad, daod, _abòr, json_,
   {{0x8aa705c2,0x02a70adb,0x25a901ec,0x6d562d80}},	//   пред, прем, smal_, akya,
   {{0x2b0e8023,0x60cda511,0x98bf8087,0xfe1b8424}},	//   त्यु_, ñamo, _nouă_, _भैंस_,
   {{0x1a6804c0,0x63bd2d81,0x9f42026f,0x7c22ad82}},	//   سیقی_, _tusn, vské_, _osor,
   {{0xea000104,0x26dead83,0xbcfb002a,0x7d0d2d84}},	//   _tiếp_, _beto_, _alég, mfas,
   {{0x9f42003e,0x7c2d2d85,0xaae10cfd,0x26de8041}},	//   tské_, mvar, _फ़िक, _ceto_,
   {{0x7ae1ad86,0x26de80b9,0xa3df873c,0x68ed0d6a}},	//   valt, _deto_, धीन_, _odad,
   {{0x7d0d1fba,0x98bf802e,0x27e90292,0x9f42027f}},	//   nfas, _două_, _ovan_, rské_,
   {{0xb4bd835a,0x7ae1ad87,0xbcfb2491,0xdc0b00ab}},	//   _आली_, talt, _elég, রিকস_,
   {{0x63600459,0x68ed2d88,0x04ff80ab,0x7cf68059}},	//   _gönd, _adad, ্যের_, türü,
   {{0x27e906c0,0x7c22ad89,0x6d5d061c,0x987000e1}},	//   _avan_, _esor, _olsa, rúča_,
   {{0x7ae1a6e1,0x442f8796,0x29e78c18,0xdb06002a}},	//   salt, _trg_, rđa_, _yukó,
   {{0x442f80b9,0x7ae1ad8a,0xeb8e8087,0x7d1bad8b}},	//   _urg_, palt, _аи_, meus,
   {{0xdfcf0013,0x6d4bad8c,0x442d920f,0x61faad8d}},	//   شيف_, _hoga, mve_, butl,
   {{0xab28845b,0xdb1b97ad,0x7d0d2d8e,0x7c2d0084}},	//   _رسول_, nquí, ffas, evar,
   {{0x7529ad8f,0x6d4bad90,0x78bb822e,0xe5a304fa}},	//   ndez, _joga, _nguv, виси,
   {{0x9f5fad11,0x6360016d,0x7c2d2d91,0x2fcd822c}},	// [1b80] _aquí_, _löne, gvar, _nteg_,
   {{0x6d4bad92,0xdcdaa769,0xa3df83eb,0xeb9f00e8}},	//   _loga, _यज्ञ, धीय_, _spør_,
   {{0x26deaa63,0x75262d93,0xc87f02af,0x7d1bad94}},	//   _reto_, _takz, raße_, keus,
   {{0x442d803a,0x63602d95,0x26dead96,0xaca38032}},	//   kve_, _sönd, _seto_, _afọj,
   {{0xd0108277,0x44222d97,0xa3f880ab,0x442d80f1}},	//   الت_, _usk_, _অন্য_, jve_,
   {{0x27e68782,0x60c9ad98,0x44200010,0x7d029429}},	//   rson_, _efem, mwi_, _scos,
   {{0xe1e78117,0x442dad99,0x656f031d,0x27e6ad9a}},	//   _جس_, eve_, _ymch, sson_,
   {{0x6f1c2d9b,0x636007d9,0x6d4b9a29,0x7d1bad9c}},	//   herc, _döne, _coga, geus,
   {{0xe3bf01df,0x26de928c,0xea0000ff,0x44200114}},	//   _xuñ_, _teto_, _khắp_, nwi_,
   {{0x6d9307e0,0x291202d6,0x68e0ad9d,0x61faad9e}},	//   nçar, _abya_, _hemd, tutl,
   {{0x6d4bad9f,0x7d2780f2,0x442dada0,0x7d1b8118}},	//   _foga, örsä, ave_, beus,
   {{0x7d1b8373,0x7c2284b9,0x442dada1,0x68e0826c}},	//   ceus, _tsor, bve_, _jemd,
   {{0xab2a91b3,0xf7730829,0x7c22882e,0x442000b4}},	//   _мода_, ناس_, _usor, jwi_,
   {{0x636007d9,0x6f1c2da2,0x44202da3,0x61faada4}},	//   _yöne, gerc, dwi_, putl,
   {{0x672880f1,0xb87b282b,0x7d0d242f,0x7dc782d0}},	//   _madj, caín, tfas, _kısa,
   {{0xbcfb2da5,0x6d4b862f,0x06e200ab,0x68ed2da6}},	//   _amér, _xoga, _বাণি, _udad,
   {{0xdd940196,0x7d0d10f6,0x6f1c2da7,0xb87b00f7}},	// [1b90] таты, rfas, berc, maío,
   {{0x6f1c2da8,0x672889cf,0xb87b0013,0x38668805}},	//   cerc, _nadj, laío, dzor_,
   {{0x442dada9,0x2fcdadaa,0x3f912dab,0x2bdf06f0}},	//   zve_, _steg_, mozu_, _पौरा,
   {{0xb4bd835a,0x63b8942f,0xb87b00f7,0x8aa40dd3}},	//   _आले_, _livn, naío, труд,
   {{0xe739a66c,0xdd910065,0x442d0091,0x6d4badac}},	//   зел_, _لوگ_, _ée_, _roga,
   {{0x25a68019,0x6d4badad,0x442dadae,0xb87b01a8}},	//   _ahol_, _soga, vve_, haío,
   {{0xf7708bbe,0x995c803e,0x7ae52daf,0xe8d911d3}},	//   جان_, síš_, maht, _alọ_,
   {{0x442dadb0,0x6f1c003e,0x94259fd0,0xdb1b85e4}},	//   tve_, zerc, емие, rquí,
   {{0x6d4badb1,0x442dadb2,0x291da5f3,0x7d1badb3}},	//   _voga, uve_, mewa_, reus,
   {{0x291d822e,0x4a45867c,0x1b1d00c8,0x629881b0}},	//   lewa_, енов, নাকে_, _byvo,
   {{0x44202db4,0x63b88503,0x442dadb5,0x6d4b8014}},	//   zwi_, _divn, sve_, _toga,
   {{0x2fc00722,0x9952026f,0x291dadb6,0x25b90f3e}},	//   _puig_, sáž_, newa_, _nisl_,
   {{0x25adadb7,0x394d879f,0xdbd70406,0xf1b9a944}},	//   mmel_, _moes_, _jäät, _miš_,
   {{0x7ae5178f,0x442006c4,0x291dadb8,0x63b8a085}},	//   jaht, vwi_, hewa_, _givn,
   {{0x69962344,0x59b98076,0x291dadb9,0xba5280f7}},	//   _прих, _ईंटर, kewa_, _منوع,
   {{0xa0a60048,0xb87b0013,0xa2cd08fd,0xf1b98024}},	//   _пайд, caío, दुस्, _niš_,
   {{0x248604c3,0xac861663,0x291dadba,0x2bdb001b}},	// [1ba0] çom_, хгал, dewa_, मीला,
   {{0x395fadbb,0xe6258028,0x44201044,0x6b520366}},	//   _alus_, _đông_, rwi_, _nægt,
   {{0x26d82dbc,0xa2a5053e,0x44202dbd,0x6728adbe}},	//   mbro_, _करण्, swi_, _radj,
   {{0x29022dbf,0x8c461593,0x39990019,0x67288353}},	//   ngka_, _земе, tési_, _sadj,
   {{0x394dadc0,0xea000129,0x2d802dc1,0x6728832a}},	//   _does_, _thắp_, mnie_, _padj,
   {{0x2d800063,0x69dc041c,0x6720052a,0x395fadc2}},	//   lnie_, _twre, मजिक_, _elus_,
   {{0xfaa31b2f,0x5693adc3,0x63830098,0x395f81b9}},	//   _баро, лашт, _сгра, _flus_,
   {{0x291dadc4,0x248681df,0xa53480c4,0xd00a9052}},	//   cewa_, _pxom_, тнич, _небе_,
   {{0x9f868221,0x63b89a7c,0xfbcf815b,0x2d802dc5}},	//   _згад, _pivn, یتی_, inie_,
   {{0x5a348e17,0x7c3b12ca,0x2d802dc6,0xdbdb846d}},	//   внот, _áure, hnie_, _dààt,
   {{0x7d0604b8,0x28f92dc7,0xb87b00f7,0x3f9110d1}},	//   _ocks, мень_, taío, vozu_,
   {{0x25d983f8,0xea000104,0x7c262dc8,0xa3c0000d}},	//   _آهنگ_, _nhập_, _oskr, ँदा_,
   {{0x2d800063,0xdd8f8154,0xb87b00f7,0xd83822f0}},	//   dnie_, _اون_, raío, нэр_,
   {{0x4426adc9,0x61fe003a,0x2d80009a,0xb87b00f7}},	//   _iso_, kupl, enie_, saío,
   {{0xbe880ca4,0x249f0088,0xdb03801b,0x59b09516}},	//   есте_, _šum_, _jiný, जगार,
   {{0x2d802dca,0x6564009c,0xba9b8039,0x4426adcb}},	//   gnie_, ghih, _מסוי, _kso_,
   {{0x44268088,0x26d800e5,0x7ae518c2,0x3ebe80c3}},	// [1bb0] _jso_, bbro_, taht, _ogtt_,
   {{0x6d5a08cf,0xd6db0009,0x2d800035,0x63ad8037}},	//   ëtar, _эти_, anie_, _èant,
   {{0xf7718bca,0x395fa4cc,0xa4d9245b,0x2d9202a0}},	//   یات_, _plus_, _одну_, boye_,
   {{0xdbd70364,0x4426811e,0x60b59e91,0x2d80009a}},	//   _päät, _oso_, نمائ, cnie_,
   {{0x4426815e,0xb8e98076,0xbcfb02ba,0x7ae50364}},	//   _nso_, _ईल_, _eléc, paht,
   {{0x394d81b0,0x6d4f0214,0x21298824,0xbcfb0866}},	//   _woes_, _hoca, žah_, _fléc,
   {{0x4426adcc,0x291d8010,0x6d4f2dcd,0x6b52006a}},	//   _aso_, pewa_, _koca, _vægt,
   {{0x752d2dce,0x69c78efc,0x7415845b,0x8477826b}},	//   ndaz, íjem, نوعا, _aáwẹ,
   {{0x51849fa0,0xdb1882d6,0x5f09866f,0xe4c895a9}},	//   _сура, _kivè, _साप्_, ربين_,
   {{0x2d802448,0x799d01ec,0x6b52008b,0xdd0201a1}},	//   znie_, elsw, _hægr, _čučk,
   {{0x4426adcf,0x96ca8540,0x36d48009,0x68e602e8}},	//   _eso_, _स्टॉ, _сохр, takd,
   {{0x27e98341,0x2902816d,0x4ad18701,0x6dbc131b}},	//   šanu_, _ökat_, _द्रव, _očar,
   {{0xf1b28f60,0xd24e80d5,0x8b25add0,0x3ebe8326}},	//   יסט_, منی_, _адле, _ygtt_,
   {{0x06e200ab,0x7bc00187,0x3ebe004a,0x6d5b8bf0}},	//   _বাহি, _émui, øtt_, lkua,
   {{0x6d4f2dd1,0x2d800063,0xfce60171,0x4426add2}},	//   _boca, tnie_, ково, _zso_,
   {{0x7ae38de1,0x2bc30fb8,0x6d5badd3,0x26d82dd4}},	//   _hent, _वंशा, nkua, sbro_,
   {{0xc9530051,0x78a40503,0x69c3add5,0x2d802dd6}},	// [1bc0] _כמה_, _uziv, _hune, rnie_,
   {{0x7ae3add7,0x69c39e98,0x27e02227,0x65642dd8}},	//   _jent, _kune, _iwin_, shih,
   {{0x6d4f0013,0x6dbc0353,0xdb1886c0,0xea0000ff}},	//   _foca, _včas, _divè, _thập_,
   {{0x7ae3add9,0x69c3adda,0x61fe2ddb,0x3f85826c}},	//   _lent, _mune, rupl, _ajlu_,
   {{0x69c3addc,0xf7468003,0xdb0baddd,0x7c26005c}},	//   _lune, кедо, _bugü, _uskr,
   {{0x7bd62dde,0x68e405d1,0x7d042ddf,0x7ae3ade0}},	//   mpyu, _leid, lgis, _nent,
   {{0x69c3ade1,0x91e30e02,0x27ed8051,0x752b81a1}},	//   _nune, _восе, _even_, _bagz,
   {{0x7d042de2,0x68e40114,0x39990f87,0x6d4f2de3}},	//   ngis, _neid, nést_, _xoca,
   {{0x7ae38763,0x63bc26a6,0x7c240192,0x27ed81f4}},	//   _bent, _kirn, nwir, _gven_,
   {{0x69c3ade4,0x3a27808e,0x4426807a,0xdb188061}},	//   _bune, _bsnp_, _vso_, _kivé,
   {{0x68e42de5,0x69c3ade6,0x7ae39ee5,0x6ed88f1b}},	//   _beid, _cune, _dent, _न्यु,
   {{0x442681e9,0x7c2400b4,0x7ae3ade7,0x629c2127}},	//   _tso_, kwir, _eent, _myro,
   {{0x7ae3ade8,0x5887014c,0x68e401e4,0x60cd8020}},	//   _fent, тына, _deid, ñami,
   {{0x7ae3ade9,0x63bc01a1,0x629c02c4,0x52e10035}},	//   _gent, _nirn, _oyro, _फ़ेस,
   {{0xe5c42dea,0xd378811f,0x68e40013,0x31668019}},	//   исто, mić_, _feid, khoz_,
   {{0x7ae3adeb,0x7982809a,0x7d042dec,0x9f59026f}},	//   _zent, jnow, ggis, musí_,
   {{0x63bc03c3,0x6c542ded,0x752d2dee,0x629c0420}},	// [1bd0] _birn, акту, rdaz, _ayro,
   {{0x7ae3862f,0x629c2def,0x7d042df0,0x68e40bfd}},	//   _xent, _byro, agis, _zeid,
   {{0x3f83011f,0xdb050013,0x6562adf1,0x27edadf2}},	//   mnju_, gmhá, _oloh, _sven_,
   {{0xd37885f5,0x6d4f026c,0x7c2402a0,0x9f4203c1}},	//   hić_, _uoca, bwir, mská_,
   {{0xd3788025,0x7ae8adf3,0x629c0bb1,0x9f4205b9}},	//   kić_, kadt, _eyro, lská_,
   {{0x65628091,0xd378803b,0x6360007b,0x490886a7}},	//   _aloh, jić_, _hönn, _हाथो_,
   {{0x63602df4,0x9f42003e,0xd378803b,0x2d55013c}},	//   _könn, nská_, dić_, _fået_,
   {{0xdb1d0a56,0x2d55013c,0x661a8748,0x4424822c}},	//   _musí, _gået_, _dptk, fwm_,
   {{0x7ae38193,0x6d5badf5,0x69c3adf6,0x3f831351}},	//   _pent, rkua, _sune, knju_,
   {{0xd37885f5,0xe9d99016,0x69c3adf7,0x2902816d}},	//   gić_, нко_, _pune, _ökar_,
   {{0x3f83003b,0xc3320158,0xdb0385e4,0x68e42df8}},	//   dnju_, זוי_, _sinó, _peid,
   {{0x69c380fe,0x290911b9,0x7412803d,0x9f42016b}},	//   _vune, _ccaa_, جویا, dská_,
   {{0x68e42a24,0xd3788d78,0xe9e980e1,0xa3dfab12}},	//   _veid, bić_, dnúť_, धीश_,
   {{0x44322df9,0x68e40faf,0xd378809a,0x2d992dfa}},	//   vvy_, _weid, cić_, _akse_,
   {{0x68e42dfb,0x39990019,0x2bdf81fe,0x31790035}},	//   _teid, tést_, पीरा, bisz_,
   {{0x96d411bc,0x63bc2dfc,0x7c242dfd,0x2d960a14}},	//   _ब्रॉ, _sirn, twir, ургс,
   {{0x6da30087,0x09cc016f,0x3f832bea,0x629c0690}},	// [1be0] сита, ाऱ्य, bnju_, _syro,
   {{0x7c242dfe,0x44322dff,0xfbcd00ab,0x87260009}},	//   rwir, rvy_, _লিখত, _смож,
   {{0xe8faa9d7,0x20022e00,0x7c242e01,0x644001a1}},	//   еле_, luki_, swir, _šmid,
   {{0x629c027f,0xd3788d78,0x786a8019,0x88e68198}},	//   _vyro, zić_, _növé, ужде,
   {{0x63bc2e02,0x20022e03,0xe3c880ff,0x629c0035}},	//   _tirn, nuki_, _mực_, _wyro,
   {{0xdb1c00f1,0xe3c88028,0x31668019,0x96a8001b}},	//   _mirë, _lực_, shoz_, _गराउ,
   {{0xd378803b,0x6b631594,0x7bc60300,0xd6d9804a}},	//   vić_, _укра, _huku, тті_,
   {{0x7bc62e04,0x3f83007d,0x1db4035a,0xd378809a}},	//   _kuku, znju_, ंगित, wić_,
   {{0xd378803a,0x12e68a4c,0x7bc62e05,0xe64483bf}},	//   tić_, лінг, _juku, ılığ,
   {{0x96d42e06,0x20022e07,0x7bc620d7,0x39402e08}},	//   _ब्लॉ, duki_, _muku, _anis_,
   {{0xd378803a,0x7bc62e09,0xdb0380f7,0x3f832e0a}},	//   rić_, _luku, _ghní, vnju_,
   {{0x2ee58613,0xe3c88028,0x9f42026f,0xf1ab0077}},	//   _zelf_, _cực_, vská_, عاده_,
   {{0x8d938013,0x3f830024,0x7bc62e0b,0x69c100e7}},	//   _النش, tnju_, _nuku, _élev,
   {{0x9f42026f,0x3179009a,0x28e30128,0x636001fa}},	//   tská_, sisz_, परहि, _sönn,
   {{0x58d50698,0x31790063,0xe8d90135,0x3f83012b}},	//   _койт, pisz_, _ajụ_, rnju_,
   {{0x7bc62e0c,0x3f8302a5,0x9f42026f,0x20022e0d}},	//   _buku, snju_, rská_, buki_,
   {{0x7bc60763,0x3f83173d,0x337513bf,0x80cd8264}},	// [1bf0] _cuku, pnju_, агар, ারম্,
   {{0x7bc62e0e,0x9f42128a,0x332e8372,0xa3e6885d}},	//   _duku, pská_, _jafx_, यीय_,
   {{0xfaa7174a,0x02a726b1,0xb4db0362,0xe9e981d6}},	//   ушан, урам, _cnàc, pnúť_,
   {{0xdc34026f,0x27ed012b,0x2ee58039,0x3835802e}},	//   _zúča, šenu_, _self_, инер,
   {{0x7bc61b19,0x3b0a0580,0x5045847f,0x6360029a}},	//   _guku, _fcbq_, релб, _könl,
   {{0x6d4d2e0f,0xb0d580d4,0x29068102,0x2b140ebf}},	//   ljaa, _ड्रग, agoa_, न्दु_,
   {{0xf1a785c2,0x7bc601ec,0xd0560085,0xf1c980ff}},	//   _бран, _zuku, _deyə, _mạc_,
   {{0x442b2e10,0x6d4d2e11,0xf1c98028,0x528400f7}},	//   _ksc_, njaa, _lạc_, _الفك,
   {{0x7bc602a3,0xab6595ac,0x2ee5ae12,0x69ceae13}},	//   _xuku, ивил, _telf_, íben,
   {{0xce6b9a19,0x69c72e14,0xd7a4000f,0x68eb84dc}},	//   _пред_, _kuje, _खींच, lagd,
   {{0x216a22df,0x6723895e,0xa96a013a,0xfaa5ae15}},	//   вини_, menj, вина_, рано,
   {{0x69c704a1,0x67238353,0xdc3401ac,0x442b00ee}},	//   _muje, lenj, _súča, _osc_,
   {{0x6603ae16,0xe3c88028,0x25e30540,0xf1c9801c}},	//   lunk, _vực_, टीसी_, _bạc_,
   {{0x7bc62e17,0x66e301e5,0x20022e18,0x6723ae19}},	//   _ruku, жора, ruki_, nenj,
   {{0x13da80c8,0x7bc62e1a,0x20020590,0x799b8c56}},	//   _দিয়, _suku, suki_, _okuw,
   {{0x7bc613b8,0x6723ae1b,0x6446816d,0x39402e1c}},	//   _puku, henj, åkig, _unis_,

   {{0x6723ae1d,0x644984c3,0x69d5011e,0x68eb96fb}},	// [1c00] kenj, nxei, _atze, dagd,
   {{0x44392e1e,0xaaba026a,0x6603ae1f,0x25a0141f}},	//   _drs_, ندار_, kunk, slil_,
   {{0x44392e20,0x7ae72e21,0x69c70052,0x67238805}},	//   _ers_, _dejt, _cuje, denj,
   {{0x7bc62e22,0xe3c8801c,0xdb0f0825,0x44392e23}},	//   _tuku, _lựa_, _bucó, _frs_,
   {{0x6a4a8201,0x2906ae24,0x33d52e25,0x3860978e}},	//   rəfi, rgoa_, _гіст, áir_,
   {{0x752f009a,0x6723ae26,0x25e30105,0x78a9826c}},	//   _zacz, genj, टीवी_, _dzev,
   {{0x69c18526,0x25fd8f85,0x7c2d8e9f,0x9f590036}},	//   _रंगी, रंगी_, _šarp, ursé_,
   {{0x3f98001b,0xdb1c21bf,0xa6e9801c,0x7ae72e27}},	//   horu_, _sirè, _ngươ, _zejt,
   {{0x69c0ae28,0x442b0118,0x6723ae29,0xdb072e2a}},	//   _iime, _xsc_, benj, _gijó,
   {{0x4aaa2e2b,0x6723803b,0x69c0ae2c,0x7c398122}},	//   _कराव, cenj, _hime, _drwr,
   {{0x69c10065,0x195917ae,0x69c0ae2d,0xe3c880ff}},	//   _élet, ганы_, _kime, _dựa_,
   {{0x50672e2e,0xf1c980ff,0x2c5e00eb,0x69c0ae2f}},	//   атга, _sạc_, _kādā_, _jime,
   {{0xb8cf0403,0x938a8098,0x8ca20d86,0x68f6031d}},	//   _कर_, _иска_, _खरगो, _ddyd,
   {{0x69c0ae30,0x3f9802a5,0x09d700ab,0x65662e31}},	//   _lime, goru_, _হিসা, _alkh,
   {{0x7ae72e32,0x752f0035,0xdef801e2,0xa1870d15}},	//   _rejt, _pacz, шыя_, _выпл,
   {{0x81c40a49,0x69c0ae33,0x672380d2,0x442b009f}},	//   _এবং_, _nime, zenj, _psc_,
   {{0x69c72e34,0x6d4d2e35,0x61fe110f,0xf2c701cf}},	// [1c10] _suje, rjaa, erpl, асен,
   {{0x34a7023c,0x69c0ae36,0x44392e37,0xdb0a80f7}},	//   _खरीद, _aime, _vrs_, _bhfé,
   {{0x6723ae38,0x5f00800f,0x69c0ae39,0x6d428162}},	//   venj, _राज्_, _bime, _onoa,
   {{0xdd8683f8,0x98a9811f,0x44392e3a,0xdb0f0144}},	//   _رو_, žač_, _trs_, _pucó,
   {{0xe8f8902a,0x7ae70038,0x44392e3b,0x6723a76e}},	//   рлі_, _tejt, _urs_, tenj,
   {{0x44292578,0x2fc901e9,0x6d4282c4,0x6603a9bd}},	//   mwa_, _muag_, _anoa, tunk,
   {{0x672382a5,0x442926e0,0x2fc901e9,0xdb1881df}},	//   renj, lwa_, _luag_, _civí,
   {{0x6723825b,0x6603ae3c,0x99858013,0xf8bf2e3d}},	//   senj, runk, _الرو, ndés_,
   {{0x44292e3e,0x1c4297ae,0x681a80eb,0x6723acc7}},	//   nwa_, зным, gādā, penj,
   {{0x69c08010,0x6569ae3f,0x44292e40,0xb4e68035}},	//   _zime, sheh, iwa_, _बड़ी_,
   {{0x44292e41,0xb6358277,0xed358162,0x68e9ae42}},	//   hwa_, _دفاع, _гэлэ, _keed,
   {{0x44292e43,0x68e982a3,0xce689878,0x3f982e44}},	//   kwa_, _jeed, _труд_, woru_,
   {{0x3438819f,0xa2e800c8,0x68e9ae45,0x2fc901c5}},	//   _پسند_, _পাসও, _meed, _cuag_,
   {{0x59cf8a16,0x4429029b,0x50d80eed,0x68e9ae46}},	//   _संपर, dwa_, _भ्रष, _leed,
   {{0x44292e47,0x7c29844e,0xdb0380f7,0xc8798087}},	//   ewa_, lwer, _ghná, _deşi_,
   {{0xbf9b03a7,0x68e98039,0x44292e48,0x3f982e49}},	//   quên, _need, fwa_, soru_,
   {{0x44292e4a,0x7c29ae4b,0x69c0ae4c,0x75242a6b}},	// [1c20] gwa_, nwer, _rime, reiz,
   {{0x69c0ae4d,0x06e200ab,0x290d8087,0x7d098192}},	//   _sime, _বাকি, _acea_, hges,
   {{0xcf57004c,0xe1fa168a,0xe80a8076,0x44291f11}},	//   _הבית_, уге_, हूना_, awa_,
   {{0x44291d1b,0xb4e6923a,0x7c29ae4e,0x2638026f}},	//   bwa_, _बजे_, kwer, _ičo_,
   {{0x7bcfa6f0,0x69c0ae4f,0x7d09949d,0x6360016d}},	//   ícul, _vime, dges, _jönk,
   {{0x69da9766,0xaa462e50,0x7c29ae51,0x2d9d8326}},	//   ypte, _легл, dwer, _akwe_,
   {{0x69c0ae52,0xf38a877f,0x68e9ae53,0x6b630d15}},	//   _time, nṣe_, _feed, _экра,
   {{0x68e98079,0x7c29ae54,0xea00001c,0xdb1885e4}},	//   _geed, fwer, _chấp_, _viví,
   {{0x7866a804,0x80668f75,0x7c29ae55,0xa6c000ab}},	//   _указ, _уваж, gwer, ্রিয়,
   {{0x681a8029,0x6e3ca868,0x2619009a,0x7d09ae56}},	//   rādā, _árbo, _पहली_, ages,
   {{0x44292e57,0x6b9b00be,0x68e981b4,0xcb9b1101}},	//   zwa_, רשיד, _yeed, רסיט,
   {{0xd90f15e4,0x44292e58,0x7c2983f4,0x2fc901c5}},	//   ریخ_, ywa_, bwer, _puag_,
   {{0x34a7016f,0x2fc901c0,0xf8ba970c,0x91ca80bc}},	//   _खरेद, _quag_, ेशिय, _संवै,
   {{0x44290205,0x2fc90069,0xd7f80198,0x69daae59}},	//   vwa_, _vuag_, щую_, ppte,
   {{0xf1c98028,0x7aea802e,0x442904b7,0x4b7b8e82}},	//   _hạn_, _ieft, wwa_, _תאוו,
   {{0x44292e5a,0x2fc92e5b,0x46d9064a,0x6b9a87f1}},	//   twa_, _tuag_, _ब्रह, lotg,
   {{0x68e9ae5c,0xd05d0201,0xf8bf2e5d,0x44292e5e}},	// [1c30] _reed, yasə, rdés_, uwa_,
   {{0x44292e5f,0x7aea803a,0x69caae60,0xf1c980ff}},	//   rwa_, _jeft, _kufe, _mạn_,
   {{0x44292e61,0x201f8087,0x7d09867f,0x9d190087}},	//   swa_, _spui_, yges, _конт_,
   {{0xe705026a,0x44292e62,0x69ca8e72,0x3f9eae63}},	//   _اسکی, pwa_, _mufe, _aktu_,
   {{0x44292e64,0x260681ce,0xf1c9801c,0xbae800ab}},	//   qwa_, सूसी_, _nạn_, _পারছ,
   {{0x7c2f0698,0xe739ae65,0x7aea8085,0x45d58293}},	//   _iscr, рек_, _neft, оцит,
   {{0x7d098e61,0x636d8c52,0x7c299699,0x9c1381bc}},	//   tges, _húng, wwer, _tọkw,
   {{0xf1c98142,0xf77391fb,0x7c29ae66,0xed5993f1}},	//   _bạn_, _کار_, twer, рои_,
   {{0x7d09ae67,0x69d8ac62,0x7c2981ed,0x25fd8fd5}},	//   rges, _atve, uwer, रूजी_,
   {{0x7c29910f,0x7d09ae68,0x6d932e69,0x3205816b}},	//   rwer, sges, lħad, tuly_,
   {{0xdce2803a,0xea00001c,0x2d8910e4,0xdd9983f2}},	//   _zloč, _thấp_, knae_, poň_,
   {{0x26138073,0x24198009,0x7c29ae6a,0xdb0180e7}},	//   mão_, _воды_, pwer, illé,
   {{0x26138073,0x656d2e6b,0xb87b0207,0x6b9aae6c}},	//   lão_, dhah, daís, botg,
   {{0x88ba8039,0x78ad0b80,0xdb0a87f1,0x7bd98db1}},	//   יזרי, _dzav, _difó, _itwu,
   {{0x3ebe2e6d,0x443dae6e,0x7bcbae6f,0x26138187}},	//   ätt_, _hrw_, _hugu, não_,
   {{0x7bc39341,0x7bcb8f45,0x656d02b8,0x2d8902f7}},	//   _hinu, _kugu, ghah, gnae_,
   {{0x7bcbae70,0x7bc3ae71,0xfd648135,0x64a32e72}},	// [1c40] _jugu, _kinu, _anwụ, дата,
   {{0xaac986bf,0xdb188019,0x443d8333,0x636001ec}},	//   रशिक, _kivá, _mrw_, _köni,
   {{0x442f82f7,0x26138187,0x7bcbae73,0x2d9e0036}},	//   _lsg_, jão_, _lugu, îtes_,
   {{0xdce280ce,0x26138073,0x8c4609e0,0x02aa12c6}},	//   _ploč, dão_, _деме, _करीन,
   {{0x274a80ae,0x2eeeae74,0x6d462e75,0x443dae76}},	//   ичко_, taff_, _inka, _nrw_,
   {{0x442209da,0x7bc3ae77,0x29d70372,0x2613841c}},	//   _ipk_, _ninu, _bħad_, fão_,
   {{0x7bcb9e44,0x2eeeae78,0x261383a7,0xf1c9801c}},	//   _augu, raff_, gão_, _sạn_,
   {{0x54549bc1,0x7bc38006,0x7bcbae79,0x44220b99}},	//   звит, _ainu, _bugu, _kpk_,
   {{0x68e2ae7a,0xa067ae7b,0xa2be063a,0x7bc3a68b}},	//   mbod, _дата_, _वृत्, _binu,
   {{0x7bcb8102,0xb4db009f,0x2d680214,0x7bc3808e}},	//   _dugu, _anàl, rşey_, _cinu,
   {{0x6d462e7c,0x78ad0019,0x7bc3ae7d,0x261383a7}},	//   _onka, _szav, _dinu, cão_,
   {{0x7bc3807b,0xdb1d02af,0xdb18826f,0x3f9c80fa}},	//   _einu, _zusä, _divá, lovu_,
   {{0x6440011f,0x6727022b,0x69caae7e,0x60c901a1}},	//   _šmin, tejj, _wufe, žemo,
   {{0x3f9c8025,0x6d460835,0x7c228136,0x7bc3ae7f}},	//   novu_, _anka, _ipor, _ginu,
   {{0x69d8ae80,0x44222e81,0xdb1c0118,0x656d00d7}},	//   _utve, _apk_, _cirí, thah,
   {{0x3f9c8042,0x31690052,0x44222e82,0x656d2e83}},	//   hovu_, _ulaz_, _bpk_, uhah,
   {{0xb87b2a63,0x261383a7,0x78ad03fb,0x636d802a}},	// [1c50] raís, zão_, _uzav, _fúnd,
   {{0x656d2e84,0x27e92e85,0xfaa71383,0x6d462e86}},	//   shah, _iwan_, ошен, _enka,
   {{0x68ed0867,0xa2be0af3,0x26138073,0x27e90683}},	//   _kead, _वृद्, xão_, _hwan_,
   {{0x68e28091,0x27e92bb7,0xa2daa769,0x61e701c0}},	//   gbod, _kwan_, पुत्, _vwjl,
   {{0xd6bd00c8,0xf7458f13,0x442200b9,0xb8d3864a}},	//   _অভিয, зело, _gpk_, _ऑर_,
   {{0x26138003,0xdfce8013,0x7d0d2e87,0x7c2d2668}},	//   tão_, ديو_, lgas, mwar,
   {{0x7c22ae88,0x59c69344,0x7bc3ae89,0xf9938277}},	//   _apor, _रंगर, _rinu, _قبر_,
   {{0x261380a9,0x7d0d2e8a,0x7bcb809f,0x442fae8b}},	//   rão_, ngas, _pugu, _psg_,
   {{0x261380a9,0xa3e68076,0x7bc3ae8c,0x7c2d2e8d}},	//   são_, यील_, _pinu, nwar,
   {{0x59cf8935,0x261383a7,0x31b6066b,0x6d9304b7}},	//   _संदर, pão_, ृद्ध, nħab,
   {{0xe299839d,0x7c2d2e8e,0x27e92e8f,0x7bc3ae90}},	//   сан_, hwar, _awan_, _vinu,
   {{0x7c2d082e,0xbea8803d,0xfc3f077f,0x68ed0cb5}},	//   kwar, _بهمن_, _orí_, _cead,
   {{0x7bc3ae91,0xf1c98104,0x8d748077,0xdb1c0118}},	//   _tinu, _tạo_, _تالا, _sirí,
   {{0x81e10a49,0x442d82f4,0x7c2d2e92,0x657d2e93}},	//   _দিন_, mwe_, dwar, _amsh,
   {{0x6d5980a4,0x442dae94,0x68ed0ad0,0xdcfb807d}},	//   _kowa, lwe_, _fead, gnuć,
   {{0x60c9ae95,0x7d0d0fc3,0xdb1c03a2,0x3f9cae96}},	//   _ngem, ggas, _virí, zovu_,
   {{0x442dae97,0x7c2d2e98,0x2b581458,0x6d598c2e}},	// [1c60] nwe_, gwar, _porc_, _mowa,
   {{0x083b0051,0x291f81bc,0x7d0d2e99,0x44222e9a}},	//   _פעיל, _abua_, agas, _vpk_,
   {{0xa9268991,0xb6a300e7,0x442dae9b,0xa75b01c6}},	//   здел, éâtr, hwe_, _הדיר,
   {{0x442da08c,0x6d59ae9c,0xfc3f01fa,0x68ed03a8}},	//   kwe_, _nowa, _frí_, _xead,
   {{0x07a69285,0x442d8578,0x684681e5,0x68e2ae9d}},	//   падн, jwe_, янда, rbod,
   {{0xe3a78b76,0x501b0039,0x21200359,0x1b0300ab}},	//   _سر_, מונו, _lbih_, র্বে_,
   {{0x7d1bae9e,0x2cc18201,0x442d81b0,0x6d59838a}},	//   ffus, ərdə_, ewe_, _bowa,
   {{0x3f9c825b,0x6b818013,0x69ce0087,0x7d7880f7}},	//   sovu_, eilg, _iube, تمبر_,
   {{0x442dae9f,0x69ce2ea0,0x68ed0051,0x6d59aea1}},	//   gwe_, _hube, _read, _dowa,
   {{0x69ce0f45,0x68ed2ea2,0xb4ac800d,0x27f7800d}},	//   _kube, _sead, _गरी_, ření_,
   {{0x52138071,0xcfc400ab,0x442daea3,0x7c2d2ea4}},	//   ндэт, ্ঠান, awe_, zwar,
   {{0x442daea5,0x7c22973d,0x7982809a,0x69ce1bcb}},	//   bwe_, _tpor, niow, _mube,
   {{0x7c22aea6,0x69ce2ea7,0x43468ba5,0x6b819c0a}},	//   _upor, _lube, _недв, bilg,
   {{0xc7c40009,0x6d59aea8,0xb9042261,0x69dc2ea9}},	//   есси, _zowa, _प्_, _otre,
   {{0xd7888104,0x68ed0006,0x21200fda,0x69ce05e4}},	//   yển_, _tead, _fbih_, _nube,
   {{0xbcfb2eaa,0x7c2d262b,0x7aee0f3e,0x7d0d0789}},	//   _llév, twar, _aebt, ugas,
   {{0x94ab2eab,0x7d0d2eac,0x69dc209c,0x2d5802c7}},	// [1c70] ства_, rgas, _atre, чить_,
   {{0x212b2ead,0x69ce2eae,0x3dc680b9,0x7c2d2eaf}},	//   lech_, _bube, _liow_, rwar,
   {{0x69ce2eb0,0x442daeb1,0x200b00d2,0x35b52eb2}},	//   _cube, zwe_, luci_, _обор,
   {{0xfc3f2eb3,0x6b81aeb4,0x212b2eb5,0x69ce2eb6}},	//   _trí_, zilg, nech_, _dube,
   {{0xf77084c0,0x6d59aeb7,0x20192eb8,0x200b0503}},	//   گان_, _rowa, ntsi_, nuci_,
   {{0x6d59aeb9,0x7bdd2eba,0xf09400be,0x25a92ebb}},	//   _sowa, _itsu, ענס_, llal_,
   {{0xf770806b,0xa3c29a1c,0x69ce2ebc,0x442d867f}},	//   دان_, ्दन_, _gube, wwe_,
   {{0x442da0d7,0x61fa007b,0x7982809a,0x7bc70144}},	//   twe_, _ætla, ciow, _hiju,
   {{0x442d8586,0x6b81aebd,0x200b0042,0x212b001b}},	//   uwe_, tilg, juci_, dech_,
   {{0xe1f99bc1,0x442daebe,0xdb1c0019,0x7bcf261d}},	//   ого_, rwe_, _kirá, _mucu,
   {{0x7bcf2ebf,0x3f832ec0,0x442da6bd,0xf1c9801c}},	//   _lucu, diju_, swe_, _tạm_,
   {{0x290f859c,0x7bdd0006,0xdb1c0333,0x37e20264}},	//   ngga_, _otsu, _mirá, _বিবর,
   {{0x02aa1344,0x59cf858c,0x7bdd01e9,0x200b00d2}},	//   _कर्न, _संवर, _ntsu, guci_,
   {{0x3f830025,0x6b8182a6,0xdb1c0144,0x1b030264}},	//   giju_, qilg, _oirá, র্তে_,
   {{0x7bcf03d3,0x6372006a,0xe5a62ec1,0xddd401d6}},	//   _aucu, _hæng, диви, ňažn,
   {{0x7bcf0012,0xdb188364,0x200b2ec2,0x2d8daec3}},	//   _bucu, _eivä, buci_, nnee_,
   {{0xe73a15fe,0x3f831487,0x7bc72ec4,0x6721a7b1}},	// [1c80] _деп_, biju_, _biju, _oblj,
   {{0x39490025,0x09e61bc1,0x6372006a,0x316d86c4}},	//   _znas_, дожн, _mæng, _alez_,
   {{0x7bc701f1,0x63720022,0x39990e06,0x6b9e2ec5}},	//   _diju, _læng, vész_, ropg,
   {{0x6e3ca6d5,0x7aee2ec6,0xdb1c0333,0xfc4a9434}},	//   _árbi, _webt, _dirá, ntíð_,
   {{0xb4ac800d,0xdfcf8c3b,0x7bc7017f,0x629500b9}},	//   _गरे_, لين_, _fiju, _exzo,
   {{0x212b085d,0x26d82ec7,0x3dc680b9,0x6d5d8106}},	//   zech_, ncro_, _siow_, ösan,
   {{0x69dc239a,0x63600019,0x200b2ec8,0xdb1c002a}},	//   _utre, _dönt, zuci_, _girá,
   {{0x2d8daec9,0xd8268a2e,0x63648580,0x6d56018f}},	//   gnee_, _одби, _iòni, njya,
   {{0xf8b28105,0xae0282f1,0x212b2eca,0x657a1a1f}},	//   _जरिय, रूजन_, vech_, éthy,
   {{0xd370845a,0x200b02a5,0x6eb6866e,0xdb0a8174}},	//   اهد_, vuci_, _قصائ, _bhfá,
   {{0xc3331a0f,0x3f83005c,0x212b001b,0x25a02ecb}},	//   דות_, viju_, tech_, koil_,
   {{0x80fb23e6,0x6372006a,0x63600106,0xe7f58035}},	//   ्लेख_, _fæng, _köns, ुंचा_,
   {{0x3f83025b,0x212b2ecc,0x63602ecd,0xd8380087}},	//   tiju_, rech_, _yönt, мэр_,
   {{0x4426aece,0x2d84aecf,0x6360016d,0xa2948a8e}},	//   _ipo_, lime_, _möns, _палі,
   {{0x290f8186,0x212b1e1e,0x200b09c4,0x63600106}},	//   ygga_, pech_, suci_, _löns,
   {{0x394905b4,0x26170073,0x2d84aed0,0x7bcf2ed1}},	//   _unas_, rço_, nime_, _pucu,
   {{0x36d516df,0x60cd26bd,0x9f4205b9,0xc3130032}},	// [1c90] _попр, _igam, lský_, _ajíṣ,
   {{0x25a91807,0x4426aed2,0x316d81a1,0x2006aed3}},	//   slal_, _mpo_, _slez_, droi_,
   {{0x9f42027f,0x2d84aed4,0x7bc72ed5,0x636487f1}},	//   nský_, kime_, _viju, _còni,
   {{0x4adf0913,0x3949840e,0x4426aed6,0xdb1c0019}},	//   _प्रव, ñas_, _opo_, _virá,
   {{0x44268282,0x752d002e,0x636d80f7,0x60cd2ed7}},	//   _npo_, meaz, _lúna, _mgam,
   {{0x752d002e,0xbcfb2ed8,0x2d848118,0x798083f7}},	//   leaz, _elét, eime_, _emmw,
   {{0x442688cf,0x69ca8128,0x6da5aed9,0x38698916}},	//   _apo_, _संगी, ника, šar_,
   {{0x636000f2,0x60cd2eda,0x752d002e,0x2d84aedb}},	//   _föns, _ngam, neaz, gime_,
   {{0x6d5d2edc,0x6442aedd,0xa2d606bf,0x4426808e}},	//   _mosa, _croi, मुक्, _cpo_,
   {{0x644294e1,0x60cd20fc,0x4426aede,0xf1c9801c}},	//   _droi, _agam, _dpo_, _hại_,
   {{0x442684be,0x80c200d4,0x636d81a8,0x2d84aedf}},	//   _epo_, रेने, _cúna, bime_,
   {{0x6442aee0,0x6d5d2ee1,0x5c758256,0x752d0087}},	//   _froi, _nosa, _плет, jeaz,
   {{0x6d4baee2,0xeb8e96cf,0xf1c98028,0xec6e8dc0}},	//   _inga, _би_, _mại_, _сп_,
   {{0xf1c98104,0x27ed8f23,0xa3c08540,0x443fad3c}},	//   _lại_, _mwen_, ंगण_, mvu_,
   {{0x6d5d056f,0x69ce8e15,0x60cd002a,0x443faee3}},	//   _bosa, íbet, _fgam, lvu_,
   {{0x6d5d2ee4,0x753baee5,0xed5715d1,0xf65280be}},	//   _cosa, nduz, нос_, נצן_,
   {{0x6d5d2ee6,0x443f82ec,0x2fdf8069,0xf1ac1251}},	// [1ca0] _dosa, nvu_, _ntug_, _टीएन,
   {{0x60dbaee7,0x25a02ee8,0x27e00110,0x79862ee9}},	//   _afum, soil_, _itin_, likw,
   {{0x6d4baeea,0x6d5d1d8c,0x090695bf,0x443faeeb}},	//   _onga, _fosa, епен, hvu_,
   {{0x2d84aeec,0x443f803a,0x7e6100f2,0x79862eed}},	//   xime_, kvu_, älpe, nikw,
   {{0x40349071,0x69c9aeee,0x63a1aeef,0x2d84aef0}},	//   телс, _diee, koln, vime_,
   {{0x6d4baef1,0xf1ca0129,0x4426aef2,0x60dbaef3}},	//   _anga, _dại_, _rpo_, _efum,
   {{0xe297111c,0xe5c68ada,0x443f9693,0x27ed8706}},	//   _зар_, нсио, evu_, _ewen_,
   {{0x9f42003e,0xd5b781bb,0xdb1c0214,0x29000135}},	//   vský_, нсы_, _birç, _ndia_,
   {{0x6d4b8359,0x6372006a,0x70af123a,0x79862ef4}},	//   _dnga, _tænd, _घरेल, dikw,
   {{0x8883a86e,0x2d84aef5,0x5c739663,0x752d002e}},	//   _служ, sime_, ульт, zeaz,
   {{0x27e0009c,0x7e9a8a47,0xa294902a,0x2a6a8061}},	//   _atin_, _عنصر_, тані, ább_,
   {{0x32029385,0x6442aef6,0x9f421c18,0x67d526b1}},	//   čky_, _troi, rský_, кому,
   {{0x38668722,0x752d0087,0x4426aef7,0x63a1aef8}},	//   nyor_, veaz, _upo_, boln,
   {{0x6d5d00a4,0x4432031d,0x66010019,0x69ce802a}},	//   _sosa, dwy_, álko, íbes,
   {{0xf1a72657,0x79a718ff,0x752d2ef9,0x644780eb}},	//   _прин, _прие, teaz, ājie,
   {{0x60cd2efa,0xbcfb25a7,0x29d70372,0xe534076a}},	//   _ugam, _alér, _bħan_, лесь,
   {{0x752d0012,0x7bcaaefb,0xfbd3006b,0x6d5d2efc}},	// [1cb0] reaz, _kifu, اتر_, _vosa,
   {{0x673aa4a0,0x752d002e,0x60dbaefd,0x7bca804f}},	//   _natj, seaz, _sfum, _jifu,
   {{0x6d5d0013,0x752d0870,0x69c98029,0x61faaefe}},	//   _tosa, peaz, _piee, nstl,
   {{0x7ff5819f,0xbcfb0065,0x27ed86c0,0xb4db0980}},	//   نستا, _elér, _pwen_, _anàv,
   {{0xa3c283bb,0xe7399878,0xa3c0aeff,0x29d704b7}},	//   ्दा_, дел_, ंगा_, _għan_,
   {{0x25a6af00,0x6d4b80dd,0xdb0501a8,0x79862f01}},	//   _akol_, _snga, rmhó, zikw,
   {{0x6d4b80dd,0xed59af02,0x63a183c1,0x61ee0428}},	//   _pnga, дой_, voln, _gwbl,
   {{0xf1ca0104,0x92e900c8,0x63a1809a,0xf1a4af03}},	//   _tại_, _যায়_, woln, _брун,
   {{0x02c98aed,0x210401e2,0xe3b98703,0x656982af}},	//   रश्न, nčių_, мби_, rkeh,
   {{0x4a458e12,0x443faf04,0x200faf05,0x6569af06}},	//   внов, rvu_, mugi_, skeh,
   {{0x3f87af07,0x200faf08,0x6aaa831d,0x779087d2}},	//   minu_, lugi_, _cyff, _دیوا,
   {{0x3f87af09,0x6d4ba890,0x212f826c,0x69dc8174}},	//   linu_, _unga, negh_, írea,
   {{0x63a18db7,0x8d74af0a,0x79862f0b,0xb0a51774}},	//   poln, _حالا, rikw, _गुदग,
   {{0x25adaf0c,0x79862970,0xa283803d,0x25bf8087}},	//   llel_, sikw, _میخو, lmul_,
   {{0xbea60056,0x7af70079,0x6aaa8114,0xe3c880ff}},	//   тавк, daxt, _gyff, _cựu_,
   {{0x395faf0d,0x1614000f,0x7bcaaf0e,0x44320035}},	//   _nous_, तंबर_, _zifu, twy_,
   {{0xccf2812a,0xf773003d,0x3f87af0f,0x61fc0390}},	// [1cc0] יכן_, _چاپ_, kinu_, _svrl,
   {{0x4432064c,0x200f8074,0xc88701ec,0x31caaac2}},	//   rwy_, dugi_, ößer_, िद्ध,
   {{0x3f878289,0xc33284de,0xf506028b,0x7ae58074}},	//   dinu_, שוב_, _изно, _õhtu,
   {{0xcfe680c8,0xb8162701,0x4a5a8039,0x200faf10}},	//   _নিবন, _तमाम_, ודעו, fugi_,
   {{0x395faf11,0x394d8775,0x261486b7,0x2d922f12}},	//   _dous_, _dnes_, नूनी_, mnye_,
   {{0x394daf13,0x3f87807b,0xbf9b00e7,0x2d9200dd}},	//   _enes_, ginu_, quêt, lnye_,
   {{0x6e288713,0x7bca9360,0x6aa301ec,0x2bd8143e}},	//   _qpdb, _rifu, ünft, _भंडा,
   {{0x2d922f14,0x7bcaaf15,0x3160011b,0xfbe78129}},	//   nnye_, _sifu, _noiz_, _thế_,
   {{0x3f878024,0x2d9200b9,0xd0e30c2d,0x47c68110}},	//   binu_, inye_, _क्षण_, _абав,
   {{0x3f8780d2,0x64460088,0x2d9200ee,0x3d148075}},	//   cinu_, _mrki, hnye_, _धावे_,
   {{0x27e68cc0,0xcb130039,0xc224826a,0x2d92036e}},	//   lpon_, בלת_, اکتو, knye_,
   {{0xfce6a1ae,0x64462f16,0x25a6820d,0x7984008e}},	//   _родо, _orki, _ukol_, _cmiw,
   {{0x7d02af17,0x2d9200b9,0x27e6af18,0xf1bf2ab5}},	//   _idos, dnye_, npon_, rmá_,
   {{0x29d704b7,0x257503ba,0x27e680e4,0x798403f7}},	//   _bħal_, _måle_, ipon_, _emiw,
   {{0x64462f19,0x636d81a8,0xfbb781c6,0xc333825f}},	//   _arki, _múnl, _שפות_, _כוס_,
   {{0x6446017f,0x39150391,0x81e100ab,0x69cb0107}},	//   _brki, _смир, _দিল_, _सूची,
   {{0x95c80bac,0x0dc82f1a,0x644488ae,0x5bb90fe6}},	// [1cd0] тура_, тури_, _šiij, елая_,
   {{0x395faf1b,0xdb01af1c,0x2571af1d,0x64460140}},	//   _sous_, golè, _mála_, _drki,
   {{0x3f87803b,0x29d72f1e,0x64462f1f,0x7d0281ac}},	//   vinu_, _għal_, _erki, _odos,
   {{0x7d0280f1,0x6446026c,0x69c88037,0x200faf20}},	//   _ndos, _frki, _èdel, tugi_,
   {{0x395f9c8d,0x3f87af21,0x2575016d,0x6d4f0888}},	//   _vous_, tinu_, _våld_, _inca,
   {{0x753d0117,0xa2be00d4,0xa3b28105,0xf1ca001c}},	//   _hasz, _वृक्, _झील_, _hạt_,
   {{0x395f86e3,0x44392f22,0x753d29bd,0x200faf23}},	//   _tous_, _hss_, _kasz, sugi_,
   {{0x2249803a,0x394d809f,0x3f87af09,0xdb01af24}},	//   _čak_, _unes_, sinu_, molé,
   {{0xc9849506,0x5184830d,0x69d52f25,0xcfab8065}},	//   _тури, _тура, _huze, _قائم_,
   {{0x25bf802e,0x25ad816b,0x44392f26,0x69d52f27}},	//   smul_, slel_, _mss_, _kuze,
   {{0x75158307,0x443912b7,0x198a0ae7,0xa18a00c4}},	//   _مواض, _lss_, ебни_, ебна_,
   {{0x753d0d38,0x44390687,0x69d52f28,0x78ad228b}},	//   _nasz, _oss_, _muze, _byav,
   {{0x69d52f29,0xaac3000d,0x2d8909c4,0x63a509da}},	//   _luze, वेतक, diae_, kohn,
   {{0x6d4f2f2a,0x77ad8118,0xdce28140,0xe2998791}},	//   _anca, fúxi, _ploć, _пал_,
   {{0xa3c2800f,0x63a52f2b,0x656d0359,0x44392f2c}},	//   ्दर_, dohn, fkah, _ass_,
   {{0x6d5b8867,0x656d2575,0x2614816f,0x442b2f2d}},	//   njua, gkah, नंती_, _bpc_,
   {{0x44392f2e,0x03260162,0xe3ba2f2f,0xa4460071}},	// [1ce0] _css_, лдан, еба_, ынад,
   {{0x6d4f2f30,0x68f60085,0x442b2f31,0x63768087}},	//   _enca, _heyd, _dpc_, _gând,
   {{0x6146af32,0xd9469fcb,0x471b00be,0x2d9200b9}},	//   лежа, лежи, _אויג, pnye_,
   {{0x44392f33,0x2d89002a,0x673e2f34,0xdb01a1bf}},	//   _fss_, ciae_, _hapj, solè,
   {{0x68f61d5a,0x776188f1,0x6d5b9abf,0x64460bf0}},	//   _meyd, _bolx, djua, _urki,
   {{0x27f2031d,0x8fa3adc3,0xfaa62154,0x753d066f}},	//   _mwyn_, баче, _баго, _zasz,
   {{0x27e6af35,0x09cf80a5,0xe1e78019,0x7c2b80eb}},	//   spon_, _संगठ, _دس_, _apgr,
   {{0x44202f36,0x7bce0587,0x44390683,0x6d5b8168}},	//   oti_, _hibu, _yss_, gjua,
   {{0x44202f37,0xa3c2835a,0x7bce0555,0x69d500ad}},	//   nti_, ्दल_, _kibu, _zuze,
   {{0x44202f38,0x3f8a022e,0x673e0019,0x69d519d5}},	//   iti_, jibu_, _napj, _yuze,
   {{0x44200a92,0xdd8f8bca,0x6b7b098a,0x63768087}},	//   hti_, _کون_, גרינ, _rând,
   {{0x84468b76,0x7bce2f39,0x7d02809a,0xddb68019}},	//   _مختل, _libu, _udos, _صحاب,
   {{0x44202f3a,0x68f62f3b,0x69c2808e,0x20000362}},	//   jti_, _deyd, imoe, _cvii_,
   {{0x44392f3c,0x447b893f,0x7bce0ab4,0x78ad018e}},	//   _rss_, _אנדע, _nibu, _vyav,
   {{0x44202f3d,0x7afa8364,0xd5bb15a4,0x2904805c}},	//   eti_, matt, еса_, _odma_,
   {{0x44202f3e,0x7bce2f3f,0x61fe2280,0x63a501ec}},	//   fti_, _aibu, dspl, wohn,
   {{0x656d2f40,0x442b01df,0x44200dc3,0x7bce1c61}},	// [1cf0] rkah, _qpc_, gti_, _bibu,
   {{0x443902a5,0x59d901b6,0x7bce2f41,0x34d195a7}},	//   _vss_, _बंदर, _cibu, _हल्द,
   {{0x5a352f42,0x44202f43,0x7afa80e5,0x44390299}},	//   рнет, ati_, iatt, _wss_,
   {{0x7afaaf44,0x673e0654,0x44202f45,0xe9ab9e29}},	//   hatt, _zapj, bti_, ردان_,
   {{0x68f98063,0x44202f46,0xda010076,0xb97c0158}},	//   rawd, cti_, _लटकत_, ענדי,
   {{0x6d478029,0xa0669bf2,0xf74584db,0x7bce04a7}},	//   ējam, раша_, реко, _gibu,
   {{0x7afaaf47,0x7f3c00be,0xff048ea6,0xb87b0118}},	//   datt, געוו, сячн, ncíb,
   {{0xdb150118,0x656280c3,0x3f8a02ec,0x7bce06a0}},	//   _tizó, _cooh, zibu_, _zibu,
   {{0x6d5b94ec,0x236301c0,0x7bce0cb7,0x28c701a2}},	//   rjua, _kojj_, _yibu, रेमि,
   {{0x7afaaf48,0x25a08ee1,0x21290239,0x42259fab}},	//   gatt, čila_, _abah_, адов,
   {{0xe299af49,0x44202f4a,0x491a02f1,0x45d5af4b}},	//   тан_, zti_, _भादो_, _тоес,
   {{0x44202f4c,0x213f8867,0x68f60086,0x69d80073}},	//   yti_, _jauh_, _qeyd, ívei,
   {{0x7afaa280,0x3f8a022e,0x671c80a5,0x290c07c0}},	//   batt, tibu_, _नामक_, ğda_,
   {{0xcb6684dd,0xb4c19094,0x68f602a3,0x7afa8081}},	//   _ваше_, ंधी_, _weyd, catt,
   {{0x3f8a022e,0x7bce178f,0x0fc300e8,0x24f616cf}},	//   ribu_, _ribu, ійсн, ичар,
   {{0x442021da,0x7bce2f4d,0x3f8a2f4e,0x257185b9}},	//   tti_, _sibu, sibu_, _málo_,
   {{0x3b860110,0x44201aea,0x6386041c,0x31bc801b}},	// [1d00] алаг, uti_, агаа, níze_,
   {{0x44200743,0xfbdf0142,0x394010af,0x61fe1d31}},	//   rti_, _trên_, _hais_, tspl,
   {{0x201faf4f,0x4aab8076,0x39402f50,0x69c280c9}},	//   _aqui_, _घुमव, _kais_, tmoe,
   {{0xc8ca8154,0x61fe2f51,0x636d816a,0x39402f52}},	//   نوان_, rspl, _búnk, _jais_,
   {{0x394019c3,0x7bce04a7,0x69c2a023,0x61fe2f53}},	//   _mais_, _tibu, rmoe, sspl,
   {{0x39402f54,0x63768087,0x69c2af55,0x9e069bb1}},	//   _lais_, _mânc, smoe, ачил,
   {{0x9c87026f,0xbcfb010c,0x798baf56,0xd6d98163}},	//   počí, _moén, bigw, уті_,
   {{0x5d5498a0,0x39402f57,0x6443009a,0xe29701a1}},	//   скит, _nais_, łnie, _тас_,
   {{0x7afaaf58,0x6d40ad03,0x68ed83a8,0xf1d00a27}},	//   tatt, rdma, ñade, _संजन,
   {{0x39520813,0xf36695b5,0x6562808e,0x7b668f13}},	//   _anys_, ртин, _wooh, ртие,
   {{0x7afaaf59,0x1b0300c8,0x0bb70039,0x39402f5a}},	//   ratt, র্কে_, שלים_, _bais_,
   {{0x644901e2,0x7afa920b,0x39402f5b,0x672d80ce}},	//   _šeim, satt, _cais_, đaje,
   {{0x39402f5c,0x7afaaf5d,0xc8642f5e,0x63768187}},	//   _dais_, patt, отри, _cânc,
   {{0x93fb8051,0x7afa8372,0x3ea98162,0xd7f80d15}},	//   _ילדי, qatt, şate_, шую_,
   {{0x394002be,0xe8d90135,0x63a8af5f,0xf1bf81d6}},	//   _fais_, _amụ_, modn, žšia_,
   {{0xda5b8051,0x69d88fee,0x2129010b,0x2baf0d86}},	//   _יכול, _iuve, _ubah_, _जीजा,
   {{0x54b901bb,0x68fd2f60,0x7af881c0,0x69d888dc}},	// [1d10] угая_, masd, _kevt, _huve,
   {{0x8ae7035f,0x3b541242,0x69d8af61,0x28c7009a}},	//   ріал, окур, _kuve, रेणि,
   {{0xcfe200c8,0x213f8748,0x69da0019,0x39520114}},	//   _বিএন, _pauh_, _étel, _ynys_,
   {{0x29190397,0x63a8af62,0x69d8997a,0x68fd2f63}},	//   ngsa_, hodn, _muve, nasd,
   {{0x8d5a0051,0xdee581cf,0x69d8af64,0x504583a7}},	//   _עכשי, боли, _luve, селб,
   {{0x69d882be,0xcc3a0158,0xdc3a0158,0x543a00be}},	//   _ouve, _געשט, _געשר, _געשא,
   {{0x798b8010,0x69d88c16,0x81e10264,0x92580436}},	//   pigw, _nuve, _দিক_, _карт_,
   {{0x7bc52f65,0xf1ca00ff,0x069801c6,0xddd50e06}},	//   lmhu, _nạp_, ידום_, nyző,
   {{0x394000f6,0x7989804f,0x69d88036,0x201f8118}},	//   _rais_, _imew, _auve, _uqui_,
   {{0xf77395e4,0x63a8af66,0x4ea792bc,0x39402f67}},	//   _بار_, godn, _креа, _sais_,
   {{0x39402f68,0x636d8019,0xa96a1c79,0xd946116b}},	//   _pais_, _júni, гина_, бени,
   {{0x394000dd,0xdb050106,0x249d81c5,0x636d957a}},	//   _qais_, llhä, _txwm_, _múni,
   {{0x63a8883d,0x39402f69,0xab298bda,0xb900109b}},	//   bodn, _vais_, _бола_, _तल_,
   {{0x2bdb023c,0x53348ada,0x442f80ee,0x7777002a}},	//   _बढ़ा, _мечт, _ipg_, _clxx,
   {{0x394001e9,0x69d8af6a,0xa50a07a1,0x261801fe}},	//   _tais_, _guve, лева_, बंधी_,
   {{0xf1d01299,0x1c030006,0x442f80ee,0xa19309a5}},	//   _सूचन, _लिखल_, _kpg_, _најч,
   {{0xb87b2f6b,0x69d881ec,0x7bd98326,0xdb018144}},	// [1d20] rcíc, _zuve, _juwu, holí,
   {{0xf3f98a49,0x26180540,0x46f6159f,0x7989804f}},	//   _আমার_, बंदी_, _учит, _amew,
   {{0x6e4603f8,0x2002127a,0x69d8862f,0x2571808b}},	//   _انجم, lski_, _xuve, _páll_,
   {{0x9f4907ca,0x442f8115,0xdb01a0ce,0xf8fa81a8}},	//   _hvað_, _opg_, dolí, اءات_,
   {{0x7f41af6c,0x7bd9803d,0x68e40c53,0xbf9b0866}},	//   _balq, _nuwu, _mfid, prêt,
   {{0x7f41862f,0x6d44011e,0xb87b0511,0x798991d3}},	//   _calq, ldia, ncía, _emew,
   {{0x644baf6d,0x41b6803d,0x65be8168,0x8afb04de}},	//   _argi, _همسر, hëhe, _תהלי,
   {{0x25a0a52d,0x63a8809a,0xb99680f7,0x657b96fb}},	//   čilo_, wodn, _الرب, ghuh,
   {{0x7c242f6e,0x69d8af6f,0x69c08009,0x656600ee}},	//   ntir, _suve, _ihme, _mokh,
   {{0x20020289,0x4f658013,0x6566029b,0x68e42f70}},	//   dski_, _والف, _lokh, _afid,
   {{0x9f5d0324,0x442f8695,0xe13521f6,0x68e92509}},	//   _ìwé_, _epg_, онны, ñedo,
   {{0x3f8e8010,0x5a9b00be,0x442f8118,0x7afe1ab3}},	//   lifu_, רשטא, _fpg_, hapt,
   {{0x6d440355,0x63a8803b,0x7afe2f71,0x68fd2f72}},	//   ddia, podn, kapt, rasd,
   {{0x7f418201,0x60d60019,0x3f8e8010,0x6d442f73}},	//   _xalq, _egym, nifu_, edia,
   {{0x41e68bbe,0xf1ca001c,0x65662f74,0xdb1c01a8}},	//   _استف, _tạp_, _bokh, _ghré,
   {{0x1619835a,0x6615011e,0xd0110b8c,0x56942f75}},	//   नंतर_, ruzk, _قلب_, част,
   {{0xdd1c816b,0x7c2400e4,0x9817136d,0xe5208105}},	// [1d30] kážk, gtir, _ابعا, _यानि_,
   {{0x63600065,0x6615011e,0x27e910ab,0x25a90748}},	//   _köny, puzk, _itan_, soal_,
   {{0x6d440b50,0x7c242f76,0xd25101a8,0x7a3501a8}},	//   bdia, atir, بنا_, تفاص,
   {{0xac191480,0x68e2af77,0x7c242b6c,0x798f0db1}},	//   _кому_, gcod, btir, nicw,
   {{0x7afe2f78,0x27e90101,0x442480b9,0xe8f89138}},	//   bapt, _jtan_, jtm_, слі_,
   {{0x7afe2f79,0x2d9a8019,0xdb01af7a,0xd7c8af7b}},	//   capt, épen_, tolí, مونه_,
   {{0xdb18826f,0x442f82f7,0x7bd980d7,0x6d42af7c}},	//   _chví, _spg_, _suwu, _baoa,
   {{0x2409af7d,0xdb01af7e,0x68e2af7f,0x442f9670}},	//   ании_, rolí, ccod, _ppg_,
   {{0x75ca809a,0x1c4297ae,0x7f4180ee,0x0b59876a}},	//   _języ, дным, _talq, арны_,
   {{0x68e42f80,0x657b8010,0x645b8118,0x644b80c3}},	//   _sfid, shuh, rxui, _vrgi,
   {{0xcb120bea,0x2002009a,0xeab180f7,0x68fb80dd}},	//   ולי_, wski_, بعة_, _keud,
   {{0x2002003a,0x68fb82be,0x443d8069,0xa4f780d5}},	//   tski_, _jeud, _tsw_, _اکثر_,
   {{0x442f802a,0x443d81ec,0xbee5016f,0x68fb851e}},	//   _upg_, _usw_, कडून_, _meud,
   {{0x7d1b8074,0x94748875,0x68fb81e4,0x257c01a8}},	//   lgus, _عدنا, _leud, _míle_,
   {{0xfc3f160a,0xdce40279,0x27e92f81,0x212daf82}},	//   _así_, nkić, _etan_, _obeh_,
   {{0x20021487,0x7c242f83,0x75298081,0x291f8069}},	//   pski_, ttir, nfez, _ncua_,
   {{0xf7462f84,0xab662f85,0x61e902d4,0x3366102a}},	// [1d40] _депо, овал, _čela, оваг,
   {{0x6d44002a,0x2575016d,0xb7d7004e,0x3cff8282}},	//   sdia, _håll_, _گویا_, hauv_,
   {{0xe0daaf86,0xdce40754,0x68e28bfd,0xfc3f0091}},	//   аве_, jkić, tcod, _esí_,
   {{0x64430035,0x671c82f1,0x27e90106,0x68fb851e}},	//   łnia, _नाहक_, _ytan_, _ceud,
   {{0x68fbaf87,0x68ed85e4,0x3f8eaf88,0x183680a0}},	//   _deud, ñada, tifu_, تراح,
   {{0x68e28f67,0x7d1baf89,0x69d82f8a,0x7c3b8123}},	//   scod, egus, íves, dwur,
   {{0xe2972f8b,0xdd1c816b,0x3f8eaf8c,0x7afc0162}},	//   _дар_, rážk, rifu_, _iert,
   {{0x3f8eaf8d,0x7d1baf8e,0x7ae901a1,0x717680d7}},	//   sifu_, ggus, _đeti, _بهرا,
   {{0x7afc2f8f,0x660381c0,0xe81603b7,0x7c3b8133}},	//   _kert, asnk, _तमगा_, gwur,
   {{0x69dc2f90,0xe4570158,0x442480ee,0x3946af91}},	//   _kure, קייט_, rtm_, ldos_,
   {{0xc4e6af92,0x798f2f93,0xbcfb04be,0x3946af94}},	//   _джей, ticw, _eléy, odos_,
   {{0x69dc2f95,0x3946af96,0x7afc2c98,0x21200176}},	//   _mure, ndos_, _lert, _ccih_,
   {{0x81ba00ab,0x3946af97,0x7dd58110,0x84968019}},	//   _অংশ_, idos_, _išsa, _بجائ,
   {{0x69dc062f,0x25a996f2,0x6738911b,0x7d00af98}},	//   _oure, čale_, nevj, lams,
   {{0xb7bb041c,0xccfb0eef,0x5559047f,0x645d862c}},	//   stão, ића_, бавя_, äsiv,
   {{0xdb1c0118,0x394481a9,0x7d00af99,0x7afc2f9a}},	//   _oiró, _nams_, nams, _aert,
   {{0x7afc100d,0x69dc2f9b,0x27e92f9c,0x0bd500f7}},	// [1d50] _bert, _aure, _utan_, سياح,
   {{0x69dc2f9d,0x7afc10b6,0x20192f9e,0x6738af9f}},	//   _bure, _cert, musi_, jevj,
   {{0x20191ad4,0x7afc00d8,0xea00001c,0x28c71516}},	//   lusi_, _dert, _đảo_, रेरि,
   {{0x69dc2fa0,0x3f910052,0xf55900f7,0x7d008bcf}},	//   _dure, lizu_, _الحب_, jams,
   {{0x69dc2fa1,0x66e591b1,0x20192fa2,0xa3ca816f}},	//   _eure, пола, nusi_, लगा_,
   {{0x7afc2fa3,0x39468510,0x213900f1,0x69dc2fa4}},	//   _gert, ados_, hesh_, _fure,
   {{0x7c390214,0x7bdd2fa5,0xf77092c8,0x69dc2fa6}},	//   şarı, _husu, خان_, _gure,
   {{0x7bdd2fa7,0x20192fa8,0x7afc2fa9,0x7c3bafaa}},	//   _kusu, kusi_, _zert, twur,
   {{0x20192fab,0x7bdd2fac,0x7d1bafad,0x69dc2fa9}},	//   jusi_, _jusu, rgus, _zure,
   {{0x7bdd2fae,0x6449afaf,0x20192fb0,0x2571807b}},	//   _musu, rvei, dusi_, _máli_,
   {{0xcb12093f,0x2b1c85b3,0x6449afb1,0x7ae50014}},	//   עלט_, _मारु_, svei, icht,
   {{0x291dafb2,0xac198b71,0xaca38133,0xdb0a80f7}},	//   ngwa_, _году_, _ahụk, _bhfó,
   {{0x20192fb3,0x7bdd2fb4,0xdce28088,0x5ed080ab}},	//   gusi_, _nusu, _glođ, _স্পে,
   {{0xdb1c0706,0xc3110264,0x636d8174,0x7bd503df}},	//   _chrì, স্তি_, _cúnt, _nizu,
   {{0xe29690fc,0xed5a0847,0xdb01afb5,0x272f83bf}},	//   _наш_, бов_, colá, mını_,
   {{0x7afc14ff,0x20192fb6,0x6372013c,0x7bdd2fb7}},	//   _sert, busi_, _tænk, _busu,
   {{0x7afc2fb8,0x29022fb9,0x69dc2fba,0x7bdd02a3}},	// [1d60] _pert, maka_, _sure, _cusu,
   {{0x29022fbb,0xef860c5c,0x272f861c,0x04fc00ab}},	//   laka_, _хлоп, nını_, ইলের_,
   {{0x7afc2fbc,0x7dc58511,0x7bdd002a,0x19ba82c7}},	//   _vert, mósf, _eusu, будь_,
   {{0x7ae50307,0x7afc206f,0xe5a60ada,0x69d60708}},	//   acht, _wert, _хими, _jiye,
   {{0x7afc0393,0x2d922fbd,0x672d80d2,0x25ad837a}},	//   _tert, miye_, đajn, doel_,
   {{0x69dc2fbe,0x6d462fbf,0x29022fc0,0x2d922fc1}},	//   _ture, _haka, haka_, liye_,
   {{0x6d462fc2,0x29022fc3,0x272f8059,0xfaa32fc4}},	//   _kaka, kaka_, dını_, _заро,
   {{0x6d462fc5,0x290209a6,0x2d922fc6,0x7ec70019}},	//   _jaka, jaka_, niye_, lépé,
   {{0x6d460846,0x7bdd2fc7,0x6618816b,0xb4c880d4}},	//   _maka, _xusu, suvk, ोखे_,
   {{0x6d462588,0x6843a87d,0xfc2f9a3c,0x20192fc8}},	//   _laka, _януа, احي_, vusi_,
   {{0x29022fc9,0x2d922fca,0x213900f1,0x69d62fcb}},	//   faka_, kiye_, tesh_, _biye,
   {{0x6d462fcc,0x20192fcd,0x644a00eb,0x69c41e68}},	//   _naka, tusi_, āfij, _chie,
   {{0x69d62fce,0x2d922fcf,0x69c4008e,0x21390168}},	//   _diye, diye_, _dhie, resh_,
   {{0x20192fd0,0x6d46076d,0x321a1d21,0x1be306a7}},	//   rusi_, _aaka, kupy_, _कंबल_,
   {{0x29022fd1,0xc6a41109,0x7bdd2fd2,0x644f017f}},	//   baka_, ерти, _susu, _srci,
   {{0x2d802fd3,0x6d461083,0x20192fd4,0x2d9202a0}},	//   ghie_, _caka, pusi_, giye_,
   {{0x071c9d01,0x6d462fd5,0xea000028,0x5c99027e}},	// [1d70] _नांव_, _daka, _đạo_, цкая_,
   {{0xe3b8884a,0xa87c0039,0x7ae501ec,0xad272385}},	//   nlı_, _לאחר, ucht, _کردو,
   {{0x7bd52fd6,0x32070065,0x6d462fd7,0x68ed82ba}},	//   _vizu, ény_, _faka, ñado,
   {{0x2d802fd8,0x4426802a,0x637307d9,0x7ae501ec}},	//   chie_, _oqo_, _sını, scht,
   {{0x25ad80c9,0xb4d909c8,0xe3b88214,0x4426afd9}},	//   voel_, ाशी_, klı_, _nqo_,
   {{0x44292fda,0xaca3019d,0xe80e83b7,0x644d2fdb}},	//   mta_, _laịb, _सिरा_, mvai,
   {{0x6d462fdc,0x29022fdd,0xc33200be,0xee3980e8}},	//   _yaka, yaka_, _שול_, іни_,
   {{0x44292fde,0xd6580039,0x5ebf00ab,0xc1740326}},	//   ota_, ליות_, _আলাই, _kiɗe_,
   {{0xe3b888c5,0x2d838110,0x272f817b,0x644d22b2}},	//   flı_, ėje_, tını_, nvai,
   {{0x4429171c,0x29022a75,0x69d62fdf,0x29d781b9}},	//   ita_, waka_, _siye, _għar_,
   {{0x29022fe0,0x44292fe1,0x272f8afe,0x62852fe2}},	//   taka_, hta_, rını_, nzho,
   {{0x4429088b,0x272f8459,0x72078019,0x2cae819d}},	//   kta_, sını_, _ہفتہ_, ịmị_,
   {{0x29022fe3,0x6d462fe4,0xa01b0065,0x3b099232}},	//   raka_, _raka, szön, _дело_,
   {{0x6d462fe5,0x44292fe6,0x6f03afe7,0x6d49811e}},	//   _saka, dta_, nanc, ldea,
   {{0x6d462fe8,0x29022fe9,0x2d922fea,0xa2c9820e}},	//   _paka, paka_, tiye_, हेश्,
   {{0x6d49afeb,0x60db8d48,0x44290b0b,0xed572fec}},	//   ndea, _ngum, fta_, мос_,
   {{0x6d462fed,0x44292fee,0x2d922fef,0x6d49803c}},	// [1d80] _vaka, gta_, riye_, idea,
   {{0x6d462ff0,0x2d922ff1,0x7c298b2b,0x6d498f31}},	//   _waka, siye_, iter, hdea,
   {{0x6d462ff2,0x44292ff3,0x7c29aff4,0x673c1e81}},	//   _taka, ata_, hter, merj,
   {{0x27e0025d,0x3d1805b3,0x44292ff5,0x443f882e}},	//   _kuin_, _फाटे_, bta_, kwu_,
   {{0x44291883,0x27e003d3,0x7d042ff6,0xe3b88182}},	//   cta_, _juin_, mais, ylı_,
   {{0x7d042ff7,0x6d59aff8,0x6f03aff9,0x673c2ffa}},	//   lais, _anwa, ganc, nerj,
   {{0x7c29affb,0x27edaffc,0xa3c38beb,0x656baffd}},	//   eter, _eten_, ्षन_, _bogh,
   {{0x7d042ffe,0x7c29afff,0x257880e7,0x753b804f}},	//   nais, fter, _vélo_, geuz,
   {{0x673c1a67,0x7c29b000,0x656bb001,0x2b47b002}},	//   kerj, gter, _dogh, _banc_,
   {{0x6f0381b1,0x7d041276,0x2d988019,0x2b47b003}},	//   canc, hais, őre_, _canc_,
   {{0x7d043004,0x656b8c64,0x81bd0029,0xa3dea6ee}},	//   kais, _fogh, stēm, _दूर_,
   {{0xaca48135,0x6d60816b,0x661c3005,0x7d043006}},	//   _akụz, ávač, durk, jais,
   {{0x44293007,0xdb088511,0x29002c03,0x27e00229}},	//   xta_, lodí, _deia_, _cuin_,
   {{0xe3b88201,0x27e03008,0x81bd00eb,0x673c3009}},	//   qlı_, _duin_, otēk, gerj,
   {{0xdfd41641,0xd90499f4,0x67d40ca4,0x79a71e25}},	//   торы, _پی_, тору, _орие,
   {{0x7d04300a,0x656bb00b,0x29ee8326,0x62850824}},	//   gais, _xogh, mƙa_, vzho,
   {{0x673c300c,0x4429300d,0x6f03b00e,0x7bd8b00f}},	// [1d90] berj, uta_, yanc, _kivu,
   {{0x661c2d27,0x752d3010,0x31a403bf,0xa3c3b011}},	//   burk, sfaz, mıza_, ्षय_,
   {{0x7c29b012,0x7d043013,0x644d3014,0x27edb015}},	//   zter, bais, svai, _sten_,
   {{0x44293016,0x6f03b017,0xaca30133,0x764502a0}},	//   pta_, wanc, _abụb, _ishy,
   {{0x39493018,0x656b861f,0x06f30a74,0x44293019}},	//   _maas_, _rogh, _अभाव_, qta_,
   {{0xf1ca001c,0x656b80f7,0xa3e400d4,0x705292dc}},	//   _dạy_, _sogh, _पंत_, انوا,
   {{0x81bd0029,0xd90f80d5,0x6d49b01a,0x45d580b3}},	//   rtēj, _نیا_, tdea, нцит,
   {{0x6f03b01b,0x79828063,0x7c299140,0x1c45b01c}},	//   sanc, chow, tter, еним,
   {{0x7c29b01d,0x27ed835f,0xfc48801c,0x3dc68079}},	//   uter, _uten_, _cử_, _dhow_,
   {{0x6d49851e,0x61e90796,0xc48286d2,0x2d8c0866}},	//   sdea, _čelj, ульк, édez_,
   {{0x673c301e,0x7bd8b01f,0x68e48024,0x394910b0}},	//   verj, _divu, žide, _baas_,
   {{0x6d598114,0x92df80ab,0xf99f3020,0x27e009ff}},	//   _unwa, তরে_, gnè_, _puin_,
   {{0x673c3021,0xa3db000f,0x6007035f,0x27e0009f}},	//   terj, _ढंग_, нням_, _quin_,
   {{0xfaa584f6,0x201d82c4,0x29ee8326,0x7bd89a14}},	//   _пало, iuwi_, bƙa_, _givu,
   {{0xf772810f,0x7d043022,0x6f01b023,0xed5a16ba}},	//   נקל_, tais, _melc, пов_,
   {{0x27e0038e,0x61ee86a5,0x673c02d4,0x2d9f80e7}},	//   _tuin_, íble, serj, nnue_,
   {{0x7d043024,0x673c01b9,0xfc488028,0xdee61f3e}},	// [1da0] rais, perj, _xử_, _попи,
   {{0x7d043025,0x60c4005d,0x8fa63026,0xdb1c01a8}},	//   sais, _izim, _سمجه, _bhrá,
   {{0xdb1c003e,0xe9da2a0e,0xc33282f6,0x4efb0039}},	//   _chrá, чке_, רוב_, _מהיו,
   {{0xfbdf00e7,0x4aaf0072,0x307a03de,0xdb0884e8}},	//   _prêt_, _जुळव, ּאַנ, vodí,
   {{0x6f018358,0xb8e88fd5,0x26180035,0x201d82d5}},	//   _belc, _उर_, बंकी_, guwi_,
   {{0x38cb8bca,0x3dc6b027,0xdfcf880b,0x60c400b8}},	//   سانی_, _show_, مين_, _mzim,
   {{0xfc488104,0x03a30b9c,0x53a32597,0x6f01b028}},	//   _sử_, _сиро, _сарб, _delc,
   {{0x7bd8b029,0x60c4302a,0x8c66838b,0x5d54b02b}},	//   _sivu, _ozim, етод, ткит,
   {{0x60c42f0e,0x10a38a2e,0x3949302c,0x81e78264}},	//   _nzim, _битн, _raas_, মীম_,
   {{0x6446008e,0xf8bf0036,0x25a00824,0x53b001a2}},	//   _mski, ngée_, hnil_, जकिश,
   {{0xc3331a0f,0x60c41f62,0x7bd8b02d,0x25a002d4}},	//   אות_, _azim, _vivu, knil_,
   {{0xfc488104,0x4c868098,0x4a9b00be,0x546a8081}},	//   _tử_, _плев, לייג, _наем_,
   {{0xb90905e8,0xdb0883a7,0xc95384de,0x25718061}},	//   _बल_, godã, אמר_, _vált_,
   {{0xa3c38e70,0x60c400eb,0x25a08353,0x3949302e}},	//   ्षण_, _dzim, čilu_, _waas_,
   {{0x3949302f,0x60c40316,0x64463030,0x6a869a1f}},	//   _taas_, _ezim, _aski, _défé,
   {{0xd5b83031,0x25a002d4,0x257c128a,0x3eba0163}},	//   есу_, gnil_, _dílo_, _dypt_,
   {{0x2ef50698,0x68ed017b,0xe802801b,0xafdb1277}},	// [1db0] _изпр, _ifad, रीमा_, rvøs,
   {{0xc5f680ab,0x200b3032,0x8aa7031f,0x889c0039}},	//   _ঘটনা_, msci_, нред, _מבחי,
   {{0x64463033,0xd5df800f,0x321eb034,0xdd9100d7}},	//   _eski, _पूंज, nuty_, _نود_,
   {{0xc17400fc,0x7ec70032,0x1a6801f9,0x27e68299}},	//   _kiɗa_, _eépí, ریقی_, fqon_,
   {{0x2d84b035,0x6f01b036,0x6d5d0b03,0x64460326}},	//   dhme_, _pelc, _insa, _gski,
   {{0x7bdf83d3,0x7c2d020f,0x656f0352,0x39498df1}},	//   _équi, mtar, _hoch, žas_,
   {{0xfbdf0073,0xe7088154,0x6372008b,0x61dc00d4}},	//   _três_, رتون_, _vænt, यदृष,
   {{0x6d4d3037,0x7dd58110,0x6f0184e7,0x49049a37}},	//   ndaa, _išsk, _welc, _موفق,
   {{0x656f3038,0x200b00d2,0x7d02802e,0x6f01accd}},	//   _moch, jsci_, _deos, _telc,
   {{0x656f0083,0x7c2d3039,0x24890042,0x67200035}},	//   _loch, itar, izam_, _बाइक_,
   {{0xfaa59980,0x6a8682be,0x7c2d2b42,0x69c981e9}},	//   тано, _réfé, htar, _khee,
   {{0x656f303a,0x7d02b03b,0x853000fc,0x2d9f8037}},	//   _noch, _geos, kiɗa, qnue_,
   {{0x6d4d0ef2,0x7c2d0168,0x8ccd8035,0x1b0c0264}},	//   ddaa, jtar, देशो, স্টে_,
   {{0x6d4bb03c,0x24891a1d,0x6d5d303d,0x6569b03e}},	//   _haga, dzam_, _ansa, ljeh,
   {{0x6d4bb03f,0x656f3040,0x7c2d3041,0x20193042}},	//   _kaga, _boch, etar, arsi_,
   {{0x656f3043,0x6d4bb044,0xe8029834,0x44393045}},	//   _coch, _jaga, रीडा_, _bps_,
   {{0x60c402a5,0x6d4b8fa9,0x25a03046,0x7c2d3047}},	// [1dc0] _uzim, _maga, rnil_, gtar,
   {{0x6d5d3048,0x61e3930c,0xa3c1823c,0x6f07003b}},	//   _ensa, _kunl, ंति_, cajc,
   {{0x442db049,0xbcfb087a,0x3f98005c,0x6d4d15e8}},	//   hte_, _poét, miru_, bdaa,
   {{0x6d4bb04a,0x3f98010b,0x656f304b,0x6d4d0079}},	//   _naga, liru_, _goch, cdaa,
   {{0x69c982a3,0x7c2d304c,0xa3c1a8b3,0x69db8722}},	//   _dhee, ctar, ंता_, _diue,
   {{0x4420304d,0x442d8ed8,0x7d02b04e,0x6d4b9bdb}},	//   mui_, dte_, _seos, _aaga,
   {{0x4420304f,0x6d4bb050,0x442d929d,0x26dc026f}},	//   lui_, _baga, ete_, _úvod_,
   {{0x75243051,0x7bdc3052,0x6d4bb053,0x657ba575}},	//   ngiz, _hiru, _caga, gkuh,
   {{0x6d4bb054,0x442db055,0x61e900d2,0x44203056}},	//   _daga, gte_, _čeli, nui_,
   {{0x2d8488cf,0x671c81ab,0x61e382bb,0x201902a5}},	//   shme_, _नाटक_, _bunl, vrsi_,
   {{0x44200867,0xdee387b6,0x442db057,0xf3638190}},	//   hui_, _тохи, ate_, ртын,
   {{0x442db058,0x6d4bb059,0x7c2d305a,0xfd5501bc}},	//   bte_, _gaga, ytar, _draị,
   {{0x442d8bf6,0x656f305b,0x4420305c,0x2904804f}},	//   cte_, _roch, jui_, _mema_,
   {{0x6d40b05d,0x6d4bb05e,0x4420305f,0x656f03b3}},	//   lema, _zaga, dui_, _soch,
   {{0x443902ee,0x35e4035f,0xda6f8698,0x6d4b81d3}},	//   _sps_, ицтв, _тя_, _yaga,
   {{0x7c2d3060,0x672d812b,0x6d40938e,0xdd11011c}},	//   ttar, đaji, nema, _düşd,
   {{0x44203061,0x54550b71,0x6d4d3062,0x7bdc3063}},	// [1dd0] gui_, ыват, rdaa, _biru,
   {{0x09cb8eed,0x2d8210f4,0x6d408006,0x656f0352}},	//   िष्य, _elke_, hema, _woch,
   {{0x442db064,0x7bdc3065,0x69c981c5,0x6d40b066}},	//   zte_, _diru, _phee, kema,
   {{0x7c2d08cf,0x6d5d1341,0x6d40b067,0x44203068}},	//   ptar, _unsa, jema, bui_,
   {{0x6d4bb069,0x442db06a,0x7bdc306b,0x69db823e}},	//   _raga, xte_, _firu, _viue,
   {{0x7dd581e2,0x442d826f,0x7bdc306c,0xe8d9019d}},	//   _išsi, vte_, _giru, _nnọ_,
   {{0x6d4bb06d,0x69c9b06e,0xc794803d,0x6abc0114}},	//   _paga, _thee, جشنب, _gyrf,
   {{0xe8d90870,0x26dc007c,0x7bdc306f,0x6f0501d0}},	//   _anọ_, וקומ, _ziru, _lehc,
   {{0x7bca9301,0x442db070,0xf1bf0038,0xc6bf00c8}},	//   _bhfu, ute_, dlá_, _আলোচ,
   {{0x9ee980f7,0x6d4bb071,0x200980eb,0x212900b9}},	//   _أفضل_, _waga, šais_, _acah_,
   {{0x6d4bb072,0x35f59baa,0x65698499,0x6d40b073}},	//   _taga, _спер, pjeh, bema,
   {{0xdb089be6,0x29043074,0x8ed58264,0x06d58264}},	//   rodá, úma_, _স্থগ, _স্থি,
   {{0x394d831d,0xd9100019,0x442d8168,0x7c648019}},	//   _maes_, میں_, qte_, _ناول,
   {{0x749a8f60,0x649a8158,0x3ced8353,0x61e3826b}},	//   _אינפ, _אינה, lcev_, _tunl,
   {{0xe1f18288,0x20003075,0x3f983076,0x98a403bf}},	//   _است_, _wwii_, riru_, ımı_,
   {{0x7d098025,0x44200f52,0x0ce200ab,0x3ced8353}},	//   naes, tui_, বর্ত, ncev_,
   {{0x752404b9,0x3f98012b,0x26180074,0x644488ae}},	// [1de0] rgiz, piru_, बूजी_, _šiiz,
   {{0xdd041010,0x39423077,0x2904b078,0x44203079}},	//   ısın, leks_, _sema_, rui_,
   {{0xeb96893f,0x6d408870,0x4420307a,0x75e78085}},	//   נדער_, yema, sui_, _qızl,
   {{0x673b005c,0x394218c2,0x4420307b,0x6d408f3e}},	//   đuje, neks_, pui_, xema,
   {{0x4420307c,0x6d40ad03,0xe3b10019,0x2904804f}},	//   qui_, vema, صرے_, _vema_,
   {{0x6fb4000f,0xa2e30256,0x7d06307d,0x39420074}},	//   ंकिं, _горд, _heks, heks_,
   {{0x6d40b07e,0x7d06307f,0xfbde0118,0x63768162}},	//   tema, _keks, _iiª_, _mânt,
   {{0x782680f7,0x746a8009,0xf65703c8,0xdd9080f7}},	//   _معطل, еров_, רסקי_, توب_,
   {{0x6d40b080,0x39423081,0xd1b38077,0x644d81a1}},	//   rema, deks_, _اینک, _šair,
   {{0x6d40b082,0x6d8784a1,0x79843083,0xff248065}},	//   sema, _añad, _aliw, _خبری,
   {{0x4ebf00c8,0xa49b0362,0xaace8074,0xfca980d7}},	//   _আল্ল, _aeòl, हेंक, _یاهو_,
   {{0x6fc005ec,0x25bf8162,0xfce6b084,0x394206ae}},	//   böck, clul_, _содо, geks_,
   {{0xa3e40540,0xe81c0006,0xa49b051e,0x8cb00c28}},	//   _पूल_, भंगा_, _ceòl, _अँगो,
   {{0xead48e02,0x63768087,0xf1bf03f2,0x1b1a0264}},	//   _коль, _cânt, slá_, ন্তে_,
   {{0xa3c3815c,0xa3c1b085,0x7d063086,0x5b7b80be}},	//   ्षर_, ंतर_, _beks, _ארגא,
   {{0x9e43016b,0xa49b0a2a,0x7984066f,0x6b9a8580}},	//   žďov, _feòl, _gliw, litg,
   {{0x7d062ca2,0x33f400f7,0xbcfb0511,0x24180fe6}},	// [1df0] _deks, مسلس, _anéc, лоты_,
   {{0x290b3087,0x7d0602d5,0x69df0168,0x395fb088}},	//   laca_, _eeks, _hiqe, _snus_,
   {{0x3ebe9816,0xdb08807b,0x394db089,0xd6db004a}},	//   _nytt_, lldó, _paes_, _яти_,
   {{0x290b308a,0x4dfa0158,0x3547102a,0x3135804a}},	//   naca_, _שפרא, _схов, редр,
   {{0x3ced807a,0xd7058dae,0xada581d6,0x69df03ed}},	//   vcev_, азли, nkúš, _miqe,
   {{0x88c700c8,0x3ebe919b,0x69df308b,0x290b308c}},	//   _এলাক, _bytt_, _liqe, haca_,
   {{0x6d4f308d,0xd5ae0117,0x27780039,0x25bf8087}},	//   _kaca, _رہے_, רגון_, tlul_,
   {{0x290b0503,0x395f9ca7,0x2d890708,0x6d4f308e}},	//   jaca_, _unus_, nhae_, _jaca,
   {{0xb81ca3e6,0xe7e1023c,0x0d828112,0x87278c2a}},	//   _नियम_, _गंगा_, ільн, _معام,
   {{0x6d4f02a3,0x308481a8,0x60c9b08f,0x00000000}},	//   _laca, _الكف, _izem, --,
   {{0x39420006,0x69cd0362,0x49ca1ddf,0xb1130135}},	//   teks_, _bhae, клон_, _tụle,
   {{0x24968077,0x69cd0114,0x672d812b,0x290b3090}},	//   انید_, _chae, đaju, gaca_,
   {{0x7dc58207,0x764e807b,0x6b65a45b,0x7d06007b}},	//   lóso, _ábyr, _вкла, _reks,
   {{0x87b90676,0x39420665,0x64598609,0x248d822c}},	//   густ_, seks_, _irwi, mzem_,
   {{0x290b3091,0x2d960196,0xe81c8105,0x7d063092}},	//   baca_, арас, _निभा_, _peks,
   {{0x6d4f3093,0x290b3094,0x69cd0013,0xdb188176}},	//   _caca, caca_, _ghae, _akvè,
   {{0x7d06021e,0x6d4f01b4,0x81bd01a9,0x3f85b095}},	// [1e00] _veks, _daca, rtēt, _ollu_,
   {{0x7bc18355,0x644b8077,0x6d4f0229,0x42560992}},	//   nllu, _msgi, _eaca, итет,
   {{0x7d060558,0x00e695f7,0x6d4f0014,0x7c3d3096}},	//   _teks, ажен, _faca, _epsr,
   {{0x6d4f3097,0x6e3e00b9,0x31608333,0x323680be}},	//   _gaca, _ippb, ñiz_, יטען_,
   {{0x60c98035,0x6d443098,0x69da8037,0x2f18b099}},	//   _czem, meia, _ètem, голь_,
   {{0x248daec8,0x2d80009a,0x60c9b09a,0x6d4f309b}},	//   dzem_, lkie_, _dzem, _zaca,
   {{0xfaa3108d,0xeb970b87,0x1c188074,0xe8e000ff}},	//   _даро, _тир_, _दिहल_, _muối_,
   {{0x2d80079f,0xe817016f,0x290b0e1b,0xad6680f7}},	//   nkie_, _तिला_, xaca_, شابه,
   {{0x290b003a,0x4432309c,0xb716803d,0x7b66b09d}},	//   vaca_, nty_, _نباش, атне,
   {{0x4432309e,0x61e0908c,0x443d808e,0x68e4309f}},	//   ity_, _himl, _dpw_, _agid,
   {{0x2d80079f,0x0cc3123a,0x3f9cb0a0,0x443230a1}},	//   kkie_, _शर्म, mivu_, hty_,
   {{0x443209a4,0x60c08009,0x3f9cb0a2,0x7bc1b0a3}},	//   kty_, _kymm, livu_, allu,
   {{0x7bce00b9,0x6d4430a4,0xdbdc81d0,0xdb050118}},	//   _ohbu, deia, lšíh, rohú,
   {{0x6d4f30a5,0xe8e00028,0x61e0b0a6,0x7c2430a7}},	//   _saca, _cuối_, _liml, duir,
   {{0x290b0024,0x6d4f30a8,0xada580e1,0x8de823e7}},	//   paca_, _paca, skúš, ифта_,
   {{0x69c88029,0xdb1c01a8,0x261803ca,0x443230a9}},	//   _ūden, _ghrú, _फिरी_, fty_,
   {{0x4424b0aa,0x6562803e,0x7bce0267,0x69c38036}},	// [1e10] num_, _mnoh, _bhbu, înem,
   {{0x799d005d,0x25a9a2fb,0x6d4f30ab,0x8c1b8039}},	//   lisw, čali_, _waca, כומי,
   {{0x60c98117,0x6d4f04f9,0x442484a7,0x27e930ac}},	//   _szem, _taca, hum_, _huan_,
   {{0x4424b0ad,0x2d8030ae,0x799d005d,0x79a4838b}},	//   kum_, ckie_, nisw, орче,
   {{0x765a8063,0x4424b0af,0x27e902f9,0x7bc1b0b0}},	//   _arty, jum_, _juan_, yllu,
   {{0xbb850307,0x4424b0b1,0x2d86b0b2,0x7d0d30b3}},	//   _السي, dum_, _aloe_, laas,
   {{0x6fcd81ac,0x636da5b3,0x27e930b4,0x799d0234}},	//   júce, _gúny, _luan_, kisw,
   {{0x6fcdb0b5,0x7d0d30b6,0x44248125,0x248d8722}},	//   dúce, naas, fum_, tzem_,
   {{0x4424b0b7,0x60c0b0b8,0xe3b99a19,0x60c9b0b9}},	//   gum_, _gymm, лби_, _uzem,
   {{0xd7748013,0x5f748013,0x7d0d2933,0x61e0b0ba}},	//   _والع, _والر, haas, _ziml,
   {{0x7d0d30bb,0xe9da0021,0x248da422,0x26c101c0}},	//   kaas, лко_, szem_, _nyho_,
   {{0x27e91e66,0x186a30bc,0x443230bd,0x7d0d30be}},	//   _buan_, гами_, yty_, jaas,
   {{0x4424b0bf,0x7d0d02a3,0x443230c0,0x55528065}},	//   cum_, daas, xty_, _رپور,
   {{0xa0270125,0x27e930c1,0x291e02d0,0x7529b0c2}},	//   _stöð, _duan_, şta_, lgez,
   {{0xc9f5845b,0x51f59e13,0xfaa2b0c3,0x644981ec}},	//   _استع, _استر, _нашо, lwei,
   {{0x7d0d30c4,0x7529b0c5,0x7c2430c6,0x63bc30c7}},	//   gaas, ngez, tuir, _skrn,
   {{0x1ddf800f,0x69c280c9,0xd4671300,0x644982af}},	// [1e20] _पूछत, vloe, бите_, nwei,
   {{0x443214e3,0x2d801a15,0x212d81f1,0x4f260991}},	//   rty_, skie_, _aceh_, _удоб,
   {{0x4432309c,0x6449b0c8,0x7c2402a5,0x7d0d30c9}},	//   sty_, hwei, suir, baas,
   {{0x4424b0ca,0x7529890d,0x443230cb,0x6f0e0326}},	//   yum_, jgez, pty_, labc,
   {{0x7c2430cc,0xdb01b0cd,0xe80b800f,0x3a258fb0}},	//   quir, noló, _सौदा_, hulp_,
   {{0xe82000a5,0x442030ce,0x64498114,0x799d0234}},	//   _बिना_, mri_, dwei, zisw,
   {{0x528600f7,0xa248019f,0x4424b0cf,0x442030d0}},	//   _الأك, _خیال_, wum_, lri_,
   {{0x442030d1,0x3f9cb0d2,0x75299d20,0xdb018298}},	//   ori_, sivu_, ggez, koló,
   {{0x442030d3,0x644997fb,0x3946b0d4,0x81ae0264}},	//   nri_, gwei, meos_, কতা_,
   {{0x4424b0d5,0xf36697cb,0x442030d6,0xdb018ce0}},	//   rum_, стин, iri_, doló,
   {{0x7d0d02c1,0x442030d7,0xed06803d,0x7dea8035}},	//   yaas, hri_, _هواپ, _męsk,
   {{0x27e930d8,0x7982809a,0x3946a5ca,0x4424808b}},	//   _puan_, nkow, neos_, pum_,
   {{0x27e930d9,0x543387d2,0x39520039,0x8c439cce}},	//   _quan_, _فرور, _days_, _неце,
   {{0x799d1c01,0x7d0d30da,0x3e580242,0x6f0e0326}},	//   sisw, waas, _bčt_, gabc,
   {{0x442030db,0x7d0d30dc,0x63ba9122,0x7a1c0087}},	//   eri_, taas, motn, nătă,
   {{0x27e930dd,0x63ba8353,0xe8d90133,0xdd940084}},	//   _tuan_, lotn, _alụ_, пасы,
   {{0x442030de,0xe8200006,0xdb01b0df,0x539901bb}},	// [1e30] gri_, _बिया_, coló, авая_,
   {{0x7d0d30e0,0xdce982ce,0x3e5806c0,0x5b1530e1}},	//   saas, vječ, _fčt_, імет,
   {{0x26c701ac,0xd1758196,0x39468511,0x27f8807a}},	//   _áno_, жылы, feos_, _črna_,
   {{0x41c91869,0xdce9a4a0,0x59c908fd,0xf1c90ebf}},	//   रतिस, tječ, रतिर, रतिन,
   {{0x1869a457,0xa069828b,0x63bab0e2,0xa3d51354}},	//   рали_, рала_, kotn, _момч,
   {{0xaded9344,0x36198009,0x66fb06bf,0xdce982ce}},	//   _चंदन_, ацию_, ्रिक_, rječ,
   {{0x3cdb8076,0xdce9920e,0x25a930e3,0x752981ed}},	//   खेने_, sječ, onal_, tgez,
   {{0x25a930e4,0x4c85835f,0x6449b0e5,0x3946a706}},	//   nnal_, жлив, twei, ceos_,
   {{0x290fb0e6,0xe10100c8,0x7989826b,0x7529b0e7}},	//   maga_, ্লাহ_, _ilew, rgez,
   {{0x290fb0e8,0x6449b0e9,0x645d2bea,0x395230ea}},	//   laga_, rwei, _mrsi, _says_,
   {{0x395203d3,0x89aa0364,0x6449a7f9,0x60cd30eb}},	//   _pays_, иков_, swei, _azam,
   {{0x290fb0ec,0x442030ed,0xc1740326,0xdb01b0ee}},	//   naga_, yri_, _kiɗi_, toló,
   {{0x77770197,0xcb699073,0xe8e00129,0x25a904e8}},	//   _boxx, _вале_, _ruồi_, dnal_,
   {{0x442030ef,0x60cd0754,0x661a03f2,0x5ed080ab}},	//   vri_, _dzam, átko, _স্টে,
   {{0xb87b25a7,0x645d30f0,0xdb01b0f1,0x290fb0f2}},	//   scíp, _arsi, soló, kaga_,
   {{0x442030f3,0xa3c38a74,0x2d8db0f4,0xa0a6004a}},	//   tri_, ्षक_, nhee_, _майд,
   {{0x442030f5,0x7d0b8065,0x290fb0f6,0x9f840198}},	// [1e40] uri_, _megs, daga_, töä_,
   {{0x442030f7,0x76418022,0x2bcf800c,0xa2d080d4}},	//   rri_, _oply, _सीमा, डेक्,
   {{0x79828063,0x644f30f8,0x442030f9,0x98b90084}},	//   tkow, _esci, sri_, resą_,
   {{0x442030fa,0x5f460416,0xed5a0f2f,0x08c69ccf}},	//   pri_, _انگل, _том_, обен,
   {{0x3946a82b,0x7982b0fb,0x61e430fc,0x798988f9}},	//   reos_, rkow, _miil, _dlew,
   {{0x7989b0fd,0xdfcf8013,0x394682ba,0x7982809a}},	//   _elew, نين_, seos_, skow,
   {{0x63baa67b,0x394685e4,0x290f820c,0xa3d70701}},	//   votn, peos_, baga_, ागर_,
   {{0x61e40a2c,0x6d5630fe,0x25a030ff,0x290fb100}},	//   _niil, ndya, niil_, caga_,
   {{0x98a38a29,0x61ea802e,0x60c40d4c,0x7c3604fe}},	//   _жите, _sufl, _nyim, ntyr,
   {{0x25a91b3b,0x61e40362,0x63a8808e,0xdb17002a}},	//   znal_, _aiil, undn, toxé,
   {{0xa2a001fe,0x63bab101,0x19590a41,0x326680e8}},	//   _गेम्, rotn, баны_, ітов,
   {{0x63bab102,0xdb17002a,0x60c40a03,0x6fc48580}},	//   sotn, roxé, _byim, dòci,
   {{0xb8f3035a,0x63ba807a,0x9f490187,0xdb01823e}},	//   _वर_, potn, _itaú_, rolò,
   {{0x290fb103,0x60cd007a,0xa294902a,0xdb170118}},	//   zaga_, _vzam, _налі, poxé,
   {{0x290fb104,0xdd9b240b,0x6933001b,0xdb23807b}},	//   yaga_, аша_, _přeč, _þrát,
   {{0xf1a40087,0x48151285,0x3f833105,0x1b0400ab}},	//   _орын, _емис, skju_, _লাগে_,
   {{0x6ebb05e8,0x25a90806,0x60cd3106,0xe8e0001c}},	// [1e50] _शुरु, rnal_, _uzam, _buổi_,
   {{0xd25b2a0e,0x645d0042,0x69c0ac62,0xed5985f3}},	//   ице_, _vrsi, _akme, može_,
   {{0xdced0a20,0x290fb107,0xdb07008b,0x25a02960}},	//   ljač, taga_, _skjó, biil_,
   {{0x20090300,0x2b8086c0,0x25a00079,0x604081bc}},	//   _kwai_, _wòch_, ciil_, _ịmag,
   {{0x290fb108,0x644f3109,0x7d0b81b0,0x64468085}},	//   raga_, _usci, _regs, çkil,
   {{0x442927ba,0x290fb10a,0xd34300d5,0x637f83a7}},	//   mua_, saga_, _تفسی, _têni,
   {{0x4429310b,0x64428e67,0xf96bb10c,0x2d8d89ff}},	//   lua_, _apoi, _край_, thee_,
   {{0x752d310d,0xe79580d5,0x3cf7809a,0x764180e1}},	//   ngaz, _کارک, ीरें_, _vply,
   {{0xdced0067,0xd7f89ddf,0x1c428190,0x68e98609}},	//   jjač, _дух_, еным, _iged,
   {{0x61e42933,0x2d8d8079,0xdced0503,0x7d0b96a1}},	//   _siil, shee_, djač, _wegs,
   {{0x442910af,0x4b7c0158,0x7641816b,0x61e4156e}},	//   hua_, יאזו, _uply, _piil,
   {{0x4429310e,0xe8028c1c,0x248001a5,0x644f806a}},	//   kua_, रीका_, yyim_, æcis,
   {{0x4429310f,0x2d9d80b4,0x27e5a817,0xeb8e96c7}},	//   jua_, _imwe_, _kiln_, _зи_,
   {{0x44290ee2,0x7c298216,0x61e40079,0x752d047f}},	//   dua_, muer, _wiil, egaz,
   {{0x96632240,0x7c2981eb,0x63a1b110,0x68e9b111}},	//   нкре, luer, miln, _oged,
   {{0x752d1eb7,0x68e9b112,0xdce404a8,0x4429004f}},	//   ggaz, _nged, njić, fua_,
   {{0x44293113,0x27ed8102,0x7c29b060,0xd467013a}},	// [1e60] gua_, _nuen_, nuer, пите_,
   {{0xe7ef8105,0x63a1b114,0x213f88f9,0x68e9a020}},	//   _चढ़ा_, niln, _abuh_, _aged,
   {{0x7c362280,0x24920063,0x44290087,0x248615d8}},	//   styr, szym_, aua_, šom_,
   {{0xb4ea8076,0x44293115,0x27ed80ab,0x290d802e}},	//   _मले_, bua_, _buen_, _ceea_,
   {{0xa3cb9521,0x7d04245e,0xe8e00028,0x63a1b116}},	//   लता_, mbis, _tuổi_, kiln,
   {{0x26c5800d,0x27ed811e,0xfbc78bbe,0x7c29b117}},	//   _bylo_, _duen_, _ست_, duer,
   {{0x63a1b118,0x68edaeb6,0x6b6305a8,0xa3c18074}},	//   diln, žada, _якра, ूतन_,
   {{0x7c298693,0xb608801b,0x7f8b0085,0x7d043119}},	//   fuer, jišť, _müqa, nbis,
   {{0x7c29ac92,0xdb050511,0x7d04311a,0xbcfb01d6}},	//   guer, cohó, ibis, _poéz,
   {{0x5ede80c8,0x39400057,0xfbbe1664,0x63a1a0d0}},	//   নুষে, _abis_, ्तिम, giln,
   {{0x27ed80ad,0x4429311b,0xa3e401ce,0x61ee04fe}},	//   _zuen_, zua_, _पूछ_, _jubl,
   {{0xed59803e,0x7c2984dc,0x63be027f,0xa3e79344}},	//   tože_, buer, hopn, _मूक_,
   {{0x63a1a842,0x7c2985b4,0xc8640adb,0x53348198}},	//   biln, cuer, нтри, _желт,
   {{0x61ee03d3,0x7c242944,0x4429311c,0x38660bcf}},	//   _oubl, drir, vua_, _šorc_,
   {{0xdced0042,0x7bda807b,0x433b8039,0x777ab11d}},	//   sjač, mmtu, _העוב, _motx,
   {{0x4429311e,0x7c24311f,0x7d04221b,0x55743120}},	//   tua_, frir, gbis, нгст,
   {{0x09c909a3,0x3f8c8459,0x7c243121,0x752d3122}},	// [1e70] रतीय, _oldu_, grir, rgaz,
   {{0x3b540a4c,0x44293123,0x798d0282,0x44248c5e}},	//   нкур, rua_, _hlaw, irm_,
   {{0x44293124,0xb6068024,0x213f80ee,0x7c243125}},	//   sua_, nošć, _pbuh_, arir,
   {{0x15f205b3,0xdd86803f,0x44293126,0x7dc58510}},	//   _आंतर_, _شو_, pua_, pósi,
   {{0x27edb127,0xdb1707f4,0x44290098,0xdb1c3128}},	//   _quen_, loxí, qua_, _chró,
   {{0x798d031d,0x777a809f,0x3f9e80b9,0x3dc90080}},	//   _llaw, _cotx, _cmtu_, llaw_,
   {{0x63a1acc8,0x61ee02a5,0x7c299770,0x798d3129}},	//   viln, _gubl, wuer, _olaw,
   {{0x7c299914,0xb60680ce,0x63a18035,0x3dc91217}},	//   tuer, došć, wiln, nlaw_,
   {{0x63a1b12a,0x320102d5,0x3940002a,0x69c38036}},	//   tiln, lphy_, _rbis_, îneu,
   {{0x798d312b,0x7c29b12c,0x798611ee,0xaca3819d}},	//   _alaw, ruer, wkkw, _nkụk,
   {{0x7c299b6c,0x63a18353,0xb6068da4,0xa91d8bcf}},	//   suer, riln, gošć, _alži,
   {{0x7c298388,0x7e7e816d,0xaca3882e,0x2d9d82a0}},	//   puer, äppe, _akụk, _umwe_,
   {{0x798d312d,0x63a1b12e,0x3dc9033e,0xbcfb00e1}},	//   _dlaw, piln, dlaw_, _inéh,
   {{0x8c4295e0,0x61fb0b67,0x7c24312f,0xa49b0706}},	//   _реше, _čuln, vrir, _leòs,
   {{0xafe30037,0xdb1703a8,0x7d0f0061,0x4ad191be}},	//   торл, goxí, _becs, _हरिव,
   {{0x61ee3130,0x99520110,0x25adb131,0xe817016f}},	//   _rubl, ršų_, nnel_, _तिचा_,
   {{0x7d043132,0xdca322fd,0x63be007a,0x6fcd80e1}},	// [1e80] rbis, вати, topn, júco,
   {{0x25bf82d6,0x7c24011e,0x387f0192,0x7dea8196}},	//   houl_, rrir, äure_, _kęst,
   {{0xa49b0706,0xdb1c0229,0x68ed81d6,0x3dc90428}},	//   _beòs, _bhrò, ľadn, blaw_,
   {{0x7c240081,0x3dc93133,0xdb1c1a26,0x2f0a8035}},	//   prir, claw_, _phró, _mógł_,
   {{0xb8f6901b,0x7bc38b99,0x7bc8807b,0xaca4019d}},	//   _हर_, _oknu, yldu, _maịs,
   {{0xdb1a826f,0x61ee02f1,0x9f458176,0xe29a3134}},	//   poté, _tubl, _jilè_, _даг_,
   {{0x2b580088,0x69c43135,0x61fc0503,0x9f8d008b}},	//   _iarc_, _okie, _utrl, nþá_,
   {{0xa5349612,0xb606811f,0x2d9202f7,0x29c40118}},	//   хнич, vošć, nhye_, iñas_,
   {{0x29069f33,0x20c381e5,0x7e878110,0xdb18b136}},	//   mboa_, _айтм, _įspū, _akvá,
   {{0x798d3137,0x69c42810,0xb606811f,0x2b583138}},	//   _slaw, _akie, tošć, _jarc_,
   {{0xa2c19513,0xd01380c8,0x798d01e9,0x3218826f}},	//   _रुद्, _সময়_, _plaw, éry_,
   {{0xe4a6954f,0xc486b139,0x68e4826c,0xb6068bcf}},	//   _орло, _олек, židu, rošć,
   {{0xa3e7823c,0xc058102a,0xbf0a016f,0x10740c4f}},	//   _मंच_, мір_, वरून_, вляю,
   {{0x0efb313a,0x2b58313b,0x47cc80ab,0x3dc902c4}},	//   ्रेस_, _narc_, াদকী, wlaw_,
   {{0x52bf0beb,0x9f45b13c,0x69c40609,0x3ceb010d}},	//   _्रेस, _dilè_, _fkie, _pgcv_,
   {{0x3dc90122,0x7f5701b4,0x58d5062c,0x637f8901}},	//   ulaw_, _waxq, _пойт, _fêns,
   {{0x7d020333,0x3dc9313d,0xb7d50032,0x9f4586c4}},	// [1e90] ñosa, rlaw_, _aṣen, _filè_,
   {{0x6d978087,0x69dd313e,0xdb018366,0xdb1c0a2a}},	//   nţar, lmse, anlæ, _shrò,
   {{0xb50e86a7,0x7d0f313f,0xe1f00481,0xdb1c01e4}},	//   सराय_, _tecs, لسن_, _phrò,
   {{0x32013140,0x7dc5b141,0x645c80eb,0x68ed80e1}},	//   rphy_, nóst, ārij, ľado,
   {{0x68ed826f,0x2b583142,0x20190198,0x6008902a}},	//   žado, _farc_, nssi_, днім_,
   {{0x657d3143,0x7c2d3144,0xa49b0229,0x443907f1}},	//   _hosh, muar, _feòr, _iqs_,
   {{0x7c2d3145,0xee398cde,0x2bbe090f,0x657d3146}},	//   luar, їни_, ्तरा, _kosh,
   {{0x68ed3147,0x63a5178f,0x657d3148,0x6d87811b}},	//   _ngad, lihn, _josh, _iñak,
   {{0x657d3149,0x3834b14a,0x7c2d314b,0xed598904}},	//   _mosh, _интр, nuar, rdž_,
   {{0x69c4314c,0xa3bf0592,0x61e9b14d,0x63a500dd}},	//   _skie, ँकि_, _hiel, nihn,
   {{0x61e9b14e,0xa2d3016f,0x60c982f7,0x25ad8706}},	//   _kiel, भेच्, _hyem, pnel_,
   {{0x657d314f,0x7c2d3150,0xa3cf81a2,0x60c983f7}},	//   _nosh, kuar, _वीर_, _kyem,
   {{0x61e9b151,0xdb088511,0x656bb152,0xbcfb00f7}},	//   _miel, godó, _ingh, _gnéi,
   {{0x61e98341,0x7c2d3153,0x7c3bb154,0xdb1e0168}},	//   _liel, duar, mtur, ropë,
   {{0x6d59b155,0x657d3156,0x442db157,0x63a514e4}},	//   _kawa, _bosh, lue_, dihn,
   {{0x6d5bb158,0x61e9b159,0x7bc1b15a,0xaca381bc}},	//   ndua, _niel, lolu, _nhịk,
   {{0x2b58315b,0x6d59b083,0x7c2d315c,0x6aa806ce}},	// [1ea0] _parc_, _mawa, guar, कप्र,
   {{0x6d59b15d,0x291fb15e,0xaca3819d,0x2d9202a0}},	//   _lawa, _adua_, _ahịk, shye_,
   {{0x61e9b15f,0x27ffa266,0x3ea63160,0xa9269d79}},	//   _biel, _atun_, _чинг, едел,
   {{0x61e9b161,0x6d59b162,0x657d3163,0xb17b016d}},	//   _ciel, _nawa, _gosh, rmåg,
   {{0xc7c69821,0x4fc6a950,0x61e988dd,0x7d1602a3}},	//   нски, нска, _diel, mays,
   {{0x7d163164,0x656bb165,0xfaa60d0e,0x442db166}},	//   lays, _angh, _заго, due_,
   {{0x6d59b167,0x657d3168,0x1dcb999e,0x61e98039}},	//   _bawa, _yosh, ातंत, _fiel,
   {{0x7d163169,0x6d59b16a,0x61e98609,0xdd9781a0}},	//   nays, _cawa, _giel, ешь_,
   {{0x442daa70,0x7c3b96fb,0x3cdb82f1,0x60c9b16b}},	//   gue_, gtur, खेले_, _gyem,
   {{0x09c90b6f,0xa0a3b16c,0x61e9b16d,0x1e969285}},	//   रत्य, _сауд, _ziel, _прер,
   {{0x200d8352,0x0c73819f,0x7d160b8a,0x7c2d316e}},	//   _zwei_, ندید, kays, zuar,
   {{0x6d59b16f,0xdce606c4,0x67eb0372,0x0efb01a2}},	//   _gawa, _ankč, _ażja, ्र्स_,
   {{0x7c3b9b9f,0x69dd3170,0x7bc1b171,0x7d160079}},	//   ctur, rmse, bolu, days,
   {{0x7bc1802e,0x657d3172,0x6d59b173,0x2019156e}},	//   colu, _sosh, _zawa, rssi_,
   {{0xdb1a87e2,0x6d59b174,0xa2a0016f,0x657d09be}},	//   notí, _yawa, _गेल्, _posh,
   {{0x7d160079,0x7c2201b9,0xdb01b175,0x6285016b}},	//   gays, ġorn, vilé, vyho,
   {{0x63a509da,0x61e9b176,0xb81ca076,0x6d4d3177}},	// [1eb0] tihn, _riel, _निगम_, reaa,
   {{0x7c2d275d,0x61e9b178,0x6e2e3179,0xb17b0366}},	//   ruar, _siel, bubb, småd,
   {{0x61e9b17a,0x7d160079,0x442d8102,0xdb188106}},	//   _piel, bays, zue_, _ikvä,
   {{0x63a5010b,0x1c218665,0x61e98168,0x27ff808e}},	//   sihn, _मिलल_, _qiel, _ptun_,
   {{0x61e9b17b,0x6d59b17c,0x7c2d317d,0x29d900f7}},	//   _viel, _rawa, quar, méad_,
   {{0x61e9b17e,0x6d598886,0xdce9920e,0x442db17f}},	//   _wiel, _sawa, ljeć, vue_,
   {{0x44293180,0x61e9b181,0x6d59b182,0x6d40b183}},	//   lra_, _tiel, _pawa, ffma,
   {{0x7c3b81dc,0x44293184,0x8d658ada,0xf8bf07bc}},	//   ttur, ora_, твие, ngés_,
   {{0x44293185,0xe43280f7,0x7bc1b186,0x6d5bb187}},	//   nra_, لفيد, tolu, rdua,
   {{0x4429186b,0x6d59b188,0x442db189,0x394fb18a}},	//   ira_, _wawa, rue_, legs_,
   {{0x09d60a49,0x6d59b18b,0x7bc1b18c,0x316d8390}},	//   _সংবা, _tawa, rolu, _knez_,
   {{0x4429318d,0x7bc1b18e,0xdb1e02be,0x656bb18f}},	//   kra_, solu, ropé, _ungh,
   {{0x442db190,0x29120179,0x8edf00c8,0x44293191}},	//   que_, _veya_, _ব্লগ, jra_,
   {{0x44293192,0x701380ab,0x7d16057b,0x7c29a280}},	//   dra_, _সমাজ_, ways, mrer,
   {{0x44293193,0x65b301cd,0x6da61577,0x7d020333}},	//   era_, għho, вива, ñoso,
   {{0x7d09aa97,0x893612c8,0x6e2e3194,0x12e880be}},	//   nbes, _شعبا, rubb, _אַפּ,
   {{0x44293195,0xa91d803a,0x7d1602a3,0x28de0540}},	// [1ec0] gra_, _možd, rays, नेशि,
   {{0x6e2e235a,0x7d163196,0x06863197,0x8cd6864a}},	//   pubb, says, _агон, मेटो,
   {{0x44293198,0x7c2982af,0xdce982ce,0x7d09874c}},	//   ara_, hrer, bjeć, kbes,
   {{0x29d900f7,0x7d1601b4,0x637e928a,0x6fcd8174}},	//   céad_, qays, _záně, lúch,
   {{0x7d09b199,0x317f83ec,0x6d46026b,0xe9478061}},	//   dbes, _douz_, _ibka, ئرمی,
   {{0x5ead80c8,0x7c29b19a,0xaca38135,0x7d09a0b5}},	//   য়েছে, drer, _chọk, ebes,
   {{0x6ae000c8,0x7c29b19b,0xf3f400ab,0x7d09b19c}},	//   _প্রো, erer, _ছবির_, fbes,
   {{0x7d09b19d,0x6ce68d13,0x7c2982df,0x6fcd8174}},	//   gbes, кіпе, frer, húch,
   {{0xc0458277,0x7c29b19e,0xdb1c01d0,0x00000000}},	//   _مخلو, grer, _zkrá, --,
   {{0xf4130051,0x2006b19f,0xf3669677,0xa91d9502}},	//   ספת_, mpoi_, ттин, _požg,
   {{0xc3331a0f,0x442931a0,0x79809088,0x7d09b1a1}},	//   בות_, zra_, _komw, bbes,
   {{0x7c29b1a2,0x316d31a3,0x6f188353,0x44290e20}},	//   brer, ñez_, lavc, yra_,
   {{0x75228133,0xb7d50032,0x6d958091,0xe9df002a}},	//   _idoz, _aṣan, _dáad, rmú_,
   {{0x442931a4,0x547b8039,0x9e3531a5,0x6d4631a6}},	//   vra_, _קטגו, легч, _abka,
   {{0xb8ca058c,0x442919e7,0x2bb1816f,0x2bec064a}},	//   _गे_, wra_, ीकरा, _अंजू_,
   {{0xa91d826f,0x7bc7104a,0x7e6531a7,0xdcfb811f}},	//   _kože, _skju, _vrhp, rkuć,
   {{0xdb1c31a8,0x291931a9,0x6f18807d,0xdcfb8289}},	// [1ed0] _skrá, masa_, kavc, skuć,
   {{0xa91d803a,0x4ea72097,0x8f55035f,0xdce9920e}},	//   _može, _арма, _свої, sjeć,
   {{0x442931aa,0x6f188503,0x7522b1ab,0x61ed31ac}},	//   sra_, davc, _odoz, _kial,
   {{0x442931ad,0x291931ae,0x673b012b,0x60cd31af}},	//   pra_, nasa_, đuju, _kyam,
   {{0xa3c2853e,0xa91d8503,0x6d5d0cb5,0x6fcdb1b0}},	//   ंवा_, _nože, _iasa, lúci,
   {{0x291915bd,0x7522b1b1,0x24890282,0x2d82b1b2}},	//   hasa_, _adoz, myam_, öken_,
   {{0x6d5d31b3,0x6da59860,0x291931b4,0xe5a5a2fd}},	//   _kasa, лика, kasa_, лики,
   {{0x61ed31b5,0x7bc50091,0x7c29b1b6,0xe459813a}},	//   _nial, lohu, trer, ежи_,
   {{0x6d5d318b,0x60cd31b7,0x6f1880d2,0xa91d8279}},	//   _masa, _nyam, bavc, _vožd,
   {{0x7c29ac03,0x6d5d31b8,0x2bd90321,0x490b800d}},	//   rrer, _lasa, _बीमा, ारको_,
   {{0x61ed31b9,0x6fcd81ac,0x60cd31ba,0x25a91e1e}},	//   _bial, júci, _ayam, kial_,
   {{0x6d5d31bb,0x291931bc,0xb4db046d,0x60cd1c61}},	//   _nasa, gasa_, _abàm, _byam,
   {{0x61ed26fd,0x4429b1bd,0x9b458591,0x343980be}},	//   _dial, _ía_, _منشو, _נײַע,
   {{0x9474806b,0x656f1140,0x63a88699,0x443fb1be}},	//   _خدما, _anch, cidn, mtu_,
   {{0x6d5d31bf,0xa2ca89a3,0x291911c2,0x61ed31c0}},	//   _basa, _सुप्, basa_, _fial,
   {{0x5bbe0f21,0x61ed31c1,0x69c98069,0xed5715fc}},	//   ्त्व, _gial, _nkee, лос_,
   {{0x443f88a7,0x6d5d059c,0x2bf680be,0x69c631c2}},	// [1ee0] ntu_, _dasa, ָמען_, moke,
   {{0x443fb1c3,0x69c631c4,0xa09b03de,0x69c9b1c5}},	//   itu_, loke, _נייט, _akee,
   {{0x6d5d31c6,0x443fb1c7,0x201f87e2,0x35a61986}},	//   _fasa, htu_, _avui_, _банг,
   {{0x25a930cc,0x6d5d31c8,0x05560d0e,0x644b8366}},	//   cial_, _gasa, _стоя, _opgi,
   {{0xdefa825d,0x443fb1c9,0xa2ca9516,0xbcfb0333}},	//   ный_, jtu_, _सुन्, _enés,
   {{0x6d5d0491,0xdb1c006a,0x69c631ca,0x7c2b1434}},	//   _zasa, _skræ, hoke, ágre,
   {{0x6d5d31cb,0x291931cc,0xb8eb800c,0xbb3b00be}},	//   _yasa, yasa_, _रु_, _רעלי,
   {{0xa91d80ce,0x6d5d02a3,0x69c623be,0x6f18b1cd}},	//   _pože, _xasa, joke, savc,
   {{0x61ed0307,0x20e303dd,0x63a8816d,0x6f18b1ce}},	//   _rial, _गणेश_, tidn, pavc,
   {{0x40938013,0x2d8231cf,0x25a931d0,0x61ed31d1}},	//   _الكر, _loke_, zial_, _sial,
   {{0x61ed0397,0x291931d2,0x60cd0590,0x443fb1d3}},	//   _pial, tasa_, _syam, atu_,
   {{0x6288b1d4,0xa91d807a,0x7bc5004f,0xe80b801b}},	//   rydo, _tože, zohu, सीका_,
   {{0x291931d5,0x629ab1d6,0x61ed31d7,0x44321126}},	//   rasa_, szto, _vial, juy_,
   {{0x6d5d2fd2,0x29192fc9,0x60cd0010,0x6fcd80e1}},	//   _sasa, sasa_, _vyam, túci,
   {{0x6d5d31d8,0xcddb0fbb,0x6d4431d9,0x69c62127}},	//   _pasa, ења_, ffia, boke,
   {{0x55580160,0x6d5d31da,0x2d580987,0x248905b0}},	//   лася_, _qasa, лись_, tyam_,
   {{0x5b1531db,0x6d5d31dc,0x7bc531dd,0x7bdc0083}},	// [1ef0] имат, _vasa, tohu, _bhru,
   {{0x6d5d31de,0x25a931df,0x7bdc0c64,0x248931e0}},	//   _wasa, sial_, _chru, ryam_,
   {{0x6d5d31e1,0x443f811e,0x7ceb8019,0xd2510c3b}},	//   _tasa, ztu_, _körü, تنا_,
   {{0x6d5d0c41,0x3d0e809a,0xbcfb31e2,0xdb018216}},	//   _uasa, सरों_, _enér, vilí,
   {{0x65360158,0xe739a2f6,0x443fb1e3,0xf3ff0187}},	//   _דארף_, вел_, xtu_, _irão_,
   {{0x61f531e4,0x8ae70d13,0xdb01b1e5,0xdb0883a7}},	//   _tuzl, _бібл, tilí, sidê,
   {{0xed59af02,0x69dbb1e6,0x61fc8118,0x01d60264}},	//   вой_, _thue, írll, _সংসদ,
   {{0x443f9184,0x14258284,0x0d85824f,0x7c2d31c1}},	//   ttu_, адим, рлин, orar,
   {{0x443fb1e7,0x998480f7,0x7c2d04be,0x69c631e8}},	//   utu_, _القو, nrar, voke,
   {{0x395fb1e9,0x4a45acd1,0x443fb1ea,0x25a6a20c}},	//   _haus_, анов, rtu_, _emol_,
   {{0xa2cb2e06,0x69c6022e,0x395fb1eb,0x2fc7b1ec}},	//   _तुम्, toke, _kaus_, mong_,
   {{0x9f49007b,0x7c2d31ed,0x39490362,0x2fc7b1ee}},	//   _stað_, krar, _cbas_, long_,
   {{0x69c631ef,0xa2a71055,0x2d82007a,0xeb8eb1f0}},	//   roke, _टेस्, _roke_, _ди_,
   {{0x7d1bb1f1,0x395f81c5,0x2fc784d2,0x442d906f}},	//   laus, _laus_, nong_, mre_,
   {{0x66e61198,0xeab00a49,0xdee60b9c,0x69c60010}},	//   рова, _কর্ম, рови, poke,
   {{0x7ceb8b06,0x2fc7840a,0x7d0d31f2,0x442db1f3}},	//   _görü, hong_, gbas, ore_,
   {{0x2fc7b1f4,0x7c2d0baf,0x6db7012b,0x6d4431f5}},	// [1f00] kong_, grar, pćan, rfia,
   {{0x442db1f6,0x6b83b1f7,0x2fc7b1f8,0xb6a61d8f}},	//   ire_, _jong, jong_, _виол,
   {{0x6f1c2c92,0x6b83b1f9,0x442db1fa,0x2fc782b8}},	//   marc, _mong, hre_, dong_,
   {{0xd94693b4,0x442db1fb,0x7d1b87ac,0x6f1c31fc}},	//   реди, kre_, jaus, larc,
   {{0x61e281b9,0x395f8282,0x7c2d002e,0x442db1fd}},	//   rmol, _daus_, crar, jre_,
   {{0x442d8e1c,0x2fc7b1fe,0x442031ff,0x7996031d}},	//   dre_, gong_, msi_, _llyw,
   {{0xd5ba9506,0x395f8282,0xf8d32769,0x6d4781a1}},	//   кси_, _faus_, _सर्प, đjan,
   {{0x442db200,0x44200190,0x6f1c3201,0x6b839e3f}},	//   fre_, osi_, harc, _aong,
   {{0x57eaa2f6,0x442d888b,0x6b83b202,0x2fc78bf2}},	//   _адам_, gre_, _bong, bong_,
   {{0x44203203,0x46a68098,0xbea68221,0x2fc7b204}},	//   isi_, _казв, _казк, cong_,
   {{0x6b83b205,0x442db206,0x6440b207,0x6f1c3208}},	//   _dong, are_, stmi, darc,
   {{0x442db209,0x4420320a,0x8c46875a,0x7d1b8051}},	//   bre_, ksi_, _веде, caus,
   {{0x6f1c2b02,0xfce68abe,0x4420320b,0x6b83907c}},	//   farc, _тодо, jsi_, _fong,
   {{0x6f1c320c,0x7c2d0012,0x8c1b83c8,0x6b83821e}},	//   garc, vrar, _יודי, _gong,
   {{0x7c22b20d,0x7bc8b20e,0x61418019,0x3160320f}},	//   _hvor, modu, náló, _faiz_,
   {{0x4420022e,0x44f53210,0x39151bdc,0x527b84de}},	//   fsi_, спас, _умир, _ינוא,
   {{0x2fc784d2,0x7d0d3211,0xe4e7035f,0x6b83b212}},	// [1f10] yong_, rbas, рівн, _yong,
   {{0x7c2d3213,0x6f1c3214,0x395fb215,0xd9bf83eb}},	//   rrar, carc, _saus_, एक्ट,
   {{0x395fb216,0x4420127b,0x2bbe0424,0x442d8061}},	//   _paus_, asi_, ्तजा, zre_,
   {{0x442db217,0x2fc7833e,0x44203218,0xdb088722}},	//   yre_, wong_, bsi_, sidè,
   {{0x44203219,0x2fc7843c,0x557600be,0x395f81c0}},	//   csi_, tong_, _הערן_, _vaus_,
   {{0x442db21a,0x645d321b,0x7d02b21c,0x06b280ab}},	//   vre_, _issi, _afos, য়েছি,
   {{0x2fc782e8,0x22950013,0xa6c996fe,0x7c22b21d}},	//   rong_, _الأس, ылка_, _avor,
   {{0x6b83b21e,0x56b80039,0x2fc7b21f,0x6f1c3220}},	//   _song, יפון_, song_, zarc,
   {{0x442da962,0x6b83b221,0x7f8b0201,0x2fc7b222}},	//   ure_, _pong, _hüqu, pong_,
   {{0x442d8625,0x291db223,0x31600ad4,0x7c22a8fc}},	//   rre_, lawa_, _saiz_, _dvor,
   {{0xa2ca816f,0x442d8019,0x6f1c3224,0xb17b0502}},	//   _सुद्, sre_, varc, rmån,
   {{0x442da65d,0x291db225,0x44203226,0xd00a1d32}},	//   pre_, nawa_, ysi_, леме_,
   {{0x6f1c3227,0x8d5a8039,0x44200085,0x31601dd7}},	//   tarc, _תכני, xsi_, _vaiz_,
   {{0x291d9cbc,0x6b838010,0x6b9a8a11,0x7643808e}},	//   hawa_, _uong, chtg, otny,
   {{0x291db228,0x645d20ef,0x7c228253,0x2d96283b}},	//   kawa_, _assi, _zvor, брас,
   {{0x442024fc,0x6da3006d,0x6f1c3229,0x2b4a008e}},	//   tsi_, писа, sarc, _sbbc_,
   {{0x7b068065,0x4420322a,0x291db22b,0x249f82ce}},	// [1f20] _érté, usi_, dawa_, nzum_,
   {{0x44202f37,0xa91db22c,0xa3dd80d4,0x61e60b81}},	//   rsi_, _roža, _थीम_, lmkl,
   {{0x645d322d,0x25adb22e,0xdb070019,0x60dbb22f}},	//   _essi, kiel_, ámár, _azum,
   {{0x291db230,0x38668067,0xa91d90d1,0xf1a5835f}},	//   gawa_, tvor_, _poža, орін,
   {{0x53c787e6,0x44203231,0x25ad81ac,0x6d563232}},	//   रकाश, qsi_, diel_, meya,
   {{0x60db8267,0x38cb803d,0xd8d700be,0x3f858140}},	//   _dzum, دامی_, זונט_, _colu_,
   {{0x25ad82d8,0x291d985b,0x3f8585aa,0x7c22b233}},	//   fiel_, bawa_, _dolu_, _svor,
   {{0x65643234,0x2d803235,0xd94397c8,0xdd978084}},	//   ndih, njie_, _неси, йшы_,
   {{0x91e38758,0x64443236,0x76438057,0x61f89123}},	//   _хоте, ntii, atny, _suvl,
   {{0x5c5b00be,0x69df00f1,0x3f858390,0x2902009a}},	//   נדיק, _shqe, _golu_, ecka_,
   {{0xa91d9234,0x64d506a7,0x25ad9695,0x6d56010c}},	//   _možn, _दर्श, biel_, keya,
   {{0x7c2284e8,0x25adb237,0x64440406,0x7bc8b238}},	//   _tvor, ciel_, ktii, sodu,
   {{0x399b020f,0xa3d805fb,0x3f858059,0x2d8001b0}},	//   _nëse_, ाता_, _yolu_, djie_,
   {{0x0a948d13,0x291db239,0xdbf1001b,0x2ca0026c}},	//   _малю, zawa_, _příl, dzid_,
   {{0x5694323a,0xa14380eb,0x291d801d,0xfdc406a7}},	//   парт, šķir, yawa_, वकूफ,
   {{0x6d56323b,0x644401b4,0x69cd323c,0x6d9c8174}},	//   geya, ftii, _ukae, _déag,
   {{0x5fba941b,0x2129036e,0x4dd401a8,0x765e06c4}},	// [1f30] ेवाल, _idah_, ستفس, _espy,
   {{0xdea404c0,0x291db23d,0x6f1ab23e,0x25adb23f}},	//   _کیفی, wawa_, _netc, ziel_,
   {{0x291db1bb,0x6d563240,0xd6d9003d,0x72b901a8}},	//   tawa_, beya, _خودش_, جهاز_,
   {{0x6ab90beb,0x291d804f,0x8f5500d7,0x64443241}},	//   _आशीर, uawa_, _انگش, btii,
   {{0x291db242,0xf7708416,0x6d9c80f7,0x25adb243}},	//   rawa_, کان_, _méad, viel_,
   {{0x291db244,0x6d4b8359,0x25ad9699,0x8afe8326}},	//   sawa_, _sbga, wiel_, _yaƙe,
   {{0x2902016d,0xfebb815b,0x62341138,0x66e28048}},	//   ycka_, داشت_, _неру, моша,
   {{0x200903ac,0x7dc58019,0x23633245,0x7643b246}},	//   _otai_, lósz, _hajj_, rtny,
   {{0xa2b901b6,0x25adb247,0x60dbb248,0x92e680ab}},	//   ्थव्, riel_, _uzum, যুৎ_,
   {{0x42259895,0x212900dd,0xb17b0f91,0x25adb249}},	//   одов, _adah_, smål, siel_,
   {{0x80d100c8,0x25adb24a,0x09b580be,0x6d56324b}},	//   সেম্, piel_, ַפֿט_, yeya,
   {{0x6d9cb24c,0x64440198,0xbc758a19,0xdb038f35}},	//   _réag, ytii, _وهاب, _imní,
   {{0xe45f025d,0x6d56324d,0x10a30162,0x65642cc7}},	//   _myös_, veya, диян, vdih,
   {{0x69cbb24e,0x212900ee,0x1af38264,0x6d498174}},	//   hoge, _edah_, _আজকে_, lfea,
   {{0x59c9885d,0xba778077,0x2d80079f,0xb8d108af}},	//   िकार, _داشت, tjie_, _टे_,
   {{0x64440364,0x753ba479,0xf50a324f,0x29d901a8}},	//   ttii, nguz, рнал_, néal_,
   {{0x92d600c8,0x6d563250,0xd46718a0,0x3b862482}},	// [1f40] _হলে_, reya, оите_, олаг,
   {{0x32d630bc,0xa91db251,0x64443241,0x213f80dd}},	//   оцес, _božo, rtii, _acuh_,
   {{0xe8fa9777,0x64443252,0x8b0780fc,0x69cb9a16}},	//   але_, stii, _taƙƙ, foge,
   {{0x6f1a82e6,0x69cbb253,0x64443254,0x7d1f011c}},	//   _setc, goge, ptii, caqs,
   {{0xe0568277,0xa91d807a,0x29d901a8,0x386001b9}},	//   تخاب, _tožn, déal_, _jsir_,
   {{0x44320114,0x7c240834,0x7d043255,0x9e06818b}},	//   mry_, msir, lcis, очил,
   {{0xdd9a9617,0x41ca1299,0x69cbb256,0xbf9b0036}},	//   иши_, रवास, boge, mpêt,
   {{0x69cb81ca,0xed59939c,0x7d043257,0x4432309c}},	//   coge, kožu_, ncis, ory_,
   {{0x7c243258,0xdb1e006a,0xc31e80ab,0x6d9c81a8}},	//   nsir, ropæ, _দাবি_, _réad,
   {{0x77928077,0x7c243259,0x44320748,0x926a88d5}},	//   _زیبا, isir, iry_, арма_,
   {{0x9d46817a,0x2009325a,0x4432016b,0xe3b8b25b}},	//   _межд, _stai_, hry_, rnı_,
   {{0x443201b0,0x7c240304,0x963385e9,0xa194102a}},	//   kry_, ksir, _ініц, даюч,
   {{0x92d600c8,0xa2ca800c,0x9f4c801b,0x7c240503}},	//   _হলো_, _सुर्, _lidí_, jsir,
   {{0x442680ce,0x69cb82af,0xc05800e8,0x09b79053}},	//   _ivo_, zoge, цію_, _अद्य,
   {{0x69cb82ec,0x4426b25c,0xddab0087,0x61fc0965}},	//   yoge, _hvo_, атал_, _nurl,
   {{0x2129035a,0x7c24325d,0x4432015c,0x2bbf2836}},	//   _udah_, fsir, fry_, ्वभा,
   {{0xb9c40013,0x6fca8540,0x78a288ae,0x3959325e}},	// [1f50] _تقيي, ाकां, jzov, mess_,
   {{0x09b3853e,0x69cb8365,0x63ba81ec,0x3959325f}},	//   ंच्य, woge, nntn, less_,
   {{0xe7f9016f,0x44323260,0x46d20cfd,0x69cb8a85}},	//   ंदवा_, ary_, _दुपह, toge,
   {{0x44268025,0xe1f80110,0x39593261,0x7d04234a}},	//   _ovo_, ігі_, ness_, ccis,
   {{0x18698258,0xa2cb3262,0xf994025f,0x8caa81a2}},	//   сали_, _तुर्, ורף_, _जेलो,
   {{0x7d1d1831,0x23fa0039,0x69cbb263,0xbdf81190}},	//   _hess, _להשא, soge, _دریا_,
   {{0x61fc1486,0xc7b40039,0xa3d800d4,0xa2ca850a}},	//   _gurl, ובס_, ातर_, _सुल्,
   {{0xc4858785,0x4c8586e6,0xf1c004e8,0x673c0140}},	//   злик, злив, čák_, zgrj,
   {{0x7d1d114e,0xe3b1803f,0x937980f7,0x29d900e7}},	//   _mess, فرد_, مصدر_, réal_,
   {{0xf8ae80d5,0x29dc85a4,0x798980c9,0x7d1d0a85}},	//   _حکم_, nían_, _hoew, _less,
   {{0x4426803a,0x799b9916,0xdb0888f1,0x8a058110}},	//   _evo_, _kluw, cidí, язне,
   {{0x7d1d1927,0x76470366,0xe61080d7,0xc7a901c6}},	//   _ness, dtjy, _ششم_, _גב_,
   {{0xb4fa8039,0x764b8110,0x92b58fd3,0xdb01862c}},	//   _הפני, žnyč, تحکا, tilä,
   {{0xfaa5a2a7,0x44323264,0xed5981c8,0x6dac02d0}},	//   _нало, vry_, lež_, rşam,
   {{0x70b89513,0x7d1d02af,0x29dc85e4,0xa2cb01d0}},	//   _अश्ल, _bess, dían_, _तुल्,
   {{0xf99f3265,0x39593266,0x7c243267,0x7d1d3268}},	//   chè_, cess_, tsir, _cess,
   {{0x7d1d3269,0x3860326a,0x8afe89ab,0x7d04262b}},	// [1f60] _dess, _usir_, _haƙa, rcis,
   {{0x4432326b,0xa01b0009,0x8afe8326,0xe7f9326c}},	//   rry_, pyör, _kaƙa, ंदरा_,
   {{0x4efb0051,0xe7170051,0x7c24326d,0x61e4326e}},	//   _להיו, _מחיר_, ssir, _khil,
   {{0xc693093f,0xd7fa8676,0x7d1d15fe,0xdb08a8e5}},	//   _נאר_, бук_, _gess, vidí,
   {{0x29dc82ba,0x61e40c41,0xed59915c,0x8afe89ab}},	//   bían_, _mhil, dež_, _laƙa,
   {{0xc7a38226,0xa2a7326f,0x29dc85e4,0x8fa3a57e}},	//   ничк, _टेक्, cían_, наче,
   {{0x442687ca,0x6566029b,0x7d1d3270,0xdb1e01ec}},	//   _svo_, _kakh, _yess, ropä,
   {{0x2abb0039,0x2d9fb271,0x4426929b,0x25a0008e}},	//   _המלא, ghue_, _pvo_, nhil_,
   {{0x3a3a04b7,0x212209c4,0xdb08a509,0xf0448fd3}},	//   lupp_, dakh_, sidí, _تعزی,
   {{0xe44f8013,0x6566005d,0x6f1e011f,0x8afe89ab}},	//   اضي_, _lakh, _nepc, _baƙa,
   {{0x395904b7,0x25a00d8b,0x61e40c41,0xfbab8035}},	//   tess_, khil_, _bhil, टोधम,
   {{0x61e43272,0x65663273,0x4426808b,0x867b81c6}},	//   _chil, _nakh, _tvo_, _לרבו,
   {{0x7d1d3274,0xa91da7b1,0x4426b275,0x39593276}},	//   _ress, _božj, _uvo_, ress_,
   {{0x6d9c8013,0x7d1d3277,0x39593278,0x656601b4}},	//   _féac, _sess, sess_, _aakh,
   {{0x7d1d00a9,0x6566005d,0xd3e582e3,0x29dc8511}},	//   _pess, _bakh, _تقوی, vían_,
   {{0x61e43279,0xbcfb03a8,0xdb08823e,0x98b901a9}},	//   _ghil, _gaél, lidà, nesī_,
   {{0x6ecd0f12,0x6c54096f,0x29dc8511,0x69cf016b}},	// [1f70] _दुरु, нкту, tían_, moce,
   {{0x7d1d0123,0x69c08115,0x8afe89ab,0x889c01c6}},	//   _wess, _ajme, _yaƙa, _לבחי,
   {{0x29dc840e,0x7d1d327a,0xecf905e9,0xbb8400f7}},	//   rían_, _tess, _менш_, علمي,
   {{0x6f1e327b,0x25a000f3,0x69cf2c04,0xc2c40174}},	//   _zepc, chil_, noce, ريني,
   {{0xa3ccb27c,0x1b2280ab,0x6d4d008e,0x237800fe}},	//   लवा_, _মানে_, mfaa, _fnrj_,
   {{0x2d8b05f5,0x6566005d,0x6d4d327d,0xceba80fc}},	//   _hoce_, _zakh, lfaa, waƙa_,
   {{0x6566029b,0xb8f49664,0x6b83007b,0x443b327e}},	//   _yakh, _सु_, öngu, luq_,
   {{0x6d4d0763,0x6d9c80e7,0x799b80dd,0x2d8b327f}},	//   nfaa, _réac, _uluw, _joce_,
   {{0xcc8980d7,0x8afe8326,0x3f818338,0xafdb0646}},	//   زنده_, _saƙa, öhus_, rtøj,
   {{0x61e43280,0x2d8b002a,0x69d981ec,0x7d038061}},	//   _shil, _loce_, llwe, _bíró,
   {{0x52db3281,0x61e43282,0x7e7e816d,0xed598259}},	//   _भरोस, _phil, äppt, pež_,
   {{0x6723b283,0x2d8b3284,0x69cf3285,0xdb08841c}},	//   lanj, _noce_, goce, tidã,
   {{0x65663286,0xa3bf2743,0x81c200ab,0x8afe89ab}},	//   _rakh, ुका_, ্গল_, _waƙa,
   {{0x82358bca,0x6723b287,0xe299b288,0x61e40051}},	//   _قربا, nanj, _мал_, _whil,
   {{0x61e43289,0x2d8b012b,0x6d4d328a,0x25a00642}},	//   _thil, _boce_, ffaa, thil_,
   {{0x6723b28b,0x291f822c,0x6569b28c,0x68fbb28d}},	//   hanj, _neua_, ndeh, _ngud,
   {{0x6449b28e,0x6723b28f,0x2d8b3290,0xbfc62349}},	// [1f80] ntei, kanj, _doce_, _обик,
   {{0x61b899e8,0x65663291,0xd9b886ce,0x212d80b9}},	//   ेक्ष, _wakh, ेक्ट, _adeh_,
   {{0x23678353,0x64499bda,0x35a60071,0x65663292}},	//   _manj_, htei, _жанг, _takh,
   {{0xe0dab293,0x2d8b3036,0x3a3a3294,0x6449b295}},	//   ове_, _goce_, rupp_, ktei,
   {{0x26039220,0xdcb90364,0x4fc69597,0xc7c697c8}},	//   _año_, _ещё_, мска, мски,
   {{0x09bb0519,0x31bb223a,0x6d42802e,0x65698fb0}},	//   _उद्य, _उद्ध, _scoa, edeh,
   {{0x9f4c8118,0x6e3c0144,0xc34e80ff,0x45d49860}},	//   _cidá_, nurb, _bổng_, нокс,
   {{0x717683f8,0xc34e801c,0x644980e3,0x68fb85ee}},	//   _تهرا, _cổng_, ftei, _ggud,
   {{0xe043b296,0x29e88085,0x69cf3297,0x3944841c}},	//   _инти, _uşaq_, voce, _icms_,
   {{0x6723803a,0x96968098,0x547b03de,0x75243298}},	//   canj, _ореш, קטיו, haiz,
   {{0x69cf3299,0xa3e606b7,0xd3370039,0xa2948d8e}},	//   toce, _पठन_, וריה_, хані,
   {{0x3872119b,0x7c3bb29a,0x7524026c,0x443b011c}},	//   _bryr_, buur, jaiz, yuq_,
   {{0x14e2a539,0x3f8cabf7,0x2d8b001b,0xdb1c07d3}},	//   _परिण, _kodu_, _roce_, _skrý,
   {{0xeaaf8416,0x61ee01ac,0xac978077,0xd90f015b}},	//   اعی_, _ďale, _تنها_, دیک_,
   {{0x2bbf14d5,0x3f8cb29b,0xdce28754,0x9f458118}},	//   ्वसा, _modu_, _maoč, _pilú_,
   {{0x23678838,0xa2ad800d,0x7bdab29c,0x693601d0}},	//   _zanj_, ुपर्, lltu, _přež,
   {{0x2d8b163e,0xf1bf026f,0x33750a42,0x6723b29d}},	// [1f90] _voce_, mná_, нгар, yanj,
   {{0xdce285f5,0xf1bf027f,0xa3e48054,0x291f8722}},	//   _naoč, lná_, _भीम_, _seua_,
   {{0x6e3c2cb1,0xaad486a7,0xe3c300ab,0x2d8b0037}},	//   curb, _ठुमक, ্গলব, _toce_,
   {{0x59f9893f,0xf1bf2527,0xa91d96f2,0x6723a994}},	//   פּעד, nná_, _koži, wanj,
   {{0x67238025,0x443b0085,0x3f8c816b,0x64499500}},	//   tanj, quq_, _bodu_, xtei,
   {{0xf77180f7,0xa3dd809a,0x66e58071,0x28b201a2}},	//   طات_, _थीं_, нола, ीपति,
   {{0x6723b29e,0x92c280ab,0xe91980e8,0xa91d9249}},	//   ranj, ্ধু_, _нові_, _loži,
   {{0x6449b29f,0xf1bf05b9,0x6d40b2a0,0x212d82f7}},	//   ttei, jná_, ggma, _udeh_,
   {{0x44290788,0xf1bf0775,0x236799b7,0xa91d8450}},	//   nsa_, dná_, _panj_, _noži,
   {{0x442932a1,0x6449b2a2,0x2d8280f2,0x7c3b8079}},	//   isa_, rtei, öker_, ruur,
   {{0xd9460d0e,0xc34e8028,0xfbd20039,0x44291813}},	//   нени, _tổng_, רתי_, hsa_,
   {{0x3f878024,0xaca381bc,0x569486c8,0x644992af}},	//   ljnu_, _ajụk, _шахт, ptei,
   {{0xaacf885d,0x44291554,0xb9081404,0x25bf802e}},	//   _सुरक, jsa_, _भर_, mnul_,
   {{0x660195dd,0xe8df8135,0x7d09b2a3,0x442932a4}},	//   _kulk, _arịa_, lces, dsa_,
   {{0x44292d08,0x66018364,0x7c29b2a5,0xf1bf026f}},	//   esa_, _julk, lser, bná_,
   {{0x660180a4,0xf1bf016b,0xe7e002f1,0x6d9c9e37}},	//   _mulk, cná_, _खीरा_, _léan,
   {{0x7c29b2a6,0x442932a7,0x64a31597,0xdca31b78}},	// [1fa0] nser, gsa_, гата, гати,
   {{0xa3c1800f,0x6721843d,0xf40180c8,0x68e432a8}},	//   ्कि_, _nelj, _এবার_, _izid,
   {{0x442932a9,0x1b1f00ab,0xdb1c0035,0x7d098035}},	//   asa_, _পাশে_, _skró, kces,
   {{0x7d0980d2,0x442932aa,0xf1a99ef7,0x3f8cb2ab}},	//   jces, bsa_, وانه_, _sodu_,
   {{0x1b1f00c8,0x442932ac,0xe814016f,0x6721b114}},	//   _পারে_, csa_, तीचा_, _belj,
   {{0x6d9c80f7,0x7c29b2ad,0x67218353,0x7dde80f1}},	//   _céan, dser, _celj, tëso,
   {{0x6d9c8307,0xa3b501d2,0xa3bf0a61,0x6721b2ae}},	//   _déan, _जगत_, ुकर_, _delj,
   {{0xa2ca8a75,0x7dde80f1,0x7bc3b2af,0x66018084}},	//   _सुग्, rëso, _ajnu, _dulk,
   {{0x6d460358,0x7c29b2b0,0xf1bf0a21,0xb7da8591}},	//   _mcka, gser, vná_, _فورا_,
   {{0xc45380f7,0x6d9c8b6a,0x1fb58195,0x69d60c8b}},	//   اضيع, _géan, _исхр, _akye,
   {{0xf1bf003e,0x7c2985ee,0x7dde8168,0x533700be}},	//   tná_, aser, qëso, ענטן_,
   {{0x442932b1,0x672180d2,0xa91db2b2,0x7d09a3e1}},	//   ysa_, _zelj, _poži, cces,
   {{0x55778158,0xf1bf003e,0xa3d0199e,0x6601b2b3}},	//   _רעדן_, rná_, शवा_, _zulk,
   {{0xe47b812a,0xf1bf026f,0x4429006a,0x5c978a8e}},	//   _מרדכ, sná_, vsa_, _якія_,
   {{0xf1bf026f,0x67e00106,0x68e401f6,0x6be381a8}},	//   pná_, möjl, _ezid, _حكوم,
   {{0x442932b4,0x13d580ab,0xa3e48beb,0xa91d82d4}},	//   tsa_, _হওয়, _भीत_, _toži,
   {{0x24580009,0x41c40c3b,0x442b32b5,0x98b90084}},	// [1fb0] нать_, _حقيق, _qvc_, mesį_,
   {{0x69dd0014,0x23a4016d,0x236a0144,0xf11980c2}},	//   llse, _nöjd_, _cabj_, दर्द_,
   {{0x442932b6,0xa2d40ebf,0x3a3e82f7,0x290b0037}},	//   ssa_, _बुद्, nutp_, occa_,
   {{0x442932b7,0xc984838b,0x5184b2b8,0x7c29b2b9}},	//   psa_, лучи, луча, yser,
   {{0x34940196,0x657d32ba,0x6601b2bb,0x442932bc}},	//   _баяр, _insh, _sulk, qsa_,
   {{0x66019e1f,0x6d5f13de,0x7c29b2bd,0xb17b0338}},	//   _pulk, leqa, vser, llåd,
   {{0x644d32be,0x6721b2bf,0xbbbf1305,0x7c29b2c0}},	//   ltai, _velj, ्वीक, wser,
   {{0x6d5f208e,0x7c29b2c1,0x672732c2,0x644d32c3}},	//   neqa, tser, hajj, otai,
   {{0x6721b2c4,0x644d32c5,0x9f5307e2,0xa3b5064d}},	//   _telj, ntai, _així_, _जगा_,
   {{0x660190c0,0x25bf8359,0x7d0981e8,0x672728d8}},	//   _tulk, snul_, sces, jajj,
   {{0x644d32c6,0x7c29b2c7,0x2d890681,0x34de0ebf}},	//   htai, sser, kjae_, _मर्द,
   {{0xe2968554,0x644d32c8,0x60dbb2c9,0x61fbb2ca}},	//   таю_, ktai, _kyum, _jiul,
   {{0x6d5f0748,0x2ca9076c,0x656d01b4,0x8c45951b}},	//   deqa, jzad_, ddah, _реле,
   {{0x656b8013,0x644d32cb,0x2d8f8a0f,0x69dd0074}},	//   _hagh, dtai, _hoge_, alse,
   {{0x443fb2cc,0x644d0084,0x6d460122,0x9f4581a8}},	//   luu_, etai, _pcka, _chlé_,
   {{0xdde9003d,0x2d8fb2cd,0xfce615a6,0x656d32ce}},	//   فرقه_, _joge_, вобо, gdah,
   {{0x60dbb2cf,0x656bafbb,0x443fb2d0,0xdb1a816a}},	// [1fc0] _nyum, _magh, nuu_, cotó,
   {{0x4e0608cc,0x656bb2d1,0x657d0c2e,0x22ba1ef5}},	//   _изоб, _lagh, _ensh, وداع_,
   {{0x23a400f2,0x644d032f,0x6a860098,0x3ea61630}},	//   _nöje_, atai, ължа, _ринг,
   {{0x443fb2d2,0x61e9b2d3,0x656bb2d4,0xc05a90ac}},	//   kuu_, _chel, _nagh, дік_,
   {{0xd0078698,0x92bd80c8,0xd94395ac,0x61fb8b20}},	//   вече_, _আরো_, речи, _diul,
   {{0xdefa81a0,0x6d4432d5,0x244b806a,0x443f8079}},	//   мый_, lgia, døm_, duu_,
   {{0x764e32d6,0x64598176,0x61fb8162,0xacbb0866}},	//   ntby, _apwi, _fiul, _jeûn,
   {{0x6d4432d7,0x61fbb2d8,0x2d8fb2d9,0x61e9b2da}},	//   ngia, _giul, _coge_, _ghel,
   {{0x80e101fe,0x656bb2db,0x443fb2dc,0x9f4c8198}},	//   _नरें, _dagh, guu_, _pidä_,
   {{0x6d442322,0xb4e28127,0x5fb68074,0xa91d8115}},	//   hgia, _धरी_, _अगिल, _dožu,
   {{0x75228267,0x46d232dd,0x656bb2de,0x19950a4c}},	//   _teoz, _दुलह, _fagh, ганя,
   {{0x2004a479,0x80d100ab,0x61e980f1,0x656b8870}},	//   _kumi_, _সৃষ্, _xhel, _gagh,
   {{0x8c4380e9,0x1d079634,0x656d32df,0xb17b0106}},	//   _вече, _речи_, vdah, vlåd,
   {{0xa2cb016f,0x656bb2e0,0x6440b2e1,0x2004b2e2}},	//   _तुझ्, _zagh, mumi, _mumi_,
   {{0x6440b2e3,0xa3c18128,0x6d9c80f7,0x2004b2e4}},	//   lumi, ्कर_, _léam, _lumi_,
   {{0x6d440698,0xa2b804c5,0x644d0364,0xa3b50740}},	//   ggia, ्पन्, ttai, _जगह_,
   {{0x6d9c94e1,0x6440b2e5,0x656d0359,0x644d051e}},	// [1fd0] _réal, numi, rdah, utai,
   {{0x644d32e6,0x6d5f05e7,0x61fbb2e7,0xbbbf000c}},	//   rtai, seqa, _siul, ्वेक,
   {{0x6440822e,0x61e9b2e8,0x644d32e9,0x60db80ee}},	//   humi, _phel, stai, _syum,
   {{0x656d02ed,0x6440b2ea,0x2004859c,0x99d180ab}},	//   qdah, kumi, _bumi_, িষ্ক,
   {{0x443f82c1,0x64408029,0x7c841baa,0x656bb2eb}},	//   xuu_, jumi, _куре, _ragh,
   {{0x6440b2ec,0xb60583cb,0x7d0d32ed,0x2004b2ee}},	//   dumi, hláš, lcas, _dumi_,
   {{0x656b97ef,0x99678d69,0x61e9b2ef,0x28da10be}},	//   _pagh, _итал, _thel, _युनि,
   {{0x4efc0051,0x443fad48,0x3949022c,0xa91d812b}},	//   ולוג, tuu_, _ncas_, _požu,
   {{0x6440b2f0,0xa3d8016f,0xa3c18aed,0x60db8bdf}},	//   gumi, ातच_, ्कल_, _uyum,
   {{0x443f927b,0x244b8aa2,0xceeb92c8,0x7d0d0362}},	//   ruu_, røm_, _قران_, hcas,
   {{0xe299b2f1,0x3869318b,0x656bb2f2,0x2d8f933b}},	//   хан_, _asar_, _tagh, _toge_,
   {{0x98b20201,0xe5708c2a,0x6440b2f3,0x443fb2f4}},	//   _sayı_, _وطن_, bumi, puu_,
   {{0x7d1bb2f5,0xad9b1d3a,0x6440925c,0x7c2d0338}},	//   mbus, _miúd, cumi, jsar,
   {{0x442db2f6,0x7c2d0bbd,0x6a7781bc,0x39490580}},	//   mse_, dsar, _ụfo, _ecas_,
   {{0x442db2f7,0xed5a1928,0xd5ac8065,0x386902c4}},	//   lse_, нов_, _رہی_, _esar_,
   {{0xceb283c8,0x442db2f8,0x29000118,0x69c38061}},	//   צין_, ose_, _ugia_, énel,
   {{0x442db2f9,0x69db0158,0x707700f7,0x7c3b802a}},	// [1fe0] nse_, _אַזו, _مميز_, nrur,
   {{0x442db2fa,0x6d9c80f7,0x1c1ba8b3,0x442fb2fb}},	//   ise_, _réam, पीएल_, _mvg_,
   {{0x6440b2fc,0x442db2fd,0x77f70039,0x2004b2fe}},	//   zumi, hse_, _תמיד_, _sumi_,
   {{0x442db2ff,0x9f5a06c0,0x7d0d00e5,0xaca384be}},	//   kse_, _sipè_, ccas, _akọk,
   {{0x64e2823c,0x442db300,0x25d70039,0x69c2b301}},	//   _परेश, jse_, _תוכן_, rnoe,
   {{0x38cb91fb,0x442db302,0xb7d280ab,0x6440b303}},	//   رانی_, dse_, াষ্ট, vumi,
   {{0xfaa617f4,0x7bcb087a,0x499482e3,0x316d80b9}},	//   _саво, égue, _پیشر, _faez_,
   {{0x6440b304,0x6d9c80f7,0x62810088,0x7d1bb305}},	//   tumi, _téam, _šlog, gbus,
   {{0x5b26aafb,0xd326976a,0x442db306,0xb99380f7}},	//   льна, льни, gse_, _القب,
   {{0x6440b307,0xf366a3e0,0x3946b308,0xaca401bc}},	//   rumi, утин, lgos_, _nsọt,
   {{0x442db309,0x7c2d0029,0xafdb0aa2,0x7dde8168}},	//   ase_, zsar, ktør, hësi,
   {{0x3946b30a,0xdb01b30b,0x7dde8168,0xaca4046d}},	//   ngos_, filó, kësi, _asọt,
   {{0x7c3b802e,0x7d028135,0xc5f38039,0x442db30c}},	//   crur, _igos, _הדף_, cse_,
   {{0x6ed61d17,0x66051e71,0xb8fd32dd,0xb8dd03b7}},	//   _मुहु, _puhk, _तँ_, _आध_,
   {{0x4422330d,0x7c2d01e0,0x394900b9,0x7dde8168}},	//   _awk_, wsar, _tcas_, tësh,
   {{0x63ba83cb,0x7c2d330e,0x4422036e,0x27ec80ee}},	//   litn, tsar, _bwk_, _lhdn_,
   {{0x386903aa,0x7d0d17d6,0x69c382be,0x26de808e}},	// [1ff0] _usar_, rcas, énem, _lyto_,
   {{0x212b330f,0x3946b310,0x63ba8f20,0x798083ec}},	//   lach_, egos_, nitn, _anmw,
   {{0x7c2d0e20,0x61ed1b4f,0x8afe8300,0x316d8144}},	//   ssar, _khal, _baƙi, _paez_,
   {{0x212b3311,0x7d02b312,0x7c2d26b1,0x442db313}},	//   nach_, _ngos, psar, yse_,
   {{0x39498029,0x1869817c,0xa069b314,0x61ed125b}},	//   ļas_, тали_, тала_, _mhal,
   {{0x212b0083,0x656f3315,0x25a93316,0xe736b317}},	//   hach_, _hach, lhal_, аеш_,
   {{0x656f3318,0x212b1988,0x244f0457,0x7c2284be}},	//   _kach, kach_, lüm_, _awor,
   {{0x442db319,0x629a8d42,0x212b0035,0x2bbf0b84}},	//   tse_, dyto, jach_, ्वका,
   {{0x212b330f,0x291db31a,0x656f331b,0x442d90b6}},	//   dach_, mbwa_, _mach, use_,
   {{0x656f331c,0xe7a983bb,0x7d028870,0x61ed011e}},	//   _lach, _कतिप, _egos, _ahal,
   {{0x61ed331d,0x26e4000d,0x4acf999e,0xf98617c7}},	//   _bhal, _गरेर_, _सुखव, агно,
   {{0x656f331e,0x442db31f,0x212b3320,0x3f812f9f}},	//   _nach, pse_, gach_, _anhu_,
   {{0x7643b321,0x61ed02c1,0x15f484e3,0x25a905a1}},	//   luny, _dhal, _اسلح, dhal_,
   {{0x629ab322,0x656f3323,0xdca28fc8,0x63ba9b40}},	//   byto, _aach, _фаши, citn,
   {{0xb8fd0935,0x645d0110,0x212b3324,0x39468110}},	//   _तु_, _apsi, bach_, ygos_,
   {{0x7dde820f,0x61ed3325,0x3d20009a,0x25a901e4}},	//   tësi, _ghal, बरें_, ghal_,

   {{0x656f3326,0x7643b327,0x8c46143b,0x044600e8}},	// [2000] _dach, huny, резе, резн,
   {{0x7dde820f,0x656f0ad0,0x7643b328,0xd76402e3}},	//   rësi, _each, kuny, _اندی,
   {{0x320787e2,0x656f3329,0x34e28b04,0x764389ca}},	//   _juny_, _fach, _पर्द, juny,
   {{0x656f332a,0x25a91054,0x39468110,0xd2e603a4}},	//   _gach, chal_, ugos_, _करीब_,
   {{0x39469e00,0x7dde80f1,0x8eb3003d,0x2d820326}},	//   rgos_, qësi, _همیش, _inke_,
   {{0x656f0f66,0x81bd0029,0x394685a4,0x6d59b32b}},	//   _zach, lsēt, sgos_, _abwa,
   {{0x76438dc4,0x8afe8326,0x56948705,0x798085ee}},	//   guny, _taƙi, сайт, _tnmw,
   {{0x6d5606c0,0x645d00e5,0x25a0332c,0x63bab32d}},	//   nfya, _ypsi, nkil_, witn,
   {{0x88bd8063,0x2fd8016d,0x7763ac88,0xdb1aa5ce}},	//   _jeśl, korg_, benx, entá,
   {{0x61ed332e,0x29120010,0x386980f1,0x26de801b}},	//   _shal, _afya_, çare_, _tyto_,
   {{0x212b332f,0xc333078d,0x76439481,0x7ac69509}},	//   tach_, חות_, cuny, рспе,
   {{0x7d028025,0x7c22809a,0x29dc8511,0x96958bda}},	//   _ugos, _twor, mías_, _уруш,
   {{0x212b3330,0x29dc8511,0x6728b331,0xa49b0580}},	//   rach_, lías_, _kedj, _agòn,
   {{0x212b3311,0x656f3332,0x2d823333,0x644f809f}},	//   sach_, _sach, _anke_, àcie,
   {{0x61ed1e66,0x6728b334,0x656f0e44,0x29dc8511}},	//   _thal, _medj, _pach, nías_,
   {{0x6728807d,0x61ed004f,0x656f2795,0x8afe8326}},	//   _ledj, _uhal, _qach, _saƙw,
   {{0x2fd83335,0x656f1030,0x25a90965,0x61e28122}},	// [2010] borg_, _vach, rhal_, dlol,
   {{0x656f3336,0x672882fd,0x9f5e820f,0x25a91b66}},	//   _wach, _nedj, _ditë_, shal_,
   {{0x656f3337,0x68e98019,0x200102c4,0x20090326}},	//   _tach, _szed, _iihi_, _huai_,
   {{0x656f1a29,0x76438aef,0x29dc85e4,0x2cad808e}},	//   _uach, vuny, días_, yzed_,
   {{0xa3e680c2,0xa2d88540,0xe7398256,0x68e0831d}},	//   पता_, _नुस्, гел_, _cymd,
   {{0x785a8029,0x7643b338,0x29dc82ba,0x8a170077}},	//   dāvā, tuny, fías_, _نظرا,
   {{0xf7708bbe,0x29dc85a4,0xed598d55,0x7763802a}},	//   بان_, gías_, гой_, renx,
   {{0xa3b305e8,0x764389ca,0x752d3339,0x2fd800f3}},	//   जोर_, runy, naaz, zorg_,
   {{0xbee403bb,0x76438d6d,0x68e08114,0x8afe80fc}},	//   _गर्न_, suny, _gymd, _maƙu,
   {{0x76438886,0xed59812b,0x29dc8020,0x4a4592ea}},	//   puny, diže_, bías_, бнов,
   {{0xe1fa0396,0x29dc85e4,0x6b95333a,0xd5758110}},	//   лго_, cías_, _mozg, _гуль,
   {{0x6d5982a0,0x200900ee,0x6728826c,0x35f5abd9}},	//   _ubwa, _buai_, _zedj, _упер,
   {{0xd24e8416,0x200900ee,0x2fd8008b,0xf1b283de}},	//   ونی_, _cuai_, torg_, לסט_,
   {{0x443fb33b,0x200900b9,0x6d49b33c,0xf4128039}},	//   mru_, _duai_, lgea, _צפו_,
   {{0x78c10086,0x66e6333d,0xdb1ab33e,0x6b83b33f}},	//   _əvvə, сова, zitë, _inng,
   {{0x6d49947d,0x29008110,0x394d81c0,0xdce4012b}},	//   ngea, žiai_, _nces_, ndić,
   {{0x6d49832f,0x69d9809a,0x7984020d,0x20093340}},	// [2020] igea, dowe, _iniw, _guai_,
   {{0x25a03341,0x443fb342,0x68e08106,0x65641f5d}},	//   skil_, iru_, _rymd, seih,
   {{0x29dc84c3,0x443fb343,0x490680f7,0x67288b80}},	//   xías_, hru_, مواق, _redj,
   {{0x5d860013,0x614691b3,0x705309d7,0xd764015b}},	//   _الحل, седа, _بنیا, _انگی,
   {{0x2056b344,0x6b95026c,0xe3b10065,0x67288088}},	//   стер, _fozg, سرے_, _pedj,
   {{0x443fb345,0x29dc91b9,0x23658267,0xfbc78481}},	//   dru_, tías_, jelj_, _رت_,
   {{0x44321486,0x443fb346,0x9f520144,0xe2970088}},	//   lsy_, eru_, _huyó_, _лар_,
   {{0x29dc960a,0x443f8b67,0x98a68012,0x15fa0bb8}},	//   rías_, fru_, _либе, ्दिर_,
   {{0xdb1ab347,0x44323348,0x443fb349,0x29dc8511}},	//   lité, nsy_, gru_, sías_,
   {{0x320a334a,0x6d498706,0x29dc8333,0x7984113b}},	//   _kuby_, agea, pías_, _aniw,
   {{0xa3d90ee6,0xdd8f8162,0x15f811bc,0x200903ac}},	//   ावत_, _еш_, ंगार_, _suai_,
   {{0x443fb34b,0x394d334c,0x7dde8168,0x25a682d5}},	//   bru_, ües_, tësu, _ulol_,
   {{0x443f8012,0x2009334d,0x8afe89ab,0x6ac4066b}},	//   cru_, _quai_, _raƙu, वपुर,
   {{0x7dde80f1,0x442684be,0x443201b0,0x33f68226}},	//   rësu, _iwo_, dsy_, _учес,
   {{0x9f5e80e7,0x3da709a8,0xdced0699,0x69d9804f}},	//   _cité_, браб, rdač, yowe,
   {{0x7bda8bd2,0xd131003d,0x200900ee,0xb88601d0}},	//   lotu, _کمک_, _tuai_, _spíš,
   {{0x6eda8076,0x7dde80f1,0xdcfd026c,0xb60689d1}},	// [2030] _पुसु, qësu, _posđ, lišć,
   {{0x6ac401c4,0x68ed0b67,0x44269437,0xa3b3009a}},	//   वपूर, _izad, _mwo_, जों_,
   {{0x69d9b34e,0x3cde016f,0x7bc8b34f,0xdd950196}},	//   towe, _कुठे_, indu, _даны,
   {{0x19598084,0x4426877f,0xa159b350,0x127b80be}},	//   рады_, _owo_, раду_, טאבע,
   {{0x44268091,0xf09f3351,0x69d9b352,0x7bda9619}},	//   _nwo_, nyà_, rowe, kotu,
   {{0x8cdc800f,0x645c802e,0xbcfb3353,0x01cf00ab}},	//   _पड़ो, ăril, _abég, রতিদ,
   {{0x35f803f8,0x4426b354,0xdb1a80e7,0x7bda8d15}},	//   _خرید_, _awo_, cité, dotu,
   {{0xa2b81d40,0x44268e4d,0xd0d58098,0x394db355}},	//   ्पर्, _bwo_, _добъ, _uces_,
   {{0x6d498068,0x443fb356,0x386d8051,0x442682f7}},	//   rgea, uru_, _user_, _cwo_,
   {{0x443f8aee,0x6d49b357,0x212f8229,0xdb0e008b}},	//   rru_, sgea, lagh_, _embæ,
   {{0x6d5d0a56,0x68ed0201,0x6602b358,0x198a0098}},	//   _obsa, _azad, _fiok, абни_,
   {{0x443fb359,0x66028037,0x23659502,0xbcfb046d}},	//   pru_, _giok, selj_, _gbég,
   {{0xa3d90576,0x4426b35a,0x2365817f,0x629e009a}},	//   ावा_, _gwo_, pelj_, zypo,
   {{0x6d5d335b,0x6d4f0098,0x25bf8087,0x6b8380e8}},	//   _absa, _acca, liul_, _unng,
   {{0x9f52046d,0xa50a335c,0x68ed0c2e,0xd62a108d}},	//   _buyò_, иева_, _ezad, робе_,
   {{0x44321af4,0xdb1a82be,0x25bf802e,0x386000b4}},	//   tsy_, vité, niul_, _tpir_,
   {{0x249f9ca6,0x212f8706,0x290501d0,0x752bb35d}},	// [2040] nyum_, dagh_, ělat_, _megz,
   {{0x4432335e,0x212280bc,0x25bf8162,0x61e60fb6}},	//   rsy_, मर्श_, hiul_, llkl,
   {{0xed5a00a9,0x3dc902d5,0x7a08928a,0x826601a8}},	//   _кон_, bnaw_, _pěti, تهان,
   {{0x00e6a606,0xe9da8604,0xdb1ab35f,0xd3788503}},	//   ожен, шке_, rité, moće_,
   {{0x25bf802e,0x7bda804f,0x7bc8808b,0x25ad9ab3}},	//   diul_, yotu, yndu, dhel_,
   {{0x442682a0,0x2d99b360,0xc7a39a19,0x8fa39ad8}},	//   _rwo_, ösen_, мичк, маче,
   {{0x59ca09c2,0x2454039c,0xf8bf0866,0xd37880fe}},	//   ाचार, läm_, mbée_, noće_,
   {{0x2cbf00fe,0x25adb361,0x2d9202a0,0xdc1e80ab}},	//   _žudi_, ghel_, njye_, _দিবস_,
   {{0xc5f3078d,0x938a9b2f,0x7bdab362,0x2717001b}},	//   ודה_, асна_, totu, nění_,
   {{0xa3e48105,0xa3ea00bc,0x442681ed,0x68ed0035}},	//   _भीख_, मति_, _vwo_, _rzad,
   {{0x7ae3831d,0x86c680f7,0xf1bf01df,0xddc8826c}},	//   _cynt, _بيان, tiá_, _irdž,
   {{0xb606b363,0x44268051,0x25bf802e,0x29008110}},	//   rišć, _two_, ciul_, žiau_,
   {{0x44268578,0x7bdaae5e,0x25d9803d,0xcf00011c}},	//   _uwo_, potu, _اهنگ_, əşən_,
   {{0x4374803d,0x271701d0,0x68ed016b,0xc6a71d7b}},	//   _رهبر, dění_, _vzad, орби,
   {{0x3ea50019,0x7ae38114,0xa3d906ae,0xed59811f}},	//   ált_, _gynt, ावस_, liža_,
   {{0x321e89c4,0xdb1703a8,0x51870b26,0x7647018e}},	//   mpty_, rixí, _фука, rujy,
   {{0x5fbc801b,0x030e8816,0x68ed3364,0x6d9c81a8}},	// [2050] ्चाल, _सलाह_, _uzad, _héas,
   {{0x69dd3365,0x09d38bbc,0xd37101a8,0x7a35819d}},	//   lose, तव्य, عها_, _ẹtit,
   {{0xe8d90870,0xdb01956e,0x211881bc,0xc3240264}},	//   _mbọ_, silö, _ịtụl, _পাখি_,
   {{0xe0d383f8,0x6b988edd,0x249f9c99,0x67ed95a0}},	//   وزش_, _lovg, yyum_, dúja,
   {{0x29090122,0x95160039,0xdb1e0580,0x6d4d14ba}},	//   _mgaa_, _מקרא_, kipè, mgaa,
   {{0x81c30a49,0x2d9900b4,0x6cfa0039,0x1b2280ab}},	//   ্তি_, _hose_, _לפרס, _মাঝে_,
   {{0x2d992637,0x69dd3366,0x25adb367,0x67ed8019}},	//   _kose_, kose, thel_, gúja,
   {{0x6d4d12eb,0xdceb84b7,0xe8d9046d,0x29093368}},	//   ngaa, _jogħ, _abọ_, _ngaa_,
   {{0x65a30006,0x81c300c8,0x25bf802e,0xdceb9693}},	//   _põhj, ্তা_, riul_, _bagā,
   {{0x5ba98319,0x290901bc,0xdceb84b7,0x26d30216}},	//   ском_, _agaa_, _logħ, _oxxo_,
   {{0x69cbb369,0x249fb36a,0x25bf8087,0x95cba857}},	//   onge, syum_, piul_, _куда_,
   {{0x2005822e,0x2ca0336b,0x69dd0168,0x186a2306}},	//   _hili_, yyid_, gose, бами_,
   {{0x69cbb36c,0xda0b8035,0x6d5b8c53,0x6d4d336d}},	//   inge, _सूरत_, mfua, dgaa,
   {{0xd9b8800c,0xa4fa81c6,0xaabd09c1,0x2d99010c}},	//   _अष्ट, _פלסט, ्पाक, _aose_,
   {{0x2d9902a0,0x2005b36e,0x59db86bf,0x76438359}},	//   _bose_, _mili_, यकार, nrny,
   {{0xf992003f,0x2005b36f,0x6d4d3370,0x2d990098}},	//   _سبب_, _lili_, ggaa, _cose_,
   {{0xdb1e020f,0x02c4016f,0x6ac4036d,0x7643808e}},	// [2060] qipë, वप्न, वप्र, hrny,
   {{0x6d4d1cbc,0x6569b371,0x395f89cd,0xa3cb8072}},	//   agaa, heeh, _abus_, रचि_,
   {{0x2d993372,0x479b0158,0x98b0805c,0x179b00be}},	//   _fose_, _הייס, đači_, _הייב,
   {{0x7bc1b373,0x6d9c80f7,0xddc88754,0x80da80ab}},	//   hilu, _léar, _srdž, _বৃষ্,
   {{0xd12f8d4a,0xa3bd835a,0x75243374,0x7bc1b375}},	//   امه_, ीचा_, mbiz, kilu,
   {{0x26118104,0x2005b376,0xdb1e09c4,0x6449809f}},	//   _báo_, _cili_, kipé, duei,
   {{0xa3d91cd4,0x2005b2db,0x26118028,0x44203377}},	//   ावर_, _dili_, _cáo_, lpi_,
   {{0x7bde23be,0xdcebb378,0x66061bcd,0x77ab0085}},	//   lopu, _xogħ, _jikk, _müxa,
   {{0x6449abe1,0x2005b379,0x6d9c81a8,0x4420337a}},	//   guei, _fili_, _béar, npi_,
   {{0x0b8a8364,0x3160008e,0x6d9c81a8,0x6606337b}},	//   ссии_, _abiz_, _céar, _likk,
   {{0xe4d699f4,0x46db0105,0x6d9c81a8,0x644401b4}},	//   _کتاب, _मुंह, _déar, hrii,
   {{0xdb1ab37c,0x7bde0133,0x6d9c8388,0xfbc400ab}},	//   mití, hopu, _véas, ্তিত,
   {{0x644983d3,0x7bc1b37d,0xdb1ab37e,0x7bde0198}},	//   cuei, bilu, lití, kopu,
   {{0x2259809a,0xe8d9019d,0x200581b4,0x6d9c8174}},	//   ńska_, _nnụ_, _xili_, _géar,
   {{0x6d4d26a1,0x6a1380f7,0xe3c400ab,0xdb1e00f7}},	//   tgaa, _كبير, ্তাব, cipé,
   {{0x66060065,0xe8d90870,0x91e40eef,0x1c11864a}},	//   _cikk, _anụ_, _поје, _डूडल_,
   {{0x6606337f,0xa3d90006,0x539921f6,0x442000e4}},	// [2070] _dikk, ावल_, овая_, gpi_,
   {{0x25ef05b3,0x3374002e,0x2a6302f7,0x7bde008e}},	//   _आठवी_, нгур, _ppjb_, gopu,
   {{0x35f5018b,0xdb0181ec,0x44203380,0xa3b30a43}},	//   _опор, chlä, api_, जोग_,
   {{0x69cb8081,0x644410b5,0xdb1e0198,0x7bc1b381}},	//   unge, brii, enpä, zilu,
   {{0x2005822e,0x200d8081,0x3ce681c0,0x7777022b}},	//   _pili_, _quei_, _nyov_, _kaxx,
   {{0x69dab382,0xdb23003d,0x66e5b383,0xdee5951b}},	//   _íten, _سوری, мола, моли,
   {{0x7bc184b7,0xe7308fc5,0x44393384,0x6d5b80b9}},	//   vilu, اصه_, _hvs_, tfua,
   {{0x69c288f1,0x2005b385,0x395f833e,0x6449b386}},	//   cioe, _wili_, _ubus_, tuei,
   {{0x7bc1b1c4,0x387f81b4,0x752f0035,0x290080e1}},	//   tilu, _urur_, _mecz, žiar_,
   {{0x752f009a,0x261180ff,0x799b8bfd,0xad9b0174}},	//   _lecz, _táo_, _houw, _siúl,
   {{0xd94623e0,0x7bc18a6e,0x61460d45,0x44200102}},	//   мени, rilu, мена, zpi_,
   {{0x5ec100ab,0x799bb387,0x7bc1b388,0x44203389}},	//   _শুভে, _jouw, silu, ypi_,
   {{0x6606338a,0x7bc1802e,0x6d9c80f7,0x64499a7d}},	//   _rikk, pilu, _téar, quei,
   {{0x660606be,0x69c28102,0x777700e5,0x799bb38b}},	//   _sikk, zioe, _caxx, _louw,
   {{0x66e3338c,0x6606037b,0x7a08800d,0x1db183eb}},	//   вора, _pikk, _děts, _जतात,
   {{0x69bf89a3,0x3dcd822b,0x644414c7,0xdb1c338d}},	//   लोमी, nnew_, trii, _imré,
   {{0x7bde0b67,0x5f76045b,0xdb1a8524,0xa3d9016f}},	// [2080] topu, _قادر, zití, ावं_,
   {{0x4439338e,0x64441eaf,0x660625d0,0xf77201f9}},	//   _dvs_, rrii, _wikk, _شاخ_,
   {{0x81c300c8,0x6606338f,0x7c360338,0x799b8a0f}},	//   ্তর_, _tikk, ssyr, _bouw,
   {{0x64a60071,0x64443390,0x2904026c,0x6d9c810c}},	//   _жама, prii, žmau_, _néap,
   {{0x69c2811b,0x799b9c11,0x2a6d01a1,0xdb1a82df}},	//   rioe, _douw, _ćebe_, nitã,
   {{0x43753391,0x7a0c0087,0xd378abea,0x7989b392}},	//   _пуст, _aşte, koća_, _enew,
   {{0x7c2b8114,0xa3db06af,0x799b8176,0x6b9c304c}},	//   _awgr, डकर_, _fouw, _iorg,
   {{0x5c749508,0x65a30006,0x6b9c3393,0x61e43394}},	//   елит, _põhi, _horg, _nkil,
   {{0x69c0b395,0x6b9c1388,0xbeeb064a,0x21268d8b}},	//   _imme, _korg, _टर्न_, mboh_,
   {{0x61e40010,0xf3668d9e,0x7d0b8558,0x7ac6818b}},	//   _akil, фтин, _eggs, дсме,
   {{0xa3b60e18,0x3ddf8a0f,0xbcfb01a8,0x6b9c3396}},	//   _जतन_, bouw_, _mbéa, _morg,
   {{0x6b9c0c41,0x9e658065,0x61f610ae,0x237802d6}},	//   _lorg, _سامن, _chyl, _larj_,
   {{0x6b9c01b0,0x0cc900ab,0x6562818e,0x00000000}},	//   _oorg, _শর্ত, _iboh, --,
   {{0xead49ea4,0x6b9c0cde,0x2cb0861c,0x61e43397}},	//   _поль, _norg, ıldı_, _ekil,
   {{0xbd0580e7,0x69c08a6f,0xf8ae004e,0xdd9b1617}},	//   _théâ, _omme, لکی_, оша_,
   {{0xfaa7803d,0xdb1a92d0,0xc5f881a9,0x96f80993}},	//   _تجهی, lità, _spēj_, фест_,
   {{0x3cfc011b,0x6b9c3398,0xdce980d2,0x94ab06b5}},	// [2090] рvv_, _borg, rdeć, цтва_,
   {{0x799b82d6,0x69c0b399,0x44390370,0xdb1ab39a}},	//   _souw, _amme, _vvs_, nità,
   {{0x6562816b,0xafdb004a,0x69cf0037,0xfd100061}},	//   _oboh, nrøm, once, اجہ_,
   {{0x77b000f2,0x442b041c,0x673507d8,0x3495164f}},	//   _växe, _twc_, lazj, _замр,
   {{0x6b9c1c93,0x2d8b02d0,0x7e620b80,0x799b890d}},	//   _forg, _ince_, _ćopi, _vouw,
   {{0x69c0b39b,0xdce407d9,0x644d000e,0x67352358}},	//   _emme, ldiğ, muai, nazj,
   {{0x644d32be,0x4ae401e2,0x4ad903b7,0x16a9af92}},	//   luai, _аўта, _बँटव, явки_,
   {{0x6b9c339c,0xc8c0835a,0x7bc5339d,0xdce40214}},	//   _zorg, _शेवट, lihu, ndiğ,
   {{0x4439b39e,0x644d339f,0x3ddf81ed,0x290d80e5}},	//   és_, nuai, rouw_, _igea_,
   {{0x61e42b0d,0x3dcd89c4,0x69cf24cc,0x7bc533a0}},	//   _skil, snew_, ence, nihu,
   {{0x25a90065,0xfaa58470,0x2d8b1b7d,0x644d01a8}},	//   kkal_, хано, _once_, huai,
   {{0x9f47816b,0x22598035,0x6dc792c8,0x7d0b80c3}},	//   dlné_, ńsko_, _غزال, _uggs,
   {{0x320902d5,0xa5c6807b,0x6abd1107,0x7bc533a1}},	//   _diay_, sjóð, ्पुर, kihu,
   {{0x2d8b33a2,0x644d33a3,0xdb1a8980,0x2d9db3a4}},	//   _ance_, duai, cità, _howe_,
   {{0x645bb3a5,0x24598385,0x2d9da0d2,0x7a0901d0}},	//   ltui, lèm_, _kowe_, _větr,
   {{0x65aa003e,0x657b9849,0x3209001c,0x06072dd0}},	//   _výho, nduh, _giay_, енск_,
   {{0xd46715fd,0x04430e6b,0xb4db026b,0x68e980d7}},	// [20a0] ните_, летн, _adàb, _nyed,
   {{0x69c633a6,0x2d8b03a8,0x213f885c,0x6abd0b04}},	//   like, _ence_, _aduh_, ्पूर,
   {{0x6b9c02af,0xdb1ab3a7,0x814680f7,0x68e9ac9a}},	//   _vorg, nitá, فنان, _ayed,
   {{0x69c633a8,0x2d9d809a,0x68e985ee,0x645b9407}},	//   nike, _nowe_, _byed, ktui,
   {{0x644d0748,0x764e0c8b,0x6b9c33a9,0x201209ab}},	//   cuai, luby, _torg, _juyi_,
   {{0x290d802a,0x69c633aa,0x201209ab,0x6283b3ab}},	//   _egea_, hike, _muyi_, _orno,
   {{0x201fb3ac,0xfa670d8f,0xda0b8327,0x56949383}},	//   _etui_, _парк_, _संगत_, тайт,
   {{0xd5b7abca,0xf3908028,0xc693036b,0x69c0b3ad}},	//   есь_, _cảnh_, ראה_, _umme,
   {{0x6283b3ae,0x7c2433af,0x2d9db3b0,0x61e2a6e8}},	//   _arno, npir, _dowe_, mool,
   {{0x61e2b3b1,0x765c009a,0xafdb03ba,0x39402179}},	//   lool, ktry, trøm, _adis_,
   {{0x6283803b,0x69c633b2,0xf8bf8125,0xdb1ab3b3}},	//   _crno, fike, _þér_, gitá,
   {{0x248000ce,0x765c01a3,0x69c61c88,0x201233b4}},	//   kvim_, dtry, gike, _buyi_,
   {{0x3f9e84b9,0xfbcf82e3,0x644d0ba3,0xdce402d0}},	//   _kotu_, شتی_, xuai, vdiğ,
   {{0x8c1b893f,0x394033b5,0x229480f7,0x7c24007a}},	//   _צווי, _edis_, _للتس, dpir,
   {{0x61e2b3b6,0x69c633b7,0x61eb951e,0xfe700065}},	//   kool, bike, ylgl, یدہ_,
   {{0x644d33b8,0x3f9eb3b9,0xf0a680ff,0xdced01a1}},	//   tuai, _lotu_, _đành_, ndać,
   {{0x3cfc2e2b,0xdce407d9,0x798d33ba,0x32111142}},	// [20b0] लेले_, rdiğ, _inaw, _suzy_,
   {{0x25a933bb,0x657b9408,0x644d032f,0x386933bc}},	//   skal_, zduh, ruai, _ipar_,
   {{0x644d25e0,0x325511d2,0xc3338039,0xdcef0162}},	//   suai, твер, רוע_, _bacă,
   {{0x7aea83ed,0x27e333bd,0x247202d6,0x7bc533be}},	//   _myft, lojn_, _fņm_, sihu,
   {{0x7aea8408,0x777aabfa,0x6579b3bf,0xf3908129}},	//   _lyft, _batx, _rawh, _rảnh_,
   {{0xf7718250,0x69c633c0,0x10a282ee,0xdb1a85be}},	//   شات_, zike, ришн, litæ,
   {{0x69c633c1,0x0675b3c2,0x61e2b3c3,0xd91581e2}},	//   yike, туля, bool, _адбы,
   {{0xd6ce8013,0xfc3f826f,0x61e2b3c4,0x68fb0084}},	//   تقى_, ším_, cool, žudy,
   {{0x69c633c5,0x2a6780ee,0x777ab3c6,0x657bb3c7}},	//   vike, _spnb_, _fatx, rduh,
   {{0x09ca053e,0x645b8b3c,0x798d33c8,0x5ed700ab}},	//   ाच्य, rtui, _anaw, _ধরনে,
   {{0x69c6288e,0x6579b3c9,0x645bb3ca,0x2fc7b3cb}},	//   tike, _tawh, stui, ming_,
   {{0xaca3819d,0x62838267,0xf8bf002a,0x765c33cc}},	//   _amụk, _vrno, rbén_, vtry,
   {{0x7529b3cd,0x98a48084,0x7c24010c,0x69c633ce}},	//   mbez, _temą_, xpir, rike,
   {{0x69c633cf,0x7c3b80dd,0x6449b3d0,0x644680fe}},	//   sike, msur, mrei, škic,
   {{0x66e62344,0x2c1980c8,0xdee6210d,0xd007023a}},	//   това, _দিয়ে_, тови, тере_,
   {{0x2fc7b3d1,0x7d1b8289,0x661c8019,0xceb284de}},	//   hing_, ncus, _érke, ביל_,
   {{0x2fc7860c,0xff26087e,0xe8fa0698,0x973c8a20}},	// [20c0] king_, _импо, _юли_, _hoće,
   {{0x2fc7b3d2,0x6449b3d3,0x7c3bb3d4,0xd00f004e}},	//   jing_, irei, isur, _گلی_,
   {{0x2fc7b3d5,0x24800025,0x6449b3d6,0x61e2b3d7}},	//   ding_, svim_, hrei, tool,
   {{0x6449b3d8,0x3ea7831d,0x442f80b9,0x6cc6053b}},	//   krei, dynt_, _owg_, _айма,
   {{0xb82280c8,0x61e290b5,0x442f8282,0x2056b3d9}},	//   _নিহত_, rool, _nwg_, ттер,
   {{0x6449b3da,0xb17b016d,0x2fc7b3db,0x61e2b3dc}},	//   drei, llåt, ging_, sool,
   {{0x973cb3dd,0x163780f7,0x61e2b3de,0x660bb3df}},	//   _noće, نسية_, pool, _bigk,
   {{0x6449b3e0,0xd01a00c8,0x557481f3,0x442f80b9}},	//   frei, তীয়_, угит, _bwg_,
   {{0x2fc797ef,0x6449a2a5,0xe817000f,0x7aea816d}},	//   bing_, grei, _धंधा_, _syft,
   {{0x442f8358,0x2fc7b3e1,0x69c42e3a,0x6e3e01a1}},	//   _dwg_, cing_, _amie, _ovpb,
   {{0x38691610,0x19590a14,0xf1f60035,0x23a40338}},	//   _spar_, наны_, ीगढ़_, _höjs_,
   {{0x6449b3e2,0xf1a71980,0x973c8267,0x200c804f}},	//   brei, трон, _doće, _hidi_,
   {{0xe1ff05a4,0xc05810ac,0x6e22192c,0xa3e203db}},	//   rmó_, кір_, _čoba, दवा_,
   {{0x9f5307e2,0x2618801c,0x38698168,0x7c22b3e3}},	//   _això_, _kéo_, çari_, _itor,
   {{0xf8bf0003,0x4ea433e4,0xc6a41317,0x200cb3e5}},	//   mbém_, арта, арти, _midi_,
   {{0x7c22b3e6,0x798d33e7,0x200c81d0,0x2fc78e9e}},	//   _ktor, _unaw, _lidi_, zing_,
   {{0x2fc78051,0x6abd01a2,0x69c380e7,0x9f430168}},	// [20d0] ying_, ्प्र, ènem, nojë_,
   {{0x69c4219c,0x68ed02c1,0x8aa7023a,0x02a700e8}},	//   _zmie, _iyad, кред, крем,
   {{0x9f5e8364,0x2fc7b3e8,0x26188866,0x75d50c3b}},	//   _mitä_, ving_, _néo_, _ميدا,
   {{0xc6920159,0x7bc88867,0x7c22b3e9,0xdd9513cd}},	//   _האט_, hidu, _otor, _самы,
   {{0x2fc7b3ea,0x200c9a73,0x7bc8b3eb,0x248681c0}},	//   ting_, _bidi_, kidu, _nrom_,
   {{0x657d33ec,0xfc3f803e,0x261880ff,0x442f822c}},	//   _hash, šík_, _béo_, _rwg_,
   {{0x657d33ed,0x7c22b3ee,0xcf94098a,0x7bc8a060}},	//   _kash, _ator, יטס_, didu,
   {{0x657d020f,0x7c3bb3ef,0x442f822c,0x24869c11}},	//   _jash, tsur, _pwg_, _brom_,
   {{0x2fc7b3f0,0x657d33f1,0x61e9b3f2,0x75299083}},	//   ping_, _mash, _ikel, rbez,
   {{0x6449b3f3,0x657d33f4,0x7c3bb3f5,0x69c433f6}},	//   rrei, _lash, rsur, _smie,
   {{0x7c22811e,0x6449aa1d,0xdb1ab3f7,0x68ed01b4}},	//   _etor, srei, entó, _ayad,
   {{0x2486804c,0x442f81e9,0x64498b2b,0x64468110}},	//   _from_, _twg_, prei, škia,
   {{0x3fc80077,0x7bc8b3f8,0x8c458b5b,0x2d8fad00}},	//   ندسی_, bidu, _селе, _inge_,
   {{0xf53980e1,0x657d01b4,0x7bc38234,0x25adb3f9}},	//   lať_, _aash, _umnu, lkel_,
   {{0x657d33fa,0x44220ac6,0x69c401b9,0x61e9b3fb}},	//   _bash, _stk_, _tmie, _okel,
   {{0x25adb3fc,0x657d33fd,0x69c41988,0xf53980e1}},	//   nkel_, _cash, _umie, nať_,
   {{0x657d33fe,0xb17b0106,0x68ed09ab,0x81cc8264}},	// [20e0] _dash, rlåt, _gyad, রকম_,
   {{0x5503176e,0xb3468073,0x9f5e0009,0x61e9b3ff}},	//   спуб, moçõ, ötä_, _akel,
   {{0x657d3400,0x25adb401,0xbea60912,0x3ea627a9}},	//   _fash, kkel_, _санк, _синг,
   {{0x61fbb402,0x657d3403,0x3ea508aa,0x2247016b}},	//   _chul, _gash, älte_, ánka_,
   {{0xe8948554,0xf539b404,0x44220867,0x261a000f}},	//   раль, dať_, _utk_, _मंडी_,
   {{0xafdb0022,0x2d8fb405,0x61e98135,0x9f430168}},	//   rsøg, _ange_, _ekel, vojë_,
   {{0x200c803a,0x657d3406,0x67388db7,0x61e6026c}},	//   _vidi_, _yash, ravj, kokl,
   {{0x9f5e8364,0x6d563407,0x7bc8809a,0xd49ab408}},	//   _sitä_, ngya, widu, еро_,
   {{0xa84a88ca,0x61e600eb,0x161602f1,0x2d803409}},	//   _سلام_, dokl, _दूसर_, idie_,
   {{0x9f4300f1,0x2912340a,0x99860084,0x2d8fb40b}},	//   rojë_, _agya_, kslų_, _enge_,
   {{0x7bc8b40c,0xdb1a8a48,0x68ed0359,0x9f430168}},	//   ridu, vitä, _syad, sojë_,
   {{0x2eb08bb8,0x2486b40d,0x2d800493,0x25adb40e}},	//   जनीत, _trom_, jdie_, ckel_,
   {{0x657d00a4,0x7bc8b40f,0x21393410,0x73c4a181}},	//   _rash, pidu, rash_, _پيغم,
   {{0x657d00a4,0x2a660035,0x14d781c6,0x29120c2e}},	//   _sash, łoby_, _גודל_, _egya_,
   {{0x657d3411,0x39448144,0xdb1ab412,0x8b6580d7}},	//   _pash, _odms_, ritä, _خانم,
   {{0x6d562acf,0x61e63413,0x657d3414,0xca4781a8}},	//   ggya, cokl, _qash, _إليه_,
   {{0x657d3415,0xdb1ab416,0xf53f3417,0xdce284e8}},	// [20f0] _vash, pitä, _slås_, _oboč,
   {{0x91fd0029,0x61fb822e,0xf53981ac,0x657d3418}},	//   stād, _shul, zať_, _wash,
   {{0x657d2b2a,0x3a7501e5,0x20d40bca,0x92590009}},	//   _tash, рлер, _نتیج, тает_,
   {{0x657d3419,0x6e250362,0x57dd8072,0x3e410048}},	//   _uash, _ithb, यव्ह, mėt_,
   {{0xf539b404,0x752d341a,0xd5b1827d,0xa3d48b99}},	//   vať_, mbaz, _lúc_, सचा_,
   {{0x44290d54,0x2259809a,0x61fb82f7,0x3f69b41b}},	//   mpa_, ński_, _whul, тико_,
   {{0xf53981ac,0x25ad8074,0xfd1180f7,0xf77403de}},	//   tať_, tkel_, يجة_, מקס_,
   {{0x1c4593b4,0x644d0090,0x4429341c,0xada58198}},	//   аним, orai, opa_, раил,
   {{0x4429028a,0x69cbb41d,0x644d061f,0xf53981ac}},	//   npa_, mige, nrai, rať_,
   {{0x69cb84e1,0xf53981ac,0x5ba9968a,0x4429341e}},	//   lige, sať_, тком_, ipa_,
   {{0x644d0a1c,0x27e7b41f,0xd6d18a47,0x25b08061}},	//   hrai, monn_, _بقا_, álló_,
   {{0x2d8f8bc5,0x69cbb420,0x44290133,0x660f3421}},	//   _unge_, nige, kpa_, _nick,
   {{0x6e2500f7,0x80c001d0,0xac278162,0x00000000}},	//   _athb, _लेखे, _сфек, --,
   {{0x644d1dad,0x7c2999ad,0xdcfb9487,0x443fb422}},	//   drai, mper, nduč, msu_,
   {{0xa91d8a56,0xe7370a94,0x09b5816f,0x63a38046}},	//   _každ, рес_, ंसाठ, _ionn,
   {{0x63a3b423,0x644d3424,0xf53f0082,0x248d3425}},	//   _honn, frai, _slår_, _šema_,
   {{0x63a3b426,0x443f8a73,0x2d8004df,0x644d3427}},	// [2100] _konn, nsu_, rdie_, grai,
   {{0x443f9572,0xdcfb8d2f,0xdb0183ba,0x63a3a1d8}},	//   isu_, jduč, rklæ, _jonn,
   {{0x69cbb428,0x673c16c4,0x973c8289,0x3dd7077f}},	//   fige, marj, _noća, úewé_,
   {{0x7c29b429,0x673c2cc7,0x63a381a8,0x88868db6}},	//   kper, larj, _lonn, илеж,
   {{0x6604043d,0x644d0cb5,0x261c002a,0x91fd00eb}},	//   mmik, crai, _hío_, ltāc,
   {{0x673c342a,0x7c29b42b,0x63a3b42c,0x6604342d}},	//   narj, dper, _nonn, lmik,
   {{0x69cbb42e,0x29568098,0x2eb080c2,0xafdb0aa2}},	//   bige, _възр, जनेत, prøv,
   {{0xd378803a,0x443fb42f,0x91e39a19,0x261c06a5}},	//   moći_, fsu_, _досе, _mío_,
   {{0x26168063,0x673c3430,0x63a3b431,0x261c0661}},	//   _पूरी_, karj, _bonn, _lío_,
   {{0x673c3432,0xeb06a10d,0x63a38213,0x798082a0}},	//   jarj, ично, _conn, _hamw,
   {{0x6d460a56,0x7980b433,0x673c3434,0x63a3b435}},	//   _odka, _kamw, darj, _donn,
   {{0x7c26003b,0x44293436,0x63a38b99,0x7982b437}},	//   _otkr, ypa_, _eonn, ndow,
   {{0x660f3438,0x63a3b439,0x84638081,0x98b20176}},	//   _rick, _fonn, _дъще, _feyč_,
   {{0x4426b43a,0x63a3b43b,0x644d03d3,0x6d460079}},	//   _ito_, _gonn, vrai, _adka,
   {{0x7c260612,0xc3fb8039,0x644083ba,0x7a138162}},	//   _atkr, _שלוש, lsmi, _bătu,
   {{0xa91d82a5,0x4426b43c,0x63a3b43d,0x644d343e}},	//   _kaže, _kto_, _zonn, trai,
   {{0x63a382ec,0x61ed17ea,0x69cbb43f,0x644d0fef}},	// [2110] _yonn, _ikal, vige, urai,
   {{0x644d3440,0x44293441,0x4426b442,0x69d880e7}},	//   rrai, rpa_, _mto_, éven,
   {{0x44293443,0x69cbb444,0x79809b19,0x386d8087}},	//   spa_, tige, _bamw, _sper_,
   {{0x4426b445,0x443fb446,0xf5950f99,0x6440b447}},	//   _oto_, ysu_, _الحج, ksmi,
   {{0x4426b448,0x702280c8,0xfd960039,0x61ed004f}},	//   _nto_, _নিউজ_, _הדרך_, _mkal,
   {{0x9f4780f1,0x6440b449,0x628ab44a,0xdb1e02f1}},	//   monë_, dsmi, _orfo, gipä,
   {{0x4426b44b,0x3f811083,0x6442b44c,0x28a7864a}},	//   _ato_, _mahu_, _avoi, _कॅरि,
   {{0x81bd0341,0x63a3b44d,0x7c2983ab,0x973c83b1}},	//   spēj, _sonn, tper, _voća,
   {{0x69c9b44e,0xb4f5313a,0x27e78247,0x63a3b44f}},	//   _imee, _आरोप_, ponn_, _ponn,
   {{0x443fb450,0x7c29b451,0xd7fb8364,0x61ed3452}},	//   rsu_, rper, _руб_, _akal,
   {{0x4426b453,0x443fb454,0x673c3455,0x63a389ff}},	//   _eto_, ssu_, varj, _vonn,
   {{0x261c02ba,0x443fb456,0x63a38c2e,0x3e619de9}},	//   _río_, psu_, _wonn, mót_,
   {{0x673c3457,0x628a8352,0x973c805c,0x3f810458}},	//   tarj, _erfo, _moćn, _bahu_,
   {{0x261c157a,0x63bab458,0x23268dcd,0xab26964f}},	//   _pío_, chtn, _лоши_, _лоша_,
   {{0x660426a6,0xdfcf00f7,0x673c054b,0x65b5816b}},	//   tmik, ريف_, rarj, _záha,
   {{0x973c803b,0x673c3459,0xd01f80ab,0xdb019b48}},	//   _noćn, sarj, নীয়_, rklä,
   {{0x6da3345a,0x6604345b,0x3f810115,0x44268144}},	// [2120] чита, rmik, _fahu_, _xto_,
   {{0xa3ca8aec,0x261c2848,0x69c9b45c,0x2a6e8144}},	//   रोप_, _tío_, _amee, _ypfb_,
   {{0xdb1a84c3,0x9f4c801c,0x8e8600f7,0x798082d6}},	//   titú, _đoàn_, _الجه, _pamw,
   {{0xe93a9ddd,0x8d560d0e,0xe9da8a26,0x6d460366}},	//   اسات_, _уточ, ыке_, _udka,
   {{0xa3e79130,0x7982b45d,0x6000345e,0x515b01c6}},	//   पवा_, rdow, römf, רכנו,
   {{0xc059835f,0xd9a5016f,0xdefa8009,0xbcfb0032}},	//   рії_, _ऑक्ट, лый_, _abéw,
   {{0x44268025,0x2d8200a4,0xa91db45f,0x65b59727}},	//   _sto_, _kake_, _saže, _sáha,
   {{0x6440a09b,0xa91d8110,0x25a03460,0xa3ca81a2}},	//   tsmi, _paže, njil_, रोन_,
   {{0x2d820051,0x77b0016d,0x5bb895a6,0x4426841c}},	//   _make_, _växj, илия_, _qto_,
   {{0xa91d805c,0x61ed0687,0xd37a8ae7,0xf8bf00e7}},	//   _važe, _skal, учи_, ncée_,
   {{0x77ab0085,0x9f8d01d0,0x25a0008e,0xc7b381c6}},	//   _müxt, uží_, kjil_, _צבע_,
   {{0xdb1c0125,0x2d820041,0xdb03b33e,0x64563461}},	//   _umræ, _nake_, _zonë, kuyi,
   {{0x4426b462,0xafdb0aa2,0x673a8009,0x5c068a4c}},	//   _uto_, drør, _ketj, _ляка,
   {{0x7bcf80e7,0x62348e8e,0x2d82026b,0x43948254}},	//   écut, _деку, _aake_, _факс,
   {{0x25a6b463,0x673a81a1,0x61ed3464,0x7bca9b8f}},	//   _kool_, _metj, _tkal, _imfu,
   {{0x673a82ce,0xa2b101bc,0x7bdc022b,0x61ed3465}},	//   _letj, _dọ́l, _ajru, _ukal,
   {{0x3f811a67,0x21f9003e,0x64a40003,0x2d8203c3}},	// [2130] _tahu_, lého_, паѓа, _dake_,
   {{0x261a009a,0x673a8fb0,0x69c98cfa,0x661a8326}},	//   _मूवी_, _netj, _smee, _outk,
   {{0x21f90775,0xdb03809f,0x02d90eca,0x1df90190}},	//   ného_, _conè, جواب_, _вены_,
   {{0xd378803b,0x25a68079,0x9f4c801c,0x64560c6a}},	//   moću_, _nool_, _đoán_, buyi,
   {{0x3dcdb466,0x973ca828,0x673a8aa2,0x21f9016b}},	//   view_, _voćn, _betj, hého_,
   {{0x21f90a56,0x7c2d2a70,0x2d82022e,0xb4b5047d}},	//   kého_, mpar, _zake_, जनी_,
   {{0x2d823467,0x201302a6,0x69cf3468,0x9989009a}},	//   _yake_, _mixi_, kice, _miał_,
   {{0x0c258790,0x69c9b469,0x94258049,0x25a681c6}},	//   омин, _umee, омие, _cool_,
   {{0x6f001931,0x7c2d346a,0x9f47b46b,0x57d58073}},	//   _kábí, npar, yonè_, _доаѓ,
   {{0x4a4599a4,0x3949346c,0x61ebb46d,0xd378842b}},	//   онов, _adas_, logl, koću_,
   {{0x395f88ae,0xe9da2748,0x63a7346e,0x69cf1ed3}},	//   _kcus_, ико_, _mojn, fice,
   {{0x61ebb46f,0x69cf2e4d,0x39490144,0x7a138162}},	//   nogl, gice, _cdas_, _bătr,
   {{0x09a78076,0x7a13802e,0x201301b4,0x64a58152}},	//   _खवैय, _cătr, _bixi_, _фала,
   {{0x2d823470,0x44079ccf,0x63a701c0,0xe7371c8b}},	//   _sake_, _учеб, _nojn, жер_,
   {{0x2d823471,0x442db472,0x7643b473,0x320682c4}},	//   _pake_, lpe_, nsny, ymoy_,
   {{0x28c50df4,0x6d5bb474,0x6000016d,0x6569b475}},	//   _लेकि, ngua, döme, nfeh,
   {{0x6b83b476,0x90c30364,0xfaf80029,0x442d8247}},	// [2140] _kang, _объе, _šī_, npe_,
   {{0x6b83828a,0xdb1c0082,0x442db477,0x7a0c8201}},	//   _jang, _områ, ipe_, _işti,
   {{0x6b83b478,0x6da6069b,0x79840041,0x2d820051}},	//   _mang, _дина, _kaiw, _take_,
   {{0xa96a81a1,0x442db479,0xdb03b47a,0x61ebb47b}},	//   рида_, kpe_, _coné, gogl,
   {{0x63a70042,0x7984020d,0x00da9a10,0xa3ca847d}},	//   _fojn, _maiw, جبات_, रोड_,
   {{0x6b83b47c,0x69cf347d,0x661a8198,0x25a681c7}},	//   _nang, zice, _putk, _sool_,
   {{0xd5ba95fe,0x179b0051,0xdb1a80f1,0x8f9b010f}},	//   иси_, ייסב, shtë, ייסי,
   {{0x6b8381d8,0x21f90ed7,0x7984347e,0x61eb8081}},	//   _aang, vého_, _naiw, cogl,
   {{0x64441e89,0x764380dd,0x442d82d5,0x69cf347f}},	//   nsii, asny, gpe_, vice,
   {{0x6b838886,0x70538077,0x661ab480,0x64443481}},	//   _cang, _آنلا, _tutk, isii,
   {{0x25a6b482,0x7414803d,0x442db483,0x798404b9}},	//   _tool_, _کوتا, ape_, _baiw,
   {{0x21f9003e,0x64441bda,0xd46a9c82,0x6b83b484}},	//   rého_, ksii, _виде_, _eang,
   {{0x6d40b485,0x3866b486,0xdd8f8c2a,0x6b83b487}},	//   mama, ntor_, _جون_, _fang,
   {{0x6d40b488,0x69cf3489,0xa91d8110,0xb4c892e0}},	//   lama, sice, _maža, ोपी_,
   {{0xa91d8390,0x69cf348a,0x2013348b,0xb5a70956}},	//   _laža, pice, _vixi_, орай,
   {{0x6d40b48c,0x6b83b48d,0x9f4780d7,0x63a701c0}},	//   nama, _zang, roné_, _sojn,
   {{0x6b83b48e,0xa91d803a,0xb4b50361,0x63a70069}},	// [2150] _yang, _naža, जने_, _pojn,
   {{0x7c2d348f,0x6d40b490,0x6b83b491,0xc2e900ab}},	//   rpar, hama, _xang, _কৃষি_,
   {{0x6d40b492,0x7a400013,0x250909a7,0x65aa05b9}},	//   kama, _rátá, _گردی_, _výhr,
   {{0xa3ca9a46,0xf67a0158,0x19598e11,0x1a9b80be}},	//   रोत_, _פארמ, сады_, ייבע,
   {{0x6d40b493,0x859a0039,0x61ebb494,0xf1b40039}},	//   dama, _השרו, rogl, וסף_,
   {{0xa91d96b5,0x3e4581a9,0xec3601c6,0xf8bf002a}},	//   _daža, tēt_, _מאשר_, lbés_,
   {{0x44393495,0x31359c79,0x628e025b,0x69cd14c7}},	//   _hws_, _невр, _grbo, _omae,
   {{0x6d40b496,0x753d0063,0x31790063,0x6602b497}},	//   gama, _jesz, jesz_, _chok,
   {{0x6b839a92,0x442db498,0x3866b499,0x6d5bb150}},	//   _pang, upe_, ctor_, rgua,
   {{0x69dd03d3,0x753d100b,0x6d5bb49a,0x75d38087}},	//   éren, _lesz, sgua, văzu,
   {{0x656f1385,0x656982af,0x4439349b,0xddc880eb}},	//   _obch, pfeh, _lws_, žoša,
   {{0x6d408faa,0x442d8dfc,0x6b83b49c,0x7bda8009}},	//   cama, ppe_, _wang, antu,
   {{0x6b83859e,0x4439146a,0x3f85b49d,0x442b349e}},	//   _tang, _nws_, _kalu_, _ntc_,
   {{0x6609b49f,0x61a88670,0x3f8591ee,0x79840300}},	//   lmek, _कक्ष, _jalu_, _waiw,
   {{0x753d0065,0x798434a0,0x443934a1,0xcf9280be}},	//   _besz, _taiw, _aws_, עטל_,
   {{0x3f85848f,0x3179009a,0xf1bf026f,0x741600f7}},	//   _lalu_, cesz_, chá_, كورا,
   {{0x39420006,0x75241e41,0xa5070c5c,0x25bf80ee}},	// [2160] maks_, rciz, зета_, ihul_,
   {{0x6d40b4a2,0x64440079,0xb90334a3,0x442034a4}},	//   zama, rsii, _язык, rqi_,
   {{0x442b34a5,0x753d0019,0xa91d80d2,0xdb1ab4a6}},	//   _etc_, _fesz, _saža, uhté,
   {{0x3866b4a7,0x628e042b,0x25bfaf9f,0x5886a1f6}},	//   ttor_, _vrbo, jhul_, зыка,
   {{0x6d40b4a8,0xd90d826a,0x3f85b4a9,0x442034aa}},	//   vama, لیف_, _balu_, qqi_,
   {{0x6d4bb4ab,0x3866b4ac,0x6602b4ad,0xa91d805c}},	//   _adga, rtor_, _shok, _važa,
   {{0x6d40b066,0x7bce34ae,0x7c2b80eb,0x59dc020e}},	//   tama, _imbu, _atgr, मचार,
   {{0x80cd81ab,0xbcfb34af,0x9adb0039,0x661e026c}},	//   _देवे, _ibér, _החלט, _mupk,
   {{0x6d40b4b0,0xa91d8024,0x661e00d2,0x6d4b01a8}},	//   rama, _kažn, _lupk, ógai,
   {{0x6d40b4b1,0xad9b001c,0x644fb4b2,0x3f859ffe}},	//   sama, _nhún, ácia, _galu_,
   {{0x21fc801b,0x7bce0359,0x21790190,0xdcfd01a9}},	//   ního_, _mmbu, ойны_, _masā,
   {{0xa91d8503,0x25bfb4b3,0x6d40b4b4,0x80ab00ab}},	//   _lažn, chul_, qama, _চেষ্,
   {{0x2ac282be,0x4420802e,0x26099094,0x3a20a329}},	//   _bébé_, _îi_, ागरी_, _čipu_,
   {{0xad9b0104,0xefc815da,0x03a3a49a,0xf09f07f1}},	//   _chún, пуск_, _пичо, rxà_,
   {{0x248200ee,0x394234b5,0xdb07010c,0x21fc928a}},	//   _askm_, baks_, _gojè, jího_,
   {{0x40ee082e,0x22f78039,0x44391670,0x9df90a4c}},	//   ọrọ_, _מזון_, _pws_, інат_,
   {{0x753d0065,0xf8bf0b2c,0xa91d8110,0xbcfb026b}},	// [2170] _vesz, rbés_, _bažn, _abér,
   {{0x6ad080ab,0x442b00ff,0x051d0264,0x44390bfd}},	//   _সুযো, _vtc_, তরের_, _vws_,
   {{0x753d0065,0xa91d81e2,0x22470061,0x69dd29d8}},	//   _tesz, _dažn, énk_, onse,
   {{0x7bce34b6,0x6aaa00f2,0x3f85b4b7,0x69dd34b8}},	//   _embu, äffa, _salu_, nnse,
   {{0xc5fb0670,0x3f858573,0x2d9934b9,0x656d3323}},	//   ्षीय_, _palu_, _inse_, mfah,
   {{0x1408016f,0xab8434ba,0xbcfb00f7,0xdfd181a8}},	//   वगृह_, _пуск, _gcéa, ضيع_,
   {{0x21fc801b,0x6609b4bb,0x63a3007b,0x3f8592a5}},	//   cího_, tmek, önnu, _valu_,
   {{0x2d8934bc,0x75fe8168,0x629a2bea,0x69dd01ed}},	//   ndae_, tëza, _štog, jnse,
   {{0x91fd0029,0x394d80d2,0x6609b4bd,0xfc058652}},	//   rtāl, _ides_, rmek, мпио,
   {{0x63aa8114,0x7655009a,0xe3b181a8,0xdb1ab4be}},	//   _cofn, krzy, ئرة_, ditó,
   {{0x91e634bf,0xf1c4801b,0x3942103d,0x29000019}},	//   доне, लोकन, taks_, _szia_,
   {{0x6d4b813c,0x44b5abfc,0xbcb58ada,0x7f4381b4}},	//   _udga, _обес, _обещ, lanq,
   {{0xe87c0459,0xa91d80d2,0xa3ca83dd,0x21fc81d0}},	//   _düşü, _lažo, रोह_, zího_,
   {{0x2d9934c0,0x39420006,0x3fcc00ab,0x63aa8428}},	//   _anse_, saks_, লক্ষ, _gofn,
   {{0x394d82a5,0xa91d8da8,0xdb03826f,0x248d83cd}},	//   _odes_, _ražn, _koní, lvem_,
   {{0xbcfb00f7,0x394d89c4,0x68f6062c,0x70ef0133}},	//   _scéa, _ndes_, _tyyd, ụrụi,
   {{0xd4670f13,0xa91d8025,0xdcfd0029,0x64468289}},	// [2180] мите_, _pažn, _pasā, škiv,
   {{0x973cb4c1,0x6b8701a1,0x2d9934c2,0x394d8580}},	//   _voćk, _cajg, _ense_, _ades_,
   {{0xa91d803a,0x38cb0077,0xa3af0665,0x213fa14a}},	//   _važn, _هایی_, _ओकर_, _beuh_,
   {{0x2005b4c3,0xbbaa946d,0xe8fab4c4,0x765c00b4}},	//   _ahli_, _चक्क, оле_, mury,
   {{0x39402763,0x7bc1859c,0x6b8734c5,0x394d9670}},	//   _meis_, khlu, _fajg, _ddes_,
   {{0x39401e59,0x6d4434c6,0x394d8009,0xc5f8b4c7}},	//   _leis_, laia, _edes_, ुष्य_,
   {{0xd90d8065,0x5a550098,0x9e06a1ae,0xdb038980}},	//   لیہ_, _пъту, мчил, _boní,
   {{0x77b4809f,0xdb038473,0x6d4433bc,0x973c8bcf}},	//   _màxi, _coní, naia, _moći,
   {{0x628382c4,0xa06ab4bf,0xf1bd8035,0xdb03846d}},	//   _asno, _фаза_, ्फरन, _doní,
   {{0x765c023b,0x0a6a9a02,0x7bc1b4c8,0x6d44011b}},	//   kury, орми_, ghlu, haia,
   {{0x6d440867,0x973c80d2,0x6fb380d7,0x452a8162}},	//   kaia, _noći, _جملا, _джен_,
   {{0x85068872,0x225185b9,0x24800748,0x69c2b4c9}},	//   _قوان, ázka_, kwim_, nhoe,
   {{0x69dd34ca,0x394000f7,0xc8642503,0x6d4434cb}},	//   rnse, _deis_, ктри, daia,
   {{0x7655009a,0x7bc1b4cc,0x6004823e,0xdb1ab4cd}},	//   trzy, chlu, lòmb, ritó,
   {{0xc1ee80d4,0x05b280d4,0x6d4403cd,0x3940212b}},	//   जवाब_, _जवाब, faia, _feis_,
   {{0xa91d8029,0x6d4434ce,0x973c81a1,0x69d60061}},	//   _ražo, gaia, _doći, ézet,
   {{0x656d34cf,0xe9df00e1,0x261683db,0xa4c0099b}},	// [2190] rfah, mnú_, _पूछी_, rüşü_,
   {{0x2d89067f,0x765c00b4,0xe9df00e1,0x09d78072}},	//   sdae_, bury, lnú_, ढच्य,
   {{0x77b0016d,0x33f40106,0x6d4434d0,0x248d81d0}},	//   _växt, växt_, baia, zvem_,
   {{0xd5a68591,0xe9df34d1,0x9f47823e,0x397c03de}},	//   _صف_, nnú_, roní_, ַטונ,
   {{0xe7eb8076,0xe3b88214,0x394d8168,0x660d21d8}},	//   टवला_, kkı_, _vdes_, mmak,
   {{0x660d34d2,0xe9df00f7,0x01c98019,0x65bcb4d3}},	//   lmak, hnú_, _کورٹ_, _réha,
   {{0xfe7189d7,0x7f43818a,0x7bc18282,0xd34600d7}},	//   ادت_, ranq, vhlu, _سینه_,
   {{0x660d34d4,0x2247027f,0x394db4d5,0x91fd00eb}},	//   nmak, ánku_, _udes_, stāj,
   {{0xe9df01ac,0xa924826f,0x6000016d,0x799b8300}},	//   dnú_, _úžas, dömn, _inuw,
   {{0xf77095e4,0x39401313,0xb605816b,0xa3caa0e9}},	//   _نام_, _seis_, dnáš, रोल_,
   {{0xeb920158,0xa3b70665,0xe299b4d6,0xd5bc046d}},	//   אָר_, _जवन_, чан_, _bọ́_,
   {{0x3ce08025,0xdb070125,0x29d200d2,0x1df9064a}},	//   _žive_, _hljó, ršao_, ंतोष_,
   {{0xbcfb1db6,0x777c002a,0x6e2180b9,0x6d4402df}},	//   _scén, terx, _hulb, vaia,
   {{0x6d44010b,0x7529b4d7,0x29d2026c,0xb4cb83b7}},	//   waia, lcez, pšao_, रछी_,
   {{0x670f800c,0xa91d8024,0x6449b4d8,0x394034d9}},	//   ाधिक_, _pažl, lsei, _teis_,
   {{0x660d34da,0x973c80c3,0x6e21a7d1,0x386902a6}},	//   gmak, _voći, _mulb, _fqar_,
   {{0x6449b4db,0x6d4434dc,0x6b5600f7,0x765c34dd}},	// [21a0] nsei, raia, فضائ, sury,
   {{0x7c2b2509,0x6d441c91,0x26cc0548,0x64498a2a}},	//   ígra, saia, údos_, isei,
   {{0xc0a90077,0x6d44208b,0x69c2b4de,0x443db41f}},	//   _فایل_, paia, thoe, _lww_,
   {{0x64a61652,0x5066a17e,0xdca6067c,0xe046867c}},	//   _зама, етка, _зами, енди,
   {{0x69c286a8,0x248000ee,0x2ac60032,0x201a2aa0}},	//   rhoe, qwim_, _bíbé_, _kipi_,
   {{0x61e410d3,0x6449b4df,0xc7a382d3,0x69c29de6}},	//   _ljil, dsei, личк, shoe,
   {{0x539b0051,0x442234e0,0xa3dd02f1,0x644b868f}},	//   _צילו, _huk_, तचर_, _avgi,
   {{0x38cb80d5,0x9f4a03fb,0x75fe80f1,0xa91d807a}},	//   _کافی_, dobí_, rëzo, _lažj,
   {{0x69c0b4e1,0x44220110,0x91fd00eb,0x63ae012b}},	//   _ilme, _juk_, stāk, _kobn,
   {{0xa3ca8d38,0x61e4022e,0x442f89ca,0x7ac6a155}},	//   रों_, _ajil, _dtg_, есме,
   {{0x19590a14,0xe3b883bf,0x2ec69c12,0xe9df00e1}},	//   маны_, rkı_, _ثقاف, tnú_,
   {{0x644982af,0x394695d7,0xcc88801c,0x3ce6822c}},	//   bsei, naos_, _tớ_, _txov_,
   {{0x44220b18,0x61e434e2,0xe9df00e1,0x201a00c3}},	//   _nuk_, _djil, rnú_, _bipi_,
   {{0xc5fb05e8,0x6d4f0683,0x6446807a,0x8c1b81c6}},	//   ्ष्य_, _sdca, škis, _זוגי,
   {{0x69c0b4e3,0x442234e4,0x660d34e5,0xd5bb2318}},	//   _olme, _auk_, tmak, пса_,
   {{0x7c228009,0x61e40168,0x3946b4e6,0x6b8ab4e7}},	//   _kuor, _gjil, jaos_, _hafg,
   {{0x660d34e8,0x442219d5,0x6ad900c2,0x3946b4e9}},	// [21b0] rmak, _cuk_, भप्र, daos_,
   {{0x69c0b4ea,0x442203c3,0x7c228081,0xdb150118}},	//   _alme, _duk_, _muor, _alzá,
   {{0xdb03816b,0xdb188216,0x660d34eb,0x29048c53}},	//   _koná, _olví, pmak, _azma_,
   {{0xa2d5053e,0x3e4c800d,0x28d2908a,0x2486826c}},	//   _येण्, dět_, _देहि, _osom_,
   {{0x7c2293cd,0xf8b334ec,0xdb03802a,0x7f4180f1}},	//   _nuor, ुनिय, _moná, _pelq,
   {{0x2d8b0a49,0x9a8734ed,0x69c08a09,0xa91d8110}},	//   _hace_, _публ, _elme, _kažk,
   {{0x973c817f,0x44220102,0x2d8b34ee,0x60000338}},	//   _noću, _zuk_, _kace_, döml,
   {{0x25a934ef,0x2d8b02a5,0x442f9083,0x6449b4f0}},	//   njal_, _jace_, _ptg_, tsei,
   {{0x7c228098,0x1c428084,0x2d8b04b9,0x6d42802e}},	//   _cuor, аным, _mace_, _deoa,
   {{0x61f634f1,0x6449b4f2,0x8b958878,0x6295026c}},	//   _skyl, rsei, трич, _krzo,
   {{0x13098009,0xa2e581e5,0x320902c4,0x920d0035}},	//   ьной_, тонд, _bhay_, सगंज_,
   {{0x7c228098,0x442fb4f3,0x62950b80,0x201a076d}},	//   _fuor, _ttg_, _mrzo, _sipi_,
   {{0x9f4a026f,0x6446929b,0xef1880eb,0x2d9d8870}},	//   sobí_, škir, _daļu_, _inwe_,
   {{0x4422067f,0x2b4302d4,0x61fd0299,0x00000000}},	//   _ruk_, _nejc_, alsl, --,
   {{0xf74314d6,0x442234f4,0x201a34f5,0x2d8b0041}},	//   ресо, _suk_, _vipi_, _bace_,
   {{0xc692810f,0x2d8b026c,0x63ae34f6,0xdb070216}},	//   סאן_, _cace_, _sobn, _cojí,
   {{0x201a34f7,0x2d8b00a4,0xab661505,0x62950333}},	// [21c0] _tipi_, _dace_, квал, _arzo,
   {{0x291f9fd1,0x44220024,0x2d8b008e,0x35c60035}},	//   _agua_, _vuk_, _eace_, रोज़,
   {{0x68fb9220,0xcf570051,0x0f570158,0x2d8b34f8}},	//   _ayud, _בבית_, _ביים_, _face_,
   {{0xa7fb01df,0x25a907d8,0x2d8b0314,0x2c6b8366}},	//   ruñe, cjal_, _gace_, kød_,
   {{0xf993010f,0x64430a20,0x2d80002e,0x3946b4f9}},	//   ירא_, ćnic, meie_, raos_,
   {{0x60048247,0x6d4283a8,0x2d8b34fa,0x2d80004a}},	//   fòma, _seoa, _zace_, leie_,
   {{0x7c228364,0xfaa334fb,0x2d8b00a4,0xc7b888ae}},	//   _suor, _каро, _yace_, _niđe_,
   {{0xa2c590a1,0x656434fc,0x5e5700be,0x2d8b0118}},	//   ानन्, ngih, דיקע_, _xace_,
   {{0x68fbb15d,0x2904b4fd,0x6d4286ae,0x7dde8ec3}},	//   _gyud, _uzma_, _veoa, nīsi,
   {{0x7c228009,0x212000b9,0x2d9d8870,0x32090df6}},	//   _vuor, _agih_, _enwe_, _shay_,
   {{0x2d8001b0,0xdea3804e,0xd7ef80f7,0xa5b300c2}},	//   keie_, _نیوی, _بكل_, _इकलौ,
   {{0x61e2b4fe,0x7c228009,0xb6d980be,0x24868069}},	//   nnol, _tuor, _אַנט, _tsom_,
   {{0x7c2d8457,0x2d8b34ff,0x3f8cb500,0x61fd29c6}},	//   _çarp, _race_, _kadu_, rlsl,
   {{0xb8cb243f,0x2d8b0041,0x7dde81a9,0x6b8a8366}},	//   _गप_, _sace_, dīsi, _uafg,
   {{0x8c1b810f,0x32090028,0x3f8c8b20,0x2d8b3501}},	//   _קווי, _thay_, _madu_, _pace_,
   {{0x69c60352,0xdb1ab502,0xf1b98668,0x320902d5}},	//   chke, chtá, _kiše_, _uhay_,
   {{0x33750021,0x25a93503,0xa5f82466,0x61e2b504}},	// [21d0] лгар, rjal_, тету_, dnol,
   {{0x1ae700ab,0xe1ff3505,0x248d026c,0x2d8b0041}},	//   _করবে_, lló_, _šems_, _wace_,
   {{0x2d8b04b9,0x798d3506,0x68fb9400,0x2d8db507}},	//   _tace_, _kaaw, _syud, ydee_,
   {{0x61e2b508,0xe1ff0019,0x3f9e8041,0xfb1580be}},	//   gnol, nló_, _antu_, אַנט_,
   {{0x80cd8063,0x040d801c,0x518481e5,0x3f8c8102}},	//   _देखे, _cườn, руха, _badu_,
   {{0xa91d8110,0x69d885db,0xa5bb0825,0x040d80ff}},	//   _maži, éver, _bióg, _dườn,
   {{0xf770a6f1,0xf1b98267,0x442932aa,0x661d3509}},	//   تان_, _aiše_, lqa_, _kisk,
   {{0x661d350a,0x644d350b,0x752d350c,0x3ea98d26}},	//   _jisk, osai, ncaz, ćat_,
   {{0xa3b70076,0x7afc00f1,0xad9b00f7,0x644d350d}},	//   _जवा_, _zyrt, _chúi, nsai,
   {{0x3f8cb50e,0x09dc035a,0x69d9b50f,0x2c6b8edd}},	//   _gadu_, मच्य, liwe, rød_,
   {{0xd9460dd3,0xd57589c7,0x61461597,0xa96a1677}},	//   лени, _буль, лена, нина_,
   {{0x7c958591,0x798d0079,0x644d3510,0xaca38133}},	//   _مشتا, _caaw, ksai, _alụk,
   {{0xeb8eb511,0x753ba742,0x798d3512,0x3f8cb513}},	//   _ли_, mbuz, _daaw, _yadu_,
   {{0x69c600f1,0xe80403b7,0xe1ff0216,0x661d2f52}},	//   shke, _शीशा_, aló_, _aisk,
   {{0x6b8184cc,0xe1ff3514,0x661d3515,0x3ebe007b}},	//   melg, bló_, _bisk, átt_,
   {{0x61e28085,0x8886148d,0x69d9804f,0x3f8c258f}},	//   xnol, _ближ, jiwe, ždu_,
   {{0xb0d2809a,0x645bb516,0x69c43517,0x7c29b518}},	// [21e0] _देंग, nrui, _ilie, nqer,
   {{0xb6a60cec,0x3ea6045e,0xdb0380e7,0x69c43519}},	//   _биол, _биог, _conç, _hlie,
   {{0x661d155f,0x644d10eb,0x50d6803d,0x7c36351a}},	//   _fisk, asai, گزار, spyr,
   {{0x3f8ca1dc,0x91fd0029,0x249f0024,0xa91d8f20}},	//   _sadu_, stāv, _šume_, _zaži,
   {{0x7bc38006,0x644d351b,0x69c401ac,0x6d4601a9}},	//   _olnu, csai, _mlie, _ieka,
   {{0x91fd0029,0x61e2a1a2,0x6d46351c,0x661d016b}},	//   ltāt, snol, _heka, _zisk,
   {{0x6d4634c3,0x26058076,0x69c4351d,0xf1c1026f}},	//   _keka, _हीही_, _olie, ášky_,
   {{0x5454b51e,0x645bb51f,0x2627826c,0x040d801c}},	//   авит, frui, _gđom_, _tườn,
   {{0xa2d9a38c,0x973c8088,0x7bc68612,0x6b81b520}},	//   _फेब्, _anće, ūkum, felg,
   {{0xf1b9803a,0x1ae70a49,0x6d46127a,0xef918077}},	//   _više_, _করতে_, _leka, _ویند,
   {{0x69c43521,0xb3458187,0x798d02d5,0xd3778048}},	//   _blie, _seçã, _paaw, учы_,
   {{0x6d463522,0x645b933a,0x8c46954f,0x0446af4b}},	//   _neka, brui, _беде, _бедн,
   {{0x645bb523,0x201eb524,0xa91d8110,0x107403c7}},	//   crui, _kiti_, _paži, бляю,
   {{0xa3e88b3b,0x69c43525,0x92948ff7,0x69d9b526}},	//   _यदि_, _elie, _вакц, ziwe,
   {{0x6d463527,0x4426822e,0xdd9b3528,0x7bda8364}},	//   _beka, _huo_, нша_, mitu,
   {{0x6d463529,0x44268110,0x7c26352a,0x69c4352b}},	//   _ceka, _kuo_, _bukr, _glie,
   {{0x661d28d1,0x2455003d,0x6298b52c,0x24580009}},	// [21f0] _visk, شناس, _hrvo, лать_,
   {{0x644d352d,0x442901b9,0x661d352e,0xf1bf01d0}},	//   rsai, rqa_, _wisk, lká_,
   {{0x644d352f,0x661d3530,0x6d463531,0x44293532}},	//   ssai, _tisk, _feka, sqa_,
   {{0x19598196,0x7bda8744,0xf1bf3533,0x3ebe0bc5}},	//   тады_, hitu, nká_, øtte_,
   {{0x201e8052,0x44268a8e,0xa0a58adb,0x7bdab534}},	//   _biti_, _nuo_, ралд, kitu,
   {{0x6d463535,0x65b5803e,0x201eb536,0x62988019}},	//   _zeka, _náhr, _citi_, _orvo,
   {{0x74d904c5,0xda05016f,0x8c0a80ab,0x6d46071f}},	//   _नेतृ, रतात_, রদান_, _yeka,
   {{0x4426b537,0xf2d204de,0x201e8084,0x225c01d6}},	//   _buo_, _ועל_, _eiti_, ávke_,
   {{0x62988364,0x44268052,0xe1348012,0x05a68009}},	//   _arvo, _cuo_, _ынты, рвый_,
   {{0xf77388ca,0x69c43538,0x7bdab539,0x6721805c}},	//   _دار_, _slie, gitu, _uglj,
   {{0x69c4353a,0x62988699,0x61e9835f,0x2909019d}},	//   _plie, _crvo, _kjel, _azaa_,
   {{0x629882a5,0x645bb53b,0x6b81b53c,0x2258b53d}},	//   _drvo, prui, selg, árka_,
   {{0x6d460025,0x69c40b3c,0x628aabe1,0x629880f3}},	//   _reka, _vlie, _esfo, _ervo,
   {{0x6d460812,0x7bdab53e,0x91fd00eb,0x7bc8b53f}},	//   _seka, citu, tuāc, chdu,
   {{0x61fbb540,0x69c401b9,0x7c263541,0x2d8fb542}},	//   _okul, _tlie, _sukr, _kage_,
   {{0xf1bf0a56,0x65b581ac,0xceb28039,0x61e9b543}},	//   cká_, _záhr, חיל_, _njel,
   {{0x9f5e8009,0x6fc5816f,0xd7c58072,0xa91d80c3}},	// [2200] _yhtä_, वसां, वसाच, _kažu,
   {{0x2d8fb544,0x61fbb545,0x75fe80f1,0x91fd01a9}},	//   _lage_, _akul, rëzi, grāf,
   {{0x6d460886,0x61e98654,0xbea614bc,0xa9268db4}},	//   _teka, _bjel, _танк, адел,
   {{0x201eb546,0x61e9920e,0x25adb547,0xc05a8d13}},	//   _siti_, _cjel, jjel_, вік_,
   {{0x61e9830b,0x201eb548,0x25a20456,0xd378807d}},	//   _djel, _piti_, _inkl_, liće_,
   {{0x91fd0341,0xd90d80d5,0x7c2480f7,0x44268870}},	//   ntār, ریل_, _éiri, _ruo_,
   {{0x44268698,0x4b7b0bea,0x7bdab549,0x64428063}},	//   _suo_, _שאלו, vitu, _swoi,
   {{0x2d920205,0x61e9945c,0xbcfb00f7,0x4426b54a}},	//   ndye_, _gjel, _scéi, _puo_,
   {{0x2d8fb54b,0x201eb54c,0xbc6780f7,0x7bdaa4cf}},	//   _dage_, _titi_, لمين_, titu,
   {{0x62988b5d,0x90e5803d,0xc5e3354d,0x201e8162}},	//   _prvo, _اسفن, _गद्य_, _uiti_,
   {{0xe7e38076,0xbeaa8077,0xf1b98353,0x2d8f8041}},	//   कचरा_, _جهان_, _hiša_, _fage_,
   {{0x4426b4ba,0x7bdab54e,0x28db946d,0x6da39541}},	//   _tuo_, situ, _मेडि, _миха,
   {{0x6e28827f,0xe3af819f,0xdb0e0214,0x75d381a8}},	//   _hudb, سری_, _albü, _بينا,
   {{0xf1bf003e,0x2d84b54f,0xf1b98390,0x248b008e}},	//   ská_, leme_, _miša_, _rscm_,
   {{0x394b3550,0x69dd0bfe,0x7bd89d61,0xadc38091}},	//   pacs_, éres, _imvu, _atẹl,
   {{0xdcfb83bf,0xf99f1b01,0x2d84b551,0xfa3395a9}},	//   nduğ, rmès_, neme_, _برود,
   {{0x69dd138e,0xf1b985a2,0x6e2889d1,0x600d8020}},	// [2210] mise, _niša_, _ludb, lúme,
   {{0x61fbb552,0x3dc90069,0x60c00bc5,0x69dd138e}},	//   _skul, shaw_, ømme, lise,
   {{0x2003003b,0xe6950013,0x6e950013,0xf1b988ae}},	//   mlji_, _الجد, _الجا, _aiša_,
   {{0x69dd3553,0x6286809a,0xa5bb0333,0xdb0e0216}},	//   nise, łkow, _dióc, _albó,
   {{0x2d8f84b9,0x2d84803e,0x9f51001b,0x260a9993}},	//   _rage_, deme_, hozí_, ातनी_,
   {{0x69dd3554,0x39490c5e,0x7dde80eb,0x490a0fb2}},	//   hise, _leas_, zīst, _सरसो_,
   {{0x2d8fb555,0x320d804c,0x69dd3556,0x7c2d3557}},	//   _page_, _they_, kise, lqar,
   {{0x59f98009,0x61fb805d,0x3940807b,0xc7b8811f}},	//   _себя_, _ukul, ðist_, _viđa_,
   {{0x7bc704c4,0x69dd0006,0x26c181ac,0x63b50bcf}},	//   _klju, dise, šho_, _kozn,
   {{0x6e28835d,0x39490118,0x25bfb4b1,0x3a2002f7}},	//   _fudb, _aeas_, skul_, _siip_,
   {{0x2d8fb558,0x69dd3559,0x7dde8029,0x63b5355a}},	//   _tage_, fise, tīst, _mozn,
   {{0x63b50904,0xd3788253,0x69dd355b,0x2d849e1c}},	//   _lozn, viće_, gise, ceme_,
   {{0x27f8355c,0x39490083,0x7bc7355d,0xec3580be}},	//   torn_, _deas_, _olju, _פאַר_,
   {{0x7c3bb55e,0xd3788289,0x69dd355f,0xdc3680be}},	//   mpur, tiće_, aise, _האסט_,
   {{0xed5a0758,0xada61b10,0x6da61630,0x75fe8168}},	//   лов_, бавл, бива, rëzv,
   {{0x249f01dd,0x6569b560,0xd3788289,0xe3bf03a8}},	//   _šuma_, ngeh, riće_, _buño_,
   {{0x61f9809a,0xdca31ac9,0xd3788904,0x7bc700ce}},	// [2220] dowl, пати, siće_, _blju,
   {{0x7bc1b561,0x65bc82be,0xd3788289,0x7f8600f7}},	//   nklu, _véhi, piće_, _الدن,
   {{0x63b53562,0xdceb80eb,0xdb0e06c4,0xce9581a9}},	//   _dozn, _angļ, _albò, šējā_,
   {{0x629a2a3e,0x27e981a8,0xdb1c0106,0x9f580168}},	//   _átom, éann_, _omrö, korë_,
   {{0x6e288025,0x28d2824c,0xdb0a8118,0x66043563}},	//   _sudb, _देखि, _mofá, mlik,
   {{0x824a2f0a,0x66043564,0xdfd080f7,0x79863312}},	//   _مشرف_, llik, بيت_, hekw,
   {{0x7bde3565,0x69dd29f7,0x8f9b0039,0xddcb826c}},	//   mipu, yise, טיסי, _šiši,
   {{0x7bde0886,0x63b50038,0x66043566,0x69cba7f9}},	//   lipu, _zozn, nlik, chge,
   {{0xe3bf07f4,0xdcfb83bf,0x6604067f,0x69dd3567}},	//   _xuño_, rduğ, ilik, vise,
   {{0x7bde03f8,0x325485c2,0xdee68992,0x7bc1a168}},	//   nipu, овор, _лози, gklu,
   {{0x69dd3568,0x66043569,0xd5af9b4b,0x93fb00be}},	//   tise, klik, _ес_, רליי,
   {{0x645d82ba,0x7bde003d,0xba9b03c8,0x69c2b56a}},	//   ásic, hipu, אסטי, nkoe,
   {{0x7bde356b,0x6604356c,0x39490511,0x600d8020}},	//   kipu, dlik, _veas_, súme,
   {{0x69dd356d,0x7bc182af,0xcc57810f,0x629c356e}},	//   sise, cklu, _פסוק_, _orro,
   {{0x98a51010,0x7bde356f,0x91fd00eb,0x7bdb8039}},	//   ğlı_, dipu, trād, _תקוו,
   {{0x98a50182,0x66043570,0x1ae700ab,0x7d02838a}},	//   şlı_, glik, _করলে_, _kyos,
   {{0x2003005c,0x545500e8,0xe9df01a8,0x93270061}},	// [2230] plji_, юват, miú_, مران,
   {{0x7bde1b6b,0x61ed23ea,0xad9b00f7,0xe9df01a8}},	//   gipu, _hjal, _chúr, liú_,
   {{0x63b5135a,0x387fb571,0xc33381c6,0x7bc702d4}},	//   _vozn, _spur_, פוף_, _vlju,
   {{0xdb038038,0xe9df00f7,0x3949a511,0x6e22b572}},	//   _ponú, niú_, úas_, _niob,
   {{0x628e3573,0x7c2d0609,0x629c3574,0x27e985e4}},	//   _esbo, qqar, _erro, éano_,
   {{0x44393575,0x7bc70042,0x9848a1f6,0xad9b0f35}},	//   _its_, _ulju, сяца_, _thús,
   {{0x798620c4,0x61ed3576,0x6569b577,0x3ffc03de}},	//   yekw, _ojal, tgeh, אפגע,
   {{0x44230586,0xe4598af2,0xf8bf3043,0x7d0282a0}},	//   _hij_, ажи_, ncés_, _byos,
   {{0xdb1a80f7,0xa3b00540,0x6e22b578,0x6569b579}},	//   chtú, टॉक_, _diob, rgeh,
   {{0x7986357a,0xa3d3800f,0x61ed357b,0x4423357c}},	//   wekw, सों_, _ajal, _jij_,
   {{0xf77095e4,0x44230613,0x7986357d,0x656f0098}},	//   _سال_, _mij_, tekw, _occh,
   {{0x7c3bb57e,0x44230069,0x6e22b57f,0x644301dd}},	//   ppur, _lij_, _giob, ćnij,
   {{0x61ed3580,0x79862f0b,0x44393581,0x69c9826c}},	//   _djal, rekw, _nts_, _mlee,
   {{0x4423022c,0xee3a2606,0xd9b697a3,0xaa45a28e}},	//   _nij_, инг_, _अक्ट, _декл,
   {{0x61ed3582,0x69c9b583,0x6d4b8590,0x66043584}},	//   _fjal, _olee, _kega, tlik,
   {{0x61ed3585,0x806611c7,0x2251803e,0xe5a30fe7}},	//   _gjal, _движ, ázku_, миси,
   {{0x44231dbe,0x66043586,0x7bde1d29,0xd3788024}},	// [2240] _bij_, rlik, tipu, lića_,
   {{0x66043587,0x3f879351,0x6d4bb588,0x69c9b589}},	//   slik, jenu_, _lega, _alee,
   {{0x6604358a,0x7bde358b,0x3f87b58c,0x44390722}},	//   plik, ripu, denu_, _ets_,
   {{0x7bde358d,0x64a608d5,0x0906802e,0xf6530039}},	//   sipu, _дама, опен, _קצר_,
   {{0x4423358e,0x6e22816a,0xd378b58f,0x69c2800b}},	//   _fij_, _riob, hića_, rkoe,
   {{0x69c995ba,0xd3788289,0xc05980e8,0xa09b03c8}},	//   _elee, kića_, сії_, יינט,
   {{0x600487e2,0xeb910158,0xd37881dd,0x628e020d}},	//   nòmi, _אָן_, jića_, _usbo,
   {{0x44230613,0xd378803b,0x6d4b90e1,0x5d5480b3}},	//   _zij_, dića_, _cega, чкит,
   {{0x6d4bb590,0x4423022c,0x7c238091,0x6d598365}},	//   _dega, _yij_, _binr, _ddwa,
   {{0x6d59b591,0x3f87825b,0xd378812b,0x61ed070b}},	//   _edwa, cenu_, fića_, _sjal,
   {{0x6d4b9e72,0xc33302f6,0xd3788042,0x69c98009}},	//   _fega, וות_, gića_, _ylee,
   {{0x7c23a32a,0x6e22826c,0x78a201a9,0xfec20264}},	//   _einr, _uiob, _šova, োপাধ,
   {{0xa5078ae7,0xe9df0013,0x6443005c,0xc95384de}},	//   _деца_, riú_, ćnik, ומר_,
   {{0xd7fb138c,0x29050029,0xd378812b,0xe9df00f7}},	//   рум_, āla_, bića_, siú_,
   {{0xcddb19e3,0x442300f3,0x7c2b8398,0xa3ae1199}},	//   ања_, _rij_, _zugr, कान_,
   {{0x442301c5,0x442b0722,0x7bdc2bb7,0x7dce8229}},	//   _sij_, _puc_, _amru, _dùsg,
   {{0x44230282,0x61fd0a96,0x92e700c8,0x7e6701c0}},	// [2250] _pij_, mosl, _পরে_, sujp,
   {{0x44233592,0x69c9b593,0x7a330609,0x9f430216}},	//   _qij_, _slee, _aħta, rojó_,
   {{0x69c9b594,0x4423290e,0x8ae7035f,0x443902f7}},	//   _plee, _vij_, ціал, _wts_,
   {{0x44230613,0x61fd3595,0xbcfb00e1,0x442b00ff}},	//   _wij_, nosl, _dcér, _tuc_,
   {{0x44233596,0x8fa58d13,0x4439008e,0x69c983b2}},	//   _tij_, зале, _uts_, _vlee,
   {{0x6d4b885c,0x2904831d,0x94ba0039,0x9f4780e7}},	//   _sega, _dyma_, _המשת, onné_,
   {{0x3f878289,0x9258038d,0x6d4ba5c8,0xed59b597}},	//   renu_, _март_, _pega, бой_,
   {{0xd378803b,0x656d3598,0xd90e8065,0x21290748}},	//   vića_, ngah, ئیے_, _ngah_,
   {{0x6d4bb599,0x205481a0,0x478b8009,0x3f87929b}},	//   _vega, _октя, _всем_, penu_,
   {{0xd3788067,0x63b881c0,0x6d4bb59a,0xf1b9826c}},	//   tića_, _covn, _wega, _hoš_,
   {{0x88bd80ab,0x7bc500dd,0x9f4e03c1,0x6b950612}},	//   _অধিক, ikhu, áním_, _mazg,
   {{0xf1b9803a,0x22470ed7,0xd3788024,0x20010359}},	//   _još_, ánky_, rića_, _akhi_,
   {{0xa3dc05b3,0x64a599b5,0x394daa3c,0xd378812b}},	//   तोड_, _хала, _mees_, sića_,
   {{0x394db59b,0x443f8812,0x4375893f,0xf1b9805c}},	//   _lees_, mpu_, _זײַן_, _loš_,
   {{0x443fb59c,0x6012007b,0x61fd176d,0xc33283de}},	//   lpu_, væmd, bosl, _אוו_,
   {{0xc8bd89a3,0x25a6040e,0x394d8282,0x69cf026f}},	//   ्नाट, ñol_, _nees_, chce,
   {{0x6b950115,0x2ea883e8,0x443f8176,0xdd8f0b8c}},	// [2260] _bazg, _कप्त, npu_, دوق_,
   {{0xdb0383d3,0x389b010f,0x60001cab,0x3a24b59d}},	//   _anné, _פיינ, röms, _simp_,
   {{0xf1b98353,0xd36f0154,0x394d9af4,0xc7b8811f}},	//   _boš_, اهم_, _bees_, _rođ_,
   {{0x2d89359e,0xa96a8f27,0x69c615c8,0x3f8a359f}},	//   ceae_, сида_, nkke, lebu_,
   {{0x6d441cdc,0x394db5a0,0x68438329,0xbcfb026b}},	//   mbia, _dees_, енча, _adéf,
   {{0x6d440110,0x3f9835a1,0x6e2602d5,0x64560034}},	//   lbia, ndru_, _hikb, msyi,
   {{0x3a248012,0x63b8803e,0x09cc035a,0xd946a09a}},	//   _timp_, _rovn, ासाठ, _неви,
   {{0x394db5a2,0x6fcb01cc,0x3a24816a,0x3f8a35a3}},	//   _gees_, _müca, _uimp_, hebu_,
   {{0x69dd02be,0x645635a4,0x443f82d5,0x48ce0264}},	//   èrem, nsyi, gpu_, রপুর,
   {{0x5a348572,0x6f668073,0x799605ee,0x61e2b5a5}},	//   мнот, _ѕвез, _aayw, liol,
   {{0xa5bb0207,0x7f3b8039,0x799602d5,0x60c29fce}},	//   _biól, _העבו, _bayw, lyom,
   {{0x394d822c,0x61e2b5a6,0x25a68114,0xdceb02d4}},	//   _xees_, niol, _unol_, _žičn,
   {{0x60c2b5a7,0xdca39c79,0x61fd1b50,0x2bd9809a}},	//   nyom, _паци, rosl, योहा,
   {{0xb7bd802e,0x6fbe80d4,0x3f8a35a8,0x61e2b5a9}},	//   _puţi, ्सिं, gebu_, hiol,
   {{0x644086a8,0xbcfb0118,0xddd035aa,0x61e2b5ab}},	//   lpmi, _acép, _šeši, kiol,
   {{0xb8e30a49,0x6d4435ac,0x76550035,0x69c60192}},	//   _এই_, gbia, rszy, ckke,
   {{0x57f5120c,0x394db5ad,0x69df0609,0xb0db8a27}},	// [2270] _опит, _rees_, _imqe, _मेंग,
   {{0xfe6e19f4,0xa3d7000f,0x60cf080a,0x76550035}},	//   دگی_, ़ों_, ınmı, pszy,
   {{0x6d4435ae,0x6602b5af,0x394d9d14,0x6b9502d0}},	//   bbia, _okok, _pees_, _vazg,
   {{0xe8d935b0,0x61e2847f,0x394d8282,0x27e301ed}},	//   _ndị_, giol, _qees_, lijn_,
   {{0x394db5b1,0x315800be,0x60c28019,0xf1b98af8}},	//   _vees_, ליאן_, gyom, _hišk_,
   {{0x394d84df,0x660290ab,0xe8d90870,0xbcfb046d}},	//   _wees_, _akok, _adị_, _adég,
   {{0x6d4f0397,0xdd918117,0x69c60b40,0x629a35b2}},	//   _keca, ہوں_, ykke, _štov,
   {{0xf1948153,0x7c2735b3,0x8459b5b4,0x38608503}},	//   _пись, _hijr, орот_, šira_,
   {{0x8554803d,0x225800cd,0x799600fc,0x6f0901d0}},	//   ریور_, _zvrk_, _rayw, řech,
   {{0x6d4f35b5,0x69cd0d62,0x443fb5b6,0x3e578162}},	//   _leca, _alae, rpu_, păt_,
   {{0x7c2f0c6e,0xa18a2b3f,0xa3ae34ec,0x69cd031d}},	//   _lucr, обна_, कात_, _blae,
   {{0x443f8fc0,0x69cd35b7,0x6d4f35b8,0x88e60ca0}},	//   ppu_, _clae, _neca, джме,
   {{0x661bb5b9,0xc4fb803d,0x69c60198,0x6609b5ba}},	//   mmuk, _اعضا_, rkke, mlek,
   {{0x69cd02c4,0x661b8a41,0x8b0381d0,0x7d061c77}},	//   _elae, lmuk, ářsk, _ryks,
   {{0xf77209d7,0x6d4f3499,0x2bda8077,0x442fb5bb}},	//   _یاد_, _beca, _بانک_, _hug_,
   {{0x4427b5bc,0x6d4f35bd,0x7e61007b,0x6609b5be}},	//   _hin_, _ceca, álpa, nlek,
   {{0x6d442bb8,0xe3ba0cf3,0xfce30195,0x442fb5bf}},	// [2280] rbia, оба_, вото, _jug_,
   {{0x44278b1b,0x8bf100c8,0x64561600,0x7d060110}},	//   _jin_, _জীবন_, rsyi, _vyks,
   {{0x442fb5c0,0x9f5c80f1,0x7c2f0118,0xbcfb26b2}},	//   _lug_, sovë_, _eucr, _adéd,
   {{0x4427b5c1,0x6609869f,0x9f5c83c1,0x661b80b9}},	//   _lin_, jlek, mové_, jmuk,
   {{0x9f5c803e,0xa3bf897d,0x645d816b,0x443d81c0}},	//   lové_, ीसा_, ásil, _ntw_,
   {{0x4427b5c2,0x6609b5c3,0x8fa38878,0xd8d735c4}},	//   _nin_, elek, каче, וונט_,
   {{0xdb03a6d5,0x9f5c827f,0x34b88bb8,0xd6d080f7}},	//   _monó, nové_, ेन्द, طقة_,
   {{0xd5b08307,0x4427b5c5,0x27e301ed,0x661b977c}},	//   افة_, _ain_, zijn_, gmuk,
   {{0x4427b5c6,0x442f8640,0x9f5c826f,0xf41f0338}},	//   _bin_, _cug_, hové_, _isär_,
   {{0x63bc0a3e,0x9f5c83cb,0x39468110,0xa3d8809a}},	//   _jorn, kové_, lbos_, ठों_,
   {{0xbcfb35c7,0x9f5c826f,0x2fd7803d,0x69cd35c8}},	//   _idée, jové_, _تولد_, _plae,
   {{0x4427b5c9,0x9f5c83fb,0x3ce08289,0x8c4687b6}},	//   _ein_, dové_, _živu_, _жеде,
   {{0x6d4f1520,0x29f8b5ca,0x443d808e,0xdb18802a}},	//   _reca, mčad_, _gtw_, _mové,
   {{0x6d4f1a67,0x4427b5cb,0x9f4300f1,0xdb038388}},	//   _seca, _gin_, mijë_, _conó,
   {{0xd5bb35cc,0x7c2f1ebb,0xdb038118,0x9f5c85b9}},	//   оса_, _sucr, _donó, gové_,
   {{0x4427b5cd,0xdb18827f,0xca2980be,0x29f8811f}},	//   _zin_, _nové, _צופֿ, nčad_,
   {{0x63bc35ce,0x4427a778,0x6d4f35cf,0x62978118}},	// [2290] _born, _yin_, _veca, _áxor,
   {{0x2fc70104,0x44278028,0x60c000f2,0x9f5c826f}},	//   _ông_, _xin_, ämme, bové_,
   {{0x3d0583bb,0x386680ee,0x63bc35d0,0xddc38087}},	//   _हुने_, eror_, _dorn, nunţ,
   {{0x6d5d006a,0x6eae001b,0x2909008e,0xf1b980ce}},	//   _udsa, ीहरु, _kyaa_, _kiši_,
   {{0xdd3a0051,0x63bc080e,0x798bb5d1,0x6609941f}},	//   _מערכ, _forn, regw, vlek,
   {{0x2d990079,0xe7398b9b,0xe8d9019d,0xe61180d7}},	//   _hase_, чек_, _ndọ_, گشت_,
   {{0x4427b5d2,0x2d9935d3,0x27e981dd,0x442fb5d4}},	//   _rin_, _kase_, đan_, _sug_,
   {{0x4427b5d5,0xdcf380fe,0xdceb81cd,0xe8d901bc}},	//   _sin_, šače, _jagħ, _adọ_,
   {{0x6609b5d6,0x661b859c,0xdceb81cd,0x9f5c826f}},	//   rlek, rmuk, _magħ, zové_,
   {{0xe3b18307,0x63bc35d7,0x2d9935d8,0xe8bd8540}},	//   ارة_, _xorn, _lase_, ्नीच,
   {{0x29090962,0x4427b5d9,0x2bb1809a,0x6609b5da}},	//   _ayaa_, _vin_, जाबा, plek,
   {{0x442f81e9,0x9f5c826f,0xf99f0247,0x9f4781a8}},	//   _tug_, vové_, blèm_, inní_,
   {{0x4427b5db,0x30750d91,0x2ec81d40,0x1c4485a8}},	//   _tin_, курс, रन्त, _анім,
   {{0x9f5c803e,0x44278f29,0x6aae81a8,0x25bd81b4}},	//   tové_, _uin_, óifí, _howl_,
   {{0xa3ae2a54,0xb9072261,0xf8bd800d,0x39468110}},	//   कास_, _ये_, ्नुप, ybos_,
   {{0x9f5c803e,0x2d9935dc,0x212d90e1,0xdb1c00e7}},	//   rové_, _case_, _ngeh_, _forê,
   {{0xa3c3835a,0x3dd20355,0x9f5c803e,0x7de8801b}},	// [22a0] _एका_, rhyw_, sové_, měst,
   {{0xdcea812b,0x61e635dd,0xfc3f0013,0x395f90f0}},	//   šiće, likl, _dtí_, _adus_,
   {{0xa3dc058c,0x63bc01ec,0x160fa0d5,0x6600a0e2}},	//   तोष_, _vorn, ातार_, yomk,
   {{0x3f9a35de,0x61e60255,0x629a00c3,0xfb1683de}},	//   _hapu_, nikl, _štos, ײַבט_,
   {{0x63bc35df,0xe8948ca0,0x6d5635e0,0xa927835f}},	//   _torn, таль, maya, ніше_,
   {{0x2d990f20,0x2d8035e1,0xdb03823e,0x644435e2}},	//   _zase_, lfie_, _anní, mpii,
   {{0xaade8105,0x3f9a1249,0xdb1c0168,0x61e635e3}},	//   _फेंक, _mapu_, _morë, kikl,
   {{0xceb30051,0x6d5635e4,0x442a0133,0xa3ae11bc}},	//   ריה_, naya, _hib_, काव_,
   {{0x442a35e5,0x61e635e6,0x18678073,0xd1758084}},	//   _kib_, dikl, _пати_, _шыры,
   {{0x6d5635e7,0x3a29059c,0x442a056c,0xb3469243}},	//   haya, _siap_, _jib_, diçõ,
   {{0x6d5602e8,0x78a435e8,0xd257804a,0x2ca002f1}},	//   kaya, _ariv, нця_, hvid_,
   {{0x442a35e9,0x6d5634c3,0x78a435ea,0x3e7a8168}},	//   _lib_, jaya, _briv, mët_,
   {{0x7dca003e,0x6d5635eb,0x3e7a820f,0x1ae700c8}},	//   _výsl, daya, lët_, _করছে_,
   {{0x442a35ec,0xf1b98024,0xb4be864a,0x78a435ed}},	//   _nib_, _viši_, ीनी_, _driv,
   {{0x2d990205,0x3a290057,0x2d802cbd,0x3e7a80f1}},	//   _pase_, _tiap_, ffie_, nët_,
   {{0x6d561efa,0x32538698,0xb3468073,0x78a40370}},	//   gaya, _свър, biçõ, _friv,
   {{0xf3670758,0x442a03ec,0x3e7a80f1,0xdb15026f}},	// [22b0] етен, _bib_, hët_, _vozí,
   {{0x442a35ee,0x3e7a820f,0x667200d7,0x7c2a8372}},	//   _cib_, kët_, دگیر, _jifr,
   {{0x442a02a3,0xdcebaf1e,0x6d5635ef,0x3e7a80f1}},	//   _dib_, _tagħ, baya, jët_,
   {{0x200335f0,0x799d35f1,0x6d5635f2,0x7de7810c}},	//   loji_, ndsw, caya, _mèsè,
   {{0x660d35f3,0x249f03a7,0x799d1989,0x7dda128a}},	//   mlak, _éum_, idsw, růst,
   {{0x660d35f4,0x61e61c37,0xdee584ae,0x442a35f5}},	//   llak, zikl, коли, _gib_,
   {{0xa3ae0d86,0x34c98bb8,0x3e7a8168,0xddd48088}},	//   कार_, िन्द, gët_, _šaši,
   {{0x442a0282,0x4ce280ab,0x660d35f6,0x4c85b5f7}},	//   _zib_, _পড়ু, nlak, влив,
   {{0x61e606be,0x442a022c,0xc8e00540,0x7c2a808b}},	//   vikl, _yib_, _पेंट, _bifr,
   {{0xad9b01fa,0xd7598b76,0x660d005d,0x20030803}},	//   _skúl, _آلات_, hlak, joji_,
   {{0x6d5635f8,0x7c2aabbe,0x27e7807b,0xa96a0e0b}},	//   yaya, _difr, minn_, мина_,
   {{0xe3b18bca,0x660d0024,0x27e7b5f9,0x3f9a355e}},	//   ارک_, jlak, linn_, _sapu_,
   {{0xeb8e9ddf,0x660d35fa,0x1a65819f,0x61e635fb}},	//   _ки_, dlak, ریکی_, rikl,
   {{0x20030db7,0x6d562b36,0xb34683a7,0x777703a8}},	//   goji_, waya, riçõ, _ccxx,
   {{0x6d5635fc,0xb34683a7,0xa3d686af,0x645d0711}},	//   taya, siçõ, _सतत_, _avsi,
   {{0x442a10af,0x660d221b,0x27e78046,0x799bb5fd}},	//   _sib_, glak, hinn_, _nauw,
   {{0xa3ae09a3,0x442a01c5,0x6d5635fe,0x27e7807b}},	// [22c0] काल_, _pib_, raya, kinn_,
   {{0x6d5635ff,0x442a0069,0xa3dc0063,0x80db3600}},	//   saya, _qib_, तों_, _যুক্,
   {{0x6d563601,0x442a0282,0x799bb602,0x81f7004e}},	//   paya, _vib_, _bauw, _سفیر_,
   {{0x442a0e60,0x5e570158,0x6e2b877f,0x6d5601b4}},	//   _wib_, _ביטע_, _nigb, qaya,
   {{0x442a01e9,0xf1b9a35d,0xf772803f,0x6d49b603}},	//   _tib_, _nišu_, لاغ_, dbea,
   {{0x27e7b604,0x3e7a80f1,0x6e2b8091,0xf09303c8}},	//   ginn_, tët_, _aigb, ינד_,
   {{0x61e400ce,0xf1b9826c,0xbcfb3605,0xd6cf80a0}},	//   _omil, _aišu_, _idéa, يقه_,
   {{0x3e7a88cf,0x6b9c3606,0x7c2ab607,0x2bca99e8}},	//   rët_, _harg, _sifr, िस्थ,
   {{0xb4be913d,0xb4cc81fe,0x6b9c3608,0xd3788289}},	//   ीने_, रने_, _karg, lići_,
   {{0x61e43609,0x69c0b60a,0xf1b98699,0x27e781e4}},	//   _amil, _home, _dišu_, cinn_,
   {{0x6d49b60b,0xd6c48bca,0xa3e3923a,0xa3c38006}},	//   bbea, _حمای, _नगर_, _एकर_,
   {{0x6b9c33fe,0xdb1c360c,0x3869b60d,0x6e2b8915}},	//   _larg, _coré, šare_, _gigb,
   {{0xdb151727,0xdb1c12b6,0x2d86810c,0xd3788140}},	//   _mozá, _doré, _iboe_, hići_,
   {{0x61e4360e,0x5ba38698,0xbcfb00f7,0xa3e1824c}},	//   _emil, _връз, _ndéa, नोद_,
   {{0x27ed003b,0xdd9b0791,0x660d360f,0x9e07035f}},	//   đen_, мша_, tlak, вчал,
   {{0xd378805c,0x2ba68beb,0x973c8115,0x59670081}},	//   dići_, _कोता, _inću, _ръка,
   {{0x660d14ff,0xa3ae00d4,0x629a3610,0x24580009}},	// [22d0] rlak, कां_, _štop, кать_,
   {{0x6b9c10dd,0xd3789487,0x39593611,0xfc3f0511}},	//   _carg, fići_, lass_, _cría_,
   {{0x6b9c3612,0x799bb613,0x69c0a170,0x656281d6}},	//   _darg, _pauw, _bome, _odoh,
   {{0x249f00fe,0xf99f06c0,0xf1b989d1,0xa11581a8}},	//   _šumu_, ndè_, _ništ_, هوات,
   {{0x27e7b614,0x69cb83b2,0xfc3f2a8c,0xa0698254}},	//   tinn_, rkge, _fría_, хала_,
   {{0x6b9c3615,0xd37882a5,0x628a806a,0xa3ae3616}},	//   _garg, bići_, _opfo, काः_,
   {{0x27e7b617,0x69c0b618,0x2bb18076,0x7dd586a5}},	//   rinn_, _fome, जासा, _láse,
   {{0x27e7b619,0x2ca6811f,0xf1b98024,0x69c0b61a}},	//   sinn_, _brod_, _pišu_, _gome,
   {{0x6d49b61b,0x9f478168,0x3f910102,0x6b9c02d0}},	//   rbea, ninë_, kezu_, _yarg,
   {{0x69c08a0f,0x6d4981e4,0xf1b980ce,0x249900ee}},	//   _zome, sbea, _višu_, _mssm_,
   {{0x39ea0ae7,0xdb1c0548,0x44211a29,0x42260193}},	//   едно_, _poré, imh_, лдов,
   {{0x9f4e003e,0x186a11d2,0x7dca03f2,0xceb280be}},	//   čník_, нами_, _výsk, _ליב_,
   {{0xc60f86b7,0xa91d8110,0x6fcb01ec,0xd37880d2}},	//   ातीय_, _pažy, _küch, zići_,
   {{0xaae4803d,0x3a2d81ed,0x66e6361c,0x2d9d867f}},	//   اسیو, _liep_, гога, _hawe_,
   {{0x2d9db61d,0xf7430098,0x66040bf0,0xcb5681c6}},	//   _kawe_, сесо, toik, _עסקה_,
   {{0xd3788052,0x2d9fb61e,0xa01b0019,0xed598088}},	//   vići_, ndue_, gtöb, naž_,
   {{0xd4671289,0x5baa03c7,0xb38607b6,0x6b9c361f}},	// [22e0] лите_, нкам_, ллал, _parg,
   {{0x69c0b620,0xd378812b,0x3ce68006,0x5eff00c2}},	//   _some, tići_, _जइसे_, _शुक्_,
   {{0x68fb87f4,0x69c0a39f,0x6b9c3621,0x63bc9252}},	//   _axud, _pome, _varg, örni,
   {{0xc693093f,0x6b9c3622,0x4421061f,0x2d9db623}},	//   _פאר_, _warg, amh_, _nawe_,
   {{0x2d922fca,0x17548c40,0x3a2d837a,0xd7e68d8e}},	//   meye_, авля, _diep_, ліко,
   {{0x6fcb02af,0x78a2816b,0x2d9d8032,0x69c0b624}},	//   _rück, rvov, _aawe_, _wome,
   {{0x6442b625,0x24803626,0xb4cc8a27,0xe8d901bc}},	//   _stoi, ltim_, रन्_, _ibụ_,
   {{0x2d922fca,0x225c026f,0xa3d686b7,0x25a03627}},	//   neye_, ávku_, _सतह_, ndil_,
   {{0x98a39e25,0x24803628,0xf74692b2,0x7c2e18d5}},	//   _лите, ntim_, _безо, _kibr,
   {{0x7c2e3629,0x320698b3,0x248002d5,0xdcef0669}},	//   _jibr, looy_, itim_, šeće,
   {{0x3f910052,0x8646b210,0x2d92362a,0x3f9e80b9}},	//   vezu_, _снеж, keye_, _iatu_,
   {{0x2480362b,0x7c2e3437,0xf6518117,0x2d9db62c}},	//   ktim_, _libr, _گئے_, _gawe_,
   {{0x7c2e0013,0x3f91007d,0x3f9e8a36,0x2480362d}},	//   _oibr, tezu_, _katu_, jtim_,
   {{0x3940026c,0x3f9eb62e,0x7d0686ae,0x3959362f}},	//   _efis_, _jatu_, üksu, sass_,
   {{0x6298803b,0xa3ae0697,0x2d9dafc0,0x39590687}},	//   _usvo, काई_, _yawe_, pass_,
   {{0xf99307bd,0x7c2e00f7,0x3f9e80eb,0xe8d90870}},	//   _طبع_, _aibr, _latu_, _abụ_,
   {{0x442e81cd,0x3b5528df,0x4421008e,0x7c2e0f3e}},	// [22f0] _kif_, икар, tmh_, _bibr,
   {{0x9f47820f,0x3f9eb630,0x7c2e3631,0x3a2d8299}},	//   rinë_, _natu_, _cibr, _siep_,
   {{0x06bf00c8,0x9f4780f1,0xa5bb0825,0x93880084}},	//   _উইকি, sinë_, _biót, ыста_,
   {{0xaca3019d,0x7dd5a6e7,0x9f47b632,0xd37880ce}},	//   _agụb, _másc, pinë_, miću_,
   {{0x3f9e9067,0x6d4d2339,0xd37881dd,0x9f47b543}},	//   _batu_, mbaa, liću_, liné_,
   {{0xdcfd0029,0x7c2e3633,0xf77191cc,0x764500f1}},	//   _lasī, _gibr, زات_, _kthy,
   {{0x45d598a0,0x3f9eaa6b,0xd378812b,0x3a2d8129}},	//   ицит, _datu_, niću_, _tiep_,
   {{0x6d4d02b5,0xb88681d0,0x442eb634,0x4465a341}},	//   nbaa, _sníž, _aif_, авив,
   {{0x851fb635,0x61eb8098,0xed598916,0x3f9eb636}},	//   मेंट_, migl, raž_, _fatu_,
   {{0x2d9dafc0,0x442e80fc,0xa5bb00f7,0x2d923637}},	//   _wawe_, _cif_, _fhóg, zeye_,
   {{0x629e9fc2,0x6d4d05f8,0xd378811f,0x6b600061}},	//   _špor, kbaa, jiću_, lágí,
   {{0xd3788024,0x9f47b638,0x78a9b639,0x61ebb63a}},	//   diću_, diné_, _krev, nigl,
   {{0x9f5c803e,0x20078006,0x6d5b8b99,0x6d4d329a}},	//   lová_, ooni_, maua, dbaa,
   {{0x2007b63b,0xd378812b,0x6d5bb63c,0xbcfb046d}},	//   noni_, fiću_, laua, _adéo,
   {{0xed5a00af,0x9f5c803e,0x2d92362a,0x9f47b63d}},	//   ков_, nová_, teye_, giné_,
   {{0x7bc38125,0x2007a7ce,0x38608289,0x78a9ace1}},	//   _honu, honi_, širi_, _orev,
   {{0x7bc3b63e,0x2007b63f,0x69d60065,0x2d922fca}},	// [2300] _konu, koni_, _ilye, reye_,
   {{0x2007b640,0x69aa05b3,0x9f5c827f,0x2d923641}},	//   joni_, _जोती, ková_, seye_,
   {{0x7f5c0e99,0xeb97228e,0x3f9eb529,0x24803642}},	//   marq, рих_, _ratu_, stim_,
   {{0x3f9e848f,0x22518efc,0xa96a8b26,0x6d5b8590}},	//   _satu_, ázky_, тида_, jaua,
   {{0x78a9b643,0x7c2e3644,0x386080f7,0xad9b026b}},	//   _crev, _tibr, éir_, _akúw,
   {{0x78a9a39f,0x7f5c1883,0x60000198,0x26170036}},	//   _drev, narq, tömy, nçon_,
   {{0x61ebb645,0x442eb646,0xd9109e29,0xd1768198}},	//   bigl, _rif_, _کیش_, _вызы,
   {{0x3f9e80f6,0x69d9b647,0xa3ae0076,0x69c413df}},	//   _watu_, chwe, काक_, _noie,
   {{0x3f9e8d4c,0x030b809a,0x20078dc4,0x2e3c007b}},	//   _tatu_, _सुबह_, boni_, _líf_,
   {{0x9f5c826f,0xa5bb00f7,0x2007b648,0x7dd58187}},	//   bová_, _thóg, coni_, _pásc,
   {{0x1fb584fa,0xbcfb3649,0x7bc3b64a,0x98a20085}},	//   _устр, _adél, _donu, dakı_,
   {{0xd378803b,0x644601dd,0x6d5bb19f,0x973c8b80}},	//   viću_, _otki, caua, _daće,
   {{0xa3e7000f,0x90980656,0x2b06b64b,0x7dd1364c}},	//   _बगल_, авят_, _सुरु_, _såso,
   {{0xd378a828,0x9f4780d7,0x9217141b,0x628e0fb0}},	//   tiću_, tiné_, _धीरज_, _opbo,
   {{0xc6a41980,0x69d62347,0x799f036e,0x6d4d364d}},	//   орти, _flye, _taqw, tbaa,
   {{0xd3788289,0x69c40102,0xcdd804ae,0x9f479ab3}},	//   riću_, _goie, ању_, riné_,
   {{0xdce6084a,0x6d4d0c11,0xf94a0158,0x2007b64e}},	// [2310] _bakı, rbaa, _געפֿ, yoni_,
   {{0x6d4d2023,0xd79500f7,0x69c400f3,0x3ceb016f}},	//   sbaa, _الدخ, _zoie, _घेणे_,
   {{0x644607d9,0x69d98234,0x6d4d0cfa,0xfc3f0511}},	//   _etki, thwe, pbaa, _trío_,
   {{0xf993803d,0x7dd8001b,0x9f5c816b,0x69c4002a}},	//   تبط_, _píse, vová_, _xoie,
   {{0xf99f009f,0x2d8b01c0,0x61ebb64f,0x98a5b650}},	//   llès_, _ibce_, rigl, силе,
   {{0x61ebb651,0x9f5c9c18,0x78a98390,0x6aaa8428}},	//   sigl, tová_, _vrev, _orff,
   {{0x44390bfa,0x2007b652,0x6d5b8b17,0xe61f001c}},	//   _hus_, roni_, taua, _khô_,
   {{0x7bc3b653,0x78a9b654,0x44393655,0x2007b656}},	//   _sonu, _trev, _kus_, soni_,
   {{0x7bc3b657,0x61e9b658,0xdce607d9,0x44393659}},	//   _ponu, _imel, _yakı, _jus_,
   {{0x4439146a,0xa3e18df4,0x7bc3b65a,0x395d9393}},	//   _mus_, नों_, _qonu, laws_,
   {{0x443910af,0x6449b65b,0x4431365c,0x2d8b21d5}},	//   _lus_, spei, _miz_, _obce_,
   {{0x4439023e,0xbcfb0032,0x3cfd81c5,0x6449b65d}},	//   _ous_, _adém, _txwv_, ppei,
   {{0x44390069,0x61e98133,0xc884817b,0x53a5802e}},	//   _nus_, _mmel, cağı_, _галб,
   {{0x7bdab3d6,0x6d598072,0x61fb8289,0x248f80b9}},	//   chtu, _hewa, _ljul, _ipgm_,
   {{0x4439365e,0xdb188117,0x6d59b65f,0x7dd5803e}},	//   _aus_, _tová, _kewa, _zása,
   {{0x25bf9ab3,0x443100eb,0xdce602d0,0x44393660}},	//   njul_, _aiz_, _sakı, _bus_,
   {{0x4431173c,0x6d59b661,0x44393662,0x2b580019}},	// [2320] _biz_, _mewa, _cus_, _perc_,
   {{0x44393663,0x61e9b664,0x6d598890,0xf1a9803d}},	//   _dus_, _amel, _lewa, یانه_,
   {{0x44393665,0x44310073,0x6fd0016d,0x479b03c8}},	//   _eus_, _diz_, _läck, _גייס,
   {{0x26173666,0x200a3667,0x29f88bcf,0xa3a80f12}},	//   nçol_, lobi_, rčao_, _खोर_,
   {{0x1cba030f,0x4fc68c07,0xc7c688cc,0x06e580c8}},	//   _صاحب_, йска, йски, _পুলি,
   {{0x161c023c,0x61e9b668,0x43751bdc,0x29f8826c}},	//   _भीतर_, _emel, _муст, pčao_,
   {{0x44393669,0x6d59b3fc,0xe0df01e8,0x2fc582d4}},	//   _zus_, _bewa, zzò_, _dolg_,
   {{0x443901e9,0x6d5980a4,0x6fd012d2,0x7dd58333}},	//   _yus_, _cewa, _bäck, _pása,
   {{0x6d598812,0x443901e9,0xbcfb026b,0xea010129}},	//   _dewa, _xus_, _adéj, _quậy_,
   {{0x6fd00106,0x9b588073,0x4431366a,0x249d8176}},	//   _däck, шиот_, _xiz_, _dswm_,
   {{0x66098fb0,0x51f900e8,0x200a328b,0x91fd01a9}},	//   boek, иною_, dobi_, krāt,
   {{0x6d59b66b,0x7bda89be,0xf2d300be,0x386081a1}},	//   _gewa, shtu, פער_, širu_,
   {{0x6e3ab66c,0xb4db046d,0xb87b01d6,0x63bca51d}},	//   _hutb, _afàn, dzíc, örns,
   {{0xa3a809a3,0x63ad80fc,0x3fe70264,0x03a38162}},	//   _खोल_, _ɗank, পক্ষ, _ничо,
   {{0x4439366d,0xd35b8bea,0x48e90074,0xe2468250}},	//   _sus_, _גדול, _चेरो_, _اختي,
   {{0x44310182,0x4439366e,0xdb0a823e,0x395d8282}},	//   _siz_, _pus_, _infà, xaws_,
   {{0xf1f800d5,0x71f80829,0x320b009a,0x44390069}},	// [2330] _دعوت_, _دروس_, mocy_, _qus_,
   {{0x66098a0f,0x6fd002af,0x200a010c,0x4439366f}},	//   zoek, _näch, cobi_, _vus_,
   {{0x6fb5003d,0x443101d0,0xe5350150,0x4439003d}},	//   _همکا, _viz_, _мень, _wus_,
   {{0x4439146a,0x7dd10022,0x6fcb0214,0x3f8c985b}},	//   _tus_, _måsk, _vücu, _abdu_,
   {{0x7dca027f,0x44390006,0x6d5f3670,0x9ccb01bb}},	//   _výst, _uus_, maqa, _сына_,
   {{0x644d0d17,0x6d5989ca,0x6fd000f2,0x6e3a8122}},	//   mpai, _sewa, _räck, _butb,
   {{0x2fc58b3c,0x7ac40056,0x6d599295,0x644d3671}},	//   _volg_, _есте, _pewa, lpai,
   {{0xa2d786ab,0x61e9b672,0x1c459017,0x59f98009}},	//   मनस्, _umel, оним, _тебя_,
   {{0x644d3673,0x22478b99,0x6609b674,0x386081a8}},	//   npai, _stnk_, roek, áirt_,
   {{0x7ff78277,0xdb1c12da,0xd2658ada,0x660981b0}},	//   _اسرا, _horá, окой, soek,
   {{0x62853675,0x6d598562,0xdb1c2792,0x78ad3676}},	//   ntho, _tewa, _korá, _arav,
   {{0x6fd0016d,0x7bc73677,0x249d8282,0x62850428}},	//   _täck, _loju, _tswm_, itho,
   {{0x200a046d,0x394d0e15,0x62850362,0xb915826b}},	//   tobi_, ñesa_, htho, _agbẹ_,
   {{0x34b283f8,0x2329b678,0x78ad011a,0xdbf18085}},	//   _آموز, _коли_, _drav, dəçi,
   {{0x200a3679,0x6285367a,0x443fb67b,0x61ef1c33}},	//   robi_, jtho, lqu_, bicl,
   {{0x63a3b67c,0x69dd0352,0x7dd58065,0xdd920b76}},	//   _hann, chse, _máso, بور_,
   {{0x63a3b67d,0x6285031d,0x13ea0048,0x7bc7367e}},	// [2340] _kann, etho, амай_, _boju,
   {{0x63a3b67f,0xad9b3680,0xa3e5103e,0x63bb0326}},	//   _jann, _skút, बोल_, _ɗung,
   {{0x63a3b681,0x3f9804b6,0xe29a2005,0x6d5f3670}},	//   _mann, meru_, рае_, baqa,
   {{0x63a3b682,0x63a50014,0xdb1c15a0,0x29f880c3}},	//   _lann, adhn, _corá, pčam_,
   {{0x92bc0a49,0xaca3819d,0x91a00129,0x7bc70032}},	//   েছে_, _blọk, _chỉ_, _foju,
   {{0x63a3b683,0x6d441f50,0x66163684,0x3f983685}},	//   _nann, lcia, llyk, neru_,
   {{0xdb1c01a8,0x62853686,0xd90d8019,0x9f9d026b}},	//   _forá, ctho, نیہ_, _dìè_,
   {{0x6d442d2a,0x26c08052,0x39428006,0x63a38c11}},	//   ncia, ćio_, _üks_, _aann,
   {{0x63a3b687,0x2249b688,0x6d443689,0x3f98368a}},	//   _bann, _čaka_, icia, keru_,
   {{0x69c28b3c,0x3f9800ce,0x63a39e68,0x7dd112c3}},	//   ljoe, jeru_, _cann, _påsk,
   {{0x61ef368b,0x1fb5b68c,0x69dd0168,0x2905080a}},	//   ticl, _эстр, thse, ğlam_,
   {{0x78ad368d,0x51f80190,0x63a3998d,0x6d44368e}},	//   _prav, жнюю_, _eann, jcia,
   {{0x63a3b68f,0x7dd59c18,0x3f983345,0xa3c3816f}},	//   _fann, _záso, feru_, _एकच_,
   {{0xa3ce81b6,0x3f983690,0x6560b691,0x7ddc80e7}},	//   _रवि_, geru_, lamh, _dése,
   {{0x9f340163,0xbcfb03a7,0x66163692,0x6d5f10ba}},	//   дері, _idéi, flyk, taqa,
   {{0x7dd5803e,0x78ad3693,0x63a390ed,0x24408247}},	//   _násl, _trav, _zann, _kòm_,
   {{0x63a3b694,0xad9b01ac,0x78ad3695,0x3f983696}},	// [2350] _yann, _skús, _urav, beru_,
   {{0x6d5f3697,0x644d0f31,0xdb1c0019,0x57f40198}},	//   saqa, rpai, _sorá, _опыт,
   {{0x644d3698,0xdd910013,0x61ed007a,0x5a35046e}},	//   spai, _كود_, _kmal, чнет,
   {{0x62850347,0x6d440098,0xfe9a00be,0xf1bf3699}},	//   rtho, ccia, _פירמ, zmán_,
   {{0x6d5d00eb,0x61ed0135,0x6285369a,0x660d09c4}},	//   _iesa, _mmal, stho, moak,
   {{0x6d5d369b,0x1da39513,0x940500d7,0x7dd5816b}},	//   _hesa, _खोजत, _روزه, _páso,
   {{0x63a3b69c,0x6d5d369d,0x7c3d3644,0xdb1c0207}},	//   _rann, _kesa, _husr, _torá,
   {{0x63a3b69e,0x3f98369f,0x6d5d2a81,0xbca580f7}},	//   _sann, zeru_, _jesa, كمبي,
   {{0x6d5d36a0,0x63a3b6a1,0xb4d58816,0x6e22b6a2}},	//   _mesa, _pann, सने_, _dhob,
   {{0x7ddc83d3,0x61ed36a3,0x443fb6a4,0x6d5d2890}},	//   _rése, _amal, rqu_, _lesa,
   {{0x63a3b6a5,0x443f82be,0xe8e10028,0x3f9810e8}},	//   _vann, squ_, _đều_, veru_,
   {{0x63a3b6a6,0x6d5d36a7,0xdb1c013c,0x3f9836a8}},	//   _wann, _nesa, _foræ, weru_,
   {{0x7c3d36a9,0x660d0359,0x63a3b6aa,0x6e298aa2}},	//   _nusr, doak, _tann, mmeb,
   {{0xf8a583f8,0x2bbb8307,0x69db9fd6,0x63a390ac}},	//   _یک_, _خاصة_, _llue, _uann,
   {{0x6d5d1a67,0x7c3d02af,0xa3b52342,0xaca40133}},	//   _besa, _ausr, झाई_, _mpụt,
   {{0xf06636ab,0x1c46268a,0x7c3501a9,0x29f88140}},	//   _екип, знам, _aizr, rčak_,
   {{0x6d5d36ac,0xdb1c00f1,0x3f9836ad,0x7c3d008e}},	// [2360] _desa, _korç, peru_, _cusr,
   {{0x6d4436ae,0x69db8364,0xe81b86a7,0x66160a64}},	//   scia, _alue, _पीला_, slyk,
   {{0x69c28901,0x8c1a8039,0xe29723d7,0x160b8beb}},	//   tjoe, צועי, зах_, हकार_,
   {{0x6d5d36af,0xf3f1aae3,0xaca40135,0x236a0122}},	//   _gesa, hị_, _apụt, _wdbj_,
   {{0xf5370051,0x2d82016d,0x6e2982f1,0xb4d586ae}},	//   _מרכז_, _icke_, dmeb, सनो_,
   {{0x56949269,0x6e949c8b,0xbcfb0091,0x2440b6b0}},	//   дакт, дику, _adéw, _ròm_,
   {{0xcf268013,0x6e22b6b1,0x69dba347,0x60168187}},	//   أرشي, _phob, _flue, nâmi,
   {{0xe9a39273,0x21a390ca,0x7c3d0359,0xade380e8}},	//   _пасп, _писм, _yusr, ецьк,
   {{0xdb1c007e,0x28168061,0xdcebb6b2,0x6560b6b3}},	//   _borç, _فورس, _bagı, ramh,
   {{0x46a68554,0x6560b6b4,0x61ed0039,0xa01b0009}},	//   _назв, samh, _smal, ttöm,
   {{0xe9df0013,0x6e2289ef,0x9f5c81d6,0xbeaa80d7}},	//   thú_, _thob, kovú_, _دهان_,
   {{0x39469313,0xdb03803d,0x26170214,0x7d028102}},	//   ncos_, _manè, rçok_, _txos,
   {{0xdb1c2670,0x39468c52,0x7dd801d0,0x9ac481b9}},	//   _forç, icos_, _písn, _suċċ,
   {{0x6d5d355e,0x92578077,0xdc378158,0xa5bb36b5}},	//   _sesa, _کشور_, _זאגט_, _chón,
   {{0x6d5d36b6,0x7c3d003a,0x9f4a0388,0x660d36b7}},	//   _pesa, _susr, cibí_, toak,
   {{0x61ed3496,0x442303ac,0x42fb8039,0xe1ab8beb}},	//   _umal, _shj_, _להוס, _घोंघ,
   {{0x394936b8,0x660d36b9,0x7bcab6ba,0x7bdc05ee}},	// [2370] _ifas_, roak, _kofu, _blru,
   {{0x3f8104cd,0x6e991b2f,0x3946b6bb,0xdd9985b9}},	//   _uchu_, _двор_, ecos_, zeň_,
   {{0xaadc85b3,0x386936bc,0xdb580198,0xdd0c0035}},	//   मनिक, _hvar_, яют_, góło,
   {{0xd13191cc,0x61fd36bd,0x38690687,0x23c8801b}},	//   نما_, nnsl, _kvar_, ाउँद,
   {{0xdd99803e,0x8fa587ff,0x92bd00ab,0x07a5b6ab}},	//   veň_, дале, ইনে_, далн,
   {{0x25a92b24,0xb4d903db,0x7bcab14f,0x443d8bfd}},	//   ldal_, ़नी_, _nofu, _ruw_,
   {{0x24890065,0x9f478216,0x6446808b,0x5692aba7}},	//   ltam_, giná_, íkin, вајт,
   {{0x96270341,0x5334013a,0x25a936be,0x25a68c41}},	//   _uzņē, _чест, ndal_, _caol_,
   {{0x248936bf,0xf1bf1bd9,0x7dd5807b,0xea0000ff}},	//   ntam_, rmál_, _hásk, _ngại_,
   {{0x63a72ce4,0x320f8051,0xdd99826f,0x394936c0}},	//   _jajn, logy_, seň_, _afas_,
   {{0x25a936c1,0xdd99816b,0x3ed58f99,0x395f81ed}},	//   kdal_, peň_, _تقار, _keus_,
   {{0x77638a2b,0x25a68c41,0x67219351,0xaca3026b}},	//   lanx, _gaol_, _izlj, _afọb,
   {{0x7dd5803e,0x395fb6c2,0xb87b0019,0xa5bb001c}},	//   _lásk, _meus_, szín, _phón,
   {{0x63a736c3,0x0c24835f,0x7dd800e1,0x24890019}},	//   _najn, _змін, _píso, dtam_,
   {{0x16a70381,0xe73715fe,0x386906ab,0xe7e58074}},	//   мври_, дер_, _evar_, _कतना_,
   {{0x200eb6c4,0xcb128039,0x601683a7,0x26138187}},	//   zofi_, _שלה_, râmi, mãos_,
   {{0x224d003b,0x39a681e2,0x63a70019,0xdb038077}},	// [2380] _čeka_, _jūsų_, _bajn, _sanè,
   {{0x39a681e2,0x6721b6c5,0xafdb0aa2,0x78a436c6}},	//   _mūsų_, _ozlj, spør, _isiv,
   {{0xe72a198c,0x395f8580,0xea010129,0x7ddc810c}},	//   _фонд_, _beus_, _quầy_, _lésa,
   {{0xfc3f0216,0x395f8362,0xbcfb0580,0xa01b062c}},	//   _fuí_, _ceus_, _adéu, ytök,
   {{0x395fb6c7,0x5fd20063,0x63a7009a,0x18678991}},	//   _deus_, _हवाल, _fajn, дачи_,
   {{0x25a680f7,0x63a736c8,0xb03380e8,0x2cad99dc}},	//   _saol_, _gajn, вніш, dved_,
   {{0xc7b88028,0xdb1c016d,0x69d880f1,0x61fd2496}},	//   _vnđ_, _borå, ëves, ynsl,
   {{0x746a8153,0x443836c9,0x395fb6ca,0x200eb6cb}},	//   оров_, _hir_, _geus_, sofi_,
   {{0x61e2b6cc,0x6f0d8380,0xd49a804a,0x6fd487f1}},	//   mhol, ğaca, іри_, _làci,
   {{0x5f76845b,0x1b2100ab,0x61e28a33,0x7ddc80e7}},	//   _زائر, _বলতে_, lhol, _désa,
   {{0x38690082,0x443836cd,0x33770039,0xc7b384de}},	//   _svar_, _mir_, ועים_, _שבע_,
   {{0xc333078d,0x61e2835f,0x443836ce,0xdd8f80f7}},	//   כות_, nhol, _lir_, _نوم_,
   {{0x7dd104b8,0xdd8f8bca,0x2ca00239,0x443801e4}},	//   _måst, _خون_, jwid_, _oir_,
   {{0x44380609,0x7dd103a6,0x61e2b6cf,0x7522b6d0}},	//   _nir_, _låst, hhol, _izoz,
   {{0x38c5020f,0x61e2805d,0xe61300f7,0x63a736d1}},	//   _bërë_, khol, نشر_, _rajn,
   {{0xe81f058c,0x2d8036d2,0x443836d3,0x24890019}},	//   _मीरा_, ggie_, _air_, ttam_,
   {{0x443836d4,0x61e2813c,0x395f809f,0xb4d9009a}},	// [2390] _bir_, dhol, _reus_, ़ने_,
   {{0x395f907f,0x3f9c8fda,0x7dd5b6d5,0xd838886f}},	//   _seus_, jevu_, _pásk, _nič_,
   {{0x443836d6,0x248936d7,0xe1ff1726,0x395f823e}},	//   _dir_, stam_, onó_, _peus_,
   {{0x7c38b6d8,0x201136d9,0x443836da,0x660296f2}},	//   _livr, lozi_, _eir_, _njok,
   {{0x7b67025d,0x63a7003a,0x386980f7,0x395f8722}},	//   _отве, _tajn, éar_, _veus_,
   {{0x187c0039,0x4438035f,0x7c38826c,0x48e080ab}},	//   קטוב, _gir_, _nivr, বপূর,
   {{0x776384c3,0x395fb6db,0x260b86bf,0xa3a80075}},	//   ranx, _teus_, ावली_, _खोट_,
   {{0x61e2b6dc,0x442c8fb0,0xd5b18872,0xdcef08c5}},	//   chol, emd_, افظ_, _hacı,
   {{0x201120d7,0xd83881a1,0x6012006a,0x316036dd}},	//   kozi_, _fič_, kæmp, _reiz_,
   {{0x7dd58019,0x2cad8039,0x3f9c8699,0x9f9d026b}},	//   _mási, rved_, cevu_, _bìí_,
   {{0x656f2158,0xd24e8416,0x7dd8209c,0xb81b8035}},	//   _odch, ینی_, _sísm, _पीएम_,
   {{0x7dd8026f,0x66028168,0x644f05f3,0x69c6022c}},	//   _písm, _gjok, _otci, ujke,
   {{0x764197ea,0x7dd5816b,0x65640009,0x26170187}},	//   _huly, _nási, vaih, nçou_,
   {{0x201136de,0x661ba818,0x6d49b6df,0x60c4956e}},	//   gozi_, lluk, lcea, äimi,
   {{0x442782af,0x66e61bc1,0xdee60b9c,0x443836e0}},	//   _ihn_, хова, хови, _rir_,
   {{0x7dd59313,0xa3a80fea,0x7641b6e1,0xd24e80f7}},	//   _bási, _खोज_, _muly, _اني_,
   {{0x20110578,0x656436e2,0xfce3023f,0x91fd00eb}},	// [23a0] bozi_, raih, гото, ksāj,
   {{0x9f9d0324,0xfc3f00f7,0x661b829b,0x085704de}},	//   _yìí_, _arís_, hluk, _רבים_,
   {{0x44382674,0x7dd10bfa,0xdb1c01ac,0x442782f7}},	//   _vir_, _påst, _horú, _mhn_,
   {{0x443836e3,0x3f85b6e4,0xceb302f6,0x2a6a8019}},	//   _wir_, _aclu_, _עיר_, ábbi_,
   {{0x443806f6,0x61e2805f,0xdb1886c4,0x3f9cb6e5}},	//   _tir_, rhol, _envè, tevu_,
   {{0x6602b6e6,0x7641b6e7,0x442c06c0,0x998d81d6}},	//   _sjok, _buly, _òd_, _vieš_,
   {{0xfc031f25,0x7dd5826f,0x6996b6e8,0x3f9cb6e9}},	//   _спро, _zási, _прах, revu_,
   {{0x661baf08,0x291e009a,0x3f9c8267,0x69d98252}},	//   gluk, ętaj_, sevu_, ckwe,
   {{0x09e38e02,0xb4da8105,0x7bce36ea,0xdb188187}},	//   _сотн, ठने_, _kobu, _invé,
   {{0x7bce0087,0x8afe89ab,0x236580c3,0x3ea9866f}},	//   _jobu, _leƙe, galj_, łata_,
   {{0x7c3880e7,0x76419fce,0x7bce36eb,0x442c80f3}},	//   _vivr, _guly, _mobu, rmd_,
   {{0x7982b6ec,0x225c003e,0x6136880a,0x7bce0234}},	//   ngow, ávky_, _gülü, _lobu,
   {{0x20110423,0x23658904,0xe3b2803d,0x799d1e26}},	//   tozi_, balj_, _مرغ_, resw,
   {{0xb8c90d38,0x644fa6e1,0x2ca68114,0x799d2e4d}},	//   _गई_, ície, _isod_, sesw,
   {{0x201100b4,0x7a3e8084,0xe28f81a8,0x6e942f7d}},	//   rozi_, _būte, _هذي_, лиру,
   {{0x63aaa8b8,0x201136ed,0x34952f02,0x2365026c}},	//   _hafn, sozi_, кабр, _žlj_,
   {{0x7dd836ee,0x7bce36ef,0xbcfb046d,0x3a29033e}},	// [23b0] _získ, _bobu, _adér, _ihap_,
   {{0x63aa8125,0xdce0b6f0,0x6442b6f1,0x7bce0c4d}},	//   _jafn, jamč, _muoi, _cobu,
   {{0xa0360039,0xbb8401a8,0x29d782d0,0x9f8f02f1}},	//   _שאתה_, المي, _uçak_, _müü_,
   {{0x6562b6f2,0xcb1380be,0x9f58007b,0x7ae582f1}},	//   _neoh, אלע_, lorð_, _ühte,
   {{0xf9940039,0x7641b6f3,0x69d99699,0x661b817f}},	//   טרף_, _suly, rkwe, vluk,
   {{0x69d9b6f4,0x6298837a,0x63aa807b,0x3f83008b}},	//   skwe, _opvo, _nafn, ngju_,
   {{0x23658390,0x628b0493,0x5f05847f,0x9f47862c}},	//   valj_, ăgos, ъзка, vinä_,
   {{0xceb40158,0x7ddc82be,0x7bce36f5,0x9f5c816b}},	//   ריק_, _déso, _zobu, mový_,
   {{0x661b8867,0x2365b55d,0xa5bb0c52,0x9f5c826f}},	//   rluk, talj_, _dióx, lový_,
   {{0x6d4980f7,0x1a65815b,0xe50203eb,0x9aa40019}},	//   scea, نیتی_, लपति_, _جمہو,
   {{0x386db20d,0x9f5c826f,0xb17b0aa2,0x261726e1}},	//   _hver_, nový_, rhån, nços_,
   {{0x999880eb,0x3a2936f6,0x186a0a7c,0x2365817f}},	//   _kurš_, _chap_, мами_, salj_,
   {{0x4427810b,0x9f5c816b,0x2365817f,0x9f9d026b}},	//   _thn_, hový_, palj_, _bìà_,
   {{0xb4bf835a,0x9f5c83fb,0x29f896f2,0xb4cd816f}},	//   ीही_, kový_, nčar_, रही_,
   {{0xfaa5a64e,0x9f5c816b,0x248db6f7,0x91a000ff}},	//   _райо, jový_, ltem_, _thì_,
   {{0x386d8051,0x9f5c826f,0x98be0214,0x63bc36f8}},	//   _over_, dový_, ştı_, _snrn,
   {{0xd4670381,0x248db6f9,0x9f58008b,0xb38622d0}},	// [23c0] ките_, ntem_, borð_, клал,
   {{0x7dd836fa,0xeafa0250,0x248db6fb,0x2d9f8a53}},	//   _mísi, ورات_, item_, heue_,
   {{0x386d8098,0xdb1c077f,0x66e636fc,0xb4cd8074}},	//   _aver_, _yorù, _рона, रहु_,
   {{0x7ddcb6fd,0xdb18803e,0xe9da80e8,0x248db6fe}},	//   _réso, _nový, ьке_, ktem_,
   {{0x80be8540,0xe8949663,0xe0e080ab,0x7bce36ff}},	//   ्हें, уаль, বপ্ন, _tobu,
   {{0xdfcf8624,0x248db700,0x6562a6ac,0x9f5c8a21}},	//   يين_, dtem_, _seoh, bový_,
   {{0x6fdd809f,0x386d8039,0x2480051e,0x973c8b80}},	//   _tècn, _ever_, luim_, _jaći,
   {{0x5f168076,0x752601c0,0x25a0051e,0x442a008e}},	//   _पुण्_, _kzkz, neil_, _hhb_,
   {{0xc5f30051,0x6442838f,0xdb01865d,0x3a2902c4}},	//   ידה_, _quoi, ndlæ, _rhap_,
   {{0x32020038,0x7c3c04b7,0x660db701,0x25a03702}},	//   enky_, _jirr, čaka, heil_,
   {{0xe9f921d2,0x0d8682a9,0x5a351508,0x37ba00ab}},	//   енні_, _ален, лнот, ুসার,
   {{0xcb1304de,0x973c80fe,0x39400db1,0x91a0027d}},	//   ילת_, _naći, _cgis_, _phí_,
   {{0x386d3703,0x6abf016f,0x248d87f1,0x9f5c816b}},	//   éer_, _एप्र, ctem_, zový_,
   {{0x24803704,0x7c3c3705,0xdb1c03ba,0xd7c900d7}},	//   duim_, _nirr, _forø, روزه_,
   {{0x88cb00ab,0xbcfb046d,0x973c8140,0x1af080ab}},	//   _লেখক, _adép, _baći, _ঘুরে_,
   {{0x32538098,0x9f5c826f,0x25a001e4,0x7c3c0362}},	//   _твър, vový_, geil_, _airr,
   {{0x80be8063,0x443cb706,0x7c3c3707,0x38600428}},	// [23d0] ्हों, _kiv_, _birr, _gwir_,
   {{0x9f5c803e,0x7c3c3708,0x6fdd8722,0x442a01a1}},	//   tový_, _cirr, _rèco, _chb_,
   {{0x443cb709,0x20031487,0x7dd5816b,0x248d8019}},	//   _miv_, mnji_, _zásu, ztem_,
   {{0xe7e581fe,0x443ca253,0x261707e0,0x973c81dd}},	//   कसभा_, _liv_, rços_, _gaći,
   {{0x7dd5b70a,0x9f5c826f,0xdfd58d55,0x851e8054}},	//   _mást, sový_, лоды, _परगट_,
   {{0x443cb70b,0x7dd581ca,0x6e3d00fc,0x9f5c84e8}},	//   _niv_, _lást, _hisb, pový_,
   {{0x6e3d370c,0x4e9580f7,0xf1a7828b,0x7645008e}},	//   _kisb, اشتر, _иран, _juhy,
   {{0x7dd5803e,0x248d8065,0x26c9805c,0x069680f7}},	//   _nást, ttem_, ćao_, انية_,
   {{0x6e3d370d,0x31348596,0xb17b00f2,0xa5bb0013}},	//   _misb, _ветр, rhål, _chói,
   {{0x7dd80125,0x200302a5,0x248db70e,0xb17b016d}},	//   _vísi, jnji_, rtem_, shål,
   {{0x7d1d00f2,0x1603015c,0x17f880f7,0xdb03b70f}},	//   _lyss, रचार_, _شركة_, _taní,
   {{0x64b592dc,0x6e3d3710,0x2b4e8326,0x61f982c4}},	//   _محتر, _nisb, _effc_, niwl,
   {{0x6d5b9a67,0x443cb711,0x25a01aab,0x6fd4823e}},	//   mbua, _fiv_, veil_, _tàct,
   {{0x443c813c,0x291e00eb,0x2a6c8101,0x75fe80eb}},	//   _giv_, āta_, bsdb_, vīzi,
   {{0x66e31ad2,0x25a03712,0x6e3d3713,0xdee33714}},	//   бора, teil_, _bisb, бори,
   {{0x64a60972,0x443c82a5,0x7dd58207,0x7c3c1037}},	//   лаба, _ziv_, _gást, _sirr,
   {{0x29050459,0xa3d78768,0x25a03715,0xb4de3716}},	// [23e0] şlar_, _सवा_, reil_, तने_,
   {{0x7dd585b9,0xfc3f00f7,0x25a001e4,0x24803717}},	//   _zást, _tsín_, seil_, ruim_,
   {{0xdb0a8980,0x764509c4,0x7c3c3718,0x1bf683de}},	//   _cafè, _guhy, _virr, נצער_,
   {{0x00e69508,0x7cda01a9,0xaa570290,0x067b03de}},	//   лжен, _pārā, النا_, _אנטל,
   {{0xb4cd8076,0x66043719,0xd9178160,0x7c3c01b9}},	//   रहो_, mnik, льш_, _tirr,
   {{0x6604371a,0x6281b71b,0x63a182a5,0xeeaa8e8e}},	//   lnik, kulo, jeln, етик_,
   {{0x63a1b71c,0x69dd0009,0xdb01816d,0x656615bd}},	//   deln, ykse, ndlä, _kekh,
   {{0x443c90af,0x5c749537,0x6604371d,0x6e3d02a3}},	//   _siv_, алит, nnik, _xisb,
   {{0x69c08511,0x443c81c5,0xa3e8023c,0x600a8ae7}},	//   _inme, _piv_, _बता_, _знам_,
   {{0xda7ab71e,0x644601d3,0x644fa363,0x61e4371f}},	//   ням_, _muki, ícia, _alil,
   {{0xd00f803f,0x66043065,0x443cb720,0x64463721}},	//   _علم_, knik, _viv_, _luki,
   {{0x69dd0364,0x15469445,0xa01b0009,0xe1350198}},	//   ukse, _седм, ytös, инны,
   {{0x20030024,0x443c81c5,0x644604b9,0x5c568139}},	//   tnji_, _tiv_, _nuki, _стеф,
   {{0x6281b722,0x53348adb,0x7d1d3723,0x3cff0110}},	//   bulo, _келт, _ryss, _žuvo_,
   {{0x6281b724,0xd5bb3725,0x64463726,0x9f3500e8}},	//   culo, нса_, _auki, реві,
   {{0x20030052,0x5d551182,0x7d1d1a50,0x660407f6}},	//   snji_, ркат, _pyss, gnik,
   {{0xd37b1860,0x6e3d03ab,0xf99000f7,0x8f55003d}},	// [23f0] ече_, _visb, _ربي_, _پنجش,
   {{0x69c0b727,0x644604b9,0x6d4d3728,0x926b2133}},	//   _anme, _duki, scaa, ерда_,
   {{0x66040db7,0xdb038e93,0x63ae0282,0x973c990f}},	//   bnik, _kaná, _dabn, _kaću,
   {{0xdb0ab729,0x6d42801c,0x5fc32bef,0x629c372a}},	//   _café, _ngoa, शावल, _dpro,
   {{0x79c989a7,0x60168087,0x601f8187,0x644600b4}},	//   _یوسف_, tâmp, lêmi, _guki,
   {{0x629c002a,0x3d18800f,0x69c0b72b,0x244981fa}},	//   _fpro, _पड़े_, _enme, _rúm_,
   {{0x6d5b8201,0x64460267,0xd3440019,0x0f5801c6}},	//   tbua, _zuki, _اہمی, ניהם_,
   {{0x660d8353,0x9f580168,0x78a9822c,0x9f4100e1}},	//   čako, tirë_, _tsev, _dlhé_,
   {{0x63a1b72c,0x6d5bb72d,0xa787815b,0x78a9b72e}},	//   teln, rbua, _مشاو, _usev,
   {{0x6281b72f,0xdb18840e,0x66043730,0x6619861b}},	//   tulo, _enví, znik, _wkwk,
   {{0x4fc4a344,0xdb038c83,0x212900b9,0x3b098ae7}},	//   _уста, _baná, _azah_, тено_,
   {{0x63a1b731,0x66040085,0xd9f780d4,0x601f8187}},	//   seln, xnik, ूचित_, dêmi,
   {{0x7dd8000d,0x63a1b732,0x628182e8,0x3d04009a}},	//   _míst, peln, sulo, _रखें_,
   {{0x66040063,0x64462fc0,0x7dd8026f,0xdb0380f7}},	//   wnik, _ruki, _líst, _eaná,
   {{0x316b0063,0x09e62e7b,0x656600b9,0xdb070144}},	//   bacz_, _войн, _pekh, _bají,
   {{0xe9df01ac,0x260b897d,0x290d8118,0xdb038216}},	//   ckú_, ावटी_, _oxea_, _ganá,

   {{0xab66045d,0xf1bf0c83,0xa01b1e2b,0xddd880d2}},	// [2400] ивал, rmát_, rtör, nuvš,
   {{0x66040668,0x6446042b,0x629c01b9,0x68200019}},	//   snik, _vuki, _ppro, ködi,
   {{0x66043733,0x65660101,0xb1468dc0,0x877b025f}},	//   pnik, _tekh, анел, _באיי,
   {{0x20183734,0x64463735,0xfc48801c,0x2d9606f1}},	//   lori_, _tuki, _lửa_, _трос,
   {{0x4fc691b3,0x629c009a,0x67450177,0x9f513736}},	//   иска, _wpro, _átjá, lizá_,
   {{0xdb07000d,0x20183737,0xfc48801c,0x63bb00fc}},	//   _zají, nori_, _nửa_, _ɗunk,
   {{0x46678fe6,0x7ddc80e7,0xb76580e8,0xa5f888ed}},	//   арым_, _hési, стій, леку_,
   {{0xd5b79fc8,0x20180114,0x9fa3808b,0x7dd58333}},	//   ась_, hori_, síðu_, _básq,
   {{0xad9b007b,0x644000e7,0x22478144,0x5f16b738}},	//   _sjúk, _émis, _aunk_, _पुर्_,
   {{0xfc488028,0x20180ff5,0x6609005c,0x60e8880a}},	//   _cửa_, jori_, čeki, ırmı,
   {{0xb4db0028,0x20183739,0x91fd00eb,0xa6ca80f7}},	//   _ngàn, dori_, ksāt, _جوال_,
   {{0x7dd807d0,0xd49ab73a,0xdb1c0fba,0x05838d9e}},	//   _míss, _арк_, _horó, _душм,
   {{0xfbcf87d2,0x7648b73b,0x245481ad,0x291f81c0}},	//   ستی_, _hudy, _انتس, _xyua_,
   {{0xb7f88aed,0xd7fb0a3d,0x7a2382f1,0xe9df01d6}},	//   ्चिम_, тум_, võtm, skú_,
   {{0xdb038019,0x62351182,0xdb1c349a,0x5f1a0fb2}},	//   _taná, _леку, _moró, _मुद्_,
   {{0x3c2b83ba,0xdb188580,0x5d78062c,0x2367b73c}},	//   røve_, _invà, ийся_, _zenj_,
   {{0x20180503,0x22a80214,0x44210f3e,0x409500f7}},	// [2410] bori_, _aşk_, tlh_, _الخر,
   {{0x7ddc82be,0x3a3f808e,0x2018373d,0xdb0e003d}},	//   _dési, _siup_, cori_, _kabè,
   {{0x24848122,0xa5bb01a8,0x442989ab,0x3a2d8129}},	//   humm_, _bhót, _ɗa_, _phep_,
   {{0x29d78380,0x32191122,0xf54f019d,0xe1f0ab7e}},	//   _açar_, nosy_, _rụwa_, وسن_,
   {{0x7dd812ca,0xdce28088,0xe80e03b7,0x245d026b}},	//   _víst, _beoč, _सदमा_, _dámò_,
   {{0xf77185ff,0x656d373e,0xab8411b3,0x7648809a}},	//   سات_, laah, _муск, _budy,
   {{0x3a3f8359,0x212981ac,0xfc4880ff,0x61fd373f}},	//   _tiup_, ťah_, _rửa_, kisl,
   {{0xfc488028,0x61fd3740,0x798d0069,0x644fb741}},	//   _sửa_, jisl, _ncaw, ício,
   {{0x442e8267,0x628515d0,0x20183742,0x22400074}},	//   _bhf_, luho, yori_, _riik_,
   {{0x53c982de,0x63a502d4,0x656d3743,0x7dd58216}},	//   угом_, nehn, haah, _vásq,
   {{0xa96a013a,0x216a17c8,0xae7880e8,0x656d3744}},	//   лина_, лини_, _всіх_, kaah,
   {{0xdb038073,0x656d0079,0x442e807b,0x6fdd8036}},	//   _lanç, jaah, _ehf_, _sèch,
   {{0xeb9998a0,0x63c281d0,0x799bb745,0x91ba81c6}},	//   _бил_, ávní, _mbuw, אמרי,
   {{0x7ddc82be,0xd91a8039,0xb4e39344,0x7648808e}},	//   _rési, רושל, ननी_, _yudy,
   {{0x799bb746,0x20183747,0x6729000d,0xe2998162}},	//   _obuw, rori_, řejn, _сай_,
   {{0xfbdf001c,0xbb3a80be,0x7ddca848,0xa2c4852a}},	//   _quên_, _געצי, _pési, िमर्,
   {{0xbddb00e7,0xfd6481bc,0x7bd50214,0xdb18b748}},	// [2420] _sièc, _agwụ, _bozu, _invá,
   {{0xbddb03d3,0xdb0391dd,0xdb0e3749,0x9f860cf9}},	//   _pièc, _canç, _habé, _угод,
   {{0xfe721168,0xb87b0065,0xe5a6134e,0x69c41254}},	//   _عدد_, szít, _лини, _knie,
   {{0x69d6374a,0xed360162,0xc8b50065,0x3eb809d1}},	//   _joye, _гэгэ, _الیک, mvrt_,
   {{0x69d602be,0x7bc3838a,0xdb1c374b,0x69c4009a}},	//   _moye, _onnu, _poró, _mnie,
   {{0x6e241a5a,0xa09b010f,0x6285374c,0x2bc9374d}},	//   llib, ריסט, buho, राणा,
   {{0x2291b74e,0x3eb8007a,0x78bb8144,0x7ddc87f1}},	//   ják_, nvrt_, _eruv, _mésv,
   {{0x7bc3b74f,0x5454b750,0x61fd04c3,0xfbc90ebf}},	//   _annu, овит, xisl, राथम,
   {{0x61fd003e,0xdce28267,0xf1c3801b,0x61e28e3a}},	//   visl, _teoč, šší_, mkol,
   {{0xb274b751,0x248001a8,0xf54f01bc,0xd4978a14}},	//   олош, irim_, _hụta_, ёры_,
   {{0x61fd0038,0x24803752,0x441b00be,0x69d63753}},	//   tisl, hrim_, רויס, _boye,
   {{0x14c83754,0x7bc3b755,0x61e2b756,0xd46a80a9}},	//   रमाण, _ennu, nkol, _биде_,
   {{0xdca3b714,0xf54f0135,0xdce60609,0x682d81d6}},	//   _наци, _mụta_, _dekċ, súde,
   {{0xdb018019,0x656d0870,0xd7f810bc,0xb8d11664}},	//   zelé, waah, бус_, _ऐन_,
   {{0x61e2b757,0x7bd5185c,0xdb0a8247,0xf40000ab}},	//   kkol, _rozu, _enfò, ্তার_,
   {{0x6e243758,0xbcfb0019,0x9f47816b,0x78ad3759}},	//   glib, _idéz, diný_, _tsav,
   {{0x63a5375a,0x656d02a3,0x7bd50085,0xdb018019}},	// [2430] tehn, raah, _pozu, velé,
   {{0xe1ff1362,0xa5bb01a8,0x6285375b,0xdb1c2509}},	//   lió_, _chór, tuho, _enrí,
   {{0xa6ab0b76,0xe7c7809a,0xdb018019,0x7bd50267}},	//   _صادق_, लासप, telé, _vozu,
   {{0xe1ff07e2,0x201eb75c,0x78bbb75d,0x61e2a476}},	//   nió_, _akti_, _pruv, gkol,
   {{0x7bd51ccc,0xdb018019,0x3ea1008e,0xb97c03c8}},	//   _tozu, relé, _hpht_, רנדי,
   {{0xf2e7119d,0x66090289,0x7e55988f,0x22918061}},	//   _любо, čeku, отиц, yák_,
   {{0xb7dc00be,0xdb0187bc,0xdddc0b80,0x7ddc810c}},	//   רקוי, pelé, lurš, _lésu,
   {{0x649982a4,0x2291a8e5,0xec79b408,0x91a90129}},	//   атор_, vák_, апи_, _nhà_,
   {{0xe1ff375e,0xb4e3809a,0x61fbb75f,0x13e9b760}},	//   dió_, नने_, _imul, имий_,
   {{0x69c43761,0x69d600e7,0x2291a792,0xdb0e3762}},	//   _snie, _soye, ták_, _sabé,
   {{0xd5ae8077,0xab298470,0xe299911c,0x645bb27d}},	//   رفی_, рона_, шан_, spui,
   {{0x5ed280c8,0xe1ff3763,0xbba60540,0x27fa0101}},	//   _থেকে, gió_, _ऑस्क, _smpn_,
   {{0x69d63764,0x9f45b765,0x776e011c,0x2291a792}},	//   _voye, _allé_, tabx, sák_,
   {{0xa2e58193,0x3eb8025b,0x61e9802a,0x61e2b766}},	//   _молд, tvrt_, _llel, zkol,
   {{0x61fb8c56,0xe1ff00ab,0xdb1c0125,0x7f430e86}},	//   _omul, bió_, _norð, держ,
   {{0xe1ff3767,0x6609b768,0x644b8578,0x69c40905}},	//   ció_, nnek, _kugi, _unie,
   {{0x656bb769,0xb87b0065,0x6e240057,0x644b81a1}},	// [2440] _megh, szír, rlib, _jugi,
   {{0x9f580013,0xdb070065,0x644bb76a,0x61fbb76b}},	//   oirí_, _sajá, _mugi, _amul,
   {{0x44258224,0x9d460256,0x661ba3e4,0xf54f0135}},	//   ill_, _менд, kouk, _pụta_,
   {{0xa9268381,0x661b8198,0x2480376c,0x660981a1}},	//   одел, jouk, prim_, jnek,
   {{0x61e2b76d,0x7642810c,0x9f5c936f,0xdce60af8}},	//   rkol, _rioy, livé_, _kekč,
   {{0x61e98135,0x6609811b,0x2d9d838a,0x6443b76e}},	//   _elel, enek, _abwe_, _nini,
   {{0x644b8110,0x98a38084,0xfe6fa1df,0x656b80e5}},	//   _augi, _ąją_, ندي_, _begh,
   {{0x9343035f,0x644bb76f,0x6443b770,0x4425b771}},	//   _інте, _bugi, _aini, ell_,
   {{0x6443b772,0x656bb773,0xe1ff06a5,0x644bb2a3}},	//   _bini, _degh, vió_, _cugi,
   {{0x7ddc83d3,0x644b811f,0x6443b774,0xa2f480e8}},	//   _résu, _dugi, _cini, зпоч,
   {{0xe1ff05a4,0x661bb775,0xe3b88214,0x3eb88061}},	//   tió_, bouk, llık_, _ért_,
   {{0x201c89cf,0x644bb776,0x644391e6,0x81e30264}},	//   lovi_, _fugi, _eini, ফোন_,
   {{0xe1ff05a4,0xa92b10ac,0xe3b88214,0x64439e68}},	//   rió_, ріне_, nlık_, _fini,
   {{0xbebc8341,0xe1ff07e2,0x6443b777,0x3a203778}},	//   _dzīv, sió_, _gini, _ekip_,
   {{0x3dc68051,0x23c9064a,0x3a26b779,0x356b0abe}},	//   _know_, रासद, klop_, иран_,
   {{0x63a8b77a,0x7a120029,0x644b8358,0x6443b77b}},	//   ledn, tāte, _yugi, _zini,
   {{0x628880ab,0x34940009,0x7dd80661,0x25d78e82}},	// [2450] ludo, матр, _vísp, קומן_,
   {{0xa2be86bf,0x61fbb77c,0x60c00366,0x9f3501b5}},	//   षिप्, _smul, æmme, _непі,
   {{0x201c803a,0x62888301,0x7afc80f7,0x7ddc82df}},	//   dovi_, nudo, úrth, _jéss,
   {{0x7bd8b77d,0xdb188106,0x386900fc,0x6600928a}},	//   _lovu, _invä, _kwar_, jimk,
   {{0x4425b77e,0x998d81ac,0x201c8390,0xf7f4003d}},	//   yll_, _tiež_, fovi_, _رسید,
   {{0x63a8807d,0x201c812b,0xa2a6000f,0x644bb77f}},	//   jedn, govi_, _टैक्, _rugi,
   {{0xfbd20051,0x644bb780,0x661bb781,0x656b80b9}},	//   _אתם_, _sugi, touk, _pegh,
   {{0x2bc91344,0x25a90014,0x63b51286,0x644bb648}},	//   रावा, neal_, _hazn, _pugi,
   {{0x6443b782,0x201c8024,0x24893783,0x321d8035}},	//   _pini, bovi_, nuam_, mowy_,
   {{0x656bb784,0x644381f6,0x25a910eb,0x321d8035}},	//   _wegh, _qini, heal_, lowy_,
   {{0x316db785,0x7bd8b786,0x63b5139c,0x386904b9}},	//   _keez_, _dovu, _mazn, _awar_,
   {{0x63b500d2,0x644bb787,0x3d959445,0x321d8035}},	//   _lazn, _tugi, _хидр, nowy_,
   {{0xdb189918,0x64439e82,0x63a882ee,0x25a93788}},	//   _anvä, _tini, bedn, deal_,
   {{0x386901cd,0x628889a4,0x9f5cb789,0x2a67841c}},	//   _dwar_, budo, tivé_, _twnb_,
   {{0xf1bf0013,0xfaa28698,0x62888c52,0xe7f38006}},	//   mlán_, _защо, cudo, _अतना_,
   {{0x201c8024,0x7bc72323,0x25a9378a,0xceb282f6}},	//   zovi_, _anju, geal_, עין_,
   {{0xdca30993,0x321d809a,0x248903ac,0x64a3017d}},	// [2460] нати, dowy_, guam_, ната,
   {{0xa097010f,0x66008850,0xdb1c0338,0x32021e1e}},	//   _צדיק_, zimk, _morö, liky_,
   {{0x201c8052,0x386902af,0xdce08289,0x3ce60a21}},	//   vovi_, _zwar_, pamć, šov_,
   {{0x3202026f,0x63a8809a,0x8c460198,0xaca40133}},	//   niky_, zedn, _неме, _ahụr,
   {{0xd7c78e1a,0x25d7093f,0xe89497d4,0x63b5378b}},	//   लांच, _זוכן_, фаль, _fazn,
   {{0xdb0e040e,0xdb0a80f2,0x63b521a2,0x7416015b}},	//   _habí, _infö, _gazn, _روزا,
   {{0xcfb600ab,0x3a2681bf,0xfbc90c1c,0x76460c2e}},	//   ঞাপন, plop_, रारम, _kiky,
   {{0xf64f803d,0xdb0380e1,0x7646008e,0xceb301c6}},	//   دئو_, _fanú, _jiky, תיה_,
   {{0x7bd8803b,0x201c803b,0x66008877,0xdb088187}},	//   _povu, povi_, rimk, cedê,
   {{0x6288b78c,0x9f4781e8,0x7ddc8187,0xb05b0106}},	//   tudo, sinò_, _péss, lväg,
   {{0x63a8b78d,0xa75b8039,0x61358019,0x3202016b}},	//   redn, _הדבר, pülé, fiky_,
   {{0xdb0e03bb,0x6288806a,0xddcb026c,0x80b38035}},	//   _nabí, rudo, _žiža, _इनमे,
   {{0x68e2b4c2,0x7bd8b78e,0x2fda0473,0x7a2382f1}},	//   nyod, _tovu, _bopg_, mõtt,
   {{0x3f8eb78f,0xf1bf3790,0xa01b0061,0xd7f80087}},	//   ngfu_, clán_, ltöz, пус_,
   {{0x752f0d38,0xa3b58592,0x25a90c41,0x245280ff}},	//   _szcz, _चोट_, teal_, _hâm_,
   {{0x63b5003b,0xe3b882bb,0x6564177c,0x6a1501b5}},	//   _sazn, ldı_, gbih, _імпу,
   {{0x61ed3791,0xb4e73792,0x67ef813c,0x9f582f10}},	// [2470] _ilal, बने_, _høje, birà_,
   {{0xe3b882bb,0x25a93793,0x67250009,0x68e2b794}},	//   ndı_, seal_, _tyhj, dyod,
   {{0x98b90459,0x63b500d2,0x25a91c1d,0x24890069}},	//   ması_, _vazn, peal_, suam_,
   {{0x7a3f1482,0x9f580207,0x62970102,0x22950687}},	//   _būti, mirá_, rtxo, råk_,
   {{0x656f031d,0x248907b6,0x321db795,0x7a1200eb}},	//   _iech, quam_, rowy_, nāta,
   {{0xb8d585e8,0x656f3796,0x7bc70573,0x98b9080a}},	//   _जन_, _hech, _unju, nası_,
   {{0x656f3797,0xdce600eb,0x9f581e00,0x60c0b798}},	//   _kech, _iekā, nirá_, _ermm,
   {{0x644f0587,0x660d3799,0x20031ec1,0x6447379a}},	//   _kuci, nnak, hiji_, _hiji,
   {{0x98b90182,0x6447379b,0xf1bf0e1b,0xdcfd0457}},	//   kası_, _kiji, tlán_, _kası,
   {{0x656f379c,0x61ed2b3e,0x2003379d,0x6447379e}},	//   _lech, _alal, jiji_, _jiji,
   {{0x3202026f,0x6447071d,0xdb088722,0x26c101c5}},	//   tiky_, _miji, nedè, _nrho_,
   {{0x656f0775,0x471a893f,0x645d01c2,0x69db83d3}},	//   _nech, _וועג, _otsi, _joue,
   {{0x25098288,0x660d00ce,0x645d10af,0x69db9e9e}},	//   _برای_, dnak, _ntsi, _moue,
   {{0xdcfd07d9,0xdb0e0d76,0x69dbacf0,0xdce600eb}},	//   _nası, _sabí, _loue, _nekā,
   {{0x645d0a8e,0x656f379f,0x9f5837a0,0x69c9b7a1}},	//   _atsi, _bech, rirà_, _onee,
   {{0x660d37a2,0x644737a3,0x656f1f1c,0xdb0a81a8}},	//   gnak, _aiji, _cech, _uafá,
   {{0x20030d11,0x644f0698,0x656f37a4,0x644737a5}},	// [2480] biji_, _cuci, _dech, _biji,
   {{0x644f37a6,0x9f459ec4,0x9f5805e4,0x656404e6}},	//   _duci, _allí_, birá_, sbih,
   {{0x6d598c0b,0xe2971a8f,0x656f03aa,0x644737a7}},	//   _ofwa, дах_, _fech, _diji,
   {{0x6d4b8854,0xa96789a0,0x644f047f,0x79a38992}},	//   _ngga, дица_, _fuci, врше,
   {{0x660437a8,0x7a238074,0xd6cf803d,0x644737a9}},	//   miik, võtt, یقه_, _fiji,
   {{0x66040ef6,0x6d4bb7aa,0xb05b016d,0x68e2b7ab}},	//   liik, _agga, sväg, ryod,
   {{0x644f04b9,0x656f37ac,0x2452b7ad,0x7a2382f1}},	//   _zuci, _yech, _sâm_, tõtt,
   {{0x98b90059,0x7bdc0079,0xc8838214,0x1dc58b84}},	//   zası_, _horu, üğü_, वागत,
   {{0x7bdc37ae,0x98b90201,0xe3b8811c,0x9f5802df}},	//   _koru, yası_, tdı_, zirá_,
   {{0x61ed0bda,0x88bd809a,0x6d4bb7af,0xc0a98481}},	//   _slal, _myśl, _egga, _عاقل_,
   {{0x200302a5,0xddcb803a,0xe3b882bb,0xdd8f81a1}},	//   viji_, žišt, rdı_, _иш_,
   {{0x24528104,0x7bdc046d,0x7c669459,0x9f58018a}},	//   _tâm_, _loru, _قاتل, virá_,
   {{0x656f37b0,0x60f801bb,0x64c8000f,0x660d01ac}},	//   _rech, дняя_, रमोश, vnak,
   {{0x9f582706,0x656f37b1,0x67ef8366,0xdce0928a}},	//   tirá_, _sech, _tøje, zamě,
   {{0x656f37b2,0xa3d205fb,0x75ea003e,0x98b9017b}},	//   _pech, वान_, _význ, rası_,
   {{0x200302a5,0x6e20b7b3,0x644737b4,0x9f5837b5}},	//   siji_, nomb, _siji, rirá_,
   {{0x656f37b6,0x660d270b,0x25a20748,0x69db80e7}},	// [2490] _vech, rnak, _dbkl_, _roue,
   {{0x7bdc37b7,0xfe710065,0x656f02af,0x644f0bcf}},	//   _coru, _مگر_, _wech, _vuci,
   {{0x7bdc1249,0x6e20b7b8,0x644737b9,0x69dbb7ba}},	//   _doru, komb, _viji, _poue,
   {{0x7bdc0176,0x3e7a8029,0xdb088019,0xdb0e0187}},	//   _eoru, dīt_, gedé, _sabã,
   {{0xa0699a8f,0x18699980,0x645d37bb,0x6e29b7bc}},	//   чала_, чали_, _utsi, vleb,
   {{0x63b88b40,0x7bdc1035,0xdb070722,0x76b3811c}},	//   _navn, _goru, _majú, _həyə,
   {{0xfc488104,0x26c183bb,0xd6d19e95,0x442137bd}},	//   _gửi_, ího_, اقع_, moh_,
   {{0x6e20a578,0x442102d4,0x22988019,0x7bdc0214}},	//   gomb, loh_, dék_, _zoru,
   {{0x7bdc37be,0x6e29b527,0xdb018a21,0x212900b9}},	//   _yoru, rleb, delá, _nyah_,
   {{0xf6e7b7bf,0xa3d20576,0x35d106a7,0x2bd20072}},	//   _оцен, वाय_, हाड़, साया,
   {{0x63b88025,0x21290057,0xdb15026f,0x6e20a0b0}},	//   _davn, _ayah_, _bazé, bomb,
   {{0x61f98afe,0x7bca8365,0x6d4ba475,0x70cb0a43}},	//   _çalı, _enfu, _ugga, ामूल,
   {{0x44211ad4,0x629a8009,0x1c398a14,0x66040198}},	//   koh_, atto, _езды_, viik,
   {{0xcc76810f,0xf1b981a1,0x212937c0,0xdb0e0338}},	//   _טענה_, _laš_, _dyah_, _inbö,
   {{0x44210057,0x5f1a0105,0x660437c1,0x6da61634}},	//   doh_, _मुख्_, tiik, нива,
   {{0x7bdc0afe,0x25ad85f8,0xc1ba00a0,0x22490122}},	//   _soru, neel_, _رابط_, _giak_,
   {{0x7bdc37c2,0x660430c4,0x1de10074,0x76b38085}},	// [24a0] _poru, riik, _नवरत, _dəyə,
   {{0xa09b0158,0x25ad8fb0,0x7bdc0201,0x660437c3}},	//   _צייט, heel_, _qoru, siik,
   {{0xf1b9803a,0x386d810c,0x2bb78076,0x88bd809a}},	//   _baš_, _awer_, _असना, _wyśl,
   {{0x60c406a4,0xd910804e,0x9f5c8118,0x62530372}},	//   _krim, لیز_, riví_, _għom,
   {{0xf1238b88,0x44210458,0x25ad837a,0x9f458722}},	//   льшо, boh_, deel_, _allà_,
   {{0x3e7a8029,0x442137c4,0x65760df6,0xe7c78327}},	//   tīt_, coh_, layh, लागप,
   {{0x44380352,0x63b88805,0x6e20b7c5,0x629a8706}},	//   _ihr_, _ravn, tomb, xtto,
   {{0x3e7a80eb,0x63b88e66,0x32078061,0x2d9237c6}},	//   rīt_, _savn, ényt_, ngye_,
   {{0x3e7a8029,0x248d855a,0x224911d6,0x2cb2031d}},	//   sīt_, guem_, _riak_, nwyd_,
   {{0x22988065,0xa87b8051,0xa01b089c,0xa5bb0032}},	//   ték_, _מאמר, tröm, _akól,
   {{0x60c437c7,0x056682ff,0x44380706,0xda77b7c8}},	//   _arim, _звен, _mhr_, няя_,
   {{0xddea803d,0x60c437c9,0xf8bf016b,0x20010106}},	//   _عرضه_, _brim, tvé_, _smhi_,
   {{0xebe6b2b8,0xf8bf02be,0x442109c4,0x60c4079a}},	//   _подп, uvé_, yoh_, _crim,
   {{0xf8bf00e7,0xdb188168,0x2cb20114,0x44380133}},	//   rvé_, _javë, dwyd_, _nhr_,
   {{0x443e8352,0x60c437ca,0x6e26008e,0x25a00428}},	//   mmt_, _erim, _bkkb, ffil_,
   {{0x7c3e12ca,0x442ca51d,0x60c404dc,0xbcfb0061}},	//   empr, lld_, _frim, _beép,
   {{0x644ab7cb,0x60c40d1a,0x69cd004f,0xe4531ef5}},	// [24b0] _kifi, _grim, _inae, اضر_,
   {{0x7a3637cc,0x1602016f,0x68470032,0x62888037}},	//   ráte, रोबर_, _dédì, ordo,
   {{0xa5f937cd,0x442c808b,0x443837ce,0x8c1b81c6}},	//   _жену_, ild_, _dhr_, לומי,
   {{0x442137cf,0x443e8192,0x644ab7d0,0x225c1517}},	//   soh_, hmt_, _lifi, ívka_,
   {{0x25ad90f4,0x644a803c,0x442110e1,0xed59812b}},	//   veel_, _oifi, poh_, ndže_,
   {{0x9f4585a4,0x442137d1,0x644ab7d2,0x66028314}},	//   _allá_, qoh_, _nifi, _amok,
   {{0xf1a7a451,0x6e2d1793,0x25adb7d3,0xf1b981f4}},	//   _пран, olab, teel_, _taš_,
   {{0x6e2d37d4,0xa91d808d,0x2bc9001b,0x02a28133}},	//   nlab, _adže, राका, _chọọ,
   {{0x8cc4009a,0x6e2d0051,0x628881ca,0x644a80b4}},	//   रियो, ilab, erdo, _bifi,
   {{0xa5bb0125,0x69cd37d5,0x6e2d005d,0x24890187}},	//   _skól, _anae, hlab, iram_,
   {{0xa3d2035a,0x24893752,0x05e10035,0x60c437d6}},	//   वात_, hram_, _नवंब, _srim,
   {{0xd70d83eb,0x442c81ed,0x24890f7c,0xdd1d8162}},	//   िपीठ_, ald_, kram_, _câţi,
   {{0x248937d7,0x644ab15e,0x248db7d8,0x7c218b99}},	//   jram_, _fifi, quem_, polr,
   {{0x2007b64e,0x65698aa2,0x7a38b7d9,0x644a8314}},	//   nini_, lbeh, míte, _gifi,
   {{0xd62a37da,0xa5961bc1,0x91fd00eb,0x6e2d349a}},	//   дове_, кращ, mpān, flab,
   {{0x200780f6,0x6e2d37db,0xa6e9801c,0x6569b7dc}},	//   hini_, glab, _trươ, nbeh,
   {{0x200780f6,0xb9070a49,0x25a037dd,0xa5071628}},	// [24c0] kini_, _যে_, rfil_, вета_,
   {{0xdca32410,0x2007b7de,0x64a30fbf,0x2bd210be}},	//   рафи, jini_, рафа, साधा,
   {{0xee3a0604,0x44278239,0xd259102a,0xeb9737df}},	//   _оно_, _mkn_, еці_, тих_,
   {{0x248902df,0x6d5b81c0,0x656981ed,0x58868a14}},	//   bram_, jcua, jbeh, выка,
   {{0xa3d21370,0x2007b7e0,0x443ea51d,0xdce4012b}},	//   वाद_, fini_, ymt_, obič,
   {{0x2007b7e1,0x44380352,0x656980e1,0x02a281bc}},	//   gini_, _uhr_, ebeh, _shọọ,
   {{0x60090503,0x644ab7e2,0xa3d58aad,0x63bc29de}},	//   nžma, _rifi, हान_, _iarn,
   {{0x44279600,0x644ab7e3,0x6adb00ab,0x531b01c6}},	//   _akn_, _sifi, _যেকো, _חולצ,
   {{0x61e08068,0x41d6000c,0x442789ca,0x229c026f}},	//   _ioml, धानस, _bkn_, lík_,
   {{0x3866b7e4,0x442c8051,0x2bb7816f,0x63bc37e5}},	//   mpor_, uld_, _असणा, _jarn,
   {{0x63bc37e6,0x443ea09b,0x229c03cb,0x764b8065}},	//   _marn, rmt_, ník_, _figy,
   {{0x2489061c,0x61e080b9,0x8b0781d0,0xad9b0032}},	//   yram_, _joml, _skří, _amún,
   {{0x63bc00b9,0x6ba78106,0x442c80b9,0xcdf781c6}},	//   _oarn, ärgå, pld_, _במאי_,
   {{0xdb03b7e7,0x44278118,0x69cd0114,0x61e0b7e8}},	//   _canó, _gkn_, _wnae, _loml,
   {{0x2bb7835a,0xdceb80eb,0x5c37807c,0xdb019647}},	//   _असता, _iegā, _שטוב_, gelä,
   {{0x24892ec0,0x518715da,0x61e0836a,0x229c016b}},	//   tram_, _рука, _noml, dík_,
   {{0x6e2d37e9,0x2007b7ea,0x63bc37eb,0x7bda822c}},	// [24d0] rlab, yini_, _barn, ojtu,
   {{0x31790117,0x248937ec,0xd378809a,0x6e2d37ed}},	//   lasz_, rram_, nać_, slab,
   {{0xf09f01c1,0x16229c4f,0x6e2437ee,0x78a980e1}},	//   ltà_, मवार_, boib, _spev,
   {{0xd378b7ef,0xf6500117,0xf1bf0032,0xa5f902de}},	//   hać_, _گئی_, ndá_, _чему_,
   {{0xd378809a,0xf09f3340,0x3c398036,0x61e081d0}},	//   kać_, ntà_, lève_, _doml,
   {{0xe73989e0,0xb4df016f,0xf09f3340,0x1e95b7f0}},	//   нел_, तही_, ità_, грир,
   {{0x2007b7f1,0xed599641,0xd3788063,0x9f5105a4}},	//   rini_, ной_, dać_, lizó_,
   {{0x2007b7f2,0x26c5803a,0xe8d9082e,0xe3b88085}},	//   sini_, _vrlo_, _afọ_, dlıq_,
   {{0xdd118182,0x2007b28f,0xdd918065,0x9f5101ca}},	//   _düşm, pini_, لوں_, nizó_,
   {{0x7a3896a5,0x3a292c8d,0x7c25016b,0x2007b7f3}},	//   ríte, _akap_, nohr, qini_,
   {{0x81b68a49,0x420a1056,0x224d81e2,0xf09f0098}},	//   জার_, енно_, _kiek_, età_,
   {{0x3a2900b9,0xdb088333,0x6ec08651,0x75ea01d0}},	//   _ckap_, cedí, विरु, _výzk,
   {{0x22478400,0x4427b7f4,0x229c016b,0x66099c11}},	//   ínky_, _tkn_, zík_, miek,
   {{0x660985d7,0x25bdb7f5,0x224db7f6,0xdb01b7f7}},	//   liek, _hawl_, _liek_, telä,
   {{0x4425b7f8,0x98a50029,0x249fb7f9,0xd757004e}},	//   mol_, ālā_, ltum_, الفت_,
   {{0x66098341,0x229c0125,0xe1f20077,0x25bfb7fa}},	//   niek, vík_, _دست_, ndul_,
   {{0xfbb788af,0x61e0b286,0x63bc1b40,0xd57505a8}},	// [24e0] _असाम, _roml, _parn, русь,
   {{0x44258355,0x229c37fb,0x61e0b7fc,0x69a021ef}},	//   nol_, tík_, _soml, ग्री,
   {{0xdee60187,0x63bc37fd,0x7f9b0039,0x51869860}},	//   _сони, _varn, _אביז, гула,
   {{0x4425b7fe,0xa3d20ebf,0x200a37ff,0xd3788035}},	//   hol_, वाह_, libi_, zać_,
   {{0x4425b800,0x63bc3801,0x7a1c81d0,0x25bf8326}},	//   kol_, _tarn, jčte, ddul_,
   {{0xb4c20aed,0x2ca00e23,0x4425b802,0x3866b803}},	//   ्मी_, mtid_, jol_, rpor_,
   {{0x2ca02e80,0x4425b7fe,0x3866b804,0x09a980c8}},	//   ltid_, dol_, spor_, ওয়া,
   {{0xd3788d38,0x200a03bf,0xb05b016d,0xa3d2056b}},	//   wać_, hibi_, dvän, वाव_,
   {{0x7ddc8117,0x644e3805,0x200a3806,0x4425831d}},	//   _kész, _kibi, kibi_, fol_,
   {{0x3a2680c9,0x4425b807,0x200a04b9,0x644e21c7}},	//   loop_, gol_, jibi_, _jibi,
   {{0x9e669d85,0x53348764,0xa91d8267,0x6609adc5}},	//   _свед, рент, _idža, biek,
   {{0xf09f0698,0xf2d30158,0xe3b88085,0xd378809a}},	//   ttà_, צער_, rlıq_, sać_,
   {{0x4425b808,0x7984031d,0x3dc00114,0x7d7b83de}},	//   bol_, _ddiw, ddiw_, _טראג,
   {{0x4425b809,0xf09f01c1,0x644e380a,0xc3568698}},	//   col_, rtà_, _nibi, _съдъ,
   {{0x3a268cfa,0xa36f80e1,0xd90f003d,0xf09f380b}},	//   koop_, äčši, تیک_, stà_,
   {{0x2bd290be,0x270e8201,0xb4c20361,0x442a0573}},	//   तावा, _mən_, ्मू_, _akb_,
   {{0x9f4100f1,0xa91d8390,0x200a380c,0x1ae200ab}},	// [24f0] _kohë_, _odža, bibi_, _গেলে_,
   {{0x644e380d,0x320b380e,0x6609b80f,0xbcfb0118}},	//   _cibi, licy_, ziek, _aféc,
   {{0x644e3810,0xddd00214,0xe45f0106,0x9e350391}},	//   _dibi, _çeşi, _grön_, _венч,
   {{0x320b0035,0x4425b811,0xac951f96,0x69d80f12}},	//   nicy_, zol_, _камш, यायी,
   {{0x656d1ad4,0x4425b812,0xa3e5950e,0x2ca00428}},	//   mbah, yol_, _नवल_, ctid_,
   {{0xdceb8087,0xba7712c8,0x656d3813,0x9f518085}},	//   _legă, _مارت, lbah, _özü_,
   {{0x224da338,0x6609b814,0xb3d2035a,0xec360039}},	//   _tiek_, tiek, सारख, _כאשר_,
   {{0x656d3815,0xfbb78063,0x249fb816,0x4425b817}},	//   nbah, _असहम, ttum_, wol_,
   {{0x4425b818,0x25bfb819,0xec768a14,0x20ce808b}},	//   tol_, rdul_, апы_, rðið_,
   {{0xa3ab01b6,0x6609b81a,0x249fb81b,0x60c9b81c}},	//   _कॉम_, siek, rtum_, _irem,
   {{0x249fb81d,0xddc701e2,0xc5d5a1d2,0x216a1d34}},	//   stum_, gpjū, _віль, кини_,
   {{0x4425831d,0xb05b00f2,0x249f808b,0xcfaa80ab}},	//   sol_, rvän, ptum_, _গোপন,
   {{0x69d801ab,0x777702f7,0x7a1200eb,0xb05b0106}},	//   याबी, _bexx, nāti, svän,
   {{0x88bd809a,0x248db81e,0x60c9804f,0x4425b81f}},	//   _wyśw, mrem_, _mrem, qol_,
   {{0x7ddc8117,0x645b9220,0xf74602c7,0x200a3820}},	//   _rész, lqui, рево, ribi_,
   {{0xdd921b9a,0x644e3821,0x06af80ab,0x8e55035f}},	//   تور_, _sibi, কিপি, стрі,
   {{0x7a3614b5,0x9f4780f7,0xa3d2064a,0x248d808e}},	// [2500] láto, ghnú_, वाल_, nrem_,
   {{0x907b0158,0x7bc1b822,0x2ca0005f,0x187b00be}},	//   _שטיי, ndlu, rtid_, _שטיב,
   {{0x2ca03823,0xe29a027e,0x7a360c83,0xdb1503a7}},	//   stid_, тае_, náto, _razã,
   {{0x60c98456,0x7ae31af3,0x50669986,0xb05b016d}},	//   _brem, änta, атка, kväl,
   {{0x270e8085,0xe046af75,0x76440041,0xf8b80074}},	//   _sən_, анди, mmiy, ेटिय,
   {{0x76443824,0x24803825,0x7a360c83,0xdb073826}},	//   lmiy, msim_, káto, _cajó,
   {{0x44443827,0x764402a3,0x60c9b828,0x7a3d282c}},	//   mm_, omiy, _erem, léte,
   {{0x60c98ac6,0xe5c68544,0x806680e8,0x61e43829}},	//   _frem, рско, _вваж, _noil,
   {{0x2bd2800d,0x7a388aae,0x6aa9026c,0x4444382a}},	//   ताला, cíta, _ćefi, om_,
   {{0x4444382b,0x69c2838e,0xdb1c06c0,0x628781b9}},	//   nm_, ldoe, _parè, ġjon,
   {{0x44442404,0x78ad003a,0x78a28a9e,0x4b7b00be}},	//   im_, _spav, ltov, כטיג,
   {{0x61e40083,0x261704b7,0xdca68d91,0x248db82c}},	//   _coil, għol_, _вади, brem_,
   {{0x78a284e8,0xfeb804c0,0x69c0b82d,0xb4c206a7}},	//   ntov, یافت_, _mame, ्मो_,
   {{0x4444382e,0xb4c224bd,0xdb18b82f,0x8c43802e}},	//   jm_, ्मै_, _haví, _дече,
   {{0x69c08012,0x61e41a29,0xc9872707,0x0cb6ab51}},	//   _oame, _foil, _купи, _अनुम,
   {{0x44443830,0x81ab8a49,0x5d550381,0xdb0504b8}},	//   em_, _কোন_, скат, nehå,
   {{0xa3d20006,0x78a2b831,0x78ad026c,0xbddb0036}},	// [2510] वां_, jtov, _upav, _bièr,
   {{0x6380001b,0x656d31a6,0x6fb509a7,0x7a388c83}},	//   vání, sbah, _امدا, víta,
   {{0x60c9b4c1,0xdb1501ac,0x645b8661,0x69c09ea2}},	//   _srem, _bazá, zqui, _bame,
   {{0xb5a73832,0x44443833,0xc9878966,0xdb18801b}},	//   _трой, am_, ружи, _naví,
   {{0x69d8016f,0x7c2880f1,0x7a3603b0,0xb05b0106}},	//   याती, kodr, záto, kväm,
   {{0x645d82ba,0xa3d224bd,0xf1bf002a,0xafe28198}},	//   ísim, वाः_, xoán_, зошл,
   {{0x75ea026f,0x657b820d,0x69c0b834,0x7a38b835}},	//   _výzv, tauh, _fame, síta,
   {{0x660d3836,0x248db837,0x69c0b838,0xff1804de}},	//   niak, trem_, _game, יקות_,
   {{0x32f78085,0xf1bf00e1,0x7c28b839,0x60c9a5f4}},	//   məyə_, hlás_, fodr, _urem,
   {{0x61e42174,0x69c0b83a,0x248db83b,0x660d0102}},	//   _soil, _zame, rrem_, hiak,
   {{0x645bb83c,0x61e4383d,0xdb1c366a,0x69c0b83e}},	//   squi, _poil, _paré, _yame,
   {{0x7a36037d,0x245b8073,0xa06a017c,0xb0c30361}},	//   ráto, _têm_, лама_, शिंग,
   {{0x660d383f,0x61e402be,0x6e298118,0xfd568039}},	//   diak, _voil, moeb, _השני_,
   {{0x7afe3840,0x76aa8201,0x7a3d0019,0x7c28b49a}},	//   yzpt, _həya, véte, codr,
   {{0x670d83bb,0x229580f7,0xe45f0106,0x528581a8}},	//   िपटक_, _العس, _dröm_, _البك,
   {{0x78a2803e,0x4444146a,0x6459b841,0x660d3842}},	//   ytov, wm_, _kuwi, giak,
   {{0x228387d9,0x78a2826f,0x7ae30106,0x146291d3}},	// [2520] lık_, xtov, äntn, _kọọp,
   {{0x444410af,0x69c092cf,0x76443843,0x24803844}},	//   um_, _same, smiy, rsim_,
   {{0x62818422,0x7d090503,0xdcef0029,0x24803845}},	//   nslo, _žest, _vecā, ssim_,
   {{0x44443846,0xe8fa8b79,0x69c09abf,0x6579b847}},	//   sm_, лле_, _qame, _newh,
   {{0x69c2800b,0x17549af1,0x6459b848,0xb3b7b849}},	//   rdoe, овля, _nuwi, _असंख,
   {{0x69c080f6,0x78a2b84a,0xab2a1d85,0x62838503}},	//   _wame, rtov, _бога_, _ovno,
   {{0x78a2b84b,0x69c086c7,0x76aa8085,0xdb18b6fa}},	//   stov, _tame, _bəya, _paví,
   {{0x8a06875a,0x78a2b84c,0x22838214,0x6459820d}},	//   _узбе, ptov, dık_, _buwi,
   {{0x628380d2,0xb87b0019,0x7a388061,0x645989c4}},	//   _avno, nyít, líto, _cuwi,
   {{0x660d384d,0x2cbd82d5,0x27e58326,0x6459b84e}},	//   ziak, _dswd_, _goln_, _duwi,
   {{0x02a39fb4,0xdb050106,0x91bc914f,0x6281a26d}},	//   прям, pehå, _ईसाई, gslo,
   {{0x7f3b8158,0x2240384f,0x224680b9,0x200e811c}},	//   _געבו, _chik_, nmok_, lifi_,
   {{0x25b7803d,0x22401ab3,0x9f4101d6,0xe9df0061}},	//   _دهند_, _dhik_, _dlhý_, rjú_,
   {{0x765a9fc5,0x7bcd84b9,0x26cc81a1,0xe8d9082e}},	//   _kuty, _ɗauk, _krdo_, _ndụ_,
   {{0xa3d583a4,0xa3cc2e2b,0x6b7b83c8,0x4b7b810f}},	//   हार_, _शोध_, _גרונ, _גאוו,
   {{0xe8d901bc,0x765a8c2e,0xf1bf0019,0x75f581d0}},	//   _adụ_, _muty, rlás_, _lázn,
   {{0xc4b681fe,0x660d0695,0xae023850,0x045b00d7}},	// [2530] _अनोख, riak, रोइन_, اجرت_,
   {{0x3a2d81b0,0x60cd018e,0x41a5000c,0x660d3851}},	//   _skep_, _iram, ग्रस, siak,
   {{0x1dc43852,0xbddb06c0,0x660d3853,0x31698333}},	//   _लोकत, _chèc, piak, ñazo_,
   {{0x60cd3854,0x3f9e80e7,0xdb0183ba,0x22469fdb}},	//   _kram, _actu_, relø, gmok_,
   {{0x200e84bb,0x26ccb855,0x777a8580,0xf8c903db}},	//   fifi_, _ardo_, _betx, िटिय,
   {{0x26cc8052,0x765ab856,0x6281b857,0x26c7817f}},	//   _brdo_, _buty, yslo, tvno_,
   {{0x6e29b858,0x7bd53859,0xa91d8267,0xe7398009}},	//   toeb, _inzu, _idžm, шек_,
   {{0x7d0907ca,0xdb0a82af,0x25a91823,0x63b7026f}},	//   _þess, _dafü, nfal_, lexn,
   {{0x38690072,0xa3bd116e,0xa3d58ebf,0x79898176}},	//   _ntar_, _आसा_, हाल_, _idew,
   {{0x7bc50077,0x228387d9,0x98178b8c,0x52a98319}},	//   ndhu, tık_, _ابرا, авом_,
   {{0x60cd385a,0xbf1580f7,0xa3ab03dd,0x28c78424}},	//   _aram, _بواب, क्य_, लिवि,
   {{0x6459b85b,0x75f59c18,0x60cd385c,0x7a3601d0}},	//   _tuwi, _zázn, _bram, mátk,
   {{0x7a36026f,0x316d2509,0x89360bbe,0x62819ff5}},	//   látk, ñeza_, تعدا, sslo,
   {{0x6281b85d,0xcb6980e8,0x6283b85e,0x7a1201a9}},	//   pslo, _таке_, _tvno, vātu,
   {{0x26cc1313,0x7bc3802e,0x60cd385f,0x65c60081}},	//   ído_, _ianu, _eram, обва,
   {{0x60cd3860,0x7bd502af,0x660b80b9,0x7989b861}},	//   _fram, _anzu, _jmgk, _ndew,
   {{0xdca31980,0x69d63862,0x7bc3b863,0x64a30d46}},	// [2540] мати, _inye, _kanu, мата,
   {{0x69c40102,0x38a43864,0x7bc53865,0x7989b866}},	//   _haie, mör_, gdhu, _adew,
   {{0x75f5a5ce,0x7bc39e44,0x2bce035a,0x0576080b}},	//   _názo, _manu, _होणा, _واحد,
   {{0xa3d58e88,0x7bc3b867,0x69c4011b,0x69c63868}},	//   हाँ_, _lanu, _jaie, ndke,
   {{0x79898114,0x2db70039,0x7a388019,0x3ebeb869}},	//   _ddew, _ולכן_, síto, _sstt_,
   {{0x7a38b86a,0x629701df,0x7bc3b86b,0xdb1c06a5}},	//   píto, buxo, _nanu, _harí,
   {{0x81e68a49,0x38a429ed,0x69d6386c,0xf1ca000c}},	//   যোগ_, hör_, _onye, ियान,
   {{0x85f70158,0x2bce2539,0x442e88dc,0x69d601bc}},	//   ַציע_, _होता, _skf_, _nnye,
   {{0xdb1c386d,0xa3d5881f,0x6283026f,0x1da6a0f2}},	//   _marí, हां_, ánov, क्षत,
   {{0x7a360013,0xe9ff8028,0x69d60247,0x60c080fc}},	//   láth, _kiến_, _anye, _ismm,
   {{0x6fde01aa,0x69c40c50,0x386910b6,0xada68196}},	//   मानं, _baie, _star_, _мажл,
   {{0x38a4386e,0x61e2b86f,0x60cd3870,0x7a3601a8}},	//   för_, njol, _pram, náth,
   {{0x38a4016d,0xa3ab00d4,0x7a3d00e7,0x10741273}},	//   gör_, क्ड_, géta, мляю,
   {{0x69d6082e,0x7bc3b871,0x9f45826b,0x248681f4}},	//   _enye, _ganu, _bolè_, _ivom_,
   {{0x226380e1,0x98ac00eb,0x61e283ba,0xdb1c046d}},	//   ľské_, ādā_, kjol, _barí,
   {{0x442cb872,0x2d580153,0xc333812a,0xa5bb026b}},	//   lod_, жить_, _קוק_, _akór,
   {{0x80ba8c28,0x2902009a,0xa8028214,0xdb1c05e4}},	// [2550] _शैले, czka_, şıyo, _darí,
   {{0x69a71094,0x442cb873,0xe9ff8028,0x7bc38079}},	//   ट्री, nod_, _biến_, _xanu,
   {{0x20113874,0xdb1c22d8,0x2c608247,0x7bc53875}},	//   mizi_, _farí, _lòd_, rdhu,
   {{0x24868025,0x5bb783dd,0x20112693,0x442cb876}},	//   _ovom_, _अस्व, lizi_, hod_,
   {{0x442cb877,0x7e6202d4,0x3f69996e,0xead0826b}},	//   kod_, _čopi, било_, _jẹbi_,
   {{0x657d1b64,0xcc76012a,0x20113878,0x442c8682}},	//   _hesh, _מעשה_, nizi_, jod_,
   {{0x657d135e,0xfd4c8028,0x533433e4,0x645d0010}},	//   _kesh, _triể, _жерт, _husi,
   {{0x645d273f,0x657d3879,0x7bc39bb7,0xf0768065}},	//   _kusi, _jesh, _sanu, _کیوں_,
   {{0x7bc3b87a,0x64551d1b,0x442c831d,0x657d387b}},	//   _panu, _kizi, fod_, _mesh,
   {{0x7a361313,0x442cb87c,0x7bc38201,0x1c428d15}},	//   máti, god_, _qanu, нным,
   {{0x69c4387d,0x6455387e,0x7bc3b87f,0x645d3880}},	//   _paie, _mizi, _vanu, _lusi,
   {{0x38a43881,0x61e9a32d,0x3d0f8072,0x273481a8}},	//   tör_, _joel, _तेथे_, súnú_,
   {{0x645d01e2,0x442c831d,0x7bc3b882,0xa01b02af}},	//   _nusi, bod_, _tanu, rsön,
   {{0x76499d5a,0x64553883,0x7a3d3884,0x7fd50d8e}},	//   lmey, _nizi, réta, місі,
   {{0x61fbb885,0x657d3886,0x645d1aea,0x29022448}},	//   _olul, _besh, _ausi, szka_,
   {{0xd90d03f8,0x645d3887,0xe8860b5b,0x661ba645}},	//   ایی_, _busi, _егип, nnuk,
   {{0x64553888,0x657d3889,0xdb0a8125,0xdb1c388a}},	// [2560] _bizi, _desh, _hafð, _varí,
   {{0xf7461fab,0x6b81b88b,0x2d800036,0x7a36041c}},	//   _непо, nalg, saie_, dáti,
   {{0x1dbd863a,0x6455388c,0x6285388d,0x7a388019}},	//   ्यात, _dizi, gsho, sítm,
   {{0x6d59882e,0x442cb88e,0xa3cc0105,0x61e9b88f}},	//   _ngwa, zod_, _शोर_, _coel,
   {{0x61e98b3c,0x442c97ea,0xed52003d,0x6b81b890}},	//   _doel, yod_, _سپس_, kalg,
   {{0x62853891,0xe9ff8028,0x2609800f,0x6d59b892}},	//   bsho, _tiến_, ़ोसी_, _agwa,
   {{0x8c430956,0x24868025,0x04430607,0xe2970ba7}},	//   _чере, _svom_, _черн, _нар_,
   {{0xd49a85f1,0xceb30051,0x442c8428,0x645506a0}},	//   бро_, גיה_, wod_, _zizi,
   {{0x38c883f8,0x442cb893,0x7d043894,0x290280f2}},	//   _بازی_, tod_, nzis, _åka_,
   {{0xe7d700ab,0x7e6d8279,0xcfaa803d,0x6e2d0ece}},	//   _হত্য, ćapr, _دارم_, zoab,
   {{0x764280dd,0x644880eb,0x39402168,0x20113895}},	//   _thoy, rmdi, _azis_, vizi_,
   {{0x24868052,0x442cb896,0x7a38816b,0x61e98118}},	//   _tvom_, sod_, dítk, _xoel,
   {{0x657d3897,0x6b81b898,0x50672b3f,0x20113899}},	//   _resh, balg, ятна, tizi_,
   {{0x645d389a,0x1ae200c8,0x657d389b,0xdb0e0020}},	//   _rusi, _গেছে_, _sesh, _jabó,
   {{0x645d29fb,0xa3e02d19,0x657d389c,0xa3c20e88}},	//   _susi, थान_, _pesh, ्यन_,
   {{0x63bab89d,0x6455389e,0x645d389f,0xa4d500e8}},	//   letn, _sizi, _pusi, мобі,
   {{0x629a98ac,0x657d00f1,0x2718809a,0x61e9910f}},	// [2570] luto, _vesh, धपुर_, _roel,
   {{0x62851ded,0x6455029a,0xf045026a,0x78fc0039}},	//   tsho, _qizi, _تعبی, _לפחו,
   {{0x645538a0,0x3f830025,0x629a90dd,0x2bae816f}},	//   _vizi, maju_, nuto, ज्या,
   {{0x2fc58bc5,0x628538a1,0x645d38a2,0x64551e8f}},	//   _salg_, rsho, _tusi, _wizi,
   {{0x48aba4c8,0x645d0364,0x63bab642,0x61e9838e}},	//   стем_, _uusi, ketn, _voel,
   {{0x63bab8a3,0x629ab8a4,0x7a36016b,0x2ca90106}},	//   jetn, kuto, ráti, mtad_,
   {{0x2ca938a5,0x61e9837a,0x6b81b8a6,0x2fc58257}},	//   ltad_, _toel, valg, _valg_,
   {{0x629ab8a7,0x3f831d96,0x61fbb8a8,0x661b985b}},	//   duto, haju_, _ulul, unuk,
   {{0x3f83003b,0x6b81b8a9,0x2ca938aa,0x76498214}},	//   kaju_, talg, ntad_, rmey,
   {{0x3f830025,0x9f638009,0x798d00a4,0x3e7a80eb}},	//   jaju_, ävät_, _adaw, būt_,
   {{0x3f830289,0x7bc70c9e,0x629ab8ab,0x7a3d026f}},	//   daju_, _maju, guto, rétn,
   {{0x7bc7036e,0x2ca938ac,0x7bd8b8ad,0xa91d81a1}},	//   _laju, ktad_, _envu, _adži,
   {{0xa3c88e18,0xb4bc009a,0xa3c21b7e,0x3ce00118}},	//   _लोक_, _आने_, ्यम_, xxiv_,
   {{0x63ba80d2,0xfd108bbe,0xdb0e002a,0x2d9f841c}},	//   cetn, _حجم_, _xabó, lgue_,
   {{0xe9ff8028,0x67ef806a,0xa3d1109b,0x798d0197}},	//   _nhắn_, _højs, वयन_, _fdaw,
   {{0xa3ab0305,0xee3a0d13,0x51560d5f,0x6009026c}},	//   क्स_, іна_, _отпу, džmu,
   {{0x3f830025,0xd0408201,0xbc6a08ca,0x2ca938ae}},	// [2580] baju_, _ermə, زمان_, gtad_,
   {{0x3f830025,0x60c438af,0x7d0438b0,0xdb1c0722}},	//   caju_, _isim, rzis, _parà,
   {{0xdb1c38b1,0x09e699b8,0x7bc72ad8,0xe9ff801c}},	//   _bará, можн, _daju, _chắn_,
   {{0xdb1c2b72,0xaca40135,0xaca38133,0xdb0e2c6c}},	//   _cará, _akụr, _anọk, _sabó,
   {{0x7a38b8b2,0x307a00be,0xdb0e24a3,0x7bc89113}},	//   níti, קאַנ, _pabó, yddu,
   {{0x60c40010,0x7bc738b3,0x386010eb,0x7a3638b4}},	//   _msim, _gaju, _muir_, mátu,
   {{0xa3c880cf,0xdb1c38b5,0x25adb8b6,0x63bab8b7}},	//   _लोग_, _fará, ffel_, vetn,
   {{0xdb1c037d,0x60c438b8,0x3f8300d2,0x25a038b9}},	//   _gará, _osim, zaju_, ngil_,
   {{0x80a68bca,0x7bc72e22,0x60c438ba,0x063703de}},	//   _زمان, _yaju, _nsim, ונקט_,
   {{0xa3d58ee6,0x427487b6,0xdb1c38bb,0xb05b0192}},	//   हाग_, нгос, _zará, hwäc,
   {{0x3f830025,0x59d00074,0x7bc88c72,0x629a82d5}},	//   vaju_, _तोहर, rddu, uuto,
   {{0x629ab8bc,0x3f8310ab,0x51f80a14,0x27ec80e1}},	//   ruto, waju_, днюю_, _hodn_,
   {{0x38601536,0x3f830025,0x6e2290ab,0xd90f04c0}},	//   _cuir_, taju_, _ijob, شید_,
   {{0x629a8637,0x67ef813c,0x2d84b8bd,0x59dd001b}},	//   puto, _højr, lame_, याहर,
   {{0x3f830025,0x60c438be,0x7bc738bf,0xa01b0338}},	//   raju_, _esim, _raju, lsök,
   {{0x3f830052,0x7c3ab8c0,0x4d7b80be,0x2ca938c1}},	//   saju_, lltr, ַרבע, ttad_,
   {{0x6458b8c2,0x3f830052,0xe81fb8c3,0x7bc7031b}},	// [2590] _kivi, paju_, _बदला_, _paju,
   {{0x2ca938c4,0x2c64016d,0x2d84b8c5,0x59dd016f}},	//   rtad_, _död_, hame_, यावर,
   {{0xa3ab053f,0x6fdd835a,0x3a2fb8c6,0x2ca9180a}},	//   क्ष_, पासू, togp_, stad_,
   {{0x6458b8c7,0xdb260077,0x2d848110,0x7bc70010}},	//   _livi, رونی, jame_, _waju,
   {{0x7bc738c8,0x9f5800f7,0x6d5d0420,0x25ad8106}},	//   _taju, mhrá_, _igsa, vfel_,
   {{0x764d1d5a,0x248938c9,0x07a29182,0xbcfb0032}},	//   lmay, msam_, гашн, _agég,
   {{0x25ad8012,0x49bb8077,0x9f458722,0x82a401a1}},	//   tfel_, _وارد_, _allò_, _иште,
   {{0xcf58004c,0xa3ab09a3,0x2d84b8ca,0x764d03bf}},	//   ובות_, क्र_, game_, nmay,
   {{0x2d9f8333,0xed5982ce,0x248938cb,0x25adb8cc}},	//   rgue_, ježe_, nsam_, rfel_,
   {{0x3ec48364,0x69cb8c4d,0x6e229d36,0x5ba980bf}},	//   ästä_, ldge, _ejob, чком_,
   {{0xa91d807a,0x61ed0087,0x3d0f8035,0x764d02d0}},	//   _deže, _boal, _तेरे_, kmay,
   {{0x61ed38cd,0x69cb84eb,0xc7a90bea,0x25e0816f}},	//   _coal, ndge, _לב_, काणी_,
   {{0xe9ff8104,0x7e61837a,0x69c9808e,0x9f45823e}},	//   _nhận_, _hulp, _maee, _molí_,
   {{0x7a38b8ce,0xb8e8001b,0x2c64016d,0x6e3b9a7f}},	//   ríti, _ईन_, _röd_, llub,
   {{0x6e29016b,0x1da686a7,0xb87b01df,0xf6262ba7}},	//   čebn, क्कत, rxía, едво,
   {{0x60c438cf,0x4423008e,0xa2c300bc,0x91fd01a9}},	//   _tsim, _ajj_, रबन्, spār,
   {{0xdd8f0c48,0x798638d0,0x24891849,0x60c42cc3}},	// [25a0] صول_, makw, gsam_, _usim,
   {{0x61ed0613,0x26c5835f,0x2d84b8d1,0x7aea0106}},	//   _zoal, _oslo_, zame_, äfto,
   {{0x6e3bb8d2,0xdb1c0073,0xeac9877f,0x2bf68158}},	//   klub, _març, _jẹ_, עמען_,
   {{0xeac98028,0x798638d3,0x5fde001b,0x4911852a}},	//   _mẹ_, nakw, मावल, _देहो_,
   {{0x2d8491ba,0xdb1a80f1,0x6b850748,0x27fe82f7}},	//   vame_, tetë, bahg, _pltn_,
   {{0xfaa638d4,0xe7e30035,0xdcc88129,0x290688f1}},	//   _паго, खाया_, _rỉ_, rzoa_,
   {{0x75f8026f,0x4df43281,0x2d84b8d5,0x2d82203d}},	//   _nízk, _इकाई_, tame_, _keke_,
   {{0x6458b8d6,0x63be04c4,0x433b0158,0xc1ca0bb8}},	//   _sivi, lepn, _זעלב, ियोग,
   {{0x2d84b8d7,0x61ed38d8,0xdb1c38d9,0x798638da}},	//   rame_, _roal, _barç, dakw,
   {{0xdee68b9c,0xa01b04b8,0x61ed0812,0xdb1ab8db}},	//   _пози, rsök, _soal, leté,
   {{0x645891b9,0x645d8091,0x629e38dc,0x59dd001b}},	//   _vivi, ísir, nupo, यालर,
   {{0x2d820025,0xdb1a8019,0xf54f0a2c,0xaca48133}},	//   _neke_, neté, _bụla_, _abụz,
   {{0xa3c238dd,0x66040ce1,0xed59811f,0x61ed0493}},	//   ्या_, dhik, teže_, _voal,
   {{0x2bd7823c,0x629e279f,0xa91db8de,0xdb1c360c}},	//   _भोपा, kupo, _idžt, _garç,
   {{0x79862f0b,0x764d03bf,0xed599502,0xf647016c}},	//   bakw, tmay, reže_, ехан,
   {{0xbddb02be,0xe9ff801c,0x7bdc01ec,0x7bca925c}},	//   _thèm, _phận_, _anru, _hafu,
   {{0xdbf98063,0x76aa8201,0x764d38df,0x5d550ae7}},	// [25b0] _głów, _dəyi, rmay, ткат,
   {{0xb60381ac,0x7bca87de,0xdd868061,0xb60680ce}},	//   čšin, _jafu, _ھو_, lešć,
   {{0x7bca822e,0x2489153a,0x764d01cc,0xb05b0338}},	//   _mafu, ssam_, pmay, sväs,
   {{0x660438e0,0x38a9b8e1,0xe9ff80ff,0x7bcab8e2}},	//   chik, túr_, _thận_, _lafu,
   {{0x8fa599b8,0x69cb89ff,0x491180c2,0x28f8804a}},	//   вале, rdge, _देशो_, нець_,
   {{0x7bca819e,0xe7398ce6,0x673a8123,0xe8d9027d}},	//   _nafu, мел_, _bytj, _ngọ_,
   {{0x38a981a8,0xd00eab7e,0x798629f7,0x3d150072}},	//   súr_, تلو_, yakw, _नेते_,
   {{0xa91da35d,0x53340615,0xeac9877f,0xed59a1f6}},	//   _vežb, _сест, _rẹ_, мой_,
   {{0xdb1c03bf,0x6e3b8359,0x7bcaa016,0xf1bf00e1}},	//   _parç, rlub, _bafu, deá_,
   {{0x75f5803e,0x798638e3,0x6e3bb8e4,0x7bca87b6}},	//   _názv, wakw, slub, _cafu,
   {{0xf1dd053e,0x91f581ab,0x798638e5,0xfbd20039}},	//   यांन, _आवाज_, takw, בתי_,
   {{0x22490205,0xa5bb007b,0x3f87b8e6,0xe8d9019d}},	//   _chak_, _sjón, lanu_, _egọ_,
   {{0x2d8238e7,0x7986062b,0xd9e380ab,0x63b50654}},	//   _reke_, rakw, _মতাম, _obzn,
   {{0xdb1a8065,0x35a7800f,0x3dcdb8e8,0x2d8238e9}},	//   zeté, _गाड़, ldew_, _seke_,
   {{0x443338ea,0x2d8238eb,0x660438ec,0xb05b0106}},	//   dox_, _peke_, thik, tvär,
   {{0x6b839755,0x25bf82b1,0xf1bf00f7,0xdb0181ec}},	//   _heng, neul_, ceá_, rflä,
   {{0x2cada543,0x443338ed,0x7bca9d1b,0x6b83b8ee}},	// [25c0] nted_, fox_, _yafu, _keng,
   {{0x395f9e59,0x660438ef,0x389b0158,0x0e6600ae}},	//   _agus_, shik, _קיינ, _икон,
   {{0x6b839dae,0x201838f0,0x3f87b8f1,0x395f8359}},	//   _meng, miri_, danu_, _bgus_,
   {{0x629e38f2,0x201838f3,0xb33c84b7,0x63be02f7}},	//   rupo, liri_, ngħa, sepn,
   {{0x629e38f4,0x25bf82b1,0x2cadb358,0xf1aa0c28}},	//   supo, deul_, jted_, _कानन,
   {{0x9346217e,0x3f87b30d,0xe9ff8028,0xf1e40105}},	//   _анге, ganu_, _phản_, गाड़_,
   {{0xcac702de,0x2ca00fb0,0xa2e338f5,0x1ae30436}},	//   _игре_, luid_, _корд, _корм,
   {{0x645c011e,0x201838f6,0x7c3e1ff5,0x25bfb8f7}},	//   _hiri, hiri_, llpr, geul_,
   {{0x201838f8,0x6b83b8f9,0x443838fa,0x69d3826f}},	//   kiri_, _beng, _kkr_, ádež,
   {{0x69a5035a,0x645c38fb,0x201838fc,0x44382daf}},	//   _काही, _jiri, jiri_, _jkr_,
   {{0x6b839dae,0x201820eb,0xcfa99a3c,0x25bf8a2a}},	//   _deng, diri_, _سالم_, beul_,
   {{0xc333073a,0x7a388510,0x645c38fd,0x7bcaa73f}},	//   יות_, pítu, _liri, _wafu,
   {{0x6b83b6bd,0x2cad8051,0x201838fe,0x7bca8b4a}},	//   _feng, cted_, firi_, _tafu,
   {{0x6b83b8ff,0xdb1703a7,0xaca4082e,0x3eba02f7}},	//   _geng, nexã, _chọr, _bppt_,
   {{0x6602a2ba,0xbe881d51,0x6d460102,0x7a3d0036}},	//   _klok, ксте_, _azka, héti,
   {{0x443eb900,0x645c3901,0x3f878024,0xa91db8b7}},	//   llt_, _airi, zanu_, _leža,
   {{0x645c3902,0x20180542,0x73d9221f,0x6b838d4e}},	// [25d0] _biri, biri_, ндар_, _yeng,
   {{0x33740b01,0xaca40133,0x46ac06a7,0x25bf8087}},	//   игур, _ghọr, _चहचह, zeul_,
   {{0x443eb903,0x6602b904,0x3f87b905,0x7d09847f}},	//   ilt_, _olok, vanu_, zzes,
   {{0x443e82af,0x645c3906,0xa2940d8e,0x3f87b907}},	//   hlt_, _eiri, раці, wanu_,
   {{0x69349d85,0x3f878a3b,0xa91db908,0xe1348110}},	//   анцу, tanu_, _beža, анцы,
   {{0x645c3909,0x660292bf,0x13a7015b,0x2fde8118}},	//   _giri, _alok, _جنسی_, _cntg_,
   {{0x6b83b90a,0x7a388065,0x6b888144,0x2be00f97}},	//   _reng, gíts, dadg, नारा,
   {{0x6b83a4ff,0x2018390b,0x656d355e,0x9d458b79}},	//   _seng, ziri_, ncah, лейд,
   {{0x6b83859c,0x629ab90c,0x765d2ac5,0x89378875}},	//   _peng, erto, _misy, _شعرا,
   {{0x6602b029,0x60c9b90d,0x645c02a3,0x2cadb90e}},	//   _elok, _isem, _xiri, rted_,
   {{0x6602b90f,0x2cadb910,0x6b83b911,0x7d09900b}},	//   _flok, sted_, _veng, szes,
   {{0x6b83b912,0x201837a3,0x3f85b913,0x443eb914}},	//   _weng, wiri_, _helu_, alt_,
   {{0x25e0853f,0x20183915,0x657b903b,0x6b888079}},	//   कारी_, tiri_, mbuh, badg,
   {{0x9d1a8158,0x5ebb00c8,0x60c9b916,0x765d178f}},	//   _אונט, _উপজে, _msem, _aisy,
   {{0x20183917,0x657b82a5,0x7bc18e9a,0x3f85b918}},	//   riri_, obuh, melu, _melu_,
   {{0x645c3919,0x2018391a,0x60c9b91b,0xa3cc0beb}},	//   _siri, siri_, _osem, _शोज_,
   {{0x271f890a,0x20182605,0x765d391c,0x248db91d}},	// [25e0] यपुर_, piri_, _disy, nsem_,
   {{0xdb150118,0x20180168,0xdb08b91e,0x6d4603c1}},	//   _nazó, qiri_, yedü, _vzka,
   {{0x645c391f,0x60c9b920,0xa91d99b7,0x200783ed}},	//   _viri, _asem, _reža, dhni_,
   {{0x7a3d10dd,0x645c3921,0x3f8a3922,0x248db923}},	//   téti, _wiri, labu_, ksem_,
   {{0x645c3924,0x7bc1a5e0,0x3f85b925,0x44383926}},	//   _tiri, kelu, _belu_, _tkr_,
   {{0x3f85b927,0x67d4af84,0x7a3d0866,0x645c051e}},	//   _celu_, року, réti, _uiri,
   {{0x60c9b928,0x7bc1b929,0x3f858b89,0x6602b92a}},	//   _esem, delu, _delu_, _plok,
   {{0x4427826c,0x7bce392b,0x3f8a2813,0x629a80e1}},	//   _ajn_, _habu, habu_, vrto,
   {{0xa91d86c2,0x2fde80dd,0xed59812b,0x7a3881ad}},	//   _teža, _tntg_, teža_, síts,
   {{0x7bc1844e,0x20078b04,0x443eb92c,0x7bce392d}},	//   gelu, chni_, ult_, _jabu,
   {{0x7bce31fe,0xd43700be,0xed59826c,0x81ce0264}},	//   _mabu, רטיי_, reža_, রান_,
   {{0x7bce392e,0x5fe2863a,0x6602922e,0xd7e28072}},	//   _labu, पावल, _ulok, पावच,
   {{0x7bc1a13f,0x78a281e8,0x765d00b9,0x69cf0106}},	//   belu, nuov, _risy, rdce,
   {{0x7bce392f,0xdb1ab930,0xb8ed03e8,0xbcfb0118}},	//   _nabu, letí, _रन_, _ofér,
   {{0x3219096a,0xa91db931,0xf3f90087,0x78a29639}},	//   pisy_, _nežn, _îţi_, huov,
   {{0xe66410f8,0x7bce3932,0x2bc706a7,0x78a2b933}},	//   стро, _aabu, रजभा, kuov,
   {{0x3f8a022e,0x2616108a,0x7bce2ae5,0x69c28bc5}},	// [25f0] babu_, _नगरी_, _babu, deoe,
   {{0x59dd016f,0x26e49d89,0xa91d81ac,0x5d541860}},	//   याकर, _कपूर_, _bežn, скут,
   {{0x753d0063,0xdb152d11,0x7afa8f06,0x63a501a8}},	//   _wysz, _razó, nytt, rghn,
   {{0x3f858067,0x6562836a,0x2614016f,0x7bc1b934}},	//   _selu_, _ngoh, नोदी_, zelu,
   {{0x3f8590ab,0xa3d486ab,0x7afa8d1a,0x2259128a}},	//   _pelu_, हया_, hytt, írky_,
   {{0xb8cd923a,0xb4c101fe,0xa3ac01b6,0xa3c21905}},	//   _कम_, ंबी_, _गाय_, ्यः_,
   {{0x7bc1802e,0x2c6980e1,0x69c29c11,0x3f858609}},	//   velu, _súd_, beoe, _velu_,
   {{0x7bce3935,0x2007b936,0x6b870b80,0x7bc1b937}},	//   _zabu, shni_, _hejg, welu,
   {{0x81ce0a49,0xccf20158,0x7bc1b938,0xb882000d}},	//   রাম_, ַכט_, telu, říze,
   {{0x3ea300f1,0x798bb939,0x1da781ab,0x5e8781e2}},	//   kujt_, lagw, _गावत, _будз,
   {{0x200581b9,0x248db666,0xa72000ab,0x7bc18087}},	//   _illi_, ssem_, _ধর্ম_, relu,
   {{0x186a0c8e,0xdb0529ed,0x7bc1abf2,0xc04903c8}},	//   ками_, behö, selu, _חז_,
   {{0x39490063,0x3f8a393a,0x7d0d0bcf,0x2b158074}},	//   _czas_, tabu_, jzas, _फेरु_,
   {{0x2bd505b3,0x661b8110,0x68e204b7,0x8fa600a9}},	//   _डोला, liuk, _ġodd, јаве,
   {{0x7bce393b,0x539a8039,0x3f8a393c,0xe73a0323}},	//   _rabu, _סיקו, rabu_, тев_,
   {{0x7bce393d,0x3f8a004f,0x75f5816b,0xa91d81f4}},	//   _sabu, sabu_, _zázr, _režn,
   {{0xdca60ba8,0xd46718a0,0x7bce1b4d,0xed5a00a9}},	// [2600] рази, иите_, _pabu, тоа_,
   {{0x9f4c25b3,0x7bce393e,0x4f96393f,0x25ab0609}},	//   ódó_, _qabu, _триу, _eccl_,
   {{0xbf9b012a,0x6441b940,0x213f8748,0x661bb941}},	//   _בייש, illi, _ayuh_, kiuk,
   {{0x7bce0533,0x64a63197,0xbcfb0019,0x2005b942}},	//   _wabu, _кама, _igén, _alli_,
   {{0x7fe9019f,0xe7e29a1c,0xb5fb0118,0x5fe2801b}},	//   _شریف_, पालप, _fiáb, पालल,
   {{0xdb17002a,0x7afa8198,0x224d9fa4,0x26da1502}},	//   sexá, yytt, _ehek_, _krpo_,
   {{0x9e06a3e0,0xddc400eb,0x2900a8c4,0x42d505a8}},	//   ичил, rmiņ, šia_, _літу,
   {{0xa01b2522,0x64418009,0xdef78190,0x88818065}},	//   nsör, elli, рыш_, _کیون,
   {{0xafe6b943,0xa06a8198,0x75fc8176,0x07a69fab}},	//   _коал, _раза_, _jézi, _вазн,
   {{0x34b70051,0xe9ff8104,0xf366a550,0x690883bf}},	//   ספים_, _phần_, штин, ırdı,
   {{0xa3ab1391,0x8aa39fb4,0x6609805d,0x03d7007c}},	//   क्ट_, оряд, bhek, בוים_,
   {{0xf2d30158,0x9f5800f7,0x6609804f,0x6441b853}},	//   קער_, bhrú_, chek, alli,
   {{0x1bd48698,0xc31a00c8,0xbcfb3353,0x7afa8009}},	//   _голя, _তুমি_, _agén, sytt,
   {{0xe9ff8028,0x2005007b,0x9f4c816b,0x331780d7}},	//   _thần_, óli_, _lodí_, ازید_,
   {{0x543980be,0x798b8545,0xf8ae053d,0xc66809a5}},	//   _געװא, yagw, وکی_, иште_,
   {{0x442a3944,0x7a2801cc,0xe9df002a,0x443c80c3}},	//   _ajb_, nıtl, flúe_, _hkv_,
   {{0xf36701f3,0x39490289,0x442a3945,0x201cb307}},	// [2610] атен, _uzas_, _bjb_, kivi_,
   {{0x60cd3946,0x442a0b80,0x81ce00ab,0x224d8168}},	//   _isam, _cjb_, রাণ_, _shek_,
   {{0xb5fb0118,0xa91d81a1,0x2c7d0032,0x931901a8}},	//   _viáb, _pežo, _bádò_, دقاء_,
   {{0x38690748,0xa2d7b947,0x644e0f3e,0xdb019277}},	//   _kuar_, यित्, _ehbi, rflø,
   {{0x98c7917e,0xe9df04c3,0x442a1142,0xe9ff801c}},	//   рсел, clúe_, _fjb_, _nhấn_,
   {{0x38693948,0x25a93949,0x60cd004f,0x7e68810c}},	//   _muar_, lgal_, _msam, _budp,
   {{0x386914ff,0x6609b94a,0xa91d817f,0x2294160e}},	//   _luar_, thek, _težo, _миря,
   {{0xc485b6ab,0x25a9394b,0xf1cf8105,0x5bc711bc}},	//   блик, ngal_, _सोचन, _रघुव,
   {{0x201c811f,0x999f826f,0x386900b9,0xe9ff80ff}},	//   bivi_, _chuť_, _nuar_, _chấn_,
   {{0x75f58feb,0xf09f394c,0x6609b94d,0x2005b94e}},	//   _vázq, drà_, shek, _ulli_,
   {{0xd7f88554,0x60cd394f,0x7c2200e7,0xf09f047f}},	//   _тут_, _asam, éori, erà_,
   {{0xa3de035a,0x60cd00b9,0x7bc50168,0x6441b950}},	//   _दोन_, _bsam, hehu, slli,
   {{0x7bc521ad,0xed4e9da9,0xa3e803db,0x7989b951}},	//   kehu, _хо_, _मचल_, _meew,
   {{0x6d4bb952,0x438580f7,0x183580be,0x7989b953}},	//   _izga, _الثق, מאָל_, _leew,
   {{0x60cd3954,0xa3ab0cf0,0xf09f023e,0x249f9a16}},	//   _esam, क्छ_, arà_, lrum_,
   {{0x25a9015b,0x60dbb955,0x38693956,0x4d66044f}},	//   ggal_, _orum, _fuar_, скав,
   {{0x61e428af,0xe3ba0fbe,0x7a3d007b,0x1b1500ab}},	// [2620] _inil, лба_, rétt, _তুলে_,
   {{0x69c63957,0x25a900f7,0xf1bf00f7,0x7bc53958}},	//   leke, agal_, nnán_, gehu,
   {{0xa3b92cdd,0x60dba60d,0x7a280214,0x59dd06ae}},	//   _अउर_, _arum, yıtl, याचर,
   {{0x61f60901,0xdb1a87f0,0x7a3d3959,0x994a81a8}},	//   _joyl, netá, létr, هلال_,
   {{0x201cb95a,0x2d80063c,0x10a3b95b,0x98a392b2}},	//   tivi_, mbie_, зичн, зиче,
   {{0x60dba37a,0x7644395c,0x7a3d2ad5,0x69c613fa}},	//   _drum, lliy, nétr, heke,
   {{0xfaa32cd1,0x69c6395d,0x201c939a,0x443a056a}},	//   _наро, keke, rivi_, mop_,
   {{0x4444395e,0x60dbb95f,0xa3c20076,0x5c74917f}},	//   ll_, _frum, ्यक_, олит,
   {{0x69c60065,0x8cdb01a2,0x60dbb960,0x2a6a00b9}},	//   deke, नियो, _grum, _hubb_,
   {{0x61e43961,0xda7a8d70,0x44443962,0x443a000b}},	//   _anil, лям_, nl_, nop_,
   {{0x44441dad,0x76443963,0x61f63964,0xdb1a8144}},	//   il_, kliy, _boyl, fetá,
   {{0x69c63965,0x64a6add0,0x444413ac,0xf09f1e06}},	//   geke, _гада, hl_, trà_,
   {{0x443a3966,0x41aa101e,0x63bc0824,0x4444083d}},	//   kop_, _कारस, _obrn, kl_,
   {{0x3e6e000d,0x44443967,0xf09f19bf,0x6e3d00b9}},	//   _být_, jl_, rrà_, _sksb,
   {{0xd5bb17d6,0x69c63968,0x76443969,0xa3d5801b}},	//   лса_, beke, fliy, ाएर_,
   {{0x4444396a,0x60cd396b,0x7c3ab732,0x69c6396c}},	//   el_, _tsam, lotr, ceke,
   {{0x320910ba,0x6fa9816f,0x7bc5396d,0x3f8eb0a0}},	// [2630] _ilay_, _घालू, tehu, kafu_,
   {{0xf367396e,0x4444396f,0x7b671287,0x7c28b970}},	//   стан, gl_, стае, nndr,
   {{0x76443971,0x2ca00074,0xb99592c8,0x2367007a}},	//   bliy, arid_, قلاب, žnjo_,
   {{0xddc1802e,0x80cc00ab,0x7a28011c,0xdb088338}},	//   _mulţ, ামর্, yıtm, bedö,
   {{0x4444031d,0xb05b00e1,0x7bc53972,0x3f8e89ab}},	//   bl_, dväz, pehu, fafu_,
   {{0x69c63973,0x7c3a9c67,0x63bc008e,0x249fb974}},	//   zeke, jotr, _gbrn, vrum_,
   {{0x41aa0f12,0x2d8b0679,0x1dda8105,0x3209007e}},	//   _कालस, _kece_, _मोहत, _olay_,
   {{0xa3e70076,0xf1d9000f,0xd346003d,0x64453975}},	//   भाव_, _बोलन, _بیمه_, llhi,
   {{0x7c3ab976,0xdb1e0087,0x60dbb977,0x69c61104}},	//   fotr, cepâ, _urum, veke,
   {{0x32093978,0x69c63979,0x61e4397a,0x249fb97b}},	//   _alay_, weke, _snil, rrum_,
   {{0x69c6397c,0x2fc7b97d,0x5fae816f,0x26c101c0}},	//   teke, meng_, _घातल, _npho_,
   {{0x2d8b02a5,0x2fc7b97e,0x3ea78722,0xf1bb80d4}},	//   _nece_, leng_, munt_, ोजिन,
   {{0x6e3b8024,0x443a10c1,0x29041ef5,0x660d003d}},	//   moub, yop_, áma_, dhak,
   {{0x69c6397f,0x2fc783f8,0x78a60289,0x290c009a}},	//   seke, neng_, rukv, ąda_,
   {{0x4444006a,0xdb1ab980,0x69c63981,0x764407c0}},	//   vl_, petá, peke, tliy,
   {{0x3d150665,0x2fc7b982,0x2d8b3983,0x660d0ec9}},	//   _नइखे_, heng_, _cece_, ghak,
   {{0x2d8b0eef,0x76440201,0x2fc7b984,0x44442ead}},	// [2640] _dece_, rliy, keng_, tl_,
   {{0x44443985,0x2fc78077,0xa91d82d4,0x41aa03eb}},	//   ul_, jeng_, _težj, _काँस,
   {{0x42ca0071,0x443a3986,0x2fc7b987,0x2d8b047f}},	//   рген_, rop_, deng_, _fece_,
   {{0xa3d58063,0xe0da9935,0x660d3988,0xfce616df}},	//   ाएँ_, иве_, chak, _домо,
   {{0x7e628118,0x7c288558,0x9989136f,0x660403e4}},	//   _riop, yndr, _dlaň_, mkik,
   {{0x2bae9305,0x7e62b989,0x2fc7b98a,0xdc3987c0}},	//   ज्ञा, _siop, geng_, kçıl,
   {{0x491a800d,0x23270098,0xe2970d5f,0x6fad000f}},	//   _मेरो_, _дори_, _мар_, _जासू,
   {{0x16378013,0x7ae10065,0xd5b78987,0xb5fb36fa}},	//   يسية_, _álta, ось_, _lián,
   {{0xa3d58063,0x3f8e84cd,0xf6530039,0x7982a4f2}},	//   ाएं_, pafu_, וצה_, mbow,
   {{0x22400019,0x3ea78176,0x224681b9,0x60cd9b26}},	//   _akik_, bunt_, llok_, çame,
   {{0x32092a92,0xdd8f8279,0xe73a804a,0x66042c6b}},	//   _play_, _ош_, _теж_, kkik,
   {{0x7c3ab98b,0x601000f2,0x80ac0816,0x2246808e}},	//   sotr, _jämf, _जमशे, nlok_,
   {{0x7c3ab98c,0xfbcf87d2,0x2d8b398d,0xd2580a8e}},	//   potr, رتی_, _rece_, юць_,
   {{0x6e20b98e,0x39450029,0xd83b22f0,0xb4d690be}},	//   limb, āls_, рэм_, ाटी_,
   {{0x28d1800c,0x2246b98f,0x660d0c14,0x78a2826c}},	//   _दैनि, klok_, thak, hrov,
   {{0x6e208397,0x2246b990,0xdb1c02af,0xa5bb008b}},	//   nimb, jlok_, _darü, _njót,
   {{0x2d8b0052,0x660d3991,0x31690019,0x78a288ae}},	// [2650] _vece_, rhak, _igaz_, jrov,
   {{0x660d0578,0x6e20b992,0xdb1c3993,0x69bc0f8d}},	//   shak, himb, _naró, ष्ठी,
   {{0x3f913994,0x6e209e45,0xa91d8353,0x660d005d}},	//   mazu_, kimb, _težk, phak,
   {{0x3f91005c,0xdce982ee,0x2fc7b995,0x2a649600}},	//   lazu_, zbeđ, weng_, _cimb_,
   {{0x2fc783f8,0x78a2826f,0xdb1c016a,0xdb150187}},	//   teng_, grov, _baró, _razõ,
   {{0xf77185ff,0xdb1c01df,0xa3da9344,0x7bc88369}},	//   رات_, _caró, _ढोल_, jedu,
   {{0x2fc7b996,0x44210824,0x224693eb,0x63b405b9}},	//   reng_, mih_, blok_, žený,
   {{0x3ea7b997,0x2fc7b998,0xc4859e25,0xed599024}},	//   runt_, seng_, плик, leži_,
   {{0x629c84c3,0x2fc78d6d,0x6e299dcb,0x442e81a1}},	//   áron, peng_, rneb, _bjf_,
   {{0xa91db999,0x3ea7b99a,0xdc39880a,0x7bc8b99b}},	//   _neži, punt_, tçıl, gedu,
   {{0x7bd5399c,0xf8a9010f,0x6e20b99d,0x661d307d}},	//   _mazu, _תש_, bimb, _omsk,
   {{0x44211600,0xdeba8039,0xdb1c0035,0x06c380ab}},	//   hih_, _למעל, _zaró, ্মদি,
   {{0x4421399e,0xfce5b99f,0x3e71b9a0,0xa5bb0125}},	//   kih_, _холо, _hát_, _ljós,
   {{0x442102f7,0xed59b5b2,0x913a80be,0x7bc8b9a1}},	//   jih_, ježi_, מערק, cedu,
   {{0x26de01df,0xa3c10ebf,0x8c3d8214,0xdee334bf}},	//   íto_, ्जन_, nuşm, нори,
   {{0x799b8077,0x3e71801c,0x386d81b0,0x8afa81c6}},	//   _nduw, _mát_, _ouer_, _להצי,
   {{0x3e71b9a2,0x660439a3,0x7bd539a4,0x386d8326}},	// [2660] _lát_, rkik, _bazu, _nuer_,
   {{0x660439a5,0x7bd50012,0x6e20b3cd,0x69d601b4}},	//   skik, _cazu, zimb, _haye,
   {{0x3f8c8805,0xe6460a13,0x38b60e34,0x6e20b9a6}},	//   _redu_, _неоп, lær_, yimb,
   {{0x23720029,0x3f8cb9a7,0x69d6010c,0x7bc8811b}},	//   _šajā_, _sedu_, _jaye, zedu,
   {{0x4421048f,0x69d6298f,0x38b600b2,0x6e208234}},	//   bih_, _maye, nær_, vimb,
   {{0x2d9239a8,0x4421135a,0x25adb9a9,0x3e71b9aa}},	//   laye_, cih_, egel_, _bát_,
   {{0xc0598cde,0x7bc8b9ab,0x3e7180ff,0xdb1c0511}},	//   ції_, vedu, _cát_, _varó,
   {{0x3e71826f,0x78a2b9ac,0x25adb9ad,0x69d61f4b}},	//   _dát_, prov, ggel_, _naye,
   {{0x6e20b9ae,0x7bd50309,0xb4d68744,0xb05b0106}},	//   rimb, _yazu, ाटे_, pväx,
   {{0x6e2081d3,0x798d30b2,0x2d9239af,0x6d4600ee}},	//   simb, _seaw, haye_, _myka,
   {{0x69d639b0,0x600b0201,0x60c439b1,0x26de80e5}},	//   _baye, _nüma, _apim, _urto_,
   {{0x69d639b2,0xa3de10f7,0x38b60e51,0xb05b0865}},	//   _caye, _दोस_, fær_, hwät,
   {{0xb5fb2a63,0x7bc8b9b3,0x2d9239b4,0x5c068098}},	//   _diál, pedu, daye_, _няка,
   {{0xdb1a8009,0xba73803d,0x7c3e026c,0x545380e8}},	//   tetä, بایت, jopr, _звіт,
   {{0x645a8125,0x69c081ac,0x98be00eb,0xdd9b0a42}},	//   mmti, _obme, ātā_, йша_,
   {{0x443eb72f,0x442103f8,0x2d9239b5,0x7e6600b9}},	//   lot_, wih_, gaye_, _cikp,
   {{0x42380bea,0xa91d803a,0xed5980fe,0x200c852a}},	// [2670] _מנהל_, _teži, teži_, _oldi_,
   {{0x443eb9b6,0xf0920bea,0x442cb9b7,0x69c08192}},	//   not_, _שני_, nnd_, _abme,
   {{0x2d9239b8,0x442139b9,0x7bd5002e,0x8c4181ec}},	//   baye_, rih_, _vazu, äßig,
   {{0x442114e5,0xa2a483eb,0x200c89e8,0x661d39ba}},	//   sih_, _किन्, _aldi_, _umsk,
   {{0x443eb9bb,0xddc41010,0x386d8073,0x89378013}},	//   kot_, lmiş, _quer_, أعضا,
   {{0xd3668013,0x443e8029,0x442101a5,0x7642930c}},	//   _له_, jot_, qih_, _akoy,
   {{0x443eb9bc,0x6e2d39bd,0x29021d21,0xddc40457}},	//   dot_, onab, zyka_, nmiş,
   {{0x6e2d02ec,0x6448a023,0x442c9527,0xcfcd80ab}},	//   nnab, eldi, end_, লাইন,
   {{0x62988081,0x442c807b,0x443eb9be,0x4c358084}},	//   _avvo, fnd_, fot_, дэнт,
   {{0x443eb9bf,0x69d9a9d8,0x69d639c0,0x69cbb2c7}},	//   got_, ldwe, _saye, lege,
   {{0x61fbb9c1,0x81d700ab,0xdb1c007b,0x69d612b6}},	//   _koul, সান_, _jarð, _paye,
   {{0x69d9b9c2,0xa3c10076,0x29020063,0x61fb8009}},	//   ndwe, ्जड_, tyka_, _joul,
   {{0x200403a7,0x515539c3,0x6e2d0114,0xaca381bc}},	//   êmio_, етру, dnab, _maịk,
   {{0xb8f61008,0x443eb9c4,0x61fba1bf,0x69d6029b}},	//   _सन_, cot_, _loul, _waye,
   {{0x7c3e007d,0xf7430767,0x7f430009,0x2d9239c5}},	//   vopr, веро, верж, taye_,
   {{0x237801dd,0x6e2d39c6,0x69cbb9c7,0x249900b9}},	//   _sfrj_, gnab, jege, _bvsm_,
   {{0x7c3e39c8,0x2d9239c9,0x69cbb9ca,0x60c425f4}},	// [2680] topr, raye_, dege, _upim,
   {{0x2d8f8c39,0x61e9b9cb,0x2d9239cc,0xa91d81a1}},	//   _lege_, _anel, saye_, _ježu,
   {{0x61fbb9cd,0x76499632,0x320d828d,0x628182d6}},	//   _boul, kley, _bley_, nplo,
   {{0x61fb8809,0x69cb8c1b,0x6b8e0102,0x443eb9ce}},	//   _coul, gege, _webg, zot_,
   {{0x443eb9cf,0x442c807b,0x64488bbd,0x61fbb9d0}},	//   yot_, ynd_, yldi, _doul,
   {{0xd12f9a37,0x6e2439d1,0x656b80e5,0x237802df}},	//   جمه_, liib, _aggh, _ufrj_,
   {{0x443e86d4,0xdb1c007b,0x61fbb9d2,0x2d8fb9d3}},	//   vot_, _garð, _foul, _bege_,
   {{0xceb30051,0xd49a813a,0x3ea0801b,0x442cb9d4}},	//   דיה_, оро_, čit_, wnd_,
   {{0x443eb9d5,0x7d040a40,0x64a383a7,0x2d8fb9d6}},	//   tot_, nyis, вања, _dege_,
   {{0x442c8051,0x61fb8bfe,0xed598654,0x9f5a03ed}},	//   und_, _zoul, ježu_, _copë_,
   {{0x443ea638,0xa3c10054,0x442cb9d7,0x271c8264}},	//   rot_, ्जत_, rnd_, _পুরো_,
   {{0x443eb9d8,0x2d8f90ab,0x20ca0540,0x7d040009}},	//   sot_, _gege_, िबंध, kyis,
   {{0xb4bd1880,0x9cb381a8,0xe8e081bc,0x6e2401b4}},	//   _आहे_, _لمنت, daịs_, diib,
   {{0x36d5146c,0xdb1e0187,0xa29483a9,0x2d8fb9d9}},	//   ногр, cepç, _закі, _zege_,
   {{0x80d5800f,0x69cbb9da,0x683f01d0,0xc5fb0073}},	//   _मैने, yege, vádě, оѓа_,
   {{0xc3338039,0xddc40059,0x7640b9db,0x7bd88bdf}},	//   _שוק_, rmiş, nomy, _havu,
   {{0x61fb9dac,0x69cbb9dc,0x7bd8b9dd,0x54550103}},	// [2690] _roul, vege, _kavu, еват,
   {{0x69cbb9de,0x61e9b9df,0x61fbb9e0,0x2a69022c}},	//   wege, _snel, _soul, _hiab_,
   {{0x69cbb9e1,0x61fbb9e2,0x2a690069,0x7640b9e3}},	//   tege, _poul, _kiab_, komy,
   {{0x7bd8b9e4,0xdb1c007b,0x7640809a,0xe4a70087}},	//   _lavu, _varð, jomy, _орго,
   {{0xf1c1052a,0x61fb82be,0x69d9800b,0x7d16009a}},	//   ष्यन, _voul, rdwe, czys,
   {{0x61fbb624,0x2a6901c5,0x78ab8cfa,0x7bd8ace3}},	//   _woul, _liab_, rugv, _navu,
   {{0x61fba7a7,0x7649b9e5,0x69cbaf5f,0x2007b9e6}},	//   _toul, tley, pege, rkni_,
   {{0xb8d580c8,0x61e9b9e7,0x2a69022c,0x6ec206a7}},	//   _জন_, _unel, _niab_, _लहसु,
   {{0x3e7539e8,0xdd918117,0x7bd8b9e9,0x3949022c}},	//   _låt_, نوں_, _bavu, _nyas_,
   {{0x7649b9ea,0x6281b52e,0x3707a240,0xaf078992}},	//   sley, tplo, _очев, _очек,
   {{0x3e75016d,0x76498ce9,0x7bd8b9eb,0xdbcc9434}},	//   _nåt_, pley, _davu, róðu,
   {{0x2a69022c,0x7afc816d,0xaca38135,0x6e240079}},	//   _ciab_, ärta, _abụk, xiib,
   {{0xa3c1053f,0x7bd8822b,0xed59812b,0x2a690176}},	//   ्जा_, _favu, težu_, _diab_,
   {{0x7bd8b9ec,0x66099dcb,0x39490122,0x3d188035}},	//   _gavu, lkek, _dyas_, _बेटे_,
   {{0x7bc3836e,0x6e2402ec,0x2a690037,0x84648081}},	//   _ibnu, tiib, _fiab_, _ръце,
   {{0x7d040364,0x6441b9ed,0xee3a00e8,0x7bd89acc}},	//   tyis, loli, їна_, _zavu,
   {{0x44259a29,0xdca30e6b,0x7bd882a0,0x64a30f04}},	// [26a0] oil_, лати, _yavu, лата,
   {{0x7d160d38,0xa3e7073c,0x4425b9ee,0x68e439ef}},	//   rzys, भाग_, nil_, _irid,
   {{0xa3b7835a,0x387f9e03,0xad9b39f0,0x68e40140}},	//   _छान_, _atur_, _clús, _hrid,
   {{0x44259882,0xa2d51516,0xaca401bc,0x68e439f1}},	//   hil_, णिज्, _ajụr, _krid,
   {{0x6441b7c2,0x394901c0,0x69c439f2,0xc0e38a41}},	//   koli, _xyas_, _mbie, лоцк,
   {{0x4425ac17,0x2ab88065,0xe8d9001c,0x64418805}},	//   jil_, yéb_, _ngờ_, joli,
   {{0x6441b9f3,0x69c439f4,0x0cd0146d,0xa3e70254}},	//   doli, _obie, _हनुम, _ядра_,
   {{0x6ed38086,0x7bd8b9f5,0x68e4026c,0xe7e080d4}},	//   _xəbə, _savu, _orid, _गोरा_,
   {{0x6441b9f6,0xddde00eb,0xf8d49513,0xdb1e2551}},	//   foli, _atpū, _धनिय, sepä,
   {{0x69c439f7,0x6441b9f8,0x2a6910af,0x600b0059}},	//   _abie, goli, _siab_, _cüml,
   {{0x68e439f9,0xa3b6801b,0x2a6901c0,0xdb1c08f1}},	//   _arid, ङ्ग_, _piab_, _obrí,
   {{0xdc12817b,0xc3330039,0x44258c5e,0x7bd8b9fa}},	//   rşıl, טות_, ail_, _wavu,
   {{0x6e22b9fb,0x68e439fc,0x3d189513,0xc05b00e8}},	//   _imob, _crid, _बेचे_, зів_,
   {{0x4425b9fd,0x6441b9fe,0x20d60efd,0x6ed38201}},	//   cil_, coli, džić_, _səbə,
   {{0x9f34021e,0x68e434c2,0x2a690282,0x80c400ab}},	//   гері, _erid, _tiab_, শিষ্,
   {{0x68e439ff,0xe7e786a7,0x45d4004a,0x44d202d6}},	//   _frid, _टोना_, лосс, _bņ_,
   {{0x629aa187,0x629c0201,0x61ed3a00,0x68e40653}},	// [26b0] lsto, _avro, _inal, _grid,
   {{0x69cf0179,0x69c4219c,0x600b03e3,0xdb01ba01}},	//   lece, _zbie, _kümm, rflö,
   {{0xd0110117,0x61ed3a02,0xdb1a806a,0xc1740041}},	//   _ملک_, _knal, getø, _haɗa_,
   {{0x69cf3a03,0x6441ba04,0xdbd708e5,0x629aba05}},	//   nece, zoli, _sääs, isto,
   {{0x629c3a06,0xdbd703ff,0x44259072,0x6441ba07}},	//   _evro, _pääs, yil_, yoli,
   {{0x63552748,0x44258201,0x44251bc0,0x2ca93a08}},	//   _авгу, xil_, _öl_, mrad_,
   {{0x629a803b,0x25bfba09,0x61ed3a0a,0x4425ba0b}},	//   jsto, tful_, _onal, vil_,
   {{0x62850c63,0x4425ba0c,0x78a48024,0x764d3a0d}},	//   mpho, wil_, šiva, nlay,
   {{0x629a81ac,0x6fb2009a,0x442300b9,0xc1740300}},	//   esto, _जालं, _kmj_, _naɗa_,
   {{0x2367003b,0x62853a0e,0x69db811e,0x629aba0f}},	//   žnju_, opho, _haue, fsto,
   {{0x15b981e5,0x764d07d9,0x68e40140,0x629aba10}},	//   _жылы_, klay, _srid, gsto,
   {{0x68e43a11,0x4425ba12,0xa2c40a74,0xf2d200be}},	//   _prid, sil_, _रहस्, בעט_,
   {{0x4425ba13,0x764d3a14,0x66068019,0x22423a15}},	//   pil_, dlay, ökke, rokk_,
   {{0x60c98133,0x68e40b81,0x7fd50558,0x61ed3a16}},	//   _mpem, _vrid, лісі, _enal,
   {{0x69cf0207,0xa0673a17,0x629aba18,0x80b3864a}},	//   bece, тара_, csto, उंडे,
   {{0x6458820f,0x764d3a19,0x940c0201,0xf1bf0333}},	//   _zhvi, glay, ələr_, lián_,
   {{0x2ca91487,0xdd8f0875,0x05661289,0x8e5500e8}},	// [26c0] grad_, زول_, тван, утрі,
   {{0x61ed0ebf,0x7bc1ba1a,0x6d4b851e,0x62868904}},	//   _znal, nflu, _myga, ćkov,
   {{0xe2970bac,0x3f9804b9,0x69db81ec,0x442300c3}},	//   вах_, maru_, _baue, _dmj_,
   {{0x3ced017f,0x69db9e9e,0xaca38091,0x2ca93a1b}},	//   _ševe_, _caue, _apọj, brad_,
   {{0x69db9919,0xa967951b,0xd7fa8162,0x8c3dba1c}},	//   _daue, вица_, дуй_, luşu,
   {{0xbcfb0065,0x442300ee,0x25daa743,0x9f6580e1}},	//   _egés, _gmj_, _खोजी_, _štát_,
   {{0x48ee8063,0x69cf07d9,0x59dd93ba,0x8c3d82d0}},	//   _आपको_, yece, _नोकर, nuşu,
   {{0x44443a1d,0x7bdc3a1e,0xe5c68895,0x3f983a1f}},	//   lo_, _haru, тско, haru_,
   {{0x2603a70d,0x3f9803c3,0x7bdc3a20,0x629aba21}},	//   _años_, karu_, _karu, wsto,
   {{0x44443a22,0x629a8a10,0x7bdc09ab,0x7bde000b}},	//   no_, tsto, _jaru, ndpu,
   {{0x44443a23,0x6e2281e0,0x60148722,0x81dc00ab}},	//   io_, _tmob, _càme, ঠান_,
   {{0x44443a24,0x7bdc3a25,0x3f933a26,0x7e6b8122}},	//   ho_, _laru, _sexu_, _gigp,
   {{0x44443a27,0x3e78ba28,0x69dd3a29,0xf1bf188b}},	//   ko_, _hét_, rdse, bián_,
   {{0x44443a2a,0x3e788065,0x629a84fe,0x69cf3a2b}},	//   jo_, _két_, psto, sece,
   {{0x44443a2c,0x5f943a2d,0x7c28a6ca,0xa3ac064a}},	//   do_, рист, midr, _गाज_,
   {{0x4444229d,0x3ce6805c,0x7bdc0091,0x61ed3a2e}},	//   eo_, _krov_, _aaru, _unal,
   {{0x444405ee,0x68e29487,0x7bdc3a2f,0x764d0059}},	// [26d0] fo_, jvod, _baru, rlay,
   {{0x7bdc10da,0x600b0182,0x69dbba30,0x2ca93a31}},	//   _caru, _mümk, _saue, rrad_,
   {{0x764d3a32,0xf8bf00e7,0x3e78801c,0xba7401a8}},	//   play, lté_, _nét_, لانت,
   {{0xc3338051,0x68e20029,0xb05b0884,0x60100106}},	//   בוע_, _šodi, städ, _jämn,
   {{0x44443a33,0xf8bf3a34,0x7bdc3a35,0x3ce68069}},	//   bo_, nté_, _faru, _nrov_,
   {{0x601004b8,0x7bdc37a5,0xf8bf00e7,0x8c3d82d0}},	//   _lämn, _garu, ité_, nuşt,
   {{0xaa67b1db,0x8cdb0c1c,0xf1bf0118,0x7afc8338}},	//   _атак, निको, vián_, ärtl,
   {{0x53340ab5,0x64451066,0x7bdc136f,0x6010016d}},	//   _тест, lohi, _zaru, _nämn,
   {{0xc104a181,0x29198711,0x7bdc3a36,0x660d3a37}},	//   _پولي, _åsa_, _yaru, ikak,
   {{0x6b950024,0x22490ad4,0x7bdc02a3,0xa2a480d4}},	//   _jezg, _akak_, _xaru, _किश्,
   {{0x3f983a38,0x7bc1ba39,0x660d3a3a,0xdd91803d}},	//   varu_, rflu, kkak, _هوا_,
   {{0x644504b9,0x3f980f3d,0x7999a914,0x9d199290}},	//   hohi, waru_, naww, _поет_,
   {{0x3ce68bbd,0x625880f7,0x64452020,0x7c2884e1}},	//   _grov_, líoc, kohi, bidr,
   {{0x44443a3b,0x3e718038,0x31568158,0x6e29ba3c}},	//   xo_, _ešte_, טירן_, lieb,
   {{0xdb1c0a56,0x6da61980,0x3f983a3d,0x3e78801c}},	//   _obrá, лива, raru_, _xét_,
   {{0x44443a3e,0x7bdc3a3f,0x660d04d2,0x2bc606b7}},	//   wo_, _saru, gkak, र्ना,
   {{0x44440323,0x7d098a5a,0xf8bf02be,0xe45a0abe}},	// [26e0] to_, nyes, cté_, ежа_,
   {{0x78a90904,0x2013008e,0x44441823,0x6e298192}},	//   ševc, _glxi_, uo_, hieb,
   {{0x7bdc08a3,0x91e6aeb2,0x81d700ab,0x2cbf8074}},	//   _varu, ложе, সার_, htud_,
   {{0x44443a40,0x7bdc3a41,0xe947804e,0x2cbf8122}},	//   so_, _waru, گرمی, ktud_,
   {{0x859b0051,0x7bdc3a42,0xa3b3816f,0x69c2ba43}},	//   _אשכו, _taru, टला_, rfoe,
   {{0xd6da860a,0xa2a4816f,0x44443a14,0xa0679ad8}},	//   ети_, _किल्, qo_, гача_,
   {{0x5fb20076,0x62588013,0x7c28ba44,0x645c00e1}},	//   _जाईल, ríob, vidr, _ihri,
   {{0x3ce6888b,0xa5bd8084,0xf8bf04e8,0x7c288799}},	//   _prov_, liųj, yté_, widr,
   {{0x27ef800d,0x7c28ba45,0x20183a46,0x247202d6}},	//   ální_, tidr, khri_, _fņme_,
   {{0xd12f87bd,0x610a80eb,0x660d33bc,0x63ad8041}},	//   _عمل_, _vēlā, zkak, _ɓang,
   {{0xa68697f9,0x2bc623bd,0xfbc60f1b,0x629e3a47}},	//   _след, र्या, र्यम, nspo,
   {{0x54e688ca,0xaca43a48,0xf8bf2538,0x9f5e9b3a}},	//   _مستق, _akọr, tté_, _noté_,
   {{0xf8bf02be,0x02d110a1,0x645c3a49,0xe9df3a4a}},	//   uté_, _सन्न, _ohri, rdú_,
   {{0x2bc6053f,0xddd00503,0xf8bf02be,0xc1740326}},	//   र्मा, _češk, rté_, _faɗo_,
   {{0xf8bf3a4b,0x6b7b812a,0x6e95079e,0xdce083bf}},	//   sté_, _ארונ, рибу, mamı,
   {{0x66028006,0xdce083bf,0x629e3a4c,0xf8bf00e7}},	//   _jook, lamı, dspo, pté_,
   {{0x64450284,0x660d3a4d,0x645c0083,0x8234026a}},	// [26f0] tohi, rkak, _bhri, _دروا,
   {{0x6b9a809f,0x6602ba4e,0x645c3a4f,0xbd6817ae}},	//   natg, _look, _chri, урсе_,
   {{0x64453a50,0x629e3a51,0xdddc011f,0xdb1a8118}},	//   rohi, gspo, sprš, metó,
   {{0xfde912c6,0x660285ee,0x60cd0133,0xb5fb2620}},	//   _ऑफिस_, _nook, _kpam, _ciát,
   {{0x69df00f1,0x26cc82c4,0x645c0635,0x02d1ba52}},	//   _maqe, _apdo_, _fhri, _तन्न,
   {{0x60cd2fc0,0x645c032f,0x60103a53,0x7999ba54}},	//   _mpam, _ghri, _näml, saww,
   {{0x6602ba55,0x629e0088,0xe57180f7,0x6e29ba56}},	//   _book, cspo, يطة_, tieb,
   {{0x82378013,0x62588013,0x7aea013c,0x6602ba57}},	//   _إرسا, ríoc, æfte, _cook,
   {{0xf1bf003e,0x6e29ba58,0x1fa79a19,0xdd99816b}},	//   riál_, rieb, _брег, raň_,
   {{0x60dbba59,0x68e9a9cb,0x2cbf8151,0x6e29ba5a}},	//   _isum, _ired, rtud_, sieb,
   {{0xfbd20039,0xa5bb026b,0x60cd08f9,0x2cbfba5b}},	//   חתי_, _amóm, _apam, stud_,
   {{0x01660656,0xaab682f1,0x998f8084,0xb34587f1}},	//   икно, _अमरक, mogų_, _alçà,
   {{0xe0d70098,0x291da198,0xaca4019d,0x2d8dba5c}},	//   авя_, nzwa_, _kwụt, mbee_,
   {{0xb8ee023c,0x6b9a87f1,0x6e2600b9,0x6602838a}},	//   _रह_, catg, _smkb, _zook,
   {{0x44d68d38,0x69df00f1,0x6602846d,0xd62a07a1}},	//   _zł_, _faqe, _yook, вове_,
   {{0x78a90db7,0x0d860470,0x3ced017f,0xee3723d7}},	//   ševa, рлан, _ševa_, анс_,
   {{0x249fba5d,0x8fa60294,0x629e3a5e,0x645c082a}},	// [2700] nsum_, _капе, wspo, _phri,
   {{0x389b00be,0x2246ba5f,0x69c982ec,0x515b01c6}},	//   _שיינ, wook_, _abee, _בכפו,
   {{0x60dba3be,0xf1eb01ce,0x68e9ba60,0xf77881b9}},	//   _asum, _जोड़_, _ared, _naħa_,
   {{0x68e992f1,0x00e6919d,0xb05b016d,0x249f8359}},	//   _bred, ижен, ptäc, ksum_,
   {{0x68e9b206,0x66029c11,0x2246ba61,0x60100009}},	//   _cred, _rook, rook_, _lämm,
   {{0xb8ce8403,0xa2e60364,0x2cadb6b8,0x6602b0c9}},	//   _कि_, _когд, dred_, _sook,
   {{0xe297333d,0x68e99d6b,0xfaa302cb,0x2bc606bf}},	//   _вас_, _ered, _маро, र्णा,
   {{0x68e98082,0x2d801122,0x28da8006,0x3e7c001b}},	//   _fred, ncie_, _मैथि, _mít_,
   {{0x68e9ba62,0x6b9a809f,0x999901ac,0xfbc624bd}},	//   _gred, tatg, nosť_, र्थम,
   {{0x5fb20076,0xe3b89014,0x60c2ba63,0x66028b99}},	//   _जागल, lnız_, mtom, _wook,
   {{0x2d8021a9,0x6b9a8722,0x33770039,0x61e089c4}},	//   kcie_, ratg, יעים_, _kaml,
   {{0x61e2ba64,0x2bc604c5,0x6ab681ce,0x2cadba65}},	//   ndol, र्ता, _अमीर, bred_,
   {{0x61e08010,0x3e7195db,0x63bc00d2,0x6b9aba66}},	//   _maml, _išta_, _ocrn, patg,
   {{0x61e28364,0x44278b99,0x6b9a8197,0x2d80009a}},	//   hdol, _gmn_, qatg, ecie_,
   {{0x6448ba67,0xf09f3a68,0xd5bb0d5f,0xdb1aba69}},	//   modi, ssà_, кса_, retó,
   {{0x442cba6a,0x248901bf,0xef190035,0xdb1a8118}},	//   lid_, tpam_, ąż_, setó,
   {{0x60cd3a6b,0x442cba6c,0x3f9c9e8f,0x61e28114}},	// [2710] _upam, oid_, kavu_, ddol,
   {{0x4ada8006,0x6448ba6d,0x442cba6e,0x3f9ca6fd}},	//   _बनाव, nodi, nid_, javu_,
   {{0x2bc60778,0xb5fb3a6f,0x25a6ba70,0x61e085e7}},	//   र्धा, _diár, _odol_, _baml,
   {{0x68e9ba71,0xa3e705fc,0x64488f20,0x2d8000e5}},	//   _pred, _मोर_, hodi, ccie_,
   {{0x69bc016f,0x442cba72,0x95080065,0x84670098}},	//   ष्टी, kid_, _پہلے_, _въве,
   {{0x68e9ba73,0x6e2d3a74,0xe7398e97,0x442cb93e}},	//   _vred, liab, лел_, jid_,
   {{0x2486ba75,0x7d0d3969,0x61e0856c,0x2d993a76}},	//   _atom_, lyas, _faml, _kese_,
   {{0x61e08558,0x249f856c,0x68e9904a,0x625880f7}},	//   _gaml, tsum_, _tred, líon,
   {{0xa3ab0d38,0x2d993a77,0x7d0d3a78,0x893993f7}},	//   _गया_, _mese_, nyas, _спас_,
   {{0x6448803a,0x6e2d3630,0x249fba79,0x2d993a7a}},	//   godi, hiab, rsum_, _lese_,
   {{0x9cf98a49,0x249fba7b,0x81da80c8,0x8c1a0039}},	//   েছেন_, ssum_, ়ার_, רותי,
   {{0x2d993a7c,0x442cba7d,0xf53f0106,0x20058428}},	//   _nese_, aid_, _oxå_, _holi_,
   {{0xeb8e80ae,0xddc602a5,0x2005ba7e,0x44278359}},	//   _ни_, _nikš, _koli_, _tmn_,
   {{0x999901ac,0x7d0d3a7f,0x6b98826c,0x4427926a}},	//   vosť_, dyas, _gevg, _umn_,
   {{0x81bf00c8,0x20058668,0x2d993a80,0xddc60110}},	//   ীয়_, _moli_, _bese_, _aikš,
   {{0x3f9c8da8,0x2d990511,0x2ca00074,0xdb170187}},	//   zavu_, _cese_, tsid_, nexõ,
   {{0x2d993a81,0x2aa38201,0x2d803a82,0x61e0a699}},	// [2720] _dese_, lıb_, rcie_, _raml,
   {{0x61e08370,0xe7e782f1,0x25e80816,0x80ad04c5}},	//   _saml, _टोला_, _चोरी_, _जिते,
   {{0xe80d0063,0x2ca002f1,0x2aa38201,0x2a600282}},	//   _सकता_, ssid_, nıb_, _khib_,
   {{0x60c2ba83,0x6e2d3a84,0x753d8035,0x6448b327}},	//   ttom, ciab, ższy, zodi,
   {{0x2005ba85,0x442cba86,0xdb1e0019,0x81da80ab}},	//   _boli_, yid_, lepü, ়াল_,
   {{0x60c29f5d,0x66061e62,0x442cba87,0xa5bb0032}},	//   rtom, _hokk, xid_, _amóh,
   {{0x660618c2,0x442a3a88,0x60c2a79a,0x2005ba89}},	//   _kokk, _imb_, stom, _doli_,
   {{0x6b989010,0x442cba8a,0x3f9a0904,0xd5ba8d91}},	//   _sevg, wid_, _lepu_, уск_,
   {{0x8fa6ba8b,0x38cb815b,0xa3b3816f,0x2005ba8c}},	//   _газе, _مالی_, टलं_, _foli_,
   {{0xb5fb0104,0x442a0267,0xdbf0801b,0x66060a64}},	//   _khác, _jmb_, _tříd, _lokk,
   {{0x442cba8d,0x6448ba8e,0xe9f90160,0x95ca80e8}},	//   rid_, rodi, анні_, _була_,
   {{0x442c8665,0x661b822e,0x66060125,0x2a6001c0}},	//   sid_, chuk, _nokk, _chib_,
   {{0xa3b8023c,0x442a01e0,0x799d3a8f,0x2486ba90}},	//   छला_, _omb_, rasw, _utom_,
   {{0x2d993a91,0x7d0d3a92,0x3f9a3a93,0xa3e706a7}},	//   _sese_, vyas, _cepu_, _मों_,
   {{0x2d993a94,0x877b82f6,0x59c88540,0x66063a95}},	//   _pese_, ראלי, रभार, _bokk,
   {{0x442a138d,0x7d0d3a96,0xb5fb01a8,0xdceb81b9}},	//   _amb_, tyas, _sháb, _qegħ,
   {{0x62871434,0x2d993a97,0x442a3a98,0x26c30353}},	// [2730] _stjo, _vese_, _bmb_, stjo_,
   {{0x224b3a99,0x6e2d056c,0x2d993a9a,0x7d0d3a9b}},	//   lock_, siab, _wese_, ryas,
   {{0x7d0d3a9c,0x68ed03fb,0x625880f7,0x2005ba9d}},	//   syas, _hrad, ríon, _roli_,
   {{0x09ab00c8,0x41558a08,0x66063a9e,0x3abb80be}},	//   গ্রা, овес, _gokk, רמאנ,
   {{0xed468986,0x09e300c8,0x26de9fa4,0x2aa38085}},	//   _آپ_, যাপা, _asto_, zıb_,
   {{0x2aa38201,0xa29506b5,0x68ed0010,0x62588118}},	//   yıb_, _магі, _mrad, líol,
   {{0xb05b0009,0x66063a9f,0x661bbaa0,0x2a668282}},	//   ytän, _yokk, thuk, bmob_,
   {{0xf2d2093f,0x68ed3aa1,0xc48584dd,0x7bd73aa2}},	//   _קען_, _orad, олик, lexu,
   {{0x2bc614a7,0x26de9220,0xe3b19e13,0x2a6001c0}},	//   र्वा, _esto_, ورد_, _rhib_,
   {{0x5ac9baa3,0x661bbaa4,0x2aa38085,0x2a6010ba}},	//   алом_, shuk, tıb_, _shib_,
   {{0x68ed3a1c,0x78a9005c,0xb05b0009,0xd7f8801c}},	//   _arad, ševl, ttän, _khăn_,
   {{0x2a6001c5,0x2aa38085,0xb6868019,0xdd1e928a}},	//   _qhib_, rıb_, _بھول_, _síťo,
   {{0x786004b8,0x6e2b826b,0x7e7a890d,0xb05b1c50}},	//   höve, _imgb, _zutp, rtän,
   {{0xb05b3aa5,0x799b82f7,0x66063aa6,0x68ed3aa7}},	//   stän, _leuw, _sokk, _drad,
   {{0xdee3117e,0x442a3aa8,0x66e33aa9,0x2a600069}},	//   мори, _rmb_, мора, _thib_,
   {{0x68ed3aaa,0x78a414a2,0xe1ff0511,0x39401d67}},	//   _frad, _tviv, lmón_, _txis_,
   {{0xad660077,0x64430353,0x3f9a3aab,0x248d80b9}},	// [2740] زاره, čnin, _tepu_, npem_,
   {{0x6b5622ea,0x66063aac,0x61e62ec5,0xc17400fc}},	//   отех, _wokk, ldkl, _naɗi_,
   {{0x61e402b8,0x59c10107,0x86460f75,0x68ed04e8}},	//   _kail, ष्कर, _множ, _zrad,
   {{0xd7f880ff,0x62588118,0x3f858162,0xdcfd0084}},	//   _chăn_, cíol, _aflu_, _nesė,
   {{0x25a03aad,0xe8949a8f,0x2d9201d3,0x10a3b7df}},	//   mail_, чаль, mbye_, дичн,
   {{0x4aa9853e,0xeeaa8b87,0xacd90158,0x76aa910b}},	//   _किंव, атик_, _פֿרי, атив_,
   {{0xa01b0198,0xc1740300,0x09b20264,0x26de8037}},	//   mpöt, _daɗi_, ট্যা, _qsto_,
   {{0x78ad8025,0x25a03aae,0x61469577,0x6b9c3aaf}},	//   šava, nail_, _деба, _herg,
   {{0x07a69cb2,0x625880f7,0x6b9c0074,0x7aee007a}},	//   _маан, níom, _kerg, _hrbt,
   {{0x25a004bc,0x3eb800f1,0x6b9c3ab0,0x9b6a8323}},	//   hail_, kurt_, _jerg, ишна_,
   {{0x61e4154c,0xa5bb0073,0x25a03ab1,0x68ed3ab2}},	//   _bail, _imóv, kail_, _srad,
   {{0x68ed01e2,0x61e43ab3,0x201a00df,0xba2b00e8}},	//   _prad, _cail, _alpi_, ріод_,
   {{0x25a0125b,0xcd368c2b,0x660f9614,0x61e42612}},	//   dail_, _براب, öcke, _dail,
   {{0xcbd500c8,0x3eb83ab4,0x6b9c3ab5,0x7c2aa32a}},	//   _হচ্ছ, furt_, _nerg, _umfr,
   {{0x09d000c8,0xdd9b0615,0x25a03ab6,0xdb4f80e8}},	//   িয়া, иша_, fail_, _цю_,
   {{0x3ead0775,0x61e43ab7,0x25a00014,0x7bce01b9}},	//   čet_, _gail, gail_, _abbu,
   {{0x6b9c3ab8,0x2fd80338,0x68ed1408,0xc05b035f}},	// [2750] _berg, berg_, _urad, _він_,
   {{0xa2a490f7,0x6b9c3ab9,0x7c3ababa,0x61e40102}},	//   _किञ्, _cerg, nntr, _zail,
   {{0x23c2800f,0x25a00013,0x926ba3d7,0x6b9c3abb}},	//   _शानद, bail_, арда_, _derg,
   {{0x25a0008c,0x7c3ababc,0x6b9c1384,0x69c0babd}},	//   cail_, hntr, _eerg, _ccme,
   {{0x6b9c2ebd,0xc5fa0039,0x6d5d1247,0x00000000}},	//   _ferg, _הפרט, _uzsa, --,
   {{0x3abb03f8,0x6b9c3abe,0xe8d90133,0x66e598d1}},	//   _پاسخ_, _gerg, _nzọ_, зока,
   {{0xa195835f,0x199589a8,0x7e628a15,0x160f08d4}},	//   _навч, _навя, _bhop, _सवार_,
   {{0x7c3ab49a,0x6b9c0102,0xe8d901bc,0xd6ce80f7}},	//   entr, _zerg, _azọ_, اقي_,
   {{0x69d9babf,0x6d4301ec,0xc1740326,0x81198652}},	//   mewe, ßnah, _taɗi_, _ужас_,
   {{0x69d9bac0,0x4b258221,0x3e71826c,0x6b9c0118}},	//   lewe, змов, _tšto_, _xerg,
   {{0x81e500c8,0xef20009a,0xb05b0106,0x91e61617}},	//   নান_, ążki_, rtäl, поне,
   {{0xb05b04b8,0x7a362c62,0x6eca811c,0x61463ac1}},	//   stäl, kšte, _məbl, зема,
   {{0x25a002be,0x61e60123,0x61e43ac2,0x7e698f81}},	//   vail_, rdkl, _vail, mmep,
   {{0x7c94803d,0x601d86c0,0x62890bcf,0xb4d7bac3}},	//   _آشنا, _fème, _čeon, ाबी_,
   {{0x61e43ac4,0x81b380ab,0x4e1f8105,0x25a010b6}},	//   _tail, জ্য_, _बताई_, tail_,
   {{0x2cb201b0,0xbddb313c,0x69d98bfd,0x6e3bbac5}},	//   tryd_, _ajèb, jewe, nnub,
   {{0x25a03ac6,0x69d9bac7,0x2d9d819d,0x3eb83ac8}},	// [2760] rail_, dewe, _mewe_, surt_,
   {{0x2d9d879f,0xdce600eb,0x25a010a2,0x625881a8}},	//   _lewe_, _iekļ, sail_, ríom,
   {{0x6b9c1d6f,0x877b0039,0x51869777,0x9f970039}},	//   _verg, _לאיי, пула, _מדיה_,
   {{0x69d9844e,0x63a1bac9,0xe8faa462,0x320900ff}},	//   gewe, haln, йле_, _xoay_,
   {{0x6b9c0867,0x3dc380c8,0xb5fb001c,0xc5c380ab}},	//   _terg, ্যাল, _khán, ্যাপ,
   {{0x7e629838,0xfaa63aca,0x9326015b,0x660401c8}},	//   _shop, _наго, _فرزن, ljik,
   {{0xeab680ab,0x8c1b0039,0x7c2e12b8,0x69d99ab0}},	//   _জন্ম, _פולי, _imbr, bewe,
   {{0x91e3bacb,0x44f49317,0x2d9d8b99,0x66043acc}},	//   _посе, дпис, _cewe_, njik,
   {{0x2ba683bb,0x63a1811f,0x81e500ab,0x7e7e2853}},	//   jící_, faln, নাম_, _lupp,
   {{0xb05b0364,0x2281808b,0xb5fb00ff,0x2ba681d0}},	//   ttäm, _bók_, _nhán, dící_,
   {{0x81df80c8,0x316034e8,0xe1d9035f,0xeee4803d}},	//   তার_, _aziz_, одні_, _تغذی,
   {{0xddc88267,0x250b804e,0xa194102a,0x752400ee}},	//   _hudž, _گرمی_, наюч, kziz,
   {{0xd6258013,0xb05b3acd,0xf1a40084,0x3f9e80f1}},	//   _تعلي, stäm, эрэн, _ketu_,
   {{0x7a360a21,0x36d51541,0x7afc9614,0x63a1bace}},	//   všte, могр, ärts, caln,
   {{0x3f9ebacf,0x7bdabad0,0xddc88267,0x628aa1ad}},	//   _metu_, metu, _mudž, _utfo,
   {{0x7bdabad1,0x3f9e9a75,0x660400f1,0xe8d901bc}},	//   letu, _letu_, gjik, _afụ_,
   {{0x69d9bad2,0xb05b1c15,0xb5fb0f35,0x65600a2a}},	// [2770] vewe, ntäk, _fhán, _ùmhl,
   {{0x7bdabad3,0x69d983f7,0x705500d7,0xf7788372}},	//   netu, wewe, _زنجا, _daħk_,
   {{0x442e8390,0x34d9800d,0xd7f8801c,0x6b8501ec}},	//   _mmf_, _भन्द, _chăm_, rchg,
   {{0x7a361601,0x7bda9b17,0x63a186e4,0xe8d92ae3}},	//   pšte, hetu, zaln, _efụ_,
   {{0xddc8bad4,0x37e588ed,0x81df80ab,0x7e7e01e8}},	//   _budž, долг, তাল_, _zupp,
   {{0xacfa0039,0x78ad8390,0x69d9bad5,0x2d9d867f}},	//   _והשכ, šavo, sewe, _sewe_,
   {{0x63a18db7,0x7bdabad6,0xb05b0009,0x69d985ee}},	//   valn, detu, ttäj, pewe,
   {{0x601000f2,0x44333ad7,0x26c78796,0x63a18035}},	//   _hämt, lix_, rtno_, waln,
   {{0x26c78353,0x7e6993c2,0x9f5e8216,0x78600338}},	//   stno_, rmep, _votá_, höva,
   {{0x2d9d822e,0x7bdabad8,0x60100106,0x7e6481b9}},	//   _wewe_, getu, _jämt, ċipa,
   {{0x387f838e,0x569484ae,0xfbcf1a46,0x04ef8264}},	//   _huur_, _захт, स्यम, য়নের_,
   {{0x63a1bad9,0x3f9e8010,0xdcf98fd3,0xb5fb128a}},	//   saln, _zetu_, _وفات_, _shán,
   {{0x7e7e0213,0x63a18f28,0x3f9e822e,0x6443003a}},	//   _supp, paln, _yetu_, čnij,
   {{0x2281807b,0x387f837a,0x7e7e3ada,0x2bcf0b84}},	//   _tók_, _muur_, _pupp, स्मा,
   {{0x59c6035a,0x8c428279,0x44333adb,0x41c60035}},	//   _वापर, _шеше, dix_, _वापस,
   {{0x25bfbadc,0x4433023e,0x2b0a801b,0x7524011b}},	//   ngul_, eix_, ाहरु_, tziz,
   {{0xb5fb0104,0xdca32f84,0x64a3176e,0x387fb512}},	// [2780] _thán, кати, ката, _nuur_,
   {{0x661d15f8,0x68e43add,0x442100dd,0x7e7e365d}},	//   _elsk, _isid, ghh_, _tupp,
   {{0x2bcf8f21,0x78a98698,0x78ad8301,0x9f458168}},	//   त्या, _avev, šavl, _dalë_,
   {{0x442134b1,0xd378812b,0x81e50264,0x387f91b8}},	//   ahh_, meće_, নাথ_, _buur_,
   {{0xd37890d3,0x7bda804f,0x9f458168,0x02da890f}},	//   leće_, yetu, _falë_, _बन्न,
   {{0x387fbade,0xd7f8801c,0xd0108c3b,0x2bcfba52}},	//   _duur_, _thăm_, طلب_, त्मा,
   {{0x7bdabadf,0xa3e7150e,0xd3788904,0x6a8307b6}},	//   vetu, _मोट_, neće_, _алса,
   {{0x78a9003b,0x973c803a,0x3f9e822e,0x25bf9295}},	//   ševi, _neće, _wetu_, ggul_,
   {{0x7bdabae0,0xe3ce8028,0x47c684ae,0x60101a50}},	//   tetu, _dựng_, _обав, _jäms,
   {{0x69c43ae1,0xf0638084,0xa3de0054,0x25bf8493}},	//   _acie, _акуп, ढ़ि_, agul_,
   {{0x0bb70051,0xd378a3e3,0x22590198,0x387f890d}},	//   ולים_, jeće_, зины_, _zuur_,
   {{0xd378803a,0x7bdabae2,0x442e9849,0xdd90880b}},	//   deće_, setu, _wmf_, _صوت_,
   {{0x200cbae3,0xb4bd02f1,0xa3de0105,0xf1bf0144}},	//   _kodi_, _इमे_, ढ़ा_, rgá_,
   {{0x200c86c0,0x6562b106,0x44332e12,0xb8f7170c}},	//   _jodi_, _izoh, xix_, _सह_,
   {{0x200cbae4,0x45d50468,0xe6dca342,0x76878214}},	//   _modi_, новс, _मनोज, _kıya,
   {{0x200cbae5,0x59c605e8,0x645a831d,0xf1d0001c}},	//   _lodi_, _वायर, llti, _hạng_,
   {{0x69dd3ae6,0x44333ae7,0x443e81e4,0x2d580b88}},	// [2790] mese, tix_, ont_, дить_,
   {{0x443ea1ec,0x69dd3ae8,0x200c8114,0xc86700f7}},	//   nnt_, lese, _nodi_, _تطبي,
   {{0x443ea0a4,0x44333ae9,0xf1d00028,0x387f8074}},	//   int_, rix_, _mạng_, _suur_,
   {{0x443e82af,0x201e94ed,0x44210b17,0x32193aea}},	//   hnt_, _alti_, shh_, nksy_,
   {{0x629c08d9,0x200cbaeb,0x78bd15a0,0x7a36131b}},	//   _ewro, _bodi_, nusv, nšta,
   {{0xb907901b,0x85740d13,0x649a0051,0x76428136}},	//   _बन_, _шлях, _מישה, _ajoy,
   {{0x63a53aec,0x69dd3aed,0x7ac411d5,0x2aa81539}},	//   mahn, kese, _исте, _отто_,
   {{0x443ebaee,0xceb40f60,0x63a51067,0x261c00f7}},	//   ent_, דיק_, lahn, _líon_,
   {{0x2bcf29b7,0x9f45826f,0x61fb9698,0x2ca90ce9}},	//   स्था, _malé_, _inul, nsad_,
   {{0xd3788024,0x63a53aef,0x69c43af0,0x443ebaf1}},	//   zeće_, nahn, _scie, gnt_,
   {{0xf1d0001c,0x61fbbaf2,0x69dd1267,0x61e9baf3}},	//   _dạng_, _knul, fese, _kael,
   {{0x2bcf0d86,0x443ebaf4,0x69dd3af5,0x200cb3b5}},	//   स्ता, ant_, gese, _zodi_,
   {{0x973c8052,0x61e9822e,0xa1550698,0x63a509ca}},	//   _veće, _mael, върш, kahn,
   {{0xfaa59fa1,0xdb1c0013,0x63a50be6,0x61e9baf6}},	//   _зако, _scrí, jahn, _lael,
   {{0x63a509ca,0x8c1a8039,0x69dd3af7,0xd3789487}},	//   dahn, _מוסי, bese, teće_,
   {{0x69dd3af8,0x20183af9,0x61e9bafa,0x9f45bafb}},	//   cese, skri_, _nael, _valè_,
   {{0x2edc800d,0xd378812b,0x15f28105,0x63a53afc}},	// [27a0] _मन्त, reće_, _अफसर_, fahn,
   {{0x61fbbafd,0x6fd387d9,0x63a53afe,0x7bc1baff}},	//   _anul, nıcı, gahn, nglu,
   {{0x3f983b00,0x23c6024c,0x2bc60744,0xa79b007c}},	//   mbru_, र्गद, र्गा, _משיח,
   {{0x6455106d,0x2bcf824c,0xdb0181ac,0xfbcf8a27}},	//   _ekzi, त्ता, galé, त्तम,
   {{0x443ebb01,0x63a53b02,0x6d5982e9,0x6b8081bc}},	//   ynt_, bahn, _nywa, ịgid,
   {{0x69dd3b03,0xb05b0364,0x9f34b73a,0x7bc180ce}},	//   zese, ttäi, келі, jglu,
   {{0x8c430765,0x69dd2499,0xd6d78150,0x765b86a5}},	//   _сере, yese, еты_, fluy,
   {{0x61e9803c,0x2bc28006,0xa3d2bb04,0x443ebb05}},	//   _gael, _शाहा, ह्न_, wnt_,
   {{0x59a70063,0x69dd3b06,0x290280f1,0x2bc70cf0}},	//   _ख़बर, vese, _çka_, _लामा,
   {{0x320dbb07,0x69dd3b08,0xe8d78039,0x443ebb09}},	//   _zoey_, wese, _אומר_, unt_,
   {{0x69dd3b0a,0xa19501bb,0x600f83ba,0x443eb2c7}},	//   tese, канч, _tømr, rnt_,
   {{0xf2d30158,0x765b85b4,0x3a200028,0x2bc70076}},	//   נער_, cluy, _clip_, _लाभा,
   {{0x63a50d92,0x6e243b0b,0x09e300ab,0x7bde3b0c}},	//   yahn, dhib, যালা, kepu,
   {{0xb05b0009,0x6010016d,0x69dd3b0d,0xb803b716}},	//   htäv, _sämr, sese, लायम_,
   {{0x387a026c,0xc22183a4,0x63a5011a,0x69dd3b0e}},	//   _dipr_, _मतलब_, vahn, pese,
   {{0x6e24222e,0x63a5010b,0x7a360b67,0x09d580ab}},	//   ghib, wahn, pšta, _সোনা,
   {{0xd90495e4,0xa5bb0118,0xb87b01fa,0x7e6d27d1}},	// [27b0] _ای_, _alóc, rvís, rmap,
   {{0x7e6d010c,0x2bd80035,0x2ca9308a,0xf8bf0144}},	//   smap, ड़गा, rsad_, mué_,
   {{0xa8580051,0x63a53b0f,0x2ca93b10,0x61e9bb11}},	//   _איזה_, rahn, ssad_, _pael,
   {{0x6e243b12,0x63a50d92,0x92b401a8,0x798d0197}},	//   chib, sahn, احلا, _jfaw,
   {{0x91bf81bc,0x2604815c,0x60103b13,0x9f5a02d6}},	//   _ahụ_, वानी_, _kämp, _anpè_,
   {{0x7bde0012,0xec350158,0xdb01a82b,0xe05780d5}},	//   cepu, _יאָר_, salé, ریات_,
   {{0xf4c280c8,0x765b9238,0x61fb85ee,0x6d598123}},	//   ্টোব, tluy, _tnul, _sywa,
   {{0xe8d9001c,0x60103b14,0x660f3b15,0x6288002a}},	//   _ngữ_, _lämp, _jock, _édoa,
   {{0x6fd381cc,0xe1ff0035,0x9f5a0176,0x5a4493bf}},	//   tıcı, lmów_, _enpè_, _сэра,
   {{0x2a6902d5,0x660f24c0,0x249680d7,0x6e2402d4}},	//   _ahab_, _lock, کنید_, zhib,
   {{0x23298c24,0xab2990f8,0x7bc1a0f0,0x6fd3899b}},	//   фони_, фона_, rglu, rıcı,
   {{0x65958cec,0x7aea006a,0x8d878081,0x2a690362}},	//   _раду, æfti, _чужд, _chab_,
   {{0xf8bf3b16,0x261c01a8,0x2a6901b4,0xbcfb0061}},	//   gué_, _díol_, _dhab_, _szén,
   {{0x2cbf8079,0x6eca829a,0x00000000,0x00000000}},	//   muud_, _səbi, --, --,
   {{0x07a33b17,0x8fa31597,0x6e243b18,0x317fbb19}},	//   расн, расе, thib, _oguz_,
   {{0x63a3bb1a,0x68e2831d,0x7bd501ec,0x661bbb1b}},	//   _henn, ywod, _abzu, nkuk,
   {{0x6441bb1c,0x6283bb1d,0x7bde3b1e,0x69d63b1f}},	// [27c0] onli, _huno, tepu, _ibye,
   {{0x6283bb20,0xd3788289,0x6441bb21,0xe29a0cf9}},	//   _kuno, leća_, nnli, даж_,
   {{0x81e50a49,0x260480d4,0x63a38e20,0xb05b0364}},	//   নার_, वामी_, _menn, ttäv,
   {{0x63a3bb22,0x62838542,0x7bde0b17,0xaca40133}},	//   _lenn, _muno, sepu, _amụr,
   {{0xe3a7850c,0x0cbc80ab,0x69c2bb23,0x92cd80ab}},	//   _پر_, _অন্ত, rgoe, রিয়_,
   {{0x09d600c8,0x63a3bb24,0x64418a0f,0xb05b0009}},	//   _তোমা, _nenn, jnli, stäv,
   {{0x29008012,0x973c80d2,0x69d63b25,0xc5eb80ab}},	//   ţia_, _beća, _obye, কানা_,
   {{0xd37882fd,0x2bcf815c,0x64419412,0x661b809c}},	//   jeća_, त्सा, enli, gkuk,
   {{0x81e88a49,0xd3788025,0x70dc035a,0x24860307}},	//   বাদ_, deća_, यबोल, íomh_,
   {{0x63a3bb26,0xe7c9809a,0x2bc6001b,0x6283bb27}},	//   _cenn, _रायप, र्चा, _buno,
   {{0x63a381a3,0x62838012,0x6d448038,0x0c7380f7}},	//   _denn, _cuno, _žiad, جديد,
   {{0x68f63b28,0xf8bf00e7,0x62839fc9,0x2a69022c}},	//   _bryd, tué_, _duno, _qhab_,
   {{0xc05b035f,0x63a3bb29,0xac0a8eef,0xe7c986f0}},	//   дів_, _fenn, _онда_, _रामप,
   {{0x63a3bb2a,0x660f3b2b,0xd9180009,0x69d602ec}},	//   _genn, _sock, тью_, _ebye,
   {{0x6e228259,0x63a88f09,0x2a690282,0x62838087}},	//   _klob, madn, _thab_, _guno,
   {{0x78ad8024,0x33778039,0xd5b80c0e,0x62810036}},	//   šavi, _בתוך_, ксу_, _éloi,
   {{0x2bcf835a,0xf8bf3b2c,0xfbcf81d0,0x63a382ec}},	// [27d0] त्वा, qué_, त्वम, _yenn,
   {{0x61ed3b2d,0x6e228722,0xddc43b2e,0x27fe808e}},	//   _haal, _llob, rmiš, _nntn_,
   {{0xe7ec00d4,0x61ed3b2f,0x660f011f,0xe29800e8}},	//   _छोटा_, _kaal, _tock, ває_,
   {{0x61ed0079,0x63a8bb30,0xc3338039,0x645e3b31}},	//   _jaal, hadn, סוף_, alpi,
   {{0x61ed3b32,0x25a93b33,0x394980a9,0x660982fd}},	//   _maal, maal_, ças_, vjek,
   {{0xd378803b,0xa3d2ac2a,0x973c9432,0xab9400e8}},	//   zeća_, _हॉल_, _seća, _вирі,
   {{0x63a38e20,0x973c8699,0xadc40032,0x7a26008b}},	//   _renn, _peća, _ajẹs, _hóte,
   {{0x61ed3b34,0x25a92409,0xdb0380e7,0xa3cf06bf}},	//   _naal, naal_, _fenê, व्र_,
   {{0x69cc826f,0x7e7d3b35,0x661bbb36,0x62838cf4}},	//   ílež, _misp, rkuk, _suno,
   {{0x7bc53aef,0x6283bb37,0x6609bb38,0x25a92808}},	//   nghu, _puno, sjek, haal_,
   {{0x63a3bb39,0xc5d5835f,0x61ed3b3a,0xbcfb0019}},	//   _venn, _біль, _baal, _szél,
   {{0xb5fb0013,0x61ed02a3,0x63a3949d,0x68f6031d}},	//   _fhái, _caal, _wenn, _pryd,
   {{0x61ed3b3b,0x25a93b3c,0x04c881a8,0x7a26016a}},	//   _daal, daal_, _لوني_, _nóte,
   {{0x6283bb3d,0x68f601b0,0xf77884b7,0x013680be}},	//   _tuno, _vryd, _taħt_, אָלט_,
   {{0x18671927,0x61ed3824,0xa3aa000f,0xb05b0004}},	//   уари_, _faal, _गजब_, kräf,
   {{0x2bcf8894,0xc6928158,0x25a902a3,0xfbcfb738}},	//   त्रा, מאל_, gaal_, त्रम,
   {{0x05663b3e,0xfbb783eb,0xdd8f0bbe,0x30be8264}},	// [27e0] уван, _आयाम, سول_, _ইন্স,
   {{0x69c9802e,0x309b0bea,0x389b010f,0x61ed0365}},	//   _acee, _רשימ, _ריינ, _zaal,
   {{0x3ce58063,0x81e880ab,0x61ed1a25,0x25a93b3f}},	//   _जैसे_, বাস_, _yaal, baal_,
   {{0x69c601da,0x61ed02a3,0xb05b02af,0x63a8807a}},	//   ngke, _xaal, stät, zadn,
   {{0x522d00be,0xc05a81e2,0x9f45bb40,0xa3cf064a}},	//   וואַ, нік_, _dalí_, _वॉक_,
   {{0x6e2295d8,0xcaa600f7,0x3a26b437,0xdd3b03de}},	//   _slob, _مصري, shop_, _װעלכ,
   {{0x444439e8,0x63a8a19f,0x68e9a499,0x94230b5b}},	//   mn_, vadn, _esed, _умре,
   {{0x443a3b41,0x44440b2f,0x201c8904,0xa281809a}},	//   lip_, ln_, skvi_, łość_,
   {{0x444406ba,0x61ed0079,0x2ba80651,0x3d0e8074}},	//   on_, _raal, गरपा, िहें_,
   {{0x44443b42,0x443a336a,0x61ed3b43,0x60c2bb44}},	//   nn_, nip_, _saal, muom,
   {{0x44443b45,0x25a902a3,0x26048aed,0x61ed3b46}},	//   in_, yaal_, वादी_, _paal,
   {{0xc333078d,0x6eca8201,0xb5fb0013,0x63a8bb47}},	//   מות_, _qəbu, _thái, sadn,
   {{0x7e7d09ba,0x443a3b48,0xdddb880a,0x61ed3b49}},	//   _risp, kip_, lmuş, _vaal,
   {{0x4394bb4a,0x44443b4b,0x443a06c0,0xf1bf0013}},	//   _такс, jn_, jip_, chán_,
   {{0x25a92808,0x61ed0c1f,0x7c3abb4c,0x5f941510}},	//   taal_, _taal, mitr, сист,
   {{0x5eb980ab,0x92b392c8,0x6eca8085,0x387ebb4d}},	//   _আহমে, _احوا, _həbs, _litr_,
   {{0x61e2bb4e,0x25a90c11,0x7e7d0029,0x7a26008b}},	// [27f0] deol, raal_, _visp, _fótb,
   {{0x7c3aab02,0xddc98214,0x443a02e8,0x25a68114}},	//   nitr, kleş, gip_, _leol_,
   {{0x45d52a71,0xb05b1af3,0x25a91ad7,0x78bc80eb}},	//   _конс, träf, paal_, _ārva,
   {{0x7c3a811a,0x973c9123,0x3e410110,0x09e300ab}},	//   hitr, _pećn, kėti_, যাকা,
   {{0x44443b4f,0x9f4781d0,0x26d10cdb,0xe94580d7}},	//   bn_, rdní_, ltzo_, جرای,
   {{0x660d2d2e,0x3e4101e2,0xb5fb3b50,0x25a9807a}},	//   ljak, dėti_, _cháv, _žal_,
   {{0xdb03bb51,0x7c3abb52,0xdb01bb53,0x26d10cdb}},	//   _genè, ditr, talí, ntzo_,
   {{0xed59b2b8,0x645704c3,0x25a68c5e,0xc3320039}},	//   кой_, loxi, _ceol_, _וול_,
   {{0x0c258ab2,0x387ebb54,0x68e9bb55,0xac858073}},	//   имин, _fitr_, _used, јгол,
   {{0xdb01bb56,0x2cad9c1d,0x22490458,0x660d156e}},	//   salí, rsed_, _ajak_, hjak,
   {{0x7f849301,0x81e88a49,0x2a6d9d14,0x69cc800d}},	//   _المن, বার_, _kheb_, _हामी,
   {{0xd5758e02,0x26c306a5,0xc86904de,0x20010122}},	//   _куль, dujo_, _חן_, _anhi_,
   {{0xeb8ea42e,0x444402c1,0x62873b57,0x443a0214}},	//   _ми_, yn_, _lujo, yip_,
   {{0x7c288014,0x7c3abb58,0x63a7001b,0xa06a01e2}},	//   chdr, citr, _nejn, тага_,
   {{0x44440b40,0x81ab80ab,0x28b20074,0xcc3a80be}},	//   vn_, _খান_, _जिकि, _בעסט,
   {{0x44443b59,0xe8fa0b30,0x644f80e7,0x64453b5a}},	//   wn_, _али_, écif, enhi,

   {{0x628702be,0x443a3b5b,0x7d098118,0xddc98214}},	// [2800] _aujo, tip_, nxes, zleş,
   {{0x44443b5c,0x6457002a,0x26c30e1b,0xdddb8380}},	//   un_, goxi, bujo_, ymuş,
   {{0x44443b5d,0x63a701c0,0x67bb0039,0x395f80e4}},	//   rn_, _dejn, _במיק, _ayus_,
   {{0xb05b034a,0xe7d201ab,0x7d1b8365,0x2efa2c92}},	//   träg, द्रप, kyus, _irpf_,
   {{0x260481c4,0x61e2bb5e,0x44442ebd,0xae0982f1}},	//   वासी_, reol, pn_, वानन_,
   {{0x443a00f1,0x2056bb5f,0x25a680f7,0x64a31986}},	//   qip_, штер, _seol_, _фара,
   {{0x2120935a,0x60c2827e,0x973c812b,0x6e298a10}},	//   ših_, suom, _većo, fheb,
   {{0xdb03aa63,0xfe6f80a0,0xddc98214,0xdddba2f8}},	//   _gené, ودي_, rleş, rmuş,
   {{0x394d0063,0x87da84c0,0x9c469016,0x7c28bb60}},	//   żesz_, _لباس_, ихол, thdr,
   {{0xbcfb0019,0x7ed680e8,0xdb038061,0x6280bb61}},	//   _szék, _відч, _zené, _himo,
   {{0x752d01dc,0x6280bb62,0x233881e2,0x6bd8803d}},	//   zzaz, _kimo, упны_, نوکس_,
   {{0xdb0384c3,0xdd8f8019,0x7c3a8084,0x6cd68019}},	//   _xené, _قوم_, sitr, _نقصا,
   {{0x04948624,0x7c948013,0x62808f20,0x6fcd83eb}},	//   _التح, _التص, _mimo, _सामू,
   {{0x251b8e82,0xd83b0087,0x798403f7,0x04dbb5c4}},	//   _בודא, тэм_, _egiw, _סקול,
   {{0x6f1c031d,0xbe880860,0x63a7007a,0x6602bb63}},	//   gyrc, исте_, _rejn, _knok,
   {{0x4b7b812a,0x30a72386,0x628084a7,0x6d5c8457}},	//   _באוו, _кров, _nimo, ğraf,
   {{0xb05b016d,0x9f45826f,0x786d841c,0x629abb64}},	// [2810] träd, _malá_, lúve, lpto,
   {{0x6e29bb65,0x6280bb66,0x62873b67,0x224680e1}},	//   zheb, _aimo, _pujo, enok_,
   {{0x2d8280e1,0x19b99539,0x2bd89869,0xd8488133}},	//   ľkej_, гуль_, ब्या, kọb_,
   {{0x62870279,0x2a6d8282,0x645c03ec,0x6457002a}},	//   _vujo, _qheb_, _ekri, soxi,
   {{0x6280bb68,0x26dea6e7,0xb5fb01a8,0xe8038072}},	//   _dimo, _apto_, _dhát, लाला_,
   {{0x09e300ab,0x7a263b69,0x6602b6ef,0x1d1601c6}},	//   যাটা, _móta, _anok, _הקשר_,
   {{0xdb0386a5,0x2a7f8748,0xdb018c83,0x316981d6}},	//   _tené, _tiub_, kalá, ťaz_,
   {{0xb8cd80c8,0xf2d204de,0x62809f6d,0x26dea5ca}},	//   _কম_, _מעל_, _gimo, _dpto_,
   {{0x6e298648,0xbc198048,0x7a2601a8,0x2bc284c5}},	//   rheb, гіні_, _nóta, _शाखा,
   {{0x40849cce,0x98148077,0x9b440117,0x68fb811e}},	//   _футб, _وبلا, _انہو, _irud,
   {{0x44213b6a,0xdce78182,0x682b0201,0x68ed3b6b}},	//   ikh_, ımız, _müdd, _asad,
   {{0xdb018019,0x6eca8085,0xf8bf023e,0xa5bb008b}},	//   galá, _təbr, fré_, _blóm,
   {{0x2604bb6c,0x291dbb6d,0xc9560009,0x8505803d}},	//   वारी_, nywa_, стны, _دوشن,
   {{0x765d0e87,0x2cbfb55e,0x3cfe01d0,0xc2c880d7}},	//   _aksy, mrud_, _čtv_, دبیل_,
   {{0xdb0184be,0x66f98107,0xd62a0320,0xf99f01e8}},	//   balá, ्मिक_, гове_, bbè_,
   {{0x645c0bbd,0xf8bf003e,0x0d861bf2,0x442102a3}},	//   _skri, bré_, слан, ekh_,
   {{0x61e63b6e,0xcc888104,0x44383b6f,0x6280bb70}},	// [2820] mekl, _lớn_, _pmr_, _rimo,
   {{0x69db85a4,0x44278890,0x61e63b71,0x4adb8fb8}},	//   _abue, _jln_, lekl, _बहाव,
   {{0x4427bb72,0xfc3f07e2,0x6d4f3b40,0x25ad8bcb}},	//   _mln_, _avís_, _exca, kael_,
   {{0x68fb84fe,0x80cb00c8,0x61e63b73,0xd2598d8e}},	//   _brud, িবর্, nekl, аці_,
   {{0x25a00393,0x6280a6d5,0x25ad8114,0xddcd1bef}},	//   mbil_, _vimo, dael_, llaş,
   {{0x645c3b74,0x25a03b75,0xe447bb76,0x44383b77}},	//   _ukri, lbil_, _رض_, _umr_,
   {{0x62808a5e,0xddcd0059,0x61e60214,0x09b200ab}},	//   _timo, nlaş, kekl, য়্যা,
   {{0x61e6111b,0x7e64020d,0x25a004e1,0xa5bb026b}},	//   jekl, nlip, nbil_, _alój,
   {{0xa9268009,0x4427810b,0x61e63b78,0x998d81a1}},	//   _удал, _bln_, dekl, _umeš_,
   {{0xddcd0214,0xf8bf00e7,0xb34682df,0xe8248061}},	//   klaş, vré_, jeçõ, _بذری,
   {{0xdb01bb79,0x5c5b00be,0x7a263b7a,0x2bf701c6}},	//   talá, רדיק, _sóta, זמין_,
   {{0xad9b0073,0x5d868013,0x2604816f,0x5b7b03c8}},	//   _anún, _الإل, वाळी_, טריא,
   {{0xfdf78039,0x44213b7b,0x661d9c50,0xf8bf3b7c}},	//   _לצאת_, ykh_, öske, uré_,
   {{0xa2c08ec5,0xf8bf3b7d,0xb9218032,0x96eb0b79}},	//   _विप्, rré_, _aisọ_, льба_,
   {{0x443e8e79,0x6fda800f,0x501b8039,0x543b80be}},	//   mit_, प्यू, נולו, _געגא,
   {{0x645abb7e,0xe8d90028,0x7bdc3b7f,0x61e63b80}},	//   loti, _ngủ_, _abru, cekl,
   {{0x68ed0510,0x2bcf89a9,0x973c8b67,0x3a2902c4}},	// [2830] _usad, त्का, _bećk, _ilap_,
   {{0x44273b81,0x645abb82,0x3ce0800f,0x97a70087}},	//   ón_, noti, _कहने_, _урил,
   {{0x6448bb83,0x3a29000b,0xfa8980ff,0x68fb8115}},	//   indi, _klap_, _lẫn_, _srud,
   {{0x443ebb84,0xc1b70c28,0x1df90009,0x7e643b85}},	//   hit_, _अयोग, _темы_, clip,
   {{0x443eb1f4,0x645abb86,0x7a36012b,0x65628db1}},	//   kit_, koti, ušti, _nyoh,
   {{0x62988b5d,0x443ebb87,0x63aa8125,0x645abb88}},	//   _otvo, jit_, _nefn, joti,
   {{0xa3be92ee,0x443ebb89,0x645abb8a,0x6562bb8b}},	//   ेलन_, dit_, doti, _ayoh,
   {{0x7a36003b,0xe619abf3,0x644898f2,0x68fbacdb}},	//   pšti, рди_, endi, _trud,
   {{0x44278894,0x25adbb8c,0x6448bb8d,0x64890b80}},	//   _pln_, rael_, fndi, _džig,
   {{0x443ebb8e,0xfa898104,0xddcd05c5,0x63aa831d}},	//   git_, _dẫn_, ylaş, _cefn,
   {{0xcb69bb8f,0x63aa8355,0x27e7bb90,0xdb1c00f7}},	//   ране_, _defn, menn_, _scrú,
   {{0x69cb8397,0x27e7bb91,0x60c615bd,0x64488010}},	//   ngge, lenn_, tukm, andi,
   {{0xe3ae8c8e,0x645abb92,0x61e63b93,0xa3aa2743}},	//   _об_, boti, rekl, _गजल_,
   {{0x442cbb94,0x61e60e63,0x645abb95,0x27e7bb96}},	//   chd_, sekl, coti, nenn_,
   {{0xa3d28063,0x26c7bb97,0x224d81bf,0x61e63b98}},	//   _हॉट_, nuno_, _ojek_, pekl,
   {{0x22b580eb,0xddcd08c5,0x27e7bb99,0x7649bb9a}},	//   māk_, rlaş, henn_, nney,
   {{0x3ea0805c,0x22b580eb,0x7e6412b0,0x81d300ab}},	// [2840] ćiti_, lāk_, rlip, _হোক_,
   {{0x25a023f8,0x27e78f7c,0xebe30af2,0xddcd099b}},	//   sbil_, jenn_, моуп, plaş,
   {{0x27e786c4,0x6e2d179f,0xd24f004e,0x22b580eb}},	//   denn_, bhab, _سنی_, nāk_,
   {{0x6e2d3b9b,0x443ebb9c,0xe8fa9777,0xddcd002e}},	//   chab, zit_, иле_, rmaţ,
   {{0x3ead003b,0x644892fa,0x645abb9d,0x28f8bb9e}},	//   ćete_, yndi, yoti, сель_,
   {{0x443ebb9f,0x6489017f,0x973c826c,0x224d80dd}},	//   xit_, _džid, _heći, _ejek_,
   {{0x645a8025,0xdcf60059,0x26c7bba0,0xdb03b49a}},	//   voti, mayı, guno_, _bení,
   {{0xdcf60182,0x443ebba1,0xdb0381d0,0x629e0a6f}},	//   layı, wit_, _cení, mppo,
   {{0x443ebba2,0x62988025,0x645abba3,0xdb03801b}},	//   tit_, _stvo, toti, _dení,
   {{0x186a8698,0xfa898028,0xd37882a5,0x47c39194}},	//   _тази_, _vẫn_, leći_, _обув,
   {{0x443e8e79,0x2bcf12e0,0x7e9180eb,0x1bfb00be}},	//   rit_, स्टा, _tāpa, בליב,
   {{0x2d9287d9,0x443ebba4,0xed5a9d34,0xd37882a5}},	//   _üye_, sit_, _кое_, neći_,
   {{0x443eb73b,0xda7b8051,0x9f5ea5b3,0xb4e918b8}},	//   pit_, ינטר, _totó_, _मने_,
   {{0xe8d92ae3,0x76408110,0x22b580eb,0x443e8168}},	//   _ngụ_, limy, bāk_, qit_,
   {{0x261c0307,0x5694044f,0x60c2bba5,0x69cb8bc5}},	//   _níos_, даст, hrom, ygge,
   {{0x2bdd0beb,0x60c2803e,0xd378805c,0x27e782d6}},	//   न्ना, krom, jeći_, zenn_,
   {{0xd378803a,0x98be002e,0x6e2d3ba6,0x60c28bcf}},	// [2850] deći_, ătă_, rhab, jrom,
   {{0x60c2a7d9,0x6e2d2a19,0x26c7bba7,0x1c050105}},	//   drom, shab, yuno_, राइल_,
   {{0x2c000076,0xce5907b6,0x261c01a8,0x764981b4}},	//   राजू_, _ганц_, _cíos_, yney,
   {{0x26c78ca2,0x9f4c8980,0xcb138e82,0xa49b0580}},	//   vuno_, _cadí_, ולע_, _pròd,
   {{0x260809a3,0x8cc20996,0x22b580eb,0x22a78019}},	//   हारी_, _लियो, zāk_, zők_,
   {{0x442a01bc,0xf8078d0e,0xd3e300d5,0x261c03a8}},	//   _glb_, ючен, _تقسی, _fíos_,
   {{0xd00e80f7,0x224d813c,0xdb03801b,0xd378825b}},	//   الى_, _tjek_, _pení, beći_,
   {{0xdb08a54d,0x0609af2f,0x3e61808b,0x44ed3ba8}},	//   gadí, сник_, jótt_, _kž_,
   {{0x27e7bba9,0x7649bbaa,0xe4d680f7,0xdb0386a5}},	//   penn_, rney, كويت_, _vení,
   {{0x1fa78a08,0x22a78019,0x26c78ce9,0x870780f7}},	//   _фраг, tők_, puno_, _وبال,
   {{0xa3dd0023,0xdb039099,0x98b00067,0x2bdd0744}},	//   थ्य_, _tení, đača_, न्या,
   {{0x22b58341,0x2c6d0efc,0x26f98740,0x9f5e81e8}},	//   rāk_, _vždy_, ्मीर_, _totò_,
   {{0x48fe80ba,0x78720366,0x601d82d6,0x22b581a9}},	//   लियो_, hæve, _fèmt, sāk_,
   {{0xd378807d,0x3ce0809a,0x261c00f7,0xfe7981d0}},	//   zeći_, _कहते_, _níor_, lmů_,
   {{0x6441bbab,0x44ed0a56,0x973c8289,0x91cc801b}},	//   mili, _až_, _peći, _हालै,
   {{0x261c3b56,0xe1ff02ba,0xa2c0923a,0xddcd026c}},	//   _ríos_, llón_, _वित्, tmaš,
   {{0x973c803a,0x52db81ab,0x261c0013,0xd37882a5}},	// [2860] _veći, _बहुस, _síos_, veći_,
   {{0x44ed3bac,0x29003bad,0xb4633bae,0x6e243baf}},	//   _dž_, _iria_, екул, skib,
   {{0x61f63bb0,0xd378805c,0x62978333,0xbcfb0061}},	//   _kayl, teći_, _éxod, _szét,
   {{0x7aba8039,0xcc88801c,0x64891f3a,0xfe7981d0}},	//   מצעו, _sớm_, _džib, jmů_,
   {{0x6441bbb1,0x201a1ab9,0xd3788052,0x26d83bb2}},	//   kili, _kopi_, reći_, ltro_,
   {{0xd37882a5,0x4425979d,0x6441804f,0xb05b01ec}},	//   seći_, jkl_, jili, hrän,
   {{0x6441bbb3,0xdb0885dc,0xd378811f,0x442580ee}},	//   dili, tadí, peći_, dkl_,
   {{0x60c2bbb4,0x682b1014,0x26c50024,0x29003bb5}},	//   prom, _müda, šlog_, _oria_,
   {{0x6441bbb6,0xdb0884e8,0x628e3bb7,0xbcfb2190}},	//   fili, radí, _hubo, _nyél,
   {{0x628e3623,0x26ca3bb8,0x3949802a,0x682f8821}},	//   _kubo, kubo_, úase_, _rødg,
   {{0x644f83d3,0x61f63bb9,0x46a3869b,0x28af000f}},	//   écia, _bayl, _захв, जीनि,
   {{0xb05b00f2,0x7ae101ec,0x645e3b30,0x628e199f}},	//   grän, _älte, hopi, _mubo,
   {{0x628e3bba,0x21670554,0x2baf009a,0x29003666}},	//   _lubo, ятог, टरमा, _cria_,
   {{0xb8f53bbb,0x629c3bbc,0x645e0369,0xe1ff0333}},	//   _हम_, _otro, jopi, clón_,
   {{0x629c827f,0xf1c6016f,0x628e1cb1,0xb05b2651}},	//   írod, _वाचन, _nubo, brän,
   {{0x29003bbd,0xade280d4,0x3e4581a9,0xee49827d}},	//   _fria_, _कॉमन_, bētu_, hẽn_,
   {{0x629c0df1,0x320902c1,0xbcfb0065,0x91bc0039}},	// [2870] _atro, _inay_, _azér, _המחי,
   {{0x628e3107,0x44ed3ba8,0x26ca00e4,0x682f8366}},	//   _bubo, _vž_, bubo_, _køde,
   {{0x41d1809a,0x26ca01e8,0x628e0c1d,0x682f854f}},	//   _हादस, cubo_, _cubo, _jøde,
   {{0x628e003a,0x682f813c,0x3a26820d,0x69cf01f6}},	//   _dubo, _møde, gkop_, ngce,
   {{0xa3be8663,0x44ed3bbe,0xbcfb0019,0xd37880d2}},	//   ेला_, _už_, _ezér, meću_,
   {{0x44250355,0x23c303d3,0x9f478efc,0x7a3601ac}},	//   _ôl_, _déjà_, lené_, nštr,
   {{0xe81e9344,0x320902d0,0x6441938e,0x682f805f}},	//   _बकरा_, _onay_, vili, _rødd,
   {{0x64418355,0xc7448013,0xdb03826f,0x764d3bbf}},	//   wili, عضوي, _nená, nnay,
   {{0x3d000e5b,0xdb01b60c,0x280881d0,0xdb07349a}},	//   रिये_, mblé, átní_, _mejí,
   {{0x61f61b37,0x32093bc0,0xe7b582e3,0x09c6016f}},	//   _sayl, _anay_, _آماد, वल्य,
   {{0x61f602bb,0xb05b1bc0,0x1b1f00ab,0x3a2dbbc1}},	//   _payl, trän, _যেতে_, _klep_,
   {{0x6441b05c,0x2900016f,0x25740125,0xd37895db}},	//   sili, _pria_, _júlí_, jeću_,
   {{0x6441bbc2,0x9f478038,0xd37881dd,0x645e0010}},	//   pili, dené_, deću_, yopi,
   {{0x3e458029,0xaac58996,0x26d80098,0x7e69829e}},	//   rētu_, _विपक, ttro_, llep,
   {{0x683000f2,0x2ba381a2,0x26d8002a,0x25b202c4}},	//   _rädd, _ख्या, utro_, tayl_,
   {{0x29000722,0x764d3bc3,0x628e3bc4,0x7bc301fa}},	//   _tria_, gnay, _rubo, ónun,
   {{0x629c0942,0x628e003b,0x224038dc,0x2bd48105}},	// [2880] _stro, _subo, _imik_, _दामा,
   {{0xd7ca003d,0xf1bf0b4c,0x6d4480e1,0x764d01b4}},	//   _بوده_, nkán_, _žiak, anay,
   {{0x645e3bc5,0x9f47803e,0x2bdd001b,0x63bc8ff4}},	//   ropi, bené_, न्धा, órni,
   {{0x7e69985c,0xfaf800eb,0x63ae3bc6,0x63a90390}},	//   jlep, _šīs_, _webn, _đene,
   {{0x5fc985b3,0x2bc703db,0x249d81c0,0x08979a3c}},	//   _राखल, _लाचा, _ntwm_, وضوع_,
   {{0x7e62bbc7,0x628e381c,0x0ee20bb8,0x2bdd275c}},	//   _skop, _tubo, _पहाड, न्दा,
   {{0x44442f3a,0x61ebbbc8,0x629c1277,0x63833bc9}},	//   mi_, begl, _utro, _агра,
   {{0x26c0bbca,0x2487803c,0x64891487,0x7e69bbcb}},	//   čio_, _ainm_, _užic, glep,
   {{0xdb08862f,0x752402ec,0x01d7830f,0x83fc8654}},	//   dadá, nyiz, _توقع_, hođe,
   {{0x44443bcc,0x83fc82fd,0x9f47827f,0xd3788289}},	//   ni_, kođe, zené_, zeću_,
   {{0xcc888142,0x44443bcd,0x764d02a3,0xd6cf806b}},	//   _mới_, ii_, ynay, _نقل_,
   {{0xc7b8803a,0x7e62bbce,0xb5fb0032,0xdb088061}},	//   _dođe_, _ukop, _akán, gadá,
   {{0x9f478a21,0x7e60bbcf,0x69dd007b,0xd8488133}},	//   vené_, momp, rfse, họm_,
   {{0x61eb8063,0x7e608812,0x656f81ec,0x601d89c4}},	//   zegl, lomp, üche, _jèmp,
   {{0x5f9417f4,0x83fc803b,0x290d002e,0x2bf3816f}},	//   тист, gođe, ţea_, _असतं_,
   {{0x44443bd0,0x41e70d13,0x5c990a14,0x32090122}},	//   ei_, _ціка, зкая_, _unay_,
   {{0x44443a20,0x78a2a828,0x5c750009,0xd37882a5}},	// [2890] fi_, jpov, елат, reću_,
   {{0x83fc8052,0x78a2803e,0x9f4c026f,0x6f030118}},	//   bođe, dpov, ždá_, _ánco,
   {{0xf1b9803a,0xb5fd84a8,0x64890110,0x9f479c18}},	//   _loše_, loše, _džia, pené_,
   {{0x44443bd1,0x6830016d,0xdb1c2509,0x7d02bbd2}},	//   ai_, _väde, _acró, _oros,
   {{0x5d852f0a,0xb5fd80ce,0x0ef7809a,0x798d0c53}},	//   _سلسل, noše, ंट्स_, _mgaw,
   {{0x61eb8353,0x160d016f,0x661d0901,0xd848819d}},	//   segl, हावर_, _hosk, bọm_,
   {{0x661d0364,0xa2c08b84,0x64453385,0x7e69bbd3}},	//   _kosk, _विष्, mihi, tlep,
   {{0x7d02bbd4,0x64453bd5,0x798d0c14,0x661d0009}},	//   _bros, lihi, _ngaw, _josk,
   {{0x661d3bd6,0x7e69810b,0xb5fd8279,0xdfdb8098}},	//   _mosk, rlep, joše, _мъж_,
   {{0xa2c090c5,0xa2c4035a,0x7d02bbd7,0x64453bd8}},	//   _विश्, ांच्, _dros, nihi,
   {{0x7d028bf0,0xdb039d1a,0xdb0894a8,0x7e69bbd9}},	//   _eros, _menç, tadá, plep,
   {{0x44443bda,0x83fc8025,0xb87b11b9,0x64453bdb}},	//   zi_, vođe, ntíf, hihi,
   {{0xdb08bbdc,0x660b8288,0xfce5835f,0x64453bdd}},	//   radá, _ingk, _чоло, kihi,
   {{0x26c78098,0x7af50019,0x6e298aa2,0x95cc8085}},	//   orno_, _oszt, lkeb, _çərç,
   {{0x44440743,0xdee30328,0xbcfb0019,0x2edd8ebf}},	//   vi_, лори, _szép, _महोत,
   {{0x444437b4,0x26128bb8,0x83fc805c,0x9f583bde}},	//   wi_, थायी_, rođe, ndré_,
   {{0x61e42562,0x661d1988,0x660b8359,0x7af50019}},	// [28a0] _ibil, _dosk, _mngk, _aszt,
   {{0x44442bb8,0x799b8300,0x76443bdf,0x394d03a8}},	//   ui_, _afuw, siiy, úese_,
   {{0x4fd7093f,0xe7c983db,0x7fd70158,0x660b8e60}},	//   _אויב_, _राजप, _אויס_, _ongk,
   {{0xcc888142,0x3ce08006,0x09c700ab,0x6ad00035}},	//   _với_, _कहले_, ষ্ঠা, _हमीर,
   {{0x44440573,0x47b300c8,0x61e4283a,0x64453be0}},	//   pi_, _জাতী, _mbil, bihi,
   {{0x660b9ad4,0xcc888104,0x25dda23a,0x44443be1}},	//   _angk, _tới_, क्सी_, qi_,
   {{0x61e40025,0x78a2807d,0x7e6080d7,0xdb0a806a}},	//   _obil, spov, tomp, _udfø,
   {{0x78a280c3,0x6fd281fe,0x7d090118,0x5fd28072}},	//   ppov, _सावं, _áesc, _सावल,
   {{0x5454bac1,0x02e0001b,0xfd1285ff,0x69c08609}},	//   квит, _नहुन, اجع_, _idme,
   {{0x660b8455,0xccf30039,0xf1b981a1,0x7d1d8106}},	//   _engk, רכז_, _voše_, ässa,
   {{0x200cbbe2,0x6fd70074,0xdb0e1f90,0xaa59168a}},	//   _indi_, _बाबू, _bebé, дину_,
   {{0x5ab7093f,0x7d02b807,0xfe7282e3,0x200c876d}},	//   עלכע_, _tros, _صدا_, _hndi_,
   {{0x442e8bc5,0x661d3be3,0x644502a3,0x64a38a4c}},	//   _tlf_, _rosk, yihi, _бача,
   {{0x61e40146,0xb5fd8796,0xdb070061,0xdb038106}},	//   _ebil, roše, _lejá, _benä,
   {{0x661d1234,0xadf4823c,0xa3d9b792,0x201e8ff2}},	//   _posk, _आसान_, _डॉट_, _moti_,
   {{0x27fa002a,0xa5bb0032,0x201ebbe4,0x78ad0b5e}},	//   _eapn_, _alór, _loti_, _twav,
   {{0x64453be5,0x8bc71285,0xf1bf0c83,0xb05b0338}},	// [28b0] tihi, есед, nkám_, nräk,
   {{0x201eaad4,0x69c087fc,0x61e4111b,0xb4e107e6}},	//   _noti_, _adme, _zbil, _दही_,
   {{0x64453be6,0xdb039fee,0xb5fd8140,0xdb070061}},	//   rihi, _venç, nošc, _bejá,
   {{0x61fd2d85,0x61ef04cc,0x200c9437,0xaca3019d}},	//   ndsl, necl, _andi_, _amục,
   {{0xd3668077,0x25a904a7,0x7e6d3be7,0xa5bb3be8}},	//   _چه_, mbal_, mlap, _flór,
   {{0xd3668077,0x7e6d3be9,0xdb18802a,0x28980039}},	//   _نه_, llap, _adví, עדון_,
   {{0x6c540470,0xf456007c,0xe4543bea,0x8f9c00be}},	//   _скру, _יישר_, _скры, ליגי,
   {{0x2499a6d5,0x60c481e2,0x200cbbeb,0x59d8864a}},	//   ísmo_, šima, _endi_, _डायर,
   {{0x320d8079,0x9f47bbec,0x9f4a0722,0xdb0a83a8}},	//   _iney_, mení_, rebé_, _defí,
   {{0x9f47800d,0xb5fb3bed,0x6e29806f,0x61e400e5}},	//   lení_, _skál, skeb, _sbil,
   {{0x68300006,0x61fbbbee,0xbf15819f,0x6fdf00d4}},	//   _näda, _kaul, _جواب, _पॉइं,
   {{0x660b94ec,0xa696810f,0x201e80f1,0x61fbbbef}},	//   _ungk, _סכנה_, _zoti_, _jaul,
   {{0x25a93363,0x463a8158,0x29040376,0x91ba81c6}},	//   dbal_, _קענע, íma_, ומרי,
   {{0x61fbbbf0,0x6a7888f1,0x69a23bf1,0x25dd8519}},	//   _laul, mífe, _क्री, क्री_,
   {{0xf1b385fc,0x998f8110,0x61e43bf2,0x6443bbf3}},	//   ुणान, nigų_, _tbil, _imni,
   {{0x61e40503,0x9f4783fb,0xe8d18424,0x7e6d1ac4}},	//   _ubil, jení_, _समूच, glap,
   {{0x9f47803e,0x0d86174a,0x6a7888f1,0x44313bf4}},	// [28c0] dení_, тлан, nífe, _blz_,
   {{0xe0b70f60,0x03a607b6,0x64890084,0x9f5a03ed}},	//   _שליט_, тижо, _džio, _japë_,
   {{0x2bd48076,0x61fbbbf5,0xe9da9cf8,0x321f826b}},	//   _दासा, _baul, дке_, _bouy_,
   {{0x201e8205,0x98a69630,0x6489025b,0x831a80be}},	//   _soti_, виде, _užin, וועז,
   {{0x201ebbf6,0x61fb84b9,0xdb0a81df,0x83fc826c}},	//   _poti_, _daul, _refí, hođa,
   {{0x03a3035f,0xf1bf04e8,0x6b9c02df,0x61fb82f9}},	//   _виро, vkám_, _ufrg, _eaul,
   {{0x8c431fab,0x201eaa4d,0x044322b7,0xddcd0087}},	//   _тере, _voti_, _терн, noaş,
   {{0x9f47800d,0x6443bbf7,0x61fbbbf8,0x35f4a42e}},	//   cení_, _amni, _gaul, упир,
   {{0x29048012,0x61ef0358,0x201e802e,0x9f49816b}},	//   _urma_, vecl, _toti_, čkám_,
   {{0xfa8a0028,0x200cbbf9,0x1e1f03db,0xa84a80b7}},	//   _mẫu_, _undi_, _यक्ष_, _غلام_,
   {{0x83fc812b,0x1db23bfa,0x0bb7025f,0x61fbaaa0}},	//   gođa, जरात, כלים_, _yaul,
   {{0x27e985f5,0xf2d30158,0x61e29529,0x60dd0711}},	//   đane_, סער_, nfol, ttsm,
   {{0x9f45826f,0xcc8880ff,0x6a788118,0x2e37825f}},	//   _malý_, _bớt_, cífe, _בראש_,
   {{0x9f47800d,0x36d50328,0xdb05008b,0x69b480d4}},	//   zení_, логр, rahú, आरडी,
   {{0x25a93bfb,0xf1b9805c,0x442cbbfc,0x69d382f1}},	//   tbal_, _loša_, mkd_, _डाली,
   {{0x2d8f006a,0x61e2bbfd,0x64438035,0xe654004a}},	//   øge_, jfol, _zmni, авсь,
   {{0x25a6040e,0x3ea9803a,0x23b6800f,0x9f47800d}},	// [28d0] ñola_, ćati_, _आजाद, vení_,
   {{0x61fba338,0x7e6d189e,0x25a93bfe,0x57f5164c}},	//   _saul, slap, sbal_, _спот,
   {{0x61fbbbff,0x68e98098,0x61e29106,0x9f4783f2}},	//   _paul, _sped, ffol, tení_,
   {{0x64489e74,0x6e36026f,0x61fb80dd,0xe1ff3c00}},	//   hidi, chyb, _qaul, ndó_,
   {{0xdca680f7,0x6e2d3c01,0xe0df3c02,0x660f0b80}},	//   _دى_, mkab, ntò_, _inck,
   {{0xb5fd80eb,0x628d00fc,0x6e2d3c03,0xf1b98115}},	//   doša, _liao, lkab, _doša_,
   {{0x61fbbc04,0x6448bc05,0x81cb00ab,0x3669960f}},	//   _taul, didi, র্য_, нако_,
   {{0x83fc803a,0xc7b88024,0xc69400be,0x644380b9}},	//   vođa, _vođa_, סאפ_, _smni,
   {{0xf1b98e9f,0x7aea8706,0x7a2601fa,0x4bd981e2}},	//   _goša_, _apft, _mótt, ньня_,
   {{0x6448bc06,0xe5768048,0x62953c07,0x628d0362}},	//   gidi, ызы_, _kuzo, _aiao,
   {{0x2bd49d01,0x6e2d3c08,0xcc888129,0xeab9814c}},	//   _दारा, kkab, _rớt_, эйн_,
   {{0xe9df00f7,0x83fc81dd,0x628d3c09,0x82361190}},	//   siún_, rođa, _ciao, اردا,
   {{0x6448bc0a,0x7d0902a5,0x628d2322,0xfd108154}},	//   bidi, _šesn, _diao, _وجه_,
   {{0xddc4001b,0x9f430009,0xdb03a84c,0x7a263c0b}},	//   dliš, kejä_, _menú, _rótu,
   {{0x75298019,0xae179664,0xd5b786b7,0x3ebe007b}},	//   lyez, थापन_, _इजाज, étt_,
   {{0x661b8867,0x6e2d043b,0x81cb00ab,0x67210589}},	//   njuk, gkab, র্ব_, älja,
   {{0x7529bc0c,0x62950102,0x753bbc0d,0x7a26008b}},	// [28e0] nyez, _auzo, nzuz, _dótt,
   {{0x63b50390,0x661b98c2,0x26d10234,0xbc6a0bbe}},	//   _cezn, hjuk, buzo_, رمان_,
   {{0x6e460878,0x49ca9508,0xd62a3c0e,0x61e2804a}},	//   _бенз, елен_, _зоне_, tfol,
   {{0x6448bc0f,0x78a42d38,0xb05b0106,0x7afcbc10}},	//   zidi, _ktiv, tsäg, ærti,
   {{0x28f88e86,0xad9b01ac,0x6448bc11,0xdb01816b}},	//   тель_, _vnút, yidi, valý,
   {{0x7d043c12,0xdb0387e0,0xb8dc8074,0xb5fd80eb}},	//   mvis, _denú, _आब_, voša,
   {{0x62953c13,0xdb18816b,0xa3d7897d,0xddc401a9}},	//   _guzo, _odvá, िलन_, rniņ,
   {{0xb5fd8029,0xceb30039,0x6448831d,0x69d609c1}},	//   toša, זיה_, widi, _भाषी,
   {{0x2fd68013,0x81cb00c8,0x7d040082,0x3ce03c14}},	//   _متاح, র্ড_, nvis, ntiv_,
   {{0x69c4011e,0xb5fd80eb,0x2a66809c,0x628281b4}},	//   _adie, roša, loob_, lmoo,
   {{0x78a40073,0xd7938013,0x2f56a83b,0xb5fd812b}},	//   _ativ, _المخ, _стас, mošn,
   {{0xa2cc0fea,0xb5fd93cf,0x6448bc15,0x2a66856c}},	//   _हिन्, lošn, sidi, noob_,
   {{0xa2c08744,0x9f47803e,0x6448bc16,0xe1ff3c17}},	//   _विक्, mená_, pidi, rdó_,
   {{0x9f47803e,0x62828282,0x69c43c18,0xb5fd826c}},	//   lená_, hmoo, _edie, nošn,
   {{0xd904850c,0xf8d1bc19,0x6e22bc1a,0xae098023}},	//   _کی_, _सम्प, _koob, वाचन_,
   {{0x63b51cf3,0xadf98bb8,0x69c00333,0xddc40088}},	//   _sezn, ्ययन_, ómet, tliš,
   {{0x6e228952,0xdb0e05e4,0xd3a702df,0xbcfb08f9}},	// [28f0] _moob, _debí, греп, _nyét,
   {{0x68ed3c1b,0xad9b0e67,0x6e2d013c,0x224b3c1c}},	//   _ipad, _saúd, skab, lick_,
   {{0x81cb00ab,0x7d043c1d,0xe29800e8,0x09bc80ab}},	//   র্ণ_, avis, гає_, _ইউজা,
   {{0x98a99487,0x6e22bc1e,0xdb07016d,0xa4d51138}},	//   šač_, _noob, _rejä, _комі,
   {{0x212b3c1f,0x90e48154,0x9f478a21,0x3ce00087}},	//   nych_, مسون, dená_, ctiv_,
   {{0x63ba8a20,0x43943c20,0x2ca9003d,0x41268009}},	//   jatn, _гарс, mpad_, рошо_,
   {{0x6e22bc21,0x59c5016f,0xc7d8007c,0x2ca92a33}},	//   _boob, वणार, אווי_, lpad_,
   {{0x6e22bc22,0x060995e0,0x212b01ac,0x442304e4}},	//   _coob, тник_, kych_, _hoj_,
   {{0x4423146a,0x680b8029,0x63ba9ce5,0xe61694ef}},	//   _koj_, _pēdē, fatn, рды_,
   {{0x4423003a,0x3ce5901b,0x212b3c23,0xa0c480f7}},	//   _joj_, _कहीं_, dych_, _ديكو,
   {{0x44232494,0x68ed3c24,0x6e22bc25,0x9f45bc26}},	//   _moj_, _apad, _foob, _való_,
   {{0x442301e9,0x6e2282a3,0xa2d626ee,0xfe9a8039}},	//   _loj_, _goob, मंत्, _סינמ,
   {{0xd1760791,0x61e98d4c,0x63ba8057,0x6721016d}},	//   рыны, _mbel, batn, äljn,
   {{0x80cd89a3,0x7d0412bb,0x98a0803a,0x442301e9}},	//   _सिने, vvis, šić_, _noj_,
   {{0x61e9bc27,0xc4478117,0x6fd703eb,0xdfcf00f7}},	//   _obel, _لیکن_, _बारू, ظيف_,
   {{0x7c2387a3,0x7d043c28,0x3ce004b7,0x6a761e00}},	//   _honr, tvis, ttiv_, máfo,
   {{0x212b0063,0x1c460110,0xa4463c29,0x656f0114}},	// [2900] cych_, анам, анад, _cych,
   {{0x629e9313,0x61e9bc2a,0x69db85b4,0x442301e9}},	//   _époc, _abel, _acue, _coj_,
   {{0xb87b3c2b,0x68fbbc2c,0x25adbc2d,0x2bdda539}},	//   stíc, _asud, kbel_, _माना,
   {{0x27ed003a,0x09e69cf6,0x2cbf9922,0xcc888028}},	//   đene_, родн, ksud_, _lớp_,
   {{0x63ba810b,0x6282bc2e,0x9f47826f,0x6f088a21}},	//   yatn, rmoo, vená_, _srdc,
   {{0x61e9bc2f,0x6e228952,0x3ec68009,0x44230147}},	//   _ebel, _soob, асиб, _goj_,
   {{0x63ba803b,0x212b009a,0x9f58009f,0xb87b05e4}},	//   vatn, zych_, ndrà_, ntía,
   {{0x27e98025,0x2c0a035a,0x63ba89ca,0x2fc5802a}},	//   đana_, _होतं_, watn, _edlg_,
   {{0x63ba89a4,0x80a6826a,0x15e2816f,0x27e08041}},	//   tatn, _ضمان, क्षर_, ƙin_,
   {{0x7c23bc30,0x61ff3c31,0xaca401bc,0x3cf90816}},	//   _conr, _saql, _amịr, _उनसे_,
   {{0x212b0d38,0x25ad923f,0x64890699,0xdfcf81a8}},	//   wych_, bbel_, _džih, _زين_,
   {{0x2ca93c32,0xfce68171,0xade2b13a,0x212b0dee}},	//   ypad_, _водо, क्शन_, tych_,
   {{0x224b3c33,0x63babc34,0xf99f0722,0x984b0081}},	//   rick_, patn, rcè_, вява_,
   {{0x212b3c23,0x656f000d,0x26c50289,0xf1a70697}},	//   rych_, _rych, šlom_, _क्रन,
   {{0x442301c5,0xf8bf1b20,0xc058035f,0xe29780a9}},	//   _roj_, ssé_, рія_, _кај_,
   {{0x44230282,0x7a360084,0x2ca909ff,0xdda80087}},	//   _soj_, kšty, tpad_, итул_,
   {{0x442301c5,0xdb050013,0xb5fdbc35,0x63b881c0}},	// [2910] _poj_, rbhí, došl, _kevn,
   {{0x656f027f,0x61e989da,0x0ba72e2e,0x44232928}},	//   _vych, _sbel, ршам, _qoj_,
   {{0xd7dc023c,0xed59803a,0x44230640,0x656f009a}},	//   _बातच, maže_, _voj_, _wych,
   {{0xed598503,0x6298bc36,0x63b8801b,0x2ca90106}},	//   laže_, _muvo, _levn, ppad_,
   {{0x44233c37,0x3ce58105,0x20010a63,0xe1ff3c38}},	//   _toj_, _कहें_, _kahi_, llós_,
   {{0x9f5801ca,0x63b880e8,0x81dd00ab,0x20033c39}},	//   ldrá_, _nevn, ড়ি_, ndji_,
   {{0x26c19385,0x6298b340,0x752d1fce,0xad9b0187}},	//   ého_, _nuvo, lyaz, _gaúc,
   {{0x7c23bc3a,0xa2c0825e,0x9f580693,0x26c98067}},	//   _sonr, _विज्, ndrá_, čao_,
   {{0x81dd00c8,0xdd918117,0x68fb8669,0xeb999a19}},	//   ড়া_, _ہوا_, _usud, лип_,
   {{0xc6e78cde,0x200100ad,0x7c3abbb0,0x6a761984}},	//   _відп, _nahi_, ghtr, táfo,
   {{0x26c502a5,0x2a7f8282,0xd6db84ae,0xe365a306}},	//   šloj_, _khub_, _шта_, скни,
   {{0x69d9bc3b,0xf59580f7,0x81cb00ab,0x8d9580f7}},	//   ngwe, _الإج, র্স_, _الإش,
   {{0x20011149,0xbca5803d,0x66ea811c,0xdb15136f}},	//   _bahi_, _امتي, _təkc, _dezé,
   {{0x7c3abc3c,0x22490859,0xf1b981dd,0x8fa30cec}},	//   chtr, _emak_, _leš_, заре,
   {{0xe7371860,0x9e5a3c3d,0xdb1c016b,0x2ca68122}},	//   бер_, граф_, _odrá, _ztod_,
   {{0x2a7f81c0,0xf1b9bc3e,0xb05b189c,0xb87b157a}},	//   _nhub_, _neš_, tsäc, rtía,
   {{0xe57a0dc0,0xb87b0511,0x15b90196,0x629881ec}},	// [2920] уза_, stía, рысы_, _zuvo,
   {{0x8ccf809a,0xd37e8042,0x9f47bc3f,0x09b00264}},	//   _दिनो, šćem_, cenç_, _কাটা,
   {{0xfdf9a3bd,0xdb0a82af,0xb05b3c40,0xadf9800c}},	//   ्यास_, _gefä, rrät, ्यान_,
   {{0xd5b90009,0xb05b016d,0xb7b5819d,0xd186ab3f}},	//   _всё_, srät, _kọw, блей,
   {{0xa3d78744,0x69db00be,0xb05b0106,0x9c82807a}},	//   िला_, אַוו, prät, ščil,
   {{0x64a3215c,0x33d5035f,0x66043c41,0xdfcf8013}},	//   _хара, _міст, ldik, فيه_,
   {{0xb5fd8025,0x2ca68082,0x68e280df,0xe8190778}},	//   pošl, _stod_, stod, दाता_,
   {{0xb8ce8a49,0x66043c42,0x60c40669,0x91e38ae7}},	//   _কি_, ndik, _ovim, _носе,
   {{0x63b88efc,0x6298b5aa,0xe12387b6,0x68300338}},	//   _pevn, _suvo, _емти, _vädj,
   {{0x96ba941e,0x22493c43,0x4438008e,0x60c2bc44}},	//   _буду_, _smak_, _jlr_, msom,
   {{0x6e969ddd,0xe69680f7,0x60c284dc,0x7d0b9384}},	//   _الصا, _الصد, lsom, _ergs,
   {{0xe7178051,0x80dd00c8,0x7c3a80f1,0xc33302f6}},	//   _לחבר_, যবস্, shtr, פור_,
   {{0x63be0877,0x60c2bc45,0x9e6580f7,0xa3ca2c4f}},	//   kapn, nsom, _بالن, ोला_,
   {{0xf1db0101,0x60c29149,0x25de99e8,0xdb1c006a}},	//   _भावन, isom, _गाडी_, _idræ,
   {{0x63be09ca,0x9f47bc46,0x02a281bc,0xddc9826c}},	//   dapn, renç_, _klọọ, lleš,
   {{0x66028074,0x22492bea,0x20012aa0,0xed59b114}},	//   _jaok, _umak_, _wahi_, saže_,
   {{0x5fc88aad,0x2001010a,0x61ed3c47,0x443800b9}},	// [2930] रणाल, _tahi_, _ibal, _blr_,
   {{0x7bdabc48,0x60c28e23,0x44e2807b,0xb6069487}},	//   ngtu, dsom, ið_, lašć,
   {{0x62808267,0xd37b1401,0x319e8133,0x645c0580}},	//   _bhmo, уча_, _ịza_, _djri,
   {{0x62808858,0x2a7f822c,0x6602aa42,0x998dbc49}},	//   _chmo, _qhub_, _naok, _aleš_,
   {{0x61ed273b,0x4ac50076,0x7bc30125,0xf1b984c4}},	//   _mbal, _लटकव, ónus, _veš_,
   {{0xc60100c8,0x9ea992b2,0x16a99485,0xd00981ae}},	//   _একটা_, авка_, авки_, реке_,
   {{0xe7398c6e,0x62358009,0x6e3ba0b3,0x46399156}},	//   рей_, _деву, thub, ичия_,
   {{0x82378f24,0xe7f5809a,0x7bda837a,0x25de816f}},	//   _ارسا, _इसका_, egtu, _गाणी_,
   {{0x6e3b8867,0x7e69838e,0xddc9807a,0x998d9024}},	//   rhub, roep, gleš, _fleš_,
   {{0x61ed3c4a,0x6e3bbc4b,0x7e6982f7,0x72c58087}},	//   _abal, shub, soep, обоз,
   {{0x60c4003a,0xfbd204de,0x61ed0c2e,0x7c2701a1}},	//   _svim, ותי_, _bbal, _mojr,
   {{0x3cfd90af,0xa2cc05fb,0x6e3b805d,0x7c270168}},	//   _tswv_, _हिस्, qhub, _lojr,
   {{0xb87b12cc,0x644f82be,0xe44e8a08,0x9f478009}},	//   rtín, écis, _жж_, senä_,
   {{0x6e3981c0,0xb5fd8450,0x61ed3c4c,0xdfd201a8}},	//   _hlwb, košk, _ebal, بيس_,
   {{0x7d09bc4d,0xb5fd8052,0x81b900ab,0x969510f8}},	//   lves, jošk, _চার_, зруш,
   {{0x4427bc4e,0x27ed003a,0x78a9801b,0x85053c4f}},	//   _hon_, đena_, _otev, रिंट_,
   {{0x66043c50,0x4427bc51,0x63be3c52,0x0c263c53}},	// [2940] rdik, _kon_, tapn, оман,
   {{0x69c982a3,0x44279d6a,0x2aed80a5,0xf20286a7}},	//   _adee, _jon_, _जहाँ_, _रोज़_,
   {{0x442786e3,0x290dbc54,0x6d40ae4d,0xf1b985f3}},	//   _mon_, _area_, zzma, _gošk_,
   {{0x290dbc55,0x4427801c,0xe4da003d,0x60c2bc56}},	//   _brea_, _lon_, _پوست_, tsom,
   {{0xa88a8071,0x290db340,0xdb1abc57,0x208a8558}},	//   айда_, _crea_, raté, айди_,
   {{0x4427bc58,0xb8f28f1b,0x764b831d,0x29000748}},	//   _non_, _वि_, _amgy, _msia_,
   {{0xab2a0021,0x71a68705,0x26d83c59,0xb5fd826c}},	//   _това_, _мавз, nuro_, cošk,
   {{0x44278af9,0x27f830e5,0x25bfbc5a,0x290d8118}},	//   _aon_, hern_, gaul_, _frea_,
   {{0x4427bc5b,0x629c3c5c,0xe4e6835f,0x27f81647}},	//   _bon_, _huro, ційн, kern_,
   {{0x4427bc5d,0x629c3c5e,0x44e28125,0x26d83c5f}},	//   _con_, _kuro, rð_, kuro_,
   {{0x629c00a9,0x2be20b86,0x44278051,0xa3e205e8}},	//   _juro, _पाना, _don_, _धान_,
   {{0x26d83c60,0x629c3c61,0x64893c62,0x63bc02af}},	//   duro_, _muro, _uživ, _lern,
   {{0x4427bc63,0x3204809a,0x27f83c64,0xc21800e8}},	//   _fon_, _mamy_, fern_, ією_,
   {{0x44279a03,0x9f4c027f,0x27f83a53,0xb87b01a8}},	//   _gon_, ždý_, gern_, rtío,
   {{0xd5bb35cc,0x764b831d,0x629c0110,0x26c53c65}},	//   иса_, _ymgy, _nuro, élo_,
   {{0x26cd003a,0x4427bc66,0x61ed3c67,0xc7b880ce}},	//   čeo_, _zon_, _ubal, _dođi_,
   {{0x4427bc68,0x2d8f034a,0x63bc383f,0xdb0385e4}},	// [2950] _yon_, äge_, _bern, _fenó,
   {{0xf1d88023,0xfbab0048,0x645abc69,0x63bc3c6a}},	//   _डाउन, ртай_, nnti, _cern,
   {{0x63bc3c6b,0xb87b0272,0x26d83c6c,0x7d09bc6d}},	//   _dern, ntím, curo_, zves,
   {{0xb5fd8db7,0x290d802e,0xf9c7835f,0x629c3c6e}},	//   rošk, _prea_, іщен, _duro,
   {{0x8d87361c,0x361a04de,0xddc8809a,0xdb188118}},	//   _фунд, _הורד, łośc, _devé,
   {{0x63bc3c6f,0x629c1bea,0x290d802e,0x7bce8207}},	//   _gern, _furo, _vrea_, óbul,
   {{0xf1b9812b,0x629c3c70,0x443ebc71,0x9f4781d6}},	//   _loši_, _guro, dht_, lenú_,
   {{0xf1bf87ca,0x4427bc72,0x682f8bc5,0x443e81ec}},	//   _þá_, _son_, _nødv, eht_,
   {{0x63bc3c73,0x27f8131e,0x7bca802a,0x225fa168}},	//   _yern, yern_, _bdfu, _ijuk_,
   {{0x443e804c,0x2900008e,0x69dd3c74,0x442783e7}},	//   ght_, _rsia_, egse, _qon_,
   {{0x44278943,0xa822803d,0x63a502af,0xdb0e01ec}},	//   _von_, _سکون, ichn, _gebä,
   {{0x2005bc75,0xdb03862f,0x645abc76,0xfc3f178e}},	//   _hali_, _senó, anti, _stíl_,
   {{0x20058859,0x4427bc77,0x27f83c78,0xdb0881a8}},	//   _kali_, _ton_, tern_, fadó,
   {{0x443e8bd5,0x26d83c79,0x9f5a047f,0x27f801ec}},	//   cht_, turo_, _papà_, uern_,
   {{0xe7ed9880,0xe7373c7a,0x7bc18c0f,0x63bc0d11}},	//   च्या_, пер_, malu, _rern,
   {{0x7bc19a67,0x200580d7,0x629a00e7,0x26d800b4}},	//   lalu, _lali_, _étoi, ruro_,
   {{0x63bc0393,0x29000057,0xdb1891b9,0x27f83c7b}},	// [2960] _pern, _usia_, _revé, pern_,
   {{0x7bc1bc7c,0x26d81f78,0x224dbc7d,0x2005bc7e}},	//   nalu, puro_, _amek_, _nali_,
   {{0xeb971bc1,0x179b010f,0x629620b0,0xe7b70039}},	//   чих_, _לייב, _kiyo, _מהיר_,
   {{0x63bc0077,0x629610fe,0xd36f12c5,0xdb1c0168}},	//   _wern, _jiyo, دهم_, _herë,
   {{0xe5720b76,0x63bc3c7f,0x2005bc80,0x645abc81}},	//   _سطح_, _tern, _bali_, ynti,
   {{0x66063c82,0x200582a3,0x7bc1bc83,0x186794f6}},	//   _hakk, _cali_, jalu, пачи_,
   {{0x2005bc84,0x81d400c8,0xed59a944,0x8f9b03c8}},	//   _dali_, স্য_, važa_, זיצי,
   {{0x225a8013,0x442a3c85,0x7e648088,0x62963c86}},	//   _الرد_, _hob_, čipo, _niyo,
   {{0x6d440698,0x442a3c87,0x7bc1bc88,0x682f9dd5}},	//   nzia, _kob_, falu, _rødv,
   {{0x20058a8e,0x645abc89,0x7bde04a7,0x64893c8a}},	//   _gali_, unti, ngpu, _užit,
   {{0x442a08df,0x62963c8b,0xddcd001b,0x62840046}},	//   _mob_, _biyo, hlaš, _bhio,
   {{0x443e88cf,0x1e8691e9,0x442a3c8c,0x62843c8d}},	//   sht_, _элем, _lob_, _chio,
   {{0x62963c8e,0x588713cd,0x7bc1a45e,0x9f5e809f}},	//   _diyo, зыва, balu, _matí_,
   {{0x6d440063,0x27ed003b,0xc9538051,0x442a3c8f}},	//   dzia, đeno_, תמש_, _nob_,
   {{0x6284003c,0x7e6d0955,0x3ce681c0,0x66063c90}},	//   _fhio, toap, _hqov_, _bakk,
   {{0x33778051,0xf4a800c8,0x629606a9,0xa2d30105}},	//   _מתוך_, _ওয়েব, _giyo, _डिब्,
   {{0x81c28a49,0x6a7d040e,0x7e6d002e,0xdb08bc91}},	// [2970] ংলা_, léfo, roap, padó,
   {{0x442a0069,0x6296132e,0x225f8186,0x78ad3c92}},	//   _cob_, _ziyo, _sjuk_, _itav,
   {{0x3cf9101c,0x63a50114,0x6606270c,0x62963c93}},	//   _उनके_, rchn, _fakk, _yiyo,
   {{0x63a502af,0xe9df3c94,0x2005bc95,0x644e02ec}},	//   schn, ngú_, _sali_, _embi,
   {{0x8c3b0352,0x3ce6822c,0x9984801b,0x443c9d14}},	//   _auße, _nqov_, _domů_, _olv_,
   {{0x7d0d3c96,0x6a7612ca,0x66ea8085,0x66063c97}},	//   mvas, ráfi, _təkl, _zakk,
   {{0x7d02933b,0x7bc193bd,0x2005bc98,0x66060c2e}},	//   _asos, valu, _vali_, _yakk,
   {{0x2005a223,0x2d998aa2,0x442a06b9,0x78ad3c99}},	//   _wali_, øse_, _zob_, _otav,
   {{0x7bc1bc9a,0x799b8122,0x442a0282,0xd0d48081}},	//   talu, _iguw, _yob_, _потъ,
   {{0x62963c9b,0x7c2a831d,0x62840c41,0x442a0069}},	//   _siyo, _cofr, _shio, _xob_,
   {{0x37e300c8,0xb05b00f2,0x7bc1bc9c,0x6fd7016f}},	//   য়ার, rsäl, ralu, _बाजू,
   {{0x7bc1bc9d,0xc7b88052,0x1c0a016f,0x5eac00ab}},	//   salu, _dođu_, _होईल_, _ছিলে,
   {{0xed4e8ea2,0x7bc1bc9e,0xdb1c00f1,0xdb1e0511}},	//   _ро_, palu, _perë, rapé,
   {{0xb8f61834,0x40950847,0x66063c9f,0x6609bca0}},	//   _हि_, ерст, _sakk, ldek,
   {{0xdee33ca1,0x628409de,0xe73a0009,0x66e3008f}},	//   кори, _thio, цев_, кора,
   {{0x442a3ca2,0x6d440102,0x644e00dd,0xa3a98a74}},	//   _sob_, tzia, _smbi, गुर_,
   {{0x442a3ca3,0x66063ca4,0x15fd0035,0x6e24008e}},	// [2980] _pob_, _vakk, उज़र_, rjib,
   {{0x6d443ca5,0x66063ca6,0x64418234,0x66098198}},	//   rzia, _wakk, nhli, hdek,
   {{0x7d090ef1,0x66063ca7,0xdb1c3ca8,0xf1b9812b}},	//   _šest, _takk, _keré, _lošu_,
   {{0x7df9800c,0x8c480085,0xa2d5bca9,0xceb304de}},	//   ्योग_, _başç, _भिन्, _שיר_,
   {{0x442a0282,0x81cb00ab,0x66098365,0x201a008e}},	//   _tob_, র্ক_, ddek, _knpi_,
   {{0x76aa9697,0x644e0f38,0x60c9807a,0x9f5806c0}},	//   отив_, _umbi, _dvem, terè_,
   {{0xe80f0023,0xd3721b9a,0x64418782,0xdb1a89b2}},	//   ायता_, _شهر_, dhli, tatí,
   {{0x60c9011f,0x7c2abcaa,0x81d400ab,0x249806ae}},	//   šemi, _sofr, স্ত_, _hirm_,
   {{0x6e2b826b,0x998d826f,0xdb1abcab,0x69c080eb}},	//   _dogb, _pleť_, ratí, _ieme,
   {{0x69c0bcac,0x682f8257,0x29049e1d,0x61e41a54}},	//   _heme, _døds, _isma_, _acil,
   {{0x69c0bcad,0xda1a0540,0x29122168,0xdb1a8511}},	//   _keme, धांत_, _arya_, patí,
   {{0x69c0bcae,0x78a082a0,0x682f8257,0xc7b880d2}},	//   _jeme, _kumv, _føds, _vođu_,
   {{0x69c08393,0x3946bcaf,0xf8ae015b,0x656f81ec}},	//   _meme, nzos_, یکی_, ücht,
   {{0x644182af,0xdb0e0118,0x69c0a385,0x59db0072}},	//   chli, _debú, _leme, _भाकर,
   {{0xfe730c2a,0x76410110,0x7793003d,0x32670081}},	//   ندر_, ūlym, ضیحا, _отив,
   {{0x27e98025,0x69c0bcb0,0xdb15026f,0xe508801c}},	//   đani_, _neme, _nezá, _kỷ_,
   {{0xa2da8b6f,0x3d118076,0x61fd3cb1,0xddc40cd9}},	// [2990] पूर्, तिये_, mesl, bliž,
   {{0x69c088f1,0x32093cb2,0x4ea73cb3,0x660982d0}},	//   _aeme, _haay_, _орма, zdek,
   {{0x60c9803a,0x69c0bcb4,0x2904b996,0x3ce93cb5}},	//   _svem, _beme, _asma_, stav_,
   {{0xfe350158,0x61fd3cb6,0xdb18801b,0xdb050b6a}},	//   _נאָך_, nesl, _neví, nché,
   {{0x69c08b0b,0xadd604de,0x29048122,0x32092676}},	//   _deme, _אורח_, _csma_, _maay_,
   {{0x75160158,0x9f0580f7,0xa3b086ae,0xfd66819d}},	//   _אַלע_, فوتو, टुम_, sspọ,
   {{0x69c0bcb7,0x7bc511df,0x66098fb0,0x20d5807b}},	//   _feme, mahu, tdek, _búið_,
   {{0x69c0915b,0x7bc53cb8,0xb87b3cb9,0x32090122}},	//   _geme, lahu, luíd, _naay_,
   {{0x6441bcba,0xdb18816b,0x2904bcbb,0x27e98300}},	//   thli, _deví, _gsma_, ƙan_,
   {{0x69c0bcbc,0x7bc51341,0xc9849510,0x61e401a8}},	//   _zeme, nahu, _руси, _scil,
   {{0x69c0bcbd,0x6e2bbcbe,0x35b59138,0xdb1c2190}},	//   _yeme, _togb, _збер, _peré,
   {{0xcb120158,0x61fd00c9,0x6a788207,0x6834809f}},	//   אלט_, gesl, tífi, _ràdi,
   {{0x7bc53cbf,0x2d9d882e,0x78a081c0,0x6f053cc0}},	//   kahu, _igwe_, _xumv, _ashc,
   {{0xf8b28039,0xe3d500ab,0x68300106,0x7e7bb65d}},	//   רשם_, স্তব, _räds, llup,
   {{0xdb1c03b0,0x3a3f9d19,0x61fd3cc1,0x7bc53cc2}},	//   _teré, _olup_, besl, dahu,
   {{0xa49b009f,0x61e4017f,0xdb0381ec,0x7e7b8ff9}},	//   _pròp, _ucil, _benö, nlup,
   {{0xc6928f60,0x69c08fc6,0x7afb20a7,0x6bd60061}},	// [29a0] ראן_, _reme, _ćuta, فتار,
   {{0x69c62a84,0x7bc53cc3,0xdb1a8019,0x7e7b8234}},	//   lake, gahu, latá, hlup,
   {{0x69c095bd,0xe1fa8f27,0x645e15b3,0x6735009a}},	//   _peme, зге_, rnpi, cyzj,
   {{0xe64611d2,0x69c63cc4,0x51868e02,0x4ad1016f}},	//   _чемп, nake, нула, _हिरव,
   {{0x76560be8,0xa3cf8778,0x7bc53cc5,0xb87b0ba3}},	//   miyy, षणा_, bahu, buíd,
   {{0x69c63cc6,0x76560086,0x26dcbcc7,0x3946bcc8}},	//   hake, liyy, tuvo_, rzos_,
   {{0x44441e59,0x81cb00c8,0x69c603f8,0x8c1b0158}},	//   mh_, র্ট_, kake, _צולי,
   {{0x76560be8,0x3a3f8668,0x7e7bbcc9,0x69c63cca}},	//   niyy, _glup_, glup, jake,
   {{0xd257810f,0x69c63ccb,0x40a88065,0x7c2e3ccc}},	//   _נשמה_, dake, _آخری_, _kobr,
   {{0x44440142,0xb05b00f2,0x9f47826f,0x224006df}},	//   nh_, rsäk, lený_, _alik_,
   {{0x3fc98077,0x1de10e5b,0x22403ccd,0xb21b00ec}},	//   _آگهی_, _फालत, _blik_, nlæg,
   {{0x61e2b2e3,0xb5fb0065,0x64a6aeab,0xa2d30eed}},	//   ngol, _aján, _зада, _डिस्,
   {{0x76563cce,0x76443ccf,0x44443cd0,0x61fd08f8}},	//   diyy, dhiy, kh_, resl,
   {{0x444428ee,0x2c16809a,0x7c2e3cd1,0x7984009a}},	//   jh_, ताओं_, _nobr, _dziw,
   {{0x4444279d,0xb5fd80d2,0xb87b0e14,0x78ad3cd2}},	//   dh_, pošt, ktív, _živč,
   {{0x44443cd3,0x442e84eb,0xa2d5800d,0xdb1abcd4}},	//   eh_, _hof_, _भित्, catá,
   {{0x7bc53cd5,0x5c753160,0x25a93cd6,0x9f478a21}},	// [29b0] tahu, влат, rcal_, dený_,
   {{0xddeb0077,0x44443cd7,0x25a93cd8,0x61e2a460}},	//   _کرده_, gh_, scal_, egol,
   {{0xa3e20006,0x7bc53cd9,0xb3e215fb,0xb87b26f0}},	//   _धार_, rahu, _पारख, ruíd,
   {{0x7bc50bfb,0x44443cda,0x61e2aa96,0x442ebcdb}},	//   sahu, ah_, ggol, _lof_,
   {{0x44441523,0x661d3cdc,0x26cc8267,0x7bc53cdd}},	//   bh_, _insk, _avdo_, pahu,
   {{0x44443cde,0x81cb00c8,0xb87b3cdf,0x69c63ce0}},	//   ch_, র্চ_, quíd, zake,
   {{0xe8221a3b,0xd9d900c8,0x1c0a005e,0x9f47826f}},	//   माता_, ধ্যম, _होटल_, bený_,
   {{0x660d3ce1,0x7c2e0ed7,0x645704c3,0x60cd3bce}},	//   ndak, _zobr, lixi, _ovam,
   {{0x7e7b810b,0xe1ff0019,0xe81e8105,0x26cc82f7}},	//   rlup, deó_, पाशा_, _evdo_,
   {{0x2240021e,0x76560201,0x442e8428,0x69c63ce2}},	//   _slik_, ziyy, _cof_, wake,
   {{0x2fc7bce3,0xdb1a8065,0x69c63ce4,0xdb0a82af}},	//   mang_, tatá, take, _gefü,
   {{0x2fc7ac11,0x444400f1,0x3eaa803e,0x38a60187}},	//   lang_, zh_, žité_, _pôr_,
   {{0x69c63ce5,0x1d0987eb,0xf1bf0019,0x76560085}},	//   rake, _цели_, pján_, viyy,
   {{0x2fc7ad67,0x76563a20,0x69c63ce6,0x6d458085}},	//   nang_, wiyy, sake, _əhal,
   {{0x64573631,0xe45680be,0x76443ce7,0x660b8122}},	//   dixi, _ביסט_, thiy, _kagk,
   {{0xadf99391,0x2fc7afd2,0xb17b016d,0x49730a2c}},	//   ्यटन_, hang_, mgån, ụtụ_,
   {{0x44443ce8,0xed5720bf,0x7c2e3ce9,0x660b84d2}},	// [29c0] th_, вот_, _pobr, _magk,
   {{0x661d3cea,0x2fc78455,0x7bc3bceb,0xb5fb007b}},	//   _ensk, jang_, _jenu, _hjál,
   {{0x7bc3845c,0x2fc78458,0x3ced8917,0x9f480009}},	//   _menu, dang_, htev_, ähän_,
   {{0x44443cec,0x660b849f,0xb21b0215,0x6289bced}},	//   sh_, _nagk, rlæg, _cheo,
   {{0x61f600f1,0x2fc78456,0x9f4780e1,0x69c43cee}},	//   _mbyl, fang_, rený_, _meie,
   {{0x2fc7bcef,0x69c42aef,0x7bc3a5c6,0xb87b03a7}},	//   gang_, _leie, _nenu, stív,
   {{0x44208104,0x2d808612,0x660bbcf0,0xd8388390}},	//   _đi_, _šie_, _bagk, _niče_,
   {{0x27ed0025,0x6289bcf1,0x69c400eb,0x442eb6b0}},	//   đeni_, _gheo, _neie, _sof_,
   {{0x2fc7977c,0x18a696be,0x7bc3ae68,0xa0a6885f}},	//   bang_, _разм, _benu, _разд,
   {{0x442e82a3,0x2fc7bcf2,0x7bc3bcf3,0xdb1a82d0}},	//   _qof_, cang_, _cenu, natç,
   {{0x201e81cd,0x60cd1a16,0x6aa481a1,0xdb188061}},	//   _inti_, _svam, _čifs, _bevá,
   {{0x200cbcf4,0x7d043cf5,0x05e103eb,0xddcd0035}},	//   _hadi_, kwis, _फाइब, ział,
   {{0xe80f035a,0x6a7d02be,0x7bc38915,0x200cbcf6}},	//   ायला_, néfi, _fenu, _kadi_,
   {{0x200c848f,0x6aa384be,0x645711ee,0x78a401ed}},	//   _jadi_, _funf, xixi, _duiv,
   {{0x45d50391,0x7bc89d9f,0x200c83ec,0x69c43cf7}},	//   ловс, madu, _madi_, _feie,
   {{0x6d0e01fe,0x200cbcf8,0x7bc89f61,0x7bc3bcf9}},	//   सिंग_, _ladi_, ladu, _zenu,
   {{0xd9049fbe,0x2fc7ac11,0x2d580364,0x62898355}},	// [29d0] _بی_, yang_, вить_, _rheo,
   {{0xda2105b3,0x200c990f,0x7642ab02,0x6289bcfa}},	//   यावत_, _nadi_, _lloy, _sheo,
   {{0x64573cfb,0xddcd009a,0x2fc7800b,0x6289851e}},	//   rixi, riał, vang_, _pheo,
   {{0x2fc7ac11,0x22590370,0x661d0858,0x629e80e7}},	//   wang_, nisk_, _unsk, _épou,
   {{0x2fc79ac4,0x4dda0051,0x200c96ea,0x7bc8bcfc}},	//   tang_, _אחרו, _badi_, kadu,
   {{0xd366af7b,0xa2cc3cfd,0x7bc88074,0x764288b1}},	//   _هه_, _हिच्, jadu, _aloy,
   {{0x2fc78455,0x660b9856,0x7bc3bcfe,0x200c83f8}},	//   rang_, _pagk, _renu, _dadi_,
   {{0xc3321a63,0x2fc7bbc2,0x6d49811e,0x201e8081}},	//   _פון_, sang_, tzea, _enti_,
   {{0x7bc394ec,0x2fc79291,0x22592280,0x6e2989ca}},	//   _penu, pang_, disk_, rjeb,
   {{0xb5fb0125,0x7bc8bcff,0x69c41789,0x200cbd00}},	//   _sjál, gadu, _seie, _gadi_,
   {{0x78a403d3,0x7bc3bd01,0x22590370,0xc73580d5}},	//   _suiv, _venu, fisk_, _حفاظ,
   {{0x22590370,0x76429bad,0xb17b0106,0x68fb819d}},	//   gisk_, _gloy, rgån, _kpud,
   {{0x7bc3bd02,0xfe70845b,0x7bc8bd03,0xc9550048}},	//   _tenu, _بدل_, badu, атры,
   {{0xdee61628,0xdb1c040e,0x6cd28c2a,0x66e60d91}},	//   логи, _serí, _اقوا, лога,
   {{0xdb1c26f0,0xe81901ce,0x61e9bd04,0x22592280}},	//   _perí, दाजा_, _ocel, bisk_,
   {{0x28dc1d01,0x3ea58c6e,0x25adbd05,0x6d410201}},	//   _बिपि, _mult_, ncel_, _əlav,
   {{0xdb0a8125,0x3a20336a,0xdb1c3d06,0x4431173c}},	// [29e0] _hefð, _inip_, _verí, _boz_,
   {{0x7d043d07,0x61e9b296,0x6600803e,0x657d00f1}},	//   rwis, _acel, zemk, _dysh,
   {{0x200c8025,0x59b80076,0x7ae1bd08,0xddc98025}},	//   _radi_, _आभार, nult, dlež,
   {{0x66ea8201,0x61e60b20,0x2fc583a8,0x64552733}},	//   _məkt, ngkl, _aelg_, _emzi,
   {{0x7ae1bd09,0x44310ba3,0x9f5801e8,0xc7b881f4}},	//   hult, _foz_, lerà_, _anđa_,
   {{0x648b1d3a,0xdcfd00eb,0x53a3102a,0x3ea5aa65}},	//   güid, _uzsā, _гарб, _bult_,
   {{0xf1ba0028,0xa3e9016f,0xe8d901bc,0x9f5801e8}},	//   _đơn_, _यात_, _izụ_, nerà_,
   {{0xe297bd0a,0x7e640074,0x96349ad2,0xb05b0106}},	//   _бас_, nnip, рниц, lsät,
   {{0x200c8867,0x7bc8bd0b,0x80a018b8,0x3d170d86}},	//   _tadi_, tadu, _गंगे, निये_,
   {{0xcb1f80d4,0xf1b9826c,0x201e809c,0x61e9801b}},	//   यमंड_, _inša_, _unti_, _zcel,
   {{0x22590370,0xa3e5835a,0xb89380f7,0x7e6414cf}},	//   tisk_, _फार_, _اللع, knip,
   {{0x9f58047f,0xd9150048,0xdb050187,0x80c1864a}},	//   derà_, адмы, lchã, रीवे,
   {{0x22590370,0x7bc8ac73,0xf1bf0019,0x3ea580f3}},	//   risk_, padu, lják_, _zult_,
   {{0x22590370,0xb5fb03fb,0xe7e300ab,0xbddb09c4}},	//   sisk_, _ukáz, য়্য, _clèn,
   {{0x645abd0c,0x81dc80c8,0x22590370,0x7ae1879a}},	//   miti, ত্য_, pisk_, cult,
   {{0xe8d90870,0x443ebd0d,0x442c8106,0x29090ec9}},	//   _azụ_, lkt_, ljd_, _tsaa_,
   {{0x54551878,0xe8220076,0xa3e90740,0xdc5504bd}},	// [29f0] ават, माशा_, _याद_, авањ,
   {{0xe7e081fe,0x61e98098,0xb87b05a4,0x645ab282}},	//   _नागप, _scel, dríg, niti,
   {{0x443126d5,0x443ebd0e,0x20033d0f,0xed59890c}},	//   _voz_, ikt_, meji_, raži_,
   {{0x20033d10,0xdb1c0073,0x27ed005c,0x645abd11}},	//   leji_, _serã, đenu_, hiti,
   {{0x25ea146d,0x628d125b,0x91bf819d,0x3ea5bd12}},	//   _छाती_, _mhao, _ajụ_, _sult_,
   {{0x443e8613,0x645abd13,0x20110bb7,0x7c3e048d}},	//   jkt_, jiti, ndzi_, ckpr,
   {{0xfc3f02ba,0x645abd14,0xdb1c03a7,0x2fc5bd15}},	//   _guía_, diti, _verã, _velg_,
   {{0xceb40451,0x6e2d3d16,0x443e97dd,0x81dc80ab}},	//   זיק_, njab, ekt_, ত্ব_,
   {{0x645abd17,0x20033d18,0x7bc7059c,0x1c45960f}},	//   fiti, keji_, _keju, иним,
   {{0x1c1f8cce,0x69cbbd19,0x7bc73d1a,0xdb1c002a}},	//   बाइल_, lage, _jeju, _herá,
   {{0x3f678a95,0xcb69813a,0x38ab83ba,0x7bc70133}},	//   _стаб, тане_, _hør_, _meju,
   {{0x628d1a29,0x69cbbd1b,0x660f0004,0x7bc735cf}},	//   _chao, nage, _nack, _leju,
   {{0x645abd1c,0x628d0ad0,0x9f580e67,0xfe708872}},	//   biti, _dhao, derá_, _عدم_,
   {{0x443ebd1d,0x69cbbd1e,0x7ae1bd1f,0x9f583340}},	//   ckt_, hage, pult, terà_,
   {{0x660f3d20,0x69cbbd21,0x38ab8aa2,0x628d0014}},	//   _back, kage, _lør_, _fhao,
   {{0x628d0083,0x660f0b80,0x7aee826f,0x9f583d22}},	//   _ghao, _cack, žití, gerá_,
   {{0xb05b1a50,0x7afc14e4,0x6486808b,0x69d60420}},	// [2a00] tsät, _sprt, iðin, _idye,
   {{0x7d0b8077,0x628d0326,0x9f583340,0x7bc70144}},	//   _msgs, _zhao, perà_, _ceju,
   {{0xb05b0884,0x9f583d23,0x660f3d24,0xf1da2207}},	//   rsät, berá_, _fack, _भयान,
   {{0x9f5810dd,0x660f02a5,0x38ab8a38,0xed598024}},	//   cerá_, _gack, _bør_, lažu_,
   {{0x03a6143b,0x645a82ec,0x3940bd25,0x443ebd26}},	//   _виго, yiti, áis_, ykt_,
   {{0x660421c0,0x645abd27,0x26dc9c67,0xf1bf0019}},	//   leik, xiti, trvo_, tják_,
   {{0xe7ee023c,0x1c1fa3bd,0x69cbb104,0x12e080ab}},	//   _जाना_, बाईल_, bage, _বন্দ,
   {{0x38ab8a38,0x261983e8,0x69cbbd28,0x7d0b8176}},	//   _før_, _मोदी_, cage, _bsgs,
   {{0x38ab8022,0x61439263,0xed598289,0x645abd29}},	//   _gør_, _дета, kažu_, titi,
   {{0x62829b98,0x628d008c,0x69d62dcb,0x9f5800e1}},	//   lloo, _shao, _adye, zerá_,
   {{0x443ebd2a,0x63a380ee,0x3dc680ee,0x6d4d0365}},	//   rkt_, _dgnn, _teow_, zzaa,
   {{0x443e819b,0x645abd2b,0x6282a695,0x2efe826c}},	//   skt_, siti, nloo, _iptf_,
   {{0x645a8c53,0x9f5803a7,0xc05b00e8,0x68e48046}},	//   piti, verá_, вів_, àidh,
   {{0x02a6aed9,0x69cbbd2c,0xc05b00e8,0x69d600e4}},	//   _крим, zage, тім_, _edye,
   {{0x628d0ad0,0x9f580207,0x69cbbd2d,0x44f0bd2e}},	//   _thao, terá_, yage, là_,
   {{0x7bc70867,0xf8a6897d,0xb05b0198,0xe61f00ff}},	//   _seju, खदाय, tsäs, _khôi_,
   {{0x660f00f2,0xdb050a21,0x7bc70458,0x44f0a2c6}},	// [2a10] _vack, dchá, _peju, nà_,
   {{0xdb1c040e,0x6d4d0a0f,0x69cbbd2f,0x38ab83ba}},	//   _será, rzaa, wage, _rør_,
   {{0x69cbbd30,0xa2f53d31,0x6282a0d1,0x38ab821e}},	//   tage, спеч, floo, _sør_,
   {{0xceb20159,0x80db800f,0xb9100135,0x628289ff}},	//   _מיט_, _निदे, _nanị_, gloo,
   {{0xdb1c0da1,0xe9d88110,0xe7ee0424,0x81d400ab}},	//   _verá, ркі_, _जामा_, স্ক_,
   {{0x6e22bd32,0x44f0bd33,0x7bd53d34,0xdb0501a8}},	//   _anob, dà_, _udzu, achá,
   {{0xdb1c03a2,0x6282930d,0x64470197,0x41e785a8}},	//   _terá, bloo, _ilji, _віза,
   {{0x38ab8aa2,0x683d8722,0x6aa09bec,0x7d0b8122}},	//   _tør_, _mèdi, _gimf, _psgs,
   {{0x64868125,0xf80780e8,0x79808114,0x7649875e}},	//   rðin, _вчен, _gymw, rhey,
   {{0x308580f7,0x7649bd35,0xe0df3d36,0x61ed0c1d}},	//   _الطف, shey, drò_, _acal,
   {{0x78a98264,0xb87b01df,0x9f58009f,0x442300fc}},	//   _huev, tuín, merç_, _mnj_,
   {{0x78a1bd37,0x66ea811c,0x61fb810c,0x6458913b}},	//   _hilv, _təkr, _jbul, _emvi,
   {{0x78a986a5,0x25bf91d6,0x66043d38,0x61fbbd39}},	//   _juev, mbul_, veik, _mbul,
   {{0x78a986a5,0x25bf8122,0x7e7d3d3a,0xf1bf041c}},	//   _muev, lbul_, _aksp, abá_,
   {{0x66043d3b,0xa2d31a3b,0x7d098d33,0xddcb2828}},	//   teik, _डिग्, lwes, _šiša,
   {{0x25bf87d9,0x290d8e1b,0xed598301,0x64470300}},	//   nbul_, _osea_, sažu_, _alji,
   {{0x78a9a70d,0x66043d3c,0xddc98035,0x7c3506c4}},	// [2a20] _nuev, reik, wieś, _bozr,
   {{0x61fbbd3d,0xdd8f0591,0xaca38133,0x628281e0}},	//   _abul, رول_, _adịk, wloo,
   {{0xdb1c3d3e,0x25bf883a,0xb09b0039,0x7d0980ed}},	//   _merç, kbul_, _תייר, hwes,
   {{0xd910819f,0x7d09805d,0xb87b3d3f,0x6b7a80be}},	//   ویز_, kwes, críb, ארענ,
   {{0xc05a8d8e,0x6441bd40,0x78a98333,0x78a192f1}},	//   лік_, kkli, _cuev, _bilv,
   {{0x78a18341,0x6447005c,0x61fbbd41,0xdb1abd42}},	//   _cilv, _glji, _ebul, ratú,
   {{0x6282bd43,0x645e3d44,0x6441816d,0x7ff380f7}},	//   ploo, mipi, dkli, سسوا,
   {{0x44f081dc,0xc8e0800f,0x6f1a807a,0x44b480e8}},	//   tà_, _निपट, _vrtc, обис,
   {{0xa49b0722,0xdb1c0187,0x7afb0da8,0x68e60711}},	//   _pròx, _berç, _ćuti, jukd,
   {{0x44f0bd45,0x61fb80f1,0x645e3d46,0x15ea83eb}},	//   rà_, _zbul, nipi, _टावर_,
   {{0x7f868307,0x6d410201,0x44f0bd33,0x547b0039}},	//   _الان, _əlaq, sà_, רטיו,
   {{0xc3331a0f,0x7a3f020f,0xe61f0028,0xa5bb37b5}},	//   לות_, _këti, _thôi_, _anón,
   {{0x6da38c48,0x645e3d47,0xdb1c0009,0xb87b0118}},	//   _عموم, kipi, _herä, buíl,
   {{0x6441bd48,0xdb1c3d49,0x69c01434,0xe0df01e8}},	//   ckli, _gerç, ðmer, rrò_,
   {{0x623507b6,0x7c351d21,0x466b072a,0xc0580d8e}},	//   _меку, _rozr, грам_, сія_,
   {{0x7bca87ca,0x4caa00ab,0x6447025b,0x68e602c4}},	//   _hefu, _চৌধু, _slji, bukd,
   {{0x69cf0333,0x7c350038,0x7cd9003d,0x7bca80b9}},	// [2a30] mace, _pozr, شواز_, _kefu,
   {{0x69cf0018,0x4d9807ac,0x6aaabd4a,0x645e3d4b}},	//   lace, скую_, _kuff, gipi,
   {{0xe7ee00cf,0xe9f90028,0x78a983a8,0x25a6bd4c}},	//   _जाता_, _giả_, _suev, _ogol_,
   {{0xa49b0176,0xb87b03cd,0x38af0850,0x04060264}},	//   _asòt, bríc, _kür_, রাগী_,
   {{0x61fbbd4d,0x7bd880d2,0x78a18b0c,0x78a9a4a3}},	//   _vbul, _odvu, _pilv, _quev,
   {{0x8aa70785,0x02a70a8e,0xdb1c00f2,0x25b3914f}},	//   _град, _грам, _berä, ीर्ण,
   {{0x81d40a49,0xa6b480ab,0x80dbb13a,0x69cf3d4e}},	//   স্ট_, _টিউট, _निवे, kace,
   {{0xee398abe,0x764d3d4f,0x7d09bd50,0x68e623c1}},	//   рни_, nhay, twes, yukd,
   {{0x82348b76,0x78a18a35,0x7bcabd51,0x893784e3}},	//   _عرفا, _tilv, _befu, _اعزا,
   {{0xf9909381,0x22493d52,0x7d09bd53,0x26199344}},	//   _سبق_, _alak_, rwes, _मोरी_,
   {{0x2007bd54,0x6441bd55,0xdb1c3d56,0x69cf3d57}},	//   meni_, rkli, _gerä, face,
   {{0x2007829b,0x81e200c8,0x64419aed,0x7d09bd58}},	//   leni_, ন্ন_, skli, pwes,
   {{0x7e7b8052,0xdb1c0073,0xe7ee0074,0xa2d58f0f}},	//   moup, _terç, _जादा_, _भिक्,
   {{0x7bca9546,0x2007805d,0x22493d59,0x7e698216}},	//   _gefu, neni_, _elak_, lnep,
   {{0x07a33d5a,0x2bbfb011,0x032580e8,0x8fa3151a}},	//   дарн, _श्या, _єдин, даре,
   {{0x38af0943,0xb87b3d5b,0x2007bd5c,0x7e69bd5d}},	//   _für_, tríc, heni_, nnep,
   {{0x645e3d5e,0x2007bd5f,0x3ea2016d,0xe45a10ee}},	// [2a40] tipi, keni_, _vikt_, ажа_,
   {{0x62863d60,0x2a7f8326,0x81b00326,0xc8e080c2}},	//   llko, _akub_, _daɓe, _निबट,
   {{0xe5a60676,0x6da61354,0x41aa81f3,0x7e7b801b}},	//   _мини, _мина, авен_, koup,
   {{0x764d3d61,0x645e0b51,0x387e82f7,0xb5fb008b}},	//   chay, sipi, _sktr_, _sjáv,
   {{0xa3e9853e,0xe80f016f,0xaca381bc,0x645e3987}},	//   यला_, ायचा_, _adọk, pipi,
   {{0xd6daa885,0x2007bd62,0xdb1c0009,0xdfd080f7}},	//   ати_, geni_, _perä, ريب_,
   {{0x44f40364,0x27e087d9,0x44443d63,0x81e200ab}},	//   lä_, ğin_, mk_, ন্য_,
   {{0x44383d64,0xa534bd65,0x91e60592,0xdb1c02af}},	//   _hor_, знич, _कागज_, _verä,
   {{0x44f40364,0xc6930bea,0x2007bd66,0xd40684fa}},	//   nä_, ואה_, beni_, ояни,
   {{0x44443d67,0x81e200ab,0xb35480e8,0x69cf0f89}},	//   nk_, ন্ম_, зкош, wace,
   {{0x444406a8,0x443801ba,0x6b838355,0x28c68eed}},	//   ik_, _mor_, _cyng, रीरि,
   {{0x81dc8a49,0xb5fb00ab,0x44381bdd,0xb87b05a4}},	//   ত্র_, _imág, _lor_, dría,
   {{0x443804df,0x7e608812,0x44443d68,0x44f40364}},	//   _oor_, mimp, kk_, jä_,
   {{0x44440586,0x6aaabd69,0x44f40009,0x7d02bd6a}},	//   jk_, _tuff, dä_, _ipos,
   {{0x69cf087a,0x764d3d6b,0x6b838114,0xd838bd6c}},	//   pace, thay, _gyng, _moč_,
   {{0x2cb90358,0x7e60b996,0x44443d6d,0x38af1266}},	//   _ptsd_, nimp, ek_, _tür_,
   {{0x44380bfa,0xa3ae86a7,0xd7fb259a,0x5d5501f3}},	// [2a50] _bor_, _कला_, _кун_, чкат,
   {{0x44383d6e,0x64dd835a,0x764d2751,0x68e29ad5}},	//   _cor_, _मिसळ, shay, drod,
   {{0x443822a0,0xf8bf24df,0x6d40bd6f,0x7ae88122}},	//   _dor_, lpé_, hyma, nudt,
   {{0x2007ae95,0x444404e0,0xc3338158,0x7c38bd70}},	//   weni_, ak_, ווע_, _lovr,
   {{0x4438073a,0x2ca30613,0x2007bd71,0x68e2809a}},	//   _for_, _tijd_, teni_, grod,
   {{0x44383d72,0x6d408110,0xd7fb8049,0xf8bf0036}},	//   _gor_, dyma, руд_, ipé_,
   {{0xe739bd73,0x2007812b,0x7d0d3d74,0x44298028}},	//   сей_, reni_, lwas, _đa_,
   {{0xb0dc05b3,0x2007b082,0x28dc0054,0x44383d75}},	//   _बिलग, seni_, _बिलि, _zor_,
   {{0xdb050352,0x81e200c8,0x7d0d3d76,0x83fc876c}},	//   schä, ন্ড_, nwas, ziđe,
   {{0x20079cb5,0xbebc80eb,0x76443d77,0x28e0a207}},	//   qeni_, _brīd, zkiy, _निति,
   {{0x7c388098,0x59cf8aed,0x7d0d3d78,0x7d02bd79}},	//   _dovr, _हजार, hwas, _epos,
   {{0x7d0d3d7a,0x83fc8024,0x60c9a6bd,0x7e608359}},	//   kwas, viđe, _kwem, cimp,
   {{0x6f1e0b80,0x69cd00c3,0xa56780d7,0x271c8129}},	//   _srpc, _deae, _بدان, _ảnh_,
   {{0x6b8388f3,0x44f40009,0x60c9a994,0x6aa411fe}},	//   _tyng, vä_, _mwem, _wiif,
   {{0xcb6694d6,0x4427bd7b,0xaa461c57,0xbebc81a9}},	//   _наше_, _inn_, _некл, _grīd,
   {{0x44f4025d,0x7c2706cb,0x6f1e00ce,0xb87b0333}},	//   tä_, _anjr, _vrpc, rría,
   {{0x76443d7c,0x7d0d1400,0x28e081a2,0x6e39822b}},	// [2a60] rkiy, gwas, _निधि, _mowb,
   {{0x44443d7d,0x764400a4,0x29120590,0x69db8216}},	//   uk_, skiy, _isya_, _adue,
   {{0x44383d7e,0xf62601f3,0x6d40809a,0x7d1b8074}},	//   _vor_, _едно, zyma, hvus,
   {{0x4444006f,0x64a61506,0xdca600ae,0x645c01ed}},	//   sk_, _нама, _нами, _wmri,
   {{0x44383d7f,0x4427bd80,0xf1a9803d,0x291f80f7}},	//   _tor_, _onn_, زانه_, _crua_,
   {{0x645c2c5d,0x68e2a00a,0x69db8118,0x69c286a8}},	//   _umri, rrod, _edue, sboe,
   {{0x7d02bd81,0xa91d826f,0x1c020540,0x7bdc00ee}},	//   _spos, _vyža, _रॉयल_, _idru,
   {{0x4427bd82,0x81e20a49,0x7c38bd83,0x6d408d42}},	//   _ann_, ন্ত_, _sovr, tyma,
   {{0x7c388b48,0x7bce0763,0xe297b73a,0x48e390ca}},	//   _povr, _kebu, _хат_, _потв,
   {{0x7e60bd84,0xb5fd85f5,0x6d409ad5,0x5fd0801b}},	//   simp, više, ryma, _सजिल,
   {{0x29123d85,0x7e6088de,0x60c98a0f,0x6d409ad5}},	//   _asya_, pimp, _zwem, syma,
   {{0x44278357,0x7bce3d86,0x78ad01c0,0x3ce901c0}},	//   _enn_, _lebu, _puav, yuav_,
   {{0xdcf783f8,0x7d028754,0x7c38807a,0x2e3781c6}},	//   _فروش_, _upos, _tovr, _מראש_,
   {{0x7bce3d87,0xb905058c,0xb5fd8916,0xa8a416ba}},	//   _nebu, _पट_, riše, ерск,
   {{0x5433826a,0xabfb81c6,0x81e200ab,0xff041cf8}},	//   _سرور, _ההור, ন্ধ_, нятн,
   {{0x7d0d3d88,0xb5fd811a,0xf8bf00e7,0xa49b026b}},	//   twas, piše, ppé_, _asòp,
   {{0x59c30327,0x7bce3d89,0x3a290359,0xdcef01a9}},	// [2a70] _व्यर, _bebu, _inap_, _izcī,
   {{0xfbab0196,0x81e200c8,0x200a3d8a,0x6609bd8b}},	//   стай_, ন্দ_, cebi_, zeek,
   {{0x7529012b,0x64451cbc,0x3d0e9344,0x3a292862}},	//   _šezd, rkhi, _तैसे_, _knap_,
   {{0xdb15026f,0xfd1f001c,0xdb1ab4be,0xa3dc8ebf}},	//   _sezó, _trì_, lató, तृत_,
   {{0xe1f09e13,0xb5fb0125,0x9f5106a5,0x7e6d3d8c}},	//   اسم_, _fjár, pezó_, mnap,
   {{0x7bce2e68,0xdb1abd8d,0x4174803d,0x6609bd8e}},	//   _gebu, nató, رانس, week,
   {{0x66098c56,0xae1e8128,0x7bc53d8f,0x3a290db1}},	//   teek, _मोहन_, mbhu, _onap_,
   {{0xda1d1d01,0x7bdc1fe7,0x7e6d25d3,0x7bce0caa}},	//   _बोलत_, _zdru, nnap, _zebu,
   {{0x5fbf000d,0xe7ee0665,0x66099306,0xd7bf0d14}},	//   ्राल, _जाला_, reek, ्राच,
   {{0x68e48307,0x6609bd90,0x5ee58035,0xbb4595b5}},	//   áide, seek, _टिप्_, деок,
   {{0x7e6d09ff,0xe29a045e,0x3ea68118,0x212000b9}},	//   knap, жан_, _fiot_, _srih_,
   {{0xd9ff8128,0xb87b01a8,0x3a290229,0x9f580144}},	//   ोजित_, frío, _cnap_, perú_,
   {{0x7e6d3d91,0xdb0a80f2,0xdb038144,0x68eb833e}},	//   dnap, _affä, _igní, nugd,
   {{0xdb1abd92,0xe8008f1b,0xa91d816b,0x67218bcf}},	//   gató, ल्पा_, _lyžo, _krlj,
   {{0x81e58a49,0xa0a33d93,0x7bce3d94,0x224d8327}},	//   ব্য_, тард, _rebu, _olek_,
   {{0x7bce1a67,0x2ca78006,0x7ae500d2,0x6721812b}},	//   _sebu, _hind_, drht, _mrlj,
   {{0x1be18074,0x7bce02f7,0x62843d95,0x2bb203db}},	// [2a80] _खयाल_, _pebu, _ikio, _जलदा,
   {{0x1daa0054,0x225f8642,0x67218140,0xdb1abd96}},	//   _कलकत, _amuk_, _orlj, cató,
   {{0x38b41918,0x28e083eb,0x65c62098,0x2ca7bd97}},	//   _här_, _निहि, _обна, _mind_,
   {{0x7bce3d98,0x1bf00105,0x2ca7bd99,0xdb18816b}},	//   _webu, _चावल_, _lind_, _nevý,
   {{0x7bce3d9a,0x83fc826c,0xb17b03a6,0x644f81a9}},	//   _tebu, hiđa, lgår, īcij,
   {{0x7bdc003a,0x224dbd9b,0x59cc800d,0x46d20105}},	//   _udru, _elek_, ारहर, _तबाह,
   {{0x38b400f2,0x224dbd9c,0xb17b04e1,0x644e3d9d}},	//   _lär_, _flek_, ngår, _ilbi,
   {{0x44208193,0x1514a49a,0x7e64046d,0x442a35ca}},	//   _şi_, едия, niip, _hnb_,
   {{0x38b41918,0x7c3c17ab,0x6d440812,0xd8388289}},	//   _när_, _korr, nyia, _liči_,
   {{0xdb1c0aa2,0x6284004f,0x2ca78087,0x67218503}},	//   _berø, _akio, _cind_, _frlj,
   {{0x9e3c826f,0x672180fe,0x60c28d55,0x9f5e823e}},	//   _buďt, _grlj, lpom, _obté_,
   {{0x38b40884,0x81e200ab,0x2ca780f3,0x60c28035}},	//   _bär_, ন্স_, _eind_, opom,
   {{0x2ca7bd9e,0xa3c0064a,0xdb1abd9f,0x644e047f}},	//   _find_, ीरा_, tató, _olbi,
   {{0x38b41918,0x7c3c3da0,0x62843da1,0x75228db1}},	//   _där_, _norr, _ekio, _iroz,
   {{0xe8009880,0x9f5f07d9,0xb5fd8024,0x7522826f}},	//   ल्या_, _ürün_, liša, _hroz,
   {{0x644e011e,0x443cbda2,0x7e6402c4,0x81b00300}},	//   _albi, _hov_, giip, _taɓa,
   {{0x443cbda3,0xdb1abda4,0x66028077,0x60c2875f}},	// [2a90] _kov_, catò, _mbok, jpom,
   {{0x7c3c3da5,0xe3b88457,0x6f05001c,0x225f806a}},	//   _corr, ncı_, _tphc, _smuk_,
   {{0x443c88df,0x224d90f4,0x7c3c3da6,0x60cd008e}},	//   _mov_, _plek_, _dorr, _hwam,
   {{0x60cd3da7,0x443cbda8,0x644e0808,0x442a3da9}},	//   _kwam, _lov_, _elbi, _enb_,
   {{0x7c3c3b39,0xa8038214,0x6e3d0122,0x67218503}},	//   _forr, _çıkt, _iosb, _srlj,
   {{0x67218052,0x6602afd5,0x7c3c3daa,0x60cd2169}},	//   _prlj, _abok, _gorr, _mwam,
   {{0x3949a338,0xddc40353,0x98bf807e,0x60cd0c6a}},	//   šas_, lniš, ırım_, _lwam,
   {{0x2ca7834a,0x439413cd,0x83fc82a5,0x75228bcf}},	//   _sind_, _расс, viđa, _broz,
   {{0x7522a7f5,0x60cd0133,0x2ca7bdab,0xd7fbbdac}},	//   _croz, _nwam, _pind_, _муж_,
   {{0x660d3dad,0xfc318307,0x443c946a,0x20cd3dae}},	//   heak, احة_, _cov_, dži_,
   {{0x2ca79699,0x443cbc22,0x60cd2142,0xda661612}},	//   _vind_, _dov_, _awam, евни,
   {{0x23bf873c,0x2bbf8744,0xfbbf853f,0xee2e8a8e}},	//   _श्रद, _श्रा, _श्रम, _ён_,
   {{0xed4ebdaf,0x7522bdb0,0x1bf00076,0x6e2b8915}},	//   _со_, _groz, _चालल_, _ingb,
   {{0x6aa996a1,0xddc4135a,0x26de0024,0x653a80be}},	//   _lief, dniš, štom_, _מענד,
   {{0x44f9bdb1,0xdb18802a,0x6619a358,0xe73a1289}},	//   lè_, _devó, _kawk, чев_,
   {{0x661bbdb2,0xb17b0e23,0x62840c53,0x443c8069}},	//   nduk, rgår, _ukio, _zov_,
   {{0xfce32856,0x14262f84,0x60cd03c3,0x660301e5}},	// [2aa0] лото, ндам, _gwam, ыпта,
   {{0x78fb0051,0x443c81e9,0x395704de,0x7e7b0289}},	//   _צפיו, _xov_, _נשים_, čupa,
   {{0x7c3c3db3,0x6d441283,0xb5fd8bcf,0x6aa9bdb4}},	//   _vorr, syia, ziša, _bief,
   {{0xddc40db7,0x7ae30742,0x661babea,0x2bb206b7}},	//   bniš, ánta, jduk, _जलवा,
   {{0xa3e9016f,0x442a3db5,0x44f986c0,0x6aa986a8}},	//   _याच_, _tnb_, jè_, _dief,
   {{0x75249dd7,0x98a38991,0x6e2b826b,0x10a38c9b}},	//   _šizo, гиче, _angb, гичн,
   {{0x91e6964f,0x443c81e9,0x09e6835f,0x7989bdb6}},	//   _пове, _rov_, _повн, _eyew,
   {{0x7522bdb7,0x443cbdb8,0xb87b3db9,0x661b8bb1}},	//   _proz, _sov_, quív, gduk,
   {{0x443c81c5,0x6ecc8105,0xc8ca9ef7,0x09cc8054}},	//   _pov_, _सबकु, _روان_, ारीय,
   {{0xa2b48076,0x60cd2fc0,0x61f61c33,0x201a0019}},	//   _ईंद्, _rwam, _acyl, _napi_,
   {{0x443cbdba,0xddc4007a,0xdee381a1,0xcf1200ab}},	//   _vov_, zniš, _бохи, হমুদ_,
   {{0xb5fdbdbb,0x7649bdbc,0xdc3c8042,0x7522bdbd}},	//   lišn, ckey, _išču, _troz,
   {{0x81a900c8,0x443c9d14,0x261981ce,0x39468019}},	//   খুন_, _tov_, _मोटी_, nyos_,
   {{0x201a3dbe,0xa3490032,0xb87b002a,0xb5fdbdbf}},	//   _capi_, _bọ́t, prím, unšv,
   {{0x45d51630,0x81b000fc,0x660d3dc0,0x141b81c6}},	//   ковс, _gaɓo, teak, _מוגב,
   {{0x6d1c00d4,0xddc40ee1,0x63ae019d,0x60cd1f34}},	//   निंग_, tniš, _agbn, _twam,
   {{0x30a7007f,0xa8a71541,0x31351777,0xb87b008b}},	// [2ab0] _пров, _прок, _репр, nrík,
   {{0xb5fd8052,0xddc4007a,0x7989808e,0x63ba88ae}},	//   jišn, rniš, _ryew, nctn,
   {{0xb5fd803a,0x28b717ba,0xddc4012b,0xf6990dc7}},	//   dišn, _इंडि, sniš, _овој_,
   {{0x44f99c5e,0x290901bc,0xd83889d1,0xb926019d}},	//   yè_, _kpaa_, _miču_, _nkwọ_,
   {{0xca749459,0x201a3dc1,0xdb0187f1,0x00000000}},	//   دالغ, _yapi_, nclò, --,
   {{0x6bd40c2b,0xb92601bc,0x290905ee,0x7e628176}},	//   _متفر, _akwọ_, _mpaa_, _amop,
   {{0x439415fe,0x6aa981ec,0xd838817f,0x79c980f7}},	//   _барс, _tief, _niču_, _يوسف_,
   {{0x44f986c0,0x9f4c8580,0x68fd072c,0x4ada825a}},	//   tè_, _abdó_, ktsd, _भिजव,
   {{0xb5fd8699,0x60db80b8,0x3d170072,0x81b000fc}},	//   bišn, _uvum, निटे_, _saɓo,
   {{0x44f9bdc2,0xd83881a1,0x26de0061,0x7bd71029}},	//   rè_, _biču_, átok_, naxu,
   {{0x201a0458,0x9f0492dc,0x3a3f86c0,0x26c101c0}},	//   _rapi_, _مولو, _koup_, _ntho_,
   {{0x201a08b3,0x44f9bdc3,0xa96a2300,0x216a2d59}},	//   _sapi_, pè_, дима_, дими_,
   {{0x212400f7,0x6486807b,0x9f5801fa,0x44f98037}},	//   ímh_, gðis, rfrí_, qè_,
   {{0x66e600a9,0xed5684ae,0x3a3f92b6,0xb05b148c}},	//   кога, _још_, _loup_, spän,
   {{0xe1ff388a,0xfc3f0ba3,0xb5fb008b,0x17790198}},	//   mión_, _luís_, _smáa, есть_,
   {{0x80d280c8,0xe5f3002e,0x201a0010,0x224b1142}},	//   _সমস্, văţă, _wapi_, ckck_,
   {{0x201a0500,0xb87b04c3,0x28dc0d86,0xbea33dc4}},	// [2ac0] _tapi_, tuít, _बिटि, ратк,
   {{0xe1ff128e,0x3eab0db1,0xf1a701d0,0x224002f9}},	//   nión_, _eict_, _गणतन, _hoik_,
   {{0xb5fd805c,0x3a3f82d6,0x3e7a8ec3,0x00000000}},	//   višn, _boup_, līte_, --,
   {{0x3a3f82be,0x20058bb1,0xb87b3dc5,0xbebc81a9}},	//   _coup_, _abli_, buís, _brīn,
   {{0x6f088118,0x2444007b,0x99dd8176,0xc7b880fe}},	//   _spdc, _sömu_, _alňs, _lađe_,
   {{0x75360713,0xdb1c0065,0xe9f910ab,0x3ea03dc6}},	//   mxyz, _kerü, _diẹ_, lmit_,
   {{0xc7b8805c,0xb5fd8390,0x7c2e3dc7,0xe8e0001c}},	//   _nađe_, rišn, _inbr, _ước_,
   {{0x2005826c,0xeb970956,0x9f580144,0x5eea01d0}},	//   _ebli_, _рис_, leró_, _छिन्_,
   {{0x5ea381a8,0xdb1abdc8,0x5275bd93,0x00000000}},	//   جميل, natö, _суру, --,
   {{0xe1ff3dc9,0xe7ee016f,0x9f580388,0x515b807c}},	//   gión_, _जागा_, neró_, _חכמו,
   {{0xad9b04be,0x3d178035,0x2252067f,0xdc3c80c3}},	//   _abúl, _बैठे_, _blyk_, _ušču,
   {{0x28b70540,0xb87b01ac,0xdb1c3dca,0xacbb0036}},	//   _इंदि, prík, _heró, _brûl,
   {{0xe1ff04c3,0x81cc00ab,0xb87b016a,0x7c2e1c11}},	//   bión_, _লাখ_, nsíg, _onbr,
   {{0xe1ff161b,0xd83882a5,0x545386cf,0x14d78158}},	//   ción_, _tiču_, _квіт, _יודל_,
   {{0x386d02fd,0x44d00063,0x3eab02f7,0x9f5801ca}},	//   đer_, eń_, _pict_, deró_,
   {{0x320f0065,0x02a4027e,0x5bcb1905,0x7c2e3dcb}},	//   _úgy_, _крым, िर्व, _anbr,
   {{0xf1b98042,0x35b415da,0x9a6800f7,0x5c7511b3}},	// [2ad0] _jaše_, рбур, _جميل_, глат,
   {{0x7ae33dcc,0xa5bb3dcd,0x7bc582f1,0x5454102a}},	//   ánto, _anót, _õhut, авут,
   {{0x629f047f,0xe81d80d4,0x6aad004f,0x3ea00039}},	//   _èpos, _योगा_, _kiaf, bmit_,
   {{0x20113dce,0xe45f00f2,0x3ce90353,0x798d31af}},	//   lezi_, _stöd_, prav_, _kyaw,
   {{0x26debdcf,0xc7b80289,0x91058d15,0x6aad2aa0}},	//   _avto_, žđe_, упле, _miaf,
   {{0xe1ff02ba,0x661d04b9,0x24440106,0x764d3dd0}},	//   xión_, _hask, _döms_, lkay,
   {{0x27e9817b,0x9388002e,0x8aa78088,0xead41091}},	//   ğan_, _аста_, _арад, _вось,
   {{0x1dd30076,0x27e982bb,0x765801e2,0x442e81e0}},	//   तरित, şan_, _įvyk, _anf_,
   {{0xe1ff1727,0x798d0397,0x2a648098,0x442ebdd1}},	//   tión_, _nyaw, _търг, _bnf_,
   {{0x661d19e0,0x69d9bdd2,0x3ea000f1,0xec769619}},	//   _lask, lawe, zmit_, лпы_,
   {{0x7bd53dd3,0x6aad3dd4,0x25af80dd,0x9f5801e8}},	//   _mezu, _biaf, _tggl_, herò_,
   {{0xe1ff161b,0xceb2804c,0x69d9822e,0x1cb98013}},	//   sión_, _היא_, nawe, _كاتب_,
   {{0xfce58729,0x798d00b4,0xdb0e0032,0x764d3dd5}},	//   _соло, _cyaw, _egbè, dkay,
   {{0x44fd3dd6,0x7e698110,0x201124e7,0xdb1c002a}},	//   dì_, liep, gezi_, _xeró,
   {{0xcfd880c8,0xb87b0ece,0x2d8f01ec,0x69bc064a}},	//   _সামন, tuír, ügen_, _एलपी,
   {{0x661d3dd7,0x69d9bdd8,0x6e3b8365,0xe3cd00ab}},	//   _cask, jawe, njub, _লাগব,
   {{0x61e43dd9,0x3ea00648,0x62863dda,0x9f580388}},	// [2ae0] _idil, rmit_, moko, teró_,
   {{0x62863ddb,0x09cc90be,0xdb1c0019,0x3ea03ddc}},	//   loko, ार्य, _terü, smit_,
   {{0x272382bb,0x6e3bbb0f,0x661d3ddd,0x91d086a7}},	//   _nın_, kjub, _fask, दरलै,
   {{0x2485bdde,0x661d00a4,0x62860b09,0x69d9bddf}},	//   holm_, _gask, noko, gawe,
   {{0x1ae03792,0x186a9bdc,0x9f581e09,0x91e3bde0}},	//   _पटकथ, нади_, peró_, соче,
   {{0x69d63de1,0x62863de2,0x7bd53de3,0x6d5b8748}},	//   _leye, hoko, _gezu, dzua,
   {{0xeb970bda,0x69d99e54,0xdb1c0333,0x62863de4}},	//   _бир_, bawe, _veró, koko,
   {{0x660402ee,0xf1b9b6f0,0x60c4072f,0x79892358}},	//   nfik, _paše_, _otim, żewi,
   {{0x54548e8e,0x20110c2e,0xb21b03ba,0x60c43de5}},	//   ивит, yezi_, klær, _ntim,
   {{0xf1b99eee,0x4cc380ab,0xdb0e046d,0xe64487c0}},	//   _vaše_, _শিশু, _agbé, ılış,
   {{0x60c43de6,0x798d0859,0x4394bde7,0xaa5919fe}},	//   _atim, _syaw, ранс, вину_,
   {{0x201ea7ba,0x20112994,0xe45287d2,0x62863de8}},	//   _hati_, wezi_, _گفتگ, goko,
   {{0x201e9af2,0x661d3de9,0x20113dea,0x61e40114}},	//   _kati_, _rask, tezi_, _ddil,
   {{0x61e40a0b,0x661d3deb,0x201e8397,0x76428079}},	//   _edil, _sask, _jati_, _hooy,
   {{0x7bdabdec,0x661d3ded,0x201e885c,0x20113dee}},	//   matu, _pask, _mati_, rezi_,
   {{0x201e8324,0x7642ba46,0x69d61210,0xdb188192}},	//   _lati_, _jooy, _geye, _bevö,
   {{0x20113def,0x764d3df0,0xdb0501ec,0xdddb81d0}},	// [2af0] pezi_, rkay, schü, nouš,
   {{0x201ebdf1,0x69c0bdf2,0x44fd3df3,0x661d3df4}},	//   _nati_, _afme, rì_, _wask,
   {{0x7bd50b67,0x69d9a169,0x44fd3d36,0x8af902a4}},	//   _vezu, tawe, sì_, тнес_,
   {{0x7bdabdf5,0x7f3a00be,0x21290168,0x7d160428}},	//   hatu, _סערו, _krah_, bwys,
   {{0x7bdabdf6,0x201ebdf7,0xe0df3df8,0x6728bdf9}},	//   katu, _bati_, nsò_, _ardj,
   {{0xe800a9b7,0xd2d7190c,0xb3468214,0x67288b80}},	//   ल्ला_, _مغرب, _kaçı, _brdj,
   {{0xe73982da,0x201ebdfa,0x7bdabdfb,0x629b801c}},	//   тей_, _dati_, datu, _thuo,
   {{0x8aa48aca,0xddc2809a,0xb87b0317,0xa2678098}},	//   _груд, _iloś, crív, _съгл,
   {{0x7bdabdfc,0xee36827e,0x69d63dfd,0xb5fd8984}},	//   fatu, рны_, _reye, lišk,
   {{0x6e3bbdfe,0x201e80f1,0x62863dff,0x44213b15}},	//   sjub, _gati_, woko, ndh_,
   {{0x4421279d,0x21290397,0x62863e00,0xb5fd8984}},	//   idh_, _arah_, toko, nišk,
   {{0x201e811b,0x3cee8072,0x764281b4,0x2cae8362}},	//   _zati_, _आमचे_, _gooy, _eifd_,
   {{0x62863e01,0x7bda9611,0x44313e02,0x8e8480f7}},	//   roko, batu, _onz_, _النه,
   {{0x7bdabe03,0x9f58007b,0x25bfbe04,0x6c7980be}},	//   catu, ferð_, lcul_, _שאַפ,
   {{0x07a605d3,0x8fa61cd5,0x62863e05,0x45d61354}},	//   равн, раве, poko, ицат,
   {{0x25bf8590,0x13da80ab,0x64553e06,0x6443be07}},	//   ncul_, _দায়, _alzi, _honi,
   {{0x6443be08,0x6604208b,0xb4663e09,0x21292368}},	// [2b00] _koni, rfik, акал, _grah_,
   {{0x75243e0a,0x3eaf8a0f,0xe457113f,0x61fb87db}},	//   rviz, _ligt_, ажу_, _acul,
   {{0x3a200a8e,0x6443a776,0x44310267,0x201ebe0b}},	//   _kaip_, _moni, _dnz_, _rati_,
   {{0x201e803b,0x4421154c,0x6443946f,0xa9268e97}},	//   _sati_, adh_, _loni, идел,
   {{0x201e9f7c,0xd3788025,0x7bda8545,0x67288904}},	//   _pati_, maće_, yatu, _srdj,
   {{0xdb1c0125,0x7ee68790,0x6443be0c,0x6aa2bb99}},	//   _ferð, ацие, _noni, smof,
   {{0x7bdabe0d,0xdb1c0125,0xd6d784d9,0x290d8102}},	//   vatu, _gerð, аты_, _epea_,
   {{0xf53f3e0e,0x7bdaa892,0x7e7601e0,0x96348389}},	//   _igår_, watu, nnyp, сниц,
   {{0x7bdabe0f,0xd90e8bca,0xdd978ca4,0xd49a8256}},	//   tatu, _آیت_, ишь_, кро_,
   {{0x656fb128,0x7642885a,0x320902c4,0x6443a91e}},	//   úcha, _wooy, _sbay_, _coni,
   {{0xc5e880c8,0x0bb70051,0x6f09009a,0xc7b8817f}},	//   ক্ষা_, ילים_, łecz, _gađa_,
   {{0x7bdabe10,0x3ced8082,0xd3789487,0xaa673e11}},	//   satu, brev_, jaće_, рток,
   {{0x7bdabe12,0xdfdb0098,0x6443be13,0xd37880ce}},	//   patu, къв_, _foni, daće_,
   {{0x27ed0352,0x64438988,0x588701e2,0xf1b9be14}},	//   ßen_, _goni, рыма, _maša_,
   {{0x80d881ce,0x09d780ab,0xe0df3a68,0x27ed02d0}},	//   _नौसे, _হাসা, ssò_, ğen_,
   {{0xb5fd8110,0x27ed0214,0xe65400e8,0x443e8106}},	//   višk, şen_, овсь, ljt_,
   {{0xf1b9be15,0x69dd3e16,0xc7b80289,0x656d81ac}},	// [2b10] _naša_, mase, žđa_, _ľahk,
   {{0x69dd3e17,0x57f505f1,0xa802899b,0x2a690282}},	//   lase, _упот, çıla, _hmab_,
   {{0x94a803a7,0xd3788b67,0xbebc81a9,0x442103ed}},	//   ртта_, baće_, _drīk, rdh_,
   {{0xdb1c07ca,0x69dd3e18,0xb5fd8984,0xc7b882a5}},	//   _verð, nase, rišk, _rađa_,
   {{0x634a8201,0xb5fd8110,0x645a8079,0xe4a703a7}},	//   lənd, sišk, khti, _врво,
   {{0x69dd3e19,0x89348065,0xe2d90065,0xb87b157a}},	//   hase, تعما, _مارچ_, crít,
   {{0x81e200c8,0x69dd3e1a,0x6d4d0def,0xb92081bc}},	//   ন্ট_, kase, lyaa, _karị_,
   {{0x6443be1b,0x80b800c8,0x69dd3e1c,0xb920819d}},	//   _soni, _অবস্, jase, _jarị_,
   {{0x6d4d0d7a,0x6443be1d,0xb5fd8e63,0x25bf8087}},	//   nyaa, _poni, niši, rcul_,
   {{0x25bfbe1e,0xd37885a2,0x799b8300,0x628d3e1f}},	//   scul_, zaće_, _izuw, _akao,
   {{0xd7958013,0x3a2003ac,0x6443be20,0x7e6d3e21}},	//   _الاخ, _paip_, _voni, kiap,
   {{0xc0493e22,0x64438613,0x69dd3e23,0x42561878}},	//   _אז_, _woni, gase, стот,
   {{0xd3788024,0xa3d73e24,0x2f01be25,0x2ba7016f}},	//   vaće_, सरा_, lóg_, केता,
   {{0x645abe26,0x2902231b,0x7bd8910f,0x10a6002e}},	//   chti, rtka_, _gevu, сигн,
   {{0x3a200a8e,0xd378876c,0xaa4601e5,0xdddb81b9}},	//   _taip_, taće_, _гейл, kluż,
   {{0x7bc1be27,0x765bbe28,0x69c101d0,0xaac48a19}},	//   lclu, nhuy, ělec, _بتون,
   {{0xe5a324c8,0xd37881dd,0x6da33e29,0x3ae382d0}},	// [2b20] зити, raće_, зита, lıp_,
   {{0xf1b981f4,0xd3788390,0xb87b2216,0xb3d58264}},	//   _raša_, saće_, rsíc, _দাঁড়,
   {{0x3ce01031,0xf1b9979d,0x68e4013c,0x6d4d0d92}},	//   ssiv_, _saša_, _hvid, ayaa,
   {{0xeb9702c7,0xe8040105,0xddcd0087,0xb5fd8115}},	//   щих_, श्रा_, rnaţ, biši,
   {{0xcfcf80c8,0xaca40135,0x7bc194a2,0xdd920c2a}},	//   _রাজন, _anụr, kclu, _روس_,
   {{0xf1b9be2a,0x3ae382d0,0x6e2408bf,0x99dd84e8}},	//   _vaša_, kıp_, ldib, _voňa,
   {{0x76460110,0x7bd8be2b,0x69dd3e2c,0x7bde3e2d}},	//   _koky, _revu, yase, mapu,
   {{0x6e243e2e,0xdb1c016d,0x645d80f1,0xceb30039}},	//   ndib, _berö, ësin, היה_,
   {{0x7d043e2f,0x764601e2,0x69dd03ca,0x7bd881a1}},	//   ntis, _moky, vase, _pevu,
   {{0x7bde103b,0xb4d6000d,0x409680f7,0xe7f28592}},	//   napu, _सबै_, _الطر, _घाटा_,
   {{0x69dd3e30,0x7d043e31,0x68e40e94,0x539880e8}},	//   tase, htis, _avid, рвня_,
   {{0x645a820f,0x7d04120b,0x7ae30511,0xf363876a}},	//   shti, ktis, ánti, ятын,
   {{0x7bde3e32,0xd90f0077,0x6443016d,0x6d4d0079}},	//   kapu, رید_, önik, xyaa,
   {{0x80b800ab,0x634a8085,0x69dd3e33,0x68e901a1}},	//   _অবশ্, tənd, sase, šedo,
   {{0xf773115f,0x6fda0ee6,0x69dd3e34,0x764602c4}},	//   ساس_, _बजरं, pase, _boky,
   {{0xdceb0a21,0x8afc809a,0x7d04075e,0x6e240ec9}},	//   žičk, rzęd, ftis, gdib,
   {{0x76463e35,0x68e40dc1,0x26de14b5,0x68e28824}},	// [2b30] _doky, _gvid, átor_, jsod,
   {{0x7e6d1083,0xb5fd811f,0x7bde3e36,0x6d4d0079}},	//   siap, riši, gapu, ryaa,
   {{0x6d4d07d5,0xb87b002a,0x6e242ad9,0xb5fd8088}},	//   syaa, brír, bdib, mišv,
   {{0x09ad00c8,0x9989003a,0x200cbe37,0xa3c90424}},	//   _ক্যা, _znaš_, _abdi_, ैरह_,
   {{0xab620182,0x645885b4,0x7d043e38,0xe9d88a8e}},	//   _çünk, _olvi, ctis, скі_,
   {{0x3ae38214,0xd5e28032,0x7ff5803d,0x1ec98878}},	//   yıp_, _amò, زستا, алки_,
   {{0x8fa2867c,0xaad786a7,0xb87b0144,0x70b50035}},	//   маше, _भौंक, nríq, ंदुल,
   {{0x245b83d3,0x44233e39,0x6e229493,0x2f01be3a}},	//   _même_, _haj_, _caob, róg_,
   {{0x44233e3b,0x64470025,0x628b9f1e,0x1fa61d40}},	//   _kaj_, _koji, mogo, _खण्ड,
   {{0x628bbe3c,0xdb1c10f6,0x3d098321,0x60c9b593}},	//   logo, _verö, _वहीं_, _item,
   {{0x68e4011f,0xeb99be3d,0x64900364,0x3b099ac9}},	//   _svid, рин_, päiv, шено_,
   {{0x44233e3e,0x64473e3f,0x7bde01df,0xa3b58ebf}},	//   _laj_, _loji, zapu, _झलक_,
   {{0x7bde2d1f,0xe820800d,0x229c816b,0xa3a93738}},	//   yapu, _यसमा_, níka_, खेत_,
   {{0x44233e40,0x9f5800e7,0x6e228b5d,0x660998e8}},	//   _naj_, lgré_, _zaob, lfek,
   {{0xe29a1b93,0x61e99ba5,0xa7aa3e41,0xf1b98353}},	//   _как_, _odel, рква_, _našo_,
   {{0x69db8352,0x7bde04cd,0x61e9803d,0x6e2427f5}},	//   _neue, wapu, _ndel, udib,
   {{0x6447025b,0x7bde2575,0x0eb6000f,0x628bbe42}},	// [2b40] _boji, tapu, _आंकड, dogo,
   {{0x7659831d,0x44233e43,0x61e9be44,0x64473e45}},	//   _llwy, _caj_, _adel, _coji,
   {{0xb7240077,0x7c238722,0x8fa6284f,0xe73a1bdc}},	//   _عکسه, _manr, _фане, _тен_,
   {{0x20180179,0x7afd8063,0x212000dd,0x6b7a80be}},	//   leri_, ństw, _ksih_, ברענ,
   {{0x44233e46,0x64a602cb,0x69c284c3,0x7bde3e47}},	//   _faj_, _мама, rcoe, papu,
   {{0x6e22a8e1,0x20183e48,0x61e9be49,0x2912022e}},	//   _saob, neri_, _edel, _mpya_,
   {{0xf8bf8a0f,0x6609a09b,0x68e2be4a,0x69db81ec}},	//   _één_, ffek, ssod, _feue,
   {{0x442301e9,0x7bdc3e4b,0x20183e4c,0xe3b8817b}},	//   _zaj_, _heru, heri_, rdım_,
   {{0x7bdc07d5,0x7c23be4d,0xd378911b,0x442301c5}},	//   _keru, _banr, daća_, _yaj_,
   {{0x2018003a,0xddc40f20,0x344a9810,0x44230069}},	//   jeri_, jniž, рчин_, _xaj_,
   {{0x7bdc1a67,0x6e228ad0,0x64900009,0x61e9806a}},	//   _meru, _taob, läis, _ydel,
   {{0xbebc8029,0xf1b18105,0xbddb0036,0x7529811a}},	//   _brīv, ुँचन, _poèm, bvez,
   {{0x2906be4e,0x64900198,0xe53486d2,0xddcd01d0}},	//   ntoa_, näis, _хель, chař,
   {{0x20183e4f,0x7bdc3e50,0x7c238114,0xe3af8019}},	//   geri_, _neru, _ganr, عری_,
   {{0x6447349a,0x6abc00dd,0x466b3e51,0xe9f9001c}},	//   _roji, _nurf, арам_, _chả_,
   {{0x44233e52,0x644704b9,0x64900009,0x7bdc3e53}},	//   _saj_, _soji, käis, _aeru,
   {{0x7bdc3e54,0x20183e55,0x44233e56,0x628b8503}},	// [2b50] _beru, beri_, _paj_, vogo,
   {{0xb5fd803a,0x20183e57,0x7bdc3e58,0xf1b9b78b}},	//   lišt, ceri_, _ceru, _pašo_,
   {{0x442301e9,0x628b8503,0x60c987ea,0x7bdc3e59}},	//   _vaj_, togo, _stem, _deru,
   {{0x61fd2280,0xf1b9807a,0xb87b0187,0x78bb87b8}},	//   ngsl, _vašo_, juíz, _puuv,
   {{0x44230025,0x3ea90364,0x7bdc3e5a,0x61fd3e5b}},	//   _taj_, mmat_, _feru, igsl,
   {{0x7bdc044e,0x3ea91f5d,0xb5fd807a,0x44b40098}},	//   _geru, lmat_, hišt, _обяс,
   {{0x7bc51b7c,0xa2ab8697,0x69db81ec,0x6abc0041}},	//   mchu, जगद्, _teue, _gurf,
   {{0xee39867c,0xe9df87ca,0xb5fd90d1,0x61e9be5c}},	//   сни_, _þú_, jišt, _udel,
   {{0x7bdc1d1b,0x1c0b000d,0x1a68803d,0x195881bb}},	//   _yeru, स्थल_, _بینی_, _даты_,
   {{0x200100f6,0x75298065,0x3ea927df,0x7bc53e5d}},	//   _nchi_, rvez, hmat_, nchu,
   {{0xf9890159,0x7c23be5e,0x3ea9059c,0x260c11bc}},	//   _ער_, _vanr, kmat_, ड्डी_,
   {{0xc86904de,0x98a90279,0x6721817f,0x20183e5f}},	//   _גן_, _drač_, _islj, weri_,
   {{0x20183e60,0x3ea90ad4,0xd378812b,0x7c23861c}},	//   teri_, dmat_, raća_, _tanr,
   {{0xb5fd8b67,0x39408198,0x2a7f82d4,0x64902079}},	//   rišu, äisi_, _ljub_, häir,
   {{0x2bd1835a,0x7bdc11ee,0x20183e61,0x43758158}},	//   _द्या, _reru, reri_, _מײַן_,
   {{0x7bdc085c,0x20010133,0x3ea9028c,0x98a008ae}},	//   _seru, _echi_, gmat_, _orić_,
   {{0x7bdc3e62,0x959a3aa3,0x20183e63,0x056636ae}},	// [2b60] _peru, ству_, peri_, чван,
   {{0xf1bf3e64,0x14231b67,0xdb0e04be,0x69c608f9}},	//   ndán_, ндум, _agbá, lcke,
   {{0x7bdc3e65,0x2ba704e5,0xdc9a80be,0x68f981ed}},	//   _veru, केला, ציעל, euwd,
   {{0x64900364,0xb87b01df,0x645e3df9,0xfc3f01df}},	//   täis, xuíz, shpi, _xuíz_,
   {{0x7bdc03ac,0xc5f3012a,0x3a26800b,0xf91880d7}},	//   _teru, _אדר_, rdop_, تراژ_,
   {{0x7bc5279e,0xb5fd8668,0x2a7fb2df,0x6e26020d}},	//   cchu, zišt, _ejub_, _hakb,
   {{0x64a30be4,0x2906be66,0x98a00b80,0x63830251}},	//   _чара, stoa_, _erić_, _згра,
   {{0x44443e67,0xb86680d5,0xa534be68,0x64903e69}},	//   lj_, _کارو, днич, päis,
   {{0x444401e9,0xb5fd9620,0xfc3f157a,0x6e263e6a}},	//   oj_, višt, _ruíz_, _makb,
   {{0x44443e6b,0x3ea93e6c,0xfd0f81a8,0x6aa405ee}},	//   nj_, zmat_, اجي_, _ahif,
   {{0x444401c5,0x443801b0,0xb5fd90d1,0x04fe80ab}},	//   ij_, _mnr_, tišt, ্টের_,
   {{0x6aa43e6d,0x7f3b8039,0x20013e6e,0x61e2be6f}},	//   _chif, _לעבו, _schi_, naol,
   {{0xb5fd803a,0x444400ee,0x3ebe9670,0x81e180ab}},	//   rišt, kj_, _hutt_, _দাম_,
   {{0x8c438652,0xb5fd8115,0x042080ab,0x7b058198}},	//   _пече, sišt, বাহী_, öttö,
   {{0xb5fd801b,0xe9ff801c,0x6e263e70,0x98a68088}},	//   pišt, _loạn_, _bakb, jvoč_,
   {{0x44443e71,0x7afabe72,0x6aa40d8b,0x5f9400e8}},	//   ej_, mutt, _ghif, хист,
   {{0x644abe73,0x7afabe74,0x61ed3240,0x628f01ac}},	// [2b70] _kofi, lutt, _idal, moco,
   {{0x60cd3e75,0x5ba71777,0x7c2894ba,0x628f0c1d}},	//   _itam, през, nddr, loco,
   {{0x7afaaa3d,0x7bc53e76,0x644a8915,0x660281a1}},	//   nutt, rchu, _mofi, _ocok,
   {{0x444410af,0xe1ff3e77,0x7bc51d77,0x27e33e78}},	//   aj_, ngó_, schu, lajn_,
   {{0xa95480e8,0x92b48060,0xb5fb04be,0x7afaaada}},	//   нкці, رحما, _alág, hutt,
   {{0xf77083f8,0x7afabe79,0xe0d08591,0x644abe7a}},	//   گاه_, kutt, ازن_, _nofi,
   {{0x9ea98056,0x69c600f2,0x16a99240,0x628f06cb}},	//   овка_, ycke, овки_, koco,
   {{0x7c273e7b,0x61ed3e7c,0x7afaa1da,0x2a7faf12}},	//   _hajr, _ndal, dutt, _ujub_,
   {{0x644abe7d,0x68e480f7,0x3e6a803d,0x60cd3051}},	//   _bofi, áidt, تجوی_, _ntam,
   {{0x61ed045c,0x644abe7e,0x6aa433fe,0x8b07928a}},	//   _adal, _cofi, _shif, _naří,
   {{0x60cd3e7f,0x1c020b04,0x6721856f,0x28b706af}},	//   _atam, र्टल_, _uslj, _इंजि,
   {{0x628f002a,0x60db8a03,0x2d8e8135,0x68e9be80}},	//   goco, _kwum, ịlị_, _kved,
   {{0x752d02a5,0x660d3e81,0x98a48087,0x61ed3e82}},	//   jvaz, dfak, _urmă_, _ddal,
   {{0x764b8065,0x6e298ca6,0x7afa80df,0x7c273e83}},	//   _hogy, ldeb, butt, _najr,
   {{0x2dcb0a2c,0x28dd8b75,0x628f0359,0x60cd34c2}},	//   _ụlọ_, नीति, boco, _etam,
   {{0x44279e7c,0x444401e9,0x661bbe84,0x96950f27}},	//   _han_, wj_, neuk, еруш,
   {{0x4427be85,0x7c27269d,0x644a8b99,0xfce30009}},	// [2b80] _kan_, _bajr, _yofi, кото,
   {{0x444410af,0x4427be86,0xb5fb3e87,0x660d036e}},	//   uj_, _jan_, _alád, afak,
   {{0x4427be88,0x6e263e89,0x7d09be8a,0xe1ff3d9f}},	//   _man_, _takb, htes, ciós_,
   {{0x4427be8b,0x8b07801b,0x7d09be8c,0xe1ff009a}},	//   _lan_, _zaří, ktes, chód_,
   {{0x09e390f8,0x44278129,0xe3e380ab,0x61e2be8d}},	//   точн, _oan_, _মানব, raol,
   {{0x4427be8e,0x645c048d,0xdfcf80a0,0x68e981a1}},	//   _nan_, _ulri, ليه_, _dved,
   {{0x63bc01a1,0x61e280e5,0xdde181f4,0x60db871f}},	//   _igrn, paol, _šuša, _ewum,
   {{0x4427bade,0x27e328fc,0x661b804f,0x7afa8198}},	//   _aan_, zajn_, geuk, vutt,
   {{0x4427be8f,0x628f1d3a,0xe7cfbbf1,0xc7b8826c}},	//   _ban_, voco, _स्वप, _lađi_,
   {{0x4427804c,0x7afabe90,0x61e0816d,0x3ebe847f}},	//   _can_, tutt, _heml, _tutt_,
   {{0x4427be91,0x764b8019,0x68e98259,0x61e0b204}},	//   _dan_, _fogy, _zved, _keml,
   {{0xc7b8be92,0x60c0be93,0x7afa81dc,0x4427be94}},	//   _nađi_, _kumm, rutt, _ean_,
   {{0x44278cf7,0x27e3012b,0xe8058e5b,0x60c0be95}},	//   _fan_, tajn_, _रामा_, _jumm,
   {{0x4427be96,0x60c0be97,0xa3dfbe98,0x628f3e99}},	//   _gan_, _mumm, तरण_, soco,
   {{0x764b88b3,0x27e304b7,0x2bdd0072,0x7bca82a6}},	//   _yogy, rajn_, यरसा, _iffu,
   {{0x61ed3e9a,0x4427be9b,0x61e0854f,0xfe1480d4}},	//   _udal, _zan_, _neml, _थॉमस_,
   {{0x4427be9c,0x60c0be9d,0x60cd04bf,0x6e940db6}},	// [2b90] _yan_, _numm, _utam, титу,
   {{0x201c803a,0x752d2d08,0x69c980f3,0x4cc800ab}},	//   jevi_, rvaz, _sfee, _লিখু,
   {{0xa3a90d38,0x68e9be9e,0xc7d60051,0xd3711e13}},	//   खें_, _sved, _אותי_, دها_,
   {{0xa4d500e8,0x3a291699,0x7d09971c,0xd3a4066a}},	//   _помі, _jaap_, ytes, труп,
   {{0xb5fb003e,0x7c270197,0xe6ed81ac,0xcce700f7}},	//   _vlád, _tajr, _väčš, _تسجي,
   {{0x07a5838d,0x8fa58847,0xa15801c6,0x78fc01c6}},	//   налн, нале, ובדה_, קלופ,
   {{0x4427be9f,0x3eb90157,0x26c13ea0,0x2eb591d0}},	//   _ran_, _kist_, _juho_, нсис,
   {{0x6d258dcd,0x7bca924b,0x2d990198,0x26c13ea1}},	//   едиз, _affu, _kyse_, _muho_,
   {{0x68e9827f,0x6fca90c5,0x3eb93ea2,0xe5798009}},	//   _uved, _स्कू, _mist_, язи_,
   {{0xf1b9bc6d,0x3eb93ea3,0x201c828e,0x224d83b2}},	//   _naši_, _list_, cevi_, _hoek_,
   {{0x4427bea4,0xe29a0d69,0x09ad00ab,0xdbdc81fa}},	//   _van_, зан_, _ক্লা, ráði,
   {{0x4427bea5,0x7bca8c2e,0x60c0a0ae,0xc332007c}},	//   _wan_, _effu, _yumm, אוט_,
   {{0x3ead8f06,0xdb1c00f2,0xddc98029,0x4427b3ce}},	//   mmet_, _ifrå, cieš, _tan_,
   {{0x3eadbea6,0x4427a12b,0x26c13ea7,0x3eb90362}},	//   lmet_, _uan_, _buho_, _aist_,
   {{0x3eb93ea8,0x4ac6903e,0xa0a3373a,0x66c782d0}},	//   _bist_, _रूपव, уард, _yıka,
   {{0x09da00ab,0xb5fb3ea9,0xe61f00e1,0x3e7a81a9}},	//   _থাকা, _aláb, _skôr_, tīti_,
   {{0x61e63eaa,0x33f6183a,0xdbe2826b,0x3ead8386}},	// [2ba0] makl, ечес, _béèd, imet_,
   {{0x61e63eab,0x60c0beac,0x3eadbead,0xa3df8c28}},	//   lakl, _rumm, hmet_, तरि_,
   {{0x224d8b3c,0x09d780c8,0xaca38135,0x60c0beae}},	//   _boek_, _হাজা, _ahịh, _summ,
   {{0x2cb8034a,0x3ead80f1,0xb34683a7,0x224d8267}},	//   _wird_, jmet_, laçõ, _coek_,
   {{0x645b0065,0x3eadbeaf,0x201cbeb0,0x601382d0}},	//   áció, dmet_, tevi_, kımı,
   {{0xeee70077,0x20c6001c,0xddc98bb6,0xd6da8c24}},	//   _تغیی, _môi_, vieš, пти_,
   {{0x442a0282,0x03a33eb1,0xf093012a,0xda200105}},	//   _iab_, _биро, אנג_, _बसंत_,
   {{0x9634867c,0x442a3eb2,0x60c0beb3,0xddc981a9}},	//   тниц, _hab_, _tumm, tieš,
   {{0x06e085fc,0x644e0063,0x61e61ca6,0x442a3eb4}},	//   _गौरव_, _kobi, dakl, _kab_,
   {{0x224d8613,0x545498a0,0xddc9b7f6,0x2cb8816d}},	//   _zoek_, твот, rieš, örd_,
   {{0x442a2f54,0x3ea68168,0xb346841c,0x7e640234}},	//   _mab_, _thot_, daçõ, khip,
   {{0xf1b981a1,0x2456007b,0x20c600ff,0xa75b825f}},	//   _saši_, _dæmi_, _bôi_, _מדבר,
   {{0x2bd18105,0x51843eb5,0x7e6409c4,0x26c13eb6}},	//   _द्वा, гура, dhip, _suho_,
   {{0x442a0069,0x3eb9035f,0xb346beb7,0x634a8085}},	//   _nab_, _sist_, gaçõ, lənm,
   {{0xf1b9beb8,0x61f40106,0x5f95041c,0x443f0129}},	//   _vaši_, ådlö, тивт, _đu_,
   {{0x78ba9087,0x61e60214,0x3a293bb0,0x439b8039}},	//   _litv, cakl, _uaap_, _מבוג,
   {{0x442a3996,0x3eb93eb9,0x8d770eca,0x442c8114}},	// [2bb0] _bab_, _vist_, رارا, odd_,
   {{0x442a2bf4,0x645abeba,0xb3468073,0xe8058beb}},	//   _cab_, nkti, caçõ, _राधा_,
   {{0x442a01e9,0x442cb3d0,0x443c81a1,0x2d99067f}},	//   _dab_, idd_, _mnv_, _wyse_,
   {{0x7c2a83ec,0xdbe2846d,0x442a1fa4,0x6013a2f8}},	//   _lafr, _dééd, _eab_, zımı,
   {{0x442a3dd7,0x6e3d01ec,0x26debebb,0x99800088}},	//   _fab_, _insb, _awto_, _kaiš_,
   {{0x644e1e4f,0x61e61286,0xa3bc8fcc,0x442a3ebc}},	//   _gobi, zakl, _अलग_, _gab_,
   {{0x7d0d3ebd,0xddcd0087,0x81e70264,0xdb1c08f9}},	//   ltas, ciaţ, _পান_, _ngrè,
   {{0x6e2d3ebe,0xb34680a9,0x442c8355,0x3eb9bebf}},	//   ndab, zaçõ, edd_, öst_,
   {{0x3eadbec0,0x442a3ec1,0x12bd80c8,0x443cba98}},	//   rmet_, _yab_, _আবেদ, _bnv_,
   {{0x09e100ab,0x3eadbec2,0x442a0069,0x61e600b9}},	//   _ভাষা, smet_, _xab_, wakl,
   {{0x6fca800f,0x61e622d1,0x764f3ec3,0x601382bb}},	//   _स्टू, takl, _oocy, rımı,
   {{0x27e7bec4,0x161126ee,0x7d0d3e8c,0x799b808e}},	//   lann_, _डॉलर_, ktas, _kyuw,
   {{0xed4e86f1,0xb3468073,0x61e63ec5,0x6e2d0079}},	//   _то_, taçõ, rakl, ddab,
   {{0x27e78013,0x7d0d013c,0x38a4016d,0xfaf880eb}},	//   nann_, dtas, föra_, brī_,
   {{0x644e21a9,0x442a3ec6,0xb3468073,0x6b66a55e}},	//   _robi, _rab_, raçõ, _végé,
   {{0x442a01e9,0x20c60104,0x644e3ec7,0x27e7ad53}},	//   _sab_, _tôi_, _sobi, hann_,
   {{0xd0408086,0x442a10af,0x6e2b849f,0x644e1188}},	// [2bc0] _etmə, _pab_, _magb, _pobi,
   {{0x442a01e9,0x61e40357,0x644e02f7,0x6e2b84be}},	//   _qab_, _heil, _qobi, _lagb,
   {{0x2c138c28,0x442a3ec8,0xbddb3b51,0x27e7bec9}},	//   त्यं_, _vab_, _poèt, dann_,
   {{0x6aa9beca,0x6e2b849f,0x7afe3ecb,0x60c40010}},	//   _chef, _nagb, rupt, _kuim,
   {{0x442a01e9,0x442ca065,0xe3b88059,0x27e7becc}},	//   _tab_, ydd_, ndır_, fann_,
   {{0xcee919f4,0x27e7becd,0x442a3ece,0x644e005c}},	//   _ترین_, gann_, _uab_, _uobi,
   {{0x8a06867c,0xb8c98fd5,0x7c2abecf,0xa7fc8457}},	//   _изве, _गी_, _rafr, _alıc,
   {{0xfaa6953d,0x66043ed0,0x61e43ed1,0x442c831d}},	//   _рабо, ngik, _neil, wdd_,
   {{0xd3788067,0x27e7bed2,0x47e180ab,0xa3d600a5}},	//   maći_, bann_, _নারী, _सभा_,
   {{0x78ba85f8,0xdb1c00e7,0x27e79a26,0x6b9c3ed3}},	//   _uitv, _agré, cann_, _kyrg,
   {{0x6fd8873c,0x442c8355,0x68ed0b48,0x7d0d3012}},	//   _न्यू, rdd_, _svad, ztas,
   {{0xd3788a20,0x6f798158,0x6282bed4,0x7d0d3ed5}},	//   naći_, _אָנג, nnoo, ytas,
   {{0x61e43ed6,0x60c40ad0,0x94030105,0x6e20bed7}},	//   _deil, _cuim, _लालच_, memb,
   {{0x6e209fce,0x58d42240,0xa2cabed8,0x645d8168}},	//   lemb, рорт, _संप्, ësit,
   {{0x7e62bed9,0x61e43eda,0x260f8701,0x8c1b8039}},	//   _klop, _feil, थ्वी_, _חווי,
   {{0x6e20bedb,0x60c40020,0x7d0d0e20,0x61e43edc}},	//   nemb, _fuim, ttas, _geil,
   {{0xa5070009,0x3944016d,0x7d00bedd,0x16df9513}},	// [2bd0] ъявл, ämst_, nums, _नब्ब,
   {{0x7d0d3ede,0xbbdd0540,0x6e209b8f,0x61e40f67}},	//   rtas, यरेक, hemb, _zeil,
   {{0x27e7bedf,0xddc6009a,0x3946802a,0x7d008088}},	//   vann_, _dokł, exos_, hums,
   {{0x6e20bee0,0x27e7bee1,0x628287b8,0x625396f0}},	//   jemb, wann_, gnoo, _açor,
   {{0x7d00bee2,0x6e208365,0x27e7bee3,0x6f1a8118}},	//   jums, demb, tann_, _aptc,
   {{0x6e2bbee4,0xfa2380ab,0x628281b4,0xaa20050a}},	//   _sagb, ফাইল_, anoo, _बस्छ_,
   {{0x6e2b97ef,0x27e7bee5,0x44211959,0x12bd80ab}},	//   _pagb, rann_, meh_, _আব্দ,
   {{0x44210fc7,0x27e7bee6,0xddcd0029,0x05a70b75}},	//   leh_, sann_, skaņ, _खराब,
   {{0x27e7bb99,0x61e4350d,0xf1b980eb,0x3a3f8122}},	//   pann_, _reil, _pašu_, _inup_,
   {{0x44213ee7,0x60c405f8,0xe9f9001c,0x61e42d01}},	//   neh_, _ruim, _thẻ_, _seil,
   {{0x6e2bbee8,0x91e61d7b,0x60c40cdd,0x21292b36}},	//   _tagb, лоне, _suim, _asah_,
   {{0x44213592,0xcd358416,0x7d00bee9,0x940389ab}},	//   heh_, _مرتب, bums, ƙƙoƙ,
   {{0x61e43eea,0x645d820f,0x4421085c,0x290f839c}},	//   _veil, ësis, keh_, ntga_,
   {{0xe3b882bb,0x4421120e,0x26c5beeb,0x61e43eec}},	//   rdır_, jeh_, _kulo_, _weil,
   {{0x61e43eed,0x91e38074,0x212900b9,0xf1b980c3}},	//   _teil, खराज_, _esah_, _zašt_,
   {{0xa2060fdd,0x26c5beee,0x75243eef,0x7874011c}},	//   _спид, _mulo_, twiz, _müvə,
   {{0x0eb90b71,0x96b909c7,0xe9f9001c,0x22400242}},	// [2be0] туры_, туру_, _nhẹ_, _inik_,
   {{0x6e20bef0,0x29023ef1,0x44213ef2,0x75240db1}},	//   zemb, muka_, geh_, rwiz,
   {{0x7d00b78b,0x6e20b92f,0xd37884a8,0xb17d80e1}},	//   zums, yemb, taći_, _reťa,
   {{0x1efb03c8,0x26d83ef3,0x1c1383eb,0x2c13808e}},	//   _אלטע, mpro_, त्तल_, त्तं_,
   {{0x29023ef4,0x6282ba61,0x44210077,0xb87b041c}},	//   nuka_, rnoo, beh_, rsív,
   {{0x3cf98063,0xb87b00a9,0x3ea03ef5,0x66c787d9}},	//   ोंने_, ssív, llit_, _tıkl,
   {{0x6e208980,0x26c5bef6,0xe8162a2b,0x290200b4}},	//   temb, _culo_, द्या_, huka_,
   {{0x7c2e3ef7,0xe3c1080a,0x26c5820d,0x29023ef8}},	//   _habr, ğış_, _dulo_, kuka_,
   {{0x6e209bcb,0x5986b2f1,0x634a8201,0x7c2e3ef9}},	//   remb, _слаб, məni, _kabr,
   {{0x634a8085,0x7ea58019,0x3e7a80eb,0xd91b807c}},	//   ləni, rópa, tīts_, _אומל,
   {{0x6e209eb3,0x7d00befa,0x7c2e1b42,0x3ea03efb}},	//   pemb, sums, _mabr, klit_,
   {{0x7c2e3efc,0xfce6beb1,0x29023efd,0xa2950221}},	//   _labr, _бодо, fuka_, рамі,
   {{0x6e938624,0xf1b9826c,0x44212eb7,0x667b80be}},	//   _النا, _hašr_, yeh_, _אטאק,
   {{0x2240026c,0xe1ff0333,0x36d50eef,0x6d468198}},	//   _enik_, chón_, иогр, äkau,
   {{0xe7f7946d,0x395f0bb6,0x442e816d,0x2bda801b}},	//   ीलता_, šus_, _iaf_, _म्या,
   {{0x3ea03efe,0x44212709,0x442ebeff,0xf8bf0036}},	//   glit_, weh_, _haf_, uvés_,
   {{0x3cee0063,0x2129078a,0xf8bf02be,0x44213a20}},	// [2bf0] ेंगे_, _usah_, rvés_, teh_,
   {{0x442ebf00,0x225d861b,0xb5fb0511,0x35b43c20}},	//   _jaf_, wkwk_, _glán, сбур,
   {{0x2baa035a,0x9f4780f1,0x44213f01,0x69dd02c4}},	//   _करणा, ranë_, reh_, obse,
   {{0x44213f02,0x60cd9984,0x27e588ae,0x644806c0}},	//   seh_, íamo, _seln_, _òdin,
   {{0x7c2e3f03,0x44213f04,0xd378812b,0xa5bb1e00}},	//   _fabr, peh_, maću_, _caót,
   {{0x46f5a3fc,0x442ebf05,0x3f9e826f,0x26c5bf06}},	//   ачит, _naf_, _bytu_, _pulo_,
   {{0xf771936d,0x36698dc7,0xe7e6016f,0x2902287b}},	//   غات_, како_, करता_, zuka_,
   {{0xee398be2,0x7c2e1620,0xbb840013,0x7c21bf07}},	//   тни_, _zabr, _الفي, welr,
   {{0x81eb00ab,0x656d3f08,0x9f43001b,0x98b9beb1}},	//   মলা_, nzah, dají_, _алат_,
   {{0x9f6b8021,0x26c5bf09,0x5c558425,0xd3788858}},	//   _през_, _tulo_, ртиф, haću_,
   {{0x9f47bf0a,0x290201d3,0x6aad0706,0x68fd000b}},	//   kané_, wuka_, _bhaf, ersd,
   {{0x61eb8c27,0x6f03b3d2,0x6aad3f0b,0x29023f0c}},	//   nagl, munc, _chaf, tuka_,
   {{0x9f47bf0d,0x6f03bf0e,0xb5fb003e,0xaca3819d}},	//   dané_, lunc, _plán, _agụk,
   {{0x29023f0f,0x442ebf10,0x61eb948c,0x2007bf11}},	//   ruka_, _gaf_, hagl, ngni_,
   {{0x6f03a623,0xfaa62103,0x66e6272e,0x29023ebe}},	//   nunc, _како, роба, suka_,
   {{0x22403f12,0xdbdf0125,0x7afc8c58,0x2902004f}},	//   _unik_, _síðu, árte, puka_,

   {{0x6d5b81c5,0x7c2e3f13,0x3ea0007b,0x69c414ed}},	// [2c00] nyua, _pabr, rlit_, _igie,
   {{0xa7fc82bb,0x6f03bf14,0x3ea03f15,0x2baa02f1}},	//   _alın, kunc, slit_, _करदा,
   {{0x6287003e,0x9f47bf16,0xf1a900d7,0x6d5b808e}},	//   čkov, bané_, _لایه_, hyua,
   {{0xeb9715f7,0x2c64016d,0x62863d40,0x6f038bcf}},	//   ших_, _döda_, nnko, dunc,
   {{0x7c2e3f17,0x7bc38081,0xb17d80e1,0x6d5b81c0}},	//   _tabr, _ognu, _deťo, jyua,
   {{0x7d043d95,0xa073835f,0xceb40085,0x2c640106}},	//   muis, огіч, lmə_, _föda_,
   {{0x7d043f18,0x53aa06b7,0xa2ca8935,0x61eb80e5}},	//   luis, _करिश, _संध्, bagl,
   {{0xa2cb09c8,0x62898168,0x2bd21130,0x61ebbf19}},	//   _तंत्, _gjeo, दुरा, cagl,
   {{0x9f43001b,0x7d0405ed,0x6d5b81c0,0xbebc81a9}},	//   vají_, nuis, gyua, _krīz,
   {{0x62863f1a,0x442ead8d,0x9f479c18,0xb806803d}},	//   enko, _qaf_, zané_, _خبره,
   {{0xe9f90028,0x6f03bf1b,0x7d04000b,0x9f478077}},	//   _chế_, cunc, huis, yané_,
   {{0xc3330051,0x7d043f1c,0x7e69bf1d,0x442ebf1e}},	//   קור_, kuis, chep, _waf_,
   {{0x9f478a56,0x442e9acf,0x7d040a6f,0x61f6031d}},	//   vané_, _taf_, juis, _ddyl,
   {{0x786201ac,0x0377804e,0x7d043f1f,0x251b807c}},	//   _dôvo, احیت_, duis, _סווא,
   {{0xe816035a,0x9f47bf20,0xb4c0000d,0xe9f9001c}},	//   द्धा_, tané_, ँदै_, _ghế_,
   {{0x798d10af,0x2c64016d,0xdce60214,0x5f943f21}},	//   _txaw, _röda_, _aykı, цист,
   {{0x7d04087a,0x764d1cbc,0x9f47bf22,0xd90482e3}},	// [2c10] guis, rjay, rané_, _تی_,
   {{0xe8160778,0x9f47bf22,0xea00001c,0x98650065}},	//   द्दा_, sané_, _trải_, _ایسے_,
   {{0x61ebbf23,0x9f47bf0a,0x5b15148d,0x656d0192}},	//   tagl, pané_, смет, szah,
   {{0x09bb00c8,0x7d043f24,0xe8f580f7,0xdddb826c}},	//   _অ্যা, buis, مستخ, knuš,
   {{0xe1f88048,0x3cfe0063,0x200c8a03,0x7e7b80c3}},	//   ргі_, _लिये_, _bcdi_, viup,
   {{0x6f039e53,0xf1bf0061,0x6d5b81c0,0x26d984e8}},	//   tunc, ldás_, vyua, _čsob_,
   {{0xda3597ae,0x61eb809c,0xb5fb0388,0x7e7b80dd}},	//   _левы, pagl, _llám, tiup,
   {{0x44313f25,0x7ea58118,0x6d498102,0x6f03bf26}},	//   _haz_, rópo, txea, runc,
   {{0xee36827e,0x44311c66,0x2aff0054,0x7ea587f0}},	//   сны_, _kaz_, शंकु_, sópo,
   {{0x44310db7,0x3c658364,0xb4658364,0x629982ec}},	//   _jaz_, ског, скол, lowo,
   {{0x64553f27,0x61e98006,0x6d5bbf28,0x20128085}},	//   _mozi, _keel, syua, əyi_,
   {{0x6455003a,0x99808038,0x786201ac,0x60c1bf29}},	//   _lozi, žiť_, _pôvo, _hilm,
   {{0x61e9bf2a,0xf6528039,0x61e4a320,0xd54892c5}},	//   _meel, _מצא_, ðili, _نجوم_,
   {{0xe9f90104,0x1c030665,0x753680be,0x64553f2b}},	//   _thế_, _लागल_, _לאנד_, _nozi,
   {{0x4425b30d,0x6443bf2c,0x6299bf2d,0xceb40085}},	//   mel_, _inni, kowo, tmə_,
   {{0x6609bf2e,0x9f4583fb,0x7d0404fa,0xcf9283de}},	//   ngek, _celé_, tuis, פטן_,
   {{0x6299a4f2,0x44313f2f,0x75298a0f,0x6e241655}},	// [2c20] dowo, _baz_, nwez, reib,
   {{0x64550073,0x44313f30,0x2292016b,0xa3ab8576}},	//   _cozi, _caz_, váky_, _खरा_,
   {{0x61e98c11,0x64553c13,0x291f8009,0xddcb8035}},	//   _beel, _dozi, _apua_, _mogł,
   {{0x4425bf31,0x61e98079,0x201820f0,0x2292016b}},	//   hel_, _ceel, lfri_, táky_,
   {{0x4425bf32,0x60c19010,0x61e98b3c,0x44313f33}},	//   kel_, _bilm, _deel, _faz_,
   {{0xd2598029,0xbb460b88,0xd90d80d5,0x38a9bf34}},	//   _viņa_, _легк, ئیل_, túra_,
   {{0xe80e8e18,0x26c23f35,0x60c1bf36,0xf1bf00e1}},	//   _साठा_, _kiko_, _dilm, ndár_,
   {{0x4425838e,0x61e9aa57,0x6299809a,0x6609836c}},	//   eel_, _geel, cowo, ggek,
   {{0x4425bf37,0x64550db1,0x443103bf,0x89669821}},	//   fel_, _yozi, _yaz_, _укаж,
   {{0xddc28efc,0x61e9bf38,0x26c23f39,0xe8d781c6}},	//   _umož, _zeel, _liko_, _לומר_,
   {{0x61e982a3,0xfd0f80d5,0xb4db0722,0xf743bcb3}},	//   _yeel, وجی_, _gràf, _нефо,
   {{0x32670dea,0x6443bf3a,0x2120008e,0x466980e8}},	//   стов, _enni, _bpih_, _крім_,
   {{0x9f45bf3b,0x4425bf3c,0xb5fb0118,0x201801b9}},	//   _relé_, bel_, _imáx, ffri_,
   {{0x4425bf3d,0x26c20041,0x27ee808b,0x2e3501bc}},	//   cel_, _aiko_, nafn_, _ụf_,
   {{0x443121a9,0x27ff0182,0x26c20870,0xeac9801c}},	//   _raz_, ğun_, _biko_, _hẹn_,
   {{0x64553f3e,0x26c23f3f,0xea00001c,0xf1ba97ba}},	//   _sozi, _ciko_, _trại_, ेशान,
   {{0x5455351e,0x443110dd,0x26c202d5,0xa7fc82d0}},	// [2c30] оват, _paz_, _diko_, _alım,
   {{0x2a690282,0x61e9bf40,0x44310085,0x61ef117d}},	//   _hlab_, _seel, _qaz_, lacl,
   {{0x64551874,0x94a80698,0x50d40065,0x212b031d}},	//   _vozi, стта_, _وزیر, lwch_,
   {{0x4425bf41,0x60c1843d,0x61ef3f42,0xdb0e0091}},	//   zel_, _silm, nacl, _agbó,
   {{0x6299b746,0x60c985a4,0x44313975,0xe3e800c8}},	//   rowo, _quem, _taz_, _পারব,
   {{0x212d8353,0x60c1a795,0x81e180ab,0x6299bf43}},	//   _vseh_, _qilm, _দাও_, sowo,
   {{0x4425bf44,0x2bdf1a87,0x786b07d9,0xb8d0873c}},	//   vel_, _प्या, _güve, _टी_,
   {{0x442585ad,0x0f7c0039,0xd04d00fc,0x826589c4}},	//   wel_, טרול, _kwaɓ, _بهرن,
   {{0x60c1bf45,0x4425bf46,0x61ef0118,0x6609b5da}},	//   _tilm, tel_, dacl, rgek,
   {{0x66099591,0x2a6900e4,0x212b0114,0x752981ed}},	//   sgek, _alab_, dwch_, rwez,
   {{0x2dd5b71e,0x4425bf47,0x2a6900c3,0x7e6d3553}},	//   _джер, rel_, _blab_, khap,
   {{0x4425bf48,0x753d0065,0xd6ab8591,0x9f4783f2}},	//   sel_, _orsz, _صدام_, naní_,
   {{0xa4f7826a,0x26c23f49,0x7e6d1ab3,0x212b0428}},	//   _اکبر_, _riko_, dhap, gwch_,
   {{0x6443807b,0x8c4581a1,0x26c23f4a,0x2a6902f1}},	//   _unni, _феке, _siko_, _elab_,
   {{0x81ea80ab,0x18a301e2,0xa0a33c20,0xe81b8072}},	//   _মাস_, фарм, фард, प्या_,
   {{0x2a6902c4,0x8afc8035,0x00ca1cb2,0xf1bf0118}},	//   _glab_, rzęt, _клик_, meán_,
   {{0x63a3831d,0xf1bf00f7,0xec7a0615,0x9f4783f2}},	// [2c40] _hynn, leán_, апа_, daní_,
   {{0x63a3bf4b,0x67218024,0x0c230198,0x3e6702f1}},	//   _kynn, _oplj, ммун, _võta_,
   {{0x49ca9354,0xeac9801c,0xa5bb026b,0xdb0e0032}},	//   ален_, _mẹo_, _abód, _agbò,
   {{0x7e6d3f4c,0xe81600c2,0x63a3bf4d,0xa3d602f1}},	//   chap, द्रा_, _mynn, _सभक_,
   {{0x2ba6864a,0xb4db0706,0xdfd48a41,0xb5fd81d6}},	//   _ऑर्थ, _cràd, полы, chši,
   {{0x6e360110,0x3a26808e,0x29020df6,0x00000000}},	//   ldyb, seop_, irka_, --,
   {{0xed508019,0xdb0e046d,0x42d60a18,0x03a333d9}},	//   کھا_, _egbò, _фігу, _жиро,
   {{0x6e361503,0x63ae026c,0x6722026c,0xf1bf00f7}},	//   ndyb, _izbn, _ćojl, deán_,
   {{0xceb304de,0xddc2809a,0xd25980eb,0xd00a84ae}},	//   ויה_, _umoż, _ziņo_, _везе_,
   {{0x31e3016f,0x09e30d14,0x0bf38009,0x63a38114}},	//   पर्ध, पर्य, мпью, _bynn,
   {{0x2a690069,0x63a38355,0x61ef3f4e,0x20d0801c}},	//   _plab_, _cynn, tacl, _hài_,
   {{0x61e2bf4f,0xb5fb03c1,0x212b0114,0x63b5816b}},	//   nbol, _vlák, twch_, ýzna,
   {{0xa2ca85b3,0x26ccbf50,0x17e200ab,0x61ef27d3}},	//   _सूर्, _hudo_, _বাড়ি, racl,
   {{0x80dd00c8,0x26cc8168,0x212b0114,0x61ef00e5}},	//   _বিদ্, _kudo_, rwch_, sacl,
   {{0x63a38355,0x61e2bf51,0x8f343c7a,0x29023f52}},	//   _gynn, kbol, мерц, arka_,
   {{0x26cc81b4,0xfb8780d7,0x6458b3d9,0x60dd20e4}},	//   _mudo_, _بدهی, _hovi, ppsm,
   {{0x9f479dc1,0x61e2813c,0x6458bf53,0x7e6d33fe}},	// [2c50] vaní_, dbol, _kovi, rhap,
   {{0x64588390,0x97152ded,0x61ed1357,0x7e6d3f54}},	//   _jovi, _емоц, _heal, shap,
   {{0x6458bf55,0xd4983f56,0x8c2580c8,0x7e6d3f57}},	//   _movi, іру_, বাচন_, phap,
   {{0x20d08142,0x7c288358,0x6458bf58,0x61e28b4e}},	//   _bài_, hedr, _lovi, gbol,
   {{0xdd868307,0x20d08028,0xcfbd00ab,0x9f47826f}},	//   _أو_, _cài_, _অভিন, raní_,
   {{0x20d08028,0x61ed0c9f,0x55ba0039,0x26cca256}},	//   _dài_, _leal, _למרו, _budo_,
   {{0x61e28682,0x26cc8699,0xdb0385b9,0x752d3f59}},	//   bbol, _cudo_, _ozná, lwaz,
   {{0x660d3f5a,0x29023f5b,0x26cc8216,0x69db15c7}},	//   ngak, yrka_, _dudo_, ñuel,
   {{0x7c28bf5c,0xd840026f,0x63a3bf5d,0xb5fb00f7}},	//   fedr, íčky_, _synn, _clái,
   {{0x7c289254,0x26cc88ec,0x60db8d57,0x68e981bc}},	//   gedr, _fudo_, _itum, _iwed,
   {{0x61ed17ca,0x628b8010,0x7c353f5e,0x6458bf5f}},	//   _beal, ongo, _mazr, _dovi,
   {{0x752d3f60,0x213f8988,0xf1bf00f7,0x61ed0ae3}},	//   kwaz, _kruh_, reán_, _ceal,
   {{0x7c28bf61,0xf1bf00f7,0x752d1118,0x20d080ff}},	//   bedr, seán_, jwaz, _xài_,
   {{0x60db822e,0x7d09bf62,0x653a80be,0x7c353f63}},	//   _mtum, mues, _לענד, _nazr,
   {{0x629d2817,0x69c99e3b,0xa7aa1269,0x61ed3f64}},	//   boso, _ogee, сква_, _feal,
   {{0x64470057,0x61ed0083,0x6458817f,0xc6c33832}},	//   _anji, _geal, _zovi, ейск,
   {{0x2bd2a076,0xf1bf00f7,0x60cd00ee,0x7d098168}},	// [2c60] _सलमा, neál_, _guam, nues,
   {{0x7e643f65,0x39403f66,0x69c99a14,0x673e05f3}},	//   skip, _iris_, _agee, _trpj,
   {{0xe8059039,0x6d4b016d,0xf8b30039,0x60dbbf67}},	//   _राजा_, ägar, _רשת_, _atum,
   {{0x39403f68,0x64473f69,0xf53f021e,0x7659809a}},	//   _kris_, _enji, _frå_, _nowy,
   {{0x7c3500b9,0xf53f01a3,0x463b00be,0xb5fb0091}},	//   _fazr, _grå_, _העכע, _aláw,
   {{0xb8f4a3a7,0x26cc85a4,0x61e2ae6c,0x20d0801c}},	//   _सं_, _pudo_, sbol, _vài_,
   {{0x7c28bf6a,0x75229fd4,0xb5fb00f7,0x91e68319}},	//   vedr, _spoz, _slái, _нове,
   {{0x20d08104,0x80dd00c8,0x39400091,0xfaa380e8}},	//   _tài_, _বিস্, _oris_, _засо,
   {{0x6458bf6b,0x2ab20019,0x394001c0,0x68e98114}},	//   _povi, kább_, _nris_, _gwed,
   {{0x26cc80a9,0x7d04244d,0xf044826a,0x6282bf6c}},	//   _tudo_, iris, _تعری, lioo,
   {{0x61ed0665,0x60cd0867,0xe61a8f2f,0x7c288082}},	//   _peal, _suam, _где_, redr,
   {{0x7d043f6d,0xe81f052a,0xaf4980f7,0xcf2580f7}},	//   kris, म्ना_, _بشكل_, _تركي,
   {{0x8c469232,0x7d098693,0xb5fb027f,0xf487881b}},	//   _неде, cues, _kláv, _کانی,
   {{0x629d3f6e,0x7d043f6f,0x61e0007e,0x80e18264}},	//   soso, dris, ımla, _নিম্,
   {{0xda0d823c,0x25afbf70,0x60c502f1,0x628b8428}},	//   _हालत_, _zzgl_, _vihm, yngo,
   {{0x443f07d9,0x752d3f71,0x7d0410b9,0x7c350289}},	//   _şu_, twaz, fris, _sazr,
   {{0xe7cc8076,0x224901ac,0x660d3f72,0xba3b0cd1}},	// [2c70] ाशाप, _inak_, rgak, roïd,
   {{0x628b8114,0x29193f73,0xb4db25dc,0xdfd101a8}},	//   wngo, mtsa_, _aràc, _جيد_,
   {{0xaac70c48,0x7d0412a5,0x290b3f74,0x752d3f75}},	//   ستان, aris, luca_, swaz,
   {{0x7d043f76,0xe3b00013,0x7d180013,0x68e9809c}},	//   bris, ارك_, éasá, _pwed,
   {{0x6e29bf77,0xaca481bc,0x9f47826f,0x29193f78}},	//   veeb, _agọz, daná_, ntsa_,
   {{0x3ea93f79,0xf9940158,0xad9b0032,0x8fa58323}},	//   llat_, ערס_, _adúg, мале,
   {{0xe80e83db,0xb8f48e5b,0x12c780ab,0x7659a9a7}},	//   _सारा_, _सू_, _শব্দ, _powy,
   {{0xd87783f8,0xb4db07e2,0x7d0980f1,0x645cbf7a}},	//   _کارب, _gràc, tues, örin,
   {{0x60db822e,0x63a70168,0x6e2991c9,0x290b3f7b}},	//   _utum, _hyjn, reeb, juca_,
   {{0x22491397,0x7d0980f1,0x2a6dbf7c,0x78700198}},	//   _anak_, rues, _hleb_, _käve,
   {{0x6ee7bf7d,0x2ab20065,0x3ea90587,0x7d0980f1}},	//   _رسال, vább_, klat_, sues,
   {{0x39402280,0x7d099220,0x38a402af,0x7d04007b}},	//   _pris_, pues, hört_, yris,
   {{0x7d0993a0,0x3ea90461,0x66c782d0,0xbbaa0bbc}},	//   ques, dlat_, _fıkr, _कर्क,
   {{0x80dd0a49,0x22493f7e,0x638585c2,0x3e83846d}},	//   _বিশ্, _enak_, _огла, _fètè_,
   {{0x07a30a13,0xb8d50006,0xc79517ae,0xe29f007b}},	//   варн, _छी_, ерты, boð_,
   {{0xe1ff1e1e,0x38a4008b,0xecea246c,0xe05800d7}},	//   lkón_, vöru_, ждал_, _کیست_,
   {{0x32d38028,0x14c80077,0xe80e81ab,0x38a40106}},	// [2c80] _hãy_, سهای_, _साला_, fört_,
   {{0x26cc1313,0x81ea8264,0x9f479ee0,0xa2e6062c}},	//   ídos_, _মাই_, zaná_, дожд,
   {{0x3ea93798,0xb4db009f,0x98a90669,0x3e7a81a9}},	//   blat_, _pràc, _građ_, sūti_,
   {{0x41aa8f80,0xb5fb0a21,0x7d0410b6,0xaca4019d}},	//   овен_, _sláv, pris, _inọr,
   {{0x9f47803e,0x20d40406,0xb5fb3f7f,0x62828074}},	//   vaná_, _jäi_, _cláu, rioo,
   {{0xd6daa64c,0x62828006,0xbddb010c,0xa3c80576}},	//   оти_, sioo, _anèh, _उलट_,
   {{0x44383f80,0xdca31c8b,0x9f47b53d,0x645c3f81}},	//   _iar_, _рари, taná_, _iori,
   {{0x44383f82,0x645c3f83,0xa3c390c5,0x1d3488cc}},	//   _har_, _hori, ्शन_, ения,
   {{0x645c003a,0x4438252d,0x64c895fb,0x9f47bf84}},	//   _kori, _kar_, रदेश, raná_,
   {{0x645c2948,0x628081c0,0x83868071,0x6aa43f85}},	//   _jori, _hmmo, дыме, _akif,
   {{0x645c3f86,0xd37a80e8,0x443810b6,0x9f47bf87}},	//   _mori, ючи_, _mar_, paná_,
   {{0xaacf853f,0x6ab6031d,0x05668012,0x32d38129}},	//   _संरक, _chyf, _овен, _dãy_,
   {{0x3ea93f88,0xa2ca800c,0xaca401bc,0x7c3e8118}},	//   vlat_, _संक्, _anọr, _ópro,
   {{0x645c1c1f,0xb9072cdd,0x44383f89,0xdbf3080a}},	//   _nori, _पऽ_, _nar_, _işçi,
   {{0xc05805e9,0x442ca427,0x25ad1f95,0xd8388503}},	//   фія_, med_, _šel_, _mač_,
   {{0x442cbf8a,0x7c38bf8b,0x3ea93f8c,0x60c8bf8d}},	//   led_, _havr, ulat_, _lidm,
   {{0x67d537cd,0x442c8114,0x443801c6,0x7c3882d0}},	// [2c90] _попу, oed_, _bar_, _kavr,
   {{0x6280bf8e,0xb5fb1931,0x645c3f8f,0x3ea9001b}},	//   _ammo, _alát, _cori, slat_,
   {{0x44383f90,0x645c3f91,0x2a6d81c0,0x7c38bf92}},	//   _dar_, _dori, _pleb_, _mavr,
   {{0x23df08d4,0x442cbf93,0x68ed3f94,0xdd140038}},	//   _प्रद, hed_, _kwad, _súťa,
   {{0x6025a31a,0x645c3f95,0x26de8081,0x6d448110}},	//   едла, _fori, _atto_, _šian,
   {{0x3e71803e,0x442cbf96,0x44383f97,0x7d0d010b}},	//   _máte_, jed_, _gar_, muas,
   {{0x442c804c,0x7d0d3d84,0x8fa2a410,0x6d428cdb}},	//   ded_, luas, лаше, _aroa,
   {{0x4438003a,0xbb480077,0x9f45826f,0x645c0102}},	//   _zar_, _تلفن_, _celá_, _zori,
   {{0x645c026b,0xddc2a7aa,0x44383f98,0x38b60aa2}},	//   _yori, _ploš, _yar_, lære_,
   {{0xe4518013,0x765d3f99,0x6aa40257,0x645c3f9a}},	//   اضة_, _losy, _skif, _xori,
   {{0x7c3883bf,0x68ed38b3,0x6d42bf9b,0x09c80d72}},	//   _davr, _awad, _eroa, रख्य,
   {{0x7d0d0590,0x644ab21a,0xdb1e81d0,0x68ed3f9c}},	//   kuas, _enfi, áván, _bwad,
   {{0x764b8065,0x4423136f,0x6d428087,0x3e6e008b}},	//   _ingy, _obj_, _groa, _nýta_,
   {{0x60c88201,0x2bdf0305,0x442cadc0,0xddc28d2f}},	//   _xidm, _प्ला, ced_, _uloš,
   {{0x7c2380ee,0x7d1bbf9d,0x765d010c,0x68ed3f9e}},	//   _ibnr, ltus, _bosy, _ewad,
   {{0x7c3882a5,0x998d012b,0x7ea58228,0x44383f9f}},	//   _zavr, žeš_, cópt, _sar_,
   {{0x44383fa0,0xeb1f80cf,0x62863fa1,0x645c3fa2}},	// [2ca0] _par_, _बहुत_, miko, _pori,
   {{0x62860ef1,0x69dbbfa3,0x7d1b8009,0x645c01b4}},	//   liko, _afue, itus, _qori,
   {{0x44383fa4,0x020692bc,0xb5fb3fa5,0x645c3fa6}},	//   _var_, езен, _clás, _vori,
   {{0xe29799b8,0xfce604a9,0x62863fa7,0x442cbfa8}},	//   нах_, _помо, niko, zed_,
   {{0x44381100,0xa96796d9,0x216790ca,0x645c15a4}},	//   _tar_, ница_, ници_, _tori,
   {{0x9f4301ac,0x62863fa9,0xdfcf80f7,0x29068102}},	//   vajú_, hiko, ميه_, rroa_,
   {{0x62863faa,0x442c8051,0x6e398420,0x7bce3fab}},	//   kiko, ved_, _bawb, _igbu,
   {{0x7c38803a,0xb65b0158,0x6d42bfac,0x442cbfad}},	//   _savr, ִדיש, _proa, wed_,
   {{0x442c804c,0x62863fae,0xb5fb3faf,0x2dd780f7}},	//   ted_, diko, _klár, ربية_,
   {{0x6aa280c9,0x99808110,0x9f4300e1,0x764bbfb0}},	//   loof, žių_, rajú_, _engy,
   {{0x442cbfb1,0x62863fb2,0x141b00be,0x68ed337a}},	//   red_, fiko, הויב, _swad,
   {{0x442c8434,0x79a70c9d,0x62863fb3,0x2bd28fb2}},	//   sed_, ерге, giko, _सलवा,
   {{0x442c8039,0x3ea6876d,0x7bce2d10,0x7bdc03ed}},	//   ped_, _ikot_, _ogbu, _ofru,
   {{0x765d3a7f,0xd25980eb,0x7413803d,0x6aa29de6}},	//   _sosy, _viņi_, _موها, hoof,
   {{0x02a71afa,0x533495b5,0x62861b19,0xc90d801b}},	//   _прим, _рейт, biko, _सम्म_,
   {{0x68ed3fb4,0xb5fb04be,0x7bce3fb5,0x7d0d12af}},	//   _twad, _alár, _agbu, tuas,
   {{0x6e2d2305,0xe59810ac,0xbbeb01a8,0x9f4a02df}},	// [2cb0] reab, екті_, كرام_, rabá_,
   {{0xb5fb0307,0xb4ab000f,0x7bdabfb6,0x6e2d3fb7}},	//   _clár, खते_, nctu, seab,
   {{0x68fb8024,0x229c816b,0xf99009a7,0x200101b4}},	//   _svud, líky_, _نبی_, _idhi_,
   {{0x7d0d010b,0x7bce0135,0x636b8061,0x212900ff}},	//   puas, _egbu, lönö, _kpah_,
   {{0x229c83c1,0x865a025f,0x7d0d0037,0x81c98264}},	//   níky_, _חדרי, quas, লুন_,
   {{0x62863fb8,0x38b62419,0x1ae68264,0x7afaa7d1}},	//   ziko, pære_, _কিনে_, kstt,
   {{0x201a8722,0x62860cb7,0xd00e81a8,0xdb1506c4}},	//   òpia_, yiko, زلي_, _egzò,
   {{0x62863fb9,0x7c238359,0x7d1ba2c2,0x21290d8b}},	//   xiko, _sbnr, ttus, _opah_,
   {{0xee36827e,0x44ef2358,0x26d30ba3,0x7e69bfba}},	//   тны_, nż_, _luxo_, rkep,
   {{0x44658895,0x2bb80424,0x58d48abe,0x290fbfbb}},	//   твов, _अरमा, _софт, muga_,
   {{0xe29a22a7,0x62863fbc,0x7d1ba47f,0xfbd20051}},	//   дан_, tiko, stus, יתי_,
   {{0x7ea5bfbd,0x225f86c0,0x20013fbe,0xa3b91a3b}},	//   róps, _jouk_, _adhi_, _चरन_,
   {{0x62863fbf,0x3eadbfc0,0xa56480f7,0x290fb044}},	//   riko, mlet_, _مدون, nuga_,
   {{0x3ea0931b,0x26d30118,0x291d804f,0x3ebfbfc1}},	//   čite_, _buxo_, itwa_, lmut_,
   {{0x44ef0063,0x26d301df,0x8fa600b3,0x26cb3fc2}},	//   eż_, _cuxo_, таве, _bico_,
   {{0x7bdc3fc3,0x7aed809a,0x26cb0140,0x291d86c0}},	//   _sfru, _łatw, _cico_, ktwa_,
   {{0xc5f28451,0x7d09bfc4,0x26cb1137,0x3eadbfc5}},	// [2cc0] ידן_, nres, _dico_, ilet_,
   {{0xb4db3fc6,0x3eadbfc7,0x69c2001b,0x224d8b09}},	//   _tràn, hlet_, रेणी, _anek_,
   {{0x3eadbfc8,0x26cb3074,0x7d0981ec,0x78a3ba92}},	//   klet_, _fico_, hres, donv,
   {{0x290f8365,0x6d448110,0x5186a749,0xe8df81bc}},	//   fuga_, _šiam, кула, _erọn_,
   {{0xc05a80e8,0x6aa2bfc9,0x290fbfca,0x78a3bfcb}},	//   дій_, roof, guga_, fonv,
   {{0x7afc24a0,0xa3c392ee,0x7d09bfcc,0x80e180ab}},	//   _tvrt, ्शा_, dres, _নিশ্,
   {{0x7c3c0af9,0x644e3fcd,0xb4c0009a,0x3eadbfce}},	//   _iarr, _inbi, ुदी_, flet_,
   {{0x80e18a49,0x7d09bfcf,0x290f81d3,0x6d460267}},	//   _নির্, fres, buga_, _krka,
   {{0x7c3c3fd0,0x7d099b7d,0x291d8035,0x08c6a2f0}},	//   _karr, gres, ctwa_, _абан,
   {{0x7c3c00ad,0x62843fd1,0x225fbfd2,0x6d4601a1}},	//   _jarr, _amio, _zouk_, _mrka,
   {{0x7c3c33fe,0xd7a99a3b,0xd25102e3,0x3ead8e1c}},	//   _marr, _चुपच, مند_, blet_,
   {{0x7c3c011e,0x7d09a09c,0x6d463fd3,0x9e669d85}},	//   _larr, bres, _orka, _швед,
   {{0x9553803d,0xa2d4064a,0x316d0333,0x518401ae}},	//   _نخوا, _बूस्, áez_, аура,
   {{0x58870048,0x26d301df,0x8cd60105,0x8c0800ab}},	//   тыма, _puxo_, _बढ़ो, র্তন_,
   {{0x54338c2a,0x26cb0207,0x443c8282,0xd25980eb}},	//   _ضرور, _pico_, _iav_, _ziņu_,
   {{0x443ebfd4,0x443cbdd7,0x3cfe000f,0x644e3fd5}},	//   ldt_, _hav_, _लिखे_, _anbi,
   {{0x80dd00c8,0x443c81c5,0x27f8209b,0x2129010b}},	// [2cd0] _বিক্, _kav_, barn_, _upah_,
   {{0x443ebfd6,0x7c3c360a,0x290f8578,0x443cbfd7}},	//   ndt_, _carr, vuga_, _jav_,
   {{0x7c3c3fd8,0x443c822c,0x3e71bfd9,0x225f807a}},	//   _darr, _mav_, _láta_, _pouk_,
   {{0x443cbfda,0x7c3c0ad0,0x6602bfdb,0x99848110}},	//   _lav_, _earr, _ndok, _namų_,
   {{0x7c3c3fdc,0x3eadbfdd,0xe8df80ff,0x443cbfde}},	//   _farr, vlet_, _trọn_, _oav_,
   {{0x443c8341,0x7c3c159d,0x290fbfdf,0x443e80f3}},	//   _nav_, _garr, ruga_, jdt_,
   {{0x28da0996,0x6d4600e1,0x290fbfe0,0x6e3d3fe1}},	//   _यूनि, _zrka, suga_, _kasb,
   {{0x443e80f3,0x3ebf8980,0x7e6d3fe2,0x224d8573}},	//   edt_, umut_, nkap, _unek_,
   {{0x3ebf9e03,0x6e3d3fe3,0x9a848b5b,0x3ead8eb9}},	//   rmut_, _masb, _турл, rlet_,
   {{0x443c8069,0x3eadbfe4,0x3e71bfe5,0x649d809f}},	//   _cav_, slet_, _dáta_, nèix,
   {{0x443c81c5,0x46158fc5,0x7e6d2450,0x27f83f88}},	//   _dav_, _موار, kkap, varn_,
   {{0x7d09bf55,0x3f7a8158,0x6e3d3fe6,0xe0c900be}},	//   pres, _אָדע, _nasb, _זײ_,
   {{0x32368158,0x81ac00ab,0x321e0035,0x443e8118}},	//   נטשן_, কেন_, ęty_, bdt_,
   {{0x40953fe7,0x443c93c2,0x81ea80ab,0xe81f001b}},	//   арст, _gav_, _মাছ_, म्ला_,
   {{0xd62a2481,0xdc9a807c,0x7c3c0041,0x61f9893d}},	//   нове_, _איסל, _rarr, kawl,
   {{0x7e6d26bc,0x7c3c3fe8,0x442780b9,0x6aa98088}},	//   gkap, _sarr, _hbn_, _nkef,
   {{0x26c03fe9,0x0c260dc0,0x443c81c5,0xa5072f4b}},	// [2ce0] rmio_, лман, _yav_, лета_,
   {{0x443c90af,0xf54f81bc,0x7c3c27cc,0x786f83ba}},	//   _xav_, _bụzi_, _qarr, _søvn,
   {{0xa3b903eb,0x7c3c3fea,0x9f4c8388,0x6e3d01a1}},	//   _चरण_, _varr, _pedí_, _fasb,
   {{0x2ca5bfeb,0x6d460904,0x998d809a,0xe3c580ab}},	//   hold_, _trka, _oceń_, _এভাব,
   {{0x7c3c3fec,0x64430073,0x442780cd,0x6abb81b4}},	//   _tarr, ônic, _obn_, _dhuf,
   {{0x61f6395c,0x4427bb15,0x3e7181a8,0x60d602c4}},	//   _leyl, _nbn_, _ráta_, _muym,
   {{0x6d443fed,0x9f580168,0x3ea4bfee,0x4acf8c28}},	//   lvia, darë_, tomt_, _संगव,
   {{0xa3b90076,0x7ae302b7,0x443cbfef,0x9b9300f7}},	//   _चरत_, ínte, _sav_, _الفت,
   {{0x5c74a657,0x443cbff0,0x6d44009f,0x6143bff1}},	//   илит, _pav_, nvia, _лета,
   {{0xd5c085e8,0x290b00d2,0x3ea48aa2,0x443c8282}},	//   शेषज, vrca_, somt_, _qav_,
   {{0x443ebff2,0x5fa40076,0x68e40110,0x7e6d076d}},	//   rdt_, _खुलल, _atid, ykap,
   {{0x201a0197,0x673a911b,0x66028f90,0xd7f88129}},	//   _acpi_, _istj, _udok, _xoăn_,
   {{0x443cbff3,0x6d4401ac,0x2ca5bff4,0x6c548073}},	//   _tav_, jvia, bold_, _вклу,
   {{0x443cbff5,0x6d3b8039,0x9f4780e1,0xb8fd3ff6}},	//   _uav_, _נתונ, vanú_, _तं_,
   {{0xb4c08e00,0xb4c286a7,0x68e406c0,0x99990019}},	//   ंगी_, ्दी_, _etid, reső_,
   {{0x58d50021,0xe80e8996,0x4ea70048,0x228b026b}},	//   _коит, _साझा_, урга, _dòkè_,
   {{0xb4db0722,0xb8049199,0x260a03db,0x6e3d342b}},	// [2cf0] _tràm, रणाम_, िलजी_, _vasb,
   {{0x7870016d,0x7e6d3ff7,0x673a82f1,0x6e3d1412}},	//   _jävl, skap, _ostj, _wasb,
   {{0x6e3d00ee,0xe7eb016f,0x649d809f,0xd4983ff8}},	//   _tasb, _ज्या_, rèix, урт_,
   {{0x39493ff9,0x6e3d008e,0xb4c2bffa,0x61f6011c}},	//   _kras_, _uasb, ्दु_, _xeyl,
   {{0x61f9ba65,0x673a8609,0xc5fa01c6,0xa3ab801b}},	//   rawl, _astj, _בפרט, _कुन_,
   {{0x216684ae,0x1bd40cb1,0x7d0d33a0,0xa3d401cf}},	//   риши_, _горя, mras, _горч,
   {{0x6fcc80d4,0x21de819d,0x2ca593c2,0x9f5803ed}},	//   ाशगं, _ịhe_, vold_, varë_,
   {{0x39492e91,0x0e658c9b,0x7e6285d8,0x2ca5bffb}},	//   _oras_, ркин, _coop, wold_,
   {{0x7ae48025,0xb4c2a701,0x7d0d2993,0x9f5800f1}},	//   _čita, ्दू_, nras, tarë_,
   {{0x3ea080d2,0x4b259957,0xac859bcc,0x4c85a481}},	//   čita_, амов, ргол, рлов,
   {{0x68e40052,0xeb999017,0x39493ffc,0x7d0d3ffd}},	//   _stid, тин_, _aras_, hras,
   {{0x80dd0a49,0xfaa62bd9,0x628b8428,0x39493ffe}},	//   _বিজ্, рамо, nigo, _bras_,
   {{0xe29719dd,0x9f583fff,0x201a03a8,0x61e90118}},	//   рая_, maré_, _pcpi_, ñela,
   {{0x7870016d,0xd4668b30,0x394930b8,0x628bc000}},	//   _gävl, _више_, _dras_, higo,
   {{0xb8fd1551,0xe7e50b9f,0x39492620,0x628b8545}},	//   _तू_, कड़ा_, _eras_, kigo,
   {{0x7e628609,0xddc9179d,0x63ae06e1,0x26cf84b9}},	//   _xoop, _šošt, _rybn, _jigo_,
   {{0x7d0d4001,0x291f81c0,0x39490f7c,0xac860cf9}},	// [2d00] gras, _nqua_, _gras_, агал,
   {{0xd12f00d5,0x26cfc002,0x0eb8016f,0x9f580144}},	//   _کمی_, _ligo_, _आठवड, haré_,
   {{0x2bab8592,0x2abc8e1b,0x7d0d1581,0xdddd0019}},	//   _घुमा, híbe_, aras, _első,
   {{0x9f4c826f,0x628baa96,0x6441808e,0x6da6004a}},	//   _nedá_, gigo, hdli, _вима,
   {{0x44e98510,0x7d0d1a2e,0x22402eac,0x290083a7}},	//   _nº_, cras, _maik_, éia_,
   {{0x20184003,0x26cf82f7,0x37069cf8,0x403495b7}},	//   ngri_, _aigo_, ачив, секс,
   {{0x628bc004,0x26cfc005,0x291f80e5,0x9f580580}},	//   bigo, _bigo_, _equa_, faré_,
   {{0xf2a38e8e,0x22400483,0x644182af,0x26cf882c}},	//   _дисп, _naik_, edli, _cigo_,
   {{0x26cfa6d5,0xd5b78987,0x61ed86a5,0xf8bf0866}},	//   _digo_, ись_, ñale, ltée_,
   {{0xb4c08063,0x8c668012,0xceea80e8,0xb4c28128}},	//   ंगे_, ртид, _адже_, ्दे_,
   {{0x22401a67,0x3e75016d,0x39468110,0x225209ca}},	//   _baik_, _låta_, lvos_, _bnyk_,
   {{0xc5f080c8,0xbd878416,0x394900d7,0x1bf283a4}},	//   _টাকা_, انین_, _pras_, _आजकल_,
   {{0x787000f2,0xcd36826a,0x224000b9,0x3946802a}},	//   _tävl, _خراب, _daik_, nvos_,
   {{0x83f89c79,0x533483c7,0x27fc83ba,0xe9df4006}},	//   _секс_, _гект, navn_, scú_,
   {{0x1cbb8158,0x44333075,0x06fd81d0,0x22404007}},	//   _שמוע, vex_, žívá_, _faik_,
   {{0x3949040e,0x27fc8edd,0xaa2d0198,0x2c190072}},	//   _tras_, havn_, ämää_, _पाहू_,
   {{0xddc40289,0x61ef00b9,0xdb1c0035,0x6d4002d4}},	// [2d10] tkiš, mbcl, _ogró, _šmar,
   {{0xe1ff0035,0xc3cb01a8,0x61fd208e,0xeaca0129}},	//   tków_, نظام_, lasl, _hẹp_,
   {{0x44334008,0x628b8e67,0x389c098a,0x1da72730}},	//   rex_, tigo, _ביזנ, _कुरत,
   {{0x7d0d4009,0xde590221,0xa3e68eed,0x7d028654}},	//   pras, _самі_, युत_, _ovos,
   {{0x394982ba,0x3ce6822c,0x26cf87e4,0x0dcb00a9}},	//   ías_, _ntov_, _rigo_, _јуни_,
   {{0x26cfc00a,0x628bc00b,0xb4c2801b,0xb4c091be}},	//   _sigo_, sigo, ्दो_, ंगो_,
   {{0xb4c283bb,0x61fd011e,0x261b816f,0x9f58400c}},	//   ्दै_, kasl, _यादी_, taré_,
   {{0xee39998c,0x201809d1,0x2f9801c6,0xb4db0706}},	//   уни_, zgri_, יכון_, _arài,
   {{0x26cf87f4,0x656d400d,0x88078c2b,0x6289c00e}},	//   _vigo_, nyah, _نظام, _imeo,
   {{0x7d02811f,0x6aad400f,0x3e7181ac,0x101781f9}},	//   _dvos, _akaf, _táto_, _خبرد,
   {{0x6441c010,0x69cb9c7b,0xa25b0187,0x9f584011}},	//   rdli, _तृती, rmôn, paré_,
   {{0xc869093f,0x2721ad11,0x6f154012,0x625a33e4}},	//   _אן_, món_, duzc, урор_,
   {{0x272188a4,0xa5098b9c,0x2c6980e1,0xeaca0129}},	//   lón_, _села_, _súdu_, _dẹp_,
   {{0x645cc013,0xb4db051e,0x656d0df6,0x37e301a1}},	//   örit, _grài, dyah, зорг,
   {{0x2721862f,0x628981e8,0x224000ee,0xb21b006a}},	//   nón_, _omeo, _taik_, dhæf,
   {{0x442a4014,0x61fd0279,0xaad006b7,0x27218118}},	//   _sbb_, casl, _सूचक, ión_,
   {{0x442a0886,0x61e42c9a,0xed574015,0x2721c016}},	// [2d20] _pbb_, _ifil, бот_, hón_,
   {{0x98a90110,0x6289aef4,0xa3ab8853,0xe09e8135}},	//   _ypač_, _ameo, कअप_, kọọ_,
   {{0x29024017,0x2721c018,0xf8bf0036,0x656d2676}},	//   lska_, jón_, utée_, ayah,
   {{0x27218c58,0x786b0085,0xd9fa03eb,0xf1fa8124}},	//   dón_, _qüvv, ्णित_, اعات_,
   {{0x19588fe6,0x186a8bc7,0xceb40085,0x656d00b4}},	//   ралы_, лади_, mlə_, cyah,
   {{0xfce34019,0x2721bfe5,0x76440085,0x29020079}},	//   _хоро, fón_, ldiy, iska_,
   {{0x6d4bc01a,0x3946c01b,0x272182ba,0x4444401c}},	//   _arga, svos_, gón_, md_,
   {{0x22968013,0x3ea0803b,0x7644401d,0x329681a8}},	//   _الرس, čito_, ndiy, _الرأ,
   {{0x75243724,0x2d80401e,0x444419c2,0x26da401f}},	//   ntiz, nzie_, od_, _lupo_,
   {{0xd6d28872,0xb865af0a,0x290202a5,0x2721c020}},	//   _فقط_, _والو, dska_, bón_,
   {{0x6d4bc021,0x27218d76,0xceb40085,0xae209a3b}},	//   _erga, cón_, klə_, _यापन_,
   {{0x6d4481e2,0x44444022,0x9c8701d0,0x6d898019}},	//   _šiau, hd_, _kočá, امیہ_,
   {{0x0c738077,0x61e4002a,0xd0418085,0x76444023}},	//   زدید, _dfil, _ailə, ddiy,
   {{0x2d800d38,0x69d60117,0xd0418086,0x44440613}},	//   dzie_, _egye, _bilə, jd_,
   {{0x44442065,0x1bfb8051,0x93fb810f,0xaae68bbe}},	//   dd_, _גלוב, _גלוי, _استو,
   {{0x44444024,0x5f94138c,0x656d056a,0xa19514ed}},	//   ed_, чист, tyah, _майч,
   {{0x2721840e,0x9f47826f,0x44440a0f,0x2d58245b}},	// [2d30] zón_, daný_, fd_, бить_,
   {{0x44444025,0x80dc809a,0x656d0079,0xd37b0f13}},	//   gd_, _पढ़े, ryah, лче_,
   {{0x272181df,0x45d51775,0xb5fd807a,0x57fa01c6}},	//   xón_, _монс, ljše, _דלתו,
   {{0x44444026,0x7ae480ce,0x656d16fb,0x61e281f6}},	//   ad_, _čitl, pyah, gcol,
   {{0xae1a0158,0xd5a689a7,0x444402f7,0xb5fd82d4}},	//   _דורכ, _آف_, bd_, njše,
   {{0x2721988b,0xd7fb8037,0x26da004f,0x628f0493}},	//   tón_, ууд_, _yupo_, hico,
   {{0x64554027,0x320901b4,0x628f34d3,0x7e7b8234}},	//   _inzi, _oday_, kico, thup,
   {{0x272188a9,0x29020079,0x644502a3,0x628f0503}},	//   rón_, yska_, ldhi, jico,
   {{0x6499840d,0x2721988b,0xb5fb4028,0xec79964f}},	//   итор_, són_, _bláz, ипи_,
   {{0x64454029,0x27218511,0x61fbc02a,0x61e4063f}},	//   ndhi, pón_, _heul, _sfil,
   {{0xe82009a3,0x628f1313,0x76440201,0x68f60355}},	//   _बाबा_, fico, ydiy, _swyd,
   {{0x2902012b,0xd5759a8f,0x60db9e08,0x628f402b}},	//   tska_, _муль, _kuum, gico,
   {{0x444402a3,0x787004a2,0xddc2c02c,0x26da0216}},	//   yd_, _hävi, _zlož, _supo_,
   {{0x60dbc02d,0x26da04be,0x38b6006a,0x78700198}},	//   _muum, _pupo_, mærk_, _kävi,
   {{0x61e29c33,0xceb40085,0x6d49c02e,0x4444004a}},	//   ycol, tlə_, lvea, vd_,
   {{0x6455402f,0x75244030,0xee3a09a5,0x61fbc031}},	//   _anzi, ttiz, јна_, _neul,
   {{0x6443c032,0x9f478a56,0xa3c383b7,0x76440201}},	// [2d40] _kani, vaný_, ्शक_, rdiy,
   {{0x3e78c033,0x6299867f,0xa3bd8424,0x44443ce8}},	//   _méta_, enwo, _आरा_, ud_,
   {{0x673e030b,0x75244034,0x61fb851e,0x213f8c68}},	//   _uspj, stiz, _beul, _asuh_,
   {{0x44444035,0x75241c8c,0x64554036,0x6443c037}},	//   sd_, ptiz, _enzi, _lani,
   {{0x81ac00c8,0x61e2c038,0x394dc039,0x61ed85a4}},	//   কের_, rcol, _cres_, ñala,
   {{0x644391df,0x61e2c03a,0xb902aa85,0xd90d803d}},	//   _nani, scol, _नं_, ایل_,
   {{0x394d9726,0x25e10076,0xe3a7819f,0xdfcf80f7}},	//   _eres_, _कलमी_, _آر_, نيه_,
   {{0xddc29807,0x628f403b,0x61fbc03c,0x39400f29}},	//   _vlož, xico, _geul, _osis_,
   {{0x7d04403d,0x64438af5,0x261b8054,0xd90d8fd3}},	//   nsis, _bani, _यारी_, _مین_,
   {{0x6443c03e,0x7d04403f,0x2246c040,0xe46a891c}},	//   _cani, isis, ldok_, ршил_,
   {{0xddc287df,0x628f0888,0x39400084,0x9f5c84e8}},	//   _ulož, tico, _asis_, kavé_,
   {{0x7d044041,0xd3778110,0x0dca8e17,0xdb214042}},	//   ksis, ючы_, _кули_, étét,
   {{0x628f4043,0x21268867,0x66008d92,0x394d1e09}},	//   rico, ntoh_, mamk, íes_,
   {{0x628f25a7,0x6443c044,0x66008079,0xfbcf82e3}},	//   sico, _gani, lamk, عتی_,
   {{0x368b2748,0x628f1820,0x81ac00ab,0x44e0c045}},	//   асан_, pico, কেল_, _hò_,
   {{0x44e0c046,0xcb138bea,0x7c2e4047,0x66008010}},	//   _kò_, _חלק_, _abbr, namk,
   {{0xd90489d7,0x7d0402b8,0x95cb0323,0x628d0b80}},	// [2d50] _جی_, gsis, рува_, _imao,
   {{0x44e0c048,0x61fb82be,0x60dba1e8,0x660095e8}},	//   _mò_, _seul, _ruum, hamk,
   {{0x44e0c048,0x68e993e1,0x3e7180f7,0x64454049}},	//   _lò_, _sted, _fáth_, rdhi,
   {{0x9f45803e,0x660089ca,0x7c2e0ab3,0xb4db051e}},	//   _celý_, jamk, _ebbr, _bràt,
   {{0x2a69404a,0x61fba5d2,0x44e083ec,0x6600c04b}},	//   _moab_, _veul, _nò_, damk,
   {{0xbca500f7,0x68e980e1,0x38b6006a,0x3e7c01d0}},	//   _رمزي, _vted, værk_, _víte_,
   {{0xf7718bbe,0x644382a5,0x2cac831d,0x61fbc04c}},	//   عات_, _rani, dodd_, _teul,
   {{0x394da84c,0x44e0c04d,0xe1ff8125,0x2919404e}},	//   _tres_, _bò_, _þó_, kusa_,
   {{0x6443c04f,0x44e0c050,0x7982809a,0x2cac831d}},	//   _pani, _cò_, czow, fodd_,
   {{0x44e090ab,0x629d087a,0x628d0133,0xc48283c7}},	//   _dò_, éron, _amao, ельк,
   {{0xf1a90159,0x3e718324,0x22920110,0xa3ab9513}},	//   _עס_, _láti_, eška_, _कुश_,
   {{0x644395bd,0xe29a108d,0x44e0c051,0x394002f7}},	//   _wani, сам_, _fò_, _psis_,
   {{0x44e09b4c,0x2eaa8117,0x6443c052,0xbbb8000d}},	//   _gò_, _اپنی_, _tani, _अर्क,
   {{0xf09f3c3f,0x26c20168,0xb87b00e1,0x15429092}},	//   dràs_, _shko_, dpís, _чешм,
   {{0x1fb523d7,0x38ca0019,0xeb96911c,0x9f5c936f}},	//   дстр, لاڑی_, _ниш_, tavé_,
   {{0x3940146a,0x29194053,0x3e6e007b,0x7d044054}},	//   _tsis_, busa_, _nýtt_, tsis,
   {{0x29193340,0x9f5c816b,0xed574055,0x44e080e5}},	// [2d60] cusa_, ravé_, пот_, _xò_,
   {{0x7d044056,0x3d13a743,0xf5070e49,0x99dd80e1}},	//   rsis, _दिने_, янул_, _raňa,
   {{0x9f45c057,0x2baf06a7,0xb4db026b,0x7ae48140}},	//   _meló_, _जुदा, _bràs, _čitk,
   {{0x81ac00ab,0xfaa385a8,0xf8bf4058,0x3202016b}},	//   কেঃ_, нахо, ntén_, naky_,
   {{0x2fda00b9,0x6d4f00c3,0x9f58023e,0xb4db01e4}},	//   _kgpg_, _grca, larà_, _dràs,
   {{0x44e08324,0x38b6007b,0x79828035,0x55bb01c6}},	//   _rò_, færi_, rzow, _למכו,
   {{0x44e0c059,0xa3ab80a5,0x9f580722,0x76462f76}},	//   _sò_, _कुल_, narà_, _kaky,
   {{0x44e0c05a,0x443a405b,0x3202016b,0x7e6402f7}},	//   _pò_, lep_, jaky_, njip,
   {{0x2919036a,0xa3c9800c,0x7646405c,0x1dbe0743}},	//   xusa_, लेस_, _maky, ्धित,
   {{0x628d0ad0,0x443a2190,0xa3e6864a,0x2292007a}},	//   _smao, nep_, युं_, vška_,
   {{0x59a51055,0xd25102e3,0x44e0877f,0x200c8114}},	//   _गुजर, نند_, _wò_, _iddi_,
   {{0x44e090ab,0x443a405d,0x9f580722,0x76460c2e}},	//   _tò_, hep_, darà_, _naky,
   {{0x443a37c0,0x442ec05e,0xc05b00e8,0x41c70035}},	//   kep_, _tbf_, бів_, रेंस,
   {{0x2919405f,0x443a02ce,0xdd3b8039,0x764600e4}},	//   rusa_, jep_, _לעדכ, _aaky,
   {{0xb5fd84c4,0x64588ca9,0x3ae18028,0x6d4f00d2}},	//   ljša, _invi, _góp_, _srca,
   {{0xfbb78051,0x81ac00ab,0x29192fdb,0x26de8f8e}},	//   _מפות_, কেই_, pusa_, _muto_,
   {{0x2d580364,0x26dec060,0xb5fd807a,0x76463a20}},	// [2d70] пить_, _luto_, njša, _daky,
   {{0x443a003d,0x6448c061,0x9f580722,0xf09f023e}},	//   gep_, nddi, barà_, rràs_,
   {{0x20034062,0x9f580722,0x64488114,0x61ed8333}},	//   maji_, carà_, iddi, ñalo,
   {{0x2ea8035a,0x6d4f02a5,0x63b5026f,0x7c3ac063}},	//   ककृत, _trca, _vyzn, hetr,
   {{0xa06994bc,0x9f581984,0x7c3a81a3,0x6d4f0162}},	//   жала_, mará_, ketr, _urca,
   {{0x26dec064,0x9f58018a,0x443a4065,0x20034066}},	//   _buto_, lará_, cep_, naji_,
   {{0x60df036e,0x6d42802a,0xa6c98572,0x442300ee}},	//   _luqm, _asoa, олка_, _icj_,
   {{0x9f581f5c,0x6447054e,0x20034067,0x442c81ed}},	//   nará_, _haji, haji_, efd_,
   {{0x64471600,0x6d4d18c7,0x20034068,0x61e9846d}},	//   _kaji, nvaa, kaji_, _ifel,
   {{0x7c3ab66b,0x20034069,0x6447406a,0xd90d8019}},	//   getr, jaji_, _jaji, _میچ_,
   {{0x6447406b,0x29090364,0xe8171c3b,0x68ed406c}},	//   _maji, _avaa_, _ताजा_, _atad,
   {{0x6458c06d,0x6447406e,0xdd8e826a,0x9f58406f}},	//   _envi, _laji, اوی_, jará_,
   {{0xda1f1499,0x76460455,0xe8f70554,0x9f582a63}},	//   _भारत_, _raky, мля_, dará_,
   {{0x64470c9e,0xf8bf02b7,0x9f580722,0x20034070}},	//   _naji, stén_, tarà_, gaji_,
   {{0x4aad8076,0x68ed4071,0xa3c9858c,0x7529b905}},	//   टकाव, _etad, लेश_, ltez,
   {{0x9f580a3e,0x44230176,0x7649c072,0xe8204073}},	//   gará_, _acj_, ndey, _बावा_,
   {{0x443a37c0,0x20034074,0x7529b349,0xdb0e001b}},	// [2d80] tep_, baji_, ntez, _vybí,
   {{0x69dbc075,0x7e7d0362,0xfbd2030f,0x9f58023e}},	//   _ague, _elsp, نتا_, parà_,
   {{0x443a4076,0x76464077,0xaec60ff0,0x9f581984}},	//   rep_, _taky, _обол, bará_,
   {{0x9f580acf,0x443a292a,0xe297a434,0x99dd826f}},	//   cará_, sep_, мах_, _daňo,
   {{0x6448a065,0xd1308416,0x66043842,0x7649c078}},	//   yddi, امت_, maik, ddey,
   {{0x66044079,0x2906862f,0xd6ea8ae7,0x64471cc5}},	//   laik, rsoa_, офил_, _gaji,
   {{0x29068073,0x7bdc407a,0xdfd081a8,0x7c3ac07b}},	//   ssoa_, _igru, ديث_, vetr,
   {{0x2003022e,0x660416d5,0x667b00be,0xc9568364}},	//   zaji_, naik, ַװיג, _отзы,
   {{0x9f5e80f1,0x6447407c,0x6f1c3aaa,0x2d848289}},	//   _ketë_, _yaji, hurc, uzme_,
   {{0x9f5e820f,0x9f58407d,0x3e78800d,0x26de801b}},	//   _jetë_, zará_, _této_, _tuto_,
   {{0xd62a9289,0x66042bc6,0x6448c07e,0xa3c98072}},	//   _може_, kaik, rddi, लेल_,
   {{0x6f1c02af,0x7d1bc07f,0x6282aeee,0x2003004f}},	//   durc, buus, nhoo, waji_,
   {{0x941e023c,0x7c3ac080,0x2003022e,0x9f582a63}},	//   _पांच_, petr, taji_, vará_,
   {{0xddcd10d3,0xc05801b5,0x656f81ec,0x7bdc003d}},	//   jkaš, міс_, äche, _ngru,
   {{0x9f581313,0x64474081,0x26c6c082,0xe8202a85}},	//   tará_, _raji, _khoo_, _बारा_,
   {{0x4ea418a0,0x7bdc2e88,0x64471eb3,0x66044083}},	//   вруа, _agru, _saji, gaik,
   {{0x9f581fd1,0xdd9401bb,0xa5bb0118,0x64470168}},	// [2d90] rará_, ваты, _ecón, _paji,
   {{0x31560051,0xf5488135,0x6d4d3768,0x9f582a63}},	//   _ניתן_, _mụ_, rvaa, sará_,
   {{0x66040867,0x9f5826d5,0xf8bf0073,0xa5bb00f7}},	//   baik, pará_, ntém_, _gcón,
   {{0xb4ca84e5,0xfd5e80ff,0x387e8037,0x6d4d090d}},	//   लगु_, _quyể, _altr_, pvaa,
   {{0x224901d8,0xc6160051,0x50b581bb,0x801807d2}},	//   _maak_, _אחרי_, нску, _عزیز_,
   {{0x26d94084,0x7d1b862c,0x2b430980,0x9f5e826b}},	//   _hiso_, vuus, _tsjc_, _ketè_,
   {{0xfd5e8028,0x7afc0114,0x38b603ba,0x9f5c84e8}},	//   _tuyể, _gwrt, mært_, baví_,
   {{0x26c6c085,0xf548b5b0,0x06098d5f,0x7d1b82ec}},	//   _choo_, _bụ_, чник_, tuus,
   {{0xf5488028,0xdc3a8201,0x2a7f8420,0x0c95add0}},	//   _cụ_, _açıq, _ilub_, ешня,
   {{0x7529c086,0x2a7f81e9,0x6ac800d4,0x291dc087}},	//   rtez, _hlub_, रग्र, muwa_,
   {{0x44211523,0x7d1b9572,0xa3c98740,0xe8d68039}},	//   igh_, suus, लें_, _נוער_,
   {{0xbbdc000f,0x26d90353,0x395201b0,0x25a0811a}},	//   _बल्क, _niso_, _prys_, _žile_,
   {{0xf548aae3,0xaca381bc,0x66040d15,0xb5fd81a1}},	//   _gụ_, _azụk, vaik, ljšo,
   {{0x660401bc,0xd11c1344,0x2a6dc088,0xf1b9816b}},	//   waik, भूषण_, _loeb_, _myš_,
   {{0xc7b2893f,0x6ab630bc,0x7d098bc5,0x2baf00a5}},	//   ָבן_, _псих, lses, _जुला,
   {{0x291da0d4,0x9f5c1c86,0x68339010,0x7bc38024}},	//   kuwa_, _því_, lıdı, _iznu,
   {{0x26d94089,0x6604408a,0xafe60391,0xf8af8beb}},	// [2da0] _diso_, raik, _попл, टवाय,
   {{0x6604408b,0x6457a6d5,0x7d098009,0x224900f3}},	//   saik, _óxid, ises, _zaak_,
   {{0xddcd0067,0x9f5ec08c,0x6604408d,0x3ce506a7}},	//   rkaš, _vetë_, paik, _झूठे_,
   {{0x09e6b38c,0x7d09c08e,0x2366003a,0x442101e4}},	//   ходн, kses, ćoj_, agh_,
   {{0x6282ba61,0x941e0076,0xaca40135,0x9f5c83fb}},	//   rhoo, _पाऊच_, _abụr, raví_,
   {{0x6d46408f,0x3b0a14b7,0x6282c090,0xe3b10117}},	//   _iska, _него_, shoo, ارے_,
   {{0x64a32028,0x645c4091,0x3ea00168,0x26c681c0}},	//   _сара, _inri, onit_, _phoo_,
   {{0x3ea01af3,0x291d84b9,0xfd55019d,0x9405811c}},	//   nnit_, buwa_, _nkaọ, milə_,
   {{0x6280825d,0x2249079f,0x3ea0372f,0xdd90803d}},	//   _ilmo, _raak_, init_, شود_,
   {{0xf5488104,0x224901b0,0xfd550133,0x6386c092}},	//   _vụ_, _saak_, _akaọ, _néné,
   {{0x69c40698,0x7ae92828,0xa5bb0118,0xfd4981bc}},	//   _azie, _četk, _acól, _kalị,
   {{0x6d464093,0x09d480c8,0x7d0982f7,0xf54880ff}},	//   _oska, _হ্যা, bses, _tụ_,
   {{0x22490a0f,0xf8bf027f,0x638682be,0x26d93d36}},	//   _vaak_, stém_, _béné, _riso_,
   {{0x69c44094,0x3ea0825b,0x638689c4,0xf1c70035}},	//   _dzie, čitu_, _céné, रेगन,
   {{0x443e83ed,0x6d464095,0x26d926de,0x60da83e3}},	//   met_, _aska, _piso_, _mitm,
   {{0x644ac096,0x2001010c,0x291d80a4,0x62670b8c}},	//   _hafi, _wehi_, yuwa_, _سابق,
   {{0x644ac097,0x26d90611,0x7c3e01f4,0xdb0e026f}},	// [2db0] _kafi, _viso_, fepr, _rybá,
   {{0x638683d3,0x44210051,0x7d1d8722,0x64848014}},	//   _géné, ugh_, àssi, _dòig,
   {{0x6d4600ad,0x7f4500f1,0xa3c2b852,0x41ee819d}},	//   _eska, _ushq, ्धि_, _ịsị_,
   {{0x443ec098,0xa3cd0b6f,0x644a80a4,0x291dc099}},	//   het_, शेष_, _lafi, tuwa_,
   {{0x443ec09a,0x765d07d5,0xfe79800d,0xd9458abe}},	//   ket_, _insy, vků_, тели,
   {{0x443ec09b,0x22498025,0xa3c28894,0x291dc09c}},	//   jet_, žak_, ्धा_, ruwa_,
   {{0x443e920b,0xb4bd0b9f,0x752d0211,0x291dc087}},	//   det_, आती_, ltaz, suwa_,
   {{0x764d409d,0x81ac00ab,0x644a846d,0x7d098074}},	//   nday, কেট_, _aafi, tses,
   {{0x752d2579,0x443ec09e,0x644ac09f,0x290b009a}},	//   ntaz, fet_, _bafi, jsca_,
   {{0x443e8a33,0x60da8214,0x6ab62a33,0xf9908199}},	//   get_, _gitm, _skyf, _طبق_,
   {{0x2007c0a0,0x5f798077,0x8c3c87d9,0x03a5818b}},	//   mani_, _تماس_, toğr, тино,
   {{0x20079fb6,0x752d0695,0x7c3e009a,0x7d09c0a1}},	//   lani_, ktaz, zepr, pses,
   {{0x443ec0a2,0x764d0ec8,0x644ac0a3,0xb4db026b}},	//   bet_, dday, _fafi, _asàm,
   {{0x2007c0a4,0x764b8065,0x7e6985f3,0x62888110}},	//   nani_, _hagy, ljep, _įdom,
   {{0x764bc0a5,0x66e604ae,0x290b1947,0xe7271290}},	//   _kagy, тоба, asca_, корд_,
   {{0x644ab6ba,0x764d179b,0x7e7b8168,0x7e69beb6}},	//   _zafi, gday, nkup, njep,
   {{0x764b8117,0x2007c0a6,0x7c3e40a7,0x3ea040a8}},	// [2dc0] _magy, kani_, tepr, rnit_,
   {{0x7ae3c0a9,0x644a8079,0x3ea040aa,0x711b00be}},	//   _kunt, _xafi, snit_, _קויפ,
   {{0x290d8012,0x7ae3c0ab,0x7c3e3665,0x68e4038e}},	//   _avea_, _junt, repr, _huid,
   {{0x764b8117,0x7ae3c0ac,0x443ec0ad,0x68e40006}},	//   _nagy, _munt, zet_, _kuid,
   {{0x443ec0ae,0x2007c0af,0x94058085,0x6d463e74}},	//   yet_, fani_, silə_, _uska,
   {{0x443e40b0,0x68e4043d,0xf1a9803d,0x6602c0b1}},	//   _út_, _muid, رانه_, _seok,
   {{0x443e8370,0x644a8c9e,0x7ae3c0b2,0x764bad80}},	//   vet_, _rafi, _nunt, _bagy,
   {{0x6e2440b3,0x443ec0b4,0xf8bf0019,0x7e7babb9}},	//   ngib, wet_, tték_, gkup,
   {{0x7ae9003b,0x443e8e79,0x20079fe5,0x48e6835f}},	//   _četi, tet_, bani_, _розв,
   {{0x7ae3c0b5,0x60da8cfa,0xa3d7047d,0x443ec0b6}},	//   _bunt, _uitm, ाखच_, uet_,
   {{0x443ec0b7,0x8c1b0158,0x7ae39b96,0x8fa38bc7}},	//   ret_, וויי, _cunt, _кафе,
   {{0x443ebe74,0x68e40014,0x92580009,0x644aa647}},	//   set_, _buid, вают_, _wafi,
   {{0x68e410eb,0x443e85a0,0x644a80a4,0x61ed8511}},	//   _cuid, pet_, _tafi, ñali,
   {{0xa8a440b8,0x1c1e0592,0xcb548b76,0x443e820f}},	//   арск, _पागल_, _منتظ, qet_,
   {{0xd6db130f,0x764d40b9,0x290b01a1,0x6b8d8326}},	//   дта_, tday, ssca_, _ƙage,
   {{0x34db035a,0x752d40ba,0x0bb78039,0x6e2423ff}},	//   बद्द, ttaz, _שלהם_, ggib,
   {{0x2007c0bb,0x68e4114e,0x51870d8e,0xb6040249}},	// [2dd0] yani_, _guid, _шука, ряск,
   {{0x752d40bc,0x1acb8eed,0x041480c8,0x63bc40bd}},	//   rtaz, िष्ठ, ত্রী_, _byrn,
   {{0x2007c0be,0x7ae387f4,0x752d40bf,0x68e400f3}},	//   vani_, _xunt, staz, _zuid,
   {{0x2007c0c0,0xf67900be,0x3d13816f,0x657200f1}},	//   wani_, _נאָמ, _दिले_, ëdhë,
   {{0x2007c0c1,0x7640c0c2,0x66ea8035,0x9564047f}},	//   tani_, demy, _ręka, _кърд,
   {{0xfaf30277,0xb4ac801b,0x7d0d40c3,0x66d58084}},	//   _نثر_, कको_, msas, _iški,
   {{0x2007c0c4,0x61e49601,0x3e750687,0x442797e9}},	//   rani_, žila, _fått_, _rcn_,
   {{0x7ae3c0c5,0x3e750448,0xdd918065,0xdb258019}},	//   _runt, _gått_, یوں_, épít,
   {{0x7ae3c0c6,0x764bc0c7,0x7e7b9abf,0x78b50503}},	//   _sunt, _vagy, rkup, kozv,
   {{0x68e421fd,0x3a2900dd,0x1abe020e,0x764b85ee}},	//   _ruid, _acap_, ोष्ठ, _wagy,
   {{0x394940c8,0x68e440c9,0xb0b680be,0xe29a1b23}},	//   _asas_, _suid, _עפעס_, еан_,
   {{0x68e42cc5,0x2005b241,0xad9b04f0,0x7d0d40ca}},	//   _puid, _heli_, _reún, ksas,
   {{0x2005c0cb,0x78b501a1,0x64848362,0xc871826b}},	//   _keli_, fozv, _dòib, _ko̟_,
   {{0x7ae3c0cc,0x3ebf8364,0x2005811f,0x628600f1}},	//   _tunt, llut_, _jeli_, shko,
   {{0x394940cd,0xe29a1927,0xa3c98778,0x2005af8c}},	//   _esas_, _пак_, लेख_, _meli_,
   {{0x6441c0ce,0x224d8b99,0x44e990ab,0x20058234}},	//   leli, _naek_, _kú_, _leli_,
   {{0x44e9c0cf,0xa3e7a701,0x7d0d02b8,0x6284400e}},	// [2de0] _jú_, _भला_, gsas, _ilio,
   {{0x6441c0d0,0x44e9877f,0x629d026f,0x7640809a}},	//   neli, _mú_, érov, zemy,
   {{0x44e99ca9,0x224d90e4,0x25ab40d1,0x6609a43c}},	//   _lú_, _baek_, _excl_, kaek,
   {{0xa3ab9499,0x64418a92,0x200a3368,0x60de008e}},	//   _कुछ_, heli, labi_, _hipm,
   {{0x44e9c0d2,0x2005c0d3,0xd378809a,0x7d0d40d4}},	//   _nú_, _beli_, zyć_, csas,
   {{0x7ae9003b,0x6441c0d5,0x200a2fc2,0xf8b40b9f}},	//   _četv, jeli, nabi_, ंकिय,
   {{0x64418de8,0xd6da86a1,0x2005c0d6,0x09b580ab}},	//   deli, нти_, _deli_, জেলা,
   {{0x44e9c0d7,0x644e05d8,0x26dd8300,0x26c000e5}},	//   _bú_, _habi, _ciwo_, nlio_,
   {{0x66061f58,0x6441c0d8,0xd49ac0d9,0x7640a1ce}},	//   _mekk, feli, ерн_, remy,
   {{0x6441c0da,0x660640db,0x27f7800d,0x62840010}},	//   geli, _lekk, čení_, _alio,
   {{0x644e40dc,0xd7ef80f7,0x44380706,0x2a60008e}},	//   _mabi, _ركن_, _mbr_, _bnib_,
   {{0x644e1fc6,0x20058052,0x6284051e,0x66062ffb}},	//   _labi, _zeli_, _clio, _nekk,
   {{0x44e99e4e,0xa3d606b7,0x443840dd,0x9f5e8216}},	//   _gú_, ाइड_, _obr_, _metí_,
   {{0xac18835f,0x6441a2f8,0x200a0040,0x224d1cf3}},	//   _року_, celi, gabi_, žek_,
   {{0x447b8158,0x660640de,0x1ee7003d,0xe80c897d}},	//   _אנגע, _bekk, اوری_, _सजना_,
   {{0x26c00021,0x44382eaa,0x3a290890,0x62841581}},	//   glio_, _abr_, _ucap_, _glio,
   {{0x644e2f14,0xe21400a0,0x660640df,0x44380366}},	// [2df0] _babi, _طبيع, _dekk, _bbr_,
   {{0x7d0d40e0,0x888300d7,0x229202d4,0x320b066f}},	//   rsas, _ایسن, vški_, lacy_,
   {{0x644e40e1,0xaca48135,0x62840009,0x20059c40}},	//   _dabi, _azịz, _ylio, _reli_,
   {{0x6441c0e2,0x66061c11,0x62359c3a,0x44380428}},	//   zeli, _gekk, реду, _ebr_,
   {{0x9f5e80e1,0x44258114,0x2005c0e3,0x6441c0e4}},	//   _detí_, ygl_, _peli_, yeli,
   {{0x44e990ab,0x8f15808f,0x44250aa2,0x7e6d0074}},	//   _rú_, афич, _øl_, ljap,
   {{0x44e9c0e5,0x200585f3,0xb5fd807a,0x7d029c00}},	//   _sú_, _veli_, ljši, _awos,
   {{0x6441b986,0x7f3c00be,0x20058079,0x225f8503}},	//   weli, געהו, _weli_, _unuk_,
   {{0xc4858251,0x644e1ea2,0x6f04811f,0x26c380eb}},	//   илик, _yabi, ćica, ējo_,
   {{0x99848013,0x7ae700f1,0x3ebf80f2,0x7d1ba03b}},	//   _الكو, _kujt, slut_, rrus,
   {{0xda661264,0x626600af,0x26c00114,0x200a40e6}},	//   авни, авна, ylio_, vabi_,
   {{0x44e9c0e7,0xe29a1052,0xc5d5835f,0x6723b6c8}},	//   _tú_, там_, _кіль, munj,
   {{0x27318104,0x64418436,0x67238359,0x200a3722}},	//   _hơn_, peli, lunj, tabi_,
   {{0xe3b0803d,0x6d59a668,0x660640e8,0x8d748f24}},	//   _کره_, _irwa, _sekk, _داما,
   {{0x67238867,0x200a40e9,0xb4c383dd,0xb4c1b4ec}},	//   nunj, rabi_, ्षी_, ंती_,
   {{0x644e40ea,0x6284022e,0x200a40eb,0x7ebe80f1}},	//   _sabi, _ulio, sabi_, tëpi,
   {{0x644e15d0,0xb2bb0039,0x61e440ec,0xf5e729c9}},	// [2e00] _pabi, _במקר, _igil, рмул_,
   {{0x26c00025,0x644e381f,0x4463035f,0x6723912e}},	//   slio_, _qabi, овув, kunj,
   {{0x26c006a5,0x66060074,0x644e007a,0xf1bf2294}},	//   plio_, _tekk, _vabi, ngán_,
   {{0x53368158,0xb4c181fe,0x67238699,0x6d59a525}},	//   ינען_, ंतु_, dunj, _orwa,
   {{0x644e40ed,0x656f81ec,0xe046824f,0xa06a8eef}},	//   _tabi, ächl, инди, када_,
   {{0xfb26003d,0x442a01e0,0x4438026c,0x764f023b}},	//   _پرسپ, _ucb_, _ubr_, _zacy,
   {{0x6d4bc0ee,0x6d59c0ef,0x3cec0540,0x61e40106}},	//   _asga, _arwa, _अंडे_, _ogil,
   {{0x2baf08fd,0x66c58125,0x61e424ff,0x7d0286c0}},	//   _जुटा, sókn, _ngil, _pwos,
   {{0x320b40f0,0xe7fb0ebf,0x444403e4,0x657b82c4}},	//   vacy_, ्रमा_, oe_, gyuh,
   {{0x37b28264,0x7ae09867,0x22920196,0x00000000}},	//   টেগর, _himt, išku_, --,
   {{0x94738307,0x444440f1,0x6d5982af,0xe82040f2}},	//   تديا, ie_, _erwa, _बाजा_,
   {{0x44441941,0x1eda80f7,0x48fd800d,0x7d028a03}},	//   he_, _شباب_, रीको_, _twos,
   {{0x64a69a80,0xe29801e2,0x673e0580,0x81e88264}},	//   _када, раў_, _appj, _মজা_,
   {{0x653b83c8,0x61e440f3,0x69c09d94,0x27248133}},	//   _סעוד, _egil, _myme, _ịnye_,
   {{0x7e629254,0xa3b7826a,0x9e070f27,0xddc60035}},	//   _knop, _پاور_, ичал, _nakł,
   {{0x444440f4,0x9f5e8081,0x962100d4,0x33db81c6}},	//   ee_, _metà_, यलेट_, _בחוד,
   {{0x629d40f5,0x7524002a,0x44443f47,0x7e6d2079}},	// [2e10] miso, guiz, fe_, rjap,
   {{0xfd4d0104,0x91bc0039,0x629d40f6,0x6abb8aa2}},	//   _khoả, _במחי, liso, _skuf,
   {{0x7ae0808e,0x69c0c0f7,0xf36740f8,0x7e62c0f9}},	//   _bimt, _ayme, штан, _onop,
   {{0x444440fa,0x4b378051,0x6723a813,0x69c0867f}},	//   ae_, שראל_, vunj, _byme,
   {{0x444440fb,0x660d02d8,0x2731801c,0x463a00be}},	//   be_, maak, _sơn_, _גערע,
   {{0x67238590,0x660d40fc,0x6c8500f7,0x6d9e0609}},	//   tunj, laak, _السم, _dħaħ,
   {{0x629d40fd,0xf8bf255e,0x6445004f,0x3f8184e8}},	//   kiso, ltés_, mehi, áhu_,
   {{0x9aa58077,0x7ebe80f1,0x64453d46,0x660d40fe}},	//   _امرو, këpu, lehi, naak,
   {{0xf8bf255e,0x3e788125,0xddc6009a,0x1fd410c8}},	//   ntés_, _rétt_, _zakł, _दण्ड,
   {{0x4c8598a2,0xd8748013,0xb4c38d14,0xcc89803d}},	//   слов, _والب, ्षे_, انده_,
   {{0x3a2d011b,0x5f79987e,0x09e61bc1,0xdb1c00e7}},	//   мep_, _حماس_, йонн, _pyré,
   {{0x44441e98,0x68e1c0ff,0x629d1fca,0x6d59809a}},	//   ze_, _hild, giso, _trwa,
   {{0x44444100,0x6d5980b4,0x68e184d6,0x6e2994f9}},	//   ye_, _urwa, _kild, mgeb,
   {{0x44443a3b,0x037989a7,0x68e18bce,0x6e29a0b5}},	//   xe_, _محبت_, _jild, lgeb,
   {{0x177911d2,0x629d1f34,0x44fb802a,0x03a28037}},	//   асть_, biso, _hª_, _нишо,
   {{0x07a31ae5,0x75244101,0x6e3b0144,0x6e29b2c7}},	//   часн, tuiz, _ñubl, ngeb,
   {{0x6ab98362,0x7ae08084,0x0dca0b69,0x64848229}},	// [2e20] dowf, _rimt, улай_, _mòin,
   {{0x7ae94102,0x44444103,0x7ae0c104,0x44fbad16}},	//   _četr, ue_, _simt, _mª_,
   {{0x18770039,0x48ee11bc,0xe9f90032,0xb5fd807a}},	//   _העיר_, _इंडो_, _ajẹ_, ljšu,
   {{0x366a0fe7,0x69c086a5,0x2c21816f,0x7f3b00be}},	//   _само_, _pyme, _माझं_, _געטו,
   {{0x68e1b2a6,0x7524016a,0x6e299337,0xf8bf4105}},	//   _bild, quiz, dgeb, ctés_,
   {{0xb4c386b7,0x69c08a21,0x44444106,0x629d4107}},	//   ्षो_, _vyme, qe_, ziso,
   {{0x43860013,0x394d84c3,0x68e18965,0xd6d096a5}},	//   _الأق, _eses_, _dild, وقت_,
   {{0xdd080038,0x8cf4c108,0x39401893,0x44f4817c}},	//   _môže, озиц, _opis_, опис,
   {{0x68e9c109,0x39401dd3,0xf65301c6,0xbcfb046d}},	//   _gued, _npis_, לצה_, _eréf,
   {{0x68e1807b,0x6282c10a,0x04669510,0x44fb802a}},	//   _gild, lkoo, стим, _dª_,
   {{0x2d82895e,0x629d410b,0x44fb8118,0x7c288bfd}},	//   ške_, tiso, _eª_, rgdr,
   {{0x6282c10c,0x25a98289,0x6d49c10d,0x7e62c10e}},	//   nkoo, _žale_, bwea, _unop,
   {{0x787d8247,0x68e19238,0xe1ff410f,0x660d0365}},	//   _sèvi, _yild, rbó_, vaak,
   {{0x629d4110,0x200e8239,0x68e18079,0xd9180009}},	//   siso, nafi_, _xild, щью_,
   {{0x6282c111,0x5c3784de,0x443c8dcc,0x64450087}},	//   kkoo, _הטוב_, _ibv_, vehi,
   {{0xf96b0098,0x62828952,0x61e481a1,0xfaa42ba7}},	//   _брой_, jkoo, žilj, _најо,
   {{0xe29f0125,0x62829ead,0x660d410c,0xf8bf02be}},	// [2e30] mið_, dkoo, raak, utés_,
   {{0xe29f0125,0x68e9c112,0x660d257a,0xa3cf8fd5}},	//   lið_, _rued, saak, _शरम_,
   {{0x660d4113,0x64454114,0xda7b85e9,0xe80c8105}},	//   paak, rehi, ляд_, _सज़ा_,
   {{0x68e9a70d,0xaac90f21,0x02c903b7,0x7aeac115}},	//   _pued, रतिक, रतिभ, _muft,
   {{0x68e9ad11,0x7aeac116,0x68e1c117,0x6aad00f1}},	//   _qued, _luft, _pild, _mjaf,
   {{0x46f595d1,0xbcfb02be,0x68e1a795,0xa3d60424}},	//   очит, _préf, _qild, ाइश_,
   {{0xe29f07ca,0x68e1c118,0x6e299781,0x3ea913f0}},	//   kið_, _vild, tgeb, onat_,
   {{0x3ea91c15,0x62349509,0xa3bc80c2,0x68e19457}},	//   nnat_, _несу, _आड़_, _wild,
   {{0x6e298df3,0x7aea82af,0xd131b026,0xe29f008b}},	//   rgeb, _auft, _زما_, dið_,
   {{0x6d5d02a5,0x6e298223,0x6aad0032,0x3ea94119}},	//   _mrsa, sgeb, _ajaf, hnat_,
   {{0xe29f0125,0x3ea9411a,0x3940411b,0x37aba12e}},	//   fið_, knat_, _spis_, _стан_,
   {{0x6d4f411c,0xe29f0125,0x6d5d411d,0x442e8358}},	//   _osca, gið_, _orsa, _ecf_,
   {{0xa509902f,0x3eb88019,0x3ea901d0,0x442e8580}},	//   _тела_, _írta_, dnat_, _fcf_,
   {{0x62898355,0x39408085,0x3940007a,0x70b40c28}},	//   _lleo, çisi_, _vpis_, ंकेल,
   {{0x62899cb2,0x39400035,0x6d5d411e,0xafe310ac}},	//   _oleo, _wpis_, _arsa, дорл,
   {{0x3ea9411f,0x6d5d036e,0x6aad008b,0xd1322b7e}},	//   gnat_, _brsa, _gjaf, _قمع_,
   {{0x3940005c,0x660b8065,0x3ce300f3,0xf8bf27d1}},	// [2e40] _upis_, _megk, _bijv_, rtér_,
   {{0x3ea9036e,0xa3d60740,0x85218e33,0x660b8019}},	//   anat_, ाइल_, _मिनट_, _legk,
   {{0x7ae43006,0x6d5d0910,0x2a6480b9,0x6d4f0c8c}},	//   _kiit, _ersa, _pnmb_, _esca,
   {{0x6d4f0580,0xfaa39246,0x7ae40df6,0x09de0264}},	//   _fsca, махо, _jiit, _ভ্যা,
   {{0xbcfb12ab,0x628290bd,0x82d703de,0x3ea04120}},	//   _créd, rkoo, קונג_, miit_,
   {{0x7ae40a92,0x6282c121,0x3ea04122,0xb4b3800f}},	//   _liit, skoo, liit_, झको_,
   {{0x200ea3ac,0xbcfb05db,0x443c81a1,0x8cb9175d}},	//   rafi_, _prég, _rbv_, ्तरो,
   {{0x7ae40364,0xf41f00ab,0x9f58349a,0xbcfb0036}},	//   _niit, ন্দর_, laró_, _fréd,
   {{0xe29f01fa,0x78bc4123,0x2d801c40,0x442e9a1f}},	//   við_, korv, nyie_, _pcf_,
   {{0xb5fb1313,0x6fc0016f,0x7d1d8019,0x6aad02f7}},	//   _anál, _शुभं, ássa, _sjaf,
   {{0xe29f07ca,0x7bc3831d,0x7ae44124,0x69c44125}},	//   tið_, _cynu, _biit, _ayie,
   {{0xe8d90028,0xf8bf04c3,0x442e8609,0x81af0264}},	//   _trị_, guén_, _wcf_, _করব_,
   {{0xe29f07ca,0x3ea9001b,0x7ae44126,0x78bc03ba}},	//   rið_, vnat_, _diit, forv,
   {{0xe29f007b,0x50ca852a,0x6d428037,0x7aeac127}},	//   sið_, ितिष, _ipoa, _tuft,
   {{0x3f85003e,0xc058035f,0x200ca068,0x64488b23}},	//   álu_, ція_, _medi_, medi,
   {{0x6448c128,0x3ea000e4,0xe298038c,0x442cc129}},	//   ledi, giit_, _мај_, lgd_,
   {{0x3ea9412a,0x7bce0088,0x442c81ed,0x98ca8035}},	// [2e50] rnat_, _azbu, ogd_, िताए,
   {{0x6448c12b,0x442c9808,0x6d5d19b7,0x28d20035}},	//   nedi, ngd_, _vrsa, _दीपि,
   {{0x2011412c,0x442cc12d,0xa801816a,0x3ea92c15}},	//   mazi_, igd_, _íñig, pnat_,
   {{0xbcfb12ab,0x68ed412e,0x6d5d09d1,0x6abd1e03}},	//   _préd, _kuad, _trsa, nosf,
   {{0x68ed0748,0x6d4f0087,0x6d5d412f,0x59d34130}},	//   _juad, _usca, _ursa, _सरफर,
   {{0x64488025,0xbcfb03d3,0x201106a0,0x200c81a1}},	//   jedi, _crée, nazi_, _cedi_,
   {{0x02a78f04,0x200c817b,0x6448c131,0x6d4d4132}},	//   _драм, _dedi_, dedi, lwaa,
   {{0x6e2d4133,0x20114134,0x64554135,0x200c846d}},	//   ngab, hazi_, _hazi, _eedi_,
   {{0x20113f6d,0x7ae40009,0xe8d90133,0x61e98f3e}},	//   kazi_, _riit, _arọ_, _igel,
   {{0x7ae40364,0x442c8106,0x20114136,0x68fb8122}},	//   _siit, ggd_, jazi_, _itud,
   {{0x64554137,0x2909019d,0x395f8573,0x69c400b9}},	//   _mazi, _awaa_, _hrus_, _syie,
   {{0x6d4d4138,0x64554139,0x442c8a0f,0x395f8461}},	//   kwaa, _lazi, agd_, _krus_,
   {{0x7ae4413a,0x68ed0c15,0x764982a3,0x6448c13b}},	//   _viit, _cuad, meey, bedi,
   {{0x6455413c,0x6448bbfe,0x6d4d4132,0x20113bb8}},	//   _nazi, cedi, dwaa, gazi_,
   {{0x6e2d01ec,0x2aa40061,0x366a0323,0x7ae418c2}},	//   fgab, rűbb_, баво_, _tiit,
   {{0x61e9840c,0x61e482ce,0xf8bf413d,0x68ed10eb}},	//   _ngel, žili, quén_, _fuad,
   {{0x64550dbb,0x68ed3dbe,0x6d4d18f8,0x2011413e}},	// [2e60] _bazi, _guad, gwaa, bazi_,
   {{0x6455413f,0x31370051,0x6ad100c8,0xf8bf02be}},	//   _cazi, _צריך_, _সংযো, trée_,
   {{0xb5fb003e,0x645a00a9,0x395f8458,0x307b0039}},	//   _znám, _ótim, _arus_, _האינ,
   {{0x25ad003a,0x20c98013,0x31603a9c,0x3d1c8740}},	//   _žele_, súil_, _kriz_, _मिले_,
   {{0x64554140,0x66044141,0x200cc142,0x76498079}},	//   _fazi, mbik, _pedi_, deey,
   {{0x61ff8201,0x644881df,0x64554143,0x66044144}},	//   ıqla, xedi, _gazi, lbik,
   {{0x43430e86,0x200c8098,0x7d160b81,0x68fb902d}},	//   _перв, _vedi_, lsys, _etud,
   {{0x200ca065,0xd90d8bca,0x20112486,0x64550234}},	//   _wedi_, _چین_, zazi_, _zazi,
   {{0x644887d9,0xc10680f7,0x395f92f1,0x7d164145}},	//   tedi, _رواي, _grus_, nsys,
   {{0x672380fe,0x6aa2804f,0x6f150035,0xc917807c}},	//   brnj, liof, yszc, _מחמת_,
   {{0x68ed1286,0x442c80f3,0x6448aad1,0x20114146}},	//   _suad, rgd_, redi, vazi_,
   {{0x6448c147,0x20114148,0x75244149,0xa25b00e7}},	//   sedi, wazi_, kriz, plôm,
   {{0x20112f6a,0x6448c14a,0x7aee022c,0x68ed1ee5}},	//   tazi_, pedi, _lubt, _quad,
   {{0xe521800d,0xe8d900ff,0xb4db026b,0xe4d780d7}},	//   _मिति_, _trọ_, _apàn, _فونت_,
   {{0x645506b9,0x2011414b,0xddc9920e,0x6af380f7}},	//   _razi, razi_, mješ, _كثير,
   {{0xddc9ae0a,0x6455414c,0x6d4d18f8,0x68e5008e}},	//   lješ, _sazi, twaa, _wihd,
   {{0x6455414d,0x6e2d414e,0xc8670ab2,0x95cb0f9c}},	// [2e70] _pazi, rgab, _етни, сува_,
   {{0x6d4d21cf,0x2a690069,0x6e2d414f,0x787d8036}},	//   rwaa, _hnab_, sgab, _lèvr,
   {{0x81af00c8,0x64550e64,0x628d190f,0x6d4d4150}},	//   _করি_, _vazi, _klao, swaa,
   {{0x6455280d,0x75244151,0x7aee009f,0x76498079}},	//   _wazi, briz, _dubt, xeey,
   {{0xdb188364,0x75240098,0x6d4d0359,0x645534c2}},	//   _hyvä, criz, qwaa, _tazi,
   {{0x81af0a49,0x26c90661,0x76499a25,0x224b4152}},	//   _করা_, llao_, weey, heck_,
   {{0xe73999b5,0xdb188198,0x7649a223,0x7aee0df6}},	//   цей_, _jyvä, teey, _gubt,
   {{0x61e900ce,0x395f8854,0xbcfb00e1,0x6564826c}},	//   želj, _trus_, _gréc, _šiha,
   {{0x395f9083,0xb3458073,0x764982a3,0x9f5c816b}},	//   _urus_, _opçã, reey, mavý_,
   {{0x660f4153,0x3b85ab2c,0x6d5b9c85,0x212b016b}},	//   _leck, длог, rvua, duch_,
   {{0xf8bf0073,0x78a3807a,0x26c90699,0x628d0f35}},	//   guém_, minv, klao_, _blao,
   {{0x76498079,0x31604154,0x628d0834,0xedd581a8}},	//   qeey, _priz_, _clao, _قياد,
   {{0x752987a3,0x62860364,0x3ead8687,0xcdcb853d}},	//   quez, rkko, mnet_, _اذان_,
   {{0x3ebf8e35,0x62860006,0x92ae00ab,0x661d128d}},	//   lout_, skko, কতে_, _adsk,
   {{0xfbd182f1,0x23d18035,0x81df00ab,0x3ead8168}},	//   _हरिम, _हरिद, দুল_, onet_,
   {{0x3eadc155,0x3ebf800d,0x75244156,0x212b4157}},	//   nnet_, nout_, triz, buch_,
   {{0x6604320e,0x6da3002e,0xec7a2457,0xe5a34158}},	// [2e80] rbik, вита, опа_, вити,
   {{0x3eadc159,0x7524011e,0xfbd1903e,0x3ebf9151}},	//   hnet_, rriz, _हराम, hout_,
   {{0xbcfb03d3,0x3ebf83ec,0x752400dd,0x93c30087}},	//   _préc, kout_, sriz, _ţări,
   {{0x660f1486,0x8b651ddd,0x65690fee,0x3ebf9a1f}},	//   _geck, عالم, _šehe, jout_,
   {{0xd910803d,0x3cfd81c0,0xa3df02f1,0x2ee68362}},	//   ایط_, _ntwv_, देब_, _riof_,
   {{0x3eadc15a,0xb5fb0144,0x32e802d0,0x787d8866}},	//   enet_, _anáh, _eşya_, _sèvr,
   {{0xddc98499,0x3eadc15b,0xfaa6853b,0x44f28162}},	//   vješ, fnet_, _жаво, _sâ_,
   {{0x3ebf8e35,0x3ead920b,0xdb0e0035,0x7c3e0901}},	//   gout_, gnet_, _wybó, lfpr,
   {{0x3206c15c,0xa3d60035,0xbcfb09c4,0xddc98140}},	//   mboy_, ाइक_, _kréa, tješ,
   {{0x3374879e,0x2126808e,0xb866a0bb,0x6ef58609}},	//   егор, mroh_, _تارو, _iġbn,
   {{0x3ebf93ff,0xddc98639,0x3eadc15d,0xda350e11}},	//   bout_, rješ, bnet_, нены,
   {{0xcfa98064,0x3206c15e,0xdddb807a,0xbd4680f7}},	//   _عالم_, nboy_, skuš, _يناي,
   {{0xddc98499,0x68e8c15f,0x224b1230,0xdb0a8106}},	//   pješ, _kidd, reck_, _nyfö,
   {{0x55778158,0x660f4160,0x212b4161,0x3dcd01b9}},	//   _קעגן_, _seck, ruch_, _ġew_,
   {{0x6d460bb6,0x212b01ec,0x660f136f,0x320682c4}},	//   _apka, such_, _peck, kboy_,
   {{0x443ec162,0x68e8c163,0x64588a55,0xbcfb010c}},	//   lft_, _lidd, _havi, _aréa,
   {{0x660f04b8,0xf8ae0077,0x6458c164,0x2d84b06a}},	// [2e90] _veck, شکی_, _kavi, nyme_,
   {{0x645880ce,0xbcfb03d3,0xdb1880f2,0x26c9005c}},	//   _javi, _créa, _tyvä, slao_,
   {{0x660f00f2,0x3ead8aa2,0x443ec165,0x6458c166}},	//   _teck, ynet_, ift_, _mavi,
   {{0x64588247,0x661d013c,0xe29880e8,0x69dd816b}},	//   _lavi, _udsk, має_, _úsek,
   {{0x29190364,0xa069a434,0xaca3019d,0xdb1c05b9}},	//   nssa_, зала_, _abục, _vyrá,
   {{0xbcfb0013,0x68e8c167,0x443e8a0f,0x29190364}},	//   _gréa, _cidd, jft_, issa_,
   {{0x68e88114,0x78a3a3be,0x65628db1,0x3eadc168}},	//   _didd, rinv, _aroh, tnet_,
   {{0x61ed4169,0x443e80f3,0x68e88114,0x645894c7}},	//   _ngal, eft_, _eidd, _aavi,
   {{0x443ea06f,0xdbd68364,0xc0cbc16a,0x3ebf9823}},	//   fft_, _lääk, _дуже_, rout_,
   {{0xe1fa00ba,0x6458c16b,0x61ed416c,0xb4b981ab}},	//   ूर्ण_, _cavi, _agal, चवे_,
   {{0x6458c16d,0x29190364,0x7ae98084,0x53c980e8}},	//   _davi, essa_, _kiet, ягом_,
   {{0x60c5008e,0x7e7d00eb,0x2d848216,0x656f8192}},	//   _akhm, _nosp, byme_, ächs,
   {{0x7ae9c16e,0xf2d280be,0x961500ab,0x61fb804f}},	//   _miet, טעט_, িলাম_, _mful,
   {{0x7ae9c16f,0x61ed4170,0xe00282f1,0x752d0ab3}},	//   _liet, _egal, रुपद_, duaz,
   {{0x2bc69664,0xb4cb8361,0xfbc6800d,0x26c0047f}},	//   _रुपा, लती_, _रुपम, toio_,
   {{0x7ae9c171,0x64588b48,0xe81c000d,0x139a8039}},	//   _niet, _zavi, _भएका_, _מבצע,
   {{0x7e7d1284,0x753bc172,0x69c9c173,0xd9de00ab}},	// [2ea0] _dosp, ntuz, _nyee, _ভ্রম,
   {{0xe0d207bd,0x6ab88996,0x64589e9e,0x26c000e5}},	//   _حزب_, इक्र, _xavi, soio_,
   {{0x7ae9c174,0x389b0158,0xb2269c8b,0x7e6b82c4}},	//   _biet, _זיינ, емел, _ongp,
   {{0x68e8a629,0x7ae980eb,0x7e7d4175,0x2ca5977a}},	//   _sidd, _ciet, _gosp, hild_,
   {{0xc1e78009,0x290d8326,0xe9478019,0x752d00e5}},	//   ньше_, _cwea_, ٹرنی, cuaz,
   {{0x59d304e5,0x7e6b81e0,0x66160df6,0x61fb8c2e}},	//   _सरसर, _angp, layk, _eful,
   {{0xb5fb0013,0x7ae9a64f,0x6458c176,0x0cbe14d5}},	//   _snái, _fiet, _ravi, ्तीम,
   {{0x6458b1dc,0xd6d784d9,0xddcd01dd,0x661601e0}},	//   _savi, нты_, ljaš, nayk,
   {{0x6458c177,0xa90a80a0,0x7ae38fb0,0x290001c0}},	//   _pavi, _ريال_, ïnte, _ntia_,
   {{0xd91b8051,0x4f96a748,0x253700be,0xb4db026b}},	//   _מומל, _преу, עניש_, _apàj,
   {{0xa3d6005e,0x443ec178,0x64588b80,0x61ed00b9}},	//   ाइट_, rft_, _vavi, _pgal,
   {{0x273a80f1,0xdbd68074,0x2d848216,0x6458c179}},	//   mën_, _rääk, pyme_, _wavi,
   {{0x2ca5c17a,0x273a80f1,0xd2510077,0x1a9b80be}},	//   bild_, lën_, هنگ_, ליטע,
   {{0x7e7d417b,0xbcfb0176,0xdbd68198,0x3a2002d0}},	//   _sosp, _brén, _pääk, _edip_,
   {{0x921089a3,0x273a820f,0xd9048117,0x6e671383}},	//   ाराज_, nën_, _گی_, нтаж,
   {{0x41de0076,0x752d417c,0x61ed417d,0xadc3846d}},	//   नेहस, tuaz, _ugal, _akẹk,
   {{0xd90499f4,0x273a80f1,0xdd9401bb,0x7ae9c17e}},	// [2eb0] _دی_, hën_, гаты, _riet,
   {{0x7ae9c17f,0x273a80f1,0xe802801b,0x752d0ab3}},	//   _siet, kën_, रुमा_, ruaz,
   {{0x7ae9c180,0x273a80f1,0x7e7d1c19,0x69c982c4}},	//   _piet, jën_, _tosp, _syee,
   {{0xed510117,0x386c8267,0x78a700f3,0x273a8168}},	//   _پھر_, _andr_, lijv, dën_,
   {{0x7ae9c181,0xe8f88221,0x273a80f3,0xddcd0503}},	//   _viet, елі_, eën_, bjaš,
   {{0x07a590ca,0x8fa59597,0x26c6a914,0xad9b026b}},	//   калн, кале, _akoo_, _afúg,
   {{0x7ae9c182,0x273a80f1,0x6b83016d,0x394900ee}},	//   _tiet, gën_, ängd, _lpas_,
   {{0xdddd00eb,0x2ca5874c,0x92588071,0x78a701ed}},	//   _nosū, wild_, _паст_, hijv,
   {{0x2d8b83cb,0x648d80f7,0x39490282,0x81b00326}},	//   áce_, _dúin, _npas_, _keɓe,
   {{0xb4cba8b3,0x44330683,0x4c8582eb,0x9d44b026}},	//   लते_, ngx_, тлов, ائين,
   {{0x39494183,0x7d042dc8,0x3a200101,0x6aa62709}},	//   _apas_, zpis, _pdip_, tikf,
   {{0xfeb88013,0x60c39727,0xddcd011f,0xfaa64184}},	//   _كانت_, lonm, zjaš, тамо,
   {{0xe29731a5,0x82768158,0x6609c185,0x7e9a83de}},	//   тая_, דערע_, mbek, _קסנו,
   {{0xbcfb4186,0x9103002e,0x9345813a,0x26cd816a}},	//   _prén, рпре, _анке, lleo_,
   {{0xe7370256,0x7d1bc187,0xb8ca326c,0x3f8c016b}},	//   кер_, lsus, _खग_, ádu_,
   {{0x7d040025,0x61ed811f,0xbcfb21bf,0xe3e880be}},	//   tpis, žalj, _créo, _אַפֿ,
   {{0xdee33344,0x7bd50081,0x66e303c7,0x66160079}},	// [2ec0] роти, _azzu, рота, rayk,
   {{0x14c803f8,0x0cbe023c,0xbcfb03b0,0x7d040057}},	//   رهای_, ्तेम, _trén, rpis,
   {{0x20184188,0x91f6000f,0xddc2805c,0x7dd8026b}},	//   mari_, _इलाज_, _mnoš, _búsí,
   {{0x20184189,0x7d1b8100,0x273a80f1,0xd36f00f7}},	//   lari_, ksus, vën_, تهم_,
   {{0xdb0e0106,0x2a7f8242,0x7bd5038a,0xc02f0129}},	//   _nybö, _doub_, _ezzu, _điếu_,
   {{0x273a88cf,0xa3df0b75,0xd90d80d5,0xe0438012}},	//   tën_, देह_, سیم_, инчи,
   {{0x64a32133,0xdca30a7c,0xdb1c01a3,0x75298c2e}},	//   _тара, _тари, _byrå, erez,
   {{0x273a820f,0x2018418a,0x6b830b2f,0x66098091}},	//   rën_, hari_, änge, gbek,
   {{0x645c418b,0x64419849,0x273a820f,0x7d1b9066}},	//   _kari, ffli, sën_, gsus,
   {{0xa3df03b7,0x2018319f,0x290686cb,0x3eb20009}},	//   देव_, jari_, mpoa_, hnyt_,
   {{0xf4fc8133,0x7529c18c,0xbddb010c,0x5fb6873c}},	//   _dịịr, arez, _abèl, _अखिल,
   {{0x645c418d,0x26cda34a,0x2fd7803d,0xc33302f6}},	//   _lari, cleo_, _شوند_, סור_,
   {{0x81e480c8,0x6280c18e,0x6e228135,0x7529a49a}},	//   পুর_, _momo, _idob, crez,
   {{0x645c418f,0x4ec400ab,0x9f35102a,0x6280c190}},	//   _nari, ্দোল, легі, _lomo,
   {{0x9cd78039,0x78a74191,0x6cd980be,0xbcfb0036}},	//   _שווה_, rijv, _אַקצ, _préo,
   {{0x6280c192,0x645c4193,0x9f98826f,0x26c4c194}},	//   _nomo, _aari, jším_, nomo_,
   {{0x645c4195,0x20184196,0x35f44197,0x44384198}},	// [2ed0] _bari, bari_, рпур, _bcr_,
   {{0x645c4199,0x7d1d83a7,0x26c481e0,0xa855419a}},	//   _cari, ássi, homo_, _скоч,
   {{0x645c16a7,0x26c494c6,0x6280bc51,0x7aed019e}},	//   _dari, komo_, _bomo, _kiat,
   {{0x3e040081,0x6e22c19b,0x7aed0609,0x60da852a}},	//   _вярв, _ndob, _jiat, _ahtm,
   {{0x645c419c,0x6280c19d,0x7aed0065,0xbcfb037d}},	//   _fari, _domo, _miat, _krém,
   {{0x645c1a85,0x3ea9419e,0x765d111e,0x2ecb89c2}},	//   _gari, liat_, _hasy, ात्त,
   {{0xb6a59a02,0xa3df419f,0xa283803d,0x7d02c1a0}},	//   ликл, देश_, _پیشو, _atos,
   {{0x7529c1a1,0x645c41a2,0x7d1b8006,0x201841a3}},	//   trez, _zari, tsus, zari_,
   {{0xd4159641,0x20183e75,0x765d1904,0x59b7800f}},	//   льны, yari_, _masy, _आखिर,
   {{0x645c1b37,0x13098364,0x7529bfae,0x6e228135}},	//   _xari, нной_, rrez, _edob,
   {{0x26cd85b4,0x3eb20364,0x6280836a,0x6441c1a4}},	//   pleo_, ynyt_, _yomo, rfli,
   {{0x765d0247,0x26c4b6f1,0x7aed41a5,0x64419bc2}},	//   _nasy, como_, _ciat, sfli,
   {{0x7aed0500,0x3ea941a6,0x8c458be2,0xe56e84ae}},	//   _diat, diat_, _беле, _уз_,
   {{0x6d59b93e,0x03198013,0x7e7b805c,0xddc2825b}},	//   _iswa, _كتبت_, ljup, _unoš,
   {{0x201841a7,0x645c04b9,0x7aed0019,0x765d41a8}},	//   rari_, _rari, _fiat, _basy,
   {{0x645c41a9,0x7aed41aa,0x998601ad,0xbcfb026b}},	//   _sari, _giat, _ملبو, _erém,
   {{0xcbb00a49,0x056611e9,0x8d6621f6,0x765d0359}},	// [2ee0] _করেছ, ыван, ывае, _dasy,
   {{0x628090dd,0x645c41ab,0x399b01c6,0x6d59a73b}},	//   _somo, _qari, _נייד, _mswa,
   {{0x0326280f,0x3ea941ac,0x26c4804f,0x4b2602de}},	//   уден, biat_, yomo_, умев,
   {{0xe297c1ad,0x3ea913f0,0x6d4ba862,0xdce284b7}},	//   лах_, ciat_, _opga, _proċ,
   {{0x645c41ae,0xa9678d69,0x19588190,0x9f98816b}},	//   _tari, лица_, талы_, rším_,
   {{0x44380216,0xd00f81a8,0xe8d90129,0x6e3641af}},	//   _ucr_, كله_, _trễ_, lgyb,
   {{0x7af500ad,0x7d028063,0x6d4b8bb6,0xb4e020d5}},	//   _guzt, _stos, _apga, दगी_,
   {{0x21200025,0x7f3b00be,0x44443593,0x212b0114}},	//   _ovih_, געקו, lf_, yrch_,
   {{0x7aed41b0,0x26c4c1b1,0xa8368065,0xddc404b7}},	//   _riat, romo_, _معاش, jjiż,
   {{0xb99380f7,0x26c4a169,0x212b016b,0xb80a81a8}},	//   _الكب, somo_, vrch_, _أيام_,
   {{0x444441b2,0x7aed41b3,0x6d4b8118,0x69cd008e}},	//   if_, _piat, _epga, _syae,
   {{0x6e228805,0xf1b88c87,0x6484851e,0x92580198}},	//   _udob, _अशान, _còir, гают_,
   {{0x7aed27c5,0xa802017b,0x3ea941b4,0x32190690}},	//   _viat, ğınd, viat_, rasy_,
   {{0x44440613,0xa80202bb,0xe3a4803d,0x7c38817f}},	//   jf_, şınd, _پشتی, _ucvr,
   {{0xd6db00ae,0x765d41b5,0x7ae2816d,0x6d408965}},	//   ета_, _pasy, kmot, ltma,
   {{0x7bd8803a,0x6e36008e,0x61ed811f,0x5e5800e8}},	//   _izvu, ggyb, žali, лися_,
   {{0x44440af4,0x6d40c1b6,0x1fe1aa54,0xf1a48035}},	// [2ef0] ff_, ntma, _पण्ड, _खेलन,
   {{0x3ea911d6,0x78a5007b,0xe1ff41b7,0x765d3907}},	//   siat_, _umhv, lcó_, _wasy,
   {{0x3ea941b8,0x1cbb80be,0x75eb8019,0x3d1b026b}},	//   piat_, עמבע, _közü, _bàwá_,
   {{0x44440c72,0xe1ff0216,0x291d8a03,0x7ae2c1b9}},	//   af_, ncó_, tswa_, gmot,
   {{0x660d3996,0x224908b3,0x444400b9,0x81b009ab}},	//   mbak, _mbak_, bf_, _keɓa,
   {{0x660d035f,0x3ea69ca7,0x5f05a7ae,0x60c70168}},	//   lbak, _amot_, азка, nojm,
   {{0x96958088,0x752d00b9,0x7ae29500,0x3d1b026b}},	//   ириш, lraz, bmot, _fàwá_,
   {{0x31690d38,0x660d0102,0xada600e1,0x752d0ab3}},	//   _oraz_, nbak, slúž, oraz,
   {{0x212b8028,0x60c741ba,0xef190035,0xdf61846d}},	//   _ích_, kojm, ąży_, _bẹ́è,
   {{0x3ea680f2,0x66f18029,0x1035803d,0x6aab928d}},	//   _emot_, _sāku, _خبرگ, ligf,
   {{0x21200025,0xe29a1612,0x752d001b,0x2bfb85fc}},	//   _svih_, ван_, hraz, लुगू_,
   {{0x09e61056,0xfc3f800d,0x91e60652,0x752d41bb}},	//   ионн, ří_, ионе, kraz,
   {{0x6d59c1bc,0x89d6021e,0x6f050090,0x6d408bfd}},	//   _uswa, рінш, _athc, ctma,
   {{0x661bc1bd,0x752d0503,0x7ae28289,0x225fc1be}},	//   lauk, draz, zmot, _lauk_,
   {{0x44fb879f,0x752d011e,0x7d09987a,0xdb038980}},	//   _hê_, eraz, lpes, _exnò,
   {{0x44fb801c,0xfb24803d,0x316903ec,0x75eb83bf}},	//   _kê_, _اروپ, _fraz_, _gözü,
   {{0x752d23e9,0xf8bf41bf,0xa3e8086a,0x394d8282}},	// [2f00] graz, gués_, मेन_, _npes_,
   {{0x444441c0,0x2a600282,0x661bc1c1,0x44fb801c}},	//   uf_, _haib_, hauk, _mê_,
   {{0x444441c2,0x66f18029,0x44fbc1c3,0x660d41c4}},	//   rf_, _māks, _lê_, bbak,
   {{0x752d0ed7,0xd7bb0051,0xe24680f7,0x661bc1c5}},	//   braz, _יציר, شخصي, jauk,
   {{0x28db1094,0x661b86ac,0x752d047f,0x444401ec}},	//   _मीडि, dauk, craz, pf_,
   {{0xdce28025,0x2a600282,0x7e0e863a,0x6284159d}},	//   _proč, _laib_, सर्ग_, _loio,
   {{0xe7e18074,0xd3721a37,0x20c981a8,0xc1d341c6}},	//   गेला_, _ظهر_, túir_, _सर्ग,
   {{0xdce28353,0x2a6041c7,0x629981ec,0x44fb80ff}},	//   _vroč, _naib_, chwo, _bê_,
   {{0x8c3c8214,0xddc98214,0x394001c5,0x66fc016b}},	//   liği, rdeş, _nqis_, _očko,
   {{0x44fbc1c8,0x6721081d,0x75eb8059,0x07a68389}},	//   _dê_, šlji, _sözü, _казн,
   {{0x99920176,0x628407b6,0x3169128a,0x57fbb5c4}},	//   _deyō_, _boio, _sraz_, _סלאו,
   {{0x201cc1c9,0x38ad0267,0x661b82f7,0x62840362}},	//   lavi_, džra_, cauk, _coio,
   {{0x6602c1ca,0x2a6001c0,0xe1ff1d24,0x60c70168}},	//   _ifok, _daib_, rcó_, tojm,
   {{0xda0712e0,0x8d85804e,0x629641cb,0xe1ff41cc}},	//   _व्रत_, _دشمن, _elyo, scó_,
   {{0x2a600069,0x629602f7,0x629880eb,0x60c70fd4}},	//   _faib_, _flyo, īvoj, rojm,
   {{0x35f541cd,0x8c3c87d9,0x2a60061b,0x316903a7}},	//   спар, diği, _gaib_, _traz_,
   {{0x201c8796,0x95cb0f9c,0x752d2801,0x44fb827d}},	// [2f10] kavi_, тува_, uraz, _xê_,
   {{0x752d2798,0x70551125,0x7af881c0,0xf36741ce}},	//   rraz, _اندا, _kuvt, итен,
   {{0x201c8214,0x6a1780f7,0xa8560039,0x6aabc1cf}},	//   davi_, لبشر, _היתה_, tigf,
   {{0x752280d2,0x2a6001c5,0x6235aba7,0x99d981a8}},	//   _ovoz, _xaib_, седу, هواء_,
   {{0xf8bf2544,0xaca48032,0xe8d90133,0x7afb0390}},	//   qués_, _ajọy, _nsị_, _čutu,
   {{0x386102af,0x88c880e8,0x6602826b,0x6d5d41d0}},	//   _jahr_, алів_, _afok, _issa,
   {{0xfbe5150b,0xe3e500c8,0x44fb84df,0xb3e500c8}},	//   _প্রত, _প্রব, _sê_, _প্রজ,
   {{0x02a481ae,0x9454011c,0xbcfb41d1,0xcfb801c6}},	//   _друм, _çərş, _préh, ילוי_,
   {{0x201c803a,0x661b9608,0x6aa99cfb,0x443c8144}},	//   bavi_, rauk, _imef, _bcv_,
   {{0x661b8029,0x2a6001e9,0x44fbc1d2,0x7522abea}},	//   sauk, _saib_, _vê_, _dvoz,
   {{0x7d09c1d3,0x1fa7ae15,0x661b8009,0x2a600282}},	//   spes, _траг, pauk, _paib_,
   {{0x7d09ad03,0xdb1e801b,0x2a600069,0xc7b281c6}},	//   ppes, íván, _qaib_, _צבא_,
   {{0xddc982fd,0xd6c68077,0x3eadc1d4,0x75229487}},	//   ljež, _امنی, miet_, _gvoz,
   {{0x3eadc1d5,0xbcfb01a8,0xe73a323a,0x40951229}},	//   liet_, _gréi, лег_, орст,
   {{0xd62a0539,0xdfd200f7,0x2a600748,0x6d5d41d6}},	//   лове_, سير_, _taib_, _assa,
   {{0x3eadb3da,0x629880eb,0x201c935a,0x6abb826c}},	//   niet_, īvok, zavi_, _njuf,
   {{0x6b830884,0x44278748,0xa2c50519,0x98a60198}},	// [2f20] ängn, _kdn_, रवर्, _гипе,
   {{0xb97b0039,0x6aa9804f,0x8c3c8214,0xa3ab83eb}},	//   _עניי, _amef, tiği, _गधा_,
   {{0x6d5d41d7,0x8c1a8039,0x201c8669,0x0b461383}},	//   _essa, רועי, vavi_, снен,
   {{0x3eadaf1e,0xf8bf0019,0x320237ba,0x8c3c82d0}},	//   jiet_, tség_, ncky_, riği,
   {{0x7243803d,0x3eadc1d8,0x64430722,0x442780fe}},	//   سپول, diet_, ònic, _odn_,
   {{0x2eb29c42,0x6aa98133,0xddcd0085,0x0496066e}},	//   ुक्त, _emef, ldaş, _السح,
   {{0x6d4441d9,0xf8bf0019,0x9f580216,0xe809016f}},	//   ltia, sség_, mbró_, वडता_,
   {{0xddcd0059,0x201a179d,0xe297c1da,0x7e6441db}},	//   ndaş, _lepi_, _лас_, ndip,
   {{0x6d4441dc,0x4427c1dd,0x25a0011c,0x5eff03b7}},	//   ntia, _bdn_, nzil_, _शून्_,
   {{0x201a010c,0xb4c298b8,0x81ae0264,0x6d4441de}},	//   _nepi_, ंवे_, কথা_, itia,
   {{0x3eadc1df,0x6d4441e0,0xf8bf0036,0x2caca906}},	//   biet_, htia, nsée_, ridd_,
   {{0x59aa09a3,0x6d44085c,0x3eadc1e1,0x4427abf0}},	//   _चेहर, ktia, ciet_, _edn_,
   {{0xbcfb00f7,0x7e6441e2,0xad9b41e3,0x6d4401c0}},	//   _tréi, ddip, _afún, jtia,
   {{0x443c8144,0x321d8035,0xf99f0037,0x201a2106}},	//   _ucv_, zawy_, rzè_, _cepi_,
   {{0x201a0205,0x7e6282c4,0x25a00122,0x2bcfa836}},	//   _depi_, _kaop, ezil_, _सुपा,
   {{0xa3be0074,0x38610192,0x7c3a8a53,0x644889ff}},	//   ुअन_, _wahr_, lgtr, lfdi,
   {{0x7bdc00ee,0x6d44022c,0x9419098d,0xad9b0032}},	// [2f30] _azru, gtia, ижат_, _efún,
   {{0x7c3ac1e4,0x3ead81a9,0x1dba0a27,0x00000000}},	//   ngtr, ziet_, _इशरत, --,
   {{0xd3710013,0x69c082a3,0xd9f995fe,0x321d8035}},	//   بها_, _axme, анец_, tawy_,
   {{0xddc9920e,0x7e629c18,0xa3e8064a,0x6aaf0122}},	//   vjež, _naop, मेध_, nicf,
   {{0x2bcf85e8,0xa92480e8,0x2bdb05fc,0xbcfb016a}},	//   _सुना, зділ, _भरवा, _arév,
   {{0x2003009a,0xa069942e,0x2909004f,0xd8388b80}},	//   ncji_, рака_, _mtaa_, _omču_,
   {{0x3eadc1e5,0x7d0d0137,0xe8d90870,0x645741e6}},	//   tiet_, lpas, _nsọ_, mexi,
   {{0x645741e7,0x44278ad4,0x6aa980b8,0x7e62c1e8}},	//   lexi, _sdn_, _umef, _caop,
   {{0x0c798e11,0x20030063,0x7d0d41e9,0xe8d901bc}},	//   асны_, kcji_, npas, _asọ_,
   {{0x64570baf,0x3eadc1ea,0x4b25a4c8,0x8d5c025f}},	//   nexi, siet_, омов, רכזי,
   {{0x6d44011e,0x3f678289,0xa49b2b5f,0x68fb8198}},	//   ztia, _uđu_, _atòk, _huud,
   {{0x201a41eb,0x7d0d06cb,0x316d8267,0x39ea2240}},	//   _sepi_, kpas, _krez_, идно_,
   {{0x6abd0661,0x7d0d090d,0x224d88f9,0x68fbc1ec}},	//   érfa, jpas, _mbek_, _juud,
   {{0x68fb8006,0x64b80a0d,0xfd62819d,0xf8bf1dac}},	//   _muud, _आदेश, _latị, ysée_,
   {{0x6b831647,0x7c648019,0xaac9a743,0x921983eb}},	//   ängl, _راول, िकाक, दराज_,
   {{0x6e3bbedb,0x6d4441ed,0x527633c2,0x316d8162}},	//   ngub, ttia, _фуку, _orez_,
   {{0x201a010b,0x7d0d10c1,0xddcd0085,0x64968087}},	// [2f40] _tepi_, gpas, rdaş, _mâin,
   {{0x3a3f8580,0x7698026b,0x61e6928a,0x224d82f9}},	//   _acup_, _díya, _úkli, _abek_,
   {{0x6d4441ee,0x2bcf816f,0x7d0d41ef,0xe1fa82ee}},	//   stia, _सुमा, apas, аге_,
   {{0x316d8db7,0x2005c1f0,0x7bdc016b,0x6d4441f1}},	//   _brez_, _afli_, _vzru, ptia,
   {{0xf8bf00e7,0x18748d8e,0x6f088144,0xc7b880fe}},	//   ssée_, згля, _stdc, _međe_,
   {{0x7e62a8e1,0xf72a9fbc,0xbcfb3477,0x24878247}},	//   _saop, аций_, _prév, _nonm_,
   {{0xab2741f2,0xd2598176,0x644e0372,0x7bdc41f3}},	//   _мора_, _djņb_, _ibbi, _uzru,
   {{0x660409c3,0xf5269af6,0x656941f4,0xc7b8826c}},	//   ncik, офон, _šehi, _neđe_,
   {{0x752437f2,0x7e9b03c8,0x22b601a9,0x20030035}},	//   nsiz, יסקו, cāki_, ycji_,
   {{0x7afc41f5,0x224041f6,0x60c200f7,0x62828009}},	//   _kurt, _acik_, _íomh, ljoo,
   {{0x660403ac,0x442a011c,0x316002d6,0xc60681e2}},	//   kcik, _mdb_, _asiz_, _дзей,
   {{0x6282c1f7,0x929401e2,0x39468084,0x752436b2}},	//   njoo, даюц, otos_, ksiz,
   {{0x394687a3,0x6e20c1f8,0x644e01e8,0x6ef58084}},	//   ntos_, mamb, _obbi, _išba,
   {{0x6e20c04e,0x3946af32,0x6ab786ab,0xc0cb3dac}},	//   lamb, itos_, _अद्र, руме_,
   {{0x58d41c8b,0x7d0d0037,0x14c78d1c,0xeeab1be5}},	//   форт, wpas, रकरण, атак_,
   {{0x644e41f9,0x7d0d0f33,0x39468612,0xc3338039}},	//   _abbi, tpas, ktos_, _חוק_,
   {{0x6457062f,0x7afc0102,0x6e20804f,0xa3e81130}},	// [2f50] texi, _aurt, iamb, मेस_,
   {{0x6e20bc07,0x644e026c,0xd5b80d8e,0xc954007c}},	//   hamb, _cbbi, іст_, _חמץ_,
   {{0x68fbc1fa,0x7afc1ee5,0xdce4016b,0x2a648326}},	//   _suud, _curt, cvič, _bamb_,
   {{0x7d0d41fb,0x68fb8006,0xbcfb087a,0x6e20a994}},	//   ppas, _puud, _brét, jamb,
   {{0x661d0bb6,0xa9698dfd,0x21390147,0x21698258}},	//   _iesk, сила_, nush_, сили_,
   {{0xa5bb01a8,0x7afc41fc,0xacfa01c6,0x26cf81a1}},	//   _ndói, _furt, _להשכ, _skgo_,
   {{0x44210812,0x661d0181,0x7afc41fd,0x2a6680e4}},	//   mah_, _kesk, _gurt, bdob_,
   {{0x4421059c,0x6e208f18,0xbcfb07ca,0x213900f1}},	//   lah_, gamb, _frét, kush_,
   {{0x661d41fe,0x3946c1ff,0x395f9295,0x2d8b82be}},	//   _mesk, ctos_, _usus_, âce_,
   {{0x44210859,0x23bf035a,0x6aad1ea2,0x7afc02d0}},	//   nah_, _एखाद, _amaf, _yurt,
   {{0x44214200,0x6e209e98,0x2d82804a,0xbb428190}},	//   iah_, bamb, øker_, неэк,
   {{0x44214201,0x661d4202,0x6e20a623,0x213902f7}},	//   hah_, _nesk, camb, fush_,
   {{0x44210812,0xed58804a,0xe80281d0,0x24878242}},	//   kah_, _мої_, रुका_, _tonm_,
   {{0x20cb9e0b,0xf8bf157a,0xdce421d1,0x450900ab}},	//   िविध, drés_, tvič, _লিংক_,
   {{0x442114ec,0x66e62804,0x661d4203,0x39468019}},	//   dah_, зова, _besk, ztos_,
   {{0xa5bb002a,0x661d1f01,0x752422f8,0x442a1a1f}},	//   _xeóg, _cesk, tsiz, _sdb_,
   {{0x4421059c,0x7afc4204,0xf8bf3b51,0x442a02f7}},	// [2f60] fah_, _surt, grés_, _pdb_,
   {{0x4421059e,0x7afc14ed,0x6e208dbb,0x7c218b81}},	//   gah_, _purt, zamb, nalr,
   {{0x6e209bcb,0xbcfb0036,0x7afc0085,0x6289810c}},	//   yamb, _brés, _qurt, _boeo,
   {{0x661d079f,0xbcfb0036,0x37d18264,0x254e0ec3}},	//   _gesk, _prét, াধার, tēlā_,
   {{0x44214205,0x22b8807a,0x6e20c206,0x62829bf1}},	//   bah_, nčki_, vamb, rjoo,
   {{0x44212254,0x98a395e0,0x6e208f0d,0x10a39017}},	//   cah_, ниче, wamb, ничн,
   {{0xb4d809a3,0x6e208545,0xfbc30221,0x7ae4291f}},	//   ाती_, tamb, _збро, _ohit,
   {{0x39468511,0x2bcf89a9,0x3da680e8,0x7e663d9c}},	//   ptos_, _सुधा, зроб, _jakp,
   {{0x6e20c207,0xa3e8009a,0x7e66419b,0xa49b4208}},	//   ramb, मेर_, _makp, _awòy,
   {{0x7ae42fc0,0x61e08bcf,0x7af60176,0x32068144}},	//   _ahit, _izml, _aiyt, lcoy_,
   {{0x6e208010,0x7ae40046,0xb5fb04be,0x623516cf}},	//   pamb, _bhit, _baál, мену,
   {{0x7ae44209,0x44214205,0x201e95c8,0xb4d8114f}},	//   _chit, zah_, _heti_, ातु_,
   {{0x4421355e,0x5bb903ca,0xa3d3000d,0xcfaa00ab}},	//   yah_, _आश्व, _हुन_, _খুলন,
   {{0x7ae40006,0x201e80ee,0x212d001b,0xa3b480e8}},	//   _ehit, _jeti_, šeho_, _облі,
   {{0xc7c40758,0x4421420a,0x4fc40ff7,0x661d04c4}},	//   ести, vah_, еста, _pesk,
   {{0x44210812,0xddc29807,0x443e95ce,0x201ec20b}},	//   wah_, _množ, lgt_, _leti_,
   {{0x4421059e,0x7e6603e9,0xbcfb046d,0x661d17ab}},	// [2f70] tah_, _dakp, _arér, _vesk,
   {{0x645abd75,0x6728830b,0x443e81e3,0x656f05b9}},	//   neti, _ovdj, ngt_, _vrch,
   {{0x4421059c,0xbcfb03d3,0x661d0025,0x6abd420c}},	//   rah_, _prés, _tesk, onsf,
   {{0xd3668077,0xb184826f,0xf8bf07f1,0xdd9501e5}},	//   _یه_, _šťas, prés_, _жамы,
   {{0x442137b4,0x656f0c41,0x201e8102,0x22b601a9}},	//   pah_, _urch, _beti_, cāku_,
   {{0x68ff02c1,0x443e8a0f,0x44210455,0xe7e41344}},	//   _muqd, jgt_, qah_, _गरमा_,
   {{0x645ac20d,0x201e8038,0xbcfb420e,0x65628a03}},	//   deti, _deti_, _trés, _asoh,
   {{0x443ec20f,0x22b600eb,0x2d9596ba,0x68f701b4}},	//   egt_, nākt_, дрос, _lixd,
   {{0xdddd009a,0x62988029,0x7c218c44,0x3a2d810c}},	//   _hasł, īvot, talr, _idep_,
   {{0x7ae44210,0x443ec211,0x7305816c,0x201e807b}},	//   _shit, ggt_, мпоз, _geti_,
   {{0xe1ff05e4,0x9c87001b,0x7fb980d7,0x60c481a8}},	//   rdón_, _začá, _بهار_, éime,
   {{0xd5ae8bca,0x443e8a0f,0xe2970c73,0x648d81a8}},	//   افی_, agt_, даю_, _cúir,
   {{0x645ac212,0x648d80f7,0x8c458dbd,0x7c2988ed}},	//   beti, _dúir, _желе, _долг_,
   {{0x7ae40039,0x645ac213,0x7e664214,0x22b882d4}},	//   _whit, ceti, _sakp, rčki_,
   {{0x6d499a29,0x61fbc215,0x7ae44216,0x7e664217}},	//   ltea, _ogul, _thit, _pakp,
   {{0xe8d90028,0x61fbc218,0x7e69a7d1,0x7ae42637}},	//   _trở_, _ngul, ndep, _uhit,
   {{0x3ea01384,0x6fe71a1f,0x17fa01a8,0x75d30174}},	// [2f80] rhit_, técé, _وردة_, نيفا,
   {{0x62860024,0x61fbc219,0xb4d800dc,0xc7b8805c}},	//   ljko, _agul, ाते_, _leđa_,
   {{0xe814053e,0xa3e8101c,0x307b0039,0x201ec21a}},	//   _त्या_, में_, _ואינ, _reti_,
   {{0x645ac21b,0x673c16f2,0x201ec21c,0xe9da8b41}},	//   zeti, murj, _seti_, оке_,
   {{0x443e8bfa,0xbcfb00e7,0xba480110,0x645ac21d}},	//   ygt_, _fréq, _grįž, yeti,
   {{0xd00f8624,0xf2bb1a3b,0x3a2da4a8,0x6d4980f7}},	//   لله_, _उद्घ, _edep_, dtea,
   {{0x201ec21e,0x290d8118,0x36d48878,0x321f8176}},	//   _veti_, _etea_, нокр, _feuy_,
   {{0xebe317ae,0xcfc000ab,0x6e24421f,0x769c810c}},	//   _росп, _ইরান, naib, _béya,
   {{0x645ac220,0x1ee88065,0x8146803d,0x63ae0084}},	//   teti, _ہوئی_, _زنان, žinė,
   {{0xe57100be,0x2bcf8c2d,0x443ec221,0x61fb8140}},	//   אַט_, _सुहा, ugt_, _zgul,
   {{0x443ec222,0xd6cfbe29,0x6e24009c,0xc7b8826c}},	//   rgt_, _ат_, kaib, _feđa_,
   {{0x645a825b,0x3a2008e9,0x6e2410e1,0x656280a4}},	//   seti, _ceip_, jaib, _tsoh,
   {{0x7c2e28e1,0x659691cc,0x6d49a9de,0xbcfb002a}},	//   _odbr, _تجار, ctea, _asén,
   {{0xe3af95e4,0x29000980,0x69b1820e,0x2bcfa769}},	//   اری_, _duia_, _आइसी, _सुवा,
   {{0xf3638048,0xf1b98916,0xbddb026b,0xceb40085}},	//   _атын, _meša_, _abèp, fiə_,
   {{0x1de285b3,0x76408683,0xdddb9487,0x6e240fd2}},	//   _परात, ngmy, ljuš, gaib,
   {{0x29004223,0x3d1a001b,0xd7fb1a4a,0x7d0d83ed}},	// [2f90] _guia_, मीले_, _мун_, _çast,
   {{0x2a692d81,0xdddb80fe,0x66de83ed,0x61e01238}},	//   _haab_, njuš, këko, ümle,
   {{0x5fae8076,0x656d1e71,0x5a3595fd,0x6d498102}},	//   _झेलल, svah, енет, ztea,
   {{0x6e244224,0x38ad0267,0x6aa28428,0x99920176}},	//   caib, džri_, ghof, _deyņ_,
   {{0x7e6980e1,0xc7b881a1,0x49b8803d,0xa3b40c33}},	//   vdep, _ređa_, واهد_, _जेठ_,
   {{0x2bbe170c,0xfc4e827d,0x2a690df6,0xf09f07f1}},	//   ्थशा, _sửng_, _laab_, mpàs_,
   {{0xb906800d,0x46f5a856,0x7c254225,0xe7399480}},	//   _यी_, нчит, mahr, чей_,
   {{0x6d49ac77,0x2a6901c0,0x6aa281f8,0x61fb011f}},	//   ttea, _naab_, chof, žulj,
   {{0x81b400c8,0x7e69c226,0xee368048,0x2d99c227}},	//   _জুন_, rdep, хны_, áse_,
   {{0x6d49a174,0xb21b006a,0x31788019,0x442e8a03}},	//   rtea, sjæl, _تحفظ_, _cdf_,
   {{0x6d49c228,0x7a6a1c79,0x2bcf9a46,0x03228162}},	//   stea, пинг_, _सुशा, лдэн,
   {{0x9cea8117,0x6d49c229,0x51f70065,0x7c2500b9}},	//   _ہونے_, ptea, کسپر, hahr,
   {{0xbddb00e7,0x349581e2,0x442ec22a,0x2bcf8c2d}},	//   _scèn, _падр, _fdf_, _सुरा,
   {{0x92c200c8,0x6f018019,0x442e8350,0x7c250192}},	//   ্গে_, _kulc, _gdf_, jahr,
   {{0x6e24422b,0x3a200356,0x61dc801b,0x7bd88084}},	//   taib, _teip_, _बर्ष, _gyvu,
   {{0xb4d80e70,0x6609c22c,0x3ebf8364,0xbcfb02be}},	//   ात्_, ncek, nnut_, _prép,
   {{0x7c250352,0x6e24212b,0xed5700a9,0x69c10214}},	// [2fa0] fahr, raib, нот_, şler,
   {{0x6441c22d,0x03a60604,0x6e24422e,0xa3be00d4}},	//   ngli, низо, saib, ुअल_,
   {{0x2018422f,0xdce98353,0x6e240637,0x2a6901b4}},	//   mbri_, jveč, paib, _yaab_,
   {{0x4425c230,0x2ebd0a74,0xe814081f,0xfaa39986}},	//   hal_, ्कृत, _त्ता_, лахо,
   {{0x4425c231,0x7d043557,0xaca384be,0x26d208ce}},	//   kal_, qqis, _ayọk, moyo_,
   {{0x6cd600f7,0x6aa2c232,0x7c2e006a,0xfbd10019}},	//   _أقسا, shof, _udbr, اتے_,
   {{0x442e9c88,0x59dc800f,0xf1b9825b,0x82a680e8}},	//   _rdf_, _बरकर, _veša_, _завж,
   {{0x3ebf8052,0x6f01c233,0x645e4234,0x61e40bcf}},	//   gnut_, _dulc, lepi, _ozil,
   {{0x4425c235,0x8ffa826a,0xfd0f853d,0x26c04236}},	//   fal_, _فرار_, یجی_, inio_,
   {{0x2a690006,0x4425c237,0xc5f30158,0x645e4238}},	//   _saab_, gal_, נדז_, nepi,
   {{0x2a6901c0,0x34b7025f,0x61e44239,0xc61f8264}},	//   _paab_, תפים_, _azil, _ধারা_,
   {{0x6ee5c23a,0x4425a82a,0x645e423b,0xa3d30d86}},	//   tóbe, aal_, hepi, _हँस_,
   {{0x26c0423c,0x44259357,0xa3e481a2,0x672a804a}},	//   dnio_, bal_, पेज_, lsfj,
   {{0x44259966,0x645e120e,0x7c2d8300,0x26c0423d}},	//   cal_, jepi, _ɓark, enio_,
   {{0x645e423e,0x7ea30074,0xdfd521f6,0x61e4423f}},	//   depi, _lõpe, товы, _ezil,
   {{0xa3e705b3,0xd6d83fe7,0x7bdb84de,0x7c2501ec}},	//   _परब_, ету_, _מקוו, wahr,
   {{0x661d8125,0xa2ce1391,0x2d5802c7,0x7d02827e}},	// [2fb0] ðski, सवर्, нить_, _juos,
   {{0x6ac98f21,0x2d870e78,0xc60d8f12,0xc7b8826c}},	//   िक्र, ćne_, _सभ्य_, _neđo_,
   {{0x212b1cb6,0x2be60072,0x7d1d8e06,0x26d24240}},	//   lsch_, _करणं_, ássz, boyo_,
   {{0x4425c241,0xc5fe8ec3,0xe8d91029,0x00000000}},	//   zal_, šējo_, _trồ_, --,
   {{0x7d028110,0x212b0b2f,0x62999c11,0x68faa08e}},	//   _nuos, nsch_, rkwo, _bitd,
   {{0x6f01c242,0x7e6d4243,0x4425865f,0xf1b981a1}},	//   _pulc, ldap, xal_, _fešn_,
   {{0x2bb80013,0x23cfae06,0x6d4d4244,0x46a58abe}},	//   _كافة_, _सुंद, ltaa, какв,
   {{0x7e6d0393,0x44234245,0x44312b1f,0x6d4d05ee}},	//   ndap, _hej_, _hdz_, otaa,
   {{0x6d4d4246,0x64418352,0x6e22bf21,0xc05b80e8}},	//   ntaa, tgli, _deob, _ніж_,
   {{0x44231bae,0xeb99997b,0x1fa790ca,0xd90d8077}},	//   _jej_, дио_, _прег, _هیچ_,
   {{0x4425c247,0x44234248,0x28b685b3,0xfaa64249}},	//   ral_, _mej_, _अगति, вано,
   {{0x4423424a,0x645e0063,0xddc4002e,0x64418114}},	//   _lej_, zepi, ndiţ, sgli,
   {{0x6455003a,0x81d380ab,0x7afb8061,0x672481a1}},	//   _obzi, হের_, _miut, ćije,
   {{0x4423424b,0x7e7d424c,0x4425b81f,0xe3b99bc1}},	//   _nej_, _ansp, qal_, _обл_,
   {{0x26c0009a,0x6e228101,0x26d205ee,0x03a2804a}},	//   tnio_, _yeob, toyo_, _вищо,
   {{0x7c238082,0x6455271c,0x443102b6,0xc6c309a8}},	//   _henr, _abzi, _adz_, айск,
   {{0x6d4d2a22,0x7e6b849f,0xa2c0800f,0x26d23bb0}},	// [2fc0] gtaa, _magp, लचस्, royo_,
   {{0x7afb8698,0xeb9a07b6,0x26c0424d,0x7e7d03ec}},	//   _aiut, миз_, snio_, _ensp,
   {{0x442301e9,0x8fa61287,0x6d4d057b,0x645e16d8}},	//   _dej_, _ране, ataa, repi,
   {{0xe2978554,0x7ae9b86c,0x7afb87e2,0x7e6b97ef}},	//   ках_, _chet, _ciut, _nagp,
   {{0x6d4d2f26,0x7ae981e4,0x7ceb01ec,0x6e228980}},	//   ctaa, _dhet, dürf, _reob,
   {{0x442314da,0xf7728b8c,0x212d8353,0xaca4019d}},	//   _gej_, لاع_, _dveh_, _kpọs,
   {{0x7d028364,0xb17d81ac,0x6b8305ec,0x6d5986c4}},	//   _suos, _vzťa, ängt, _apwa,
   {{0x7644424e,0xa3e7035a,0x4444424f,0x7afbc250}},	//   ngiy, _परत_, lg_, _giut,
   {{0xceb3004c,0x44444251,0xa2cf83eb,0xade380e8}},	//   ייה_, og_, धकर्, ицьк,
   {{0x7d028364,0x68fa85f8,0xb4ccc252,0xb86582e3}},	//   _vuos, _uitd, लवे_, _مامو,
   {{0xdeef9641,0x444420a4,0xa2951ae5,0x387e8012}},	//   _вы_, ig_, гані, _intr_,
   {{0x29048a73,0x7bdc03ac,0x7d028009,0x98b1026c}},	//   _kuma_, _myru, _tuos, _čađu_,
   {{0xf2d38158,0xe53487ac,0x2904c253,0x386cc254}},	//   שער_, _сель, _juma_, _kadr_,
   {{0x44440a0f,0x212b4255,0x2904c256,0x25a904e8}},	//   jg_, rsch_, _muma_, vzal_,
   {{0x6d408086,0x87040698,0xb8cb198e,0x29048b09}},	//   luma, ияте, _खत_, _luma_,
   {{0x44444257,0x7c28c258,0x7e60a5e0,0x6d4d0009}},	//   eg_, ladr, nemp, ttaa,
   {{0x6d40c259,0xdef8259a,0x7e6d14ff,0x44230069}},	// [2fd0] numa, тыр_, rdap, _pej_,
   {{0x4444021e,0x6d4d2a57,0x7e60c25a,0x7ae9adef}},	//   gg_, rtaa, hemp, _shet,
   {{0x6d4d06dc,0x6d40c25b,0x50b80624,0x44230022}},	//   staa, huma, _جديد_, _vej_,
   {{0x4444425c,0x6d40be95,0x6d4d059c,0x7e60c25d}},	//   ag_, kuma, ptaa, jemp,
   {{0xdd868b8c,0x4423425e,0x7c28b962,0x6d40c25f}},	//   _او_, _tej_, kadr, juma,
   {{0x98e580f7,0x7c2880e1,0x6d40c260,0x6b8305ec}},	//   دكتو, jadr, duma, ängs,
   {{0x7e6b9856,0xa3e72b62,0x005804de,0x22490214}},	//   _pagp, _परि_, דשות_, _ocak_,
   {{0xdb240307,0x660d01bf,0x6d40b9fe,0x7c23a6f9}},	//   _úsái, ncak, fuma, _senr,
   {{0x6d40c261,0xb5fd920e,0x752d2a4d,0x41b780d4}},	//   guma, ješe, nsaz, _अधिस,
   {{0x64451023,0x3485976e,0x2a7f90af,0x224901bf}},	//   nghi, угог, _hnub_, _acak_,
   {{0x7c23862f,0x94758077,0x7e6bc262,0x64450014}},	//   _venr, ندگا, _tagp, ighi,
   {{0xc86902f6,0x6d40c263,0x7e6089c4,0x200100e5}},	//   _מן_, buma, cemp, _aghi_,
   {{0x661bbbab,0xf2d2810f,0x7c23c264,0x7bcaa4a3}},	//   mbuk, מעט_, _tenr, _exfu,
   {{0x91030628,0xb4bf000d,0x7c28c265,0x91ba8039}},	//   спре, ुको_, cadr, תמשי,
   {{0x2d8f1bc0,0x3f9e026f,0xb4c199e8,0xb8dc26ee}},	//   ägen_, átu_, ्की_, _आग_,
   {{0x444401c5,0x6b9c8edd,0x661bc266,0x2bb28697}},	//   wg_, ørge, nbuk, ुपरा,
   {{0x83fc8025,0x44444267,0x394d8069,0x6aa4004f}},	// [2fe0] ređe, tg_, _nqes_, _ilif,
   {{0x444401e9,0x7e60b937,0xf0664268,0x2904c269}},	//   ug_, zemp, _скоп, _ruma_,
   {{0xe29ab93f,0x7e60932c,0xd62a0098,0xeb9707b6}},	//   наж_, yemp, _поне_, лиф_,
   {{0x44440046,0x6d40ad80,0x094a9505,0x386c80fc}},	//   sg_, yuma, ечки_, _sadr_,
   {{0x78b885a2,0x5f76053d,0x38a2807b,0xa3e80697}},	//   tivv, _شاگر, _aðra_, मेज_,
   {{0x4b26136d,0x386cc26a,0xddc2817f,0x2ee00713}},	//   _معرف, _qadr_, _naoš, llif_,
   {{0x6aa43ca6,0xd6d0a0bb,0x394206ae,0x3a24bf3c}},	//   _olif, يقت_, huks_, _temp_,
   {{0x1d349194,0xa534a748,0x661b9fdb,0x6b83016d}},	//   ания, анич, gbuk, ånge,
   {{0x7e60c26b,0x6280b724,0x22938013,0x656d826c}},	//   remp, _inmo, _القس, _šahr,
   {{0x6d40c26c,0x7e608821,0xd5638698,0x6aa4426d}},	//   ruma, semp, стъп, _alif,
   {{0x2ee00059,0x6d40c26e,0x661baceb,0xf8bf0e06}},	//   klif_, suma, bbuk, ssék_,
   {{0x2246c26f,0x7c28879f,0x6d40c270,0x753b8037}},	//   ngok_, sadr, puma, bruz,
   {{0x629d06be,0xc05b035f,0x753b9e00,0x7c28c271}},	//   rkso, нів_, cruz, padr,
   {{0x6fd60540,0x2a6d001b,0x6aa44272,0xdced011f}},	//   _मुहू, žeb_, _elif, tvač,
   {{0x62808629,0xb5fd8916,0x7d064273,0xa3b4123a}},	//   _onmo, reše, _auks, _जेल_,
   {{0x7d064274,0x7d0d80f7,0xb4bf064a,0xddc28390}},	//   _buks, _éasc, ुक्_, _zaoš,
   {{0x660d4275,0x7aed4276,0xa3b8816f,0x6e261699}},	// [2ff0] rcak, _ihat, _घेत_, _dekb,
   {{0x6280c277,0x660d4278,0x752d2d08,0x68fe0122}},	//   _anmo, scak, rsaz, _gipd,
   {{0x7aed393e,0x6445180b,0x752d4279,0xb4b51344}},	//   _khat, rghi, ssaz, _जगी_,
   {{0x660291e8,0x7ceb427a,0xa3be903e,0x19b98110}},	//   _ngok, würd, _ेशन_, куль_,
   {{0x2169869b,0xa9698258,0x7aed01e4,0xa5bb0118}},	//   тили_, тила_, _mhat, _xeól,
   {{0xe739ab3f,0x7c8701bb,0xf4870221,0x3ea90061}},	//   век_, _суме, _сумн, lhat_,
   {{0xe8d901bc,0x7aed427b,0x75229210,0x07a59f50}},	//   _apị_, _ohat, _awoz, райн,
   {{0x7aed2ae3,0x753baa4d,0x8d55a138,0x7d0636b2}},	//   _nhat, truz, аточ, _yuks,
   {{0x661b94ec,0x7e6f051e,0x315880f7,0x78478019}},	//   rbuk, _macp, _مجلة_, _مضام,
   {{0x753ba579,0xdd99952c,0x6602811e,0xb4c19299}},	//   rruz, ryň_, _egok, ्के_,
   {{0xe2860fe7,0x61e10201,0x23cf85fc,0x7aed01e4}},	//   ални, əlli, _सुखद, _bhat,
   {{0x7f438098,0x753b82a5,0x39420074,0x25b6803d}},	//   munq, pruz, tuks_, اهید_,
   {{0x7aed427c,0x6e260ae6,0x7f438081,0xcad68039}},	//   _dhat, _rekb, lunq, שורת_,
   {{0x8c428c4f,0x7c2701d0,0x7d06427d,0x7ebe9d46}},	//   _деше, _nejr, _ruks, rūpe,
   {{0x7d06427e,0x6d5d06f7,0xd62a205f,0x8c2400ab}},	//   _suks, _apsa, кове_, _পালন_,
   {{0x4427c27f,0xa3ea8076,0x3ea94280,0xa5bb0207}},	//   _hen_, _मरत_, ghat_, _teól,

   {{0xcbe20a49,0x4427c281,0x0c260103,0xe9df01df}},	// [3000] _বলেছ, _ken_, иман, lgún_,
   {{0x4427800d,0xac83176e,0x7d060bcf,0x25adb075}},	//   _jen_, огул, _vuks, izel_,
   {{0x44278039,0xa3d30063,0xe9df040e,0x6e264282}},	//   _men_, _हुआ_, ngún_, _tekb,
   {{0x4427b404,0x3ea94283,0x7d064284,0x5b5683de}},	//   _len_, chat_, _tuks, ישען_,
   {{0x7c27006a,0x6d5d011b,0x19588a41,0x4427c285}},	//   _fejr, _gpsa, уалы_, _oen_,
   {{0xb4c18023,0x61e980eb,0x64a64286,0xddcd0493}},	//   ्को_, _dzel, _тага, leaş,
   {{0x61e9c287,0x25ada948,0x6d440493,0xb4c181d0}},	//   _ezel, ezel_, luia, ्कै_,
   {{0x83fc920e,0x3ea04288,0x442782f9,0xe297b73a}},	//   jeđa, nkit_, _aen_, _кас_,
   {{0xe8fa8c9b,0x3b078216,0xc7b881f4,0x74c68081}},	//   _ала_, _aunq_, _međi_, ищож,
   {{0x7aed2e93,0x44278e3a,0x7ae2c289,0xaa1f001b}},	//   _shat, _cen_, llot, पर्छ_,
   {{0x44278257,0xb4790158,0x7aed428a,0x9e668b88}},	//   _den_, אָרי, _phat, _введ,
   {{0x44279302,0x96fa8829,0xd90f1ab3,0x6b81428b}},	//   _een_, _شعار_, ویب_, _álge,
   {{0xa3d30063,0x4427b778,0xad9b0032,0x7ae28037}},	//   _हुई_, _fen_, _agún, ilot,
   {{0x44278f23,0xa8a416d9,0x7aed2c04,0xa3e70074}},	//   _gen_, орск, _what, _परल_,
   {{0x7c658288,0x7aed428c,0x442cc28d,0xb5fdc28e}},	//   _دانل, _that, mad_, meša,
   {{0x442780ad,0x93fb8158,0x7c27428f,0x442cc290}},	//   _zen_, _בלוי, _sejr, lad_,
   {{0x44278077,0x3ea94291,0x78bc0118,0xad9b0091}},	// [3010] _yen_, rhat_, birv, _egún,
   {{0x442c888b,0x442700f7,0x3ea94292,0xe8d901bc}},	//   nad_, ún_, shat_, _kpọ_,
   {{0x61e98019,0x7c27006a,0x3ea68722,0x6448809c}},	//   _szel, _vejr, _olot_, igdi,
   {{0x442cc293,0xdd910065,0x3ea04294,0x42d8902a}},	//   had_, _فوج_, ckit_, афія_,
   {{0x8d8707a1,0x290101e0,0x777a8102,0x6d440162}},	//   _тунд, _kiha_, _artx, cuia,
   {{0x4174819f,0x442c8665,0xb5fd920e,0x6e2d02a3}},	//   غانس, jad_, ješa, laab,
   {{0x442cc295,0x4427b665,0xb5fd8024,0x290104c4}},	//   dad_, _ren_, deša, _miha_,
   {{0x4427c296,0xa3d30d38,0x6e2d02ec,0x3ea6abd5}},	//   _sen_, _हुए_, naab, _clot_,
   {{0xddc60db7,0x17e40697,0x442cc297,0xf2d280be}},	//   _kakš, _गर्व_, fad_, _זען_,
   {{0x442cc298,0x3eb900b9,0x44278168,0xdce28115}},	//   gad_, _lmst_, _qen_, _brođ,
   {{0xe29a2118,0x4dde03bb,0xc62680c8,0x3ea6813c}},	//   ган_, _कुनै_, _যারা_, _flot_,
   {{0x4427c299,0x3a290219,0x6e2d01b4,0x7c3b00fc}},	//   _wen_, _ceap_, jaab, _ɓura,
   {{0x442cc29a,0x83fc8904,0xc7b881a1,0x442781c6}},	//   bad_, ređa, _ređi_, _ten_,
   {{0x7d1bc29b,0x442cc29c,0xb5fd85a2,0x7cf002f1}},	//   mpus, cad_, ceša, märg,
   {{0x2bcf8d14,0x2901033e,0x31ae8061,0x78bc008b}},	//   _सुचा, _diha_, _közé_, rirv,
   {{0x539a84de,0x7649c29d,0x422619a5,0xb2261ad0}},	//   _תיקו, ngey, _удив, _умил,
   {{0x395f81c0,0x290101b9,0x3ea01619,0x7e64429e}},	// [3020] _npus_, _fiha_, rkit_, reip,
   {{0x6296429f,0x3ea02d5c,0xbcfb026b,0x61e08338}},	//   _hoyo, skit_, _apéb, _ryml,
   {{0x395fc2a0,0x2d8f006a,0x6e2d1a25,0x62961a85}},	//   _apus_, øger_, baab, _koyo,
   {{0x442c825b,0x20058098,0x63ae1487,0x6e2d0079}},	//   zad_, _agli_, _đinđ, caab,
   {{0x442caa22,0x6d4426f0,0xc05a85a8,0x629605fe}},	//   yad_, quia, гій_, _moyo,
   {{0x7ae2838e,0x940736ae,0x987a00be,0x28f89b53}},	//   slot, _герб_, ראַט, шель_,
   {{0x442cacdd,0x7ae2870d,0x443842a1,0xb4d442a2}},	//   vad_, plot, _idr_, हकी_,
   {{0x442a42a3,0x442cc2a4,0x20058081,0xe6668ea6}},	//   _heb_, wad_, _egli_, стко,
   {{0x442cc2a5,0x442a42a6,0x7d1babb9,0x7c3c8511}},	//   tad_, _keb_, gpus, órro,
   {{0xdce2805c,0xfd4d0135,0x442a00eb,0x26dd81bc}},	//   _prođ, _achị, _jeb_, _ekwo_,
   {{0x442cc2a7,0xef1a95fd,0x443842a8,0xf1b9979d}},	//   rad_, _сме_, _mdr_, _reši_,
   {{0x442cc2a9,0x442a42aa,0x6e2d0079,0xe8d9001c}},	//   sad_, _leb_, xaab, _trừ_,
   {{0x645c26f0,0x588707ac,0xb5fdc2ab,0x81da80ab}},	//   _obri, быва, peša, ডের_,
   {{0x442a3ca3,0x224d42ac,0x6e2d0ef2,0x442c9669}},	//   _neb_, żek_, waab, qad_,
   {{0x49930077,0xdce280d2,0x6e2d257a,0xdbf1001b}},	//   زیگر, _urođ, taab, _přím,
   {{0x629604b9,0x237f05f3,0x59da3947,0x6284051e}},	//   _goyo, _čuj_, _युवर, _gnio,
   {{0x38ab8aa2,0x442a028d,0xca380039,0xd8388267}},	// [3030] _høre_, _beb_, _הנחה_, _elči_,
   {{0x39468c52,0x38ab813c,0xa3cc809a,0x6e2d1a25}},	//   duos_, _køre_, _रखा_, saab,
   {{0x442a42ad,0x395f802e,0xb5fd920e,0x62960010}},	//   _deb_, _spus_, ješn, _yoyo,
   {{0x645c0114,0x442a42ae,0x7c2ac2af,0x38ab80e8}},	//   _ebri, _eeb_, _lefr, _møre_,
   {{0xc7b88025,0xddc60353,0x3946c2b0,0x2bd90105}},	//   _među_, _takš, guos_, _बुरा,
   {{0xb608003e,0x7cf0016d,0x6d40825b,0xb5fb0032}},	//   _vyšš, gärd, drma, _abág,
   {{0x6d40a525,0x7cef83ba,0x26c90c93,0x44210865}},	//   erma, nøre, onao_, mbh_,
   {{0x442a01c5,0x6f0294ed,0x44210046,0x6aa28c54}},	//   _zeb_, _cioc, lbh_, ckof,
   {{0xa2d68b84,0x44210ad0,0x1a6880d5,0x764982a3}},	//   यकर्, obh_, _دینی_, rgey,
   {{0x40349ddf,0x44210cb5,0x442a022c,0x6569c2b1}},	//   _неус, nbh_, _xeb_, rweh,
   {{0x61ed42b2,0xda6634d6,0x4421152f,0x6d40c2b3}},	//   _azal, овни, ibh_, arma,
   {{0x6f028698,0x2a720079,0xc3320496,0x38ab8366}},	//   _gioc, _qayb_, ווט_, _døre_,
   {{0xdce9803b,0x7cf012d2,0x3ead9f20,0x7de791cc}},	//   jveć, läre, mhet_, _اسام,
   {{0x2ee20ebf,0x03a598a2,0x7c2a9ab0,0x7cef8b40}},	//   पत्त, _мило, _gefr, føre,
   {{0x38ab8022,0x7d0bb6bd,0x656f42b4,0x7cf00884}},	//   _gøre_, _hugs, _asch, näre,
   {{0x442a42b5,0xe61a197b,0x3eada5be,0x7d03c2b6}},	//   _seb_, рда_, nhet_, _hins,
   {{0x442a146a,0x7d03c2b7,0x6e2b8019,0xe1ff0511}},	// [3040] _peb_, _kins, _megb, león_,
   {{0x7d03c2b8,0x6e2bc2b9,0x6aa9846d,0x442a0069}},	//   _jins, _legb, _alef, _qeb_,
   {{0x7d03c2ba,0xbcfb03d3,0x7cf02e6d,0x8b6a0009}},	//   _mins, _spéc, värd, риев_,
   {{0x442a3c72,0x6aa9c2bb,0xf99f00e7,0x4421032f}},	//   _web_, _clef, ccès_, abh_,
   {{0x442a10af,0x644302ba,0x3eadc2bc,0x443802f7}},	//   _teb_, ónic, dhet_, _tdr_,
   {{0x98a39194,0x7d03c2bd,0x7cf0016d,0x2a6690e4}},	//   миче, _nins, färe, seob_,
   {{0xf093093f,0x7d0b8029,0xfaa68084,0xb86580f7}},	//   ונג_, _augs, _даво, ثانو,
   {{0x7d03adb3,0x3ead904d,0x60dc0057,0x7d0b9a76}},	//   _ains, ghet_, horm, _bugs,
   {{0x61e4019f,0x6d561072,0x60dc0061,0x7d03c2be}},	//   _nyil, ntya, korm, _bins,
   {{0x26c9003b,0xb5fd9734,0x59c086b7,0x7d038b16}},	//   znao_, pešn, _शेयर, _cins,
   {{0x7d03c2bf,0x61ed2422,0xdee69285,0x6f028635}},	//   _dins, _szal, _дожи, _tioc,
   {{0x7d03c2c0,0x2bbd0bb8,0x3eadbfb6,0xddcd0162}},	//   _eins, ्पता, chet_, ndaţ,
   {{0x7d03b43f,0x672d812b,0x26c9017f,0x61e40a03}},	//   _fins, ćaje, vnao_, _cyil,
   {{0x7d03c2c1,0x1c0e8fd5,0x7cef8aa2,0xf7730c48}},	//   _gins, _सलिल_, tøre, واز_,
   {{0x09b7885d,0xb4e6816f,0x788080e1,0xeabf00e5}},	//   _अध्य, पती_, _závä, più_,
   {{0x7d03c2c2,0x9d15176e,0x7cef83ba,0x69da0162}},	//   _zins, здач, røre, ştea,
   {{0x61ed035c,0x6d5602d5,0x7d03b6ba,0x5fdb2a2b}},	// [3050] _uzal, gtya, _yins, _मुरल,
   {{0x3eadc2c3,0xd37b42c4,0xde8f80ff,0x92c780ab}},	//   zhet_, иче_, _kịch_, _উঠে_,
   {{0x44210ad0,0xdce9803b,0xf8bf00e7,0xd7df816f}},	//   rbh_, sveć, ssés_, _पुढच,
   {{0x1dca82f1,0x656f3a3c,0x69c000d4,0x442142c5}},	//   ापात, _tsch, _लेडी, sbh_,
   {{0xde8f8104,0x249817af,0x656f1075,0xa92480e8}},	//   _lịch_, _form_, _usch, дділ,
   {{0x3cf6800f,0xc5fa0039,0x7d0b8110,0x6ee581df}},	//   ीदों_, _לפרט, _rugs, móbi,
   {{0x6562c2c6,0x656d42c7,0x248980ff,0x3eadc2c8}},	//   _apoh, lwah, _đam_, thet_,
   {{0x32090028,0x764d42c9,0x7d03c2ca,0x6abb8cb7}},	//   _ngay_, ngay, _sins, _umuf,
   {{0x3eadc2cb,0x7d03c2cc,0x3ebf80f1,0x656d42cd}},	//   rhet_, _pins, riut_, nwah,
   {{0x2ca991b3,0x3eadc2ce,0x32090bb1,0x6e2b9591}},	//   скоп_, shet_, _agay_, _wegb,
   {{0x3c21811b,0x7d039020,0x61e403ac,0x60dc1e7a}},	//   _vгv_, _vins, _syil, vorm,
   {{0xde8f8104,0x7d039412,0x656d0518,0xa96a419a}},	//   _dịch_, _wins, kwah, бима_,
   {{0x290580f6,0xb7bc8029,0x7d0381b9,0x49990198}},	//   _kila_, _reģi, _tins, отря_,
   {{0x23bd1d40,0xa3ab0b85,0x764d0ef2,0x320902c4}},	//   ्पाद, गना_, egay, _egay_,
   {{0x17790364,0xfaa634c4,0x29058695,0xd00f1a00}},	//   ость_, _нако, _mila_, الف_,
   {{0x60dc2cf0,0x539a81c6,0x6b9c9d31,0xf77283de}},	//   sorm, _ליצו, ärge, עקן_,
   {{0x60dc10c1,0xb5fb0118,0xa11300f7,0xdb0d01d6}},	// [3060] porm, _abáb, _كويت, ľkým,
   {{0x290584d2,0x6aac1244,0xb17b03c8,0xf8a5826a}},	//   _nila_, _चतुर, _פטיר, _شک_,
   {{0x389b0f60,0x249842cf,0x309b0039,0x6d5618ac}},	//   _היינ, _vorm_, _השימ, stya,
   {{0x2905ab40,0xf1e10424,0xe9f90091,0x3a2d8197}},	//   _aila_, _गुड़_, _alẹ_, _ceep_,
   {{0xbefa000f,0x6e240365,0x249842d0,0x055523e7}},	//   ्दीन_, mbib, _torm_, _отря,
   {{0x2905820f,0x6e24004a,0xa3cc82f1,0x7ceb22f8}},	//   _cila_, lbib, _रखल_, nürl,
   {{0x36d4af49,0x38cb815b,0xa8570039,0x2905bcb2}},	//   мокр, حانی_, פיקה_, _dila_,
   {{0x877b00be,0x6e2405ee,0x6d4412a5,0x7c2e4290}},	//   מאצי, nbib, oria, _hebr,
   {{0x6ce681e5,0x6d49818a,0x29058558,0x614396cf}},	//   зіне, guea, _fila_, _пета,
   {{0x29058057,0x6d4442d1,0xf1b981a1,0xd00f81a8}},	//   _gila_, iria, _vešt_, _ملك_,
   {{0xe45700be,0x6d4442d2,0xccf881d0,0x7ceb02d0}},	//   הייט_, hria, rmě_, dürl,
   {{0x2905be50,0xa3bd8035,0x6d442f52,0xdc02936f}},	//   _zila_, _इधर_, kria, _učím,
   {{0x867b8039,0xc50a80f7,0x6d441b6b,0x69da0087}},	//   _לראו, _اتصل_, jria, şten,
   {{0xddeb893f,0xb1138a2c,0x200c35ca,0x6d4442d3}},	//   _פֿאָ, wụkw, ždin_, dria,
   {{0x7127026a,0x7b0681d0,0xd7f808b0,0x443c81e8}},	//   _کربل, ístě, зут_, _idv_,
   {{0xdce4003b,0x56941d85,0x442e8125,0x6e2402b8}},	//   dviđ, наст, _hef_, gbib,
   {{0x7c2e1c2c,0x1df801bb,0x764d42d4,0x5c990fe6}},	// [3070] _bebr, зеты_, rgay, окая_,
   {{0x7c2e42d5,0xd01104c1,0x656d42d6,0xe8d30065}},	//   _cebr, _جلد_, rwah, _سمجھ,
   {{0x656d42d7,0xdced0a20,0x7c2e0eb9,0x98ab0087}},	//   swah, hvać, _debr, ască_,
   {{0x2905c2d8,0x38af0192,0x442ec2d9,0x3f57011c}},	//   _sila_, _würd_, _lef_, mçu_,
   {{0x29059341,0x6d44041c,0x63ad8326,0x3f57011c}},	//   _pila_, cria, _ƙank, lçu_,
   {{0x7c2e0574,0x6aad2d6f,0x26f79053,0x442ec2da}},	//   _gebr, _llaf, ुद्र_, _nef_,
   {{0xb4d9035a,0xb8f589f2,0x3f5742db,0xa3d40071}},	//   ावी_, _हद_, nçu_, _зорч,
   {{0x443342dc,0x443c9fcd,0x7c2e42dd,0x317f82f7}},	//   lax_, _adv_, _zebr, _truz_,
   {{0x2905c2de,0xa91d80d2,0x442ec2df,0x7cf01cab}},	//   _tila_, _brže, _bef_, lära,
   {{0x6aad42e0,0x4c69b7cd,0x6e240bcf,0x443c8299}},	//   _alaf, цион_, zbib, _cdv_,
   {{0x62030086,0x443c8353,0x60c38a6e,0x32460048}},	//   ətlə, _ddv_, minm, менг,
   {{0x60c3c2e1,0x7d070a0f,0x7c250cb5,0x929d809a}},	//   linm, _lijs, hbhr, _miło,
   {{0x7ceb3ea8,0x6d49c02b,0x3ea2816d,0x27e08214}},	//   türl, quea, ökte_, ğine_,
   {{0x1dd8000f,0xfbc58a29,0xb69b03a7,0x60c38041}},	//   _भुगत, _обло, _diâm, ninm,
   {{0x66e6141e,0x7c2e1f1f,0xdee6280f,0x44330079}},	//   дова, _rebr, дови, dax_,
   {{0x26f80074,0xb5fd911b,0x26cd8118,0x7d0f2ef8}},	//   ंगेर_, ješk, nneo_, _bucs,
   {{0x38af0214,0x7c2e42e2,0xed5700a9,0x60c3a008}},	// [3080] _süre_, _pebr, мот_, kinm,
   {{0xf8d20327,0x6f062a0b,0x443301b4,0x6d442816}},	//   _सदिय, _wikc, gax_, rria,
   {{0xddcd42e3,0xbddb09c4,0x7cf00106,0x7d071799}},	//   rdaš, _adèd, gära, _dijs,
   {{0x9c7cc2e4,0x7d0f0350,0x6d4442e5,0xeb9680be}},	//   moče, _fucs, pria, ודער_,
   {{0x9c7c9fe7,0x26cd8279,0x657b026c,0x443301b4}},	//   loče, dneo_, _šuhv, bax_,
   {{0x1de1823c,0xfbd90996,0xab2a0098,0x60c3808b}},	//   _पड़त, _बुकम, _мога_, ginm,
   {{0xb4ea0af3,0xfc030012,0x443c8036,0xd83882d4}},	//   मती_, _апро, _rdv_, _noče_,
   {{0x3da692c0,0x442ec2e6,0x6b83013c,0x629b8122}},	//   дроб, _sef_, ænge, _gouo,
   {{0x443c8a20,0x63bb04b9,0xa91d812b,0x672d8904}},	//   _pdv_, _ƙung, _prže, ćaja,
   {{0x7ae442e7,0x6aad42e8,0x9c7c84c4,0x60c39040}},	//   _akit, _slaf, koče, cinm,
   {{0x7eb100e8,0x442eb9e6,0x9c7c9911,0xf77281a8}},	//   _håpe, _vef_, joče, _جاء_,
   {{0x1d0a9a34,0x7af61803,0xa2a180d4,0xe5c68c6c}},	//   _деди_, _chyt, कॉप्, _осло,
   {{0xa3088117,0x26c4abe9,0x25de0074,0xa91d82d4}},	//   _کرتے_, mimo_, _कुली_, _trže,
   {{0x3946956b,0x7ae442e9,0x1bd49bc1,0xd838a4b2}},	//   iros_, _ekit, _поля, _foče_,
   {{0x9c7c8353,0xa2bf80d4,0x248d001c,0x7d0700f3}},	//   goče, लोड्, _đem_, _rijs,
   {{0x26c4c2ea,0x2d82026c,0x83fc9351,0x443321e7}},	//   nimo_, _brke_, jeđi, wax_,
   {{0x44331cbe,0x2fdf009a,0x60c3aade,0x6722026c}},	// [3090] tax_, ług_, yinm, _čoje,
   {{0xb4d92e2b,0x3f81026f,0x7afd0bcb,0x26c4b2db}},	//   ावे_, _trhu_, lmst, himo_,
   {{0x38ab8022,0x443342eb,0x26c48110,0x39469d24}},	//   _børn_, rax_, kimo_, eros_,
   {{0x26c481e2,0xd6270013,0x2d8200d2,0xd9f3016f}},	//   jimo_, _تعدي, _frke_, _घरात_,
   {{0x39468333,0x2d82017f,0xe1ff0019,0xb5fd8115}},	//   gros_, _grke_, deók_, rešk,
   {{0x7cf042ec,0x99d4803d,0x7b670997,0xe1f081a8}},	//   pära, ختما, _отбе, جسم_,
   {{0x60c384b9,0x83fc8088,0xc8788380,0x5b1416dd}},	//   rinm, beđi, _dağ_, _амст,
   {{0x3946840e,0xee398abe,0xfe719e13,0x3ea942ed}},	//   bros_, чни_, ادث_, nkat_,
   {{0x26cdc2ee,0x443107d9,0x98ef000f,0x3a3f8359}},	//   rneo_, _kez_, छताछ_, _idup_,
   {{0xb5fd86f7,0x7ae41fe6,0x16010592,0xd01180f7}},	//   neši, _skit, लेयर_, _إلا_,
   {{0x26c4c2ef,0x3ea942f0,0xc2c600f7,0x3b0900b9}},	//   bimo_, kkat_, فيدي, _biaq_,
   {{0x7cf000f2,0x6d4d42f1,0xeab20250,0x614617c8}},	//   järn, kuaa, اعد_, нема,
   {{0x8c458c24,0xb5fdc2f2,0x7e6d0162,0xc878807e}},	//   _зеле, keši, deap, _yağ_,
   {{0xb5fd920e,0x26fa01c4,0x7e7b88dc,0xb4d9326c}},	//   ješi, ्द्र_, ldup, ावो_,
   {{0xb4bd835a,0x7ea30006,0x46f61ccf,0x645c8722}},	//   ीची_, _lõpu, ечат, òrie,
   {{0x3ea942f3,0x7eaa026f,0x291f81bc,0xcf9280be}},	//   gkat_, _výpo, _otua_, נטן_,
   {{0xac8607a1,0x61e980d5,0x291f8282,0x3486002d}},	// [30a0] нгал, _nyel, _ntua_, нгаг,
   {{0x23d63408,0x44310038,0xb4ea058c,0x26c4912e}},	//   нцер, _cez_, मते_, zimo_,
   {{0x7b090182,0x443133f3,0x291fc2f4,0x61e9c2f5}},	//   _üstü, _dez_, _atua_, _ayel,
   {{0x39469313,0x6d5bc2f6,0xe8d90028,0xa50a024b}},	//   tros_, ktua, _trợ_, _нема_,
   {{0x26c4c2f7,0x83fc8052,0x44310073,0xf53981ac}},	//   vimo_, ređi, _fez_, jsť_,
   {{0x39468fba,0x672d9601,0x20070722,0xa5bb42f8}},	//   rros_, ćajn, _únic_, _teór,
   {{0xcb671afa,0x291229e2,0x2d8042f9,0x25fc109b}},	//   _паре_, _luya_, lvie_, लेरी_,
   {{0x38b4016d,0x6d5b8168,0x6e362676,0x2d800037}},	//   _färg_, ftua, nayb, ovie_,
   {{0x26c4c2fa,0x7ae294c7,0x2d8037ba,0x6d5bc2fb}},	//   rimo_, moot, nvie_, gtua,
   {{0x2240103b,0x387a01ac,0x7ae2b0c9,0xd5e2819d}},	//   _adik_, _napr_, loot, _anọ,
   {{0x7984380a,0x26c49c2d,0xe7e00e70,0xd00f80f7}},	//   _ariw, pimo_, _खुला_, _الم_,
   {{0x7ae28a52,0x291204bb,0x9e739ef7,0x79840286}},	//   noot, _buya_, _مهمت, _briw,
   {{0x64a6a549,0xf2d38158,0x24588554,0x29120876}},	//   _пада, רער_, _жаль_, _cuya_,
   {{0x79840c0b,0x26c208ae,0x6b8388ae,0x2ed9036d}},	//   _driw, _amko_, _frng, भक्त,
   {{0xe7db0a16,0x64432848,0x79840c2e,0x7e6d0087}},	//   _मुखप, ónim, _eriw, teap,
   {{0x443142fc,0x6d4d07b8,0x63a51e1e,0x3cfe8037}},	//   _sez_, tuaa, vyhn, lmtv_,
   {{0x25fc035a,0x628d0010,0x443101ca,0xdce4009a}},	// [30b0] लेली_, _inao, _pez_, zwią,
   {{0x26c208ae,0x3ea942fd,0x2f150106,0x6d4d0299}},	//   _emko_, skat_, _tåg_, ruaa,
   {{0x443110dd,0x6e360461,0x92598009,0x61e980b9}},	//   _vez_, bayb, дает_, _syel,
   {{0x61e981e0,0x443142fe,0x3ea903ed,0x9f961101}},	//   _pyel, _wez_, qkat_, _סדרה_,
   {{0x443142ff,0x628d4300,0x644a12ca,0x38b40338}},	//   _tez_, _mnao, ófic, _färd_,
   {{0xf771845b,0xf745bacb,0xfaff0168,0x6d5b81c0}},	//   لاب_, веко, hmë_, vtua,
   {{0x6a159a80,0xd7fb8162,0x7e7985ee,0xe2d980d7}},	//   _амбу, чуд_, _pawp, _قارچ_,
   {{0xfaff020f,0x629f02a3,0x6d5bc301,0xa3e60072}},	//   jmë_, _noqo, ttua, _पडत_,
   {{0xc21284de,0x7cf008dc,0x7e7b839c,0x7003019d}},	//   _כהן_, kärl, rdup, ọchu,
   {{0xb4bdae2b,0x628d4302,0x27e08162,0xb4cb8072}},	//   ीचे_, _anao, şina_, रचे_,
   {{0x6d5bb150,0x629f02a3,0xf4120039,0x2120025b}},	//   stua, _boqo, יפי_, _stih_,
   {{0x68e38a40,0x6d5bc303,0x29124183,0x83fc9351}},	//   lond, ptua, _puya_, jeđu,
   {{0x6e298359,0x645c8722,0x6a3a81c6,0x7cf00338}},	//   mbeb, òric, וגרפ, färl,
   {{0xdca28572,0x2eedc304,0x64a2b317,0x661d4305}},	//   _ваши, llef_, _ваша, _afsk,
   {{0xafe611d2,0x291204b9,0x20cd0267,0x7ec789c4}},	//   товл, _wuya_, džid_, _gèpè,
   {{0x661b9599,0x68e3c306,0xfe431b47,0x29124307}},	//   ncuk, hond, инсо, _tuya_,
   {{0x9c7c9f95,0x6d49c308,0xec7a02a4,0x657b026c}},	// [30c0] loča, nrea, мпа_, _šuhr,
   {{0x6d49954c,0x31370051,0xa3d59344,0x293704de}},	//   irea, _שנים_, _सखा_, _שאין_,
   {{0x6d49c309,0xaac60105,0x4ac60074,0x38b4016d}},	//   hrea, _लगाक, _लगाव, _värd_,
   {{0x23270073,0xdcfb8bcf,0x0a678195,0xc4c40264}},	//   тоци_, dvuč, врши_, ্তেজ,
   {{0x90cb011b,0x7ae29328,0x75431431,0x6d498390}},	//   _vvрv, root, _княз, jrea,
   {{0x68e3c30a,0x91bb0039,0x6f0b8706,0x48d080ab}},	//   gond, ומני, _aigc, িত্র,
   {{0xb8ea8bb8,0x7bc7bdcc,0x2a7d81c0,0x547b01c6}},	//   _लग_, újul, bdwb_, _קטלו,
   {{0x9c7c805c,0x6d49a086,0xb7db03c8,0x63a3430b}},	//   doča, frea, וקצי, änne,
   {{0xa91dc30c,0x6ee581ac,0x44208300,0x09068196}},	//   _trža, tóbr, _ƙi_, _апан,
   {{0x8ffa9125,0x21269083,0x68e3914e,0xd838a4b2}},	//   _قرار_, mpoh_, cond, _foča_,
   {{0xda3507ac,0x6d49c30d,0x9c7c8353,0x7cf0016d}},	//   лены, area, goča, värl,
   {{0xa91d803a,0x8aa70012,0x2eed8242,0x02a70425}},	//   _mržn, трод, clef_, тром,
   {{0x61f6009a,0x6d498051,0xfaff00f1,0x290c8300}},	//   _czyl, crea, rmë_, _kida_,
   {{0x929d809a,0x290c86c0,0x7522ac18,0xfaff0168}},	//   _piłk, _jida_, _itoz, smë_,
   {{0x290cc30e,0xb4de8076,0xcfa4002e,0x40340198}},	//   _mida_, थकी_, ашти, ресс,
   {{0x2f188117,0xa3e6000f,0x68e3c30f,0x628d022e}},	//   _még_, _पड़_, zond, _unao,
   {{0x83fc805c,0xdcfb8289,0x68e3c310,0x261903b7}},	// [30d0] ređu, zvuč, yond, युगी_,
   {{0x6adba9b7,0xb5fd8eef,0x61ed4311,0x5f95154f}},	//   यक्र, mešt, _iyal, _биот,
   {{0x68e38a0f,0xddc40110,0x6aa0913b,0x6d49c312}},	//   vond, reiš, _bomf, zrea,
   {{0x68e380c9,0x7b643e29,0x6e95069c,0x61ed4313}},	//   wond, ртфе, _симу, _kyal,
   {{0x68e3c314,0x38b402af,0x290c95d0,0xb5fd943c}},	//   tond, _wäre_, _bida_, nešt,
   {{0x6d49b760,0x290c81b4,0x61ed3ebe,0xfc4781d6}},	//   vrea, _cida_, _myal, číky_,
   {{0x53343725,0xf094012a,0x290cc315,0xdce4009a}},	//   _вест, ינס_, _dida_, jwię,
   {{0x68e3c316,0x7cf008e5,0xf770803d,0xe579951b}},	//   sond, järj, تاه_, ези_,
   {{0x68e383d3,0xb5fd82fd,0x61ed4317,0x6e29c318}},	//   pond, ješt, _nyal, rbeb,
   {{0x290cafd5,0x68e3829b,0x9c7cc319,0x38ab83ba}},	//   _gida_, qond, toča, _mørk_,
   {{0x7afb8c9e,0x61ed431a,0x752281bc,0x2d8681e8}},	//   _khut, _ayal, _etoz, _eroe_,
   {{0x7e7d431b,0x9c7c8353,0x290c8668,0xe29a431c}},	//   _nasp, roča, _zida_, хам_,
   {{0xc95601bb,0x38c8003d,0x9c7cc31d,0x78a1a1b4}},	//   ытны, ناسی_, močn, _kolv,
   {{0x9c7cc31e,0x3eada28f,0xdddd009a,0x438580f7}},	//   ločn, lket_, _obsł, _ملتق,
   {{0xaa7b0125,0x7ae9c31f,0x2b180fd5,0x61ed4320}},	//   glýs, _oket, _बंधु_, _eyal,
   {{0x9c7c826f,0x7e7d4321,0x7ea30074,0x7ae9819d}},	//   nočn, _casp, _sõpr, _nket,
   {{0x61ed1eb7,0x0d860196,0x7e7d4322,0x95860fe6}},	// [30e0] _gyal, ылан, _dasp, ылае,
   {{0x7cf04323,0xddc6027f,0x2718007a,0xa91d8bda}},	//   märk, _takž, _učno_, _pržn,
   {{0x39400a38,0x3ead93e1,0x7afba2f5,0x290cc324}},	//   _hvis_, kket_, _bhut, _rida_,
   {{0xe9da8895,0x290c92cf,0x7afbc325,0xbae5835f}},	//   нке_, _sida_, _chut, ацій,
   {{0xc1e78987,0x290c8661,0x10a682a4,0x5a33804a}},	//   льше_, _pida_, лидн, сніт,
   {{0xa91d8805,0x7ae9c326,0x3eadb42b,0x7d1b02df}},	//   _tržn, _eket, eket_, _éusa,
   {{0x69dc809a,0x657980b9,0x7d0e01b4,0x3b0d8609}},	//   _śred, _aswh, _iibs, _fieq_,
   {{0x443a4327,0xdd908591,0xd6d78fe6,0xe8d9019d}},	//   lap_, قوب_, лты_, _irụ_,
   {{0xbcfb00f7,0x45d484bd,0xb5fb0032,0x290c821e}},	//   _spéi, ропс, _abáj, _tida_,
   {{0x443a4328,0xb5fd8eef,0x5b26976e,0x78a1baf2}},	//   nap_, vešt, льма, _golv,
   {{0x39404329,0x61ed00dd,0xdfcf80f7,0xdeefa462}},	//   _avis_, _syal, _فيك_, _гы_,
   {{0x3ead9cd6,0x7d0e02a6,0x7eb581d6,0x63a897db}},	//   cket_, _libs, _pápe, rydn,
   {{0xf4868110,0x61ed05ee,0x7d0e0706,0x7522c32a}},	//   _буйн, _qyal, _oibs, _utoz,
   {{0x6b9c8022,0xed578051,0x443a07d5,0x26c68069}},	//   ørgs, _עבור_, jap_, _hmoo_,
   {{0x443a14ff,0x8c1b8039,0xb8dd016f,0x69c03382}},	//   dap_, _אווי, _आत_, úmer,
   {{0x4ea4432b,0x7d0e0362,0x7c3ac32c,0xaa7b008b}},	//   бруа, _aibs, latr, rlýs,
   {{0x7e7d1c67,0xe8d9082e,0x443a2e83,0x26c681bc}},	// [30f0] _vasp, _arụ_, fap_, _mmoo_,
   {{0x443a432d,0xaa7b0125,0x7e7d0b17,0x25a9432e}},	//   gap_, plýs, _wasp, ryal_,
   {{0x25a91b71,0xd3710624,0x7afb81e4,0x7c3a847f}},	//   syal_, تها_, _phut, iatr,
   {{0xf53f04b8,0x78a1c32f,0x8f9a010f,0x7c3ac330}},	//   _två_, _solv, _סירי, hatr,
   {{0x6e2d4331,0x210f92ee,0x78a1b1d7,0x7c3ac332}},	//   mbab, ादेश_, _polv, katr,
   {{0x443a0886,0x7c3a805c,0x07a58698,0x6e2d4333}},	//   cap_, jatr, иалн, lbab,
   {{0x78a1c334,0x9c7c8038,0xc4d20039,0x7afbc335}},	//   _volv, točn, _וגם_, _thut,
   {{0xd838826c,0xa3b20035,0x7545a481,0x6f0f0197}},	//   _fočo_, टनर_, аниз, _jicc,
   {{0x9c7c905e,0x6d4d36c0,0x38b4016d,0x6f0f0b57}},	//   ročn, nraa, _lära_, _micc,
   {{0x3eada97c,0x7eaa026f,0x99d491cc,0x2a7f8282}},	//   sket_, _výpi, _اتفا, _haub_,
   {{0x38b400f2,0xf79984c1,0x2a7f822c,0x394001a1}},	//   _nära_, _جناب_, _kaub_, _svis_,
   {{0x6f0f4336,0x6d4d23b6,0x7cf03a53,0x8b0881d0}},	//   _nicc, kraa, tärk, mořá,
   {{0xfeb88416,0x2a7f822c,0x690b02a6,0xed598087}},	//   _حالت_, _maub_, _eżem, _рол_,
   {{0x6e3bc337,0x6d4d10b0,0x2a7f8282,0x75298548}},	//   laub, draa, _laub_, mpez,
   {{0xac7483f8,0x443a07d9,0x6f0f23b9,0x6d4d0079}},	//   _دانش, vap_, _bicc, eraa,
   {{0xddc60063,0x6e2d02b8,0x6f0f4338,0x7a0c00eb}},	//   _takż, gbab, _cicc, _pētī,
   {{0x443a1ca6,0x6f0f4339,0x6d4d387f,0x395f8282}},	// [3100] tap_, _dicc, graa, _nqus_,
   {{0x7cef8aa2,0xe3b200f7,0x8c4604db,0x25fc0035}},	//   føri, يرا_, реже, लेगी_,
   {{0x443a28af,0x798980a4,0x6f0f433a,0x6e2d433b}},	//   rap_, _arew, _ficc, bbab,
   {{0x443a336a,0x63a300f2,0x2a7f822c,0x6d4d0f1a}},	//   sap_, änna, _caub_, braa,
   {{0x3940c33c,0x6f043c32,0x7989a319,0x2a7f8122}},	//   éis_, mmic, _crew, _daub_,
   {{0x6ab6031d,0x6f040229,0x7989809a,0xe8d9001c}},	//   _llyf, lmic, _drew, _trụ_,
   {{0xd6dac33d,0xbb43433e,0x7c3aaf5d,0xd90d87d2}},	//   кти_, _мерк, vatr, ریم_,
   {{0x4438433f,0xb4de81a2,0x6f040229,0x38698503}},	//   _her_, थक्_, nmic, đara_,
   {{0x44380db7,0xdd908591,0xe51c005e,0x6280c340}},	//   _ker_, سود_, _भूमि_, _iamo,
   {{0x4438003a,0x6280c341,0x628282b5,0x2a7f81c5}},	//   _jer_, _hamo, ldoo, _zaub_,
   {{0x6f04003a,0x4438179a,0x7c3ac342,0x6280c343}},	//   kmic, _mer_, ratr, _kamo,
   {{0xf2c70f16,0x62808fe2,0x44383caa,0x20cd0110}},	//   рсон, _jamo, _ler_, džia_,
   {{0x44384344,0xdd8f8013,0x6f0404a8,0x6f0f0098}},	//   _oer_, _يوم_, dmic, _ricc,
   {{0x443804b8,0x3d1a01ce,0x6d4d038e,0x6f0f047f}},	//   _ner_, _बढ़े_, vraa, _sicc,
   {{0x6f0f0698,0xd8388d11,0x040480ab,0x13a980d7}},	//   _picc, _meč_, _শ্রী_, _منوی_,
   {{0x6280c345,0x5eb404fa,0x6d4d26a1,0x44384346}},	//   _namo, ойст, traa, _aer_,
   {{0x44382d85,0x6d40c347,0x628282a3,0x6e2d0ad4}},	// [3110] _ber_, nsma, ddoo, rbab,
   {{0x7c388efd,0x6d4d4348,0x44384349,0x645c00ee}},	//   _jevr, rraa, _cer_, _ccri,
   {{0x4438434a,0xdd86850c,0x2a7f90af,0x6d4d35da}},	//   _der_, _کو_, _paub_, sraa,
   {{0x6e951e95,0x6d4d00c9,0xe69516a5,0x645c00e7}},	//   _الحا, praa, _الحد, _ecri,
   {{0x4438434b,0xdced02a5,0x7eb5826f,0xd8388289}},	//   _fer_, svađ, _nápa, _beč_,
   {{0x4438434c,0x6e22c34d,0x2d8b01a1,0x7ceb0380}},	//   _ger_, _afob, _irce_, rürs,
   {{0x2a7f81c5,0x6d42c34e,0x6d46c34f,0x2fde83a8}},	//   _taub_, _avoa, škal, _cxtg_,
   {{0x44211f4c,0x4438011e,0x6280c350,0x4177803d}},	//   lch_, _zer_, _gamo, _پارس,
   {{0x443802bb,0x9c7c8353,0x6d40a310,0x7c38837a}},	//   _yer_, močj, gsma, _bevr,
   {{0x7aed4351,0x44214352,0x6aa40362,0x67d59bcc}},	//   _akat, nch_, _soif, _лозу,
   {{0x44214353,0x7c38c354,0xa3d72836,0x6280b394}},	//   ich_, _devr, ापि_, _yamo,
   {{0xfbd20039,0x62808118,0x75299e41,0xf8a91101}},	//   לתי_, _xamo, ppez, _אש_,
   {{0x7c38c355,0xd46989a5,0x6b8a9699,0xf8db8035}},	//   _fevr, _биле_, _erfg, _बदाय,
   {{0x7c3880c9,0x7cf01bda,0x7aed4356,0xe8f7002e}},	//   _gevr, päri, _ekat, йля_,
   {{0xf412804c,0x78a5012b,0x7eb5803e,0x2d8b4357}},	//   _צפה_, _dohv, _zápa, _arce_,
   {{0x645c4358,0x44384359,0x644721e5,0x628281b4}},	//   _scri, _ser_, _adji, xdoo,
   {{0x4438435a,0xbea315e3,0x6280c35b,0xa3cb8105}},	// [3120] _per_, чатк, _ramo, _रेत_,
   {{0x9992000d,0xc5f283c8,0x7cf00338,0x4423018e}},	//   _když_, לדן_, härv, _cfj_,
   {{0x443810dd,0x6280abd2,0x7f860013,0xd838b251}},	//   _ver_, _pamo, _الجن, _reč_,
   {{0x44380352,0x93bc802e,0xd25980e8,0x4421435c}},	//   _wer_, mbăt, иці_, ach_,
   {{0x4438435d,0x6282b062,0x6280c35e,0x673b005c}},	//   _ter_, rdoo, _vamo, ćuje,
   {{0xdb1a8065,0x3ea7002e,0xd7fa8193,0x52a50540}},	//   szté, _într_, луй_, _ऑक्स,
   {{0xd838a52d,0x6564435f,0xf1bf0065,0x20c980f7}},	//   _več_, ltih, zzá_, جبني_,
   {{0x6d40c360,0x7c3893ff,0x62828df6,0xc6f882ee}},	//   tsma, _sevr, qdoo, јних_,
   {{0x94868087,0x6d40c361,0x656419b0,0x20cd01a1}},	//   бынд, usma, ntih, džin_,
   {{0x7aed4362,0x9c7c8353,0x38b9b66f,0xb866815b}},	//   _skat, močk, _père_, _دارو,
   {{0x95f5064a,0xaca40133,0xd2510f24,0x6d564363}},	//   _आर्ट_, _adịr, وند_, huya,
   {{0x38af02bb,0x6d564364,0x7c3e26a6,0xddcd0087}},	//   _türk_, kuya, hapr, neaţ,
   {{0x44212ecc,0x9c830db7,0x7c3883b2,0x65642992}},	//   ych_, ščit, _tevr, jtih,
   {{0x7cfd80e7,0xc0c84365,0x9a298129,0x6d5602d5}},	//   tère, бусе_, _mươi_, duya,
   {{0x443eabab,0xaab8901b,0xbcfb02be,0x38af209e}},	//   mat_, _आतंक, _opér, _jüri_,
   {{0x44212065,0xd2510117,0x38ab8aa2,0x7aed4366}},	//   wch_, _کچھ_, _hørt_, _ukat,
   {{0x44213693,0x69da1d54,0xf77804b7,0x38ab806a}},	// [3130] tch_, şter, ħħa_, _kørt_,
   {{0x3f8c80ad,0x645aac60,0x44214367,0x798d4368}},	//   _ordu_, ngti, uch_, _iraw,
   {{0x44214369,0x443e8087,0xbcfb08f9,0xcfad8264}},	//   rch_, iat_, _spés, _কেনন,
   {{0x443ec36a,0x44211ab0,0xe5700065,0x2d8b017f}},	//   hat_, sch_, بطہ_, _trce_,
   {{0x443ec36b,0x7c3e01f6,0x9967c36c,0x5d330019}},	//   kat_, bapr, стел, _رہائ,
   {{0x443ec36d,0x3f8c80d2,0x02c6016f,0x493c03c8}},	//   jat_, _brdu_, _लग्न, נגוו,
   {{0x443ec36e,0xf5228133,0x291308dc,0xf3f32384}},	//   dat_, _rịọr, _mixa_, _رأس_,
   {{0x92b788ca,0x2249061b,0x9c7c826f,0x645ac36f}},	//   _احسا, _ndak_, bočk, egti,
   {{0x99d48013,0x212907d5,0x798d0069,0x2d8b801b}},	//   _فتكا, _ntah_, _nraw, íce_,
   {{0x443ec370,0xe4c5835f,0x20cd0110,0x7cef804a}},	//   gat_, ійни, džio_, jørt,
   {{0x798d4371,0x224900b9,0x7cf00198,0xf9891101}},	//   _araw, _bdak_, märt, _שר_,
   {{0xef0e8d13,0xae0908fd,0x798d4372,0x65643aab}},	//   _ім_, वधान_, _braw, ytih,
   {{0x443e8859,0xe5a597c8,0x672d82a5,0x8c4595b7}},	//   bat_, _фили, ćaju, _деле,
   {{0x443ea9ab,0x248300dd,0xbf0204c5,0x798d4373}},	//   cat_, _najm_, लग्न_, _draw,
   {{0xfaa6104b,0xa91d931b,0x3f8c016b,0x7c3e4374}},	//   _мако, _drži, ídu_, vapr,
   {{0x765bc375,0x2ca783b2,0x93bc8087,0x7c3e008e}},	//   nguy, _hond_, rbăt, wapr,
   {{0x27e087d9,0x798d4376,0x29134377,0x62964378}},	// [3140] ğini_, _graw, _fixa_, _inyo,
   {{0x33f60e8e,0x27e0c379,0x629601c0,0x62863dab}},	//   очес, şini_, _hnyo, ldko,
   {{0x2ca7ac23,0x7eb5803e,0x656404e8,0x7c3e437a}},	//   _mond_, _nápo, stih, rapr,
   {{0x443e9f41,0x7ebc8065,0x62861cb6,0x7c3e437b}},	//   zat_, _képe, ndko, sapr,
   {{0x6284156b,0x443ec1ae,0xe894812f,0x88e699a5}},	//   _maio, yat_, заль, ожде,
   {{0x443e881a,0x5fcf0035,0x628412f5,0x11398084}},	//   xat_, _हेडल, _laio, сяцы_,
   {{0x443ec37c,0x6d4436ae,0x62960870,0x9949809a}},	//   vat_, lsia, _onyo, góły_,
   {{0x7c3c437d,0xa3d705b3,0x9a29801c,0x7cf48722}},	//   _herr, ापर_, _tươi_, màri,
   {{0x443ec37e,0x7c3c0364,0x9c7c8db7,0x41278256}},	//   tat_, _kerr, loči, _мото_,
   {{0x0caa938f,0x443ec37f,0x62964380,0x3b5486d2}},	//   ртии_, uat_, _anyo, пкор,
   {{0x7c3c4381,0x6d4403ac,0x7cf4809f,0x62844382}},	//   _merr, hsia, nàri, _baio,
   {{0x798d4383,0x672dabea,0x6b83006a,0x7c3c4384}},	//   _praw, ćajt, ængi, _lerr,
   {{0x443e8595,0xf1c5016f,0xaca4019d,0xd251003d}},	//   pat_, _लेखन, _adọr, ونگ_,
   {{0x443ec385,0x7ebc80e7,0x843880f7,0x9c7c8796}},	//   qat_, _dépe, _اكثر_, koči,
   {{0x224909da,0x9c7c807a,0x6d461f0a,0xa8140073}},	//   _tdak_, joči, _avka, ддрш,
   {{0x798d4386,0x56944286,0x7eb5826f,0x7cf48722}},	//   _traw, маст, _nápl, dàri,
   {{0x7c3c4387,0x443c9393,0xa91d803a,0x7ebc8019}},	// [3150] _berr, _kev_, _trži, _gépe,
   {{0x7c3c4388,0x2d892a23,0x449811e9,0x7d1d87e0}},	//   _cerr, rvae_, овую_, íssi,
   {{0x9c7c8353,0x7eaa026f,0x395901ec,0x443cc389}},	//   goči, _výpr, luss_, _mev_,
   {{0xb77a093f,0x0f7a0158,0x7cf00004,0x877a03c8}},	//   _פארש, _פארב, färs, _פארי,
   {{0x7c3c438a,0xc692093f,0x6b8e022b,0x24830088}},	//   _ferr, _נאך_, _erbg, _tajm_,
   {{0x443c8282,0x7c3c01e1,0x63a300e8,0x3f8103ed}},	//   _nev_, _gerr, ønns, _kshu_,
   {{0x2ca7c38b,0xda3597ae,0x78a8817f,0xe7398009}},	//   _rond_, _невы, _dodv, щей_,
   {{0x7d1d1328,0x7c3c0102,0x7640b8ba,0x7c2528c6}},	//   _kuss, _zerr, gamy, lchr,
   {{0xee3681e2,0x6284438c,0x7cf00198,0x7d1d1f5d}},	//   чны_, _raio, märr, _juss,
   {{0x443c81e9,0x7d1d438d,0x6aa980f3,0x7c3c438e}},	//   _cev_, _muss, _hoef, _xerr,
   {{0x7d1d12bb,0x2ca78a0f,0x62840037,0x6f028834}},	//   _luss, _vond_, _paio, _fhoc,
   {{0x6d440114,0x443c8609,0x2ca79989,0x6f028362}},	//   ysia, _eev_, _wond_, _ghoc,
   {{0x361a812a,0x3495a133,0x443cc38f,0x5ec300ab}},	//   _הונד, _надр, _fev_, ্কাই,
   {{0x3e4c8110,0x7e6f00c3,0x3ebf808e,0xe51f06ae}},	//   rėtų_, _abcp, lhut_, _बढ़ि_,
   {{0x6441c390,0x7d1d4391,0xdfd200f7,0xc7a60098}},	//   mali, _auss, رير_, чивк,
   {{0x7c3c1e9e,0x7d1d4392,0x7d150029,0x6d440006}},	//   _serr, _buss, _aizs, tsia,
   {{0x7c3c4393,0x6d444394,0x6e3d4395,0x6e2405e4}},	// [3160] _perr, usia, _desb, rcib,
   {{0x6abbc396,0x7cf4809f,0x6e243648,0x443c856c}},	//   _aluf, tàri, scib, _xev_,
   {{0xd838805c,0x6e3d010c,0x6d440ca9,0x3ebfc397}},	//   _uoči_, _fesb, ssia, khut_,
   {{0x9c7c824a,0x6441bdf5,0xe80f946d,0xdddba30a}},	//   roči, hali, ाधना_, zduš,
   {{0x6441843c,0x7c3c05d8,0x290a004f,0x26d201b4}},	//   kali, _terr, omba_, miyo_,
   {{0x6441c398,0x69c28613,0x26d24399,0x92cc80ab}},	//   jali, rzoe, liyo_, রকে_,
   {{0x6abb9045,0xf0930039,0xa3cba0d5,0xdddb807a}},	//   _fluf, תנו_, _रेल_, vduš,
   {{0x6d558063,0x443cc39a,0x69cd94d5,0x3ebf8359}},	//   ązan, _sev_, _देवी, ghut_,
   {{0x6441c39b,0x443c822c,0x76408a03,0x25a00118}},	//   fali, _pev_, ramy, nxil_,
   {{0x6441c39c,0x26d23a19,0x645e033e,0x31bb8039}},	//   gali, hiyo_, ngpi, _הזמנ,
   {{0x443c8069,0x61e412ca,0x81aa00ab,0x6f1e016a}},	//   _vev_, _axil, _গেল_, _nupc,
   {{0xed5aa7de,0x201a03a8,0x6441956e,0x26d20079}},	//   _год_, _agpi_, aali, jiyo_,
   {{0x6441c39d,0x26d2439e,0x443cc39f,0x6e3d43a0}},	//   bali, diyo_, _tev_, _resb,
   {{0x64a381e2,0xa3ac0af7,0x39590dba,0x6e3d43a1}},	//   _пача, गहा_, russ_, _sesb,
   {{0x7d1d43a2,0x6e3d008e,0x7f9443a3,0x2d823f4f}},	//   _suss, _pesb, нарх, _aske_,
   {{0xc6f9102a,0x26c00122,0x0ccd80ab,0x67278061}},	//   інах_, ghio_, রকৃত, _éjje,
   {{0x3d1706a7,0xd83880c3,0x1ddc820e,0x7c2543a4}},	// [3170] _भूखे_, _hoču_, मपित, tchr,
   {{0xad9b0e1b,0x442743a5,0xc1bc0039,0x3f8101c0}},	//   _azúc, ùn_, _למחש, _tshu_,
   {{0x23790b76,0x09aa80c8,0x7d150019,0x2d8206c0}},	//   تماد_, _খেলা, _vizs, _eske_,
   {{0x7d1d240d,0x7c2543a6,0x6441c3a7,0x26c043a8}},	//   _tuss, schr, zali, chio_,
   {{0x6441c3a9,0x6f1e00d2,0x0ef9064a,0x69348956}},	//   yali, _zupc, ंतीस_, енчу,
   {{0x7e62c3aa,0x64418085,0xb9260032,0xf4840098}},	//   _acop, xali, _aawọ_, _пусн,
   {{0x238c801b,0x66e58a13,0xb5fb046d,0x6aa9989f}},	//   _něj_, мока, _gbár, _toef,
   {{0x2bd30074,0x3949016a,0x7e6d0118,0x44278299}},	//   _धेया, _ovas_, nfap, _sfn_,
   {{0x26c381e2,0x224dc3ab,0x6f09872a,0x442580b9}},	//   ėjo_, _idek_, rmec, tcl_,
   {{0x26d2005d,0x38b40f02,0x3a3f9989,0xa91d936f}},	//   ziyo_, _värk_, _heup_, _držt,
   {{0x3b0a1ac9,0x68e48174,0x394902f1,0x61f60198}},	//   жено_, éide, _avas_, _syyl,
   {{0xe29a31a5,0x80d00540,0x216a0009,0x291f804f}},	//   цам_, डोने, оими_, _kuua_,
   {{0x68ee05ee,0xf652825f,0x44279914,0x7e7baaa0}},	//   tobd, _יצא_, _tfn_, meup,
   {{0x31568158,0xd838826c,0x6441c3ac,0x6ada9a46}},	//   וישן_, _foču_, qali, _भद्र,
   {{0x26c0031d,0x7ebcc186,0xdce401b9,0x291f82f1}},	//   thio_, _hépa, stiċ, _luua_,
   {{0x61f60009,0x212d8326,0x61e40cdb,0x224d9ab3}},	//   _tyyl, _oteh_, _txil, _ndek_,
   {{0xf1bf1d8c,0x26d243ad,0x6d468e63,0x6569c3ae}},	// [3180] lcán_, riyo_, škav, nteh,
   {{0x3157093f,0x24878247,0x26d243af,0x9c7ca648}},	//   _קיין_, _janm_, siyo_, boču,
   {{0x24878247,0x224001e0,0x212dc3b0,0x9a86a853}},	//   _manm_, _keik_, _ateh_, дулл,
   {{0xe1fa8604,0x212003ac,0xa3d48054,0x38af01ec}},	//   оге_, _kuih_, _सेफ_, _fürs_,
   {{0x397a9e13,0x2d8200ce,0x29058362,0x69c633bc}},	//   تصاد_, _uske_, _bhla_, nzke,
   {{0x7e62c3b1,0x3a26be1e,0x22402496,0x212000ee}},	//   _scop, scop_, _leik_, _muih_,
   {{0x638314b7,0x3946a31e,0xdb832482,0x212009c4}},	//   _игра, ssos_, _игри, _luih_,
   {{0x444443b2,0xf8bb0e70,0x81c400c8,0x2f178009}},	//   la_, _उत्प, _এখন_, мощь_,
   {{0x786682bc,0x4444011e,0x248783ec,0x6d4f8b80}},	//   _оказ, oa_, _banm_, šcan,
   {{0x444443b3,0x7ebc83d3,0x09038162,0x00000000}},	//   na_, _dépa, _апун, --,
   {{0x44440c39,0x79841e8c,0x403380e8,0xb86584c1}},	//   ia_, _asiw, _реєс, _سالو,
   {{0x444443b4,0x63a33c40,0x21202b36,0x6d5b820d}},	//   ha_, änni, _buih_, buua,
   {{0x4444400f,0x24878247,0xf1bf0e1b,0xf5b6815b}},	//   ka_, _fanm_, acán_, _تصاد,
   {{0xfbcf89d7,0x690b0372,0xfd4f0129,0x6602c3b5}},	//   اتی_, _ażer, _triế, _izok,
   {{0xc5888104,0xd7f801a0,0x2f01b128,0x86020176}},	//   _hồ_, дут_, lóga_, _dakٍ_,
   {{0x4444002e,0x3869811f,0x442a43b6,0x76440326}},	//   ea_, đari_, _afb_, gaiy,
   {{0x444443b7,0x09d90a49,0x394926d5,0xfd1f36f1}},	// [3190] fa_, _সরকা, _uvas_, _quì_,
   {{0x80b383db,0xc58880ff,0x599601c6,0x9c7c81d6}},	//   _अवधे, _mồ_, _נכתב_, poču,
   {{0x70db86a7,0xc58880ff,0x32558d9e,0x442a43b8}},	//   _बदौल, _lồ_, евер, _dfb_,
   {{0x7d188bfa,0x444443b9,0x527c03de,0x6f060362}},	//   _livs, aa_, ַנוא, _ghkc,
   {{0x7c2aab5e,0x5e5600be,0x6f0d04b9,0x442a1ab3}},	//   _offr, _אירע_, mmac, _ffb_,
   {{0x6f0d43ba,0xf8bf03c9,0x7ebc80e7,0xd1b8806b}},	//   lmac, mpés_, _répa, باما_,
   {{0x64452fd2,0x6602c3bb,0x7ebc80e7,0x7ceb43bc}},	//   mahi, _azok, _sépa, kürz,
   {{0x7c2ac3bd,0xc58880ff,0xf4298198,0x291f82f1}},	//   _affr, _bồ_, kkää_, _tuua_,
   {{0x7d1881dd,0xa3d48424,0x98758d46,0x224043be}},	//   _bivs, _सेब_, _плац, _reik_,
   {{0x6445132c,0x6569afb3,0x6f0d427a,0x31348087}},	//   nahi, rteh, hmac, _рефр,
   {{0xeb998785,0x6569c3bf,0x6f0d43c0,0xccf20039}},	//   чин_, steh, kmac, רכי_,
   {{0x64452813,0x87b680be,0x6aad0087,0x1a66015b}},	//   hahi, _אלעס_, _coaf, ریخی_,
   {{0xed4ea40f,0x463a893f,0x64451066,0xa3d48074}},	//   _що_, _זענע, kahi, _सेठ_,
   {{0x444416cb,0xdb1a8065,0x73e58698,0xfc3189a7}},	//   xa_, sztá, _полз, _صحت_,
   {{0x6d49c3c1,0x644543c2,0x910311c7,0x224000b9}},	//   lsea, dahi, упре, _teik_,
   {{0x6443007b,0x98a00369,0x2d800035,0x6721ad2e}},	//   ðnin, _otić_, twie_, _mulj,
   {{0x6d49c3c3,0x672181b9,0x7eb5a509,0x76442008}},	// [31a0] nsea, _lulj, _cápi, raiy,
   {{0x6d498ad0,0x9f8643c4,0x444443c5,0x26df80d2}},	//   isea, _згод, ua_, hnuo_,
   {{0x7c249010,0x26df805c,0x929d809a,0x6e460af2}},	//   _şirk, knuo_, _chło, _пенз,
   {{0x444443c6,0xe60780f7,0xaa7b026f,0x7c3b0115}},	//   sa_, _مش_, mnýc, _đure,
   {{0x644543c7,0xaa7b026f,0xd6d080d5,0xda6580f7}},	//   bahi, lnýc, یقت_, ضاني,
   {{0x10a38a94,0x444443c8,0x98a395e0,0x6d4981e4}},	//   личн, qa_, личе, dsea,
   {{0xaa7b026f,0x6602900b,0x7eb5826f,0x291a008e}},	//   nnýc, _szok, _zápi, _mipa_,
   {{0x6721c3c9,0x26df80ce,0x7d1b43ca,0x6f199670}},	//   _dulj, gnuo_, _èusc, _ciwc,
   {{0x6d49c3cb,0x91e38081,0x301a81a8,0x66db062c}},	//   gsea, _боте, _فتاة_, läkä,
   {{0x291a077f,0xa2a3064a,0x7ae41c40,0x224682d5}},	//   _nipa_, गाभ्, _ajit, laok_,
   {{0xf3898104,0xaa7b026f,0x31e280ab,0x6f0d10ae}},	//   _cả_, jnýc, _বরিশ, ymac,
   {{0xaa7b0efc,0x6d498362,0x34dd109b,0xad2681a8}},	//   dnýc, bsea, _मद्द, _كرتو,
   {{0x6721826c,0x64454331,0x291a0115,0x6d498427}},	//   _zulj, yahi, _bipa_, csea,
   {{0x7eb58510,0x26f90935,0xb4af1d70,0x212b802a}},	//   _rápi, ंत्र_, _ओके_, _éche_,
   {{0x6445365d,0x6f0d43cc,0x291a43cd,0xbddb010c}},	//   vahi, tmac, _dipa_, _ndèr,
   {{0x7ae40b18,0x6445323d,0x7cf487f1,0xabfb81c6}},	//   _gjit, wahi, càrr, _מהור,
   {{0x64453e75,0x7c3b0267,0x988381d6,0x75228084}},	// [31b0] tahi, _đurb, víľu_, _juoz,
   {{0x7afd43ce,0xaa7b0a21,0x6f0d0d35,0x98650065}},	//   llst, bnýc, smac, _جیسے_,
   {{0xc4d380be,0xf09f80ff,0x764b0019,0xd6d10f24}},	//   נגע_, _đà_, ógys, _نقد_,
   {{0x644543cf,0x291a0279,0x59d2809a,0xbd05826b}},	//   sahi, _zipa_, _देहर, _akẹ́,
   {{0x67218364,0x64453bc2,0x41b32594,0xc2c481a8}},	//   _sulj, pahi, ुनिस, ديني,
   {{0xdb2304c0,0x3ea943d0,0x9dd60039,0x7afd3b13}},	//   _موسی, ljat_, _יורק_, hlst,
   {{0x656d43d1,0x26df8503,0x07a58c07,0x9be401e5}},	//   ltah, tnuo_, тайн, _бітк,
   {{0x7ebc82be,0xcf248154,0x3ea943d2,0xf1d29094}},	//   _dépo, دروي, njat_, _देवन,
   {{0xceb40f60,0x391593bd,0x6e29c3d3,0x26df8289}},	//   טיק_, _амар, rceb, rnuo_,
   {{0x6d49c3d4,0x26df812b,0x7af608f8,0x7afd09e5}},	//   rsea, snuo_, _skyt, elst,
   {{0xa3ba01ce,0x6d49c3d5,0x3ea90267,0x3fdc00ab}},	//   आईए_, ssea, kjat_, _ধর্ষ,
   {{0x291a0699,0xaa7b0a21,0x3ea902a6,0x6d5f005d}},	//   _sipa_, vnýc, jjat_, kuqa,
   {{0x6d46803a,0xcb128158,0x20d600e8,0x656d33d2}},	//   škar, ילט_, вівс, jtah,
   {{0xaa7b0efc,0xf389801c,0x7afd2525,0x20188580}},	//   tnýc, _tả_, alst, _úric_,
   {{0x46f600e8,0x7eb816dc,0x10a306e9,0xddca0035}},	//   вчат, _hípi, ширн, łoży,
   {{0xcf928158,0xaa7b026f,0x321f801c,0x20cd0084}},	//   סטן_, rnýc, _nguy_, džiu_,
   {{0x6443c3d6,0x61fbbd9b,0xaa7b026f,0x656d2a22}},	// [31c0] _keni, _nyul, snýc, gtah,
   {{0x6443859c,0xaa7b016b,0xfaf901a9,0x66db062c}},	//   _jeni, pnýc, stīt_, täkä,
   {{0x394d87a3,0x61e99a16,0x7eb82509,0x213f810c}},	//   _aves_, _axel, _lípi, _awuh_,
   {{0x60c1c3d7,0x7ebc83d3,0x6443afbc,0x79828035}},	//   _allm, _répo, _leni, twow,
   {{0x80b38075,0x7ebc82be,0x200580b9,0x3eab016b}},	//   _अवशे, _dépl, _azli_, žitá_,
   {{0x7982809a,0xed59816b,0x6443c3d8,0x2126808e}},	//   rwow, drž_, _neni, rqoh_,
   {{0x61e9c3d9,0x7ee69d51,0xf6e68ff7,0x213f88f9}},	//   _exel, кцие, кцин, _ewuh_,
   {{0x2d86a09c,0x7e6443da,0xd6d784d9,0x7bc8816b}},	//   _psoe_, ngip, кты_, vzdu,
   {{0x6443c3db,0x7ae281f6,0x2d9206c0,0x61fb8061}},	//   _beni, mnot, nvye_, _gyul,
   {{0xd90e826a,0xe7ed81fe,0x64438942,0x7ae2c3dc}},	//   _بیت_, _चुका_, _ceni, lnot,
   {{0x7d1c43dd,0x34b70039,0x6443c3de,0x9f4f061c}},	//   _mirs, דפים_, _deni, ünüz_,
   {{0x7ae2c3df,0x4fd98158,0x41e705e9,0x394d8c1a}},	//   nnot, _אַנד, віга, _yves_,
   {{0x394d06e3,0xb3568416,0x7afd016d,0xdd9287d2}},	//   ées_, ریکا_, rlst, _خوش_,
   {{0x799643e0,0x61e200c3,0x26c243e1,0x00000000}},	//   _dryw, _žolc, _alko_, --,
   {{0x6448c3e2,0x251b898a,0x92950a42,0x442ec3e3}},	//   madi, _קווא, _байц, _iff_,
   {{0x6443c3e4,0x7d1c0782,0xaf34003d,0x7c2e43e5}},	//   _zeni, _airs, شرفت, _afbr,
   {{0x7ae28775,0x6443884a,0x3ea943e6,0xe8d90133}},	// [31d0] dnot, _yeni, rjat_, _asụ_,
   {{0xfaff020f,0x656d0f68,0x6443c3e7,0x3e530028}},	//   llë_, rtah, _xeni, ệt_,
   {{0xa2b486bf,0x656d132c,0x38b4016d,0x5a35867c}},	//   _आवश्, stah, _värt_, гнет,
   {{0x941580be,0x628f43e8,0x7ae285ed,0x2bc200bc}},	//   אַנד_, ndco, gnot, वैधा,
   {{0x7d1c0051,0x442e8051,0x69cd93ba,0xaca301bc}},	//   _firs, _off_, _देखी, _atụb,
   {{0x6448c3e9,0x7c341663,0xdce981b9,0x7ae28198}},	//   jadi, _верх, rteċ, anot,
   {{0x3d06800f,0x6448c3ea,0xccf201c6,0x8af98085}},	//   _सीधे_, dadi, _לכך_, _atəş,
   {{0x6e2d43eb,0x2a6901c0,0xb5fd80eb,0x7cfd823e}},	//   ncab, _ncab_, egša, mèri,
   {{0x6448c3ec,0x6d4d02a1,0x4035ad59,0x6f1d079a}},	//   fadi, nsaa, _безс, _misc,
   {{0x6448c3ed,0x60c180f7,0x6f1d028e,0x64438168}},	//   gadi, _ullm, _lisc, _qeni,
   {{0x7a6a0758,0x6443c3ee,0x7c958077,0x68f5026c}},	//   нинг_, _veni, نشگا, dozd,
   {{0x79960063,0x64438352,0x6d4d25e0,0x68ed8013}},	//   _pryw, _weni, ksaa, éadf,
   {{0x6443af30,0x645c9313,0x6448c3ef,0x442c89c4}},	//   _teni, óric, badi, bcd_,
   {{0x6f1d0013,0x6448c3f0,0x6d4d43f1,0x644383ba}},	//   _aisc, cadi, dsaa, _ueni,
   {{0x1fb501ae,0x2cb88e43,0x7d1c0118,0xd36e81a8}},	//   астр, örde_, _rirs, _فهو_,
   {{0x63bc8aa2,0x292500f7,0x7c3b0da8,0x6d4d067f}},	//   ørne, úpaí_, _đura, fsaa,
   {{0xceb28bea,0xed5700a9,0x7d1c0077,0xe5a33650}},	// [31e0] זין_, лот_, _pirs, бити,
   {{0x888610f8,0x6f1d43f2,0x03a622a7,0x7ff600f7}},	//   _слож, _eisc, лизо, _مسجا,
   {{0x7d1c0bb6,0xfaf900eb,0xad9b0e1b,0x7ae2c3f3}},	//   _virs, brīd_, _ayúd, tnot,
   {{0x6d5b820f,0x6e2d1ac6,0xbea60a08,0x80a201ab}},	//   krua, ccab, _самк, खावे,
   {{0x7ae29c4b,0x7d1c43f4,0x2d8402be,0x6448ba14}},	//   rnot, _tirs, _ème_, yadi,
   {{0x7ae2c3f5,0xb6058088,0x2cb102d4,0x6448857b}},	//   snot, _mišč, _gozd_, xadi,
   {{0x6448b1dc,0x9cd704de,0xe3a78829,0x442c8122}},	//   vadi, _עולה_, _ار_, vcd_,
   {{0x6448c3f6,0x442e8da8,0x6e3b97ea,0x798611ee}},	//   wadi, _sff_, gbub, kwkw,
   {{0xceb3025f,0x6d5bc3f7,0x442cc3f8,0xbddb0176}},	//   מיה_, grua, tcd_, _neèl,
   {{0xddcb8087,0x752600ee,0x3374c3f9,0x3a098fd3}},	//   ţişt, _mukz, агор, _شکنی_,
   {{0x6448c3fa,0x7eb5a6e7,0x4f5a92c8,0x5fa89664}},	//   radi, _cáps, _سجاد_, _कपिल,
   {{0x6448c3fb,0x291ec3fc,0x6d4d0079,0x7646306c}},	//   sadi, _hita_, ysaa, _neky,
   {{0x291ec3fd,0x6f1d01e8,0x6448c3fe,0xa3d482f1}},	//   _kita_, _risc, padi, _सेर_,
   {{0x6f1d43ff,0x1be40540,0x291ec400,0x644881b4}},	//   _sisc, कपाल_, _jita_, qadi,
   {{0x291e854e,0x764601eb,0x40340009,0x248e80ee}},	//   _mita_, _beky, сесс, _iafm_,
   {{0x96353ff8,0xf1a72927,0x291ec401,0x6d4d2adb}},	//   рнац, _брон, _lita_, tsaa,
   {{0x2d580c4f,0xf8ae004e,0x272ac402,0xe9058129}},	// [31f0] лить_, سکی_, _lùn_, _lượ,
   {{0x6d4d4403,0x6e2d0333,0x7cfd809f,0x0f35003d}},	//   rsaa, scab, tèri, _نکرد,
   {{0x6d4d4404,0xd25192dc,0x6f1d34cc,0xbc070a0e}},	//   ssaa, قنا_, _tisc, учай,
   {{0x6e22ae95,0x6f1d00f7,0x291ec405,0x0ce1a539}},	//   _ngob, _uisc, _aita_, _पद्म,
   {{0xa0698638,0x1869845d,0x68458071,0xe0458767}},	//   вала_, вали_, анла, анли,
   {{0x2f55a2fd,0x272a9b4c,0x2d990511,0x7eb5816b}},	//   атис, _bùn_, _irse_, _nápr,
   {{0x256f2d46,0x291ec406,0x628281ed,0x6d4285ee}},	//   lül_, _dita_, beoo, _awoa,
   {{0xca488307,0x443108ae,0x6d5bc407,0x2d990b80}},	//   _ملفه_, _hfz_, trua, _krse_,
   {{0x7afbb4c6,0x291ec408,0x64474409,0xa2c28f12}},	//   _ikut, _fita_, _keji, लसर्,
   {{0x6d5ba75d,0x6447000d,0x291e8f33,0xeb998eef}},	//   rrua, _jeji, _gita_, вио_,
   {{0x6447440a,0x645c8187,0xb6058115,0x7ae98163}},	//   _meji, ória, _sišč, _kjet,
   {{0x2d8b0267,0x64470b95,0x60c500dd,0xb605807a}},	//   _osce_, _leji, _alhm, _pišč,
   {{0xddc2800d,0x7afb8010,0x2611ab51,0x7ae980f1}},	//   _zbož, _mkut, देशी_, _mjet,
   {{0x7ae982fd,0xe8f72856,0x6ac28778,0x3eadc40b}},	//   _ljet, иля_, _शत्र, ljet_,
   {{0x7afbc40c,0xb8de0f8d,0x290400eb,0x2d8b0037}},	//   _okut, _आव_, ēma_, _asce_,
   {{0x5de6098d,0xc6c302a9,0x3eadaed5,0x068603a7}},	//   ажба, ойск, njet_, јган,
   {{0x1c4619fe,0xa4460d0e,0x256f440d,0x4ad80019}},	// [3200] инам, инад, gül_, _لاکھ_,
   {{0x7ae9c40e,0xf1c20824,0x3eadc40f,0x389a03de}},	//   _ajet, rišč_, hjet_, _ייִנ,
   {{0x0c790196,0xdddb8289,0x2d8b047f,0x63a30106}},	//   ысты_, jduž, _esce_, ännp,
   {{0x291ec410,0x2bda016f,0x3ebfc411,0x78a186c4}},	//   _sita_, _येणा, jkut_, _anlv,
   {{0x27f70bca,0x7ae982fd,0x3ead82ce,0x3f9a2e0a}},	//   _مفید_, _djet, djet_, _hrpu_,
   {{0x64550063,0x60dc4412,0xd8f780e8,0x7afb8c6a}},	//   _gdzi, nirm, анії_, _ekut,
   {{0x291ec413,0x3cf50072,0x65640198,0x7ae983ed}},	//   _vita_, ्तरे_, luih, _fjet,
   {{0x7ae984b1,0x12c100c8,0x3f988125,0x3ead80f1}},	//   _gjet, _উদ্দ, _árum_, gjet_,
   {{0x291ec414,0x2bda016f,0xd04a8085,0xe4a6c415}},	//   _tita_, _येता, zifə, арно,
   {{0xd49a8847,0x291e8087,0x27ed3349,0x26c900fc}},	//   три_, _uita_, şeni_, zhao_,
   {{0x60dc0850,0x256f0019,0x26c00037,0x92952ba7}},	//   dirm, zül_, kkio_, банц,
   {{0x63bac416,0x81c301a9,0xd5e2846d,0x5693804a}},	//   rytn, ņēmi, _gbo̟, _маєт,
   {{0x60dc4417,0x20b4000f,0xd534826a,0xfce69c79}},	//   firm, ुसंध, _افتخ, _кодо,
   {{0x26c681c0,0x60dc4418,0x256f0019,0x7c3b0904}},	//   _hloo_, girm, vül_, _đuro,
   {{0xb5e880c8,0x23278b30,0xab278fbb,0x64474419}},	//   _পরিচ, _који_, _која_, _reji,
   {{0x256f0019,0x3a2480b9,0xa2d6064a,0x61ed011b}},	//   tül_, _ngmp_, मोद्, _txal,
   {{0x64470699,0x60dc441a,0xdddb8754,0x44230144}},	// [3210] _peji, birm, zduž, _pgj_,
   {{0x7afb8a7a,0x7ae9911b,0x256f0019,0x60dc441b}},	//   _skut, _sjet, rül_, cirm,
   {{0x443e82af,0x9f5e80f1,0x68f88b67,0x6447441c}},	//   ibt_, _dytë_, dovd, _veji,
   {{0x21290590,0xb69b00e7,0x29034292,0x66e881d0}},	//   _kuah_, _chât, llja_, děko,
   {{0x7ae9c41d,0x3ead911b,0x644705a4,0x764d441e}},	//   _vjet, vjet_, _teji, maay,
   {{0xe8f88160,0x6455009a,0xaa7b016b,0x764d441f}},	//   алі_, _udzi, dným, laay,
   {{0x7ae988cf,0x3ead80f1,0x02a79273,0x212900ee}},	//   _tjet, tjet_, _крам, _luah_,
   {{0x7afb91e8,0x764d1a25,0x7ae9bc49,0x7980819d}},	//   _ukut, naay, _ujet, _ịweg,
   {{0x6eba0076,0x3eadc420,0x3ebfc421,0x332001b4}},	//   _एकसु, rjet_, rkut_, _riix_,
   {{0x3eadc422,0x764d0079,0x212109da,0x26c0011b}},	//   sjet_, haay, _nihh_, zkio_,
   {{0x798d1629,0x80ab14d5,0xaca30133,0x764d132f}},	//   _asaw, ञाने, _adịc, kaay,
   {{0x212914ec,0xaa7b016b,0xe1ff016a,0x799b810c}},	//   _buah_, bným, rgón_, _kruw,
   {{0xed599182,0x764d4423,0x60dc4424,0x443e80f2}},	//   _сол_, daay, tirm, bbt_,
   {{0x6c3589d7,0x2d8902f7,0xdce401a1,0x7af9c425}},	//   _افغا, dwae_, mtić, howt,
   {{0x5b358b76,0xbea60d69,0xe29a2f4b,0x60dc4426}},	//   _اعتر, бавк, _бай_, rirm,
   {{0xc2460652,0x2a6d822c,0x9f5e8168,0x2bc60697}},	//   _уник, _nceb_, _sytë_, लनसा,
   {{0x6da3024f,0x29030ee1,0xe8df9d12,0x60dc0637}},	// [3220] пита, blja_, _awọn_, pirm,
   {{0x308600f7,0x07fa003d,0x387a018e,0x0ffa01a8}},	//   _الدف, _مرجع_, _ubpr_, _معجب_,
   {{0xe29ac427,0x799bc428,0xa2e6a3e7,0x202901d6}},	//   лаж_, _aruw, божд, átiť_,
   {{0x673b0bcf,0xdce40115,0x764d01b4,0x799bc429}},	//   ćujt, ktić, caay, _bruw,
   {{0x6728ab1f,0xf1d28321,0x6f04442a,0xdce40bda}},	//   _sudj, _देखन, mlic, jtić,
   {{0x6f04442b,0x672886cb,0xaa7b016b,0x6286442c}},	//   llic, _pudj, vným, heko,
   {{0x68f884b7,0x35d086a7,0x38cb8180,0x6f043648}},	//   rovd, _तेज़, دانی_, olic,
   {{0x1dd9823c,0x6286345f,0x2bb50076,0x6f0402af}},	//   _बेहत, jeko, ंहरा, nlic,
   {{0x645c8073,0x62862cd7,0x6f04442d,0x7c29026c}},	//   ório, deko, ilic, _đerz,
   {{0x67288065,0x6f0402af,0x21290359,0x6aa40114}},	//   _tudj, hlic, _ruah_, _anif,
   {{0x6f04442e,0x23658bcf,0x764d442f,0x443ec430}},	//   klic, gulj_, yaay, rbt_,
   {{0x6286044e,0x21293ab1,0x212102f7,0xd5a48180}},	//   geko, _puah_, _sihh_, _ولای,
   {{0x6f044431,0x290300d2,0xc05b00e8,0x7ae38511}},	//   dlic, tlja_, лів_, énti,
   {{0x764d0ec8,0xf6178039,0x6f044432,0x66e50084}},	//   waay, _החדש_, elic, mėki,
   {{0x6f044433,0x628609e8,0x764d257a,0x2129008e}},	//   flic, beko, taay, _wuah_,
   {{0x6f044431,0x798d4434,0x36d40cec,0x29030699}},	//   glic, _tsaw, поср, slja_,
   {{0x29030503,0xdced1bfe,0x798d2647,0x764d3bdf}},	// [3230] plja_, stač, _usaw, raay,
   {{0x764d02ec,0xddd00162,0x66029075,0x00000000}},	//   saay, ţeşt, _myok, --,
   {{0x7c2d8214,0xdce08289,0x660283f7,0x764d033e}},	//   _şark, jumč, _lyok, paay,
   {{0x799bc435,0x26d90192,0x99998056,0x764d0df6}},	//   _pruw, _umso_, икет_, qaay,
   {{0x6458935a,0x6602925c,0xd825c436,0x6025841c}},	//   _odvi, _nyok, одли, одла,
   {{0x47598021,0x10a281f3,0x98a28323,0x62864437}},	//   ария_, дишн, дише, zeko,
   {{0xe7398009,0x6602c438,0x7e699384,0xdddb81a1}},	//   шей_, _ayok, tgep, deuš,
   {{0x2ee9031d,0x64589527,0x6602c439,0x62860cdb}},	//   nnaf_, _advi, _byok, xeko,
   {{0x6286443a,0x644ab611,0x7e69b177,0xb88380e1}},	//   veko, _befi, rgep, _príč,
   {{0x7aed443b,0x7cfdc43c,0xcd2881a8,0x753bc43d}},	//   _ajat, vèrs, حسين_, rpuz,
   {{0x62861711,0xdce4003b,0x6f04443e,0x64988196}},	//   teko, stić, ylic, стыр_,
   {{0x67228144,0x2485c43f,0x644a8032,0x6d4f8118}},	//   _gioj, selm_, _eefi, ácas,
   {{0xe56ea59a,0x644a802a,0x412a042f,0x7aed0168}},	//   _юз_, _fefi, рого_, _djat,
   {{0x8afd0d38,0x644ac440,0x186a0dc7,0x52b68fea}},	//   stęp, _gefi, јави_, _अक्स,
   {{0x6f040352,0x6441c441,0x68e480f7,0x93bc8087}},	//   tlic, mbli, éidi, scăr,
   {{0x7aed020f,0xee3a1289,0xf4128039,0x752382af}},	//   _gjat, рна_, _קפה_, _hinz,
   {{0x6f0443a6,0x764b8065,0x5d6a2306,0x6441c442}},	// [3240] rlic, _megy, ризм_, obli,
   {{0x764b8065,0x44278057,0x81c200ab,0x6441989c}},	//   _legy, _jgn_, ্পদ_, nbli,
   {{0x6f044443,0x68fc04fe,0x61fb04b7,0x93460558}},	//   plic, mord, żult, інде,
   {{0xf1db946d,0xa206b01c,0x7523c444,0xe5a62482}},	//   _मेहन, опед, _linz, _дими,
   {{0x6722957a,0x68fc01ed,0x9c7c87dd,0x4427c445}},	//   _rioj, oord, liče, _ogn_,
   {{0x257404b8,0x68fc4446,0x764b82f7,0x4427c447}},	//   mäl_, nord, _aegy, _ngn_,
   {{0x9c7c803a,0x764b8a38,0x67228388,0x660280b9}},	//   niče, _begy, _pioj, _syok,
   {{0x35b4938c,0x752b810c,0x1ef781a8,0x68fc39dc}},	//   збир, _bugz, يعية_, hord,
   {{0x65762c8d,0xd04e0201,0x0caa9a19,0x94aa9ac9}},	//   ntyh, sibə, атни_, атна_,
   {{0xf06390ef,0x7ebc880d,0x7523c448,0x2cb80370}},	//   _окуп, _répu, _cinz, _jord_,
   {{0x44278483,0x9c7c8067,0x7aed4449,0x2cb81b4a}},	//   _dgn_, jiče, _pjat, _mord_,
   {{0xf3ec0a49,0x75238352,0x04fc80c8,0x050a80ab}},	//   _করার_, _einz, ীদের_, রদের_,
   {{0x644181dc,0xead2877f,0x2574016d,0x2d968294}},	//   bbli, _rẹ̀_, jäl_, _фрес,
   {{0x64588022,0x2cb84359,0x2bca800f,0x644a80c3}},	//   _udvi, _nord_, ानदा, _uefi,
   {{0xd6db444a,0x7aed0aa8,0xcb6782ee,0x00000000}},	//   ата_, _tjat, _даје_, --,
   {{0xa5351091,0x4427890d,0x25740338,0x7e7d09c4}},	//   знач, _zgn_, fäl_, _qbsp,
   {{0x2cb8444b,0x38c900d7,0xdb17066f,0x06cd0264}},	// [3250] _bord_, _هادی_, ńców, রচলি,
   {{0x7afd444c,0x68fc07b5,0x3f9eb3bb,0x44278118}},	//   lost, cord, _ortu_, _xgn_,
   {{0xd0f80441,0x2d82444d,0xfe700019,0xfbab01e5}},	//   ंकरण_, _epke_, عدہ_, штай_,
   {{0x6ffa01c6,0x25bf8326,0x6e960061,0x3eb415d8}},	//   _להתפ, yyul_, _فلپا, ľatá_,
   {{0x64418114,0x3f9eb855,0x2cb8444e,0x764b83f7}},	//   ybli, _artu_, _ford_, _regy,
   {{0xe0d8835f,0xfbca89c2,0x55ba0039,0x752b890d}},	//   ові_, ानाम, _המשו, _rugz,
   {{0x3eb9444f,0x602283c7,0x7ebc8019,0x3f9e811f}},	//   _kost_, ндша, _néps, _crtu_,
   {{0x7e6d4450,0x0ea98364,0x7523950f,0x64418176}},	//   ngap, ский_, _sinz, wbli,
   {{0x3eb90051,0x68fc07d9,0x95558013,0x7ebc8ece}},	//   _most_, yord, أخبا, _répt,
   {{0xe73380f7,0x7ebc85e4,0x2b478114,0x6441c451}},	//   _قصص_, _sépt, _pwnc_, ubli,
   {{0x6441b958,0x7afd4452,0xe29a1510,0x68fc00c9}},	//   rbli, fost, бан_, vord,
   {{0x7afd4453,0x2907c454,0x9c7cc455,0x212d80ee}},	//   gost, llna_, viče, _kueh_,
   {{0x442780dd,0x261183eb,0x224dc456,0x75239abf}},	//   _tgn_, देखी_, _meek_, _tinz,
   {{0x97428067,0x659a812a,0x2574016d,0x27318091}},	//   šćen, _לינק, väl_, _kán_,
   {{0x3f5701cd,0x07a3140b,0x3eb94457,0x273180e1}},	//   għu_, нарн, _bost_, _ján_,
   {{0xcf92893f,0x7afd4458,0x7e6d255f,0x63bc8338}},	//   עטן_, cost, ggap, ärne,
   {{0x056636ae,0x68fc4459,0x27319cac,0x38b402af}},	// [3260] яван, pord, _lán_, _märz_,
   {{0x629610c1,0x7e6d02c4,0x9c7c82d4,0x2731827d}},	//   _hayo, agap, piče, _oán_,
   {{0x3eb9445a,0x6296445b,0xc61d00ab,0x7bc1810c}},	//   _fost_, _kayo, ধুলা_, nylu,
   {{0x2fc50bc5,0x2cb80039,0xc7b303c8,0x212d8144}},	//   ølge_, _word_, _טבת_, _bueh_,
   {{0xd24f83f8,0xe8948c5c,0x7644445c,0x673a80b9}},	//   انه_, даль, mbiy, _sttj,
   {{0x27318104,0x7afd0dee,0x20058cf0,0x629631ee}},	//   _bán_, zost, _byli_, _layo,
   {{0xd6da8987,0x764402a3,0x2731801c,0x6d5d81a8}},	//   йти_, obiy, _cán_, ásan,
   {{0x44440352,0x7c3b0d11,0x98788353,0x442a1705}},	//   lb_, _đuri, _išči_, _hgb_,
   {{0x644e445d,0x7afd445e,0x444410af,0x6d56445f}},	//   _kebi, vost, ob_, nsya,
   {{0x7ae2c460,0x44444461,0x3d068424,0xdb1b0019}},	//   liot, nb_, _सीखे_, sztü,
   {{0x44440cd8,0x2731c462,0x62961e98,0x6d56010b}},	//   ib_, _gán_, _bayo, hsya,
   {{0x644e048f,0xddc400eb,0x6d564463,0x629601e0}},	//   _lebi, maiņ, ksya, _cayo,
   {{0x64a6b031,0x6296033e,0xdca6824f,0x0e9b8039}},	//   _нада, _dayo, _нади, _לשאל,
   {{0x760b8158,0x644e4464,0x442a4465,0xf8be83eb}},	//   _פּאַ, _nebi, _ngb_, ्सिय,
   {{0x3eb90051,0x62808353,0x44444466,0x78ba9309}},	//   _post_, _obmo, db_, _motv,
   {{0x44444467,0x629602b8,0x442a02af,0x65640bbd}},	//   eb_, _gayo, _agb_, frih,
   {{0xdb1b2422,0x7e6d3da1,0xa2aa0e00,0x672601b9}},	// [3270] sztó, rgap, टार्, _dikj,
   {{0x66060aa2,0xb03523e7,0x66ca04e8,0x290701a8}},	//   _dykk, _юнош, _výka, _óna_,
   {{0x764421c7,0xa3e28540,0x62961c61,0x316c0035}},	//   bbiy, _नेम_, _yayo, ądze_,
   {{0x4444146a,0x2731c468,0x66ca026f,0x645c09c4}},	//   ab_, _rán_, _týka, _edri,
   {{0x44444469,0x27318091,0x442a446a,0x9c7c8110}},	//   bb_, _sán_, _fgb_, anči,
   {{0x644e105d,0x224d8039,0x2731816b,0xb5fb026b}},	//   _gebi, _week_, _pán_, _adág,
   {{0x7ebcc186,0xb90586a7,0x690d802a,0x644505e7}},	//   _répr, _पग_, búen, mbhi,
   {{0x3eb9808b,0x7ae2c46b,0x442a446c,0x78a8bff4}},	//   ðst_, ciot, _zgb_, _endv,
   {{0x6296446d,0x78278154,0x802782e3,0x628bc46e}},	//   _rayo, _فعال, _فرام, mego,
   {{0x2731c46f,0x628b88ff,0x62960637,0x6299c470}},	//   _tán_, lego, _sayo, ldwo,
   {{0xb4cd8076,0x62964471,0x764401b4,0x7527090d}},	//   _रती_, _payo, ybiy, _mijz,
   {{0x628bc472,0xbe15845b,0x91e61cb2,0x63a31c50}},	//   nego, _قواع, доме, änny,
   {{0x6f098c0b,0xdc0a1993,0xed4e9c3a,0x6f1bc473}},	//   mlec, _वर्ड_, _шо_, mmuc,
   {{0x7ae2c474,0x628b83a8,0x6f09c475,0x6606054f}},	//   ziot, hego, llec, _rykk,
   {{0xa3dd4476,0x62964477,0x660600e8,0x628b810c}},	//   _तेल_, _tayo, _sykk, kego,
   {{0x68e3c478,0x44442f54,0x9c7c805c,0x628bad61}},	//   hind, wb_, miča, jego,
   {{0x76444479,0x75270a0f,0x764f009a,0x644e447a}},	// [3280] rbiy, _bijz, _decy, _pebi,
   {{0x444401e9,0x6d56447b,0x6f0982af,0x6aa99670}},	//   ub_, rsya, hlec, _anef,
   {{0x9c7c803a,0x6f09b1cd,0x764f0118,0x6d5600dd}},	//   niča, klec, _fecy, ssya,
   {{0x6606447c,0xb4db0032,0x628b89ff,0x6d560122}},	//   _tykk, _atàd, gego, psya,
   {{0x68e3c47d,0x78ba9620,0x7ae2c47e,0x644e447f}},	//   find, _potv, riot, _tebi,
   {{0x68e3859f,0x7ae38511,0x6f09c480,0x6f02c481}},	//   gind, éntr, elec, _skoc,
   {{0x628ba586,0xad9b0019,0xdfd080f7,0x2a7d822c}},	//   bego, _nyúj, طية_, bfwb_,
   {{0x628b8267,0x26d2008e,0x6abb9a1f,0x656d81d6}},	//   cego, nhyo_, _gouf, _ťaha,
   {{0x68e3c482,0x2246ae8f,0x24984483,0x3f8581a1}},	//   bind, mbok_, _karm_, _eplu_,
   {{0xa2da88d4,0x68e3c484,0x78a8b64c,0x9c7c812b}},	//   पोर्, cind, _undv, fiča,
   {{0x6f09840e,0x7d0880f2,0x9c7c812b,0x24980118}},	//   blec, rlds, giča, _marm_,
   {{0x7c2d8214,0x24980502,0x2246c485,0x6d40a651}},	//   _şart, _larm_, nbok_, ppma,
   {{0x2bde8beb,0xace981f9,0x471bb5c4,0xbddb026b}},	//   _फेरा, _کرنل_, _וואג, _leèr,
   {{0x9c7c803a,0x660f81ec,0x7b76a3f7,0x212b81e8}},	//   biča, ücke, _قطعا, _èche_,
   {{0xa3dd0e18,0x0cca864a,0x764f0428,0x22469388}},	//   _तें_, िसीम, _pecy, kbok_,
   {{0x68e3c486,0x290a0144,0x929d8035,0xbbca9d40}},	//   zind, alba_, _okła, ानीक,
   {{0xa3e285b3,0x68e3c487,0x9d153e09,0x22469f0a}},	// [3290] _नेत_, yind, едач, dbok_,
   {{0x6abba246,0x68e3c488,0x628b8c2e,0xee3f01d6}},	//   _souf, xind, wego, _iným_,
   {{0xdce9805c,0x64450c41,0x6f09c489,0x3a3c8135}},	//   steć, rbhi, ylec, _ịgụ_,
   {{0x75270a0f,0x68e3c48a,0x9c13019d,0x6fae000d}},	//   _wijz, wind, _bọro, ीहरू,
   {{0x9c7c8024,0x6299c48b,0xbbca9664,0xcad80039}},	//   ziča, rdwo, ानुक, וואת_,
   {{0x26c9448c,0x3cf886a7,0x7b0382f1,0x6d5d8174}},	//   lkao_, ँवों_, tõus, ásam,
   {{0x68e3c48d,0x656d03ac,0x6abbc48e,0xfe7181a8}},	//   rind, luah, _touf, هدة_,
   {{0x68e3c48f,0xf53f0f96,0x273500f2,0x9c7c8503}},	//   sind, _tråd_, _mån_, viča,
   {{0x68e3c490,0x6f099e26,0x27350370,0x9980009a}},	//   pind, rlec, _lån_, _dziś_,
   {{0x9c7c803a,0x9742803a,0xc4d20158,0x213f82f7}},	//   tiča, šćan, ָגט_, _ituh_,
   {{0xe29a221f,0x273500f2,0x320902a3,0x28ac8aed}},	//   пан_, _nån_, _ayay_, चारि,
   {{0xe29a1597,0xd0550085,0x63bc816d,0xdce40214}},	//   чам_, mizə, ärna, ktiğ,
   {{0x9c7cc491,0xa3e600c2,0xfd5081bc,0x213f8609}},	//   mičn, _बेन_, _medị, _jtuh_,
   {{0x9c7c80ce,0x657b8c93,0x213f83e4,0x00000000}},	//   piča, mtuh, _mtuh_, --,
   {{0x9cd68051,0x657bb4e0,0x8cac866f,0x394d8176}},	//   _רוצה_, ltuh, जारो, _lwes_,
   {{0x7bda8051,0x66ca0efc,0x225f923c,0x2201019d}},	//   _מקצו, _výko, _nduk_, ụsịl,
   {{0x657bc492,0x7c3b0085,0x25798247,0x290580b9}},	// [32a0] ntuh, _şura, nèl_, _okla_,
   {{0x7ae64493,0x225f8763,0x33f6046e,0xfa1580ab}},	//   likt, _aduk_, нчес, িশাল_,
   {{0x929d809a,0x213f8573,0x24980370,0x69c64494}},	//   _skła, _atuh_, _varm_, lyke,
   {{0x213f808e,0x26c900d2,0x657b977c,0x9c7c8824}},	//   _btuh_, ckao_, ktuh, jičn,
   {{0x28ac85e8,0x9c7c8b24,0x27f200eb,0x76560041}},	//   चालि, dičn, šanā_, mayy,
   {{0x26cf90dd,0xd90d80d5,0x02cc13e5,0x257986c0}},	//   _algo_, قیق_, ासुन, dèl_,
   {{0x56948607,0x9c7c8824,0xb9250133,0x929d8035}},	//   вайт, fičn, _akpụ_, _wkła,
   {{0xd6d78009,0x39400e35,0xdd908250,0xc7b304de}},	//   еть_, _otis_, لوب_, רבה_,
   {{0x3940022c,0x929d809a,0x88869a19,0xe0dab93f}},	//   _ntis_, _ukła, _плаж, _ева_,
   {{0x6284217b,0x20128085,0x2a604495,0x20d402f1}},	//   _abio, əyin_, _adib_, _jäid_,
   {{0xdeef93cd,0x9c7c803a,0x394006c0,0x76560041}},	//   _бы_, bičn, _atis_, kayy,
   {{0xe8d901bc,0x7ec68036,0x27350106,0x28a482f1}},	//   _mpụ_, _dépê, _rån_, _गोति,
   {{0x2735016d,0x765605a3,0x66ca016b,0x248c808e}},	//   _sån_, dayy, _výkl, pedm_,
   {{0x2ec90e70,0x2a600201,0x7d018706,0x628402c4}},	//   रस्त, _edib_, cols, _ebio,
   {{0xb909035a,0xf53f13c2,0x394002f7,0x4394b61c}},	//   _मग_, _stå_, _etis_, _райс,
   {{0x5694210d,0xf1c68028,0x752a9087,0xdce40214}},	//   ласт, _đánh_, _hifz, ttiğ,
   {{0xb81680ab,0x6aad0010,0xe8d90133,0x6d44222e}},	// [32b0] াশিত_, _inaf, _apụ_, gpia,
   {{0x629d4496,0x473502de,0x9c7c8805,0x26c90503}},	//   ldso, _инос, zičn, skao_,
   {{0x290300f6,0x37e580ab,0x76560326,0x26c900fe}},	//   moja_, _পুনর, bayy, pkao_,
   {{0xd6db0160,0x25798205,0x7b2c0214,0x29032dd9}},	//   _хто_, yèl_, _ağus, loja_,
   {{0x9c7c9408,0x7bc50859,0x6f0d2f9a,0xb0ac80d4}},	//   vičn, syhu, mlac, चांग,
   {{0x25798247,0x29034497,0x9c7c9b2c,0xd0098012}},	//   vèl_, noja_, dičo, меле_,
   {{0x9c7c8ee1,0x6aad00c9,0x628f00b9,0x6f0d0635}},	//   tičn, _onaf, keco, olac,
   {{0x2579c498,0x225f86cb,0x6f0d4499,0x442e8366}},	//   tèl_, _uduk_, nlac, _agf_,
   {{0x9c7c84c4,0x213fbcf2,0x2903449a,0x7ae61f6c}},	//   ričn, _utuh_, koja_, vikt,
   {{0x6f0d3428,0x657b80dd,0x6aad449b,0xa3e282f1}},	//   hlac, rtuh, _anaf, _नेह_,
   {{0x657ba108,0x765600a4,0x7ae6449c,0xe7b59459}},	//   stuh, yayy, tikt, _جماد,
   {{0x2d4f0063,0x6e3d0267,0x6448826c,0x6f0d00e1}},	//   kże_, _nfsb, abdi, jlac,
   {{0x7d01809a,0x69d9c49d,0x7649bdd0,0x443c8163}},	//   pols, nzwe, mbey, _ffv_,
   {{0x7ae60448,0x29034319,0x442e81ec,0x61430956}},	//   sikt, goja_, _ggf_, рера,
   {{0x66e62707,0x225202c4,0x6d440114,0xd0070284}},	//   вова, _teyk_, wpia, вере_,
   {{0x6e3b8ad4,0x6f0d449e,0x246400eb,0xe3b2026a}},	//   ncub, glac, zīmē_, یرا_,
   {{0x7ae4449f,0xed570003,0xf65280be,0x765600a4}},	// [32c0] _imit, кот_, יצן_, rayy,
   {{0x672b820f,0x6f0d1a29,0xa3c88105,0x315700be}},	//   _ligj, alac, लैक_, _שיין_,
   {{0x6f0d44a0,0x7989c4a1,0x6d5bc4a2,0xd8388668}},	//   blac, _apew, hsua, _jače_,
   {{0x6146b4fb,0x765600dd,0xd0418085,0x6d440a0e}},	//   веда, qayy, _illə, ppia,
   {{0xd91089d7,0x6d5b81c0,0x7ae4038a,0x64488df6}},	//   میر_, jsua, _mmit, ybdi,
   {{0x044344a3,0x8c432341,0x65699831,0x9c7c9e1e}},	//   _верн, _вере, dreh, vičo,
   {{0x66d10106,0xc60700ab,0xdce0826c,0x20d402f1}},	//   _håka, লেদা_, lumć, _käib_,
   {{0xe81a0105,0x25a99f27,0x0cca9905,0x68e7090d}},	//   _धरना_, _šala_, िस्म, zijd,
   {{0x6569c4a4,0x80d300c8,0x628f44a5,0x672b8168}},	//   greh, _সদস্, veco, _digj,
   {{0x3946a5a7,0xe4a6916b,0x7ae444a6,0x6282c3f1}},	//   mpos_, трио, _amit, lfoo,
   {{0x290306ee,0xdced025b,0xd4978d15,0x3946989e}},	//   voja_, stać, тры_, lpos_,
   {{0x290e8114,0x7e989ef7,0x68e701ed,0xdce41f27}},	//   llfa_, _سنتر_, wijd, drič,
   {{0x6f0d0052,0x290344a7,0x68e700f3,0x4cba80ab}},	//   vlac, toja_, tijd, ইসবু,
   {{0x7ae444a8,0x394682ba,0x5ba687b6,0xd3a68087}},	//   _emit, ipos_, _ариз, _арип,
   {{0x4fc40190,0xc7c412b2,0x290344a9,0x68e700f3}},	//   аста, асти, roja_, rijd,
   {{0x6aad004f,0x8f9b83de,0x290344aa,0x212c8168}},	//   _unaf, וילי, soja_, _lidh_,
   {{0x6f0d198d,0x1be8064a,0xa6152bd9,0xa5bb2294}},	// [32d0] rlac, _टेबल_, умач, _agór,
   {{0xdce41024,0x26058424,0x03c744ab,0xe7e38074}},	//   brič, _हँसी_, ксем, _कइला_,
   {{0x645744ac,0x6f0d2183,0x273880ff,0xed46804e}},	//   raxi, plac, _nén_, _گپ_,
   {{0x69d982af,0xe8e1001c,0x6d5d44ad,0x212c8229}},	//   tzwe, _đột_, _tvsa, _aidh_,
   {{0x212c8014,0x9985987e,0x3946b88d,0xda788c4f}},	//   _bidh_, التو, gpos_, тях_,
   {{0x92e380ab,0x212cc4ae,0x69d99cb6,0x2738c4af}},	//   নকে_, _cidh_, rzwe, _bén_,
   {{0xe81e8e18,0x27388013,0x66e5802e,0x660b80ee}},	//   येला_, _cén_, лока, _sygk,
   {{0xdd91880b,0x3869880a,0x64553de3,0x6d5bc4b0}},	//   موع_, şar_, _hezi, tsua,
   {{0x6e3bc4b1,0x273881ed,0x25a68115,0x28a48c2d}},	//   rcub, _eén_, _crol_, _गोवि,
   {{0x6e3bab72,0x7b2c88c5,0x6f04002a,0x9c7ca944}},	//   scub, _uğur, zoic, ličj,
   {{0xa3d60f12,0xd0118f99,0x6d5bc4b2,0x2738c4b3}},	//   िनय_, _الا_, ssua, _gén_,
   {{0x645544b4,0xd94601f3,0x6569c4b5,0x216a035f}},	//   _lezi, леми, preh, ними_,
   {{0x60c198c5,0x3eaf80b9,0xdbc982f1,0x7d0503ed}},	//   _kolm, _ingt_, _rõõm, kohs,
   {{0x645544b6,0x273888f9,0x66d10711,0x8d5a8039}},	//   _nezi, _yén_, _råka, _טכני,
   {{0xf456810f,0x657d008e,0x66d10aa2,0x2d9944b7}},	//   _עיקר_, _aqsh, _såka, _asse_,
   {{0x66e301a1,0xdb041a1f,0x94428061,0x7ae4113b}},	//   боса, _orné, _پھین, _umit,
   {{0x645544b8,0x6f0444b9,0x25a601a8,0x3dc90122}},	// [32e0] _bezi, roic, íol_, gyaw_,
   {{0xdce40805,0x779402e3,0x6ea401ab,0x85038a74}},	//   prič, _پیرا, _चोरु, रकिट_,
   {{0x2d9900a9,0xe7e3835a,0x332daf1e,0x645510e8}},	//   _esse_, _केला_, _biex_, _dezi,
   {{0xa3c88105,0x394682c4,0x443144ba,0x2d860187}},	//   लैट_, tpos_, _egz_, çoes_,
   {{0x9f060065,0xaca401bc,0xaa5795a9,0x63a705ee}},	//   _لوگو, _atụs, الها_, _erjn,
   {{0x645544bb,0x307a00be,0xb42601ad,0x7e62c4bc}},	//   _gezi, גאַנ, _معزو, _sdop,
   {{0x26c244bd,0xbf0f835a,0x3946c4be,0x3eaf82f7}},	//   _koko_, ातून_, spos_, _bngt_,
   {{0x3ea008cf,0x2738c4bf,0x25a69d3a,0x64550234}},	//   ndit_, _vén_, _prol_, _zezi,
   {{0x2d8044c0,0xb8ea80ab,0x7ebc8019,0x26c244c1}},	//   ntie_, _লগ_, _képz, _moko_,
   {{0x60c18503,0x26c244c2,0x859700be,0x9c7c98a6}},	//   _golm, _loko_, נדיג_, mičk,
   {{0x9c7c9249,0xa92385b9,0x8cd90035,0xee868084}},	//   ličk, ížen, फोटो, _было,
   {{0xbda68154,0x57fb8039,0x26c2021e,0xdc3c8517}},	//   _محتو, _אלבו, _noko_, mšči,
   {{0x9c7c82a5,0x7bdab1d6,0xb5fb0091,0x6d42804f}},	//   ničk, sztu, _adán, _utoa,
   {{0x3aeb06c4,0x316002d6,0xa2a6864a,0x22403353}},	//   _bòpè_, _dviz_, _घोस्, _efik_,
   {{0x645544c3,0x26c200a4,0x9c7c805c,0xdc3c8353}},	//   _rezi, _boko_, hičk, nšči,
   {{0x645544c4,0x26c201f4,0xdc3c9502,0x00000000}},	//   _sezi, _coko_, išči, --,
   {{0xa3dd023c,0x26c2026b,0xdc55230e,0x645544c5}},	// [32f0] _तेज_, _doko_, ивањ, _pezi,
   {{0xf53f1918,0x9c7c803e,0x2bb884e5,0x443ec4c6}},	//   _från_, dičk, इमपा, nct_,
   {{0x5a35938c,0x92598364,0x2d8044c7,0x31600267}},	//   анет, вает_, atie_, _zviz_,
   {{0x9c7c8024,0x64550234,0xf991853d,0x60c1812c}},	//   fičk, _wezi, قبت_, _solm,
   {{0x2d8044c8,0x629f44c9,0x50b800d5,0x645544ca}},	//   ctie_, _maqo, _شدید_, _tezi,
   {{0xb4c38a61,0x645ac4cb,0xe05780d5,0x3eaf836e}},	//   _एके_, jati, ایات_, _sngt_,
   {{0x44253715,0xa3dd016f,0x60c1858f,0x645aa62b}},	//   _àl_, _तेच_, _volm, dati,
   {{0x8c0a80c8,0x9c7c9807,0x660f016d,0x0565c4cc}},	//   রধান_, bičk, _kyck, авин,
   {{0x645a80b4,0x63418029,0x057680f7,0x798d0069}},	//   fati, _mēne, لمية_, _npaw,
   {{0x660f1918,0x3b858b79,0xc48293cd,0x7aebc4cd}},	//   _myck, алог, ольк, ligt,
   {{0x660f00f2,0x2907c4ce,0x764d44cf,0x629f3670}},	//   _lyck, mona_, kbay, _baqo,
   {{0x2907c4d0,0xceb40201,0x443e85ae,0xf770806b}},	//   lona_, rmək_, act_, _رام_,
   {{0x660f016d,0x656d03ac,0x26c244d1,0xa91d8084}},	//   _nyck, jrah, _roko_, _apži,
   {{0x645a87cc,0x03a58cde,0x29079fca,0x6d4980a0}},	//   cati, _вико, nona_, mpea,
   {{0x9c7c8289,0xd8388024,0xb21b013c,0x26c206c0}},	//   zičk, _jača_, lfæl, _poko_,
   {{0xe51980a5,0x2907c4d2,0x799bc4d3,0x764d132b}},	//   _नीति_, hona_, _osuw, gbay,
   {{0x3ea044d4,0x7aebc4d5,0x656d44d6,0x6d49c4d7}},	// [3300] rdit_, digt, grah, npea,
   {{0x2d8044d8,0x9c7c8f20,0x2907c4d9,0xb4c3908a}},	//   rtie_, vičk, jona_, _एको_,
   {{0xa7fc8182,0x26c20854,0x2d80281b,0x3dbd80c8}},	//   _adın, _toko_, stie_, েছিল,
   {{0x9c7c8025,0x656d0726,0x645ab499,0x2d8044da}},	//   tičk, brah, zati, ptie_,
   {{0x69268087,0xaca40133,0xa3e60006,0x672401b9}},	//   амда, _agụr, _बेर_, mmij,
   {{0x273c221c,0x9c7c803b,0x290787e2,0x645ac4db}},	//   _kín_, ričk, gona_, xati,
   {{0x645ac4dc,0xe0b703de,0x0306064a,0x9c7cc4dd}},	//   vati, ילסט_, रवाह_, sičk,
   {{0x645a9dde,0x273c0125,0xf102001b,0xd8388088}},	//   wati, _mín_, लकुद_, _dača_,
   {{0x2907c4de,0x01cb00ab,0x38658314,0x25b0852a}},	//   bona_, _লেনদ, _fdlr_, जमेण,
   {{0x2907b227,0x273c0118,0x67240267,0xdc3c82d4}},	//   cona_, _oín_, hmij, pšči,
   {{0x645ac4df,0x764d0c27,0x50b5c4e0,0xb4d68beb}},	//   rati, ybay, _усту, _सती_,
   {{0x645a9dbd,0x6d46003a,0x672437d7,0x629f0609}},	//   sati, _otka, jmij, _qaqo,
   {{0xc05b0cde,0x79828063,0x2c06816f,0x645ac4e1}},	//   ків_, ntow, _सुरू_, pati,
   {{0x645ac4e2,0x386d02af,0xa3d6364b,0x660f0106}},	//   qati, ßer_, िना_, _ryck,
   {{0x386d07d9,0x251b812a,0x6d46252a,0x64588029}},	//   ğer_, _שווא, _atka, _ievi,
   {{0x656d44e3,0x7982809a,0xd6d80c0e,0x6458bb2d}},	//   trah, ktow, ату_, _hevi,
   {{0x764d0965,0x2907c4e4,0x798d005d,0x84470481}},	// [3310] rbay, yona_, _upaw, لخال,
   {{0x40950013,0xb89500f7,0x6458c4e5,0x67240079}},	//   _الدر, _الدع, _jevi, amij,
   {{0x64588267,0x290795a4,0xd00800a9,0x656d44e6}},	//   _mevi, vona_, _веќе_, srah,
   {{0x660f04b8,0x23670353,0x290c809c,0x69cb8106}},	//   _tyck, šnjo_, _akda_, tyge,
   {{0x7aebc4e7,0x7d08c4e8,0x6aa0982f,0x1869971c}},	//   rigt, kods, _damf, гали_,
   {{0x6458c4e9,0x66d8026f,0x7aebc4ea,0x7642826b}},	//   _nevi, _víke, sigt, _afoy,
   {{0x2907c4eb,0x6aa080fc,0x79828035,0x7aebc4ec}},	//   rona_, _famf, atow, pigt,
   {{0x20d40364,0x2907c4ed,0x66d584be,0x77f8025f}},	//   _näin_, sona_, _báka, ימוד_,
   {{0x7ae9c4ee,0x6458c4ef,0x2738801c,0x799bc4f0}},	//   _imet, _bevi, _lĩnh_, _usuw,
   {{0x2ba58341,0x6aa0c4f1,0x66d10186,0x25ff0424}},	//   _pēc_, _zamf, _såkl, _रखनी_,
   {{0x7ae98353,0x1fe58264,0xfaa600e5,0xe217824c}},	//   _kmet, _পুরস, бано, _तरुण_,
   {{0x6d5d8118,0x7afb85ee,0x6aa08580,0x6d49c4f2}},	//   ásas, _jjut, _xamf, ppea,
   {{0x4545806b,0x64a5a950,0x7ae98135,0x68e8831d}},	//   _انتق, _гала, _mmet, _ymdd,
   {{0x7afb811f,0x05b8826a,0x6458c4f3,0x6ac48054}},	//   _ljut, _خدمت_, _gevi, _वक्र,
   {{0x66d58a56,0xb8f00996,0x7b33802e,0x96db801b}},	//   _záka, _शव_, _căut, _बताउ,
   {{0x3ebf8867,0x9c7c81e2,0x7afbc4f4,0x6458913b}},	//   njut_, viči, _njut, _zevi,
   {{0xe61a102f,0x67240a0f,0x998600f7,0xb5fb01d0}},	// [3320] уда_, rmij, _الخو, _udál,
   {{0x7afbc4f5,0x7ae9c4f6,0x6724120e,0x6aa0c4f7}},	//   _ajut, _amet, smij, _samf,
   {{0x7ae98037,0x1d1683de,0xa09b0538,0x2fd00493}},	//   _bmet, צקער_, _גייט, ângă_,
   {{0x76598355,0xdbd0027f,0x9c7c943c,0x290a44f8}},	//   _newy, _užív, riči, loba_,
   {{0xe3a78986,0x78a180eb,0x6d460687,0x798280fc}},	//   _کر_, _balv, _utka, utow,
   {{0x7ae9c4f9,0xa3d50076,0x79828063,0x26c0012b}},	//   _emet, ाईश_, rtow, ljio_,
   {{0x6458c4fa,0x645e44fb,0xf0930039,0x7982c4fc}},	//   _revi, mapi, פנה_, stow,
   {{0x6458a2f8,0x645e44fd,0x26c0012b,0x26d2008e}},	//   _sevi, lapi, njio_, nkyo_,
   {{0x7cd88bba,0x7ae3838e,0x645882f7,0x7d08c4fe}},	//   имир_, ënte, _pevi, tods,
   {{0x78a1a338,0x645e1868,0x290a1c00,0xd49a9593}},	//   _galv, napi, joba_, ури_,
   {{0x387e80f6,0xa6868e17,0x241897ae,0xdee68e49}},	//   _ictr_, _глед, роны_, _ложи,
   {{0x3f9e803a,0x645e0077,0x6443807b,0x7659867f}},	//   _istu_, hapi, _efni, _gewy,
   {{0x645e272f,0x290a0267,0x612018b6,0xa6a987c3}},	//   kapi, foba_, köld, _خالق_,
   {{0x64a38d70,0x27388104,0x290a0365,0x7e7d026c}},	//   _нача, _cũng_, goba_, _scsp,
   {{0x368b0071,0x645e3afe,0x673ac4ff,0x273880ff}},	//   лсан_, dapi, _jutj, _dũng_,
   {{0xccf8800d,0x2bac04c5,0x2738801c,0xfbdf00ab}},	//   lně_, घटना, _vĩnh_, _বুঝত,
   {{0x634501e2,0x60c51d0e,0x628d4500,0x673a8168}},	// [3330] _mėne, _tohm, _ibao, _lutj,
   {{0x645e0447,0x7aef2bd5,0x290a4501,0x69cf1916}},	//   gapi, lict, coba_, myce,
   {{0x43941b47,0x3ea24502,0x16350198,0x9e350196}},	//   захс, _fakt_, _меня, _менч,
   {{0x78a1a91e,0x7aef109b,0xd0488085,0x6f09802a}},	//   _salv, nict, _ildə, xoec,
   {{0x78a18364,0x645e25b3,0x1a68815b,0xccf881d0}},	//   _palv, bapi, صیلی_, kně_,
   {{0x661d0029,0xd90f80d5,0xccf8801b,0x6d4d08e5}},	//   _izsk, ریا_, jně_, mpaa,
   {{0xccf8800d,0x2eed85f8,0x78a18399,0x25a94503}},	//   dně_, tief_, _valv, lval_,
   {{0x7ae9c504,0x7afb803b,0xee399a19,0x290a4505}},	//   _umet, _ujut, шни_, zoba_,
   {{0x7aef0bd9,0x2eed85f8,0x78a1c506,0x25a90cfa}},	//   dict, rief_, _talv, nval_,
   {{0x33658c8e,0x2eed8a0f,0x2a69208b,0x6f0496f2}},	//   овог, sief_, _adab_, čica,
   {{0x39491a67,0x2ca30065,0x66d8007b,0xf53f0711}},	//   _atas_, _majd_, _líka, _bråk_,
   {{0xc5d58d13,0xeb968009,0xc04903c8,0x6441c507}},	//   _міль, цию_, _יז_, scli,
   {{0x290a4508,0x80b500ab,0x3ea2016d,0xccf8801b}},	//   toba_, ুসন্, _rakt_, bně_,
   {{0x26d904e7,0x6efe81a9,0xccf881d0,0xceb4011c}},	//   _also_, mība, cně_, hmət_,
   {{0x6efe80eb,0x61200dfa,0x3ea24509,0x7ce90085}},	//   lība, völd, _pakt_, _görə,
   {{0x7e7bc50a,0xa3e283b6,0x290a450b,0x645e004f}},	//   ngup, _नेट_, soba_, wapi,
   {{0x0566035f,0x6efe80eb,0x6d4d2575,0xceb40085}},	// [3340] юван, nība, gpaa, dmət_,
   {{0x6aa403ae,0xa3d52743,0xdb210198,0x7b3418ad}},	//   _haif, ाईं_, ätök, _găur,
   {{0xeb9a450c,0x3ea2209b,0x3984450d,0x6aa41325}},	//   рие_, _takt_, lös_, _kaif,
   {{0x66dcc50e,0x645e0d58,0x094aa748,0x914a97c8}},	//   _kéke, sapi, ачки_, ачка_,
   {{0x673ac50f,0x645e0ed0,0xccf8801b,0x39842976}},	//   _sutj, papi, yně_, nös_,
   {{0x6aa400a4,0x83fc812b,0x6efe80eb,0xb50386b7}},	//   _laif, lađe, dība, रकोप_,
   {{0xd6daa05f,0xccf8800d,0x444400ee,0xcb670012}},	//   ити_, vně_, mc_, _маре_,
   {{0x83fc803a,0x76444510,0x44444511,0x758a891c}},	//   nađe, nciy, lc_, асов_,
   {{0x01638951,0x645c0590,0xccf8800d,0x44444402}},	//   _окто, _keri, tně_, oc_,
   {{0x44444512,0x645c4513,0x394981df,0x673a83ed}},	//   nc_, _jeri, íase_, _tutj,
   {{0x44444514,0x44384515,0xccf8801b,0x2018807b}},	//   ic_, _mgr_, rně_, _ári_,
   {{0xccf8801b,0x65644516,0x6aa42bbe,0xe8e100ff}},	//   sně_, ksih, _caif, _đốt_,
   {{0x66d58775,0x7e608590,0x64a69e25,0x6efe8029}},	//   _záko, mamp, _мада, cība,
   {{0x645c4517,0x9c7c82a5,0x7ce90085,0x69cf0362}},	//   _neri, tiču, _törə, ryce,
   {{0x7ce04426,0x6aa40300,0x40341290,0xceb40085}},	//   _körf, _faif, дерс, ymət_,
   {{0x7e60c518,0x66d5803e,0x83fc8067,0x645c4519}},	//   namp, _nákl, gađe, _aeri,
   {{0x645c451a,0x25a9451b,0x6564451c,0x4444451d}},	// [3350] _beri, uval_, gsih, fc_,
   {{0x645c0859,0x25a935da,0x200101c0,0x2bae8697}},	//   _ceri, rval_, _txhi_, टिपा,
   {{0x6d4d387f,0x6efe80eb,0x4438451e,0x6b850122}},	//   spaa, zība, _dgr_, uthg,
   {{0x4444451f,0xb5fd8353,0x6d4d0009,0x76440041}},	//   ac_, laše, ppaa, cciy,
   {{0x27ff0459,0x661d0029,0x7aed4520,0x78a54521}},	//   ğunu_, _uzsk, _mmat, _kahv,
   {{0x645c4522,0x4438016d,0x8505015b,0xb5fb00f7}},	//   _geri, _ggr_, _روزن, _ndái,
   {{0x765d0247,0x64454523,0x6722a817,0xd343015b}},	//   _kesy, mchi, _bhoj, _آفری,
   {{0x64454524,0x645c4525,0x6efe80eb,0x7e60a34d}},	//   lchi, _zeri, tība, gamp,
   {{0x645c0459,0x765d4526,0x80cc052a,0x75351a14}},	//   _yeri, _mesy, _सकले, _kizz,
   {{0x66d58a56,0xdced003e,0x75350609,0x6aa44527}},	//   _zákl, krač, _jizz, _saif,
   {{0x7ce000f2,0x64454528,0x6efe8029,0xd378812b}},	//   _förf, ichi, sība, guć_,
   {{0xf8bd80ab,0x6efe81a9,0x7aed0118,0xdced007a}},	//   _অতিথ, lībn, _cmat, drač,
   {{0x171a8158,0x14a6816f,0x83fc8289,0x6729c529}},	//   _פונע, _कोकण, vađe, mmej,
   {{0x7aed011e,0x75350c9f,0x17fa00f7,0xdca5a659}},	//   _emat, _nizz, مرأة_, _хаки,
   {{0x6aa4452a,0x753d452b,0x61e2c52c,0x3f87812b}},	//   _taif, _ausz, zzol, ntnu_,
   {{0xee3a3c3d,0xaad00076,0x3b070698,0x443801e4}},	//   сна_, _हकिक, _нещо_, _sgr_,
   {{0x83fc803a,0x4438452d,0xa3de001b,0x765d0176}},	// [3360] rađe, _pgr_, दैन_, _desy,
   {{0x65640057,0x4444452e,0x6445056c,0x3f87825b}},	//   rsih, uc_, gchi, ktnu_,
   {{0x444443c3,0x7535452f,0x6f0d062f,0x645c3396}},	//   rc_, _dizz, boac, _veri,
   {{0xd7bb004c,0x78a50289,0x4444444b,0xdce40024}},	//   _הצטר, _zahv, sc_, krić,
   {{0x60c88690,0x645c1342,0xdce4026c,0x7e60c530}},	//   _podm, _teri, jrić, vamp,
   {{0x64450698,0xdce402a5,0x9c13019d,0xb5fb046d}},	//   cchi, drić, _bọdo, _adáw,
   {{0x7e60c531,0xb8f4857a,0x61e28019,0x6d4b8110}},	//   tamp, _हक_, szol, _atga,
   {{0xb8d39370,0x6f04992c,0x35b4807f,0x7535038a}},	//   _जो_, čico, дбир, _zizz,
   {{0x7e608886,0xa06ac532,0x186a98a3,0x60229b88}},	//   ramp, _газа_, _гази_, _bímí,
   {{0x7aed0025,0x7e60b55e,0x656fc533,0xb4d6809a}},	//   _smat, samp, ácha, ससे_,
   {{0xa3be05b3,0x78a50006,0x7e609890,0x7b370b67}},	//   ेहि_, _rahv, pamp, _ućut,
   {{0x7ce00106,0x66028102,0xd7ef81a8,0xdced02d4}},	//   _förg, _txok, _حكم_, vrač,
   {{0xf2d38158,0xf1be8076,0x7ce0016d,0xaca40032}},	//   גער_, ्हिन, _körd, _awọs,
   {{0x2367012b,0x3d148740,0x765d445f,0x6299809a}},	//   šnji_, _नीचे_, _sesy, zewo,
   {{0xbebb020f,0x78a508e5,0x7ce00884,0xb5fd9809}},	//   _dhën, _vahv, _mörd, raše,
   {{0x59be8e18,0xabfb8051,0x7ce000f2,0x7aed4534}},	//   ्हार, _להור, _lörd, _umat,
   {{0xdd940084,0x65940254,0x644501c6,0x78a5209e}},	// [3370] наты, нату, tchi, _tahv,
   {{0x81e600ab,0xdced026c,0x3ea680e4,0xa11501a8}},	//   _বুক_, prač, _laot_, _زوجت,
   {{0x62998e35,0x7afd05e6,0x75350197,0x64454535}},	//   tewo, onst, _vizz, rchi,
   {{0x753d4536,0x7afd0e5d,0x64454537,0x386ca817}},	//   _tusz, nnst, schi, _addr_,
   {{0x6299be5b,0x7afd4538,0x64454539,0x7535111d}},	//   rewo, inst, pchi, _tizz,
   {{0x66d8007b,0x7afd30e5,0x008a00be,0xdce40390}},	//   _líkl, hnst, ַרפֿ, vrić,
   {{0xb4fb03eb,0x7ce007c0,0xdb240061,0x917a027d}},	//   ्वीप_, _dörd, őség, _mất_,
   {{0x24bf00c8,0xdd918872,0x3f87825b,0x26cb40d4}},	//   _ইতিহ, نوع_, rtnu_, _joco_,
   {{0x7ce029ed,0x3f87c53a,0x29010267,0xfce591d0}},	//   _förd, stnu_, _ojha_, допо,
   {{0xd13183f8,0x7afd453b,0x26cb453c,0x6729c28e}},	//   _شما_, enst, _loco_, smej,
   {{0xf77092dc,0x3169453d,0xb7d58c2a,0x00000000}},	//   _مان_, _avaz_, _تقاب, --,
   {{0xbebb020f,0xc8690051,0x2901008e,0x25a9811f}},	//   _shën, _כן_, _ajha_, _šalu_,
   {{0xdce2807a,0x3ea90106,0x6d4b80e8,0x7ce001ec}},	//   _zvoč, ddat_, _utga, _höre,
   {{0x225f8613,0x7afd2c15,0xda2081ab,0xbddb0176}},	//   _leuk_, anst, _बरसत_, _efèk,
   {{0x25ad82f1,0xaa7b06d4,0x00000000,0x00000000}},	//   lvel_, uhýc, --, --,
   {{0x2ca7b96a,0x394d826c,0xef1a0221,0x4ae206ab}},	//   _hand_, _otes_, іма_, _पतिव,
   {{0xbebb00f1,0x394d8069,0x0906237e,0x2ca7c53e}},	// [3380] _thën, _ntes_, _опин, _kand_,
   {{0x2ee0453f,0x3ea601a9,0x62840176,0x66dc88f9}},	//   shif_, žot_, _hcio, _méka,
   {{0x3940240d,0x2ca7813c,0x4f260d69,0x66dc801b}},	//   _huis_, _mand_, _одоб, _léka,
   {{0x2ca7c540,0x26cb0279,0x83fc8301,0x2d9f81bc}},	//   _land_, _goco_, nađa, kwue_,
   {{0x6143c541,0xd00f0416,0xa1588009,0x394001b0}},	//   веча, _ملی_, чалу_, _juis_,
   {{0x83fc812b,0x39404542,0xd83881a1,0x2a602b3a}},	//   hađa, _muis_, _kači_, _leib_,
   {{0xd838a828,0xb906856b,0xdb02016b,0x394dc543}},	//   _jači_, _पत_, zvlá, _etes_,
   {{0x2ca781b0,0x7e642307,0x225f8cdb,0x356a862c}},	//   _aand_, naip, _geuk_, орон_,
   {{0x25a01705,0x2ca79aad,0x20d08362,0x66dc810c}},	//   nwil_, _band_, _bàit_, _céka,
   {{0x7ce00004,0x2ca78012,0x29188019,0x38cb8065}},	//   _före, _cand_, _óra_, _والی_,
   {{0x7ce04544,0x7e643e21,0xb5fb04e8,0x917a0129}},	//   _göre, kaip, _udáv, _rất_,
   {{0x83fc803a,0xf9e700ab,0x7e6406df,0xeb9100be}},	//   gađa, _গুগল_, jaip, אָך_,
   {{0x51844365,0xaca40032,0x2ca7ab29,0xc984002e}},	//   кура, _afọr, _fand_, кури,
   {{0x6e22c545,0x39404546,0xa8030214,0x26cb4547}},	//   _izob, _duis_, _çıkm, _soco_,
   {{0x26cb4548,0x83fc8024,0xb5fd812b,0x3ea90cfa}},	//   _poco_, bađa, maša, tdat_,
   {{0xb5fd992c,0x2ca781ed,0x5694031a,0x628401a8}},	//   laša, _zand_, каст, _gcio,
   {{0x78baa4de,0x3ea94549,0xd83881a1,0x7ae289c4}},	// [3390] _ontv, rdat_, _dači_, dhot,
   {{0x2edb946d,0x78a8b78d,0xdb0401ec,0x651501ad}},	//   _बत्त, _nadv, _ernä, روائ,
   {{0x68f502bb,0x3a759a1b,0x26cb428b,0x394d8580}},	//   mizd, елер, _toco_, _stes_,
   {{0x7ce0016d,0x2911454a,0x7ae2808e,0x628f01e8}},	//   _röre, loza_, ghot, nfco,
   {{0x644ac54b,0x672d80e1,0x7ce0048d,0x99158a4c}},	//   _offi, ňajk, _söre, нькі,
   {{0x68f503bf,0x8d5a02f6,0x2911154e,0x66dcbd9b}},	//   nizd, _מכשי, noza_, _réka,
   {{0x3861034a,0x7ce004b8,0x2ca78252,0x225f90e4}},	//   _mehr_, _förb, _rand_, _teuk_,
   {{0xfaff08cf,0xf838004c,0x644ac54c,0x7ae2c54d}},	//   jnë_, ונות_, _affi, chot,
   {{0x291129f7,0x91ee00d4,0x2ca781ed,0x6f0282a6}},	//   koza_, _चेंज_, _pand_, _djoc,
   {{0x23670025,0x6284454e,0x25adc54f,0x7ce04550}},	//   šnju_, _scio, rvel_, _töre,
   {{0x394003d3,0x2ca7c551,0x6abbc552,0xa3d50701}},	//   _suis_, _vand_, _knuf, ाईट_,
   {{0x394002be,0x629d2b60,0x644a9fe3,0x660f81ec}},	//   _puis_, geso, _effi, ücks,
   {{0xa4d5835f,0x394003a7,0x3989c553,0x672d026c}},	//   _поді, _quis_, nús_, dmaj,
   {{0x628b016d,0x29114554,0x83fcac08,0xdca2bd93}},	//   _ögon, goza_, sađa, _баши,
   {{0x629d0c30,0x39899de9,0x6d4f4555,0xfd64019d}},	//   beso, hús_, _atca, barị,
   {{0x629d39f4,0x394001b0,0x6f1bbf24,0x62840b80}},	//   ceso, _tuis_, nluc, _ucio,
   {{0x7e6416da,0xe6e0000f,0x29111ea2,0xb5fb01a8}},	// [33a0] raip, _नतीज, boza_, _reác,
   {{0x25a04556,0x6d4400b9,0x6f1bc557,0xdc3c81f4}},	//   rwil_, rqia, hluc, ršći,
   {{0x7ae2c558,0xd83885a2,0x7e644559,0x27218c83}},	//   thot, _tači_, paip, zóna_,
   {{0xbee992c6,0xc7b3025f,0xca26ae65,0x69c28cdb}},	//   टफोन_, _עבר_, нфли, txoe,
   {{0xc69300be,0x6f1b8041,0x7ae2c55a,0xb21b455b}},	//   _גאר_, dluc, rhot, lfær,
   {{0x6aa900c8,0x97a69afa,0x7ae2a5f4,0x644300e1}},	//   গাযো, ерил, shot, ľnic,
   {{0x7a368a0b,0x6443000a,0x7ae28c92,0x629d00f1}},	//   _bütü, žnic, phot, yeso,
   {{0x29112c01,0x20d08706,0x7f4181b4,0x2389128a}},	//   zoza_, _càir_, _dulq, žují_,
   {{0x94868162,0x569b0051,0x8cc4064a,0x3989bdcd}},	//   нынд, ליקצ, रापो, cús_,
   {{0xdce40024,0x629d227b,0x672d01a1,0xa5bb136f}},	//   ksič, weso, zmaj, _ozón,
   {{0xb5fdc55c,0x291100ce,0x6f02816d,0x629d455d}},	//   raša, voza_, _tjoc, teso,
   {{0x38610352,0xb5fd8024,0x62828365,0x15eb8074}},	//   _sehr_, mašn, ngoo, _जेकर_,
   {{0xb5fd8699,0xaca4819d,0x29110435,0x25a0847f}},	//   lašn, _arụz, toza_, _èil_,
   {{0x644a81c1,0x52dd824c,0xddc984e8,0xba3b0901}},	//   _uffi, _मत्स, dceň, deïe,
   {{0xd6db0328,0x629d455e,0x672d455f,0x61204560}},	//   пта_, peso, tmaj, möll,
   {{0xf5e70d8e,0x629d03ed,0x61200198,0x6d428c93}},	//   нізм, qeso, löll, _kuoa,
   {{0x672d4561,0x68f516f2,0xb5fb0091,0x386100ee}},	// [33b0] rmaj, pizd, _adár, _tehr_,
   {{0xb5fd811f,0x6abb9de6,0x6aa9808e,0x672d4562}},	//   kašn, _snuf, _saef, smaj,
   {{0xb5fd8025,0xdcfb8289,0xd2518250,0xf09201c6}},	//   jašn, stuć, لنا_, _דני_,
   {{0x7e62825b,0xb5fd803b,0xf41380be,0xd838811f}},	//   _neop, dašn, אפע_, _jaču_,
   {{0x61204563,0x6f1b8a58,0x6d4f0061,0x5eef8035}},	//   köll, vluc, _utca, इफस्_,
   {{0x2d994564,0x26c902a5,0x7f41c565,0x66d5808b}},	//   _ipse_, ljao_, _pulq, _jákv,
   {{0x3989957a,0x7e628279,0x66e58652,0xbea58081}},	//   sús_, _beop, кока, вайк,
   {{0x26c90052,0x6569a55a,0x5334c566,0x66dc89c4}},	//   njao_, tseh, _бест, _déko,
   {{0xe8d904be,0x06098956,0x7e628162,0xd3788035}},	//   _awọ_, ьник_, _deop, erć_,
   {{0x6f1b8307,0x8cc40beb,0x656981ec,0xdbde808b}},	//   sluc, रायो, rseh, tíða,
   {{0x3b0a3408,0x2d99008e,0x65699831,0xd83881a1}},	//   дено_, _lpse_, sseh, _baču_,
   {{0x63b50699,0xdce9805c,0x7e629412,0xf4120039}},	//   _mrzn, kreć, _geop, שפט_,
   {{0xe7308277,0x4e7880f7,0x26c90b67,0x7ce48706}},	//   _اصل_, _أحمد_, djao_, _bòrd,
   {{0x3eada382,0x8c4281a1,0x6d404567,0xa3e11795}},	//   ldet_, _кеше, _émai, धना_,
   {{0xb90a05b3,0x2d994568,0x26cfc569,0x6282bdd5}},	//   _मत_, _apse_, _kogo_, ygoo,
   {{0x3ead8d1a,0xf7728158,0x26cf80a9,0x7e62acff}},	//   ndet_, יקל_, _jogo_, _xeop,
   {{0x26cf817f,0xb21b03ba,0x3eada63f,0x66d103ba}},	// [33c0] _mogo_, lgæn, idet_, _påkr,
   {{0xe8f7012f,0xb97b04de,0x3ead8198,0x317b007c}},	//   _аль_, _קניי, hdet_, _קרימ,
   {{0x316d82be,0x64a3431c,0x18770039,0x2d8d8198}},	//   _avez_, раха, _בעיר_, htee_,
   {{0x68e1816d,0x3ead813c,0x29058267,0x26cf82d4}},	//   _alld, jdet_, _ajla_, _nogo_,
   {{0x64430110,0x62829ba9,0x3eadc155,0x66dc89c4}},	//   žnia, rgoo, ddet_, _dékl,
   {{0x224d88b3,0xc9530039,0x7ce0016d,0x3ea0456a}},	//   _efek_, סמו_, _föra, leit_,
   {{0x7e629706,0x7ce0016d,0x26cfc56b,0x7416003d}},	//   _peop, _göra, _bogo_, _شورا,
   {{0x81e800c8,0xeb0d90be,0x753c026c,0x3ea00a2a}},	//   _যখন_, िकृत_, _hirz, neit_,
   {{0x66d5803e,0xd946a657,0x80c28fb8,0x26cfa07b}},	//   _náku, _рези, लादे, _dogo_,
   {{0x3ea0456c,0x9b588003,0x70d10665,0x224000b9}},	//   heit_, ниот_, _सकेल, _agik_,
   {{0x3ea002af,0x83fcb4c1,0x753c456d,0x26cf8317}},	//   keit_, rađo, _mirz, _fogo_,
   {{0xb4df1c7b,0x26cfc56e,0x50f28054,0xbe8581a8}},	//   _तत्_, _gogo_, _अगुआ_, _مجهو,
   {{0x3944a338,0xdb218065,0x7e7d8207,0x316d00e7}},	//   _jums_, ítés, óspe, éez_,
   {{0x3944a338,0xab650f4f,0x104b0198,0x629602ec}},	//   _mums_, ngüí, ьями_, _ebyo,
   {{0x09cb00c8,0xd8388029,0xb5fb002a,0x601823e7}},	//   _লেখা, _taču_, _adáp, воря_,
   {{0x26cf84c3,0xdce08110,0x7ce0456f,0xdce980fe}},	//   _xogo_, tumė, _röra, treć,
   {{0x1df821f6,0x9f34021e,0x753c4570,0xa5f84571}},	// [33d0] веты_, реті, _birz, вету_,
   {{0x09be80c2,0xfd62819d,0x798d0197,0x6aad0299}},	//   ्हैय, _setị, _iqaw, _haaf,
   {{0xdce9803a,0x29030024,0x3ea002af,0x66d5816b}},	//   sreć, mnja_, beit_, _záku,
   {{0x2d800c6e,0x6aad00ee,0xeb0d8072,0x7b188118}},	//   buie_, _jaaf, िकेत_, díus,
   {{0xadf0035a,0x6aad4572,0x644e026c,0x667a01c6}},	//   _घेऊन_, _maaf, _ffbi, _אטרק,
   {{0x66d80125,0x89dc0039,0x9b45045b,0x7ce005ec}},	//   _ríki, וחדי, _منسو, _hörn,
   {{0x7ce00065,0x26cfb075,0x61200106,0xd34700d7}},	//   _körn, _pogo_, följ, _شیشه_,
   {{0xbb840013,0x29034573,0x63b80366,0x6aad4574}},	//   _خلفي, hnja_, ævne, _naaf,
   {{0x3ead88f8,0x656d10c1,0x798d01c0,0x673d4575}},	//   rdet_, nsah, _nqaw, _misj,
   {{0x3ea002af,0x645e8074,0x66d8008b,0x68e1c576}},	//   zeit_, _õpil, _víki, _ulld,
   {{0xa5bb0019,0x9f558af2,0x2d8daa57,0x6aad4577}},	//   _szól, _свеч, stee_, _baaf,
   {{0xa5bb0065,0x6aad0079,0x799b819d,0x645aa676}},	//   _gyóg, _caaf, _kpuw, abti,
   {{0x69d9b9a6,0x765b80b4,0x6dc492c8,0x661d006f}},	//   nywe, mbuy, _نزول, _nysk,
   {{0x3ea002af,0xd9430012,0x290300c3,0x657b8c53}},	//   weit_, сери, gnja_, mruh,
   {{0x3ea024de,0x66e60785,0x1cb8af0a,0xdee62bf3}},	//   teit_, гова, _جانب_, гови,
   {{0xeabe80ab,0x7e55116b,0x2d804578,0xceb40085}},	//   _আত্ম, итуц, tuie_, lməz_,
   {{0x2bcb85e8,0x29034579,0x7ae4457a,0x3ea0457b}},	// [33e0] ाहका, bnja_, _ilit, reit_,
   {{0x661d009a,0xe617229c,0x2903017f,0x3f9a008e}},	//   _dysk, уду_, cnja_, _tppu_,
   {{0x7ce0016d,0x2b4f8087,0x656d009c,0x753c00eb}},	//   _förn, _încă_, asah, _virz,
   {{0x62862e8c,0x55e6197b,0x6aad0079,0x656d04e8}},	//   ngko, _бомб, _xaaf, bsah,
   {{0xf5488104,0xceb303c8,0x4427826c,0x7ae44546}},	//   _mục_, _פיש_, _lzn_, _mlit,
   {{0x6f040e3f,0xf548801c,0x7b188118,0x386a00c3}},	//   lnic, _lục_, tíus, nabr_,
   {{0xfbc78624,0x6f0415db,0x248a01e0,0x7ae4457c}},	//   _ات_, onic, _icbm_, _olit,
   {{0x6f04457d,0x6d46457e,0x290302a5,0xa3c98327}},	//   nnic, _kuka, znja_, ोहन_,
   {{0xa206abd9,0x1a069501,0x44278201,0x6f042c99}},	//   _спад, _спам, _azn_, inic,
   {{0x6d46457f,0x7ae43083,0x6f044580,0x764d4581}},	//   _muka, _alit, hnic, zcay,
   {{0xd4979006,0x2903173d,0x7ae44582,0x6d460e5a}},	//   уры_, vnja_, _blit, _luka,
   {{0x291a0870,0xf548801c,0xb5fb0019,0x51870652}},	//   _akpa_, _cục_, _beál, луга,
   {{0x6f041620,0xf5488028,0x90d580ff,0x7ce48362}},	//   dnic, _dục_, _mìn, _còrc,
   {{0x661d4583,0x6f043648,0x6aad4584,0x28c79a3b}},	//   _rysk, enic, _waaf, लायि,
   {{0x7ae44585,0xc4f7807c,0x661d0711,0x6f0401e0}},	//   _flit, _תמוז_, _sysk, fnic,
   {{0x6d464586,0x656d1400,0x29030da8,0xdce40b80}},	//   _buka, tsah, snja_, driđ,
   {{0x764d059c,0x29034587,0x6d460ad4,0x644f809a}},	// [33f0] rcay, pnja_, _cuka, ście,
   {{0x6d464588,0x764d208b,0x656d0057,0x661d4589}},	//   _duka, scay, rsah, _vysk,
   {{0x6d46458a,0xfff900d5,0x569501e2,0x6e95179e}},	//   _euka, _شکست_, _кант, _кину,
   {{0xdced0024,0x661d0f06,0x7ce00106,0x98b30087}},	//   krać, _tysk, _föro, _fixă_,
   {{0xe1358084,0x213e803c,0xaca3019d,0x09d880ab}},	//   анды, _bith_, _agục, _দেবা,
   {{0x6ae210c5,0x2618959a,0x02e20128,0xd3669a5c}},	//   _पत्र, _पड़ी_, _पत्न, _وه_,
   {{0x3f830397,0x6d460041,0x3f91011b,0x6b818118}},	//   nuju_, _zuka, ntzu_, xulg,
   {{0x6b81841c,0x6d460214,0x2d9580a1,0xfe458073}},	//   vulg, _yuka, арос, шнио,
   {{0x386a1072,0x608780f7,0xdced0088,0x51878a3d}},	//   yabr_, _مشاك, grać, _љуба,
   {{0x3f8302a5,0x81cb00ab,0xb5fb03b0,0xb4658a13}},	//   kuju_, লনা_, _reál, школ,
   {{0x3f83003a,0x78a38a10,0x9b060b5f,0x02c60225}},	//   juju_, menv, изод, айно,
   {{0xdced28e1,0x3f830052,0x4e198009,0x63b880ce}},	//   brać, duju_, _июля_, _drvn,
   {{0xd946160f,0x6286458b,0x41a702a9,0x78c48061}},	//   реги, rgko, авян_, _átvé,
   {{0x6d462ce3,0x6f040063,0xcc898077,0x412a11d2}},	//   _ruka, wnic, _شنبه_, того_,
   {{0x46f62bca,0xf5488028,0x3f8301dd,0x52760c24}},	//   ачат, _tục_, guju_, _купу,
   {{0xb5fd9809,0xfd4c801c,0x29d800e1,0xdb0ec58c}},	//   jašk, _nhiễ, eľať_, _orbá,

   {{0xe7371b47,0x7ce000f2,0xb4662e7b,0xee3a013a}},	// [3400] рет_, _förl, икал, тна_,
   {{0x6f0410d1,0x6d460503,0x3eafc58d,0x25bf19ce}},	//   snic, _vuka, _lagt_, _šulc_,
   {{0x3f830052,0x307b0039,0xf1b9826c,0x213e80f7}},	//   cuju_, _באינ, _arš_, _rith_,
   {{0x2918458e,0xeb968158,0x213e8a2a,0x68fc080a}},	//   lora_, ידער_, _sith_, lird,
   {{0x332d82a3,0x80c29d17,0x26cd80d2,0x7ce0458f}},	//   _dhex_, लाले, djeo_, _hörm,
   {{0xdced0024,0x78a3c590,0x6aa28174,0x307a03de}},	//   vrać, genv, seof, דאַנ,
   {{0xe3a783f8,0xa3ba0006,0x96f88056,0x7ee6b14a}},	//   _بر_, _अछि_, лект_, ицие,
   {{0x213e873a,0x29184591,0x68fc0285,0xd6d78198}},	//   _with_, hora_, hird, иты_,
   {{0x3f830025,0x29182bd4,0x68fc007e,0xaa7b04e8}},	//   zuju_, kora_, kird, hkýc,
   {{0x63b8800d,0x29183724,0x14c9036d,0x7bda9c28}},	//   _prvn, jora_, रायण, tytu,
   {{0x26c20364,0x68fc07c0,0x66e683bd,0xa113853d}},	//   _onko_, dird, _кожа, _بولت,
   {{0x83fc8024,0xdced02a5,0x3f830b67,0x32674592}},	//   nađi, prać, vuju_, штов,
   {{0xbddb1b09,0xf8da86a7,0xe4e680e8,0x7d1c04e8}},	//   _agèn, _बकाय, _війн, _okrs,
   {{0x3f831cbc,0x26c206c0,0x68fc4593,0x3a20076d}},	//   tuju_, _anko_, gird, _dyip_,
   {{0xbb849e95,0x438480f7,0x2ee9031d,0x533514f6}},	//   _العي, _العق, thaf_, _лект,
   {{0x2fcd003a,0x643b8833,0x2d920901,0x3f911fa4}},	//   ćeg_, _בעונ, ftye_, rtzu_,
   {{0x7afd4594,0x29184595,0x3f830052,0x2d84c596}},	// [3410] mist, bora_, suju_, nume_,
   {{0x29184597,0x7ce000f2,0x3f830024,0xfd100290}},	//   cora_, _förm, puju_, وجل_,
   {{0xaa7b0a56,0x69dd2280,0x7ce002bb,0x3949022c}},	//   ckýc, lyse, _görm, _huas_,
   {{0x7b1d05e4,0x39494598,0x2d849611,0x83fc8042}},	//   céut, _kuas_, kume_, gađi,
   {{0x2d84c599,0x78a38d35,0xf1a7abca,0x26cd826c}},	//   jume_, tenv, ррен, vjeo_,
   {{0x3eaf8189,0x39490069,0x31580039,0xac191a0b}},	//   _sagt_, _muas_, סיון_, _богу_,
   {{0x7afd2a37,0x3949459a,0x3a8787ac,0x48788d13}},	//   kist, _luas_, _вызв, рсія_,
   {{0x7afd459b,0x78a3907f,0xb5fd8067,0xf1b9826c}},	//   jist, senv, laši, _trš_,
   {{0x7afd2cb8,0x39490014,0x25a90948,0x2d84c59c}},	//   dist, _nuas_, nwal_, gume_,
   {{0x50db8128,0x7e6d2f77,0xb5fd833b,0x7afd0a52}},	//   _भविष, haap, naši, eist,
   {{0x291802a5,0x7ce004b8,0x7e6d459d,0xa3d70076}},	//   vora_, _börj, kaap, िहि_,
   {{0x394909ca,0xc049007c,0x2ee68122,0x7b1d0118}},	//   _buas_, _טז_, _glof_, déus,
   {{0x394923f0,0x2d84802a,0x68fc03bf,0xb5fd8390}},	//   _cuas_, cume_, tird, kaši,
   {{0x6443003a,0x6d5b8812,0x3949459e,0x25a91dde}},	//   žnij, mpua, _duas_, dwal_,
   {{0x7afd459f,0x291845a0,0x2ca5a862,0x5eaa80c8}},	//   bist, rora_, meld_, কারে,
   {{0xe9ff801c,0x70160f97,0xf54880ff,0x6306003d}},	//   _ngắn_, _दुःख_, _mụn_, _دوبل,
   {{0xf50a11b3,0xaa7b03fb,0xb5fd812b,0x70b7801b}},	// [3420] гнал_, skýc, faši, _आफूल,
   {{0x77ca14d6,0xad9b0118,0xb5fd817f,0xee374592}},	//   _блог_, _axús, gaši, сну_,
   {{0x493b0051,0x7b1d0511,0x3ea601a4,0xaf0a006b}},	//   _תגיו, péut, _линг, _مقدم_,
   {{0x7ce02203,0x6d5b8359,0x2907c5a1,0x2ca5c5a2}},	//   _körk, kpua, enna_, held_,
   {{0x2ca5c5a3,0x83fc805c,0x67242dbe,0xb5fd9351}},	//   keld_, rađi, mlij, baši,
   {{0x7afd45a4,0x7ce00ffd,0xceb40085,0x836a003d}},	//   zist, _mörk, ldə_, _مصرف_,
   {{0x2249807d,0x442a010c,0x8f34c5a5,0x79860caa}},	//   žaka_, _uzb_, оекц, hukw,
   {{0xceb402bf,0x7afd45a6,0x29078307,0x2d84c5a7}},	//   ndə_, xist, anna_, tume_,
   {{0x672445a8,0xceb30039,0x2ca581ec,0x6d5b809c}},	//   ilij, ליה_, feld_, gpua,
   {{0x394945a9,0x7afd45aa,0x2d849c2d,0x2ca58574}},	//   _ruas_, wist, rume_, geld_,
   {{0xa3e805b3,0x394945ab,0x2a690006,0xceb40201}},	//   यनि_, _suas_, _peab_, kdə_,
   {{0x394901e9,0x67240253,0x798606bb,0x2d801142}},	//   _puas_, jlij, fukw, krie_,
   {{0x3949022c,0x672400d2,0x656f80f7,0x7e6d43e1}},	//   _quas_, dlij, ácht, vaap,
   {{0x7afd45ac,0x394901c0,0x1c0802f1,0x69dd0901}},	//   sist, _vuas_, वपाल_, ryse,
   {{0x7afd410b,0x64430805,0x7d1ac5ad,0x6e22808e}},	//   pist, žnik, mots, _hyob,
   {{0x394945ae,0x7ce000f2,0x3f7302a5,0xaae708ca}},	//   _tuas_, _förk, rću_, _دستو,
   {{0xb5fd8289,0x2907c5af,0x7ce009ce,0xf8ae053d}},	// [3430] taši, ynna_, _görk, رکی_,
   {{0xfaff037a,0x5c750071,0x9c470fbf,0xf99001a8}},	//   lië_, ілет, схал, _أبي_,
   {{0x672445b0,0x2d8045b1,0x28c781a2,0x7e6d2460}},	//   blij, arie_, लासि, paap,
   {{0x2d80002e,0x291eafbb,0x63ae00dd,0xfaff06a8}},	//   brie_, _akta_, _dsbn, nië_,
   {{0xdd86a6f1,0x6e22c5b2,0x9fa2807b,0x7d1ac5b3}},	//   _تو_, _nyob, _síða_, kots,
   {{0xb4d78076,0x7bc5807b,0xa3b6000f,0x6eea01ac}},	//   _सवे_, _áhug, जिश_, _výbe,
   {{0xdb0b0207,0x2ca5beea,0xe3b31ef5,0x60dc007c}},	//   _esfé, veld_, _عرس_, רקונ,
   {{0xba7784c0,0x2ca5baa7,0xe5798d69,0xa3b60768}},	//   _داست, weld_, ази_, जिर_,
   {{0x7ae987d9,0x7afbc5b4,0x2ca5c5b5,0xfaff074c}},	//   _ilet, _imut, teld_, dië_,
   {{0x6d5ba08b,0xceb40085,0x67240140,0xdced09d1}},	//   rpua, zdə_, zlij, ksač,
   {{0x2ca590f4,0x7ae9c5b6,0xeb9995fc,0x130a0009}},	//   reld_, _klet, шин_, иной_,
   {{0x628b9d29,0xdb1c82be,0x3f879db9,0x7afb8372}},	//   nggo, _arrê, munu_, _jmut,
   {{0x7ce000f2,0x7d1ac53e,0x3f87880a,0xec6e8ea2}},	//   _förh, bots, lunu_, _оп_,
   {{0x6d59c5b7,0x7ae9c5b8,0x64470168,0x7ae2c5b9}},	//   _itwa, _llet, _ngji, zkot,
   {{0xb9020076,0x48e1acdd,0x7ae9837b,0x672445ba}},	//   _दव_, _कवनो_, _olet, tlij,
   {{0x6d43bcef,0xbebb020f,0x6f0985ef,0x6d4ba578}},	//   _hina, _shër, nnec, _kuga,
   {{0x6d43c5bb,0x67240613,0x6d4bc5bc,0xceb40086}},	// [3440] _kina, rlij, _juga, rdə_,
   {{0x67240582,0x6d4bb06f,0x2d801337,0x6d43c5bd}},	//   slij, _muga, rrie_, _jina,
   {{0x6d4bc5be,0x6d439d29,0x672400d2,0xa09b00be}},	//   _luga, _mina, plij, _דייט,
   {{0xe29aa569,0xdcfba3e3,0xd2509b9a,0x6d43c5bf}},	//   рад_, druč, رنت_, _lina,
   {{0x6d43811e,0xdb218019,0x6f1b801b,0x6d4bc5c0}},	//   _oina, ítás, douc, _nuga,
   {{0x7ae9c5c1,0x6d43c5c2,0xfbc99a1c,0x3a2d8da8}},	//   _elet, _nina, िमाम, _dzep_,
   {{0x6d598542,0x6d4bc5c3,0x7ae992ed,0xd90d87d2}},	//   _atwa, _auga, _flet, دیل_,
   {{0x6d4bad58,0x7c2e45c4,0x6d43c5c5,0x644700f1}},	//   _buga, _izbr, _aina, _zgji,
   {{0x6d4bc5c6,0x29008187,0x6d4380f8,0xe4a6948d}},	//   _cuga, éias_, _bina, орно,
   {{0x6d4b84a7,0x6d43c5c7,0x332681b9,0xb5fd81a1}},	//   _duga, _cina, llox_, jašu,
   {{0x6d598352,0x2e4e81bc,0x6d4bc5c8,0x7d1ac5c9}},	//   _etwa, _dọrọ_, _euga, rots,
   {{0x2eed9a16,0x6d438357,0x7c2e008e,0x6f1b8036}},	//   chef_, _eina, _mzbr, couc,
   {{0xc6499ddd,0xfaff0cfa,0x6d4b8978,0x2e4e81bc}},	//   _اجمل_, rië_, _guga, _fọrọ_,
   {{0x6d438bf2,0xfaff45ca,0x3a2482c4,0x7c2e04e8}},	//   _gina, sië_, _mymp_, _ozbr,
   {{0x291c8087,0x466b0323,0x6d4bc5cb,0x7c238428}},	//   iova_, ирам_, _zuga, _gynr,
   {{0x291cc5cc,0x6d43aef4,0xa3c99370,0x6d4ba6e8}},	//   hova_, _zina, ोहर_, _yuga,
   {{0x61200065,0x83fc803a,0xdd940110,0x344b0878}},	// [3450] tölt, rađu, маты, ачен_,
   {{0xb5fd8052,0x7ae98bc5,0x61320366,0x6f008041}},	//   mašt, _slet, gæld, himc,
   {{0xf092004c,0xb5fd8025,0x141900f7,0x2249008e}},	//   _אני_, lašt, حياة_, _kgak_,
   {{0x9948015b,0x224900ee,0x26c6819d,0x79828035}},	//   _دلیل_, _jgak_, _nnoo_, frow,
   {{0x386c8267,0x6f00817f,0xdce98088,0x7982a17a}},	//   _bedr_, dimc, zređ, grow,
   {{0x6d4bc5cd,0x3ea945ce,0x463a03c8,0xe4a401a1}},	//   _ruga, leat_, _לערע, _орсо,
   {{0x6d43c5cf,0xf77180f7,0x98a280e8,0x2721816b}},	//   _rina, ءات_, хище, zónu_,
   {{0x6d43c5d0,0xdce98eef,0x7afb8578,0x2249015d}},	//   _sina, vređ, _umut, _ngak_,
   {{0x6f09c5d1,0x6d43b877,0x291c8067,0xddcb80eb}},	//   rnec, _pina, bova_, _iegū,
   {{0xa3df0b3b,0x22490867,0x6f1bc5d2,0x291cc5d3}},	//   _तथा_, _agak_, souc, cova_,
   {{0x6d43c5d4,0x6f00803a,0x644f809a,0x2a6d8069}},	//   _vina, bimc, ścio, _keeb_,
   {{0x26d9062f,0x6d4bc5d5,0x6d43c5d6,0x2121008e}},	//   _noso_, _tuga, _wina, _akhh_,
   {{0x6d4392e8,0x2a6d81c0,0x6d59c5d7,0xdc3c80eb}},	//   _tina, _meeb_, _utwa, kšķi,
   {{0xdce990d3,0xd47980be,0x2a6d8cd8,0xe8e100ff}},	//   pređ, _האַל, _leeb_, _đợt_,
   {{0xa3cc890a,0xb5fdb1a7,0x26d945d8,0xe0161513}},	//   रमण_, rašu, _boso_, _दुखद_,
   {{0x9c7c83fb,0x3f51801c,0x2a6d8069,0xc7b280be}},	//   nkčn, _máu_, _neeb_, עבן_,
   {{0x0d860071,0x6da3079e,0x25ada42f,0x272191a9}},	// [3460] ялан, нита, nwel_, lóns_,
   {{0xe52311c7,0x6ab60915,0x5fbd8651,0x39458687}},	//   едуп, _hayf, ्माल, _nils_,
   {{0x6132013c,0xeb9a1ed1,0x68e1345e,0x6ecc001b}},	//   ræld, сие_, ölde, हादु,
   {{0x2a6d81e9,0x3ea90609,0x3f8a0bb1,0x79828035}},	//   _ceeb_, ceat_, mubu_, trow,
   {{0x6ab61c33,0x7d01c5d9,0x25ad80f3,0x3f9845da}},	//   _mayf, kils, jwel_, ltru_,
   {{0x394d87e2,0xd90d89a7,0xdb07807b,0xed5713d1}},	//   _dues_, لیق_, _brjó, _хор_,
   {{0x3f980193,0x2a6d8069,0x7c2e2e63,0xb5fd811f}},	//   ntru_, _feeb_, _uzbr, zašt,
   {{0x291cc5db,0xc7b30039,0x7d1e016d,0x7982809a}},	//   sova_, תבה_, lops, prow,
   {{0x291c8503,0x3945c5dc,0x6f009040,0x2167c5dd}},	//   pova_, _fils_, rimc, _нити_,
   {{0x3f8a45de,0xb5fd80fe,0x61e28176,0x27218118}},	//   kubu_, vašt, myol, fóns_,
   {{0x7ce004b8,0x61e283f7,0x2a6d81c5,0xf8b3807c}},	//   _förv, lyol, _yeeb_, _רשע_,
   {{0x2a6d81e9,0xdb0e8980,0xb5fd8669,0x6b888366}},	//   _xeeb_, _arbú, tašt, rudg,
   {{0x61e2c5df,0x7d01c5e0,0xa3b306af,0x26d91ab3}},	//   nyol, bils, _जैन_, _roso_,
   {{0x26d945e1,0x7d578039,0xa63b8039,0xb5fd943c}},	//   _soso_, _ציוד_, _הגדר, rašt,
   {{0xb8f5000f,0x7d1e0573,0x26d90573,0x2721802a}},	//   _सच_, dops, _poso_, cóns_,
   {{0xdb1583a8,0xb5fd9351,0xf7700061,0xd6d804dd}},	//   _orzá, pašt, طاف_, пту_,
   {{0xceb40201,0xf6500064,0x7aed45e2,0x26d901df}},	// [3470] vlət_, ائف_, _ilat, _voso_,
   {{0x6eea026f,0x3ea945e3,0x2a6d822c,0x394d8036}},	//   _výba, seat_, _seeb_, _rues_,
   {{0x2a6d81c0,0x3ea945e4,0xa7740162,0x0edc80c2}},	//   _peeb_, peat_, _плэч, _बवंड,
   {{0x394d85b4,0x60c88006,0x628f005d,0x2a6d8cd8}},	//   _pues_, _andm, ngco, _qeeb_,
   {{0x272187f4,0x6f0d394e,0x3f51c5e5,0x394dc5e6}},	//   zóns_, mnac, _sáu_, _ques_,
   {{0xa3cc83bb,0xa3be800d,0x394d82be,0x47598b33}},	//   रमा_, ीमा_, _vues_, ория_,
   {{0x2a6dc5e7,0xceb40085,0x7d01c5e8,0x25ad8197}},	//   _teeb_, mlər_, vils, wwel_,
   {{0x6d471067,0x6458813c,0xceb40085,0x443100b9}},	//   _hija, _afvi, llər_, _izz_,
   {{0x6d4f002e,0x6d4745e9,0xa2d109c2,0x7d019277}},	//   _juca, _kija, धान्, tils,
   {{0x7aed45ea,0x6ab60179,0x7ce023fe,0x6d4f0079}},	//   _alat, _sayf, _föru, _muca,
   {{0x6d4f45eb,0x7ce00019,0x2d848dd7,0xa3b6009a}},	//   _luca, _törv, arme_, जिए_,
   {{0x7aed45ec,0x6d5d4405,0x272181df,0x7d01c5ed}},	//   _clat, _otsa, róns_, sils,
   {{0x2360805c,0xe8160076,0x80b4809a,0xceb40201}},	//   _čije_, _दुजा_, _इसमे, klər_,
   {{0x7aed12d9,0x6d4745ee,0xdcfb80eb,0x6729c5ef}},	//   _elat, _nija, bruā, llej,
   {{0xd9431172,0x6d5d1d4c,0x6143280f,0x7aed45f0}},	//   тери, _atsa, тера, _flat,
   {{0x6d4f45f1,0x6f0d45f2,0xdced00c3,0xbfc3047f}},	//   _buca, gnac, drađ, ъбск,
   {{0x290342e3,0xcb130051,0x44278355,0x3f9845f3}},	// [3480] bija_, _שלח_, _hyn_, stru_,
   {{0x3e6c0104,0x7aed45f4,0x6d4f45f5,0x6f0d330f}},	//   ết_, _zlat, _duca, anac,
   {{0xdced003a,0x6d4745f6,0x7d1e2771,0x6d4f03cd}},	//   građ, _dija, rops, _euca,
   {{0x44279d33,0x673b809a,0x60dac5f7,0x7d1e45f8}},	//   _myn_, jmuj, _sotm, sops,
   {{0x6fc08076,0x6d4745f9,0xceb40201,0x4427b07d}},	//   विभू, _fija, blər_, _lyn_,
   {{0x6f0403e4,0xdced0503,0x764b8c2e,0xd25982d6}},	//   liic, brađ, _aggy, _efņ_,
   {{0x672985a4,0xb8d69278,0x62880110,0x4427c5fa}},	//   flej, _जस_, ėdoj, _nyn_,
   {{0xd6d08013,0x6d4f0388,0x6729807a,0x3f808110}},	//   اقة_, _yuca, glej, čiu_,
   {{0xa3b61a46,0x7ce000f2,0x9f4545fb,0x6459009a}},	//   जिक_, _fört, álé_, świe,
   {{0x6f0d009a,0x764b8365,0x290304b7,0x2cb801a1}},	//   znac, _eggy, xija_, _jard_,
   {{0x4427831d,0x6ef1013c,0x7ce012d2,0x2cb8022b}},	//   _cyn_, _håbe, _hörs, _mard_,
   {{0x44278114,0x2d4d017f,0x29033907,0x8c3c8214}},	//   _dyn_, _užeg_, wija_, neği,
   {{0xf2d3893f,0x7aed012b,0xdced011f,0xceb4011c}},	//   דער_, _vlat, zrađ, ylər_,
   {{0xa6db008b,0x442785b1,0x6d4f2637,0x6ef10646}},	//   _viðm, _fyn_, _ruca, _måbe,
   {{0x6d471f3a,0xd6db1928,0x7aed003d,0x4427c5fc}},	//   _rija, ота_, _tlat, _gyn_,
   {{0x6d4f003b,0x6d4745fd,0x2cb80cfa,0x2cacc5fe}},	//   _puca, _sija, _aard_, ledd_,
   {{0x2cac831d,0xceb40085,0x9df9098d,0x50670081}},	// [3490] oedd_, tlər_, чнат_, _отна,
   {{0x6f0d45ff,0x973c8d26,0x2cb8062d,0x2cac8114}},	//   snac, _općo, _card_, nedd_,
   {{0xceb40086,0x6d474600,0x6720911b,0x673b8035}},	//   rlər_, _vija, komj, ymuj,
   {{0x7ce04323,0x521580e5,0x2cac831d,0x6d4737c0}},	//   _börs, ндет, hedd_, _wija,
   {{0x865a0051,0xa9698258,0x2169a2ea,0xb65a007c}},	//   _מדרי, чила_, чили_, _מדרש,
   {{0x798bc601,0xa3be82f1,0x2cb84602,0x3eb932c7}},	//   rugw, ँटा_, _gard_, _hast_,
   {{0xddc600eb,0x3eb94603,0x67298074,0xf1b9816b}},	//   _iekš, _kast_, tlej, _myši_,
   {{0x7ce04604,0x8c3c87d9,0xb4db0722,0xe9ff8129}},	//   _förs, ceği, _guàr, _ngần_,
   {{0x7ce04605,0x99678221,0x7cf2013c,0xe8d9082e}},	//   _tört, _італ, _færd, _atọ_,
   {{0x67bb8060,0x644e8289,0xdb0b4606,0x0d828e11}},	//   _واضح_, žbin, _erfü, ыльн,
   {{0xab2a1c79,0xc2090039,0x7ced80f7,0x6729c607}},	//   зона_, _פה_, _cúra, plej,
   {{0x7af98059,0xbebb0168,0xf41203de,0x2a7f8197}},	//   _çatı, _skën, רפט_, _jdub_,
   {{0x3eadc608,0xaca38135,0xc33284de,0x4427c609}},	//   meet_, _arụk, טוט_, _wyn_,
   {{0xdce98279,0x3eadaada,0x7cf2006a,0x80bf8264}},	//   dseć, leet_, _kære, ্সক্,
   {{0x07a300c4,0x6ee302f1,0x8fa317c8,0x3eb9460a}},	//   ларн, _lõbu, ларе, _bast_,
   {{0x3ead8364,0x6eea003e,0x224d82d5,0x26dda0d2}},	//   neet_, _výbo, _ngek_, _jowo_,
   {{0x7cf20bc5,0x395f8282,0x629600b4,0x6f04460b}},	// [34a0] _lære, _ntus_, _icyo, riic,
   {{0x050000ab,0xdd8f12dc,0x6f040362,0x26ddc60c}},	//   ্ত্র_, صوم_, siic, _lowo_,
   {{0x3eb9460d,0x66e61f50,0x3ead956e,0xaca401bc}},	//   _fast_, _зона, keet_, _nzụr,
   {{0x69c4460e,0x3eb9460f,0x60de4610,0x3ead8198}},	//   _krie, _gast_, _hopm, jeet_,
   {{0x2cb84611,0x6726021e,0x7ce0016d,0xe8948c5c}},	//   _tard_, _ikkj, _dörr, валь,
   {{0x65644612,0x7cf20aa2,0x6ef1006a,0x290e8333}},	//   mpih, _bære, _våbe, unfa_,
   {{0x7ce000f2,0x25a68696,0x09d880ab,0x7cf2013c}},	//   _förr, _spol_, _দেখা, _værd,
   {{0x8f9b0451,0x61e601e2,0x539b0039,0x26dd8b99}},	//   ליצי, kykl, _מילו, _cowo_,
   {{0x55068a41,0x10a6a33f,0x3f8780d2,0xdce28bcf}},	//   ечна, _пиан, arnu_, _svođ,
   {{0x5597093f,0xfd4d019d,0xdb1581ec,0x7e7688ae}},	//   עדיע_, _aghị, _erzä, _šapć,
   {{0xccf30051,0x2cac8514,0x644e01bc,0xe1ff808b}},	//   רכת_, redd_, _mgbi, _þór_,
   {{0x2cac8514,0xa6db007b,0x39524613,0xf1bf03f2}},	//   sedd_, _viðk, _buys_, tvá_,
   {{0xfce697f9,0x2b493404,0x3eb92ed5,0x645c0aa8}},	//   _подо, _viac_, _rast_, _ofri,
   {{0x313515b7,0x7521823e,0x3eb90a53,0x2c86826b}},	//   тегр, colz, _sast_, _dídà_,
   {{0x6280803a,0xdce28024,0x78bab860,0x3ea02cf0}},	//   _odmo, _uvođ, _matv, ffit_,
   {{0x645c4614,0x69c40051,0x644e4615,0x6d4aa813}},	//   _afri, _frie, _agbi, _hifa,
   {{0x6d4ac616,0x65640bb1,0x7d250019,0x644e0609}},	// [34b0] _kifa, gpih, نفرن, _bgbi,
   {{0x645abb09,0x29014617,0x3f8ec618,0x6d4ac619}},	//   ncti, _umha_, kufu_, _jifa,
   {{0xa6db007b,0x6d4a804f,0x3eb9319a,0x7cf203ba}},	//   _liði, _mifa, _tast_, _bærb,
   {{0x6abd2a4f,0xf6790158,0x7c2a8aff,0x877a007c}},	//   ndsf, _קאָמ, _myfr, _קארי,
   {{0x645c031d,0x442b80ff,0x6abd2023,0x7c2a8428}},	//   _ffri, ́c_, idsf, _lyfr,
   {{0x672d461a,0x3ead867f,0x6d4ac61b,0x91e28dac}},	//   llaj, weet_, _nifa, роше,
   {{0x3ead88e5,0x8aa781e2,0x6fb280f7,0x61e60402}},	//   teet_, _прад, لموا, zykl,
   {{0x78a4803a,0x7cf20257,0x645a802e,0x672d423b}},	//   điva, _være, ecti, nlaj,
   {{0x23608067,0x6d4ac61c,0x7ce0461d,0x78ba8088}},	//   _čija_, _bifa, _körp, _fatv,
   {{0x2d838805,0x82348013,0x78bac61e,0x7bc3826c}},	//   čje_, _إرفا, _gatv, _prnu,
   {{0x7c2a8355,0xc6e7835f,0x6abb8352,0x6d4ac61f}},	//   _cyfr, _підп, _kauf, _difa,
   {{0x69c44620,0x2907c621,0x29110098,0xe1ff4622}},	//   _prie, lina_, enza_, rbón_,
   {{0x6d4aab40,0x399b83a7,0x2d8d876b,0x95e98019}},	//   _fifa, nês_, quee_, _تباہ_,
   {{0x69c424de,0x6abb90f6,0x2d89067f,0x6d4a8a03}},	//   _vrie, _lauf, drae_, _gifa,
   {{0x7c2a831d,0x61e60b73,0xf0928039,0x81d780ab}},	//   _gyfr, sykl, ינם_, ানি_,
   {{0x2907c623,0x29114624,0xe1f21381,0x672d38de}},	//   hina_, anza_, _نسخ_, glaj,
   {{0x2907c625,0x60de4626,0x657bc627,0x7afd03ed}},	// [34c0] kina_, _topm, nsuh, ërte,
   {{0x81d780c8,0x7ce4809f,0x25b2079f,0x656409ca}},	//   ানা_, _fòru, rwyl_, rpih,
   {{0x2907803a,0x672d4628,0x644f809a,0x1fbd8035}},	//   dina_, blaj, ściw, ्मोड,
   {{0x66e61511,0x672d06a5,0xe1ff0019,0x2d891b56}},	//   _рома, claj, kból_, brae_,
   {{0x78baac62,0x6459009a,0x2907c629,0x7ce0016d}},	//   _patv, świa, fina_, _förp,
   {{0x28d5462a,0x97a69541,0x645c462b,0xa3b3462c}},	//   दायि, врил, _ufri, _जैव_,
   {{0xdfd080f7,0x6abb9c7d,0x8b26a2f6,0x28c781a2}},	//   صية_, _fauf, _адве, लाजि,
   {{0xa3d584e5,0x1ae3b33d,0x3f8ec62d,0x399b8187}},	//   समन_, _косм, rufu_, bês_,
   {{0x2907be55,0x399b8073,0x81e700ab,0x3f8e8b3f}},	//   bina_, cês_, _যেন_, sufu_,
   {{0x799d01c0,0xf212819d,0x6abb866f,0xfd4e0135}},	//   vtsw, bọrọ, _zauf, wekọ,
   {{0x6d4a8010,0xd251003d,0x69c2874c,0x7ae081f6}},	//   _vifa, ینگ_, lvoe, _komt,
   {{0xb69b0087,0x7ce48580,0x6d4a818f,0x69dd87b6}},	//   _amân, _aòrt, _wifa, _àsec,
   {{0x69c2910f,0x6abd04e1,0x394cc62e,0x7ae3841c}},	//   nvoe, rdsf, _kids_, ênti,
   {{0x55778158,0x7ae0a499,0x2d89067f,0xf548827d}},	//   _יעדן_, _lomt, vrae_, _cụt_,
   {{0x799d01c0,0xa6db007b,0xa3cc86a7,0x7ce48a2a}},	//   stsw, _miðv, _रपट_, _dòrt,
   {{0x6609007b,0x394ca06a,0x2d89462f,0xd5b69a3b}},	//   _þekk, _lids_, trae_, _अनाज,
   {{0x672d4630,0x06c500ab,0x2907a28d,0xd49b1775}},	// [34d0] rlaj, _একদি, yina_, дре_,
   {{0x290787f4,0x2d89002a,0x7d08826c,0x2c7c01d0}},	//   xina_, rrae_, nids, vádí_,
   {{0xa3d584e5,0xd251990c,0x6ef5a27d,0xa3b302f1}},	//   समय_, منا_, _hábe, _जैश_,
   {{0x7ae087fa,0x2907c631,0x7d088392,0xaad606a7}},	//   _comt, wina_, hids, धायक,
   {{0x4aa51d01,0xdcef0201,0xf99f0247,0xdb0e8118}},	//   ग्यव, şdır, ntè_, _arbó,
   {{0x3ea6c632,0x6e2b8428,0x6934b73a,0xdb1c8580}},	//   _abot_, _rygb, анчу, _errà,
   {{0x6abb8433,0x3f588187,0x65628915,0x3f91007e}},	//   _tauf, _céu_, _atoh, nuzu_,
   {{0x2907c633,0xf8380051,0xf99f0247,0x3f588722}},	//   sina_, כנות_, ktè_, _déu_,
   {{0x7bc181c0,0x61320366,0xfec50264,0x2b4daaa0}},	//   wvlu, fæll, _একাধ, _iiec_,
   {{0xee368110,0x394cc634,0x2907b14f,0x7cf2008b}},	//   ыны_, _gids_, qina_, _kæra,
   {{0xe29a2e65,0xd1208074,0xfc0580e2,0xe1ff0061}},	//   нан_, मकरण_, упно, sból_,
   {{0x68e184c7,0x2249856f,0xdb1583a8,0x65628168}},	//   _hold, žaku_, _arzú, _ftoh,
   {{0x68e1c635,0x6f09809a,0x26cfc636,0xdbe700ab}},	//   _kold, miec, _ingo_, _গেমস_,
   {{0x6f0980eb,0x68e1826c,0xf1b98267,0x293580be}},	//   liec, _jold, _msš_, טאָן_,
   {{0x68e1c637,0x4424819f,0xa6db01fa,0x3f910102}},	//   _mold, _پروف, _liðu, guzu_,
   {{0xb8eb000f,0x6f099a1d,0x6ee30006,0x2b9c001b}},	//   _रो_, niec, _sõbr, víc_,
   {{0xa6db0125,0x7bc7003d,0xa2d14638,0x80b38424}},	// [34e0] _niðu, _arju, धार्, ंजाइ,
   {{0x69ba8035,0x7ae0c639,0x6909463a,0x59c7914f}},	//   _एनबी, _somt, lžen, लिनर,
   {{0x389b093f,0xb09b012a,0xa2d8024c,0xdb1c8825}},	//   _איינ, _אייר, याप्, _arrá,
   {{0x290a463b,0x69c285f8,0x7cf68087,0x3cf00072}},	//   liba_, tvoe, _târg, _इतके_,
   {{0x28130077,0xc05a835f,0x2b9c03fb,0x68e1c63c}},	//   _نویس, ній_, síc_, _bold,
   {{0x69c2838e,0x26cfc63d,0x29058362,0x3eb202c4}},	//   rvoe, _ango_, _cmla_, leyt_,
   {{0x7ae09517,0x6d5dc63e,0x7d08a9c6,0x6d418916}},	//   _tomt, ísan, vids, dmla,
   {{0x6d4e463f,0x2d829cf5,0x66090267,0x3dc6c640}},	//   _hiba, škem_, _žeki, _prow_,
   {{0x6d4e331a,0xa2d804c5,0x7d088082,0x5896803d}},	//   _kiba, यान्, tids, _مجاز,
   {{0xdce981ac,0x8f76835f,0x6d4e4641,0x68e1c642}},	//   ateľ, _буді, _jiba, _gold,
   {{0x6f09c643,0x7d088b81,0x290a4644,0x6d4e4645}},	//   biec, rids, diba_, _miba,
   {{0x6d4e4646,0x973c82fd,0xa2ca81ab,0x68e1c647}},	//   _liba, _opći, _सोम्, _zold,
   {{0x7d08c648,0x68e18059,0x26c0031d,0xf1c784e5}},	//   pids, _yold, ddio_, लियन,
   {{0x25a0013c,0x7faa8201,0x5d8380f7,0x68e18118}},	//   dtil_, _təqd, _الول, _xold,
   {{0xe44f9368,0xd7f80364,0xf99f4649,0x7c2e0502}},	//   _عضو_, гут_, stè_, _nybr,
   {{0x6d4e130c,0xa4ff000c,0x3f9101f4,0x636081bc}},	//   _aiba, ोच्च_, ruzu_, _ịnwa,
   {{0x6d4e4207,0xdd950071,0x2d9200b4,0x443809ed}},	// [34f0] _biba, разы, guye_, _azr_,
   {{0x2d873a71,0x290a0661,0x6d4e464a,0x753c0035}},	//   čne_, ciba_, _ciba, _chrz,
   {{0x6d4e0be6,0x68e183a8,0x32558110,0xaa55a748}},	//   _diba, _rold, авер, авеш,
   {{0xd6db464b,0x2d923623,0x6d4e0102,0x65950110}},	//   _что_, buye_, _eiba, _каму,
   {{0x68e1c03c,0x25a0464c,0x2b4d80ff,0x442ec64d}},	//   _pold, ctil_, _viec_, _lyf_,
   {{0x6d4e464e,0x6f09809a,0x68e1a08e,0xa6db007b}},	//   _giba, wiec, _qold, _viðu,
   {{0x68e1bb63,0x6f098029,0xe3e480c8,0x46f5c64f}},	//   _vold, tiec, _ফেসব, ичит,
   {{0x290a0309,0x9585a209,0x6d4e44de,0x9a1281bc}},	//   ziba_, алие, _ziba, pọpụ,
   {{0x68e19a76,0xe57697ae,0x19598a14,0x3ebfc650}},	//   _told, азы_, _разы_, rdut_,
   {{0x6f098114,0xb3a98214,0x6d4e0118,0xdce981d6}},	//   siec, _çıkı, _xiba, steľ,
   {{0xd01187bd,0x6f098029,0x6d41b974,0xfd5e01bc}},	//   _بلا_, piec, rmla, _bayọ,
   {{0xb6c98117,0x69c9c651,0x690901d0,0x1f5a81c6}},	//   _جائے_, _kree, užen, _סדנא,
   {{0x290a4652,0x69c9808e,0x956795a6,0x7f570036}},	//   tiba_, _jree, _съед, _auxq,
   {{0x7e7b8867,0x8c45c653,0x672481dd,0x2ca780ff}},	//   laup, _келе, čije, _ubnd_,
   {{0x61eb807b,0x6aa9c654,0x37e34655,0x2f1a8ec3}},	//   hygl, _obef, оорг, līga_,
   {{0xe8df8028,0x09e60e97,0x539a84de,0x26c044b2}},	//   _muốn_, _воин, _סיפו, udio_,
   {{0xed570003,0x6d5bc656,0x9f453649,0x69c981c0}},	// [3500] иот_, nqua, álá_, _nree,
   {{0x6909003e,0x7ae41bda,0x25a03a4c,0xb97b02f6}},	//   nžel, _hoit, rtil_, _שניי,
   {{0x25a04657,0x7e7b862c,0x1d19035f,0xeb9a04fa}},	//   stil_, kaup, ують_, тие_,
   {{0x7c2e03cb,0xfaa690fc,0x7ae40009,0x82a68110}},	//   _vybr, радо, _joit, радж,
   {{0x7ae407f4,0x44260063,0x41b695a4,0x7c2e009a}},	//   _moit, ło_, рсет, _wybr,
   {{0x7ae4062f,0x6f160dee,0xa3d5801b,0xb11480ab}},	//   _loit, lnyc, समा_, িত্ব_,
   {{0xe8df801c,0xc60e8a27,0xd00f80a0,0xa2c181d0}},	//   _cuốn_, ाप्य_, وله_, _रोक्,
   {{0x6f164658,0x7ae44659,0x7e7bc65a,0x69c9b437}},	//   nnyc, _noit, gaup, _free,
   {{0x2d80465b,0x69c9c65c,0x1dc9066b,0x50b6804a}},	//   nsie_, _gree, रियत, _всеу,
   {{0x44f491d5,0x7af60110,0x3f5c0118,0x2d804543}},	//   спос, _alyt, _oíu_, isie_,
   {{0x7ae400e7,0xdeef81e2,0x3f5c465d,0x443893c2}},	//   _boit, _ды_, _níu_, år_,
   {{0xe5a6867c,0x7ae40068,0x6da6c65e,0x2d80079f}},	//   _види, _coit, _вида, ksie_,
   {{0x6f160dee,0x2d8000e1,0x2369816b,0x4efb83c8}},	//   dnyc, jsie_, _čaje_, _בלאג,
   {{0xddcf0162,0xa6db01fa,0x6abf022b,0x00000000}},	//   _lecţ, _niðr, _waqf, --,
   {{0x7af612f1,0xc7c41285,0x7c388024,0x9a872bca}},	//   _flyt, ости, _uzvr, _купл,
   {{0x27219c18,0x7ae40cdb,0xa2d8001b,0xddc998ad}},	//   fóny_, _goit, याण्, nceş,
   {{0x7cf21277,0x635398ad,0x2d8005ee,0xa2ca81d0}},	// [3510] _værn, _dănu, gsie_, _सोध्,
   {{0x629b8098,0x04670ea6,0xeb1f99e8,0x6aa98037}},	//   _scuo, ртам, यक्त_, _sbef,
   {{0x6f16009a,0x61368087,0xd6d100f7,0x2d8d80b9}},	//   bnyc, tâln, _فقد_, zree_,
   {{0x69c9c65f,0xa6db0125,0x7528809a,0xd64e819d}},	//   _pree, _viðs, hodz, _kọdụ_,
   {{0xa2d80aed,0xe1ff38a5,0x68e50364,0x7cf24660}},	//   यात्, nzó_, _kohd, _kærl,
   {{0x69c980c9,0x6f0d4661,0xb4e5816f,0x68e50198}},	//   _vree, liac, _नवे_, _johd,
   {{0x6fd70540,0xa3bb000d,0x68e500ee,0x7e7b96b5}},	//   डमिं, _अनि_, _mohd, taup,
   {{0x6f0d4662,0x2d8d81b0,0x6d450c5e,0x38180039}},	//   niac, tree_, lmha, יקום_,
   {{0x6b5e8029,0x6ef5816a,0x9f4e004a,0xd64e819d}},	//   _rīga, _cába, _åfå_, _nọdụ_,
   {{0x6f16219c,0x6d45008c,0x7ae44663,0x6d5bb06a}},	//   znyc, nmha, _soit, rqua,
   {{0x69090110,0x6d5bc664,0x7ae43940,0x65699024}},	//   ržel, squa, _poit, speh,
   {{0x60c1c665,0xd64e8133,0xdce080eb,0x65958048}},	//   _halm, _bọdụ_, rpmā, _гаду,
   {{0x7ae44666,0x60c1c667,0x333f81cd,0xe2970009}},	//   _voit, _kalm, _mhux_, щая_,
   {{0x60c19ab3,0xd466835f,0x6f16009a,0xeb999cb2}},	//   _jalm, _лише_, wnyc, _бик_,
   {{0xbb858307,0x60c1c668,0x6ef5803e,0x6d59c669}},	//   _البي, _malm, _zába, _huwa,
   {{0x09bd8a49,0x6d598303,0xd64e819d,0x2d80000b}},	//   _আপনা, _kuwa, _fọdụ_, tsie_,
   {{0xac8601e5,0xe73715d1,0x0dca01e5,0x7faa8201}},	// [3520] йгал, сет_, ылай_, _məqa,
   {{0x2d801de5,0x6d59c66a,0xddcf0087,0x5c56466b}},	//   rsie_, _muwa, _secţ, стаф,
   {{0x2d80466c,0xb5fd81e2,0x8ca9886a,0x6d59b15d}},	//   ssie_, rašy, ज्यो, _luwa,
   {{0x6f0d11b9,0x6455466d,0x2d803f1a,0xe5a601ae}},	//   ciac, _egzi, psie_, _лими,
   {{0x26c2003a,0x2b400083,0x6d59c66e,0x4a9b03c8}},	//   _iako_, _mhic_, _nuwa, רינג,
   {{0xa50a0381,0x86370039,0x6eea016b,0x26c2466f}},	//   _сега_, _לרכב_, _výbu, _hako_,
   {{0x60c1abea,0x6ef58510,0x68e10ede,0x6d59854e}},	//   _dalm, _sába, öldi, _auwa,
   {{0x26c24670,0x6d59c671,0xe8df801c,0xe807816f}},	//   _jako_, _buwa, _buồn_, _वेळा_,
   {{0x26c2001d,0x2dda81a8,0x6d59aeb7,0xa2c1a128}},	//   _mako_, ابعة_, _cuwa, _रोट्,
   {{0x6d59c672,0x2d8a875f,0x60c181b4,0x6f0d4673}},	//   _duwa, čbe_, _galm, ziac,
   {{0x63a582af,0x7cf20b40,0x75289988,0x7afd0168}},	//   _ähnl, _nærm, rodz, ërto,
   {{0x7cf20bc5,0x26c24674,0x083b80be,0x6d5980fc}},	//   _særl, _nako_, _געבל, _fuwa,
   {{0x7982809a,0x2d4d0279,0x1562819d,0x26c380eb}},	//   nsow, _džej_, _fọọa, ējot_,
   {{0x19580791,0xa2d5816f,0x2ee681b0,0x26c205ee}},	//   сары_, णाऱ्, _hoof_, _aako_,
   {{0x6e3c82bf,0x6d59c675,0x26c204bb,0x78b5330c}},	//   ərba, _zuwa, _bako_, rezv,
   {{0x877b83c8,0x290e83e4,0xdce080eb,0xceb981d0}},	//   טאלי, hifa_, ksmī, toři_,
   {{0x28b98321,0x26c21f2c,0x690909d1,0x26c701d0}},	// [3530] _इसलि, _dako_, nžek, ěno_,
   {{0x6f0d0038,0x6d451769,0x89dc01c6,0x2ee68a53}},	//   siac, umha, _תחזי, _loof_,
   {{0x6d454676,0x2d4d00d2,0x6f0d34cd,0x26c24677}},	//   rmha, _užem_, piac, _fako_,
   {{0x539b8039,0x6d450c41,0xf2d400be,0x81bd8264}},	//   ריאו, smha, ּעס_, ইমস_,
   {{0xb2bc00be,0x994801f9,0x6aad2eae,0x6f1d0bfd}},	//   טמאר, _خلیل_, _mbaf, _ijsc,
   {{0x6d59c678,0x656d4679,0x60c18085,0x26c2467a}},	//   _ruwa, mpah, _qalm, _zako_,
   {{0x60c1be00,0x26c2022e,0x6d59c67b,0x43943cb3}},	//   _valm, _yako_, _suwa, _нарс,
   {{0x0565916b,0xa3ae0006,0x46e98162,0x7d0a8362}},	//   овин, _कहत_, рдин_, _amfs,
   {{0x60c1c67c,0x4add00c2,0xa2d8024c,0x656d2916}},	//   _talm, यानव, यास्, npah,
   {{0x3b859383,0x6aad467d,0x5ba99541,0x672481a1}},	//   олог, _abaf, аком_, čija,
   {{0x28158013,0x656d0573,0x443c81a1,0x69cd0915}},	//   _بواس, hpah, _czv_, _arae,
   {{0x6d59c67e,0x4acf9199,0x63a50c5e,0x69cd1aa5}},	//   _tuwa, _सोमव, ithn, _brae,
   {{0xabd78065,0x26c2011b,0x9f4c01d0,0x6ef58061}},	//   _گزشت, _rako_, ádí_, _hábo,
   {{0x26c2467f,0x672f009a,0x2d4d0088,0x69cd1eb8}},	//   _sako_, _akcj, _džek_, _drae,
   {{0xc447803d,0x3ea937f7,0x7ce00061,0x69cd4680}},	//   _دیدن_, ffat_, _törz, _erae,
   {{0x7afd0352,0x6aad11d3,0x9f590061,0x1b180264}},	//   chst, _gbaf, ázás_, _ধীরে_,
   {{0x23608025,0x69cd4681,0x26c20042,0x6da30012}},	// [3540] _čiji_, _grae, _vako_, мита,
   {{0x26c2022e,0x62898091,0xe5773a8b,0xa2d80b99}},	//   _wako_, _adeo, юзу_, याव्,
   {{0x6ef5826f,0x6efc80e7,0xdee62f2f,0x66e6116b}},	//   _nábo, _hébe, _дони, _дона,
   {{0x3f984682,0x49ca91b3,0xa25b01d6,0x7982b235}},	//   muru_, илен_, jdôl, tsow,
   {{0xdce28503,0x3f980458,0x63a500f7,0x290e93a9}},	//   _stoč, luru_, athn, tifa_,
   {{0xc5f30051,0xf7729b9a,0x7cf2013c,0x6ef58f09}},	//   _חדש_, واع_, _mærk, _bábo,
   {{0x290ec683,0x4aca32dd,0xa3ae02f1,0xaadd03eb}},	//   rifa_, ियाव, _कहि_, यामक,
   {{0x78ad812b,0x27e08024,0xe297a72e,0x290ec684}},	//   đava, ćin_, _мас_, sifa_,
   {{0x26c281ac,0x3f983a2f,0x7cf227d1,0xe0daa481}},	//   ľko_, huru_, _nærk, _ква_,
   {{0xa3ae0d38,0x3f984685,0x69c08065,0x26c2877b}},	//   _कहा_, kuru_, _isme, žko_,
   {{0x7e644686,0x3ce7826c,0xdce2812b,0x3f982a3b}},	//   kcip, _donv_, _utoč, juru_,
   {{0x69cd4687,0xeb07035f,0x6efc83c9,0x7ae2808e}},	//   _prae, ічно, _bébe, njot,
   {{0x9e65803d,0xad5a8198,0x6ef5936f,0xddc3802e}},	//   _رانن, _трех_, _zábo, _обци,
   {{0x3f984134,0x6efc84c3,0x443c8b24,0x69cd0a53}},	//   furu_, _débe, _tzv_, _vrae,
   {{0x3f98376a,0x443cb5ca,0x290c82d5,0xb90312c6}},	//   guru_, _uzv_, _mmda_, _नच_,
   {{0x69c08904,0x69cd28c6,0xd6d84688,0x37bc80ab}},	//   _osme, _trae, оту_, _অপার,
   {{0xa2d80b84,0x2d848101,0x61e48198,0x31690326}},	// [3550] यार्, nsme_, äill, _utaz_,
   {{0x3f984689,0x2d84c68a,0x656d00dd,0x8883003d}},	//   buru_, isme_, rpah, _زیرن,
   {{0xa3cd9d40,0x69c0c68b,0x291123a8,0x656d468c}},	//   रिय_, _asme, miza_, spah,
   {{0x0cb785b3,0x629d02e8,0x63a5031d,0x2d8480eb}},	//   _अस्म, ngso, rthn, ksme_,
   {{0x7e7d0341,0x68e8c68d,0x2d8486d4,0x1a9c03de}},	//   _iesp, _bodd, jsme_, שידע,
   {{0x2911468e,0x91bc0039,0x68e891fe,0x7cf204d6}},	//   niza_, ימדי, _codd, _nærh,
   {{0x20032180,0x69c0c68f,0x6d5d1d4f,0x68e8c690}},	//   nzji_, _esme, _husa, _dodd,
   {{0x2d9592c0,0x6d5d43b7,0x7e7d4691,0x6b830511}},	//   прос, _kusa, _jesp, ángu,
   {{0x3f984692,0x291139e1,0x6d552fc0,0xfaff00f1}},	//   zuru_, kiza_, _kiza, dhë_,
   {{0x6d5d4693,0x7afb8125,0x7e7d0247,0x29110c53}},	//   _musa, _hlut, _lesp, jiza_,
   {{0xca291dce,0x6d5d4694,0x2d84c695,0x7ae9aada}},	//   _עם_, _lusa, asme_, _koet,
   {{0xf770819f,0x6d5d241f,0xdb04006a,0x25608176}},	//   _شام_, _ousa, _opnå, _fòl_,
   {{0x7ae98613,0x29114696,0x7cf30214,0x7d1a81c0}},	//   _moet, fiza_, _kırı, bnts,
   {{0x7cf2013c,0x3f984697,0x29114698,0x6d554699}},	//   _værk, turu_, giza_, _niza,
   {{0x7afbba3e,0x79998748,0x6d5d469a,0xd9b88bb8}},	//   _olut, huww, _ausa, _इन्ट,
   {{0x05661269,0xdee3333d,0x3f98469b,0x66e30615}},	//   зван, носи, ruru_, носа,
   {{0x6d55469c,0x7e7d0927,0x2911409f,0x60c5469d}},	// [3560] _biza, _desp, biza_, _fahm,
   {{0x3f98469e,0xdd8f0f99,0x6d5d469f,0x7afbc6a0}},	//   puru_, اول_, _dusa, _alut,
   {{0x46bd816f,0x7ae9a26f,0x68e88114,0x7afb81ec}},	//   ्याह, _boet, _rodd, _blut,
   {{0x7e7d16a1,0xe29ac6a1,0x68e8c6a2,0x6d5d46a3}},	//   _gesp, сад_, _sodd, _fusa,
   {{0x6d5d46a4,0x6d552d68,0x63828019,0x7ae28009}},	//   _gusa, _fiza, _kíná, rjot,
   {{0x7f42820f,0x7bce0a20,0x6d55011e,0x7e7d009a}},	//   _shoq, _trbu, _giza, _zesp,
   {{0x7afbc6a5,0x6d5d0352,0xd0108013,0x7cf22ba5}},	//   _flut, _zusa, ضلة_, _næri,
   {{0x67248042,0x799980ee,0x6d550ab4,0xe2f88019}},	//   čijo, buww, _ziza, _بورڈ_,
   {{0x69c084c4,0x660446a6,0x3cfe951e,0x6d5d0079}},	//   _usme, nzik, thtv_, _xusa,
   {{0x7ae9c6a7,0x6d439995,0x636181bc,0x7d1a82f9}},	//   _zoet, _chna, _ịnap, unts,
   {{0xfaff020f,0xa2950221,0x256086c0,0x929511cf}},	//   thë_, мані, _wòl_, манц,
   {{0x23be001b,0xf7730019,0x7d1a81c0,0x29110314}},	//   _můj_, ہار_, snts, wiza_,
   {{0xdd8f845b,0x236082a5,0x7ced80f7,0x29112fe0}},	//   _مون_, _čiju_, _cúrs, tiza_,
   {{0x6d5d0f43,0xfaff00f1,0x0cc700ab,0x7bdc8074}},	//   _rusa, shë_, _শক্ত, ärus,
   {{0x29112ea5,0x6d5d0590,0x6d5546a8,0x443a8028}},	//   riza_, _susa, _riza, _áp_,
   {{0x6d5d0859,0xb8f41516,0x70b9a0e9,0x29110316}},	//   _pusa, _सो_, _इस्ल, siza_,
   {{0xdce98a56,0x7e7d12d0,0x6d5525ca,0x5d552700}},	// [3570] zpeč, _vesp, _piza, дкат,
   {{0x7afbc6a9,0xe94500d5,0x7ae9c6aa,0x672d0c93}},	//   _slut, _تربی, _soet, soaj,
   {{0x7afbc6ab,0xccf380be,0xe8d901bc,0x7e7d46ac}},	//   _plut, עכע_, _juọ_, _tesp,
   {{0x6d550c5a,0xa3cd90c5,0xa3ae000f,0x6d5d11b5}},	//   _wiza, रित_, _कहर_, _tusa,
   {{0xdd868117,0x7ae985f8,0xa2a50bb3,0x6d5d46ad}},	//   _جو_, _voet, _कान्, _uusa,
   {{0x25a946ae,0xf770003d,0xc2448d8e,0xbcfb1727}},	//   mtal_, _جای_, хнік, _quéd,
   {{0x7ae981b7,0x25a920f0,0x7afb89c4,0x7cf698ad}},	//   _toet, ltal_, _tlut, _cârm,
   {{0x26c90010,0xdb1900e1,0x25a924d7,0x628d01a8}},	//   ndao_, _prvý, otal_, _ndao,
   {{0x25a946af,0x7cf305e0,0x917a027d,0x387e8c0b}},	//   ntal_, _tırı, _mật_, _fetr_,
   {{0xab659980,0x2a690176,0x7ce482d6,0x628d0493}},	//   мвол, _afab_, _kòry, _adao,
   {{0xccf2012a,0x6ef83666,0x1c459fb4,0xd7c186ae}},	//   דכי_, _bíbl, ьном, _शनिच,
   {{0x395f82f1,0x52b801a2,0xc87882d0,0x769681cc}},	//   _kuus_, इजेस, _doğu_, rüyü,
   {{0x64a5817d,0xb4bd081f,0xa06a0196,0x5fc5c6b0}},	//   _жала, _आसू_, жага_, विकल,
   {{0xa3ae0006,0xdb190580,0xdcfb80c3,0x7cf22419}},	//   _कहल_, _esvà, pruđ, _hærv,
   {{0x07a306c8,0xe8d9019d,0x2d8f0216,0x225f026c}},	//   карн, _guọ_, ágen_, žuka_,
   {{0x6604011b,0x6ef80144,0x25a9090d,0x98bf822b}},	//   tzik, _víbo, ftal_, _ftuħ_,
   {{0x395f84df,0x28de06ae,0xe1ff0511,0xccc6361c}},	// [3580] _nuus_, मादि, lcón_, мбай,
   {{0xf53f108c,0x660446b1,0x6ef595d8,0x69c446b2}},	//   _spår_, rzik, _bábk, _isie,
   {{0xe1ff06a5,0xf365021e,0x78bc0cab,0x69c402a6}},	//   ncón_, етін, merv, _hsie,
   {{0x31602d68,0x78bc46b3,0xa2d4081f,0x7cf20e51}},	//   _kuiz_, lerv, _बोम्, _nærv,
   {{0x7bda086f,0x7afd00f1,0x387e801b,0x31600187}},	//   _štud, ërti, _petr_, _juiz_,
   {{0xa2a5001b,0x316000b9,0x2f1a80eb,0x69c446b4}},	//   _काभ्, _muiz_, mīgi_, _msie,
   {{0xb9068105,0x6b632b3f,0x64a346b5,0x3ead926c}},	//   _बच_, _акса, _шара, ffet_,
   {{0x78a9003a,0x3ea038dc,0x8c431cb2,0x758a8009}},	//   đevi, ngit_, _ресе, осов_,
   {{0x443846b6,0xb8f480ab,0x2f1a80eb,0x78bc46b7}},	//   _hyr_, _হক_, nīgi_, kerv,
   {{0x62808020,0x6efc82be,0xb143802e,0x690904e8}},	//   _hemo, _déba, _анул, nžet,
   {{0x78bc01eb,0x38cb80d5,0xaad002f1,0x7cedc6b8}},	//   derv, _باقی_, _तोहक, _púrr,
   {{0x60c8c6b9,0x443846ba,0xed5a95be,0x25a904e8}},	//   _hadm, _myr_, _дод_, ytal_,
   {{0xe707826a,0x5ea38065,0x645c46bb,0x5573902a}},	//   _تسلی, _شمول, _ogri, _агіт,
   {{0x672d812b,0x645c2b0f,0xa3de000d,0x25a9016d}},	//   čaje, _ngri, तमा_, vtal_,
   {{0x403419b5,0x690946bc,0xdb190118,0xd5c880ff}},	//   верс, džet, _esvá, _hề_,
   {{0x6d588019,0x25a946bd,0x3ea015d4,0xd5c88129}},	//   _hiva, ttal_, ggit_, _kề_,
   {{0x7cff879f,0x60da80c9,0x7cf246be,0x9f340163}},	// [3590] _wêre, _ontm, _læru, теті,
   {{0x44384285,0x3f9c82ec,0x7aed46bf,0x3d940758}},	//   _byr_, kuvu_, _hoat, тифр,
   {{0x62809de6,0x6722c6c0,0xd5c88129,0x44381a1f}},	//   _bemo, _ojoj, _lề_, _cyr_,
   {{0x6d58c6c1,0x44382280,0xbcfb00e7,0xdced0279}},	//   _liva, _dyr_, _québ, mpač,
   {{0x7aed01e0,0xa069c6c2,0x31600118,0x7d088084}},	//   _moat, пала_, _xuiz_, _kūrė,
   {{0x628082c4,0x7aed46c3,0x4438245f,0x60c8bcc0}},	//   _eemo, _loat, _fyr_, _cadm,
   {{0x6ef58acf,0x6d47026c,0x2d4d0088,0x6efcc6c4}},	//   _hábi, _ihja, _džet_, _séba,
   {{0x6280837a,0x6d58c6c5,0xa3cd84c5,0x60c88118}},	//   _gemo, _aiva, रिस_, _eadm,
   {{0x79a4b16c,0x6d58c6c6,0x2d8946c7,0x6abd0261}},	//   _архе, _biva, nsae_, desf,
   {{0x620183bf,0x3eadc6c8,0x6d58c6c9,0x6b650084}},	//   ızlı, sfet_, _civa, _jėgo,
   {{0x7c958077,0x290300f1,0x78bc0be7,0x6ef58187}},	//   وشگا, dhja_, verv, _lábi,
   {{0xe1ff157a,0x6d58c34e,0x2e4e819d,0x78bc46ca}},	//   rcón_, _eiva, _kọlọ_, werv,
   {{0x6d470009,0x6d588901,0x99d60019,0x2bb18074}},	//   _ohja, _fiva, رتحا, _जहवा,
   {{0xa3c123bd,0x64a58ba7,0x6ef580f7,0x6d58c6cb}},	//   ्टा_, _чака, _sábh, _giva,
   {{0x657d0032,0x0ea686a7,0x656f0c0b,0xfc648081}},	//   _awsh, क्कड, _atch, _ръчн,
   {{0xdbd718c5,0x6443c6cc,0xc4c60077,0x7aed46cd}},	//   _määr, _izni, کترو, _goat,
   {{0x628600a4,0x443e1fe7,0x6280c6ce,0x443846cf}},	// [35a0] mako, _št_, _remo, _syr_,
   {{0x6280859c,0x628646d0,0x2ebd816f,0x2f1a80eb}},	//   _semo, lako, ्युत, rīgi_,
   {{0x62808057,0x6ef580f7,0x60c8812b,0xbcfb041c}},	//   _pemo, _tábh, _radm, _suéc,
   {{0x869a0364,0x22288077,0xed5a2355,0xe3631b3f}},	//   _этот_, وزشی_, _ном_, укци,
   {{0x62809e00,0x60c889c4,0x395a46d1,0x260faa47}},	//   _vemo, _padm, _kips_, _तेली_,
   {{0x7faa8085,0xc0e38c4f,0x628646d2,0xb86680d7}},	//   _həqi, лочк, hako, راتو,
   {{0x8c430c8e,0x6280c6d3,0x443e0019,0xddcd0289}},	//   _бере, _temo, _át_, mbaš,
   {{0xd5e28032,0x6d58c6d4,0xa6aa81a8,0x03d701c6}},	//   _afó, _siva, سابق_, _אולם_,
   {{0x6d588669,0x644380ee,0x7ced9e00,0x7aed0162}},	//   _piva, _azni, _púrp, _roat,
   {{0xd5c88142,0x81e600ab,0x81b380ab,0xc42a9bc1}},	//   _về_, পনা_, টিশ_, зюме_,
   {{0x7aed0c6e,0x6d58c6d5,0xa2d58072,0x6abd039c}},	//   _poat, _viva, णाच्, tesf,
   {{0x81b380c8,0x78a5026f,0x6aa293fa,0x628646d6}},	//   টির_, _schv, ngof, gako,
   {{0x6f0401e4,0x6d58c6d7,0xdc12a2f8,0xee3ac3e1}},	//   dhic, _tiva, rşım, _энд_,
   {{0x395a3c2d,0xa3cd9a87,0x248587f1,0x7cf2006a}},	//   _cips_, रिश_, calm_, _mærs,
   {{0x7aed0c6e,0x628637c6,0xa2d80c78,0xddcd026c}},	//   _toat, bako, याख्, dbaš,
   {{0x290300f1,0x6f043279,0x643b8039,0xdc3b84de}},	//   shja_, ghic, _מעונ, _מעור,
   {{0xdd940196,0x6594361c,0x3d941a02,0x7faa8085}},	// [35b0] латы, лату, литр, _dəqi,
   {{0xac272d55,0xbcfb026b,0xa3e20035,0x2f1a81a9}},	//   нфек, _atér, _गपशप_, mīgu_,
   {{0x2d890609,0x2901153a,0x80a49107,0x6efc83a8}},	//   ssae_, _ilha_, च्छे, _nébo,
   {{0x91bf81ce,0x9e150112,0x6f0446d8,0x59bf909b}},	//   _एनआई, _адмі, chic, _एनआर,
   {{0x3f8c826c,0x2b490c41,0xdb1c8019,0x2d8b01a1}},	//   _avdu_, _mhac_, _arró, _uvce_,
   {{0x628646d9,0x6e398428,0xdbd72551,0x395a07f1}},	//   zako, _rywb, _päär, _xips_,
   {{0x628646da,0x7cf23c10,0x6efc89c4,0xafe58084}},	//   yako, _vært, _cébo, тойл,
   {{0xdbd7043d,0x7cf20125,0x25b900b9,0x2b4900ff}},	//   _väär, _færs, _kpsl_, _nhac_,
   {{0xe7f38f21,0xdb1c80ab,0x290103a7,0x26cb46db}},	//   _अथवा_, _erró, _olha_, _maco_,
   {{0x6b5e80eb,0x673b8968,0x6286019e,0xd9559190}},	//   _līgu, sluj, wako, _شناخ,
   {{0xe29a12a0,0x628646dc,0xaadd0aed,0xdce42bea}},	//   ман_, tako, यांक, spić,
   {{0x6443803e,0x46128180,0x2b4946dd,0x26cb46de}},	//   _vzni, اویر, _chac_, _naco_,
   {{0xed4eabb3,0x62863539,0x28de0327,0x2485c6df}},	//   _во_, rako, मालि, palm_,
   {{0x628646e0,0x7c878878,0xf487a0bf,0xdd92004e}},	//   sako, _чуде, _чудн, یوز_,
   {{0x6f0414f2,0xdb02002a,0xe73a0572,0x25ada2ab}},	//   thic, atlá, дев_, ltel_,
   {{0x3ebf81ec,0x7cf201fa,0x07a30073,0x7b119e1e}},	//   neut_, _nærr, јатн, sťuj,
   {{0x6609829b,0xe8120768,0x7bd546e1,0x68470118}},	// [35c0] nzek, _डेरा_, _arzu, _pédí,
   {{0x67248fda,0x6f0400fa,0xbcfb0036,0xdbe48091}},	//   čiji, shic, _stér, _bèèr,
   {{0x291846e2,0xe0fb03c8,0x261883eb,0x6ef846e3}},	//   mira_, _חליל, _बेनी_, _líbi,
   {{0x69d608cf,0x29180c56,0xe6bd816f,0xdb1c8722}},	//   _krye, lira_, ्योज, _arrò,
   {{0x4aaa0076,0xe894a325,0x628446e4,0xa2a504c5}},	//   _कानव, галь, _meio, _कास्,
   {{0x291846e5,0x66098029,0x81b380c8,0x69c2874c}},	//   nira_, dzek, টিং_, rwoe,
   {{0x0fe08a49,0x7cf215f8,0x38cb87d2,0xebe3006d}},	//   বন্ধ, _færr, بانی_, _корп,
   {{0x6d5c46e6,0x291846e7,0xa3c10128,0x69d62879}},	//   _hira, hira_, ्टर_, _orye,
   {{0x291820d7,0x6f030012,0xf1aa8077,0x28e2809a}},	//   kira_, _înce, _تازه_, पादि,
   {{0x6d5c46e8,0x672d8052,0x29181b52,0x644346e9}},	//   _jira, čaja, jira_, żnie,
   {{0x291846ea,0x3ebfc6eb,0xdc9b007c,0x69d62ce1}},	//   dira_, beut_, וייל, _arye,
   {{0x29180548,0x6d5c46ec,0x65628198,0x200a0140}},	//   eira_, _lira, _tuoh, dzbi_,
   {{0xc3338051,0x65948087,0x25adb49a,0x69d607f1}},	//   שור_, _салу, ctel_, _crye,
   {{0x291846ed,0xa2a51d7c,0x26cb04f0,0x853000fc}},	//   gira_, _काव्, _saco_, buɗi,
   {{0x19580110,0x6f02c6ee,0x26cb157a,0x5433815b}},	//   тары_, _kloc, _paco_, _پرور,
   {{0x25a01301,0x6d5c010a,0x6ef58207,0x69d6028c}},	//   fuil_, _aira, _fábu, _frye,
   {{0x291846ef,0x2f1a81a9,0x2369877b,0x69d646f0}},	// [35d0] bira_, līgs_, _čaji_, _grye,
   {{0x29182e96,0x6f02c5b8,0x7afd417e,0x6d5c01b4}},	//   cira_, _lloc, lkst, _cira,
   {{0xa2d8053e,0x6d5c316a,0x2bd5809a,0x2d4d0668}},	//   याच्, _dira, धिया, _džep_,
   {{0x7afd46f1,0x26c0041c,0x6d5c46f2,0xbddb010c}},	//   nkst, ceio_, _eira, _nyèg,
   {{0x6d5c46f3,0x442a0118,0x99158d8e,0x7bd5009a}},	//   _fira, _exb_, лькі, _wrzu,
   {{0x6d5c146f,0x7c3c0125,0xa5da00be,0x6f028087}},	//   _gira, _fyrr, _אַלי, _aloc,
   {{0x6f02aaf4,0x6e3d031d,0x7c3c0114,0x46aa001b}},	//   _bloc, _hysb, _gyrr, ङ्कह,
   {{0x660980ad,0x25adc6f4,0x291846f5,0x7e6d0867}},	//   tzek, ttel_, zira_, ncap,
   {{0x6d4a8013,0x29180e4d,0x25ad8e61,0x6d5c0079}},	//   _bhfa, yira_, utel_, _yira,
   {{0x6609c6f6,0x2ed0000f,0x25ad92af,0x291801df}},	//   rzek, _हफ्त, rtel_, xira_,
   {{0x25adc6f7,0x66098019,0x7e6d008e,0x29079a26}},	//   stel_, szek, kcap, mhna_,
   {{0x7f5d0609,0x6f02c6f8,0x29182bc2,0xaca3819d}},	//   _nisq, _gloc, wira_, _krịk,
   {{0xa2a5085d,0xe4c8815b,0x7e6d0299,0x628440d9}},	//   _कार्, ربین_, dcap, _veio,
   {{0x361a8158,0x6f028052,0xa2d4090f,0xef19a358}},	//   _אונד, _zloc, _बोर्, liż_,
   {{0x291846f9,0x7f5d46fa,0x60260098,0x6d5c46fb}},	//   rira_, _bisq, удва, _rira,
   {{0xbcfb46fc,0xef1981b9,0x6ef5841c,0x7faa811c}},	//   _quén, niż_, _tábu, _təqv,
   {{0x291846fd,0xb90a00c8,0x2569c6fe,0x7f5d46ff}},	// [35e0] pira_, _মত_, _júl_, _disq,
   {{0xb5fb0118,0x6d5c2691,0x26c00187,0xee3746a1}},	//   _afás, _qira, seio_, уну_,
   {{0x6d5c4700,0x9f5800f1,0x290781e4,0x656983ed}},	//   _vira, nyrë_, dhna_, hqeh,
   {{0x6d5c2b11,0x7e6d01e8,0x7cf68162,0x5c3683de}},	//   _wira, ccap, _hârt, ארען_,
   {{0x6d5c4701,0x25a00661,0x427b00be,0x98a7c702}},	//   _tira, quil_, גאנג, zoną_,
   {{0x6724003a,0xa3e3800d,0xbebb00f1,0xa3d692ee}},	//   lnij, नमा_, _njëj, सिम_,
   {{0xc5f18a49,0x6f02aa07,0xa2a52128,0x6d4781cd}},	//   _জেলা_, _ploc, _काल्, ċjal,
   {{0x6d4a80f1,0x672401cd,0x6566005d,0xa6f48162}},	//   _shfa, nnij, _kukh, рзиш,
   {{0x94868162,0xe9da835f,0xb226bb4a,0x443c854f}},	//   лынд, _яка_, _смал, _syv_,
   {{0x38c8819f,0x656641a8,0x2907801b,0x6724026c}},	//   _جاری_, _mukh, chna_, hnij,
   {{0xdb020bd7,0x5ea68019,0x6f028369,0x4c9b00be}},	//   ktlä, _ممال, _tloc, עשטע,
   {{0x67240025,0xe45700be,0x8aff0041,0x2f1a80eb}},	//   jnij, טייט_, _buƙa, rīgs_,
   {{0x7f5d02be,0x92580198,0x0eab00c2,0xb69b0493}},	//   _risq, лают_, _छाबड, _blân,
   {{0xbcfb0144,0x98a78084,0xbebb03ed,0xbd029517}},	//   _cuél, poną_, _gjëj, _šéfr,
   {{0x395e910f,0xffe4104b,0x7e6d0580,0x7d1ac703}},	//   _mits_, бютн, tcap, mits,
   {{0x7d1ac704,0xc8780059,0xeafb003d,0x2bc8016f}},	//   lits, ığa_, _سرعت_, रबना,
   {{0xd49b023a,0x7e6d10e1,0x2d8f0019,0xb5fb0091}},	// [35f0] ере_, rcap, ége_, _afár,
   {{0x7d1ac705,0x65664706,0x395e823e,0x3f9c8699}},	//   nits, _dukh, _nits_, krvu_,
   {{0x67244707,0x7faa8201,0x9c4701b5,0x1cb815a9}},	//   bnij, _məqs, ухал, طالب_,
   {{0x67240052,0x7e62c708,0x7d1ac709,0x2d8d857b}},	//   cnij, _ngop, hits, ysee_,
   {{0xdd0107d9,0xef1984b7,0x7cdb00eb,0xd49b0073}},	//   ştır, viż_, _pārē, _прв_,
   {{0x69c9807a,0x7e6280e5,0x395e81a9,0x6ce73f56}},	//   _vsee, _agop, _cits_, _сіме,
   {{0x80ad1370,0x7d1ac70a,0x395e9b01,0xbebb0168}},	//   _जाने, dits, _dits_, _njëk,
   {{0xb8fcc70b,0x4975a57e,0x69c990af,0x2d8d8c04}},	//   _तो_, _влас, _tsee, tsee_,
   {{0x7bd88006,0x660d2486,0x09b88277,0x628bc70c}},	//   _arvu, nzak, _مطلع_, mago,
   {{0x7d1ac70d,0x5f958098,0x2d8d8c4d,0x7b16470e}},	//   gits, _вижт, rsee_, ršum,
   {{0xd8748060,0x04458c8e,0x2905c70f,0x3b0a0ae7}},	//   _طالب, ренн, _illa_, вено_,
   {{0x60c38179,0x628bc710,0x216a0b88,0x25698019}},	//   lenm, nago, кими_, _túl_,
   {{0xfce5b0bc,0x6ef59313,0x67240025,0x7bcac711}},	//   _воло, _fábr, vnij, _esfu,
   {{0x81b800c8,0x26cf9143,0x393601e5,0x660d4712}},	//   ছিল_, _hago_, рэмс, dzak,
   {{0x67240025,0xb8ee0c2d,0x628ba272,0x26cfc713}},	//   tnij, _रस_, kago, _kago_,
   {{0x6f0980a9,0x26cfc714,0x2caa008e,0x6ef5816b}},	//   nhec, _jago_, _scbd_, _zábr,
   {{0x29058181,0x6724012b,0xa3cd8ebf,0x6da611f3}},	// [3600] _olla_, rnij, रिक_, риза,
   {{0x67240025,0xb4c2053e,0x80ad4252,0x6d41831d}},	//   snij, ्ये_, _जाये, nlla,
   {{0x24878f23,0x6d41c715,0x6cd31a37,0x389b03c8}},	//   _menm_, illa, تقلا, _ביינ,
   {{0x2905c716,0x628baab2,0x7d1ac717,0xe29ac718}},	//   _alla_, gago, zits, тад_,
   {{0x395e82e6,0x6f030087,0x7d1a8ab4,0x28e28bc2}},	//   _pits_, _înca, yits, पालि,
   {{0x3f9cb4d5,0xaca3819d,0x89da826a,0x26cf8091}},	//   trvu_, _brọk, _یوزر_, _aago_,
   {{0xb8cec252,0x7b240052,0x26cf82b8,0x628bc719}},	//   _का_, rđuj, _bago_, bago,
   {{0xd6d7c64b,0x2905c71a,0x6d41c71b,0xa8570039}},	//   ать_, _ella_, ella, סיקה_,
   {{0x26cf811e,0x10a6835f,0x7d1ac71c,0xc0e69b47}},	//   _dago_, _визн, tits, _коак,
   {{0x6208807e,0x60c3c71d,0x6296038a,0xdb0209c4}},	//   ırlı, cenm, _adyo, lulè,
   {{0x7d1ac71e,0x80c50f12,0x26cf83a8,0x660d471f}},	//   rits, ाजसे, _fago_, zzak,
   {{0x6d41c720,0x291cc721,0x7d1ac722,0x26cfc723}},	//   alla, liva_, sits, _gago_,
   {{0x7bda0bcf,0x26c4c724,0xb5fb0032,0x8b57807c}},	//   _štul, memo_, _agán, ייטס_,
   {{0xb4c2000d,0x29050125,0x291cc725,0x7cf68087}},	//   ्यो_, óla_, niva_, _vârs,
   {{0xb4c201d0,0x9b9488ca,0x26cf8091,0xdb0b006a}},	//   ्यै_, _البت, _yago_, _opfø,
   {{0x27ed003b,0x660d011e,0x2fcd009a,0x6d4e25b0}},	//   ćen_, tzak, łego_, _ahba,
   {{0x60c3b78f,0x798404b9,0x224902d0,0x291cc726}},	// [3610] yenm, _gwiw, _uzak_, kiva_,
   {{0x61fd2158,0x660d4727,0x6efc8eba,0xe1ff009a}},	//   mysl, rzak, _débi, wców_,
   {{0x660d0019,0x60c3c728,0x26188074,0x9f3505a8}},	//   szak, venm, _बेसी_, _гені,
   {{0xf21c000f,0xaefb0706,0x6e32128a,0xf21281bc}},	//   _पेड़_, _diùc, _žebř, rọnọ,
   {{0x6d41c729,0x60c3c72a,0x26cfc72b,0xa9c78087}},	//   ylla, tenm, _rago_, рсек,
   {{0x628babd3,0x3169083a,0x291c8037,0x7c280088}},	//   sago, _muaz_, giva_, _ždre,
   {{0x26cf9fd1,0x260f823c,0x628bc72c,0xa2d8816f}},	//   _pago_, _तेजी_, pago, _नोव्,
   {{0x3ea91904,0x53348328,0x3eb9808b,0x0d858ba8}},	//   ngat_, _дест, ýst_, блин,
   {{0x20c78364,0x291cc72d,0xc33280be,0x98c79630}},	//   _всег, biva_, _זון_, _всел,
   {{0xdb1c83d3,0xa5da00be,0x6aad01a1,0x6f098144}},	//   _aprè, אַטי, _acaf, shec,
   {{0x63a50057,0x2bda009a,0x26cfc72e,0x673d02f1}},	//   nuhn, णिया, _tago_, _oksj,
   {{0x26c490d3,0xc86900be,0x442e81e0,0x6d41c5f7}},	//   cemo_, _טן_, _dxf_, slla,
   {{0xdb02472f,0x6abb81bc,0x61fd0196,0x248782d6}},	//   nulé, _mbuf, gysl, _tenm_,
   {{0xcd768039,0x673d00e8,0xa9670f9c,0xed4480e8}},	//   _העסק_, _aksj, сира_, _дніп,
   {{0xa3cd85b3,0xd0071fc1,0x69cd0cdb,0x6abbbbb8}},	//   रिओ_, бере_, _esae, _obuf,
   {{0x291c82a5,0x98a7809a,0x3ea94730,0x753c14df}},	//   ziva_, ronę_, ggat_, _skrz,
   {{0xc27b0039,0x10a600e8,0x98a61bc1,0xaefb0a2a}},	// [3620] _גרפי, _липн, _липе, _siùc,
   {{0x26c4c731,0x6abbc732,0x7af601e0,0x88ca0c4f}},	//   zemo_, _abuf, _hoyt, _слов_,
   {{0xcfea03f8,0x63a50867,0x26c480b4,0x25b20123}},	//   _صفحه_, guhn, yemo_, styl_,
   {{0xfaa6a09a,0x69db8625,0xddc981d6,0x7ae40609}},	//   садо, _brue, dbež, _jnit,
   {{0xdce28052,0xd946902f,0x61469dc7,0xd91a89c7}},	//   _suoč, беди, беда, льк_,
   {{0x63a50057,0x26c4a813,0x6abba970,0x291a00b9}},	//   buhn, wemo_, _ebuf, _jmpa_,
   {{0x291c888b,0x7ae40091,0x26c48314,0xa3bc03ca}},	//   riva_, _onit, temo_, _अहि_,
   {{0xa3d6946d,0xc6f8a466,0xe8d900ff,0x69db888a}},	//   सिस_, рних_, _tuệ_, _frue,
   {{0x26c4c733,0x249800b9,0x69dbc734,0x291cc735}},	//   remo_, _kdrm_, _grue, piva_,
   {{0x6aad3648,0x26c4c736,0x7d1e02d5,0xbf0500a5}},	//   _scaf, semo_, nips, _रत्न_,
   {{0xb5fb0118,0x25a00d8b,0x261885fc,0xdb1cc737}},	//   _agál, hril_, _बेरी_, _apré,
   {{0xa3cd86a7,0x291a4738,0x69cd0118,0x7ae40362}},	//   रिज_, _ampa_, _psae, _cnit,
   {{0x4aaa0c78,0x7d1e4739,0x2d9fc73a,0xaaaa0744}},	//   _कारव, kips, crue_, _कारक,
   {{0x7ae42df1,0x25a0473b,0x2d92067f,0xf1270c5c}},	//   _enit, dril_, dsye_, сьмо,
   {{0x28de1a46,0x24b78039,0x76428681,0x236a010c}},	//   माजि, _ההון_, _hyoy, _nubj_,
   {{0x69c0838e,0x3ea90087,0xf99f03ec,0x764283f7}},	//   _opme, ugat_, prè_, _kyoy,
   {{0x7bdc4395,0xd0d50098,0xddc99024,0x44f50bba}},	// [3630] _arru, _допъ, zbež, опас,
   {{0x04671baa,0x8c671ddf,0x63a50b20,0x753a8f3e}},	//   стам, стад, tuhn, notz,
   {{0x69c08029,0x7f4405c9,0xbc4b0150,0x645a473c}},	//   _apme, bliq, учае_, _útil,
   {{0x69db85b4,0xa294835f,0x63a5010b,0x672d9bcf}},	//   _prue, заці, ruhn, čajk,
   {{0x6f0d061f,0x63a509ca,0xe1ff4057,0x7bdc0102}},	//   mhac, suhn, nyó_, _erru,
   {{0x28ad0743,0xf7718250,0x63a500c3,0x6f0d07b6}},	//   ञ्चि, واب_, puhn, lhac,
   {{0x7762c73d,0x764284b9,0x628f2190,0x37868081}},	//   _biox, _ayoy, kaco, общо_,
   {{0x6d45473e,0x2d9584fa,0x69db8257,0x6abb9d61}},	//   llha, орос, _true, _ubuf,
   {{0x2903473f,0xd629c740,0xdd8e80a0,0x76428db1}},	//   kkja_, ропе_, نوي_, _cyoy,
   {{0x26d980e1,0x7af64741,0x753a811b,0xdb059d31}},	//   ôsob_, _soyt, gotz, sthä,
   {{0x02c61194,0x25a000b9,0xddc28035,0x7642c742}},	//   ойно, zril_, _czoł, _eyoy,
   {{0x7bda00cd,0x6b9c8661,0x628f4743,0x25a0113b}},	//   _štuk, árga, gaco, yril_,
   {{0x6f0d24ee,0xa96a047f,0x2d4d1f3a,0x3204016b}},	//   dhac, рига_, _džez_, ámy_,
   {{0x6efc82be,0x6729c744,0xb4e80327,0x320c066f}},	//   _débu, lnej, _मचे_, ądy_,
   {{0x656bc745,0xd9430012,0xbf0511bc,0x6b650110}},	//   _hugh, фери, रसून_, _mėgs,
   {{0x7ae439ac,0x6f0d0870,0x656b8c53,0x6729c746}},	//   _unit, ghac, _kugh, nnej,
   {{0x6563c747,0x2498288e,0x80a50019,0x20110037}},	// [3640] _kinh, _pdrm_, _کمپن, azzi_,
   {{0x25a0433a,0x6563c748,0x6443b4f1,0xdca30adb}},	//   rril_, _jinh, _kyni, дафи,
   {{0x6563c749,0x7d1e2585,0x7f4405c9,0x656bc74a}},	//   _minh, rips, pliq, _lugh,
   {{0xe9daaa0e,0x6563c1c8,0x6f0d474b,0x6729c74c}},	//   ике_, _linh, chac, jnej,
   {{0x68f70201,0x7762802a,0x6d450114,0x752895d8}},	//   _yoxd, _riox, blha, yndz,
   {{0x628f21a2,0x1d0a245b,0xf8068009,0x224d8b67}},	//   zaco, _теги_, жчин, _dzek_,
   {{0xe3a78416,0x224d8019,0xeb971b3f,0x28b20f3d}},	//   _تر_, _ezek_, _мир_, _जानि,
   {{0x644e0ee1,0x656bc74d,0x63b303c1,0xe1faa59a}},	//   _izbi, _bugh, žení, _кгб_,
   {{0x6563c74e,0x62829151,0x64439428,0x3cf80589}},	//   _binh, mboo, _ayni, _korv_,
   {{0xa3d685e8,0x2b46823e,0x32d700ff,0x656bc74f}},	//   सिल_, lloc_, _ủy_, _dugh,
   {{0x6563c345,0x64438114,0x6729875f,0x628f4750}},	//   _dinh, _cyni, bnej, taco,
   {{0x6563c751,0x672981ac,0x644381e6,0x753a8102}},	//   _einh, cnej, _dyni, sotz,
   {{0x628f0a7a,0x7d1c026c,0x753ac752,0x6563c753}},	//   raco, _omrs, potz, _finh,
   {{0x644e0025,0x65639ac4,0x628f2484,0x6282c754}},	//   _ozbi, _ginh, saco, hboo,
   {{0x6f0d125b,0x6282c755,0x20051d9a,0x60c74756}},	//   thac, kboo, áli_, rejm,
   {{0x442d003a,0xe7f280cf,0x443100ee,0x290346be}},	//   _će_, _अपना_, _rxz_, skja_,
   {{0x200518a6,0x6d45112e,0x63a884ef,0x644e00fc}},	// [3650] šli_, tlha, ludn, _azbi,
   {{0x6729a7aa,0x7c280bcf,0x62829447,0x6563c757}},	//   znej, _ždra, eboo, _xinh,
   {{0x63a8807a,0x62829de6,0xa2a5152c,0x290eaaa0}},	//   nudn, fboo, _काञ्, dhfa_,
   {{0x6282c758,0x672901a1,0xddcd4759,0x7d1c05ee}},	//   gboo, čejs, mbaž, _emrs,
   {{0x6729a19f,0x63a8c75a,0x28b2064a,0xed5b0180}},	//   vnej, hudn, _जामि, _نشست_,
   {{0x656bc75b,0xb17c04de,0x98aa01d0,0x69dd8118}},	//   _rugh, סטור, době_, _ásem,
   {{0xa2ac035a,0x6729c75c,0xe8d9019d,0x3d00016f}},	//   _झाल्, tnej, _gwụ_, _शकते_,
   {{0x0d859d8f,0x656ba7e4,0x63a8a676,0x2b46a112}},	//   плин, _pugh, dudn, cloc_,
   {{0x6443c75d,0x67298165,0x65638187,0xb3648081}},	//   _syni, rnej, _pinh, _църк,
   {{0x67299fe7,0xe6168e11,0x656bc75e,0x2b400af8}},	//   snej, яды_, _vugh, _skic_,
   {{0x6563c75f,0x6f1d00f3,0x628d0362,0xbb460254}},	//   _vinh, _omsc, _beao, зенк,
   {{0x6443850f,0x7d0ac760,0x798994ee,0x691006ae}},	//   _vyni, _elfs, _kwew, _käeg,
   {{0x55e581a1,0x25a913b8,0x6563c1c8,0x64438063}},	//   _холб, jual_, _tinh, _wyni,
   {{0x3eadc761,0x63a8c02c,0x25a94762,0x4dda81c6}},	//   lget_, budn, dual_, _לחנו,
   {{0x6f040668,0x3ce8999e,0x6282c763,0xbebb0168}},	//   tkic, जारे_, yboo, _njës,
   {{0x3eadb7c0,0x7d1c011f,0x628281e0,0xdce60da8}},	//   nget_, _smrs, xboo, _vukč,
   {{0x6f0400d2,0x316d8388,0xf6510019,0x7989838a}},	// [3660] rkic, _nuez_, ہئے_, _nwew,
   {{0x6f044764,0x6282c3b6,0x600a0791,0xd88400d7}},	//   skic, wboo, _гном_, _تهدی,
   {{0xc9530039,0x798982e9,0x5fe04765,0xe0fb025f}},	//   _רמת_, _awew, _पछिल, _הליל,
   {{0xcfc380c8,0x25a90748,0x798983f7,0xe2979541}},	//   ্মান, bual_, _bwew, зац_,
   {{0xd9468aac,0x3eadc766,0x6282c767,0x237f005c}},	//   педи, dget_, rboo, _čuje_,
   {{0x673b4768,0x2d804769,0x69c403a8,0x7bc3c76a}},	//   čuje, mpie_, _mpie, _opnu,
   {{0x6282a2dd,0x2b4681e0,0xab648192,0x2ca7016a}},	//   pboo, ploc_, grüß, ónde_,
   {{0x3ead8f06,0x3da69033,0x69c40dee,0xb2268012}},	//   gget_, проб, _opie, _ембл,
   {{0xa0a68084,0x96349fb4,0x5d549182,0x316d83c9}},	//   _наад, ьниц, мкит, _guez_,
   {{0xcb98835f,0x63a8822b,0x48d70264,0xa61701c6}},	//   ової_, tudn, _সক্র, פקיד_,
   {{0xa9f7000d,0x5335151c,0x6efc8036,0x68e88366}},	//   ुन्छ_, дент, _débr, _indd,
   {{0x63a8850a,0x68fac76b,0x61e09502,0xcb0b1e11}},	//   rudn, _hotd, _krml, сход_,
   {{0x76460009,0xaefb0229,0xc6938e82,0xa6b40264}},	//   _nyky, _diùl, _נאס_, ুযায়,
   {{0xa3df0935,0xbebb00f1,0xd90f0077,0x61e080c3}},	//   तिम_, _njër, اید_, _mrml,
   {{0xc7c40db6,0x4fc40a9f,0xdb1cbd42,0x1cbb84de}},	//   нсти, нста, _aprí, _המוע,
   {{0x6d48c76c,0x25a9476d,0xdb1c81a8,0x64430035}},	//   llda, tual_, _bprí, żnik,
   {{0xa63400e8,0x69dd8187,0xf1b118a9,0xe3b8807e}},	// [3670] енті, _àsex, _जमिन, ltı_,
   {{0x4d980a41,0x64c7052a,0x291e8db1,0x68fa8799}},	//   якую_, रजेश, _nmta_, _notd,
   {{0x28b21e19,0xe3b883bf,0x3ead8106,0x25a930e3}},	//   _जाति, ntı_, yget_, sual_,
   {{0xf1b1000f,0x290cc76e,0x6f1d0192,0xa3d481a2}},	//   _जमान, _alda_, _umsc, _हनन_,
   {{0xeab081a8,0x672d0822,0x9647259a,0xa9f981d0}},	//   اعم_, mnaj, _хэнд, ्नेछ_,
   {{0xd0450201,0xe3b88457,0xbebb00f1,0x3e7c01d0}},	//   _sahə, ktı_, _gjër, rátů_,
   {{0xb8d5abef,0xdfce80f7,0x656f476f,0x60d70df6}},	//   _झा_, ليو_, _huch, _maxm,
   {{0x656f4770,0x6d5a8640,0xe5799ddf,0xfbd20039}},	//   _kuch, emta, ози_, _בתל_,
   {{0x51878098,0x3eadbfcc,0x61e0812b,0x7ae9c771}},	//   _хуба, rget_, _grml, _inet,
   {{0x656f1220,0x69dd0353,0x7afb838e,0x2f23826b}},	//   _much, dvse, _hout, _bègè_,
   {{0x656f4772,0x69c44773,0x7afb8247,0xfaa60993}},	//   _luch, _spie, _kout, мано,
   {{0x6d48c774,0x6f03002e,0x7afb8009,0x656f4775}},	//   alda, _înch, _jout, _ouch,
   {{0x657d01e9,0x60d70085,0x68e88114,0xd706804a}},	//   _ntsh, _baxm, _yndd, _інше_,
   {{0x6606804a,0xdce280e1,0xbcfb0144,0xa3c2170c}},	//   økke, _zvoľ, _mués, ्बम_,
   {{0x7ae9811b,0x1867164f,0xdb1c80e1,0xa067030d}},	//   _onet, дари_, _sprí, дара_,
   {{0x656f4776,0x7afbc777,0x69c01238,0x7ae985ee}},	//   _buch, _nout, çmes, _nnet,
   {{0x656f2423,0x2bd580c2,0xf7430993,0x60d700f5}},	// [3680] _cuch, धिका, тето, _faxm,
   {{0x656f0a7a,0x7ae98217,0x2d80002f,0x80bf8035}},	//   _duch, _anet, rpie_, ल्मे,
   {{0x7afbadb2,0x6d4380b9,0x628601c0,0x8e862606}},	//   _bout, _mkna, obko, _огне,
   {{0x2bf68158,0xe51dab62,0x7afbc778,0x4e0d8441}},	//   ומען_, योति_, _cout, िनाई_,
   {{0x7afbc779,0xfe420065,0xc69304de,0xb17b013c}},	//   _dout, _شکری, _באר_, rvåg,
   {{0x60c180b9,0x7ae9c77a,0xe3b8811c,0xbebb03ed}},	//   _cblm, _enet, ytı_, _ujër,
   {{0x7afbc77b,0xd01080f7,0x3320002a,0xe3b88085}},	//   _fout, طلة_, _omix_, xtı_,
   {{0x6d43c77c,0x7afba9d5,0x7ae9c77d,0xd75781a8}},	//   _akna, _gout, _gnet, وجيا_,
   {{0x6604373c,0x68fac65b,0xa3b089c8,0x3494b383}},	//   nyik, _totd, टून_, напр,
   {{0x672d0289,0x7afb8247,0xe3b88214,0xbcfb0661}},	//   znaj, _zout, ttı_, _huér,
   {{0x7afbc77e,0x2be10697,0x60d701b4,0x48eb80c2}},	//   _yout, फिया, _raxm, चारो_,
   {{0xe3af817e,0x38638019,0xdd8f803d,0xe3b8807e}},	//   گری_, _újra_, _چون_, rtı_,
   {{0x6ef5803e,0x672d807a,0xdd8f8a47,0x6abd007b}},	//   _náby, čajt, _نون_, rfsf,
   {{0xe3af80d5,0x656f0491,0xe3b882d0,0x61e48198}},	//   دری_, _ruch, ptı_, äily,
   {{0x656f477f,0xb88201ac,0x628608dc,0xc7b80a41}},	//   _such, _číta, bbko, мёт_,
   {{0xdcc70f21,0xa3db82f1,0x63a5016b,0x656701e9}},	//   रज्ञ, ठिर_, vrhn, _sijh,
   {{0xa3d69299,0x672d3732,0x7afbc780,0x5d554781}},	// [3690] सिक_, rnaj, _rout, екат,
   {{0x7afbc782,0x88c4009a,0x2fd303a8,0xdb020658}},	//   _sout, ęści, _tsxg_, mulá,
   {{0x7afbc783,0xfe700117,0x5695151b,0x656f4784}},	//   _pout, ادہ_, _пант, _wuch,
   {{0x224910fe,0x656f4785,0xd6d98035,0x3f8301b9}},	//   _kyak_, _tuch, koła_, mpju_,
   {{0xe664259a,0x7bda0088,0x7ae9807a,0x2fc580b9}},	//   _атро, _štut, _vnet, _splg_,
   {{0x23690282,0xc9849d7b,0xe8f88d13,0xe9d886cf}},	//   _liaj_, туци, млі_, ькі_,
   {{0x7afba24b,0x26d94786,0xf7458293,0xbcfb0144}},	//   _tout, _kaso_, неко, _fuér,
   {{0x236901c5,0x26d90102,0x7ae9c787,0xdb024788}},	//   _niaj_, _jaso_, _unet, kulá,
   {{0x2d998065,0x26d94789,0x2d8b82be,0x2bd18a27}},	//   ése_, _maso_, èce_, _तनहा,
   {{0xf8078364,0xdb022792,0x26d9478a,0x00000000}},	//   _очен, dulá, _laso_, --,
   {{0x8b2600af,0x8cc11199,0x798d38b3,0x224902d0}},	//   едне, र्यो, _awaw, _ayak_,
   {{0x28b20576,0x236901c5,0x26d9350c,0x798d2578}},	//   _जाहि, _ciaj_, _naso_, _bwaw,
   {{0xdca59383,0x64a59957,0xdb020f09,0xf1e283b6}},	//   _зали, _зала, gulá, पियन,
   {{0x2618823c,0x80bb000c,0x656fc533,0x2249478b}},	//   _बेटी_, श्ले, íchu, _dyak_,
   {{0x26d9478c,0x6724478d,0x79828035,0x3e750133}},	//   _baso_, tiij, zpow, _ụta_,
   {{0x6d419a9f,0xdb1c826f,0xdcba0768,0xfe7981d0}},	//   lola, _oprá, ैज्ञ, nců_,
   {{0xe5a30aac,0x6da31a34,0xdce381a1,0xada302df}},	// [36a0] лити, лита, _linč, латл,
   {{0x6d41c78e,0xaac1000d,0x02c103b6,0x8aff09ab}},	//   nola, ष्ठक, ष्ठभ, _duƙu,
   {{0x26d91c7d,0x660436e2,0x6616009a,0x25ad8216}},	//   _faso_, syik, szyk, huel_,
   {{0x6d41c78f,0xbcfb087a,0x67240079,0xe29280f7}},	//   hola, _quér, qiij, اذا_,
   {{0x6d41be4f,0x61e20253,0x68fe4790,0xdced04b7}},	//   kola, _šolj, _kopd, ssaġ,
   {{0x6b51816d,0x6d418573,0x63ba90cc,0x2a6d826b}},	//   råga, jola, yttn, _egeb_,
   {{0x6d41c791,0xfaa681e2,0xdce38140,0x7cf68162}},	//   dola, _паво, _cinč, _târz,
   {{0x61e410ab,0x6e2d8b80,0xb1839c18,0xdce38b80}},	//   _oril, _žaba, šťan, _dinč,
   {{0x25adb0a4,0x6d41acc4,0xe2a6807b,0x6d5e1867}},	//   guel_, fola, æðum_, ompa,
   {{0x6d41c792,0xe9d780e8,0x6b9c06ec,0x798d0a03}},	//   gola, _яку_, _kvrg, _rwaw,
   {{0x66e6a4a4,0xdb1c800d,0x22490239,0xf8b39101}},	//   _пожа, _zprá, _syak_, _תשע_,
   {{0x201800b9,0x61e44793,0x60dab5c3,0xdb024794}},	//   dzri_, _bril, _hatm, tulá,
   {{0x6d41c795,0x23694796,0x69068125,0xc3338039}},	//   bola, _viaj_, _aðei, רור_,
   {{0x6d41b5dc,0xa3c2123a,0xd0488085,0x2eeb0036}},	//   cola, ्बा_, _sadə, _sncf_,
   {{0x26d9040e,0x23690282,0x61e4037b,0xb4ac9834}},	//   _paso_, _tiaj_, _eril, गली_,
   {{0xdb0203b0,0xd6d80cf9,0xf7700019,0x61e42ca0}},	//   pulá, нту_, صاف_, _fril,
   {{0x6722822e,0x7aed4797,0xe573080b,0xe4a715b1}},	// [36b0] _mmoj, _inat, اطر_, ерео,
   {{0x6fe085b3,0xaab12bef,0x63a8c798,0x81d68264}},	//   पटां, _झाँक, ordn, িমা_,
   {{0xdb1c8a56,0x26d93e97,0x7aed007b,0x6b9a888b}},	//   _sprá, _taso_, _knat, nstg,
   {{0x6d41c799,0x66fb01ab,0x8aff00fc,0xa5a18035}},	//   zola, _एकटक_, _tuƙu, _खिलौ,
   {{0x7aed479a,0xe4a7230e,0xdce3850b,0x25ad8036}},	//   _mnat, _прво, _sinč, xuel_,
   {{0x7f4d03e7,0xeafe0cf0,0x4438008e,0x60dac79b}},	//   llaq, _उक्त_, _fxr_, _catm,
   {{0x6d418a9e,0xe7399577,0x644a8186,0xaab106a7}},	//   vola, мек_, _nyfi, _झांक,
   {{0x25adc79c,0xdce39fa6,0x6455479d,0x6d41c79e}},	//   tuel_, _vinč, _izzi, wola,
   {{0x6d41c79f,0x6f09810b,0x60dac7a0,0x200980eb}},	//   tola, rkec, _fatm, ņai_,
   {{0x7aed47a1,0x270e159a,0x25ad957a,0x25a9020d}},	//   _anat, _सत्र_, ruel_, iral_,
   {{0x63a880d2,0x644a8114,0x25a900e1,0x6d588609}},	//   grdn, _cyfi, hral_, _dhva,
   {{0x6d41c7a2,0x74c10075,0x25a90b17,0x68fe02c4}},	//   sola, र्तृ, kral_, _sopd,
   {{0x6d41c7a3,0x25adc7a4,0x1c1e035a,0x63a8808e}},	//   pola, quel_, _येईल_, ardn,
   {{0x7e7d47a5,0x6d4181b4,0xe5a2954f,0xddc28115}},	//   _afsp, qola, _тиши, _ugoš,
   {{0x21670b9c,0xa9671878,0x764b8114,0x673b0390}},	//   тири_, тира_, _hygy, čujn,
   {{0x61e447a6,0x69c9815f,0x7c2e8333,0x84648081}},	//   _tril, _opee, úbre, _съче,
   {{0x61e4002e,0x69c981c0,0x6b9c0289,0x0e6647a7}},	// [36c0] _uril, _npee, _svrg, ткан,
   {{0x7aed003a,0x25762320,0xd9100117,0xc00617c8}},	//   _znat, _væl_, _ایس_, _апок,
   {{0xeb9747a8,0xa3df28b3,0x7d03016d,0x6b51816d}},	//   вих_, तिष_, önsa, rågn,
   {{0x130a8190,0x60daa2f8,0xfaa68779,0x2aeb114f}},	//   ьней_, _satm, тадо, टाएँ_,
   {{0xceb30158,0xdb020bc5,0x827700be,0x161a064a}},	//   _דיר_, pulæ, דענע_, _नेचर_,
   {{0x92ce00ab,0x6b588531,0x8cc104c5,0x6722882c}},	//   রায়_, díge, र्दो, _smoj,
   {{0xdbcc007b,0xd00f80f7,0xc01000ff,0x2d9d82d6}},	//   _góða, يله_, _đuổi_, _avwe_,
   {{0x6d58803a,0xa3df2cdd,0xceb40085,0x63a880fe}},	//   _shva, तिर_, ciət_, vrdn,
   {{0x32469ac9,0x94868162,0x60da9238,0x2127827d}},	//   _реаг, кынд, _tatm, binh_,
   {{0x6ad292ee,0xb4ac8d14,0x44f4813a,0x61e2829a}},	//   _ससुर, गले_, упос, mvol,
   {{0xe9ff8028,0x61e2c7a9,0x929547aa,0xdb023b13}},	//   _thảo_, lvol, ланц, kulä,
   {{0xdb9b010f,0x6722822e,0xf6268ab2,0x7e7bc7ab}},	//   וסטר, _umoj, _идео, ccup,
   {{0xf2d3893f,0x61e2907f,0x69dd81fa,0xceb381c6}},	//   בער_, nvol, _áset, _כיף_,
   {{0x6d58803b,0x25a90085,0xa8a4017c,0x3494c7ac}},	//   _uhva, vral_, ирск, _сакр,
   {{0xe7e58128,0x7f4d02a6,0x40350073,0xe8940110}},	//   किया_, tlaq, уевс, рась,
   {{0x7aed47ad,0xb7db83c8,0x6d4747ae,0x7528ae63}},	//   _unat, וקלי, _skja, lidz,
   {{0x273701cd,0x2d8f02be,0xe6640878,0x7e55004a}},	// [36d0] għna_, ège_, атфо, уває,
   {{0x58d50009,0x61e28696,0x2ba99869,0x7528a795}},	//   _соот, dvol, _किमा, nidz,
   {{0x69c9c7af,0xdd86804e,0x7a0a81a9,0x2127827d}},	//   _spee, _گو_, _lētā, vinh_,
   {{0x25a947b0,0x7b3c812b,0x6b518106,0x6f160ebf}},	//   pral_, jčud, rågo, chyc,
   {{0xdd869fbe,0xf1bf47b1,0x28c0000f,0x8d874184}},	//   _دو_, ntá_, श्वि, _шунд,
   {{0x6f0d47b2,0x26c685ee,0xb4ac8072,0xadc38032}},	//   lkac, _aboo_, गलो_, _gbẹk,
   {{0xf7718872,0x6d4515e6,0x645547b3,0x290147b4}},	//   حات_, moha, _uzzi, _moha_,
   {{0x6d452916,0xa3c22b51,0xdb0580f7,0x6f0d47b5}},	//   loha, ्बर_, rthó, nkac,
   {{0x752880dd,0x62998077,0x645c808b,0x7bca8a03}},	//   fidz, mawo, ýrin, _apfu,
   {{0x6299c7b6,0x7c2805f3,0x6b58c7b7,0x63730372}},	//   lawo, _ždri, ríge, _aħni,
   {{0xc2091101,0x6f0d0326,0xf1bf02df,0x5edb8264}},	//   _צה_, kkac, etá_, ভাবে,
   {{0xa77a80be,0x26c68133,0x6299c7b8,0x2f11826b}},	//   _טרעפ, _gboo_, nawo, _fága_,
   {{0xed4ec44a,0xa3d381fe,0x6d4547b9,0x6729c702}},	//   _го_, _सैर_, koha, miej,
   {{0x6d4547ba,0x3ea200dd,0x67298110,0x75288267}},	//   joha, _sdkt_, liej, cidz,
   {{0x37c380c8,0xab2a0009,0x26dd80a4,0x6d45059e}},	//   ্মকর, _пока_, _kawo_, doha,
   {{0x67298d12,0x236d809a,0x26dd84b9,0x26df8084}},	//   niej, _niej_, _jawo_, nduo_,
   {{0x25bf8012,0x6609ae43,0xdce38029,0xe7370364}},	// [36e0] ntul_, nyek, _zinā, ует_,
   {{0x62960637,0xa3c7a342,0x798402d5,0x25bf8162}},	//   _heyo, _उहा_, _itiw, itul_,
   {{0xdb023c40,0x6e2d8bcf,0x6729866f,0xb17b0338}},	//   pulä, _žabl, kiej, nvån,
   {{0xf8c00a27,0x26ddc7bb,0xa3e48128,0x6f0d47bc}},	//   श्रय, _nawo_, नित_, ckac,
   {{0x6d4547bd,0xf1268ca0,0x25bfaf9f,0xe81c8035}},	//   boha, лько, jtul_, _भेजा_,
   {{0x61e2b3fc,0x26d2005d,0xbebd8110,0x6d450034}},	//   rvol, leyo_, siūl, coha,
   {{0x3d0783bb,0x61e294f9,0xa3df0743,0x6d5c47be}},	//   ाउने_, svol, तिः_, _ihra,
   {{0x26d247bf,0x61e29384,0x758aa3e7,0x75288035}},	//   neyo_, pvol, нсов_, widz,
   {{0x9d149bc1,0x26dd9cee,0xa0b68a47,0x1634c7c0}},	//   идич, _dawo_, _محاص, репя,
   {{0x88bc801b,0x6aa4046d,0x26d202c4,0x02039a47}},	//   _změn, _adif, heyo_, _узун,
   {{0x9b5900a9,0xef868615,0x61d4b738,0x25bf8162}},	//   киот_, _слеп, _धनुष, atul_,
   {{0xa3a9800f,0x667680f7,0x6609c7c1,0x290147c2}},	//   गंज_, _إدار, byek, _soha_,
   {{0x25bf802e,0x6d5c2cc7,0x6d4504a7,0xf2d38158}},	//   ctul_, _ohra, yoha, זער_,
   {{0x6aa41883,0x60de47c3,0x863781c6,0x26ddb08f}},	//   _edif, _capm, _גאדג_, _zawo_,
   {{0x6d4503a7,0xf1bf1c18,0x7984019d,0x19580009}},	//   voha, stá_, _etiw, уары_,
   {{0x6458c7c4,0x2ba980a5,0x656e0c41,0x6b5647c5}},	//   _izvi, _किता, _aibh, pága,
   {{0x6f0d47c6,0x6d4547c7,0x291800f7,0x6d5c0c5e}},	// [36f0] rkac, toha, bhra_, _bhra,
   {{0xb0b20063,0x6d5c0219,0x67298084,0x291847c8}},	//   _जाएग, _chra, ziej, chra_,
   {{0x62960010,0x6299c7c9,0x644e0122,0x3a75a4c8}},	//   _yeyo, tawo, _cybi, алер,
   {{0x98a9805c,0x6f028079,0x6d4529e2,0x656e0219}},	//   đač_, _nooc, soha, _eibh,
   {{0x60de07d9,0x62999410,0x6d5c032f,0xf99f06c0}},	//   _yapm, rawo, _fhra, nsè_,
   {{0x6d5c0c41,0x26ddc7ca,0xbebb03ed,0x656e47cb}},	//   _ghra, _sawo_, _njëz, _gibh,
   {{0xfe718307,0xdb1ca32f,0xb8cd86ae,0x629986a9}},	//   يدة_, _språ, _कय_, pawo,
   {{0x88bc81d0,0x6609810c,0x661b811b,0xaefb0706}},	//   _uměn, tyek, tzuk, _dhùg,
   {{0x629647cc,0x7afd01a1,0x67298196,0xa8a798a3}},	//   _reyo, djst, riej, _брек,
   {{0x25bf802e,0x629647cd,0x661b9bb7,0x656e022c}},	//   rtul_, _seyo, rzuk, _xibh,
   {{0x25bf8012,0x661b8063,0x5ea780ab,0x26dd9341}},	//   stul_, szuk, ক্ষে, _tawo_,
   {{0x25bf8012,0x3947c7ce,0xda66280f,0xb17b016d}},	//   ptul_, lons_, ивни, rvån,
   {{0x82d6812a,0x80df00ab,0xbbd10651,0xaefb0706}},	//   בורג_, মান্, सबुक, _liùs,
   {{0x3947c7cf,0x26d201f6,0x66068009,0x25ad80e1}},	//   nons_, weyo_, äkke, mrel_,
   {{0x6f02c7d0,0x7d0380f7,0x5f0647d1,0xdfd200f7}},	//   _yooc, _ions, азва, غير_,
   {{0x1e86024f,0x06860470,0x6d5c47d2,0x61e98493}},	//   рлам, рган, _shra, _orel,
   {{0x7d03c7d3,0x78bb005c,0xa5260a8e,0xa1560098}},	// [3700] _kons, đuvr, амад, _външ,
   {{0x64a647d4,0x26d247d5,0xdca60374,0x3947c7d6}},	//   ража, seyo_, ражи, jons_,
   {{0x61e98333,0xe29a81e2,0x7d0390b6,0x93469374}},	//   _arel, вае_, _mons, анже,
   {{0xf99f06c0,0xdee602ee,0x66e61509,0x7d03c7d7}},	//   zyèm_, _томи, _тома, _lons,
   {{0x644e0063,0x6d5c0224,0x3947c7d8,0xd90d826a}},	//   _wybi, _thra, fons_, کیل_,
   {{0x97a6a804,0x6d5c3933,0x656e01e4,0x25a007c0}},	//   арил, _uhra, _uibh, msil_,
   {{0xf0930051,0x64a302cb,0xdfd08013,0x03a30dbd}},	//   חנו_, _фаса, سية_, _миро,
   {{0x61e98a35,0xbb438012,0xa3e48bbc,0x3ec38d15}},	//   _frel, _деск, निस_, осьб,
   {{0xc6f79006,0x61e9c7d9,0xe0da97d6,0x394787f1}},	//   рных_, _grel, _ива_, bons_,
   {{0xdceb8087,0x7ae2b3bc,0x8fa69bdc,0x81cc0264}},	//   _rugă, ldot, _важе, রটা_,
   {{0x25a00201,0x2f150106,0xa3df0035,0x69c2b5da}},	//   hsil_, _låga_, तिए_, ltoe,
   {{0x7ae2b56e,0x25a044cf,0x98a301a9,0xaefb0706}},	//   ndot, ksil_, dijā_, _liùr,
   {{0x7d03c2af,0x69c2c7da,0xdd8e8019,0x273a8ec3}},	//   _fons, ntoe, _کوڈ_, cīna_,
   {{0x29c28028,0x7ae28198,0x2d050072,0x7d03a937}},	//   _mưa_, hdot, _शकेल_, _gons,
   {{0x753d8065,0x6458bbac,0x69c28009,0x61e247db}},	//   észe, _uzvi, htoe, _šolt,
   {{0x6d48c7dc,0x25a00609,0xa3c21513,0x7d03c7dd}},	//   loda, fsil_, ्बई_, _zons,
   {{0x629d47de,0x394780e7,0x7ae2ad08,0x7bdc47df}},	// [3710] maso, yons_, ddot, _asru,
   {{0x44f40705,0xa8a71290,0x3947c5e6,0x30a718c6}},	//   опус, _трик, xons_, _трив,
   {{0x61e982a5,0x98a300eb,0x394780e7,0x9cd78039}},	//   _srel, cijā_, vons_, שובה_,
   {{0xfaff020f,0x629d02c4,0x06ac80c8,0x2ba9923a}},	//   një_, naso, ক্তি, _किसा,
   {{0xa2bc29b7,0x249847e0,0x672d0010,0x3947c7e1}},	//   ष्ट्, _ferm_, miaj, tons_,
   {{0x629d47e2,0x61e98da8,0x660d0542,0x88bc801b}},	//   haso, _vrel, myak, _uměl,
   {{0x3947c7e3,0x6d48c7e4,0xb8ff931d,0x660d2a96}},	//   rons_, doda, _तस_, lyak,
   {{0x4975860a,0x7d03c7e5,0xf83804de,0x28a70b04}},	//   _глас, _sons, ינות_, कृति,
   {{0x660d4450,0xa3df0aad,0x7d03c7e6,0x629d47e7}},	//   nyak, तिक_, _pons, daso,
   {{0x6d48803a,0x7bc181ec,0x660d02d5,0x7ae0b6ba}},	//   goda, ttlu, iyak, _zamt,
   {{0xe29a031f,0x04458e02,0x94078085,0x660d00b4}},	//   лан_, сенн, _yenə_, hyak,
   {{0x2905c7e8,0xa3e8000f,0x2d85219f,0xf1bb800f}},	//   _hola_, बित_, _člen_, _ईमान,
   {{0xfce5895a,0x6d48c7e9,0x68e1c7ea,0x7bc1c7eb}},	//   _голо, boda, _kald, stlu,
   {{0x7d1ac3a6,0x61e20353,0x68e380f1,0x0fda0e11}},	//   chts, _šols, ndnd, льбы_,
   {{0x8cca03db,0x09d4873c,0x290590e5,0xb4b3816f}},	//   स्फो, _धन्य, _mola_, टली_,
   {{0x290580e4,0x629d0511,0x98a300eb,0x6b5d00e7}},	//   _lola_, caso, rijā_, tége,
   {{0x660d01bf,0x60d5026c,0x7c248326,0x7ae08366}},	// [3720] gyak, bezm, _ƙirg, _ramt,
   {{0x2ed485e8,0x25a047ec,0x7ae0c7ed,0x2905811e}},	//   _दस्त, rsil_, _samt, _nola_,
   {{0x6b5d0117,0x7ae08052,0x940c8201,0x4adc0074}},	//   sége, _pamt, fadə_, _बसाव,
   {{0x1db78540,0xb21b008b,0x734980e8,0x2b5f80ff}},	//   _आमंत, mbær, ачів_, _chuc_,
   {{0x68e1c7ee,0x2905a362,0xd9108416,0x59f884fa}},	//   _bald, _bola_, ویر_, реля_,
   {{0x69c29de6,0xd9438198,0xa80282d0,0x7ae0c7ef}},	//   rtoe, печи, şıml, _wamt,
   {{0x6d488f20,0x69c29e7e,0x2905c7f0,0x629d2290}},	//   voda, stoe, _dola_, yaso,
   {{0xdc3700be,0x69c289ff,0x6d48c7f1,0x6f060af8}},	//   _האלט_, ptoe, woda, _jokc,
   {{0x6b58c7f2,0x68e1c7f3,0x6d48c7f4,0x6282ad81}},	//   lígo, _fald, toda, mcoo,
   {{0x68e1c7f5,0x28c480d4,0x629d0b3f,0xa3bc001b}},	//   _gald, ल्शि, waso, _आमा_,
   {{0x6d48ac28,0x629d3721,0x8cca0035,0x2458b23a}},	//   roda, taso, स्यो, рань_,
   {{0x2ba98996,0x23a9800f,0x23600282,0x660d00a4}},	//   _किरा, _किरद, _chij_, yyak,
   {{0x629d071e,0x2905c6e1,0x6d488b24,0x63ab009a}},	//   raso, _yola_, poda, ągni,
   {{0x672d009a,0x463b80be,0x629d0102,0x47d200ab}},	//   wiaj, _געדע, saso, হিনী,
   {{0xaac89d01,0x629d47f6,0x4ac88ebf,0x5f940012}},	//   रभाक, paso, रभाव, зист,
   {{0x6d4e1953,0x660d3d9b,0x6b5d0061,0xec3781c6}},	//   _akba, tyak, ségb, _לאור_,
   {{0x645c4022,0xe8d90870,0x23668699,0x246e811c}},	// [3730] _azri, _atụ_, dmoj_, ləm_,
   {{0xe29f007b,0xe6c00668,0x61ed47f7,0x660d47f8}},	//   lað_, čišć, _iral, ryak,
   {{0x2905ba69,0x8cca80d4,0x660d04bf,0x3e6f8214}},	//   _rola_, त्यो, syak, _kötü_,
   {{0x61ed0289,0xe29f0125,0x325590f8,0xd6db47f9}},	//   _kral, nað_, овер, _сто_,
   {{0x290581df,0x28c0023c,0x7c87373a,0x99d780f7}},	//   _pola_, श्कि, _губе, إتصا,
   {{0x6440009a,0x68e19b37,0xa969818b,0x21699509}},	//   _śmie, _qald, шила_, шили_,
   {{0x68e1c7fa,0xe29f007b,0x2905c7fb,0xdbf1801b}},	//   _vald, kað_, _vola_, _přít,
   {{0x68e1c7fc,0x0d8585c2,0x7bc547fd,0x777ab11d}},	//   _wald, олин, mthu, _dutx,
   {{0x68e180ad,0x7bc53a20,0xe5768e11,0x645c00b9}},	//   _tald, lthu, озы_, _zzri,
   {{0xb4b3b64b,0x7989c7fe,0xdb1c83ba,0x628447ff}},	//   टले_, _itew, _sprø, _sfio,
   {{0x61ed4800,0x7bc54801,0x777a811e,0x394080f7}},	//   _aral, nthu, _gutx, éise_,
   {{0x61ed141f,0xbfb492c8,0xd2508065,0x44211a1f}},	//   _bral, _رحمت, _آنے_, izh_,
   {{0x4e78845b,0x64a5bdc4,0xdca597c8,0x61ed0362}},	//   _احمد_, _дала, _дали, _cral,
   {{0xd56787f2,0xdc698087,0xe3b18742,0x7bc50687}},	//   _утеп, _калд_, _قرب_, kthu,
   {{0xe7ec8e18,0xa06a0f04,0x186a14b8,0x61ed4802}},	//   झिया_, рава_, рави_, _eral,
   {{0x61ed4803,0x6aa98c53,0x7c2d8300,0x81d08264}},	//   _fral, _ndef, _ƙirƙ, ষিত_,
   {{0x61ed2590,0x7ae44804,0xd7f8002e,0x44210dc1}},	// [3740] _gral, _iait, ţă_, ezh_,
   {{0x7ae44805,0x2716864a,0x6aa9826b,0x7d070b80}},	//   _hait, _तत्र_, _adef, _cojs,
   {{0x7ae44806,0x7af60f91,0x8b2680e8,0x6f0602f7}},	//   _kait, _knyt, одже, _tokc,
   {{0x7ae40102,0x741301a8,0xfaff0168,0xa80282d0}},	//   _jait, بوما, hmën_, şıkl,
   {{0x7ae44807,0x69c60065,0x6aa9831d,0x6282c808}},	//   _mait, ntke, _ddef, rcoo,
   {{0x7ae44663,0x3ea04809,0xed570d0e,0x6282c80a}},	//   _lait, lait_, _моя_, scoo,
   {{0xea0100ff,0x6b5d4089,0xfbc33a2d,0xd7fa8c6e}},	//   _đậu_, héga, _обро, рул_,
   {{0x7ae4480b,0x3ea0480c,0xd838882c,0xc6f8a466}},	//   _nait, nait_, _neče_, сних_,
   {{0xe29f007b,0xaf079a3c,0xb17b004a,0xb0ca1c4f}},	//   vað_, تقيم_, rvåk, िभाग,
   {{0x61ed00f1,0x38c887d2,0xdb218019,0x7af60039}},	//   _rral, _داری_, ütör, _anyt,
   {{0x7ae4480d,0xe29f0125,0x06ac80ab,0x98a30084}},	//   _bait, tað_, ক্ষি, niją_,
   {{0x06658077,0x246e8201,0x61ed480e,0x7ae40cac}},	//   _کامپ, rəm_, _pral, _cait,
   {{0x7ae4480f,0x3ea026b9,0xe29f007b,0x41e4102a}},	//   _dait, dait_, rað_, міра,
   {{0x7bc50428,0xe29f008b,0x25a68299,0x752a913b}},	//   ythu, sað_, _ivol_, _umfz,
   {{0xbbc903bb,0x7d070353,0xe29f008b,0xa2db816f}},	//   _रहेक, _rojs, pað_, _नसल्,
   {{0x61ed1e72,0x7ae44810,0x06ac80ab,0xd6ac80ab}},	//   _tral, _gait, ক্রি, ক্রয,
   {{0x690b0722,0xaded81af,0xdb02016b,0x61ed4811}},	// [3750] _qües, जियन_, nulý, _ural,
   {{0x929d809a,0x7ae40102,0x7bc54812,0xa2c10894}},	//   _poło, _zait, tthu, _वाड्,
   {{0x7ae4035a,0x3ea04813,0xb4ab009a,0x7d0704ef}},	//   _yait, bait_, _गयी_, _vojs,
   {{0x6abd2280,0x442103e7,0x61290858,0x7d070035}},	//   ngsf, rzh_, džli, _wojs,
   {{0x237f02a5,0x68e50009,0x7bc509ff,0xa3e1941b}},	//   _čuju_, _kahd, sthu, _नैन_,
   {{0x673b003a,0x290302f7,0x68e54269,0x92d70264}},	//   čuju, njja_, _jahd, সায়_,
   {{0xa2959ae5,0x68e54814,0x98a301e2,0x657d08dc}},	//   _наві, _mahd, ciją_, _hush,
   {{0x657d4815,0xdfce803d,0x753a8102,0x7b3c81a1}},	//   _kush, ايي_, entz, nčul,
   {{0x64469010,0xd838b1a7,0x80dc00d4,0x7ae44816}},	//   şkil, _reče_, _फसले, _rait,
   {{0x7ae44817,0x58bb8bbe,0x6e200074,0x68e54818}},	//   _sait, _خارج_, _ümbe, _nahd,
   {{0x6d890038,0xd838850b,0x7ae42ff6,0xfaff0168}},	//   _hľad, _peče_, _pait, rmën_,
   {{0x65750326,0x96b8c6a1,0x62810035,0x2fc78122}},	//   _lizh, _душу_, ślon, mtng_,
   {{0xd83890d3,0x3ea04819,0x213100dd,0x2bd218a9}},	//   _veče_, vait_, fizh_, _सहभा,
   {{0x645d8086,0xeb18864a,0xdd920065,0xeb08943e}},	//   əsin, _दत्त_, ہور_, _वक्त_,
   {{0x7ae4481a,0x2fd3002a,0x442184e1,0x3ea04042}},	//   _tait, _cpxg_, _åh_, tait_,
   {{0x657d297b,0x673b98c2,0x77698144,0x0d860bda}},	//   _bush, nnuj, nmex, злан,
   {{0x3ea0174b,0xf1da809a,0xfe43481b,0x68e5481c}},	// [3760] rait_, _मैंन, енто, _fahd,
   {{0x657d481d,0x3ea0481e,0xd5af0591,0x6b56041c}},	//   _dush, sait_, افل_, dági,
   {{0x3c21811b,0x3ea0481f,0xa3e48fea,0xa87b0039}},	//   _eгvv_, pait_, निए_, _לאיר,
   {{0x657d4820,0x98a30110,0x2b81c821,0x63be80e8}},	//   _fush, riją_, _móc_, _åpne,
   {{0xceb3093f,0x657d4822,0x673b817f,0xd6c380ab}},	//   _איר_, _gush, dnuj, ্যায,
   {{0x28c00778,0x6455026f,0x2d8281d0,0xf53f0338}},	//   श्चि, _fyzi, íkem_, _tvåa_,
   {{0x04430ca0,0xbbda801b,0x2b818129,0x48fe8327}},	//   _зерн, _बनेक, _nóc_, लाबो_,
   {{0x1ae39198,0x543b0039,0x671c0eed,0x657d00fc}},	//   _посм, _העלא, नसिक_, _yush,
   {{0x4343997b,0x6e242c91,0x657d0df6,0xbb438103}},	//   _четв, nzib, _xush, _четк,
   {{0x47d480ab,0x2b818129,0x6b518338,0x6e2405ee}},	//   থিবী, _bóc_, bågs, izib,
   {{0xdbf1801b,0x2b8180ff,0x69c0023e,0x4ae08072}},	//   _přát, _cóc_, àmen, _नसाव,
   {{0x1dac4823,0x60c4973d,0xf6e580e8,0x6aa2804f}},	//   _चिंत, đimu, _оцін, naof,
   {{0x6abd03a6,0x6f044824,0x872581a8,0x9f47010c}},	//   rgsf, djic, _تعلم, _éné_,
   {{0xb4ab009a,0x61ed8201,0xb4e6000d,0x67d51775}},	//   _गये_, çilə, भयो_, могу,
   {{0x3d000a16,0x2b81801c,0xd7f842c4,0xb9054825}},	//   राने_, _góc_, пут_, _नस_,
   {{0x443f003a,0x63ba858b,0x7d0ac826,0x68e5022b}},	//   _ću_, mutn, _hofs, _wahd,
   {{0xa3e49a46,0x1bea8ee6,0xa2a20105,0x6aa28187}},	// [3770] निक_, टिवल_, _ख़त्, daof,
   {{0x04670676,0xf1b20035,0xe61f0114,0x798d4827}},	//   птем, _जितन, _ffôn_, _itaw,
   {{0x69100006,0xedd9801b,0x1e188697,0x23810196}},	//   _päev, _भन्छ, धनुष_, _vėjo_,
   {{0x657d4828,0x6b560187,0xdb058168,0x6f16237c}},	//   _tush, tági, mshë, ckyc,
   {{0xdb1c8019,0x63ba816b,0x672083ed,0xbebd8196}},	//   _apró, hutn, dhmj, kiūr,
   {{0x63ba8057,0xdb1b0009,0xe4e400e8,0xe9d88a18}},	//   kutn, lttä, _пісн, які_,
   {{0x1bd44829,0x20548098,0xdb058168,0x62860106}},	//   _поря, нтър, nshë, ycko,
   {{0x63ba80dd,0xe61995a6,0x629f1cb5,0xdb1b0198}},	//   dutn, жди_, _neqo, nttä,
   {{0x798d146a,0x2b81c82a,0x98a78087,0x7769c82b}},	//   _ntaw, _sóc_, gină_, rmex,
   {{0xee369842,0x3d000105,0xe6c4876c,0xdb058168}},	//   ьны_, राये_, češć, kshë,
   {{0x3c65835f,0x2d540006,0x798d373c,0xdb058168}},	//   ьког, päev_, _ataw, jshë,
   {{0x57278250,0x799b81bc,0x2b818129,0x3dc9482c}},	//   _عراق, _kwuw, _vóc_, ktaw_,
   {{0x3d002724,0x80c4801b,0xdb058168,0x98a78162}},	//   रामे_, _रामे, eshë, cină_,
   {{0x63ba8f68,0x2b818028,0x3ebf8722,0xdb058168}},	//   butn, _tóc_, lgut_, fshë,
   {{0x63ba80b9,0x06e080ab,0x798d2e00,0xa3dc2724}},	//   cutn, ভারি, _etaw, _तैं_,
   {{0x3ebfc82d,0xdbd90073,0x2c0a801b,0x7b060118}},	//   ngut_, nçõe, ाहरू_, _lóuz,
   {{0xf50a228e,0xd8389c67,0xdbd9241f,0xaefb00ff}},	// [3780] онал_, _meča_, içõe, _thùn,
   {{0xb4b8009a,0x61e4482e,0x3ce7c82f,0x6f1601d6}},	//   छले_, _isil, _janv_, skyc,
   {{0x6f660073,0x0aea8049,0xb6a38129,0x799b85e7}},	//   _овоз, ждей_, _phầ, _awuw,
   {{0x60dc4830,0x7c650277,0xdb1c8176,0xddcb4831}},	//   lerm, رالل, _aprò, žišk,
   {{0xa2c100d4,0xb5fb016b,0xdb1c8035,0x2baa06a7}},	//   _वास्, _vzác, _spró, _चटका,
   {{0xa91d8289,0x26c01aae,0x7d030106,0x98a78162}},	//   _nužd, lgio_, önst, vină_,
   {{0x38cb89d7,0xd83880d2,0x799b8c2e,0x4425ad1b}},	//   تانی_, _beča_, _ewuw, jzl_,
   {{0x60dc4832,0x61e422cd,0xef91803d,0x69100074}},	//   herm, _osil, ایند, _käes,
   {{0x60dc1e62,0x75d480f7,0x8c3c8085,0x29184833}},	//   kerm, ريدا, dağa, kkra_,
   {{0x6b5d03d3,0x2fdf0063,0x63ba8ad4,0xdbd90187}},	//   tégo, ługi_, tutn, açõe,
   {{0xdb1b025d,0x61e44834,0xccf8801b,0x798d009a}},	//   yttä, _asil, dmět_, _staw,
   {{0x68e8c835,0x290c805c,0x79808b15,0x63ba8359}},	//   _hadd, _hoda_, _kumw, rutn,
   {{0x60dc1cdc,0xff278077,0x63ba8025,0x68e8c836}},	//   ferm, _تبلی, sutn, _kadd,
   {{0xfc2f83f8,0x79808542,0x660f8884,0xdb0580f1}},	//   احی_, _mumw, äcke, tshë,
   {{0x68e882bb,0x61e44837,0xba3b4838,0x63ba80b9}},	//   _madd, _esil, caïn, qutn,
   {{0x26c00021,0x6d5ac839,0x8ccaa29e,0xc3280013}},	//   ggio_, llta, त्रो, _يكون_,
   {{0x798d483a,0x64588364,0xc61200c8,0x68fa838e}},	// [3790] _utaw, _hyvi, _সেবা_, _ontd,
   {{0x290c80dd,0x2918016d,0x68e88365,0x6d5a85ee}},	//   _noda_, ckra_, _nadd, nlta,
   {{0x3dc946e9,0xa7750abe,0xa3e4bed8,0x60c50176}},	//   staw_, _плоч, निट_, _ichm,
   {{0x160e83db,0xae0e8d86,0xbebb0168,0x290c8362}},	//   िहार_, िहान_, _emër, _aoda_,
   {{0x68e88ec8,0x290cc83b,0x3f8137ee,0xf1a7980b}},	//   _badd, _boda_, _huhu_, френ,
   {{0x41b2009a,0x290c88d8,0x3f810074,0xd838979d}},	//   _जिसस, _coda_, _kuhu_, _seča_,
   {{0xa91d817f,0x78a38338,0xa92781a9,0x25a9483c}},	//   _ružd, ranv, _režī, lsal_,
   {{0x6d5ac83d,0x78a38365,0x68fa81ec,0x59b18beb}},	//   elta, sanv, _entd, ुंदर,
   {{0x7afbc83e,0x290cc83f,0xb9b58875,0x98a30084}},	//   _inut, _foda_, _سماع, siję_,
   {{0x290cc840,0x68e8985b,0x7afb816b,0x7ae98198}},	//   _goda_, _gadd, _hnut, _haet,
   {{0x60dc0f82,0xc4d200be,0x3f81054e,0x29c981ca}},	//   verm, נגט_, _nuhu_, lúa_,
   {{0x78a1c841,0x6d5a8046,0x61e401e0,0x60c54842}},	//   _helv, alta, _psil, _achm,
   {{0xa2c1000c,0x68e8c843,0x29c982ba,0x60dc4844}},	//   _वार्, _yadd, núa_, term,
   {{0x7ae980f7,0x291e1eca,0x3f8100fc,0x8c4581cf}},	//   _laet, óta_, _buhu_, _пеле,
   {{0x9d1a80be,0x46f60678,0x69cb8f67,0x7c8488ed}},	//   _מוסט, нчат, htge, _руче,
   {{0xdee34845,0xe45680be,0x60dc4846,0x7c2d8041}},	//   лоси, _איצט_, serm, _ƙarf,
   {{0xea010104,0x26c02118,0xc69280be,0x69c981c0}},	// [37a0] _đầu_, rgio_, טאן_, _nqee,
   {{0x7afb99f7,0x79808314,0x7d7a83de,0xafe61a80}},	//   _anut, _rumw, פרעג, _зоол,
   {{0x389b0158,0x68e8c847,0x69c980b9,0x6aa09b6b}},	//   _מיינ, _radd, _aqee, _pemf,
   {{0x6d554848,0x7ae9c849,0x612201ac,0xfe6788ca}},	//   _ekza, _caet, _dôle, _مد_,
   {{0xa3e50105,0xb17b04e1,0x7ae98114,0x6d5a8106}},	//   _बैठ_, lvår, _daet, ylta,
   {{0x68e896bb,0x672404bf,0x1c0f83b7,0x2ca581fa}},	//   _qadd, lhij, ाहाल_, jald_,
   {{0xa2c101b6,0xb90895bc,0x4ac6016f,0x78a184fe}},	//   _वाल्, _बस_, _वाढव, _delv,
   {{0x68e8c836,0x8b668077,0x7ae9c84a,0x7659831d}},	//   _wadd, _سازم, _gaet, _bywy,
   {{0x290c9313,0xa84a80d5,0x78a18019,0x2ca58370}},	//   _toda_, _کلام_, _felv, fald_,
   {{0x3c2500ad,0x2d82484b,0x3ea49722,0xb17b016d}},	//   _vзvv_, _muke_, samt_, kvår,
   {{0x7d0e484c,0x929530c6,0xe57103de,0xa2950a4c}},	//   _mobs, канц, יַט_, кані,
   {{0xa4fd000c,0x60c502af,0x6458816b,0x3320484d}},	//   _उच्च_, _schm, _vyvi, _clix_,
   {{0x3f81059c,0x2ca581ec,0x6e3b00e1,0xd2440087}},	//   _suhu_, bald_, _ľubo, гэри,
   {{0x63be04e8,0xd5b990ac,0x7d0e0609,0x39860c0b}},	//   kupn, _ісі_, _nobs, _dôs_,
   {{0x67d41541,0xdfd80098,0x332007f1,0x6b588118}},	//   лору, нът_, _flix_, lígu,
   {{0x63be0057,0x2d82484e,0x61e292eb,0x25a9484f}},	//   dupn, _buke_, kwol, tsal_,
   {{0x2d820267,0x25a91b6c,0xe7e28035,0x5d550323}},	// [37b0] _cuke_, usal_, _कैसा_, вкат,
   {{0x2edd80d4,0x2d820e79,0x7d1a82f1,0x7ae9c850}},	//   _मस्त, _duke_, nkts, _saet,
   {{0x25a94851,0x236901c0,0x7ae9c852,0x78a182f1}},	//   ssal_, _khaj_, _paet, _relv,
   {{0x78a1aa3d,0x67240a0f,0x29c985e4,0x25a9001b}},	//   _selv, chij, túa_, psal_,
   {{0xdd86881b,0x66640098,0x5f0490a1,0xe5c72f42}},	//   _خو_, _бърз, वान्_, _ясно,
   {{0x69cb84eb,0x78a70669,0x88bc81d0,0xccf881d0}},	//   rtge, najv, _směr, změr_,
   {{0x69cbc853,0x7c288390,0x7ae9c854,0x63be008e}},	//   stge, jzdr, _taet, cupn,
   {{0xf77185ff,0x256600e7,0x26c6bb40,0xadc40032}},	//   جات_, rôle_, _ccoo_, _akẹr,
   {{0x49758e9f,0x62849c67,0x9fb6001b,0x99d4bb76}},	//   _алас, žioc, vřít_, _متلا,
   {{0xe9759a3c,0x2f11c855,0x61e482d0,0x26c68037}},	//   _شهاد, _págs_, çile, _ecoo_,
   {{0xa91d8067,0x8c459e25,0xecc6086a,0xa8028380}},	//   _tužb, тене, र्टफ, şırl,
   {{0x76598114,0x6f0f01e8,0x23690242,0xf1bf016a}},	//   _tywy, _nocc, _chaj_, rzán_,
   {{0xb5fb0061,0x6aa600b9,0xf1bf041c,0x0b4301b5}},	//   _szán, rakf, guá_, рнян,
   {{0x2d82003a,0x6fd88424,0x6f09a6af,0x9e6483a9}},	//   _ruke_, _महमू, ljec, _свід,
   {{0x2d8203c3,0xea010028,0x10a33751,0x6f0f0081}},	//   _suke_, _đấu_, рисн, _bocc,
   {{0x2d82020d,0x6f0f4856,0x22160a41,0x66040102}},	//   _puke_, _cocc, _афор, txik,
   {{0x67244857,0x6da60258,0x6f0f0081,0xb17b0106}},	// [37c0] rhij, тиза, _docc, rvår,
   {{0x6b83c858,0x672402a0,0x63be05b9,0xe6c91351}},	//   _kung, shij, tupn, čašć,
   {{0x6d41c859,0x6b83c85a,0x68fe00e5,0x7c290326}},	//   inla, _jung, _inpd, _ƙera,
   {{0x6b83b1d5,0x6441485b,0x63be017f,0x6f0f047f}},	//   _mung, _žlic, rupn, _gocc,
   {{0x9c7c827f,0x6f09a1a2,0xaca3819d,0x6b83c290}},	//   leče, djec, _apọk, _lung,
   {{0x61e28114,0x6f0f01e8,0x6aa421fb,0x7b3c8088}},	//   rwol, _zocc, _leif, jčuv,
   {{0x03a3214d,0x6a86a550,0x6b83c85c,0xb4de485d}},	//   _висо, _алба, _nung, ढ़ी_,
   {{0x6d5e485e,0x2ca32f9f,0x04431505,0x2fda00b9}},	//   llpa, _zejd_, _тесн, _mppg_,
   {{0x91e399a4,0x5d548323,0x3eb981a8,0x6b83aaa0}},	//   _коте, лкит, ósta_, _aung,
   {{0xe29a0028,0x660f816d,0xa8028085,0xfe7f023e}},	//   _đưa_, äcka, şıql, _raïm_,
   {{0x9c7c920e,0x6b83c85f,0x6b5d12ab,0x6f09c860}},	//   ječe, _cung, légi, bjec,
   {{0x6b839b11,0x61f60aa2,0xddcfc861,0x7984010c}},	//   _dung, _bryl, žešk, _buiw,
   {{0x6f0f0081,0x645c4862,0x6aa44863,0x7def8061}},	//   _rocc, _lyri, _deif, rősö,
   {{0x6f0f4864,0x7984067f,0x2f150687,0x61f60286}},	//   _socc, _duiw, _lågt_, _dryl,
   {{0xf7730bbe,0x28d20778,0x6b83c865,0x236901c5}},	//   لار_, द्धि, _gung, _thaj_,
   {{0x5eb40ada,0x6280808e,0x27fe0106,0x2007023e}},	//   ийст, _ngmo, åtna_, _ànim_,
   {{0x657c076d,0x79840041,0x7aed02c4,0x645c22f8}},	// [37d0] _birh, _guiw, _iaat, _ayri,
   {{0x7aed4866,0x672280f1,0x6b83b107,0x98a79c28}},	//   _haat, _lloj, _yung, binę_,
   {{0x6f0f0081,0xb227007b,0x7aed4867,0x6b8388f1}},	//   _tocc, _fræð, _kaat, _xung,
   {{0x7c248326,0x3f570866,0x27f9928a,0xb22701fa}},	//   _ƙirj, rçus_, _čsn_, _græð,
   {{0x7aed1694,0x3ea94868,0x6f09af9f,0x69cf45e6}},	//   _maat, maat_, vjec, ntce,
   {{0x645c1c86,0xeb9308ca,0x7aed4869,0x1bf4823c}},	//   _fyri, _نظر_, _laat, ेमाल_,
   {{0x6f09a4a0,0x98a28009,0xb8dbb26c,0x3d00114f}},	//   tjec, щище, _अय_, रारे_,
   {{0x765d0364,0x6b83c86a,0x7aed486b,0xa91d95db}},	//   _kysy, _rung, _naat, _duža,
   {{0x6aa4486c,0xdce38bda,0x8cca04c5,0xaefb01e4}},	//   _reif, _sinđ, स्को, _chùi,
   {{0x6b8383f8,0x61e9c86d,0x6f0982ce,0x6e29851c}},	//   _pung, _isel, sjec, rzeb,
   {{0xb5fb0065,0x7aed0365,0x6722c86e,0xfaa6198c}},	//   _szál, _baat, _floj, лано,
   {{0x7aed486f,0x15f587bd,0x61f6016d,0x6b58957a}},	//   _caat, _مستح, _pryl, lígr,
   {{0x9c7cc870,0x3f858b20,0x6b83ab35,0x3ea91e7a}},	//   veče, _hulu_, _wung, daat_,
   {{0x6b83c871,0x25adb804,0x64a5c872,0x92df80ab}},	//   _tung, msel_, _сака, তায়_,
   {{0xc815035f,0x25ad831e,0x3ea94873,0x3f859c67}},	//   аєть, lsel_, faat_, _julu_,
   {{0x7bc1c874,0xa3b89344,0x61e9c875,0x3f858b99}},	//   mulu, _चित_, _osel, _mulu_,
   {{0x7bc1c876,0x201e4877,0x765d0355,0x645c4878}},	// [37e0] lulu, šti_, _cysy, _syri,
   {{0xb4de0b9f,0x319b012a,0x7aed24f2,0xb19b03c8}},	//   ढ़े_, _רבינ, _zaat, _רייכ,
   {{0xf5368158,0x9c7cc879,0x7bc1c87a,0x69db85a4}},	//   נטער_, peče, nulu, _apue,
   {{0x25adc87b,0x3ea9487c,0x645c3999,0x6b5d4011}},	//   ksel_, caat_, _vyri, tégi,
   {{0x7bc1c87d,0x99d380f7,0x657c02c4,0x765d0114}},	//   hulu, متوا, _tirh, _gysy,
   {{0x7bc1bc4c,0x645c01e2,0x3f85b661,0xdce380eb}},	//   kulu, _tyri, _bulu_, _minē,
   {{0x7bc1c87e,0xd54709b5,0xd90d803d,0x61e9c87f}},	//   julu, _спре_, بیل_, _esel,
   {{0x3f858393,0x7bc1c880,0xc6f89fde,0x60c8849c}},	//   _dulu_, dulu, тних_, _wcdm,
   {{0x25ad84fe,0xd33581e2,0xe1faa59a,0x7ae2c881}},	//   gsel_, _тэры, _яга_, meot,
   {{0x7aed3126,0xa91d811f,0x80d601c4,0x7bc1c882}},	//   _saat, _tuža, म्मे, fulu,
   {{0x7bc1c883,0x7aed4884,0xa3bb80d4,0x3f85c885}},	//   gulu, _paat, इंग_, _gulu_,
   {{0xb5fb0117,0x23a58076,0x7aed02a3,0x317e811e}},	//   _szám, _खबरद, _qaat, _hitz_,
   {{0x7aed247f,0xa5968698,0x3f85c206,0x3ea90a53}},	//   _vaat, _срещ, _zulu_, vaat_,
   {{0x7bc1b598,0xa2c103dd,0x6d58807a,0x7aed4886}},	//   bulu, _वाक्, _ukva, _waat,
   {{0x7aed4887,0x7bc1c888,0x3ea9282a,0x753aabfa}},	//   _taat, culu, taat_, mitz,
   {{0x753a8813,0xa91d8499,0xcb69003d,0x765d0009}},	//   litz, _nužn, _جمعه_, _pysy,
   {{0x3ea94889,0x7bdc488a,0xdb1e80e7,0x7ae2a9a4}},	// [37f0] raat_, _apru, cupé, deot,
   {{0x753a87e2,0x3ea9015d,0xd7f88087,0x628f0088}},	//   nitz, saat_, _oră_, lcco,
   {{0x765d009a,0x61e98fd6,0xb97a01c6,0x04671246}},	//   _wysy, _ssel, _שנתי, утам,
   {{0x92eb80f7,0x753a8102,0x3ea905ee,0x7f440722}},	//   عراق_, hitz, qaat_, cniq,
   {{0xa91d803a,0x7bc1c88b,0x6f0d488c,0x753a8102}},	//   _dužn, zulu, mjac, kitz,
   {{0xf77f07d9,0x6f0d003a,0xe8f885a8,0x7a2a8061}},	//   _hiç_, ljac, ллі_, _söté,
   {{0x753a8102,0xd70595a6,0x6b5d0036,0x7bc18162}},	//   ditz, изки, légu, xulu,
   {{0x6d573d27,0x6f0d2e96,0xd34389a7,0x25adc88d}},	//   loxa, njac, _افری, tsel_,
   {{0xd7068009,0x6e2d488e,0x2bdd8035,0xb5fb0061}},	//   рные_, nzab, _फैजा, _száj,
   {{0x7bc1ad7b,0x25adc88f,0x753a811b,0x6d4508b6}},	//   tulu, rsel_, gitz, nnha,
   {{0x30848013,0x237f8176,0xe29a079e,0xa2cc800d}},	//   _المف, _kiuj_, кан_, _हाम्,
   {{0x68e3c890,0x7bc1c891,0x6f0d02a5,0x290144e8}},	//   lend, rulu, jjac, _anha_,
   {{0x7bc1c892,0xfe9a8051,0x6f0d10d3,0x753ac893}},	//   sulu, _סיסמ, djac, bitz,
   {{0x82768158,0x68e3c894,0x6d454895,0xa91d80e1}},	//   יערע_, nend, jnha, _mužo,
   {{0x2bb10063,0xa3e5198e,0x68fc86a5,0x8fa6096f}},	//   jąc_, _बैल_, _órde, рабе,
   {{0x68e3c896,0x273f0009,0xd91009a7,0x6fd8bac3}},	//   hend, vänä_, _کیس_, _महसू,

   {{0x661bafb7,0xa91d805c,0x29130118,0x63a38114}},	// [3800] nyuk, _ružn, _foxa_, _hwnn,
   {{0x33f61b93,0x26cb0098,0x68e3ad03,0xf1bf0061}},	//   ичес, _ecco_, jend, zzák_,
   {{0x68e3c897,0xa3bb8540,0x225f808e,0x2ca7c898}},	//   dend, इंट_, _ayuk_, _mend_,
   {{0x753a811e,0x28d2000c,0x6f0d009a,0x48ee001b}},	//   zitz, द्रि, cjac, इएको_,
   {{0x2bd20c78,0x272a801c,0xdb020338,0x273f062c}},	//   _सहका, _hùng_, mslä, sänä_,
   {{0x39582bd5,0x68e3c899,0xc05a80e8,0x8b96351e}},	//   nors_, gend, кій_, _врач,
   {{0xa91d8024,0x8c430b88,0xf8b30039,0x443e16d2}},	//   _tužn, _дере, קשה_, _ät_,
   {{0x9c7c93ee,0x6d5c007a,0xd838826c,0x395800e7}},	//   ječa, _hkra, _ječi_, hors_,
   {{0x60ea8ae7,0x753aabfa,0x3958489a,0x2a6001c0}},	//   _имам_, titz, kors_, _nyib_,
   {{0x395802e6,0xd8388279,0x6443009a,0x63a385ee}},	//   jors_, _leči_, źnie, _bwnn,
   {{0x39580813,0x753ac89b,0x6e2d0d3d,0xb0aa0035}},	//   dors_, ritz, zzab, करनग,
   {{0x753a9919,0xd6d9809a,0xee3a8bda,0x48fe801b}},	//   sitz, koły_, _ине_, लाको_,
   {{0x78a88065,0xf5948013,0x6d5c105e,0x3958489c}},	//   _kedv, _التج, _okra, fors_,
   {{0x78a8803b,0xf77f00f1,0x272a8129,0x6fca852a}},	//   _jedv, _siç_, _bùng_, संपू,
   {{0x272a8104,0x4ea70073,0xaad781d0,0x4ad78107}},	//   _cùng_, ираа, ण्डक, ण्डव,
   {{0x68e3c89d,0x272a8104,0x6d5c489e,0x6c7b812a}},	//   zend, _dùng_, _akra, _באופ,
   {{0x68e3c89f,0xdceb0696,0x2913002a,0x8cc200dc}},	// [3810] yend, šičk, _toxa_, _लाखो,
   {{0x290148a0,0x61ed48a1,0xa91d81ac,0x6e2d48a2}},	//   _unha_, _isal, _ružo, rzab,
   {{0x68e3c8a3,0x6d4548a4,0x6d570358,0x236d81c0}},	//   vend, rnha, roxa, _phej_,
   {{0x68e3c8a5,0x28c9816f,0x1fcc80ab,0x2b591717}},	//   wend, _राहि, লবাস, nosc_,
   {{0xe91980e8,0xaefb051e,0x61ed0372,0x3be8029a}},	//   лоді_, _dhùt, _jsal, _eşq_,
   {{0xf1bf1984,0x6f02c8a6,0x61ed48a7,0x98a2a482}},	//   irá_, _anoc, _msal, пише,
   {{0xe7398a41,0x2ca7c8a8,0x63be011f,0xf1bf3fe5}},	//   лек_, _rend_, crpn, hrá_,
   {{0x61ed01c2,0x7bc548a9,0x2ca78039,0xf1bf007b}},	//   _osal, muhu, _send_, krá_,
   {{0x612b0065,0x68e3a840,0x7bc50886,0x9c7c8353}},	//   _küld, pend, luhu, veča,
   {{0x6aa98586,0xb8fc80c8,0xf1bf48aa,0x0d829439}},	//   _heef, _তো_, drá_, яльн,
   {{0x61ed48ab,0x2ca7c8ac,0x395848ad,0x661b8859}},	//   _asal, _vend_, vors_, syuk,
   {{0x6f02c8ae,0x61fbc8af,0x7981a676,0x2c4100fc}},	//   _gnoc, _krul, _hilw, _mɗd_,
   {{0x61ed0065,0xd838979d,0x7bc507fe,0x9c7c8024}},	//   _csal, _reči_, huhu, reča,
   {{0x6aa9838e,0x9c7cc8b0,0x7bc513fa,0xfd48819d}},	//   _leef, seča, kuhu, _memọ,
   {{0x9c7c800d,0x7981ab02,0xf1bf1f90,0x7d03c8b1}},	//   lečn, _milw, ará_, _inns,
   {{0xf1bf48b2,0x1e86161a,0xdc3984b7,0x272a801c}},	//   brá_, слам, _aħħa, _vùng_,
   {{0x9c7c803e,0x7ae60214,0xa3ca016f,0x2fdf0162}},	// [3820] nečn, mekt, ळून_, ăuga_,
   {{0x25bf9eb1,0x272a801c,0x23db8ebf,0x69c6005d}},	//   irul_, _tùng_, _बहाद, muke,
   {{0x69c622b3,0x6aa9c8b3,0x25bf836e,0x61fbc8b4}},	//   luke, _beef, hrul_, _arul,
   {{0x61fbc8b5,0xaefb0a2a,0x78a89be9,0x6b5d1a1f}},	//   _brul, _dhùs, _sedv, légr,
   {{0x9c7c94ce,0x28c9ae06,0x3ea048b6,0x7ae6011e}},	//   ječn, _राशि, mbit_, iekt,
   {{0x25bf8abf,0x28db000c,0x9c7c816b,0x6d5c1d56}},	//   drul_, म्पि, dečn, _ukra,
   {{0xdfd080f7,0x93bc8087,0x64a302ac,0x6ab780ab}},	//   ذية_, nzăt, _хаса, _ইউরো,
   {{0x6aa98a0f,0x6d8908ae,0xa3ab8fea,0x7d03998d}},	//   _geef, _džaf, गठन_, _anns,
   {{0xc6f791e9,0xa63b00be,0xa91d812b,0x79819acf}},	//   сных_, ָגיר, _mužj, _filw,
   {{0xb606812b,0x73d8b09d,0xdce38084,0x69c648b7}},	//   vršć, адор_, _minė, duke,
   {{0x7ae63f82,0x628581d0,0x3ea00ec9,0x3ead82c4}},	//   fekt, ěhov, kbit_, baet_,
   {{0x09bf00ab,0x3f8200d7,0x8e8681a8,0x25bfc8b8}},	//   েবসা, _niku_, _الإه, brul_,
   {{0xc3338051,0x25bf8162,0x9418011c,0xd75781a8}},	//   פוש_, crul_, _verə_, _النت_,
   {{0xa2d901fe,0xecc7009a,0x3f820032,0xdcfc0b67}},	//   _फॉर्, _लाइफ, _aiku_, _birč,
   {{0x0d3b804c,0x7d1509a4,0x77640118,0xd6db19ab}},	//   _תגוב, _rozs, flix, лта_,
   {{0xf7700250,0x61ed00a4,0x7ae60214,0x3f8200b9}},	//   فاق_, _tsal, cekt, _ciku_,
   {{0xe66711c7,0xb505000f,0x61ed48b9,0x9c8700f7}},	// [3830] ство, रालय_, _usal, مشاه,
   {{0x7bc5022e,0x6d48a3aa,0x25e08006,0xdcfc01a1}},	//   tuhu, nnda, _कहनी_, _firč,
   {{0x25bf80ee,0xaefb0229,0x6d48c8ba,0xadea86ae}},	//   zrul_, _dhùr, inda, _जैसन_,
   {{0x61fb8bfd,0x6d5ac8bb,0x7bc548bc,0x7981c8bd}},	//   _prul, hota, ruhu, _silw,
   {{0x6d5ac8be,0xd838b4c1,0x7bc51e8f,0x2179c3e1}},	//   kota, _meču_, suhu, айды_,
   {{0x2d990364,0x68e70067,0x92e500c8,0x65940a42}},	//   _itse_, nejd, নায়_, _хару,
   {{0x7ae648bf,0xb9260135,0x6d5ac8c0,0xdfce80f7}},	//   yekt, _agwọ_, dota, نيو_,
   {{0xf3898104,0x6d48c8c1,0xef19a14d,0x9c7c800d}},	//   _bản_, enda, рми_, tečn,
   {{0x6b8a8352,0x2d8b04a8,0x6d48807b,0xf38980ff}},	//   _aufg, _juce_, fnda, _cản_,
   {{0x6d5ac8c2,0x9c7ca19f,0x45198997,0xc58880ff}},	//   gota, rečn, рция_, _tồn_,
   {{0x5fdd91be,0x9c7c84c4,0x637180f2,0x2d8b48c3}},	//   _महिल, sečn, gång, _luce_,
   {{0x6d48c8c4,0x2fc78077,0x69c612a5,0x2d9902f1}},	//   anda, mung_, tuke, _otse_,
   {{0x6d5ac8c5,0x2fc7c8c6,0x2d990069,0x6b5d02be}},	//   bota, lung_, _ntse_, tégr,
   {{0x2d83003a,0xe7dd81ab,0x3f8200f6,0xf99284de}},	//   _nije_, _महाप, _siku_, ורך_,
   {{0x2fc7c8c7,0x3cee835a,0x332948c8,0x3f82026c}},	//   nung_, _असते_, _flax_, _piku_,
   {{0x7f49c73a,0xf389801c,0x6d4b2d5d,0x28db04c5}},	//   nneq, _hảo_, égan, म्बि,
   {{0x68e70022,0xf09f8104,0x2fc7c8c9,0xe7e9800f}},	// [3840] bejd, _đàn_, hung_, झौता_,
   {{0x2fc78854,0x61e48059,0x2d8b202a,0xf53f0106}},	//   kung_, çilm, _duce_, _svår_,
   {{0x98788038,0x2fc7a08b,0x13ea0087,0x2d8348ca}},	//   _páči_, jung_, рмей_, _dije_,
   {{0x672d48cb,0xe1fa9634,0xc7b3007c,0x6d5ac8cc}},	//   chaj, иге_, _קבר_, zota,
   {{0xe8949a8f,0x6d488125,0x2b4d826c,0x6f0614a2}},	//   паль, ynda, _djec_, _inkc,
   {{0x6b8432f4,0xf8aa0105,0x2fc781ec,0x2d830176}},	//   _liig, करिय, fung_, _gije_,
   {{0xb8f2aa18,0xf3898104,0x6d5ac8cd,0xf72a80d6}},	//   _वा_, _sản_, vota, иций_,
   {{0x68e7009a,0x672448ce,0x4b34803d,0x6d5ac8cf}},	//   zejd, nkij, _عکاس, wota,
   {{0xf3898104,0xf7730039,0x6d5ac8d0,0x1ee8803d}},	//   _bảo_, וקה_, tota, لوژی_,
   {{0x61300004,0x6d48c8d1,0xd83881a1,0x23668168}},	//   _hälf, unda, _seču_, lloj_,
   {{0x6d5a92bf,0x672448d2,0x6d48c8d3,0xd7ef80f7}},	//   rota, kkij, rnda, _لكل_,
   {{0x51871454,0x78ba9c33,0x6d5ac8d4,0x67242948}},	//   жува, _hdtv, sota, jkij,
   {{0x6d5ac8d5,0x3f8c84b9,0x9f4c80f7,0xb5fb046d}},	//   pota, _hudu_, _ordú_, _ayán,
   {{0x3f8cc8d6,0x6d5a8079,0x0e8e819d,0x2d8b01d0}},	//   _kudu_, qota, _gịrị_, _ruce_,
   {{0x28d28076,0x69c2c8d7,0x637192f1,0x29050850}},	//   _सानि, hroe, låne, ıla_,
   {{0x6d4e026c,0x7d18c8d8,0x2bc9016f,0x2d8348d9}},	//   _ajba, _hovs, ांसा, _sije_,
   {{0x672d48da,0x7bc8973c,0x2fc781ec,0x80cd8035}},	// [3850] rhaj, ludu, zung_, सलमे,
   {{0x672d022e,0x2d8b02a5,0xf09f8028,0x850512c6}},	//   shaj, _vuce_, _đào_, राइट_,
   {{0x80c48778,0x3eb98110,0x2d8b00a4,0xd25100d7}},	//   _राजे, ųsti_, _wuce_, _زنگ_,
   {{0x7d18c8db,0xdceb9dd7,0xa4a5826b,0x6724026c}},	//   _lovs, _čiči, _afọ̀, ckij,
   {{0x69c280c9,0x2fc7c8dc,0x7bc880b8,0x2b4d8168}},	//   groe, wung_, hudu, _vjec_,
   {{0x2fc7c8dd,0x3f8ca771,0xa91db5ca,0x7d18976d}},	//   tung_, _budu_, _kuži, _novs,
   {{0x6371816d,0xe8d900ff,0x2fc781ec,0xa91d80c3}},	//   tånd, _quỹ_, uung_, _juži,
   {{0x2fc7c8de,0x7bc8c8df,0x3f8ca0d2,0xc61200ab}},	//   rung_, dudu, _dudu_, _সেটা_,
   {{0x2fc7c8e0,0x6b840006,0x2d9980f1,0x3d000072}},	//   sung_, _riig, ëse_, राचे_,
   {{0x2fc78886,0xee368084,0xc588801c,0x799bc8e1}},	//   pung_, яны_, _gồm_, _ituw,
   {{0x3f8c8041,0x798d0c53,0x7bc8c8e2,0x46cb001b}},	//   _gudu_, _auaw, gudu, िलाह,
   {{0x09e6091d,0x26dd8578,0x1becbed8,0x612f805f}},	//   помн, _ubwo_, _जनरल_, _bølg,
   {{0xb0d2b852,0x6d890038,0xa2d394d5,0x6ed091be}},	//   _सामग, _zľav, _डान्, _धातु,
   {{0x867a8051,0xfe708077,0xa91d856f,0x14c7016f}},	//   _פרסו, _شدن_, _buži, _लागण,
   {{0xab99987e,0x672448e3,0x7bc881cc,0xed5981a1}},	//   _اختر_, tkij, cudu, juži_,
   {{0x6d41c8e4,0x612f86be,0xa91d8025,0x753c0668}},	//   lila, _følg, _duži, _smrz,
   {{0x672448e5,0x9c7c911b,0x5bdb9a46,0x6443008b}},	// [3860] rkij, ječj, _बहुव, únin,
   {{0x6d41bb84,0x61e404be,0x6abbc7fe,0x4d630073}},	//   nila, _ipil, _aduf, екув,
   {{0x711b0158,0xa7fc8059,0x3d0c86a7,0x28d283a4}},	//   _הויפ, _ayın, ़ाते_, _साबि,
   {{0x6d41c518,0x6d890253,0xeb9680be,0x61e400b9}},	//   hila, _džab, לדער_, _kpil,
   {{0x291a48e6,0x6d419dde,0x61300106,0xc33301c6}},	//   _kopa_, kila, _välf, עוד_,
   {{0x25a0445d,0x612b0006,0x291a0009,0x27fe80b9}},	//   mpil_, _küla, _jopa_, _prtn_,
   {{0xc44809d7,0xfaa692a0,0x3d090075,0xd7fa802e}},	//   _بیان_, _наво, सारे_, сул_,
   {{0xf3898104,0x96eac7a8,0x69c286a8,0x61300106}},	//   _cảm_, ська_, proe, _fälg,
   {{0x7d18a7aa,0x4ac60072,0x3f8cc8e7,0x6f19c8e8}},	//   _povs, _वाजव, _wudu_, _dowc,
   {{0x6aad3e5b,0x7bc88886,0x3f8c89ab,0x63bc84e8}},	//   _seaf, tudu, _tudu_, árno,
   {{0x1e869519,0x6db5817b,0x61e448e9,0xd12f8872}},	//   _елем, _aşağ, _apil, _حمل_,
   {{0xa91dc8ea,0x9c7c81d0,0x212c8362,0x61e40f35}},	//   _ruži, lečk, _hldh_, _bpil,
   {{0x637f00eb,0xc3338039,0xa91d8110,0xd7098054}},	//   _jūni, תור_, _suži, वारथ_,
   {{0x6b9c00d2,0x6d5e012b,0xa91d80c3,0x256f02f1}},	//   _otrg, jopa, _puži, küla_,
   {{0x6d5e2a0b,0xd1488028,0xf99f06c0,0xaac6016f}},	//   dopa, yễn_, spè_, _वाचक,
   {{0x8f9b810f,0xf09f80ff,0x798d05ee,0x6491007a}},	//   מילי, _đàm_, _tuaw, zžič,
   {{0xbf1d053e,0x78838019,0x9f5e8168,0x320002d6}},	// [3870] _नवीन_, _kívü, _artë_, _griy_,
   {{0xf9940451,0xa91d803b,0x9c7cc8eb,0x612f806a}},	//   _ארץ_, _tuži, ječk, _køle,
   {{0x442748ec,0x25a00420,0x799b8cab,0xa02206ae}},	//   án_, apil_, _stuw, ööta,
   {{0x394300eb,0xaabf0f0a,0x99990035,0xceeb01f9}},	//   lijs_, ्लिक, mysł_, _اردن_,
   {{0x6d41c8ed,0x6d5e48ee,0xa2c006f0,0x442100b9}},	//   yila, bopa, _वयस्, syh_,
   {{0x6d41c8ef,0x5d8500d5,0x394300eb,0x61300f02}},	//   xila, _زلزل, nijs_, _välg,
   {{0x81e300ab,0x213e8168,0x6e2002f1,0xe7398b7d}},	//   নটি_, _dmth_, _ümbr, жей_,
   {{0x6604c8f0,0x28d281a2,0x6fcf816f,0x6d41c8f1}},	//   _šika, _साथि, संबं, wila,
   {{0x2731c8f2,0x3f868176,0x80ce064a,0x0609804a}},	//   _láng_, _diou_, _ताले, інок_,
   {{0x7af60201,0x7aeb81ec,0x69cb8f8e,0x81e30264}},	//   _sayt, legt, muge, নটা_,
   {{0x61e4320d,0x291a00ab,0x7af648f3,0xa3a8816f}},	//   _spil, _ropa_, _payt, खील_,
   {{0x7af6011c,0x291a47b7,0xf1d18aad,0x2d8b85e4}},	//   _qayt, _sopa_, _समान, íces_,
   {{0x6d41c8f4,0xdb1b0364,0x69d9a41b,0x69cb9eb1}},	//   pila, yttö, ntwe, nuge,
   {{0x61e488c5,0x612f8b40,0xafe61bb1,0x6d418438}},	//   çili, _føle, могл, qila,
   {{0xb8f6053e,0xe0d200d7,0x67030133,0x2d8f81c6}},	//   _हा_, _یزد_, _ọkai, _huge_,
   {{0xa91d8503,0x2731801c,0xf4128039,0xdbc60074}},	//   _gužv, _dáng_, _יפו_, _köög,
   {{0xb5fb0019,0x2d8f8036,0x6db5811c,0x0d860071}},	// [3880] _szár, _juge_, _uşağ, длан,
   {{0x3eafc8f5,0xc8ca003d,0x28d286ab,0x4176003d}},	//   _legt_, _بودن_, _साधि, _تابس,
   {{0x6d5e48f6,0x613004b8,0x5fe2364b,0x9c7cac90}},	//   ropa, _väld, _पहिल, večk,
   {{0x69d99fba,0xfbc58beb,0x2bc5861e,0x4a46c8f7}},	//   ftwe, _विनम, _विना, мнев,
   {{0xceb31def,0x63760c58,0x3cee816f,0x6d5e48f8}},	//   _שיש_, mánd, _असले_, popa,
   {{0x332d86cb,0xfbc61fb4,0xcf9a84ae,0x7bc30144}},	//   _elex_, _обго, оји_, ánuc,
   {{0x399404b8,0x9c7c826f,0x3d119862,0x2d8f91e6}},	//   _läs_, rečk, ताने_, _auge_,
   {{0xc5888028,0x63760511,0x2d8f89ab,0x2d8792a5}},	//   _hồi_, nánd, _buge_, _aine_,
   {{0x2d878012,0x6e24018c,0xc62000ab,0x9c7cc877}},	//   _bine_, nyib, _নেতা_, meči,
   {{0x2d87c8f9,0x9c7c8353,0x2d8f805c,0x2b40009f}},	//   _cine_, leči, _duge_, _amic_,
   {{0x2d8786be,0x69c048fa,0xa3a88006,0xd6cfb6fc}},	//   _dine_, ámen, खीं_, _ит_,
   {{0x2d878943,0x3d050063,0x7d1c02be,0x80da8aed}},	//   _eine_, _होने_, _lors, प्रे,
   {{0x2d878653,0x27318028,0x7d1c00c9,0x660f816d}},	//   _fine_, _sáng_, _oors, äckt,
   {{0x7d1c0cde,0x3eaf8a0f,0x6602c8fb,0x2d8784b9}},	//   _nors, _zegt_, _irok, _gine_,
   {{0x394348fc,0xc58880ff,0x69cb81ec,0xdfd80081}},	//   rijs_, _nồi_, zuge, мът_,
   {{0x9c7c82fd,0x63760511,0x15f282f1,0x2d87c8fd}},	//   ječi, gánd, _अनार_, _zine_,
   {{0x171b8158,0x2d878214,0xe784323a,0xbf1f0105}},	// [3890] קומע, _yine_, туро, _यकीन_,
   {{0x7d1c1137,0x2bc58c46,0xad9b0118,0xc58880ff}},	//   _cors, _विमा, _crúa, _bồi_,
   {{0xe3b89014,0xe1ff0216,0x6376016a,0x7c2d8041}},	//   nsı_, lvó_, bánd, _ƙari,
   {{0x32559baa,0x637605e4,0x0f2700e8,0x66028102}},	//   нвер, cánd, _цьом, _orok,
   {{0x7d1c15f8,0x2bc58dbc,0x7aebc8fe,0xdddd009a}},	//   _fors, _विभा, regt, _wysł,
   {{0x69cbc8ff,0x7d1c4900,0x70c9835a,0x69d98a10}},	//   ruge, _gors, रलेल, rtwe,
   {{0x6d45009c,0x6602c901,0x3d0506a7,0x69cbc902}},	//   miha, _arok, _होये_, suge,
   {{0x6d45028a,0xf7718829,0x2d87c903,0x69c60f06}},	//   liha, دات_, _sine_, yrke,
   {{0x2a6901c5,0x78b508ae,0xf1a78a4c,0x79888372}},	//   _nyab_, kazv, _іран, _fidw,
   {{0x6f1d4904,0x6e9f864a,0x28df0540,0x6d454905}},	//   _losc, _ग्रु, _पॉलि, niha,
   {{0x2d87c906,0x934601bb,0x6b898019,0x69b20074}},	//   _vine_, енне, _kieg, _अबही,
   {{0x65959a12,0x6602805f,0xdd958190,0x637603a8}},	//   _заду, _frok, _зады, xánd,
   {{0xed4ec907,0x6b89c908,0x2d87c909,0x6d45490a}},	//   _бо_, _mieg, _tine_, kiha,
   {{0x6b89c90b,0x412a00e8,0x2bd003eb,0x2eed874c}},	//   _lieg, чого_, _हमला, leef_,
   {{0xdee62344,0x637602ba,0xd466c90c,0xd007490d}},	//   нови, tánd, _пише_, нере_,
   {{0xc5888104,0x6729c90e,0x6f1d490f,0x6b89c910}},	//   _rồi_, nkej, _cosc, _nieg,
   {{0xee3a1506,0xdcf40024,0x7ae40a6d,0x6d4504be}},	// [38a0] чна_, šačk, _ibit, fiha,
   {{0x7d1c0079,0xa91d826f,0x63760511,0x98a78110}},	//   _qors, _mužs, sánd, minė_,
   {{0x7d1c0352,0x20c9853f,0x6f1d4911,0x798880dd}},	//   _vors, _राजध, _fosc, _ridw,
   {{0x28d28f85,0xeb92893f,0x6b89c912,0x7f440079}},	//   _साहि, אָס_, _cieg, qiiq,
   {{0x7d1c2280,0x6b89a4b5,0x63762511,0xf38a001c}},	//   _tors, _dieg, cáne, _cải_,
   {{0x6604816b,0x41d1864a,0x4425c913,0xf38a0129}},	//   _šiko, _समरस, kyl_, _dải_,
   {{0x50b78013,0xfc1a20bb,0x2d998118,0x7ae444dc}},	//   ردود_, _عقرب_, ísen_, _obit,
   {{0x26d2033e,0x20d29199,0x3d0e01ab,0x28d2861e}},	//   ngyo_, _सावध, ठावे_, _सावि,
   {{0xdb022739,0x020680e8,0x2d8a166a,0x657e0866}},	//   mplè, _язан, _kibe_, omph,
   {{0x44258c0b,0x7ae44914,0xe7b10035,0x645d8085}},	//   fyl_, _abit, _जबलप, əsiz,
   {{0x290c83c3,0xd5c28f12,0x61f604fe,0x63ae008e}},	//   _inda_, _शिवज, _asyl, _jwbn,
   {{0x291ec915,0xb605826c,0xf09f801c,0xbacf00ab}},	//   _hota_, _bošč, _đài_, িজ্ঞ,
   {{0x291e8500,0xe5a387b6,0x6d4501d4,0x8c2400ab}},	//   _kota_, _бичи, yiha, _যেমন_,
   {{0x656180a9,0x2d8a3129,0x7ae402ec,0x291ec916}},	//   colh, _nibe_, _ebit, _jota_,
   {{0xb4be8576,0xf2b000ab,0x291ec917,0x6f1d00e1}},	//   ेली_, _কারণ, _mota_, _posc,
   {{0x63763930,0x628d0b67,0x6d451f78,0x63788118}},	//   táne, _ugao, wiha, nínd,
   {{0x290c803a,0x6d453f12,0x273500f2,0x6b89816a}},	// [38b0] _onda_, tiha, _lång_, _rieg,
   {{0x7afd200b,0x637604e8,0x7aef4918,0x6b89c919}},	//   ldst, ráne, lect, _sieg,
   {{0x98c4025d,0x6d4542f3,0x6b89c91a,0x63baad03}},	//   _ссыл, riha, _pieg, nstn,
   {{0x290c8852,0x6d450859,0x6b8981b9,0xe8d90129}},	//   _anda_, siha, _qieg, _tuỳ_,
   {{0x69dd491b,0x7aef0012,0x291ec91c,0x6b8980eb}},	//   ntse, iect, _bota_, _vieg,
   {{0xa069bc7a,0xe61f001c,0x290c808e,0xf38a00ff}},	//   мала_, _ngôi_, _cnda_, _vải_,
   {{0x6b89af1e,0x2bc586a7,0x629687d9,0x63ba875f}},	//   _tieg, _विधा, ıyor, jstn,
   {{0x3d05491d,0x290cc91e,0xf38a0028,0x06098a13}},	//   _होते_, _enda_, _tải_, дник_,
   {{0xb4be800f,0x67298057,0x69dd491f,0xceb403c8}},	//   ेलू_, rkej, jtse, ניץ_,
   {{0x7afbc920,0x69db913b,0x3f8b005c,0xdb024921}},	//   _haut, _ique, _licu_, mplé,
   {{0x273500f2,0x7aef0806,0x7afbc922,0x7afd00f3}},	//   _gång_, fect, _kaut, fdst,
   {{0x7afbb761,0x3947c923,0x98a781e2,0x3dc900ee}},	//   _jaut, lins_, tinė_, kraw_,
   {{0x7afbc924,0x69cf017f,0x2f188061,0x656182df}},	//   _maut, guce, _négy_, polh,
   {{0x6606813c,0x3dc94925,0x7afbc926,0x39479e9e}},	//   ække, draw_, _laut, nins_,
   {{0xa0672410,0x69dd0613,0x186705da,0x6378c927}},	//   вара_, atse, вари_, líne,
   {{0xed59803b,0xc6c31056,0xcf9280be,0x69cf4928}},	//   drži_, ийск, שטן_, buce,
   {{0x3dc93a65,0x2d8a4929,0x1e86373a,0x3f8b2433}},	// [38c0] graw_, _pibe_, тлам, _dicu_,
   {{0x61ed81b9,0x3947c92a,0xad9b492b,0x657e4754}},	//   ħall, jins_, _trún, umph,
   {{0x69db938d,0x7afbc92c,0xf1bf25b3,0x3ea9492d}},	//   _aque, _baut, nyán_, bbat_,
   {{0x291e809f,0x776d01df,0x7afbb499,0xf1bf0144}},	//   _sota_, clax, _caut, iyán_,
   {{0x7fe203a4,0x291ec92e,0x2b4681a8,0x8c9605a8}},	//   _पहुँ, _pota_, rioc_, _арбі,
   {{0xdca3345a,0x64a30f04,0xb5fb0032,0x7afb89c4}},	//   _вари, _вара, _ayáw, _eaut,
   {{0x15432f84,0x7aef1220,0x291ead77,0x7afb80e7}},	//   _терм, yect, _vota_, _faut,
   {{0x7aef492f,0x7afbc930,0x8a06813a,0x394783ac}},	//   xect, _gaut, _избе, ains_,
   {{0x291ebb67,0xae0503b7,0xe0da8fbb,0x7aef01e0}},	//   _tota_, रियन_, _ова_, vect,
   {{0x2176975e,0xb4be8f85,0x69cf02a5,0x39478cf8}},	//   _рубр, ेले_, vuce, cins_,
   {{0x7aef4918,0x3cfa009a,0x2005abea,0x33200980}},	//   tect, _उसने_, _grli_, _boix_,
   {{0x69cf00e7,0x63bac931,0x65c681e5,0x46a68081}},	//   tuce, rstn, _абда, _радв,
   {{0x7aef0918,0x61e980b9,0x6130039c,0x9c7c82d4}},	//   rect, _xpel, _säla, veču,
   {{0x69dd05e1,0x273513c2,0xdc558061,0x7bde1db4}},	//   rtse, _måne_, ئریک, ktpu,
   {{0x6d488c52,0x5ea400ab,0x7aef0cf7,0x69dd4932}},	//   mida, _ওয়ে, pect, stse,
   {{0x6d4887a3,0x3ea907d5,0x6376001b,0x3947c933}},	//   lida, ubat_, ránc, zins_,
   {{0xb0d29cd4,0x3ea9223e,0x7afbc934,0x3f930079}},	// [38d0] _सांग, rbat_, _raut, _wuxu_,
   {{0x6d489313,0x3947a2dd,0x7afbc935,0x637638e1}},	//   nida, xins_, _saut, mána,
   {{0x61e9ab61,0x7afbaf40,0x63764936,0xc3160264}},	//   _spel, _paut, lána, াসরি_,
   {{0xfaff00f1,0x6d48c937,0xe3b000f7,0xc2c480f7}},	//   ndë_, hida, ترك_, ليمي,
   {{0x3947c938,0xa2d601fe,0x6b8d0bb1,0xe9df4939}},	//   tins_, _भास्, _miag, ntú_,
   {{0xf1d58a61,0x30758009,0x7afbc93a,0xa805002a}},	//   डंबन, луйс, _waut, coñé,
   {{0x7afbc93b,0x3947c93c,0xf7458fc8,0xdcfc1f3a}},	//   _taut, rins_, леко, _sirć,
   {{0x3947c93d,0x6b8d1083,0xdb0200e7,0xe1f3803d}},	//   sins_, _niag, pplé, _پسر_,
   {{0x6d48b546,0x90e78eca,0x2121008e,0xa1948323}},	//   fida, _لسان, _oohh_, _вауч,
   {{0xee36979e,0x5ba980e2,0x6376493e,0xdb1c8176}},	//   унь_, нком_, dána, _avrè,
   {{0x6b951e4f,0x6b8d493f,0x672d4940,0x20058037}},	//   _juzg, _biag, kkaj, _urli_,
   {{0x257982be,0x6b954941,0x11d6102a,0x672d0115}},	//   dèle_, _muzg, лігр, jkaj,
   {{0xfce5818b,0x2bc58a3a,0xaad1800f,0x9f5e3649}},	//   _боло, _विवा, _हाईक, ítí_,
   {{0x6d488510,0x6f1b8052,0xb602801b,0x399993f8}},	//   cida, ljuc, čátk, _mès_,
   {{0x74d89008,0x3999c942,0x3d1706af,0x69cb8192}},	//   _मातृ, _lès_, नाने_, hrge,
   {{0x3d118e18,0x6d890fda,0x69c4800f,0x6b8d0bb1}},	//   तावे_, _džam, _रिली, _giag,
   {{0xa3b603b7,0x6e298393,0xc69280be,0x80b300ab}},	// [38e0] चीन_, nyeb, מאן_, _জার্,
   {{0xdff38935,0xc8d28670,0xfd9e8135,0xe6d0928a}},	//   _आनंद_, _साइट, _jụọ_, _सञ्ज,
   {{0xa3bb80dc,0x6ab60059,0x6f1b817f,0xfd9e8135}},	//   ेंट_, _keyf, kjuc, _mụọ_,
   {{0x2ca70a0b,0x6d48c943,0xe73a0364,0xe29aa63e}},	//   ında_, zida, _чем_, хад_,
   {{0x82d70158,0xb17b0bfa,0x59f8c944,0x6d48c945}},	//   רונג_, ståe, теля_, yida,
   {{0x399982be,0x6ab6007b,0x660400b4,0x7ae2a0d1}},	//   _dès_, _leyf, mvik, sfot,
   {{0xe3a7896c,0x6d489313,0xd90d8bca,0x6604075e}},	//   _در_, vida, ظیم_, lvik,
   {{0xb8cb809a,0x3999c946,0xcfe780f7,0x2cba0122}},	//   _क्_, _fès_, افيه_, lapd_,
   {{0x10a68d31,0x66043f1e,0x6b8d0014,0xa534af75}},	//   _бизн, nvik, _riag, инич,
   {{0x46a483dd,0x6b8d3d34,0x23692009,0x2bc58c2d}},	//   _ग्रह, _siag, _skaj_, _विशा,
   {{0x2056a569,0x6d488511,0x40938307,0xd6c491fb}},	//   _стар, rida, _المر, _نمای,
   {{0x6d48c947,0x80d70b86,0x2bc581a2,0x27ec82f7}},	//   sida, _बाहे, _विरा, _ipdn_,
   {{0x7c3a8065,0x6d48c948,0xfe728065,0x96b985e9}},	//   sztr, pida, _ادا_, _руху_,
   {{0x98a78024,0x660414a2,0x6376066e,0x68fe0722}},	//   čići_, dvik, rána, _capd,
   {{0x629d0117,0xb8fd0bb8,0x09d18b84,0x67228282}},	//   pcso, _डा_, _सम्य, _kooj,
   {{0x67228079,0x613016d2,0x637d09c4,0x96f820bf}},	//   _jooj, _häll, déng, лест_,
   {{0x6b82811f,0x613000f2,0x799600fc,0x672d4949}},	// [38f0] dmog, _käll, _guyw, rkaj,
   {{0x672d494a,0x627c0051,0x61300406,0x45d40470}},	//   skaj, _אנחנ, _jäll, софс,
   {{0xa9260029,0x5b27814c,0x53a400f7,0xbc070110}},	//   _dažā, льда, مملك, ычай,
   {{0x2d8ec94b,0x637887e0,0x61ed01bc,0xade58074}},	//   _life_, vínc, _kpal, _कहलन_,
   {{0x99d78013,0xd5af0117,0x6d4b01df,0x7aff02a6}},	//   اتصا, _رہا_, égas, _maqt,
   {{0x2cf3835a,0x34941b53,0xa4f3816f,0x637d0333}},	//   _असेल_, _гарр, _असेच_, lénd,
   {{0xad9b10ab,0x60de86c0,0xfd9e8870,0x25a902c4}},	//   _orúk, òpma, _rụọ_, lpal_,
   {{0x6d588699,0x637d157a,0xcf2581a8,0x260906af}},	//   _ajva, nénd, شرعي, सिपी_,
   {{0xed5998a0,0xef1684d9,0x3d11801b,0xfd9e8133}},	//   кои_, рмы_, ताले_, _pụọ_,
   {{0x61fb9efa,0xd1678098,0xed4580e8,0x63789e1c}},	//   _isul, _съби, рноп, mína,
   {{0x768b8201,0x61ed494c,0xf77081f9,0xad9b1434}},	//   _böyü, _apal, _کال_, _brúk,
   {{0xe2860139,0x60c501a8,0x6b6607b6,0x273b846d}},	//   илни, _adhm, ркма, _dànù_,
   {{0x7ae98f5d,0x61300b2f,0x998081ac,0x7bc3367e}},	//   _mbet, _fäll, šiť_, ánuj,
   {{0x613004b8,0xdca59317,0x25bf89ca,0x64a59269}},	//   _gäll, _таки, msul_, _така,
   {{0xa06a05d3,0x80d7090f,0x186a0767,0x7ae9b78d}},	//   тава_, _बारे, тави_, _obet,
   {{0xb6a602bc,0x660400e8,0x7d1cc56f,0x637629f4}},	//   риал, tvik, örsv, máno,
   {{0x7dc60077,0x25bf802e,0x63760019,0x66030012}},	// [3900] شقان, nsul_, láno, опта,
   {{0x3f8f8503,0x66043568,0x3ead8214,0x127b00be}},	//   _ligu_, rvik, hbet_, _באפע,
   {{0xc5f2c94d,0x3cdd8996,0xf5368158,0x6604494e}},	//   _अन्य_, _खाने_, סטער_, svik,
   {{0x25bf8074,0x637d4089,0x78bc494f,0x79a68425}},	//   ksul_, cénd, larv, арке,
   {{0x6b82ac00,0x6722c950,0x63a94951,0x23bc0032}},	//   rmog, _rooj, _čene, _bájá_,
   {{0x637d3b40,0x67228074,0x78bc1bd0,0x31678267}},	//   méne, _sooj, narv, gonz_,
   {{0xd7fa8c6e,0x61fbc952,0x3f8f8326,0x02b60072}},	//   тул_, _esul, _bigu_, _अजून,
   {{0x3ea04953,0x6130016d,0xab278323,0x61348362}},	//   ncit_, _säll, _коса_, _dàla,
   {{0xb5fb0019,0x66e286ce,0x3f8f811b,0x3dcd8176}},	//   _száz, क्षक_, _digu_, grew_,
   {{0x96a68540,0xdce182d4,0x61e2c954,0x612b4955}},	//   _ट्रॉ, bolč, mtol, _tüli,
   {{0x61ed4956,0xa41480c8,0x3ead8ecb,0x6d890267}},	//   _spal, ান্য_, bbet_, _džah,
   {{0x61ed162a,0x27f80114,0x61e28c53,0x3dc002d5}},	//   _ppal, dwrn_, otol, ksiw_,
   {{0x61e2c957,0x61300364,0x9da78098,0x2d968e0b}},	//   ntol, _täll, _къща_, _трес,
   {{0x7523c958,0x7aff0079,0x2703001c,0x3cdd83db}},	//   _gonz, _waqt, _ổn_, _खाये_,
   {{0x637d01df,0xd6db10f8,0xb5fb0019,0xd48f9cff}},	//   ténd, кта_, _nyár, _фр_,
   {{0x75238144,0x6130156e,0x6568c959,0x3f8f008b}},	//   _zonz, _jälj, lodh, ögu_,
   {{0xdb02016d,0x442c955c,0x637d495a,0x78bc3c49}},	// [3910] tslö, lyd_, rénd, barv,
   {{0x25a9036e,0x78bc495b,0x929d8035,0xb912819d}},	//   rpal_, carv, _małe, renụ_,
   {{0x443ec95c,0x49140054,0xdb020338,0x656f8866}},	//   nzt_, दारो_, rslö, îchi,
   {{0x2731826f,0x63760019,0x69ce001b,0x25a90061}},	//   _ráno_, jánl, _तिमी, ppal_,
   {{0x877a004c,0x290102e7,0x10a58abe,0xfaff0168}},	//   _תארי, _kaha_, билн, llës_,
   {{0x63a4803e,0x2903495d,0xb34784b7,0x3eb90aa2}},	//   _činn, ndja_, _saħħ, _hest_,
   {{0x2901363c,0xb5fb0019,0x01380039,0x2d990c86}},	//   _maha_, _gyár, שרות_, _huse_,
   {{0x3eb90610,0x81e680c8,0x6378826f,0x25a680ee}},	//   _jest_, _বছর_, pína, _btol_,
   {{0xf2d28159,0x6e2d495e,0x3eb9120b,0x61fb8573}},	//   _מען_, nyab, _mest_, _usul,
   {{0xf9908872,0x442c8355,0x68f5495f,0x25bf802e}},	//   _قبل_, fyd_, jezd, rsul_,
   {{0x442cc960,0x237f81c0,0x3cfa009a,0x2d914961}},	//   gyd_, _khuj_, _उससे_, _mize_,
   {{0xe6958013,0x25bf94e4,0x637601ac,0x05c70072}},	//   _الإد, psul_, ráno, _लिंब,
   {{0x8e8580f7,0x78bc3ae2,0x29014962,0x6568c963}},	//   _الشه, tarv, _baha_, bodh,
   {{0x7d1c80f2,0x753ac964,0xa0a30081,0x637629f4}},	//   örst, chtz, зард, páno,
   {{0x29010b06,0x3eb94965,0xd9430e8e,0x236dc966}},	//   _daha_, _best_, чери, _okej_,
   {{0xdd9200f7,0x637d0061,0xdceb8372,0x78bc2818}},	//   كور_, téne, _bugħ, sarv,
   {{0x61300364,0x3bc38201,0x2d910c12,0x29010362}},	// [3920] _jälk, lıq_, _bize_, _faha_,
   {{0x3eb90006,0x3ea04967,0x2d9101d6,0x29010db1}},	//   _eest_, scit_, _cize_, _gaha_,
   {{0x41760986,0xdd8f0b76,0x3eb94968,0x69c401ac}},	//   _پاکس, روم_, _fest_, _hvie,
   {{0x2cb84969,0x61e2a1da,0x69c40110,0x2ca10046}},	//   _werd_, ttol, _kvie, achd_,
   {{0x237f81c0,0x2d9102d6,0x6130062c,0x7c3e0061}},	//   _dhuj_, _fize_, _nälk, szpr,
   {{0x613004b8,0x6f041df5,0x7bc1c96a,0xada3259a}},	//   _sälj, ldic, kslu, _харл,
   {{0xb9008d38,0x61e2c96b,0x443e2e80,0xa7fc880a}},	//   _था_, stol, _åt_, _ayır,
   {{0x6f040c6b,0x29033610,0x6378816b,0x3f84808e}},	//   ndic, zdja_, míno, ummu_,
   {{0x6130496c,0x442c8355,0x612b13f4,0xa80583a8}},	//   _välj, wyd_, _kült, _poñí,
   {{0x443e834a,0x442c879f,0x69cf0699,0xccfa8eef}},	//   tzt_, tyd_, vrce, ући_,
   {{0x2901496d,0x68f51024,0x351b00be,0x78ba80eb}},	//   _raha_, vezd, אוינ, _ietv,
   {{0x2901003d,0x442cc96e,0x443e81ec,0x6aa2b648}},	//   _saha_, ryd_, rzt_, ncof,
   {{0x667692dc,0x443eb1d6,0x4f6580f7,0x69cf496f}},	//   _ادار, szt_, _بالف, urce,
   {{0x3eb90006,0x69c42d45,0x70d3016f,0x2d9912ec}},	//   _sest_, _dvie, तलेल, _ruse_,
   {{0x40342357,0x3cddc970,0xdbf1001b,0x29034971}},	//   перс, _खाते_, _příj, rdja_,
   {{0x2d914972,0x6e2d4973,0x2d994974,0x6d5c4975}},	//   _size_, tyab, _puse_, _ajra,
   {{0x29010074,0x3eb94976,0x69c005e4,0x7aed4977}},	// [3930] _taha_, _vest_, ámet, _ibat,
   {{0x78bac978,0xdb1b00f7,0x6f028834,0x3eb90039}},	//   _netv, istí, _laoc, _west_,
   {{0x6e95153d,0x69c41a2f,0x6e2d0359,0x3eb94979}},	//   _мину, _zvie, syab, _test_,
   {{0x6f02817f,0x2d91018f,0x98a78110,0xd2518829}},	//   _naoc, _wize_, tinį_, ونا_,
   {{0x6d4a8082,0x7aed497a,0x4cd080ab,0x200cbfae}},	//   _omfa, _mbat, ত্যু, _ardi_,
   {{0x527c00be,0x612b497b,0x7bc1875e,0x98a78084}},	//   אנדא, _gült, yslu, rinį_,
   {{0x7aed497c,0xe809873c,0x69a01094,0xb8f18072}},	//   _obat, विधा_, _गंभी, _वय_,
   {{0x3eb987ca,0x6d4a83c3,0xf83804de,0x3d17131d}},	//   úst_, _amfa, מנות_, नावे_,
   {{0x78bab66c,0x673bc97d,0x200c9c0a,0xa3cb8075}},	//   _fetv, rhuj, _erdi_, _लिह_,
   {{0x28e0890a,0x7aed1ea2,0x613000f2,0xe8098540}},	//   _नायि, _abat, _välk, विदा_,
   {{0x69c4416f,0xe8559459,0xc4d201c6,0x09be8264}},	//   _svie, _بناد, וגי_, _উৎপা,
   {{0xf8a9004c,0x7bc1c97e,0x3f9a012b,0x28dc000d}},	//   _יש_, rslu, _rupu_, _बाहि,
   {{0x2bc5a9b7,0x7bc1a42f,0x3ebfc97f,0x4ade86af}},	//   _विका, sslu, maut_, फ्टव,
   {{0xb17b00f2,0x3f9a4980,0x7aed0dde,0x7bc1888b}},	//   stån, _pupu_, _ebat, pslu,
   {{0x273c0013,0x2d9f82be,0x6609c981,0xa2e60081}},	//   _líne_, lque_, lvek, _дойд,
   {{0x7d03c982,0x637d366a,0x6f040362,0x7aed01bc}},	//   _hans, rénc, udic, _gbat,
   {{0x7d03c983,0x2d9fc984,0xa526035f,0x69c400e1}},	// [3940] _kans, nque_, омад, _uvie,
   {{0x2bed823c,0x3f9a0870,0x29040029,0x2d9f9ede}},	//   _जहां_, _tupu_, ēmas_, ique_,
   {{0x7d03c985,0x320d80b9,0x273889c4,0x3ebf8035}},	//   _mans, _arey_, _léna_, kaut_,
   {{0x7d03c986,0x78ba979d,0xfa2580ab,0x320d802a}},	//   _lans, _setv, _মেইল_, _brey_,
   {{0x394e82be,0xe8fac987,0x3d050074,0x7d0388dc}},	//   tifs_, илд_, _होके_, _oans,
   {{0x69c2879f,0x97a68a95,0x7d03871f,0x26c00081}},	//   rsoe, орил, _nans, laio_,
   {{0xdfd08307,0x256f0065,0x3d17000f,0xe80d0327}},	//   رية_, rült_, नारे_, हिया_,
   {{0xa2d601ab,0x7d03bade,0x03679a02,0x644180b9}},	//   _भाग्, _aans, _диск_, dzli,
   {{0x7d03c988,0x9989811a,0x260006f0,0xdb1e8118}},	//   _bans, šaš_, रिटी_, supó,
   {{0x2bd12b51,0x7aed23b9,0x200c807a,0x6b9c4989}},	//   _हिमा, _sbat, _trdi_, _kurg,
   {{0x7d03c98a,0x3ebf81ec,0x66e6c872,0x6f028289}},	//   _dans, baut_, _можа, _taoc,
   {{0x6b9c08bf,0xe3af826a,0x3b068609,0x2d9f8144}},	//   _murg, کری_, ndoq_, bque_,
   {{0xed5a9efc,0xda7b2630,0x637d2ad5,0x7ae080b9}},	//   _код_, рян_, géna, _mcmt,
   {{0x6d4ac98b,0x7d03a28f,0xa3b5864a,0x41d280d4}},	//   _umfa, _gans, _चौक_, _सिनस,
   {{0x2731801c,0x28dc143e,0x69c00118,0x2f190198}},	//   _bánh_, _बारि, ámer, бовь_,
   {{0x4c3b8051,0x7aed06df,0x2fcd0668,0x2731801c}},	//   _כתוב, _ubat, čeg_, _cánh_,
   {{0x7d03c98c,0xd49b498d,0x6d5ac98e,0x3d0f816f}},	// [3950] _yans, аре_, onta, _थोडे_,
   {{0x6d5ac98f,0xdfdb0021,0x63a48025,0xe6b788fd}},	//   nnta, _към_, _činj, _इज्ज,
   {{0xa2f5835f,0x6d5ac990,0x6b9c4991,0x92dd0264}},	//   зпеч, inta, _curg, ড়ী_,
   {{0xdd95259a,0x6b9c4992,0x659518d1,0x20014993}},	//   _намы, _durg, _наму, _ishi_,
   {{0x6d581351,0xe9d885a8,0x863503de,0x7e7d0ec3}},	//   čvar, жкі_, _זאָג_, _uzsp,
   {{0x6d5a81c0,0x3f894994,0x5ef301bc,0x637604e8}},	//   jnta, lmau_, _ịhọọ, tánk,
   {{0x6b9c16ea,0xc95403c8,0x7d03c995,0x6abb8192}},	//   _gurg, ומס_, _rans, _teuf,
   {{0x63761389,0x61300a92,0xef19a1ae,0x7bc54996}},	//   ránk, _väli, сми_, mshu,
   {{0x7d038983,0x3ebf80e3,0x28dc0107,0x30a79f72}},	//   _pans, raut_, _बालि, _древ,
   {{0x80d701fe,0x644182af,0x69d9c997,0x63764998}},	//   _बागे, tzli, muwe, pánk,
   {{0x7d03821e,0xc4d200be,0x69d9c999,0x2d9f8806}},	//   _vans, עגט_, luwe, sque_,
   {{0x2d999313,0x6d5ac99a,0x2905c99b,0x6441a85a}},	//   íses_, anta, _hala_, rzli,
   {{0x2905c99c,0x7d03c99d,0x20010326,0x7bc50cd5}},	//   _kala_, _tans, _ashi_, hshu,
   {{0x2907c99e,0x7d038b40,0x2731801c,0x29fd81ac}},	//   ndna_, _uans, _sánh_, _mňa_,
   {{0x29058b5d,0xb9250135,0x69d983e9,0x26c0499f}},	//   _mala_, _hapụ_, huwe, taio_,
   {{0x29058079,0x660f0267,0x69d9c9a0,0x7bc50bbd}},	//   _lala_, _brck, kuwe, dshu,
   {{0x26c00098,0x9ad301bc,0x0e6306f9,0x96630dff}},	// [3960] raio_, _dịde, ектн, екте,
   {{0x649a49a1,0x69d9c9a2,0x26c00ba3,0x69c649a3}},	//   стар_, duwe, saio_, mske,
   {{0x69c649a4,0x389b0158,0xc2f100ab,0xa3b60fd5}},	//   lske, _ליינ, য়ারি_, चीं_,
   {{0x23a1809a,0x290799e7,0x637881d0,0xe3c90216}},	//   _mój_, edna_, mínk, _soñé_,
   {{0x2905c9a5,0x2d9d84df,0x637602ba,0x660f04a8}},	//   _bala_, _nuwe_, gáni, _grck,
   {{0x6b9c49a6,0x6f060ad4,0x29fd81ac,0x6d891c78}},	//   _turg, _hakc, _dňa_, _džas,
   {{0x6d4e49a7,0xb4ca0bf5,0xad9b29c4,0x7c650060}},	//   _imba, ोली_, _frús, _قافل,
   {{0x91e68f04,0x672449a8,0x29079498,0xceb40085}},	//   _нобе, njij, adna_, nbə_,
   {{0xb0dc11bc,0x20dc09c8,0x637602ba,0x2905c9a9}},	//   _बांग, _बांध, cáni, _fala_,
   {{0x6d5ac9aa,0x613dace0,0x69c649ab,0x612f83ba}},	//   unta, _pèle, dske, _sølv,
   {{0x444449ac,0x3cdd8127,0xd6cf854c,0xa438902a}},	//   nz_, _खारे_, _пт_, ізму_,
   {{0x444449ad,0x6b84357f,0x66e38a74,0xdee68d0e}},	//   iz_, _chig, _गायक_, _ходи,
   {{0x6b8402c1,0x6d4e1b6b,0x6e9380f7,0x95868037}},	//   _dhig, _omba, _كلما, _елде,
   {{0x2bc58894,0x92dd00ab,0x6602c9ae,0x25f20074}},	//   _विचा, ড়ে_, _isok, ुबनी_,
   {{0xc86402df,0x63a901a1,0xa4270264,0x776d0118}},	//   етти, _čeno, _মধ্য_, toax,
   {{0x6d4e20d4,0x44441a15,0x7bdac9af,0x3f9e80a4}},	//   _amba, dz_, mutu, _mutu_,
   {{0x7bda81c2,0x444449b0,0x3f890428,0x69c60061}},	// [3970] lutu, ez_, rmau_, cske,
   {{0x7bc5164d,0x2bd106a7,0x660f01f4,0x6b8400fc}},	//   tshu, _हिदा, _vrck, _zhig,
   {{0x25f90063,0x9f5e85a4,0x629a001b,0xe57012c5}},	//   _उनकी_, _esté_, ětov, اطق_,
   {{0x63760333,0x6d4e4899,0x6602811b,0x69d9a994}},	//   táni, _emba, _osok, tuwe,
   {{0x2905c9b1,0x3f9e8052,0x44440102,0x7bdac9b2}},	//   _pala_, _autu_, az_, hutu,
   {{0x637649b3,0x6d4e00dd,0x3f9e989e,0x2905c9b4}},	//   ráni, _gmba, _butu_, _qala_,
   {{0x4444009a,0x660d2125,0x7bda87b8,0x64e20072}},	//   cz_, lvak, jutu, _पातळ,
   {{0x2905c5bb,0x05a9835f,0xee398fe7,0x44330748}},	//   _wala_, овий_, жни_, myx_,
   {{0x6d890a20,0x29058e20,0x05b9803d,0xa3df816f}},	//   _užas, _tala_, زگشت_, धून_,
   {{0x6b8403c3,0xb4d7b64b,0x7bda854e,0x69c6251c}},	//   _shig, िले_, futu, vske,
   {{0xa3d49094,0x7d070b48,0x637d016b,0x25740106}},	//   िंग_, _majs, rénn, mält_,
   {{0x60c3c9b5,0x7d070390,0x09e200ab,0x929d809a}},	//   lanm, _lajs, যবসা, _mało,
   {{0xe56e8698,0x612f83ba,0x3f9e8bcf,0x25fd0ad5}},	//   _аз_, _følt, _zutu_, _रैली_,
   {{0x69c60d5b,0x7bdabc80,0x6f098c57,0x673d49b6}},	//   rske, butu, ldec, _alsj,
   {{0x6d41c9b7,0x6b8401e4,0x6f060ad4,0xafe32597}},	//   mhla, _thig, _pakc, корл,
   {{0x672b88b3,0x6f09a3ed,0x629b801c,0x69c649b8}},	//   _jogj, ndec, _nguo, pske,
   {{0x09e200c8,0x63a4803b,0x6f0649b9,0xfb87004e}},	// [3980] যবহা, _čini, _vakc, _تدوی,
   {{0x44440ad9,0x6378c9ba,0x6d41805d,0x25740106}},	//   tz_, míni, nhla, jält_,
   {{0xd91b0158,0x68fc09ca,0xf74649bb,0x711b00be}},	//   _וויל, merd, _жено, _וויפ,
   {{0x44441013,0x68fc292e,0x3cfa0063,0x6ea506a7}},	//   rz_, lerd, _उसके_, _कलयु,
   {{0x444449bc,0xd9469d32,0x6d41810b,0x636803bf}},	//   sz_, меди, khla, mınd,
   {{0x3f9e82a5,0x6d4e49bd,0x636802bb,0xb4d7800d}},	//   _putu_, _umba, lınd, िलो_,
   {{0xd0108d4a,0x613000f2,0x2b0e101c,0x6d41a12b}},	//   الب_, _häls, ियाँ_, dhla,
   {{0x636802bb,0x7bda84a2,0x6d8900d2,0x68fc49be}},	//   nınd, vutu, _užar, herd,
   {{0x10a68364,0x2d9849bf,0x68fc49c0,0x60c389ab}},	//   _жизн, _kire_, kerd, banm,
   {{0x6d41954c,0x7bdac9c1,0x3f9ec9c2,0x25740106}},	//   ghla, tutu, _tutu_, mäls_,
   {{0x68fc49c3,0x2d9849c4,0x44388298,0x660d3bac}},	//   derd, _mire_, ár_, zvak,
   {{0x2d9849c5,0x7c4481dd,0x291a01df,0x2bd1123a}},	//   _lire_, _đurđ, _anpa_, _हिसा,
   {{0xd3790025,0x7bda8006,0x636803bf,0x6d418c49}},	//   juće_, sutu, dınd, bhla,
   {{0x6d4184ac,0x7bdac9c6,0xd3790024,0x26c4c9c7}},	//   chla, putu, duće_, lamo_,
   {{0xa3cb8610,0x636805c5,0x4fc40678,0x273c0125}},	//   _लिए_, fınd, кста, _sína_,
   {{0x26c4c9c8,0x2d982305,0x60c3b969,0x3995026b}},	//   namo_, _aire_, zanm, _bùsì_,
   {{0xd379003a,0x68fc1c37,0xa3dc016f,0x8af78085}},	// [3990] guće_, berd, णूस_, şəkk,
   {{0x69dd49c9,0x660d0336,0x2d9849ca,0x273c026f}},	//   muse, rvak, _cire_, _vína_,
   {{0x2d9849cb,0x8af9a296,0x69dd49cc,0x61303568}},	//   _dire_, знес_, luse, _vält,
   {{0x26c4c9cd,0x490703bb,0xf38a001c,0x6d41816b}},	//   jamo_, िएको_, _bảy_, zhla,
   {{0xfe088104,0x26c4c9ce,0x69dd49cf,0xad9b00f7}},	//   _nữ_, damo_, nuse, _grúp,
   {{0x637649d0,0xd122146d,0xde1600be,0x3ea949d1}},	//   lánt, मायण_, _אַלץ_, lcat_,
   {{0xb9078006,0x69dd2280,0x60c3c9d2,0x6f0981ec}},	//   _भा_, huse, ranm, tdec,
   {{0x3ea949d3,0x69dd3553,0xdb1b1bc0,0x7afd0c6b}},	//   ncat_, kuse, nstä, jest,
   {{0x7afd49d4,0x29d58c3b,0x3f990115,0x68e50229}},	//   dest, _سياس, _misu_, _ochd,
   {{0x69dd0744,0x9a8483c7,0xfe08801c,0x06828071}},	//   duse, _русл, _dữ_, ыгын,
   {{0x116a84c0,0x26c4c9d5,0x973c826c,0xdb1b0106}},	//   _علمی_, bamo_, _suće, kstä,
   {{0x3f990025,0x60c1810a,0xf4120158,0x26c4ae96}},	//   _nisu_, _helm, אפט_, camo_,
   {{0x68fc438b,0x60c1c9d6,0x69dd0006,0xf38a001c}},	//   terd, _kelm, guse, _xảy_,
   {{0xf1b28051,0x6e20009f,0xfc31987e,0xb606807b}},	//   רסם_, _àmbi, _محب_, sráð,
   {{0x63681010,0x3f9900dd,0x60c1c9d7,0x2d980036}},	//   tınd, _bisu_, _melm, _rire_,
   {{0x28dc0665,0x6d5e01e0,0xb5fb06a5,0x68fc38b9}},	//   _बाकि, wnpa, _exám, serd,
   {{0x63680afe,0x6996007f,0xcf92812a,0x3dc91c33}},	// [39a0] rınd, _прох, רטן_, gsaw_,
   {{0x63680a0b,0xec098104,0x59c98105,0x26c4baa4}},	//   sınd, _kế_, _रिजर, zamo_,
   {{0x491d0076,0xf5368158,0x2d9806c0,0xd3791bcf}},	//   मारो_, עטער_, _vire_, suće_,
   {{0x3ea949d8,0x20570158,0x661b49d9,0x442602a5}},	//   ccat_, _טייל_, _šuke, ćo_,
   {{0x2d878352,0x20058587,0x635c8353,0x798e0c53}},	//   _ohne_, _asli_, nčni, ombw,
   {{0x3f868358,0x7afd49da,0xdb1b01a3,0x26c48dc5}},	//   _shou_, zest, mstå, wamo_,
   {{0x26c4c331,0x22468019,0x333fae1c,0x3f86822c}},	//   tamo_, szok_, _flux_, _phou_,
   {{0x7afd062f,0x60c18074,0x62840037,0x752e0609}},	//   xest, _eelm, _ozio, _hobz,
   {{0x26c4c9db,0xbb4381bb,0xdb1b0f96,0x6e242c88}},	//   ramo_, _сетк, nstå, nxib,
   {{0xa3cb8b85,0x60c18214,0x7ae2c9dc,0x7afd49dd}},	//   _लिख_, _gelm, lgot, west,
   {{0x2b400eef,0x62840098,0x7bde17a0,0x7afd0888}},	//   _blic_, _azio, nupu, test,
   {{0x69dd0665,0x7ae2c9de,0xec0980ff,0xdbc702f1}},	//   tuse, ngot, _dế_, _tööv,
   {{0x7afd49df,0x7bde0ad4,0xdb1b0106,0x799a8737}},	//   rest, hupu, vstä, _kitw,
   {{0x7afd49e0,0x69dd49e1,0xa4d4835f,0x7bde49e2}},	//   sest, ruse, _рокі, kupu,
   {{0x62840870,0xd7f849e3,0x69dd49e4,0xdb1b12d2}},	//   _ezio, нут_, suse, tstä,
   {{0x799ac9e5,0x26c24001,0x7d0ac9e6,0x69dd49e7}},	//   _litw, _ceko_, _hafs, puse,
   {{0x3ea949e8,0x3f993761,0xdb1b0b2f,0x7d0a80f1}},	// [39b0] rcat_, _visu_, rstä, _kafs,
   {{0xceeb0077,0xdb1b1f0f,0x3ea9437e,0xfd61001c}},	//   _کردن_, sstä, scat_, _huyế,
   {{0x9f478a21,0x3f990034,0x60c749e9,0xec0980ff}},	//   stné_, _tisu_, majm, _xế_,
   {{0xd6db025d,0x7ae28587,0x60c1c9ea,0x5b2499b8}},	//   _это_, ggot, _selm, льча,
   {{0x799ac9eb,0x6f1d3c72,0x3984016d,0xd7f88087}},	//   _bitw, _insc, lösa_, _apă_,
   {{0x7d0ac9ec,0x98b40289,0x26c20669,0x3cfe8267}},	//   _nafs, čeći_, _zeko_, jetv_,
   {{0xe81400d4,0x60c183cb,0x48e90035,0xb8140f0a}},	//   डिया_, _velm, _जानो_, डियम_,
   {{0x27e700f2,0x43948198,0xa2cd9905,0x78b885ee}},	//   _ännu_, _басс, दृश्, abvv,
   {{0x7b648dc8,0xd7068009,0x60c1c9ed,0x644881ac}},	//   _стре, тные_, _telm, ezdi,
   {{0x29cd0038,0x2bd80b9f,0x6f0d442d,0xdb058192}},	//   dľa_, _डिमा, hdac, sphä,
   {{0xcb6a0463,0x6f1d49ee,0x69cb8c4d,0xd11e8dd2}},	//   дане_, _onsc, lsge, पारण_,
   {{0x69d986a8,0xdd0200c3,0x3cddb26c,0x63680850}},	//   orwe, _čuči, _खाके_, dınc,
   {{0xad9b49ef,0x799a80b4,0xee2e91b3,0xe809a594}},	//   _asúm, _yitw, _тн_, विका_,
   {{0x4999025d,0x23d11094,0xec098104,0x6f1d02af}},	//   ется_, _हिंद, _tế_, _ansc,
   {{0xdb0810ab,0x929d809a,0x8c428a0e,0x69d981ec}},	//   ólóh, _całk, _веще, hrwe,
   {{0x973c8499,0xd36f00f7,0x6729c9f0,0xdb1b108c}},	//   _kuća, _وهو_, njej, tstå,
   {{0xb6a30087,0xdca61810,0x63a3888b,0x7f440168}},	// [39c0] риул, вази, _hunn, rhiq,
   {{0x63a39682,0xdb1b0bfa,0x1dd4835a,0x7bde49f1}},	//   _kunn, rstå, _दिसत, tupu,
   {{0x7c960ef5,0x40d90158,0x7f4402be,0xd7ca0077}},	//   трац, _אַרײ, phiq, _توجه_,
   {{0x6b89c9f2,0x799ac9f3,0xdb1b0186,0x673b8b67}},	//   _cheg, _sitw, pstå, jkuj,
   {{0x7bde49f4,0xcb13010f,0x6fbe80c8,0x8b6592dc}},	//   supu, ילא_, _ইমেই, دالم,
   {{0x49738160,0x7bde3f8c,0x6d4501ec,0x27fa008e}},	//   аліс, pupu, chha, _kppn_,
   {{0x7af6016b,0x6b9b9d15,0xa87a00be,0x237d822c}},	//   _obyt, _fiug, ואַר, blwj_,
   {{0x6b9b8698,0x657e151e,0x60c701dd,0x799a80b4}},	//   _giug, llph, zajm, _witw,
   {{0xe9a68698,0xd379005c,0x660400e4,0x25f4801b}},	//   _разп, juća_, nwik, ्बधी_,
   {{0x973cc3c9,0xd3791487,0x799a837a,0x205689b1}},	//   _duća, duća_, _uitw, _итер,
   {{0x291e82a3,0x63a38014,0x637d03c9,0xbd06826b}},	//   _inta_, _cunn, léni, _abéò,
   {{0x290ca480,0xfd610028,0x63a3c9f5,0x99ae00ab}},	//   _hada_, _quyế, _dunn, _কয়েক,
   {{0x7d0ac9f6,0xd379005c,0x63a3808e,0x6d86808b}},	//   _tafs, guća_, _eunn, rðab,
   {{0x672f42ac,0x63a3c9f7,0xf8b48665,0x290cc9f8}},	//   _socj, _funn, ुरिय, _jada_,
   {{0x63a3c9f9,0x290cc9fa,0xfd610028,0x6378957a}},	//   _gunn, _mada_, _tuyế, níns,
   {{0xd6d822d2,0xf1a71810,0x6f0d457d,0x2a6901c0}},	//   кту_, _ирон, udac, _txab_,
   {{0x6f0d49fb,0xc299035f,0x69c003a7,0x291ea168}},	// [39d0] rdac, _яких_, âmet, _onta_,
   {{0x290ca5a7,0xf8b70af3,0x7af613e2,0x63a39bb7}},	//   _nada_, _अभिय, _zbyt, _yunn,
   {{0x4035324f,0x290e8114,0x69c08609,0x63680380}},	//   _сенс, ddfa_, _awme, lına,
   {{0x41c400d5,0x291ec9fc,0x6f0084e8,0x2d9c9357}},	//   _حقیق, _anta_, jemc, _live_,
   {{0x290cc917,0x1959876a,0x637d49fd,0x66f603c8}},	//   _bada_, нады_, géni, _גמרא_,
   {{0x69cbc9fe,0xc4bd80ab,0x60c50197,0x61ed0197}},	//   rsge, _ইঞ্জ, _jehm, _mqal,
   {{0x6d550059,0x60c549ff,0xf7f581ad,0xd379026c}},	//   _imza, _mehm, استد, zuća_,
   {{0x53348f5a,0x61ed05e7,0x80dc00c8,0xaf0580bf}},	//   _кест, _oqal, ম্প্, упил,
   {{0x290cca00,0x63a38e20,0x637d2511,0x6729ca01}},	//   _fada_, _sunn, céni, rjej,
   {{0x290c8341,0x9f5e87e2,0x60c502af,0xc9878e97}},	//   _gada_, _està_, _nehm, _руби,
   {{0x6f0ba888,0x7f42ca02,0x61ed4a03,0x637884e8}},	//   _tagc, _floq, _aqal, cíns,
   {{0xc654803d,0x63a3ca04,0x27350338,0x3f4706ae}},	//   افیک, _vunn, _måns_, _jõud_,
   {{0x973c803b,0xf77092dc,0x290cca05,0x7bda89ff}},	//   _kućn, _بال_, _yada_, artu,
   {{0x06e3959a,0xa11609a7,0x2d9c8039,0x63a3ca06}},	//   _गाँव_, دوست, _give_, _tunn,
   {{0xd3794a07,0x7d01aa33,0x18670ae7,0x6d438037}},	//   suća_, mels, гари_, _ilna,
   {{0x290c003a,0x7af6003e,0x66044a08,0x7c3c8bc5}},	//   žda_, _ubyt, twik, ørre,
   {{0x60c52991,0x637d01df,0x558a096f,0x33200197}},	// [39e0] _fehm, xéni, ебам_, _inix_,
   {{0x27350186,0x66040077,0x090606e6,0x64648110}},	//   _sånt_, rwik, _спон, štiš,
   {{0x06e3959a,0xdd8f00f7,0x48e9016f,0x9f5e4a09}},	//   _गांव_, أول_, _जातो_, ító_,
   {{0x290c803b,0xb7db010f,0xbda600d5,0x7d01804a}},	//   _sada_, _אקטי, _محسو, hels,
   {{0x290c9dae,0x7d018082,0x799e4a0a,0x6b460032}},	//   _pada_, kels, _kipw, _kógb,
   {{0x64a33056,0x290c9a7b,0x7d018686,0x637d0866}},	//   _гара, _qada_, jels, réni,
   {{0x2d9c8205,0x8c461510,0x7d018f06,0x290cca0b}},	//   _rive_, _севе, dels, _vada_,
   {{0x290c82a3,0x7d0e393e,0x4734a209,0xa81780d7}},	//   _wada_, _habs, рнис, اتور_,
   {{0xa3e68996,0xd2669e25,0x2611864a,0x660d826c}},	//   यून_, _скай, तिषी_, _šakr,
   {{0x7d01920b,0x291eabc6,0x6378ca0c,0x5d54a240}},	//   gels, _unta_, píns, ркот,
   {{0x9f5e9313,0x2498816d,0x443a0901,0xaca48135}},	//   _está_, ärm_, nyp_, _ntụz,
   {{0x6d43ca0d,0x9295249a,0xdb1b1277,0xe9f90129}},	//   _elna, ианц, nstø, _ngả_,
   {{0x60c504a2,0x2d9c83a7,0x7d019c5c,0x61e28110}},	//   _pehm, _tive_, bels, nuol,
   {{0xdd8f92dc,0x7d01ca0e,0x973c811f,0x61ef14cf}},	//   _فون_, cels, _kućo, rtcl,
   {{0x273c001c,0x3f9d8041,0x6d488c41,0x6d5abf3c}},	//   _kính_, _yiwu_, mhda, mita,
   {{0x61e2ca0f,0x7d0e02c4,0x8c1b9101,0xaefb026b}},	//   kuol, _aabs, _טווי, _ijùk,
   {{0x5d553dc4,0x613d8247,0x80ca80ab,0x6e9901a1}},	// [39f0] акат, _sèlm, _রান্, твар_,
   {{0x6d5a85d8,0x7d0e0079,0x7ae9ca10,0x273c00ff}},	//   nita, _cabs, _scet, _lính_,
   {{0x61fb9a62,0x6d5a8267,0x02d08072,0x63ad81a1}},	//   _spul, iita, हणून, _čank,
   {{0x6d5aca11,0xb17b016d,0x52158991,0x7d01ca12}},	//   hita, fråg, идет, zels,
   {{0x6d5aca13,0x7d01ca14,0x36de86a7,0x90c58110}},	//   kita, yels, _गाड़ी_, абле,
   {{0xdb04020f,0x26c98a20,0x6d5a9c9e,0x29110b80}},	//   _punë, _žao_, jita, ndza_,
   {{0x7d018370,0xb17b0082,0x9f47800d,0xe73181a8}},	//   vels, mråd, stní_, قصة_,
   {{0x25a6808e,0xadc404be,0x7d01ca15,0xb17b006f}},	//   _buol_, _amẹr, wels, lråd,
   {{0x6d5aca16,0x7d01ca17,0x6f0f4a18,0x3f838029}},	//   fita, tels, _macc, ēju_,
   {{0x6d5aca19,0x6d48c4b9,0x6f0f4a1a,0x7d0e0079}},	//   gita, ghda, _lacc, _xabs,
   {{0x7d018370,0x6b8d4a1b,0x69dd044e,0xd469b1f0}},	//   rels, _bhag, erse, тине_,
   {{0x7d0181eb,0x6b8d1c40,0xa3ab85fc,0x672d0365}},	//   sels, _chag, _कंठ_, jjaj,
   {{0xf770ca1c,0x672d20a7,0x6b8d02a3,0x9f048065}},	//   _عام_, djaj, _dhag, _دونو,
   {{0x6d5aca1d,0x6d488782,0xd379005c,0x29032446}},	//   cita, chda, vrće_, geja_,
   {{0x63a70353,0x1fb50221,0xd47980be,0x7d0e4a1e}},	//   _nujn, йстр, _באַל, _rabs,
   {{0x6f0f4a1f,0x6b8d01bc,0x273c046d,0x7d0e4a20}},	//   _cacc, _ghag, _kíni_, _sabs,
   {{0xee372318,0x4b7b00be,0x2a7f81c0,0x7b0800eb}},	// [3a00] ант_, _באקו, _nyub_, āstī,
   {{0xf53f13c2,0x7d0e02a3,0x14c8003d,0x443a4a21}},	//   _står_, _qabs, اهای_, typ_,
   {{0x6f0f0098,0x6c4a04c1,0x2a7f8642,0x6289810c}},	//   _facc, خلاف_, _ayub_, _azeo,
   {{0x55e60328,0x6d5aca22,0x3945ca23,0xa3e6835a}},	//   _комб, zita, _alls_, यंत_,
   {{0x7d0e01c5,0x637d4a24,0xdb1b0aa2,0x6d5ab6ed}},	//   _tabs, mént, rstø, yita,
   {{0x6d5aca25,0x6f040352,0x6f0f00df,0xb4cf852a}},	//   xita, leic, _zacc, षणो_,
   {{0x6d5aa05a,0xed572481,0x2a7f89c4,0xf1d286a7}},	//   vita, _тор_, _eyub_, _सिकन,
   {{0x6d5aca26,0xdefa8084,0x61e293cd,0x3945809f}},	//   wita, тык_, puol, _ells_,
   {{0x6d5aca27,0x6b8d0355,0x2366807d,0x48e6a2f3}},	//   tita, _rhag, mnoj_, _возв,
   {{0x23668025,0x69dd0052,0x6b8d4a28,0x236901dd}},	//   lnoj_, vrse, _shag, _sjaj_,
   {{0x273c0104,0x6d5a8908,0xc8b581e5,0x29034a29}},	//   _tính_, rita, _ысты, veja_,
   {{0x6b82ca2a,0x63a0933b,0x6d5aca2b,0x69c40372}},	//   nlog, _jimn, sita, _bwie,
   {{0x6f0f2b3c,0x290346b2,0x69dd4a2c,0x05b4806b}},	//   _racc, teja_, urse, _امتح,
   {{0xd5fb8051,0x5ba6828b,0x6f0f4a2d,0x69c42180}},	//   _ספור, _криз, _sacc, _dwie,
   {{0x6f0f0081,0x6b8d008c,0x6d5880b4,0x60c8a25b}},	//   _pacc, _thag, _imva, _medm,
   {{0x236680d2,0x63a7173d,0x29034a2e,0xddc4009a}},	//   jnoj_, _rujn, seja_, dził,
   {{0x23668025,0x672d4a2f,0x212100ff,0xb17b04e1}},	// [3a10] dnoj_, rjaj, _tnhh_, tråd,
   {{0x64410074,0x6f0f04b9,0x764d1037,0x63a0ca30}},	//   _ülik, _wacc, rzay, _aimn,
   {{0x6f0f4a31,0x69c44a32,0x6b828114,0xb17b006f}},	//   _tacc, _zwie, flog, rråd,
   {{0x2366826c,0x637d0511,0xa3e603b7,0xb17b0f91}},	//   gnoj_, cént, पढ़_, sråd,
   {{0x636802bb,0x6280831d,0x6d589406,0x63a0811a}},	//   dınl, _cymo, _omva, _dimn,
   {{0xdb0780f2,0x2bac801b,0x6280ca33,0x2aadca34}},	//   _stjä, _něco_, _dymo, _bóbó_,
   {{0xe9df00f7,0xb90c0133,0x2366812b,0x60c882d5}},	//   hrú_, _achụ_, bnoj_, _dedm,
   {{0x75350117,0x236682a5,0x6b828980,0x7d0500b9}},	//   _hozz, cnoj_, clog, lehs,
   {{0x7afbca35,0x6d86807b,0x7f4980f1,0x6d470301}},	//   _ibut, rðan, rheq, _klja,
   {{0x63a08e04,0x6f0402af,0x6722ca36,0x39458722}},	//   _zimn, zeic, _enoj, _ulls_,
   {{0x69c44a37,0x753500df,0xeb9a2300,0x6d4701f4}},	//   _swie, _mozz, лио_, _mlja,
   {{0x67228805,0x63a081df,0xa3c914d5,0x7aed01a1}},	//   _gnoj, _ximn, लीय_, _ccat,
   {{0x3da7ca38,0x3ebf859c,0xb5a7a657,0xd77480f7}},	//   _треб, mbut_, _трей, _بالع,
   {{0x4e7a8158,0x2366812b,0x75354a39,0x6722883d}},	//   _גאנצ, znoj_, _nozz, _znoj,
   {{0x637d0c15,0x7afbca3a,0x6f0400eb,0xa78604a3}},	//   tént, _obut, teic, مشرو,
   {{0x69c44a3b,0x6d4716ea,0x6b6b009a,0x27ea806a}},	//   _twie, _alja, lęgn, _åbne_,
   {{0x6f04034a,0x23668025,0x6609ca3c,0xe61a0190}},	// [3a20] reic, vnoj_, nwek, ыда_,
   {{0x6d41ca3d,0x4cd980c8,0x637d01df,0x753501e8}},	//   nkla, ব্রু, sént, _cozz,
   {{0x2366803a,0x636807d9,0x63a0808e,0xa5dd0035}},	//   tnoj_, yınl, _pimn, _पिथौ,
   {{0xf0930039,0x6609ca3e,0x60c89620,0x63680085}},	//   _מנת_, kwek, _sedm, xınl,
   {{0xceb3093f,0x26c042ee,0x23668025,0x6b82ca3f}},	//   _מיר_, mbio_, rnoj_, rlog,
   {{0x2366803b,0x7afbca40,0x75354a41,0xa7b8ca42}},	//   snoj_, _ebut, _gozz, алку_,
   {{0x6c360288,0x6d5e4a43,0x63a0ca44,0x6d4185b9}},	//   _افزا, mipa, _timn, dkla,
   {{0x6d5e04d2,0x62808114,0x61e6377d,0x543b00be}},	//   lipa, _tymo, kukl, _געלא,
   {{0x61e610f5,0x160e03db,0xfa6a8162,0x3f4706ae}},	//   jukl, सिटर_, _саак_, _jõua_,
   {{0x3ebf8bb1,0x61e64a45,0xf8ac83db,0x9ad301bc}},	//   abut_, dukl, _चलिय, _tịke,
   {{0xdefa8364,0x308680f7,0x9f47826f,0xa3ab8105}},	//   _был_, _الاف, stná_, _कूद_,
   {{0xdc9b0158,0x6d5e4a46,0x2be00dd2,0x973c992c}},	//   טייל, hipa, _पटना, _mućk,
   {{0x6d5e4a47,0x6e968013,0x44274a48,0x98ac90a1}},	//   kipa, _الشا, ̣n_, _चलाए,
   {{0x6d41ca49,0x067b8158,0x6d5e4a4a,0xe3af82e3}},	//   ckla, _ענגל, jipa, بری_,
   {{0x6d5e4a4b,0xa89905a8,0x75350b91,0x657aca4c}},	//   dipa, ркву_, _rozz, moth,
   {{0x3ceb4a4d,0x6d4700d2,0x7eb90098,0x657aca4e}},	//   _चाहे_, _slja, ргас_, loth,
   {{0x171b8158,0x6d47003b,0xf1b9807d,0xa535067c}},	// [3a30] נומע, _plja, _krše_, онач,
   {{0x657a8bef,0x3ebf8359,0x628d1dd7,0x98c70a0e}},	//   noth, zbut_, _izao, _усил,
   {{0x443eca4f,0x26c00081,0xfbd0003d,0x293800be}},	//   nyt_, bbio_, فتن_, _לאזן_,
   {{0x291301df,0xd9ed0f12,0xe2f98558,0x6d41a1c5}},	//   _haxa_, _जमात_, реді_, zkla,
   {{0x6d41a310,0x75354a50,0x2b4900c3,0x657a81f6}},	//   ykla, _tozz, _mlac_, koth,
   {{0x7ff40077,0xa5bb007b,0x6d47042b,0x59dc0441}},	//   _بسیا, _próf, _ulja, _बिसर,
   {{0x6d418186,0xcfb480ab,0x661d192c,0x6d86808b}},	//   vkla, _টিউন, _hrsk, rðal,
   {{0x7afb8578,0x59c6800d,0x29130118,0x26cb01a1}},	//   _ubut, रीहर, _laxa_, _jeco_,
   {{0x161c000f,0xee3687ac,0x3ebfca51,0x26cb0118}},	//   नियर_, жны_, rbut_, _meco_,
   {{0x61e6011f,0xd3790024,0x661d00cd,0x26c00289}},	//   vukl, vrća_, _mrsk, zbio_,
   {{0xdb1b0789,0xf6d580e8,0xd847ca52,0x2b490c0b}},	//   sstý, _діля, _ухап, _blac_,
   {{0xa3e105e8,0xf7708013,0x6e24c7db,0x61e64a53}},	//   _दिन_, _كان_, _šibe, tukl,
   {{0xa3c9016f,0x6d41ca54,0x29130be9,0xdb1e83ba}},	//   लीत_, pkla, _baxa_, rspø,
   {{0x443e9122,0x2907ca55,0x31af080a,0x07a60226}},	//   byt_, nena_, _düz_, жавн,
   {{0xa0a34a56,0x61e64a57,0x475a23bc,0xe73a4a58}},	//   дард, sukl, арая_, аев_,
   {{0x661d0db7,0x77698557,0x2907ca59,0xb3470187}},	//   _brsk, nnex, hena_, ruçõ,
   {{0x2907ca5a,0x80ca80ab,0xdb040216,0x2913011b}},	// [3a40] kena_, _রাস্, _juní, _faxa_,
   {{0x2d85ca5b,0x661d0289,0x63a40074,0xf1b901d0}},	//   nlle_, _drsk, _hiin, íše_,
   {{0x6d5e16a7,0x63a432d2,0x273c007b,0x2d85bc72}},	//   ripa, _kiin, _sínu_, ille_,
   {{0x6d5e4022,0x64990c51,0x7f4d0144,0x31af061c}},	//   sipa, стур_, chaq, _yüz_,
   {{0x63a44a5c,0x67264a5d,0xdb00ca5e,0x657a81f6}},	//   _miin, _inkj, _jimé, yoth,
   {{0x61438009,0x63a418c2,0x2bda8035,0xceb4011c}},	//   меча, _liin, _भिला, lcə_,
   {{0xaada01fe,0xb4e601ce,0x98be8087,0xa7fc811c}},	//   _भयंक, फली_, _altă_, _axır,
   {{0x44208a56,0x63a44a5f,0x963494d6,0x973c805c}},	//   _či_, _niin, зниц, _kući,
   {{0x550691e9,0xdb1b02af,0x628400b9,0xcd069033}},	//   очна, rstü, _nyio, очни,
   {{0x63764a60,0xdd908872,0x443eca61,0x2b491a2e}},	//   mány, عود_, tyt_, _slac_,
   {{0xd6cfca62,0xf1b982a5,0x2b494a63,0xad1b00be}},	//   _от_, _vrše_, _plac_, בויר,
   {{0x74ba85e8,0x8cba8ebf,0x443ea133,0x657aca64}},	//   _श्रृ, _श्रो, ryt_, soth,
   {{0xf2d39b9e,0xd37900fe,0x63a4404b,0xfd0f8077}},	//   וער_, nući_, _diin, رجی_,
   {{0x26cb06ea,0x443eca65,0x6602b13c,0x63b880ff}},	//   _seco_, pyt_, _ipok, _ttvn,
   {{0x63a40012,0xb4d6800c,0xa1578039,0x7d08ca66}},	//   _fiin, िणी_, קבלה_, meds,
   {{0x29130962,0x3cfd000d,0x2907ca67,0x661d01dd}},	//   _waxa_, र्ने_, zena_, _prsk,
   {{0xd3790025,0x29132c59,0x2907ca68,0xdb00ca69}},	// [3a50] jući_, _taxa_, yena_, _gimé,
   {{0xd379003a,0x290792f5,0x7d0881a3,0x201eca6a}},	//   dući_, xena_, neds, _orti_,
   {{0x61e287f1,0x76408428,0x4ab99273,0xd7a98035}},	//   erol, hymy, буля_, _चूंच,
   {{0x7d088022,0x6d5c2d68,0xa3ccaa47,0x80ca80ab}},	//   heds, _emra, शीय_, _রাষ্,
   {{0xd3790052,0x201e96b2,0x776980ee,0xdb00816a}},	//   gući_, _arti_, vnex, _ximé,
   {{0xe817b2dd,0x2b9200e1,0x201e808e,0x7d088140}},	//   थिला_, máce_, _brti_, jeds,
   {{0x2907853e,0x25e30b9f,0x236d816d,0x6d450234}},	//   rena_, टंकी_, _tjej_, mkha,
   {{0x81aa80c8,0x27e7ca6b,0x3f5701b9,0x15ef06ae}},	//   _খবর_, runn_, għux_, _चमार_,
   {{0x2907ca6c,0x201e8ad4,0x7769822b,0x2d85823e}},	//   pena_, _erti_, rnex, tlle_,
   {{0x63a40df8,0x2d85a1aa,0x6d454a6d,0x613d8580}},	//   _siin, ulle_, nkha, _cèlt,
   {{0x2d85862f,0xa3e68b9f,0xdb00ca6e,0x6602bc95}},	//   rlle_, यूल_, _simé, _epok,
   {{0x2d8581df,0xd8748591,0x69c9ca6f,0x660d0234}},	//   slle_, _غالب, _kwee, kwak,
   {{0x7d08ca70,0x63a44a71,0x4a430081,0x69c985ee}},	//   beds, _viin, еняв, _jwee,
   {{0x25bfad7b,0xfbd180f7,0xd1320019,0xc7b88140}},	//   mpul_, _كتب_, رمز_, _hrđa_,
   {{0x6561ca72,0x6023002d,0xd8233943,0x3d0f0035}},	//   milh, ндра, ндри, ड़ने_,
   {{0xcc3a8158,0x0eaa0a8e,0x6aa9ca73,0x38650174}},	//   _לעצט, скай_, _ngef, úlra_,
   {{0xe7371172,0x6d5c00b9,0xa5bb0032,0xc7b88088}},	// [3a60] чет_, _pmra, _arób, _mrđa_,
   {{0xd379005c,0x65618187,0x98ac8084,0x63760061}},	//   vući_, nilh, _kodą_, vány,
   {{0x31570159,0x4915170c,0xe7eb000f,0x6441831d}},	//   _זיין_, _फोटो_, जूदा_, nyli,
   {{0x7d088063,0x290a4a74,0x6da6045e,0x6e2003a8}},	//   zeds, leba_, _нима, _ámbo,
   {{0x26d24a75,0x6d450326,0x6f098df6,0xe5a61289}},	//   mayo_, bkha, deec, _хиги,
   {{0x61e29220,0xe4da1125,0x26d24a76,0x6d5c0d1b}},	//   rrol, _دوست_, layo_, _umra,
   {{0x6561ca77,0x28bf0d14,0xd9d9001b,0x7d0884d6}},	//   dilh, ्रति, _भट्ट, veds,
   {{0x26d24a78,0x61e28754,0x657e4a79,0x64a30110}},	//   nayo_, prol, loph, _часа,
   {{0x91e38468,0x7538a7aa,0xeb979577,0xbebb0cab}},	//   _поте, _povz, _хит_, _poëz,
   {{0x290a453d,0xb3e006a7,0x2c000074,0x73d89ad8}},	//   jeba_, _पटाख, _ईहां_, одор_,
   {{0x7d08ca7a,0x76408364,0x26d20418,0x69c981ed}},	//   reds, symy, kayo_, _zwee,
   {{0x657e22f1,0xc7b384de,0x6d4b01a9,0x394c8174}},	//   hoph, _טבע_, īgai, _hlds_,
   {{0x7afda9ed,0x63ae11fe,0x6602b731,0xf1b989d1}},	//   _öste, _lubn, _upok, _krša_,
   {{0x6d4a808e,0x3f823360,0xad9b0333,0xada38073}},	//   _ulfa, _akku_, _apún, _зачл,
   {{0xd6db163f,0x7d150353,0x34fb81c6,0x657e4a7b}},	//   йта_, _razs, _ההוד, doph,
   {{0x29184a7c,0x35d18105,0x26d2260b,0x8f340791}},	//   adra_, _दौड़, gayo_, несц,
   {{0xaac32207,0x4ac323bd,0xae1f8054,0x6d452322}},	// [3a70] _व्यक, _व्यव, बियन_, tkha,
   {{0xa5bb2422,0xd49b1bab,0x660d450b,0x290a0644}},	//   _prób, бре_, rwak, ceba_,
   {{0x26d200f6,0x660d0726,0x6d45332e,0xa5bb3cd4}},	//   bayo_, swak, rkha, _bróc,
   {{0x1ddd809a,0x6d454a7d,0xf1b98267,0x7fd604de}},	//   _मिलत, skha, _arša_, _קורס_,
   {{0xbef88b9f,0xdb020106,0x657e0234,0x63760118}},	//   ्जैन_, pplö, boph, ránx,
   {{0xf8bf024c,0x3f890114,0x657e01f6,0x2bac81d0}},	//   ्रिय, llau_, coph, _těch_,
   {{0x656183a7,0xe0d09a37,0x3f890114,0x7bdc8061}},	//   vilh, ازه_, olau_, árul,
   {{0x39841bc0,0x290a009a,0x69c99457,0x321f801c}},	//   löst_, zeba_, _twee, _truy_,
   {{0x50bf000f,0xa8a78dae,0x1ddd816f,0xd3791487}},	//   ्राष, _ерек, _मिळत, nuću_,
   {{0x61e4ca7e,0x25bfca7f,0x26d2005d,0x7afd1384}},	//   áile, rpul_, zayo_, efst,
   {{0x63ae4a80,0xeb9a002e,0x6561ca77,0x26d21fca}},	//   _xubn, жин_, rilh, yayo_,
   {{0x657e1c96,0x8c1a0039,0x3cfd016f,0x2901198d}},	//   zoph, קורי, र्ते_, _abha_,
   {{0xd379012b,0xa3b2800f,0x7e6902d4,0xe5e680d7}},	//   juću_, _झूठ_, _žepn, _قزوی,
   {{0x59e0816f,0x26d24a81,0x200580b9,0x2242004a}},	//   _निसर, wayo_, _kpli_, rykk_,
   {{0x26d231bc,0x290a4a82,0x29184a83,0xb4e98576}},	//   tayo_, reba_, rdra_, यली_,
   {{0x60c11010,0x26cf8063,0x7bc18197,0x63ae0140}},	//   ılma, _jego_, mplu, _rubn,
   {{0xd1ba0b76,0x6b8402a0,0x26d20924,0x3a200077}},	// [3a80] _بابا_, _ikig, rayo_, _urip_,
   {{0x26d2005d,0x3eb9007b,0x61eb8558,0xf507002e}},	//   sayo_, _efst_, dugl, мнул_,
   {{0xe73a0381,0x657e4a84,0xa3c9016f,0x7bc1ca85}},	//   _ден_, roph, लील_, nplu,
   {{0x26cf803a,0x27e50038,0x728a95a6,0x394c8216}},	//   _nego_, álne_, обег_, _slds_,
   {{0x75490117,0x61eb80fe,0x2bac81d0,0x6b8403e4}},	//   ászó, gugl, _věci_, _mkig,
   {{0xe8948c5c,0xa5bb0035,0x7bc18299,0x5183af75}},	//   наль, _wróc, kplu, куща,
   {{0x9f4301d0,0x26cfca86,0xb90680c2,0x59e08107}},	//   zují_, _bego_, _भय_, _निवर,
   {{0x4444309c,0x8e1485c2,0x48de052a,0x1e1495a4}},	//   my_, едиц, कृतो_, емия,
   {{0x753c0063,0x6a8397ae,0xe9d78d5f,0x3ea28106}},	//   _korz, _алта, _окт_, äkt_,
   {{0x4a578039,0x69c289ff,0x9f4301d0,0x6b840f45}},	//   _חשמל_, mpoe, vují_, _akig,
   {{0x44440f66,0xdb00ca87,0x973c8369,0xdb1b0198}},	//   ny_, _limí, _suću, istö,
   {{0xf6d68bca,0xa3e10e5b,0x3a26026c,0x26cf80c3}},	//   _آزاد, _दिस_, _šopa_, _gego_,
   {{0x44440775,0x51871507,0xc33382f6,0x527b80be}},	//   hy_, дува, דור_, ַנלא,
   {{0x44440a56,0x6e22948e,0x753c00ee,0x6b8402ec}},	//   ky_, _irob, _norz, _ekig,
   {{0x80d380c8,0x6e22816b,0x1fa70e63,0x140d0327}},	//   _সাম্, _hrob, драг, _सनेह_,
   {{0x2bd80996,0x5f940468,0x9f580247,0xf7700124}},	//   _डिजा, вист, ntrè_, لاق_,
   {{0x44440079,0x2005001b,0xd2520019,0x88bc81d0}},	// [3a90] ey_, ůli_, _منٹ_, _vněj,
   {{0x30150c8e,0x7d1abff4,0x6d48ca88,0x4444309c}},	//   _здор, ndts, nkda, fy_,
   {{0x44444a89,0xa3c90b9f,0xd3791bcf,0x36d50009}},	//   gy_, लीं_, suću_, _понр,
   {{0x309a0051,0x6d4e4a8a,0x9f4780e1,0x16350081}},	//   _משתמ, _elba, stnú_, _земя,
   {{0x753c4a8b,0x26cf92f5,0x7d18816d,0x44444a8c}},	//   _forz, _rego_, _oavs, ay_,
   {{0x44440f4c,0x6f0d0c64,0x61eb811f,0x41e080d4}},	//   by_, leac, rugl, _निरस,
   {{0x62868bc5,0x4444137c,0x61eb8042,0x673d01a1}},	//   _økon, cy_, sugl, _kosj,
   {{0x6f0d154c,0xee398dd3,0x6e228114,0xac940d15}},	//   neac, зни_, _brob, _расш,
   {{0xe1f0826a,0x68138201,0x6abb81bc,0x6e228115}},	//   _نسل_, _mədə, _ifuf, _crob,
   {{0xe00f0c69,0x3159990c,0x29cd4a8d,0x6f0d0ad0}},	//   ाबाद_, _علاج_, dža_, heac,
   {{0x26cf8d38,0x63a981cd,0x62898683,0x636802d0}},	//   _tego_, _kien, _hyeo, kınt,
   {{0x91e60256,0xf092807c,0x79854a8e,0x81d700ab}},	//   номе, _גנב_, _akhw, _সহজ_,
   {{0x6f0d154c,0x63a9892d,0x69d9ca8f,0xdc3b881d}},	//   deac, _mien, nswe, _išče,
   {{0x63a9ca90,0x6289ca91,0x6f1bc3ca,0x7bc193ac}},	//   _lien, _myeo, lduc, pplu,
   {{0x6e228063,0xf1dc0996,0x6f0d00f7,0x6b464a92}},	//   _zrob, _बिकन, feac, _lógi,
   {{0x44440a56,0x63a9ca93,0x6f0d4772,0xd252045b}},	//   vy_, _nien, geac, _منع_,
   {{0x44440d38,0x2b0020f2,0x9f584a94,0x69cd0114}},	// [3aa0] wy_, ष्णु_, ntré_, _gwae,
   {{0xa3e386a7,0x60d53cd4,0x98a582d6,0x69d989ff}},	//   _फटा_, cazm, _anlč_, dswe,
   {{0xdb1b2298,0x63a9ca95,0xdd8f187e,0x44444a96}},	//   rstö, _bien, حول_, uy_,
   {{0x444414e3,0x63a991b9,0x291a022e,0xa5bb016a}},	//   ry_, _cien, _hapa_, _irón,
   {{0x63a98f29,0x4444096a,0x05d48072,0xdcfc01a9}},	//   _dien, sy_, _धबधब, _ekrā,
   {{0x4444185c,0xa5bb007b,0x63a9ca97,0xdb040073}},	//   py_, _krón, _eien, _funç,
   {{0x2d980352,0x69c2a023,0x63a98687,0x69d98a53}},	//   _ihre_, spoe, _fien, aswe,
   {{0x291a4a98,0xa84780f7,0xdb0b00e8,0x7d18ca99}},	//   _lapa_, عليم_, _utfø, _savs,
   {{0x3cfd0540,0x6289810c,0x6b82ca9a,0x52cc81d0}},	//   र्वे_, _gyeo, moog, ारीस,
   {{0x291a4a9b,0x6b828006,0x63a98102,0x672bca9c}},	//   _napa_, loog, _zien, _engj,
   {{0xd498835f,0x6d48ca9d,0x22468019,0x6f19ca9e}},	//   ької_, rkda, lyok_, _fawc,
   {{0x6e2287e2,0x6f02ca9f,0x63a981c0,0x290ecaa0}},	//   _trob, _uboc, _xien, lefa_,
   {{0x291a1083,0x7d188214,0x6e2281ac,0x22468019}},	//   _bapa_, _tavs, _urob, nyok_,
   {{0xa3e10740,0x291a4aa1,0x290e8c0b,0x6b82af26}},	//   _दिल_, _capa_, nefa_, hoog,
   {{0x673d030b,0x6f0d0af9,0x1cb7812a,0xa5bb02ba}},	//   _posj, teac, _אלול_, _crón,
   {{0x68138201,0x2d8c816d,0x6b82b0be,0x7bdabfa4}},	//   _qədə, llde_, joog, mstu,
   {{0x6f0d1523,0x62350dca,0xf1a71fab,0x63a9caa2}},	// [3ab0] reac, _репу, _прон, _rien,
   {{0x6f0d154c,0x62898708,0x4ea403c7,0x442302f7}},	//   seac, _ryeo, урса, _prj_,
   {{0x63a9caa3,0x9cd78051,0x41b7000f,0x2d9e8fb0}},	//   _pien, גובה_, _इंडस, imte_,
   {{0x7bdacaa4,0x69d9caa5,0xeab08154,0xdb07caa6}},	//   istu, tswe, معه_, _bujá,
   {{0x63a9caa7,0xdb078125,0x22468065,0x213e8051}},	//   _vien, _stjó, gyok_, _both_,
   {{0xceb40086,0x7bdacaa8,0xfbd30154,0x26c94aa9}},	//   ndən_, kstu, _متر_, lbao_,
   {{0x63a9caaa,0xe7399687,0x69c087d9,0xac940196}},	//   _tien, дей_, _etme, _барш,
   {{0x2d8c8cfa,0x61e4bb2e,0x7bc501f6,0x2246808e}},	//   elde_, šila, mphu, byok_,
   {{0xb11580b3,0x81bb80ab,0xceb40085,0x7bdacaab}},	//   _имаш, _আটক_, kdən_, estu,
   {{0x637d0065,0xdb0e8511,0x7bda867f,0x6b460789}},	//   mény, _rubé, fstu, _jógv,
   {{0x9f5825bf,0x7bdacaac,0x316780b9,0x15f3064a}},	//   stré_, gstu, minz_, इंडर_,
   {{0x291a3204,0x069980f7,0x2d8ccaad,0x61fd4aae}},	//   _sapa_, _قناة_, alde_, ftsl,
   {{0x291a3f71,0x20d600e8,0xe29703c7,0xceb4011c}},	//   _papa_, ківс, каю_, fdən_,
   {{0x6e200da1,0x3f8d894d,0xf8d19a3b,0x6d478338}},	//   _ámbi, lleu_, हरिय, öjad,
   {{0x4879212c,0x5d7a83de,0x61fd1c11,0xb8ea03ca}},	//   естя_, _קאצק, atsl, _ऊभ_,
   {{0x27e501ac,0xa3e68beb,0xe8030697,0x1fe380ab}},	//   álna_, _पित_, _लहरा_, _মহাস,
   {{0x8fa31285,0x291a4aaf,0x07a310f8,0xdcfa80eb}},	// [3ac0] рате, _tapa_, ратн, lotā,
   {{0x64458006,0x63ae81a8,0xf29701c6,0x9f4302df}},	//   _ühis, _úiné, _בכפר_, rujá_,
   {{0x6b82cab0,0x66e60dca,0x213e8252,0xdcfa81a9}},	//   toog, _иона, _roth_, notā,
   {{0xf7460d0e,0xa5bb0035,0xb4ae86a7,0x41e68a4c}},	//   _ремо, _król, _कल्_, віка,
   {{0x6d8681fa,0x637d0061,0x333f8036,0x6b82cab1}},	//   iðar, gény, _doux_, roog,
   {{0x7bc50640,0x7bdacab2,0xf80680e8,0xdcfa81a9}},	//   bphu, ystu, вчин, kotā,
   {{0xb50206bf,0x9d1b00be,0x351b0039,0xdfd080f7}},	//   र्णय_, _קולט, _קולנ, حيب_,
   {{0x2d8786c0,0xe7e38105,0x290ecab3,0xceb40085}},	//   _akne_, _गिरा_, sefa_, zdən_,
   {{0x7d1c4ab4,0x7bdabdd7,0x68ed8019,0x69c08163}},	//   _kars, wstu, ándé, _utme,
   {{0xfe6f9301,0xf1dc0fea,0x7bdaad4d,0xdcfe00fe}},	//   تدى_, _बिजन, tstu, kopč,
   {{0xc0a980f7,0x2d9eb3fc,0xa5bb0032,0xa0a68081}},	//   _كامل_, rmte_, _aról, _ражд,
   {{0xe50203eb,0x7bdacab5,0xd5e2058c,0x7d1c0f06}},	//   र्ति_, rstu, _पिंज, _lars,
   {{0x29042828,0x7d1c011b,0x9b581cc7,0xa3e6aeff}},	//   đman_, _oars, тият_, यूज_,
   {{0x70bf0aed,0x6d86807b,0x61ef0503,0x7d1c4ab6}},	//   ्रेल, rðas, rucl, _nars,
   {{0xceb40201,0xd37b0fe7,0x224d1eee,0xdfd80098}},	//   rdən_, _очи_, šek_, кът_,
   {{0xd4378039,0x34cb2769,0x6568cab7,0x3eaf128d}},	//   _ירוק_, िर्द, lidh, øgt_,
   {{0x333fcab8,0x26c90bcf,0xe3b8811c,0x680a811c}},	// [3ad0] _roux_, rbao_, lqı_, _hədd,
   {{0x7d1c4ab9,0xbebb020f,0x2b8e803e,0x637d0019}},	//   _cars, _anët, lých_, vény,
   {{0x7d1c4aba,0x29114abb,0x6ca704bd,0x2ca70bd7}},	//   _dars, meza_, траж, änd_,
   {{0x2b8e8775,0x29112420,0x7d1c0706,0xd4980a95}},	//   ných_, leza_, _ears, тру_,
   {{0x7d1c4abc,0x63ad4abd,0xe1ff1355,0x64488114}},	//   _fars, _mian, ntó_, hydi,
   {{0x29114abe,0x7d1c4abf,0xd5fa0051,0x98c602a5}},	//   neza_, _gars, _אפשר, čući_,
   {{0x2b8e8ed7,0xccf20051,0x6142a3e7,0x3f84bebe}},	//   kých_, _לכם_, сеща, fomu_,
   {{0xe61994b7,0x63ad4ac0,0x4429976d,0x2911300f}},	//   еди_, _nian, _ča_, heza_,
   {{0x29111b83,0x2b8e816b,0x69dd00f3,0x6b9bcac1}},	//   keza_, dých_, jsse, _ihug,
   {{0x6f1d4ac2,0xdcfa8029,0x80ca873c,0x28ac800d}},	//   _lasc, totā, _स्पे, _चलचि,
   {{0x63ad0098,0x63b502a5,0x69dd4ac3,0x3f8480b8}},	//   _bian, _juzn, esse, bomu_,
   {{0x6f1d4ac4,0xc7b28039,0x63ad4ac5,0x3f84cac6}},	//   _nasc, _הבא_, _cian, comu_,
   {{0x63ad1ad4,0x6d868125,0xee2e8193,0x65688010}},	//   _dian, rðar, _ун_, bidh,
   {{0x2911300f,0xaca38135,0x660b80b9,0xe00f064a}},	//   geza_, _atụk, _ipgk, ाबंद_,
   {{0xdee6134e,0x63ad4ac7,0x2d85cac8,0x66e64ac9}},	//   лови, _fian, mole_, лова,
   {{0x63ad35db,0xd6d98035,0x80ca8c2d,0x2f552714}},	//   _gian, nał_, _स्ने, атус,
   {{0x7d1c014c,0x29114aca,0x7ae40289,0xceb284de}},	// [3ae0] _pars, beza_, _idit, מין_,
   {{0xdca62eb2,0x4427cacb,0x7d1c0be9,0x6b9bac18}},	//   гази, _krn_, _qars, _ahug,
   {{0x6f1d291e,0x69c40372,0x2d858037,0xd6d9866f}},	//   _fasc, _htie, iole_, kał_,
   {{0x7d1c4acc,0x2d858234,0x63b5007d,0x6b9b80f7}},	//   _wars, hole_, _duzn, _chug,
   {{0x673b8efd,0x298a8ae7,0x614694b7,0x7d1c4acd}},	//   djuj, нско_, леда, _tars,
   {{0xc27b00be,0xb605807a,0x6b89819d,0x2d85c902}},	//   ערסי, _mašč, _ekeg, jole_,
   {{0xa3e1090a,0x9f479b2c,0x2d85cace,0x7ae44acf}},	//   _दिए_, stný_, dole_, _odit,
   {{0x20d88110,0xdb1900e1,0x7ae42eae,0x29110b5e}},	//   džių_, _otvá, _ndit, zeza_,
   {{0x2b8e8ed7,0x70f684e3,0x80d380c8,0x63ad4ad0}},	//   vých_, _مسائ, _সার্, _rian,
   {{0x7ae42822,0x2d85cad1,0x551406a7,0x7bde00b9}},	//   _adit, gole_, ड़िए_, ospu,
   {{0x261405e8,0x6568cad2,0x291100fa,0x2b8e803e}},	//   नौती_, ridh, veza_, tých_,
   {{0x2911229b,0x291ecad3,0xb6058754,0xd4978196}},	//   weza_, _hata_, _bašč, ыры_,
   {{0x291ea7ba,0x29114ad4,0x2b8e803e,0x645a8065}},	//   _kata_, teza_, rých_, szti,
   {{0x2d85cad5,0xd379011f,0x6e93880b,0xe1ff285c}},	//   cole_, vrću_, _الها, rtó_,
   {{0x29110fb7,0x291ecad6,0x69c44ad7,0xe1ff4ad8}},	//   reza_, _mata_, _etie, stó_,
   {{0x2f1802c7,0x7bde0aa2,0x291ecad9,0xe1ff01ca}},	//   лось_, dspu, _lata_, ptó_,
   {{0x29112467,0xdb0e8144,0x59e090a1,0x63b500fe}},	// [3af0] peza_, _cubí, _निगर, _suzn,
   {{0x6b9bb3ed,0x291ecada,0x63a281e2,0x6f1d01ec}},	//   _shug, _nata_, emon, _wasc,
   {{0xb6058db7,0xc1740039,0x6f1d4adb,0x3a2902c4}},	//   _zašč, _לחץ_, _tasc, _hrap_,
   {{0xfbd00077,0xd2518013,0xf2960091,0x3a29000b}},	//   ستم_, ينا_, _abẹ́_, _krap_,
   {{0x291eb4b1,0xf1b98904,0xe704026a,0xa3c91094}},	//   _bata_, _krši_, _اسپی, लीज_,
   {{0xd6d98063,0x98ba0029,0x63b50503,0xa069bd93}},	//   wał_, _kopā_, _tuzn, кала_,
   {{0x6b9b8c64,0x2d858098,0x291ecadc,0x2f55cadd}},	//   _thug, vole_, _data_, итис,
   {{0x5ba48436,0x6b460118,0x2d85cade,0xddc98035}},	//   _груз, _lógr, wole_, cześ,
   {{0x291ecadf,0x00e5803d,0x4427c51b,0xdb0e8118}},	//   _fata_, _نتای, _srn_, _xubí,
   {{0x0565be41,0x291ecae0,0xd6d9809a,0xb6058289}},	//   рвон, _gata_, sał_, _rašč,
   {{0x2815803d,0x66160035,0xeb9a1073,0x3a294ae1}},	//   _خواس, zwyk, кио_, _arap_,
   {{0xe81b800f,0x291e80a4,0x34b20816,0x25ee8072}},	//   _भैया_, _zata_, _जल्द, _आमची_,
   {{0xed4ea64c,0x291ecae2,0x26cd816a,0x4427808e}},	//   _до_, _yata_, mbeo_, _wrn_,
   {{0x64a58f04,0x44278390,0xa5bb0035,0xdb158168}},	//   _кала, _trn_, _trój, _buzë,
   {{0x6d4391cd,0xa0a6280f,0x4427cae3,0x7bc380dd}},	//   _iona, равд, _urn_, _utnu,
   {{0x6e248754,0x3ebfbb5b,0x6d438102,0x70d1800d}},	//   _šibi, ncut_, _hona, हरुल,
   {{0x05664ae4,0x6b460013,0x6d43cae5,0x6f041ac6}},	// [3b00] аван, _fógr, _kona, rfic,
   {{0x6e24016a,0x6f044ae6,0x7bde4ae7,0xa3e1066f}},	//   rvib, sfic, tspu, _दिख_,
   {{0xe5020054,0x60dc4ae8,0xaaba03a4,0x161c8105}},	//   र्षि_, marm, _इलाक, _बैनर_,
   {{0x291e803a,0x60dc4ae9,0x7bde4aea,0xdb0e8118}},	//   _sata_, larm, rspu, _tubí,
   {{0x70d1800d,0xf8da00c2,0x320204e8,0xda63a42e}},	//   हरूल, _बजाय, ntky_, овци,
   {{0x63a2caeb,0x26c04aec,0x60dc007b,0x3f920683}},	//   smon, lcio_, narm, llyu_,
   {{0xd01081a8,0xb8deb26c,0xa8a38081,0x201a8037}},	//   سلة_, _इल_, орък, ìpi_,
   {{0x26c0100a,0x291e83c3,0x6d438ad0,0x9c828efc}},	//   ncio_, _wata_, _aona, _účin,
   {{0x291e81bf,0x6d43caed,0x60dc4aee,0x26c04aef}},	//   _tata_, _bona, karm, icio_,
   {{0x6d438cac,0x5d5481f3,0x60dc4af0,0x2b92016b}},	//   _cona, скот, jarm, lách_,
   {{0x60dc4af1,0x34b70039,0x3320009f,0x69c04af2}},	//   darm, יפים_, _baix_, ímen,
   {{0x2b920626,0x680a8201,0x6d438118,0x3d060f0a}},	//   nách_, _tədb, _eona, स्ते_,
   {{0x60dc4af3,0x6d43caf4,0x4cd580ab,0xee948019}},	//   farm, _fona, _দারু, _اداک,
   {{0x6d43caf5,0xc98700b3,0x224b016d,0x2b92016b}},	//   _gona, руми, ryck_, hách_,
   {{0xf1b98024,0x2b92026f,0x32021e1e,0x656f8866}},	//   _vrši_, kách_, atky_, èche,
   {{0x442d252d,0x6d43caf6,0xf77301ad,0x9f4301d6}},	//   _če_, _zona, زاز_, lujú_,
   {{0x61e48796,0x236906c0,0x442a4af7,0x60dc13c4}},	// [3b10] šilj, _imaj_, _arb_, barm,
   {{0xa2c9800d,0x60dc4af8,0x7afb8087,0x443a0216}},	//   हुन्, carm, _scut, fxp_,
   {{0xdcf8801b,0x92d900ab,0x320db581,0xf1cf90be}},	//   _skvě, ালী_, _spey_, _सौजन,
   {{0x26c00098,0x442a00ee,0x2121008e,0x9f4300e1}},	//   ccio_, _drb_, _hahh_, hujú_,
   {{0x442a4af9,0x6d5ac00d,0x3ebf82d0,0x6b8d0c53}},	//   _erb_, khta, vcut_, _mkag,
   {{0xe8f8804a,0xdcfc066f,0x2bd90180,0xf4350012}},	//   илі_, _okrę, _مارک_, _легэ,
   {{0x44254afa,0x442a00d2,0x3f6984ae,0x26d94afb}},	//   _él_, _grb_, лико_, _keso_,
   {{0xef198993,0x21210a84,0x7c25807b,0x7afb8b80}},	//   уми_, _lahh_, _áhri, _ucut,
   {{0xd4d98112,0x60dc4afc,0x80dd00ab,0x9f584afd}},	//   льні_, yarm, _বান্, ntrá_,
   {{0x3ebf93df,0x6b8d46d6,0x6d438085,0x987800d2}},	//   scut_, _akag, _qona, _ušća_,
   {{0xb8958013,0x40958013,0x6d43cafe,0x60dc4aff}},	//   _الاع, _الار, _vona, varm,
   {{0x60dc4b00,0x212134b1,0xa3ea0107,0x63b880fe}},	//   warm, _aahh_, _मिस_, _duvn,
   {{0x6d43cb01,0x5ea580ab,0x7c2a8192,0x998001f4}},	//   _tona, _গ্রে, _erfr, _ariš_,
   {{0x6d5a9301,0x3202016b,0x2c57811c,0x9f4301d6}},	//   chta, rtky_, hədə_, cujú_,
   {{0x26d94b02,0x3202026f,0x212100dd,0x2c578085}},	//   _beso_, stky_, _dahh_, kədə_,
   {{0x394580e4,0xdb1c84e8,0xdb028a53,0x2efd8901}},	//   _lols_, _otrá, rmoë, _jcwf_,
   {{0x644300f2,0x442a1024,0x2b921c18,0xf7430073}},	// [3b20] änin, _srb_, vách_, чето,
   {{0x23690503,0x26c04b03,0x61e4113b,0xd9100061}},	//   _zmaj_, scio_, _ivil, _تیس_,
   {{0xdb1ca336,0x61e40a38,0x2b92026f,0xe2caa0bf}},	//   _atrá, _hvil, tách_, глед_,
   {{0xd0488085,0xe73a4b04,0xf1b9842b,0x9f4300e1}},	//   _gedə, _сем_, _buš_, zujú_,
   {{0x672437d7,0x21210101,0x2b92016b,0xaeff8264}},	//   mdij, _yahh_, rách_, ্যাণ_,
   {{0x39459e9e,0x6f1600b9,0x64a61c8b,0x3ce781a1}},	//   _cols_, leyc, _гага, _ndnv_,
   {{0xa3f28a49,0x629b819d,0x3dc6b603,0x3d1402f1}},	//   _জন্য_, _ezuo, _stow_, ड़ीं_,
   {{0xb8ef97ba,0x26d9002a,0xf1b98140,0xc7b301c6}},	//   _व्_, _xeso_, _fuš_, הבה_,
   {{0x66040d66,0xa5bb00f7,0x03a381cf,0x50d680d7}},	//   ntik, _prói, _хито, _هزار,
   {{0xb9968013,0xa3b98f12,0x67240072,0x39459b26}},	//   _الطب, _अंश_, hdij, _gols_,
   {{0x69b2000f,0x61e42f2d,0x66040009,0x974300ce}},	//   _इंजी, _avil, htik, šćiv,
   {{0x6d5acb05,0x6724026c,0x75e1819d,0x04638190}},	//   shta, jdij, _ịzer, ятым,
   {{0x26d9047f,0x4e968c2b,0xc6968019,0x539b83de}},	//   _reso_, _اشار, _اشاع, טיטו,
   {{0x92d900ab,0x7c3eb60c,0x6023128a,0x69b0064a}},	//   ালে_, _àpro, jímá, ंदगी,
   {{0x26d92de9,0xf4848077,0xc8cf864a,0x67228326}},	//   _peso_, _باشی, _स्फट, _kaoj,
   {{0xd6d80ca0,0xe7f08744,0x6b8d1d22,0x764d4b06}},	//   йту_, _घटना_, _ukag, tyay,
   {{0xf77005ff,0x66040bb1,0x93bc8162,0x518701e5}},	// [3b30] راف_, gtik, zvăl, _гуна,
   {{0x2b921c18,0x61e29388,0x764d4b07,0x201ecb08}},	//   váci_, dsol, ryay, _osti_,
   {{0xdb1c9385,0xd2510416,0xf99404de,0x61e287cd}},	//   _strá, _رنگ_, _מרץ_, esol,
   {{0x394587fa,0xdb19016d,0x66040122,0x59d00b84}},	//   _sols_, _utvä, btik, तीकर,
   {{0x4cde8a49,0x6d588065,0x2c578201,0x61458ada}},	//   _মানু, _olva, rədə_, жела,
   {{0x60da8118,0x6e2d990f,0x2c57811c,0x2b92136f}},	//   _cetm, _šabo, sədə_, ráci_,
   {{0x394587fc,0xf9908154,0xddd6009a,0x5edd8264}},	//   _vols_, ربه_, czył, _যাবে,
   {{0x6d58cb09,0x6d474b0a,0xf1b9bc6d,0x290c84b7}},	//   _alva, _hoja, _tuš_, _ebda_,
   {{0x201eb819,0x9f5c801b,0x80caa769,0x60dacb0b}},	//   _esti_, ctví_, _स्वे, _fetm,
   {{0x6b8bbe9d,0xe5699630,0x80d380ab,0x60da8085}},	//   logg, риод_, _সাক্, _getm,
   {{0xca291a0f,0x61e40098,0x6d474b0c,0x66044b0d}},	//   _שם_, _svil, _moja, ztik,
   {{0x6d474b0e,0x672281c0,0x6d588f7c,0x6b8b867f}},	//   _loja, _gaoj, _elva, nogg,
   {{0x84e5a103,0xfce5964c,0x8d74a3f7,0x67244b0f}},	//   _долж, _доло, _کانا, vdij,
   {{0xa3ea101b,0x412a11d2,0x0d84b73a,0x28cf863a}},	//   _मिल_, шого_, _елін, _स्मि,
   {{0x1b0f00ab,0x96c7082e,0x75238c53,0x06ae8264}},	//   িয়ে_, _ụfọd, _ianz, ছুদি,
   {{0x66044b10,0x7ae98578,0x752380b4,0x61e40370}},	//   ttik, _ndet, _hanz, _tvil,
   {{0x6d47025b,0xee3a067c,0x7523cb11,0x92e900a0}},	// [3b40] _boja, шна_, _kanz, _طريق_,
   {{0x3a2017ea,0x90c308b0,0x3d140035,0xb17b0106}},	//   _isip_, _обье, ड़ें_, lsån,
   {{0x7523cb12,0x032695b5,0x29182104,0xf7464b13}},	//   _manz, жден, mera_, _дено,
   {{0x29184b14,0x7523840e,0x60da87e2,0xeb978009}},	//   lera_, _lanz, _setm, оих_,
   {{0xada601a1,0x3a2d81a1,0x6d471e67,0x6a1692c5}},	//   _мамл, _crep_, _foja, تبار,
   {{0x7ae9cb15,0x61e2b550,0xdb0b016d,0x6d470390}},	//   _edet, rsol, _utfö, _goja,
   {{0x29184b16,0x6f09cb17,0xd83a8048,0x60da80f1}},	//   iera_, ffec, рэл_, _vetm,
   {{0x29184b18,0x9c7c90d1,0x7523cb19,0xdb1ca3a6}},	//   hera_, nače, _aanz, _stræ,
   {{0x29184b1a,0x7523cb1b,0x63bc15d0,0x3a2dcb1c}},	//   kera_, _banz, _hurn, _grep_,
   {{0x7523cb1d,0x70b9035a,0xa06a8098,0x98a68878}},	//   _canz, _आलेल, _каза_, _дизе,
   {{0x63bc4b1e,0x7523c62f,0x3a20008e,0x201ecb1f}},	//   _jurn, _danz, _asip_, _usti_,
   {{0x63bc1cc5,0x25eb00d4,0xa5bb009a,0x9c7c811a}},	//   _murn, _चिली_, _krót, jače,
   {{0xa2bc050a,0x320682c4,0x2ee00140,0xe57a8087}},	//   _एलर्, ntoy_, daif_, _кзд_,
   {{0x29180542,0x752382af,0xd5af8558,0x3d140035}},	//   gera_, _ganz, _іс_, ड़ों_,
   {{0xd6db067c,0xa89914bc,0x20990d15,0x36d50103}},	//   ита_, скву_, сквы_, зобр,
   {{0x27ed04c4,0x7523822e,0x2d8ccb20,0x6d474b21}},	//   čen_, _zanz, lode_, _soja,
   {{0x29184b22,0x7c2e4b23,0x752383c3,0xe4cb019f}},	// [3b50] bera_, _arbr, _yanz, لبان_,
   {{0x80f501bb,0xa5bb03a8,0x2d8c929d,0xd7fb0012}},	//   _эпох, _asóc, node_, _кум_,
   {{0x5b159289,0x9c7c8024,0x290106cb,0xf8b1003d}},	//   змет, bače, _icha_, _سکس_,
   {{0x501a004c,0x3a2d82e6,0x2d8c8b48,0xe3b8373a}},	//   _פורו, _prep_, hode_, ібі_,
   {{0x6d4701a1,0x2d8c9a40,0x7f3a025f,0x6b8b8a53}},	//   _toja, kode_, _הערו, rogg,
   {{0x6b8bcb24,0x6d5e0192,0xe8b9275c,0x63bc15df}},	//   sogg, chpa, _आलोच, _furn,
   {{0x63bc4b25,0xb4d734ec,0x6b8b847f,0xa5bb09aa}},	//   _gurn, सरी_, pogg, _erót,
   {{0xd00e8013,0x636883bd,0x29184b26,0x7523cb27}},	//   الي_, _друг_, zera_, _sanz,
   {{0x28cf9a87,0x236d8ad4,0x29014b28,0x63bc4b29}},	//   _स्थि, _imej_, _ocha_, _zurn,
   {{0x9c7c80fe,0x29014085,0x6f09bb50,0x29184b2a}},	//   zače, _ncha_, sfec, xera_,
   {{0x7523cb2b,0xb97a80be,0xccf200be,0x317a80be}},	//   _vanz, _פרעז, עכט_, _פרעמ,
   {{0x29014b2c,0xe50b00c2,0x29184b2d,0x28cf8327}},	//   _acha_, स्ति_, wera_, _स्ति,
   {{0x7523cb2e,0xd2520019,0x442ea5d0,0xb6ba8e82}},	//   _tanz, رنس_, _erf_, _הצני,
   {{0x27f80039,0x7afd06a8,0x75238c53,0x442e8493}},	//   turn_, agst, _uanz, _frf_,
   {{0x29184b2f,0x2007b8e9,0x2f5601a1,0x8fa61eef}},	//   rera_, ntni_, птас, заве,
   {{0xb8f30076,0x63ba26d5,0x29014b30,0x9f5803ed}},	//   _ह्_, _étni, _echa_, murë_,
   {{0x63bc4b31,0x2ee000f7,0x9c7c812b,0x26dd81bc}},	// [3b60] _surn, raif_, rače, _mewo_,
   {{0x63bc21e5,0x20078968,0x6284008e,0x33248282}},	//   _purn, ktni_, _ixio, _samx_,
   {{0xa3dec19f,0x3f8d8118,0xd25280d7,0x61e60687}},	//   दीप_, koeu_, کنش_, lskl,
   {{0x2d8c8052,0xeb9a8009,0xa5bb4b32,0xaefb026b}},	//   zode_, щие_, _prót, _alùf,
   {{0x61e60338,0x63a41e3f,0x60de008e,0x61ed807a}},	//   nskl, _mhin, _kepm, šaln,
   {{0xe8949663,0xdb1c8004,0xf8be4b33,0x3206cb34}},	//   маль, _strä, ्डिय, rtoy_,
   {{0x2d8c803b,0x55f880c8,0x64a6221f,0xada31290}},	//   vode_, _অনেক_, _хава, _чарл,
   {{0x9634a748,0x442e826c,0x6449061c,0x63a4027d}},	//   дниц, _rrf_, çmiş, _nhin,
   {{0xa3de8b9f,0xbb3b8039,0x80dd00ab,0x798e02a0}},	//   दीन_, _פעמי, _বাস্, kobw,
   {{0x7c86908d,0x61e60b81,0x63a44b35,0x442e82df}},	//   зуме, dskl, _ahin, _prf_,
   {{0x9c7ccb36,0x63a41581,0xb4bcb011,0xbae100ab}},	//   dačc, _bhin, _अली_, _ভাবছ,
   {{0x63a44b37,0x29014b38,0x7ae2804f,0xaca3819d}},	//   _chin, _scha_, naot, _gwọk,
   {{0x63a402a3,0xb7e0800c,0xdb0400ff,0x60cb8061}},	//   _dhin, _गौतम_, _khiê, _élmé,
   {{0x6e22abd7,0x63b60748,0x442e82df,0x6d4a2b0d}},	//   _isob, _eiyn, _trf_, öfal,
   {{0xd90f0077,0xd5a5803d,0x7d1acb39,0x442e80b9}},	//   نیک_, _تلوی, mets, _urf_,
   {{0x63a40ad7,0x95d90081,0x6d5c4b3a,0xa2de0072}},	//   _ghin, ждат_, _alra, परण्,
   {{0x59b72279,0xf1d780c8,0x7aed011e,0x6d4acb3b}},	// [3b70] _इंटर, _সম্ভ, _idat, _kofa,
   {{0xdb040028,0xb4d734ec,0xb4c9016f,0x29014b3c}},	//   _nhiê, सरे_, ैरे_, _ucha_,
   {{0xa5bb008b,0x8c190c3b,0x9cd781c6,0xdb1ccb3d}},	//   _prós, تيار_, פואה_, _kurè,
   {{0x7d1aa5be,0x27e500e1,0xfaff0168,0x63a403ed}},	//   hets, álnu_, ngë_, _xhin,
   {{0x7d1acb3e,0x539c0039,0x6f0d4b3f,0x6e22cb40}},	//   kets, זיאו, mfac, _nsob,
   {{0x7d1a82fd,0xdb04001c,0x6f028118,0x67260fbc}},	//   jets, _chiê, _acoc, _zakj,
   {{0x29c287ca,0x7aed2503,0xdb1c8082,0x28de8105}},	//   _eða_, _odat, _strå, _नजरि,
   {{0x6f0d0352,0x80380039,0x3eb98aa2,0x20079b39}},	//   nfac, לנוע_, øst_, rtni_,
   {{0x2007b118,0x63a44b41,0x61e48013,0x6adc00ab}},	//   stni_, _rhin, áilt, _ভালো,
   {{0x7aed4b42,0x7d1a82a0,0xa2c99d17,0x6d4acb43}},	//   _adat, gets, हुर्, _cofa,
   {{0x68e3cb44,0x63a44b45,0xceb40085,0x69cd4b46}},	//   mand, _phin, ndər_, _atae,
   {{0x68e3b396,0x61e980e8,0xe29a4b47,0xdb0a81d6}},	//   land, _kvel, жам_, _šnúr,
   {{0x7d1a84b8,0x27e0a3e3,0xa3b9a539,0x7aed031d}},	//   bets, ćine_, _अंक_, _ddat,
   {{0x25ee000f,0x63a43c32,0x6d4a831d,0xb4d70441}},	//   ेंसी_, _whin, _gofa, सरो_,
   {{0x63a40051,0x6609cb48,0x672601ed,0x7aed0372}},	//   _thin, ltek, _pakj, _fdat,
   {{0x7e7b4573,0x61e9cb49,0x6729cb4a,0xe82080c2}},	//   _župa, _ovel, ndej, _मनसा_,
   {{0xdd9207bd,0x80dd00c8,0x6609cb4b,0x68e385d1}},	// [3b80] نور_, _বার্, ntek, kand,
   {{0x68e3cb4c,0x443101dd,0x442300b9,0xa5bb0511}},	//   jand, _brz_, _bsj_, _prór,
   {{0x68e3cb4d,0x6726403c,0x6f0d0122,0x61e98e5a}},	//   dand, _takj, bfac, _avel,
   {{0x9c7c803a,0x6729cb4e,0xaefb0362,0x65c61198}},	//   nača, jdej, _clùd, _обма,
   {{0xa3de023c,0x68e3cb4f,0xdb040028,0x61e98088}},	//   _दौर_, fand, _phiê, _cvel,
   {{0x68e3cb50,0x6da62262,0x6f0281e8,0x7ae29b88}},	//   gand, _цига, _scoc, saot,
   {{0x9c7c8267,0xa3b9970c,0xd5ad0019,0x443100e5}},	//   kača, _अंग_, _اہل_, _grz_,
   {{0x9c7c803b,0xdca30ab2,0x6d4a9277,0x61e94b51}},	//   jača, _раси, _sofa, šeli,
   {{0xf8cf8aed,0xdb040028,0x6609b9ad,0x9c7c856f}},	//   _स्वय, _thiê, gtek, dača,
   {{0x7afd91bf,0x657e01a8,0x7ae08106,0x7bdc010c}},	//   _östr, nnph, _hemt, _kwru,
   {{0x291ccb52,0x7d1acb53,0x69c0cb54,0xfa1300ab}},	//   meva_, rets, _hume, িয়াল_,
   {{0xee3a93cd,0x69c09167,0x291c94c7,0x7d1a932e}},	//   _мне_, _kume, leva_, sets,
   {{0xf2d38158,0x69c0cb55,0x6d4a822e,0x5eac80ab}},	//   כער_, _jume, _tofa, _ট্রে,
   {{0x69c0cb56,0x291ccb57,0xdb1c82be,0xceb40085}},	//   _mume, neva_, _duré, ydər_,
   {{0x69c0cb58,0x9c7c9123,0xa5bb0032,0xa3ea064a}},	//   _lume, bača, _aróp, _मिग_,
   {{0x7ae0cb59,0xb4d7016f,0x4423008e,0xaefb026b}},	//   _nemt, सर्_, _rsj_, _amùr,
   {{0x68e3cb5a,0x69c0a91e,0xdb008511,0xf1a70088}},	// [3b90] yand, _nume, _limó, _орон,
   {{0x291ca3e3,0x15f3035a,0xd49b0284,0x6e2d3a65}},	//   jeva_, ेंबर_, оре_, rvab,
   {{0x7527020f,0x291ccb5b,0xf48500d5,0x66098102}},	//   _vajz, deva_, رائی, ztek,
   {{0x68e3b8ba,0x69c0930e,0x395ecb5c,0x3d0e9f1c}},	//   wand, _bume, _alts_, त्ते_,
   {{0x68e3cb5d,0xdb1c802a,0xe5c40198,0xeb9200be}},	//   tand, _xuré, _ассо, אָג_,
   {{0xa0a5a155,0x25b80add,0x7c3a042b,0xe8e000ff}},	//   налд, _girl_, _štre, _kiều_,
   {{0x7ae08e23,0x1fb58d69,0xdb008118,0x442300b9}},	//   _femt, нсир, _cimó, _usj_,
   {{0x69c0bd02,0x491b800d,0x9f582ad5,0xa295902a}},	//   _fume, _यसको_, turé_, _забі,
   {{0x68e39c40,0x61e9b28b,0x69c0cb5e,0x6729bfd7}},	//   pand, _uvel, _gume, rdej,
   {{0x6609cb5f,0x291ccb60,0x7bc800e7,0x61fd4b61}},	//   rtek, ceva_, _éduc, dusl,
   {{0x6609cb62,0xeb9a0056,0x9f580036,0x9c7c81a1}},	//   stek, зин_, suré_, tača,
   {{0x68e18e20,0x6609cb63,0xdb1c98cc,0xd6d9866f}},	//   _held, ptek, _puré, ykły_,
   {{0x7e7b4573,0x68e1bfc9,0x632200ab,0x61fd02f1}},	//   _župn, _keld, যালয়_, gusl,
   {{0x9c7c84e8,0xdb190087,0x68e1a6af,0xade302f1}},	//   mačn, _cuvâ, _jeld, गठनन_,
   {{0x9c7c9f95,0x0396017a,0x68e1977a,0xfbc6800d}},	//   lačn, _прия, _meld, _रूपम,
   {{0x28d00ebf,0xa5bb0073,0x20050722,0x291c80d2}},	//   _त्रि, _próp, àlia_, zeva_,
   {{0x61ed8d11,0x9c7c803a,0xc7b2812a,0x7ae64b64}},	// [3ba0] šalj, načn, רבן_, makt,
   {{0x2cbc004a,0x6aa40234,0x26cb0037,0x7ae0cb65}},	//   øvd_, _izif, _efco_, _semt,
   {{0x69c0cb66,0x66e60b9c,0xdee61b3f,0x291ccb67}},	//   _sume, _пона, _пони, veva_,
   {{0x9c7c826f,0xb4bc864a,0xaca401bc,0xe1ff002a}},	//   kačn, _अल्_, _nrụr, izón_,
   {{0x291ca49a,0x68e1cb68,0xdb00957a,0x395e808e}},	//   teva_, _beld, _simó, _plts_,
   {{0x6b841487,0x6fc78214,0xaca40135,0x68e18661}},	//   _ljig, _sıca, _arụr, _celd,
   {{0x64a34b69,0xdca31ddf,0x7ae64b6a,0x291ca420}},	//   _бара, _бари, kakt, reva_,
   {{0x69c0b202,0x4444022b,0x6d4e4b6b,0x59dd801b}},	//   _tume, mx_, _hoba, नीहर,
   {{0x291ccb6c,0x9c7ca19f,0x44444b6d,0x68e1cb6e}},	//   peva_, gačn, lx_, _feld,
   {{0x68e1cb6f,0xdb00a620,0xc0aa9459,0x6d4e4b70}},	//   _geld, _timó, _فاضل_, _joba,
   {{0x7ae628d2,0x6d4e3fab,0x236000f3,0x44444b71}},	//   fakt, _moba, _blij_, nx_,
   {{0x4444252f,0x61fd2cb0,0x5fb40424,0x68e1cb72}},	//   ix_, tusl, ंगफल, _zeld,
   {{0xf99f06c0,0xc33384de,0xe1ff0118,0x3f800035}},	//   stèm_, אור_, azón_, dniu_,
   {{0x7d1e02a5,0x2b840457,0x6d4e4b73,0x6b840135}},	//   jeps, rıca_, _noba, _ejig,
   {{0x7d1e4b74,0x6aa40c6a,0x97a71510,0xa0c401a8}},	//   deps, _ezif, ерал, ايفو,
   {{0x5f94038b,0x7ae64b75,0x7c9b810f,0x4444022b}},	//   гист, cakt, _משוג, dx_,
   {{0x6d4e2c65,0x444419e7,0x80e18264,0x2b9c928a}},	// [3bb0] _boba, ex_, _নাস্, mích_,
   {{0x6d5acb76,0x44444b77,0x6b9d2900,0x61ed4b78}},	//   nkta, fx_, llsg, _ival,
   {{0x9c7c826f,0xa5bb002a,0x5f0c00d4,0xdbdb9727}},	//   začn, _isóm, _डॉक्_, _yáñe,
   {{0x2b9c800d,0x68e70019,0x68e1c0de,0x29030357}},	//   ních_, lajd, _seld, lgja_,
   {{0x22588009,0xaa58960f,0xe1ff01ca,0x68e181a9}},	//   ницы_, ницу_, nuó_, _peld,
   {{0x865a0bea,0x29031805,0x6d4e4b79,0x7ae64848}},	//   _חדשי, ngja_, _goba, zakt,
   {{0xe8e00028,0x68e18357,0x660d0956,0x7ae6004a}},	//   _hiểu_, _veld, ltak, yakt,
   {{0x6d4e0063,0xee398139,0x672d4b7a,0xe8e00028}},	//   _zoba, дни_, ndaj, _kiểu_,
   {{0x27e08025,0x0d858e8e,0x338488d5,0x68e1cb7b}},	//   ćina_, клин, _сурв, _teld,
   {{0xb2748468,0x9c7c803e,0x41b584c0,0x7ae60057}},	//   _слуш, račn, _شمار, wakt,
   {{0x80ca904f,0x61ed20a5,0x63bb804f,0x9c7c80e1}},	//   _स्टे, _aval, _kiun, sačn,
   {{0x9c7c8968,0x2cb00085,0xe1ff2c92,0x628c8035}},	//   pačn, ündə_, rzón_, żnoś,
   {{0x2d8701ac,0x63bba810,0x63660118,0x63a98428}},	//   čnej_, _miun, _lóng, _mhen,
   {{0x7ae6272f,0x29030357,0xdb0b4b7c,0x673d0197}},	//   sakt, ggja_, _bufó, _ansj,
   {{0x66e619b8,0xdee6257e,0x6d4e4b7d,0xc0e311b3}},	//   кова, кови, _roba, роск,
   {{0x2b9c83cb,0x660d1c66,0xe8e00028,0xd5c302f1}},	//   cích_, ftak, _biểu_, _वंशज,
   {{0x6d4e4b7e,0x660d1d23,0x672b80f1,0x7bc3a7f3}},	// [3bc0] _poba, gtak, _magj, _hunu,
   {{0x63a9a087,0x44444b7f,0x7bc38010,0x7ae40e20}},	//   _ahen, tx_, _kunu, _heit,
   {{0x444406e3,0x61ed0052,0x660d4b80,0x272192c7}},	//   ux_, _zval, atak, _मसूर_,
   {{0x7bc39a5a,0x44444b81,0x63a99c40,0x7d1e4b82}},	//   _munu, rx_, _chen, seps,
   {{0x7ae44b83,0xa96a97f4,0x63bb81fb,0x63a9cb84}},	//   _meit, мида_, _diun, _dhen,
   {{0x7ae44b85,0x7e69cb86,0x2b9c81d0,0x442784e8}},	//   _leit, dzep, zích_, _osn_,
   {{0x8c43028e,0xebe32a98,0x7bc3cb87,0x2d98026c}},	//   _кере, _восп, _nunu, _ikre_,
   {{0x63bbcb88,0x6f044b89,0x59dd8740,0x03a686a1}},	//   _giun, ngic, _नौकर, _рибо,
   {{0xf7730051,0xdb1ccb8a,0x9c7c826f,0x692680a9}},	//   יקה_, _jurí, tačo, _имаа,
   {{0x7bc3cb8b,0x63a9cb8c,0x6b82882c,0x73d882fb}},	//   _bunu, _zhen, lnog, ндор_,
   {{0x7ae4034a,0x6d5a80e3,0x68e72c08,0xaf06cb8d}},	//   _beit, rkta, vajd, _апел,
   {{0x3f8081e2,0x7ae40083,0x16dc016f,0x7bc3cb8e}},	//   čius_, _ceit, बरोब, _dunu,
   {{0x3ea08013,0x7ae41c10,0x7c3e826c,0x2b9c81a8}},	//   _áit_, _deit, _šprd, rích_,
   {{0x3cfe0c87,0x66008057,0x28c6940d,0x6b828428}},	//   _लागे_, mumk, रुचि, hnog,
   {{0x7ae44b8f,0x7bc38397,0x4fc40391,0x212c820f}},	//   _feit, _gunu, иста, _madh_,
   {{0x2d9eae76,0x3d0e816f,0x61ed943c,0x2d9802c4}},	//   llte_, त्रे_, šali, _akre_,
   {{0x636605a4,0x6b82805c,0x61ed4b90,0x63bb8081}},	// [3bd0] _dónd, dnog, _uval, _riun,
   {{0x7c3a025b,0x63a9cb91,0x7ae40352,0x63bb827e}},	//   _štra, _shen, _zeit, _siun,
   {{0x2d9e8ad0,0x6b82831d,0xd49b4184,0x660d4a2b}},	//   ilte_, fnog, фра_, stak,
   {{0x7ae4062f,0x4ea701e2,0xe8e00028,0x2d9e81ec}},	//   _xeit, _арга, _tiểu_, hlte_,
   {{0x63bb8010,0x2ee90359,0xad9b0118,0x2175b160}},	//   _viun, maaf_, _opúx, лукр,
   {{0x776284c3,0x02a3019d,0x2ee94090,0x3f868242}},	//   _alox, _arịọ, laaf_, _ajou_,
   {{0xd4980190,0x68e50965,0x101581a8,0x212c8a2a}},	//   _арт_, _mehd, ابتد, _dadh_,
   {{0x68e50009,0x7bc3cb92,0xd10580dc,0x212c8219}},	//   _lehd, _runu, _रावण_, _eadh_,
   {{0xa3e7101b,0xdb1c84c3,0x7bc3cb93,0x799500b4}},	//   _मौत_, _xurí, _sunu, kozw,
   {{0x7ae44b94,0x7762cb95,0x7bc3cb96,0x2ee94b97}},	//   _seit, _elox, _punu, haaf_,
   {{0x7ae44852,0x7bc3828d,0x3b0a177f,0x672b8061}},	//   _peit, _qunu, нено_, _tagj,
   {{0x67209351,0xa2aa904f,0x63760115,0xe61180d7}},	//   cemj, जेक्, ršno, _هشت_,
   {{0x7ae40125,0x68e5026c,0x06b180ab,0x69c43f55}},	//   _veit, _behd, _ট্রি, _quie,
   {{0x7ae436e3,0x7bc3cb98,0xfce58dc9,0xdb19006a}},	//   _weit, _tunu, _соко, _nuvæ,
   {{0xb4df8576,0x7ae4031d,0x4427a20e,0x63660118}},	//   तरी_, _teit, _usn_, _pónd,
   {{0xfbd28051,0x80d41053,0x6e3b0bcf,0x26cd9ed4}},	//   _פתח_, _ब्रे, _šuba, nceo_,
   {{0x22460179,0x36674b99,0x6b82812b,0x0d861a4a}},	// [3be0] _çok_, гато_, vnog, глан,
   {{0x04460ba5,0x6e2409ca,0x8c461508,0x636607f1}},	//   лезн, rwib, лезе, _dóne,
   {{0x98a8000d,0xf8a8000d,0x6b828140,0x212c851e}},	//   _गरिए, _गरिय, tnog, _radh_,
   {{0xe51381c4,0x25e80540,0xdb1ccb9a,0x7c3ecb9b}},	//   त्ति_, _चौथी_, _turí, _ápre,
   {{0x320201ac,0x5b7b00be,0xf1bf2792,0x2d9e821e}},	//   nuky_, ערנא, lvár_, ylte_,
   {{0x6b8282ce,0xa5bb002a,0x75218019,0x31348c4f}},	//   snog, _apóf, jelz, рекр,
   {{0xfaff00f1,0x8d630320,0x27e081a1,0x6720a157}},	//   dhën_, _увре, ćino_, temj,
   {{0x442a056c,0x9f549156,0x998d8087,0x17548081}},	//   _isb_, рвич, _preţ_, рвия,
   {{0x28cf8540,0x6ce6a133,0x998900e1,0xe4e6bf56}},	//   _स्कि, ліне, _hrať_, лінн,
   {{0x98ba0176,0x752194cf,0xf1bf4b9c,0xf28bb5c4}},	//   _anpč_, gelz, kvár_, _אָבֿ,
   {{0x9c7c803b,0x9f5806a5,0x2cb8816d,0xe7b4015c}},	//   mačk, ntró_, ärd_, ंगाप,
   {{0x78a8a3e3,0x3d140f97,0x442a4b9d,0xda350009}},	//   _izdv, न्ते_, _msb_, аемы,
   {{0xed5a8544,0xa77b80be,0x442a01e0,0x629e8035}},	//   _под_, _אראפ, _lsb_, ępow,
   {{0x9c7c803b,0x44384b9e,0xceb383c8,0x442a0558}},	//   načk, _orr_, _פיס_, _osb_,
   {{0xe3b00416,0x657acb9f,0x65688c5e,0x442a4ba0}},	//   تری_, mith, mhdh, _nsb_,
   {{0x657acba1,0xf40a00ab,0x7c2acba2,0x9c7c9249}},	//   lith, রবার_, _isfr, hačk,
   {{0x68e519e0,0x63ad4ba3,0x442a079f,0x557506e6}},	// [3bf0] _tehd, _ihan, _asb_, агат,
   {{0x9c7c82a5,0x63760353,0x046701a1,0x657acba4}},	//   jačk, jšnj, лтем, nith,
   {{0x2ca70e23,0x9c7c826f,0x63ad4ba5,0x752e0326}},	//   ånd_, dačk, _khan, _dabz,
   {{0xd49846a1,0x20030b20,0x442a4ba6,0xbe050065}},	//   уру_, muji_, _dsb_, _پوسٹ,
   {{0x63ad4ba7,0x81c780eb,0x442a008b,0x657a879d}},	//   _mhan, klēš, _esb_, kith,
   {{0x657a80f1,0x9c7ccba8,0x63ad4ba9,0x645a84f6}},	//   jith, gačk, _lhan, kyti,
   {{0x5ba78767,0x63ad4baa,0x657a90fa,0x315804de}},	//   _браз, _ohan, dith, ריון_,
   {{0x63ad0028,0x7bd5011e,0x61fd2329,0x657a8428}},	//   _nhan, _itzu, krsl, eith,
   {{0x9c7ccbab,0x9f4c4bac,0x7bc74bad,0xa3e78540}},	//   bačk, édé_, _huju, मीन_,
   {{0x7bc73e18,0xb4dfb792,0x8d5589e0,0x63ad02a0}},	//   _kuju, तरे_, ртич, _ahan,
   {{0xcb6a0021,0x64a59908,0xe8e00028,0x7bc7059c}},	//   ване_, рана, _hiệu_, _juju,
   {{0x63ad3693,0x661d45f8,0xfaff00f1,0x7bc74bae}},	//   _chan, _opsk, shën_, _muju,
   {{0x63ad4baf,0x6db2809a,0x7bc74bb0,0x657a81f6}},	//   _dhan, _płat, _luju, bith,
   {{0x2907cbb1,0x657acbb2,0x63ad0114,0x3202016b}},	//   ngna_, cith, _ehan, ruky_,
   {{0xb8ce22db,0x661d0df1,0xe8e00028,0x6b9b8c56}},	//   _और_, _apsk, _liệu_, _okug,
   {{0x63ad3343,0x2b404bb3,0x7aeba5dd,0x6b9bcbb4}},	//   _ghan, _unic_, jagt, _nkug,

   {{0x539b0039,0x7aeb81b0,0xc4e60198,0x7bd507f1}},	// [3c00] _ביקו, dagt, ижай, _atzu,
   {{0x63ad23ac,0x845a3314,0x7bc74bb5,0x752e4bb6}},	//   _zhan, крет_, _buju, _qabz,
   {{0x9c7c812b,0xb4d60063,0x0c261e25,0xf0aa17ae}},	//   vačk, _सभी_, рмен, _школ_,
   {{0x657a805d,0x9f58023e,0x6d5e06ae,0x61e44a4e}},	//   zith, rtró_, skpa, _kwil,
   {{0x2d828019,0x9f581e21,0x657a8234,0x9c7c936f}},	//   ékek_, stró_, yith, tačk,
   {{0x442a4bb7,0x61e40010,0xe8e000ff,0xdb1c9820}},	//   _tsb_, _mwil, _diệu_, _durá,
   {{0x9c7c803b,0x6b5f00f1,0x68eacbb8,0x44381929}},	//   račk, _dëgj, rafd, _urr_,
   {{0x7aeb8079,0x2ca71f8e,0x03d70039,0xd1388035}},	//   cagt, ünde_, _כולם_, _skąd_,
   {{0x9c7ccbb9,0x63ad031d,0x657a8174,0x70f69ddd}},	//   mači, _rhan, tith, _نسائ,
   {{0x9c7ccbba,0xa9068077,0x7bc084a7,0x21a68162}},	//   lači, _خبرن, _himu, _тизм,
   {{0x657a8013,0x7bc0b7c6,0x44388feb,0x63a280e5}},	//   rith, _kimu, ír_, olon,
   {{0x68e8cbbb,0x657acbbc,0x9c7c93b3,0x64410118}},	//   _hedd, sith, nači, _álie,
   {{0x645acbbd,0x7bc0cbbe,0xda780071,0x27e9812b}},	//   syti, _mimu, аяр_, ćane_,
   {{0x7af6009a,0x63a28234,0x63ad4bbf,0x7e6d007a}},	//   _edyt, hlon, _whan, vzap,
   {{0x68e8bc4e,0x63a28289,0x63ad4bc0,0x6db28063}},	//   _medd, klon, _than, _włas,
   {{0x7bc7288e,0x501b8051,0x9c7c811f,0x68e888f3}},	//   _ruju, כולו, jači, _ledd,
   {{0x7a1a80eb,0xba0180ab,0x63a2cbc1,0x68e88114}},	// [3c10] nātā, _এন্ড_, dlon, _oedd,
   {{0x7bc70748,0x6b9b9020,0x68e88365,0x3cec826c}},	//   _puju, _skug, _nedd, nadv_,
   {{0x63660065,0x6b89882c,0x7bc08f8e,0x5c070081}},	//   _hóna, _pjeg, _bimu, ряза,
   {{0x9c7c8025,0x41c4003d,0x63a2c4cf,0xbd05846d}},	//   gači, _دقیق, glon, _adẹ́,
   {{0x19598110,0x7bc74bc2,0x7bc08be6,0xab5da358}},	//   лады_, _wuju, _dimu, _niże,
   {{0x7bc7028a,0x63a2c1cb,0x98ac83bf,0x6366016a}},	//   _tuju, alon, _aldı_, _móna,
   {{0x63a2866b,0x7aeb97ea,0x680a8085,0x7bce957a}},	//   blon, pagt, _sədr, íbul,
   {{0xbb858013,0x438580f7,0x9b94a255,0x6b9ba6bd}},	//   _الري, _الرق, _дисц, _ukug,
   {{0x68e88114,0x290c8326,0x163981a8,0xa7628081}},	//   _fedd, _fcda_, اسبة_, якъд,
   {{0x4d65ae7b,0x3a2d808e,0x6d5503ec,0x7c3e8988}},	//   сков, _isep_, _joza, _špra,
   {{0x69c9808e,0xd05c0085,0xaefb026b,0x3f58841c}},	//   _huee, barə, _alùm, _céus_,
   {{0x69c19c37,0x6d41007b,0x291a00ee,0x60c54bc3}},	//   _hile, _ólaf, _sbpa_, _aghm,
   {{0xe1ff1355,0x69c1cbc4,0x636600f7,0x3f9d8135}},	//   gró_, _kile, _cóna, _ikwu_,
   {{0x2bcf8894,0xe50303bb,0x7ae9a444,0x6d5500eb}},	//   _संपा, _लागि_, _leet, _noza,
   {{0x6d43af9c,0x05748277,0x201e24df,0x98a612ea}},	//   _inna, _باند, ïti_, сиве,
   {{0x6f09a6db,0x69c19c66,0xa3e781a2,0xe1ff4bc5}},	//   ngec, _lile, मीण_, bró_,
   {{0xee3a25c6,0x69c18083,0x6e29cbc6,0x6b998079}},	// [3c20] ына_, _oile, nweb, dowg,
   {{0x7bc09219,0x66040cfa,0xd05c0085,0xa3de9521}},	//   _simu, ruik, zarə, दीक_,
   {{0x68e8805f,0x63a2809c,0xd5c8801c,0x3a2d81bf}},	//   _redd, tlon, _nền_, _asep_,
   {{0x387a8201,0x69c1cbc7,0xaca38133,0x68e8cbc8}},	//   _üzrə_, _aile, _atịk, _sedd,
   {{0x7ae999a8,0x9c7cb5aa,0x6d550118,0x63a2cbc9}},	//   _deet, rači, _foza, rlon,
   {{0xdd9215e4,0x6d554bca,0xe6e08054,0x69c1cbcb}},	//   _روز_, _goza, नर्ज, _cile,
   {{0x7bc0878a,0x69c18b23,0x2c1c00c2,0x657e0234}},	//   _timu, _dile, _नहिं_, miph,
   {{0x6d43aa4c,0x69c18046,0x2d9a4bcc,0x7ae9cbcd}},	//   _anna, _eile, lope_, _geet,
   {{0xa5bb0510,0x2cea8987,0x6d551a14,0x68ee00b9}},	//   _próx, льно_, _yoza, kabd,
   {{0x8e5700be,0x3f9d8870,0x657e005d,0x68ee00b9}},	//   צייג_, _ekwu_, niph, jabd,
   {{0xfaff020f,0xaf0a89d7,0x80a692c8,0xa5bb12ca}},	//   shëm_, _مقام_, _امان, _isót,
   {{0x6d43b755,0x69c1aef9,0xe1ff4bce,0x657e164d}},	//   _enna, _zile, tró_, hiph,
   {{0xc7978065,0x5e5a9459,0xbc67804e,0x363680f7}},	//   _اپنا_, _حجاج_, لمین_, _دراس,
   {{0x69c1cbcf,0xfbcf9e29,0xe1ff4bd0,0x7bdacbd1}},	//   _xile, بتی_, rró_, pptu,
   {{0x6d554bd2,0xdbe283a8,0x115b80be,0x2bcf852a}},	//   _roza, _téñe, נדלע, _संया,
   {{0x28d92539,0x443f0669,0x442ecbd3,0x9f051c81}},	//   _ब्रि, _ču_, _isf_, تورو,
   {{0x67d18029,0x7ae9cbd4,0xa2a04476,0x443ca4b9}},	// [3c30] _māja, _reet, _गुप्, _hrv_,
   {{0x7bca874b,0x7ae9cbd5,0x443ca8fc,0x6eff026b}},	//   _kufu, _seet, _krv_, _bàbà,
   {{0x6d55003b,0x69c1cbd6,0x7ae98650,0xa5bb0333}},	//   _voza, _rile, _peet, _apóc,
   {{0x2564016d,0x1dc883eb,0x7aef4bd7,0x7bcacb40}},	//   _höll_, रदात, nact, _mufu,
   {{0x2bcf83b7,0x6d5509ab,0x7c2e4bd8,0x7ae982f1}},	//   _संभा, _toza, _esbr, _veet,
   {{0x7ae9cbd9,0x6b8d017f,0x657e4bda,0xdb0d003d}},	//   _weet, _ljag, ciph, _dhaé,
   {{0xb4e50f12,0x02fb3852,0x69c1cbdb,0xa2a018a9}},	//   नरी_, ्लाह_, _vile, _गुन्,
   {{0xf7718250,0x3f890355,0x27e501ac,0x23cf86b7}},	//   بات_, nnau_, álny_, _संबद,
   {{0x14da9880,0x7aef4bdc,0x442e8358,0x645c8bc5}},	//   _म्हण, dact, _asf_, ørin,
   {{0x6b8d4bdd,0x2bb99664,0xe579981f,0x442e8388}},	//   _ajag, ेदवा, рзо_, _bsf_,
   {{0x3a2021bf,0x443c82f7,0xa34a1a19,0x1b4a0ae7}},	//   _spip_, _crv_, азна_, азни_,
   {{0xeaba01e8,0x2007cbde,0xe51900bc,0x920d8744}},	//   ийн_, muni_, न्ति_, _समाज_,
   {{0x3dd901c0,0x2007cbdf,0xe7968019,0x657e0234}},	//   _ntsw_, luni_, _بالک, yiph,
   {{0x6f1d02af,0x6aad4be0,0xfd52019d,0x200c023e}},	//   _absc, _dzaf, _dajụ, àdio_,
   {{0x2007cbe1,0x2918054f,0x7bcacbe2,0x68ee4be3}},	//   nuni_, rfra_, _gufu, rabd,
   {{0x3f891670,0xa3de82f1,0xa3cd0327,0x2087004a}},	//   gnau_, दीओ_, रदन_, ійти_,
   {{0x27e08025,0xbea312ef,0xee373c20,0x2007a577}},	// [3c40] ćini_, датк, онт_, huni_,
   {{0x6f1d4be4,0x20079bb7,0x645e4be5,0x443c80b9}},	//   _ebsc, kuni_, typi, _yrv_,
   {{0x2007cbe6,0x657e4be7,0x2127826c,0x7ac69e9d}},	//   juni_, riph, denh_, осле,
   {{0xeb9a8ca4,0x8cda00d4,0xe73a0009,0x3e7002be}},	//   шие_, _प्रो, _тем_, _côté_,
   {{0x094a9445,0xee371663,0x27ed0024,0x914aabf3}},	//   ички_, _дня_, ćene_, ичка_,
   {{0xaca391d3,0x661603ba,0x2007a198,0x7aef0087}},	//   _atọk, mtyk, funi_, zact,
   {{0x64a30a42,0xdca30cec,0x2007b8dc,0xdb0f026f}},	//   _жара, _жари, guni_, ždéh,
   {{0x3b078ae7,0x7bca818e,0x7bde0198,0x29008162}},	//   _месо_, _rufu, mppu, şia_,
   {{0xc7b31a0f,0x799c0578,0x27e9805c,0xed8ac81b}},	//   ובה_, korw, ćana_, исок_,
   {{0x661601e2,0x2007822e,0xdb0d00e7,0x067b007c}},	//   ityk, buni_, _chaî, ינפל,
   {{0x20078098,0x3f89031d,0x23694be8,0x6aad0035}},	//   cuni_, ynau_, _plaj_, _szaf,
   {{0x926b3a8b,0x66164be9,0x6aa40a03,0x443c9502}},	//   арга_, ktyk, _byif, _vrv_,
   {{0x81d300ab,0x64480118,0x799c4bea,0x236900c3}},	//   হীন_, _ádif, forw, _vlaj_,
   {{0x7aef4beb,0x7bcacbec,0x7c3e802a,0x69dd0e20}},	//   sact, _tufu, _ápro, rpse,
   {{0xd5c88028,0x752881ac,0xd24e004e,0x443c8980}},	//   _mềm_, medz, نچی_, _urv_,
   {{0x2bcf89a3,0x27fe1e1e,0x69dd2f9c,0xa857825f}},	//   _संता, átna_, ppse, חילה_,
   {{0x20078245,0x66f40e02,0xef19a180,0x3f890428}},	// [3c50] zuni_, ьпту, niża_, rnau_,
   {{0x6d589487,0x2007cbed,0x8c6701a8,0x7d1a8192}},	//   _jova, yuni_, يطان, nfts,
   {{0x6d58cbee,0x7aed010b,0x256980e1,0x49b800d7}},	//   _mova, _keat, _júla_, _بايد_,
   {{0xa2a00697,0x6d58cbef,0x7ae28637,0x20079fb6}},	//   _गुड्, _lova, gbot, vuni_,
   {{0x69c5169f,0x6145980f,0xd9458256,0x7aed4bf0}},	//   _kihe, зела, зели, _meat,
   {{0x6d5890ac,0x2007cbf1,0x4129813a,0xaca381bc}},	//   _nova, tuni_, соко_, _stọk,
   {{0x77a5862f,0xfbc68beb,0x6d474bf2,0x2bc6816f}},	//   lóxi, _रंगम, _inja, _रंगा,
   {{0xdb1c98b6,0x6f0d4bf3,0xd343815b,0x6e2281a8}},	//   _strö, ngac, _تفری, _bpob,
   {{0xc3329a63,0x6b9d002a,0x6d470088,0x70a8125f}},	//   _און_, dosg, _knja, _गर्ल,
   {{0x7ac4821e,0x4423008e,0x61e98caa,0xceb981d0}},	//   _істе, _kpj_, _iwel, neři_,
   {{0x04458c8e,0x75351917,0x6d58a5c6,0x442303ac}},	//   ченн, _mazz, _dova, _jpj_,
   {{0x61e980b8,0x69c50364,0x7aed04bc,0x66164bf4}},	//   _kwel, _aihe, _ceat, ytyk,
   {{0x799c4bf5,0x442300dd,0x99890503,0x69c53977}},	//   torw, _lpj_, _draž_, _bihe,
   {{0x6d5880cd,0x753504b7,0xb227007b,0x61e9874b}},	//   _gova, _nazz, _svæð, _mwel,
   {{0x2564016d,0x7aed0051,0x69c52577,0x44310b67}},	//   _följ_, _feat, _dihe, _nsz_,
   {{0x6d470034,0x6f1ba43d,0xdfcf00f7,0x7aed0427}},	//   _anja, nfuc, طيك_, _geat,
   {{0x75354bf6,0x69c50609,0x77a581df,0x26c2a461}},	// [3c60] _bazz, _fihe, góxi, žkov_,
   {{0xaa3b0039,0x75350081,0x66161c59,0x2d8100b4}},	//   _פתיח, _cazz, rtyk, gihe_,
   {{0xa0a6002e,0x661630bd,0x69dbcbf7,0xdd8f00f7}},	//   _ханд, styk, _atue, دول_,
   {{0x7f4a1381,0x6d470a40,0xe3c9801c,0x69c53ea1}},	//   _الحق_, _enja, _nằm_, _zihe,
   {{0x7ae283ab,0x20184bf8,0xf8dd800d,0x200a4bf9}},	//   rbot, ltri_, नुभय, lubi_,
   {{0xdb15cbfa,0x75352565,0x6d470669,0x660412b7}},	//   _buzó, _gazz, _gnja, mrik,
   {{0x61e9cbfb,0x201838c6,0x6d58a732,0xd83a81e5}},	//   _ewel, ntri_, _rova, сэл_,
   {{0x95d88009,0x753504b9,0x6d58a8d2,0x6a86cbfc}},	//   одит_, _zazz, _sova, _елба,
   {{0x3a3fcbfd,0x7bce0812,0x61e98355,0x7aed4bfe}},	//   _grup_, _hubu, _gwel, _reat,
   {{0x7bce20e7,0x6b82cbff,0x7bcd8088,0x64482738}},	//   _kubu, liog, _čaur, _àdis,
   {{0x75288029,0x6366007b,0xd5b88029,0x43950d5f}},	//   redz, _tónl, rmā_, данс,
   {{0x98ac8029,0x66044c00,0xd5b880eb,0x22404c01}},	//   _gadā_, krik, smā_, _brik_,
   {{0x27e085f5,0x6d589fc2,0x7bce4c02,0x212a026c}},	//   ćinu_, _tova, _lubu, febh_,
   {{0x6604180a,0xdb0981a8,0x35b38d8e,0xdb0d1627}},	//   drik, _mheá, _збір, _ciaò,
   {{0x7aed4c03,0x753512bb,0x36d51bb6,0x7bce3cc2}},	//   _teat, _razz, добр, _nubu,
   {{0x27ff0805,0x2d9ea7d4,0x97a40162,0x26c2816b}},	//   čun_, lote_, ерул, žkou_,
   {{0x6f0d3330,0x75350081,0x6d4700dd,0x224000b9}},	// [3c70] rgac, _pazz, _pnja, _grik_,
   {{0x2d9ecc04,0x442300b9,0x2fc6c74f,0xdb1c816a}},	//   note_, _ppj_, _liog_, _gurú,
   {{0x69db8aa2,0x2d8ccc05,0x200a00e5,0x7bce2596}},	//   _stue, inde_, cubi_, _cubu,
   {{0x2bcfbca9,0x23cf800c,0x7bce4c06,0x75354bcd}},	//   _संसा, _संसद, _dubu, _wazz,
   {{0xb90a0104,0xe1f881e5,0x75351347,0xcf560039}},	//   _nghệ_, згі_, _tazz, _חברת_,
   {{0x09e200ab,0x2d8c81ed,0x2d9eb689,0x98a59ef3}},	//   _বিমা, jnde_, jote_, миле,
   {{0xb4ab816f,0x27e98503,0x7bce2c45,0x2d9e8a41}},	//   _खरे_, ćano_, _gubu, dote_,
   {{0x2d8ccc07,0x23668052,0x6d5c8bd7,0x53348012}},	//   ende_, ckoj_, öran, _пест,
   {{0x09e20a49,0xee368110,0x88c500ab,0x61fb005c}},	//   _বিভা, дны_, ্রিক, šulj,
   {{0x2d9ecc08,0xe81e009a,0x9e6481a8,0xdce70824}},	//   gote_, _पहला_, عاين, _oljč,
   {{0x2fc68362,0x7983912e,0x61fc81a9,0xe3c9827d}},	//   _fiog_, minw, _ārli, _tằm_,
   {{0x2d8c87b3,0x09e20264,0xc8e64c09,0x7983bcb2}},	//   ande_, _বিবা, कर्म_, linw,
   {{0x0caa000c,0xf77088ca,0x2bcfa539,0x2d9ea26b}},	//   _कर्म, _حال_, _संवा, bote_,
   {{0xd5bb86b5,0x2d9ecc0a,0x20183105,0xdb0d002a}},	//   _усе_, cote_, ttri_, _diañ,
   {{0x07a6069b,0x236d8f4c,0x2b494c0b,0x8fa64c0c}},	//   давн, _olej_, _fnac_, даве,
   {{0x66044c0d,0x290402bb,0x22401299,0x7bce4c0e}},	//   trik, şma_, _trik_, _rubu,
   {{0x63a44c0f,0x7bce4259,0x27ed003a,0xdcfa8029}},	// [3c80] _ikin, _subu, ćena_, litā,
   {{0x5983176e,0x66044c10,0xdd8f0290,0xab5d8609}},	//   _альб, rrik, لوق_, _biżo,
   {{0x660412a5,0x3a2480b9,0x2366811f,0xdcfa81a9}},	//   srik, _spmp_, tkoj_, nitā,
   {{0x491a03bb,0x2ca7cc11,0x61e9002e,0x2d9e8c53}},	//   म्रो_, _mynd_, ţele, zote_,
   {{0x236d81c0,0x23668168,0x63a40c93,0x2d9e80f8}},	//   _dlej_, rkoj_, _mkin, yote_,
   {{0x7bce010b,0x2366803b,0x6b828110,0x7c3a15f2}},	//   _tubu, skoj_, siog, _štru,
   {{0xa3ae03b7,0x7bdc4c12,0x2d9ebfd7,0x65631a42}},	//   कता_, _utru, vote_, önhe,
   {{0x96348785,0xc6f8c7a8,0x6d5c2f96,0x2d9e804f}},	//   ениц, чних_, _hora, wote_,
   {{0x7e643286,0x2d9ecc13,0xdb040f35,0x00000000}},	//   nyip, tote_, _fhiú, --,
   {{0x63a44c14,0xa3cf959a,0xb4e881fe,0x6d5c4022}},	//   _akin, _वंश_, बरे_, _jora,
   {{0x7bda02be,0xb4de809a,0xcfa98019,0x69c88df6}},	//   _étud, _तभी_, _کالم_, _iide,
   {{0x63b6031d,0x6d5c4c15,0x69c68c1c,0xa5bb4c16}},	//   _chyn, _lora, ादकी, _apól,
   {{0x69c8cc17,0x63a40122,0x61e2cc18,0xfaff03ed}},	//   _kide, _dkin, npol, dhët_,
   {{0x3f84cc19,0x63a44c1a,0x6d5c4c1b,0x69c8cc1c}},	//   limu_, _ekin, _nora, _jide,
   {{0x58d40729,0xb8d7035a,0x69c8cc1d,0x6d4aa91e}},	//   тост, _जर_, _mide, _infa,
   {{0x69c8cc1e,0x7538cc1f,0x65ab164a,0xab5d81b9}},	//   _lide, _havz, rühm, _riżo,
   {{0x6d5c1f32,0x69c88cb5,0xa3e711bc,0x443e81a3}},	// [3c90] _bora, _oide, _मौज_, lvt_,
   {{0x3f84822e,0x69c8cc20,0xbddb0362,0xb91281bc}},	//   himu_, _nide, _crèa, ranụ_,
   {{0x236d8bda,0x3f84cc21,0x7538cc22,0x68f50380}},	//   _plej_, kimu_, _mavz, mazd,
   {{0x14df03b7,0xdb041a26,0x6d5c01a8,0x61e2bd53}},	//   _प्रण, _shiú, _eora, fpol,
   {{0x6d5c4c23,0x69c880ad,0xdb1602be,0xb4bb852a}},	//   _fora, _bide, écéd, _अण्_,
   {{0x6d5c4c24,0x61ed2994,0x7538a19f,0x6722846d}},	//   _gora, _mwal, _navz, _aboj,
   {{0x69c8b2e7,0x61e2bcc0,0x10a2940b,0x7642948e}},	//   _dide, apol, лишн, _aroy,
   {{0x6d4acc25,0x69c8cc26,0xdcfa80eb,0x7642cc27}},	//   _anfa, _eide, vitā, _broy,
   {{0x69c89c6d,0x2ca7a09b,0x63b6031d,0x7642bffe}},	//   _fide, _synd_, _rhyn, _croy,
   {{0x69c8cc28,0x68f51988,0x128a80d5,0x6d5c3dd5}},	//   _gide, jazd, _عملی_, _xora,
   {{0x809f0996,0x61ed4c29,0x98148124,0xa2c204c5}},	//   _खुले, _awal, _لبنا, रेन्,
   {{0x7bc98d00,0x6d4acc2a,0xe29a23cd,0xdcfa80eb}},	//   _jieu, _enfa, зам_, ritā,
   {{0x7bc982be,0xfbcf864a,0x7f4b81f6,0x7642cc2b}},	//   _mieu, _सूरम, _ingq, _groy,
   {{0x7bc9cc2c,0xdcfa80eb,0x200781e8,0x68f50061}},	//   _lieu, pitā, orni_, gazd,
   {{0x2d85cc2d,0x7f5d02ba,0x61ed0c2e,0x61e2807a}},	//   mile_, _bosq, _ewal, zpol,
   {{0x7bc98586,0xe29a0021,0x2d85cc2e,0x6d5c4c2f}},	//   _nieu, _най_, lile_, _sora,
   {{0x6d5c4c30,0x661b885c,0xdd920154,0x61ed4c31}},	// [3ca0] _pora, ntuk, هور_, _gwal,
   {{0xa3b4023c,0x2d85cc32,0x6d5c02a3,0x661b8bc6}},	//   _जीत_, nile_, _qora, ituk,
   {{0x6aba8076,0x6d5c4c33,0xdcfa802e,0xaacb8ee6}},	//   ेश्र, _vora, lită, िशंक,
   {{0x69c8cc34,0xeb97cc35,0x2d85805d,0x673b809a}},	//   _side, них_, hile_, jduj,
   {{0x6d5c4c36,0x2d85829b,0x69c8cc37,0x57be03eb}},	//   _tora, kile_, _pide, ्दीह,
   {{0x1ae700c8,0x61e4802e,0x61e2cc38,0x61fb04f0}},	//   _কাছে_, ţilo, rpol, áuli,
   {{0x2d85cc39,0x7dc90110,0x443e4c3a,0xc7c69ed1}},	//   dile_, _užsa, _ét_, нсии,
   {{0xfaa6cc3b,0x7642cc3c,0x7c3e8019,0x35e687a1}},	//   _забо, _proy, _ápri, нцов,
   {{0x3f848542,0xf652990c,0x69c8904a,0x2d85cc3d}},	//   rimu_, ائع_, _tide, file_,
   {{0x3f84cc3e,0x63a291c9,0x2d85be10,0x4427808e}},	//   simu_, loon, gile_, _bpn_,
   {{0x64438052,0x4c948db3,0xddcd2bea,0x68f5026c}},	//   _crni, тинс, izaš, vazd,
   {{0x67229bcf,0x442780dd,0x63a282ec,0x6443c861}},	//   _uboj, _dpn_, noon, _drni,
   {{0x2d85b057,0x4427c929,0x6366002a,0x2a668282}},	//   bile_, _epn_, _xóni, nyob_,
   {{0x2d85cc3f,0x63a2cc40,0x6d4acc41,0x4aa5104f}},	//   cile_, hoon, _unfa, _गुणव,
   {{0xd3a74249,0x27ed003a,0x395e82be,0xb8e91c3b}},	//   _прип, ćeno_, _mots_, _ऋण_,
   {{0x25a102af,0x63a281ab,0x61ed4c42,0xbddb010c}},	//   wohl_, joon, _twal, _drèn,
   {{0x7bc9bd3e,0xfaff00f1,0x63a2a960,0xdcfa8162}},	// [3cb0] _rieu, shës_, doon, cită,
   {{0x200eaf9f,0x7bc9cc43,0x673b8b80,0xd2519190}},	//   kufi_, _sieu, zduj, ینا_,
   {{0x63a298f0,0x61fb84e1,0x661b8102,0x44271e9e}},	//   foon, _svul, ztuk, ïn_,
   {{0x2d85cc44,0x63a2cc45,0x200782d4,0xdb160176}},	//   zile_, goon, vrni_, _chyè,
   {{0x239600eb,0x7bc980e7,0x61e080b9,0xe9d88084}},	//   nāja_, _vieu, _ctml, екі_,
   {{0x395ecc46,0x79870314,0x2f3f019d,0x2d85cc47}},	//   _cots_, nijw, _ọghi_, xile_,
   {{0xdd94053b,0x200e80b4,0x2795cbfc,0x0138025f}},	//   _сары, gufi_, кшир, גרות_,
   {{0x661b985b,0x6366016a,0xc01c80ff,0x20078168}},	//   ttuk, _tóni, _hước_, rrni_,
   {{0xe3b0845b,0x2d85cc48,0x290147cd,0x2b4dcc49}},	//   _طرف_, tile_, _odha_, _inec_,
   {{0x4d659ae5,0x661bcc4a,0x89348077,0x1c459383}},	//   тков, rtuk, _معما, вном,
   {{0x2d85cc4b,0x661b8bc4,0xeb9a1584,0x3d1906af}},	//   rile_, stuk, дин_, _पाने_,
   {{0x2d85cc4c,0x0056812a,0x6443807a,0xdcfa8493}},	//   sile_, _בשעת_, _vrni, tită,
   {{0xeaf20105,0x3f7a80be,0x3b000168,0xdcfc4b1f}},	//   _अजीत_, _קאנס, _vdiq_, _smrč,
   {{0xc01c8104,0xdcfa8087,0x6443cc4d,0x4427cc4e}},	//   _nước_, rită, _trni, _tpn_,
   {{0x10a63ca1,0x98a62402,0x63a2b50f,0x6443cc4f}},	//   тивн, тиве, yoon, _urni,
   {{0xd00f0b76,0x20050c4e,0x57be001b,0x2004239f}},	//   تلف_, ália_, ्देह, čmi_,
   {{0x7c24803b,0x6b844c50,0xc01c8028,0x96632630}},	// [3cc0] _ćiri, _imig, _bước_, акте,
   {{0x63a2bca6,0x6d8b00eb,0x5bcaa076,0xc01c80ff}},	//   woon, kļau, िद्व, _cước_,
   {{0x63a2cc51,0x6ea2146d,0x5f060a13,0x80c780ab}},	//   toon, _कुरु, _изна, রুত্,
   {{0x91e69a19,0x395ebb11,0x67d181a9,0x26cf80d7}},	//   воде, _sots_, _gāji, _nggo_,
   {{0x395e809f,0x63a2cc52,0x2fc04c53,0x2564007b}},	//   _pots_, roon, mmig_, _sölu_,
   {{0xfce34c54,0x63a2cc55,0x6609cc56,0xc27b01c6}},	//   _воро, soon, drek, ורני,
   {{0x395e8722,0x63a2ae05,0x6d4e4c57,0x6609cc58}},	//   _vots_, poon, _inba, erek,
   {{0xf093078d,0x442a4c59,0x753c31a6,0x65b001ec}},	//   ינו_, _ipb_, _harz, zähl,
   {{0x395e8813,0x753c0f89,0x6609cc5a,0x443800ee}},	//   _tots_, _karz, grek, _hsr_,
   {{0x6b84402b,0xc01c8129,0xb5fd928a,0x26cf9407}},	//   _amig, _xước_, myšl, _eggo_,
   {{0x753c1cdc,0x6ab2abef,0x6609811e,0x21759ef8}},	//   _marz, _जरुर, arek, _сутр,
   {{0x44383075,0x23960029,0x66099de6,0x65b001ec}},	//   _msr_, tāja_, brek, wähl,
   {{0x51871507,0x80c780c8,0x2d8f0019,0xed5a8081}},	//   вува, রুদ্, égek_, _оод_,
   {{0x6b844c5b,0x753c009a,0x443808ae,0xaefb026b}},	//   _emig, _narz, _osr_, _alùp,
   {{0x97a70009,0x843880f7,0xa3b44c5c,0xd7f8002e}},	//   врал, _أكبر_, _जीव_, кут_,
   {{0x6ab2901b,0x6d4e4c5d,0x24b800ab,0x63660dfe}},	//   _जरूर, _anba, জশাহ, _bónu,
   {{0x27e9812b,0x68f88858,0x7c3a0b80,0xc7c80198}},	// [3cd0] ćani_, kavd, _štrp, тыре_,
   {{0x1c099a3b,0x6935028e,0xdcb10129,0xf4d10264}},	//   _विमल_, _сноу, _ở_, ির্ব,
   {{0x9f5806a5,0xdce88110,0x7bcd0110,0x6acb83b6}},	//   guró_, sidė, _kiau, िश्र,
   {{0x6d4e4c5e,0x201111b7,0x09cb816f,0x212580dd}},	//   _enba, muzi_, ाद्य, _sblh_,
   {{0x2011454a,0x3f8942d1,0x753c4c5f,0xd83882d6}},	//   luzi_, miau_, _farz, _asč_,
   {{0x3f894c60,0x7c388052,0xdb1ccc61,0x6f02cc62}},	//   liau_, _osvr, _zurü, _adoc,
   {{0xb8dbb850,0xc954010f,0x20112169,0x2576006a}},	//   _घर_, ימס_, nuzi_, _sælg_,
   {{0xee399a19,0x3f89031d,0x753c009a,0xb4c10105}},	//   ени_, niau_, _zarz, ुशी_,
   {{0xdb1c8e14,0x673d07ba,0x09dd80ab,0x63a9cc63}},	//   _euró, _masj, _ঠিকা, _iken,
   {{0x6609cc64,0x6f02819d,0x7bd52479,0x2576006a}},	//   rrek, _edoc, _kuzu, _vælg_,
   {{0x9f0591cc,0x78548416,0x7bd50c9e,0x63bb801c}},	//   _موضو, _نیوز_, _juzu, _khun,
   {{0x91e60d9e,0x7bd50ce7,0x36d580a9,0x673d035f}},	//   ломе, _muzu, _содр, _nasj,
   {{0x7bcd00dd,0x660586c8,0x2ed900ab,0x3f890114}},	//   _diau, _спла, তরাষ, diau_,
   {{0x201102ec,0xbddb00e7,0x644702d0,0xe4e7804a}},	//   fuzi_, _crèm, _orji, _рідн,
   {{0x5f060698,0x2011114c,0x63a9cc65,0x6aad14ee}},	//   лзва, guzi_, _oken, _eyaf,
   {{0x3f890a8e,0x63a9862b,0xe7374c66,0x63bb801c}},	//   giau_, _nken, лес_, _nhun,
   {{0x6443013c,0x753c3fc3,0x7e69a0cf,0x200a0267}},	// [3ce0] ænin, _parz, nyep, srbi_,
   {{0x2018832b,0x61e40247,0x63a9cc67,0x491b00d4}},	//   _årig_, _itil, _aken, _बायो_,
   {{0x711b093f,0x63bb8c5e,0x3f894c68,0x753c14af}},	//   _אויפ, _bhun, biau_, _varz,
   {{0x63bbcc69,0x7bd50102,0x3f894c68,0xe29a81e2}},	//   _chun, _duzu, ciau_, нае_,
   {{0x25a5a28c,0xa68304cf,0x63bbcc6a,0x753c4a05}},	//   koll_, _гляд, _dhun, _tarz,
   {{0x64a64c6b,0x63a98caa,0x673d02ce,0x7af64c6c}},	//   _бага, _eken, _zasj, _leyt,
   {{0xebe32078,0x629c8063,0x63a61142,0x68f887fd}},	//   _госп, _środ, kokn, ravd,
   {{0xb4c0000f,0x7c9300f7,0x61e44c6d,0x7af64c6c}},	//   ँधी_, _الفص, _otil, _neyt,
   {{0xa2cb88af,0x44440ecb,0xa5bb00f7,0xe297c653}},	//   _तृप्, lv_, _spói, _бат_,
   {{0x444401e9,0xa3d30063,0x71d78039,0x7bcd0110}},	//   ov_, _हूँ_, _עובד_, _siau,
   {{0x61e44c6e,0x4ac70076,0x7c2902ee,0x6aad208b}},	//   _atil, रेनव, _ćerk, _syaf,
   {{0x44444c6f,0x7bc286c0,0xaca40133,0x63a980b9}},	//   iv_, nmou, _arịr, _xken,
   {{0xc3338051,0x388e8086,0x25a58106,0x69d60144}},	//   זור_, _hər_, boll_, _cuye,
   {{0x7bc2abb7,0x3f890114,0x518419b8,0x61e90162}},	//   hmou, wiau_, буса, ţelo,
   {{0x21310176,0x776282a3,0xa3d3009a,0x44444c70}},	//   rezh_, _koox, _हूं_, jv_,
   {{0x63a63286,0x201100b4,0x7bd525f4,0x61e44c71}},	//   cokn, ruzi_, _ruzu, _ftil,
   {{0x444401c5,0x8cf51628,0x3f894c72,0xc9872276}},	// [3cf0] ev_, изац, riau_, _буни,
   {{0x63bbcc73,0x63a9cc74,0x3f894c75,0x213ecc76}},	//   _shun, _sken, siau_, _nath_,
   {{0x3d1c8441,0xe1ff0019,0xd6d100f7,0x3f891ad5}},	//   _माने_, lsó_, _وقد_, piau_,
   {{0xb5190e18,0x2249013c,0x25b280d4,0x6d581743}},	//   न्जय_, _krak_, ुगुण, övar,
   {{0x444401e9,0xe9ff801c,0xe1ff4c77,0xfaa5aba7}},	//   av_, _trận_, nsó_, јало,
   {{0x2249011f,0x3f86cc78,0x213ea0a4,0xa593004e}},	//   _mrak_, _amou_, _cath_, _اگرچ,
   {{0x25a5ba30,0x213e8090,0x705281a8,0xe73991b1}},	//   voll_, _dath_, قنوا, вей_,
   {{0x63a9a001,0x163981a8,0x63bb8108,0x6f658081}},	//   _uken, نسخة_, _uhun, рвиз,
   {{0x660d22f8,0x44214c79,0x7af61bef,0x213e8114}},	//   nrak, lth_, _reyt, _fath_,
   {{0x45859cce,0x6b8b9277,0x27058028,0x79c88875}},	//   ргов, ligg, ồn_, _موقف_,
   {{0x61e42e52,0x47358dea,0x22490859,0xf1c8001b}},	//   _stil, _внес, _arak_, ntář_,
   {{0x44214c7a,0x22492f66,0x1ee7803d,0x660d01a9}},	//   ith_, _brak_, _صوتی_, krak,
   {{0xeb970b33,0x25a5cc7b,0x27e9992c,0x7ae91f49}},	//   рия_, poll_, ćanu_, ñeta,
   {{0xa2c21a46,0xa5098767,0xfce58eef,0x69c381a8}},	//   रेष्, _река_, _токо, nmne,
   {{0x69c3cc7c,0x9d1a807c,0x660d4c7d,0x2c7b846d}},	//   imne, _יוסט, erak, _dádé_,
   {{0x44213437,0x6840801b,0x69d600ff,0x22490197}},	//   dth_, ládá, _tuye, _frak_,
   {{0x44212065,0x444410af,0xa2c22d05,0x7de50250}},	// [3d00] eth_, wv_, रेश्, مسلم,
   {{0xe5772386,0xab5d81b9,0x79fb04de,0x44444c7e}},	//   азу_, _miżu, _שליח, tv_,
   {{0x68fc4c7f,0x44440069,0x2abb077f,0x22493733}},	//   mard, uv_, _tàbí_, _zrak_,
   {{0x779411fb,0x68fc0459,0x44444c80,0x69c387d8}},	//   _ایرا, lard, rv_, emne,
   {{0x80ad80c8,0x2d87810c,0x69c382f7,0x1603001b}},	//   টেম্, _omne_, fmne, _लिएर_,
   {{0x99f580e8,0x29184c81,0x333f8036,0x213e808e}},	//   сяці, ngra_, _eaux_, _qath_,
   {{0xa967824b,0xd83a8087,0x333fc73a,0x21678eef}},	//   рија_, тэл_, _faux_, рији_,
   {{0x68fc4c82,0xb9178135,0x93168180,0xab5d8035}},	//   hard, _kedụ_, _خورش, _biżu,
   {{0x68fc4c83,0xba29830f,0x27ed003b,0xae0c0540}},	//   kard, _مسلم_, ćeni_, िंटन_,
   {{0x68fc025b,0x656380a9,0x5d668c9d,0x2d8780ee}},	//   jard, _conh, ртиз, _cmne_,
   {{0x2cb88e23,0xe2f900e8,0x3cf80122,0x10a680e8}},	//   ård_, лені_, _merv_, _тижн,
   {{0x2d878bc5,0x80ad80ab,0x68f74c84,0xbb940198}},	//   _emne_, _চলচ্, _sexd, жающ,
   {{0x52141fb4,0x3636803d,0x68fc4c85,0x491b0074}},	//   одят, _خراس, fard, _बादो_,
   {{0xac1885e9,0x44214c86,0x7c2e3ccd,0x68fc10b6}},	//   _боку_, yth_, _opbr, gard,
   {{0x2bd04638,0xb4d2816f,0x657a80f7,0xb868024b}},	//   _संचा, वशी_, mhth, ајте_,
   {{0x2d8ccc87,0x8b6700d5,0x291800f7,0x36d5287d}},	//   lide_, _خاتم, agra_, соар,
   {{0x7afd2551,0x7bd880f2,0xdef80196,0x63ad4c88}},	// [3d10] mast, _huvu, рыс_, _ikan,
   {{0x7afd4c89,0x7bd88abd,0xdcf907bd,0x2d8ccc8a}},	//   last, _kuvu, افات_, nide_,
   {{0x65ab02af,0x9f35102a,0x63ad0365,0x95c823d7}},	//   führ, _лені, _kkan, рута_,
   {{0x7afd0711,0x44212dc0,0xe4578158,0xa3b4835f}},	//   nast, rth_, ייבט_, обхі,
   {{0x07560039,0x6b8bcc8b,0x7bd88009,0x2d8c8dde}},	//   _הסרט_, rigg, _luvu, kide_,
   {{0x7afd203b,0x443c8082,0x463a0158,0xab5d84b7}},	//   hast, _osv_, _געשע, _riżu,
   {{0x6602ace1,0x63ad4c8c,0x333f80e7,0x7e6d44cf}},	//   _avok, _okan, _taux_, lyap,
   {{0x65638073,0x09e680ab,0x7afd23c6,0x69dc875f}},	//   _sonh, _নিরা, jast, _črev,
   {{0x7afd4c8d,0x9f5e4c8e,0x6b89cc8f,0x2d8ccc90}},	//   dast, été_, _imeg, fide_,
   {{0x8d5585c2,0x2d8c8870,0x63ad4c91,0x657acc92}},	//   стич, gide_, _akan, ghth,
   {{0xbb460009,0x64a5980f,0x6d41cc93,0xcb6a36ab}},	//   бенк, сана, rdla, гане_,
   {{0x7afd0558,0x3d1c8424,0xe45600be,0x316581ec}},	//   gast, _माथे_, צירט_, _holz_,
   {{0x644a91f8,0x2d8c811e,0x139a80be,0x6b898135}},	//   _erfi, bide_, רברע, _mmeg,
   {{0x2d8ca61d,0x63ad14ee,0x3f8dcc94,0x657a8d35}},	//   cide_, _ekan, lieu_, chth,
   {{0x2b400046,0xe1f2003d,0x3d1c950e,0x660282d4}},	//   _taic_, _کسب_, _माते_, _zvok,
   {{0xea5a0fbb,0x316581de,0x68fc4c95,0x43930992}},	//   _број_, _lolz_, sard, _најс,
   {{0x09e200ab,0x7ae44c96,0xa3b4326c,0x6ea2001b}},	// [3d20] _বিকা, _ifit, _जीए_, _कुखु,
   {{0x6b9bcc97,0x442ec752,0x32023d23,0x6b89b73c}},	//   _ajug, _ypf_, msky_, _ameg,
   {{0xa5bb0207,0xd8d70158,0x0c260785,0xa06a01a1}},	//   _após, _לויט_, смен, _сана_,
   {{0xeafa8b53,0x8afd801b,0x798e02ec,0xdce381d0}},	//   ارات_, _pořa, libw, _plně,
   {{0x3202237c,0xa96a902f,0x6b9b8118,0x65ab01ec}},	//   nsky_, лида_, _djug, rühr,
   {{0x6b898135,0x2d8f0019,0x7c330e15,0x6b9b819d}},	//   _emeg, éget_, ñerí, _ejug,
   {{0x764b8114,0x7afd1a73,0x2d8cca4c,0x6602b37e}},	//   _argy, yast, vide_, _svok,
   {{0x442e8a5a,0x2d8ccc98,0x7bd88435,0xbddb09c4}},	//   _rpf_, wide_, _ruvu, _crèw,
   {{0x7afd10a6,0x2d8c8074,0x657aca30,0xda638323}},	//   vast, tide_, thth, _евти,
   {{0x867b004c,0x7afd1a94,0x716580f7,0x442ebaab}},	//   טרפו, wast, _والك, _ppf_,
   {{0xdeef814c,0x2d8ccc99,0x672082f1,0x6e2400b9}},	//   _ны_, ride_, _यापक_, htib,
   {{0x6e244363,0x2d8ca62b,0x4c9b00be,0x3f8d823e}},	//   ktib, side_, רשטע, cieu_,
   {{0x2d8ccc9a,0xe5a68e97,0x3d190327,0x256f02d0}},	//   pide_, _лиди, _पाले_, _yılı_,
   {{0x7bd8cc9b,0x7ae40789,0x7afd33e1,0x443ccc9c}},	//   _tuvu, _efit, sast, _tsv_,
   {{0x7dc901e2,0xe8140076,0x442e8980,0x38c30036}},	//   _užsi, तूला_, _upf_, déré_,
   {{0x2d8a028d,0x63ad0dc5,0x44ce8085,0x7e6d02d0}},	//   _ambe_, _ukan, mə_, tyap,
   {{0x320f0065,0x61f6031d,0x44ce8085,0x6e24076d}},	// [3d30] _így_, _gwyl, lə_, gtib,
   {{0x67d50110,0x7d1acc9d,0x69dc8074,0x6b898084}},	//   _sąju, ngts, _पढ़ी, _smeg,
   {{0x44ce8086,0xe43503f8,0xa2cbb947,0x7f440df6}},	//   nə_, تفاد, तेन्, bdiq,
   {{0x291ecc9e,0xdfc681a8,0xe3b902d0,0x8c1b9101}},	//   _acta_, _زي_, ktım_, רואי,
   {{0x27ed012b,0x38c34033,0x2d8f0019,0x2bb880f7}},	//   ćenu_, béré_, éges_, حالة_,
   {{0x6ea20f85,0x3cfe88ae,0x98be861c,0xbddb0036}},	//   _कुटु, jatv_, _altı_, _brèv,
   {{0x6d554c9f,0x29f6809a,0x212c82c4,0xdb060c83}},	//   _inza, ała_, _dbdh_, soké,
   {{0x44ce8201,0x798e0c56,0x06098951,0x6b89cca0}},	//   də_, zibw, аник_, _umeg,
   {{0x63ab803b,0x332db49a,0x96b985e9,0x200500ce}},	//   mogn, _ibex_, шуку_, šlih_,
   {{0x6d4503f8,0x7afb8352,0x63ab9137,0x3202136f}},	//   ndha, _heut, logn, vsky_,
   {{0x61e98d11,0x7afba08b,0x69c1a499,0xbddb0036}},	//   _htel, _keut, _ihle, _grèv,
   {{0x7c254ca1,0x61f60114,0x6d5c8106,0x224d8176}},	//   ithr, _pwyl, örar, _krek_,
   {{0x3204003e,0x798e02ec,0xbb3a83de,0x7afbcca2}},	//   émy_, tibw, בערי, _meut,
   {{0x7afb82af,0x32021ee0,0x6729822b,0x2effcca3}},	//   _leut, rsky_, lfej, lauf_,
   {{0x6d450428,0x7ae404b7,0x798e4ca4,0xafe302c0}},	//   ddha, _tfit, ribw, досл,
   {{0x6d43cca5,0x6f1b859c,0x6e244ca6,0x46ea0c9b}},	//   _hana, nguc, ttib, рдан_,
   {{0x05662386,0x614629c9,0x20d601e2,0x69c1cca7}},	// [3d40] ован, _депа, _мінс, _ohle,
   {{0x6d43cca8,0x6e244ca9,0xa5bb066e,0x3f8b026c}},	//   _jana, rtib, _spór, _emcu_,
   {{0x224dccaa,0x3a3f810c,0x0b468a0e,0x7afbccab}},	//   _arek_, _asup_, жнен, _beut,
   {{0xab2a941e,0x6d43ccac,0xfe678c3b,0x20184cad}},	//   рода_, _lana, _قد_, muri_,
   {{0x20184cae,0x7afbb2c7,0x7c250083,0x6d4501b4}},	//   luri_, _deut, athr, bdha,
   {{0x6d43ccaf,0x69c1b30f,0x44ce8201,0xbddb009f}},	//   _nana, _chle, yə_, _prèv,
   {{0x657e0013,0x20184cb0,0x29f6809a,0x61e98009}},	//   mhph, nuri_, sła_, _etel,
   {{0x6d4382a3,0x69c7120e,0x44ce8201,0x3860826c}},	//   _aana, zmje, və_, ćir_,
   {{0x20182967,0x7bdc25f3,0x66044cb1,0x224d8168}},	//   huri_, _huru, nsik, _grek_,
   {{0x7bdc4cb2,0x20184cb3,0x637f020f,0xa2a38bb8}},	//   _kuru, kuri_, _këng, _छुट्,
   {{0x6d438025,0x9cdb0158,0x7bdc4cb4,0x224037d1}},	//   _dana, יקיפ, _juru, _asik_,
   {{0xc5f980c8,0x20184cb5,0x7bdc4cb6,0x883b8039}},	//   _আমরা_, duri_, _muru, _כתבו,
   {{0x6d43ccb7,0x7bdc0458,0x6d450079,0x4e969459}},	//   _fana, _luru, ydha, _بشار,
   {{0x6d43ccb8,0x7c254cb9,0x2735001c,0x20184cba}},	//   _gana, ythr, _ấn_, furi_,
   {{0xf77312dc,0x20184cbb,0xe9ff801c,0x69c700f1}},	//   وار_, guri_, _trần_, rmje,
   {{0x69c71351,0x20030035,0xa5bb0032,0x3a2682df}},	//   smje, rsji_, _apóp, ktop_,
   {{0x6b8d4cbc,0x6d43bbb1,0x0ec501fe,0x66043d52}},	// [3d50] _imag, _yana, लेंड, gsik,
   {{0x7bdc1c88,0x6d43ccbd,0x20184cbe,0x09e200ab}},	//   _buru, _xana, buri_, _বিচা,
   {{0x20180012,0x6d454cbf,0x7afb9699,0x63abccc0}},	//   curi_, rdha, _peut, togn,
   {{0x7bdc4cc1,0x23960029,0x7c2528c6,0x224dccc2}},	//   _duru, tāji_, rthr, _prek_,
   {{0x644e4cc3,0x63abae6c,0x69c1be76,0x65b014c7}},	//   _erbi, rogn, _phle, täht,
   {{0x63ab8098,0x7bdc49fc,0xd24e8bbe,0x7c25388d}},	//   sogn, _furu, انو_, pthr,
   {{0x6d43ccc4,0xdcfc02a5,0xd0f8010f,0x637f00f1}},	//   _rana, _smrć, חמות_, _kënd,
   {{0x61e9a28c,0x3a3f82c4,0x32191122,0x1606970c}},	//   _ttel, _tsup_, kusy_, _शिखर_,
   {{0x6d43ccc5,0x20184cc6,0x7bdc4cc7,0x2eff82af}},	//   _pana, zuri_, _zuru, rauf_,
   {{0x0d828e86,0x6b8d4bb4,0x76498364,0x2eff83ac}},	//   ельн, _amag, rvey, sauf_,
   {{0x6d439e7a,0x3d1c800f,0xc17281c6,0x20184cc8}},	//   _vana, _मारे_, _רחב_, xuri_,
   {{0x6d43a96c,0xeb9a1401,0x20184cc9,0xddcd0503}},	//   _wana, сим_, vuri_, jzaž,
   {{0x6d43ccca,0x2018419b,0xbebb00f1,0x34b803eb}},	//   _tana, wuri_, _mbës, _अर्द,
   {{0x20184ccb,0xdce3a19f,0x6b8d4ccc,0x6d4388ce}},	//   turi_, _konč, _emag, _uana,
   {{0xdfd200f7,0x3945cccd,0x645c956e,0xaca401bc}},	//   فيس_, _mals_, ärit, _kpụr,
   {{0x66043fbb,0x20183f30,0xab6600e8,0x32190690}},	//   tsik, ruri_, _хвил, busy_,
   {{0x644e0d11,0xfbd30051,0x20184cce,0x22400bb1}},	// [3d60] _srbi, _אתה_, suri_, _usik_,
   {{0xf1bf0742,0x20184ccf,0x6b8d1840,0x7bdc032a}},	//   ltán_, puri_, _zmag, _puru,
   {{0x7bdc4cd0,0x65b001ec,0x7bd62c14,0x6bd606e2}},	//   _quru, fähr, _kiyu, ستار,
   {{0x7bdc369b,0x8fa6268a,0x7bd600fc,0x6282890d}},	//   _vuru, _хаме, _jiyu, tzoo,
   {{0x7d01ccd1,0x7bdc4cd2,0x7c3b0b67,0x7bd6469d}},	//   kals, _wuru, _ćure, _miyu,
   {{0x7bdc1922,0x40348a7c,0x239600eb,0x7d01ccd3}},	//   _turu, декс, māju_, jals,
   {{0x072085e8,0x64a3214d,0x3a26ccd4,0xdca31ddf}},	//   _यादव_, _зара, stop_, _зари,
   {{0x5ea580c8,0x23278abe,0xdce389d1,0x4c9b01c6}},	//   খেছে, _носи_, _donč, _הבלו,
   {{0xc6f787ac,0x6f008300,0x2cba826c,0x3945ccd5}},	//   чных_, ramc, _špd_, _fals_,
   {{0x6b8d4cd6,0x998680d5,0xc243a325,0x7bd60300}},	//   _smag, _علاو, _янук, _aiyu,
   {{0x7bd63a8f,0xb60381a9,0xe6b923bd,0x00000000}},	//   _biyu, ēšam, _आर्ज, --,
   {{0x7bc40330,0x18778039,0x7d018074,0xbebb0168}},	//   _chiu, _מעבר_, aals, _mbër,
   {{0x7d018029,0x637f020f,0x2aab1194,0x602a8085}},	//   bals, _rënd, стно_, _məmm,
   {{0x5e578051,0xd90f0416,0x82778158,0x7c3781df}},	//   _מידע_, دید_, לעכע_, ñarí,
   {{0x68fe11ee,0x2c82846d,0xdb1b80f7,0x6d58879a}},	//   _depd, _dédé_, _shuí, _inva,
   {{0x637f00f1,0xa8578039,0x6b8d4cd7,0x753a9919}},	//   _qënd, הילה_, _umag, letz,
   {{0x63af0f4c,0x9d5500d5,0x9f8a002a,0x2fc9067f}},	// [3d70] mocn, وچست, _añón_, rmag_,
   {{0x61ed4cd8,0xdb0bb8b4,0x65b001ec,0x2fc94cd9}},	//   _ital, mogé, währ, smag_,
   {{0x29034cda,0x6b9d0d35,0xbddb346b,0x637f0168}},	//   maja_, onsg, _près, _tënd,
   {{0xf99f4cdb,0x290cae1f,0x6b9d1897,0x3d1910f7}},	//   près_, _adda_, nnsg, _पाके_,
   {{0xd945b51e,0x2d998065,0xdce38353,0x6145932a}},	//   дели, ések_, _sonč, дела,
   {{0x99678009,0xbddb00e7,0xeab080f7,0xa2c200d4}},	//   ятел, _frèr, دعم_, रेट्,
   {{0x7d01ccdc,0x753a8102,0x3945ccdd,0x61ed0420}},	//   vals, detz, _vals_, _ltal,
   {{0x29034cde,0x69d71d3a,0x6d588247,0x290cccdf}},	//   haja_, _lixe, _anva, _edda_,
   {{0x6d470d8b,0xa3d10105,0x3945cce0,0x66158035}},	//   _kaja, वगन_, _tals_, ązko,
   {{0x6d474c3c,0x29034ce1,0x7bc44ce2,0xdce3a944}},	//   _jaja, jaja_, _shiu, _tonč,
   {{0x6d474ce3,0x61ed4b14,0x6fbf035a,0x03a6257e}},	//   _maja, _atal, ्षां, дино,
   {{0x6d58cce4,0x6d470247,0x69d70722,0x61fb819d}},	//   _enva, _laja, _aixe, _kwul,
   {{0xa5098af2,0x753a8102,0x69d74ce5,0xf1bf338d}},	//   _дела_, betz, _bixe, rtán_,
   {{0x6d47003b,0xdb0b80f2,0x290328f2,0x69df01b4}},	//   _naja, llgä, gaja_, _duqe,
   {{0x2bd909a3,0x69d701df,0xdee60ba8,0x66e60847}},	//   _बंगा, _dixe, доби, доба,
   {{0xe29a233f,0x23960029,0x6443cce6,0x61fb9e54}},	//   _май_, tāju_, _isni, _owul,
   {{0x6d470733,0x6e29cce7,0x290301ca,0x754646a1}},	// [3d80] _baja, nteb, baja_, мназ,
   {{0x7ae9cce8,0x29030025,0x6d474ce9,0xf1e18816}},	//   _afet, caja_, _caja, _पढ़न,
   {{0x53e5035f,0x6d4704c4,0x395a047f,0x6ad6816f}},	//   еціа, _daja, _inps_, धश्र,
   {{0x661bbd90,0xeb979bb1,0x6443ccea,0x6e29cceb}},	//   kuuk, мих_, _msni, kteb,
   {{0x6f0401e4,0x6d488514,0x09e387c4,0x628609e8}},	//   maic, ydda, вочн, nzko,
   {{0xc6930158,0x6443803b,0x6d470397,0x7ae98073}},	//   _יאר_, _osni, _gaja, _efet,
   {{0x61fbccec,0x7ae9cced,0x6e29ccee,0x443e0242}},	//   _ewul, _ffet, eteb, _èt_,
   {{0x6f040014,0x6d47368e,0x8b958a18,0xdb1b8362}},	//   naic, _zaja, _зруч, _ghuà,
   {{0x753a8102,0x6e2985b1,0x6d47019e,0x6616127a}},	//   tetz, gteb, _yaja, nryk,
   {{0x2366812b,0x628621a9,0x6f0401e4,0x28a982a8}},	//   ljoj_, dzko, haic, _चुकि,
   {{0x29030796,0x6f0404b9,0x6d4893b0,0x753a8102}},	//   vaja_, kaic, rdda, retz,
   {{0x753a8352,0x23668052,0x93bd002e,0x69d70609}},	//   setz, njoj_, ptăm, _sixe,
   {{0x290314c7,0x61e0a5f3,0x69d74cef,0xf8e28441}},	//   taja_, _juml, _pixe, _पलाय,
   {{0x66160a5c,0x6d58b25b,0x61e0ccf0,0x2d9307b6}},	//   dryk, _unva, _muml, xixe_,
   {{0x6d474cf1,0x69d704c3,0xdb0b80f2,0x80d080ab}},	//   _raja, _vixe, llgå, _স্ত্,
   {{0x6d474cf2,0x316cccf3,0x36d54cf4,0x69dd8037}},	//   _saja, _lodz_, еобр, _èseg,
   {{0x6d47167a,0x61ed4954,0x672d4cf5,0x69d70118}},	// [3d90] _paja, _utal, rfaj, _tixe,
   {{0x2d9eb3d6,0x20050065,0x33248362,0xd5bb05a8}},	//   nnte_, ális_, _acmx_, іса_,
   {{0x6d474cf6,0x2d9eccf7,0x5b159354,0x79953c07}},	//   _vaja, inte_, емет, mizw,
   {{0x6d4707ba,0x79952486,0x6f044cf8,0x2d9e8192}},	//   _waja, lizw, caic, hnte_,
   {{0x34bb8441,0x6d4709ca,0x6fc58388,0xa3c20c2d}},	//   _उर्द, _taja, nóce, ्गत_,
   {{0x349516df,0x6025a7ae,0xc10581a8,0x645a15d8}},	//   _загр, едка, روبي, _štie,
   {{0xa3af2128,0xb4bd98b8,0x7d0500dd,0x25a621bf}},	//   कवा_, _आरे_, mahs, éole_,
   {{0x2d9eade9,0x6e29ae6c,0x661b8c56,0x2fc68706}},	//   ente_, tteb, tuuk, _chog_,
   {{0xee368b71,0xeab38872,0xf6519ddd,0x9f510019}},	//   ены_, _شعر_, ائب_, lszó_,
   {{0x661bccf9,0x316c809a,0xdb06016b,0x29014949}},	//   ruuk, _godz_, doká, _neha_,
   {{0x6e29ccfa,0x5fdb03eb,0x3eb90aa2,0xf1bf05bf}},	//   steb, _मंगल, _lyst_, rtál_,
   {{0x2b490580,0xf1bf0f09,0x2fd90362,0x22521407}},	//   _caac_, stál_, _nisg_, _pryk_,
   {{0x55599e25,0x29014a85,0x59c4864a,0x2b4902ed}},	//   _надя_, _beha_, _लीडर, _daac_,
   {{0x23960029,0x79953094,0x6609912e,0xdca585fa}},	//   tājs_, gizw, msek, _пали,
   {{0x2f562659,0xa0a30d46,0x62862448,0xa06a03bc}},	//   нтас, гард, szko, чава_,
   {{0x66160bc5,0x2252006a,0xdce700e1,0x613381cc}},	//   tryk, _tryk_, _dojč, lılı,
   {{0x6f040046,0x539b0051,0x63a44cfb,0xe61a4cfc}},	// [3da0] raic, _מיקו, _ijin, яда_,
   {{0x6f040046,0xbd4600f7,0x6133861c,0x66098198}},	//   saic, عناي, nılı, isek,
   {{0x6b829532,0x6f040c41,0x660980ee,0x61e0ccfd}},	//   thog, paic, hsek, _suml,
   {{0x237f802e,0xc0530039,0x637f00f1,0x25fb0424}},	//   _cluj_, _עזר_, _këna, _लौकी_,
   {{0x63a4022e,0x7d051f32,0x6b828fb0,0x69ce4a0a}},	//   _mjin, bahs, rhog, ombe,
   {{0xe894976e,0x602a8201,0x26ddccfe,0xe29f008b}},	//   каль, _həmi, _agwo_, naða_,
   {{0xc30b00c8,0xe5a305c2,0x69ce4cff,0x2d9e83ba}},	//   ষ্টি_, _сири, imbe, vnte_,
   {{0x9634a64c,0x189780f7,0x2fc681c0,0x63a44d00}},	//   вниц, عضوة_, _qhog_, _njin,
   {{0x79950ab4,0x940a8085,0xe72f9ef7,0x929d8035}},	//   yizw, əmək_, صصي_, _pełe,
   {{0x44380072,0x63a4217b,0xdb060c83,0x2d9e8037}},	//   _kpr_, _ajin, voká, unte_,
   {{0x98be8087,0xbddb0176,0x2cb8bc10,0x4438010c}},	//   _dată_, _asèl, ærd_, _jpr_,
   {{0x69da84a6,0x443801bf,0x1e868c9d,0x290100ee}},	//   _hite, _mpr_, _плем, _seha_,
   {{0x69daa892,0xdb0f0e1b,0x29010748,0x2018011b}},	//   _kite, nocé, _peha_, erri_,
   {{0x613383bf,0x6f02cd01,0x6594a59a,0x38c6826b}},	//   cılı, _heoc, _шалу, _gírí_,
   {{0x69dab416,0xd8380048,0x3ebf0503,0x7995020c}},	//   _mite, нэт_, _šut_, rizw,
   {{0x6d4a831d,0x602a8201,0x63a400f1,0x6d5c3b99}},	//   _hafa, _cəmi, _gjin, _anra,
   {{0x6d4ab468,0x29010006,0xc8f50098,0x44384d02}},	// [3db0] _kafa, _teha_, _изпъ, _apr_,
   {{0x6d4a930c,0x443800dd,0x69dacd03,0x656e0c41}},	//   _jafa, _bpr_, _nite, _cobh,
   {{0x6d4acb2e,0x7d054d04,0x628e00ce,0x76464d05}},	//   _mafa, rahs, ćnoš, _esky,
   {{0x3f670364,0x61338182,0x6d4acd06,0x4438061b}},	//   _чтоб, zılı, _lafa, _dpr_,
   {{0x69dacd07,0x6133880a,0xaa458198,0x3ebf00e1}},	//   _bite, yılı, телл, _áut_,
   {{0x69dacd08,0x6d4ab11e,0x3d1c8d14,0x61338201}},	//   _cite, _nafa, _मागे_, xılı,
   {{0x69da8458,0xdb0b8c15,0x5ba785e9,0xead18264}},	//   _dite, logí, _зраз, াডেম,
   {{0x70de1a3b,0x69dacd09,0x7f4d1953,0x6609c680}},	//   _मल्ल, _eite, ndaq, tsek,
   {{0x0ea9835f,0x6f02cd0a,0x613385c5,0x69dacd0b}},	//   ький_, _deoc, tılı, _fite,
   {{0x6609cd0c,0x7aed120f,0x63b62445,0x6d4a917d}},	//   rsek, _afat, _skyn, _cafa,
   {{0x2907b0ec,0x64a58e0b,0x61338182,0xdca5b51e}},	//   mana_, тана, rılı, тани,
   {{0x2907cd0d,0xe29a0972,0x69dacd0e,0x91e60811}},	//   lana_, дам_, _zite, коме,
   {{0x69c88364,0x6d4acd0f,0x61338457,0x4a430081}},	//   _yhde, _fafa, pılı, аняв,
   {{0x657acd10,0x6d4acd11,0x2907c899,0xc1740041}},	//   ckth, _gafa, nana_, _kuɗi_,
   {{0x2018279e,0xbbe880f7,0x7aed0428,0x290797c9}},	//   urri_, _كريم_, _ffat, iana_,
   {{0x2907b10d,0x6d4acd12,0x6d218105,0x7d03cd13}},	//   hana_, _zafa, _माँग_, _hens,
   {{0x2907cd14,0x7d038314,0x645500a4,0x44384d15}},	// [3dc0] kana_, _kens, _arzi, _spr_,
   {{0x2907cd16,0x6455003a,0x7d03888a,0x2d85cd17}},	//   jana_, _brzi, _jens, nhle_,
   {{0x7d03cd18,0x2907ca8e,0x69da965e,0x602a8201}},	//   _mens, dana_, _rite, _təmi,
   {{0x69dacd19,0x7981831d,0x7bc981e4,0x59bc000d}},	//   _site, _allw, _cheu, ोगकर,
   {{0x6d21823c,0x61e403d3,0xdb158019,0x69dacd1a}},	//   _मांग_, _juil, óbál, _pite,
   {{0x644f8341,0x2abd0b4c,0x61e44d1b,0x25fb00c2}},	//   ācij, lábú_, _muil, _लौटी_,
   {{0x69dacd1c,0x26c08110,0xeb9a95fe,0x7bc98014}},	//   _vite, _šio_, _жив_, _fheu,
   {{0x78ba8a56,0x67244d1d,0xf1bf0019,0x69dacd1e}},	//   _vytv, ngij, tták_, _wite,
   {{0x7d03cd1f,0x2907cd20,0xe3b907d9,0x09e68a7f}},	//   _bens, bana_, ktır_, _розн,
   {{0x69da85f8,0x7aed002e,0x6d4a9669,0x444401b4}},	//   _uite, _sfat, _qafa, ow_,
   {{0x351b00be,0xfe6f815b,0x657a80f1,0xf4868729}},	//   ווינ, مدی_, rkth, тупн,
   {{0x63a2cd21,0x6d4acd22,0x44440b99,0x61e42488}},	//   nnon, _wafa, iw_, _buil,
   {{0x81be00c8,0x61e41536,0x6d4aa07b,0x7d0381ec}},	//   েদন_, _cuil, _tafa, _fens,
   {{0xf2d3893f,0x657d80f1,0x61e40046,0x7d03a419}},	//   יער_, ësht, _duil, _gens,
   {{0xb33b0073,0x394c928d,0x6fc59727,0xf4849e29}},	//   ança, _mads_, lóca, _حاشی,
   {{0x7d088343,0x7aed4d23,0x61e40219,0x3dca05ee}},	//   lads, _ufat, _fuil, _ahbw_,
   {{0x6ed60076,0x2907cd24,0x6e20b8b9,0xdfd80098}},	// [3dd0] _मृदु, yana_, numb, тър_,
   {{0x7d088448,0x2907cd25,0x2713001c,0xbbcb800c}},	//   nads, xana_, ện_, िष्क,
   {{0x6e20b64e,0x98ba01d0,0x83198061,0x9f41010c}},	//   humb, _mapě_, فقار_, _luhé_,
   {{0x29078ef9,0x6e20afe0,0x3d1c835a,0x2613816f}},	//   wana_, kumb, _माझे_, _दिली_,
   {{0x2907b39d,0x6e20a479,0x471a0039,0xee870198}},	//   tana_, jumb, _אורג, _рыно,
   {{0x644732d6,0x660d13fa,0x6e20cd26,0x9aa481a8}},	//   _tsji, msak, dumb, جمهو,
   {{0x2907cd27,0x7d03cd28,0x01380039,0x7bc9cd29}},	//   rana_, _rens, דרות_, _theu,
   {{0x2907ca81,0x2f548364,0x6e209d1b,0x3ea09024}},	//   sana_, атьс, fumb, _žita_,
   {{0x4421059c,0x2907b6d9,0x6e2088a7,0x645c9f0a}},	//   luh_, pana_, gumb, årin,
   {{0x4d65cd2a,0x61e41699,0x394c81a9,0x89348290}},	//   уков, _ruil, _gads_, _نعما,
   {{0x44210393,0x7d0381eb,0xa3c7800f,0x290580eb}},	//   nuh_, _vens, _उठा_, _iela_,
   {{0x290584b8,0x660d4d2b,0x7d03a166,0x4fa480e8}},	//   _hela_, ksak, _wens, _києв,
   {{0x22490117,0x61e44d2c,0x2d8b82be,0x2d8314f1}},	//   _csak_, _quil, èces_, _olje_,
   {{0x44210587,0x2905b6d9,0x660d4d2d,0x61e41699}},	//   kuh_, _jela_, dsak, _vuil,
   {{0x6d41cd2e,0xa6db0125,0x2905cd2f,0x44210057}},	//   mela, _maðu, _mela_, juh_,
   {{0x6d41cd30,0x61e40ad0,0x44210587,0x8a960077}},	//   lela, _tuil, duh_, _مشخص,
   {{0x6724044a,0x1fa73650,0x660d28c0,0x6b843e21}},	// [3de0] rgij, укти_, gsak, _ilig,
   {{0x290589b2,0x85064d31,0x5bdc8ebf,0x76440db1}},	//   _nela_, اوان, यद्व, rwiy,
   {{0x44440586,0x44210812,0x290a4d32,0x660d10e1}},	//   uw_, guh_, maba_, asak,
   {{0xd9cc8576,0x290a24e1,0x09e696be,0x501b0039}},	//   ाष्ट, laba_, годн, _אוטו,
   {{0x6d41cd33,0x63a2cd34,0x69de25fa,0x2fc00f06}},	//   kela, rnon, _kipe, mlig_,
   {{0xfce30e86,0x44210812,0x2905cd35,0x661bc603}},	//   _горо, buh_, _cela_, druk,
   {{0x2905cd36,0x6d41b067,0x442100dd,0x290a4d37}},	//   _dela_, dela, cuh_, iaba_,
   {{0x6d4e4d38,0xa3e7823c,0x2fc00f91,0xa8570039}},	//   _haba, _बढ़_, nlig_, ריקה_,
   {{0x6d4e4d39,0x6d41cd3a,0x290a21ea,0x7d088b81}},	//   _kaba, fela, kaba_, tads,
   {{0x6b844d3b,0x01d79a00,0x6d4e0b50,0x26190105}},	//   _alig, _موقع_, _jaba, यूटी_,
   {{0x6d4e4d3c,0x290a4d3d,0x6e2093b2,0xc445803d}},	//   _maba, daba_, sumb, لیون_,
   {{0x6d4e3615,0x7d0882ee,0x661bcd3e,0x2fc014a2}},	//   _laba, sads, bruk, jlig_,
   {{0x6d41abf2,0x2fc01e7c,0x6b8401e4,0x2905c732}},	//   bela, dlig_, _dlig, _yela_,
   {{0x29050307,0x6b840733,0x69de003a,0x22491df8}},	//   úla_, _elig, _cipe, _vsak_,
   {{0x69de0458,0x4cd280ab,0x97a722ea,0x645a0115}},	//   _dipe, _দ্রু, грал, _štin,
   {{0x2fc00f06,0x6f06008e,0x6b8401f4,0x5f942503}},	//   glig_, _cekc, _glig, бист,
   {{0xdb0f3930,0x6458826c,0x4421003d,0x98a503bf}},	// [3df0] nocí, _hrvi, wuh_, ılı_,
   {{0x290a0207,0x6d4e2388,0x4421059c,0x31352ed9}},	//   caba_, _caba, tuh_, _теор,
   {{0x6add8e18,0x6d4e4d3f,0x2905810b,0x7bcd01c5}},	//   यश्र, _daba, _rela_, _khau,
   {{0x4421059c,0x6d41cd40,0x64588668,0x8f470cf9}},	//   ruh_, zela, _mrvi, _сход,
   {{0x290580a9,0x4421059c,0x7bdf009f,0x6d418234}},	//   _pela_, suh_, _miqu, yela,
   {{0x6d4e4d41,0x2d8300ce,0x6d418ece,0x44214d42}},	//   _gaba, _ulje_, xela, puh_,
   {{0x6602990b,0xddcb8110,0x2905cd43,0xa3e48740}},	//   _awok, žiūr, _vela_, _भूल_,
   {{0x6d4e4d44,0xee39838d,0x291b8201,0x290a4d45}},	//   _zaba, вни_, şqa_, zaba_,
   {{0x6d418890,0x6d4e4d46,0x2905cd47,0x6458cd48}},	//   tela, _yaba, _tela_, _arvi,
   {{0x6d4e4d49,0x290a4d4a,0x80bb016f,0x6b964d4b}},	//   _xaba, xaba_, _शुभे, _smyg,
   {{0x30a788cc,0x69de4d4c,0x63a9835f,0x7bdf0187}},	//   _срав, _ripe, _kjen, _biqu,
   {{0xe72e99b6,0x7bcd03d3,0x6d41cd4d,0xeb9a1935}},	//   _ќе_, _chau, sela, тим_,
   {{0x63a9cd4e,0x2fc00e23,0x7bcd4d4f,0x7bdf0333}},	//   _mjen, vlig_, _dhau, _diqu,
   {{0x6f06372c,0x7d07000d,0x7bdf03a8,0x63a98140}},	//   _sekc, _nejs, _eiqu, _ljen,
   {{0x63bbcd50,0x7bdf4d51,0x9c13819d,0x2fc04d52}},	//   _okun, _fiqu, _kọmu, tlig_,
   {{0x6d4e4d53,0x63a9cd54,0x290a0c6f,0x63bb9119}},	//   _saba, _njen, saba_, _nkun,
   {{0x7ae40578,0x2fc00f91,0x290a4d55,0xaa460b88}},	// [3e00] _igit, rlig_, paba_, _тепл,
   {{0x6d4e381f,0x63a9acb1,0x929d809a,0x63bb86a0}},	//   _qaba, _ajen, _pełn, _akun,
   {{0x2d9a4d56,0x6d4e0006,0x7d074d57,0x2fc04d58}},	//   ripe_, _vaba, _dejs, plig_,
   {{0xfbc39056,0x6d4e06a0,0x63a982ce,0x2d9a0247}},	//   обхо, _waba, _cjen, sipe_,
   {{0x7ae4803e,0x7d070067,0x2d9a4d59,0x425481a8}},	//   žito, _fejs, pipe_, إنتر,
   {{0x63a9813c,0x2d9a00f1,0x93bd0087,0x799c020c}},	//   _ejen, qipe_, ntăr, nirw,
   {{0x64a30084,0x50668071,0xdc670071,0x76598114}},	//   _дара, ртла, _кард_, _arwy,
   {{0x63a9cd5a,0x7ae44a76,0x799c00b4,0x394301a9}},	//   _gjen, _ngit, hirw, zejs_,
   {{0xd0fb1513,0x7bcd022c,0x799c020c,0xe9da87b6}},	//   ्रमण_, _rhau, kirw, _ака_,
   {{0x7bdf4d5b,0x7bcd453f,0x76598114,0x637f0168}},	//   _siqu, _shau, _drwy, _gënj,
   {{0xdeef96fe,0xfe1887e6,0x2ec30770,0x409680d6}},	//   _мы_, _दिवस_, _शर्त, _трат,
   {{0x7bcd022c,0x63a981b9,0x645882d4,0x06ea8a27}},	//   _qhau, _xjen, _vrvi, _ऑलिव_,
   {{0xc3338039,0x7bdf009f,0x7762cd5c,0x7985022c}},	//   חור_, _viqu, _inox, _plhw,
   {{0x7ae400ad,0x799c020c,0x3f891670,0x7bdf0580}},	//   _egit, girw, whau_, _wiqu,
   {{0x7d074d5d,0x7bcd10af,0x3f890355,0x7bdf16dc}},	//   _rejs, _thau, thau_, _tiqu,
   {{0x386d2828,0xb8cf00c2,0x04db81c6,0x93bd0493}},	//   ćer_, _कश_, _בקול, drăg,
   {{0x6b8704c0,0x3f890114,0xfaff0168,0x799c36ed}},	// [3e10] _مشکل, rhau_, mbë_, birw,
   {{0x63a9811f,0x6b9d033e,0x7bc283a8,0x78ad87c0}},	//   _sjen, lisg, elou, şavi,
   {{0x70550c48,0x63a98668,0xaab802e3,0x637f0168}},	//   _انجا, _pjen, _مدیر_, _nënk,
   {{0x2d9802d0,0x6b9d2937,0x6e243648,0xdce380c3}},	//   _emre_, nisg, buib, _tonć,
   {{0x63a9a1be,0x6f0d0079,0x4ec180ab,0x7f3a00be}},	//   _vjen, maac, _উল্ল, _גערו,
   {{0x5d850250,0x7762b6f8,0x3f868580,0x6b9d0bb1}},	//   _السل, _anox, _alou_, hisg,
   {{0x63a98a38,0x3f86867f,0x7bc2cd5e,0xb4c28778}},	//   _tjen, _blou_, blou, ्धो_,
   {{0x6d452b36,0x7bc2cd5f,0x63bba6bd,0x63a9cd60}},	//   leha, clou, _ukun, _ujen,
   {{0x799c00b4,0x332d816a,0x3f9900c3,0xf1bf0061}},	//   yirw, _icex_, _mmsu_, ntás_,
   {{0x51748013,0x41749e95,0x27178028,0x6d4545e8}},	//   _والأ, _والس, ển_, neha,
   {{0x61f60bd9,0x3b0a140b,0x61e98020,0xe7c703eb}},	//   _styl, лено_, _huel, लताप,
   {{0x61e98010,0x80d080ab,0x3fc9803d,0x03a60a0e}},	//   _kuel, _স্ক্, _صدای_, симо,
   {{0xeb97204a,0xf668803d,0x61e1cd61,0x799c0f8e}},	//   сия_, _نحوه_, _kill, tirw,
   {{0x645a1123,0x61e9cd62,0x61e1cd63,0x9f580388}},	//   _štim, _muel, _jill, mpré_,
   {{0x63b98d38,0xdca2867c,0x61e1938e,0x64a2b4fb}},	//   kown, _наши, _mill, _наша,
   {{0x4425cd64,0x61e1a280,0x93bd0087,0x799c0542}},	//   mul_, _lill, stăr, sirw,
   {{0x44258c6e,0x0d86196e,0x63b9cd65,0x06ca01e5}},	// [3e20] lul_, блан, down, угай_,
   {{0xd9100416,0x6d45105d,0xbddb0032,0x4425cd66}},	//   _زیر_, geha, _apèb, oul_,
   {{0x4425cd67,0x98a78084,0xdb0f1727,0x224d8176}},	//   nul_, menė_, locá, _asek_,
   {{0x61e1cd68,0x6f0d02ed,0xf1bf066e,0x61e9811b}},	//   _aill, caac, stát_, _buel,
   {{0x44258006,0x61e19ed3,0x61e98e1b,0x20058609}},	//   hul_, _bill, _cuel, _awli_,
   {{0x61e980ad,0x4425ca13,0x61e19581,0x76498079}},	//   _duel, kul_, _cill, dwey,
   {{0x6c860013,0x61e1cd69,0x01338013,0x4425a3ee}},	//   _الأم, _dill, سعود, jul_,
   {{0xf1bf01ac,0x63b9809a,0x644e0079,0x645c3f3c}},	//   ntár_, cown, _isbi, _irri,
   {{0x61e1cd6a,0x35f7803d,0xb4c286ab,0x7c3b00fe}},	//   _fill, یرید_, ्ध्_, _ćuri,
   {{0x61e1cd6b,0x4425b309,0x61ef80e7,0x644e026c}},	//   _gill, ful_, _écla, _ksbi,
   {{0xb5fb0510,0x4425cd6c,0x22400077,0x61e98102}},	//   _gráf, gul_, _apik_, _zuel,
   {{0x29c98511,0xe29f007b,0x290ecd6d,0x60db80be}},	//   núan_, laði_, lafa_, _עקאנ,
   {{0x61e1cd6e,0x6b9d051e,0xfaff03ed,0x6d454d6f}},	//   _yill, risg, rbë_, yeha,
   {{0x44258850,0x645c011e,0x61e18079,0x644e08ae}},	//   bul_, _orri, _xill, _osbi,
   {{0x65750a56,0x44258012,0x6f0d30f9,0x644e0267}},	//   _rozh, cul_, taac, _nsbi,
   {{0x2d9ecd70,0x53a40251,0x27e200fc,0x290ecd71}},	//   lite_, _најб, _cikn_, hafa_,
   {{0x645c3260,0x55751677,0x6d454d72,0x6f0d01b4}},	// [3e30] _arri, огат, teha, raac,
   {{0xae1e009a,0xf1bf0e06,0x2d8700e1,0x994d0084}},	//   यंजन_, rtás_, óne_, ržų_,
   {{0x6d454d73,0x61e985b4,0x58d5059d,0xe29f01fa}},	//   reha, _suel, _фонт, daði_,
   {{0x61e1c36d,0x2d9ecd74,0x6d451ad4,0x53c917a3}},	//   _sill, hite_, seha, रतिश,
   {{0x2d9e8a8e,0x4425cd75,0x2bb18063,0x764982a3}},	//   kite_, zul_, jące_, xwey,
   {{0x61e99099,0x61e19abf,0x2d9e8805,0x4425bd9b}},	//   _vuel, _qill, jite_, yul_,
   {{0x39530101,0x4425cd76,0x7dc69434,0x69dd81e8}},	//   _maxs_, xul_, rðsl, _èsem,
   {{0xe6199b78,0x533493b4,0x4425cd77,0x63ad27ce}},	//   ади_, _нест, vul_, _njan,
   {{0x61e1cd78,0x2d9e8578,0x69c380e1,0x44259cc5}},	//   _till, fite_, plne, wul_,
   {{0x4425cd79,0x2d9e80a9,0x161e000f,0xb5fb0510}},	//   tul_, gite_, यूटर_, _tráf,
   {{0x5baa168a,0x61fd2170,0x92e500ab,0xb5fb4d7a}},	//   иком_, epsl, _পড়ে_, _frág,
   {{0x44258c6e,0x3c31826f,0x394788f8,0xc169007c}},	//   rul_, ráv_, lens_, _בח_,
   {{0x4425ad7b,0x2d9ec453,0x63ad4d7b,0x0cc64252}},	//   sul_, bite_, _djan, _वर्म,
   {{0x6b89c339,0x4425cd7c,0x39478082,0x80d080ab}},	//   _lleg, pul_, nens_, _স্ট্,
   {{0x765d00f1,0x6b9b82ec,0xaf9a1ae1,0x6b89cd7d}},	//   _arsy, _omug, атах_, _oleg,
   {{0x82a600e8,0x290e8242,0x6b898133,0xfbc30081}},	//   _майж, zafa_, _nleg, _общо,
   {{0x1dc501fe,0xb6a604fa,0x7ae4826f,0x2240008e}},	// [3e40] वतंत, циал, žitk, _upik_,
   {{0x6b89cd7e,0x6b9ba0ee,0x644e0267,0x26c20084}},	//   _aleg, _amug, _psbi, _vyko_,
   {{0x3947990e,0x66e62139,0x2db680be,0x29c98511}},	//   dens_, _мона, קלען_, túan_,
   {{0x3947913b,0x89360019,0xd62a0eef,0xdce18ec3}},	//   eens_, _اٹھا, _коме_, eklī,
   {{0x290ec219,0x28f8854c,0x3947cd7f,0x5f0301e2}},	//   tafa_, бель_, fens_, _ізра,
   {{0x3947cd80,0x753c003b,0xd01a95b7,0x201a841c}},	//   gens_, _ubrz, афи_, ápio_,
   {{0xcc2480ab,0x645c0102,0xda0b8105,0xe29f008b}},	//   _বন্ধ_, _urri, सीबत_, raði_,
   {{0x2d9ecd81,0xfc4683fb,0x93fb02f6,0x290ecd82}},	//   wite_, šíku_, _כללי, safa_,
   {{0xe29a80a9,0x7d188216,0x21a682bc,0xdcfa81d0}},	//   _таа_, _pdvs, _диам, chtě,
   {{0x3947cd83,0x66090214,0x63ad004a,0x2bb1866f}},	//   cens_, _çeke, _sjan, rące_,
   {{0xa3e4800f,0x63ad4d84,0x7d0a807b,0x290c80b9}},	//   _भूख_, _pjan, _vefs, _ieda_,
   {{0x3f8dcd85,0x78ad84e8,0x291a0db1,0xf7468956}},	//   cheu_, ťový, _adpa_, _федо,
   {{0x7fd78159,0x7d0ab66c,0xcb138039,0x753d8019}},	//   _וואס_, _tefs, ולר_, ősza,
   {{0x290ccd86,0x27fa00dd,0x15f1064a,0xad9b026b}},	//   _jeda_, _btpn_, _अंबर_, _ewúj,
   {{0x6d48829e,0xdfd50198,0xcf9b04ae,0x69d8a023}},	//   meda, зовы, аја_, imve,
   {{0x491703bb,0x290ccd87,0x7c2881bf,0x442105b9}},	//   _भएको_, _leda_, mudr, vrh_,
   {{0x3f848b99,0x394780e7,0x645a81a3,0xd6db0956}},	// [3e50] ikmu_, yens_, lvti, ртв_,
   {{0x63bd0052,0x6d48cd88,0x6b89cd89,0x32090901}},	//   losn, neda, _sleg, _iway_,
   {{0x3947cd8a,0x6b89bbfe,0x29111acc,0xd5b8102a}},	//   vens_, _pleg, maza_, ісу_,
   {{0x61ed0590,0x291100fa,0x69c74292,0x6d488074}},	//   _kual, laza_, llje, heda,
   {{0x290ccd8b,0x6d48cd8c,0x61ed0057,0x645e8988}},	//   _beda_, keda, _jual, _špil,
   {{0x6d488025,0x88df00c8,0x29110ca3,0xaca3019d}},	//   jeda, _ব্যক, naza_, _apục,
   {{0x764285b4,0x290ccd8d,0x3947920b,0x764d0234}},	//   _apoy, _deda_, rens_, lway,
   {{0x6b9b8578,0x6d554d8e,0x3947a280,0x2911308f}},	//   _umug, _haza, sens_, haza_,
   {{0x6d554d8f,0x29114d90,0x3947800b,0xd7068009}},	//   _kaza, kaza_, pens_, чные_,
   {{0x61fb9904,0x69c70499,0xb998a1f6,0x9f420168}},	//   _itul, jlje, _двух_, _pikë_,
   {{0x6d554d91,0x1b0e80ab,0x3209279a,0x29110300}},	//   _maza, _হাতে_, _away_, daza_,
   {{0x61ed0c41,0x320902d6,0x29110087,0x09b4064a}},	//   _bual, _bway_, eaza_, ंक्य,
   {{0x61ed0693,0xed598767,0x69c180b9,0x69c7026c}},	//   _cual, _гол_, _kkle, flje,
   {{0x6d554d92,0x61ed0219,0x6e298264,0x291128e3}},	//   _naza, _dual, mueb, gaza_,
   {{0x61e50609,0x32091029,0x7ae982f9,0xfaff03ed}},	//   _dihl, _eway_, _oget, gjës_,
   {{0x7ae9b112,0x7ae481ac,0x09a8a0d8,0x61fba4f2}},	//   _nget, žiti, _औद्य, _otul,
   {{0x69c70ee1,0x6fc58073,0x61ed4d93,0x29111ea2}},	// [3e60] blje, góci, _gual, baza_,
   {{0x2a604d94,0x6d554d95,0x637f0168,0x69c7026c}},	//   _irib_, _caza, _dënu, clje,
   {{0x981607bd,0x61fbb339,0x644380b9,0x6d554d96}},	//   _عبدا, _atul, _jpni, _daza,
   {{0x261c823c,0x290c8665,0x225f821e,0x764d0365}},	//   _मिली_, _seda_, _bruk_, bway,
   {{0x6f0439fd,0x11548c4f,0x6d4881f8,0x3b0d81b4}},	//   mbic, дклю, yeda, _deeq_,
   {{0x225f8b3c,0x6443cd97,0x6d55205e,0xb5fb007b}},	//   _druk_, _opni, _gaza, _fráb,
   {{0x8c434d98,0x6d48cd99,0xd90d8077,0xf7729e91}},	//   _пере, veda, شین_, فاظ_,
   {{0x69c1cd9a,0x6d554d9b,0x29110314,0x7c288687}},	//   _ekle, _zaza, zaza_, vudr,
   {{0x6d55448d,0x290ccd9c,0x6d48cd9d,0x6578822c}},	//   _yaza, _teda_, teda, _povh,
   {{0x63a2cd9e,0x61eb00e7,0x290c89c4,0xb33b041c}},	//   lion, _égli, _ueda_, diça,
   {{0xfe6f8bca,0x61ed378e,0xdb06026f,0xab5b02d0}},	//   ندی_, _sual, soký, slüm,
   {{0x63a2cd9f,0x291130a0,0x764d3392,0x637f00f1}},	//   nion, waza_, yway, _nënt,
   {{0x61ed2a4b,0x63bd4da0,0x6d48a81c,0x6282c423}},	//   _qual, rosn, peda, nyoo,
   {{0x63a29d15,0xbddb22c6,0x2a600176,0x26c6cda1}},	//   hion, _apèn, _drib_, _iyoo_,
   {{0x29114da2,0x6d554da3,0x63a2cda4,0x27e68176}},	//   raza_, _raza, kion, _kion_,
   {{0x69c723e3,0x15f1023c,0x764d4da5,0xf7730f24}},	//   slje, _अंदर_, tway, راز_,
   {{0x63a282f7,0x6d554da6,0x29114da7,0x672d04b9}},	// [3e70] dion, _paza, paza_, rgaj,
   {{0x6d550201,0x7d1c0267,0xb5fb016a,0x26c701a9}},	//   _qaza, _cdrs, _arác, āno_,
   {{0x6b8d01eb,0x645e8024,0x80c280ab,0x61fbcda8}},	//   _klag, _špij, ষেত্, _stul,
   {{0x69c1cda9,0x6d552cc3,0xf65f006a,0x6e24117d}},	//   _skle, _waza, _træ_, brib,
   {{0x6e244daa,0x6d55207b,0x26c681c0,0x2fc903fc}},	//   crib, _taza, _nyoo_, mlag_,
   {{0xd90f8117,0x2fc94dab,0x6b8d023e,0xbd4501a8}},	//   ایا_, llag_, _llag, _تنسي,
   {{0x23690025,0x63a2809a,0x645a0042,0x6b8d4dac}},	//   _onaj_, bion, _štiv, _olag,
   {{0x225fcdad,0x7e64811f,0x6b8d01bc,0x69c18035}},	//   _truk_, _šipa, _nlag, _wkle,
   {{0xe3b0819f,0x6f0f35ae,0x645cb20d,0x673b9320}},	//   _صرف_, _mecc, ærin, rfuj,
   {{0x6b8d4dae,0x6f0f12d0,0x6e2985a4,0x2fc901ec}},	//   _alag, _lecc, rueb, hlag_,
   {{0x637f0168,0x27e69009,0x1b4a091e,0x753d8061}},	//   _nëns, _fion_, озни_, őszo,
   {{0xfaa601e5,0x6b8d0362,0x15ed064a,0x7bda80e5}},	//   дамо, _clag, जदार_, _ètut,
   {{0x6e29907c,0x7ae482d4,0xe29714ef,0x6e24029a}},	//   queb, žitv, дая_, xrib,
   {{0x63a2cdaf,0x6f1d353e,0xb33b03a7,0x27e68102}},	//   zion, _adsc, riça, _zion_,
   {{0x50b51b47,0x6f0f4db0,0x14d19130,0x91e30425}},	//   есту, _becc, _हरिण, торе,
   {{0x63a2a09c,0x201e0289,0x6f0f4db1,0x2905008b}},	//   xion, štio_, _cecc, ðlar_,
   {{0x6f044db2,0x26c681e9,0x2a60010c,0x7bc42aa0}},	// [3e80] rbic, _xyoo_, _urib_, _ikiu,
   {{0x236902a5,0x6f044db3,0x63a2809a,0x6282804f}},	//   _znaj_, sbic, wion, vyoo,
   {{0x63a286f3,0xb5fb016b,0x5f06069b,0x2fc94db4}},	//   tion, _prác, _озна, blag_,
   {{0x6e24447b,0x7d0e326b,0x27f70efc,0x7d0501a8}},	//   prib, _webs, žené_, abhs,
   {{0xd0418085,0xb5fb01d0,0x25be8216,0x6fc5841c}},	//   _izlə, _vrác, yotl_, nócu,
   {{0x2fc000f7,0x6f0f01e8,0x14b70072,0x6d48016b}},	//   loig_, _zecc, _अडचण, ímač,
   {{0x03a689b8,0xb5fb4db5,0xa3c3073c,0xa2a51370}},	//   _живо, _trác, ्तम_, _चेन्,
   {{0x97a38d15,0xab5b1238,0x2269928a,0x44259502}},	//   крыл, rlük, átký_, drl_,
   {{0x7ae9025b,0x03a38087,0x91a6819d,0x6b8d0362}},	//   žetk, _рито, gwọ_, _rlag,
   {{0x6b8d44ef,0xe16695a9,0x7bc40c53,0xe123997b}},	//   _slag, _تدري, _akiu, _амфи,
   {{0x6b8d4db6,0xe046804a,0x291e9e8f,0x308687c3}},	//   _plag, _інди, _idta_, _تلاف,
   {{0x0a6b066a,0xa3c0b850,0xdcf504e8,0x76460123}},	//   орги_, ुति_, _rozč, _opky,
   {{0xfe7281bd,0x61e8977c,0xed5a8e8e,0x6b8d0805}},	//   _جدا_, _kidl, _мод_, _vlag,
   {{0x6f0f1883,0x7dcf8aa2,0x02a30135,0x7bc405ee}},	//   _secc, løsn, _nrụọ, _ekiu,
   {{0x61e8c62b,0x6f0f4db7,0x656a80f7,0xdc3e8ec3}},	//   _midl, _pecc, _infh, rģēt,
   {{0x7e6292f1,0x6d58cdb8,0x6b8d003a,0x442ccdb9}},	//   _krop, _hava, _ulag, mud_,
   {{0x442ccdba,0x6d58cdbb,0x4ad30076,0x2fc904fe}},	// [3e90] lud_, _kava, _सरिव, rlag_,
   {{0x2fc9190e,0xca48003d,0x6d5acdbc,0x36d40087}},	//   slag_, _کلیه_, ndta, тоур,
   {{0x442ccdbd,0x2fc94dbe,0x6d58804f,0x3c388061}},	//   nud_, plag_, _mava, név_,
   {{0xad9b0dfa,0x61e88362,0x61fb0162,0x291e8e06}},	//   _stúd, _aidl, ţulu, _adta_,
   {{0x657c005f,0x645a003a,0x61e881b9,0xa2a52342}},	//   _forh, _štit, _bidl, _चेम्,
   {{0x442ccdbf,0x6d5887dd,0x7dd00106,0xdb1d0106}},	//   kud_, _nava, läsn, llsä,
   {{0xb8f79344,0x442cb55e,0x61e88915,0x7e628091}},	//   _सर_, jud_, _didl, _arop,
   {{0x7aed4dc0,0xa4d4035f,0x442ccdc1,0xa2f90540}},	//   _ngat, _росі, dud_, ंडोज_,
   {{0x6d58cdc2,0xe4e30b75,0x6e2d016a,0xaad3c765}},	//   _bava, _कृति_, nuab, _तरिक,
   {{0x6d58cdc3,0x7aed4dc4,0x777d0282,0xc8fb064a}},	//   _cava, _agat, _losx, ्रोम_,
   {{0x6d58cdc5,0x44258362,0x442ccdc6,0x2907807a}},	//   _dava, url_, gud_, mbna_,
   {{0x69c54dc7,0x2d8ecdc8,0x64470197,0x7853829a}},	//   _akhe, _elfe_, _mpji, _nəvə,
   {{0xbe878b76,0x6d5880e5,0x7e62cdc9,0x776b8234}},	//   _تجاو, _fava, _grop, _ingx,
   {{0x442ca09b,0x6d58cdca,0x201e025b,0x442582d4}},	//   bud_, _gava, štim_, prl_,
   {{0x1beb09a3,0x25a580f5,0x186744cc,0xa0670eef}},	//   _जंगल_, mill_, нари_, нара_,
   {{0x6d58984c,0x3f890867,0x9f468081,0x7bc4004f}},	//   _zava, gkau_, _cioè_, _ukiu,
   {{0xcf9280be,0x6e3bcdcb,0x63a609da,0x6d58cdcc}},	// [3ea0] אטן_, ntub, mikn, _yava,
   {{0x63a609ca,0x25a5cdcd,0x09062927,0x7dc6053d}},	//   likn, nill_, _япон, رقان,
   {{0x03269d91,0x657c02af,0x399b00be,0x61e8839c}},	//   еден, _vorh, _זייד, _ridl,
   {{0xb5fb0019,0x61e8cdce,0x63a6026f,0x6e3b8a32}},	//   _irán, _sidl, nikn, ktub,
   {{0x6f630364,0x25a5807b,0x71a68e11,0xf1bf0511}},	//   _связ, kill_, надз, irán_,
   {{0x64a622d2,0xdca61507,0xf1bf00f7,0x442ccdcf}},	//   _зага, _заги, hrán_, yud_,
   {{0xb0da92c6,0x442c8085,0x63a64dd0,0xfdbe0035}},	//   येंग, xud_, kikn, ्तीफ,
   {{0xdb1d02be,0x395a0074,0x9fb8016b,0x6d58cdd1}},	//   posé, _laps_, _očí_, _sava,
   {{0x6d58cdd2,0x61e886be,0xf1bf05a4,0x569481e5}},	//   _pava, _tidl, drán_, тапт,
   {{0x442c8778,0x40968fbb,0x721b84de,0x6286219c}},	//   tud_, _прет, _מומח, dyko,
   {{0x46ea80a9,0x6fc58e15,0xf1bf0333,0x63a64dd3}},	//   _еден_, tóct, frán_, fikn,
   {{0x442c99f6,0xaca4019d,0xf1bf4dd4,0x63a600ee}},	//   rud_, _apịr, grán_, gikn,
   {{0x6d589ff8,0x7e62cdd5,0x32191d5e,0x442ccdd6}},	//   _tava, _urop, ussy_, sud_,
   {{0xf2d3893f,0xa02482af,0xdee38012,0x442ccdd7}},	//   טער_, _größ, _сочи, pud_,
   {{0xda1d05b3,0xc4f7893f,0x8d5b8039,0xf1bf016a}},	//   _भटकत_, _אזוי_, _זכוי, brán_,
   {{0x0aeb0f99,0x7aed4dd8,0x6e2d4dd9,0x317e8c00}},	//   _عربي_, _ugat, tuab, _lotz_,
   {{0x28a7881f,0x66041400,0x9f4680e5,0x8aa40a41}},	// [3eb0] _केनि, gpik, _cioé_, _брэд,
   {{0x2249003a,0xb5fb4dda,0x3f894cfa,0x64550061}},	//   _ipak_, _frán, skau_, _pszi,
   {{0x6f1602bf,0xdcf8803a,0x26e200c8,0x645a0353}},	//   bayc, _novč, গুলো_, _štir,
   {{0xa3c3123a,0xae218592,0x28c4809a,0x20010234}},	//   ्ति_, _मिलन_, _लुधि, _ithi_,
   {{0xe1f890ac,0x6e3bab01,0xdb0825b3,0x2fd90101}},	//   егі_, xtub, élék, _ihsg_,
   {{0x6145bbae,0x25a5007b,0x63a600b9,0x7dcb02f1}},	//   тека, _öll_, zikn, küsi,
   {{0xa3c323bd,0x62861bae,0x25a5cddb,0x29134ddc}},	//   ्ता_, zyko, vill_, _mexa_,
   {{0x9ff300c8,0xf7719ddd,0xfe458073,0x6d8d8144}},	//   _জবাব_, شاب_, внио, _cúan,
   {{0xe80d81ce,0x63a6005c,0x25a5a51d,0x99558087}},	//   _सबका_, vikn, till_, _икац,
   {{0x6e3b9600,0x2913008e,0xb46580e8,0x62864b51}},	//   rtub, _nexa_, вкол, vyko,
   {{0x63a6085c,0x6e3b913c,0x20010282,0x22494ddd}},	//   tikn, stub, _nthi_, _apak_,
   {{0x6286185c,0x395a4dde,0x03a62ec1,0x661d0140}},	//   tyko, _saps_, тимо, _ovsk,
   {{0xeb9709b4,0xed4ecddf,0x63a6010b,0x25a5cde0}},	//   тия_, _ко_, rikn, pill_,
   {{0x412a035f,0x2fcdcb48,0x63a63286,0x7d1ccde1}},	//   ього_, lleg_, sikn, órst,
   {{0x6f09826f,0x661d0186,0xed52003d,0x21210144}},	//   obec, _avsk, یپر_, _ddhh_,
   {{0x2fcd8eb9,0x810d886a,0x626619a5,0xe4e480e8}},	//   nleg_, हरुख_, _авиа, _січн,
   {{0x69c399e0,0x63a43b20,0xee3a0c5c,0xb8c9199e}},	// [3ec0] kone, _imin, ьна_, _खे_,
   {{0x66040072,0x69c3835f,0xb5fb001c,0x6d41cde2}},	//   rpik, jone, _trán, nfla,
   {{0x66044de3,0x69c3cde4,0xad9b026b,0x741315a9}},	//   spik, done, _awús, لولا,
   {{0x69ce05ec,0x09ca970c,0xb5fb001b,0x661b94c7}},	//   llbe, ित्य, _král, ksuk,
   {{0x69c3a280,0x27e04de5,0xaefb0362,0x2fcd821e}},	//   fone, mmin_, _cnùu, dleg_,
   {{0x29184de6,0xf5030198,0x2fc68687,0x39908362}},	//   nara_, _взро, _skog_, _bàsa_,
   {{0xa3d201ab,0x6da30f2e,0x6d5c04bc,0x656e0046}},	//   वता_, _тира, _iara, _inbh,
   {{0x27e013f2,0x368a87b6,0x588381e5,0x661b808e}},	//   nmin_, дсон_, рыша, fsuk,
   {{0x6d5c34b1,0x291831cc,0x6e299123,0x69c3c4de}},	//   _kara, kara_, greb, bone,
   {{0x63a44de7,0x29184de8,0x69c3cde9,0xe7ed864a}},	//   _amin, jara_, cone, _चूका_,
   {{0x92af150b,0x27e00859,0x6d5c4290,0x7c3e4dea}},	//   _করে_, kmin_, _mara, ntpr,
   {{0x6d5c4deb,0x2913062f,0x224900b9,0x6e299fd6}},	//   _lara, _sexa_, _ppak_, breb,
   {{0x27e04dec,0x29184ded,0x6fc59e00,0x6722cdee}},	//   dmin_, fara_, pócr, _idoj,
   {{0x29184def,0x63a40d6a,0x660290ab,0x7dc6808b}},	//   gara_, _emin, _itok, rðss,
   {{0x28f802c7,0x25ab80e7,0x291301df,0xdb1b80ff}},	//   тесь_, ècle_, _vexa_, _khuô,
   {{0x69c3cdf0,0x6d5c02b8,0xe4e30770,0x63a4009a}},	//   zone, _aara, _कृषि_, _gmin,
   {{0x29184df1,0x645a075f,0x6ff180eb,0x69c3cdf2}},	// [3ed0] bara_, _štip, _vāci, yone,
   {{0x29180763,0x63a407d8,0x660902d0,0x5c070ba7}},	//   cara_, _zmin, _çekm, вяда,
   {{0x6d5c127b,0x80a2835a,0x6ec9800d,0x2001005d}},	//   _dara, _केले, _हुनु, _uthi_,
   {{0x6602b642,0x69c385f8,0xff040ba7,0x6d5c1c9d}},	//   _otok, wone, _вярн, _eara,
   {{0x6d5c05a3,0x69da88ae,0xa3ab21ef,0x1308804a}},	//   _fara, _bhte, _गगन_, тній_,
   {{0x6d5c4a2b,0x6e299edc,0xdb0600f1,0xdb1d0019}},	//   _gara, vreb, tikë, dosí,
   {{0x6602cdf3,0x2fcdcdf4,0x14c7003d,0x7c3e090d}},	//   _atok, tleg_, _شهری_, ctpr,
   {{0x6e29ba71,0x29183a2f,0xdb060168,0xdb1b80ff}},	//   treb, zara_, rikë, _chuô,
   {{0x6d5c4df5,0x29184df6,0x2fcd821e,0x7f5d4df7}},	//   _yara, yara_, rleg_, _masq,
   {{0x6e29cdf8,0x6d5c0be9,0x63a40ecb,0x27e04df9}},	//   rreb, _xara, _smin, zmin_,
   {{0x29182cdb,0x6d418e51,0x51848a42,0xb4b10035}},	//   vara_, rfla, _тута, _ओशो_,
   {{0x29184400,0xb5fb38b4,0x7f5d07f1,0xe81d00c2}},	//   wara_, _arám, _nasq, _फिजा_,
   {{0x29184dfa,0x6d4715f2,0x69da825d,0x9d4581e5}},	//   tara_, _obja, _yhte, _белд,
   {{0xed5681cf,0xf65281c6,0x21f980d7,0xf1a6914f}},	//   _бош_, _לצד_, _mèh_, कोपन,
   {{0x29184dfb,0xb5fb4dfc,0xf99f0247,0x7c3e2900}},	//   rara_, _drám, nsèy_, xtpr,
   {{0x29184dfd,0x2bbb18b8,0x6d474dfe,0x63a40461}},	//   sara_, _उदया, _abja, _umin,
   {{0x7bc6185b,0x29c98388,0x0e660110,0xb5fb0174}},	// [3ee0] moku, núas_, ыкан, _frám,
   {{0x6d5c4dff,0x1a9b0158,0x3c3c458c,0x7bc98176}},	//   _qara, _נייע, tív_, _akeu,
   {{0x6d5c4e00,0xef198063,0x31570158,0x7f5d002a}},	//   _vara, każ_, _גיין_, _fasq,
   {{0x69da88cf,0x6d5c4e01,0x44261fc2,0x7bc60234}},	//   _shte, _wara, čo_, noku,
   {{0x6d5c4e02,0xef19809a,0x7bdb8079,0x69650fd3}},	//   _tara, daż_, _dhuu, _صدیق,
   {{0x1db801fe,0xdd920481,0x6d5c4e03,0x443e8357}},	//   _आदित, _اوس_, _uara, ytt_,
   {{0x7bc64e04,0x6b8092f1,0x3f824e05,0x443e03e7}},	//   koku, _tomg, _koku_, _ët_,
   {{0x3f820364,0x201e82f7,0xf09301c6,0x2d838198}},	//   _joku_, _vvti_, מנו_, öjen_,
   {{0xaab88f12,0x09368bbe,0xa91c80e1,0x01368199}},	//   _अशिक, _مراج, _voľb, _معاد,
   {{0xa2a50beb,0xd6570039,0x7981ce06,0x3b004e07}},	//   _चेष्, ניית_, _golw, _afiq_,
   {{0x3a200118,0x94d4bc7a,0x7e640100,0xdb1b827d}},	//   _avip_, ронц, hvip, _thuô,
   {{0xdb09820f,0xd4978c6e,0x3f8209b6,0x7dcb0965}},	//   _vjeç, урь_, _noku_, lüst,
   {{0x6602ce08,0x7f5d07f1,0x395e86ab,0x00000000}},	//   _utok, _rasq, _kats_, --,
   {{0xdcfc1024,0xad9b0032,0x365b81c6,0xba00819d}},	//   _borč, _atún, _נכונ, _ọọ_,
   {{0x6ab0ce09,0x7f5d4e0a,0x7d150061,0x43950110}},	//   जपुर, _pasq, _rezs, _вайс,
   {{0x7d1a8c0f,0x29c98125,0x998681d0,0x395ece0b}},	//   lats, núar_, spoň_, _lats_,
   {{0xb5fb02ba,0xaaa48023,0x61f61f1b,0x3f824e0c}},	// [3ef0] _trám, _खेलक, _guyl, _doku_,
   {{0x442c81d8,0x7d1ace0d,0x7bc98a53,0x7bdbce0e}},	//   ord_, nats, _skeu, _shuu,
   {{0x320480b9,0xd5b81ac0,0x7f5d0722,0xdcfc011a}},	//   _atmy_, уст_, _tasq, _gorč,
   {{0x7d1ace0f,0xfaff00f1,0xc8ff80d4,0x2a694d7b}},	//   hats, ncë_, ॉर्म_, _krab_,
   {{0x6f0d0483,0x7d1ace10,0xee8717ae,0x7981a404}},	//   mbac, kats, _сыно, _polw,
   {{0x7d1abbce,0x7bc620b3,0xef19809a,0xe1f080d7}},	//   jats, zoku, waż_, سسه_,
   {{0x7bc6400f,0x7981837a,0x7d1ace11,0x6f0d4d10}},	//   yoku, _volw, dats, obac,
   {{0x2d8300a9,0x82f880f7,0x44334e12,0x6f0d1839}},	//   _hoje_, _مركز_, mux_, nbac,
   {{0x2d830025,0xe61687ac,0x442c9aee,0x399400f2}},	//   _koje_, ады_, erd_, _läsa_,
   {{0x7d1ace13,0x6f0d4e14,0x2b5f81c0,0x1c458b73}},	//   gats, hbac, _hauc_, аном,
   {{0x04458c8e,0x5f748077,0x69c70390,0xeb9a1593}},	//   шенн, _گالر, doje, вин_,
   {{0x6266007f,0x2d834e15,0x6e2d4e16,0x2b490286}},	//   авма, _loje_, krab, _cbac_,
   {{0x3f8209a4,0x7d1a81d4,0x442cce17,0x6f1bce18}},	//   _roku_, bats, ard_, mauc,
   {{0x6f1bce19,0x69c70824,0xdcfe00eb,0x48dc800d}},	//   lauc, goje, āvīg, गेको_,
   {{0xdca292b2,0x6f0d4e1a,0x0cb000c8,0x7bc6022e}},	//   _маши, fbac, _কর্ত, poku,
   {{0xa3c32ab7,0xcc3a80be,0x6441888b,0x4433022b}},	//   ्तः_, _סעפט, mtli, dux_,
   {{0x2d83003a,0x443300e7,0x644181ec,0x24f6002e}},	// [3f00] _boje_, eux_, ltli, ачер,
   {{0xf21380ab,0x69c70144,0xf507002e,0xd24f00d7}},	//   _সমূহ_, coje, инул_, _کنی_,
   {{0x6441c582,0x3f824e1b,0x224dce1c,0x6f0d0041}},	//   ntli, _toku_, _apek_, bbac,
   {{0x7d1ace1d,0x21258359,0x395e92f1,0xdb0b8187}},	//   zats, _adlh_, _sats_, ligê,
   {{0x395e8df1,0x44332739,0x236001c0,0x644183e3}},	//   _pats_, aux_, _maij_, htli,
   {{0x6441ce1e,0x2360022c,0x44330197,0xa50713f7}},	//   ktli, _laij_, bux_, _вера_,
   {{0x7d1acbab,0x224da34d,0x7dcb497b,0xdb1d0061}},	//   vats, _epek_, rüst, őzés,
   {{0xf1bf0298,0x236001c0,0x7d1ace1f,0x7dcb0074}},	//   nuár_, _naij_, wats, süst,
   {{0xd6d78987,0x7d1ace20,0xb3558019,0x69c701f8}},	//   ить_, tats, _دینا_, yoje,
   {{0x64418456,0xddc2809a,0x71ea826a,0x6f0d012b}},	//   ftli, _społ, _شفاف_, zbac,
   {{0x7d1abfb3,0x442c80f3,0x1b190009,0x291c96dc}},	//   rats, urd_, лжны_, mava_,
   {{0x291cce21,0x7d1a9aed,0x236001e9,0x6f1b91b9}},	//   lava_, sats, _caij_, cauc,
   {{0x6b844e22,0x9f420364,0x48fd800d,0x69c704a9}},	//   _doig, _mikä_, रुको_, toje,
   {{0x660907d9,0x6e2d4e23,0x63ab98f1,0x98a5811c}},	//   _çeki, vrab, zign, _zalı_,
   {{0x6b96108c,0x97a72597,0x69c70e3f,0x628b809a}},	//   _flyg, арал, roje, zygo,
   {{0x6e2d02e8,0xcf980b30,0x291cce24,0xa3d20d72}},	//   trab, ају_, hava_, वतः_,
   {{0x69c70ac1,0x63abce25,0x645c003d,0x7bcd1400}},	// [3f10] poje, vign, _asri, _ikau,
   {{0x6e2d4e26,0x6f0d1d31,0x44330197,0xf1bf0061}},	//   rrab, sbac, tux_, dság_,
   {{0x224d831e,0x63abce27,0x6b840216,0x201e01d0}},	//   _spek_, tign, _yoig, átit_,
   {{0x6e2d4e28,0xdea1003d,0x2360022c,0x4433300b}},	//   prab, _فیزی, _xaij_, rux_,
   {{0xd6db4718,0x644e026c,0xeab095a9,0x63ab85ed}},	//   _што_, _epbi, وعه_, rign,
   {{0x9f420364,0x27ef8051,0x98a582d0,0x7d189b40}},	//   _eikä_, _sign_, _salı_, _nevs,
   {{0x04950013,0x7c950013,0x6f1ba71c,0x6c850f99}},	//   _الأح, _الأص, tauc, _الزم,
   {{0x7bcd01e9,0x5ba48b88,0x28b80039,0x63688615}},	//   _nkau, _друз, יפוש_, _круг_,
   {{0x6f1bce29,0x2294a2b7,0xceb981d0,0xb5fb0174}},	//   rauc, _дитя, kaře_, _brái,
   {{0x291cce2a,0x7bcd4e2b,0x66099fe8,0x6f1bce2c}},	//   cava_, _akau, rpek, sauc,
   {{0x30a7a2d2,0x6b844e2d,0x200581b9,0x34c50035}},	//   _трав, _poig, _utli_, _वडोद,
   {{0x69de020f,0x64419690,0xf989010f,0x44213cc0}},	//   _shpe, rtli, _אר_, ish_,
   {{0x63a9bd8b,0xeab20065,0x66058a13,0xad9b04be}},	//   _mmen, سٹس_, _упла, _atúm,
   {{0x637f020f,0x63bbce2e,0x44234e2f,0x63a9ce30}},	//   _mëny, _ljun, _ovj_, _lmen,
   {{0xb9001cd4,0x63a9ce31,0xdcfc0029,0x442100f1}},	//   _तर_, _omen, _norā, jsh_,
   {{0xd00f12dc,0x291ca76e,0x07a30ba5,0xe3b90380}},	//   علق_, zava_, пасн, lsın_,
   {{0xa3bd0105,0xdd8f004e,0xea0080ff,0xdee32240}},	// [3f20] _आदत_, کول_, _đắm_, зоти,
   {{0x63bba5d7,0x201e2ed8,0x291c87d0,0x627b03de}},	//   _ajun, átis_, xava_, _ענינ,
   {{0x291cbe3d,0x261986a7,0xbddb06c4,0x130a802e}},	//   vava_, _मौसी_, _apès, гней_,
   {{0xf3f980c8,0x201e0110,0xe29a8ba7,0x63a9ce32}},	//   _আবার_, štis_, лае_, _cmen,
   {{0x291a0978,0x63bbce33,0xe3b901cc,0xc6b28264}},	//   _kepa_, _djun, ksın_, _চর্চ,
   {{0x63a9ce34,0x55e301a0,0x6f0281e8,0x399400e1}},	//   _emen, _нояб, _sfoc, _mäso_,
   {{0xf1bf0019,0x6e228419,0xe04a803d,0xc8668081}},	//   sság_, _svob, اشته_, стли,
   {{0x4444005f,0xbb438009,0x291a04c4,0x3f9202f7}},	//   mt_, _неск, _lepa_, nkyu_,
   {{0xa3d5823c,0x76443d4f,0xf66a803d,0x877b03de}},	//   हतर_, ntiy, احبه_, ראפי,
   {{0x63a98038,0x7bcd4e35,0x7bdf00f1,0x4444396a}},	//   _zmen, _skau, _shqu, ot_,
   {{0xe6d50a74,0x2ed5000d,0x69ca8b80,0x769e826b}},	//   _दर्ज, _दर्त, mofe, _bàyé,
   {{0x44443c72,0xc7f78039,0x69ca8d35,0x7d1e4e36}},	//   it_, _הזאת_, lofe, haps,
   {{0x44444e37,0xb5fb4e38,0x7d1e225f,0x2aab0eef}},	//   ht_, _trái, kaps, утно_,
   {{0x44444e39,0x398f02f1,0x44214e0e,0x69cace3a}},	//   kt_, _küsi_, ysh_, nofe,
   {{0x44442ca8,0x291a4463,0x6f0d8087,0x251b8e82}},	//   jt_, _depa_, _încâ, _גווא,
   {{0xa3bd00a5,0x398b983d,0xd5b881a9,0x69cace3b}},	//   _आदि_, _høst_, lnā_, hofe,
   {{0xa3cc8076,0x63af31a7,0x88bc801b,0xaa591594}},	// [3f30] रकन_, micn, _sděl, _типу_,
   {{0xa3dd05b3,0x44444e3c,0x63af0025,0x63a9ca52}},	//   _तीत_, ft_, licn, _smen,
   {{0x44443f82,0x490f000d,0xa91c80e1,0xc8a79993}},	//   gt_, _त्यो_, _poľn, _केंट,
   {{0x63af007d,0x2d980267,0x93bd0087,0x291a0118}},	//   nicn, _elre_, crăt, _zepa_,
   {{0x44441645,0x7f3a0158,0xa91c81ac,0x60c481cc}},	//   at_, _דערו, _voľn, şiml,
   {{0xa9699d8f,0x2903009a,0x44444e3d,0x69cac53e}},	//   рика_, ncja_, bt_, gofe,
   {{0x44444e3e,0x88bc801b,0x63bb81a1,0x93e981a8}},	//   ct_, _uděl, _tjun, _نفسك_,
   {{0x6d572363,0xdfd18013,0x63bb8e60,0x63a9c96b}},	//   lexa, بيع_, _ujun, _umen,
   {{0x7bcb803a,0x64450014,0x2903009a,0x660d4e3f}},	//   mogu, lthi, kcja_, npak,
   {{0x7bcbce40,0xdb0bce41,0x225f88f9,0x6d5703cd}},	//   logu, digé, _isuk_, nexa,
   {{0x64454e42,0xe3ba0009,0x7e648279,0x320922f9}},	//   nthi, ибо_, _šipt, _atay_,
   {{0x3ce10d38,0x61fb98c5,0x64454e43,0x7e6b826c}},	//   _करने_, _kuul, ithi, _trgp,
   {{0x61fb8074,0xb69b0087,0x644536a2,0x63bd0144}},	//   _juul, _sfân, hthi, érna,
   {{0x6445308b,0x225f8359,0x4444043c,0x660d2a52}},	//   kthi, _msuk_, yt_, dpak,
   {{0x61fba551,0x63af0289,0x7bcb8074,0x6d574e44}},	//   _luul, bicn, kogu, dexa,
   {{0x673b84e8,0x44440f06,0x657526ca,0x6563ce45}},	//   nguj, vt_, _anzh, _hanh,
   {{0x660d1066,0x7bcbce46,0x2a6d822c,0x44444e47}},	// [3f40] gpak, dogu, _nreb_, wt_,
   {{0x44444e48,0x76444e49,0xd910026a,0x656389ab}},	//   tt_, rtiy, _سیر_, _janh,
   {{0x44444e4a,0x39584755,0x76444e4b,0xe45a1ad0}},	//   ut_, mers_, stiy, рже_,
   {{0x395801eb,0x2905ce4c,0xa3d4800f,0xa91c80e1}},	//   lers_, _afla_, _सीख_, _poľo,
   {{0x6f040b80,0x7dd00106,0x2a6002a6,0xdd1c936f}},	//   mcic, fäst, _jsib_, váži,
   {{0xb5fb0a56,0x39581989,0x082a80af,0x63af00fe}},	//   _práv, ners_, ации_, zicn,
   {{0x69cace4d,0x7bcb8032,0x444401b9,0xcf9a84ae}},	//   rofe, bogu, qt_, ији_,
   {{0x7d1c1591,0x656380c9,0x261101ce,0x39580039}},	//   _hers, _aanh, दीकी_, hers_,
   {{0x7d1c4e4e,0x65638073,0x61fb82a3,0x63af0b67}},	//   _kers, _banh, _guul, vicn,
   {{0x2d988063,0x48e6ba2d,0xb5fb026f,0x3958022b}},	//   óre_, _дозв, _tráv, jers_,
   {{0x2cfb0451,0x63af00d2,0x39581527,0x7d1c4e4f}},	//   יליא, ticn, ders_, _mers,
   {{0xb5fb003e,0xddc28029,0x236680f1,0x6f0401dd}},	//   _krát, _droš, ndoj_, jcic,
   {{0x7988829b,0xf1bf03fb,0x2d87ce50,0x7d1c2525}},	//   _kodw, krát_, _fone_, _oers,
   {{0x39584a3f,0x656380a9,0x63af02a5,0x628f2c18}},	//   gers_, _ganh, sicn, ryco,
   {{0x63af00d2,0x3494a853,0x37ab2481,0x6ca38081}},	//   picn, _хайр, атан_, _оръж,
   {{0x6720911b,0x22468461,0x660d27f2,0x644501c0}},	//   namj, ktok_, tpak, vthi,
   {{0x7d1c0fc7,0x63ad4e51,0x2b59002e,0x59ca8743}},	// [3f50] _bers, _iman, mesc_, ाकार,
   {{0x660d4e52,0x7d1c3f21,0x93bd0087,0x79888114}},	//   rpak, _cers, crăr, _nodw,
   {{0x437596d9,0x6d574e53,0x7d1c0b0b,0x61fbce54}},	//   зулт, rexa, _ders, _suul,
   {{0x7d1c24de,0x64454e55,0x6d574e56,0x2b59002e}},	//   _eers, rthi, sexa, nesc_,
   {{0x7d1c0c82,0x27e94e57,0x644503e9,0x63ad4e58}},	//   _fers, mman_, sthi, _mman,
   {{0x27e94e59,0xa3dd146d,0x7d1c4e5a,0x8dfa0039}},	//   lman_, _तीस_, _gers, _להשת,
   {{0x63ad4e5b,0x7857817e,0x765908c5,0xb5fb002a}},	//   _oman, تیاز_, şayı, _usáb,
   {{0x27e94e5c,0x39584e5d,0x2a6d8e72,0x61fb8df8}},	//   nman_, zers_, _treb_, _tuul,
   {{0x28d2101b,0xb5fb4e5e,0x2d87a752,0x65638420}},	//   _दुनि, _grát, _pone_, _panh,
   {{0x63ad3f6d,0xddc2883d,0x27e90c9e,0x6f1d4e5f}},	//   _aman, _proš, hman_, _lesc,
   {{0xb5fb003e,0x65638364,0x27e9133b,0x1b2000ab}},	//   _krás, _vanh, kman_, _ভাবে_,
   {{0x27e906c0,0x6f1d4e60,0xdb0605bf,0x39580bbf}},	//   jman_, _nesc, fiká, wers_,
   {{0x27e94e61,0xa3cc9344,0x39583593,0x386100dd}},	//   dman_, रकत_, ters_, _ashr_,
   {{0x2d9ece62,0x63ad4e63,0xf1bf4e64,0x64a58539}},	//   chte_, _eman, drás_, _нала,
   {{0x6f1d2644,0xddc29408,0x22468019,0x2b590087}},	//   _besc, _uroš, ztok_, besc_,
   {{0x39584e65,0x27e93794,0xab9a0077,0x2fcd8b3c}},	//   sers_, gman_, _دختر_, noeg_,
   {{0x6f1d2a70,0x59cb800c,0x6e243953,0x41cb8c78}},	// [3f60] _desc, िवार, usib, िवास,
   {{0x7d1c00f1,0x6b9b9cef,0x63ad0353,0x27e94e66}},	//   _qers, _alug, _zman, aman_,
   {{0x7d1c0faf,0x1b0d80c8,0x3ce1016f,0xa3c3016f}},	//   _vers, _হয়ে_, _करणे_, ्तच_,
   {{0x6f1d1736,0x8c4907d9,0x7d1c009a,0xb5fb4e67}},	//   _gesc, daşı, _wers, _prát,
   {{0x7d1c045c,0x236681f4,0xb5fb016a,0x7988809a}},	//   _ters, rdoj_, _drás, _podw,
   {{0xb5fb0a21,0x47360077,0x6f1d00d2,0x69ce148c}},	//   _vrát, _برگز, _zesc, nobe,
   {{0x6b9b8189,0x34a70652,0x2d8a0118,0xdb060c83}},	//   _flug, _евро_, _iobe_, ziká,
   {{0x3ce10d38,0xc91804e5,0xb5fb4e68,0x69ce4e69}},	//   _करते_, थरुम_, _trát, hobe,
   {{0xfaa39092,0xed588038,0x2d9ece6a,0x443a4e6b}},	//   _зато, teľ_, thte_, lup_,
   {{0x63ad003b,0xf64f8064,0x27e906c0,0xd9c6064a}},	//   _sman, ائي_, zman_, लकोट,
   {{0x27e94154,0x69ce1b3b,0x2b590087,0xdcfc0035}},	//   yman_, dobe, tesc_, _gorą,
   {{0x2d9e88cf,0x69d8ba01,0x291e8106,0xa3e286a7}},	//   shte_, llve, _heta_, _नीम_,
   {{0x2b59002e,0x27e906c0,0x291ece6c,0x2707801c}},	//   resc_, vman_, _keta_, _ống_,
   {{0x7e62cc16,0x23de823c,0x2b59002e,0x291e80f1}},	//   _isop, _फीसद, sesc_, _jeta_,
   {{0x291ec304,0xa3be805e,0xa3cc800d,0xdfd50d15}},	//   _meta_, ीका_, रका_, довы,
   {{0x291ece6d,0x6d5ab065,0x443a14ff,0x63ad0d02}},	//   _leta_, leta, dup_, _uman,
   {{0xd6db0b88,0x9f4c81ac,0x6f1d458e,0x27e933e1}},	// [3f70] ств_, _budú_, _vesc, rman_,
   {{0x6d5a80ad,0x27e90242,0x69ce22d8,0x7bcf0087}},	//   neta, sman_, cobe, locu,
   {{0x4427128e,0x27e906c0,0x443a0590,0x7d0502af}},	//   én_, pman_, gup_, rchs,
   {{0x6d5ace6e,0x27e93752,0x245e001b,0xfc300bbe}},	//   heta, qman_, _dům_, احل_,
   {{0x6d5a95ee,0xe6670a14,0x6e22012b,0x2fcd81b0}},	//   keta, _этно, šobr, voeg_,
   {{0xac192a0e,0x3f8b0052,0x443a02f7,0x2d8a4e6f}},	//   _могу_, _hocu_, bup_, _gobe_,
   {{0x6b89a4de,0x6d5a98c1,0xb9058054,0x291ece70}},	//   _toeg, deta, _नर_, _deta_,
   {{0x69ce4e71,0x06099ad0,0x389c03c8,0xefc800ff}},	//   zobe, оник_, מיונ, _địch_,
   {{0x200c8201,0x291e881a,0x7e628019,0x2d8a0041}},	//   _etdi_, _feta_, _csop, _yobe_,
   {{0x291e8125,0xa3d5809a,0x1dbf4c5c,0x442781a9}},	//   _geta_, हतक_, ्वित, _pvn_,
   {{0xb8089e13,0x65670353,0x69ce0b80,0xf8e183eb}},	//   _فيلم_, _majh, vobe, _फरिय,
   {{0x7e6d026f,0x2d9cce72,0x3f8b025b,0x61c601cb}},	//   kvap, _elve_, _nocu_, लक्ष,
   {{0x6d5ace73,0x65a002af,0x1dbf0bbc,0x61ff0609}},	//   beta, _höhe, ्वात, _cuql,
   {{0x9f5ec64b,0x6d5ace74,0x443a4e75,0x64554e76}},	//   _että_, ceta, yup_, _opzi,
   {{0x69ce4e77,0xa067117e,0xdb008009,0x3f8b00ce}},	//   robe, мара_, _ymmä, _bocu_,
   {{0xe61a4e78,0x69ce0b24,0xafe31ef8,0x200c01a9}},	//   жда_, sobe, восл, īdi_,
   {{0xa1c61506,0x60c48214,0x69ce069f,0x64551d46}},	// [3f80] _обид, ğimi, pobe, _apzi,
   {{0xca370039,0xa2ad016f,0x2257003d,0xee3700e8}},	//   _קניה_, ीपर्, _کلید_, ьну_,
   {{0x0b46a133,0x291ece79,0x07a62357,0x013500be}},	//   днен, _reta_, _жанн, _אָרט_,
   {{0x6d5ace7a,0x443a4e7b,0x291ece7c,0x3ebf012b}},	//   zeta, rup_, _seta_, _žute_,
   {{0x291e859c,0x6d5ace7d,0x2d8a4e7e,0xd250806b}},	//   _peta_, yeta, _tobe_, انت_,
   {{0x6d5aae24,0x7afb811b,0x6e3b81b4,0x672400b9}},	//   xeta, _egut, duub, laij,
   {{0x291ece7f,0x6d5ace80,0xa3d98740,0xf54e801c}},	//   _veta_, veta, _ठीक_, _bụng_,
   {{0x291e8133,0x6d5ace81,0x3320023e,0x3a268637}},	//   _weta_, weta, _neix_, psop_,
   {{0xf54e8104,0x2b44826c,0xb146802e,0x63a2ce82}},	//   _dụng_, _icmc_, _онал, mhon,
   {{0x2a648e72,0x60cd83bf,0xdcfc0bda,0x200c80b9}},	//   _ismb_, şama, _dorć, _ttdi_,
   {{0x6d5a888b,0x75370051,0x53ca02f1,0x7bcf28bf}},	//   reta, ואיד_, रवंश, tocu,
   {{0x69c002be,0x6ec9984a,0x6448ce83,0x67c181a9}},	//   émen, _हुकु, rtdi, pēja,
   {{0x6d5ace84,0x6448ce85,0x7bcf18f6,0x61f7019c}},	//   peta, stdi, rocu, _pixl,
   {{0x7c3acd42,0x7bcf4e2a,0x246c928a,0x6d439867}},	//   putr, socu, _těm_, _gcna,
   {{0x63a2829b,0x855784de,0xb5fb4e86,0x98480081}},	//   khon, _חשוב_, _aráp, мята_,
   {{0x1b1900c8,0x27e6814a,0x7e6d8390,0xab5b02d0}},	//   _থাকে_, _jhon_, _šapi, ylüy,
   {{0x7f4d00f1,0x63a2803d,0x6567022c,0x27e682f7}},	// [3f90] rfaq, dhon, _pajh, _mhon_,
   {{0xd9e306b7,0xaad28105,0xdb0b8216,0x995400e1}},	//   _गठित_, _तड़क, rigí, _päť_,
   {{0x6567022c,0x27e68bb1,0x7c28ce87,0xddc2866f}},	//   _vajh, _ohon_, nsdr, _spoś,
   {{0xa3a98063,0x2b44802a,0xd6d00019,0x63a2ce88}},	//   गों_, _ccmc_, اقے_, ghon,
   {{0x6b8d4e89,0xdcf881d0,0xf54e8129,0x7d0ac4f2}},	//   _moag, _pově, _rụng_, _offs,
   {{0xa3e60fd5,0x2b44808e,0x2bb8826c,0x6845bc3d}},	//   _बीन_, _ecmc_, dčcu_, енка,
   {{0x27e68014,0x200102f1,0x442a0bfd,0x00000000}},	//   _bhon_, _juhi_, _gvb_, --,
   {{0xd0f80bea,0x7afbce8a,0x9e65a240,0x2bbb056b}},	//   ומות_, _ugut, евид, _उदगा,
   {{0xa3cc81fe,0xb8d6816f,0xa3be816f,0xea0080ff}},	//   रकर_, _चे_, ीकर_, _đầm_,
   {{0x2121008e,0x4c8586e9,0x89388dca,0x27e68362}},	//   _nehh_, елов, _опус_, _ehon_,
   {{0xe572093f,0x3f158009,0x33200722,0x6e3b82ec}},	//   אַר_, _здес, _peix_, suub,
   {{0xfe71815b,0x27f94e8b,0xf1bf0118,0xcf2780d7}},	//   _مدت_, _nisn_, usán_, _آراي,
   {{0x27edce8c,0xc33282f6,0x661d01c0,0x998401d0}},	//   mmen_, נוך_, _nwsk, émů_,
   {{0xc2128451,0x6e298234,0x20010420,0x74ca8a27}},	//   רהם_, mseb, _buhi_, _सुकृ,
   {{0xddc40289,0xa3c1ce8d,0x212102f7,0x9f5e82d6}},	//   jviš, ुवा_, _dehh_, _butè_,
   {{0x27ed8205,0x6f0983ac,0x442a05db,0x2121008e}},	//   nmen_, ncec, _rvb_, _eehh_,
   {{0x290502bb,0xee3a2f4b,0x6e29ce8e,0xdce3a355}},	// [3fa0] ılar_, яна_, nseb, _manč,
   {{0x6d41ce8f,0x27ed8352,0x6e360683,0xdce38289}},	//   ngla, hmen_, rryb, _lanč,
   {{0x236901c0,0xb5fb016a,0x63a2ce90,0x273a8380}},	//   _yaaj_, _usán, thon, nünü_,
   {{0x2486003a,0x8c1a8039,0xb5fb016b,0x69dc4e91}},	//   ćom_, פוני, _tráp, llre,
   {{0xfeba08ca,0x45240264,0x6e298366,0x27ed8865}},	//   _راحت_, _পাঠক_, jseb, dmen_,
   {{0x63a2ce92,0x27e68c41,0x27eda0dd,0x6e29807a}},	//   shon, _shon_, emen_, dseb,
   {{0x63a2ce93,0xfce31383,0xb882001b,0xdce3807a}},	//   phon, _боро, _říjn, _banč,
   {{0x2fc04e94,0x6d5e4e95,0x69dc4161,0xdd258084}},	//   nnig_, lepa, hlre, _rūši,
   {{0x7c3e003e,0x2fc04e96,0x7ae42169,0x67c50084}},	//   lupr, inig_, _nzit, nėja,
   {{0x6d5e4e97,0x6d41ce98,0x7bd60c2e,0x7bc40c53}},	//   nepa, ggla, _akyu, _ajiu,
   {{0xd6da8065,0xd4978012,0xb5fb0032,0x27e6ce99}},	//   _کوشش_, еря_, _asál, _thon_,
   {{0x20012008,0x29180661,0x67c50084,0x27e68420}},	//   _ruhi_, ebra_, kėja, _uhon_,
   {{0xdfcf8077,0x4e93804e,0x20014319,0x7c28804a}},	//   _اين_, _مشور, _suhi_, ssdr,
   {{0x6d5e0654,0x67c50110,0xdb0f0187,0x7c3e4e9a}},	//   jepa, dėja, micí, kupr,
   {{0xb90905b3,0xbebb08cf,0xdb0f02ba,0x61fa9fba}},	//   _बर_, _ndër, licí, _mitl,
   {{0x443eb15d,0x987b8158,0x7c3e00fe,0x26020074}},	//   mut_, האלט, dupr, _वंशी_,
   {{0x443ece9b,0x660287ac,0xdb0f4e9c,0x391512bc}},	// [3fb0] lut_, _juok, nicí, _импр,
   {{0x443e81e0,0x6d5e0ac5,0x66028009,0xad9b046d}},	//   out_, gepa, _muok, _atúr,
   {{0x443e99e0,0xe3be8182,0x66028009,0x656a8239}},	//   nut_, ğına_, _luok, _mafh,
   {{0x04c800f7,0xe3be817b,0xddc40da8,0x6e298114}},	//   روني_, şına_, rviš, yseb,
   {{0x443ece9d,0x21699541,0xa96994d6,0x61face9e}},	//   hut_, дили_, дила_, _bitl,
   {{0x443eb69d,0x2369812b,0xd8380db7,0x6d5e4e9f}},	//   kut_, žaj_, šče_, cepa,
   {{0xdce3a9a5,0x443ea5e0,0x6d5501c0,0x27ed8dc6}},	//   _panč, jut_, _ibza, tmen_,
   {{0x3f89372d,0x3994016d,0x776d4ea0,0x6d4181c0}},	//   njau_, _häst_, ndax, wgla,
   {{0x764d2ad9,0x6f0986cb,0x6458a52a,0x3ea94ea1}},	//   ntay, rcec, _apvi, nzat_,
   {{0x6e29845c,0xa8a78191,0x30a796d4,0x61fa82d5}},	//   rseb, _прек, _прев, _gitl,
   {{0x443ecea2,0x03a61ad0,0x6e29cea3,0xdce3cea4}},	//   gut_, вино, sseb, _bonġ,
   {{0x399400f2,0x6d41cea5,0x09da016f,0x7e6d80d2}},	//   _läst_, sgla, णत्य, _šapu,
   {{0xa2d503ca,0x3ea90168,0x6d5e10fa,0x98b00140}},	//   _युद्, jzat_, yepa, _čađe_,
   {{0x784a8085,0x39940106,0x67c50084,0xdb0604e8}},	//   _səvi, _näst_, vėja, nikú,
   {{0x443e8012,0x67228072,0x3f8f8074,0x64a59b67}},	//   cut_, _yeoj, _kogu_, _шака,
   {{0x3ebf01dd,0x212780ff,0xa0670073,0x764d4ea6}},	//   _žuta_, hanh_, њата_, ftay,
   {{0x3f8f803a,0x6d5e1958,0x399400f2,0x7523a62d}},	// [3fc0] _mogu_, tepa, _bäst_, _kenz,
   {{0xdb0b8298,0x2fcd0805,0xa3e60105,0xa80601cf}},	//   vigá, čega_, _बीत_, _изол,
   {{0xdd100038,0x81d800ab,0x2fc00122,0x499b1101}},	//   _týžd, িষদ_, pnig_, _חשיב,
   {{0xeb97baa3,0x3f8f8a20,0x7523bee9,0x78a30085}},	//   ких_, _nogu_, _lenz, _ünva,
   {{0x443e8c3a,0x7c3e3079,0x425480a0,0x67228144}},	//   zut_, supr, انتر, _reoj,
   {{0x657c0355,0x66028364,0x7f958510,0x7f4400e7}},	//   _unrh, _ruok, _máqu, lgiq,
   {{0x9346867c,0x3f8f811f,0xa3c43d9c,0x61faa51d}},	//   _инве, _bogu_, ्वा_, _vitl,
   {{0x443ecea7,0x2d8e8390,0x61fa9de6,0xf76f81a8}},	//   vut_, _sofe_, _witl, قاً_,
   {{0x443ea1e5,0xa3c1881f,0x3f8f811b,0x9f590176}},	//   wut_, ुवर_, _dogu_, _disè_,
   {{0x66028364,0x61fa838e,0x7bc28362,0xb5fb026b}},	//   _vuok, _uitl, lnou, _asáj,
   {{0x3ea94ea8,0x35678087,0x7e6d86ec,0xd7ef8615}},	//   zzat_, трын_, _šapt, _ву_,
   {{0x443e8dab,0x040d801c,0x316c826c,0x752381ed}},	//   rut_, _hưởn, _hadz_, _eenz,
   {{0x443eadaf,0xe5c6bacb,0x161b82f1,0x3f8f008b}},	//   sut_, _иско, पीआर_, ögum_,
   {{0x656a806a,0x7bc281d0,0x7523cea9,0x3f8f83ed}},	//   _uafh, hnou, _genz, _zogu_,
   {{0x9f350221,0xd48fceaa,0x59f8002e,0x76408c2e}},	//   леві, _тр_, теря_, lumy,
   {{0x3ea929b8,0xb8db2bef,0x764d4eab,0x752381f6}},	//   tzat_, _आइ_, ttay, _zenz,
   {{0x8bb40b76,0x7c2e068f,0x5d551071,0x7bc281d0}},	// [3fd0] _خصوص, _avbr, лкат, dnou,
   {{0x3ea92126,0x26058ad5,0x6b9d14ab,0x764d3843}},	//   rzat_, _हंसी_, lksg, rtay,
   {{0x764d4078,0xdce380eb,0x29010135,0x39940106}},	//   stay, _kanā, _igha_, _väst_,
   {{0x6b9d08df,0xed510065,0x9f4c8144,0x2013011b}},	//   nksg, _گھر_, _mudó_, _itxi_,
   {{0xdb1d26d5,0x6b9d01ed,0xf9900fd3,0x6f0d4eac}},	//   losó, iksg, _طبی_, mcac,
   {{0x75288029,0x644a0722,0xa5bb009a,0xca7682e3}},	//   jadz, àfic, _dwóc, اموش_,
   {{0x7523cead,0x65a0011c,0x442c890d,0x6e2d285e}},	//   _renz, _köhn, jsd_, lsab,
   {{0x7523cb67,0x6d451100,0x69d54eae,0x2d914eaf}},	//   _senz, lgha, hoze, _hoze_,
   {{0xaab79299,0x69d54eb0,0x2d9106c0,0x4ab78778}},	//   _अधिक, koze, _koze_, _अधिव,
   {{0x6d451904,0x63b9ceb1,0x4585a57e,0x6e2d40c5}},	//   ngha, liwn, угов, isab,
   {{0x2d9102a5,0x481587eb,0xfbb78c78,0x201301c0}},	//   _moze_, _смес, _आगाम, _ntxi_,
   {{0x7523a0b3,0xe72e8b30,0x2901082e,0x29cd01ac}},	//   _wenz, _ће_, _agha_, hľad_,
   {{0x69c382be,0x539a8158,0x6f1bceb2,0x2005809c}},	//   onne, גירו, mbuc, _huli_,
   {{0x957c8063,0x8c458a42,0x186a0098,0x20059f34}},	//   gląd, _беке, наги_, _kuli_,
   {{0x69c38c64,0x65618073,0xc4be00ab,0xdb1d002a}},	//   inne, melh, _অর্জ, gosó,
   {{0x6f0d4eb3,0x2005ceb4,0x6f1b82af,0xad9b01d6}},	//   gcac, _muli_, nbuc, _stúp,
   {{0x63a44eb5,0x6e2d043b,0x2005ceb6,0x69d54eb7}},	// [3fe0] _ilin, gsab, _luli_, boze,
   {{0x51660607,0x63a4026f,0x7bc28637,0xc96632b8}},	//   _своб, _hlin, wnou, _свой,
   {{0x6441885c,0x26cb0748,0x200580d7,0xdce700e1}},	//   nuli, _exco_, _nuli_, _fajč,
   {{0xa22a9194,0x69c3ceb8,0x7c2e8e15,0x20183df8}},	//   ежда_, enne, ábri, mpri_,
   {{0xd00f04c0,0x75840077,0x2125826c,0x6441ceb9}},	//   _ولی_, _پیام, _belh_, huli,
   {{0x27e04eba,0x6441b374,0x20058c56,0xe8948364}},	//   llin_, kuli, _buli_, иаль,
   {{0x64418533,0x63a44ebb,0x66060406,0x27e04ebc}},	//   juli, _olin, _hukk, olin_,
   {{0x66060ef6,0x75288063,0x963485c2,0xa0678003}},	//   _kukk, wadz, аниц, ѓања_,
   {{0x2bb18063,0x040d8028,0x244e026f,0x752886cb}},	//   jący_, _tưởn, lým_, tadz,
   {{0x63a44883,0xa3b086b7,0x65618a34,0xdb0f2509}},	//   _alin, टोर_, gelh, dicá,
   {{0x244e0775,0x66063ca7,0x7528809a,0x2005cebd}},	//   ným_, _lukk, radz, _guli_,
   {{0x656e1a29,0xdb0f0c52,0x69d524f2,0x6726007a}},	//   _labh, ficá, woze, _nekj,
   {{0xe7f8097d,0x244e016b,0x69d5011b,0x6606156e}},	//   ंगना_, hým_, toze, _nukk,
   {{0x63a44ebe,0x6441b883,0x645c4ebf,0xf2d38158}},	//   _elin, buli, _opri, מער_,
   {{0x6f0d0362,0x6441bb7c,0x69d54ec0,0xb97b8158}},	//   tcac, culi, roze, ענלי,
   {{0x2a6901c5,0x2d8c8106,0x7ddd83ec,0x3f150071}},	//   _tsab_, ljde_, vèsi, рдас,
   {{0xa3c403b7,0x2d914ec1,0x645c3206,0x2a691341}},	// [3ff0] ्वर_, _poze_, _apri, _usab_,
   {{0xd8380db7,0x6e2d4ec2,0x656e0cac,0x2d9ec255}},	//   šča_, rsab, _cabh, nkte_,
   {{0x6e2d4ec3,0x2d9100d2,0x2dd800f7,0x6d454ec4}},	//   ssab, _voze_, ابقة_, rgha,
   {{0xae048670,0xb767163f,0x61fe05b0,0x16049094}},	//   रदान_, _стой, _zipl, रदार_,
   {{0x2005856a,0x3ce1009a,0xfdf68105,0x644188bf}},	//   _suli_, _करके_, ीदास_, zuli,
   {{0x656e0ad0,0x2005cec5,0xe2968ae7,0x6f02cec6}},	//   _gabh, _puli_, раш_, _agoc,
   {{0xa0a581e5,0x18a58196,0x6561cec7,0x10a595a1}},	//   райд, райм, velh, рийн,
   {{0xe3b092dc,0xddc9cec8,0x6e3b816b,0x7f759033}},	//   _فرق_, dveš, trub, рукц,
   {{0xdb06020f,0x442301c5,0x6f1b8865,0x64418c56}},	//   shkë, _hwj_, rbuc, wuli,
   {{0x7ae9cec9,0x2005c404,0xdcf88029,0x4423022c}},	//   _izet, _tuli_, _novē, _kwj_,
   {{0x63a44eca,0x656189e9,0x61fe01e0,0x397a80be}},	//   _plin, relh, _ripl, _שטענ,
   {{0xe29a0471,0xddc28110,0x6441cecb,0x765d4ecc}},	//   вам_, _grož, ruli, _opsy,
   {{0x7ff48277,0x44230069,0x6561cecd,0x63a4110f}},	//   _اسلا, _lwj_, pelh, _vlin,
   {{0x64418a14,0x2d9ea9ed,0x1a9a8158,0x463a80be}},	//   puli, ckte_, דישע, _יענע,
   {{0x6606268d,0xa3d597a3,0xd70600b3,0x656e032f}},	//   _sukk, सका_, изви, _rabh,
   {{0x244e0ed7,0x63a44ece,0x656e4ecf,0x20184ed0}},	//   vým_, _ulin, _sabh, rpri_,

   {{0x28db0076,0x201806c0,0x27f24ed1,0xb69b0087}},	// [4000] _मुठि, spri_, rmyn_, _sfâr,
   {{0x637b0009,0x244e026f,0x1a9b03c8,0x7bdbb7a8}},	//   _tänä, tým_, _סייע, _akuu,
   {{0x31570158,0xdd8f190c,0x44230069,0xb4664ed2}},	//   _דיין_, بول_, _cwj_, ркел,
   {{0xa3b0809a,0x244e05b9,0x3d160d14,0x3ce60006}},	//   टों_, rým_, _प्रे_, _करीं_,
   {{0x656e003c,0x2d9e854f,0x98a301a9,0x752708b2}},	//   _tabh, ykte_, majā_, _fejz,
   {{0xfe088028,0x4423022c,0xb33b00f1,0x76440010}},	//   _nữa_, _fwj_, thçk, muiy,
   {{0x97a6802e,0x58868196,0xdb0401ed,0xf1a9803d}},	//   ирил, рыла, _clië, دانه_,
   {{0x44444ed3,0x776407e2,0x6e228247,0x9f420198}},	//   mu_, neix, _pwob, _eikö_,
   {{0x44444ed4,0xfe0880ff,0xfaa3ced5,0xb5fb046d}},	//   lu_, _bữa_, _дато, _aráy,
   {{0x44444ed6,0x44230069,0x3d168072,0x9f970580}},	//   ou_, _ywj_, पुढे_, nçò_,
   {{0xb5fb003e,0x2d9e9254,0xa3c402f7,0x31630bda}},	//   _práz, rkte_, ्वं_, vejz_,
   {{0xa3cc800c,0x44444ed7,0x9ffa81a8,0x69d8b567}},	//   रकट_, iu_, _شراء_, love,
   {{0x77640722,0x6fb381a8,0x7e798114,0x387a0db1}},	//   deix, _بمنا, _grwp, _arpr_,
   {{0x6b5c006a,0x14b789a7,0xa5bb026b,0x1cba81a8}},	//   _pågæ, ادیث_, _awón, _لاعب_,
   {{0xa3d69278,0x351b83de,0x06d88264,0x69d88493}},	//   हवा_, _יוגנ, দেশি, iove,
   {{0x77640722,0x442301c0,0x34fb8039,0x3cfb8039}},	//   geix, _rwj_, _בהוד, _בלונ,
   {{0x44444ed8,0x69d8ced9,0x63bd4eda,0x7c3e1254}},	// [4010] eu_, kove, misn, erpr,
   {{0x6d489341,0x444438fc,0x7bdbb3b0,0x443ecedb}},	//   ngda, fu_, _skuu, ort_,
   {{0x44441a7b,0x5455316c,0x69d8af06,0x4423022c}},	//   gu_, свет, dove, _qwj_,
   {{0x443e954c,0xb4e71130,0x63bd43d6,0x69c70353}},	//   irt_, _परी_, nisn, lnje,
   {{0x44444edc,0x443e8352,0x4df68d86,0x75272928}},	//   au_, hrt_, ँगाई_, _tejz,
   {{0xdca68307,0x6ab78076,0x32090358,0x69d89b39}},	//   _فى_, _अधीर, _muay_, gove,
   {{0x01380039,0x7d038118,0x260c86a7,0x6d488122}},	//   ברות_, _rgns, _डूबी_, dgda,
   {{0x63bd4411,0xfe08801c,0xfaff0168,0x1bd480e8}},	//   jisn, _sữa_, ndës_, _дося,
   {{0x443ecedd,0x7ae985f5,0x63bd0052,0x3ead80d2}},	//   ert_, _uzet, disn, uzet_,
   {{0xcda983f8,0x69c702a5,0x51848adb,0x4c698256}},	//   اهده_, jnje, _муха, гион_,
   {{0x69c7135a,0x64453f8c,0x672d07b8,0x232a1a66}},	//   dnje, nuhi, kaaj, лони_,
   {{0xe0d08277,0x63bd4ede,0x06b8803d,0x672d3252}},	//   _غزل_, gisn, انیک_, jaaj,
   {{0x443ec9fb,0xed59997b,0x44444edf,0xb5fb002a}},	//   art_, _бол_, zu_, _fráx,
   {{0x44444ee0,0x69c71b39,0x32090122,0x644513fa}},	//   yu_, gnje, _duay_, kuhi,
   {{0x3ce60d38,0x77641209,0x63bd02b1,0x68e9001b}},	//   _करें_, teix, bisn, ředn,
   {{0x81cd80c8,0x81bf80c8,0xaf064286,0x2451826f}},	//   রতি_, ীতি_, спал, mám_,
   {{0x44444ee1,0x7764009f,0x2451816b,0x823612c8}},	// [4020] wu_, reix, lám_, _اربا,
   {{0xaadb82f1,0x67c181a9,0x69c700fe,0x6b9601b4}},	//   _बड़क, mēju, cnje, _hoyg,
   {{0x6445009c,0x7ae08106,0x69de0870,0x67c181a9}},	//   guhi, _symt, _ikpe, lēju,
   {{0x7f8601a8,0x7e698ca2,0x661b82d5,0x9f5d8032}},	//   _الحن, kwep, kpuk, _fiwé_,
   {{0x44444732,0x6d489c33,0x290582d5,0xca568073}},	//   su_, ygda, _bgla_, стењ,
   {{0x443ecee2,0x20020010,0x63bd026c,0x2451837d}},	//   yrt_, _hiki_, zisn, kám_,
   {{0x24778104,0x69d88b24,0xfaff020f,0x20020365}},	//   _năm_, rove, ndër_, _kiki_,
   {{0x24518e93,0xa6148750,0x69d8cee3,0xfaa6a2ea}},	//   dám_, омич, sove, _лабо,
   {{0x69d89734,0xa3d58540,0x2a60022c,0xddc281a1}},	//   pove, सकर_, _npib_, _asoš,
   {{0x6b8402a3,0x68e1813c,0x7afd826f,0xddc400eb}},	//   _anig, _fyld, _ústa, stiņ,
   {{0x63bd4ee4,0x443ea86b,0x68e18aa2,0x6d5c4ee5}},	//   tisn, urt_, _gyld, _mbra,
   {{0x63a2cee6,0x9f4003d3,0x20024ee7,0x69de008e}},	//   nkon, blié_, _niki_, _akpe,
   {{0x63bd0e78,0x32090028,0x69c701dd,0x5187395b}},	//   risn, _quay_, tnje, бува,
   {{0x6b84241e,0x200200a4,0x63bd35a8,0x24518c83}},	//   _enig, _aiki_, sisn, bám_,
   {{0x63a2c8d2,0x97a72357,0x681180eb,0x63bd4ee8}},	//   kkon, брал, _kāda, pisn,
   {{0x6d5c4ee9,0x02a70765,0xaada0f12,0x200200a4}},	//   _abra, _гром, _युवक, _ciki_,
   {{0x69c70369,0x6d5c008e,0x67c50110,0xdb0d0214}},	// [4030] pnje, _bbra, nėji, _amaç,
   {{0x7aed00ad,0x64453bdd,0x672d2933,0xec0980ff}},	//   _izat, tuhi, saaj, _mến_,
   {{0x672d0280,0x247780ff,0x6d5c0362,0x5f950012}},	//   paaj, _xăm_, _dbra, _динт,
   {{0x63a2abb9,0x6d5c4eea,0x64454eeb,0x67c50110}},	//   gkon, _ebra, ruhi, kėji,
   {{0xe1f1803d,0x24518019,0xeb908eca,0x64452e7f}},	//   وست_, zám_, عظم_, suhi,
   {{0xe3cf00c8,0x9f420009,0x644526a6,0x67c50084}},	//   রতিব, _ehkä_, puhi, dėji,
   {{0xa3d9000f,0x319c00be,0x299c01c6,0x63a2ceec}},	//   ़का_, רבונ, רסומ, bkon,
   {{0xee398fe7,0x2d98ceed,0x6d5c070d,0x245185b9}},	//   ани_, ören_, _zbra, vám_,
   {{0xa3e2816f,0xbebb06a8,0x63a9ceee,0xe293a0bb}},	//   _नीट_, _beëi, _ilen, _عذر_,
   {{0xdcf500eb,0x29058b67,0x2451826f,0x31348294}},	//   _nozī, _ugla_, tám_, _неур,
   {{0x63a9ceef,0x7aed0314,0x63bb808e,0xdce381a1}},	//   _klen, _azat, _kmun, _manć,
   {{0xd8d6893f,0xf9890bea,0xe8d68158,0x22408253}},	//   _וועט_, _בר_, _ווער_, šike_,
   {{0x20024ef0,0x79970122,0xddcd026c,0x63a9cef1}},	//   _riki_, _boxw, zvaš, _mlen,
   {{0xd3780d38,0x63a9cef2,0x64a581e2,0xdca58ff7}},	//   ść_, _llen, _мала, _мали,
   {{0x929d8063,0x63a28a21,0x20024ef3,0x63a98100}},	//   _ogło, ykon, _piki_, _olen,
   {{0x6b84031d,0xa2d521e3,0xec0980ff,0x9f4680ff}},	//   _unig, _युक्, _yến_, _khoá_,
   {{0x672bcef4,0xe617017a,0x44278355,0x660392a5}},	// [4040] _megj, жду_, _hwn_, _kink,
   {{0x200217fe,0x672bb8db,0x6603a003,0x63bbcef5}},	//   _wiki_, _legj, _jink, _amun,
   {{0x6603cef6,0x130a9d51,0xb5fb04e8,0x63a9cef7}},	//   _mink, аней_, _spác, _blen,
   {{0x6603cef8,0x6441832f,0x69dc4ef9,0x65a008dc}},	//   _link, irli, lore, _möhi,
   {{0x63a2cefa,0xadeb10c5,0x644181ec,0x442780ee}},	//   rkon, _जीवन_, hrli, _lwn_,
   {{0x63a2cefb,0x660382a3,0x44278039,0x6d5c07c6}},	//   skon, _nink, _own_, _ubra,
   {{0x672bcefc,0x6286905e,0xe5710158,0xbfaa93f1}},	//   _begj, _škod, _אַן_, итие_,
   {{0x2d984efd,0xdfd08013,0x69dc4efe,0x3ebf012b}},	//   _hore_, عية_, hore, _žuti_,
   {{0x69dc0578,0x2d98253d,0x7ae40fd3,0x64418faf}},	//   kore, _kore_, _nyit, erli,
   {{0x929d8063,0x69dc00ab,0xdd9aa482,0x161f1199}},	//   _zgło, jore, рши_, मीटर_,
   {{0x2d984eff,0x7ae4335a,0x6603cf00,0xdb1d02be}},	//   _more_, _ayit, _dink, lisé,
   {{0x6603c751,0x2d980295,0xb4ea8441,0x212c83ed}},	//   _eink, _lore_, _मरी_, _hedh_,
   {{0x6603811b,0xdb1d2538,0x64419384,0xdceb01f4}},	//   _fink, nisé, arli, _čiča,
   {{0xa184027e,0x200c84b9,0xbf9b03a7,0x66038084}},	//   мысл, _kudi_, _ciên, _gink,
   {{0x200c90e1,0x65689eb3,0xa3bc816f,0x69cacf01}},	//   _judi_, medh, ेचा_, infe,
   {{0x64488393,0x31678192,0x6603cf02,0x656880f1}},	//   mudi, zenz_, _zink, ledh,
   {{0x69dc3a2f,0x1ab40364,0x7bdd4f03,0x59bc800c}},	// [4050] bore, _объя, mosu, ्चार,
   {{0xd90489a7,0x386100b9,0xb5fb0032,0x2d9835db}},	//   _لی_, _tphr_, _asár, _core_,
   {{0x2d984f04,0x63a9b3ce,0xdb008580,0x3319cf05}},	//   _dore_, _plen, _almà, біля_,
   {{0x98a30035,0x656880d7,0xdcee1ee0,0x00000000}},	//   gają_, hedh, _gabč, --,
   {{0x672bcf06,0x7e7d29ed,0x2d980b56,0x65689e29}},	//   _regj, _ursp, _fore_, kedh,
   {{0x2d9802a5,0x6568820f,0x672b8125,0xa9698cae}},	//   _gore_, jedh, _segj, сика_,
   {{0x7e62cf07,0x660381e2,0x6c542344,0x3f99003a}},	//   _apop, _rink, _окру, _kosu_,
   {{0x69dc011f,0x63bbcf08,0x2d9802a5,0x6603cf09}},	//   zore, _umun, _zore_, _sink,
   {{0xdd918bca,0x69dc4f0a,0xdb1d0661,0x65688c53}},	//   فوظ_, yore, cisé, fedh,
   {{0xc05b8cde,0x3f990e80,0x41b5845b,0x6568bd9b}},	//   _від_, _losu_, _عمار, gedh,
   {{0xbf9b0028,0x657505a3,0x6603cf0b,0xb0db016f}},	//   _riên, _mazh, _vink, _मुलग,
   {{0x6603c969,0x7bdd4292,0x320d80b9,0x3f994b1f}},	//   _wink, gosu, _kuey_, _nosu_,
   {{0x6603cf0c,0x213100dd,0x7bcbcf0d,0x6448cf0e}},	//   _tink, fazh_, ingu, audi,
   {{0x200c8a46,0xceb280be,0x7769c963,0x67e58661}},	//   _yudi_, _איד_, leex, dóji,
   {{0x03a6067c,0x69dc4f0f,0x2d87cf10,0xe7f8016f}},	//   _нико, rore, _inne_, ंगला_,
   {{0x3f8604c3,0x4c3a8039,0xdb1d0019,0xf43a8039}},	//   ñou_, _התקב, yisé, _התקש,
   {{0x69dc4573,0x7e6d00e4,0xa3d90035,0x00000000}},	// [4060] pore, gwap, ़कर_, --,
   {{0xc27b0f60,0xf27b012a,0x67c50084,0x3f8f007b}},	//   _פריי, _פריש, dėju, ögur_,
   {{0x2d98021e,0x399b03c8,0x999b0039,0x319b01c6}},	//   _vore_, _הייד, _הביט, _הבינ,
   {{0x200ccf11,0x7bcb9217,0xdb1d07bc,0x320d8661}},	//   _rudi_, gngu, tisé, _buey_,
   {{0x200c89a6,0x2d983cee,0x6286b1a7,0x98a30035}},	//   _sudi_, _tore_, _škob, rają_,
   {{0xdb1d282c,0x7bcbcf12,0x67244f13,0xceb303de}},	//   risé, angu, lbij, _טיר_,
   {{0x64489613,0x7e62cf14,0xb4eaa0d5,0x7bdd3e2c}},	//   xudi, _spop, _मरे_, yosu,
   {{0x442a02f7,0x27e200ee,0x69ca8115,0x200c8088}},	//   _iwb_, _jkkn_, snfe, _vudi_,
   {{0x7bdd005c,0x442a2f54,0x35f48767,0x6568cf15}},	//   vosu, _hwb_, мпир, tedh,
   {{0x200ca52d,0x64489883,0x4444396a,0x644300eb}},	//   _tudi_, tudi, or_, šnie,
   {{0x92e900c8,0xb0db12c7,0x6568ad68,0xaac0816f}},	//   _বলে_, _मुंग, redh, _शेतक,
   {{0x4444435c,0x2d87cf16,0x6448cf17,0x68e9001b}},	//   ir_, _enne_, rudi, ředk,
   {{0x5187433d,0x444411e6,0x6448cf18,0x3f990087}},	//   пува, hr_, sudi, _rosu_,
   {{0x3f994f19,0x76440f33,0xddcd009a,0x628081a1}},	//   _sosu_, driy, ztał, _mrmo,
   {{0xaf12819d,0x557783c8,0x444415f6,0x971a019d}},	//   _fụtụ, _מעגן_, jr_, _ọdụd,
   {{0x5f940676,0x94738013,0x213100f1,0x6280cf1a}},	//   нист, _أدوا, sazh_, _ormo,
   {{0x63ad4f1b,0x443800e7,0x7bc2cf1c,0x442a4f1d}},	// [4070] _ilan, _avr_, diou, _awb_,
   {{0x63ad01f6,0x645704b7,0x44444f1e,0x7e6d0cda}},	//   _hlan, ttxi, fr_, rwap,
   {{0x63ad4f1f,0x6575020f,0x442a255d,0xf9920039}},	//   _klan, _vazh, _cwb_, _סרט_,
   {{0x7988cf20,0xff2509d7,0x320581d6,0x61e183ed}},	//   _andw, _تبدی, _sily_, _skll,
   {{0x27e901e4,0xd25ba1d2,0x1ee7004e,0x63ad4f21}},	//   mlan_, сце_, _روسی_, _mlan,
   {{0x27e91a50,0x63ad4f22,0xddcd0063,0x44444f23}},	//   llan_, _llan, stał, br_,
   {{0x442a00fc,0x3205816b,0x7bcbcf24,0x27e94f25}},	//   _gwb_, _vily_, pngu, olan_,
   {{0xe6199b78,0x22408390,0x27e916fb,0x79888365}},	//   оди_, šika_, nlan_, _endw,
   {{0x66070613,0x6d4a1727,0xc2c481a8,0x27e94f26}},	//   _kijk, ófag, _كيفي, ilan_,
   {{0x63ad4f27,0x67240025,0x27e94f28,0xd838007a}},	//   _alan, zbij, hlan_, šči_,
   {{0x442a10af,0x27e94f29,0x69c3a776,0x673d15db}},	//   _xwb_, klan_, mine, _odsj,
   {{0x66070a0f,0xfc3f8efc,0x63ad4f2a,0x547a0039}},	//   _lijk, čí_, _clan, קטרו,
   {{0xeb970656,0x69c38c64,0x5f058048,0x6b8980dd}},	//   фия_, oine, _ўзла, _mneg,
   {{0x63ad4f2b,0xdcee0029,0x76444f2c,0x6b9b8e35}},	//   _elan, _labā, vriy, _loug,
   {{0x63ad04ce,0x661d2c62,0xc0e3217e,0x672400f3}},	//   _flan, _atsk, ворк, tbij,
   {{0x6d4300ab,0xa3e60fcc,0x69c3cf2d,0x76444f2e}},	//   ónan, _बीच_, hine, triy,
   {{0x69c3cf2f,0x444437f5,0x67244f30,0x442a0282}},	// [4080] kine, wr_, rbij, _swb_,
   {{0x272c0104,0x27e909ca,0x44440a89,0x6ec204e5}},	//   ến_, alan_, tr_, _रेणु,
   {{0x44441a93,0x27e94f31,0xbc6a003d,0x442a01c0}},	//   ur_, blan_, تمان_, _qwb_,
   {{0x44444f32,0x76440385,0x27e901e4,0x29183550}},	//   rr_, priy, clan_, lcra_,
   {{0x7bc2a840,0x6b89808e,0x799a809a,0x27e022b2}},	//   riou, _dneg, _potw, moin_,
   {{0x442a01e9,0x7bc2b13d,0x644305e4,0x6b8993fe}},	//   _twb_, siou, ánic, _eneg,
   {{0xa3de1664,0x660f4f33,0xb4cc8740,0xec16003d}},	//   तका_, _zuck, _रखे_, _آورد,
   {{0x660701ed,0x6d5e09ff,0x27e007c5,0x69c3cf34}},	//   _zijk, lfpa, noin_, aine,
   {{0xaf128135,0x6ac80e70,0xb5fb04e8,0x056aaba7}},	//   _bụrụ, रपोर, _opál, ојни_,
   {{0x27e946b1,0x68e901d0,0xdc3e016b,0x69ce090d}},	//   zlan_, ředi, _líče, jnbe,
   {{0x69dd81a8,0x27e94f35,0x27e0062c,0x98a78493}},	//   _ísea, ylan_, koin_, rană_,
   {{0x69ce36c0,0xe717803d,0x61eacf36,0xf0b780be}},	//   enbe, _قيمت_, llfl, _קלאר_,
   {{0x27e92b61,0x672f01a1,0x5ede02f1,0x63ad01d6}},	//   vlan_, _recj, _कुल्_, _vlan,
   {{0xa4d4835f,0x44214f37,0x63ad4612,0x660f4f38}},	//   _полі, yph_, _wlan, _ruck,
   {{0x2eed0024,0x27e90065,0xdb0b81df,0x660700f3}},	//   _šef_, tlan_, tigü, _rijk,
   {{0x69c3cf39,0x63ad2bf2,0x2fc48609,0x660f4f3a}},	//   zine, _ulan, nimg_, _puck,
   {{0x2458cf3b,0x35f50171,0x69c3cb78,0x3ea4cf3c}},	// [4090] lém_, епар, yine, nymt_,
   {{0x2d9c809f,0x6b898968,0xdce70035,0x660f0b80}},	//   _jove_, _sneg, _zaję, _vuck,
   {{0x27e901eb,0x645a8364,0x61e514ec,0xb4cc9344}},	//   plan_, ntti, _ikhl, _रखो_,
   {{0x2d9ccf3d,0x660700f3,0x290c8420,0x645a8198}},	//   _love_, _wijk, _agda_, itti,
   {{0x201ea35a,0x661d0b64,0xdcef8267,0x645a890d}},	//   _atti_, _utsk, _čeča, htti,
   {{0x68e88355,0x2458801b,0x69c38362,0x7bc08365}},	//   _bydd, kém_, uine, _emmu,
   {{0x3d1a053e,0xe739a18c,0x64740198,0x201e8580}},	//   मुळे_, пей_, _игру, _ctti_,
   {{0x69c3ae52,0x68e8831d,0xb4ab03b7,0x80be816f}},	//   sine, _dydd, गनी_, _वेळे,
   {{0x92ea00c8,0x645a8656,0x201e8214,0xb9068a0d}},	//   _গল্প_, etti, _etti_, _यु_,
   {{0x68e8831d,0x2fcd831d,0x69c3cf3e,0xdb0b816a}},	//   _fydd, sneg_, qine, pigó,
   {{0x64a58196,0x657881c0,0x69c1cf3f,0xdca59f72}},	//   хана, _davh, _imle, хани,
   {{0xe3b2045a,0x7f848013,0x61e54f40,0xdb04241f}},	//   ارد_, _للمن, _akhl, _aliá,
   {{0x645acf41,0x27e00198,0xda0f81cb,0x3ce60072}},	//   atti, voin_, ादित_, _जुने_,
   {{0xe9df008b,0x2018cf42,0x6d434f43,0x00000000}},	//   trúa_, _éric_, ónal, --,
   {{0xe3b200f7,0x69ce2cfb,0x24588187,0x7bcf01c0}},	//   _مرة_, rnbe, cém_, bncu,
   {{0x2d9c8025,0x201e00eb,0xafe318a2,0xb90802f1}},	//   _zove_, īti_, госл, _बड_,
   {{0x7ae99eb3,0x764d0388,0x7bc606a7,0x0d86249a}},	// [40a0] _nyet, guay, miku, нлан,
   {{0x7bc62f9e,0x27e002be,0x3f9d826b,0x2d9c81df}},	//   liku, soin_, _lowu_, _xove_,
   {{0x28df901b,0x31570158,0x0b46885f,0xe8990065}},	//   _पुलि, _איין_, енен, _ہمیں_,
   {{0x7ae98c2e,0x7bc64f44,0x68e88b7f,0x224681e0}},	//   _byet, niku, _rydd, trok_,
   {{0x41e686b5,0x2458cf45,0x68e897db,0xdb1d041c}},	//   ніка, zém_, _sydd, lisã,
   {{0xd8380353,0x7ae9cf46,0x645acf47,0xdb1d09b2}},	//   šču_, _dyet, ytti, visí,
   {{0x232a8139,0x7bc630a0,0xab2a813a,0x7ae99896}},	//   _нови_, kiku, _нова_, _eyet,
   {{0x2d9ccf48,0x628425d5,0x2458801b,0x224686a4}},	//   _sove_, _orio, vém_, prok_,
   {{0x7bc61611,0x2d9c807a,0x765b8ce9,0x68e88114}},	//   diku, _pove_, gtuy, _wydd,
   {{0x2458cf49,0x98a78035,0x2ca58366,0x2b400db1}},	//   tém_, waną_, fyld_, _adic_,
   {{0x7bc64f4a,0x62844f4b,0x3a204f4c,0x7792881b}},	//   fiku, _ario, _atip_, _میثا,
   {{0x62840224,0x2458cf3b,0x7bc64f4d,0x645acf4e}},	//   _brio, rém_, giku, rtti,
   {{0x62841c9d,0x27e6cf4f,0x645a8bbd,0x69da01d0}},	//   _crio, _ikon_, stti, čten,
   {{0x2244026f,0xddd98176,0x6578804a,0x049481a8}},	//   ámka_, _apwņ, _uavh, _للتح,
   {{0x62844f50,0x28db12ee,0x7bc61f34,0x2fc202f7}},	//   _erio, _मुखि, biku, _bmkg_,
   {{0x62844f51,0x8d7700d7,0x17f801a8,0xddc405b2}},	//   _frio, کارا, فرقة_, ttiş,
   {{0x62844f52,0x6b8d0079,0xe61300f7,0x78a10106}},	// [40b0] _grio, _inag, اشر_, älvb,
   {{0x64489412,0x7c3acf53,0x201e023e,0xddc98b80}},	//   ordi, ostr, ític_, zvež,
   {{0x69c70668,0xdb1d03a7,0x7ae99c46,0x776d0118}},	//   mije, cisã, _syet, peax,
   {{0x69c7111b,0x7ae9820f,0x53e1016f,0x7c3aa8c6}},	//   lije, _pyet, नविश, istr,
   {{0xbf360051,0xdb0f07a3,0xfe088028,0x853c8084}},	//   _בארץ_, licó, _hữu_, rkėj,
   {{0x69c70025,0x7c3acf54,0x27e69c33,0x64488699}},	//   nije, kstr, _akon_, krdi,
   {{0x7c3acf55,0xa3e1052a,0x7ae982e6,0xbddb0176}},	//   jstr, थवा_, _wyet, _avèg,
   {{0x7c3a9412,0x7c251106,0xa5bb0061,0xc6240264}},	//   dstr, mphr, _utób, _পিতা_,
   {{0x200b002e,0x7bc64f56,0x2a690282,0x69c72bd7}},	//   _mici_, viku, _npab_, kije,
   {{0x0d829663,0x6b8d4f57,0x200b0289,0x69c18c54}},	//   альн, _anag, _lici_, _umle,
   {{0x69c72368,0x7c3aaa33,0x40358790,0x6448817f}},	//   dije, gstr, _реес, grdi,
   {{0x200b0012,0xdb1d0073,0x62844f58,0x61e3b6b2}},	//   _nici_, visã, _prio, lonl,
   {{0x7bc60d7a,0x27ffcf59,0x64489384,0xe29716fe}},	//   riku, mmun_, ardi, вая_,
   {{0x27edbd2a,0x200b29de,0xa06a1597,0x69c70503}},	//   llen_, _aici_, мага_, gije,
   {{0xddd6003e,0x200b3340,0x29cd0858,0x6e3ba320}},	//   jvyš, _bici_, džad_, lsub,
   {{0x62844f5a,0x6f1b810b,0x4425cf5b,0x6a86002e}},	//   _trio, ncuc, mpl_, _алиа,
   {{0x69c7003a,0x200b0b9a,0x27edcf5c,0x62841041}},	// [40c0] bije, _dici_, ilen_, _urio,
   {{0x27ed8352,0x69c7003a,0x75d300f7,0xca370039}},	//   hlen_, cije, ليقا, _שניה_,
   {{0x27ed813c,0x27ff80dd,0x61e3cf5d,0x44258176}},	//   klen_, kmun_, donl, npl_,
   {{0x61ee4f5e,0x27edcf5f,0xdb0f023e,0x8fa63c3d}},	//   llbl, jlen_, licò, _раме,
   {{0x7c3acf60,0x63a984b7,0x86432c3b,0x27edcf61}},	//   zstr, _ċent, _княж, dlen_,
   {{0x27edcf62,0x61e3c000,0x7c3aaaf9,0x415380e8}},	//   elen_, gonl, ystr, ивіс,
   {{0x2eca83b6,0x660a86cb,0xddc98035,0x27edcf63}},	//   ाप्त, _rifk, steś, flen_,
   {{0x6448805c,0x27edc235,0x6729a5b3,0x65ad8144}},	//   vrdi, glen_, gbej, _búho,
   {{0xb8e988fd,0x6e3b8c27,0x657c4f64,0x245c016b}},	//   _ले_, gsub, _karh, lím_,
   {{0x6b8d0025,0x7c3a8d35,0x657e015d,0x64488353}},	//   _snag, tstr, ndph, trdi,
   {{0x245c0a56,0x69c70582,0x63a0cf65,0xaefb026b}},	//   ním_, vije, _komn, _abùl,
   {{0xa3d5a9b7,0xd5b08077,0xd3a71541,0xa73a8f24}},	//   िचय_, _گفت_, троп, _آثار_,
   {{0xfe728bca,0xec0a0104,0x7af60063,0xf77304c0}},	//   _خدا_, _nếu_, _czyt, یار_,
   {{0x63a0cf02,0x7c3acf66,0x7bc405ee,0x6e2d9238}},	//   _lomn, pstr, _emiu, _çaba,
   {{0x69c7003a,0x6286bdbb,0x245c026f,0x999980e1}},	//   rije, _škol, jím_, _ísť_,
   {{0x245c026f,0x657c013c,0x02a70705,0x63a081f6}},	//   dím_, _aarh, _аром, _nomn,
   {{0x291e80f2,0x69c71351,0x62828a0f,0x61e3861c}},	// [40d0] _ofta_, pije, jvoo, yonl,
   {{0x67298088,0x68ed801b,0xa5bb0032,0xdc4281d0}},	//   zbej, řadi, _awór, _léče,
   {{0x657c2054,0x63a0cf67,0x61e3862c,0x62829151}},	//   _darh, _bomn, vonl, evoo,
   {{0x27ff077f,0x6e22cf68,0x7a3881bc,0x764982c4}},	//   _òun_, _otob, _ụtar, yrey,
   {{0x63a091ec,0x657c0d8b,0xd945b93f,0x27ed9277}},	//   _domn, _farh, гели, vlen_,
   {{0xec0a0028,0x487994ed,0x245c016b,0x7f428661}},	//   _hết_, есия_, bím_, _adoq,
   {{0xec0a0104,0x61e386c7,0x27ed8065,0x245c027f}},	//   _kết_, ronl, tlen_, cím_,
   {{0x61e38019,0xec0a001c,0x869980a9,0x291ecf69}},	//   sonl, _yếu_, етот_, _efta_,
   {{0x67298022,0x7aed0397,0x3ea92380,0x27edcf6a}},	//   rbej, _nyat, nyat_, rlen_,
   {{0x6e3bcf6b,0x27edcf6c,0x6f1b8144,0x764981b4}},	//   rsub, slen_, scuc, rrey,
   {{0x7535139a,0x6e3bcf6d,0x7aed3efd,0xc10481a8}},	//   _mezz, ssub, _ayat, _نوكي,
   {{0xc209073a,0xddcd003a,0x3ea90455,0x7aed1b19}},	//   _זה_, jvaž, kyat_, _byat,
   {{0xdcf40279,0x29cd08ae,0x7aed00b4,0x290a8118}},	//   _čača, džab_, _cyat, _ºbac_,
   {{0x06e580ab,0x9d55815b,0x3ea94f6e,0x99d600f7}},	//   _পৃথি, _صنعت, dyat_, اتحا,
   {{0x18674f6f,0x64434f70,0xa3e38bb8,0xa0674a52}},	//   лари_, ánil, नका_, лара_,
   {{0x245c001b,0x645c8722,0x1fb50087,0xaefb026b}},	//   vím_, àrie, асур, _ibùj,
   {{0xa6860084,0x657c136e,0x3ea94f71,0x93fb007c}},	// [40e0] ылад, _parh, gyat_, _אלקי,
   {{0x245c03cb,0x63a0881a,0x3ea08014,0xaf030087}},	//   tím_, _somn, _àite_, спул,
   {{0xe73a02ac,0x80a880c8,0xa0a616d9,0x63a089b3}},	//   _пен_, _কেন্, _санд, _pomn,
   {{0x65ad81ac,0x644a023e,0x245c4f72,0x99990084}},	//   _súhl, àfiq, rím_, busų_,
   {{0x245c0775,0x4423020f,0x657c0a6e,0xa29485e9}},	//   sím_, _etj_, _tarh, ралі,
   {{0x62828b3c,0xfce6117f,0x91e38198,0x3f8f8234}},	//   rvoo, _бого, боче, _angu_,
   {{0x98a70e78,0x628280bd,0xf1a9803d,0x6e22cf73}},	//   čića_, svoo, خانه_, _stob,
   {{0x6d43cf74,0x7c3e209b,0x3f804f75,0x753505ee}},	//   _adna, mspr, ndiu_, _zezz,
   {{0xb5fb178e,0x7c3e2a33,0x2487802a,0x36d4983a}},	//   _spái, lspr, _arnm_, ропр,
   {{0x3f8fcf76,0x7aed0314,0x660e0372,0xd90ecf77}},	//   _engu_, _ryat, _jibk, _عیب_,
   {{0x7aed07d5,0xd7efb314,0x6d4301a8,0x628f96f0}},	//   _syat, _гу_, ónai, _àcor,
   {{0x3ea90086,0xce358061,0x2fc9022c,0x317e9fa4}},	//   yyat_, _چونک, xiag_, _hatz_,
   {{0x65949401,0xdcf500eb,0x3a2480b9,0x2fc68122}},	//   _валу, _mazā, _jtmp_, _imog_,
   {{0x7aed08b1,0xa5bb4f78,0x7c3e0687,0x7002819d}},	//   _vyat, _atón, kspr, _ọcha,
   {{0xb76701e5,0xd48f88b0,0x351b83c8,0x3ea94f79}},	//   лтай, _ур_, _אוונ, wyat_,
   {{0x443ecf7a,0x7c3e04fe,0x753a811e,0x64434f7b}},	//   mst_, dspr, latz, ánim,
   {{0x75350098,0x260d0279,0x69cacf7c,0xe81b85fc}},	// [40f0] _pezz, _džon_, kife, _पूना_,
   {{0x753a8102,0x44234f7d,0x443ecf7e,0x64430796}},	//   natz, _ptj_, ost_, šnim,
   {{0x443e8558,0x69cacf7f,0xec0a001c,0x3ea90359}},	//   nst_, dife, _tết_, syat_,
   {{0x443e8ae2,0x753aafa9,0xdb0086c0,0x63af04e8}},	//   ist_, hatz, _komè, nkcn,
   {{0x753a811e,0x672d4f80,0x2d8503a7,0x386c8118}},	//   katz, mbaj, _óleo_, _apdr_,
   {{0x644a1313,0x2169b0bc,0x443ecf81,0x60258c07}},	//   áfic, тики_, kst_, адка,
   {{0x443ecf82,0xdb1d0125,0x753a8102,0xf77f0214}},	//   jst_, nnsó, datz, _kaç_,
   {{0x07a5cf83,0xc1d20e00,0xf77f0580,0x443e9ed3}},	//   раин, _सद्ग, _jaç_, dst_,
   {{0xee368b71,0x764d4f84,0xdcf88353,0x9f5e8019}},	//   аны_, nray, _davč, _autó_,
   {{0x27e08805,0x7bcbcf85,0x27338028,0x443ecf86}},	//   čina_, ligu, ản_, fst_,
   {{0x443e888a,0xab2a134e,0x764d4e07,0x237f8282}},	//   gst_, кона_, hray, _kauj_,
   {{0x9991012b,0x7bcbcf87,0xb4d5998e,0x2d98816d}},	//   _čašu_, nigu, _सखी_, örer_,
   {{0x2d910586,0x237f8282,0xdb00cf88,0xa2c0001b}},	//   _onze_, _mauj_, _comè, _लेख्,
   {{0x764d002a,0x7bcb833e,0xdb00c649,0x237f8069}},	//   dray, higu, _domè, _lauj_,
   {{0x64430a20,0x52d1816f,0xaca40133,0x77640197}},	//   šnij, तपुस, _kwụr, tfix,
   {{0x673b8110,0x69cacf89,0x788081d0,0x3f800162}},	//   nauj, zife, lává, udiu_,
   {{0x3f802590,0x22404f8a,0xd007163e,0x77b80118}},	// [4100] rdiu_, _uvik_, рете_, _níxe,
   {{0x7c3e0223,0x9d461194,0x77643803,0x644e802a}},	//   tspr, режд, sfix, ábig,
   {{0x6289cf8b,0x63a44f8c,0x14c8003d,0x98a7801b}},	//   _areo, _koin, دهای_, raně_,
   {{0x7c3e105d,0x764d4f8d,0x753a811e,0x63a44f8e}},	//   rspr, bray, zatz, _join,
   {{0x63a403d3,0x6289cf8f,0x63b64f90,0x02068009}},	//   _moin, _creo, _mlyn, аздн,
   {{0x443eaa4f,0x63a42ad0,0x77b8002a,0x7c3e20f0}},	//   yst_, _loin, _díxe, pspr,
   {{0x64a6130f,0xb9c38013,0x7b96835f,0x8c434f91}},	//   _тава, تقوي, _краї, _мере,
   {{0x22498052,0x237f81c0,0x9634a2b7,0x27f24f92}},	//   šaka_, _gauj_, бниц, nlyn_,
   {{0x753a80d3,0xa3e397ba,0x62338073,0x443e8428}},	//   tatz, नकर_, _меѓу, wst_,
   {{0xcd069895,0xdb00cf93,0x443e8a0f,0x550691c7}},	//   ични, _nomé, tst_, ична,
   {{0x753a80ad,0xdd9781e2,0x443ecf94,0x200f86c0}},	//   ratz, ршы_, ust_, _figi_,
   {{0x63a43c8d,0x443ecf95,0x753a8b90,0x200fc9c6}},	//   _coin, rst_, satz, _gigi_,
   {{0x443e9722,0x753a8102,0xc6769459,0x63a44f96}},	//   sst_, patz, _خطاب, _doin,
   {{0x463b8158,0x261a000f,0xdb00a72b,0xf77f0457}},	//   _יעדע, _बढ़ी_, _comé, _saç_,
   {{0xdb0084e8,0x63a400f7,0x63b60114,0xdcf50162}},	//   _domé, _foin, _flyn, _mază,
   {{0x63a40039,0x64431809,0x6d5c212b,0x57b412b2}},	//   _goin, šnik, _acra, обст,
   {{0x6b828144,0x2cac831d,0xdb008118,0x237fcf97}},	// [4110] ddog, lydd_, _fomé, _rauj_,
   {{0xeb9f0bc5,0x717512c5,0x764d4f98,0x2d9e8168}},	//   ljø_, _اهدا, rray, njte_,
   {{0x2ca7002e,0x2cac831d,0x237f8282,0x6fb500d7}},	//   ând_, nydd_, _pauj_, _همدا,
   {{0x77b83b56,0x96c20540,0x6d5c05f7,0x764d09c4}},	//   _píxe, _रेकॉ, _ecra, pray,
   {{0x6b80cf99,0x59bb09a9,0x673b8110,0x60db007e}},	//   _damg, _उतार, vauj, ğumu,
   {{0xc69200be,0x2cac816d,0x75388255,0x27e94f9a}},	//   _זאך_, kydd_, _nevz, loan_,
   {{0x7bcb8077,0x673b80eb,0x237f822c,0x7880928a}},	//   pigu, tauj, _tauj_, vává,
   {{0x27e94f9b,0x62898013,0x2cac8114,0x63ad82f1}},	//   noan_, _treo, dydd_, öand,
   {{0x63a4061f,0xddc2807a,0xe3b080f7,0x673b8612}},	//   _roin, _spoš, _غرف_, rauj,
   {{0x63a44f9c,0x2cac8114,0x7afbcf9d,0x27e94f9e}},	//   _soin, fydd_, _izut, hoan_,
   {{0x63b6003e,0x63a40806,0x27e9011e,0xec0a001c}},	//   _plyn, _poin, koan_, _bếp_,
   {{0xe29a2b3f,0x5f779a37,0xdb00802a,0x645c823e}},	//   гам_, _خاطر, _somé, ària,
   {{0x6d471502,0x63a40a26,0x7981802f,0x27e9011b}},	//   _odja, _voin, _kalw, doan_,
   {{0xc6928039,0x6d470326,0x6fde81a9,0x2fcd800b}},	//   _מאד_, _ndja, rīce, lieg_,
   {{0x63a40009,0xb4e61344,0x3ead8019,0xddc2807a}},	//   _toin, _पडे_, lyet_, _upoš,
   {{0x27e94f9f,0x79818247,0x4427cfa0,0x6441aa4c}},	//   goan_, _lalw, _itn_, msli,
   {{0x244393da,0x3ead8642,0x442781c0,0x8fa30991}},	// [4120] lım_, nyet_, _htn_, чате,
   {{0x6b80cfa1,0x8b08009a,0x7bc9a7d4,0x27f24fa2}},	//   _samg, _cięż, _ameu, slyn_,
   {{0x244382bb,0x6441cfa3,0xb4b212e0,0x64a000ce}},	//   nım_, nsli, टने_, _ošiš,
   {{0x69ce4fa4,0xec0a0028,0x80c100ab,0x4427cfa5}},	//   libe, _xếp_, _শুক্, _mtn_,
   {{0x7981bd16,0xdb040362,0x2443a2f8,0xab658ec3}},	//   _balw, _pliù, hım_, daļā,
   {{0x09e398a0,0x64419247,0x24438214,0x64439fd6}},	//   почн, ksli, kım_, _ovni,
   {{0xe4da1125,0x588681bb,0x3f8241eb,0x7e64160c}},	//   _صورت_, сыла, _kaku_, ltip,
   {{0x244382bb,0x27e08353,0xf0930039,0x6441a2ba}},	//   dım_, čino_, לנו_, dsli,
   {{0x2cac8355,0x3f824fa6,0xa3d5aa47,0x26c04fa7}},	//   wydd_, _maku_, िचर_, nzio_,
   {{0x3f820886,0x4427800e,0x27e9011b,0x7981b807}},	//   _laku_, _btn_, zoan_, _galw,
   {{0x6e2281bc,0x539900e8,0x644184dc,0x69ce0f3e}},	//   _dịọk, авня_, gsli, dibe,
   {{0x5f768875,0x3f824fa8,0x61e1223a,0x2cac831d}},	//   _دائر, _naku_, पक्ष, rydd_,
   {{0x7981b919,0x644181b0,0x6443913b,0xcb033c4f}},	//   _yalw, asli, _evni, रेंड_,
   {{0x65948c9d,0x3d9482df,0x8b08001b,0x27e909c4}},	//   _факу, _фикр, _stří, woan_,
   {{0x3f824fa9,0x27e94faa,0x442692c5,0x201a3f19}},	//   _baku_, toan_, _ارتف, _cupi_,
   {{0x1fa4067c,0xfd5901bc,0x7e7d00b9,0x9f5d8176}},	//   пруг, _febụ, _pssp, _chwè_,
   {{0x680a8063,0x3f82036e,0xdcfc01ac,0x7e6413d2}},	// [4130] _będz, _daku_, _darč, gtip,
   {{0x6d5acfab,0x7bcf4e74,0x69ce0511,0xbddb4fac}},	//   ngta, licu, cibe, _evèn,
   {{0x4427038e,0xa3ad0beb,0x6ad1824c,0xb5fb4fad}},	//   ën_, _गवा_, तप्र, _spás,
   {{0x7bcf4fae,0x2d9c0106,0x7981cfaf,0x8264003d}},	//   nicu, över_, _salw, _بهین,
   {{0xe299917e,0x2443817b,0x69d8807b,0x3cea86a7}},	//   рал_, zım_, fnve, _घुसे_,
   {{0xa2cd853e,0x7bcf4fb0,0x244383bf,0x3f8204b9}},	//   _देण्, hicu, yım_, _zaku_,
   {{0x6e2d157a,0xe1f09a37,0x2fcd8192,0x7e62912e}},	//   lpab, رسه_, tieg_, _aqop,
   {{0x6d5ac78d,0x69ce4fb1,0x2d830423,0xce49a3e7}},	//   egta, zibe, _haje_, азие_,
   {{0xe6169006,0x69ce4fb2,0x6e2d0144,0x6286cfb3}},	//   оды_, yibe, npab, _škov,
   {{0x644183a6,0x2d83011f,0x244383bf,0x442790e4}},	//   tsli, _jaje_, tım_, _ptn_,
   {{0x87e78153,0x3a290763,0xd469c64f,0x628d1b1d}},	//   _люде, _atap_, шине_, _arao,
   {{0x244382bb,0x201a4fb4,0x7c2d8da8,0xe6958872}},	//   rım_, _rupi_, _čard, _ولاد,
   {{0x29cd05f5,0x628d0083,0x24438214,0x6441cfb5}},	//   ržan_, _crao, sım_, ssli,
   {{0x63b880eb,0x6441a651,0x628d0219,0x2d832e5a}},	//   īvni, psli, _drao, _naje_,
   {{0x3a294fb6,0x7bcf023b,0x673f0168,0xdcfc4fb7}},	//   _etap_, bicu, faqj, _parč,
   {{0xa3be073c,0x25fd8076,0x69ce4fb8,0xa6db007b}},	//   _इति_, _रीती_, sibe, _meðf,
   {{0xf772812a,0x628d4fb9,0x2d834fba,0xdcfc007a}},	// [4140] וקן_, _grao, _baje_, _varč,
   {{0x6b840074,0x64570b6e,0xdd9207d2,0x26c0047f}},	//   _haig, fuxi, بوط_, rzio_,
   {{0x07a61056,0x7e641ffe,0x6b9601e2,0x649a0aac}},	//   _данн, stip, _knyg, штар_,
   {{0x2ca7016d,0x77b8002a,0xcb6a8af0,0x6d43008b}},	//   ända_, _fíxa, раде_, ónar,
   {{0x7e0301bc,0x00000000,0x00000000,0x00000000}},	//   ọsar, --, --, --,
   {{0x6b84032f,0x2d8308f2,0x7bcf4fbb,0x236d8609}},	//   _laig, _gaje_, zicu, _ebej_,
   {{0x2d85cfbc,0x29cd026c,0x628f83a8,0xdb1d0106}},	//   ddle_, džal_, _ácon, mnsö,
   {{0x44444fbd,0xca7696fe,0x753c43cc,0x6b844fbe}},	//   ms_, _музы, _herz, _naig,
   {{0x76444fbf,0x7bcf09c4,0xdb0d4fc0,0xdb00816b}},	//   nsiy, vicu, _ilaç, _komí,
   {{0x63a2a3d0,0x78a100f2,0x3f829c18,0x442a008e}},	//   ljon, älvk, žku_, _ktb_,
   {{0x6b841247,0x3a2900c9,0x753c4fc1,0x3d058075}},	//   _baig, _stap_, _merz, हेले_,
   {{0x76444fc2,0x63a2cbf2,0x6b844fc3,0x628d4fc4}},	//   ksiy, njon, _caig, _prao,
   {{0x7bcf44c6,0xaac54fc5,0x6b844fc6,0x9f49009f}},	//   ricu, _लेखक, _daig, llaç_,
   {{0x44444fc7,0x29cd0052,0x7bcf0098,0x442c8122}},	//   ks_, ržao_, sicu, ppd_,
   {{0x444448fc,0x6b840ad0,0x97a73d65,0x2d834fc8}},	//   js_, _faig, орал, _raje_,
   {{0x62808503,0x09b78519,0x628d1995,0x2d832d68}},	//   _osmo, _अत्य, _trao, _saje_,
   {{0x44444fc9,0x753c4014,0x44380114,0xa6db007b}},	// [4150] es_, _berz, _awr_, _meðg,
   {{0x44444fca,0xc05b0a4c,0x6724044a,0xdb008825}},	//   fs_, _кім_, acij, _comí,
   {{0x44440a85,0x753c01ec,0x62808102,0xdb00a9c3}},	//   gs_, _derz, _asmo, _domí,
   {{0x207a0158,0x987a0158,0x2d834c0e,0x307a00be}},	//   _פארא, _פארט, _waje_, _פארנ,
   {{0x44444fcb,0x79850ad4,0xbf9a04de,0x442a011b}},	//   as_, _kahw, _הירש, _etb_,
   {{0xe7f90076,0x44444fcc,0x20094fcd,0xd83886c4}},	//   ंतवा_, bs_, lmai_, _bwč_,
   {{0x44444fce,0x6286842b,0x661d0b40,0xc5f20039}},	//   cs_, _škot, _husk, _נדל_,
   {{0xb4d71a3b,0x6615011e,0x63a2809a,0x661d4fcf}},	//   ापी_, _hizk, cjon, _kusk,
   {{0xe81b8fcc,0x63bbc82e,0xd14b87d2,0x661d4fd0}},	//   _पूरा_, _ilun, _نشان_, _jusk,
   {{0x6b840219,0x6b9600f2,0x7bcd4fd1,0x63a9867f}},	//   _saig, _snyg, _amau, _hoen,
   {{0x6b840074,0x752501ec,0x98b800eb,0x20090019}},	//   _paig, ichz, karā_, kmai_,
   {{0x2d8384c4,0x64454fd2,0x63a98198,0x764401b4}},	//   žje_, ishi, _joen, ysiy,
   {{0xed4e891c,0x7985035a,0x63a981b0,0x64450723}},	//   _по_, _bahw, _moen, hshi,
   {{0x63a284b7,0x7c29001b,0x63bbcfd3,0x764403bf}},	//   zjon, _čern, _llun, vsiy,
   {{0x6d41adaf,0x63bbcfd4,0x6b844fd5,0x63a28118}},	//   mala, _olun, _taig, yjon,
   {{0x6d41cfd6,0x76444fd7,0x444403ab,0x20093ff5}},	//   lala, tsiy, vs_, gmai_,
   {{0x44444fd8,0x6615011e,0xe7370009,0x442a374e}},	// [4160] ws_, _bizk, яет_, _stb_,
   {{0x6d41843c,0x63bbcfd9,0x76444fda,0x443848e7}},	//   nala, _alun, rsiy, _pwr_,
   {{0x44444fdb,0x661d0379,0x753c4fdc,0x76440201}},	//   us_, _eusk, _verz, ssiy,
   {{0xdb008012,0x6d41cfdd,0x161b823c,0x661d00a4}},	//   _româ, hala, नदार_, _fusk,
   {{0x44444fde,0x753c4fdf,0x27ed874c,0x63a9a41f}},	//   ss_, _terz, doen_, _doen,
   {{0x63a2cfe0,0x6d418763,0x61ee473a,0x63bb80fa}},	//   sjon, jala, nobl, _elun,
   {{0x6d41cfe1,0x2d980106,0x44444fe2,0xa5bb026b}},	//   dala, _inre_, qs_, _atów,
   {{0x27ed811e,0xd6d9809a,0x7ae40118,0x6d5e0074}},	//   goen_, wała_, _oxit, lgpa,
   {{0x9f400019,0x7ae40168,0xa5bb0091,0x61ee27d1}},	//   llió_, _nxit, _awóy, kobl,
   {{0x6d5e4fe3,0xfe6f8829,0x61ee001b,0xf1b980fe}},	//   ngpa, ادي_, jobl, _puše_,
   {{0x7ae403a8,0x443889c4,0x3dbe00ab,0xb4b68105}},	//   _axit, èr_, _আদাল, छने_,
   {{0x79851a7b,0x9f5d8032,0x78fb81c6,0xd6d9866f}},	//   _sahw, _diwó_, _פלאפ, sała_,
   {{0x6d41cfe4,0xa3be035a,0xe61f00ff,0x59b0864a}},	//   bala, _इतर_, _trôi_, _जकार,
   {{0x201ecfe5,0x291a00ee,0x64454fe6,0xbf9b4c43}},	//   _kuti_, _cgpa_, yshi, _chên,
   {{0x661d4fe7,0x7ae439bd,0x213e9c33,0x66151142}},	//   _susk, _exit, _meth_, _rizk,
   {{0x657acfe8,0x201ecfe9,0x213e8014,0x77b803a8}},	//   leth, _muti_, _leth_, _díxo,
   {{0x645a8218,0x25aa031d,0x64454fea,0xaefb026b}},	// [4170] luti, _bobl_, wshi, _abùr,
   {{0xd9048288,0x657a8234,0x64450234,0x77b801df}},	//   _می_, neth, tshi, _fíxo,
   {{0xdcfc0029,0x645acfeb,0x63a9b807,0x63bbcfec}},	//   _parā, nuti, _poen, _plun,
   {{0x6d41cfed,0x657a805d,0x661d4fee,0x7bdd4fef}},	//   zala, heth, _tusk, nnsu,
   {{0x6d41cff0,0x213e831d,0x6286cff1,0x201e9bcf}},	//   yala, _beth_, _škor, _auti_,
   {{0x63a985f8,0x64434ff2,0x645a9473,0x29cd0267}},	//   _woen, ánis, kuti, džak_,
   {{0x27edca85,0x6d4190ed,0x201e8239,0x63a9837a}},	//   toen_, vala, _cuti_, _toen,
   {{0x6d41cff3,0x645acff4,0x201ece8a,0x224909d1}},	//   wala, duti, _duti_, _ovak_,
   {{0x6d41cff5,0x27edca85,0x3867813c,0x3f869210}},	//   tala, roen_, stnr_, _daou_,
   {{0xe2908bbe,0x27edcff6,0x645acff7,0x657acff8}},	//   _حذف_, soen_, futi, geth,
   {{0x645a8e01,0x7af60009,0x9f4b01d0,0xdb008174}},	//   guti, _syyt, _akcí_, _iomá,
   {{0x6d419397,0x333f83d3,0xd6ce80d5,0x60158110}},	//   sala, _jeux_, اقی_, _išmo,
   {{0x6d418e01,0x61ee4ff9,0x3f89031d,0xe1ff0333}},	//   pala, tobl, ddau_, rtón_,
   {{0x6d41b7fc,0xe1ff0511,0xe61f00e1,0x321f8144}},	//   qala, stón_, _osôb_, _muuy_,
   {{0xc7b8801c,0xdb008118,0x645aac04,0x7e69a741}},	//   _ttđt_, _momá, cuti, ltep,
   {{0xee3a4f05,0x3e6602be,0x9b46003d,0x7af60198}},	//   жна_, tôt_, _کنکو, _tyyt,
   {{0x7dc01f0f,0x2d87cffa,0x25aa031d,0xa2cd8d86}},	// [4180] _löse, _kane_, _pobl_, _देल्,
   {{0x3f890355,0xfd12045a,0x27e08805,0x62840870}},	//   adau_, نجا_, čini_, _isio,
   {{0x2d87cffb,0x93bd002e,0x3a2d86cb,0xdb1986c0}},	//   _mane_, mpăr, _atep_, viwò,
   {{0x333f82be,0x3e6600e7,0xf6260195,0x201ea637}},	//   _ceux_, pôt_, _одмо, _ruti_,
   {{0x333f83d3,0x657acffc,0x25aa026c,0x213e8114}},	//   _deux_, yeth, _tobl_, _peth_,
   {{0x201e8c27,0x2d87cb46,0x082a9508,0x3a2000b9}},	//   _puti_, _nane_, оции_, _muip_,
   {{0xdb00827f,0xab2a8d13,0x232a80e8,0x333f8036}},	//   _domá, _мова_, _мови_, _feux_,
   {{0x645abe18,0xf76f8124,0x657ab9f8,0xdb008722}},	//   vuti, لاً_, weth, _tomà,
   {{0x8e149b53,0x6e220013,0x2d87cffd,0xb4b6800d}},	//   ндиц, íobh, _bane_, छन्_,
   {{0x7bc29de6,0x2d87cffe,0x645aa4c0,0x65ad81d6}},	//   lhou, _cane_, tuti, _súhr,
   {{0xd7ef8193,0x62840009,0x333f80e7,0x657aceac}},	//   _ау_, _asio, _yeux_, reth,
   {{0x645acfff,0x7bc283b2,0xdb042509,0x657a8234}},	//   ruti, nhou, _aliñ, seth,
   {{0x6d4e0025,0xc33384de,0x7d1c02d4,0x6aa28118}},	//   _odba, כור_, _ogrs, nxof,
   {{0x79889142,0x2d8784b9,0x7d0304e8,0xdb1d03ca}},	//   _jadw, _gane_, ýnsk, lisü,
   {{0x798884b7,0x291880e1,0x7bc29699,0x2006d000}},	//   _madw, _úrad_, khou, _khoi_,
   {{0x80a00540,0x2d87d001,0x98a78503,0x7bc281ed}},	//   _ऑपरे, _zane_, žiću_, jhou,
   {{0x799aa40d,0x28cf000d,0x443c8282,0x63ad0087}},	// [4190] _ontw, _हेरि, _hwv_, _ioan,
   {{0x8d7707bd,0x63ad001c,0x443c81c5,0x7bc2b32d}},	//   بارا, _hoan, _kwv_, ehou,
   {{0x333f82be,0x6005a868,0xdb00d002,0x2d8700e1}},	//   _peux_, lóme, _romá, ľne_,
   {{0x799a9ab0,0x63ad19fd,0x2d87378d,0x69d5079a}},	//   _antw, _joan, žne_, lize,
   {{0x63ad0bb1,0x600585e4,0x333f82be,0xdb0085b9}},	//   _moan, nóme, _veux_, _pomá,
   {{0x69d55003,0x9f40007b,0xd6d98035,0xf1bf5004}},	//   nize, llið_, wało_, mpás_,
   {{0x6d454378,0x79888079,0xc7b88115,0x6f028db1}},	//   maha, _dadw, _suđa_, _azoc,
   {{0xde888104,0x6d455005,0x7bc2a1bf,0x799abee1}},	//   _bị_, laha, chou, _entw,
   {{0x20190b20,0x2d87d006,0xdb0084e8,0x3eb99eca}},	//   _misi_, _pane_, _tomá, ást_,
   {{0x77b59313,0xde88b5b0,0x6d451efa,0x77bc862f}},	//   _máxi, _dị_, naha, _véxa,
   {{0x69c38083,0xf1b98bda,0x6f028caa,0xc5f204de}},	//   mhne, _guša_, _ezoc, רדי_,
   {{0x6d455007,0xceb40201,0x2d8784b9,0xc7b8811f}},	//   haha, yyə_, _wane_, _tuđa_,
   {{0x6d450ec9,0x63ad5008,0xde88b5b0,0x2d878315}},	//   kaha, _doan, _gị_, _tane_,
   {{0x20195009,0x443c8282,0x69d5130e,0xbed680be}},	//   _aisi_, _fwv_, gize, _אונז_,
   {{0x6d45500a,0x7dc002af,0xc0e30a42,0x201920af}},	//   daha, _lösc, горк, _bisi_,
   {{0x67299d24,0x66188bcf,0x200db686,0x93bd0162}},	//   ncej, _zivk, nmei_, spăr,
   {{0x6d45500b,0x7649d00c,0x6284004f,0x60058144}},	// [41a0] faha, nsey, _usio, cóme,
   {{0x6b9bb4c3,0x69d535b8,0x443c822c,0x4d63098d}},	//   _anug, cize, _ywv_, лкув,
   {{0x19b7012a,0x7bc2d00d,0x443c8282,0x69c381e4}},	//   _נפטר_, thou, _xwv_, dhne,
   {{0xbea619b8,0xd8d700be,0x79888114,0x753b0088}},	//   _замк, _טויט_, _sadw, _đuze,
   {{0x6d451904,0x7bc28b3c,0x2006831d,0xf1b9a944}},	//   baha, rhou, _rhoi_, _suša_,
   {{0x6d450b20,0x28f895e3,0x7bc28848,0x69c3d00e}},	//   caha, мель_, shou, ghne,
   {{0x27e0500f,0xc5ec21e3,0x64580187,0x6f028061}},	//   onin_, जकीय_, ávid, _szoc,
   {{0xb4ac0e18,0x2d8a5010,0x27e05011,0x645e3143}},	//   गही_, _habe_, nnin_, mupi,
   {{0x7bc0d012,0x645e10d8,0x661894bd,0x69c38c5e}},	//   _ilmu, lupi, _pivk, bhne,
   {{0x69c3d013,0xde888028,0x657e5014,0x62829c11}},	//   chne, _vị_, neph, mwoo,
   {{0x61fc0713,0xa5bb0d38,0xa6db0125,0x81d600ab}},	//   dlrl, _któr, _meða, িকা_,
   {{0x2d8a4ff2,0xd5b88029,0x6282d015,0x205583c7}},	//   _labe_, skā_, owoo, _штур,
   {{0x6d451f24,0x27e0262f,0x628283b2,0x20190147}},	//   yaha, dnin_, nwoo, _risi_,
   {{0x27e08289,0x201925eb,0x7afd8aa2,0x60058333}},	//   činu_, _sisi_, _øste, róme,
   {{0x7bc09010,0xf8072f86,0x6d455016,0x657e1e8f}},	//   _olmu, ечан, vaha, deph,
   {{0x77b5c92f,0x6d455017,0x27e02320,0x645e5018}},	//   _páxi, waha, gnin_, dupi,
   {{0x2d8a5019,0x20191c1f,0x28c081a2,0x80d1064a}},	// [41b0] _babe_, _visi_, षैति, _डेरे,
   {{0x9ce71ee7,0x2019023b,0x78a10106,0xa5bb026b}},	//   нцел, _wisi_, älvs, _atór,
   {{0x6d45501a,0x2d8a011b,0x6e22a05e,0xf99f8129}},	//   raha, _dabe_, _luob, _đè_,
   {{0x628280f3,0x6235b5b4,0x291e82c4,0x7f4287b6}},	//   fwoo, веду, _agta_, _neoq,
   {{0x628284df,0x6d45501b,0x69c38c41,0xaab303b6}},	//   gwoo, paha, thne, ुनिक,
   {{0x2d8a011e,0x98b80084,0xe296964f,0x7e6d501c}},	//   _gabe_, sarą_, таш_, mtap,
   {{0x4425002e,0x69c3826c,0x3f8b501d,0xdcf88196}},	//   _îl_, rhne, _kacu_, _tavę,
   {{0x3f8b00fe,0x2d8a04b9,0x889c00be,0x02d280d4}},	//   _jacu_, _zabe_, לבוי, _देवभ,
   {{0x7e6d501e,0x44314861,0x200d8087,0x26c9004f}},	//   ntap, _htz_, rmei_, nzao_,
   {{0x442301e9,0xdb008884,0xef1f501f,0x7649d020}},	//   _kuj_, _domä, _saül_, rsey,
   {{0x69c193af,0x27e00672,0x44235021,0x3947b396}},	//   _ille, ynin_, _juj_, mans_,
   {{0x3947d022,0x44235023,0x7d1a008b,0x2d9cbfc7}},	//   lans_, _muj_, _útse, _enve_,
   {{0xf4128158,0x44230282,0x7dc00338,0x2e47826b}},	//   יפט_, _luj_, _lösa, _dìfá_,
   {{0x3947d024,0xaf0480e8,0xdb1b823e,0x65c7826b}},	//   nans_, _спіл, _lluï, _déhù,
   {{0xa06708d5,0xd9430b5b,0x442301c5,0xb21b013c}},	//   кара_, реси, _nuj_, tvær,
   {{0x2d8a0510,0x6d43d025,0x3f8d8548,0x3f8b180c}},	//   _sabe_, _hena, ndeu_, _cacu_,
   {{0x6d43c586,0x27e05026,0x321a003e,0x3947d027}},	// [41c0] _kena, rnin_, _tipy_, kans_,
   {{0xa5bb1b92,0x6d4384bf,0xb21b128d,0x3947d028}},	//   _stór, _jena, svær, jans_,
   {{0x6d43859c,0x3947d022,0x44235029,0x7afb8915}},	//   _mena, dans_, _cuj_, _ayut,
   {{0x62829aee,0x442301c0,0x657e502a,0x7c238706}},	//   twoo, _duj_, seph, _munr,
   {{0x394796b3,0x02d2800c,0xaad2801b,0x224db464}},	//   fans_, _देशभ, _देशक, _cvek_,
   {{0x62829337,0x3f9d81bc,0x7afb833e,0x657e036a}},	//   rwoo, _anwu_, _dyut, qeph,
   {{0x64a3181d,0x8c431e25,0x25aed02b,0x04433750}},	//   _кара, _весе, _rofl_, _весн,
   {{0x69c181a3,0xd90d826a,0x77bc8118,0x62962dcb}},	//   _elle, سین_, _véxo, _oryo,
   {{0x6d43d02c,0x661c502d,0x83fd0024,0x39479e9e}},	//   _bena, _kirk, nuđe, bans_,
   {{0x6d43d02e,0x68e9002e,0x661c502f,0x77b8002a}},	//   _cena, şedi, _jirk, _díxi,
   {{0x6d43cc4f,0x23b68006,0x3a24d030,0x224d8267}},	//   _dena, _अकाद, _hump_, _zvek_,
   {{0xccf30051,0x629609c4,0x3a2480b9,0x69d8ae52}},	//   יכת_, _bryo, _kump_, live,
   {{0xdfcf8624,0x7c2382f7,0x83fd190f,0x645d8084}},	//   _بين_, _eunr, juđe, ąsia,
   {{0x6d43d031,0x7c2384be,0x720500f7,0x661c09e1}},	//   _gena, _funr, اوسم, _nirk,
   {{0x7e60a34d,0x3f8b06cb,0x2fc20359,0x8a180087}},	//   lump, _pacu_, _blkg_, торс_,
   {{0xa5bb04c3,0x44235032,0x645a8390,0x39478bd6}},	//   _atóp, _ruj_, mrti, zans_,
   {{0x39478247,0x69d884dc,0x387a0db1,0x2ceb02f1}},	// [41d0] yans_, kive, _eppr_, _जुड़ल_,
   {{0x7e6d3c51,0x394782e6,0x6b8d5033,0x6d4382a6}},	//   rtap, xans_, _haag, _xena,
   {{0x3947a62d,0x7e6d010a,0x6b8d2a22,0x7afb8e6d}},	//   vans_, stap, _kaag, _syut,
   {{0x83fd0668,0xa3cd8035,0x7e6d09c4,0x39478c53}},	//   buđe, षों_, ptap, wans_,
   {{0x6d48d034,0x3947d035,0xb5fd803e,0x7e60b6e2}},	//   kada, tans_, luše, jump,
   {{0x69d886be,0x44233592,0xe81b83eb,0x6b8d00bd}},	//   give, _tuj_, _पूजा_, _laag,
   {{0x39478205,0x6adf0996,0x2369017f,0x2d815036}},	//   rans_, नपुर, _ocaj_, mehe_,
   {{0x6d43d037,0x39478bd6,0x661c21a3,0x236901c5}},	//   _sena, sans_, _zirk, _ncaj_,
   {{0x224d8d11,0xe6198dea,0x3f8dabe1,0x6d48c3f0}},	//   _uvek_, нди_, rdeu_, fada,
   {{0x7dc000f2,0xb5fd935a,0xddcd0035,0xceb200be}},	//   _lösn, kuše, jważ, ציי_,
   {{0x69c7020f,0xddc41c24,0xa3c006a7,0x6b8d0365}},	//   dhje, ntiš, ंघल_, _baag,
   {{0x4e95806b,0x6d43d038,0xdb1b8722,0x62960e35}},	//   _مشتر, _wena, _lluí, _pryo,
   {{0x6d43b55e,0xee2e8934,0x6d48cd3d,0xe1ff009a}},	//   _tena, _ын_, bada, ntów_,
   {{0x7bc6020f,0x27ffa7be,0x2d81111b,0xa5948081}},	//   shku, llun_, jehe_, _връщ,
   {{0xc8b50084,0x6b8d5039,0x057489a7,0x50b51246}},	//   асты, _faag, _خاند, асту,
   {{0xe1ff009a,0x200b001b,0x69d8b8e6,0x6b8d11c9}},	//   któw_, _chci_, zive, _gaag,
   {{0x661c1608,0xaf060470,0x764d0ce9,0x69d8a499}},	// [41e0] _pirk, упал, gsay, yive,
   {{0x59862550,0xf9921921,0x6b8d2ea8,0xdca60eef}},	//   _слоб, _طبخ_, _zaag, лази,
   {{0x661c05be,0x27e9d03a,0x3a2481e0,0x29cd02ce}},	//   _virk, čanj_, _sump_, ržat_,
   {{0x661c0352,0x4fa6165d,0x6d488510,0x926a91b3}},	//   _wirk, _симв, zada, ерка_,
   {{0x6d488be9,0xdb1bd03b,0x673b807a,0xbb3b0e82}},	//   yada, _fluí, dbuj, געני,
   {{0x7c29003e,0x7bc4009f,0xaca40135,0x644e026c}},	//   _červ, _lliu, _atụr, _tvbi,
   {{0x3945938d,0xa2db015c,0x6e26020d,0xfd690133}},	//   _dels_, _पेन्, _hukb, hapụ,
   {{0x69d8d03c,0x6005afb5,0x6d48d03d,0x57b48dc0}},	//   sive, tóma, wada, рбит,
   {{0x6d48d03e,0xda040072,0x6b8d01b4,0x2bb98075}},	//   tada, ळतात_, _raag, _आवता,
   {{0x7bc4503f,0x80ba00ab,0x6b8294f2,0x6b8d5040}},	//   _aliu, _উইন্, leog, _saag,
   {{0x7e60d041,0x6b8d1341,0x6e2602c4,0x7bc45042}},	//   sump, _paag, _lukb, _bliu,
   {{0x764d02b8,0x7e60d043,0x629d802a,0x645acb9d}},	//   ysay, pump, _ásoc, rrti,
   {{0x6d48d044,0x59b888fd,0x8f9b810f,0x7bc40706}},	//   pada, _अवार, _רידי, _dliu,
   {{0x6b8d5045,0x6d48afc7,0x645a807a,0x6b8282c4}},	//   _waag, qada, prti, heog,
   {{0x860791cc,0x6b8d02a3,0x4dfb8051,0xdb00840e}},	//   _حقوق_, _taag, _רפוא, _comú,
   {{0x69c700f1,0x764d00a4,0xb5fd85b9,0xdc9b8039}},	//   shje, tsay, ruše, _טיול,
   {{0x2d8eace1,0xa3ea035a,0x6b82cdb0,0x141c0039}},	// [41f0] _kafe_, _मदत_, deog, _אוהב,
   {{0x9967014f,0x21671445,0x76428365,0xb8db00ab}},	//   _стил, _стиг, _mwoy, _আই_,
   {{0x80d300c8,0x2d81022e,0x628980b9,0xb6042306}},	//   _দুর্, rehe_, _sseo, сятк,
   {{0x6722a0b3,0x321e8176,0x39459a1f,0xa1340019}},	//   _ngoj, _aity_, _sels_, _پریش,
   {{0x394587e2,0x216994d6,0xa969817c,0xfaa5a84f}},	//   _pels_, вили_, вила_, рало,
   {{0x321ed046,0x9f5200e7,0xa85589a5,0x98558284}},	//   _city_, voyé_, атиј, атиш,
   {{0xe1ff0063,0x24980118,0x7642c713,0x394581a1}},	//   stów_, _grrm_, _awoy, _vels_,
   {{0x765bd047,0x98a58087,0x9b898065,0x656a8229}},	//   truy, _află_, _جنرل_, _acfh,
   {{0x6d47059c,0x673b8216,0xdee59156,0xe3b08591}},	//   _keja, rbuj, ропи, _عرف_,
   {{0x6d470812,0x201d930c,0x7bc800eb,0x7e7d00b9}},	//   _jeja, _wiwi_, ījum, _mpsp,
   {{0xa3ea101c,0x7983d048,0x9d2200ab,0x7bc40084}},	//   _मदद_, menw, _পড়ুন_, _pliu,
   {{0x6d475049,0x69c5504a,0x7e7d3ccd,0x79838114}},	//   _leja, _alhe, _opsp, lenw,
   {{0x9814803f,0x75d58065,0xe5a5bd93,0x6286090d}},	//   _ابلا, _پيغا, _вили, uwko,
   {{0x8cb58021,0x6d4703f2,0xed598779,0x3f8fd04b}},	//   _всич, _neja, _рок_, _hagu_,
   {{0x7aed03a7,0x6e260122,0x7e7d01a9,0x59b89d40}},	//   _exat, _sukb, _apsp, _अवसर,
   {{0xa0670003,0x6d5503d2,0x44278087,0x2fc90637}},	//   јата_, _adza, _iun_, ghag_,
   {{0x442793e1,0x6d47504c,0x7983aa52,0x2d8e8300}},	// [4200] _hun_, _beja, kenw, _yafe_,
   {{0x4427d04d,0x442000f6,0x399a093f,0x3f8fcce6}},	//   _kun_, _hii_, _ייִד, _lagu_,
   {{0x6d47504e,0x6b82ac6c,0x4420504f,0x03269260}},	//   _deja, teog, _kii_, аден,
   {{0x4427d050,0x69dc5051,0x3f8f90b5,0x4420026b}},	//   _mun_, lire, _nagu_, _jii_,
   {{0x44205052,0x69dc00f7,0x83fd00ce,0x798395aa}},	//   _mii_, oire, nuđa, fenw,
   {{0xe8549301,0x79838d35,0x69dc5053,0x4427c051}},	//   منتد, genw, nire, _oun_,
   {{0xfce30c8e,0x25f517a3,0x4427b2c7,0x3f8f82c4}},	//   _доро, ्तरी_, _nun_, _bagu_,
   {{0x44200665,0x69dc5054,0x443a123c,0xf1b882a6}},	//   _nii_, hire, mpp_, _diġa_,
   {{0x4427d055,0x69dc1efb,0x3f8f8359,0x317a826a}},	//   _aun_, kire, _dagu_, _لحاظ_,
   {{0x77bc9fd1,0x4427bf80,0x44205056,0x69dc1b6d}},	//   _méxi, _bun_, _aii_, jire,
   {{0x442787f4,0x2fc000c9,0x442010ab,0x77bcaa3e}},	//   _cun_, kkig_, _bii_, _léxi,
   {{0x4427d057,0xe73a8dea,0x67228088,0xdcfe01a1}},	//   _dun_, _ред_, _ugoj, jepč,
   {{0x69dc3d27,0x4427d058,0x9b580098,0x2fc6820d}},	//   fire, _eun_, шият_, _ilog_,
   {{0x69dc5059,0x645e0d2f,0x44278039,0x2fc90122}},	//   gire, krpi, _fun_, whag_,
   {{0x44278046,0x44200012,0x2ee880ab,0xed578dc7}},	//   _gun_, _fii_, _পরিষ, _тој_,
   {{0x6d4714e5,0x3f84a254,0x69dc1dad,0x4420505a}},	//   _seja, nemu_, aire, _gii_,
   {{0x6d47059c,0xd2510013,0x69dc505b,0x61f88289}},	// [4210] _peja, _عند_, bire, kovl,
   {{0x3f84822e,0x442782b8,0x7bdd505c,0x27070a3a}},	//   hemu_, _yun_, lisu, _शरीर_,
   {{0x44270104,0xe4750003,0x4420077f,0x3f84d05d}},	//   ên_, слењ, _yii_, kemu_,
   {{0x442008f1,0x0c242e2e,0x889a02f6,0x7c20d05e}},	//   _xii_, імін, _עברי, _cimr,
   {{0x3f8f8274,0x6d470661,0x3f8486b8,0x79838f67}},	//   _ragu_, _teja, demu_, tenw,
   {{0xb5fd812b,0x2b493625,0x2fc682d5,0x61f8811f}},	//   kuša, _leac_, _alog_, govl,
   {{0x2fc68213,0x7bdd505f,0xb5fd80eb,0x3a2900dd}},	//   _blog_, kisu, juša, _luap_,
   {{0xdce18029,0x7c2080b9,0x071281bc,0x44278039}},	//   selī, _gimr, _gụkọ, _run_,
   {{0x26cd812b,0x2d910025,0xef198364,0x442010ab}},	//   uzeo_, _kaze_, ыми_, _rii_,
   {{0x44279a67,0x4420504f,0x69dc002a,0x69ca8799}},	//   _pun_, _sii_, xire, chfe,
   {{0x2d9102a0,0x85118035,0x3f8480c3,0x69fa80be}},	//   _maze_, डेंट_, bemu_, _עלעק,
   {{0x44279029,0x7bdd0deb,0x69dc5060,0x671b83eb}},	//   _vun_, gisu, wire, _पृथक_,
   {{0x442044e0,0x44278032,0x3a2902f7,0x69dc5061}},	//   _vii_, _wun_, _cuap_, tire,
   {{0x4427d062,0x77bc862f,0xa06a5063,0x44201532}},	//   _tun_, _réxi, лага_, _wii_,
   {{0x2d85b7c5,0xa3e7816f,0x69dc4cc8,0x44205064}},	//   mele_, यचा_, rire, _tii_,
   {{0x2d85d065,0x0b4601a1,0x2cb8816d,0x236d8282}},	//   lele_, _унин, ärde_, _ncej_,
   {{0xb8ff26ee,0x2d912e4d,0xbb3b0158,0x63a45066}},	// [4220] _दे_, _baze_, _געפי, _inin,
   {{0x2d85b238,0x99860307,0x3f84bf2d,0xa2b8864a}},	//   nele_, _الدو, zemu_, ्नस्,
   {{0x63a42bea,0x2d911c80,0xf1b9811f,0x46d9a724}},	//   _knin, _daze_, _guši_, _बेसह,
   {{0x2d85d067,0xc7b8811f,0x6e2d01b4,0xdcfa8493}},	//   hele_, _tuđi_, bqab, letă,
   {{0x2d85d068,0x7e641b01,0xaad28816,0x61f8807a}},	//   kele_, quip, _देखक, tovl,
   {{0x2d85d069,0x2fc6d06a,0xcaa580f7,0x2244016b}},	//   jele_, _slog_, تصمي, ámky_,
   {{0x2d85d06b,0x61f8d06c,0x3f84bc80,0xd010830f}},	//   dele_, rovl, temu_, ولت_,
   {{0x63b63bb0,0x96348374,0x9a29027d,0x63a40c2e}},	//   _noyn, ониц, _lươn_, _nnin,
   {{0x7bdd0a8d,0xcf930039,0x61f88042,0xa37b03a7}},	//   visu, לטה_, povl, niõe,
   {{0x442a01c5,0x63a4506d,0xf9c4804e,0x7bc282c4}},	//   _kub_, _anin, _بحری, lkou,
   {{0x26c2844a,0x2937893f,0xfe6f8bca,0x3a2909da}},	//   ško_, _האבן_, ودی_, _suap_,
   {{0x2fc68042,0xf1b98289,0xdb0d007b,0x290ca759}},	//   _ulog_, _ruši_, _blað, _izda_,
   {{0x442a506e,0x2d85d06f,0x15fa0fea,0xadfa0d5d}},	//   _lub_, bele_, ्तार_, ्तान_,
   {{0xf2d38158,0x2d85d070,0x236d009a,0xb5fd826f}},	//   לער_, cele_, żej_, lušn,
   {{0x442a022c,0xeb9f006a,0x44385071,0xcad2819d}},	//   _nub_, rløb_, _ntr_, dịmị,
   {{0x543b8158,0x7bdd0609,0x628d01a8,0x290c816b}},	//   _געהא, qisu, _tsao, _mzda_,
   {{0x442a5072,0x6d4ad073,0x2d9100d2,0xa37b03a7}},	// [4230] _aub_, _kefa, _paze_, giõe,
   {{0x7c2a936f,0x6d4ad074,0xfbdf041c,0xcaae8264}},	//   _kufr, _jefa, liê_, কনাফ,
   {{0xb5fd8db7,0xd49b0196,0x7c2a8239,0x62808084}},	//   kušn, ыра_, _jufr, _apmo,
   {{0x442a5075,0x2d85d076,0x69c8d077,0xf8a9803d}},	//   _dub_, zele_, _alde, یگاه_,
   {{0x2d85c2f5,0x957c809a,0x27e931b3,0xddc9826c}},	//   yele_, ciąg, mnan_, hteš,
   {{0x867a007c,0xddc281d0,0x957c8035,0x7c388390}},	//   _דרשו, _tvoř, niąd, _otvr,
   {{0x2d85d078,0x3dce80ab,0xd90e8019,0x27e902db}},	//   vele_, িচাল, ہیے_, onan_,
   {{0x27e95079,0xdbf203bb,0x2d85bf60,0x6d58ae52}},	//   nnan_, _přís, wele_, _adva,
   {{0x2d85d07a,0x27e90590,0x6d4ad07b,0x7c2a81ec}},	//   tele_, inan_, _befa, _aufr,
   {{0x6d4ad07c,0x6e3b81a9,0xb5fd9809,0x79870314}},	//   _cefa, rpub, krše, jejw,
   {{0x6d4ad07d,0x6e3bd07e,0x2d85d07f,0x7bc99aee}},	//   _defa, spub, rele_, _kleu,
   {{0x2d85d080,0x645c83a7,0x6d589db4,0xe29a041c}},	//   sele_, ária, _edva, аам_,
   {{0xeb9709b4,0x7bdb826c,0x16090327,0x4a435081}},	//   ция_, _mmuu, वतार_, мняв,
   {{0x83fd005c,0x8c4598a0,0x38a0802e,0x6d4ad082}},	//   vrđe, _деке, _fără_, _gefa,
   {{0x6d41d083,0xab5b08c5,0xd83880ce,0x290c1235}},	//   mbla, mkün, _trče_, åda_,
   {{0x63a45084,0x442a3dd7,0x27e9280c,0x7c29026f}},	//   _unin, _rub_, gnan_, _čerp,
   {{0x3ebf8458,0x7c2a8398,0x6d41851e,0x443800ed}},	// [4240] nyut_, _zufr, obla, _str_,
   {{0x442a01c5,0x7c241572,0x6d4a81df,0x27e9474f}},	//   _pub_, _hiir, _xefa, anan_,
   {{0x7c2409f8,0x442a01c5,0x6e23d085,0x7bc980e7}},	//   _kiir, _qub_, _minb, _bleu,
   {{0x2d0a016f,0x130682eb,0x61fc0162,0x395a02c4}},	//   _वरील_, озем, lorl, _hdps_,
   {{0xc7b30bea,0x7c2410ab,0x6d41874c,0x27e00a5b}},	//   _חבר_, _miir, kbla, miin_,
   {{0x442a1393,0x1a9b0158,0x4a9b00be,0x61fc5086}},	//   _tub_, יינע, יינג, norl,
   {{0xa9678fbb,0x7bc9d087,0x61edc1d1,0x6d4a9139}},	//   ција_, _fleu, éala, _refa,
   {{0x6d418e1b,0x6e2bd088,0x27e05089,0x7bc994cc}},	//   ebla, _bugb, niin_, _gleu,
   {{0x7c2a8b5a,0x61fc508a,0x7e76508b,0x4424d08c}},	//   _sufr, korl, ntyp, _iim_,
   {{0x27e002c1,0xb5fd80fe,0x6d41a7d1,0xd5ba9cd5}},	//   hiin_, sušn, gbla, рси_,
   {{0x27e01e38,0x69a7801b,0x4395151b,0x7c240079}},	//   kiin_, चारी, панс, _biir,
   {{0xb5fd803a,0x6d4a831d,0x6e2390f6,0x3e741743}},	//   vrše, _wefa, _einb, kät_,
   {{0x671685e8,0x4424d08d,0x6d41d08e,0x7c24508f}},	//   देशक_, _mim_, bbla, _diir,
   {{0x4424d090,0x6d58d091,0x35f78077,0xdb008feb}},	//   _lim_, _udva, _ورود_, _homó,
   {{0x7c38803a,0x61fd87ca,0x7e7601e0,0x27e05092}},	//   _utvr, _ísle, etyp, fiin_,
   {{0x4424c536,0xc7b8825b,0x395a0197,0xd9c28264}},	//   _nim_, _tuđu_, _edps_, ্চিম,
   {{0x27e921b4,0x443ec12d,0x7e765093,0x80dc0264}},	// [4250] rnan_, lpt_, gtyp, _মুদ্,
   {{0xd49b0012,0x7bc9837a,0x27e95094,0x69ce2b29}},	//   ире_, _sleu, snan_, chbe,
   {{0x7bc9d095,0xc17201c6,0x98bc81d0,0x27e92f08}},	//   _pleu, _אחי_, ravě_, pnan_,
   {{0x442481c5,0x70fa0039,0x60fa0039,0x78fa0039}},	//   _cim_, _להתח, _להתק, _לפתו,
   {{0x4424d096,0x80d38063,0xe29984fa,0xbf3603c8}},	//   _dim_, _भेजे, сал_, _מארץ_,
   {{0x6e2bd097,0x76ba0051,0x2249004f,0x3f891a1f}},	//   _rugb, _המשפ, _mwak_, leau_,
   {{0x4424d098,0x69c39412,0x671f03eb,0x443e81ed}},	//   _fim_, rkne, _मृतक_, jpt_,
   {{0x7bdbd099,0x3f890cf8,0xdb0081a8,0x443e80ee}},	//   _umuu, neau_, _comó, dpt_,
   {{0x6005840e,0x645c8db0,0x61fc0214,0x72058019}},	//   nómi, árin, yorl, _فورم,
   {{0x4424b709,0xd1b88060,0x7c2435e2,0xb5fda58f}},	//   _zim_, _والا_, _siir, dršc,
   {{0x7c2401c2,0x442481e9,0x2249509a,0x6d41800b}},	//   _piir, _yim_, _awak_, rbla,
   {{0x6d41d09b,0x44248069,0x6e2bd09c,0x395a0088}},	//   sbla, _xim_, _tugb, _sdps_,
   {{0x74c300c8,0x3f89509d,0x61fc19db,0x2905802a}},	//   ্পিউ, deau_, torl, _hyla_,
   {{0x3e74025d,0x8e0880e8,0xab5b0019,0xf1b9c573}},	//   vät_, _днів_, lkül, _gušt_,
   {{0x27e00364,0x5502809a,0x61fc509e,0x77bc81df}},	//   tiin_, _रुपए_, rorl, _téxt,
   {{0x3e74509f,0x4abdd0a0,0x09b8b849,0x7e76226d}},	//   tät_, ्नाव, _अव्य, ttyp,
   {{0x4adb84e5,0x27e050a1,0x2905808e,0xc0768129}},	// [4260] _मेलव, riin_, _lyla_, _bướm_,
   {{0x4424d0a2,0x27e02d48,0x3e741a3f,0x1a9b00be}},	//   _sim_, siin_, rät_, _פייע,
   {{0xa3e7816f,0x4424d0a3,0xc32a80f7,0x7e762aec}},	//   यचं_, _pim_, مكان_, styp,
   {{0x7c2e8187,0x3f891eed,0x7bc650a4,0x27e00df6}},	//   íbri, ceau_, nkku, qiin_,
   {{0x442481e9,0x6d5c8019,0xd0568085,0xf1b0109b}},	//   _vim_, órak, əcək, ञापन,
   {{0x443ed0a5,0x2905800d,0x1df78e5b,0x62840267}},	//   ypt_, _byla_, ुतोष_, _mpio,
   {{0x7dcb009a,0x6d5c50a6,0xddcd0087,0xdb008035}},	//   yższ, _idra, staţ, _pomó,
   {{0x6d4e0590,0xf09304de,0x394cb603,0x672201a9}},	//   _heba, תנה_, _weds_, žoju,
   {{0x6d4e059c,0x9f5f83a7,0x443e819d,0x69de50a7}},	//   _keba, cluí_, wpt_, _ompe,
   {{0x645c8003,0xddd6009a,0x7c2e50a8,0x60e7807b}},	//   ário, jwyż, _kubr, ármá,
   {{0x443e82af,0x6736009a,0x2249067f,0x9f530061}},	//   upt_, kcyj, _swak_, ődés_,
   {{0x6d4e1600,0x69de0cda,0x7e6450a9,0x7c2e010c}},	//   _leba, _ampe, krip, _mubr,
   {{0x3f8950aa,0x5fa99664,0xada68ff7,0xd7a98072}},	//   veau_, कारल, _надл, कारच,
   {{0x171b873a,0x6d4e1b75,0xddcd02a5,0x443ed0ab}},	//   _הודע, _neba, ktaš, ppt_,
   {{0x3cdc035a,0x3f890cf8,0x2905008b,0xa3be86ae}},	//   _गेले_, teau_, æla_, ेसा_,
   {{0x69de1a14,0x6d5c031d,0xb5fd81f4,0x6d4e0f3e}},	//   _empe, _adra, mrša, _aeba,
   {{0x6d4e0dab,0x443cd0ac,0x3f891030,0x7dc002af}},	// [4270] _beba, _htv_, reau_, _lösu,
   {{0x20021c86,0x3f8902be,0x7c2e0024,0x6d4e0333}},	//   _ekki_, seau_, _bubr, _ceba,
   {{0x7bcd1247,0x7c2e02ba,0x3f8950ad,0x6d5c0428}},	//   _klau, _cubr, peau_, _ddra,
   {{0x7c2e1123,0xdfc680f7,0x2c750370,0x69c70163}},	//   _dubr, _شي_, råd_, lkje,
   {{0x7e6450ae,0xdb0d0187,0xd6844197,0x443c9d46}},	//   crip, _doaç, _пурп, _ltv_,
   {{0x6d4e1254,0x200950af,0xb5fd8024,0x6458d0b0}},	//   _geba, llai_, krša, _ovvi,
   {{0x6d4538ec,0x7c2e008e,0xa6db007b,0x443cd0b1}},	//   mbha, _gubr, _veðu, _ntv_,
   {{0x6d5c3a71,0xee398847,0x6d450046,0x6d4e1f4b}},	//   _zdra, они_, lbha, _zeba,
   {{0x442e8943,0x6458d0b2,0xb904a701,0x6b8b9917}},	//   _auf_, _avvi, _पे_, megg,
   {{0xa2b28063,0xf1a497a3,0x6b8b92af,0x6b960214}},	//   _आपत्, _गोपन, legg, _sayg,
   {{0x62843625,0x7bcd0d35,0x63bb8247,0x61e3d0b3}},	//   _spio, _blau, _koun, minl,
   {{0xe72ed0b4,0xf77083f8,0x7dc000f2,0x63bb8247}},	//   _је_, _ماه_, _höst, _joun,
   {{0xe56ed0b5,0x63a98db7,0x27388028,0x27ff8247}},	//   _из_, _mnen, _ứng_, moun_,
   {{0x443cd0b6,0x7bcd03ac,0x6b8b8081,0x27ed81ec}},	//   _ftv_, _elau, hegg, lnen_,
   {{0x27edc20c,0x957c809a,0x63a9c717,0xb5fd8699}},	//   onen_, siąc, _onen, hušk,
   {{0x6d4e045c,0x27edd0b7,0x63bba4df,0x7bcd4c33}},	//   _seba, nnen_, _noun, _glau,
   {{0x27edb416,0x22160171,0x61e383bf,0xe7df001b}},	// [4280] inen_, _офор, kinl, _नगरप,
   {{0x3f4c0028,0xb5fdad9b,0x27ed82af,0x7e6450b8}},	//   ếu_, dušk, hnen_, rrip,
   {{0x61e3d0b9,0x6441d0ba,0x6d5c81a8,0xeb9aa328}},	//   dinl, npli, órai, жие_,
   {{0x63bb8051,0x27ed8a0f,0xfe79800d,0xab838009}},	//   _coun, jnen_, ktů_, вушк,
   {{0x6d4e02ec,0xddcd01dd,0x27ff8176,0x63a980c3}},	//   _teba, staš, doun_, _dnen,
   {{0x27edd0bb,0x61e3807b,0xc0aa830f,0x7c2e50bc}},	//   enen_, ginl, قابل_, _tubr,
   {{0xdcfc0029,0x63bbd0bd,0xd7a9816f,0xf1b884b7}},	//   _varē, _foun, कांच, _jiġi_,
   {{0xb5fd8067,0x442e9705,0x27ed8e3b,0x443ca76e}},	//   vrša, _ruf_, gnen_, _rtv_,
   {{0x2d9850be,0x7dc0007b,0xf1b884b7,0x442ea948}},	//   _kare_, _föst, _liġi_, _suf_,
   {{0x7dc00459,0xaa43802e,0x89169e91,0x2d9850bf}},	//   _göst, _рефл, _قبائ, _jare_,
   {{0x9cec0a49,0x7bcd50c0,0x2d9844ce,0x61fd87ca}},	//   _করুন_, _plau, _mare_, _ísla,
   {{0x2d9850c1,0x443c80ff,0xaec696cf,0x626f09ab}},	//   _lare_, _vtv_, _обел, lɗoɗ,
   {{0x501b80be,0x2d980087,0x83fd0904,0xdcf500eb}},	//   _וואו, _oare_, nuđi, _pazī,
   {{0x7c668f24,0x7bcd00dd,0xc9841505,0x6b8b81ed}},	//   _قابل, _wlau, куси, zegg,
   {{0x2d8cd0c2,0x6e2701ed,0x69c7021e,0x26c48084}},	//   mede_, _rijb, rkje, lymo_,
   {{0x2d8cd0c3,0x2d9850c4,0x69c7035f,0x0cca801b}},	//   lede_, _aare_, skje, ानीम,
   {{0xd904803d,0x63a980dd,0x2d9817af,0x7dcd808b}},	// [4290] _چی_, _rnen, _bare_, _húsa,
   {{0x44290282,0x2d8cd0c5,0xaa88003d,0x2d980039}},	//   _hia_, nede_, _کنیم_, _care_,
   {{0x7dc000f2,0x442950c6,0x6d450083,0x5f05800d}},	//   _röst, _kia_, rbha, _हुन्_,
   {{0xe6670698,0x2d8c9fcd,0x26c48110,0xb5fd877b}},	//   _отго, hede_, kymo_, tušk,
   {{0x442950c7,0xa2af816f,0x6b8bd0c8,0x2d980ca9}},	//   _mia_, ंमध्, regg, _fare_,
   {{0x442950c9,0x2d9850ca,0x2d8c85f3,0x4095997b}},	//   _lia_, _gare_, jede_, ерит,
   {{0x63bb8247,0x442950cb,0x3f9950cc,0x2d8cd0cd}},	//   _toun, _oia_, _kasu_, dede_,
   {{0x6441aa30,0x442950ce,0x27edd0cf,0xb4bd0c87}},	//   vpli, _nia_, unen_, ेनी_,
   {{0x3f990a73,0x2ec98e70,0x27edc255,0x27ffd0d0}},	//   _masu_, िनेत, rnen_, roun_,
   {{0x7c298e61,0xe93884c0,0xe6168d15,0x2d8cd0d1}},	//   _hier, _قسمت_, нды_, gede_,
   {{0x442950d2,0x7c29d0d3,0xfe79801b,0xf3e6117f}},	//   _bia_, _kier, stů_, ежно,
   {{0x442950d4,0x6441890d,0x3f9950d5,0xeb9a0a7c}},	//   _cia_, rpli, _nasu_, чим_,
   {{0x442939fd,0x443110dd,0x2d8cd0d6,0x6441809e}},	//   _dia_, _luz_, bede_, spli,
   {{0xf2d2893f,0x2d8c8511,0x3e798247,0x395e00e7}},	//   נעם_, cede_, mèt_, ûts_,
   {{0xf505835f,0x3f9904b9,0xb5fd80eb,0x3e7983ec}},	//   _язко, _basu_, juši, lèt_,
   {{0x44290104,0x2d9850d7,0x7c29d0d8,0x35c58105}},	//   _gia_, _sare_, _nier, _लकड़,
   {{0x9cec00c8,0x7dd2013c,0x3e798247,0x6b8450d9}},	// [42a0] _করেন_, _læse, nèt_, _ibig,
   {{0x442950da,0x22401600,0xf1b884b7,0x2b5f8087}},	//   _zia_, _itik_, _tiġi_, _aduc_,
   {{0x2d980370,0x224d83ac,0x3a3f8122,0x7c29d0db}},	//   _vare_, _awek_, _atup_, _bier,
   {{0x7c29d0dc,0xe9f90104,0x2d9850dd,0x7e7bd0de}},	//   _cier, _trả_, _ware_, ktup,
   {{0x2d9850df,0xb5fd803a,0xa2948d13,0x7c29acf1}},	//   _tare_, vršn, талі, _dier,
   {{0x98a58182,0xcb1300be,0x3f9904b9,0x764450e0}},	//   _adlı_, אלד_, _zasu_, mpiy,
   {{0x3ea032da,0x83fd011f,0x3f9900fc,0x7c298888}},	//   lvit_, suđi, _yasu_, _fier,
   {{0xdfd08013,0x26c48110,0xdb0083a8,0x2d8c820d}},	//   شيخ_, tymo_, _enmá, wede_,
   {{0xe1ff0feb,0xc6f8835f,0x66018370,0x2d8c8808}},	//   drón_, ьних_, folk, tede_,
   {{0x442950e1,0x998902a5,0x6b841714,0xa3e33ffa}},	//   _sia_, _staž_, _abig, फोन_,
   {{0xd7ef9ad0,0x442900f6,0x2d8cd0e2,0x22400247}},	//   _бу_, _pia_, rede_, _atik_,
   {{0x444450e3,0x87da8b76,0x2d8cd0e4,0x07da845b}},	//   ip_, _عباس_, sede_, _عذاب_,
   {{0x660182a3,0x51871507,0x3f992bb1,0x2d8cd0e5}},	//   bolk, нува, _rasu_, pede_,
   {{0x6aa413c2,0x80b503b6,0x6b842396,0x7dcd807b}},	//   _drif, _उपदे, _ebig, _húsn,
   {{0x224050e6,0x3f9950e7,0x44444c84,0x442950e8}},	//   _etik_, _pasu_, jp_, _tia_,
   {{0x645ad0e9,0x5f9410f8,0x442950ea,0x2614816f}},	//   msti, лист, _uia_, _नीती_,
   {{0xb9081404,0x645c2db2,0x645ad0eb,0x63ad3c15}},	// [42b0] _मे_, _avri, lsti, _inan,
   {{0x3f9903c3,0x7c29d0ec,0xf41f0009,0x799a8314}},	//   _wasu_, _sier, lmä_, _natw,
   {{0x7c299ff1,0xf1b884b7,0x3a3f942f,0x7e6d00dd}},	//   _pier, _jiġu_, _stup_, suap,
   {{0xeaec8b9f,0x6b9d50a3,0x7c298216,0xf8b61101}},	//   जपूत_, ndsg, _qier, _ספרי_,
   {{0x7c2986ee,0x2bb88013,0xa30f0327,0x645a8229}},	//   _vier, عامة_, _सरोज_, hsti,
   {{0xc0e58381,0x7c29d0ed,0xf41f0198,0x443150ee}},	//   колк, _wier, hmä_, _tuz_,
   {{0x7c29d0ef,0x6601837a,0x645ad0f0,0x83fd0669}},	//   _tier, volk, jsti, luđu,
   {{0x644550f1,0xdb238077,0x645a9277,0xf41f01ac}},	//   mphi, _موزی, dsti, jmä_,
   {{0x799a8d92,0x645ad0f2,0x603180eb,0x3f8d8a53}},	//   _fatw, esti, _māmi, reeu_,
   {{0x63ad0077,0x3e798247,0x7e7bd0f3,0x6b9b80e8}},	//   _anan, rèt_, rtup, _haug,
   {{0x6b9bbefe,0xe1ff0511,0xcb6a0a42,0x22401791}},	//   _kaug, trón_, мане_, _stik_,
   {{0x6aa4475d,0xa3dc009a,0x798e50f4,0x957c8035}},	//   _prif, णों_, webw, wnąt,
   {{0xe1ff2fb5,0x6ec492c8,0x3cf511be,0xdb1b9a1f}},	//   rrón_, _متوق, ्थडे_, _boué,
   {{0xf505838d,0x63ad41e6,0x200db27d,0x27e20101}},	//   _изло, _enan, llei_, _smkn_,
   {{0x1c11800f,0x444450f5,0xdd921190,0x6e2d8037}},	//   ़ताल_, xp_, یور_, _èabb,
   {{0xa2b2853e,0x3ea0826c,0x6fde81a9,0x63ad0af8}},	//   _आपल्, _šiti_, tūci, _gnan,
   {{0x78a5013c,0x444400ee,0x35a68d86,0xd00702a4}},	// [42c0] _erhv, wp_, _कोड़, тете_,
   {{0x64a616be,0xdca61697,0x08c650f6,0x69d5460f}},	//   каза, кази, _абон, chze,
   {{0x44443693,0x6b9bd0f7,0x9f4001a8,0x200dd0f8}},	//   up_, _baug, iniú_, klei_,
   {{0x3958009f,0xfdbd0540,0x799a81bf,0x9f4000f7}},	//   lars_, ोसॉफ, _satw, hniú_,
   {{0xdaba8077,0xe1ff0019,0x6b9ba612,0x799a83ec}},	//   بهشت_, król_, _daug, _patw,
   {{0x39584a23,0x4444088b,0x645ad0f9,0x7e69d0fa}},	//   nars_, pp_, ysti, drep,
   {{0x645c02ce,0x55e31bdc,0x38c88180,0x7d030192}},	//   _uvri, _торб, عاتی_, ünst,
   {{0x28ba170c,0x2ca70366,0x27f250fb,0x6fe7810c}},	//   _उपनि, ænde_, nnyn_, _rècè,
   {{0x7e69998b,0xb2268110,0x4b7b80be,0x645ad0fc}},	//   grep, _амал, _קאמו, wsti,
   {{0x2246d0fd,0x645a9be9,0x20e3816f,0x7bc085b0}},	//   mpok_, tsti, _केवळ_, _homu,
   {{0x5fa38076,0x81c900c8,0x1da6835a,0xc8ca803d}},	//   _खोवल, লোড_, _कोणत, _توان_,
   {{0xf74690ca,0x39530a76,0x7bc0bfae,0x68fa8609}},	//   _редо, _sexs_, _jomu, _ixtd,
   {{0x200484b9,0x6b8f026c,0x7dc48362,0xe737c19a}},	//   momi_, recg, _bòst, _реч_,
   {{0x395803ab,0x3cfd86a7,0x63ad5025,0x2004b5aa}},	//   gars_, _रुके_, _wnan, lomi_,
   {{0xf807257e,0xd90f003d,0x98c40198,0xcf9b0073}},	//   вчан, تید_, астл, мја_,
   {{0x2d9cd0fe,0x63ad02b8,0x2004d0ff,0x2618058c}},	//   _have_, _unan, nomi_, _बीबी_,
   {{0xa3b685e8,0x2d9ca7b1,0x6d575100,0xb4bd01a2}},	// [42d0] जान_, _kave_, taxa, ेन्_,
   {{0xab5d8063,0x6b9b81e2,0x2d9ea382,0x7c2d5101}},	//   _może, _saug, ndte_, _hiar,
   {{0x7c2d004f,0x65945102,0x6d570be9,0x6b9bae8f}},	//   _kiar, раху, raxa, _paug,
   {{0x80dc00c8,0x2d9cd103,0xdb040317,0x7c2d0704}},	//   _মুক্, _lave_, _uniã, _jiar,
   {{0x7bc0d104,0x20048612,0x7c2d5105,0x290c807e}},	//   _domu, domi_, _miar, _ayda_,
   {{0x3f86d106,0x2d9cd107,0x27e93437,0x6b9bd108}},	//   _abou_, _nave_, lian_, _waug,
   {{0xe739b1a5,0xdb0084b8,0x7642d109,0x7c2d011b}},	//   ней_, _anmä, _atoy, _oiar,
   {{0x7e69d10a,0xccf20bea,0x7c3a02be,0xdb0081ac}},	//   trep, _הכל_, _étra, _pomô,
   {{0x5a348b88,0x200d9781,0x6d5507d5,0x51f982c7}},	//   _внут, rlei_, _keza, _знаю_,
   {{0x442dd10b,0xef168196,0xb5fb026f,0x27e91ad1}},	//   _hie_, ымы_, _uvád, hian_,
   {{0x27e92fb8,0x290c8355,0x6d55510c,0x7c2d07d5}},	//   kian_, _gyda_, _meza, _biar,
   {{0x27e90812,0x442d81e2,0x7c2d467c,0x61e5510d}},	//   jian_, _jie_, _ciar, _amhl,
   {{0x27e9510e,0x442d8b87,0x6fd58511,0x660500dd}},	//   dian_, _mie_, _cáce, kohk,
   {{0x6d551ee0,0x61e50706,0x2d9cd10f,0x69c19473}},	//   _neza, _cmhl, _gave_, _jole,
   {{0x69c1c6b2,0x27e95110,0xa3b6800f,0x660509ca}},	//   _mole, fian_, जाम_, dohk,
   {{0x442d9019,0xb8dc0d38,0x27e92fb8,0x7c2d0098}},	//   _nie_, _आप_, gian_, _giar,
   {{0x6d552deb,0xe61a05f1,0xa3d7a342,0x7bc0971c}},	// [42e0] _beza, еда_, िसन_, _romu,
   {{0xb5fd8025,0x7c2d5111,0x2bcc150e,0x6d555112}},	//   dršk, _ziar, ासका, _ceza,
   {{0x6d555113,0x27e912bf,0xdd5680be,0x2004923c}},	//   _deza, bian_, רבעט_, yomi_,
   {{0x9f060277,0x2d9c0301,0x7c3ed114,0x2ca78dc5}},	//   _موجو, žve_, _épre, _mrnd_,
   {{0x442d96a1,0x69c1d115,0x1603d116,0x6fca0038}},	//   _die_, _bole, रकार_, _rých,
   {{0x442d879f,0x6d555117,0x69ce1080,0x38a382d0}},	//   _eie_, _geza, nkbe, _bır_,
   {{0x69c1d118,0x442d8012,0x7bc0d119,0x799e0122}},	//   _dole, _fie_, _tomu, _mapw,
   {{0x09d111be,0xaa86003e,0x442dd11a,0x2d9cd11b}},	//   _हत्य, _zvýš, _gie_, _save_,
   {{0x6fca003e,0x7c2d0cb5,0x6e2e41cb,0x7c229a21}},	//   _vých, _riar, _kibb, mmor,
   {{0x69c1d11c,0x442dd11d,0x7c2d511e,0x2004b0a0}},	//   _gole, _zie_, _siar, somi_,
   {{0x6fca01ac,0x442d81bc,0x645e511f,0x2db70e82}},	//   _tých, _yie_, nspi, אלין_,
   {{0x6e2e5120,0x69c1d121,0xdce383bf,0xdb1b8118}},	//   _libb, _zole, _canı, _gluó,
   {{0x7c2d1e72,0x644386a4,0xdce39014,0x27e6d122}},	//   _viar, _etni, _danı, _imon_,
   {{0x69d88125,0xa3ab998e,0x27e95123,0x869b8039}},	//   nhve, _कोन_, wian_, _ניוז,
   {{0x69cc823c,0x248d003a,0x7c2d5124,0xdcfc00eb}},	//   _तकनी, _ćemo_, _tiar, _darī,
   {{0x645e5125,0x69ce1c11,0x69c007b6,0x00000000}},	//   dspi, akbe, êmer, --,
   {{0x27e92fb8,0x5d550fbe,0xb5fd803a,0x442d8133}},	// [42f0] rian_, икат, pušt, _rie_,
   {{0x442dd126,0x6d5ad127,0x27e934c6,0x3eb98009}},	//   _sie_, nata, sian_, ästi_,
   {{0xdce382bb,0x27e95128,0xa115003d,0x628e011f}},	//   _yanı, pian_, _خودت, čnoš,
   {{0x6d5ad129,0xd4980071,0x69c1d12a,0xdce38085}},	//   hata, ыру_, _sole, _xanı,
   {{0xe299b1db,0x6d5ab18b,0x69c1d12b,0x442dd12c}},	//   тал_, kata, _pole, _vie_,
   {{0x442d8df3,0x27e6d12d,0x6e2e1106,0x7c22d12e}},	//   _wie_, _amon_, _gibb, amor,
   {{0x442d95cb,0x69c1d12f,0x7d1c807b,0x7e6d03a6}},	//   _tie_, _vole, ýrsl, lrap,
   {{0x2d931139,0x166585c2,0x28b68f0f,0x225f8115}},	//   lexe_, авим, _अपरि, _tvuk_,
   {{0x6d5ab9b5,0x7e6d003d,0x78a88084,0x644f817f}},	//   fata, nrap, _erdv, ćcim,
   {{0x0d829a8f,0xdce38214,0x2d931eed,0x629b80e4}},	//   ольн, _sanı, nexe_, _isuo,
   {{0x6fd58118,0x7e6d4f7a,0x67d59ef3,0x6b9f022b}},	//   _cácc, hrap, _кожу, _baqg,
   {{0x6aa9d130,0xcc760039,0x6d5a82d5,0x7dcdd131}},	//   _kref, סגרת_, aata, _kúsk,
   {{0x6d5a8a98,0x6b89d132,0x7bdd0168,0xe72ea276}},	//   bata, _mbeg, ërua, _фе_,
   {{0x6d5a9afe,0x64a58425,0x6aa98010,0xb5fd95db}},	//   cata, _вака, _mref, krši,
   {{0xdce38459,0x7c22d133,0x90c31229,0x69ce1c11}},	//   _tanı, ymor, обре, rkbe,
   {{0x3ead00d2,0x32079c51,0x6ed5850a,0x6aa981e8}},	//   _šeta_, hony_, मैथु, _oref,
   {{0x1b0d00c8,0x2b4d04c3,0x7e6d3131,0x32078658}},	// [4300] সেবে_, ñece_, grap, kony_,
   {{0x83fd005c,0x2d859f1b,0x998c81a9,0x6b898deb}},	//   vrđi, nfle_, _vidū_, _abeg,
   {{0x6aa99286,0xd838812b,0x3ea98b80,0xc1010129}},	//   _aref, _trči_, _šatl_, _mượt_,
   {{0x6d5ace1d,0xc1010028,0x9f91877f,0x5aca8071}},	//   zata, _lượt_, _náà_, клем_,
   {{0x32078023,0x7e6d1c33,0x6e2e327e,0x645e5134}},	//   fony_, crap, _tibb, sspi,
   {{0x20ba29b7,0x6aa98114,0xceb30039,0x64a6373a}},	//   _उपाध, _dref, _ויש_, _кага,
   {{0xa3c60b3b,0x6d5ad135,0x02b4000d,0x61ead136}},	//   _एवं_, vata, ुहुन, rifl,
   {{0x6d5ab155,0x61ea9286,0xbfa78198,0x7bd981ec}},	//   wata, sifl, атье_, chwu,
   {{0x6d5ad137,0x44381918,0x3207d138,0xe2979908}},	//   tata, _hur_, bony_, _кат_,
   {{0x44385139,0x63a08687,0x61ed80f7,0x62828a53}},	//   _kur_, _hamn, éalt, mtoo,
   {{0xd49782ff,0x6d5a81bf,0x63a0d13a,0x6282929d}},	//   аря_, rata, _kamn, ltoo,
   {{0x4438513b,0x6d5ad13c,0xc7c78198,0x63a0821e}},	//   _mur_, sata, _выше_, _jamn,
   {{0x6d5a80e4,0x44381fdc,0x63a081b4,0x3a741af1}},	//   pata, _lur_, _mamn, оляр,
   {{0xa2a78c78,0x4438004c,0x6d5ad13d,0x7e6d047f}},	//   चित्, _our_, qata, vrap,
   {{0x4438034a,0x19581c0e,0x6d5880eb,0x2904007e}},	//   _nur_, расы_, _ieva, şman_,
   {{0x7e6d513e,0x63a28019,0x63a0d13f,0x25e29370}},	//   trap, jdon, _namn, टोरी_,
   {{0x44380b65,0x51870791,0xba3d801b,0x6d588074}},	// [4310] _aur_, _куна, _prům, _keva,
   {{0x7e6d5140,0x27058028,0x63a2847f,0x3207d141}},	//   rrap, ồng_, edon, xony_,
   {{0x4438003c,0xd49b0098,0x3207826b,0x7e6d22dc}},	//   _cur_, ъра_, vony_, srap,
   {{0x6d58af68,0x2d930373,0x5b2580f7,0x63a083ac}},	//   _leva, sexe_, مفضل, _camn,
   {{0x7cca8201,0xa3ab835a,0x69c55142,0x660883ac}},	//   lərd, _कोण_, _kohe, kodk,
   {{0xceb20159,0x7c38adb2,0x79951c40,0x81c900ab}},	//   _זיך_, _ouvr, nezw, লোর_,
   {{0x4438061f,0x32078063,0xf09400be,0x6fca016b}},	//   _gur_, rony_, ַנץ_, _výcv,
   {{0x6aa9d143,0x62828cd8,0xddcd0805,0x63a2c5e3}},	//   _tref, btoo, ntaž, cdon,
   {{0x4438034a,0x799520b3,0x7dcd807b,0x06098abe}},	//   _zur_, kezw, _húsi, лник_,
   {{0x58878a7f,0x6d5887d9,0x66088353,0x69c52bd7}},	//   _выда, _ceva, godk, _nohe,
   {{0x6d58d144,0xc3290451,0xc101001c,0x63a0d145}},	//   _deva, _נו_, _vượt_, _yamn,
   {{0xe9f90028,0x69d703a8,0xeb9f1277,0xd83882d6}},	//   _trẻ_, _alxe, dløs_, _prčv_,
   {{0xed4e91c7,0x69c55146,0x27edabc5,0x87078198}},	//   _но_, _bohe, mien_, _тяже,
   {{0x6d58a40d,0x69c507f1,0xd5b18872,0xed599c79}},	//   _geva, _cohe, _رفع_, _сок_,
   {{0x7dd2013c,0x3f6a1950,0x27ed81ed,0x87db86a7}},	//   _sæso, ливо_, oien_, _बताऊ,
   {{0x6ab78996,0xafe305d3,0x44385147,0xd83880fe}},	//   _आपूर, посл, _rur_, _grču_,
   {{0x44381c8d,0x4420082e,0xef1a0a9f,0x75468019}},	// [4320] _sur_, _ihi_, ума_, _érzé,
   {{0x27edd148,0x63a0a055,0x7cca8085,0x62828069}},	//   hien_, _samn, bərd, vtoo,
   {{0x44200142,0x7dc00065,0xb8ed00c8,0x27edd149}},	//   _khi_, _kösz, _শে_, kien_,
   {{0x27ed8009,0x61ee011c,0x320a0a7a,0x6608b55a}},	//   jien_, libl, loby_, zodk,
   {{0x27eda187,0x63a28bf9,0x63a0822c,0xdcfc0bcf}},	//   dien_, rdon, _vamn, _obrć,
   {{0x4438514a,0x61ee10cd,0x63a2d14b,0x27ed80f3}},	//   _tur_, nibl, sdon, eien_,
   {{0x44381aee,0x6d58a1bf,0x6d5e514c,0x62828ebc}},	//   _uur_, _reva, mapa, stoo,
   {{0x6d5e5005,0x27edb665,0x4420001c,0x44321bb5}},	//   lapa, gien_, _nhi_, _niy_,
   {{0x52b403bb,0x6d588eef,0x7c38b6c5,0x7cca8085}},	//   ुहोस, _peva, _suvr, zərd,
   {{0x6d5e514d,0x4420514e,0x61ee514f,0x27ed80f3}},	//   napa, _ahi_, jibl, aien_,
   {{0xab5d8063,0x183683f8,0x27edd150,0x320a0e04}},	//   _możn, _طراح, bien_, doby_,
   {{0x44205151,0x27ed90cd,0x6d5e1c01,0x4426d152}},	//   _chi_, cien_, hapa, nmo_,
   {{0x6d5e049f,0x44322543,0x6d58d153,0x44205154}},	//   kapa, _diy_, _teva, _dhi_,
   {{0x6abb00c8,0x61ee5155,0x44200133,0x69dc0739}},	//   উনলো, gibl, _ehi_, ghre,
   {{0x58d429c9,0x84468277,0x6d5e0867,0x2fc69d14}},	//   порт, _اختل, dapa, _koog_,
   {{0x44200028,0x4426935a,0x36d50ada,0x2fc681b4}},	//   _ghi_, jmo_, ообр, _joog_,
   {{0xddcd1329,0x2fc6d156,0x69dc0c41,0xa3ce016f}},	// [4330] rtaž, _moog_, bhre, _शकत_,
   {{0x69dc5157,0x6d5e0461,0x27edaffc,0x7175003d}},	//   chre, gapa, zien_, _بهدا,
   {{0x2bdd86bf,0x23690353,0x9f350558,0x6d9e84b7}},	//   _मतदा, _kdaj_, _мені, _għaż,
   {{0xedb5901c,0x6d4186a5,0x649e84a8,0x2fc68069}},	//   _अच्छ, zcla, mšić, _noog_,
   {{0x6b8d5158,0x27edd159,0x6d5e217b,0x7e7900be}},	//   _mbag, vien_, bapa, _דאָז,
   {{0x4426d15a,0x764d515b,0x7f5f3e5a,0x4a5c0e82}},	//   amo_, mpay, laqq, נדוו,
   {{0x27edb52f,0x64ac9487,0xdb0d01df,0x3ea9515c}},	//   tien_, nđić, _moañ, lvat_,
   {{0x2369020f,0x2249059c,0x7a20016d,0x5fa38d86}},	//   _ndaj_, _otak_, möte, _खोखल,
   {{0x27edd15d,0xa3b69c4f,0xee3684d9,0x2fc68952}},	//   rien_, जार_, оны_, _doog_,
   {{0x44200a73,0x27edd15e,0x27080028,0x6b8d1ea2}},	//   _shi_, sien_, ởng_, _abag,
   {{0x22494fb6,0x6d41d15f,0x44200028,0x27edd160}},	//   _atak_, rcla, _phi_, pien_,
   {{0xab2a102f,0x442001c0,0x232a10ca,0x6a8601e5}},	//   иона_, _qhi_, иони_, олма,
   {{0x69dc36b1,0xadfb08fd,0x6d5e3e75,0xfdfb073c}},	//   thre, ्वान_, yapa, ्वास_,
   {{0x6aad5133,0xb21b013c,0x7a202203,0x44268110}},	//   _draf, stæn, köte, zmo_,
   {{0x44200104,0x4426d161,0x320a5162,0x75e90201}},	//   _thi_, ymo_, roby_, _gözə,
   {{0xe7370364,0x6d5e23c9,0x6b8d19a8,0x442001e4}},	//   жет_, wapa, _gbag, _uhi_,
   {{0x6e46015b,0x63a45163,0x61ee06c0,0xe29a1073}},	// [4340] زنام, _iain, pibl, _тап_,
   {{0x63a45164,0x23690353,0x05660110,0x604301bc}},	//   _hain, _zdaj_, івен, ọmat,
   {{0x63a45165,0x6d5e5166,0x3ea90009,0xa3b68f97}},	//   _kain, rapa, avat_, जाल_,
   {{0xddcd0087,0x63a41ffc,0xead2846d,0x2d855167}},	//   tuaţ, _jain, _fẹ́_, _ölen_,
   {{0x6d5e5168,0x63a45169,0x1a968875,0x62862d09}},	//   papa, _main, تجاج, ntko,
   {{0x442699c5,0xfce60847,0x63a4516a,0x7d068063}},	//   smo_, _дого, _lain, ększ,
   {{0x6d5c0029,0xa37b0073,0xfd078065,0xd4670009}},	//   _iera, lhõe, _آج_, _мире_,
   {{0x6d5c1705,0xef19809a,0xb4d6073c,0x6286119b}},	//   _hera, leży_, िनी_, ktko,
   {{0x6d5c16a7,0x7e64516b,0xab5d8063,0x6fdc82be}},	//   _kera, nsip, _możl, _néce,
   {{0x7c3c1c26,0x6b8d0081,0x06cd00ab,0x5c748cec}},	//   _kurr, _sbag, _রেডি, плот,
   {{0x63a4516c,0x6d5c1599,0x29188ede,0x77668098}},	//   _bain, _mera, _ára_, _дълж,
   {{0x63a40ad7,0x7bc283d3,0x6d5c1c11,0x69c880e8}},	//   _cain, njou, _lera, _hode,
   {{0x63a4516d,0x7c3c011e,0x6fe8809a,0x6448516e}},	//   _dain, _lurr, jści, _édif,
   {{0x6fdc82be,0xaca401bc,0x69c8d16f,0xdb0080e7}},	//   _déce, _atọr, _jode, _camé,
   {{0xe50286b7,0xdb00810c,0x62865170,0x68e20326}},	//   _रुचि_, _damé, atko, _ƙoda,
   {{0x6d5c5171,0x6b8d5172,0x6fd80333,0x63a42816}},	//   _aera, _ubag, _píca, _gain,
   {{0x6d5c2b15,0x7c3c00ad,0x224944a4,0x443c81c5}},	// [4350] _bera, _aurr, _utak_, _huv_,
   {{0x63a45173,0x443c946a,0x7c3c5174,0x69c8d175}},	//   _zain, _kuv_, _burr, _node,
   {{0x6d5c088b,0x7c3c0051,0xd37180f7,0xa3b68a27}},	//   _dera, _curr, فها_, जां_,
   {{0xa3ab8063,0x69daaa70,0x7c3c00f1,0x7f5f0609}},	//   _कोश_, _alte, _durr, qaqq,
   {{0x443c9393,0x69c8d176,0x7d7712c8,0x29f68035}},	//   _luv_, _bode, _واسط, kład_,
   {{0xe570026a,0xfa780039,0xdb1b8187,0x1a9c00be}},	//   _لطف_, קעות_, _louç, יידע,
   {{0x69c8d177,0x443c8282,0xdd1c80e1,0x9878011f}},	//   _dode, _nuv_, yšši, ršće_,
   {{0x62860d38,0x6d4501e4,0x61c805fb,0x69dad178}},	//   ytko, lcha, _रक्ष, _elte,
   {{0x69c8d179,0x443c822c,0x7f5d517a,0x6d451e3f}},	//   _fode, _auv_, _mesq, ocha,
   {{0x6d5c35d7,0x6d45517b,0x6fdc82be,0x69c8d17c}},	//   _xera, ncha, _réce, _gode,
   {{0xcb09073a,0xb21b013c,0x2b408bc8,0x63a4517d}},	//   _על_, rtæl, žice_, _pain,
   {{0x29040214,0x6d45340d,0xe29a1986,0x22841eca}},	//   şmak_, hcha, бам_, tök_,
   {{0x98a78182,0x63a4517e,0xeb970750,0x7dd302d0}},	//   manı_, _vain, чия_, _kısı,
   {{0x7dcd8118,0x63a4517f,0x6e35011f,0x7dd2005f}},	//   _cúst, _wain, _nizb, _væsk,
   {{0x22841836,0x63a45180,0x6e3d02af,0x7dd30214}},	//   sök_, _tain, _ausb, _mısı,
   {{0x6d5c04bf,0x63a40c41,0x7e6412a5,0xfbdf0187}},	//   _sera, _uain, tsip, chê_,
   {{0x6d5c059c,0xdb00c92f,0x69cc8105,0x7c242bd7}},	// [4360] _pera, _tamé, _तकली, _ihir,
   {{0x443c822c,0x7dcdb1bd,0x06c580ab,0x80ae80d4}},	//   _yuv_, _gúst, এনপি, ंटमे,
   {{0xc9530451,0x6d5c2fbc,0x31570158,0x7e645181}},	//   _אמת_, _vera, _מיין_, ssip,
   {{0xa3e68d38,0x6d450c64,0x69c88db7,0x7bc982be}},	//   यों_, acha, _sode, _coeu,
   {{0x6d4501c5,0x7bc28009,0x27e05182,0x6fd581d0}},	//   bcha, rjou, mhin_, _václ,
   {{0x27e01066,0x7c3c4f32,0xfd5901bc,0x7c2402c4}},	//   lhin_, _turr, _mgbụ, _lhir,
   {{0x6561d183,0x764b9ad5,0x7c240286,0x5fe001a2}},	//   dalh, _atgy, _ohir, _नताल,
   {{0xdfd08013,0x27e05184,0x79988247,0x2d9a5185}},	//   ئية_, nhin_, sevw, lepe_,
   {{0x69c88364,0x27e00364,0x442482af,0xa3e6d186}},	//   _tode, ihin_, _ihm_, योः_,
   {{0x7c242f13,0x69dad187,0x27ff2944,0x443c8069}},	//   _ahir, _ulte, čuni_, _puv_,
   {{0x395ea40d,0x443c810c,0xfd590135,0x3d0681ab}},	//   _iets_, _quv_, _agbụ, _सुखे_,
   {{0x395e8186,0x7dcdd188,0xdddb941f,0xddc98162}},	//   _hets_, _súst, rtuš, treţ,
   {{0x6561d189,0x6d45518a,0x7c241a79,0x27e0387b}},	//   balh, ycha, _dhir, dhin_,
   {{0x2d9a518b,0xa410001b,0x656199ae,0x398f861c}},	//   jepe_, ětší_, calh, cısı_,
   {{0x7f5d518c,0x69d501ec,0x395ed18d,0x27e001ec}},	//   _pesq, rkze, _mets_, fhin_,
   {{0x2d8c90f4,0x34fb8039,0x7c243648,0x27e00acd}},	//   lfde_, _להוד, _ghir, ghin_,
   {{0x6d451a21,0x9f40007b,0xa3b682f1,0x69c38035}},	// [4370] tcha, rnið_, जाई_, yjne,
   {{0x6d45518e,0x06140009,0xf1d1000d,0x4424b4b1}},	//   ucha, едую, _सकिन, _ahm_,
   {{0xf8d1000f,0xd9180e02,0x6d4532e6,0x244180ff}},	//   _हथिय, _нью_, rcha, _xóm_,
   {{0x27e006c0,0x6d450367,0xf1b88609,0x7a200106}},	//   chin_, scha, _anġ_, möta,
   {{0x398f8214,0x59d10ebf,0xe8108a0d,0x6e3d518f}},	//   yısı_, _सकार, ावना_, _uusb,
   {{0x644a11b9,0x2d9a002e,0xe7d51bef,0x2d8c81ed}},	//   ífic, cepe_, _yığı, jfde_,
   {{0x395ed190,0x656183cd,0xf8928073,0x6e2d8037}},	//   _dets_, valh, вајќ, _èabi,
   {{0x656187fe,0x2a669fdb,0x2d8c9384,0x7ddf841c}},	//   walh, bsob_, efde_, _mêse,
   {{0xc91a3ed8,0x656180a9,0x395e8722,0x236d807a}},	//   _धर्म_, talh, _fets_, _idej_,
   {{0x7dcdd191,0x7c245192,0xddc98267,0x27e00168}},	//   _rúss, _shir, freš, zhin_,
   {{0x31630d11,0x6561d193,0x398f807e,0x601e8168}},	//   dajz_, ralh, rısı_, sëma,
   {{0x6fd815a0,0x656187f0,0x3078866e,0x2d8c9407}},	//   _cícl, salh, _رحمة_, afde_,
   {{0xe60e8a8e,0xbdf88065,0x656183a7,0x06cd00ab}},	//   _ад_, _کرنا_, palh, _রেসি,
   {{0x75e00065,0xc58e8028,0x2441c92b,0x2fdd8197}},	//   _köze, _hồng_, _tóm_, _hlwg_,
   {{0x27e033fe,0x7c2433fe,0x2fcb07f1,0x236d8af8}},	//   thin_, _thir, _bocg_, _odej_,
   {{0x6fdc88f9,0x442b5194,0x6144846d,0x26c002f9}},	//   _kéca, cmc_, _kìló, txio_,
   {{0xb4d6001b,0x442488ae,0x27e05195,0x2fcb00e5}},	// [4380] िन्_, _rhm_, rhin_, _docg_,
   {{0x27e05196,0x270c8104,0x44248b99,0x7bc602a5}},	//   shin_, ớng_, _shm_, ljku,
   {{0xe73a0698,0x2d9a3d9b,0x4424d197,0x799c5198}},	//   _мен_, repe_, _phm_, merw,
   {{0xd36f8013,0x799c5199,0x2d9a519a,0xc58e80ff}},	//   لهم_, lerw, sepe_, _nồng_,
   {{0xa3e30fd5,0xdb040118,0xaaa7001b,0xdb008176}},	//   फोट_, _baié, खिएक, _anmò,
   {{0x799c1111,0xc3330039,0x9f468192,0x6aa40c93}},	//   nerw, דוד_, _bloß_, _msif,
   {{0x6b840253,0x3ea01384,0xc58e8129,0x22405033}},	//   _ocig, lwit_, _bồng_, _luik_,
   {{0x6bda803d,0x466a823f,0x3eadb644,0x7764023e}},	//   _بورس_, ором_, fvet_, naix,
   {{0xcebb8201,0x799c2eae,0xe2469a37,0x96349bc1}},	//   _şərh_, kerw, _آخري, нниц,
   {{0x7dcd80c8,0xc6f784d9,0xb21b0125,0x6b840118}},	//   _búsq, ьных_, rtæk, _acig,
   {{0xdb0088f1,0x05770039,0x75e0519b,0x2b490118}},	//   _mamí, וגים_, _közb, _pfac_,
   {{0x69de306a,0x22401699,0x9f9c026b,0x444401b4}},	//   _alpe, _buik_, _bíí_, iq_,
   {{0xf7d7810f,0x5187395b,0xfd6500ff,0x753c0035}},	//   _קודש_, мува, _chuỗ, _ogrz,
   {{0xa3ab8df4,0xe7ea85b3,0x20148063,0xddc9976d}},	//   _कोई_, जोरा_, ścią_, preš,
   {{0x6aa40234,0xd6fb0264,0x86379101,0x874c01bc}},	//   _esif, _আরো_, _קרוב_, _ọdịg,
   {{0x5f940e97,0xdc2b003d,0x69de519c,0x6fa9016f}},	//   кист, _بسته_, _elpe, _चोखं,
   {{0x644e0341,0xee3f0028,0x444404b7,0x799c519d}},	// [4390] _atbi, _quý_, eq_, berw,
   {{0x645c0114,0x6b9d01ba,0x69d88bfd,0x39472795}},	//   _bwri, lesg, jkve, _üns_,
   {{0x7985010c,0x7764107f,0x61f503bf,0x7bcd011f}},	//   _ichw, baix, mizl, _koau,
   {{0x7764519e,0xe8df801c,0x64410036,0x6b9d519f}},	//   caix, _niềm_, _élim, nesg,
   {{0xdb00a670,0x3d0f05b3,0x444401b4,0xc58e80ff}},	//   _famí, _तुरे_, aq_, _rồng_,
   {{0x7ff58986,0x6fd584e8,0x92a9009a,0x27ff0796}},	//   کستا, _zách, _załó, čunu_,
   {{0x5fd305e8,0x444421bf,0x2b40811a,0x2618064a}},	//   _सवाल, cq_, žica_, _बीटी_,
   {{0x01380bea,0xe3ca062f,0x799c18e3,0x6d4aa4cf}},	//   ורות_, _mañá_, zerw, _affa,
   {{0xf390001c,0x63bb9afe,0xcdf58d15,0xddcd0162}},	//   _bảng_, _inun, ечны, craţ,
   {{0x7bdf51a0,0x644805db,0x2d8136f1,0x63a9d0fc}},	//   _alqu, _édic, nghe_, _haen,
   {{0x3ead8353,0x63a99eb3,0x799c1457,0xf7709ab3}},	//   svet_, _kaen, verw, _چاه_,
   {{0xff53845b,0x6d4ad1a1,0x1ac680ab,0x63a992bf}},	//   _شخص_, _effa, _শেয়া, _jaen,
   {{0x799c51a2,0x63a9d1a3,0x45d5a098,0x2bc793f5}},	//   terw, _maen, _подс, _रचना,
   {{0x63a98074,0x7bdf24a3,0x25a78144,0x2be203b7}},	//   _laen, _elqu, _uanl_, _पतवा,
   {{0x799c01d3,0xdb00d1a4,0x63bbd1a5,0x98aa080a}},	//   rerw, _ramí, _onun, tabı_,
   {{0x7dd2013c,0x27ff97ee,0x07a30a90,0x799c51a6}},	//   _læst, nnun_, ласн, serw,
   {{0xd707490d,0x3f8051a7,0xdee327cb,0xe810950e}},	// [43a0] енте_, rgiu_, готи, ावता_,
   {{0x7dd21103,0x9f5d819d,0xe61734c4,0xf0a58129}},	//   _næst, _akwü_, еду_, _đàng_,
   {{0x6fd58216,0xeb9a9d7b,0x5ec80264,0x9f9503a6}},	//   _tách, зие_, _রেখে, _såå_,
   {{0x6fd5c02b,0x63a99193,0x656543cd,0x444451a8}},	//   _fáci, _caen, aahh, rq_,
   {{0xa3e690c5,0x7985031d,0xdbc70074,0x63a9cc2b}},	//   योग_, _ychw, _tööl, _daen,
   {{0xa8a691b3,0x644501c0,0x59c3064a,0x7bd98133}},	//   ерик, bqhi, शायर, akwu,
   {{0x660303c7,0x644e00f2,0xde03143b,0x63a9b9cb}},	//   _спра, _utbi, _спри, _faen,
   {{0xb4be142d,0x2000443e,0x69d8d1a9,0x61f500fe}},	//   ेही_, nnii_, skve, zizl,
   {{0x25aa0b67,0xd5b081a8,0x68050196,0x7dd251aa}},	//   _kabl_, لفة_, nėda, _fæst,
   {{0x7cca8086,0x7dd2013c,0x63a9d1ab,0x71eaaf7b}},	//   bərl, _gæst, _zaen, _عفاف_,
   {{0x8afd801b,0xe8df80ff,0x67fb0198,0x63a98f84}},	//   _veře, _tiềm_, näjä, _yaen,
   {{0x7985034a,0x6b82d1ac,0xab5d81b9,0x982b8061}},	//   _schw, ngog, _pożi, _فتنہ_,
   {{0x6b9d51ad,0xf39000ff,0x70c901a2,0xdb1b87b6}},	//   resg, _tảng_, रह्ल, _anuê,
   {{0x6d4ad025,0xdb040aae,0xd5b881a9,0xddcd0084}},	//   _uffa, _anió, rmās_, kraš,
   {{0x2d9ed1ae,0x3161026c,0x9f9c046d,0xc60c81cb}},	//   mete_, _vehz_, _bíà_, सकीय_,
   {{0x2d9ebada,0x61f5080a,0xe8df801c,0x656500dd}},	//   lete_, sizl, _hiểm_, wahh,
   {{0x442951af,0xe8df8028,0xb8c806b7,0x6fd83502}},	// [43b0] _iha_, _kiểm_, _खै_, _mích,
   {{0x26c7005c,0x63a9d1b0,0x3954001b,0xaa640098}},	//   ćno_, _saen, časí_, _стък,
   {{0xf1bf8028,0x6fd800f7,0x63a9d1b1,0x2d813648}},	//   _đá_, _oích, _paen, rghe_,
   {{0xe8d6004c,0x2d9ed1b2,0x44290197,0x6fd5a620}},	//   _יותר_, hete_, _jha_, _táci,
   {{0xfaa592b2,0x442927e4,0x63a982f1,0xa3b686a7}},	//   тало, _mha_, _vaen, जाज_,
   {{0x4429003d,0x63a9d1b3,0x4b3800be,0xe9d881e2}},	//   _lha_, _waen, ׂראל_, нкі_,
   {{0x2d9e8b24,0x442905b0,0x63a9d1b4,0x628bc12d}},	//   dete_, _oha_, _taen, stgo,
   {{0x6fdc83d3,0x44292b74,0x7e698074,0x63bbd1b5}},	//   _déco, _nha_, tsep, _unun,
   {{0x6fdc9313,0x2d9ed1b6,0x7c29bde5,0xdee58fc8}},	//   _técn, fete_, _iher, топи,
   {{0x442951b7,0x7e69c3d6,0x6fdc8866,0x7c3b8362}},	//   _aha_, rsep, _féco, _hiur,
   {{0x44290782,0x201200a4,0x3ea680eb,0x7c298c53}},	//   _bha_, yoyi_, _esot_, _kher,
   {{0x442951b8,0x3a3a008e,0x443b00b9,0xe73f00ff}},	//   _cha_, _sipp_, _ciq_, _ngõ_,
   {{0x442951b9,0x2d9ed1ba,0x76428326,0xaca3019d}},	//   _dha_, bete_, _guoy, faịd,
   {{0x2d9e803e,0xdb0086a5,0x7c3b8362,0x2fcfd1bb}},	//   cete_, _jamá, _liur, _hogg_,
   {{0x7c29d1bc,0x98b800eb,0xdb00bb7a,0xfce58d70}},	//   _oher, mbrī_, _mamá, _шоко,
   {{0x64438012,0x44290870,0x20000087,0x65638257}},	//   _iuni, _gha_, unii_, _henh,
   {{0xee3a0676,0xa3d583bb,0x6443bd34,0x36670098}},	// [43c0] дна_, ाउन_, _huni, като_,
   {{0x7a7b010f,0x67fb0364,0x2fcf835f,0x7c2980b4}},	//   _קריס, täjä, _logg_, _aher,
   {{0x7c3b8d12,0x6443ac04,0x6fd80580,0xada32b3f}},	//   _biur, _juni, _líci, рахл,
   {{0x7c29d1bd,0xdb040874,0x6fdcd1be,0x6563d1bf}},	//   _cher, _unió, _réco, _lenh,
   {{0x64438b65,0x69dc0503,0x6fdc82be,0x2d9eafea}},	//   _luni, okre, _décl, yete_,
   {{0x6563d1c0,0x7c2993d2,0xddcd02d7,0x2d9e01d0}},	//   _nenh, _eher, praš, _úte_,
   {{0x6443d1c1,0x2ca70366,0xdb0081a8,0x75e002d0}},	//   _nuni, ændt_, _damá, _göza,
   {{0x7c3b8330,0x27e200b9,0xd6daa306,0x7c299b79}},	//   _giur, _jlkn_, дто_, _gher,
   {{0xfaa3b23a,0x6563b0ba,0x7d1d8085,0x644386c1}},	//   _като, _benh, əssi, _auni,
   {{0x44294c0e,0x6443d1c2,0x7c3bd1c3,0xf77f02d0}},	//   _sha_, _buni, _ziur, _ilçe_,
   {{0xd82f8012,0x442951c4,0x7d7b0039,0x6e3c1d3f}},	//   _вэ_, _pha_, וניו, _mirb,
   {{0x6443d1c5,0x40ab8065,0x65638cfa,0xdb04002a}},	//   _duni, _زخمی_, _eenh, _aniñ,
   {{0xa3c9113d,0x80d000ab,0x44292419,0x6ab60428}},	//   लॉग_, _হেল্, _vha_, _cryf,
   {{0x442951c6,0xaca40133,0xc3338039,0xdb008118}},	//   _wha_, _ahọp, יור_, _xamá,
   {{0x44293b94,0x6568a5f3,0x6443d1c7,0x629a0087}},	//   _tha_, madh, _guni, ătoa,
   {{0x6568803d,0x3f849295,0xaca40870,0xd7c5816f}},	//   ladh, ngmu_, _chọp, वायच,
   {{0x6e3c03bf,0x6ab621f5,0x7c29808e,0x6443b2b5}},	// [43d0] _birb, _gryf, _rher, _zuni,
   {{0xf41f464b,0x7c29d1c8,0x3f730104,0x69dc1230}},	//   llä_, _sher, ệu_, ckre,
   {{0x6e3c01e2,0x63ad26a6,0x61f8812b,0xdb1d0074}},	//   _dirb, _kaan, divl, rksõ,
   {{0x2d87009a,0x63ad10b5,0x6568d1c9,0x6e3c0706}},	//   żne_, _jaan, hadh, _eirb,
   {{0x7c3b809f,0xe3b0803d,0xdb0081d0,0x201900e4}},	//   _viur, ترل_, _pamá, _iksi_,
   {{0x7c298051,0x63ad51ca,0x7d1c0357,0x6fd59f5c}},	//   _wher, _laan, _fyrs, _láct,
   {{0x7c29804c,0x3da40698,0x2edb801b,0x2610016f}},	//   _ther, _тряб, यन्त, तकरी_,
   {{0x6563d1c0,0x63ad51cb,0xfe79801b,0x6443d1cc}},	//   _senh, _naan, trů_, _runi,
   {{0x6568822e,0xee398698,0x7e6d51cd,0x6443d1ce}},	//   fadh, нни_, nsap, _suni,
   {{0x6568815b,0x7a248247,0x2b400118,0x6fd8041c}},	//   gadh, pòta, _sgic_, _víci,
   {{0x63ad51cf,0x656383a7,0xa3df016f,0x66d9846d}},	//   _baan, _venh, णसं_, _bùkú,
   {{0xf1a90039,0x63ad0079,0x5bde064a,0x628f51d0}},	//   _מס_, _caan, मसेव, ftco,
   {{0x656380a9,0x63ad51d1,0x65688079,0x92f6102a}},	//   _tenh, _daan, badh, учні,
   {{0x201907c7,0x6443bc72,0x6fd5841c,0x7bdd51d2}},	//   _aksi_, _tuni, _vácu, aksu,
   {{0xb21b006a,0xe0d500e8,0x27e20748,0x63ad01b4}},	//   kræf, ають, _plkn_, _faan,
   {{0x63ad51d1,0x61f882a5,0x69dc44ef,0xdce701d0}},	//   _gaan, zivl, skre, ůměr,
   {{0x7e6d16fb,0x857a028b,0x628f0bfd,0x25a10192}},	// [43e0] gsap, есет_, ctco, fehl_,
   {{0xe058003d,0x2d85d1d3,0x80b38105,0xcf2501a8}},	//   _لیست_, ngle_, ंटाइ, شرقي,
   {{0xb33b0073,0xf8a5819f,0x63ad3b0b,0xe5f680be}},	//   meça, _بک_, _yaan, נזער_,
   {{0x80a1009a,0x8afd81d0,0xb5fb01d0,0xa4f40072}},	//   खबरे, _seřa, _svát, _आधीच_,
   {{0x9f4480f1,0x61f8d1d4,0x6d5a81b4,0x7e6d0061}},	//   shmë_, tivl, ybta, csap,
   {{0x7e7bd1d5,0xf12680e8,0x9f52008b,0x6e3c0174}},	//   drup, льйо, ábær_, _uirb,
   {{0x20190009,0x61f8a944,0xf41f0198,0x7c3a80e5}},	//   _yksi_, rivl, ylä_, _ètro,
   {{0x61d1146d,0xddcb826c,0x9f49008b,0x6568d1d6}},	//   _सक्ष, _ćiši, nnað_, wadh,
   {{0x7e7b92f1,0x23af0076,0x7bc0d1d7,0x628f0a2a}},	//   grup, _जोगद, _inmu, xtco,
   {{0x7cca82bf,0x63ad51d8,0x211a80f7,0x35f49509}},	//   ləri, _saan, _كتاب_, рпор,
   {{0x63ad02b8,0x4d7b0158,0x6568c954,0x7c669ddd}},	//   _paan, ערטע, radh, داخل,
   {{0x53350758,0x201f83a7,0x63ad0df6,0xf74694d6}},	//   иент, clui_, _qaan, _седо,
   {{0x656880d7,0x2d980722,0x63ad0848,0x764605ee}},	//   padh, _obre_, _vaan, _nuky,
   {{0x63ad3512,0x7cca8085,0xe534812f,0x85568019}},	//   _waan, həri, _кель, _حیدر_,
   {{0x63ad1f61,0x6fd585e4,0x6fd8009f,0xe919004a}},	//   _taan, _táct, _lícu, тові_,
   {{0x2d980510,0xb8860187,0x69c8048d,0x76460365}},	//   _abre_, _suíç, öder, _buky,
   {{0x311b8bb8,0x7c2d0c03,0x35f516fc,0x6fc5816f}},	// [43f0] _पुनः_, _ihar, апар, वातं,
   {{0x6b898098,0x2d8a0197,0x7c2d0706,0x6f1d136f}},	//   _sceg, _ccbe_, _hhar, _vysc,
   {{0x8d7400a0,0x7c2d51d9,0x7e6d51da,0x7cca8085}},	//   صالا, _khar, ssap, fəri,
   {{0x43959a0b,0x2d9851db,0x7c2d51dc,0x63a2d1dd}},	//   радс, _ebre_, _jhar, geon,
   {{0x27e91a29,0x7c2d4c36,0xe8df801c,0x75e00019}},	//   mhan_, _mhar, _kiệm_, _közl,
   {{0x291e80f2,0x27e90cf4,0x02a301bc,0xf67a03c8}},	//   _byta_, lhan_, _gwụọ, _באשמ,
   {{0xc0e584fa,0x7c2d0102,0x2258807a,0x7e628032}},	//   ройк, _ohar, _črke_, _awop,
   {{0x27e951de,0x201f8087,0xccf20496,0x3eb94824}},	//   nhan_, ului_, _וכל_, _krst_,
   {{0x442db5b0,0xda788098,0x6fdc8036,0xdce181a9}},	//   _ihe_, _бях_, _méch, dalā,
   {{0xdcf5084a,0x644700f6,0x67fe8029,0x443fd1df}},	//   _hazı, _kuji, dīju, _hiu_,
   {{0x7c2d09c5,0x443fd1e0,0x69c1d1e1,0xa5098ae7}},	//   _bhar, _kiu_, _inle, тена_,
   {{0x7c2d32c5,0x64470010,0x443f872a,0x6d5c9434}},	//   _char, _muji, _jiu_, ðrar,
   {{0xed4ed1e2,0x1615146d,0xe9ff8028,0x7c2d3ccf}},	//   _мо_, तकार_, _luận_, _dhar,
   {{0xd9e583b7,0xdcf51010,0x2fcd803a,0x442d8073}},	//   कसित_, _lazı, ljeg_, _lhe_,
   {{0xb33b07e0,0x7a2002af,0x7c2d0c49,0x0596803d}},	//   reça, nöti, _fhar, _خانگ,
   {{0x7c2d51e3,0x27e91341,0x2fcd8024,0x290c04b7}},	//   _ghar, ghan_, njeg_, ħda_,

   {{0x056612b2,0x8d660009,0x65672f9f,0x63a281e0}},	// [4400] иван, ивае, _bejh, veon,
   {{0x75e01010,0x957c809a,0xdb0401df,0x443f8706}},	//   _gözl, wiąz, _gaiá, _aiu_,
   {{0x3eb902af,0x0b46a318,0xb97b0051,0x7663001b}},	//   _erst_, анен, _בניי, _čtyř,
   {{0x442dd1e4,0x27e951e5,0x9f060bca,0x61fc05c5}},	//   _che_, chan_, _نوجو, lirl,
   {{0x442d9674,0x443f809f,0x63a281a8,0x31c68098}},	//   _dhe_, _diu_, reon, искв,
   {{0x27e000a4,0x63a2d1e6,0xc5690065,0xed57490d}},	//   lkin_, seon, _محفل_, _вор_,
   {{0x443fb3a5,0x67fe80eb,0xb5fb03f2,0x9965804a}},	//   _fiu_, zīju, _tvár, стіл,
   {{0x27e051e7,0xd90d95e4,0x442dd1e8,0x443fd1e9}},	//   nkin_, رین_, _ghe_, _giu_,
   {{0x28a68b9f,0x61fc0059,0x41aa82d3,0x27e051ea}},	//   _कैरि, kirl, _иван_, ikin_,
   {{0x7c22d1eb,0x7c2d51ec,0xd9439537,0x6447008e}},	//   llor, _shar, _дефи, _yuji,
   {{0xdcf50afe,0x27e051ed,0xc8ca815b,0x61fc0965}},	//   _yazı, kkin_, _جوان_, dirl,
   {{0x75e00459,0x67fe8029,0x6440a1c7,0xdb040118}},	//   _sözl, tīju, _jimi, _saiá,
   {{0x64408a0d,0x27e00267,0x61fc51ee,0x2909807e}},	//   _mimi, dkin_, firl, şaat_,
   {{0x3d0f01fe,0xd9f8d1ef,0x27e00102,0x661c0267}},	//   _तुझे_, ्चित_, ekin_, _nkrk,
   {{0x27e90219,0x98480021,0x6c848013,0x7c2d14f2}},	//   than_, ията_, _العم, _thar,
   {{0x6440d1f0,0x7c2d51f1,0x27e042f3,0x645a90b6}},	//   _nimi, _uhar, gkin_, mpti,
   {{0x321821d5,0x443fd1f2,0xb33b03a7,0x06cd00ab}},	// [4410] bory_, _riu_, meço, _রেজি,
   {{0x6fdcc6fc,0x442d8051,0x27e951f3,0x61fc4565}},	//   _déci, _she_, shan_, cirl,
   {{0xf8b10288,0x443f8098,0x33180117,0xe9ff801c}},	//   _عکس_, _piu_, _مزید_, _quận_,
   {{0x1b1080c8,0x98a10028,0x6447244c,0x442d822c}},	//   ়েছে_, _nghĩ_, _vuji, _qhe_,
   {{0x443fa7fb,0x6fd805dc,0xfaa78c40,0xe2998087}},	//   _viu_, _víct, ршен, уал_,
   {{0xa2580051,0x644751f4,0x22490359,0x27e6d1f5}},	//   סבוק_, _tuji, _muak_, _alon_,
   {{0x442dd1f6,0x78ba84c3,0x6ce4035f,0x22492914}},	//   _the_, _crtv, _діте, _luak_,
   {{0x61fc0201,0x32180831,0x6440d1f7,0x3f8951f8}},	//   zirl, zory_, _gimi, ngau_,
   {{0xe6199073,0x61fc08c5,0xa159818b,0xfe7181a8}},	//   лди_, yirl, _базу_, أدب_,
   {{0x3f538032,0x27e0011e,0x6440922e,0x3f7780ff}},	//   ṣu_, zkin_, _zimi, ểu_,
   {{0x3ea9010b,0x3218026f,0x6440cd3d,0x80d700ab}},	//   hwat_, vory_, _yimi, _ডেস্,
   {{0x3ea9330d,0x22492914,0x98648061,0x644082ed}},	//   kwat_, _buak_, _بیٹے_, _ximi,
   {{0x78ba82a5,0x61fc51f9,0x13a8003d,0x224900ee}},	//   _zrtv, tirl, هنگی_, _cuak_,
   {{0x6d43809c,0x6fdc80e7,0x765b95d7,0xdddb81b9}},	//   _ugna, _réci, mpuy, ntuż,
   {{0x27e00009,0x61fc51fa,0x25a59c6d,0x6b9ba396}},	//   tkin_, rirl, mell_, _obug,
   {{0x25a5d1fb,0x3ebf0390,0x61fc099b,0x037a0180}},	//   lell_, _šuta_, sirl, _صحبت_,
   {{0x27e051fc,0x62800065,0x7bc4020d,0x63a63286}},	// [4420] rkin_, ámod, _iniu, mekn,
   {{0x25a5a906,0x64408ca9,0x6b9b860f,0x628622a3}},	//   nell_, _simi, _abug, muko,
   {{0x6440d1fd,0xc7a60785,0x628651fe,0x7bd602d0}},	//   _pimi, _линк, luko, _koyu,
   {{0x25a581ba,0x28bd83b6,0x6abbd1ff,0x3ea902d5}},	//   hell_, ्मनि, _bruf, bwat_,
   {{0x7c228be3,0x64409e72,0x62865200,0x9f91807b}},	//   rlor, _vimi, nuko, _ráð_,
   {{0x27e6990f,0xdb1b8118,0x6b9bbd7a,0xd46a08ca}},	//   _slon_, _couñ, _ebug, _محرم_,
   {{0x25a5874a,0x6286272f,0x7c22c793,0x27e68242}},	//   dell_, huko, plor, _plon_,
   {{0xa8570051,0x62865201,0x61ea81e0,0x64408049}},	//   זיקה_, kuko, shfl, _uimi,
   {{0xe9ff8028,0x25a5d202,0x69968544,0x6abb8428}},	//   _quản_, fell_, _грех, _gruf,
   {{0x25a5c5b8,0x6b8d5203,0x78bc83a7,0x2d998061}},	//   gell_, _scag, _árvo, ősen_,
   {{0xd4978009,0x7bd603bf,0x25f00ad5,0x1da989c1}},	//   бря_, _boyu, _इतनी_, _कसरत,
   {{0x224903ac,0x6286016b,0x7bd63749,0x24190a41}},	//   _puak_, fuko, _coyu, ромы_,
   {{0x25a5d204,0xb33b03a7,0x998c826c,0xa3d0815c}},	//   bell_, reço, _midž_, _वचन_,
   {{0x2d578009,0x25a5d205,0xe6778039,0x07378039}},	//   _лишь_, cell_, _פתוח_, _האדם_,
   {{0x63a6008e,0x6722808e,0x7c3f01e8,0xfc4980ff}},	//   bekn, _hyoj, _èpro, _hận_,
   {{0x63a6008e,0x672285ee,0xf7701ef5,0x3ea9288a}},	//   cekn, _kyoj, ّال_, twat_,
   {{0x6aad0010,0x9df91dc7,0x34e1001b,0x644ab0f9}},	// [4430] _usaf, анат_, पन्द, _hufi,
   {{0xdce70063,0x644ad206,0x99671cad,0xa2c61c3b}},	//   _zdję, _kufi, _утил, ामर्,
   {{0x2127001c,0xfc498129,0x67d50162,0x656ad207}},	//   _ánh_, _lận_, _дону, _mefh,
   {{0x661a811f,0x69d7002a,0x7cca8085,0x644aa0b0}},	//   hotk, _hoxe, lərs, _mufi,
   {{0x644ab327,0xf42a0198,0x661aa551,0x3abc03de}},	//   _lufi, lvää_, kotk, ָמונ,
   {{0xd4e70d0e,0x5ce717d4,0x51878009,0x25a5823e}},	//   _люби, _люба, суда, xell_,
   {{0x25a5d208,0x644a8803,0x6286248d,0x661a84e8}},	//   vell_, _nufi, zuko, dotk,
   {{0x20091106,0x6b9b9d61,0xfc4980ff,0x40328073}},	//   nnai_, _ubug, _bận_, мејс,
   {{0x6458d209,0x25a5ac1d,0xdce382ee,0xfc49801c}},	//   _atvi, tell_, _venč, _cận_,
   {{0x7bd60059,0x661a812b,0x69d7473d,0x63a609e1}},	//   _soyu, gotk, _noxe, wekn,
   {{0x25a5d20a,0x200902f7,0x66838019,0xddc995d8}},	//   rell_, knai_, _کیخل, prež,
   {{0x25a5bbfe,0x6286520b,0x7bd60201,0x69c5520c}},	//   sell_, tuko, _qoyu, _anhe,
   {{0x8c1a8bea,0x25a5aebd,0x63a6520d,0x2b1703db}},	//   שורי, pell_, rekn, _धुआँ_,
   {{0xfce582da,0x6d47020f,0x27ffd20e,0x644a826c}},	//   _моло, _ngja, liun_, _fufi,
   {{0x61430a68,0x6286505c,0xd9431ed1,0xd5b881a9}},	//   дера, suko, дери, klāj_,
   {{0x3ea9826f,0x27ff846d,0x7bc40087,0x69c50f06}},	//   _šaty_, niun_, _uniu, _enhe,
   {{0x4420520f,0x76438a5a,0x9d2600c8,0x29f6809a}},	// [4440] _iki_, _kiny, _বলেন_, cław_,
   {{0x6fdc957a,0x7643d210,0x7c261ff5,0x644a8326}},	//   _héct, _jiny, llkr, _yufi,
   {{0x7643abf2,0xdd7a8158,0x24758029,0xfecf80ab}},	//   _miny, שטעל, nām_, িনিধ,
   {{0x76439f60,0x661a812b,0x27ff80dd,0xeb9a8073}},	//   _liny, zotk, jiun_, рид_,
   {{0x27ff91ee,0x27edd211,0x1fb501e5,0xdc3700be}},	//   diun_, dhen_, _эсэр, קאנט_,
   {{0x7643932c,0x247580eb,0x27ed8a48,0x09e3876a}},	//   _niny, kām_, ehen_, мочн,
   {{0x24758341,0x44205212,0xe7868d9e,0xd7c5816f}},	//   jām_, _oki_, оупо, वांच,
   {{0x44205213,0x27ff810c,0x247580eb,0x644ace51}},	//   _nki_, giun_, dām_, _rufi,
   {{0xa3ce00cf,0x09c480ab,0x4426955c,0x7643ae4a}},	//   रान_, ্সবা, mlo_, _biny,
   {{0x4426a91e,0x44200065,0x44322ccd,0xfc49801c}},	//   llo_, _aki_, _ahy_, _vận_,
   {{0x6fdcd214,0x7643859c,0xa3ae816f,0x4426cb60}},	//   _sécu, _diny, _कसा_, olo_,
   {{0x27ed8943,0x44268b4c,0x27ff802e,0xfc49801c}},	//   chen_, nlo_, ciun_, _tận_,
   {{0x4420016f,0x4426d215,0x661ad216,0x62829336}},	//   _dki_, ilo_, potk, nroo,
   {{0x4426d217,0x9e658077,0x442034c2,0x247580eb}},	//   hlo_, _راهن, _eki_, bām_,
   {{0x6458835f,0x29f68035,0xd48f8a08,0x6282890d}},	//   _utvi, sław_, _юр_, hroo,
   {{0x35e08b85,0x44268088,0x187b80be,0x3166026c}},	//   _पकड़, jlo_, יטלב, _đoze_,
   {{0x4426d218,0xdce380eb,0x20095219,0x2d8c86a8}},	// [4450] dlo_, _ienā, rnai_, ogde_,
   {{0x31352410,0x27ff9a89,0xdcbb50f6,0x4426d21a}},	//   _непр, ziun_, ище_, elo_,
   {{0x2fc68025,0x4439521b,0x321c826f,0x7a201743}},	//   _onog_, oms_, dovy_, rött,
   {{0xf53783de,0x62828901,0x0b588071,0xdb1b87b6}},	//   קטאר_, froo, оршы_, _anuá,
   {{0xa7560039,0x601304b7,0x628286a8,0x2a69008e}},	//   _משרד_, għme, groo, _jwab_,
   {{0xa96680a9,0x4426a223,0x21668c24,0x7f3a01c6}},	//   пиша_, alo_, пиши_, _לערו,
   {{0x4426d21c,0x628291fe,0x764bd21d,0x27edd21e}},	//   blo_, aroo, _sugy, then_,
   {{0x7643d21f,0x75ed8298,0x443914da,0x6282d220}},	//   _siny, _múze, jms_, broo,
   {{0x7643d221,0x27edd222,0xadc4046d,0x27ff8168}},	//   _piny, rhen_, _afẹr, riun_,
   {{0x27ed83c3,0x27ff88b3,0x24758029,0x44390110}},	//   shen_, siun_, tām_, ems_,
   {{0x44200c68,0x236d8282,0x7a2d8118,0x2a69010c}},	//   _pki_, _keej_, cúta, _awab_,
   {{0x3835a1f6,0x2b4903a8,0x247580eb,0xdce7001b}},	//   _энер, _cgac_, rām_, _nejč,
   {{0x76438870,0x236d81c5,0x67ea007b,0x247581a9}},	//   _tiny, _meej_, _nýja, sām_,
   {{0xceb29b9e,0x236d90af,0x44320039,0x985600e8}},	//   _ניו_, _leej_, _why_, зташ,
   {{0x4426d223,0xdca29056,0x31160076,0x44200b99}},	//   ylo_, _защи, _दुखः_, _tki_,
   {{0x236d81e9,0x6282d224,0xe0431d7b,0x8ca60105}},	//   _neej_, yroo, енси, _टैगो,
   {{0x4426bd3a,0x3ead9151,0xe7371adb,0x2c0b0061}},	// [4460] vlo_, nwet_, зет_, _دعوی_,
   {{0x63b601b4,0xf8bd86ab,0x66019b40,0xd83882d6}},	//   _hayn, ्माय, nilk, _apčl_,
   {{0x63b607d9,0xddcd0353,0x89db04de,0x61fe24cf}},	//   _kayn, braž, _החיי, _impl,
   {{0x62829e87,0x205703c8,0x4426b722,0x224d80b9}},	//   troo, _מיטל_, ulo_, _buek_,
   {{0x4426957e,0x63b65099,0x66019eb1,0x224d9142}},	//   rlo_, _mayn, kilk, _cuek_,
   {{0x98b80b06,0x44269234,0x6282cab1,0x628690aa}},	//   ları_, slo_, rroo, _åkom,
   {{0xdca31878,0x6601d225,0x62828123,0x44395226}},	//   _пари, dilk, sroo, yms_,
   {{0x644e002e,0x6282c6c3,0x661e0796,0x6aa40037}},	//   _iubi, proo, lopk, _opif,
   {{0x644e5227,0x61fe009f,0x96349ad8,0x63a089c4}},	//   _hubi, _ompl, мниц, _ibmn,
   {{0x644e0c6f,0xf9c489d7,0x660182f7,0x6726021e}},	//   _kubi, _تحری, gilk, _mykj,
   {{0x69c8d228,0x236d90af,0xdcfc0214,0x6fdc82be}},	//   _inde, _yeej_, _karı, _décr,
   {{0xb21b013c,0x644e01d3,0x61fe15ad,0x661e042b}},	//   græn, _mubi, _ampl, hopk,
   {{0x44395229,0xe9ff8028,0x644e522a,0xddcd522b}},	//   rms_, _quần_, _lubi, vraž,
   {{0x4439522c,0x69da8364,0x6601b091,0x22450106}},	//   sms_, _jote, cilk, ölk_,
   {{0xddcd003a,0x644e522d,0x59f8522e,0x859b8039}},	//   traž, _nubi, черя_, _השוו,
   {{0xa3ce0778,0xe9ff8028,0x61fe4475,0x22960edd}},	//   राण_, _tuần_, _empl, bæk_,
   {{0x69c8933a,0x35b5522f,0xe9ff80ff,0x95d92748}},	// [4470] _onde, мбар, _huấn_, одат_,
   {{0x69dad230,0x644e0f8e,0x236d8282,0x317100b9}},	//   _note, _bubi, _seej_, qazz_,
   {{0x644e01ca,0x682583a7,0xdcfc03bf,0x63a0808e}},	//   _cubi, sódi, _barı, _bbmn,
   {{0x236d822c,0x645c0174,0x22459ee5,0x3eb2062c}},	//   _qeej_, _dtri, _silk_, äntä_,
   {{0x69dab543,0xa3ce035a,0x69c8d231,0x7ae2d232}},	//   _bote, रात_, _bnde, gyot,
   {{0xed46803d,0x69da9139,0xdea4053d,0xbde5010c}},	//   _لپ_, _cote, _سیمی, _dhèè,
   {{0x644e003a,0x7c84490d,0x6601d233,0x69da83f2}},	//   _gubi, _путе, vilk, _dote,
   {{0x7e7d82b7,0x6d5883b2,0x560000ab,0x7ff5803d}},	//   áspo, _afva, ্তৃক_, بستا,
   {{0x644e3065,0x6601d234,0x76470314,0x91d00035}},	//   _zubi, tilk, _kijy, दामै,
   {{0xd7068364,0x63abae4c,0x644e5235,0x628ba2a3}},	//   ьные_, legn, _yubi, mugo,
   {{0xdcfc02bb,0x644802be,0x628bd236,0x6add809a}},	//   _yarı, _édit, lugo, _मथुर,
   {{0xd91a8159,0x6601d237,0x68e392fa,0xa3ce0af3}},	//   _וועל, silk, mynd, राध_,
   {{0x629989e5,0x0f568051,0x628b977c,0x68e3808b}},	//   ntwo, _חינם_, nugo, lynd,
   {{0x63b65238,0x22960366,0xbea2ca52,0xa2b08072}},	//   _wayn, ræk_, _рашк, _आईस्,
   {{0x32432659,0xa3ce00d4,0x628b82e8,0x80ba0035}},	//   терг, राद_, hugo, ॉमें,
   {{0xdfd200f7,0xc7b98019,0x764f0a5a,0x5d4483de}},	//   خير_, ndő_, _bucy, _אָפּ_,
   {{0x1dc909a3,0x644e0b87,0x386d0a20,0x645c5239}},	// [4480] रांत, _subi, ćera_, _stri,
   {{0xdcfc03bf,0x644e523a,0x7ae28010,0x61fe0087}},	//   _sarı, _pubi, vyot, _umpl,
   {{0x7e760176,0x764702d6,0x7c240c2e,0xb4e81404}},	//   ssyp, _dijy, _kkir, यने_,
   {{0x656e523b,0x63abd23c,0xd90d0019,0xdcfc0085}},	//   _webh, gegn, _ایف_, _qarı,
   {{0x19588084,0x656e523d,0x245380ff,0x6684004e}},	//   палы_, _tebh, _lãm_, _سیال,
   {{0x644e268b,0x7ae29315,0x6fb4016f,0x98c69ef0}},	//   _tubi, ryot, _उघडू, дсил,
   {{0x68e3813c,0x7c24523e,0x63ab9108,0x645c523f}},	//   gynd, _okir, begn, _utri,
   {{0xdfd08013,0x628bd240,0xd7d1016f,0x5fd1016f}},	//   اية_, bugo, हायच, हायल,
   {{0x69dad241,0x6d431024,0x25b800ed,0x7c3f0037}},	//   _tote, žnat, _karl_, _èpri,
   {{0x69c8c33f,0x7c24300f,0xd49a8012,0x7bc9826f}},	//   _unde, _akir, орм_, _zneu,
   {{0x6448d242,0x442484fb,0x62805243,0x35f780f7}},	//   _édis, _kkm_, ámon, بريد_,
   {{0x4424af16,0x9f4901a8,0xa2c298b1,0xddc282d4}},	//   _jkm_, thaí_, लिप्, _uvož,
   {{0x2004973c,0x4424d244,0x6b9d5245,0x3dca0176}},	//   mimi_, _mkm_, rfsg, _onbw_,
   {{0x2004d246,0xe9ff801c,0x7c240c56,0x6abd0646}},	//   limi_, _tuấn_, _ekir, rvsf,
   {{0x26c2472e,0xa3ae8072,0x7647018f,0xdb160176}},	//   _arko_, _कसं_, _rijy, _layè,
   {{0x2d9ea8fd,0xdb00d247,0x23669320,0x27f20c0b}},	//   lfte_, _jamó, jboj_, ghyn_,
   {{0x98af02bb,0x26c2017f,0xdb00816a,0x63abd248}},	// [4490] ınız_, _crko_, _mamó, vegn,
   {{0x2004c898,0x6eb186a7,0xdb0b8bdd,0xa2c2a4bd}},	//   himi_, _अनसु, ndgå, लिन्,
   {{0x2004d249,0x81c68264,0x7bc9bc72,0xe759004a}},	//   kimi_, ৎসা_, _pneu, _нині_,
   {{0x628bd24a,0x2004c96b,0xb5fb01a8,0x629981ec}},	//   tugo, jimi_, _stád, ttwo,
   {{0x27e90867,0x63ab8bc5,0x81d880ab,0xe94502e3}},	//   mkan_, regn, াসন_, _ترکی,
   {{0x27e929a9,0x63ab920c,0x7bc9831d,0x628bd24b}},	//   lkan_, segn, _wneu, rugo,
   {{0x54542155,0x63ab8098,0x27e90280,0x6594524c}},	//   _авст, pegn, okan_, _шару,
   {{0x27e93661,0x68e385ee,0x20048ff2,0x66050458}},	//   nkan_, rynd, gimi_, lihk,
   {{0x27e9408b,0x68e384dc,0xa3ce0526,0x200db7f0}},	//   ikan_, synd, रास_, rnei_,
   {{0x27e9045c,0xee3687ac,0x6d4ea828,0x7c2bd24d}},	//   hkan_, нны_, žban, llgr,
   {{0x27e9524e,0x64c980d4,0x20048168,0xdb00d24f}},	//   kkan_, िमेश, bimi_, _famó,
   {{0xca290051,0x66051600,0x8ca80c28,0xab5d8035}},	//   _הם_, hihk, _घनघो, _poży,
   {{0xc7d68f60,0x27e95250,0xd9e380c2,0x1ae18264}},	//   _רוני_, dkan_, _औकात_, _খেতে_,
   {{0xdb00809a,0x67e30074,0x7c2b948c,0xb8663b76}},	//   _zamó, _mõju, hlgr, فارو,
   {{0x27e90057,0xa3c186bf,0x6605010b,0x6e218369}},	//   fkan_, ्ञा_, dihk, molb,
   {{0x27e90b13,0x7c2420cf,0x628635b2,0xdb0083a8}},	//   gkan_, _ukir, prko, _xamó,
   {{0x44225251,0x63a45252,0xd7c40072,0x8d661dc7}},	// [44a0] mok_, _ibin, _लोणच, евзе,
   {{0x44225253,0x27e9208b,0xa3ce419f,0x2004d254}},	//   lok_, akan_, राव_, zimi_,
   {{0x27e90393,0x442480dd,0x6449a590,0x225f8748}},	//   bkan_, _pkm_, _biei, _atuk_,
   {{0xe29a8ba5,0x27e904b8,0x44220298,0xd5c9090a}},	//   зад_, ckan_, nok_, राउज,
   {{0xdb00a509,0x5b2387ac,0x2004d255,0xd32382c7}},	//   _ramó, льша, vimi_, льши,
   {{0x44221066,0x69de4483,0x2a6000ee,0xdb008176}},	//   hok_, _jope, _mtib_, _bamò,
   {{0x2004d256,0x6d4e18b2,0x26c05257,0x63a404be}},	//   timi_, _igba, lvio_, _obin,
   {{0x69de5258,0x8c438bba,0x3ebf111b,0x3f920326}},	//   _lope, _бесе, _šuti_, ngyu_,
   {{0x2004d259,0x4422525a,0x7c22858f,0x62800019}},	//   rimi_, dok_, moor, ámol,
   {{0xdd908277,0x69de45c5,0x200490ad,0x63a4525b}},	//   جود_, _nope, simi_, _abin,
   {{0x6f66839d,0x4ac3035a,0x2d9eae68,0x6d4e082e}},	//   _звез, शिभव, rfte_, _mgba,
   {{0x4422525c,0x7c22b98f,0x2bc6d25d,0xcfaf80ab}},	//   gok_, noor, _रोमा, কাউন,
   {{0x81b38a49,0xa2be03dd,0x6d5c06c0,0x2bb20beb}},	//   টার_, शिष्, _ofra, _जसरा,
   {{0x7c228b3c,0x69de47ff,0x3c32027f,0xdb028e15}},	//   hoor, _cope, ráva_, ndoñ,
   {{0x27e9045c,0x4422525e,0x7c22d25f,0x69de127a}},	//   tkan_, bok_, koor, _dope,
   {{0x44220e60,0x6d4e5260,0x629a0087,0x2b498bda}},	//   cok_, _agba, ător, žaci_,
   {{0x27e9045c,0xf65316a5,0x66050359,0x7e6416fb}},	// [44b0] rkan_, ائر_, tihk, gpip,
   {{0x27e90393,0x984b5261,0x6d5ad262,0x7bdf023e}},	//   skan_, _няма_, ncta, _hoqu,
   {{0x27e90393,0x225f838e,0x55778158,0x7c22a007}},	//   pkan_, _stuk_, געבן_, foor,
   {{0x6d5c2e4d,0x660515bd,0x7c2290b5,0x69de007a}},	//   _efra, sihk, goor, _zope,
   {{0x6449d263,0x629d5264,0x6d5c0114,0x660523be}},	//   _viei, ntso, _ffra, pihk,
   {{0x7bdf3bfe,0x44220e14,0x1e1a809a,0xdb0bbb7a}},	//   _loqu, zok_, नकोष_, negé,
   {{0x70bd85e8,0x5ba78a94,0x7c229e87,0xd3a786b5}},	//   ्मेल, _праз, boor, _прап,
   {{0x63af111b,0x6d4e811f,0x442b8129,0x7c22c3b6}},	//   jecn, žbal, _óc_, coor,
   {{0xee39867c,0x629d3c96,0x22849663,0x225f8359}},	//   мни_, jtso, _бухг, _utuk_,
   {{0x645a07a3,0x442208b3,0x628f47ab,0x63bbd265}},	//   _étic, wok_, duco, _haun,
   {{0x44225266,0x63bb8a14,0xa806017b,0x7bdf106c}},	//   tok_, _kaun, lmış, _boqu,
   {{0x63bbbb8a,0x32078e04,0x7bdf5267,0xa2be1344}},	//   _jaun, liny_, _coqu, शिल्,
   {{0x44225268,0x63bba34d,0xa806017b,0x21f402f1}},	//   rok_, _maun, nmış, _lähe_,
   {{0x44225269,0x32078e04,0x26c001e8,0x63bbd26a}},	//   sok_, niny_, vvio_, _laun,
   {{0x4422526b,0x64c5005c,0x21f401ec,0x44c10084}},	//   pok_, nčić, _nähe_, _nė_,
   {{0xb8da1094,0x63bb8cf4,0x63a40dc5,0x6d5c0d02}},	//   _आई_, _naun, _ubin, _sfra,
   {{0x539b0051,0xf7728158,0x7c228b3c,0x3207816b}},	// [44c0] _חיפו, יקן_, voor, kiny_,
   {{0x7c2290f4,0x4d631adf,0xe737526c,0x3207826f}},	//   woor, икув, теу_, jiny_,
   {{0x32078efc,0xeb9a8e8e,0x7c22d26d,0x26c0041c}},	//   diny_, дие_, toor, svio_,
   {{0x7bdf0580,0x31780035,0x7e7b8100,0xe7279a10}},	//   _xoqu, larz_, ksup, _نص_,
   {{0x7c22a808,0x63bbd26e,0x32079075,0x8004819d}},	//   roor, _daun, finy_, ịakọ_,
   {{0x7c229e7e,0x7e7b8338,0xa3ce01a2,0xa3ae86a7}},	//   soor, dsup, राँ_, _कसक_,
   {{0xc9530039,0xfc4a001c,0x7c2286a8,0x629b8037}},	//   סמה_, _hậu_, poor, _equo,
   {{0x61df01fe,0x67f58038,0x63bb8084,0xb21b006a}},	//   _नक्ष, _nájd, _gaun, træk,
   {{0x6d4e80ce,0x7bdf526f,0x7e7b93d2,0x32078873}},	//   žbam, _roqu, gsup, biny_,
   {{0x63a2d270,0x63bb84b9,0x7bdf3666,0xdbd6046d}},	//   lfon, _zaun, _soqu, _gùús,
   {{0x7bdf2f30,0x63af5271,0xb4cc86ae,0x624b04b7}},	//   _poqu, tecn, रमे_, _bżon,
   {{0x601304b7,0xd5be81a9,0x629d0687,0xbf9b041c}},	//   għml, _šāda_, ttso, _amên,
   {{0x80c08b9f,0x61e1016d,0x63af095e,0x6825816a}},	//   विवे, öllo, recn, pódr,
   {{0x629d00ad,0x63af0503,0x7a32006a,0xdcfc02d6}},	//   rtso, secn, sætn, _adrč,
   {{0x7bdf428b,0xdb04002a,0x67f58061,0xa8060380}},	//   _toqu, _baió, _fájd, zmış,
   {{0xa3ce01a2,0x7bcd5272,0xdb04002a,0x0eb68beb}},	//   राः_, _unau, _caió, _अनाड,
   {{0x4429177c,0x63bb97ee,0xfc4a001c,0x2caa0b99}},	// [44d0] _ika_, _raun, _cậu_, _apbd_,
   {{0x7c2f1a2e,0x2caa02f7,0xb5fb026b,0x201202ec}},	//   llcr, _bpbd_, _awár, anyi_,
   {{0x3207803e,0xb90800c8,0x63bb9fdb,0x9f9c008b}},	//   viny_, _মে_, _paun, _tíð_,
   {{0x7e62d273,0x64c5012b,0xa80607c0,0x44290176}},	//   _otop, včić, tmış, _jka_,
   {{0x53a5058c,0x3207826f,0x2009335d,0x26c68282}},	//   ग्यश, tiny_, miai_, _nroo_,
   {{0x20090a8e,0x6d4e992c,0xa8060380,0x644d5274}},	//   liai_, žbaj, rmış, _liai,
   {{0x7e62862f,0x63bb8cd5,0x3207d275,0xa3e4064a}},	//   _atop, _taun, riny_, पॉड_,
   {{0x20090a8e,0x44295276,0x7e7bd277,0x26c682f7}},	//   niai_, _nka_, tsup, _broo_,
   {{0xfc4a0028,0x7c29811e,0xa3d7123a,0x32079c18}},	//   _mật_, _iker, सान_, piny_,
   {{0x44295278,0xf99388ca,0xe616c3e1,0x64552479}},	//   _aka_, _خبر_, лды_, _kuzi,
   {{0xeb9a024f,0xd131845a,0x65753b65,0x7e7bcec3}},	//   нин_, _اما_, _mezh, ssup,
   {{0xa3ce0768,0x44290168,0x442f8118,0x65750168}},	//   राइ_, _cka_, nlg_, _lezh,
   {{0x61e1a4b6,0x6da5a40b,0xe5a59810,0xe2c70ea6}},	//   _koll, _била, _били, гляд_,
   {{0x44295279,0x61e18009,0x27eda28f,0x090500c8}},	//   _eka_, _joll, lken_, _শুধু_,
   {{0xfc4a0028,0x644d338d,0x6455032d,0x7c29d27a}},	//   _bật_, _fiai, _nuzi, _oker,
   {{0x27edd27b,0x20091450,0x7c29af0b,0x2d83527c}},	//   nken_, giai_, _nker, _adje_,
   {{0xee3a0951,0x7c26527d,0x27edd27e,0x645527a3}},	// [44e0] ена_, mokr, iken_, _auzi,
   {{0x61e19ffb,0x6455020c,0xdd92006b,0x7c3bd27f}},	//   _noll, _buzi, صوص_, _ahur,
   {{0x27edd280,0x399b00be,0x65750609,0x67f5801b}},	//   kken_, _אייד, _dezh, _záje,
   {{0x27ed8613,0xa3d70aed,0x248601ac,0x2009335d}},	//   jken_, साय_, čom_, ciai_,
   {{0x0cb081cb,0xc6940158,0x7c3bd281,0x09e6935f}},	//   _जन्म, _דאָ_, _dhur, лодн,
   {{0x2d83030b,0x61e1914e,0x27ed8a0f,0x7c298135}},	//   _gdje_, _coll, eken_, _eker,
   {{0xee0980c8,0x64555282,0x7c264949,0x61e19d56}},	//   রকাশ_, _guzi, kokr, _doll,
   {{0xd6dad283,0xd252803d,0x6b840c2e,0xdb040118}},	//   ето_, _هنر_, _ndig, _laiñ,
   {{0x3ea05284,0x61e1d285,0xa3ce0bb8,0xb4cc9c7b}},	//   ntit_, _foll, राई_, रम्_,
   {{0x44291918,0x57e1035a,0x61e1d286,0x6b845287}},	//   _ska_, _नव्ह, _goll, _adig,
   {{0x2ed10af3,0x806696ba,0xc223803d,0xf0669a4a}},	//   _सप्त, _свеж, _اکنو, _скеп,
   {{0x764e054e,0x27ed92a1,0x3ea05288,0xab6203bf}},	//   _liby, cken_, ktit_, şünd,
   {{0xa3d705e8,0x61e18182,0x20090110,0xe3bf5289}},	//   साब_, _yoll, viai_, goña_,
   {{0x2fc03aa7,0x249c80ee,0x764e00b4,0xe80202f1}},	//   edig_, _tqvm_, _niby, रोसा_,
   {{0x657a8234,0xb21b006a,0x4426d28a,0xf55b81c6}},	//   math, kræv, koo_, _אדומ,
   {{0xb8dd113d,0x4426a1aa,0x657ab598,0x64550157}},	//   _इन_, joo_, lath, _ruzi,
   {{0x4426d28b,0x200901e2,0xfc4a0028,0x33a80698}},	// [44f0] doo_, riai_, _vật_, _също_,
   {{0x78ba8025,0x200901e2,0x7c3bc45c,0x7c29d28c}},	//   _ostv, siai_, _shur, _sker,
   {{0x38c900d5,0x2ee92323,0xd7c4816f,0xfc4a00ff}},	//   _شادی_, syaf_, वयाच, _tật_,
   {{0x61e1d28d,0x442682a3,0x657aa388,0x200c00e7}},	//   _soll, goo_, hath, édit_,
   {{0x657aa890,0x63bf2fc7,0x61e1bf3c,0x3ea007f1}},	//   kath, _maqn, _poll, ctit_,
   {{0x17ed85e8,0x64551f34,0x2006836e,0x2d8304a8}},	//   जस्व_, _tuzi, _amoi_, _udje_,
   {{0x4426d28e,0x61e1c537,0x27edad94,0x657abd8f}},	//   boo_, _voll, tken_, dath,
   {{0x7c3bcb2e,0x3fe5a134,0x61e1b2c7,0x27edc12d}},	//   _uhur, ржив, _woll, uken_,
   {{0x27edc4bb,0xe7e68665,0x657aa78e,0x63a9d28f}},	//   rken_, _ओकरा_, fath, _iben,
   {{0x657ac8ed,0x80bb00ab,0x61e180b9,0x67ea01d0}},	//   gath, _উপন্, _uoll, _výji,
   {{0x21f40074,0xdb04002a,0xee368087,0x2fc02937}},	//   _näha_, _raiñ, рнэ_, ydig_,
   {{0x92d780ab,0xab5d8372,0xe3bf03a8,0x09aa8264}},	//   ানী_, _dażg, toña_, _গোপা,
   {{0x63a9803d,0x657a805d,0x63bf0609,0x59b9908a}},	//   _mben, bath, _daqn, _इसार,
   {{0x657ad290,0xe1ff01df,0x6fa18beb,0xb5fb016b}},	//   cath, spón_, क्रू, _stán,
   {{0xab5d8063,0x614611d0,0x7c262d68,0x412a05c2}},	//   _każd, рева, pokr, тово_,
   {{0x4426d291,0x2fc0038e,0x1f66096b,0x3ea00aa8}},	//   xoo_, udig_, ркам, ttit_,
   {{0x2fc0268d,0xed5a2028,0x3ea05292,0x4426c013}},	// [4500] rdig_, воз_, utit_, voo_,
   {{0x3ea05293,0x63a9a1a3,0xc27b093f,0xa3d70996}},	//   rtit_, _aben, _שריי, साथ_,
   {{0x3ea019e0,0x8fa6130f,0xb5fb4f3b,0x7a2d807b}},	//   stit_, _кане, _itál, nútu,
   {{0xb5fb0019,0x03a6a481,0x657a8234,0xa87b00be}},	//   _után, ридо, zath, _באטר,
   {{0x4426d294,0xdce3801b,0x764e056c,0x657a81f6}},	//   roo_, _peně, _tiby, yath,
   {{0x442682c1,0x63a9c784,0x80aa80ab,0x645a0866}},	//   soo_, _eben, কিস্, _étio,
   {{0x44c580eb,0x218900be,0x44268198,0xdb0f2509}},	//   _nē_, אָפּ, poo_, recé,
   {{0x4fc69597,0x67f80144,0x657aa647,0x7afd50b1}},	//   рска, _fíje, wath, yzst,
   {{0x8f9b012a,0x7e6980e4,0x657ad295,0xd6d78c6e}},	//   דיפי, gpep, tath, атэ_,
   {{0x35f4a10d,0x26c08110,0x7bc0d296,0x7bc28bfd}},	//   спор, _šios_, _hamu, ldou,
   {{0x78baacc8,0xd7ef9d32,0x7d7b0496,0x6aa2d297}},	//   _ustv, _ду_, כניו, ltof,
   {{0x7bc0d298,0x0ed6000d,0x3869826c,0x657ad299}},	//   _jamu, ठमाड, ćart_, sath,
   {{0x7bc0c83c,0x6aa28d85,0x657ad29a,0x7a2d808b}},	//   _mamu, ntof, path, rútv,
   {{0x7bc09cc5,0x7a2d8177,0x657a85e7,0x44c58176}},	//   _lamu, sútv, qath, _fē_,
   {{0xfc64819f,0xf8073c7a,0x16b681a2,0xa3d71516}},	//   _اختی, ачан, _अनुब, साद_,
   {{0x7bc08763,0x74150bca,0x25aa04be,0xe802064a}},	//   _namu, _دوبا, _abbl_, रोला_,
   {{0x645889f8,0x7c2d529b,0xe7ee8665,0x65788282}},	// [4510] _huvi, _ikar, _जवना_, _kevh,
   {{0x6458d29c,0x7bc0b481,0x63a980dd,0x6f0d80c3}},	//   _kuvi, _aamu, _sben, _žack,
   {{0x090500c8,0x7bc081d3,0x8d740e06,0xdcbb0081}},	//   _শুরু_, _bamu, زالا, ъща_,
   {{0x64588609,0xdb160144,0x97a70425,0x81b80264}},	//   _muvi, _hayá, _трол, ছাঃ_,
   {{0x7bc0d29d,0x61e5529e,0xfc4a0129,0xdb0602d0}},	//   _damu, _kohl, _mập_, rekç,
   {{0x65789dc1,0xfc4a0028,0x64588073,0xa4d50a18}},	//   _nevh, _lập_, _ouvi, _логі,
   {{0x92d780c8,0x7c2d529f,0x61e5027f,0x7bc0a316}},	//   ানে_, _okar, _mohl, _famu,
   {{0xe73994ef,0x43948009,0x7bc0d2a0,0x32558470}},	//   лей_, _масс, _gamu, _гвар,
   {{0x442db5b0,0x443fd2a1,0x6abbd2a2,0x601301b9}},	//   _ike_, _ihu_, _usuf, għmi,
   {{0x7c2d52a3,0x6e288132,0x7bc0b28b,0x7e69c8c8}},	//   _akar, godb, _zamu, rpep,
   {{0x443f8028,0x6458802e,0x7bc086b0,0xdb06072c}},	//   _khu_, _cuvi, _yamu, ndkö,
   {{0xb5fb027f,0x69c1d2a4,0xfc4a0028,0x645883a7}},	//   _stál, _hale, _cập_, _duvi,
   {{0xa3e9058c,0x442dd2a5,0x61e552a6,0xeb970098}},	//   _मकर_, _mke_, _bohl, щия_,
   {{0x7c2d0102,0x69c1a73c,0x200d8c7b,0x237d81c5}},	//   _ekar, _jale, liei_, hawj_,
   {{0x69c1d2a7,0x442dba48,0x443f8135,0x7c9580f7}},	//   _male, _oke_, _ohu_, _العص,
   {{0x2fdf8eef,0x442db5b0,0x200d8012,0x69c1d2a8}},	//   njug_, _nke_, niei_, _lale,
   {{0xed168986,0xe61a0364,0x0d860056,0x38a180f7}},	// [4520] _نہیں_, гда_, йлан, hór_,
   {{0x442dd2a9,0x7bc090fe,0x69c1d2aa,0x443f8135}},	//   _ake_, _samu, _nale, _ahu_,
   {{0x315704de,0xa9bb007c,0x6458802a,0xe66281bc}},	//   _ליין_, _גזיר, _xuvi, _mọọb,
   {{0x6d5552ab,0x443f8b9d,0x037a8829,0x6aa2b399}},	//   _egza, _chu_, احات_, ttof,
   {{0x1db7864a,0x21788e11,0x7bc0838a,0x200d9b1f}},	//   _असंत, айлы_, _vamu, diei_,
   {{0x442d91d3,0x6aa2d2ac,0x27e04707,0xed5714bc}},	//   _eke_, rtof, ljin_, _гор_,
   {{0x6aa2d245,0x69c18ebf,0xf8c5816f,0x7bc0d2ad}},	//   stof, _dale, विषय, _tamu,
   {{0xb8d08665,0x74168c2a,0x27e02949,0x657e005d}},	//   _ओह_, _اورا, njin_, laph,
   {{0x64408364,0x69c1d2ae,0x6458d2af,0xa3d73ac3}},	//   _ihmi, _fale, _suvi, सास_,
   {{0x69c1d2b0,0xf1a98077,0x22f78039,0x628da4b2}},	//   _gale, _نامه_, _הזמן_, šaoc,
   {{0xa3bc835a,0x705684c1,0x62828079,0x11d781a8}},	//   _असा_, _انصا, lsoo, _دولة_,
   {{0x69c1d2b1,0x27e02003,0x61e552b2,0x200db296}},	//   _zale, jjin_, _sohl, ciei_,
   {{0x61e503fb,0x6578c282,0xa3ce090f,0x62829b98}},	//   _pohl, _tevh, राज_, nsoo,
   {{0x6458a824,0x6282826b,0x998301d0,0x27e0008e}},	//   _tuvi, isoo, rojů_, ejin_,
   {{0x16d10996,0xfc4a0104,0x37ab221f,0xdb160144}},	//   सम्ब, _tập_, лтан_, _vayá,
   {{0x27e00168,0x7c2d52b3,0x27e6d2b4,0x61e5529e}},	//   gjin_, _ukar, _joon_, _wohl,
   {{0x6d480a56,0x442b5275,0x63ad52b5,0x36d40aac}},	// [4530] _údaj, moc_, _iban, потр,
   {{0x443fb6ba,0x9b950077,0xd0470201,0x442dd2b6}},	//   _shu_, _الکت, _əmək, _ske_,
   {{0x2bdd03eb,0xe7c406ce,0x442d8101,0x443f8947}},	//   यापा, _लोकप, _pke_, _phu_,
   {{0x62829c11,0xb21b006a,0x69c1b3e1,0xeb909ef7}},	//   fsoo, præs, _sale, فظه_,
   {{0x69c1d2b7,0x63ad52b8,0x8aa79628,0x6282d2b9}},	//   _pale, _mban, сред, gsoo,
   {{0x7e6d451c,0x69c1b2bc,0xda78a1f6,0xa2ba80d4}},	//   mpap, _qale, сяц_, _एनर्,
   {{0x443fd2ba,0x200d802e,0x69c38456,0x80c08cf0}},	//   _thu_, tiei_, rdne, विगे,
   {{0x1665ad6b,0x442d80e8,0x63ad01bc,0x57e98b26}},	//   овим, _uke_, _nban, рдим_,
   {{0xa3bf1d01,0x7c2bc2af,0x69c1d2bb,0x27e6bbc3}},	//   ीयन_, mogr, _tale, _doon_,
   {{0x63ad44de,0x200d8c7b,0x69c1d2bc,0xac858811}},	//   _aban, siei_, _uale, огол,
   {{0xca48a684,0x04460c8e,0xab5b52bd,0x27e6867f}},	//   _الله_, женн, rdün, _foon_,
   {{0x38858029,0x7e6d3286,0xeb9a023f,0x2bcf8054}},	//   mēr_, kpap, шим_, _सोमा,
   {{0xe72e8cde,0xce6b9cd0,0x7cff8032,0x645e8036}},	//   _це_, _сред_, _báré, _épin,
   {{0x63ad52be,0x27e680f3,0x0dcb84ae,0x644881e8}},	//   _eban, _zoon_, _људи_, _èdiv,
   {{0x27e690e4,0x2a69011b,0x9c6580d7,0xdfd21ef7}},	//   _yoon_, _etab_, _بهبو, ويس_,
   {{0x628038b5,0x6b89b79d,0xb4d5d2bf,0x63ad19a8}},	//   ámos, _ndeg, समी_, _gban,
   {{0xa3d71b7e,0x7e6d1882,0x7c2b805c,0xe57a013a}},	// [4540] सार_, gpap, dogr, иза_,
   {{0x6440af9f,0x7bd6022c,0x0d861138,0x67f80061}},	//   _shmi, _hnyu, ілен, _díja,
   {{0x2eb68770,0xdddb82a5,0xb60780eb,0xd94640d9}},	//   _अन्त, kruž, mašī, _фени,
   {{0x926ab16c,0x2bdd0eb4,0xd36f80f7,0xdddb811f}},	//   арка_, याया, نهم_, jruž,
   {{0xdddb914d,0x7bc42e07,0x27e6d099,0x2bac364b}},	//   druž, _maiu, _roon_, ट्या,
   {{0x6282a1cf,0x6b89d2c0,0xc8c580d4,0xdce38b80}},	//   rsoo, _edeg, विंट, _lenđ,
   {{0x27e6d2c1,0x23ca01a2,0xfbca001b,0x2e2f0192}},	//   _poon_, ियाद, ियाम, rüft_,
   {{0x254e8201,0x657c52c2,0xeeaaa1f4,0x7bc402e8}},	//   vəl_, _herh, аток_, _naiu,
   {{0xdefa93cd,0x442b1100,0x645c3679,0xdde38087}},	//   рый_, voc_, _huri, ârşi,
   {{0x645c52c3,0x50d6806b,0x27e68cfa,0xd946917e}},	//   _kuri, _وزار, _woon_, _дези,
   {{0x26c9003b,0x27e6838e,0xa3d703b7,0xdb0f05e4}},	//   zvao_, _toon_, साल_, recí,
   {{0x645c52c4,0x7a3f80e7,0xab5d8372,0xb5fb128a}},	//   _muri, rête, _każa, _pták,
   {{0x2bdd000c,0x442b52c5,0x23dd016f,0x657c016d}},	//   याबा, roc_, याबद, _oerh,
   {{0x67fcd2c6,0x81d88264,0x645c03cd,0x7bd61896}},	//   _déje, াসক_, _ouri, _enyu,
   {{0x7c2bd2c7,0xba3d801b,0x957c8035,0xf65f006a}},	//   yogr, _způs, ając, _træk_,
   {{0xcb0b08cc,0x63ad52c8,0x6825809a,0x3e6086c0}},	//   _вход_, _uban, wódz, _kòt_,
   {{0x657c0393,0x645c52c9,0x81b38264,0x6ecd914f}},	// [4550] _berh, _auri, য়াত_, तियु,
   {{0x7c2b8247,0xdce18110,0xf2d200be,0x2bac0035}},	//   wogr, galė, _װעט_, ट्ठा,
   {{0x3e608205,0x69d72194,0x7e6d2c6a,0x40352481}},	//   _lòt_, _inxe, spap, _неос,
   {{0x6b9d1839,0xf3ff0073,0x645c52ca,0x69c552cb}},	//   ngsg, nhã_, _duri, _hahe,
   {{0xa3bc85e8,0x657c1286,0x216982d3,0x69c552cc}},	//   _असर_, _ferh, били_, _kahe,
   {{0x69c752cd,0x645c52ce,0xf1cb0a27,0x61e8d2cf}},	//   ndje, _furi, ायिन, _codl,
   {{0x29032442,0x758204c0,0x645c52d0,0x69c552d1}},	//   nzja_, _سینم, _guri, _mahe,
   {{0x69c552d2,0xb5fb001b,0xe7a68a75,0x765d00ee}},	//   _lahe, _stáh, क्लप, _kusy,
   {{0x645c3a4d,0x41cb2b62,0x06099e25,0x3e6082d6}},	//   _zuri, ायास, йник_, _còt_,
   {{0x645c52d3,0x2d811849,0x765d10e1,0xc33283c8}},	//   _yuri, nahe_, _musy, _טון_,
   {{0x645c52d4,0xc3290039,0x645e8036,0x00000000}},	//   _xuri, _עו_, _épil, --,
   {{0xe6720059,0x69d72c88,0x75f302d0,0xb5fb01a8}},	//   _ölçü, _anxe, _hızı, _dtái,
   {{0x69c50a5a,0x75f30214,0x765d00ee,0xc5f58081}},	//   _bahe, _kızı, _nusy, _някъ,
   {{0xcefd8059,0x7c27007a,0x216707b6,0xa9670abe}},	//   ığın_, čkra, зири_, зира_,
   {{0x69c502af,0x31af83bf,0xf7721ddd,0xa3bcd2d5}},	//   _dahe, mızı_, فاء_, _असल_,
   {{0x69d7184f,0xb8e40aed,0x645c0314,0x26cf8b80}},	//   _enxe, _एन_, _ruri, _krgo_,
   {{0xa3df901b,0x35d0800f,0x645c52d6,0x44200a2c}},	// [4560] तान_, _थोड़, _suri, _iji_,
   {{0x62860025,0x2c6183b0,0x31af85c5,0x3c3205b9}},	//   msko, _kód_, nızı_, rávu_,
   {{0x657c105d,0xd7bd853e,0x6fbd8b86,0xc1730051}},	//   _verh, ्याच, ्यां, _אחת_,
   {{0x2c61b38d,0xe363c7d4,0x26cf8118,0x5f070035}},	//   _mód_, екци, _orgo_, _सेक्_,
   {{0x6286007d,0x61e8a842,0x657c0855,0x44200010}},	//   nsko, _podl, _terh, _mji_,
   {{0x20120201,0x26c252d7,0x628652d8,0xb5fb016a}},	//   liyi_, _isko_, isko, _cuád,
   {{0x442052d9,0x645c0006,0x6286026c,0x777d0069}},	//   _oji_, _uuri, hsko, _yesx,
   {{0x442052da,0xab66981d,0x201252db,0x764380dd}},	//   _nji_, _хвал, niyi_, _ahny,
   {{0x62860025,0xb5fb00f7,0xfaa4804e,0x290301b9}},	//   jsko, _stái, _تجزی, zzja_,
   {{0x6286003b,0x720680d5,0x442052dc,0xa3da81ce}},	//   dsko, _عوام, _aji_, ़ाव_,
   {{0x43950972,0x2c6180f7,0xbebb0168,0x645652dd}},	//   манс, _cód_, _nxën, _biyi,
   {{0x64441009,0x67228069,0x6b82d2de,0x645605ee}},	//   _chii, _txoj, naog, _ciyi,
   {{0x62861309,0x644402a3,0x645652df,0x20120201}},	//   gsko, _dhii, _diyi, diyi_,
   {{0x4420082e,0x225986c0,0x6f04009a,0x44320c56}},	//   _eji_, _èske_, dzic, _eky_,
   {{0x69c50665,0xa3bc835a,0x26c2011e,0xa41c9a3b}},	//   _vahe, _असं_, _asko_, पचाप_,
   {{0x75378051,0x999e8110,0x2d9ea382,0x64561d19}},	//   _מאוד_, _kitų_, lgte_, _giyi,
   {{0x69c52a1f,0x656552e0,0x6b8d52e1,0xdb0880e7}},	// [4570] _tahe, tchh, _idag, _élèv,
   {{0x443913a0,0x2d9eae9d,0xddc40289,0x317e81ec}},	//   lls_, ngte_, tpiš, _netz_,
   {{0x645782ba,0x76553a9c,0x999e8110,0x271e80ff}},	//   _éxit, _vizy, _litų_, ịnh_,
   {{0x7a32013c,0xa3d3086a,0x44cc800d,0x20000087}},	//   sætt, _होम_, _mě_, chii_,
   {{0x443952e2,0xa3df93f5,0xddc4025b,0x2d8701ca}},	//   ils_, ताब_, spiš, ónes_,
   {{0xf77f0201,0x44391705,0x75f30085,0x3ea93ac8}},	//   _heç_, hls_, _qızı, mtat_,
   {{0x63b9809a,0xd90f8065,0x2fc682d5,0x44cc81d0}},	//   pewn, دیا_, _baog_, _ně_,
   {{0x2fc91384,0xa009990c,0x6b8d52e3,0x443952e4}},	//   ndag_, تقبل_, _ndag, jls_,
   {{0x3ea952e5,0xa3da809a,0xdcf88115,0x44391670}},	//   ntat_, ़ार_, _devč, dls_,
   {{0x644452e6,0xee368084,0x20124f89,0x645652e7}},	//   _shii, мны_, ziyi_, _siyi,
   {{0x6f04047f,0x7983d2e8,0x39408326,0x64562168}},	//   zzic, manw, ƙisa_, _piyi,
   {{0x442f805c,0x6286012b,0x2fc90a0f,0x3ea952e9}},	//   nog_, tsko, jdag_, ktat_,
   {{0xee2e97a1,0x3ea900f1,0xe5a58d70,0x6fda80d4}},	//   _ан_, jtat_, _жили, भारं,
   {{0x42550396,0x442fd11e,0x7d288019,0xd2520019}},	//   етст, hog_, épsé, ئنس_,
   {{0x442f803a,0xd9ff05b3,0x628603ab,0x645652ea}},	//   kog_, _उतरत_, ssko, _tiyi,
   {{0x6286003b,0x2fc92692,0x942605e9,0xdb160020}},	//   psko, gdag_, _імпе, _mayú,
   {{0xe7370364,0x442f831d,0xf41380c8,0x79838435}},	// [4580] дет_, dog_, িকার_, kanw,
   {{0x6f0452eb,0x200002a3,0x201252ec,0xfbc686a7}},	//   rzic, shii_, siyi_, _रोजम,
   {{0xdce18029,0xc486002e,0x6289826c,0xa3cf8424}},	//   dalī, флек, _aveo, _वोह_,
   {{0x442f8025,0xb4ae000f,0xab5d809a,0x7c650875}},	//   gog_, _कही_, _ważn, ءالل,
   {{0x3ea913df,0xaaba80b7,0x26c20ca1,0x2d9e8366}},	//   ctat_, تدار_, _usko_, ygte_,
   {{0xb5fb026f,0x7983d2ed,0xeb9f0257,0xbbca11be}},	//   _stáv, ganw, niør_, ियुक,
   {{0x442fbcef,0xada352ee,0x6da31860,0xe5a352ef}},	//   bog_, _шарл, _шира, _шири,
   {{0x442f80d7,0x232a942c,0xab5b0380,0xab2ad2f0}},	//   cog_, _доби_, rdük, _доба_,
   {{0x2bdd1880,0x79838870,0xfbdd1869,0x9f4902d0}},	//   यासा, banw, यासम, rkaç_,
   {{0x4439022b,0x67fcd2f1,0xdd908b8c,0xdb0f1243}},	//   wls_, _déja, دود_, lecç,
   {{0x5597010f,0x2fc901b0,0xdb0b9e7c,0x6b808135}},	//   ודיע_, ydag_, regå, _kemg,
   {{0x69caae6c,0x225f8573,0x63a40362,0x3ea91e1e}},	//   ldfe, _yuuk_, _ccin, ytat_,
   {{0xa3df853e,0x81b380c8,0xf7738051,0x65949b78}},	//   तात_, য়ার_, _סקס_, _залу,
   {{0x3f84bd8b,0x69c8d2f2,0xfd0f80d5,0x6d5c0077}},	//   lamu_, _jade, اجی_, _ngra,
   {{0x1958076a,0xa934054c,0xcec88028,0x442fd2f3}},	//   дары_, верш, _hộ_, yog_,
   {{0x765880f6,0x3ea952f4,0x3f84d2f5,0x69da833e}},	//   _hivy, ttat_, namu_, _lnte,
   {{0x442f803b,0x2fc91412,0x69dad2f6,0x63bd35aa}},	// [4590] vog_, rdag_, _onte, mesn,
   {{0x3ea952f7,0x69c89989,0xa3d32e2b,0x629d52f8}},	//   rtat_, _nade, _होत_, muso,
   {{0x3ea91602,0x3f849f62,0x628982a5,0x629d0461}},	//   stat_, kamu_, _sveo, luso,
   {{0x69da84f0,0x3ea952f9,0xf41f0009,0x60c552fa}},	//   _ante, ptat_, nnä_, _ishm,
   {{0x3f84a479,0x3e644424,0x644b8502,0xfc4a00ff}},	//   damu_, _göt_, rmgi, _cậy_,
   {{0x442fd2fb,0xa2d0064a,0xfc4a001c,0xe29c0039}},	//   sog_, दित्, _dậy_, קשור,
   {{0x205583bd,0x28c2946d,0x69c8d2fc,0x236085f5}},	//   нтир, _वैदि, _dade, žija_,
   {{0xcec88104,0xa2ba8f12,0x63bd02fd,0x4439d2fd}},	//   _bộ_, _शैक्, jesn, _ós_,
   {{0xef198c8e,0x7bdbd2fe,0x63bd12b9,0x15f31b7e}},	//   ями_, _inuu, desn, _आकार_,
   {{0x69c8d2ff,0x629d5300,0x645a023e,0x6b8081a9}},	//   _gade, duso, _ètic, _zemg,
   {{0x3f84b0a0,0x03a61617,0xc984817c,0xfc4a027d}},	//   bamu_, нино, _шути, _zậy_,
   {{0x9f4b0003,0x69c88419,0xc4d200be,0x629d106c}},	//   _você_, _zade, אגט_, fuso,
   {{0x765881c0,0x69da8286,0x539a81c6,0x501a83de}},	//   _fivy, _ynte, הירו, _צונו,
   {{0x80cc016f,0x6da59ddf,0xa3e4064a,0xe5a58b26}},	//   हिले, _чика, पॉज_, _чики,
   {{0x60264cfc,0xb4ae0b85,0x63bd0904,0xd8260abe}},	//   едва, _कहे_, besn, едви,
   {{0x6d43803a,0x6d5c5301,0x63a45302,0x2d85d303}},	//   _izna, _sgra, _ucin, lale_,
   {{0x7c242d10,0xa3bf0072,0x2bdd2b12,0x38550081}},	// [45a0] _ijir, ीयर_, यारा, търс,
   {{0x2d85867b,0xee370ff0,0x3f84d304,0x2bac03dd}},	//   nale_, ену_, zamu_, ट्रा,
   {{0x6d5c0353,0xdb060074,0x272180ff,0xdb0f0187}},	//   _vgra, hekü, ỳnh_, tecç,
   {{0x03269b47,0x69c8d305,0x2d85d306,0xb5fb001b}},	//   нден, _sade, hale_, _stát,
   {{0x69c8d307,0xc7b30039,0xba3b023e,0xdb0f041c}},	//   _pade, _גבר_, buïd, recç,
   {{0x6d5c003b,0xfc4a0028,0x2d8586ae,0xaefb0032}},	//   _ugra, _vậy_, jale_, _afùw,
   {{0x2d85d308,0x69c89384,0x3f84828d,0x15431073}},	//   dale_, _vade, tamu_, _берм,
   {{0x7c245309,0x3f820042,0x69c89579,0xf65f0366}},	//   _njir, _jeku_, _wade, _træt_,
   {{0x63bd246f,0x3f84d30a,0x2417812a,0xfe6f84c0}},	//   vesn, ramu_, _נחמן_, یدی_,
   {{0x69da834a,0x48e6b51e,0x3f848b3f,0x3f82530b}},	//   _unte, _позв, samu_, _leku_,
   {{0x29188006,0x29078063,0x63bd530c,0x3f848359}},	//   _ära_, czna_, tesn, pamu_,
   {{0x63a2d30d,0x3f82003a,0x629d530e,0x68f50110}},	//   ngon, _neku_, tuso, vyzd,
   {{0x1dd105e8,0x63bd4164,0x7f42836a,0x63a281e0}},	//   _सफलत, resn, _uzoq, igon,
   {{0x2d85d30f,0x63bd5310,0x7c240870,0x7d0680e7}},	//   cale_, sesn, _ejir, _céré,
   {{0x3f82085c,0x7d06c092,0x2c86846d,0x63bd5311}},	//   _beku_, _déré, _dídá_, pesn,
   {{0x7c240168,0x7e628d55,0x653b8039,0xdb1d03ed}},	//   _gjir, _kuop, _מעוד, nesë,
   {{0xa3da823c,0x6e940162,0x63a2d312,0x644f0326}},	// [45b0] ़ाई_, литу, dgon, mmci,
   {{0x63a2b88d,0x4df4004a,0x7c3d20db,0x7d068866}},	//   egon, ляєт, llsr, _géré,
   {{0xd3719368,0xb7d90065,0x41de06ab,0xd49b2700}},	//   لها_, _ہوگا_, मारस, яра_,
   {{0x63a2d313,0x2cb80b99,0x2d85d314,0x30af80ab}},	//   ggon, _dprd_, zale_, কিৎস,
   {{0x2d85d315,0x16bc942d,0x69dd800d,0x7bcb8106}},	//   yale_, ्टोब, पाली, rdgu,
   {{0xe1f88196,0x3f820bcf,0xa3dfa724,0xb5fb041c}},	//   нгі_, _zeku_, ताह_, _etár,
   {{0x9f40008b,0x3f825316,0x99838084,0x26c690ba}},	//   lkið_, _yeku_, _ųjų_, _asoo_,
   {{0xe8c185b3,0x2d85d317,0x7981d318,0x2907d319}},	//   _शनीच, wale_, _welw, rzna_,
   {{0x32558470,0x2d83531a,0x1e8281e5,0x6d4800f7}},	//   _авар, _keje_, алым, _údar,
   {{0x7c36531b,0x2d83137a,0x388c801b,0xa3df89c1}},	//   _skyr, _jeje_, běr_, ताव_,
   {{0x2d83531c,0xeb9a1c79,0xfbdd025a,0x4e958019}},	//   _meje_, мин_, यांम, رشکر,
   {{0x2d83531d,0x0f158009,0x88c000ab,0x785c00fe}},	//   _leje_, _имею, _উপলক, _očvr,
   {{0xa3b3873c,0x27e92766,0x3f82428e,0x64498cb5}},	//   ज्य_, djan_, _reku_, _mhei,
   {{0xb82380ab,0xaa460081,0x27e90144,0x2d8581f6}},	//   _পঠিত_, тегл, ejan_, qale_,
   {{0x6d43896a,0xdcfc531e,0xb7bd8162,0x505a0a41}},	//   _uzna, _perč, anţe, дшая_,
   {{0x2fcdcc2b,0x27e9531f,0x73ec80ab,0x2b5f8129}},	//   ndeg_, gjan_, _কষ্ট_, _nguc_,
   {{0x3eadd320,0x2d8319fb,0x9f4f8722,0x3f821df0}},	// [45c0] ntet_, _beje_, _algú_, _veku_,
   {{0x6b8401c6,0x601b0364,0x3ead82af,0x25f780d4}},	//   _heig, tämä, itet_, एसटी_,
   {{0x6449954c,0x26cf00f2,0x3f825321,0x6b840706}},	//   _bhei, ågor_, _teku_, _keig,
   {{0x6449d322,0x3eadd323,0xa3e503ca,0x6b8401e2}},	//   _chei, ktet_, नाय_, _jeig,
   {{0x64498c64,0xe7e591bc,0x67fc82be,0x2360807a}},	//   _dhei, काना_, _séjo, žijo_,
   {{0x6b845324,0xc33302f6,0x67f58019,0xb5fb0216}},	//   _leig, בוד_, _máju, _huán,
   {{0x64498068,0xfce30b88,0x3ea05325,0xa3e50fcc}},	//   _fhei, _коро, luit_, नाम_,
   {{0x6449925b,0x3ead920b,0x8c468009,0x765c00b4}},	//   _ghei, ftet_, _ребе, _hiry,
   {{0xa3df8128,0x3ea01699,0xa3dc0327,0x96348ae7}},	//   तार_, nuit_, ठाई_, лниц,
   {{0x25a7bf24,0x27e90372,0xa3da8ad5,0x20048168}},	//   _ccnl_, zjan_, ़ाक_, shmi_,
   {{0x6b8436dd,0xf1a9803d,0xd59b0039,0x659b0039}},	//   _beig, _ساله_, וביל, וייק,
   {{0xa806017b,0x7c22d326,0xd7ef80f7,0x765c479e}},	//   nlığ, nnor, _وكل_, _liry,
   {{0x51871132,0x5694a59a,0x6b841897,0xddc9d327}},	//   кува, _салт, _deig, speš,
   {{0x3ea003d3,0x7c2282af,0x5a340cb1,0x765c0a03}},	//   duit_, hnor, инят, _niry,
   {{0x27e946b8,0x925801e5,0xa80602d0,0x97a71444}},	//   tjan_, тарт_, klığ, крал,
   {{0xb5fb0693,0x23aa016f,0x28d3909b,0xf7730bbe}},	//   _cuán, _कायद, थिति, شار_,
   {{0x6449a06f,0x27e93b14,0x3ea05328,0x35b50568}},	// [45d0] _rhei, rjan_, guit_, лбар,
   {{0x6449cb38,0x6b8402af,0x9f40008b,0xfc3f01a8}},	//   _shei, _zeig, rkið_, llí_,
   {{0xa3df923a,0x290a009a,0x2baa016f,0x23aa000d}},	//   ताल_, czba_, _कामा, _कामद,
   {{0x7c22d329,0x3ea03f91,0x200c0722,0x3eadbc95}},	//   gnor, buit_, èdit_, ytet_,
   {{0xee8413cd,0x02a78e8e,0x3ea00162,0x2d830168}},	//   _высо, трем, cuit_, _teje_,
   {{0x785c011f,0x7d1580e1,0xb6da00be,0x27ef80e8}},	//   _učvr, úzsk, _אַלט, _sogn_,
   {{0x6449c35c,0x89d681a8,0xa3ab864a,0xdb040362}},	//   _thei, طوير_, _खाप_, _dbiù,
   {{0x3ead8f06,0xb4c12539,0x44d32bea,0x79850326}},	//   ttet_, ्टी_, _ić_, _lehw,
   {{0x2a64915c,0xdbdd007b,0xf1a78f75,0xfc3f01d0}},	//   _gumb_, _ráðs, _арен, dlí_,
   {{0x3ead91e6,0x41c086b7,0x6b84532a,0x7bdf3a16}},	//   rtet_, _एसएस, _seig, _anqu,
   {{0x3eadd32b,0xed5881ac,0x6b841009,0x25a5007b}},	//   stet_, teľa_, _peig, _öllu_,
   {{0xe29a2154,0x3eadae6c,0x4c9a03c8,0x657aa3f0}},	//   нам_, ptet_, עברו, abth,
   {{0x6b8411a9,0xfbaa000d,0xa3abd32c,0xa806007e}},	//   _veig, _काठम, _खान_, nlış,
   {{0x6e928013,0x5e9280f7,0xfb168158,0x64a5b73a}},	//   _الوا, _الوط, אַלט_, _бака,
   {{0x63a987f5,0xfc3f0013,0x6b840110,0x3e69801c}},	//   _ocen, blí_, _teig, _hút_,
   {{0x3ea0532d,0x765c0a07,0xfc3f01a8,0xe3b201a8}},	//   tuit_, _siry, clí_, _طرب_,
   {{0x66e300af,0xdee3067c,0x2fc0532e,0xab5d8372}},	// [45e0] бота, боти, reig_, _fażi,
   {{0xfdfc8996,0x3ea0532f,0xb4c11344,0x63a9b88f}},	//   एसएस_, ruit_, ्टू_, _acen,
   {{0x3ea00970,0x2a648748,0xa3df8894,0xb4de06ab}},	//   suit_, _sumb_, तां_, तमे_,
   {{0x9e6600f7,0x765c1bb5,0xa3da047d,0x289b03de}},	//   _ماسن, _wiry, _डोम_, _איטא,
   {{0xa3e55330,0xa8060059,0x7c228bcb,0x3e69801c}},	//   नात_, rlığ, rnor, _nút_,
   {{0xe9188084,0xddcd18ad,0xdd921c81,0xb5fb1075}},	//   колі_, rpaţ, _دوس_, _utáp,
   {{0x66031f3e,0xdb1d0065,0xab5b080a,0x67f580e1}},	//   _упра, resé, ndür, _nájs,
   {{0xa3d3000f,0xb4d0016f,0xa3df9acd,0x3e6980ff}},	//   _हों_, वटी_, ताः_, _bút_,
   {{0x8d868071,0x2d98802a,0x3e69827d,0xc326cf05}},	//   лунд, óreo_, _cút_, _смак,
   {{0x3207800d,0xb5fb01a8,0xb21b0366,0x6f1d8174}},	//   chny_, _nuál, nsæt, úsca,
   {{0x0ce280c8,0x2369803a,0x7bcd0bb6,0xddcd026c}},	//   মন্ত, žaje_, _paau, npaš,
   {{0xac1902c7,0xdb550009,0xdcfa80c3,0x7bc281c6}},	//   тому_, ивны, hatć, neou,
   {{0xa3d61094,0xb21b006a,0xdd9280d7,0xa8378e82}},	//   _सफर_, ksæt, _هوش_, _גראד_,
   {{0xc3338051,0xb5fb06a5,0xfc3f016b,0xa7fb02f9}},	//   מור_, _cuál, slí_, _miñe,
   {{0xb21b006a,0x3a3a008e,0xa7fb0118,0x2f7201bc}},	//   dsæt, _dkpp_, _liñe, _ọtọm,
   {{0xc864091c,0xd9048117,0x7bdf1c96,0xa2c5109b}},	//   стри, _ہی_, _unqu, िबद्,
   {{0xa3e8800f,0xdd9b1a19,0x44290091,0xa7fb0388}},	// [45f0] बान_, еше_, _ija_, _niñe,
   {{0x27338104,0x628f054a,0x27218028,0xd90489a7}},	//   ợng_, msco, ẳng_, _فی_,
   {{0x644d5331,0x628f00f7,0x27208fea,0xb4c10f0a}},	//   _khai, lsco, मपुर_, ्टे_,
   {{0x907a03c8,0xd9e30fd5,0x44291a14,0xa7fb02f9}},	//   _שטרי, खावत_, _jja_, _biñe,
   {{0x644d0068,0x661a8057,0x628f5332,0x44295333}},	//   _mhai, kitk, nsco, _mja_,
   {{0x3d19035a,0xa7fb04c3,0x4095938c,0x3e69801c}},	//   _येथे_, _diñe, арит, _rút_,
   {{0x44293af6,0xa3d601c4,0x69ad40f2,0x661ad334}},	//   _oja_, _सफल_, _जानी, ditk,
   {{0x44295335,0x7bc29c33,0xe739844f,0x660380e1}},	//   _nja_, ceou, кей_, _slnk,
   {{0x0ab88416,0x3d19016f,0x4fe68162,0x249135ca}},	//   _مطلب_, _येते_, рмын_, _hvzm_,
   {{0x442931ff,0x7c298bc5,0x0f5803c8,0xed598a9f}},	//   _aja_, _hjer, ניזם_, коп_,
   {{0x644d0af9,0xe005053f,0x9d45a8df,0x628f284c}},	//   _bhai, रसाद_, ренд, esco,
   {{0x69c39fcf,0x3f898125,0x6b8bd336,0x644d435c}},	//   lene, _þau_, nagg, _chai,
   {{0x7c29d337,0x644d4ba7,0xeb97287d,0x7c3b8010}},	//   _mjer, _dhai, шия_, _mkur,
   {{0x412a0c8e,0x44290549,0x69c3b20e,0x602181a9}},	//   вого_, _eja_, nene, dēmi,
   {{0x644d0c64,0x26cb0388,0x7c298216,0x2d8781e8}},	//   _fhai, _asco_, _ojer, _iene_,
   {{0x7c29d338,0xb8de02f1,0x69c3d339,0x644d0f58}},	//   _njer, _इह_, hene, _ghai,
   {{0x69c3d33a,0xb4de0f0f,0x2d87d33b,0x46a611a8}},	// [4600] kene, तम्_, _kene_, разв,
   {{0x7c3bd33c,0xdbdfa320,0xe5771541,0x7c29b7a3}},	//   _akur, _síðs, изу_, _ajer,
   {{0x2d87812b,0xb21b23a6,0x399b00be,0x7c29d33d}},	//   _mene_, rsæt, _בייד, _bjer,
   {{0xa7fb0feb,0x6b8bc577,0x27ff8279,0x61e19193}},	//   _piñe, gagg, jkun_, _anll,
   {{0x69c3d33e,0xe7fb05e8,0x27ed8b67,0xa3e88beb}},	//   fene, _एकता_, djen_, बाब_,
   {{0x200002a3,0xa3d30665,0x7c3bd33f,0xa7fb05e4}},	//   lkii_, _होई_, _ekur, _viñe,
   {{0xf8069878,0x7c298b40,0xf9930039,0x661a890c}},	//   ичин, _fjer, קרה_, vitk,
   {{0x44c80459,0x200002a3,0x61e1d340,0x7c29cd5a}},	//   _iş_, nkii_, _enll, _gjer,
   {{0xa3ab9d01,0x539b8051,0x2d87d341,0xa3cf800f}},	//   _खात_, _שימו, _bene_, _वोट_,
   {{0x2d87b931,0x64428364,0x644d4a28,0xe839801b}},	//   _cene_, lloi, _shai, ější,
   {{0x2dd9093f,0x644d2039,0xd5d90158,0x4426d342}},	//   אַרב, _phai, אַרש, ono_,
   {{0x4426d343,0xef1a80c4,0x20092928,0x92d880ab}},	//   nno_, _име_, xhai_, াহী_,
   {{0x4426c37b,0x200002a3,0x5457898a,0x661ad344}},	//   ino_, dkii_, יסטן_, pitk,
   {{0xa3e50105,0x628f5345,0x4426d346,0xedd384a3}},	//   नाह_, rsco, hno_, _ويند,
   {{0x644d2039,0x04948307,0x2d8cd347,0x20095348}},	//   _thai, _البح, made_, thai_,
   {{0x4426935a,0x2d8cd349,0x6f0d07e2,0x69c38fe0}},	//   jno_, lade_, tzac, zene,
   {{0x44268e3f,0x60d301e2,0x63ad534a,0xac07004e}},	// [4610] dno_, _žemė, _ican, _مذکو,
   {{0x2d8cd34b,0xa3e5123a,0x200901c5,0x69c3c8ef}},	//   nade_, नाव_, shai_, xene,
   {{0x6b8bd34c,0x2a6901e9,0x20000079,0x201e023e}},	//   tagg, _huab_, bkii_, ètic_,
   {{0x4439534d,0x4426d34e,0x69c3d34f,0x2d8c8d35}},	//   nos_, gno_, wene, hade_,
   {{0x7c29830b,0x2d8cd350,0xf2c78098,0x44391cef}},	//   _vjer, kade_, рсен, ios_,
   {{0x44395351,0x2d8cd0c4,0x2a6910af,0x89a8835f}},	//   hos_, jade_, _muab_, иків_,
   {{0x2d8c87e1,0x44391d69,0x7c2988cf,0x69c3d352}},	//   dade_, kos_, _tjer, rene,
   {{0x443929bb,0x442682a5,0x7c3bd353,0x7c29a486}},	//   jos_, cno_, _ukur, _ujer,
   {{0xee398abe,0x27ed86a4,0x63bb8397,0xa9c78698}},	//   лни_, rjen_, _ibun, _всек,
   {{0x2d8cbeac,0x2d8780f1,0x27ed84b1,0x7988a26f}},	//   gade_, _qene_, sjen_, _gedw,
   {{0x44395354,0x2d87d355,0x6b898074,0x27edc292}},	//   fos_, _vene_, _keeg, pjen_,
   {{0xc0b280ff,0x27ed8168,0x26c93a2f,0xdbd60032}},	//   _lưới_, qjen_, kwao_, _gùìs,
   {{0x2a6901c5,0x6b8983b2,0x63bbd356,0x1dc720d8}},	//   _cuab_, _meeg, _mbun, रजात,
   {{0x7f3a893f,0x49990364,0x2a6901e9,0x5d8580f7}},	//   _גענו, ится_, _duab_, _الثل,
   {{0x44395357,0x4426d358,0x63bb8a40,0x20005359}},	//   bos_, yno_, _obun, tkii_,
   {{0x44391313,0x6b89b630,0x6e3c0132,0xb4fa8039}},	//   cos_, _neeg, _skrb, _תפקי,
   {{0x200002c1,0x7bc6022e,0x7c399670,0x629201d6}},	// [4620] rkii_, meku, dowr, ýkoľ,
   {{0x7bc626b0,0x4426809a,0xc0b2801c,0xbd8a003d}},	//   leku, wno_, _cưới_, انان_,
   {{0xf8a59fbe,0xe0580077,0xc0b28028,0x78be1252}},	//   _تک_, _نیست_, _dưới_, _uppv,
   {{0x4426a6f9,0x44d7802e,0x7bc60074,0x2d8c89b2}},	//   uno_, _mă_, neku, zade_,
   {{0x6b8982a3,0xa91c8038,0x2ca58f67,0x2a69022c}},	//   _deeg, _veľm, huld_, _xuab_,
   {{0x4439535a,0xa2d902a8,0x3c320a56,0xfce63314}},	//   zos_, मित्, rávy_, _лого,
   {{0x7afd0d38,0xa3e8901b,0x4439535b,0x64a3229c}},	//   zyst, बाद_, yos_, _нара,
   {{0x44392be1,0x4fc68009,0x661e2b78,0xc7c6974f}},	//   xos_, сска, lipk, сски,
   {{0x2d8cd35c,0xdb1d0019,0x7e7b96fb,0x2d8a0300}},	//   tade_, tesí, gpup, _kebe_,
   {{0x63bb85f5,0x2737001c,0xa7fb01df,0x7afd0fe6}},	//   _zbun, ủng_, _miña, vyst,
   {{0x44392a70,0x44d78c6e,0xa7fb04c3,0x2d8a0133}},	//   tos_, _că_, _liña, _mebe_,
   {{0x7afd1405,0x2d8cd35d,0x7bc6004f,0xceb40085}},	//   tyst, sade_, geku, ktə_,
   {{0xa3ab89a3,0xa7fb05a4,0x2d8cd35e,0x2a69022c}},	//   _खास_, _niña, pade_, _quab_,
   {{0x7afd48e8,0x2d9c03a7,0xdb040118,0x2bd9116e}},	//   ryst, óvel_, _abió, _बोरा,
   {{0xa159535f,0x61fa0106,0x7bc603df,0x661e02f7}},	//   раву_, ötla, beku, dipk,
   {{0x2a690282,0xceb40085,0x3ea000ec,0x7bc65360}},	//   _tuab_, ftə_, frit_, ceku,
   {{0x60250110,0x6b898074,0xf41f0198,0x798e00b4}},	// [4630] nėmi, _reeg, miä_, babw,
   {{0x7c2d2496,0xd5674872,0x6b899bfc,0xf41f0009}},	//   _hjar, стап, _seeg, liä_,
   {{0x2d8a5361,0x386200b9,0x7c2d007b,0x69c75362}},	//   _debe_, _fikr_, _kjar, meje,
   {{0x3ea04848,0x69c70646,0xf41f0009,0x2911026c}},	//   brit_, leje, niä_, mzza_,
   {{0xdefb01bb,0x3ea007fc,0x78678061,0x6d4e81d6}},	//   _сын_, crit_, _műve, ýbaj,
   {{0x6b89d363,0x7bc62143,0x600a01ac,0x69d55364}},	//   _weeg, zeku, _výme, ndze,
   {{0xb5fb1dc1,0x2bd48076,0xe7e581fe,0xf41f0009}},	//   _otáz, _ठोका, काला_, kiä_,
   {{0x63bb9267,0xdd0e03bf,0xfaff00f1,0x2ca580f3}},	//   _ubun, lışa, ncës_, vuld_,
   {{0x44d78c6e,0x443fd365,0x442dd366,0x3f8b0b67}},	//   _să_, _iku_, _ije_, _mecu_,
   {{0xa1949285,0x7c2d059c,0x69c75367,0x69d524ad}},	//   _науч, _ajar, jeje, jdze,
   {{0x7c2d0a35,0x1ee78077,0x442d8353,0xfbc610f8}},	//   _bjar, _گوشی_, _kje_, обно,
   {{0x3f8b0052,0x44d7802e,0x2baa016f,0x7e7b9c50}},	//   _necu_, _vă_, _काळा, ppup,
   {{0x7bc6414b,0x69c70019,0x7c2d30a6,0x798e0f8e}},	//   reku, feje, _djar, tabw,
   {{0x7bc63553,0xc8ad9251,0xa3da0105,0x69c75368}},	//   seku, _टमाट, _डोर_, geje,
   {{0x443fd369,0x442dd36a,0x7bc62266,0x7c2d007b}},	//   _oku_, _oje_, peku, _fjar,
   {{0x442d922b,0xfc3207bd,0x1dac0063,0x3ea001f7}},	//   _nje_, _تحت_, _चाहत, trit_,
   {{0xe61a2cd1,0x3f8b3363,0xe7fb0665,0xc60500c8}},	// [4640] ада_, _decu_, _एकरा_, োচনা_,
   {{0x443f859c,0x442dd36b,0xe5a31afa,0xa7fb0e15}},	//   _aku_, _aje_, дифи, _viña,
   {{0xa91c8038,0x7e63d36c,0x246581a9,0x741300d7}},	//   _veľk, _minp, _tēmu_, _رویا,
   {{0x66e61285,0xdee61d32,0xa7fb04c3,0x3ea0536d}},	//   _дома, _доми, _tiña, prit_,
   {{0x2d8a02a5,0x442dd36e,0xa3ab999e,0xf773003d}},	//   _tebe_, _dje_, _खार_, _تاپ_,
   {{0x442dd36f,0x443fd370,0x6d43817b,0xddc2a7b1}},	//   _eje_, _eku_, _oyna, _stož,
   {{0x9d43171c,0x23aa016f,0xf1b2009a,0x41b20441}},	//   _жерд, _कांद, _जानन, _जानस,
   {{0x8ca385e8,0x3b868e8e,0x442dcd5a,0xdfda8081}},	//   _कमजो, _флаг, _gje_, рък_,
   {{0xc6f787ac,0x6b828542,0xf41f0009,0x6d4399d4}},	//   жных_, mbog, viä_, _ayna,
   {{0x6e289c33,0x7e6381c0,0xa2d900d4,0x6d43ca15}},	//   undb, _cinp, मिस्, _byna,
   {{0x6d4381e6,0xf41f0009,0x64748221,0x69c75371}},	//   _cyna, tiä_, ягну, veje,
   {{0x9f49008b,0x200dd372,0x69ad0072,0x7ee681a8}},	//   kkað_, chei_, _जाही, _وكان,
   {{0x934700f7,0x69c75373,0xf41f0198,0xe51a801b}},	//   تخدم, teje, riä_, _फेरि_,
   {{0xf41f0364,0x1fbc80ab,0x720500f7,0x7e638420}},	//   siä_, _অফিস, أوسم, _ginp,
   {{0x69c75374,0x29055375,0x6d438286,0x63ab98b6}},	//   reje, ála_, _gyna, yggn,
   {{0x7c2d0458,0x533517d4,0x99830110,0x69c75376}},	//   _ujar, _нейт, tojų_, seje,
   {{0x85569125,0x656d880a,0x70c6897d,0x356b046e}},	// [4650] _دیگر_, _şahi, लबुल, арен_,
   {{0x6440808e,0x41b206a7,0x2bb10d14,0x6b8d01a8}},	//   _akmi, _जायस, _झाडा, _heag,
   {{0x6b8d0458,0x2d810427,0x27e69210,0xdd0e22f8}},	//   _keag, rbhe_, _onon_, rışa,
   {{0x7c3d1639,0x6b8290ab,0x6458023e,0xf8e480c2}},	//   nosr, gbog, _èxit, _कपड़ा_,
   {{0x7f76012a,0x6b8d3a18,0x236982d4,0x442b5377}},	//   _מערב_, _meag, žajo_, inc_,
   {{0x3ea90057,0x7e6b81e2,0x6d58016b,0x2452016b}},	//   muat_, _rugp, ývac, máme_,
   {{0xc5f2036b,0x3ea90a26,0x7e63826b,0x47d480ab}},	//   _אדם_, luat_, _rinp, থানী,
   {{0xd3e3819f,0x443fc66e,0xa7fb01df,0x6b8d0087}},	//   _تقری, _uku_, _miño, _neag,
   {{0xb4e38a27,0x7e638091,0xa3e8923a,0xe619af92}},	//   नम्_, _pinp, बार_, йди_,
   {{0xee368009,0x443dd378,0xa3ab8fb2,0x201f8196}},	//   знь_, low_, _खाँ_, siui_,
   {{0xa7fb05b4,0x044605e9,0x2452016b,0x0ee80035}},	//   _niño, зенн, háme_, _ऐप्स_,
   {{0x7e639217,0x3ea90c8f,0x6d43828f,0x38978087}},	//   _winp, kuat_, _vyna, măr_,
   {{0xe72ed379,0x6d43809a,0xdb1d01df,0x6b8d01e4}},	//   _че_, _wyna, tesá, _deag,
   {{0x443dcc98,0x2452026f,0xbb3a80be,0xddc380eb}},	//   how_, dáme_, מערי, _minū,
   {{0xdb1d016b,0x6b8d5163,0x38978162,0x443dd37a}},	//   resá, _feag, năr_, kow_,
   {{0x6b9bb79d,0x27e6165f,0x4c9a8039,0xf1c7816b}},	//   _ndug, ñon_, _השקע, _hráč_,
   {{0xe7ec82f1,0xdfcf01a8,0x6fbd92c6,0x443d99c2}},	// [4660] झाता_, ديق_, व्यू, dow_,
   {{0x273a801c,0x6b9b846d,0x656902d0,0x9f49008b}},	//   ừng_, _adug, _şehr, rkað_,
   {{0x50461317,0x14c8003d,0x6b8d05ee,0x7d01839c}},	//   _необ, تهای_, _yeag, nyls,
   {{0x3ea90867,0x6aa2d37b,0x68e1006a,0x27f90b80}},	//   buat_, trof, ælde, _gosn_,
   {{0x7bd6537c,0x6b82c8ee,0x3f920b17,0x26c200b9}},	//   _mayu, rbog, mayu_, _upko_,
   {{0x3f921cbc,0x4422537d,0x7bd6537e,0xceb302f6}},	//   layu_, hik_, _layu, _איש_,
   {{0xa3ac2d05,0xa3cc0327,0xa3be0b9f,0x4422537f}},	//   खला_, रजा_, ीजा_, kik_,
   {{0x6aa2d380,0x44225381,0xaca4019d,0x443d9ba9}},	//   prof, jik_, _chụp, cow_,
   {{0x6b8d4fdc,0x44225382,0xfaa3cc3b,0x6e21874d}},	//   _reag, dik_, _пато, filb,
   {{0xddcb87d9,0x3f92059e,0x7bd6076d,0x4498804a}},	//   ğişt, hayu_, _aayu, овою_,
   {{0x61e8d383,0x4422133b,0x7bd62eae,0x6b8d02f1}},	//   _indl, fik_, _bayu, _peag,
   {{0x44225384,0x1016845b,0xa7fb0216,0x61fad385}},	//   gik_, _عباد, _riño, _hotl,
   {{0x7bd65386,0x3f9206cb,0x319f81a9,0x69ca800b}},	//   _dayu, dayu_, bāzē_, oefe,
   {{0x69d8d387,0xaa64038c,0xa7fb2511,0x2452001b}},	//   ndve, етск, _piño, váme_,
   {{0x6b8d154c,0x61fa837f,0x7c2b8114,0x443d81b4}},	//   _teag, _motl, yngr, yow_,
   {{0x44225388,0xb8e52cdd,0x3ea913f0,0x7bd6385b}},	//   cik_, _एह_, tuat_, _gayu,
   {{0x47340a7c,0x45d50162,0xdb1b807b,0x386680ee}},	// [4670] ентс, моас, _nauð, _mior_,
   {{0x443dd389,0xa3e509f2,0x2d8ed38a,0x2452016b}},	//   wow_, नाक_, _jefe_, ráme_,
   {{0x69cad38b,0x7c228b57,0xf9fc0039,0x7ae0d38c}},	//   defe, fior, _להזמ, _armt,
   {{0x7c228698,0x4ab11344,0x61e8b8c0,0x320c82f7}},	//   gior, _जमाव, _andl, _aldy_,
   {{0x3ea90722,0xe3b0936d,0xa3d512ee,0xf42a0009}},	//   quat_, ارم_, _सघन_, ltää_,
   {{0x44223550,0xe8190076,0x443dd38d,0x69cad38e}},	//   zik_, नोरा_, sow_, gefe,
   {{0x4422538f,0xf9909e13,0xf42a0009,0x7c22809a}},	//   yik_, ابه_, ntää_, bior,
   {{0x69d71045,0x7c22d390,0xddc28110,0x2d935391}},	//   _laxe, cior, _ruoš, laxe_,
   {{0x7bd600a4,0x3e72802e,0x442217ab,0x6e2195f8}},	//   _rayu, _cât_, vik_, tilb,
   {{0x7bd63368,0x2d9304c3,0x49bb8077,0x7bcbd392}},	//   _sayu, naxe_, _دارد_, legu,
   {{0x7bd60590,0x69c1ad81,0x3866851e,0x3f8480dd}},	//   _payu, _ible, _fior_, bbmu_,
   {{0x7bcbb11d,0xea01001c,0x6e21d393,0xe825803d}},	//   negu, _đạt_, silb, _غذای,
   {{0x44220cdb,0x2480803a,0xa3ab92ee,0x2d8e8915}},	//   rik_, _čime_, _खाई_, _fefe_,
   {{0x4422061b,0x7c22d394,0x7bcba21e,0xa06a16d9}},	//   sik_, zior, hegu, жава_,
   {{0x442203d2,0xd94302a4,0x69c1cb84,0x7e7d1482}},	//   pik_, вери, _mble, _atsp,
   {{0xdee60dd3,0x7bcbace3,0x7b070061,0xdb0987f1}},	//   моби, jegu, örté, _oceà,
   {{0x44205395,0x69c19234,0x69d71031,0x69ca9ccc}},	// [4680] _imi_, _oble, _faxe, yefe,
   {{0x2d8e81df,0x2d858247,0x44205396,0x69bf850a}},	//   _xefe_, nble_, _hmi_, ल्मी,
   {{0x2d85aeaa,0x442002d5,0x61fad397,0x136aa134}},	//   ible_, _kmi_, _rotl, ошли_,
   {{0xf7679301,0x7bcbd398,0x69c1d399,0x3f8fd39a}},	//   _لا_, gegu, _able, _negu_,
   {{0x7c22d271,0xab5b0352,0x44200744,0x2d930118}},	//   rior, rfüg, _mmi_, baxe_,
   {{0x7c22d39b,0xc5d506b5,0x2d858088,0x273e026b}},	//   sior, _пісь, jble_, _ẹnì_,
   {{0x442010ab,0x69cad39c,0x386683a7,0x69d8d39d}},	//   _omi_, refe, _pior_, rdve,
   {{0x69c1810c,0xa3ab8b75,0x4420046d,0xf8b30039}},	//   _eble, _खाए_, _nmi_, דשה_,
   {{0xf65f013c,0xdbdd026b,0x3f8f86a2,0x7c208706}},	//   _især_, _dáìs, _degu_, _immr,
   {{0x4420539e,0x6282d39f,0xf42a0198,0x6444373c}},	//   _ami_, mpoo, ytää_, _akii,
   {{0xf4be80c8,0xae1d8054,0xa3d280d4,0xd5e28032}},	//   েম্ব, योधन_, _वसा_, _awọ,
   {{0x2d9304c3,0xb5fb06a5,0x69d701b4,0x69c18af8}},	//   zaxe_, _juár, _saxe, _zble,
   {{0x27f7826f,0x442053a0,0x236d007a,0xfc3f01a8}},	//   žená_, _dmi_, žejo_, roí_,
   {{0x7e7db404,0x442053a1,0xf42a0364,0x3494b3d9}},	//   íspe, _emi_, ttää_, _закр,
   {{0x44202956,0xa3de8f97,0x7e6701ed,0x7bcb9267}},	//   _fmi_, तया_, _rijp, yegu,
   {{0x23dd835a,0x7a290267,0x26c68133,0xf42a0198}},	//   _नोंद, džte, _kpoo_, rtää_,
   {{0x2d930373,0x7bcbd3a2,0xf42a0009,0x7e6700f3}},	// [4690] taxe_, vegu, stää_, _pijp,
   {{0x7bcbd3a3,0xa2dd80c2,0x6d4753a4,0xdd9107c3}},	//   wegu, पिस्, _pyja, اوا_,
   {{0x7bcbce8a,0x2d930b6e,0x79950234,0x7d0d80fc}},	//   tegu, raxe_, mazw, _ƙasi,
   {{0x2d9304c3,0x6d4703f2,0x628480eb,0x79952647}},	//   saxe_, _vyja, ģion, lazw,
   {{0x823403f8,0x62848012,0xc2cb8077,0x6f16009a}},	//   _سریا, ţion, تبال_, czyc,
   {{0x7bcbd3a5,0xa2f98b85,0x2cac804a,0x624d8118}},	//   segu, ्नौज_, kudd_, cúol,
   {{0xab5b011c,0xd498259a,0xc8d80a27,0xa966d3a6}},	//   rdüy, _орт_, डिएट, ниша_,
   {{0x200901e2,0xdb0d002a,0xb5fb0216,0x764382d5}},	//   nkai_, _acaí, _guár, _skny,
   {{0x5a35ac38,0x9f590144,0x0e659617,0x7995308f}},	//   _знат, _bosé_, нкин, kazw,
   {{0x273e0142,0xac859b67,0x272c0104,0x442f8ec9}},	//   ững_, нгол, ếng_, lng_,
   {{0x442fd3a7,0x2d9153a8,0x3f8fd3a9,0x656d81cc}},	//   ong_, _meze_, _tegu_, _şahs,
   {{0xafdb013c,0x442fcd7b,0xfaa6014c,0x99878084}},	//   _skøn, nng_, намо, ponų_,
   {{0xe2972afb,0x442fd3aa,0xef0e92b2,0x200fd3ab}},	//   ная_, ing_, _см_, _ilgi_,
   {{0x645d53ac,0xd25208ca,0x442f81e0,0x2fcdd3ad}},	//   amsi, انس_, hng_, leeg_,
   {{0x3ead82f7,0x76418061,0x2fd91bad,0x7e6009c4}},	//   luet_, moly, _basg_, _èmpi,
   {{0xad1a8051,0x442053ae,0xdb1b802a,0x76418106}},	//   _מוצר, _umi_, _abuí, loly,
   {{0xddc601e2,0xe7370009,0x2a7f8282,0xcfd980ab}},	// [46a0] _aukš, еет_, _ntub_, থাপন,
   {{0x9f5904c3,0x7ae4011e,0x8c96021e,0x6e4608ca}},	//   _xosé_, _irit, ерді, رنام,
   {{0x2d911dbe,0x6f160063,0xe3bf01df,0xb0af01ce}},	//   _deze_, szyc, liña_, जूदग,
   {{0x69ce53af,0xe7df8996,0x69dc32f7,0x442f9400}},	//   lebe, _खोला_, ldre, gng_,
   {{0xd12f0077,0x76419e2b,0xe3bf03a8,0x2fcd9de6}},	//   _نمی_, koly, niña_, deeg_,
   {{0x442fd3b0,0x69dc0cf7,0x69ce11e6,0x4a9b007c}},	//   ang_, ndre, nebe, לינג,
   {{0x6282a432,0x69dc2cc4,0x03a691d0,0x442f82c4}},	//   spoo, idre, _пиво, bng_,
   {{0x7ae453b1,0x69ce53b2,0xd6d080f7,0x69dc0428}},	//   _orit, hebe, لقب_, hdre,
   {{0x61eb8065,0xcf268013,0x69ce23ba,0x27fdd3b3}},	//   állí, عربي, kebe, _down_,
   {{0x4426d3b4,0xa3e88b9f,0x7641d3b5,0xba3b13fc}},	//   lio_, बाक_, goly, nuït,
   {{0xd82f814c,0x7ae40102,0x69dc226d,0x5455066a}},	//   _бэ_, _arit, ddre, квот,
   {{0x1beb10c5,0x38ba80f1,0x8cb18035,0x2cac804a}},	//   टाइल_, mër_, _अमरो, rudd_,
   {{0x7ae433e1,0x69ce53b6,0x79950a5a,0x69dc0d35}},	//   _crit, febe, tazw, fdre,
   {{0x4426d3b7,0x7ae453b8,0x69ce53b9,0x69dad3ba}},	//   hio_, _drit, gebe, _jate,
   {{0x4426abd2,0x61fe0775,0x7ae435e2,0x2fc053bb}},	//   kio_, _dopl, _erit, ffig_,
   {{0x69dad00d,0x23698639,0x67d412d7,0x20090084}},	//   _late, žaji_, лосу, ukai_,
   {{0x4426aad1,0xe3bf04c3,0x7ae42827,0x23c10054}},	// [46b0] dio_, ciña_, _grit, ष्णद,
   {{0x69ce00a9,0xe45f00f2,0x442f831d,0x2009189e}},	//   cebe, lmö_, wng_, skai_,
   {{0x2d91003a,0x4426d3bc,0x2a7f9d29,0xdcf880eb}},	//   _veze_, fio_, _stub_, _ievē,
   {{0xf1d98e70,0x4426bf24,0x7ae40364,0xe7fb101e}},	//   _योजन, gio_, _yrit, _एकटा_,
   {{0x69daba27,0x3f8912b0,0x442f8359,0xa3b918b8}},	//   _bate, mbau_, rng_, _चान_,
   {{0x69da9b7d,0xc6920158,0x3ea953bd,0x442f86cb}},	//   _cate, _דאך_, mrat_, sng_,
   {{0x6b758fe7,0x6299b261,0x69da885e,0x27fd80ee}},	//   _албу, sswo, _date, _pown_,
   {{0x44269f90,0xf094007c,0x3f8901ec,0x3ea9023e}},	//   cio_, אנק_, nbau_, orat_,
   {{0x69dad3be,0x7bcf3724,0x5334d3bf,0x69dc2347}},	//   _fate, decu, _бетт, ydre,
   {{0x7ae4020f,0x2fcd81e9,0xe3bf01df,0x38ba8168}},	//   _rrit, seeg_, viña_, bër_,
   {{0x6d4a8355,0x7c260110,0xa2d58d1c,0x7641d3c0}},	//   _cyfa, tikr, _मैत्, roly,
   {{0x3ea93e6b,0xe29a1a1a,0x61fe20ce,0xab2a05e9}},	//   krat_, мам_, _sopl, дома_,
   {{0x69dab6ed,0x69ce53c1,0x7bdb820d,0xe784d3c2}},	//   _yate, tebe, _mauu, _сухо,
   {{0x4426d3c3,0x8c3d0459,0xe3bf04c3,0x7c262c60}},	//   zio_, duğu, riña_, sikr,
   {{0x69ce0542,0x7ae40051,0x290c026f,0x69dc48a3}},	//   rebe, _writ, áda_, rdre,
   {{0x69ce029b,0x44268b6e,0xea010028,0xa3b9000f}},	//   sebe, xio_, _đất_, _चाय_,
   {{0x61fe53c4,0xcf928158,0x7c2453c5,0x1f660a08}},	// [46c0] _topl, יטן_, _imir, ткам,
   {{0xee372466,0x44268114,0x9f590061,0x62860123}},	//   вну_, wio_, _alsó_, mpko,
   {{0x3ea953c6,0x4426d3c7,0x7c240267,0x69dad3c8}},	//   arat_, tio_, _kmir, _rate,
   {{0xdca353c9,0x3ea953ca,0x3e76013c,0x69da9d6f}},	//   раци, brat_, _tæt_, _sate,
   {{0x69da9247,0xc7b30bea,0x7c24082e,0x386053cb}},	//   _pate, _דבר_, _mmir, mmir_,
   {{0x38ba820f,0x4426d3cc,0xa158a2d0,0x38600085}},	//   tër_, sio_, налу_, lmir_,
   {{0xc2130051,0x69dad3cd,0x7bdb8362,0xed350162}},	//   שהו_, _vate, _fauu, _бэтэ,
   {{0xc7c68dbd,0x69dab593,0xf0930039,0x7d03016d}},	//   тски, _wate, בנה_, änse,
   {{0x8d868767,0x69dad3ce,0x09aa00ab,0x626687b6}},	//   кунд, _tate, খ্যা, _аваа,
   {{0x7c2453cf,0x38ba820f,0x5fae816f,0x602786c0}},	//   _amir, për_, _टाकल, _pèmè,
   {{0x2618800c,0xa8a58b76,0x43951fab,0x7ae2a351}},	//   योगी_, _مصنو, ланс, lvot,
   {{0xa3e883bb,0xd9f08076,0x6abd119b,0x442480b9}},	//   बाट_, चावत_, ttsf, _jmm_,
   {{0x9f590698,0x6d58016b,0x7bcf0162,0x7c2402a6}},	//   _così_, ývaj, recu, _dmir,
   {{0x7c240c56,0x7bcf3847,0x3ea9246d,0x6abd04e1}},	//   _emir, secu, vrat_, rtsf,
   {{0xb4d101ab,0xef19809a,0x4424822b,0x19940c07}},	//   _वने_, daży_, _omm_, рася,
   {{0xe3bf062f,0x3ea941a6,0x3d0e8075,0x6e288289}},	//   miño_, trat_, ानीं_, lidb,
   {{0x9f55395b,0x3ea953d0,0xe3bf01df,0x7ae2811f}},	// [46d0] увач, urat_, liño_, jvot,
   {{0x3ea953d1,0x80b880ab,0xa567004e,0x28ce02f1}},	//   rrat_, _আনন্, ندان, _हैकि,
   {{0x629d094c,0x3ea953d2,0xd371880b,0x7bdb82d5}},	//   lsso, srat_, مها_, _pauu,
   {{0x3ea953d3,0xfbdf041c,0x2d9c0118,0x7640008b}},	//   prat_, ndê_, óver_, _ímyn,
   {{0x629d21b7,0x59c00bc2,0xeabf01e8,0xe3bf0118}},	//   nsso, श्वर, ntù_, hiño_,
   {{0x26d900a9,0x2a6c80ee,0x6e2889d1,0x2fc682c4}},	//   _isso_, _cidb_, jidb, _abog_,
   {{0x04678a28,0x74f70061,0xfbab0264,0x9f4001fa}},	//   _атам, _جہاز_, গ্যত, ljið_,
   {{0x31580039,0x629d0bcb,0xe3bf2825,0xdb1d1277}},	//   כיון_, ksso, diño_, besø,
   {{0x2f548c8e,0x601580e1,0x98be8084,0x2907927a}},	//   итьс, _náme, _rytą_, syna_,
   {{0x7c24011f,0x8ca48128,0x3201026f,0x629d2f9c}},	//   _smir, _किशो, _nohy_, dsso,
   {{0x25e88d86,0xdb00d3d4,0x629d1388,0x386053d5}},	//   जाजी_, _admè, esso, ymir_,
   {{0x629d251d,0x26d91a47,0xdd4103f7,0x6e95841c}},	//   fsso, _osso_, _aŋŋa, _биду,
   {{0x2bc5835a,0x645b9a29,0x8f9a8039,0xd90f8065}},	//   ळ्या, _mhui, _ניסי, _دیں_,
   {{0x2fc6803b,0x9f5907f1,0xad2481f9,0xddc38493}},	//   _zbog_, _cosí_, اریو, _dinţ,
   {{0xf6528051,0x07a605d3,0x2fdd81e9,0xe3bf01df}},	//   _הצג_, лавн, _kawg_, ciño_,
   {{0x27ef808e,0x2fdf8122,0x629d0bcb,0x62864503}},	//   _jngn_, ndug_, bsso, ppko,
   {{0x823603f8,0x6f09d3d6,0x63a453d7,0x60158144}},	// [46e0] _مردا, nyec, _idin, _gáme,
   {{0x644653d8,0x645b819d,0xdcfc01a1,0xa37b041c}},	//   loki, _ahui, _serđ, rdõe,
   {{0x6b9653d9,0x645b925b,0x6015826f,0x26d90081}},	//   _keyg, _bhui, _záme, _esso_,
   {{0x645b9523,0x0ecf000f,0xdb19809a,0x69de53da}},	//   _chui, _सैकड, jewó, _hape,
   {{0x645b8ad0,0x244e827f,0x69c38252,0x141781a8}},	//   _dhui, nými_, ffne, دينة_,
   {{0x200200dd,0x27e053db,0x69de4f15,0xa3e491bc}},	//   _hoki_, ldin_, _jape, _भोर_,
   {{0xa3e405b3,0x69de53dc,0xed572481,0x644653dd}},	//   नया_, _mape, _бор_, koki,
   {{0x27e053de,0xb8cc81b6,0x69de53df,0x8c469c79}},	//   ndin_, _कट_, _lape, _себе,
   {{0x26c00114,0x644606a2,0x27ef89da,0x60e08110}},	//   ntio_, doki, _dngn_, _žymė,
   {{0x63a453e0,0xe3bf29c8,0x2d9a53e1,0x60158c83}},	//   _adin, tiño_, nape_, _cámb,
   {{0x85f70158,0x6e28d3e2,0x3d0e8035,0x1dc609c2}},	//   אציע_, ridb, ानें_, र्यत,
   {{0xe3bf0feb,0x64460102,0x629d2310,0x6e288503}},	//   riño_, goki, tsso, sidb,
   {{0x27e053e3,0xe60f8077,0x34d100bc,0x2d9a009e}},	//   ddin_, زشی_, _सन्द, kape_,
   {{0x629d21b7,0xeabf047f,0x628401a8,0x2fdd81c0}},	//   rsso, rtù_, _dtio, _zawg_,
   {{0x69de0072,0x200253e4,0x2fdd81c5,0x7d7b83de}},	//   _dape, _boki_, _yawg_, _אנוו,
   {{0x6c8380f7,0x6015802a,0xf7730250,0xa2ad0072}},	//   _اليم, _táme, صار_, _जिप्,
   {{0xc05801e5,0x200253e5,0x442b53e6,0xa3cb00d4}},	// [46f0] уір_, _doki_, mic_, _रॉय_,
   {{0x442b53e7,0x6449c0de,0x645b808c,0x60da82f1}},	//   lic_, _skei, _shui, _ostm,
   {{0x5c0785e9,0xdcf500eb,0x2002039c,0x6f1b80e5}},	//   ляда, _iezī, _foki_, zzuc,
   {{0xd5642bd9,0x69de0942,0x7bdf16dc,0x1e01816f}},	//   ступ, _zape, _jaqu, _लक्ष_,
   {{0x26c053e8,0xfaa78425,0x68e88114,0x2fdd81c0}},	//   ctio_, ушен, _ardd, _rawg_,
   {{0x442b1c33,0x7bdf00e7,0x20022944,0x7c973026}},	//   hic_, _laqu, _zoki_, _مشرا,
   {{0x645bd3e9,0x20020176,0x6ce400e8,0x2fdd81c5}},	//   _thui, _yoki_, _літе, _pawg_,
   {{0x7bdf0548,0x442b1f27,0x2fdd81c0,0xa92804e8}},	//   _naqu, jic_, _qawg_, loží,
   {{0x442b53ea,0xf1a78a29,0xcdf581bb,0xddcb80eb}},	//   dic_, _брен, ачны, _augš,
   {{0x7c2bd3eb,0x3ebfd23a,0x7ae98091,0x244e803e}},	//   ligr, rtut_, _iret, vými_,
   {{0x69de1495,0x64462a1a,0x442b0927,0x62842cb9}},	//   _rape, toki, fic_, _stio,
   {{0x69de53ec,0x8c460dbd,0x0446197b,0x442b1b9f}},	//   _sape, реме, ремн, gic_,
   {{0x7bdf0548,0x200253ed,0x63a48174,0x32181075}},	//   _daqu, _roki_, óini, thry_,
   {{0xc332804c,0x200253ee,0x3ead8bbd,0x244e9d9a}},	//   קום_, _soki_, mret_, rými_,
   {{0x69de53ef,0x2d9a05f3,0x245c816b,0x7c2b8122}},	//   _vape, vape_, líme_, kigr,
   {{0x63a453f0,0x69de0c85,0x6ca4804e,0x6d4e0690}},	//   _udin, _wape, _اصول, _ryba,
   {{0x27e053f1,0xa0671289,0xdce18182,0x18672dea}},	// [4700] rdin_, рата_, malı, рати_,
   {{0x66038364,0xe6172d0b,0x26c050fb,0xe5a60012}},	//   _jonk, аду_, rtio_, рижи,
   {{0xeb9a93f1,0x7ae9d3f2,0x2d9a53f3,0x200253f4}},	//   вие_, _aret, rape_, _toki_,
   {{0xa2ad01c4,0x6d4e027f,0x7ae98625,0x7d03016d}},	//   _जिम्, _vyba, _bret, änsa,
   {{0x245902be,0x60180019,0x3ead806a,0x60da80b9}},	//   néma_, _címe, jret_, _sstm,
   {{0x7ae9d340,0x5bd3123a,0x245c9c18,0x3ead8f06}},	//   _dret, _तस्व, díme_, dret_,
   {{0x64a31957,0x8ccd005e,0x7ae9d3f5,0x05c6016f}},	//   _мара, _सहयो, _eret, र्णब,
   {{0x8c438676,0x2d9800f8,0x442b02e6,0x7ae9d3f6}},	//   _десе, _here_, xic_, _fret,
   {{0x2d9853f7,0x6603805d,0x7bdf16dc,0x3ead8687}},	//   _kere_, _bonk, _raqu, gret_,
   {{0x59b206a7,0xa3b901ce,0x9a6a8872,0x2d98275b}},	//   _जागर, _चाह_, _شمال_, _jere_,
   {{0x2d9853f8,0x442b1b9f,0x660380c9,0xa17b83c8}},	//   _mere_, tic_, _donk, _סטאט,
   {{0x2d981741,0x3ea053f9,0x245c816b,0x3eadd3fa}},	//   _lere_, ksit_, bíme_, bret_,
   {{0x3ead8e22,0x6603d3fb,0x799c031d,0x60180118}},	//   cret_, _fonk, farw, _oímb,
   {{0x442b53fc,0x2d9853fd,0x3f8216ea,0x799c53fe}},	//   sic_, _nere_, _afku_, garw,
   {{0x442b53ff,0x6d5880eb,0x3ea000f1,0x76489106}},	//   pic_, _uzva, esit_, mody,
   {{0x34fb8bea,0x6603805d,0x2d985400,0x20d8801c}},	//   _יהוד, _zonk, _aere_, _mũi_,
   {{0x2d98149f,0x799c023b,0x6603805d,0x7c2b96f2}},	// [4710] _bere_, barw, _yonk, vigr,
   {{0x7ae9820f,0x27338104,0x2d98002e,0xb8dd00ab}},	//   _rret, ảng_, _cere_, _ইন_,
   {{0x7ae9a3e3,0x69d55401,0x2d985402,0x245c801b}},	//   _sret, meze, _dere_, zíme_,
   {{0x69d55403,0x25fb2261,0x3eadc155,0x37ac80ab}},	//   leze, लॉजी_, yret_, ক্তর,
   {{0x44290a2c,0xf1ec023c,0x2d98434d,0x3ea00019}},	//   _mma_, _छोड़_, _fere_, csit_,
   {{0x2d983b07,0x2ba78028,0x409582a4,0x245c826f}},	//   _gere_, ốc_, брит, víme_,
   {{0x442932f4,0xb7bd802e,0x3f990da8,0x9f4b01ca}},	//   _oma_, liţi, _kesu_, _tocó_,
   {{0x01381a0f,0x3f995404,0x2d815405,0x44290135}},	//   ירות_, _jesu_, lche_, _nma_,
   {{0x69d55406,0x7c298a54,0x6015840e,0x7ae9a4fc}},	//   keze, _imer, _cáma, _uret,
   {{0x44295407,0x2d815408,0xe6169adb,0x644d5409}},	//   _ama_, nche_, йды_, _akai,
   {{0x2d813cde,0xeb9a2482,0x61e1d40a,0x660380e1}},	//   iche_, лин_, _iall, _vonk,
   {{0x61e1b2c7,0x3f9921b8,0x6603805d,0x6b9d1aa8}},	//   _hall, _nesu_, _wonk, gasg,
   {{0x61e1d40b,0x7c299292,0x799c04b9,0x8e85d40c}},	//   _kall, _mmer, tarw, _угле,
   {{0x4429540d,0x644d0102,0x27ff81b9,0x661a8f67}},	//   _ema_, _ekai, ljun_, chtk,
   {{0x2d98540e,0x7c29af9f,0xfbdf03a7,0x799c540f}},	//   _rere_, _omer, glês_, rarw,
   {{0x61e184b9,0x2d985410,0x3ea01743,0x3205802a}},	//   _lall, _sere_, tsit_, _loly_,
   {{0x2d985411,0x69d55412,0xee3a0d9d,0x6b845413}},	// [4720] _pere_, beze, гна_, _ifig,
   {{0x82360077,0xc333010f,0x3ea05414,0x9f404a96}},	//   _دربا, _מוח_, rsit_, ndié_,
   {{0xd91009d7,0x44290355,0x2d98021e,0x3ea05415}},	//   _غیر_, _yma_, _vere_, ssit_,
   {{0x2d985416,0xa3cb0327,0xeb9a8591,0x3ea05417}},	//   _were_, र्प_, اضات_, psit_,
   {{0x7c3bd418,0x2d985419,0x6a6002af,0xdcfa81a9}},	//   _djur, _tere_, röff, tatī,
   {{0x2d810081,0x61e1d41a,0x7c29d41b,0x27e20326}},	//   cche_, _call, _emer, _hakn_,
   {{0x3f993433,0xa3b9146d,0x61e19140,0x845a97c8}},	//   _yesu_, _चाल_, _dall, _брат_,
   {{0x6c3684e3,0x61e18219,0x7c3b8168,0x68e100ec}},	//   _افرا, _eall, _gjur, ældi,
   {{0x628004c3,0xa3cb3b04,0x69d50019,0x7de68071}},	//   ímol, र्फ_, yeze, бінд,
   {{0x645f0b18,0x644d1d4c,0xa3cb04c5,0x2d98d41c}},	//   _shqi, _skai, र्न_, úre_,
   {{0x764881e2,0xb7bd802e,0x69d50019,0xf8ac8105}},	//   rody, ziţi, veze, _घटिय,
   {{0x69d53979,0x61e1d41d,0xdb04002a,0x25a78118}},	//   weze, _zall, _aciñ, _ednl_,
   {{0x69d533bc,0x4429541e,0x61e18326,0x6d5c00b9}},	//   teze, _vma_, _yall, _lzra,
   {{0x98dc83eb,0xf8dc83a4,0x61e1d41f,0x6b8402df}},	//   _मनाए, _मनाय, _xall, _efig,
   {{0x95838063,0x69d55420,0x5d9b8039,0x2d9ea0a5}},	//   łącz, reze, _גבוה, mate_,
   {{0x44295421,0xb90112ee,0x69d55422,0xdb008118}},	//   _uma_, _धन_, seze, _admí,
   {{0x200690f4,0x44395423,0x69d50fe0,0xd6d70264}},	// [4730] _mooi_, mns_, peze, সম্প,
   {{0x44395424,0x7c2995d8,0xdb0402af,0x799a967c}},	//   lns_, _smer, _heiß, _netw,
   {{0x2d8105ed,0x4439368b,0x2264001b,0x9379846e}},	//   rche_, ons_, řské_, абет_,
   {{0x44395425,0x2d811736,0x61e185a3,0x7c2f002a}},	//   nns_, sche_, _sall, nicr,
   {{0xa3cb00d4,0x81e280c8,0x799a8051,0x44395426}},	//   र्य_, ধান_, _betw, ins_,
   {{0x2d9ed427,0x61e19953,0x7aed4ef1,0x20898081}},	//   jate_, _qall, _mrat, айки_,
   {{0xf8a98077,0x61e1a05a,0xb4c78006,0x799a83ec}},	//   شگاه_, _vall, _उहे_, _detw,
   {{0xa3cb00d4,0x7c29bf21,0x6b828081,0x20c1818d}},	//   र्म_, _umer, ccog, rói_,
   {{0x61e1d428,0xd5c6000c,0x442f9451,0xa3dd0b9f}},	//   _tall, र्वज, mig_, ड़न_,
   {{0x442fd429,0xdce508c5,0xf993830f,0xfc40016b}},	//   lig_, lahı, _ربط_, čím_,
   {{0x7aed542a,0x63a48125,0x6d468214,0xa3cb0cf0}},	//   _arat, ðing, şkan, र्भ_,
   {{0x7aed542b,0x442f843c,0xd7e48221,0x6b9b838e}},	//   _brat, nig_, _нічо, _jeug,
   {{0xab5b01ec,0x9346373a,0x29050106,0x2d9ed42c}},	//   nfüh, інге, älan_, bate_,
   {{0x2d9ed42d,0xca7a810f,0xe81c000c,0x6b9b8014}},	//   cate_, ינשט, नसभा_, _leug,
   {{0xa3b99d01,0x442f8747,0x63a9a5dd,0x5fddc970}},	//   चला_, kig_, _oden, _मसाल,
   {{0x63a9d42e,0x6b9b85f3,0x7aed1b82,0x601583a2}},	//   _nden, _neug, _frat, _mámo,
   {{0x442fd42f,0x562a283b,0x644b8114,0xaa7b016b}},	// [4740] dig_, ажам_, dogi, jvýh,
   {{0x6607026c,0x7e560221,0x237f01d6,0xdd1c01d6}},	//   _cojk, ітац, ľuje_, ráža,
   {{0x442fd430,0x237f1ee0,0x16000540,0x6b9bd431}},	//   fig_, žuje_, लॉगर_, _beug,
   {{0x2d9ed432,0x442fd433,0xab5b0799,0x6aa2c3e1}},	//   zate_, gig_, ffüh, tsof,
   {{0x2d9ec71f,0x200681b0,0x6aa80105,0x63a9aaf1}},	//   yate_, _rooi_, _कटोर, _dden,
   {{0xaab2023c,0x6b82957a,0x6aa2d434,0x660701dd}},	//   _जिनक, scog, rsof, _gojk,
   {{0xa3cb0a3a,0x442f849f,0x6b9ba483,0x2d9ed435}},	//   र्ड_, big_, _feug, vate_,
   {{0x63a4808b,0x644bd436,0x442fa467,0x6015b8b5}},	//   ðind, cogi, cig_, _dámo,
   {{0x2d9eb499,0x601c8019,0x41ca052a,0x4439006a}},	//   tate_, _néme, िभास, vns_,
   {{0x70f6990c,0x44392b02,0x63a9936f,0x200680b9}},	//   _وسائ, wns_, _zden, _wooi_,
   {{0x7d7b0039,0xd7fa8d8e,0x7aed051e,0x69d888e0}},	//   יניו, _вул_, _srat, meve,
   {{0x2d9ed437,0x44394aac,0xd7ef80f7,0x24590118}},	//   sate_, uns_, _لكم_, rémo_,
   {{0x78758110,0x106980f7,0x47369459,0x44390cf7}},	//   _išva, _احلى_, _براز, rns_,
   {{0x442f8a0f,0x644bd438,0xdb0401ec,0x3ea6826c}},	//   zig_, zogi, _weiß, _ivot_,
   {{0xcf9b0fbb,0x69c307d9,0x442fd439,0x6018007b}},	//   ија_, _önem, yig_, _síma,
   {{0x69d8bffb,0x2ee9826c,0x442fd43a,0x2d9c8163}},	//   heve, _šafi_, xig_, _heve_,
   {{0xa3cb0b6f,0x7aed543b,0x7c2d0a5a,0x6607543c}},	// [4750] र्ण_, _urat, _imar, _pojk,
   {{0x69d88988,0x442fd43d,0x63bd543e,0x2fc9183d}},	//   jeve, wig_, lgsn, sfag_,
   {{0x442f8c1b,0x69d89b2a,0x7c2d0295,0x628f474f}},	//   tig_, deve, _kmar, lpco,
   {{0x2d9cd43f,0x60180125,0x3eb2068f,0x601c887a}},	//   _leve_, _tíma, bryt_, _lémb,
   {{0x442f92af,0x38690687,0x61e5005d,0x7c2d5440}},	//   rig_, mmar_, _kahl, _mmar,
   {{0x69d8c7a5,0x442fc389,0x2d9c8e6c,0xaca301bc}},	//   geve, sig_, _neve_, _ahụa,
   {{0x442fadf3,0xb8820ed7,0xe4a40e97,0x7c2d5441}},	//   pig_, žíva, _орто, _omar,
   {{0x38695442,0x63a9813c,0xb8d383db,0x97d980e8}},	//   nmar_, _uden, _झट_, ську_,
   {{0x442dd443,0x443f8135,0x38695444,0x2d9c80e5}},	//   _ime_, _iju_, imar_, _beve_,
   {{0x7c2d5445,0x61e5003e,0x8c0800c8,0x69d8d446}},	//   _amar, _nahl, _লগইন_, ceve,
   {{0x2d9c98a0,0x442d82c4,0x443f81a1,0x7e755447}},	//   _deve_, _kme_, _kju_, _mizp,
   {{0xca29004c,0x38690088,0x63bd0711,0x88838019}},	//   _גם_, jmar_, ggsn, _ٹیکن,
   {{0x442dd448,0x7e7d5449,0x61e50234,0x5ed300ab}},	//   _mme_, _nusp, _bahl, সিডে,
   {{0x7e688122,0x60338493,0x61e517c9,0xbfa107b6}},	//   cmdp, rămu, _cahl, ãªnc,
   {{0xfe708288,0x442dd44a,0x443f90ab,0x7e7d544b}},	//   _شده_, _ome_, _oju_, _ausp,
   {{0x7e7d0088,0x0686373a,0x7e75544c,0xbb460110}},	//   _busp, зган, _aizp, _нейк,
   {{0x7e7d0083,0xd007433d,0x441b007c,0x69d8b14f}},	// [4760] _cusp, чете_, _לוקס, yeve,
   {{0xa3e4acdd,0x442dd44d,0x443f8d62,0x9f42001b}},	//   _भोज_, _ame_, _aju_, _jaké_,
   {{0x7c2d0114,0xdcfc00eb,0x442dd44e,0xb33b041c}},	//   _ymar, _ierī, _bme_, maça,
   {{0x61e5544f,0xb33b5450,0x69d88039,0xe4529a37}},	//   _zahl, laça, weve, رضا_,
   {{0xcfc380c8,0x201f804f,0xfbc104c5,0x2bc101cb}},	//   ্যান, dhui_, ष्टम, ष्टा,
   {{0x442d8a2c,0x64a60221,0x443fd451,0xb33b1b01}},	//   _eme_, _нага, _eju_, naça,
   {{0x69d883ba,0x2d9ca1bf,0x67245452,0x7bd98c4d}},	//   reve, _reve_, lzij, bewu,
   {{0xa2ad2a18,0x69d8aeae,0xd01080f7,0x6011108c}},	//   _जिल्, seve, ئلة_, _påmi,
   {{0xc6f787ac,0x5eca00ab,0x63a29fb7,0xba3d801b}},	//   зных_, রিকে, maon, _kvůl,
   {{0x1dcf0c78,0xab5b1209,0x6018016a,0x63a2d453}},	//   स्पत, ngüe, _oímo, laon,
   {{0x386900fc,0xa3cb0006,0x442dd454,0x9f4701d0}},	//   ymar_, _रउआ_, _yme_, ěné_,
   {{0x63a28d4c,0x25a101ec,0x61e55455,0xbb940198}},	//   naon, zahl_, _sahl, нающ,
   {{0x61e51295,0x2d9c8073,0x601cd456,0xc905064a}},	//   _pahl, _teve_, _témb, रह्म_,
   {{0x27e681a8,0x2600104f,0x63a29b88,0x7e7d5457}},	//   _haon_, राफी_, haon, _rusp,
   {{0x2600090f,0x63a2d458,0x799e06c4,0x3d2288f9}},	//   रानी_, kaon, _depw, _déwé_,
   {{0x61e55459,0x7c2d545a,0x63a2d45b,0x25a10192}},	//   _wahl, _umar, jaon, wahl_,
   {{0x644f11b9,0xdce882bb,0x63ad545c,0xf77f26e1}},	// [4770] moci, madı, _idan, _caça_,
   {{0x442d8038,0xdce883bf,0x443f8b64,0x628d0c53}},	//   _sme_, ladı, _sju_, _itao,
   {{0xf65016a5,0x443f808e,0xb88301d0,0x7c3d1647}},	//   ائق_, _pju_, říbr, onsr,
   {{0x644f545d,0xf77f0073,0xd3719368,0x63a2d45e}},	//   noci, _faça_, نها_, gaon,
   {{0x27e9545f,0x443f8088,0x91e5b7bf,0x9f4b02df}},	//   mdan_, _vju_, доле, _cocô_,
   {{0x2d850006,0x27e90b0b,0x200b00e1,0xdb1d0106}},	//   _üle_, ldan_, _hoci_, besö,
   {{0xa3dd101b,0x94d40dc0,0x200b23ac,0x2489826c}},	//   ड़ा_, _порц, _koci_, _čamo_,
   {{0x27e902fa,0x63ad3202,0x442dd460,0xd0f80039}},	//   ndan_, _ndan, _ume_, למות_,
   {{0x26c92b5c,0x200b5461,0xdce887c0,0x627980e1}},	//   ntao_, _moci_, dadı, _dňoc,
   {{0x63ad0d53,0x27e90046,0xa3cb2303,0x7b7481a8}},	//   _adan, hdan_, र्स_, _أطفا,
   {{0x1dcf000c,0x044611d2,0x672401b9,0x628d545b}},	//   स्यत, денн, zzij, _atao,
   {{0x200b07df,0x3f1595f7,0x629b81bc,0x443d8114}},	//   _noci_, _одес, _kwuo, nnw_,
   {{0x9f42000d,0x0cba0bb8,0xe72e9f6e,0x27e95462}},	//   _také_, _उम्म, _ре_, ddan_,
   {{0xf77f383c,0x6724026c,0x628d01a8,0x1dcf052a}},	//   _raça_, vzij, _dtao, स्मत,
   {{0x63a2d463,0x200b5464,0xb33b383c,0x6b89823e}},	//   yaon, _boci_, raça, _ofeg,
   {{0x27e923da,0x6f168063,0x644f0baf,0x998d0668}},	//   gdan_, _życi, coci, đeš_,
   {{0x200b0052,0x63a2c579,0xb33b5465,0x6da61fab}},	// [4780] _doci_, vaon, paça, диза,
   {{0x6b898813,0x69cd03b7,0x7ae4005d,0x63a28010}},	//   _afeg, द्दी, _isit, waon,
   {{0x1dcf84e5,0xa3cb03dd,0x63a287fe,0x614603bd}},	//   त्यत, र्व_, taon, _цена,
   {{0x69dc22ba,0x200b0bda,0x9f42816b,0x69ce074c}},	//   lere, _goci_, žké_, lfbe,
   {{0x27e68083,0x34dad466,0xb3c600d4,0x78bc00b9}},	//   _raon_, _बन्द, _वानख, lurv,
   {{0x2bae8028,0x201d84bf,0x6b898133,0x7ae4004f}},	//   ộc_, _alwi_, _efeg, _msit,
   {{0x63a28b6d,0x6443816a,0x69dc2f84,0x27e6a6b9}},	//   paon, énic, iere, _paon_,
   {{0x69dc5467,0xb8d69664,0x2fc05468,0x7ae45469}},	//   here, _जि_, ngig_, _osit,
   {{0x69dc546a,0x6fd00b9f,0x6015826f,0x19c697c8}},	//   kere, ड्यू, _zámk, _обам,
   {{0x69dc546b,0x7c2280a9,0x660a82a3,0x601c82be}},	//   jere, lhor, _qofk, _déma,
   {{0xf9c78bca,0x45b70051,0x27e69882,0x27e9546c}},	//   _تحقی, ופיל_, _taon_, ydan_,
   {{0x61e882a3,0x6280d46d,0x63a0826f,0x7c22a32d}},	//   _hadl, _kumo, _jemn, nhor,
   {{0xdce8862a,0x6280d46e,0xa3cb123a,0x61ca0054}},	//   radı, _jumo, र्ष_, िभूष,
   {{0x69dc2235,0x200b3a68,0x644f3277,0x63a08087}},	//   gere, _soci_, soci, _lemn,
   {{0x7ae44837,0x6280d46f,0x27e90085,0x61e89a76}},	//   _esit, _lumo, tdan_, _madl,
   {{0xb907023c,0x63ad5470,0xe3d0001c,0x7c2283c1}},	//   _मई_, _udan, _hằng_, jhor,
   {{0x69dc5471,0x27e95472,0xfc3f000d,0x200b0330}},	// [4790] bere, rdan_, mní_, _voci_,
   {{0xfc3f03bb,0x61e882a5,0x69dc5473,0xea010028}},	//   lní_, _nadl, cere, _đặt_,
   {{0x26c90fda,0x69c50870,0x29198201,0x27e95474}},	//   stao_, _iche, _əsas_, pdan_,
   {{0xfc3f5475,0x27e90085,0x68e55476,0x200b017f}},	//   nní_, qdan_, _ishd, _uoci_,
   {{0x1dc70105,0x320c8e25,0x63a0d477,0x62809495}},	//   _लापत, _body_, _demn, _cumo,
   {{0xaab20063,0x0d840fe6,0x11d981a8,0x260003dd}},	//   _जिसक, _алён, سوعة_, राणी_,
   {{0x69c5022e,0x3ea95478,0xe0d18019,0x61e8d479}},	//   _mche, lsat_, ازت_, _dadl,
   {{0x69dc547a,0x3866bcde,0xfc3f03fb,0x61fa81ec}},	//   zere, _chor_, jní_, _entl,
   {{0xfc3f03bb,0x69dc547b,0xe3d00104,0x7a2202be}},	//   dní_, yere, _bằng_, _hôte,
   {{0x6cea9094,0x69dc08f1,0x69c50870,0xe3b2026a}},	//   टिंग_, xere, _nche, گرد_,
   {{0x2600035a,0x25e0800d,0x69dc547c,0x60158511}},	//   राती_, _कसरी_, vere, _lámi,
   {{0x69c5547d,0xeb970364,0x601c801b,0xccf200be}},	//   _ache, нию_, _téma, אכט_,
   {{0x386d8bbd,0x6015d47e,0x81e28264,0x6d588380}},	//   mmer_, _námi, ধার_, _eyva,
   {{0x64a58721,0x386d8687,0x3ea9547f,0x442203ed}},	//   _зака, lmer_, dsat_, shk_,
   {{0xfc3f000d,0x25a5d480,0xa3cb00d4,0x3ea90706}},	//   bní_, mall_, _रॉक_, esat_,
   {{0x69c5082e,0x69dc532b,0x7bdd17ec,0x7ae40074}},	//   _eche, sere, cesu, _tsit,
   {{0x69dc5481,0x63a65482,0x9f420247,0x3ea90122}},	// [47a0] pere, makn, _ankò_, gsat_,
   {{0x63a08012,0xa3c0073c,0x63a62d27,0xf77f03a7}},	//   _semn, ुभव_, lakn, _faço_,
   {{0x399b0451,0x44e181e2,0x3ea903ac,0x386d81ac}},	//   _מייד, _jų_, asat_, kmer_,
   {{0xf76791ac,0x63a65483,0xc5f880eb,0x628082c4}},	//   _ما_, nakn, nmēr_, _pumo,
   {{0xa3b80c1c,0x81e980ab,0x087700be,0xafdb004a}},	//   _चयन_, যান_, _רעכט_, _kjøn,
   {{0x7c22d2cb,0xc33300be,0x7bdd5484,0x63a6010b}},	//   shor, נוג_, zesu, hakn,
   {{0x44202c84,0x320c803e,0xe643035f,0xe3d00028}},	//   _oli_, _vody_, _серп, _rằng_,
   {{0xc6f8ad6b,0x63a609da,0xefb2803d,0x320c809a}},	//   дних_, jakn, ایشگ, _wody_,
   {{0xfc3f03bb,0x63a60500,0x25a58fb6,0xc24695da}},	//   vní_, dakn, fall_, _знак,
   {{0xceb3004c,0x25a5ae12,0x64470115,0x7ed381a8}},	//   נית_, gall_, čkim, ازيا,
   {{0x439519b8,0xfc3f03bb,0x4420179a,0x60180019}},	//   канс, tní_, _bli_, _címk,
   {{0x63768182,0x69c5547c,0x63a60886,0x6d58816b}},	//   _günü, _sche, gakn, _vyva,
   {{0x25a5d485,0xfc3f000d,0xb33b5486,0x69c50953}},	//   ball_, rní_, raço, _pche,
   {{0x44205487,0x171b8158,0xfc3f001b,0x7af68198}},	//   _eli_, _צוגע, sní_, äyty,
   {{0x9f47000d,0xa2ad01ce,0xfc3f03fb,0xb33b383c}},	//   ění_, _जिक्, pní_, paço,
   {{0x44200021,0x601c82be,0x63a6008e,0x36d52f92}},	//   _gli_, _mémo, cakn, кобр,
   {{0x2bc60c78,0x69c503ec,0x50645488,0xfc4001d0}},	// [47b0] _वाता, _tche, утра, čít_,
   {{0x69c55489,0x4420012b,0x645d3936,0x63a4807b}},	//   _uche, _zli_, llsi, ðinn,
   {{0x09bf8a49,0xe1ff8104,0x3ea9548a,0x44200364}},	//   _ইসলা, _đó_, ssat_, _yli_,
   {{0xa3d4000f,0x69cd10c8,0xdb1b8511,0x3ea9001b}},	//   स्प_, द्री, _acuá, psat_,
   {{0xfbd306bf,0x2bd3024c,0x645d01a8,0xdb00810c}},	//   ध्यम, ध्या, ilsi, _jemè,
   {{0xdc138059,0xdb008168,0x1a9c00be,0xf2d403de}},	//   rşıs, _zemë, לידע, רעס_,
   {{0x63a60890,0x25a5880f,0x6d420087,0x2ee681b0}},	//   yakn, vall_, şoar, _asof_,
   {{0x601cd48b,0x8f75bf56,0x75288ec3,0x7f758c75}},	//   _démo, купі, dzdz, купц,
   {{0x386dd48c,0x25a5d48d,0x2459026f,0x63a6548e}},	//   rmer_, tall_, nému_, vakn,
   {{0x273e0028,0xa3d406b7,0x6b8d0032,0x386dd48f}},	//   ắng_, स्न_, _afag, smer_,
   {{0x44200247,0x63a600ce,0x25a35490,0x9d4581a1}},	//   _pli_, takn, _mejl_, тенд,
   {{0x66b5a84f,0x2459016b,0x3de180ab,0x44200037}},	//   _абду, kému_, বাইল, _qli_,
   {{0x8af002bf,0xe3b80182,0x27ed8584,0x25a5d491}},	//   _azər, ğı_, mden_, pall_,
   {{0xe3b80059,0x27edc537,0x63a612b7,0xe3d580ab}},	//   şı_, lden_, sakn, _সোমব,
   {{0x69c3d492,0x63a641eb,0xe9a32dc7,0x3ebf910f}},	//   igne, pakn, расп, luut_,
   {{0x27ed977a,0x44203a59,0x7848801b,0xf7721c12}},	//   nden_, _uli_, pěve, لاء_,
   {{0x27edd493,0xe7371269,0x26cd8511,0x3ebf8cfa}},	// [47c0] iden_, вет_, nteo_, nuut_,
   {{0x63a43f5d,0x644383b0,0x27ed8009,0x200fd494}},	//   _hein, énin, hden_, _logi_,
   {{0x63a45495,0x60182d11,0xdb008168,0xafdb00e8}},	//   _kein, _lími, _temë, _kjøl,
   {{0x27ed8613,0x7af609a4,0xb4d2009a,0x69c48072}},	//   jden_, _kryt, _वही_, _राही,
   {{0xa3d40dbc,0x27edce47,0x63a411e6,0x7bc283c9}},	//   स्य_, dden_, _mein, rgou,
   {{0xbda507bd,0x27e03326,0x63a4394e,0x80db80c8}},	//   _محفو, lein_, _lein, ভিন্,
   {{0x7d0300f2,0x403486c8,0xdca314b8,0x7af60110}},	//   änst, лекс, _васи, _lryt,
   {{0x63a45496,0x6b8580f7,0x27edd497,0x601c802a}},	//   _nein, _مشكل, gden_, _vémo,
   {{0x7e7c0190,0xc8ae83eb,0x6d5c0aa8,0x291812b7}},	//   _kirp, _टिकट, _hyra, hyra_,
   {{0x44268003,0x7c86845d,0x4b558698,0x601ca02e}},	//   lho_, куме, _съст, _témo,
   {{0x63a45498,0x27e05499,0xa3e6816f,0xdb0083ec}},	//   _bein, kein_, _बघा_, _semè,
   {{0x44268003,0x61fe0247,0x64428009,0x7af6549a}},	//   nho_, _anpl, nnoi, _bryt,
   {{0x63a45013,0x59c99d17,0x27e01a95,0x34df0571}},	//   _dein, _रामर, dein_, _नन्द,
   {{0x2459026f,0x3eb980e1,0x200f8326,0x7bd60c2e}},	//   vému_, áste_, _zogi_, _ebyu,
   {{0x442691e8,0x63a4549b,0x195821f6,0x29183d9b}},	//   kho_, _fein, вары_, gyra_,
   {{0x442681ac,0xe7ed02f1,0x63a41151,0x61fe549c}},	//   jho_, _चोखा_, _gein, _enpl,
   {{0x4439549d,0x62840d76,0x4426d49e,0x26c002c4}},	// [47d0] mis_, _guio, dho_, guio_,
   {{0x27ed87d9,0x2fdf82af,0x442681ac,0x2459016b}},	//   zden_, zeug_, eho_, rému_,
   {{0x27edd49f,0x44391390,0x9f4f8106,0x7e7c0286}},	//   yden_, ois_, _ingå_, _dirp,
   {{0x443954a0,0xc4d38158,0x4426d4a1,0x6d5c267f}},	//   nis_, יגע_, gho_, _dyra,
   {{0x1dc289a3,0x59a7000d,0x69c48651,0x200f88e4}},	//   _शांत, _औजार, _राशी, _rogi_,
   {{0x443954a2,0x78ba0025,0x21699541,0xa9699170}},	//   his_, štve, нили_, нила_,
   {{0x44393e80,0x205589b8,0x26000fb2,0x69c3d4a3}},	//   kis_, лтир, रारी_, rgne,
   {{0x4426d4a4,0x443954a5,0xe3b0830f,0x27edc5a8}},	//   cho_, jis_, _ورق_, uden_,
   {{0x27edd4a6,0x69d707f4,0x63a4293c,0xdb0603ed}},	//   rden_, _obxe, _rein, rakë,
   {{0x63a409af,0x26cd9cdc,0x27e00102,0xafdb021e}},	//   _sein, rteo_, zein_, _sjøl,
   {{0x7fd5ba8b,0x63a41b3a,0xdb00d4a7,0x26cd8216}},	//   _білі, _pein, _remé, steo_,
   {{0x601854a8,0x2d8e9384,0xdb063d9b,0x9ef581a8}},	//   _tími, _effe_, laké, _مستش,
   {{0x8c1a8051,0x62844e2a,0x27e054a9,0x2bd300c2}},	//   גורי, _quio, vein_, ध्धा,
   {{0x63a454aa,0x44392617,0x29180168,0x7c260168}},	//   _wein, ais_, tyra_, shkr,
   {{0x44395005,0x63a428cc,0x3ead829e,0x291e54ab}},	//   bis_, _tein, lset_, áta_,
   {{0x7ae9b72e,0x1dcfa0f2,0x58950425,0xd5cf816f}},	//   _oset, त्रत, ршру, त्रज,
   {{0x291e003a,0x26001344,0x7c2454ac,0x7e7c0267}},	// [47e0] šta_, राली_, _ilir, _pirp,
   {{0x3ead8009,0x44268609,0xdb061ee0,0x683e8ec3}},	//   iset_, who_, jaké, mūde,
   {{0x4426d4ad,0xa3cb024c,0x7ae9a551,0x273380ff}},	//   tho_, र्क_, _aset, ảnh_,
   {{0x7bc601da,0x3ead825d,0x6d5c110d,0x69c30214}},	//   ngku, kset_, _vyra, _öner,
   {{0x4426d4ae,0x6d5c009a,0xf772015b,0x6442d4af}},	//   rho_, _wyra, _داد_, rnoi,
   {{0x44268774,0x443954b0,0xa3d401d2,0x38605202}},	//   sho_, zis_, स्त_, llir_,
   {{0x7ae9d4b1,0x44393a96,0x442691e8,0x60158125}},	//   _eset, yis_, pho_, _náms,
   {{0x4fc6844f,0xb4fb0051,0x79818114,0x6b808122}},	//   уска, _אפלי, _eglw, _ugmg,
   {{0x74138277,0x442482f1,0x67041e19,0x3ead9aed}},	//   _اوقا, _ilm_, रमिक_, gset_,
   {{0x443954b2,0x4424ae08,0x68ed809a,0x7c360176}},	//   wis_, _hlm_, łada, _amyr,
   {{0xdb0983b0,0xd6570039,0x97c68199,0xd7ef8adb}},	//   _ideá, ריית_, _مقاو, _лу_,
   {{0x6015803e,0x225a00ee,0x7c244e55,0x661d93de}},	//   _dáms, _akpk_, _clir, ëskr,
   {{0x443905d8,0xa3cb0305,0x2bc6009a,0xa3bc864a}},	//   ris_, र्ग_, _वारा, _आयन_,
   {{0x443954b3,0xa2cc800c,0x2c7b0032,0xf77381c6}},	//   sis_, _समन्, _bàdì_, _פקס_,
   {{0xbd558077,0x1959076a,0xd7fb01e5,0x667180d7}},	//   _پروژ, тавы_, нуа_, _بگير,
   {{0x5f950e8e,0x9f4b0388,0x6e3a8366,0x6d469238}},	//   риат, _hacé_, litb, şkas,
   {{0xd5bb117e,0x245c928a,0x9f590580,0x963554b4}},	// [47f0] есе_, nímu_, _rosó_, анац,
   {{0x4424813c,0xafdb004a,0x236902d6,0xa3dd00c2}},	//   _alm_, _kjøk, _izaj_, ड़क_,
   {{0x386007fa,0x44248890,0x9f591d7e,0xb8670019}},	//   blir_, _blm_, _posó_, _ماحو,
   {{0x4424802a,0x69c7021e,0x7ae9817f,0xf41f0009}},	//   _clm_, lgje, _pset, nkä_,
   {{0x4424b72d,0x81e980ab,0x9f4201d6,0xcfaa8264}},	//   _dlm_, যাস_, _taká_, ওলান,
   {{0xd05a8086,0xa3cc0740,0x7ae98a21,0x69c754b5}},	//   _istə, _लाभ_, _vset, ngje,
   {{0x2bf506a7,0x44248168,0x6e3ad4b6,0xafdb004a}},	//   इयां_, _flm_, ditb, _skøy,
   {{0xb8cd823c,0x3ead8100,0x69d58105,0xe3b3806b}},	//   _कब_, tset_, _मॉरी, _درس_,
   {{0x53358847,0x600691e9,0x78a48a20,0xf7458a7c}},	//   _теат, рным_, ćiva, репо,
   {{0x63aba1b4,0x3eadbeb9,0x3f8d83a7,0x7c2400d7}},	//   lagn, rset_, sceu_, _slir,
   {{0x99849301,0x3ead82fe,0x61e3d2a4,0x7c242cb1}},	//   _المو, sset_, menl, _plir,
   {{0xf7708117,0x61e3ad46,0x60c3bdfc,0xda03a730}},	//   _کام_, lenl, munm, लावत_,
   {{0x2bd79880,0x60c38457,0x20d1801c,0x501a8039}},	//   ण्या, lunm, _hơi_, _שונו,
   {{0x672d21a9,0x7a2b13da,0xe297117e,0x61e3d4b7}},	//   dzaj, _lütf, рар_, nenl,
   {{0x28dd8d86,0x463a80be,0x98a61c79,0x6d468713}},	//   _महफि, _בעסע, рибе, şkar,
   {{0x63ab803a,0xa3d78105,0x7c243e21,0x61e38192}},	//   jagn, ़्म_, _ulir, henl,

   {{0x63ab8081,0x6f1b89ca,0x61e3d4b8,0x6b8402c4}},	// [4800] dagn, nyuc, kenl, _igig,
   {{0x645bbda1,0xbda501a8,0x630694a0,0x63ab82c4}},	//   _akui, محمو, یوال, eagn,
   {{0x20d18028,0x61e3d4b9,0xdddd0087,0x20e78019}},	//   _nơi_, denl, _susţ, _női_,
   {{0xe29aa597,0x63ab8bcb,0x64462916,0x60c38041}},	//   вад_, gagn, nnki, dunm,
   {{0xa3cb229e,0xf1948009,0x99830110,0x672d009a}},	//   र्ट_, биль, cijų_, czaj,
   {{0x61e3d4ba,0x6b84026c,0x20d180ff,0x645bd4bb}},	//   genl, _lgig, _bơi_, _ekui,
   {{0x03a680e8,0x4424d4bc,0x63abd4bd,0x48a78190}},	//   _вибо, _tlm_, bagn, атым_,
   {{0xdfda8098,0xdb0b0214,0x63ab9268,0x4424d4be}},	//   тък_, _çiçe, cagn, _ulm_,
   {{0xde888135,0x2360022c,0xe61f00ff,0x61e3d297}},	//   _bịa_, _nyij_, _muôn_, benl,
   {{0xe61f0028,0x20d6835f,0x225854bf,0x6b8454c0}},	//   _luôn_, _відс, jork_, _agig,
   {{0xf41f0009,0x24800362,0x629605ee,0x6e3a83a6}},	//   tkä_, _biim_, _atyo, ritb,
   {{0xa3a981ce,0x6f0983a8,0x386081a8,0x6aa4018f}},	//   _खड़ा_, bxec, _óir_, _bwif,
   {{0x6e948013,0x81e980c8,0xe69480f7,0x27f2031d}},	//   _التا, যার_, _التد, ddyn_,
   {{0x20024ea8,0xa3cb01d2,0x64460a5b,0x6b8454c1}},	//   _anki_, र्ज_, anki, _egig,
   {{0x97a7197b,0x69c71832,0x26c49a99,0x27ef80dd}},	//   ирал, rgje, lumo_, _yagn_,
   {{0x61e387d9,0x02a70b9b,0xcf980b30,0x5d7b81c6}},	//   zenl, _кром, ију_, _באוק,
   {{0xf7730288,0x61e393f4,0x63ab8bcb,0x95d90b79}},	// [4810] زار_, yenl, vagn, лдат_,
   {{0x60c3cfbf,0x645b81b0,0x99830110,0x2002471f}},	//   yunm, _skui, rijų_, _enki_,
   {{0xa3d40076,0x228b821e,0x63ab8625,0x99830084}},	//   स्व_, _søk_, tagn, sijų_,
   {{0xa3cb3849,0x601c80e7,0x20d1801c,0x7aed09e1}},	//   र्च_, _fémi, _rơi_, _ksat,
   {{0x61e3d4a6,0xe21402e3,0xadf8863a,0x7848801b}},	//   tenl, _طبیع, ्ञान_, těvn,
   {{0x63abd4c2,0x60c39040,0x26c4d4c3,0xdb008144}},	//   sagn, tunm, dumo_, _gemí,
   {{0x26091880,0x63abd4c4,0x61e3d4c5,0x601801d0}},	//   साठी_, pagn, renl, _tímt,
   {{0x9f950006,0x7aed54c6,0x60c3880a,0x7bcd01c5}},	//   _nüüd_, _osat, runm, _ncau,
   {{0x6e27026c,0xa3cb001b,0x26c48084,0x27efd4c7}},	//   _kljb, र्छ_, gumo_, _vagn_,
   {{0x6459d4c8,0x443dd4c9,0x2d83806a,0x60c3803d}},	//   lowi, liw_, øje_, punm,
   {{0x30858013,0x63a982a3,0x7aed4e58,0x90998779}},	//   _الصف, _keen, _asat, _свет_,
   {{0xe29a3b17,0x64598063,0x6281d4ca,0x04460749}},	//   лам_, nowi, _hilo, семн,
   {{0x7aed0065,0x63a9d033,0xe60e9d7b,0x05c70072}},	//   _csat, _meen, _ед_, _लांब,
   {{0x63a9d4cb,0x62818326,0x7aed0372,0x6ec101d0}},	//   _leen, _jilo, _dsat, _लमजु,
   {{0xb4e603bb,0x7aed1604,0x64598035,0x01662357}},	//   _भने_, _esat, kowi, скво,
   {{0x765c54cc,0x6281d4cd,0x9ac504b7,0x63a9d4ce}},	//   _skry, _lilo, fiċċ, _neen,
   {{0x6459809a,0x92b61e91,0x661554cf,0xa0670323}},	// [4820] dowi, _احبا, _bozk, сата_,
   {{0x62819217,0x7bdb91b5,0xaca38133,0xa3d40035}},	//   _nilo, _abuu, _ndịi, स्र_,
   {{0x63a9d4d0,0x60de00f2,0xa63a80be,0x7afbd4d1}},	//   _been, _uppm, נגער, _arut,
   {{0x3ebfd4d2,0x6281be9f,0x63a98579,0xdc190035}},	//   krut_, _ailo, _ceen, _błęd,
   {{0x6281d4d3,0x7afb8068,0x63a990b0,0x6d5c8a21}},	//   _bilo, _crut, _deen, ýraz,
   {{0xed5a1d85,0x6d430013,0xa8a6b33d,0x59db0bb8}},	//   _бог_, únac, брик, म्पर,
   {{0x92e880c8,0x62819600,0x7afbd4d4,0x64598035}},	//   যমে_, _dilo, _erut, bowi,
   {{0x7afbd4d5,0x69cd9664,0xde88819d,0x63a9d4d6}},	//   _frut, _साथी, _dịn_, _geen,
   {{0x7afb8dba,0xfaa3a81c,0x91fc8362,0xdb0082df}},	//   _grut, _нато, _bhāt, _demã,
   {{0x6281d4d7,0x7bcd002e,0x26c4d4d8,0x63a9d4d9}},	//   _gilo, _scau, rumo_, _zeen,
   {{0xa3bc809a,0xa3cfc252,0x9f4f86c0,0x25aa0088}},	//   _आया_, _शाम_, _lagè_, _mebl_,
   {{0x7f868013,0x26c00a20,0x69d8800b,0x6281b8a8}},	//   _الإن, krio_, lfve, _zilo,
   {{0xd5a804e5,0xcc3b80be,0x7c3d1ab3,0x7c228f3e}},	//   गराज, רעכט, risr, ikor,
   {{0xab5b54da,0x6aa918e6,0x26c02843,0x6459809a}},	//   ngüi, _कबीर, drio_, zowi,
   {{0x463b80be,0x7c22d4db,0x661509a4,0xde8880ff}},	//   _געגע, kkor, _rozk, _xịn_,
   {{0x2c7b0341,0x7aed54dc,0x26c01670,0x3a3a1b88}},	//   _līdz_, _tsat, frio_, _empp_,
   {{0x442954dd,0x7aed54de,0x7c22bd7f,0x5a350049}},	// [4830] _ila_, _usat, dkor, _мнит,
   {{0x44291393,0x63a981ab,0x644aabda,0x09b300ab}},	//   _hla_, _seen, éfin, ঞ্জা,
   {{0x26c0160a,0x6459d4df,0x443d876d,0x7afb8090}},	//   ario_, towi, tiw_, _srut,
   {{0x237f0052,0x7afb9303,0x8cc08f85,0xaa7b016b}},	//   žuju_, _prut, _विनो, jvýz,
   {{0x64598063,0x69c4d4e0,0xd90f82e3,0x248d083d}},	//   rowi, _राखी, کیا_, _čemu_,
   {{0x40959300,0x63a981b0,0xdb008118,0x56942118}},	//   орит, _ween, _admó, _харт,
   {{0x64598d38,0x442954e1,0x6281bac8,0x1b1780ab}},	//   powi, _ola_, _vilo, _দেশে_,
   {{0xe7399cd3,0x7c22816d,0x442910ab,0x682a001b}},	//   ией_, ckor, _nla_, _týde,
   {{0x7c3bd4e2,0x7afba668,0x7c29d4e3,0x6281d4e4}},	//   _imur, _urut, _iler, _tilo,
   {{0x442954e5,0xc8ab8698,0x644d0b20,0x7fb9803d}},	//   _ala_, _бъде_, _ajai, _چهار_,
   {{0x442954e6,0x5f9587eb,0xf3e61056,0x7c29d4e7}},	//   _bla_, _диет, ожно, _kler,
   {{0x7bcb859c,0x443b0081,0xc2090039,0x5f74826a}},	//   nggu, _cmq_, _בה_, _کامر,
   {{0x44290d38,0x69db0267,0x627981d6,0x7c29810c}},	//   _dla_, đuen, _dňov, _mler,
   {{0xa2cc80ba,0x442936c7,0x5ebe80c8,0x765a810c}},	//   _समस्, _ela_, ্বশে, coty,
   {{0x7c3bd4e8,0x7c29d4e9,0x442200b9,0x717601a8}},	//   _omur, _oler, pkk_, زهرا,
   {{0x78ba369f,0xfc3f0a21,0x59db54ea,0x601c816a}},	//   štvo, cií_, म्बर, _fému,
   {{0x3205cbc0,0xf99f801c,0x78a90bcf,0xdb1d0338}},	// [4840] _only_, _đèn_, ćeva, ggsä,
   {{0xdb00803e,0x26c28025,0x442900d2,0x7c3b83c3}},	//   _nemá, škog_, _zla_, _amur,
   {{0x20f800d2,0x7c22a9c6,0x7c29d4eb,0xd30281a2}},	//   _uči_, tkor, _bler, लम्ब_,
   {{0xf8b3004c,0x26c00698,0xab66a10d,0x6f0d002a}},	//   _קשר_, prio_, овел, bxac,
   {{0x3ce600e1,0x7cf7819d,0x19949f96,0x8cc080c2}},	//   ňov_, _ịru, паля, _विभो,
   {{0x64a612b2,0x7c2286ee,0x7c29baf6,0xdca602a4}},	//   _мага, skor, _eler, _маги,
   {{0x7c298f06,0x628fd4ec,0xdb008693,0x082a8396}},	//   _fler, _écon, _demá, иции_,
   {{0xdfd09168,0xd6da8785,0xdb008722,0x920382f1}},	//   ريخ_, ато_, _temà, लाउज_,
   {{0x69968098,0x63a481fa,0x63af0b80,0xe297a481}},	//   _дрех, ðinu, vacn, _мат_,
   {{0xddd8803b,0x44290a0f,0xdb1d54ed,0x69da00d4}},	//   _bivš, _sla_, ngså, _पॉली,
   {{0x442954ee,0xa3cc0105,0x6563831d,0x81468065}},	//   _pla_, _लाश_, _cynh, _بنان,
   {{0x2d8784d6,0xccf8928a,0x9f4b136f,0x6a6487f1}},	//   _egne_, rvě_, _sací_, dòfi,
   {{0xfc3f026f,0x447b80be,0x442954ef,0x7a2b0380}},	//   rií_, ינטע, _vla_, _rütb,
   {{0x4429177c,0xe5348d15,0x6018023e,0xfc3f01d6}},	//   _wla_, _нель, _símp, sií_,
   {{0x4429011a,0x65638114,0x63a2d4f0,0x69de008e}},	//   _tla_, _gynh, kbon, _dbpe,
   {{0x1ddd05e8,0x36348077,0x4429549e,0xa3dc8105}},	//   न्नत, _برچس, _ula_, त्म_,
   {{0x36d40364,0x645d54f1,0x2d87007a,0xc98747d4}},	// [4850] мотр, mosi, žnem_, _муни,
   {{0x645d54f2,0x60c70140,0xdd9b3aca,0xc33201c6}},	//   losi, pujm, рша_, _נוי_,
   {{0x63ad0359,0x69c48701,0xdb008118,0x89da0019}},	//   _kean, _राजी, _remá, _اوپر_,
   {{0x645d54f3,0x515a0039,0x63a2a5b3,0xdb009984}},	//   nosi, _לכתו, gbon, _semá,
   {{0xfaa58698,0x7c29d4f4,0x27e941ef,0x63ad0039}},	//   чало, _vler, mean_, _mean,
   {{0x27e954f5,0x628554f6,0x645d0114,0x786586a5}},	//   lean_, _jiho, hosi, móvi,
   {{0xa3cc09a3,0x645d22b3,0x628516f2,0x2484807b}},	//   _लाल_, kosi, _miho, _fimm_,
   {{0x27e92975,0x1bb88b76,0x7c3bd40f,0x62852916}},	//   nean_, _واقع_, _umur, _liho,
   {{0xdb008acf,0xee39920c,0x63bbd4f7,0xe293803d}},	//   _temá, йни_, _idun, _آذر_,
   {{0x628554f8,0xe8098054,0x27e90046,0x661881c0}},	//   _niho, वाहा_, hean_, _covk,
   {{0x63ad54f9,0x1ddd0a74,0xed59d4fa,0x80a480f7}},	//   _bean, न्यत, сон_, _يمكن,
   {{0x63ad154c,0x644bd4fb,0xf0f9800f,0x27e92956}},	//   _cean, nngi, ्मीद_, jean_,
   {{0x27e91f13,0xf1d28935,0x63ad0c49,0xda070540}},	//   dean_, _सामन, _dean, शांत_,
   {{0x1dc72e2b,0xf77084e3,0x877a80be,0xf67580be}},	//   _लागत, _شان_, _פאסי, _צײַט_,
   {{0x7641d4fc,0x62851600,0x63bbd0b9,0x63ad3040}},	//   mily, _diho, _odun, _fean,
   {{0x201954fd,0x27e954fe,0x63ad54ff,0x2bc6016f}},	//   _cosi_, gean_, _gean, _वाटा,
   {{0x0cdb815c,0x6f16809a,0x20195500,0x628501b9}},	// [4860] _बहुम, _życz, _dosi_, _fiho,
   {{0x63bb9341,0x63a2d501,0xceb40085,0x0e630fe6}},	//   _adun, wbon, rsə_, екун,
   {{0x27e90cdb,0x629bd502,0x20190609,0xceb4011c}},	//   bean_, _atuo, _fosi_, ssə_,
   {{0x69dc5503,0x27e95504,0x20190135,0x9f4280e1}},	//   lfre, cean_, _gosi_, ľkú_,
   {{0x628f82be,0x41d304e5,0x7641d505,0x249f01a1}},	//   _écol, _तामस, kily, _čume_,
   {{0x7848800d,0x69dc2a1d,0x69d587d9,0x3ea00812}},	//   pěvk, nfre, _özel, mpit_,
   {{0xfce3069b,0x64a6084b,0x645d4dc7,0x2d8a2d10}},	//   _поро, _хаба, yosi, _igbe_,
   {{0x25ee8076,0x6ebd86b7,0x7d1c835f,0xafdb0aa2}},	//   _असही_, _शिशु, ørsm, _hjør,
   {{0xae20000f,0x2bd1835a,0x96f88a29,0xafdb035f}},	//   _मकान_, _हाता, цепт_, _kjør,
   {{0x4426d506,0x63ad0635,0x27e90102,0x824a830f}},	//   lko_, _sean, zean_, _اشرف_,
   {{0xa96a99f4,0x645d3b19,0x63ad24db,0x2d8a0a2c}},	//   _امام_, tosi, _pean, _mgbe_,
   {{0xb8658b76,0x9f401378,0x69dc816d,0x27e90102}},	//   _قانو, ndió_, _öreb, xean_,
   {{0x69dc42bb,0xe80980a5,0x4426d507,0x765e02e7}},	//   ffre, वारा_, iko_, kopy,
   {{0x4426824a,0xa3dc873c,0xdb040511,0x7a300106}},	//   hko_, त्त_, _adió, _nätd,
   {{0xa3cc9d01,0x69ce09a3,0x7ae45508,0x44269b02}},	//   लला_, _तारी, _epit, kko_,
   {{0xdc2b0077,0x2d8a0091,0x2d980176,0x6ee201bc}},	//   _دسته_, _agbe_, _afre_, _ọbag,
   {{0x44269ce9,0x62854b25,0x7c2d5509,0xafdb054f}},	// [4870] dko_, _tiho, _ilar, _bjør,
   {{0x4426d50a,0x27e910a2,0xa3cf81c4,0x682a026f}},	//   eko_, sean_, _शाह_, _výda,
   {{0x7c2d0bfa,0x40350468,0xb83501a0,0xa3d40305}},	//   _klar, _женс, _женщ, स्क_,
   {{0x22430586,0x7641c154,0x644ba7a1,0x7bcf13e0}},	//   lijk_, zily, ungi, ngcu,
   {{0x38691739,0xdcf70085,0x245881e2,0x6493022b}},	//   mlar_, raxı, чаць_, _għin,
   {{0x4426d50b,0xdd868250,0x7c2d009f,0xafdb035f}},	//   ako_, _لو_, _llar, _gjør,
   {{0x7c2d0afe,0xe8099344,0x23bf0b85,0xe61f001c}},	//   _olar, वाला_, ्लाद, _nuôi_,
   {{0x38690b06,0xccf20051,0x44269f01,0xb69b02be}},	//   nlar_, _בכל_, cko_, _grâc,
   {{0x442db7be,0x22430613,0x997e802e,0x443fbd36}},	//   _ile_, kijk_, tăţi_, _imu_,
   {{0x38690380,0x442dd50c,0x7a30156e,0x20d7007e}},	//   hlar_, _hle_, _käte, kçi_,
   {{0x3869550d,0x7ae438b0,0xa2c98540,0xa3ea1597}},	//   klar_, _spit, हूर्, одна_,
   {{0x386907d9,0x4ad18c78,0xca290496,0xdd1c00e1}},	//   jlar_, _समाव, _דם_, náša,
   {{0x3869550e,0xdb0081ec,0x290109ab,0x7c2d010c}},	//   dlar_, _gemä, _arha_, _dlar,
   {{0x442dd50f,0x442680ad,0x68fc0b24,0x64428037}},	//   _lle_, zko_, tvrd, zioi,
   {{0x442dd510,0xa3cc0076,0x7a3000f2,0x443f8c56}},	//   _ole_, _लाऊ_, _näte, _omu_,
   {{0x98a7809a,0x443fd511,0x3869088b,0x3b0001b9}},	//   czną_, _nmu_, glar_, _triq_,
   {{0xe61a10fc,0x7ae4003a,0xf7430b9b,0x64428009}},	// [4880] ода_, _upit, вето, vioi,
   {{0x442db72c,0x443fd512,0xf1d28dbc,0x7c2d0115}},	//   _ale_, _amu_, _साधन, _zlar,
   {{0x4426d513,0x38695514,0x442d8cde,0x938ab9c3}},	//   tko_, blar_, _ble_, осла_,
   {{0xdca30af2,0x0ea904e5,0x4426d515,0x68310370}},	//   таци, _चौकड, uko_, _rådg,
   {{0x25ee89a3,0x8db6035f,0x5f060196,0x442d801b}},	//   _असली_, _осві, _ўзга, _dle_,
   {{0x442d988e,0x20ee800d,0x443f8365,0x38603715}},	//   _ele_, _při_, _emu_, loir_,
   {{0x26119513,0x35a7800f,0xafdb035f,0xda6580f7}},	//   तानी_, _ग़ज़, _kjøp, راهي,
   {{0xd0108307,0x68e302af,0x442dd516,0x7d03013c}},	//   الة_, _ände, _gle_, ænse,
   {{0xc6f787ac,0x661c5517,0x78ad8067,0x5fbf86b7}},	//   дных_, _kork, ćava, _एयरल,
   {{0x3869017b,0x20ee801b,0x442dd518,0x7c2d0502}},	//   zlar_, _tři_, _zle_, _slar,
   {{0x38693881,0x44fe0110,0x442dd519,0x994a8060}},	//   ylar_, _jį_, _yle_, _بلال_,
   {{0x61f70201,0x224300f3,0x69daa539,0x3869551a}},	//   _saxl, wijk_, प्री, xlar_,
   {{0x6288d51b,0x386912a3,0xe80d0697,0x661c067f}},	//   _kido, vlar_, हासा_, _oork,
   {{0x20d703bf,0x6831006a,0x7d030106,0x78538162}},	//   tçi_, _måde, ånsk, măva,
   {{0x38690a82,0x22430a0f,0x6288d51c,0x64408372}},	//   tlar_, rijk_, _mido, _ommi,
   {{0x7c2d112e,0x6f02ac2d,0x6ce380e8,0x6288d51d}},	//   _ular, _kroc, _ріше, _lido,
   {{0x3869551e,0x78a20d11,0x6b8d551f,0x682a001b}},	// [4890] rlar_, _čove, _igag, _týdn,
   {{0x6440939a,0x443f8e6d,0x09c600ab,0x24890069}},	//   _ammi, _smu_, শ্বা, _hiam_,
   {{0x24890176,0x442d809f,0x38695520,0x2c720c83}},	//   _kiam_, _ple_, plar_, láda_,
   {{0x38690201,0xdddc01e2,0x447c00be,0xdcfa880a}},	//   qlar_, _virš, ַנגע, natı,
   {{0xa3d40894,0xd6c692dc,0x6288d521,0x661c0bc5}},	//   स्ट_, _حق_, _bido, _fork,
   {{0x24893dd7,0x661c5522,0x863500be,0x6440d523}},	//   _liam_, _gork, _טאָג_, _emmi,
   {{0x9f40007b,0x6288d524,0x1b1780c8,0x22498042}},	//   ldið_, _dido, _দেখে_, đak_,
   {{0x443fb994,0x248901e9,0x6b8d5525,0x628883a8}},	//   _umu_, _niam_, _ngag, _eido,
   {{0xf62588cc,0x9f400125,0x3eb9b74e,0x23695526}},	//   едпо, ndið_, ést_, _nyaj_,
   {{0xa3e210c5,0x6b8d5527,0x644f1984,0x78ba00d2}},	//   न्न_, _agag, enci, štvi,
   {{0x1d09813a,0x6aad54d9,0xb7d58032,0xd46a2857}},	//   чени_, _awaf, _aṣet, зине_,
   {{0x62888503,0xce958698,0x24890282,0x6aad0365}},	//   _zido, _задъ, _ciam_, _bwaf,
   {{0xe72e8785,0x386003d3,0x27ed94d0,0x24895528}},	//   _се_, voir_, meen_, _diam_,
   {{0x27edd529,0x200b04b9,0xc33284de,0x4a750a41}},	//   leen_, _anci_, רוך_, выст,
   {{0xafe60b88,0x50b50e97,0x12d000ab,0x42d000ab}},	//   новл, ксту, িবেদ, িবেশ,
   {{0x27edd52a,0x661c552b,0x248900ff,0x7e61808e}},	//   neen_, _sork, _giam_, lolp,
   {{0x6446552c,0x7bd600b4,0x7a2b1bef,0x38600036}},	// [48a0] miki, _icyu, _kütl, roir_,
   {{0x68310e23,0x27edd52d,0x7af60034,0x6b9b8365}},	//   _råde, heen_, _isyt, _afug,
   {{0x61d70159,0xf1c98bb8,0x27edd52e,0x41c99a87}},	//   _אויף_, _राजन, keen_, _राजस,
   {{0x6288927b,0x644610fa,0xe3b2830f,0x661c0051}},	//   _sido, niki, ارا_, _work,
   {{0xa3e2073c,0x27edd52f,0x59f88656,0xe803816f}},	//   न्य_, deen_, деля_, _शोधा_,
   {{0x64464c47,0x8cc080d4,0x61fc5530,0x61ee2aec}},	//   hiki, _विलो, ndrl, nebl,
   {{0x64465531,0xdcfa82bb,0xa2cc86b7,0x6288b6d9}},	//   kiki, yatı, _समक्, _vido,
   {{0xf1d28076,0x683e8029,0x27e05109,0x27edc866}},	//   _सावन, līdz, nfin_, geen_,
   {{0x64461d52,0xc5f88029,0x24890282,0x26018fd5}},	//   diki, klēt_, _riam_, _वोही_,
   {{0x2c7593c2,0x4375a59a,0x7e6181ca,0x61ee0140}},	//   råde_, _руст, golp, jebl,
   {{0xa3cc0e70,0x644610fa,0x6f02d532,0x27ed8079}},	//   _लाख_, fiki, _wroc, been_,
   {{0x6f02d533,0x644600b4,0xe80015fb,0x27ed8079}},	//   _troc, giki, _लोला_, ceen_,
   {{0x7d0396a1,0x61fad534,0xdcfa861c,0x248907b6}},	//   _erns, _katl, ratı, _viam_,
   {{0x61ee0799,0x7e6180e5,0xb69b0162,0x2c72016b}},	//   gebl, colp, _brân, ráda_,
   {{0x2bd1823c,0x248901e9,0x61fad535,0xe80d016f}},	//   _हाला, _tiam_, _matl, हाला_,
   {{0xb9090d38,0x63a901df,0x24890748,0x64465536}},	//   _यह_, ñend, _uiam_, ciki,
   {{0x2ba70f3d,0x9df915b1,0xa2cc8b84,0xe7e293ba}},	// [48b0] _क्या, мнат_, _समग्, क्या_,
   {{0x27e05537,0xb69b0493,0x6b9b847f,0x04b78019}},	//   afin_, _frân, _sfug, _تھیں_,
   {{0x27ed82c1,0xbc6807d2,0x682302f1,0x92ad8264}},	//   yeen_, _زمین_, _sõdu, _কমে_,
   {{0x09c98d14,0x27edd538,0x442b0140,0x683e8196}},	//   रल्य, xeen_, nkc_, būdi,
   {{0x61fa878c,0x27edbb2d,0x321e81d0,0x9f5903ed}},	//   _batl, veen_, _boty_, _masë_,
   {{0x64465539,0xceb200be,0x321e81e0,0x9f44823e}},	//   ziki, _דיך_, _coty_, demà_,
   {{0x27edd53a,0x2055a606,0x260e1513,0x6446553b}},	//   teen_, ктир, ठारी_, yiki,
   {{0x2605491d,0x6e200162,0x7a302651,0x6446011b}},	//   _होती_, _îmbr, _mäta, xiki,
   {{0x27ed9322,0x03ec00ab,0x64462d5c,0x61fad53c}},	//   reen_, য়ামী_, viki, _fatl,
   {{0x27edd53d,0x38668057,0x26c38353,0x26c900d2}},	//   seen_, _ekor_, čjo_, irao_,
   {{0x6446553e,0x853c8110,0x7e61d53f,0x7a300338}},	//   tiki, lbėj, rolp, _näta,
   {{0x8c460087,0x61aa036d,0x61fad540,0x61e51995}},	//   теме, कर्ष, _zatl, _abhl,
   {{0x386dd541,0x26cd85e4,0xdb099727,0x6d588144}},	//   mler_, queo_, _ideó, _exva,
   {{0x64465542,0xa2c4858c,0x66828019,0x7ae68106}},	//   siki, _रिस्, _پیپل, _äkte,
   {{0x64d0023c,0x386d9486,0xa06a0323,0xa967164f}},	//   _हमेश, oler_, дава_, вира_,
   {{0x2c08000f,0x386d87d9,0x70e218b8,0x7ae98009}},	//   षाओं_, nler_, _पहील, _opet,
   {{0xa0670572,0xc7b2893f,0x18671abe,0x60dc5543}},	// [48c0] тата_, יבן_, тати_, strm,
   {{0x386d82af,0xdee30256,0x44205544,0xa9261b67}},	//   hler_, рофи, _hoi_, _адол,
   {{0x386dd545,0xd49900e8,0x61fad546,0x387fb55e}},	//   kler_, ері_, _ratl, kmur_,
   {{0x4420002e,0xf7678c2a,0xad1a8158,0x351a80be}},	//   _joi_, _نا_, ווער, ווענ,
   {{0x80e2101b,0x44205547,0x386d93ca,0xe36391d5}},	//   _पहुं, _moi_, dler_, акци,
   {{0x44205548,0xa3e2005e,0x386dcac3,0x78758110}},	//   _loi_, न्त_, eler_, _išvy,
   {{0x6444194c,0xdb0f0626,0x386dd549,0x6e43024f}},	//   _omii, vací, fler_, _терз,
   {{0x4420554a,0x386d8f06,0xc6f8ad6b,0x7643be43}},	//   _noi_, gler_, ених_, _amny,
   {{0x09b800c8,0x61fabeab,0xa3cc0fb8,0x78a90024}},	//   _জানা, _tatl, _लाज_, ćevi,
   {{0xceb30039,0x442001a8,0x35e380e8,0x64442223}},	//   סית_, _aoi_, ацюв, _amii,
   {{0x386d82fe,0x4432079f,0xd7ef8193,0x29058503}},	//   bler_, _bly_, _ку_, _grla_,
   {{0x64440b99,0x4420554b,0x6d4300f7,0x07a684ae}},	//   _cmii, _coi_, únai, _радн,
   {{0xa3e200bc,0x27e6c040,0x290c0106,0x442001c6}},	//   न्ध_, _ibon_, ådan_, _doi_,
   {{0x442008f1,0x2c5600eb,0xb7d5846d,0x7c208f35}},	//   _eoi_, rāda_, _iṣat, _lomr,
   {{0x442007e1,0x44320367,0x6d459517,0x2905554c}},	//   _foi_, _fly_, _žhav, íla_,
   {{0xceb40086,0x26c902a5,0x44200c4b,0xa3e200a5}},	//   yyət_, trao_, _goi_, न्द_,
   {{0x41d283b7,0x09ca80c8,0x7a220036,0xda028072}},	// [48d0] _सांस, ল্যা, _vôtr, लयात_,
   {{0xe7e28519,0x386d8457,0x387f81bf,0x0e3405a8}},	//   क्ता_, zler_, zmur_, аную,
   {{0x7ae9d54d,0x386d8214,0x2d8703e3,0xee843d31}},	//   _spet, yler_, äne_, рыто,
   {{0xa2c4823c,0xdb0f0187,0xd01101a8,0x7a3006ae}},	//   _रिश्, cacã, _الح_, _jätn,
   {{0x3e7980e7,0x7c2b9c11,0x386dd54e,0x7a300106}},	//   lète_, rkgr, vler_, _mätn,
   {{0x386dcfe2,0x27e6a1e5,0x853c8084,0xde888129}},	//   wler_, _abon_, rbėj, _xịt_,
   {{0x09b800c8,0x386dd54f,0x2166d550,0x3e7980e7}},	//   _জামা, tler_, лиши_, nète_,
   {{0xb8dba0d5,0x224789ff,0x8bbf1869,0x386dd551}},	//   _अब_, sink_, ्लोअ, uler_,
   {{0x44205552,0x386dd553,0x3b55c907,0x764381c0}},	//   _roi_, rler_, _скар, _pmny,
   {{0x69c1813c,0x386dd554,0x44205555,0x7c2080e1}},	//   _udle, sler_, _soi_, _zomr,
   {{0xc3291a63,0xb7d58b76,0x44200698,0x386dcd6e}},	//   _צו_, _مقاب, _poi_, pler_,
   {{0x22998205,0x41dfd556,0x248d822b,0xe7b78651}},	//   _kèk_, प्रस, _jiem_, _इजिप,
   {{0x44205557,0xe2970912,0x27fd831d,0x55e58071}},	//   _voi_, лая_, _iawn_, _болб,
   {{0xed598468,0x628f82be,0x27fd84b7,0x442000dd}},	//   _пол_, _écou, _hawn_, _woi_,
   {{0x68311fdd,0x44205558,0x7d1c805f,0xde8880ff}},	//   _såda, _toi_, ørst, _vịt_,
   {{0xc2f980c8,0xf7720064,0x6444009c,0x69cd83b7}},	//   _আপনি_, ماء_, _umii, _साझी,
   {{0x6729ba2f,0x27ffd559,0x63b997ac,0x7d030366}},	// [48e0] nyej, idun_, dawn, ænsn,
   {{0xc3330051,0x3e79bafb,0x248200dd,0xe8fa1bf2}},	//   _לוח_, bète_, lmkm_, _зло_,
   {{0x7c208bcf,0x63b63cc0,0x200fc802,0x69db0b80}},	//   _pomr, _keyn, _ongi_, đuet,
   {{0x442087ca,0x629626bd,0x229986c4,0x981601a8}},	//   ði_, _kuyo, _bèk_, _إبدا,
   {{0x61fe2315,0x248dd55a,0x27f201b4,0x229988f9}},	//   _kapl, _diem_, meyn_, _cèk_,
   {{0x26d205b0,0x673b80e1,0x2ee002f7,0x63b6555b}},	//   muyo_, dzuj, mtif_, _leyn,
   {{0xc31c80ab,0x76488242,0x20000079,0x7c20d55c}},	//   _দেখি_, vidy, odii_, _tomr,
   {{0xba010076,0x26c2803a,0x61fe03ec,0x76aaaa98}},	//   _ऊफ्फ_, škom_, _lapl, нтов_,
   {{0x2ee024df,0x96348293,0x7648b24d,0x9f593762}},	//   ntif_, иниц, tidy, _pasé_,
   {{0x14ca8364,0xa3e203dd,0xf2978039,0x6fa48935}},	//   ными_, न्स_, _עכבר_, _ग्रं,
   {{0xb9939e95,0x63b6062a,0x6aa43f1e,0xd7e680e8}},	//   _المب, _beyn, _atif, _біло,
   {{0xc0a984e3,0x6f04011f,0x62961ea2,0x8706804e}},	//   _شامل_, kvic, _buyo, _مبتل,
   {{0xfe0405e8,0x200002c1,0x051480c8,0x629606a5}},	//   रयास_, ddii_, ানের_, _cuyo,
   {{0xad26803d,0x62962bc6,0x69351073,0x9f4b01a8}},	//   _مربو, _duyo, ангу, _tacú_,
   {{0x61fe1f2c,0xd5b88029,0x2611d55d,0xa3e24476}},	//   _dapl, skās_, तारी_, न्ह_,
   {{0x629600b9,0x3e798036,0x50674bfc,0x63b60df6}},	//   _fuyo, rète_, утга, _geyn,
   {{0x6296123c,0x3da7197b,0x248d9c11,0x26d21fb7}},	// [48f0] _guyo, греб, _riem_, guyo_,
   {{0x7aed0637,0x61fe2f31,0x2d9e802e,0x63b607c0}},	//   _ipat, _gapl, ncte_, _zeyn,
   {{0x2ee00458,0xe817800d,0xb65a10ab,0xfbdf001c}},	//   atif_, थामा_, nrẹ́, hiêm_,
   {{0x7aed0870,0x81bc81a9,0x26d21fdb,0x3e9701a8}},	//   _kpat, _slēp, buyo_, _مؤسس,
   {{0x26c28a20,0x2ee0555e,0x63b9809a,0x248d80e1}},	//   škoj_, ctif_, rawn, _viem_,
   {{0x3ea90393,0x65943079,0x248d809a,0xdd940084}},	//   mpat_, _гару, _wiem_, _гары,
   {{0x248d80eb,0x4439555f,0x3b090122,0x3ea95560}},	//   _tiem_, khs_, _lraq_, lpat_,
   {{0xaec595d2,0x7aed1249,0x63ad85e4,0x2ba710be}},	//   абил, _opat, ñand, कुमा,
   {{0x63b60125,0xa3d923e6,0xdb268065,0x644bd561}},	//   _reyn, ालन_, _پولی, migi,
   {{0x644bd562,0xcee881a8,0x7d098eef,0xdb0f0118}},	//   ligi, ارين_, вног_, xacá,
   {{0xed598767,0x6aa40ed0,0x7aed4022,0x59dc1344}},	//   тон_, _stif, _apat, _बाबर,
   {{0xe29a34fb,0x69c55563,0x644bd564,0x63861071}},	//   кам_, _adhe, nigi, игна,
   {{0x61fe1482,0x683801d0,0x63bb008b,0x628f8866}},	//   _papl, _jíde, ðuna, _écos,
   {{0xa2cd80ba,0x644bc378,0x63b60079,0x27f20079}},	//   _सिन्, higi, _weyn, weyn_,
   {{0xa96a2481,0x60262005,0x69d7073c,0x644bd565}},	//   тива_, адва, _बारी, kigi,
   {{0x32040063,0x44392331,0x3db200ab,0xa3e580d4}},	//   śmy_, chs_, _চাইল, _बॉल_,
   {{0x6e23d566,0x6aa45567,0x645d5568,0xde8880ff}},	// [4900] _konb, _utif, érie, _kịp_,
   {{0xee373fe7,0x09e400c8,0x35dd8cfd,0x2ee05569}},	//   ану_, _ফোরা, _माफ़, rtif_,
   {{0x644b8cb5,0x7c24113f,0xbef28f85,0x37e615b7}},	//   figi, _koir, _अन्न_, _конг,
   {{0xa3d9085d,0x644b82b8,0x7aed0110,0x2ee0556a}},	//   ालय_, gigi, _ypat, ptif_,
   {{0x7c24051e,0x69c1008b,0x7aed0bfd,0x539b01c6}},	//   _moir, ðleg, _xpat, דינו,
   {{0x7c24556b,0x98c68cec,0x6e238cdb,0x7a34851e}},	//   _loir, асил, _nonb, _bàta,
   {{0x644bd56c,0x7a3487f1,0x7afbd56d,0x26c00084}},	//   bigi, _càta, _esut, lsio_,
   {{0x58868048,0x7c2400e7,0xb8ce8665,0xb8fe864a}},	//   шыла, _noir, _कऽ_, _तम_,
   {{0xe7e28e70,0xe29aabca,0xfba70eed,0x4424d56e}},	//   क्षा_, _раз_, _क्षम, _iom_,
   {{0x4424d56f,0x26c00428,0x7c242305,0xb3b00264}},	//   _hom_, isio_, _aoir, _কাগজ,
   {{0x4424d570,0x7aed5571,0x7c241581,0x0d970039}},	//   _kom_, _spat, _boir, יכים_,
   {{0xdee6a410,0x4424d572,0x7c245573,0x66e6b317}},	//   _води, _jom_, _coir, _вода,
   {{0x7ae2d574,0x7c24032f,0x26cd8333,0xa3ce80c2}},	//   ntot, _doir, creo_, _शयन_,
   {{0x4424d575,0x05dd835a,0xfba72769,0xb7e299e8}},	//   _lom_, _मायब, _क्रम, क्रम_,
   {{0x7c245576,0x644b81d3,0x4424d577,0x6835816b}},	//   _foir, yigi, _oom_, _háda,
   {{0x4424d578,0x3ea95579,0x7c240014,0x5f4500f7}},	//   _nom_, tpat_, _goir, منزل,
   {{0xdb009ee6,0xe7f9873c,0x3ea9557a,0x7aed557b}},	// [4910] _memó, ्यता_, upat_, _upat,
   {{0x63bd557c,0x313530c6,0x3ea9121e,0x69c5557d}},	//   lasn, _геор, rpat_, _udhe,
   {{0x4424a727,0x03ec00ab,0x26cd8699,0x78a9017f}},	//   _bom_, য়ারী_, zreo_, ćevs,
   {{0x3ea6859c,0x3ea91c9c,0x68380511,0xa2ce0cf0}},	//   _otot_, ppat_, _píde, _तिम्,
   {{0x4424d57e,0x81ae80c8,0x09df80c8,0xdb0081ec}},	//   _dom_, _কাজ_, _যোগা, _gemü,
   {{0x683803fd,0x644bd57f,0xc244902a,0x44c4846d}},	//   _víde, sigi, онік, _ajọṣ,
   {{0x63bd0025,0x644b87fe,0x4424a53d,0xd90f804e}},	//   kasn, pigi, _fom_, بیا_,
   {{0x2ba71370,0x9b898bbe,0x26cd8118,0x7afb80fc}},	//   _क्ला, _منزل_, treo_, _tsut,
   {{0x63bd0052,0x600681bb,0xdb00816a,0x68358118}},	//   dasn, сным_, _demó, _cáda,
   {{0x7c244d68,0x26cd960a,0xee368a7f,0x6e3a8aff}},	//   _soir, rreo_, йны_, ghtb,
   {{0x2fd98b76,0x44248069,0x7c241390,0x26cd8042}},	//   _مواد_, _yom_, _poir, sreo_,
   {{0xca29004c,0x3ebf978b,0xd79580f7,0x60d50289}},	//   _אם_, psut_, _الإخ, duzm,
   {{0x6e238247,0x7c2400e7,0x59dc1130,0x320102c4}},	//   _tonb, _voir, _बादर, _bahy_,
   {{0x6e3a8a11,0xe2970764,0xa2da873c,0x09b800ab}},	//   chtb, сар_, _नमस्, _জাহা,
   {{0x7c240ad0,0x63bd09da,0x64498118,0x27eb0326}},	//   _toir, basn, _omei, _bbcn_,
   {{0x5eeec825,0xdb008722,0x81ae8264,0x1cb681c6}},	//   _अहम्_, _memò, _কাছ_, _פלפל_,
   {{0x4424d580,0xe7e9853e,0x7a301e71,0x6f1d92d2}},	// [4920] _rom_, झ्या_, _jätk, äsch,
   {{0x44248bfa,0x6449905f,0x6ecf800d,0x26c05581}},	//   _som_, _amei, _दिनु, rsio_,
   {{0x442490af,0xdcea8d11,0x26c00652,0x69fb007c}},	//   _pom_, čiće, ssio_, _גליק,
   {{0xe29a8196,0x746980e8,0x7ae2d582,0xf487853d}},	//   гад_, арів_, ttot, مانی,
   {{0x4424d583,0xa3d90996,0x853c8110,0xdb0083a8}},	//   _vom_, ालत_, lbėt, _remó,
   {{0x78a202fd,0x7ae2d584,0x2002022e,0xc5d5035f}},	//   _čovj, rtot, _haki_, _місь,
   {{0x2002059c,0x63a40136,0xf41f0009,0x69d8d0e9}},	//   _kaki_, _ofin, yjä_, rgve,
   {{0x6d5700be,0x2002009a,0x628f81e8,0x63a40144}},	//   _הילף_, _jaki_, _ècon, _nfin,
   {{0x368abd93,0x3b07932a,0x41e081af,0x501b0039}},	//   лсон_, _лето_, _नापस, רופו,
   {{0x20021dde,0x63a400a2,0x63bd0ec9,0x2a6a3192}},	//   _laki_, _afin, wasn, jobb_,
   {{0xe85384c0,0x63bd5585,0x69c89acf,0xdb00802a}},	//   _کنند, tasn, _idde, _temó,
   {{0x24805586,0x63a2d587,0x49178039,0x20025588}},	//   _chim_, ncon, _לקבל_, _naki_,
   {{0x7e68826f,0x63a40122,0xb8658250,0x3ea680e4}},	//   podp, _dfin, _بالو, _utot_,
   {{0x63a280b9,0x290c826c,0x63a45589,0xe5348ea6}},	//   hcon, _krda_, _efin, _мель,
   {{0x20021037,0x28d91094,0x25dd8074,0xdddc2c62}},	//   _baki_, बंधि, _खाती_, _birž,
   {{0x290c8bcf,0x2002558a,0x98a501cc,0x25be8122}},	//   _mrda_, _caki_, çlı_, latl_,
   {{0x69c89fd4,0x63a2b0b2,0x2002558b,0xf7730b53}},	// [4930] _odde, dcon, _daki_, سار_,
   {{0x290cd58c,0x7a300338,0xdceb01d6,0x2007066f}},	//   _orda_, _näth, žiči, śni_,
   {{0x5f95002e,0x7f95174a,0xadea8074,0x59d28072}},	//   _минт, _манх, ज्यन_, _साजर,
   {{0x69d804b8,0x69dbae2b,0xfbd08077,0x69c88051}},	//   _över, _नाही, فته_, _adde,
   {{0x387e02be,0xdc3984b7,0x2be1103e,0x290cb25b}},	//   ître_, għġb, _कानू_, _arda_,
   {{0x290c82a5,0x27e9031d,0x2002558d,0x644f558e}},	//   _brda_, lfan_, _zaki_, hici,
   {{0xa3d90894,0x644f00a4,0x200200a4,0x6615190f}},	//   ाला_, kici, _yaki_, _inzk,
   {{0x2bdb09a9,0x63a28098,0x09ca80c8,0x27e903ec}},	//   _भाषा, ccon, ল্লা, nfan_,
   {{0xee39a80f,0xcdf5a1f6,0x25dd9344,0x290c8144}},	//   ини_, очны, _खादी_, _erda_,
   {{0x63a4558f,0x7bdf4d02,0xa6e2007b,0x24805590}},	//   _sfin, _acqu, æðin, _shim_,
   {{0xcb09073a,0x24805591,0x63bb8057,0x61558019}},	//   _של_, _phim_, _keun, _بنائ,
   {{0x63bb83d3,0x644f02be,0x59dc0321,0x645983ec}},	//   _jeun, gici, _बाहर, nnwi,
   {{0xe29a47ac,0xa3e19299,0x67d48221,0x41e092e0}},	//   раг_, _दान_, _хочу, _नामस,
   {{0x3ead91ee,0xa509a8a1,0x20025592,0x63bb8b2e}},	//   mpet_, _века_, _saki_, _leun,
   {{0x290c5593,0xf41f0364,0x24805594,0x27e929dc}},	//   ída_, mmän_, _thim_, ffan_,
   {{0x6603d595,0xf41f0c3c,0x670505fc,0x59dc00d4}},	//   _hank, lmän_, रिंक_, _बावर,
   {{0x66038f38,0x7e2615e0,0x63a2826c,0x3e6f0019}},	// [4940] _kank, одаж, vcon, yütt_,
   {{0xe6172fc4,0x66038b48,0x63a2b907,0x2002054e}},	//   оду_, _jank, wcon, _waki_,
   {{0x69dc5596,0x6835826f,0x63bb9670,0x20025597}},	//   mgre, _nádo, _beun, _taki_,
   {{0x69dc11f8,0x6603d598,0xd00a0895,0x717b0051}},	//   lgre, _lank, _теме_, _כניס,
   {{0x6f0985f5,0xd838a0f9,0x63a2d599,0xda668098}},	//   jvec, _juče_, rcon, овди,
   {{0x628194f2,0x2486807d,0x683c82be,0x63a2a0ef}},	//   _chlo, smom_, _méde, scon,
   {{0x644f559a,0x63a2890d,0xed571a1b,0x6ab7559b}},	//   yici, pcon, _дор_, _अब्र,
   {{0x2120803b,0x3ec6b3d9,0x6603a1cf,0x63bb8d00}},	//   ćih_, особ, _aank, _geun,
   {{0xb5fc84b7,0x31698380,0x7c22a127,0x2be10105}},	//   loġi, ğaza_, mjor, _काबू_,
   {{0x69c88efa,0x66038823,0x644f009a,0x2002807a}},	//   _udde, _cank, wici, žki_,
   {{0x66038faf,0xa3e1800f,0xafe6835f,0x644f1b7d}},	//   _dank, _दाम_, _можл, tici,
   {{0x09d3035a,0x7c22d59c,0x1ee980d7,0x660d89ab}},	//   तल्य, njor, جویی_, _ɗaki,
   {{0x6603d59d,0x6756804e,0x261a847d,0xdddc01b9}},	//   _fank, _بخار, बादी_, _birż,
   {{0x644f2d11,0x7e04000c,0x38698024,0x69dc559e}},	//   sici, रयोग_, čare_, ggre,
   {{0x26050063,0x7a3f001b,0xe3bf03a8,0xf84b02a9}},	//   _होगी_, vště, pañ_, ачай_,
   {{0x26c2816b,0x60c901a9,0x2d98559f,0x68380144}},	//   škou_, ņemo, _agre_, _pída,
   {{0xdd9b0fbe,0x27e91a5a,0x9f4b0722,0x7c22d5a0}},	// [4950] аше_, rfan_, _racó_, djor,
   {{0x44290104,0x61f8a4b2,0x26c4a29d,0x63bbd5a1}},	//   _hoa_, jevl, ismo_, _seun,
   {{0x6aa9d5a2,0x4429011b,0x201601ac,0x644d00ee}},	//   _stef, _koa_, ácií_, _kmai,
   {{0x7bdd55a3,0x442955a4,0x7c22b28c,0x29015128}},	//   ngsu, _joa_, gjor, _isha_,
   {{0x442955a5,0x78a2005c,0x62818a2a,0x68310aa2}},	//   _moa_, _čovi, _phlo, _rådh,
   {{0xceb23e22,0x442955a6,0x2c5601a9,0x6f0f0037}},	//   _איך_, _loa_, rādi_, _ircc,
   {{0x628f81e8,0x6603d5a7,0x644d0198,0x63bb9c11}},	//   _ècom, _rank, _omai, _teun,
   {{0x442955a8,0x59d789a3,0x66038a76,0x6f09816d}},	//   _noa_, _ठाकर, _sank, tvec,
   {{0x6603d5a9,0xef1697ae,0x69dc407e,0xf1a79ef3}},	//   _pank, змы_, ygre, _дрен,
   {{0xee39964f,0x644d195f,0x683c9a90,0x3eb901ec}},	//   сно_, _amai, _réde, _mwst_,
   {{0x4429156b,0x7c29c6f7,0x6603d5aa,0x7c3b9651}},	//   _boa_, _koer, _vank, _klur,
   {{0x442907f4,0x3ead904a,0x6603985b,0x7c29cff6}},	//   _coa_, ppet_, _wank, _joer,
   {{0x66039bb8,0x4429510e,0x69dc55ab,0xc05280be}},	//   _tank, _doa_, tgre, _אזא_,
   {{0x683c8019,0xd838812b,0xc60a06a7,0x2496803d}},	//   _véde, _vuče_, _होंठ_, _کنيد_,
   {{0x7c3ba192,0x28cf914f,0x3eb90114,0xe7e2815c}},	//   _olur, सूचि, _awst_, क्का_,
   {{0x7a30016d,0xd83881dd,0xb8f40cf0,0x644d55ac}},	//   _nätv, _tuče_, _हट_, _gmai,
   {{0xe7e3959a,0x7d0e05b7,0xee3a0c9b,0x2fc00224}},	// [4960] _गाना_, _srbs, бна_, raig_,
   {{0x7c3bd5ad,0x2fc055ae,0xd6cf0199,0x3ea003ed}},	//   _alur, saig_, اقل_, rqit_,
   {{0x7c2990f4,0x399b012a,0xb3a982bb,0xa06a0071}},	//   _boer, _לייד, ğını, _гана_,
   {{0x386d89c4,0xb3a9817b,0xd6d9809a,0x7c29d5af}},	//   joer_, şını, kuł_, _coer,
   {{0x7c229c19,0x224c808e,0x320582f9,0x08e68264}},	//   rjor, _pmdk_, _baly_, কিছু_,
   {{0xd5b20b76,0xa2cdbb04,0x38a38059,0x6831128d}},	//   _سفر_, _सिर्, _sıra_, _rådi,
   {{0x490f275c,0x61f8d5b0,0x60c80174,0x764e0314}},	//   डियो_, revl, ádmh, _imby,
   {{0x61f8812b,0x97148698,0x8f468098,0xd6da80e8}},	//   sevl, дмиц, зход, бто_,
   {{0xbbd881a2,0xa2ce008e,0x26c48196,0x7a3d83ec}},	//   डलीक, _तिष्, usmo_, _sète,
   {{0xba29ca1c,0x2d98835f,0xceb30039,0x7bc0007b}},	//   _وسلم_, øre_, עית_, ðmun,
   {{0x25dd8076,0xfc3f00f7,0x386d9a40,0xe0d28019}},	//   _खारी_, thí_, boer_, _سزا_,
   {{0x2fc08125,0x897b80be,0x6249016b,0x644d0609}},	//   _þig_, _פראצ, nžov, _qmai,
   {{0x288b84c0,0x44290033,0x7afd00f3,0x764e01a3}},	//   _اصلی_, _voa_, uwst, _omby,
   {{0x26c28110,0x6f02b392,0xa2ce01d0,0x7de69ab3}},	//   škos_, _isoc, _तिर्, _رستم,
   {{0x0cd700c8,0x442955b1,0xae0a001b,0x61142133}},	//   _সন্ত, _toa_, _होइन_, ндру,
   {{0x644d3d80,0xa2cd815c,0x940b954b,0x764e471f}},	//   _umai, _सिल्, _सोंच_, _amby,
   {{0x7c299151,0x387e0036,0x7bcd02f9,0x92080ec3}},	// [4970] _roer, îtra_, _idau, _brāļ,
   {{0xd3580039,0x290101c0,0x248482c4,0x6aad00b8}},	//   _משחק_, _tsha_, _ahmm_, _itaf,
   {{0x7c3bd5b2,0xd7dc853e,0x7c299ab3,0xdb04007b}},	//   _plur, _यांच, _poer, _heið,
   {{0x442987ca,0x628a81b0,0x683801d0,0x645d55b3}},	//   ða_, emfo, _jídl, nnsi,
   {{0x7c298b3c,0xa3e20ebf,0x25dd93ba,0x386d9ad7}},	//   _voer, न्ट_, _खाली_, voer_,
   {{0x20090110,0xae0a016f,0x629f008e,0x2484808e}},	//   ldai_, _होऊन_, _muqo, _ehmm_,
   {{0x6f02d5b4,0xdb040125,0x7c298b3c,0x2ee90125}},	//   _asoc, _leið, _toer, ltaf_,
   {{0x200900dd,0x77f981cb,0x7a3002af,0xd6d9809a}},	//   ndai_, ्येक_, _hätt, tuł_,
   {{0xfaf09368,0x2ee9031d,0x7a300074,0xd7068009}},	//   _مثل_, ntaf_, _kätt, дные_,
   {{0x7bcd0012,0xf1a79289,0x7a3055b5,0x629755b6}},	//   _adau, _хран, _jätt, _nixo,
   {{0x20068307,0x6607003b,0x69c39473,0x6f0d0042}},	//   _faoi_, _majk, mane, hvac,
   {{0x7a3000f2,0x69c383fd,0x6607005c,0x6fd6880a}},	//   _lätt, lane, _lajk, rücü,
   {{0x20090355,0x7a348a2a,0x261ab26c,0x26c28088}},	//   ddai_, _bàth, बाशी_, škor_,
   {{0x27ed82af,0x660728fc,0x20090110,0x7a301a50}},	//   lfen_, _najk, edai_, _nätt,
   {{0x63a9d5b7,0x261a890f,0xafe600e8,0x6f0d828f}},	//   _ofen, बारी_, мовл, _šach,
   {{0xf7721e95,0x6d4509ca,0x629716cb,0x6b9bd5b8}},	//   ناء_, dzha, _eixo, _ngug,
   {{0x7a3004b8,0x69c3d5b9,0x2cad02ee,0xf4130039}},	// [4980] _bätt, kane, _čeda_, _יפה_,
   {{0x201955ba,0x69c3d5bb,0x63a9846d,0x6607111b}},	//   _ensi_, jane, _afen, _cajk,
   {{0x621b093f,0x61fc07d5,0xafdb0edd,0x290400eb}},	//   _וויק, merl, _blød, āmas_,
   {{0x25fa101c,0x61fc16fa,0x629f208e,0xa3e255bc}},	//   _उसकी_, lerl, _yuqo, न्च_,
   {{0x69c3829b,0xdb0081ac,0x62491c24,0x59d2238c}},	//   fane, _nemô, ržov, _तयार,
   {{0x69c38d23,0x27e055bd,0x27edaba9,0x320a422a}},	//   gane, lgin_, efen_, ndby_,
   {{0x27edc964,0x26f88576,0x2c0e0063,0x63a9bf3a}},	//   ffen_, ्ट्र_, ियां_, _ffen,
   {{0x27e02031,0x66072cf7,0x61e901dd,0x161c016f}},	//   ngin_, _zajk, đeli, नावर_,
   {{0xa3e203bb,0x644280f7,0x61fc2315,0x60dc010c}},	//   न्छ_, mhoi, kerl, hurm,
   {{0x38698025,0x4426ad6d,0x6838026f,0x61fc0669}},	//   čara_, ljo_, _sídl, jerl,
   {{0x61fc55be,0x7bc0bb0f,0xb143802e,0x6aad4ef7}},	//   derl, _kemu, _инфл, _staf,
   {{0x7bc08b17,0x6835826f,0x64428009,0x6aa0acc3}},	//   _jemu, _nádh, nhoi, _kumf,
   {{0x7bc09ca6,0xf047819f,0x61fc55bf,0x645d46be}},	//   _memu, _تعلی, ferl, rnsi,
   {{0x7bc0c980,0x60dc022b,0xdb04007b,0xc5d580ab}},	//   _lemu, furm, _veið, ত্বপ,
   {{0x7a3004b8,0xdb1d008b,0xa3e70f97,0x8c671071}},	//   _rätt, masí, _पाप_, _отид,
   {{0x7a302e6d,0x27e02475,0x7bc09517,0x6f0d00fe}},	//   _sätt, ggin_, _nemu, tvac,
   {{0x61fc07d9,0x4426854b,0x290c016d,0x6aad0010}},	// [4990] berl, djo_, ådar_, _utaf,
   {{0x61fc0693,0x2ca704c3,0xab5dc6e9,0x60dc55c0}},	//   cerl, índo_, _jeże, burm,
   {{0x69c3d5c1,0xb3a98059,0x63a9d5c2,0x7bc08019}},	//   vane, şımı, _pfen, _bemu,
   {{0x44390367,0x69c3d5c3,0x7bc080ee,0x09d7816f}},	//   nks_, wane, _cemu, ठल्य,
   {{0x69c3afb9,0xe5c705c2,0x7bc0d5c4,0xa3e7035a}},	//   tane, _осво, _demu, _पान_,
   {{0xdd868bbe,0xd3380051,0x683c80e7,0xa2d720d8}},	//   _مو_, ורדה_, _réda, _बिन्,
   {{0xdb0b8013,0x27ed87d9,0x3e74016d,0x2eff8239}},	//   tagó, tfen_, rätt_, wwuf_,
   {{0x6442d5c5,0x44390a0f,0xb91a0a2c,0x7bc0978f}},	//   choi, jks_, _anyị_, _gemu,
   {{0x443fd5c6,0x27edd5c7,0xf70880ff,0x9f4b016b}},	//   _ilu_, rfen_, _củ_, _obcí_,
   {{0x442d81d8,0x443955c8,0x7bc082ee,0xab84a063}},	//   _hoe_, eks_, _zemu, _руск,
   {{0x442dd5c9,0x443fa08b,0x7af655ca,0x7c2d1bd4}},	//   _koe_, _klu_, _spyt, _boar,
   {{0x69c1d5cb,0x290582a3,0xd8389487,0xb91a01bc}},	//   _hele, _isla_, _tuča_, _enyị_,
   {{0x2bd0816f,0x442db2b3,0x7c2d0162,0x3f9d8133}},	//   हणता, _moe_, _doar, _igwu_,
   {{0x69c1d5cc,0x442d8006,0x97568039,0x60dc55cd}},	//   _jele, _loe_, _אינו_, turm,
   {{0x7c2d0012,0x69c18855,0x3da6835f,0x443fd5ce}},	//   _foar, _mele, _якщо_, _olu_,
   {{0x69c1d5cf,0x02df88fd,0x442d8cde,0x443955d0}},	//   _lele, _नमून, _noe_, cks_,
   {{0x7bc629b3,0x683585e4,0x27e055d1,0x068601cf}},	// [49a0] maku, _cádi, rgin_, еган,
   {{0x7bc0845c,0x7bc60393,0x2d9c0bc5,0x69c1d5d2}},	//   _semu, laku, øve_, _nele,
   {{0x7bc0859c,0x442d957a,0x443f956f,0x644280f7}},	//   _pemu, _boe_, _blu_, thoi,
   {{0xdd8f12dc,0x09c8816f,0x4426d5d3,0xa06a0071}},	//   حوم_, रण्य, ujo_, _хама_,
   {{0x68e300f2,0x4426bf7e,0x443f89ca,0x7794026a}},	//   _ändr, rjo_, _dlu_, _شیطا,
   {{0x443fd5d4,0xfce63de7,0x78a1d5d5,0x3f9dd5d6}},	//   _elu_, _пого, _bulv, _agwu_,
   {{0x7bc63d5e,0x7bc0d5d7,0x443fa543,0x644281a8}},	//   kaku, _temu, _flu_, phoi,
   {{0x38603b8d,0x68e303ba,0xfba483eb,0x6b840135}},	//   nnir_, _ånde, _ओलिम, _ozig,
   {{0x6440d559,0x69c18065,0x7bc655d8,0x09d800ab}},	//   _ilmi, _fele, daku, দ্যা,
   {{0x69c1d5d9,0x6e2e0094,0x443f80d2,0x7c2d095d}},	//   _gele, _jobb, _zlu_, _soar,
   {{0x6e2e3fe4,0x78a18aa2,0x7c2d0087,0x3860007b}},	//   _mobb, _gulv, _poar, knir_,
   {{0x61e5034a,0x7bc606a0,0xf708801c,0xda1e8075}},	//   _schl, gaku, _tủ_, पावत_,
   {{0xa3e7146d,0x629ab22a,0x443955da,0x2aab0656}},	//   _पाठ_, _kito, rks_, ятно_,
   {{0x44392302,0x171b8039,0x6e2e228c,0x629ad5db}},	//   sks_, _מודע, _nobb, _jito,
   {{0xa3e183db,0x6b8452a1,0x7bc638ba,0x2cad017f}},	//   _दाल_, _ezig, baku, _čedo_,
   {{0x3860007b,0x4ea711d2,0x629ad5dc,0xc6a72138}},	//   gnir_, ержа, _lito, ержи,
   {{0x63ad031d,0x64438168,0x63bb008b,0x7c3d03ed}},	// [49b0] _ifan, ënim, ðunu, ërru,
   {{0x629ac193,0x443fb644,0x6e2e1c33,0x6440d5dd}},	//   _nito, _slu_, _cobb, _almi,
   {{0x6e2e1277,0xf65380be,0x69c73f01,0x442dd5de}},	//   _dobb, נצע_, maje, _poe_,
   {{0x69c70dd1,0x13a78077,0x629ab673,0xe3b38829}},	//   laje, رنتی_, _aito, ارض_,
   {{0x629a9efb,0x63ad280d,0x09e580b3,0x91e5be80}},	//   _bito, _mfan, волн, воле,
   {{0x69c755df,0x660a8859,0x7bc60518,0x6440d5e0}},	//   naje, _nafk, zaku, _elmi,
   {{0xa2cd91be,0xfa1300c8,0x7bc63f6d,0x63ad5589}},	//   _सिक्, _সকাল_, yaku, _ofan,
   {{0xe81e8074,0x200b02a5,0x62888009,0x69c1d5e1}},	//   भाषा_, _jaci_, _ehdo, _wele,
   {{0x600691e9,0x629ad5e2,0x69c7029b,0xdcfc00eb}},	//   тным_, _fito, kaje, _izrā,
   {{0x7bc6400f,0x63ad55e3,0x660a84b9,0x7a300106}},	//   waku, _afan, _cafk, _nätp,
   {{0x69c755e4,0x04460364,0x7bc63d95,0x0d828987}},	//   daje, венн, taku, ильн,
   {{0x200b0052,0x25dd85fc,0x2af58074,0x3f9d8870}},	//   _naci_, _खाकी_, _इहाँ_, _ugwu_,
   {{0xe72e9401,0xde059860,0x38600176,0xdee5a796}},	//   _те_, _апли, vnir_, _роли,
   {{0xe2972afb,0xc3328051,0x7bc655e5,0xe5a2802e}},	//   кая_, סום_, saku, _киши,
   {{0xe29755e6,0x7bc62883,0x200b55e7,0xa2ce09c1}},	//   тар_, paku, _baci_, _तिक्,
   {{0x63a904c3,0x27ffca91,0x200dc0d9,0x200b55e8}},	//   ñent, neun_, ndei_, _caci_,
   {{0x38600125,0xe9f90104,0xe5a6067c,0x200b55e9}},	// [49c0] rnir_, _quả_, визи, _daci_,
   {{0x69c70052,0x683803a7,0x200b0197,0x4f950087}},	//   caje, _mídi, _eaci_, урсу,
   {{0x27ff808e,0x69d90158,0x200b13df,0x629ad5ea}},	//   keun_, _אַרו, _faci_, _rito,
   {{0x629ad5eb,0x27ff826b,0x69d781df,0x7794015b}},	//   _sito, jeun_, óxen, _میزا,
   {{0x6e2e55ec,0x7c659a00,0x200d911d,0x6aa40036}},	//   _tobb, دالل, ddei_, _juif,
   {{0x5333c845,0x9586104b,0x6f040314,0x200b09ab}},	//   решт, _алге, mwic, _zaci_,
   {{0x2576003d,0x9c7d0289,0x645880e7,0x98c38a8e}},	//   _شهرس, luče, évis, асыл,
   {{0x629acd81,0x27ff82f7,0xdfd080f7,0x6d489e1e}},	//   _wito, geun_, حية_, vzda,
   {{0xe7e38076,0x629ad5ed,0xfaa6884b,0x26c7005c}},	//   _गारा_, _tito, _разо, ćnog_,
   {{0x4375827e,0x63ad0087,0x629a815f,0x200d8162}},	//   _суст, _sfan, _uito, adei_,
   {{0x248951c4,0x69c755ee,0xd5b881a9,0x63ad0192}},	//   _pham_, vaje, rbā_, _pfan,
   {{0xa3ea8076,0x5fe11c3b,0x6fa68072,0x26cf0061}},	//   _माफ_, _फाइल, _ऑलिं, ágok_,
   {{0xa3ea9344,0x660a8041,0xfe468d9e,0x1de24073}},	//   _मान_, _tafk, _индо, _पांत,
   {{0x7df3000d,0xaa641697,0x200b55ef,0xab5d8372}},	//   _měsí, атск, _saci_, _jeża,
   {{0x69c70bc1,0x24895591,0x200b55f0,0x0efd0072}},	//   raje, _tham_, _paci_, ॉट्स_,
   {{0x6ebf913d,0x69c755f1,0x63ad00b8,0x63a0808e}},	//   लीवु, saje, _ufan, _ngmn,
   {{0x81cd80c8,0x09d800ab,0x44ce8d42,0x22840106}},	// [49d0] ষ্ট_, দ্ধা, lę_, söka_,
   {{0x7c3d55f2,0x7aed52fa,0x7a3d8980,0x41a703ca}},	//   lksr, _iqat, _rèto, _खलिस,
   {{0x44ce8d42,0x3cd515a6,0x723401a8,0x200b55f3}},	//   nę_, ужес, _خريط, _taci_,
   {{0xccf38158,0x1c1d8305,0x7a2b01ec,0xf34e81bc}},	//   יכע_, फाइल_, _nütz, rụnụ_,
   {{0x69c50057,0x62358152,0x41a71a3b,0x6458823e}},	//   _kehe, леду, _खलास, èvia,
   {{0x44ce8d42,0x2fc91c11,0x657c267f,0x683855f4}},	//   kę_, laag_, _fyrh, _rídi,
   {{0x69c555f5,0x44ce809a,0x27ffa4c2,0x63a4d5f6}},	//   _mehe, ję_, teun_, žina,
   {{0xd7099b93,0x69c555f7,0xead1077f,0x44ced5f8}},	//   ение_, _lehe, _pẹlu_, dę_,
   {{0x200dd5f9,0x27ff8706,0xe5a58dc0,0xe8e10129}},	//   rdei_, reun_, липи, _ướp_,
   {{0x9a87abca,0x7afb8637,0x41c7d5fa,0x69c555fb}},	//   _рубл, _iput, _रजिस, _nehe,
   {{0x25eb0076,0x6ed8858c,0x44ced5f8,0x3866804a}},	//   _चानी_, _मिथु, gę_, _fjor_,
   {{0xc209004c,0xdb040118,0x9f058019,0x999e8176}},	//   _מה_, _afiá, _موصو, _antň_,
   {{0xa3e1abef,0x69c54a2b,0x2fc955fc,0x628f81e8}},	//   _दाई_, _behe, daag_, _ècos,
   {{0x6446387b,0x387fb90f,0x9c7d005c,0x6fe1064a}},	//   shki, llur_, vuče, _फाउं,
   {{0x213e1ddd,0x69c51acf,0x44ce809a,0xd9430371}},	//   áth_, _dehe, cę_, бери,
   {{0x6f0402af,0x2b55003d,0x9c7d0289,0x69c51fdb}},	//   twic, ایید_, tuče, _eehe,
   {{0x44201dae,0x33260086,0x64599998,0x645600b4}},	// [49e0] _ini_, _çox_, diwi, _imyi,
   {{0x443205a4,0x69c51781,0xa206433d,0x9c7d1249}},	//   _hoy_, _gehe, _спод, ruče,
   {{0x320c8e04,0x7afb81bc,0x442035fa,0x63a9219f}},	//   _rady_, _aput, _kni_, žene,
   {{0xf7678288,0x0b4684fa,0x320c826f,0xfaa6976e}},	//   _ها_, лнен, _sady_, гадо,
   {{0xa3e70fcc,0x4caa80c8,0x60c90029,0xa09b00be}},	//   _पास_, _কিছু, ņemt, _ריכט,
   {{0xa2d7000c,0x35a355fd,0xada30196,0x2d878088}},	//   _बिस्, _гарг, _гарл, _ozne_,
   {{0x6601a52d,0x7afbd5fe,0x629e0144,0x320c84e8}},	//   delk, _eput, _mipo, _vady_,
   {{0x04438318,0xc6f8a466,0x387f807b,0x4420026b}},	//   _лесн, вних_, glur_, _nni_,
   {{0xab668656,0x320c801b,0x44ce8035,0x627b8035}},	//   _свал, _tady_, wę_, _słoń,
   {{0x442055ff,0x44ce8d42,0x1ef78013,0x9e06a659}},	//   _ani_, tę_, اعية_, учил,
   {{0x44ee027f,0x69c53735,0x44200101,0x387fd600}},	//   ný_, _rehe, _bni_, blur_,
   {{0x69c55601,0xa2db9c3b,0x69cad397,0x443206cb}},	//   _sehe, _निम्, lafe, _coy_,
   {{0x44205602,0x660184e8,0x44320e1b,0x44cec702}},	//   _dni_, belk, _doy_, sę_,
   {{0x44205603,0x69cad604,0xdd948196,0x44ce9c28}},	//   _eni_, nafe, _калы, pę_,
   {{0x629e0b20,0x61f582d0,0x69c50061,0x765ad605}},	//   _dipo, _özle, _vehe, mity,
   {{0x765ad0d3,0xa2ce016f,0x7ae28110,0x57b53317}},	//   lity, _तिच्, kuot, рбат,
   {{0xcddb19e3,0x69c55606,0xf3f000f7,0x2fc90fb0}},	// [49f0] ење_, _tehe, _رأي_, raag_,
   {{0x59e0800c,0x765a9bee,0x7ae28110,0x443d81bf}},	//   _नागर, nity, duot, wkw_,
   {{0x6459d607,0x2d87016d,0x660e01b4,0xc66803a7}},	//   tiwi, åne_, _dabk, уште_,
   {{0x6601809a,0x765a8009,0x64440706,0x629e038a}},	//   zelk, hity, _xlii, _zipo,
   {{0x34c18b6f,0x3ea90609,0x645981bf,0x660e0282}},	//   _शब्द, qqat_, riwi, _fabk,
   {{0x50b811fb,0x08d58656,0x6459a79e,0x6835826f}},	//   _جدید_, ация, siwi, _nádr,
   {{0x90c29b93,0x765ad5ad,0xdb0d002a,0x63bd02c4}},	//   обще, dity, _meañ, kbsn,
   {{0x44d10a8e,0x3ea682d5,0xc0a88199,0x38aa8362}},	//   mą_, _buot_, داول_, _dùr_,
   {{0x7afb803a,0xeab087bd,0x7bcb9f6b,0x41e791cc}},	//   _uput, _فعل_, magu, _مساف,
   {{0xee3995e0,0x44325608,0xee368364,0x7bcbcb14}},	//   тно_, _soy_, ины_, lagu,
   {{0x9967812f,0x44d11c30,0x629e5609,0x248d8640}},	//   _стал, ną_, _ripo, _khem_,
   {{0x2aab8022,0x68e3d60a,0x629e560b,0x7bcb85ac}},	//   _køb_, mund, _sipo, nagu,
   {{0xa3e71344,0x68e3d60c,0x443200ab,0x66018102}},	//   _पार_, lund, _voy_, pelk,
   {{0x7bcb8a8c,0x44d101e2,0x200fd60d,0x7f8480f7}},	//   hagu, ką_, _hagi_, _الهن,
   {{0x44d10d12,0x68e3d60e,0x20563ff1,0x4420061b}},	//   ją_, nund, атар, _tni_,
   {{0x44ee0a56,0x44d10d42,0x645d560f,0x7bcbaeae}},	//   vý_, dą_, érit, jagu,
   {{0xe7370364,0x7bcbd610,0x2ca79766,0x68e3d611}},	// [4a00] ает_, dagu, _hund_, hund,
   {{0x68e3d612,0x200f8812,0x44ee003e,0x2ca7c6b6}},	//   kund, _lagi_, tý_, _kund_,
   {{0x9c7d0024,0x44d118eb,0x68e38074,0x89db0039}},	//   luča, gą_, jund, _בחיי,
   {{0x44ee0a56,0x2ca788cf,0xf09f5613,0x66e6210d}},	//   rý_, _mund_, _già_, _кома,
   {{0x69cad614,0x63a4b999,0x6b89809a,0x291a2e0a}},	//   tafe, žino, _czeg, _hrpa_,
   {{0x68e3d615,0x7ae281e2,0xc8da016f,0x09d800ab}},	//   fund, ruot, _बटाट, দ্রা,
   {{0x200f845c,0x68e3a6e7,0x7bcbcb5d,0x3ea6c15c}},	//   _bagi_, gund, bagu, _suot_,
   {{0x63a42eda,0xa2d71c4f,0x63ad8511,0x64a31597}},	//   _ngin, _बिल्, ñant, _фата,
   {{0x9c7d011f,0x3ea6c752,0xf1c605fc,0x09e6c019}},	//   juča, _quot_, वरान, _возн,
   {{0x63a4011e,0x9c7d02a5,0x68fe035f,0xd838811f}},	//   _agin, duča, _oppd, _muči_,
   {{0x24421220,0x69c8d616,0x63a4008e,0x765ad617}},	//   _cómo_, _iede, _bgin, rity,
   {{0x69c8d618,0x765a8364,0x200fd619,0x290c8cf4}},	//   _hede, sity, _gagi_, _isda_,
   {{0x69c8d61a,0xab8705e9,0xba7701a8,0x78a88338}},	//   _kede, рунк, لاست, _hudv,
   {{0x69c8b31e,0x2004d61b,0x63a400ad,0x2245007b}},	//   _jede, lemi_, _egin, ólk_,
   {{0x645d02be,0x6cd489a7,0x228981ac,0x7bcbcffd}},	//   éris, _اقبا, núka_, yagu,
   {{0x69c8a2ba,0x9c7d0301,0x2004d61c,0x44d10084}},	//   _lede, buča, nemi_, vą_,
   {{0x44d1009a,0xcf9380be,0x78a8d61d,0x69c88bfd}},	// [4a10] wą_, ַטע_, _ludv, _oede,
   {{0x645d561e,0x38698025,0x44d11c30,0x68e3b36a}},	//   lisi, čari_, tą_, yund,
   {{0x7bcbd61f,0x6b898019,0x2004d620,0x248d81c5}},	//   tagu, _szeg, kemi_, _phem_,
   {{0x645d5621,0x44d10d42,0x68e3d622,0xdcef82a5}},	//   nisi, rą_, vund, žeći,
   {{0x7bcbd623,0x77640698,0x68e3d624,0xd8388279}},	//   ragu, _държ, wund, _guči_,
   {{0x27e95625,0x7bcbd626,0x78a8825b,0x21699541}},	//   lgan_, sagu, _budv, лили_,
   {{0x645d22b3,0x200f8867,0x248dd627,0x66050359}},	//   kisi, _pagi_, _them_, mehk,
   {{0x27e9059c,0x66050057,0x2ca782af,0xb8ff800c}},	//   ngan_, lehk, _rund_, _ति_,
   {{0x200fd628,0x2ca78ac6,0x27e95629,0x6b80d62a}},	//   _vagi_, _sund_, igan_, _gymg,
   {{0x69c89989,0x68e3d62b,0x27e90362,0x2ca7ad91}},	//   _gede, pund, hgan_, _pund_,
   {{0x645d009e,0x200fd62c,0x63b88187,0xda7a83de}},	//   fisi, _tagi_, _àaná, _ענער,
   {{0x4aab85b3,0x6aa18352,0x69c8d62d,0x69d703a8}},	//   _चढाव, _hilf, _zede, _adxe,
   {{0xd87480f7,0x660500ee,0x69c882d0,0x7bc99151}},	//   _بالب, kehk, _yede, _meeu,
   {{0x9c7d005c,0xe5a58081,0x7bc983b2,0x683c80e7}},	//   ruča, _уики, _leeu, _rédi,
   {{0x64b587bd,0x61430c99,0x6aa19106,0xd9430aac}},	//   _احتر, пера, _milf, пери,
   {{0x27e92973,0x63a40503,0x645d1b7d,0x7bd602c4}},	//   ggan_, _ugin, cisi, _udyu,
   {{0xef1a0110,0x7c244193,0x44f1d62e,0x2bb5103e}},	// [4a20] ыма_, _inir, lá_, ंडरा,
   {{0xa3ea809a,0x27e90014,0x7ae6562f,0x7c360b0b}},	//   _माह_, agan_, mukt, _hoyr,
   {{0x68fe04b8,0x44f184ab,0xeafa0416,0x7ae64412}},	//   _uppd, ná_, _شرکت_, lukt,
   {{0x69c8b78d,0x69ce4717,0x2c21000f,0xd8388da8}},	//   _sede, labe, याएं_, _tuči_,
   {{0x69c882b1,0x44f1826f,0x06b200ab,0x26cf0019}},	//   _pede, há_, _চিকি, ágot_,
   {{0xfe678307,0x9c7d04c4,0x645d5630,0x660507cf}},	//   _رد_, jučn, zisi, cehk,
   {{0x69c8d631,0x7c242a02,0x2004d632,0xa3d80a16}},	//   _vede, _onir, temi_, ाणा_,
   {{0xdd8f00f7,0x44f19c2f,0x6d5c9c05,0x69c8a32e}},	//   _سوق_, dá_, úram, _wede,
   {{0x69ce4e7b,0x69c8a90f,0x20049a4d,0x6aa1aebd}},	//   kabe, _tede, remi_, _filf,
   {{0x2004d633,0x7c245634,0x6442b9a3,0x225a0748}},	//   semi_, _anir, lkoi, _nmpk_,
   {{0x645d5635,0x99869e95,0x667b0158,0xd7faa482}},	//   tisi, _الاو, רטיק, _бул_,
   {{0xdee6838d,0x3d000fea,0x9c7d050b,0x2ee05636}},	//   _годи, _रहने_, krče, krif_,
   {{0xd7968307,0x645d5637,0x073a8bbe,0xafdb0366}},	//   _الشخ, risi, _حساب_, _fløj,
   {{0x7c245638,0x69ce5639,0xa2db9516,0x44f1936f}},	//   _enir, gabe, _निस्, bá_,
   {{0x27e90428,0x645d0042,0x6e3509a4,0xd2581138}},	//   tgan_, pisi, _rozb, сця_,
   {{0x63a48042,0x25eb0074,0xdbf1801b,0x2ee00114}},	//   žinj, _चाही_, _přík, frif_,
   {{0x69ce563a,0x94120085,0x40340198,0x6e35563b}},	// [4a30] babe, _niyə_, четс, _pozb,
   {{0x69ce0333,0x7bcf208b,0x6b8d1768,0x27e9563c}},	//   cabe, lacu, _izag, sgan_,
   {{0x40350087,0x9f5905a4,0x4424bab1,0x660523be}},	//   _денс, _pasó_, _bnm_, rehk,
   {{0x26cf0019,0x6aa1cb4f,0xbebb0168,0x7bcf563d}},	//   ágos_, _silf, _rrëf, nacu,
   {{0x7981ad12,0x38690408,0xa3e7000f,0x44f1c855}},	//   _sylw, mnar_, _पाई_, zá_,
   {{0x6ca708cc,0x6e3500d2,0xe2999677,0x41e780e8}},	//   _граж, _uozb, шал_, сіда,
   {{0x44f1841c,0x6443d63e,0xa2db8b99,0x7bc98bfd}},	//   xá_, ënis, _निव्, _teeu,
   {{0x44f18a56,0x69ce563f,0x38690357,0x7ae60122}},	//   vá_, zabe, nnar_, yukt,
   {{0x6aa1805f,0x38695640,0xac9481e5,0x09e100ab}},	//   _tilf, inar_, _хатш, ম্যা,
   {{0x44f18626,0xc0cbc7a8,0x3f8380eb,0xe81e816f}},	//   tá_, _буде_, āju_, _मोठा_,
   {{0x6449a32e,0x9c7d10d1,0x38692a4c,0x3207d641}},	//   _klei, ručn, knar_, meny_,
   {{0x78a28698,0x69ce5642,0x32079122,0x7ae61400}},	//   _giov, wabe, leny_, tukt,
   {{0x69ce5643,0x683ca6d5,0xe042835f,0x26c6819d}},	//   tabe, _cédu, _інши, _gwoo_,
   {{0x6449c5b8,0x38699487,0x2fd9002a,0x539a825f}},	//   _llei, čaru_, _adsg_, יירו,
   {{0x69ce5644,0x6449d645,0x6b8d011e,0x3ce08035}},	//   rabe, _olei, _ezag, _किये_,
   {{0x69ce5646,0x38692d85,0xa3e70996,0x44d58029}},	//   sabe, gnar_, _पाए_, mā_,
   {{0xa2db8b84,0x69ce43e3,0x44d580eb,0x24802d68}},	// [4a40] _निष्, pabe, lā_, _ikim_,
   {{0x44248079,0x09e100ab,0x645b81a8,0xf65f3c10}},	//   _snm_, ম্বা, _amui, _svær_,
   {{0x44d58029,0x6449d647,0x6f1d02af,0x8fa60eb3}},	//   nā_, _blei, _ersc, _мане,
   {{0x9c830a21,0x984c801b,0x64498224,0x442480e5}},	//   _účto, věď_, _clei, _qnm_,
   {{0x64428364,0x4424ba98,0xb60582d4,0x3f821238}},	//   rkoi, _vnm_, _kršč, _uyku_,
   {{0xa2db885d,0x44d58029,0x6449b0a4,0x248000ee}},	//   _निर्, kā_, _elei, _lkim_,
   {{0x44d58341,0x64498357,0x8c468ab2,0xf65f007b}},	//   jā_, _flei, _деве, _tvær_,
   {{0x09b70c78,0x6449d648,0x44d580eb,0x24800282}},	//   _अभ्य, _glei, dā_, _nkim_,
   {{0xf09301db,0x7bc282be,0x32079517,0x466aa344}},	//   ונה_, mbou, beny_, иром_,
   {{0xa3ea800f,0x386d0503,0x683c82be,0x2486821e}},	//   _माँ_, čeri_, _rédu, llom_,
   {{0x64498364,0x7bcf3736,0x683c8036,0x3869099b}},	//   _ylei, tacu, _sédu, ynar_,
   {{0x7bc29377,0x9c7d016b,0x80b1025a,0x6b840314}},	//   nbou, ručo, _आंबे, _byig,
   {{0xfbd38051,0x25eb05b3,0x7e7a812b,0x61fe00b9}},	//   ותר_, _चाली_, potp, _bbpl,
   {{0xa3e70361,0x24800214,0x7bcf0216,0x6f02b2a3}},	//   _पाक_, _ekim_, sacu, _ipoc,
   {{0x24868503,0xa3ea809a,0xa2d70b04,0x63b60114}},	//   klom_, _मां_, _बिक्, _ffyn,
   {{0x765c031d,0x24868088,0x6f028133,0xd8388da8}},	//   _amry, jlom_, _kpoc, _tuču_,
   {{0x38695649,0xddab1071,0x69da875f,0x248680e1}},	// [4a50] rnar_, ател_, _odte, dlom_,
   {{0xe81b0076,0x291e8059,0x7ae286aa,0xf1bf801c}},	//   _पोरा_, _orta_, drot, _đáo_,
   {{0x628705f5,0x6449d64a,0x3869564b,0xd49b846e}},	//   mljo, _plei, pnar_, ард_,
   {{0x248682a5,0x69da80ee,0x3cfb80be,0x442781a8}},	//   glom_, _adte, שלאנ, غراف,
   {{0x44c78065,0x7ae2ad54,0x291ead7b,0x644981b0}},	//   ző_, grot, _arta_, _vlei,
   {{0x6aad564c,0x6f0d0c53,0xab5d822b,0x64498428}},	//   _muaf, mwac, _jeżi, _wlei,
   {{0xa3eb023c,0x291e812b,0x3f89826c,0x768b02d0}},	//   मला_, _crta_, _šau_, lüyo,
   {{0x3207c640,0x3d000321,0x7ae2888b,0x44d580eb}},	//   seny_, _रहते_, brot, vā_,
   {{0x63a9d64d,0x768b0214,0x7ae2d64e,0x9c7d0289}},	//   _igen, nüyo, crot, ručl,
   {{0x44d58029,0x44c78065,0x24800ad4,0x5bb6024c}},	//   tā_, tő_, _skim_, ूर्व,
   {{0x7bcd24cc,0x6615564f,0x69c3807a,0x3eb980eb}},	//   _beau, _mazk, mbne, ūst_,
   {{0x44d580eb,0x801480e8,0x7bcd0087,0x66155650}},	//   rā_, _офіц, _ceau, _lazk,
   {{0x7ff4826a,0x44d580eb,0x63a9804f,0x7d1a81c0}},	//   _آسما, sā_, _mgen, avts,
   {{0x27ed892e,0xe29a0071,0x3ebf978f,0xdb0f0013}},	//   lgen_, саг_, mput_, ódái,
   {{0x929d8063,0x660a0086,0x63a9d651,0x20d704b7}},	//   _usłu, _ölkə, _ogen, għi_,
   {{0x27edbd2a,0x38b18117,0x63a9aeda,0x63a4b999}},	//   ngen_, _már_, _ngen, žini,
   {{0x628182a5,0x6d41a916,0x3ebf812b,0x27ed8e83}},	// [4a60] _oklo, lyla, nput_, igen_,
   {{0x2d9612bc,0x7bdb8079,0x64460009,0x386001b4}},	//   прес, _aduu, lkki, siir_,
   {{0x60263317,0x6abbd652,0x2c21016f,0x6f0d0079}},	//   _една, _atuf, याचं_, awac,
   {{0x27ed8613,0x64460009,0xeb9a8396,0x63a98118}},	//   jgen_, nkki, бие_, _cgen,
   {{0x3ebf8088,0x937a9459,0x3a3a088b,0x7bdb9a14}},	//   jput_, حصار_, _kopp_, _dduu,
   {{0x26c05653,0x63a9aca0,0x27edc60f,0x38b18019}},	//   mpio_, _egen, egen_, _bár_,
   {{0xf6230b69,0x2bed016f,0x6abb81bc,0x40348a0e}},	//   _ядро, _झालं_, _etuf, дейс,
   {{0x27edba56,0x7e7e5654,0x291e811a,0x38b181a8}},	//   ggen_, lopp, _vrta_, _dár_,
   {{0x1be61344,0xab5d8035,0x7bcd17c9,0x68e38299}},	//   _काजल_, _odży, _reau, arnd,
   {{0x93258077,0x291eb1a7,0x7e7e3ca4,0x7bcd5655}},	//   _ترفن, _trta_, nopp, _seau,
   {{0xa3e0864a,0xc04f835f,0xab5d851c,0x41bb8039}},	//   _दया_, _зі_, _reżi, _הצבע,
   {{0x7e7e5656,0xf0448180,0x33205657,0x6608d658}},	//   hopp, _تعطی, _brix_, sedk,
   {{0xa3ea8006,0x9c7d0fda,0x7e618078,0x62870b80}},	//   _माई_, lučk, bilp, tljo,
   {{0x8f9b81c6,0x9fbf04e8,0x7ae00e06,0xa2c18a27}},	//   _הידי, rčík_, ámta, रीट्,
   {{0xd5fb8039,0x26c701dd,0x66150353,0x6d41d659}},	//   _הפור, ćnom_, _razk, cyla,
   {{0xb9050c78,0xb4d8816f,0xd4680b30,0x11f7003d}},	//   _नि_, ाळी_, _није_, _کودک_,
   {{0x4429565a,0x2bc30dbc,0xb8f409a3,0x644d565b}},	// [4a70] _ina_, _व्या, _सौ_, _ilai,
   {{0x6f0d2ea4,0x42550077,0x644d0282,0xddab1b47}},	//   rwac, _آندر, _hlai, стал_,
   {{0x644d29fb,0x443b0cc0,0x58d40009,0x9c7d135a}},	//   _klai, _koq_, _поэт, jučk,
   {{0x9f9d80a9,0x44290052,0x26d98019,0xa3bf09c1}},	//   nção_, _jna_, ások_, ेरि_,
   {{0x66153f63,0x9f9d83a7,0x4429565c,0xddc8911b}},	//   _tazk, ição_, _mna_, dodž,
   {{0x38b18658,0x7e7e047f,0x443b0144,0x644d0428}},	//   _pár_, copp, _loq_, _llai,
   {{0x9c7d00d2,0x6446565d,0x25fd016f,0x27eda7e9}},	//   ručj, ykki, र्णी_, tgen_,
   {{0x44290870,0x63a9d65e,0x1c1d0074,0x27edd65f}},	//   _nna_, _ugen, _बोलल_, ugen_,
   {{0x27ed890d,0xf1bf2207,0x7e61d660,0x61fb00d2}},	//   rgen_, ्रान, tilp, đulj,
   {{0x44292dba,0x644d2b25,0x6281803b,0x3ebfd661}},	//   _ana_, _alai, _uklo, rput_,
   {{0x7c3b8247,0x644d06f6,0xac0a1d99,0x240a0081}},	//   _kour, _blai, онна_, онни_,
   {{0x332003d3,0x31c609a3,0x7c3b8809,0x26c734c1}},	//   _prix_, वर्ध, _jour, ćnoj_,
   {{0x7c3b8247,0x64460364,0x6d41d662,0x78a600fe}},	//   _mour, rkki, syla, _rikv,
   {{0x44295663,0x9f9d8073,0x386dd664,0x32180326}},	//   _ena_, ação_, lner_, udry_,
   {{0x386d8082,0x7c298ab3,0xa3e7016f,0x32180123}},	//   oner_, _oner, _पाच_, rdry_,
   {{0x644d5665,0x9f9d83a7,0x44290122,0xa2d7047d}},	//   _glai, cção_, _gna_, _बिच्,
   {{0xee3a21ae,0x3a3a03e5,0x7e7e088b,0x2d910c2e}},	// [4a80] она_, _topp_, topp, _azze_,
   {{0x4429003a,0x2fcf821e,0x7c29d666,0x386db2a2}},	//   _zna_, _legg_, _aner, hner_,
   {{0x7e7e5667,0x78a6005c,0x4429031d,0x25fd2a47}},	//   ropp, _tikv, _yna_, र्धी_,
   {{0x7c3b8809,0x387f82be,0x26c015a6,0x7e7e21cb}},	//   _cour, jour_, ppio_, sopp,
   {{0x7c3b8548,0x386dc968,0xd12f803d,0x2905810c}},	//   _dour, dner_, یمه_, _apla_,
   {{0x2d8b8d38,0x93438098,0x3f86808e,0x386daa38}},	//   ęcej_, ънче, _ryou_, ener_,
   {{0xaca401bc,0xd5ad0065,0x7c3b90b6,0x2fcf8362}},	//   _afọi, _اہم_, _four, _begg_,
   {{0xd6dad668,0x8f469242,0x386da2c7,0x7c3b9b87}},	//   ото_, дход, gner_, _gour,
   {{0x6e3c3f12,0x3ea7953a,0x63a91b40,0x69de02d4}},	//   _korb, _bint_, ženk, _odpe,
   {{0x44290068,0x3eb9a6d5,0x644d4f73,0xe81e82f1}},	//   _sna_, ísta_, _slai, _मोरा_,
   {{0x9c7d003a,0x6e3c5669,0x644d06f8,0x248480b9}},	//   luči, _morb, _plai, _kkmm_,
   {{0x386dd66a,0x2121157a,0x628ac359,0x6e3c566b}},	//   cner_, _rrhh_, llfo, _lorb,
   {{0x3ea78082,0xccf8800d,0x9f9d83a7,0x9c7d0110}},	//   _fint_, stě_, rção_, nuči,
   {{0x6e3c566c,0x6aa88197,0x29188174,0xe46a062c}},	//   _norb, _jidf, _áras_, ttöä_,
   {{0x6aa8c52f,0x9f9d83a7,0xd83f00e1,0x30a715ff}},	//   _midf, pção_, áčov_, драв,
   {{0x4429566d,0x44f8d66e,0xa3ea801b,0xdb250162}},	//   _una_, mé_, _माग_, ăpân,
   {{0x6e3c0025,0x44f8aca7,0x63ad3665,0x81e680ab}},	// [4a90] _borb, lé_, _igan, য্য_,
   {{0x3ea71836,0x7c3b8766,0x7c29a445,0xb6a580ff}},	//   önt_, _sour, _sner, _nhậ,
   {{0x44f8d66f,0xdcf88029,0x69d54aa1,0x7c3b90b6}},	//   né_, _izvē, maze, _pour,
   {{0x4429b1a3,0x25eb0076,0x337594bc,0x64838074}},	//   ña_, _चाकी_, нгер, võis,
   {{0x6e3c0e40,0x44f8bf0d,0x38b50082,0x2019002e}},	//   _forb, hé_, _hår_, _iasi_,
   {{0x201925a1,0x7bdf0fa4,0x386dd670,0x7aebd671}},	//   _hasi_, _ldqu, wner_, rugt,
   {{0x20195672,0x387fd673,0x386d888a,0x2b498289}},	//   _kasi_, tour_, tner_, šac_,
   {{0x67228025,0x63ad5674,0x3ea7d675,0x38b5016d}},	//   _broj, _ngan, _sint_, _mår_,
   {{0x69d50234,0xdb16008b,0x63bbd676,0x38b512f1}},	//   kaze, _neyð, _ifun, _lår_,
   {{0x201917cf,0x387f80b9,0x63ad019e,0x69d55677}},	//   _lasi_, sour_, _agan, jaze,
   {{0x38b5005f,0x63a48110,0x3ea7d678,0x6618807a}},	//   _når_, žint, _vint_, _davk,
   {{0xa01b00f2,0x201949ec,0x3ea780f3,0x2ca9051e}},	//   _skön, _nasi_, _wint_, _ciad_,
   {{0x63ad008e,0x63bbb41a,0x69d55679,0x6722d67a}},	//   _dgan, _mfun, faze, _groj,
   {{0x44f8d67b,0x63ad567c,0x69d51c40,0x3d000006}},	//   bé_, _egan, gaze, _रहले_,
   {{0x2019022e,0x7d020063,0x44f880e7,0x9c83007a}},	//   _basi_, łosz, cé_, ščaj,
   {{0x20192752,0x54360019,0x6e3c567d,0x628501f6}},	//   _casi_, _سربر, _sorb, _ekho,
   {{0x2cbf0668,0x201906cb,0x6b89d67e,0xc05283c8}},	// [4aa0] _čuda_, _dasi_, _nyeg, אזן_,
   {{0x38b508f8,0xe617567f,0x63bba290,0xd91009a7}},	//   _får_, нду_, _afun, _پیر_,
   {{0x6e3c5680,0x38b508f8,0x0446c286,0x10a61d32}},	//   _vorb, _går_, нежн, _пион,
   {{0x61138201,0x27ffd681,0x20195682,0x2d95373a}},	//   _gələ, jfun_, _gasi_, трус,
   {{0xeb9a8087,0xbb3b00be,0x98a78084,0xab838469}},	//   чид_, ּעצי, lynė_, лушк,
   {{0x44f8d683,0xb866803d,0x63bbbebe,0xb42581f9}},	//   yé_, کاتو, _efun, _یعقو,
   {{0x321a0e04,0x6b89d684,0xa5070764,0x27ff8326}},	//   _mapy_, _eyeg, _пера_, ffun_,
   {{0x44f89db6,0x69c70fda,0x63a93a71,0xdfd080f7}},	//   vé_, zbje, ženi, جية_,
   {{0xd5bd9055,0x64ac07d9,0xe6668af2,0x25fd5685}},	//   ोरंज, _eğit, етно, र्वी_,
   {{0x44f8d686,0xa2d40076,0x2ca90013,0x28e10a43}},	//   té_, _बौध्, _siad_, _फिलि,
   {{0x9e038048,0x827783de,0xdb1601fa,0x4d98804a}},	//   учыл, _טעמע_, _seyð, ькою_,
   {{0x44f89dbb,0xe7ea80d4,0x2d8a00b9,0xe73a8198}},	//   ré_, _टाटा_, _mybe_, _нее_,
   {{0x44f8a739,0x63ad008e,0xfdf006a7,0x38b5006f}},	//   sé_, _vgan, _चांस_, _sår_,
   {{0x44f8c092,0x20195687,0x63ad82ba,0x160203eb}},	//   pé_, _sasi_, ñanz, र्मर_,
   {{0xdfd51006,0x2019020f,0x69d51ce9,0x67d503c7}},	//   ковы, _pasi_, raze, кову,
   {{0x63ad0545,0x38b5104d,0x2747077f,0x61138085}},	//   _ugan, _vår_, _nínú_, _qələ,
   {{0x8aa723e7,0x02a714b7,0x160206b7,0x20195688}},	// [4ab0] _прод, _пром, र्भर_, _vasi_,
   {{0x4439016d,0x3b0901e0,0xb7140198,0xbebb03ed}},	//   ljs_, _ipaq_, ыдущ, _frën,
   {{0x61138201,0x20190704,0x70590fbf,0x63bbd689}},	//   _tələ, _tasi_, _жанр_, _pfun,
   {{0x7afd0b3c,0x2019568a,0x7af201d0,0x9fb581d0}},	//   otst, _uasi_, šetř, třík_,
   {{0x2fc93bc2,0x7de700e8,0xee3f0129,0x7c2d0c53}},	//   mbag_, _півд, _buýt_, _mnar,
   {{0x3eaa0352,0xdd868bca,0x2fc9568b,0xd2b8025f}},	//   _gibt_, _نو_, lbag_, עלות_,
   {{0xdd940110,0x9c7d0503,0x7c2d568c,0x65941ddf}},	//   _бары, luču, _onar, _бару,
   {{0x63bba0b3,0x7c2d019d,0x7afd226c,0x2fc901e0}},	//   _ufun, _nnar, ktst, nbag_,
   {{0x39498341,0x442dd68d,0xe803016f,0xc2210105}},	//   ņas_, _ine_, ऱ्या_, मयाब_,
   {{0x7aef568e,0x443f90f4,0xa01b18b6,0xb0e1064a}},	//   duct, _hou_, _sköl, _फिंग,
   {{0x443f8247,0x2bc3035a,0x2ee9568f,0x7afd1de6}},	//   _kou_, _व्हा, hraf_, etst,
   {{0x443fd690,0x442dd691,0x7afd5503,0xbebb0168}},	//   _jou_, _jne_, ftst, _rrën,
   {{0x443fcce4,0x7afd422a,0x442d826f,0xae0212e0}},	//   _mou_, gtst, _mne_, र्डन_,
   {{0x443f9f1b,0x62839152,0xdddc192c,0x26d9936f}},	//   _lou_, nono, _okrš, ásou_,
   {{0x442dd692,0x7afd33fc,0x389e8133,0x7c3f02a6}},	//   _one_, atst, _ọria_, _foqr,
   {{0x443fd693,0x442db86c,0x2fc9033e,0xb3a987c0}},	//   _nou_, _nne_, gbag_, şıyı,
   {{0x2ee95694,0x98a30758,0xa6861285,0x59d18006}},	// [4ac0] graf_, рите, влад, हरार,
   {{0x442dd695,0x628386b9,0xfaa61baa,0xaf06026b}},	//   _ane_, jono, _шапо, _ajùú,
   {{0x443fd696,0x64a68221,0x2fc90326,0x77798609}},	//   _bou_, важа, bbag_, _lxwx,
   {{0x0b468221,0xb60900eb,0x3d19809a,0x443fbb7c}},	//   кнен, _atšķ, _बनने_, _cou_,
   {{0x442d9cf3,0xd36f80f7,0x443fd697,0x60c185ee}},	//   _dne_, يهم_, _dou_, _atlm,
   {{0xf5060758,0xfe678872,0x26c214ce,0xc4bc8264}},	//   _изго, _ضد_, _itko_, _আয়োজ,
   {{0x443fd698,0xd46a8e1d,0x9e630226,0xd13081a8}},	//   _fou_, _живе_, _тврд, صمة_,
   {{0x661c5699,0x44fc569a,0xdd8f0591,0x443fd69b}},	//   _hark, mí_, _ذوق_, _gou_,
   {{0x661c569c,0x44fc569d,0x6283b8b3,0xae0215bc}},	//   _kark, lí_, bono, र्थन_,
   {{0x7c2d12f1,0x6283d69e,0x443f8613,0xd9ee0076}},	//   _snar, cono, _zou_, _जागत_,
   {{0x661c0bde,0x6440d69f,0x443f873a,0x44fc2191}},	//   _mark, _komi, _you_, ní_,
   {{0xae02085d,0x69d8d6a0,0x443f007b,0x7afd035f}},	//   र्तन_, lave, ðu_, ttst,
   {{0x38b887ca,0xee3a8037,0x44fc01d6,0x7b6403a7}},	//   _hér_, _онд_, hí_, атре,
   {{0x6440d6a1,0x7afd0b2b,0x7aef4918,0x61bf21ef}},	//   _lomi, rtst, ruct, ्रेष,
   {{0x44fc000d,0x2cbf005c,0x7aef1486,0x7afd527b}},	//   jí_, _čudo_, suct, stst,
   {{0x38b887ca,0x44fc56a2,0x69d8a2ba,0x2ee906a8}},	//   _mér_, dí_, have, traf_,
   {{0x2fc956a3,0x661c0788,0x63ad9024,0x443fd6a4}},	// [4ad0] rbag_, _bark, žank, _rou_,
   {{0x443fd6a5,0x9c7d56a6,0x6283bd27,0x6b8d02a3}},	//   _sou_, ruču, xono, _iyag,
   {{0x443fbc68,0xf3ff00a9,0x442d8706,0x44fc41cc}},	//   _pou_, nião_, _pne_, gí_,
   {{0x8c3d82bb,0x6283d6a7,0x6b8d0c2e,0x661c02f9}},	//   _kişi, wono, _kyag, _eark,
   {{0x661c56a8,0x443f8317,0xfaff00f1,0x644080ef}},	//   _fark, _vou_, ntë_, _domi,
   {{0xfe711fbe,0x443fd6a9,0x38690a46,0xf41f0364}},	//   _اگر_, _wou_, liar_, hdä_,
   {{0xfaff0b18,0x443f8205,0x44fc56aa,0x64ac8059}},	//   htë_, _tou_, cí_, _işin,
   {{0x442dd6ab,0x6440b866,0xef199593,0x6d48d6ac}},	//   _une_, _gomi, еми_, dyda,
   {{0x628386b9,0xfaff00f1,0x69d8827f,0x6b8d3de5}},	//   pono, jtë_, bave, _nyag,
   {{0x99679d7b,0x7bd9d6ad,0x69d89af9,0x69ca8c2d}},	//   _ител, lawu, cave, _स्पी,
   {{0xf3ff0073,0x6b8d0e05,0xe81e8fd5,0x6440d6ae}},	//   gião_, _ayag, _मोका_, _yomi,
   {{0xfaff00f1,0x6b8d020c,0x80d08264,0x8c3d8850}},	//   ftë_, _byag, সংখ্, _bişi,
   {{0xdee5879e,0x44fc03fb,0x66e58c9b,0x6d5a8102}},	//   _соли, zí_, _сола, azta,
   {{0x6a860aac,0x41a50beb,0x64b701a1,0x09e58264}},	//   улга, _गृहस, _aćim, প্রা,
   {{0x628e1c33,0x50b50c9d,0x09d880ab,0xe29704ae}},	//   rlbo, исту, _সামা, уар_,
   {{0x661c56af,0x201d8077,0x44fc03fb,0x69d8c949}},	//   _sark, _jawi_, ví_, zave,
   {{0x201db7cf,0x29050214,0x5baa00e8,0x9c7d04e8}},	// [4ae0] _mawi_, çlar_, _яким_, ručt,
   {{0x44fc0a56,0x2bcc8c78,0x6440d6b0,0x533700be}},	//   tí_, ार्थ, _somi, _ענין_,
   {{0x661c4294,0x2d962a71,0x2cad81b0,0x69d8bca2}},	//   _vark, урас, _bied_, vave,
   {{0x44fc2057,0x629a80f1,0x661c56b1,0x3ce601ac}},	//   rí_, _shto, _wark, čov_,
   {{0x661c56b2,0x38b887ca,0x44fc56b3,0x20124482}},	//   _tark, _sér_, sí_, meyi_,
   {{0x201207c0,0x661c0695,0x44fc03c1,0x98aa0084}},	//   leyi_, _uark, pí_, tybė_,
   {{0x6440803a,0xdd9209d7,0xf41f0009,0x64ba8609}},	//   _tomi, _طور_, ydä_, _aċin,
   {{0xdb0284c3,0x64408081,0x06c880ab,0x6456189e}},	//   scoñ, _uomi, _শিবি, ūzij,
   {{0xd5b08013,0xc9f680f7,0x61f681a8,0x6f0701a9}},	//   يفة_, _مساع, _مساء, cībā,
   {{0x6aca80ab,0x3869011b,0x715a9b78,0x2489328c}},	//   _রিপো, ziar_, _прес_, _skam_,
   {{0x5fb405b3,0x201256b4,0xdd948110,0x5c750c9b}},	//   ंखाल, keyi_, раны, илот,
   {{0x6d48d6b5,0xdd9781e5,0x201d9ac4,0xc0ff80ff}},	//   ryda, ышы_, _gawi_, _lướt_,
   {{0x38690531,0x6d5ad6b6,0x6eb01251,0x4e1406a7}},	//   viar_, szta, _अंगु, ड़ाई_,
   {{0xfaff020f,0x290c80dd,0xc987031f,0x672406ec}},	//   rtë_, _kpda_, губи, dvij,
   {{0xfaff00f1,0x672400eb,0xaa7b016b,0x649601a8}},	//   stë_, evij, krýv, máin,
   {{0x60180160,0x649601a8,0x6b8d02d5,0x3d19d6b7}},	//   лося_, láin, _tyag, _बनते_,
   {{0x2cad822b,0xe8069862,0x38690558,0xe8158cfd}},	// [4af0] _ried_, व्या_, riar_, ढ़ता_,
   {{0x386956b8,0x63a9016b,0xd01d80ab,0x201f93bd}},	//   siar_, žens, থায়_, zdui_,
   {{0x867b810f,0x2cadd6b9,0x7bd9cb40,0x9d152f92}},	//   ערבו, _pied_, tawu, рдеч,
   {{0x644f378d,0x3d05159a,0xe7871b47,0x69d756ba}},	//   nkci, _रहीं_, _буго, _hexe,
   {{0x1614800f,0x201d90e1,0x7bd9d6bb,0xb7da0039}},	//   तजार_, _rawi_, rawu, _בקרי,
   {{0xeab0803d,0x7bd9af4d,0x201d8642,0x62870612}},	//   سعه_, sawu, _sawi_, nojo,
   {{0x2486d6bc,0x20559505,0xa3c5009a,0x69d70187}},	//   boom_, итир, एडा_, _mexe,
   {{0xaae78154,0x9c7d0267,0xdb1d02f1,0xa6e59935}},	//   _مسئو, brči, lasõ, ажил,
   {{0x628756bd,0xfd100065,0x61e5016b,0x86998073}},	//   kojo, _وجہ_, _odhl, ктот_,
   {{0xe7088013,0x60c50c9e,0x7b748f99,0xb8db80ab}},	//   اتين_, _othm, _اطفا, _অব_,
   {{0xa3e9864a,0xa115af0a,0x481584fa,0x67290267}},	//   _मया_, _خوات, _вмес, _šejl,
   {{0xd46a1361,0x61e50219,0x20d38493,0x38698338}},	//   тиме_, _adhl, mţi_, _öar_,
   {{0xd6c384c0,0xe81e92ee,0x308480f7,0x20d3802e}},	//   _امتی, _मोटा_, _النف, lţi_,
   {{0x35a58084,0xe29a028e,0x2ba71199,0xe5a5a14d}},	//   _калг, таг_, _गणरा, _кили,
   {{0x20d3802e,0x290c56be,0x69d756bf,0x68460081}},	//   nţi_, ïda_, _dexe, анва,
   {{0x67240341,0x7ae90024,0x78af026c,0xe8e0001c}},	//   tvij, šeta, _cicv, _liệt_,
   {{0x7643d6c0,0x628721c5,0x44321e1e,0x33290216}},	// [4b00] _kony, bojo, _iny_, _grax_,
   {{0x442056c1,0x672401a9,0x443202f7,0x6444010c}},	//   _hai_, rvij, _hny_, _hoii,
   {{0x442056c2,0x764390e1,0x67240654,0x248689ff}},	//   _kai_, _mony, svij, toom_,
   {{0x03269cce,0x69c1d6c3,0x09d880c8,0x442056c4}},	//   иден, _afle, _সাধা, _jai_,
   {{0x442056c5,0xe8e00028,0x2b168009,0x59da4765}},	//   _mai_, _biệt_, рьер, _बजार,
   {{0x442056c6,0x69dc56c7,0x5eeb064a,0x2eed8114}},	//   _lai_, nare, _चित्_, dref_,
   {{0x443256c8,0xdb1f26e1,0xe8e0001c,0xddc88084}},	//   _ony_, _seqü, _diệt_, sidū,
   {{0x64599f4c,0x38bc56c9,0xf106bac3,0x3fb48264}},	//   chwi, _mír_, _शहीद_, ঘর্ষ,
   {{0xa2b22e06,0x04f280ab,0x7643d6ca,0x20d3802e}},	//   _इंग्, _জনের_, _bony, aţi_,
   {{0x44320051,0x7c22ce3b,0x38bc0511,0x76439fd6}},	//   _any_, ldor, _oír_, _cony,
   {{0x442015d6,0x69d704c3,0x7c20d6cb,0x69dc56cc}},	//   _bai_, _rexe, _kamr, dare,
   {{0x442008ac,0x98be000d,0x7aed80cd,0x26060744}},	//   _cai_, ště_, šate, स्ती_,
   {{0x442056cd,0x69dc03a6,0x62872c28,0x629e026c}},	//   _dai_, fare, tojo, _bhpo,
   {{0x5ef3816f,0xdb1d0019,0x7c208326,0x3b000372}},	//   ंढर्_, ncsé, _lamr, _dqiq_,
   {{0x442056ce,0x3d05000f,0x69d704c3,0x628756cf}},	//   _fai_, _रहें_, _vexe, rojo,
   {{0x442056d0,0x7c208353,0x0854004a,0x69d70df6}},	//   _gai_, _namr, овсю, _wexe,
   {{0x7bdd1922,0x7c228114,0x628721c5,0x57a70081}},	// [4b10] masu, ddor, pojo, ршва,
   {{0x69dc56d1,0x442003c3,0x7d0100f2,0x2cb80609}},	//   care, _zai_, _älsk, _burd_,
   {{0x442056d2,0x25fd0beb,0x26c902a5,0x60c506df}},	//   _yai_, र्गी_, spao_, _uthm,
   {{0x442056d3,0x68f5007e,0x8c3d8162,0x4c958198}},	//   _xai_, muzd, _nişt, щиес,
   {{0x69c181ec,0x7c20ce2f,0x26c681c5,0xda041834}},	//   _pfle, _damr, _ntoo_, श्वत_,
   {{0xf20791d2,0x98e580f7,0x27e68300,0x4422026c}},	//   рядо, مكتو, _adon_, zdk_,
   {{0xe8e00104,0x7bdd3d46,0x2a580039,0xa06996fc}},	//   _việt_, kasu, שבון_, лака_,
   {{0x69dc56d4,0x76438caa,0x2eedcf92,0x20d3802e}},	//   zare, _sony, tref_, rţi_,
   {{0x442056d5,0x3eb90051,0x76439a48,0x69dc56d6}},	//   _rai_, _just_, _pony, yare,
   {{0x442056d7,0x443256d8,0x3eb956d9,0x645d56da}},	//   _sai_, _sny_, _must_, ërin,
   {{0xb9958013,0x44201b16,0x200b026f,0x671c8466}},	//   _الاب, _pai_, _obci_, _बैठक_,
   {{0xf09f0142,0x69dc56db,0x7bdd386b,0x645d0110}},	//   _nhà_, ware, gasu, ūrin,
   {{0x442056dc,0x386dc73a,0x2245d6dd,0x249f810c}},	//   _vai_, mier_, _kolk_, _mhum_,
   {{0x386d8ee9,0x442004b9,0x6146017c,0x610a811c}},	//   lier_, _wai_, бега, _həla,
   {{0x442056de,0x69dc56df,0x443256e0,0x7bdd4d46}},	//   _tai_, rare, _tny_, basu,
   {{0xe3b2045b,0x44e38182,0x386d9a93,0x69dc1473}},	//   _عرب_, mı_, nier_, sare,
   {{0x44e3884a,0x8fa30d5f,0x69dc3131,0x127a0019}},	// [4b20] lı_, зате, pare, _محدث_,
   {{0xcf928158,0x7c20d6e1,0x38bc00f7,0x386dd6e2}},	//   לטן_, _samr, _tír_, hier_,
   {{0x44e38459,0xf1bf8028,0x25fe12ee,0x6f1d56e3}},	//   nı_, _đáp_, _लाठी_, _essc,
   {{0xaae68013,0x249f8c49,0x7c209f79,0xa3d82724}},	//   مستو, _chum_, _qamr, िरि_,
   {{0x7c22820f,0x3eb94de9,0x386d93c2,0x31cf80ab}},	//   rdor, _gust_, dier_, _রাজশ,
   {{0x09d880c8,0x4df536ae,0x44e38201,0x7c2294fb}},	//   _সাহা, _мяст, kı_, sdor,
   {{0x386dd6e4,0xa3d82b62,0x8d630193,0x6b9b8133}},	//   fier_, िरा_, _евре, _ezug,
   {{0x44e382bb,0x8cd29305,0xc5630d15,0x7ae402d4}},	//   dı_, _भौगो, _экск, _ovit,
   {{0x2bce835a,0x64a381e5,0x6f0435dc,0x649601a8}},	//   _ह्या, _хата, ntic, ráil,
   {{0x59cfbbf1,0x7bdd1f62,0xb8fe80ab,0x14ca862c}},	//   _स्पर, wasu, _তম_, лыми_,
   {{0x25fd06b7,0x69da8029,0x7bdd00ad,0x386dd6e5}},	//   र्टी_, _iete, tasu, bier_,
   {{0x7bc2d6e6,0x6f041249,0x69da8094,0x386dd6e7}},	//   ncou, ktic, _hete, cier_,
   {{0x69da94e5,0x7ae48013,0x7ae409d1,0xab870f75}},	//   _kete, áith, _cvit, сунк,
   {{0x29031d84,0x7bdd3755,0x69da80f1,0x7ae2808e}},	//   ttja_, sasu, _jete, isot,
   {{0x7bdd45bb,0x44e38457,0x6f040037,0xa1581f96}},	//   pasu, cı_, etic, бару_,
   {{0x69da84e8,0x6f0417c9,0x6f1d00b9,0x2ca056e8}},	//   _lete, ftic, _pssc, _ghid_,
   {{0x78ba826c,0x25578085,0x95d906a1,0x2ca682d5}},	// [4b30] _lutv, vələ_, идат_, dmod_,
   {{0x291e843d,0x69dad6e9,0x3a750e97,0x249f80f1}},	//   _osta_, _nete, _флор, _shum_,
   {{0xf09f220a,0x628a81e0,0x7d0d8bda,0x6f0417d6}},	//   _thà_, dofo, _ćask, atic,
   {{0xd3719a3c,0x3cfb80be,0x25fd0f0a,0x69da86ab}},	//   وها_, רלאנ, र्जी_, _aete,
   {{0x69dab301,0x386dd6ea,0x291e8012,0x6f04079a}},	//   _bete, vier_, _asta_, ctic,
   {{0x44e387d9,0x291e82d5,0x2557811c,0x610a811c}},	//   yı_, _bsta_, sələ_, _səla,
   {{0x386da02e,0x224584eb,0x69dabf55,0x67290858}},	//   tier_, _volk_, _dete, _šejh,
   {{0xdb2100e1,0xd6d19ddd,0xaec584ad,0x7bc2d6eb}},	//   _štýl, وقع_, обил, ccou,
   {{0x291eab72,0x386da280,0x69ca8ebf,0x9f400125}},	//   _esta_, rier_, _स्वी, ngið_,
   {{0x69da905d,0x44e38059,0xa01b008b,0x386d8a85}},	//   _gete, tı_, _fjög, sier_,
   {{0xe806835a,0xc5f204de,0xa5099285,0x1d0990ca}},	//   व्हा_, ודי_, шена_, шени_,
   {{0x44e3b6d4,0x69c523a6,0x69dad6ec,0x6abb8c53}},	//   rı_, _afhe, _zete, _kuuf,
   {{0x44e38b06,0x69da8214,0x8c1a84de,0x888c83de}},	//   sı_, _yete, בורי, _גראַ,
   {{0x1e8490ac,0x59cf861e,0x26cd8037,0xa3d806a7}},	//   _елім, _स्मर, mpeo_, िरह_,
   {{0x8c460b5b,0x81ab80ab,0xd8262796,0x26cd8144}},	//   _меке, কুর_, одви, lpeo_,
   {{0x7ae41c78,0x6f0456ed,0x645d56ee,0xa9278084}},	//   _tvit, ttic, chsi, mažė,
   {{0x6e23c78b,0xaa7b008b,0x76900009,0x6729d6ef}},	// [4b40] _kanb, msýn, käyt, nvej,
   {{0xee37045d,0xa01b1252,0x7bc29916,0x6e238242}},	//   ону_, _sköt, wcou, _janb,
   {{0x69da9eed,0x41d003bb,0x6e23a53d,0x321821d5}},	//   _rete, _त्यस, _manb, mery_,
   {{0x69da8734,0x7bc282be,0x32184a15,0x51f6015b}},	//   _sete, ucou, lery_, _اسکر,
   {{0x7c241536,0xbb4387ac,0x7bc2d6e7,0x2ca6b5ad}},	//   _mair, мецк, rcou, rmod_,
   {{0x27e056f0,0x98c69594,0x7c2456f1,0xa905003d}},	//   lain_, осил, _lair, _ببین,
   {{0x7ae2c269,0x69da8e79,0x61e88037,0x41c68a0d}},	//   ssot, _vete, _vddl, रुषस,
   {{0x6e239aee,0x69daa65f,0xe8e08104,0x628a92f5}},	//   _aanb, _wete, hiệp_, sofo,
   {{0x69dabd9b,0x6e23d6f2,0x81ab80ab,0x645d0168}},	//   _tete, _banb, কুল_, ërim,
   {{0x44249277,0x27e00219,0x78ba8006,0x64428966}},	//   _ham_, hain_, _tutv, ljoi,
   {{0x4424d6f3,0x6e23d6f4,0x27e056f5,0x7c2445ab}},	//   _kam_, _danb, kain_, _bair,
   {{0x44268c6b,0x7c244f3f,0x2bb18105,0xfe788084}},	//   ndo_, _cair, ुँचा, snį_,
   {{0x4424c536,0x4426a706,0x27e045ff,0x7c2435dd}},	//   _mam_, ido_, dain_, _dair,
   {{0x4424d586,0x64428009,0x2ef201b0,0x4426a683}},	//   _lam_, hjoi, dryf_, hdo_,
   {{0x7c2410b6,0x4426d6f6,0x551e8035,0x6b51026b}},	//   _fair, kdo_, _बनिए_, _bógú,
   {{0x4424c402,0x7c240cc8,0x4426b78b,0x27e001ba}},	//   _nam_, _gair, jdo_, gain_,
   {{0xb90205e8,0x4426d6f7,0xd5bb01ae,0x321856f8}},	// [4b50] _नौ_, ddo_, асе_, bery_,
   {{0x69ca80d4,0x551e9660,0x7c2456f9,0x2fdfcf97}},	//   _स्ली, _बनाए_, _zair, zaug_,
   {{0x4424d6fa,0x7c8781a4,0x9c830824,0x6abb8df6}},	//   _bam_, оуде, ščuj, _suuf,
   {{0x27e01627,0x7d051106,0x212100dd,0xfc3f20ce}},	//   cain_, rths, _ishh_, zmín_,
   {{0x2cbf00ce,0x76900198,0x083a03de,0x883a025f}},	//   _čudu_, täyt, _הערל, _התרו,
   {{0xdcfb003d,0x76ba01c6,0x01d90264,0x660e02f9}},	//   _پرسش_, _למשפ, _তাঁদ, _gbbk,
   {{0x6e23d6fb,0x4426d6fc,0x76b28035,0x2fdf81c0}},	//   _ranb, bdo_, _płyn, taug_,
   {{0x7cc18341,0x4424d6fd,0x397c098a,0x6e2386c0}},	//   _bērn, _gam_, יטונ, _sanb,
   {{0xf7718307,0x6e238bb1,0xdbd9007b,0x7c2456fe}},	//   عاب_, _panb, væði, _rair,
   {{0x4424d6ff,0x6729d700,0x7c240009,0x27e00102}},	//   _zam_, rvej, _sair, zain_,
   {{0x442490af,0xfc3f026f,0x27e05701,0x64499384}},	//   _yam_, rmín_, yain_, _koei,
   {{0x44248069,0x160b00d4,0x59cf8a0d,0x6e2392f9}},	//   _xam_, स्तर_, _स्तर, _wanb,
   {{0x7c243d3b,0x64498b3c,0xeb9f013c,0xdb080059}},	//   _vair, _moei, lføj_, _ölüm,
   {{0x19b9035f,0x7c242bb7,0x27e05702,0x44268110}},	//   жуть_, _wair, wain_, zdo_,
   {{0x20560eef,0x7c240cac,0x10a60615,0x4426d358}},	//   птар, _tair, зивн, ydo_,
   {{0x7c241a29,0xa01b18b6,0x442681b4,0xaec6171c}},	//   _uair, _skör, xdo_, збал,
   {{0x27e05703,0x44268824,0x32185704,0x1f6653c2}},	// [4b60] rain_, vdo_, pery_, чкам,
   {{0x17790cde,0x4424d705,0x27e05706,0xea64003d}},	//   ість_, _sam_, sain_, _آپدی,
   {{0x4424d707,0x27e05708,0x628e5709,0x64499c11}},	//   _pam_, pain_, mobo, _boei,
   {{0x645b861f,0x4426d70a,0x69de484c,0x78a980f1}},	//   _clui, udo_, _hepe, jmev,
   {{0x6442825d,0x69de059c,0x27f7026f,0x38600834}},	//   rjoi, _kepe, šené_, mhir_,
   {{0x645b8d62,0xf7880085,0x26c281ac,0x69de0168}},	//   _elui, _neçə_, íkom_, _jepe,
   {{0x4424d70b,0xa3ac0a74,0x69de570c,0xbea31246}},	//   _tam_, केत_, _mepe, _чарк,
   {{0xdb160065,0x6449a4c2,0x50668196,0x09b9016f}},	//   _egyé, _goei, ятла, _आल्य,
   {{0xa41183bf,0x628e2eae,0x09e200ab,0x29078b7e}},	//   lığı_, kobo, _বানা, atna_,
   {{0x7ae9011f,0x69de570d,0xdbe503b7,0x649d0f35}},	//   šetk, _nepe, कण्ड_, géin,
   {{0x38600867,0x628e1fce,0xd7efa762,0xfbe10264}},	//   khir_, dobo, _пу_, _ভাবত,
   {{0x6ab50935,0x35678071,0x00bb8039,0x09c50072}},	//   ंद्र, ярын_, _המאמ, वड्य,
   {{0x69de03b2,0x38600f58,0x2121008e,0xd90e803d}},	//   _bepe, dhir_, _sshh_, _شیک_,
   {{0x69de4186,0x628e570e,0xbd0181df,0x2480010c}},	//   _cepe, gobo, ñéce, _ejim_,
   {{0x69de3da5,0x19580048,0x06b1928a,0x00000000}},	//   _depe, пары_, řící_, --,
   {{0xa41182bb,0xa01b1a50,0x661ad70f,0xf0b405a8}},	//   dığı_, _sjöb, letk, ейсь,
   {{0xead780c8,0xf7730b8c,0x06b70180,0x64499151}},	// [4b70] _সম্ম, رار_, سناک_, _roei,
   {{0x645b85f8,0x69de1c11,0x13d58d1c,0x661ac312}},	//   _slui, _gepe, दर्भ, netk,
   {{0x38600046,0x645bd710,0x6449a32d,0xa25b00e1}},	//   bhir_, _plui, _poei, spôs,
   {{0x69c8d711,0x38605712,0x69de0fe2,0x765c038a}},	//   _afde, chir_, _zepe, _elry,
   {{0x7bdf0580,0x0dcb0c9b,0xcfab00d7,0x6ab70197}},	//   _mequ, _губи_, _دادم_, _kixf,
   {{0x7bdf00e7,0x200f80b9,0x672d5713,0x29078bcb}},	//   _lequ, _sbgi_, mvaj, ttna_,
   {{0x672d3b7a,0x661a844a,0x67228091,0xf49780d7}},	//   lvaj, detk, _asoj, _فشرد,
   {{0x7bdf5714,0x610a8085,0x628e3327,0x2907d715}},	//   _nequ, _gəlm, zobo, rtna_,
   {{0x628e0578,0x2907d716,0x26018740,0x649d0b6a}},	//   yobo, stna_, _शादी_, téin,
   {{0x661acdd0,0x7ae9a1c5,0x69c70140,0x628e34d3}},	//   getk, _ivet, jcje, xobo,
   {{0x61e3a2f8,0x628e5717,0xa787803d,0x7bdf5718}},	//   manl, vobo, _کشاو, _bequ,
   {{0x69de045c,0x61e38850,0x7ae98a21,0x7bdf0118}},	//   _sepe, lanl, _kvet, _cequ,
   {{0x69de5719,0xe8e0001c,0x25fe097d,0x3d1983db}},	//   _pepe, _thịt_, _लाली_, _बनके_,
   {{0x672d369f,0x661a8052,0x764a831d,0x61e3d71a}},	//   dvaj, cetk, _gofy, nanl,
   {{0x3860571b,0x63bbd71c,0x27ffc901,0xe297571d}},	//   thir_, _ogun, ogun_, фар_,
   {{0x27ffb996,0x628e0c56,0x63bbd71e,0xb8f60665}},	//   ngun_, sobo, _ngun, _हऽ_,
   {{0x6f0989b2,0x61e382fa,0x69de4502,0x628e4340}},	// [4b80] ntec, kanl, _tepe, pobo,
   {{0x63bb8397,0x3860571f,0x6f09802a,0xe2920f24}},	//   _agun, shir_, itec, _جذب_,
   {{0x7ae989b5,0x67290858,0xdbc68074,0x61e3d720}},	//   _avet, _šejt, _mööd, danl,
   {{0xae021a46,0xed57004a,0x68fc5721,0x6aa6864a}},	//   र्जन_, ьох_, murd, गग्र,
   {{0x7ae98b89,0x671c8fea,0xaca4819d,0xb5e38264}},	//   _cvet, _बैंक_, _haịp, _মানচ,
   {{0x63bb80ad,0x7df986b7,0x61e3d722,0xbe16003d}},	//   _egun, ्भोग_, ganl, _توسع,
   {{0x661ad723,0x247601a9,0x200d8037,0xdd920180}},	//   vetk, nāms_, ffei_, _شور_,
   {{0xdfd08013,0x764a84e6,0x200282f1,0x2000019a}},	//   دية_, _sofy, üki_, ngii_,
   {{0x7bdf3f55,0xf0930039,0x41cf8aed,0xb6070197}},	//   _requ, כנה_, _स्वस, _feġġ,
   {{0x3f988029,0x64ac87c0,0x644601c0,0x7bdf5724}},	//   āru_, _eşit, ejki, _sequ,
   {{0x7bdf1313,0xe01e0df4,0x38c8804e,0xab5b08c5}},	//   _pequ, _पसंद_, _راضی_, rcüm,
   {{0x68fc031d,0x83fd8019,0xfbad00ab,0x3a3a00fc}},	//   durd, _előf, _ক্ষত, _anpp_,
   {{0xe66682dc,0xd62ab7cd,0x92bc80ab,0x661ad5ee}},	//   _отко, _моде_, _আবু_, petk,
   {{0x6cfe0441,0xe56f8180,0x8f9b81c6,0x38a1b38d}},	//   _उमंग_, اطی_, _וידי, móra_,
   {{0x19940098,0xfbde8697,0x69c70168,0x38a1d725}},	//   варя, मराम, rcje, lóra_,
   {{0x6e270b80,0x200001b4,0x27e49f0a,0x69c705f3}},	//   _sajb, ggii_, namn_, scje,
   {{0x61e383bf,0x59d03c4f,0x610a8085,0x3eb8008b}},	// [4b90] yanl, _त्वर, _bəlk, _birt_,
   {{0x5ec800c8,0x7afd14c7,0x27e48186,0x44295726}},	//   _লিখে, must, hamn_, _haa_,
   {{0x7ae9ba71,0xb8f40a49,0x44295727,0x61e3d728}},	//   _svet, _হয়_, _kaa_, vanl,
   {{0x8c1c0158,0x44292551,0x61e380dd,0x2d9803ba}},	//   ַווי, _jaa_, wanl, _dyre_,
   {{0x44291312,0x7afd3ae2,0x271d800d,0x2d9801e0}},	//   _maa_, nust, _भनेर_, _eyre_,
   {{0x44295729,0x78ad572a,0xf2d400be,0x644d016a}},	//   _laa_, lmav, דעס_, _loai,
   {{0x61e385b2,0x7afd0074,0x85570019,0x6f098299}},	//   ranl, hust, _تیار_, wtec,
   {{0x61e3884a,0x4429572b,0x26019a3b,0x63bbd72c}},	//   sanl, _naa_, _शाही_, _ugun,
   {{0x61e3d72d,0xef168009,0x7c3b9998,0xe811016f}},	//   panl, емы_, _inur, ड्या_,
   {{0x7c29d72e,0x6f09d72f,0x7afd5730,0xe8df81bc}},	//   _haer, rtec, dust, _alụm_,
   {{0x6f098ebf,0x44295731,0xa90780d5,0xc6920039}},	//   stec, _baa_, _زبان, ראי_,
   {{0x7c2ba0f0,0xc2090039,0x6459a70c,0x3d07009a}},	//   ndgr, _לה_, nkwi, _हमने_,
   {{0x61e1d732,0x60c1a0ac,0x7c3bbd34,0x644d2404}},	//   _kell, _hulm, _mnur, _doai,
   {{0x60c1d733,0x61e1d734,0xf2d2898a,0x66f68039}},	//   _kulm, _jell, רעם_, _נמצא_,
   {{0x61e18558,0xf9928158,0xc5f283c8,0x44295735}},	//   _mell, ָרן_, _עדה_, _faa_,
   {{0x44290870,0x387f807b,0xe3da00ab,0x212590e1}},	//   _gaa_, nnur_, _থাকব, _mslh_,
   {{0x2000085d,0x3f8603a7,0xa3ac5736,0xdbd9808b}},	// [4ba0] rgii_, çou_, केश_, _ræðu,
   {{0x61e18021,0x63a45737,0x44295738,0x78ad01e8}},	//   _nell, _izin, _zaa_, amav,
   {{0x44295739,0x7c29d73a,0xa3ac01d0,0x89db025f}},	//   _yaa_, _baer, केर_, _מחיי,
   {{0x7c29831d,0x5ed580ab,0x3eb8022b,0x649601a8}},	//   _caer, _দিনে, _wirt_, máis,
   {{0x7c2994e5,0x61e1a91e,0xe29a85c2,0x649600f7}},	//   _daer, _bell, пад_, láis,
   {{0x2d9808cf,0x61e18213,0x60c18214,0x63a40c53}},	//   _tyre_, _cell, _bulm, _mzin,
   {{0x61e1d1e4,0xada310ac,0x26c2022e,0xe5a300e5}},	//   _dell, _барл, _huko_, _бири,
   {{0x26c20578,0x661e279f,0x3b0a818b,0x7c298114}},	//   _kuko_, lepk, _небо_, _gaer,
   {{0x4429573b,0x7afd01df,0x61e1aad1,0x39a68032}},	//   _raa_, xust, _fell, _bísí_,
   {{0x442922d9,0x3eb8ba01,0x628004c3,0x61e1831d}},	//   _saa_, ört_, émol, _gell,
   {{0x4429573c,0x2d988bc5,0x764e573d,0x26c253b1}},	//   _paa_, ære_, _moby, _luko_,
   {{0x7afd18c5,0xe7869d7b,0x61e1cf33,0x63a4410d}},	//   tust, _пуло, _zell, _bzin,
   {{0x26c202a0,0x442b0db1,0x61e1d73e,0x291e02d0}},	//   _nuko_, rdc_, _yell, çtan_,
   {{0x44290962,0x7afd2551,0x63a401a9,0x764e0cf4}},	//   _waa_, rust, _dzin, _noby,
   {{0x44290d10,0x7afd14c7,0x63a4573f,0x6abad740}},	//   _taa_, sust, _ezin, _mitf,
   {{0x759b8496,0x442902f7,0x26c20c8b,0x645f0168}},	//   _מיוח, _uaa_, _buko_, _ulqi,
   {{0x78ad2ed0,0x26c20267,0xf41f0198,0x64960174}},	// [4bb0] rmav, _cuko_, meä_, ráit,
   {{0x7c3bbfee,0x38a1807b,0xb8f700ab,0x4b7c01c6}},	//   _snur, jórn_, _সি_, _מאחו,
   {{0x61e1d741,0x649600f7,0x7aed5742,0x7c29d743}},	//   _rell, cáis, _hvat, _paer,
   {{0x610a8201,0x61e1d744,0x999a001b,0x7aed5745}},	//   _gəli, _sell, _např_, _kvat,
   {{0x60c180f1,0x442981ac,0x6459ae66,0x7c2bd333}},	//   _sulm, ľa_, rkwi, rdgr,
   {{0x60c1d746,0x4429a8fc,0x764e0cf4,0x61e18168}},	//   _pulm, ža_, _goby, _qell,
   {{0x6f0d3402,0x9d1819b5,0x26cf8144,0xf41f0198}},	//   ltac, _порт_, _stgo_, keä_,
   {{0x61e734c5,0x26c22fc0,0xa3ac0006,0x6f0d0229}},	//   hajl, _yuko_, केँ_, otac,
   {{0xb8c88076,0x61e1d747,0x7c8481a1,0x387fd748}},	//   _खी_, _tell, _суре, rnur_,
   {{0x2ca911d6,0x6285017f,0x9f5f9b01,0xd121064a}},	//   _ahad_, _njho, ngué_, मबाण_,
   {{0xc9599fbe,0x63a40065,0x423680be,0x69caaa2b}},	//   _تلاش_, _szin, _שנעל_, _स्टी,
   {{0x9055844f,0xed5680e8,0xa01b0106,0x91fc81a9}},	//   _швец, тою_, _sjön, _glāb,
   {{0x7aed00ce,0x032300e8,0xa85681c6,0x2ca90706}},	//   _cvat, адян, _שינה_, _dhad_,
   {{0x26c25749,0x2ca9026c,0x64960174,0xfaa60e63}},	//   _ruko_, _ehad_, gáir, таго,
   {{0xfbe100c8,0x26c281ac,0x4096197b,0x09e680ab}},	//   _ভারত, íkov_, врат, _নামা,
   {{0x249d81e9,0x20c7001c,0x26c200d2,0x4e1406b7}},	//   jlwm_, _dõi_, _puko_, न्नै_,
   {{0x764e0e04,0x6b9b8019,0x63a41fb6,0x2bd801d0}},	// [4bc0] _poby, _nyug, _uzin, _भ्या,
   {{0x787b0364,0x7ae904b7,0x0e63259a,0x3f9c01a9}},	//   tävä, ġett, акун, āvu_,
   {{0xa06a0a42,0x7aed0024,0x6f0d051e,0xf8b384c5}},	//   _жана_, _zvat, atac, ुदाय,
   {{0xf53680be,0x26c2574a,0x6f0d09ab,0x6b9bc6d6}},	//   כטער_, _tuko_, btac, _byug,
   {{0xa01b1252,0x80af0035,0x6f0d0cf7,0x6b9b818e}},	//   _mjöl, ंगरे, ctac, _cyug,
   {{0x9f420168,0x98b80196,0xdce9928a,0x67240157}},	//   _lekë_, tyrė_, áněn, mwij,
   {{0x672401ed,0xda6581a8,0x6b8997c9,0x3e608706}},	//   lwij, داني, _exeg, _nòta_,
   {{0xc9530051,0x628fd74b,0xdca68c66,0x64a68254}},	//   שמה_, _ícon, _раби, _раба,
   {{0xa4918077,0xb22690ca,0xe3e100ab,0x672400f3}},	//   _اینت, _имал, _ভালব, nwij,
   {{0x291a016f,0x7aed0669,0x2bce8a74,0x6aba89ff}},	//   _oppa_, _rvat, हुरा, _uitf,
   {{0x765a80f2,0x4e350158,0x7aed574c,0x61e70bda}},	//   rkty, אָרן_, _svat, vajl,
   {{0x897983de,0x6724574d,0x2baf8075,0x017983de}},	//   _אָנה, kwij, जेवा, _אָנל,
   {{0x291a0b99,0xae0305fc,0x61e7574e,0xfb870071}},	//   _appa_, _लालन_, tajl, тынн,
   {{0x175781c6,0x97378538,0x25fe2743,0x6724090d}},	//   _בסדר_, _שרגא_, _लागी_, dwij,
   {{0xc6938159,0xa01b07ca,0x61e7574f,0x7ae081c0}},	//   _דאס_, _fjöl, rajl, _lwmt,
   {{0x20c70665,0x6f0d5750,0x61e707d9,0x9f9d007b}},	//   _või_, ttac, sajl, _bæði_,
   {{0x53350676,0xc62580ab,0x7aed0669,0x672437ce}},	// [4bd0] _септ, বারা_, _uvat, gwij,
   {{0x6f0d266a,0x7c2d0a10,0x3a2cb6f8,0x81dd00ab}},	//   rtac, _haar, _nadp_, _ডাক_,
   {{0x7bf98993,0x9f5f876b,0x6f00b468,0x0b941ab3}},	//   енер_, rgué_, humc, _مجید,
   {{0x7c2d3ade,0x645d5751,0x6f0d5752,0x6f00c097}},	//   _jaar, nksi, ptac, kumc,
   {{0x27e90a5b,0x610a8086,0x6f00826c,0x7cc18ec3}},	//   maan_, _məlu, jumc, _vēri,
   {{0xdd868013,0x7c2d278d,0x2c62026f,0x3a2c8118}},	//   _هو_, _laar, _móda_, _cadp_,
   {{0xc6920051,0xa3e32631,0x645d2406,0x3a3e89c4}},	//   _האם_, धरा_, kksi, _dntp_,
   {{0x27e95753,0xccf20051,0x39498289,0x7c2d5754}},	//   naan_, _לכל_, ćas_, _naar,
   {{0x443f90ab,0x62950019,0xdd2e81d0,0xe3b398e0}},	//   _inu_, kozo, měře, _ضرر_,
   {{0x27e95755,0x442d847b,0xb7bd8087,0x83528065}},	//   haan_, _hae_, deţe, _دھما,
   {{0x27e95756,0x7c2d5757,0x69c1d758,0x2f0b813c}},	//   kaan_, _baar, _igle, søg_,
   {{0x27e95759,0x442d90e4,0x78bd575a,0x7c2d0df6}},	//   jaan_, _jae_, _nisv, _caar,
   {{0x442da065,0x27e9404b,0x7c2d01d8,0x81d50a49}},	//   _mae_, daan_, _daar, _হয়_,
   {{0x412a176a,0x7c2f3a21,0x442dd75b,0xc87987c0}},	//   ного_, adcr, _lae_, liş_,
   {{0x443fd75c,0xc9550071,0x8cca8ebf,0x7c2d0079}},	//   _onu_, атты, _संयो, _faar,
   {{0x27e9575d,0x7c2d575e,0xc8798182,0x6724575f}},	//   gaan_, _gaar, niş_, twij,
   {{0xee3a1ebd,0x44225760,0x98a3140b,0x69c18ee1}},	// [4be0] нна_, mek_, сите, _ogle,
   {{0x443fd761,0x67240613,0x69c18154,0xb2260705}},	//   _anu_, rwij, _ngle, _смол,
   {{0xae069513,0x69dc10cd,0x27e935e4,0x442db4dd}},	//   _शासन_, mbre, baan_, _bae_,
   {{0x44225762,0x27e95763,0x442dd764,0xe4d7026a}},	//   nek_, caan_, _cae_, اونت_,
   {{0x442d879f,0x68e3013c,0x6d43016d,0xcec880ff}},	//   _dae_, _ændr, änar, _mộc_,
   {{0x443fd765,0x69dc0dc2,0x11548ada,0xcec880ff}},	//   _enu_, nbre, иклю, _lộc_,
   {{0x44225766,0x6e21852e,0x645d0009,0x7d0183a6}},	//   kek_, delb, yksi, juls,
   {{0x44225767,0x8cca81b6,0x7d01930c,0x62838114}},	//   jek_, _संबो, duls, anno,
   {{0x20570158,0xd4678003,0x7de685a8,0x6440d768}},	//   טיקל_, _сите_, лінд, _inmi,
   {{0x7c2d1eaf,0x6e21d769,0x91d4000f,0x27e90ad4}},	//   _saar, gelb, _ब्लै, zaan_,
   {{0x27e9576a,0xa3e889a3,0x7c2d576b,0x6295001b}},	//   yaan_, _मजा_, _paar, vozo,
   {{0x27e902c1,0x44220019,0x7c2d02a3,0x645d0009}},	//   xaan_, gek_, _qaar, uksi,
   {{0x7c2d26a3,0x27e95499,0x78bd047f,0xeb070198}},	//   _vaar, vaan_, _risv, ычно,
   {{0x7c2d01d8,0x27e91197,0x6e2e0c2e,0x45d4b134}},	//   _waar, waan_, _nabb, _токс,
   {{0xd49b2f92,0x27e902a1,0x7c2d576c,0x6440837a}},	//   _при_, taan_, _taar, _onmi,
   {{0x44220179,0x20ca801c,0x4fd52098,0x61e53670}},	//   cek_, _mùi_, ржат, _wehl,
   {{0x6283998a,0x7c22d76d,0x6e2e03c3,0x6d5a8019}},	// [4bf0] ynno, deor, _babb, lyta,
   {{0x442dd76e,0x2be3000f,0xe45f016d,0x64408147}},	//   _sae_, परवा, lkö_, _anmi,
   {{0x27e93d44,0x6e2e1cee,0xf3ff03a7,0x7bcf0081}},	//   paan_, _dabb, nhão_, occu,
   {{0x27e90079,0x7c22d76f,0x628882d4,0x7afd5770}},	//   qaan_, geor, _ajdo, orst,
   {{0x6e2e235a,0x23af81b6,0x7e7a810b,0x38690cb5}},	//   _fabb, जेंद, kitp, mhar_,
   {{0x386900a9,0x261403a4,0x44225771,0x442d8077}},	//   lhar_, न्दी_, zek_, _wae_,
   {{0x291100ad,0x44223f51,0x442dd772,0x29035773}},	//   ntza_, yek_, _tae_, nuja_,
   {{0x443f8870,0x38695774,0x5d8400f7,0x7ccc03bf}},	//   _unu_, nhar_, _الفل, _uğra,
   {{0xc87982bb,0xf8bf0264,0x6e21d775,0xaec28e11}},	//   riş_, _mié_, telb, обыл,
   {{0xee36d67f,0x63a9d776,0x29035777,0x442200d4}},	//   ань_, _izen, kuja_, wek_,
   {{0x44220f87,0xc05b835f,0x6da59290,0x35a58071}},	//   tek_, _під_, рина, ранг,
   {{0x3e640106,0x6f1d01ed,0x6e21d778,0x76b28035}},	//   _möta_, _opsc, selb, _błys,
   {{0x44225779,0x6e21d77a,0x69dc1412,0x38690387}},	//   rek_, pelb, tbre, dhar_,
   {{0x442201f9,0x26c405db,0x320782f7,0x6d5ad77b}},	//   sek_, _émoi_, ngny_, byta,
   {{0x4422577c,0xdca60009,0x69dc10b9,0xc0e60ca0}},	//   pek_, _каки, rbre, робк,
   {{0x6e2e577d,0xad1a8039,0x3869577e,0x7cc50084}},	//   _sabb, _יוצר, ghar_, _gėri,

   {{0xd90d0077,0xf77f1b26,0x27fd009a,0x929d809a}},	// [4c00] ویی_, _peça_, ówna_, _wpły,
   {{0x7df380a5,0x2bde8d72,0x45d609b5,0x2903577f}},	//   _आयोग_, मर्थ, рцат, buja_,
   {{0x38690ad0,0xa5260087,0x98a61fa5,0xa0a609f7}},	//   bhar_, рмед, _вине, _ванд,
   {{0x7ae402a0,0x1d168158,0x20ca80ff,0x3d070074}},	//   _kwit, יקער_, _rùi_, _हमरे_,
   {{0x6e2e00a4,0x7e600087,0x7bc48110,0x7c22d780}},	//   _tabb, _împo, žiuo, reor,
   {{0x7c228867,0x63a9b8de,0xb8f481a8,0x64588035}},	//   seor, _dzen, مكتب, _ścią,
   {{0x61ead1ee,0x6f040083,0x672b80f1,0x63a9d781}},	//   rafl, luic, _asgj, _ezen,
   {{0x14d702f6,0x6440d782,0x649d5783,0x5fc606a7}},	//   _כולל_, _unmi, néit, लखिल,
   {{0x7e7a9d5e,0x44f184b7,0x76aa8198,0x63a98115}},	//   titp, eġ_, ктов_, _gzen,
   {{0x7afd135a,0x6d5a8084,0x7bc40372,0x27e68144}},	//   vrst, tyta, _agiu, _weon_,
   {{0x160b0f0a,0x994a92c8,0x24868503,0xe45f0009}},	//   स्टर_, _جلال_, onom_, tkö_,
   {{0x6298abf8,0x6d5aabe9,0x2486821e,0x291e83ac}},	//   lovo, ryta, nnom_, _ipta_,
   {{0x20118085,0x3d08016f,0x7afd1412,0x3ed481a8}},	//   əzi_, ांडे_, urst, _اقتر,
   {{0x6d5a809a,0x61e8a304,0x48fd800d,0xda7b245b}},	//   pyta, _jedl, रूको_, тям_,
   {{0x61e88e23,0x3869003c,0x2bd80743,0x07e702de}},	//   _medl, thar_, _भ्वा, ицам,
   {{0x7cc18029,0x29030304,0x38600b99,0x16190e5b}},	//   _vērt, ruja_, gkir_, न्नर_,
   {{0x629887dd,0x395f00eb,0xab5b0085,0x6f045784}},	// [4c10] kovo, ņus_, rcüs, guic,
   {{0x386910fe,0x61e88370,0x644f012b,0x1a650019}},	//   shar_, _nedl, ljci, _ایسی_,
   {{0x63a9d785,0x91fc8029,0x3866d786,0x2486817f}},	//   _szen, _plān, _olor_, fnom_,
   {{0xef1f8214,0x6280026f,0x2486d787,0x644f017f}},	//   çük_, émov, gnom_, njci,
   {{0x28c0000f,0x261413ba,0x649d1867,0x96f80162}},	//   _शूटि, न्ही_, léis, _кеят_,
   {{0xa3ac086a,0x3866c495,0x20095788,0x5ed580ab}},	//   केट_, _alor_, lgai_, _দিলে,
   {{0xceb20158,0x25a50019,0x5c078198,0x2486a8fc}},	//   _מיך_, _áll_, _вяза, bnom_,
   {{0x20092062,0x6add00c8,0x6c8580f7,0x4c94862c}},	//   ngai_, _বিনো, _الرم, _дисс,
   {{0x6298816b,0x63a9d789,0xf749803d,0x69c50135}},	//   bovo, _uzen, اجعه_, _oghe,
   {{0x6287011f,0x0e6582cb,0x69c52111,0x765503ec}},	//   jnjo, скон, _nghe, _jozy,
   {{0x62870025,0xc329010f,0x993592c8,0x7ae401c6}},	//   dnjo, _רו_, _دفات, _swit,
   {{0xdd380029,0x15f395a7,0x491c8b75,0x44e38061}},	//   nāša, _आयकर_, _महतो_, rű_,
   {{0x38a1807b,0x2fdf80d7,0x27edd78a,0x649d0118}},	//   jóri_, mbug_, maen_, véit,
   {{0x2486811f,0xfbd81305,0x27ed831d,0x2bd806ce}},	//   znom_, _भ्रम, laen_, _भ्रा,
   {{0x76438063,0xa06a0098,0x291e0722,0x649d1b88}},	//   _inny, гава_, ïta_, téit,
   {{0xb8d0578b,0x320c009a,0x69c501bc,0x7cd38162}},	//   _ओठ_, żdy_, _eghe, _căre,
   {{0xe61a3cb3,0x24868ee0,0x386029a6,0x6444009c}},	// [4c20] лда_, vnom_, rkir_, _inii,
   {{0x4432578c,0x6f044fbe,0x3860008b,0xf41f062c}},	//   _hay_, ruic, skir_, nnän_,
   {{0x44324022,0x5bc680f7,0x61ee578d,0x200900dd}},	//   _kay_, مقال, mabl, bgai_,
   {{0xdd8f0872,0x64560136,0x61ee473a,0xd49980e8}},	//   رون_, _joyi, labl, арі_,
   {{0xa3c9823c,0x4432004c,0x6298a39d,0x27e0578e}},	//   ोड़_, _may_, tovo, mbin_,
   {{0x64560032,0x523a0158,0x3320001b,0x649d00f7}},	//   _loyi, רײַנ, _mpix_, néir,
   {{0x629e0135,0x61e8d78f,0x64a69c0e,0xed570c6e}},	//   _mkpo, _vedl, _гава, _лор_,
   {{0x74168277,0x7643d790,0x443235db,0xc6f8a466}},	//   _دورا, _anny, _nay_, аних_,
   {{0x33668d8e,0x7d1b026c,0x629e0135,0x254e8085}},	//   _уваг, _ćusi, _okpo, məli_,
   {{0x4426d791,0x78a4026f,0x61ee0144,0xbb3b80be}},	//   leo_, hliv, jabl, _געמי,
   {{0x78a45792,0xe0da8b30,0x64565793,0x44322574}},	//   kliv, _све_, _boyi, _bay_,
   {{0x4426d794,0x7643d795,0x7cd38087,0x629e01bc}},	//   neo_, _enny, _bărb, _akpo,
   {{0x44324bc0,0x628702a5,0x78a4016b,0xddc88369}},	//   _day_, tnjo, dliv, midž,
   {{0xfaff020f,0x61ee157a,0x60c280f7,0x69c800e1}},	//   rrë_, gabl, _hiom, žden,
   {{0x4426822e,0x44325796,0x7cd38087,0xf77f0187}},	//   keo_, _fay_, _păre, _peço_,
   {{0xc7d9012f,0x629e0135,0x4426d797,0x661c0115}},	//   рмах_, _ekpo, jeo_, _abrk,
   {{0x4426d730,0x62351584,0x7655009a,0x62870115}},	// [4c30] deo_, _депу, _pozy, pnjo,
   {{0x63ad00ad,0x518719b8,0x44321b11,0xe1338301}},	//   _izan, _гума, _zay_, ščić_,
   {{0x81e780c8,0x27e004b9,0x78a45798,0x4426d799}},	//   _ভাল_, bbin_, bliv, feo_,
   {{0xac19c6a1,0x241981bb,0x4432579a,0xc1b5103e}},	//   роду_, роды_, _xay_, ंधीग,
   {{0xa3ea0f97,0x3de800ab,0x7eaf804a,0xdea40019}},	//   यरत_, _পারল, løpe, _کیلی,
   {{0x672f111b,0x7c2629bd,0x63ad1fb6,0xdcf422f8}},	//   _iscj, zekr, _mzan, _çağl,
   {{0x4426d79b,0x6d5e010c,0x7cd38162,0x27edb3d9}},	//   beo_, cypa, _mărc, taen_,
   {{0x26c305a4,0x61ee0a0c,0x63ad5207,0x60c2d79c}},	//   _hijo_, zabl, _ozan, _ciom,
   {{0x2fdfcf79,0x60c2d79d,0x27edd79e,0x656d8326}},	//   rbug_, _diom, raen_, _ƙaho,
   {{0x248d8b40,0x8cca81cb,0x4432579f,0x26cb0314}},	//   _hjem_, _संशो, _say_, _muco_,
   {{0x26c357a0,0x63ad57a1,0x7cd38087,0x248d821e}},	//   _mijo_, _azan, _sărb, _kjem_,
   {{0x2907d7a2,0xdb078789,0x16190cf0,0x3a27826c}},	//   muna_, _ímót, न्तर_, lenp_,
   {{0xd6db8abe,0x6d5e009a,0x61ee1b7d,0x443257a3}},	//   _сте_, zypa, tabl, _vay_,
   {{0x386d80a9,0x44320051,0xfce580b3,0x4426811f}},	//   lher_, _way_, _доко, zeo_,
   {{0x61ee57a4,0x78a404e8,0x44320104,0x29078850}},	//   rabl, tliv, _tay_, nuna_,
   {{0xe3bf00ab,0x248dd7a5,0x44268511,0x26cb00e5}},	//   seña_, _njem_, xeo_, _buco_,
   {{0x4426803b,0xa0670381,0x8fa30d31,0x290784a7}},	// [4c40] veo_, цата_, дате, huna_,
   {{0x2907bc75,0xa3af2e2b,0x9f44bb50,0x78a404fe}},	//   kuna_, _करत_, namá_, sliv,
   {{0x4426d7a6,0x26c300ab,0x2907d7a7,0xfc3f03a8}},	//   teo_, _dijo_, juna_, llía_,
   {{0xf7461935,0x2907d7a8,0x629c1c7c,0x26cb002a}},	//   _демо, duna_, loro, _fuco_,
   {{0x26c3238a,0x386d81b9,0x9d0a00ab,0xda05950e}},	//   _fijo_, dher_, রবেন_, _राखत_,
   {{0x4426d7a9,0x29078a40,0x16190ebf,0x6f162c2d}},	//   seo_, funa_, न्दर_, mtyc,
   {{0x290795e8,0xa3ea0b75,0x60c2847f,0xddc88699}},	//   guna_, यरा_, _piom, tidž,
   {{0x629c57aa,0x3ea5816d,0x63a457ab,0x26c3026c}},	//   horo, ellt_, _oyin, _zijo_,
   {{0x63a432cf,0x629c57ac,0xf8b302f6,0x29078087}},	//   _nyin, koro, ושה_, auna_,
   {{0x2ca6d7ad,0x629c57ae,0xb5e80264,0x76aa83a7}},	//   llod_, joro, _পাঁচ, јтив_,
   {{0xa06aa66c,0x60c28cb5,0x63a4228d,0x63ad2448}},	//   _кажа_, _tiom, _ayin, _szan,
   {{0x386d837e,0x6f16009a,0x63a402a0,0x2ca6911e}},	//   cher_, ktyc, _byin, nlod_,
   {{0x09e200c8,0x629c40ef,0x63a40a03,0x7792881b}},	//   _বাজা, foro, _cyin, _زیدا,
   {{0x59dd800d,0x32d0801c,0x9c130133,0x628ac44b}},	//   नुपर, _mày_, _nọve, nnfo,
   {{0x58d41232,0x6e28d7af,0x628ad7b0,0xc0cb210d}},	//   дост, medb, info, руге_,
   {{0x6722819d,0x200f02f1,0x43950a18,0x62800866}},	//   _kpoj, ügi_, _найс, émor,
   {{0x32d08142,0x629c57b1,0x765881c0,0x29078102}},	// [4c50] _này_, boro, _kovy, zuna_,
   {{0xe3bf0511,0x6e28b7e5,0x26cb082c,0x249fa280}},	//   leño_, nedb, _vuco_, _skum_,
   {{0x7d08ac76,0x1bf200d4,0x5fca9869,0x69d5066f}},	//   nuds, _अजमल_, ाखाल, mcze,
   {{0xa3af1880,0x81e780c8,0x2907a198,0x61fa8118}},	//   _करा_, _ভাই_, vuna_, _adtl,
   {{0x4c3c0158,0x9327803d,0x3ea5d7b2,0x32d08129}},	//   יגאצ, تران, yllt_, _cày_,
   {{0x6e2882ce,0x99910019,0x32d080ff,0xdc558019}},	//   jedb, lező_, _dày_, _کرسک,
   {{0x386d804c,0xd24e80f7,0x823480f7,0x67228032}},	//   ther_, انى_, برنا, _apoj,
   {{0x629c1ee0,0x628a81a1,0x25ed8072,0xe3bf0144}},	//   zoro, anfo, _आजही_, jeño_,
   {{0x2907d7b3,0x386d82af,0x629c0a5a,0xe3bf0333}},	//   suna_, rher_, yoro, deño_,
   {{0x670c0beb,0x7ae9d7b4,0x386d8367,0x6e3557b5}},	//   िंतक_, _iwet, sher_, _jazb,
   {{0xcb090051,0x629c4319,0xdca62098,0x64a61287}},	//   _תל_, voro, зани, зана,
   {{0x7ae9d642,0x629c1111,0x69d5009a,0x672d1f12}},	//   _kwet, woro, ecze, kwaj,
   {{0x629c29f4,0x7052a403,0x20d18129,0x87049df9}},	//   toro, _سنوا, _hái_, _قبول,
   {{0x70b40ee6,0xf77082e3,0x7ae9d7b6,0x2f140106}},	//   ंग्ल, _جام_, _mwet, väg_,
   {{0xd9430dc0,0x629c48e1,0x6da2bac1,0x213e01a8}},	//   нери, roro, _пиша, íth_,
   {{0x786a003e,0xfc3f57b7,0x20d1801c,0x629c391e}},	//   _býva, llín_, _mái_, soro,
   {{0x442057b8,0x629c57b9,0x20d1801c,0x3e6086c0}},	// [4c60] _ibi_, poro, _lái_, _sòti_,
   {{0x7c3602d0,0x388581a9,0x6a700338,0x6f16066f}},	//   _hayr, mēru_, _säff, rtyc,
   {{0x6f160063,0x0c26b38c,0x6e3501a1,0x261383ca}},	//   styc, змен, _dazb, _दानी_,
   {{0x3d1c0403,0xc20e800f,0x9b6a8221,0x7ae98365}},	//   _नहीं_, _साहब_, йшла_, _bwet,
   {{0xe3638ab2,0x442057ba,0x09c500c8,0x7c3602b8}},	//   нкци, _mbi_, ্রণা, _mayr,
   {{0x8d660396,0x442057bb,0x628a8333,0x6f044d10}},	//   _евге, _lbi_, unfo, mric,
   {{0x67229249,0x20d18104,0x4420082e,0x6e28c319}},	//   _spoj, _cái_, _obi_, vedb,
   {{0x64a39c68,0x69d557bc,0x27f20079,0x2b40026c}},	//   _заса, zcze, nayn_, _oric_,
   {{0x213e8355,0x07f780f7,0x6f041cb6,0x290a0234}},	//   _wrth_, سريع_, nric, huba_,
   {{0x290a467d,0x442057bd,0x27f20079,0x6f040c5e}},	//   kuba_, _abi_, hayn_, iric,
   {{0x7c361010,0x6e28803a,0x20d18028,0x442057be}},	//   _bayr, redb, _gái_, _bbi_,
   {{0x2b208b3b,0x60c6059c,0x7d08806a,0x6e2882d4}},	//   _यहाँ_, _nikm, ruds, sedb,
   {{0xfc3f22d8,0xa5f882de,0xe3bf57bf,0xe8e00129}},	//   blín_, _делу_, reño_, _thớt_,
   {{0xe3bf040e,0x442057c0,0xf7bb81c6,0x7c361407}},	//   seño_, _ebi_, _הזדמ, _eayr,
   {{0x290a2676,0xe3bf0511,0xdd8f8048,0x6f040037}},	//   guba_, peño_, _чш_, eric,
   {{0x29030168,0x7c3602d0,0x672d0314,0x6e35128a}},	//   rrja_, _gayr, twaj, _sazb,
   {{0xa01b57c1,0xbfab21f6,0xcc3400f7,0x3ed901a8}},	// [4c70] _björ, стве_, _سريع, زواج_,
   {{0x442b378d,0x672d1258,0x44393396,0x7bc98014}},	//   lec_, rwaj, lds_, _sgeu,
   {{0x7ae9d7c2,0x290a1267,0x6e3501d0,0x2dd801a8}},	//   _swet, cuba_, _vazb, سبلة_,
   {{0xc0ab07bd,0x44394f95,0x442b57c3,0x7c3657c4}},	//   _داخل_, nds_, nec_, _xayr,
   {{0x443957c5,0x6f0401df,0x1a658416,0x9f59861c}},	//   ids_, cric, ویری_, üsü_,
   {{0x78a2826c,0x442b57c6,0xbb4290ca,0xa01b008b}},	//   _akov, hec_, тешк, _gjör,
   {{0x442b4744,0xe1f09a3c,0x6594117c,0x261381d0}},	//   kec_, اسه_, _зару, _दाबी_,
   {{0xba77803d,0x443940d1,0x673b8bcf,0x7ae9d7c7}},	//   _کارت, jds_, tvuj, _twet,
   {{0x521581ae,0x290a00b4,0x200d86ab,0x7afb0140}},	//   _одат, zuba_, rgei_, šutj,
   {{0x443905f8,0x442034b1,0x20d1801c,0x7c2b9ff1}},	//   eds_, _sbi_, _tái_, legr,
   {{0x90e78077,0xfc3f57c8,0xb5798009,0x291808dc}},	//   _رسان, rlín_, ющих_, xtra_,
   {{0x442b0988,0x645b92b6,0x6f0457c9,0xff519e29}},	//   gec_, _joui, yric, _لخت_,
   {{0x201882bf,0x6f09d7ca,0x25aa10be,0x78a98b81}},	//   əri_, quec, _कर्ण, mlev,
   {{0x290a0a5a,0x29181b08,0xc332807c,0x60c657cb}},	//   tuba_, ttra_, דוך_, _sikm,
   {{0x442b0e04,0x3d0c009a,0x6449800b,0x6f0457cc}},	//   bec_, _हमें_, _onei, wric,
   {{0x44202a86,0x78a9d7cd,0x26c780b4,0x6add00ab}},	//   _ubi_, nlev, _hino_, _বিরো,
   {{0x26c7d7ce,0x98a30468,0x26cfd7cf,0x6283d7d0}},	// [4c80] _kino_, тите, _jugo_, kino,
   {{0x26cfd7d1,0x6f0432c7,0x26c7d7d2,0x27f257d3}},	//   _mugo_, rric, _jino_, sayn_,
   {{0x6283d7d4,0x26cf862f,0x645bd0aa,0x6f045778}},	//   dino, _lugo_, _boui, sric,
   {{0x26c7d7d5,0x7c2b8faf,0x32d40009,0x50b621d2}},	//   _lino_, gegr, _käy_, _існу,
   {{0x78a99fb2,0x645b8866,0x93cb8019,0x2d828326}},	//   dlev, _doui, زانہ_, ̄ke_,
   {{0xfe6783f8,0x442b06b9,0x78a2813c,0x38cb00d7}},	//   _شد_, zec_, _skov, _دایی_,
   {{0x65c30110,0x7c2bd778,0xe5a6197b,0x443944e7}},	//   _абра, begr, _циви, yds_,
   {{0xcec88104,0x2900a8c4,0x765c3f52,0x2c62016b}},	//   _hội_, čia_, _hory, _kódu_,
   {{0x26c782ec,0x09b500ab,0x61fe23f9,0xd426811c}},	//   _bino_, _জ্ঞা, _odpl, ışdı_,
   {{0x628382d7,0x7cd38162,0x5d54a061,0x26c789c4}},	//   cino, _căro, екот, _cino_,
   {{0x26c7d7d6,0x78a9d7d7,0x7ae2d7d8,0x7e600162}},	//   _dino_, blev, lpot, _împu,
   {{0x27ef807b,0x765c57d9,0xa3d64073,0xfc3f002a}},	//   _gegn_, _lory, ाँग_, rlío_,
   {{0x443957da,0x26c7d7db,0x442b2f62,0x8cca8127}},	//   rds_, _fino_, rec_, _संको,
   {{0x26c7a3ff,0xb06184a2,0x9958001b,0x6594814c}},	//   _gino_, _ääre, láře_, _палу,
   {{0xcec88104,0x6d58062c,0x6aaa8428,0xf7730061}},	//   _nội_, äval, ilff, ھار_,
   {{0x9ed90071,0x26c78365,0xb8d702f1,0x2480008e}},	//   змат_, _zino_, _छठ_, _gmim_,
   {{0x69dad7dc,0xeb0d8bb8,0xb8d60576,0x7bcd00eb}},	// [4c90] _ofte, _समेत_, _ची_, _igau,
   {{0x6283887a,0x6449d7dd,0xb90500ab,0x765c422a}},	//   xino, _snei, _নি_, _cory,
   {{0xd49b917e,0x8c3d8214,0xdb00802a,0x25de06a7}},	//   орд_, _akşa, _gzmú, गड़ी_,
   {{0x1ddf18a9,0xd5df0a0d,0x05df0e70,0x69dac33f}},	//   _प्रत, _प्रज, _प्रब, _afte,
   {{0x7c2b83a8,0xe8df0028,0x27ef8370,0x38690041}},	//   regr, _khỏe_, _regn_, mkar_,
   {{0x6e38d7de,0x38691a31,0xdcfb0077,0x7aed3f9c}},	//   _navb, lkar_, _ورزش_, _mwat,
   {{0x6283d7df,0x6f0d2e88,0x8cca8006,0x26c7b032}},	//   rino, luac, _संगो, _rino_,
   {{0x69da8786,0x26c7d7e0,0x38690687,0x7bcd2031}},	//   _efte, _sino_, nkar_, _ngau,
   {{0x6f0d2d11,0x78a9d7e1,0x261381ce,0x27ef852a}},	//   nuac, rlev, _दादी_, _vegn_,
   {{0x99678371,0x02cb9905,0x7bcd57e2,0x63a9912e}},	//   _отел, ादीन, _agau, _iyen,
   {{0x7aed2892,0x78a9a28f,0xd0118019,0x6f0d21fd}},	//   _awat, plev, _ملا_, huac,
   {{0xeb9a0f2e,0x3e6981ac,0x63a98365,0x7aed36ed}},	//   зим_, _túto_, _kyen, _bwat,
   {{0x3ea10006,0x386957e3,0x2f2301a9,0x63a9818f}},	//   koht_, dkar_, nīgā_, _jyen,
   {{0xd7748b8c,0x42798158,0x6f0d1883,0x7afb8c53}},	//   _جامع, לאָג, duac, _mvut,
   {{0xe2972f4b,0x628e21fb,0x48b60d70,0xd826046e}},	//   хар_, rnbo, ещат, ндви,
   {{0x786a003e,0x38691600,0x63a9d7e4,0xddca82d6}},	//   _vývo, gkar_, _oyen, _anfň,
   {{0x63a9d2b3,0x7c2402a0,0x6f0d57e5,0x06e380ab}},	// [4ca0] _nyen, _ibir, guac, _মিডি,
   {{0xba760077,0xdb9b0496,0xa2d50e81,0x7bdbc577}},	//   _ساخت, _מספר, _यंत्, _afuu,
   {{0x9f420364,0x7afbd7e6,0x7c2404b7,0x7871128d}},	//   _sekä_, _avut, _kbir, _såve,
   {{0xdee61f25,0x386900f2,0x66e61a19,0x78710687}},	//   _поми, ckar_, _пома, _påve,
   {{0x7ae28067,0x6f0d11b9,0x2907a766,0x7c244b40}},	//   upot, cuac, erna_, _mbir,
   {{0x7ae28359,0xcec8801c,0x9f5206c0,0x3a3a0106}},	//   rpot, _tội_, vayè_, _japp_,
   {{0xdd920307,0xfd078277,0x7c2457e7,0x98c68087}},	//   _صور_, _حج_, _obir, нсил,
   {{0x7f428201,0x9d1b04de,0x61f502a5,0x7ae2d7e8}},	//   _proq, _מולט, zazl, ppot,
   {{0x63068c48,0x29078083,0x26ca2dcb,0x63a9d7e9}},	//   _سوال, arna_, _kibo_, _gyen,
   {{0xdbfb0a16,0x7c242a75,0xe0ce80ab,0x3b83a6b1}},	//   ्ल्ड_, _abir, _রবীন, _слуг,
   {{0xdb160065,0xdd948196,0xfc3f026f,0xf76f803d}},	//   _együ, таны, slím_, لای_,
   {{0x26ca0c27,0x7f428c1d,0x7ccc07c0,0x2486866f}},	//   _libo_, _troq, _uğru, niom_,
   {{0x4e10000d,0xfbab17ae,0x6d43d7ea,0x7eb00338}},	//   ालाई_, ятой_, _erna, väpn,
   {{0x7c240c56,0x442482c4,0x26ca57eb,0x2ba50d72}},	//   _ebir, _lbm_, _nibo_, _गुणा,
   {{0xe4a71d79,0x3e728087,0xe29f007b,0x290e8041}},	//   _прио, _câte_, nuði_, nufa_,
   {{0x2ea90054,0x7aed4b40,0x26ca01a1,0xd49801e2}},	//   कत्त, _twat, _aibo_, _пры_,
   {{0x644d57ec,0x7c2f009f,0x3869088b,0x26ca57ed}},	// [4cb0] _inai, mecr, rkar_, _bibo_,
   {{0x386957ee,0x290eafc9,0x7c240805,0x26ca0081}},	//   skar_, kufa_, _zbir, _cibo_,
   {{0x4424d7ef,0x443b00f1,0x6287076a,0x9419a296}},	//   _bbm_, _kaq_, mijo, джет_,
   {{0x628757f0,0x7c3d02fe,0x6281801b,0x4424aaa0}},	//   lijo, ndsr, _smlo, _cbm_,
   {{0xa7fb07f4,0x27e957f1,0x26190f12,0x6f0d2bd5}},	//   _coñe, mban_, _पापी_, quac,
   {{0x78ad57f2,0x628712b9,0x26ca02c4,0x63a9804f}},	//   llav, nijo, _gibo_, _vyen,
   {{0x40959cd5,0x248688ae,0x644d5163,0x56942749}},	//   крит, biom_, _onai, _сарт,
   {{0x27e90065,0x7e600087,0x6f1bcdb0,0x7c3d0366}},	//   nban_, _împr, ttuc, jdsr,
   {{0x442fa00a,0x2ba88105,0x8ccb141b,0x5b158b73}},	//   meg_, _छुपा, _संजो, _шмат,
   {{0x442f8558,0x7c3bd7f3,0x644d2307,0x83fd8065}},	//   leg_, _haur, _anai, _előt,
   {{0x27e90065,0x2619123a,0x78ad3ef9,0x7c3b9cc5}},	//   kban_, _पानी_, klav, _kaur,
   {{0x442f8114,0x7c3b811e,0xddce001b,0x3201008e}},	//   neg_, _jaur, _dobř, _adhy_,
   {{0x7c3ba7f5,0x987a80be,0xe73981f3,0x3e641252}},	//   _maur, _קאנט, _цел_, _kött_,
   {{0xd2520c3b,0x62870110,0x6d4381ac,0x161886b7}},	//   جنس_, gijo, _trna, _दायर_,
   {{0xc21284de,0x78ad008b,0x78b981c0,0x7fd60221}},	//   יהם_, flav, _khwv, візі,
   {{0x442f803a,0x27e90019,0x7c3bd7f4,0x3eb802c4}},	//   jeg_, gban_, _naur, _shrt_,
   {{0x442fa10a,0x628757f5,0xee3a1a1a,0x984580eb}},	// [4cc0] deg_, bijo, мна_, dēļ_,
   {{0x62870084,0x6d41876c,0x34ca8f12,0x60cb8901}},	//   cijo, ovla, िद्द, _ligm,
   {{0x27e957f6,0x5fa7016f,0x7c3b9500,0x26ca01e8}},	//   bban_, _कुठल, _baur, _vibo_,
   {{0x25410a8e,0xa7fb062f,0xb5098beb,0x7c3bd7f7}},	//   _dėl_, _poñe, _विनय_, _caur,
   {{0x7c3bd7f8,0x26ca57f9,0x332900b9,0x2c1a081f}},	//   _daur, _tibo_, _xpax_, _भानू_,
   {{0x6f09d7fa,0x5b7b00be,0xe18909a7,0x442480b9}},	//   drec, ורנא, _آئین_, _wbm_,
   {{0xcec88142,0x6e3c57fb,0x442483a7,0x7c3bd7fc}},	//   _một_, _iarb, _tbm_, _faur,
   {{0x442f8052,0x7c3bd7fd,0x62870110,0x656357fe}},	//   ceg_, _gaur, zijo, änhe,
   {{0x291c82a5,0x6e3c57ff,0x83fd8019,0x60cb809c}},	//   stva_, _karb, _elős, _digm,
   {{0x644d5800,0xa80603bf,0x7c3b9ffc,0xb90880ab}},	//   _snai, ldığ, _zaur, _বি_,
   {{0xa96a9fbe,0x6f09802e,0xb7bd8087,0x27e90061}},	//   _تمام_, arec, deţu, yban_,
   {{0x6f098eb9,0xa80603bf,0x9ffa8eca,0x70be0c33}},	//   brec, ndığ, _آراء_, ्दोल,
   {{0x6f09a509,0x62875801,0x63b6009a,0xcec880ff}},	//   crec, tijo, _czyn, _bột_,
   {{0x2be30063,0xc60800ab,0xcec880ff,0x3e640106}},	//   _क्रं_, র্তা_, _cột_, _möts_,
   {{0x62875802,0x442fbb1d,0x27e90065,0x236d01ac}},	//   rijo, yeg_, tban_, šej_,
   {{0x62870a28,0x27e95803,0x6e3c1d49,0x61f8826c}},	//   sijo, uban_, _aarb, havl,
   {{0xdef80b71,0x442fa055,0x2ca90a20,0xc0c8464f}},	// [4cd0] вых_, veg_, _ikad_, туре_,
   {{0x78ad0b72,0x7c3b83c3,0x63ad5804,0x27e90019}},	//   slav, _saur, _iyan, sban_,
   {{0x6e3c3b88,0x7c22d805,0x7c3b8081,0x569403c7}},	//   _darb, ffor, _paur, шафт,
   {{0x7c22a7d1,0xfc3f5806,0x25410110,0x6e3c051e}},	//   gfor, ndí_, _vėl_, _earb,
   {{0x6e3c5807,0x442f92af,0x2911071f,0x4ea702df}},	//   _farb, reg_, luza_, _арва,
   {{0x442fd808,0x63ad3b27,0x7c3b8326,0x7afd39a9}},	//   seg_, _myan, _waur, isst,
   {{0x7c3ba614,0x29114c0f,0x7c22d809,0x63ad4439}},	//   _taur, nuza_, bfor, _lyan,
   {{0x20d8863e,0x6f098cc9,0x81d900c8,0x83fd8019}},	//   _déi_, trec, ারি_, _előr,
   {{0x62850613,0x63ad580a,0xb4bf8768,0x2911580b}},	//   _omho, _nyan, ँगी_, huza_,
   {{0x3d08035a,0x7afd0370,0x291123a8,0x6f098cf7}},	//   ांचे_, dsst, kuza_, rrec,
   {{0x63ad580c,0x6f09d778,0x81d900ab,0x60cb8bb1}},	//   _ayan, srec, ারা_, _tigm,
   {{0x67030aed,0x6d41a409,0x2911580d,0x2246080a}},	//   _लिंक_, rvla, duza_, _şok_,
   {{0x63ad02f4,0xd7f885e9,0x7afd21b4,0x9c1411d3}},	//   _cyan, _рух_, gsst, _fọnt,
   {{0xa3e40a74,0x454580d5,0x29110b5e,0x78710bbd}},	//   _प्र_, _منتق, fuza_, _råva,
   {{0x69dc02be,0x04462853,0x63ad556d,0x29112a8a}},	//   rcre, _бейн, _eyan, guza_,
   {{0x61f882a5,0x6e3c580e,0x388c801b,0x69dc2a70}},	//   zavl, _sarb, běru_, scre,
   {{0x6d47527c,0x386d83b2,0x7c2283ba,0x290a0267}},	// [4ce0] _arja, iker_, vfor, srba_,
   {{0x2619035a,0x29111e98,0xe6171541,0x7ae40a63}},	//   _पाणी_, buza_, лду_, _itit,
   {{0x386d92f0,0x0446a84d,0x6e3c580f,0x787581ac}},	//   kker_, лежн, _varb, _záve,
   {{0xeb9a8991,0x6e3c02a3,0x386d8a0f,0x3ea59dba}},	//   ние_, _warb, jker_, holt_,
   {{0x6e3c5810,0x7c22ae52,0x5efe052a,0xa806080a}},	//   _tarb, rfor, _लिट्_, rdığ,
   {{0x7c229277,0xd13a8656,0x386d9151,0xfc3f016b}},	//   sfor, ехи_, eker_, zdí_,
   {{0x26190b9f,0x14cf816f,0x7c22adb7,0xe9df827d}},	//   _पाती_, _संगण, pfor, _đút_,
   {{0x64a6d5d3,0x63a90063,0x7ae45811,0x61f88d11}},	//   _саба, żeni, _otit, savl,
   {{0x44f181e2,0x6a169a00,0xeb979073,0xa3e482f1}},	//   eš_, _مبار, _бит_, पुण_,
   {{0x7afd0370,0x6ce6cf05,0x2ca6a960,0x073704de}},	//   vsst, ліме, lood_, נאים_,
   {{0x7ae45812,0x63ad5813,0x2bc7064a,0x628ad814}},	//   _atit, _syan, रेना, mifo,
   {{0x2ca6d815,0x386dbd20,0xd5b79adb,0x29111ad3}},	//   nood_, cker_, ысы_, vuza_,
   {{0xfc3f3bec,0x2f18a45b,0x657a8019,0x6d410661}},	//   rdí_, _роль_, szth, _álav,
   {{0x2ca6aa06,0x63ad5816,0x7afd5817,0x29110b5e}},	//   hood_, _vyan, rsst, tuza_,
   {{0x7ae40870,0x63ad5818,0x2ca6aa1f,0x9f4b07f1}},	//   _etit, _wyan, kood_, _secà_,
   {{0x29110c03,0x628ad819,0x7ae40609,0xda1703ca}},	//   ruza_, hifo, _ftit, _तावत_,
   {{0x26cecc19,0x209811e9,0x44294988,0x35f50790}},	// [4cf0] _kifo_, укты_, _iba_, ипар,
   {{0xdd9b004a,0x32d986c0,0xa7fb016a,0x7cd38162}},	//   нше_, _rèy_, _doña, _sări,
   {{0xceb3893f,0x7cd38087,0x3cfe86cb,0x69c80d2f}},	//   ציע_, _pări, nstv_, žder,
   {{0xd3718013,0x2ca6d81a,0xae19001b,0x23bb026b}},	//   يها_, good_, न्जन_, _gàjí_,
   {{0x4429082e,0x291e8197,0x447c03de,0x7c3f0df6}},	//   _mba_, _aqta_, ענדע, _maqr,
   {{0xaa458ff0,0x61f70101,0x6d47008e,0x06e38264}},	//   рекл, _jexl, _trja, _মিলি,
   {{0x4429581b,0x60cf00d2,0x3a3e8118,0xc6920039}},	//   _oba_, _kicm, _datp_, _ואם_,
   {{0xf8b50ee6,0x6f0d0090,0x248b01a1,0xaf0584ad}},	//   ंतिय, orac, jicm_, апил,
   {{0x3255807f,0x7c29d81c,0x443f801f,0xcf8e8077}},	//   _квар, _iber, _iau_, وژه_,
   {{0x443fd81d,0x386dd81e,0x442946e5,0x628a802a}},	//   _hau_, sker_, _aba_, cifo,
   {{0x443f8274,0x7ae44480,0x4429581f,0x6f0d0219}},	//   _kau_, _stit, _bba_, hrac,
   {{0x443fbd3b,0x64a61597,0xcb6a01f3,0xdca63e3d}},	//   _jau_, рама, ваме_, рами,
   {{0x443f88b3,0x7c2988b8,0x27edd820,0x26ce846d}},	//   _mau_, _mber, mben_, _fifo_,
   {{0x443fd821,0x27edd822,0x877a80be,0x4429404e}},	//   _lau_, lben_, _באני, _eba_,
   {{0x7c29d823,0xa7fb0693,0x2effa1e5,0x257b8032}},	//   _ober, _soña, lsuf_, _dálé_,
   {{0x3fe628fe,0x4429077f,0x443f86c1,0x6f0d3cfe}},	//   ржав, _gba_, _nau_, frac,
   {{0x7e63d824,0x27ed8352,0xa6860791,0x78780073}},	// [4d00] _konp, iben_, алад, _níve,
   {{0x7c29cc82,0x61408019,0xf5e7002e,0x60cf0037}},	//   _aber, nálá, имул_, _eicm,
   {{0x27ed8065,0x6f0d1a29,0x2ca6cc98,0x7e638bfe}},	//   kben_, arac, tood_, _monp,
   {{0x499b0f60,0x61fc3a32,0x0b469109,0x443fd825}},	//   _ישיב, larl, инен, _cau_,
   {{0x443fd826,0xa01b016d,0x2ca6857b,0x7c298642}},	//   _dau_, _omöj, rood_, _dber,
   {{0x61fc5827,0x443f82be,0x27ed8352,0x27e03468}},	//   narl, _eau_, eben_, lcin_,
   {{0xd1308013,0x628ad828,0xed571a1b,0x443f821e}},	//   سمة_, rifo, _кор_, _fau_,
   {{0x27e003c3,0x443fd829,0x7416815b,0x20548098}},	//   ncin_, _gau_, _خورا, ския,
   {{0x61fc3c41,0x6440a20e,0x27e03603,0x4426d82a}},	//   karl, _iami, icin_, mfo_,
   {{0x61fc582b,0xa3bd0bb8,0x443fa6b4,0x7c29824a}},	//   jarl, _अरब_, _zau_, _zber,
   {{0x27edd82c,0x443fd82d,0x61fc582e,0xa2b7000d}},	//   bben_, _yau_, darl, ोगस्,
   {{0x44269aed,0x6440a07b,0x443fbff5,0x746b0ba5}},	//   nfo_, _jami, _xau_, тров_,
   {{0x7b642aed,0xec718158,0x6140a5b3,0x61fc209b}},	//   отре, פֿט_, bálá, farl,
   {{0x28db1094,0x443f44a9,0x6f0d141f,0x7d03026f}},	//   _मंदि, žu_, vrac, ánsk,
   {{0x60c400b9,0x7c3f022b,0x753c0140,0x6f0d582f}},	//   fmim, _taqr, _nsrz, wrac,
   {{0x64408569,0x6d4a9286,0x6f0d5830,0x44292bd7}},	//   _nami, _irfa, trac, _uba_,
   {{0x443f946a,0xd7f85831,0x61fc5832,0xdddc0301}},	// [4d10] _rau_, рус_, barl, _smrš,
   {{0x443fd833,0x7c2984c3,0x61fc229d,0xe45f016d}},	//   _sau_, _sber, carl, ljö_,
   {{0x443fa6e1,0x6440bf5e,0x6f0d0046,0xf8b107d2}},	//   _pau_, _bami, srac, _فکر_,
   {{0x6f0d1122,0x29360158,0x6f02826f,0x443fb592}},	//   prac, _פארן_, _ovoc, _qau_,
   {{0x6440d834,0x443fd835,0xa6db0125,0x91e58db4}},	//   _dami, _vau_, _orði, боле,
   {{0x443fd836,0x200680ee,0x64428118,0xe80f02f1}},	//   _wau_, _adoi_, adoi, िलका_,
   {{0x443f946a,0x27ed8065,0xdd940196,0x65940f25}},	//   _tau_, tben_, _дары, _дару,
   {{0x6440d837,0x26d15838,0x61fc5839,0x27edd83a}},	//   _gami, _hizo_, zarl, uben_,
   {{0x27edd83b,0xbb8580f7,0x7e63c78b,0x6d4ad83c}},	//   rben_, _الذي, _ponp, _arfa,
   {{0x64408ebf,0x2489583d,0x7875826f,0x60c400d2}},	//   _zami, _amam_, _dáva, zmim,
   {{0x41b58b76,0x26d90207,0xe5a58037,0x26d1583e}},	//   _امار, _luso_, сини, _mizo_,
   {{0x25458029,0xf8bf0028,0x672f009a,0x26d10118}},	//   _vēl_, _nhé_, _opcj, _lizo_,
   {{0x6d4ad83f,0x9f40807b,0xd7a70c28,0xfc3f0118}},	//   _erfa, _þið_, _कुलच, moíl_,
   {{0x7e7a8f67,0x63bb804f,0x91e318d1,0x09e31628}},	//   chtp, _mzun, зоре, зорн,
   {{0x61fc22f8,0x7875826f,0x6a6b080a,0xa7fb01ca}},	//   rarl, _záva, _nüfu, _coño,
   {{0x26d95840,0x61fc3a03,0xf8bf5841,0x27e00300}},	//   _buso_, sarl, _ché_, ucin_,
   {{0x44f501ac,0x60c45842,0x7bd6222e,0x2bc70054}},	// [4d20] eť_, rmim, _igyu, रेदा,
   {{0x61fc208e,0xc7b283c8,0x3e76007b,0x27e000fc}},	//   qarl, לבן_, _bæta_, scin_,
   {{0x6440d843,0xa3df04e5,0x63a904b7,0xa0a60110}},	//   _pami, दुक_, żent, _ганд,
   {{0x628e02e8,0xf8bf00ff,0x26d9495b,0x78a98b80}},	//   libo, _ghé_, _fuso_, joev,
   {{0x8c1b02f6,0x28b500d4,0x38ba8168,0x26d14022}},	//   רוני, ंतरि, jëra_, _fizo_,
   {{0x66e30098,0x63bba44c,0xdee300ae,0x2cbfa008}},	//   _хора, _dzun, _хори, _ehud_,
   {{0x67245844,0x6440d845,0xb5099521,0x2ee68166}},	//   ltij, _tami, _विषय_, _stof_,
   {{0x04968064,0x3860059c,0xe45f016d,0x628e5476}},	//   _الرح, njir_, xjö_, hibo,
   {{0x628e0033,0x1ddc01a2,0x421a830f,0x3f8000e1}},	//   kibo, _बलात, _مزاج_, nziu_,
   {{0xa3e4923a,0x626580f7,0x8c448087,0x1ed781a8}},	//   पुर_, _والق, ăşur, حبيب_,
   {{0xd7efd846,0x6724111b,0x998c8858,0x628e1400}},	//   _ну_, htij, _hadž_, dibo,
   {{0x67244603,0x7d0305e4,0xac1900e8,0x6aaa800b}},	//   ktij, ánsi, шому_, loff,
   {{0xa7fb01df,0x628e5847,0x938b2482,0x0b8b302b}},	//   _soño, fibo, усна_, усни_,
   {{0x38668b3c,0x26d90333,0xb69b0087,0xe45f0106}},	//   _hoor_, _ruso_, _avân, sjö_,
   {{0x54e6806b,0x9f59079f,0x26d9535b,0x65939052}},	//   _استق, _gesê_, _suso_, _нашу,
   {{0x43953e41,0x26d95848,0x67245849,0x7602801b}},	//   _майс, _puso_, ftij, bízí,
   {{0x9df91fc1,0x628e0f8e,0x3866d84a,0x6aaac432}},	// [4d30] инат_, bibo, _moor_, koff,
   {{0x88bc81d0,0x2cad8937,0x7875936f,0x32f6866f}},	//   _zpět, _sked_, _návn, dły_,
   {{0xd5bb2457,0x38740333,0xf8bf0036,0x6eff046d}},	//   уса_, ñará_, _thé_, _bàbá,
   {{0x3866d84b,0x2a6582d5,0x62989989,0x26d919b0}},	//   _noor_, _solb_, envo, _tuso_,
   {{0x44f53404,0x7c2d3149,0xe7840012,0x629a016b}},	//   sť_, _mbar, _еуро, čtov,
   {{0x60da88ae,0x6aaad84c,0x7c2d01a1,0xf99002e3}},	//   _butm, goff, _lbar, _آبی_,
   {{0x32f6809a,0x7875816b,0x48798081,0x386690b0}},	//   ały_, _dávn, исия_, _boor_,
   {{0xd7098991,0x38668118,0x4f0995b7,0x61fa9384}},	//   ание_, _coor_, анин_, _eetl,
   {{0x3866d84d,0x442dca40,0x63bb85b2,0x628e0518}},	//   _door_, _ibe_, _uzun, yibo,
   {{0x7c2d21ed,0x6aaa89c4,0x7ae9d84e,0x7645584f}},	//   _abar, coff, _itet, ndhy,
   {{0x628e02d6,0x7ae98088,0x7c2d0362,0x2d810174}},	//   vibo, _htet, _bbar, nzhe_,
   {{0x386681b4,0x69d7112e,0x7f758012,0x6f0e85b2}},	//   _goor_, _agxe, _мулц, üncü,
   {{0x28df91bc,0x628e5850,0xc61100c8,0x442dc5e1}},	//   _पंडि, tibo, স্যা_, _mbe_,
   {{0x7875816b,0x9c13019d,0x3e7b8036,0x27ff808b}},	//   _kávo, _nọfe, _bête_, laun_,
   {{0x628e2704,0x76439083,0xd9434b60,0x442dd851}},	//   ribo, _iany, мери, _obe_,
   {{0x7643d852,0x67245853,0x4fea15d2,0x628e5854}},	//   _hany, ttij, рман_, sibo,
   {{0x7643d855,0x442003d3,0x628e02c4,0x16660ea6}},	// [4d40] _kany, _ici_, pibo, овам,
   {{0x442dd856,0x3e7b80e7,0x6456022c,0x764384b9}},	//   _abe_, _fête_, _hnyi, _jany,
   {{0x67242948,0x7643d857,0x7875803e,0xfe21864a}},	//   stij, _many, _návo, _मानस_,
   {{0x2bc70076,0x291800b4,0x61fad858,0x6143001b}},	//   रेवा, mura_, _setl, sílá,
   {{0x7d002067,0x6aaa94cf,0x29182909,0x61fa8503}},	//   _bárá, toff, lura_, _petl,
   {{0x442d8a2c,0x7643b188,0xa6e2008b,0x71250061}},	//   _ebe_, _nany, áðun, _بریل,
   {{0x69c302ba,0x6f041d15,0x291802a0,0x787c85db}},	//   _únet, lsic, nura_, _léve,
   {{0xb4d6023c,0x442d90ab,0x6444009c,0x61fac613}},	//   सदी_, _gbe_, _naii, _wetl,
   {{0x38669302,0x7643d859,0xf220023c,0x29180423}},	//   _voor_, _bany, _बाढ़_, hura_,
   {{0x291852cb,0x64562ab2,0x60da8059,0x35af0740}},	//   kura_, _anyi, _tutm, _जुड़,
   {{0x7643d85a,0x2fc7001c,0x9f5900f1,0x2918585b}},	//   _dany, ̀ng_, _pesë_, jura_,
   {{0x9c1301bc,0x629e074a,0x76439a14,0x9f590176}},	//   _mọge, _ajpo, _eany, _fesè_,
   {{0x7643d489,0x7875801b,0xfbca8e88,0xa09b8039}},	//   _fany, _závo, िधिम, _דיאט,
   {{0x787c83d3,0x7643d85c,0x2918585b,0x64562256}},	//   _déve, _gany, fura_, _enyi,
   {{0x60c2d85d,0x2905585e,0x867b8039,0x98ba0176}},	//   _khom, éla_, _דרגו, _espč_,
   {{0xda170b9f,0x290346e9,0x7c2d3ef1,0x787584e8}},	//   _ताकत_, rsja_, _ubar, _návl,
   {{0xcddb0fbb,0x2fcf00f2,0x6d4e585f,0x7643930e}},	// [4d50] ање_, ägg_, _arba, _yany,
   {{0x3e7b82be,0x29185860,0x454b1cf8,0x69c806d4}},	//   _tête_, bura_, ичем_, ýdec,
   {{0x2918438a,0x7ae9d861,0x7e670088,0x27f20338}},	//   cura_, _stet, _vojp, bbyn_,
   {{0x2b4dd862,0xe7870eef,0x6f040799,0x91fc8ec3}},	//   _prec_, _дуго, bsic, _glāz,
   {{0x09e5a103,0x6d4e18d5,0x44395551,0x6f040203}},	//   полн, _erba, ies_, csic,
   {{0x44394780,0x69c303a8,0x27e68114,0x60c2d863}},	//   hes_, _únes, _afon_, _ahom,
   {{0x6d4e007d,0xc27c0039,0x27ff9ab3,0x649601d6}},	//   _grba, שרוי, taun_, lšie,
   {{0x44395864,0x60c2b311,0x76439855,0xd12e880b}},	//   jes_, _chom, _sany, امي_,
   {{0x60c2cce2,0x76439452,0x7ae98010,0x9c1301bc}},	//   _dhom, _pany, _utet, _mọde,
   {{0x458585c2,0x2fd9015d,0x7875d865,0x787cd568}},	//   згов, _lgsg_, _távo, _réve,
   {{0xc61100c8,0x7643d866,0x04461052,0x27ffd867}},	//   স্থা_, _vany, пенн, paun_,
   {{0x44394844,0x291800b4,0x7643cd22,0x2245d868}},	//   ges_, vura_, _wany, _halk_,
   {{0x764389ca,0xf0928039,0xeb971bba,0xb7da8039}},	//   _tany, _אנא_, зия_, _הקני,
   {{0x11da00f7,0x60c982d0,0xc6110264,0xa96a02df}},	//   صورة_, lmem, স্তা_, бига_,
   {{0x6601b091,0xfaa322cb,0x6d5c8074,0x6b82847f}},	//   malk, харо, ärat, zzog,
   {{0x44390806,0x83fd8065,0x44200699,0x29180a5a}},	//   ces_, _előz, _uci_, rura_,
   {{0x27fd8355,0x27f2031d,0x6d4e5869,0x60168457}},	// [4d60] _mewn_, rbyn_, _srba, lümü,
   {{0x29180886,0x6f040352,0x6601afb8,0x44e1877f}},	//   pura_, rsic, nalk, _kó_,
   {{0x44e1d86a,0x6f044db0,0x89db04de,0x6016807e}},	//   _jó_, ssic, _לחיי, nümü,
   {{0x44e19c94,0x60c99af5,0x6d4e10d3,0xfe1e02f1}},	//   _mó_, jmem, _vrba, _पावस_,
   {{0x387f820f,0x44e18324,0x6601b30d,0x61fe586b}},	//   dhur_, _ló_, kalk, _kepl,
   {{0x4439586c,0x442081cd,0x63b60009,0x60c2c21f}},	//   zes_, żi_, _myyn, _shom,
   {{0x44e1d86d,0x4439586e,0x6601d52f,0x2245879f}},	//   _nó_, yes_, dalk, _dalk_,
   {{0x04439421,0x8c439b4b,0x787104d6,0x61fe586f}},	//   _песн, _песе, _påvi, _lepl,
   {{0x44390918,0x64960267,0x6601d870,0x26dd810c}},	//   ves_, kšib, falk, _cuwo_,
   {{0x44e1c46f,0x61468c0e,0x66018be6,0xd0918201}},	//   _bó_, _неза, galk, _müəl,
   {{0x44e1d871,0x70f69c12,0xb0db01ce,0x27fd831d}},	//   _có_, _رسائ, _मूंग, _fewn_,
   {{0x44e1d872,0x44392b90,0xf3f98087,0x6fbe5873}},	//   _dó_, ues_, _poţi_, ्धां,
   {{0x6601d874,0x61fe24c2,0x76805618,0xfbad0264}},	//   balk, _bepl, _köyd, _গণহত,
   {{0x44e184be,0x61fe5875,0xaa640c9b,0x442b0609}},	//   _fó_, _cepl, нтск, sfc_,
   {{0x61fe2823,0x44391098,0x79a4075a,0xa5d782e3}},	//   _depl, pes_, ерте, _عبور_,
   {{0x76800009,0x7d1a80b4,0xf3f98087,0x44393518}},	//   _löyd, muts, _toţi_, qes_,
   {{0xbed801cf,0x7d1ad876,0x7af0016b,0x9f34021e}},	// [4d70] здух_, luts, čitý, неті,
   {{0x61fe0574,0xdcfc02bb,0xfbd00013,0x7aed1e8f}},	//   _gepl, _ayrı, _حتى_, _itat,
   {{0x947587d2,0x7d1a8314,0x06e380ab,0x38978162}},	//   وگرا, nuts, _মিছি, sări_,
   {{0x69da879f,0x254c801b,0x61e880ee,0x6a6f805f}},	//   _agte, _měl_, _afdl, _løft,
   {{0xfebb003d,0x7d1a8cb7,0xdb1b8129,0x2245d877}},	//   _هاست_, huts, _nguô, _palk_,
   {{0x7d1ad878,0x7aed2aa0,0x66018df6,0x6016a2f8}},	//   kuts, _mtat, xalk, yümü,
   {{0x6601d879,0xa3b4000d,0x7d1ac53e,0xc61906b7}},	//   valk, _जुन_, juts, दलीय_,
   {{0x443987e2,0x44e1d872,0x69da879f,0x31580039}},	//   _ús_, _ró_, _egte, ליון_,
   {{0x44e1d87a,0x60c9d87b,0x7bc083a8,0xa7fb0144}},	//   _só_, rmem, _gzmu, _coñi,
   {{0x44e1d87c,0x387f820f,0x649602a5,0x2caf80f3}},	//   _pó_, shur_, kšic, logd_,
   {{0xdca60a94,0x61fe587d,0xd9998013,0x7aed587e}},	//   дани, _repl, _بنات_, _atat,
   {{0x69c1d87f,0x6601beb6,0x61fe5880,0x7afb819d}},	//   _izle, salk, _sepl, _kwut,
   {{0xf745bacb,0x660180f4,0x44e18324,0x61fe02d6}},	//   _цело, palk, _wó_, _pepl,
   {{0x44e18324,0x7d1a82a0,0x201f8722,0x68fb00ce}},	//   _tó_, buts, lgui_, ćudn,
   {{0x7aed5881,0x2d948098,0x6729c9d8,0x629c048d}},	//   _etat, _пръс, ltej, rnro,
   {{0x201fd882,0x63a40102,0x7bdb8c2e,0xb90606a7}},	//   ngui_, _txin, _nguu, _पढ_,
   {{0xe4c71125,0x61fe027f,0x6729d883,0x258280e7}},	// [4d80] _تصوی, _tepl, ntej, _télé_,
   {{0x80be0996,0x78a90353,0xaae18105,0xee3710ef}},	//   _वीरे, čeva, _पढ़क, мну_,
   {{0x787c83a2,0xa01b12d2,0xa06a04ae,0xf41f016d}},	//   _léva, _blöd, _дана_, miär_,
   {{0xf4878077,0x7875826f,0x6e3ad884,0xe81986af}},	//   وانی, _dávk, zetb, _धागा_,
   {{0x69c1bab1,0x76488114,0x63be8035,0xd0418300}},	//   _azle, yddy, ępno, _hulɗ,
   {{0x9c140133,0x3b06a08e,0x9f400b24,0x7bdb85ee}},	//   _kọst, rsoq_, ncií_, _eguu,
   {{0x28c30063,0xa01b0106,0x7afba970,0x26d85885}},	//   _वीडि, _flöd, _ewut, _iiro_,
   {{0xa3ae03b7,0x807b00be,0xa7fb0118,0x7d1a8314}},	//   कथा_, ַניצ, _poñi, vuts,
   {{0x3f84825b,0x26d81588,0xe29aa853,0x9f4000e1}},	//   uzmu_, _kiro_, _даа_, kcií_,
   {{0x44325162,0x7d1aaf90,0x44248028,0x26d80079}},	//   _aby_, tuts, _hcm_, _jiro_,
   {{0x7aed5886,0xb80e2303,0xc58a8009,0xeae680ab}},	//   _stat, िणाम_, ющие_, _নিয়ম,
   {{0x7d1a9c76,0x7ae0d887,0x291c805d,0xa7fb0118}},	//   ruts, _kumt, muva_, _toñi,
   {{0x4424d888,0xc0a9936d,0x291cd889,0x7ae081a9}},	//   _mcm_, _عامل_, luva_, _jumt,
   {{0x44320c56,0x78ad9f3a,0x7c24588a,0x7d1ad88b}},	//   _eby_, čave, _ecir, puts,
   {{0x7ae080f1,0x4432008e,0x4c950cec,0x8637807c}},	//   _lumt, _fby_, _пикс, _חרוב_,
   {{0x030e80cf,0x78780061,0xd5f40129,0x64a40115}},	//   _सिंह_, _hívj, _đán, rđic,
   {{0x26d852f8,0x7c3d0359,0x7ae0b353,0x7aed004f}},	// [4d90] _biro_, mesr, _numt, _utat,
   {{0x2004d88c,0xd5bb0374,0x291cb7c1,0x752f8035}},	//   hami_, осе_, kuva_, ńcze,
   {{0x60c901b9,0x25b8010c,0x26d801b4,0xe3b00fd3}},	//   ċemb, _cyrl_, _diro_, _مری_,
   {{0x2004d88d,0x4424d88e,0x26d800eb,0x6f160035}},	//   jami_, _ccm_, _eiro_, bryc,
   {{0x20049c28,0x60cd588f,0xf8b20e82,0xfdbb864a}},	//   dami_, mmam, _תשכ_, _उर्फ,
   {{0x26d80ab3,0x60cd1d5a,0x65950dff,0x4424d890}},	//   _giro_, lmam, _загу, _ecm_,
   {{0x6605178f,0x4424d891,0x63ba0035,0x08d5847f}},	//   mahk, _fcm_, ętni, нция,
   {{0x409493cd,0x660513b8,0x27e95892,0x29078b67}},	//   крыт, lahk, ncan_, rsna_,
   {{0x290780f2,0x645bd893,0x6d5a1a90,0xb9068128}},	//   ssna_, _inui, _àtar, _यू_,
   {{0x443da358,0xef828e02,0x44320e6d,0x6729d743}},	//   lew_, ульп, _sby_, rtej,
   {{0x20048933,0x6729d894,0x50678ada,0x291c8b80}},	//   bami_, stej, _отда, cuva_,
   {{0x200486b9,0x443da9b9,0x7c3d016d,0x6729d895}},	//   cami_, new_, gesr, ptej,
   {{0x68e1cae8,0x6605010b,0x394589d1,0xa3e480d4}},	//   _huld, kahk, _hsls_, पुट_,
   {{0xddc3802e,0x68e1d896,0xe5a5bbae,0x660509ca}},	//   _conţ, _kuld, _пили, jahk,
   {{0x205616d4,0x26d80032,0x6605372d,0x19b900e8}},	//   нтар, _riro_, dahk, дуть_,
   {{0x6f1646ee,0x60cd02b8,0x26d85897,0xa01b016d}},	//   tryc, gmam, _siro_, _smör,
   {{0x6f09b724,0x91e60ca0,0x26d85898,0x443dd899}},	// [4da0] nsec, _попе, _piro_, dew_,
   {{0x2004d89a,0x68e18176,0x98c0080a,0x7a338457}},	//   zami_, _ould, ırır_, nıtı,
   {{0xe820816f,0x2004d89b,0x2480074c,0x2c7ec5e6}},	//   _याला_, yami_, _klim_, _aïda_,
   {{0x27e9589c,0x644983a8,0x44220d3a,0xc4868a14}},	//   ccan_, _caei, ngk_, элек,
   {{0x26d843f0,0x66051eb1,0x26c7826c,0x2004a2fb}},	//   _tiro_, bahk, _ohno_, vami_,
   {{0x2004cdc4,0x291c9608,0x6605010b,0x68e1d89d}},	//   wami_, tuva_, cahk, _buld,
   {{0xa3d01c07,0x7875826f,0x2004d89e,0x46a30048}},	//   वेत_, _závi, tami_, _сарв,
   {{0x64498307,0x2002589f,0x291c8338,0x2b448338}},	//   _gaei, _jeki_, ruva_, _tsmc_,
   {{0x2004d8a0,0x9f4058a1,0x03a39fd0,0x7d1e03ba}},	//   rami_, ncià_, _бито, lups,
   {{0x68e1813c,0x6462d8a2,0x27e91b54,0x248058a3}},	//   _fuld, štič, zcan_, _alim_,
   {{0x27e902bf,0x68e1b64c,0x6d418114,0x04b80019}},	//   ycan_, _guld, gwla, کھوں_,
   {{0x7c22a0eb,0x66050359,0x6295009a,0x69de0362}},	//   ngor, zahk, wizo, _agpe,
   {{0x9f499c86,0x2918016a,0x66050359,0x7c3d473e}},	//   _það_, erra_, yahk, resr,
   {{0x56949285,0x7bc42337,0x443dd8a4,0x64960084}},	//   _шалт, _dziu, zew_, ršia,
   {{0xc17712c8,0x3e76007b,0x60cd58a5,0x64960b80}},	//   ردست, _gæti_, tmam, mšin,
   {{0x62952647,0x660500dd,0x200226ca,0x60cd58a6}},	//   sizo, wahk, _ceki_, umam,
   {{0x60cd3468,0x7c228da8,0xa3d00b9f,0x66050590}},	// [4db0] rmam, dgor, वेद_, tahk,
   {{0x27e90333,0x06b7026a,0x644980eb,0x2480017f}},	//   scan_, رناک_, _saei, _zlim_,
   {{0x98738012,0x66050867,0xa3d384e5,0xddc380e1}},	//   nţă_, rahk, हेन_, _konš,
   {{0x66050057,0x7c22d8a7,0x6ac98da0,0x25f101ab}},	//   sahk, ggor, िग्र, ेरही_,
   {{0x6283831d,0x290c91b9,0x68e1d8a8,0xbb458323}},	//   thno, _avda_, _suld, телк,
   {{0x660500b9,0x672d58a9,0x38694d5a,0x7c228cdb}},	//   qahk, mtaj, ljar_, agor,
   {{0x672d4269,0x443d84b7,0x6f098bfd,0xecbba385}},	//   ltaj, pew_, wsec, _فطرت_,
   {{0xfd658104,0x38691e03,0x6f09d818,0x787c80e7}},	//   _thuậ, njar_, tsec, _dévo,
   {{0x672d58aa,0x3e76007b,0xfc3f016b,0x66158061}},	//   ntaj, _sæti_, deí_, ózko,
   {{0x68e1b8dc,0x78bbd8ab,0x63bbd8ac,0x672d58ad}},	//   _tuld, sluv, _iyun, itaj,
   {{0x62819f79,0xe5a59a34,0x63bb90e4,0x3207c640}},	//   _illo, тини, _hyun, many_,
   {{0xeb9a134e,0x63bb8708,0x6d55026c,0x386958ae}},	//   дим_, _kyun, _mrza, jjar_,
   {{0xc4d28158,0x28db058c,0xdb0b077f,0x6d4e919b}},	//   יגט_, _मंजि, _ènìy, åbar,
   {{0x3ce20076,0x6d5504c3,0x63bb8681,0x09d580ab}},	//   _ओढले_, _orza, _myun, _স্যা,
   {{0x2b918028,0x99878110,0x200202d0,0x11390a14}},	//   ạch_, menų_, _peki_, няты_,
   {{0x63bb8459,0x66038364,0xbb8600f7,0x43b3082e}},	//   _oyun, _henk, _للبي, ụrụ_,
   {{0xb8e9023c,0x6281878e,0x6d470006,0x63bbd8af}},	// [4dc0] _ली_, _ollo, _asja, _nyun,
   {{0x32078690,0x6d550bcf,0x6603d8b0,0xe8e000ff}},	//   jany_, _brza, _jenk, _chợt_,
   {{0x63a9862f,0x63bb8511,0x6603990d,0x3207809a}},	//   _axen, _ayun, _menk, dany_,
   {{0x6d550025,0x74138064,0x7ae432d2,0x6603d8b1}},	//   _drza, لوما, _kuit, _lenk,
   {{0x4fa300e8,0x628180f1,0x38ba8168,0x7d1e5885}},	//   _вияв, _bllo, qëri_, sups,
   {{0x7ae458b2,0xc7b30051,0x6603d8b3,0x4ed51bcc}},	//   _muit, _כבר_, _nenk, _бюст,
   {{0x09d58a49,0x81b400c8,0x30a694b7,0x63a985e4}},	//   _স্বা, জের_, крив, _exen,
   {{0x628186a5,0xd01080f7,0xe8df819d,0x237183ed}},	//   _ello, حلة_, _gbọm_, ënjë_,
   {{0xf093078d,0x1ae6835f,0xa2e6835f,0x66039fb6}},	//   ינה_, _розм, _розд, _benk,
   {{0x78ad8025,0x6603d8b4,0xb0618009,0x78780ba3}},	//   čava, _cenk, _ääne, _dívi,
   {{0x66039ab0,0xfe6f80f7,0xf76f8077,0x7e7ad8b5}},	//   _denk, تدي_, مای_, rktp,
   {{0x7ae40ee8,0x62989ee0,0x2486d8b6,0x7d0303a7}},	//   _buit, livo, nhom_, ânsi,
   {{0x6603ad9b,0x649658b7,0x7ae458b8,0x6d5e80c3}},	//   _fenk, pšin, _cuit, _špad,
   {{0x7ae405f8,0x261c8074,0x629898f1,0x66038646}},	//   _duit, _माटी_, nivo, _genk,
   {{0x386958b9,0xfce38eef,0x6608d8ba,0x7ae40362}},	//   tjar_, _којо, madk, _euit,
   {{0x70bf05b3,0x672d0364,0x6603d8bb,0x6608d8bc}},	//   ्षेल, ttaj, _zenk, ladk,
   {{0x442958bd,0x3d050076,0x38692f9c,0xd9048065}},	// [4dd0] _ica_, हीने_, rjar_, _ڈی_,
   {{0xd9049125,0xd04b8201,0x66088079,0x644d0cda}},	//   _وی_, _digə, nadk, _haai,
   {{0x3207816b,0xf1ab003d,0xdc4301d0,0x442902df}},	//   vany_, _زاده_, _léčb, _kca_,
   {{0x32078063,0x261c835a,0x5f13800f,0x660895e8}},	//   wany_, _माझी_, _दिल्_, hadk,
   {{0x644d18c5,0x3207c640,0x09cb853f,0x442930b2}},	//   _maai, tany_, ाध्य, _mca_,
   {{0x26dcd8be,0x6e95013a,0x62988358,0x2009067f}},	//   _nivo_, _сигу, givo, laai_,
   {{0x56940e9f,0x32078e04,0x60dd1380,0x6603d8bf}},	//   _тарт, rany_, _kism, _renk,
   {{0x442958c0,0x60dd02a6,0x6603906f,0x248685b9}},	//   _nca_, _jism, _senk, chom_,
   {{0x60dd58c1,0x660387ac,0x99bf00ab,0x32078690}},	//   _mism, _penk, _আলোক, pany_,
   {{0x6281802a,0x44290014,0x7ae414cc,0x66038168}},	//   _ullo, _aca_, _ruit, _qenk,
   {{0x442958c2,0x7c298042,0x6603d8c3,0x7ae458c4}},	//   _bca_, _kcer, _venk, _suit,
   {{0x09d580c8,0x4429070d,0x6f0d042b,0x6603c206}},	//   _স্থা, _cca_, ksac, _wenk,
   {{0xe7398012,0x660386cf,0xaca38135,0x6608ca1e}},	//   _чел_, _tenk, _abịa, badk,
   {{0x81bf00ab,0x7ae42bd5,0x1e848221,0xbf9a83c8}},	//   েশন_, _vuit, _клім, _אינש,
   {{0x63be809a,0xb606026f,0x32058019,0x64860118}},	//   ępni, ntáž, _mely_, _póid,
   {{0x27edd8c5,0x7ae444a0,0x26dc8042,0x60dd3dd5}},	//   ncen_, _tuit, _zivo_, _cism,
   {{0x6d5ec033,0x9b460199,0xa3d058c6,0x60dd1abd}},	// [4de0] _àpar, _صندو, वेश_, _dism,
   {{0x7c29ab72,0x628719c9,0x60dd0084,0xe1fa0a8e}},	//   _acer, chjo, _eism, _яго_,
   {{0x2486d8c7,0x672082ce,0x6f0d0c41,0x29560098}},	//   thom_, zumj, asac, _съпр,
   {{0x7c2658c8,0x7641d8c9,0xac2580e8,0x236681c0}},	//   ngkr, hely, ифік, txoj_,
   {{0x62989313,0xe29aa466,0x68e558ca,0x2486d8cb}},	//   tivo, над_, _zuhd, rhom_,
   {{0x851c0076,0x55e3179e,0x7c2981bf,0x6f1bd8cc}},	//   _पटपट_, _горб, _ecer, druc,
   {{0x7641d8cd,0x649601a1,0x78ad82d4,0x6608d8ce}},	//   dely, tšil, čavn, vadk,
   {{0x764e2fc0,0x6298d8cf,0x3f149ad8,0x7521bb7a}},	//   _haby, sivo, адис, dulz,
   {{0x764e58d0,0x44268bb1,0x27e20b50,0xb606cc6b}},	//   _kaby, mgo_, _mgkn_, лянк,
   {{0x4426d8d1,0x7641d8d2,0x225e89ca,0x644281a8}},	//   lgo_, gely, _untk_, leoi,
   {{0x64964e1b,0x05ce816f,0x66088079,0x644d58d3}},	//   mšij, हेंब, radk, _paai,
   {{0x4426d612,0x69c8d8d4,0x6f1bbb52,0x27ed84b9}},	//   ngo_, _izde, bruc, ccen_,
   {{0x249958d5,0x6608d8d6,0x4426d8d7,0x6f1bb724}},	//   rism_, padk, igo_, cruc,
   {{0x764e023b,0x60dd191f,0x24992666,0x68e50198}},	//   _naby, _sism, sism_, _puhd,
   {{0xd918176e,0x648600f7,0x442928c9,0x02e1800d}},	//   льт_, _dóib, _tca_, _पढ्न,
   {{0x60dd011c,0x6f029415,0xa3e906b7,0x6d4a9f79}},	//   _qism, _kwoc, _बलि_, _isfa,
   {{0x6d588a20,0x764e2fbe,0x64428013,0x60dd00eb}},	// [4df0] _hrva, _baby, deoi, _vism,
   {{0x4426d8d8,0x81b400ab,0x6f0d58d9,0x7c29ad08}},	//   ego_, জেই_, rsac, _scer,
   {{0x60dd4cc9,0x3e76008b,0x628558da,0x290c1be6}},	//   _tism, _rætt_, _ilho, ádat_,
   {{0x4426c50b,0x6442c1d1,0x6f0d0362,0x6f028035}},	//   ggo_, geoi, psac, _owoc,
   {{0xd5af0117,0xae1e03eb,0x442981a9,0x768002d0}},	//   _کہا_, _पाचन_, ļa_, _köyl,
   {{0x4426d8db,0x4429d8dc,0x7875803e,0x657a81e0}},	//   ago_, ża_, _návr, kyth,
   {{0x7641d8dd,0xfa7801c6,0x201982df,0x272f22f8}},	//   vely, רעות_, ósio_, lün_,
   {{0x6f1b9883,0x69d5803e,0x69c8009a,0x76418114}},	//   truc, _územ, żdeg, wely,
   {{0x6d58870a,0x272f0182,0x8fa59052,0x628558de}},	//   _arva, nün_, рапе, _olho,
   {{0x6f1bc99f,0x9c1301bc,0xbb8480f7,0x78a458df}},	//   rruc, _dọme, _الكي, zniv,
   {{0x6d588267,0x2ca90609,0x81eb0264,0x38ba83ed}},	//   _crva, _bjad_, মরা_, tërt_,
   {{0x752f809a,0x62855328,0x673d325c,0x6f1b81ec}},	//   ńczo, _alho, _opsj, pruc,
   {{0x6d589aee,0xa3d001b6,0x386d920e,0x768007d9}},	//   _erva, वें_, mjer_, _böyl,
   {{0x386d8e23,0x4426a215,0x471a80be,0x660701d0}},	//   ljer_, zgo_, _יונג, _nejk,
   {{0xaca4019d,0x628501ac,0x3d0503b7,0xd94618a2}},	//   _agụi, _dlho, _हौले_, шеви,
   {{0xe0df0098,0x386db3cc,0x661502f7,0x7d568039}},	//   _ciò_, njer_, _adzk, _כיצד_,
   {{0x753c0d38,0x272f05c5,0x387f81fa,0xe3b80085}},	// [4e00] _sprz, gün_, ikur_, şıb_,
   {{0x98481010,0x290c01a8,0x764e01b4,0xed5a0fbf}},	//   rşı_, ádas_, _qaby, коз_,
   {{0x387f807b,0x644280f7,0x386dd8e0,0x920281a9}},	//   kkur_, teoi, kjer_, šāka,
   {{0xf5368158,0x629c58e1,0x386d81b9,0xe058004e}},	//   יטער_, liro, jjer_, _حیرت_,
   {{0x644280f7,0x386d8582,0x9c13019d,0x764e58e2}},	//   reoi, djer_, _bọje, _taby,
   {{0x4426d8e3,0x291c8d11,0x644281a8,0x8b5700be}},	//   sgo_, trva_, seoi, יינס_,
   {{0xe5a328df,0xddc708ae,0x7bc98326,0x64a401a1}},	//   _дири, _tojš, _ezeu, rđij,
   {{0x629c44ad,0x69c8886f,0x9f4f81ca,0x64a6816c}},	//   hiro, _vzde, _negó_, _таба,
   {{0xe666d22f,0x629c12e5,0x657a8114,0x087703de}},	//   атно, kiro, wyth, שעפט_,
   {{0x6d58a368,0x629c0326,0x291c811f,0x8f370538}},	//   _prva, jiro, prva_, סטיג_,
   {{0xd7ef8abe,0x629c1193,0x69c8a52a,0x6996854c}},	//   _му_, diro, _uzde, _трах,
   {{0x768002bb,0x629c1d3a,0xb17b8158,0xc19b8039}},	//   _söyl, eiro, _שטאר, _בשבי,
   {{0x6d5a011f,0x68e8bb15,0x6285022c,0x395a09c4}},	//   _štal, _hudd, _plho, _arps_,
   {{0x6d588efc,0x68e8d8e4,0x629c57e2,0x8af00085}},	//   _trva, _kudd, giro, _irəl,
   {{0x6d58d8e5,0xf8072482,0xfc3f0333,0xdd938084}},	//   _urva, ичан, anía_, _машы,
   {{0x272f0a0b,0x68e8d8e6,0x63ad0102,0x673d09c4}},	//   tün_, _mudd, _txan, _ppsj,
   {{0x7c2d58e7,0x68e8a9e4,0x660701f4,0x35e70bc7}},	// [4e10] _icar, _ludd, _pejk, ацев,
   {{0xbebd9c1f,0x629c1727,0xc61f00ab,0x387f8196}},	//   ltūr, ciro, ন্না_, zkur_,
   {{0x2ca6831d,0x9c1301bc,0xab6282d0,0x6d5a0061}},	//   fnod_, _nọke, _şüph, _átal,
   {{0xdd868986,0xbebd8df1,0xa5d980be,0x940b0085}},	//   _ہو_, ntūr, אַני, ticə_,
   {{0x7bc0831d,0xb4c78105,0x64860187,0xbd05826b}},	//   _cymu, _उठी_, _jóia, _atẹ́,
   {{0xa2298b79,0x1df80e11,0x7bc08114,0x8e8501a8}},	//   ужка_, _веры_, _dymu, _السه,
   {{0xbebd8df1,0x68e8a78e,0x3cf001d6,0x3a2c9dc5}},	//   ktūr, _cudd, ľové_, _dcdp_,
   {{0x629c003a,0x68e8a1c7,0x3cf0016b,0xbca5866e}},	//   ziro, _dudd, žové_, _امري,
   {{0x387fd8e8,0x7bc08114,0x7c3baa3b,0x6a7d86c0}},	//   rkur_, _gymu, _ibur, _lèfi,
   {{0xe1f0bf7d,0xba748307,0x7c2d01f1,0x629c58e9}},	//   _قسم_, _والت, _acar, xiro,
   {{0x629c2ae9,0x68e882a3,0xa3d3816f,0x443b43e8}},	//   viro, _gudd, हेर_, _bbq_,
   {{0x7ae1d8ea,0xb4e7800d,0x64a602fb,0x629c58eb}},	//   _hilt, _बढी_, сама, wiro,
   {{0x7ae1d8ec,0x629c58ed,0x7c3bd8ee,0x27ffb3d2}},	//   _kilt, tiro, _mbur, mbun_,
   {{0x6d5a28e1,0x412a11d2,0x787c83e6,0x26d981d0}},	//   _štam, лого_, _révi, ůsob_,
   {{0x7c3bd8ef,0x7ae98009,0xada29c82,0x68e88df6}},	//   _obur, _luet, _нашл, _xudd,
   {{0x442d8069,0x629c0110,0x27ffd8f0,0x6a7d823e}},	//   _nce_, siro, nbun_, _dèfi,
   {{0xee3a0abe,0xa01b00f2,0x7ae98144,0x644658f1}},	// [4e20] лна_, _glöm, _nuet, meki,
   {{0x644658f2,0x5986028b,0x5d6a08b0,0xcf2500f7}},	//   leki, _глоб, лизм_, ترفي,
   {{0x7bc0831d,0xa3dad8f3,0x09d60264,0xd9f88327}},	//   _symu, डेन_, _ত্রা, ुरसत_,
   {{0xa50726ad,0x6446482e,0x1d0720bf,0x186a4415}},	//   сеца_, neki, сеци_, _сами_,
   {{0x7ae1d8f4,0x7d1e02a5,0x205704de,0x7ae98144}},	//   _bilt, srps, _היכל_, _cuet,
   {{0x60c458f5,0x46160117,0x7c3b8133,0xdd20001b}},	//   llim, _دوسر, _ebur, může,
   {{0x5d860013,0x68e884b7,0x7ae183ed,0x7ae98580}},	//   _الأل, _qudd, _dilt, _euet,
   {{0x6d5c41bb,0x60c458f6,0x6d4e58f7,0x69c18114}},	//   _irra, nlim, _isba, _dyle,
   {{0xd6da8703,0x69c18214,0x661cd8f8,0xa01b0106}},	//   лто_, _eyle, órko, _blöj,
   {{0x7c2d1429,0x273090ab,0x7ae1d8f9,0x60c40a48}},	//   _scar, ràn_, _gilt, hlim,
   {{0xe72f8bca,0xb6bb0158,0x245f0009,0x6d5a1b39}},	//   وصی_, רציי, _nämä_, _štaj,
   {{0x320e8101,0x69c10214,0x60c4026c,0x996481d0}},	//   lafy_, ülem, jlim, _kůže_,
   {{0x7c2d0370,0x27e6b5ac,0x7ae98473,0xdc9b81c6}},	//   _vcar, _igon_, _xuet, ריכל,
   {{0x9964800d,0xa3da8b9f,0x442d0035,0x6d5c58fa}},	//   _může_, डेय_, że_, _orra,
   {{0x7e7509a4,0x6446013d,0x9f490174,0x29df822b}},	//   _rozp, beki, rcaí_, _għaċ_,
   {{0xc4c4850c,0x60c415d3,0x64a40dc7,0xb4c78105}},	//   _سے_, glim, _наја, _उठे_,
   {{0x29110065,0x6d5c2816,0xe7301921,0x6e99196e}},	// [4e30] ssza_, _arra, فصل_, авар_,
   {{0x443910f4,0xf7700829,0x7bcd01a9,0x29110035}},	//   lfs_, راق_, _izau, psza_,
   {{0x44391393,0x7e750144,0x7ae9d8fb,0x24890123}},	//   ofs_, _vozp, _suet, _klam_,
   {{0x7ae190c0,0x27e6801c,0x7afd1699,0xccf380be}},	//   _silt, _ngon_, opst, לכע_,
   {{0x6d5c58fc,0x7ae18074,0xa3d38740,0x6d4e4bd8}},	//   _erra, _pilt, हें_, _esba,
   {{0x644658fd,0x27e6828c,0xd9fb170c,0x09d28264}},	//   zeki, _agon_, ्रित_, াশনা,
   {{0x68e2d8fe,0x442dd8ff,0xdcf581a9,0xaefb0362}},	//   _biod, _tce_, ēcīg, _brùg,
   {{0xef19895a,0x7c3b8578,0x2eb3816f,0x69c1826f}},	//   ами_, _ubur, ुत्त, _vyle,
   {{0x7ae18e51,0x68e2d900,0x7c2480f7,0x200b0087}},	//   _tilt, _diod, óire, _meci_,
   {{0x24895166,0xee3697d4,0x27e6811e,0x273b0087}},	//   _alam_, онь_, _egon_, mână_,
   {{0x2b400118,0x68e28229,0x24895901,0x660a80c3}},	//   _spic_, _fiod, _blam_, _defk,
   {{0x2d8b8063,0x7c2b923c,0xf9928039,0x6d5a00ce}},	//   ące_, nggr, _קרא_, _štak,
   {{0xe60e8fbb,0x64463cac,0x2d839491,0x24895902}},	//   _од_, reki, šje_, _dlam_,
   {{0xf8bf541c,0x64463d61,0x78bb801b,0xc61f00ab}},	//   _aké_, seki, louv, ন্তা_,
   {{0x38c804c0,0x7bcd0102,0x24890580,0x7f5d0706}},	//   ماری_, _ezau, _flam_, _arsq,
   {{0x200b5903,0x78bb902d,0x53a600e8,0x2247c853}},	//   _ceci_, nouv, _майб, henk_,
   {{0x60c40ad4,0x200b5904,0xe1ff801c,0x26c5a1ab}},	// [4e40] rlim, _deci_, _đón_, ollo_,
   {{0x245f0364,0x26c583a8,0xd62601a8,0x66cf804a}},	//   _tämä_, nllo_, تعري, bøke,
   {{0x37e60adb,0x60c45905,0x26c5d906,0x78bb86c0}},	//   _монг, plim, illo_, kouv,
   {{0x629a82f7,0xb922819d,0x67df0196,0x6abc27d3}},	//   _smto, akpọ_, _sąjū, lorf,
   {{0x2cad9351,0x69c583e3,0xaefb0362,0x926a951b}},	//   _djed_, ühen, _crùd, ирка_,
   {{0x27345907,0x200b0087,0xdce981d0,0xaefb0706}},	//   män_, _zeci_, íněn, _drùd,
   {{0x6d5c27a2,0x27340198,0x660a826c,0x6d4e5908}},	//   _urra, län_, _refk, _usba,
   {{0xa7749878,0xb97b00be,0xdd8f045b,0x26c5991f}},	//   злич, ינצי, _شوق_, ello_,
   {{0x920a05e8,0xeeaa80e8,0x660a8bda,0x7bc40573}},	//   वराज_, иток_, _pefk, _nyiu,
   {{0x6283d909,0xd6d08875,0xe29781ae,0x69c12131}},	//   ckno, عقد_, _дау_, ülek,
   {{0x2734025d,0x2489590a,0xceb30158,0x994a8013}},	//   hän_, _plam_, ויז_, _خلال_,
   {{0x66e685da,0x78bb83d3,0xe3b80182,0xe78690ac}},	//   _дода, couv, ğın_, _муло,
   {{0x200b0025,0xe3b8017b,0x27340009,0x443910c9}},	//   _reci_, şın_, jän_, rfs_,
   {{0x27340364,0x9f590081,0xaaca801b,0x7afd3bd9}},	//   dän_, _gesù_, ितिक, rpst,
   {{0x7648d90b,0x31c415e0,0x7cf304b7,0xfc3f01d0}},	//   medy, дств, _oħra, lním_,
   {{0x7648d90c,0x24890cef,0x7afd20e4,0xda78816b}},	//   ledy, _ulam_, ppst, _loď_,
   {{0x200b01ac,0x66cf804a,0x41e70a4c,0xaaca81d0}},	// [4e50] _veci_, søke, _міна, िताक,
   {{0x764882e7,0x2cbf85b1,0x78ad8904,0xadc3826b}},	//   nedy, _skud_, čavi, _afẹh,
   {{0x2ee300f3,0x92b400f7,0x7aed5101,0xea0000ff}},	//   _vijf_, _تحيا, _huat, _hiếu_,
   {{0xa3c41993,0xe3b382e3,0x7aed590d,0x6ac39a46}},	//   _्रम_, ورش_, _kuat, षत्र,
   {{0x395e90b6,0x76489ac4,0xdb078380,0xeab01e29}},	//   _arts_, kedy, _ömür, _سعی_,
   {{0x09df0a49,0xe1f18bca,0x7aed1295,0xfc3f001b}},	//   _ব্যা, رست_, _muat, dním_,
   {{0x7aed04bc,0x91e2838b,0x320c82f7,0x628389ff}},	//   _luat, ноше, _dedy_, rkno,
   {{0x7ae50006,0x7aed590e,0x6283a3a7,0x2cad8b80}},	//   _liht, _ouat, skno, _ujed_,
   {{0x443fd90f,0x3211003e,0x78a9bb39,0x600687ac}},	//   _ibu_, kazy_, rnev, чным_,
   {{0x7655003e,0x7afb876d,0x78a9a571,0x6eed81d6}},	//   _jazy, _itut, snev, _hĺbk,
   {{0x69c50082,0xc8ab8098,0x648601a8,0x26c5802a}},	//   _nyhe, _къде_, _fóil, rllo_,
   {{0x7aed459a,0x3f4d35ca,0xc86495a6,0xfc3f01d0}},	//   _buat, _ožu_, _отчи, bním_,
   {{0x7aed0c15,0x443f8f59,0x6abc5910,0x69c7806a}},	//   _cuat, _mbu_, torf, _øjeb,
   {{0x27345907,0xddc881a9,0x76550035,0x7afb8c93}},	//   vän_, ņoša, _nazy, _mtut,
   {{0x443fd911,0x186a1445,0xd13200f7,0xa06a0e17}},	//   _obu_, бави_, عمر_, бава_,
   {{0x386602ba,0x4fea174a,0x67360009,0x7aed4c36}},	//   ñor_, сман_, ttyj, _fuat,
   {{0xe61a2240,0x6abc03a7,0x44320314,0x1e860196}},	// [4e60] йда_, porf, _icy_, плам,
   {{0x443fd912,0x8cc40035,0x7ae501f4,0x2734256d}},	//   _abu_, रतको, _giht, rän_,
   {{0x7afb9192,0x64562a8d,0x27340198,0x3f8603f2}},	//   _atut, _kayi, sän_, šou_,
   {{0x443f89da,0x66e614f6,0xdee61229,0x2b5fd913}},	//   _cbu_, _нома, _номи, _bruc_,
   {{0x64562a8d,0x648600f7,0x201234c2,0x6f630110}},	//   _mayi, _nóim, mayi_, _звяз,
   {{0x443fd914,0x64560201,0x6d43d387,0xfc3f001b}},	//   _ebu_, _layi, _opna, vním_,
   {{0x15430049,0x7afbd915,0x9d430dc0,0xd90d815b}},	//   _перм, _etut, _перд, لیل_,
   {{0x20123468,0x443fa36a,0xfc3f01d0,0x64561ea2}},	//   nayi_, _gbu_, tním_, _nayi,
   {{0x320c801b,0x7e788353,0x67245916,0x629e09b6}},	//   _tedy_, _povp, nrij, _ompo,
   {{0x2486d917,0x660e0029,0x46be001b,0x9f970039}},	//   lkom_, _jebk, ्तिह, פדיה_,
   {{0x67240613,0x7aed0867,0x645638ba,0x6b829fce}},	//   hrij, _suat, _bayi, lyog,
   {{0x68e6003e,0x3866802e,0x629e1e9e,0x7ae51e71}},	//   _nikd, _unor_, _ampo, _siht,
   {{0x7aed1e9e,0x787c82be,0x7648d813,0x6b829efb}},	//   _quat, _févr, pedy, nyog,
   {{0x67240613,0xdfa58013,0xdee381a1,0x34a98105}},	//   drij, _تحمي, _зочи, _कद्द,
   {{0xe63b8039,0xfc3f00e1,0x291e230a,0x321109a4}},	//   _התוכ, nník_, štan_, razy_,
   {{0x629e5918,0x7aed0014,0x24868024,0x3ebe8019}},	//   _empo, _tuat, jkom_, lott_,
   {{0x67245919,0xa2b514b7,0x98a7812b,0xe8d78039}},	// [4e70] grij, _обич, šiću_, לולר_,
   {{0xcb12004c,0x6456591a,0x20c181a8,0x443fd91b}},	//   _שלי_, _zayi, nóir_, _sbu_,
   {{0x7afbd91c,0x6456591d,0x2d870298,0xaefb0706}},	//   _stut, _yayi, áne_, _brùc,
   {{0x672436c8,0xfc3f026f,0x20c180f7,0x317e01ec}},	//   brij, dník_, hóir_, ätze_,
   {{0x2d873e2a,0x61ec0019,0x2fc681c5,0x3ebe909a}},	//   šne_, _állá, _nyog_, kott_,
   {{0x60c2d91e,0x2b5f817f,0xa9698e8e,0x78ad4168}},	//   _akom, _vruc_, жика_, lnav,
   {{0xa2a0035a,0x3ebed91f,0x78ad55f4,0x6d5a0da8}},	//   _ऑगस्, dott_, onav, _štav,
   {{0x443f8578,0x78ad5920,0x24868ee0,0x2b5fd921}},	//   _ubu_, nnav, ckom_, _truc_,
   {{0x64565922,0x66d01cab,0x66cb061c,0x64960b80}},	//   _rayi, läka, yükl, kšir,
   {{0x644b8c39,0x60c2d56d,0x6459d923,0x20c180f7}},	//   legi, _ekom, ldwi, góir_,
   {{0xe3b803bf,0x672402ce,0x248da39e,0xa90787c3}},	//   ğım_, zrij, _klem_, _ربان,
   {{0x6459b0e5,0x644bd924,0xe3b803bf,0x03a612c0}},	//   ndwi, negi, şım_, димо,
   {{0xee2e8dca,0xeb97233f,0x6729d925,0xb7f406ae}},	//   _ин_, дия_, quej, _अलबम_,
   {{0x60c9a538,0xa50999b6,0x672415f5,0x23600a0f}},	//   llem, _дека_, vrij, _vrij_,
   {{0x2d1c0540,0x64565926,0xb9b50098,0xd5d184e5}},	//   _पटेल_, _tayi, естъ, _हरिज,
   {{0x76800364,0x20551baa,0x291e0289,0x60c9d927}},	//   _löyt, нтур, štao_, nlem,
   {{0x8fa30cb1,0xe7371285,0x24868988,0x200fd928}},	// [4e80] вате, мет_, vkom_, _megi_,
   {{0x672452e4,0x200fd929,0x248d8b62,0x2012185b}},	//   rrij, _legi_, _alem_, sayi_,
   {{0x60c9d92a,0x6aa3d92b,0x78ad14cf,0x6724592c}},	//   klem, dinf, bnav, srij,
   {{0x3ebe8065,0xfc3f003e,0x44f38028,0x644bd92d}},	//   zott_, vník_, _mã_, gegi,
   {{0x60c98bfa,0x2486d92e,0x44f3d92f,0x4bda8fd3}},	//   dlem, rkom_, _lã_, آباد_,
   {{0x60c2d930,0xfc3f016b,0x44328035,0xa50a046e}},	//   _skom, tník_, ży_, _мега_,
   {{0x644b8ad4,0xa9678992,0x200f811b,0x44f3d931}},	//   begi, дија_, _begi_, _nã_,
   {{0x60c9a1bf,0x6496075f,0x2120881d,0x9f54b760}},	//   glem, zšir, čih_, евич,
   {{0x3ebe8065,0xb05b016d,0x200fd55b,0xdca3937b}},	//   tott_, _okän, _degi_, _рати,
   {{0xda669168,0x60c9d932,0x44f38129,0x78a42446}},	//   _تاري, alem, _bã_, hiiv,
   {{0x3ebed933,0x9986845b,0x6fd50006,0x20c181a8}},	//   rott_, _تلاو, _दरभं, róir_,
   {{0x25fe87e6,0x9f401f18,0x101680d5,0x60c2b094}},	//   _श्री_, nció_, _آباد, _ukom,
   {{0x78ad0353,0x69c8d934,0x3ebe8019,0x2fc68122}},	//   vnav, _hyde, pott_, _uyog_,
   {{0x44f383a7,0x60c0d935,0x09d580ab,0x81d800ab}},	//   _fã_, lomm, _স্টা, িশন_,
   {{0x7ae88bc5,0x442f9235,0x76800198,0x19580a14}},	//   _midt, ygg_, _löys, мары_,
   {{0x58d42386,0x60c0d4be,0x315783de,0x6287226d}},	//   вост, nomm, וילן_, skjo,
   {{0x69c8d936,0x644b92fa,0x6d5e80c3,0xb3d302f1}},	// [4e90] _lyde, vegi, _špah, _सरिख,
   {{0x23480077,0x644b837a,0x3ce90282,0x248dd937}},	//   _کلیپ_, wegi, _hiav_, _slem_,
   {{0x644bd938,0x60c08a51,0x44f38028,0x7e7c13c7}},	//   tegi, komm, _xã_, _dorp,
   {{0x6ab9800c,0x7e7c0cb5,0x9475803d,0x7762802a}},	//   ेत्र, _eorp, رگزا, _orox,
   {{0x200fc485,0x6aa3d939,0x7e7c0aa2,0x6459a0ea}},	//   _regi_, tinf, _forp, rdwi,
   {{0x200f9cdf,0x9f40009f,0x644bc717,0x7658d93a}},	//   _segi_, ació_, segi, _navy,
   {{0x60c989bd,0x200f83ac,0x349590ca,0x6aa3c255}},	//   tlem, _pegi_, _завр, rinf,
   {{0x45d40364,0x9f400813,0x249f88de,0x3ce901c0}},	//   _росс, cció_, _umum_, _niav_,
   {{0x60c984e6,0x44f3d93b,0xf41f0198,0x7658d93c}},	//   rlem, _sã_, tkän_, _bavy,
   {{0xee399878,0xfe718013,0xb6cc817b,0xe3b80214}},	//   чно_, ادة_, şünü, şık_,
   {{0x200f90b5,0x765882d6,0x9f4001e8,0x78a400b9}},	//   _tegi_, _davy, nciò_, yiiv,
   {{0x3ce90282,0x60c0a4cc,0x7762802a,0x26c1501d}},	//   _ciav_, comm, _frox, hoho_,
   {{0xf74590bf,0x3ce9022c,0x26c1026f,0xdd8e826a}},	//   _чело, _diav_, koho_, لوی_,
   {{0x2739d93d,0x291e012b,0x09e380ab,0x3f7a83de}},	//   mèn_, štam_, _ন্যা, _מאנס,
   {{0x78a401c2,0x614312e9,0x04460a41,0xd943013a}},	//   tiiv, лера, _зейн, лери,
   {{0xd9c0103e,0x645a01a9,0x2ca02795,0xafe62f75}},	//   _एडीट, ētis, _umid_, еобл,
   {{0x4420593e,0x3cff0024,0x673bd93f,0x7643808e}},	// [4ea0] _idi_, _čuva_, ntuj, _kbny,
   {{0x78bb003b,0x78a414c7,0xb7d71c81,0x3ea586ae}},	//   čuva, siiv, رولا_, nilt_,
   {{0x1a9b093f,0xa01b2298,0x69c10065,0x9f590144}},	//   _זייע, _plöt, ület, _besó_,
   {{0x673b8e04,0x69c8d940,0x3ce90282,0x6d5e02f1}},	//   ktuj, _ryde, _xiav_, rvpa,
   {{0x7e7c0085,0x3ea59375,0x26c1046d,0xa3da897d}},	//   _torp, kilt_, boho_, डें_,
   {{0xada60652,0x7d1cb680,0x2739d941,0x2d85d942}},	//   _загл, ársk, dèn_, kyle_,
   {{0x6f042509,0x442011d3,0x9f405943,0x60c0d944}},	//   lpic, _odi_, pció_, tomm,
   {{0x7762887a,0x7ae8d945,0x44205946,0x76588084}},	//   _prox, _widt, _ndi_, _savy,
   {{0x76588110,0x656380f3,0x7643808e,0x60c08eb9}},	//   _pavy, _arnh, _bbny, romm,
   {{0x69c8d947,0x60c0d948,0x3ce90282,0x6996860a}},	//   _tyde, somm, _siav_, _прех,
   {{0x291e003b,0x3b0000b9,0x3ce901c5,0xc6930039}},	//   štaj_, _atiq_, _piav_, ראת_,
   {{0x2ebe03eb,0xe1ff80ff,0x64440706,0x66cb58ce}},	//   ्तुत, _đói_, _cbii, tükk,
   {{0x366a8364,0x3ea58bbd,0x7643808e,0x8b671459}},	//   _надо_, bilt_, _fbny, راحم,
   {{0x2d85d106,0x44205949,0xa6aa8872,0x628aa085}},	//   byle_, _edi_, _عاشق_, nkfo,
   {{0xe5f78051,0x3cea8740,0xdd8f89f7,0x3ce901c5}},	//   _אזור_, _घंटे_, _сш_, _tiav_,
   {{0x672d0dd7,0x7d1a8b81,0xceb4011c,0x69d58b99}},	//   tuaj, msts, zrət_, येटी,
   {{0x66d0016d,0x6d47007b,0x16be0035,0xaefb026b}},	// [4eb0] räkn, _spja, ्तूब, _erùn,
   {{0x644f3a69,0xc13b801c,0x4420368d,0x26d80706}},	//   leci, _cướp_, _zdi_, _chro_,
   {{0x09df00c8,0x7d1c0289,0x44200114,0x7d1ad778}},	//   _ব্রা, _cvrs, _ydi_, nsts,
   {{0x673b9bfe,0x645d594a,0x2bde2e06,0xe4e4a1d2}},	//   ytuj, ndsi, नेवा, гічн,
   {{0x645d01e4,0x69d800e1,0x20093ada,0x60cd594b}},	//   idsi, _úver, mbai_, mlam,
   {{0xaa459c79,0x78a2d94c,0x7d1a897a,0x7dee0061}},	//   текл, _amov, ksts, rősí,
   {{0x644f12ae,0xd49b8c6e,0xfd660135,0x45d40db3}},	//   keci, _ера_, _mkpọ, _борс,
   {{0x42d180c8,0x673b8009,0x44f70457,0x60cd594d}},	//   াদেশ, ttuj, _iç_, nlam,
   {{0x644f49fd,0x7528809a,0x3f8b81ac,0x3ea588c7}},	//   deci, erdz, ácu_, tilt_,
   {{0x2d850006,0x60cd179f,0x628ac432,0x2739d94e}},	//   _üles_, hlam, ckfo, rèn_,
   {{0x673ba9fd,0x4420594f,0xc5f202f6,0x3f8b8301}},	//   stuj, _pdi_, ידי_, šcu_,
   {{0x64a60b73,0xdca6138f,0x291e00d2,0xfd660870}},	//   тама, тами, štak_, _akpọ,
   {{0x60cd5950,0x290144b9,0x3ea5d951,0x8c1a825f}},	//   dlam, _atha_, pilt_, וורי,
   {{0xc33283de,0x68eb8bb1,0xcb128039,0x66d00198}},	//   בוך_, _higd, שלם_, väko,
   {{0xa56480f7,0x78bb0115,0x6f1b8799,0x7641a25b}},	//   _مدين, čuvn, lsuc, mfly,
   {{0x68fc8065,0x44204dd5,0x645b8326,0x68eb8197}},	//   _érde, _udi_, _naui, _jigd,
   {{0xd9ad85b3,0x68ebd952,0x7d1c0024,0x6f1b81ec}},	// [4ec0] टपुट, _migd, _svrs, nsuc,
   {{0x60cd5101,0xaefb001c,0x7641870b,0xe6be0d5d}},	//   alam, _trùn, nfly, ्तेज,
   {{0x6729d953,0x60cd5954,0x6f1b81ec,0xe0da04ae}},	//   hrej, blam, hsuc, _ово_,
   {{0x6aca8c78,0x68eb87c6,0x6f041d58,0x3218309c}},	//   ित्र, _nigd, ppic, lary_,
   {{0xe29a996e,0x24800035,0x2ca6869d,0xda7a8162}},	//   мад_, _moim_, riod_, дяй_,
   {{0x644f0063,0x60c4061a,0x32185955,0x66032306}},	//   zeci, loim, nary_, _впра,
   {{0xbea35956,0x7d1c011a,0x7641806a,0xdbdc826b}},	//   _тарк, _uvrs, dfly, _dáák,
   {{0x7d5700be,0x765c2668,0x518395ff,0xc98399a4}},	//   _בילד_, _hary, руша, руши,
   {{0x765c5957,0x67299024,0x68eb89c4,0x644f5958}},	//   _kary, grej, _digd, veci,
   {{0x3aeb803d,0x7528826c,0x60c401a8,0xd337825f}},	//   _قبلی_, trdz, hoim, _ברמה_,
   {{0xb05b016d,0x644f5959,0x60c40198,0x245504a3}},	//   _skäm, teci, koim, هندس,
   {{0x4fc68ab2,0x52bd0526,0x78a280d2,0x321335db}},	//   _исла, ोत्स, _umov, _sexy_,
   {{0x24840106,0x645d595a,0x7d1ad95b,0x98a3066f}},	//   ömma_, rdsi, ssts, nują_,
   {{0x765c595c,0xc7d781c6,0x7afdd95d,0x31353383}},	//   _nary, _סוגי_, _éste, легр,
   {{0x60cd30d8,0x611416cf,0x63be8035,0xb6d980be}},	//   tlam, идру, ępny, _אַקט,
   {{0x2aad352c,0xf0b4102a,0x98a30035,0x6d4a8db1}},	//   džbe_, айсь, kują_, _ipfa,
   {{0x6d5a005c,0x765c260b,0x20090110,0xd7f83c3d}},	// [4ed0] _štap, _bary, rbai_, тус_,
   {{0x60cd022e,0xd2510077,0xba5519e3,0x79a710ff}},	//   slam, _اند_, _свој, _арме,
   {{0x765c19b2,0x60cd22f8,0x67299b2c,0xf1df0576}},	//   _dary, plam, zrej, फेशन,
   {{0x7bcd00a4,0x60c40122,0x1b198198,0x6f02d95e}},	//   _kyau, coim, ежды_, _otoc,
   {{0x4c9c007c,0x291e82d4,0x0c24a1d2,0xa09a00be}},	//   ובאו, _avta_, рмін, _נישט,
   {{0x6d58825b,0xbbd38740,0x67299c67,0x6d4a806a}},	//   _osva, _तरीक, vrej, _opfa,
   {{0x81cb80c8,0xc69203de,0xa3aa103e,0x6f02d95f}},	//   রেন_, _פאל_, _गेन_, _atoc,
   {{0x66155960,0x6729c949,0xc1740039,0x88c5801b}},	//   _hezk, trej, שחק_, _ověř,
   {{0x6615011b,0x7641bfee,0x765c5961,0x6d4a818e}},	//   _kezk, tfly, _yary, _apfa,
   {{0x6f1b8352,0x6729ae12,0x82d88012,0x64ab128a}},	//   rsuc, rrej, _адус_, yřic,
   {{0x3218016b,0x764184e1,0xceb403c8,0x34aa1a19}},	//   vary_, rfly, ייץ_, евно_,
   {{0x6281b136,0x6729d962,0x6f1b8387,0xab2a18d1}},	//   _holo, prej, psuc, нома_,
   {{0x32185963,0x6281d964,0x3cedcb9b,0x4fa480e8}},	//   tary_, _kolo, _miev_, _київ,
   {{0x62818a87,0x78a9d965,0xb607ad59,0x6615128a}},	//   _jolo, liev, _рядк, _nezk,
   {{0x26c5d966,0x60c42551,0x6281d967,0x291e5968}},	//   molo_, toim, _molo, éta_,
   {{0x32185969,0x6281d96a,0x63bb8085,0x26c581f6}},	//   sary_, _lolo, _oxun, lolo_,
   {{0x7c240013,0xddd5027f,0x765c596b,0x648600f7}},	// [4ee0] _idir, _rozš, _pary, _dóit,
   {{0x26c588f1,0x6281a683,0x20f802a5,0xa3c78105}},	//   nolo_, _nolo, _učio_, _उड़_,
   {{0x765c3ef9,0xa0a63c29,0x60c403a7,0xa2c1016f}},	//   _vary, _банд, poim, लकर्,
   {{0x2056095a,0xb4c08006,0x26c58234,0x317b00be}},	//   _стор, ुते_, holo_, _נאכד,
   {{0x38602608,0x26c5bbb8,0x765c0110,0x6442d96c}},	//   mdir_, kolo_, _tary, rfoi,
   {{0x62818ca9,0xc3330bea,0x3860596d,0x3b0693de}},	//   _colo, מוד_, ldir_, rpoq_,
   {{0x6281d96e,0x6f02d96f,0x26c5c1e6,0x2ca4808e}},	//   _dolo, _stoc, dolo_, _tmmd_,
   {{0x38602608,0x9958026f,0x7c241efb,0x65000135}},	//   ndir_, káže_, _ndir, _ịkwụ,
   {{0x62818012,0xa3cb83db,0x3860198d,0x26c5d970}},	//   _folo, _रुप_, idir_, folo_,
   {{0x0f570051,0xa2e6a103,0x7c245971,0x9b938013}},	//   ניים_, _созд, _adir, _الكت,
   {{0x38600850,0x442480b9,0x7bcd00dd,0x64bc8088}},	//   kdir_, _kdm_, _syau, pčid,
   {{0xd00faf0a,0x3a3a002a,0xfbcd00ab,0x628e0123}},	//   _فلم_, _acpp_, রেফত, ekbo,
   {{0x38605972,0x26c580e1,0x69c00214,0x6281d973}},	//   ddir_, bolo_, şmel, _yolo,
   {{0x8f9b893f,0x26c58698,0x7c240201,0x2eb181a2}},	//   _אידי, colo_, _edir, ीकृत,
   {{0x6d588052,0x661ad01e,0x9928012f,0x66155974}},	//   _usva, matk, люта_, _rezk,
   {{0x6947003b,0x661ad975,0x395a0122,0x6aaa81ec}},	//   jčeš, latk, _dsps_, hiff,
   {{0xb4c300d4,0xceb40085,0x2ba4a743,0x8e150cec}},	// [4ef0] ्ती_, rsən_, _खेला, идац,
   {{0x645f00dd,0xd5bb2597,0xc7d78039,0x661ad976}},	//   _haqi, нсе_, רומי_, natk,
   {{0x5d554c3b,0x6281ceb2,0xf1ab003d,0x3860011c}},	//   ркет, _rolo, _ساده_, bdir_,
   {{0x44fa8b18,0x661a8057,0x3af98205,0x6281d977}},	//   _më_, hatk, _pèp_, _solo,
   {{0x661ac08b,0x09dd8b86,0x5bd301aa,0xa7fb0020}},	//   katk, मध्य, _सरोव, _cañe,
   {{0xb4c30aad,0xe8e0001c,0x44fa81b0,0x2ba4816f}},	//   ्तु_, _đức_, _oë_, _खेळा,
   {{0x661ad978,0x44fa9674,0xd1758791,0x78a9c8fc}},	//   datk, _në_, рылы, tiev,
   {{0x645f5979,0x5f759ef7,0x2eee9bad,0x63bb9fa4}},	//   _naqi, لاخر, _aiff_, _txun,
   {{0x6281d97a,0x26c5d97b,0x672d597c,0x78a9d97d}},	//   _tolo, tolo_, nraj, riev,
   {{0x99980019,0x661aa0d0,0x201b0d7a,0x3860080a}},	//   zerű_, gatk, haqi_, zdir_,
   {{0x26c5d97e,0x672d026f,0x6d5ea8f7,0x38600380}},	//   rolo_, hraj, _špar, ydir_,
   {{0x26c582ec,0x7f5981c0,0xb87b0118,0x2369010c}},	//   solo_, _tswq, _xiít, _braj_,
   {{0x661a8867,0x64498013,0x26c5ca10,0x5f7784c1}},	//   batk, _mbei, polo_, _حاضر,
   {{0x412a0c8e,0xee0f1a3b,0x6f098216,0x648600f7}},	//   кого_, िरोध_, mpec, _cóir,
   {{0x7c3b8693,0x91e60b5b,0x628e597f,0x38600085}},	//   _ocur, рове, rkbo, tdir_,
   {{0xf7720013,0x7c242e28,0x27ff9c33,0x7bcd80eb}},	//   ياء_, _udir, ncun_, ļauj,
   {{0x38605980,0x672d06e4,0xee3a0847,0xa3e52207}},	// [4f00] rdir_, graj, кна_, भेद_,
   {{0x6449d981,0x44248b99,0x2bdc8fd5,0xaa460adb}},	//   _abei, _sdm_, _बरबा, _теол,
   {{0x64bc8499,0xc27b0051,0x6d41ac20,0x395a484d}},	//   jčic, _סרטי, ntla, _usps_,
   {{0x8c4691c7,0xdd8f0d4a,0x0446a05f,0x645f0079}},	//   реде, بوم_, редн, _xaqi,
   {{0x661aa08b,0x7d09007a,0x39ae8085,0x68e41923}},	//   yatk, _čese, _səs_, mmid,
   {{0xd36f80f7,0x6d41d982,0x68e402f3,0x7c3bd983}},	//   بهه_, ktla, lmid, _ecur,
   {{0x5bd30b6f,0x649382bb,0x6aaa8d02,0x661ad984}},	//   _सर्व, _için, riff, vatk,
   {{0x6b8ba280,0x8f468160,0x6d5c0e5a,0x224982a5}},	//   bygg, аход, _isra, đaka_,
   {{0x44fa88cf,0xd6da9bba,0x20050085,0x661ad985}},	//   _së_, кто_, _əli_, tatk,
   {{0x26c70025,0x3cf85986,0x7afd86a5,0x443b0118}},	//   čnog_, _kurv_, _ésta, _scq_,
   {{0x44fa8b18,0x661ad987,0x200001ac,0x2484977b}},	//   _që_, ratk, kcii_, _komm_,
   {{0xb4c30a16,0x661a810b,0x69dac102,0xdb0401df}},	//   ्ते_, satk, _izte, _axiñ,
   {{0x661a94ff,0x6d41a161,0xdce40b80,0x6d5c0122}},	//   patk, atla, _grnč, _lsra,
   {{0x44fad988,0x171b84de,0x236900e1,0xe80e8074}},	//   _të_, _יודע, _vraj_, सरका_,
   {{0x2bd30592,0x30a70ddc,0x3eacd297,0xddd89502}},	//   _सरका, арав, midt_, _fovš,
   {{0x1410800f,0x2366805c,0x88940009,0x68e4110f}},	//   ारोह_, kvoj_, оисх, gmid,
   {{0xe3b80059,0x6d5c11d6,0x661881c0,0xaa8912c8}},	// [4f10] şır_, _asra, _kevk, _منظم_,
   {{0xde1907bd,0x42550c48,0x672d011e,0x4439005f}},	//   اقات_, _اندر, rraj, lgs_,
   {{0x6f0984e8,0x44390144,0x2bda00d7,0x672d2551}},	//   zpec, ogs_, _لایک_, sraj,
   {{0x44395989,0x672d598a,0x6618807a,0x315600be}},	//   ngs_, praj, _levk, _פירן_,
   {{0x69da811e,0x6b658a08,0xe3b084a3,0x6285598b}},	//   _azte, скла, وره_, _koho,
   {{0x6285598c,0x20191fa4,0x78ad0110,0x6b8bb860}},	//   _joho, _hesi_, liav, rygg,
   {{0x2019022e,0xb5e500c8,0x6285598d,0xf59500f7}},	//   _kesi_, _প্রচ, _moho, _الأج,
   {{0xb4c3000d,0x20191351,0x6ca484ad,0x6285598e}},	//   ्तो_, _jesi_, _друж, _loho,
   {{0xb8fe80cf,0x2019598f,0xb4c3000d,0x27ffd990}},	//   _दी_, _mesi_, ्तै_, rcun_,
   {{0x6f098359,0x27ffba68,0x2019005d,0x78ad5991}},	//   rpec, scun_, _lesi_, hiav,
   {{0x74ea0c9b,0x79a7b2f1,0xaefb0229,0xddd885b7}},	//   лдог_, _трае, _drùi, _povš,
   {{0x6d41d992,0x44390bcb,0x648600f7,0xc18c80be}},	//   rtla, ggs_, _cóip, _שטאָ,
   {{0x6d41d993,0x64bcb999,0x26d9809f,0xe60e8c0e}},	//   stla, nčia, ïsos_, _нд_,
   {{0x64bc8110,0xcb128039,0x2bde150e,0xd37a83de}},	//   ičia, הלך_, नेगा, ארשט,
   {{0x62851807,0x2019059c,0x40960171,0xf2d29101}},	//   _doho, _besi_, брат, פעל_,
   {{0x387f861b,0x60c9838e,0x10a301a4,0x2aad016b}},	//   njur_, noem, писн, ržba_,
   {{0xa0670698,0x201914a9,0x64bc80e1,0xac9705ff}},	// [4f20] щата_, _desi_, jčia, _دنيا_,
   {{0x68e45994,0xe7f400d4,0xdc1080c2,0x20000037}},	//   smid, _अलका_, ार्ड_, scii_,
   {{0x3ce0022c,0x64bc8110,0x629c00f7,0x321c9075}},	//   _khiv_, ečia, mhro, vavy_,
   {{0xeb9aa33f,0x291e01e2,0x628504fb,0x78ad55f4}},	//   лие_, štas_, _zoho, ciav,
   {{0x387f8106,0x321c816b,0x69da8061,0x649385aa}},	//   djur_, tavy_, _szte, _içil,
   {{0x6e960307,0x6d5c01a8,0x6d178035,0xd9fa2a54}},	//   _السا, _tsra, _दबंग_, ्डित_,
   {{0x5fac035a,0x321c8efc,0x81cb80ab,0xd7fa8088}},	//   _घेतल, ravy_, রেস_, луп_,
   {{0x387fd928,0x2ed08a75,0xceb40085,0x831a8c2a}},	//   gjur_, हत्त, ksək_, _مقرر_,
   {{0xdfd08307,0x7f445995,0xdddc0087,0x6720911b}},	//   بية_, ntiq, _forţ, usmj,
   {{0xa7fb05b4,0x2d9e82af,0x69da826c,0xb87b00ff}},	//   _maña, tzte_, _tzte, _khíc,
   {{0x6285136f,0x69daab43,0x3eac928d,0xa7fb0118}},	//   _roho, _uzte, ridt_, _laña,
   {{0x67228ee0,0x3ce001c5,0x3eaa00b9,0xb87b01a8}},	//   _tvoj, _chiv_, _lmbt_, _mhíc,
   {{0x62850696,0x443903ab,0x661e0057,0x201916ce}},	//   _poho, rgs_, kapk, _resi_,
   {{0x20195996,0xdd948d15,0x65948087,0xdb0a1434}},	//   _sesi_, _малы, _малу, ðnám,
   {{0x661e09ca,0x78ad5997,0x66d00009,0x201900e5}},	//   dapk, tiav, näku, _pesi_,
   {{0xa7fb1f49,0xb7150081,0x2a615998,0x3ce6a39f}},	//   _baña, ждащ, _wahb_, jmov_,
   {{0x628503fb,0x201938be,0xa7fb1e4f,0x644d011b}},	// [4f30] _toho, _vesi_, _caña, _ibai,
   {{0xa7fb06a5,0x6c35026a,0x661e00dd,0x43d401a8}},	//   _daña, _افکا, gapk, _عزيز,
   {{0x201912d0,0x291e2944,0x7f4400e7,0xb87b5999}},	//   _tesi_, štar_, atiq, _chíc,
   {{0x42550019,0x3e8501d0,0xb87b0174,0x44fe0123}},	//   _انگر, _sítě_, _dhíc, _dï_,
   {{0xa7fb062f,0xa03a0158,0x644d00f7,0x1dcf8105}},	//   _gaña, _דערפ, _mbai, _सुनत,
   {{0x661e0057,0x660d8668,0x64bc88fc,0x442902df}},	//   capk, _đako, rčia, _lda_,
   {{0x644d003c,0x44291fcf,0x60c99727,0x6f0d599a}},	//   _obai, _oda_, toem, lpac,
   {{0xa3aa2cdd,0xaf059baa,0x7afd86a5,0x3f42807b}},	//   _गइल_, опил, _ésto, fðu_,
   {{0x660482bb,0x7c29846d,0xb4d592c6,0x60c9910f}},	//   _şika, _ider, हती_, roem,
   {{0x4429599b,0x644d599c,0xda02800f,0x6d454772}},	//   _ada_, _abai, रुआत_, otha,
   {{0xa2c6909b,0x6d45599d,0x7afb8009,0x443f8267}},	//   िवर्, ntha, _huut, _kcu_,
   {{0x6d45031d,0x4429599e,0x7afbbf6c,0xa775964f}},	//   itha, _cda_, _kuut, _млеч,
   {{0x4429599f,0xfc4a026b,0x629c435c,0x7afba551}},	//   _dda_, _adíá_, thro, _juut,
   {{0x7afb8181,0x442959a0,0x64bc811f,0x201f8359}},	//   _muut, _eda_, jčin, laui_,
   {{0x81cb8a49,0x443f805c,0x04460098,0xfbde14fc}},	//   রের_, _ocu_, _дейн, नेजम,
   {{0x7c2997d5,0xa7fb06a5,0x443f822c,0x6f0d090d}},	//   _nder, _paña, _ncu_, fpac,
   {{0xe73a0c8e,0xe61a2481,0x661e0867,0x7e63d9a1}},	// [4f40] рез_, ида_, tapk, _kanp,
   {{0x7c29cea9,0x443f8013,0x7e63826b,0x6d451433}},	//   _ader, _acu_, _janp, ftha,
   {{0x7f44295a,0x661e0867,0x22580cfa,0x91e659a2}},	//   stiq, rapk, merk_, _фоне,
   {{0x7e638102,0x82360019,0x69de49cd,0xe73a0198}},	//   _lanp, _ارکا, _izpe, _кем_,
   {{0x6d450083,0xdee60098,0x66090214,0x7c298114}},	//   atha, _моми, _şeke, _dder,
   {{0x7c29d9a3,0xb87b0104,0x6d4559a4,0x6da60b5b}},	//   _eder, _thíc, btha, _дига,
   {{0x67240c7f,0xb05b1a50,0xdd920019,0x6d454d01}},	//   lsij, _fjäd, _غور_, ctha,
   {{0x661c54b9,0xf8ba80c8,0x7e63838e,0xdddc272a}},	//   _herk, ুষ্ঠ, _aanp, _gorš,
   {{0x6724225d,0x661c289c,0xa3aa0006,0xda0b816f}},	//   nsij, _kerk, _गेल_, _स्वत_,
   {{0x442914c9,0x3f428125,0x63a2d9a5,0x09e6866c}},	//   _sda_, rðu_, mzon, _дозн,
   {{0x7c29813c,0x64bc81e2,0x80c782f1,0x6288a817}},	//   _yder, nčio, ावशे, _iodo,
   {{0x6f0d0953,0xceb8c702,0x06de00ab,0xe4a7004a}},	//   ypac, snę_, _ভূমি, ірно,
   {{0x63a2d9a6,0x67240289,0xa2a1954b,0x443f00eb}},	//   nzon, jsij, कोक्, ļu_,
   {{0x6288810b,0x6724026c,0x6d450428,0x443f17ac}},	//   _jodo, dsij, ytha, żu_,
   {{0x6288d9a7,0x2d83813c,0x68e289da,0x48ab1652}},	//   _modo, øjet_, _khod, атам_,
   {{0x62888e80,0x442912bf,0xd5b980e8,0x26cc89c4}},	//   _lodo, _uda_, _усі_, lodo_,
   {{0x661c0397,0x63a28a0f,0x64bc8b80,0x68e28090}},	// [4f50] _berk, jzon, tčin, _mhod,
   {{0x6f0d59a8,0x62888029,0x7bdf1099,0x63a2809a}},	//   rpac, _nodo, _izqu, dzon,
   {{0x68e2826f,0x7afb84a2,0x6d450fe9,0xdddc0088}},	//   _ohod, _suut, utha, _porš,
   {{0x236dd9a9,0x6d4547c8,0xb4d58a16,0x7afb88e5}},	//   _prej_, rtha, हते_, _puut,
   {{0x0f79093f,0x64bc9487,0x66d00106,0x443f8609}},	//   _האָב, mčil, täkt, _vcu_,
   {{0x24893603,0x4efa01c6,0x60cd03e4,0x661c59aa}},	//   _loam_, _להשו, loam, _gerk,
   {{0x26ccd5ad,0x6288c18b,0x7e638247,0x68e29dfb}},	//   dodo_, _dodo, _ranp, _bhod,
   {{0x68e289a4,0x60cd25ca,0x64bc9807,0x63a2a91d}},	//   _chod, noam, nčil, bzon,
   {{0x63a28063,0x7e63d9ab,0x201f808e,0x6288a00a}},	//   czon, _panp, raui_, _fodo,
   {{0x26ccd9ac,0x6459d9ad,0x35d003b7,0x776981df}},	//   godo_, lewi, _तुड़, rvex,
   {{0x22583fa4,0x27f90118,0x68e29995,0xd46a04dd}},	//   verk_, _ogsn_, _fhod, бине_,
   {{0x225816a1,0x62838503,0x649a0cc1,0x7c3d0711}},	//   werk_, ljno, стор_, ggsr,
   {{0xee2e8554,0x7e638763,0x68e9805f,0x225859ae}},	//   _пн_, _tanp, mmed, terk_,
   {{0xa7fb05a4,0x68e9d9af,0x2cbf816d,0x68e29c18}},	//   _baño, lmed, _ljud_, _zhod,
   {{0x40961354,0x63a2aa4d,0xa7fb0020,0x5bb89b7e}},	//   прат, zzon, _caño, _अश्व,
   {{0x03261878,0xb05b00f2,0x6e21d9b0,0xa7fb2423}},	//   _един, _skär, lalb, _daño,
   {{0x442243db,0x661c0dab,0x6459c5fc,0x2258074c}},	// [4f60] mak_, _perk, dewi, perk_,
   {{0x4422059f,0x67241ffe,0x68e98754,0xddc18019}},	//   lak_, rsij, hmed, lelő,
   {{0x672459b1,0x6288d357,0xa7fb01df,0x60cd59b2}},	//   ssij, _rodo, _gaño, boam,
   {{0x442259b3,0x661c0574,0x645996a1,0x6288d9b4}},	//   nak_, _werk, gewi, _sodo,
   {{0x661c0393,0x68e2831d,0xd7f200f7,0x6e218110}},	//   _terk, _rhod, _سكس_, kalb,
   {{0x44220455,0x63a2d9b5,0x62888079,0x68e2ba06}},	//   hak_, rzon, _qodo, _shod,
   {{0x442259b6,0x63a2b1d6,0x20070063,0x66d00009}},	//   kak_, szon, śnie_, säks,
   {{0x25e1009a,0x63a2aa13,0xc05ab73a,0x55bb01c6}},	//   _करती_, pzon, сік_, _המלו,
   {{0x44221dae,0x62888510,0x68e2803e,0x201d8cf1}},	//   dak_, _todo, _vhod, _dewi_,
   {{0x6e218666,0x7c228032,0x7bcd81a9,0x59a78074}},	//   galb, laor, ļaut, _केकर,
   {{0x7bd600a4,0x26cc8110,0x1dbe1299,0x68e980e1}},	//   _ayyu, rodo_, ्थित, bmed,
   {{0x442259b7,0x2d828d11,0x7c22d9b8,0xd1978039}},	//   gak_, ćke_, naor, _מכבי_,
   {{0x6e21d9b9,0x2d83806a,0xb921019d,0xa0c981a8}},	//   balb, øjer_, basị_, _بذلك_,
   {{0xb87b0104,0x1dbe23e6,0x2ec789a9,0x4422008e}},	//   _chín, ्थात, रकृत, aak_,
   {{0x4422592d,0x31c415e0,0xa9c40110,0x7c22d9ba}},	//   bak_, еств, естк, kaor,
   {{0x442259bb,0x64bca368,0x321ed9bc,0x50cc8072}},	//   cak_, učil, _lety_, ाविष,
   {{0xb90409a3,0x7c2d59bd,0x60cd2cfd,0x290c8cd4}},	// [4f70] _पी_, _idar, roam, _ltda_,
   {{0xaefb0a2a,0x2cad97db,0x65950087,0x765ad9be}},	//   _brùr, _smed_, мазу, nety,
   {{0x753a8352,0x6459a5ad,0x64bc807a,0x6d48d9bf}},	//   nutz, tewi, mčij, ntda,
   {{0x765a8198,0x66054255,0xc435881b,0xfbe101d0}},	//   hety, schk, بکست, _नराम,
   {{0x753ac5cb,0x38694426,0x321ed9c0,0x38790db1}},	//   hutz, mdar_, _bety_, _insr_,
   {{0x44223065,0x9f960039,0x38690ba0,0x66d0016d}},	//   zak_, _חדשה_, ldar_, säkr,
   {{0x44224259,0x7c2d0b4c,0x776d01df,0x68e9d9c1}},	//   yak_, _odar, lvax, tmed,
   {{0x386959c2,0x7c2d59c3,0x2cbf9eb1,0x05d082f1}},	//   ndar_, _ndar, _ujud_, _हड़ब,
   {{0x64bc8582,0xcb348098,0x7e6716f2,0x53349dc7}},	//   kčij, _петъ, _kajp, _петт,
   {{0x442259c4,0x7c2d2266,0xdd1b816b,0x321e8123}},	//   wak_, _adar, _váže, _gety_,
   {{0x442259c5,0x442d85b9,0x6d48d9c6,0x753a8102}},	//   tak_, _kde_, gtda, gutz,
   {{0x442d801b,0x7e672009,0x4422011b,0xb87b01a8}},	//   _jde_, _lajp, uak_, _shín,
   {{0x44220781,0x3869407e,0x7c2d031d,0x765a951f}},	//   rak_, ddar_, _ddar, bety,
   {{0x7e6709b3,0x7ea059c7,0xb87b00f7,0x7c2d59c8}},	//   _najp, _köpe, _bhío, _edar,
   {{0x442dc5e1,0xa3d485e8,0xb87b1d72,0xa9671bab}},	//   _ode_, _सुन_, _chío, мира_,
   {{0x98a08d11,0x442dd9c9,0xb87b00f7,0x25d680be}},	//   čić_, _nde_, _dhío, _קוקן_,
   {{0x7f49d9ca,0x7e670b80,0x44200087,0x64bcb78b}},	// [4f80] nteq, _bajp, _iei_, učim,
   {{0xf7679fbe,0x7c2d0e04,0x44200956,0x442dd9cb}},	//   _یا_, _zdar, _hei_, _ade_,
   {{0x7c2280ee,0xa0a602c0,0x68fe02c4,0x629e00e5}},	//   taor, _жанд, _uupd, _ilpo,
   {{0x442001e2,0x69c00214,0x321e8690,0xa3d20651}},	//   _jei_, şmes, _sety_, _वडा_,
   {{0x7c228d02,0x629e00b9,0x442dd9cc,0x26c38301}},	//   raor, _klpo, _dde_, čjoj_,
   {{0x442059cd,0x442dd9ce,0x38668068,0x7c228748}},	//   _lei_, _ede_, _saor_, saor,
   {{0xd90d84c0,0x2f0400f2,0x6d48d9cf,0x44200bfd}},	//   میل_, _hög_, xtda, _oei_,
   {{0x44201f96,0x442d8d11,0xd01081a8,0x00000000}},	//   _nei_, _gde_, دلة_, --,
   {{0x6f021301,0x765ad9be,0xb6f48a3d,0xc246aba7}},	//   íoch, tety, нзиј, _онак,
   {{0x24868052,0x442d800d,0x6996a3e7,0x753a89e8}},	//   ljom_, _zde_, _орех, tutz,
   {{0x442059d0,0xf76f83f8,0x2d988038,0x2f04007b}},	//   _bei_, های_, áre_, _lög_,
   {{0x44200012,0x765aa168,0x442d83ac,0x6fc980d4}},	//   _cei_, sety, _xde_, _हुकू,
   {{0x44201fcb,0xd7e2a9b7,0xe7e28107,0xfc3f00f7}},	//   _dei_, _परिच, _परिप, rgí_,
   {{0x44200118,0x7d033680,0x80dc00ab,0x7817097d}},	//   _eei_, ínsk, _মূল্, तर्क_,
   {{0xa2b1805e,0x44203aa8,0xd5afa355,0x480c019d}},	//   _अगस्, _fei_, _рс_, _ọzịz,
   {{0xdd8e8065,0x81cb80ab,0x660d8115,0x442030a3}},	//   _موڈ_, রেক_, _đaki, _gei_,
   {{0x386959d1,0x645d59d2,0x7af701b9,0x24868bcf}},	// [4f90] rdar_, mesi, _tixt, djom_,
   {{0x76d50013,0x69c501e9,0x44200a0f,0xb87b00f7}},	//   رياض, _txhe, _zei_, _thío,
   {{0x386901bf,0x7e6701c0,0xaefb026b,0x752881a9}},	//   pdar_, _vajp, _erùp, nsdz,
   {{0x645d59d3,0x8b6b80eb,0x2aad012b,0xb69b0162}},	//   nesi, ņēmē, džbi_, _atât,
   {{0x68ed59d4,0x511f0074,0x628e00d2,0x7e670197}},	//   mmad, _बबुआ_, žnoš, _tajp,
   {{0xa9698676,0x290115d0,0x2d470187,0x21699af1}},	//   зика_, _kuha_, põe_, зики_,
   {{0x7c2080f1,0x645d59d5,0xac198e1d,0x6e25008e}},	//   _femr, kesi, _нову_, mahb,
   {{0x442dd9d6,0x290131a7,0x645d59d7,0x68ed22f8}},	//   _ude_, _muha_, jesi, nmad,
   {{0x442059d8,0xe8200076,0x68ed59d9,0x290116fb}},	//   _rei_, बरता_, imad, _luha_,
   {{0x44203528,0x39648364,0x7c2080f1,0x458590ca}},	//   _sei_, ässä_, _zemr, егов,
   {{0x044601d9,0x29010ad4,0x68ed59da,0xa6e2008b}},	//   ненн, _nuha_, kmad, íðin,
   {{0x859a0039,0x802780d7,0x64ca1299,0xd46a3296}},	//   פשרו, _آرام, रवेश, чиме_,
   {{0xe72ed9db,0x442059dc,0xaca38028,0x1dcf93e5}},	//   _ще_, _vei_, _chứn, _सुरत,
   {{0x249fd9dd,0x60dbd9de,0xa764804a,0x68ed03ca}},	//   _llum_, llum, _шкід, emad,
   {{0xf09f0362,0x442059df,0x2bdc91be,0xf3f98162}},	//   _blà_, _tei_, _बर्थ, _daţi_,
   {{0x645d05e4,0x290104a7,0x68ed02a3,0x248d9ad7}},	//   cesi, _duha_, gmad, _noem_,
   {{0x672985b4,0x7c260234,0xace900d7,0x8fa30ba5}},	// [4fa0] nsej, makr, _ترول_, гате,
   {{0x6da62410,0xe5a601f3,0x7c263d9b,0x249f9916}},	//   низа, низи, lakr, _alum_,
   {{0x60db9cbc,0xe3bf04c3,0x249fd9e0,0x200601df}},	//   klum, maña_, _blum_, ñois_,
   {{0x64a38b69,0xac07d081,0x0ca980f7,0x61e11266}},	//   лаха, енца_, وطني_, ülle,
   {{0xc5f88029,0x7cfe8029,0xe3b28a47,0xeb978198}},	//   ldēt_, _vīri, درا_, ниц_,
   {{0x7d0d890c,0x6e250d8b,0x645d5105,0x9966959f}},	//   _časn, cahb, zesi, етил,
   {{0x645d59e1,0x55e3031f,0x1dcf8540,0x64a6cc6b}},	//   yesi, _борб, _सुलत, _зава,
   {{0x60dbd9e2,0xa3cb8105,0x62988084,0x7c2654a9}},	//   glum, _रुक_, skvo, jakr,
   {{0xb907853e,0x59d2035a,0xb4cc9130,0xdca38294}},	//   _मी_, _दुसर, रकी_, _сати,
   {{0x44268272,0x645d3d41,0xddd8801b,0x2ef8807b}},	//   lao_, wesi, _zavř, örf_,
   {{0x7d092191,0x645d59e3,0x5fe2835a,0x01368591}},	//   _česk, tesi, _परवल, _سعاد,
   {{0x7afa9f0a,0x4426d74a,0x2fc690af,0x6442a91f}},	//   _hitt, nao_, _txog_, ngoi,
   {{0x087780be,0x78a43df9,0x29013cd2,0x6e2500ee}},	//   _רעדט_, dhiv, _suha_, yahb,
   {{0x7afa81b9,0x877b80be,0xe3bf0661,0x3ce78054}},	//   _jitt, _מאדי, gaña_, _छीने_,
   {{0x7afad9e4,0x68ed36b2,0xf09f07f1,0x7cfe8196}},	//   _mitt, tmad, _plà_, _būre,
   {{0x44268025,0x7afad5d1,0x7c26008e,0x7bde809a}},	//   jao_, _litt, cakr, ępuj,
   {{0x4426803b,0x3d068b9f,0x6a151a02,0x9f340163}},	// [4fb0] dao_, _संडे_, _импу, леті,
   {{0xa3aa1a3b,0x7afa8197,0x3f8701dd,0x249f8706}},	//   _गेट_, _nitt, ćnu_, _slum_,
   {{0xeab18bca,0xceb3898a,0x3ce90069,0x200900ee}},	//   یعت_, ניע_, _khav_, pcai_,
   {{0x44268025,0x2bdc8076,0x78a42c04,0x7c849631}},	//   gao_, _बरखा, chiv, луче,
   {{0x7afad9e5,0x69da85b0,0x69e3025b,0x6f02ad60}},	//   _bitt, _ayte, šteć, _nuoc,
   {{0xc61b00c8,0x7afa8698,0x69dad9e6,0x6d58c7a5}},	//   _ঢাকা_, _citt, _byte, _opva,
   {{0x4426a64b,0x7afaad08,0x7d0d9ee0,0x7f4d32aa}},	//   bao_, _ditt, _časo, ltaq,
   {{0x4426d9e7,0x7afa8125,0xa3c309a9,0x249f9600}},	//   cao_, _eitt, ्था_, _ulum_,
   {{0xc62400c8,0x60db8859,0x6f028081,0x7f4d011c}},	//   _পাতা_, rlum, _cuoc, ntaq,
   {{0x7afa87d9,0xf1a790ca,0x60dbd9e8,0x82378bbe}},	//   _gitt, _прен, slum, _سرطا,
   {{0xdca6119d,0x4df48153,0x6729ae12,0x64a60611}},	//   вани, ляют, ssej, вана,
   {{0x224980fe,0x7d04d9e9,0x7afacb19,0x3ce901c5}},	//   đaku_, _čist, _zitt, _chav_,
   {{0x26c7003b,0xccf280be,0xe3bf0511,0x7ea00106}},	//   čnoj_, יכט_, taña_, _löpa,
   {{0x386d806f,0xd02680c8,0x64410084,0xa7fb02f9}},	//   lder_, _যায়_, ėlia, _gañi,
   {{0xaca38142,0x26d30825,0xa01b016d,0x4426d9ea}},	//   _nhữn, doxo_, _onöd, yao_,
   {{0x2aad111b,0x3a2782c4,0x6e23d9eb,0xe3bf0333}},	//   džbu_, hanp_, _henb, saña_,
   {{0x4426803b,0xe3bf160a,0xb05b04b8,0x6e238247}},	// [4fc0] vao_, paña_, _tjän, _kenb,
   {{0xb05b04b8,0x78a413fa,0x4426c53f,0x386d8428}},	//   _hjäl, shiv, wao_, hder_,
   {{0x7d0390e4,0x4432001b,0x6e2380dd,0x2d9c01ac}},	//   _juns, _kdy_, _menb, áve_,
   {{0x7afad9ec,0x386daa52,0x7d039b19,0xb4be8a16}},	//   _sitt, jder_, _muns, ीके_,
   {{0x4426803b,0x7c2407ca,0x93439b47,0x8c43a155}},	//   rao_, _meir, инце, рече,
   {{0x44268025,0xe8e00028,0x386d8ac5,0x386001e4}},	//   sao_, _độc_, eder_, leir_,
   {{0x69da820f,0x4426803b,0x7afa8d02,0x6f02d9ed}},	//   _qyte, pao_, _vitt, _suoc,
   {{0xfce68cde,0x7afa8ac5,0xe0cf80f7,0xf993025f}},	//   _робо, _witt, يزي_, שרה_,
   {{0xf8b30051,0x7afad9ee,0xc6f89fb4,0x7d038362}},	//   ישה_, _titt, нних_, _auns,
   {{0x7afa98c7,0x7d03d9ef,0x15e618a4,0x60cd81a1}},	//   _uitt, _buns, _करार_, čama,
   {{0x7c2459f0,0xceb30051,0x6e2392a2,0x4424d9f1}},	//   _beir, שית_, _denb, _kem_,
   {{0x80e080c8,0x79b78051,0x4424aed5,0x35b3a357}},	//   _পূর্, _בלבד_, _jem_, рбюр,
   {{0x7c24444b,0x4424d9f1,0x7d03808e,0xd007ca56}},	//   _deir, _mem_, _euns, _рече_,
   {{0x4424d9f2,0x28ae8074,0x6e23806a,0x78a28115}},	//   _lem_, जोरि, _genb, _hlov,
   {{0x81d480c8,0x7c24186c,0xe2f8004a,0xb05b0106}},	//   সের_, _feir, тері_, _fjäl,
   {{0x44248986,0xb4cc83bb,0xb4be83bb,0x4432050d}},	//   _nem_, रको_, ीको_, _gdy_,
   {{0xe3bf040e,0xf77307bd,0x64bc8110,0xfc3f0118}},	// [4fd0] maño_, جاز_, nčiu, chía_,
   {{0xa3e805b3,0xed4d8986,0x7f4d07d5,0xe3bf01df}},	//   _भरत_, _بھی_, rtaq, laño_,
   {{0x442480a9,0xa9c40d70,0x386dd9f3,0x7f4d59f4}},	//   _bem_, _всяк, yder_, staq,
   {{0x4424d9f5,0xe7e2b4ec,0x6ba802d0,0x7c2403a8}},	//   _cem_, _परंप, _örgü, _xeir,
   {{0x4424d32b,0xe78423d7,0x386d804a,0x6f020174}},	//   _dem_, _куро, vder_, íoct,
   {{0xdce401d0,0x539c0e82,0x672d59f6,0x98b80ec3}},	//   _brně, וידו, msaj, murā_,
   {{0x27e68019,0x672d0338,0x79a78081,0x64bc8196}},	//   _azon_, lsaj, ърде, ečiu,
   {{0x2ca68265,0x6e23d9f7,0x386d80f3,0x78a2d9f8}},	//   chod_, _senb, uder_, _clov,
   {{0x386da815,0x672d0a49,0x68fd074c,0x7c2459f9}},	//   rder_, nsaj, _misd, _reir,
   {{0xb05b04b8,0x44248070,0x7c24061f,0x76453205}},	//   _själ, _zem_, _seir, nghy,
   {{0x391599b8,0x4424d9fa,0x236900f1,0x7c2459fb}},	//   _смер, _yem_, _asaj_, _peir,
   {{0x44248142,0x3a25d9fc,0xe3bf01ca,0x6e23b235}},	//   _xem_, _help_, gaño_, _wenb,
   {{0x2905d9fd,0x629c0668,0x7d0381ec,0xceb8809a}},	//   _hula_, tkro, _wuns, bię_,
   {{0x2905cd24,0x2d732bea,0x7d0393d7,0x68fd0706}},	//   _kula_, _oće_, _tuns, _aisd,
   {{0x29059f3a,0x7c2432c3,0x629c209b,0xa7fb0118}},	//   _jula_, _teir, rkro, _mañu,
   {{0x6d419dde,0x1c461289,0x2905d9fe,0x629c2c15}},	//   mula, _сним, _mula_, skro,
   {{0x2905cf67,0xe73715e0,0xe7c400ab,0x68fd1181}},	// [4fe0] _lula_, лет_, ্ধ্য, _disd,
   {{0x4424bbed,0x6449d8cf,0xda6600af,0x7e61d779}},	//   _sem_, _acei, _свои, nelp,
   {{0x44248069,0x6d41a4ed,0x21761448,0x88bc801b}},	//   _pem_, nula, _супр, _květ,
   {{0x64460812,0x29180531,0x64bc803b,0x672d01b9}},	//   ngki, mpra_, jčit, bsaj,
   {{0x4424d9ff,0x2905cd2c,0x6d4197b7,0x6d4103a6}},	//   _vem_, _aula_, hula, _ålan,
   {{0x78a299a1,0x6d41da00,0x2905da01,0xaa58968a}},	//   _slov, kula, _bula_, тику_,
   {{0x4424da02,0x248005f5,0x2905807d,0xa3d48054}},	//   _tem_, _onim_, _cula_, _सुर_,
   {{0x4734bbae,0x6d4e0a76,0x644980f7,0x60c45a03}},	//   анис, _iqba, _gcei, nnim,
   {{0x7c938013,0x69d60105,0x29059400,0x6e28da04}},	//   _القص, _मुसी, _eula_, tadb,
   {{0x2480009c,0x6e989a19,0x2905da05,0x6d41da06}},	//   _anim_, твор_, _fula_, fula,
   {{0x2905b55e,0x6d41b09c,0x7afd8081,0x241917ae}},	//   _gula_, gula, _èsta, коны_,
   {{0x78a2da07,0xbd87803d,0x236901a1,0xa3c300bc}},	//   _ulov, چنین_, _psaj_, ्थल_,
   {{0x60c45a08,0x7e618be7,0x68fd09f4,0x6d41a416}},	//   dnim, belp, _risd, aula,
   {{0x6d5c1eee,0x7afe01da,0x24805a09,0x23690353}},	//   _opra, _cipt, _enim_, _vsaj_,
   {{0x19580071,0x6f065a0a,0x35d90b9f,0x6eeb5a0b}},	//   лары_, _aukc, _बुढ़, nübe,
   {{0x23690282,0x60c45a0c,0x30150b5b,0xa8151c79}},	//   _tsaj_, gnim, рдар, рдаш,
   {{0x6d5c5a0d,0x6d4e01b4,0x68fd0b82,0xa3c30072}},	// [4ff0] _apra, _aqba, _visd, ्थळ_,
   {{0x325503c7,0x644980f7,0x88bc81d0,0xba552ba7}},	//   _твор, _scei, _zvět, _твој,
   {{0x68fd5a0e,0x672d3194,0x60c45a0f,0x6722838a}},	//   _tisd, ssaj, bnim, _lwoj,
   {{0xc8671b10,0x48670698,0xb4c18074,0xddc3912b}},	//   _стои, _съоб, ुवे_, _janš,
   {{0x6d41da10,0x2905acc4,0xcb69a762,0xa7fb0388}},	//   zula, _sula_, тале_, _pañu,
   {{0x290594ff,0xeb96a482,0x442b2179,0x6d41d60e}},	//   _pula_, риш_, hac_, yula,
   {{0x0dc8035f,0xe5098028,0xdd940196,0x442b5975}},	//   _бути_, _mặc_, _лары, kac_,
   {{0x38ba9482,0x27e6009a,0x64bca368,0x6d41da11}},	//   tūra_, żone_, učit, vula,
   {{0x8b588b8c,0x3a258072,0x6d5c001b,0x6d418573}},	//   _مجلس_, _telp_, _zpra, wula,
   {{0x88bc800d,0xcdf58009,0x2905809c,0xe8df819d}},	//   _svět, ичны, _tula_, _idọm_,
   {{0x6281bf38,0x3ced81c0,0x7afe09c4,0x442b52ce}},	//   _inlo, _khev_, _ript, fac_,
   {{0x6d419238,0xeb9a34d6,0x442b0079,0x7afe0b67}},	//   rula, вим_, gac_, _sipt,
   {{0x6d41b1fe,0x60c4007a,0x87e79562,0xe0d084c1}},	//   sula, vnim, _сюже, _عزم_,
   {{0x6e2701d0,0x7c2b8118,0xe5098129,0x7ea002d0}},	//   _nejb, hagr, _cặc_, _röpo,
   {{0xfce60dc0,0x60c41809,0x7bcd12ab,0x6f060035}},	//   _коко, tnim, _exau, _sukc,
   {{0xa3b10361,0x98b80162,0x661c82d0,0x80660a2e}},	//   _टेक_, dură_, ırke, јваж,

   {{0xa06718a0,0x6d5c1ff1,0x60c45a12,0x62819447}},	// [5000] шата_, _spra, rnim, _onlo,
   {{0x6f06026c,0x611181a9,0x2d9a0c6b,0x29180338}},	//   _vukc, _zāle, type_, ppra_,
   {{0x05662451,0x69da816f,0x98b80162,0x05d903db}},	//   рвен, _पुढी, gură_, _बुदब,
   {{0x7d09003a,0xeb9a825d,0x6d5c0db7,0xed5680be}},	//   _čest, кие_, _vpra, יבער_,
   {{0x3ced81c0,0x78bb80e5,0xe8e20072,0x78a30162}},	//   _dhev_, diuv, पतीच, _înva,
   {{0x442b011f,0x7ea00338,0x3d2800d7,0x38721277}},	//   zac_, _köpm, _متری_, ldyr_,
   {{0x67228063,0x81d800ab,0x6d4e0748,0xc448803d}},	//   _swoj, ়ের_, _uqba, _میان_,
   {{0xc05a8163,0x8c438abe,0x6eeb02af,0x672286c0}},	//   тік_, _месе, rübe, _pwoj,
   {{0x442b003b,0x660907d9,0x6eeb0192,0xdb24010c}},	//   vac_, _şeki, sübe, _èsèn,
   {{0xf708d871,0x7d00da13,0x442b582f,0x62818a2a}},	//   _của_, _hims, wac_, _gnlo,
   {{0xa0a68364,0x442b5a14,0x7d00da15,0x69d6016f}},	//   _кажд, tac_, _kims, _मुली,
   {{0x67228063,0xd00f8b76,0x78a99ac6,0x395e8748}},	//   _twoj, _قلم_, chev, _ipts_,
   {{0xbf9b03a7,0x2007066f,0x7c360286,0xdfd28a19}},	//   _agên, śnik_, _ddyr, _بيش_,
   {{0x7c2bda16,0x799c0114,0xdddc02a6,0x1b038264}},	//   zagr, fyrw, _borż, রীকে_,
   {{0x64400511,0x45448061,0xddce01a9,0x61038e06}},	//   ómic, _انعق, _dabū, _tőle,
   {{0xd2510077,0xd5fb8051,0x7bcd01e9,0x7d00da17}},	//   _کند_, _בפור, _txau, _nims,
   {{0x28f80364,0xe5098129,0x7d0d82d4,0x644d0db1}},	// [5010] реть_, _tặc_, _časi, _icai,
   {{0x7d008cac,0x44290006,0x98b8002e,0x4fc40b73}},	//   _aims, _hea_, tură_, іста,
   {{0x3ced81c0,0xa2b7853f,0x7cff0110,0xdef82462}},	//   _phev_, ्चस्, _jūro, рыт_,
   {{0x3ced8282,0x7d0081a1,0xdd398493,0xe43c928a}},	//   _qhev_, _cims, lăţe, bříč,
   {{0x7c2b8410,0x4429002e,0xa3dd009a,0xd7fb04ae}},	//   ragr, _mea_, _तुम_, _јун_,
   {{0x44294cc8,0x3e57001b,0x6e35011f,0x69158197}},	//   _lea_, _dětí_, _udzb, _jġeg,
   {{0x442903ec,0x3ced8282,0x69da80d4,0xb7bd8162}},	//   _oea_, _thev_, _पुदी, maţi,
   {{0xc31d00c8,0x6d455a18,0xb7bd802e,0x26c7026f}},	//   _তিনি_, muha, laţi, čnou_,
   {{0x6d451fdb,0x78a9bb2d,0xa9e4001b,0x00000000}},	//   luha, rhev, _गर्छ_, --,
   {{0x26e5146d,0x7c2982b5,0x644d5a19,0x78a9b08b}},	//   _कठोर_, _heer, _acai, shev,
   {{0x6d454259,0x7c29da1a,0x38720c0b,0x78a98163}},	//   nuha, _keer, ydyr_, phev,
   {{0x44290012,0xb4c42eff,0x7c299e3b,0x443e02af}},	//   _cea_, ्वे_, _jeer, ßt_,
   {{0x44295a1b,0x7c299151,0x61e1b723,0x6d455a1c}},	//   _dea_, _meer, _hyll, huha,
   {{0x61e18364,0x7c29bd8e,0x6d454c5a,0x442902a6}},	//   _kyll, _leer, kuha, _eea_,
   {{0x91e611c7,0x44290216,0x61e1806a,0x395e0722}},	//   сове, _fea_, _jyll, ïts_,
   {{0x6d452e03,0x7c299e7e,0xa9281c18,0x3eb810e8}},	//   duha, _neer, _nižš, _smrt_,
   {{0x4fea0a13,0x57ea3296,0xe29a01a1,0x3872226d}},	// [5020] уман_, удам_, _бап_, rdyr_,
   {{0x645bda1d,0xb7bd8087,0xb87b046d,0x44295447}},	//   _abui, gaţi, _akíd, _zea_,
   {{0x7c29b3c3,0x6d455a1e,0x69158197,0x2b5f8493}},	//   _beer, guha, _jġed, _apuc_,
   {{0x0446c9a1,0x395e8118,0x308601a8,0x645b8706}},	//   седн, _rpts_, _الحف, _cbui,
   {{0xe29aa84d,0x61e18144,0x7c299f74,0x7f44076b}},	//   лад_, _ayll, _deer, quiq,
   {{0x6d4520d9,0xb7bd802e,0x29025a1f,0x7d1a816b}},	//   buha, caţi, _hika_, ypts,
   {{0xfce69628,0x29021c00,0x61e18114,0x6d450683}},	//   _гово, _kika_, _cyll, cuha,
   {{0x29020fc7,0x7c29927b,0x26da04be,0xb4c4114f}},	//   _jika_, _geer, lopo_, ्वो_,
   {{0x44295a20,0x29025559,0x644d5a21,0x7e2a902a}},	//   _rea_, _mika_, _rcai, ліна_,
   {{0x61e19808,0x2902101f,0xed4f0117,0x644d00f7}},	//   _fyll, _lika_, _تھے_, _scai,
   {{0x44290074,0x61e1a9dc,0x7c299a25,0xe0d6a306}},	//   _pea_, _gyll, _yeer, _людь,
   {{0x7c298079,0xb7bd8087,0xf1c000ff,0xb5fb00be}},	//   _xeer, zaţi, _ương_, טליכ,
   {{0x44295a22,0x26da074b,0xdd398087,0x5f94891e}},	//   _vea_, kopo_, tăţe, _филт,
   {{0x29025a23,0x6d45234d,0x44295a24,0x0db98065}},	//   _aika_, yuha, _wea_, ائیں_,
   {{0x51841980,0x290209d8,0x30a7310c,0x3211009a}},	//   пута, _bika_, брав, rczy_,
   {{0xfd4d0028,0x25ef146d,0x2bda0c1c,0x3ebeaebd}},	//   _thoạ, _अरबी_, _युवा, litt_,
   {{0x59df8c78,0x29020870,0x7cff00eb,0xb7bd8087}},	// [5030] _पुनर, _dika_, _jūrm, taţi,
   {{0x6d4550fd,0x7c29da25,0x2aab813c,0xdef811e9}},	//   tuha, _seer, _købe_, бых_,
   {{0x6285110f,0xb7bd802e,0x29024b0b,0xb87b01a8}},	//   _inho, raţi, _fika_, _dhír,
   {{0xa3bd0bb8,0x29025a26,0x3ebeda27,0x27e60035}},	//   _आधा_, _gika_, hitt_, żona_,
   {{0x7c299316,0x6eef806a,0x2aab806a,0xb87b01a8}},	//   _veer, løbe, _løbe_, _fhír,
   {{0x7c298c11,0x61e1da28,0x78ad04dc,0x236d807a}},	//   _weer, _pyll, lhav, _vsej_,
   {{0xd9f90063,0xa2d28013,0x9d180463,0x7c29da29}},	//   ंधित_, بيوت, _гост_, _teer,
   {{0x78ad0022,0x7f598073,0xa3d48c28,0x6009a344}},	//   nhav, ајот_, _सुक_, шним_,
   {{0xdddc07d9,0xfa0100c8,0x7d0a82af,0x442fda2a}},	//   _karş, ্রিল_, _aufs, mag_,
   {{0x86998049,0x3ebe804a,0x61e1da2b,0xe5098129}},	//   ртит_, gitt_, _tyll, _dặn_,
   {{0x2ca91de6,0xaca380ff,0xdddc0380,0xf1a7917f}},	//   _blad_, _chủn, _marş, _уран,
   {{0x644b8cef,0x442fda2c,0x2b40ba71,0x2299da2d}},	//   nggi, nag_, šice_, _tèks_,
   {{0xee2e9c82,0x29025a2e,0x26da004f,0x7cd200eb}},	//   _он_, _rika_, yopo_, vārd,
   {{0xe5a59860,0x60c99412,0x6da5a748,0x290258f2}},	//   _мили, lnem, _мила, _sika_,
   {{0x40962155,0x29025a2f,0x442f833e,0xc61681c6}},	//   орат, _pika_, kag_, _וחצי_,
   {{0xd0071e7d,0x60c9da30,0x02b68eed,0x6f03da31}},	//   жете_, nnem, _अग्न, _hinc,
   {{0x39478032,0x60c980e7,0x62970118,0x29025a32}},	// [5040] huns_, inem, _foxo, _vika_,
   {{0x290202b8,0xc9664cfc,0x41c9816f,0x7ea00106}},	//   _wika_, _двой, िपास, _köpi,
   {{0x29020029,0x7d043735,0x78ad30ba,0x60dbd31e}},	//   _tika_, _kiis, bhav, koum,
   {{0x23770bca,0x78ad1075,0x60c98933,0x26da15d0}},	//   _امید_, chav, jnem, sopo_,
   {{0xa3d483b7,0x60db8289,0x7d040079,0x26da010c}},	//   _सुख_, doum, _miis, popo_,
   {{0x6f038065,0x644b8081,0x7d041f61,0x7c2f01e8}},	//   _ninc, aggi, _liis, zacr,
   {{0xa2cd0b6f,0x3947855a,0x64a69878,0x40348973}},	//   _सदस्, guns_, _дава, пейс,
   {{0x7cf18e23,0x290280f2,0x60c9da33,0x7d04037b}},	//   gård, öka_, gnem, _niis,
   {{0x6f03da34,0xdb2480d5,0xe6669f72,0x49110074}},	//   _binc, _روای, отно, _दूनो_,
   {{0x7c229277,0x7d04008e,0x39478187,0x6f03af96}},	//   lbor, _aiis, buns_, _cinc,
   {{0x3ebeb611,0x867b03c8,0x6f03da35,0x291a816b}},	//   ritt_, בריו, _dinc, ípad_,
   {{0x7d0d803e,0x7c22a22f,0x1b1d80ab,0x6b8200eb}},	//   _čast, nbor, _নিতে_, _šoga,
   {{0x7c2f2eaa,0xfe6f803d,0x6d41da36,0x2ca92d7b}},	//   racr, ردی_, arla, _vlad_,
   {{0x7c2f0baf,0xaabc83eb,0xaca3da37,0x2ca90114}},	//   sacr, ्चिक, _ihụn, _wlad_,
   {{0x290cda38,0x442fa6bc,0x28c70f12,0x644bb6bd}},	//   _juda_, yag_, रचलि, yggi,
   {{0x261685b3,0x290ca5eb,0x6d4887d5,0xa3aa809a}},	//   पुरी_, _muda_, muda, खना_,
   {{0x9f59581e,0x6d48da39,0x6297002a,0x7c22b839}},	// [5050] _også_, luda, _toxo, dbor,
   {{0xdddc0086,0x60c0d699,0x442f849f,0x62850118}},	//   _qarş, himm, wag_, _unho,
   {{0x442fda3a,0x6d48da3b,0x7c2d015d,0xd6d81138}},	//   tag_, nuda, _kear, іту_,
   {{0x7c22a294,0xb4d5809a,0x7d040079,0x60db8118}},	//   gbor, सके_, _xiis, xoum,
   {{0x442f9839,0xdfc68013,0x6d4884b9,0x7cf1816d}},	//   rag_, _أي_, huda, vård,
   {{0x38691e07,0x7ead81ac,0x6d48da3c,0x442fda3d}},	//   lear_, _kúpe, kuda, sag_,
   {{0x81dd00c8,0x6d48da3e,0x442f9882,0x6f03da3f}},	//   তের_, juda, pag_, _rinc,
   {{0x386945e3,0x290c965f,0x6f03da40,0x39478187}},	//   near_, _duda_, _sinc, runs_,
   {{0x60c9da41,0x7c3ba266,0xea0000ff,0x7d041987}},	//   rnem, _idur, _phẫu_, _riis,
   {{0x38690c49,0x0ea98364,0x7d045a42,0x60c9c5e8}},	//   hear_, ской_, _siis, snem,
   {{0x442dda43,0x290c80a4,0x7d041e71,0x7c2d5a44}},	//   _kee_, _guda_, _piis, _bear,
   {{0x7c2d061f,0x442d84cd,0x6d41da45,0x895a9101}},	//   _cear, _jee_, rrla, _לדעת,
   {{0x442dda46,0x7c2d061f,0xdd8e8bca,0x7d04043d}},	//   _mee_, _dear, نوی_, _viis,
   {{0x290c82ec,0xfaa6076a,0x7c2d0362,0x442d81c6}},	//   _yuda_, чаго, _eear, _lee_,
   {{0xd1790cde,0x2bdc1551,0x64a6140b,0x703a0364}},	//   ості_, _गुरू_, _нака, йчас_,
   {{0x7c2d003c,0x442d85f8,0x38691c9d,0xb4d58023}},	//   _gear, _nee_, gear_, सको_,
   {{0xee3a0973,0x237f8282,0x78a40687,0x7c22da47}},	// [5060] йна_, _nruj_, rkiv, vbor,
   {{0x7c3b84be,0x6b7b010f,0x78a45a48,0x60c081ec}},	//   _adur, _פרינ, skiv, zimm,
   {{0x929b0051,0x7c2d4380,0xe29b0039,0x6abe1e5a}},	//   _היית, _year, _השיר, _impf,
   {{0x442dda49,0xb4d68076,0x38695a4a,0x2fcd0115}},	//   _cee_, हवे_, cear_, _žege_,
   {{0x442d8d10,0x290c8503,0x7c22da4b,0x1ddd816f}},	//   _dee_, _suda_, rbor, _नुसत,
   {{0x3ce6ad6d,0x6d48da4c,0x7c3bda4d,0x3f808110}},	//   slov_, yuda, _edur, _šiuo_,
   {{0x3ce682a5,0x395800eb,0x82338019,0x60c0da4e}},	//   plov_, ntrs_, رروا, timm,
   {{0x6e2e0586,0xb05b00f2,0x442dda4f,0x25ae0214}},	//   _hebb, _hjär, _gee_, ıklı_,
   {{0xd6da8698,0x60c0da50,0x7f441571,0x7d0e40c5}},	//   йто_, rimm, nriq, _hubs,
   {{0x7c2d5a51,0x6d48da52,0x60c08364,0x290c80d2}},	//   _sear, tuda, simm, _tuda_,
   {{0x7c2d0ad0,0x63a2da53,0x442dda54,0x6288b3e1}},	//   _pear, lyon, _yee_, _indo,
   {{0xd5b78196,0x0cab00b3,0x7cff0110,0x6d48905f}},	//   ясы_, стои_, _kūri, ruda,
   {{0x6d489283,0x629ad01e,0x7d0e5a55,0x7eadda56}},	//   suda, _koto, _lubs, _súpe,
   {{0x27e682b8,0x6e2e571d,0x7f445a57,0x629ada58}},	//   _iyon_, _nebb, driq, _joto,
   {{0x30a7091c,0x38690013,0x26de9fb6,0x7e750db7}},	//   прав, tear_, moto_, _razp,
   {{0x61e5003e,0x6abe0352,0x25e0009a,0x629ac374}},	//   _vyhl, _empf, _कड़ी_, _loto,
   {{0x4c3c0051,0x442dae28,0x628880ad,0xb4d90740}},	// [5070] _התחב, _ree_, _ondo, ़की_,
   {{0x442d9d6f,0x38691995,0xcb1400be,0x63a2b36a}},	//   _see_, sear_, _אלץ_, dyon,
   {{0x38695a59,0x6e2e2d08,0x442dc5b4,0x27e69dac}},	//   pear_, _debb, _pee_, _lyon_,
   {{0x628899fd,0x7f445a5a,0x26deda5b,0x442d81c5}},	//   _ando, briq, hoto_, _qee_,
   {{0x6e2e0098,0x26deda5c,0xb05b016d,0xe29992ea}},	//   _febb, koto_, _fjär, жал_,
   {{0x442d882e,0x91e58ada,0x629ad94c,0xfc3f05bf}},	//   _wee_, моле, _coto, chív_,
   {{0x442d94c7,0x27e682b8,0xac1985e9,0x629ada5d}},	//   _tee_, _ayon_, _мову_, _doto,
   {{0x60cd3c2c,0x26ccda5e,0x92bf80c8,0x63a2a6e8}},	//   nnam, endo_, ীতে_, byon,
   {{0x26deda5f,0x2d98da60,0x60cd5a61,0xa8068661}},	//   foto_, ären_, inam, _riñó,
   {{0x2489198d,0xddc88612,0x68e2da62,0x6f0f047f}},	//   _anam_, cedū, _ekod, _mucc,
   {{0x04460b79,0x8c4610ee,0x6f0f0081,0xa8068333}},	//   менн, мене, _lucc, _piñó,
   {{0x6f0701c0,0x629ab6c4,0x98bc8110,0x38c3826b}},	//   _lijc, _zoto, tuvą_, _dèrè_,
   {{0x7ea0016d,0x68e984dc,0x26deda63,0x629ada64}},	//   _köpt, mled, boto_, _yoto,
   {{0x65c59383,0x68e9a862,0xddc590ef,0x24895a65}},	//   _обла, lled, _обли, _enam_,
   {{0x81e600c8,0x91e32885,0x09e30139,0x35fb82e3}},	//   বেন_, воре, ворн, _ارشد_,
   {{0x2a6a0065,0x60cd342c,0x20fa0a0d,0x6f0f2c5b}},	//   sebb_, gnam, ्देश_, _bucc,
   {{0x6f0f35ae,0x65690267,0x395800eb,0x63a00106}},	// [5080] _cucc, _ćeha, strs_, ämnd,
   {{0x2489003a,0xee3a0110,0x290c1313,0x68e9800d}},	//   _znam_, іне_, ídas_, hled,
   {{0xd00a3de7,0xed5707a1,0xd82611d2,0x60264c54}},	//   _мене_, дох_, _одни, _одна,
   {{0x6e2e5a66,0x68e9813c,0x2eaa809a,0x60cd00f7}},	//   _webb, jled, _छत्त, cnam,
   {{0x41c383eb,0x68e9bb28,0x99878390,0xb05b1cab}},	//   _वेबस, dled, vanš_, _tjär,
   {{0x2ca6a699,0x6d4300f7,0x60c4254a,0x7d0e022c}},	//   skod_, ánac, liim, _tubs,
   {{0x63a2ba7f,0x629aa6de,0xde030676,0x6f0f0081}},	//   syon, _voto, _апри, _zucc,
   {{0x68e9805c,0x88bc801b,0xa77484fa,0x7cff00eb}},	//   gled, _hvěz, елич, _tūri,
   {{0x4426afe0,0x629aa698,0x26de822e,0xb4bc816f}},	//   mbo_, _toto, toto_, ेची_,
   {{0x60cd1807,0x4426da67,0x7e9880f7,0x60c401b4}},	//   znam, lbo_, سنجر_, hiim,
   {{0x68e9da68,0x26deb383,0x60c45a69,0x60cd5a6a}},	//   bled, roto_, kiim, ynam,
   {{0x4426bdc2,0xb4d9000f,0x26de948e,0xb87b0091}},	//   nbo_, ़के_, soto_, _akín,
   {{0x80c1104f,0x26dea726,0x78a30087,0x25088019}},	//   रोफे, poto_, _învi, _کرتی_,
   {{0xe7e2000f,0x45d48572,0x26de81b4,0x68e0913b}},	//   _खड़ा_, _полс, qoto_, lomd,
   {{0x31c40a29,0x6f0f3206,0x442697ea,0x60cd5a6b}},	//   вств, _succ, kbo_, tnam,
   {{0x2d5880e7,0x24895a6c,0x61e8d275,0x60cd31c2}},	//   mée_, _unam_, _mydl, unam,
   {{0x4426da6d,0x2d5882be,0x2ca40106,0xa3c2073c}},	// [5090] dbo_, lée_, ömde_, ्पण_,
   {{0x05eb0003,0x60cd5a6e,0x44269262,0x7ead80e1}},	//   офеи_, snam, ebo_, _kúpa,
   {{0x2d5883d3,0x403504db,0x7ae509da,0x68e9da6f}},	//   née_, _пенс, _ikht, yled,
   {{0x6d5a8364,0x4426da70,0x3f820699,0xb4bd01ab}},	//   itta, gbo_, _frku_, _इगो_,
   {{0x291e8528,0x27ff0036,0x2d588036,0x6ef8019d}},	//   _atta_, _àun_, hée_, ụbar,
   {{0x61e8827f,0xef1f02d0,0x4426b3c3,0xa3c20beb}},	//   _bydl, _itü_, abo_, ्पत_,
   {{0x4426ca9a,0x68e9da71,0x387900fc,0x6d5ada72}},	//   bbo_, tled, _kasr_, jtta,
   {{0x2d5880e7,0x2aad04e8,0xd7ca8035,0x69d70609}},	//   dée_, ržby_, ापंच, _mxxe,
   {{0x68e9800b,0x443f803a,0x68fb89ec,0x41df873c}},	//   rled, _idu_, rmud, _पुरस,
   {{0xf1a79fb4,0x7d09da73,0x2d7e82a6,0x6d5a9388}},	//   _орен, _hies, _bċe_, ftta,
   {{0x7d0991d4,0x35a5a597,0x2d5880e7,0x6cc601e2}},	//   _kies, ханг, gée_, ейна,
   {{0x7cf61e1e,0x7c2d808b,0x7fd58084,0x443f928a}},	//   káre, ðarh, _пілі, _jdu_,
   {{0x7d09da74,0x7655009a,0x6d5a853b,0x386dc767}},	//   _mies, _oczy, atta, meer_,
   {{0x386d80c9,0x78a9d043,0x7cf625ce,0x44268824}},	//   leer_, lkev, dáre, zbo_,
   {{0x6d5abfc7,0x2d5880e7,0xddc3c573,0x60c43236}},	//   ctta, cée_, _hanž, tiim,
   {{0xef1a039d,0x7d09da75,0x7afc0503,0x78a9b1c2}},	//   зма_, _nies, smrt, nkev,
   {{0x60c40ec8,0x068601a1,0x2b4600f7,0x645600b4}},	// [50a0] riim, нган, _íoc_, _icyi,
   {{0xddc3803e,0x386d9e94,0x60c45a76,0x443fc0bb}},	//   _manž, heer_, siim, _adu_,
   {{0x386d867f,0x443235db,0x78a983ba,0x6da318d1}},	//   keer_, _key_, kkev, лифа,
   {{0x6b840370,0x26c5bc47,0x3f820b67,0xb4bc816f}},	//   _krig, hilo_, _trku_, ेचे_,
   {{0x7d09da77,0x386dda78,0xaca3801c,0x07a34688}},	//   _dies, deer_, _giọn, _баян,
   {{0x443205b4,0xc3330051,0x4426da79,0x6d5aaf9c}},	//   _ley_, רוג_, sbo_, ytta,
   {{0x7d0986a5,0x2bc080d4,0x044680e8,0x09068162}},	//   _fies, _शेरा, _певн, нчим,
   {{0x386d9aee,0x2d5882be,0xa3c2016f,0x7d09da7a}},	//   geer_, vée_, ्पा_, _gies,
   {{0x26c58098,0x3f829d9a,0x68e3009f,0x68e0b45e}},	//   filo_, íku_, _índe, romd,
   {{0xc6f793cd,0x61e880f2,0x2d5882be,0x629e5a7b}},	//   нных_, _tydl, tée_, _nopo,
   {{0xceb30bea,0x386d90f4,0x2f16006a,0x6b845a7c}},	//   רית_, beer_, _læg_, _arig,
   {{0x2d5883d3,0x61e48214,0x6d5ac530,0xac1900e8}},	//   rée_, ğild, rtta, ьому_,
   {{0x2d5883d3,0xdcf58063,0x60c2da7d,0x629e5a7e}},	//   sée_, _urzą, _imom, _bopo,
   {{0xda1085b3,0x629e5a7f,0x2d9884d6,0x2d588036}},	//   ाशित_, _copo, øres_, pée_,
   {{0x81e28a49,0x629e5a80,0x6440a101,0x6b845a81}},	//   নের_, _dopo, _odmi, _erig,
   {{0x6b840f3b,0xb4da800d,0x61e58192,0x2e46826b}},	//   _frig, ठको_, ühli, _fífà_,
   {{0x7d09900a,0x6b8430c6,0xf77300d5,0x84640098}},	// [50b0] _ries, _grig, داز_, _съще,
   {{0x443f8392,0x7ae500dd,0xf1b0856b,0x752d809a}},	//   _sdu_, _ukht, जनान, _łazi,
   {{0x7d09da82,0x387901ac,0x60c2ab5f,0x753a94cf}},	//   _pies, _tasr_, _omom, nstz,
   {{0x6b840144,0x7cf61727,0x38b18061,0xef1f06ae}},	//   _yrig, márc, _márc_, _ttü_,
   {{0x7d09da83,0x889a0bea,0x68ed55ee,0x386d85f8}},	//   _vies, _חברי, mlad, veer_,
   {{0x386d837a,0x7d09da84,0x290b01a1,0x236900b9}},	//   weer_, _wies, _hica_, _mpaj_,
   {{0x7d099e1f,0x26c5935a,0x386d837a,0x68ed5a85}},	//   _ties, vilo_, teer_, olad,
   {{0x443fda86,0xb7f514fc,0xd6c400ab,0x290b5a87}},	//   _udu_, _आराम_, ্তৃপ, _jica_,
   {{0x386dba61,0x290b5a88,0x68ed5a89,0x4432020a}},	//   reer_, _mica_, ilad, _rey_,
   {{0x290b003b,0x386d92af,0xa68299b8,0x38b514a2}},	//   _lica_, seer_, альд, _hård_,
   {{0x68ed1385,0x26c5be2a,0x19ab97ae,0x249f8176}},	//   klad, rilo_, _этап_, _koum_,
   {{0x629e0511,0x26c5bb4f,0x7cea81fa,0x68ed0efa}},	//   _sopo, silo_, týri, jlad,
   {{0xeb971bba,0x629e378d,0x2d988bc5,0x6d48da8a}},	//   вия_, _popo, ører_, arda,
   {{0xc3328039,0x61e48214,0x7cf8b49a,0x443201b4}},	//   שום_, şile, míre, _wey_,
   {{0x20563d5a,0x68ed5a8b,0x291301df,0x6cda1194}},	//   ктар, flad, _cuxa_, _офис_,
   {{0x2055116b,0x7ae3da8c,0xe3b2003d,0x290b330c}},	//   лтур, hont, _نرخ_, _cica_,
   {{0x629e5a8d,0x290b5a8e,0xb2261860,0x15f402f1}},	// [50c0] _topo, _dica_, _импл, _अरहर_,
   {{0x68ed5a8f,0x3f8013bd,0x248d9b09,0x386011ee}},	//   alad, rviu_, _anem_, sfir_,
   {{0x200f8698,0x290b5a90,0x7ae38822,0x672405f3}},	//   _oggi_, _fica_, dont, spij,
   {{0x67242948,0x68ed0fba,0x673bcbf4,0xb7340019}},	//   ppij, clad, ksuj, _مہرب,
   {{0x7ae3da91,0x2bc8016f,0xdbcc8118,0x68e45a92}},	//   font, रपटा, _póño, moid,
   {{0x7ae38aa8,0x248dda93,0x29000009,0xe73704ae}},	//   gont, _enem_, lmia_, _јер_,
   {{0x2913041c,0xa9678195,0x2ab40799,0x290b0a03}},	//   _xuxa_, вија_, _gäbe_, _yica_,
   {{0x7e7c5a94,0x7cf881df,0x68e45a95,0x64a39f72}},	//   _harp, fíre, noid, _каса,
   {{0xb50c09a3,0x64a389c7,0x1306853b,0xdca38493}},	//   _संजय_, _тата, _азам, _тати,
   {{0xa3e605b3,0x3c320142,0x7ae39ee5,0x68e407b8}},	//   _बुध_, _được_, cont, hoid,
   {{0x68ed3843,0x6d489de6,0x68e45a96,0x2ab08032}},	//   ylad, urda, koid, _gàba_,
   {{0x249f07ca,0x7e7c002a,0x68e40198,0x7cf881d0}},	//   ðum_, _larp, joid, bíre,
   {{0xe0b78158,0xdb580d70,0x6b8280e5,0x7f4983a8}},	//   _בלאט_, кюр_, nvog, creq,
   {{0x68ed02c1,0x290b10e4,0x1ddd816f,0x29005a97}},	//   wlad, _sica_, _नुकत, emia_,
   {{0x79a4117e,0xb50c00c2,0xf1a40a08,0x623412b2}},	//   арте, _संचय_, артн, ресу,
   {{0x38b1d7bb,0x645504ae,0x6b828140,0x6f0d80e5}},	//   _kára_, _свиђ, kvog, _èacc,
   {{0x44395a98,0x68ed5a99,0x57f5079e,0xc6f90329}},	// [50d0] mas_, rlad, упат, енах_,
   {{0x68ed386d,0xa3c2146d,0x7d0d2b36,0x29130118}},	//   slad, ्पर_, _hias, _tuxa_,
   {{0x68ed5a9a,0xe7e3000d,0x7d0d022e,0x7e7c031d}},	//   plad, _कुरा_, _kias, _darp,
   {{0x44390f29,0x73d994f6,0x442b151e,0x78b60110}},	//   nas_, ндер_, nbc_, chyv,
   {{0x44395a9b,0x7d0d0063,0xe3b080a0,0x7ae3ad71}},	//   ias_, _mias, يره_, tont,
   {{0x44394250,0x7ead80f7,0xddce0019,0x78ad0254}},	//   has_, _cúpl, _ebbő, lkav,
   {{0x44391db4,0x260212ee,0xceb200be,0x2d9c0edd}},	//   kas_, वेदी_, _פיל_, øvet_,
   {{0x4439252a,0x7ae3da9c,0x6e355a9d,0x7e7c0c43}},	//   jas_, sont, _hezb, _zarp,
   {{0xe50a0104,0xa6e58162,0x7ae3da9e,0x0fca809a}},	//   _mặt_, лжил, pont, ापगढ,
   {{0x63a48009,0xc7b98019,0x1ab795bc,0xe3b0853d}},	//   äine, rző_, _अतिथ, _برف_,
   {{0x64a619b8,0x3cca091e,0x78ad3ae2,0x60559a3c}},	//   гана, елно_, kkav, _مناط,
   {{0x44395a9f,0x7d0d5aa0,0xb4de016f,0x38b18b4e}},	//   gas_, _cias, तके_, _fára_,
   {{0x889a812a,0xf7459dc7,0x387fd1ee,0x60c9d96b}},	//   _רבני, _село, mdur_, miem,
   {{0x387f8125,0x7f3a810f,0x60c98791,0x3866daa1}},	//   ldur_, _טענו, liem, _zbor_,
   {{0x44395aa2,0xa06a1a1a,0x1a6602e3,0x3916003d}},	//   bas_, нава_, نیکی_, اورز,
   {{0x443907a3,0x387fdaa3,0x7d0d0420,0x2d5c06a5}},	//   cas_, ndur_, _gias, víe_,
   {{0x6e351487,0xa4fb0039,0x0e6600c4,0x44205413}},	// [50e0] _bezb, _אלקט, лкан, _ifi_,
   {{0x7c364c6c,0x7643808e,0x387d8114,0x42560162}},	//   _heyr, _jdny, _lawr_, _стит,
   {{0xa9a60d9e,0x6e350087,0x60c99c28,0x7d0d022c}},	//   _синд, _dezb, kiem, _yias,
   {{0x6d5e5aa4,0x6adc8a27,0x7c360326,0x387d8114}},	//   rtpa, मक्र, _jeyr, _nawr_,
   {{0x7e7c0b71,0xfaa6a84d,0x387fcc6c,0x44200300}},	//   _tarp, ладо, ddur_, _mfi_,
   {{0x44395aa5,0x38b5035f,0x6b82daa6,0x442001e0}},	//   zas_, _våre_, rvog, _lfi_,
   {{0x6722c5f4,0x81e600c8,0x38b18b4c,0x44202b5f}},	//   _stoj, বের_, _sára_, _ofi_,
   {{0xb4de000d,0xa96780f7,0xfce6806d,0x3f868722}},	//   तको_, اميم_, _собо, _prou_,
   {{0xdfd080f7,0x2d87920b,0x7d0d0e6c,0xddcf811f}},	//   تية_, _arne_, _rias, _češa,
   {{0x44395aa7,0x44204a34,0x7d0d4bad,0x3f86879f}},	//   was_, _afi_, _sias, _vrou_,
   {{0xa9269b10,0x2d87803b,0x387d831d,0x8b03801b}},	//   _сдел, _crne_, _fawr_, ířen,
   {{0x60c9daa8,0xd5b797d4,0x3f86daa9,0xab5b0061}},	//   ciem, усь_, _trou_, nzüg,
   {{0x44392d2a,0x2d87daaa,0x9990012b,0x7c3610ea}},	//   ras_, _erne_, _čaše_, _deyr,
   {{0xbda688ca,0x78a29c1d,0x3ce69d43,0x8c3d8085}},	//   _محبو, _hoov, hoov_, _xoşb,
   {{0x7d0d01c0,0x2b40803e,0xc693807c,0x7cf65aab}},	//   _tias, šich_, _לאס_, márn,
   {{0x7cf603fb,0x6e3adaac,0x443904b7,0x7d028c83}},	//   pára, latb, qas_, jmos,
   {{0x96350e0b,0xe50a0028,0x611c007a,0x81e60264}},	// [50f0] инац, _vặt_, _včla, বেল_,
   {{0xd251019f,0x78ad5aad,0x7cf60e93,0xda190ebf}},	//   _بند_, skav, nárn, _दलित_,
   {{0x7ae7003a,0x2d870df0,0x6e35025b,0xdd1e016b}},	//   mojt, íne_, _vezb, _píše,
   {{0x81cd80c8,0x611c0eef,0x387f8201,0x52dd903e}},	//   রথম_, _učla, xdur_, यव्स,
   {{0x60c9bdc9,0x2d9c0aa2,0xa85604de,0x7cf6026f}},	//   viem, øver_, _דירה_, kárn,
   {{0xddda8065,0xae048ebf,0x38a702f1,0x6925a5af}},	//   hető, रधान_, _võru_, амка,
   {{0x746b9980,0x60c9bbd9,0x59df8074,0xa5f80ba1}},	//   _прав_, tiem, _पुखर, _беру_,
   {{0x6aa180ed,0x52d20fb8,0xe7f08fb2,0xcf458037}},	//   _wolf, _सद्स, _चरखा_, аний,
   {{0x44205aae,0x60c9daaf,0x6e3a826c,0x387fd96d}},	//   _rfi_, riem, fatb, rdur_,
   {{0x4d658dc8,0x60c9dab0,0xb05b016d,0x7c361d5a}},	//   аков, siem, _smäl, _seyr,
   {{0xcc8a003d,0x9962816b,0xd9998290,0x60c9dab1}},	//   ننده_, píše_, _جنات_, piem,
   {{0x38589a37,0x7c360085,0x6b89ac00,0x2d8782d4}},	//   _مشهد_, _qeyr, _kreg, _vrne_,
   {{0x6e3a8420,0x7c290b5a,0x7643808e,0x290f81b4}},	//   batb, ñera, _tdny, _iiga_,
   {{0xceb8809a,0x7643806a,0xab272503,0x290f82c4}},	//   chę_, _udny, рора_, _higa_,
   {{0xe2972e15,0x7c360428,0x81138264,0x61ed89ab}},	//   шар_, _teyr, _সবুজ_, ƙalu,
   {{0x290f96ea,0xdd2f001b,0xa01b18b6,0x3ce68282}},	//   _jiga_, _běžn, _snör, xoov_,
   {{0xe8012e2b,0xc87f02af,0x1fa71cd5,0x7cf600e1}},	// [5100] लेला_, _daß_, акти_, láro,
   {{0x645b9727,0xda660396,0x27f28163,0x63ab8338}},	//   _acui, _твои, _øyne_, dygn,
   {{0x7cf603b0,0x2480022c,0x6b89dab2,0x290f8216}},	//   náro, _kaim_, _areg, _oiga_,
   {{0xb4c42cdd,0x6b8992ed,0x232aa748,0x248000dd}},	//   _एगो_, _breg, води_, _jaim_,
   {{0x93778013,0x6b89dab3,0x24800282,0xf74604ae}},	//   لصور_, _creg, _maim_, _њего,
   {{0x78a28006,0x3ce681c5,0xddda8019,0x24800282}},	//   _soov, soov_, zető, _laim_,
   {{0x7cf603c1,0x6b898314,0x290fdab4,0x6e3a8061}},	//   várn, _ereg, _biga_, vatb,
   {{0x645b8013,0x7afd80eb,0x7cf8801b,0x63ab8edd}},	//   _gcui, _īste, bíra, bygn,
   {{0x290fb736,0x7c2ddab5,0x7cf60c83,0x6569026c}},	//   _diga_, ñare, tárn, _ćehi,
   {{0x4aaa85fc,0x290f8357,0x27ef8106,0x1b1d8264}},	//   _कविव, _eiga_, _dygn_, _নিচে_,
   {{0x7cf6026f,0x7cfd282c,0x290f8b57,0x2480123c}},	//   rárn, hére, _figa_, _baim_,
   {{0x290f84be,0x55770158,0x7cf60019,0x49110074}},	//   _giga_, בעטן_, sárn, _दूगो_,
   {{0x248001e9,0xe8d78039,0xa2bd8a27,0xbbd12730}},	//   _daim_, _דואר_, वोक्, सपेक,
   {{0x290f8133,0x7cfd0036,0x61ed8326,0x175783de}},	//   _ziga_, dére, ƙalt, _כסדר_,
   {{0x7ae700f1,0x6ac49885,0x4de6016f,0x290fdab6}},	//   rojt, _वगैर, _जुलै_, _yiga_,
   {{0x7cfd02be,0x2d850118,0x290f0f02,0x290f8df6}},	//   fére, _álei_, öga_, _xiga_,
   {{0x69de3f55,0x7d1881c0,0xb8cf03ca,0x7ae7016b}},	// [5110] _expe, _huvs, _कव_, pojt,
   {{0x26cc9fd1,0x6b89820f,0x7c3d0387,0x7f4d0980}},	//   nido_, _rreg, lasr, rraq,
   {{0x68e3157a,0x641581a8,0xaadc01c6,0xafdb2419}},	//   _índo, مواط, _בחזר, _idøm,
   {{0x40950013,0x8c3d861c,0x2480022c,0x88bc81d0}},	//   _الحر, _boşa, _xaim_, _stěn,
   {{0x26cc8637,0x7cf65ab7,0x290fdab8,0x21258101}},	//   kido_, záro, _riga_, _stlh_,
   {{0x60cd4079,0x290f80a2,0x26cc86a5,0xe50a0129}},	//   liam, _siga_, jido_, _lặp_,
   {{0x26cc8510,0x290f8245,0x272380e1,0x7cf6002a}},	//   dido_, _piga_, kčný_, xáro,
   {{0x60cd1c28,0x6b89820f,0x3949c589,0x2602016f}},	//   niam, _treg, čas_, वेळी_,
   {{0x6b89dab9,0x443ddaba,0x290f82f1,0xea0000ff}},	//   _ureg, maw_, _viga_, _thầu_,
   {{0x443dd2fb,0xe8e00028,0x7cf60065,0x7ead81ac}},	//   law_, _đọc_, táro, _kúpi,
   {{0x290f8812,0x60cd01e2,0x3cff8069,0x248001c0}},	//   _tiga_, kiam, _khuv_, _paim_,
   {{0x6459dabb,0x62819b7b,0x7cf65abc,0x443d8948}},	//   ngwi, _halo, ráro, naw_,
   {{0x26cc9984,0x60cd15a4,0x24805abd,0x68e9b986}},	//   bido_, diam, _vaim_, moed,
   {{0x26cc9313,0x443ddabe,0x26c79083,0x68e98114}},	//   cido_, haw_, _umno_, loed,
   {{0x6281a6fd,0x443ddaba,0x60cd5abf,0x24805ac0}},	//   _malo, kaw_, fiam, _taim_,
   {{0x7cfd07bc,0xe50a0028,0x6281dac1,0x443d81b9}},	//   tére, _gặp_, _lalo, jaw_,
   {{0x7c245ac2,0x2d8a10d3,0x98a30758,0xddd5007a}},	// [5120] _ifir, _srbe_, чите, _razš,
   {{0x38b504b8,0x6281c724,0x68e98355,0x81e280ab}},	//   _våra_, _nalo, hoed, নেট_,
   {{0x99860013,0x60cd0098,0xc27b00be,0x6d41dac3}},	//   _الجو, biam, _גריי, nsla,
   {{0x26cc83a7,0x443d8948,0x7cfd272b,0x6281dac4}},	//   zido_, gaw_, mérc, _aalo,
   {{0x44270086,0x68e9831d,0x44220326,0x7cf60376}},	//   _ən_, doed, ick_, járm,
   {{0x26cc862f,0x6d41dac5,0x2480883d,0x62838267}},	//   xido_, ksla, žim_, gdno,
   {{0x443dc341,0x26cc9820,0x6281c000,0x7c242f00}},	//   baw_, vido_, _dalo, _ofir,
   {{0xa3b81299,0x6d4184fe,0x236984b7,0x68e9dac6}},	//   चना_, dsla, ħajr_, goed,
   {{0x26cc8510,0x291a4518,0x6281dac7,0x6d418cab}},	//   tido_, _lupa_, _falo, esla,
   {{0x6d419e75,0x7cf60065,0x60cd5342,0x877b03de}},	//   fsla, sárl, ziam, נאיי,
   {{0x26cc8510,0x7c2905e4,0x7cf8b37c,0x7c3b0789}},	//   rido_, ñero, níro, ðuro,
   {{0x6281885d,0x7c22b17d,0x7aea9384,0x2b40992c}},	//   _zalo, ncor, loft, šicu_,
   {{0x940301b6,0x26cc80a2,0x60cd3340,0x6e38bb65}},	//   रेंच_, pido_, viam, _tevb,
   {{0x2b448118,0x6281dac8,0x7c2f0118,0x7c24029a}},	//   _mvmc_, _xalo, sbcr, _efir,
   {{0x443d843b,0x60cd5ac9,0x291a33a5,0x7c2402a6}},	//   yaw_, tiam, _cupa_, _ffir,
   {{0x291a0012,0x7cf882b7,0x776401b9,0x26ca5aca}},	//   _dupa_, díro, ftix, _ambo_,
   {{0x60cd130f,0x7bda07d9,0xfc3f00f7,0x2aab813c}},	// [5130] riam, ştur, maí_, _købt_,
   {{0x765a8110,0xfc3f0013,0xd5bb0071,0x60cd5acb}},	//   ngty, laí_, лсе_, siam,
   {{0x443ddacc,0x7c240125,0x443b00f1,0x3cffc796}},	//   taw_, _yfir, _keq_, _phuv_,
   {{0xfc3f0307,0x6b8d5acd,0xaca3801c,0xb4e380dc}},	//   naí_, _krag, _miện, नके_,
   {{0xeb99838d,0x6281dace,0x68e9837a,0x20d3802e}},	//   рил_, _palo, voed, nţie_,
   {{0xfc3f0013,0x443d95d0,0x38695acf,0x7c22c9d7}},	//   haí_, saw_, lfar_, acor,
   {{0x442200f2,0x443ddad0,0x3cff822c,0xaa5684ae}},	//   yck_, paw_, _thuv_, цију_,
   {{0x7c22dad1,0x386900f7,0x81e600ab,0x7c3b008b}},	//   ccor, nfar_, বেক_, ðurl,
   {{0x6449c395,0x6281d089,0xef1691e9,0xfc3f00f7}},	//   _idei, _talo, омы_, daí_,
   {{0x7c3bdad2,0x823489d7,0xee39867c,0x6d419412}},	//   _heur, _فرما, шно_, tsla,
   {{0x6b8d14a3,0x7cd20029,0x7c3bdad3,0x6da595fe}},	//   _arag, kārt, _keur, цина,
   {{0x291a0886,0x6b8d51aa,0x44225ad4,0xfc3f01a8}},	//   _rupa_, _brag, uck_, gaí_,
   {{0x7c3bb92c,0xe7399980,0x6d41a0e4,0x2d98816d}},	//   _meur, _тел_, ssla, ärer_,
   {{0x291a0091,0x7c3b83d3,0x6b8d079a,0x6d4190aa}},	//   _pupa_, _leur, _drag, psla,
   {{0xed59b10c,0x6b8d011e,0x38695a05,0x64a64b60}},	//   _той_, _erag, ffar_, _мака,
   {{0x7c3bdad5,0xb4e383bb,0x7c2281df,0x6b8d4e3d}},	//   _neur, नको_, xcor, _frag,
   {{0xee3a05f1,0x3ea788c2,0xc31f80ab,0x20d3802e}},	// [5140] ина_, _kont_, নীতি_, cţie_,
   {{0x6449831d,0x291a11ca,0x7cfd03e6,0x7764002a}},	//   _adei, _tupa_, méra, rtix,
   {{0x7c3ba088,0x6e3e5ad6,0x77645ad7,0x3ea7cf42}},	//   _beur, rapb, stix, _mont_,
   {{0x61fe4102,0x7c3bdad8,0x2fc05ad9,0x672d01c0}},	//   _izpl, _ceur, pzig_, bpaj,
   {{0x7c22dada,0x7cfd03d3,0x7c3bb99a,0x75248052}},	//   rcor, néra, _deur, _čizm,
   {{0x7c22dadb,0x7cf883b0,0x6d5701df,0x68f65adc}},	//   scor, píro, buxa, llyd,
   {{0x44248118,0x7c3bcd10,0x7cfd39c6,0x7aea92ec}},	//   _tfm_, _feur, héra, roft,
   {{0x6e3c10f5,0x8f468c3e,0xddd8826f,0xbebb00f1}},	//   _herb, оход, _navš, _atëh,
   {{0xd6da8021,0x629e8364,0x24868bb1,0x7ead92ca}},	//   ито_, öpos, mdom_, _lúpu,
   {{0x3ea78012,0x2366b592,0x7cfd26ae,0x3eb8bb69}},	//   _cont_, mtoj_, déra, órt_,
   {{0xfc3f0307,0x691583bb,0x3ea78220,0x6e3c5add}},	//   taí_, _všec, _dont_, _merb,
   {{0x2486afbc,0xef1f0192,0x92da00ab,0x672d0282}},	//   ndom_, _früh_, ়তো_, ypaj,
   {{0x3ea781b3,0xfc3f0013,0x2bc5035a,0x395800e7}},	//   _font_, raí_, _लेखा, eurs_,
   {{0x6b8d02d8,0xfc3f0013,0xd6d9809a,0x6e3c5ade}},	//   _vrag, saí_, kuły_, _nerb,
   {{0x298815b5,0x2486dadf,0xfc3f01a8,0xca140081}},	//   осто_, kdom_, paí_, ддръ,
   {{0x7cfd232b,0xa3e6086a,0x27208242,0x92bd00ab}},	//   béra, _बुक_, _kòn_, েকে_,
   {{0x6e3c010b,0x38695ae0,0xb4e700c2,0x7c3b9c8f}},	// [5150] _berb, rfar_, बकी_, _reur,
   {{0x7c3b8364,0x2720dae1,0x612787d9,0x6e3c0114}},	//   _seur, _mòn_, _yıld, _cerb,
   {{0x628502c4,0x6e3c2ad1,0x7c3bdae2,0x6fdd06af}},	//   _iaho, _derb, _peur, _यशवं,
   {{0x645d04bf,0x7d1c3b19,0x248682fe,0x6abaa37e}},	//   ngsi, _durs, gdom_, _altf,
   {{0x62851efa,0x7c3b87e2,0x889a0039,0xd37b9a19}},	//   _kaho, _veur, _הברי, рче_,
   {{0x7d1c5ae3,0x6e3c2bee,0x63a0016d,0x29090198}},	//   _furs, _gerb, ämni, lmaa_,
   {{0xf2d40158,0x628522da,0x7c3b8a48,0x3ea798e8}},	//   ועס_, _maho, _teur, _ront_,
   {{0x3ea786e3,0x6e3c011e,0x6d452e14,0x38bc00f7}},	//   _sont_, _zerb, msha, _tíre_,
   {{0x27208104,0x6d4502a3,0x3ea7dae4,0x6e3c5ae5}},	//   _còn_, lsha, _pont_, _yerb,
   {{0x6285000d,0x92b780d5,0x7cf65ae6,0x260202f1}},	//   _naho, _بحرا, mári, वेकी_,
   {{0x6d455ae7,0x7cf631b0,0x3ea7dae8,0xbec301a9}},	//   nsha, lári, _vont_, _ķīli,
   {{0x7f4400e7,0xf2c900be,0x7cff0110,0x7cfd2d5d}},	//   ysiq, _גע_, _kūry, téra,
   {{0x7cf60907,0x62855ae9,0x68ed0101,0x2720801c}},	//   nári, _baho, doad, _gòn_,
   {{0x39585aea,0xe0df0032,0x6d4527d1,0xdd0100eb}},	//   turs_, _ajò_, ksha, ītāj,
   {{0x6285132b,0x272086c0,0x7641daeb,0xdddc0087}},	//   _daho, _zòn_, maly, _marţ,
   {{0x6f1d2a63,0x6e3c5aec,0x6d453e5b,0x7cfd5aed}},	//   _busc, _serb, dsha, péra,
   {{0x6e3c369d,0x7d1c5aee,0x6f1d00e5,0x6f15441b}},	// [5160] _perb, _surs, _cusc, _bizc,
   {{0x1fb5035f,0x6f1d0004,0x7cf65aef,0x226501d6}},	//   єстр, _dusc, dári, ľský_,
   {{0xc27b004c,0x6e3c2fbc,0x68ed04c3,0x7f4400e7}},	//   _פרטי, _verb, boad, ssiq,
   {{0x6e3c02af,0x13b000ab,0x6285141f,0x6f1d5af0}},	//   _werb, _চেয়, _zaho, _fusc,
   {{0x6e3c045c,0x2486daf1,0x6aa88668,0x7d043f66}},	//   _terb, rdom_, _podf, _mhis,
   {{0x7d1c02a5,0x3f8202c1,0x66c0016d,0x46c01513}},	//   _turs, _isku_, _sökf, _एतिह,
   {{0x386b00f7,0x6f1d01ec,0x60dbd245,0xfe55004e}},	//   _éirí_, _zusc, fnum, _زینب_,
   {{0x78a4003a,0xfaff00f1,0x4ddb0039,0x23668168}},	//   njiv, jtën_, _החלו, ptoj_,
   {{0x4426daf2,0x2ca90039,0x289b03c8,0x7cf609b2}},	//   mco_, _road_, מיקא, cári,
   {{0x4426bbb2,0x7d042e0b,0x7d1602d6,0x02ce0035}},	//   lco_, _ahis, _aiys, होमभ,
   {{0x62855699,0x69c38063,0xfaff0168,0x442680e5}},	//   _raho, czne, ftën_, oco_,
   {{0x7d045af3,0x44269ee5,0x62850461,0x6442daf4}},	//   _chis, nco_, _saho, naoi,
   {{0x68e326d5,0x78a40052,0xaf078077,0x7d042be4}},	//   _índi, djiv, تقیم_, _dhis,
   {{0x764a806a,0x64428c41,0x6f1d5af5,0xb05b0192}},	//   _udfy, haoi, _rusc, _kläg,
   {{0x6f1d0018,0x291e8483,0x68ed3fb0,0x62874818}},	//   _susc, _juta_, toad, rdjo,
   {{0x291edaf6,0x9ddb8039,0xe8b50214,0x7cfd00e7}},	//   _muta_, _לקוח, _dışı, méro,
   {{0x44295af7,0x291edaf8,0x20d38087,0x6f150661}},	// [5170] _ifa_, _luta_, nţia_, _pizc,
   {{0x6d450234,0x7cf60c83,0x290907b8,0x80c1170c}},	//   tsha, vári, smaa_, रोजे,
   {{0x6f154012,0x7c2d8511,0x3f820102,0x6e250192}},	//   _vizc, ñaro, _esku_, rchb,
   {{0xdd8680d5,0x7cf609e9,0x7bf98dae,0xe45f0106}},	//   _یو_, tári, онер_, ngö_,
   {{0x6d455af9,0x2d9c016d,0x6d5a94c7,0x68e483f2}},	//   ssha, äver_, huta, čidl,
   {{0x7cf60073,0x28ca8d86,0x4426dafa,0x1ee71e29}},	//   rári, ़ोसि, aco_, _روزی_,
   {{0x6d5ada65,0xaca381bc,0x7641dafb,0x7cf65afc}},	//   juta, _akụn, valy, sári,
   {{0x4426dafd,0x7cfd0b2c,0x291e859e,0x6d5adafe}},	//   cco_, déro, _duta_, duta,
   {{0x3eaa5aff,0x6d4ea35e,0xf70880ff,0x69c3900b}},	//   _yobt_, ában, _hủy_, szne,
   {{0x44295b00,0x7d044e0e,0x443f809f,0x644d5b01}},	//   _afa_, _shis, _heu_, _adai,
   {{0xb05b00f2,0x6d5ad20b,0x443f8970,0xa50a15b7}},	//   _kläd, guta, _keu_, жена_,
   {{0x443f83d3,0x2d9102a5,0x41748154,0x3f8f8805}},	//   _jeu_, _mrze_, _سامس, _trgu_,
   {{0x443fdb02,0xaca3801c,0xdddc1247,0x20d3802e}},	//   _meu_, _chỉn, _marš, cţia_,
   {{0x6d5abbc2,0x44295b03,0x442685a4,0x66c02522}},	//   buta, _efa_, zco_, _köke,
   {{0x7cfd087a,0x7d045942,0x3f8d8548,0x44295b04}},	//   céro, _this, lveu_, _ffa_,
   {{0x443f9f4c,0xe8fa05e9,0xf1b804b7,0x44269ee3}},	//   _neu_, іла_, ġġ_, xco_,
   {{0x2ab40006,0x98a6a0a7,0xf74327cb,0xa6860187}},	// [5180] _läbi_, žiće_, кето, млад,
   {{0x6b84308f,0x2d910024,0x61e481cc,0x257e01d0}},	//   _isig, _brze_, şili, _půl_,
   {{0x329b0039,0x1a9b0039,0x4426db05,0x201e0087}},	//   _וביד, _וייע, tco_, _ştiu_,
   {{0x291e91b9,0x44268272,0x2d9102a5,0x386d80f3}},	//   _ruta_, uco_, _drze_, jfer_,
   {{0x443f8931,0x7c3b007b,0x64428090,0x291edb06}},	//   _deu_, ðuri, raoi, _suta_,
   {{0x291e803b,0x7c298133,0x44269441,0x2bd2816f}},	//   _puta_, _efer, sco_, _देणा,
   {{0x443f87fa,0x7cfd01df,0x2d8c0317,0x7c298114}},	//   _feu_, xéro, _éde_, _ffer,
   {{0x6b84003a,0x52bb0f85,0x386054a8,0x2724016d}},	//   _osig, _उत्स, ngir_, _kön_,
   {{0x4fc681bb,0x291e8337,0x27240019,0x776992b7}},	//   ьска, _wuta_, _jön_, gtex,
   {{0x64408b67,0x6d5a80ad,0xc6f781bb,0x442901e0}},	//   _hemi, tuta, мных_, _sfa_,
   {{0x629a980b,0x6b845b07,0x2724016d,0x443f80ff}},	//   _into, _asig, _lön_, _yeu_,
   {{0xe57100be,0x7e7a8f33,0x3f8d8bda,0x409380f7}},	//   אַך_, setp, bveu_, _للمر,
   {{0x6d5a8665,0x6440848f,0x6288db08,0x764e009a}},	//   suta, _memi, _kado, _odby,
   {{0x6440db09,0xdd909e91,0x6288db0a,0x628aa25b}},	//   _lemi, _موت_, _jado, ndfo,
   {{0x6b845b0b,0x29068028,0x44290037,0xaf0781a8}},	//   _esig, _khoa_, _tfa_, _تقوم_,
   {{0x6440db0c,0xd788801c,0x2b498bcf,0xe45f1647}},	//   _nemi, _kể_, šaci_, riös_,
   {{0x443fdb0d,0x6d48db0e,0x7c29d681,0x569501e5}},	// [5190] _reu_, lsda, _rfer, наат,
   {{0x443f907f,0x27240457,0x629a808e,0xceb898eb}},	//   _seu_, _dön_, _nnto, nkę_,
   {{0x443fdb0f,0x6d48a4de,0x6d5a016d,0x6440d068}},	//   _peu_, nsda, _åtal, _bemi,
   {{0x629adb10,0x6440db11,0x6288846d,0x7769810c}},	//   _anto, _cemi, _aado, ytex,
   {{0x6288be12,0x66c000f2,0x443f9209,0xf8bf077f}},	//   _bado, _söke, _veu_, _ilé_,
   {{0x6288db12,0x6d488186,0x29190010,0x248901c0}},	//   _cado, ksda, _hisa_, _laam_,
   {{0x6288db13,0x443fdb14,0x29195b15,0xceb88035}},	//   _dado, _teu_, _kisa_, dkę_,
   {{0x2489240d,0x629a9883,0x6440d14b,0x26dedb16}},	//   _naam_, _ento, _gemi, ento_,
   {{0x386ddb17,0x2369022c,0x6288d025,0xb275a0bf}},	//   rfer_, _nqaj_, _fado, _плаш,
   {{0xd7068364,0x6440db18,0x386d9e03,0x7ce80085}},	//   нные_, _zemi, sfer_, zırd,
   {{0xab5b0065,0x7769cb95,0x64409790,0xf8bf5b19}},	//   szül, stex, _yemi, _olé_,
   {{0x291927be,0x672f0042,0x0fd0816f,0x6440db1a}},	//   _nisa_, _otcj, _तेवढ, _xemi,
   {{0x7f5b8079,0x2cad9384,0x68fb82d0,0x2bba01a8}},	//   quuq, _moed_, mlud, ساحة_,
   {{0xc3329a0f,0xf8bf0091,0x290da596,0xdbcd1434}},	//   רום_, _alé_, lmea_, róðr,
   {{0x29192fc5,0xf652810f,0x2724016d,0x3d1882f1}},	//   _bisa_, _עצה_, _sön_, _बूझे_,
   {{0x7cf88510,0xb05b016d,0xf8bf324c,0x6f1886ec}},	//   píri, _smär, _clé_, _zivc,
   {{0x2919020f,0x64460274,0x38605b1b,0x27e602be}},	// [51a0] _disa_, maki, rgir_, çon_,
   {{0x644644a4,0x291e0ece,0x212100b9,0x2cbf8144}},	//   laki, ítas_, _fuhh_, _alud_,
   {{0x6440859c,0x62888b48,0x2cbf826c,0x68fb93c2}},	//   _pemi, _rado, _blud_, klud,
   {{0x9346a28e,0x8fa60f52,0x64465b1c,0x29195b1d}},	//   енде, _заме, naki, _gisa_,
   {{0x6288db1e,0x7cf600e1,0x691584e8,0xceb8db1f}},	//   _pado, lárs, _všel, ykę_,
   {{0x64465b20,0x764e006a,0x7645008e,0x9258896b}},	//   haki, _udby, cahy, факт_,
   {{0x62889d69,0x64465b21,0x6440db22,0x66e34b47}},	//   _vado, kaki, _temi, _сора,
   {{0x2cad98db,0x6288a69f,0x6d4e8511,0x7e7e5b23}},	//   _goed_, _wado, ábam, lepp,
   {{0x6d5e5b24,0x93aa8b76,0xdefa8071,0x64465b25}},	//   lupa, _عارف_, зын_, daki,
   {{0x2489079f,0x6d48848d,0x59b202f1,0x26de847f}},	//   _saam_, tsda, ीनार, unto_,
   {{0xd5b78a08,0x68fb8052,0x61db8f21,0x998c8b80}},	//   еся_, blud, यपृष, _hedž_,
   {{0x68fb8051,0x7cf601ac,0xb87b026b,0x27e60035}},	//   clud, dárs, _ajín, żony_,
   {{0x29191cb1,0x60c4135e,0x5ef55b26,0x7e7e008b}},	//   _risa_, dhim, ्तम्_, kepp,
   {{0x2919059c,0x8f9b83c8,0x8caa83b7,0xfd748162}},	//   _sisa_, _מידי, _झकझो, _алкэ,
   {{0xa2b3836d,0x64461c88,0x291918de,0xf8bf00f7}},	//   _अवस्, baki, _pisa_, _plé_,
   {{0x6d5e0867,0xb5fb810f,0x76450359,0x60c41341}},	//   dupa, _מלוכ, wahy, ghim,
   {{0x29195b27,0x3f8683bb,0xf1b900eb,0xddc8db28}},	// [51b0] _visa_, _jsou_, ņš_, nedž,
   {{0x798501e9,0xdd950009,0xb05b016d,0x212100dd}},	//   _tshw, казы, _bläc, _tuhh_,
   {{0x7cf65b29,0x76455b2a,0x29195b2b,0xe2a7007b}},	//   párt, rahy, _tisa_, æður_,
   {{0x2bd29d17,0xec158077,0x2919008e,0x7c2d0609}},	//   _देहा, نواد, _uisa_, _jfar,
   {{0x68fbdb2c,0x45188fd3,0x80a492c6,0x2cad8a53}},	//   vlud, رآمد_, काने, _voed_,
   {{0x6d5e12fb,0x64465b2d,0xeb969577,0xb05b3a53}},	//   bupa, zaki, тиш_, _fläc,
   {{0x6446015d,0x3f8686c4,0x6d5e1140,0x7ae48118}},	//   yaki, _asou_, cupa, éita,
   {{0xa3c1053e,0x2bd287e6,0x2919816d,0xddc88b80}},	//   ंना_, _देवा, ösa_, fedž,
   {{0x776d0b6e,0x442dd811,0x644606ee,0x5b15af03}},	//   ntax, _ife_, vaki, _амат,
   {{0x7c2d1b6d,0x64465b2e,0x68fbdb2f,0x1e9581cf}},	//   _afar, waki, slud, трир,
   {{0x64465b30,0x7d1bb006,0x7f498037,0x3eae8338}},	//   taki, _kius, sseq, _doft_,
   {{0x7c2d00f1,0x893480f7,0x2247874c,0x60c403ed}},	//   _cfar, _إعلا, lank_, xhim,
   {{0x442d8870,0x78a9ad61,0x7d098010,0x387f829c}},	//   _mfe_, mjev, _mhes, meur_,
   {{0x387fdb31,0x64465b32,0x4804835f,0x3eae81c0}},	//   leur_, saki, _спів, _goft_,
   {{0x442ddb33,0x44393a65,0x64465b34,0x60c45b35}},	//   _ofe_, bbs_, paki, thim,
   {{0x78a984c4,0x442dad10,0x8c3d8214,0x387fdb36}},	//   njev, _nfe_, _koşu, neur_,
   {{0x7643db37,0x2fc92483,0x442010ab,0x60c4208b}},	// [51c0] _keny, gzag_, _igi_, rhim,
   {{0x60c45b38,0x6d5e3e21,0x06e380ab,0x442ddb39}},	//   shim, tupa, _নীতি, _afe_,
   {{0x76438458,0x2b4d9c8d,0x78bb84a2,0x629e5b3a}},	//   _meny, _avec_, kkuv, _inpo,
   {{0x6d5e0393,0x7643c954,0x7e7e1e41,0x7523930e}},	//   rupa, _leny, sepp, _munz,
   {{0x2bd2816f,0x7d1b8458,0x6d5e43e3,0xfbd290be}},	//   _देशा, _dius, supa, _देशम,
   {{0x442ddb3b,0x628e5b3c,0x442009ca,0x3866db3d}},	//   _efe_, ndbo, _lgi_, _scor_,
   {{0xe5a30b01,0xada31bf2,0x67228009,0x442d82ec}},	//   _кири, _карл, _suoj, _ffe_,
   {{0x7d1b8698,0x442d808e,0x61fa83f2,0x2b4d0bda}},	//   _gius, _gfe_, _vytl, šeci_,
   {{0x7643854f,0xaca38028,0xb4be809a,0x6f1c5b3e}},	//   _beny, _giốn, इसी_, _kirc,
   {{0x7cfd5b3f,0x38b5016d,0x7c2d5b40,0xb87b026b}},	//   méri, _hårt_, _sfar, _ajíl,
   {{0x7643db41,0x7cfd0e14,0xceb3012a,0xb8e880c8}},	//   _deny, léri, ייז_, _ঈদ_,
   {{0x6b9604fe,0x776d0085,0xc5f30039,0xb86580d7}},	//   _bryg, ytax, ידת_, _ماهو,
   {{0x44395b42,0x60c28280,0x3f86a41f,0x317a4b77}},	//   rbs_, _ilom, _usou_, _appz_,
   {{0x752381dc,0x76438205,0x6b965b43,0x26c580e1}},	//   _funz, _geny, _dryg, chlo_,
   {{0x7c3b0125,0x349523d7,0x60c2c9a2,0x7c2901df}},	//   ðurs, _байр, _klom, ñers,
   {{0x6b96006a,0x7c2d1fb6,0x764380b8,0x629e03ec}},	//   _fryg, _ufar, _zeny, _enpo,
   {{0x7d1b8098,0x7643a73f,0x7d09831d,0x2247808e}},	// [51d0] _rius, _yeny, _rhes, yank_,
   {{0x776d5b44,0xfe701ddd,0x6f1c3206,0x7648bba1}},	//   rtax, قدم_, _circ, nady,
   {{0x776d5b45,0x60c2db46,0x387f80e7,0x6f1c5b47}},	//   stax, _olom, yeur_, _dirc,
   {{0x8c3d8162,0xf4e18264,0xaf3700d7,0x387f9a1f}},	//   _noşt, বত্ব, _لرست, xeur_,
   {{0x7cfd5b48,0x42d58221,0x387f902d,0x7d1ba590}},	//   géri, ліку, veur_, _vius,
   {{0xf990026a,0x91e58391,0x6d581e1e,0x69158084}},	//   _ابی_, лоле, ávac, _išei,
   {{0xfa78073a,0x387fa5d2,0x7d098051,0x60c293c2}},	//   דעות_, teur_, _thes, _blom,
   {{0x6fd483b7,0x7cfd5b49,0x752385ee,0x88bc928a}},	//   _बेहू, béri, _runz, _stěr,
   {{0x7643859c,0x6d5adb4a,0x78a9cb0f,0x387fdb4b}},	//   _peny, erta, rjev, reur_,
   {{0xb7bd802e,0x61278214,0x387f9030,0x6b89db4c}},	//   ncţi, _yıll, seur_, _iseg,
   {{0x04460ca0,0x78a98654,0xb87b0032,0x387f8036}},	//   ленн, pjev, _ajím, peur_,
   {{0x76439e45,0x3f4f0029,0x248d8580,0x7cf60c1d}},	//   _weny, kļu_, _jaem_, tárq,
   {{0x20248038,0xeb971194,0x765c8063,0x6d5ada85}},	//   ásiť_, гия_, óryc, arta,
   {{0x7cf60207,0x60c2a19f,0x7cc40019,0x644400b9}},	//   rárq, _zlom, nőrz, _weii,
   {{0x6d5a805c,0x2729c0d2,0x2d87805c,0x22459b9b}},	//   crta, _hún_, _usne_, _melk_,
   {{0x6b96070b,0x291d8397,0x272984be,0x26c3026c}},	//   _tryg, _jiwa_, _kún_, _aljo_,
   {{0x2729c6fe,0x3f4f00eb,0x48065b4d,0x6f1c01a9}},	// [51e0] _jún_, gļu_, упав, _pirc,
   {{0x6da6028b,0xe5a613f1,0x629e02e6,0x2729db4e}},	//   лиза, лизи, _unpo, _mún_,
   {{0x6b89b1a3,0x2d960048,0xe45aced5,0x2729db4f}},	//   _aseg, ырас, еже_, _lún_,
   {{0x7cfd5b50,0xa34a8a13,0x5fd5016f,0x9b6a867c}},	//   téri, езда_, _ठेवल, ешка_,
   {{0x38b50448,0x68e402f7,0xb05b0884,0x2d87006a}},	//   _vårt_, mnid, _klän, æner_,
   {{0x60c2811f,0x29005582,0x929491f3,0x88c60264}},	//   _slom, llia_, ракц, _এদিক,
   {{0x272985b4,0x6b89db51,0x80b803eb,0xa9678992}},	//   _aún_, _eseg, _इकाइ, гија_,
   {{0x7cfd02be,0x92e480c8,0x6d5a8390,0x68e443cb}},	//   péri, নতে_, vrta, nnid,
   {{0x291ddb52,0xd90d803d,0x68e40114,0xceba8326}},	//   _diwa_, ذیه_, inid, _liƙe_,
   {{0x27299ca9,0x672610e1,0x557486f9,0x22458609}},	//   _dún_, _mukj, агот, _gelk_,
   {{0x76489c59,0x65618187,0x2900004f,0xd6db025f}},	//   rady, gulh, klia_, תחיל,
   {{0x27298324,0x76488c27,0x6d5a8c49,0x7ce8080a}},	//   _fún_, sady, rrta, tıra,
   {{0xaab88076,0x6d5a80d2,0xf09f001c,0xb05b0338}},	//   _अवाक, srta, _giày_, _blän,
   {{0x248d0b5d,0x66c000f2,0x291d804f,0x59a8881f}},	//   žem_, _sökn, _ziwa_, _कपार,
   {{0x7af51124,0x291d84b9,0x68e40114,0x6234004a}},	//   rozt, _yiwa_, fnid, сесу,
   {{0x29000698,0x5455132a,0x38351b67,0x95539a00}},	//   glia_, _твит, рнар, _اخوا,
   {{0x1ee7003d,0x7d0d5b53,0xe8940198,0x2d985b54}},	// [51f0] هوری_, _ihas, щать, _arre_,
   {{0x68e430c9,0x290056b2,0xaca380ff,0x248d841c}},	//   anid, alia_, _phỏn, _saem_,
   {{0x7f4d0372,0x7d0d332e,0x2900574a,0x6b89db55}},	//   ssaq, _khas, blia_, _sseg,
   {{0x63b98063,0x20070201,0x29005b56,0xddc880e1}},	//   tywn, ənin_, clia_, radň,
   {{0x2d980065,0x03a58012,0x9098120c,0x66c00380}},	//   _erre_, рило, _свят_, _kökl,
   {{0x2729db57,0x291db353,0x7d0d09ab,0x26da3d22}},	//   _rún_, _siwa_, _lhas, cipo_,
   {{0x61150110,0x27298091,0x387900b9,0x63b9866f}},	//   _sąly, _sún_, _kbsr_, sywn,
   {{0x78ad135a,0x249f8789,0x224580f3,0x6b89bf73}},	//   njav, _unum_, _welk_, _tseg,
   {{0x644bdb58,0x6a6795e4,0x29038029,0x09d2016f}},	//   magi, _مطال, ēja_, _सध्य,
   {{0x644bdb59,0x4905800f,0x81bb00c8,0x3f99026c}},	//   lagi, _हीरो_, _আইন_, _mrsu_,
   {{0x7d0d5b5a,0x64a60196,0x78ad30a6,0x68e4057b}},	//   _bhas, аана, kjav, ynid,
   {{0x628387f1,0x2729877f,0xb05b016d,0x6561a38f}},	//   leno, _tún_, _slän, rulh,
   {{0x7d0d549e,0xee2ebb4a,0xf7459821,0x78ad0088}},	//   _dhas, _мн_, _тело, djav,
   {{0x644ba0f4,0x60c9db5b,0x6283db5c,0x13ba83de}},	//   hagi, lhem, neno, דזשע,
   {{0xd9465b5d,0x66c00106,0x6726008e,0x644bdb5e}},	//   реби, _söko, _sukj, kagi,
   {{0x61fe0efc,0x92d600c8,0x60c98009,0x6283db5f}},	//   _vypl, িকে_, nhem, heno,
   {{0x644bdb60,0x443202f7,0x62838978,0x7c243de5}},	// [5200] dagi, _ify_, keno, _igir,
   {{0xee3719fe,0xfd4c8028,0xdcf9001b,0x60db81e8}},	//   ину_, _nhiệ, _osvě, hium,
   {{0x628380ce,0x14268b9c,0x4a5b0039,0x26da2256}},	//   deno, адем, _בדיו, ripo_,
   {{0x644bdb61,0x7cfd3a97,0x672600b9,0x26da5b62}},	//   gagi, sérv, _tukj, sipo_,
   {{0x60c9b543,0x20d38087,0x66c0011c,0xd4678087}},	//   dhem, cţii_, _hökm, риче_,
   {{0x6283a0b5,0xb87b046d,0xd954866e,0x27e08084}},	//   geno, _ajíh, منتخ, _žino_,
   {{0x644bdb63,0x6d5594b5,0x8c46872a,0x69ce5b64}},	//   bagi, ázal, _вебе, nzbe,
   {{0x7c245353,0xb4c503ca,0x7c2d8216,0xf4c100ab}},	//   _ngir, _एते_, ñart, _উদ্ব,
   {{0xc6a68dc9,0x4ea6bb17,0x6283db65,0x752701c0}},	//   арни, арна, beno, _zujz,
   {{0x7d0d1581,0x7c242b39,0xfaff00f1,0x7520826c}},	//   _shas, _agir, ntët_, _himz,
   {{0x7aed80e7,0x06970039,0x7cfd0061,0xd82f8012}},	//   éate, בדים_, kért, _мэ_,
   {{0x7d0282af,0xf8da83db,0x9abc81b9,0x66c48176}},	//   nlos, _बगिय, _diċe, _dòka,
   {{0x66e6c4e0,0xd0d3db66,0x4ab40b99,0x9f4981fa}},	//   _кода, _بينظ, ुसंव, _áað_,
   {{0x7d02a3cf,0x60c65b67,0x644bc7e7,0x7764023e}},	//   hlos, _alkm, zagi, duix,
   {{0x1fe880ab,0x644b8e8c,0x7d0d5b68,0x7d02db69}},	//   _পরিস, yagi, _thas, klos,
   {{0x26d85b6a,0x7d02817f,0x7ce8007e,0x7d0d5b6b}},	//   _amro_, jlos, nırl, _uhas,
   {{0x78ad5b6c,0x6283db6d,0x6d580a21,0xdcf201b9}},	// [5210] rjav, yeno, ávan, _żgħi,
   {{0x6b8d02c1,0xed4d8117,0x6283802a,0x644bb722}},	//   _isag, _تھی_, xeno, wagi,
   {{0x63bd08bd,0x20c70665,0x62838304,0x644bb06f}},	//   lysn, _võib_, veno, tagi,
   {{0x77640722,0xfc3f5b6e,0xb05b0106,0x6283cbcd}},	//   buix, nbí_, _kläm, weno,
   {{0x644ba135,0x6283db6f,0x307a00be,0x76470282}},	//   ragi, teno, _גארנ, _tejy,
   {{0x78a2b6f8,0x644bdb70,0xa5f90a41,0x6b8d5b71}},	//   _anov, sagi, _бегу_, _msag,
   {{0x60c9805d,0x644bdb72,0x6915826f,0x44248915}},	//   them, pagi, _ošet, _fgm_,
   {{0x38692a4c,0x6283db73,0x9abc84b7,0x6b8d011b}},	//   ngar_, seno, _riċe, _osag,
   {{0xfd4c8028,0x60dbdb74,0x60c9836e,0x68fd02f7}},	//   _thiệ, rium, rhem, _mksd,
   {{0x4d659273,0x60dbdb75,0xddb581a8,0x78a2b7fd}},	//   бков, sium, محجب, _enov,
   {{0x6b8d5b76,0x60c9db77,0x60db8037,0xa294804a}},	//   _asag, phem, pium, _фахі,
   {{0xe1f09459,0xf41f0198,0xe7998a47,0xfce60087}},	//   _غسل_, ydät_, _مختص_, сомо,
   {{0x80a492ee,0x66c02522,0xfaff0168,0x2d8a8366}},	//   कारे, _sökm, jtës_, æber_,
   {{0x78a29807,0x216a0f27,0xa96a0adb,0x6d5cdb78}},	//   _znov, лиги_, лига_, árac,
   {{0xb05b0364,0xcd358077,0x20560071,0x6b8d5b79}},	//   _eläm, _ارتب, йтар, _esag,
   {{0x25718125,0x3869088b,0xfaff00f1,0x7c240435}},	//   mál_, ggar_, ftës_, _ugir,
   {{0xc7a30ada,0x03e280ab,0x543b00be,0x8fa30198}},	// [5220] питк, _বর্ণ, _געפא, пате,
   {{0x7ce81010,0x394597fe,0x6d5e011f,0x528600f7}},	//   zırl, _owls_, trpa, _الدك,
   {{0x7d028067,0x2571a792,0x6b9bdb7a,0xb8ce00ab}},	//   tlos, nál_, _arug, _কত_,
   {{0x6b9b8ae1,0xab2aa5b6,0xfaff00f1,0xed5680be}},	//   _brug, года_, stët_, מבער_,
   {{0x7d02db7b,0xa80501df,0x2bd2a743,0xb87b0032}},	//   rlos, ruñé, _देखा, _ajíw,
   {{0x6b9bdb7c,0x26d8003b,0x7d0284e8,0xd6270139}},	//   _drug, _umro_, slos, _горе_,
   {{0x7ce8017b,0xd2598221,0x6b9b8133,0xfc3f01d0}},	//   tırl, рці_, _erug, ybí_,
   {{0x4424861b,0x6b9b806a,0x644981ec,0x47348ab2}},	//   _ugm_, _frug, _geei, онис,
   {{0xd9a500d4,0x60c0db7d,0x307781a8,0x6b9bdb7e}},	//   _ऑप्ट, rkmm, صحية_, _grug,
   {{0x66fa09c8,0x8c3d83bf,0xa29f801b,0x24868bcf}},	//   ्तिक_, _inşa, _गोप्, leom_,
   {{0x7c2d9408,0xd24f9459,0x39458609,0xf76f80d7}},	//   žare, _سنن_, _gwls_, وای_,
   {{0x78a2807a,0x7cfd5b7f,0x7bcf0144,0x248680c3}},	//   _unov, vérs, tzcu, neom_,
   {{0x6915b404,0x66fa0076,0x06fa125f,0x38cb8180}},	//   _všet, ्ताक_, ्ताव_, _حالی_,
   {{0x77608713,0x6d4e81df,0x3da6a45b,0x7ae480f7}},	//   mrmx, ábas, _гриб, éith,
   {{0x26de98f1,0x20021040,0x69238bcf,0xf8bf0036}},	//   mito_, _ayki_, _uđet, _liée_,
   {{0x764a8355,0x6915826f,0x58d40c9d,0x320c816b}},	//   _hefy, _ušet, пост, _mzdy_,
   {{0xf7701e95,0x29048406,0x6d580029,0x386959f9}},	// [5230] فال_, ilma_, šval, rgar_,
   {{0x6b9b820f,0xdddc0110,0x38690fe9,0x6efd80e7}},	//   _rrug, _darž, sgar_, lèbr,
   {{0x212237d7,0x62875b80,0xf60b2133,0xfaff0168}},	//   _fikh_, mejo, ухай_, stës_,
   {{0xe9a98077,0x6b9b805c,0xd5fb80be,0x26de8037}},	//   یگان_, _prug, נפאר, hito_,
   {{0x60cd5b81,0xfb8580d7,0x765884e8,0x69d8008b}},	//   mham, تدای, _odvy, _þver,
   {{0xe2998f04,0x62875b82,0x60cd5b83,0x6b9b81b0}},	//   рак_, nejo, lham, _vrug,
   {{0x26dedb84,0x96080a8e,0x32cb804a,0x00000000}},	//   dito_, _гэта_, _nøye_, --,
   {{0x60cd5b5b,0x25718061,0x7ce8061c,0xceba8300}},	//   nham, vál_, tırm, _riƙa_,
   {{0x6b9b82a0,0x28d8800f,0x62871ebe,0x26dec9d8}},	//   _urug, बोधि, kejo, fito_,
   {{0x673ba0d0,0x200380eb,0xd25184e3,0x6d46826c}},	//   rpuj, āji_, _آنا_, ćkan,
   {{0x34aa2bf3,0x60cd0234,0x80c903eb,0x2d9c81f4}},	//   авно_, kham, रसाइ, _crve_,
   {{0x644f353e,0x2360812b,0x7c2900fe,0x26cc81b4}},	//   gaci, šije_, žern, ahdo_,
   {{0x26dedadb,0xab2a0e02,0x98f4845b,0x60cd3b0b}},	//   bito_, рога_, _عثما, dham,
   {{0x26de9cdc,0x81cc80ab,0x68fb8198,0xb05b0106}},	//   cito_, রপর_, loud, _fläk,
   {{0x2d988370,0x200b8503,0x5d6980e5,0x691582d4}},	//   året_, škić_, _тийм_, _ušes,
   {{0x644f2d11,0x33660d0e,0x60cd15d0,0x672385af}},	//   caci, _двиг, gham, _hinj,
   {{0xe8f700e8,0x6723db85,0xfaff0168,0x464a197b}},	// [5240] ілу_, _kinj, rtër_, изан_,
   {{0x2be00076,0x68fb82d8,0xdddc0110,0xfaff00f1}},	//   _पेया, houd, _varž, stër_,
   {{0xc27b012a,0x68fb8176,0x2d9c03c1,0x527b1101}},	//   _דריי, koud, íve_, _דניא,
   {{0x60cd5b86,0x6723c575,0xdd1c816b,0x2d9ab1cd}},	//   cham, _linj, sážn, _špek_,
   {{0x6d55026c,0x26de8a03,0x60c42aa0,0x248681f4}},	//   _evza, yito_, mkim, reom_,
   {{0x644f05e4,0x7afc5b87,0x60c45b88,0x75245b89}},	//   zaci, nort, lkim, _liiz,
   {{0x7c2f85b7,0x3f82008e,0x644f5b8a,0xed571a4a}},	//   _širš, _hpku_, yaci, _мор_,
   {{0x60c45b8b,0x764a831d,0x644f526f,0x3eb80722}},	//   nkim, _sefy, xaci, _hort_,
   {{0x3eb80d1a,0x26dea581,0x6723db8c,0xb05b016d}},	//   _kort_, tito_, _binj, _släk,
   {{0x67238052,0x644f04b9,0x7afc01a3,0xddde0087}},	//   _cinj, waci, jort, cepţ,
   {{0x644f11b9,0x3eb82477,0x672384b7,0x60c404a2}},	//   taci, _mort_, _dinj, kkim,
   {{0x26deade9,0x644282f9,0x62950035,0x26cc83ed}},	//   sito_, nboi, wdzo, shdo_,
   {{0x6d58003e,0x26de95a4,0x6723826b,0x752409ca}},	//   ávaj, pito_, _finj, _diiz,
   {{0x25478065,0x6723b413,0x7afc5b8d,0xe5728b8c}},	//   ből_, _ginj, gort, _قطع_,
   {{0x60cd2b16,0x644f05d8,0xdb1d0019,0x7c360114}},	//   tham, paci, nysé, _ffyr,
   {{0x26ca5b8e,0x628703a7,0x34b98f3d,0x47355b8f}},	//   _albo_, sejo, _आवेद, знас,
   {{0x3eb81816,0x44295b90,0x60cd2699,0x7afc5b91}},	// [5250] _bort_, _iga_, rham, bort,
   {{0x60cd25f4,0x3eb85b92,0xdd9b3eb1,0xadfe9d40}},	//   sham, _cort_, ише_, _उडान_,
   {{0x3eb84161,0x68e9831d,0x60cd005d,0x644d0748}},	//   _dort_, yned, pham, _keai,
   {{0x442909ca,0x6b808133,0xf9fa01c6,0x224c82f9}},	//   _jga_, _ịgag, _להתמ, _aedk_,
   {{0x44291635,0x656888ce,0xd7d985fc,0xeb9993f1}},	//   _mga_, hudh, _बेंच, сил_,
   {{0x77ba0039,0xda7b9bc1,0x02c58935,0x6568db93}},	//   _המשח, ряд_, वसेन, kudh,
   {{0xceb2093f,0xca7c03c8,0x6723c898,0x200981a9}},	//   _אים_, ינגט, _rinj, _šai_,
   {{0x44295b94,0x25750082,0x6723a909,0xa3cb1a87}},	//   _nga_, mål_, _sinj, लना_,
   {{0x6723a08b,0xb4e7835a,0x7641831d,0x34c78105}},	//   _pinj, यची_, tbly, लसीद,
   {{0x44295b95,0x25478019,0xddde1807,0x7524026c}},	//   _aga_, től_, lepš, _siiz,
   {{0x7cfd26d5,0x6da58811,0x442901e0,0xb05b0009}},	//   térp, чина, _bga_, _eläi,
   {{0x25478065,0x7afc2331,0xdb0d00e1,0x44295b96}},	//   ről_, wort, ľkýc, _cga_,
   {{0x7afc5b97,0x67239083,0xa2d28670,0x8fa5a7ae}},	//   tort, _tinj, भोक्, _хале,
   {{0x44294802,0x386d8a38,0xf67580be,0x64428087}},	//   _ega_, lger_, _זײַט_, zboi,
   {{0x2f141918,0x7d110065,0x60c40009,0x44290118}},	//   lägg_, üksé, tkim, _fga_,
   {{0x386d8aa2,0xf992893f,0x7c29db98,0xddde120e}},	//   nger_, ערן_, _nger, jepš,
   {{0x60c45b99,0xb87b046d,0x386dc964,0x3eb824cc}},	// [5260] rkim, _ajís, iger_, _port_,
   {{0x7c29db9a,0x645b80b9,0xd00f00f7,0x60c42764}},	//   _ager, _adui, الك_, skim,
   {{0x657701c0,0x3abb025f,0xf09f0a2a,0x7abb01c6}},	//   gtxh, _המינ, _chàs_, _הציו,
   {{0x27ed003a,0x3eb801ec,0xf53680be,0x386ddb9b}},	//   _žene_, _wort_, לטער_, jger_,
   {{0x29020006,0x64429ef3,0xa294902a,0x212c808e}},	//   _ikka_, rboi, далі, _sudh_,
   {{0x386d8a11,0x3205801b,0x6568b7c0,0x6577022c}},	//   eger_, _byly_, yudh, btxh,
   {{0x8c468293,0xb909001c,0x2480025b,0x7c2d8390}},	//   _неве, _nghỉ_, _obim_, žara,
   {{0x386d8082,0x3ea7db9c,0xf4849e29,0xc10481a8}},	//   gger_, _annt_, _تاسی, بوعي,
   {{0x644d1cef,0x36d4954f,0x7b09807b,0x4fc69f96}},	//   _reai, допр, ðstö, яска,
   {{0x692a83bb,0x3f1381e5,0x68e0bead,0x3ea78362}},	//   _před, ндыс, simd, _cnnt_,
   {{0xceb30051,0x598694bc,0xaab05b9d,0x28a998b8}},	//   תית_, _хлеб, ञानक, काशि,
   {{0x6abadb9e,0x6298db9f,0xc98581a8,0x6568d4bb}},	//   _hotf, ldvo, _تشكي, rudh,
   {{0x7bc282f7,0x66c00085,0x46a6a535,0xde588d8e}},	//   nyou, _höku, _надв, _далі_,
   {{0x765c08cf,0x753c0063,0x29025ba0,0x764e001b}},	//   _ndry, _otrz, _akka_, _neby,
   {{0x25dc016f,0x51840a41,0x27328129,0x867b81c6}},	//   _गेली_, нута, _hân_, _הרוו,
   {{0x44291c63,0x02d98c87,0xb87b026b,0x776403a8}},	//   _uga_, _भग्न, _ajír, frix,
   {{0xf77305ff,0xf09f0706,0x764e2280,0x76b94bfc}},	// [5270] عار_, _bhàr_, _beby, олар_,
   {{0x20070ec3,0x2732a111,0xf09f0a2a,0x6abaaa1d}},	//   āni_, _mân_, _chàr_, _notf,
   {{0x764e0114,0x386d8b81,0x2732dba1,0x3915002e}},	//   _deby, yger_, _lân_, _омор,
   {{0xb4e7835a,0x765c031d,0x5fde0fb2,0x386d0366}},	//   यचे_, _edry, _नेवल, _øer_,
   {{0x68ed1042,0x05de86bf,0x889a0039,0x7aed8036}},	//   mnad, _फेसब, _וברי, éato,
   {{0x628aa91b,0x764e1277,0x63a08bcf,0x03a2960e}},	//   gefo, _geby, _drmn, тишо,
   {{0x68ed26e7,0x28a9801b,0x236084b7,0xd5b8002e}},	//   onad, कालि, ġija_, _ест_,
   {{0x68ed5ba2,0x27329e4e,0x23608289,0x5fc8800d}},	//   nnad, _bân_, šija_, ाईंल,
   {{0x6d58dba3,0x2732dba4,0x386dc780,0x68ed3c0b}},	//   _avva, _cân_, rger_, inad,
   {{0x27328104,0x057580f7,0x68ed4e96,0x2ca95ba5}},	//   _dân_, واجد, hnad, _anad_,
   {{0x7ae38fe6,0x68ed2cdb,0x6b8401e8,0x386d8106}},	//   mint, knad, _spig, pger_,
   {{0x7ae3dba6,0xcd02809a,0xf2c903c8,0x69c38428}},	//   lint, _gość_, _דע_, myne,
   {{0x1e0a0da0,0x7e0a0f85,0x7ae3b2be,0x2732a111}},	//   _वर्ष_, _वर्ग_, oint, _gân_,
   {{0x7d0700e7,0x672708ae,0x32008214,0xe0df5ba7}},	//   térê, _nijj, şiye_, _amò_,
   {{0x764e2dcb,0xb0c91299,0x6281dba8,0xdb26811c}},	//   _reby, रसंग, _mblo, şqçi,
   {{0x7ae3dba9,0x77645baa,0x629881dd,0x764e1088}},	//   hint, trix, zdvo, _seby,
   {{0x7ae3dbab,0xd0070185,0x6281dbac,0x753c009a}},	// [5280] kint, дете_, _oblo, _strz,
   {{0x9d4610ff,0xbefa0f12,0x7ae3dbad,0x68ed5bae}},	//   дежд, ्तेन_, jint, anad,
   {{0x7ae3dbaf,0x6d41dbb0,0x7e7e80f2,0x6aba9388}},	//   dint, npla, _öppe, _rotf,
   {{0x040400ab,0x7c2d811a,0x69c3a337,0xf48381b5}},	//   রেণী_, žarn, dyne, вушн,
   {{0xe7e880c8,0x7ae3dbb1,0x6d670110,0x628ab703}},	//   _পর্য, fint, _įraš, tefo,
   {{0x7ae3dbb2,0x6d41af51,0x68e45bb3,0xd13aa306}},	//   gint, kpla, liid, охи_,
   {{0x2732801c,0x62988cfa,0x753c0035,0x7bc282d6}},	//   _sân_, rdvo, _utrz, syou,
   {{0x6281d847,0x7ae3851e,0x628a805f,0x692a81d0}},	//   _eblo, aint, sefo, _přeb,
   {{0x7c295bb4,0x692a928a,0x628a8299,0xb05b0799}},	//   žerk, _břec, pefo, _gläu,
   {{0x7d042fe0,0x2732801c,0x2ca9001b,0x2ab40106}},	//   _akis, _vân_, _snad_, _täby_,
   {{0x6d41dbb5,0x27e98125,0x62970b6e,0xb05b0106}},	//   gpla, _þann_, _raxo, _klät,
   {{0x7d165bb6,0x692a800d,0x2732a10e,0x66c05bb7}},	//   _chys, _třeb, _tân_, _köks,
   {{0x68e402ab,0xfeb7803d,0xf8bf0216,0x68ed088b}},	//   diid, سایت_, _bién_, vnad,
   {{0x7d040c56,0x629701b4,0x6d41bff4,0x057685ff}},	//   _ekis, _qaxo, bpla, _قاعد,
   {{0x6d558019,0x41e4102a,0xdb008168,0x68ed4575}},	//   ázat, віта, _armë, tnad,
   {{0x7ae3dbb8,0x5064096f,0xdce200eb,0x7c87102a}},	//   zint, ктуа, pulā, _цуке,
   {{0x7ae3a499,0x7c2d1c88,0x3cf286a7,0x97150087}},	// [5290] yint, _igar, ंचने_, емац,
   {{0x20c70665,0x68ed5bb9,0x7ae38079,0x66c482d6}},	//   _kõik_, snad, xint, _bòki,
   {{0xa29f8b49,0x7ae3b4a3,0x25788019,0xe3b0803d}},	//   _गोष्, vint, nél_, یره_,
   {{0x809e86b7,0x6281b47b,0x66c02522,0x443927eb}},	//   _खोले, _sblo, _sökt, ncs_,
   {{0x6d419640,0x7ae3dbba,0x60d60bea,0x44395bbb}},	//   zpla, tint, _נושא_, ics_,
   {{0xdb258019,0x69c39c20,0x4439026c,0x2bd0056b}},	//   _épül, tyne, hcs_, हनता,
   {{0x6d41bb15,0x64460035,0xb05b0338,0x78bd5bbc}},	//   xpla, ybki, _flät, _kosv,
   {{0x7ae3cb78,0x7c2d5bbd,0x2f1402af,0xa3c10e88}},	//   sint, _ngar, räge_, ूना_,
   {{0x692a801b,0x7c3bba48,0x69c3dbbe,0x6d418bfd}},	//   _přec, _ifur, syne, wpla,
   {{0x7c2d5bbf,0x1dca816f,0x7d043d26,0x2900011b}},	//   _agar, ानंत, _skis, zoia_,
   {{0x75298a0f,0x1d0a091e,0xa50a16fc,0x7d16444e}},	//   _kiez, зени_, зена_, _phys,
   {{0x92bc00c8,0x55da00be,0x26cedbc0,0x6d418e79}},	//   _আগে_, פֿינ, _elfo_, rpla,
   {{0x7529dbc1,0x31c852bf,0x00d8803d,0x78abacfc}},	//   _miez, रन्ध, _تبلت_, _ingv,
   {{0x60c994e0,0x6d41dbc2,0x387fdbc3,0x7c2d5447}},	//   lkem, ppla, lfur_, _egar,
   {{0x442d8a2c,0x7c3bbe87,0x13bd801b,0x2cab00f7}},	//   _oge_, _ofur, ्नुभ, áidí_,
   {{0x26fa000c,0x75298063,0x442ddbc4,0x60c9dbc5}},	//   ्त्र_, _niez, _nge_, nkem,
   {{0xfaa61155,0xd00f0013,0xb6a62657,0x6e3b0214}},	// [52a0] _запо, ملف_, ниал, _şuba,
   {{0x63a447fe,0xa29f8b84,0x7c3bdbc6,0x7c2d06da}},	//   _irin, _गोल्, _afur, _zgar,
   {{0x60c9dbc7,0x63a4007b,0x752981a9,0xb05b2821}},	//   kkem, _hrin, _biez, _plät,
   {{0x628e0f33,0x63a40357,0x2366936f,0xe45292c8}},	//   lebo, _krin, troj_, اضا_,
   {{0x26068105,0x7529dbc8,0x6abe01ec,0x63a200c3}},	//   _सुनी_, _diez, _kopf, _šonj,
   {{0x629c5bc9,0x442ddbca,0x63a400d7,0xb05b1f5b}},	//   ndro, _ege_, _mrin, _fläs,
   {{0xa3e7064a,0x6ec3800d,0x629c5424,0x7c3b831d}},	//   _येन_, ाउनु, idro, _ffur,
   {{0x628e5bcb,0x63a45bcc,0xf1b30039,0x25789eca}},	//   hebo, _orin, רסה_, vél_,
   {{0xb4be8c1c,0x7d02dbcd,0xb05b0192,0x67d4910e}},	//   ेसी_, moos, _klär, топу,
   {{0x7d0287f6,0x7c2d5bce,0x6d5c0115,0x628e04fe}},	//   loos, _sgar, _kvra, jebo,
   {{0x63a45bcf,0x2b400473,0x6d4e008e,0xa4d501b5}},	//   _arin, _atic_, _jwba, воні,
   {{0x629c0123,0x629adbd0,0xbebc81a9,0xe3a78061}},	//   edro, _hato, kmīg, _تشہی,
   {{0x629adbd1,0x44393b16,0x9b580698,0xddcb81dd}},	//   _kato, rcs_, ният_, ćišt,
   {{0x69a486bf,0x628e0c1b,0x443902e6,0x56938860}},	//   किपी, gebo, scs_, _башт,
   {{0x63a433dc,0x3a2504b8,0x629adbd2,0x30a70009}},	//   _erin, älp_, _mato, нрав,
   {{0x629ab13c,0x69d880d2,0x6d5acaae,0x7c2d5bd3}},	//   _lato, izve, msta, _ugar,
   {{0x63a425ed,0xe81c0076,0xe73307bd,0x2906822e}},	// [52b0] _grin, पेला_, اصر_, _mkoa_,
   {{0xdef82afb,0x629adbd4,0x66c0016d,0x7c3b8372}},	//   ных_, _nato, _sökr, _sfur,
   {{0x7529dbd5,0x68e2dbd6,0x63a4345f,0x6c6a0065}},	//   _piez, _omod, _zrin, _علیہ_,
   {{0x9e040162,0x69a48a75,0x69d881a9,0x629a8100}},	//   учул, किनी, dzve, _aato,
   {{0xe2999878,0x60c982d4,0x7529dbd7,0x6d5c5bd8}},	//   дал_, vkem, _viez, _evra,
   {{0x91e5ae7b,0x6d5abe80,0x68e28114,0x629a9afe}},	//   коле, ksta, _amod, _cato,
   {{0x7d02dbd9,0x6f01dbda,0x212b22e4,0x68e28609}},	//   boos, volc, _kich_, _bmod,
   {{0x442d813c,0x6d450234,0x629a9a2e,0x212b01d0}},	//   _uge_, mpha, _eato, _jich_,
   {{0x212b0352,0x60c9a5e0,0x6d5adbdb,0x387fdbdc}},	//   _mich_, rkem, esta, rfur_,
   {{0x6d5aa023,0x2cbf80f3,0x2cad83f1,0xfbd700ab}},	//   fsta, _houd_, _hned_, সপাত,
   {{0xb9b5af0a,0x63a41916,0x2cbfdbdd,0x628e3f8b}},	//   _جماع, _srin, _koud_, vebo,
   {{0xfce612b2,0x7bc60063,0x212b5bde,0x83fd8061}},	//   томо, tyku, _nich_, _időb,
   {{0x6d5adbdf,0x629ab433,0x75658065,0x629c0422}},	//   asta, _yato, ریکہ_, tdro,
   {{0x3d12159a,0xceb88063,0x212b0a2a,0x66c48032}},	//   _धीरे_, cję_, _aich_, _bòku,
   {{0xab271628,0x628e1142,0x23270c24,0x6d5adbe0}},	//   тора_, rebo, тори_, csta,
   {{0x09e100ab,0x26d11d20,0xceba8326,0x27360366}},	//   _মুহা, _alzo_, _riƙi_, _pæn_,
   {{0x212b5be1,0x6e3b1487,0xc05280be,0x290ddbe2}},	// [52c0] _dich_, _đubr, יזן_, ilea_,
   {{0x212b0355,0xb8c90665,0x7f440168,0x69a48b84}},	//   _eich_, _गो_, rpiq, किमी,
   {{0x225843f3,0x6b89a82b,0x212b02d6,0x290dabb7}},	//   mark_, _apeg, _fich_, klea_,
   {{0x6d5c8013,0x09f704de,0xa3cea1e3,0xcb6a9a19}},	//   árai, _ימים_, शनल_, даде_,
   {{0x629adbe3,0x6d5a8f28,0x693c026f,0x2bb7816f}},	//   _pato, zsta, _učeb, _आपणा,
   {{0x6d5adbe4,0x212b0613,0xdd920bca,0x6e432550}},	//   ysta, _zich_, _پور_, _верз,
   {{0x66e30adb,0x6b89826c,0x6d4506e7,0x610c01ec}},	//   _тора, _epeg, cpha, eßli,
   {{0x629a822e,0x2cbfac23,0x69d8dbe5,0x290d85f3}},	//   _wato, _goud_, rzve, glea_,
   {{0x6c7b80be,0x6d5a809a,0x24078012,0x69c7009a}},	//   _קאמפ, wsta, _анти_, zyje,
   {{0x2b468722,0x291f804f,0x70bf001b,0x2bdb9905}},	//   mpoc_, amua_, _एक्ल, _मेटा,
   {{0xd5b7835f,0x6d5adbe6,0x63a2dbe7,0x1e570039}},	//   вся_, usta, lvon, כשיר_,
   {{0x23698289,0x13c680ab,0xf09f0032,0x9ad3819d}},	//   šaje_, _শেয়, _akàn_, _jịnj,
   {{0x3f9880eb,0x212b5be8,0x29049502,0x21200824}},	//   ārus_, _rich_, moma_, dmih_,
   {{0x212b0943,0x6d5a8412,0x25fd8105,0x27ed1de3}},	//   _sich_, psta, _रुकी_, _ženo_,
   {{0x7aed82be,0x31c435cc,0x6d5a822b,0xe7178039}},	//   éati, аств, qsta, _שחור_,
   {{0x63a2c160,0xa3b2801b,0x257c01d0,0x68fb463a}},	//   kvon, टमा_, díl_, čudo,
   {{0x260681ab,0x6d454695,0xdb0400d7,0x212b0580}},	// [52d0] _सुती_, wpha, _oriè, _vich_,
   {{0x257c01a8,0x20f30267,0x2cbf81d0,0x290d811b}},	//   fíl_, pćio_, _soud_, zlea_,
   {{0x2904dbe9,0xa3e7035a,0x6b89a310,0x765701b4}},	//   koma_, _येत_, _speg, raxy,
   {{0x0ce180c8,0xe7de001b,0x60d65bea,0x5fde081f}},	//   যক্ত, _नेकप, chym, _नेकल,
   {{0x2904dbeb,0xfd5381bc,0x692a801b,0x63858a41}},	//   doma_, _begị, _přen, угла,
   {{0xe3b08ea5,0x3f995bec,0x291f81c0,0x4999a3e7}},	//   ترم_, _issu_, wmua_, етия_,
   {{0xa3e38006,0x45d50009,0x49bb803d,0xc8798380}},	//   _फेर_, _совс, باشد_, lişi_,
   {{0x60cd5bed,0x2904c141,0xb92881bc,0xf99092c5}},	//   nkam, goma_, _ikwụ_, تبه_,
   {{0x2fc92123,0x645983f8,0x7d09dbee,0x59d1800d}},	//   nyag_, mawi, _ikes, तनहर,
   {{0x60cd5bef,0x6459dbf0,0x752d002a,0x1e95997b}},	//   hkam, lawi, _aiaz, урир,
   {{0x7d1b885c,0x60cd14c7,0x290d8216,0xf8758199}},	//   _khus, kkam, plea_, _مهاج,
   {{0xc3290051,0x7e7e80f2,0x2904bbce,0x753548b3}},	//   _זו_, _öppn, coma_, _muzz,
   {{0x60cd1151,0x75350ffa,0x22585b75,0xb3831273}},	//   dkam, _luzz, tark_, блял,
   {{0xb05b00f2,0x68e9dbf1,0x31a38214,0xdb2081ac}},	//   _släp, lied, _kız_, _štúd,
   {{0x6459dbf2,0xaca3ba48,0xb928819d,0x443f81bc}},	//   kawi, _akọn, _nkwụ_, _ofu_,
   {{0x60cd043b,0x6459809a,0x68e99a22,0x7d09862b}},	//   gkam, jawi, nied, _nkes,
   {{0xef1a3714,0xad1b010f,0x0686282d,0x9d1b0039}},	// [52e0] ема_, _אוקר, лган, _אוקט,
   {{0x539b0051,0x68e9a5e5,0x7d0657d8,0x7d1b9bf4}},	//   _טיפו, hied, loks, _ahus,
   {{0xc27b0158,0x765506c0,0x64565bf3,0x629e0122}},	//   _אריי, _dezy, _keyi, _iapo,
   {{0x257c31a8,0x7d1bb30f,0x629e1049,0x6459dbf4}},	//   ríl_, _chus, _hapo, gawi,
   {{0x629e3286,0xaca38028,0x59b6b947,0xdb041a1f}},	//   _kapo, _chốn, _अपहर, _priè,
   {{0x2d51803a,0x6721803a,0x7d098133,0x63a28631}},	//   kše_, jmlj, _ekes, rvon,
   {{0x2d518db7,0x918680f7,0x2904dbf5,0x629e4a0a}},	//   jše_, اجتم, toma_, _mapo,
   {{0x629e1600,0x6459a73c,0xeb9a8f2e,0x6d5e1d6a}},	//   _lapo, cawi, _пиб_, mspa,
   {{0x2904dbf6,0x6d438110,0x752d002a,0x03a395b1}},	//   roma_, _atna, _riaz, _лито,
   {{0x2904a994,0xcaa680f7,0x672e0122,0x60cd5bf7}},	//   soma_, _حصري, _jibj, zkam,
   {{0x68e9dbf8,0x752d0098,0x58868048,0x443202c4}},	//   bied, _piaz, _была, _bgy_,
   {{0x68e99313,0x799a8205,0x60cd02a3,0x629e57ed}},	//   cied, _istw, xkam, _aapo,
   {{0x64560086,0x752d593a,0x69c81dd5,0x3eb88338}},	//   _deyi, _viaz, øden, örts_,
   {{0x44320986,0x945d8063,0x629e4043,0x6d5e26fa}},	//   _egy_, _końc, _capo, kspa,
   {{0x765adbf9,0x48ab22cb,0x160b9199,0x60c2dbfa}},	//   maty, нтам_, _सुपर_, _koom,
   {{0x64565bfb,0x7c2d8669,0x7d0600b9,0x765adbfc}},	//   _geyi, žari, coks, laty,
   {{0x62889234,0x7aea8082,0xce6b2306,0x6f1c0362}},	// [52f0] _obdo, kift, еред_, _bhrc,
   {{0x60c290b5,0x7c294c4d,0x6b8d535b,0xc8798457}},	//   _loom, žers, _ipag, rişi_,
   {{0x6459dbfd,0x999e81e2,0x3d950d9d,0x6d5e048d}},	//   tawi, _metų_, риер, gspa,
   {{0xfc3f5bfe,0x6b8d0133,0x6456011c,0xc50b80d7}},	//   ncí_, _kpag, _xeyi, رتال_,
   {{0x64598063,0x3f8007e2,0xa3e5000d,0x20d880f7}},	//   rawi, ctiu_, पछि_, _méid_,
   {{0x68e98d38,0x629e01df,0x7aeaa28f,0x6459c000}},	//   wied, _xapo, gift, sawi,
   {{0x68e9936e,0x7d1bcecf,0xfc3f027f,0x31a38085}},	//   tied, _thus, kcí_, _qız_,
   {{0x2d5180d2,0xaca38028,0x6b8d0091,0x08c59a02}},	//   vše_, _thốn, _opag, рбин,
   {{0x68e9ca33,0xaac611bc,0x645606c0,0x60c2dbff}},	//   ried, रॉडक, _reyi, _doom,
   {{0x63a9a459,0x6b9b82a3,0x66d2007b,0x249f81c5}},	//   _iren, _isug, _lækn, _haum_,
   {{0x68e9b6bb,0x249f815d,0x7d060009,0x60c28952}},	//   pied, _kaum_, toks, _foom,
   {{0x2d810307,0x629e5c00,0xe1f08154,0x2d51941f}},	//   ithe_, _sapo, _عسل_, rše_,
   {{0x9f6b8098,0x07478f75,0x765adc01,0x249f8282}},	//   _чрез_, _схем, baty, _maum_,
   {{0xe5a59f6e,0x212f8051,0xdb0083a7,0x63a99eb3}},	//   _вики, _high_, _irmã, _mren,
   {{0x2056002e,0x64565c02,0x6d438122,0xf09f046d}},	//   итар, _teyi, _utna, _baà_,
   {{0xfc320872,0x249fdc03,0x236080ce,0x776d01df}},	//   _بحث_, _naum_, šiji_, frax,
   {{0x629e47c7,0x26c32254,0xb605819d,0xe737246c}},	// [5300] _tapo, _bojo_, _fláà, иет_,
   {{0x6d5e0ac5,0x2ca0178f,0x3f802be1,0x26c30216}},	//   tspa, _haid_, rtiu_, _cojo_,
   {{0x63a9dc04,0x273b8104,0x3f803d5b,0x249fa761}},	//   _aren, _lên_, stiu_, _baum_,
   {{0x63a9cd5a,0x249f8069,0x98a60162,0x692a81d0}},	//   _bren, _caum_, _тиме, _přem,
   {{0x273b8104,0x249fdc05,0x7aea948c,0x63a9a2a0}},	//   _nên_, _daum_, tift, _cren,
   {{0x60c2dc06,0x63a9dc07,0x99668a13,0x809e94df}},	//   _soom, _dren, атил, _खोजे,
   {{0x7aea82fe,0xaca38028,0x291d80dd,0x212f8706}},	//   rift, _chồn, _bhwa_, _bigh_,
   {{0x273b8028,0x23698024,0x68f60114,0x63a9dc08}},	//   _bên_, šaja_, nnyd, _fren,
   {{0x69d58117,0xd90d8077,0x765ab6ff,0xbb43bdac}},	//   _üzen, ریه_, taty, _метк,
   {{0x249f81e9,0x2486826c,0xeeaa841c,0x212f8a2a}},	//   _zaum_, lfom_, ттик_, _eigh_,
   {{0x63a982ee,0x6b8d1180,0xdcfcc702,0x765ac702}},	//   _zren, _spag, _sprę, raty,
   {{0x20188086,0x765a8176,0x249f822c,0x57ea8cd0}},	//   ərin_, saty, _xaum_, _идем_,
   {{0x765ad9aa,0xd010803d,0x29120122,0x386682f9}},	//   paty, _علت_, dlya_, _idor_,
   {{0x81e800ab,0xfc3f01a8,0x2d815c09,0x6d489f0a}},	//   _বড়_, scí_, ythe_, ppda,
   {{0x68f60355,0xf1a42296,0x171b8158,0x26c315c7}},	//   fnyd, ортн, _שווע, _rojo_,
   {{0x776d5c0a,0x273b801c,0x40340198,0xfce42ba7}},	//   trax, _yên_, жетс, _мојо,
   {{0x645d0270,0x7d0d00ad,0x693c04ef,0x692a801b}},	// [5310] masi, _ikas, _učen, _přej,
   {{0x2be004e5,0x249f81c5,0x2ca03a20,0x539c0039}},	//   _पेटा, _saum_, _zaid_, _ייחו,
   {{0x62955c0b,0x249f81c0,0x66d2007b,0x63a980d7}},	//   mezo, _paum_, _tækn, _sren,
   {{0x645d5c0c,0x69c4000d,0x76588009,0x62955c0d}},	//   nasi, रहरी, _levy, lezo,
   {{0x68ed503e,0x26c30118,0xd37b8ce6,0x7d0d57d2}},	//   miad, _tojo_, тче_, _mkas,
   {{0x645d4450,0x68ed5c0e,0x7658850f,0x629521ab}},	//   hasi, liad, _nevy, nezo,
   {{0x645d1600,0x20d18013,0x49938bca,0x7d0d0fc2}},	//   kasi, _fáil_, تیار, _okas,
   {{0x68ed5c0f,0x62955bee,0x645d5c10,0x6b9b8300}},	//   niad, hezo, jasi, _tsug,
   {{0x9267dc11,0x63a9925c,0xa49b06c0,0x386681a1}},	//   _ندام, _uren, vlòp, _ddor_,
   {{0x7d0d1f62,0x2ca05c12,0x68ed0114,0x6295026c}},	//   _akas, _said_, hiad, jezo,
   {{0xdb2684c0,0x68f6031d,0xdca61285,0x09e580ab}},	//   _اولی, ynyd, бани, _পুরা,
   {{0x273b8104,0x6aa1800b,0xdb0084c3,0x3981a380}},	//   _tên_, _half, _irmá, mós_,
   {{0x68ed0355,0xb05b00f2,0x2ca00006,0xa3d786ce}},	//   diad, _poän, _vaid_, ानि_,
   {{0x8c1a8039,0x62950d35,0x6449811c,0x645d05ee}},	//   טורי, gezo, əmiş, aasi,
   {{0x645d5c13,0x6aa1dc14,0xf8db8063,0xa06a221f}},	//   basi, _malf, _बताय, лава_,
   {{0xa3d79521,0x68ed0114,0x60db8073,0xaca380ff}},	//   ाना_, giad, nhum, _khổn,
   {{0xbb860013,0x62955c15,0x6d4700eb,0xdb0981ed}},	// [5320] _الخي, bezo, _atja, _creë,
   {{0x692a801b,0xfca9db66,0x68f61407,0xe45f008b}},	//   _přek, یانو_, snyd, gjöf_,
   {{0x0d862dea,0x94128085,0x60db805d,0x39818177}},	//   слен, ədən_, khum, jós_,
   {{0x68ed282b,0x27038076,0x6b82b4d7,0x045a81bd}},	//   ciad, रकुर_, ttog, اجات_,
   {{0xdb00dc16,0xa3d28105,0x8c3d8214,0x69ce5c17}},	//   _armá, हैं_, _başb, lybe,
   {{0x645d5c18,0x78a41aed,0xd5d604d9,0x3981823e}},	//   zasi, ldiv, _любы, fós_,
   {{0x645d5c19,0x6b82c24d,0x60dbce12,0x6f08a304}},	//   yasi, stog, fhum, vodc,
   {{0x78a40698,0x27ed005c,0xa3e39993,0x6b82dc1a}},	//   ndiv, _ženi_, _फेक_, ptog,
   {{0xa92604e8,0x9ed8802e,0xd01081a8,0x629501f6}},	//   mažď, имит_, بلة_, yezo,
   {{0x645d11b7,0x693c0a20,0x68ed5c1b,0x3981a2c6}},	//   wasi, _pčel, ziad, bós_,
   {{0x645d5c1c,0xc04fa1d2,0x62951809,0xb80000ab}},	//   tasi, _ні_, vezo, ্ধিত_,
   {{0x691307d9,0x68ed04c3,0x6442bfde,0x60dbdc1d}},	//   rçek, xiad, ncoi, chum,
   {{0x6295011f,0x645d2d8d,0x68ed0510,0x78a423b9}},	//   tezo, rasi, viad, ddiv,
   {{0x68ed29a7,0xadfa03e8,0x27e0009a,0x7c360019}},	//   wiad, ्थान_, dzin_, _egyr,
   {{0x68ed031d,0x692a800d,0x36338f24,0xd5af8791}},	//   tiad, _přeh, _عروس, _эс_,
   {{0x957c8063,0x316c01ac,0x645d011c,0x32cb804a}},	//   rząd, ádza_, qasi, _høyt_,
   {{0x68ed5c1e,0x62955c1f,0x6d470a35,0x78a28c53}},	// [5330] riad, pezo, _stja, _maov,
   {{0x63ad5c20,0x68ed48e8,0xb8d003db,0xa3ac8816}},	//   _iran, siad, _टो_, गिन_,
   {{0x68ed2706,0x403501e2,0x69ce00f3,0x6aa1dc21}},	//   piad, _менс, cybe, _ralf,
   {{0x63ad5c22,0x398182b7,0x81c100ab,0x764907c0}},	//   _kran, vós_, ্ছদ_, _şeyd,
   {{0x2d9c013c,0xd0068124,0x256387c0,0x987a00be}},	//   æver_, _آل_, zıl_, _דארט,
   {{0x2369807a,0x3981bd9f,0x63ad1ab3,0x2563899b}},	//   šajo_, tós_, _mran, yıl_,
   {{0x60db8234,0x6aa19be9,0xa4d580e8,0xfd13806b}},	//   thum, _valf, _дові, _فجر_,
   {{0x63ad045c,0x2b49003b,0x3981c10f,0x69d58019}},	//   _oran, _otac_, rós_, _üzem,
   {{0x3ea32009,0x6aa1a911,0x2b4903e4,0xbcb4936f}},	//   _kajt_, _talf, _ntac_, šším,
   {{0x60dba6bd,0x66e580e8,0x4d659bab,0x7bcf00b9}},	//   shum, іона, оков, dycu,
   {{0x60db805d,0x3f84815d,0x27e05c23,0x2b494650}},	//   phum, atmu_, zzin_, _atac_,
   {{0x7fd58d13,0xa50a1ad2,0x81c100ab,0x3ea301a1}},	//   _мілі, рема_, ্ছা_, _lajt_,
   {{0x256387d9,0xf8bf00e7,0x78a4016b,0x60c600e1}},	//   sıl_, _liés_, vdiv, _rokm,
   {{0x63ad20b5,0xe57192c8,0x645b8362,0x78a28b80}},	//   _dran, _قطب_, _leui, _zaov,
   {{0x63ad5c24,0x7c3b0669,0xdb09c64c,0xd7658019}},	//   _eran, žura, _creé, _انڈی,
   {{0x63ad5c25,0x26c78c0b,0x8b960b79,0x27e05c26}},	//   _fran, _hono_, _дроч, tzin_,
   {{0xeb9a2318,0x46ea3eb1,0xaec6522f,0x26c7803d}},	// [5340] _тип_, адан_, обал, _kono_,
   {{0xafdb005f,0x27e05c27,0x26c78a14,0x3200a2f8}},	//   _iføl, rzin_, _jono_, şiyi_,
   {{0x63ad026f,0xa2a3016f,0x66d20215,0x765e5c28}},	//   _zran, _छोट्, _hækk, rapy,
   {{0xa3c1016f,0x83fd8061,0x645b8706,0xf8bf1b88}},	//   ूनच_, _időj, _ceui, _chéd_,
   {{0x693c0289,0x160b8076,0xfc3f05e4,0x7ed600e8}},	//   _oček, _सुसर_, ndía_, _дівч,
   {{0x38602176,0x44020063,0x6442a44e,0x29008196}},	//   lair_, _लखनऊ_, scoi, čiam_,
   {{0x66d24660,0xd2598a8e,0x645b902d,0x201d818f}},	//   _lækk, сці_, _feui, _azwi_,
   {{0x38604863,0xe81e8074,0x478a84dd,0xf4868061}},	//   nair_, _परदा_, асом_, _گاڑی,
   {{0x27e981f4,0xb60201d0,0x20ca8362,0x77640118}},	//   _žanr_, řádn, _bùir_, nsix,
   {{0x3860061f,0x753c5c29,0x26c7dc2a,0x66d2007b}},	//   hair_, _kurz, _cono_, _sækj,
   {{0x63ad57d6,0xa2be0592,0xd6d7835f,0x2b49474f}},	//   _sran, शान्, іть_, _stac_,
   {{0x63ad3f13,0x2ca6dc2b,0x386006cb,0xd05f0085}},	//   _pran, ndod_, jair_, biqə,
   {{0x3860082a,0x26c7a581,0x61358110,0xd0f980be}},	//   dair_, _fono_, _išla, _פּער,
   {{0x66d2006a,0xb4e78a27,0x8c3da2f8,0x248013de}},	//   _dækk, _पष्_, _maşa, _ecim_,
   {{0x692a801b,0x26f885fc,0x3ea324c5,0x63ad0428}},	//   _dřev, ुवीर_, _rajt_, _wran,
   {{0x63ad5c2c,0x3ea35c2d,0x38600857,0x765c02d6}},	//   _tran, _sajt_, gair_, _aery,
   {{0xb8e303b7,0x14ab8ebf,0x63ad4c50,0x765c5c2e}},	// [5350] _एच_, _घोषण, _uran, _bery,
   {{0x6298a368,0x957c8063,0xddab1071,0x7f4d0085}},	//   jevo, cząc, ител_, rpaq,
   {{0x80c700ab,0x3ea32009,0x386044b9,0x765c5c2f}},	//   রোগ্, _vajt_, bair_, _dery,
   {{0x8c3d8214,0x38604720,0xd251026a,0x291e0722}},	//   _başa, cair_, _تنگ_, ïtat_,
   {{0x645b82be,0x6aa509ca,0x765c4154,0xd7f85c30}},	//   _veui, _kahf, _fery, _дур_,
   {{0x7f3a0051,0x62988b3c,0xe299a29c,0x212900ee}},	//   _לעשו, gevo, сак_, lmah_,
   {{0x645b89c4,0x6aa500ee,0x753c04b9,0x7c9781a8}},	//   _teui, _mahf, _gurz, _وشرا,
   {{0x26c78021,0x26de8198,0x01fc01c6,0x673d5c31}},	//   _sono_, ehto_, יפול, _kusj,
   {{0x73d986e6,0x26c78071,0x6298b560,0x753c0192}},	//   _удар_, _pono_, bevo, _zurz,
   {{0x76451c33,0x66d2013c,0x6298dc32,0xd25180f7}},	//   nchy, _rækk, cevo, _أنا_,
   {{0x2129478e,0x386000dd,0xdca60878,0x64a6130f}},	//   kmah_, yair_, пани, пана,
   {{0x8c3d8459,0x656e81a8,0x38600609,0x64410035}},	//   _yaşa, ábha, xair_, ślin,
   {{0xf7498307,0x69ce834a,0x692a801b,0xd05f0085}},	//   _التي_, _über, _přev, qiqə,
   {{0x26de803e,0xfc3f0511,0xfaff0168,0x66d20366}},	//   chto_, rdía_, drës_, _vækk,
   {{0x38604772,0xfaff03ed,0x76ba81c6,0xdb041b88}},	//   tair_, erës_, _למספ, _criá,
   {{0x765c5c33,0x68fb807b,0xa5070098,0x24800bcf}},	//   _sery, nnud, _неща_, _ucim_,
   {{0x38605c34,0x765c5c35,0x969610f8,0x2ca480b9}},	// [5360] rair_, _pery, зреш, _ramd_,
   {{0xfc3f5c36,0x44205a5f,0x38600c41,0x7e61dc37}},	//   ndín_, _izi_, sair_, nalp,
   {{0x80db923a,0x1dcba207,0x2a5701c6,0xba9b01c6}},	//   बसाइ, ाहित, _מבין_, _פסטי,
   {{0xa3d78072,0x8c3da0ec,0x644618eb,0x6281913b}},	//   ानं_, _paşa, ncki, _aclo,
   {{0x7e618029,0x2ca6a87f,0x62988d02,0xaae5003d}},	//   kalp, rdod_, tevo, _رسیو,
   {{0x60c4003a,0x05cb8fcc,0x753c398c,0x62818362}},	//   ljim, ाहाब, _turz, _cclo,
   {{0x78a60025,0x6298dc38,0x628a831d,0x691302d0}},	//   _kakv, revo, rffo, rçev,
   {{0x60c40025,0x44200a2c,0x64a38bac,0x4034b4ba}},	//   njim, _ozi_, _паса, мейс,
   {{0x20d88307,0x6298d15a,0x44205c39,0xa3d7864a}},	//   _féin_, pevo, _nzi_, ानः_,
   {{0x7e618144,0xfa67a306,0xe8040035,0x7c208301}},	//   galp, _наук_, _रखना_, _izmr,
   {{0x44205c3a,0x3eb802f7,0xceb30039,0x78a65c3b}},	//   _azi_, _mnrt_, גית_, _oakv,
   {{0x98ab0162,0x48e3828e,0x60c41abf,0x75242aa0}},	//   _mică_, _похв, jjim, _chiz,
   {{0x60c40289,0x6b9d01ed,0x66d302d0,0x61359075}},	//   djim, uwsg, _yıkı, _ušla,
   {{0x7e618216,0x27f7816b,0x236d02d4,0x75240cdb}},	//   calp, šená_, šejo_, _ehiz,
   {{0x673d111b,0x44205c3c,0x78a60840,0xbd878124}},	//   _susj, _ezi_, _bakv, _فنون_,
   {{0xd5fb8039,0x60c40168,0x657a9a99,0xfaff03ed}},	//   _לפור, gjim, muth, trës_,
   {{0x6aa503ac,0x213e8a87,0x657aa0b3,0x67350144}},	// [5370] _tahf, _luth_, luth, _pizj,
   {{0x21293e55,0xdb04188b,0xfaff0168,0xb99900e8}},	//   smah_, _triá, rrës_, _двох_,
   {{0xfc3f0333,0x76450428,0x26ca02d4,0x0c4a81bc}},	//   ndío_, rchy, _dobo_, _ịdịl,
   {{0xe4e48d13,0x66d30214,0xb4d7ad05,0x6615001b}},	//   нічн, _sıkı, िसे_, _vyzk,
   {{0x65655c3d,0xfaa59bdc,0x657a8234,0x6f020036}},	//   sshh, дало, huth, éocc,
   {{0x657a91e8,0xb87b002a,0xf2c78fe6,0x4fd601c6}},	//   kuth, _emít, ясен, _חושב_,
   {{0x26fb05e8,0x659404f6,0xdd940084,0x7d0f0061}},	//   ्वीर_, _пару, _пары, kocs,
   {{0x23690025,0x26dc8187,0x213e8362,0x318e811c}},	//   _ovaj_, _alvo_, _duth_, _qəza_,
   {{0x3f8907d5,0x7e61dc3e,0x75241916,0x7c3ba4fc}},	//   ntau_, talp, _rhiz, _igur,
   {{0x68fb8264,0xe3b08bbe,0xef168009,0xb87b01d0}},	//   snud, _حرف_, ммы_, _hlíd,
   {{0xfc3f4622,0x645f0ace,0x213e8c41,0x23690bcf}},	//   rdín_, _beqi, _guth_, _avaj_,
   {{0xb4ca0e5b,0x3f8900b9,0x2d6781dd,0x7e61af2d}},	//   ोसे_, ktau_, rđe_, salp,
   {{0xef0e8c6e,0x7e6182d5,0x78a602f1,0x2d67826c}},	//   _ам_, palp, _rakv, sđe_,
   {{0xb4ba81ce,0xc72480e8,0x657a8234,0x60dd00f3}},	//   _अच्_, _здій, buth, _alsm,
   {{0x26ca4bf7,0x692a801b,0x7c3bbf5e,0x78a60084}},	//   _robo_, _třet, _ogur, _pakv,
   {{0x387fdc3f,0x7c3bdc40,0x693c005c,0x2b4d826f}},	//   ngur_, _ngur, _očev, _otec_,
   {{0xf7720013,0x3ea7a5d0,0x26ca04c3,0x60c42daf}},	// [5380] ضاء_, _kant_, _pobo_, rjim,
   {{0x63a43496,0x290081e2,0x7c3b86a2,0x6449818a}},	//   _isin, čiai_, _agur, _afei,
   {{0x78a6003a,0xdb0986a5,0x693c0088,0xa92615d1}},	//   _takv, _creí, _ačev, _одол,
   {{0x26ca0247,0xdb008019,0x60cb8fb0,0x628e5c41}},	//   _wobo_, _ismé, _nogm, lfbo,
   {{0xab9a826a,0x78a9aebd,0x3f890114,0xbb43b2f1}},	//   تخار_, ddev, ctau_, вечк,
   {{0xed5a4541,0x64498073,0x63a40010,0x78a9847f}},	//   _мог_, _efei, _msin, edev,
   {{0xa7fb01df,0x64498114,0x60cbdc42,0x78a99384}},	//   _veñe, _ffei, _bogm, fdev,
   {{0x63a42e4d,0x387fdc43,0x2b588019,0x657a81f6}},	//   _osin, ggur_, _فیصد_, vuth,
   {{0xa7fb062f,0x60cb82f7,0xb8f6a43f,0xe29284a3}},	//   _teñe, _dogm, _हव_, _لذا_,
   {{0x629c546b,0x20188029,0x692a800d,0x66cd81ac}},	//   jero, āri_, _přes, _súkr,
   {{0x9e770051,0x78a98279,0x58868048,0x6e3c00c3}},	//   וגיה_, bdev, _жыла, _mgrb,
   {{0x657a808c,0x63a40609,0xfc3f0333,0x6aa89670}},	//   ruth, _bsin, rdío_, _hadf,
   {{0x629c5c44,0x63a40065,0x3ea780e8,0x9b580081}},	//   fero, _csin, _fant_, мият_,
   {{0x3ea7dc45,0x81cd00c8,0x7f44011c,0x63a402f7}},	//   _gant_, _শেষ_, dqiq, _dsin,
   {{0x8c3d8afe,0x63a42370,0xf67b8039,0x23c500f1}},	//   _başl, _esin, _ואומ, _bëjë_,
   {{0x2369812b,0xe7d2a836,0x25f452d5,0xcd2b00d7}},	//   šaji_, _तथाप, ्पनी_, _بستن_,
   {{0x6d4e0029,0x6d5c1ab3,0x6aba800b,0x21268362}},	// [5390] _atba, _awra, _ontf, _mhoh_,
   {{0xdef804d9,0x6d40017f,0x7c3b8229,0x4a5500e8}},	//   мых_, _čmar, _sgur, _якос,
   {{0x62850135,0x3f892091,0x2d8700e7,0x2ca91e3b}},	//   _icho, stau_, îne_, _kaad_,
   {{0xd0100065,0x20d881a8,0x245881e2,0x2a7f0326}},	//   الے_, _béim_, даць_, ɗuba_,
   {{0xe66700c4,0x20d881a8,0xdcfc81a9,0x007601c6}},	//   _отво, _céim_, _aprē, _אתרי_,
   {{0x213900b9,0x2ca95c46,0x66d2008b,0x394105ee}},	//   _hish_, _laad_, _bæku, _kuhs_,
   {{0x8c3d8182,0x7e650101,0xb87b001b,0xf99188ca}},	//   _yaşl, mahp, _umís, ابت_,
   {{0x3ea7dc47,0x3a380051,0x6aba82af,0x7e6509ca}},	//   _sant_, ורום_, _entf, lahp,
   {{0x629c2922,0x78a9c17e,0x692a81d0,0x213903ed}},	//   yero, rdev, _přer, _mish_,
   {{0xb4ca03bb,0x629c2e24,0x21393e5b,0x62850133}},	//   ोस्_, xero, _lish_, _ncho,
   {{0xa2be1299,0x63a403f7,0xa3d7873c,0x6738cb0f}},	//   शास्, _ssin, ानक_, _divj,
   {{0x62855c48,0x3ea78051,0x63a40267,0x629c5c49}},	//   _acho, _want_, _psin, wero,
   {{0x3ea7dc4a,0x36d5af85,0x629c5c4b,0x2ca910b8}},	//   _tant_, _подр, tero, _daad_,
   {{0xbea29677,0x21390101,0x693c007a,0xe0df03ec}},	//   _башк, _aish_, _očet, _alò_,
   {{0x09e60b9c,0xc5fa00ab,0x682a0019,0x7e650748}},	//   ховн, _অর্থ_, ködé, dahp,
   {{0x63a40637,0xe45f1e2b,0x6738dc4c,0xe0df01e4}},	//   _tsin, ljön_, _zivj, _clò_,
   {{0x629c25e0,0x63a40051,0x21395c4d,0xd00712ea}},	// [53a0] pero, _usin, _dish_, еете_,
   {{0xa3b385e8,0xef172c38,0x3ce001c0,0x69c8006a}},	//   टिन_, ему_, _hliv_, ødes,
   {{0xe7f003eb,0x69c102f1,0x8c3d82d0,0xb917826b}},	//   _घेरा_, älet, _taşl, _didẹ_,
   {{0x20d1c92f,0x29023036,0xe73a2857,0x63f700d7}},	//   _máis_, _ujka_, _нем_, _آفیس_,
   {{0x883b0051,0x2912005d,0x98160250,0xdb098706}},	//   _מתכו, moya_, _سبحا, _breà,
   {{0x68e45c4e,0x9f4001ac,0x21268168,0x79a69b47}},	//   lhid, nzií_, _shoh_, ерие,
   {{0x7c969a84,0x6ee00065,0x3ce05c4f,0xdb040a53}},	//   _прац, _több, _oliv_, _asië,
   {{0x7c240353,0x3eaa01ec,0xb87b03aa,0x29002506}},	//   _ozir, _habt_, _ilíc, nnia_,
   {{0xd2528013,0x2ca92808,0x7c24331a,0x2900181c}},	//   _منذ_, _raad_, _nzir, inia_,
   {{0x15f40128,0x2ca95c50,0x7d045c51,0x63a2867d}},	//   _आधार_, _saad_, _ajis, mwon,
   {{0x3ce0013c,0x20d680e8,0x291205ee,0x68e45c52}},	//   _bliv_, _підс, koya_, khid,
   {{0x62855c53,0xa7fb016a,0x26c38106,0x26d983ed}},	//   _scho, _leña, öjor_, ësor_,
   {{0x29000063,0x21395c54,0x2912008e,0x63a2dc55}},	//   dnia_, _rish_, doya_, nwon,
   {{0x29008a8e,0x29000063,0x657e029b,0x2471001c}},	//   čiau_, enia_, kuph, ễm_,
   {{0x61258825,0x38622f9f,0x59a6850d,0x2912026b}},	//   sóle, _bekr_, _कैमर, foya_,
   {{0x63a2cbcd,0x29000081,0x291204b9,0xa3e08ef0}},	//   kwon, gnia_, goya_, दना_,
   {{0x2d980205,0x62850bfe,0xd251003d,0x442481a1}},	// [53b0] _apre_, _tcho, _پنج_, _nzm_,
   {{0x62854c86,0x290003b7,0x7d1d0408,0x7d04001b}},	//   _ucho, ania_, llss, _zjis,
   {{0x29123129,0x68e45c56,0x7e6500dd,0x63a281ed}},	//   boya_, bhid, rahp, ewon,
   {{0x693c5c57,0xdb040176,0x68e4079a,0x2b4986ea}},	//   _včet, _asiè, chid, íaco_,
   {{0x03a5a209,0xdb09bbec,0x386f841c,0x5c14abca}},	//   тило, _areá, _rdgr_, льшу,
   {{0xe2969354,0x78ad2947,0xf8bf00ff,0x2ca9826c}},	//   ваш_, ldav, _khéo_, žad_,
   {{0x692a801b,0xdb099727,0xb87b0118,0x693c007a}},	//   _přep, _creá, _glíc, _hčer,
   {{0x78ad38e4,0x0c7280d7,0x693c0140,0x27e900fe}},	//   ndav, _نگهد, _kčer, ozan_,
   {{0x27e9224a,0x443fd287,0x93948199,0x64598314}},	//   nzan_, _igu_, _مجلا, mbwi,
   {{0x7d162133,0xdb098118,0x443f808e,0xf1b30ec5}},	//   _skys, _freá, _hgu_, ुमान,
   {{0x1d0a1a19,0xa50a067c,0x3ce001c0,0x77698187}},	//   дени_, дена_, _pliv_, ssex,
   {{0x2369805c,0x434618a0,0x764903bf,0x8e360039}},	//   šaju_, кемв, _şeyl, כנתא_,
   {{0x68e45c58,0xe72edc59,0x83fd8019,0x26ce92ab}},	//   vhid, _ве_, _idős, _fofo_,
   {{0x78bd0bfa,0x8c3d87d9,0x68e42cb1,0x6283a79e}},	//   _ansv, _başk, whid, ngno,
   {{0x3f8dc1b4,0x68e4051e,0x290029bd,0x443fdc5a}},	//   lteu_, thid, tnia_, _ogu_,
   {{0x443fdc5b,0xa7fb05b4,0x60dba05e,0x7e638a84}},	//   _ngu_, _seña, nkum, _henp,
   {{0x1e860002,0xa6861091,0x6d43dc0f,0x2d98002e}},	// [53c0] клам, клад, _huna, _spre_,
   {{0x6d43dc5c,0xd37b012a,0x68e40b8f,0x5b7b04de}},	//   _kuna, _קריט, shid, _קריא,
   {{0x60db870f,0x181e805e,0xdb040118,0x64a68f9c}},	//   kkum, _पर्व_, _oriú, кажа,
   {{0x7ae1dc5d,0x752984cd,0x63a2dc5e,0x60db8267}},	//   _allt, _chez, twon, jkum,
   {{0x6d439364,0xa7fb04c3,0x31da801b,0xa8032306}},	//   _luna, _teña, बन्ध, _взял,
   {{0x7e638247,0x66d2013c,0x63a2dc5f,0xdb098333}},	//   _nenp, _væks, rwon, _preá,
   {{0x6d438041,0x693c0efd,0x99638071,0x63a2dc60}},	//   _nuna, _učes, атыл, swon,
   {{0x7c3b0042,0x63a280f3,0x442480b9,0x752986d8}},	//   žuri, pwon, _tzm_, _ghez,
   {{0x673c0181,0x68e30087,0x6d43dc61,0xb8fadc62}},	//   _kirj, _înde, _auna, _ठक_,
   {{0x7d02931b,0x6d4394f2,0x661c0687,0x6440026c}},	//   lnos, _buna, _kyrk, žmil,
   {{0x7e63b3bb,0x6d43ab69,0x867b0039,0x6d4480e1}},	//   _denp, _cuna, וריו, _čias,
   {{0x6d439341,0x7d02dc63,0x63b6195e,0x7ce6018a}},	//   _duna, nnos, _bryn, _nórd,
   {{0x69d587d9,0x7d1d3f7a,0x56948fbf,0x78ad0669}},	//   _üzer, rlss, _балт, vdav,
   {{0xdb0d062f,0x67da00eb,0x60cf5c64,0x68e28696}},	//   _traí, _mājā, _socm, _hlod,
   {{0x69d88019,0x68e2dc65,0xb87b016a,0x7d02c43d}},	//   nyve, _klod, _alía, knos,
   {{0x7ce61099,0x27e90102,0x20188085,0x63b62911}},	//   _córd, tzan_, ərir_, _fryn,
   {{0x78ad5c66,0x6d438353,0xb4df050d,0x3f80107f}},	// [53d0] rdav, _zuna, णसी_, guiu_,
   {{0x6d43dc67,0xe71900f7,0x64490110,0x443f806a}},	//   _yuna, ريات_, žeid, _sgu_,
   {{0x693c1234,0x28c583db,0x60cf0087,0x673c5c68}},	//   _včer, वामि, _tocm, _dirj,
   {{0x657a8c49,0x661c0257,0x6125807b,0x7d028ca9}},	//   irth, _dyrk, kóla, gnos,
   {{0xdfc69368,0xf8bf01ac,0x2919026c,0x38691aa6}},	//   _اي_, _iné_, _iksa_, maar_,
   {{0x386905f8,0xa92781ac,0x8c3d802e,0x9f9c807b}},	//   laar_, _obľú, _maşi, _ræða_,
   {{0x69d89450,0x7d02c19d,0x68e2a280,0x2489026c}},	//   gyve, bnos, _blod, _ocam_,
   {{0x443f82c1,0xe9468077,0x7d0287df,0x38690b3c}},	//   _ugu_, دروی, cnos, naar_,
   {{0x776d062f,0x6d4385a3,0x60c9885c,0x60dbdc69}},	//   nsax, _suna, rjem, rkum,
   {{0x6d43d1d8,0xfe7180f7,0x3f8ddc6a,0xeb0e83eb}},	//   _puna, حدة_, rteu_, ाकृत_,
   {{0x386910f4,0x26d101df,0x68e29f94,0x2d81369f}},	//   kaar_, _mozo_, _flod, nuhe_,
   {{0x68e298f4,0x38690fb0,0x63b60114,0x24890580}},	//   _glod, jaar_, _pryn, _ccam_,
   {{0x657adc6b,0xd1108aec,0xf8bf00ff,0x38694b97}},	//   arth, ावरण_, _chém_, daar_,
   {{0x6d43dc6c,0x6449062f,0x7d02935a,0x43430e8e}},	//   _tuna, ñeir, znos, серв,
   {{0x09e3197b,0x2a658267,0x7d02a581,0x6d43dc6d}},	//   борн, _melb_, ynos, _uuna,
   {{0xc486024b,0x4c860652,0x673c4483,0x205506f9}},	//   _слик, _слив, _sirj, итур,
   {{0x7d02beaf,0x63a9a169,0x661c00ee,0xdd0401a9}},	// [53e0] vnos, _nsen, _syrk, šsēd,
   {{0x7d02a1f5,0x3ea10192,0x661c0198,0x6b5b0e82}},	//   wnos, geht_, _pyrk, _רדיפ,
   {{0x386902b5,0x63a9cc37,0x6b9b819d,0xa2c29199}},	//   baar_, _asen, _apug, लास्,
   {{0x98ba0012,0x0b8ab511,0x938a82a4,0x5c068b79}},	//   _după_, ески_, еска_, ляла,
   {{0x628107a3,0x254c801b,0x63a98061,0x66741190}},	//   ólog, _měla_, _csen, _نگار,
   {{0x661c0e51,0x610881d0,0x68e2ae63,0x37cd0264}},	//   _tyrk, děla, _slod, _রেকর,
   {{0x63a9b328,0x7d029807,0x39459e9e,0xfd6501bc}},	//   _esen, pnos, _culs_, _mesị,
   {{0x58d484fa,0x02d1000d,0x6ad10107,0x2edc800d}},	//   роит, _सक्न, _सक्र, यस्त,
   {{0xdfd081a8,0x6cc38087,0x78a090ac,0x00000000}},	//   زيد_, _уйта, remv, --,
   {{0x2489151e,0x539b8039,0x83fd8019,0x6146b511}},	//   _scam_, _אימו, _időp, _бежа,
   {{0xdd948196,0x6b82dc6e,0x38690079,0xd5b78470}},	//   шаны, luog, yaar_, гся_,
   {{0xdb098003,0x13d880ab,0x657a80f7,0x705680f7}},	//   _preç, _দেয়, rrth, _إنشا,
   {{0x38691ad7,0xfd1f047f,0x7e6880e4,0x2d8100c3}},	//   vaar_, rlì_, padp, zuhe_,
   {{0xa7fb040e,0x3869037a,0xf41f0106,0x32d986c4}},	//   _seño, waar_, ffär_, _pèyi_,
   {{0x31c4017a,0x38695c6f,0x318e8085,0xa7fb0144}},	//   бств, taar_, _bəzi_, _peño,
   {{0x3eae8772,0x90551c57,0x6ad18072,0x6b82aaa0}},	//   _haft_, рвац, _तक्र, kuog,
   {{0x38690c11,0x81cd00ab,0x26d111b9,0x386680ee}},	// [53f0] raar_, _শেখ_, _pozo_, _meor_,
   {{0xbd6b3760,0x386697ca,0xe945026a,0x38691bfc}},	//   ерде_, _leor_, _پردی, saar_,
   {{0x80ba85b3,0x386914fb,0x752d4022,0x7127006b}},	//   _शोभे, paar_, _khaz, _مرحل,
   {{0x2d815c70,0x63a98bcf,0xa8a70a0e,0xdb160176}},	//   ruhe_, _psen, _срок, _aryè,
   {{0x3cfd000f,0x60cd3d95,0xd7fb01a1,0xda6590f8}},	//   _लगने_, mjam, _чун_, авли,
   {{0x321e826f,0x450b00ab,0x6125809a,0xe299dc71}},	//   _byty_, রতিক_, góln, так_,
   {{0x60cd01e2,0xd49b8a8e,0x6ee008aa,0xdb009eec}},	//   ojam, _пра_, _möbl, _armó,
   {{0xdfd18013,0x44292c88,0x50b5a154,0x2cbf8122}},	//   قيع_, _oza_, рску, _unud_,
   {{0x7d1b80ad,0x6d4727ba,0x63a9dc72,0x82878829}},	//   _ikus, _huja, _usen, _مجال,
   {{0x6d475c73,0x59678698,0x7c29dc74,0x8c3d8214}},	//   _kuja, _бъда, _izer, _başv,
   {{0x28c581a2,0x44295c75,0xa3b3809a,0x6cc63832}},	//   वादि, _aza_, टिव_, айна,
   {{0x386987ca,0x6d475c76,0x752d5c77,0x6125818a}},	//   _þar_, _muja, _chaz, mólo,
   {{0x7d09830b,0x89348b76,0x68e9dc78,0x6125802a}},	//   _mjes, _اعلا, mhed, lólo,
   {{0x60cd00eb,0x7e67001b,0x7d0994ce,0x68e99de6}},	//   ejam, _nejp, _ljes, lhed,
   {{0x7d1b94ee,0xa06a08d5,0x44294ebb,0x6125a706}},	//   _okus, кава_, _eza_, nólo,
   {{0x68e9976f,0x752d3e5a,0x2a6a0019,0x0f1e01a2}},	//   nhed, _ghaz, sabb_, भत्स_,

   {{0xb8fe1499,0x0e661506,0x27ed9d77,0x03a627cb}},	// [5400] _तक_, икан, nzen_, _типо,
   {{0xe9da0abe,0x44205c79,0x7d1bdc7a,0x6d472d68}},	//   _ако_, _iyi_, _akus, _buja,
   {{0x7c298201,0xc27b012a,0x6aa3a382,0xa6db007b}},	//   _azer, _בריי, denf, _guðm,
   {{0x7afc07d9,0x6ec406ab,0x44201bb7,0x81b98326}},	//   lirt, राहु, _kyi_, _gaɓɓ,
   {{0x27ed8613,0x7c298063,0x68e9cf15,0xdb008144}},	//   jzen_, _czer, dhed, _asmá,
   {{0x66e601f3,0x78a45c7b,0x7d1b8234,0x6aa3dc7c}},	//   _тога, leiv, _ekus, genf,
   {{0xdcfe80fe,0x386682ba,0x7c29dc7d,0x64a69597}},	//   lupč, _peor_, _ezer, _кава,
   {{0x68e9b51d,0xc9530451,0x44200135,0x68fb8081}},	//   ghed, חמה_, _oyi_, giud,
   {{0x4420217b,0x6125809a,0x6d470503,0x69dc5c7e}},	//   _nyi_, póln, _zuja, hyre,
   {{0x7d1b801b,0x60cd07d8,0x7522dc7f,0x64440706}},	//   _zkus, zjam, lloz, _agii,
   {{0x6d40c3b7,0x6125a82b,0x44205c80,0x75228904}},	//   _kima, cólo, _ayi_, oloz,
   {{0x6d40a2e9,0x68e9dc81,0x752d4732,0x68fb923d}},	//   _jima, ched, _qhaz, ciud,
   {{0xdcfc80eb,0x8f5486e2,0x3eae82f7,0x60c2c654}},	//   _aprī, _انتش, _taft_, _inom,
   {{0x3f84dc82,0x6e948250,0x35f7803d,0xdb0992f1}},	//   mumu_, _طلبا, ارید_, _treå,
   {{0x5d848013,0x4420077f,0x3f84c146,0x60cd0722}},	//   _العل, _eyi_, lumu_, tjam,
   {{0x6d5a8e99,0x6d40da6d,0x6d475c83,0x44200295}},	//   mpta, _nima, _ruja, _fyi_,
   {{0x60cd2cc7,0x6d472eb7,0x7afc473c,0x7d09911b}},	// [5410] rjam, _suja, birt, _rjes,
   {{0x63ad343a,0x6d471b09,0x539a0039,0xc9871c8b}},	//   _isan, _puja, _עיתו, _куми,
   {{0x7c298986,0x7d09dc84,0xdb0d0214,0x6d40ae5f}},	//   _szer, _pjes, _araç, _bima,
   {{0x3f84a95e,0xbd188cde,0x4518835f,0x6d4090fe}},	//   kumu_, ації_, ація_, _cima,
   {{0x3f848341,0x6d40a8a7,0x7c20a065,0x889a0496}},	//   jumu_, _dima, _cymr, _גברי,
   {{0xd945a856,0x60c2dc85,0x3f84dc86,0xa9699ddf}},	//   беки, _anom, dumu_, гика_,
   {{0x7d0982ce,0x442981ac,0x6d4080fc,0xe05782e3}},	//   _tjes, ťa_, _fima, لیات_,
   {{0x27eddc87,0x7d1b805d,0x27ed003e,0x6d40b1ec}},	//   tzen_, _ukus, _ženy_, _gima,
   {{0x8aa785c2,0x7c208355,0x3f84dc88,0x68e9b51d}},	//   _вред, _gymr, gumu_, rhed,
   {{0x28c5946d,0x39b58029,0x2bcb06b7,0x27ed9d77}},	//   वाहि, _tās_, ामना, rzen_,
   {{0x44260029,0x63ad5c89,0x99d98013,0x44200590}},	//   _šo_, _asan, _حواء_, _syi_,
   {{0x3f84dc8a,0x7afc01ec,0x2b410176,0x7d198035}},	//   bumu_, wirt, _aihc_, nows,
   {{0x7ce600f7,0xeb9710ff,0x7afc2270,0x2b49002a}},	//   _córa, бия_, tirt, _cuac_,
   {{0x69dc460a,0x63ad008e,0x386d89ff,0x59bd8f0f}},	//   tyre, _dsan, laer_, ्मपर,
   {{0x63ad5c8b,0xf2d28158,0x69dc87d9,0x7afc0125}},	//   _esan, לעך_, _üret, rirt,
   {{0x7ce60307,0x63bb8091,0x26c30187,0xdcfb00eb}},	//   _fóra, _orun, _anjo_, putā,
   {{0x6d40dc8c,0x44260028,0x2d85cd30,0x7afc3518}},	// [5420] _rima, _áo_, lule_, pirt,
   {{0x6d40dc8d,0x3ea599f6,0x69c829dd,0x7c5700d7}},	//   _sima, nelt_, ädes, _پلیر_,
   {{0xa0a65c8e,0x63bb905c,0x6d40dc8f,0x7522c895}},	//   _ланд, _arun, _pima, tloz,
   {{0x20d88013,0x237f077b,0xdb0d0187,0xfd508032}},	//   _léir_, šuje_, _praç, _aadọ,
   {{0x3ea5a28f,0x2d85dc90,0xd91b0039,0x26180ad5}},	//   kelt_, hule_, _תוכל, _बुरी_,
   {{0x2d85a0aa,0x291d8870,0x394201bf,0x6f1c011f}},	//   kule_, _akwa_, _hiks_, _ukrc,
   {{0xd1308117,0x63bbdc91,0x3ea5829e,0xa96784bd}},	//   ومت_, _erun, delt_, бија_,
   {{0x3f84dc92,0x63bbd6e8,0xdb0d5c93,0xa3a90006}},	//   tumu_, _frun, _traç, _गईल_,
   {{0x63bb95ce,0x39420006,0x3ea5805f,0x7b07bb69}},	//   _grun, _miks_, felt_, órtá,
   {{0x3f84dc94,0x3ea5dc95,0xb6c68009,0x675380f7}},	//   rumu_, gelt_, ссий, أخير,
   {{0x63ad0c2e,0x3860036e,0x2d85db89,0x2a6e808e}},	//   _ssan, kbir_, gule_, mafb_,
   {{0x6d5a8df1,0x39420b3c,0x63ad01d0,0xdb045c96}},	//   rpta, _niks_, _psan, _orió,
   {{0x3860284e,0x3ea584fe,0xddc18b67,0x28c58bb8}},	//   dbir_, belt_, ralš, वारि,
   {{0x2d85b328,0x628a84fe,0xde58a1d2,0xd84f01bc}},	//   bule_, ngfo, _такі_, _lọta_,
   {{0xa3a905e8,0x2d858f77,0x13c380ab,0x31c40992}},	//   _गैर_, cule_, ্নয়, пств,
   {{0x63ad5c97,0xdb0401df,0x3f805c98,0x7ce619ae}},	//   _tsan, _brió, friu_, _tóra,
   {{0x69c80884,0x7d0d008e,0x61050110,0x6d4ab2dc}},	// [5430] äder, _ijas, nėli, _hufa,
   {{0x6d4aa80d,0x3ce925f7,0x7c2d5c99,0x7c26936f}},	//   _kufa, _hlav_, _izar, _úkry,
   {{0x957c809a,0x39420147,0xd84f11d3,0x386001b9}},	//   cząt, _fiks_, _bọta_, bbir_,
   {{0x6d4a8deb,0x6f1ac78b,0x6aa70267,0x3f802484}},	//   _mufa, hotc, lejf, briu_,
   {{0x3f80009f,0xd37ba762,0x7d19dc9a,0x68ed498e}},	//   criu_, уче_, rows, mhad,
   {{0x6d58803b,0x68ed5c9b,0x4ea7002e,0xa5e71ea4}},	//   _otva, lhad, _урма, _любл,
   {{0x20d88013,0xda788c5c,0x6f1a8295,0x28c5809a}},	//   _réir_, сяч_, dotc, वालि,
   {{0x63bb8add,0x68ed5c9c,0xe0d99cd5,0x6f0880ee}},	//   _trun, nhad, рви_, endc,
   {{0x4439dc9d,0x6d588bb6,0x3ea5c5ea,0x63bbdc9e}},	//   _às_, _atva, telt_, _urun,
   {{0x2d85db89,0x6d4a930e,0x7ce6002a,0x7d0d07b8}},	//   tule_, _bufa, _córn, _ajas,
   {{0x3cca0abe,0x7079819f,0x3ea5ad03,0x7c2d5c9f}},	//   ално_, _نماز_, relt_, _azar,
   {{0x3ea58665,0xf2c90039,0x6d4adca0,0x3ce9026c}},	//   selt_, _בע_, _dufa, _clav_,
   {{0xa3e984e5,0x7c2d009a,0xdb04282b,0x2d8598d0}},	//   मनि_, _czar, _asiá, sule_,
   {{0x764700f1,0x7c2d00dd,0x7b1f8187,0x6f1a8362}},	//   _ngjy, _dzar, cêut, cotc,
   {{0xc5d58d13,0x442d801b,0x7c2d011e,0x6d4a82a0}},	//   _філь, _lze_, _ezar, _gufa,
   {{0x68ed125b,0x442ddca1,0xa92600e8,0x7d0d00f1}},	//   ghad, _oze_, ідал, _gjas,
   {{0x442d82ec,0x6ecd8035,0x6d4adca2,0x272f1238}},	// [5440] _nze_, तापु, _zufa, züne_,
   {{0x6125808b,0x63a0808e,0x98b901a9,0x1db0dca3}},	//   fólk, _rpmn, _visā_, _जनमत,
   {{0x68ed5bae,0x394200eb,0x442ddca4,0x412a004a}},	//   bhad, _tiks_, _aze_, _воно_,
   {{0x68ed0782,0x0c26831f,0x3f804650,0x764907c0}},	//   chad, омен, priu_, _şeyt,
   {{0x8c3d8201,0xf77212dc,0x442d8035,0x78b60048}},	//   _başq, _تاج_, _cze_, mdyv,
   {{0x6d441bda,0xe81d8035,0xf21f03db,0x69c30118}},	//   _liia, _पड़ा_, _मुड़_, _ánec,
   {{0xfce68af2,0x442d8870,0xa7fb016a,0x84e6804a}},	//   _дово, _eze_, _reñi, _довж,
   {{0x6d5e0009,0x26d85ca5,0x68e45339,0x6d4aa813}},	//   mppa, _horo_, nkid, _rufa,
   {{0x6d58805c,0x27e02b5f,0x7c240a5a,0x4ea6bff1}},	//   _stva, nyin_, _nyir, орна,
   {{0x232a8698,0xf5498028,0x7f43c58e,0xd6da8db3}},	//   _този_, _vấn_, _cinq, рти_,
   {{0x290902a3,0x3ce9358f,0x81df00ab,0x7c2d29bd}},	//   ynaa_, _plav_, _দেন_, _szar,
   {{0x26d85ca6,0xf549801c,0x98a68e8e,0x6d444963}},	//   _loro_, _tấn_, _фиде, _ciia,
   {{0xa7fb0216,0x7ce62363,0x6d4a808e,0x25a98b80}},	//   _teñi, _tórn, _wufa, _ćale_,
   {{0x26d85ca7,0x6d4a854e,0xdb041041,0x394c826c}},	//   _noro_, _tufa, _briñ, _kuds_,
   {{0x68ed12be,0x5b14035f,0x6d58a1ad,0x6d440706}},	//   thad, ємст, _utva, _fiia,
   {{0x02b783bb,0x7d0d1fb6,0xb05b0106,0x6ab78072}},	//   _आफ्न, _ujas, _gnäl, _आफ्र,
   {{0x68ed1a67,0x26d8236a,0x7d1d2f5d,0xf7730277}},	// [5450] rhad, _boro_, moss, باز_,
   {{0x68ed5ca8,0x7d1d2ada,0xd5bb023a,0x26d85ca9}},	//   shad, loss, исе_, _coro_,
   {{0x26d80135,0x254808c5,0xdb044752,0x68ed5caa}},	//   _doro_, _oğlu_, _griñ, phad,
   {{0x7d1d2a49,0xe3b19459,0xe4e48d8e,0x44248035}},	//   noss, فرت_, мічн, _bym_,
   {{0x26d85a5e,0xef9309d7,0x6b8291fe,0x7ba780f7}},	//   _foro_, _زیاد, grog, تصام,
   {{0x6d020fea,0xa6db007b,0x26d82eb7,0xdb0d1243}},	//   _लगभग_, _auðv, _goro_, _araú,
   {{0x7d1d15c8,0xddc38087,0x26c980ff,0x1a9c03de}},	//   koss, _menţ, _đao_, ייגע,
   {{0x26d80133,0x7f43dcab,0x6b8297d6,0xf8bf00ff}},	//   _zoro_, _sinq, brog, _ghét_,
   {{0x6d0205b3,0x7d1d04fa,0x442daa0c,0x61258825}},	//   _लगबग_, doss, _uze_, nóli,
   {{0xb05b016d,0x394c81a1,0x68e4011b,0x6d4402f1}},	//   _snäl, _fuds_, zkid, _siia,
   {{0xa3b38aed,0x7c24010b,0x394c81a3,0xe165803d}},	//   टिक_, _syir, _guds_, _رضای,
   {{0x692c01ec,0x499a8039,0x27e031e0,0x629e01a1}},	//   eßen, _לשעב, yyin_, _sbpo,
   {{0xddd50019,0xeb9715a6,0x395a0144,0x6d442446}},	//   _mező, пия_, _stps_, _viia,
   {{0xf09f0091,0x78a98365,0x249f8216,0x273406ae}},	//   _abà_, leev, _lbum_, mäng_,
   {{0x26d832e2,0x6f01dcac,0xc3328039,0xf1bd9c7b}},	//   _roro_, milc, גום_, ्मिन,
   {{0x80a18063,0x26d82d10,0x7d1d4e2a,0x6125dcad}},	//   _कॉमे, _soro_, coss, fóli,
   {{0x26d85cae,0xdb04007b,0x68e45caf,0x290005ee}},	// [5460] _poro_, _frið, rkid, riia_,
   {{0x63a45cb0,0x68e41611,0x7cf60612,0x41bd89c2}},	//   _ipin, skid, ršru, ्मास,
   {{0x629c3b07,0x32db01c6,0x27f20035,0x4424dcb1}},	//   mfro, _החינ, szyn_, _sym_,
   {{0x31570158,0xf7461264,0xf09f10ab,0xf54980ff}},	//   _מיטן_, _немо, _gbà_, _nấm_,
   {{0xaac7823c,0x61258272,0xf8bf816f,0xddc500e1}},	//   लांक, cóli, _शोधय, rahš,
   {{0x628e2c15,0xb4e90743,0xe7370098,0x249f8133}},	//   ngbo, _यत्_, _нея_, _ebum_,
   {{0xada3024f,0x394c8a84,0xf549801c,0x7ce60118}},	//   _парл, _quds_, _bấm_, _pórl,
   {{0x4424a19c,0x26c78698,0xf54980ff,0x249fb7ee}},	//   _tym_, _anno_, _cấm_, _gbum_,
   {{0x40538013,0x6d4e19b0,0x2b4599dc,0x3ce6a39f}},	//   رئيس, _huba, _filc_, mkov_,
   {{0x6d4e06b0,0x3ce68db7,0x7d02dcb2,0x6f1e0503}},	//   _kuba, lkov_, lios, nopc,
   {{0x63a42b40,0x06970051,0x2d78042b,0x7d1d1f5d}},	//   _apin, הדים_, nče_, toss,
   {{0x6d4e257c,0x3ce6dcb3,0x7afe067f,0x7d02dcb4}},	//   _muba, nkov_, _ampt, nios,
   {{0xa847806b,0x6d4e5cb5,0x629c5cb6,0xe81c01ce}},	//   _علوم_, _luba, ffro, _भुला_,
   {{0x6d5c5aa8,0xa77b8051,0x5693838c,0xdb1b8388}},	//   _otra, _פרופ, _зашт, _prué,
   {{0xd3088104,0x3a250022,0x39469142,0x2d7819ce}},	//   yện_, ælp_, _kios_, jče_,
   {{0x58d42386,0x612587a3,0x6aaa8c19,0x3ce68619}},	//   ност, tóli, heff, jkov_,
   {{0x7d02dcb7,0x3ce6875f,0x84981921,0x3946da4a}},	// [5470] dios, dkov_, _رئيس_, _mios_,
   {{0xe8df019d,0x6d4e5cb8,0xceb89c28,0xac990019}},	//   _ipọd_, _buba, ndę_, _اچھا_,
   {{0x6d4e2d2a,0x3f528028,0x7bc0dcb9,0x94d58221}},	//   _cuba, _lâu_, _armu, можц,
   {{0x2ea9801b,0xeae586a7,0xa7fb0216,0xe81d8f85}},	//   _कस्त, कस्त_, _señu, _पडला_,
   {{0x212914ec,0x6d5c0ee7,0xddc3826f,0xa6db007b}},	//   mlah_, _etra, _menš, _suðu,
   {{0x212904aa,0x7b3981bc,0xf549827d,0xaac781a2}},	//   llah_, _aňur, _sấm_, लाइक,
   {{0x6d5c5579,0x6d4e4c45,0x6f01d02e,0x7bc089e8}},	//   _gtra, _guba, vilc, _ermu,
   {{0x21290867,0xb925046d,0xe8df81bc,0x27340338}},	//   nlah_, _aipẹ_, maịa_, täng_,
   {{0x3946b1a2,0x3f528028,0x6d4e5cba,0x21290859}},	//   _dios_, _câu_, _zuba, ilah_,
   {{0x60069006,0x21290057,0x3ceddcbb,0x3cff822c}},	//   ьным_, hlah_, _hlev_, _hmuv_,
   {{0x39468046,0x212914ff,0x6d5c4818,0x34aa140b}},	//   _fios_, klah_, _xtra, овно_,
   {{0x13e180c8,0x6f01807a,0xeb9a5cbc,0x59a68f3d}},	//   _মেয়, silc, оим_, _कैटर,
   {{0x4c9a8039,0x6f01dcbd,0xa2c28072,0x80098061}},	//   חברו, pilc, लाच्, _براہ_,
   {{0x7d02dcbe,0x66058c40,0xfe7180d5,0x6d5a00e7}},	//   zios, _опла, _شدت_, _étag,
   {{0x4343067c,0xa3b4800d,0x212900ee,0x7b090267}},	//   терв, _छैन_, flah_, džud,
   {{0x6d4e5cbf,0x7d0284c3,0x52da8074,0x2129036e}},	//   _ruba, xios, _बक्स, glah_,
   {{0x6d4e3bd5,0x3ce69fc2,0x27308362,0xd24f0065}},	// [5480] _suba, vkov_, làna_, انہ_,
   {{0xe73701a1,0x212910e1,0x6c680065,0x61e381b0}},	//   деу_, alah_, _بلکہ_, kynl,
   {{0x3ce6a52d,0x3ced93c2,0x550206b7,0x2734016d}},	//   tkov_, _blev_, _लगाए_, vänd_,
   {{0x25d6893f,0x7e6e5cc0,0x2d85954c,0x2d538073}},	//   ווען_, _webp, irle_, _mãe_,
   {{0x69c1dc45,0x5f760eca,0x6b9981c0,0xb4ae83eb}},	//   _arle, _تاجر, gtwg, _कसी_,
   {{0x3ce6dcc1,0x98b90110,0x450600ab,0x2d780654}},	//   skov_, _visą_, ৈতিক_, pče_,
   {{0x6aaa949d,0x3f52801c,0x05660d8e,0xda001513}},	//   reff, _sâu_, _іван, ोपित_,
   {{0x3eb8115b,0x57b4891c,0x6b8bdcc2,0xceb8809a}},	//   _hart_, ебит, bugg, wdę_,
   {{0x69c1c751,0xb7db0158,0x394689da,0x3eb80b0b}},	//   _erle, ַקטי, _vios_, _kart_,
   {{0xddce0bb6,0x6a83896f,0x75241c40,0x81bc80eb}},	//   _nebū, _алфа, _akiz, _dzēr,
   {{0x3eb805b2,0xceb30039,0x2120026c,0x7ce60061}},	//   _mart_, דית_, koih_, _kórh,
   {{0x6ee4809f,0xa3b58074,0x3eb80168,0x0fb683b7}},	//   _mòbi, _जनम_, _lart_, _अनपढ,
   {{0x44320d38,0x29048025,0xd943b714,0x2d85900a}},	//   _czy_, mima_, _реци, arle_,
   {{0x2904dcc3,0x1eaa81ad,0x75240365,0x28e10075}},	//   lima_, _ذاتي_, _ekiz, _नवहि,
   {{0x39150381,0x21290867,0x98a68035,0x26cd00ff}},	//   емвр, tlah_, _choć_, _đeo_,
   {{0x212909ca,0xf8bf00ff,0x61258118,0x3eb85cc4}},	//   ulah_, _chép_, sólv, _aart_,
   {{0x2129372d,0xf7700bbe,0x2d8cdcc5,0x26dc8110}},	// [5490] rlah_, لال_, lude_, _kovo_,
   {{0x44295cc6,0x21290057,0x2904dcc7,0x26dc8b80}},	//   _iya_, slah_, hima_, _jovo_,
   {{0x2d8c803b,0x61e100f2,0x2129010b,0x3ced81c0}},	//   nude_, älld, plah_, _plev_,
   {{0x29048025,0xd25109d7,0x44290c56,0xf8bf00ff}},	//   jima_, _جنگ_, _kya_, _ghép_,
   {{0x290482a5,0x80cc020e,0xb87b01a8,0x2d8cdcc8}},	//   dima_, हारे, _dlít, hude_,
   {{0x26dcdcc9,0x41b5a457,0x78a28039,0x659513bd}},	//   _novo_, есит, _abov, _пагу,
   {{0x60dd2f16,0x442902ec,0x2d8cdcca,0xdb098362}},	//   _kosm, _lya_, jude_, _breò,
   {{0x4429148e,0x290d802e,0x2d8cdccb,0x644d01a8}},	//   _oya_, unea_, dude_, _ngai,
   {{0x44295ccc,0x61e38aa2,0x290db349,0xf0768019}},	//   _nya_, synl, rnea_, ریوں_,
   {{0x4d6585c2,0x644d435c,0x26dc80e5,0x75245ccd}},	//   нков, _agai, _covo_, _skiz,
   {{0x44295cce,0x29048503,0x7c29ae3a,0x644d00dd}},	//   _aya_, bima_, _hyer, _bgai,
   {{0x29048025,0x442901d3,0x09bd84e5,0x998d009a}},	//   cima_, _bya_, ्मीय, łeś_,
   {{0x44290578,0x644d0580,0xb87b1243,0x78ad39ff}},	//   _cya_, _dgai, _moíd, deav,
   {{0x2d8c803e,0x67238289,0x68e9dccf,0x91fc80eb}},	//   bude_, _uknj, lked, _teāt,
   {{0x28d385e8,0xf8bf0028,0x672186ec,0x60dd1de6}},	//   थापि, _phép_, molj, _bosm,
   {{0x68e9dcd0,0xb4ae816f,0x672182ce,0xa3cf800c}},	//   nked, _कसे_, lolj, षमा_,
   {{0x7c29dcd1,0x3eb80809,0xa7a70912,0xf77201a8}},	// [54a0] _nyer, _part_, нкта_, طاء_,
   {{0x290493b2,0x7d06388d,0x6721dcd2,0x78b981c0}},	//   zima_, liks, nolj, _lawv,
   {{0x7c29ab5f,0x3eb8021e,0x68e9928d,0xf8bf00ff}},	//   _ayer, _vart_, kked, _thép_,
   {{0x61e10c3c,0x78ad0749,0x7c2980b4,0xb87b3dcd}},	//   älle, ceav, _byer, _coíd,
   {{0x2904803b,0xa29485e9,0xd3268c4f,0xdce20713}},	//   vima_, валі, ньки, ntlı,
   {{0x60cb828c,0xd24f9ef7,0xdb098144,0x67218115}},	//   _angm, منه_, _breñ, jolj,
   {{0xfbd880c8,0x6721811f,0xe7370749,0x2b5f8197}},	//   _দেখত, dolj, _чер_, _etuc_,
   {{0xd3728077,0x859b0039,0x673e00f3,0x7bc45cd3}},	//   _مهر_, _משלו, lmpj, _oriu,
   {{0x7c298065,0x7d065cd4,0x6d5a02be,0x26dc8317}},	//   _gyer, diks, _étab, _povo_,
   {{0x2d8ca4c4,0x798e2169,0x442902a0,0x75228c2e}},	//   tude_, kubw, _rya_, looz,
   {{0x44295cd5,0x7bc45cd6,0x23605cd7,0x7d06377c}},	//   _sya_, _ariu, _atij_, fiks,
   {{0x399a80f1,0x2d8cdcd8,0x2ba78054,0x9c130135}},	//   mës_, rude_, _गहमा, kọta,
   {{0x66e6a80f,0x24800355,0xdee68ff7,0x399a80f1}},	//   _пода, _ddim_, _поди, lës_,
   {{0x442900f6,0x657c35ca,0xd5b0803d,0x26dc847f}},	//   _vya_, _ovrh, _نفت_, _uovo_,
   {{0x399a820f,0x28c58996,0x60dd0a25,0x51840adb}},	//   nës_, वाचि, _posm, лута,
   {{0x88bd8063,0x61f58019,0x28a680d4,0x7bc4047f}},	//   mośc, _üzle, _कॉमि, _friu,
   {{0x81df00c8,0x399a80f1,0x61e10106,0x4429036a}},	// [54b0] _দেশ_, hës_, ällb, _uya_,
   {{0x399a820f,0x68e98061,0x7c29dcd9,0xb87b128a}},	//   kës_, zked, _ryer, _plís,
   {{0x88bd8063,0x6d4980eb,0xe31400f7,0x399a80f1}},	//   nośc, _piea, _حبيب, jës_,
   {{0x30790158,0x399a8168,0xa87903de,0x69c50362}},	//   _קאָנ, dës_, _קאָר, _irhe,
   {{0x38691295,0x06b780c8,0x98ab0035,0xeb998b5b}},	//   mbar_, জাতি, _chcą_, фил_,
   {{0x6aba9c33,0x88bd809a,0x7d065cda,0x78b98282}},	//   _catf, kośc, ziks, _sawv,
   {{0x399a80f1,0x752282ec,0x6ca78084,0x68e9d8ce}},	//   gës_, booz, _праж, tked,
   {{0x38695cdb,0xdddc0214,0x629c8106,0x610881d0}},	//   nbar_, _herş, _öron, děls,
   {{0x68e98a38,0x7d062818,0xa3b586ae,0x78bbd3a9}},	//   rked, viks, _जनि_, rduv,
   {{0x3f83dcdc,0x68e9dcdd,0x38695cde,0x0ab488ca}},	//   čju_, sked, hbar_, _محمد,
   {{0xee398987,0x7d061ffe,0x940c0201,0x399a8168}},	//   ьно_, tiks, ədə_, cës_,
   {{0x7bc4011f,0xe945803d,0xa3b5a743,0x60cba3a6}},	//   _priu, _شرای, _जना_, _ungm,
   {{0x67218067,0x3f8d8722,0x2ef59a19,0xde16803d}},	//   polj, queu_, _издр, فقیت_,
   {{0x212da88e,0x2d6e801b,0xe8ca001b,0x29020748}},	//   lleh_, bře_, ाञ्च, _smka_,
   {{0x6b9d115b,0x412a04db,0xb87b02df,0xd04d0326}},	//   atsg, дово_, _alíq, nkaɗ,
   {{0x63a9c755,0x3f895cdf,0x6ba50338,0x2fc05ce0}},	//   _open, frau_, åtgä, tvig_,
   {{0x62818db7,0x657c003a,0xd007091e,0x61430adb}},	// [54c0] _odlo, _svrh, вете_, рета,
   {{0x75228c56,0x45140264,0x2fc05297,0xddc701f4}},	//   wooz, _সঠিক_, rvig_, _sejš,
   {{0x63a99820,0x386915f4,0x9d468098,0xdd8f0f99}},	//   _apen, bbar_, вежд, قول_,
   {{0x399a820f,0x7afd81e2,0x80a19d7c,0x62818428}},	//   vës_, _įsta, _कॉले, _adlo,
   {{0x29120393,0x8b9681a0,0x39405ce1,0xc1da928a}},	//   mnya_, треч, mmis_, यङ्ग,
   {{0x399a820f,0x291213b8,0x394014c7,0x68f65ce2}},	//   tës_, lnya_, lmis_, lhyd,
   {{0x7d0450a7,0x291230a0,0x63a9dce3,0x7f4a808e}},	//   _omis, onya_, _epen, _rifq,
   {{0x291223d5,0x399a820f,0x52df3852,0xfce38237}},	//   nnya_, rës_, _नक्स, _косо,
   {{0x88bd8063,0x8afd800d,0x8c43a7cb,0x29120057}},	//   wośc, _stře, _вете, inya_,
   {{0x29120393,0x7d045ce4,0x399a8168,0x310210f7}},	//   hnya_, _amis, pës_, रोतः_,
   {{0x2912048f,0x7bc293f2,0xfdd08264,0x38695ce5}},	//   knya_, lvou, ান্ড, ybar_,
   {{0x2912036e,0x6eed8118,0x6b9d0fb6,0x657adce6}},	//   jnya_, _fúbo, ttsg, rsth,
   {{0x29120867,0x7bc285f8,0x38695ce7,0xf54a001c}},	//   dnya_, nvou, vbar_, _nấu_,
   {{0x2caf80f3,0x2fc69fdb,0x29123bdf,0x6b9d27d1}},	//   zegd_, _irog_, enya_, rtsg,
   {{0x2912010b,0x394b5a44,0x386901ec,0x8c3da795}},	//   fnya_, _pics_, tbar_, _daşy,
   {{0x7d1600f1,0x291210e1,0x2fc6dce8,0x99bb8039}},	//   _gjys, gnya_, _krog_, וזלט,
   {{0xa2d00076,0x383509b4,0x38695ce9,0x386605e4}},	// [54d0] दाश्, унар, rbar_, ñora_,
   {{0xf54a0028,0x29121a14,0x2d9e837a,0xb87b12ca}},	//   _dấu_, anya_, otte_, _elíp,
   {{0x29120057,0x69c515ec,0x63a9b7eb,0x272f0019}},	//   bnya_, _urhe, _spen, lünk_,
   {{0x7ce62660,0x29120101,0x27398036,0x7c2d2e22}},	//   _fóru, cnya_, mène_, _kyar,
   {{0xceeb09d7,0x2fc690af,0xc48481e5,0x27398036}},	//   _قرآن_, _nrog_, рлік, lène_,
   {{0x68ed0c9a,0x8f9a0039,0xe29680a9,0xf8d1016f}},	//   lkad, _אישי, гаш_, हावय,
   {{0x78bd0a92,0xf2d40158,0x6eeddcea,0xeaf38b9f}},	//   _kasv, יעס_, _súbo, _अतीत_,
   {{0xa502016f,0x272f0061,0x6d4d0bb1,0x7c2d5ceb}},	//   _लगेच_, künk_, _niaa, _oyar,
   {{0x27e95cec,0xf54a001c,0x7c2d4100,0x63a98010}},	//   nyan_, _mất_, _nyar, _upen,
   {{0x6d552221,0x442dc2f5,0x2fc69be9,0xc9879033}},	//   _kuza, _iye_, _drog_, _ауди,
   {{0x442dba5f,0xde05b0c3,0x2912015d,0x7c2d5ced}},	//   _hye_, упни, ynya_, _ayar,
   {{0x78bd0db7,0x6d555cee,0x7c2d02a0,0x27e9040a}},	//   _nasv, _muza, _byar, kyan_,
   {{0xbea59285,0xdb0d05e4,0x6d550102,0xe72ea6b1}},	//   _балк, _arañ, _luza, _ге_,
   {{0x442d835f,0xdb0d01df,0x29120101,0x27e95cef}},	//   _mye_, _brañ, wnya_, dyan_,
   {{0x7ae1dcf0,0x2912048f,0xf54a00ff,0x442ddcf1}},	//   _molt, tnya_, _bất_, _lye_,
   {{0x442dd4f7,0x61e1016d,0x7ce6002a,0xb4db0722}},	//   _oye_, älla, _córt, rmàc,
   {{0x29120393,0x7e7509a4,0x442dd0e2,0x27e95cf2}},	// [54e0] rnya_, _bezp, _nye_, gyan_,
   {{0x29120393,0x4df60364,0x6d55505b,0x98a02663}},	//   snya_, ляет, _buza, klić_,
   {{0x291213b8,0x442dc2f5,0x4a9b0158,0x1a9b00be}},	//   pnya_, _aye_, _אייג, _אייע,
   {{0x442daea5,0x68ed00f2,0x753bdcf3,0x2d8705e4}},	//   _bye_, ckad, _chuz, ánea_,
   {{0x7ae1dcf4,0xc879807e,0x7fd50558,0x442d80b4}},	//   _bolt, daş_, _кірі, _cye_,
   {{0x2d9e8aa2,0x78bd141f,0x68e30087,0x6b84826c}},	//   ytte_, _zasv, _îndr, šigo,
   {{0xee370611,0x6abe428b,0x272f0061,0x98a006ec}},	//   _бнр_, _mapf, zünk_, glić_,
   {{0x8c469071,0x442d86c4,0x3ea7841c,0x7df3811c}},	//   _бебе, _fye_, _abnt_, cəsə,
   {{0x2ef4938c,0x6d55016b,0x442d8c56,0x98ab0035}},	//   изир, _zuza, _gye_, _chcę_,
   {{0x6d4d008e,0x7f4e01b9,0x68ed5cf5,0x7c2d00b4}},	//   _siaa, _jibq, zkad, _ryar,
   {{0x7c2d14ec,0x6d4d0122,0xd884803d,0x645a01d0}},	//   _syar, _piaa, _نهای, ětin,
   {{0x27e9068a,0x272f0019,0x3f925cf6,0x27399f1b}},	//   yyan_, tünk_, kuyu_, vène_,
   {{0xf54a0104,0x78bd5cf7,0x2bc7902e,0x2d9ed2a4}},	//   _rất_, _rasv, लिया, stte_,
   {{0x78bd0025,0xbebc8029,0x7ce600f7,0x88bd8035}},	//   _sasv, glīt, _sórt, nośn,
   {{0xc3338051,0x7ce62c6c,0x78bd5cf8,0x7e75008e}},	//   מוש_, _pórt, _pasv, _rezp,
   {{0x6d550314,0x68e2c6f7,0x27e95cf9,0x27398866}},	//   _ruza, _jood, tyan_, rène_,
   {{0x68ed5cfa,0x68e29f61,0x629ab4f8,0x7c2d0214}},	// [54f0] rkad, _mood, _octo, _uyar,
   {{0x3f87003a,0xdef807ac,0x68ed5cfb,0x200d0125}},	//   čnu_, лых_, skad, _þeim_,
   {{0xf54a0028,0x54559a47,0x27e95cfc,0x442ddcfd}},	//   _tất_, авет, syan_, _sye_,
   {{0x68e280c9,0xa3e909a9,0x442d8247,0x7ce601df}},	//   _nood, _यथा_, _pye_, _hórr,
   {{0x69c89b6d,0xe2999ccf,0x6d5a02be,0x7ae1da96}},	//   _arde, вал_, _étan, _polt,
   {{0x63ad2479,0x6d55362a,0x442d86c0,0x084e8133}},	//   _mpan, _tuza, _vye_, _kọfị_,
   {{0x7ae1dcfe,0x68e2dcff,0xdb00806a,0x2ca900c3}},	//   _volt, _bood, _opmæ, _obad_,
   {{0x3f9f8009,0x442d867f,0x98a0076c,0x00e58087}},	//   ttuu_, _tye_, rlić_, ржин,
   {{0x68e29e94,0x2d8c85f8,0x442d8234,0x60dbbf72}},	//   _dood, erde_, _uye_, rjum,
   {{0x2ca9059e,0x7d0b9277,0x63bba266,0x26c100d7}},	//   _abad_, ligs, _isun, ndho_,
   {{0xa2d90e70,0x68e2bcc0,0x63ad5d00,0x3f9f8009}},	//   मान्, _food, _apan, stuu_,
   {{0x7bc9dd01,0x7d0bd83a,0x68e280ef,0x8c460249}},	//   _kreu, nigs, _good, иене,
   {{0x61e100f2,0x2d8cdd02,0x5fa9801b,0x2cbfa0db}},	//   älln, arde_, _कहिल, _maud_,
   {{0xf7708077,0x2cbfc950,0x386d82af,0x7ce61b07}},	//   _راه_, _laud_, lber_, _córr,
   {{0xf8bf08f9,0x63ad5d03,0x7d0b833e,0x68e28037}},	//   _baé_, _epan, kigs, _yood,
   {{0xc95501e2,0x7866259a,0x394f81e0,0x3f5b801c}},	//   стры, рказ, _jigs_, _kêu_,
   {{0xb8de0610,0x386d81ec,0x394f82c4,0xaf065d04}},	// [5500] _इस_, iber_, _migs_, апал,
   {{0x394f80b9,0x8ca70035,0x657e01ec,0x543b03de}},	//   _ligs_, ट्ठो, tsph, _בעפא,
   {{0x386ddd05,0xd91009d7,0x63bbdd06,0x98a61ad2}},	//   kber_, _فیس_, _asun, _кине,
   {{0x64a6a549,0x0b8a9a19,0x7bc981ba,0xdca69fab}},	//   рада, вски_, _breu, ради,
   {{0x7bc9dd07,0x2cbf800e,0x93468294,0x68e2800b}},	//   _creu, _daud_, анде, _rood,
   {{0x7bc9dd08,0x3f8d8722,0x68e290b5,0xfc3f0511}},	//   _dreu, dreu_, _sood, nfía_,
   {{0x7e7a8b81,0xaca481bc,0x68e282f1,0xb05b0106}},	//   vatp, _agụp, _pood, _knäp,
   {{0x7bc9dd09,0xa7748193,0x386041ac,0x2d8c817f}},	//   _freu, блич, ncir_, vrde_,
   {{0x7bc9dd0a,0x5fc903ca,0x6fc906f0,0x68e282f1}},	//   _greu, रियल, रियं, _vood,
   {{0x2cbf8282,0x9ed88187,0x28a6864a,0x8544819d}},	//   _zaud_, умот_, _कॉरि, _ịghọ_,
   {{0xd5b7902a,0x386d93e1,0x68e28074,0x07370039}},	//   ася_, bber_, _tood, שאים_,
   {{0x186aa466,0xa06abfe7,0x6fc900d4,0x3f8d9e9e}},	//   _ради_, _рада_, रिमं, breu_,
   {{0x63a2bb4f,0xda788038,0x92d880ab,0x07da803d}},	//   nton, _keď_, াসী_, _جذاب_,
   {{0x6298bbd9,0x81c781a9,0x39b80176,0x63a282df}},	//   ngvo, stēš, _bōs_, iton,
   {{0xed578003,0xb6cb8065,0x58d51182,0x7c872118}},	//   _кој_, _جانے_, бовт, _купе,
   {{0x3f5b8104,0x63a2dd0b,0xa3d6902e,0x26de826c}},	//   _yêu_, kton, िमा_, ljto_,
   {{0x63ad5672,0xfb85003d,0xdddaa57b,0x752d3977}},	// [5510] _upan, _ادبی, katū, _ikaz,
   {{0x6d58dd0c,0x28a69516,0x2cbf8069,0x2d8705e4}},	//   _kuva, क्ति, _saud_, áneo_,
   {{0xdfc68019,0x386ddd0d,0x2cbf8101,0x7d0bcac3}},	//   _کي_, yber_, _paud_, tigs,
   {{0x7c878af2,0x6d58dd0e,0x63a2dd0f,0x237f011f}},	//   руже, _muva, fton, šuju_,
   {{0x7ae5247f,0x672884a8,0xd3088028,0xe78419b8}},	//   _koht, kodj, yệt_, _муро,
   {{0x7ae50364,0x7bc99004,0xf54a0129,0x2d93002a}},	//   _joht, _vreu, _lấp_, puxe_,
   {{0x752d5d10,0xceb20039,0x386d808e,0x6d58dd11}},	//   _okaz, _מים_, tber_, _nuva,
   {{0x63bb9cc5,0x7bc9dd12,0x6ea9800d,0x3f8ddd13}},	//   _tsun, _treu, ज्नु, treu_,
   {{0x63bbb76e,0x7d09bb44,0x6edb06ab,0x394f867f}},	//   _usun, _imes, नापु, _vigs_,
   {{0x3f8d895b,0x6d58dd14,0x67288916,0x752d409f}},	//   rreu_, _buva, godj, _akaz,
   {{0x776983a8,0x69c702ce,0x2d8100a4,0x6d5894a9}},	//   spex, jvje, nshe_, _cuva,
   {{0xf54a0104,0x69c702ce,0xf1c38110,0x6d58dd15}},	//   _cấp_, dvje, rašė_, _duva,
   {{0x7052806b,0x67288699,0xa8568039,0x7d0980de}},	//   _عنوا, bodj, _הינה_, _mmes,
   {{0x7d1bdd16,0x7c3b8010,0x543a80be,0x626324a4}},	//   _ljus, _mzur, טערא, звра,
   {{0x27eddd17,0x5d858013,0xc33284de,0x63a28019}},	//   lyen_, _البل, פול_, zton,
   {{0xf54a001c,0x7d1b811f,0x7c3b8133,0xa5649ef7}},	//   _gấp_, _njus, _ozur, _بدون,
   {{0x27ed8205,0x7c3b8010,0x38601b01,0x27ff8300}},	// [5520] nyen_, _nzur, rcir_, nzun_,
   {{0x7d09b517,0x7d1bb7dd,0x7e5623cd,0xf6560e02}},	//   _ames, _ajus, стац, стаю,
   {{0x7c3bdd18,0x2734016d,0x3f80023e,0x463a15a6}},	//   _azur, länk_, ssiu_, учая_,
   {{0x6723003a,0x63a2cdb0,0x6eed84c3,0x6d5a5d19}},	//   čnja, tton, _dúbi, _étam,
   {{0x2ca6831d,0x27ed90ed,0x611398ad,0x68fbdd1a}},	//   rfod_, jyen_, căli, dhud,
   {{0x7d09dd1b,0x27ed86c0,0x64410085,0x60c45d1c}},	//   _emes, dyen_, əlid, ldim,
   {{0xc05a8a4c,0xddda9482,0x6728cd57,0x7c3b81bc}},	//   ліп_, ratū, vodj, _ezur,
   {{0x60c45d1d,0xdca38d9e,0x64a3be80,0x63a2dd1e}},	//   ndim, _наси, _наса, pton,
   {{0x27ed8065,0x6d58a0a2,0xda78801b,0xe762819d}},	//   gyen_, _suva, _teď_, _bọọs,
   {{0xc6f7827e,0xf76f96a5,0xdb040118,0x3f8a816b}},	//   йных_, راً_, _osiñ, čbu_,
   {{0x67289024,0x6b845d1f,0x6eed8118,0x67fe8032}},	//   rodj, _avig, _xúbi, _bàjé,
   {{0x27ed8247,0x8af98201,0x67289455,0xa1578039}},	//   byen_, rləş, sodj, _הבאה_,
   {{0x7e7e079f,0x6b829a90,0xf54a0129,0xddd50176}},	//   kapp, nsog, _vấp_, _egzň,
   {{0x64560065,0x6b841752,0x6b890289,0x6d58dd20}},	//   _egyi, _dvig, šego, _tuva,
   {{0x6b840bbd,0x752d18ad,0xddc8b3b5,0x7e7e3ffb}},	//   _evig, _tkaz, ladž, dapp,
   {{0x752d1620,0x3e4e8085,0x61138162,0x79950435}},	//   _ukaz, mət_, tăli, ruzw,
   {{0x69c72b1f,0xe80303eb,0xddc8803b,0x14d623e6}},	// [5530] svje, _रेखा_, nadž, धारण,
   {{0x6d40dd21,0x7d09dd22,0x7bcd0102,0x2d8101f6}},	//   _ahma, _smes, _irau, tshe_,
   {{0x6d408267,0xddc888ae,0x3e4e8085,0x2c5e8133}},	//   _bhma, hadž, nət_, _ịda_,
   {{0x60c2cba7,0x7bcd2ab6,0x2d815d23,0x27edaade}},	//   _naom, _krau, rshe_, yyen_,
   {{0x889a04de,0xddc88bda,0x7e7e5d24,0x7d09807a}},	//   _דברי, jadž, bapp, _vmes,
   {{0x28a68701,0x7e7e156f,0x395a02f7,0x776d03a8}},	//   क्सि, capp, _yups_, mpax,
   {{0xdd94076a,0x6aaa0352,0xa3b58054,0x659410f8}},	//   _нары, _öffe, _जनक_, _нару,
   {{0x7d09dd25,0x27ed86c0,0x27ff8102,0x7a40008b}},	//   _umes, tyen_, tzun_, _hátí,
   {{0xe8f686b5,0xb87b05b9,0x7bcd01e9,0x23690282}},	//   іль_, _blíz, _nrau, _ntaj_,
   {{0x0d85aded,0x27eddd26,0x05a997ae,0x45858d9e}},	//   олон, ryen_, авой_, огов,
   {{0x27eddd27,0x7bcd011e,0x26c35d28,0xc6920039}},	//   syen_, _arau, _majo_, ואי_,
   {{0x7bcd1db4,0x7a428019,0x03a60009,0x2d8b81d0}},	//   _brau, síté, оимо, čce_,
   {{0x28c40b9f,0xb87b0118,0xdd0c809a,0x7bcd01e0}},	//   _लोगि, _coím, _późn, _crau,
   {{0x7bcd5d29,0x366984ae,0x3e4e8085,0x61ee5d2a}},	//   _drau, _тако_, bət_, tybl,
   {{0x7bcd0cdb,0xd5ac8065,0x23695d2b,0x2d8700e1}},	//   _erau, _یہی_, _etaj_, šnej_,
   {{0x26c3046d,0x60c40110,0x290b00b9,0x44200069}},	//   _aajo_, udim, _cmca_, _txi_,
   {{0x26c305b4,0x6b8401df,0x6569026c,0x07a31a80}},	// [5540] _bajo_, _uvig, _čeha, матн,
   {{0x249f8012,0x57ba000d,0x69c80106,0x6d408168}},	//   _acum_, _उनीह, ådes, _shma,
   {{0xbc6a8277,0xe45a9628,0xa2dd801b,0x57b68074}},	//   لمان_, аже_, पान्, _अन्ह,
   {{0x629c26a1,0x60c4011c,0x9b6a9ddf,0xe0df0229}},	//   lgro, qdim, ашка_, _chòd_,
   {{0xf746079e,0x8bb6803d,0x7e7e0bcb,0x63a601e0}},	//   _мемо, تصاص, papp, ntkn,
   {{0x629c5d2c,0x3e4e8201,0x3872004a,0x2fcf006a}},	//   ngro, yət_, lbyr_, ægge_,
   {{0x14ca009a,0x6b82cf69,0xaacb001b,0xe6170162}},	//   ियाण, ssog, ायतक, _ддр_,
   {{0x6d5c5d2d,0x37aaa21f,0x89db01c6,0x387fa476}},	//   _iura, атон_, שחקי, gaur_,
   {{0x28a6853f,0x6d5c15e8,0xd7fac4e0,0x63ad80f1}},	//   क्षि, _hura, руй_, çant,
   {{0xddc8876c,0x2018802e,0x60c28c53,0x2ca02093}},	//   radž, ări_, _waom, _acid_,
   {{0x7e7c0642,0x24890101,0x60c29581,0xb65b00be}},	//   _merp, _pdam_, _taom, ידיש,
   {{0xcd07035f,0x3e4e8201,0x30c500ab,0x7cff03ed}},	//   ічни, rət_, _এক্স, _mërg,
   {{0x81af00c8,0x7ac72410,0x38cb826a,0x6d5c1651}},	//   ওয়া_, осве, _خالی_, _lura,
   {{0x2d87000d,0x6eed846d,0x6d5c1d5e,0x629c0901}},	//   ánek_, _búbu, _oura, ggro,
   {{0x7ae88022,0xc0d1026b,0x7d0f01ed,0x0e7580e1}},	//   _modt, _akíọ, pics, äčší,
   {{0x58d41485,0x26c337d7,0x63a40168,0x7bcd0d88}},	//   мост, _sajo_, _fqin, _trau,
   {{0x7e7c0393,0x7cff020f,0x6d5c5d2e,0x6fbc81b6}},	// [5550] _berp, _përf, _aura, ्टिं,
   {{0x6d5c448d,0x7e7c0b20,0x8ca70aed,0x539a0039}},	//   _bura, _cerp, ट्रो, _פיתו,
   {{0x6d5c5d2f,0x7e7c0ed0,0x2bc311be,0x7bc0dd30}},	//   _cura, _derp, शिका, _asmu,
   {{0x7cff00f1,0xf992010f,0xd7bc8aed,0xfd6281bc}},	//   _dërg, _ארט_, ्टाच, _satọ,
   {{0x39495d31,0x7d0d0135,0x3af58d15,0xe0df5d32}},	//   mmas_, _mmas, зяйс, _fiòr_,
   {{0x6d5c1fcc,0x39493b78,0x386681bc,0x8505881b}},	//   _fura, lmas_, _afor_, _کورن,
   {{0x39490207,0x6d5c5d33,0x2d8add34,0x7d0d5d35}},	//   omas_, _gura, ábel_, _omas,
   {{0x69cc016f,0x39495d36,0x28bd90a1,0x6b4b0372}},	//   हिती, nmas_, ्यधि, _iżgu,
   {{0x4439c92f,0x7f5d02be,0x2d9e016d,0x394901a9}},	//   _ás_, _jusq, _äter_, imas_,
   {{0x7d0d199f,0x6d5c5d37,0x387fdd38,0x443f8870}},	//   _amas, _yura, saur_, _izu_,
   {{0x6d5c09e3,0xdcfb0110,0xcee8803d,0x8cd803eb}},	//   _xura, nutė, ترين_, यालो,
   {{0x80a283b7,0x629c43e8,0x26c382d4,0x7d0d0706}},	//   _गाये, wgro, žjo_, _cmas,
   {{0x443f8267,0x629c1336,0x98e481a8,0x087683de}},	//   _jzu_, tgro, _تكنو, _זענט_,
   {{0xdcfb00eb,0x7d0d4c47,0x6569026c,0x254d01d0}},	//   rstā, _emas, _čehn, _měly_,
   {{0x629c110f,0xbbb88f97,0x867a81c6,0x91e600ae}},	//   rgro, _इन्क, _הרצו, чове,
   {{0x6d5a03d3,0x7f5d2eaa,0x443fdd39,0x629c06a8}},	//   _étai, _busq, _ozu_, sgro,
   {{0x6d5c0763,0x81b180ab,0x6d56076d,0x629c13fc}},	// [5560] _sura, টটি_, _iiya, pgro,
   {{0x7cff08cf,0x6d5c3343,0xaa461677,0x6d560637}},	//   _përg, _pura, _непл, _hiya,
   {{0x7e7c1781,0xfc668698,0x6d5c5d3a,0x2561b2c4}},	//   _verp, пълн, _qura, _jól_,
   {{0x6fc9056b,0x6d5c07c0,0x6d56203d,0x39495d3b}},	//   रिशं, _vura, _jiya, cmas_,
   {{0x7e7c0393,0x6d5635fe,0x6d5c04b9,0x6d440c41}},	//   _terp, _miya, _wura, _mhia,
   {{0x29125d3c,0x6d5c5d3d,0x6d5643da,0x6ef680e7}},	//   liya_, _tura, _liya, _câbl,
   {{0x3f86801b,0x443f8135,0xdcfb0162,0x27f20198}},	//   _svou_, _ezu_, nstă, lyyn_,
   {{0x29125d3e,0x6d565c6d,0x290003a7,0x68e45d3f}},	//   niya_, _niya, nhia_, njid,
   {{0x60c6045f,0x69c1811b,0x7c2403ed,0x387d9bad}},	//   _makm, _esle, _nxir, _dewr_,
   {{0xd6da92e1,0x6d4401bc,0x29121066,0x6440dd40}},	//   сти_, _ahia, hiya_, _izmi,
   {{0x6d565d41,0x39490110,0x29125d42,0x2fc700ff}},	//   _biya, ymas_, kiya_, ̉ng_,
   {{0x6d445d43,0x6d564672,0x66010214,0x29121cee}},	//   _chia, _ciya, _ülke, jiya_,
   {{0x6d565d44,0x29121037,0x29005d45,0x6d445d46}},	//   _diya, diya_, dhia_, _dhia,
   {{0xdee39260,0x66e3835f,0x28da8aad,0x60c602c4}},	//   _почи, _поча, भावि, _aakm,
   {{0x7cff020f,0x6d5607d9,0x291200a4,0x6d440083}},	//   _përd, _fiya, fiya_, _fhia,
   {{0x29125d47,0x39495d48,0x6d4408d8,0x7d0d5d49}},	//   giya_, umas_, _ghia, _umas,
   {{0xb8e52539,0x60c615d7,0x80a1d59b,0x395e852a}},	// [5570] _एस_, _dakm, क्टे, _luts_,
   {{0x6d5642e1,0x39495d4a,0xbbc906b7,0x98b201a9}},	//   _ziya, smas_, िटीक, ībās_,
   {{0x291216ea,0x6440883a,0x6d56380a,0x7d1d5d4b}},	//   biya_, _azmi, _yiya, onss,
   {{0x29005d4c,0x291204b9,0x7d1d00d9,0x7f5d0144}},	//   chia_, ciya_, nnss, _tusq,
   {{0xfbab8b88,0x8ca5016f,0x7d1d008b,0x27e0027d}},	//   стей_, _कानो, inss, cxin_,
   {{0x3eba44dc,0x2d8580e1,0x395e8036,0x78a28580}},	//   cept_, ysle_, _buts_, _acov,
   {{0xa9c480f7,0x2d9a0036,0xb457853d,0xceb203de}},	//   فزيو, cupe_, _فیاض_, _שיל_,
   {{0x2561866e,0x6ca49a12,0x395e8580,0x28da825a}},	//   _ról_, _пруж, _duts_, भाषि,
   {{0x443faa41,0x2561d8f8,0x6d565d4d,0x29038084}},	//   _uzu_, _sól_, _riya, ėja_,
   {{0x6d565d4e,0x09bc80c8,0x6d445d4f,0x29125d50}},	//   _siya, _অপরা, _shia, ziya_,
   {{0x57ba2261,0x6d563a0d,0x6d4401c5,0x69c1a35d}},	//   _उन्ह, _piya, _phia, _usle,
   {{0xd00e89d7,0x29003592,0x6d563dd5,0xfd660091}},	//   الی_, xhia_, _qiya, _aapọ,
   {{0x2d9a80e8,0xb4e6026b,0xbea58056,0x6eed81d6}},	//   _åpen_, _apàà, _жалк, _dúbr,
   {{0x6283dd51,0x25619eca,0x853d0084,0x6d565d52}},	//   nano, _tól_, ntėj, _wiya,
   {{0x6d44146a,0x248d8052,0x6d561d29,0xc3328039}},	//   _thia, _odem_, _tiya, דום_,
   {{0xb4bc853e,0x6283831d,0x78bba2b9,0x26c780b4}},	//   _असे_, hano, neuv, _hano_,
   {{0x29125d53,0x6283912e,0x26c7b174,0x236d81e9}},	// [5580] riya_, kano, _kano_, _ntej_,
   {{0x29125d54,0x24802496,0x29005d55,0x68f65d56}},	//   siya_, _heim_, shia_, skyd,
   {{0x26c7dd57,0x6283dd58,0x60c65d59,0x291233ef}},	//   _mano_, dano, _takm, piya_,
   {{0x60c98259,0x2d870187,0x6abc5d5a,0x799c0314}},	//   jdem, ânea_, lerf, murw,
   {{0x62838b67,0x60c98365,0x69ce03ba,0x9f5281d0}},	//   fano, ddem, lvbe, ždém_,
   {{0xf96a9cad,0x7cff00f1,0x27e084b7,0x290f8122}},	//   орий_, _kërc, _ħin_, _amga_,
   {{0x200d07ca,0x68eba503,0xbebc80eb,0x65c31ef3}},	//   _þeir_, _bogd, lnīg, _ибра,
   {{0xe6431cad,0xa3de001b,0xb4c80697,0x2bbf864a}},	//   _респ, णमा_, ईयो_, _शैवा,
   {{0x68ebdd5b,0x6abc007b,0x26c782ec,0x7d02c8c8}},	//   _dogd, kerf, _bano_, mhos,
   {{0x6283a706,0x7d0283a7,0x752f009a,0x799c0314}},	//   cano, lhos, wocz, kurw,
   {{0x24800352,0x06970039,0x75d480f7,0x15150198}},	//   _beim_, ודים_, ريحا, едня,
   {{0xb4bc816f,0x7d02dd5c,0x290f8122,0x2ebb1a46}},	//   _असो_, nhos, _gmga_, _उस्त,
   {{0x7cff020f,0x26c7dd5d,0x27e0861c,0x752f0035}},	//   _përb, _fano_, _çin_, rocz,
   {{0xf54a0028,0xe6c81905,0x26c7c087,0x2fc046f8}},	//   _mấy_, रयोज, _gano_, dwig_,
   {{0xf54a0028,0x394681c0,0x752f009a,0x7d02805d}},	//   _lấy_, _khos_, pocz, khos,
   {{0x6aaa02af,0x69d85d5e,0x7e6d8115,0xc1570135}},	//   _öffn, _švec, _đapi, _ụgbọ,
   {{0x78ad3736,0x26c7833e,0x7d02bdf9,0x96db06a7}},	// [5590] rfav, _yano_, dhos, नालॉ,
   {{0xa3be00d4,0xf3ff0187,0x6283dd5f,0x6b9d4bf9}},	//   ीटर_, lcão_, xano, musg,
   {{0x6b89803a,0x6283b5aa,0x2734016d,0x7d02c3f2}},	//   _sveg, vano, vänt_, fhos,
   {{0x26c717aa,0xf7735c11,0x69c52bd7,0xf54a0129}},	//   žno_, _لاس_, _ishe, _bấy_,
   {{0x4fc40087,0xf54a0129,0x3f9b011c,0x7e6a839c}},	//   _исра, _cấy_, ququ_, _offp,
   {{0x38691fd6,0x877a03c8,0x290f80dd,0x39468122}},	//   lcar_, _מאשי, _smga_, _ahos_,
   {{0x7d02936f,0x6b9d5d60,0x39468a2a,0x395927eb}},	//   bhos, husg, _bhos_, _kiss_,
   {{0x38693a66,0x26c7dd61,0xc7c88028,0x62838ca1}},	//   ncar_, _sano_, _bố_, sano,
   {{0x62838ff9,0x26c7dd62,0xc7c88028,0x39468282}},	//   pano, _pano_, _cố_, _dhos_,
   {{0x69c533cd,0x3ea10c53,0xeab081a8,0x39595d63}},	//   _oshe, nght_, _نعم_, _liss_,
   {{0x3ea11c33,0x6d5a00e7,0x2bc790be,0x26c7991f}},	//   ight_, _état, लिका, _vano_,
   {{0xed59800d,0x64ca1993,0x673a910f,0xfce6004a}},	//   _již_, ियेश, altj, хомо,
   {{0x394ddd64,0xdd0c8063,0x6281dd65,0x26c78010}},	//   mmes_, _różn, _kelo, _tano_,
   {{0x394d818d,0x7cff00f1,0x6281811f,0x799c5689}},	//   lmes_, _përc, _jelo, turw,
   {{0x395901cd,0x7d02c3cd,0x394d8722,0x28a6dd66}},	//   _biss_, yhos, omes_, क्कि,
   {{0x0d828098,0x6281dd67,0x39593fc7,0x799c00b4}},	//   _слън, _lelo, _ciss_, rurw,
   {{0x69c55d68,0x14dd06af,0x6abc05d8,0x799c5d69}},	// [55a0] _eshe, यारण, perf, surw,
   {{0xf1c58028,0x69c500f1,0x64440db1,0x2fc02937}},	//   _đáng_, _fshe, _izii, rwig_,
   {{0x7d02dd6a,0x395902a6,0x394d8612,0xf54a0129}},	//   thos, _fiss_, kmes_, _sấy_,
   {{0xa6de8104,0x6281831d,0xe811016f,0x69ce8118}},	//   _nhưn, _aelo, _ठेवा_, _ábei,
   {{0x28c3800c,0x6281d87d,0x99bc80ab,0xe3af8a47}},	//   वजनि, _belo, _অপেক, مرو_,
   {{0x6281daa1,0x7d02b6ba,0xddda84e8,0x31c691f3}},	//   _celo, shos, hatš, есив,
   {{0x6281dd6b,0xc7c88104,0x7d02dd6c,0x3946dd6d}},	//   _delo, _số_, phos, _phos_,
   {{0x6d5e8036,0x3cff81a1,0x394dcf42,0xa6de8129}},	//   _épai, _gluv_, gmes_, _chưn,
   {{0xf76f803d,0xf77280f7,0x7d008074,0x26ca5d6e}},	//   یای_, داع_, _ilms, _kabo_,
   {{0x6281bbd3,0x09e69285,0x1ddb9094,0x80a286ae}},	//   _gelo, _позн, यमंत, _गावे,
   {{0x32078063,0xceb30039,0xa2dd800c,0x7bcf022c}},	//   czny_, אית_, पार्, wvcu,
   {{0x26ca5d6f,0xc7c8801c,0x6b9d5d70,0x28a7dd71}},	//   _labo_, _tố_, tusg, _गायि,
   {{0xd12f8065,0x7b09026c,0x258681d0,0xe0df0362}},	//   _امن_, džur, _bílá_, _bhòn_,
   {{0x26ca2896,0xd84f3a48,0x75240caa,0x02cb052a}},	//   _nabo_, _dọla_, _ejiz, ायेन,
   {{0x6b4002af,0x7d0082c4,0x69dc802a,0x318c81d0}},	//   mögl, _olms, _áred, něz_,
   {{0x3ebedd72,0x26ca5d73,0x2d9edd74,0xa63b81c6}},	//   lett_, _aabo_, mute_, _מגור,
   {{0xf770045b,0x2d9edd75,0x98170077,0x26ca1d61}},	// [55b0] مال_, lute_, ربرا, _babo_,
   {{0x26ca1313,0x69c501e9,0x61e1016d,0x3959010c}},	//   _cabo_, _tshe, älls, _wiss_,
   {{0x21200805,0x3f89259f,0x69c537fc,0x4ade02f1}},	//   bnih_, ssau_, _ushe, मारव,
   {{0x6281dd76,0xd4e48607,0x5ce49ea4,0x62875d77}},	//   _selo, лючи, люча, lajo,
   {{0x62818152,0x60cd02b8,0x3ebec503,0xfaa58729}},	//   _pelo, mdam, kett_, вало,
   {{0x60cd5d78,0x2d9e8074,0x60dd008e,0x3869a358}},	//   ldam, kute_, _hnsm, _żar_,
   {{0x3ebe8eb9,0x60cd0110,0x09e5b3c2,0x394ddd79}},	//   dett_, odam, тойн, tmes_,
   {{0x2d9edd7a,0x60cd138e,0x26ca26bd,0x6281c631}},	//   dute_, ndam, _zabo_, _welo,
   {{0x394ddd7b,0xf771990c,0x3ebedd7c,0x5ef8085d}},	//   rmes_, جاب_, fett_, _एवम्_,
   {{0x394d9e9e,0x60cd5d7d,0x62875d7e,0x2d9edd7f}},	//   smes_, hdam, jajo, fute_,
   {{0x62870619,0xe8df81bc,0x2eee9cf9,0x7c3b82f7}},	//   dajo, _agụm_, _doff_, _hyur,
   {{0xc329010f,0x6d4983ac,0x2904b119,0x7c3bdd80}},	//   _וו_, _jhea, chma_, _kyur,
   {{0x6d498ad0,0x60cd5d81,0x68e982ce,0xd9ca052a}},	//   _mhea, ddam, mjed, ाट्ट,
   {{0x68e98d26,0xe61182e3,0x60dd3b99,0xa2d90651}},	//   ljed, _پشت_, _ansm, माग्,
   {{0x26ca43f0,0x5eca00ab,0x19b902c7,0x6b400106}},	//   _rabo_, রামে, нуть_, sögo,
   {{0x26ca5d82,0x60cd5837,0x60cb826c,0x20094619}},	//   _sabo_, gdam, _jagm, fzai_,
   {{0x6287238a,0x60cbb234,0xf77216a5,0x26ca5d83}},	// [55c0] bajo, _magm, شاء_, _pabo_,
   {{0x21200824,0x60cb998b,0xb87b0118,0xbebc80eb}},	//   snih_, _lagm, _boís, mnīc,
   {{0x6d49803c,0xd6cf003f,0x65638073,0xc4868396}},	//   _bhea, تقل_, _junh, влек,
   {{0x3ebe8065,0x60cbdd84,0x6d49bcd7,0x26ca1d61}},	//   zett_, _nagm, _chea, _wabo_,
   {{0xa3b48160,0x6d498c64,0x4e12000d,0xdca391d5}},	//   ублі, _dhea, _धेरै_, рачи,
   {{0x69ce8074,0x934397d6,0xdb1b816a,0x78a4226d}},	//   थिली, анче, _bruñ, lgiv,
   {{0x656387f4,0x2904dd85,0x6d498ad0,0xe567806b}},	//   _nunh, thma_, _fhea, _خط_,
   {{0x6d49861f,0x68e98168,0x2d9e9b22,0x3ebedd86}},	//   _ghea, gjed, vute_, wett_,
   {{0x3ebe8065,0x60cbd625,0xaae286af,0xa3b683ca}},	//   tett_, _dagm, पादक, _जहि_,
   {{0x248481cd,0x81b900ab,0x2d9ea0a5,0x7522dd87}},	//   _hemm_, চিত_, tute_, lnoz,
   {{0x6563dd88,0x68e982fd,0xdb1bdd89,0x69d801e2}},	//   _cunh, bjed, _usuá, _šven,
   {{0xdddc0025,0x656387f4,0xa3b68768,0x3ebedd8a}},	//   _održ, _dunh, _जहा_, sett_,
   {{0x5f068676,0x78a40082,0x656386ff,0x62875d8b}},	//   _изда, dgiv, _eunh, tajo,
   {{0x2d9edd8c,0x68ef02a3,0x9b580098,0x52c0dd8d}},	//   pute_, _socd, кият_, _एसोस,
   {{0x3eab9e1e,0xbbbf864a,0x30a70a18,0x5bbf864a}},	//   žitý_, _एन्क, крав, _एन्व,
   {{0x62875d8e,0x44295d8f,0x6b8d8267,0x60c08198}},	//   sajo, _txa_, šagi, nemm,
   {{0x75228690,0xbed909c7,0x69d8002a,0x58840084}},	// [55d0] dnoz, ндах_, _áven, рыса,
   {{0x65638708,0x20095d90,0xdf3900f7,0x60c0dd91}},	//   _yunh, rzai_, ركات_, hemm,
   {{0x7c3b9083,0x6d498083,0x62853b00,0x60c0dd92}},	//   _syur, _phea, _ieho, kemm,
   {{0x60c0dd93,0x6d5e8036,0x7699026b,0x21268168}},	//   jemm, _épau, _bùyà, _njoh_,
   {{0x289a012a,0x4429a31e,0x68e982ce,0xfd580133}},	//   _אירא, ça_, vjed, _akaụ,
   {{0x62855d94,0x93fc03c8,0x442981b9,0x05138264}},	//   _jeho, ולדי, ħa_, িকের_,
   {{0x60cb9066,0x628531a7,0x3c9382e3,0xdddc0259}},	//   _pagm, _meho, _نیاز, _zdrž,
   {{0x62855d95,0x6d5a80e7,0x50459f50,0x7c29811b}},	//   _leho, _étap, лейб, _txer,
   {{0x69c8809f,0x7b99803d,0x68fba6a6,0x213902f7}},	//   _esde, _سپاس_, rkud, _mksh_,
   {{0x26c15d96,0x68e982fd,0x62850e93,0x65638187}},	//   neho_, sjed, _neho, _punh,
   {{0x941e0201,0x63ad37fc,0xe0df0706,0x60cbd9c6}},	//   ətə_, _aqan, _phòl_, _tagm,
   {{0xeb9a19fe,0xf2c9012a,0xe0d088ca,0x97c5830f}},	//   ним_, _מע_, _وزن_, _مقصو,
   {{0x69d709e3,0x62855d97,0x5fb7800d,0x8ca502b4}},	//   _arxe, _beho, _अहिल, _कारो,
   {{0xe3630dca,0x63bbb00f,0xe5a58396,0x69dc802a}},	//   скри, _mpun, _бики, _árec,
   {{0xceb28039,0x021900e8,0x2c1a801b,0xbebc80eb}},	//   _היו_, віть_, _मेनू_, snīc,
   {{0x386ddd98,0xe0df0706,0xa2a8152c,0x63bbdd99}},	//   ncer_, _cnò_, ञ्ज्, _opun,
   {{0xd94315d1,0x7d045d9a,0x6b891c67,0x3f8ddd9b}},	// [55e0] сети, _ilis, šegr, nseu_,
   {{0x62850e61,0x78a45d9c,0x4b7b1101,0x6d438866}},	//   _geho, sgiv, _ראיו, înan,
   {{0x63bbac92,0x386d82f7,0x3ce001a3,0x881a026b}},	//   _apun, kcer_, _kniv_, _dírẹ,
   {{0x163680be,0xa3c8052a,0x63bb8f35,0x00000000}},	//   אנער_, _ईना_, _bpun, --,
   {{0x925a0077,0x62852813,0xdddc05b9,0x26c10b5e}},	//   _تشکر_, _yeho, _udrž, beho_,
   {{0x39402446,0x7d0407e2,0x69c884c3,0x26c101ac}},	//   llis_, _llis, _psde, ceho_,
   {{0x7d040364,0x14aa0072,0x2f008176,0x5eca0264}},	//   _olis, _काढण, _bògn_, রাদে,
   {{0x2902dd9d,0xb87b0073,0x7643009a,0xed578c9b}},	//   óka_, _iníc, żnyc, _бос_,
   {{0x60c09485,0x7dea8085,0x1d078009,0x69d80084}},	//   remm, məsi, _сети_, _švel,
   {{0x7d0400f6,0xd24f8077,0x60c0dd9e,0x7dea8085}},	//   _alis, _کنم_, semm, ləsi,
   {{0x39401648,0x62855d9f,0xdbca8074,0xe814a539}},	//   klis_, _reho, _võõr, _तेरा_,
   {{0x386d951e,0x39401083,0x2ca684a7,0x6917802e}},	//   ccer_, jlis_, ngod_, nţel,
   {{0x3eb816f2,0x26c102a0,0xab6202d0,0x7d041867}},	//   _obrt_, yeho_, şüne, _dlis,
   {{0x7d045da0,0xe1f18065,0x628aa4dc,0x7dea8085}},	//   _elis, _اسے_, nafo, həsi,
   {{0x63a2aba4,0x7d045da1,0xe91900e8,0x26c15da2}},	//   huon, _flis, вові_, veho_,
   {{0x6f1adda3,0x63a2dda4,0x161a83eb,0x26c100b4}},	//   litc, kuon, _फेयर_, weho_,
   {{0x62855da5,0x26c15da6,0x3f150196,0x6d4d2676}},	// [55f0] _teho, teho_, адас, _ihaa,
   {{0x394038dc,0x6d4d5da7,0x7d16219c,0x63a2dda8}},	//   alis_, _hhaa, _zmys, duon,
   {{0x63bb8278,0x69d704c3,0x8afc809a,0x26c15da9}},	//   _spun, _urxe, _międ, reho_,
   {{0x297a010f,0x26c10db1,0x1c1682f1,0x3940551e}},	//   _שטרא, seho_, _देहल_, clis_,
   {{0xdfc6880b,0x6a85a659,0x6d5f0d8b,0x63a2ddaa}},	//   _بي_, алла, _miqa, guon,
   {{0x68ed1f3a,0xa3b68105,0x6d5f5dab,0x2d91928a}},	//   ljad, _जहर_, _liqa, ázek_,
   {{0xa2ad001b,0x6f1a81ed,0x7dea8085,0x7e740019}},	//   _जान्, ditc, bəsi, _چاہئ,
   {{0x68ed048f,0x63a2ddac,0x7dea8085,0xe0d986e6}},	//   njad, buon, cəsi, тви_,
   {{0x386d9e9e,0x60cf117d,0x2f04016d,0x753bddad}},	//   rcer_, _macm, _höga_, _ikuz,
   {{0x6d4d02c1,0x5187b38c,0xc987a57e,0x386d83a7}},	//   _ahaa, _буда, _буди, scer_,
   {{0x7d045dae,0x1d0a0abe,0xa50a0abe,0x26ceddaf}},	//   _plis, вени_, вена_, _dafo_,
   {{0x7fd58160,0x6d4d5db0,0x443f8681,0x69dc8510}},	//   _вікі, _chaa, _kyu_, _área,
   {{0x6d4d02a3,0x290926df,0x888c80be,0x6d5f00ee}},	//   _dhaa, dhaa_, _טראַ, _diqa,
   {{0x6d4d1fa4,0xbea28196,0x39ae811c,0xdce4022b}},	//   _ehaa, _дашк, _səsi_, _kunċ,
   {{0xfc3f05a4,0xada5a3e7,0x6d5f00ee,0x753b8a40}},	//   rgía_, _тайл, _fiqa, _okuz,
   {{0x7529ab1f,0x61e1016d,0x92b380ab,0x7d041fb6}},	//   _njez, ålla, য়ায়_, _ulis,
   {{0x07a602a9,0x39405db1,0xa686004a,0x8fa603bd}},	// [5600] разн, rlis_, илад, разе,
   {{0x753bddb2,0x39405db3,0xbe8500f7,0x6d5f5db4}},	//   _akuz, slis_, مجمو, _épar,
   {{0x39404fac,0x443fb996,0x7dea8085,0xd946341b}},	//   plis_, _ayu_, təsi, _вени,
   {{0x8fa62950,0x29090870,0xdddc026c,0x6b8402a0}},	//   _каме, chaa_, _cerš, _kwig,
   {{0xaae2800d,0xf863035f,0xb60700eb,0x7dea8085}},	//   पालक, _євро, ekšē, rəsi,
   {{0x60c42bb7,0x29005db5,0x6b840a5a,0x61138162}},	//   leim, lkia_, _mwig, călz,
   {{0xe81a05e8,0x79458063,0x6449ddb6,0x2ca682c4}},	//   _नेता_, równ, _ezei, pgod_,
   {{0x7cff020f,0x64a39908,0x60c4061a,0x3f428125}},	//   _përm, _маса, neim, rðum_,
   {{0x443fb286,0x28bd80d4,0x290006a2,0xfaa6a3d7}},	//   _gyu_, ्यजि, ikia_, _вазо,
   {{0x60c41794,0x6d4d0079,0x6d4292f5,0xd6da8293}},	//   heim, _shaa, lloa, тти_,
   {{0x29000009,0xb6d900be,0x3ed900be,0x628881a9}},	//   kkia_, אַרט, אַרא, _iedo,
   {{0x60c424b2,0x69da8102,0x215aa0bb,0x6b840314}},	//   jeim, _irte, _شجاع_, _bwig,
   {{0x6288c97c,0x6f1a80c3,0xdb040144,0x442d0168}},	//   _kedo, pitc, _apiñ, çe_,
   {{0x7cff020f,0x81c30341,0x628882af,0x6b845db7}},	//   _kërk, ņēmu, _jedo, _dwig,
   {{0x8d9480f7,0x60cf1c33,0x6b8428fd,0x48ab0b79}},	//   _البش, _pacm, _ewig, ктам_,
   {{0x7c2d0102,0x6d428087,0x6288ddb8,0x7cff03ed}},	//   _txar, jloa, _ledo, _mërk,
   {{0x68ed5db9,0x195817ae,0xa1581444,0xf7731a00}},	// [5610] rjad, раты_, рату_, تاز_,
   {{0x7d1d5dba,0x69da848d,0x753bddbb,0x290901b4}},	//   liss, _orte, _skuz, shaa_,
   {{0x28a78540,0xdceb876c,0x23692d42,0x443f90e1}},	//   _गालि, šiči, _huaj_, _syu_,
   {{0x7d1d5dbc,0x23690069,0x291b0609,0xd1268bbe}},	//   niss, _kuaj_, qiqa_, _رم_,
   {{0x69da9473,0x628885f8,0xe2f990ac,0x236900f1}},	//   _arte, _bedo, леді_, _juaj_,
   {{0x2369146a,0x68e28114,0x8d77026a,0x7d1d05ed}},	//   _muaj_, _anod, _نارا, hiss,
   {{0x7d1d3726,0x236901c5,0xa3a90361,0x69da81dd}},	//   kiss, _luaj_, खंड_, _crte,
   {{0x753b829b,0x1dd5d8f3,0x26d100fc,0x7d1d5dbd}},	//   _ukuz, धिसत, _hazo_, jiss,
   {{0x443f82a0,0x2d9eddbe,0x6288c8a7,0x69daddbf}},	//   _uyu_, erte_, _fedo, _erte,
   {{0x6288a04d,0xaf059d79,0x29000102,0xb33b0118}},	//   _gedo, спол, zkia_, duço,
   {{0x7d1d5dc0,0x26d13905,0x24891357,0x2d918b24}},	//   fiss, _mazo_, _beam_, éze_,
   {{0x62888358,0x7bdbb2f4,0x41558f25,0x26d156ae}},	//   _zedo, _kruu, _увес, _lazo_,
   {{0x387fced0,0x2d9eddc1,0x23690282,0xb4c8009a}},	//   mbur_, arte_, _cuaj_, _उसी_,
   {{0x20a7800f,0x23693592,0x26d15dc2,0x291904b9}},	//   _गाँध, _duaj_, _nazo_, _amsa_,
   {{0x26c5bee9,0x6d428bb1,0x7d1d243c,0x7bcd047f}},	//   melo_, yloa, biss, _esau,
   {{0x26c5805d,0x236901c0,0x7d1d24eb,0x6b841e8f}},	//   lelo_, _fuaj_, ciss, _twig,
   {{0x69030074,0x29005dc3,0x3cf1026f,0x60c45dc4}},	// [5620] _tõen, rkia_, žová_, reim,
   {{0xb8ff058c,0x26c5805d,0x3ce618b8,0xb33b0214}},	//   _धो_, nelo_, टावे_, nuçl,
   {{0xf9921e95,0x20a7a8b3,0x628e5dc5,0x25a59aa5}},	//   _عبد_, _गांध, mabo, null_,
   {{0x6288a1e5,0xe76a08ca,0x26c58234,0xfd4d8133}},	//   _sedo, _محسن_, helo_, _ichọ,
   {{0x26c5805d,0x69030074,0xb87b0118,0x236901c0}},	//   kelo_, _mõel, _unía, _xuaj_,
   {{0x26c582fd,0x7cff020f,0x628e5dc6,0x25a592ed}},	//   jelo_, _përk, nabo, kull_,
   {{0x64408063,0x62888a9e,0x7e7e8074,0x7bdb8c2e}},	//   _wymi, _vedo, _õppi, _eruu,
   {{0x1f748249,0x628e1221,0x78a99c11,0xa7748705}},	//   олия, habo, ggev, олич,
   {{0x628e0542,0x7d1d0a7c,0x7d02ddc7,0x6b40007b}},	//   kabo, viss, mkos, lögu,
   {{0x7d1d5dc8,0x23691085,0x63a6010b,0xa7149246}},	//   wiss, _ruaj_, dukn, імні,
   {{0xd6d79006,0x2002895e,0x69da80ad,0x7d1d5dc9}},	//   сты_, ški_, _urte, tiss,
   {{0x7d029a99,0xc5f30039,0xa06a84ae,0x2369022c}},	//   nkos, לדת_, _сада_, _puaj_,
   {{0x26c5ddca,0x7d1d5dcb,0x23690069,0x705687bd}},	//   belo_, riss, _quaj_, _انشا,
   {{0x7d1d5dcc,0x26c5ddcd,0x628e37ac,0x25a5ddce}},	//   siss, celo_, gabo, bull_,
   {{0x25a58722,0x248904e7,0x26d1002a,0x7d02ddcf}},	//   cull_, _team_, _razo_, kkos,
   {{0x236910af,0x7bcd5dd0,0xa3e8800d,0x673a8722}},	//   _tuaj_, _tsau, यमा_, lotj,
   {{0x02fa83b7,0x26d104c3,0x752d0859,0x628e06a0}},	// [5630] ्साह_, _pazo_, _ijaz, babo,
   {{0x7d02867f,0x2fc901b0,0x628e2f5d,0x387f8088}},	//   ekos, rwag_, cabo, zbur_,
   {{0x7cff00f1,0x2fc92b05,0x7e6d9238,0x7d0289ff}},	//   _përh, swag_, _şapk, fkos,
   {{0xa8a711d2,0x30a70009,0x26c58234,0x7d02ddd1}},	//   _урок, _уров, zelo_, gkos,
   {{0x26d109ab,0x6265a57e,0x7af702f9,0x752d03e4}},	//   _tazo_, овла, _koxt, _mjaz,
   {{0x3866831d,0x49998656,0x69d816b5,0xe0df02d6}},	//   _agor_, атия_, _švei, _chòv_,
   {{0xdce4003b,0x945d8063,0x78a9838e,0x7cff00f1}},	//   _sunč, _pańs, tgev, _tërh,
   {{0xb4c80063,0x628e0a3b,0xe8f98dae,0xe800001b}},	//   _उसे_, zabo, рли_, लैका_,
   {{0x26c5a29d,0x78a98a0f,0x7d1bddd2,0x7d09826b}},	//   telo_, rgev, _imus, _iles,
   {{0x80d200c8,0xdcc206b7,0x78a986a8,0x212900ee}},	//   হায্, षज्ञ, sgev, hnah_,
   {{0x8afc8d38,0x7d09b7e5,0x6b52013c,0xe4c618ba}},	//   _więc, _kles, lægg, ойни,
   {{0x63a60359,0xa3ad8441,0x21295dd3,0x25a5bac8}},	//   tukn, _कमा_, jnah_, rull_,
   {{0x80d200c8,0x26c584c4,0xa34a22a7,0x1b4a1073}},	//   হাম্, pelo_, изма_, изми_,
   {{0x63a65037,0x27ffddd4,0x7d09ddd5,0x25a58168}},	//   rukn, myun_, _lles, pull_,
   {{0x628e5dd6,0x63a6015d,0x7d1b8c56,0xfd1200f7}},	//   rabo, sukn, _omus, _يجب_,
   {{0xb1460d13,0xa0670323,0xdfd25c11,0x7945866f}},	//   інал, жата_, ويز_, dówk,
   {{0xef1a2569,0x628e15d0,0x09a6952c,0x6f1e0669}},	// [5640] ама_, pabo, _गम्य, tipc,
   {{0x69c1a862,0x7d098b91,0x27ed809f,0x6d465dd7}},	//   _ople, _ales, ixen_, llka,
   {{0x6f1e5dd8,0xb87b0013,0x27ff86ff,0xa2d4873c}},	//   ripc, _gnío, hyun_, _योग्,
   {{0xf7678624,0x0eac016f,0xd9461401,0xdd8f1459}},	//   _يا_, _चावड, _феми, ئون_,
   {{0x6b44809f,0x6d4615e8,0x60d60110,0x69c1d6e9}},	//   lògi, ilka, mdym, _aple,
   {{0x7d09ddd9,0x60d60110,0x69de0289,0x7d1ba27b}},	//   _eles, ldym, _krpe, _emus,
   {{0xaab201c4,0xa2ad035a,0x4ab2000f,0xd90d815b}},	//   _जानक, _जास्, _जानव, گین_,
   {{0xd7c88077,0xdcfc8024,0xa2ba8540,0x60d60084}},	//   موعه_, _tvrđ, _शॉर्, ndym,
   {{0xd90d8416,0xc9530039,0xb81d8beb,0x5ed38264}},	//   دین_, ומה_, _बेदम_, তানে,
   {{0x7b1002af,0x21295dda,0x28da847d,0x6d462525}},	//   _häuf, znah_, _मोरि, elka,
   {{0x673acb0f,0x6b400106,0x7b100192,0x76438114}},	//   rotj, högs, _käuf, _cyny,
   {{0x290ddddb,0xe9ff80ff,0x1c1f8035,0x7afa5ddc}},	//   chea_, _hiếm_, _मेडल_, öttn,
   {{0xe9ff8028,0x8d5b80be,0x9f4681ec,0x7763802a}},	//   _kiếm_, יכטי, _groß_, _finx,
   {{0x7b1002af,0x6d465ddd,0xbd6a898d,0x994382d0}},	//   _läuf, alka, _крие_, _kış_,
   {{0x59ce01fe,0x320503b0,0x63a2ddde,0x2129178f}},	//   _हैदर, ály_, hron, tnah_,
   {{0xf8bc86b7,0x8d1801bd,0x69a2864a,0x752d1fb6}},	//   ्जिय, _وزير_, _गिनी, _ujaz,
   {{0x21290393,0xc05b035f,0x63a2803d,0xf77006e2}},	// [5650] rnah_, рів_, jron, نال_,
   {{0x21291600,0x7763b798,0x3f7b80be,0x629ea6e7}},	//   snah_, _xinx, יאמס, ópol,
   {{0x2d872db2,0x63a28fa3,0xe0df0229,0x2ef85ddf}},	//   ène_, eron, _bhòt_, _dorf_,
   {{0x63a2b340,0x629aa22e,0xf9da00be,0x613e8168}},	//   fron, _adto, _פֿיל, këlq,
   {{0x63a28e9c,0x35cc8105,0x69c1dde0,0x999e81d0}},	//   gron, ़बड़, _sple, _bytů_,
   {{0x7945809a,0x78ad00eb,0x6d4088dc,0x6595282d}},	//   mówi, lgav, _ekma, _нагу,
   {{0x290ddde1,0x63a2dde2,0x7d09c4e5,0x6d460df6}},	//   thea_, aron, _tles, ylka,
   {{0x6ca4941a,0x7763dde3,0x78ad5de4,0x7d1ba9da}},	//   _оруж, _sinx, ngav, _umus,
   {{0x6b520366,0xf8ae81f9,0x5b158162,0x77638580}},	//   læge, اکم_, _емат, _pinx,
   {{0x65640009,0xdce7826c,0x6b8981bc,0xd7098198}},	//   _siih, _mujč, _iweg, сное_,
   {{0x7bdf26f0,0x248d81c0,0x9d463160,0xc8ab0035}},	//   _arqu, _keem_, зенд, _छांट,
   {{0x753d0019,0x6b8986b0,0x236581a1,0x9cf98264}},	//   gosz, _kweg, _hilj_, _আগুন_,
   {{0x80278013,0x437512bc,0x65640009,0x248d81c5}},	//   _برام, дуст, _viih, _meem_,
   {{0x63a49bf2,0xf8bf04be,0x3d02009a,0x60c9dde5}},	//   šing, _abé_, _mówi_, leem,
   {{0x6721dde6,0x2fcdb3fc,0x2365caac,0xed5a002e}},	//   milj, lweg_, _milj_, _лок_,
   {{0x248d90f4,0x60c98a6f,0x6f1c0699,0x78ad2c19}},	//   _neem_, neem, _smrc, ggav,
   {{0x7cff00f1,0x8cbc0a27,0x6b898870,0x60d65de7}},	// [5660] _përv, ष्णो, _nweg, rdym,
   {{0x63a28036,0x60c9800b,0x2120008e,0xe0df02d6}},	//   vron, heem, siih_, _akòd_,
   {{0x02fb025f,0x6b89838a,0x248d87b6,0x629e8118}},	//   _הלימ, _aweg, _beem_, ópom,
   {{0xccf9809a,0x61e1013c,0x248d8282,0xf8bf077f}},	//   _coś_, ælle, _ceem_, _gbé_,
   {{0x248ddde8,0xead48b79,0x1c168006,0x69dc12f1}},	//   _deem_, доль, _देखल_, lvre,
   {{0x67218503,0x291d8176,0xb3e9866e,0xa3ad8105}},	//   jilj, _amwa_, تعمل_, _कमर_,
   {{0x6721805c,0x248d81c5,0x6b898133,0x51868b69}},	//   dilj, _feem_, _eweg, чула,
   {{0x63a29dcc,0x8b668bbe,0x859b0039,0x248d81bc}},	//   pron, _فاطم, _לשלו, _geem_,
   {{0x6721b70c,0x68f98101,0xed57c653,0x2fcd9989}},	//   filj, _dowd, _хот_, gweg_,
   {{0x7522dde9,0xdce400eb,0x248d8282,0x0dca964f}},	//   lioz, _runā, _zeem_, буми_,
   {{0x7ae88022,0x248d81e9,0x69dc0042,0x908a80f7}},	//   _indt, _yeem_, jvre, _هناك_,
   {{0x248d81c5,0x76a28032,0x2902d8e5,0x7522c893}},	//   _xeem_, _bíyà, ökad_, nioz,
   {{0x67218025,0x753d5dea,0x656e5deb,0x66e6a82d}},	//   bilj, rosz, _lubh, _нода,
   {{0x7afa8009,0xb87b016b,0x4ab2016f,0x7b640073}},	//   _jott, _vním, _जाणव, етсе,
   {{0x31c412a0,0x2d9c0073,0x7afa90aa,0xceb383c8}},	//   нств, ável_, _mott, _ניק_,
   {{0xa3ad85e8,0x8e4780f7,0x6b52006a,0x7afaa91e}},	//   _कमल_, _عليك_, væge, _lott,
   {{0x383428df,0x78ad00f3,0x7bdf15a0,0x248d8122}},	// [5670] ентр, rgav, _urqu, _reem_,
   {{0x7d0d003e,0x7afa8098,0x6b8982a0,0x3ce90069}},	//   _hlas, _nott, _rweg, _hnav_,
   {{0x28f90987,0x8afc0039,0x248d822c,0x78ad097a}},	//   _день_, _להזי, _peem_, pgav,
   {{0x752280d2,0x656e0c41,0x69c50234,0xd5b881a9}},	//   gioz, _dubh, _iphe, itā_,
   {{0x7afa8a85,0x39495c7e,0x656e0a2a,0x248d82df}},	//   _bott, mlas_, _eubh, _veem_,
   {{0x49b80077,0xd5b880eb,0x39495dec,0xe3b08199}},	//   _باید_, ktā_, llas_, طره_,
   {{0x7afa99aa,0x248d8069,0x39495ded,0x75229351}},	//   _dott, _teem_, olas_, bioz,
   {{0x7c3a009a,0x2cbf82f7,0x7ae88aa2,0x7afa82f7}},	//   ętrz, _ubud_, _endt, _eott,
   {{0x60c987e3,0x67218503,0xa2b58098,0x2d9e016d}},	//   reem, tilj, _обач, _åter_,
   {{0x69c53968,0x2fcd9781,0x39495dee,0x60c9b0c9}},	//   _ophe, rweg_, hlas_, seem,
   {{0xdca60391,0x64a635aa,0x394902d7,0x2fcd9f2e}},	//   мани, мана, klas_, sweg_,
   {{0x69dc0bda,0x63a48140,0x7afa94cf,0x92ea0264}},	//   vvre, šine, _zott, _মতে_,
   {{0x69c501f6,0x2bd50327,0x69d581a2,0xb87b026b}},	//   _aphe, दिगा, भिकी, _eník,
   {{0x2bc081ce,0xada181ac,0x39495def,0x88bd8035}},	//   _एहसा, ľúbe, elas_, biśc,
   {{0x6146132a,0x7cff0168,0x63abddf0,0x5ed38264}},	//   дева, _përt, hugn, তাদে,
   {{0x39495df1,0x7d0d5de0,0x69dc1bc2,0x69110366}},	//   glas_, _glas, rvre, _nåed,
   {{0x7cff020f,0x69c55df2,0x1f66012f,0x657c016b}},	// [5680] _vërt, _ephe, дкам, _strh,
   {{0x39494f52,0xa2bf9344,0x2bd486a7,0x7d0d02d4}},	//   alas_, ल्म्, _धनबा, _zlas,
   {{0x7afaddf3,0x39495df4,0xdd8f0c3b,0xa06a3d93}},	//   _rott, blas_, لول_, _мана_,
   {{0x0c26825d,0x7afa81dc,0xb80d8c28,0x69dc808b}},	//   ммен, _sott, िनाम_, _árei,
   {{0x7522853c,0xe7d880ab,0x31c6925f,0x28a78035}},	//   rioz, _তথ্য, लब्ध, _गाजि,
   {{0x39405df5,0x7522ddf6,0xa2fa914f,0x656e0362}},	//   lois_, sioz, ्सेज_, _tubh,
   {{0xaac0000c,0x2d680214,0x96630fc8,0x7afaa406}},	//   श्यक, _eğer_, _акре, _vott,
   {{0x92ea00c8,0x39402e1c,0x6d44022c,0xa0220214}},	//   _মতো_, nois_, _nkia, _şöyl,
   {{0x629e09a4,0xb8d68935,0x26d85df7,0x7afa8009}},	//   _odpo, _जा_, _karo_, _tott,
   {{0x35f48abe,0x26d85df8,0x7ae8806a,0xa3cd06ab}},	//   епор, _jaro_, _undt, रबस_,
   {{0x7d0d5df9,0x2d98ce86,0x26d808e4,0xda6581a8}},	//   _plas, ére_, _maro_, _كامي,
   {{0xd5b880eb,0x26d8009c,0x6d560122,0x7e6d8162}},	//   rtā_, _laro_, _chya, _şapt,
   {{0xd5b88029,0x29121916,0x6d560122,0x394908dc}},	//   stā_, dhya_, _dhya, vlas_,
   {{0x7cff020f,0x17548e86,0x6594b3e4,0x6d44011b}},	//   _përs, _явля, _заку, _ekia,
   {{0x69d801dd,0x26ccddfa,0x394000e7,0xcda79ef7}},	//   _šver, medo_, fois_, _قهوه_,
   {{0x6ec1000d,0x26d82b40,0xa2bf00d4,0x69078144}},	//   र्नु, _aaro_, _लॉर्, _añej,
   {{0x394945be,0x20049988,0xd6db0098,0x2486812b}},	// [5690] rlas_, nymi_, жте_, dbom_,
   {{0xb90603bb,0x39494f97,0x26cc802a,0x08540009}},	//   _यो_, slas_, nedo_, твую,
   {{0x26d82655,0x69c50234,0x60c2b77d,0x394013ff}},	//   _daro_, _uphe, _obom, bois_,
   {{0xa3d60fd5,0x63abddfb,0x6b8d5dfc,0x399a81a9}},	//   _सनम_, tugn, _kwag, dīs_,
   {{0x50641597,0x26d85dfd,0xc8641c8b,0x2fc68069}},	//   _атра, _faro_, _атри, _npog_,
   {{0x6295022e,0x2909153c,0x60cd0c5e,0x60c2ab81}},	//   nazo, lkaa_, leam, _abom,
   {{0x2fc680e4,0x61459da9,0x60c283f7,0x6b8d07fb}},	//   _apog_, нека, _bbom, _lwag,
   {{0x63abddfe,0x60cd14f2,0x26d80326,0x29090b8a}},	//   pugn, neam, _zaro_, nkaa_,
   {{0x83358160,0x62950619,0x26d85dff,0x7d048198}},	//   _знах, kazo, _yaro_, öise,
   {{0x6d4bde00,0x60cd0c5e,0x6d560314,0x6d445e01}},	//   llga, heam, _shya, _skia,
   {{0x29090364,0x62954c9e,0xd12e815b,0x6b8d33cd}},	//   kkaa_, dazo, شمی_, _awag,
   {{0x28df28ed,0x60c291d3,0xfd120250,0x29d18115}},	//   _पोलि, _gbom, اجد_, _iša_,
   {{0xeb9702bc,0x3f4287ca,0x65698364,0xe72e891e}},	//   ния_, rður_, _mieh, _бе_,
   {{0x3b0a0009,0x60dbafb3,0x2486abea,0x68fd0219}},	//   чего_, ldum, zbom_, _aosd,
   {{0xa18a0698,0xa50a10ca,0x68fd03a8,0x7f4186a5}},	//   ябва_, _нека_, _bosd, molq,
   {{0x60db9f6f,0x26d85e02,0x61e1013c,0x6569a70c}},	//   ndum, _saro_, ælla, _nieh,
   {{0x07a3351e,0x237f90af,0x8fa311b3,0x26d805e4}},	// [56a0] латн, _ntuj_, лате, _paro_,
   {{0x60d99393,0x291202a0,0x62955e03,0x7bd6076d}},	//   _lawm, shya_, cazo, _isyu,
   {{0x394000a9,0x6b9b82a0,0xdcf48289,0x60cd5e04}},	//   pois_, _avug, šači, beam,
   {{0xe57280be,0xc8ae80bc,0x644985ee,0xb0ae85fb}},	//   אַס_, _टाइट, _byei, _टाइग,
   {{0x26d85e05,0x98a0009a,0x65698609,0x249f8197}},	//   _taro_, enić_, _dieh, _ddum_,
   {{0x399a80eb,0x68eb8637,0x6449d55f,0x290fd660}},	//   tīs_, _angd, _dyei, _alga_,
   {{0x2004809a,0x27e05e06,0x9966a927,0xdca6a481}},	//   wymi_, lvin_, нтил, _пави,
   {{0xa9678fbb,0x60d981c0,0x25bb0039,0x81b280ab}},	//   нија_, _cawm, _מצלמ, টবল_,
   {{0x26cca6b9,0x60d98609,0x399a81a9,0x212481a8}},	//   tedo_, _dawm, sīs_, rimh_,
   {{0xdcc90ebf,0x656981ec,0x2ca021ab,0x7afe0087}},	//   िज्ञ, _zieh, _adid_, _nopt,
   {{0x80bd816f,0x6b8d555f,0x26ccc458,0x7bd60886}},	//   व्हे, _swag, redo_, _asyu,
   {{0x26ccde07,0x7cff0168,0x2ca081a8,0x60d98326}},	//   sedo_, _përq, óidh_, _gawm,
   {{0x62955e08,0x04670009,0x68fd00dd,0xdceb8289}},	//   tazo, этом, _rosd, šići,
   {{0x27e05e09,0xdcfb0084,0x6d4286ae,0x7b100799}},	//   dvin_, ystė, hooa, _räuc,
   {{0x29090009,0x60d9822c,0x62340162,0xdb029727}},	//   tkaa_, _yawm, геру, ntoñ,
   {{0x58d41628,0x6b8d020c,0x62955e0a,0x290f01a8}},	//   лост, _twag, sazo, óga_,
   {{0x6295062f,0x29092683,0x6b8d18e3,0xbcfb360c}},	// [56b0] pazo, rkaa_, _uwag, rméd,
   {{0x656982af,0x60cd4909,0x81d780ab,0x6d4b8079}},	//   _sieh, seam, ামত_, wlga,
   {{0x6b9b8052,0x6449a08b,0x63bd5e0b,0x60cd35f7}},	//   _svug, _syei, ltsn, peam,
   {{0x48ab0364,0x3946822c,0xeb099905,0x764a8114}},	//   _этом_, _nkos_, वस्त_, _myfy,
   {{0xc6a70dc7,0x4ea70195,0xe4a481e5,0x98a0066f}},	//   _први, _прва, урхо, wnić_,
   {{0xfe700154,0x9f3500e8,0x6569822b,0x8c1c01c6}},	//   _هدف_, _регі, _wieh, הודי,
   {{0x15a80098,0x9f3400e8,0xae1e016f,0x6569c269}},	//   _пъти_, _сері, _येऊन_, _tieh,
   {{0xf9940451,0x98a00fda,0x25fe0327,0x60d99953}},	//   ארק_, rnić_, लहरी_, _qawm,
   {{0x200b83fb,0xe0d6827e,0x60dbde0c,0x69c88144}},	//   áci_, твы_, rdum, _epde,
   {{0xb8e880d4,0x55e58188,0xa2ad0b84,0x394682df}},	//   _लॉ_, вооб, _जाग्, _ekos_,
   {{0x7cff020f,0x60d981c0,0xa2ba864a,0x290f876d}},	//   _përp, _tawm, _शॉट्, _tlga_,
   {{0xb4ac184a,0x2f04016d,0x68eba28f,0x7afe5e0d}},	//   खले_, _högt_, _ungd, _sopt,
   {{0x63af0052,0x7afe5e0e,0x2d478187,0x394da2ba}},	//   gucn, _popt, lões_, mles_,
   {{0x394dde0f,0xa3e283eb,0xe8ff00e7,0x395fde10}},	//   lles_, धित_, _aoû_, lmus_,
   {{0x320c026f,0xcb67002e,0x63bd090d,0x764a8428}},	//   ády_, таре_, atsn, _gyfy,
   {{0x25de8076,0x2d85b68b,0xdddc0110,0x8afc809a}},	//   गिरी_, mple_, _perž, _pięk,
   {{0x394d80e7,0x395901a1,0x7afe1f1a,0x75241b8f}},	// [56c0] iles_, _dhss_, _topt, _imiz,
   {{0x320784e8,0xbcfb0036,0x395fab3a,0x3ce606ae}},	//   kyny_, rmée, hmus_, _जोते_,
   {{0x8afc809a,0x63bb913b,0xb4e6046d,0xe0df02d6}},	//   _więk, _aqun, _gbàá, _ikòn_,
   {{0xd8260dc8,0x64a6de11,0x6da335cc,0x63a923f9}},	//   _адми, тада, рица, šene,
   {{0x69030074,0x2f04007b,0xdd0c8035,0x290c01a9}},	//   _võet, _sögu_, _półn, ūdas_,
   {{0x394d8548,0x69c881df,0xf9c69fb4,0x39468933}},	//   eles_, _ppde, вщин, _skos_,
   {{0x3f8f930c,0x2d47841c,0x7bc10162,0x63bb912e}},	//   _awgu_, gões_, ălui, _equn,
   {{0xf9930051,0x395f856c,0x3cffa1bf,0x31ba80f1}},	//   ברה_, gmus_, _gouv_, rëz_,
   {{0xab66a29c,0xa2bf816f,0x2489816a,0x04468425}},	//   _авал, ल्ह्, ñame_, _реан,
   {{0x394dde12,0x75245e13,0x7d00de14,0x27ff0036}},	//   ales_, _amiz, _homs, _àune_,
   {{0x629884e8,0x394d90b6,0xceb30039,0xd6d7853b}},	//   mavo, bles_, בית_, тты_,
   {{0x394db68b,0x6298828e,0x4fc68791,0x60268103}},	//   cles_, lavo, _аска, _идеа,
   {{0xdcfb0029,0x6931803d,0xd00f80f7,0x7d00b417}},	//   lstī, _دکور, _ولم_, _moms,
   {{0x63af0052,0xb3458073,0x6298de15,0x75243bb8}},	//   rucn, moçã, navo, _emiz,
   {{0x1db69370,0x57578039,0x6728a28c,0x645605ee}},	//   _अमित, _שבוע_, midj, _ezyi,
   {{0x26dc81ed,0x3944de16,0x7524011f,0x6934373a}},	//   _havo_, noms_, _gmiz, ансу,
   {{0x26dc8e2d,0x2d478187,0xb8db052a,0x80be8264}},	// [56d0] _kavo_, zões_, _घा_, ্যপ্,
   {{0xdcfb0029,0x6d4f02e6,0x3f141157,0x3f9b56b9}},	//   kstī, llca, адус, rsqu_,
   {{0x8d740250,0x7bc9de17,0x3944de18,0x2d4783a7}},	//   لانا, _speu, koms_, xões_,
   {{0x58840b71,0x394d04b7,0x656d0b7e,0x394496b5}},	//   _выра, ċess_, _jiah, joms_,
   {{0xad1c093f,0x21290587,0xaac010be,0x4ac001c4}},	//   וואר, miah_, श्वक, श्वव,
   {{0x2129059c,0x6298de19,0x2d4783a7,0x69030074}},	//   liah_, gavo, tões_, _tões,
   {{0x27e6b2db,0x80be80c8,0x60dd5e1a,0x395f8f09}},	//   _aron_, ্যন্, _kasm, tmus_,
   {{0x27e6a9d2,0x21295e1b,0xdfd180f7,0x2d47841c}},	//   _bron_, niah_, ميع_, rões_,
   {{0x20090393,0x60dd5e1c,0x2d4783a7,0x27e68706}},	//   nyai_, _masm, sões_, _cron_,
   {{0x26dc8081,0x2129036e,0x60dd5e1d,0x65750168}},	//   _cavo_, hiah_, _lasm, _kuzh,
   {{0xd2518013,0x4d662f42,0x88bd809a,0x6d5bc2ad}},	//   _انا_, лков, liśm, _khua,
   {{0x637f8087,0x644d05ee,0x39449532,0x27e6b807}},	//   _tână, _byai, coms_, _fron_,
   {{0x2129059c,0x657523ac,0xbebc81a9,0x8fa59246}},	//   diah_, _luzh, rnīr, _сале,
   {{0x8f9a893f,0x6d5b81c0,0x68fbad2e,0xe45680be}},	//   _װיקי, _lhua, ljud, טירט_,
   {{0x6d49de1e,0x21292b36,0x71761a3c,0x60dd5e1f}},	//   _okea, fiah_, اهرا, _basm,
   {{0xdd008029,0x656d4f24,0xdddc01b9,0x62988f87}},	//   ītīb, _giah, _verż, zavo,
   {{0x6d465e20,0x46ea49a1,0x27e60013,0xa2ac0054}},	// [56e0] moka, ндан_, íon_, _जयप्,
   {{0x6d465e21,0x6b844378,0x6d5f00e5,0x6d5bc2c5}},	//   loka, _itig, _èpar, _ahua,
   {{0x6d5b8ad0,0x6937005c,0x20090590,0x21290359}},	//   _bhua, mćen, ayai_, biah_,
   {{0x6d5b861f,0xb87b1984,0x6d463718,0xd910081b}},	//   _chua, _caíd, noka, _بیر_,
   {{0x6298de22,0x44208028,0x6d5ba039,0x5b2681e2}},	//   tavo, ài_, _dhua, лька,
   {{0x6d465e23,0x63a482d7,0x9e6600d7,0xa2bf8072}},	//   hoka, šino, _مازن, ल्ल्,
   {{0x62988a56,0x29025e24,0x672882a5,0x6d465e25}},	//   ravo, _koka_, vidj, koka,
   {{0x26dc8a8e,0x2902025d,0xf9930039,0x6d5b8c41}},	//   _savo_, _joka_, זרה_, _ghua,
   {{0xe2928307,0x2fc01c11,0x35ba0105,0x6298de26}},	//   _هذا_, ntig_, _उमड़, pavo,
   {{0x29025e27,0x2fc002af,0x2129036e,0x6d5b80fc}},	//   _loka_, itig_, ziah_, _zhua,
   {{0x68fb80f2,0x644d0812,0x64410201,0xceb30039}},	//   bjud, _syai, əliy, זית_,
   {{0x69dade28,0x2ed10fe4,0x27e6de29,0x2fc00687}},	//   _iste, _हस्त, _tron_, ktig_,
   {{0x60dd0c9e,0xc62105fb,0xdb1d0019,0x26dc8110}},	//   _rasm, _मध्य_, ltsé, _tavo_,
   {{0x501b8051,0xe81d8b85,0x60dd5e2a,0x212900ee}},	//   _אודו, _बेटा_, _sasm, wiah_,
   {{0x6d464ee7,0x13cd80ab,0x212900dd,0x764e01a3}},	//   boka, লিয়, tiah_, _nyby,
   {{0x2fc01277,0x2d9ea39e,0x6d462168,0x70af0072}},	//   ftig_, mste_, coka, टलेल,
   {{0x2fc05e2b,0x21290590,0x290204b9,0x200f0019}},	// [56f0] gtig_, riah_, _doka_, ági_,
   {{0x69da9711,0x6d5bde2c,0xb87b0e67,0x60dd1306}},	//   _oste, _shua, _saíd, _wasm,
   {{0x2d9e9989,0x60dd4f79,0x21290072,0x5c75af4b}},	//   nste_, _tasm, piah_, алет,
   {{0x2d9ede2d,0x39a101e2,0x7985112e,0x01ba80ab}},	//   iste_, mės_, _ithw, ংবাদ,
   {{0x39a10a8e,0xc05810ac,0x69daca2b,0x389a0538}},	//   lės_, _бір_, _aste, _בירנ,
   {{0x3f895e2e,0x2d9e92af,0x6b7c00be,0x6d464954}},	//   mpau_, kste_, ערונ, zoka,
   {{0x39a10746,0x6d5bde2f,0xd2b80039,0x6d46544e}},	//   nės_, _thua, אלות_, yoka,
   {{0x2d9e9610,0x629700f1,0xd131880b,0xb0f380ab}},	//   dste_, _lexo, تمع_, জস্ব_,
   {{0x2d9ede30,0xe8f68791,0x02a780b3,0x290d8bf0}},	//   este_, рлы_, _брем, rkea_,
   {{0x39a101e2,0x62971e00,0x26d303a8,0x81cc00ab}},	//   kės_, _nexo, nexo_, লিত_,
   {{0x6d465e31,0x2d9ea68d,0xdce9b2b2,0x7985022c}},	//   toka, gste_, _lieč, _nthw,
   {{0x39a10110,0xb91281bc,0x2b478088,0x00000000}},	//   dės_, _mgbọ_, lonc_, --,
   {{0xdce981ac,0x29020ed6,0x2d9ede32,0xdb1ba706}},	//   _nieč, _roka_, aste_, _aqué,
   {{0x6d463990,0x29025e33,0x69daaaef,0x26c78282}},	//   soka, _soka_, _yste, _ubno_,
   {{0x6d465e34,0x4096067c,0x29025e35,0xe2970ddc}},	//   poka, ират, _poka_, рас_,
   {{0x2fc050e9,0x387f978f,0x776e01c0,0x63a9011f}},	//   ttig_, ncur_, _sibx, šena,
   {{0x06d880c8,0x6937157c,0xfaa615ac,0xb912819d}},	// [5700] তারি, pćen, _капо, _agbọ_,
   {{0x39a101e2,0xef170f25,0x2fc05e36,0x3ce001c5}},	//   bės_, аму_, rtig_, _haiv_,
   {{0x2fc03a6d,0x290210fa,0xab5b02af,0x7bdb8c2e}},	//   stig_, _toka_, stüc, _asuu,
   {{0x7d040009,0x6281a64f,0x66031a50,0xbfcd0032}},	//   _jois, _aflo, änka, _dáṣọ_,
   {{0x6562de37,0x3ce001c5,0xfbd2b026,0x28df0327}},	//   rmoh, _maiv_, تتا_, _पोटि,
   {{0xf1a6946c,0x7d045e38,0xa3ce32dd,0x6f03cdb0}},	//   арин, _lois, _रहन_, _nonc,
   {{0xbcfb0019,0x35a33c3d,0xe5a320bf,0x316f81a1}},	//   dmén, _марг, _мири, _bigz_,
   {{0x7d045e39,0xed5a9b2f,0x3b86ae65,0x6281de3a}},	//   _nois, _роб_, _влаг, _eflo,
   {{0x629c5e3b,0xd7fa8749,0x39a10110,0xc60e824c}},	//   karo, туй_, zės_, ान्य_,
   {{0x2d9e9aee,0x629c01ca,0xa9a68098,0x7b100192}},	//   tste_, jaro, _вижд, _bäum,
   {{0x69dacb16,0x7bcd01e2,0x6f03809f,0x7d045e3c}},	//   _uste, _spau, _donc, _bois,
   {{0x7d04599c,0x39a101e2,0x3ce00069,0x7bc29336}},	//   _cois, vės_, _caiv_, otou,
   {{0x6f0383d3,0x2d9e83dc,0x7d0402ce,0x7bc2de3d}},	//   _fonc, sste_, _dois, ntou,
   {{0x6e948307,0x39a10a8e,0x8f9b8158,0x629c0333}},	//   _الثا, tės_, _יידי, garo,
   {{0x7d04473d,0x7d161277,0x394b0144,0xba080081}},	//   _fois, _flys, _pkcs_, ахте_,
   {{0x39a10110,0x09c380ab,0x9875431c,0x7d045e0b}},	//   rės_, ্মচা, слац, _gois,
   {{0x39a101e2,0x25de800f,0x6d4d3162,0x63a496f2}},	// [5710] sės_, गिकी_, _ikaa, šinj,
   {{0x02a72a71,0x629c3724,0x657881c0,0x39a10110}},	//   _трим, caro, _kuvh, pės_,
   {{0x5fd884e5,0x09f90013,0xdcfc8029,0xa3df0701}},	//   _बैसल, _صفحة_, _strā, णिक_,
   {{0xbcfb0019,0x26d35e3e,0xdb0b86a5,0xd7a68105}},	//   zmén, sexo_, rugí, _खिंच,
   {{0x657880ee,0x2bda873c,0xaca381bc,0xd7f8151a}},	//   _luvh, _मैदा, _nnụn, _кур_,
   {{0x9735053d,0xc324a1d2,0xe29681e5,0x7d1983e4}},	//   _اکرا, омік, баш_, shws,
   {{0x20028009,0x7582003d,0x3f868176,0xa0a5d3c2}},	//   äkin_, _فیلم, _atou_, байд,
   {{0x629c25ca,0x6f03807a,0xeb040aed,0x7b1001ec}},	//   zaro, _sonc, _रक्त_, _räum,
   {{0x7529c692,0x7bc285db,0xa3e28ec5,0x6f03989d}},	//   _imez, ctou, धिः_, _ponc,
   {{0x6d4d30a0,0x7d0401e4,0x7d160ff4,0x629c4382}},	//   _akaa, _sois, _slys, xaro,
   {{0x629c5e3f,0x3ce001c0,0x7d0427d3,0x395d81c0}},	//   varo, _paiv_, _pois, _thws_,
   {{0xcb090bea,0x7ae1de40,0x629c5e41,0x98b001d6}},	//   _אל_, _halt, waro, _šaľa_,
   {{0x7d0422b2,0x7f8580f7,0x7ae19473,0x66e5876a}},	//   _vois, _التن, _kalt, _гола,
   {{0x44630081,0x249d8069,0xf67980be,0x6f1ac9ee}},	//   явяв, hawm_, _גאַמ, chtc,
   {{0x7ae181cd,0x7d044663,0x629c5074,0x7b32809a}},	//   _malt, _tois, raro, sług,
   {{0x645a0086,0x629c13a8,0xb87b05e4,0x443f8085}},	//   ətin, saro, _raíc, _oxu_,
   {{0xc6760eca,0x66761650,0x66030106,0x39522cd4}},	// [5720] مطاب, مدار, änkn, rlys_,
   {{0x1ea9080b,0xe646035f,0x7529de42,0x69c3d5ee}},	//   لامي_, безп, _amez, ktne,
   {{0x394901df,0x645b89b2,0x69c38b80,0x61460084}},	//   boas_, _azui, jtne, _гена,
   {{0xdca3a410,0x63a413c2,0x69de3333,0x39490216}},	//   заци, _kvin, _ispe, coas_,
   {{0xd9e082a8,0x7cff0168,0x7ae1de43,0xc30a85a8}},	//   पट्ट, _përz, _balt, ледж_,
   {{0x7bc282be,0x75298135,0x60d60965,0x7ae1c7ff}},	//   rtou, _emez, leym, _calt,
   {{0x7ae1a305,0x7bc2801b,0xf2d31101,0xe7e0064a}},	//   _dalt, stou, פעה_, निकप,
   {{0x7ae1c7cb,0x63a45e44,0xd13080f7,0x61e1006a}},	//   _ealt, _ovin, ظمة_, ælli,
   {{0xfaa68607,0x200d8061,0xaaba8bbe,0x17fa81a8}},	//   _газо, gyei_, _مدار_, ارعة_,
   {{0x69de5e45,0x6d4d01b0,0xd6daa05f,0xb7db03c8}},	//   _ospe, _skaa, ути_, נקיי,
   {{0x63a45e46,0x63a2de47,0x29e785f3,0x24f90190}},	//   _avin, lson, _gđa_, анны_,
   {{0x2d731123,0x39490118,0x629a83ed,0x7ae18bfd}},	//   _kćer_, xoas_, _heto, _zalt,
   {{0x629ade48,0xe0438b9c,0x07e98019,0x68e45e49}},	//   _keto, _енци, _پرنٹ_, ddid,
   {{0xf1dc81b6,0x629a80f1,0x63a91620,0xdc378158}},	//   _मनान, _jeto, šeno, מאכט_,
   {{0x63a4017b,0x80db8264,0xc33381c6,0x68e2de4a}},	//   _evin, ভার্, לוש_, _kaod,
   {{0x629a8ef1,0x995521d2,0x29000168,0x68e42b9c}},	//   _leto, ікац, gjia_, gdid,
   {{0xdb0f05e4,0x752f009a,0x394903a7,0xb87b016a}},	// [5730] lucí, micz, roas_, _caía,
   {{0x291b0713,0x629a8243,0x752f009a,0x63a29c11}},	//   shqa_, _neto, licz, dson,
   {{0xf3cb0077,0x6eca8a0d,0xa282003d,0x63a45e4b}},	//   _شبکه_, त्यु, _آیفو, _zvin,
   {{0x752f0063,0x81cc00c8,0x54558098,0x6aa89670}},	//   nicz, লিশ_, овет, _addf,
   {{0x629aafbc,0x7ae1de4c,0xdcfc802e,0x03a5802e}},	//   _beto, _palt, _stră, цило,
   {{0x69c3dddc,0x629ade4d,0x539c00be,0x317a06cb}},	//   ttne, _ceto, ניוו, _yupz_,
   {{0x7ae1de4e,0x7bdf5e4f,0x56940196,0x63a2cbcd}},	//   _valt, _lsqu, _хаст, ason,
   {{0xdb0f0e15,0x77859fa2,0xe7a99033,0x753b804f}},	//   ducí, олиз, авил_, _ujuz,
   {{0xef199383,0x6d4b8019,0x69c3b78d,0x600681bb}},	//   ими_, moga, stne, жным_,
   {{0x629a83b2,0x6b8982a0,0x2ca95e50,0xc34b8110}},	//   _geto, _iteg, _adad_, _сябе_,
   {{0xceb20158,0x29190182,0x752f009a,0x7bdf0216}},	//   ויי_, _olsa_, ficz, _asqu,
   {{0x6d4bd826,0x752f009a,0xa3e60e5b,0x629ade51}},	//   noga, gicz, फिल_, _zeto,
   {{0xe72e8dac,0x636002af,0x27e90b80,0x2d5900e7}},	//   _же_, höne, jvan_, péen_,
   {{0x2ca9076f,0x63a48013,0xe29715fe,0x6d4bde52}},	//   _edad_, áini, жар_, hoga,
   {{0x7bdf0887,0x6ee48591,0xb87b2363,0x91e327cb}},	//   _esqu, _رسول, _saía, море,
   {{0x63a403a6,0xf8d981ce,0x63a4ac62,0x6b8992e5}},	//   _tvin, ढ़िय, šini, _oteg,
   {{0x68e410dd,0x6d4bde53,0x37060294,0xaf062597}},	// [5740] rdid, doga, опаг, опал,
   {{0xab5b05c5,0x0cd68264,0x65608362,0x98a9066f}},	//   ntül, _সচেত, _shmh, ynać_,
   {{0x394619d9,0x69de5e54,0x6d4b89df,0xec7abd73}},	//   _мног, _uspe, foga, апе_,
   {{0xa3ce0d38,0xf09f0028,0x63a2b768,0x629a872f}},	//   _रहा_, _hoàn_, tson, _seto,
   {{0x6bd680d7,0x225880c3,0x934684db,0xd4038198}},	//   تتار, _šrk_, онде, дящи,
   {{0x63600019,0x47d900be,0xa3bbde55,0x37d900be}},	//   lönb, _פֿרײ, _अमर_, _פֿרע,
   {{0x65c32804,0x629aca58,0x63a29e68,0x6b898c2e}},	//   _обра, _veto, sson, _eteg,
   {{0x63ad8341,0x984f8059,0x8c46867c,0x442201a1}},	//   šana, _ağır_, _дебе, kzk_,
   {{0x629ade56,0xdfd080a0,0x4aca0107,0x50b7803d}},	//   _teto, ريد_, िभाव, زديد_,
   {{0xe5c68364,0xcf2680f7,0xbcfb0036,0x752f0035}},	//   осмо, تربي, rmém, wicz,
   {{0x667b010f,0xd5b781d9,0xa3e290c8,0x6d4380e7}},	//   יטיק, ося_, धिक_, énag,
   {{0x6eca03dd,0x7d02acc7,0x657c5e57,0x27e9007e}},	//   स्तु, njos, _murh, yvan_,
   {{0xdee69afa,0x1ae400c8,0x66e69577,0xa06a8eef}},	//   _моди, খানে_, _мода, _тада_,
   {{0xb87b0118,0xdce401a1,0x78a081f6,0x672a808b}},	//   _caín, _dunđ, lamv, _umfj,
   {{0x31c40b79,0x7bc60ad4,0x39838214,0x657c036e}},	//   мств, atku, _kısa_, _nurh,
   {{0x2eed1d81,0x6d4bddaf,0x2ee3022b,0x3ce695d8}},	//   _şef_, xoga, _sajf_, jdov_,
   {{0x752d120f,0x6d4b8317,0xdce400fe,0x7d028b80}},	// [5750] _imaz, voga, _gunđ, djos,
   {{0x27e91384,0x368b01e5,0x7c228805,0xa92801d0}},	//   rvan_, рсан_, dzor, _požá,
   {{0x57b7853e,0x6d4bde58,0x657c0e6d,0x673a86a8}},	//   _आम्ह, toga, _curh, intj,
   {{0xbfa38129,0x7bf9a3d7,0x98a000c3,0x6f07066f}},	//   _biế, йнер_, viić_, _wojc,
   {{0x6d4bbc36,0x7ae50406,0x69c7480a,0x4fc40b26}},	//   roga, _kaht, ltje, _осра,
   {{0x37c280c8,0x31693f41,0x673a81ed,0x657c010c}},	//   ্টার, lmaz_, jntj, _furh,
   {{0x69c75e59,0x5ee100ab,0x34958767,0x7ae51bda}},	//   ntje, নাদে, _навр, _maht,
   {{0x7ae50406,0x3169080a,0x39a580eb,0x673a86a8}},	//   _laht, nmaz_, rēs_, entj,
   {{0x63a9003a,0x69c70582,0x60c9842b,0x6b89c736}},	//   šenj, htje, rfem, _uteg,
   {{0x1dd21516,0xa2b4b51e,0xef1996cf,0x752d5e5a}},	//   _सहमत, _обуч, смо_, _amaz,
   {{0x69c700f1,0x7d1bde5b,0xe8df81bc,0x69c501c0}},	//   jtje, _klus, _azụm_, _nqhe,
   {{0xb87b03a8,0xdce4042b,0x673a9151,0x69c70366}},	//   _saín, _punđ, antj, dtje,
   {{0x7d09de5c,0x2bdf0327,0x7ae53d77,0x69c700f3}},	//   _moes, _पैदा, _baht, etje,
   {{0xa3ae890a,0x752d3c4c,0x394dde5d,0x692c02d0}},	//   _किस_, _emaz, loes_, rşem,
   {{0x7d1bba3e,0x7bc61aed,0x7c2280e5,0xf77080d7}},	//   _olus, stku, zzor, _شاه_,
   {{0x04460081,0x752d082c,0x657a0036,0x64430035}},	//   _нейн, _gmaz, _éthi, _śnie,
   {{0x6843046a,0xe04311d5,0xf09f0104,0x80dd0076}},	// [5760] ента, енти, _toàn_, _पसरे,
   {{0x7d1b81c2,0x752d01ac,0x394dde5e,0x8c3d82d0}},	//   _alus, _zmaz, hoes_, _keşf,
   {{0x7d09de5f,0xf29701c6,0xfebd8264,0x63a6209b}},	//   _boes, _מכיר_, _অসাধ, lskn,
   {{0xdd8f12dc,0x7d1ba543,0x2d870c52,0x7c228102}},	//   اون_, _clus, ínea_, tzor,
   {{0xf8b30bea,0x629e01f1,0x98a48110,0x63a62c15}},	//   _אשר_, _kepo, nimą_, nskn,
   {{0x7d1badf8,0x7c22de60,0xada60d45,0x657c0009}},	//   _elus, rzor, _нагл, _turh,
   {{0x7c228061,0x7d1d067f,0x394d8114,0x6b520366}},	//   szor, ërsk, foes_, lægs,
   {{0x629e095e,0xbcfb0065,0xfce38758,0x26da1024}},	//   _lepo, rmék, _посо, lepo_,
   {{0x98a48110,0x6d409a7b,0x44228106,0x61e18580}},	//   jimą_, _ijma, _åk_, _esll,
   {{0x629e258f,0x2486de61,0x65645e62,0x68e60326}},	//   _nepo, lcom_, _ahih, _lakd,
   {{0x2d9886e3,0x27208028,0x78a080b4,0x1cd90110}},	//   ère_, _lòng_, pamv, одны_,
   {{0x2486de63,0x394d8187,0x68e605b0,0x291fda58}},	//   ncom_, coes_, _nakd, chua_,
   {{0x61dc8aed,0x399a8110,0x65644584,0x60c2de64}},	//   _मनुष, lūs_, _dhih, _icom,
   {{0x26da02fd,0xbcfb00f7,0x65640135,0x629e5e65}},	//   jepo_, iméi, _ehih, _cepo,
   {{0x629e26e7,0x6588801b,0x68e612b7,0x5f000a27}},	//   _depo, _běhe, _bakd, रान्_,
   {{0x672e04b7,0x69c750e9,0xe63b8039,0x752d5e66}},	//   _ambj, rtje, _לתוכ, _umaz,
   {{0x7ae514c7,0x69c73fd6,0xc05b00e8,0x7d098cab}},	// [5770] _taht, stje, сів_, _roes,
   {{0x6d4f1a47,0x27208028,0x629e0574,0x316900eb}},	//   loca, _dòng_, _gepo, smaz_,
   {{0x7d09a57f,0x692c1238,0x6f1c1b88,0x753d0799}},	//   _poes, kşeh, _dlrc, onsz,
   {{0x7d1d00f1,0x291f81c0,0x6ec1175d,0x6288a301}},	//   ërsh, xhua_, र्जु, _afdo,
   {{0x3b098396,0xdb1b8187,0x63601e2b,0x96eb2357}},	//   жело_, _aquá, löna, _льва_,
   {{0x63ad80eb,0x6d4f01a8,0x7d098cfa,0x60cd07f1}},	//   šano, hoca, _woes, lfam,
   {{0x7d0985f8,0x2fc95e67,0xe9d980e8,0x290b02d0}},	//   _toes, ltag_, іки_, _koca_,
   {{0xa3ce2cdd,0x2d83816b,0x7d1b8214,0x290b0088}},	//   _रहल_, íjem_, _ulus, _joca_,
   {{0xb8d583db,0x63a48013,0x2fc94255,0x6b8d5e68}},	//   _जय_, áint, ntag_, _ntag,
   {{0xee39aaed,0x290b349a,0x05a98009,0x656400f1}},	//   жно_, _loca_, овой_, _shih,
   {{0xdb268077,0x6aa38b50,0x6d4f5e69,0x6d47011a}},	//   _تولی, manf, foca, čkan,
   {{0x60c28013,0x629e5e6a,0x63a9807b,0x6b9bac18}},	//   _gcom, _sepo, _kven, _kwug,
   {{0xa2c4800d,0xeb970656,0x249f8176,0x629e57d2}},	//   _राम्, мия_, _meum_, _pepo,
   {{0x63a60082,0x68e98c4d,0x6aa391e6,0x06e180ab}},	//   rskn, lded, nanf, বাহি,
   {{0x6b8d5297,0x68e621e5,0x60cd5e6b,0xa50a1289}},	//   _etag, _pakd, ffam, _мека_,
   {{0x68e99f90,0x249f8da4,0x63a9a2ba,0x26da0010}},	//   nded, _neum_, _oven, wepo_,
   {{0x2fc9033e,0x8fa310f8,0xcece80ff,0x27edde6c}},	// [5780] gtag_, кате, _mộng_, nven_,
   {{0x27208028,0x6d599849,0x3636003d,0xdb1b8118}},	//   _vòng_, elwa, وراس, _opuñ,
   {{0x68e65e6d,0xa3e60ebf,0x2486de6e,0x6aa38357}},	//   _takd, फिक_, tcom_, danf,
   {{0x290b5e6f,0x249f851e,0x68e98366,0x6b9b818e}},	//   _goca_, _ceum_, jded, _bwug,
   {{0x27ed8613,0x249f8197,0xc3da803d,0x68e9de70}},	//   jven_, _deum_, تباط_, dded,
   {{0x60c28081,0x6d59cbcd,0xbcfb0f35,0x290b0118}},	//   _scom, alwa, rméi, _zoca_,
   {{0x63a9c4fa,0x81cc00c8,0x27ed80f3,0x2486ccef}},	//   _even, লিক_, even_, pcom_,
   {{0xcece8028,0x63a901ac,0x2ca00006,0x78a40242}},	//   _cộng_, šeni, _neid_, naiv,
   {{0x27e05e71,0x5ee100ab,0x2d5c823e,0x64a38721}},	//   nwin_, নারে, níem_, _шата,
   {{0x2216801e,0x44268010,0x63a4de72,0xf4040264}},	//   _офер, mzo_, šins, উনার_,
   {{0x27e01083,0x1d350d8e,0x6b8d1e68,0x442681e8}},	//   hwin_, ення, _stag, lzo_,
   {{0x60db82b7,0x66033416,0x291d86c4,0x6b80c0c0}},	//   ceum, änki, _glwa_, _kumg,
   {{0x4426de73,0x7a13800d,0x290b2c92,0x1016806b}},	//   nzo_, _větš, _roca_, _تباد,
   {{0x27208176,0x290b16dc,0xbcfd8129,0xdb0b8106}},	//   _bòne_, _soca_, _nhũn, stgö,
   {{0xd90f04c0,0x290b3bfe,0xc1dc816f,0x09dc8054}},	//   لید_, _poca_, _मनोग, _मनोय,
   {{0x58d40c3e,0xa2d580d4,0x2fc91b48,0xa3ae8101}},	//   кост, _मॉन्, ttag_, _किं_,
   {{0x3fbc80c8,0x40342f7d,0x290b0bcf,0x60cd074d}},	// [5790] _অনুষ, ветс, _voca_, rfam,
   {{0x63bd07ba,0x2d870207,0x7ae88953,0x4426de74}},	//   musn, íneo_, _nadt, dzo_,
   {{0xc1750c3e,0x63a98687,0xb8e500c8,0x68e98bff}},	//   _площ, _sven, _এস_, yded,
   {{0x61e55e75,0xb4b98935,0x7afada96,0x7d0d5e76}},	//   _ishl, चले_, _antt, _joas,
   {{0xdb1d013c,0xcece801c,0x7ae8de77,0x7d0d4633}},	//   rtsæ, _rộng_, _badt, _moas,
   {{0xfbb2009a,0x31668fe0,0xdcf58162,0x8f9a0538}},	//   _जिसम, _ahoz_, _buză, _מישי,
   {{0xe5c41697,0x24808052,0xaca3819d,0x6d5986c0}},	//   _исто, žima_, _azụa, plwa,
   {{0x7d0d0012,0x27ed80d2,0x3fe58b5b,0xfa7802f6}},	//   _noas, tven_, ежив, ועות_,
   {{0x6c54aa71,0x61f88038,0x68e9bc51,0x20198019}},	//   _акту, _ďalš, rded, ási_,
   {{0x60dbcdc6,0x26c110e4,0x2ca05e78,0x29028338}},	//   seum, ngho_, _seid_, ökar_,
   {{0xed5a0607,0xa2c4863a,0x7bcbde79,0x27e01415}},	//   зон_, _रात्, ltgu, zwin_,
   {{0x6aa19ab0,0xf2c9007c,0xa3e403db,0x67218b80}},	//   _helf, _לע_, _ननद_, shlj,
   {{0x2d9c3b50,0x63bd0c9a,0xdb06026f,0x7bcb881a}},	//   ávez_, gusn, lské, ntgu,
   {{0xada5a2d2,0xe9ff8028,0x5ecf00ab,0x316dbf41}},	//   _закл, _giảm_, _হোসে, lmez_,
   {{0x44268021,0x3ea5a947,0xdb06003e,0x216a490c}},	//   zzo_, malt_, nské, зиви_,
   {{0x63bd0988,0x3ea5de7a,0x316d82d0,0x79818c2e}},	//   busn, lalt_, nmez_, _mulw,
   {{0x63ad8ee1,0xd1750048,0x81d580c8,0x59750071}},	// [57a0] šanj, тыры, িটি_, тыру,
   {{0xe9e58028,0x6fb312dc,0x27e05e7b,0xff7a80be}},	//   _đúng_, املا, rwin_, פטעמ,
   {{0x8236004e,0x2d9c102d,0xdd8f1a00,0xa0a61c79}},	//   _سردا, ève_, مول_, _панд,
   {{0x3ea5d95b,0x3ce9022c,0x442699fd,0xb81f8072}},	//   halt_, _xaav_, tzo_, यनाम_,
   {{0x39405d13,0x80c9016f,0x3ea597ab,0x6aa1de7c}},	//   mnis_, _हॉटे, kalt_, _belf,
   {{0x4426c2ee,0xf6510117,0x853d0110,0x7981de7d}},	//   rzo_, ائے_, gsėj, _bulw,
   {{0x6aa1c561,0x3f82022e,0x8cc1009a,0x6d565e7e}},	//   _delf, _huku_, _वालो, _okya,
   {{0x3f821e8c,0x2c578063,0xdcfc976d,0x394027d3}},	//   _kuku_, _będą_, _kurč, nnis_,
   {{0x9346938f,0x0b469bc1,0x63bd026f,0xdcfccec8}},	//   _знае, _знан, xusn, _jurč,
   {{0x3f8204b9,0x6d443353,0x6d470696,0x2ca6833e}},	//   _muku_, _ajia, čkam, laod_,
   {{0x39400cf6,0xd36f9a3c,0xf1d48074,0x613b0198}},	//   knis_, _اهل_, _दहिन, nälä,
   {{0x6aa18613,0x2724008b,0x39521e44,0x76589075}},	//   _zelf, _hönd_, joys_, _vyvy,
   {{0x8c3d87d9,0xa2d58074,0x3ea5cdc6,0x7d0d0087}},	//   _teşe, _मॉड्, balt_, _voas,
   {{0x63bd0867,0x394050f8,0x61230074,0x6d5602ec}},	//   rusn, enis_, _mõle, _ekya,
   {{0x63bd0057,0x3f8205a3,0xf09f00ff,0x3940464d}},	//   susn, _auku_, _hoài_, fnis_,
   {{0x3f82059c,0x365b8039,0x0e5b8039,0x63600019}},	//   _buku_, _מכונ, _מדוב, lönl,
   {{0xb4dd00cf,0xb90903bb,0x3f823f3f,0xdb1d1d31}},	// [57b0] ड़ी_, _यस_, _cuku_, ttsä,
   {{0x2007003b,0x6d5d5e7f,0x26de9aae,0xc43c0039}},	//   ćni_, llsa, neto_, _מתחי,
   {{0xdb1d00f2,0x394002af,0xf09f00ff,0xd5bb06d2}},	//   rtsä, bnis_, _loài_, яса_,
   {{0x6aa1de80,0xdb06026f,0x26ded46a,0xdb1d0338}},	//   _self, vské, heto_, stsä,
   {{0x81d580c8,0x26de9c3d,0x490486ae,0xdb1d0192}},	//   িয়া_, keto_, वानो_, ptsä,
   {{0x26dede81,0x3ce98353,0xdb06016b,0x7bcba875}},	//   jeto_, žav_, tské, rtgu,
   {{0x3ea58006,0x6aa195f8,0x2d8500e7,0x7bcb87f1}},	//   valt_, _velf, _île_, stgu,
   {{0x68ed46f2,0xdb06026f,0x63ad0687,0x3ea581ec}},	//   ndad, rské, _ovan, walt_,
   {{0x3ea58bfa,0xa3ae809a,0x6aa1de82,0xf8bf0019}},	//   talt_, _किए_, _telf, _elég_,
   {{0x39401c56,0x6569de83,0x68ed0046,0x657b808e}},	//   znis_, _hheh, hdad, _hiuh,
   {{0x63ad0cf8,0x68fd0082,0xa3e98778,0xdc3401ac}},	//   _avan, _onsd, यिक_, rúča,
   {{0x3ea58006,0x2d83180c,0x38359715,0x78a290bc}},	//   salt_, _muje_, _инер, _geov,
   {{0x68ed59d4,0x26debcfc,0x3ea5de84,0x68eb8122}},	//   ddad, beto_, palt_, _iagd,
   {{0x68ed3d4c,0x26dede85,0x68eb9ac4,0x656f01c0}},	//   edad, ceto_, _hagd, amch,
   {{0x63ad270c,0x3f825e86,0xa2c495bc,0xfaa303c7}},	//   _evan, _suku_, _रास्, расо,
   {{0x3f820870,0x6d44059c,0x68ed0461,0xf1b280be}},	//   _puku_, _ujia, gdad, יסל_,
   {{0x68eb9ac4,0x3ea32e21,0x2fcdcc2b,0xf8bf07f1}},	// [57c0] _magd, _bejt_, nteg_, _amés_,
   {{0x394054a0,0x3f820390,0x667602e3,0x68eba7d1}},	//   snis_, _vuku_, ندار, _lagd,
   {{0x63ad225d,0x644984c3,0x2d8302a5,0x2d559f0a}},	//   _zvan, _axei, _cuje_, våer_,
   {{0x3f820d7f,0x68eb9066,0x290fde87,0x6b843e18}},	//   _tuku_, _nagd, _noga_, _kuig,
   {{0xe7bc8a49,0x99418035,0x0fbc8264,0x69ce5e88}},	//   _অন্য, kół_, _অন্ধ, ltbe,
   {{0x6569de89,0x60c45e8a,0x6b8401e4,0x26de802a}},	//   _eheh, lgim, _muig, xeto_,
   {{0xf1a38084,0x6b841e41,0xe5a30ff7,0xbcfb0036}},	//   арын, _luig, _виси, llée,
   {{0x60c42f6f,0x23b200dc,0x26dede8b,0xe9ff827d}},	//   ngim, _जिंद, weto_, _chằm_,
   {{0x68ebbcb2,0x26dede8c,0xceba80fc,0x2fc0474f}},	//   _dagd, teto_, _alƙa_, nuig_,
   {{0xa3e7a43f,0x63ad0bda,0x24800168,0xd5b881a9}},	//   _बनत_, _rvan, _agim_, trā_,
   {{0x63ad2a4f,0x557501cf,0xc9d58fd3,0x68ed0438}},	//   _svan, лгот, _مملک, ydad,
   {{0xb4dd00cf,0x69da81bf,0x6b841412,0x43950d45}},	//   ड़े_, _ipte, _buig, ламс,
   {{0x26de82e7,0xe72f8077,0x02c98074,0xaac983b6}},	//   peto_, صصی_, _रामभ, _रामक,
   {{0x2d871be6,0x6b840229,0x59c6aa2b,0x68e0de8d}},	//   ínek_, _duig, रंपर, lemd,
   {{0x987e07d9,0xaad201d0,0x98c72218,0x98a90035}},	//   _açık_, द्धक, ксал, niać_,
   {{0x741508ca,0xbcfb3b79,0x60c45e8e,0x290f81df}},	//   _موبا, rmés, ggim, _xoga_,
   {{0x68ed25a7,0x691c80e7,0xadea897d,0x2fc03bb0}},	// [57d0] rdad, _réel, टिकन_, guig_,
   {{0xa2c4a9b7,0x63a9003e,0x6569c941,0x68ed5e8f}},	//   _राष्, šens, _sheh, sdad,
   {{0x394685a4,0x6b8401ed,0x3cff8072,0x69ce090d}},	//   _ojos_, _zuig, ळाले_, ctbe,
   {{0x99f60051,0x2d590036,0x2fc05e90,0xa3d70072}},	//   _עזרה_, mées_, buig_, _सहा_,
   {{0xd0069168,0x63a0831d,0x2d5900e7,0x7bcf0980}},	//   _ال_, _cwmn, lées_, ntcu,
   {{0xe1f00065,0x569421d2,0x68eb813c,0x8c1c007c}},	//   _اسی_, _варт, _sagd, וודי,
   {{0x2d5902be,0x68eb97ef,0x1cbb80f7,0x38668176}},	//   nées_, _pagd, _يارب_, _azor_,
   {{0x00e58a7c,0xb4dd06a7,0x89d688ca,0x6b820037}},	//   ужин, ड़ो_, اوير_, _èogg,
   {{0x7ff5880b,0x7bcd01c0,0x6ec703db,0xa3e782f1}},	//   اسبا, _nqau, ालपु, _बनि_,
   {{0x3cff81c0,0x6b840014,0x38668122,0x8e09af75}},	//   _hnuv_, _ruig, _dzor_, енов_,
   {{0x290f8025,0xdca608cc,0x64a62549,0x68ebde91}},	//   _toga_, лани, лана, _tagd,
   {{0xa3e780cf,0x2f160125,0x6b840722,0xdcfc80eb}},	//   _बना_, _hægt_, _puig, _kurā,
   {{0xf7f4819f,0xdcf900eb,0x9f405e92,0xdb0407b6}},	//   _پسند, _atvē, rviú_, _aviá,
   {{0x69ce1722,0x78a982f1,0x79850deb,0x6fb29df9}},	//   ttbe, laev, _buhw, _اموا,
   {{0x321e026f,0x2d5900e7,0xc33281c6,0x395f832a}},	//   áty_, gées_, מוך_, olus_,
   {{0x69ce2e1d,0x6b840c41,0x2fc05e93,0x46cf9664}},	//   rtbe, _tuig, tuig_, त्रह,
   {{0x60c45e94,0x69ce4255,0x321e026f,0xe3b20019}},	// [57e0] rgim, stbe, šty_, _ارب_,
   {{0x26c580ee,0x613e81a9,0x693a81b9,0x7536016b}},	//   nglo_, rīli, nċer, _hmyz,
   {{0x629c26d5,0x777c04c3,0x7524005c,0x2d590036}},	//   mbro, _virx, _kliz, cées_,
   {{0xe45f00f2,0x628197cf,0x291e01a9,0xab5b0192}},	//   mför_, _aglo, ītas_, stüt,
   {{0xbd2d0158,0x628f8087,0x6d42de95,0x98a90035}},	//   וואָ, _şcoa, rnoa, wiać_,
   {{0xbda60277,0xab5b02d0,0x7cfb062c,0x395f86ae}},	//   _محرو, ltür, _kärä, elus_,
   {{0xe45f00f2,0xe6079a37,0xdce2825b,0x26d80041}},	//   nför_, _اش_, jmoć, _ibro_,
   {{0x391495d1,0xdce280d2,0xf38a826b,0x60f88081}},	//   рмир, dmoć, _aṣe_, тния_,
   {{0xed358196,0xa3ae8540,0x68e0de96,0x629c3db4}},	//   _тэрэ, _किट_, remd, kbro,
   {{0x473494b7,0x68e0b6bd,0x7524348e,0x3866816b}},	//   рнос, semd, _aliz, _vzor_,
   {{0xd6d78e11,0x0f5704de,0x629c08dc,0x7bc2de97}},	//   уты_, ריים_, dbro, luou,
   {{0xd9fe0076,0x6281805c,0x395f8cf8,0x9e770039}},	//   _उपजत_, _zglo, clus_, טגיה_,
   {{0x38668668,0xbcfb0511,0x658881d0,0x26d85913}},	//   _uzor_, eléc, _těho, _obro_,
   {{0x75245e98,0x6aaaaeae,0x2d5900e7,0xa01b0106}},	//   _eliz, naff, tées_, _oför,
   {{0xa3ab823c,0x78a60292,0x349515a4,0xdd9081a8}},	//   _कौन_, _bekv, _кайр, _بوب_,
   {{0x6aaa9d77,0x316006c0,0x2d5900e7,0x5184002e}},	//   haff, gliz_, rées_, сура,
   {{0x473544ab,0x2d5902be,0x6aaaaa33,0x656d0f1d}},	// [57f0] анас, sées_, kaff, _ihah,
   {{0x291e00f1,0xbcfb01df,0x2d590036,0x38bb046d}},	//   ëtar_, bléc, pées_, _bàrà_,
   {{0x395fde99,0x3f868118,0x61f700b9,0x656d0326}},	//   ylus_, _luou_, _urxl, _khah,
   {{0x661a8748,0x057482e3,0xb87b0118,0x26d85e9a}},	//   iytk, ماند, _saíu, _ebro_,
   {{0xd7e680f7,0x6aaa8041,0x63af01a8,0xab5b011c}},	//   _بك_, faff, nscn, rrüf,
   {{0x645a0087,0x212900dd,0x41b59e9d,0x6aaaadae}},	//   ştig, lhah_, асит, gaff,
   {{0xaa498098,0x2f16455b,0xdb0b8018,0x395f8074}},	//   ъпка_, _vægt_, nsgé, tlus_,
   {{0xa2d58540,0x63bd2bea,0xe8f9a3d7,0xc27c03de}},	//   _मॉर्, krsn, тли_, ערהי,
   {{0x68ef117d,0xa2cd81cb,0x69158118,0x2eee8176}},	//   _macd, _साप्, _sáes, _baff_,
   {{0xe80d05e8,0x62818b67,0x21291abf,0x2eee80e5}},	//   _सपना_, _uglo, hhah_, _caff_,
   {{0x52848013,0x60b5819f,0x75240247,0xed4628df}},	//   _المك, _نمائ, _pliz, иноп,
   {{0x7ae3de9b,0x69c3831d,0x69678591,0x31600101}},	//   lent, mune, _صداق, xliz_,
   {{0xa09a8158,0x656d0303,0x21290077,0x289a80be}},	//   _סיסט, _dhah, dhah_, _סיסא,
   {{0x661a8f4c,0xa3c70105,0x290d8042,0xfaa317f9}},	//   bytk, _उमर_, ljea_, жаро,
   {{0x63bd0014,0xa2cd8a0d,0x6d498216,0xbb431444}},	//   arsn, _सान्, _ojea, церк,
   {{0xe45f04b8,0x7ae3da96,0x629c2310,0x6d5b8282}},	//   rför_, hent, sbro, _nkua,

   {{0x7ae3c288,0x3ea7d2a4,0x69c3de9c,0xb8ee0c2d}},	// [5800] kent, _kent_, hune, _रा_,
   {{0x2d87de9d,0x6d5bbc5a,0x69c3a2b3,0x656d00dd}},	//   _kune_, _akua, kune, _zhah,
   {{0x72080117,0x2d878039,0x6d4701f4,0x21294b38}},	//   _صفحہ_, _june_, čkav, bhah_,
   {{0x63a43623,0x69c39c10,0x63648722,0x47dc80ab}},	//   _kwin, dune, tòno, বিতী,
   {{0x7ae3c798,0x68e45e9e,0x290200b4,0xb92a801c}},	//   fent, meid, _inka_, _thuế_,
   {{0x7ae389af,0x68e41d7a,0x8c1b0051,0x63a41b74}},	//   gent, leid, כוני, _mwin,
   {{0x44209cbd,0x1bed159a,0x69c3de9f,0x19a78071}},	//   ši_, _चैनल_, gune, атып_,
   {{0xa3d70e18,0x6d461d14,0x68e43f5d,0x2eee8aee}},	//   _सहल_, jnka, neid, _saff_,
   {{0x8f46948d,0x673a8168,0x3ea7d47c,0x2fd20338}},	//   иход, titj, _bent_, ntyg_,
   {{0x68e40c72,0x656d5ea0,0x63bd003a,0x2d87802e}},	//   heid, _shah, vrsn, _bune_,
   {{0x69c3dea1,0x673a9001,0x6d9304b7,0x68e45ea2}},	//   cune, ritj, _għad, keid,
   {{0x673adea3,0x63a40f8e,0x6aa88428,0xb87b07b6}},	//   sitj, _bwin, _hedf, _maír,
   {{0x3ea7b86a,0x69de0c55,0xa2cd8aed,0xd79480f7}},	//   _fent_, _appe, _साम्, _التخ,
   {{0x3ea7dea4,0x63a406a8,0x3cfd86a7,0x80d2801b}},	//   _gent_, _dwin, _रोने_, भ्रे,
   {{0x68e400f7,0x2729801c,0x6aa88f06,0x63a41aa5}},	//   feid, _súng_, _medf, _ewin,
   {{0x644d01e9,0xdb1d05b9,0xd3a704cf,0xa3e78074}},	//   _txai, musí, _кроп, _बनल_,
   {{0x7ae39fdb,0xc05b0cde,0x64480085,0x69c38102}},	// [5810] yent, тів_, şdir, zune,
   {{0x7ae3ae24,0x6d5bdea5,0x30778039,0x21290c9e}},	//   xent, _skua, שתמש_, shah_,
   {{0xb87b5ea6,0x7ae3dea7,0x68e422d4,0xa3c9835a}},	//   _país, vent, beid, लून_,
   {{0x7ae3c74d,0x21200052,0x6705063a,0x753d0019}},	//   went, ckih_, राहक_, nisz,
   {{0x7ae3dea8,0xc6510019,0x2d9a0037,0xdd020140}},	//   tent, _کہاک, appe_, šući,
   {{0x69c39673,0x97250fd3,0x8ccc8ad5,0x2ca901c6}},	//   tune, _افسو, _हाथो, _lead_,
   {{0xd2b801c6,0x6d46538d,0x3495a244,0xdbdd04e8}},	//   בלות_, ynka, _габр, dšív,
   {{0x69c39cf2,0x3ea7dea9,0x78ad3755,0xe0df03ec}},	//   rune, _sent_, naav, _akòz_,
   {{0x69c38cc7,0x6d59c4f0,0x2d878041,0x27e90915}},	//   sune, mowa, _sune_, nwan_,
   {{0x2d87deaa,0x69c38049,0x291fa91f,0x6d59b09c}},	//   _pune_, pune, skua_, lowa,
   {{0x99858307,0x2ca91c33,0x27e92992,0x79970069}},	//   _الصو, _bead_, hwan_, _ntxw,
   {{0x753d0065,0x6d598063,0xeb9a5eab,0x2ca9125b}},	//   gisz, nowa, лим_, _cead_,
   {{0x6b8980c8,0x68e40029,0xdcf580eb,0xef0ecc66}},	//   _jueg, veid, _atzī, _ем_,
   {{0x60c9d95b,0x6e9580f7,0x27e95d36,0x6b8181b9}},	//   lgem, _الغا, dwan_, _jilg,
   {{0x6d598063,0x6b8980ab,0x21200db7,0x68e42c6a}},	//   kowa, _lueg, tkih_, teid,
   {{0x6ed3a38c,0x628f8087,0x27e900dd,0x6d59b937}},	//   ब्रु, _şcol, fwan_, jowa,
   {{0x6d598063,0xa3c9800f,0x636486c0,0xb87b09b2}},	// [5820] dowa, लूम_, wònm, _saír,
   {{0xd9f785b3,0x7bc652f8,0xbeaa003d,0x6b8198d5}},	//   ंटात_, muku, اهان_, _nilg,
   {{0x7bc65eac,0x248d026f,0x6d598f90,0x7d0404b7}},	//   luku, žeme_, fowa, _knis,
   {{0x6d59dead,0xab5b0182,0x2ee5deae,0x395d8282}},	//   gowa, crüb, helf_, _nkws_,
   {{0x6b818179,0x60c9c613,0x7d045eaf,0x23d6896b}},	//   _bilg, dgem, _mnis, сцер,
   {{0x81e180c8,0xff47826a,0xf1a69ddf,0x2d5c8144}},	//   দিন_, _رخ_, брин, tíes_,
   {{0x6d59ac0b,0x248980d2,0x7d040091,0x7bc640a6}},	//   bowa, žama_, _onis, huku,
   {{0x3eaa0613,0x7bc62d80,0x6b898020,0xf8ba0aed}},	//   _hebt_, kuku, _fueg, ेलिय,
   {{0x2ca93910,0x3eacdeb0,0x0c26a37e,0x7bc65eb1}},	//   _read_, tadt_, _уман, juku,
   {{0x75228065,0x2ca919c7,0x2d8a005d,0x6b81deb2}},	//   lkoz, _sead_, _kube_, _gilg,
   {{0xa2cd81ab,0x9f4006a5,0x2f5b03c8,0x27e900ee}},	//   _सात्, lvió_, רדינ, zwan_,
   {{0xf8bf01df,0x75229f4b,0x7bc6273f,0x6ed8001b}},	//   _alén_, nkoz, fuku, न्तु,
   {{0x7bc61a08,0x673e00c3,0x6d438866,0x753d0e06}},	//   guku, kipj, énai, risz,
   {{0x2fc05eb3,0x6d59deb4,0x7d045eb5,0xab5b0192}},	//   drig_, zowa, _enis, drüc,
   {{0x2d8a05e4,0x78ad37a8,0x6d599090,0x27e90326}},	//   _nube_, taav, yowa, wwan_,
   {{0x7bc61ea2,0x6d472944,0x61fa2320,0x7d0412f1}},	//   buku, čkas, ætla, _gnis,
   {{0x506734ba,0x78ad0364,0xc867038b,0x636d87e0}},	// [5830] ства, raav, стви, núnc,
   {{0x78ad2e09,0x27e91bb7,0x6b8981ca,0x2d8a4f4d}},	//   saav, rwan_, _rueg, _bube_,
   {{0x6d59b239,0x6ed8001b,0xe7ea809a,0x6b898388}},	//   towa, न्धु, _जैसा_, _sueg,
   {{0x2ee58a0f,0x7ae75eb6,0xab5b0192,0x2d8a5360}},	//   zelf_, lejt, brüc, _dube_,
   {{0x6d598063,0x69d500ad,0x39495eb7,0x2d9802be}},	//   rowa, ltze, mnas_, _etre_,
   {{0x6d598063,0xa3aa923a,0x612a026f,0x6ed8123a}},	//   sowa, _खबर_, _výle, न्दु,
   {{0x69d500ad,0x80ac00c8,0x5ea780ab,0x7bc606a0}},	//   ntze, _ছাত্, _খালে, zuku,
   {{0x394938d2,0x3f8b007d,0x7bc60d7a,0x69d50102}},	//   nnas_, _kucu_, yuku, itze,
   {{0x60c9ad9c,0x6b81deb8,0x69c7136f,0x7ae7016b}},	//   rgem, _tilg, huje, kejt,
   {{0x60c9b3fc,0x3cfd80d4,0x3cdc001b,0x2caf9235}},	//   sgem, _रोते_, ग्ने_, lagd_,
   {{0xf1dda38c,0x3f8b5eb9,0x39495eba,0x69c70968}},	//   _महिन, _lucu_, knas_, juje,
   {{0xed5a023f,0x7bc65ebb,0x7d162b95,0x63a48087}},	//   ром_, tuku, _qoys, ţine,
   {{0xdbf406b7,0xbcfb5ebc,0xc178936d,0x75298c53}},	//   इटेड_, plén, _اصلا_, _mlez,
   {{0x59dd8935,0x41dd800c,0xf1dd800c,0xa3ab8eed}},	//   _महार, _महास, _महान, कीय_,
   {{0x69c7179d,0x6372006a,0x753b8365,0x2bb602f1}},	//   guje, hæng, _omuz, _अटका,
   {{0x3f8b00b9,0x752981bc,0x69820133,0x09be8264}},	//   _bucu_, _nlez, _ọgbụ, _আহমা,
   {{0x78ab8065,0x3f8b09ca,0x2d8a0876,0x2fc009e5}},	// [5840] _megv, _cucu_, _sube_, urig_,
   {{0x69c7219f,0xe6b781c4,0x39495a4a,0x2fc04fa2}},	//   buje, _आयोज, anas_, rrig_,
   {{0x75228065,0xb87b026b,0x39495ebd,0x7529810c}},	//   tkoz, _abíd, bnas_, _blez,
   {{0x6364823e,0xed5a8198,0xdca3b1f0,0xab5b0192}},	//   mòni, шое_, даци, prüc,
   {{0x6364809f,0xfbcf8fc5,0xa2948a4c,0x0b938481}},	//   lòni, نتو_, палі, وجود,
   {{0x7529debe,0x9f400020,0x39403241,0x61fe0b80}},	//   _elez, rvió_, liis_, _krpl,
   {{0xcebf01d0,0x6364823e,0x9f400144,0xdd921190}},	//   _úřad_, nòni, svió_, _آور_,
   {{0x39404000,0x7529debf,0x315781a8,0x48149a19}},	//   niis_, _glez, يجية_, змис,
   {{0x8c4381a1,0xc17304de,0xfbd1801b,0x78ab81a9}},	//   _жете, וחה_, _समयम, _degv,
   {{0xa3df823c,0x6d4d01ed,0xdb061743,0x39495ec0}},	//   _तहत_, _sjaa, nskä, znas_,
   {{0x7ae71cf3,0x7bc2dec1,0x2d850019,0x61230074}},	//   vejt, lrou, _élet_, _sõlm,
   {{0xe4e7035f,0x69c70ac1,0xc0c782de,0x2480936f}},	//   ціон, vuje, _душе_, žimu_,
   {{0x39498289,0xdb060106,0x394001c7,0x7ae701d0}},	//   čast_, kskä, diis_, tejt,
   {{0x4f57806b,0x7c2f87d9,0x6364823e,0x98a38196}},	//   _وجود_, _ücre, fòni, ėją_,
   {{0xd13b0698,0x7ae75ec2,0x3a25007b,0x3f8b5ec3}},	//   аха_, rejt, álp_, _sucu_,
   {{0x69d50379,0x2d9edec4,0xdc2b0077,0x2d848074}},	//   rtze, mpte_, _نسخه_, _nime_,
   {{0x394938fa,0x7ae700f1,0x76b90071,0x69c758d6}},	// [5850] rnas_, pejt, йлар_, suje,
   {{0x6d5d5ec5,0x2d8482be,0x26cccf24,0x3f8b017f}},	//   losa, _aime_, ngdo_, _vucu_,
   {{0xa2c48894,0x7529dec6,0x272980e1,0x8c3da75e}},	//   _राज्, _plez, _júna_, _ieşi,
   {{0x2d848699,0x5c7595ac,0x6f18811a,0x39405ec7}},	//   _cime_, плет, _lovc, ciis_,
   {{0x03a58790,0x7bc290b6,0xb11381bc,0x3cfc03c8}},	//   чило, grou, _hụgh, ילאנ,
   {{0x6f18803a,0x6b8d3ff5,0x60cd5ec8,0xdefb01e2}},	//   _novc, _muag, lgam, _тым_,
   {{0x6d5d018c,0x291936d9,0x2729807b,0x6b8d0122}},	//   kosa, _kosa_, _núna_, _luag,
   {{0x60cd308f,0x753b9d61,0x63720366,0x3cf50035}},	//   ngam, _umuz, mæne, इयों_,
   {{0x853d01e2,0xd90c8077,0x6d5d37c0,0x2572026f}},	//   ipėd, شیو_, dosa, nále_,
   {{0x248932d1,0xc61480ab,0x6b9bdec9,0x636d808b}},	//   _agam_, াননা_, _itug, búna,
   {{0xf8bf00a9,0xf9f9815b,0x98cb0035,0x63a982c4}},	//   _além_, _دفاع_, िलाए, _hwen,
   {{0x63a9cece,0x2919062f,0xbcfb5eca,0x60cd0168}},	//   _kwen, _nosa_, blém, jgam,
   {{0x63a98205,0x8c3d8457,0x0c233b9e,0x68e9ae46}},	//   _jwen, _beşi, емян, meed,
   {{0x63a9be1f,0xe2972118,0x68e98079,0x69c389ff}},	//   _mwen, зар_, leed, orne,
   {{0xc6928158,0x394009f1,0x63a98c6a,0x6d4b9400}},	//   _טאג_, tiis_, _lwen, knga,
   {{0x3991decb,0x291914e7,0x60cd1066,0x55ba8051}},	//   _más_, _cosa_, ggam, _המקו,
   {{0x8ca20063,0x2919059c,0x39405ecc,0x68f6031d}},	// [5860] _क्यो, _dosa_, riis_, rdyd,
   {{0x68e98079,0x7bc2decd,0x63648722,0x6d4b9272}},	//   heed, vrou, pòni, enga,
   {{0x39918a56,0xceb28039,0x29192509,0x442201b0}},	//   _nás_, גיב_, _fosa_, lyk_,
   {{0x7bc29a93,0x63a98555,0x6b8d01c0,0x6372006a}},	//   trou, _bwen, _yuag, sænd,
   {{0x68e9d735,0x8c3d8214,0x63a9810c,0x44220196}},	//   deed, _yeşi, _cwen, nyk_,
   {{0x6d4bcac5,0xf1a6b314,0x2d9edece,0x6b9b80f7}},	//   anga, прин, ypte_, _dtug,
   {{0xdca69860,0x2d84804c,0xa2cd8ebf,0x64a69273}},	//   _нави, _time_, _सार्, _нава,
   {{0x44225e18,0x079884ae,0x79860133,0x68e981b4}},	//   kyk_, овић_, _jikw, geed,
   {{0x6d5d0284,0x63a9cd09,0xb8d48105,0x69c3decf}},	//   vosa, _gwen, _जज_, arne,
   {{0x539b8bea,0x798607d8,0x6d4298cb,0xb4bc86b7}},	//   _לימו, _likw, lioa, _आयु_,
   {{0x6d5d13ec,0x3991ba6f,0x7c2286c0,0x60cd02d0}},	//   tosa, _gás_, lyor, ygam,
   {{0xab5b01ec,0x6b8d01c0,0x6d429b1f,0x7aeaaad3}},	//   grün, _puag, nioa, left,
   {{0x7c22c219,0x645a0087,0x8c3d8214,0xf76f803d}},	//   nyor, ştin, _peşi, ضای_,
   {{0x6d5d12a5,0x6b8d01c0,0x79860362,0xb113819d}},	//   sosa, _vuag, _aikw, _pụgh,
   {{0xe9ff8104,0x29192f10,0x69d88422,0xd6db81c6}},	//   _phẩm_, _posa_, ntve, _החול,
   {{0x613101a3,0x79865ed0,0x3eae9cb6,0x7aea878b}},	//   _målg, _cikw, _heft_, heft,
   {{0x291901df,0x79865ed1,0x20540162,0x752d5ed2}},	// [5870] _vosa_, _dikw, ектя, _ilaz,
   {{0x9f4dcdf9,0x69ca8ace,0xc987002e,0xb1138133}},	//   rveç_, kufe, _нуми, _tụgh,
   {{0x27ed8247,0x63a9ded3,0xe9ff801c,0x6b9bded4}},	//   zwen_, _swen, _thẩm_, _stug,
   {{0xe8eb0117,0x3eae8039,0x39918dbf,0x6d428c7b}},	//   _اردو_, _left_, _rás_, gioa,
   {{0x6d932f1e,0x68e98264,0x29d716dc,0xdb062417}},	//   _għan, veed, lça_, rrkö,
   {{0x3eae8085,0x69d8ded5,0x7aea806a,0x3991816b}},	//   _neft_, ftve, geft, _pás_,
   {{0x29d7231e,0x44221bae,0xdce436c5,0x68e9b7d3}},	//   nça_, zyk_, _uhić, teed,
   {{0x39918775,0x6d42802e,0x212b809a,0xc2e90264}},	//   _vás_, cioa, óch_, খাটি_,
   {{0x27ed8a0f,0x68e990b0,0x69dc816d,0xf1b804b7}},	//   uwen_, reed, _ären, ġġi_,
   {{0x27ed8a12,0x7d1b8051,0x752d5ed6,0x29d70214}},	//   rwen_, _hous, _alaz, kça_,
   {{0x752d0a0c,0x7bcbb722,0xc3328039,0x7d1bded7}},	//   _blaz, lugu, _שוב_, _kous,
   {{0xc3292afe,0x7d1bb2bb,0x3f9f8198,0x44225ed8}},	//   _דו_, _jous, ppuu_, tyk_,
   {{0x394dded9,0x7bcb977c,0xd90f8019,0x7d1b99c3}},	//   mnes_, nugu, _لیں_, _mous,
   {{0x7d1bdeda,0x6d4280ad,0x44225edb,0x395f8551}},	//   _lous, zioa, ryk_, lous_,
   {{0x394d9220,0xaca3819d,0x7bcb9f17,0x44222133}},	//   ones_, _anọn, hugu, syk_,
   {{0x752d0971,0x394ddedc,0x7d1b8009,0x3f8f8079}},	//   _glaz, nnes_, _nous, _kugu_,
   {{0xef1a0ff0,0xa06718a0,0x394ddedd,0xdb0b8019}},	// [5880] ома_, дата_, ines_, zsgá,
   {{0x7bcbdede,0xe7e5809a,0x3f8f80fc,0xe6a80d86}},	//   dugu, _कहना_, _mugu_, गरेज,
   {{0x2d9c020f,0x7d1bcfac,0x3f878006,0x3f8f8ccf}},	//   ëve_, _bous, _minu_, _lugu_,
   {{0x7d1ba4c4,0x53d2058c,0x395f809f,0xdce280fe}},	//   _cous, _तमाश, jous_, ploč,
   {{0x6d428c76,0x7bcbad80,0x7d1bdedf,0x394da1c5}},	//   rioa, gugu, _dous, dnes_,
   {{0x394d9726,0x3f87877f,0x7d09a7e2,0x6d42dee0}},	//   enes_, _ninu_, _enes, sioa,
   {{0x7aeadee1,0x8e830bba,0x7c228ad4,0x7bcb80eb}},	//   reft, _агре, syor, augu,
   {{0x69d8a39e,0x394d8eb7,0x2d8e9471,0x69ca82af}},	//   rtve, gnes_, _rufe_, rufe,
   {{0x6d40aa4d,0x6f1c330c,0x3f8f80fe,0x69ca8db1}},	//   _imma, _korc, _cugu_, sufe,
   {{0x752d0052,0x3f8f811e,0x394d9b01,0x7d09807a}},	//   _slaz, _dugu_, anes_, _znes,
   {{0x6f1c0cf8,0xd6d78fe6,0x395f907c,0x645a0087}},	//   _morc, фты_, bous_, ştil,
   {{0x2ca6838e,0x394d817f,0x3f87807b,0xa00a80f7}},	//   nbod_, cnes_, _einu_, _وقال_,
   {{0x248d012b,0x68e29a90,0x7b67245b,0x27328028}},	//   žemo_, _ibod, дтве, _nâng_,
   {{0x61310370,0x6d9301cd,0xf0478416,0x2ef80118}},	//   _måle, _bħal, _تعمی, _narf_,
   {{0x6d40dee2,0x7af70201,0x20020b8a,0x6b88dee3}},	//   _omma, _vaxt, _arki_, _midg,
   {{0x29d726e1,0x752d003a,0x6376dee4,0x3944de16}},	//   rça_, _ulaz, lând, nims_,
   {{0x518422cb,0x6f1c0965,0xb8f715bc,0xc9840012}},	// [5890] тура, _borc, _सा_, тури,
   {{0x394dd89a,0x6f1c5ee5,0xce6b0381,0x6d40d359}},	//   znes_, _corc, оред_, _amma,
   {{0x7d1bace0,0x6d932f1e,0x68e2882e,0x6f1c032f}},	//   _pous, _għal, _obod, _dorc,
   {{0x63ad40a6,0x629a816d,0x20020267,0x7bcba566}},	//   _kwan, _afto, _frki_, tugu,
   {{0x68ed0ece,0xe299a657,0x290b002e,0x5f11952c}},	//   mead, пал_, _inca_, ताम्_,
   {{0x63ad114c,0x68ed008c,0x26e380c8,0x68e2ab5f}},	//   _mwan, lead, _কোনো_, _abod,
   {{0x7d1bcfac,0xe0d18013,0x394ddee6,0x4429c4a9}},	//   _tous, هزة_, tnes_, ša_,
   {{0x21295ee7,0x3f879ea7,0x68ed14f2,0x394d82be}},	//   nkah_, _sinu_, nead, unes_,
   {{0x394d805f,0x8b678250,0xd7e68198,0x212900b9}},	//   rnes_, _قائم, емые_, ikah_,
   {{0x27e404b8,0x68ed261b,0x395fdee8,0x394dcf74}},	//   _ämne_, head, sous_, snes_,
   {{0x63ad028d,0x21290b20,0x3944bd80,0x395fdee9}},	//   _awan, kkah_, bims_, pous_,
   {{0x63ad0b15,0x3f8fdeea,0x68ed5eeb,0x67b9830f}},	//   _bwan, _tugu_, jead, _فاتح_,
   {{0x78279c12,0x69c1026f,0x3f87826b,0x236580b9}},	//   _تعال, álen, _tinu_, _kklj_,
   {{0x27328012,0x63ad242f,0x643a80be,0xf8bf04be}},	//   _când_, _dwan, לערנ, _adé_,
   {{0x63ad479e,0xc7b98019,0x21290859,0x291d84b9}},	//   _ewan, lső_, fkah_, _kowa_,
   {{0x68fb9922,0x6f1c1390,0x68ed0ce2,0x6376802e}},	//   ndud, _sorc, gead, mâne,
   {{0x63ad5eec,0x291d866f,0x68f9d462,0x63bb838a}},	// [58a0] _gwan, _mowa_, _mawd, _nvun,
   {{0x248dbd1a,0x2732b7ad,0x399508bd,0x2d9116eb}},	//   _agem_, _vâng_, _fås_, _buze_,
   {{0xfad7093f,0x63ad0d35,0xaac983dd,0x02c983b7}},	//   _אויך_, _zwan, _राजक, _राजभ,
   {{0x8fa6130f,0x68ed0635,0x69dc1bc2,0x6d9304b7}},	//   _паме, cead, mtre, _għam,
   {{0x69dc2c42,0x6f1c5eed,0x69ce071f,0xead4abca}},	//   ltre, _torc, lube, воль,
   {{0x6d4624ec,0xbcfb0174,0x61310163,0x45160264}},	//   hika, rléi, _våle, াসিক_,
   {{0x69dc5eee,0x6d4634e8,0x3944809f,0x2d910669}},	//   ntre, kika, tims_, _guze_,
   {{0x6d46178f,0x6d40deef,0x63a2b4d7,0x3f8a5ef0}},	//   jika, _umma, ppon, _hibu_,
   {{0x6d46296d,0x69ce0234,0x69c70654,0x3944def1}},	//   dika, hube, zrje, rims_,
   {{0x63ad4685,0xb34580a9,0x442682e7,0x3f8a0010}},	//   _rwan, riçã, myo_, _jibu_,
   {{0x4426aad9,0xb3458073,0xa0a698a0,0x63ad55f2}},	//   lyo_, siçã, _заед, _swan,
   {{0x80e00a49,0x6d463afe,0x7afadef2,0x44268d10}},	//   _পোস্, gika, _hatt, oyo_,
   {{0x4426c9af,0x48fb0b04,0xb87b0091,0x27e68039}},	//   nyo_, _लोगो_, _abín, _upon_,
   {{0x25724533,0x7afa822b,0xa3e88e33,0x69c7007a}},	//   rála_, _jatt, _बहन_, trje,
   {{0x68ed4948,0xdb0405e4,0x4ac980d4,0x31c41354}},	//   tead, _avió, _राघव, лств,
   {{0x442682ec,0x69c700f1,0x212909ca,0x7bda002e}},	//   kyo_, rrje, ukah_, ătur,
   {{0x2129059c,0x2d91005c,0x63ad3c75,0xa3e50006}},	// [58b0] rkah_, _suze_, _uwan, _नहि_,
   {{0x7afa8bfa,0x68ed5ef3,0x4426def4,0x21291ad4}},	//   _natt, sead, dyo_, skah_,
   {{0xceb38158,0x69ce08f1,0x69dc00f7,0x212914e4}},	//   ריע_, cube, ctre, pkah_,
   {{0xa567803d,0xa3e506a7,0x888300d7,0x7bdd06ae}},	//   ردان, _नहा_, _میزن, otsu,
   {{0x7bdd469a,0x27ff01df,0x4426def5,0x7afa9e68}},	//   ntsu, _éun_, gyo_, _batt,
   {{0x6d4621e0,0xbbd186ce,0x7bdd5ef6,0x68f9def7}},	//   zika, _समीक, itsu, _sawd,
   {{0x44268de2,0x62880279,0x7afadef8,0xe9ff80ff}},	//   ayo_, ždov, _datt, _thậm_,
   {{0x4426a1ea,0x25be007b,0x6009968a,0x63bbaca0}},	//   byo_, _ætla_, дним_, _tvun,
   {{0x7afadef9,0x4426ca82,0x69ce813c,0x43958098}},	//   _fatt, cyo_, _åben, _разс,
   {{0x7d0d3874,0x7afac02f,0x6d46020d,0xd2f78065}},	//   _anas, _gatt, wika, _سکتا_,
   {{0x64a60a4c,0xed5a2659,0x6ea78065,0x614789c4}},	//   кана, дон_, ونکہ_, _cèlè,
   {{0x2cb20201,0xd24e803d,0x63768187,0xceba80fc}},	//   _qeyd_, _بچه_, râne, _roƙe_,
   {{0x317f8214,0x7afade7e,0x78a9b30c,0x61358a09}},	//   mmuz_, _yatt, mbev, _pálf,
   {{0x03a30364,0x69dc5efa,0x8ca21199,0x316dad5d}},	//   риро, ttre, _क्रो, llez_,
   {{0x3f8a5efb,0x80e000ab,0xe2970972,0xf2d283de}},	//   _ribu_, _পোষ্, тас_, יעם_,
   {{0x69dc3807,0x78a983b2,0x3f8a37cf,0xdb0f00f7}},	//   rtre, nbev, _sibu_, rscá,
   {{0xf8b28158,0x7bcf4732,0x54a501a8,0x442681b4}},	// [58c0] ישן_, cucu, _صحيف, xyo_,
   {{0x442680f6,0x61230074,0x9bb70039,0x69dc1db4}},	//   vyo_, _sõlt, _שהיה_, ptre,
   {{0x7afa92a5,0xb6068333,0x65628bb1,0x7bdb8580}},	//   _ratt, _ibáñ, tooh, _aquu,
   {{0x442681d3,0x7afa913f,0xb4ccb64b,0x2fc95efc}},	//   tyo_, _satt, लले_, brag_,
   {{0xeb978a7c,0xd843016b,0x7afa8ca9,0x30752503}},	//   вич_, ročí_, _patt, _бурс,
   {{0x4426defd,0x7afa822b,0x46a32597,0x6376841c}},	//   ryo_, _qatt, _варв, dânc,
   {{0x7afa84b8,0x442697ef,0x3cfd8074,0xf743197b}},	//   _vatt, syo_, _रोके_, _теро,
   {{0x7afadefe,0x4426820d,0x5ec700ab,0x63768187}},	//   _watt, pyo_, র্দে, fânc,
   {{0xe80505b3,0x798b831d,0x2bc9866b,0x63768187}},	//   रिया_, _digw, _रिया, gânc,
   {{0x61310186,0x7d0d1581,0xa2d70cf0,0x21ce8085}},	//   _måla, _snas, _बाध्, _məhz_,
   {{0x752081f6,0xb87b0032,0x7d0d008e,0x2d8c8061}},	//   _komz, _abíl, _pnas, _édes_,
   {{0xc4bf06bf,0x779289a7,0x64bf064a,0x255600eb}},	//   ्लेख, _پیدا, ्लेश, tāla_,
   {{0xd6d282e3,0xe9ff80ff,0xdb04016a,0x60c2b35d}},	//   _نقش_, _thảm_, _aviñ, _idom,
   {{0x7520deff,0x2d8792cc,0x7bdd1611,0x70cb000d}},	//   _lomz, ínez_, rtsu, िल्ल,
   {{0x442d003b,0x2736013c,0xa92300e1,0x7bdd5f00}},	//   še_, _mænd_, áľov, stsu,
   {{0x3998938d,0x2fc95f01,0x7520836a,0x7d0d004f}},	//   _més_, trag_, _nomz, _unas,
   {{0xaad2800f,0xdb0603c1,0x6aa25f02,0x60c28c53}},	// [58d0] _सांक, lský, _şofe, _mdom,
   {{0x6d440063,0x656f5f03,0xa2f5004a,0x2cb90326}},	//   _zmia, llch, _споч, lasd_,
   {{0xdb06003e,0x60c2df04,0x2baf0072,0x39988866}},	//   nský, _odom, जीरा, _nés_,
   {{0xf65381c6,0xdcfc8085,0x60c2996c,0x6135826b}},	//   בצע_, _vurğ, _ndom, _kále,
   {{0x798b81b9,0xfbdf041c,0xd103970c,0xbcfb2538}},	//   _rigw, ntê_, _शोषण_, llés,
   {{0x6135807b,0xab6481e2,0x6376841c,0xf9901e29}},	//   _mále, авіл, vânc, _دبی_,
   {{0xa9699541,0x21698c8e,0x6145df05,0x68fd0110}},	//   ника_, ники_, лека, _kasd,
   {{0x637683a7,0xdb06016b,0xe9ff80ff,0x6c858019}},	//   tânc, dský, _chạm_, _ملزم,
   {{0x6135826f,0x1c07009a,0x78a981eb,0x68fd114b}},	//   _nále, शिफल_, rbev, _masd,
   {{0x656f151e,0x39493afc,0x60c2d56d,0x78a9874d}},	//   elch, hias_, _edom, sbev,
   {{0x63bd3d9c,0x458612ea,0x0d8608b0,0x2006b2a3}},	//   essn, лгов, ллон, _eroi_,
   {{0xaadf8744,0xb87b0032,0x629c0326,0x6135826b}},	//   प्रक, _abím, wcro, _bále,
   {{0x66e593f7,0x290f8408,0xeb971bba,0x39490625}},	//   _бола, _inga_, лия_, dias_,
   {{0xcc3a80be,0xa3d50074,0x656f051e,0xdd8e810c}},	//   געשט, _हमर_, alch, _کوي_,
   {{0xa2db82a8,0xbcfb009f,0x3949106c,0x69d4016f}},	//   _नान्, glés, fias_, बंधी,
   {{0x39491520,0x68fd0118,0x81b58264,0x6d930609}},	//   gias_, _casd, _জমা_, _għai,
   {{0xb4d00076,0x27eb0326,0x7d7b03c8,0x2fdfa476}},	// [58e0] शली_, _cpcn_, _אנקו, ntug_,
   {{0x63a45f06,0x888310f8,0x6566029b,0x657bda01}},	//   _itin, служ, lokh, _ahuh,
   {{0x39495f07,0xf8bf02be,0x61359d9a,0x6b965f08}},	//   bias_, _clés_, _zále, _huyg,
   {{0x3949402b,0xa37b03a7,0xac97803d,0x68fd5ded}},	//   cias_, rtõe, هنما_, _gasd,
   {{0x77f28dbc,0x26f38076,0xa37b0073,0x7afe0eb9}},	//   _अनेक_, _असूर_, stõe, _kapt,
   {{0x81c900c8,0xf7460364,0x08fc00c8,0x6ed88540}},	//   োবর_, _сего, _একটু_, _माधु,
   {{0x27e03457,0x82970051,0xe9ff8028,0x41e680f7}},	//   ltin_, נדקס_, _phạm_, استف,
   {{0x29003a70,0xd01080f7,0xdb060e04,0x20068267}},	//   ndia_, قلب_, vský, _proi_,
   {{0x3d11835a,0x63a40135,0xfaa69bc1,0x473481a4}},	//   णारे_, _ntin, _базо, инис,
   {{0x138a80f7,0xdb06016b,0x4ad303eb,0x3998816a}},	//   _أخرى_, tský, _ताइव, _tés_,
   {{0x22938307,0x63a45f09,0x49ca8003,0xaa938829}},	//   _المس, _atin, _член_, _المث,
   {{0x39495f0a,0xdb062a5a,0x9f490125,0x27e02ad3}},	//   xias_, rský, hvað_, ktin_,
   {{0x39491e00,0x394684c3,0xbf9b03a7,0xa2db8a0d}},	//   vias_, _imos_, _prêm, _नाम्,
   {{0xa3c98076,0x39468282,0x6b960214,0x613581d0}},	//   लूट_, _hmos_, _duyg, _vále,
   {{0x2d9c00a9,0x63a40870,0x5fc70006,0x13d18b04}},	//   ível_, _etin, _लिहल, _सम्भ,
   {{0x27e05f0b,0x2900009f,0xddcb04b7,0xbcfb0061}},	//   ftin_, gdia_, ċiżj, rlés,
   {{0x39491313,0x7afe002e,0x3f8e85ee,0x3eba0493}},	// [58f0] rias_, _fapt, _kifu_, fapt_,
   {{0x39495f0c,0xaadc016f,0x63600061,0x3cfd99ee}},	//   sias_, _बायक, köny, _रोजे_,
   {{0x39492b72,0x68fd5f0d,0x3946ddaf,0x06cc00ab}},	//   pias_, _tasd, _omos_, র্ভি,
   {{0x67d510ef,0xc56b8060,0xe7e582f1,0x68e40174}},	//   _кому, رحال_, _कहला_, cfid,
   {{0x7afe07d9,0x78ad30fc,0x61fa82f9,0x6e950749}},	//   _yapt, mbav, _astl, _вигу,
   {{0xa3d60576,0x26c3008e,0x290f8122,0xeb969577}},	//   ांत_, _udjo_, _snga_, шиш_,
   {{0x2bd185e8,0x657b80f1,0x316b0088,0x798f03f7}},	//   _समका, _thuh, _kkcz_, _kicw,
   {{0xa9258258,0xceba8326,0x5ec70264,0x613113c2}},	//   рдил, _roƙa_, র্শে, _målo,
   {{0x6d4bbc59,0x61fa9e5e,0x2f55ccf4,0x64c80196}},	//   miga, _estl, итос, nčių,
   {{0x3cff90af,0x5745a133,0xb87b0032,0xe9ff80ff}},	//   _hauv_, рноб, _abík, _nhầm_,
   {{0xd2518064,0xbb8480f7,0x6285826f,0x3cff822c}},	//   _بنا_, _اللي, ýhod, _kauv_,
   {{0xeb9a00bf,0xd0118013,0x6d4b8e01,0x290fdf0e}},	//   ким_, _ولا_, niga, _unga_,
   {{0xe72e8934,0xed570a08,0x3cff8282,0x3ce900b9}},	//   _де_, роя_, _mauv_, _dbav_,
   {{0xa3e885e8,0x2d9582a4,0x3cffdf0f,0x6d4bdf10}},	//   _बहस_, _крис, _lauv_, higa,
   {{0xc3328039,0x98a05f11,0x6d4bc9af,0xa2d706bf}},	//   חום_, nkić_, kiga, _बार्,
   {{0x290009e8,0x10a602bc,0x18a61246,0x7afe5f12}},	//   udia_, риан, раам, _wapt,
   {{0x6d4bdf13,0x6723df14,0x7afe102a,0x63a41267}},	// [5900] diga, _konj, _tapt, _utin,
   {{0x613104b8,0x27e05f15,0xdb06008b,0x60d61388}},	//   _håll, rtin_, rskó, sgym,
   {{0xc0e601b5,0x48e60a95,0xdb2402e3,0x67239fd6}},	//   _конк, _конв, _نوکی, _monj,
   {{0xb64c8158,0xfce6a3fc,0x672386c0,0xb4c2800d}},	//   עגאָ, родо, _lonj, ूले_,
   {{0x638681a1,0x2ca982ba,0x3cff81c0,0x613801d0}},	//   агда, ñada_, _dauv_, _cíle,
   {{0x69ce0a0f,0x31c68d0e,0xa9c6a630,0x05c580d4}},	//   orbe, асив, асик, _विंब,
   {{0xd24f845a,0x6d4baeba,0xd90d826a,0xdce280c3}},	//   ونه_, biga, کین_, looč,
   {{0x3f8e80ee,0x75243de3,0xbcfb01d0,0x32cc8032}},	//   _sifu_, _noiz, jlép, _bóyà_,
   {{0x6723df16,0xd0e2873c,0x69c18214,0x14a70d72}},	//   _bonj, क्षण_, _evle, _क्षण,
   {{0x6723df17,0x80a6904f,0x257580f2,0x2d98298d}},	//   _conj, _ट्रे, håll_, _kure_,
   {{0x3eb80065,0x6723803b,0x6abc00e3,0x2fcddf18}},	//   _mert_, _donj, darf, areg_,
   {{0x7d02cb3d,0x7d0096f2,0x2d985f19,0x2fcd80fe}},	//   ndos, _jams, _mure_, breg_,
   {{0x6abc031d,0x69c85f1a,0x6723c0d4,0x69ce09e5}},	//   farf, áden, _fonj, erbe,
   {{0x6d4baa8d,0x7d009345,0x98a9050b,0x6d5d0036}},	//   ziga, _lams, rkač_, érab,
   {{0x6135c93e,0x48dd86ab,0x6d4babd7,0xff7b83de}},	//   _hála, क्को_, yiga, _שטומ,
   {{0x2d520024,0x75240102,0x67238168,0x7d00df1b}},	//   všeg_, _goiz, _zonj, _nams,
   {{0x3eb85497,0x2d985f1c,0x3cff822c,0x69ce5468}},	// [5910] _bert_, _aure_, _rauv_, arbe,
   {{0x3eb852f7,0x6135df1d,0x2d985f1e,0x3cff822c}},	//   _cert_, _mála, _bure_, _sauv_,
   {{0xd0068416,0x2bc986b7,0x3cff81c5,0x7d00b6cb}},	//   _کل_, _रिहा, _pauv_, _bams,
   {{0xe1f01fbe,0x7d00df1f,0x2d985f20,0x3cff81c5}},	//   _کسی_, _cams, _dure_, _qauv_,
   {{0xa3b285b3,0x6d4ba653,0xfc3f001b,0x3eb85f21}},	//   झील_, riga, nzí_, _fert_,
   {{0x6d4bcd46,0x3eb85f22,0x2d520503,0x3da70073}},	//   siga, _gert_, pšeg_, _враб,
   {{0x2d98011e,0x6d4bdf23,0x7d008168,0x3cff822c}},	//   _gure_, piga, _fams, _tauv_,
   {{0x672386c0,0xe9a880f7,0x7d00ce6f,0xe8f99263}},	//   _sonj, جدون_, _gams, ули_,
   {{0xb8ffa128,0x6d498ac7,0x2d98011e,0x6d5b84cd}},	//   _ता_, _imea, _zure_, _ijua,
   {{0x3f990803,0x636d85e4,0x2fcddf24,0x257201fa}},	//   _musu_, gúnt, rreg_, máli_,
   {{0x3ea102af,0x37a800ab,0x6723d96e,0x752402d4}},	//   icht_, _ওয়ার, _vonj, _poiz,
   {{0xc329004c,0x69d5003b,0x3ce30076,0xb8958013}},	//   _או_, duze, ट्ले_, _الإع,
   {{0x394ddf25,0x6abc007b,0x3f99004f,0x291f9c40}},	//   mies_, tarf, _nusu_, mjua_,
   {{0xfaa31a47,0x673a80f3,0xeb971a1b,0x7af55382}},	//   заро, chtj, сир_, gezt,
   {{0x2bd1800f,0xbb431cad,0x69d512e5,0x200b01e8}},	//   _समझा, черк, guze, _arci_,
   {{0x3a2500f2,0x399c01fa,0x3eb85f26,0xa3e88dd2}},	//   älpa_, _vís_, _sert_, _बहल_,
   {{0x4e961301,0x46ea07b6,0x3d155f27,0x2d980039}},	// [5920] مشار, лдан_, धारे_, _sure_,
   {{0x6d49ad7e,0x3f9904a8,0x60dd026c,0x69d52665}},	//   _amea, _dusu_, _ecsm, buze,
   {{0xd0f983b7,0x394dc613,0xa3d60006,0x3eb85f28}},	//   ्याण_, kies_, ांव_, _vert_,
   {{0x61fe003a,0x3ea10013,0x394ddf29,0xd9100077}},	//   _ispl, acht_, jies_, _تیر_,
   {{0x200b02a5,0x6ed89344,0x394dd87d,0xe607804e}},	//   _grci_, _मालु, dies_, _کش_,
   {{0x290203c3,0xf6d5035f,0x8fa30098,0x7d028168}},	//   _haka_, _міся, _харе, sdos,
   {{0x7d00df2a,0x394ddf2b,0x27298118,0x61359434}},	//   _tams, fies_, _lúns_, _sála,
   {{0x21200796,0xf99304de,0x68f635c2,0x29021c7c}},	//   njih_, הרה_, neyd, _jaka_,
   {{0x29025f2c,0x3d1c053e,0x74548065,0x7af50061}},	//   _maka_, याने_, _بھائ, yezt,
   {{0x61358986,0x19ba8765,0xcafc83eb,0x2d920091}},	//   _vála, _будь_, _एसिड_, _aiye_,
   {{0x394dba65,0xd9469b53,0x25a7802a,0xb99680f7}},	//   bies_, _лежи, _ctnl_, _الصب,
   {{0xd7fe0104,0x673a820f,0x29021b28,0x2d80019d}},	//   _đăng_, shtj, _naka_, _chie_,
   {{0x2d9207d9,0x7d7b8039,0x716580f7,0xdb09807b}},	//   _diye_, טרטג, _بالك, _kveð,
   {{0x799a93b2,0x29020032,0x637f8187,0x613cc28b}},	//   _kutw, _aaka_, cênd, _bélg,
   {{0x29025f2d,0x3f99059c,0xa2db9905,0x2d9200a4}},	//   _baka_, _susu_, _नास्, _fiye_,
   {{0x69d50b67,0xa3d60eed,0x799ab6ed,0x2904870e}},	//   ruze, ांश_, _mutw, ndma_,
   {{0x61fe5f2e,0x645a07d9,0x76b901a1,0x63b6031d}},	// [5930] _espl, ştir, илар_, _gwyn,
   {{0xec380051,0x3ea102af,0x394dd6bd,0x6d49df2f}},	//   _לאחר_, ucht_, zies_, _smea,
   {{0x2ca982ba,0x3f9102a5,0xa3db816f,0x2902036a}},	//   ñado_, _vizu_, ढून_, _faka_,
   {{0x3ea102af,0x5c758758,0x200b1487,0x3d1c00c2}},	//   scht_, олет, _trci_, याये_,
   {{0xb6078a56,0x320c808e,0x3ebe919b,0x394dd47c}},	//   _koší, _ardy_, katt_, vies_,
   {{0x29025f30,0x85bb12c5,0x55bb00d7,0x394dbaf5}},	//   _zaka_, _مارس_, _مطرح_, wies_,
   {{0x394ddf31,0xb529026b,0x7aea01ec,0x3d1c052a}},	//   ties_, _akọ̀, _öfte, यामे_,
   {{0x5d549d8f,0x6d49df32,0x81ea80ab,0x672708dc}},	//   _екст, _umea, মিং_, _hojj,
   {{0x394d8b39,0x200b803e,0x320c82c4,0xe8df80ff}},	//   ries_, íci_, _erdy_, hiện_,
   {{0x394ddf33,0x63a98073,0x656bb4d7,0x6d93822b}},	//   sies_, _iten, logh, _għar,
   {{0x6d598901,0x2d923ba1,0x799a8b5e,0x637f841c}},	//   onwa, _piye_, _gutw, gêne,
   {{0x29038029,0xdb06016d,0x656bb271,0x6b9bdf34}},	//   ējas_, nskö, nogh, _kuug,
   {{0xeb9a01a1,0x3ebedf35,0xae17815b,0x4ae0816f}},	//   риг_, batt_, _گذشت, _नामव,
   {{0x29020288,0x3b0a0009,0x63a9804f,0x3ebe8037}},	//   _saka_, шего_, _mten, catt_,
   {{0xcb12878d,0x2902387e,0x68f60009,0xdb060106}},	//   ולם_, _paka_, teyd, kskö,
   {{0x60dbdf36,0x6f03df37,0x63a9a444,0x6138007b}},	//   ngum, _hanc, _oten, _bíla,
   {{0x6f03df38,0xfe780110,0x2120007a,0x29025f39}},	// [5940] _kanc, _šį_, rjih_, _vaka_,
   {{0xef17176a,0x29021855,0x69c3df3a,0x6721817f}},	//   ому_, _waka_, ksne, njlj,
   {{0x29025f3b,0xe4d309a7,0x60db80b9,0x6a800032}},	//   _taka_, _عقید, kgum, _dáfí,
   {{0x7bc2951e,0x6b9b8079,0x186a0c4f,0xb4db023e}},	//   tsou, _buug, _вами_, liàr,
   {{0x7d045f3c,0x06cc00ab,0x25ad016b,0x69c101d0}},	//   _mais, র্ষি, _čele_, šlet,
   {{0xaff900be,0x79a690ff,0x6d4f1598,0x60db80eb}},	//   _פּרי, орие, zica, egum,
   {{0x63a9df3d,0x7bc2bd14,0x68e9df3e,0x613c8718}},	//   _eten, ssou, ffed, _léle,
   {{0x7d045f3f,0x2bd28592,0x442f8114,0x26c700e1}},	//   _nais, _सिपा, byg_, ónov_,
   {{0x6f0380ee,0xd83a8196,0x290280e1,0x2572016b}},	//   _banc, рэй_, ľka_, nálu_,
   {{0x29029807,0x6d4f5f40,0x6f03ac04,0x61358118}},	//   žka_, wica, _canc, _fálo,
   {{0x6d4f160c,0x7d045f41,0x3ebedf42,0x613c8019}},	//   tica, _bais, ratt_, _péld,
   {{0x7d0427b0,0x3ebea1ad,0x25a50118,0x6f038229}},	//   _cais, satt_, _élle_, _eanc,
   {{0x6d4f5f43,0x61359d9a,0x60c0df44,0x6442b24d}},	//   rica, _zálo, mamm, nzoi,
   {{0xdcfc81e2,0x491281d0,0x48f481d0,0x613cc042}},	//   _turė, थाको_, ्यको_, _déle,
   {{0x7d045576,0xd90f0077,0x656b8135,0x61380825}},	//   _fais, نید_, yogh, _síla,
   {{0x7d045660,0xa2d70768,0x6f038041,0x6edd0d14}},	//   _gais, _बाक्, _zanc, _पाहु,
   {{0xe572093f,0x6d4d5f45,0x6f0384b9,0x637f8187}},	// [5950] _אַז_, _imaa, _yanc, nênc,
   {{0x7d0402a5,0x61310aa2,0xb87b0118,0x69d8a366}},	//   _zais, _måli, _acíc, kuve,
   {{0x69d8df46,0x2d9cdf47,0x6b9b8079,0x442fa937}},	//   juve, _juve_, _suug, wyg_,
   {{0x2fc68025,0x442f84b8,0x61358144,0x3ebca67f}},	//   _ovog_, tyg_, _cáll, _levt_,
   {{0x18350158,0x656bdf48,0x613583a8,0x60c081b4}},	//   _זאָל_, rogh, _dáll, damm,
   {{0x637f8073,0xd6d817d4,0x2d9ccc78,0x257c80e1}},	//   dênc, _мтс_, _ouve_, ríla_,
   {{0x6d4d2d62,0x69d8df49,0x6f039342,0xe5c4148d}},	//   _omaa, guve, _ranc, _осто,
   {{0x25720019,0x69c39151,0x26c15f4a,0x61358019}},	//   nált_, rsne, laho_, _válo,
   {{0x6f03b996,0x63a9df4b,0x798282a3,0x2bd2800f}},	//   _panc, _uten, _dhow, _सिया,
   {{0x7d045f4c,0x613100f2,0x6d4d5f4d,0x6f0381b4}},	//   _sais, _dåli, _amaa, _qanc,
   {{0x613c82be,0xe8020540,0x366999a4,0xb9e780e8}},	//   _séle, _रैना_, сано_, _фізи,
   {{0xed5a00e2,0x6f03df4e,0x60c0df4f,0x78bd35aa}},	//   сом_, _wanc, camm, _nesv,
   {{0x6f03df50,0x7d045f51,0xc95284de,0x26c12e5f}},	//   _tanc, _vais, _אמא_, kaho_,
   {{0x613c8065,0x200f8110,0xdb0600e1,0x6d4d5f52}},	//   _véle, _irgi_, jskô, _emaa,
   {{0x7d045f53,0x78bd0a33,0xaca4019d,0xd2520061}},	//   _tais, _besv, _ahụw, رنر_,
   {{0x25aa86a5,0x5fc70006,0x7d040c41,0x3f9da168}},	//   íble_, _लिखल, _uais, _kuwu_,
   {{0x78bd5f54,0xf8bf002a,0xaa8a004e,0xeaaf0019}},	// [5960] _desv, _toén_, _گندم_, ئٹہ_,
   {{0xdfcf00a0,0xb87b0032,0x78a401e8,0x869a0c67}},	//   ايل_, _abís, sciv, стат_,
   {{0x1a9b0158,0x7bc60e51,0x4a9b00be,0x6edd0074}},	//   _לייע, lsku, _לייג, _पारु,
   {{0x63768012,0xc4868cdf,0xdb0d007b,0xbf9b00e7}},	//   mâni, плек, _hvað, _prêt,
   {{0x26c12087,0x61358065,0x7bc65f55,0xa806802a}},	//   baho_, _váll, nsku, _mañó,
   {{0x7982a79a,0x69d8a52a,0xfc3f0511,0x61358118}},	//   _show, tuve, ncía_, _dálm,
   {{0x2fc68025,0x60c0ab92,0xa50a8098,0x200f8102}},	//   _svog_, tamm, _лева_, _argi_,
   {{0xd13080f7,0x637f83a7,0x613101a3,0x7bc61d49}},	//   ئمة_, tênc, _påli, ksku,
   {{0x60c08e51,0x7af882d4,0x2d9c9adc,0x255601a9}},	//   ramm, pevt, _suve_, nālu_,
   {{0x60c0df56,0x637f80a9,0x6b6697ae,0x6d4d03b2}},	//   samm, rênc, _экза, _smaa,
   {{0x2cad0e15,0x2480083a,0x637f83a7,0x6d4d0122}},	//   ñedo_, _azim_, sênc, _pmaa,
   {{0x2fc68052,0xc27b810f,0x4a7b80be,0xa8068020}},	//   _tvog_, _פראי, _פראב, _cañó,
   {{0x7bc6126c,0x78bd08dc,0xdfcf81a8,0xddd380c3}},	//   gsku, _resv, _مين_, čaše,
   {{0x3b058085,0x2d9cdf57,0x661c8884,0x9abc84b7}},	//   _xalq_, _tuve_, ärks, _soċj,
   {{0x637683a7,0x81ea80ab,0x26c100b4,0x61310711}},	//   gâni, মিক_, vaho_, _målv,
   {{0x6d4d45bb,0x39400834,0x26c10a03,0xa3cd864a}},	//   _umaa, ghis_, waho_, _शटल_,
   {{0xb905184a,0x656f0063,0xb4d91299,0xb87b026b}},	// [5970] _ना_, moch, ाली_, _abír,
   {{0xc6a40ba8,0x63ad5f58,0xd24e0065,0x09b280ab}},	//   ерци, _itan, اچی_, _ঘটনা,
   {{0x75299216,0x26c10578,0x20020214,0x6d5d5f59}},	//   _poez, raho_, _eski_, onsa,
   {{0x6d5d0046,0x656f5f5a,0xdced04a8,0x39401d8e}},	//   nnsa, noch, _okač, chis_,
   {{0xdfc68c3b,0x2919002e,0x2d520353,0x69c8868f}},	//   _جي_, _insa_, kšen_, _avde,
   {{0x68e2a509,0x63ad0010,0xb4d906b7,0x212b01ec}},	//   _acod, _mtan, ालु_, _hoch_,
   {{0x656f5f5b,0xd0158592,0x69c700e8,0x752980f3}},	//   koch, तम्भ_, nsje, _toez,
   {{0x56941e18,0x7bc65f5c,0x29090010,0x63ad1210}},	//   _част, ysku, ndaa_, _otan,
   {{0x600691e9,0x63ad23d2,0x69d502af,0x798980dd}},	//   дным_, _ntan, hrze, rmew,
   {{0x27e95f5d,0x212b3428,0x333984c0,0x02a79cf6}},	//   itan_, _loch_, _بزرگ_, _храм,
   {{0x63ad5f5e,0x7a3580f7,0x69d50035,0x291902c4}},	//   _atan, _تفاص, jrze, _onsa_,
   {{0x212b034a,0x6281812b,0x27e95f5f,0x69c75f60}},	//   _noch_, _izlo, ktan_, dsje,
   {{0x68ed00f7,0x27e92f9f,0x394fdf61,0x3d1e0424}},	//   dfad, jtan_, _imgs_, _बचीं_,
   {{0x6f0758d6,0x29192015,0xaca381bc,0xdce400d2}},	//   _najc, _ansa_, _baịn, _okić,
   {{0xe2971bc6,0x656f0870,0x39405f62,0xfc3f2d11}},	//   дар_, boch, this_, rcía_,
   {{0x656f1ed4,0xceba80fc,0x27e95f63,0x29190a2a}},	//   coch, _roƙi_, ftan_, _cnsa_,
   {{0x212b0352,0xa4940077,0x27e9033e,0xb8f6000d}},	// [5980] _doch_, _سیست, gtan_, _सय_,
   {{0x39400282,0x613c80e7,0x3d1c016f,0x62818390}},	//   shis_, _méla, यावे_, _ozlo,
   {{0x27e90867,0xd946138f,0xa3d623e6,0x68fb8009}},	//   atan_, _жени, ांक_, keud,
   {{0x69dc1d36,0x7afc2d59,0xa2aa0105,0x27e926c2}},	//   mure, lert, जुर्, btan_,
   {{0x27e95f64,0x0edd816f,0x60c45f65,0x59830221}},	//   ctan_, _मांड, maim, _шлюб,
   {{0x656f39d9,0x7afc3e44,0x68e28037,0xbfa580ff}},	//   zoch, nert, _scod, _việ,
   {{0x656f386c,0x6298003e,0x63bbdf66,0x255601a9}},	//   yoch, _úvod, _ewun, nāls_,
   {{0x3f98011e,0x3d0692ee,0x60c45101,0x4ae0852a}},	//   _hiru_, _सोचे_, naim, _नावव,
   {{0xbcfb03d3,0x6d5d1ed4,0x69dc42d9,0x6f0701c0}},	//   nnée, éram, hure, _yajc,
   {{0x3ce10006,0x613c80e7,0x60c43d80,0x6446009a}},	//   _काहे_, _déla, haim, dzki,
   {{0x60c44612,0x68ed0214,0x6138002a,0xd5b78d15}},	//   kaim, yfad, _píll, мся_,
   {{0xb4d9000c,0x613c8125,0x2bd2816f,0x63a0c7ef}},	//   ाले_, _féla, सळपा, _kumn,
   {{0x7afc5f67,0x2d5220f9,0x656f5f68,0x69a4809a}},	//   fert, pšen_, roch, _चंडी,
   {{0xf64f8117,0x69d50063,0x7afc06a2,0xc87f81ec}},	//   ائی_, trze, gert, üße_,
   {{0x69dc5f69,0x656f5f6a,0x43940f04,0xda780607}},	//   gure, poch, тарс, дят_,
   {{0x60c40393,0x69c7401c,0x3f985f6b,0x61383b40}},	//   gaim, rsje, _airu_, _fílm,
   {{0xe811901b,0x3f98059c,0x68ed5f6c,0x27e902d6}},	// [5990] ़िया_, _biru_, rfad, utan_,
   {{0x212b06c4,0x27e95f6d,0x69d50063,0xc8088028}},	//   _woch_, rtan_, prze, _mở_,
   {{0x212b0613,0x7bdd5f6e,0x7bc9abea,0x7ae54fb4}},	//   _toch_, lusu, _sveu, _icht,
   {{0x27e95f6f,0x29191341,0x613581d0,0x27ff8114}},	//   ptan_, _unsa_, _válk, ywun_,
   {{0x7bdd5f70,0x9f9a8009,0x27ff0081,0xc80880ff}},	//   nusu, nään_, _èun_, _nở_,
   {{0xfbd083f8,0x63a08012,0xc2c581a8,0x798d0326}},	//   شته_, _dumn, ريبي, lmaw,
   {{0xe1f19125,0xa4d5835f,0x18a585a8,0xe2968073}},	//   است_, _пові, найм, наш_,
   {{0x7afc33bc,0x9f9a8364,0x7bdd1fb6,0x6d42df71}},	//   zert, kään_, kusu, choa,
   {{0x7ae55f72,0x69dc80e8,0x0bd581a8,0x68fbbff4}},	//   _ocht, _åren, _سياح, reud,
   {{0x200dc3ff,0x7bdd5f73,0x6135807b,0x60c45f74}},	//   rvei_, dusu, _máli, zaim,
   {{0x7afc1527,0x06cc00c8,0x7d099400,0x06d500ab}},	//   vert, র্কি, _kaes, স্থি,
   {{0x7ae55bb0,0x7afc5013,0x613101a3,0xc0e9803d}},	//   _acht, wert, _måls, _رفتن_,
   {{0xd90f850c,0x752d0b6e,0x7afc5f75,0x3ce10beb}},	//   _میں_, _doaz, tert, _कारे_,
   {{0x69dc5f76,0x06d500ab,0xa8568039,0x66e5802e}},	//   ture, স্তি, _אינה_, _чока,
   {{0x60c43e95,0x7afc2dd7,0x63769fea,0x7d1bdf77}},	//   taim, rert, mânt, _onus,
   {{0x7ae525e5,0x395fdf78,0x7bdd5f79,0x26c585e7}},	//   _echt, nnus_, busu, lalo_,
   {{0x7afc010b,0x61359984,0x69dc05ef,0xfaa60254}},	// [59a0] pert, _cáli, sure, _папо,
   {{0xe2058028,0x386604b7,0x60c45f7a,0xbcfb00e7}},	//   _đóng_, ħor_, saim, rnée,
   {{0x63a08025,0x1f3683c8,0x60c444ec,0x3f985f7b}},	//   _sumn, ערער_, paim, _viru_,
   {{0x80be823c,0x26c5ca76,0x9f40023e,0x395f81c0}},	//   _एजें, halo_, stià_, jnus_,
   {{0x26c5df7c,0x7d098683,0x3f9800dd,0x6135b355}},	//   kalo_, _daes, _tiru_, _gáli,
   {{0xdd318201,0x26c5df7d,0x4908000d,0x06d580ab}},	//   _təşk, jalo_, ाएको_, ত্তি,
   {{0xc8088028,0x3ce10035,0x6135816b,0xf77701c6}},	//   _sở_, _काले_, _záli, _נעלי_,
   {{0x7d1b826c,0x395f8687,0x2d52128a,0xab5b06ae}},	//   _gnus, gnus_, ušel_, tsük,
   {{0xb908ce09,0x6d40ad62,0x752d0706,0x9a6a804e}},	//   _बा_, _ilma, _roaz, _کمال_,
   {{0x4734845d,0x65641e8c,0x78a981e8,0x9f9a8198}},	//   тнос, _ajih, acev, vään_,
   {{0x0f570051,0x7d0981e0,0xd6d78fe6,0x613103ba}},	//   תיים_, _yaes, хты_, _målr,
   {{0x9f9a825d,0x3ce1016f,0x8fa69f72,0x7ae51a1f}},	//   tään_, _काळे_, _заде, _scht,
   {{0x26c5df7e,0x29578158,0xdb008168,0x6b9a838a}},	//   balo_, _אסאך_, _numë, _kitg,
   {{0xdb00816d,0x7bdd36b2,0xf8b8001c,0xd9f4816f}},	//   _utmä, rusu, _đĩa_, _आहात_,
   {{0x6d408b06,0x6b9a8352,0x2bd30006,0x0a680705}},	//   _olma, _mitg, _तिवा, ерти_,
   {{0x9f9a8009,0x7bdd5f7f,0x99980c51,0x798d008e}},	//   sään_, pusu, екст_, umaw,
   {{0x671c1094,0xa3d29a46,0x69d88192,0xdfd4062c}},	// [59b0] नांक_, _विष_, hrve, лоты,
   {{0x6d40c7ea,0x61358907,0xa3d60697,0x4de486a7}},	//   _alma, _váli, _हित_, _कमाई_,
   {{0x78a204e8,0x7d098098,0x317200b9,0x316009c4}},	//   žova, _paes, boyz_, bniz_,
   {{0x60c29cf3,0x61358789,0x6285007a,0x2fcb0088}},	//   _neom, _hálv, _izho, _tvcg_,
   {{0x26c5bbb8,0x69d89f2e,0x9f4003a8,0x672e0197}},	//   yalo_, erve, stiá_, _fobj,
   {{0x2d52012b,0x69da0216,0x6d40df80,0x212902d4}},	//   všem_, áteg, _elma, ljah_,
   {{0x290b0288,0xa969a659,0x78a98087,0x63768087}},	//   _kaca_, мика_, tcev, vânt,
   {{0x290b02a5,0x26c5bebe,0x1a68803d,0x21295f81}},	//   _jaca_, walo_, رینی_, njah_,
   {{0x33f49e95,0x290b5f82,0x395fdf83,0xfbd0803d}},	//   _مسلس, _maca_, rnus_, _هتل_,
   {{0xee398fcb,0xddd88110,0xa2db93ba,0x78a9847f}},	//   дно_, _gyvū, _नाट्, scev,
   {{0x0d860bba,0x99d492dc,0x69d8812b,0x7bcd0198}},	//   клон, _متنا, crve, _avau,
   {{0xb4ac0e18,0x26c5df84,0x21295f85,0x7052826a}},	//   गडे_, salo_, jjah_, انیا,
   {{0x2129008e,0x06cc00ab,0x8afe80fc,0x00000000}},	//   djah_, র্টি, moƙr, --,
   {{0xd5d10076,0xeb970698,0x43755f86,0x290d811e}},	//   _हिंज, кия_, густ, ldea_,
   {{0x27ed834a,0x290b0867,0xeb971d91,0xdb0089c4}},	//   lten_, _baca_, тир_, _dumè,
   {{0x290db469,0x60c281df,0x27ed80c6,0x7bcb8338}},	//   ndea_, _xeom, oten_, ksgu,
   {{0x27ed861b,0x290b0c6e,0x672e02fd,0x31605679}},	// [59c0] nten_, _daca_, _pobj, rniz_,
   {{0x27edcf62,0x5fd4816f,0x249f9142,0x6fd48035}},	//   iten_, _दिसल, _agum_, _दिसं,
   {{0x26c35f87,0xe7fe0740,0x290b3296,0x27eddf88}},	//   _dejo_, _उनका_, _faca_, hten_,
   {{0x27edd2bb,0x63a45f89,0x6b9adf8a,0x6dac07c0}},	//   kten_, _kuin, _sitg, _ağac,
   {{0x69da00d2,0x27eddf8b,0x5ed980ab,0x29001fea}},	//   šted, jten_, ব্যে, meia_,
   {{0x63a45f8c,0x60c29a26,0x27e023be,0x291d81bc}},	//   _muin, _seom, muin_, _anwa_,
   {{0x44208012,0x2d968048,0x27edd919,0x61ee081a}},	//   ţi_, _арас, eten_, ntbl,
   {{0x27edd468,0x69cac4e7,0x69d8bf11,0x29004e2a}},	//   ften_, rsfe, rrve, neia_,
   {{0x60c28efd,0x53a69878,0xc9530bea,0x27edb0c8}},	//   _veom, _разб, ימה_, gten_,
   {{0x6b9aa40d,0x7791826a,0x7792803d,0x69ca874d}},	//   _uitg, مینا, جیتا, psfe,
   {{0xdb0083d3,0x27e05f8d,0x27eddf8e,0xe514103e}},	//   _numé, huin_, aten_, _तोहि_,
   {{0x61359984,0xa9278110,0x63a4212b,0x27e05f8f}},	//   _sálv, gužė, _buin, kuin_,
   {{0x0ee23792,0x27ed8613,0x4426c5a6,0x63a445c6}},	//   _पांड, cten_, nxo_, _cuin,
   {{0x44269a7d,0x63a4061f,0x290b282b,0x6d4609ca}},	//   ixo_, _duin, _saca_, ahka,
   {{0x4f9b8039,0x671f800f,0x6135ca92,0x2ba50105}},	//   _קבוצ, बारक_, _válv, _गंवा,
   {{0x63a40cb5,0xe807816f,0x6285007a,0x68e45f52}},	//   _fuin, वटचा_, _vzho, ggid,
   {{0x40340364,0x27e0009f,0x21290ad4,0xdb00b59e}},	// [59d0] аетс, guin_, rjah_, _eumé,
   {{0x7d0d2c67,0x44395f90,0xa6cc00ab,0x02b73852}},	//   _haas, mys_, র্ঘট, _अभिभ,
   {{0x7d0d5a42,0x44392bee,0xa3df1a3b,0x27ed811e}},	//   _kaas, lys_, दूर_, zten_,
   {{0x27ed9d49,0x656281a1,0x27e002c4,0x2d5202d4}},	//   yten_, gnoh, buin_, všek_,
   {{0x7d0d0eea,0x44393ece,0x27ed8884,0x26c35f91}},	//   _maas, nys_, xten_, _tejo_,
   {{0x7d0d43f1,0x7ae381c0,0x7bcb88dc,0x799d574d}},	//   _laas, ugnt, rsgu, _hisw,
   {{0x2b8981ac,0x799d0010,0x61385f92,0x7bcb839c}},	//   júce_, _kisw, _síli, ssgu,
   {{0x7d0d4348,0x09f680f7,0x3ce9022c,0x78ad4664}},	//   _naas, افية_, _ncav_, ncav,
   {{0x290dd53f,0x6d59be21,0xb8cb85fc,0x27ed9e0f}},	//   rdea_, miwa, _खल_, uten_,
   {{0x6d59b162,0x44395f93,0xfb87adc7,0x257c85b9}},	//   liwa, dys_, _рыбн, víli_,
   {{0x7d0d18dc,0xa01b0009,0x6135816a,0x3f9cdf94}},	//   _baas, _hyöd, _bált, _divu_,
   {{0x6d599629,0x63a40f56,0x10158591,0x6d462e35}},	//   niwa, _puin, _مبتد, uhka,
   {{0x63a41621,0x290007d0,0xd456004a,0x44392024}},	//   _quin, veia_, утнь, gys_,
   {{0x6d4600f1,0x6d59809c,0x03a30198,0x61ee1ff5}},	//   shka, hiwa, сиро, ttbl,
   {{0x6d59abae,0x6135ac6c,0xc5d580e8,0x32430e9f}},	//   kiwa, _fált, _сіль, берг,
   {{0x27e00ff9,0x63a45f95,0x2bdc0105,0x7d0d0dda}},	//   tuin_, _tuin, _बिपा, _gaas,
   {{0xe8168b9f,0x6d5602a0,0x6d440010,0x29005f96}},	// [59e0] तिया_, _imya, _ilia, reia_,
   {{0x06d580ab,0x613c8061,0x60c9810c,0x27e034da}},	//   ত্রি, _célj, haem, ruin_,
   {{0x2bc68054,0x7d0d461f,0x290003cd,0x6d445eb7}},	//   रीना, _yaas, peia_, _klia,
   {{0x6d59c79e,0xd7d4800f,0x7d0d0079,0x6135807b}},	//   giwa, _दिलच, _xaas, _máls,
   {{0x44269704,0x69ce3958,0x27e04f42,0x9f400198}},	//   uxo_, lsbe, quin_, ttiä_,
   {{0x44268509,0x6f01911b,0x46a31f96,0xfbdc5f27}},	//   rxo_, jelc, _гарв, _बिनम,
   {{0x6d59c50b,0x3f9cdf97,0x6d445e16,0x26790162}},	//   biwa, _rivu_, _olia, _астэ_,
   {{0x3d0e0d38,0x69ce5f98,0x3f9c8009,0x4fd4a2ea}},	//   ियों_, isbe, _sivu_, ажит,
   {{0x3b868c91,0xddcfa7b1,0x44395b82,0x273b801c}},	//   _благ, _češn, xys_, _kênh_,
   {{0x6d4457d2,0x17f78013,0x69ce01eb,0xb1148870}},	//   _alia, ارية_, ksbe, _gụny,
   {{0x6d44154c,0xb52100ba,0x44395f99,0xab938013}},	//   _blia, यालय_, wys_, _اللغ,
   {{0x443913cd,0x6d440c5e,0x628880eb,0x3ce68619}},	//   tys_, _clia, _izdo, ngov_,
   {{0x61358065,0x799d00dd,0x7d0d10c3,0x69ce1151}},	//   _vált, _risw, _vaas, esbe,
   {{0x44395f9a,0x799d48e0,0x7d0d30f9,0x6d599f12}},	//   rys_, _sisw, _waas, ziwa,
   {{0x7d0d5f34,0x443f0029,0x613c8065,0x44395f9b}},	//   _taas, šu_, _nélk, sys_,
   {{0x6d445ded,0x78ad00d2,0x6288816b,0xeab00019}},	//   _glia, ucav, _mzdo, قعہ_,
   {{0xd6db19d9,0x2bdc150e,0x7d028869,0x78ad5f9c}},	// [59f0] ете_, _बिया, deos, rcav,
   {{0x78ad5b02,0x248900b9,0x6d599495,0x628889a4}},	//   scav, _izam_, wiwa, _ozdo,
   {{0x78a28699,0x6d59809c,0x539a0039,0xa01b0198}},	//   _ogov, tiwa, _שיתו, _syöd,
   {{0xf8b10bca,0x613c801b,0x6138318a,0x637f82df}},	//   _ذکر_, _délk, _sílv, mêni,
   {{0x6d59df9d,0x9f4900f7,0xd0069c12,0x7bcf2cfd}},	//   riwa, ltaí_, _بل_, nscu,
   {{0x39490073,0x6d59df9e,0x78a2c4e8,0x2fcd8699}},	//   lhas_, siwa, _agov, vseg_,
   {{0xdea40077,0x2ba192c7,0x2d87837f,0x6925ae50}},	//   _ایمی, _ओंका, ïnes_, имка,
   {{0x3949156b,0x7c3986a9,0xb4f98158,0xa3d6064a}},	//   nhas_, pywr, _שפּי, _हिल_,
   {{0x9f490013,0x248900b9,0x657b8726,0xaae78a47}},	//   htaí_, _nzam_, _ikuh, _مساو,
   {{0xff51803f,0x6d445f9f,0x2d8d808e,0x777701b9}},	//   تخب_, _slia, _hhee_, noxx,
   {{0x6d445fa0,0x32679155,0x4d661ad8,0x23ab813c}},	//   _plia, _став, иков, _høj_,
   {{0xed5a2c38,0x20192f5d,0x2fcd826c,0x69ce03a6}},	//   том_, _orsi_, pseg_, vsbe,
   {{0x5ed000ab,0x6569b52c,0x212d86ec,0x39490387}},	//   স্টে, _mjeh, mjeh_, dhas_,
   {{0x290fdfa1,0x60c6449c,0x9af380fc,0x3ce6cfb3}},	//   _haga_, _sekm, _ƙeƙe_, zgov_,
   {{0x61e38059,0x290f82a3,0x7e7980be,0x637f8187}},	//   nunl, _kaga_, _באַז, gêni,
   {{0x6d5d02be,0x98a31194,0x69ce3e9d,0x39490cb5}},	//   érat, жите, rsbe, ghas_,
   {{0xb4e20076,0x6f0e0069,0x290f8537,0x69ce189c}},	// [5a00] दली_, _pabc, _maga_, ssbe,
   {{0x290f92cf,0xdce981ac,0x61e3dfa2,0x69ce1c11}},	//   _laga_, _cieľ, kunl, psbe,
   {{0x26c7dfa3,0x60c60353,0x38698125,0x39490083}},	//   _meno_, _tekm, _þarf_, bhas_,
   {{0x39495fa4,0x2d8d8135,0x290fc69d,0x2d9f8362}},	//   chas_, _chee_, _naga_, _ciue_,
   {{0x7d02c3e3,0xb6a600e8,0xe3af9459,0x7c220118}},	//   reos, _вигл, ورو_, _áord,
   {{0x26c7dfa5,0x386080ce,0x68f60114,0xc60c8264}},	//   _neno_, _žiro_, lfyd, ষমতা_,
   {{0x290f988c,0xf1a38791,0x613ca738,0xf8aa103e}},	//   _baga_, орын, _héli, _कलाय,
   {{0x2d8d81bc,0x213f8590,0xb87b026b,0x39405fa6}},	//   _ghee_, gkuh_, _abíy, nkis_,
   {{0x8ad6990c,0x290f8a73,0x1ae68364,0x8c438a68}},	//   _نتائ, _daga_, _возм, _дете,
   {{0x61fe035f,0x6618826f,0x26c78353,0xaae0824c}},	//   _oppl, _prvk, _ceno_, _नाटक,
   {{0x290fdfa7,0x628881a9,0x2d68011f,0x33335fa8}},	//   _faga_, _uzdo, rđen_, _roxx_,
   {{0x78a2803a,0x26c7838a,0x7a1c8493,0x25a05fa9}},	//   _ugov, _eeno_, _vătă, _ciil_,
   {{0x61fe39ac,0xcb220b9f,0x2572016b,0x613c8118}},	//   _appl, मांड_, nály_, _néli,
   {{0x2904dfaa,0x394681c0,0x290fdfab,0x0eba876a}},	//   lema_, _hlos_, _zaga_, _руды_,
   {{0x26cc90dd,0x39491e66,0x98c714d6,0x7bcf5fac}},	//   mado_, thas_, исал, sscu,
   {{0x26cc8510,0x3ce101ab,0xa37b0187,0x39405fad}},	//   lado_, _काटे_, drõe, gkis_,
   {{0x6d5d0c0f,0xf0938158,0x613cb60c,0x9f4901a8}},	// [5a10] misa, ַנע_, _céli, staí_,
   {{0x6d5d5fae,0x26cc8510,0x613c82be,0x20190042}},	//   lisa, nado_, _déli, _vrsi_,
   {{0x3d1c035a,0x2904d523,0x2b8981ac,0x6569826c}},	//   याचे_, kema_, júca_, _pjeh,
   {{0x26cca6f3,0x613cb884,0x2904dfaf,0x39405fb0}},	//   hado_, _féli, jema_, ckis_,
   {{0x26ccba19,0x290f90fe,0x29048c53,0x98a9011f}},	//   kado_, _raga_, dema_, njač_,
   {{0x60cd28fb,0xdb040013,0x26ccdfb1,0xfbb80039}},	//   laam, _stiú, jado_, ספות_,
   {{0x26cc90dd,0x3ce8035a,0xdb0405b4,0x45d40705}},	//   dado_, _झाले_, _quié, _морс,
   {{0x61e38214,0x6569829b,0x6b4b0019,0x23ab806a}},	//   runl, _ujeh, _függ, _tøj_,
   {{0x290f87d0,0x2019ca34,0x6d5d5fb2,0x25a00101}},	//   _vaga_, ísi_, disa, _riil_,
   {{0x26cca5a7,0xbb8580f7,0x60cd5fb3,0x98a90b67}},	//   gado_, _الطي, haam, djač_,
   {{0x212d920e,0x63a98010,0x6d5d30f9,0x290fd20b}},	//   pjeh_, _huen, fisa, _taga_,
   {{0x6d5d49af,0x63a9822e,0x60cd04a2,0x200904b9}},	//   gisa, _kuen, jaam, kwai_,
   {{0x814c893f,0xe72e8364,0x60cd02a3,0x517480f7}},	//   _בעאַ, _ее_, daam, _بالأ,
   {{0x98a002a5,0x7fb480d5,0x26cc95c1,0x25a00079}},	//   ljić_, _بلوچ, cado_, _wiil_,
   {{0x6d5d501d,0x25a00bb1,0x5ede0264,0x3940327d}},	//   bisa, _tiil_, ন্ডে, tkis_,
   {{0x6d5d438a,0x6281dfb4,0x98a00d11,0x60cd0079}},	//   cisa, _mylo, njić_, gaam,
   {{0x752401dc,0x7d060009,0x39405fb5,0x6735011f}},	// [5a20] _iniz, meks, rkis_, _bozj,
   {{0x2bab800f,0xa3ab8b9f,0x324622ea,0xdb0e0009}},	//   _चढ़ा, _गढ़_, _геог, äkär,
   {{0x61fe57c1,0xa75a893f,0x27f22937,0xb8ee00ab}},	//   _uppl, נדער, styn_, _রা_,
   {{0x63a99783,0x26cc8510,0x7d065fb6,0xeabf80ff}},	//   _buen, zado_, neks, _đùa_,
   {{0x63a99220,0x26ccba19,0xdb040046,0x6b46807b}},	//   _cuen, yado_, _stiù, _aðga,
   {{0xf7678288,0x63a9811e,0x26cc8ba3,0x27e012ed}},	//   _را_, _duen, xado_, mrin_,
   {{0x26cc90dd,0x6d5d0dc4,0x2904aeae,0x68e994fb}},	//   vado_, yisa, tema_, fged,
   {{0x2be084e5,0x3d182701,0x63a986a5,0x7d0604e6}},	//   _निपा, _बोले_, _fuen, jeks,
   {{0x26cc8510,0x290484c4,0x27e0077f,0xe8e0001c}},	//   tado_, rema_, nrin_, _ngọt_,
   {{0x290480f6,0x60cd407f,0x3ae88077,0x26ca056f}},	//   sema_, zaam, _خبری_, _jebo_,
   {{0x26cc8228,0x6d5d5fb7,0x877b007c,0xa3e48576}},	//   rado_, tisa, ראיי, पूर_,
   {{0x26cca82b,0x27e05fb8,0xdb0284c3,0x26ca01ac}},	//   sado_, krin_, mpoñ, _lebo_,
   {{0x40968307,0xb8968013,0x60cd40fc,0x703a8277}},	//   _الشر, _الشع, vaam, _حساس_,
   {{0x26ca03bb,0x6d5d41af,0x27e05fb9,0x60cd2693}},	//   _nebo_, sisa, drin_, waam,
   {{0x6d5d5fba,0x69da003a,0x237e826c,0x6fa2199e}},	//   pisa, šten, _mktj_, _कंजू,
   {{0x8e838013,0x26d81e72,0x7d060214,0xbcfb0036}},	//   _عليه, _adro_, ceks, fiée,
   {{0x60cd5fbb,0x58870198,0xddd415d8,0xe894062c}},	// [5a30] raam, сыва, _čašn, зать,
   {{0x60cd3755,0x2b5a0118,0x6b4b0799,0xed5980c3}},	//   saam, _gmpc_, _büge, _smž_,
   {{0x63a98e1b,0x26ca0333,0x6d4b8114,0x6d680118}},	//   _suen, _debo_, thga, _ásaí,
   {{0x63a1a08f,0x63a99783,0x27e05fbc,0xe4cb803d}},	//   _siln, _puen, brin_, ابان_,
   {{0x63a18612,0x25ad00d2,0x63a98548,0xe3b3803d}},	//   _piln, _čelu_, _quen, سرش_,
   {{0x41b58c3e,0x3da72118,0x7ae785e9,0xeb9980af}},	//   осит, _граб, сюдж, шил_,
   {{0x63a18a8e,0x68e98cfa,0xdb008511,0x26c10267}},	//   _viln, tged, _atmó, mbho_,
   {{0x13a7803d,0x63a9cace,0x628183c1,0x5ede00ab}},	//   _هنری_, _tuen, _vylo, ন্দে,
   {{0xe81c101b,0xfbe086bf,0x68e98c77,0xbcfb026f}},	//   निया_, _नियम, rged, mnéh,
   {{0xf77187bd,0x7524007d,0x68e9dfbd,0xbcfb026f}},	//   باب_, _sniz, sged, lnéh,
   {{0x2bdc12ee,0x27e04e07,0xdced00e1,0xa2ba03dd}},	//   _बिहा, zrin_, _diaľ, ्रस्,
   {{0x2bc6946d,0xc3290051,0xbcfb026f,0x2fdf8668}},	//   रीवा, _בו_, nnéh, prug_,
   {{0x613c8207,0x395fdfbe,0x656d09c4,0x66e00032}},	//   _célu, mius_, _djah, _jákà,
   {{0x395fc1af,0x7d065fbf,0x394d80a9,0x957d009a}},	//   lius_, seks, lhes_, stąp,
   {{0xfaa32c9f,0xe29a1f25,0x69dc904a,0x7d065fc0}},	//   даро, рав_, _året, peks,
   {{0x2bcf8327,0x27e03ae0,0x26ca5fc1,0xa2ba016f}},	//   _सौभा, trin_, _sebo_, ्रह्,
   {{0xdb01820f,0xbcfb0a21,0x60cb8019,0x79840c02}},	// [5a40] _cilë, dnéh, _megm, rliw,
   {{0x27e05fc2,0x6d4992ec,0x25e0a1e3,0x2b5a01e0}},	//   rrin_, _alea, _किमी_, _umpc_,
   {{0x98a618ba,0x395f8110,0xb87b0174,0x248d83ed}},	//   _мине, kius_, _scít, _azem_,
   {{0x6d49b6d3,0x66e0026b,0x4c86c566,0x92a6866f}},	//   _clea, _bákà, олев, zyłą,
   {{0xa01b2732,0x394db543,0x6d498c41,0x26ca00dd}},	//   _szöv, dhes_, _dlea, _tebo_,
   {{0x6d42811b,0x248d826c,0x8c1b0039,0xb33c8609}},	//   skoa, _dzem_, יוני, _biħa,
   {{0x2d800640,0xbcfb1c18,0x6d49c4b9,0x8fa30d69}},	//   _okie_, bnéh, _flea, _царе,
   {{0x6d498c49,0x394ddfc3,0x684080f7,0xa01b0009}},	//   _glea, ghes_, _nádú, _myön,
   {{0xf993078d,0xdb0287f4,0x60cb82a3,0xff0684fa}},	//   ורה_, spoñ, _degm, оянн,
   {{0x656d06cb,0x9abc8609,0x35af0327,0x2d8682f9}},	//   _sjah, _inċo, _जूड़, lloe_,
   {{0x69da001b,0x2bc68701,0xceb301c6,0x3160019d}},	//   átel, रीरा, וית_, kiiz_,
   {{0xd90e80d5,0x394d9706,0x395fdfc4,0x6eba970c}},	//   _شیخ_, ches_, cius_, _श्रु,
   {{0xd7ef80f7,0x69da42f2,0x98a901ac,0xa6d500ab}},	//   _لكن_, štel, tiaľ_, স্টট,
   {{0xada580e1,0x2bdc001b,0x23b08866,0xbcfb4b7e}},	//   _skúš, _बिरा, _màj_, inéi,
   {{0xdb018f33,0x613c8e06,0x656d1cfe,0x68fd0362}},	//   _dilè, _félt, _tjah, _pbsd,
   {{0xa3e80072,0x98a901d6,0xed580a2e,0x656d5a17}},	//   मूह_, siaľ_, _мој_, _ujah,
   {{0xbcfb0a21,0x657d39d6,0x2ca901b4,0x27140264}},	// [5a50] vnéh, mosh, _igad_, ঠানো_,
   {{0x657d5fc5,0x3ea70aa2,0xa29505e9,0x6d498834}},	//   losh, ønt_, _напі, _slea,
   {{0x6d49dfc6,0xbcfb026f,0xa01b0019,0x63ad453f}},	//   _plea, tnéh, _gyön, _huan,
   {{0x63ad00f6,0x395f8722,0xaae709a7,0x02b3801b}},	//   _kuan, xius_, _اسکو, ँड्न,
   {{0x69d5100b,0xbcfb026f,0x395f8084,0x58840048}},	//   lsze, rnéh, vius_, _жыра,
   {{0x27e909ca,0xbcfb016b,0x248480ee,0x2139008e}},	//   muan_, snéh, _dymm_, _hosh_,
   {{0x395f9b09,0x27e9059f,0x2bd7835a,0x4429802e}},	//   tius_, luan_, _ठिका, ţa_,
   {{0x2bdc000f,0x6d5b8135,0x26000035,0xe0df0176}},	//   _बिला, _umua, _रहती_, _amòz_,
   {{0x395fcf05,0x27e917a0,0x68ed0ece,0x657d39d6}},	//   rius_, nuan_, igad, dosh,
   {{0x6738dfc7,0x395f8110,0x2ca95fc8,0x69d50019}},	//   _covj, sius_, _agad_, ksze,
   {{0x27e90763,0x656b86e7,0x62852a30,0xdce98d26}},	//   huan_, ongh, _nyho, _lječ,
   {{0xa3d70063,0x27e95fc9,0x656bdfca,0x69d5100b}},	//   ाओं_, kuan_, nngh, dsze,
   {{0x63ad1220,0x9fd600c8,0x27e9010b,0x31b18019}},	//   _cuan, _সঙ্গ, juan_, _ház_,
   {{0x27e92dd3,0x63ad5fcb,0xa026807b,0x2d990fb0}},	//   duan_, _duan, stöð, amse_,
   {{0x6b5004b8,0x62850355,0x3cff826f,0x657d0234}},	//   _lägg, _cyho, _obuv_, bosh,
   {{0x25e0835a,0x68ed5a3e,0x55da8158,0x38608503}},	//   _किती_, ggad, _פֿונ, _žiri_,
   {{0x63ad2f30,0xb4d80bbc,0x200ddfcc,0xb9042730}},	// [5a60] _guan, ाणी_, nwei_, _नय_,
   {{0x44205fcd,0xdce982fd,0x7d1602a3,0xa01b0009}},	//   _iri_, _dječ, _hays, _työn,
   {{0x7d1658f6,0x63bbdfce,0x62850114,0x76419106}},	//   _kays, _atun, _gyho, nyly,
   {{0x8fa6013a,0x27e909ca,0x6d465be7,0x92e880ab}},	//   _наме, buan_, nkka, _বসে_,
   {{0x293700be,0x6d460009,0x9f44c79c,0xb87b046d}},	//   _זאכן_, ikka, sumé_, _adíf,
   {{0x60c401e2,0x656b8013,0x7bc9831d,0x63bb808e}},	//   lbim, angh, _dweu, _dtun,
   {{0xf107823c,0xbcfb0013,0x657d341a,0x6f08dfcf}},	//   वजूद_, snéi, yosh, vedc,
   {{0x44205fd0,0xb6a31317,0x4ddb01c6,0x63bbb7f4}},	//   _ori_, _числ, _לחלו, _ftun,
   {{0x6738920e,0x4420082e,0xb904c765,0x6f088144}},	//   _povj, _nri_, _भए_, tedc,
   {{0x69d531d6,0x63ad059c,0x44270104,0xa8570051}},	//   ysze, _ruan, _ăn_, פייה_,
   {{0x44205fd1,0x657d5fd2,0x63ad5fd3,0x27e9316e}},	//   _ari_, tosh, _suan, zuan_,
   {{0x27e95fd4,0x4420337a,0xd843026f,0x63ad0214}},	//   yuan_, _bri_, ničí_, _puan,
   {{0x63ad20ef,0x657d5fd5,0x4420054e,0x9f400388}},	//   _quan, rosh, _cri_, ntió_,
   {{0xdce9920e,0x69d51529,0x44205fd6,0x6d460009}},	//   _rječ, tsze, _dri_, akka,
   {{0x44202444,0xb909801c,0x2bd91344,0xdce98654}},	//   _eri_, _nghề_, _भटका, _sječ,
   {{0x27e95fd7,0x6285003e,0x19580a14,0x69d55fd8}},	//   tuan_, _vyho, пасы_, rsze,
   {{0x6d4d02a3,0x69d50019,0x44205fd9,0xf4850180}},	// [5a70] _ilaa, ssze, _gri_, _تاثی,
   {{0x27e95fda,0x2bcf81fe,0x68ed5fdb,0xdce982ce}},	//   ruan_, सीफा, sgad, _vječ,
   {{0xfbaf00c8,0x63bb8e20,0x6d4d26a1,0x27e93158}},	//   _কবিত, _stun, _klaa, suan_,
   {{0x27e9255f,0xb4e7aa85,0x65628115,0x798281bc}},	//   puan_, पले_, gioh, _nkow,
   {{0xe1f18077,0xfc46801c,0x26dc81a1,0x1be9804a}},	//   چسب_, _đích_, _odvo_, ідки_,
   {{0xaabf053f,0x6b50016d,0xdb0983bf,0xb87b026b}},	//   ्रिक, _vägg, _önün, _adíg,
   {{0xa3b409c8,0x60cf4160,0xe2969577,0x6b4f8366}},	//   _जून_, _kecm, маш_, _nøge,
   {{0xa0a597a1,0x3a3a8106,0x34958196,0x673c8106}},	//   майд, äppa_, _жабр, örjn,
   {{0x24c500ab,0x63bb8435,0xaabf1a46,0x7d163dd5}},	//   ্লাহ, _utun, ्राक, _rays,
   {{0x6d4d5fdc,0xf8aa073c,0x6b4f813c,0xe8aa03db}},	//   _alaa, _कल्प, _bøge, _कल्च,
   {{0x7529825b,0x6d4d000b,0xfce601a4,0x6ad380ab}},	//   _knez, _blaa, моно, _সাপো,
   {{0x44201fc2,0xb4d8035a,0x9f400511,0x6d4d000b}},	//   _pri_, ाणे_, rrié_, _claa,
   {{0x6b5000f2,0x6d460009,0x753b8118,0x6b4b02f1}},	//   _läge, rkka, _mouz, _süga,
   {{0x889a8039,0x753b83a8,0x7989dc81,0x06e300ab}},	//   _ובני, _louz, llew, ন্তি,
   {{0x03a301a0,0x6d4d019d,0x26c5d826,0xbcfb0388}},	//   тиро, _flaa, mblo_, mién,
   {{0x316d82be,0xbcfb0144,0x6d4d0bfd,0x61e10061}},	//   nnez_, lién, _glaa, álla,
   {{0x44205fdd,0xbf8a801c,0x60c45fde,0x7d0bb026}},	// [5a80] _uri_, _đoạn_, rbim, degs,
   {{0x7529b08f,0xbcfb0020,0x6d4d026c,0x60c400b9}},	//   _anez, nién, _zlaa, sbim,
   {{0x753ba4be,0x2be08105,0x6b500106,0xe29a2c24}},	//   _bouz, _निहा, _vägd, _фан_,
   {{0x25e08063,0xe8df801c,0x2fc01c11,0x448a93f1}},	//   _किसी_, _trộm_, ppig_, обен_,
   {{0x753bace0,0xa2a09513,0x32058122,0x3d00016f}},	//   _douz, गेन्, _aply_, ष्ये_,
   {{0x9f401099,0x629c816b,0x316d811b,0x7989804f}},	//   rtió_, _úrok, enez_, elew,
   {{0x9f40009f,0xbcfb0333,0xdb00c255,0xdee32ba7}},	//   stió_, dién, _rumä, _јоси,
   {{0xd1308013,0x316d80e7,0x673c0079,0xa8149294}},	//   امة_, gnez_, _horj, едиш,
   {{0x6b4f8022,0x673c1bda,0x36d48a7c,0x61ea8162}},	//   _søge, _korj, нопр, sufl,
   {{0x6d4d10f4,0xeeeb001c,0x99898668,0x4b269a3c}},	//   _slaa, _đừng_, ćaš_, _تعرف,
   {{0x6d4d2409,0x673c0353,0x7989a418,0x6aba810c}},	//   _plaa, _morj, blew, _iftf,
   {{0xc86684fa,0x69d8dfdf,0xe3c701df,0xc5f880eb}},	//   _отли, msve, íños_, rtē_,
   {{0x63a8b24d,0x69d8a1b4,0x6d4d038e,0x7bc2dfe0}},	//   _kidn, lsve, _vlaa, npou,
   {{0xbcfb06a5,0x29020326,0x673c0198,0x69d8b610}},	//   cién, _abka_, _norj, osve,
   {{0x63a88079,0xe81684c5,0x442d0087,0xd13b2f4b}},	//   _midn, तिका_, ţe_, оха_,
   {{0x69d8deb0,0x6d4d4da1,0x5ec800ab,0xd90f004e}},	//   isve, _ulaa, _লাগে, جیح_,
   {{0x6b5004b8,0xb8e70076,0x2be085fc,0x753bdfe1}},	// [5a90] _säge, _उभ_, _निषा, _rouz,
   {{0x7529bdbf,0x753bdfe2,0xa91d8796,0x3d00016f}},	//   _snez, _souz, može, ष्ठे_,
   {{0xa91da842,0x753b800d,0x7d0b8019,0x25a95fe3}},	//   lože, _pouz, tegs, _kial_,
   {{0x2be085e8,0x23e08076,0x6b502e6d,0x656f1581}},	//   _निशा, _निशद, _väge, nnch,
   {{0x7bc4802e,0x7d0b8412,0x656f5fe4,0x29190162}},	//   ţiun, regs, inch, _iasa_,
   {{0xb3e085b3,0xfbe084e5,0x98af8063,0x2919022e}},	//   _निरख, _निरम, _mogą_, _hasa_,
   {{0x291903c3,0x2369803a,0x2006802e,0x4b380039}},	//   _kasa_, đaj_, _apoi_, ורגל_,
   {{0x3949189e,0x5694153d,0x291914e5,0x2d788904}},	//   nkas_, _раст, _jasa_, včeg_,
   {{0x29195fe5,0x2d8b15ab,0x2489022c,0xbcfb01ca}},	//   _masa_, dlce_, _nyam_, tién,
   {{0x29195fe6,0x656f0073,0xa91d8289,0x27e2816b}},	//   _lasa_, ench, dože, ákna_,
   {{0x2489059c,0x2b898038,0x8d662296,0x62889ad5}},	//   _ayam_, júci_, евне, _gydo,
   {{0x92c100c8,0x63a8811f,0x2d8400e7,0xdb018c1d}},	//   ুলো_, _zidn, ôme_, _milí,
   {{0xf992812a,0x66f0223a,0x394911fe,0x2ca40106}},	//   _ערד_, _चालक_, dkas_, ämd_,
   {{0x212b0081,0x883a8039,0xa91da663,0x29194bf9}},	//   _anch_, _מתנו, sožd, _aasa_,
   {{0x291903f8,0xdb0f01a8,0xbcfb12ab,0x27ed8cdb}},	//   _basa_, ádái, gnés, luen_,
   {{0x61358019,0xa91d816b,0x386d026c,0xa3c186a7}},	//   _pály, bože, _žera_, ूठा_,
   {{0xd0070fbe,0xc72601e5,0x25bf005c,0x27eddfe7}},	// [5aa0] нете_, ндай, _čula_, nuen_,
   {{0xe1fa025d,0x80ac05b3,0x65665fe8,0x2d8238b3}},	//   _его_, _झलके, likh, loke_,
   {{0x291905a3,0x64465fe9,0x63a883e2,0x394935b5}},	//   _fasa_, lyki, _ridn, bkas_,
   {{0x39495fea,0x3a25013c,0x29195feb,0x41bb0039}},	//   ckas_, ælpe_, _gasa_, _מצטע,
   {{0x60d60637,0x66150019,0x7d0431ca,0x9cd701c6}},	//   maym, _eszk, _mbis, תונה_,
   {{0x69d8d27b,0x60d62f3b,0x27ed8cdb,0xdb01dfec}},	//   tsve, laym, duen_, _filí,
   {{0x7d043929,0xfce6a410,0x63a8dfed,0x291931cc}},	//   _obis, _пово, _vidn, _yasa_,
   {{0x7afb0025,0x63a8a180,0x69d88f2c,0xeeeb001c}},	//   đuti, _widn, rsve, _đứng_,
   {{0x63a880f2,0x27edae88,0x25a959b2,0x2d823353}},	//   _tidn, guen_, _rial_, doke_,
   {{0xd6da88cc,0x4424bdd1,0x7d040c03,0xd130803d}},	//   чти_, _irm_, _abis, امک_,
   {{0x24890359,0xa3d31905,0x7c2457eb,0xfd4d8135}},	//   _syam_, हीन_, _arir, _nghọ,
   {{0xb4eb090a,0xeabf8129,0xa91d82d4,0x442488dc}},	//   मले_, _đùi_, tože, _krm_,
   {{0x291904aa,0xfd4d8135,0xf74681a4,0x9abc8197}},	//   _rasa_, _aghọ, _педо, _anċi,
   {{0x291900f6,0x7d0402ec,0x61e10061,0x7986022b}},	//   _sasa_, _ebis, állo, _akkw,
   {{0xb9e4035f,0x2d825fee,0xa01b0009,0x7c241292}},	//   літи, boke_, _työk, _erir,
   {{0xf99300f7,0x4424808c,0xa91d82a5,0xfc46801c}},	//   ابس_, _orm_, pože, _đính_,
   {{0xd3a73d65,0xb8d92701,0x39490288,0x7a138201}},	// [5ab0] _проп, _चल_, rkas_, _vətə,
   {{0x39495fef,0x291900a4,0x7d1d00b2,0xb87b002a}},	//   skas_, _wasa_, ldss, _adíc,
   {{0x29195d18,0x26d10988,0x3f810168,0x27ed811b}},	//   _tasa_, _vezo_, rohu_, zuen_,
   {{0x7d1d23ea,0x59b61834,0x442481a1,0xbc68004e}},	//   ndss, _आंतर, _brm_, _آمین_,
   {{0x7d1d1377,0x752d0c53,0x8d749459,0x53e09a46}},	//   idss, _mnaz, دالا, _निःश,
   {{0x798d4da1,0x8c4291d5,0x6566005d,0x04428073}},	//   llaw, реше, zikh, решн,
   {{0x7bd99770,0x69da0353,0x56940a42,0x6b500589}},	//   sswu, štev, _барт, _jäga,
   {{0x27ed80ad,0x7d1d2a52,0x8afe80fc,0x752d03f7}},	//   tuen_, jdss, riƙa, _nnaz,
   {{0x5b159a19,0x2d821315,0x27e95ff0,0xa91d807a}},	//   _имат, voke_, nran_, tožb,
   {{0x27e941e3,0x7d1b8788,0x27edb665,0x752d2f0e}},	//   iran_, _haus, ruen_, _anaz,
   {{0x27e9198d,0x6b83840c,0x7d1bdff1,0x65663c5a}},	//   hran_, mong, _kaus, tikh,
   {{0x25e91344,0x64460d12,0x7d1bdff2,0xaa6499b8}},	//   _चटनी_, tyki, _jaus, _стук,
   {{0x2d825ff3,0x27eddff4,0x7d1bdff5,0x798d01e0}},	//   roke_, quen_, _maus, dlaw,
   {{0x2d825ff6,0x7d1b8b74,0x6b838c8b,0x27e95ff7}},	//   soke_, _laus, nong, dran_,
   {{0x27e920e1,0x798d0114,0xdb0888f9,0x2d820db1}},	//   eran_, flaw, _didè, poke_,
   {{0x7d041f3a,0x6b83dff8,0x0c26341b,0x27e95ff9}},	//   _ubis, hong, _амин, fran_,
   {{0xa0671a19,0x186747a8,0x68431273,0x6b83b490}},	// [5ac0] вата_, вати_, анта, kong,
   {{0x6b83a499,0x998d003a,0x7986008e,0x03a61630}},	//   jong, ćeš_, _wkkw, _шипо,
   {{0x7d1bbe50,0x6b83d038,0xf2d30bea,0x27e95ffa}},	//   _baus, dong, _דעת_, aran_,
   {{0xfce69baa,0x44248abf,0x69de824a,0xdb0083ba}},	//   тодо, _prm_, špek, _humø,
   {{0x7d1bdd18,0x3f8c808b,0x69dc1dba,0x6d988144}},	//   _daus, yldu_, lsre, víad,
   {{0x6b83b31a,0xf8bf010c,0xf41301c6,0x232785d3}},	//   gong, _anéh_, יפד_, кочи_,
   {{0xd24f880b,0x69dc0ed0,0x672e0106,0xbebc80eb}},	//   ينه_, nsre, _inbj, ldīg,
   {{0xdce2803a,0x7d1bae2e,0x60c98b4e,0x6f1c5ffb}},	//   dnoć, _gaus, gbem, _harc,
   {{0x6d408ad0,0x6b838d48,0xdef884b7,0xdca390ef}},	//   _ioma, bong, liċi_, _вати,
   {{0x7d1b8025,0xa2c186bf,0x65642123,0x6b839267}},	//   _zaus, रुद्, _amih, cong,
   {{0x13d780ab,0x69dc0289,0xa4d50221,0xd00b00ab}},	//   _সময়, jsre, лоні, রিয়_,
   {{0xb4bf01b6,0x27e905b0,0x670203eb,0x6f1c107c}},	//   ेरे_, yran_, र्तक_, _larc,
   {{0x6d40dffc,0x201880eb,0xa3b88105,0x18369a37}},	//   _moma, āris_, _घूम_, _جراح,
   {{0x52bf000c,0x36d48d40,0x6d40dffd,0x2bb50035}},	//   ्रेस, _сокр, _loma, ंदबा,
   {{0x25bf0289,0x96f7830f,0x27e93a19,0x6d408df6}},	//   _čulo_, _شعور_, wran_, _ooma,
   {{0x6d40dffe,0x44f55fff,0x6b5004fd,0x6b839a08}},	//   _noma, _спис, _väga, zong,
   {{0x6f1c023e,0x9b450bca,0x6b8381d3,0x798d0590}},	// [5ad0] _barc, _منظو, yong, rlaw,
   {{0x5b150364,0x27e96000,0x7d1b9247,0x7c228140}},	//   _смот, rran_, _saus, dvor,
   {{0x3ea700f2,0x2367842b,0x6b838176,0x6d40d84a}},	//   änt_, vinj_, vong, _boma,
   {{0x6d40e001,0x68e2af61,0x6b83e002,0x69c72948}},	//   _coma, _ndod, wong, mpje,
   {{0x6f1c6003,0xdfc6880b,0x2bdc0beb,0x6b4f8aa2}},	//   _farc, _دي_, _बिछा, _døgn,
   {{0x6f1c0333,0x68e29998,0x7bdd6004,0x6d408609}},	//   _garc, _adod, issu, _eoma,
   {{0xa3d3035a,0x3da7c4e0,0x6d408242,0x6a8597ae}},	//   हीत_, _араб, _foma, ылка,
   {{0x6d40ace1,0x6b83e005,0x6f1c6006,0x3169011b}},	//   _goma, song, _zarc, niaz_,
   {{0xa3e0800d,0x6b83e007,0x2367cb0f,0x6b548091}},	//   _थिए_, pong, pinj_, _dàgb,
   {{0xee398951,0xdb018118,0x6d40a81f,0xdce2876c}},	//   ено_, _filá, _zoma, tnoć,
   {{0xf8d30076,0x8c4287d9,0x9d460d8f,0x7bdf1072}},	//   तराय, _öğre, генд, _avqu,
   {{0x69dc0aa2,0x6d880144,0xbc1a0048,0xdce280fe}},	//   vsre, eñar, нігі_, rnoć,
   {{0x2d8f8307,0xdce2805c,0xafe581e5,0x27e981df}},	//   ilge_, snoć, _солл, _ían_,
   {{0x291da07b,0xf8bf0091,0x69dc189c,0x291f811b}},	//   _hawa_, _afé_, tsre, ldua_,
   {{0x291de008,0x20190211,0x7bdd0037,0xdea1853d}},	//   _kawa_, _assi_, assu, _دیدی,
   {{0xdb089b20,0x291d8854,0x291f847c,0x394d955f}},	//   _vidé, _jawa_, ndua_, nkes_,
   {{0x6d40a49a,0x27ffe009,0x291d803d,0x248d81c5}},	// [5ae0] _roma, ntun_, _mawa_, _nyem_,
   {{0x6d40e00a,0x6b4f813c,0x291dc500,0xdef881b9}},	//   _soma, _søgn, _lawa_, tiċi_,
   {{0x25adc640,0x6ce68048,0x20190081,0x394d8257}},	//   _biel_, гіле, _essi_, kkes_,
   {{0x7c228b5d,0x6f1c28c6,0x25ad80e7,0x6d4086cb}},	//   tvor, _warc, _ciel_, _qoma,
   {{0x0b8a80c4,0x938a9285,0x3f8584b7,0x25ade00b}},	//   нски_, нска_, kolu_, _diel_,
   {{0x2bb7000f,0x7c228223,0x2912112e,0x6d40e00c}},	//   _इंसा, rvor, leya_, _woma,
   {{0x2be080ba,0x2741800d,0x39422c62,0x3f85e00d}},	//   _निका, _méně_, _koks_, dolu_,
   {{0xdb018065,0x2120478e,0xdca68d9e,0x25ad9c11}},	//   _vilá, ndih_, _баби, _giel_,
   {{0x2000600e,0xcaf69b9a,0x291d8d4c,0x2d680019}},	//   ntii_, _مساب, _dawa_, tően_,
   {{0xade58424,0x25adc60f,0x3f859c66,0x26da600f}},	//   _किशन_, _ziel_, golu_, napo_,
   {{0xd5b78364,0xa37b0073,0x1d3521d2,0x64400009}},	//   лся_, nsõe, ання, ämin,
   {{0xc27b8451,0xa91dcb1f,0x291de010,0x2b4100dd}},	//   _ארבי, ložn, _gawa_, _sohc_,
   {{0xfd1f0098,0x7bdd00e7,0x6fb00105,0x67d48087}},	//   rdì_, ussu, _अंगू, _толу,
   {{0x77f78051,0x6b4f806a,0xae050006,0x909780e8}},	//   _עמוד_, _nøgl, _रहलन_, _світ_,
   {{0x31c4085f,0xf993019f,0x291db174,0xa14381a9}},	//   йств, مبر_, _yawa_, _šķir,
   {{0x2019061b,0x69c700f1,0x386982d4,0x9f520198}},	//   _pssi_, rpje, _žari_, htyä_,
   {{0x69c76011,0xc05b00e8,0xbebc81a9,0x31690cdb}},	// [5af0] spje, хів_, mdīb, riaz_,
   {{0xbebc8029,0x7a0a8201,0x2bcf9513,0x25ade012}},	//   ldīb, _mətb, _सौगा, _siel_,
   {{0xc3320159,0x69da011f,0x25ade013,0xcf938158}},	//   _ווי_, šter, _piel_, צטע_,
   {{0x69c56014,0x20190282,0x44296015,0x200001b4}},	//   _ithe, _tssi_, _kra_, btii_,
   {{0x7d1f19e7,0x291dc0bb,0x25ad9d77,0x26da022e}},	//   _maqs, _rawa_, _viel_, bapo_,
   {{0x69c500f1,0x291daef4,0x03a5d9dc,0xdcfbb52c}},	//   _kthe, _sawa_, шило, _okuć,
   {{0x25addbd7,0xba77803d,0x44296016,0x2d7880c3}},	//   _tiel_, داشت, _lra_, mčen_,
   {{0x44296017,0x6d98802a,0x27ffe018,0x6009ad6b}},	//   _ora_, ríac, ttun_, вним_,
   {{0x3f858964,0x656bbbb0,0x394d91b4,0xa91d85f3}},	//   tolu_, migh, rkes_, božn,
   {{0x69c5004c,0x753d0063,0x394d99f6,0x7c29e019}},	//   _othe, ejsz, skes_, _irer,
   {{0x442922c6,0x644bb30a,0x27ffd479,0x7bc42c66}},	//   _ara_, lygi, stun_, _stiu,
   {{0x44291c47,0xe1f0803f,0x6e210510,0x3f85ad9c}},	//   _bra_, _رسم_, _álbu, solu_,
   {{0xf7708fd3,0x7d09e01a,0x998480f7,0x69c50e5a}},	//   _کان_, _mbes, _النو, _athe,
   {{0x4429601b,0x60dbadde,0xbea58dc0,0x656ba756}},	//   _dra_, laum, _калк, high,
   {{0x29d38012,0xc5d5835f,0x44294899,0xfaa61269}},	//   nţa_, _тіль, _era_, раво,
   {{0x44291f26,0x92d600c8,0x90c60a41,0x1c461ccf}},	//   _fra_, হলে_, рбае, _вним,
   {{0x656ba770,0x657d0019,0x2912401d,0x4429601c}},	// [5b00] digh, érhe, reya_, _gra_,
   {{0x2000601d,0x7d09c82e,0x7f43e01e,0x27edb20e}},	//   rtii_, _abes, _jonq, iren_,
   {{0x27ed8352,0x2000601f,0x26da3c1b,0x67020aed}},	//   hren_, stii_, rapo_, र्षक_,
   {{0x44290a8e,0x0c2689b0,0xa37b0187,0xe7ef016f}},	//   _yra_, имен, rsõe, _चमचा_,
   {{0x4ada18b8,0xa37b03a7,0x9f520009,0x6b4b0074}},	//   _बजाव, ssõe, ttyä_, _sügi,
   {{0x27e06020,0x27ede021,0x7d09836a,0x69dc804a}},	//   msin_, dren_, _ebes, _ærek,
   {{0x6d560065,0x27edd176,0x27e005b2,0x7c2991d3}},	//   _olya, eren_, lsin_, _erer,
   {{0xa01b0009,0x6d59e022,0xdb1600ff,0xf1269cf8}},	//   _työt, chwa, _quyê, рько,
   {{0x27e06023,0xdce98499,0x27ede024,0x06da80ab}},	//   nsin_, _sjeć, gren_, _দাবি,
   {{0x27e032c6,0x6d561061,0x26d800d7,0x4429488e}},	//   isin_, _alya, _jero_, _rra_,
   {{0xe8fac907,0x27e0083a,0x27ed9d6a,0xdb16001c}},	//   _але_, hsin_, aren_, _tuyê,
   {{0x44296025,0x99758364,0xa2ca8894,0x69ca82af}},	//   _pra_, _лучш, _स्त्, mpfe,
   {{0xae438077,0x69c5148f,0x442680b9,0x6b5001ec}},	//   مپیو, _sthe, nvo_, _tägl,
   {{0x656be026,0x4429079f,0x4426c34e,0x83870048}},	//   zigh, _vra_, ivo_, рыме,
   {{0xa3b88768,0xdcfb8289,0x7d1f01b9,0x99671b47}},	//   _घूस_, _ukuć, _taqs, атал,
   {{0x44296027,0x4426803a,0x6d444395,0x5d843b76}},	//   _tra_, kvo_, _goia, _ولول,
   {{0xd6db0073,0x60cd6028,0x26d823f8,0x61ee509b}},	// [5b10] вте_, rbam, _bero_, arbl,
   {{0x26d805e4,0xbf0201a2,0x2be0800c,0x2d788267}},	//   _cero_, र्लभ_, _निजा, učen_,
   {{0x6d59e029,0x69c5602a,0x4426847f,0xa3d30072}},	//   thwa, _uthe, evo_, हीर_,
   {{0xa2cb0076,0x27eda911,0x6d4403a8,0x27e0602b}},	//   _त्त्, yren_, _xoia, bsin_,
   {{0x26d8602c,0x442982ba,0x2fc68282,0x27e05138}},	//   _fero_, ía_, _ntog_, csin_,
   {{0x67d4091c,0x6d59ddc2,0x26d82fa3,0xa3e88054}},	//   _фору, shwa, _gero_, _मटर_,
   {{0x21698544,0xa9699935,0x25b84125,0xa01b15c8}},	//   лики_, лика_, _gurl_, _työs,
   {{0xc692093f,0x27edbfae,0x7d09e02d,0x991580e8}},	//   _זאל_, tren_, _ubes, ські,
   {{0x6569ac07,0x27eda5e5,0x60db8e20,0x26d8602e}},	//   _imeh, uren_, raum, _yero_,
   {{0x27ed80ad,0x26c10207,0x75209a7b,0x33330118}},	//   rren_, ncho_, _zamz, _nnxx_,
   {{0x22958307,0xe81c8105,0xb87b001b,0xaa9580f7}},	//   _الاس, _बैठा_, _sdíl, _الاث,
   {{0x05561056,0x27e00009,0x27eda106,0x8d5627b9}},	//   стоя, ysin_, pren_, сточ,
   {{0x6c7980be,0xdb0d0144,0x65698870,0x7f43ce12}},	//   ראָפ, _atañ, _mmeh, _tonq,
   {{0x66018713,0x2be0816f,0x61f5029a,0x316d9139}},	//   ptlk, _निघा, fuzl, liez_,
   {{0x450d00c8,0x26d80578,0x44269d96,0xfbd200d5}},	//   ষয়ক_, _rero_, zvo_, _کتب_,
   {{0xf99f602f,0x27e06030,0x26d86031,0x31bc0019}},	//   _chè_, tsin_, _sero_, _víz_,
   {{0x26d86032,0x61431a34,0x41270698,0x4426241f}},	// [5b20] _pero_, чета, щото_, _éo_,
   {{0x27e05618,0xa01b0009,0x7989874c,0x6569a0b3}},	//   rsin_, _pyör, hoew, _ameh,
   {{0x27e03798,0x26d847c0,0x14c8803d,0x869a0087}},	//   ssin_, _vero_, لهای_, утат_,
   {{0x44268ed6,0xdb08826f,0xb5fa80be,0xd5fa80be}},	//   tvo_, _vidí, טלעכ, טפער,
   {{0x2a6e026c,0x307501a1,0x6d988118,0x75208084}},	//   _žfbh_, _дурс, bían, _vamz,
   {{0x8c1b0039,0x2d8d81bc,0x6d9883a8,0xa3da064a}},	//   טוני, _ekee_, cían, डीय_,
   {{0x316d80e7,0x201d810c,0x9f5f8036,0x6d9d0174}},	//   fiez_, _aswi_, ctué_, néac,
   {{0x657b820f,0xa517035a,0xa3d82c79,0x394000b9}},	//   _gjuh, _तसेच_, ाठा_, njis_,
   {{0x25bf0052,0x64a7016f,0x38606033,0xeafa80f7}},	//   _čuli_, _गणेश, nzir_, _مرات_,
   {{0xdbd42511,0xa91d8088,0xb35680d5,0x161d001b}},	//   _núñe, nožj, _دیتا_, फिचर_,
   {{0xab5b07d0,0xb0b806ae,0x00000000,0x00000000}},	//   nqüe, _अलंग, --, --,
   {{0x9f470a56,0x316de034,0x386000b9,0x06971101}},	//   čné_, ciez_, kzir_, מדים_,
   {{0xa3d30665,0x589680d5,0x25a06035,0x06e300ab}},	//   हीं_, _اجاز, _dhil_, ন্টি,
   {{0x39468079,0x661c806a,0x386000dd,0x0eba8e11}},	//   _hoos_, ærks, dzir_, _суды_,
   {{0xe5c696d4,0x26de9aae,0x3946e036,0x6d988511}},	//   _усло, mato_, _koos_, vían,
   {{0x26dee037,0x25a00219,0x7a0a811c,0x3946a525}},	//   lato_, _ghil_, _xəta, _joos_,
   {{0x39468069,0x656f6038,0x26c102d6,0x7d0d20af}},	// [5b30] _moos_, mich, tcho_, _ibas,
   {{0x656f6039,0x26de8dff,0x2d8b0081,0x26c1603a}},	//   lich, nato_, loce_, ucho_,
   {{0x6d98b1bd,0x26c1603b,0x21220326,0xf99f2d60}},	//   rían, rcho_, _fakh_, _thè_,
   {{0x656f603c,0xbcfb03d3,0x2d8b34a6,0x7ae8e03d}},	//   nich, ciét, noce_, _addt,
   {{0x26de9f05,0x7d0d603e,0xbcfb603f,0xdce601a9}},	//   kato_, _mbas, liés, nikā,
   {{0x656f1d1f,0xbcfb0019,0xdea4004e,0x752801a9}},	//   hich, gnéz, _کیمی, ēdzi,
   {{0x9f490307,0x7d0d39a8,0x656f6040,0x39468f1a}},	//   nraí_, _obas, kich, _boos_,
   {{0x7c2d6041,0x3946e042,0x656f588e,0x57e9a300}},	//   _orar, _coos_, jich, адим_,
   {{0x5fe2101c,0xa91d803e,0xf8ae8077,0x3946e043}},	//   _पिछल, ložk, نکه_, _doos_,
   {{0x7d0d2896,0x442d91d3,0x26dee044,0x8e099508}},	//   _abas, _ire_, gato_, анов_,
   {{0xb8ff80c8,0x656f6045,0x6e459980,0xe8d90a2c}},	//   _তা_, fich, ценз, ghị_,
   {{0xdb0d0125,0x63bbd777,0x656f6046,0xdce600eb}},	//   _stað, _kuun, gich, fikā,
   {{0x26deade6,0x66e58ff7,0xbcfb0333,0x63bb8074}},	//   bato_, _дола, viét, _juun,
   {{0x26de8698,0x63bbae05,0x78130105,0x7d0d0074}},	//   cato_, _muun, डबैक_, _ebas,
   {{0x9f4900f7,0x6d5d032f,0xed5a2097,0xa01b0198}},	//   graí_, bhsa, _вой_, _syöp,
   {{0x442d9429,0x68fbbb11,0x656f002a,0x3cff81c0}},	//   _ore_, ngud, cich, _ncuv_,
   {{0x6723829b,0x442de047,0xbcfb080d,0xdbd4002a}},	// [5b40] _kanj, _nre_, riét, _túñe,
   {{0x44206048,0x672384bf,0x752408bf,0xb3580065}},	//   _isi_, _janj, _haiz, _ایسا_,
   {{0x6723ae4d,0x442d873a,0xe61a2762,0xbcfb03b0}},	//   _manj, _are_, рде_, miér,
   {{0x67238867,0x442da009,0x629e0353,0xa01b0009}},	//   _lanj, _bre_, _izpo, _työp,
   {{0x3946e049,0x442dad2c,0x25a6acbb,0x7524544c}},	//   _roos_, _cre_, rmol_, _maiz,
   {{0x394684df,0x442da50e,0x656f604a,0x60c4025b}},	//   _soos_, _dre_, zich, lcim,
   {{0x442de04b,0x26de8698,0x39469d14,0x2d78875f}},	//   _ere_, vato_, _poos_, nček_,
   {{0x4420604c,0xdb088acf,0x442d9f6c,0x26de985b}},	//   _osi_, _didá, _fre_, wato_,
   {{0x6723e04d,0xb4e6a0f2,0x442d8db7,0x656f1af7}},	//   _banj, पणी_, _gre_, vich,
   {{0x656f0e83,0x68fbda1d,0x672384b9,0x10370039}},	//   wich, agud, _canj, קטים_,
   {{0x26dee04e,0x656f604f,0x6723a53d,0xdd9501bb}},	//   rato_, tich, _danj, заны,
   {{0x26dee050,0x60c4012b,0xe7f38072,0x6d42e051}},	//   sato_, jcim, _आमचा_, njoa,
   {{0x656f6052,0x26dee053,0x6d988388,0xaade881f}},	//   rich, pato_, víal, _नजाक,
   {{0x656f6054,0x68e0e055,0x7c2d0168,0x6d989e00}},	//   sich, lamd, _vrar, díam,
   {{0x44206056,0x7524284e,0xf96b0b69,0x3f8ce057}},	//   _esi_, _faiz, арай_, modu_,
   {{0x9f490013,0xd1380470,0x7c2d3e3d,0x4cd500ab}},	//   rraí_, оху_, _trar, _থাকু,
   {{0x656d043b,0x7c2d1c88,0x6723e058,0x27f22cd4}},	// [5b50] _imah, _urar, _yanj, gryn_,
   {{0x4e1e8996,0x68e09067,0x442de059,0x75240102}},	//   _बनाई_, hamd, _rre_, _zaiz,
   {{0x63bb83ff,0x7bc99ab0,0x442d8b89,0x672500f1}},	//   _suun, _steu, _sre_, rdhj,
   {{0x442de05a,0x3f8cc4dd,0x26dc84c4,0x6d98a706}},	//   _pre_, hodu_, _levo_, bíam,
   {{0x9f400876,0xdb0405e4,0xbcfb00e7,0x6d98818a}},	//   guió_, _guió, chée, cíam,
   {{0x442d8247,0x656d0122,0x777a81c0,0x67ba01c6}},	//   _vre_, _lmah, jntx, _למשק,
   {{0x7de00065,0x5694102a,0x656d003d,0x7c26a46d}},	//   _vásá, _жарт, _omah, _škrt,
   {{0x442daca0,0x627c012a,0x60dd0668,0xceba80fc}},	//   _tre_, ינונ, _jesm, _baƙo_,
   {{0x60dd156b,0x442de05b,0x67238d54,0x6d5b83ca}},	//   _mesm, _ure_, _panj, _ilua,
   {{0xf8b8150e,0x656d01d4,0x60dd5818,0x6d5b81e9}},	//   _अल्प, _amah, _lesm, _hlua,
   {{0x6723e05c,0x4420605d,0x26dca349,0x6d5b8590}},	//   _vanj, _ssi_, _devo_, _klua,
   {{0x7d19e05e,0x670b19e8,0x60dd3732,0x070b26ee}},	//   news, स्तक_, _nesm, स्तव_,
   {{0x6723e05f,0x752401e2,0x60c4005c,0xbcfb157a}},	//   _tanj, _vaiz, vcim, tiér,
   {{0x44200db7,0x8ccc06ab,0x656d01f6,0xef1881a9}},	//   _vsi_, _थ्रो, _emah, ceļ_,
   {{0xbcfb003e,0xb87b0264,0x60c40669,0x6d9d3dcd}},	//   riér, _leíd, tcim, méan,
   {{0x442001e9,0x629e3c49,0x216716df,0xa96703bc}},	//   _tsi_, _vzpo, писи_, писа_,
   {{0xb4d81094,0x4420180b,0x1dd78105,0x46ea0cf9}},	// [5b60] िरी_, _usi_, भीरत, йдан_,
   {{0xf7721e95,0x60c41577,0xd7ef00f7,0xc2ea0065}},	//   راء_, scim, اكل_, _اعظم_,
   {{0x60c4005c,0x7abb0039,0x395f816d,0x9cca8fe6}},	//   pcim, _לציו, khus_, была_,
   {{0x6d5b832f,0xb4e6816f,0x60dd074c,0xeeeb00ff}},	//   _clua, पणे_, _gesm, _đụng_,
   {{0x395fe060,0x6d5bc88c,0x6d428009,0x29e80713}},	//   dhus_, _dlua, rjoa, lğa_,
   {{0xa09b03de,0x670300a5,0x6d5b82f1,0xa2948a4c}},	//   _ליכט, _लायक_, _elua, малі,
   {{0x3f8c9249,0x3ce2017f,0xc7a30087,0xceba89ab}},	//   vodu_, kakv_, _чирк, _saƙo_,
   {{0x6d5b808c,0xdb0401df,0x3f8c809a,0x6d498197}},	//   _glua, _muiñ, wodu_, _goea,
   {{0x68e082b8,0xb4ca8f97,0x36d4bcb3,0x3f8ce061}},	//   ramd, ोरी_, мопр, todu_,
   {{0x3eb88bc5,0xe29281a8,0x23a40338,0x2d83128a}},	//   ørt_, _كذا_, nöjd_, čkem_,
   {{0xe7e88074,0xd6d78198,0x7a0a829a,0x00000000}},	//   _टटका_, чты_, _xətl, --,
   {{0x395fe062,0xd5b78198,0x23a40338,0x6ecc8bbc}},	//   chus_, ясь_, höjd_, _द्रु,
   {{0x60dd6063,0x1b1f80ab,0x8ca48035,0x2d800176}},	//   _resm, পারে_, _औरफो, _djie_,
   {{0xda20816f,0x2fcb0267,0xa91d976d,0x7c2d8085}},	//   _मनात_, _rtcg_, voži, çirə,
   {{0x60dd1108,0x6e93b5b4,0xdb04002a,0x62340087}},	//   _pesm, _пишу, _cuiñ, неру,
   {{0x9f4703bb,0xf67b8039,0x656d13fa,0xa3da06a7}},	//   ční_, _לאומ, _umah, डीह_,
   {{0xb8d503eb,0x60dd1e1e,0x81bc81a9,0x57b5302b}},	// [5b70] _छः_, _vesm, _krēs, дбат,
   {{0xb8f4023c,0x657d1c33,0x64d581cb,0x6d5b8c49}},	//   _स्_, lnsh, दर्श, _slua,
   {{0x6d5b8069,0x6d5a8110,0xdb040333,0x0ea700d4}},	//   _plua, _įtar, _guiñ, केंड,
   {{0x6b4fd9c6,0x7f94823e,0xa91d81d6,0x5c759ae1}},	//   _løgt, màqu, poži, млет,
   {{0x69da82a6,0x45270264,0x2bdd864a,0x6b500338}},	//   _awte, যাপক_, _नौशा, _vägv,
   {{0x97351e29,0x883a01c6,0xe7871a19,0x20090084}},	//   _تکرا, _ותשו, _хумо, mtai_,
   {{0x6fd5823c,0xc9a982de,0x395facd4,0x225480e1}},	//   _मौजू, овке_, thus_, _čaká_,
   {{0x2129059c,0x394b009f,0x67271369,0x17c99ccf}},	//   ndah_, _jocs_, _hajj, огии_,
   {{0x200916d5,0x395f90a9,0x7bcd01e9,0xf53f0aa2}},	//   ntai_, rhus_, _ntau, rmål_,
   {{0x2d8f84c4,0xf53f035f,0x2d92051e,0x395f8bbd}},	//   loge_, smål_, _skye_, shus_,
   {{0x7bcd34c6,0x7ae38d88,0x395fe064,0x67276065}},	//   _atau, mant, phus_, _majj,
   {{0x200901e2,0xa2cb0075,0x61f500d2,0x26c5802a}},	//   ktai_, तुस्, drzl, sclo_,
   {{0x21296066,0x26c7ad16,0x6b548362,0x660d80c3}},	//   ddah_, _tfno_, _bàgh, _ćaku,
   {{0xfaa60729,0x21290748,0x5eb780ab,0x2d995e14}},	//   даго, edah_, _আজকে, alse_,
   {{0x6dbe01ac,0xeb97087e,0xe0df01e4,0xdb040333}},	//   _vďak, фир_, _beò_, _quiñ,
   {{0x7ae3e067,0x29e8029a,0x2d1c816f,0x61ee806a}},	//   hant, rğa_, _नसेल_, _æble,
   {{0x62856068,0x490f801b,0x67276069,0xd00717c8}},	// [5b80] _exho, थ्यो_, _bajj, мете_,
   {{0x7ae392b9,0x7c24606a,0x6d46011f,0x2d789024}},	//   jant, _isir, ljka, nčev_,
   {{0x4432003e,0x672707d5,0x5b5701c6,0x394b51fb}},	//   _hry_, _dajj, _חייב_, _focs_,
   {{0x4432079f,0x6e239c33,0x2b008054,0xb4ca9344}},	//   _kry_, _msnb, _राहु_, ोरे_,
   {{0x68e40739,0x7ae3bc72,0x7c83a481,0x6c1a8bbe}},	//   maid, fant, куше, تتاح_,
   {{0x68e4606b,0xf8bf11b9,0x7c2404cd,0x6aa582f1}},	//   laid, _jaén_, _msir, गे्र,
   {{0x7d0402a5,0x61fc606c,0x6f1a81a1,0x7bdb9a14}},	//   _ocis, nurl, vetc, _ewuu,
   {{0xbea32c9f,0x29002810,0x68e412be,0x2d8f86a5}},	//   _раск, ngia_, naid, coge_,
   {{0x7ae3e06d,0x02cf9299,0xdb088198,0x7306b511}},	//   bant, _स्वभ, _pidä, _опаз,
   {{0x68e4154c,0xb3568077,0xddc90087,0x61fc606e}},	//   haid, _زیبا_, _înţe, kurl,
   {{0x7bc0b3ef,0x7c24606f,0x36f70039,0x7bcd1831}},	//   _humu, _asir, וצים_, _stau,
   {{0x7bc09f34,0xc0a9817e,0x4432267f,0x61fc6070}},	//   _kumu, _کامل_, _bry_, durl,
   {{0x7bc08010,0x68e40014,0xa3da016f,0xe043a482}},	//   _jumu, daid, डील_, _инци,
   {{0xfe6f9125,0x289b8051,0x7bc0a2a3,0x4424bd93}},	//   ادی_, _וידא, _mumu, _msm_,
   {{0x443202ec,0x7c2450c2,0x68e41b7c,0x7bc0a34d}},	//   _ery_, _esir, faid, _lumu,
   {{0x7ae3e071,0x68e46072,0xbcfb0013,0x29000098}},	//   zant, gaid, bhéa, ggia_,
   {{0x7d1d6073,0x7ae3e074,0xc05b035f,0x4432009a}},	// [5b90] mess, yant, ців_, _gry_,
   {{0x20096075,0x7d1d2b52,0x628501e9,0xdce9911b}},	//   rtai_, less, _txho, _rjeđ,
   {{0xb905150b,0x20092024,0xfad60051,0x8aa71bc1}},	//   _না_, stai_, _אותך_, _юрид,
   {{0x68e46076,0x7bc0c45b,0xe51000ff,0x67270c2e}},	//   caid, _bumu, _lặng_, _wajj,
   {{0xa3d3016f,0x67276077,0x4424e078,0x0c7580d7}},	//   हीच_, _tajj, _csm_, رگرد,
   {{0xe510001c,0x7bc08077,0xfaa595a4,0x27e957c4}},	//   _nặng_, _dumu, нало, msan_,
   {{0x27e92973,0x41b589e0,0xb87b016a,0x7d1d6079}},	//   lsan_, нсит, _edít, kess,
   {{0xd2b80051,0x349594b7,0x4424c264,0x27e9117d}},	//   ולות_, _забр, _fsm_, osan_,
   {{0x27e95c6d,0x7d1d03ff,0x7bc0ad80,0xa2ca8128}},	//   nsan_, dess, _gumu, _स्क्,
   {{0x27e95537,0x6b50016d,0xd7098009,0x6d59e07a}},	//   isan_, _lägr, чное_, lkwa,
   {{0x7bc0c675,0x7d1d3261,0x6dac83bf,0xcf9204de}},	//   _zumu, fess, _işar, רטי_,
   {{0x27e9607b,0x7ae1a3f8,0x26070665,0x90e7826a}},	//   ksan_, _helt, _हमनी_, _آسان,
   {{0x7ae18f52,0x649a13d7,0x6d4d00b9,0x6d598041}},	//   _kelt, ятор_, _doaa, ikwa,
   {{0x61fc0082,0x6b5487e2,0xdb1c0201,0x68e4022e}},	//   turl, _pàgi, _özün, waid,
   {{0x2d960b9c,0x68e40739,0x69c183ba,0x6d59e07c}},	//   _прис, taid, _jule, kkwa,
   {{0x7d1d20ef,0x60c9c73a,0xdb01a489,0x64401bda}},	//   cess, ncem, _kiló, ämis,
   {{0x68e40219,0x69c18aa8,0x27e902a3,0x6d598041}},	// [5ba0] raid, _lule, gsan_, dkwa,
   {{0x68e4607d,0x6d59e07e,0x6d5d03ed,0x1aea0264}},	//   said, ekwa, ërav, ঞ্জে_,
   {{0x7bc0c18f,0xaadb0051,0x27e93d84,0x44248abf}},	//   _sumu, _מחיר, asan_, _ssm_,
   {{0x9f471dc1,0x27e90079,0x7bc0809c,0xac869cff}},	//   čná_, bsan_, _pumu, нгел,
   {{0x3d120b86,0xdca38aac,0xb87b0073,0xe505275c}},	//   ध्ये_, гаци, _veíc, ष्टि_,
   {{0x69c1e07f,0x6562ceb6,0x7d1d6080,0xf48782e3}},	//   _bule, shoh, zess, رانی,
   {{0x7ae18370,0x752980b9,0x69c1e081,0x1e950256}},	//   _delt, _faez, _cule, _артр,
   {{0x7bc0e082,0xd90e815b,0x69c1e083,0x44220573}},	//   _tumu, صیت_, _dule, kwk_,
   {{0x7ae1dccf,0x7d1d3666,0x442480ee,0x7c248059}},	//   _felt, vess, _usm_, çird,
   {{0x7d028118,0x7c22e084,0x7ae1e085,0x7d1d6086}},	//   lgos, mwor, _gelt, wess,
   {{0x26c7005c,0x1600809a,0x6dba8197,0x69c804e8}},	//   žnog_, लंधर_, _aċar, ídel,
   {{0x7d02e087,0x63ba803a,0x27e902a3,0x7a0a8201}},	//   ngos, _hitn, ysan_, _nəti,
   {{0xf4840abe,0xe5100028,0x69c182af,0x27e92fc7}},	//   гурн, _tặng_, _zule, xsan_,
   {{0xdbc78006,0x5b240b79,0xb4bb0180,0x6f1e0140}},	//   _tööt, льса, _کاغذ_, jepc,
   {{0xd0560201,0x7d1d2660,0xf1a73197,0x399a8168}},	//   mayə, pess, еран, tësh_,
   {{0x7c229328,0x673c06c4,0xceba8326,0x63ba9c77}},	//   kwor, _anrj, _naƙi_, _litn,
   {{0x442f1c86,0x6b50016d,0x399a8168,0x7d02e088}},	// [5bb0] _ég_, _vägr, rësh_, dgos,
   {{0x27e93dd5,0x7f4e01c0,0x2d84b5ca,0xd0560085}},	//   rsan_, _cobq, _ajme_, nayə,
   {{0x7ae7179d,0xceba8300,0xf74801a8,0x6d59890d}},	//   majt, _baƙi_, علمي_, tkwa,
   {{0x7ae1e089,0x442f84c3,0x7a0a8201,0x9f400020}},	//   _selt, tvg_, _gəti, frió_,
   {{0x63ba803a,0x6d59800b,0xd0560085,0x7c22e08a}},	//   _bitn, rkwa, kayə, gwor,
   {{0x629a8831,0xe299891d,0x7ae7608b,0x69c1e08c}},	//   _byto, мал_, najt, _pule,
   {{0x7ae1afb1,0xc33404de,0x38693b40,0xee840198}},	//   _velt, טוס_, lzar_, _быто,
   {{0x7ae1e08d,0x9f40349a,0xdb17002a,0x6ecd00d4}},	//   _welt, brió_, _dixé, दुरु,
   {{0x212b285f,0x3869608e,0x7c228358,0x7ae70619}},	//   _mach_, nzar_, cwor, kajt,
   {{0x69c1a47f,0x25a9011e,0x63ba809c,0x7ae70796}},	//   _tule, _ahal_, _gitn, jajt,
   {{0x39158077,0xa2ca9053,0xdb01c649,0x799b96fb}},	//   _لواز, _स्ट्, _filò, pluw,
   {{0x212b1769,0x2019061b,0x25a9608f,0x2d7880c3}},	//   _nach_, _opsi_, _chal_, lčer_,
   {{0x0d8307a1,0x6e270338,0x644fe090,0x63ba89c4}},	//   рлян, _lsjb, _àcid, _yitn,
   {{0x93fa804c,0x987a80be,0x386900dd,0x7ae71924}},	//   ולשי, _קאסט, dzar_, gajt,
   {{0xe2970468,0x212b0114,0x27ff8009,0x200d8afc}},	//   вар_, _bach_, luun_, ltei_,
   {{0x212b4045,0x399a8168,0x25a901b9,0x68e2802a}},	//   _cach_, tësi_, _ghal_, _xeod,
   {{0xf5770013,0x200db296,0x8c464845,0x7ae735bf}},	// [5bc0] _جميع_, ntei_, _репе, bajt,
   {{0x93fb0158,0x4438827f,0x212b36d3,0x7bfb0039}},	//   _קליי, _čr_, _each_, _קפיצ,
   {{0x212b278c,0xb87b0333,0x3869016a,0x63ba8bcb}},	//   _fach_, _veía, azar_, _ritn,
   {{0x212b1523,0x63ba803a,0x7c228367,0x27ff8009}},	//   _gach_, _sitn, twor, kuun_,
   {{0xa3dd816f,0x0b8a8abe,0x61eaba65,0x938a867c}},	//   थील_, мски_, wsfl, мска_,
   {{0x67138f97,0x9f401d24,0x61ea848d,0x629a839c}},	//   त्मक_, rrió_, tsfl, _pyto,
   {{0xf50696cf,0x212b0101,0x63baa406,0xd5b285ff}},	//   _изво, _yach_, _vitn, _نفس_,
   {{0xdb09a423,0xf98f80f7,0x2d540187,0xdb1703a8}},	//   _dueñ, يبي_, _mães_, _vixé,
   {{0xdefa8162,0xc17304de,0x6dac8085,0x290680b9}},	//   мын_, יחה_, _uşaq, _vcoa_,
   {{0x63ba8cfa,0x7d1601d0,0x5ba78012,0x473386d2}},	//   _uitn, _abys, _акум_, аньс,
   {{0xb9088a49,0x386927be,0x0f5701c6,0x6b7b83c8}},	//   _বা_, zzar_, דיים_, _קרבנ,
   {{0xdced026c,0x7bc45ad8,0x6d988118,0x9f4d802a}},	//   _tmač, _buiu, mías, rreá_,
   {{0x7ae70b48,0x212b6091,0x7bc418ad,0x06e800ab}},	//   tajt, _rach_, _cuiu, _পানি,
   {{0x27f980e1,0x69c30061,0x212b6092,0x7bc45ad8}},	//   ásne_, _ének, _sach_, _duiu,
   {{0xda780656,0xb87b0032,0x31c400c4,0x2d540187}},	//   вят_, _adíp, иств, _cães_,
   {{0x38696093,0x3f9ecc11,0x656647d0,0x99640012}},	//   tzar_, lltu_, chkh, атул,
   {{0x212b36b0,0x394902f1,0x7ae70968,0x6ca40162}},	// [5bd0] _vach_, rjas_, pajt, _врэж,
   {{0x44296094,0xdb1a820f,0x386949d8,0xf77012c5}},	//   _isa_, _ditë, rzar_, يال_,
   {{0x3a8407ac,0x733a00be,0x212b6095,0xed5980c3}},	//   _выяв, _װערס, _tach_, _liže_,
   {{0x6d5d6096,0x6d98a363,0x38690144,0x867b81c6}},	//   nksa, días, pzar_, ורבו,
   {{0xdb0985b4,0xed598052,0x752d2c07,0x7ae50006}},	//   _sueñ, _niže_, _maaz, _keht,
   {{0x4209a964,0x69c500b8,0xb464804a,0x3d0882f1}},	//   енко_, _kuhe, шкіл, _हाथे_,
   {{0xe296bcb3,0x69c502f1,0x291f8c53,0xdb019ee0}},	//   лаш_, _juhe, teua_, _uhlí,
   {{0x4429043d,0x7ae51453,0x69c54141,0xc8798087}},	//   _osa_, _leht, _muhe, laşi_,
   {{0x7d098a03,0x69c503ed,0x7ae502f9,0xdce28965}},	//   _ices, _luhe, _oeht, lioğ,
   {{0x7c29e097,0xed59812b,0x200de098,0x7ae501d0}},	//   _iser, _diže_, rtei_, _neht,
   {{0x44296099,0x200d895d,0x394f8106,0x1d0a0081}},	//   _asa_, stei_, _togs_, нени_,
   {{0x25624b9b,0xd76382e3,0x200d995c,0xaca38133}},	//   _bóla_, انگی, ptei_, _nrịa,
   {{0xff53803d,0xe72ec2c4,0x60dbd88b,0xe8d9019d}},	//   _پخش_, _ле_, mbum, akị_,
   {{0x752f0063,0x27ed8ed0,0x60dbe09a,0x69c5609b}},	//   adcz, msen_, lbum, _buhe,
   {{0x4429040e,0x27ed8f06,0x6721dcdc,0x6b5dadb2}},	//   _esa_, lsen_, melj, _règl,
   {{0x69c508cf,0x660182a3,0x6d5d1647,0x98a0005c}},	//   _duhe, mulk, cksa, ndić_,
   {{0x27edd280,0x43761597,0xa067013a,0x999e0019}},	// [5be0] nsen_, _бунт, гата_, ítő_,
   {{0x7d09e09c,0x27ed95ec,0x6459809a,0x324604ae}},	//   _aces, isen_, dywi, _беог,
   {{0x2776893f,0x7c29c6c7,0x670688fd,0x68e982c4}},	//   נגען_, _aser, _शासक_, kaed,
   {{0x27edbe74,0xd9460aac,0x98a00042,0x7d098118}},	//   ksen_, _семи, jdić_, _cces,
   {{0x5ee300c8,0x7c298019,0x4d7b00be,0xbebc80eb}},	//   _পারে, _cser, ערנע, ldīt,
   {{0x53348676,0x67218025,0x27ed8aaa,0x6be380f7}},	//   рект, jelj, dsen_, حكوم,
   {{0x6721e09d,0x7c29e09e,0x3d050d38,0x96660470}},	//   delj, _eser, _वाले_, _скве,
   {{0x68e9e09f,0x63be60a0,0x6d989d3a,0xaca42d10}},	//   gaed, _lipn, rías, _akọw,
   {{0xa3cb80cf,0x68e601a1,0xb6e685e9,0x6d40ba84}},	//   _रूप_, _mekd, люнк, _inma,
   {{0x66e40af3,0x25620019,0x75228118,0x656401f8}},	//   गरिक_, _róla_, leoz, _alih,
   {{0x49068f99,0x3eb8e0a1,0x6601808e,0x98a0026c}},	//   _مواق, ärt_, gulk, bdić_,
   {{0x69c529d6,0xdd9501e5,0xafe6be3d,0x27ed9433}},	//   _ruhe, рамы, _бодл, bsen_,
   {{0x6d5d1614,0xb99396a5,0xc99380f7,0x442690ab}},	//   rksa, _النب, _النظ, nwo_,
   {{0x69c50364,0x0703009a,0x442960a2,0xdcef0087}},	//   _puhe, _लाइव_, _vsa_, fică,
   {{0x60cd093d,0x6459809a,0x69c500f1,0xdb1ae0a3}},	//   tcam, zywi, _quhe, _cité,
   {{0x442901c5,0x2608035a,0x7aea82af,0x29ca8028}},	//   _tsa_, ांनी_, haft, _mùa_,
   {{0x442960a4,0x60cd157a,0x7ae560a5,0x9f4021f2}},	// [5bf0] _usa_, rcam, _teht, ksiä_,
   {{0x442695ab,0xa3da1834,0x6e2a826c,0x69c5405e}},	//   dwo_, डीओ_, _ksfb, _tuhe,
   {{0x7aeae0a6,0x57a42306,0xe4d58290,0x539c01c6}},	//   daft, сшта, لقاد, _איזו,
   {{0x60c29281,0x89da007c,0x7c299fa4,0x6459866f}},	//   _ngom, _שחרי, _pser, tywi,
   {{0x1aee80c8,0x8c459af6,0x705801e5,0x29190118}},	//   চ্ছে_, реле, _баяр_, _ibsa_,
   {{0x6459ce06,0x6d4085e4,0xb60600cd,0x60c29f78}},	//   rywi, _enma, _bišć, _agom,
   {{0xdb0180f7,0x29190267,0x06e380ab,0x27ede0a7}},	//   _chlá, _kbsa_, _মালি, wsen_,
   {{0x44268578,0x7d09876c,0x7c2984b9,0xaca3026b}},	//   bwo_, _uces, _tser, _ajọf,
   {{0x84678698,0xdb0d0118,0x98a000ce,0x27ed8456}},	//   _съве, _luañ, rdić_, usen_,
   {{0xee39952a,0x27ed82fe,0x6601e0a8,0xf77188ca}},	//   вно_, rsen_, tulk, تاب_,
   {{0x27ed977a,0x3ea5816c,0x2ca90085,0x67218968}},	//   ssen_, ринг, _azad_, relj,
   {{0xa3a985e8,0x27ed9c50,0x51849444,0xc9849afa}},	//   _गीत_, psen_, _луча, _лучи,
   {{0x6721881d,0x6601a3be,0x452700ab,0xa3b1016f}},	//   pelj, sulk, যাংক_, _ओळख_,
   {{0x394dc2ed,0x68e660a9,0xb4e50105,0xdb1abd9b}},	//   ljes_, _sekd, _पड़ी_, _pité,
   {{0x09e6035f,0xa3da0540,0xc7c8801c,0x2d8b00e7}},	//   робн, डीज_, _tốc_, ébec_,
   {{0x629e026f,0x395f8110,0x394d88b2,0x61ee2a33}},	//   _vypo, nkus_, njes_, rsbl,

   {{0x629e0063,0x386d9f8e,0x3fc8004e,0x395f9d46}},	// [5c00] _wypo, nzer_, ادری_, ikus_,
   {{0x629e5518,0x13cc80ab,0x386dd76f,0xe0df0176}},	//   _typo, রীড়, izer_, _anòd_,
   {{0x394da9af,0x395f8074,0x6d988118,0x7626072a}},	//   kjes_, kkus_, fíap, рмез,
   {{0xf1bf0142,0x44268063,0xe45a8364,0x61fc8f06}},	//   _giá_, two_, кже_, _årli,
   {{0x394dc5ba,0xac07c90d,0xd24f02e3,0x386d80f3}},	//   djes_, инца_, _فنی_, jzer_,
   {{0x4426e0aa,0x60c2847f,0x2ca000b9,0x395f81a9}},	//   rwo_, _sgom, _myid_, ekus_,
   {{0x661c1c67,0x7aeaafd7,0x25bf8087,0x46aa0074}},	//   _uprk, raft, _fiul_, _करिह,
   {{0x6d40ab02,0xb6060267,0x394daf34,0xed57a503}},	//   _unma, _višć, gjes_, _кос_,
   {{0xed578ca4,0x7f9d80e7,0x20120198,0x777a8cdb}},	//   _тот_, hèqu, ntyi_, titx,
   {{0xc3068061,0x38170039,0x200b809f,0x394d81ca}},	//   _خبرو, סקים_, àcia_, ajes_,
   {{0x56948d0f,0xed5980c3,0x777aac03,0xb87b0144}},	//   сант, _hiža_, ritx, _reím,
   {{0x60c28435,0xdb17002a,0xdb1e0580,0x69c8e0ab}},	//   _ugom, _vixí, _hipè, _iude,
   {{0xd007a6ad,0x80dd80c8,0xb7d49c12,0x69c8a069}},	//   _вече_, _যাচ্, _اقتب, _hude,
   {{0x69c88102,0x200480eb,0x93880198,0x2717128a}},	//   _kude, mumi_, асса_, _mění_,
   {{0x69c88012,0x2004bd3d,0x7ae8e0ac,0x2b099008}},	//   _jude, lumi_, _medt, _सासु_,
   {{0x69c8e0ad,0xeeeb00ff,0xd5430032,0x7ae8a9c6}},	//   _mude, _đựng_, _dẹ́b, _ledt,
   {{0x657d60ae,0xb4e303db,0x2d9960af,0x2004c561}},	// [5c10] mish, धरी_, mose_, numi_,
   {{0x2d9960b0,0x69c885f8,0x7c2d3143,0x657d2840}},	//   lose_, _oude, _isar, lish,
   {{0x20049090,0x645d0039,0xcf9383de,0xa1950c99}},	//   humi_, lysi, קטע_, _ганч,
   {{0x2d9902a5,0x2004e0b1,0x657d3418,0xe57080f7}},	//   nose_, kumi_, nish, وطن_,
   {{0x20048341,0x68ed26dc,0x3d088105,0xa6be80ab}},	//   jumi_, maad, _हारे_, োরিয়,
   {{0x657d364e,0x68ed26dc,0xb5c90875,0x2004e0b2}},	//   hish, laad, _موسم_, dumi_,
   {{0x657d38ef,0x394d95ca,0x7d0d11b9,0xd5bb98d1}},	//   kish, tjes_, _ocas, _аса_,
   {{0x386de0b3,0x68ed429a,0x7d0d0388,0x290960b4}},	//   tzer_, naad, _ncas, ngaa_,
   {{0x25621220,0x2d990511,0x657d13a2,0x394d80f1}},	//   _sólo_, dose_, dish, rjes_,
   {{0x394da9af,0x395f9371,0x7d0d60b5,0x69c883a7}},	//   sjes_, skus_, _acas, _fude,
   {{0x386d8065,0x7c2d60b6,0x68ed60b7,0x394d9696}},	//   szer_, _asar, kaad, pjes_,
   {{0x657d02a0,0x7a7a8158,0x645d60b8,0x20120009}},	//   gish, _גרעס, fysi, ytyi_,
   {{0x7d1be0b9,0x7bc18e01,0x68ed02ab,0x69c881ec}},	//   _mbus, _kilu, daad, _zude,
   {{0x1dcf89a3,0x660507d5,0x6d4b0247,0xb47a80be}},	//   _संपत, kuhk, _ògan, אָלי,
   {{0x657d38ef,0x7bc194f0,0x7d1b8a40,0x69c88509}},	//   bish, _milu, _obus, _xude,
   {{0x442d820f,0x7c3b9998,0x66050b20,0x68ed60ba}},	//   _ose_, _orur, duhk, gaad,
   {{0x69d7011e,0x442d8091,0xef1a09a0,0x6d44076d}},	// [5c20] _etxe, _nse_, лма_, _inia,
   {{0x6d440282,0x7bc1b496,0xed5996f2,0x9f4001a8}},	//   _hnia, _nilu, _riža_, lsiú_,
   {{0x442de0bb,0x6d560b8e,0xb3bb0039,0x6605010b}},	//   _ase_, _koya, _תמיכ, guhk,
   {{0x69c8e0bc,0xdb1b807b,0x6d5660bd,0xbcfb00f7}},	//   _rude, _stuð, _joya, théi,
   {{0x69c8b5aa,0x6d5610e1,0x69dc14fb,0x9f4001a8}},	//   _sude, _moya, lpre, isiú_,
   {{0x636b0459,0x6605208b,0x657d13a2,0x442060be}},	//   _günd, buhk, zish, _mpi_,
   {{0x657d1b8f,0x44202168,0x7ae880e8,0xdb088118}},	//   yish, _lpi_, _vedt, _sidó,
   {{0xf1268cde,0x442022cd,0x6d5660bf,0x2d9901df}},	//   сько, _opi_, _noya, xose_,
   {{0xa49484c0,0xdce9a3e3,0x96ea81d9,0x657d39d6}},	//   _بیشت, _smeć, льна_, vish,
   {{0x2004e0c0,0x543b8158,0x160c0665,0x7bc1e0c1}},	//   rumi_, _געמא, _हमार_, _gilu,
   {{0x657d60ae,0xa3e481fe,0x442009ca,0x69c88364}},	//   tish, भीर_, _api_, _uude,
   {{0xd567140b,0x69dc60c2,0x2d990110,0x6b5d8722}},	//   стоп, dpre, uose_, _règi,
   {{0x657d3149,0x6d56572d,0x9743825b,0x7d0d60c3}},	//   rish, _doya, _šćep, _vcas,
   {{0x657d60c4,0x68ed60c5,0x645d60c6,0x69dc2a1d}},	//   sish, waad, rysi, fpre,
   {{0x44200205,0x657d0010,0x69dc1400,0xa77b8039}},	//   _epi_, pish, gpre, _תרופ,
   {{0x7c2d03c3,0x657d00f1,0x44201142,0x636b0074}},	//   _tsar, qish, _fpi_, _sünd,
   {{0xb8d1101b,0x68ed26a5,0x7c2d60c7,0x7aee0079}},	// [5c30] _ओर_, raad, _usar, babt,
   {{0x66050877,0x442de0c8,0x68ed60c9,0x80d91299}},	//   tuhk, _rse_, saad, _फ्रे,
   {{0x656b8c41,0x65628088,0x63a3816b,0x442de0ca}},	//   thgh, fkoh, vlnn, _sse_,
   {{0x442d820f,0xd126826a,0x9c39a155,0xe7ed0540}},	//   _pse_, _غم_, ипет_, _चौथा_,
   {{0xe3b18277,0x7bc98051,0x6aa18114,0x44200122}},	//   ورت_, _queu, _sylf, _xpi_,
   {{0x442da52d,0x31b38526,0xc1ed02f1,0x7d1b82f7}},	//   _vse_, ुद्ध, _जबाब_, _wbus,
   {{0x27e68324,0x81cb00c8,0x636b03bf,0x3e4e811c}},	//   _awon_, রীর_, _güne, bəti_,
   {{0x442d8069,0x7d1ba9da,0xc7c8801c,0x27ffce30}},	//   _tse_, _ubus, _vốn_, trun_,
   {{0x442d8051,0x7c3bb090,0x7d0481a8,0x69c2811b}},	//   _use_, _urur, óise, _dioe,
   {{0x6d5642e1,0x2d8b0019,0x69dc02d5,0x70c61834}},	//   _soya, ében_, ypre, _वल्ल,
   {{0xda02800f,0x69dc60cb,0xc7c88129,0x27e6a17b}},	//   रूआत_, xpre, _uốn_, _ewon_,
   {{0x80d90540,0x69dc007a,0x261a82f1,0x69c280e5}},	//   _फ्ले, vpre, _बहरी_, _gioe,
   {{0x6d5603d3,0x333301b9,0x9f35804a,0x00000000}},	//   _voya, _baxx_, _меді, --,
   {{0x4375333d,0xf99f0032,0x7989bcc0,0x69c28cdb}},	//   пуст, _akè_, lnew, _zioe,
   {{0xa3cb800f,0x65699295,0x6d56450b,0x06e800ab}},	//   _रूस_, _oleh, _toya, _পালি,
   {{0x44203cf2,0xe0da1289,0x7aee1801,0x6d441fd8}},	//   _tpi_, рва_, sabt, _unia,
   {{0x69dc60cc,0x46ea0088,0x98a3153d,0x88bd809a}},	// [5c40] spre, идан_, дите, ześn,
   {{0xbf878104,0x7c248059,0x81df80ab,0x799b80f3}},	//   _điện_, çirm, _তিন_, houw,
   {{0x2018802e,0x316d8019,0x644100eb,0xdd8f003d}},	//   ării_, khez_, ālie, _سوی_,
   {{0xcbd580c8,0x96da01fe,0x68eb803a,0xdce40503}},	//   _হয়েছ, _प्रॉ, _negd, _olič,
   {{0xead493cd,0x656280f1,0x7989e0cd,0xc2f380ab}},	//   поль, rkoh, dnew, চ্ছি_,
   {{0x47c30698,0x65628100,0x69c302be,0x9c8305b9}},	//   _обяв, skoh, _éner, _účel,
   {{0xdce4026c,0xe1ef80f7,0x291d838a,0xf96a802e}},	//   _alič, نسي_, _bbwa_, ирий_,
   {{0xdced1c67,0x387f00d2,0x6b9c2126,0xf99f01e8}},	//   _imać, _žuri_, horg, _xkè_,
   {{0x6da390ee,0x6b9c60ce,0x38603798,0xe5a395e0}},	//   _цита, korg, nyir_, _цити,
   {{0x25620125,0x636b5a0b,0xdea38326,0x25a6e0cf}},	//   _fólk_, _münc, _hanƙ, llol_,
   {{0xe8a715fb,0x799b838e,0xdce43a98,0xe80c0ad5}},	//   _खर्च, bouw, _amiđ, िंडा_,
   {{0x69dae0d0,0x316d8036,0xd1308180,0xe45f0198}},	//   _itte, chez_, _سمت_, työ_,
   {{0xd5b802c7,0xbcfb0019,0x6b9c60d1,0x1ae20264}},	//   юсь_, bkén, forg, _বাড়া,
   {{0xa3b08063,0x7980914c,0x39468144,0xdea380fc}},	//   _टीम_, limw, _hnos_, _lanƙ,
   {{0x2d878019,0x0eba8084,0xda34014c,0x7ed39ef5}},	//   ének_, _туды_, меры, _غزوا,
   {{0x3495177f,0x6608dc52,0xd5cf86ae,0x26c701d6}},	//   _найр, mudk, _संतज, ľnom_,
   {{0x6b9c0bcb,0xb4d70074,0x656f00f7,0xc6f909c7}},	// [5c50] borg, िडी_, mhch, йнах_,
   {{0xd6db11b1,0x672882fd,0x69daa3e7,0x6b9c047f}},	//   рта_, nedj, _otte, corg,
   {{0xcb1204de,0xdea38326,0x79808a5a,0x6569aed5}},	//   _אלי_, _banƙ, kimw, _pleh,
   {{0x8d74915f,0xa6e300ab,0xf653825f,0x7bcd05ee}},	//   وانا, _পাওয়, וצע_, _kuau,
   {{0x69da8a97,0x636b0214,0xa91d8390,0x67289e2b}},	//   _atte, _günc, niže, kedj,
   {{0x3946956b,0x6728856f,0x3c1e80eb,0xab29813a}},	//   _anos_, jedj, dāvā_, сока_,
   {{0xdce4003a,0x66088057,0x1df801bb,0x7afa007b}},	//   _slič, judk, _меры_, ótti,
   {{0x657b823d,0x6b9c0a0f,0x3f8160d2,0x32078690}},	//   _umuh, zorg, lihu_, runy_,
   {{0x4439e0d3,0x02a813d9,0x69da97ab,0xa91d8fda}},	//   _és_, _गर्न, _ette, jiže,
   {{0x3ced81e9,0x443fd3a1,0x7989e0d4,0x316d8019}},	//   _heev_, _iru_, snew, shez_,
   {{0x637029ed,0x443f826f,0x6da61631,0x6b9c10b9}},	//   _häng, _hru_, зина, vorg,
   {{0x2d9d809a,0x3f810267,0x69ca0187,0x7bc500fc}},	//   nowe_, hihu_, _éfei, _aihu,
   {{0x6b9c60d5,0xdce40904,0x7bc5376a,0x160d00d4}},	//   torg, _ulič, _bihu, ांडर_,
   {{0x637042ec,0x69da8448,0x26c70024,0x2d8b317f}},	//   _mäng, _ytte, žnoj_, ance_,
   {{0x637029ed,0x7bc50057,0x2d9de0d6,0xae1f8424}},	//   _läng, _dihu, kowe_, _बहिन_,
   {{0x3946160a,0x9f471dc1,0x443f815e,0x29d1877f}},	//   ños_, čný_, _oru_, _máa_,
   {{0x2d8260d7,0x2d9d809a,0x443f84b7,0x20092484}},	// [5c60] mike_, dowe_, _nru_, guai_,
   {{0x2d8260d8,0x161f98e6,0x7bc560d9,0x7c244f67}},	//   like_, _बहार_, _gihu, _ipir,
   {{0x443fe0da,0x7bdb8365,0x3860036e,0x38660bda}},	//   _aru_, _atuu, syir_, šor_,
   {{0x3ced8069,0xed59801b,0xe80c01a2,0x200900ee}},	//   _ceev_, _což_, िंदा_, buai_,
   {{0xe8030063,0xdce60029,0x68e460db,0x3ced8282}},	//   _लिया_, dokļ, mbid, _deev_,
   {{0x27e0059c,0xdb1a84c3,0x88bd809a,0x68e4011e}},	//   mpin_, _bitá, reśl, lbid,
   {{0x443f87ca,0xfce6842f,0x2d9d9111,0xed59826c}},	//   _eru_, _ново, bowe_, _fož_,
   {{0x63701bc0,0x636b0201,0x68e460dc,0x443f84e1}},	//   _händ, _müna, nbid, _fru_,
   {{0x63700004,0x69c63fae,0x16040054,0x68e460dd}},	//   _känd, _mike, शंकर_, ibid,
   {{0x29d1ca34,0x69c660de,0x644098d5,0x138a81a8}},	//   _fáa_, _like, _irmi, _اخرى_,
   {{0x69c6025d,0xaadb8051,0x2d821cb5,0x672884a8}},	//   _oike, _החבר, fike_, redj,
   {{0x394684c9,0x63701bc0,0x2c208063,0x6440905e}},	//   _unos_, _länd, _यहां_, _krmi,
   {{0x98d2819d,0x63700338,0x9f520216,0x2b5a0580}},	//   _dịtụ, _oänd, nuyó_, _bopc_,
   {{0x69c65559,0xddda8019,0x7fb8803d,0x395906ab}},	//   _aike, sztő, _بهتر_, _soss_,
   {{0x395901e0,0x99670254,0x321802c4,0x7c2403ed}},	//   _poss_, птал, gtry_, _epir,
   {{0x3f9e9cf2,0x200907d5,0x44249b6c,0x26ca04be}},	//   lotu_, tuai_, _opm_, _agbo_,
   {{0xa2bcaa54,0x69c6059c,0x3015014c,0x3f815d5e}},	// [5c70] षेत्, _dike, ьдар, tihu_,
   {{0x3ced8069,0x3f9e81a9,0x29038084,0x69c622d4}},	//   _seev_, notu_, ėjai_, _eike,
   {{0x7bdb81d8,0x20090393,0x6440e0df,0x63703c40}},	//   _stuu, suai_, _armi, _säng,
   {{0x443fd572,0x644080b9,0x26ca45e1,0x3f9e84e8}},	//   _pru_, _brmi, _egbo_, hotu_,
   {{0x98ab0012,0x2d9dd82f,0xa15602f6,0x240980e8}},	//   _dacă_, rowe_, _חברה_, інки_,
   {{0x7c948077,0x656d60e0,0x2d9d809a,0x8c4299a5}},	//   رشنا, _llah, sowe_, теше,
   {{0x656d08b3,0x3ced81e9,0x98ab0087,0x2d9d8035}},	//   _olah, _teev_, _facă_, powe_,
   {{0x636f8bc5,0x443fe0e1,0x9f520216,0x798d60e2}},	//   _sønd, _tru_, buyó_, nnaw,
   {{0x443fb5d1,0x2d820052,0x63700364,0x6d499995}},	//   _uru_, vike_, _häne, _inea,
   {{0x656d02e7,0x798d27e4,0xd00e853d,0x9e65d3c2}},	//   _alah, hnaw, گلی_, двод,
   {{0x442f831d,0x656d04e8,0xa2a48105,0x2004ade6}},	//   lwg_, _blah, _चुप्, armi_,
   {{0x44323504,0x6d5b8036,0xd00e9190,0xb33c8372}},	//   _psy_, _joua, دلی_, _ikħa,
   {{0xef0e964f,0x2eaa0a0d,0x2d822397,0xe6aa0a0d}},	//   _им_, _कर्त, rike_, _कर्ज,
   {{0x7c248086,0x69c660e3,0x366994d6,0x8e858abe}},	//   çiri, _sike, _мало_, _огле,
   {{0x69c63307,0x6fd580c8,0xfaa32dd9,0xbcfb3b7a}},	//   _pike, _দিয়ে, варо, rhér,
   {{0x6b83e0e4,0x140d8996,0x6370016d,0x683825b3}},	//   hing, _समूह_, _sänd, júdá,
   {{0xb4ea0128,0x321814e3,0xbcfb0036,0x6e2901a1}},	// [5c80] यरी_, stry_, phér, _ćeba,
   {{0x69c61af7,0x6b83e0e5,0x68e423f8,0x656d0824}},	//   _wike, jing, sbid, _zlah,
   {{0x6b83b26a,0x2fc7aeb7,0x637004fd,0x4424af19}},	//   ding, _ming_, _vänd, _spm_,
   {{0xc486be80,0x9f520661,0x973c8669,0x27e00e20}},	//   млек, tuyó_, moće, ppin_,
   {{0xd24f8077,0x6370016d,0x6b83e0e6,0x69d781df}},	//   ینه_, _tänd, fing, íxen,
   {{0x6b83e0e7,0x2fc7e0e8,0x06e800ab,0x7c2dacfa}},	//   ging, _ning_, _পাকি, çara,
   {{0x3f9e803a,0x2eee9142,0xb87b0118,0x7f5c1243}},	//   votu_, _reff_, _feís, _iorq,
   {{0x3834b1db,0xed439285,0x2fc7808e,0x7f5c471b}},	//   енир, _инсп, _aing_, _horq,
   {{0x4424810a,0x26ca812b,0xc2f400ab,0xdce60084}},	//   _upm_, žbom_, _জানি_, likė,
   {{0x6b83e0e9,0xf41400c8,0x2fc786cb,0x69de0904}},	//   cing, িবার_, _cing_, _otpe,
   {{0xe0da867c,0x2fc7b4da,0x3f9ed6bd,0xc9568009}},	//   _две_, _ding_, rotu_, _отды,
   {{0x7bc894ff,0xc7c880ff,0x1bf58074,0x7afe07b6}},	//   _hidu, _lối_, ुंचल_, _adpt,
   {{0x7bc8e0ea,0x9f40009f,0xb87b0019,0xe73a846e}},	//   _kidu, nsió_, _leír, _мед_,
   {{0xb4af2b2d,0x2fc7a5e5,0xa91d80c3,0x56949a1a}},	//   _करी_, _ging_, miža, _палт,
   {{0xc7c8801c,0x3d0f8105,0xa2a480bc,0x7bc8e0eb}},	//   _nối_, _डाले_, _चुम्, _midu,
   {{0x6b839f12,0x69da0013,0x2fc7801c,0x798d4044}},	//   zing, ítea, _zing_, unaw,
   {{0x46d2800f,0xfe7000d7,0x442f822c,0xe50d82f1}},	// [5c90] _सलाह, یدم_, xwg_, हलसि_,
   {{0x6d49a4db,0x673a816d,0xc7c880ff,0x63620187}},	//   _snea, ndtj, _bối_, _bônu,
   {{0xdb1a8364,0x6b83e0ec,0xc33203de,0xfc3f0216}},	//   _mitä, ving, _גוי_, lví_,
   {{0xceb3812a,0x46df000d,0x6b83e0ed,0xa4d580e8}},	//   דיע_, _प्रह, wing, ході,
   {{0xd0068b76,0xa91d82a5,0x7bc8e0ee,0x7f5c1af9}},	//   _حل_, jiža, _bidu, _forq,
   {{0x6738882c,0x442f8428,0xe1f0081b,0xc5f88ec3}},	//   _navj, rwg_, _حسی_, ksē_,
   {{0xc6a40c6e,0x7bc8e0ef,0x4ea4014c,0x21395fcc}},	//   _арти, _didu, _арта, _kash_,
   {{0x2fc78288,0x6b83828d,0x261883d3,0xb4af016f}},	//   _sing_, sing, déo_, _करू_,
   {{0x7bc8ad08,0x6b8385d1,0xed59812b,0x160d016f}},	//   _fidu, ping, _niži_, ांवर_,
   {{0x81e500c8,0x636b13d6,0xa3d4a8b3,0x7bc88bb1}},	//   _নিন_, _sünn, _संत_, _gidu,
   {{0xa29f0f1b,0xe61693bf,0x2fc7d55c,0x7af50f3e}},	//   _खुल्, ндэ_, _ving_, dazt,
   {{0x20028084,0xc692007c,0x224600c3,0xa91d8140}},	//   škia_, ראט_, _čok_, biža,
   {{0x2fc7e0f0,0xf53981ac,0x2d8f8c41,0xa2c786ce}},	//   _ting_, _mať_, inge_, ाशक्,
   {{0x2fc78362,0x7af50cdb,0x29038084,0xbcfb04e8}},	//   _uing_, gazt, ėjau_, hkéh,
   {{0x3f859142,0xdce9817f,0xeb971073,0x41b61092}},	//   milu_, _aleč, хир_, есат,
   {{0x673882ce,0xdce98699,0x3f85e0f1,0xc7c880ff}},	//   _zavj, _omeđ, lilu_, _rối_,
   {{0x7f5c10dd,0x752460f2,0xa3cb8c69,0x7af5011b}},	// [5ca0] _porq, _ibiz, _रंग_, bazt,
   {{0x212db371,0xdce60110,0xe3b2066e,0x31691fa4}},	//   heeh_, tikė, _حرب_, akaz_,
   {{0xe8ac912a,0x7bc88330,0x69d78118,0x69de0687}},	//   _चर्च, _ridu, íxel, _utpe,
   {{0xd91000d5,0x64440406,0xd6e800ab,0x7bc89f61}},	//   _خیر_, _krii, _পাওয, _sidu,
   {{0xd467aa0e,0xf53980e1,0x68f62f3b,0xd90d09a7}},	//   нице_, _dať_, mayd, _ذیل_,
   {{0x9f40009f,0xc7c88028,0x68f62f3b,0x7c3600b9}},	//   rsió_, _tối_, layd, _msyr,
   {{0x9f4007e2,0x7bc89482,0xf9c6aa46,0x3f85811a}},	//   ssió_, _vidu, нщин, dilu_,
   {{0x673882fd,0x64a6bc3d,0xbcfb027f,0xdca6e0f3}},	//   _savj, _заба, ckéh, _заби,
   {{0x59d2101b,0xdb1a825d,0x7bc89a67,0xb4af0740}},	//   _दूसर, _pitä, _tidu, _करे_,
   {{0x261880e7,0x7524413e,0xed598140,0x7bdf816a}},	//   téo_, _abiz, _riži_, íque,
   {{0x7c3600ee,0x64441698,0x00ca917e,0x752405ee}},	//   _asyr, _arii, _елек_, _bbiz,
   {{0xa91d812b,0xfc3f03bb,0xe4a71bc1,0x68f660f4}},	//   ližn, tví_, ерго, jayd,
   {{0x3f85e0f5,0x68f60079,0x69da0019,0xb4fb02f1}},	//   bilu_, dayd, íten, ्लौप_,
   {{0x636b02bb,0xafdb5986,0x75243bb8,0x65b6128a}},	//   _günl, _brøn, _ebiz, váhe,
   {{0xb5a7035f,0x3da71240,0xdcfb8353,0x7af5011e}},	//   _прий, _приб, _smuč, razt,
   {{0x195801e5,0x6444209b,0x68f660f6,0x291202ec}},	//   насы_, _frii, gayd, ggya_,
   {{0x6d4d576a,0x64440915,0x31690326,0x20980fe6}},	// [5cb0] _inaa, _grii, rkaz_, екты_,
   {{0x442960f7,0x81bc8029,0xa91d8132,0x69b31344}},	//   _ipa_, _spēl, jižn, _आठवी,
   {{0xafdb0b40,0xdce98668,0x21390168,0x6d4d1989}},	//   _grøn, _smeđ, _tash_, _knaa,
   {{0x753d0065,0x3f8580d2,0x80a203bb,0x2d8fe0f8}},	//   ndsz, zilu_, _कुवे, unge_,
   {{0x442960f9,0xb4af3716,0xaacc8d86,0xf0d281bc}},	//   _jpa_, _करो_, ाशंक, _rịpọ,
   {{0xbcfb026f,0x996c81d0,0x395d9b6c,0xb4af03db}},	//   skéh, měř_, _sows_, _करै_,
   {{0x2d878264,0xe29681f3,0x6d4d3ca6,0x533801c6}},	//   énes_, каш_, _onaa, גנון_,
   {{0x200dc395,0x6d4d0365,0xe7a9066f,0x752f066f}},	//   tuei_, _nnaa, कतकप, jecz,
   {{0x442957bb,0x26c701d6,0x63748980,0xa3d5804a}},	//   _npa_, ľnou_, _bànd, _розч,
   {{0x6d4d60fa,0x7c29bc36,0x2003836f,0x753babb7}},	//   _anaa, _iper, čji_, _hauz,
   {{0x4429028a,0x39158676,0x13e68a49,0xfce607c8}},	//   _apa_, _амер, _নিয়, коно,
   {{0x200901e2,0x44290fd2,0xd2568039,0x644460fb}},	//   krai_, _bpa_, _בשעה_, _prii,
   {{0x68e9e0fc,0x200de0fd,0xe72e8195,0x753b8c53}},	//   mbed, quei_, _ке_, _mauz,
   {{0x63a3e0fe,0x7c29d2e3,0x76438573,0x442960ff}},	//   nonn, _mper, _trny, _dpa_,
   {{0x69cba578,0xd2990558,0x561300ab,0xcb1283c8}},	//   _kige, етті_, সবুক_, ילם_,
   {{0x63a3b5ad,0x973c80d2,0x644402f1,0x1c460103}},	//   honn, moća, _trii, _аним,
   {{0x63a3b655,0x2fca0748,0x69cb8c03,0x41d211be}},	// [5cc0] konn, _pibg_, _mige, _दूरस,
   {{0x69cbe100,0x63a3e101,0x68f6080a,0xafdb004a}},	//   _lige, jonn, sayd, _trøn,
   {{0x7c29bd36,0x81dc00c8,0x63a3e102,0x200912ae}},	//   _aper, _ঠিক_, donn, arai_,
   {{0x69cbe103,0x753b8012,0x598323e7,0x7c868dae}},	//   _nige, _cauz, _влюб, куле,
   {{0xed59811f,0x753b811b,0xf48780d7,0x68e9e104}},	//   _nižu_, _dauz, پانی, dbed,
   {{0x63a38d35,0x752f009a,0x973c8267,0x2d878298}},	//   gonn, zecz, koća, éner_,
   {{0x753b978f,0x69cb820c,0xa91d811a,0xc7c88129}},	//   _fauz, _bige, rižn, _mốt_,
   {{0x673c043d,0x753b811e,0x68e98c30,0xd90e8180}},	//   _harj, _gauz, gbed, زیت_,
   {{0xb42587bd,0x673c20a2,0x61e90042,0x34a78171}},	//   _معلو, _karj, ćeli, _авто_,
   {{0x69cbe105,0x753b803b,0x63a382be,0x442958eb}},	//   _eige, _zauz, conn, _rpa_,
   {{0x752f009a,0x69cbe106,0x3eaa806a,0x69da01d0}},	//   tecz, _fige, æbt_, ítel,
   {{0x7982809a,0x69cb917a,0x2912821e,0xeeeb0129}},	//   _umow, _gige, _øya_, _đọng_,
   {{0x6442a2b9,0x94a8245b,0x61e200d2,0xc4580198}},	//   nvoi, втра_, _čola, виях_,
   {{0xd90e8986,0xa5c7007b,0x69cbcb2f,0x636f84d6}},	//   _ایک_, _bjóð, _zige, _lønn,
   {{0x5fb78051,0xdced6107,0x5ec080ab,0x6b8700f3}},	//   _שהוא_, _hlač, _শ্রে, rijg,
   {{0x63a398e8,0x20096108,0x69cb8079,0x0eeb2a2b}},	//   zonn, trai_, _xige, टर्स_,
   {{0x63a3e109,0x7ff41e95,0x69d8610a,0x25a910e1}},	// [5cd0] yonn, لسلا, _éven, _ikal_,
   {{0x68e98eef,0x63700006,0x65b6026f,0x20091a06}},	//   zbed, _täna, máha, rrai_,
   {{0x63700c3c,0xf41f025d,0x673c0ad4,0x4fc41170}},	//   _känn, ltä_, _darj, рста,
   {{0x65609523,0x63a3b31c,0x5bcba207,0x63700198}},	//   _comh, wonn, ाद्व, _jänn,
   {{0x637008aa,0x63a3e10b,0x65608068,0x69cbe10c}},	//   _männ, tonn, _domh, _rige,
   {{0x69cb805f,0xf41f0009,0x2d84e10d,0xed59882c}},	//   _sige, itä_, _emme_, _rižu_,
   {{0x63a3e10e,0x69cb8982,0x3869610f,0x261c1099}},	//   ronn, _pige, lyar_, cío_,
   {{0xf2df8028,0x63a3d94c,0x56943eb1,0xdce40904}},	//   _đâu_, sonn, _таст, _ilić,
   {{0x68e9e110,0x60dbe111,0x69cbe112,0x386957f8}},	//   rbed, rcum, _vige, nyar_,
   {{0x2608035a,0x25a9059c,0xc2e900c8,0x68e98c1b}},	//   ांची_, _akal_, কৃতি_, sbed,
   {{0x2f5481e5,0x391592c8,0x8f9c0039,0x25a9008e}},	//   ртыс, _مواز, ויזי, _bkal_,
   {{0xed5a19fe,0x5184a597,0xc7c880ff,0x6b854a30}},	//   хом_, _куча, _sốt_, _amhg,
   {{0x644f8acf,0x973c803a,0xdced09d1,0xa5c7008b}},	//   _ácid, moćn, _glač, _sjóð,
   {{0xdb1a8feb,0x3dcd80ee,0xe0df04be,0x50b8803d}},	//   _sitú, _liew_, _afò_, _شدند_,
   {{0x412a181f,0xafdb0bc5,0xe297182d,0x637002f1}},	//   ново_, _drøm, гар_, _fänn,
   {{0x973c812b,0x261c0c15,0x673c2551,0x213f911f}},	//   noćn, vío_, _sarj, nduh_,
   {{0x38690065,0xc7c88104,0x81bc8029,0x6560832f}},	// [5ce0] gyar_, _tốt_, _spēk, _romh,
   {{0x6560dc56,0x636f854f,0x261c2509,0xe0df03ec}},	//   _somh, _sønn, tío_, _efò_,
   {{0x673c6113,0x9d468098,0xdb038187,0x69c0e114}},	//   _varj, лежд, ponê, ymme,
   {{0x64428358,0x261c05e4,0x38693384,0xdb03e115}},	//   tvoi, río_, byar_, lonè,
   {{0x673c6116,0x2d9ee117,0x6442a4df,0x3940008e}},	//   _tarj, _ítem_, uvoi, mdis_,
   {{0x6442e118,0x7bd66119,0x3940611a,0x261c016a}},	//   rvoi, _muyu, ldis_, pío_,
   {{0xa3d4931d,0xbf100778,0x6560e11b,0x7af8888b}},	//   _सूर_, ालीन_, _tomh, ravt,
   {{0xdd92850c,0xdced0517,0xf41f0364,0x6e931c12}},	//   _اور_, _plač, ytä_, _الفا,
   {{0xd6d08013,0x0443bd1f,0xd37f012b,0x63748722}},	//   يقة_, _летн, šćih_, _cànc,
   {{0x25a9005f,0x7d04478b,0x65b6611c,0x10370039}},	//   _skal_, _adis, váha, נטים_,
   {{0x4aa41344,0x7bd60326,0x213f80b9,0xb8068beb}},	//   _खुलव, _auyu, bduh_, _शिवम_,
   {{0x1a9b893f,0xf41f0364,0xdced027f,0x7bd60850}},	//   _איבע, ttä_, _tlač, _buyu,
   {{0x637000f2,0x69da8074,0x3940022b,0x7d042d50}},	//   _vänn, _पंडी, ddis_, _ddis,
   {{0x200b8038,0x25a69645,0x25bb0358,0x7bd60457}},	//   ácie_, hool_, _whql_, _duyu,
   {{0xf41f464b,0x25a6e11d,0x35d90105,0x63700198}},	//   stä_, kool_, _बूढ़, _tänn,
   {{0x810f11be,0x3f98022b,0x210f0035,0x65b6008b}},	//   िलेख_, _ajru_, िलेश_, páha,
   {{0x2ef5095d,0xdce40140,0x7bd64240,0xab87157b}},	// [5cf0] изар, _slić, _guyu, _бунк,
   {{0x7c2d611e,0x26decb95,0x213fdf11,0x3869611f}},	//   _ipar, ncto_, zduh_, ryar_,
   {{0x6dbc0063,0x2cad83ac,0x3869036e,0x63a703ed}},	//   _właś, _syed_, syar_, mojn,
   {{0x4a5a0051,0x8af80201,0x7bd60a76,0x63a700f1}},	//   _סדרו, _şəxs, _yuyu, lojn,
   {{0x78fa004c,0x3dcd887b,0x68ed471f,0x7989ba4e}},	//   _בפרו, _view_, mbad, view,
   {{0x27e91d0f,0xfbd0803d,0x63a700f1,0xab298bba}},	//   mpan_, سته_, nojn, тока_,
   {{0xe0d18013,0x2d8b6120,0x798981b0,0xe4e78d8e}},	//   يزة_, kice_, tiew, _бізн,
   {{0x7c2d6121,0x25a696f0,0xa8059ad8,0x7c3e809a}},	//   _opar, cool_, азил, łpra,
   {{0x2d8b0b91,0x63a76122,0x23a50023,0x26110105}},	//   dice_, kojn, ओवाद, दूरी_,
   {{0x442dbdf3,0x7989802f,0x7c3bc7e7,0x63a70168}},	//   _ipe_, siew, _isur, jojn,
   {{0x201fadc7,0x6449807b,0x2d8b3499,0x63a70168}},	//   stui_, _hrei, fice_, dojn,
   {{0x6da622b7,0xe5a60adb,0xdb038077,0x7bd60590}},	//   рима, рими, doné, _puyu,
   {{0x7d0481a8,0x68ed01b4,0x7d1b8144,0x69d734d3}},	//   óisi, dbad, _mcus, _auxe,
   {{0x442de123,0x63a70ffc,0x27e90420,0xafdb0366}},	//   _mpe_, gojn, dpan_, _trøj,
   {{0x75299f3a,0xdb1a820f,0x0cb2873c,0xdb03e124}},	//   _obez, _shtë, _जर्म, goné,
   {{0x00e635cc,0x2d8b0024,0x68fb8110,0x7bd606cb}},	//   ржан, cice_, naud, _tuyu,
   {{0x68431814,0x69cf100a,0x442d81e9,0x63a70796}},	// [5d00] онта, _dice, _npe_, bojn,
   {{0xc3fb04de,0x93fb007c,0x39400ce9,0x68ed6125}},	//   _שליש, _שליי, sdis_, abad,
   {{0x442de126,0x7afc6127,0x1fb501bb,0x7c3b81bf}},	//   _ape_, mart, сстр, _asur,
   {{0x6449e128,0xe29b0051,0x7763862f,0x61461878}},	//   _brei, _ישיר, _lonx, _тема,
   {{0x6449e129,0x69c4612a,0x25a6aa38,0x68fbd44c}},	//   _crei, mmie, rool_, daud,
   {{0x64498e5d,0x200de12b,0x69c4612c,0x2d8b612d}},	//   _drei, drei_, lmie, zice_,
   {{0x200d8ab3,0x442de12e,0x63748014,0x6449e12f}},	//   erei_, _epe_, _càna, _erei,
   {{0x644991e6,0x7afc2404,0x79961088,0x200d81ec}},	//   _frei, hart, nnyw, frei_,
   {{0x6449d1a9,0x7afc6130,0xa3b6016f,0x2d8b5de0}},	//   _grei, kart, जता_, vice_,
   {{0xe5680159,0x6d40e131,0x7763862f,0x2d8b6132}},	//   _אַ_, _hama, _conx, wice_,
   {{0x6d40e133,0x2d9e82be,0x7afc6134,0x6370016d}},	//   _kama, _êtes_, dart, _vänl,
   {{0x6d40b7cf,0x7af71820,0x68fb8020,0x6d42e135}},	//   _jama, _sext, caud, ndoa,
   {{0x69cf0021,0x6d40db21,0x69c40038,0x2d8b083d}},	//   _rice, _mama, dmie, rice_,
   {{0x6d40e136,0xc90f159a,0x7afc6137,0x69cf4545}},	//   _lama, िल्म_, gart, _sice,
   {{0xd90f0416,0x63a72ed5,0x69cf5257,0x439413f7}},	//   وید_, rojn, _pice, царс,
   {{0x6d40e138,0x29dc160a,0x63a71001,0x69d7016d}},	//   _nama, _día_, sojn, _vuxe,
   {{0xdefb0364,0x63a72f9f,0x7c2280f1,0x27e9423b}},	// [5d10] вые_, pojn, jtor, upan_,
   {{0x7afc468a,0x68ed6139,0x7d1b8081,0x69c42581}},	//   cart, sbad, _scus, amie,
   {{0x20028824,0x6d40aa8d,0xd6d80729,0x27e960cc}},	//   ških_, _bama, рту_, span_,
   {{0x6449e13a,0x27e92317,0x2906e13b,0xbd1880e8}},	//   _prei, ppan_, _ndoa_, иції_,
   {{0x8c458bc7,0x92d900c8,0x4439613c,0x8d748065}},	//   селе, ারী_, nws_, غاما,
   {{0x200d9429,0x083a00be,0xe29996ba,0xa03a00be}},	//   vrei_, _געשל, лал_, _געשפ,
   {{0x7c22c4b2,0xf1bf001c,0x6d40e13d,0x27e6833e}},	//   ator, _khá_, _fama, _aton_,
   {{0x6d40e13e,0x7afc613f,0x798d0359,0x27ffe140}},	//   _gama, zart, niaw, tsun_,
   {{0x7c229b7d,0x68fbb014,0x7afc0041,0xb4b615fb}},	//   ctor, raud, yart, _झरे_,
   {{0x8aa7af84,0x6d408431,0xfbd08c2a,0x200dde45}},	//   _кред, _zama, _قتل_, rrei_,
   {{0x6d40b328,0x9a87b99f,0x27ffe141,0xb8dd80ab}},	//   _yama, _туал, ssun_, _আল_,
   {{0xbc1a01e5,0x29dc04c3,0x6d408079,0x200de142}},	//   лігі_, _ría_, _xama, prei_,
   {{0x7afc6143,0x5f0a016f,0x65b60061,0x644b0144}},	//   tart, ाणम्_, sáho, _ágil,
   {{0x3d1a18b8,0x3f8c8699,0xf1bf0032,0x29dc002a}},	//   _भावे_, cidu_, _ahá_, _pía_,
   {{0x7afc016f,0xf2d280be,0x09e6102f,0xa3d483b7}},	//   rart, לעם_, собн, _सूई_,
   {{0x29dc02ba,0xe8030321,0xf1bf0317,0x69c46144}},	//   _vía_, _लिखा_, _chá_, umie,
   {{0x69c41690,0xf1bf0013,0x386de145,0x75d38087}},	// [5d20] rmie, _dhá_, nyer_, _văzu,
   {{0x7afc1c26,0x29dc2a6c,0x395f8074,0x69c46146}},	//   qart, _tía_, hjus_, smie,
   {{0x6d40e147,0x637000f2,0x671e005e,0x386d80f1}},	//   _pama, _länk, _पाठक_, hyer_,
   {{0x7c22b528,0x6d40b231,0x25bf86e7,0x89360872}},	//   ttor, _qama, _chul_, _اعدا,
   {{0x23658db7,0xcb6aa3e0,0x24588a08,0xd5af9a3c}},	//   _bolj_, ладе_, раль_, رفه_,
   {{0x6d40b957,0x98a20110,0xeb9f006a,0x386d8ec9}},	//   _wama, _sakė_, rsøg_, dyer_,
   {{0x6d40e148,0x3f8c8859,0x39420006,0x27e6e149}},	//   _tama, vidu_, _kaks_, _ston_,
   {{0x7a430065,0xf5968013,0x61ea81ec,0x637005ec}},	//   lítá, _الرج, rpfl, _bänk,
   {{0xdefa81e5,0x61ea8192,0x63700338,0x2bb900c2}},	//   лын_, spfl, _vänj, _इठला,
   {{0x8b658307,0xdce0cbab,0x200ba68c,0x74138b53}},	//   _والم, _momč, ácia_, _روما,
   {{0x3f8ce14a,0x68f98197,0xdb01928a,0x63748a2a}},	//   ridu_, _fewd, _uklá, _hàno,
   {{0x7afa9388,0xa1c68256,0x3f8ce14b,0x5fba98b8}},	//   _hett, _убед, sidu_, _उठवल,
   {{0x443907b3,0x39a10110,0xb87b41e3,0x07a68293}},	//   uws_, nėse_, _afín, _ладн,
   {{0x69dae14c,0xab840171,0x7afab729,0x7a430061}},	//   _kute, пуск, _jett, jítá,
   {{0x7afae14d,0xf1bf0028,0x798d0590,0x7de68b53}},	//   _mett, _phá_, tiaw, _استم,
   {{0x92d900c8,0x69da8542,0xdcfb80d2,0x3f8a09c4}},	//   ারে_, _mute, _imuć, _ambu_,
   {{0xa3d485e8,0x69dabc95,0xc6f959dc,0x798d0573}},	// [5d30] _संग_, _lute, инах_, riaw,
   {{0x7afa8cde,0x644d0102,0x798d09ca,0x2d990122}},	//   _nett, _irai, siaw, lnse_,
   {{0x58d52f75,0x798d0b99,0x69dae14e,0xdb1a8118}},	//   _монт, piaw, _nute, _litó,
   {{0x644d614f,0x394200b9,0x3f8a2e5e,0x2d993f66}},	//   _krai, _gaks_, _embu_, nnse_,
   {{0x69dad0ad,0x7afa8039,0x2365e150,0x68ff0085}},	//   _aute, _bett, _polj_, maqd,
   {{0x7afa86e3,0x69da93c6,0x661d809a,0xc5fb00a0}},	//   _cett, _bute, ński, _معرض_,
   {{0x7afa9e7c,0xdb1e020f,0x63701af3,0xaca3819d}},	//   _dett, _shpë, _sänk, _idọn,
   {{0x212b9385,0x69da80ad,0x644d6151,0x3fe59594}},	//   ých_, _dute, _orai, ожив,
   {{0xb9018e70,0x7d09b950,0x776701c0,0x657d00f1}},	//   _दल_, _ides, _kojx, dhsh,
   {{0x2d8f81eb,0x443fcce6,0x69dadc03,0x752d29f7}},	//   lige_, _isu_, _fute, _abaz,
   {{0x69da9e5a,0x644d0356,0x3eb9809a,0x752d0197}},	//   _gute, _arai, ęsto_, _bbaz,
   {{0x637004b8,0x2d8fae67,0x7afa8a0f,0x29d1805c}},	//   _tänk, nige_, _zett, _išao_,
   {{0x69da811e,0x7afab4c2,0xbcfb0019,0x637d89c4}},	//   _zute, _yett, rkép, _cèng,
   {{0x2d9903b2,0x752d0102,0x289a807c,0x7ae50197}},	//   anse_, _ebaz, _דינא, _cfht,
   {{0x644d6152,0x27edbe84,0x7d099516,0xaa435d04}},	//   _erai, lpen_, _odes, мерл,
   {{0x644d0b6a,0x443f84be,0x7d09e153,0x752d01bc}},	//   _frai, _osu_, _ndes, _gbaz,
   {{0x2d8fc01c,0x1f661baa,0x6d5629da,0x42d60b73}},	// [5d40] dige_, окам, _inya, _міну,
   {{0x7d09ba23,0xdb0385e4,0x6d560069,0x47c300e8}},	//   _ades, foní, _hnya, дбув,
   {{0x7afa86be,0x072181c4,0x443fe154,0x7f4382be}},	//   _rett, _मानव_, _asu_, _manq,
   {{0x7afacd4c,0x7bc1e155,0x7a430065,0x6d440102}},	//   _sett, _ahlu, sítá, _jaia,
   {{0x69dae156,0x6d44011e,0x7afae157,0x636b452b}},	//   _sute, _maia, _pett, _güns,
   {{0x69dae158,0xafdb005f,0x09b49b7e,0x290057e2}},	//   _pute, _prøv, ुष्य, laia_,
   {{0x27eda463,0x7e2304bd,0x443fe159,0x26d8007a}},	//   epen_, _одрж, _esu_, _igro_,
   {{0x7afa8dfb,0x2900615a,0x7d0981a1,0x2d8f811f}},	//   _wett, naia_, _gdes, cige_,
   {{0x7f43e15b,0x7afae15c,0xfc03c81b,0xdce98088}},	//   _banq, _tett, _опто, _sleć,
   {{0x6d56615d,0x4426b732,0x69da9917,0xdce9811f}},	//   _anya, mto_, _tute, _pleć,
   {{0x4426a623,0x644d615e,0x657d11c0,0x6d5609ca}},	//   lto_, _srai, thsh, _bnya,
   {{0x4426a060,0x644d4b8f,0x6562ad71,0x6d44615f}},	//   oto_, _prai, njoh, _caia,
   {{0x4426e160,0xf746818b,0x2900011b,0x98b90162}},	//   nto_, _медо, daia_, _masă_,
   {{0x44269820,0x644d02be,0x2d8fb9de,0x657d23ac}},	//   ito_, _vrai, zige_, shsh,
   {{0x4426c182,0x212900dd,0x644d0428,0x236c0106}},	//   hto_, tfah_, _wrai, ödja_,
   {{0x4426e161,0x644d0218,0x6d440102,0x29006162}},	//   kto_, _trai, _gaia, gaia_,
   {{0xd6db0f80,0x47d50013,0x2d8fa799,0x44268038}},	// [5d50] ате_, سيار, vige_, jto_,
   {{0x44269341,0x2d8f874c,0x27e601a8,0x9f4901fa}},	//   dto_, wige_, íona_, gsað_,
   {{0x2d8f9ab0,0x69da0019,0x636b02af,0x95cb8071}},	//   tige_, ítet, _wüns, ауда_,
   {{0xb23a0158,0xdcef00eb,0x98b90087,0x7bc181e4}},	//   _פערז, dicī, _casă_, _shlu,
   {{0x2d8f8422,0x764e031d,0x4426b2b1,0x61e204a8}},	//   rige_, _erby, gto_, _čoli,
   {{0x2d8f88c9,0xdb0391b9,0x25a68267,0x63858196}},	//   sige_, poní, čola_, ягла,
   {{0x4426e163,0x443f8326,0xef2301a9,0x6440e164}},	//   ato_, _wsu_, _ceļš_, _esmi,
   {{0x443f81c0,0x7d09e165,0x44268079,0x9d189bdc}},	//   _tsu_, _udes, bto_, _мост_,
   {{0x4426961b,0x2d8de166,0x69e18042,0xf8b91305}},	//   cto_, _imee_, _šveđ, _आरोप,
   {{0x27edbe84,0x6d440102,0x63700106,0x68fd5c45}},	//   rpen_, _saia, _hänv, _lesd,
   {{0x2f54835f,0x29d18052,0x6d5600dd,0x27edb7dc}},	//   єтьс, _ušao_, _pnya, spen_,
   {{0xb2ba8039,0xd00e82e3,0xdca60adb,0x7aba81c6}},	//   _המער, خلی_, зами, _הצעו,
   {{0x69c9ad81,0x6d440ece,0xe6b80aed,0x2d8d819d}},	//   mmee, _vaia, _अर्ज, _mmee_,
   {{0xe820800f,0x69c98ebc,0xf99f0032,0x6d4403e4}},	//   _ममता_, lmee, _ajè_, _waia,
   {{0xaacba3e6,0x637d87fa,0x4426b1e3,0xa3d48744}},	//   ाधिक, _gène, zto_, _संघ_,
   {{0x6d561e7f,0xe0da0098,0x44269ba9,0x69c9a757}},	//   _unya, сва_, yto_, nmee,
   {{0x68fd1313,0x44269313,0x38c80077,0x68e46167}},	// [5d60] _desd, xto_, زاری_, rcid,
   {{0x6f018067,0x68e46168,0xa3bf000d,0x69da03a2}},	//   nalc, scid, ेषण_, ítes,
   {{0x4426dce7,0x2900373d,0x657b8609,0x69c9aeee}},	//   wto_, paia_, _bluh, kmee,
   {{0x44268ca9,0xe45a80e8,0x21a60162,0x6374846d}},	//   tto_, йже_, _химм, _gànj,
   {{0x4426c4b2,0x69de3d95,0x6f01a8f7,0x7afe0084}},	//   uto_, _hupe, kalc, _kept,
   {{0x2b45e169,0x6f018353,0x69de616a,0xdce080eb}},	//   _calc_, jalc, _kupe, _domā,
   {{0x877b0158,0xdb1e04f0,0x6f0182d4,0x69de616b}},	//   _פאלי, _hipó, dalc, _jupe,
   {{0x44268511,0x7afe00d2,0xd90d819f,0x657ba368}},	//   pto_, _lept, لیم_, _gluh,
   {{0x6da3806d,0x6f01e16c,0x7d02e16d,0x63ae017f}},	//   _чита, falc, maos, kobn,
   {{0x43868277,0x25a01af7,0x3ce681d6,0x69c981b4}},	//   _علاق, _ajil_, lcov_, amee,
   {{0x69c98069,0x6283809a,0x69de616e,0xe8b90072}},	//   bmee, czno, _nupe, _आर्च,
   {{0x06970051,0x3ce681ac,0x7d02e16f,0xdced0140}},	//   לדים_, ncov_, naos, _mlać,
   {{0x68fd3e55,0x0cab0098,0x94ab15a6,0x69de0706}},	//   _resd, стни_, стна_, _aupe,
   {{0x9a870dca,0x39469f3a,0x6f01b1b6,0x7f589263}},	//   публ, _haos_, calc, _факс_,
   {{0x27e60307,0x82a46170,0x69de4168,0xa29505a8}},	//   íonn_, еште, _cupe, фаві,
   {{0xdb0a80f2,0x673ae0a2,0x2d9c8019,0x31978087}},	//   llfä, letj, ével_, tăzi_,
   {{0xa3cc85b3,0x40340af0,0x394680d7,0x52d080ab}},	// [5d70] रगा_, нетс, _maos_, _স্মৃ,
   {{0x656981bf,0xdb039b2c,0xdced09d1,0xb88305b9}},	//   _soeh, koná, _blać, vníč,
   {{0x7bdf0713,0xcb1204de,0xb4bd000d,0x68fd23c1}},	//   _huqu, _בלי_, _अरु_, _tesd,
   {{0x6fd80540,0x660500f1,0x7afe001b,0x8c3d8085}},	//   _भूकं, rshk, _zept, _axşa,
   {{0xd0068060,0x673a8009,0xf8b1004e,0x661a9f38}},	//   _جل_, ketj, _شکر_, hutk,
   {{0x0721ab62,0x8c1c0051,0x661a8359,0x65bd016b}},	//   _माधव_, מודי, kutk, kého,
   {{0x6f018db7,0x661a810b,0x7d0d0214,0x39496171}},	//   valc, jutk, _odas, odas_,
   {{0xeeeb0104,0x7d0d601a,0x7d02b204,0x63700198}},	//   _động_, _ndas, caos, _hänt,
   {{0x62838117,0xfc3086e2,0x69c9a6a1,0xb8e585fc}},	//   szno, _محل_, rmee, _एर_,
   {{0x7d0d547b,0x378980e8,0x673a806a,0x69c9d294}},	//   _adas, ібно_, getj, smee,
   {{0x6da605c2,0x7afe1753,0x63a4d138,0xe5a63714}},	//   дина, _rept, éine, дини,
   {{0xcb09073a,0x7bdf0228,0xed5a34c4,0x823487d2}},	//   _כל_, _buqu, цом_, _سرما,
   {{0x39492af9,0x7bd70118,0x673a928d,0x63ae00e1}},	//   ddas_, _bixu, betj, tobn,
   {{0x7d0d0006,0x39496172,0x661a8057,0x7bd7002a}},	//   _edas, edas_, butk, _cixu,
   {{0x661abc5a,0x7bdd80e5,0x636f9277,0x2327047f}},	//   cutk, _èsuf, _høns, ьори_,
   {{0x291fe173,0x7bd70980,0x636f8366,0x7bdf6174}},	//   ngua_, _eixu, _køns, _fuqu,
   {{0x3ce680e1,0xdb1e023e,0xdced0088,0x6fd8064a}},	// [5d80] vcov_, _dipò, _slać, _भूखं,
   {{0xdced003a,0x2be1800f,0x64446175,0x636f8aa2}},	//   _plać, _पढ़ा, _isii, _møns,
   {{0xdb1a8061,0x7d02a0f0,0x636f83ba,0xe6bb903e}},	//   _kitö, taos, _løns, _उरोज,
   {{0x6d91816b,0xdb1e0118,0x395902a6,0xa3dd0074}},	//   sťan, _tipó, _gnss_, _तूँ_,
   {{0x7bdf0079,0xe8f70b79,0x3ce6e176,0x394680d7}},	//   _xuqu, _юля_, rcov_, _raos_,
   {{0x3ce6a6b4,0x68f65986,0x7643808e,0x53338226}},	//   scov_, lbyd, _osny, вешт,
   {{0x3946e177,0x63700106,0x673a807a,0xd25081bd}},	//   _paos_, _häns, vetj, انب_,
   {{0xd91083f8,0x637000f2,0x3d1a0441,0x21203e55}},	//   ایش_, _käns, _भागे_, ngih_,
   {{0xb4bd1551,0xa3dd18b8,0x673ab30c,0x63748980}},	//   _अरे_, _तूं_, tetj, _làni,
   {{0x7d00b9e8,0x6370016d,0x661a8ca1,0x3e4c81d0}},	//   _hems, _mäns, tutk, _pět_,
   {{0x63701af3,0x3946e035,0x7643808e,0x6444466a}},	//   _läns, _taos_, _csny, _asii,
   {{0x661aab78,0x7d008088,0x2b5a0162,0x673ae178}},	//   rutk, _jems, _anpc_, setj,
   {{0x29049fb6,0x071e06a7,0x321c80e1,0x68f66179}},	//   mama_, _पांव_, luvy_, dbyd,
   {{0x2904e17a,0x661a956e,0xdb0704e8,0x7d0083ed}},	//   lama_, putk, pojí, _lems,
   {{0xd8488028,0x63701af3,0x03200105,0x64440009}},	//   _họ_, _ränt, _बारह_, _esii,
   {{0xf77003f8,0x21200077,0x7bdf05ee,0x2fd80362}},	//   یال_, ggih_, _tuqu, _airg_,
   {{0xe8940364,0x39493e80,0xb9070fea,0x2486817f}},	// [5d90] вать, rdas_, _पल_, jzom_,
   {{0x2904e17b,0xd84890ab,0x753d0019,0x3949617c}},	//   hama_, _mọ_, lesz, sdas_,
   {{0x2904bd8b,0xd848877f,0x637000f2,0x68f6010c}},	//   kama_, _lọ_, _vänt, bbyd,
   {{0x29d1827f,0x3eb80370,0x2a7601c6,0xcdd983de}},	//   _však_, _dyrt_, _נערך_, פֿער,
   {{0xd848882e,0xc9160039,0xb60704b7,0xe800801b}},	//   _nọ_, _אחרת_, _suġġ, लीमा_,
   {{0x8c1c007c,0x59bf00d4,0xb87b0032,0x442900ee}},	//   קווי, ्षवर, _agíg, _mqa_,
   {{0x628704b7,0x6f050101,0x442b02f7,0x6d1f05fc}},	//   nzjo, mahc, htc_, _भांग_,
   {{0xd848c462,0x3f9e80eb,0x7dde80eb,0x291f8c93}},	//   _bọ_, entu_, _mūsd, ugua_,
   {{0x4f95a45b,0x442901c5,0x65948f25,0xaca381bc}},	//   ерну, _nqa_, _рату, _mpịa,
   {{0x9e6585d3,0x60c28b80,0x80c481a2,0x6d4ba25b}},	//   евод, _dzom, ाइजे, ldga,
   {{0x7c36617d,0xa3cc8105,0xc7b20039,0xf1db4130}},	//   _spyr, रगर_, רבי_, _मंगन,
   {{0x2904803a,0xf2df8104,0xc3290051,0x656d0388}},	//   cama_, _đây_, _לו_, _coah,
   {{0x61e1a674,0x7c2bbe06,0x636f83ba,0xb4e0064a}},	//   _hull, ntgr, _uøns, _तली_,
   {{0x61e1e17e,0x69c6020f,0x68e9a509,0xbea586d2}},	//   _kull, _shke, lced, _палк,
   {{0x61e190f4,0xfaa30110,0x69d9b0a0,0x6f0500dd}},	//   _jull, гаро, _kiwe, dahc,
   {{0x61e1e17f,0xe9d701cf,0x61430258,0x98a000c3}},	//   _mull, екс_, леса, nfić_,
   {{0x7d0637a5,0x61e18bce,0x68f627a0,0x7d0094cf}},	// [5da0] maks, _lull, rbyd, _rems,
   {{0x7d064492,0x2904e180,0x6d5be181,0x637000f2}},	//   laks, zama_, _anua, _väns,
   {{0x290488a7,0x61e1c4b2,0x20090057,0xb87b046d}},	//   yama_, _null, asai_, _agíd,
   {{0x84e68221,0x2ac6801b,0x69d9e182,0x32180748}},	//   ходж, _líbí_, _niwe, mrry_,
   {{0xee49801c,0x61e1e183,0x6d498428,0xdb03862c}},	//   _lẽ_, _aull, _daea, konä,
   {{0x53349016,0x7d060406,0x753d009a,0xd848e184}},	//   тект, haks, zesz, _rọ_,
   {{0xd848d3a1,0x2d805711,0x60c28019,0x81e200ab}},	//   _sọ_, _olie_, _szom, নীর_,
   {{0x61e1cc86,0xd6570039,0xaca48135,0x7d06501e}},	//   _dull, _אילת_, _arụp, jaks,
   {{0x62873640,0x64a38190,0x69d9e185,0x753d0019}},	//   zzjo, _бата, _diwe, vesz,
   {{0x61e1870b,0x2904c230,0x75228065,0x6d628024}},	//   _full, sama_, lgoz, štač,
   {{0x61e18e5d,0x3eb895f8,0x9d191240,0xe0da8073}},	//   _gull, ært_, монт_, _еве_,
   {{0x29020025,0x7522a73f,0x7bda815d,0x68e98081}},	//   _neka_, ngoz, _hitu, cced,
   {{0x7bdacc21,0x753d100b,0x61e18a0f,0x79840010}},	//   _kitu, resz, _zull, dhiw,
   {{0x2d801af7,0x69d99f62,0x7bda8041,0x9f400037}},	//   _elie_, _ziwe, _jitu, ppiù_,
   {{0x61e187f4,0x7bdae186,0x6d960029,0x290203df}},	//   _xull, _mitu, mšan, _beka_,
   {{0x661e0057,0xdd9107d2,0xb6bb8039,0x7d066187}},	//   dupk, _خوب_, _מצוי, caks,
   {{0x69cd0bc5,0xe1340162,0x3dc902d5,0x7bdac893}},	// [5db0] rmae, ынты, _ihaw_, _oitu,
   {{0xf7730b76,0x2009335d,0x6da41487,0xf53f016d}},	//   دار_, rsai_, nđan, leå_,
   {{0x3dc9022c,0xcf9380be,0x661e00dd,0x6d9180e1}},	//   _khaw_, נטע_, gupk, sťam,
   {{0x79846188,0x7bda826b,0x5c759e9d,0x7c2bacfc}},	//   chiw, _aitu, клет, ttgr,
   {{0x61e1ada0,0x04459adf,0x8c45d3c9,0x7bdad621}},	//   _sull, телн, теле, _bitu,
   {{0x7bda8df1,0x6d960353,0x7d065ee9,0x9f9401ec}},	//   _citu, jšan, zaks, mäß_,
   {{0x7bda95ee,0x85bb8bbe,0xfebb026a,0x61e1811c}},	//   _ditu, _فارس_, _راست_, _qull,
   {{0x205591d0,0xb4e01251,0x61e1e189,0x27ef80b9}},	//   втор, _तले_, _vull, _ptgn_,
   {{0xee498104,0x7bdae18a,0xf7718872,0x7d062138}},	//   _sẽ_, _fitu, لاد_, vaks,
   {{0x61e1aa37,0x7bda8959,0x7655009a,0x6d9601a9}},	//   _tull, _gitu, _krzy, gšan,
   {{0x7d060665,0x3ea5cb8d,0xbea58b26,0xab848d15}},	//   taks, тинг, танк, _сутк,
   {{0xa3e64823,0x3dc901e9,0x7bdaba27,0xb90680ab}},	//   _बंद_, _chaw_, _zitu, _বড়_,
   {{0xe8188d38,0x7d060341,0x2902618b,0x394de18c}},	//   _दिया_, raks, _reka_, mdes_,
   {{0xc8838afe,0x394de18d,0x2902618e,0x27e2026c}},	//   ığı_, ldes_, _seka_, _rukn_,
   {{0x7d0636e2,0x79842895,0x7bce0168,0x69dc8061}},	//   paks, thiw, rmbu, _éret,
   {{0x320a1be9,0xaad384c5,0xdb071e1e,0x3cb30870}},	//   rsby_, धेयक, rojá, ụzụ_,
   {{0x6f03859c,0x1b1700c8,0x394de18f,0xdb1a8009}},	// [5dc0] _kenc, দ্ধে_, ides_, _yhtä,
   {{0x798420b3,0x7d044926,0x1acc80ab,0x2902074b}},	//   shiw, _heis, রুয়া, _weka_,
   {{0x6f03b9fd,0x29026190,0x7d040a4c,0x213f808e}},	//   _menc, _teka_, _keis, keuh_,
   {{0x6b8182af,0x394de191,0xdb0a804a,0x7d041fa4}},	//   _allg, jdes_, llfø, _jeis,
   {{0x3d07853e,0x7bda9bee,0xdb0a85e4,0x394dce2e}},	//   हणजे_, _pitu, sofí, ddes_,
   {{0xf6510019,0x39402fbc,0x7d043660,0x66e60251}},	//   جئے_, leis_, _leis, _јова,
   {{0x7bdae192,0x79a68f9c,0x76550035,0xcb1301c6}},	//   _vitu, крие, _grzy, בלו_,
   {{0x2902808b,0x394de193,0x32538081,0x7bda8db1}},	//   úka_, gdes_, рвър, _witu,
   {{0xf9931a0f,0xa3b22435,0xebe6835f,0x8c43cbfc}},	//   ירה_, टका_, _розп, _кете,
   {{0xd378e194,0x394d8722,0x394001e4,0x6f0396d6}},	//   _biće_, ades_, heis_, _cenc,
   {{0x7d0402af,0x82668077,0x6d96252a,0x6f03e195}},	//   _beis, _جهان, ršan, _denc,
   {{0xac190c8e,0xceb30051,0x7d0411cd,0x614684ae}},	//   ному_, יית_, _ceis, _једа,
   {{0x7d0420a4,0x394001ca,0x6d9600eb,0x2616864a}},	//   _deis, deis_, pšan, पूजी_,
   {{0x394b4105,0x6f0393a9,0xd37881a1,0x7dde81a9}},	//   _sacs_, _genc, _fiće_, _bīst,
   {{0xdcfb803a,0x9e348364,0x2d993b7a,0x7982b97d}},	//   _sluč, _сейч, éres_, _klow,
   {{0x7d0433e0,0x3dc9076d,0xdcfb80c3,0x6f03e196}},	//   _geis, _uhaw_, _pluč, _zenc,
   {{0x2d990665,0x6d5f6197,0x085521f6,0xd5b901a9}},	// [5dd0] mise_, _inqa, ываю, stās_,
   {{0x76550d38,0x7d046198,0x2d99138e,0x9f4d841c}},	//   _przy, _zeis, lise_, mpeã_,
   {{0x39402509,0x2d996199,0x6d96011f,0xb924019d}},	//   beis_, oise_, kšal, _jesụ_,
   {{0x2d995b35,0x39401820,0xa97900be,0x6d9602d4}},	//   nise_, ceis_, _נאָכ, jšal,
   {{0xa2d58a27,0x394d8711,0x68ed0df6,0xe4ff128a}},	//   येन्, vdes_, mcad, _štěň,
   {{0x2d99585b,0x447c00be,0x61e5005d,0x69dd619a}},	//   hise_, ונדע, _kuhl, _hise,
   {{0x69dd1fce,0x6f03e19b,0xdb07007b,0x61e50009}},	//   _kise, _renc, lljó, _juhl,
   {{0x6f03aeaa,0x394de19c,0x61e527f6,0xca748196}},	//   _senc, udes_, _muhl, рушы,
   {{0x6f0395bd,0x7d044932,0x2d99619d,0x3f858114}},	//   _penc, _reis, dise_, thlu_,
   {{0x69dd0573,0x7d04619e,0xd3788067,0x6d5f01b9}},	//   _lise, _seis, _piće_, _anqa,
   {{0xf7718077,0x69dd3715,0x2d9931ca,0x7d043760}},	//   لاگ_, _oise, fise_, _peis,
   {{0x69dd4b0f,0x78a48b89,0x63ad80f7,0x7de881d0}},	//   _nise, _žive, éanf, _těsn,
   {{0x3940518c,0x7d04619f,0x442f8362,0x1b0680ab}},	//   veis_, _veis, ntg_, _রাতে_,
   {{0xade30af3,0x7d0402af,0x69dd3f66,0x68fb8aa2}},	//   गदान_, _weis, _aise, lbud,
   {{0x7d0461a0,0x69dd61a1,0x81e580ab,0x2d9961a2}},	//   _teis, _bise, বীর_, bise_,
   {{0x644985db,0x2d9961a3,0x69dd44b9,0xdebc0326}},	//   _osei, cise_, _cise, _garƙ,
   {{0x07a60071,0x6e2185a3,0x39401839,0x200d9243}},	// [5de0] гаан, lulb, reis_, nsei_,
   {{0x44220886,0x69dd14cf,0x7dda801b,0x68ed61a4}},	//   muk_, _eise, _půso, acad,
   {{0x7c3bc395,0x7bde02c4,0x394003cd,0x4b7b03de}},	//   _apur, _iipu, peis_, _נאטו,
   {{0x69dd150f,0xc4868009,0xac0a95fc,0x1a9b03de}},	//   _gise, ллек, енда_, _טייע,
   {{0x4422336e,0x7bde4940,0x68fb9f40,0x6b98bbc8}},	//   nuk_, _kipu, dbud, tivg,
   {{0x66e3108d,0xdee30705,0x7c3b826c,0x2d9927f6}},	//   _гора, _гори, _dpur, zise_,
   {{0x442200d7,0xb4db0722,0x442f8122,0x6374e1a5}},	//   huk_, ndàr, atg_, _bànr,
   {{0x636b0a0b,0x7bde00e4,0x44220dc6,0x661a84e8}},	//   _düny, _lipu, kuk_, vrtk,
   {{0x442261a6,0x7f4e01c0,0xc17304de,0x656081a8}},	//   juk_, _kabq, מחה_, _inmh,
   {{0x2d9961a7,0x4422028a,0x3f9a010b,0x7bde61a8}},	//   wise_, duk_, nipu_, _nipu,
   {{0x7c22e1a9,0x06d780ab,0x2d9961aa,0x63b561ab}},	//   luor, _দ্বি, tise_, vozn,
   {{0x443b010c,0x61e50850,0x44222d93,0x7bde1fa4}},	//   _ppq_, _ruhl, fuk_, _aipu,
   {{0x2d995983,0x69dd61ac,0x7bde0133,0x68e28135}},	//   rise_, _rise, _bipu, _igod,
   {{0x2d9927f6,0x69dd2249,0x09bf06bf,0x7bde0573}},	//   sise_, _sise, ्ष्य, _cipu,
   {{0xf1a70a08,0x7bde08b3,0xf0b08117,0x637d810c}},	//   гран, _dipu, _دیکھ, _bènj,
   {{0x443b008e,0xeeeb00ff,0xd5a48019,0x2e139459}},	//   _tpq_, _đống_, _رہ_, _ابوح,
   {{0x69dd61ad,0x442261ae,0x6d42e1af,0x200f0019}},	// [5df0] _vise, cuk_, deoa, égi_,
   {{0xe8ff03d3,0x78bd026f,0x7bde61b0,0xe71900f7}},	//   _août_, _vysv, _gipu, ئيات_,
   {{0x7f4e0952,0xdced26d2,0x4fc40150,0xe7ea0035}},	//   _dabq, _hlađ, сста, _झूठा_,
   {{0xe8ff00e7,0xdced012b,0xe8df019d,0x71472306}},	//   _coût_, _klađ, _klọb_, _схож,
   {{0x27e6e1b1,0xab29a481,0x7c228037,0x2329867c}},	//   _nuon_, вола_, guor, воли_,
   {{0xdced003a,0xe2999c79,0x3f83012b,0xaa1584bd}},	//   _mlađ, кал_, _ulju_, афиј,
   {{0x442233bc,0x442fdd86,0x25a90144,0x45d5862c}},	//   zuk_, stg_, _ojal_, _вовс,
   {{0x44220967,0x27e6d1e9,0x200d8074,0xe8ff00e7}},	//   yuk_, _buon_, tsei_, _goût_,
   {{0x77858049,0x7c8790ef,0x64498364,0x68fb9277}},	//   илиз, _суве, _usei, rbud,
   {{0x7d0be1b2,0x6c848013,0x25a90006,0x47599156}},	//   lags, _الكم, _ajal_, трия_,
   {{0x3915826a,0x8d6604fa,0x7bde365d,0x200d8152}},	//   _نواز, авне, _ripu, ssei_,
   {{0x44221dae,0x38608052,0x7d0b9066,0x200d8162}},	//   tuk_, _šire_, nags, psei_,
   {{0x0c230656,0x6e218420,0x26050072,0x660b8084}},	//   омян, sulb, हीती_, _šokė,
   {{0x68e28e8b,0x44221600,0x6a8647a7,0x7d0b807b}},	//   _zgod, ruk_, алга, hags,
   {{0x44220393,0xe2970037,0xf8bf077f,0xd19600a9}},	//   suk_, аар_, _ayé_, ашањ,
   {{0x44220397,0xd378ac08,0x394f9407,0xe9df1b88}},	//   puk_, _mića_, _jags_, _ciú_,
   {{0xe0da2bd9,0x55bb0051,0x7bde5b92,0x7d0ba1b4}},	// [5e00] тва_, _במקו, _tipu, dags,
   {{0x6fc200e1,0x7c228198,0x7f4e01b4,0xdced0609}},	//   môck, vuor, _qabq, _imaġ,
   {{0xdd8f0077,0xe9df16a5,0x6f0708ae,0x81ab8264}},	//   _روی_, _fiú_, _dejc, _গঠন_,
   {{0x1636893f,0x2bb4023c,0x26170105,0x3f9a61b3}},	//   ינער_, ंकवा, _पटरी_, sipu_,
   {{0x6c54bbae,0x9346c055,0xd4038a0e,0xcb6aa0bf}},	//   склу, инде, оящи, каде_,
   {{0xd378805c,0xa6ca07b6,0xe45703de,0x5bb7902a}},	//   _bića_, _алга_, יינט_, алія_,
   {{0x80db00ab,0x6d960390,0xe81e06f0,0x7d0bb88d}},	//   যুদ্, ršaj, यंका_, bags,
   {{0x26ca0904,0x39524cfa,0x316d83ed,0x6379026b}},	//   _izbo_, ndys_, gjez_, _hìnt,
   {{0xab668389,0x394fa3fe,0x2cbf9341,0x7c2280e5}},	//   _квал, _dags_, _gyud_, quor,
   {{0x10370039,0x1be10fce,0xd3788088,0x25a91388}},	//   סטים_, _गूगल_, _fića_, _sjal_,
   {{0xdceb2cf7,0xdced192c,0x628e0bcf,0x9a6a8250}},	//   šiča, _slađ, jzbo, _جمال_,
   {{0x63b8e1b4,0xd5b80cde,0x68e2ab09,0xd6d78084}},	//   lovn, ися_, _ugod, шты_,
   {{0x28d28e70,0x0f1100ab,0x7d160114,0x8fa682ac}},	//   देशि, স্টঃ_, _ddys, _каде,
   {{0x2cad04b7,0x798600fc,0xa3cc864a,0x61e881f6}},	//   ħed_, _alkw, रगट_, _kudl,
   {{0xb3458073,0xdce0801b,0xda780081,0xdcef89d1}},	//   leçã, _pomě, аят_, _šeče,
   {{0x7de18029,0x63b887dd,0x3f986033,0x61e88197}},	//   _vēst, hovn, _amru_, _mudl,
   {{0x63b88ee1,0x0f150221,0x6b9c4165,0x26c5368d}},	// [5e10] kovn, ймаю, birg, _šlo_,
   {{0x7d1d8117,0xeeeb0104,0x644d61b5,0x5eab00c8}},	//   _össz, _đồng_, _isai, _করবে,
   {{0xd6db0698,0x7d0b9614,0xdfd80098,0x6f07128a}},	//   тта_, tags, рът_, _vejc,
   {{0xe945003d,0x25a6e1b6,0xb6d980be,0x3ed983de}},	//   _اردی, gnol_, אַנט, אַנא,
   {{0xe81e0ee6,0xa3ae15bc,0xf0d281bc,0x7d0b90b9}},	//   _पिया_, _कदम_, _dịkọ, rags,
   {{0x7f850013,0xd3788024,0x63b8807a,0xdb0380e7}},	//   _السن, _pića_, govn, onné,
   {{0x752d002e,0x7989805d,0x7d0b97ea,0x799b808e}},	//   _ocaz, thew, pags, tiuw,
   {{0xe81889a3,0x2129078a,0x78a486c2,0x016580a9}},	//   _दिशा_, ngah_, _živa, скио,
   {{0xa3b7131d,0x2d9d8435,0x628e00b9,0x79898a53}},	//   जवा_, miwe_, zzbo, rhew,
   {{0x63b88a56,0x23748013,0x2d9daeed,0xab748013}},	//   covn, _والح, liwe_, _والإ,
   {{0xd90f8986,0x7d098359,0x1d0a1354,0x394f86f3}},	//   _ہیں_, _kees, лени_, _tags_,
   {{0x645b9384,0x443f861b,0x7d099572,0xaca380ff}},	//   _krui, _kpu_, _jees, _ngừn,
   {{0x7d0998ce,0x2b1b83bb,0xe739b4fb,0x753b93fa}},	//   _mees, _नयाँ_, _бел_, _mbuz,
   {{0xf1b9e1b7,0x7d099dab,0x443fdf91,0xd8d681c6}},	//   loš_, _lees, _mpu_, _פוסט_,
   {{0xa2bb0fce,0x15f5845b,0x25a6831d,0x2d9db64e}},	//   _शुद्, _استح, ynol_, kiwe_,
   {{0x69cf21d5,0x7d0980eb,0x2d8b026f,0x212937c0}},	//   _chce, _nees, chce_, ggah_,
   {{0xf1df81ce,0xa06701f3,0x6564009c,0x443fdcbb}},	// [5e20] _पूछन, бата_, _inih, _npu_,
   {{0x753be1b8,0x4b260112,0x6d4661b9,0x9b4612c8}},	//   _abuz, _умов, leka, _اندو,
   {{0x6564003e,0x7d09d045,0xe61a3314,0xf1b98140}},	//   _knih, _bees, уде_, koš_,
   {{0x645b94cc,0x10a61ddf,0x7d098579,0xe818816f}},	//   _brui, _гимн, _cees, _दिला_,
   {{0x29000f84,0x63b89fd4,0xe3bf05e4,0x61e88bb1}},	//   mbia_, tovn, luña_, _sudl,
   {{0x645b9581,0x6d4661ba,0xdd92853d,0x3f98017f}},	//   _drui, heka, _کور_, _umru_,
   {{0x3ce98289,0x63b88a56,0x7d09838e,0x443f80ee}},	//   žava_, rovn, _fees, _epu_,
   {{0x6d460025,0x7d09e1bb,0xb3458073,0xf1b98088}},	//   jeka, _gees, teçã, goš_,
   {{0x645be1bc,0x63b8812b,0x61e8b26a,0xc95301c6}},	//   _grui, povn, _wudl, למה_,
   {{0x69c40352,0xb34583a7,0x752d0087,0x61e88ec9}},	//   hlie, reçã, _scaz, _tudl,
   {{0x7d098ef2,0xdceb3c6d,0x69c45896,0x61fc026c}},	//   _yees, žičn, klie, jprl,
   {{0x443f80b9,0x65760144,0x290dd23d,0xd3788140}},	//   _ypu_, _coyh, caea_, _kićo_,
   {{0x4426803b,0x69c461bd,0xb4e9154b,0x7c263327}},	//   nuo_, dlie, _बली_, gukr,
   {{0x2d9de1be,0xd3788390,0xf41f0198,0x69c40901}},	//   ziwe_, _mićo_, rrä_, elie,
   {{0x6d46063d,0x3f9ee1bf,0x60c290e4,0x98b001b9}},	//   beka, mitu_, _hyom, _ħaġa_,
   {{0x3f9eabf8,0x69c40698,0x644d61c0,0x6440808e}},	//   litu_, glie, _tsai, _opmi,
   {{0x644d00db,0x7d0f61c1,0x61e2aab5,0x442681bc}},	// [5e30] _usai, macs, _miol, juo_,
   {{0x44268d46,0x3f9ede51,0x7d09e1c2,0x32110035}},	//   duo_, nitu_, _sees, pszy_,
   {{0x69c44a3f,0x29000081,0x2d9d8435,0x9f40008b}},	//   blie, bbia_, tiwe_, rpið_,
   {{0xd6d8286e,0x7d0f02a3,0x44268a54,0x05c9090f}},	//   сту_, nacs, fuo_, रतिब,
   {{0x60c28065,0x4426e1c3,0x78a4826f,0x2d9d82a0}},	//   _nyom, guo_, _živn, riwe_,
   {{0x6d460c5a,0x7d0992eb,0xe81e275c,0x2d9dbc07}},	//   zeka, _wees, _पिता_, siwe_,
   {{0x3f9ed0b8,0x2d820bc5,0x290b0b80,0x1dc9016f}},	//   ditu_, ykke_, _keca_, रतात,
   {{0xa3e90935,0x4426b537,0x753ba9da,0x798d0cf4}},	//   यदा_, buo_, _ubuz, nhaw,
   {{0xf1b98b67,0x61e2e1c4,0x44268568,0x52fb001b}},	//   roš_, _diol, cuo_, ्राउ_,
   {{0x3f9e8ee2,0x69c40029,0x6d46497a,0xf1b99f3a}},	//   gitu_, zlie, weka, soš_,
   {{0x27e30586,0x6d462be2,0xa119880b,0x798d4a73}},	//   _mijn_, teka, _نقاط_, khaw,
   {{0x27e300f3,0x69d08424,0x798d01e9,0x2bee081f}},	//   _lijn_, _डीपी, jhaw, _इंदू_,
   {{0x6d463a2f,0x98c78013,0x3f9ec5b0,0xef0ec90d}},	//   reka, _اغان, bitu_, _ом_,
   {{0x7c262414,0x2b47823e,0x3f9eb732,0x29190609}},	//   rukr, nenc_, citu_, _adsa_,
   {{0x44268135,0x7d0f61c5,0x290b1fd6,0x6d461aed}},	//   zuo_, bacs, _beca_, peka,
   {{0xe3bf07f4,0xddc3017a,0x290b1f3a,0xe8fa0f25}},	//   ruña_, _общи, _ceca_, рла_,
   {{0x290b61c6,0x387f89e1,0x386d8118,0xb4c88c28}},	// [5e40] _deca_, nyur_, nxer_, _उरे_,
   {{0x290002d6,0x69c461c7,0x291900e4,0xbc6a9190}},	//   sbia_, slie, _edsa_, یمان_,
   {{0xdb18820f,0x69c40add,0xfa6a0329,0x290b076b}},	//   sovë, plie, _танк_, _feca_,
   {{0x4426e1c8,0x2e3a80be,0x63bc03d5,0x302a1fb4}},	//   tuo_, יגענ, lorn, _комп_,
   {{0x973c8024,0x27e300f3,0xdb188e93,0x2019816b}},	//   liće, _fijn_, lové, ásil_,
   {{0x44269c8c,0x63bc61c9,0xd7c5016f,0x925a80f7}},	//   ruo_, norn, वतःच, لشعر_,
   {{0x63ad8307,0x973c8668,0xdb18c72f,0x3f9ea46d}},	//   éana, niće, nové, vitu_,
   {{0x27e31dbe,0x63bc0c8d,0xb4e9052a,0x3ea70144}},	//   _zijn_, horn, _बले_, únte_,
   {{0x44268998,0x973c80d2,0xd90d80d7,0x3f9ee1ca}},	//   quo_, hiće, ایه_, titu_,
   {{0x4734867c,0x60c28010,0x3dc6e1cb,0xdfd080f7}},	//   чнос, _vyom, llow_, عيد_,
   {{0x63bc2c22,0x3f9ee1cc,0x973c8289,0xddc90084}},	//   dorn, ritu_, jiće, rydž,
   {{0x973c81dd,0x7d028cfa,0xdb18816b,0x9c1301bc}},	//   diće, nbos, dové, _jọgb,
   {{0x9ccb0084,0x290b61cd,0x160a0072,0xe7ea00c2}},	//   рына_, _reca_, हीतर_, _झूला_,
   {{0x63bc2766,0x3dc6808e,0x798d0362,0xdceb81f4}},	//   gorn, hlow_, whaw, _čičo,
   {{0xd3788d11,0x973c84a8,0x27e35b67,0x442227d1}},	//   _moć_, giće, _rijn_, ark_,
   {{0xdb18816d,0x442201f4,0x3f8a11ec,0xf7709ab3}},	//   llvä, brk_, _albu_, _تاچ_,
   {{0x63bc3dbb,0x27e300f3,0x12e70048,0x290b5ec0}},	// [5e50] born, _pijn_, _мінг, _veca_,
   {{0xd3788025,0x798d407c,0x973c9487,0x2bd2063a}},	//   _noć_, shaw, biće, _दीपा,
   {{0x78a48db7,0x6e288db7,0xc332010f,0x6d96011f}},	//   _živl, nudb, _אוי_, ršav,
   {{0xf1a71fa9,0x3dc6dc52,0xb8d100ab,0x27e300f3}},	//   _фрон, glow_, _ওর_, _wijn_,
   {{0xdfdb0698,0xe3b004c0,0x6d9602a5,0x661d809a}},	//   _във_, _سری_, pšav, ąski,
   {{0x39495f64,0x9f4300f1,0x8cce0ee6,0x7d0d435c}},	//   leas_, _mijë_, _सरसो, _leas,
   {{0xa91b007b,0xd3788369,0x7d02aa96,0xb5a792c0}},	//   _alþi, _doć_, bbos, _драй,
   {{0x63bc0696,0xdb038e15,0x98af82a5,0x386d8722}},	//   zorn, tonó, šače_, txer_,
   {{0x3dd20114,0x637d80d7,0x973c8bcf,0x7d1b9267}},	//   _rhyw_, _bènt, ziće, _idus,
   {{0x39490cac,0x63bc1042,0xdb038333,0x6e288267}},	//   heas_, xorn, ronó, fudb,
   {{0xa2bb223a,0x98ab83bf,0x6d960668,0x637d810c}},	//   _शुल्, ıcı_, kšat, _dènt,
   {{0x973c803b,0x7d0d61ce,0x7c2480f7,0xdb0381a8}},	//   viće, _ceas, áirg, inní,
   {{0xd1b884c0,0x7d0d0046,0x394961cf,0x7bc70267}},	//   _بالا_, _deas, deas_, flju,
   {{0x27ff8077,0xff5187d2,0xdb18826f,0x973c8289}},	//   mpun_, _سخت_, tové, tiće,
   {{0x7d1b803a,0x63bc61d0,0x67210009,0x69d0864a}},	//   _odus, rorn, _öljy, _डीडी,
   {{0x973c81dd,0x31660b5a,0xdb18816b,0x7d0d49fe}},	//   riće, ñoz_, rové, _geas,
   {{0xa2a28bb8,0xef1a0596,0x27ff9ad4,0x1dc900d4}},	// [5e60] _केन्, йма_, npun_, रतरत,
   {{0x6d56083a,0x98a68668,0xdb0a816d,0x7d1be1d1}},	//   _haya, šiće_, llfö, _adus,
   {{0x7d0d61d2,0xee3a34d6,0x27ff87d5,0xdd8f803d}},	//   _yeas, сне_, hpun_, گون_,
   {{0x39492483,0x27ff90e1,0x63ad81a8,0xdd9980e8}},	//   ceas_, kpun_, éann, оші_,
   {{0x6d5661d3,0x291261d4,0xdd8f8829,0xd37880c3}},	//   _maya, maya_, دون_, _poć_,
   {{0x6d560587,0x291261d5,0x7d1b8009,0xa3b200d4}},	//   _laya, laya_, _edus, टकट_,
   {{0x61e6050b,0xdb03823e,0x9c13019d,0x6da400c3}},	//   _kikl, tonò, _tọgb, nđas,
   {{0x29122b95,0x7de8800d,0x637d89c4,0x7bc18338}},	//   naya_, _měst, _bèns, _eklu,
   {{0x61e61de9,0x7d0d0039,0xdb03e1d6,0xdcfb85f3}},	//   _mikl, _reas, ronò, _sluć,
   {{0x1b0f8a49,0x29124450,0xdcfb8024,0xe7be0d72}},	//   _সাথে_, haya_, _pluć, ्तिप,
   {{0x6d5631b3,0x7bc7003a,0x64443353,0xb3471243}},	//   _baya, vlju, _apii, _liçõ,
   {{0x29120397,0x6d560079,0x61e651e1,0xb7d78065}},	//   jaya_, _caya, _nikl, _ہونا_,
   {{0x6d56395c,0x6fbe0e1a,0x29121ad4,0x6e28e1d7}},	//   _daya, ्तां, daya_, sudb,
   {{0x7dda801b,0x9f4303ed,0xe3bf0118,0x237a00e5}},	//   _zůst, _vijë_, ruño_, _copj_,
   {{0x7d0d14f2,0x6d408289,0x20070668,0x39490834}},	//   _teas, _obma, ćnim_, teas_,
   {{0x291261d8,0x25a22828,0x5eab00ab,0x31c40073}},	//   gaya_, cikl_, _করলে, есув,
   {{0x394961d9,0x78a4a368,0x61e661da,0xdb1a8298}},	// [5e70] reas_, _živj, _dikl, _aktí,
   {{0x3949517b,0x44395424,0x442b1498,0x6d565998}},	//   seas_, mts_, muc_, _zaya,
   {{0x291261db,0x6d56534f,0x443913a0,0x394905e4}},	//   baya_, _yaya, lts_, peas_,
   {{0x2912469d,0x7ddf189e,0x210082d4,0x6d563dd5}},	//   caya_, _būsi, nčič_, _xaya,
   {{0x44390b39,0x442b61dc,0x63ada509,0x657d0168}},	//   nts_, nuc_, éano, ërhy,
   {{0x44391098,0x6f1c0118,0x69d8047f,0xbb428081}},	//   its_, _gdrc, _èver, вешк,
   {{0x443961dd,0x6d86002a,0x442b555a,0xdce89238}},	//   hts_, _sóam, huc_, _çoğa,
   {{0x44390029,0xdb1c00f1,0x27ff8359,0x80658ba5}},	//   kts_, torë, tpun_, движ,
   {{0x349489c7,0x27ff8867,0x6d4b8057,0x442b02a5}},	//   _затр, upun_, mega, juc_,
   {{0x291261de,0x27ff87d5,0x442b61df,0x6d598417}},	//   zaya_, rpun_, duc_, ldwa,
   {{0x63a3b3d9,0x291261e0,0x25a20115,0x4439547c}},	//   minn, yaya_, tikl_, ets_,
   {{0x63a3e1e1,0x6d4be1e2,0x7c248024,0x64a601e5}},	//   linn, nega, šire, дама,
   {{0x6d560f03,0x61e661e3,0xe72e846e,0x7c2bb7c0}},	//   _vaya, _rikl, _ие_, nugr,
   {{0x69c9a551,0xa3cd81c4,0x6d4be1e4,0xa3bf81c4}},	//   llee, रति_, hega, ीति_,
   {{0x0caa823c,0x2912336a,0x6d5643b7,0x28e006b7}},	//   _कश्म, taya_, _taya, पेनि,
   {{0x63a3e1e5,0x6d4be1e6,0x69db8216,0x69c9e1e7}},	//   hinn, jega, nmue, nlee,
   {{0xb906053e,0x44390051,0x6d4be1c4,0x63a3e1e8}},	// [5e80] _पण_, cts_, dega, kinn,
   {{0x291261e9,0x78a48d11,0x63a3e1ea,0x65699ad4}},	//   saya_, _živk, jinn, _aneh,
   {{0x27e7e1eb,0x63a3e1ec,0x69c9cc05,0x27ef8106}},	//   _minn_, dinn, klee, _lugn_,
   {{0x27e7e1ed,0x290fe1ee,0x3ea70013,0x6d4be1ef}},	//   _linn_, _nega_, únta_, gega,
   {{0x6f0e01c5,0x63a3af9c,0x6aa6b4c7,0xc7b98061}},	//   _tebc, finn, गप्र, tről_,
   {{0xf626038c,0x290f8074,0x69c2d947,0x6f1c08ae}},	//   _одго, _aega_, _skoe, _udrc,
   {{0x6d4be1f0,0xd2578a14,0xe5a68b9c,0x13398019}},	//   bega, дцы_, _живи, ستوں_,
   {{0x290f8052,0xd90d80d5,0xdb1c016d,0xaca4819d}},	//   _cega_, میم_, llrä, _asụp,
   {{0x290f99eb,0x274a8009,0x63a38ed4,0x27e78219}},	//   _dega_, очно_, binn, _binn_,
   {{0x27e78cac,0x61fe005c,0xdb150019,0xfc67803d}},	//   _cinn_, _otpl, kozá, _تخفی,
   {{0xd12f8f2f,0x69c9da1a,0xdce08029,0xe5350678}},	//   _их_, blee, _tomē, нень,
   {{0x4426c5e1,0x27e78125,0x38698503,0x443924c0}},	//   oro_, _einn_, _šare_, tts_,
   {{0x20070024,0x27e7821e,0x5c7402c7,0x61fe02d7}},	//   ćnik_, _finn_, влят, _atpl,
   {{0x4426956b,0x443961f1,0xcf2680d7,0xf8ad8019}},	//   iro_, rts_, _آرشي, _چکی_,
   {{0x443961f2,0xeb9180be,0x44268428,0x7d0d81fa}},	//   sts_, אָן_, hro_, ðask,
   {{0xd378811f,0xdce4016b,0x63a3e1f3,0xceb3807c}},	//   _dići_, _znič, zinn, _שיק_,
   {{0x629a00e1,0x777c0168,0x90990081,0x2e388118}},	// [5e90] útor, _borx, чват_, léf_,
   {{0x69c0e1f4,0x657bba4b,0x2d9f80b9,0x6d4b8365}},	//   home, _souh, _smue_, wega,
   {{0x69c0b063,0x63a3d47e,0x4426a752,0x6d4b9044}},	//   kome, vinn, ero_, tega,
   {{0x63a39c48,0x4426e1f5,0x69c08035,0xdb1c03c9}},	//   winn, fro_, jome, voré,
   {{0x69c0e1f6,0x290f9686,0x777c03a8,0x69c981ed}},	//   dome, _rega_, _forx, vlee,
   {{0x290fdcca,0x42558767,0x6d4bc721,0x7c39951e}},	//   _sega_, етит, sega, rtwr,
   {{0x63a3d245,0x4426ade6,0x6d4b8359,0x290f84f0}},	//   rinn, aro_, pega, _pega_,
   {{0x27e7e1f7,0x3cf90035,0x6569b553,0x973c8140}},	//   _sinn_, ंडों_, _uneh, vića,
   {{0x69c9c0f1,0x20198019,0xb7bd802e,0x63a392a5}},	//   rlee, ési_, luţi, pinn,
   {{0x2007005c,0x290f81bc,0x69c9caad,0x39591690}},	//   ćnih_, _wega_, slee, _lass_,
   {{0x290f8db7,0x27e79bb8,0xaa9580f7,0xd13181a8}},	//   _tega_, _vinn_, _ثلاث, _مما_,
   {{0x69c0a5a7,0xdb0a003e,0xceb202f6,0x6a538201}},	//   come, čník, ריט_, _nəfə,
   {{0x394d8006,0xd378817f,0x27e7e1f8,0xa2838019}},	//   mees_, _sići_, _tinn_, _سیکو,
   {{0x33d50d13,0xe51f81a2,0x394d81b0,0x399183a8}},	//   віст, मृति_, lees_, _dáse_,
   {{0x6da6117e,0x1a6602e3,0x3243062c,0xfb8501e2}},	//   _пика, ریحی_, лерг, тыўн,
   {{0x394dca3f,0x7989b6ba,0xdb152792,0x4426e1f9}},	//   nees_, nkew, rozá, yro_,
   {{0x3959034a,0xf992893f,0x1f660470,0xe3b207d2}},	// [5ea0] _dass_, ארן_, нкам, _مرد_,
   {{0xdb18e1fa,0x44268073,0xdc3b0039,0x69c093fa}},	//   toví, vro_, _צעיר, zome,
   {{0x7dca808b,0x3959048d,0x69c0e1fb,0x61fe1be9}},	//   lýsi, _fass_, yome, _utpl,
   {{0x4426dd43,0x395914e0,0xf6510019,0x69c08118}},	//   tro_, _gass_, گئے_, xome,
   {{0x4426e1fc,0x69c08823,0xdceb011f,0x7dd60118}},	//   uro_, vome, šića, cáse,
   {{0xdb18801b,0x69c0d2ea,0xb7bd8087,0x9f478168}},	//   poví, wome, buţi, _dinë_,
   {{0x1c1c823c,0x394d867f,0xc33303de,0x60e58085}},	//   _निकल_, fees_, אוו_, ərmə,
   {{0xd25981e2,0x394006ab,0xdb03810c,0x2b5a1670}},	//   ьці_, nfis_, hinè, _lapc_,
   {{0xdcef803a,0xcfa68758,0xf9930039,0xd84e81bc}},	//   _šeće, ешни, טרה_, _gọlf_,
   {{0x69c0a892,0x25a6d340,0x6d444689,0x661c08ae}},	//   some, liol_, _abia, _kvrk,
   {{0x69c086d4,0x6456178f,0x394da79e,0x6d44026c}},	//   pome, _asyi, bees_, _bbia,
   {{0xceb3004c,0x394dbd3e,0x25a6c03e,0xac19054c}},	//   טית_, cees_, niol_, мому_,
   {{0xa3bd109b,0x6fcb0192,0xdb1c0428,0x395961fd}},	//   इकल_, büch, gorï, _rass_,
   {{0x6fcb02af,0x6a538201,0x25a68114,0x69c6000b}},	//   rück, _səfə, hiol_, _akke,
   {{0x2d9903d3,0x1c1d0074,0x7ddf0110,0xdb0a9727}},	//   ères_, _भटकल_, _būst, lofó,
   {{0x6298803b,0xdb038168,0xf1a40a4c,0x2b5a07f1}},	//   izvo, tinë, грун, _eapc_,
   {{0x656d2dde,0x25a6831d,0x6d4f178f,0x2bd2009a}},	// [5eb0] _inah, diol_, meca, _दीवा,
   {{0x7dd611a9,0x69c60125,0x6d4f0063,0x6d5d2c15}},	//   ráse, _ekke, leca, ldsa,
   {{0x1b0f80ab,0x765a01ac,0xf770045b,0x7c2f3cfe}},	//   _সালে_, _štyr, حاق_, lucr,
   {{0xe821823c,0x6d5d0d1a,0x6d4f4fd9,0x63a72ea4}},	//   _मिला_, ndsa, neca, lijn,
   {{0x76550d38,0xf8d50105,0xbde5826b,0x2fd900f7}},	//   _wszy, _दरिय, _abèé, _يوجد_,
   {{0xfaa59986,0xe61361fe,0x63a74171,0x394d81b0}},	//   кало, _مشر_, nijn, wees_,
   {{0x25a682e6,0xbd0580e7,0x69cd0114,0x41b59155}},	//   biol_, _créé, olae, ксит,
   {{0x6d4f02fd,0x63a71696,0x290901b4,0x25a6e1ff}},	//   jeca, hijn, nbaa_, ciol_,
   {{0xdd948196,0x6d4f3e1e,0xc8db8361,0x6594802e}},	//   _саты, deca, मेंट, _сату,
   {{0xfd4d8028,0x656d6200,0xd378825b,0x66e581a4}},	//   _ngoạ, _anah, _biću_, копа,
   {{0x9f47801b,0x63a7016b,0x6d5be201,0x6fcb01ec}},	//   _jiné_, dijn, _kaua, rüch,
   {{0xe5a61e25,0x7bc3e202,0xdb03c533,0xb33c81b9}},	//   тими, lonu, diné, _imħa,
   {{0x6d5b80f6,0x399a8158,0x69cd031d,0x1fb58b5b}},	//   _maua, _קינד, dlae, _искр,
   {{0x6d5be203,0xd37881f4,0x7bc3e204,0x63a75c9a}},	//   _laua, _fiću_, nonu, gijn,
   {{0xc3328bea,0x442fe205,0xdb18e206,0x6d4f347d}},	//   יום_, hug_, nová, beca,
   {{0x38608503,0x3a25008b,0x64499ea8,0xdb1c34cd}},	//   _širi_, álpa_, _opei, morí,
   {{0x61ebe207,0x09e3176e,0xdb1883fb,0xdb1c386d}},	// [5ec0] _migl, ротн, hová, lorí,
   {{0x38601b01,0xcfb500c8,0xe0d71a12,0xdb18801b}},	//   rvir_, _জীবন, тву_, ková,
   {{0xe9da04ae,0xdb1c157a,0x1fb50615,0xe3b223f7}},	//   _око_, norí, устр, _مرگ_,
   {{0x5bcaa38c,0xdb1883fb,0x2d800036,0x8ab701c6}},	//   ित्व, dová, _joie_, _יהיו_,
   {{0x7bc3b349,0x25a68114,0x6449802a,0x6d5be208}},	//   fonu, riol_, _cpei, _daua,
   {{0xdceb1123,0xd7030098,0x661aa7d1,0x7bc3c480}},	//   žićn, _взри, ystk, gonu,
   {{0x5ee000c8,0x61ebe209,0xa6e000ab,0xdb1c16f3}},	//   _প্রে, _bigl, _প্রয়, jorí,
   {{0x442f833e,0xdb1c620a,0x69d9831d,0x2fc78637}},	//   bug_, dorí, _chwe, _akng_,
   {{0x6d4f00d2,0x61eb80d2,0xdb348bca,0xbcfb0036}},	//   veca, _digl, _مذاک, ndée,
   {{0x656d016b,0x81d800ab,0xd3788390,0x2d92620b}},	//   _snah, াদি_, _piću_, _alye_,
   {{0xdb1c160a,0x7f5c3274,0x6d4f620c,0x61eb8098}},	//   gorí, _marq, teca, _figl,
   {{0x891a87d2,0x661ae20d,0x63a7620e,0x61eb81e8}},	//   _آغاز_, rstk, wijn, _gigl,
   {{0x2019800d,0x6dbc94ce,0xae068cfd,0x5f76803d}},	//   ásit_, mčad, वीजन_, _لاغر,
   {{0x8fa39056,0xdb0700f1,0xdb03a538,0x2d9202d6}},	//   _каче, mijë, tiné, _elye_,
   {{0x248d1874,0x7c2f347a,0x442f81ec,0x63a74502}},	//   šem_, sucr, zug_, rijn,
   {{0x7bc3e20f,0x6dbc825b,0x656d6210,0xe5c400e8}},	//   zonu, nčad, _unah, _всьо,
   {{0x98a20201,0x3dc9049f,0x7bc38059,0xdb18801b}},	// [5ed0] _bakı_, _ikaw_, yonu, zová,
   {{0x2fc75871,0x3b5512b2,0x24840198,0x7f5c6211}},	//   ông_, _скор, ämme_, _carq,
   {{0xa2a2835a,0xd00684c0,0x6449e212,0xcf9380be}},	//   _केल्, _گل_, _spei, סטע_,
   {{0xdb1881d0,0x7bc8810c,0x6dbc81a1,0x442fe213}},	//   vová, _akdu, jčad, tug_,
   {{0xd006803f,0x7c24803b,0xa3b80077,0xfc3f6214}},	//   _دل_, širn, _سایر_, ntí_,
   {{0x442f8166,0x61ebe215,0xdb1c0693,0xdb189be6}},	//   rug_, _sigl, yorí, tová,
   {{0x442f8aff,0x05bb8c48,0x61eb80e5,0xa9a5a81c}},	//   sug_, _قدرت_, _pigl, ликд,
   {{0xdb18800d,0x2fc780b9,0x61fe816b,0x386681a3}},	//   rová, _skng_, ípla, _bror_,
   {{0xdb1881d0,0x61ebd1ff,0x7bc3e216,0xf94a03de}},	//   sová, _vigl, ponu, געפֿ,
   {{0xdb1c2848,0x2d9900f3,0x68fbd03e,0xdb1881d0}},	//   torí, ëren_, scud, pová,
   {{0x6f1505a4,0x386692bf,0x1bec82f1,0x61ebe217}},	//   _mezc, _eror_, _छूटल_, _tigl,
   {{0x3ce98052,0xed5700e8,0x6b81cb70,0x78b981c0}},	//   žavu_, гою_, _holg, _txwv,
   {{0x711a804c,0xdb1c05e4,0x2d8052c5,0xf7459612}},	//   _נוספ, sorí, _voie_, _бело,
   {{0xf77387bd,0x395faf89,0xe739859d,0x6dbc8b80}},	//   _خاص_, ldus_, _чек_, pčag,
   {{0x395d8282,0x6b81b003,0x442b0635,0x69c41a06}},	//   _kaws_, _molg, arc_, toie,
   {{0x395fd747,0x798d221b,0x7d198035,0x6d4e136f}},	//   ndus_, gkaw, jaws, íhač,
   {{0x7f5c26d5,0xdb018019,0xa3e38327,0x38660174}},	// [5ee0] _parq, _emlé, नगा_, íor_,
   {{0xe3b21a37,0x7d160079,0xe7370088,0xb8cc02f1}},	//   _درب_, _heys, леу_, _कइ_,
   {{0x11d609a7,0x6fd00338,0x798d0326,0x7c2b8299}},	//   _متحد, läck, bkaw, ergr,
   {{0x7bda80f1,0x7f5c0079,0xa80602d0,0xc51699ea}},	//   _shtu, _warq, ttığ, ابات,
   {{0xd8760250,0x395f831d,0x7f5c00e5,0x7d1610ea}},	//   _صاحب, ddus_, _tarq, _meys,
   {{0x6b818511,0x7c24817f,0x39525778,0x9326803d}},	//   _colg, širo, leys_, ارشن,
   {{0x6b81e218,0x2d9c80e7,0x2611807a,0x3d0b8072}},	//   _dolg, èves_, jšo_, ारखे_,
   {{0x2bdb11bc,0x3160478b,0x395de219,0xa8060214}},	//   _मीना, ndiz_, _caws_, ptığ,
   {{0x6b81adad,0x395d81e9,0xa3c4000d,0x5b368872}},	//   _folg, _daws_, एका_, _معار,
   {{0xa2bf86b7,0xa8570039,0x973c8042,0x75240f3e}},	//   _लुक्, נייה_, mićk, _adiz,
   {{0x9f4a00f7,0xd6d084a3,0x3f6381e5,0x35b5148d}},	//   _cibé_, تقد_, стыб, ибор,
   {{0x3866904a,0xd6d781bb,0x386080d2,0x6d468106}},	//   _tror_, ыты_, _širu_, _ökad,
   {{0x98a38676,0x5b270c73,0xe4a7018b,0x5eab00ab}},	//   _лице, льва, урно, _করছে,
   {{0x7524621a,0x44200110,0xbe8680d5,0xfc3f621b}},	//   _ediz, _dvi_, _مجبو, rtí_,
   {{0xfc3f0626,0xdcfb800d,0x6f1ae21c,0x442020fb}},	//   stí_, _souč, matc, _evi_,
   {{0x19580196,0x7d160bde,0x6f1ae21d,0x6fd04255}},	//   ласы_, _geys, latc, läch,
   {{0x798d621e,0x2d9900f7,0x0f150c4f,0x97152e65}},	// [5ef0] rkaw, mhse_, имаю, имац,
   {{0x6fd001ec,0x973c826c,0x644d0637,0x7d198122}},	//   näch, dićk, _ipai, waws,
   {{0xb8cc0403,0xb87b07d0,0x941f8085,0x644e007a}},	//   _के_, _egíp, ərək_, čniš,
   {{0x6b818257,0x7bc7621f,0x29f8011f,0xa2bf90f7}},	//   _solg, loju, _očaj_, _लुग्,
   {{0xf41f0364,0x6d5f02a3,0x58870196,0x395d81e9}},	//   nsä_, _maqa, _сына, _raws_,
   {{0x20090393,0x395dabf4,0x6a85853b,0x7bc7252a}},	//   mpai_, _saws_, илла, noju,
   {{0x6b8198db,0x395dbdd7,0x2fc580c9,0x52758012}},	//   _volg, _paws_, volg_, рулу,
   {{0x91fc80eb,0xaca38133,0x395dcbb6,0xd18580e5}},	//   _grām, _agụn, _qaws_, рлий,
   {{0x3f83012b,0x5d8496a5,0x395fd660,0x20096220}},	//   _koju_, _القل, rdus_, npai_,
   {{0x6f1a9502,0x44200267,0xdb1c0298,0x20548081}},	//   gatc, _rvi_, korá, стър,
   {{0x44200025,0x6d5f6221,0x7bc76222,0x3f8328fc}},	//   _svi_, _baqa, doju, _moju_,
   {{0x61ef556e,0x629c0353,0x8afc809a,0x657d0168}},	//   _nicl, vzro, _wnęt, gjsh,
   {{0x6d498013,0x290d8010,0x7d09002a,0x3952062c}},	//   _mbea, mbea_, ñesa, veys_,
   {{0xdee59628,0x66e59ed1,0x6fd000f2,0x61ef41ef}},	//   _коли, _кола, räck, _aicl,
   {{0x6d5f19e7,0x629c007d,0x644d0102,0xf53f006a}},	//   _faqa, uzro, _epai, rnår_,
   {{0xd1321921,0x2d990192,0x6026004a,0x66761190}},	//   تمر_, chse_, идба, یدار,
   {{0x7dd60065,0x3f83011f,0x7bc74b20,0x80dd80d4}},	// [5f00] láso, _boju_, boju, _परफे,
   {{0xdb1c002a,0x6d49802a,0x753b802e,0x973c8503}},	//   borá, _abea, _acuz, vićk,
   {{0xed5a835f,0x6d5f3a14,0xee3a34d6,0x7641e223}},	//   кож_, _yaqa, тне_, ntly,
   {{0x973c842b,0x6d498362,0x61ef1a1f,0x3998826b}},	//   tićk, _cbea, _gicl, _kése_,
   {{0x61e46224,0x63aae225,0x6d498706,0x3f830091}},	//   mmil, tifn, _dbea, _foju_,
   {{0xbcfb00f7,0xb4d69094,0x7dd60019,0x61e43718}},	//   idéa, _हरी_, káso, lmil,
   {{0x2b4707d9,0x7ddd0019,0xd25080f7,0x443f8609}},	//   _önce_, lése, سنة_, _equ_,
   {{0x61e46226,0x63aa80dd,0x7dd60061,0x39918032}},	//   nmil, sifn, dáso, _dáso_,
   {{0x973c856f,0x7df38087,0x290001ca,0x61e4008b}},	//   lići, _măsu, icia_, imil,
   {{0x2d849645,0x63ad80f7,0x6d5f6227,0x656081a8}},	//   _home_, éant, _saqa, _hamh,
   {{0xa3e3873c,0x290001ac,0x2d84a255,0x61e46228}},	//   नगर_, kcia_, _kome_, kmil,
   {{0x6560b22b,0x61e402a5,0x7c2d8042,0x656280f1}},	//   _jamh, jmil, šare, ndoh,
   {{0x64429413,0x7bc72a24,0x2d84812b,0x94a82e72}},	//   ntoi, toju, _mome_, атра_,
   {{0x29003993,0xc0a9845b,0x2d848390,0x2484016d}},	//   ecia_, _حامل_, _lome_, ämma_,
   {{0xf41f464b,0xdced003a,0xf1a700c5,0x79a71287}},	//   ssä_, _inač, аран, арае,
   {{0x2d84e229,0x80dd836d,0x3d10809a,0x973c82a5}},	//   _nome_, _परमे, ारों_, dići,
   {{0x7d1d2551,0xc10400f7,0x6f18822c,0x7bc7622a}},	// [5f10] mass, توقي, _kevc, poju,
   {{0xe7190013,0xe733045b,0x9951826f,0x68f5801b}},	//   ايات_, تصر_, _máš_, ězdi,
   {{0x212682a5,0x6f188214,0x2d84e22b,0x973c8140}},	//   _odoh_, _mevc, _bome_, gići,
   {{0x29000098,0x2d84cd02,0x7d1d2764,0xd256007c}},	//   ccia_, _come_, nass, _פשרה_,
   {{0x9951803e,0x7dd60019,0x6560a305,0xe81600c2}},	//   _náš_, záso, _damh, दीदा_,
   {{0x2bbb8013,0x7d1d622c,0xdb0aa4df,0x212680d7}},	//   خاصة_, hass, nifè, _adoh_,
   {{0xd6e500c8,0xfee500c8,0x06e500c8,0xe69500f7}},	//   _প্রয, _প্রধ, _প্রি, _الأد,
   {{0xd2b80bea,0x7dd88038,0x78b800d2,0x753b8380}},	//   ילות_, písa, šavš, _ucuz,
   {{0xf8a98077,0x6442e22d,0x60068a14,0x7d1d4c37}},	//   دگاه_, ctoi, бным_, dass,
   {{0x7dd60065,0x29192055,0x25a90859,0x6f1881a1}},	//   táso, _lesa_, _amal_, _cevc,
   {{0x201f8073,0x7ddd0061,0x7d1d622e,0xdce401a1}},	//   ssui_, zése, fass, _knić,
   {{0xceb2010f,0x2919622f,0x7d1d6230,0x442fe231}},	//   ליי_, _nesa_, gass, org_,
   {{0x515a8039,0xa5c701fa,0x7c2902d4,0x7ddd0118}},	//   _תכנו, _slóð, šern, xése,
   {{0x39988118,0x799b8326,0x394b07b6,0x69c4819d}},	//   _vése_, lhuw, _abcs_, ịstị_,
   {{0xe29749a1,0x29196232,0xf8bf16f0,0x6996281c}},	//   бар_, _besa_, _axé_, брах,
   {{0xc2433832,0x7ddd0019,0xe9df0028,0x973c807d}},	//   янск, tése, _chú_, vići,
   {{0xe0da18a0,0x2900368e,0x291903d2,0x4ca600c8}},	// [5f20] ува_, rcia_, _desa_, _গুরু,
   {{0x6560e233,0xe47b0051,0x2d848051,0x29000098}},	//   _samh, _עריכ, _some_, scia_,
   {{0x44220370,0xc7d68039,0xdb038722,0x2e238214}},	//   lsk_, צועי_, dinà, nıf_,
   {{0x4a5b0051,0xdb1c1b26,0x631480ab,0x291909ca}},	//   _עדכו, forç, _সাইট_, _gesa_,
   {{0x44220d1a,0xfe678077,0x628e6234,0x996c81d0}},	//   nsk_, _کد_, lybo, těž_,
   {{0x6442e235,0xd00f04c1,0x973c8115,0x7d1d0061}},	//   rtoi, _سلف_, pići, zass,
   {{0x2d84803a,0x6442acf0,0x7d046236,0xf3f1e237}},	//   _tome_, stoi, _ofis, _dị_,
   {{0xed5a835f,0x7d1d02df,0x6f1e1c18,0x65608c41}},	//   _щоб_, xass, lapc, _uamh,
   {{0x7d1d5dcb,0x628e016b,0x6f1882d4,0xdb1c0980}},	//   vass, hybo, _pevc, corç,
   {{0x99518a56,0x7d046238,0x7d028098,0x7c2d84a8}},	//   _váš_, _afis, lcos, šarc,
   {{0xf8d5146d,0x59c81a3b,0x63ae01b4,0x7ddd0061}},	//   _दर्प, लवार, dibn, vésb,
   {{0x4424ba4c,0x7d02e239,0x628e623a,0x799b80f3}},	//   _kvm_, ncos, dybo, chuw,
   {{0x29194716,0xdb03b3a7,0x6f1e0019,0x3ced02f1}},	//   _resa_, liná, kapc, äev_,
   {{0x7d043413,0x7c240110,0x29190168,0x7df38087}},	//   _efis, _dvir, _sesa_, _păst,
   {{0x29193b44,0xe9df001c,0x1b1d80ab,0xdb0384e8}},	//   _pesa_, _phú_, _নামে_, niná,
   {{0x7d1d0372,0x61fae23b,0x26dc8858,0x7c228d23}},	//   qass, _mutl, _izvo_, ksor,
   {{0x79860133,0x442480f3,0x9f940198,0xf8bf0216}},	// [5f30] _dokw, _nvm_, kää_, _edén_,
   {{0x32550bba,0x1ae380ab,0x6fdd80e7,0x7c229a40}},	//   _двор, নুয়া, pèce, dsor,
   {{0xe9df1c03,0xd6db2355,0xdb0383f2,0x9f4781d0}},	//   _thú_, ута_, jiná, _jiná_,
   {{0xdb03936f,0xfe7000f7,0x3cd59ccf,0x9b450019}},	//   diná, عدل_, ожес, _انھو,
   {{0x442fb4d3,0x7c2284dc,0x913a00be,0x61fa81a1}},	//   urg_, gsor, _דערק, _autl,
   {{0x61faa36f,0x7e620035,0xdb038f09,0x42098ff7}},	//   _butl, łopa, finá, анко_,
   {{0xdb03827f,0xe2998973,0x38695b5b,0x65958071}},	//   giná, рай_, lvar_, _даву,
   {{0x80dd82a8,0xe8f9a10d,0x4422623c,0x7d02e23d}},	//   _परदे, шли_, ysk_, ccos,
   {{0x2eb90e5b,0x7529e23e,0x38690085,0x7c2293ec}},	//   _आशुत, _idez, nvar_, csor,
   {{0x6dbc812b,0x6d4d0e05,0x7d1b94cf,0x80c600ab}},	//   nčan, _abaa, _heus, লেক্,
   {{0x7c240025,0x98b98182,0x61fa80d2,0xbcfb0118}},	//   _svir, ısı_, _gutl, rdén,
   {{0x3cf08105,0x442204dc,0x24ea16d9,0xe29483de}},	//   ुँचे_, tsk_, имни_, _צװײ_,
   {{0x4424623f,0x764508f9,0x628e0428,0x7d1bddf5}},	//   ém_, hthy, wybo, _meus,
   {{0x69cf6240,0x4422021e,0x628e0110,0xf8bf0032}},	//   _akce, rsk_, tybo, _adéo_,
   {{0x79864eb1,0x394908dc,0x6f1e026c,0x7d0401b9}},	//   _pokw, ffas_, vapc, _tfis,
   {{0x7c24805c,0xbcfb6241,0x63ae0359,0x7d044d60}},	//   širi, ndél, sibn, _ufis,
   {{0xef1a6242,0x3f879a45,0x3869524d,0xe7aa01cf}},	// [5f40] има_, _konu_, gvar_, авал_,
   {{0xafdb06be,0x2d82025b,0x65646243,0x75298d19}},	//   _spør, ljke_, _haih, _adez,
   {{0x9f940364,0x2b580da8,0x442481a1,0x2eee016d}},	//   vää_, merc_, _svm_, äff_,
   {{0xdb03826f,0x442481bb,0x2d8216f2,0x893612c8}},	//   viná, _pvm_, njke_, _بعدا,
   {{0x9f94025d,0x65643e32,0x64465681,0x7d1be244}},	//   tää_, _maih, ntki, _deus,
   {{0x7c22e245,0x7d02e246,0x752981bc,0x65640198}},	//   rsor, scos, _edez, _laih,
   {{0xd6270652,0x7bcace2a,0x644602f1,0x9f940198}},	//   _море_, rofu, htki, rää_,
   {{0x6f1c056f,0x9f940364,0x81d800c8,0x6eca86ab}},	//   _herc, sää_, াদক_, _सुषु,
   {{0xb9028dd2,0xa3da009a,0x46cf86ae,0x9f94156e}},	//   _धर_, ़ता_, _सुबह, pää_,
   {{0x7dd65968,0x39988077,0x3f98808b,0xff988eef}},	//   lásh, _désa_, óru_, ској_,
   {{0x6f1c10b6,0x614685e9,0x65642992,0x4efb00be}},	//   _merc, _межа, _baih, יליג,
   {{0x65640362,0xdced0372,0xbcfb1a1f,0x386d1075}},	//   _caih, _jlaħ, rdéo, _šerm_,
   {{0x65643413,0x7b671ccf,0x6eca8b49,0x61e2a2b3}},	//   _daih, отве, _सुरु, _ihol,
   {{0xa0078060,0x76450114,0x7763823e,0x8c48899b}},	//   _بقول_, ythy, _ganx, mağı,
   {{0x6dbc803a,0x8f9b84de,0x92681612,0x61e2e247}},	//   včan, _דיגי, орта_, _khol,
   {{0x60f911e9,0x65c4038c,0x1a9b83de,0x2bdb0305}},	//   сная_, _обја, בילע, _मीरा,
   {{0xbcfb6248,0x6f1c29ac,0x7d1bb04c,0x61e2a7e7}},	// [5f50] ndém, _berc, _reus, _mhol,
   {{0x6f1c1f65,0xe94509d7,0xdfd10013,0x7d1b815d}},	//   _cerc, _کردی, ريا_, _seus,
   {{0x44396249,0xd5758c8e,0x386902fe,0x3ea70032}},	//   lus_, зуль, svar_, ànt_,
   {{0x753d624a,0x76450114,0xdce083bf,0xbc681190}},	//   ngsz, rthy, _almı, _امین_,
   {{0x6dbc811f,0x6f1c0114,0x3d0a86a7,0x7d1b802a}},	//   pčan, _ferc, ाड़े_, _veus,
   {{0xf1bf07ca,0x2d9db64e,0x61e2e24b,0x291f804f}},	//   _hjá_, shwe_, _ahol, waua_,
   {{0x6fd4823e,0x6fba3616,0x69c4833b,0xdced0609}},	//   càci, ्वरू, čien, _flaħ,
   {{0xd24e9168,0x7763aeec,0x6dbc8968,0x98ab07c0}},	//   اني_, _sanx, nčal, _hacı_,
   {{0x443955d5,0xa3bd03bb,0x25ade24c,0x65640b20}},	//   jus_, ेका_, _imel_, _raih,
   {{0x4439624d,0xee39a748,0x61e2b937,0x25bf81a3}},	//   dus_, бно_, _ehol, _hjul_,
   {{0x59bd0a0d,0xb90180ab,0x4439624e,0x2b580037}},	//   ्कार, _দল_, eus_, verc_,
   {{0x6d59e24f,0x61e2e250,0x995181d6,0xdb150061}},	//   newa, _ghol, _báť_, kozó,
   {{0xea000104,0x65640364,0x61e995ce,0x8c4882bb}},	//   _biết_, _vaih, mmel, cağı,
   {{0x61e9e251,0x24441a5b,0x291d804f,0xf1bf04be}},	//   lmel, röm_, _hewa_, _ajá_,
   {{0x64460d38,0x6721803b,0xf7708bca,0x443901e2}},	//   stki, malj, _جان_, aus_,
   {{0x61e9d0e9,0xe8fa333d,0x6f1c139f,0xf2d283de}},	//   nmel, сла_, _serc, געל_,
   {{0x6f1c0ca9,0x6d59d360,0x21200b50,0x671f800f}},	// [5f60] _perc, dewa, raih_, _मजाक_,
   {{0x25adbb19,0x7c265aa6,0xea00001c,0x61e9e252}},	//   _amel_, mskr, _giết_, hmel,
   {{0x6d59a2f5,0xd90d0019,0x212000b9,0x61e9e253}},	//   fewa, _چیف_, paih_, kmel,
   {{0x7dd64c16,0x7bce6254,0x7e62009a,0x6d59b560}},	//   fási, lobu, łopo, gewa,
   {{0x7c2612fa,0x938a8ba7,0x0b8a8098,0x6b88e255}},	//   nskr, йска_, йски_, _podg,
   {{0x61e2e256,0x25ad8ad4,0x5334b7bf,0x7bce01f6}},	//   _shol, _emel_, фект, nobu,
   {{0x6721b7fd,0x9f478009,0x61e2e257,0x6d59e258}},	//   dalj, _minä_, _phol, bewa,
   {{0x291d8a73,0x6d59df37,0x8c4685fa,0x8c4887c0}},	//   _cewa_, cewa, _небе, tağı,
   {{0x7df40012,0x291d81da,0xdb0a80f7,0x64a3b16c}},	//   _răsp, _dewa_, lifí, _зата,
   {{0x44395fa6,0x7c262a33,0x08e900ab,0x9f9d077f}},	//   vus_, dskr, টুকু_, yìí_,
   {{0x44396259,0x61e2e25a,0xe5350110,0x3f8a0bb1}},	//   wus_, _thol, мень, _mobu_,
   {{0x7c24811f,0x3f9e820f,0xa2cd0eb4,0xa44b816b}},	//   širu, shtu_, _दुष्, lášť_,
   {{0x7c262445,0x6721a582,0xf09f026b,0x69cd03a8}},	//   gskr, balj, _afàn_, voae,
   {{0x200be25b,0xf1bf0125,0x4426a6e8,0xdeb4c3e1}},	//   ície_, _sjá_, iso_, _облы,
   {{0xea000104,0x4439625c,0x15ec83b7,0x7ac41ed1}},	//   _viết_, sus_, जगार_, есте,
   {{0x61fe1520,0x4426e25d,0xdb0a9727,0x7c264be9}},	//   _dupl, kso_, difí, bskr,
   {{0xa2cd090f,0xea000028,0x91fc8029,0x752d011e}},	// [5f70] _दुर्, _tiết_, _krās, _idaz,
   {{0x44290d02,0x4c9c0039,0x7bce1de6,0xade10074}},	//   _iva_, _לבחו, cobu, _गीतन_,
   {{0x44290cde,0x3f8a026f,0xb81e80a5,0x44268114}},	//   _hva_, _dobu_, _मौसम_, eso_,
   {{0xdb1ac6fe,0x672180d2,0x4429021e,0xf53f00e8}},	//   _októ, zalj, _kva_, ngå_,
   {{0x291de25e,0xf8c1123a,0x6e3ae25f,0x4426bcb2}},	//   _rewa_, _एशिय, hutb, gso_,
   {{0x6d599142,0x291d8458,0x6dbcb1a7,0x44295611}},	//   sewa, _sewa_, nčaj, _mva_,
   {{0x752d007d,0xbe880012,0x442682ec,0x61e9e260}},	//   _odaz, _есте_, aso_, tmel,
   {{0x44290025,0xd9e3050d,0x7d04a5ca,0xdb18816b}},	//   _ova_, _कीमत_, ñist, mový,
   {{0xdb18826f,0x7c2480f7,0xf53f013c,0x4426e261}},	//   lový, áirt, dgå_, cso_,
   {{0x61e985d1,0x91fc81a9,0x7c29e262,0x7c2604dc}},	//   smel, _prāt, _iver, vskr,
   {{0x44292dda,0x7c29e263,0x6721d8cb,0xdb1c01ac}},	//   _ava_, _hver, ralj, porú,
   {{0x67218052,0x61368059,0x9f478009,0x262781a1}},	//   salj, rülü, _sinä_, rđo_,
   {{0x61fe4e9f,0x6fbf016f,0x893480f7,0x4c830098}},	//   _supl, ्वां, _أعما, вляв,
   {{0x99808038,0xdb18826f,0x28e28c28,0x9fb58201}},	//   čiť_, kový, _परति, dəçi_,
   {{0xaa430037,0xdb18816b,0x386d9b7d,0x0eac064a}},	//   керл, jový, lver_, _टेंड,
   {{0x7c29e264,0x442682a3,0xe9da1a84,0x3f8a005c}},	//   _over, yso_, іка_, _sobu_,
   {{0x7984085c,0x1f66012f,0x44293f1d,0xd54901a8}},	// [5f80] rjiw, мкам, _gva_, _رجيم_,
   {{0x1b1800ab,0x7d09826b,0xe8de00c2,0x61fe0198}},	//   _তাকে_, _afes, _मरीच, _tupl,
   {{0xdfcf0307,0x9f5f87e2,0x7c29b206,0x386d8257}},	//   جيل_, rquè_, _aver, hver_,
   {{0x4426e265,0xe57a8fe6,0x6fd48980,0x7c298799}},	//   tso_, юзе_, làct, _bver,
   {{0x44268ba7,0xa3e306b7,0x4197003d,0x045a80f7}},	//   uso_, _फीड_, _آشپز, تجات_,
   {{0x7c2981ac,0xa3a8809a,0x7d09dc72,0xdb1883c1}},	//   _dver, खों_, _efes, bový,
   {{0x4426d668,0x7c298051,0x394dbf8b,0x6fdd823e}},	//   sso_, _ever, ffes_, tècn,
   {{0x6d44022c,0x32538098,0x386d0267,0xd91a804a}},	//   _ncia, твър, _šeri_, цьк_,
   {{0x660d9fe7,0x7c2981b9,0x6dbc80e1,0x798b8326}},	//   _čaka, _gver, yčaj, _dogw,
   {{0x83fd8019,0x7dd8b86d,0xada40035,0x39950338}},	//   _erős, dísi, óźni, _påsk_,
   {{0x7c2981ac,0x3869826c,0x6fd4823e,0xa3cb8072}},	//   _zver, _šart_, dàct, ळकर_,
   {{0x5693a45b,0x6e3a8711,0x6d4400e5,0x4ad200c2}},	//   тают, rutb, _ccia, _दुधव,
   {{0x2edb023c,0xdb050307,0xf8e2890a,0x50e28778}},	//   _भर्त, _amhá, _परिय, _परिष,
   {{0x21249a29,0x237a03a7,0x6d440609,0x69c2d9c6}},	//   lamh_, _cnpj_, _ecia, _hjoe,
   {{0xe2f810ac,0xb90c01bc,0xdce281d6,0x00000000}},	//   дері_, _ọbịb, jkoľ, --,
   {{0x21248af9,0x75208065,0x44292ca4,0xd5b8053b}},	//   namh_, _nemz, _tva_, _осы_,
   {{0xa3ce9d01,0x6d5d3188,0xb4dd8d86,0x4429191f}},	// [5f90] रवा_, mesa, _डरे_, _uva_,
   {{0xdb18803e,0xd6db1594,0x399c01fa,0x7c2989ed}},	//   tový, оте_, _vísa_, _rver,
   {{0x7c298687,0x63b5007a,0x19951ea4,0xfbdf0187}},	//   _sver, mizn, _заня, ntêm_,
   {{0x6d5d6266,0x68e2e267,0xdb18826f,0x9f5fd1be}},	//   nesa, _ozod, rový, rqué_,
   {{0x61ed5559,0x802712dc,0x7dd602b7,0xdb18816b}},	//   mmal, _ترجم, mást, sový,
   {{0x61ed6268,0x6d5d51d6,0xd7c900d7,0xdb1884e8}},	//   lmal, hesa, _روزه_, pový,
   {{0x6d5d288e,0xd90f87d2,0xf99f06c0,0x61ed6269}},	//   kesa, لیا_, _klè_, omal,
   {{0x6d5d142f,0x9f59027f,0x61ed626a,0x2d9900f3}},	//   jesa, _musí_, nmal, jkse_,
   {{0x386d83d3,0x7c29a9a5,0xa2d60f12,0x6d5d1142}},	//   uver_, _uver, _मुन्, desa,
   {{0x6d44626b,0x7520bc2d,0x2d990cfa,0x6569e26c}},	//   _scia, _zemz, ekse_, _haeh,
   {{0x7d04c824,0xc7a881a8,0x386de26d,0x81d60264}},	//   žise, بديل_, sver_, িগত_,
   {{0xb8e58a49,0x7dd8a511,0x6569d867,0x3991970b}},	//   _এর_, tísi, _jaeh, _pásu_,
   {{0xdb070009,0xbdf98065,0x61ed01a9,0x7c3d02f1}},	//   kijä, _کرتا_, dmal, gusr,
   {{0x7dd8816a,0x69db8168,0xf99f626e,0xa066898d}},	//   rísi, llue, _alè_, _чаша_,
   {{0x6d5d0890,0x8f9a810f,0x21764a56,0x6fd4809f}},	//   besa, _מיסי, нуар, ràct,
   {{0x6d5d626f,0x61ed1fdb,0x600a1a19,0x443dae5e}},	//   cesa, gmal, знам_, kuw_,
   {{0x26de003a,0x39406270,0x3fe64a52,0x63b56271}},	// [5fa0] _što_, rgis_, ежав, bizn,
   {{0x63b50503,0x2d9f8009,0x657b82c4,0x443d81ed}},	//   cizn, _alue_, _anuh, duw_,
   {{0x7520826c,0x443d81ed,0x2d9f8add,0xdee60198}},	//   _pemz, euw_, _blue_, хожи,
   {{0x9426be3d,0x9f5d8077,0x61bd0519,0x7dd60118}},	//   емде, _duwé_, ्कृष, cást,
   {{0x20040087,0x6569808e,0x7dd60061,0xc9536272}},	//   _îmi_, _daeh, láss, _גמר_,
   {{0x9f58020f,0xaa669ac1,0xa3c0150e,0x69c2beea}},	//   _mirë_, етик, ंचि_, _sjoe,
   {{0xdee314b7,0x66e30251,0x9f580168,0xa2d6123a}},	//   _бори, _бора, _lirë_, _मुम्,
   {{0xea000104,0x20026273,0xdcf60176,0x244981fa}},	//   _nhật_, _kuki_, _anyč, búm_,
   {{0xa3c0035a,0xdced0d26,0x82fa804e,0x6d5d6274}},	//   ंचा_, _inać, _فراز_, vesa,
   {{0xa3c78076,0x27f886db,0x200be275,0x999f80eb}},	//   _उदय_, örn_, ícia_, ārši_,
   {{0xdd91136d,0x7054803d,0x61ed6276,0x63b52771}},	//   لود_, رنگا, ymal, vizn,
   {{0x6d428102,0x7afe002a,0x29d70722,0x69dbe277}},	//   ngoa, _agpt, nçat_, clue,
   {{0x2002026c,0x2d9942cf,0x6d4f010c,0x19b783de}},	//   _nuki_, rkse_, rfca, _אפאר_,
   {{0xcf2680f7,0x27e78362,0x0ce1064a,0x2d84048d}},	//   _أرشي, _ghnn_, _नरीम, ömer_,
   {{0xdb0e2509,0x7cf683bf,0x66738154,0x20026278}},	//   cibí, _yürü, _مدير, _auki_,
   {{0x26db84de,0x3f8e804f,0x20024ffd,0x250900d7}},	//   _מקומ, _hofu_, _buki_, _غربی_,
   {{0x7d0d20af,0x69c0d47c,0x7dd64ae5,0xdb1503ed}},	// [5fb0] _ifas, inme, rást, nizë,
   {{0x200f0029,0x200201a1,0x7c2d1db4,0xab840249}},	//   īgi_, _duki_, _ivar, _буюк,
   {{0x7c2d6279,0x4fc40544,0x44390176,0x394683a8}},	//   _hvar, уста, lrs_, _ocos_,
   {{0x7c2d0558,0xdce08dba,0x442b627a,0x200200fc}},	//   _kvar, _samā, osc_, _fuki_,
   {{0x7d0d45b7,0x84eb80c2,0x7c2d02a6,0xc8af8a27}},	//   _mfas, जेंट_, _jvar, _जेंट,
   {{0x7cf6817b,0x443d85ee,0x6d42811b,0x644be27b}},	//   _sürü, ruw_, agoa, rtgi,
   {{0x660de27c,0x6569808e,0xdb0a807b,0xdce40b80}},	//   _čako, _taeh, kifæ, _raič,
   {{0x44390301,0xa3e30105,0x96f81a19,0x644b890d}},	//   krs_, _फीस_, _чест_, ptgi,
   {{0x29d70187,0x442b0035,0x4439627d,0x7dd60061}},	//   lças_, jsc_, jrs_, záss,
   {{0x8aa78463,0x02a78951,0x7d0d627e,0x93e00105}},	//   _пред, _прем, _afas, _खींच_,
   {{0x44394543,0x7c2d20a2,0x29d70073,0x6da60676}},	//   ers_, _avar, nças_, вина,
   {{0xaad50105,0x7bc5008e,0xdb0e1727,0x2d9617c7}},	//   _धड़क, _ajhu, ribí, трос,
   {{0xb87b0065,0x7c2be27f,0xfc3f6280,0x5fd10af3}},	//   _szín, nsgr, guí_, तकाल,
   {{0x33d50160,0x395f9aa5,0x6a4a8085,0x7d0d6281}},	//   гіст, leus_, _səfi, _efas,
   {{0x25e3023c,0xea000028,0x7c2d2637,0x9f430118}},	//   _टीवी_, _thật_, _evar, _lijó_,
   {{0x442d8025,0x316d8866,0x7dd8c1bf,0x200252c1}},	//   _ove_, ndez_, níst, _puki_,
   {{0x6d566282,0x7c2d3dbf,0x316d9e00,0xa3e49261}},	// [5fc0] _ibya, _gvar, idez_, नतम_,
   {{0x4420026b,0xdced02a5,0x672381bf,0x6603bebe}},	//   _iwi_, _snać, _jenj, _kunk,
   {{0x6723845c,0x442002f7,0x75246283,0x395f8198}},	//   _menj, _hwi_, _keiz, keus_,
   {{0x66038eb9,0x442058fd,0xdd99821e,0x6723a956}},	//   _munk, _kwi_, нші_, _lenj,
   {{0x395fe284,0x7dd8e285,0xcfaa12dc,0x6d42e286}},	//   deus_, díst, _قاسم_, rgoa,
   {{0x442d9117,0x39468087,0x6dbc81a1,0x9f43026b}},	//   _dve_, _scos_, jčav, _dijó_,
   {{0x6603e287,0x395f87f1,0x26068072,0x6d565a54}},	//   _nunk, feus_, _संधी_, _obya,
   {{0x7dd8e288,0x7524285e,0x2d9c80eb,0xd13080f7}},	//   gíst, _neiz, īves_, حمة_,
   {{0xf1b30bea,0x4fd49354,0x44202b5f,0x69c0ad57}},	//   יסה_, лжит, _nwi_, rnme,
   {{0x29d72670,0x6603e289,0xdb1ad0de,0x9989811a}},	//   nçar_, _bunk, _aktö, čaš_,
   {{0x7c2d628a,0xa3d602a8,0xdd950791,0x65950087}},	//   _svar, िकन_, ганы, гану,
   {{0x236ce28b,0x6603e28c,0x25a6e28d,0x443900eb}},	//   _hadj_, _dunk, nhol_, trs_,
   {{0x443906e3,0x4fc6891c,0x7ddd0077,0x3866802e}},	//   urs_, _иска, nési, _usor_,
   {{0xc0e38652,0x4420031d,0x09bd0651,0x6d560c56}},	//   _точк, _dwi_, ्क्य, _ebya,
   {{0x75fa801b,0x6fddace0,0x66039037,0x7ddd00e7}},	//   _různ, dèch, _gunk, hési,
   {{0x7c2d8132,0x7c2d628e,0x39a41819,0x7d0d0a5a}},	//   šari, _tvar, ашув, _ufas,
   {{0xfc3f433a,0xdb1c628f,0x1075076a,0x66038326}},	// [5fd0] quí_, goró, ылаю, _zunk,
   {{0x2d538324,0x67288b67,0x660384b9,0x63b88267}},	//   _ṣe_, nadj, _yunk, jivn,
   {{0x442d803a,0xdfd80098,0x7c2be290,0xd6db01cf}},	//   _sve_, тът_, wsgr, фта_,
   {{0x7dd8e291,0x6728e292,0xf65383c8,0x7c2b9ff5}},	//   xíst, hadj, יצע_, tsgr,
   {{0x656d6293,0x21290812,0x395f87f1,0x40841073}},	//   _maah, maah_, veus_, _курб,
   {{0xdd03884a,0x63b89e6b,0x212957d3,0xbcfb0019}},	//   ırıl, givn, laah_, ldés,
   {{0x61fd6294,0x672381b9,0x395f91ce,0x425281a8}},	//   _kisl, _renj, teus_, منور,
   {{0x45d5817a,0x67238590,0x200b8073,0x25a6e295}},	//   _собс, _senj, ício_, chol_,
   {{0x316daee0,0x75246296,0x672395bd,0x6603e297}},	//   rdez_, _reiz, _penj, _sunk,
   {{0x6728b4c5,0x6603e298,0x21296299,0x395fe090}},	//   gadj, _punk, haah_, seus_,
   {{0x656d02a3,0x442002d6,0x395fe29a,0x6723e29b}},	//   _baah, _swi_, peus_, _venj,
   {{0x8aa48002,0x2d9d81b9,0x399c016b,0xe81e923a}},	//   _труд, nkwe_, _písm_, _मौका_,
   {{0x69d98135,0xa3c00006,0x656d0079,0x21290748}},	//   _ikwe, ंचल_, _daah, daah_,
   {{0xd00e9301,0xf1b9a7b1,0x61fd517b,0x660385a3}},	//   _على_, liš_, _aisl, _tunk,
   {{0xfaa30c73,0x32058051,0x15f5a279,0x44201c33}},	//   баро, _july_, ेदार_, _wwi_,
   {{0x2fd8010b,0x290d8087,0x7641c50b,0xd2e41199}},	//   _skrg_, ncea_, muly, _गरीब_,
   {{0xa2da835a,0x57ea067c,0x316000eb,0x6a4a8085}},	// [5fe0] _पुन्, едам_, reiz_, _həft,
   {{0x6d498c6e,0x61fd4d10,0xf8bf0ba4,0x33662466}},	//   _acea, _eisl, _adés_, _свог,
   {{0x29d726e1,0x69d994ee,0x2d80115b,0x25a68114}},	//   rçar_, _okwe, _knie_, thol_,
   {{0x6d460458,0x6dbc816b,0x69d99292,0xdb1c172b}},	//   ngka, jčat, _nkwe, poró,
   {{0x69c41a1d,0x63b89620,0x2d800063,0xa3ab02f1}},	//   mnie, tivn, _mnie_, _खतम_,
   {{0x69c4629c,0x7641e29d,0x437600be,0x0a6a891c}},	//   lnie, kuly, רײַן_, ерии_,
   {{0x63b8bf88,0xbcfb2190,0x25a6e29e,0x645b9eed}},	//   rivn, ndér, phol_, _epui,
   {{0x38348468,0x7bc3a19b,0x6d498013,0xc0348dc7}},	//   анир, annu, _gcea, аниј,
   {{0xfce39033,0xf9930039,0x80dc80ab,0x320582c4}},	//   _гото, מרה_, মেন্, _euly_,
   {{0x69d9882e,0x385780f7,0x656d629f,0xbcfb62a0}},	//   _ekwe, اشيد_, _saah, zdés,
   {{0x67288b67,0x69c42445,0xf1b98796,0x2d920041}},	//   radj, knie, biš_, _boye_,
   {{0xceb30039,0x69c462a1,0x67288b80,0xf1b9811f}},	//   מית_, jnie, sadj, ciš_,
   {{0x69c41a15,0x7bd562a2,0x589692c8,0xa3c0016f}},	//   dnie, tozu, _حجاز, ंचं_,
   {{0x765c62a3,0x6d460282,0x69c41a22,0x7f968866}},	//   _opry, agka, enie, _pâqu,
   {{0x61fd62a4,0x212915e8,0x6dbcc573,0xea0000ff}},	//   _pisl, taah_, nčas, _phạt_,
   {{0x69c462a5,0xb115174a,0x39152f84,0x80d300ab}},	//   gnie, рмаш, рмар, _দৃষ্,
   {{0xa3e485e8,0xbcfb0065,0x60f921f6,0x644d0748}},	// [5ff0] नता_, rdés, тная_, _uqai,
   {{0x3f9e969e,0xb4c31299,0x6d49c1d1,0x9f4101a8}},	//   nktu_, ्थी_, _scea, lmhú_,
   {{0x69c4118c,0x6dbc826f,0x645bdf95,0x62670199}},	//   bnie, jčas, _spui, _صادق,
   {{0x7bdae2a6,0x61fd0010,0x6dbc8259,0x531402e3}},	//   _aktu, _uisl, dčas, _پذیر,
   {{0x6dbc83f2,0x8b258a0e,0xa5c5826b,0x7a1181a9}},	//   včat, адле, _atóè, _māte,
   {{0x6fdd8722,0xd7f8028e,0x0ed0016f,0x69d9b937}},	//   pèci, _бус_, _तुकड, _skwe,
   {{0xa3d60076,0xfe09801c,0xaadb06a7,0x98bf88ae}},	//   िकत_, _mắc_, _मुमक, rguč_,
   {{0x798d20c8,0xfe0980ff,0x34958256,0x2006e2a7}},	//   njaw, _lắc_, _кабр, _buoi_,
   {{0x0cd9803d,0xf09200be,0x290d8087,0x78ad02d6}},	//   _شارژ_, ַנט_, rcea_, nzav,
   {{0x69c4350e,0x81bc8029,0x442fd908,0x7641e2a8}},	//   znie, _svēt, msg_, tuly,
   {{0x6dbc84a8,0xf1b9d717,0xdee5971c,0x672701b9}},	//   mčar, piš_, рони, _mejj,
   {{0x58d58698,0x69d9ae57,0x287581bb,0x66070267}},	//   _коет, _ukwe, _выкр, _mujk,
   {{0x69d603d3,0xef0e9c20,0x2d920247,0x69c400eb}},	//   voye, _мм_, _voye_, vnie,
   {{0x69c40063,0x6dbca944,0xb92b00ff,0x78ad0619}},	//   wnie, nčar, _thuỷ_, dzav,
   {{0x69c41a1d,0xa2d6023c,0x412a0225,0x69d61dac}},	//   tnie, _मुश्, ково_, toye,
   {{0x7c2f13a0,0x798d00ee,0x2d805ed7,0xe1ff07f1}},	//   bscr, gjaw, _unie_, _ció_,

   {{0x69c462a9,0x7d0400b4,0x316f808e,0x21672466}},	// [6000] rnie, _igis, _magz_, шити_,
   {{0x69c40029,0x998d0796,0x61e481b9,0xef171bb1}},	//   snie, češ_, ċili, иму_,
   {{0x63bc003a,0x672704b7,0xe8e283eb,0x69c42e63}},	//   mirn, _dejj, _पर्च, pnie,
   {{0x1e568158,0xe1ff001c,0x7c2400b4,0x6b818176}},	//   ישער_, _gió_, _kwir, _anlg,
   {{0x2ca08307,0x7ddd58cf,0x9f4f81ca,0x629c0706}},	//   áid_, mést, _jugó_, lyro,
   {{0xd25a80c4,0x63bc62aa,0x7c24150f,0x3998808b}},	//   вци_, nirn, _mwir, _lést_,
   {{0x20068098,0xfe6788ca,0x27ff047f,0xf1a6e2ab}},	//   _suoi_, _بد_, _èuna_, ирин,
   {{0x63bc0867,0x20068698,0xa2da835a,0x7c2f1c33}},	//   hirn, _puoi_, _पुण्, yscr,
   {{0xbee6035a,0x200682be,0x63bc62ac,0x629c2af9}},	//   _करुन_, _quoi_, kirn, hyro,
   {{0x20068098,0x47348ada,0x7bc8826c,0x7d0462ad}},	//   _vuoi_, щнос, _ujdu, _agis,
   {{0x442481c5,0x78ad2bd7,0xc98682eb,0x21268034}},	//   _hwm_, zzav, _вули, _teoh_,
   {{0x99808a8e,0x2006d1e9,0xfe098028,0x44248069}},	//   čių_, _tuoi_, _sắc_, _kwm_,
   {{0xa2da9513,0xb4c301d0,0x6ce7021e,0xe1ff0144}},	//   _पुत्, ्थे_, ріне, _rió_,
   {{0xbee6035a,0x09b1035a,0x69c802be,0x7c2f01a8}},	//   _करून_, ीच्य, éden, rscr,
   {{0x442481e9,0xff178039,0x79828039,0x7ddd03a8}},	//   _lwm_, _דקות_, _know, fést,
   {{0x7bd8e2ae,0x4efb8039,0x78ad023e,0x9f4f8144}},	//   hovu, _בלוג, tzav, _fugó_,
   {{0x63bc399e,0x798d085c,0x7c240114,0x64400722}},	// [6010] birn, rjaw, _gwir, àmit,
   {{0x78ad0052,0x63bc5c2a,0xed5980c3,0x9f58026b}},	//   rzav, cirn, _sbž_, _firí_,
   {{0x41d6800f,0x27e984b9,0xdb188198,0x17f801a8}},	//   डकास, _ɗan_, invä, شركة_,
   {{0xeef784de,0x7bc702d4,0x3dc6a9f8,0x3cee06ae}},	//   במבר_, lnju, gnow_, _घरमे_,
   {{0x65a6007b,0x6600d5d6,0x4424e2af,0x3d0f801b}},	//   _jóha, _dimk, _cwm_, ाडौं_,
   {{0xdcfb811f,0xfc3f0013,0x9cd80039,0x39495ac0}},	//   _unuč, irí_, בודה_, lgas_,
   {{0x52758087,0x38695025,0x356b9ddf,0x926481a8}},	//   сулу, lwar_, _иран_, قديم,
   {{0x394962b0,0x4424822c,0x63bc0669,0x26c980d2}},	//   ngas_, _fwm_, zirn, _ćao_,
   {{0x386900fc,0x79828122,0x629c0035,0xa2e4052a}},	//   nwar_, _dnow, zyro, _गर्ज_,
   {{0x6d4d01a1,0xf8b201c6,0x7c2d826c,0xfc3f07f1}},	//   _acaa, פשי_, šars, drí_,
   {{0x9f47809f,0xdce08668,0x63bc0796,0xb8fe99e8}},	//   _sinó_, _pamć, virn, _दु_,
   {{0xcb090039,0x44248282,0x6d4d038a,0x629c1bfe}},	//   _טל_, _ywm_, _ccaa, vyro,
   {{0x291f8010,0x442481e9,0xfc3f023e,0x63bc62b1}},	//   mbua_, _xwm_, grí_, tirn,
   {{0x38691acf,0x629c1c85,0xdb1880e7,0x3cdc052a}},	//   dwar_, tyro, tivé, _गुणे_,
   {{0x4ad205b3,0x68e30201,0xd29900e8,0x61ef0267}},	//   _दुखव, əndi, атті_, _bhcl,
   {{0x09060f04,0xdb1880e7,0xa06a316c,0x394962b2}},	//   спан, rivé, лаба_, ggas_,
   {{0xea000104,0xa3d7999e,0x249d81c0,0xeb9a0249}},	// [6020] _nhất_, सवा_, jywm_, _бип_,
   {{0x69dd054f,0x6446130e,0x6d5b80dd,0x6609017f}},	//   _ekse, muki, _abua, _čekr,
   {{0x644622b3,0xe29a26b1,0x3dc68197,0x60cf1727}},	//   luki, _сан_, tnow_, _excm,
   {{0x44248282,0x998600f7,0x3f8303f7,0x7ddd0061}},	//   _pwm_, _الحو, _enju_, lésr,
   {{0xea000028,0x644662b3,0x61e44f89,0xa3bc02f1}},	//   _chất_, nuki, mlil, _आगा_,
   {{0x61e462b4,0x44248069,0x2a6c841c,0x29de0428}},	//   llil, _vwm_, _psdb_, rïau_,
   {{0x6e96003f,0x320206cb,0x7bd8e2b5,0x7bde0870}},	//   _الزا, _kiky_, rovu, _mkpu,
   {{0xd90e80d5,0x61e45a53,0x64463d90,0x4814aed9}},	//   ریت_, nlil, kuki, омис,
   {{0xa01b01ec,0x64460c2e,0x7bde0870,0x7bd8aaa0}},	//   _eröf, juki, _okpu, povu,
   {{0x644662b6,0x61e462b7,0xc32280ab,0x7bde0135}},	//   duki, hlil, _নাকি_, _nkpu,
   {{0x8c0000c8,0xdb18816d,0x2120026c,0x11d68c4f}},	//   ্ঠান_, rnvä, kbih_, _людя,
   {{0x69c80019,0xc6930039,0x7bde0133,0xfc3f01ac}},	//   édel, לאת_, _akpu, trí_,
   {{0xe8948e02,0x2120026c,0x2ec40a27,0x64460f45}},	//   _фаль, dbih_, वपुत, guki,
   {{0x7ddd0061,0x58f781c6,0x18378e82,0x68e2a6f3}},	//   téss, _המדע_, _פאול_, _iyod,
   {{0xf1a7067c,0x0f578bea,0xfe09801c,0x39490573}},	//   бран, _היום_, _hắn_, tgas_,
   {{0x61e402b8,0x644662b8,0x7bde0135,0x39490110}},	//   glil, buki, _ekpu, ugas_,
   {{0xa2da8b6f,0x752f009a,0x23ab806a,0x752980b9}},	// [6030] _पुस्, macz, _høje_, _reez,
   {{0x386904b9,0xb17b016d,0x6d5b80dd,0x394915d0}},	//   rwar_, _skåd, _sbua, sgas_,
   {{0x61e462b9,0x38692bb7,0x2120026c,0x9f5812d0}},	//   blil, swar_, bbih_, _dirà_,
   {{0x752f0063,0xcd2b803d,0x85300326,0x69dd02f1}},	//   nacz, اسان_, _koɗa, _ukse,
   {{0x6738973d,0x212b1670,0x27ff01e8,0x7ae1806f}},	//   _odvj, _iech_, _èuno_, _sylt,
   {{0x80dc800f,0xe2998012,0x212b0713,0x65663d8f}},	//   _पड़े, иал_, _hech_, zekh,
   {{0x64465282,0x68e2d038,0x65662499,0x539c03de}},	//   zuki, _ayod, yekh, ריוו,
   {{0x200b0052,0xea000028,0xfe09801c,0xdb1c0168}},	//   _kuci_, _thất_, _bắn_, tirë,
   {{0xb4e80105,0x9f4700ff,0x660a81ec,0xaadb0fb2}},	//   _भरे_, _điên_, _aufk, _मुसक,
   {{0x53349445,0x25a93e95,0x200b00fe,0x6d4a83bf}},	//   _неут, _alal_, _muci_, ılaş,
   {{0x20032ef4,0x02a7bd93,0xdb1c0168,0x93888951}},	//   _miji_, _урам, sirë, _уста_,
   {{0x64465542,0x82d680be,0x20190074,0xe9df3f87}},	//   tuki, _וועג_, _otsi_, _nkú_,
   {{0x22478019,0xfe09801c,0x2019022c,0x92e600ab}},	//   lunk_, _gắn_, _ntsi_, _ফলে_,
   {{0xbea59927,0x98a20029,0x6446300f,0xb6a581a0}},	//   _малк, _nekā_, ruki, _милл,
   {{0x752f009a,0x69c9e2ba,0x61e462bb,0x212b0620}},	//   bacz, onee, tlil, _bech_,
   {{0x69c98a52,0x62878036,0xdce4011f,0x64463735}},	//   nnee, _àjou, _naić, puki,
   {{0x212b2257,0x20030590,0x200b010b,0xe9d705e9}},	// [6040] _dech_, _biji_, _cuci_, іку_,
   {{0x200302a5,0x21200239,0x69c9e004,0x200b2fdb}},	//   _ciji_, sbih_, hnee, _duci_,
   {{0xa6ca00f7,0x2247e2bc,0x20190198,0x21200267}},	//   جوال_, junk_, _etsi_, pbih_,
   {{0xed5a90fc,0xa2da800c,0x69c981c0,0xa01b016d}},	//   род_, _पुष्, jnee, _bröd,
   {{0xdb153cdf,0xb87b0019,0x0b8a8188,0x798645b7}},	//   lizá, _szív, иски_, _inkw,
   {{0x660418c5,0xdce0801b,0x7bdc44e0,0xfe0980ff}},	//   _liik, _zamě, noru, _rắn_,
   {{0xdb1538bb,0xada68198,0xe5a685fa,0xa2da8054}},	//   nizá, _давл, _диви, _पुश्,
   {{0x8c4693f1,0xf1268d8e,0xa9c380e8,0x69c9e2bd}},	//   _мебе, цько, дськ, gnee,
   {{0x80dc00c8,0x7522a742,0xa2da824c,0x180482f1}},	//   _মৃত্, mboz, _पुर्, रदेव_,
   {{0x6d40008b,0x69c98df6,0x9178846d,0x752f0035}},	//   óman, anee, _fé̟_, wacz,
   {{0x3f980a20,0xf09f62be,0x7a1181a9,0x69c98069}},	//   _moru_, _ngàn_, _tāta, bnee,
   {{0xdced0503,0xd83f016b,0x79860133,0xfe09827d}},	//   _snađ, íčku_, _nnkw, _tắn_,
   {{0xf76f8077,0x66040057,0x69c08009,0xb87b026b}},	//   رای_, _diik, mime, _ayín,
   {{0xbebc8029,0x212b010c,0xfbbca9b7,0x200b005c}},	//   rbīb, _sech_, ्चिम, _ruci_,
   {{0x200b0587,0x6d4b8186,0xda780ada,0xdce0801b}},	//   _suci_, ygga, оят_, _pamě,
   {{0x3015002d,0xdb18928c,0x20030077,0x7ddd0144}},	//   здар, diví, _siji_, césp,
   {{0x9abc84b7,0x3f980965,0x22478061,0x6ab8864a}},	// [6050] _deċi, _boru_, zunk_, ेपुर,
   {{0xa2d60a3a,0x442904be,0x7bdc62bf,0x5ba71a19}},	//   _मुक्, _iwa_, coru, _фриз,
   {{0x752d0abf,0x69c0e2c0,0xa2da847d,0x69c98a5b}},	//   _keaz, kime, _पुल्, ynee,
   {{0x442962c1,0x671b1993,0x69c0b9d6,0x48c900ab}},	//   _kwa_, _प्रक_, jime, _শরীর,
   {{0x6442a1aa,0x69c98069,0x442906c4,0x3f980102}},	//   groi, vnee, _jwa_, _foru_,
   {{0x442947f0,0xb09a0039,0x22478019,0x3f980289}},	//   _mwa_, _הישר, tunk_, _goru_,
   {{0x69c0c51b,0x44295cf1,0x3f89801c,0xe29993bd}},	//   fime, _lwa_, _đau_, сай_,
   {{0x4429376b,0x7bdc62c2,0xa2ce04c5,0x22478061}},	//   _owa_, zoru, _सशस्, runk_,
   {{0x7bdc0179,0xdb0e0331,0x2019820f,0x44293318}},	//   yoru, ribú, ësi_, _nwa_,
   {{0x69c9e2c3,0x7c29e2c4,0xb113019d,0x9c138133}},	//   snee, _iwer, _tụwa, họkw,
   {{0x69c0e2c5,0x67219de3,0x7bdc18ad,0x7a3081a8}},	//   bime, rblj, voru, _vótá,
   {{0x69c09092,0x7c29af0b,0x44292f14,0xf09f00ff}},	//   cime, _kwer, _bwa_, _ngào_,
   {{0x7bdc0012,0x66040364,0x44295a64,0xb88681fa}},	//   toru, _viik, _cwa_, rtíð,
   {{0x44290773,0xf771990c,0x394d99f6,0xaca3e237}},	//   _dwa_, _سات_, lges_, _ngọn,
   {{0x753b803a,0xa2d60b6f,0x6da61fab,0x44291e54}},	//   _oduz, _मुख्, _ника, _ewa_,
   {{0x7d760277,0x7d09829b,0x44290247,0xaca3819d}},	//   _رابط, _nges, _fwa_, _agọn,
   {{0x7c298a2c,0x6ed40105,0x661b0279,0xb9288133}},	// [6060] _nwer, _बुजु, _čuka, _agwụ_,
   {{0x7d09b353,0xe4570158,0xfe098028,0x69c0c3d8}},	//   _ages, _צייט_, _lắm_, zime,
   {{0xfe050086,0xdfcf0013,0x3f980125,0x386d81ec}},	//   _üçün_, ديل_, _voru_, hwer_,
   {{0x248006c4,0xfe0980ff,0x7c29e2c6,0x69c0e2c7}},	//   _krim_, _nắm_, _bwer, xime,
   {{0x65765eae,0xdca385c2,0x3f980054,0x394da7d3}},	//   _mayh, наци, _toru_, dges_,
   {{0x7fd60d13,0x6442971c,0x7c299412,0xdbd6826b}},	//   _хімі, rroi, _dwer, _bùáy,
   {{0x69c0c953,0x7c298135,0x27f701d0,0x89d884a3}},	//   time, _ewer, řené_, يوتر_,
   {{0x394d84d6,0xfe0980ff,0x386d80b9,0x9f5c8216}},	//   gges_, _cắm_, fwer_, _viví_,
   {{0x752d1b68,0x7c29ad50,0x8c439033,0xb87b0019}},	//   _reaz, _gwer, _пете, _nyíl,
   {{0x442902a0,0x7648843b,0xb113019d,0x2c5e80eb}},	//   _rwa_, tudy, _hụta, rādā_,
   {{0x45d50003,0x442906c0,0x6b88813c,0xd7f88087}},	//   донс, _swa_, _indg, rmă_,
   {{0x442903ec,0x6b9a8129,0x7ae50198,0x248062c8}},	//   _pwa_, _hotg, _ryht, _brim_,
   {{0x61e284b7,0xdb018118,0x2480023e,0xb1130133}},	//   _ikol, _illá, _crim_, _mụta,
   {{0x083b8051,0x75ff0029,0xb4bd1834,0x442906c0}},	//   _פעול, _mūzi, _आधी_, _vwa_,
   {{0xdb0ae2c9,0xb91a0a2c,0xcfc400ab,0xd6cf8c4f}},	//   lifó, _ọtụt, ্তান, _чт_,
   {{0xf77309d7,0x44292e48,0x61e284b7,0x24800748}},	//   کار_, _twa_, _jkol, _frim_,
   {{0xa3dc816f,0x442962ca,0x661c00c3,0x248062cb}},	// [6070] ठवा_, _uwa_, _atrk, _grim_,
   {{0xdefb0198,0xedc583ca,0x7c298a03,0x61e2822b}},	//   бые_, लच्छ, _rwer, _lkol,
   {{0x7c29e2cc,0xdb0183a8,0x363401a8,0xf77020bb}},	//   _swer, _ollá, فرنس, داق_,
   {{0x25a68a84,0x6d4f62cd,0x61e28365,0x23490fd3}},	//   gkol_, ngca, _nkol, _اسکی_,
   {{0x69cd00d2,0x76430061,0xeb9980af,0x65608362}},	//   mnae, ányb, жил_, _dbmh,
   {{0xfe09801c,0x61e291ad,0xbd05826b,0xa2e58162}},	//   _sắm_, _akol, _apéé, молд,
   {{0x394d8813,0x386de2ce,0x61e28609,0xe3b081a8}},	//   tges_, wwer_, _bkol, درن_,
   {{0x69cd1a5a,0x2360a663,0x394de2cf,0x7d09db0c}},	//   nnae, đija_, uges_, _uges,
   {{0xbf0583dd,0x394de2d0,0x386d81ed,0x50b599b8}},	//   रश्न_, rges_, uwer_, ьску,
   {{0xee39c4cc,0x6615826f,0xdb018019,0x7999810c}},	//   оно_, ízko, _ellá, _woww,
   {{0x7bc3e2d1,0x644bc739,0x9d46117c,0x0f58010f}},	//   minu, lugi, менд, ליזם_,
   {{0x2d890333,0x9f45a9d5,0x656b80e5,0x386d80e4}},	//   _cnae_, illé_, negh, pwer_,
   {{0xe73980a9,0x61fb8365,0x69cd0bda,0x6459c538}},	//   _дел_, mmul, dnae, ntwi,
   {{0x61e98006,0x61fb8087,0x7bc3e2d2,0x68e60a53}},	//   llel, lmul, ninu, _rykd,
   {{0xea000028,0x4adb0105,0x09e610ca,0x25bf8087}},	//   _chết_, _मुआव, довн, _omul_,
   {{0x61e9a5b3,0x7bc384a7,0x200783e4,0x644b9efb}},	//   nlel, hinu, _hini_, kugi,
   {{0x2007e2d3,0x91e31697,0x09e3102a,0xdb1c0144}},	// [6080] _kini_, тоте, тотн, lirí,
   {{0x6281d41e,0xdfcf0013,0x2007e2d4,0x68e60110}},	//   _orlo, ليق_, _jini_, _vykd,
   {{0x7e56245b,0x7bc393bd,0x200f9761,0xb1130870}},	//   ьтац, dinu, _lugi_, _pụta,
   {{0x644be2d5,0xea000028,0x26138073,0x645981bc}},	//   fugi, _đặc_, _mão_, ftwi,
   {{0x4ac38076,0x3ea60029,0x61e9829b,0x6281e2d6}},	//   _वेबव, ņot_, dlel, _arlo,
   {{0x61e2a673,0x20078ca2,0x6ac98107,0xbf9b0036}},	//   _skol, _nini_, िपूर, _quêt,
   {{0x261399b6,0x661c02ce,0x79960069,0x644b8084}},	//   _não_, _utrk, ojyw, augi,
   {{0x2007e2d7,0x30a6869b,0x200fe2d8,0x61fb809c}},	//   _aini_, дров, _bugi_, gmul,
   {{0x20079953,0xa3c00a61,0xc05a80e8,0xe11281bc}},	//   _bini_, ूचा_, цій_, _bụrị,
   {{0x200785f5,0xb4aa8b9f,0x6b88813c,0x61e284b7}},	//   _cini_, खनी_, _undg, _wkol,
   {{0x2007e2d9,0x7c22e2da,0x26138187,0xdb1c349a}},	//   _dini_, lpor, _cão_, girí,
   {{0x61e2c707,0x2007c1be,0x26138187,0xf64f8019}},	//   _ukol, _eini_, _dão_, گئی_,
   {{0x2007e2db,0x7c22e2dc,0x61e08122,0xd90f003d}},	//   _fini_, npor, moml, یید_,
   {{0x2007e2dd,0x09c7016f,0xf1bf007b,0xdb1c0333}},	//   _gini_, रच्य, _smá_, birí,
   {{0x69cd0052,0xdb1c0333,0xa27801ae,0x9f4e826b}},	//   tnae, cirí, мбру_, _fifò_,
   {{0x260710c5,0x250900d5,0x2007e2de,0x7bc3995c}},	//   _सूची_, _عربی_, _zini_, zinu,
   {{0x2007829b,0x656b8087,0x7d0d62df,0x7bc3e2e0}},	// [6090] _yini_, vegh, _igas, yinu,
   {{0x7c229807,0xc8088104,0x69cd0699,0x656b882e}},	//   dpor, _bởi_, snae, wegh,
   {{0x2bdd86bf,0x656b8133,0x61e0e2e1,0x20ca816f}},	//   यवसा, tegh, koml, ापुढ,
   {{0x7c2d62e2,0x3f9c8639,0x4439010c,0x644baeae}},	//   _kwar, _lovu_, oss_, tugi,
   {{0x7c22b394,0x628a063e,0x7d0d0122,0x443962e3}},	//   gpor, _àfor, _mgas, nss_,
   {{0x3f9c803a,0x200f8b20,0x7c2d0435,0xe6670656}},	//   _novu_, _rugi_, _mwar, _отбо,
   {{0xc8088028,0x38668091,0x61fbe2e4,0x2ca98267}},	//   _gởi_, _apor_, tmul, šad_,
   {{0x20078393,0x7d0d24ff,0x2bdd86bf,0x443900eb}},	//   _sini_, _ngas, यवहा, kss_,
   {{0x26138003,0x31790063,0x2007e2e5,0x61e9ad27}},	//   _são_, _masz_, _pini_, rlel,
   {{0x442db44e,0x7d0d62e6,0x61fb9430,0x61e98f09}},	//   _iwe_, _agas, smul, slel,
   {{0x2007e2e7,0x6609e2e8,0x3f9c8858,0x7d0d019d}},	//   _vini_, _kiek, _dovu_, _bgas,
   {{0xb17b108c,0x26138073,0x200782d6,0x442de2e9}},	//   _skån, _vão_, _wini_, _kwe_,
   {{0xa8a795e4,0x2007bd9b,0x442d8247,0x5e56803d}},	//   _تصاو, _tini_, _jwe_, ولیس_,
   {{0x6609ac28,0x7c2d05ad,0x26138073,0x442da4e7}},	//   _liek, _dwar, _tão_, _mwe_,
   {{0x36668098,0x80ec00ab,0x387f807b,0x442d98b7}},	//   _защо_, _কলেজ_, lvur_, _lwe_,
   {{0x6609e2ea,0x442d9c00,0x3f9c8024,0x15e812c6}},	//   _niek, _owe_, _zovu_, _टीचर_,
   {{0xa0675668,0x7c2d62eb,0x18670847,0x656402a0}},	// [60a0] ната_, _gwar, нати_, _ibih,
   {{0x442062ec,0x5c5b010f,0x7d1be2ed,0xf99f010c}},	//   _iti_, _צדיק, _afus, _hièl_,
   {{0x7c2d46f6,0x442002f7,0x34a880c2,0x660989ff}},	//   _zwar, _hti_, कन्द, _biek,
   {{0x7c22cbab,0x442dc314,0x6609809a,0x14c8803d}},	//   tpor, _bwe_, _ciek, وهای_,
   {{0xfb0b0102,0xb4aa8063,0x660990e1,0x442db26a}},	//   _óëñ_, खने_, _diek, _cwe_,
   {{0x442d8205,0xa01b016d,0x7c22b437,0xa3d60a74}},	//   _dwe_, _krön, rpor, िकट_,
   {{0x442de2ee,0x38668808,0x92948110,0x69058201}},	//   _ewe_, _spor_, тайц, ərdə,
   {{0x442062ef,0xd13080f7,0xdee31b47,0x44392f9c}},	//   _oti_, جمة_, _соси, yss_,
   {{0x44204314,0xa3e001ab,0x442dbe82,0x6d408085}},	//   _nti_, तवा_, _gwe_, _idma,
   {{0x66098a0f,0x316003ac,0x200a10fe,0x7c2d00b4}},	//   _ziek, hfiz_, _jibi_, _rwar,
   {{0x442062f0,0x7c2d2044,0xb907916e,0xffb700be}},	//   _ati_, _swar, _मु_, גליש_,
   {{0x7bc181ac,0x7173803d,0xf41f016d,0xdd12061c}},	//   _zmlu, _مهما, nväg_, rüşm,
   {{0x07a6b317,0x69c10036,0x499b81c6,0x38668824}},	//   _падн, èlem, _משאב, _upor_,
   {{0x443962f1,0x3872031d,0x61e60609,0x3f9c9c40}},	//   rss_, dwyr_, _akkl, _uovu_,
   {{0x6d40803a,0x442062f2,0xa785803d,0x81c900ab}},	//   _odma, _eti_, _جشنو, _লীগ_,
   {{0x7d0d2e96,0x7c2d18e3,0x443b01c0,0x200a00fc}},	//   _ugas, _twar, _tvq_, _aibi_,
   {{0x656f62f3,0x7ddd0019,0x7c2d62f4,0x38720114}},	// [60b0] mech, kész, _uwar, gwyr_,
   {{0x6609d8d3,0xdb018009,0x6d40ddf0,0x200a047f}},	//   _siek, _yllä, _adma, _cibi_,
   {{0x6609b50e,0xa01b00f2,0x7bc70f27,0x645d62f5}},	//   _piek, _grön, miju, ltsi,
   {{0x7bc762f6,0x657d62f7,0xdb1c02b7,0x656f1c18}},	//   liju, ndsh, mirá, nech,
   {{0x2129059c,0x645d62f8,0x6ac9824c,0x61ed62f9}},	//   mbah_, ntsi, िप्र, mlal,
   {{0x200a0179,0x61ed45ea,0x7bc762fa,0x64a2a29c}},	//   _gibi_, llal, niju, раша,
   {{0x22568288,0x644f0661,0x248480ee,0x6609e2fb}},	//   نلود_, huci, _ermm_, _tiek,
   {{0x645d0074,0x9f4100f1,0x61ed0cf4,0x644f1a99}},	//   ktsi, kohë_, nlal, kuci,
   {{0x442dcdd5,0x644f0042,0x645d3592,0x4439877f}},	//   _uwe_, juci, jtsi, _ìs_,
   {{0x61ed029b,0x81d700ab,0x657bab06,0xa283803d}},	//   hlal, িতি_, _hauh, _میتو,
   {{0x656f62fc,0x273c001b,0x6285022c,0x212900dd}},	//   fech, lání_, _nrho, kbah_,
   {{0x2d9f902d,0xdb1c0511,0x657be2fd,0x645d11e6}},	//   _joue_, dirá, _jauh, ftsi,
   {{0x81d700c8,0x61ed005d,0x853a8039,0x273c001b}},	//   িতা_, dlal, וגרי, nání_,
   {{0x8fa28ce6,0xf7458811,0x2d990168,0x657be2fe}},	//   _ваше, _реко, ajse_, _lauh,
   {{0x645d1e7a,0xdb1c4bce,0x39988061,0x62850144}},	//   atsi, girá, _rész_, _crho,
   {{0x61ed62ff,0x200a6300,0x656f2997,0x442062e0}},	//   glal, _sibi_, cech, _tti_,
   {{0x644f2d11,0x26170073,0x44203c92,0x2d5a0353}},	// [60c0] cuci, _aço_, _uti_, _všeč_,
   {{0x273c000d,0x61ed20df,0xdb1c05e4,0x3872031d}},	//   dání_, alal, birá, rwyr_,
   {{0x1dc620d5,0x21295f85,0x25a00573,0x7ddd0019}},	//   _लगात, bbah_, _koil_, vész,
   {{0x290f8072,0x71a6284f,0xe9a60b5b,0x200a010c}},	//   _ngga_, _рамз, _рамп, _wibi_,
   {{0x200a130c,0x779100d5,0x2d9f8473,0xf41f0106}},	//   _tibi_, _گیلا, _doue_, rväg_,
   {{0x656f0063,0x61e40198,0xf41f0338,0x69c28cab}},	//   zech, loil, sväg_, _smoe,
   {{0x645b8cf7,0x644f0035,0x877b03de,0x7ddd0061}},	//   _equi, zuci, _קאלי, rész,
   {{0x28c70aad,0x80e080ab,0x16770039,0x68eb835f}},	//   _रेडि, _পৃষ্, _בגלל_, _bygd,
   {{0x656f6301,0x394200ee,0x645d6302,0x6da3a3d7}},	//   vech, _mdks_, xtsi, _тита,
   {{0xaadb01ce,0xdce400ce,0x644f042b,0x656f6303}},	//   _मुझक, _naiđ, vuci, wech,
   {{0xe5351a8f,0xdd9107bd,0x777c173e,0x4426c2fc}},	//   лень, مود_, _marx, lpo_,
   {{0x23698024,0xa01b016d,0xb5a704fa,0x6846a2f6}},	//   đaje_, _bröl, трой, _анда,
   {{0x656f6304,0xceb88063,0x4426e305,0x5c741676}},	//   rech, szę_, npo_, алят,
   {{0x4426840e,0x645d6306,0x656f6307,0xdb1c188b}},	//   ipo_, rtsi, sech, tirá,
   {{0x656f1c56,0x764f8063,0x21290b50,0x644f036e}},	//   pech, ącyc, tbah_, suci,
   {{0x1e978051,0x7bc701e2,0x44268135,0xdb1c0511}},	//   _יכול_, siju, kpo_, rirá,
   {{0x61ed0483,0x657b8009,0x7bc70110,0x2d9f8036}},	// [60d0] rlal, _rauh, piju, _roue_,
   {{0x273c03bb,0x76430019,0x21290748,0x2ca40106}},	//   vání_, ányo, sbah_, ämde_,
   {{0x660d6308,0xe45f0009,0xdbdc807b,0x212901a1}},	//   _kiak, ltö_, _ráðh, pbah_,
   {{0x79951baa,0xa439908d,0x61e401a8,0x7d0901a9}},	//   _симф, езду_, coil, _tīrī,
   {{0x660d022e,0x4426820d,0x798f04ee,0x754485a8}},	//   _miak, gpo_, _incw, рніз,
   {{0x273c01d0,0x60cd80c3,0xfe0a027d,0xdce40372}},	//   rání_, _žamo, _hắt_, _jniġ,
   {{0x657bd2c1,0x68eb806a,0x75f60061,0x4426e309}},	//   _tauh, _sygd, háza, apo_,
   {{0x75f6003e,0x16199094,0x387900ee,0x77ad83a8}},	//   káza, _नंबर_, _kssr_, _púxo,
   {{0xfe0a0028,0x76b3811c,0x60099af1,0x7bc5630a}},	//   _mắt_, məyə, нним_, _omhu,
   {{0x777c07e2,0xe8f68196,0x443fddad,0x53b7816f}},	//   _xarx, ылы_, _ivu_, _अतिश,
   {{0xada601a1,0x6da600b3,0x660d054a,0xadc3801c}},	//   ганл, гина, _biak, _giản,
   {{0x644bd9a5,0x7bc50706,0x660d00e5,0x63a18061}},	//   orgi, _amhu, _ciak, _holn,
   {{0x660d0397,0x443d82f7,0x61e4630b,0xa7858bbe}},	//   _diak, nsw_, voil, _مشغو,
   {{0xb88283c1,0x317f811b,0xc2f68264,0x69c9a3df}},	//   čítk, lduz_, _চলতি_, liee,
   {{0xd94611b3,0xfe0a0028,0xa01b00f2,0x63a1ae6c}},	//   леви, _bắt_, _dröm, _moln,
   {{0x443f8025,0xfe0a001c,0x660d0420,0x317fe30c}},	//   _ovu_, _cắt_, _giak, nduz_,
   {{0xbfa3077f,0xe9d72f42,0x1f660b79,0x75f60333}},	// [60e0] _àwọn_, укт_, лкам, cáza,
   {{0x7c240850,0x777c01b4,0x6b561133,0x649701c6}},	//   _itir, _qarx, _стих, _עדיף_,
   {{0xaac39344,0x4d4a8be2,0xc8f081a2,0x2b5a02d6}},	//   _वेलक, епен_, _चर्म_, _icpc_,
   {{0x35e59138,0x63a18362,0x3879010c,0xfe0a0129}},	//   аців, _aoln, _fssr_, _gắt_,
   {{0x777c630d,0x69c6630e,0x4426c4ec,0x4c94954f}},	//   _tarx, _imke, upo_, рилс,
   {{0x66e60767,0x44320355,0xdb08802a,0xdee6110e}},	//   _бога, _mwy_, _aldá, _боги,
   {{0x63a1a08f,0x27ea0748,0x443fb0a6,0x644ba4b5}},	//   _doln, _ikbn_, _evu_, argi,
   {{0x44268698,0xdb08816d,0x7c2400fe,0x6d4400f7}},	//   ppo_, _omdö, _otir, _ndia,
   {{0x63a199b7,0x7c240314,0x661b0088,0x661504e8}},	//   _foln, _ntir, _čuki, _zuzk,
   {{0x4424dad8,0x6d44438a,0x660d09ca,0x66028326}},	//   _itm_, _adia, _siak, lmok,
   {{0x7c244c78,0x051680ab,0xb2269229,0x4432026b}},	//   _atir, ারীর_, _смел, _awy_,
   {{0xac192964,0x38601a45,0x7bcac00f,0xe9da80e8}},	//   кому_, ktir_, lifu, _яке_,
   {{0x4424cfd1,0xdb1e15a0,0xe973803d,0x6d440428}},	//   _jtm_, _empí, _دهند, _ddia,
   {{0xfe0a001c,0x44320114,0x69c80036,0x46b40072}},	//   _sắt_, _dwy_, èden, ंनाह,
   {{0x7c240085,0x171b80be,0xe45f0009,0x62354f91}},	//   _etir, _אווע, stö_, ребу,
   {{0x1619835a,0x4432031d,0x38600b97,0x75f60f09}},	//   _नंतर_, _fwy_, ftir_, lázn,
   {{0x98170154,0x7bca8309,0x2a7a01a1,0x200e8300}},	// [60f0] ابرا, kifu, _espb_, _kifi_,
   {{0xd6db490d,0x62889eed,0x7bca8010,0xd101000c}},	//   нте_, _ordo, jifu, लेषण_,
   {{0x443f8052,0xd6db0ddc,0xfe0a001c,0x38600748}},	//   _svu_, хта_, _tắt_, atir_,
   {{0x63a18b81,0x24891b4a,0x673ae30f,0x00000000}},	//   _soln, _kram_, hatj, --,
   {{0x63a1a8f2,0x6288b3ab,0x22838214,0x493a0039}},	//   _poln, _ardo, _sık_, _בגרו,
   {{0x62888042,0x8c1c03de,0x443fd542,0x7bca8c6f}},	//   _brdo, עווי, _vvu_, gifu,
   {{0xe2998c07,0x63a19be6,0x5b580051,0xea0000ff}},	//   тай_, _voln, אשון_, _chặt_,
   {{0x63a1809a,0x62838b80,0x200e930c,0x48fc001b}},	//   _woln, rvno, _aifi_, लेको_,
   {{0xa91d8067,0x6288e310,0x24890069,0x69c9e311}},	//   jdže, _erdo, _nram_, riee,
   {{0x69c981b0,0xb06880f7,0x3f810077,0x9e6581e2}},	//   siee, اصيل_, ndhu_, авод,
   {{0xf772004c,0x2c1d80c8,0x75f884c3,0x7bfa8158}},	//   חקי_, _নিয়ে_, líza, _ספעצ,
   {{0x24896312,0x6933804e,0x44320114,0x4424b5a4}},	//   _bram_, _اکثر, _pwy_, _ytm_,
   {{0x200e84be,0xd1b8803d,0x75f883a8,0xb4c003b7}},	//   _fifi_, _حالا_, níza, ंछे_,
   {{0xf77196a5,0xbcfb007b,0xa01b0106,0x24896313}},	//   _ذات_, mfél, _tröj, _dram_,
   {{0x24891fea,0x6569e314,0xdb250019,0xa01b18b6}},	//   _eram_, _obeh, ásár, _frök,
   {{0x38603816,0x24890357,0x13d286ab,0x31260048}},	//   ttir_, _fram_, _तद्भ, рдаг,
   {{0xfbdf0548,0xa3e58074,0x2d920870,0x00830037}},	// [6100] guês_, नवा_, _inye_, олто,
   {{0xee0e81ab,0x6d5be315,0x320f816b,0xf77201a8}},	//   िद्ध_, _acua, _ligy_, غاء_,
   {{0x38606316,0x2fc780dd,0x660286cb,0xdb1e0580}},	//   stir_, _mmng_, tmok, _impà,
   {{0x38606317,0x9325003d,0x75f604e8,0xb8cc0264}},	//   ptir_, _پرین, zázn, _কই_,
   {{0x69d66318,0x2722801b,0x6e29007a,0x66028cf9}},	//   mnye, nční_, _čebe, rmok,
   {{0x051680c8,0x6d5bb724,0x81d700ab,0x2a6ca404}},	//   ারের_, _ecua, িতঃ_, _ppdb_,
   {{0x2d96885f,0x7bcae319,0x2d920a2c,0xa59680e8}},	//   _крас, rifu, _onye_, _кращ,
   {{0x2369803b,0xdca6a318,0x69d61fc5,0x7bca805d}},	//   đaja_, _каби, nnye, sifu,
   {{0x442480ee,0x673a8019,0x73768fe6,0x62830118}},	//   _utm_, tatj, _выех, _ánov,
   {{0x07b88307,0x2d925b41,0x8146804e,0x69d600ee}},	//   اهدة_, _anye_, _چنان, hnye,
   {{0x2d8004df,0x2486813c,0xc2248065,0x673ae31a}},	//   _baie_, lvom_, _اکتو, ratj,
   {{0x58868a8e,0x200e9532,0x2fc782f7,0xc8c79e29}},	//   _выка, _wifi_, _emng_, اوین_,
   {{0xa3ca901c,0x2d800748,0x3a2600c3,0x2d920176}},	//   _लगा_, _daie_, _čopa_, _dnye_,
   {{0x2d9252a1,0x9f5844d0,0xa91d80ce,0xfd1f01e8}},	//   _enye_, _miró_, rdže, scì_,
   {{0x31c7076a,0xf9c70098,0x19950098,0xdb018036}},	//   асав, ащан, бавя, _colè,
   {{0x2486803a,0xbf0700d4,0x4e1d0105,0x391513bd}},	//   kvom_, _वृषभ_, _बंबई_, смар,
   {{0xa3d6853e,0xd7aa8fd5,0x4059053d,0x3dc902c4}},	// [6110] ाचा_, _चकाच, طلاح_, _imaw_,
   {{0x753d0117,0x2fc70104,0xdf3900f7,0x2d80011b}},	//   lasz, òng_, اكات_, _zaie_,
   {{0x75158307,0x3f810dab,0x39468084,0x3ea74991}},	//   مواض, rdhu_, _odos_, ânt_,
   {{0x241981bb,0xb99500f7,0xdb1e002a,0xbcfb0061}},	//   годы_, _الحب, _impá, yfél,
   {{0xb8cc00c8,0x320f8326,0x2d588087,0x629a01d6}},	//   _কে_, _rigy_, ричь_, ätov,
   {{0x6738920e,0x75f881df,0x3946e31b,0xfe0a001c}},	//   _nevj, ríza, _ados_, _lắp_,
   {{0xe1ff0028,0xdb01e31c,0x21390168,0x753d5dea}},	//   _khó_, _kolé, _kesh_, kasz,
   {{0x2249803b,0x20110010,0x69cd031d,0x63a501ec}},	//   čak_, _hizi_, niae, _lohn,
   {{0xdb01887a,0x78ad3e2e,0x9f59041c,0x0dc88bc7}},	//   _molé, nyav, _fusô_, _тури_,
   {{0x3fb780c8,0xbcfb007b,0x2019631d,0x291f8511}},	//   ীক্ষ, rfél, _musi_, scua_,
   {{0xbebc8029,0x66e5961a,0x20190f33,0x6b9c8722}},	//   ecīb, сона, _lusi_, _òrga,
   {{0x6d59a6bd,0x75f61307,0xe1ff4462,0x6b818079}},	//   ngwa, rázo, _nhó_, _halg,
   {{0x3f69831f,0x69cd0114,0xdb0186c0,0xb0c706a7}},	//   _било_, diae, _solè, _रेलग,
   {{0x6b818074,0xe1ff046d,0xdb018722,0x272281d0}},	//   _jalg, _ahó_, _polè, rční_,
   {{0x6b81e31e,0x2d9200ee,0x2d800162,0x213903ed}},	//   _malg, _tnye_, _taie_, _besh_,
   {{0x2019190d,0xe1ff00ff,0xdb01e31f,0x69cd4850}},	//   _busi_, _chó_, _colé, giae,
   {{0x201157b3,0x69d60eb9,0x21200214,0x442b0144}},	// [6120] _bizi_, rnye, rcih_, cpc_,
   {{0x6b818feb,0x61e98c0b,0xc49b01c6,0x2a69866f}},	//   _nalg, hoel, _עשית, łaby_,
   {{0x6b7b0f60,0x20110214,0x7bce01f6,0x0e66072f}},	//   _גרינ, _dizi_, mibu, скен,
   {{0x24868ee0,0x20196320,0x7e4b0019,0x395d8326}},	//   tvom_, _fusi_, اسلہ_, _ncws_,
   {{0x61e9838e,0x201910e1,0xeb108105,0x9f5801e8}},	//   doel, _gusi_, ाश्त_, _dirò_,
   {{0x6b8182e6,0x2011061b,0xf99f0247,0x2d809e1e}},	//   _calg, _gizi_, _chèf_, žie_,
   {{0xb28691e9,0x75240102,0xe7dd016f,0x7d160114}},	//   сылк, _ofiz, _मदतप, _ogys,
   {{0x75d69a37,0x7bce0a4f,0x61e98102,0x79843328}},	//   _ايرا, hibu, goel, ndiw,
   {{0xf48483f8,0xa3c90b3b,0xa3e81664,0x3ce001c0}},	//   _بازی, लोड_, यका_, _nxiv_,
   {{0x310483b7,0xfe0a001c,0x2fca0042,0x6b81d625}},	//   शेषः_, _sắp_, _jmbg_, _galg,
   {{0x7bdf82be,0x63a509f4,0xbcfb016b,0xe21696a5}},	//   éque, _rohn, rfém, _طباع,
   {{0xd6d78987,0x8cb50023,0x64428009,0x604181bc}},	//   сть_, उनलो, osoi, _ịmer,
   {{0xac1903c7,0xb0c7131d,0x753d5dea,0x6ce70048}},	//   рогу_, _रेंग, rasz, сіне,
   {{0x7d160065,0x442b0953,0x69da00e7,0x9f5800f7}},	//   _egys, rpc_, éten, _bhrí_,
   {{0x7f3b8159,0x20190475,0x753d0019,0xe1ff001c}},	//   _געוו, _susi_, pasz, _phó_,
   {{0x38350160,0x63a50352,0xdcfb9c67,0x23ab806a}},	//   жнар, _wohn, _sauč, _højt_,
   {{0x270e8086,0xdb05020f,0xa91dd869,0x69cd0355}},	// [6130] lən_, _kohë, ndža, riae,
   {{0x44292778,0x161d00d4,0x78ad038a,0x61e9b847}},	//   _ita_, _बंदर_, ryav, zoel,
   {{0x163b0013,0xb8f02261,0x270e8085,0xdcfb9487}},	//   اسطة_, _वे_, nən_, _vauč,
   {{0x4ac3816f,0x2011004f,0x20196321,0x7afa5b64}},	//   _वेगव, _wizi_, _tusi_, ütte,
   {{0xa3bd491d,0x04679240,0x201903ff,0x61e983b2}},	//   _आता_, стем, _uusi_, voel,
   {{0x1ae280ab,0x270e8085,0x62830118,0x75228037}},	//   গেছে_, kən_, _ános, acoz,
   {{0x6b81e322,0x61e99c11,0xb16e008b,0x9f580037}},	//   _valg, toel, _þýði, _tirò_,
   {{0x270e8086,0x44296323,0x7bce29f7,0x6b819337}},	//   dən_, _ota_, zibu, _walg,
   {{0x44296324,0x98a0017f,0x9f458198,0x7bce31ba}},	//   _nta_, rbić_, yllä_, yibu,
   {{0x7c2982a0,0x3e7a8029,0x656d409f,0x20118019}},	//   _iter, _būt_, _abah, özi_,
   {{0x44296325,0x753b8a0f,0xd9fb016f,0xa3d686ab}},	//   _ata_, _keuz, ्षात_, ाचर_,
   {{0x7c2983bb,0x3f831600,0x960400d4,0xa50a0073}},	//   _kter, _laju_, रगेट_, иена_,
   {{0x7bce6326,0xf7459285,0x7641d64b,0xccfa0221}},	//   tibu, _дело, ssly, рхні_,
   {{0xf8078cd0,0x7643808e,0x248d8b80,0x69dd0140}},	//   _учен, _tvny, _mrem_, _ajse,
   {{0x44296327,0x9c870efc,0x316900ee,0x201f8144}},	//   _eta_, _počí, ffaz_, lqui_,
   {{0x7c29a467,0x3ce010af,0x753bd660,0x7bce3328}},	//   _oter, _txiv_, _neuz, sibu,
   {{0xa2ca03bb,0x3f830867,0x7c29e328,0x201fbb40}},	// [6140] _हेर्, _baju_, _nter, nqui_,
   {{0x3f85805d,0x46f60098,0x24800214,0x75f601d0}},	//   ndlu_, очет, _isim_, kázk,
   {{0x69cb8b3c,0x7c29e329,0xe29a0f27,0xdd1c816b}},	//   _omge, _ater, _тан_, rážo,
   {{0xf53f0bc5,0x213f810b,0x44290711,0x7c2989d1}},	//   lkår_, jauh_, _yta_, _bter,
   {{0xac0aae15,0x240a9b78,0xdca38dc9,0x270e8085}},	//   анда_, анди_, маци, zən_,
   {{0x270e8201,0x7522b7b7,0xa01b016d,0xdb0501b3}},	//   yən_, scoz, _pröv, _bohè,
   {{0x64429dbd,0x248d87f1,0x96631bb1,0x3f85ad50}},	//   ssoi, _erem_, _окре, ddlu_,
   {{0x2480003a,0x394009b2,0x248d8b40,0xdd92803d}},	//   _osim_, nais_, _frem_, _تور_,
   {{0x673c059c,0x248d807a,0x28d00ec5,0x6010046d}},	//   _kerj, _grem_, _सेमि, _gómì,
   {{0x39402039,0x661c632a,0x2d84e32b,0xa91d826c}},	//   hais_, _kurk, _hame_, rdža,
   {{0x39402338,0x24801087,0x2d84e32c,0x673c632d}},	//   kais_, _asim_, _kame_, _merj,
   {{0x63a8a191,0x69da0065,0x270e8201,0x39400df1}},	//   _hodn, étel, rən_, jais_,
   {{0x270e8201,0x442902f7,0x7c298609,0x39405042}},	//   sən_, _qta_, _xter, dais_,
   {{0x673c3f01,0x63a881a1,0xd0078087,0x98a382ee}},	//   _nerj, _jodn, _дече_, _циље,
   {{0x63a8bc6d,0xd13b0098,0x24800009,0xf1a70705}},	//   _modn, иха_, _esim_, оран,
   {{0x2d84e32e,0x224d632f,0x2d8500eb,0x656d20cf}},	//   _name_, ček_, ēles_, _ubah,
   {{0x673c14ff,0x44296330,0x661c00ad,0x2bdba261}},	// [6150] _berj, _uta_, _aurk, _बदला,
   {{0xf7730872,0x59ca8105,0x656080f7,0xc72b00e8}},	//   بار_, ़ोतर, _acmh, ріал_,
   {{0x661c4573,0x248d8bda,0x673c5d01,0x2d84cf3e}},	//   _curk, _srem_, _derj, _bame_,
   {{0x7c298358,0x7e9b8051,0x394009b2,0x427a00be}},	//   _pter, יסבו, cais_, _פארג,
   {{0xc86405a5,0x506404fa,0xdb170118,0xa3d6816f}},	//   _отри, _отра, _alxé, ाचं_,
   {{0x32096331,0xd0fa0b04,0x447c00be,0x248d8087}},	//   lmay_, ्धरण_, ינדע, _vrem_,
   {{0x61e48353,0x661c048d,0xb113019d,0x63a8816b}},	//   čiln, _gurk, _bụga, _dodn,
   {{0x75f6003e,0x32091a03,0x2d848039,0x248de332}},	//   rázk, nmay_, _game_, _trem_,
   {{0xdb1e0009,0xc21b8424,0xb3678098,0x661c00fe}},	//   _ympä, _पूरब_, _мъжк, _zurk,
   {{0x6d5d0079,0x2d84e333,0x394026c5,0xaec59bdc}},	//   egsa, _zame_, zais_, збол,
   {{0xe9df0324,0x25a90118,0xdb01816b,0x3f85808e}},	//   _ojú_, _boal_, _kolí, rdlu_,
   {{0x6281e334,0x69cb90f6,0xdb1c00f7,0x24800d56}},	//   _islo, _umge, mhré, _psim_,
   {{0x39400e37,0x6b855c52,0x60020187,0x6459cc2b}},	//   vais_, _bahg, lôme, nuwi,
   {{0xe81f0816,0xe9df4bbe,0x2c641e2b,0x201d82d5}},	//   _बढ़ा_, _ajú_, röd_, _iuwi_,
   {{0x39406335,0x60020187,0x8f9a81c6,0x3af50198}},	//   tais_, nôme, _ליסי, дятс,
   {{0x248001e9,0x673c01b9,0x201d83f8,0x3209033e}},	//   _tsim_, _serj, _kuwi_, gmay_,
   {{0x673c6336,0x24800748,0x61f605ee,0x55bb01c6}},	// [6160] _perj, _usim_, rlyl, _למקו,
   {{0x2d84bada,0x39400e37,0xdee6171c,0x32090079}},	//   _same_, sais_, пози, amay_,
   {{0x64466337,0x673c6338,0xa01b016d,0xdb01b49a}},	//   lski, _verj, _brös, _bolí,
   {{0x63a88353,0x271901d0,0x320901b4,0x6002041c}},	//   _sodn, třní_, cmay_, dôme,
   {{0x673c0855,0xc95304de,0xa2d40a74,0x645980e4}},	//   _terj, _אמר_, णपक्, guwi,
   {{0x64466339,0x60d68084,0x60c40234,0x79860a03}},	//   iski, _žymo, mzim, _hakw,
   {{0x63a8905e,0xdee3196e,0xdb018825,0xd35700be}},	//   _vodn, _зори, _folí, ליסי_,
   {{0xcb130051,0xa01b0004,0x61e482d4,0x63a88035}},	//   עלה_, _tröt, čilo, _wodn,
   {{0x60c427f6,0x7986633a,0x5ea980ab,0x1b1b8264}},	//   nzim, _makw, _ছেলে, _নজরে_,
   {{0x25a90500,0x6604633b,0x9178826b,0x60021243}},	//   _soal_, _ahik, _bẹ́_, lômb,
   {{0xb8f39880,0x32090637,0x66041cfe,0x79861b6c}},	//   _हे_, ymay_, _bhik, _oakw,
   {{0x6604633c,0x798620c4,0xd5bb1cad,0x1a9b80be}},	//   _chik, _nakw, ссо_, _ליבע,
   {{0xafdb0aa2,0xdcef0087,0x6446633d,0x66045d7f}},	//   _svøm, decă, gski, _dhik,
   {{0x60c4633e,0xa01b0338,0x7f4196f0,0xea000129}},	//   dzim, _orör, calq, _đạc_,
   {{0x61ed633f,0x79866340,0x2b4c826c,0xd37800e8}},	//   toal, _bakw, _mddc_, ччя_,
   {{0x52142804,0x65bf020f,0x777a8102,0x765a83f7}},	//   едст, _bëhe, letx, muty,
   {{0x28c70076,0x79866341,0x32093dd0,0x6d4d5735}},	// [6170] _रेखि, _dakw, rmay_, _idaa,
   {{0x7c2d00b4,0xdb01816a,0x32093cc0,0x61ed4395}},	//   _itar, _solí, smay_, soal,
   {{0x4fc41b47,0xf77001a8,0x752d8333,0x1a650061}},	//   хста, طال_, ñazo, _تیزی_,
   {{0xf65007bd,0x6459809c,0x25a9807b,0x79866342}},	//   ائل_, tuwi, ðal_, _gakw,
   {{0x69c0931a,0x8ccd809a,0xf3ff0187,0xdb01e343}},	//   dhme, _देशो, ntão_, _volí,
   {{0x38696344,0x79863937,0x765a818c,0xeb969a19}},	//   mtar_, _zakw, kuty, диш_,
   {{0xf7720039,0x79866345,0xa01b1614,0xdb0502df}},	//   _שקל_, _yakw, _trös, _ilhó,
   {{0xdb08a246,0x3a2c8118,0x69c0822b,0x64466346}},	//   _modè, _dtdp_, ghme, yski,
   {{0x7c2d02a0,0x69dbe347,0x7d1bcb06,0xc5e99d40}},	//   _ntar, rnue, _igus, टकीय_,
   {{0x442da2cd,0x6604020f,0x644647c4,0x3869383c}},	//   _ite_, _shik, vski, itar_,
   {{0x6281a8e1,0x7c2d24fc,0x6446009a,0x90e782e3}},	//   _uslo, _atar, wski, _کسان,
   {{0x6446003a,0xe9458077,0xd7f88087,0x3869343f}},	//   tski, _آرای, ală_, ktar_,
   {{0xb4b84823,0x644601bb,0xdb1e002a,0x201d876d}},	//   चने_, uski, _impú, _uuwi_,
   {{0x79866348,0xee399fab,0x395fd3a9,0x38696349}},	//   _sakw, _днк_, lgus_, dtar_,
   {{0x644606b1,0x386903a7,0xca7514ef,0x7c2d634a}},	//   sski, etar_, нуты, _etar,
   {{0x64460289,0x38690455,0x395fe34b,0x7d1be34c}},	//   pski, ftar_, ngus_, _ngus,
   {{0x60c4003b,0xa0670819,0x386900f7,0x18671132}},	// [6180] uzim, мата_, gtar_, мати_,
   {{0x7d1bd298,0xe45703c8,0x79862198,0x69cf3392}},	//   _agus, _קייט_, _wakw, _emce,
   {{0x442dceb6,0x3f87e34d,0x4420634e,0x7986634f}},	//   _ate_, _manu_, _hui_, _takw,
   {{0x44202cdd,0x89361125,0x3f878032,0x442d80b9}},	//   _kui_, _تعدا, _lanu_, _bte_,
   {{0x75e803bf,0x7989aaf1,0x44200036,0x0c7a99ea}},	//   mızd, ddew, _jui_, تصاب_,
   {{0x28c709a3,0x44200681,0x7529e350,0x442de351}},	//   _रेटि, _mui_, _efez, _dte_,
   {{0x44203d57,0x442db4c0,0xfd6500ff,0x69c0e352}},	//   _lui_, _ete_, _chuố, thme,
   {{0x31600380,0x442003d3,0x3f8782a3,0x75e803bf}},	//   ngiz_, _oui_, _aanu_, nızd,
   {{0xf4d900c8,0x6d40e353,0x30148cdf,0x6e2d8279}},	//   _সর্ব, _iema, ндир, _čaba,
   {{0x2018082e,0x6d40e354,0x69c0a5ee,0x909b03c8}},	//   _jiri_, _hema, shme, קסיק,
   {{0x6d408458,0x2018322e,0x05c28996,0x0f570039}},	//   _kema, _miri_, _शताब, ויים_,
   {{0x6d40e355,0x25a6e356,0xa3d684e5,0x20186357}},	//   _jema, njol_, ाचक_, _liri_,
   {{0x6d40845c,0x44200698,0xf9c782e3,0x39448110}},	//   _mema, _cui_, _تحلی, mams_,
   {{0xf3ff00a9,0xa3c90063,0x6d40878a,0xb3458073}},	//   rtão_, लों_, _lema, maçã,
   {{0xb34580a9,0xf3ff00a9,0xf1b280a5,0xd6cf99b8}},	//   laçã, stão_, _जवान, _рт_,
   {{0x23698e78,0x386903e5,0x44206358,0x39448110}},	//   đaji_, ttar_, _fui_, nams_,
   {{0x7c20b432,0x20186359,0xb3458073,0x5f952b98}},	// [6190] _numr, _biri_, naçã, ниат,
   {{0x645d41cb,0x3869635a,0x2018059c,0xdbd68406}},	//   musi, rtar_, _ciri_, _jään,
   {{0x6449e35b,0x2018208b,0x5d558425,0x6d409a23}},	//   _svei, _diri_, екет, _bema,
   {{0x6285635c,0x3869635d,0x3f870024,0x3944989e}},	//   _isho, ptar_, žnu_, jams_,
   {{0x6d4090b6,0x3944a57b,0x645d19ad,0x1c008074}},	//   _dema, dams_, nusi, _लीहल_,
   {{0x7bd52ed0,0x657d37b8,0xb34583a7,0x3a210101}},	//   nizu, hesh, daçã, _kuhp_,
   {{0x645d022e,0x387f80b9,0x63a80106,0xadc38129}},	//   husi, wwur_, ödni, _giến,
   {{0x6d40844e,0x657d1cc8,0x201852e3,0x645d2bc0}},	//   _gema, jesh, _ziri_, kusi,
   {{0xe0d9920c,0xb3458073,0x657d3d1c,0x20180f50}},	//   яви_, gaçã, desh, _yiri_,
   {{0xfd650028,0x3fcd80ab,0x75f88e14,0x60068150}},	//   _thuố, রক্ষ, vízi, нным_,
   {{0x44204db7,0xf1bf2ed8,0xf77200be,0x62852221}},	//   _sui_, _olá_, נקט_, _nsho,
   {{0x4420002e,0x3219052a,0x6d40e35e,0x394481a9}},	//   _pui_, _nisy_, _xema, cams_,
   {{0x4420635f,0xb34580a9,0x7fd5b73a,0x645d6360}},	//   _qui_, caçã, _пікі, gusi,
   {{0xdee5cddf,0x61fba40a,0x44200104,0x66e59d85}},	//   _поли, llul, _vui_, _пола,
   {{0x61e90025,0x645d0a8e,0xe2971b67,0xf770819f}},	//   čeln, ausi, нар_, _خان_,
   {{0x20180a54,0x645d3ebe,0x63738059,0x44206361}},	//   _siri_, busi, lını, _tui_,
   {{0x6d463167,0x628504e8,0x6d40960c,0x394fc32a}},	// [61a0] maka, _esho, _rema, _mdgs_,
   {{0x04790077,0x7d042a0c,0x6373817b,0x61fb805d}},	//   _کلیک_, _izis, nını, hlul,
   {{0xb34580a9,0x6d408812,0x2018007a,0x61460294}},	//   zaçã, _pema, _viri_, _пена,
   {{0x10a60ada,0x201802a6,0x291d882e,0xadc380ff}},	//   _зимн, _wiri_, _ngwa_, _viến,
   {{0x25ad837a,0x6373880a,0xb3458187,0x20186362}},	//   _doel_, kını, xaçã, _tiri_,
   {{0xf09f0142,0x69d66363,0x6d460c9e,0xadc38104}},	//   _ngày_, liye, haka, _tiến,
   {{0x6d40e364,0x6d461868,0x39448df1,0x657d0c53}},	//   _tema, kaka, tams_, yesh,
   {{0x6d46111f,0xb34580a9,0x7bc381ac,0xdbd68009}},	//   jaka, taçã, ahnu, _sään,
   {{0x6d461fb9,0x657d6365,0x61e2a316,0x3944989e}},	//   daka, vesh, _vjol, rams_,
   {{0xb3458003,0x7bc3c431,0x645d1202,0x3dc0076d}},	//   raçã, chnu, vusi, _aliw_,
   {{0x657d6366,0xd6da835f,0x6d463f60,0xd3378039}},	//   tesh, яти_, faka, _נראה_,
   {{0x6d4636ba,0xa3cc83b7,0xb34583a7,0x6562cf3e}},	//   gaka, शोर_, paçã, ngoh,
   {{0x69d63843,0x7afa854f,0x6ad91107,0x6373861c}},	//   diye, _hytt, णप्र, bını,
   {{0xbcfb03d3,0xf99f602f,0x7d04009a,0x657d6367}},	//   ffér, _chèn_, _dzis, sesh,
   {{0x645d6368,0xda780ac8,0x657d122b,0x7d040316}},	//   susi, нят_, pesh, _ezis,
   {{0x657d285d,0x69c436f1,0xceb38039,0x61e9463a}},	//   qesh, ghie, _תיק_, čelo,
   {{0x3f8a00a4,0x7afa8aa2,0x2129008e,0x25ad8bfd}},	// [61b0] _babu_, _lytt, rcah_, _roel_,
   {{0x628501c5,0x320d80b9,0x752d00fc,0x6002041c}},	//   _tsho, zmey_, _hfaz, tôma,
   {{0x7afa821e,0x69d60b8f,0x62853406,0x394203ba}},	//   _nytt, biye, _usho, _feks_,
   {{0x69c41c1e,0x6373861c,0x69d62fc1,0x3eae0106}},	//   chie, zını, ciye, äfta_,
   {{0x25ad90f4,0x637383bf,0xc86700e8,0x7dc600a2}},	//   _voel_, yını, _ятни, _fósf,
   {{0x6d466369,0x7afa8370,0xa91d9ff9,0x823400d7}},	//   zaka, _bytt, mdži, _جریا,
   {{0xa91d8110,0xda628c4f,0x68fc8085,0x61fbe36a}},	//   ldži, авщи, ərdi, tlul,
   {{0x798d3ebe,0x25bf80ee,0xa224803d,0xdce405a2}},	//   ndaw, _ulul_, دروه, _ubić,
   {{0x63738059,0xa91d8110,0x61fbe36b,0xa3d100c2}},	//   tını, ndži, rlul, वफा_,
   {{0x6d462917,0x69d65207,0x661b8009,0xddc900d2}},	//   waka, ziye, _hiuk, _ćošk,
   {{0x63738a0b,0x6d461999,0x644d344c,0xed5a1bdc}},	//   rını, taka, _avai, мон_,
   {{0x63738a0b,0x2369803a,0x69d60079,0x443f81bc}},	//   sını, đaju_, xiye, _kwu_,
   {{0x6d460859,0xc8d001fe,0x798d3fb0,0xdb1c007b}},	//   raka, _सेंट, ddaw, firð,
   {{0x69e3856f,0x799d0039,0x386de36c,0x661b8d15}},	//   šteđ, _answ, mter_, _liuk,
   {{0x6d461904,0x3f8a0274,0x43430098,0x60c98214}},	//   paka, _rabu_, ресв, lzem,
   {{0x3f8a636d,0x798d0bb1,0x75f60061,0x644ba475}},	//   _sabu_, gdaw, rázs, ksgi,
   {{0x386dc33f,0x7bc18364,0x69d6636e,0xbcfb04e8}},	// [61c0] nter_, _ollu, riye, sfér,
   {{0x44320e35,0x386de36f,0x69d66370,0x798b86a9}},	//   _ity_, iter_, siye, _lagw,
   {{0x386d8613,0xbcfb6371,0x69c46352,0x644d00eb}},	//   hter_, ngén, phie, _zvai,
   {{0x386de372,0x66098a54,0x7afa81a3,0x798bad80}},	//   kter_, _chek, _rytt, _nagw,
   {{0x672300d2,0x3f8a6373,0x661b9295,0x386db839}},	//   žnja, _tabu_, _diuk, jter_,
   {{0xa3cc809a,0xa3c20075,0x38601a2e,0x60c9af28}},	//   शों_, ंसि_, muir_, dzem,
   {{0xe9e6b1db,0x443f815e,0x38602216,0x798bb1ba}},	//   кцио, _ewu_, luir_, _bagw,
   {{0x386d8bfa,0xdb050118,0xe1ef92c5,0x661b8122}},	//   fter_, _johá, يسي_, _giuk,
   {{0x386dc4ea,0xbc6a936d,0x38600531,0xa3c24638}},	//   gter_, _زمان_, nuir_, ंसा_,
   {{0x61ed9148,0x7afa8009,0x2cc4880a,0xdb0881ac}},	//   čala, _tytt, ırdı_, _hodí,
   {{0x443200f1,0x06d580ab,0xa91d8110,0x644d0612}},	//   _aty_, _সুবি, zdži, _svai,
   {{0x4424dc05,0x6e239a2e,0x798b838a,0x7c241581}},	//   _kum_, _dunb, _gagw, _buir,
   {{0x386da71d,0x7c240068,0x442496b2,0x6d440102}},	//   cter_, _cuir, _jum_, _deia,
   {{0x442482ec,0x386045c6,0x9f9a0074,0x452880ab}},	//   _mum_, duir_, _jääb_, মরিক_,
   {{0x4424a991,0xac180258,0x241821f6,0x69c2a525}},	//   _lum_, тору_, торы_, _kloe,
   {{0x201c822e,0x11d90013,0x31c42aee,0x7c240014}},	//   _hivi_, روءة_, асув, _fuir,
   {{0x4424e374,0xa91d8110,0x7bd8b071,0x201c92a5}},	// [61d0] _num_, udži, kivu, _kivi_,
   {{0x6609d196,0xdb1a8c1d,0x69c28114,0xa91de375}},	//   _shek, _altí, _lloe, rdži,
   {{0xa91dcd57,0xa3c2097d,0xd7f844e0,0x60c9e376}},	//   leže, ्फर_, тут_, zzem,
   {{0x38601115,0x1eea026a,0x644b816d,0x386d8b64}},	//   buir_, رونی_, tsgi, yter_,
   {{0x44248c6e,0x386de377,0x33d58a18,0xad9b04c3}},	//   _cum_, xter_, лікт, clúe,
   {{0x4424b773,0x3949038e,0xadc3801c,0x60c9b102}},	//   _dum_, laas_, _thắn, vzem,
   {{0x69c290f4,0x4424dd36,0x6609e378,0xb3648098}},	//   _bloe, _eum_, _thek, ръчк,
   {{0x386d806f,0x2489003b,0xceb200be,0x60c9b11d}},	//   tter_, _osam_, _פין_, tzem,
   {{0x386d83d3,0x44248014,0x6e23c1de,0x6d444576}},	//   uter_, _gum_, _sunb, _reia,
   {{0x798b84df,0xee3995b5,0x7bc1e379,0x60c9d6bd}},	//   _wagw, нно_, _ullu, rzem,
   {{0x4424834a,0x24893996,0xb8fa8f0a,0x61e92bea}},	//   _zum_, _asam_, _डे_, čelj,
   {{0xb2ba8158,0xf41f0009,0x64a60071,0xaee38032}},	//   _אמער, yvät_, гама, _aiṣi,
   {{0x7c24209c,0x3a258b3c,0x394902a3,0x4424e37a}},	//   _quir, _hulp_, daas_, _xum_,
   {{0x7052845a,0xf745e37b,0xa0668adb,0x3f81111b}},	//   _انوا, _секо, _саша_, jehu_,
   {{0xfc3f04c3,0xdb0503b0,0x248900eb,0x656982f7}},	//   rxía_, _pohá, _esam_, _oceh,
   {{0x201c80d2,0x056623d7,0x39490079,0x7c240090}},	//   _zivi_, _свин, gaas_, _tuir,
   {{0xbcfb637c,0x98a30103,0x600a017d,0x4432326a}},	// [61e0] ngél, бите, енам_, _uty_,
   {{0xb8dc0a27,0x44249d8b,0x351b0051,0x2d82637d}},	//   _अथ_, _rum_, _אופנ, leke_,
   {{0x44248a64,0xdb08e37e,0xfc3f0118,0x3949637f}},	//   _sum_, _podí, nxín_, baas_,
   {{0x2d82082e,0x65660359,0x6ce6a133,0x7dc60118}},	//   neke_, ngkh, ліле, _fóse,
   {{0x7bd8995c,0x61e44453,0x7e61915b,0x320001c0}},	//   tivu, mnil, hulp, mliy_,
   {{0x61e427aa,0x2d826380,0xa91d8669,0x69c29699}},	//   lnil, heke_, ndžu, _sloe,
   {{0x69c2c38b,0x2d826381,0x201ce382,0x79808545}},	//   _ploe, keke_, _rivi_, temw,
   {{0x61e46383,0x48aabaa3,0x2d82120e,0x7bd883a0}},	//   nnil, етом_, jeke_, sivu,
   {{0x69c28b3c,0x442480ee,0x61e40b74,0x76aa8085}},	//   _vloe, _uum_, inil, məyi,
   {{0x53b8863a,0x76aa8085,0x61e46384,0x307780f7}},	//   _अविश, ləyi, hnil, احية_,
   {{0x7413845b,0x200280eb,0x201ce385,0xa91d84c4}},	//   _اولا, ēki_, _vivi_, veže,
   {{0xb11301bc,0x61e4016b,0x25a00036,0xdcf6011c}},	//   _bụla, jnil, _cnil_, _qayğ,
   {{0xdfda8098,0x201ce386,0xa91d8968,0x5c741af1}},	//   _пък_, _tivi_, teže, блят,
   {{0x39490079,0x00000000,0x00000000,0x00000000}},	//   waas_, --, --, --,
   {{0x39492692,0x2d820234,0x539b8039,0x7e618e65}},	//   taas_, beke_, עילו, culp,
   {{0xa91d807a,0x248901c5,0x61e46387,0xf99f00ff}},	//   seže, _tsam_, gnil, _thèm_,
   {{0x361c0051,0x3f8e8b67,0x06b200ab,0x24890187}},	// [61f0] _אוהד, _kafu_, _টেলি, _usam_,
   {{0xb4c1053e,0x4439368b,0x600b02d0,0x39496388}},	//   ंनी_, mps_, küme, saas_,
   {{0x6723012b,0xa3c2009a,0x37071ef8,0x44393437}},	//   žnjo, ंसर_, учав, lps_,
   {{0x645d8186,0x39468088,0x29e82795,0xe80b8fd5}},	//   _åsik, _neos_, lğan_, _सीना_,
   {{0x64a5981d,0xdca5b725,0xdcfd0110,0x7e61811b}},	//   рала, рали, kesč, zulp,
   {{0x4255867c,0x44390722,0x644f0834,0x2d8201f6}},	//   атит, ips_, isci, zeke_,
   {{0xdce9803a,0x02d88ec5,0xadc3827d,0xfbb801c6}},	//   _obeć, _भेदभ, _chản, רפות_,
   {{0x3946bd27,0x020580a9,0x76aa8085,0x645d026c}},	//   _ceos_, јзин, cəyi, krsi,
   {{0x6d4bc8e1,0x798f0358,0x394687b6,0x3f8e8c2e}},	//   maga, _macw, _deos_, _bafu_,
   {{0x6d4bc1a8,0x2d826389,0x660d56f9,0x61e40968}},	//   laga, weke_, _ahak, znil,
   {{0x2d82638a,0x660d326a,0x61e4638b,0x645d115b}},	//   teke_, _bhak, ynil, ersi,
   {{0x6d4be38c,0x6b838c90,0x660d022e,0x58d98b33}},	//   naga, leng, _chak, _идея_,
   {{0xe72e8ae7,0x2d82130e,0x660d638d,0x7e61bbb0}},	//   _ме_, reke_, _dhak, sulp,
   {{0x6b83e38e,0x6d4ba607,0x60cd1a1d,0x2d8206a0}},	//   neng, haga, dzam, seke_,
   {{0x6d4bc040,0x2bb88697,0x2d8239c7,0x645d1b98}},	//   kaga, _अवसा, peke_, arsi,
   {{0xdb1c03b0,0x7bc51124,0x6b83c100,0x61e40087}},	//   nkré, _elhu, heng, unil,
   {{0x6b839efb,0x75240435,0x798f0079,0x78a9802a}},	// [6200] keng, _igiz, _dacw, nxev,
   {{0xe80b83db,0x6b83e38f,0xf41f0106,0xeb9a0256}},	//   _सीमा_, jeng, svär_, _рио_,
   {{0x7bdc5f84,0x76aa8201,0x6d4be390,0xa5268071}},	//   miru, təyi, faga, амед,
   {{0x6d4bdc6d,0xed5a8425,0x644409b6,0x25a08216}},	//   gaga, тод_, _kwii, ñil_,
   {{0x69c98079,0x67238968,0x39468661,0x69c66391}},	//   dhee, _ognj, _reos_, _ilke,
   {{0x6b83e1e8,0x7bdc6392,0x35a80d86,0x78bb8216}},	//   geng, niru, गाड़, dyuv,
   {{0x6d4b94ec,0xdee3002e,0x237a00b9,0x6e270300}},	//   baga, _дори, _mbpj_, _gujb,
   {{0x6d4be393,0x3f8e804f,0x7524005d,0x69c98bfd}},	//   caga, _safu_, _ngiz, ghee,
   {{0xdb088efc,0x6b83e394,0x387201a3,0x2d97816b}},	//   _dodá, beng, ntyr_, ádež_,
   {{0x645d05f5,0x61e90754,0x75242221,0x6b8381d4}},	//   vrsi, čeli, _agiz, ceng,
   {{0x6e20822e,0x7c3600f1,0x7bdc6395,0x37a793bf}},	//   _kimb, _atyr, diru, ртын_,
   {{0x6e20e396,0x6602a79e,0x69c9a7f2,0xaadb81c6}},	//   _jimb, nlok, chee, _בחבר,
   {{0xb4c10063,0xb3b401ab,0x76430019,0x6e20e397}},	//   ंने_, ुसंख, ányz, _mimb,
   {{0x660d6398,0x75244a6c,0x6d4be399,0x6602805d}},	//   _whak, _egiz, zaga, hlok,
   {{0x6d4bda00,0x88e880ab,0xd6278b30,0x6e20826c}},	//   yaga, _পরিক, _које_, _oimb,
   {{0xa91de39a,0x4439639b,0x6e20c5b2,0x6b838555}},	//   leža, pps_, _nimb, zeng,
   {{0x6b83e39c,0x6602cba9,0x7bdc0deb,0xad9b002a}},	// [6210] yeng, dlok, biru, clúa,
   {{0xc60f8935,0x60cd639d,0x6d4be39e,0x960f824c}},	//   िष्य_, rzam, waga, िष्ट_,
   {{0x6d4bc8a9,0xb8fe0d38,0x6e20e39f,0x6b839f96}},	//   taga, _थे_, _bimb, veng,
   {{0x4429568a,0x6b83c50b,0xb113019d,0x656d01e0}},	//   _kua_, weng, _jụka, _jcah,
   {{0x6d4be3a0,0x442963a1,0x6e20c07c,0x24f881bb}},	//   raga, _jua_, _dimb, анцы_,
   {{0x442963a2,0x6d4bc8a9,0x442107dd,0xa91db5b2}},	//   _mua_, saga, _jih_, ježa,
   {{0x6d4b82e8,0x0d678698,0x5b7c0051,0xb5a78056}},	//   paga, _възм, דרוא, _край,
   {{0x6b838c6f,0x2bd988d4,0x6e20e3a3,0x7bdc166a}},	//   seng, _भगवा, _gimb, ziru,
   {{0x44290307,0x6b83e3a4,0x3f9100d2,0x69c9ac52}},	//   _nua_, peng, _kazu_, rhee,
   {{0x69c9e3a5,0x248d84b7,0xdb1c170b,0x656d0db1}},	//   shee, _isem_, skré, _acah,
   {{0x7c360e51,0xb4e783eb,0x7c2996f3,0x442963a6}},	//   _styr, _पशु_, _huer, _aua_,
   {{0xc329010f,0x3f91017f,0x442963a7,0x442163a8}},	//   _טו_, _lazu_, _bua_, _aih_,
   {{0x442105f5,0x44295586,0x248d83bb,0x213f859c}},	//   _bih_, _cua_, _jsem_, mbuh_,
   {{0x442963a9,0x7c2985b4,0xf7718019,0x44211705}},	//   _dua_, _muer, _رات_, _cih_,
   {{0xdd11003e,0x657b80fa,0x442936c2,0x442163aa}},	//   _výšk, _obuh, _eua_, _dih_,
   {{0xe80b946d,0x7bdc5a76,0x7c2981b0,0xb11301bc}},	//   _सीता_, siru, _ouer, _gụka,
   {{0x44290057,0x0ce280c8,0x6e208d02,0x3e71d968}},	// [6220] _gua_, _বর্ত, _rimb, lát_,
   {{0xbb860013,0x44215b2a,0x657bd34a,0xab6623e7}},	//   _الدي, _gih_, _abuh, _увол,
   {{0x3f910352,0x38720bc5,0x2d923753,0x600203a7}},	//   _dazu_, styr_, _kaye_, nômi,
   {{0x237f003a,0x4429022c,0xa2d1064a,0x7c298865}},	//   đuje_, _yua_, _डेट्, _buer,
   {{0x3f91012b,0x7c2985b4,0x89d88077,0x6602a1e5}},	//   _fazu_, _cuer, یوتر_, rlok,
   {{0x7c29e3ab,0x3f8582fd,0x2d9254f7,0x6e208010}},	//   _duer, jelu_, _laye_, _wimb,
   {{0x69a49513,0x3e718065,0x3f858933,0xe80b959a}},	//   काली, ját_, delu_, _सीधा_,
   {{0x7c299220,0x2d9263ac,0x38349878,0x2fc78637}},	//   _fuer, _naye_, онир, _alng_,
   {{0xdce41487,0x8c439b53,0x2fc7808e,0x25a48144}},	//   _obiđ, _нете, _blng_, _inml_,
   {{0x442963ad,0x7c2f82be,0xb7fa0b04,0x2d9210ab}},	//   _rua_, _écra, ्तिम_, _aaye_,
   {{0x44291fd0,0xd3378051,0x38603a20,0x3e718019}},	//   _sua_, _הרבה_, hrir_, gát_,
   {{0x4429568a,0xceb30051,0x4421035a,0x6fc0016d}},	//   _pua_, לית_, _sih_, _böck,
   {{0x44290104,0x3f85e3ae,0xa91d895e,0xdb018176}},	//   _qua_, belu_, ležn, _anlè,
   {{0x4429001c,0x3e71a792,0xd9b30035,0xa3be83db}},	//   _vua_, bát_, ीस्ट, ँघट_,
   {{0x442163af,0x69d9831d,0xd5bb0098,0x3f910035}},	//   _vih_, _ymwe, _бсп_, _razu_,
   {{0x442963b0,0x463b8158,0x2d9203ec,0x386051be}},	//   _tua_, _געהע, _gaye_, frir_,
   {{0x7bc88afe,0x4421003a,0xb3eb0013,0x6d4f3cd0}},	// [6230] _oldu, _tih_, _معدل_, maca,
   {{0x6d4f3185,0x2fc7001c,0x6aa88035,0x29023fd3}},	//   laca, óng_, _कपूर, _dyka_,
   {{0x6fc00352,0x7c29e3b1,0xa91d82ce,0x2d9236ba}},	//   _möch, _suer, ježn, _yaye_,
   {{0x6d4f63b2,0x7c29e3b3,0x7bc8e3b4,0x29d38087}},	//   naca, _puer, _aldu, nţat_,
   {{0x7c298510,0x99801010,0x6d49e3b5,0x7bc68196}},	//   _quer, lmiş_, _veea, _įkur,
   {{0xeb999baa,0x248d8353,0x6d4f117d,0x3dc90114}},	//   рик_, _vsem_, haca, _llaw_,
   {{0x998003bf,0x6d4f2fd7,0x853000fc,0x2d99816a}},	//   nmiş_, kaca, _haɗe, _óseo_,
   {{0x3e718065,0x6d4f0503,0x7c299ed4,0xa6b200ab}},	//   vát_, jaca, _tuer, _টেকট,
   {{0x6d4f63b6,0x6e2a81ec,0x2d924dee,0x7c21e3b7}},	//   daca, _aufb, _raye_, _tilr,
   {{0xeb9b89d7,0x3e718019,0x290380eb,0x2d9263b8}},	//   _حضرت_, tát_, āja_, _saye_,
   {{0x6b9c8da1,0x59c90eed,0x28d99513,0x85ea1677}},	//   _órga, रसार, _बेरि, идов_,
   {{0x3e7183b0,0x6d4f3a14,0x69d9c2d6,0x3f85d12e}},	//   rát_, gaca, _umwe, selu_,
   {{0x7d0d0063,0x3e71b74e,0xb8fe80ab,0x2fc780dd}},	//   _czas, sát_, _দু_, _tlng_,
   {{0xa3ac8076,0x386002be,0xe7398226,0x2d92315e}},	//   गाय_, vrir_, _тек_, _waye_,
   {{0xdde90077,0x61e9e3b9,0x7d0d3ebe,0x394b4f42}},	//   _گروه_, onel, _ezas, _becs_,
   {{0x6d4f155e,0x3e5581a9,0x394b07f1,0x3dc90428}},	//   caca, māt_, _cecs_, _glaw_,
   {{0x20c98778,0x186a028b,0xf8c9b13a,0x3e5580eb}},	// [6240] िनिध, рази_, िनिय, lāt_,
   {{0x61e98352,0x62819699,0x869a2bf3,0x853009ab}},	//   hnel, _oplo, итет_, _daɗe,
   {{0x3e558029,0x628181e9,0x61e98110,0x61fbe3ba}},	//   nāt_, _nplo, knel, koul,
   {{0xa3c2000f,0x98a61860,0xc8c980d4,0x7e7e8106}},	//   ंसक_, _диме, िनाट, _äppe,
   {{0x69c404b7,0x61e98279,0x61fb9c7d,0x64c48035}},	//   mkie, dnel, doul, वनेश,
   {{0xd25a90ca,0x69c463bb,0x629e011f,0x3e5581a9}},	//   аци_, lkie, _krpo, kāt_,
   {{0x6d4f0459,0x04fc80c8,0x6fc4858d,0x61fb93ff}},	//   yaca, েশের_, _dòcl, foul,
   {{0x69c463bc,0x61e98aa2,0xa91d807a,0x6e3888ae}},	//   nkie, gnel, režn, _rtvb,
   {{0x7d0463bd,0x224980d2,0xc2130039,0x628181a1}},	//   _nyis, ćaka_, והה_, _eplo,
   {{0x61e9802e,0xdd0901ac,0xc07b00be,0x69df1cb5}},	//   anel, _pôži, סטיש, ziqe,
   {{0x69c432bb,0x7d0463be,0x6d4f63bf,0xc9070105}},	//   kkie, _ayis, taca, _शर्म_,
   {{0x6d42e3c0,0x6e240362,0x61fbe3c1,0x7dc6026b}},	//   nboa, _ciib, coul, _dóso,
   {{0x6e240d92,0x61e0cf4c,0x69c40035,0x7d040a03}},	//   _diib, miml, dkie, _cyis,
   {{0x60cc8182,0x61e0880a,0x69c400eb,0x39590115}},	//   ılmı, liml, ekie, _sdss_,
   {{0x656b919b,0x2e4a8081,0x69cd63c2,0x7dc607f1}},	//   yggh, _тяло_, thae, _góso,
   {{0x61e0803a,0x99800182,0x225e03c1,0x3c2f0192}},	//   niml, rmiş_, átka_, _tüv_,
   {{0x7d0d0ce7,0x657f01c5,0x69cd45fc,0xfb2700d7}},	// [6250] _uzas, _ibqh, rhae, _وردپ,
   {{0xdb188125,0xdb21826f,0x61e0e3c3,0x7bce0799}},	//   mkvæ, _štít, himl, chbu,
   {{0x7c2d123d,0x61e0880a,0x6d4d00dd,0x68e481d0}},	//   _huar, kiml, _keaa, _židl,
   {{0x69c463c4,0xb17b04e1,0xb50f06a7,0x60c0c30b}},	//   ckie, _småf, _सराय_, kymm,
   {{0x62818db7,0x7c2d0590,0x18350158,0x69dd01b9}},	//   _splo, _juar, _מאָל_, _imse,
   {{0x443b0a84,0x764701c0,0x38690168,0x7c2d63c5}},	//   _mtq_, _twjy, muar_, _muar,
   {{0x386963c6,0x7c2d63c7,0xe7fa0054,0xf1bf001c}},	//   luar_, _luar, ्तरा_, _giác_,
   {{0x3e75016d,0xdb1e00e7,0x7a1c0176,0x61e98493}},	//   måt_, _impô, _pōti, unel,
   {{0x61fbe3c8,0xa3b88019,0x75298314,0x3e750b81}},	//   roul, _ڈالر_, _igez, låt_,
   {{0x69c43836,0x7c3be3c9,0x200586d8,0x61e9bbd9}},	//   zkie, _itur, ulli_, snel,
   {{0x6281e3ca,0x61fbe3cb,0xbea59652,0x69dd12af}},	//   _uplo, poul, чанк, _omse,
   {{0x3869020f,0x442d88b3,0x3eb8816d,0x44259272}},	//   kuar_, _kue_, ärta_, _hil_,
   {{0x7c2d3d25,0x442d8264,0x386900f1,0xa0a58071}},	//   _cuar, _jue_, juar_, _халд,
   {{0x69dd031d,0x442589da,0x7c2d27ef,0x38690168}},	//   _amse, _jil_, _duar, duar_,
   {{0x442d8364,0xfaa349a1,0xa3ac816f,0xf09f026b}},	//   _lue_, наро, गात_, _arà_,
   {{0x442581cd,0x7c3b83bf,0x7529829b,0xba230d45}},	//   _lil_, _otur, _ngez, едск,
   {{0x69c4149d,0x7c2d0ca9,0x2d8002f7,0x7c2500fc}},	// [6260] rkie, _guar, _ibie_, _fihr,
   {{0x69c4002f,0x61e08059,0x6d5b8ad4,0x7d0497ad}},	//   skie, ziml, _adua, üism,
   {{0x6d42e3cc,0x7c3b81bf,0x3bbb0039,0x61e0880a}},	//   tboa, _atur, _המיד, yiml,
   {{0x4425831d,0x38691832,0x600b02d0,0xf09f0037}},	//   _ail_, buar_, lüml, _frà_,
   {{0x4425e3cd,0x7bde0a84,0x2a6a119b,0x61e08380}},	//   _bil_, _kmpu, lubb_, viml,
   {{0x69cbbfa6,0x442de3ce,0xa91d817f,0x6d428f3e}},	//   _alge, _due_, režl, sboa,
   {{0x4425b95c,0x249f807b,0x7bde00dd,0x61e081cc}},	//   _dil_, _erum_, _mmpu, timl,
   {{0x442d9220,0x89d8ca1c,0x44258046,0x11d880f7}},	//   _fue_, توبر_, _eil_, توبة_,
   {{0x64498355,0x442d816f,0x4425c575,0x7dc60207}},	//   _gwei, _gue_, _fil_, _cósm,
   {{0x69c5820f,0x30138196,0x61e087d9,0xbfaa94ed}},	//   ëher, ндыр, siml, стие_,
   {{0x3869020f,0x7c2d0500,0x644982af,0xfbb00107}},	//   zuar_, _suar, _zwei, ञानम,
   {{0x7c252f9f,0xd6d79dfe,0x63ba8087,0x2ca01823}},	//   _sihr, яты_, _hotn, _brid_,
   {{0x44259238,0x8fa6c36c,0x629c2c08,0x7c2d20ef}},	//   _yil_, _наде, evro, _quar,
   {{0xe10b8158,0x649210d3,0x442581b4,0x481380e8}},	//   _פּאָ, džić, _xil_, _зміс,
   {{0x63ba8353,0x7c250198,0xfc3f628f,0x7c2d0326}},	//   _motn, _vihr, spí_, _wuar,
   {{0x386908cf,0x7c2d0cb5,0x63ba8035,0x225f0267}},	//   tuar_, _tuar, _lotn, čuk_,
   {{0x290f04b8,0x2d8b63cf,0x7bde0118,0x600b1238}},	// [6270] åga_, mece_, _fmpu, büml,
   {{0x442de3d0,0x386908cf,0x2d8b03cd,0x290701a9}},	//   _rue_, ruar_, lece_, āna_,
   {{0x38692b42,0x7c3bcf7a,0xf55991cc,0xfe788110}},	//   suar_, _stur, قلاب_, ntį_,
   {{0x2d9905f8,0x21670364,0x69dd63d1,0x2d8b2a63}},	//   ndse_, _этог, _umse, nece_,
   {{0x61ed0087,0x53d102f1,0x386926bf,0x63ba80d9}},	//   mnal, _हताश, quar_, _botn,
   {{0x442d82be,0xfe788110,0x32093cd0,0x3e750106}},	//   _vue_, ktį_, llay_, påt_,
   {{0x4425805f,0x994d01ac,0x6e2e267f,0xdb188106}},	//   _vil_, _môžu_, _gubb, jkvä,
   {{0x442581d8,0x61ed63d2,0xa2b505e8,0x63a8813c}},	//   _wil_, nnal, _उपन्, _endn,
   {{0x442595f8,0x2d8b05c5,0x16dd3792,0x7c3bafc0}},	//   _til_, dece_, _मधुब, _utur,
   {{0x600697ae,0x4425e3d3,0x628545f8,0x2d991412}},	//   мным_, _uil_, _opho, edse_,
   {{0xd1758196,0x6285022c,0x320900e4,0x59758048}},	//   _жылы, _npho, klay_, _жылу,
   {{0xfce61fb4,0x2ca0011a,0x9f458037,0xdb1c128a}},	//   домо, _prid_, golò_, jkrá,
   {{0xb886807b,0xdcfb8024,0x320963d4,0xdbd787b8}},	//   rsíð, _obuč, dlay_, pääs,
   {{0x660e01ac,0x39520039,0x853000fc,0x225e1e1e}},	//   _ďaku, ways_, _daɗa, átko_,
   {{0xe2973210,0x628e00f3,0xdb188106,0xab270e63}},	//   мар_, uwbo, ckvä, дора_,
   {{0x61ed47ab,0x32095099,0x2ca004b7,0xb6868065}},	//   gnal, glay_, _trid_, _کھیل_,
   {{0x66040870,0x628563d5,0x629c1384,0xed598140}},	// [6280] _ikik, _epho, svro, _možd_,
   {{0x6e2e09ba,0x77fa0076,0xbcfb4d5c,0x7e7b1f3a}},	//   _pubb, ्तेक_, rgét, _ćupr,
   {{0x32094000,0x3dcdab02,0xb9050441,0xef1881a9}},	//   blay_, _blew_, _भे_, beļu_,
   {{0xa91d807a,0x7f4e0363,0x85300326,0xdb1c04e8}},	//   režj, _webq, _yaɗa, ckrá,
   {{0x6d460748,0x63ba807a,0xc95304de,0x61e463d6}},	//   ibka, _potn, _שמש_, miil,
   {{0xdb2181ac,0x1ae980ab,0x61e44d76,0x3dc68c2d}},	//   _štát, য়েছে_, liil, skow_,
   {{0xa93487ac,0xf1a9816f,0xbcfb00d7,0x2d99067f}},	//   нейш, कांन, ngér, ydse_,
   {{0xa9c3835f,0xa3ac800f,0x61e40e68,0xdb01e115}},	//   вськ, गाह_, niil, _polò,
   {{0x2d8b0098,0x60d61c33,0x3f981f6f,0x92be8264}},	//   vece_, nzym, _karu_, ঁছে_,
   {{0x8c4381ae,0x660463d7,0x853009ab,0x6442e3d8}},	//   _рефе, _akik, _raɗa, mpoi,
   {{0x61e40079,0x61ed63d9,0x6442e3da,0xdd9115a9}},	//   kiil, ynal, lpoi, هود_,
   {{0xfe788110,0xdb188106,0xa3ac8072,0x2bbe8072}},	//   rtį_, rkvä, गाव_, ्सवा,
   {{0x2d8b282b,0x657d4a9c,0x61ed05b7,0x61e40e68}},	//   rece_, rfsh, vnal, diil,
   {{0xab840ac8,0x2d8b0796,0x66042396,0x80d901a2}},	//   куск, sece_, _ekik, _नेगे,
   {{0x53341194,0x3f8c82a5,0x61e463db,0x7bc7007b}},	//   тест, medu_, fiil, rkju,
   {{0x3e788019,0xdb1a83a7,0x6604008e,0x68290bcf}},	//   mét_, _potê, _gkik, _ažda,
   {{0x3f980fc7,0x3209151e,0x2aff0e88,0x752d54b1}},	// [6290] _baru_, rlay_, _शुरु_, _igaz,
   {{0xed59803a,0xb4cb146d,0xdb1c007b,0x320963dc}},	//   _može_, लनी_, skrá, slay_,
   {{0x61e45a42,0x3f98489a,0x6285114a,0x7982809a}},	//   biil, _daru_, _upho, _obow,
   {{0x25a985e4,0x61e4002e,0x644d63dd,0xafdb128d}},	//   ñal_, ciil, _kwai, _stød,
   {{0x7c289e7c,0x3f9804b9,0xed59816b,0x394f867f}},	//   _bidr, _faru_, _nože_, _regs_,
   {{0x3f8c86d3,0x7c28c092,0x394fe3de,0x79828915}},	//   jedu_, _cidr, _segs_, _abow,
   {{0xf220800f,0x3e788019,0x79829a14,0x45d5804a}},	//   मगढ़_, jét_, _bbow, _зовс,
   {{0xa91d9bfe,0x752d20b3,0xed59811f,0x6010016d}},	//   leži, _ngaz, _bože_, nämn,
   {{0xb4be035a,0x60258012,0xed598b80,0xdb1a83ec}},	//   _इथे_, ндиа, _vožd_, _lotè,
   {{0x443f9dae,0x7c288267,0x752d391a,0xdce9ac08}},	//   _itu_, _gidr, _agaz, _ubeđ,
   {{0x2bac816f,0x7d0982f7,0x3e788019,0xd5e60993}},	//   चारा, _hyes, gét_, ежни,
   {{0x20010041,0x58d58bc7,0x443fd70d,0x644d1a14}},	//   hohi_, _поет, _ktu_, _bwai,
   {{0x3f8c82ee,0x3156810f,0x2d9e001b,0x707580be}},	//   bedu_, _ניסן_, ěte_, _נײַע_,
   {{0x443f80f6,0x6e298352,0x69c99e0a,0x799980fc}},	//   _mtu_, _lieb, lkee, _haww,
   {{0x61e4238b,0x386d80e7,0x78a281d0,0x7d099a14}},	//   tiil, luer_, _zrov, _lyes,
   {{0x443f8a2c,0x3f9863df,0x6e29809a,0x692604ae}},	//   _otu_, _saru_, _nieb, емба,
   {{0x443f8069,0x61e4002e,0x644d031d,0x7d099dd5}},	// [62a0] _ntu_, riil, _gwai, _nyes,
   {{0x61e44c90,0x60d60063,0xe47b0039,0x752d0289}},	//   siil, rzym, _צריכ, _zgaz,
   {{0x443fd5d6,0xf1bf0028,0xd9100bca,0x61e4002e}},	//   _atu_, _giáo_, _چیز_, piil,
   {{0xd91004c0,0x644281e0,0x3f9801bf,0x6e29809a}},	//   _نیز_, tpoi, _waru_, _cieb,
   {{0x63be0503,0xdca38aac,0xdb08b24c,0x3f9863e0}},	//   _kopn, лаци, _indé, _taru_,
   {{0x44321220,0xdb1a83a7,0x7d09adcb,0x443fe3e1}},	//   _muy_, _hoté, _dyes, _dtu_,
   {{0x644287f4,0xfe67803f,0x443f8870,0x7c28b7dd}},	//   spoi, _حد_, _etu_, _vidr,
   {{0x7dc62511,0x69c99384,0x3e788061,0x799b8122}},	//   _fósi, gkee, vét_, gduw,
   {{0x386d9b01,0x63ab801b,0x443f8b99,0x3f8c811f}},	//   guer_, ální, _gtu_, tedu_,
   {{0x3e788019,0xdefa8071,0x629c81d0,0xdb1ab4b2}},	//   tét_, зым_, _šrou, _loté,
   {{0x3f8cca33,0x644d63e2,0x7999e3e3,0x69c981b4}},	//   redu_, _swai, _faww, bkee,
   {{0x78a2e3e4,0x44320039,0xdce08085,0x3e788537}},	//   _trov, _buy_, _hamı, rét_,
   {{0xb4cb0063,0x61e2946f,0x3e788019,0x94a8141e}},	//   लने_, _imol, sét_, нтра_,
   {{0x7bcaa026,0x4432001c,0x6fe680e7,0xdb08816a}},	//   nkfu, _duy_, _décè, _andé,
   {{0xd6cfbbc9,0x44321142,0x6602a256,0xa91de3e5}},	//   _ст_, _euy_, kook, veži,
   {{0x6440a828,0x6b9a81a9,0x9b1781c6,0x660282f1}},	//   _otmi, _latg, תחלה_, jook,
   {{0x765a81e2,0x644d2992,0x6e29e3e6,0xb6068369}},	// [62b0] lsty, _uwai, _rieb, _mošć,
   {{0x7c2f83d3,0x6e29e3e7,0x69c9811b,0x62889989}},	//   _écri, _sieb, zkee, _opdo,
   {{0x61e2e3e8,0xf653190c,0x64448012,0x443face4}},	//   _omol, ائط_, ţiil, _stu_,
   {{0xcb1204de,0x248901bc,0x37040073,0x41a52539}},	//   _כלי_, _kpam_, учув, _ऑफिस,
   {{0x62888110,0x248900b9,0xa3ac852a,0xeb999ccf}},	//   _apdo, _jpam_, गां_, дил_,
   {{0xf1bf001c,0x394963e9,0xdb1703a8,0x765aabe9}},	//   _hoá_, lbas_, _loxí, ksty,
   {{0x64409010,0x6b9a831d,0x386d810c,0xbe1200ab}},	//   _etmi, _datg, wuer_, _সংসদ_,
   {{0x765aa419,0x386d8866,0x56942d59,0x799981b9}},	//   dsty, tuer_, _щаст, _qaww,
   {{0x69c982b5,0x24890282,0x443fe3ea,0x25ad8162}},	//   rkee, _npam_, _utu_, _inel_,
   {{0xf3ff0073,0xee3990bc,0x2d8f91e6,0x69c985d1}},	//   drão_, мно_, lege_, skee,
   {{0x9d4618b0,0x4432001c,0x248900b9,0x7e7e8106}},	//   кенд, _suy_, _apam_, _äppl,
   {{0x443263eb,0x386922f8,0xb6068042,0xdb170118}},	//   _puy_, krar_, _gošć, _coxí,
   {{0x386d85ce,0x44320028,0x320d9c33,0x39490858}},	//   quer_, _quy_, mley_, dbas_,
   {{0x38690186,0x39491971,0xd705a46c,0x5f058237}},	//   drar_, ebas_, _изли, _изла,
   {{0x2d9b00f1,0x62888118,0xa6ec0264,0x63be01fa}},	//   _faqe_, _xpdo, _কর্ম_, _vopn,
   {{0x25bf802e,0x44320028,0xa3be00d4,0x78a90b67}},	//   _noul_, _tuy_, _आवक_, _ševa,
   {{0xf1bf001c,0x63be63ec,0x31721c80,0x2d8f80b4}},	// [62c0] _giám_, _topn, rgyz_, dege_,
   {{0x46a62244,0x25ad8317,0x7bd501ec,0x644663ed}},	//   казв, _anel_, chzu, mpki,
   {{0x39491606,0xe57a8a8e,0x25bf83ec,0x6b9a81ec}},	//   bbas_, дзе_, _boul_, _ratg,
   {{0xceb28451,0x8c46934e,0x600fd986,0x0446a549}},	//   ייב_, веде, dømm, ведн,
   {{0xdb1c12d2,0xdf74003d,0x25bf8176,0x2c0e8072}},	//   skrä, _مگاب, _doul_, ितलं_,
   {{0xf7430d69,0x765ae3ee,0x25adc7ff,0x2b580362}},	//   _веро, ysty, _enel_, narc_,
   {{0x37e30153,0x25bf83ec,0x66e60fe6,0x6b9a80ff}},	//   _торг, _foul_, _рова, _vatg,
   {{0xa2b50c78,0x2b580c5e,0x200780ce,0x320de3ef}},	//   _उपस्, harc_, _akni_, gley_,
   {{0x1426a597,0x2ecaa3a7,0xa06784bd,0x0c2693f7}},	//   _адам, ान्त, вања_, _аман,
   {{0x78a62c5d,0xb4ce95bc,0x0eeaa306,0x765abd26}},	//   _mrkv, शनी_, дьми_, tsty,
   {{0xdb01806a,0xa01b0106,0x765a8e11,0x442c90ba}},	//   _anlæ, _spök, usty, _iid_,
   {{0x61469240,0x25ad0118,0x25bf1434,0x32068122}},	//   _реда, ñel_, ðul_, _ukoy_,
   {{0x7d16009a,0x765a84fe,0xed59850b,0x442c8833}},	//   _czys, ssty, _joža_, _kid_,
   {{0xf3ff0187,0x4ea6802e,0x38695656,0x6fc48980}},	//   rrão_, _ариа, vrar_, _còct,
   {{0x442ce3f0,0xf2c404fa,0x3e7c000d,0x59b68ebf}},	//   _mid_, астн, jít_, _आचार,
   {{0x442cae66,0x3869383c,0xa3cf06af,0x3204e3f1}},	//   _lid_, trar_, _शतक_, nomy_,
   {{0x78a6003a,0x3f9ce3f2,0x39492a48,0x21f704b7}},	// [62d0] _crkv, _kavu_, rbas_, għha_,
   {{0x386963f3,0x6fcd8acf,0x25ad8613,0x442c831d}},	//   rrar_, _núcl, _snel_, _nid_,
   {{0x25bfe3f4,0x2d8fe3f5,0x69dc8110,0xc33204de}},	//   _poul_, tege_, _įren, _לוי_,
   {{0x6e2d054e,0x386963f6,0xb87b002a,0x3f9c81f4}},	//   _jiab, prar_, _oxíx, _lavu_,
   {{0x442ca543,0x645d0009,0x50f40c4f,0x2d8fe3f7}},	//   _bid_, nssi, _взят, rege_,
   {{0x442c8079,0x2d8fe3f8,0x799d63f9,0x69cd00b9}},	//   _cid_, sege_, _hasw, lkae,
   {{0x36d51d2f,0x442c8039,0x799d1400,0x7d0d450b}},	//   _совр, _did_, _kasw, _lyas,
   {{0x2c1a02f1,0x442ce3fa,0x600f8257,0x6e2d0c61}},	//   _मीनू_, _eid_, rømm, _niab,
   {{0x44f58a14,0x320d8295,0x442c84b7,0x6d59e3fb}},	//   _спас, rley_, _fid_, mawa,
   {{0x6d59d9c4,0x320d8e35,0x442ce3fc,0xdb08802a}},	//   lawa, sley_, _gid_, _codó,
   {{0xc7d60039,0x7f55157a,0x645d5397,0x7d0d1267}},	//   רותי_, _mezq, essi, _ayas,
   {{0x6d598c9e,0x8c460c66,0x6e2d00e5,0x799d63ea}},	//   nawa, леме, _ciab, _nasw,
   {{0x7bc180ee,0x40798158,0x61e9e3bc,0x1ae10264}},	//   _kolu, _נאַװ, miel, _খুলে_,
   {{0x61e9e3fd,0x6d59e136,0xadc380ff,0x387f8168}},	//   liel, hawa, _khẳn, mtur_,
   {{0x35a60037,0x6d599cc5,0xada60037,0x2005e3fe}},	//   _байг, kawa, _байл, moli_,
   {{0xdb019918,0x6d59e3ff,0x61e9cd43,0xa2a48aed}},	//   _inlä, jawa, niel, कित्,
   {{0x6d59e400,0xa06719d9,0x60c989ca,0x7d16009a}},	// [62e0] dawa, лата_, nyem, _uzys,
   {{0x66062c27,0x2005e401,0x7bc18d4e,0x61e9e402}},	//   lokk, noli_, _nolu, hiel,
   {{0x6d5609ca,0x61e9e403,0x25b7003d,0x6da68bba}},	//   _keya, kiel, _شهید_, лижа,
   {{0x442ce404,0x661bb86c,0x6d59e405,0x2005b553}},	//   _sid_, _chuk, gawa, holi_,
   {{0x100385b3,0x7bc1d3db,0x387f820f,0x6d562bab}},	//   रकाश_, _bolu, jtur_, _meya,
   {{0xafe62103,0xa3de809a,0x6609a914,0x7bc1aa70}},	//   _согл, दों_, _ekek, _colu,
   {{0x442ce406,0x61e9cb72,0xadc3801c,0x6606365d}},	//   _vid_, fiel, _chẳn, kokk,
   {{0x3f9c8029,0x6564020f,0xb3a481c4,0x61e9809a}},	//   _savu_, _ndih, _गोरख, giel,
   {{0x442c8082,0xdca3bb4c,0xdb018004,0x6e2d6407}},	//   _tid_, _лати, _anlä, _riab,
   {{0x2005d2fa,0x987b0158,0xa09700be,0xdb01e408}},	//   goli_, עריק, נדיק_, _polô,
   {{0xe5b511e9,0x61e9e409,0x6d561d19,0x387fe40a}},	//   айны, biel, _beya, atur_,
   {{0x61e9e40b,0xd6d78153,0x60c9db5e,0x645d4968}},	//   ciel, уть_, byem, tssi,
   {{0x7bc1e40c,0xb4c10540,0x1c160074,0xdb1a8298}},	//   _yolu, ूने_, _दीहल_, _motí,
   {{0x20058698,0x6d59854e,0x645d156e,0x6b9e6195}},	//   coli_, zawa, rssi, _capg,
   {{0x799d1b66,0x45d51287,0x6d59cdcb,0xcb378039}},	//   _pasw, _войс, yawa, ראלי_,
   {{0xdb1aa670,0x660611ee,0x29d881a8,0x6d5626e8}},	//   _notí, cokk, _déag_, _geya,
   {{0x6e350052,0xac9501a1,0x9f5505da,0xb4ce83ca}},	// [62f0] _suzb, _тапш, ивач, शनो_,
   {{0xdefb025d,0x61e98920,0x661b86df,0x629ae40d}},	//   ные_, ziel, _shuk, _osto,
   {{0xa3d89513,0x6d59c1a8,0x799d1f33,0x7bc1e40e}},	//   ासन_, tawa, _tasw, _rolu,
   {{0xdb1a802a,0x6e22cf24,0x387fbf11,0x200589d8}},	//   _cotí, gmob, ytur_, zoli_,
   {{0x7bc18289,0x6d59c230,0x2d89010c,0x2005836a}},	//   _polu, rawa, _mbae_, yoli_,
   {{0x6d59885c,0x03a59814,0x61e9e40f,0x6e35017f}},	//   sawa, рико, wiel, _tuzb,
   {{0x2005e410,0x6d5995d0,0x2919026c,0x661bde86}},	//   voli_, pawa, _hzsa_, _thuk,
   {{0x387fa7dd,0xc9a988cc,0x7bc1d34f,0x60c996fb}},	//   ttur_, твие_, _wolu, tyem,
   {{0xa9228698,0x61e9cd28,0x7bc1e411,0x20059aae}},	//   одъл, riel, _tolu, toli_,
   {{0x387fa3ea,0x61e9e412,0xadc3801c,0xb17b0502}},	//   rtur_, siel, _thẳn, _smål,
   {{0x387f8125,0x612b85c5,0x2005e413,0x61e9e414}},	//   stur_, _bölü, roli_, piel,
   {{0xa2c413e5,0xa3b38697,0xb2ba8039,0x29d881a8}},	//   रहस्, टाव_, _במער, _céad_,
   {{0x4b2300c8,0x7c38011f,0x20059fcb,0x66065e59}},	//   _ব্লগ_, _čvrs, poli_, rokk,
   {{0x394d9031,0xb6a5835f,0x629a831d,0x78a4047f}},	//   lbes_, _викл, _ysto, vviv,
   {{0x39460511,0xe7fb0697,0x76439235,0x6d5656a7}},	//   ñoso_, ्वना_, _utny, _teya,
   {{0xb14619b8,0x213f8748,0x386d80e7,0xf2d280be}},	//   рнал, ncuh_, orer_, קען_,
   {{0x6b9e026b,0xaca48133,0xe73a45dd,0x64446415}},	// [6300] _tapg, _kwụp, вез_, _utii,
   {{0x82360077,0x657b808e,0x25a02b02,0x3cf1016b}},	//   _پردا, _acuh, _hail_, šová_,
   {{0x386d82af,0xed5ab4a3,0x25a06416,0x248de417}},	//   hrer_, вое_, _kail_, _apem_,
   {{0xa2a49c4f,0x386d8aa2,0x32ee8085,0x629a8115}},	//   किस्, krer_, _rəy_, _rsto,
   {{0x25a01706,0x386d8366,0x61e15bbc,0x2d9f82f9}},	//   _mail_, jrer_, ëlle, _daue_,
   {{0xaa669519,0x3860032f,0x386d8257,0x7fd505a8}},	//   атик, msir_, drer_, _лісі,
   {{0x15f80076,0x1606023c,0xfe06142d,0x4e063c4f}},	//   ीवार_, रवार_, रवास_, रवाई_,
   {{0x394001bf,0x386d83a7,0x61f63384,0x629a8419}},	//   ncis_, frer_, nnyl, _vsto,
   {{0xb9c38013,0xdb1a8073,0x38606418,0x80b097ba}},	//   تقيي, _botã, nsir_, जमें,
   {{0x4ea6b210,0x386002be,0x1ae6891e,0x3d1b83b7}},	//   арма, isir_, _козм, _बरते_,
   {{0x35ab81ce,0x386dbb15,0x2ca907b6,0x0737025f}},	//   _घोड़, arer_, _srad_, יאים_,
   {{0x386d87e2,0xb33c84b7,0x29188085,0x25a00229}},	//   brer_, _waħd, əran_, _cail_,
   {{0x25a06419,0xb33c81b9,0x224601a1,0x386d8866}},	//   _dail_, _taħd, _čoka_, crer_,
   {{0x25a00122,0xf99f08f9,0xdb1e0286,0x3940285e}},	//   _eail_, _saè_, _copï, ecis_,
   {{0x9b5817c8,0x9f5e019d,0x29d88174,0x25a00833}},	//   рист_, _ótù_, _téad_, _fail_,
   {{0x386010e1,0xdce08176,0xb33c82a6,0xed598af8}},	//   fsir_, _admč, _jaħb, _rožo_,
   {{0x660d454a,0x7afe1727,0x2ca9641a,0x7a358084}},	// [6310] _ikak, _expt, _urad_, _ište,
   {{0xd7590bbe,0xf773006b,0x6ab6b738,0x53990ac8}},	//   الات_, تار_, _अपूर, _своя_,
   {{0x248d8609,0x6fcd81a8,0x853000fc,0x29070035}},	//   _spem_, _dúch, _raɗi, łna_,
   {{0x237f003a,0x6d5d2487,0xf2d200be,0x386d821e}},	//   đuju_, nasa, _זעט_, yrer_,
   {{0x64a5814c,0xdff891be,0x7bc50006,0x61ed0198}},	//   сала, ुवाद_, _kohu, mial,
   {{0x82340416,0x386d8036,0xf677003d,0xf77881b9}},	//   _دریا, vrer_, _پاسخ, jgħ_,
   {{0x6d5d0d1f,0x7a35803b,0xdcfb803b,0xf21c000f}},	//   kasa, _ošte, _obuć, _भीड़_,
   {{0x96f81505,0x7bc53af6,0xadc3801c,0x82f80039}},	//   _тест_, _lohu, _thằn, יצוב_,
   {{0x60cd3051,0x6d5d641b,0xe73996dd,0x394dbb7c}},	//   nyam, dasa, леп_, rbes_,
   {{0x386da6e1,0x660d33cd,0x61ed641c,0x60100009}},	//   rrer_, _akak, hial, tämi,
   {{0xee36802e,0xed5a2927,0x61ed0ff9,0x6d5d1ce5}},	//   йнэ_, лон_, kial, fasa,
   {{0xfbc9073a,0x63a1a478,0x60cd0365,0xed5981d0}},	//   _את_, _haln, kyam, _jež_,
   {{0x61ed641d,0x63a18df1,0x22818019,0x7bc503c1}},	//   dial, _kaln, lók_, _bohu,
   {{0x434336ab,0x60cd02e9,0x660d2460,0x69db82df}},	//   зерв, dyam, _ekak, lhue,
   {{0xc3328bea,0x15f781a2,0xa3e9123a,0x91dbb2dd}},	//   לום_, ंचार_, _मगर_, _बताई,
   {{0xed5983bb,0xa22a1541,0x61ed47ff,0x463a80be}},	//   _než_, ужба_, gial, _געקע,
   {{0x395939e8,0x6c8600f7,0xdb0501ec,0x3940641e}},	// [6320] _dess_, _الخم, _anhä, rcis_,
   {{0x3860008e,0x63a180e4,0x66da0190,0x6eca811c}},	//   rsir_, _naln, льер_, bəbd,
   {{0x3860641f,0xdb1e026f,0x61ed31c4,0x3e6382d0}},	//   ssir_, _kopí, bial, nıt_,
   {{0x629e003a,0x250b8416,0xed5a81a8,0x22818061}},	//   _ispo, گرمی_, اشات_, dók_,
   {{0x77940077,0x78ad81a1,0xed59895e,0x69db83ed}},	//   _ویرا, _šavn, _dež_, dhue,
   {{0x25a09234,0x6d5d57ac,0x628381f4,0xf99f0077}},	//   žil_, zasa, ftno, _akèh_,
   {{0x6d5d6420,0x69c66421,0xdb1aa511,0x6da69ddf}},	//   yasa, _koke, _botá, _лива,
   {{0x853009ab,0x66f701c6,0x69c632e9,0x26cc8196}},	//   _haɗu, _המלא_, _joke, vydo_,
   {{0xa3d8853e,0x6d5d2c28,0x69c60110,0x637d026b}},	//   ासद_, vasa, _moke, _bàǹ,
   {{0x61ed6422,0x629e0052,0x660d079f,0x2281807b}},	//   zial, _ospo, _skak, bók_,
   {{0x66fa053f,0x9f5ee423,0x79960706,0xd36f81a8}},	//   ्थिक_, gotá_, keyw, _أهم_,
   {{0xca37810f,0x2bd10c28,0x69dbc28b,0x7bc802f1}},	//   _הנאה_, हस्थ, chue, ödun,
   {{0x6d5d0859,0x63a19010,0x629e03f2,0x7a35c63a}},	//   rasa, _yaln, _aspo, _všte,
   {{0x6d5d6424,0x39593105,0x69c08da8,0x8fa3828b}},	//   sasa, _sess_, ljme, _наче,
   {{0x61ed1532,0xd7f88087,0x69c61235,0xcf2680f7}},	//   tial, mnă_, _boke, _ارشي,
   {{0x7a358a20,0x69c637d1,0x60cd197a,0x98a4861c}},	//   _ušte, _coke, tyam, lamı_,
   {{0x629e6425,0xa2b5016f,0x35f8026a,0x7bc56426}},	// [6330] _espo, _उपक्, _درود_, _tohu,
   {{0x61ed6427,0x67eb04b7,0x60cd0314,0xd6db0012}},	//   sial, rżjo, ryam, лте_,
   {{0xa9350d8e,0x61ed2447,0x3d3e81bc,0x6e994436}},	//   _менш, pial, _ịwa_, рвер_,
   {{0x443b0168,0x44336428,0xdb019243,0x69c61502}},	//   _kuq_, _hix_, _falê, _goke,
   {{0xd7fb035f,0xa87900be,0xa5bd8110,0x853009ab}},	//   _був_, _דאָר, _siųs, _faɗu,
   {{0x22818065,0x3e638459,0x78ad811f,0x69c6113b}},	//   tók_, yıt_, _šavo, _zoke,
   {{0x657a8013,0x41e0103e,0xdb1aa13c,0x6eca811c}},	//   úchá, _नतमस, _potá, həbb,
   {{0x62838503,0x644b816d,0x49c9917e,0x3cff81c0}},	//   rtno, ppgi, рлин_, _txuv_,
   {{0x62838f20,0xf77180a0,0x63a1e429,0x69db8580}},	//   stno, واد_, _taln, rhue,
   {{0x9e659383,0x443301ec,0x1665a306,0xf1bf01a8}},	//   овод, _nix_, овом, _fhág_,
   {{0x6d5b8e60,0x7c3b9306,0xdb1aa8e5,0x224601f4}},	//   _keua, _huur, _totá, _čoko_,
   {{0x8c3d8214,0xd7f88087,0x7c3be42a,0x44333b7c}},	//   _arşi, ană_, _kuur, _aix_,
   {{0x7c3b98c5,0x395fe42b,0x443302a6,0xdffb1299}},	//   _juur, maus_, _bix_, ्वाद_,
   {{0x395f82f8,0x69c60a5b,0x7c3bac67,0xa3e40035}},	//   laus_, _soke, _muur, पों_,
   {{0xfaa303c7,0x443300e7,0x2fc7c74f,0xf09f0032}},	//   маро, _dix_, _iong_, _asà_,
   {{0x443b2f1e,0x6d5ba06f,0x395fe42c,0x7bdc0079}},	//   _fuq_, _neua, naus_, shru,
   {{0x2fc79882,0xdfd20624,0x57ea1652,0x629e009a}},	// [6340] _kong_, وير_, адам_, _wspo,
   {{0x2fc79384,0x395fa761,0x65698091,0x6e3b0699}},	//   _jong_, haus_, _adeh, _čubr,
   {{0x2fc7e42d,0x6449e42e,0x35af0fea,0x69d9bbb8}},	//   _mong_, _atei, _जोड़, _olwe,
   {{0x7c3bb062,0x2fc7d1d3,0x395f827e,0x2cad93c2}},	//   _buur, _long_, jaus_, _bred_,
   {{0x2cad802e,0xdb018168,0x395f8084,0x7de40061}},	//   _cred_, _falë, daus_, lőss,
   {{0x44331c4b,0xe0fb0039,0x7c3b82b5,0x66e609ea}},	//   _xix_, _כלכל, _duur, _дога,
   {{0x98a48059,0x291d80b9,0x9f4580e5,0x7c218706}},	//   vamı_, _azwa_, dilà_, _dhlr,
   {{0x395f8110,0xe57785a8,0x224602d4,0xb33c822b}},	//   gaus_, _мзс_, _čokl_, _daħa,
   {{0xdfd08013,0x7c3b82a3,0x2cade42f,0x6e3c0102}},	//   فية_, _guur, _gred_, _hurb,
   {{0x6e3c153e,0x2fc7801c,0xd7f88087,0xa5bb018a}},	//   _kurb, _cong_, ună_, rmóm,
   {{0xdefa8071,0x2fc7d0c6,0x2ca04463,0x2127001c}},	//   рып_, _dong_, _asid_, ̀nh_,
   {{0x395fa6b4,0x6e3c5a3e,0x44336430,0x7bc8e431}},	//   caus_, _murb, _six_, _hodu,
   {{0x7bc88006,0x2fc7e432,0x6fda0072,0xd7da0072}},	//   _kodu, _fong_, णसां, णसाच,
   {{0xfc3f2509,0x2fc7821e,0x61ed80e1,0xa3b383eb}},	//   svío_, _gong_, ďale, टाए_,
   {{0x38668a38,0x69d80110,0x200cc4bc,0x6fcd8388}},	//   _hvor_, _įver, modi_, _cúcu,
   {{0x25a48a84,0x2fc7b962,0x248684ef,0x39448118}},	//   _naml_, _zong_, ktom_, ncms_,
   {{0x25a68355,0x2d99108a,0x2fc7bf8c,0xdcfd00eb}},	// [6350] ddol_, mese_, _yong_, resē,
   {{0x6e3c6433,0x2a78151e,0x7bc8b47d,0x2fc7801c}},	//   _burb, burb_, _nodu, _xong_,
   {{0x7c3ba986,0x64498e5d,0xfdff11bc,0x2cad8289}},	//   _suur, _stei, _उदास_, _sred_,
   {{0x2cadba71,0x6e3c6434,0xee3805a8,0x1a9a00be}},	//   _pred_, _durb, іні_, _פירע,
   {{0x2fc70104,0x63a501e0,0x200caef4,0x395f8d15}},	//   ưng_, _kahn, kodi_, vaus_,
   {{0xe0198105,0xfaa5998c,0x7bc8802e,0x7c3b837a}},	//   _नींद_, зако, _codu, _vuur,
   {{0x7bc88052,0x2fc7e435,0x6e3c6436,0x63a56437}},	//   _dodu, _rong_, _gurb, _mahn,
   {{0x249f81e9,0x7c3b9e89,0x2fc78039,0x24868069}},	//   _tsum_, _tuur, _song_, btom_,
   {{0x2d996438,0x2fc7e439,0xb4ea016f,0x2cad920e}},	//   dese_, _pong_, _मधे_, _ured_,
   {{0xb4d78592,0x200ca0c4,0xa3e786a7,0x78af0140}},	//   ानी_, godi_, मोश_, _mrcv,
   {{0x2d99451b,0xf77200be,0x2fc780ff,0x395f8198}},	//   fese_, עקט_, _vong_, paus_,
   {{0x2fc783f8,0x2d99534f,0xa3e78f21,0xe8df8133}},	//   _wong_, gese_, मोर_, nrịa_,
   {{0x621a812a,0x61fb802e,0x63a5643a,0xb9c481a8}},	//   _פונק, mnul, _bahn, _تقني,
   {{0x8fa58d46,0xc87983bf,0xe1ff026b,0x63a5023e}},	//   _хаке, muş_, _ajó_, _cahn,
   {{0x2d9941e3,0xc8798b16,0x25a6c489,0x8c1a81c6}},	//   bese_, luş_, ydol_, מושי,
   {{0x61fb8b74,0xdb0181b3,0xdddc8699,0x9f4c8388}},	//   nnul, _valè, _sprž, vidé_,
   {{0x7f5c07e2,0x910300e5,0xdce981a1,0x395dd55f}},	// [6360] _perq, епте, _oceđ, _mews_,
   {{0x2b8f8214,0x004681bc,0x7bd50192,0x7b070061}},	//   nıcı_, _jụụ_, ckzu, érté,
   {{0x6e3c12b5,0x61460258,0xe357010f,0x61fbcbab}},	//   _qurb, _нена, _משיח_, knul,
   {{0x395da840,0xdb018298,0x200c812b,0x63a54431}},	//   _news_, _galé, zodi_, _zahn,
   {{0x7bc8e43b,0xc1730051,0x29370158,0x78a908ae}},	//   _podu, _אחר_, _מאכן_, _ševv,
   {{0x69c43e4a,0x6e3c4dd1,0x2d990c2e,0x261c8216}},	//   ljie, _turb, zese_, cíon_,
   {{0x200c803b,0x80d100c8,0x29d88013,0x395d8609}},	//   vodi_, _সেপ্, _déan_, _bews_,
   {{0x6da39628,0x3f9a009a,0x2d9901df,0x61fb85f3}},	//   _писа, lepu_, xese_, gnul,
   {{0x2d99234a,0x200cce7c,0x290280f1,0x68e44219}},	//   vese_, todi_, çka_, nzid,
   {{0xf1bf0104,0xfaa691a8,0x6e242676,0x2d99643c}},	//   _khác_, _назо, _ahib, wese_,
   {{0xf119023c,0x2d99643d,0xadf383dd,0x63a55244}},	//   _दर्द_, tese_, _आगमन_, _rahn,
   {{0x26c28289,0x67e0016d,0x63a51266,0x69c401b9}},	//   ćko_, _höjd, _sahn, jjie,
   {{0x2d99643e,0x6e2402a3,0x80d100ab,0x69c46250}},	//   rese_, _dhib, _সেন্, djie,
   {{0x2d99643f,0x3f9a02ce,0xdb01b4d3,0x78a2e440}},	//   sese_, jepu_, _salé, _isov,
   {{0x3a292a23,0x2d996441,0xba0806a7,0x05dd83ca}},	//   tmap_, pese_, वकूफ_, _मतलब,
   {{0x6e24051e,0x5a340652,0xc2c401a8,0x067b9101}},	//   _ghib, енст, ريقي, _הנהל,
   {{0x628704b7,0x63a54ce6,0x7e7a839c,0x7a0181a9}},	// [6370] stjo, _tahn, lutp, nēta,
   {{0x660f1230,0x301433e4,0xe9e2809a,0x61fb812b}},	//   lock, едур, leźć_, znul,
   {{0x3a296442,0xdb1e00e1,0x3a3e8748,0x61fbe443}},	//   pmap_, _topá, _nutp_, ynul,
   {{0xfe700154,0x78a28289,0xe81d0006,0xf1bf00ff}},	//   ادل_, _osov, _बीरा_, _giáp_,
   {{0xb4d7c70b,0x0db880f7,0x61fb8904,0x2b8f807e}},	//   ाने_, ثالث_, vnul, yıcı_,
   {{0xa3e7809a,0x660f048d,0x9c8703fb,0xb17b12f1}},	//   मों_, hock, _začí, _blåg,
   {{0x61fb82a5,0x660f2e6c,0x6d460106,0x2b5e8122}},	//   tnul, kock, ycka, _detc_,
   {{0x656d17d5,0x61fbd4c0,0x60101c50,0x2003b114}},	//   _ndah, unul, lämp, čjim_,
   {{0x61fbd682,0x644d0282,0x2b8f8457,0x753b8135}},	//   rnul, _ntai, tıcı_, _iguz,
   {{0x6e246444,0x79828300,0x26288087,0x656d6445}},	//   _shib, _ecow, _uşor_, _adah,
   {{0x443f822e,0x69dd0aa2,0x9f840074,0x7d160009}},	//   _huu_, _olse, _töö_, _syys,
   {{0x443fe446,0x9f4781a8,0x3eb88338,0x645b8176}},	//   _kuu_, _imní_, årta_, _kwui,
   {{0x443fa83a,0x4425e447,0x60103b13,0x67e00106}},	//   _juu_, _khl_, kämp, _höje,
   {{0xe7879bc1,0x443fc1ec,0x69cbaffc,0x644d01a8}},	//   _худо, _muu_, _hoge, _dtai,
   {{0x160d8e70,0x69cbe448,0x69c46449,0xfebb803d}},	//   िकार_, _koge, tjie, _داشت_,
   {{0xed59811f,0x1de20a27,0x753be44a,0x7d04011b}},	//   _kožu_, _पतित, _nguz, _txis,
   {{0x69cb87b3,0x6b9300f2,0x3eb101ec,0x2007007a}},	// [6380] _moge, ädgå, _arzt_, čnin_,
   {{0x249703f8,0x69cbcc9a,0xb17b644b,0x69c4067f}},	//   _کنید_, _loge, _småt, sjie,
   {{0x6b9c644c,0x67e0016d,0x69c404b7,0x29d880f7}},	//   merg, _nöje, pjie, _béal_,
   {{0x69cb8ae1,0x443f8079,0xdc488133,0x93bc80ff}},	//   _noge, _buu_, _aṅụ_, _chăn,
   {{0xdca3abf3,0x249a8416,0x8c4393f1,0x95880110}},	//   каци, تخاب_, вече, _grąž,
   {{0xdb0887e0,0x753bbbb5,0xa91d8110,0xe73a11c7}},	//   _indú, _eguz, igžd, _фев_,
   {{0x69cbe44d,0x645d81b9,0xdced0380,0xb17b0646}},	//   _boge, _ħsie, _ocağ, _flåd,
   {{0x78a285f5,0x69cbe44e,0x6b9c644f,0xdb1a81d6}},	//   _psov, _coge, herg, _kotú,
   {{0x7a35c599,0x645b8300,0xfc3f008b,0x60f8a3e7}},	//   _ešto, _gwui, rvík_, яния_,
   {{0x6d4481ac,0xb8e6925f,0x291880eb,0x7a0180eb}},	//   žiad, _उप_, āra_, rēta,
   {{0x644d0427,0x6440e450,0x78ad00fe,0x656d008e}},	//   _stai, _humi, zvav, _pdah,
   {{0x6440e451,0x7bde02f7,0x69cbd025,0x2cb20114}},	//   _kumi, _alpu, _goge, _bryd_,
   {{0x3a2680f2,0x443f0028,0x7c84117e,0xa3b38a0d}},	//   _ihop_, êu_, куре, _जोड_,
   {{0x6440a05e,0x63a88a20,0x69cb8f67,0x660f6452}},	//   _mumi, _jadn, _zoge, sock,
   {{0x6440c290,0x69cbe453,0x9e07302b,0xa195004a}},	//   _lumi, _yoge, _очил, навч,
   {{0xb0d28a27,0x656d2e96,0xdb1a8174,0x2cb26454}},	//   _तथाग, _udah, _botú, _fryd_,
   {{0x92c100c8,0x644093bf,0x9be700e8,0x7c3719e7}},	// [6390] ্ছে_, _numi, _жінк, _tixr,
   {{0xf77007bd,0x25a900c9,0x443f8101,0x6b9c0748}},	//   لام_, _haal_, _ruu_, cerg,
   {{0xb4d781d0,0x25a92e5c,0x4425808e,0x443fe455}},	//   ान्_, _kaal_, _rhl_, _suu_,
   {{0x6440df4a,0x69dd20b1,0x443fe456,0x44258106}},	//   _bumi, _ulse, _puu_, _shl_,
   {{0x6440c73d,0xf3ff0073,0x25a96457,0x63a88079}},	//   _cumi, nsão_, _maal_, _badn,
   {{0x7afc8052,0x6440ab6c,0x69cbe458,0x38695a05}},	//   _žrta, _dumi, _soge, msar_,
   {{0x443f8079,0x59d300bc,0x93bc80ff,0xb60603c1}},	//   _wuu_, _सवार, _thăn, _hláš,
   {{0x6440e459,0x29dc0118,0x443fb735,0xb606016b}},	//   _fumi, _lían_, _tuu_, _kláš,
   {{0x39490207,0xe8f99bc1,0x69cbe45a,0x38694359}},	//   icas_, яли_, _voge, nsar_,
   {{0x38690073,0xeb90845b,0x2d9de45b,0x394900b9}},	//   isar_, _نظم_, lewe_, hcas_,
   {{0x25a919eb,0x644081ec,0x9f4c8e6f,0x628a81ed}},	//   _baal_, _zumi, cidí_, ctfo,
   {{0x63a88e3f,0xed57035f,0x2d9d80b4,0xa95480e8}},	//   _zadn, ною_, newe_, _акці,
   {{0x522c8158,0x67d5948d,0xdb068019,0x25a95a78}},	//   _וואַ, _поду, ümöl, _daal_,
   {{0xdb0181df,0x7bc700f1,0xc0588180,0xbf1f0072}},	//   _lalí, gjju, _آشنا_, _भरून_,
   {{0x6b9c09ff,0xb7da81c6,0xcb1280be,0x59d382f1}},	//   rerg, _מקסי, ָלן_, _तवार,
   {{0xe9df01a8,0x25a9645c,0x672385f3,0x6b9c645d}},	//   _clú_, _gaal_, _iznj, serg,
   {{0x34b300f7,0x6566005d,0x66040135,0x69c0816f}},	// [63a0] _مميز, makh, _ijik, वाती,
   {{0x64408886,0x75240633,0x25a901ed,0x65663598}},	//   _rumi, _iziz, _zaal_, lakh,
   {{0x63a890e8,0x24460028,0xee3a4249,0xdb01826f}},	//   _radn, _hôm_, чне_, _balí,
   {{0x7ddf020f,0xafdb0b40,0x6440809c,0xdb018118}},	//   _kësa, _støt, _pumi, _calí,
   {{0x443a645e,0xf1bf001c,0x211e80d4,0x61f602d0}},	//   _kip_, _khán_, _परेश_, miyl,
   {{0x628ae45f,0x3a26885e,0x443a6460,0xfaa681ae}},	//   ttfo, _shop_, _jip_, ешин,
   {{0xed5a8abe,0x2d96a549,0x63a8d8df,0x764e21ad}},	//   _нов_, _прас, _vadn, _utby,
   {{0x6440b5fc,0x61f66391,0xdb01823e,0xf1e000d4}},	//   _tumi, niyl, _galí, नसिन,
   {{0x7e7e235a,0x628a82fe,0x65660a84,0x2bd1052a}},	//   lupp, stfo, dakh, _सकला,
   {{0x443a08c4,0x39490388,0x66040091,0x25a96461}},	//   _nip_, zcas_, _ajik, _saal_,
   {{0x75242388,0x7e7e0589,0x11d680e8,0x59e0150e}},	//   _aziz, nupp, _підр, नसार,
   {{0x7c2e6462,0x7c3a8db7,0x6d4002a5,0x78a60140}},	//   embr, _hitr, žman, _oskv,
   {{0x61e41d9f,0x99e98019,0x660401a1,0x68fb00e1}},	//   dhil, _تعلق_, _djik, _ľudo,
   {{0xf8b3812a,0xf3ff0073,0x443a3343,0x66040870}},	//   _תשס_, rsão_, _cip_, _ejik,
   {{0xf3ff00a9,0x25a92808,0x3f9e9ba4,0xdce98353}},	//   ssão_, _taal_, metu_, _rdeč,
   {{0x7c3ae463,0x61e46464,0x38696465,0xda10923a}},	//   _litr, ghil, tsar_, ावित_,
   {{0x39490510,0xc4c48065,0x209817ae,0x38696466}},	// [63b0] rcas_, _اے_, нкты_, usar_,
   {{0x7c3a8fa6,0x251c0158,0x661d1808,0x3949402b}},	//   _nitr, _צוזא, llsk, scas_,
   {{0xf7700c3b,0x98141e13,0x38694359,0x2d9d80b4}},	//   صال_, ابقا, ssar_, tewe_,
   {{0x61e401ed,0x38696467,0x7c3ab901,0x3a3900e5}},	//   chil, psar_, _aitr, _uisp_,
   {{0xdca5bf21,0x64a59a0b,0x2d9dba9a,0xdb01816a}},	//   тали, тала, rewe_, _valí,
   {{0x3f9e8499,0x69cf0052,0x65660234,0xe2998be4}},	//   jetu_, _hoce, zakh, дак_,
   {{0x7c3a911f,0x9ad381bc,0x3f9e811b,0xdb05016a}},	//   _ditr, _bịak, detu_, _inhó,
   {{0x69cf0bfe,0x65958071,0xf4858019,0x6d4d1a14}},	//   _joce, _шабу, _لائی, _nfaa,
   {{0x7c3a8b50,0x3c24016d,0xdb018187,0x6d598737}},	//   _fitr, höva_, _balã, mbwa,
   {{0x6d4d4577,0x69cf01a9,0x7c3a8bb1,0xd00e80a0}},	//   _afaa, _loce, _gitr, يلي_,
   {{0x656610e1,0xba74815b,0x442080fc,0x443a225c}},	//   takh, _مانت, ɓi_, _rip_,
   {{0x7d1b9a14,0x11f9803d,0xdd9982d6,0x7c3ae468}},	//   _kyus, _کوچک_, _akňz_, _zitr,
   {{0x65660393,0xe0ce8c9b,0x60c4022b,0xf1bf00ff}},	//   rakh, _тв_, xxim, _phán_,
   {{0x656626f3,0x2eb58d9e,0x6b83e469,0xe81986a7}},	//   sakh, _асис, ngng, _नीचा_,
   {{0x61e4005d,0xf1bf0129,0x61f63b4e,0xdee581cf}},	//   thil, _cháo_, tiyl, _шоки,
   {{0x244600ff,0xdb08810c,0x6e3b8b57,0x69c9e46a}},	//   _tôm_, _dadè, _niub, njee,
   {{0xa0670381,0x69cf646b,0x7d1bbd9b,0xdb1a8247}},	// [63c0] ката_, _doce, _nyus, _entè,
   {{0x7643b00f,0xafdb005f,0x61e4646c,0x3fe31454}},	//   _kuny, _stør, shil, ажув,
   {{0x7c3a81c1,0x61e4029b,0x26dc05b9,0x7d098388}},	//   _ritr, phil, ávo_, _axes,
   {{0x6e29db41,0x76438f45,0x973c81dd,0x3f9e81f4}},	//   _cheb, _muny, meće, zetu_,
   {{0xdb1ae46d,0xdd8f915f,0x6e3b87d5,0x973c8503}},	//   _inté, تون_, _diub, leće,
   {{0xdb0e0125,0x6564646e,0x387fc2cf,0x57e08035}},	//   _þjón, _leih, duur_, _फतेह,
   {{0x3f9e805c,0x628e267f,0x7d098144,0x973c8699}},	//   vetu_, ntbo, _exes, neće,
   {{0x6e3be46f,0x7c3a809a,0x7984310d,0x7bdc01f7}},	//   _giub, _witr, ngiw, hkru,
   {{0x64a3ab3f,0x3f9e803b,0x7c3ae470,0x3014bd93}},	//   _ката, tetu_, _titr, лдир,
   {{0xdefa8a14,0xa3e68fea,0x7c3a8cfa,0x236780d2}},	//   дым_, _पति_, _uitr, canj_,
   {{0xdef487ac,0xddc90e78,0x973c8052,0x628e2009}},	//   упны, rudž, jeće, jtbo,
   {{0x7643dc67,0x973c8024,0x3f9ed41e,0xe0da84ae}},	//   _duny, deće, setu_, _ове_,
   {{0xa3e6901b,0x661d016d,0x628e24a3,0x7643808e}},	//   _पता_, rlsk, etbo, _euny,
   {{0xdb01c58c,0x20180101,0x6602e471,0xdb1ae472}},	//   _halá, _nkri_, hnok, _anté,
   {{0x56949485,0x7643e473,0x6d4086c0,0xd6cf8254}},	//   _сайт, _guny, _ogma, _тт_,
   {{0x29188214,0x66028019,0x6d4082c4,0x1f3781c6}},	//   ğraf_, jnok, _ngma, _ברור_,
   {{0x69cf0baf,0x62341fea,0x201e80e5,0x764380fc}},	// [63d0] _voce, рету, olti_, _zuny,
   {{0xb8cb101b,0xa5bb0013,0xdefb0009,0xdb1abb40}},	//   _कई_, slód, мые_, _enté,
   {{0xf773810f,0x2367e474,0x6d4080dd,0x628e09c4}},	//   שקע_, vanj_, _bgma, ctbo,
   {{0x20180247,0xf1bf001c,0x7ddf00f1,0x98650065}},	//   _ekri_, _khám_, _mëso, _میرے_,
   {{0xdb050118,0x7a050084,0x629aa717,0x7a2581fa}},	//   _mahí, lėto, _apto, jóta,
   {{0xe50405e8,0x61e2e475,0x7a358110,0xa3b38fcc}},	//   रपति_, _alol, _išti, _जोश_,
   {{0xe2998221,0x23679a4d,0xfb8481e2,0xdb01e476}},	//   хай_, ranj_, рычн, _balá,
   {{0x387fa409,0xf8a99cad,0xa3b39199,0x2367826c}},	//   tuur_, евик_, _जोर_, sanj_,
   {{0x2367e477,0x69c9953c,0xdb01a5b3,0x7643e066}},	//   panj_, rjee, _dalá, _suny,
   {{0xab4a011b,0x68e98d38,0x76439a67,0x973c8289}},	//   _kaмe, rzed, _puny, zeće,
   {{0x200704c4,0xe3b0936d,0xdb0526de,0xa2d580f7}},	//   čnih_, _برق_, _bahí, _حيات,
   {{0x261903d3,0xdb01e478,0x2d890580,0x8d760174}},	//   déos_, _galá, _ccae_, دادا,
   {{0x2245e479,0x973c825b,0xe1f98084,0x236581f4}},	//   _hulk_, veće, mių_, _kelj_,
   {{0xe1f98a8e,0x394ddb80,0x656401ec,0x386de47a}},	//   lių_, lces_, _weih, mser_,
   {{0xe29717f4,0x386d8370,0x973c803b,0x7bdc1c11}},	//   лар_, lser_, teće, rkru,
   {{0xe1f98a8e,0x394d9098,0x601d8722,0x98a62097}},	//   nių_, nces_, dèmi, либе,
   {{0x973c805c,0x628e0687,0xa6ca61fe,0xa9260523}},	// [63e0] reće, stbo, کوال_, удал,
   {{0xd8488104,0x25bf8012,0x973c8279,0xa3b38d86}},	//   _học_, _anul_, seće, _जोल_,
   {{0xe1f981e2,0xb8cb2435,0xe57a8ab2,0x973c81a1}},	//   kių_, _कै_, езе_, peće,
   {{0xc27b093f,0x25ad8355,0x386d84d6,0x9ad381bc}},	//   _ארטי, _cael_, kser_, _pịnk,
   {{0x386d813c,0x7c3e647b,0xd84880ff,0x23658176}},	//   jser_, _kipr, _mọc_, _belj_,
   {{0x386d813c,0xdb01e47c,0xd848801c,0x394de47d}},	//   dser_, _salá, _lọc_, eces_,
   {{0xdb01936f,0xdee6002e,0x291d810c,0x386de47e}},	//   _palá, _сови, _aywa_, eser_,
   {{0xdd928277,0x25ad8355,0xef17091d,0xaca4819d}},	//   _دور_, _gael_, _смс_, _atụp,
   {{0xdfd08013,0x2edc800d,0x69dc064a,0xa5079ddf}},	//   قية_, मन्त, _नवनी, _бета_,
   {{0x08978307,0x749b810f,0x189780f7,0xb4e08105}},	//   اضيع_, _אימפ, اضية_, दनी_,
   {{0xdb018117,0x6c338013,0xe1f98110,0x3a203117}},	//   _talá, _افلا, bių_, klip_,
   {{0x394dd919,0x6146828b,0x443e81c6,0xd8488129}},	//   cces_, _седа, _hit_, _cọc_,
   {{0xd84880ff,0x3a2002d5,0x443ea640,0xf8a886ae}},	//   _dọc_, dlip_, _kit_, _कनिय,
   {{0x9f34a133,0x7c3e17d6,0xdce0875f,0x25ad001b}},	//   _келі, _cipr, _nemč, žel_,
   {{0x443ed83b,0x7c3e0397,0xda780656,0x2d890118}},	//   _mit_, _dipr, лят_, _tcae_,
   {{0xf1bf00ff,0x3f980609,0x7a0181a9,0xf99f0176}},	//   _thám_, _abru_, vētk, _ejèn_,
   {{0x7c3e002a,0x2ca938dc,0x6e2d2bd7,0x2bc79a46}},	// [63f0] _fipr, _usad_, _ihab, लामा,
   {{0x443ee47f,0x7c3e0bb1,0x1e0d8035,0x316682f9}},	//   _nit_, _gipr, िक्ष_, _leoz_,
   {{0x6e2d6480,0xa195218c,0x6d5d02ed,0x6d4f00e5}},	//   _khab, _канч, obsa, occa,
   {{0x443ee481,0x386da171,0x6595bb17,0x0dc8988f}},	//   _ait_, yser_, раду, лучи_,
   {{0xe1f981e2,0xd2640029,0x442c8ad4,0x6b658084}},	//   vių_, _viņš_, _bhd_, акла,
   {{0xeb999baa,0x987a00be,0xa87a03c8,0xd7e4004a}},	//   тик_, _באשט, _באשר, _лісо,
   {{0x443e93c7,0x67e004b8,0xfa340bca,0x3cfc009a}},	//   _dit_, _möjl, _خرید, _लेने_,
   {{0x386dc377,0x25bf8012,0x443e821e,0x4095bb4a}},	//   tser_, _unul_, _eit_, арот,
   {{0xe1f98a8e,0x68ed02ba,0xdb1a82ba,0xe450987e}},	//   rių_, nzad, _botó, _فضل_,
   {{0x386d92f1,0xe1f981e2,0x2cb88277,0x9989017b}},	//   rser_, sių_, _حافظ_, ylaş_,
   {{0xed5a4249,0x63a3cae5,0x7c3e6482,0xa2b88beb}},	//   кон_, menn, _ripr, ्मण्,
   {{0x6283e483,0x63a3e484,0x443e8613,0x6e2d2305}},	//   muno, lenn, _zit_, _chab,
   {{0x660980f1,0xdb1aa660,0x6e2d60c5,0x628382e8}},	//   _mjek, _fotó, _dhab, luno,
   {{0x6609920e,0xdb01855a,0x61e98ed0,0x656b8135}},	//   _ljek, _calç, lhel, hagh,
   {{0x661bc40c,0xa96a0098,0x76475213,0x6fc900d4}},	//   _okuk, кива_, _nujy, रानं,
   {{0x63a3e485,0x6e2d0ad0,0x65bb0364,0x61e9e486}},	//   henn, _ghab, _vähä, nhel,

   {{0x63a3a921,0x60db8737,0x6283e487,0x973c8a20}},	// [6400] kenn, nyum, huno, meća,
   {{0x65bb0364,0x2f562749,0x63a3e488,0x628389b6}},	//   _tähä, ртас, jenn, kuno,
   {{0xd37b0451,0x5b7b0051,0x63a3aaeb,0x61e9e489}},	//   _בריט, _בריא, denn, khel,
   {{0x62838420,0x629e2d08,0xdcf60214,0x7bc182c4}},	//   duno, _ippo, _hayı, _anlu,
   {{0xdcf607d9,0x63a3831d,0x61e9cf15,0x61fb8087}},	//   _kayı, fenn, dhel, diul,
   {{0x6609e48a,0x3eaa00dd,0x75298088,0x3e6800d7}},	//   _ejek, _tsbt_, _dzez, _مجری_,
   {{0x443ee48b,0x6283e48c,0xdcf6017b,0xdce6026f}},	//   _vit_, guno, _mayı, dakč,
   {{0x973c82fd,0x98b20214,0x91fc80eb,0x6609821e}},	//   jeća, layı_, _avār, _gjek,
   {{0x443e9a48,0xc7c6a57e,0x4fc689a8,0xfce38dae}},	//   _tit_, асни, асна, _дото,
   {{0x443e933a,0x6e2d648d,0x6d444f9b,0x629e24cf}},	//   _uit_, _shab, _agia, _oppo,
   {{0x09e68160,0x6283802e,0x6e2d06e7,0x61e9829b}},	//   _кожн, cuno, _phab, bhel,
   {{0x5183997b,0x61fb8087,0x6e2d523d,0x6d4462d8}},	//   _душа, ciul, _qhab, _cgia,
   {{0x629e19cc,0x53470eef,0x3eb981a9,0xdcf6007e}},	//   _appo, ихва, āsta_, _bayı,
   {{0x764086c0,0x6e22805d,0x6d440102,0x26f78180}},	//   _limy, hlob, _egia, اریخ_,
   {{0x6e2d0013,0x25b00198,0x996747d4,0x9f5e81a8}},	//   _thab, öllä_, итал, nntí_,
   {{0x68ed2bfa,0x827780be,0x31c400e8,0xf1bf00ff}},	//   tzad, יעלע_, осув, _khái_,
   {{0x63a3e48e,0x7c9500f7,0x7767022c,0x656be48f}},	// [6410] yenn, _الخص, _pejx, vagh,
   {{0x3d1a809a,0xdb1ab8ce,0x68ed6490,0x7a0180eb}},	//   _बड़े_, _antí, rzad, rēti,
   {{0x656b8870,0xdb0512d2,0xf77000f7,0x95cb8009}},	//   tagh, _anhö, باق_, куда_,
   {{0x3618835f,0x63a3e491,0x261c8020,0xdcf602d0}},	//   ацію_, wenn, díos_, _zayı,
   {{0xdcf60459,0x656be492,0x66099351,0x22b580eb}},	//   _yayı, ragh, _vjek, _sāk_,
   {{0x656bb3b0,0x261c8511,0xdb0501d0,0x2bc7864a}},	//   sagh, fíos_, _zahá, लाधा,
   {{0x61e9829b,0x656b91c2,0x63a389af,0x66098343}},	//   thel, pagh, renn, _tjek,
   {{0x63a3e493,0x62838ff9,0xc6920158,0x661b805d}},	//   senn, runo, _מאל_, _ukuk,
   {{0x973c803b,0x6283e494,0x61e9e495,0x20d5a1d2}},	//   veća, suno, rhel, сійс,
   {{0x61e9e496,0xddc9026c,0x59c5801b,0x261c8118}},	//   shel, grdž, वाहर, bíos_,
   {{0xee3a091e,0x7ddf020f,0x61e9829b,0x38ca803d}},	//   лно_, _kësh, phel, نایی_,
   {{0x64419fdb,0xdcf602bb,0xd12e853d,0x682901d0}},	//   _hili, _sayı, ظمی_, _vždy,
   {{0x6441cb46,0x49b896a5,0x60c484b7,0xdea18019}},	//   _kili, _خالد_, _ġimg, _کیجی,
   {{0xf8b68051,0xb05b1bc0,0xdcf60201,0x6441d08f}},	//   _לפני_, _kräf, _qayı, _jili,
   {{0x973c8bda,0x6449802a,0xd8488135,0x12b800ab}},	//   lećn, _luei, _jọn_, ীন্দ,
   {{0x6441842a,0xa5bb062f,0x68ec8182,0x7989e497}},	//   _lili, llón, _öldü, ngew,
   {{0x644180f7,0x249f81c0,0xb4db0722,0xdce40084}},	// [6420] _oili, _npum_, scàr, _keič,
   {{0x6441b3e7,0x7640b4c2,0xe0df02d6,0xd12f1ef5}},	//   _nili, _simy, _afòs_, رمل_,
   {{0x6d448110,0x6e22b110,0xdb08802a,0x3cfc0035}},	//   žiam, tlob, _padí, _लेते_,
   {{0x261c8693,0x6441e498,0x798980f3,0xdfd261fe}},	//   víos_, _aili, jgew, _کيس_,
   {{0x6441c1ae,0x7ddf020f,0x973c82ce,0xa13600f7}},	//   _bili, _dësh, jećn, _دردش,
   {{0x6441b543,0x62810207,0x741680ab,0x69c2bf61}},	//   _cili, álog, াষ্ট_, _snoe,
   {{0xf99f0242,0x764082c4,0xddc90b80,0xb7b5819d}},	//   _akèy_, _timy, vrdž, kọb,
   {{0x6441e499,0x6281005c,0xf1bf001c,0x9054864f}},	//   _eili, šlog, _phái_, овиц,
   {{0x8b969cad,0x6441e49a,0xdd1703db,0xa3b3ab12}},	//   _греч, _fili, _धुंध_, _जोक_,
   {{0x64419a0d,0x6569890d,0xd848826b,0x6abc8e06}},	//   _gili, _zeeh, _fọn_, _árfo,
   {{0xd848801c,0x501b0039,0xf41f0106,0x200b9243}},	//   _gọn_, רויו, ktär_, écia_,
   {{0x6441822e,0xdb1a80a9,0xf1bf0028,0x387f8239}},	//   _zili, _entã, _thái_, brur_,
   {{0x999f880a,0x64418d6a,0x24868267,0x394680e4}},	//   lmuş_, _yili, nuom_, _igos_,
   {{0x6441e49b,0x7ddf00f1,0xa5bb2509,0xf64f8061}},	//   _xili, _mësi, clón, بئی_,
   {{0x81ab80c8,0x999f88c5,0x7a358084,0x201a5712}},	//   খার_, nmuş_, _ištr, dopi_,
   {{0x22420019,0x2a8e8085,0xd25781c6,0xb33c8197}},	//   _cikk_, _həbs_, משלה_, _jaħq,
   {{0x656f649c,0x7a0881d0,0x02a5d59b,0x4fd51073}},	// [6430] mach, větl, _खन्न, ожат,
   {{0x656f0af9,0x752d0289,0x6449887a,0xe9df00f7}},	//   lach, _izaz, _ruei, _siúd_,
   {{0x543c0158,0x39469cbc,0x7bc5649d,0x2242035f}},	//   _געזא, _ogos_, _inhu, _fikk_,
   {{0x656f28b5,0x63a7649e,0x224200e8,0x249f80b9}},	//   nach, lejn, _gikk_, _ppum_,
   {{0x61ed178e,0x6449907f,0x7a35805c,0x7ddf00f1}},	//   mhal, _quei, _oštr, _vësh,
   {{0x6441e49f,0x61ed4cf5,0x656f2305,0xdb03e4a0}},	//   _qili, lhal, hach, lené,
   {{0xdce982ee,0x6441c18b,0x973c8289,0x79898e61}},	//   _odeć, _vili, dećo, tgew,
   {{0x61ed0558,0x64418a07,0x65949501,0x320964a1}},	//   nhal, _wili, _насу, nnay_,
   {{0x656f64a2,0x7989b66b,0x2cad8051,0x395f9482}},	//   dach, rgew, _used_, rbus_,
   {{0xb05b00f2,0x660d0074,0x7989a32e,0x973c8904}},	//   _träf, _ajak, sgew, rećn,
   {{0x46f59194,0x61ed005d,0x63a71cf3,0x752d2bd7}},	//   ючит, khal, dejn, _azaz,
   {{0x656f1dfb,0xfbc90051,0xb33c81b9,0xd848819d}},	//   gach, _בת_, _taħr, _kọl_,
   {{0x61ed3a51,0x3e480214,0x6830016d,0x660d64a3}},	//   dhal, _işte_, läde, _djak,
   {{0xdee598a2,0x316030b2,0x66e59662,0x8af70085}},	//   _моли, wbiz_, _мола, ğənn,
   {{0x656f64a4,0xed5a0698,0xc7448154,0x25a68681}},	//   bach, _кой_, _عضوي, yeol_,
   {{0x61ed64a5,0x660d00f1,0x32093bc3,0xb22605a8}},	//   ghal, _gjak, gnay_, імал,
   {{0x6fdf80e7,0x68300192,0x201a1502,0x6d4481d6}},	// [6440] _pêch, häde, topi_, žiak,
   {{0xb4e61c4f,0x62870264,0x320901b4,0x63a701d0}},	//   पनी_, bujo, anay_, cejn,
   {{0x444464a6,0x61ed029b,0x7e670282,0x6146263e}},	//   _ii_, bhal, _cwjp, _мена,
   {{0x444464a7,0x2486826c,0xdb0883c1,0xb05b0106}},	//   _hi_, tuom_, _nadá, _bräd,
   {{0x44440838,0x69c6539c,0xdb1e2511,0xad9b00f7}},	//   _ki_, _inke, _topó, liúc,
   {{0x444464a8,0x2ca991dd,0x61e43a92,0xd848819d}},	//   _ji_, çada_, lkil, _dọl_,
   {{0x26cc020f,0xb05b12d2,0x68300106,0x656f1fb6}},	//   _çdo_, _präg, rädd, yach,
   {{0x444464a9,0x672e02fd,0xdb089eec,0x999f807e}},	//   _li_, _izbj, _cadá, rmuş_,
   {{0x656289ca,0xb05b0106,0x61e400dd,0x63a70168}},	//   mboh, _gräd, ikil, yejn,
   {{0x444420b6,0xc7b8a8e1,0x656f64aa,0x109b0039}},	//   _ni_, kođe_, wach, סביב,
   {{0xb05b1b48,0x245080ff,0xf1bf00ff,0x656f435c}},	//   _träg, _hàm_, _khát_, tach,
   {{0x69a181fe,0x2fd80c64,0x752400b4,0x76440326}},	//   _कॉपी, _lorg_, _byiz, _ciiy,
   {{0xf7728019,0xdb03816b,0x75240314,0x6723838a}},	//   _ہاں_, vené, _cyiz, _eynj,
   {{0x656f0c64,0x6b9b005c,0x62872254,0xdb08826f}},	//   sach, đugo, tujo, _zadá,
   {{0x444464ab,0x24508142,0x656f64ac,0x61ed64ad}},	//   _di_, _làm_, pach, thal,
   {{0x444464ae,0x244f0179,0x63a72f9f,0x62870bcf}},	//   _ei_, _tüm_, sejn, rujo,
   {{0x444464af,0x61ed2e67,0x2fd864b0,0x320964b1}},	// [6450] _fi_, rhal, _borg_, rnay_,
   {{0x444464b2,0x69c64e39,0x61ed64b3,0x320963dc}},	//   _gi_, _enke, shal, snay_,
   {{0x61ed64b4,0x656d0458,0x644d0834,0x2fd800ee}},	//   phal, _keah, _huai, _dorg_,
   {{0x29dc160a,0x444416eb,0x6445165a,0xdb1e0722}},	//   _días_, _zi_, _hihi, _topò,
   {{0x44442778,0x69ce8023,0xe7bc8b84,0x64456415}},	//   _yi_, थानी, ्ञाप, _kihi,
   {{0x444401cd,0xf8bf64b5,0x656d0706,0x493a0039}},	//   _xi_, _iré_, _leah, _לגרו,
   {{0x81b480c8,0x4cd380c8,0x64454703,0x644d008c}},	//   ঞান_, _দেখু, _mihi, _luai,
   {{0x798d2444,0xb05b00f2,0x2fd80a0f,0x5fc90540}},	//   ngaw, _träd, _zorg_, रावल,
   {{0x644d154c,0xd84881bc,0xdb088061,0xafdb004a}},	//   _nuai, _fọm_, _vadá, _støy,
   {{0x1e858ff7,0x764402a3,0xf1b980d2,0x7ddf00f1}},	//   плом, _siiy, doše_, _mësu,
   {{0x44442b66,0x61fd2081,0xdb1a8187,0x98ab861c}},	//   _ri_, _omsl, _botõ, ımız_,
   {{0x644d1a29,0x200164b6,0xd1b89ddd,0xcfe9803d}},	//   _buai, hihi_, _وانا_, _گفته_,
   {{0x44440205,0x644d0068,0xf1b9817f,0x64454005}},	//   _pi_, _cuai, goše_, _bihi,
   {{0x644d0083,0x69d98039,0xf99f0032,0x225a00b9}},	//   _duai, _howe, _abè_, _ptpk_,
   {{0x44440082,0x64450057,0x61e43b4e,0xab2a0539}},	//   _vi_, _dihi, tkil, сова_,
   {{0x44443db1,0x644d003c,0xad9b0013,0x29dc01df}},	//   _wi_, _fuai, riúc, _rías_,
   {{0x444464b7,0x61e464b8,0x98a30758,0x7a2592ca}},	// [6460] _ti_, rkil, ните, góti,
   {{0x644504a7,0x444464b9,0x29dc03a8,0xaabd8f1b}},	//   _gihi, _ui_, _pías_, ्माक,
   {{0xf1bf1c03,0xf8bf10ab,0xba760481,0x998da329}},	//   _phát_, _eré_, _عادت, zmeš_,
   {{0x29dc05e4,0x69d9c4f0,0x2cbfa25b,0x645b8362}},	//   _vías_, _nowe, _brud_, _btui,
   {{0x644502a3,0x2001208b,0x649a9232,0x657b8122}},	//   _yihi, bihi_, стер_, _dduh,
   {{0x38600590,0x660bc36a,0x9f5e80f1,0x657b8133}},	//   mpir_, angk, ritë_, _eduh,
   {{0x6fc901fe,0x69d9e4ba,0xa3cd016f,0x46a30b69}},	//   रारं, _bowe, ळात_, _парв,
   {{0x9f5ee4bb,0x2d9f8133,0x3a2200ee,0x69d9e4bc}},	//   mité_, _gbue_, _jkkp_, _cowe,
   {{0x9f5eb347,0x3cfc18b8,0x764e2676,0x69d9e3c2}},	//   lité_, _लेले_, _huby, _dowe,
   {{0xb4d88b6f,0x6602b10e,0x656d1c33,0x644d0c49}},	//   ाही_, liok, _seah, _ruai,
   {{0x47348987,0x2ab5877f,0x644d032f,0xbcfb0b4c}},	//   ьнос, rùbá_, _suai, gbén,
   {{0x7bdac508,0x69d98573,0x63aa807b,0x973c88ae}},	//   _hotu, _gowe, lefn, lećk,
   {{0xd7e68d13,0x644d0073,0x7bda84b9,0x44210101}},	//   _ніко, _quai, _kotu, _pkh_,
   {{0x493b8bea,0x764e0247,0x69d98a0f,0x63aa807b}},	//   _הגדו, _ouby, _zowe, nefn,
   {{0x7bdad68b,0x201ee4bd,0x628a84b9,0x661d136f}},	//   _motu, moti_, nufo, posk,
   {{0x644d0cac,0xf8bf272b,0x82341e91,0x9f5e80e7}},	//   _tuai, _pré_, فرقا, dité_,
   {{0x798d01b0,0x2c2700e8,0x644564be,0x6d403e83}},	// [6470] rgaw, _ньог, _tihi, žmar,
   {{0x44270013,0x7bdae4bf,0x201eac62,0x9f47826f}},	//   _ón_, _notu, noti_, _plné_,
   {{0x200164c0,0x645be2ce,0x0ef9001b,0x63aa8114}},	//   rihi_, _stui, ्पेस_, defn,
   {{0x7bc8dcca,0x764e07cd,0x200125eb,0x2ca98187}},	//   _andu, _duby, sihi_, çado_,
   {{0xee38835f,0x3e4c800d,0x69d9cbe9,0x6283831d}},	//   їні_, _děti_, _rowe, wrno,
   {{0x69d9c174,0x0fe780ab,0xfaa5a597,0x7a050084}},	//   _sowe, _পদ্ধ, дако, rėtu,
   {{0x9f5ee4c1,0x69d9b910,0x201e9202,0x7528009a}},	//   cité_, _powe, doti_, ędzi,
   {{0x24808024,0xceb2010f,0x60c4e4c2,0x200c82f1}},	//   šima_, _ביל_, _šima, endi_,
   {{0xf8a9803d,0x6b9c031d,0xdb03b680,0x645b82c4}},	//   تگاه_, yfrg, mení, _utui,
   {{0xdb03a792,0x201ee4c3,0xb95b0032,0x69d9913b}},	//   lení, goti_, _bnìk, _wowe,
   {{0x3a2964c4,0xe7f50321,0xff5601c6,0x69d9e4c5}},	//   klap_, _इतना_, ובתך_, _towe,
   {{0xf3e90bea,0x2d8f8077,0x200c80e5,0xfb1a80be}},	//   _דף_, ngge_, andi_, _וועמ,
   {{0x6d44b999,0x3a29222e,0x518490ac,0xee371273}},	//   žiav, dlap_, _чуха, ьню_,
   {{0x33d50112,0x67d4a3fc,0xf77180a0,0x6602811b}},	//   ніст, _почу, _شات_, ziok,
   {{0x04431814,0x8c43153d,0x320d8e35,0xef1f8085}},	//   терн, тере, oney_, şüb_,
   {{0x9f5e83d3,0x3d19116e,0x764e0314,0xad9b01a8}},	//   vité_, _युके_, _ruby, liún,
   {{0xd378803b,0xd7c9035a,0x765c4fa2,0x6e2402a0}},	// [6480] _hoće_, रांच, _stry, _ikib,
   {{0xdfa600f7,0xdee602ee,0x66e6571d,0x9f5eb789}},	//   بحري, мози, моза, tité_,
   {{0x86c60013,0x386007f1,0x644f8144,0x4e02005e}},	//   بيان, spir_, _écij, _लगाई_,
   {{0x9f5e83d3,0x452a8758,0x7bdaa9f1,0xad9b01a8}},	//   rité_, ожен_, _sotu, hiún,
   {{0x3ead003a,0xa3b2101c,0x68ed809a,0xb4d89344}},	//   _ćete_, _ऐसा_, _żadn, ाहे_,
   {{0x660284cd,0x2d8f847f,0xd25a80c4,0x320dabf0}},	//   siok, agge_, оци_, eney_,
   {{0x160e2a25,0x7bdaa4a6,0x765c64c6,0xf74324c8}},	//   ाचार_, _votu, _utry, _аеро,
   {{0x628a80b9,0x2d95bd5a,0x6298d778,0x80b50035}},	//   rufo, _прус, rtvo, _उनमे,
   {{0x629884a8,0x7bda8790,0x68e464c7,0x628ac4ad}},	//   stvo, _totu, nyid, sufo,
   {{0x6e240590,0x7bc8d038,0x973c80d2,0xa5c70118}},	//   _akib, _undu, leći, _opóñ,
   {{0xd8488028,0x3c24016d,0xdd950084,0x68e42daf}},	//   _mọi_, hövs_, наны, hyid,
   {{0x6e362158,0x6d448110,0x7c2a9ff5,0x2366026c}},	//   _chyb, žiau, llfr, _đoja_,
   {{0x201e8010,0xdb01826f,0x6448c53f,0xdb0e64c8}},	//   poti_, _malý, _kidi, ndbæ,
   {{0x6e240c56,0xdf0a814c,0xd7c881a8,0x7a138087}},	//   _ekib, _мэйл_, _روعه_, măta,
   {{0x6448e4c9,0x60c2b732,0xf1b98088,0x2d8f8370}},	//   _midi, _hrom, loša_, ygge_,
   {{0x1de3000c,0x60c287dd,0x973c805c,0x8cc60beb}},	//   _पवित, _krom, jeći, ामखो,
   {{0x973c803a,0x60f91006,0x7a138087,0xdb03936f}},	// [6490] deći, чная_, năta, vení,
   {{0x3a29451c,0x2486bfe5,0x5fc91a3b,0xceeb0199}},	//   slap_, drom_, राइल, يران_,
   {{0x9f4c8144,0xb17b64ca,0xf4148264,0xdb0397a8}},	//   lidó_, _blåt, িতার_, tení,
   {{0x6448ce07,0x60c2e4cb,0x68300106,0x7bde808b}},	//   _aidi, _orom, räda, öpun,
   {{0x6448b22b,0xb4e981d2,0x7ae38114,0xd4699860}},	//   _bidi, मने_, wynt, чиле_,
   {{0xc6a73bae,0x644881b4,0x69dd64cc,0xdb03816b}},	//   _орби, _cidi, _hose, sení,
   {{0xd8488028,0x6d4d02a3,0x69dd64cd,0x387e01a9}},	//   _gọi_, _ogaa, _kose, _ātri_,
   {{0x69dd64ce,0x60c2bdbc,0x6d4d3368,0xc7b882a5}},	//   _jose, _brom, _ngaa, vođa_,
   {{0x6448d039,0x69dd64cf,0x7a258125,0xa5bb00f7}},	//   _fidi, _mose, dótt, clói,
   {{0x60c2e4d0,0x6d4d257a,0x6448e4d1,0x6e2464d2}},	//   _drom, _agaa, _gidi, _skib,
   {{0x66e58048,0xad9b00f7,0xd62a2902,0x60c2c3b5}},	//   хона, riún, зоне_, _erom,
   {{0x69dd463a,0xad9b0013,0xd3788a20,0x7c2502a3}},	//   _nose, siún, _voće_, _akhr,
   {{0x764980b9,0x61e9bd8f,0x8cc2850a,0xe8eec718}},	//   _miey, mkel, लियो, _сл_,
   {{0x973c8289,0xe51082f1,0x764980b9,0x6e3d1151}},	//   zeći, ़पति_, _liey, amsb,
   {{0x2005bdfa,0xf1d3853f,0xf1bf0104,0x161f88fd}},	//   mili_, थापन, _pháp_, यकार_,
   {{0xf2d28159,0x61e99699,0x69dd37a0,0x3ebe007b}},	//   נען_, nkel, _cose, _átti_,
   {{0x69dd2ffa,0xa84a1a00,0x045700f7,0xb4e9852a}},	// [64a0] _dose, سلام_, _كلية_, मनो_,
   {{0x660614c7,0xb17b0687,0x5fb783eb,0x61ef0144}},	//   likk, _blås, _असफल, _elcl,
   {{0x69cb8a52,0x61e9ae9d,0x69dd64d3,0x0d8682a4}},	//   _onge, kkel, _fose, елен,
   {{0x66060100,0x63ae64d4,0x628e445b,0x7ae13294}},	//   nikk, lebn, mubo, älte,
   {{0x2005b874,0x628e64d5,0x7bde64d6,0x6448e4d7}},	//   kili_, lubo, _kopu, _pidi,
   {{0x69cbc369,0x031f0b85,0x2005d791,0x2480e4d8}},	//   _ange, _मुँह_, jili_, šimo_,
   {{0x6448be05,0x660664d9,0x628e177c,0x69cb82f7}},	//   _vidi, kikk, nubo, _bnge,
   {{0xe643aaed,0x7bde0009,0x629c64da,0x7e9b0039}},	//   _бесп, _lopu, itro, _מסלו,
   {{0x644884b8,0x8c958160,0xdb01e4db,0x6c8688ca}},	//   _tidi, _архі, _baló, _سلام,
   {{0x69cbe4dc,0x200587d9,0x6e22bcb2,0x628e005d}},	//   _enge, gili_, loob, kubo,
   {{0x211a95e4,0x031f000f,0x660602fe,0x629c0088}},	//   _کتاب_, _मुंह_, fikk, jtro,
   {{0x61e98b2f,0x629c64dd,0x628e00fc,0xc33381c6}},	//   ckel, dtro, dubo, _עוף_,
   {{0x2005c96b,0x37e68ab5,0x7a25807b,0xafe68878}},	//   bili_, _подг, rótt, _подл,
   {{0x69dd596e,0xb05b16d2,0x63ae02af,0xdb018144}},	//   _sose, _brän, gebn, _galó,
   {{0xdeef905c,0x660602ec,0xdbc78074,0x09c500ab}},	//   _сы_, bikk, _töös, _একবা,
   {{0xf1a681fe,0x3cfc0006,0xb05b1614,0x59a680d4}},	//   _कॉमन, _लेके_, _drän, _कॉमर,
   {{0x6e228079,0x764980b9,0x9f5e816a,0x41b8864a}},	// [64b0] doob, _riey, hití_, _आसनस,
   {{0xa0c400f7,0x7c25036e,0xf7700124,0xdb08826b}},	//   ديكو, _ukhr, مام_, _dadú,
   {{0x44230025,0x63a9003b,0xb05b016d,0x57a40110}},	//   moj_, đend, _grän, ышта,
   {{0xaf3401a8,0x75298176,0x127a03de,0x2b1a01d0}},	//   اركت, _pyez, _קארע, _मुटु_,
   {{0x44258681,0x973c8904,0xb4bd8c28,0x672a807b}},	//   _pkl_, meću, ेमे_, _lyfj,
   {{0x4423003a,0x03a58c6e,0xed158065,0x63baaad6}},	//   noj_, тико, _یہاں_, _catn,
   {{0x61e9e4de,0xb5a7876a,0x9f34021e,0xdea4003d}},	//   tkel, _прай, _бері, _میلی,
   {{0x2005e4df,0x442364e0,0xdb018333,0x63ae050a}},	//   wili_, hoj_, _saló, zebn,
   {{0x4423003a,0x61e9a2ba,0x6d4480e1,0x80c44823}},	//   koj_, rkel, žiar, रिये,
   {{0x4423003a,0x61e98f52,0x63ba81fa,0x6606037a}},	//   joj_, skel, _gatn, wikk,
   {{0x2005e4e1,0x66060558,0xdb01b74e,0x63ae027f}},	//   rili_, tikk, _való, vebn,
   {{0x3ddf8a0f,0x7a13802e,0x63ba80ee,0xdce0801b}},	//   _jouw_, măto, _zatn, _nemě,
   {{0x66062bc5,0xf41f1a50,0x63ae001b,0x7a138087}},	//   rikk, rrän_, tebn, lăto,
   {{0x629c139a,0x660664e2,0x628e0461,0x3ddf8a53}},	//   ttro, sikk, tubo, _louw_,
   {{0x23270abe,0xab272300,0x3dcd8b99,0xe29736ab}},	//   вори_, вора_, _onew_, кар_,
   {{0x629c17c5,0x212b000d,0x628e018e,0x7c23e4e3}},	//   rtro, _bych_, rubo, honr,
   {{0x4423135a,0x660409ae,0x7bde3349,0x25bd831d}},	// [64c0] boj_, _imik, _topu, ddwl_,
   {{0xb05b04b8,0x98a31e25,0x629c64e4,0xdb1c0168}},	//   _trän, рифе, ptro, ndrë,
   {{0x224b04b8,0x63ba8025,0xc815035f,0x6e2290b5}},	//   _fick_, _ratn, уєть, toob,
   {{0x224b04b8,0x63ba8668,0x7c2e1ff5,0x98b181d0}},	//   _gick_, _satn, llbr, íběh_,
   {{0x63ba9061,0x6fc90361,0x2b060321,0x224002f1}},	//   _patn, राखं, _हेतु_, mmik_,
   {{0x3a26883b,0x22400d86,0xdce081d0,0xdb07128a}},	//   _skop_, lmik_, _země, zejí,
   {{0xfba41094,0x63ba8357,0x7a138087,0x6604519a}},	//   ख्यम, _vatn, găto, _omik,
   {{0xada689c7,0xbbdf0b86,0xa9348e11,0x442335bf}},	//   _шабл, _नक्क, лейш, zoj_,
   {{0xdb1a80f1,0x63baa9cb,0xdca680a9,0x1c468791}},	//   _katë, _tatn, _јази, _анам,
   {{0x66040065,0x1da51130,0xef1f82d0,0x442364e5}},	//   _amik, ग्नत, ğün_, xoj_,
   {{0x7a13802e,0x2ca900b9,0xadc3826b,0xef1f8380}},	//   căto, _spad_, _ajẹn, şün_,
   {{0x6f030073,0x3a268267,0x2489e4e6,0x7e7a94cf}},	//   únci, _ukop_, šame_, rstp,
   {{0x5c070098,0x6fb681a8,0xf8b68107,0xdb070216}},	//   вява, _لمشا, _अनिय, rejí,
   {{0xdb1a80f1,0xdb07001b,0x66040a40,0x443a02d0}},	//   _natë, sejí, _emik, _chp_,
   {{0x442364e7,0x9b580703,0x9f5eaa4d,0xaad28bb8}},	//   roj_, тист_, mità_, थमिक,
   {{0xed598025,0x9f5e89ba,0x6616020f,0x442300f1}},	//   _kaže_, lità_, _gjyk, soj_,
   {{0x973c82a5,0x4423246d,0x6d5d0061,0x10178019}},	// [64d0] reću, poj_, mcsa, _سکیں_,
   {{0x9f5e81c1,0x224b1a2e,0x973c85a2,0x25ff090f}},	//   nità_, _wick_, seću, शोरी_,
   {{0xdb0387e2,0xdb1a8168,0x212b0428,0xf77021df}},	//   menç, _datë, _wych_, زال_,
   {{0x212b0dee,0xed58835f,0xdb03bd5b,0x7c3a9611}},	//   _tych_, вої_, lenç, _ahtr,
   {{0x69cf0a1e,0x61ed209b,0xdca5db5d,0xb05b05ec}},	//   _ince, mkal, уали, _kräm,
   {{0x59d100c2,0x7a138162,0x320933c7,0x0c248a4c}},	//   हावर, tăto, liay_, амін,
   {{0x9f5eaa4d,0xa2c0809a,0x36d40c4f,0x3ddf890d}},	//   dità_, विष्, _корр, _touw_,
   {{0x61ed64e8,0xd3788e78,0xdb1ae4e9,0x7c23d15f}},	//   nkal, _voća_, _matè, sonr,
   {{0x7a138087,0x6e3b8234,0x61ed64ea,0x37758190}},	//   săto, _ihub, ikal, лынс,
   {{0x7982e4eb,0xe8f69e18,0x660400c3,0xa2c083dd}},	//   _edow, уль_, _smik, विश्,
   {{0x764d016f,0xb99580f7,0x61ed64ec,0x752d0d4e}},	//   _biay, _ملاب, kkal, _ayaz,
   {{0x7655009a,0x2459801c,0x61ed1279,0x3a24e4ed}},	//   _muzy, _kèm_, jkal, comp_,
   {{0xe0ce91cf,0x764d1ab3,0x61ed2765,0x2d9e0035}},	//   _ув_, _diay, dkal, ęte_,
   {{0x9f5e8698,0x61ed64ee,0x2d9e01d0,0xdb1a8242}},	//   cità_, ekal, řte_, _batè,
   {{0x65798372,0xf8bf0019,0xdb1a8580,0x3eb981a9}},	//   kawh, _szép_, _catè, āsts_,
   {{0x61ed1066,0x764d4f24,0x69db816a,0x6e298133}},	//   gkal, _giay, njue, _nkeb,
   {{0x68e98867,0xb05b00f2,0x224064ef,0x3eaa00b9}},	// [64e0] nyed, _främ, rmik_, _spbt_,
   {{0xb8dc3792,0xdb038073,0x67f2007b,0x6e3b82a0}},	//   _आन_, cenç, _bæja, _ahub,
   {{0xa2e61289,0x7d1b81df,0xd84881bc,0xbd8a81a8}},	//   _сонд, _axus, _kọr_, فنان_,
   {{0x7c3a820f,0x61ed0668,0x645664f0,0xed5aaeab}},	//   _shtr, ckal, _kuyi, ход_,
   {{0x645604b9,0xa3a900d4,0x6e3b90eb,0x63be0061}},	//   _juyi, _गॉड_, _dhub, _kapn,
   {{0x63a48267,0xdb1a8061,0x69a1836d,0x64561c61}},	//   đino, _haté, क्सी, _muyi,
   {{0x9f5e8a3f,0x60c464f1,0xe7372255,0xdb1aa190}},	//   vità_, lvim, _бер_, _katé,
   {{0x24800025,0x6e3b8c93,0xbc7680d7,0x245983ec}},	//   _ovim_, _ghub, _مهرب, _fèm_,
   {{0xdb1ae4f2,0x9f5e9b68,0x26c7e4f3,0x463b80be}},	//   _maté, tità_, _arno_, _טעלע,
   {{0x52768a08,0x26c7801b,0x09e10d14,0xed5984a8}},	//   _буду, _brno_, _नव्य, _važe_,
   {{0x9f5ea35a,0x25fb84e5,0x26c7803b,0x29dc0d76}},	//   rità_, लोकी_, _crno_, _díaz_,
   {{0x645664f4,0x9f5e8081,0xdb0a83a7,0x244f0609}},	//   _buyi, sità_, nefí, _ażma_,
   {{0xdb038073,0xcd073751,0x55073b17,0xae0401cb}},	//   tenç, учни, учна, शोधन_,
   {{0x61e28006,0x6c542596,0xab9504ae,0xdb1a8f33}},	//   _hool, скру, јављ, _patè,
   {{0xc4c4e4f5,0xdb03e4f6,0x61ed5fff,0xdb1a80e1}},	//   _کے_, renç, tkal, _baté,
   {{0x67388499,0xdb1a83d3,0xdb0383a7,0x777ae4f7}},	//   _izvj, _caté, senç, latx,
   {{0xb60681f4,0x6e3bdc45,0x9f4a07f1,0x478b1957}},	// [64f0] _mašć, _rhub, _albà_, есем_,
   {{0x61ed64f8,0x6e3bd1f3,0x61e2b0da,0xad9b01a8}},	//   skal, _shub, _lool, diúi,
   {{0x6579833e,0x1dc6809a,0x60c40110,0xb05b58e5}},	//   tawh, _रोहत, avim, _kräk,
   {{0x63be026f,0x61e2ae46,0x777a8cdb,0x70950048}},	//   _zapn, _nool, hatx, _камф,
   {{0x6aba8012,0xad9b00f7,0x6579e4f9,0x66f38085}},	//   _astf, giúi, rawh, rəkə,
   {{0x3206820d,0x62658878,0x3f830b67,0x68fb811c}},	//   _amoy_, авка, _udju_, vzud,
   {{0x61e2e0ba,0x69c080f3,0x6e3bc7cb,0x25a9016b}},	//   _bool, fdme, _thub, _obal_,
   {{0x09e58256,0x245986c0,0x61e2c4dc,0x9f5e84e8}},	//   роин, _tèm_, _cool, vitá_,
   {{0x61e2c86f,0xad9b01a8,0x20548048,0x660bb4e0}},	//   _dool, ciúi, йтэр, migk,
   {{0x25a900dd,0xdb0392a5,0x59d3801b,0x660b9887}},	//   _abal_, tenä, थाहर, ligk,
   {{0x24800025,0x02d989d7,0x61e2a556,0x3255a45b}},	//   _svim_, _جواب_, _fool, _твер,
   {{0x6cc601e5,0x660bb4e0,0x78b98069,0x61e2d731}},	//   айма, nigk, _tswv, _gool,
   {{0x442789f8,0x7ae101ec,0xf8a982f1,0x200b8036}},	//   oon_, ältn, _कहिय, écis_,
   {{0x4427e4fa,0xdb1a92ca,0x1ef980f7,0x69a18aed}},	//   non_, _saté, _لعبة_, क्री,
   {{0xab2a0db3,0xdb01801b,0xdb1a8825,0x232a0ae7}},	//   това_, _oblí, _paté, тови_,
   {{0x4427e4fb,0x60c40025,0x24809b3b,0x61e28079}},	//   hon_, tvim, šimi_, _xool,
   {{0xa80614ef,0xdfd200a0,0x422300e8,0x660b8192}},	// [6500] азал, يير_, ідув, digk,
   {{0x4427b217,0x6443809a,0x387f80b9,0x60c464fc}},	//   jon_, jmni, isur_, rvim,
   {{0x25bfe4fd,0xdfcf0c3b,0x71a6259a,0x69c081b4}},	//   _baul_, ظيم_, _канз, ydme,
   {{0x6da6a503,0xad9b00f7,0xe5a6802e,0x387fcdbb}},	//   рида, tiúi, риди, ksur_,
   {{0xa3cb00d4,0x62818711,0x61e284a2,0x248080f7}},	//   _रोड_, _avlo, _rool, éim_,
   {{0x44279fb0,0x61e2a986,0xad9b01a8,0x628e0299}},	//   gon_, _sool, riúi, orbo,
   {{0x66e60987,0x81b900c8,0xad9b00f7,0x660be4fe}},	//   _това, চার_, siúi, bigk,
   {{0x9874818b,0x25bf859e,0x30a6be80,0x24899ccb}},	//   блиц, _gaul_, аров, šama_,
   {{0x4427d592,0xdfd08013,0x25a90362,0xf1bf001c}},	//   bon_, كية_, _rbal_, _cháy_,
   {{0x200780b9,0x4427b260,0x57f48284,0xb60584e8}},	//   _cmni_, con_, спот, _višň,
   {{0xdefa8196,0x8f7b010f,0x2019809f,0x61e2d5d0}},	//   тып_, כניק, ésia_, _tool,
   {{0x98a69821,0x10a69033,0x28c90f1b,0xf99f06c4}},	//   _виде, _видн, रिमि, _amèn_,
   {{0x442cd8ca,0x443ec51c,0x69fb83de,0x00d78fd3}},	//   _kkd_, _kht_, _בלאק, _نبوت_,
   {{0x9989009a,0x26fc00ab,0x442c80c3,0xf3ff041c}},	//   znań_, _এখনো_, _jkd_, rpão_,
   {{0x7ac41383,0xf8b680c2,0xf2c40ada,0x200cbd61}},	//   осте, _अनुप, остн, midi_,
   {{0x4427a574,0x33f40106,0x443ec3cd,0x7bda2abd}},	//   zon_, _växa_, _lht_, ötur,
   {{0x4427c1b5,0x657d64ff,0x6e2d00b4,0x80d100d4}},	// [6510] yon_, mash, _ikab, समें,
   {{0x657d4d3d,0xb767044f,0x3866808e,0x28c902f1}},	//   lash, ртай, _mtor_, रिबि,
   {{0x4427b360,0x63b50353,0x660b82af,0x656f026f}},	//   von_, mezn, tigk, obch,
   {{0x63b51640,0x59a68076,0x200c822e,0x657d25f4}},	//   lezn, _कॉलर, hidi_, nash,
   {{0xd49b8c6e,0x443e80cd,0x9f439931,0x442c8683}},	//   тре_, _bht_, ójú_, _bkd_,
   {{0x657d5ae9,0x200c85ee,0x660b81ec,0xdd118197}},	//   hash, jidi_, sigk, _iżża,
   {{0x657d3623,0x68ed19b0,0x443e81e0,0xd90f8065}},	//   kash, lyad, _dht_, ڈیا_,
   {{0x4427e500,0xdb1ae501,0x657d00f1,0x68ed0079}},	//   son_, _antó, jash, oyad,
   {{0x68ed6502,0x657d5961,0x6609e503,0x4427b1ee}},	//   nyad, dash, _imek, pon_,
   {{0x753b803b,0x31790065,0x6e2d1ea2,0x44278079}},	//   _izuz, _lesz_, _akab, qon_,
   {{0x657d0578,0x387fce30,0x7980819d,0x7bc1e504}},	//   fash, ssur_, _ịweb, _ialu,
   {{0x7bc1aad7,0x7c3e020f,0xdb1a84c3,0x657d39af}},	//   _halu, _shpr, _entó, gash,
   {{0x66098135,0x661b834e,0x200ce505,0x61fb8b81}},	//   _mmek, _mjuk, bidi_, mhul,
   {{0xe29a0791,0x7bc1832e,0x200c8b57,0xe7088065}},	//   лаг_, _jalu, cidi_, اتین_,
   {{0x6e95a684,0x657d6506,0x7bc19dde,0x2ba9835a}},	//   _العا, bash, _malu, च्या,
   {{0x80c40076,0x7bc19083,0x661be1f0,0x628e0106}},	//   रिले, _lalu, _njuk, rrbo,
   {{0x6143104b,0x63b5007a,0x7a138087,0xc862819d}},	// [6520] зета, bezn, găti, _kọọd,
   {{0x7bc1ad80,0x66098010,0x2f560972,0xdb1c349a}},	//   _nalu, _amek, стас, ldrí,
   {{0x442a6507,0x61fb91e8,0x5b5700be,0xd37894ce}},	//   mob_, khul, _לייב_, _reć_,
   {{0xdb1c11b9,0x442a6508,0x200c8010,0xd719047d}},	//   ndrí, lob_, zidi_, _दशरथ_,
   {{0x7bc1b59a,0x61fbe389,0x6281001b,0x68ed0079}},	//   _balu, dhul, álov, cyad,
   {{0x6609e509,0x7bc185ae,0x29000010,0x657d0314}},	//   _emek, _calu, mzia_, zash,
   {{0xd378803a,0x38668082,0x200c8698,0x657d5ae9}},	//   _već_, _stor_, vidi_, yash,
   {{0xada3872f,0x442a01e9,0x61fbe50a,0x63b51660}},	//   _насл, hob_, ghul, zezn,
   {{0x2900650b,0x78a401e8,0x442c826c,0xc86281bc}},	//   nzia_, ntiv, _tkd_, _bọọd,
   {{0x6e2d013c,0x657d40a6,0x442a3ff4,0x7bc18662}},	//   _skab, wash, job_, _galu,
   {{0x657d4d12,0x5f38835f,0x200ce50c,0x6e4581fa}},	//   tash, рпня_, ridi_, _útbú,
   {{0x7bc1b4fd,0x61fb9cb6,0x61e600eb,0x60c485f3}},	//   _zalu, chul, _nokl, _šimu,
   {{0x657d1419,0x69c404b7,0xd90e8bca,0x2d992176}},	//   rash, ddie, _سید_, rgse_,
   {{0x63a90025,0x657d03c3,0x6d561eb7,0xb05b00f2}},	//   đeno, sash, _egya, _kräv,
   {{0x6fd205b3,0xec340cde,0x63b5650d,0xcfa9803d}},	//   साईं, їнсь, rezn, _خانم_,
   {{0x245d0104,0x6e2d2fc0,0xf1b980eb,0x657d4a03}},	//   _tìm_, _ukab, toši_, qash,
   {{0x660f003e,0x7c97006b,0x998900c3,0x69c2810c}},	// [6530] mick, _اشعا, glaš_, _maoe,
   {{0xd5a5016f,0x661b8687,0xa8a417ae,0x1da5140d}},	//   ग्रज, _sjuk, ярск, ग्रत,
   {{0x76b901e5,0x2900650e,0x68ed3bd5,0x41c403dd}},	//   рлер_, azia_, syad, _लोकस,
   {{0x660f0a56,0x7bc1ad2a,0xd2468077,0x99990110}},	//   nick, _salu, _زن_, _visų_,
   {{0x78a4650f,0x7bc1cc89,0xdb18806a,0xd1268591}},	//   ctiv, _palu, ndvæ, _آم_,
   {{0xdfdb0698,0x660f4431,0x2489e510,0x547c03de}},	//   _съм_, hick, šamo_, נטוו,
   {{0x7bc1b9ac,0x61fb805d,0x7bc381ec,0xdb1e0187}},	//   _valu, thul, rdnu, _papé,
   {{0x7bc1c79e,0xa5f897ae,0x6609804f,0x6b8885ee}},	//   _walu, _лесу_, _umek, _eddg,
   {{0x2aa18063,0x442a0282,0x660f026f,0x7bc1e511}},	//   sób_, yob_, dick, _talu,
   {{0x6e2b8b4c,0x61fba76b,0xdb1ae512,0x600982de}},	//   logb, shul, _zatí, рном_,
   {{0xe7399289,0x660f003e,0x623595ac,0xb05b0106}},	//   рен_, fick, _дежу, _gräv,
   {{0x660f003e,0x58d58323,0x9f4581d0,0xc862819d}},	//   gick, _моет, chlý_, _wọọd,
   {{0x442a6513,0xc0e58be2,0x6283d497,0xb05b0192}},	//   tob_, _фолк, lsno, _kräu,
   {{0x386d9277,0x61e626a6,0xdce981d6,0x2b4081d0}},	//   mper_, _sokl, _oceľ, řice_,
   {{0x60c9e514,0x660f40dd,0xf8bf2c8a,0xfbd281c6}},	//   lvem, bick, _asé_, ותם_,
   {{0x78a40211,0x6d560065,0x2900011e,0xbcfb00f7}},	//   ttiv, _ugya, tzia_, scéa,
   {{0x98a31d32,0x69c46515,0x27e78247,0x600a3b17}},	// [6540] мите, rdie, _konn_, анам_,
   {{0x69c42c28,0x25ada00b,0x290001ac,0xdb1ae516}},	//   sdie, _abel_, rzia_, _satí,
   {{0x91e61264,0xbcfb6517,0xdb1ae518,0x27e78242}},	//   _доне, ncén, _patí, _monn_,
   {{0x645ba487,0x5eac00ab,0x386d80b9,0xad9b01a8}},	//   _buui, ছিলে, kper_, liúr,
   {{0x6441803c,0xa3b6800f,0xa01b0125,0x5046002e}},	//   _bhli, ज़ल_, _kvöl, _мемб,
   {{0x660f07df,0x6562856f,0x326690f8,0x6441a305}},	//   zick, scoh, отив, _chli,
   {{0xfc3f02ba,0xa2bda38c,0x2bcb001b,0x64418c49}},	//   ntía_, _वैद्, ायता, _dhli,
   {{0xd378803a,0xab5c80eb,0x48aa968a,0x9874e519}},	//   _moći_, _daļa, атом_, плиц,
   {{0x27e7b903,0xb7bc8029,0x660f136f,0x41a6a207}},	//   _bonn_, loģi, vick, क्षस,
   {{0x274a8676,0xc6a69814,0xb4d692ee,0x765c5b5e}},	//   ично_, орми, िमी_, _kury,
   {{0x660f0a56,0xd3788025,0x1f5b010f,0x27e7bb42}},	//   tick, _noći_, ידיא, _donn_,
   {{0x765c540f,0x27e7808e,0x3dc6a093,0xc7b88503}},	//   _mury, _eonn_, ndow_, vođu_,
   {{0x660f0a56,0xf8ad8077,0x27e7bb42,0x2ca6d18f}},	//   rick, _یکی_, _fonn_, ntod_,
   {{0x660f003e,0x3dc4822c,0x63b8e51a,0x7980c50b}},	//   sick, _lamw_, nevn, lamw,
   {{0xc1ee823c,0x3d118063,0x660f026f,0x320b0037}},	//   _जवाब_, _देने_, pick, ахан_,
   {{0xd378803a,0x2ca68420,0x91fc81a9,0xb05b0338}},	//   _doći_, ktod_, _stāj, _orät,
   {{0xdcfb805c,0x27e78247,0xf8bc809a,0x7a138162}},	// [6550] _iduć, _yonn_, ्टिय, cătu,
   {{0x63b8e51b,0x7980823d,0x765c02a0,0x2cbf8101}},	//   jevn, hamw, _bury, _rsud_,
   {{0xd6db49a1,0xdb150065,0xa2cc016f,0x7bd7651c}},	//   шта_, kezé, हिण्, _inxu,
   {{0xa91d8052,0x6281003a,0x64418c41,0x386d81a3}},	//   laže, šlos, _shli, yper_,
   {{0x7bc5058e,0x9f4c81a8,0x660d3fb5,0xb7b5819d}},	//   _kahu, ghdú_, _mmak, kọp,
   {{0x2249651d,0x26ce802a,0x395909d1,0xa91d9874}},	//   lmak_, _orfo_, _hgss_, naže,
   {{0x7bc52fbb,0xdb1a8722,0x058781a1,0x660d651e}},	//   _mahu, _catà, _муам, _omak,
   {{0xe9d98785,0x40958cd0,0xdb1c3930,0x3f81651f}},	//   ски_, прот, ndrá, lahu_,
   {{0x63a90025,0x6283856c,0xfbcb1905,0xb05b0192}},	//   đenj, ssno, ायाम, _träu,
   {{0x660d44de,0x7bc533ef,0x3f81000e,0x386d8b2b}},	//   _amak, _nahu, nahu_, rper_,
   {{0xdb0aa9ed,0x386dc5f8,0xed5a4b8d,0xf529025f}},	//   gefä, sper_, йон_, _עץ_,
   {{0xd1318013,0x2d9db9fa,0x224900d2,0x386d97af}},	//   _كما_, ngwe_, jmak_, pper_,
   {{0x3f81026c,0x7bc502a0,0xf1b9811a,0x27e78e20}},	//   kahu_, _bahu, meš_, _tonn_,
   {{0xdb1a8065,0xa91d856f,0x660d6520,0x33d51138}},	//   _hatá, ražd, _emak, міст,
   {{0x7bc5208b,0x34b8a0d8,0x0f7a8039,0x6b9c008e}},	//   _dahu, _इन्द, _הרצל, rgrg,
   {{0x09e312a0,0xdddcb5ca,0x63b88da8,0xfc3f0511}},	//   носн, _ovrš, zevn, rtía_,
   {{0x2d822cb1,0x765c0cc0,0xfc3f05e4,0xa3bd881f}},	// [6560] make_, _sury, stía_, ेया_,
   {{0x2d821110,0xfc3f00f7,0x7bc560d9,0x9ce70019}},	//   lake_, ltín_, _gahu, _روپے_,
   {{0x4444003a,0x41bd835a,0xf1bd8b86,0x59bd800c}},	//   _ih_, ्यास, ्यान, ्यार,
   {{0xfc3f6521,0xdb1aa13c,0x7bc56522,0xa3a9886a}},	//   ntín_, _natá, _zahu, ग्स_,
   {{0x7bc54ffd,0x63b885b9,0xb4d682f1,0xf1b99ee0}},	//   _yahu, tevn, िमे_, deš_,
   {{0x62988a8e,0x69c66523,0x2d8258af,0x443803ac}},	//   tuvo, _hake, hake_, nlr_,
   {{0x80c41053,0x44444ad2,0x69c6155f,0x2d8203f8}},	//   रिके, _mh_, _kake, kake_,
   {{0x69c66524,0xdb1e0038,0xdb1a8510,0x44440252}},	//   _jake, _napí, _catá, _lh_,
   {{0xfc648077,0x6b569381,0x69c60e9e,0x7c2e31cd}},	//   _آخری, _فضائ, _make, kobr,
   {{0x6d408341,0x660d1be9,0x1dda8076,0xdb03826f}},	//   _izma, _smak, णावत, lený,
   {{0xdd950a14,0x7bc50074,0x69c6151e,0x659515ac}},	//   маны, _rahu, _oake, ману,
   {{0x44446525,0xdb1e023e,0x7bc54081,0xaac29834}},	//   _ah_, _capí, _sahu, _वैयक,
   {{0x44446526,0x7bc55885,0x7c2e0118,0x76560300}},	//   _bh_, _pahu, fobr, _diyy,
   {{0x444406f6,0x7c2e0052,0x41da852a,0x60c2e527}},	//   _ch_, gobr, भावस, _isom,
   {{0x69c60c03,0x44440046,0xa91d8289,0x883b8051}},	//   _bake, _dh_, raže, _התגו,
   {{0x44446528,0x69c60642,0x2486a67f,0xa7fb06a5}},	//   _eh_, _cake, ksom_, _muñe,
   {{0x7bc5048f,0x3f815237,0x44443a5c,0xdb03826f}},	// [6570] _tahu, tahu_, _fh_, dený,
   {{0xd6db0d0e,0xa3d40beb,0xdb1e03f2,0x60c280b8}},	//   йте_, _सोप_, _zapí, _msom,
   {{0x69c66529,0xdddc8503,0xb05b0b2f,0xe9df001c}},	//   _fake, _svrš, _präs, _chúc_,
   {{0x661d36bd,0x3f81003e,0xe9df0028,0x645701df}},	//   nnsk, sahu_, _giúp_, _hixi,
   {{0x44441fd8,0x64a58ddc,0x628723b1,0x661d0412}},	//   _yh_, фала, lsjo, insk,
   {{0x4444652a,0x69c60a0f,0x2d82652b,0x3d11816f}},	//   _xh_, _zake, zake_, _देणे_,
   {{0xea000028,0xdb03803e,0xddcd009a,0xd3788024}},	//   _hoạt_, bený, _miał, _noću_,
   {{0xa3d405fc,0x7c2e26fd,0xdb03e52c,0x661d23f9}},	//   _सोन_, zobr, menü, jnsk,
   {{0x34949448,0x2d8de52d,0x9f4780f1,0x3a2d85f8}},	//   _патр, _idee_, _tonë_, roep_,
   {{0x2d82022e,0x6287035f,0x764404b9,0xdb1e0187}},	//   wake_, ksjo, _shiy, _japã,
   {{0x4ac180d4,0x2d82652e,0xdb1e2aa8,0x3d118c69}},	//   _शनिव, take_, _papí, _देते_,
   {{0x661d0aa2,0x645708f1,0xa3a98c78,0x60cd00ce}},	//   gnsk, _aixi, ग्र_, kvam,
   {{0x69d9e52f,0x7c2e6530,0x2d824f15,0x69c62551}},	//   _inwe, tobr, rake_, _rake,
   {{0x6b83859e,0x69c633a9,0x2d826531,0x661d01ac}},	//   nang, _sake, sake_, ansk,
   {{0x69c66532,0x2d826533,0xdb03bdcd,0xfaa32c24}},	//   _pake, pake_, menó, каро,
   {{0x6b83bcc3,0x69c9e534,0x645f00f1,0x7c2e1400}},	//   hang, ndee, _fuqi, sobr,
   {{0x78a9aeec,0x6b83a0e7,0x2fc788b3,0x61ebacdb}},	// [6580] ntev, kang, _kang_, _mogl,
   {{0x26d1003a,0x6b83bb5b,0x6d5bb7dd,0xe9df001c}},	//   _brzo_, jang, _agua, _phúc_,
   {{0x2fc78681,0x6b83c083,0x69d9e535,0x78a9e536}},	//   _mang_, dang, _onwe, htev,
   {{0x61eb8022,0xdd8f845b,0x63bc29c6,0x2fc7843c}},	//   _nogl, لوم_, lern, _lang_,
   {{0x442e9de6,0x2d800006,0xdb098efc,0x6b83aa1d}},	//   tof_, _meie_, čnýc, fang,
   {{0x2fc7e537,0x63bc29c6,0x24868687,0x69d9ab29}},	//   _nang_, nern, rsom_, _anwe,
   {{0x9f5e820f,0x96630607,0x998901ac,0x61ebaf65}},	//   shtë_, _аксе, slať_, _bogl,
   {{0x63a9003b,0x442eb2b3,0x61eb81a7,0x80b280ab}},	//   đeni, sof_, _cogl, জিস্,
   {{0x6b8385c6,0x6d40e538,0x63bc0f06,0xdb1a8187}},	//   bang, _uzma, kern, _antô,
   {{0x63bc1277,0x69d98a2c,0x629c6539,0x6b83e53a}},	//   jern, _enwe, kuro, cang,
   {{0x7bdae53b,0x61eb8429,0xdb0e00f2,0xa5bb04c3}},	//   _intu, _fogl, nebä, olóx,
   {{0x72169381,0x61eb831d,0x629c0114,0x2fc78114}},	//   _غذائ, _gogl, duro, _eang_,
   {{0x7bc8e53c,0xe9f780e8,0x79840010,0x661d06b1}},	//   _kadu, _інші_, daiw, rnsk,
   {{0x63bc17db,0x7bc88ad4,0xf8bc8105,0x2fc7c33f}},	//   gern, _jadu, ्टीप, _gang_,
   {{0x6457653d,0x62a2826f,0xa3b0816f,0xa3e69513}},	//   _vixi, _útoč, ट्य_, _बचन_,
   {{0x645702a3,0xa91d825b,0xf1bf0019,0x6b838a40}},	//   _wixi, laža, _akár_, zang,
   {{0x2fc79dae,0x63bc653e,0x628701cd,0x90990098}},	// [6590] _yang_, bern, ssjo, яват_,
   {{0x60cd2d28,0x6d5be53f,0x60c900cd,0xf1d803eb}},	//   rvam, _sgua, _šems, डाउन,
   {{0xa3e2a9b7,0x20130201,0x629c072a,0x44316540}},	//   धान_, rixi_, curo, moz_,
   {{0x6b83e541,0x7bdae542,0x7bc88032,0x44316543}},	//   wang, _antu, _aadu, loz_,
   {{0x6b83afe9,0x7bc89c88,0x7bda80dd,0x61eb8796}},	//   tang, _badu, _bntu, _rogl,
   {{0x61ebc1a1,0x7bc88b57,0x22469142,0x44316544}},	//   _sogl, _cadu, _ahok_, noz_,
   {{0x6b83999f,0xeab18065,0x6b7c0051,0xe2998c07}},	//   rang, اعت_, חרונ, чай_,
   {{0x44310065,0xdb1c0073,0x2fc7e545,0x201ec7ff}},	//   hoz_, ferê, _sang_, enti_,
   {{0x6b838ec9,0x69c985f8,0x61ebc17c,0x2fc784d2}},	//   pang, rdee, _vogl, _pang_,
   {{0xe3b083f8,0x7bc880eb,0x443101ca,0x78a9e546}},	//   _نرم_, _gadu, joz_, rtev,
   {{0x6811801b,0x61ebe53f,0x2ca900ee,0xc95980a0}},	//   vědě, _togl, _aqad_, _فلاش_,
   {{0x6b81b860,0x7bc88025,0x91fc80eb,0xdb1e026f}},	//   _helg, _zadu, _stāv, _napá,
   {{0x5184902a,0x6b8183ca,0x2fc7e547,0x7bc8d40f}},	//   _руха, _kelg, _tang_, _yadu,
   {{0x2fc7816f,0x224d93f4,0x629c195c,0xe1ff6548}},	//   _uang_, lmek_, turo, _aló_,
   {{0x63bc6549,0x2d800074,0x3f8581d0,0xdce40609}},	//   rern, _teie_, malu_, _ddiġ,
   {{0x3f858867,0xe1f981e2,0x63bc0f96,0x224d8214}},	//   lalu_, nkų_, sern, nmek_,
   {{0x63ad803a,0x63bc654a,0xf8c8801c,0x629c654b}},	// [65a0] đanj, pern, _xứ_, suro,
   {{0x3f85825b,0xdb018207,0x44310511,0xd9bd86de}},	//   nalu_, _eclé, coz_, ्युट,
   {{0x225902fe,0x539b0039,0x6602b8ec,0xc0498129}},	//   _fisk_, _ציטו, thok, _sườn_,
   {{0xf5398038,0x7bc8e54c,0x9ccaa1f6,0x9f5c86c4}},	//   _byť_, _sadu, зыка_, _elvè_,
   {{0x6b81e54d,0x3f85e54e,0x201e8198,0x3ebf0b67}},	//   _belg, kalu_, ynti_, _ćute_,
   {{0x3f8580d2,0x6b8183a8,0x66028abd,0xc049801c}},	//   jalu_, _celg, shok, _vườn_,
   {{0xd9bd8996,0x3f85e54f,0x6b818333,0x9f47826f}},	//   ्यूट, dalu_, _delg, _plný_,
   {{0x3d118074,0x44316550,0xdb1c6551,0x68e450a3}},	//   _देवे_, zoz_, terê, oxid,
   {{0xdfd08307,0x80bc835a,0xc8c93792,0xbddb00e7}},	//   لية_, ्टें, रिएट, llèg,
   {{0x7bda9dae,0x6e246552,0xa2e696ba,0x201ee553}},	//   _untu, _ajib, _позд, unti_,
   {{0xa3cb0ebf,0x44311b77,0xa3df016f,0x290b8cd4}},	//   _रोग_, voz_, णास_, úcar_,
   {{0x63a50352,0x645acb3a,0xe9df026b,0xf8c880ff}},	//   _schn, _hiti, _ahún_, _tứ_,
   {{0x645ab06c,0x3f85d4a5,0x44316554,0x6e2457d3}},	//   _kiti, balu_, toz_, _djib,
   {{0x6d440d38,0x6e24019d,0x645aa054,0xbcfb6555}},	//   _dzia, _ejib, _jiti, ncéi,
   {{0x645ae556,0xed598253,0x2fdf026c,0x03d781c6}},	//   _miti, _važi_, _đug_, עולם_,
   {{0xa3b08076,0x644e6557,0x28b786a7,0x7522139c}},	//   ट्त_, ambi, _अहमि, _žoze,
   {{0xab871525,0x0841046d,0x21390168,0x645ae558}},	// [65b0] _пунк, _adìẹ_, _qysh_, _oiti,
   {{0x63ad90d3,0x6e3d0840,0xa91d80ce,0x9f5e8216}},	//   đank, llsb, kažn, mitó_,
   {{0x22591cf3,0xa7fb0511,0x9f5e8661,0xa91d8968}},	//   _tisk_, _cuña, litó_, jažn,
   {{0x6b818310,0xdd958196,0x2eee016d,0x7afa04d6}},	//   _selg, тады, äffa_, øtte,
   {{0x69dd1429,0x645acdcc,0x3d1183ca,0x629881ed}},	//   _inse, _biti, _देशे_, ervo,
   {{0x741591cc,0xdb1c6559,0x3fcb80ab,0x645adde0}},	//   ضوعا, ferè, _লক্ষ, _citi,
   {{0x645a8587,0xe9d18013,0x78ad655a,0x6b81c0df}},	//   _diti, لغة_, ltav, _velg,
   {{0x3f85e1ff,0xe1f98110,0x645a81a8,0xe4e780e8}},	//   walu_, ukų_, _eiti, _пізн,
   {{0x224dbf41,0x78ad0f52,0x6b81a9ba,0x645ae55b}},	//   rmek_, ntav, _telg, _fiti,
   {{0x24558077,0x3f830683,0x645a833e,0x765b8420}},	//   _شناس, _jeju_, _giti, _hiuy,
   {{0x69dd0454,0x248d8b40,0x78ad156e,0x6d440019}},	//   _onse, _hvem_, htav, _szia,
   {{0x61ef3795,0x78ad0612,0x2612176d,0x645ae55c}},	//   _nocl, ktav, pšom_, _ziti,
   {{0x64488009,0x61e985f3,0xb6060032,0x78ad0168}},	//   _yhdi, mjel, _aráà, jtav,
   {{0x69dd444b,0x61e9e55d,0xd3720154,0x69cb97ab}},	//   _anse, ljel, شهر_, _hage,
   {{0x69cb81bf,0x3a2001e0,0x66d7819d,0x9f47816b}},	//   _kage, tnip_, _ịko, _koní_,
   {{0x61fb91e8,0x61e9abf2,0xba232597,0x3eaa801b}},	//   nkul, njel, адск, žití_,
   {{0xed598025,0x229b077f,0x3eb800dd,0x59a683dd}},	// [65c0] _kažu_, tàkì_, _sprt_, क्टर,
   {{0x69cbcd52,0x09cd80c8,0x61e9b3d9,0xa7fb0511}},	//   _lage, িউটা, hjel, _puña,
   {{0x0d868c40,0xa3df035a,0x61fbdb89,0x248d802e}},	//   влен, णार_, kkul, _avem_,
   {{0x645a8511,0xa2d58bb8,0xc1bd8ebf,0x61ef639a}},	//   _siti, भिन्, ्योग, _gocl,
   {{0x61e9830b,0x645a8205,0xdca3a33f,0xe5a38a95}},	//   djel, _piti, иаци, ричи,
   {{0xdb1c51db,0x628a84dc,0xa7fb0118,0x7982808e}},	//   terè, tsfo, _tuña, _seow,
   {{0xdee33751,0x645ae55e,0x69cb9f57,0x66e32457}},	//   _кори, _viti, _bage, _кора,
   {{0x61e9e55f,0xa91d8b67,0x628a9c11,0x61fb8637}},	//   gjel, gažo, rsfo, gkul,
   {{0x69cbce39,0x6e2281bc,0x91fc80eb,0x38ab806a}},	//   _dage, mnob, _stās, gør_,
   {{0xdb188e14,0x2d849916,0x61fbe560,0x9f5e8388}},	//   leví, _heme_, akul, vitó_,
   {{0x25df01ab,0x69cbb5ce,0x61e9b25c,0x656d1705}},	//   गाली_, _fage, bjel, _pfah,
   {{0xa3cb1551,0x69cbe561,0x61e9911b,0x60c40dc5}},	//   _रोज_, _gage, cjel, kwim,
   {{0x69c09790,0xa3e68105,0x2d84e562,0xe89497d4}},	//   meme, _बचा_, _meme_, _саль,
   {{0x69c0e563,0xac242a15,0x69cbe564,0x200584e8}},	//   leme, афск, _zage, chli_,
   {{0xdeef93cd,0xe8e08028,0x9f5eb699,0x69cb820c}},	//   _ты_, _đội_, sitó_, _yage,
   {{0x78ad025d,0x63ad8025,0xd9e5800f,0x0f578039}},	//   ttav, đani, कायत_, _ביום_,
   {{0xc4c48065,0x5184065c,0xa91d817f,0x57b51dc7}},	// [65d0] _بے_, руса, jažl, лбат,
   {{0xb8cb0105,0xcbbd80ab,0x673c0357,0x7649e565}},	//   _गम_, _ইচ্ছ, _byrj, _shey,
   {{0xcf938158,0xa3d68744,0xf7700591,0x7c351b2c}},	//   שטע_, ियन_, تاق_, mozr,
   {{0x69dd0352,0xa3b08e00,0x69c0bf7e,0x3a2682f7}},	//   _unse, ट्स_, jeme, _njop_,
   {{0xe9df10ab,0x69c0da9e,0xa91d826f,0x6aba808e}},	//   _inú_, deme, važo, _aptf,
   {{0x69cbe566,0xdb056567,0x30da00be,0xb4fc01c6}},	//   _sage, _aché, _אַלע, ופדי,
   {{0xdb1c0020,0x69cb9850,0x39468118,0x61e9e568}},	//   teré, _page, _azos_, tjel,
   {{0x69c09412,0xf1da8076,0xb05b016d,0x683d8722}},	//   geme, भागन, _osäk, mèdi,
   {{0x61e9e569,0x20559d51,0x28c90aed,0x69cbe56a}},	//   rjel, лтор, रिटि, _vage,
   {{0x61fbe56b,0xdb052ce0,0xa7fb1f49,0x248980eb}},	//   skul, _tchè, _muño, šams_,
   {{0x69cbe56c,0x61e9920e,0x69c0c71c,0x92000032}},	//   _tage, pjel, beme, _bọ́,
   {{0x69c0e567,0x8afa83c8,0x2005e56d,0xcf4982d0}},	//   ceme, _אלעז, shli_, _ışık_,
   {{0x81cc0a49,0xa7fb0144,0xa3df0c2d,0x92000032}},	//   লাম_, _nuño, णां_, _dọ́,
   {{0x409280f7,0x3a3f92a5,0x7bce0216,0xd91a9101}},	//   _الور, llup_, udbu, _אונל,
   {{0x9987017f,0xab274b60,0x3ea102f1,0x60c400b9}},	//   _šiša_, гора_, juht_, wwim,
   {{0x316de56e,0xa3d406ae,0x9200026b,0xf3f18032}},	//   ncez_, _सोर_, _gọ́, _lọ_,
   {{0xc0e30396,0x6604022e,0xb1463c0e,0xa3d6825e}},	// [65e0] ботк, _ilik, унал, ियम_,
   {{0x69c0e56f,0x2d8496c9,0x3a3948ee,0xdee620bf}},	//   zeme, _seme_, _eksp_, лози,
   {{0x69c0afc6,0x645e02c4,0x81cc0264,0xdb15016a}},	//   yeme, _iipi, লাব_, pezá,
   {{0x69c087e2,0xc9760277,0x0caa8652,0x94aa9878}},	//   xeme, _حادث, етки_, етка_,
   {{0x645e022e,0x22406570,0x628e03d9,0x69c0a4cc}},	//   _kipi, mlik_, lsbo, veme,
   {{0xa91d80d2,0x22403566,0x443a025b,0xdb055686}},	//   gažm, llik_, _jkp_, _sché,
   {{0x660457fe,0x443a107a,0xd25a838d,0x69c0ac02}},	//   _olik, _mkp_, нци_, teme,
   {{0x22403586,0x201a5dc2,0x79865b41,0x777a81c0}},	//   nlik_, lipi_, _jekw, wbtx,
   {{0x224001b0,0xdd8f8a47,0x79860135,0x2df781c6}},	//   ilik_, _رول_, _mekw, _עצמך_,
   {{0x69c0cb31,0x78a09f17,0x2240208e,0x79860133}},	//   seme, rumv, hlik_, _lekw,
   {{0x10370051,0x22406571,0x69c0c19b,0xf1bf00e1}},	//   רטים_, klik_, peme, ššie_,
   {{0xa3b0be98,0x25a6e572,0x628e209b,0x0f570039}},	//   ट्र_, ngol_, dsbo, טיים_,
   {{0x22406573,0x645e165c,0x25a907f1,0x628e1c11}},	//   dlik_, _bipi, _vcal_, esbo,
   {{0x66046574,0x443a03ac,0x22405e14,0x60000106}},	//   _elik, _ckp_, elik_, _sömn,
   {{0x645e059e,0x3ffb8158,0x22406575,0x66042c15}},	//   _dipi, _אפגע, flik_, _flik,
   {{0xdb0ae576,0x6fa70540,0x22406577,0xa7fb0661}},	//   lefó, _चाहू, glik_, _puño,
   {{0x48151052,0x80df00d4,0x30153a17,0x2d8b1620}},	// [65f0] амас, नमें, адар, mace_,
   {{0x645e6578,0x64468084,0x2d8b6579,0xdb0a8118}},	//   _gipi, _ūkin, lace_, nefó,
   {{0xf7700bbe,0x2240657a,0x764d657b,0xdb0a81ec}},	//   سال_, blik_, _khay, gefü,
   {{0x8f3783c8,0xe51686ae,0x79861384,0x248d368d}},	//   נטאג_, _देहि_, _gekw, šemu_,
   {{0x26d836c7,0xfce59170,0xa2bd9305,0x6385a1ae}},	//   _erro_, роло, _वैज्, агла,
   {{0x69cf270d,0xb09a0051,0x201a2f10,0x61ed28f2}},	//   _hace, _בישר, cipi_, ljal,
   {{0x2d8b657c,0x69cf3fbe,0x6d9c80e1,0x5fce109b}},	//   kace_, _kace, _sťaž, _होटल,
   {{0x61ed657d,0xe9d99485,0x69cf3f52,0xe516a5e8}},	//   njal, тки_, _jace, _देवि_,
   {{0x97c59bcc,0xade400d4,0x38af07c0,0xdb038036}},	//   айпе, गासन_, nür_, igné,
   {{0x764d02c1,0x66042cdb,0x22400182,0x998d8063}},	//   _ahay, _slik, zlik_, wień_,
   {{0x66040d38,0xb4de2ab7,0xf7459541,0xa3e2902e}},	//   _plik, णम्_, рено, धार_,
   {{0x69cf2509,0x645e657e,0x7bc3e57f,0x2d8b6580}},	//   _nace, _sipi, lenu, gace_,
   {{0x6e3b8010,0x32090079,0x7986022b,0x9f4a00e1}},	//   _mkub, dhay_, _rekw, _robí_,
   {{0x38af0059,0x7bc38074,0x656f047f,0x79866581}},	//   dür_, nenu, acch, _sekw,
   {{0x6e3bc40c,0x68fb8747,0x645e0010,0x7e6701c0}},	//   _okub, lyud, _vipi, _nujp,
   {{0x69260a42,0x38af3ea8,0x69cf6582,0x628e303e}},	//   амба, für_, _cace, rsbo,
   {{0xe8f7218c,0x22403586,0x65640578,0xdb1c188b}},	// [6600] алт_, rlik_, _igih, merí,
   {{0xdb1c040e,0x224013d6,0x60048247,0x32090079}},	//   lerí, slik_, _kòma, ahay_,
   {{0xa3e98768,0x69cf30cc,0x05669a1a,0x32460329}},	//   यान_, _face, авен, _венг,
   {{0x44386583,0x61ed46e9,0x320903ec,0xdb1c05e4}},	//   lor_, cjal, chay_, nerí,
   {{0xfbe2800d,0x25a687f1,0x0cd48d0e,0x8cd90ad5}},	//   पालम, rgol_, солю, मियो,
   {{0x69c40412,0x2d8b001b,0x7bc3e584,0x2c6b8b40}},	//   leie, zace_, genu, _død_,
   {{0x44208052,0x3f98808b,0x6b8a9c11,0xdb1c0187}},	//   đi_, órum_, rafg, lerâ,
   {{0x44385ea5,0xada38a94,0xdb1c0876,0x69cf01df}},	//   hor_, _масл, jerí, _xace,
   {{0x443804a6,0xdb1c0a96,0xed579b10,0x2d8b1620}},	//   kor_, derí, _вот_, vace_,
   {{0xdefa9006,0x61ed42ac,0x764d571f,0x7e60e585}},	//   вым_, zjal, _shay, _himp,
   {{0xdb1c1984,0x2d8b01d0,0x4fd900be,0x7e60e586}},	//   ferí, tace_, אַרד, _kimp,
   {{0xa5bb3cd4,0x7e6081b9,0x80a70035,0x7af78338}},	//   cnól, _jimp, टूडे, äxte,
   {{0x7e60859c,0x61e2de45,0x2d8b2014,0x614381f3}},	//   _mimp, _inol, race_, _деца,
   {{0x443831d1,0x69cf6587,0xa3e98107,0x7c38e588}},	//   gor_, _sace, याय_, novr,
   {{0x69cf6589,0xd8388db7,0x2d8b454c,0xa3ae946d}},	//   _pace, moč_, pace_, _कान_,
   {{0xdb1c05e4,0x3f8c8e2e,0x20180010,0x3f879fb6}},	//   cerí, ladu_, _amri_, _zenu_,
   {{0xa3d68f85,0x661d658a,0xa3e98f0a,0x3f87a486}},	// [6610] िया_, misk, याम_, _yenu_,
   {{0x320902a3,0x6e29aa81,0x38af080a,0x6e3be58b}},	//   shay_, _sjeb, rür_, _skub,
   {{0xe8e08028,0xb5fd817f,0xf1b98253,0xa3bc82f1}},	//   _đời_, _liše, liše_, ेजन_,
   {{0x661d03ab,0x201800f1,0xb7c600eb,0xd6d8658c}},	//   nisk, _emri_, _apģē, шту_,
   {{0x3d1195a7,0x81d580c8,0xf1b98253,0xd838807a}},	//   _देखे_, _সকল_, niše_, koč_,
   {{0x5f09852a,0x7c388da8,0x798d257a,0x00f604de}},	//   ानम्_, govr, laaw, _המשך_,
   {{0x569423e0,0xdb1c0e1b,0xa91d8084,0xe2a89ef7}},	//   _март, yerí, maži, لاين_,
   {{0x6e3b91e8,0x290d80ad,0x00858544,0xa3d903b7}},	//   _ukub, tzea_, блио, _ठोस_,
   {{0x7bc3b72d,0xfc3f12c9,0x4438658d,0x03c78009}},	//   penu, ntís_, yor_, _всем,
   {{0xa3ae853e,0x63ad8025,0xf1b980d2,0x4438658e}},	//   _काय_, đans, diše_, xor_,
   {{0xdb1c02ba,0x3f878036,0x798d3722,0x44f98264}},	//   terí, _venu_, kaaw, _অধিক_,
   {{0x661d0bfa,0x6443e58f,0x83fc8024,0x44386590}},	//   gisk, llni, _viđe, wor_,
   {{0xa3ae8a43,0x443849df,0xa91d9024,0x44278083}},	//   _काम_, tor_, kaži, onn_,
   {{0x2d9e1b97,0xd9e581ab,0xdd998176,0x9f430032}},	//   şte_, कावत_, _blňk_, _dojú_,
   {{0x4427bc69,0x09e611b3,0x443824c0,0xdb1c6591}},	//   inn_, бовн, ror_, derã,
   {{0xc332804c,0x63bb0025,0x661d1a22,0x3ea58957}},	//   פון_, đuna, cisk, mult_,
   {{0x44383804,0xe0da0a14,0xf1b9826c,0x69c46592}},	// [6620] por_, ыва_, ciše_, reie,
   {{0xa91da5ef,0x7e690353,0x25ad8087,0x69c412af}},	//   gaži, _čepr, _acel_, seie,
   {{0x6abe23fe,0x3ea58006,0x7e6091d6,0x8d1a803d}},	//   _uppf, nult_, _pimp, گزار_,
   {{0x6da6846e,0xad9b00f7,0xdb1c0722,0x60c98518}},	//   сида, thúi, merà, kwem,
   {{0x7c388025,0x78a40e67,0x91a6826b,0xb87b0032}},	//   tovr, quiv, _ako̟_, _aríf,
   {{0x3ea5a5d3,0x661d6593,0x6d40826f,0x20180010}},	//   kult_, zisk, _vyma, _umri_,
   {{0x7e60c909,0x6d40809a,0xbea30425,0xd2508077}},	//   _timp, _wyma, _нарк, ونت_,
   {{0x44278af9,0x30a69f3e,0xa07484fa,0x187495a6}},	//   ann_, бров, огич, огия,
   {{0xd8388d26,0x661d6594,0x050a00ab,0x3f8a01a1}},	//   toč_, visk, রপুর_, _kebu_,
   {{0xb5fd803b,0xf1b9803a,0x661d009a,0x224f8118}},	//   _više, više_, wisk, _ehgk_,
   {{0x661d4362,0x44270459,0x50d684c0,0x28cf000c}},	//   tisk, _ın_, _گزار, _सैनि,
   {{0xf1b98503,0xd838807a,0xa2d5952c,0x6f0901d0}},	//   tiše_, soč_, भिर्, _řeck,
   {{0x661d6595,0x2ca69ac4,0xdddb189e,0x05aa01d0}},	//   risk, nuod_, lptū, _कारब,
   {{0x661d02d7,0x3f8a00d2,0xf1b984a8,0x443e8d89}},	//   sisk, _nebu_, riše_, _jkt_,
   {{0xa3e9853e,0x201e973d,0xdb1a82af,0x6602e596}},	//   यात_, miti_, _natü, kkok,
   {{0x201eb30d,0x26df0052,0xdb1a8061,0x7a3e8168}},	//   liti_, _čuo_, _ható, pëtu,
   {{0x443ee597,0x3f8a005c,0xa5bb2e88,0x44279106}},	// [6630] _okt_, _bebu_, riód, ynn_,
   {{0xb76733c2,0x261b8074,0xfc3f0899,0x3f6718a3}},	//   стай, _मगही_, buía_, стаб,
   {{0x3f8a218d,0x6e2d026c,0xb87b3bfe,0xfc3f023e}},	//   _debu_, _kjab, _oríg, stís_,
   {{0x7afa224c,0xa9c70077,0x7bd54159,0x442c812b}},	//   ätte, _ازدو, ldzu, _ajd_,
   {{0x69a2800f,0x201ee598,0xd49bc64f,0xa91d8110}},	//   _गाजी, kiti_, уре_, paži,
   {{0x201e80ce,0x3eb30706,0x3f8a1600,0xdb188198}},	//   jiti_, ptxt_, _gebu_, kevä,
   {{0x59da9d01,0x81cc00c8,0x442781e4,0x93fc00be}},	//   _मोहर, লার_, rnn_, רלוי,
   {{0xdb1c037d,0x4095940b,0x1dd90576,0xdb1a8032}},	//   nerá, орот, _बोलत, _aató,
   {{0x6609ba48,0x201e8010,0x661b8280,0x7bc712ae}},	//   _ilek, fiti_, _imuk, keju,
   {{0xdb1a87a3,0x39438029,0x2d8f91e6,0x2ca080f7}},	//   _cató, ājs_, lage_, áide_,
   {{0x65c61287,0xa3d6a0d5,0x1dd5016f,0xbddb24df}},	//   обна, ियर_, धयंत, rlèn,
   {{0x26dc8067,0xed5a013a,0xd5aa016f,0x361600e8}},	//   _drvo_, ион_, _काळज, ієнт,
   {{0xdb1c6599,0x6609e59a,0x89378872,0x67d5a3d7}},	//   derá, _mlek, _اعضا, _моду,
   {{0x201e82a5,0xdb1c0722,0x2d8f80e8,0xbddb0036}},	//   citi_, terà, hage_, llèl,
   {{0x66098006,0xdd920117,0x8c431a34,0xe363035f}},	//   _olek, _ہوں_, фере, дкри,
   {{0x91e30d9e,0x66098870,0x3a290061,0xdb1c38b4}},	//   мосе, _nlek, gnap_, gerá,
   {{0x2bb2090a,0x2d8fe59b,0x81cc00ab,0xa7fb016a}},	// [6640] _जापा, dage_, লাল_, _zuñi,
   {{0x661b9efb,0x39420084,0xdfa601a8,0x7f8c83de}},	//   _amuk, _vyks_, تحري, ָנאַ,
   {{0x06ca1287,0x15fe0076,0xdb1c08a4,0x6609a120}},	//   ргей_, _उकार_, berá, _blek,
   {{0x201e812b,0x3f8a027f,0xdb1c188b,0x7c3c0c43}},	//   ziti_, _webu_, cerá, lorr,
   {{0x61e654e6,0x660280a4,0xb12480ab,0x3f8a059e}},	//   _inkl, rkok, _পর্ব_, _tebu_,
   {{0xe7ae8ebf,0x60048362,0x661bb328,0x38b44255}},	//   ज्ञप, _còml, _emuk, mär_,
   {{0x38b40884,0x3d1a8063,0xe8e08028,0xdb1a86a5}},	//   lär_, _मेरे_, _đối_, _rató,
   {{0x443e82f7,0x201e803d,0x7c3c0cdb,0x2d8f9dbd}},	//   _wkt_, witi_, horr, cage_,
   {{0x201e803a,0x6d4410af,0x7c3c659c,0x38b40884}},	//   titi_, _nyia, korr, när_,
   {{0xdb1c0a56,0x2d82067b,0x6e2d2ca2,0xb8f282f1}},	//   zerá, ebke_, _sjab, _हई_,
   {{0x443c824a,0x7c3c659d,0x38b40106,0xdb1ae59e}},	//   mov_, dorr, här_, _obté,
   {{0xae1609a3,0x443ce59f,0x200ce5a0,0x78b60110}},	//   दोलन_, lov_, shdi_, ktyv,
   {{0xdb1c016a,0x7bc7365d,0xdb18b568,0x7c3c65a1}},	//   verá, teju, sevä, forr,
   {{0x443ce5a2,0x61e60e3b,0xdb0565a3,0x7c3c0102}},	//   nov_, _ankl, _achá, gorr,
   {{0x2d8f82be,0x7bc72b40,0xf1b982ce,0xa2a2864a}},	//   yage_, reju, liša_, _गिफ्,
   {{0x38b400f2,0xceeb003d,0x200a65a4,0x7bc7588b}},	//   fär_, یران_, _albi_, seju,
   {{0x443c9fc2,0x7c3c19fd,0xf1b9842b,0xb5fd8b67}},	// [6650] kov_, borr, niša_, _niša,
   {{0xd6db0ae7,0x61e61be9,0x443c8038,0x661be5a5}},	//   ите_, _enkl, jov_, _smuk,
   {{0x2d8fe5a6,0xa3e9912a,0x443c824a,0x6609858f}},	//   tage_, यास_, dov_, _plek,
   {{0xd2468b76,0x38b400f2,0x24890a0f,0xe9df001c}},	//   _سن_, bär_, _kwam_, _chút_,
   {{0xd12680f7,0x2d8fe5a7,0x600d8020,0x27f84ec3}},	//   _أم_, rage_, _húme, _forn_,
   {{0x798be5a8,0x2d8fe5a9,0x60cd2479,0x6447276e}},	//   _segw, sage_, mwam, nlji,
   {{0x27e980ff,0x2c5d82d6,0x60c297c9,0x6e3d106f}},	//   _đan_, _jňdi_, _apom, kosb,
   {{0x661b82a0,0xa3e98424,0x83fc812b,0x7c3c0fe0}},	//   _umuk, याह_, _viđa, zorr,
   {{0x7e640009,0x443ce5aa,0xd24e84a3,0x64470796}},	//   _riip, bov_, دني_, klji,
   {{0x443ce5ab,0x798b9f2e,0x2a6c81a1,0x62955dea}},	//   cov_, _wegw, _fudb_, kszo,
   {{0xb8f28403,0xe7398185,0x2489372d,0x26158038}},	//   _है_, сен_, _awam_, sťou_,
   {{0xa3e985b3,0xbddb03d3,0x60cd1e7f,0x62955e59}},	//   याव_, blèm, kwam, dszo,
   {{0x7c3c65ac,0xa8798158,0x5fac016f,0x998d8035}},	//   torr, _פאַר, _चालल, zieś_,
   {{0x387fb4c3,0x987a810f,0x600d8118,0x64470353}},	//   mpur_, _האסט, _búme, glji,
   {{0x63bc8214,0x91e61ddf,0x09e600e8,0x61f981e0}},	//   _örne, пове, повн, _kowl,
   {{0x443ce5ad,0xfc3f0d76,0x78b60009,0x249f00eb}},	//   zov_, quín_, ttyv, šuma_,
   {{0x78a98020,0x7e7b26d2,0x7c3c65ae,0xdb0a83a7}},	// [6660] nuev, _čupa, porr, lefô,
   {{0x443c8069,0x81cc00c8,0x13a80416,0xa3d403a4}},	//   xov_, লাই_, _بندی_, _सोच_,
   {{0xe9df0028,0x443c875f,0x290000b9,0x78b60198}},	//   _phút_, vov_, syia_, styv,
   {{0xe7e28074,0x2bca20f2,0xb5fd811f,0x7d0682f1}},	//   _कोना_, ाजवा, _piša, _üksk,
   {{0x443c9fc2,0xe516a743,0xdd8f8199,0x798463ea}},	//   tov_, _देखि_, اوه_, mbiw,
   {{0xb5fd811f,0x25bfc411,0xf1b99024,0xa7fb63ab}},	//   _viša, _ebul_, viša_, _buñu,
   {{0x443ce5af,0x60c2beaf,0x6458be5b,0x78a40a53}},	//   rov_, _spom, rmvi, lriv,
   {{0x443ca39f,0x30a68a7c,0xb5fd807a,0x64471809}},	//   sov_, пров, _hišn, zlji,
   {{0x61f982c1,0x443c886f,0xb5fd812b,0x3ebf025b}},	//   _dowl, pov_, _kišn, _ćuti_,
   {{0xdb1e05a4,0x6e98997b,0xdcef01a9,0x779280b7}},	//   _japó, овор_, sacī, ریبا,
   {{0xa3e980cf,0x6f01831d,0xbb4a9368,0x61f9e5b0}},	//   यार_, gylc, _الان_, _fowl,
   {{0x6e22b49a,0x6a168872,0x60cd0035,0x61f981b9}},	//   niob, _عبار, ywam, _gowl,
   {{0x7e6e022c,0x35470c99,0x78a98144,0x6e3d0061}},	//   _lubp, яхов, cuev, rosb,
   {{0x78a403a6,0x2bb2016f,0x394682c4,0x62950061}},	//   driv, _जाणा, _iyos_, tszo,
   {{0x9f5800f1,0x7ac41b23,0x897a0135,0x60cd0300}},	//   _dorë_, нсте, _ọgụg, wwam,
   {{0x7afa016d,0x3ce04741,0x6447007a,0x60cd65b1}},	//   ätta, _friv_, slji, twam,
   {{0x69340db6,0x62950019,0xe1340048,0x660d568b}},	// [6670] енту, sszo, енты, _ilak,
   {{0xb87b01ac,0xf7701a3c,0xdb1e2509,0x60cd020c}},	//   _príb, هام_, _capó, rwam,
   {{0x2bb22539,0x6d41017b,0xdb1c01ec,0x59f90098}},	//   _जाता, şlad, gerä, _деня_,
   {{0xe0df0028,0x78a462b9,0x442365b2,0x64418ffe}},	//   _trò_, briv, lij_, _skli,
   {{0x78a41621,0x660d5f82,0xa3ae8105,0x20cd025b}},	//   criv, _mlak, _काश_, _uži_,
   {{0xe9df0174,0xb4ad81d2,0x44230e8b,0xce6b060a}},	//   _thús_, _कमी_, nij_, _град_,
   {{0x80db0592,0x660d003a,0xa3ae9a87,0x394696fb}},	//   निवे, _olak, _कार_, _ayos_,
   {{0x44230069,0x2ca08267,0xdb1c041c,0x00e59d7b}},	//   hij_, šida_, serç, джин,
   {{0x9f5e8013,0x81cf80ab,0x200e0084,0xdcfb80d7}},	//   chtú_, শাল_, škių_, _ارزش_,
   {{0x660d65b3,0x22491600,0xdb1e01df,0xb5fd8668}},	//   _alak, hlak_, _xapó, _kišo,
   {{0xe5a60dc8,0x6da618f6,0x660d5660,0x60c48029}},	//   мини, мина, _blak, _ģime,
   {{0x3f9c826c,0x387fbac5,0xb8050264,0x63ad8326}},	//   _edvu_, ppur_, োচিত_, ɗana,
   {{0x224902d5,0x44233e6b,0x21010110,0x2bb202f1}},	//   dlak_, fij_, nčią_, _जादा,
   {{0xb05b00f2,0x660d2388,0x442301c8,0x9f580242}},	//   _spän, _elak, gij_, _forè_,
   {{0x81b480ab,0xbb430b69,0x3f85e5b4,0xa3ae86ae}},	//   _ছোট_, верк, mblu_, कलत_,
   {{0x78a40012,0xa3e982b4,0x3cee835a,0xc332836b}},	//   triv, याँ_, _आपले_, דול_,
   {{0xa3ae9094,0x7e7c005c,0x44234191,0x2bae816f}},	// [6680] _काल_, _strp, bij_, _घाला,
   {{0x44230db7,0xa5bb04c3,0x60048014,0x7d02804f}},	//   cij_, nión, _còmh, vyos,
   {{0x44441dbe,0xb5fd8301,0x216a0652,0x22493d9b}},	//   _ik_, _višn, _мини_, blak_,
   {{0x78a4003b,0xe9d9809a,0xa3e60beb,0x7bc1e5b5}},	//   priv, jdź_, फाक_, _ablu,
   {{0xa3e9c252,0x444465b6,0x09bc80c8,0x6e229e3f}},	//   यां_, _kk_, _অফলা, riob,
   {{0xfc3f062f,0x444465b7,0x7d02b3ef,0x6aaade97}},	//   oría_, _jk_, ryos, tuff,
   {{0xb87b65b8,0x2bc00519,0x7e7c1b40,0xa06751e2}},	//   _tríc, श्या, _utrp, _цара_,
   {{0x44443463,0x6aaa9bea,0x44232c00,0x3f8e8b80}},	//   _lk_, ruff, zij_, _sefu_,
   {{0xb5fd8025,0x6aaaddf5,0x2d86c54d,0xfa1c027d}},	//   _mišl, suff, mboe_, _đất_,
   {{0x444465b9,0x224921a2,0x764447fe,0xa3e9e5ba}},	//   _nk_, zlak_, _akiy, याः_,
   {{0xe8e08028,0x2fd854fb,0xf8ab0fea,0x7c3d81fa}},	//   _đổi_, _marg_, _चम्प, _ísra,
   {{0x444465bb,0xfc3f05b4,0x2fd8376c,0xb5fd8279}},	//   _ak_, dría_, _larg_, _nišl,
   {{0x442365bc,0x7afa00f2,0xfc3f0333,0x224909ff}},	//   tij_, ättn, ería_, vlak_,
   {{0xa5bb492f,0x3fd900ab,0x68e28019,0xfc3f0333}},	//   ción, _দক্ষ, _irod, fría_,
   {{0x444465bd,0x44232c00,0xfc3f05e4,0x27ed001c}},	//   _dk_, rij_, gría_, _đen_,
   {{0x44442674,0xb5fd826c,0x7bd70079,0xa3e58beb}},	//   _ek_, _rišo, _waxu, _बोन_,
   {{0xdb0502af,0xa3ae8744,0xfc3f0511,0x224965be}},	// [6690] _schä, कला_, aría_, rlak_,
   {{0xfc3f05a4,0xb87b2509,0x68e2e5bf,0xb5fd811a}},	//   bría_, _cría, _mrod, _pišo,
   {{0x23d98af3,0xdb1c032b,0x2904951e,0x60048722}},	//   _योगद, terå, hyma_, _còmi,
   {{0x68e2d1f4,0x1cb98013,0xa01b1252,0x78a2027f}},	//   _orod, كاتب_, _stöd, šova,
   {{0x629ae5c0,0xe00e835a,0x2fd80314,0xdb0983fb}},	//   _avto, िसाद_, _farg_, čníc,
   {{0xa5bb04c3,0x444465c1,0xe9d9809a,0x2fd85b9c}},	//   xión, _xk_, wdź_, _garg_,
   {{0x4429803a,0x7c23b6c0,0xbb429a19,0xaad8001b}},	//   đa_, rinr, лешк, डिएक,
   {{0x68e2812b,0xe7d7ce09,0x656d01d4,0x200eab78}},	//   _brod, _भोजप, _ngah, _alfi_,
   {{0xa5bb0118,0x61fd1c11,0x78ad12d0,0x44211995}},	//   tión, _mosl, nuav, _omh_,
   {{0x6445022c,0xb5fdb1a7,0x61fd1254,0x656d00b4}},	//   _nkhi, _mišm, _losl, _agah,
   {{0xf6260951,0x68e2ba65,0x99918019,0x3f910102}},	//   едно, _erod, őző_, _mezu_,
   {{0x444433e6,0x644514ec,0xa5bb062f,0x61fd0029}},	//   _sk_, _akhi, sión, _nosl,
   {{0x8fa5baca,0x78ad1ae3,0x657b8db1,0x68e2e5c2}},	//   _зале, juav, _mfuh, _grod,
   {{0x7e698df1,0x69d9c584,0xfc3f05e4,0xb5fd817f}},	//   _liep, _hawe, tría_, _sišl,
   {{0x42560f13,0xa5bb2a63,0x69d99588,0x48bf00ab}},	//   етат, gnós, _kawe, উটোর,
   {{0xe7ed85b3,0x7e69809a,0x78bb81e2,0x69dbd15d}},	//   जावा_, _niep, otuv, ndue,
   {{0x78bb81bb,0x98a30103,0x16c8140d,0x656d80e1}},	// [66a0] ntuv, лите, रब्ब, ľahl,
   {{0x7d060009,0x69d98114,0x657b819d,0x44440039}},	//   myks, _lawe, _afuh, _uk_,
   {{0xa3e988fd,0x39ea1927,0xb4e892ce,0x7bce03af}},	//   याई_, _едно_, यम्_, mebu,
   {{0x69d9cbe9,0x186a11d2,0x32090358,0x7bdc0c42}},	//   _nawe, _нами_, ckay_, ldru,
   {{0x7e6980c9,0x2fd806da,0x2d923753,0xdb15016a}},	//   _diep, _targ_, _meye_, bezó,
   {{0x7bdc2ed0,0x6e260a0f,0x229a80eb,0x6298e5c3}},	//   ndru, hikb, tīk_, tsvo,
   {{0x68e28503,0x69d9e5c4,0xada6d22f,0xe805016f}},	//   _srod, _bawe, _павл, _शकता_,
   {{0x20bd8063,0xd25787ac,0x7bce65c5,0x6298844e}},	//   ्बंध, нцы_, hebu, rsvo,
   {{0x7bce65c6,0x600d88f1,0x24800069,0xe3b282e3}},	//   kebu, _súma, _ntim_, _مرا_,
   {{0x25a00886,0x61eba1cd,0x76428079,0x4c9b8039}},	//   _adil_, _engl, looy, _משמע,
   {{0x8f34879e,0x91e68a7c,0xddc78353,0x442109da}},	//   тенц, _поже, _hujš, _rmh_,
   {{0x7bdae5c7,0xa5bb0207,0x68e28f06,0x69d9c9a2}},	//   _hatu, ciól, _trod, _gawe,
   {{0x7bdabbc2,0x68e2809a,0x61fd65c8,0xb87b65c9}},	//   _katu, _urod, _rosl, _arín,
   {{0x7bda8057,0x25a0016a,0x7bce07c1,0x69d9e5ca}},	//   _jatu, _edil_, gebu, _zawe,
   {{0x7bdae5cb,0x8ff78bca,0x53340190,0x69d99f62}},	//   _matu, _سرور_, герт, _yawe,
   {{0x7bdae5cc,0x80ca00ab,0xfc3f0118,0x79964500}},	//   _latu, রিন্, crín_, gayw,
   {{0x7e699c5d,0x97a722b7,0x32090079,0x9c390081}},	// [66b0] _riep, ерел, rkay_, _опит_,
   {{0x60db00d2,0x320906c0,0xc02e801c,0x442100b9}},	//   _šums, skay_, _điệu_, _umh_,
   {{0x7e69e5cd,0x4fc40110,0x2d92022e,0x69cd65ce}},	//   _piep, ыста, _yeye_, peae,
   {{0xc8a91513,0x78bb8110,0x7bda9761,0xa64782e3}},	//   _छटपट, ytuv, _aatu, رخان,
   {{0x7bda8559,0x3f910042,0x629a016b,0xddc08087}},	//   _batu, _tezu_, átov, _simţ,
   {{0x7bda8d6d,0x99dd801b,0x69d98077,0xfaa59a36}},	//   _catu, plňk, _sawe, вако,
   {{0xf7718bca,0x629a070d,0x7e69b64f,0x764281b4}},	//   یاد_, štov, _tiep, booy,
   {{0xb5fd92b9,0xf99f0247,0x7c2715e8,0x7bce009a}},	//   _mišk, _elèv_, hijr, zebu,
   {{0x69db811e,0x7bdae5cf,0x290b81ac,0x78bb97ae}},	//   rdue, _fatu, áca_, utuv,
   {{0xa2a98cce,0x7bdaac22,0x78bb9482,0x69d980b8}},	//   _टिप्, _gatu, rtuv, _wawe,
   {{0x4427e5d0,0x6443a536,0x78bb8b0c,0xb5fd8279}},	//   min_, moni, stuv, _nišk,
   {{0x644385e7,0x7d060364,0x442780ef,0x61ebe5d1}},	//   loni, tyks, lin_, _ungl,
   {{0x64438006,0xed57035f,0x44278ad0,0x51848329}},	//   ooni, кою_, oin_, _суха,
   {{0x4427e5d2,0x6443e5d3,0x8fa58bba,0xb87b65d4}},	//   nin_, noni, _раке, _prín,
   {{0x7bdc044e,0xb5fd8353,0xae1f102e,0x78a9b3f9}},	//   rdru, _višj, मोहन_, lrev,
   {{0x7bce04bf,0x6443e5d5,0xb87b00f7,0x7ae5012b}},	//   sebu, honi, _crío, _drht,
   {{0x4427e5d6,0xf992893f,0x41271927,0x6443a397}},	// [66c0] kin_, ירן_, вото_, koni,
   {{0x6443af1e,0x4427e5d7,0x6d5600b9,0xb87b01a8}},	//   joni, jin_, _izya, _trín,
   {{0x78a98a0f,0x76428079,0xb87b1eec,0xaad080c2}},	//   hrev, tooy, _frío, _थैंक,
   {{0xf53f0bbd,0x225f8748,0x6ea488af,0x78a9a7d1}},	//   mgår_, jmuk_, _किसु, krev,
   {{0x4427e5d8,0xa3ae8074,0x764281b4,0xcd7703de}},	//   fin_, कलल_, rooy, דענק_,
   {{0x625307fa,0x78a9a7f2,0xe1f98110,0xc44880d7}},	//   nçon, drev, ejų_, ریان_,
   {{0x3cee8063,0x224d808e,0xd25a89a0,0xf53f004a}},	//   _आपके_, flek_, мци_, ngår_,
   {{0x7bda822e,0x44278068,0xc3330158,0x76428079}},	//   _watu, ain_, יוו_, qooy,
   {{0x4427ab89,0xdfd08307,0xd83a8084,0x6443e5d9}},	//   bin_, مية_, дэн_, boni,
   {{0x44278a73,0xad1b8051,0x224de5da,0x212be5db}},	//   cin_, _חומר, alek_, úcha_,
   {{0xa3c81513,0x645a8214,0x201980f1,0x224da168}},	//   ोजन_, _ihti, ësia_, blek_,
   {{0x78a98646,0xf53f006a,0xe7e28c28,0xd3788390}},	//   brev, dgår_, _कोरा_, _daće_,
   {{0x78a980a9,0x660085f5,0xf1b38039,0xd01aa1ae}},	//   crev, _momk, _כסף_, _офк_,
   {{0xb5fda52d,0x9f589931,0x3cf5816f,0xa3a404ae}},	//   _pišk, óró_, ्हते_, ијск,
   {{0x2bc49cd4,0xdb2307d9,0xb87b0013,0x442d003a}},	//   ल्या, _ürün, _prío, đe_,
   {{0x9f5c8a56,0x5a340cd0,0xb5fd80ce,0x6443bc95}},	//   _nové_, анст, _višk, zoni,
   {{0x4427e5dc,0x2d9965dd,0x995555e6,0x9f58046d}},	// [66d0] yin_, mase_, укац, _dorí_,
   {{0x4427e5de,0x4427360f,0x6d4d65df,0x2bc48105}},	//   xin_, _ön_, _iyaa, ल्मा,
   {{0x4427e5e0,0x6d4d008e,0x62670eca,0x2a6001c0}},	//   vin_, _hyaa, _لاحق, bmib_,
   {{0x6443e5e1,0x4427b4b1,0x2af2001b,0x6d4d0c2e}},	//   woni, win_, ीहरु_, _kyaa,
   {{0x2bc0053f,0x44278e79,0x61ef3f55,0x62818267}},	//   श्वा, tin_, _incl, _stlo,
   {{0xe7e280c2,0x2d9965e2,0x1c4485a8,0x4427e5e3}},	//   _कोला_, hase_, анім, uin_,
   {{0x44278788,0x69dd65e4,0x6443b09c,0x63b501a9}},	//   rin_, _kase, roni, igzn,
   {{0x4427a776,0x645ae5e5,0xe0d996cf,0xda13001b}},	//   sin_, _ehti, еви_, ठसित_,
   {{0x69dd65e6,0x44279b7b,0x224da203,0x6d4d3371}},	//   _mase, pin_, rlek_, _nyaa,
   {{0x69dd3553,0x4427c4e2,0x7d048364,0x224de5e7}},	//   _lase, qin_, äise, slek_,
   {{0x6d4d02a3,0x61ef4f42,0x765b8028,0x63b8016d}},	//   _ayaa, _oncl, _khuy, _övni,
   {{0x69dd00fa,0x6d4105c5,0x7c250013,0xb87b01ac}},	//   _nase, ğlan, _amhr, _príl,
   {{0x6d410182,0xa0a58084,0xe8eeb45a,0x10a5891e}},	//   şlan, _салд, _ул_, _силн,
   {{0x44258358,0x61ef1726,0xb87b01ca,0x6d4d02c4}},	//   _jml_, _ancl, _crím, _dyaa,
   {{0x69dd4a4c,0xdceb81b9,0x2fc782c4,0x6253360c}},	//   _base, bagħ, _ibng_, rçon,
   {{0xb5fb0e14,0xceb28051,0x61fbe5e8,0x7e6d31c1}},	//   rmác, _היה_, njul, _giap,
   {{0x57ea0254,0x76460084,0x62530866,0x6d4d03f7}},	// [66e0] ндам_, moky, pçon, _gyaa,
   {{0x67160a14,0xb90c8032,0x61fbe5e9,0x7649caf5}},	//   льеф, _aimọ_, hjul, _akey,
   {{0x2c6f04b7,0x55e690ca,0x2ca0006a,0x7bde09da}},	//   _iżda_, ложб, _hvid_, _iapu,
   {{0x765b8142,0x442a65ea,0x69dd65eb,0x7bde65ec}},	//   _chuy, lib_, _gase, _hapu,
   {{0x7bde5094,0xa4268e02,0x7bc381ec,0x80d386a7}},	//   _kapu, лькл, ffnu, _बैले,
   {{0x442a65ed,0x69dd65ee,0x2d9904c3,0xf74615ac}},	//   nib_, _zase, zase_, _бего,
   {{0x7bde4032,0x68e412bd,0x0cb1326f,0x69dd1167}},	//   _mapu, lvid, _जम्म, _yase,
   {{0x2d994a25,0x69c41ed4,0x7bde4f25,0x442a65ef}},	//   xase_, nfie, _lapu, hib_,
   {{0x68e44d2c,0x442a65f0,0x48149baa,0x13b6803d}},	//   nvid, kib_, имис, _مصاح,
   {{0x7e6d1a67,0x442a07d5,0xa3ae800f,0xd07381a8}},	//   _siap, jib_, _काट_, حديث,
   {{0x2d994774,0x6306af0a,0x6fc6035a,0x442a2b95}},	//   tase_, _حوال, र्यं, dib_,
   {{0x90e68f24,0xb5fd8805,0x7bde02d5,0x3f9a01bc}},	//   _مستن, _piši, _aapu, hapu_,
   {{0x2d9965f1,0xa3e9835a,0x2ed11250,0x69dd17ab}},	//   rase_, याच_, _सन्त, _rase,
   {{0x68e40395,0x7bde65f2,0x2d99002a,0xb5fd8353}},	//   dvid, _capu, sase_, _viši,
   {{0x3a291a67,0x2d991c56,0x7bde0057,0x179784de}},	//   tiap_, pase_, _dapu, _גדול_,
   {{0x69dd2d68,0x59df2743,0xb5fd8968,0x2bc48035}},	//   _qase, _पोखर, _tiši, ल्ता,
   {{0x442a65f3,0x69dd47d4,0xaca3801c,0x290f2491}},	// [66f0] bib_, _vase, _trứn, ága_,
   {{0xf1b9b69f,0x69dd3f60,0x3a2900dd,0x7bde00d7}},	//   riši_, _wase, siap_, _gapu,
   {{0xa3ae82f1,0x69dd2446,0x76b9002e,0x09ac80ab}},	//   _काज_, _tase, тлер_, ক্যা,
   {{0x7bc8e5f4,0x3ce90082,0xf1b9a7b1,0x644765f5}},	//   _abdu, _krav_, piši_, loji,
   {{0x798d4492,0x44258358,0x563800be,0x7ae381c0}},	//   mbaw, _pml_, נאדע_, wvnt,
   {{0x64470bb6,0x3ce900d2,0xb5fdac08,0xab298993}},	//   noji, _mrav_, _nišv, кола_,
   {{0x765b801c,0x3d958a7c,0x628508ae,0xf10d852a}},	//   _thuy, _вибр, _jtho, िन्द_,
   {{0x442a1086,0x64470010,0x0205a796,0x212b8187}},	//   zib_, hoji, рзин, úcho_,
   {{0x20030025,0x442a1072,0x3ce901c0,0x644765f6}},	//   _koji_, yib_, _nrav_, koji,
   {{0x442a65f7,0xb87b01ac,0x644700a4,0x600982de}},	//   xib_, _príj, joji, тном_,
   {{0xe7399927,0x64471d57,0x7bde365d,0x6285022c}},	//   тен_, doji, _rapu, _ntho,
   {{0x25e603dd,0x200303ac,0x6e2b846d,0x60168187}},	//   _जोशी_, _loji_, nigb, _câmb,
   {{0x7bde048c,0x32020efc,0x628565f8,0x7646472c}},	//   _papu, _roky_, _atho, roky,
   {{0x78ad2944,0x92d780ab,0x6447588d,0xd3788bda}},	//   drav, ামী_, goji, _kaća_,
   {{0x442a65f9,0xeb97117e,0xe2970087,0x7bde18d5}},	//   rib_, рис_, иар_, _vapu,
   {{0x442a5abd,0x660f11ee,0x224b008e,0x99dd816b}},	//   sib_, ckck, _ckck_, plňu,
   {{0x69c420e3,0x3ce92823,0x2ca00052,0xa3d5e5fa}},	// [6700] rfie, _grav_, _uvid_, िजा_,
   {{0x8fa610f8,0x68e4186c,0x644765fb,0x07a611b1}},	//   раже, rvid, coji, ражн,
   {{0x81cb0a49,0x6b9c0e56,0x23fb04de,0x799b876d}},	//   লয়_, marg, _ספטמ, kauw,
   {{0x3f9a65fc,0x38710088,0x68e408dc,0x1a9b03de}},	//   sapu_, _žorž_, pvid, _ביטע,
   {{0xf1b981dd,0x2ca080f7,0x78ad0ba3,0x59df0075}},	//   nišu_, éid_, crav, _पोटर,
   {{0x66e60698,0xdb1c0019,0x8aa6af75,0xfaa69ac9}},	//   _кога, kerü, арид, ашин,
   {{0xbea3013a,0x7c2aa67f,0x28ac03eb,0xc7a3242e}},	//   _марк, rifr, _चिडि, _фиск,
   {{0x6b9c085c,0x3f9802f7,0x4aa780d4,0xc4868ae7}},	//   harg, _heru_, _गिरव, _влак,
   {{0x6b9c1ad1,0x6447004f,0x9a6781a8,0xc9148264}},	//   karg, yoji, جميل_, াপ্ত_,
   {{0x6016802e,0xf806a503,0x66040362,0x3f980326}},	//   _sâmb, рчин, _aoik, _jeru_,
   {{0x08570051,0xd6d78278,0x6d41017b,0xb87b00e1}},	//   שבים_, атя_, ğlam, _prík,
   {{0x3ce90db7,0x47dc80ab,0x6d41017b,0xf1b98b80}},	//   _prav_, বাধী, şlam, fišu_,
   {{0x644765fd,0x0ca48035,0x6b9c0625,0x66040f3e}},	//   toji, _ऑटोम, farg, _doik,
   {{0x224b008e,0x78a281a1,0x6b9c47f7,0xddc401a1}},	//   _skck_, _ivov, garg, _viiš,
   {{0xda78001e,0xbebc8029,0xdb1c4640,0x99dd826f}},	//   ият_, dzīg, deró, plňt,
   {{0x78ad65fe,0x52141ccf,0x200304b9,0x3ce92417}},	//   trav, одст, _soji_, _trav_,
   {{0x6b9c0876,0x798d1067,0x644705b9,0x443a00b9}},	// [6710] barg, rbaw, poji, _fjp_,
   {{0x6b9c1f5c,0x96da83bb,0x3ea706a5,0xb5fd816b}},	//   carg, _बनाउ, ánto_, _lišt,
   {{0xfc3f04c3,0x8ae4035f,0x628565ff,0x9f5803a8}},	//   buír_, _діял, _utho, _porá_,
   {{0xb5fd803a,0x7d0b816d,0x26c10176,0x09ac80ab}},	//   _ništ, tygs, rtho_, ক্তা,
   {{0x26c1010c,0xdb1c016a,0xd37880c3,0x2249011b}},	//   stho_, beró, _saća_, moak_,
   {{0xda78826f,0xb87b0118,0x7982826b,0x5fc603eb}},	//   _buď_, _asíg, _afow, र्दल,
   {{0x9f5c87f1,0x60cf09c4,0x9f580c1d,0x7a3e8ec3}},	//   _boví_, _hpcm, _torá_, zīte,
   {{0xe9d9a341,0x7c28c22a,0xb5fd817f,0x22490102}},	//   уки_, _emdr, _pišu, noak_,
   {{0x6e29b86c,0x600de600,0x2bc4816f,0x7bc70267}},	//   _imeb, _húmi, ल्हा, kfju,
   {{0x4394b160,0x764d2bd7,0xaffe80ff,0x2d9db328}},	//   _маус, _akay, _phướ, lawe_,
   {{0x224900ad,0xb5fb0065,0x66040364,0x2eb68aec}},	//   koak_, rmán, _poik, _अमृत,
   {{0xf4090451,0x645e020f,0x6b9c003d,0xa01b18b6}},	//   _אפ_, _shpi, warg, _stöl,
   {{0x308580f7,0x66040198,0x443a008e,0x6e298135}},	//   _التف, _voik, _pjp_, _mmeb,
   {{0xf1b98da8,0xaffe801c,0x2d9d80b4,0x16040072}},	//   rišu_, _thướ, hawe_, _लवकर_,
   {{0xfc3f01df,0x2d9de0d6,0x6b9c6601,0x22491fa4}},	//   tuír_, kawe_, rarg, foak_,
   {{0x3f98105a,0xf1b98042,0x6b9c16b5,0x22490102}},	//   _seru_, pišu_, sarg, goak_,
   {{0x51560991,0x1b2000ab,0x6b9c6602,0xfc3f03a8}},	// [6720] ству, _মুখে_, parg, ruír_,
   {{0x3cfb04de,0x6e29e603,0x3a2d80ff,0xfc3f03a8}},	//   _עלינ, _ameb, hiep_, suír_,
   {{0x3f984e30,0x3879026c,0x6d5bad2a,0xe9ff80ff}},	//   _veru_, _eusr_, _azua, _ngắm_,
   {{0x7c2e3e45,0xe5a38adb,0xceb28158,0xb05b2603}},	//   libr, зици, ליב_, _spät,
   {{0xdd998038,0x69d60214,0x6e3b8390,0xa5bb0825}},	//   _deň_, meye, _djub, miót,
   {{0x69cb8352,0x69d60214,0x61e46604,0x6e3baf00}},	//   _abge, leye, ldil, _ejub,
   {{0x8ae6804a,0x81e18264,0xb05b062c,0x8cda066f}},	//   сілл, দান_, _epäs, _पैसो,
   {{0x61e44f89,0x69d66605,0x8f370833,0xb5fb01fa}},	//   ndil, neye, _האלו_, gmál,
   {{0xdb0502af,0xd90e815b,0x7c2e008e,0x79998197}},	//   _schü, عیت_, kibr, _deww,
   {{0x4734a4c8,0x765f0168,0x22490102,0xa2088380}},	//   жнос, _shqy, zoak_, ılış_,
   {{0x661d00f1,0x60c40406,0x601683a7,0x644ae606}},	//   ërko, htim, _câma, mofi,
   {{0x442e8850,0x0f570039,0x63a8808e,0x6b9ae607}},	//   lif_, מיים_, _hddn, _hetg,
   {{0x60c400f1,0x61e46608,0x7bd56609,0xdb05010c}},	//   jtim, ddil, tezu, _idhé,
   {{0x4adc9d01,0xdb0500f1,0x9f5e80f1,0x4e93803d}},	//   _मनाव, _udhë, njtë_, _کشور,
   {{0x3f9e8778,0x1dc8e60a,0x60c40110,0x6b9ae60b}},	//   matu_, रभात, etim, _metg,
   {{0x53340991,0x3f9e811e,0x60c40168,0x644ae60c}},	//   чест, latu_, ftim, hofi,
   {{0x60c4660d,0x62532f69,0x22490102,0x61e294f2}},	// [6730] gtim, nçoi, roak_, _maol,
   {{0x3f9ee60e,0x24890748,0x61e2e60f,0x22490102}},	//   natu_, _itam_, _laol, soak_,
   {{0x7ac71285,0xa3e21a3b,0x442ec818,0x69d62b5f}},	//   _успе, _नोट_, dif_, beye,
   {{0x3f9ea03c,0xdebb83c8,0x6aa1007b,0x3f8101e4}},	//   hatu_, רמאל, álfu, schu_,
   {{0x3f9e811e,0xcc340065,0x644a84b9,0x789302e3}},	//   katu_, _ذریع, fofi, _ریاض,
   {{0x2bc4800d,0xd7fb00a9,0xdb0500e7,0x644a8428}},	//   ल्ला, _сум_, _adhé, gofi,
   {{0x61e2e610,0xdc380158,0xb4d61e0b,0x3f9e811e}},	//   _baol, זאגט_, _सन्_, datu_,
   {{0x20c28125,0x6e298c5a,0x61e28c41,0x80a9b750}},	//   fði_, _umeb, _caol, авив_,
   {{0x20c28125,0xb5fb0375,0x644aaf70,0x248901c0}},	//   gði_, rmál, bofi, _ntam_,
   {{0xbebc8029,0xd82580e8,0x3f9ed522,0x764babf0}},	//   dzīb, ідни, gatu_, logy,
   {{0x61e28f35,0x09c380c8,0xee3a0468,0x02d987d2}},	//   _faol, ্যবা, ино_, _خواب_,
   {{0x92b4804e,0x61e281a8,0x69c912c6,0x3cede611}},	//   _رحما, _gaol, _हॉली, _krev_,
   {{0x8fa5975e,0x95561b9a,0x3f9ee612,0xdb0a8106}},	//   _дале, تخدا, batu_, uffö,
   {{0xf1bf0e1b,0xdb1c007b,0x3f9ee613,0x69c9844e}},	//   _acá_, ferð, catu_, lfee,
   {{0xdb1c0125,0xcb6a5488,0x69d60214,0xe7e29a87}},	//   gerð, раве_, teye, _कोटा_,
   {{0x60c415a6,0x661d0865,0x20078102,0xe9da0dc7}},	//   ttim, chsk, _honi_, јка_,
   {{0x20078e80,0xd910026a,0xe8fa0721,0x69d66614}},	// [6740] _koni_, ریس_, шла_, reye,
   {{0x2f5600ae,0xe29a0b30,0x998901ac,0x7afa0106}},	//   отес, _као_, vnať_, ätts,
   {{0x764bade8,0x20078198,0x69d603ec,0x25bf8362}},	//   fogy, _moni_, peye, _bcul_,
   {{0x2007b649,0x60c46615,0x3ced8370,0x3f9edbe2}},	//   _loni_, ptim, _brev_, zatu_,
   {{0x973c8024,0x64a3974a,0x16b6825e,0x68e9d6a6}},	//   maće, дача, _अम्ब, jved,
   {{0x973c8024,0x70d900be,0xdb1c007b,0xb87b00e1}},	//   laće, _פֿרו, rfræ, _prív,
   {{0x644ae616,0x61e2e617,0x69c9d778,0x6b9a9c11}},	//   rofi, _paol, ffee, _vetg,
   {{0x30a69631,0x9f5c8efc,0x3f9ee618,0x6b9a8cfa}},	//   оров, _nová_, watu_, _wetg,
   {{0x3f9ee619,0xdcf88065,0x644a804f,0xd7fab93f}},	//   tatu_, _دہشت_, pofi, аун_,
   {{0x20c287ca,0x2018bfd9,0xaaab0424,0x973c8bda}},	//   rði_, óri_, _छिलक, haće,
   {{0x3f9ee61a,0x09ac80c8,0x8f7b012a,0xdb188006}},	//   ratu_, ক্ষা, יניק, tevõ,
   {{0x3f9ee61b,0x7e7c3140,0xdb1c007b,0x973c8b67}},	//   satu_, _murp, verð, jaće,
   {{0x3f9eaf39,0x9ccb0196,0x973c8088,0x91368019}},	//   patu_, шына_, daće, _براؤ,
   {{0x224982a5,0x68fb0722,0x3ceb852a,0x7bd882f1}},	//   čake_, _àudi, चिते_, nevu,
   {{0x442c8915,0x799f0d92,0x5fb78039,0x764bb7c0}},	//   _mmd_, taqw, _והוא_, yogy,
   {{0x20078668,0x25a90102,0x973c812b,0xe1ff002a}},	//   _zoni_, _udal_, gaće, _riós_,
   {{0x7afa016d,0xa01b016d,0x64400018,0x442c8176}},	// [6750] ättr, _utök, émic, _omd_,
   {{0x6aa10125,0x478b0fbf,0x2007008b,0x7bd881d0}},	//   álfs, рсам_, ðni_, jevu,
   {{0x44310459,0x7bd8e2f1,0x80a703eb,0xb87b0580}},	//   miz_, devu, _चिके, _arít,
   {{0x3f9ca46f,0xb87b026b,0x3cfd822c,0x27e30326}},	//   _levu_, _brít, txwv_, _wajn_,
   {{0x443eb204,0xb5fd8115,0xe0df0037,0xb4c902f1}},	//   _bjt_, _dišp, _usò_, _ईहो_,
   {{0x443136d4,0x7bd8e61c,0x68e9ad5e,0x69c98299}},	//   niz_, gevu, vved, wfee,
   {{0x4ea41ddf,0x659581e2,0x60d9007e,0x7e7c0cdb}},	//   _орта, _наву, şamı, _gurp,
   {{0x2007b1ca,0xdce8809a,0x44310102,0xb87b008b}},	//   _soni_, _śląs, hiz_, _frít,
   {{0x4431661d,0x69c9b02e,0xe8f68fe6,0xb87b0032}},	//   kiz_, rfee, злы_, _irís,
   {{0x87259056,0x6e2d0dbb,0x799d2e4d,0x660980c9}},	//   змож, _amab, _lesw, _hoek,
   {{0x6c6a8117,0x661b83cf,0x4431661e,0x660998c7}},	//   _اللہ_, _kluk, diz_, _koek,
   {{0x82378019,0x6609c44d,0x2a6901c0,0x3ebe004a}},	//   _برطا, _joek, jmab_, _åtte_,
   {{0x317a810f,0x973c8024,0x44312d8d,0xa3df816f}},	//   _האנד, vaće, fiz_, _तसा_,
   {{0x201eb119,0x44311c0a,0x6609a6a6,0x6e2d3bb8}},	//   chti_, giz_, _loek, _emab,
   {{0x661be61f,0x6b630103,0xdce603bf,0xa3cd8c9a}},	//   _oluk, екра, rakı, ष्य_,
   {{0x3ce00282,0x78a416e1,0x661b838a,0x15460225}},	//   _tsiv_, tsiv, _nluk, _нейм,
   {{0x973c8052,0x799d01ec,0x7e7c22c3,0xfc3f11a9}},	// [6760] raće, _desw, _surp, grís_,
   {{0xa3cd83b7,0xddc9b2b2,0x600d8ece,0x6d5604b9}},	//   ष्म_, _rieš, _túmu, _iyya,
   {{0x660990f4,0x224dcaad,0x973c812b,0x442c88f9}},	//   _boek, koek_, paće, _rmd_,
   {{0xddc9b2c8,0x25a20748,0x644e0f2a,0xb87b6620}},	//   _pieš, nakl_, lobi, _prít,
   {{0x20170065,0x01c380ab,0xd90d2181,0x224d8769}},	//   áció_, ্যাদ, _پیل_, doek_,
   {{0x7e7c6621,0xddc981e2,0x61e60214,0x661b8074}},	//   _turp, _vieš, _hakl, _eluk,
   {{0x60120789,0x61e665f6,0x661b8d23,0x290003a8}},	//   _næmi, _kakl, _fluk, lxia_,
   {{0xddc98029,0x2d8081ac,0x44316622,0x644e03df}},	//   _tieš, žieb_, ziz_, hobi,
   {{0xdfd08307,0x76438065,0x61e66623,0x443153fb}},	//   نية_, énye, _makl, yiz_,
   {{0x66098586,0x251b810f,0x644e012b,0xe1ff001c}},	//   _zoek, _הומא, jobi, _khóc_,
   {{0x224dc0f1,0x644e239f,0x6d560300,0x7e760122}},	//   boek_, dobi, _ayya, _biyp,
   {{0xa3cd8b3b,0xcb13893f,0xf27b8051,0x8afb8039}},	//   ष्ठ_, _אלע_, _הראש, _להבי,
   {{0x44316624,0xa9c58077,0x2ca6820d,0x63bc8106}},	//   tiz_, _آزمو, nsod_, _örns,
   {{0x9a871a02,0x68e2b129,0x7e6416fb,0xb3472359}},	//   зуал, _isod, _ehip, _naçõ,
   {{0x44314d6e,0x25a201f4,0xdb1c03e6,0x268a81a8}},	//   riz_, bakl_, ngrè, _اختي_,
   {{0x44310182,0x6e2d5deb,0x61e60140,0x7f3b83de}},	//   siz_, _umab, _cakl, _לעוו,
   {{0x61e6003a,0x200a6625,0x443101ca,0xb95b0032}},	// [6770] _dakl, _bobi_, piz_, _abìr,
   {{0x224d8a0f,0x6609e626,0xdb1a9727,0x200a4e28}},	//   zoek_, _soek, _actí, _cobi_,
   {{0xb87b3404,0x2ca90ae1,0x3ea70065,0x200a3733}},	//   _prís, _hvad_, ént_, _dobi_,
   {{0x3a203962,0x61e600b9,0x5d358019,0x9f4a041c}},	//   chip_, _gakl, وفائ, _robô_,
   {{0x629ae451,0xdb1c016d,0xe8eb01a8,0x200a033a}},	//   _awto, rfrå, _ارجو_, _fobi_,
   {{0x61e607dd,0xa3cd0beb,0xdb1c0711,0x76438061}},	//   _zakl, रभि_, sfrå, ényb,
   {{0x66098b3c,0x61e60214,0x6281026f,0x68e2e627}},	//   _toek, _yakl, íloh, _asod,
   {{0x601f80e7,0xf99f0242,0x6e3d0bfd,0x201c862c}},	//   _même, _alèz_, jnsb, _alvi_,
   {{0x68e28019,0x6820016d,0x224de628,0x25ade629}},	//   _csod, _född, roek_, _idel_,
   {{0x44318201,0x6e3d1c33,0x224de62a,0xdb050118}},	//   _öz_, ensb, soek_, _adhí,
   {{0x63a3a055,0x644e10d3,0xa3cd83dd,0x1f6580e8}},	//   mann, vobi, ष्ण_, ьком,
   {{0xd12e9125,0xcb128051,0x320b0035,0xf99f0176}},	//   امی_, _שלא_, _nocy_, _elèz_,
   {{0xfd59846d,0x61e9e62b,0x63a38037,0x00000000}},	//   _agbẹ, mdel, oann, --,
   {{0xb4ce0df4,0x61e98370,0x61e6662c,0xddcd0087}},	//   _रही_, ldel, _sakl, _piaţ,
   {{0x60c9aa33,0x69cd484a,0x61e602d7,0x63a38359}},	//   ltem, ffae, _pakl, iann,
   {{0x27e787ca,0x2d9f8352,0x644e662d,0xddcd002e}},	//   _hann_, _neue_, sobi, _viaţ,
   {{0x27e7834a,0x63a39203,0x61e994d1,0x600a0fbf}},	// [6780] _kann_, kann, idel, онам_,
   {{0x60c98ca5,0xb87b01ac,0x63a3e62e,0x61e98009}},	//   item, _prír, jann, hdel,
   {{0x63a3e62f,0xdb050352,0x7659831d,0x27e791e6}},	//   dann, _schö, flwy, _mann_,
   {{0x61e9e630,0x6b670019,0x60c986c0,0xa3c80b6f}},	//   jdel, ségé, ktem, ोजक_,
   {{0x61e98422,0x3cfa8063,0x200a6631,0x63a3e632}},	//   ddel, ्हें_, _tobi_, fann,
   {{0x7bdc07d5,0xb5fb00f7,0x61e99254,0xb4de8074}},	//   neru, rmái, edel, _तनी_,
   {{0x59e20c28,0x61e9d6bc,0x2a7e9a7b,0x25a000e7}},	//   _पसार, fdel, _qutb_, _oeil_,
   {{0xe1ff0028,0x7bdc6633,0x31620282,0x63a3d62f}},	//   _khóa_, heru, _kzkz_, aann,
   {{0x63a3e634,0x27e7e635,0x301484fa,0xada38196}},	//   bann, _bann_, едпр, _шатл,
   {{0x2249803b,0x63a3a305,0x68204323,0x7bdc1fb6}},	//   čaka_, cann, _föde, jeru,
   {{0x27e7834a,0x7bdc1655,0x741380d5,0x80bd80c8}},	//   _dann_, deru, _جولا, ্টগ্,
   {{0xd378803a,0xa01b016d,0x200581c0,0x25a04a30}},	//   _naći_, _utöv, ajli_, _ceil_,
   {{0x60c982be,0xadc380ff,0xb87b41e3,0x27e78e20}},	//   ctem, _hoản, _asín, _fann_,
   {{0x201980f1,0xe72f803d,0xe6300085,0x27e7e636}},	//   ësit_, اصی_, _təşə, _gann_,
   {{0x6adcd59b,0x450700c8,0x81e180ab,0x2a668282}},	//   _मनोर, _লেখক_, দার_, _khob_,
   {{0x63a3e637,0x69c09c77,0x25a05778,0x68ed8140}},	//   zann, ngme, _geil_, _šadi,
   {{0x7bdc148e,0xee3f003e,0x30bc80c8,0x48bc80ab}},	// [6790] beru, mný_, _অনুস, _অনুর,
   {{0xee3f003e,0x61e99c3d,0x7bdc0efa,0x9c380198}},	//   lný_, zdel, ceru, _опыт_,
   {{0x61e9e638,0x68ed42a9,0xb2751662,0x53350012}},	//   ydel, svad, _плош, _чент,
   {{0x7ae508cf,0xee3f003e,0x63a3985b,0x61e98144}},	//   _isht, nný_, wann, xdel,
   {{0x63a3e639,0x2ca98013,0x682000f2,0x24f98a41}},	//   tann, éad_, _söde, янды_,
   {{0xc7ce8104,0x6b65945a,0x660d08f2,0x200502f1}},	//   _sống_, нкла, _loak, _õli_,
   {{0xe7e585b3,0x27e7e63a,0xee3f026f,0x7bc500b8}},	//   _कसबा_, _rann_, kný_, _mchu,
   {{0x63a3e639,0x60c985a7,0x2a66822c,0x27e7c456}},	//   sann, ttem, _chob_, _sann_,
   {{0xb4ce1499,0xee3f0775,0x61e987b3,0x2919ca89}},	//   _रहे_, dný_, rdel, ása_,
   {{0x60c98625,0x2480663b,0xddc981ac,0x7bc5663c}},	//   rtem, _ruim_, _dieť, _nchu,
   {{0x69d00076,0x98ab87d9,0x27e7a253,0x24800090}},	//   ड्डी, ğlık_, _vann_, _suim_,
   {{0xfbc90051,0x27e781ec,0xc7ce8028,0x7bdc534f}},	//   _לת_, _wann_, _uống_, weru,
   {{0x9f4788cf,0x27e786c0,0x7bdc663d,0x973c8052}},	//   _kanë_, _tann_, teru, raća,
   {{0x9f4788cf,0x25a00352,0x6281dbc5,0x33d5035f}},	//   _janë_, _weil_, _kulo, кіст,
   {{0x78a9809f,0xee3f0efc,0x25a0663e,0x7bdc663f}},	//   lsev, bný_, _teil_, reru,
   {{0xb87b0038,0x62818365,0x798980a4,0x91e33760}},	//   _príp, _mulo, ncew, лосе,
   {{0x7ae508cf,0x3946231e,0x6d410459,0x6e3b0039}},	// [67a0] _esht, ços_, şlar, _מתקד,
   {{0x57e744e0,0x78a9e640,0x6564132e,0x7bdc03ed}},	//   ндум_, isev, _izih, qeru,
   {{0x28ac0aed,0x6e228234,0x44446641,0x2cbd81ed}},	//   _चिकि, thob, _ij_, euwd_,
   {{0x25a08307,0xa01b016d,0x2a790748,0xb87b526f}},	//   úil_, _stöt, _gisb_, _tríp,
   {{0x22406642,0x98b880eb,0xb97b0039,0xb608816b}},	//   mnik_, ārī_, _מרכז, _nešť,
   {{0x2240371a,0x6e228578,0x6281b722,0xee3f016b}},	//   lnik_, shob, _bulo, zný_,
   {{0x2bd223e6,0x6281a189,0x6e2280f7,0x63a1a704}},	//   द्या, _culo, phob, _deln,
   {{0xfce694d6,0x6281820d,0x63a18074,0x58d48e97}},	//   _побо, _dulo, _eeln, воит,
   {{0xee3f0efc,0xc05a81e2,0xdd8f8bbe,0xd7f080f7}},	//   vný_, зін_, _طول_, لكة_,
   {{0x764404b9,0x22403430,0x62818326,0x38678362}},	//   _ajiy, hnik_, _fulo, _chnr_,
   {{0xee3f003e,0xe297a597,0xdd950048,0x659529d7}},	//   tný_, _зах_, каны, кану,
   {{0x444433e6,0x7bc53243,0x39469d67,0x5fc70072}},	//   _aj_, _schu, _txos_, _लाभल,
   {{0xee3f027f,0x60168187,0xba2981a8,0x444400ed}},	//   rný_, _lâmi, _تسلم_, _bj_,
   {{0xee3f026f,0x7a2302f1,0x65640140,0x9be42133}},	//   sný_, _mõte, _dzih, ліск,
   {{0xee3f026f,0x2456007b,0x973c8289,0x81c500ab}},	//   pný_, væmt_, maćo, _এসব_,
   {{0x444403a6,0xb5fb26d5,0xa75b81c6,0x9b58004a}},	//   _ej_, gmát, _מדור, хист_,
   {{0x200ee643,0x9f5c81ac,0x26d8100a,0x3ebe804a}},	// [67b0] _kofi_, _novú_, _apro_, lutt_,
   {{0xb9090d86,0x7bc5022e,0x29070067,0x66199d08}},	//   _मन_, _uchu, ćna_, wkwk,
   {{0xf3ff8142,0x7ae5020f,0x22400353,0xdb0380f1}},	//   _đã_, _usht, bnik_, ranë,
   {{0x63a71024,0x2b0e001b,0x6281e644,0xee38804a}},	//   lajn, ठहरु_, _rulo, ннє_,
   {{0xfce594d6,0x6281c7c7,0x61fd6645,0x63a196b5}},	//   толо, _sulo, _insl, _peln,
   {{0xe3b384c0,0x6281d24a,0x29360158,0xd7208054}},	//   ارش_, _pulo, _יארן_, मनाथ_,
   {{0x81ea8a49,0x44335056,0x4421008e,0x60cd5f05}},	//   মান_, _mmx_, _mlh_, ltam,
   {{0x78a98406,0x32090e35,0x63a18299,0xdb1c226d}},	//   tsev, njay_, _weln, rfrø,
   {{0xe3b39381,0x9f43001b,0x5c758a2e,0x60cd05d8}},	//   _مرض_, _mají_, _алат, ntam,
   {{0x6281e646,0x224004c4,0x78a98508,0x60cd1243}},	//   _tulo, znik_, rsev, itam,
   {{0x63a70165,0x444403a7,0xb5fb001b,0x61ed44cf}},	//   dajn, _rj_, klád, kdal,
   {{0x60cd6647,0x4421054e,0x61ed04a6,0x9f47e648}},	//   ktam, _alh_, jdal, _jané_,
   {{0x61ed6649,0x442107d5,0xd3788b67,0xdb0384e8}},	//   ddal, _blh_, _daću_, dané,
   {{0x320f8986,0x22400063,0x63a70805,0x212900dd}},	//   _hogy_, wnik_, gajn, dzah_,
   {{0xe80505e8,0x03a31429,0xfe460087,0x44331867}},	//   राना_, рисо, _инко, _dmx_,
   {{0xc24312a0,0x61ed0ec9,0x61eb9d49,0xdb038661}},	//   анск, gdal, _jagl, gané,
   {{0x444402a5,0x61ebe64a,0x6d5b81e9,0x60cd13d2}},	// [67c0] _tj_, _magl, _nyua, gtam,
   {{0xa01b23d8,0x2240664b,0xb5fb26d5,0x224d012b}},	//   _stör, snik_, smát, čeka_,
   {{0x36890071,0x22400988,0x3d65053d,0x6fd38035}},	//   есін_, pnik_, _لطیف, ब्यू,
   {{0x4438571a,0x61eb977c,0x7c21ab0d,0x6820016d}},	//   lir_, _nagl, _allr, _döda,
   {{0x60cd05dc,0x44380013,0x7e7b885c,0x9f47816b}},	//   ctam, oir_, _diup, _dané_,
   {{0x4438664c,0xa7da03f8,0x69c43ad2,0x93bc8162}},	//   nir_, _توسط_, lgie, _slăb,
   {{0x02a38a41,0xaa58baa3,0x61ebe64d,0x62349a1a}},	//   арым, нику_, _bagl, леку,
   {{0xe3b2803d,0x261403a7,0x61ebc52c,0xdbdf808b}},	//   _چرا_, _mãos_, _cagl, síðu,
   {{0xfce3825d,0x4438664e,0x61ebe64f,0x48c280c8}},	//   _кото, kir_, _dagl, ্ট্র,
   {{0xd7f79006,0x61ed6650,0xb5fb0019,0x44385625}},	//   вую_, zdal, ymás, jir_,
   {{0x44386651,0x81d78a49,0x61ed0182,0x61eb95f8}},	//   dir_, ায়_, ydal, _fagl,
   {{0x7c38a1bf,0x442100dd,0x61ebbe3d,0x200e80fc}},	//   livr, _slh_, _gagl, _wofi_,
   {{0xdfd48071,0x67d48bda,0xdb03826f,0x9f4701ac}},	//   _болы, _болу, vané, ľné_,
   {{0x9f470a56,0x44380357,0x61e08214,0xdfd081a8}},	//   žné_, gir_, leml, _طيب_,
   {{0x2bd203eb,0xd8389024,0xfbd201d0,0x23d2097d}},	//   द्धा, mič_, द्धम, द्धद,
   {{0x60cd2f47,0x69c46652,0x4438125b,0x63a70b80}},	//   ttam, ggie, air_, sajn,
   {{0x44386653,0x60c0a09b,0xe7cf8bb8,0x61ed6654}},	// [67d0] bir_, numm, त्वप, rdal,
   {{0x4438040e,0xb5fb03a2,0x2bd20bc2,0x661d0cab}},	//   cir_, slád, द्दा, lksk,
   {{0x60cd2b1e,0x64556655,0xd371003d,0x12bd80ab}},	//   stam, mozi, _دهد_, _আন্দ,
   {{0x60cd002e,0x60c0e02b,0x69df0234,0x661d074d}},	//   ptam, kumm, qeqe, nksk,
   {{0xe8df0104,0x60c0e656,0x91ba0039,0xa8a400a9}},	//   _thực_, jumm, _אמרי, _врск,
   {{0x61ebc6bc,0xcb6992bc,0xbfb80077,0x60c0e657}},	//   _sagl, нале_, _لطفا_, dumm,
   {{0x61eb84d2,0x7e7b9600,0x7bc3812b,0x2484808e}},	//   _pagl, _tiup, rgnu, _eumm_,
   {{0x44386658,0x62856659,0x93bc8087,0x3eda00be}},	//   zir_, _muho, _plăc, _אַמא,
   {{0x44380201,0x6012013c,0x64553327,0xe1ff0028}},	//   yir_, _kæmp, kozi, _nhóm_,
   {{0x4438665a,0x63a501ac,0xdb018b4c,0x61eba79e}},	//   xir_, _nehn, _lelé, _wagl,
   {{0xe5a60e8e,0x61ebb645,0x35a63134,0x6da61878}},	//   лини, _tagl, ланг, лина,
   {{0x4438665b,0xdb018036,0xe8f581a8,0x60c0e65c}},	//   wir_, _relè, _مستخ, bumm,
   {{0x443830aa,0x518481e5,0x78ad0b67,0xd838a3f9}},	//   tir_, _туха, jsav, bič_,
   {{0x6455665d,0x6285242d,0xd91a80be,0x201100ce}},	//   gozi, _buho, _רוסל, _nozi_,
   {{0x4438665e,0x6443b2be,0xdb018019,0xe6d20424}},	//   rir_, inni, _belé, _सहेज,
   {{0x44384e07,0xe7cf835a,0x69c40029,0xdb019e1c}},	//   sir_, त्रप, ugie, _celé,
   {{0x6e242735,0x9f5c86c4,0x64553997,0x78ad2ca0}},	// [67e0] _ilib, _anvè_, bozi, gsav,
   {{0xdb01e65f,0x225f9ad4,0x69c40d35,0x2484852a}},	//   _telè, hluk_, sgie, _rumm_,
   {{0x225fe660,0x20116661,0x09b000ab,0xdb018019}},	//   kluk_, _dozi_, ঙ্গা, _felé,
   {{0xe1ff00f7,0x6443809a,0x175680be,0x52d700be}},	//   _gnó_, enni, אסער_, _גוטע_,
   {{0x7a3e81a9,0x7642e662,0x649a8878,0x9f5807b6}},	//   nūte, rnoy, хтер_, _poró_,
   {{0x6e2407e2,0x26c1515b,0x2a606663,0x998de664}},	//   _llib, buho_, llib_, vieš_,
   {{0xd838e665,0x81e700ab,0x6e246666,0xa5bb0c83}},	//   vič_, পার_, _olib, rióz,
   {{0x611a00eb,0x64438717,0x521481cf,0x7afa0198}},	//   _tālā, anni, рдит, ätty,
   {{0x61e0895e,0x02e1101c,0x463b8158,0x68ed826c}},	//   reml, _पन्न, _נעמע, _šadr,
   {{0x6e240b3f,0x60c0afff,0x6a65a3ca,0x61e0b327}},	//   _alib, rumm, rófa, seml,
   {{0x60c092a5,0xb33c84b7,0x645ae667,0xd838bc35}},	//   summ, _ieħo, _ikti, rič_,
   {{0xd10402a8,0x10a682df,0x98a680a9,0x6e2400f7}},	//   रमाण_, _бидн, _биде, _clib,
   {{0x62850988,0x661d2a33,0x81ea8264,0xd838877b}},	//   _suho, rksk, মাদ_, pič_,
   {{0x6e245076,0x6285050b,0xa2ab8072,0x6298890d}},	//   _elib, _puho, ींच्, opvo,
   {{0x443f0025,0x501b84de,0xfe70053d,0x656f9e1e}},	//   đu_, _אוגו, تدی_, _úchv,
   {{0x3ce901c5,0x973c8754,0x78ad6668,0x64556669}},	//   _tsav_, haćk, tsav, sozi,
   {{0xbf1d03b7,0x645511ec,0x6443e66a,0x2011666b}},	// [67f0] पन्न_, pozi, ynni, _pozi_,
   {{0x201ea8d1,0x6285666c,0x27ee808b,0x225fe66d}},	//   nkti_, _tuho, _jafn_, zluk_,
   {{0xdb01840e,0x78ad4e2a,0xb87b0298,0xd6db0e11}},	//   _telé, ssav, _kríz, эта_,
   {{0x7afa013c,0x6448af9f,0xeef784de,0x51840088}},	//   ætte, _ajdi, טמבר_, _гура,
   {{0xfaf88db5,0x2bd20bb3,0x225f80d2,0x7e6d1f4d}},	//   _arī_, द्वा, vluk_, _mhap,
   {{0x7bc7008b,0x27ee807b,0x3dc981b9,0x6443862c}},	//   ngju, _nafn_, żaw_, unni,
   {{0xdb1c12ca,0xa3498098,0x1b498098,0x44fd0264}},	//   ográ, ъзка_, ъзки_, ুনিক_,
   {{0xe1ff8333,0x4b3801c6,0x61ef10ba,0xdb1c0537}},	//   ñó_, טרול_, _jacl, ngrá,
   {{0x61ef666e,0x2d9da578,0xdb038333,0xd9458c40}},	//   _macl, mbwe_, maní, репи,
   {{0xaaae816f,0x7e6d0135,0x66db8009,0x1bab8019}},	//   _टिचक, _ahap, _näkö, _سائٹ_,
   {{0x43848013,0xbb8480f7,0xb87b39f0,0x4e198d86}},	//   _المق, _المي, _epíg, _दवाई_,
   {{0x7e6d24f0,0x1c038beb,0x6a658333,0xdddc9c34}},	//   _chap, लावल_, mófo, _kurš,
   {{0xe0c000c8,0x59678081,0x7e6d003d,0x98b88162}},	//   _উন্ন, _съжа, _dhap, ără_,
   {{0x7bc7008b,0xe7878c0e,0x6d5f0168,0x557683de}},	//   ggju, _судо, _dyqa, יערן_,
   {{0xfaa60396,0x765ba18e,0x4425e66f,0x26c7023e}},	//   рабо, _okuy, _mll_, ànol_,
   {{0xc48605c2,0xceb8809a,0x2fd800b9,0x61ef0362}},	//   _клик, rzęt_, _sbrg_, _cacl,

   {{0xfce60e6b,0xddc980eb,0x2d8080e1,0xdb03bb81}},	// [6800] _топо, _biež, žiek_, daní,
   {{0x442581c0,0x7a230074,0xb5fb016b,0x2c7c0032}},	//   _nll_, _võta, plác, _dádì_,
   {{0x0d8682a9,0x3bbb0039,0x61ef0014,0x69d982ec}},	//   ален, _במיד, _facl, _obwe,
   {{0x4425804c,0x9f5c83cb,0x3a290a0f,0x2bd201cb}},	//   _all_, _nový_, chap_, द्रा,
   {{0x61e46670,0x9d2480ab,0xdb0a948c,0x261787b6}},	//   meil, বপ্ন_, ngfö, _aços_,
   {{0x18a30972,0x7c3c00dd,0x65698267,0x69d981ec}},	//   _фарм, nirr, _dzeh, _abwe,
   {{0x7f430765,0x442580dd,0xdb03c1bf,0x7aed8035}},	//   _держ, _dll_, baní, łatn,
   {{0x4425809f,0x78a28247,0xb95b026b,0x61e40009}},	//   _ell_, _pwov, _abìy, neil,
   {{0x973c803b,0x2d8482c4,0x9f47816b,0x2aac826b}},	//   maći, _igme_, _daní_, _bóbá_,
   {{0x61e46671,0x92d580c8,0x201e989e,0x973c811f}},	//   heil, িয়ে_, ukti_, laći,
   {{0x61e40009,0x442a00f7,0x7bda81c0,0x09e695e0}},	//   keil, dhb_, _ibtu, _воен,
   {{0x443ca069,0x7e62a6a3,0xd5e4027d,0xdb18d8e5}},	//   liv_, nlop, _phí, rgvä,
   {{0xb8948307,0x40948307,0x61e46672,0x60c41148}},	//   _التع, _التر, deil, juim,
   {{0x645881dd,0x6288e673,0xbebc8029,0xb4d71199}},	//   novi, _kudo, dzīv, _सही_,
   {{0xf1a70be2,0x63a893cf,0xdb1a85e4,0x61e40114}},	//   иран, _medn, _actú, feil,
   {{0x7e6d28e1,0x443ce674,0x63a89602,0x6288e675}},	//   _uhap, hiv_, _ledn, _mudo,
   {{0x64588289,0x60c42c92,0x443cbda8,0x7bdabcd4}},	// [6810] kovi, guim, kiv_, _obtu,
   {{0x9f47001b,0x6e3d06b1,0x6458ba06,0x7e6281ed}},	//   žní_, lisb, jovi, elop,
   {{0xa18707ac,0x6447003b,0x248901c5,0xcfe180ab}},	//   _выгл, mnji, _huam_, বাচন,
   {{0x24893f73,0xd2468a47,0xdb050019,0x068410ac}},	//   _kuam_, _رن_, _nehé, ігін,
   {{0x9ce78b87,0x7afa82d0,0x65608114,0x63a8e676}},	//   рцел, _artt, _cymh, _bedn,
   {{0x6288e677,0xdb03b88a,0xb4e78740,0x24890069}},	//   _budo, saní, _बनी_, _muam_,
   {{0x248901e9,0x6013001b,0x200304b9,0x99848084}},	//   _luam_, _výmě, _inji_, jimų_,
   {{0xa2d88076,0x09f980f7,0x765b8234,0xddc4007a}},	//   _महर्, افظة_, _ukuy, _ohiš,
   {{0x6458825b,0x7659809a,0x248901c0,0x2baa150e}},	//   bovi, mowy, _nuam_, करमा,
   {{0x64588a00,0x998d81ac,0x4425d743,0x6447011f}},	//   covi, dieť_, _ull_, jnji,
   {{0x628882a3,0xdb050019,0x62970069,0x26d3011b}},	//   _gudo, _fehé, _ntxo, ntxo_,
   {{0x81b180c8,0x08f9826a,0xddc9a358,0xb87b0118}},	//   ঞ্জ_, _مرتب_, _nież, _eríx,
   {{0x61e46678,0x248901c5,0xee370c5c,0xd7c70424}},	//   veil, _cuam_, сня_, _लांच,
   {{0x61e402af,0x24890168,0x64470b80,0x68e99e26}},	//   weil, _duam_, gnji, mwed,
   {{0xff5391fb,0x81ea80c8,0x4e958bbe,0x61e46679}},	//   _بخش_, মার_, _اشتر, teil,
   {{0xbb431b93,0x645880d2,0x69c9cbcd,0x26c5e67a}},	//   ческ, zovi, ngee, mulo_,
   {{0xe8fa01bb,0x61e4667b,0x7e628247,0xf653007c}},	// [6820] ыла_, reil, vlop, _מצה_,
   {{0x443c81e9,0x61e43673,0x60c45f95,0xf20986a7}},	//   xiv_, seil, ruim, वाड़_,
   {{0x63a8c8db,0x645880d2,0xd00f1ddd,0x443ce67c}},	//   _redn, vovi, علم_, viv_,
   {{0x63a8e67d,0x452aa2f3,0xa5bb00f7,0x601683a7}},	//   _sedn, лжен_, thói, _lâmp,
   {{0x27e59f0f,0x98a0009a,0x7e629412,0x973c9487}},	//   keln_, dzić_, rlop, raći,
   {{0x26c59f60,0x9cd70039,0x69c98079,0x68e9ce06}},	//   kulo_, מונה_, egee, dwed,
   {{0x443c8082,0x8bf200c8,0x63a88db7,0x6604667e}},	//   riv_, ঞাপন_, _vedn, _onik,
   {{0xae0c81fe,0x4c868dbd,0x443c96eb,0xe45f50de}},	//   _सचिन_, _глав, siv_, ntör_,
   {{0x6458803b,0x0f2081fe,0xdca39d99,0x63a88353}},	//   povi, मन्स_, _нати, _tedn,
   {{0x6288e67f,0x24890069,0x27e58b2f,0x66044505}},	//   _tudo, _ruam_, geln_, _anik,
   {{0x8104326f,0xe45f50de,0x24896680,0x66166681}},	//   रमुख_, ktör_, _suam_, _boyk,
   {{0x24890069,0xde590b73,0x99848110,0xe1ff00ff}},	//   _puam_, рамі_, rimų_, _thói_,
   {{0x6e3d2475,0x27e592d2,0x64470253,0xb8d3803d}},	//   risb, beln_, tnji, _فتوش,
   {{0x66046682,0x26c5e683,0x24890069,0x7d1d2127}},	//   _enik, bulo_, _vuam_, ryss,
   {{0x752f0d38,0x26c59f5c,0xa3cd8c78,0x629c2a66}},	//   szcz, culo_, ष्ट_, gpro,
   {{0x248901c5,0x6447007d,0x99990249,0x6e4400a9}},	//   _tuam_, snji, ркат_, _нејз,
   {{0x301512b2,0x63ae010b,0x7c3aa39e,0xb4e78fcc}},	// [6830] одар, babn, _omtr, _बने_,
   {{0x656d4945,0x2cb4001b,0xdced00fe,0x2baa0072}},	//   _izah, řadí_, _ugađ, करणा,
   {{0xdb019f5c,0x7659809a,0xb87b1727,0x4f6b16dd}},	//   _pelí, towy, _apíc, ушам_,
   {{0xe3b88182,0x3e7b01e2,0x9f4a0122,0x68e98114}},	//   _adı_, _būti_, _babâ_, ywed,
   {{0xa509a659,0x63858251,0x7659809a,0x22490061}},	//   рела_, огла, rowy, mnak_,
   {{0x22490019,0x973c9487,0x27e585ec,0x2a6f808e}},	//   lnak_, laću, xeln_, _shgb_,
   {{0x8c1c0f60,0x6d4103bf,0xdb07001b,0x2bdb6684}},	//   רווי, ğlay, kají, म्या,
   {{0x6d411010,0x7c28a496,0x22490065,0x3ced81e9}},	//   şlay, _eldr, nnak_, _tsev_,
   {{0x69c9858f,0xb5fb02b7,0x22491124,0x26c5b1ba}},	//   rgee, tlán, inak_, wulo_,
   {{0x6e298904,0x764d1e8c,0x225d9142,0x68e98e8a}},	//   _hleb, _ajay, _wkwk_, rwed,
   {{0x22490065,0x6e298204,0x656d6685,0x9b58846e}},	//   knak_, _kleb, _azah, _лифт_,
   {{0x443a0e60,0xb5fb6686,0x63ae010b,0xceb203c8}},	//   _smp_, slán, wabn, ויט_,
   {{0x2249295b,0x63ae0239,0x2eee826c,0xf1bf026f}},	//   dnak_, tabn, _esff_, _plán_,
   {{0x26c5d24a,0xaadd8af3,0x656d0359,0x02dd8aed}},	//   pulo_, _महाक, _dzah, _महाभ,
   {{0x63ae252d,0x366a0fbb,0x6e3b82ec,0x656d01f6}},	//   rabn, _како_, _omub, _ezah,
   {{0x443a1b11,0x9fa3007b,0x3a3f8359,0x22490019}},	//   _wmp_, _síðu_, niup_, gnak_,
   {{0x1005000d,0x6440063e,0xe7aa0b5b,0x7bdc807b}},	// [6840] रांश_, émis, ивал_, _örug,
   {{0x6e29b404,0x629c04b7,0x69cf0098,0x443a6687}},	//   _aleb, ppro, _ecce, _ump_,
   {{0x46ea1092,0x06ea0087,0x9f510176,0x1c0386ae}},	//   рден_, рмек_, _jazè_, लाईल_,
   {{0x05668193,0xcbc680ab,0x645c22c3,0xd49abc3d}},	//   овен, _এসেছ, lori, арк_,
   {{0xe8f7117c,0x6e229142,0x6ec08c28,0x9f4700e1}},	//   _для_, rkob, _विभु, ľná_,
   {{0x9f47003e,0x6e29bbb5,0x628300e7,0x7c83e688}},	//   žná_, _eleb, _énor, муще,
   {{0xa3dc0fce,0xb4c70424,0x60d60a14,0xdb03e689}},	//   ण्य_, _उम्_, ltym, taná,
   {{0x201800ad,0x645c260f,0xa2cb0576,0xb33c8372}},	//   _hori_, hori, तंत्, _jeħi,
   {{0xdb03b680,0xfdee0035,0x60d64bf4,0xdb0701d0}},	//   raná, ज़नस_, ntym, vají,
   {{0x22490019,0xd01a917e,0x60d60084,0x4734ae65}},	//   znak_, рфи_, itym, знос,
   {{0x645c361a,0x2018668a,0x224913f4,0xe297abd9}},	//   dori, _mori_, ynak_, _дах_,
   {{0x2018077f,0x46db83eb,0x629ae68b,0x65640314}},	//   _lori_, _बहरह, _itto, _byih,
   {{0x61f60428,0x65640a03,0x20a90054,0x938b047f}},	//   ddyl, _cyih, _चौंध, исва_,
   {{0x2018668c,0x9faf080a,0x7a230074,0x9f34a133}},	//   _nori_, _işçi_, _võtm, _нелі,
   {{0x22490019,0xb024801c,0x644a81a8,0x973c8267}},	//   tnak_, _giườ, infi, taću,
   {{0x786f8aa2,0x224002d5,0x2abb8e82,0xddeb00d7}},	//   røve, giik_, ימלא, _ضربه_,
   {{0x2018668d,0x765d1ad6,0x69dd2307,0x224912de}},	// [6850] _bori_, mosy, _vbse, rnak_,
   {{0x629a8698,0x22491403,0xe6168353,0x68e2826c}},	//   _otto, snak_, _čišč, _mpod,
   {{0x98ac00eb,0x2018668e,0x2ca90326,0x199502a9}},	//   ālās_, _dori_, _hwad_, _наня,
   {{0xdb03d465,0x69cf047f,0x765d074d,0x2ca90326}},	//   lanç, _ucce, nosy, _kwad_,
   {{0x629acdb0,0xeb999300,0x64a5976e,0x2018047f}},	//   _atto, бил_, чала, _fori_,
   {{0x9f4301ac,0xdb0391dd,0x3e72026f,0x320682c4}},	//   _majú_, nanç, máte_, _anoy_,
   {{0x68e2957a,0x68ed599f,0x765d668f,0x3a3f90e1}},	//   _apod, lwad, kosy, tiup_,
   {{0x6e3b82a0,0x69cd6690,0x290d8102,0x68e28f35}},	//   _umub, ngae, txea_, _bpod,
   {{0xa3dc0bb8,0x645c4a96,0x629a9793,0x20186691}},	//   ण्ड_, yori, _etto, _yori_,
   {{0x25ad9aee,0xe8df0028,0x645c6692,0xb87b0061}},	//   _heel_, _chức_, xori, _zsír,
   {{0xf1cb04e5,0x961d8029,0xdb0383a7,0x25ad9316}},	//   िलान, _ziņa, danç, _keel_,
   {{0xfe72045b,0xfce6035f,0x765d1066,0x68ed6693}},	//   عدد_, помо, gosy, kwad,
   {{0x2bd2885d,0x645c0888,0xc1048013,0x25ad82a3}},	//   _सामा, tori, _يومي, _meel_,
   {{0xa09a9b9e,0x5fc7035a,0x3e72026f,0xa7fc8059}},	//   _היסט, _लागल, dáte_, nlıl,
   {{0x2007e694,0x2018130c,0x765d076d,0x645c00ef}},	//   _inni_, _rori_, bosy, rori,
   {{0x645c6695,0x1dc6035a,0x20186696,0x3e7b0029}},	//   sori, _वाटत, _sori_, _būtu_,
   {{0x20185c28,0x2edb9051,0xdd9982d6,0x22401f61}},	// [6860] _pori_, _बहुत, _enňk_, riik_,
   {{0x645c0085,0xdb0383a7,0x61e9a805,0x60d66697}},	//   qori, canç, heel, rtym,
   {{0x60d60fe6,0x9f4a4c16,0x61e9e2f5,0xdb0e010c}},	//   stym, _babá_, keel, kabé,
   {{0xd6cf1a37,0x6820016d,0xdd8f99ea,0x25ad81b4}},	//   طقه_, _nödv, هوم_, _ceel_,
   {{0x25ad90f4,0x61e9838e,0xd5af8154,0x68ed2751}},	//   _deel_, deel, افه_, cwad,
   {{0x7bce6698,0x961d8029,0x02a6b45a,0x7bdc0087}},	//   ngbu, _viņa, прим, nfru,
   {{0x68e286b9,0x66e33408,0x628630a0,0x61e981bc}},	//   _spod, _пора, _kiko, feel,
   {{0x20078698,0xa9c3835f,0x8cc485fb,0x25adcb97}},	//   _anni_, нськ, _रिपो, _geel_,
   {{0x62866699,0x60c98333,0x1dc6016f,0x248590b6}},	//   _miko, guem, _वाजत, _film_,
   {{0x60c40013,0x2018807b,0x2cb7801b,0x6b669fa5}},	//   irim, ðri_, ředí_, _екза,
   {{0xfaa395e3,0x61e9b062,0x443e842b,0xe1ff00f7}},	//   _захо, beel, _imt_, _mhór_,
   {{0x60c4669a,0x61e9cd76,0x7c3e23ee,0x998206c4}},	//   krim, ceel, _ampr, _ankō_,
   {{0xe8df0028,0xdb0502ba,0x5c070ba7,0xdb0387d0}},	//   _thức_, _vehí, пява, tanç,
   {{0x3cef8105,0x68fb03a7,0x62860009,0x60c43ffd}},	//   _इनसे_, _áudi, _aiko, drim,
   {{0x7e8683bb,0xdb03855a,0x628646ed,0x60c40006}},	//   íspě, ranç, _biko, erim,
   {{0x6286669b,0x7d009581,0x3f9826ca,0xb87b026b}},	//   _ciko, _orms, _afru_, _asíp,
   {{0x62860455,0xa6ae80ab,0x60c4669c,0x442c8039}},	// [6870] _diko, _কমিট, grim, _old_,
   {{0x44ef58dc,0xd7f8802e,0x68ed669d,0xb87b4e86}},	//   _iż_, ndă_, rwad, _epín,
   {{0x6e2d3916,0x6a65a6d5,0x6286669e,0x9f45801b}},	//   _klab, sófi, _fiko, telé_,
   {{0x1dad0e18,0x6286669f,0x3f8a0135,0xd77412c8}},	//   चरित, _giko, _egbu_, رالع,
   {{0x25ad80bd,0x248d80a9,0x442cbb07,0x61e99e7e}},	//   _veel_, _quem_, _bld_, veel,
   {{0x61e9e6a0,0x2a693aa8,0xb95b0032,0x6f010187}},	//   weel, llab_, _adìg, _álco,
   {{0xe3b08d4a,0x6e2d66a1,0x61e9e6a2,0x25ade6a3}},	//   اره_, _olab, teel, _teel_,
   {{0x09e080c8,0x02dd901c,0x3ede8870,0x442c90cc}},	//   _মোবা, _महीन, _chọọ_, _eld_,
   {{0x4900000d,0x61e9dea2,0xdb0e0548,0xf1bf026b}},	//   रियो_, reel, rabé, _alák_,
   {{0xb8d59499,0xa5bb0125,0x8afc809a,0x386300ee}},	//   _जब_, skól, _częs, _jkjr_,
   {{0x6e2d080d,0x2a695d0d,0xe0200105,0x661be6a4}},	//   _blab, klab_, _मकसद_, _kouk,
   {{0x1b168a49,0x6443e6a5,0x661b8009,0x4427836e}},	//   _থেকে_, lini, _jouk, lkn_,
   {{0x62864269,0x60c9a738,0xb4bb86a7,0x64438090}},	//   _riko, quem, _आटो_, oini,
   {{0x7afc003b,0x6443e6a6,0x628666a7,0x224d8019}},	//   tvrt, nini, _siko, lnek_,
   {{0xa3df89c2,0xe2970071,0x628666a8,0x660983df}},	//   ध्य_, дас_, _piko, _onek,
   {{0x7bdc1984,0x2a6901c0,0x224d8019,0xe1f98110}},	//   sfru, glab_, nnek_, ndų_,
   {{0x6443e6a9,0xd94310bf,0x2bdb2e06,0x614311a8}},	// [6880] kini, вети, म्हा, вета,
   {{0x6443c5d8,0x6609a9fb,0x2bd28526,0x60c466aa}},	//   jini, _anek, _साधा, rrim,
   {{0x6443e6ab,0x224d8065,0x2a693371,0x628666ac}},	//   dini, knek_, blab_, _tiko,
   {{0x81e280c8,0xf54f082e,0xb33c84b7,0x7afc818a}},	//   _ফোন_, pụta_, _meħt, _árti,
   {{0xdb0aa509,0xa7fc83bf,0x05b606a7,0x224d8061}},	//   rafí, rmız, _अजनब, dnek_,
   {{0x6443e202,0xdb0a85e4,0xe3b8880a,0x442780dd}},	//   gini, safí, _alır_, gkn_,
   {{0xbddb009f,0x644e0d35,0x7e6406c0,0xb5fb659e}},	//   dièn, inbi, _okip, noác,
   {{0xf2d3004c,0x26d8008e,0xaca40091,0x7d00808e}},	//   דעה_, _iqro_, _afọw, _trms,
   {{0x64439f96,0x961d8029,0x442780ee,0xdfd081a8}},	//   bini, _ziņo, bkn_, هية_,
   {{0xdb0192d2,0x629e003b,0x3f1484fa,0x29020088}},	//   _belä, _otpo, едос, _mrka_,
   {{0x3eb88117,0x6e2d08f9,0xd7f88162,0xb5fb01a8}},	//   ért_, _plab, rdă_, llái,
   {{0x26c7005c,0xa5f90009,0x644e66ad,0x2902524d}},	//   šnog_, чему_, enbi, _orka_,
   {{0x26c5e6ae,0xdb088207,0xdd318085,0xa7fc82d0}},	//   arlo_, _medí, _məşh, nlık,
   {{0xe94789a7,0xbddb0722,0x7a3100e8,0x69d58061}},	//   _ترمی, cièn, _måte, őzet,
   {{0x7a3139e8,0x98a38110,0x29022fd7,0xe7f3816f}},	//   _låte, ąją_, _arka_, _असता_,
   {{0x6443b77b,0x290208ae,0x90990098,0x3e5600eb}},	//   zini, _brka_, зват_, tāte_,
   {{0x64438850,0x26ccaa0b,0x61e2da58,0x27f83e88}},	// [6890] yini, ludo_, _mbol, _barn_,
   {{0xe3c600c8,0x661be6af,0x224d8019,0x27f866b0}},	//   শ্বব, _souk, znek_, _carn_,
   {{0x6443e6b1,0x661be6b2,0x61e284c4,0x201c8144}},	//   vini, _pouk, _obol, _movi_,
   {{0x63b50289,0x290202a5,0x2bdb0aed,0x6443e6b3}},	//   lazn, _frka_, म्रा, wini,
   {{0x6443e6b4,0xeb998e8e,0x290200d2,0xdb088bd3}},	//   tini, пил_, _grka_, _dedí,
   {{0x201c8289,0x36d50391,0x6820016d,0x7640d8e2}},	//   _novi_, _погр, _döds, _emmy,
   {{0x6443b5dd,0x224d8019,0x4427836e,0x661b8009}},	//   rini, tnek_, rkn_, _touk,
   {{0x64438380,0x442780ee,0x6609e6b5,0x999f81d6}},	//   sini, skn_, _unek, knuť_,
   {{0x63b5003e,0xa3c10076,0x6443e6b6,0x25bfb413}},	//   kazn, ुला_, pini, _idul_,
   {{0x7e642406,0x61ed0083,0x63b506b9,0x6443829b}},	//   _skip, heal, jazn, qini,
   {{0xfe460cb1,0xbddb009f,0x366a02a4,0x201c8267}},	//   енно, rièn, зано_, _dovi_,
   {{0xed5a1594,0x6ec086bf,0x60cd004f,0xd5ed0129}},	//   зом_, _विरु, kuam, _phá,
   {{0x61ed5ad8,0x61fb8057,0x63b50968,0x2d8403ca}},	//   deal, mdul, fazn, äme_,
   {{0x09ba035a,0x61f9b7f5,0x60dbd03f,0x68320366}},	//   ेल्य, _hawl, mtum, _kæde,
   {{0x80c20076,0x26cc8207,0x91e613f1,0x60dbe6b7}},	//   _लिहे, cudo_, нове, ltum,
   {{0x61fba499,0x3a290ae6,0x2bdf8519,0xed5a08b0}},	//   ndul, gkap_, प्ता, _ной_,
   {{0x63b50052,0x60cd49d7,0x2bd29199,0x6832006a}},	// [68a0] bazn, guam, सलमा, _læde,
   {{0x25dc1a3b,0x76465515,0x3c2b8aa2,0x6c340019}},	//   ग्री_, liky, _søvn_, _شہزا,
   {{0xf09f139a,0x60db837b,0x7d042503,0x2bc99299}},	//   _età_, htum, _hris, _राजा,
   {{0x7d0466b8,0xa3d289a3,0x321d809a,0x29020da8}},	//   _kris, _वाह_, _nowy_, _trka_,
   {{0xc3c909a7,0x27f866b9,0x61fbe6ba,0x26cc87b6}},	//   _عظیم_, _tarn_, ddul, zudo_,
   {{0xf1bf016b,0x7d04004f,0xa7fc82d0,0x61e28037}},	//   _zdá_, _mris, rlık, _sbol,
   {{0x2bd3016f,0x201c8037,0x78a40037,0xa3df8a27}},	//   _तासा, _rovi_, lpiv, ध्ध_,
   {{0x7d0466bb,0x93bc8087,0x28c74638,0x998d8035}},	//   _oris, _alăt, _लिमि, cież_,
   {{0x29029d9a,0x61f982a3,0x60db87cd,0x2900023e}},	//   íka_, _dawl, gtum, nvia_,
   {{0x81c900c8,0x26cc8548,0xdb06802e,0x7e62c7dd}},	//   ল্প_, tudo_, ămân, loop,
   {{0x28c28996,0x61fbe6bc,0x6f03992c,0x2ca000b9}},	//   _शिवि, bdul, _crnc, _atid_,
   {{0x26c2812b,0x61e2ace4,0x6d5180c3,0x0ae981a8}},	//   čko_, _ubol, škaš, _تركي_,
   {{0x7a230074,0x645a026f,0x63b50f09,0x9f4e826b}},	//   _mõtt, čtin, tazn, _dafá_,
   {{0xaad4800f,0x7d0418f4,0x998d8035,0x3e7204e8}},	//   _धमाक, _dris, zież_, ráta_,
   {{0x7d043755,0x63b51249,0xf09f01e8,0x2cea01fe}},	//   _eris, razn, _stà_, टबॉल_,
   {{0xfd268028,0xa3d60740,0x7d0427eb,0x60cd66bd}},	//   _đình_, _हाथ_, _fris, tuam,
   {{0x660d66be,0x865c0039,0xb5fb041c,0xf09f00e5}},	// [68b0] _inak, _מדהי, fláv, _qtà_,
   {{0x61ed05ae,0x3a2966bf,0x6820016d,0x60cd2a83}},	//   seal, skap_, _södr, ruam,
   {{0xdcfd0459,0xa3d6142d,0x64472003,0xc5d59138}},	//   ması, _हात_, miji, віль,
   {{0x644766c0,0xdcfd07c0,0x7a3e9247,0x660d0580}},	//   liji, lası, būti, _jnak,
   {{0x3e5600eb,0x60cd00e5,0x68323c10,0x660d0c61}},	//   nāta_, quam, _sæde, _mnak,
   {{0x64472f1e,0xdcfd0059,0x3e878032,0x661f03ed}},	//   niji, nası, _bìtì_, _loqk,
   {{0x660d0025,0xdce40063,0x2bd2800d,0x61f9c2ac}},	//   _onak, _dzię, _सारा, _pawl,
   {{0x05d880d4,0x60dba645,0x6824823e,0x61fbe6c1}},	//   _डायब, ttum, _mòdu, udul,
   {{0x212b8a65,0x3495b51e,0xdcfd1010,0x61fb93ec}},	//   ách_, _разр, kası, rdul,
   {{0x60dbe6c2,0x7c2ae6c3,0x64472813,0x4ae206a7}},	//   rtum, ckfr, jiji, _पहलव,
   {{0x34d18c78,0x2ca0056f,0x76462916,0x47c700ab}},	//   _समुद, _stid_, tiky, র্থী,
   {{0x270101e2,0xddc280d2,0xbbaa1130,0x9f5802d6}},	//   _mėn_, ološ, कर्क, _darè_,
   {{0x9f5808cf,0xdcfd22f8,0xdb0e66c4,0xee372325}},	//   _parë_, fası, rabí, тня_,
   {{0x660d66c5,0x628b82c4,0x64471a99,0x290000e5}},	//   _enak, _higo, giji, vvia_,
   {{0x2bd31905,0x628ba169,0x9cff80ab,0xc7d69101}},	//   _तारा, _kigo, ্নয়ন_, _יוסי_,
   {{0x290066c6,0x628be6c7,0xdb0880e1,0xc3329101}},	//   tvia_, _jigo, _jedá, בול_,
   {{0x7bc1803a,0xf1b28158,0x64472949,0xddc28289}},	// [68c0] _odlu, יסן_, biji, jloš,
   {{0x25e301ce,0x628b8110,0x9f580388,0x29002853}},	//   ट्ठी_, _ligo, _haré_, rvia_,
   {{0x44444ca3,0x99990065,0xbddb13ff,0xfaa60a18}},	//   _im_, _első_, zièm, _шано,
   {{0xdb08826f,0x78bb87b8,0xdb018061,0x471a80be}},	//   _nedá, ksuv, _felú, וועג,
   {{0x7e6287b8,0x7a230006,0xbddb00e7,0x9f430388}},	//   roop, _võtt, xièm, _bajó_,
   {{0x07a3325a,0x628b8101,0x8fa32659,0x682d80e1}},	//   _варн, _aigo, _варе, _súdn,
   {{0xf746110b,0x628be6c8,0x779100d5,0x4444037e}},	//   _рево, _bigo, _ایما, _mm_,
   {{0x60f89b93,0xf506838d,0xda09a3e6,0xa3e28540}},	//   ения_, _избо, वागत_, _फॉर_,
   {{0x44446193,0xdcfd0201,0x628be6c9,0xfbb800ab}},	//   _om_, yası, _digo, _জানত,
   {{0x6e2084a1,0x660d0257,0x88bd809a,0x76441af7}},	//   _homb, _snak, myśl, _amiy,
   {{0x64470503,0x61e61807,0x7a310711,0x60c9816a}},	//   viji, _obkl, _låta, arem,
   {{0x444404e7,0x291180f7,0x6e20861b,0xc0aa92c8}},	//   _am_, ónaí_, _jomb, _قاتل_,
   {{0xdd1188c5,0x9f5103a8,0x78700106,0xdcfd061c}},	//   _müşa, _mazá_, tävl, tası,
   {{0x09cb238c,0x628bdb1d,0x764466ca,0x22988061}},	//   िल्य, _zigo, _emiy, _kék_,
   {{0x64474ea1,0xdcfd0182,0x6e2081b0,0x44440252}},	//   riji, rası, _oomb, _dm_,
   {{0x444441d2,0x6e20e6cb,0xe5e90009,0x79a40009}},	//   _em_, _nomb, ämää, ируе,
   {{0x444466cc,0xb3d28540,0xa3d2e6cd,0x7d0288ae}},	// [68d0] _fm_, _सांख, वला_, jvos,
   {{0x63b88353,0x7d0280d2,0x5347259a,0x2ca6bbb0}},	//   javn, dvos, _ахма, dpod_,
   {{0x63b8803b,0xdb05016d,0x58841dfe,0x425500b7}},	//   davn, _behå, рыта, _مندر,
   {{0xdb0700e1,0x13b80264,0xdb01816a,0x29068106}},	//   kajú, _জায়, _telú, _oroa_,
   {{0x444466ce,0x44212d68,0x6e20e6cf,0x4433008e}},	//   _ym_, _koh_, _domb, _klx_,
   {{0x60c9803b,0x27fc8b40,0x44214206,0x2249011b}},	//   vrem, _navn_, _joh_, liak_,
   {{0xe816835a,0x6e208176,0xf41402f6,0x212900dd}},	//   ताना_, _fomb, יפס_, lyah_,
   {{0xe8f999d9,0x22491cf2,0x61fd4b25,0x442154d2}},	//   ели_, niak_, _jasl, _loh_,
   {{0xb5fb1389,0x21290b50,0x656d52c1,0x60c981b3}},	//   hlás, nyah_, _nyah, urem,
   {{0x6e2086a0,0x60c9ca6c,0xa2cabe98,0xef19c249}},	//   _zomb, rrem, संख्, емо_,
   {{0x44441cbc,0x656d09ca,0xe7f60770,0x2249011e}},	//   _rm_, _ayah, ीयता_, kiak_,
   {{0x61fd036f,0x64a65c8e,0xdca60294,0xe80a009a}},	//   _nasl, лама, лами, _होना_,
   {{0x44440c6b,0x37e58a7c,0xf1b9a7b1,0x7a358511}},	//   _pm_, _болг, maš_, _cáte,
   {{0xf1b9e6d0,0x9f058077,0xdb018aa2,0x44440de4}},	//   laš_, _موتو, _belø, _qm_,
   {{0x442166d1,0x61fd36b2,0x60dd0609,0x22490fe0}},	//   _doh_, _basl, _aqsm, fiak_,
   {{0x63b8807d,0xe811800f,0x2249011e,0x44212404}},	//   zavn, ़ावा_, giak_, _eoh_,
   {{0xeb1f8076,0x6e20836e,0x443300ee,0xf1bf046d}},	// [68e0] बहुत_, _romb, _flx_, _alás_,
   {{0x444466d2,0xe73a2469,0x442166d3,0xe8f701e5}},	//   _um_, нез_, _goh_, ылу_,
   {{0x0dca81a0,0xb5fb0207,0x22490fe0,0x6e20e6d4}},	//   елей_, clás, biak_, _pomb,
   {{0xed5a825d,0xe1f20277,0x7e7bb736,0x7d0281f4}},	//   ное_, _اسد_, _chup, tvos,
   {{0x442166d5,0xe816801b,0xa92801d0,0x7e7be6d6}},	//   _yoh_, तामा_, _držá, _dhup,
   {{0x7e69819d,0xdb0700e1,0x7d028e6c,0x6e20836a}},	//   _ekep, vajú, rvos, _womb,
   {{0x78a2b6dc,0xd6ae80c8,0x533491d2,0x05d4016f}},	//   _stov, _কম্প, рейт, _थांब,
   {{0x48aa80e2,0x2906e516,0xf7530199,0x69d666d7}},	//   нтом_, _proa_, _انفج, ngye,
   {{0x38348328,0x2611816f,0x7c21823e,0x25fdbac3}},	//   инир, णारी_, _folr, _रोटी_,
   {{0xe45f016d,0x2249011e,0xf1a4909b,0x7c2182c4}},	//   tröm_, ziak_, _ग्रन, _golr,
   {{0x9b938307,0x33938013,0x44210587,0xab938013}},	//   _المت, _المز, _roh_, _المغ,
   {{0x21291600,0x7a35801b,0x2cb20114,0x442143b0}},	//   yyah_, _páte, _bwyd_, _soh_,
   {{0x442144cf,0xf09f026b,0x78a2e6d8,0x349513d1}},	//   _poh_, _aràn_, _utov, рагр,
   {{0xb4e50063,0x61fd46bc,0x9f5c8168,0xe09e819d}},	//   _नही_, _sasl, _javë_, _gọọ_,
   {{0x0cd185e8,0x61fd449c,0x28c7035a,0xf8bf000d}},	//   _सम्म, _pasl, _लिहि, _své_,
   {{0x53341056,0xb5fb0019,0x442100d7,0x229180c3}},	//   щест, rlás, _woh_, _uške_,
   {{0x7bdae6d9,0x224900ad,0x68f6031d,0x44211a92}},	// [68f0] _octu, riak_, gwyd, _toh_,
   {{0x7e69aa33,0x25fd835a,0xf1bf00f7,0x22495394}},	//   _skep, _रोजी_, _clár_, siak_,
   {{0xf1b98353,0x2129010b,0x81cc80ab,0x22493fae}},	//   ljše_, syah_, শ্য_, piak_,
   {{0x61fd00f7,0xddc28035,0x7c21a280,0xd5fb827d}},	//   _uasl, mnoś, _solr, _khủ,
   {{0xddc28063,0x7c21e6da,0x21290359,0x644a854e}},	//   lnoś, _polr, qyah_, fifi,
   {{0x628f00ee,0xd90e0065,0x60cd09c4,0x644ae6db}},	//   _hico, _کیے_, mram, gifi,
   {{0xf1b9811f,0xf99180f7,0x60cd0174,0xff040081}},	//   taš_, يبة_, lram, _лятн,
   {{0x60cd0081,0x6d5b81c5,0x26c380e1,0x26d30118}},	//   oram, _txua, ájom_, muxo_,
   {{0x20558628,0x26cc85b4,0xa3d600a5,0x661d01a1}},	//   итор, erdo_, _हाल_, djsk,
   {{0x2001003d,0x644ae6dc,0xe3b0803d,0x764b84a7}},	//   ndhi_, cifi, _فرم_, ligy,
   {{0x2bab835a,0x60cd66dd,0x2bdc1299,0x69a690a1}},	//   _घ्या, hram, _बाबा, _ट्वी,
   {{0x7d0988e7,0x81cc80ab,0xddc2809a,0x7bc52718}},	//   _kres, শ্ব_, dnoś, _adhu,
   {{0x60cd1069,0x9f4c8081,0x99838084,0xe09e81bc}},	//   jram, ledì_, ėjų_, _tọọ_,
   {{0x69cb3cd4,0x62972795,0x26cc80d2,0x4fa59a19}},	//   ógen, _buxo, brdo_, _тикв,
   {{0x61e45b9e,0x290f00f2,0xae1e000f,0x9f4c8081}},	//   tfil, ågan_, _बचपन_, nedì_,
   {{0x60cd070b,0x644ad2b2,0x98a28110,0xc33284de}},	//   fram, zifi, šką_, קון_,
   {{0xdb03803e,0x628f66de,0x9f4701ac,0xada900f7}},	// [6900] vaný, _dico, ľný_, _صديق_,
   {{0x68f65f99,0x644ab075,0x9f47026f,0xf09f00ff}},	//   rwyd, xifi, žný_, _tràn_,
   {{0x628f66df,0x91e64a58,0x103680be,0x09e609a8}},	//   _fico, _коне, סטעם_, _конн,
   {{0xa3d6000f,0x2011004f,0x0e66b3d9,0x270580eb}},	//   _हाँ_, _enzi_, шкен, _mēn_,
   {{0x25a99e4f,0x644aa4cf,0x7afa826c,0x7d098888}},	//   ñala_, tifi, _sstt, _cres,
   {{0x63bc20d0,0x0ec581fe,0x26d301df,0x3e7c826f}},	//   narn, _विंड, buxo_, díte_,
   {{0x764b809c,0x15e780d4,0xb5fb04e8,0xdb1e1e1e}},	//   bigy, _टॉवर_, kláp, _odpí,
   {{0xe80a113d,0x628f023e,0xdb088338,0x62830037}},	//   _होता_, _xico, _nedå, _ènot,
   {{0x1da7223a,0xa3d6064d,0xd01080f7,0x64a39ea6}},	//   _क्षत, हला_, كلة_, _мата,
   {{0x6600e6e0,0x63bc19f0,0x69a68361,0x44e090ab}},	//   _hamk, jarn, _ट्री, mò_,
   {{0x63bc29dc,0x645a89da,0x44e09b72,0x44e280ff}},	//   darn, _ijti, lò_, _hư_,
   {{0x60cd0182,0x6602e6e1,0x6600e6e2,0x6e244ac7}},	//   yram, ndok, _jamk, _coib,
   {{0x628f0698,0x40969506,0x62840063,0x44e0946f}},	//   _rico, _трет, dmio, nò_,
   {{0x63bc18b6,0xddc28063,0x78a903bf,0xcfcc00ab}},	//   garn, tnoś, _çevi, র্তন,
   {{0x78a6008b,0xdddd0035,0x6e3627d1,0x8ff78019}},	//   _atkv, rosł, _flyb, _ضرور_,
   {{0x80c20321,0x0dcb0c4f,0xddc28035,0xdce98b67}},	//   _लिखे, _руки_, rnoś, _uzeć,
   {{0x5fdd901b,0x63b70201,0x51871507,0x9f581c72}},	// [6910] _मामल, _texn, рува, _darí_,
   {{0x60cd26d5,0x9f4786a5,0x7d0980f1,0x44e0bfd1}},	//   rram, _ganó_, _rres, dò_,
   {{0xfbdc035a,0xf7700277,0x7d0982a5,0x7a358b4c}},	//   _बातम, وام_, _sres, _láta,
   {{0x60c285f5,0x9f4c8081,0x7a3c8019,0x6600808e}},	//   _ovom, vedì_, _hétf, _camk,
   {{0xaca38028,0x44e2801c,0x60cd0201,0x6600982f}},	//   _trọn, _cư_, qram, _damk,
   {{0x26d301df,0x2291826c,0xdb050edd,0x7d09c5ca}},	//   puxo_, _aška_, _behø, _vres,
   {{0x9725003d,0xad9d809a,0xa3dc0f12,0x7a2a026f}},	//   _افزو, _paźd, ण्ट_, _výtv,
   {{0xe1f980ae,0x61e90074,0xb87b0118,0x3e7c816b}},	//   уги_, _öeld, _epít, títe_,
   {{0x63bc09da,0x7649a2b3,0x7d09e6e3,0x44e080e5}},	//   yarn, _imey, _ures, cò_,
   {{0x7e6d0b3f,0x6600809a,0x60c2824a,0x2bdc03eb}},	//   _akap, _zamk, _dvom, _बाधा,
   {{0x78a98db7,0x3e7c803e,0x6e240013,0x6fd8816f}},	//   spev, síte_, _poib, _मारू,
   {{0x63bc3996,0x44259104,0xdb150e93,0x80ad00ab}},	//   warn, _hol_, gazí, _চিন্,
   {{0x4425e6e4,0x682d88f1,0x998580f7,0x224d9151}},	//   _kol_, _lúdi, _الشو, miek_,
   {{0x53a30791,0x224de6e5,0x03a32098,0x7e6d66e6}},	//   зарб, liek_, зиро, _ekap,
   {{0x63bc66e7,0x09a900ab,0x8c432097,0x7c253dbb}},	//   rarn, _ওয়া, чере, _dohr,
   {{0x224ddbd7,0x9f45839c,0x442590b6,0x7a2a01fa}},	//   niek_, relä_, _lol_, _nýtt,
   {{0xdb188073,0x19b901e2,0x4fea1777,0x7a2e8014}},	// [6920] ravé, русь_, лман_, _dùth,
   {{0x66008125,0xdb018019,0x80cf8526,0x9588009a}},	//   _samk, _belü, _दिने, _ciąż,
   {{0xd9f9835a,0x93fb0158,0x644e5a91,0x44e2801c}},	//   ्यात_, _גליי, mibi, _sư_,
   {{0x0d86884b,0x44e0946f,0x05ba9a00,0x6d03e6e8}},	//   блен, tò_, ادات_, लिंग_,
   {{0x4425e6e9,0xe8df0028,0x6fd8800f,0x290b01a1}},	//   _bol_, _phục_, _मालू, _grca_,
   {{0x4425af10,0x68e40082,0x6fd5035f,0xa0a3217e}},	//   _col_, mtid, _місц, _хард,
   {{0x60c28052,0x4425e6ea,0x68e41aed,0xc5ed80c8}},	//   _svom, _dol_, ltid, ওয়া_,
   {{0x44e28104,0x644e66eb,0x5fa4016f,0x644d8036}},	//   _tư_, hibi, खुरल, éair,
   {{0x644e34c2,0x55548065,0xdced005c,0xa5078b02}},	//   kibi, _بھار, _izać, _лета_,
   {{0x7e6d088b,0xa3d28d14,0x644e1a9b,0x3202016b}},	//   _skap, _वाट_, jibi, _laky_,
   {{0x644e13d4,0xb05b0106,0x68e402f1,0xc7b301c6}},	//   dibi, _ovän, htid, הבת_,
   {{0x90e68077,0x60c280d2,0x68e40074,0xdb1c3089}},	//   _هستن, _tvom, ktid, parê,
   {{0x44259010,0x412a835f,0x7e93802e,0x6018a5af}},	//   _yol_, _щодо_, _săpt, _воля_,
   {{0x629aa0d4,0x3a268b3c,0x80a4803d,0x394001a9}},	//   _kuto, _hoop_, _همچن, dzis_,
   {{0x3a2685f8,0xa3e086b7,0x4ea68523,0xf1b9807a}},	//   _koop_, _थान_, _урла, ljša_,
   {{0x63bad9e9,0x629aa0ee,0xb4e88105,0x7a358718}},	//   _letn, _muto, _बहू_, _látn,
   {{0x644e66ec,0x3207001b,0xf1b9807a,0x629e816b}},	// [6930] bibi, ěny_, njša_, ípoj,
   {{0x644e160a,0x629ae6ed,0x224daffc,0x7d0d66ee}},	//   cibi, _outo, ziek_, _iras,
   {{0x2baf0dbc,0x4425831e,0xe7ea816f,0x3ea703b2}},	//   _ज्या, _rol_, ज्या_, ënt_,
   {{0x25e1023c,0x7bc8e6ef,0x9f5801e8,0xed51803d}},	//   _काफी_, _addu, _darà_, وپا_,
   {{0x4425979d,0x68e408f1,0x25e113e5,0x224d80e1}},	//   _pol_, ctid, _कानी_, viek_,
   {{0x9f58394c,0x63ba807d,0x629ae6f0,0xdb1c1b48}},	//   _farà_, _cetn, _buto, rgrö,
   {{0x224ddd2c,0xdb018073,0xdb1c66f1,0x3a2682df}},	//   tiek_, _reló, varë, _boop_,
   {{0x4425ac23,0x200328ab,0x7d0d66f2,0x644e66f3}},	//   _wol_, _haji_, _oras, zibi,
   {{0xdb1c020f,0x224d811e,0x200366f4,0x3a26874c}},	//   tarë, riek_, _kaji_, _doop_,
   {{0x9f5805a4,0x224d9c59,0x442583a7,0x20030010}},	//   _hará_, siek_, _uol_, _jaji_,
   {{0x7d0d448d,0x2003022e,0x629ae6f5,0x644e047f}},	//   _aras, _maji_, _guto, vibi,
   {{0x7d0d16cc,0x76598355,0x68e412cf,0x29188174}},	//   _bras, nnwy, ytid, ófaí_,
   {{0x1ddb0853,0x61e9d589,0x2be084c5,0xe81c000d}},	//   _भारत, mfel, _नामा, नामा_,
   {{0x7d0d4b38,0x69dbd26f,0xdb1c11a9,0x61e98357}},	//   _dras, lgue, laré, lfel,
   {{0x644e66f6,0x7d0d1611,0x26c7012b,0xe8168c2d}},	//   ribi, _eras, šnoj_, तारा_,
   {{0x644e1598,0x61e9bfcb,0x69dbb274,0x68e466f7}},	//   sibi, nfel, ngue, ttid,
   {{0x9f580698,0x7a358298,0x7a380118,0x602581d0}},	// [6940] _sarà_, _láto, _cíta, _témě,
   {{0x9f58146f,0x20034941,0x2005e6f8,0x39400162}},	//   _aará_, _caji_, ndli_, rzis_,
   {{0x6604025d,0xbddb03d3,0x63ba8bc5,0x3202001b}},	//   _kaik, mièr, _retn, _taky_,
   {{0xac9719f4,0xbddb02be,0x0caa891d,0x61e980f3}},	//   _دنیا_, lièr, атки_, jfel,
   {{0xb05b00f2,0x660466f9,0x9f582a63,0xdb170118}},	//   _kväl, _maik, _dará_, _rexé,
   {{0x66043d3b,0x629a8289,0x48f90158,0x7bdc66fa}},	//   _laik, _puto, _פּרא, ngru,
   {{0x752f0063,0x3f980a20,0x443a66fb,0x7a3c8019}},	//   zycz, _igru_, _mlp_, _léte,
   {{0x61e98065,0x1cba9381,0x660429fb,0x80ad00ab}},	//   gfel, _نائب_, _naik, _চিত্,
   {{0x60c43328,0x7bdc232f,0x320281ac,0x3e72016b}},	//   nsim, kgru, ľky_, nátu_,
   {{0x3202803e,0xdb1a820f,0x7b1680f7,0x59dc816f}},	//   žky_, _jetë, _وظائ, _यावर,
   {{0x91e690ee,0x907b0451,0xe7e20076,0x660434c6}},	//   _може, שטיי, _पानप, _baik,
   {{0x7d0d2c28,0x752f0d38,0x98b20063,0xdb1a80f1}},	//   _pras, tycz, czyć_, _letë,
   {{0x3ce6886f,0x08fa826a,0x66040110,0x7bdc01ec}},	//   ntov_, _خراب_, _daik, fgru,
   {{0xe80a65fa,0xdb08813c,0x7a3c82be,0x7d0d00f1}},	//   _होला_, _bedø, _déte, _vras,
   {{0x7c28c31e,0x443a0358,0x628281e9,0x200366fc}},	//   _modr, _dlp_, _khoo, _raji_,
   {{0x7d0d3528,0xdb188125,0x3ce6886f,0xaca30133}},	//   _tras, javí, ktov_, _ahụg,
   {{0x7c3a8698,0xdb1885b4,0x7bdc002a,0x60c4009c}},	// [6950] _oltr, daví, bgru, gsim,
   {{0x69c0e6fd,0x7c288029,0x6282b58e,0x38a08014}},	//   hame, _nodr, _lhoo, _mòr_,
   {{0xe7e285e8,0x69c0d3fa,0x660403f8,0x629a0019}},	//   _खाना_, kame, _yaik, ítot,
   {{0x7c3ae6fe,0x69c0ca77,0x6e228019,0x3e5600eb}},	//   _altr, jame, gjob, tāti_,
   {{0x7ec02067,0x03a59e25,0x7c28e66d,0x43d40180}},	//   _pápá, пило, _bodr, _عزیز,
   {{0xf1bf04c3,0x7c288162,0x96d3064a,0xb09a01c6}},	//   _xoán_, _codr, _डिपॉ, _לישר,
   {{0x68f903bf,0x7c289ee0,0x69c0e2c8,0x9f5c816b}},	//   şadı, _dodr, fame, _baví_,
   {{0x69c09092,0x6e229b88,0x3cff81c0,0x62828039}},	//   game, cjob, _tsuv_, _choo,
   {{0xc3cb803f,0x69db9fd6,0x62828079,0x61e9a66f}},	//   _نظام_, rgue, _dhoo, rfel,
   {{0x61e991d9,0x66040077,0x68fb87d5,0x764d36ed}},	//   sfel, _saik, rwud, _amay,
   {{0x660403ff,0x69c0d643,0xfd4d0028,0xdb238077}},	//   _paik, bame, _triệ, _توضی,
   {{0x7c2880f3,0x20038ee1,0xb05b0106,0x62828362}},	//   _zodr, žji_, _sväl, _ghoo,
   {{0x66042afb,0xbddb02be,0xf1b98353,0xc19a8039}},	//   _vaik, tièr, ljšo_, _השני,
   {{0xb068845b,0xf745840d,0x2bdc0072,0x44e41743}},	//   _وصول_, _нело, _बाळा, rö_,
   {{0x660407ac,0x7bdc0456,0xbddb00e7,0xd9e28105}},	//   _taik, rgru, rièr, क्कत_,
   {{0x7bdc04fe,0xee3f026f,0x60c45afe,0x160b80d4}},	//   sgru, chý_, tsim, _सोलर_,
   {{0x60c401e2,0xf1bf0028,0xdb1566ff,0x6f0e08ae}},	// [6960] usim, _toán_, razá, _srbc,
   {{0x3e72003e,0x88bd80c8,0x6e3b8136,0xa3d61513}},	//   rátu_, _আমাক, _alub, _हाट_,
   {{0x60c4452c,0x7c288c52,0xdb1a88cf,0x9f5807e2}},	//   ssim, _rodr, _vetë, _març_,
   {{0x69c0cd49,0x7c28e700,0x0d868436,0x6aa30511}},	//   xame, _sodr, плен, _énfa,
   {{0x60c401b9,0xdb18816b,0x6e229375,0x629e6701}},	//   qsim, raví, rjob, _hupo,
   {{0x29024672,0x044395b9,0x26c58110,0x68e48009}},	//   _iska_, нечн, kslo_, _äidi,
   {{0xd9f98bf5,0x628281c5,0x78a9017b,0x3ce6886f}},	//   ्यंत_, _phoo, _çevr, stov_,
   {{0x7584804e,0x224000e4,0x3ce6a39f,0xaf5b01c6}},	//   _قیام, nhik_, ptov_, _הכלכ,
   {{0xa3dd000f,0x629e15d0,0x26da6702,0x3e5600eb}},	//   _डाल_, _lupo, lupo_, nātu_,
   {{0x4734a05f,0xdefa97ae,0x645c6703,0x69cbaf96}},	//   днос, бым_, jnri, _edge,
   {{0x69c0e704,0x628281c5,0x290fe705,0x5fdd93ba}},	//   pame, _thoo, _erga_, _मारल,
   {{0x0f570039,0x6b7b80be,0x290202f1,0xc1e38c69}},	//   ליים_, _פראנ, _oska_, _गायब_,
   {{0x94058085,0x290f85f3,0x786f983d,0x6382e706}},	//   _ailə_, _grga_, røvr, _fíní,
   {{0xa3dd0072,0x629e038a,0x26da02c4,0x8aa71501}},	//   _डाळ_, _bupo, kupo_, зрад,
   {{0x7b64171c,0x629e3736,0x2d800870,0x63be008e}},	//   етте, _cupo, _ezie_, _depn,
   {{0x764d6707,0x20183da9,0xeb3b83de,0x645c0901}},	//   _umay, _anri_, זעלש, anri,
   {{0x236d009a,0x320680e4,0xa3d60072,0x2007041c}},	// [6970] łej_, _maoy_, _हाच_, ônio_,
   {{0x80cf816f,0xb60680c3,0x638707bc,0x6e29e708}},	//   _दिसे, _lešć, géné, _soeb,
   {{0xf1dc835a,0xfbd2036b,0x48f91e0b,0x26c7000d}},	//   _यांन, _בתי_, _उनको_, éno_,
   {{0xb8d30a49,0x224002d6,0xcf9380be,0xdd918829}},	//   _টি_, chik_, גטע_, نوا_,
   {{0xfce595b1,0xdb018019,0xf1bf0118,0xa3b9864a}},	//   фоло, _jelö, _joám_, चरल_,
   {{0x61e2e709,0x3e480019,0xdb1703a8,0x61ed670a}},	//   _acol, lőtt_, _lexí, lfal,
   {{0xdcfb817f,0x753c8085,0x6e29910f,0xb60680c3}},	//   _izuč, _ərzi, _toeb, _bešć,
   {{0x5f9400e9,0x394d07ca,0x61ed10f6,0x6e3b809a}},	//   _чист, _þess_, nfal, _ulub,
   {{0x7fd5a1d2,0xa3dd016f,0xa4d480e8,0x6289e70b}},	//   міні, डला_, _поті, rmeo,
   {{0xb02480ff,0x80dc8035,0xb5fb0216,0x2c760366}},	//   _phườ, पढ़े, zoát, pædi_,
   {{0x7bc3e70c,0xfe708019,0xfbe300ab,0xf771bb76}},	//   manu, _شدہ_, য়াত, ضاد_,
   {{0x200b8610,0xddc2877b,0x7bc3e70d,0x26c58110}},	//   ści_, zlož, lanu, rslo_,
   {{0x320952e6,0x7a359c18,0x290380eb,0x61ed670e}},	//   dday_, _látk, ājas_, dfal,
   {{0xb0248028,0x61ed1849,0x765d02f7,0xe29a3750}},	//   _thườ, efal, ansy, жав_,
   {{0xeb970b5b,0xe7e28770,0x03a32659,0xa2e3186c}},	//   дир_, _खाता_, тисо, корд,
   {{0xed5a07c4,0x7bc3e70f,0x25bf898b,0x2007e710}},	//   _мой_, hanu, _neul_, _hani_,
   {{0xdb1c2509,0x2007bcb2,0x68e9e711,0xf77884b7}},	// [6980] marí, _kani_, nted, mgħa_,
   {{0xdb1c1727,0x7a38009f,0x7a3c80e7,0x32090079}},	//   larí, _títo, _méta, aday_,
   {{0x8c1b0159,0x2007e712,0x441b0158,0x49ba0b8c}},	//   _וויי, _mani_, _וויס, _واحد_,
   {{0x60db8e05,0x68e987d9,0x2ca00006,0xdb1c2509}},	//   kuum, kted, _kuid_, narí,
   {{0x25e309a3,0x6e3d00f1,0x7bc3ba5c,0x68e9e165}},	//   ट्टी_, ërbi, fanu, jted,
   {{0x2ca06713,0x2007a486,0x7bc3e714,0x2ca9cd2c}},	//   _muid_, _nani_, ganu, íada_,
   {{0x5f030139,0x160e05e8,0xae0e085d,0xddc691b3}},	//   _изра, ियार_, ियान_, _обви,
   {{0x38a41836,0x7d04015e,0x2be0816f,0xdb1c1e09}},	//   _kör_, _osis, _नावा, jarí,
   {{0x2007e715,0x7bc382a0,0xdb1701df,0xdb1c0333}},	//   _bani_, banu, _rexí, darí,
   {{0x25e1053e,0x7a358064,0x7a3c83d3,0x2007e716}},	//   _काही_, _láth, _déta, _cani_,
   {{0x9343917e,0x38a4016d,0x32096717,0x61fbdad8}},	//   _инфе, _lör_, yday_, beul,
   {{0x442c826f,0xdb1c0333,0x32090079,0x99800084}},	//   _hod_, garí, xday_, nkių_,
   {{0x442c803a,0x2ca00ad0,0x7a310370,0x68e99916}},	//   _kod_, _cuid_, _mått, cted,
   {{0x2007c508,0x2ca006cb,0x32090079,0x628602d5}},	//   _gani_, _duid_, wday_, _ahko,
   {{0x442ce718,0x7d046719,0x61ed39d7,0xc1088028}},	//   _mod_, _esis, tfal, _hỗ_,
   {{0x442ce71a,0x38a400f2,0x7c3e3644,0xdb1c05e4}},	//   _lod_, _bör_, _elpr, carí,
   {{0x20078214,0xf09f001c,0x261c1199,0x764289e1}},	// [6990] _yani_, _quà_, यारी_, dhoy,
   {{0xe61089d7,0x25bf82be,0x61ed3ff4,0x47d080ab}},	//   یشن_, _seul_, sfal, ত্রী,
   {{0x6455640c,0x249f8176,0x2cad8b40,0x2ca000f3}},	//   mizi, _suum_, _sted_, _zuid_,
   {{0x38a4671b,0x80cf816f,0x32090079,0x7bc3b0a0}},	//   _för_, _दिले, qday_, wanu,
   {{0x38a404b8,0x442c8355,0x7bc394c7,0x6e2d0bb1}},	//   _gör_, _bod_, tanu, _moab,
   {{0xd3788063,0x6385b383,0xdb85802e,0xe299e71c}},	//   _być_, нгла, нгли, пак_,
   {{0x2be0853f,0x442ca87f,0x7bc3e71d,0x2ba70c28}},	//   _नारा, _dod_, ranu, _खलना,
   {{0x200780a4,0x68e99dd5,0x645518e9,0x443ee71e}},	//   _sani_, tted, hizi, _elt_,
   {{0x442c8355,0x64550883,0xdb1c08a4,0x661b9fb7}},	//   _fod_, kizi, varí, _inuk,
   {{0x44e9a980,0x68e9e71f,0x442c8a85,0x9bf48103}},	//   mú_, rted, _god_, _изуч,
   {{0x68e984c6,0x64556720,0xdb1c388a,0x2007911b}},	//   sted, dizi, tarí, _vani_,
   {{0x20078a73,0x2bb8116e,0xa3ab8fcc,0xdd1282d0}},	//   _wani_, अर्थ, कुर_, nüşt,
   {{0x7bc18812,0x2007e721,0x64556722,0x442ce723}},	//   _kelu, _tani_, fizi, _yod_,
   {{0x628608cf,0x38a4016d,0xdb1c1f5c,0x64552290}},	//   _shko, _rör_, sarí, gizi,
   {{0x6d460063,0xe80a0063,0x7bc1a7df,0x60c9ac1d}},	//   szka, _होगा_, _melu, lsem,
   {{0x7bc1c23b,0x7d041827,0xdb260065,0x629980dd}},	//   _lelu, _tsis, _épít, _jiwo,
   {{0x69c4631b,0xe0da1367,0x44e9e724,0x64556725}},	// [69a0] raie, ява_, jú_, bizi,
   {{0x64550249,0x661be726,0x60c9a2b9,0x7bc1e064}},	//   cizi, _anuk, isem, _nelu,
   {{0x6443ce6a,0x66098708,0xe7e28424,0x671f8701}},	//   dhni, _baek, _खासा_, यमिक_,
   {{0x7a35cc16,0xdb1e6727,0x442ce728,0x60c98100}},	//   _fáti, _repè, _sod_, ksem,
   {{0x7bc193b8,0xd250803d,0x62980036,0xdb1c3666}},	//   _belu, ینت_, _évoq, barã,
   {{0xa3ab9513,0xdee602de,0xa2a489c8,0x66e6280f}},	//   कुल_, _поги, _चंद्, _пога,
   {{0x7bc1895e,0x81e980c8,0x25e10bb8,0x442ce729}},	//   _delu, য়ন_, _काली_, _vod_,
   {{0x6fdd80d4,0x62998041,0x998900e1,0x64553556}},	//   _माउं, _ciwo, skať_, zizi,
   {{0x200a0c6a,0x0d868b30,0x7bc1e72a,0xe21380f7}},	//   _kabi_, _члан, _felu, طبيع,
   {{0x7bc185f8,0x63b3826f,0x6e2d002a,0x64a3a853}},	//   _gelu, čení, _soab, _сафа,
   {{0x8ad68eca,0x60c9956e,0x085701c6,0x998d80c3}},	//   _ستائ, asem, תבים_, rkeš_,
   {{0x200a672b,0x11e980f7,0x2f5b007c,0x7bc1e72c}},	//   _labi_, _يعني_, לדינ, _zelu,
   {{0x6455672d,0x6aa18359,0xe0d480be,0xda6f8019}},	//   tizi, _zulf, _סײַ_, _اُن_,
   {{0x200a672e,0x7e640242,0xdb1acf45,0xda1e86ae}},	//   _nabi_, _ejip, _letí, भावत_,
   {{0x64551917,0xb05b0338,0xdb1c16dc,0x3e641238}},	//   rizi, _kväv, garà, sıta_,
   {{0x6455665d,0xa3dd000f,0x26de826f,0x2d84826c}},	//   sizi, _डाक_, muto_, _ozme_,
   {{0x26ded7e8,0xdb1c0187,0xa3e092c6,0x628d365d}},	// [69b0] luto_, tarã, थला_, rmao,
   {{0x7e7d088b,0xd2510416,0x44e981ac,0xb881801b}},	//   llsp, _چند_, vú_, _říze,
   {{0xd6db1367,0x26dee72f,0x7bc76730,0xdced0024}},	//   ята_, nuto_, maju, _izađ,
   {{0xdb0504b8,0x7bc1a6db,0x7bc70abf,0x60c9b2ce}},	//   _behö, _selu, laju, ysem,
   {{0x78a28021,0x7bc194ff,0xdb1c04ab,0x64438c41}},	//   _nuov, _pelu, mará, thni,
   {{0x200a5c6d,0x2ef500c4,0x6299e731,0x44e9bfe5}},	//   _gabi_, _изгр, _siwo, rú_,
   {{0x68ed0510,0x26debd0f,0x44e9cdfc,0xf1b98353}},	//   ltad, juto_, sú_, ljši_,
   {{0x26de8003,0x60c9e732,0x661b8289,0x6443e733}},	//   duto_, tsem, _unuk, shni,
   {{0x39492511,0xe664919d,0x7bc1ac17,0xdb0502af}},	//   nzas_, _стро, _telu, _gehö,
   {{0xe7398188,0x60c99922,0x68ed0ece,0x7bc700d2}},	//   део_, rsem, itad, jaju,
   {{0x60c9e734,0x7bc70025,0x9f458388,0x68ed6735}},	//   ssem, daju, veló_, htad,
   {{0xed5a3aa3,0x68ed59af,0x657b816f,0xdb1c6736}},	//   дом_, ktad, _kyuh, jará,
   {{0xdb1c6737,0xc692807c,0xda1e8035,0x26dee738}},	//   dará, יאט_, भारत_, auto_,
   {{0x26dee739,0x98798158,0x307980be,0x09ca0072}},	//   buto_, _קאַט, _קאַנ, िण्य,
   {{0x200a1cc5,0x39490144,0xfaa60dae,0xf8bf217b}},	//   _rabi_, ezas_, табо, _awé_,
   {{0x200a02b8,0x68ed673a,0xdb1c157a,0x3b0700a9}},	//   _sabi_, ftad, gará, њето_,
   {{0x65698168,0x64418198,0xe9df046d,0x68ed673b}},	// [69c0] _nxeh, _olli, _amús_, gtad,
   {{0x7a38433a,0x161a13e5,0x2d9f8362,0x25ade73c}},	//   _míti, धाकर_, _ague_, _afel_,
   {{0x7a380125,0x290f016d,0x657ba914,0x39492720}},	//   _líti, ågar_, _ayuh, azas_,
   {{0xee3a8160,0x75d38013,0x947380d5,0xe9a6013a}},	//   ьне_, ليما, یدوا, _шамп,
   {{0x200a673d,0x68ed11b9,0xd4e38009,0x200c831d}},	//   _tabi_, ctad, ающи, yddi_,
   {{0x61e407d9,0x07a6038c,0x5c7385e9,0x7d028559}},	//   lgil, _јавн, аліт, rwos,
   {{0x78a2e73e,0x7a358177,0x15f40054,0x969681e5}},	//   _suov, _látu, ेजार_, _араш,
   {{0x61e449de,0x26de8081,0xd7e2001b,0x2281807b}},	//   ngil, vuto_, _पाँच, sókn_,
   {{0x2d848052,0x7e6281f4,0x7a3803f2,0x64a6865c}},	//   _uzme_, mnop, _cíti, _раза,
   {{0x26ded7e8,0xdb1c05e4,0x7eb881a1,0x9f458037}},	//   tuto_, zará, нгос_, velò_,
   {{0x7bc70025,0xa3e7e73f,0x2bdc1094,0x481500be}},	//   vaju, _भात_, _बाजा, אַרן_,
   {{0xf1e10996,0xf7730039,0x7d16245f,0xd00b00ab}},	//   _फाइन, יקת_, _brys, রায়_,
   {{0xe0469b47,0x0fe2016f,0x320b45e3,0x26de9a14}},	//   _инди, _पांढ, _racy_, suto_,
   {{0x7a358e14,0x7e62e740,0x26deca10,0x6458875e}},	//   _dátu, hnop, puto_, nivi,
   {{0x7bc74f7d,0xdb1c6741,0xe81f95bc,0x82a42ba7}},	//   raju, tará, बारा_, иште,
   {{0x68ed6742,0xcbe300c8,0x7bc7002e,0x1fcb001b}},	//   ttad, য়েছ, saju, ाण्ड,
   {{0xdb1c2a8c,0x68e084a7,0x6458b65d,0x3a2902f7}},	// [69d0] rará, numd, kivi, rjap_,
   {{0x1621053e,0x394902ba,0xdb1c188b,0x6e3d41c2}},	//   यावर_, rzas_, sará, lksb,
   {{0x660d6743,0xdb1c4028,0x533549e3,0x657b9600}},	//   _kaak, pará, _сент, _syuh,
   {{0xe7ff0321,0xb90900ab,0x2ca482f7,0xaee3026b}},	//   _उसका_, _মন_, _bumd_, _aiṣa,
   {{0xd1268bbe,0x660d6744,0x58d40698,0x89da036b}},	//   _ام_, _maak, _коят, _אחרי,
   {{0x660d28fb,0x7a359eca,0x2a668122,0x69c681fa}},	//   _laak, _látt, _ajob_, ðken,
   {{0x629d3d90,0x7a380187,0xed59807a,0x7bc56745}},	//   _kiso, _síti, _težo_, _mehu,
   {{0x20016746,0x660d1328,0x7a35807b,0x629d236a}},	//   lehi_, _naak, _nátt, _jiso,
   {{0x629d5dc6,0x68e0bbce,0x3d94ac81,0xe81f92c6}},	//   _miso, gumd, _витр, बाला_,
   {{0x7659864c,0x7b088009,0x7a380548,0x7bc56747}},	//   liwy, ästä, _víti, _nehu,
   {{0x8eb2803d,0x660d0365,0xe2030072,0x7a359b88}},	//   یمیش, _baak, _लसूण_, _bátt,
   {{0x60cd3456,0x7d166748,0x20cf00eb,0x68e0ac8f}},	//   ksam, _prys, kļi_, bumd,
   {{0x7bc503b2,0x61e403bf,0x7d0982f9,0xee37002e}},	//   _behu, vgil, _jses, уня_,
   {{0xd0068381,0x60dbadd4,0x629d6749,0x7d1601b0}},	//   _беше_, mrum, _aiso, _vrys,
   {{0x60dbb7e4,0xdea1815b,0xcb672d55,0x7bc50168}},	//   lrum, _دیجی, гаре_, _dehu,
   {{0x41b5522f,0x7d161670,0x645880fa,0x629d0d56}},	//   исут, _trys, zivi, _ciso,
   {{0xdb1a8207,0x7644022e,0x60cd1066,0x7e62805c}},	// [69e0] _metá, _iliy, gsam, vnop,
   {{0x660d674a,0xdb1a816b,0x7bc506a8,0x629d0114}},	//   _zaak, _letá, _gehu, _eiso,
   {{0x4444674b,0x7d09e74c,0x6458e74d,0x7a358019}},	//   _il_, _ases, vivi, _játs,
   {{0x64a695e3,0x5d6a8009,0xb05b00e1,0x629d0314}},	//   гада, нием_, _svät, _giso,
   {{0x444415f8,0x81e98a49,0x7bc501bf,0x7a358061}},	//   _kl_, য়া_, _yehu, _láts,
   {{0x4444674e,0x07a304db,0x69c61989,0x83f882a4}},	//   _jl_, _гарн, _heke, текс_,
   {{0x69c6674f,0xb5fb001b,0x76441a14,0xa3d50072}},	//   _keke, dnán, _oliy, हणत_,
   {{0x6458e750,0x5a349878,0xdd0881ac,0x44444ff8}},	//   sivi, рнит, môže, _ll_,
   {{0x44446751,0xb05b016d,0xdb1a802a,0x660d2c52}},	//   _ol_, _tvät, _detá, _raak,
   {{0x44446752,0x76446753,0x660d1e89,0x68e0817b}},	//   _nl_, _aliy, _saak, rumd,
   {{0x764406c0,0x2a7f822c,0x049381a8,0x7bca81f6}},	//   _bliy, blub_, _اللح, mafu,
   {{0x69c66754,0x7bc5010b,0xdb08816d,0x7bcae690}},	//   _neke, _sehu, _bedö, lafu,
   {{0x444454e6,0x60dbba21,0x629d6755,0x3c398205}},	//   _bl_, crum, _riso, _sèvi_,
   {{0x7bcaac91,0x660d26e8,0x76446756,0x9f5e80e7}},	//   nafu, _waak, _eliy, heté_,
   {{0x69c66757,0x629d2eaa,0x43950c6c,0xe2f810ac}},	//   _beke, _piso, равс, лері_,
   {{0x44446758,0xf127025d,0x200ee759,0x78a610d3}},	//   _el_, льзо, _hafi_, _bukv,
   {{0xd49b0765,0x44442f1e,0x7bcaae5e,0x69c6675a}},	// [69f0] _про_, _fl_, kafu, _deke,
   {{0x4444675b,0x60cd07d5,0xee3f001b,0x629d018e}},	//   _gl_, rsam, lký_, _wiso,
   {{0x200e80a4,0x69c61464,0x629d463a,0xa2a48d86}},	//   _mafi_, _feke, _tiso, _चूल्,
   {{0x69c60574,0x2001059e,0x60cd675c,0xb5fb01d0}},	//   _geke, sehi_, psam, znán,
   {{0x1d098d31,0xa5099017,0xb05b0338,0x7bcae75d}},	//   тели_, тела_, _dvär, fafu,
   {{0x69c60613,0x7bcaaaf6,0xab5c80eb,0x200e80ee}},	//   _zeke, gafu, _ceļo, _nafi_,
   {{0xb5fb001b,0x645700b9,0x249e8176,0x290b0580}},	//   vnán, _mmxi, _ditm_, _hsca_,
   {{0xa3e78665,0xd5f98158,0x6eaa064a,0xe8f988ed}},	//   _भाव_, _שפּר, _जंतु, вли_,
   {{0x7a3c80e7,0xdb1e02b7,0x681b00eb,0x7bcac67d}},	//   _méth, _repí, _tādē, bafu,
   {{0xb4c18076,0xb8fd800f,0x60dbc929,0x200eb631}},	//   ंठी_, _तट_, rrum, _cafi_,
   {{0xb5fb02ba,0x3f6982dc,0x69cf8333,0x200e9325}},	//   rnán, тино_, óces, _dafi_,
   {{0x44210104,0x7ae3b946,0x64451a9b,0x60db9bb3}},	//   _anh_, munt, _alhi, prum,
   {{0x4444675e,0x69c61543,0x64a61330,0x44330039}},	//   _pl_, _reke, рага, _box_,
   {{0x7e6982fd,0x69c6675f,0x998480f7,0x93460d46}},	//   _ljep, _seke, _الهو, анге,
   {{0x69c627ba,0x7e7b85e7,0x42560328,0x7ae3e760}},	//   _peke, _okup, атат, nunt,
   {{0xee3f0a56,0xc2430af2,0x76440a6c,0x200e8041}},	//   cký_, онск, _uliy, _zafi_,
   {{0x44446761,0xe2972262,0x2fc7e762,0x61ebcb77}},	// [6a00] _tl_, рат_, _keng_, _mcgl,
   {{0x44441717,0x3ea78613,0x7ae39413,0x69c60a0f}},	//   _ul_, _kunt_, kunt, _weke,
   {{0xeaf4853e,0x69c606dc,0x645c4b40,0x7ae3aeaa}},	//   _आहेत_, _teke, miri, junt,
   {{0x645c5e7e,0x320f8065,0x7e6994ce,0x13a8026a}},	//   liri, _nagy_, _cjep, _جنگی_,
   {{0x7bcad542,0xcfaa006b,0x44330085,0x9f5e8036}},	//   tafu, _لازم_, _yox_, reté_,
   {{0x645c1efb,0x2fc78077,0x67210699,0x394d80eb}},	//   niri, _neng_, _šlje, dzes_,
   {{0x7ae3d938,0xa3e78054,0x68e42805,0xb05b016d}},	//   gunt, _भार_, luid, _tvär,
   {{0x7a380510,0x645c4b2e,0xfb198065,0x200eba5c}},	//   _títu, hiri, اروں_, _safi_,
   {{0x645c4b40,0xe8df0104,0xfbc604e5,0x68e41493}},	//   kiri, _việc_, वराम, nuid,
   {{0x645c6763,0x7ae3e764,0x7a3c82be,0x249e83ac}},	//   jiri, bunt, _méti, _uitm_,
   {{0x645c6765,0x2fc7e766,0xcb679c79,0x2d8000ee}},	//   diri, _deng_, _кафе_, _ayie_,
   {{0x8c3c87d9,0xe7ea9513,0x60c2bf1e,0xd6d80264}},	//   _diğe, ज्जा_, _twom, _সহায,
   {{0x7bc89a67,0x645c0b3f,0x443300b9,0x261c05fc}},	//   _kedu, firi, _pox_, याजी_,
   {{0x645c5ab6,0xee3f0400,0xe0fb8039,0x2fc7e767}},	//   giri, ský_, _סלול, _geng_,
   {{0x224903f8,0xeaf4816f,0x224685e6,0x31c7157b}},	//   thak_, _आहोत_, _klok_, исав,
   {{0x645c00f7,0x7bc897cf,0x3ea002c4,0x3e72016b}},	//   airi, _ledu, _giit_, káty_,
   {{0xe29f1c86,0x645c29ef,0x765d3a7f,0x22490057}},	// [6a10] _við_, biri, misy, rhak_,
   {{0x7e7b836f,0x2fc70104,0x765d6768,0x645c585b}},	//   _skup, úng_, lisy, ciri,
   {{0x261c1880,0x7ae381df,0x2246978f,0x81de80ab}},	//   याची_, xunt, _olok_, দ্য_,
   {{0x32048063,0x765d0247,0x68e4435e,0x7d0d0326}},	//   jemy_, nisy, buid, _ksas,
   {{0xb4c18076,0x7bc8e769,0x38c9004e,0x68e40333}},	//   ंठे_, _bedu, _حاجی_, cuid,
   {{0x7ae3e76a,0xfaa582cb,0x2246ac11,0x1cb80039}},	//   tunt, бако, _alok_, סלול_,
   {{0x25e8035a,0x8b948098,0xdb15016a,0x2ca902c4}},	//   _झाली_, оръч, mazó, _luad_,
   {{0x7ae3e76b,0x7e7b80fa,0x3ea780f2,0x2fc7e060}},	//   runt, _ukup, _runt_, _seng_,
   {{0x3ea78c6e,0x320f8117,0x20111b74,0x26de9965}},	//   _sunt_, _vagy_, _kazi_, erto_,
   {{0x3ea7e76c,0x7bc8e76d,0x22468ad4,0x3ea00074}},	//   _punt_, _gedu, _elok_, _siit_,
   {{0x394d8065,0x2246e76e,0x2011676f,0xa3ac923a}},	//   szes_, _flok_, _mazi_, _गलत_,
   {{0x2909386c,0x7bd704c3,0x7d1b9db4,0x2ca90239}},	//   kwaa_, _adxu, _krus, _buad_,
   {{0x645c6359,0xba748013,0xa8a7a856,0x2fc795d7}},	//   tiri, _بالت, _трек, _teng_,
   {{0x61e98b11,0x81ae80ab,0xaf49845b,0x3dd804b7}},	//   lgel, করণ_, _مشعل_, _żewġ_,
   {{0x2005a733,0x7d0d0d6a,0x765d2588,0x28ddbffa}},	//   meli_, _esas, bisy, _मिडि,
   {{0x61e98ded,0x645c1253,0x68e426d5,0x2005e770}},	//   ngel, siri, tuid, leli_,
   {{0x645c6771,0x201143fe,0x6e246772,0xdb170118}},	// [6a20] piri, _bazi_, _inib, _xexú,
   {{0xdb1507f4,0x66062e1d,0x68e45a4a,0x2240067f}},	//   gazó, lekk, ruid, skik_,
   {{0x7afe23fe,0x7d1be773,0xb5fb016b,0x61f63860}},	//   _uppt, _arus, znám, pfyl,
   {{0x7bc8e774,0x7bce6775,0x80d893f5,0x7a3ce776}},	//   _sedu, labu, _मिले, _hétv,
   {{0x7bc8c45d,0x2005cebe,0x644a80f7,0x61e981b4}},	//   _pedu, keli_, thfi, dgel,
   {{0x200582ce,0x7bce4674,0x765d142a,0x3e72027f}},	//   jeli_, nabu, zisy, ráty_,
   {{0x6e246777,0x753d009a,0x61e9e778,0x66e30a42}},	//   _onib, zysz, fgel, _нора,
   {{0x2618057a,0x61e9bb39,0x9f58047f,0x7bce6016}},	//   _बोली_, ggel, _farò_, habu,
   {{0x7bce1dde,0x765d4463,0x7bc88359,0x7d1be779}},	//   kabu, visy, _tedu, _grus,
   {{0x6b81b6bd,0x2005dafe,0x7bce005d,0x27178129}},	//   _fylg, geli_, jabu, _băn_,
   {{0x43868064,0x907b012a,0x765d0247,0x28dde5fa}},	//   _الاق, רטיי, tisy, _मिथि,
   {{0xdb1a8198,0x2ca900b9,0xf99f010c,0x3f8281a9}},	//   _vetä, _puad_, _kaèt_, āku_,
   {{0xb9968013,0x765d60f6,0x91e382c7,0xdb1e002a}},	//   _الشب, risy, _хоче, _repá,
   {{0x765d10c1,0x26de8353,0x9f5ee77a,0x2005e77b}},	//   sisy, prto_, letí_, celi_,
   {{0x765d5123,0xa3d0aeff,0x66060357,0x9f4ca4a3}},	//   pisy, _वजन_, bekk, redó_,
   {{0x62840698,0x2aa8148d,0x2909004f,0x7f8381a8}},	//   glio, стро_, twaa_, _علين,
   {{0x51871507,0x38351afa,0x7bce467d,0x621b83de}},	// [6a30] сува, онар, babu, נומק,
   {{0x6aa28706,0x7d1b83ed,0x9998002e,0x81ae8264}},	//   _liof, _rrus, скут_, করি_,
   {{0xdb153bb4,0x7d1b8042,0xdcfb816b,0x9f58047f}},	//   razó, _srus, _vyuč, _sarò_,
   {{0x2005b327,0x6448811e,0x20112486,0xceb380be}},	//   zeli_, _aldi, _wazi_, ליע_,
   {{0x2005805d,0x7ae71b3b,0x7e6d405e,0x61e9826c}},	//   yeli_, lujt, _mjap, vgel,
   {{0x42d98750,0x987900be,0x26c28390,0x20059598}},	//   афия_, _כאָט, ćkoj_, xeli_,
   {{0x61e98c72,0xa3b886a7,0xfd4a18b2,0xa2299cce}},	//   tgel, चड़_, _bulọ, ижка_,
   {{0xe0d980ae,0x8c0980c8,0x2005a486,0x6448df39}},	//   ави_, লাইন_, weli_, _eldi,
   {{0x61e9e77c,0x2d99c033,0x7bce2290,0xdb18816b}},	//   rgel, _àse_, yabu, mavý,
   {{0x7ae72009,0x61e994fb,0x6e36151e,0xd7660065}},	//   kujt, sgel, _soyb, _انہی,
   {{0x81de80c8,0x61e99989,0x6443809a,0x61fd0831}},	//   দ্ধ_, pgel, mkni, _obsl,
   {{0x27178104,0x4425973d,0x64438082,0x7ae7026f}},	//   _văn_, _hnl_, lkni, dujt,
   {{0xa5bb0125,0x7bce0542,0x6606401c,0xe8ee8b69}},	//   tjór, tabu, rekk, _юл_,
   {{0xf7459814,0x64438bbd,0x2d8d8010,0x660627d6}},	//   _мело, nkni, _mzee_, sekk,
   {{0xa3e7901b,0x7bce4cb3,0x69cb8057,0x4911800d}},	//   _भाई_, rabu, _kege, तिको_,
   {{0x6e245fda,0x7bce2025,0xa2cc80d4,0x69cb8eb9}},	//   _unib, sabu, _सबस्, _jege,
   {{0x69cbe1ad,0x7bce242d,0xb33c822b,0x6284677d}},	// [6a40] _mege, pabu, _agħl, rlio,
   {{0x61ef1ac6,0x69cbca2b,0xb90203ca,0x6721011f}},	//   _eccl, _lege, _धि_, _šlja,
   {{0xeda682de,0x62842dee,0x1eda00f7,0xdb0500ff}},	//   ошло, plio, شباب_, _nghè,
   {{0x69cbe77e,0x5efa8158,0x0d86c197,0x5bb4b54d}},	//   _nege, יפעד, олен, ुर्व,
   {{0xc27b0051,0x764280dd,0x2c0f016f,0xb33c8197}},	//   _כרטי, rkoy, ायचं_, _egħl,
   {{0x764984be,0x2bbf1a46,0x8cdb873c,0x442587f1}},	//   _eley, ्रया, _निरो, _cnl_,
   {{0x68f60a53,0x2d8d85ee,0x7649e77f,0x290f82ed}},	//   ltyd, _ezee_, _fley, _asga_,
   {{0x7649807b,0xb95b0091,0x26d88298,0x4425d8e5}},	//   _gley, _adìy, árom_, _enl_,
   {{0xed5a8003,0x69cbe780,0x2bbf0d14,0x661d807b}},	//   _тоа_, _dege, ्रमा, _óska,
   {{0x644380f2,0xdced080a,0x290f8037,0x291d8176}},	//   ckni, _ayağ, _dsga_, _drwa_,
   {{0xc7b30051,0x3eb88168,0x41aa1b7e,0xd7f88162}},	//   ובת_, ërt_, कशास, rfă_,
   {{0x69cb8c1b,0x8b65ca1c,0xdb1f2320,0x78a389e7}},	//   _gege, _عالم, ðvík, _einv,
   {{0xb5fb00f7,0xa06a84ae,0x225787d2,0xb86582e3}},	//   nnái, _када_, _بلند_, _کانو,
   {{0x7ae7230a,0x61ef0122,0x69cbe781,0xaaa986a7}},	//   tujt, _sccl, _zege, _चूँक,
   {{0x3a268cab,0xd25b0a9f,0xb5fb0061,0x69cb8314}},	//   _knop_, аца_, riáb, _yege,
   {{0x7ae76782,0x42db80be,0xdb1a8144,0x78a3890d}},	//   rujt, יקלע, _betú, _zinv,
   {{0x37ab1182,0x25a90074,0x7ae742e4,0xc69400be}},	// [6a50] атен_, _igal_, sujt, _קאפ_,
   {{0x7ae7136f,0x7a3c8061,0xb33c822b,0x7bde8144}},	//   pujt, _kéts, _agħm, ópul,
   {{0x7649e783,0xaaa98105,0x64800009,0xb5fb3fe5}},	//   _pley, _चूंक, röit, ciác,
   {{0x9f58007b,0x8f9b8039,0x2d9984e8,0xdb05027d}},	//   _varð_, ביבי, _úsek_, _nghé,
   {{0x69cb87b3,0x5184012f,0x44258087,0xc984002e}},	//   _rege, _жура, _pnl_, _жури,
   {{0x69cb89ca,0x61ed6784,0x7e7d6785,0x78ab80c3}},	//   _sege, lgal, hosp, _rugv,
   {{0x64438bfa,0x81ce00c8,0xfe7392dc,0x224dc8c7}},	//   rkni, _রাত_, _قدر_, thek_,
   {{0x765b82a0,0x6443cf3a,0xefc8001c,0x00c98e8e}},	//   _umuy, skni, _đỉnh_, блик_,
   {{0x7e7d5fac,0x7a3c8125,0x225fc97f,0xddc4017f}},	//   dosp, _rétt, riuk_, _njiš,
   {{0xa2dc123a,0x69cb9cb6,0x25a9002a,0x25b6175d}},	//   _फिल्, _wege, _agal_, ूर्ण,
   {{0x69cbe786,0x2cad8609,0x224da00b,0x2019928a}},	//   _tege, _hued_, phek_, ěsi_,
   {{0x3ea400f2,0x63b5009a,0xaca3801c,0x291d8035}},	//   ömt_, eczn, _trồn, _trwa_,
   {{0x61ed6787,0x78a382a6,0xe16781a8,0xed598bcf}},	//   dgal, _tinv, _بداي, _težu_,
   {{0x25a96788,0xe1ff0091,0xd47980be,0x78a3808e}},	//   _egal_, _abó_, מאָל, _uinv,
   {{0xd00e8307,0x68e98c0b,0x8b2327a9,0x7e6b82d5}},	//   _إلى_, lued, ндре, kngp,
   {{0xcb12893f,0x61ed3722,0x9f96807c,0x57568039}},	//   עלן_, ggal, _צדקה_, _מבצע_,
   {{0xdb1c0e15,0x80a62b7e,0x9abc82a6,0xb5fb15d8}},	// [6a60] mbrí, سمان, _irċe, siác,
   {{0x61ed0365,0x6f0388ae,0x3ea4e789,0x68f61a23}},	//   agal, _kpnc, _simt_, rtyd,
   {{0x645e4b67,0x443a3fd2,0xe4570158,0x8cb20540}},	//   _impi, _iop_, _זייט_, _इंडो,
   {{0xe1ff077f,0x7a3c8019,0x3a390639,0x2d848661}},	//   _gbó_, _létr, _gosp_, _pyme_,
   {{0x69c41ed4,0x2ca58cb4,0x443a3ccd,0xdb1c00f7}},	//   mbie, _bild_, _kop_, ibrí,
   {{0x69c4678a,0xb5fb00f7,0x7d040c2e,0xe81b82f1}},	//   lbie, rnái, _mpis, _भोला_,
   {{0x443a02ee,0x6ada06a7,0x60230071,0xaab89190}},	//   _mop_, _बटोर, _ядра, زگار_,
   {{0x7d04678b,0x68e407a3,0x69c433fc,0x443a0129}},	//   _opis, orid, nbie, _lop_,
   {{0x63b50063,0xfce39232,0x588681e5,0x68e98114}},	//   yczn, _пото, зына, gued,
   {{0x645d8110,0x7e6285fe,0x68e41581,0xbc639033}},	//   _įsig, liop, irid, _звук,
   {{0x68e4678c,0x7a3c80e7,0xa2b1462c,0xb914819d}},	//   hrid, _détr, _आंध्, _yadị_,
   {{0x645e22ac,0x648d80f7,0x68e43a4c,0x69c4051c}},	//   _ampi, núin, krid, jbie,
   {{0x6d42e78d,0x7aea93c2,0x69c4678e,0x51839bdc}},	//   nyoa, luft, dbie, _пуша,
   {{0x2ca51de9,0x7e62e78f,0x69c43e5b,0x9f580216}},	//   öld_, hiop, ebie, _abrí_,
   {{0xb5fb003e,0x1dcc8b84,0x61ed1482,0xd5cc9b7e}},	//   dnáv, ारात, tgal, ाराज,
   {{0x81de80c8,0x7c3ad400,0x61ed6790,0x62340073}},	//   দ্র_, _lotr, ugal, несу,
   {{0x61ed6791,0x68e46792,0x7c2884e8,0x3eae82f7}},	// [6a70] rgal, grid, _ondr, _huft_,
   {{0x7c3ae793,0x37ab1537,0x61ed110a,0x3014002e}},	//   _notr, стан_, sgal, ндур,
   {{0x69c424c5,0x442b801c,0x68e402f1,0x212b8129}},	//   bbie, _đc_, arid, ̣ch_,
   {{0x7c288082,0x28dd946d,0x7c3a8229,0xf2d200be}},	//   _andr, _मिलि, _aotr, _בעט_,
   {{0x2ab187a3,0x26d8609d,0xa3b1131d,0x1c22009a}},	//   _sáb_, _evro_, _ओला_, माचल_,
   {{0x6282e794,0x7c3a8493,0xd7f81860,0x05748180}},	//   _akoo, _cotr, _нус_, راند,
   {{0x69cf059c,0xfbd080f7,0x764d2192,0x2ca5806a}},	//   _kece, اته_, _olay, _vild_,
   {{0x7c28a40f,0x7e628706,0x69cf0079,0x2fce8176}},	//   _endr, ciop, _jece, _aefg_,
   {{0x61fba3ea,0x2cad8074,0x7a3cb4d3,0x7c3ad913}},	//   rful, _uued_, _pétr, _fotr,
   {{0x09aa1344,0x764d6795,0xddc280fe,0xefc80104}},	//   _कल्य, _alay, mnoš, _định_,
   {{0x69dd1024,0x7d04054f,0x6e3bc741,0x443a6796}},	//   _odse, _spis, _koub, _rop_,
   {{0x69cf2c04,0xb5fb026f,0x2b4f8214,0x443a584a}},	//   _nece, znáv, ımcı_, _sop_,
   {{0x205595e0,0x68e9a34a,0x6e3b8bb1,0x629b80e5}},	//   _откр, qued, _moub, mmuo,
   {{0x69dd0358,0x7d040353,0x6e3be797,0x6289e798}},	//   _adse, _vpis, _loub, lleo,
   {{0xdca30f2f,0x7d040063,0x64a30a8e,0xddcb005c}},	//   тари, _wpis, тара, žišn,
   {{0x7ae10065,0xd0480086,0x69cf6799,0x2a6dd877}},	//   álta, ələr, _cece, nneb_,
   {{0x443a0add,0x7d04003a,0x78a70a0f,0xda6515a9}},	// [6a80] _top_, _upis, _bijv, رافي,
   {{0xb8f64a4d,0xddc2805c,0x69c4679a,0x645e3d44}},	//   _सब_, dnoš, sbie, _umpi,
   {{0x6e3b9c7d,0x6289e79b,0x69cf5d5d,0xe61ab7cd}},	//   _boub, kleo, _fece, жде_,
   {{0xa3d0823c,0x69cf679c,0x7c288359,0x93ee0bb8}},	//   _वजह_, _gece, _sndr, _जाँच_,
   {{0x6da3a482,0xc8798380,0xb33c8372,0xe5a39092}},	//   вица, luşu_, _igħi, вици,
   {{0x6282879f,0xf1bf8e15,0x7e629ae3,0xdb07251d}},	//   _skoo, ñán_, siop, rbjö,
   {{0x7c3a86e3,0x161985b3,0x6289831d,0xdb1c016a}},	//   _votr, _नोकर_, fleo, maró,
   {{0x2018672e,0x37e300ab,0x41e68221,0xb33c84b7}},	//   _hari_, ন্দর, фіка, _jgħi,
   {{0x93ee023c,0x95839401,0x3f878079,0x6282808e}},	//   _जांच_, _алте, _aynu_, _vkoo,
   {{0x201833d2,0x7c288bcb,0x47348fe7,0xdb1c01a8}},	//   _jari_, _undr, енос, naró,
   {{0x764d279a,0x2bbf04c5,0x26d88866,0x9b468c3b}},	//   _play, ्रसा, éro_, _تناو,
   {{0x2018679d,0x81e400ab,0x21298267,0xbddb00e7}},	//   _lari_, প্ত_, _šahe_, thèq,
   {{0xdc3a02bb,0x6280dc0d,0x981380d7,0x25ad07dd}},	//   _açıl, momo, ربیا, želo_,
   {{0x6280bc9b,0x2018130e,0xb5fb016a,0x28b5064a}},	//   lomo, _nari_, cián, _अंबि,
   {{0x200cc09e,0x69cf3bfe,0xd6cf98ed,0x8aa7373a}},	//   medi_, _pece, _шт_, драд,
   {{0x764d0010,0x1da71834,0xdb1200f7,0x2018020d}},	//   _ulay, _गणपत, ógái, _aari_,
   {{0x20180f69,0x69cf158d,0x6e3b89b2,0xb33c8197}},	// [6a90] _bari_, _vece, _roub, _dgħi,
   {{0x20180393,0x6e3b800d,0xdfd10013,0x26000006}},	//   _cari_, _soub, ايا_, ष्ठी_,
   {{0x20181dae,0x628086a0,0x3ea954d2,0xb8d6199e}},	//   _dari_, komo, _kiat_, _चू_,
   {{0xb05b1bc0,0xb93500a9,0x69dd006a,0x2bbf0aed}},	//   _städ, _земј, _udse, ्रवा,
   {{0x6280ce32,0x20180ba0,0x3ce6e79e,0xe3a51190}},	//   domo, _fari_, grov_, _تشکی,
   {{0x20184508,0x200c82fd,0x3ea90877,0xf8bf679f}},	//   _gari_, jedi_, _liat_, _crée_,
   {{0x27f8026f,0xe784432b,0x6e3b9f1b,0x68ed6478}},	//   žený_, _ауто, _toub, luad,
   {{0xe9d99285,0x3ea9059c,0x62808110,0x201800b4}},	//   чки_, _niat_, gomo, _zari_,
   {{0x20180578,0x5c75860a,0x9f5e8009,0x629b8110}},	//   _yari_, _злат, hetä_, rmuo,
   {{0x1bee05b3,0xc05200be,0xb5fb016b,0x271e8609}},	//   _जाइल_, ָזט_, znát, _bċn_,
   {{0x6289e7a0,0xb5fb0c83,0x22b867a1,0x7bd567a2}},	//   pleo, rián, _očka_, dazu,
   {{0xf772010f,0xf6521a00,0x248582c4,0xee37373a}},	//   רקט_, ائد_, _hklm_, еню_,
   {{0x61d68039,0x200cb275,0xe1ff007b,0xb7d58032}},	//   _נוסף_, bedi_, _ljós_, _aṣer,
   {{0x68ed26d5,0x200ce7a3,0x6f150035,0x26dc01d6}},	//   duad, cedi_, _oszc, ávok_,
   {{0xf8bf38a7,0xa3c2823c,0x20184792,0xaca3819d}},	//   _até_, ूरत_, _rari_, _apịn,
   {{0xc3328bea,0x2cbf80d2,0xf2d280be,0x629c8037}},	//   נון_, _otud_, טעל_, _èrot,
   {{0x2018010a,0x66040a6d,0x26d881ac,0x68ed2eaa}},	// [6aa0] _pari_, _ibik, árov_, guad,
   {{0x6d465c1f,0xb4fb0051,0x7e661a92,0x201867a4}},	//   myka, _צפיי, likp, _qari_,
   {{0x20180a45,0x6d460190,0xb33c81b9,0x75240088}},	//   _vari_, lyka, _tgħi, _hriz,
   {{0x3ce6dcb3,0xee3ab10c,0x201802a0,0x6723817f}},	//   trov_, яне_, _wari_, _mrnj,
   {{0x7c3e0988,0x68ed02ba,0x6280e7a5,0xb5fb67a6}},	//   _kopr, cuad, vomo, onár,
   {{0x28b51094,0x7c3e00eb,0x60c41269,0x2bfb81fe}},	//   _अंति, _jopr, mpim, ल्लू_,
   {{0x6fd6823c,0x68fbe516,0x6280cdd1,0xe8e000ff}},	//   _मजबू, etud, tomo, _ruột_,
   {{0xd257d67f,0xdff00b85,0x69d62b82,0x98c68fbf}},	//   ець_, _चाँद_, naye, нсол,
   {{0x68fbbb1d,0x50669597,0xc8668ff7,0x998004b7}},	//   gtud, етна, етни, jjiż_,
   {{0x6280bd8b,0x66040121,0x672380d2,0x3ea967a7}},	//   somo, _abik, _brnj, _siat_,
   {{0x442c8ae1,0x200cb9d0,0x69d667a8,0x6280e7a9}},	//   _ind_, redi_, kaye, pomo,
   {{0xb5fb03b0,0x2120003a,0x200c9a4d,0x443e8039}},	//   ciál, kvih_, sedi_, _hot_,
   {{0x443ea52d,0x200cc154,0x38b600b2,0x5c070098}},	//   _kot_, pedi_, _nær_, нява,
   {{0x62862231,0x31578158,0xddc9920e,0x7c3e24eb}},	//   _akko, _אידן_, _mješ, _copr,
   {{0x443e919b,0x7c3e267b,0x7bd543fe,0xc4c48117}},	//   _mot_, _dopr, razu, _گے_,
   {{0x69d637fc,0x98a7026c,0x443e824d,0xdb1a8168}},	//   gaye, _điđa_, _lot_, _aftë,
   {{0x60f91006,0x442c8355,0x660f003e,0x6ca71980}},	// [6ab0] ьная_, _ond_, meck, _прож,
   {{0x443e804c,0x28e20076,0x661d67aa,0x660f4a65}},	//   _not_, _पिरि, ldsk, leck,
   {{0xbbbf0bb8,0x68ed05ee,0x69d667ab,0xe8020006}},	//   ्रीक, suad, baye, _रउरा_,
   {{0x442ce7ac,0x661d2280,0x660f026f,0x38b667ad}},	//   _and_, ndsk, neck, _fær_,
   {{0xed588cde,0x68ed67ae,0x442c82f7,0x38b6007b}},	//   ної_, quad, _bnd_, _gær_,
   {{0xe52267af,0x442ce7b0,0x7e66026c,0x660f4538}},	//   मिति_, _cnd_, zikp, heck,
   {{0x998d8bcf,0x6f150035,0xa7fc811c,0x443eca2b}},	//   dješ_, _uszc, hnıs, _dot_,
   {{0x442c8039,0x68fba131,0x78aa8037,0x661d184e}},	//   _end_, ttud, _aifv, jdsk,
   {{0xb5fb1c18,0x443ee7b1,0x660f1d4e,0x442c8362}},	//   riál, _fot_, deck, _fnd_,
   {{0x6e2d67b2,0x661be7b3,0x68fbe7b4,0x7d09e7b5}},	//   _anab, _hauk, rtud, _ipes,
   {{0xdddb801b,0x661b8f52,0xaca30133,0xdb1c007b}},	//   _zkuš, _kauk, _chọg, jarð,
   {{0x7c3e67b6,0x2f548e86,0x6723e7b7,0x661b8612}},	//   _sopr, утьс, _vrnj, _jauk,
   {{0x69c99a25,0x0d990fe6,0x443e8176,0x9599143d}},	//   mbee, етры_, _yot_, етру_,
   {{0x661ba57b,0xe73184c0,0x69c98079,0x69d61c38}},	//   _lauk, _نصب_, lbee, waye,
   {{0xe739835f,0x38b627d1,0xdb1c008b,0xaca3019d}},	//   _цей_, _sær_, garð, _ghọg,
   {{0x26c5a6d5,0x661be7b8,0x69c9b29a,0x628d67b9}},	//   mplo_, _nauk, nbee, glao,
   {{0x69d63670,0xa3c1886a,0x7aee2f70,0x7c3e0214}},	// [6ac0] raye, ंडा_, subt, _topr,
   {{0xddc982fd,0x0b460002,0x69d667ba,0x38b60b40}},	//   _rješ, _анон, saye, _vær_,
   {{0x7d0983a7,0x68e9831d,0x443ee7bb,0xdddb8796}},	//   _apes, hred, _rot_, _skuš,
   {{0x443ee7bc,0x38b667bd,0xddc9920e,0x60db87b8}},	//   _sot_, _tær_, _pješ, ksum,
   {{0x661bafd5,0x443e9603,0x9cb380f7,0x68e9e7be}},	//   _dauk, _pot_, لمنت, jred,
   {{0xddc9920e,0x8d5b0039,0xddc2816b,0x7d090315}},	//   _vješ, וכני, dnoť, çesi,
   {{0x443eba5d,0xdb1a8c52,0x442c801c,0x68e9e7bf}},	//   _vot_, _retó, _vnd_, ered,
   {{0x68e9a9dc,0x69c9d039,0xddc98d26,0xf2d301c6}},	//   fred, gbee, _tješ, בעה_,
   {{0x660f67c0,0x6fd6823c,0x6da39a47,0xd0108013}},	//   veck, _मजदू, _вита, ملة_,
   {{0x442ce7c1,0x6e2d04b8,0x67210024,0x7054804e}},	//   _und_, _snab, _šlji, اندا,
   {{0x660f1ee0,0x1df901bb,0x7640c500,0x7bd8e7c2}},	//   teck, нены_, _komy, mavu,
   {{0xe80217a3,0x26f2800f,0x68e993c2,0xc8e200d4}},	//   र्ता_, _अमीर_, bred, _पिंट,
   {{0x660f5c29,0x2cac81e0,0x3dd780ab,0xb884001b}},	//   reck, _kidd_, _হামল, _zvíř,
   {{0x7bd8c71c,0x1dc318b1,0x26d88061,0x60cd82d0}},	//   navu, _व्रत, áros_, _çama,
   {{0xe5c71c82,0x07f789d7,0x7e64008e,0xa3d4016f}},	//   _испо, _شروع_, _fmip, _हजर_,
   {{0x35f50b87,0x2c6d026c,0x201c8061,0xf8bf1ab3}},	//   _спир, džde_, _havi_, _aréa_,
   {{0x51871507,0x7bd8e7c3,0x201ca7b1,0x661b8a41}},	// [6ad0] тува, kavu, _kavi_, _rauk,
   {{0x201c80ce,0x661bd001,0xdbcd007b,0x75228259}},	//   _javi_, _sauk, _góðu, dvoz,
   {{0x7d09e7c4,0x61e29ee0,0x661ba63b,0x97a75812}},	//   _spes, _odol, _pauk, трал,
   {{0x60c29a9f,0x201c8247,0x7bca81c0,0x61e2b1ca}},	//   _otom, _lavi_, ebfu, _ndol,
   {{0xf1bf077f,0x66d90032,0x752280c3,0x76408f39}},	//   _ifá_, _bùká, gvoz, _domy,
   {{0x68e98289,0x61e2e7c5,0x291904b7,0x7bd8c722}},	//   vred, _adol, _issa_, gavu,
   {{0x60c2e7c6,0x9f3400e8,0x8c428ada,0x661bb014}},	//   _atom, _кері, сеще, _tauk,
   {{0x60db92a5,0x2126808e,0x76408176,0xe81b82f1}},	//   tsum, _broh_, _gomy, _भोजा_,
   {{0x69c9bade,0x201c803b,0x39491400,0x7fd58a4c}},	//   rbee, _bavi_, nyas_, ліні,
   {{0xf4848d70,0x0495803f,0x2a6901e9,0x201c847f}},	//   _кухн, _صلاح, hiab_, _cavi_,
   {{0x68e9935a,0x60dbe02b,0x201c82df,0x212689c4}},	//   sred, ssum, _davi_, _eroh_,
   {{0x29195819,0x6441b437,0x3949512d,0x21268192}},	//   _ossa_, _holi, kyas_, _froh_,
   {{0x3ead822b,0x28dd9130,0x62581b88,0x49dabd9b}},	//   _miet_, _मिटि, _híog, _سانگ_,
   {{0xfbe580c8,0x64418866,0x3eadaa13,0xfba5036d}},	//   প্রত, _joli, _liet_, _गृहम,
   {{0x91e60ba5,0x09e62964,0x29193194,0x3ce90072}},	//   лове, ловн, _assa_, _जिथे_,
   {{0x3ead9dbe,0x42551519,0x6441da17,0x7bd8b77f}},	//   _niet_, атут, _loli, zavu,
   {{0x0e9b0039,0x7bd8abd7,0x2d8d819d,0x9e650e06}},	// [6ae0] _אשקל, yavu, _nyee_, _خاون,
   {{0x6441e7c7,0x69cb008b,0x201ce7c8,0x25bf8326}},	//   _noli, ðger, _xavi_, _aful_,
   {{0x291918a0,0x93fb00be,0x7640809a,0x224d8019}},	//   _essa_, _אליי, _pomy, kkek_,
   {{0x201c011f,0xd01c80ab,0x64418326,0xdb1c05ec}},	//   žvi_, তায়_, _aoli, rbrä,
   {{0x6441928d,0x6602ad27,0x044690ca,0xa0760198}},	//   _boli, rfok, ледн, _бывш,
   {{0x224d808e,0x61f60114,0x29001c40,0x644e67c9}},	//   ekek_, lgyl, mtia_, nkbi,
   {{0x7bd8e7ca,0x3d1609c8,0x29000722,0x9696e7cb}},	//   ravu, _पैसे_, ltia_, _браш,
   {{0x3eada70c,0x77910416,0x6441b648,0x998907c0}},	//   _giet_, _بیما, _eoli, ndaş_,
   {{0x290027f1,0xa2bb0f0f,0x286a95e0,0xd7fac3e1}},	//   ntia_, _शून्, ерно_, нун_,
   {{0x0d759006,0x3ead8a0f,0x29005df6,0x64a68791}},	//   _тыся, _ziet_, itia_, _саза,
   {{0xa3c181fe,0x29000198,0xde5900e8,0x201c867f}},	//   ंडर_, htia_, вані_, _vavi_,
   {{0x22421786,0x2a69022c,0xe7e0801b,0x644e0299}},	//   _nokk_, xiab_, _गएका_, ekbi,
   {{0x60c2e7cc,0x80b002f1,0xf992bb76,0x201ce7cd}},	//   _utom, _अंगे, _ابا_, _tavi_,
   {{0x2a6681c0,0x6441ca4e,0x6458e7ce,0x29190f3e}},	//   _hmob_, _xoli, nhvi, _rssa_,
   {{0x56950698,0xce950098,0x7ac4004a,0x2d840192}},	//   _какт, _какъ, йсте, ümer_,
   {{0x1fdd00ba,0x7ae85138,0xea019029,0x26dee7cf}},	//   मण्ड, ádta, _đẫy_, msto_,
   {{0x52d18b9f,0x3f980267,0x19580a14,0x3eadd5c8}},	// [6af0] _सब्स, _azru_, гаты_, _riet_,
   {{0x7d0d3162,0x2a6901c5,0x26dec43e,0x3eadb4cd}},	//   _ipas, siab_, osto_, _siet_,
   {{0x64418aa8,0xdb1e0510,0x3ead8cfa,0x290067d0}},	//   _roli, _depó, _piet_, atia_,
   {{0x2bbf0778,0x6441af96,0x51870992,0x7d0d01bc}},	//   ्रका, _soli, _буга, _kpas,
   {{0xa3c1800f,0x2900002e,0x3ead801c,0x62580473}},	//   ंडल_, ctia_, _viet_, _díod,
   {{0x26deccc5,0x80c380c8,0x68ed01e4,0x6721192c}},	//   ksto_, _শিল্, mrad, _šlju,
   {{0x64418b5d,0x7bd70118,0x68ed67d1,0x26deb1a7}},	//   _voli, _mexu, lrad, jsto_,
   {{0xc245a6b1,0x7bd74d5a,0x69cd0683,0x68ed0c41}},	//   рник, _lexu, nbae, orad,
   {{0x68ed34e7,0x6441e7d2,0xe0d68a7f,0x26dea536}},	//   nrad, _toli, авы_, esto_,
   {{0x7d1be7d3,0x7e6b83ba,0xaf059bcc,0x6fe001d0}},	//   _isus, ligp, апол, mácí,
   {{0x68ed0775,0xd37180f7,0x7d0d2aa4,0xfb15826a}},	//   hrad, _بها_, _apas, _خواج,
   {{0x68ed1e1d,0xd13180f7,0x7529b8e9,0x76598114}},	//   krad, _وما_, _krez, nhwy,
   {{0x68ed246d,0x463a83de,0x528481a8,0xb0640799}},	//   jrad, דערע, _النك, nmäß,
   {{0x8fa5a29c,0xb05b29ed,0x752981dd,0x7e6b820d}},	//   _кале, _stän, _mrez, higp,
   {{0x05d581fe,0x6609e7d4,0xdb1e67d5,0x7e6b8bb1}},	//   दराब, _obek, _repó, kigp,
   {{0xbbd1800d,0x29002f47,0x68ed67d6,0x212d0267}},	//   हरुक, ttia_, frad, _šeha_,
   {{0x68ed2872,0x7d1b8146,0xe3b20829,0x98e601a8}},	// [6b00] grad, _nsus, _ورد_, شكاو,
   {{0x60c982be,0x69db82af,0x290067d7,0xdb1e03ec}},	//   ipem, haue, rtia_, _depò,
   {{0x44440698,0x7d1bd5d6,0x7bdc33f5,0x7529e7d8}},	//   _io_, _asus, maru, _arez,
   {{0x7529be6b,0x7bc1b0f8,0x8f9a8039,0x3ced011f}},	//   _brez, _aflu, דיעי, ševe_,
   {{0x44445252,0x6aa40682,0x68910065,0xbbd1800d}},	//   _ko_, mmif, _کیلئ, हरूक,
   {{0x26de8079,0x24078162,0x3ce9009a,0xd90d003d}},	//   ysto_, инчи_, _जिसे_, _سیم_,
   {{0x444467d9,0x66e33eb1,0xdb1a8019,0x7529e7da}},	//   _mo_, _мора, _letö, _erez,
   {{0x444467db,0x3ce9803b,0x7659ad12,0x7bdc49c6}},	//   _lo_, šava_, chwy, haru,
   {{0x44446525,0x7bdc67dc,0x7529e7dd,0x7aee007a}},	//   _oo_, karu, _grez, hrbt,
   {{0x44442c04,0x6609ae56,0xb8fe901b,0x7bdc06df}},	//   _no_, _zbek, _तब_, jaru,
   {{0x7d0d0289,0x7bd701df,0x68ed0450,0x61e60259}},	//   _spas, _rexu, zrad, _odkl,
   {{0x444407e1,0x6e20cbad,0xf76f87bd,0xe1ff0118}},	//   _ao_, _jamb, باً_, _amón_,
   {{0x444467de,0x6e20e7df,0x7d0281f9,0x7bdc443f}},	//   _bo_, _mamb, ntos, faru,
   {{0x6e209cc5,0x44440039,0x7bdc67e0,0x7c8712b2}},	//   _lamb, _co_, garu, руме,
   {{0x4444004c,0x883b8039,0xc5d780ab,0x6fcc8a27}},	//   _do_, _בתגו, _হাসপ, _द्यू,
   {{0x6e20a9b6,0x444446dd,0x09aa80ab,0x0f5781c6}},	//   _namb, _eo_, _গ্যা, _כיום_,
   {{0x44444208,0x7bdc3e4c,0x7d0d67e1,0x69cd00ee}},	// [6b10] _fo_, baru, _upas, rbae,
   {{0x44441301,0x752980f1,0xd7f88087,0x7bdc0087}},	//   _go_, _rrez, ngă_, caru,
   {{0x4ea781e5,0xd12699f4,0x6e20e7e2,0x68ed016d}},	//   арда, _کم_, _bamb, srad,
   {{0x444467e3,0x68ed4088,0x6e22adf3,0x6e209b7d}},	//   _zo_, prad, gdob, _camb,
   {{0x444467e4,0x6e20e7e5,0xf8bf0c83,0xe7f00105}},	//   _yo_, _damb, _krém_, _चाचा_,
   {{0x44442056,0x44210074,0x3eb82152,0x7529ac00}},	//   _xo_, _jah_, _furt_, _vrez,
   {{0x44213d34,0x644567e6,0x03a58198,0x69db89af}},	//   _mah_, _mohi, щико, taue,
   {{0x6e20845f,0x4421059c,0xe8f993b4,0xeb780039}},	//   _gamb, _lah_, гли_, יעוץ_,
   {{0x7e69e7e7,0x0fd9827e,0x69dbc5cb,0x7bdc0a5a}},	//   _imep, льны_, raue, yaru,
   {{0x4421016f,0x69dbb20e,0xdb1c67e8,0xf1bf128a}},	//   _nah_, saue, scré, _znát_,
   {{0x444467e9,0x9b958013,0xab9580f7,0x6e20c141}},	//   _ro_, _الات, _الاغ, _yamb,
   {{0x44441964,0xb05b04b8,0x60c9e7ea,0x7bdc20c5}},	//   _so_, _stäl, ppem, waru,
   {{0x442167eb,0x7e698135,0x69d9867f,0x64454e21}},	//   _bah_, _mmep, _iewe, _bohi,
   {{0x6e228d26,0x442100d7,0x7e7b811f,0x69d989c4}},	//   zdob, _cah_, _ljup, _hewe,
   {{0x444467ec,0x442114ff,0x7d028065,0x7bdc28d6}},	//   _vo_, _dah_, ztos, raru,
   {{0x444467ed,0x7bdc1d36,0xe1f98110,0xc3328039}},	//   _wo_, saru, ngų_, הול_,
   {{0x444467ee,0x6e208b50,0x394db86a,0x3eb8081a}},	// [6b20] _to_, _ramb, nyes_, _surt_,
   {{0x69d9879f,0xd12f0f99,0x7e69804f,0xe73a1ef3}},	//   _lewe, عمل_, _amep, лез_,
   {{0x6e20a34d,0xbc680065,0xfa6a084b,0xb5fb0907}},	//   _pamb, _مجھے_, _банк_, riáv,
   {{0x7d029a53,0x291d8247,0x6e2290dc,0x212b00c3}},	//   ttos, _oswa_, udob, _frch_,
   {{0xd6258307,0x6e22e7ef,0x4421016f,0x7e7b8687}},	//   تعلي, rdob, _yah_, _djup,
   {{0x70560277,0x7d02ce28,0x6f1301df,0x68460d9d}},	//   _انسا, rtos, ñecí, _унга,
   {{0x69d98df3,0xa3d90305,0x7d029ff1,0xa6f280ab}},	//   _bewe, ारत_, stos, _জন্ম_,
   {{0x69d9816f,0x3ce9009a,0xd25781bb,0xa3e800d4}},	//   _cewe, _जिले_, йцы_, मृत_,
   {{0xdfd08307,0xed508117,0x69d99d10,0x6fe2800d}},	//   وية_, _تھا_, _dewe, jící,
   {{0x2bcf886a,0xd7f8802e,0x3ea68bb1,0x3ea04412}},	//   _स्पा, ugă_, lmot_, _ahit_,
   {{0xe2ca8021,0x20028063,0x3aeb804e,0x3ea00362}},	//   _след_, ęki_, _مبنی_, _bhit_,
   {{0x69d9905d,0x44212c17,0x644500dd,0x291a89a7}},	//   _gewe, _sah_, _sohi, _مقصد_,
   {{0x7bdae7f0,0xa9679285,0xb05b00f2,0x442167f1}},	//   _ketu, _лица_, _stäm, _pah_,
   {{0x7af500ad,0x645c2323,0x3a22019d,0xe9478065}},	//   tuzt, ghri, _aakp_, _درمی,
   {{0x7bdae7f2,0xb8659a37,0x2246858f,0x78a90037}},	//   _metu, _بانو, _kook_, _èevi,
   {{0x442167f3,0x7bdae7f4,0x78ba001b,0x2bcf81a2}},	//   _wah_, _letu, _čtvr, _स्ना,
   {{0x442167f5,0x644567f6,0x31342306,0x625801a8}},	// [6b30] _tah_, _tohi, петр, _síoc,
   {{0x645c1d77,0x7bdab1c2,0x22468806,0x261380ff}},	//   chri, _netu, _look_, _ảo_,
   {{0x625c83e6,0xe1f98084,0x38ad00c3,0x752d04e8}},	//   _géog, ygų_, _hžrk_, _hraz,
   {{0x3e721601,0x752d06c0,0x9f5e8144,0x395f80b9}},	//   pšte_, _kraz, letó_, yzus_,
   {{0x7bdae7f7,0x8c458284,0x660d534f,0x22be81bc}},	//   _betu, желе, _mbak, _ọkpa_,
   {{0x7bdae0f9,0x752d0696,0x69d9d5f2,0x386a0239}},	//   _cetu, _mraz, _sewe, _gmbr_,
   {{0x7bdae7f8,0x44d68063,0xda598568,0x22468039}},	//   _detu, ał_, ириш_, _book_,
   {{0xe1f98110,0x752d00df,0x7e69804f,0x69df0168}},	//   ugų_, _oraz, _umep, naqe,
   {{0x212be7f9,0x7bdae7fa,0x60cd5b34,0x2a6de7fb}},	//   ích_, _fetu, npam, rieb_,
   {{0x7bdae7fc,0x660d2896,0x60cd3666,0x69d9b7c0}},	//   _getu, _abak, ipam, _wewe,
   {{0xe80b0e70,0x2bcf801b,0x752d67fd,0xa5bb1427}},	//   स्या_, _स्या, _araz, rdón,
   {{0xd02200ab,0x68ee88c5,0xf5061f5e,0x59a9064a}},	//   নায়_, ündü, озмо, कधार,
   {{0x80c38a49,0x645c3337,0x37e59d2f,0x2bc68b6f}},	//   _শিক্, thri, _долг, रुवा,
   {{0x2bcf9094,0x61fbe7fe,0xe1ff0118,0xf1b283c8}},	//   _स्मा, lgul, _acó_, _חסד_,
   {{0x69df0168,0x3ea04d01,0x752d67ff,0x645c008b}},	//   faqe, _thit_, _eraz, rhri,
   {{0x61fbb3cd,0x3ced01dd,0x660d0135,0x49ca03a7}},	//   ngul, ševa_, _gbak, рлан_,
   {{0x752d6800,0x645c6801,0x3d19800d,0x60cd1066}},	// [6b40] _graz, phri, _मैले_, gpam,
   {{0xd378826c,0x320901b4,0xb5fb0118,0x7d040372}},	//   _heće_, afay_, siát, _iqis,
   {{0x2bd01880,0xef1a1330,0x6e2402b8,0x7bda879a}},	//   _त्या, рме_, _kaib, _retu,
   {{0x7bdabb5b,0xb5fb5188,0x1ea984a3,0xb87b008b}},	//   _setu, chád, ماني_, _hvíl,
   {{0x7bda859c,0x6e24221b,0x224690c7,0x290403ed}},	//   _petu, _maib, _rook_, _ëma_,
   {{0x68e40448,0x6e243af6,0x98a6801b,0xc1d2816f}},	//   msid, _laib, _proč_, सर्ग,
   {{0xd25a8abe,0x7bdae802,0x68e4209b,0x2246820d}},	//   ици_, _vetu, lsid, _pook_,
   {{0xd378803a,0x61fb82ec,0x6e240c61,0x69c40cf7}},	//   _neće_, ggul, _naib, ncie,
   {{0x68e46803,0x7bda9588,0xdddd00e1,0x22b581a9}},	//   nsid, _tetu, nosť, _sākt_,
   {{0x224690e4,0x31af880a,0x2904e804,0x61fbd4c0}},	//   _wook_, _sözü_, rtma_, agul,
   {{0x38170051,0x6e246805,0xa3d912ee,0xd7bb03c8}},	//   חקים_, _baib, ारस_, יציר,
   {{0x752d6806,0x6448bc8a,0x6e240834,0x6fd68072}},	//   _praz, _hodi, _caib, _मजकू,
   {{0x61e08457,0x6e24051e,0x6448bf3c,0xa3be8a27}},	//   maml, _daib, _kodi, _इला_,
   {{0x6448ca96,0xd14980d5,0xd00f80f7,0xc1d30c2d}},	//   _jodi, _دشمن_, _لله_, तर्ग,
   {{0x9f470182,0x6448bc72,0x68e42a83,0x926b041c}},	//   ünü_, _modi, esid, араа_,
   {{0xddc407d9,0xa75b8039,0x95cb00a9,0x21290353}},	//   _iliş, _כדור, _тука_, tvah_,
   {{0x50f50364,0xb5fb6807,0x69df0168,0x68e46808}},	// [6b50] язат, siás, raqe, gsid,
   {{0x6448a26f,0xf72b0790,0xb5fd8267,0xb5fb241f}},	//   _nodi, ицей_, _imši, ciár,
   {{0x87e40009,0xe3d880ab,0xdefb01e5,0x501b8039}},	//   ьюте, _সাংব, рыз_, שובו,
   {{0x69c40c9f,0x645ace17,0x64488706,0x60cd6809}},	//   ccie, _alti, _aodi, ppam,
   {{0x672e00f2,0x2600035a,0x7c2502d0,0x28dad2d5}},	//   _erbj, ष्टी_, _kahr, _मौलि,
   {{0x7c250352,0x6448c58e,0x645500f3,0x2bc6801b}},	//   _jahr, _codi, nkzi, रुला,
   {{0x69dd0812,0x64488025,0xd6c30077,0x999900e1}},	//   _kese, _dodi, _آمری, _dosť_,
   {{0x625800f7,0x6aa2e80a,0x6448808e,0x61e0d91b}},	//   _líon, _chof, _eodi, gaml,
   {{0x2bcf90c5,0x69dd3e55,0xe80b053f,0x6e240307}},	//   _स्था, _mese, स्था_, _raib,
   {{0x6448803a,0x7c250696,0x6e242a4e,0x7e6d64f0}},	//   _godi, _nahr, _saib, _amap,
   {{0xe7bc8424,0x69c4009a,0xb5fb0187,0x44258197}},	//   ोड़प, ycie, viár, _ial_,
   {{0x64438289,0x4425e80b,0x69dd3ef9,0xe80b0aad}},	//   ljni, _hal_, _nese, स्ता_,
   {{0xd378803b,0x7c2505a3,0x4425e80c,0x4a9a83c8}},	//   _veće_, _bahr, _kal_, _פינג,
   {{0xdb1c680d,0xddc98582,0xb042801c,0x78b500d2}},	//   scrí, _njež, _thưở, _nizv,
   {{0x44258e7c,0x69dd37fd,0x765be80e,0x42561cc7}},	//   _mal_, _bese, _oluy, птат,
   {{0xb21b065d,0x78b500eb,0x69dd680f,0x69c400eb}},	//   _skær, _aizv, _cese, ucie,
   {{0x7c250352,0x69c46810,0xddc982ce,0x672e01a1}},	// [6b60] _fahr, rcie, _bjež, _srbj,
   {{0xb4d81880,0x68e40d1a,0x69c44db0,0x3979035f}},	//   ाठी_, rsid, scie, істю_,
   {{0x68e42416,0x69dd6811,0x61eb812b,0x3bbb0039}},	//   ssid, _fese, _odgl, _למיד,
   {{0x6448acc7,0x69dd3577,0x7c2503cb,0x442581b4}},	//   _sodi, _gese, _zahr, _aal_,
   {{0x7bde085c,0x27e1583a,0x225fe812,0x61e08380}},	//   _kepu, bahn_, dhuk_, vaml,
   {{0x44259209,0x7bde1083,0x6aa2e813,0x6448b32e}},	//   _cal_, _jepu, _shof, _qodi,
   {{0x4425e814,0x765b8216,0x7bde01bc,0xdb1c5d2a}},	//   _dal_, _fluy, _mepu, mbró,
   {{0x201a0968,0x7bde6815,0x22b800c3,0x9f58041c}},	//   lepi_, _lepu, _učku_, _ecrã_,
   {{0xd90e9125,0x61eb03a8,0x4425d128,0x6448b5f7}},	//   ایت_, ógli, _fal_, _todi,
   {{0x4425e816,0x645ac3b1,0x61e0aa4f,0xe786bc7a}},	//   _gal_, _ulti, saml, зумо,
   {{0xd9a9020e,0x09db80ab,0x21270129,0x6abe018e}},	//   _कण्ट, _ধারা, ̉nh_, _nupf,
   {{0x4425e729,0x7c250b67,0x61e0829a,0x225fe817}},	//   _zal_, _sahr, qaml, chuk_,
   {{0x69dd6818,0x09aa80c8,0x4425e20b,0x7c2500b9}},	//   _rese, _গ্রা, _yal_, _pahr,
   {{0x69dd0cbb,0x3ced02a5,0x201a02ce,0x44258be9}},	//   _sese, ševo_, jepi_, _xal_,
   {{0x7bde6819,0x69dd059e,0x78b51087,0x9f628009}},	//   _depu, _pese, _rizv, ävän_,
   {{0x7c2502af,0xdddbb5ca,0xd5c103eb,0x7e6d02e8}},	//   _wahr, _skuž, _एलिज, _umap,
   {{0x69dd681a,0xda1e243f,0x66e2826b,0x64412446}},	// [6b70] _vese, _पसरत_, _fíká, ölis,
   {{0x69dd09af,0x7bde03b2,0x2fc7001c,0x3a2689c4}},	//   _wese, _gepu, ùng_, _laop_,
   {{0xddc9ab1f,0xe71900f7,0xc05383c8,0x69dd22f8}},	//   _vjež, تيات_, עזע_, _tese,
   {{0x4425e81b,0x2a601af7,0x7e7d681c,0xa3cf816f}},	//   _sal_, chib_, nnsp, वुन_,
   {{0xf1ab0077,0x5184053b,0x3ce681a1,0xece8804a}},	//   _داده_, _зура, gsov_, зділ_,
   {{0x5fe1159a,0x442581b9,0x224b00ee,0x201a681d}},	//   _फ़िल, _qal_, _hock_, cepi_,
   {{0x4425c3be,0x29090198,0x224b2a33,0x64438338}},	//   _val_, ltaa_, _kock_, rjni,
   {{0x5694baca,0x3a290642,0xddc41bcf,0xf8bf08f9}},	//   _заст, ndap_, _omiš, _kué_,
   {{0x29091e0a,0x4425c575,0x44278101,0x7c878162}},	//   ntaa_, _tal_, pdn_, _еуже,
   {{0xaec596c7,0xb95b026b,0x2a6000b9,0x6fdd12c6}},	//   мбол, _afìk, zhib_, यरिं,
   {{0x29090009,0x7bde681e,0x3ce90176,0xcb558290}},	//   htaa_, _repu, _avav_, _تناظ,
   {{0x7bde01f1,0x2a603592,0x1ee78065,0x2cbf8074}},	//   _sepu, xhib_, _ہوتی_, _kuud_,
   {{0x625800f7,0x7bde358b,0x25df02f1,0x2d84681f}},	//   _díol, _pepu, _कजरी_, çme_,
   {{0x78600065,0x2cbf8074,0x68fbb252,0x3940022c}},	//   _köve, _muud_, muud, vxis_,
   {{0x41d1853e,0xa3e58fd5,0x2cbfae07,0xa3c59a3b}},	//   _सभास, _भजन_, _luud_, _एलन_,
   {{0x09b180ab,0xe80b15bc,0x7bde0133,0xcb1281c6}},	//   _ট্যা, स्सा_, _wepu, כלל_,
   {{0x7bde0458,0x68fbe820,0xf8bf0216,0x201a54bb}},	// [6b80] _tepu, nuud, _cué_, tepi_,
   {{0x2a60208e,0x39428009,0xd37885f3,0xa3d91c7b}},	//   shib_, äksi_, _leća_, ारः_,
   {{0x78600019,0xdb1c00f7,0xb6c50d8e,0x201a6821}},	//   _növe, rbró, есій, repi_,
   {{0x90c60e12,0xe8020327,0x201a2c17,0x7afc36b2}},	//   _обме, र्जा_, sepi_, murt,
   {{0x61e4271b,0x92d600c8,0x443a09da,0x69d66822}},	//   mail, _সময়_, _knp_, mbye,
   {{0x13e200c8,0x3ddf80f3,0x61e46823,0xa6e2007b}},	//   _বাড়, _eeuw_, lail, æðsl,
   {{0x60c40168,0xe80306a7,0x645d8084,0x62580174}},	//   lqim, _लाता_, _įsit, _líom,
   {{0x61e41581,0x30ea8fdd,0xc7a30ada,0x69d603ec}},	//   nail, офон_, _риск, nbye,
   {{0x2bcfa207,0x60c20013,0x6723820f,0x2cbf82a3}},	//   _स्वा, íomh, _asnj, _guud_,
   {{0x7afc6824,0x61e414f2,0xe8020778,0x66044b12}},	//   kurt, hail, र्चा_, _acik,
   {{0x61e46825,0x7c3ab499,0x60c400f1,0xe810016f}},	//   kail, _intr, hqim, ठ्या_,
   {{0x443a1bca,0x7afc6826,0x7c2892cf,0x7e629345}},	//   _anp_, durt, _hadr, nhop,
   {{0x506697f9,0x68469fab,0x224b01c6,0x68fb81b4}},	//   _отка, _онда, _rock_, cuud,
   {{0x7c2895f2,0xe57180be,0x7c2ae827,0x6d42802a}},	//   _jadr, אַל_, ndfr, ixoa,
   {{0x7afc4f8c,0x61e44c86,0xc61400ab,0x7c2895c1}},	//   gurt, fail, িয়া_, _madr,
   {{0x2909025d,0x61e410a8,0x78600201,0xe80203eb}},	//   ttaa_, gail, _növb, र्घा_,
   {{0xf8bf1220,0xa3cf913d,0x661d0069,0x7c3ae828}},	// [6b90] _qué_, वुड_, mesk, _ontr,
   {{0x5c740554,0x29091e0a,0xd9bb88fd,0x7afc6085}},	//   _альт, rtaa_, _उल्ट, burt,
   {{0x2909025d,0x0c740dd0,0x8bd60051,0x83350158}},	//   staa_, _جديد, _אותו_, _װאָס_,
   {{0x28df90be,0x7c3ae829,0x61e40cb5,0x68f6682a}},	//   पीडि, _antr, cail, bryd,
   {{0x7c28a699,0x644e02d4,0x6aad08dc,0xe50481a8}},	//   _badr, žniš, mmaf, نبوي,
   {{0x7c28e82b,0x03a59fbc,0xfe10001c,0xd37885a2}},	//   _cadr, нило, _nắng_, _seća_,
   {{0x661d043d,0x60cf1d7e,0xd37880c3,0x7c28d0fc}},	//   kesk, _htcm, _peća_, _dadr,
   {{0x7c3ab0e3,0x7e6284e8,0xe8100c28,0x659581d9}},	//   _entr, chop, ठ्ठा_, _забу,
   {{0xd378803a,0x59c18105,0xf1b9911b,0x395981fa}},	//   _veća_, शखबर, ješe_, áss_,
   {{0x62580013,0x61e4011e,0x1cb88077,0x20010081}},	//   _ríom, zail, _قالب_, nghi_,
   {{0xe7399289,0xbcfb0065,0x68fb83ff,0xe3b38b76}},	//   чен_, szél, suud, _شرط_,
   {{0x661d44f3,0x6e2982f7,0x3f9981a9,0x443a682c}},	//   gesk, _jaeb, āsu_, _snp_,
   {{0x61e4682d,0xee370d70,0xdddb9a14,0xc7b880c3}},	//   vail, хня_, _aluŋ, veđe_,
   {{0x7afc1d46,0xe0068740,0xfe1000ff,0x629b8114}},	//   turt, _शायद_, _gắng_, lluo,
   {{0x1e960b9c,0x61e444df,0xa69619e3,0x68e9a67f}},	//   _прир, tail, _приј, lsed,
   {{0x3dda00ab,0x69c9c0d1,0x2bd0073c,0x68f6682e}},	//   _থাকল, ncee, _त्रा, tryd,
   {{0x61e4682f,0xe8fa09c7,0x6a830be2,0x68e9983d}},	// [6ba0] rail, яла_, улта, nsed,
   {{0xb8820efc,0x7afc6830,0x61e40102,0x2bcf8540}},	//   _čísl, purt, sail, _स्ला,
   {{0x91e614b7,0x69cbe831,0xe61a84a9,0xdfcf00f7}},	//   _поне, _ofge, зде_, صين_,
   {{0x7c28803a,0x98a0017f,0x69c981c0,0xfce6a3e7}},	//   _sadr, kvić_, jcee, еодо,
   {{0x7e62816d,0x6e298101,0xd469004e,0xad9b016a}},	//   rhop, _daeb, _رحیم_, lfúr,
   {{0x68e99108,0x69cba40d,0x8c4391c7,0x7c28df52}},	//   dsed, _afge, лече, _qadr,
   {{0xc79501e2,0x8fa31a19,0x645890c9,0x4f953383}},	//   _арты, _баре, rkvi, _арту,
   {{0x179b03c8,0x5a349354,0xa50aa29c,0x7c288326}},	//   _זילב, тнит, _неба_, _wadr,
   {{0x81e500c8,0xe0cf80d5,0x661d1474,0x98a000c3}},	//   _নাম_, یزی_, vesk, gvić_,
   {{0x473485c2,0xbc6a8c3b,0x66028061,0x6e29838a}},	//   внос, _عمان_, lgok, _zaeb,
   {{0x81df8a49,0x1df911e9,0x661d6832,0x45d50389}},	//   _তার_, мены_, tesk, конс,
   {{0x6602829b,0xea018028,0xff7b04de,0xd3788267}},	//   ngok, _đầy_, לטימ, _hećo_,
   {{0xfe6e0bca,0x661d6833,0xa32080c2,0x78b8822b}},	//   تگو_, resk, _मनुज_, _tivv,
   {{0xb5fb56c9,0x661d27d1,0x212688f9,0x61e2b4e7}},	//   chán, sesk, _isoh_, _heol,
   {{0x9388024f,0x60c28364,0xfaa714bc,0xab952d6b}},	//   еста_, _huom, ешан, тиві,
   {{0x201ee834,0x60c2e835,0x66e701d0,0x998681d6}},	//   leti_, _kuom, _léká, _množ_,
   {{0x2cff8aed,0x60c28198,0xddc98493,0x62808123}},	// [6bb0] _ईमेल_, _juom, _aleş, inmo,
   {{0x201ee836,0x61e2b0e4,0x6e3be837,0x3b55002e}},	//   neti_, _leol, _snub, _акор,
   {{0x3ea937ee,0x20010081,0x60c28198,0xf41201c6}},	//   _khat_, rghi_, _luom, _דפי_,
   {{0xa3d90076,0xfb1a0986,0xd5758c5c,0x201ee838}},	//   ारक_, _کریں_, куль, heti_,
   {{0x60c281e2,0x5a341cf8,0xddc9e839,0x3a2b0037}},	//   _nuom, _снят, _eleş, _iacp_,
   {{0x2249003b,0x201e82ce,0x3ea900e4,0x6e298c93}},	//   ljak_, jeti_, _lhat_, _waeb,
   {{0xf8bf0036,0xe7840705,0x21268176,0x2bac863a}},	//   _trés_, _буто, _asoh_, टेला,
   {{0x5f941980,0x3ea9001c,0x68e9e83a,0x61e281a8}},	//   _сист, _nhat_, tsed, _ceol,
   {{0x69c981ed,0x60c28037,0x201ee662,0xd24e95a9}},	//   rcee, _cuom, feti_, تني_,
   {{0x68e98867,0x857499b8,0x60c28110,0x69c98299}},	//   rsed, _слух, _duom, scee,
   {{0xf7718277,0x2608800d,0x68e991b4,0x200b809a}},	//   شاد_, _हामी_, ssed, ęci_,
   {{0x26c3005c,0x27e304b7,0x3ea935db,0x3ce98115}},	//   _mujo_, _lejn_, _chat_, šavu_,
   {{0xceb2893f,0x201ee83b,0x26c30264,0x26fe0321}},	//   ייט_, beti_, _lujo_, _उम्र_,
   {{0x5ed200c8,0x201ee83c,0x64a60196,0x68ff011c}},	//   _হিসে, ceti_, тага, duqd,
   {{0xfe0a0740,0x160a016f,0x09e62748,0xe29a004a}},	//   _वापस_, _वापर_, ковн, дав_,
   {{0xc3328039,0x61e281df,0x2c6d0267,0xc0b981d0}},	//   סון_, _xeol, dždu_, řádá,
   {{0xe2971d8f,0x290d8c39,0x27e304b7,0xad9b04c3}},	// [6bc0] тат_, ntea_, _bejn_, lgún,
   {{0xb21b0ae1,0xb05b3a53,0xa2a2015c,0x291902d5}},	//   _hjæl, _stär, _कीर्, _dpsa_,
   {{0xe813835a,0xb8e90424,0x7c3e0102,0x645c683d}},	//   त्या_, _लू_, _inpr, mkri,
   {{0x201ee83e,0x75360035,0x3ce00242,0xc6088e1b}},	//   zeti_, _kryz, _kwiv_, _রোজা_,
   {{0x27e301cd,0x61e28114,0x201e8c12,0x2d8f006a}},	//   _fejn_, _reol, yeti_, _øget_,
   {{0x61e2e83f,0x645c5994,0x201e0ede,0x2900004f}},	//   _seol, nkri, _úti_, muia_,
   {{0x60c2825d,0x201e979d,0x290d8144,0xf74345a5}},	//   _suom, veti_, etea_, _керо,
   {{0x3ced0289,0x753600b9,0x78bc0009,0xc7b8911b}},	//   ševi_, _oryz, _hirv, jeđa_,
   {{0x201ee840,0xfe918077,0x6280816d,0x30a6a927}},	//   teti_, _اینج, rnmo, кров,
   {{0xea01801c,0x27e304b7,0xb42587d2,0x3dc002c4}},	//   _đấy_, _xejn_, _معمو, _agiw_,
   {{0x442c954c,0xadc3826b,0xb5fb00f7,0x3ea900ff}},	//   _iad_, _abẹn, bhál, _phat_,
   {{0x442cba4e,0x60c2a1f6,0xb87b007b,0x7c3e0edc}},	//   _had_, _tuom, _hvít, _anpr,
   {{0x442ce532,0x201ee841,0x06e282f1,0xd0480085}},	//   _kad_, peti_, _कौरव_, şlər,
   {{0x3ea9004c,0xd0109a00,0x491783c8,0x442ce842}},	//   _what_, _طلب_, _סקול_, _jad_,
   {{0x3ea9073a,0x7ac4072a,0xa3208006,0xefb08077}},	//   _that_, исте, _मनोज_, _دیدگ,
   {{0x442c813c,0x7c3e59a1,0x75360035,0xb113819d}},	//   _lad_, _enpr, _fryz, _mụnw,
   {{0x443ee843,0x30150037,0x2d8f00e7,0xdddb9123}},	// [6bd0] _ont_, лдар, _âge_, _njuš,
   {{0x443e80ee,0xf1b98612,0xc05801e2,0x442e8144}},	//   _nnt_, neša_, кіх_, jdf_,
   {{0x6e2d18d0,0x2bd90ebf,0x290d8102,0x442e8114}},	//   _kaab, _ब्या, ztea_, ddf_,
   {{0x442c82c1,0x443ea9fb,0x765d06c0,0x29000087}},	//   _aad_, _ant_, nksy, buia_,
   {{0x6e2d45bb,0x442cb2c7,0xa5bb0333,0x76880380}},	//   _maab, _bad_, cdót, nıya,
   {{0x442c84f9,0x81df80c8,0x443e88f1,0x260881ce}},	//   _cad_, _তাই_, _cnt_, _हाथी_,
   {{0xeb968d9e,0xe299e844,0x68ed15d0,0xaca301bc}},	//   лиш_, нак_, lsad, _nkọg,
   {{0x0b1680f7,0x645c4c4f,0xb87b0118,0x78bc07c0}},	//   اقية_, zkri, _evít, _zirv,
   {{0x68ed6845,0x442c861f,0x6abd04c7,0x3e6201a8}},	//   nsad, _fad_, _misf, _nóta_,
   {{0x290d8c76,0x442ce846,0xb21b013c,0xe8f681bb}},	//   rtea_, _gad_, _sjæl, ыль_,
   {{0x290d8c76,0x6e2d0e05,0xfc309e91,0x29000010}},	//   stea_, _baab, _بحق_, zuia_,
   {{0x6abd1c6c,0x290d8087,0x98ad807a,0x68ed0687}},	//   _nisf, ptea_, mveč_, ksad,
   {{0x09b180ab,0x69dbe847,0x6d59e848,0x6e2d5735}},	//   _ট্রা, mbue, nywa, _daab,
   {{0x68ed0079,0x69dbe395,0x442c81b4,0x68fb85fe}},	//   dsad, lbue, _xad_, mrud,
   {{0x66098052,0x645c50e9,0xe739802e,0x7c2e6849}},	//   _ocek, rkri, _чей_, rdbr,
   {{0x645c120b,0x78bc0020,0x6e2d0ec8,0xe29709b1}},	//   skri, _sirv, _gaab, гас_,
   {{0x6abd1d24,0x68fbbb07,0x7e645d49,0x386300dd}},	// [6be0] _disf, nrud, _ilip, _bljr_,
   {{0x7bc18199,0x61e9e84a,0x20c980ff,0x29000087}},	//   _nglu, hael, _múi_, ruia_,
   {{0x7e6437e4,0xddc9c30c,0xb87b3b56,0x68fbc50f}},	//   _klip, _smeš, _avís, hrud,
   {{0xe813a3e6,0x68ed0079,0x7bc1bb40,0xb87b01d0}},	//   त्ता_, bsad, _aglu, _svít,
   {{0x29002511,0x442ce84b,0x68fbe84c,0x24f68f80}},	//   quia_, _pad_, jrud, учер,
   {{0x7bdc13ca,0x61e646be,0xac188e1d,0x273384be}},	//   nbru, _hekl, току_, _ẹni_,
   {{0x442ce84d,0x260500cf,0x1fb50009,0x2c160c28}},	//   _vad_, _वाली_, _встр, द्यं_,
   {{0x442ca1c7,0x32548e0b,0x61e6007a,0x61e98739}},	//   _wad_, рвир, _jekl, gael,
   {{0x442ce84e,0x61e60029,0xddc99024,0x20180573}},	//   _tad_, _mekl, _umeš, _kbri_,
   {{0xdefaaafb,0x7e6449a0,0x6e2d1bf1,0x7d028110}},	//   ным_, _alip, _saab, muos,
   {{0xb8cba2db,0x60c60e59,0xf8c8801c,0x6e2d2e07}},	//   _की_, _lukm, _bức_, _paab,
   {{0x6e2d0079,0x6e9500e8,0x69dd807b,0x68fbe84f}},	//   _qaab, риму, ðset, brud,
   {{0x22938013,0x550701e2,0x6284009a,0x249a008e}},	//   _النس, ычна, dnio, _bkpm_,
   {{0x6e2d0ec8,0x7e640234,0x3e6201a8,0x5b271273}},	//   _waab, _elip, _vóta_, льба,
   {{0x61e60808,0x309b8051,0x6f01816a,0x6e2d57d3}},	//   _bekl, _רשומ, culc, _taab,
   {{0x60c64a3c,0x68ed22ab,0x20180eba,0x7d028e11}},	//   _bukm, tsad, _abri_, kuos,
   {{0x61e66850,0x9875024f,0x7bdc1031,0x201805ee}},	// [6bf0] _dekl, алац, bbru, _bbri_,
   {{0x68ed61c1,0x09d185e8,0x7e64026c,0x2c663a2c}},	//   rsad, _सभ्य, _zlip, _pôde_,
   {{0x68ed6851,0x97a714f6,0x6d59a9a7,0x7e640198}},	//   ssad, урал, wywa, _ylip,
   {{0x4423475a,0x61e604eb,0x3ced056f,0xa49b009f}},	//   lej_, _gekl, ševu_, ctòr,
   {{0xd126990c,0x68ed0df6,0x58870d15,0x68e28326}},	//   _بم_, qsad, _быва, _nwod,
   {{0x442321a9,0xa8790158,0xc484a1d2,0x69c29142}},	//   nej_, _יאָר, блік, _agoe,
   {{0xfd580133,0x6d598035,0x68e28915,0x9f51861c}},	//   _braụ, sywa, _awod, üzü_,
   {{0x4423600b,0x7f840013,0x2ce500d4,0x68fb9188}},	//   hej_, _الفن, _कबूल_, trud,
   {{0x44233f63,0x61e9e852,0x7d1b80d2,0x394901df}},	//   kej_, rael, _upus, nxas_,
   {{0x442321a9,0x7ae7940b,0x39496853,0xf8c88028}},	//   jej_, _бюдж, ixas_, _sức_,
   {{0x8fa580e9,0x366a0729,0x44231517,0x62846854}},	//   ране, вано_, dej_, ynio,
   {{0xed5a00bf,0x20c9801c,0x443100eb,0x249a00b9}},	//   вом_, _túi_, edz_, _skpm_,
   {{0xc0e587eb,0x9f430388,0xf8bf09c4,0xa69681c6}},	//   _толк, _dejé_, _asém_, שכרה_,
   {{0x61e66855,0x224d807a,0x6f01ac2c,0x38ab8aa2}},	//   _sekl, ljek_, pulc, føre_,
   {{0x46a61cd0,0xeb9a143d,0x78600086,0xf8c88028}},	//   _какв, тив_, _dövl, _tức_,
   {{0x7bdc2aec,0x76880214,0x7e645b2b,0xf8c880ff}},	//   sbru, mıyo, _ulip, _hứa_,

   {{0x44231683,0x76880214,0x6f1c026f,0x62960c06}},	// [6c00] bej_, lıyo, _sprc, royo,
   {{0xa49b07e2,0x26c7e856,0x44231d66,0x27e786c0}},	//   stòr, _kuno_, cej_, _jenn_,
   {{0x27e7a496,0x76880214,0x61e66857,0x7c23d994}},	//   _menn_, nıyo, _tekl, denr,
   {{0xed5a95b9,0x27e798e8,0x6441848d,0x3ebf9495}},	//   кое_, _lenn_, _anli, _ciut_,
   {{0xe53484cf,0x3ebf81bc,0x26c78365,0x1bd48081}},	//   сель, _diut_, _luno_, боля,
   {{0x7c2397fb,0x2d579d51,0x76880214,0x7d02e858}},	//   genr, ришь_, kıyo, ruos,
   {{0x2480cbab,0xaa668d9e,0xb5fb027f,0x26c7e859}},	//   đim_, итик, nkác, _nuno_,
   {{0x442358d6,0x68e28247,0xd2578009,0xe8138aed}},	//   zej_, _pwod, ицы_, त्सा_,
   {{0x26da0198,0x48aa9594,0x29120c8b,0x7c23bff4}},	//   lppo_, ктом_, ntya_, benr,
   {{0x2a69208b,0xd7aa00d4,0xb5fb00f7,0x32ca801c}},	//   zhab_, _कराच, mhái, _tùy_,
   {{0x4423685a,0x27e78352,0x50b780f7,0x224d9600}},	//   vej_, _denn_, جديد_, bjek_,
   {{0x44230d38,0x6f03009f,0x2a693592,0x625801a8}},	//   wej_, ànci, xhab_, _míos,
   {{0x44230eb0,0x2a668122,0x249832c7,0x768802d0}},	//   tej_, _ilob_, form_, mıyl,
   {{0x290480eb,0x2a6681c5,0xb87b0032,0x25a904e8}},	//   muma_, _hlob_, _awín, _vzal_,
   {{0xeabf0021,0xdb580364,0x4423086f,0x29048418}},	//   _più_, ают_, rej_, luma_,
   {{0xe81905fc,0x44233f28,0xd7bb8039,0x7afa1de9}},	//   न्ना_, sej_, _בצור, átta,
   {{0xe8138beb,0x442301b9,0x7e7d07b8,0x3ebf851e}},	// [6c10] त्वा_, pej_, misp, _riut_,
   {{0x1c16016f,0x2a69008e,0x6ecb00d4,0xb5fb01a8}},	//   द्दल_, shab_, _तंदु, dhái,
   {{0x2c008540,0x29049fb6,0x92950048,0xc5d5a1d2}},	//   _राजू_, huma_, _ганц, біль,
   {{0x2904e85b,0x7e7d3a2f,0xf2d20039,0x625801a8}},	//   kuma_, nisp, _מעט_, _díos,
   {{0x61ed5c06,0x29048029,0x224d8499,0x51842dc7}},	//   maal, juma_, vjek_, _дура,
   {{0x61ed486f,0xa3be08fd,0x2904e85c,0x7e7d685d}},	//   laal, ुँच_, duma_, hisp,
   {{0x212900b9,0x7ebf01a9,0x7c23c538,0x27e7821e}},	//   lwah_, _rūpn, renr, _renn_,
   {{0xb5fb0307,0x569481e2,0x7c23e85e,0x61ed14c7}},	//   bhái, _даст, senr, naal,
   {{0x2904df6b,0xb5fb685f,0x7e7d12ab,0x661bc5b2}},	//   guma_, chái, disp, _ibuk,
   {{0x44238117,0x753b80ad,0xb8ff8665,0x61ed6860}},	//   _új_, _iruz, _तऽ_, haal,
   {{0x2bdd8c78,0x61ed2df0,0x5434826a,0x21291600}},	//   _न्या, kaal, _برقر, hwah_,
   {{0x27e7834a,0x2129372d,0xb5fb016b,0x6b7a80be}},	//   _wenn_, kwah_, vkác, _גרענ,
   {{0xd378803a,0x61ed3bdf,0x1e3a80be,0x9f478168}},	//   _reći_, daal, אגרא, _kenë_,
   {{0x320902c1,0xa3d317ba,0x629d28dc,0x9f4780f1}},	//   egay_, हुल_, _akso, _jenë_,
   {{0x661be861,0xd378a828,0x7e7d0333,0x9359229c}},	//   _obuk, _peći_, bisp, арту_,
   {{0x61ed0962,0xe81383eb,0x753b90d3,0x575681c6}},	//   gaal, त्रा_, _oruz, _לבצע_,
   {{0xd3788025,0x2f118019,0x39460187,0xddcd09d1}},	// [6c20] _veći_, lág_, ãos_, _umaš,
   {{0x7d060364,0x29120019,0x62580174,0x661be862}},	//   muks, rtya_, _píos, _abuk,
   {{0x44446863,0x61ed4577,0x2904ae96,0xa3b4000c}},	//   _in_, baal, zuma_, जेश_,
   {{0x290481d3,0x44446864,0xb5fb01a8,0x69da0087}},	//   yuma_, _hn_, thái, _ştef,
   {{0x44443e92,0xc0b28028,0x8936045b,0x7d060ff9}},	//   _kn_, _cười_, _اعجا, nuks,
   {{0x2904b328,0xa3d8001b,0x7e7d3327,0x661bdc72}},	//   vuma_, ाडि_, zisp, _ebuk,
   {{0x907b00be,0x2a66822c,0xf99f08f9,0x753be865}},	//   _עטלי, _plob_, _acèh_, _eruz,
   {{0x60f882bc,0x2904a221,0x29006866,0xb5fb3502}},	//   ания_, tuma_, oria_, phái,
   {{0x4444073a,0xc05a8a18,0x26ca0733,0x76880457}},	//   _on_, гін_, _hubo_, rıyl,
   {{0x44445511,0x7d066867,0x2ef4828b,0x76880457}},	//   _nn_, duks, озор, sıyl,
   {{0xa09b010f,0x6aa40059,0x61ed0ef2,0x889b03c8}},	//   רייט, klif, yaal, רביי,
   {{0x44446868,0x2904c28b,0xe1ff026b,0x6d5d0198}},	//   _an_, puma_, _alón_, tysa,
   {{0x7e7d34f7,0xa3cf8006,0xe8190c87,0x249e80b9}},	//   risp, वुक_, न्डा_, _kktm_,
   {{0x26d81ea9,0x92d400c8,0x81e500c8,0x5ed900c8}},	//   _otro_, _হয়ে_, _নাই_, _ডিসে,
   {{0xa3d8000f,0x21290239,0xa87b81c6,0xf3f18129}},	//   ाड़_, wwah_, _תאור, _học_,
   {{0x2bd903eb,0x6aa40a2b,0x7d066869,0xe5c728a1}},	//   _ब्रा, glif, buks, _уско,
   {{0x61ed1572,0x7e628fb0,0x44446352,0x29003666}},	// [6c30] raal, dkop, _fn_, gria_,
   {{0x61ed254a,0x4444686a,0x69d90540,0x9f4782d6}},	//   saal, _gn_, _फ्री, _benè_,
   {{0x61ed1699,0x29005d5d,0x37ab02ee,0x8a19002e}},	//   paal, aria_, утан_, _конс_,
   {{0xa3ae000f,0x61ed02a3,0x2900462f,0x753b8503}},	//   _औरत_, qaal, bria_, _pruz,
   {{0x4444686b,0x2f118019,0x81c380ab,0x672e006a}},	//   _yn_, zág_, ্রম_, _esbj,
   {{0x9f47820f,0x6ab381cb,0x58d43d65,0xb5fb016b}},	//   _qenë_, ुद्र, _хорт, cháv,
   {{0x64571c33,0xb1138133,0xae0a0074,0xfcb281d6}},	//   _moxi, _tụkw, _वालन_, úšať_,
   {{0xe8f9a05f,0xd378803b,0x661bad3c,0x9f43001b}},	//   али_, _neću_, _ubuk, _její_,
   {{0x26ca173d,0x44330144,0x753b8314,0x7e7be86c}},	//   _zubo_, _oax_, _uruz, _imup,
   {{0x2bd9159a,0xe3b38277,0x6aa4686d,0xef198eef}},	//   _ब्ला, _فرض_, zlif, амо_,
   {{0xbba803bb,0x81e880c8,0x7e69cb1f,0xf626006d}},	//   _गरेक, _বার_, _klep, одно,
   {{0xa3bf03b7,0x7d06025d,0x3cf0800f,0x9f4a03a7}},	//   ेशन_, tuks, ुंचे_, _bebê_,
   {{0x2f118065,0x4444686e,0x4427decd,0x44331b37}},	//   ság_, _pn_, oen_, _bax_,
   {{0x66e59289,0xe7398767,0x7d06171c,0x645702df}},	//   _дока, _век_, ruks, _coxi,
   {{0x44440104,0xa3b40063,0x60cb807b,0x76562914}},	//   _vn_, जें_, _hugm, _toyy,
   {{0x4427e86f,0x29006870,0x6289e871,0xf1d186a7}},	//   hen_, tria_, nneo, _हलफन,
   {{0x61ebb5ae,0x60cb8bda,0x26ca64fd,0xbcfb0019}},	// [6c40] _megl, _jugm, _subo_, szér,
   {{0x290000ad,0x61ebda16,0x4433008e,0x394d8722}},	//   rria_, _legl, _gax_, ixes_,
   {{0xbc6a0bca,0x25ad826c,0xe5c68c9d,0xa3188105}},	//   _ممکن_, _azel_, осло, _दहेज_,
   {{0x290019ab,0x61460993,0x4427a450,0x60c3808e}},	//   pria_, _дема, een_, _linm,
   {{0x4427dddf,0x7e62b3fc,0xff0a00c8,0xa2b90cf0}},	//   fen_, rkop, রবেশ_, ्दर्,
   {{0x4427d27b,0x66e626ad,0xe819000d,0xdee60a7c}},	//   gen_, _мога, न्दा_, _моги,
   {{0x61ebe872,0x26d803ba,0x25ade873,0x7e6286aa}},	//   _begl, _utro_, _ezel_, pkop,
   {{0x60c38ad0,0x41e68221,0x2c6b8257,0xf99f0176}},	//   _ainm, ціка, _røde_, _abèy_,
   {{0x4427abba,0x61eb8698,0x3fc8826a,0x2c6b806a}},	//   ben_, _degl, یدگی_, _søde_,
   {{0x44278511,0x60cb90d3,0x7e69826f,0x7d0282f7}},	//   cen_, _dugm, _zlep, mros,
   {{0xd838807a,0x60c3a008,0x7bc88bb1,0x7d02a0db}},	//   joče_, _dinm, _igdu, lros,
   {{0x60c390f6,0x3ea682f7,0x62898cb5,0x44336874}},	//   _einm, nlot_, cneo, _sax_,
   {{0xd378805c,0x3ea0008e,0x6280e875,0x60cb8bb1}},	//   _veću_, _dkit_, mimo, _gugm,
   {{0x35cc83b7,0x7d029243,0x2717128a,0x9f45e876}},	//   ़खड़, iros, něná_, balà_,
   {{0xd8388353,0x7c276877,0x2122008e,0x3ea682c4}},	//   goče_, rejr, _apkh_, klot_,
   {{0x4427bcf9,0x26c4b2db,0x478985a8,0x2605016f}},	//   zen_, _nimo_, _усім_, _वाटी_,
   {{0x4427e878,0x1ad680ab,0xf4e580ab,0x3eb9232a}},	// [6c50] yen_, সওয়া, _নম্ব, mmst_,
   {{0x4427e879,0x6280e87a,0x442710ab,0x7e698e20}},	//   xen_, himo, _ún_, _slep,
   {{0x442781ed,0x26c48032,0xc5d8819d,0xd5d881bc}},	//   ven_, _bimo_, _ịrụb, _ịrụr,
   {{0x44279377,0xa3dd98a4,0x1daf0072,0xb5fb03c1}},	//   wen_, थुन_, _घरात, chát,
   {{0x61e20693,0xb3bd00ab,0x26c482c4,0xa5bb0e06}},	//   ñole, _অভিজ, _dimo_, deók,
   {{0x4427e87b,0x61ebe87c,0x224680b9,0x25ad82d4}},	//   uen_, _segl, _anok_, _vzel_,
   {{0x61eb805c,0x29090009,0x60c383ec,0x7d02e87d}},	//   _pegl, luaa_, _rinm, aros,
   {{0x6d5c8201,0x78600019,0x60c3e87e,0x394d8722}},	//   _əraz, _rövi, _sinm, txes_,
   {{0x4427be84,0x13a80aed,0xe8068778,0xa3eb0fea}},	//   pen_, _गर्भ, _शाखा_, मरा_,
   {{0x9f4587e2,0xe5c486cf,0x442780f1,0x3ea0687f}},	//   talà_, _істо, qen_, _skit_,
   {{0x62808333,0x38ab8366,0x786d808b,0xf745a80f}},	//   bimo, børn_, _núve, чено,
   {{0x628085e4,0x60cbb234,0x316000b9,0xb5fb128a}},	//   cimo, _tugm, yyiz_, skán,
   {{0x80de8264,0x09e28264,0x3ce90362,0xe79a928a}},	//   _মিথ্, _যাচা, _cwav_, _měří,
   {{0xc1728051,0x6ab4313a,0x3e62007b,0xf1b982ce}},	//   _אחד_, ंग्र, _móti_, ješi_,
   {{0x09e612ea,0x22590609,0xbb4345a5,0x07a28087}},	//   зобн, _bosk_, нерк, _пашн,
   {{0x32d18142,0x49ca0b79,0x9f458511,0x3ea00637}},	//   _máy_, слан_, calá_, _ukit_,
   {{0x7af50019,0x648908ae,0xb5fb1de9,0xe7f280c2}},	// [6c60] aszt, džif, rhát, _आजमा_,
   {{0x44e9809a,0x628094e6,0x26c4e880,0x6e3601b4}},	//   dź_, zimo, _simo_, _hayb,
   {{0xa7fc87d9,0x6e360214,0xd00f0124,0x212de881}},	//   kkın, _kayb, الم_, hweh_,
   {{0x442a29b7,0x8ca4866f,0x93250061,0x9f431a1f}},	//   leb_, _चीजो, _کرین, _dejà_,
   {{0x64a682a9,0x61e46882,0xe8193e24,0x6280c2b0}},	//   пада, mbil, न्हा_, vimo,
   {{0x44386883,0x442a22de,0x3ea6bd58,0x260886a7}},	//   ndr_, neb_, slot_, _हाकी_,
   {{0x6280a6d5,0x3ea6cd05,0x26c4e884,0x9f5881cc}},	//   timo, plot_, _timo_, ürü_,
   {{0x442a35b1,0x1dbe016f,0x46a3ba8b,0x752400c3}},	//   heb_, ोशात, _засв, _opiz,
   {{0x62808558,0xb21b00e8,0x61e4047f,0x442a5d86}},	//   rimo, _kjær, ibil, keb_,
   {{0x6d408ece,0x6280aed0,0x442a06ec,0x645a0198}},	//   _irma, simo, jeb_, ötil,
   {{0x1faa03a4,0x9f4a1fd1,0x6e363d85,0x442a0114}},	//   _करोड, _bebé_, _bayb, deb_,
   {{0x7c2aa45f,0x645ad958,0x200281cc,0xfb878061}},	//   lefr, _hoti, şki_, _عدلی,
   {{0x645a825d,0x44380088,0x61e42875,0x2fca010c}},	//   _koti, fdr_, dbil, _ogbg_,
   {{0x27e98104,0x91bb8039,0xfd65826b,0x442a5d86}},	//   _đang_, _המדי, _aisọ, geb_,
   {{0x752402a5,0x8557003d,0x644886cb,0xe81001a2}},	//   _epiz, زیگر_, _mndi, ालना_,
   {{0x6d40e885,0x645ae886,0xfbdf8028,0x61e40461}},	//   _orma, _loti, _đêm_, gbil,
   {{0xd49b0c8e,0xa3cc9664,0x6448d27c,0x44380115}},	// [6c70] _грн_, रखा_, _ondi, bdr_,
   {{0x645ae887,0x61e41ba2,0xb5fb6888,0x2f150338}},	//   _noti, abil, chár, tåg_,
   {{0x61e401cd,0x06e080c8,0x6d40938e,0x7c2abf8b}},	//   bbil, _ভিডি, _arma, defr,
   {{0x6448cfd0,0x6d4080dd,0x645a8362,0x2bd901d0}},	//   _andi, _brma, _aoti, बुरा,
   {{0xc7b88025,0x645ae889,0x2f150106,0x628d08ae}},	//   među_, _boti, såg_, mnao,
   {{0xdfc68013,0x7c2ae88a,0x6aa2826b,0x03a59170}},	//   _لي_, gefr, _akof, мило,
   {{0xff0407ac,0x645ac7c4,0x65628122,0xe0df0706}},	//   _пятн, _doti, ayoh, _bròg_,
   {{0xe0d9c4cc,0xac778077,0x4421010b,0x442a009a}},	//   ови_, _کارش, _lbh_, zeb_,
   {{0x645a9ee0,0x44212f65,0xa7fc807e,0x320d8713}},	//   _foti, _obh_, rkın, rgey_,
   {{0x7e6d0065,0xa3bf17ba,0x68ed81b9,0x60c703ec}},	//   _alap, ेशा_, _ħadd, _jijm,
   {{0x752f009a,0xa2cd06a7,0x752400c3,0x61e41277}},	//   ewcz, _दूल्, _spiz, ybil,
   {{0x6e3602a3,0x645a80f1,0x68f60114,0x60c7090d}},	//   _qayb, _zoti, ysyd, _lijm,
   {{0x442a688b,0x20188722,0x7e6d2ce4,0x38b40799}},	//   teb_, òric_, _dlap, läre_,
   {{0x6aa983a6,0x4e0a0105,0x60c700f3,0x645a82df}},	//   llef, _वाकई_, _nijm, _xoti,
   {{0x61e45424,0x442a5657,0x64890267,0x6e3601e0}},	//   tbil, reb_, džid, _tayb,
   {{0x442a688c,0x4cdd00ab,0x60cf00c3,0x7d0b8122}},	//   seb_, _বিরু, _bucm, kugs,
   {{0x61e409e8,0x8ffa003f,0x6e2b9931,0xfaa315fc}},	// [6c80] rbil, قرار_, degb, тато,
   {{0x61e44255,0x68f626fa,0x76498176,0x9c8704e8}},	//   sbil, rsyd, _aney, _vyčí,
   {{0x69cbe88d,0x765bcfac,0x68eb81c0,0x38b40106}},	//   _ogge, _bouy, _lwgd, värd_,
   {{0x0d868ea6,0x9f47800d,0x645a8790,0xdee31630}},	//   млен, _není_, _soti, тоци,
   {{0xb90300c8,0xdddb81a1,0x28af10c5,0x6aa3041c}},	//   _নয়_, _fjuž, _जीवि, _ênfa,
   {{0x69d982b5,0x69cbe88e,0x7b4008ae,0x6aa28123}},	//   _afwe, _agge, pćuć, _skof,
   {{0x645acbe5,0x765b86c0,0x65628ec9,0xd83882d4}},	//   _voti, _fouy, syoh, joča_,
   {{0x32b78013,0xd25080f7,0xfe4387b6,0x7c2a8c54}},	//   ودية_, انة_, _инсо, sefr,
   {{0x6d40e88f,0x645a9517,0x442a83a8,0x64400ec3}},	//   _urma, _toti, _ºb_, ēmij,
   {{0x6448e890,0x7e6d3bd9,0x0c239a19,0x15f89055}},	//   _undi, _slap, _имун, ुलकर_,
   {{0xd8388353,0xd9ee0361,0xf4140264,0x765be891}},	//   goča_, जरात_, াজার_, _youy,
   {{0x4ad20076,0xa40e8d86,0x442100b9,0x940e82f1}},	//   _दूधव, _साँप_, _sbh_, _साँच_,
   {{0x1613852a,0x9f410174,0xb17d81d6,0x63a480fc}},	//   ण्टर_, rbhé_, saťr, ƙins,
   {{0x212683ac,0x26ced970,0x5fd286ae,0x80d580ab}},	//   _ipoh_, _tufo_, _सलिल, _দিচ্,
   {{0x20198086,0x3d0881ce,0x260f8105,0xdeef8162}},	//   əsi_, _समझे_, _डाली_, _шы_,
   {{0x6aa0901f,0x442100b9,0x7e6d47cb,0xb5fb016b}},	//   nomf, _wbh_, _ulap, cháp,
   {{0xa40e8b9f,0x61e205e4,0x4421051e,0x940e8074}},	// [6c90] _सांप_, ñola, _tbh_, _सांच_,
   {{0xa7fc82d0,0x44210174,0x37ab302b,0x765b86c4}},	//   kkım, _ubh_, отен_, _souy,
   {{0x61ef6892,0x6aa0b327,0x91c003b7,0x45dc81bc}},	//   _tecl, komf, लेबै, _ịpụ_,
   {{0xd7df23bd,0x7bda8125,0x645e80f2,0x5fdf2207}},	//   _प्रच, _aftu, öpin, _प्रल,
   {{0x6e2ba5b3,0x2a690b99,0xd5fb819d,0x26c96893}},	//   regb, mkab_, _akụ, _miao_,
   {{0x7d0bc5f8,0x26c900fc,0xa3d30054,0x947580d7}},	//   rugs, _liao_, हुच_, رگذا,
   {{0x765b8247,0x2489812b,0xfaa58811,0xa7fc82d0}},	//   _touy, đam_, нако, rkıl,
   {{0xa3b40701,0x2a6943e3,0x3a3902d6,0x26c9010c}},	//   जेट_, nkab_, _jasp_, _niao_,
   {{0x26d881df,0x9f478144,0x3a3907b6,0x9f4a026b}},	//   íron_, _vení_, _masp_, _lebì_,
   {{0x26d10234,0x6aa9a127,0x6913811f,0x6eca81d0}},	//   _kuzo_, slef, jžeš, _संखु,
   {{0x201887e2,0x2a690074,0x25a902f7,0x44ed20f6}},	//   òria_, kkab_, _ayal_, ež_,
   {{0x26c96894,0xd838807a,0x3e62007b,0x49758523}},	//   _ciao_, roča_, _nótt_, _плес,
   {{0x64890267,0x7872006a,0xddc40af8,0xf48400d7}},	//   džib, _hæve, _bliš, ناسی,
   {{0xe1ff370f,0x3a2d8a85,0x00000000,0x00000000}},	//   _adó_, leep_, --, --,
   {{0xd00e8013,0x29191a7b,0xe0df3742,0xf1b981a9}},	//   _الى_, _aqsa_, _atò_, rešu_,
   {{0x26c90028,0xe0da310c,0x09c380ab,0x3d0083eb}},	//   _giao_, зва_, _এ্যা, _रिले_,
   {{0x41271927,0xd5b20829,0x6e2402a0,0x26d1011b}},	// [6ca0] ното_, _حفظ_, _ibib, _auzo_,
   {{0x6d446895,0x80a623f7,0xddc40088,0x26d10144}},	//   _iria, رمان, _gliš, _buzo_,
   {{0xb4be1834,0x3a2db32d,0xe0df026b,0xdd929e29}},	//   ेदी_, keep_, _etò_, گوش_,
   {{0xb8f600c8,0xe29a01e5,0x443a6896,0x2bdd8519}},	//   _সব_, _хам_, _hap_, नुसा,
   {{0xe5348e86,0x443a6897,0x78600201,0x3a2d8609}},	//   тель, _kap_, _dövr, deep_,
   {{0x443a6898,0x61f66899,0x645e689a,0x3d208305}},	//   _jap_, layl, _jopi, _यहीं_,
   {{0x394003a6,0x443a0039,0x26d14dd5,0x645e01e0}},	//   lvis_, _map_, _guzo_, _mopi,
   {{0xada6a84f,0x443a689b,0x645e689c,0x6d44689d}},	//   _забл, _lap_, _lopi, _oria,
   {{0x3940689e,0x6d4401c0,0x3ce00282,0x9f4c9e1e}},	//   nvis_, _nria, _ntiv_, radí_,
   {{0x443a5d17,0x7c2e689f,0x645e00eb,0x5f048fd5}},	//   _nap_, jebr, _nopi, _विद्_,
   {{0x6d44031d,0x61f668a0,0xdef78a8e,0x7f9481e5}},	//   _aria, kayl, ныя_, танх,
   {{0x442ed3e8,0x63a487d9,0xddc4007a,0x394068a1}},	//   lef_, ğind, _sliš, kvis_,
   {{0x2f188065,0x6d4400a9,0x7c3ae587,0x39400bda}},	//   ség_, _cria, _katr, jvis_,
   {{0x443a41b4,0x7c2e044e,0x628290af,0x645e3499}},	//   _cap_, gebr, _hmoo, _copi,
   {{0x083b812a,0x443a2322,0x2ba401ce,0x43940226}},	//   _מעגל, _dap_, _खुदा, гарс,
   {{0x7c3ae8a2,0x6d4468a3,0x442ea25b,0x26d1026c}},	//   _latr, _fria, hef_, _ruzo_,
   {{0x39400bc5,0x764d26df,0x6d44615e,0xf8072341}},	// [6cb0] gvis_, _inay, _gria, ечен,
   {{0x7c3a911b,0x2a69547f,0x7c2e3cbb,0x6e3d2875}},	//   _natr, skab_, cebr, ldsb,
   {{0x61f668a4,0xe8188768,0x3a2d0118,0x442ee8a5}},	//   bayl, _दाना_, _ºep_, def_,
   {{0xa2d61094,0x6e3d23ea,0x78a1b819,0x443a16f0}},	//   _मंत्, ndsb, zolv, _zap_,
   {{0x442ed8b6,0x443a4022,0x64cb9a46,0x6e3d06a8}},	//   fef_, _yap_, ादेश, idsb,
   {{0x7c3ae8a6,0x6aad68a7,0x62828915,0x26d1004f}},	//   _catr, llaf, _amoo, _tuzo_,
   {{0xe2998f04,0x764d0214,0x7c3a8428,0xfbd401c6}},	//   мак_, _onay, _datr, נתק_,
   {{0xc245a386,0x7d1d070b,0x60ca8197,0x31258081}},	//   тник, ktss, _aifm, вдиг,
   {{0x38b4016d,0x7c3ae8a8,0x3a2d86a8,0xdb0883c1}},	//   lära_, _fatr, reep_, _vzdá,
   {{0x2903dcdc,0x764d0a72,0x7c3a81bf,0x6aad01ec}},	//   čja_, _anay, _gatr, hlaf,
   {{0x6e3b8dd8,0x25c70085,0x68e40102,0x764d0326}},	//   _kaub, ətlə_, zpid, _bnay,
   {{0x6d440038,0x645e0364,0x7d1d434a,0xf5ec046d}},	//   _pria, _sopi, ftss, _bẹẹ_,
   {{0x61e9e8a9,0x443a0247,0x645e68aa,0xba748591}},	//   mbel, _pap_, _popi, _حالت,
   {{0xab2a0221,0x232a00e8,0x69dd0343,0x68fbe8ab}},	//   мога_, моги_, _afse, msud,
   {{0x638301e2,0xf8c88028,0x61f60214,0x889a8039}},	//   агра, _cứu_, tayl, _קבצי,
   {{0x443a602f,0x69dbcaf6,0xf2d280be,0x394068ac}},	//   _wap_, ncue, שען_, tvis_,
   {{0x443a68ad,0x645e68ae,0x6d440c7b,0x69a201fe}},	// [6cc0] _tap_, _topi, _uria, _कुशी,
   {{0x443a01bf,0x68e40102,0x61f606d5,0x61e980ee}},	//   _uap_, rpid, sayl, hbel,
   {{0x8a060fe7,0xa3bf01a2,0xd6d9004a,0x39400082}},	//   _изне, ेशः_, еті_, svis_,
   {{0x7c3abe50,0x68fbb55e,0x9f4c87a3,0x6e3ba056}},	//   _satr, ksud, nadá_, _caub,
   {{0xdd8f8013,0x786d8722,0xceb304de,0xa2d61a46}},	//   يوم_, _núvo, ביא_, _मूत्,
   {{0x38b40106,0x68fb97bf,0x61e9d778,0x44259867}},	//   bära_, dsud, ebel, _cbl_,
   {{0x442e831d,0x7c3a803a,0x26130768,0x442597c9}},	//   ref_, _vatr, _थाली_, _dbl_,
   {{0x442ee8af,0x61e9e8b0,0x32638198,0x5a34964f}},	//   sef_, gbel, итыв, унит,
   {{0x28d80e70,0x7c3acc30,0x7e6080f7,0x9f4c81df}},	//   _भूमि, _tatr, _iomp, dadá_,
   {{0xdefa87ac,0x7e608282,0x3ce6dcbb,0x9f4c823e}},	//   мым_, _homp, mpov_, tadà_,
   {{0x81cb00ab,0xdeb58326,0xe4758162,0xbebd0ec3}},	//   রুপ_, _arzƙ, _сутэ, ntīg,
   {{0x64890a8e,0x09e682a9,0x83fc805c,0x91e680b3}},	//   džia, _родн, _dođe, _роде,
   {{0x39408013,0x6e3d0cd7,0x02be01d0,0xf8c8827d}},	//   _éis_, rdsb, ्दैन, _bứt_,
   {{0xdddb87d9,0x7e60a388,0x67d38f51,0xf00b0129}},	//   _oluş, _lomp, _кошу, _đắng_,
   {{0x81e400c8,0x248d0a20,0x47c080ab,0xf8c880ff}},	//   _নয়_, đem_, _শ্রী, _dứt_,
   {{0x764d00b8,0xb5fd8ee0,0x2018373d,0x7e60b8ec}},	//   _unay, _koše, _acri_, _nomp,
   {{0x2ba98bb8,0xd759015b,0x3ea909ca,0xc05b0b73}},	// [6cd0] _चुना, کلات_, _ikat_, між_,
   {{0x61e9e292,0x6e3bd399,0x38b40106,0xb7672f92}},	//   zbel, _saub, tära_, ктей,
   {{0x2fc700f2,0x443168b1,0x7529e8b2,0x7eb668b3}},	//   äng_, mez_, _spez, lápa,
   {{0x443107e8,0xacf99abe,0x38b98866,0x3946e8b4}},	//   lez_, енду_, mère_, _oros_,
   {{0x7eb64227,0xfd1f146f,0xb5fdd717,0x3946822c}},	//   nápa, ntì_, _noše, _nros_,
   {{0x443168b5,0x6738920e,0x261a0105,0xa3b70fce}},	//   nez_, _osvj, _भाभी_, _जरा_,
   {{0x4fc40c8e,0x6d42802e,0x6e3be8b6,0x39468114}},	//   _вста, avoa, _taub, _aros_,
   {{0x83fc803b,0x44314042,0x6d4100eb,0x61e98cab}},	//   _rođe, hez_, ālaj, ubel,
   {{0x4425d9ba,0x4431420d,0x69dbc5e6,0x3946c507}},	//   _tbl_, kez_, rcue, _cros_,
   {{0x61e687d9,0x39468355,0x46e9867c,0x83fc817f}},	//   ıkla, _dros_, ндон_, _pođe,
   {{0x443168b7,0x68e2826c,0x6ec786ae,0x6aa40c93}},	//   dez_, _etod, ़गपु, yoif,
   {{0x83fc8052,0x394680b9,0x38b98036,0xcee88180}},	//   _vođe, _fros_, dère_, کرین_,
   {{0x3946e8b8,0x443155d6,0x91058ba8,0x3ea900dd}},	//   _gros_, fez_, _спле, _dkat_,
   {{0x6abe0ebf,0x443168b9,0x26d189b2,0x38b98036}},	//   ्द्र, gez_, ízos_, fère_,
   {{0x5a960af2,0xe8188074,0x9f4c801b,0x161486a7}},	//   граф, _दाता_, padá_, _डालर_,
   {{0x6d4696f2,0x20032168,0x64892284,0xa3bb8074}},	//   _škam, _adji_, ržia, _घरन_,
   {{0x291fb673,0x394668ba,0xe2970087,0xd02601e8}},	// [6ce0] ntua_, íos_, уат_, лмай,
   {{0x64891752,0x7e60e8bb,0x291f8bf0,0x443168bc}},	//   lžin, _somp, itua_, cez_,
   {{0x441b093f,0x141b00be,0x5c3703c8,0xe7e306a7}},	//   _אויס, _אויב, _גרין_, गड़ा_,
   {{0x291f8102,0xbebd00eb,0x23650106,0xfdd280ab}},	//   ktua_, rtīg, älje_, ার্ড,
   {{0x7c3e4eef,0x5bcc864a,0xbebd01a9,0x291f83ed}},	//   _kapr, ाश्व, stīg, jtua_,
   {{0x9f478214,0x2003026c,0xdca380e8,0x64a3e844}},	//   _genç_, _gdji_, бачи, бача,
   {{0x7c3e24ec,0x6fb802f1,0x291d81b9,0x7eb6016b}},	//   _mapr, _अरिं, _aqwa_, zápa,
   {{0x44310d38,0x7c3e0d29,0x22405650,0x660468bd}},	//   zez_, _lapr, ndik_, _ndik,
   {{0xe818ac2a,0xa9c3835f,0x443102be,0x64890b80}},	//   _दादा_, йськ, yez_, džin,
   {{0x660410e1,0x3ea90343,0xb8dc81a2,0x3ea6c2cf}},	//   _adik, _skat_, _आठ_, loot_,
   {{0x443103d3,0x2c1b159a,0xa3d805fc,0x443ec1ef}},	//   vez_, _बाबू_, िशन_, _iat_,
   {{0x443e8367,0x3946cf74,0x1efb00be,0x38af0214}},	//   _hat_, _tros_, עלכע, türk_,
   {{0x443168be,0x443ec463,0x5c072244,0x9c83807a}},	//   tez_, _kat_, лява, _ščit,
   {{0xdfcf8013,0x66040247,0x443ee8bf,0x3ea6e8c0}},	//   _فيه_, _edik, _jat_, hoot_,
   {{0x443e9be9,0xfe148105,0x7c3e0247,0x8cd50f3d}},	//   _mat_, _डांस_, _dapr, _यूरो,
   {{0x443107e8,0x443e8063,0xddc2c2e4,0x5a3503a7}},	//   sez_, _lat_, zkoš, јнат,
   {{0x4431157a,0x443eb0b2,0x7c288259,0x20cd0b67}},	// [6cf0] pez_, _oat_, _obdr, _džin_,
   {{0x38b980e7,0x13cc80ab,0x752d0037,0x25ad8176}},	//   père_, রুয়, _ipaz, _ryel_,
   {{0x47350087,0x291f811b,0x63680081,0xf1bf026b}},	//   рнес, ztua_, _бряг_, _gbán_,
   {{0x7c3e68c1,0xa3ca81ce,0x4fc40009,0x63a90214}},	//   _zapr, ोशन_, ссуа, ğend,
   {{0x6e3f0372,0xddc2abea,0x443eca2b,0x7c3e02d0}},	//   _maqb, tkoš, _bat_, _yapr,
   {{0x6b659594,0xa3d8016f,0x20030b80,0x443e81c6}},	//   икла, िशय_, _udji_, _cat_,
   {{0x443ee8c2,0x61ed54bc,0x224f80ee,0x5c0484cf}},	//   _dat_, obal, _pngk_, сяча,
   {{0x291f9b10,0x752d0353,0xa3a983dd,0x78720366}},	//   ttua_, _opaz, _गुण_, _jævn,
   {{0xe8f684d9,0xaca381bc,0x6e2982d5,0x291f8198}},	//   алы_, _awụn, _ibeb, utua_,
   {{0xb5fb000d,0x443ec826,0x291f9e80,0x64890110}},	//   cház, _gat_, rtua_, džio,
   {{0x291f8bf0,0x61ed64da,0x7c3e3fc7,0x3a3d80b9}},	//   stua_, kbal, _rapr, _tawp_,
   {{0xf1c5146d,0x7c3e68c3,0x7872006a,0x5f080424}},	//   वधान, _sapr, _nævn, _हिस्_,
   {{0x61ed28e1,0x7c3e68c4,0x61fbe8c5,0x38ab8aa2}},	//   dbal, _papr, maul, ført_,
   {{0x317a83c8,0x443e823e,0x18669d79,0xf745997b}},	//   _באנד, _xat_, _ваши_, _веко,
   {{0x6b632481,0x6a78008b,0x68e98687,0xe3631ad8}},	//   окра, _lífe, lped, окри,
   {{0x61fbdeee,0x61ed68c6,0x7c3e21b0,0x2ca79384}},	//   naul, gbal, _wapr, hond_,
   {{0x2ca78006,0xa2d668c7,0xe9d70c0e,0x7c3e0e2d}},	// [6d00] kond_, _मूर्, рку_, _tapr,
   {{0x6e29bebe,0xf00b001c,0xe0df00ff,0x68e98084}},	//   _abeb, _đảng_, _tròn_, iped,
   {{0x21200ee1,0x61ed4577,0x3ea69384,0x6d49b9ff}},	//   stih_, bbal, toot_, _area,
   {{0x0bb704de,0x6d49bcd7,0x75468e97,0xa116003d}},	//   _כלים_, _brea, инез, _پوست,
   {{0x443ee8c8,0x6d49b474,0xe81e0105,0x62963759}},	//   _pat_, _crea, _पापा_, mnyo,
   {{0x23ba000f,0x6d49ac9b,0x6e29912e,0xb5fb0298}},	//   _इराद, _drea, _ebeb, nkár,
   {{0x443ed88a,0x2ba9809a,0xe45700be,0x3ea6e8c9}},	//   _vat_, _चुदा, ייסט_, poot_,
   {{0x443e9db8,0x6d498af9,0x629602ec,0x7f3b04de}},	//   _wat_, _frea, nnyo, _בעלו,
   {{0x443e81cd,0xfce39878,0x6d49dfc6,0xd5a511bc}},	//   _tat_, _мото, _grea, _गुंज,
   {{0x26d868ca,0x29000009,0x2ca7c918,0x61ed04e8}},	//   _kuro_, isia_, cond_, zbal,
   {{0x764086c7,0x1df907ac,0xa2d60aad,0x75228065}},	//   _kamy, лены_, _मूल्, ltoz,
   {{0xb5fd9070,0x29000364,0x61fbe8cb,0x26d85107}},	//   _koša, ksia_, caul, _muro_,
   {{0x2900218a,0x61e2d122,0xb5fd8b80,0x26d80144}},	//   jsia_, _ifol, _joša, _luro_,
   {{0x26d80548,0x7ebd00e7,0xd8388968,0xe0df02d6}},	//   _ouro_, dépe, koči_, _dròl_,
   {{0xbebd0029,0xe2870073,0xd838807a,0x83f80198}},	//   rtīb, аѓан, joči_, ресс_,
   {{0xbebd0029,0x78a8e8cc,0x2ca780f3,0x277781c6}},	//   stīb, lodv, zond_, _כגון_,
   {{0xdebc0039,0xc1b953bf,0x27f868cd,0xf8baa539}},	// [6d10] _במהל, улах_, _bern_, _उठाय,
   {{0x085400e8,0x6296008a,0x06de0264,0xa5bb0144}},	//   овую, anyo, _ডিজি, nfóm,
   {{0xec360051,0x62963c96,0x2ca78a0f,0x6d498083}},	//   _האתר_, bnyo, vond_, _srea,
   {{0x26d864b5,0x83fc8052,0x6d49e8ce,0x2ca7910f}},	//   _duro_, _rođa, _prea, wond_,
   {{0xf8db0424,0x290068cf,0x2ca7e8d0,0x764082d6}},	//   _बढिय, csia_, tond_, _damy,
   {{0xb5fd8025,0x6d49802e,0xe81e01fe,0x27f801ec}},	//   _doša, _vrea, _पाया_, _gern_,
   {{0xe7ed035a,0xa3d817a3,0x2ca783b2,0x26d868d1}},	//   _च्या_, िशत_, rond_, _guro_,
   {{0xeb980039,0x6d49b910,0x76408110,0x290dc975}},	//   ידור_, _trea, _gamy, trea_,
   {{0x61fb9716,0xa2ba354d,0x2ca780e7,0x6d49a7d1}},	//   raul, ्षत्, pond_, _urea,
   {{0x2055916b,0x290dae2f,0xcea900be,0xd3a7a66d}},	//   стир, rrea_, _װי_, _креп,
   {{0x61fbe8d2,0xa5bb007b,0xb8fe8006,0xe945803d}},	//   paul, sfól, _दू_, _گرای,
   {{0x644384e1,0x290016a7,0xed5a19fe,0x68e9e8d3}},	//   ldni, ysia_, гом_, pped,
   {{0xdd9204e3,0xe945803d,0x3f8b8035,0x627b8035}},	//   سوس_, _درای, ńcu_, głoś,
   {{0x28db101b,0x9f47b618,0x64439614,0x6441e8d4}},	//   _बढ़ि, _menú_, ndni, _jali,
   {{0x394b1e9e,0xb5fb34cd,0x786dc6b8,0x7e6468d5}},	//   _arcs_, rkár, _núvi, _toip,
   {{0x225f8812,0x6441e8d6,0x2900252c,0x20cd01a1}},	//   njuk_, _lali, tsia_, _džim_,
   {{0x290068d7,0x26d807f1,0xbebd01a9,0x76408196}},	// [6d20] usia_, _suro_, stīc, _ramy,
   {{0x26d200f6,0x644183f8,0x26d802e8,0x62965439}},	//   _hiyo_, _nali, _puro_, snyo,
   {{0x6443816d,0x3ead82c4,0xe81e06ae,0x27f8021e}},	//   ddni, _bket_, _पाठा_, _vern_,
   {{0xb5fd8d11,0x6443e8d8,0x9f58020f,0x786d80a9}},	//   _poša, edni, _herë_, _dúvi,
   {{0x78600201,0x64890da8,0x3ead808e,0x9f459c18}},	//   _mövz, džij, _dket_, valý_,
   {{0x75228019,0x6441879a,0x26d868d9,0x6a758144}},	//   rtoz, _cali, _turo_, _ráfa,
   {{0x6441e8da,0x26d2010c,0x087703de,0x26c00833}},	//   _dali, _oiyo_, _פעלט_, _ohio_,
   {{0x6e968013,0x7d04352c,0xe6968013,0x25ad009a}},	//   _الرا, _ovis, _الرد, żeli_,
   {{0x81aa00c8,0xa3d80466,0x9f5a09b2,0xd7fa9577}},	//   গের_, िशा_, dapé_, лун_,
   {{0x7c658013,0x7d02955f,0x6441960c,0x290a8259}},	//   _والل, msos, _gali, čba_,
   {{0x7d043472,0x26d21cee,0x7d028711,0x26c00362}},	//   _avis, _biyo_, lsos, _bhio_,
   {{0xc3b780be,0x26d20704,0x8f9b025f,0xe0df0362}},	//   _פלאץ_, _ciyo_, ריטי, _sròm_,
   {{0x92d50a49,0x261a09a3,0x98a6872a,0x64419af2}},	//   _হবে_, _भारी_, _лиде, _yali,
   {{0x2a66822c,0x64418be9,0xf4840098,0x9f458216}},	//   _hoob_, _xali, пусн, galó_,
   {{0x25a068db,0x2a6681c5,0xeabf001c,0x5f93ca56}},	//   _exil_, _koob_, _phù_, _ништ,
   {{0x644386b9,0x7d02a551,0x9f5a34d3,0x00000000}},	//   zdni, ksos, capé_, --,
   {{0xb5fd8fda,0x786d81ac,0x6e2d52b5,0x2a668282}},	// [6d30] _bošn, _súvi, _ibab, _moob_,
   {{0x44276184,0x2a66e8dc,0x3eade8dd,0x81bd80ab}},	//   _ùn_, _loob_, _sket_, _আলম_,
   {{0xeabf00ff,0x6441e8de,0x656f68df,0x273a81a9}},	//   _thù_, _rali, lych, _jūn_,
   {{0x2a66bdd7,0x6d4d1316,0x442ce667,0x81cb00ab}},	//   _noob_, _kraa, _abd_, রুষ_,
   {{0x6441861b,0xa3cb9a87,0xed59a262,0x656f0428}},	//   _pali, रेन_, рол_, nych,
   {{0x61ff029a,0x68ed68e0,0x442caad6,0x644189ac}},	//   laql, mpad, _cbd_, _qali,
   {{0x64418744,0x2a66e8e1,0x64438082,0x8c1c098a}},	//   _vali, _boob_, rdni, אווי,
   {{0x6441a6fb,0xe9d9c436,0x2a6681c5,0x6d4d68e2}},	//   _wali, шки_, _coob_, _oraa,
   {{0x2ba980c2,0x6609bbb5,0x68ed0ff5,0xe0d68a8e}},	//   _चुरा, _idek, npad, овы_,
   {{0xaf0594b8,0x6e2d64f0,0x39493efc,0x26d20010}},	//   опол, _abab, ivas_, _siyo_,
   {{0x2a668282,0x7d0931ce,0x6609816b,0x7d0468e3}},	//   _foob_, šesl, _kdek, _svis,
   {{0x6d4d14d1,0x2a6681b4,0x63ad8850,0xddcd0824}},	//   _braa, _goob_, ğand, _slaš,
   {{0xddcd68e4,0x763a8158,0x2c6b8257,0xb5fd811f}},	//   _plaš, בערג, _født_, _lošo,
   {{0x6d4d05f8,0x7d0480f7,0xdfdb8081,0x6e2d036a}},	//   _draa, áisi, _съд_, _ebab,
   {{0x81b100ab,0xbb432154,0xd2520591,0x6d4d4ab0}},	//   টেম_, мерк, ونس_, _eraa,
   {{0x66098135,0x6d4d1e7a,0x6e2d68e5,0x7d040840}},	//   _ndek, _fraa, _gbab, _tvis,
   {{0x6d4d42cf,0x25df000f,0x68ed1341,0x2a79008e}},	// [6d40] _graa, _गलती_, gpad, _dlsb_,
   {{0x83fc81a1,0x68e4e8e6,0x1fb6004a,0x6ecca2f8}},	//   _rođo, _éide, осер, _işbi,
   {{0x4444369d,0xe821809a,0x81cb00ab,0x224200d9}},	//   _ia_, _माना_, রুল_, _takk_,
   {{0x44443f47,0x61ff0085,0xd62a8371,0x87ac83de}},	//   _ha_, caql, роде_, נשאַ,
   {{0x2a66e8e7,0x764468e8,0x6ef002d6,0x66099a14}},	//   _roob_, _maiy, _bòbò, _ddek,
   {{0x444468e9,0x443868ea,0x66098133,0x83fc817f}},	//   _ja_, ner_, _edek, _vođo,
   {{0x444468eb,0x443868ec,0x7d02baa8,0x9f4305a4}},	//   _ma_, ier_, ssos, _dejó_,
   {{0x44384979,0x61e43a03,0xfbd30039,0xead38009}},	//   her_, ncil, ותו_, мощь,
   {{0x44383ff7,0xa2da8894,0x444468ed,0xe51c06b7}},	//   ker_, _पूर्, _oa_, भूमि_,
   {{0x6d40e8ee,0x7e62803b,0x443868ef,0xddc4378d}},	//   _isma, ljop, jer_, _bliž,
   {{0xb7db03c8,0x7e7d1a2e,0x76440041,0x673a81ed}},	//   יקיי, thsp, _baiy, uwtj,
   {{0x444401b4,0x6d4d058f,0x368b11cf,0x39490110}},	//   _aa_, _praa, рсон_, yvas_,
   {{0x44445a5c,0x4438273d,0x200a026c,0x1dca84c5}},	//   _ba_, fer_, _odbi_, िधित,
   {{0x444468f0,0x443817db,0x6d4d1aee,0x656f68f1}},	//   _ca_, ger_, _vraa, rych,
   {{0x76440326,0x9f4100e5,0x6d4d1384,0xd8388b80}},	//   _faiy, cchè_, _wraa, meč_,
   {{0x444468f2,0x6d40e8f3,0xd838c759,0x6d4d23df}},	//   _ea_, _osma, leč_, _traa,
   {{0x444453a5,0xe82181ab,0x61ff0201,0xb5fd87dd}},	// [6d50] _fa_, _मामा_, raql, _došl,
   {{0x44445738,0x7c388052,0x68ed39b3,0x61e40118}},	//   _ga_, jevr, rpad, acil,
   {{0x44214157,0x6d408573,0x1eea026a,0x4ea7e8f4}},	//   _ich_, _asma, مولی_, орда,
   {{0x51872355,0x68ed016d,0x9f4147ab,0x236c0106}},	//   _дуга, ppad, nché_, ädje_,
   {{0x44442af7,0x644504d2,0x73e58698,0x6609820f}},	//   _ya_, _kahi, полз, _vdek,
   {{0x444468f5,0x61fd0775,0xd83882fd,0x644510fe}},	//   _xa_, _hesl, ječ_, _jahi,
   {{0x64451856,0x6d40c9cf,0x2001061b,0x290683a8}},	//   _mahi, _esma, mahi_, _avoa_,
   {{0x4438623f,0x60d507d9,0x442101a8,0xb87b016b}},	//   zer_, _hizm, _lch_, _stíh,
   {{0x4421671b,0x44380806,0xc1b9035a,0xdb08801b}},	//   _och_, yer_, _आरोग, _vydá,
   {{0x26dc8a8e,0x443868f6,0x644568f7,0x44214fbe}},	//   _buvo_, xer_, _nahi, _nch_,
   {{0x443804c7,0x444468f8,0xe8218076,0x7e7b803a}},	//   ver_, _ra_, _माठा_, _klup,
   {{0x44441f2c,0x44211523,0x443828be,0x9f410698}},	//   _sa_, _ach_, wer_, rchè_,
   {{0x64452100,0x20013f8c,0x57b8064a,0x1c200f3d}},	//   _bahi, kahi_, _अर्ह, _बादल_,
   {{0x3cfd8076,0x443868f9,0x2001123c,0x644568fa}},	//   रीये_, uer_, jahi_, _cahi,
   {{0x444413f0,0x44382267,0x61fd2a65,0xb5fda19f}},	//   _va_, rer_, _besl, _pošl,
   {{0x444468fb,0xe9da0e17,0x61fd017f,0xd5a70d86}},	//   _wa_, ска_, _cesl, _टुकड़,
   {{0x444468fc,0x6445152b,0x61fd00a2,0x61e45fd9}},	// [6d60] _ta_, _fahi, _desl, rcil,
   {{0x4444146a,0xb90411bc,0x8fa60098,0x7e7ba256}},	//   _ua_, _पं_, пазе, _alup,
   {{0x25bf8510,0xc2f080ab,0x59b00035,0x7d19890d}},	//   _azul_, _টিভি_, _फ़रवर, euws,
   {{0x61fd6338,0x64451982,0x0dca8009,0x3e7b00f1}},	//   _gesl, _zahi, блей_, _këta_,
   {{0xa25b0142,0x48e312c0,0x64452abe,0x7c389dcc}},	//   _khôn, _появ, _yahi, tevr,
   {{0x25bf80dd,0x91bb0039,0x7e62b945,0xb87b0216}},	//   _dzul_, _למכי, sjop, _cuíd,
   {{0x8fa30c40,0x5e969a00,0xd8388353,0x07a30791}},	//   _заре, _فلسط, več_, _зарн,
   {{0x7e7b803a,0x60dd00dd,0xb95480e8,0x26dc8037}},	//   _glup, _yusm, двищ, _ruvo_,
   {{0x6d40b1e0,0x7984005d,0x26dc8904,0x2d828106}},	//   _usma, nziw, _suvo_, _åke_,
   {{0x443887ca,0x44e281fa,0x6c8692dc,0x2fd883ba}},	//   _úr_, _ið_, _علام, ørg_,
   {{0x644549ec,0x09b906bf,0xd838e150,0x7bda8420}},	//   _rahi, _आर्य, reč_, _igtu,
   {{0x644537f1,0xd6d78987,0xe821b792,0x442168fd}},	//   _sahi, ять_, _माथा_, _sch_,
   {{0x9f412b3c,0x644547c7,0x61fd68fe,0x200168ff}},	//   rché_, _pahi, _resl, yahi_,
   {{0x753d0063,0x6ab51094,0x26dc8693,0x29028110}},	//   rwsz, ंत्र, _tuvo_, škas_,
   {{0x64456900,0x3d12016f,0x2491080a,0xe821ab51}},	//   _vahi, _तिथे_, rizm_, _माता_,
   {{0x200160ea,0x60f911e9,0x644563ea,0x69da0087}},	//   wahi_, жная_, _wahi, _şter,
   {{0x200124ec,0xf9930077,0x644541a8,0xd2500065}},	// [6d70] tahi_, ربر_, _tahi, ھنے_,
   {{0x201e81e2,0x26c48267,0x61fd0a15,0x3eb9232a}},	//   ngti_, _ahmo_, _wesl, llst_,
   {{0x44e2e901,0xb9040076,0x61fd4da6,0x7e7b80e7}},	//   _að_, _पू_, _tesl, _plup,
   {{0xa159259a,0x20010a4f,0xddd08110,0x19590a14}},	//   _даму_, sahi_, _šešt, _дамы_,
   {{0x8c459ccf,0x04459354,0x6d468805,0xb87b002a}},	//   деле, делн, _škar, _puíd,
   {{0x7e7b80b9,0x7eb60061,0x22496902,0xb5fd8619}},	//   _wlup, rápi, ldak_, _košk,
   {{0x7e6985f8,0x9f5ee903,0x9f3400e8,0xb5fd836f}},	//   _toep, baté_, _пері, _jošk,
   {{0xb5fd8db7,0x660d6904,0xcf9200be,0x7e7be905}},	//   _mošk, _ndak, _סטן_, _ulup,
   {{0x81b58a49,0x08c58328,0x21290812,0x7d0480f7}},	//   ছেন_, мбин, ntah_, áist,
   {{0x660d20f4,0x7d0484b7,0x2a7f9705,0xa8899138}},	//   _adak, ġist, shub_, ійна_,
   {{0xa25b00e7,0xaabf14a7,0x628081c0,0xb21b00ec}},	//   _rhôn, ्षाक, bhmo, _klæd,
   {{0x7bc18668,0x21290d8b,0x2249231b,0x38b40106}},	//   _izlu, ktah_, jdak_, lärt_,
   {{0xddc08efd,0xe81e1344,0xd945813a,0xd009a857}},	//   _komš, _पाला_, _цели, _деле_,
   {{0xb5fd8503,0x2a7d8069,0x741601ad,0x7afb0b80}},	//   _bošk, _hlwb_, بوسا, ćutn,
   {{0x09e61b4b,0x2129226e,0x394da0a5,0x41eb019d}},	//   добн, etah_, lves_, _ụsọ_,
   {{0xc3328051,0x64890110,0x7d09a3e7,0x212933bf}},	//   כול_, džiu, _oves, ftah_,
   {{0xa25b0104,0x63a487d9,0x3ced81c5,0xe29702df}},	// [6d80] _thôn, ğini, _ntev_, фат_,
   {{0x6d44236a,0x63a48b16,0xa2be06f0,0xb5fb01fa}},	//   _isia, şini, _वीर्, hjál,
   {{0x7d09a0dc,0xa3b506a7,0x7eb883a8,0x9f5eb4d3}},	//   _aves, _छुप_, lípi, taté_,
   {{0x7c3c0102,0x20072320,0xdddb81d0,0x386a0428}},	//   lerr, ónir_, _kouř, _wobr_,
   {{0xa3cb890f,0x6489005c,0x9f5eaad5,0x98bd82d6}},	//   रेस_, rživ, raté_, _aswč_,
   {{0x394d8019,0x7c3c1473,0x38b40338,0x6d442aa0}},	//   dves_, nerr, gärt_, _msia,
   {{0x628080f1,0x6489026f,0xf743087e,0x9f5ee906}},	//   thmo, mžit, _иеро, paté_,
   {{0x7c3c5245,0x6d4462eb,0xb21b013c,0x7c2931ce}},	//   herr, _osia, _glæd, đeri,
   {{0x7c3c0bf0,0x14268187,0xa2daa0d8,0xdb088198}},	//   kerr, _одам, _पंक्, _sydä,
   {{0x6a7c80e7,0x62808168,0x7c3c1832,0x63ad807e}},	//   _défa, shmo, jerr, şana,
   {{0x6d446907,0x381704de,0x7d09af82,0xdb0b07c0}},	//   _asia, וקים_, _zves, ünüz,
   {{0x64488a98,0x443c8982,0x442ee908,0x787f80e7}},	//   _hadi, lev_, lff_, _rêve,
   {{0x6448927b,0x645a8122,0x7c3c6909,0x63a902d0}},	//   _kadi, _knti, ferr, ğenm,
   {{0x64488be6,0xb5fdd7c3,0x442ee90a,0x443c8074}},	//   _jadi, _pošk, nff_, nev_,
   {{0xa4d4035f,0x46a70009,0x62810110,0xf8378039}},	//   торі, _ошиб, ūlom, _חנות_,
   {{0xe0df0698,0x83fc812b,0x3204c75a,0x660d690b}},	//   _può_, _dođi, namy_, _udak,
   {{0x7c3c690c,0x443ce90d,0x7eb883a7,0x645a8980}},	// [6d90] berr, kev_, cípi, _onti,
   {{0x3e7b020f,0x443c8805,0x7d1d530e,0x7c3c58cf}},	//   _këto_, jev_, muss, cerr,
   {{0x7d098067,0x21291a4d,0x7d1d2551,0xd148801c}},	//   _sves, stah_, luss, _lễ_,
   {{0xb5fd9dc1,0xc3320158,0x6aa280f1,0x6e3d4b48}},	//   _koši, _גוט_, _njof, nesb,
   {{0x6448e90e,0xe3b8880a,0x7e6d0420,0xb5fd8b80}},	//   _badi, _ayı_, _moap, _joši,
   {{0xdfc695a8,0x645a80dd,0x443c82f1,0x251c0e82}},	//   _مي_, _cnti, gev_, קווא,
   {{0xb5fd811f,0x6448e90f,0x1ee700d7,0x6600d497}},	//   _loši, _dadi, _آوری_, _femk,
   {{0x7c3c1124,0xb1459d32,0x7e6d002e,0x7d1d12a5}},	//   zerr, енил, _noap, kuss,
   {{0x7c252158,0x81b100c8,0x644884b9,0x9f410013}},	//   _ochr, টের_, _fadi, ichí_,
   {{0x6448e910,0xd1488028,0x7d1d62f1,0x443c807a}},	//   _gadi, _dễ_, duss, cev_,
   {{0x3ce04fac,0xa3cb83dd,0xe7ee86a7,0x394de911}},	//   _suiv_, रेश_, छड़ा_, sves_,
   {{0x29090009,0x290b0669,0x32048035,0x7c255377}},	//   ksaa_, _ovca_, camy_, _achr,
   {{0x7ae1e912,0xb87b03a8,0xa25b0036,0x7d1d6913}},	//   _hult, _xuíc, _chôm, guss,
   {{0x8fa5b4fb,0x61e9e914,0x64488be9,0x83fc80fe}},	//   _пале, lcel, _xadi, _pođi,
   {{0x2005e915,0x4256117e,0x7c3c2cd7,0x4425d0b1}},	//   mali_, нтат, rerr, _mcl_,
   {{0x61e9e916,0x7ae1e583,0x6d4401c5,0x7c3c09cb}},	//   ncel, _mult, _tsia, serr,
   {{0x443c8086,0x66066917,0x563700be,0x08c6393f}},	// [6da0] yev_, makk, _טאקע_, ебан,
   {{0x2005e918,0x660660fe,0x3940009a,0xf1bf0032}},	//   nali_, lakk, rwis_, _abás_,
   {{0xabfb0051,0x66008b99,0xf7721ddd,0x7ae181f4}},	//   _מהיר, _pemk, داء_, _nult,
   {{0x6448e919,0x2005c0a6,0x66061f5d,0x645a80b9}},	//   _sadi, hali_, nakk, _snti,
   {{0x443ca52d,0x2005e3ff,0x4abf0076,0x6448e91a}},	//   tev_, kali_, ्षरव, _padi,
   {{0x6296691b,0x2005cb71,0x7ae19fdc,0x44e6001c}},	//   liyo, jali_, _bult, _mô_,
   {{0x443c92f1,0x2005e91c,0x1fb50ddc,0x64488ddc}},	//   rev_, dali_, _астр, _vadi,
   {{0xcb130051,0x443c9d43,0x6296691d,0x660622dc}},	//   אלה_, sev_, niyo, jakk,
   {{0x6448e91e,0x66061b6b,0xada39cfc,0x261a016f}},	//   _tadi, dakk, _батл, _भाजी_,
   {{0x2005e91f,0xd7f796fe,0x62961b28,0x320480ee}},	//   gali_, ную_, hiyo, samy_,
   {{0xb4cc93e5,0x62965ced,0x660602a6,0x61e9b603}},	//   रगी_, kiyo, fakk, bcel,
   {{0x7c2507b4,0x6e22829b,0x7d1d23b6,0x290902a3}},	//   _schr, ngob, tuss, ysaa_,
   {{0x44e60104,0x2005e920,0x62963be6,0x44336921}},	//   _cô_, bali_, diyo, _pbx_,
   {{0x20059429,0x6606008e,0xbcfb002a,0x7ae201a1}},	//   cali_, aakk, bxén, _čotr,
   {{0x66065bc7,0x7d1d6922,0x39ee0a2c,0xd7f88087}},	//   bakk, suss, _ọzọ_, mbă_,
   {{0xb5fd8390,0x7d1d0c4f,0xb0ec00ab,0x66e50084}},	//   _toši, puss, _ওয়েব_, _dėkl,
   {{0x38b400f2,0x68e2827e,0x51873678,0x320204e8}},	// [6db0] värr_, _juod, хува, _deky_,
   {{0x7c25122e,0x68e28009,0x9f5807f1,0x7d0d17c9}},	//   _uchr, _muod, _berà_, _ivas,
   {{0x62961040,0x29090198,0x26c96923,0x44e60129}},	//   biyo, ssaa_, _khao_, _zô_,
   {{0x2005e924,0x628429d1,0x39468baf,0x9f5e80e1}},	//   zali_, chio, _osos_, jatí_,
   {{0xe8218697,0x200582ec,0x272a84be,0x44e600ff}},	//   _माला_, yali_, hùn_, _xô_,
   {{0x76498101,0xd11604de,0x44232f3e,0x224b1e44}},	//   _waey, _בקשה_, ngj_, _hack_,
   {{0xa3cb8063,0x76498708,0xb87b05e4,0x6606028d}},	//   रें_, _taey, _guía, yakk,
   {{0x2005e925,0xa562803d,0xb4bf008e,0x6a7c8036}},	//   wali_, _چگون, ेषु_, _défo,
   {{0x66064269,0x200304be,0xe9df157a,0x61e985d8}},	//   vakk, _keji_, _raúl_, rcel,
   {{0x7ebd03d3,0x61e9cdb0,0x68e28084,0x629661fb}},	//   léph, scel, _duod, ziyo,
   {{0x2005bae4,0x07a58112,0xf42700c8,0x394685b4}},	//   rali_, танн, য়ার_, _esos_,
   {{0x26c96926,0xd7f88087,0xfce61ac1,0x44e65931}},	//   _chao_, abă_, комо, _pô_,
   {{0x2005b22e,0xb6a339c3,0x629602d0,0xfd1f00e5}},	//   pali_, риял, viyo, guì_,
   {{0x44e60028,0x2005836a,0x44230789,0x9f580118}},	//   _vô_, qali_, ggj_, _lerá_,
   {{0x224b3624,0x629607d9,0x62843424,0x7d0d6927}},	//   _back_, tiyo, thio, _evas,
   {{0x224de928,0x44e61762,0xb5fd805c,0xcfb700ab}},	//   ndek_, _tô_, _košu, জধান,
   {{0x62966929,0x9f5807e2,0x290c01a9,0xbcfb002a}},	// [6dc0] riyo, _serà_, _ādas_, nxél,
   {{0x92dc80c8,0x6296692a,0x66043416,0x628401c6}},	//   তীয়_, siyo, _heik, shio,
   {{0x394d0289,0x3a3fe92b,0x7d09005c,0x6a78007b}},	//   _šest_, keup_, šest, _lífi,
   {{0x6a7c80e7,0x644e5c09,0x9407811c,0x2003026b}},	//   _réfo, ldbi, minə_, _eeji_,
   {{0x6e228242,0x3cfd801b,0x63ad861c,0x6604692c}},	//   rgob, रीले_, şanl, _meik,
   {{0x66040357,0xdb1a8019,0x644e4f36,0x3a268087}},	//   _leik, _aztá, ndbi, _scop_,
   {{0xa0370bea,0xfbd580ab,0x3860c861,0x02a68087}},	//   _שאלה_, _স্বত, _đir_, крим,
   {{0xeaaf80f7,0x60dc07b8,0x6d5610ed,0x6a78016a}},	//   يعي_, _hirm, _orya, _bífi,
   {{0x60dc692d,0x2498008e,0x63a902d0,0xfce69133}},	//   _kirm, kirm_, ğeni, _розо,
   {{0x68e28364,0xe7ed81d0,0x63a9692e,0x00000000}},	//   _vuod, चुला_, şeni, --,
   {{0x7d0d0052,0x25be0201,0x6d56692f,0xba268bba}},	//   _svas, ətli_, _arya, _адек,
   {{0x645e0205,0x6f030073,0xc7b304de,0xa3b601ce}},	//   _anpi, ânci, יבת_, _जड़_,
   {{0x40348110,0xbebd00eb,0x3946c33a,0xceb384de}},	//   _белс, ktīv, _usos_, שיר_,
   {{0x628281e9,0x8f54803d,0x66e50110,0xf75480f7}},	//   _hloo, _منتش, _sėkm, _منتج,
   {{0xb5fd803b,0x69c600ad,0x26c90028,0x6d560ec8}},	//   _košt, _azke, _thao_, _erya,
   {{0x28c686b7,0x442d001b,0xb87b0580,0x645e332c}},	//   _रीति, ře_, _atíp, _enpi,
   {{0x628281e9,0xaca3019d,0x6a7c80e7,0xf80700e8}},	// [6dd0] _mloo, _alụg, _réfl, вчен,
   {{0x9f580510,0x7e7d0123,0xa2c98054,0x764d01b4}},	//   _será_, lksp, _हीन्, _haay,
   {{0x224b04b8,0x764d2575,0x62828091,0x69c60102}},	//   _tack_, _kaay, _oloo, _ezke,
   {{0x628281c0,0x4b7a007c,0x60dc0a2a,0xed59816b}},	//   _nloo, _נארו, _eirm, _lyže_,
   {{0xed588cde,0x764d1341,0x9f58282b,0x7ae50009}},	//   кої_, _maay, _verá_, _huht,
   {{0x60dc6930,0x764d5d73,0x66e8800d,0x6282a57a}},	//   _girm, _laay, _něko, _aloo,
   {{0x7ae50006,0x9f580e67,0x224d837a,0x6282c7af}},	//   _juht, _terá_, tdek_, _bloo,
   {{0x2369803b,0x2018846d,0x7ae5421d,0x66e8801b}},	//   ćaj_, órin_, _muht, _pěkn,
   {{0x66042f4c,0x3a3f82f7,0x20c2807b,0x6e299c96}},	//   _reik, reup_, rðin_, _iceb,
   {{0x94078201,0x6d49c3cb,0x7989809a,0x91bc0039}},	//   yinə_, _isea, rzew, ומחי,
   {{0xa2f58278,0x764d4577,0x628281c6,0x79898035}},	//   _спеч, _baay, _floo, szew,
   {{0xddcd026f,0x764d486f,0x89b4819d,0xf38c83de}},	//   _dlaž, _caay, ịtọs_, _קראָ,
   {{0x61fbbf6d,0x660425e4,0xb87b0ece,0x22400110}},	//   mbul, _veik, _ruín, veik_,
   {{0x61fbcb9d,0x753b82a0,0x7e7d6931,0x7ae5050b}},	//   lbul, _mpuz, ërpr, _buht,
   {{0x387880f2,0x88838077,0x66041db4,0x30da80be}},	//   örre_, _میکن, _teik, _אַהע,
   {{0x94078201,0xb87b00f7,0x7e7d048d,0x6721e932}},	//   rinə_, _buío, cksp, mulj,
   {{0x60dc3d3b,0x94078201,0x22402ca2,0x98a00289}},	// [6de0] _pirm, sinə_, reik_, ntić_,
   {{0x61ed1268,0x224033f9,0x764d0c2e,0xa84a0174}},	//   acal, seik_, _zaay, علام_,
   {{0xe61a828b,0x61fb883a,0x6d49e933,0xeb9a4ddf}},	//   еде_, kbul, _asea, _чин_,
   {{0x61ed6934,0x95ca9444,0xa96a0256,0xdfcf00f7}},	//   ccal, нула_, _зима_, سين_,
   {{0x6aa40087,0x98a005a2,0xe5a3951b,0x63a90799}},	//   mnif, jtić_, бици, ßenv,
   {{0x1aeb80c8,0x62829699,0xafe31ae1,0xbebd01a9}},	//   _টিজে_, _sloo, _горл, ltīt,
   {{0xb5fd9874,0x6282a29a,0x6721817f,0x6d49913b}},	//   _pošt, _ploo, julj, _esea,
   {{0x6721d464,0x98a00754,0x61fb8ce9,0x391481cf}},	//   dulj, ftić_, gbul, амир,
   {{0xddcd0a20,0x83fc8e78,0x201883a7,0x628286a8}},	//   _slaž, _anđe, ório_, _vloo,
   {{0xddcd1011,0x83fc9f3a,0x473495b7,0x764d26e8}},	//   _plaž, _vođs, анос, _saay,
   {{0x61fb8365,0x764d0637,0xf65f006a,0x2fd88106}},	//   bbul, _paay, nlæg_, ärg_,
   {{0x7bc88d11,0x91e68009,0x61ed0388,0x45d50c9b}},	//   _izdu, _соде, xcal, ионс,
   {{0x7ae501c2,0xd90e87d2,0x6d4f8118,0x25f403db}},	//   _suht, _عید_, _ácat, ंड़ी_,
   {{0x764d02a3,0x67d492bc,0x7ae504a2,0x2c7986c0}},	//   _waay, _колу, _puht, _pèdi_,
   {{0x8aa70951,0xb87b0013,0xd25b1fa9,0xddcd0d11}},	//   град, _suío, нца_, _ulaž,
   {{0xf65f0ae1,0x6aa41162,0x5faf064a,0x48fb801b}},	//   dlæg_, gnif, _जुगल, लीको_,
   {{0x61ed058d,0x98a91432,0x3ea900b9,0x940a0085}},	// [6df0] rcal, stač_, _ijat_, hibə_,
   {{0x61fba008,0xf00b001c,0x98a90267,0x68e600fc}},	//   zbul, _đẳng_, ptač_, _dukd,
   {{0x61e2d527,0x2fc700f2,0x753b8140,0x828b8032}},	//   _ogol, ång_, _spuz, _látọ,
   {{0x61e2dbc5,0x5d55a262,0x635c8087,0x6aa4209c}},	//   _ngol, икет, _mănă, cnif,
   {{0x00000000,0x00000000,0x00000000,0x00000000}},	//   --, --, --, --,
   {{0x61e2a256,0x4d7c00be,0x98a00088,0xf1bf046d}},	//   _agol, ערגע, vtić_, _iyá_,
   {{0x43698071,0x9f5c8580,0x961d0264,0x7d1d4255}},	//   тайн_, _nevà_, ধ্যম_, hrss,
   {{0x6d498013,0x3f8c826c,0x3dc900b9,0xbb3c0e82}},	//   _tsea, dzdu_, _ozaw_, געהי,
   {{0xb42787d2,0x6d498009,0xd5388872,0x798d09ab}},	//   _معاو, _usea, _مثلا_, nzaw,
   {{0x5d848013,0x25bf8201,0x290d922d,0x660ba414}},	//   _الكل, _iyul_, rsea_, lagk,
   {{0x205481bb,0x98a00d11,0x6443cdd1,0x5ba78009}},	//   стыр, stić_, meni, _сраз,
   {{0x6443c75a,0x6721e935,0x2cba0101,0x660b809c}},	//   leni, rulj, _skpd_, nagk,
   {{0x05d0016f,0x6cc600e8,0xfce61033,0x920801a9}},	//   सेंब, ийма, рого, ntāž,
   {{0x6443e936,0x629b8110,0x442790e1,0x6721cb25}},	//   neni, liuo, ngn_, pulj,
   {{0xe29a395b,0xa09a83c8,0xdca30572,0xf1bf026b}},	//   вав_, _ביסט, цари, _ayá_,
   {{0x6443bfae,0x63be026f,0x629b8110,0x6f1c9727}},	//   heni, _vypn, niuo, árce,
   {{0xe9da00e9,0x6443b301,0x2007820f,0x673c02ce}},	// [6e00] тка_, keni, _keni_, _sprj,
   {{0x64438b5d,0xbebd0029,0x200780f1,0x7e608101}},	//   jeni, stīt, _jeni_, _snmp,
   {{0x6443e937,0xb4b205fc,0x2cb804fe,0x629b8084}},	//   deni, टकी_, mord_, kiuo,
   {{0x7d046938,0xb17b00f2,0x2a6d84b7,0x2cb83807}},	//   _kwis, _igån, jjeb_, lord_,
   {{0x6443ba6d,0x9c7c82d4,0xe80106a7,0x9f4e8242}},	//   feni, _liče, _लड़का_, _jefò_,
   {{0x7d041b74,0x2007e939,0xd7f200f7,0x2cb80687}},	//   _mwis, _neni_, _ذكر_, nord_,
   {{0x2d80b7f6,0x9c7cd717,0xd838a58f,0x8fa3693a}},	//   šie_, _niče, niče_, _даре,
   {{0x7bc89807,0xd257e93b,0x2a7f81c0,0xddcd17ac}},	//   _vzdu, аць_, gkub_, _plaż,
   {{0x30a69b93,0x6443e93c,0x2007e93d,0x506681e2}},	//   иров, beni, _beni_, атна,
   {{0x2007e93e,0x9da5803d,0x213d82c4,0x2cb81e7c}},	//   _ceni_, _اصفه, _dpwh_, jord_,
   {{0x6d4f8207,0xb5fd826c,0x2007c8a7,0x7d04022b}},	//   _ácar, _košp, _deni_, _awis,
   {{0xd83881d0,0x442c8229,0x3ea6e907,0x7761002a}},	//   diče_, _hcd_, nnot_, _álxe,
   {{0x6a78007b,0xb87b00f7,0x2007deea,0x443a693f}},	//   _lífs, _suím, _feni_, _bbp_,
   {{0xb8cb80c8,0x2007b4dd,0x68ed80f7,0x443a43b6}},	//   _কী_, _geni_, _éada, _cbp_,
   {{0x200ce940,0x443a0748,0x66e8928a,0x26c204e8}},	//   madi_, _dbp_, _měkk, blko_,
   {{0x200ce941,0x64439d21,0x20078042,0x32641454}},	//   ladi_, zeni, _zeni_, отув,
   {{0x20078a0b,0x2cb8209b,0x1bf88105,0x7c3a81a1}},	// [6e10] _yeni_, bord_, ुराल_, _obtr,
   {{0x200cc06a,0x6d4d6942,0x6a7ce943,0x3eb910d1}},	//   nadi_, _isaa, _défi, lost_,
   {{0x7d040352,0x6443e944,0x3ce9022c,0xed59811f}},	//   _zwis, veni, _huav_, _srž_,
   {{0xa2830bca,0x200c8c47,0x3ce901c0,0x63bb03bf}},	//   _بیرو, hadi_, _kuav_, ğund,
   {{0x644398cc,0xe618821e,0x200cd1d6,0xa3d4cc5c}},	//   teni, рді_, kadi_, सेस_,
   {{0x3eb96945,0x6d4d022e,0x200c8239,0x308500f7}},	//   host_, _msaa, jadi_, _السف,
   {{0x6443e946,0x26cd8104,0x62898013,0x3eb907dd}},	//   reni, _theo_, theo, kost_,
   {{0x20078a8f,0x3e7b00f1,0x3eb90668,0x3a2944cf}},	//   _seni_, _këtu_, jost_, ngap_,
   {{0x629b949e,0x6e3bc1a8,0x3eb92771,0x3ce90282}},	//   riuo, _ibub, dost_, _nuav_,
   {{0x14748013,0x7c2d8067,0xac748013,0x92e200ab}},	//   _والج, đars, _والش, নীয়_,
   {{0x160b853f,0x6d4d0ed4,0x25f409c8,0x2007d5e8}},	//   _हजार_, _asaa, ंडली_, _veni_,
   {{0x443a00ee,0x394904b9,0x9c7c817f,0x8b9a81c6}},	//   _sbp_, kwas_, _viče, _גבעת,
   {{0x200c8587,0x6609e947,0x3ce90069,0x2007ab5f}},	//   badi_, _meek, _cuav_, _teni_,
   {{0xd838803b,0xa956812a,0x6609e948,0xab2a47f9}},	//   tiče_, _לינק_, _leek, лога_,
   {{0x8fa292e1,0xc0528039,0x9ef580f7,0x6e3b82ec}},	//   _наше, _מזג_, _استش, _obub,
   {{0x4f168159,0x3a29010b,0x2731d002,0x6609aef3}},	//   _פֿון_, ggap_, mán_, _neek,
   {{0x2731e949,0x7e64694a,0x49ca0bda,0x6d5b81c5}},	// [6e20] lán_, _inip, улан_, _nrua,
   {{0xe9d71cf6,0x6e3b83c3,0x764604dc,0x81ac8264}},	//   ску_, _abub, leky, _গরম_,
   {{0x6609e94b,0x7e645cc4,0x2731d138,0xef1a4eaa}},	//   _beek, _knip, nán_, уме_,
   {{0xdddb82a5,0x3ce9146a,0x62860364,0xe821835a}},	//   _sluš, _yuav_, _ulko, _माझा_,
   {{0x27318013,0x6d5b8083,0x200cd038,0x3ce9022c}},	//   hán_, _crua, yadi_, _xuav_,
   {{0x6e3b8135,0x2b4c80b9,0x76460122,0x62998545}},	//   _ebub, _psdc_, heky, _amwo,
   {{0x33178013,0x7f860013,0x200ce510,0x7e64046d}},	//   مزيد_, _الأن, vadi_, _onip,
   {{0x50f4910b,0x200cab16,0x2731e94c,0x9695a30e}},	//   озит, wadi_, dán_, _друш,
   {{0x3eb95717,0x200ce94d,0x29121066,0x6d5be94e}},	//   vost_, tadi_, nsya_, _grua,
   {{0xdefa827e,0x7ae88019,0xb5fd8267,0x97148be2}},	//   лым_, _tudt, _inša, омоц,
   {{0x200ccd16,0xb8ef89a3,0x2731b38d,0x3ce901e9}},	//   radi_, _वी_, gán_, _suav_,
   {{0x200cb51c,0x3ce90069,0x7c2a83ba,0xddc401a9}},	//   sadi_, _puav_, lgfr, _maiņ,
   {{0xa1338077,0xddc09dd7,0x3ce90069,0x6d408176}},	//   _فروش, _lomž, _quav_, _jpma,
   {{0x657d08cf,0xc9178039,0x27318019,0x200cb697}},	//   rysh, _פחות_, bán_, qadi_,
   {{0x657d694f,0xd5ed0129,0x2731ab7e,0xd6db0163}},	//   sysh, _toà, cán_, _йти_,
   {{0x6d4d4950,0x78ba812b,0x139b80be,0x46a404bd}},	//   _tsaa, lotv, אבלע, _најв,
   {{0x660f05f5,0x90991354,0x66098cfa,0x3a2902f7}},	// [6e30] mack, ават_, _reek, rgap_,
   {{0x660f6950,0x7ae29ffb,0x297b807c,0x68ed01b4}},	//   lack, _liot, אטמא, rqad,
   {{0x200a2b5f,0x645521a2,0x6d40a52a,0x394901e0}},	//   _debi_, mdzi, _apma, swas_,
   {{0x46c90074,0x644706c1,0x67250748,0xddc082d4}},	//   रतिह, leji, ruhj, _domž,
   {{0xd12687bd,0x2731e951,0x628d00f7,0x6489026c}},	//   _تم_, zán_, mhao, džiz,
   {{0x2731a5b3,0x6455629c,0x1bfb238c,0x6609e952}},	//   yán_, ndzi, ्रिल_, _week,
   {{0x78ba856f,0xa3d4816f,0x6609ce5b,0x0ec903eb}},	//   dotv, सेल_, _teek, रताड,
   {{0x2731aaa8,0x6d5b893a,0x539c00be,0x7ae2cb43}},	//   ván_, _trua, טיוו, _ciot,
   {{0x3ebf8867,0xc42b8277,0x940e8201,0x6f0701c0}},	//   _ikut_, _مثال_, hifə_, _hwjc,
   {{0x2731e953,0x487988cc,0x6455009a,0x78ba825b}},	//   tán_, рсия_, jdzi, gotv,
   {{0xbebd0029,0xcdc9012a,0xe7399a19,0xfe460c40}},	//   drīb, _סך_, шен_, онно,
   {{0x2731e954,0x9f586955,0x660f0bcf,0x7ae29de8}},	//   rán_, _perú_, gack, _giot,
   {{0x2731e956,0x2d84003e,0x44ef0201,0x3eadc3f7}},	//   sán_, áme_, _cü_, _mjet_,
   {{0x27318290,0x7ae2811b,0x2b410176,0x764601e0}},	//   pán_, _ziot, _bphc_, seky,
   {{0x68e3836a,0x44ef58ce,0x7ebd0866,0x63a90799}},	//   _iind, _eü_, répr, ßenp,
   {{0x68e3e957,0x7e6415d0,0x201800dd,0x21201809}},	//   _hind, _unip, _sdri_, trih_,
   {{0x3200008e,0x68e3b96a,0x81e200ab,0x2018008e}},	// [6e40] rbiy_, _kind, নুন_, _pdri_,
   {{0x3eada69d,0x28cf8c1c,0x68e3e958,0x394f82df}},	//   _ajet_, _सीमि, _jind, _msgs_,
   {{0x68e3dccf,0x91e62f84,0x3ce306a7,0x201881d6}},	//   _mind, _моне, _टूटे_, órii_,
   {{0x68e38d23,0x628d311a,0x200a43f0,0x6a7c810c}},	//   _lind, chao, _webi_, _yéfu,
   {{0x7ae2bd27,0x3ead826c,0x395de959,0x8afc8035}},	//   _riot, _djet_, _nrws_, _kręg,
   {{0x68e3e95a,0x9c7cb3b5,0x2018011f,0x3ead8646}},	//   _nind, _biča, _udri_, _ejet_,
   {{0x44208179,0x78ba86ec,0xa2c6816f,0x7ae28035}},	//   ği_, votv, ातल्, _piot,
   {{0x68e3e95b,0x1fcf80c8,0x4420a987,0x628401bb}},	//   _aind, রশাস, şi_, nkio,
   {{0xfe43835f,0xf2d304de,0x48aa86f1,0x5ca6a3e7}},	//   _інфо, ועה_, итом_, _диаб,
   {{0x66028102,0x3878032e,0x44388014,0x6a7c8036}},	//   lbok, _jorr_, _ùr_, _réfu,
   {{0x44f08104,0x7ae2e95c,0x67218024,0x38781abf}},	//   _hà_, _tiot, grlj, _morr_,
   {{0x68e3905d,0x6455009a,0xd25080d5,0xa3c983b7}},	//   _eind, wdzi, _سنت_, ोधर_,
   {{0x61a58a16,0xd6d80cde,0x68e3e95d,0xa3dd2594}},	//   खपृष, ють_, _find, तेन_,
   {{0x44f0e95e,0xbf148077,0x443e8042,0x68e3cc49}},	//   _mà_, _فوتب, _jbt_, _gind,
   {{0x44f08142,0x645506d7,0x644742df,0x629f09ca}},	//   _là_, rdzi, reji, tiqo,
   {{0x68e3e95f,0x443ee960,0x672881a1,0x44ef4955}},	//   _zind, _lbt_, mudj, _tü_,
   {{0x44f0877f,0x629f6961,0x672880fe,0x628d6962}},	// [6e50] _nà_, riqo, ludj, rhao,
   {{0x660d02f1,0x38780219,0x628d6963,0x27e700e8}},	//   _heak, _corr_, shao, ønn_,
   {{0x660d09ca,0x67288da8,0x44f0826b,0x7d161e1e}},	//   _keak, nudj, _aà_, _zvys,
   {{0x44f09b5b,0x6602e89f,0x9c7c8c95,0xf7738538}},	//   _bà_, gbok, _riča, וקע_,
   {{0x3ead820f,0x63ad0029,0x44f0801c,0x7522debf}},	//   _vjet_, šinā, _cà_, groz,
   {{0xe3df0a49,0x317a0051,0x44f0e964,0x2249011e}},	//   _ব্যব, _הרשמ, _dà_, leak_,
   {{0x8c440201,0x3ebf80dd,0x68eb8420,0x212900b9}},	//   əşdi, _tkut_, _sugd, luah_,
   {{0x44f090ab,0x6d5f0085,0x6721957c,0x2249011b}},	//   _fà_, _orqa, vrlj, neak_,
   {{0x6aa980b2,0x44f0e2be,0x273501a3,0xe52052bf}},	//   rnef, _gà_, lån_, _बिधि_,
   {{0x6721812b,0x6abbe965,0x68e38168,0x62840102}},	//   trlj, souf, _qind, zkio,
   {{0x6d5f15e8,0x68e3e966,0x7bc56967,0x629d1e7c}},	//   _arqa, _vind, _nyhu, _omso,
   {{0x7d09b312,0x68e3a093,0xee3f016b,0x64900074}},	//   _kwes, _wind, bným_, _käig,
   {{0x2249011e,0x81a79e91,0x660d4968,0x44f08129}},	//   deak_, _بحال, _deak, _xà_,
   {{0x9c7ca8e1,0x629d63dd,0x6721825b,0x7d09820c}},	//   _ličn, _amso, prlj, _mwes,
   {{0x3d1805fc,0x93590ef5,0x6728817f,0x394256e3}},	//   _भटके_, орту_, cudj, _spks_,
   {{0x6486807b,0xc7b284de,0x2249011b,0x7d098c6a}},	//   _aðil, _רבה_, geak_, _owes,
   {{0xd94315b7,0x66e8801b,0x2167205f,0xa96709a0}},	// [6e60] нети, _děku, пити_, пита_,
   {{0x3ea203ab,0x44f0ca48,0xbcfb04c3,0x13e380ab}},	//   likt_, _rà_, rxét, নুয়,
   {{0xb8f31094,0x44f084be,0x443e86cb,0x76566968}},	//   _ही_, _sà_, _rbt_, _kayy,
   {{0x21291a67,0x44f0c462,0xe7ee0105,0xddcf9bf2}},	//   buah_, _pà_, _जलवा_, _šeše,
   {{0x38786969,0x443e80ee,0x78a1807b,0x7d098114}},	//   _torr_, _pbt_, kilv, _cwes,
   {{0x44f0d871,0x628b8558,0x3ea20a0f,0x290058aa}},	//   _và_, _algo, hikt_, mpia_,
   {{0x44f0877f,0x3af180ff,0x5f273099,0x6602e8a1}},	//   _wà_, _cáp_, _норм_, pbok,
   {{0x44f0e96a,0xee3f026f,0x443e80ee,0x60f895a6}},	//   _tà_, tným_, _wbt_, ония_,
   {{0x7ae64ea8,0x85068416,0x6d4401c0,0x629c8084}},	//   _mikt, _روان, _npia, _įrod,
   {{0x672302a5,0xb0be04c5,0x50be06b7,0x660d1922}},	//   šnje, ्तिग, ्तिष, _seak,
   {{0x660d0006,0x765603c3,0x66e8801b,0x3d0f016f}},	//   _peak, _bayy, _někt, तीने_,
   {{0x7ae6696b,0x290002f7,0x6458e96c,0x2249011b}},	//   _nikt, kpia_, ldvi, xeak_,
   {{0x6728b4c1,0xf8be052a,0x765600fc,0x78a1a26c}},	//   sudj, ्ताय, _dayy, bilv,
   {{0xb9db8051,0x64900406,0x644ab261,0x7ae6696d}},	//   _החדש, _näid, nefi, _aikt,
   {{0x083b82f6,0x2249011e,0x3edf01bc,0x7ae6696e}},	//   _העול, teak_, _amụọ_, _bikt,
   {{0xe8df801c,0x212909da,0x644a8114,0x765604b9}},	//   ược_, tuah_, hefi, _gayy,
   {{0x69c6032b,0x22490102,0x260b86a7,0x2eeee96f}},	// [6e70] _cyke, reak_, ारसी_, _huff_,
   {{0x644ad869,0x212903ac,0x69c60106,0x200e89ab}},	//   jefi, ruah_, _dyke, _jefi_,
   {{0x21290ad4,0x3f871c2f,0x6d5d183d,0xa5bb0118}},	//   suah_, ánu_, lvsa, rgóu,
   {{0x273500f2,0x629d248d,0x3f8f009a,0x39520198}},	//   rån_, _umso, ągu_, änsä_,
   {{0x3f870052,0x9c7c80c3,0x3af18129,0x64576970}},	//   šnu_, _vičn, _sáp_, _kaxi,
   {{0xd7e68013,0xfd6201bc,0x644ae971,0x2eee8118}},	//   _لك_, _akwọ, gefi, _ouff_,
   {{0xe2998084,0x6a7c8036,0x93bc8493,0xe738062c}},	//   жай_, _réfr, _scăr, _неё_,
   {{0xe8f983c5,0x6aad6972,0x94110085,0x7d09820c}},	//   оли_, nnaf, rizə_, _twes,
   {{0x81b100c8,0x44330358,0x765600b9,0xd12e80f7}},	//   য়ের_, _ocx_, _rayy, لمي_,
   {{0x76561f37,0x7659c609,0x644ae973,0x9f5a0216}},	//   _sayy, ldwy, cefi, capó_,
   {{0x7e7be974,0x6d440098,0x200e8242,0x7e6992f1}},	//   _koup, _spia, _defi_, _knep,
   {{0x29000358,0x76560359,0xaf9897ae,0xe5a65102}},	//   ypia_, _qayy, ятых_, дими,
   {{0x7ae66975,0xdb1e016b,0x3ea22d00,0x61ebe02b}},	//   _rikt, _vypí, rikt_, _iggl,
   {{0xd9429928,0x2bda8c28,0x7ae66976,0x765600fc}},	//   _реши, येवा, _sikt, _wayy,
   {{0xfce335f7,0x64570201,0xa3d8009a,0x6441b035}},	//   торо, _daxi, ़ें_, _mbli,
   {{0x764b8019,0x6458816b,0xfa671a4a,0x644ae977}},	//   jegy, zdvi, маск_, zefi,
   {{0x7ae6088b,0x3ea00118,0x68e700f3,0x7659831d}},	// [6e80] _vikt, _imit_, _bijd, ddwy,
   {{0xf42500c8,0xeb0d8105,0xc5f40326,0x7ae6309c}},	//   ম্বর_, _सबूत_, _daɓe_, _wikt,
   {{0xd70a10ac,0x7ae64180,0xbcfb0019,0x78be1699}},	//   інде_, _tikt, tvég, ropv,
   {{0x29001194,0x6441e978,0x7e7ba4cc,0xb87b0187}},	//   ppia_, _abli, _coup, _suít,
   {{0x6aa4004f,0x649002f1,0x64418362,0x644a8425}},	//   miif, _täid, _bbli, tefi,
   {{0x7414845b,0x44f40009,0xe1ff85e4,0x6fd6073c}},	//   روبا, _mä_, ñón_, _भरपू,
   {{0x17790364,0x3ea017fe,0x6b83831d,0x200ecc01}},	//   _есть_, _omit_, gyng, _refi_,
   {{0xf1bf00f7,0x68e701ed,0x5a348081,0x2eee8901}},	//   _gcás_, _zijd, хнит, _ruff_,
   {{0x7984400f,0xb87b002a,0x44f41a50,0x248c80ee}},	//   nyiw, _guís, _nä_, _tldm_,
   {{0x3ea00065,0x9c7c8289,0x7d02960c,0x7e7b8118}},	//   _amit_, _kičm, mpos, _zoup,
   {{0x7d0299dd,0x3ce78d86,0x98a9009a,0x9346804a}},	//   lpos, _छूटे_, stać_, _інде,
   {{0xc5f90074,0xbd6b08b0,0x645701b4,0x2ca301ed}},	//   ंडेय_, орге_, _saxi, wijd_,
   {{0x2ca30613,0x7d02d19f,0x200581cd,0x44331b11}},	//   tijd_, npos, bbli_, _pcx_,
   {{0x44f454b6,0x7d028b80,0x2eee8106,0xd7ef8a3d}},	//   _dä_, ipos, _tuff_, _ју_,
   {{0x68e70a0f,0x2ca300f3,0x6457002a,0x7d02808e}},	//   _rijd, rijd_, _vaxi, hpos,
   {{0x2738c92f,0xbcfb0019,0x645701b4,0x320f0061}},	//   mén_, tvéd, _waxi, úgy_,
   {{0x7d02e979,0x7e7b9cef,0x6aad19f0,0x5ea400f7}},	// [6e90] jpos, _roup, rnaf, _جميل,
   {{0x6fa0000f,0xd01112dc,0x7e7ba7b5,0xd7f8802e}},	//   _गेहू, الا_, _soup, ncă_,
   {{0x7e7be31f,0x764b9fce,0x2738a190,0x2fc7006a}},	//   _poup, tegy, nén_, æng_,
   {{0x7d0d2425,0x29190858,0x35b5831a,0x44310118}},	//   _kwas, _tvsa_, нбер, lgz_,
   {{0x68e70613,0x7d0295d0,0x8498003d,0x7996009a}},	//   _tijd, gpos, _رئیس_, czyw,
   {{0x64900006,0x7d0d0fb7,0x2738804e,0x752b890d}},	//   _täie, _mwas, kén_, rugz,
   {{0x4fc4176e,0x7e7b86c0,0x27388019,0xce958098}},	//   _аста, _toup, jén_, _завъ,
   {{0xd24e80f7,0xe3b09ef7,0x20111fa4,0x2738881b}},	//   منى_, جره_, _hezi_, dén_,
   {{0x2011026c,0x9f4a0032,0x63538085,0xbebd0ec3}},	//   _kezi_, _agbè_, _mənə, trīn,
   {{0x20110247,0x3ea01de6,0x6441972b,0x81b10264}},	//   _jezi_, _smit_, _ubli, _ওরা_,
   {{0x394684df,0x2011697a,0x3dc91066,0x7d0d4c3e}},	//   _epos_, _mezi_, _ayaw_, _awas,
   {{0x28cf800f,0xb4d8000f,0xdd1e0087,0x2011005d}},	//   _सीरि, िष्_, _câşt, _lezi_,
   {{0x20c28125,0x5fd1901e,0x3eaf81a8,0x224d8cdb}},	//   rðir_, _हरवल, ingt_, meek_,
   {{0x27388333,0x7afe0748,0x224d8102,0x20113275}},	//   bén_, _ptpt, leek_, _nezi_,
   {{0x2738957a,0xcb672762,0x7d028f28,0x21391a89}},	//   cén_, наре_, zpos, _aqsh_,
   {{0x7d029c59,0x9f5e84e8,0x44f4697b,0xa3d786a7}},	//   ypos, natý_, _tä_, _सरन_,
   {{0x95560013,0x7d0d0355,0x26c20c03,0x764400b4}},	// [6ea0] _أخبا, _gwas, moko_, _ibiy,
   {{0x1fb659a2,0x6d5641ac,0x26c25854,0x628f0661}},	//   нсер, _isya, loko_, _elco,
   {{0x4444146a,0x03a60729,0x7d1be97c,0xbcfb0036}},	//   _ib_, _чино, _avus, rvée,
   {{0x44441cbc,0x7d02803a,0x60c18502,0x81e200c8}},	//   _hb_, tpos, holm, নুষ_,
   {{0x64a6a549,0xe89b0059,0x27388c83,0xdca68294}},	//   нада, _çağı, zén_, нади,
   {{0x67230025,0xa8028201,0x98a48029,0x26c2697d}},	//   šnja, _çıxa, kumā_, hoko_,
   {{0x26c2697e,0x98a48029,0x7d02a91e,0x44440c6b}},	//   koko_, jumā_, spos, _mb_,
   {{0x644e697f,0x65640cf4,0x66e38a2e,0x26c26980}},	//   hebi, _orih, _боса, joko_,
   {{0x44446981,0x26c24901,0x644e6982,0xc05ab73a}},	//   _ob_, doko_, kebi, пін_,
   {{0x273893af,0x644e0c70,0x7644313c,0x8b96917e}},	//   tén_, jebi, _abiy, _преч,
   {{0x6d563c8e,0x56956983,0xd7f88087,0x9c7c8669}},	//   _asya, вант, rcă_, _ličk,
   {{0x44446984,0x273882b7,0x645ae985,0xd7f8802e}},	//   _ab_, rén_, _hati, scă_,
   {{0x645aa0d4,0x83fc8267,0x225181d0,0x22593ca7}},	//   _kati, _anđi, ánků_, _rask_,
   {{0x60c1a34a,0x9f58e986,0x645ad4d2,0x63538201}},	//   colm, úró_, _jati, _sənə,
   {{0xaa671908,0x645a9b7b,0x5b241663,0xb86589a7}},	//   нтак, _mati, льта, _جانو,
   {{0x645ab3ce,0x65640f06,0xd2582902,0x7d0d66db}},	//   _lati, _frih, нцу_, _twas,
   {{0x7e6d6987,0xdc3c826c,0x2b52809a,0x7ebd0061}},	// [6eb0] _inap, _ašči, łych_, képz,
   {{0x645ae988,0xd91b810f,0x644e6989,0x655601c6}},	//   _nati, פובל, cebi, _סבתא_,
   {{0x2011698a,0x7e6d03a6,0x4ab28076,0xceeb026a}},	//   _vezi_, _knap, ुकाव, سران_,
   {{0x9f583d45,0x765d006a,0x531a00be,0x9f5ebb7a}},	//   _però_, ndsy, _קורצ, lató_,
   {{0x3209535b,0xddc40087,0xdfc688f9,0x760c00be}},	//   mbay_, _iniţ, _چي_, פּאַ,
   {{0x645ae98b,0x7d1c8029,0x224d9ad7,0x2129698c}},	//   _cati, _ārst, week_, mrah_,
   {{0x26c22221,0x60c19fe4,0x224de98d,0xdfd401e5}},	//   yoko_, volm, teek_, _боры,
   {{0x9f5e8019,0x7d1b826c,0x752480ce,0x644e698e}},	//   ható_, _tvus, šiza, zebi,
   {{0x6e94bd65,0xb3eb8f24,0x224d874c,0x644e0214}},	//   _ситу, _فعال_, reek_, yebi,
   {{0x7e6d698f,0x224d82d6,0x212909ca,0x4421012b}},	//   _anap, seek_, irah_, _ndh_,
   {{0x60c1be5a,0x644e04e6,0x3209009c,0xb4cd904f}},	//   rolm, vebi, kbay_, रती_,
   {{0x65646990,0x645ae991,0x644552b2,0x2129288e}},	//   _prih, _zati, _abhi, krah_,
   {{0x50b5932a,0xe1f08829,0x26c216d8,0x21290455}},	//   _иску, _اسم_, roko_, jrah_,
   {{0x61fd6992,0x44443c32,0x64948782,0x9c7c826c}},	//   _afsl, _qb_, _gàid, _ričk,
   {{0xaac61b9a,0x645c22ba,0x26c2013e,0x7aeb8122}},	//   نترن, rdri, poko_, _kigt,
   {{0x444401c5,0x7afc8065,0x2ca7b278,0x644e6993}},	//   _wb_, _érte, hind_, sebi,
   {{0x61fb8272,0x2ca7949d,0x212909e1,0xc5f400fc}},	// [6ec0] icul, kind_, grah_, _gaɓa_,
   {{0x44446994,0xe9d70c0e,0x395201b0,0x7aebe995}},	//   _ub_, тку_, rwys_, _ligt,
   {{0xe29a268a,0x645aa840,0xee3ac249,0x6d498118}},	//   _жан_, _rati, дне_, _apea,
   {{0x26c3003a,0x9bb70039,0x68ed0110,0x787e801b}},	//   čkog_, _יהיה_, _žodž, _závě,
   {{0x645aa612,0x3ea6e996,0xa2bf1a46,0x2ba7a5e8}},	//   _pati, riot_, वकर्, _केबा,
   {{0x9f58008b,0x031606a7,0x9c7c81a1,0x53d601a2}},	//   _ferð_, _तबाह_, _kiči, _धराश,
   {{0x645ae997,0x18a301e5,0x07a62098,0x7aebbbb0}},	//   _vati, _тарм, _равн, _bigt,
   {{0x69cb81b0,0x6728876c,0xcb130039,0x645ae3ea}},	//   _byge, vrdj, בלה_, _wati,
   {{0x645ac18b,0x273c1867,0x7aebe998,0x2ca79407}},	//   _tati, lín_, _digt, bind_,
   {{0x2bbb8105,0x2ca7db3d,0xc5f40326,0xdb1e062c}},	//   _ऊँचा, cind_, _raɓa_, _kypä,
   {{0x273c03b3,0x320917ea,0x212900b9,0x9c7ca8fc}},	//   nín_, ybay_, zrah_, _niči,
   {{0x44216999,0xb283bd73,0x290201a1,0x6f1ac432}},	//   _sdh_, _вышк, _otka_, rstc,
   {{0xa2d30074,0x3857826a,0x9f5e8019,0x7e6d02d4}},	//   _भीष्, رشید_, tató_, _vnap,
   {{0x3af8e99a,0x273c0333,0x9c7c8084,0x98a383a7}},	//   _kép_, kín_, _biči, _киче,
   {{0xa3dd0321,0x9f5e8722,0x273c00e1,0x64450144}},	//   तें_, rató_, jín_, _vbhi,
   {{0x31668025,0x21291999,0x273c01ac,0x9c7c817f}},	//   _kroz_, trah_, dín_, _diči,
   {{0x2246803d,0x2ab701b9,0xb5fb0118,0x9f5e8216}},	// [6ed0] _mbok_, għba_, rdád, pató_,
   {{0x66df1482,0x44210072,0x7d1b1f90,0x765b84b9}},	//   _tūks, _udh_, áusu, _sauy,
   {{0x2ca7e99b,0xb8fa2303,0x2129059e,0xdb1e80e7}},	//   vind_, _डी_, srah_, _évèn,
   {{0x6723003a,0x2ca78a15,0x212901bf,0x9f58007b}},	//   šnjo, wind_, prah_, _verð_,
   {{0x7aebe99c,0x454580f7,0x2ca7b760,0x961d81a9}},	//   _rigt, انتق, tind_, _noņe,
   {{0xb4cd89a3,0x6acb8f97,0x273c4bbe,0x7aeb868b}},	//   रते_, ात्र, bín_, _sigt,
   {{0x44299014,0x2ca7801f,0x447c0158,0x69cb806a}},	//   ğa_, rind_, ונגע, _syge,
   {{0x4429880a,0x3166812b,0x2ca7e99d,0x649007b8}},	//   şa_, _broz_, sind_, _näin,
   {{0x7aeb8022,0x83fc8088,0x101584cf,0x2d99804a}},	//   _vigt, _anđu, льня, _åse_,
   {{0xd7098009,0x69cb84e8,0x20558185,0x44f9810c}},	//   нное_, _vyge, утир, _iè_,
   {{0x7c3800f2,0x44f9801c,0x9eaa15fe,0x16aa09a0}},	//   _övri, _hè_, евна_, евни_,
   {{0x44f9bdb1,0xb8038ebf,0x69cbac15,0x00000000}},	//   _kè_, _श्रम_, _tyge, --,
   {{0x273c03b0,0x25e68035,0xa3e6064a,0x5e5683de}},	//   zín_, जेपी_, बेन_, נישע_,
   {{0x6aa994f9,0x44f9c048,0x2eed8e61,0x6cd600f7}},	//   lief, _mè_, _lief_, اقسا,
   {{0x44f986fe,0xeb9a1194,0x60c5008e,0x273c235e}},	//   _lè_, хив_, dohm, xín_,
   {{0x225f859c,0x273c00e1,0x628d04a7,0xfaa3259a}},	//   nduk_, vín_, gkao, басо,
   {{0x41271adf,0xe0da2300,0x7989822e,0x213f8057}},	// [6ee0] лото_, ева_, nyew, ntuh_,
   {{0x273c08a9,0x459b02f6,0x7d04018e,0x6aa9d2b2}},	//   tín_, _נסיע, _itis, hief,
   {{0xe4570158,0x645e0420,0x3dcd8326,0xfaa60dfd}},	//   _גייט_, _iapi, _ayew_, _бано,
   {{0x44f9c46f,0x273c64db,0x645e509c,0x225fe99e}},	//   _bè_, rín_, _hapi, jduk_,
   {{0x63b60029,0x76428239,0x225f80b9,0xd838816b}},	//   šanā, rfoy, dduk_, siči_,
   {{0x6adcdd8d,0x44f9bdc2,0x10a60652,0x645e00f1}},	//   मग्र, _dè_, _сигн, _japi,
   {{0x645e699f,0x394069a0,0x201a02c4,0x439481e2}},	//   _mapi, ltis_, mapi_, райс,
   {{0x44f98f23,0x7d0400d2,0x201a1066,0x6e2436ed}},	//   _fè_, _otis, lapi_, _ndib,
   {{0x394069a1,0xc61086b7,0x225d84b7,0xcc368591}},	//   ntis_, ारीय_, _dawk_, _مراع,
   {{0x645e5fba,0x31570051,0x6e240102,0x39570039}},	//   _napi, ניין_, _adib, נשים_,
   {{0x7d045fcc,0xb866803d,0x394002f1,0xc6000264}},	//   _atis, ناگو, htis_, ্ণনা_,
   {{0x394029fb,0x41b40072,0x645e3735,0x68ee10ba}},	//   ktis_, ंपास, _aapi, _libd,
   {{0x201a0500,0xb5fd886f,0xeda700ca,0x443a0036}},	//   kapi_, _inšt, ушно, _bcp_,
   {{0x645e3206,0x6e240085,0x313784de,0x66d61de9}},	//   _capi, _edib, _ערוך_, ráka,
   {{0x201a0867,0x645e033e,0x7d04006f,0xf53f01a3}},	//   dapi_, _dapi, _etis, stå_,
   {{0x68ed80f7,0x9258181f,0x67008135,0x443a07b6}},	//   _éadr, ласт_, _ịkwa, _ecp_,
   {{0xf8070e49,0x6448816b,0x39400084,0x497502cb}},	// [6ef0] гчен, _obdi, gtis_, шлас,
   {{0xddc40025,0x44f98324,0x201a1dde,0x645e584a}},	//   _uniš, _rè_, gapi_, _gapi,
   {{0x44f9c051,0x501b8039,0x23fa0039,0x68ee020d}},	//   _sè_, גובו, _בהתא, _dibd,
   {{0x645e68c1,0x44f9c051,0x6448b08a,0xd838b5ca}},	//   _zapi, _pè_, _abdi, miču_,
   {{0xa3a915a7,0xbcfb0019,0xfd1f3d36,0xed599bdc}},	//   _खेत_, zvén, nsì_, тол_,
   {{0x29090009,0x201a1eb1,0x63858198,0x1abd00ab}},	//   mpaa_, capi_, игла, _আওয়া,
   {{0x44f986fe,0x6aa98e19,0x3f870074,0xe8d60039}},	//   _wè_, tief, änud_, _כושר_,
   {{0x44f9c051,0xca8580e5,0xa92594b7,0x31258037}},	//   _tè_, ргий, адил, адиг,
   {{0x81a880c8,0x66160125,0x6aa9aa33,0x2b4c80ee}},	//   _খুব_, _reyk, rief, _epdc_,
   {{0xe8e00028,0xa3b569a2,0x69cf2817,0x656982c4}},	//   _địa_, जपा_, _myce, _ireh,
   {{0x7d045717,0x6d4d69a3,0x32559cf8,0xe73984ae}},	//   _stis, _apaa, _ввер, њем_,
   {{0x645e3f06,0x6b7a8158,0xbcfb0019,0xd5e60294}},	//   _sapi, _ברענ, rvén, ижни,
   {{0x2d9d8578,0x15ba01e5,0x7649804f,0xc8b48fd3}},	//   nzwe_, тыны_, _mbey, _گلوک,
   {{0xafe58009,0xab2a47d1,0x2aba81a9,0xc5f400fc}},	//   _колл, кога_, mība_, _taɓo_,
   {{0x63831541,0xc7a2a28e,0x7649e9a4,0x201a05f3}},	//   огра, _мишк, _obey, vapi_,
   {{0x394069a5,0x4425b0b2,0x645e0010,0x602800eb}},	//   ttis_, _ldl_, _wapi, zīmē,
   {{0x201a14ff,0x7d04025b,0x2aba80eb,0x7aef10b6}},	// [6f00] tapi_, _utis, nība_, _dict,
   {{0x394069a6,0x6e3b802a,0x60260ba7,0xed4f003d}},	//   rtis_, _acub, рджа, _کپی_,
   {{0x394069a7,0x547b0039,0x324617c8,0x41d50816}},	//   stis_, _סטטו, _кенг, _दरअस,
   {{0x201a17a0,0xdfcf00f7,0x39400662,0x0566a05f}},	//   sapi_, ذين_, ptis_, ивен,
   {{0x68ee04b7,0x83fc81a1,0x7ae42776,0x09e40264}},	//   _tibd, _lađe, mmit, _ফ্রা,
   {{0x656981ec,0x7ae412a5,0xc7b8812b,0x2aba81a9}},	//   _dreh, lmit, lađe_, dība_,
   {{0x83fc8067,0x2018287d,0x2348826a,0x66dd0019}},	//   _nađe, _ieri_, استی_, léke,
   {{0xe8df8104,0x7ae469a8,0x6490037b,0xc7b88289}},	//   ước_, nmit, _säil, nađe_,
   {{0x65698836,0x7ae46004,0x5ecc8264,0x3afc0a05}},	//   _greh, imit, িষদে, _líp_,
   {{0x2018130c,0x2ba785fc,0x7ae469a9,0x7e6099ad}},	//   _jeri_, _केवा, hmit, _hamp,
   {{0xb8fd8d38,0x501b0051,0x20185715,0x6d4d03b2}},	//   _थी_, כויו, _meri_, _spaa,
   {{0x2d8b009a,0x212003f8,0x44380114,0x614681e2}},	//   tyce_, ksih_, egr_, _веда,
   {{0x7e608812,0x2aba80eb,0xa3e2a23a,0x3a2680b9}},	//   _mamp, cība_, नेर_, _idop_,
   {{0x442d02af,0xd8388024,0x634a8201,0x2018499f}},	//   ße_, tiču_, _gənc, _neri_,
   {{0x0b882344,0x938815d2,0x7aef494b,0x83fc8699}},	//   асти_, аста_, _pict, _gađe,
   {{0x7e60e9aa,0x7ae40bb1,0xbea40992,0xd838817f}},	//   _namp, gmit, _мајк, riču_,
   {{0x661d69ab,0x20185996,0x51f801bb,0x3ea9120e}},	// [6f10] mask, _beri_, рную_, _imat_,
   {{0xdb1a80e7,0x6d4286a9,0x7af70216,0x7e6082d5}},	//   _exté, dtoa, _tuxt, _aamp,
   {{0x20182b42,0xd7f801a1,0x7ce0016d,0x6d5b80dd}},	//   _deri_, руу_, förf, _ssua,
   {{0xd2469301,0x44fd446f,0x65698ed6,0x64556376}},	//   _عن_, _kì_, _preh, lezi,
   {{0x7e60e9ac,0x442594ed,0x20183550,0x44fd6184}},	//   _damp, _pdl_, _feri_, _jì_,
   {{0x44fd1b4c,0x64555380,0x2018571a,0x661d4495}},	//   _mì_, nezi, _geri_, hask,
   {{0x44fd69ad,0xd7950013,0x1fe500c8,0x7e609670}},	//   _lì_, _الأخ, _প্রস, _famp,
   {{0x163493cd,0x6d5b81e9,0x7e6088b3,0x83fc81dd}},	//   _меся, _tsua, _gamp, _rađe,
   {{0x83fc80fe,0x44fd10ab,0x1c0b8770,0x20180059}},	//   _sađe, _nì_, _स्थल_, _yeri_,
   {{0x2001379b,0xdce40b5d,0x3ea9372d,0xf1b982a5}},	//   nchi_, _prič, _amat_, jaše_,
   {{0xb4e392c7,0xd3a79ebd,0xaec61ebd,0xf1b9817f}},	//   नगी_, _трап, йбол, daše_,
   {{0x1d0a2aee,0x661d1ce5,0x7e60e648,0x83fc812b}},	//   леми_, gask, _xamp, _vađe,
   {{0x24858074,0x645569ae,0x41299810,0xddcb8035}},	//   _kolm_, fezi, _соло_, legł,
   {{0x44fd69af,0xdce4026f,0x645569b0,0xfc0314c4}},	//   _dì_, _trič, gezi, зпро,
   {{0x66e64a38,0x634a8085,0xeb970568,0x7ae469b1}},	//   _лока, _kəna, бир_, tmit,
   {{0x66dd0065,0x20184022,0x2723817b,0xed5a02dc}},	//   téke, _seri_, mın_, _бои_,
   {{0x7e60c214,0x44fd0104,0xe9da05c2,0x27238182}},	// [6f20] _ramp, _gì_, ука_, lın_,
   {{0x21200867,0xc6108ebf,0x81bc00c8,0x7e60b3e1}},	//   rsih_, ार्य_, েইল_, _samp,
   {{0x27238a0b,0x20186662,0x2a7f89ca,0x98a00267}},	//   nın_, _veri_, kjub_, hrić_,
   {{0xc3330051,0x98a002ee,0xb87b01df,0x26df8010}},	//   _צור_, krić_, _xuíz, _chuo_,
   {{0xf767850c,0x7bda8063,0x2018450b,0x9878b4d5}},	//   _کا_, _sztu, _teri_, _ušću_,
   {{0xb8960013,0x40960013,0x20010098,0x272393da}},	//   _السع, _السر, cchi_, kın_,
   {{0x62863126,0xa3e0023c,0xa3e29370,0x6d42c893}},	//   _koko, _तरफ_, नें_, stoa,
   {{0x2723884a,0x645569b2,0x628669b3,0xe643a09a}},	//   dın_, zezi, _joko, _несп,
   {{0xd01080f7,0x661d2d03,0x62860048,0x6455314f}},	//   ولة_, vask, _moko, yezi,
   {{0x62863c6d,0x660454f7,0x44fd04be,0xb87b01df}},	//   _loko, _afik, _rì_, _suíz,
   {{0x44fd077f,0x661d69b4,0x66d8826f,0x443eb0b2}},	//   _sì_, task, níko, _ict_,
   {{0x64551b66,0x6602b62e,0x7d160114,0x7ce01b48}},	//   wezi, ncok, _bwys, hörd,
   {{0x645534d7,0xf1b9812b,0xf1bf2fb5,0x60c8ac90}},	//   tezi, taše_, _adán_, podm,
   {{0x6723003b,0x44fd0104,0x66040b67,0xc0aa819f}},	//   šnji, _vì_, _efik, _حاصل_,
   {{0x201ee9b5,0x645524fc,0x628669b6,0x7afa90a6}},	//   mati_, rezi, _boko, _jutt,
   {{0x201e97f7,0x3ea914ec,0x44fd04be,0x7afaa776}},	//   lati_, _umat_, _tì_, _mutt,
   {{0x645509e8,0x7afae9b7,0x443ee9b8,0x7ce03a53}},	// [6f30] pezi, _lutt, _oct_, förd,
   {{0x798d2fc5,0x26cb69b9,0x656d5d52,0x81e580ab}},	//   ryaw, loco_, _irah, বুক_,
   {{0x23a79094,0x20010098,0x7afa9333,0x798d07cf}},	//   _केंद, rchi_, _nutt, syaw,
   {{0x3eb94751,0x200169ba,0x656d00f1,0xf770003f}},	//   nnst_, schi_, _krah, عال_,
   {{0x201e874b,0x272382bb,0x2a3a0158,0x823a0158}},	//   kati_, zın_, _דערמ, _דערצ,
   {{0x272382bb,0xa3bd035a,0x98a00289,0x7afaa4cf}},	//   yın_, _अशा_, vrić_, _butt,
   {{0xeb999cd3,0xddc9826f,0x27238085,0x62863392}},	//   рий_, _dneš, xın_, _yoko,
   {{0xcfce80c8,0x7afae9bb,0x656d0668,0x386369bc}},	//   রধান, _dutt, _orah, _hajr_,
   {{0x443e8118,0xaca3019d,0xe8f6a1f6,0x6e298133}},	//   _fct_, _alọg, олы_, _ideb,
   {{0x201ee9bd,0x3eafa50b,0x7d048029,0x272382bb}},	//   gati_, ligt_, ģist, tın_,
   {{0xa3a90d38,0x656d69be,0x661b8a0f,0x7524452c}},	//   _खेल_, _arah, _keuk, _sviz,
   {{0x27238a0b,0x656d4f15,0x7d16031d,0x25f08d86}},	//   rın_, _brah, _pwys, ुँची_,
   {{0x62860038,0xdce0802e,0x2723817b,0x7ce001ec}},	//   _roko, _urmă, sın_, höre,
   {{0x201eb2a3,0x628605a3,0x656d1ab8,0x272383bf}},	//   cati_, _soko, _drah, pın_,
   {{0x6286085d,0xe51985e8,0x6e298cf0,0xaca380ff}},	//   _poko, नीति_, _odeb, _huỳn,
   {{0x83fc803b,0xb5fb69bf,0x6e29d840,0x661ba8c8}},	//   _mađa, ndál, _ndeb, _neuk,
   {{0x3eaf9b4a,0xed5a133c,0x614312a0,0xd94312e1}},	// [6f40] digt_, _топ_, мета, мети,
   {{0x6e29930c,0x7ce0016d,0x7e6469c0,0xc7b8811f}},	//   _adeb, före, _haip, lađa_,
   {{0x628669c1,0x3169026c,0x7e640d55,0x661b9412}},	//   _toko, avaz_, _kaip, _beuk,
   {{0x823607d2,0x7afae9c2,0x7bde3102,0xddc981a1}},	//   _بردا, _rutt, _izpu, _sneš,
   {{0x7e64043b,0xa3e60f12,0x661be0a7,0x634a811c}},	//   _maip, बेर_, _deuk, _cənn,
   {{0x6e29e509,0x6d46036e,0x7e6469c3,0xc7b880d2}},	//   _edeb, itka, _laip, hađa_,
   {{0x7d09e726,0x46ca09c2,0x6d465033,0xddc99502}},	//   _etes, रवाह, htka, _vneš,
   {{0x09de1880,0x201eb55e,0x3a206532,0x7e643791}},	//   _मराठ, wati_, naip_, _naip,
   {{0x443e86e7,0x6d4401c0,0x26cb0037,0x6d462c2d}},	//   _tct_, _nqia, voco_, jtka,
   {{0x7afad1e4,0xb4c403bb,0xdb1e02be,0x7e7643cd}},	//   _tutt, एको_, _expé, _anyp,
   {{0xd7d0035a,0x83fc8289,0xdc3c8858,0x7afa8009}},	//   _तुमच, _gađa, _ašći, _uutt,
   {{0x656d09e6,0xc7b88a20,0xb5fd82a5,0x56941fb4}},	//   _prah, gađa_, _kaša, дают,
   {{0x201e8b50,0xb5fd82a5,0xfaf880eb,0x6fcae9c4}},	//   pati_, _jaša, _trīs_, _सुरू,
   {{0xcce70307,0x6458e9c5,0xb5fd8267,0x290002f7}},	//   تسجي, nevi, _maša, dqia_,
   {{0x6d460867,0xf1b98699,0xc7b88042,0x7ae281bf}},	//   atka, maša_, bađa_, _khot,
   {{0x656d38b9,0x201c8b80,0x764d69c6,0x3eaf8338}},	//   _trah, _hevi_, _ubay, xigt_,
   {{0xb5fd8067,0x7ae28c41,0x64588a41,0x656d1ae4}},	// [6f50] _naša, _mhot, kevi, _urah,
   {{0x6458a771,0x7ce00884,0xf1b98796,0x80782218}},	//   jevi, töre, naša_, обус_,
   {{0x7d09e9c7,0x3eafba53,0x65608362,0x2bd20072}},	//   _stes, tigt_, _asmh, _दुपा,
   {{0x6e3d4255,0x201c9a4d,0x83fc812b,0xb5fd8bcf}},	//   ngsb, _levi_, _rađa, _baša,
   {{0x3eafb64c,0x260a800f,0x41e721d2,0x3d0f016f}},	//   rigt_, ाड़ी_, _фіна, तीचे_,
   {{0x64589699,0x3eaf94a2,0xf1b980ce,0x7ae2e9c8}},	//   gevi, sigt_, jaša_, _ahot,
   {{0x661b91ee,0x68fd0bbd,0xfd64882e,0x7ae28219}},	//   _teuk, _husd, _karị, _bhot,
   {{0x7ae28219,0x201c8267,0x3bbc0039,0x644a80e5}},	//   _chot, _aevi_, ימוד, affi,
   {{0xdb0a003e,0x7d098186,0x6458a7d1,0xf2d400be}},	//   čnéh, _utes, bevi, ועק_,
   {{0xd24e80d5,0x48798009,0x6458d257,0xf1b98390}},	//   پنی_, ссия_, cevi, gaša_,
   {{0x201ca367,0x7e6469c9,0x4abd1130,0x7ae2e9ca}},	//   _devi_, _paip, ्काव, _fhot,
   {{0x7ae2b861,0x98ad8353,0x2bc49344,0xed5a2c38}},	//   _ghot, mreč_, _लुटा, бом_,
   {{0xdd920154,0xf1b9817f,0x239081a9,0x6d465454}},	//   روس_, baša_, _vējš_, utka,
   {{0x8fa58c0e,0x3ebf812b,0x66dd003d,0x7ae2816b}},	//   _нале, _ljut_, réka, _zhot,
   {{0x68fd02af,0x67029993,0x3a200110,0x7e6469cb}},	//   _ausd, _रूपक_, taip_, _taip,
   {{0xe61f00e1,0x68f500eb,0x80d40035,0x7afebb40}},	//   skôr_, _aizd, _बीजे, ípti,
   {{0x68f5080a,0x64588201,0xdeb70039,0x66160267}},	// [6f60] _bizd, yevi, _מפקח_, čakč,
   {{0xd12f05ff,0x3eade9cc,0x3ebfdb92,0x7ae9cc5f}},	//   امل_, _amet_, _ajut_, hmet,
   {{0x68f50508,0x7ae9d896,0xd4c504a3,0xabfb025f}},	//   _dizd, kmet, _تغيي, _להיר,
   {{0xde03a657,0xb5fd8df1,0x7ae9e9cd,0xdfcf15a9}},	//   епци, _paša, jmet, ديم_,
   {{0x7ae9c088,0x68fd02f7,0x244f8214,0x20079a5a}},	//   dmet, _gusd, kımı_, _ofni_,
   {{0x64a3a84d,0x7afe020f,0xb4d68576,0xb5fd876c}},	//   нача, _kupt, सते_, _vaša,
   {{0x7ae2cf8e,0x289b010f,0x2f018ff4,0x201c8242}},	//   _phot, _פילא, _nóg_, _revi_,
   {{0x6458e9ce,0x201ce9cf,0x2007808e,0x7ae9e9d0}},	//   sevi, _sevi_, _afni_, gmet,
   {{0x81ce00c8,0x7afe002e,0x3ea7874c,0x224200b9}},	//   ষের_, _lupt, ënte_, _mckk_,
   {{0x26c3003a,0x2bd204e5,0x67220029,0x2db780be}},	//   čkom_, _दुभा, ņoju, _זלמן_,
   {{0x7ae2820f,0x7afe214a,0x442ccb19,0x16350cb1}},	//   _thot, _nupt, _idd_, меня,
   {{0x20078125,0x7ae985b0,0x3f82811f,0x78ba8267}},	//   _efni_, cmet, ćku_, sntv,
   {{0x201cdebf,0x3ea40168,0x6d5d01ed,0x442c8144}},	//   _tevi_, ëjta_, uwsa, _kdd_,
   {{0xe7be2207,0x26d202ec,0x3ae180e1,0x68fd69d1}},	//   ्थाप, _ekyo_, rópe_, _rusd,
   {{0x67d39ae5,0x442c84b9,0x7afe0087,0x66d8807b}},	//   _пошу, _mdd_, _cupt, ríkj,
   {{0x628687b8,0x68f5061c,0xd7bb81c6,0x62840168}},	//   ökoh, _sizd, _לצור, gjio,
   {{0xdce98353,0x51871f84,0x83fc80d2,0x68f55d99}},	// [6f70] _sreč, чува, _nađo, _pizd,
   {{0xdce98709,0x7d0d5b2e,0x3eadd0a3,0xb4d68072}},	//   _preč, _itas, _smet_, सतो_,
   {{0x6490025d,0x44231a8b,0x59f90364,0xf0938158}},	//   _päiv, maj_, _меня_, ענע_,
   {{0x442c8051,0x940c8201,0xe7300250,0xdce9807a}},	//   _add_, _ildə_, اصل_, _vreč,
   {{0x394681c0,0x290b0019,0xb5fd8115,0x629d00e5}},	//   _nqos_, _utca_, _fašn, _ilso,
   {{0x44230cb2,0x2a690006,0xdce98110,0x394926ff}},	//   naj_, ldab_, _treč, mtas_,
   {{0x26c3003a,0x39490219,0x6e2d003a,0x644183ac}},	//   čkoj_, ltas_, _odab, _vcli,
   {{0x442310af,0x442c9503,0x2a690006,0x7d0d05ee}},	//   haj_, _edd_, ndab_, _otas,
   {{0x44232dc8,0x394969d2,0x7ae9ddf5,0x6abb82fe}},	//   kaj_, ntas_, rmet, rnuf,
   {{0x26cfe9d3,0x6e2d69d4,0x442306e4,0xe8d90a2c}},	//   logo_, _adab, jaj_, kwọ_,
   {{0xb9048403,0x229c0125,0xd25180f7,0x244f8457}},	//   _भी_, _líka_, _لنا_, rımı_,
   {{0x394926ff,0x7c23adaf,0xddcd012b,0x26cfded0}},	//   ktas_, lanr, _snaš, nogo_,
   {{0xa3e000cf,0x20bf0ebf,0x95830009,0x7afe012b}},	//   _तरह_, ्वाध, вляе, _supt,
   {{0x649001c2,0x442ce9d5,0x7ce0016d,0x629d00f3}},	//   _näit, _xdd_, föra, _also,
   {{0xcee911fb,0x38ad0086,0x316da336,0xb5fd8b48}},	//   ترین_, _görə_, lvez_, _našo,
   {{0x628bad90,0xa3e29199,0x7c238ad4,0x3a3f90dc}},	//   _jogo, नेट_, hanr, ngup_,
   {{0x628b8db7,0x26cf822e,0x39494fc6,0xb5fde9d6}},	// [6f80] _mogo, dogo_, gtas_, _pašn,
   {{0x44230025,0x6609c78b,0xddc41c18,0x65640234}},	//   caj_, _afek, _kniž, _isih,
   {{0x645c296d,0xfaa60084,0x39494bf9,0x26cfa41f}},	//   meri, _жано, atas_, fogo_,
   {{0x645c69d7,0x628bb8a3,0x26cf93a2,0xbc3a0061}},	//   leri, _nogo, gogo_, _اسکا_,
   {{0xfee98013,0x39492706,0x64a6a21f,0x6e228c41}},	//   أعلى_, ctas_, мада, raob,
   {{0x16bb02f1,0x7c2381e0,0x6e2281a1,0x628b83e4}},	//   _उद्ब, ganr, saob, _aogo,
   {{0x628be9d8,0x7529a499,0xbcfb0019,0x645c69d9}},	//   _bogo, _evez, lvét, ieri,
   {{0x4423024a,0x628b9727,0xa7fc83bf,0x63a30019}},	//   zaj_, _cogo, rdım, _ünne,
   {{0xa80287d9,0x041d80ab,0x7c23c462,0x442369da}},	//   _çıka, _নারী_, banr, yaj_,
   {{0x645c03c3,0x66dd0065,0x6e20e9db,0x7644593c}},	//   jeri, téko, _hemb, _aciy,
   {{0x7529de54,0x6e2094e5,0x442338e9,0x7d0d2b28}},	//   _zvez, _kemb, vaj_, _stas,
   {{0x44442065,0xe7e60063,0x628b811e,0x6e2088b3}},	//   _ac_, _करना_, _gogo, _jemb,
   {{0x6e20be91,0x44233e1d,0x41e283dd,0xf1e2847d}},	//   _memb, taj_, _परिस, _परिन,
   {{0x6e2089ca,0xa3e58697,0xdb1e0118,0x3a249e7a}},	//   _lemb, _नरम_, _expí, lamp_,
   {{0x4423036f,0x4444555a,0xdfd080f7,0xb5fd826c}},	//   raj_, _dc_, _حيث_, _bašl,
   {{0x59e284e5,0x44443a65,0x628bca25,0x39491cab}},	//   _परार, _ec_, _xogo, ttas_,
   {{0x44230db7,0xdced003e,0x7c23e9dc,0xddc4024a}},	// [6f90] paj_, _hrač, yanr, _zniž,
   {{0x645c69dd,0x7bc510af,0xfe70803d,0x7bc022f8}},	//   ceri, _txhu, یدن_, ğmur,
   {{0x64450caa,0xe7ea0076,0x3a24a171,0x9f041368}},	//   _ichi, झेला_, kamp_, نولو,
   {{0x6e2090e1,0xdced0668,0x39493689,0xb5fd87aa}},	//   _cemb, _mrač, ptas_, _vašo,
   {{0x7c238648,0x64900074,0x442141a8,0x6e20e9de}},	//   tanr, _täit, _keh_, _demb,
   {{0xf41d00ab,0x4421423b,0x649008e5,0xd91a0039}},	//   _তাঁর_, _jeh_, _häir, _מושל,
   {{0x628b836f,0x442169df,0x765d69e0,0x7ce01e2b}},	//   _pogo, _meh_, kesy, körn,
   {{0xc1e3146d,0x442102c1,0xc24595e0,0x6e20859c}},	//   _खराब_, _leh_, хник, _gemb,
   {{0x644510ec,0x316d82be,0x628b8858,0x7e7be9e1}},	//   _ochi, uvez_, _vogo, _inup,
   {{0x644500f6,0xdced0a20,0x44210573,0x645c69e2}},	//   _nchi, _brač, _neh_, xeri,
   {{0x7aed0590,0x765d53fb,0x645c0e79,0xc0a89368}},	//   kmat, fesy, veri, بايل_,
   {{0x64451154,0xeb96893f,0x645c69e3,0xa5bb65a3}},	//   _achi, _אדער_, weri, raón,
   {{0x753d0065,0x7aed69e4,0x44215862,0x4444037e}},	//   gusz, dmat, _beh_, _pc_,
   {{0x44441532,0xb4da0816,0x64450037,0x26101a46}},	//   _qc_, ़ते_, _cchi, _थ्री_,
   {{0x444400a9,0x4421016f,0xe815835a,0xfddc8540}},	//   _vc_, _deh_, _द्या_, _बर्फ,
   {{0x644510ec,0x442169e5,0x28ab81a2,0x444469e6}},	//   _echi, _eeh_, टोरि, _wc_,
   {{0x6e20daed,0xdced27b1,0x59d58006,0x6e265f4a}},	// [6fa0] _remb, _zrač, _डुमर, makb,
   {{0x6e20e9e7,0x6e264f71,0x7aed69e8,0x7e7b809c}},	//   _semb, lakb, amat, _anup,
   {{0x6e2094ec,0x7d00c225,0x6f0b8087,0xb5fd826c}},	//   _pemb, _sums, _încă, _tašl,
   {{0x64900074,0x212900b9,0x291d82c4,0xd7ef01a8}},	//   _täis, bsah_, _owwa_, حكم_,
   {{0x69d9d1b3,0x7c2182d6,0x6fd00ad5,0xbcfb69e9}},	//   _nywe, _belr, _तुरं, lvér,
   {{0xf366a4c8,0x765d009a,0x7e7b91d3,0x34ca86a7}},	//   етин, zesy, _enup, ाकेद,
   {{0x6e20e9ea,0x61e28065,0xbcfb01df,0x7e698118}},	//   _temb, _szol, nvér, _faep,
   {{0x290269eb,0x2d4984c3,0x7d00e9ec,0xb5fb07f0}},	//   _kuka_, búe_, _tums, ldáv,
   {{0x5bbd0107,0x634a8201,0x6e2609da,0x3a24aa33}},	//   _ईश्व, _məni, dakb, ramp_,
   {{0x290269ed,0x69d9831d,0x3ea0003d,0x3ae1af8a}},	//   _muka_, _dywe, _alit_, rópa_,
   {{0x59e28105,0x44212709,0x2129016b,0x93aa8290}},	//   _परवर, _reh_, zsah_, _عاطف_,
   {{0x644569ee,0x6f0307a3,0x44213d76,0xdced06c2}},	//   _schi, ínci, _seh_, _vrač,
   {{0x765d69ef,0x7aed61f6,0x656281ec,0xf8bf01d0}},	//   resy, vmat, nwoh, _svém_,
   {{0xe04a8077,0x753d009a,0xb4bd06ae,0x7aed242f}},	//   _رشته_, rusz, ेके_, wmat,
   {{0x765d0e87,0xdced0289,0x7aed18d6,0x75f68214}},	//   pesy, _urač, tmat, _yüzü,
   {{0x29020590,0x212900dd,0x753d29bd,0x55752481}},	//   _buka_, tsah_, pusz, _агит,
   {{0x7aed1140,0x442169f0,0x60f907ac,0x200b8063}},	// [6fb0] rmat, _teh_, дная_, ście_,
   {{0x29022db6,0x2ec982f1,0x26c48668,0x290f00eb}},	//   _duka_, िक्त, _ajmo_, īga_,
   {{0x3209008e,0x2aba81a9,0xdce40115,0x9c7c8176}},	//   pcay_, lību_, _srić, _chčm,
   {{0x2d4984c3,0x6aa469f1,0xd7c81c81,0x6d4bcf38}},	//   túe_, chif, رونه_, ttga,
   {{0x2aba80eb,0x8c458152,0x386a69f2,0x660d0372}},	//   nību_, веле, _fabr_, _mfak,
   {{0x01360039,0x2298807b,0x64cbd556,0x34cb801b}},	//   _ברשת_, _fékk_, िवेश, िवेद,
   {{0x7bda998a,0x2d4984c3,0xdca29242,0x64a28009}},	//   _cytu, súe_, ращи, раща,
   {{0xe7e628b3,0x6d4b9770,0xb5fdac90,0xb5fb0019}},	//   _करता_, ptga, _mašk, ldáu,
   {{0x7ce050de,0xfc33804e,0x44f5a2f0,0xb5fd82d4}},	//   förl, _محض_, _апас, _lašk,
   {{0x5ba78ab2,0xb4bd13d9,0xd3a7813a,0x660d69f3}},	//   _през, ेको_, _преп, _afak,
   {{0x752d1087,0xb5fd80d2,0x6e26020d,0x09de1299}},	//   _avaz, _našk, takb, _मर्य,
   {{0x98a9009a,0x395900b9,0x96962bf3,0x644388e0}},	//   brać_, _opss_, трош, lgni,
   {{0xd94581ae,0x05631570,0x61459860,0x39590bda}},	//   _рели, авян, _рела, _npss_,
   {{0x634a8085,0x2a6d8114,0x394de9f4,0x752d0115}},	//   _səni, ldeb_, mtes_, _dvaz,
   {{0x29022dc4,0x394da962,0x4427b4c6,0x6e260072}},	//   _suka_, ltes_, ian_, pakb,
   {{0x628f16e8,0xdd921e13,0x3ea0009c,0x394d81b3}},	//   _coco, _نوع_, _ulit_, otes_,
   {{0x4427859c,0x394d821e,0x412701f3,0x2aba8029}},	// [6fc0] kan_, ntes_, кото_, cību_,
   {{0x6f03885c,0x6aa469f5,0x38cb0fd3,0x6e240428}},	//   _kunc, shif, والی_, _heib,
   {{0x649b0f60,0x7d0405f8,0x394de9f6,0x6e24036e}},	//   _חסיד, _huis, htes_, _keib,
   {{0x6f03e9f7,0x7d040010,0x394d8412,0x2902203d}},	//   _munc, _kuis, ktes_, _tuka_,
   {{0x4427e9f8,0x7d040a0f,0x7bda809a,0x76428b0b}},	//   fan_, _juis, _sytu, rgoy,
   {{0x7d041e31,0x6e245bdf,0x4427c290,0x644380f2}},	//   _muis, _leib, gan_, ggni,
   {{0x2d808012,0x6f038510,0x7d040a52,0x61f78085}},	//   ţie_, _nunc, _luis, əblə,
   {{0x68fc0065,0x394ddbbc,0x4427e9f9,0xdee698c6}},	//   _hird, ftes_, aan_, _роби,
   {{0x442780ef,0x394db055,0x3940352d,0xd83a814c}},	//   ban_, gtes_, nuis_, мэн_,
   {{0x4427cc98,0x38a400f2,0x7bda809a,0xa786803d}},	//   can_, _före_, _tytu, نشجو,
   {{0x38a407d9,0x6f038509,0xc2469baa,0x2bd20b75}},	//   _göre_, _cunc, _анек, _दुला,
   {{0xc7b88b6d,0x6f03a756,0x52769e91,0x6e242509}},	//   nađi_, _dunc, _جائز, _ceib,
   {{0x394d87e2,0x98c69d2f,0x7d045d64,0x6f038580}},	//   ctes_, _искл, _cuis, _eunc,
   {{0x09e38a94,0x628f02a3,0x7d0416a1,0xb5fdc2f2}},	//   _точн, _soco, _duis, _pašk,
   {{0x628f69fa,0x7d0469fb,0x6f03e9fc,0x2aba80eb}},	//   _poco, _euis, _gunc, sību_,
   {{0x44278695,0x5a3419d9,0x7d041d7e,0x68fc0c5e}},	//   zan_, инст, _fuis, _aird,
   {{0x3eb90665,0x7d043b40,0x49750e11,0x394069fd}},	// [6fd0] mist_, _guis, ылас, guis_,
   {{0x3eb91c1d,0x4427e9fe,0xb5fdbbbe,0x26c3026f}},	//   list_, xan_, _tašk, čkou_,
   {{0x4427e68f,0x7e6d32bb,0x6aa2e9ff,0xb5fd8da8}},	//   van_, _kaap, _olof, _haši,
   {{0xb5fd825b,0xdbdc808b,0x7e6d2f89,0x394dbe80}},	//   _kaši, _ráði, _jaap, ytes_,
   {{0x4427ea00,0x7e6d1998,0x518422f6,0x6d4f01b3}},	//   tan_, _maap, _кура, ntca,
   {{0xb5fd9bf2,0xdfc68013,0x4427a5e0,0x6aa28609}},	//   _maši, _هي_, uan_, _alof,
   {{0x7c25461d,0x225f8b99,0x3eb96a01,0xddc2b7f6}},	//   _mehr, teuk_, kist_, rdoš,
   {{0x4427c231,0x394dea02,0x569481e2,0x36d59f5e}},	//   san_, ttes_, _каст, _собр,
   {{0x6f038289,0x6e949860,0x394dc105,0xb4db0722}},	//   _sunc, _титу, utes_, ntàs,
   {{0x6f03ea03,0xb5fdea04,0x4427d13d,0xf9920039}},	//   _punc, _naši, qan_, צרי_,
   {{0x394dea05,0x5b158e17,0x7ea62d11,0x69dd0370}},	//   stes_, _смет, _lópe, _lyse,
   {{0x3eb90b74,0x4425ac15,0x394dea06,0xbddb0722}},	//   gist_, _hel_, ptes_, rgèn,
   {{0x4425ea07,0x7d045e81,0xb5fd9351,0x69dd46f0}},	//   _kel_, _quis, _baši, _nyse,
   {{0x4425803a,0x7afd615e,0x3ebe0065,0xe8bf000c}},	//   _jel_, _aist, őtt_, ्वोच,
   {{0x42560139,0x7c2501b9,0xc0528039,0x61e60035}},	//   лтат, _dehr, _הזו_, _szkl,
   {{0x7d046a08,0xb3d210be,0x68fc6a09,0x4425ea0a}},	//   _tuis, _दुःख, _sird, _lel_,
   {{0x7afd30cc,0x6d4f0bfd,0x3edb00be,0x6d5b8069}},	// [6fe0] _dist, ctca, _אַזא, _npua,
   {{0x44258021,0xe9d76844,0x3b86148d,0x7afd031d}},	//   _nel_, уку_, _блог, _eist,
   {{0xb4c0053e,0xee3aea0b,0x7afd24be,0x6ac612dc}},	//   ंची_, ене_, _fist, _مقدم,
   {{0x394003d3,0x7afd6a0c,0x442a15e8,0x5f068b85}},	//   puis_, _gist, lab_, _संस्_,
   {{0xe7e60105,0x68fc00eb,0x39403b7c,0x69dd647e}},	//   _करवा_, _tird, quis_, _gyse,
   {{0x3ea6ea0d,0x4425ea0e,0x442a6a0f,0x7afd01ac}},	//   shot_, _cel_, nab_, _zist,
   {{0x4425d66d,0xb5fb6a10,0xc8db0039,0x8fa65c71}},	//   _del_, ndár, _נקלט, _саве,
   {{0x442a5abd,0xbea38e02,0xb4db0722,0xd91ab139}},	//   hab_, _ласк, ntàr, ньо_,
   {{0x4425d3b5,0x6e938064,0x442a6a11,0xe6938013}},	//   _fel_, _القا, kab_, _القد,
   {{0x2e240104,0x442a363c,0x7e6d156e,0x78748061}},	//   _đườn, jab_, _saap, küvő,
   {{0x324692dc,0xd7f781bb,0x442a6a12,0x7e6d10ab}},	//   _مناف, лую_, dab_, _paap,
   {{0x7c2ac6b8,0x59af8006,0x7e62ea13,0x80b68074}},	//   lafr, _जेकर, neop, _ऋगवे,
   {{0x7afd15a4,0x99bf00ab,0x212b80f7,0xb5fdac28}},	//   _rist, _আর্ক, ácht_, _paši,
   {{0x442a6a14,0x2d996a15,0x7c2aea16,0x673a82d4}},	//   gab_, ryse_, nafr, prtj,
   {{0x3eb96a17,0x447b80be,0x7e6d57d8,0x709b83de}},	//   pist_, ענלע, _taap, _אױגו,
   {{0xadf6800f,0x78ba8805,0x7afd00ee,0x386101ec}},	//   ेशान_, litv, _qist, wehr_,
   {{0x442a3091,0xf1b9c573,0xddc9904c,0x7afd291e}},	// [6ff0] bab_, taši_, _snež, _vist,
   {{0xdddb8a56,0x78ba807a,0x442a0be9,0x1ae1a43f}},	//   _použ, nitv, cab_, _पठ्ठ,
   {{0x7afd6a18,0x69dd1c59,0x3a2900e4,0xa9240084}},	//   _tist, _wyse, paap_, _įžei,
   {{0xdce9803b,0x7afd05f3,0xaa671289,0x9f4a0091}},	//   _kreć, _uist, _сток, _agbó_,
   {{0x80bf0a49,0x44258813,0xa2b3809a,0xb5fd990f}},	//   ্তব্, _pel_, इफस्, _lašv,
   {{0x64475fc2,0x78ba807a,0xa3bc052a,0xc7b881a1}},	//   ngji, jitv, _अधम_, lađu_,
   {{0x442580b2,0x78ba8353,0xd4980039,0x66dd3d9b}},	//   _vel_, ditv, רכות_, léku,
   {{0x4425a64f,0xd6c3819f,0xc7b88289,0xddc40110}},	//   _wel_, _امری, nađu_, _laiš,
   {{0x844792dc,0x38a4016d,0x442a1061,0x6d5b96fb}},	//   _مخال, _höra_, yab_, _upua,
   {{0x6e2b8091,0x38a400f2,0x4425ea19,0xc62500ab}},	//   lagb, _köra_, _uel_, _ভাষা_,
   {{0x442a0a1b,0xaec60198,0x2902808b,0x5fcf90f7}},	//   vab_, ибол, íkar_, _सुखल,
   {{0xfd4c8104,0x442a14ec,0x6e2b820d,0x64400110}},	//   _nhiề, wab_, nagb, ėmim,
   {{0x442a032a,0x2bdb000f,0x9fa2808b,0x78ba82d4}},	//   tab_, _मुबा, síða_, bitv,
   {{0xb4c0053e,0x49b8806b,0x61e68214,0x659a80be}},	//   ंचे_, _حامد_, ükle, דישק,
   {{0x8a0612b2,0x3a2680ee,0x6e2bea1a,0x661d1be9}},	//   изве, _yeop_, kagb, bbsk,
   {{0x442a6a1b,0xfd4c801c,0x7bde016b,0xfd630133}},	//   sab_, _chiề, _vypu, netị,

   {{0x442a0205,0x6e2bea1c,0x7ce03a53,0x799b911f}},	// [7000] pab_, dagb, höri, nyuw,
   {{0xdbdf008b,0x3ea48359,0xddc41d46,0x442a6a1d}},	//   _tíði, _slmt_, _gaiš, qab_,
   {{0x09e28aed,0xa7fc82bb,0x6e36001b,0x9f4a0091}},	//   _पर्य, ldır, _kdyb, _agbò_,
   {{0x98a01487,0x2eede9e6,0x752401d4,0xe7371508}},	//   ksić_, _chef_, _kwiz, рец_,
   {{0x25a09301,0xa7fc884a,0xa8060198,0x7c2a81fa}},	//   áil_, ndır, _взгл, tafr,
   {{0x7ce0456f,0x75242fc0,0x38a40106,0xe71a04a3}},	//   föri, _mwiz, _föra_, _ليست_,
   {{0xf767896c,0x38a404b8,0x78ba8db7,0x25a09807}},	//   _با_, _göra_, vitv, šil_,
   {{0xf1bf00f7,0x66040234,0xcb130039,0xb5fb0174}},	//   _meán_, _ngik, חלה_, deán,
   {{0x395201e2,0xe5a3835f,0x4c868171,0x78baea1e}},	//   ntys_, _дити, _клав, titv,
   {{0xb5fd8029,0x92c880ab,0xf1b98858,0xb4c010f7}},	//   _pašv, োগে_, jašu_, ंचो_,
   {{0xdce9803b,0x78ba8db7,0x6f00dd36,0x787900be}},	//   _sreć, ritv, _kimc, אָרו,
   {{0xdce982a5,0x7ceda49c,0x26c6ea1f,0x6f0081b4}},	//   _preć, túrg, nnoo_, _jimc,
   {{0x2a64807a,0x628281b4,0x78bac949,0x1cbb05de}},	//   memb_, _inoo, pitv, ناسب_,
   {{0x7c288988,0xdce9805c,0x66c80214,0x6282822c}},	//   _jedr, _vreć, lıkl, _hnoo,
   {{0x644708cf,0x7c28ea20,0xfd4c80ff,0x533412b2}},	//   rgji, _medr, _phiề, жест,
   {{0xdce9803a,0xb3458073,0xb5fd976d,0xf1bf2c6c}},	//   _treć, luçã, _kašt, _deán_,
   {{0xf8071bc1,0x645aea21,0xb5fd8fee,0x62828088}},	// [7010] ачен, _obti, _jašt, _mnoo,
   {{0x2bd209a3,0x26d939fe,0xb5fd805c,0x80d1016f}},	//   _दुका, loso_, _mašt, तकें,
   {{0x6e2bac22,0x62828365,0xb5fdb464,0xfd4c8129}},	//   tagb, _onoo, _lašt, _thiề,
   {{0x39448029,0x63ad00eb,0xf1d82076,0x645aea22}},	//   kums_, ģinā, _भुवन, _abti,
   {{0x7c289682,0x39448341,0x6c7800d5,0xb5fd85b7}},	//   _bedr, jums_, _صحیح_, _našt,
   {{0x6282c577,0x645a8216,0x38a40106,0x6f0702d4}},	//   _anoo, _cbti, _hörn_, _tujc,
   {{0xb34580a9,0x26d904be,0x1cb88875,0x6e2be6f9}},	//   duçã, koso_, جانب_, pagb,
   {{0xb5fdea23,0x224b82af,0x26d91520,0x6f00a36f}},	//   _bašt, ück_, joso_, _gimc,
   {{0x26d9282b,0x394480eb,0x7c2893b0,0x5fcf80d4}},	//   doso_, gums_, _fedr, _सुजल,
   {{0x7c28905d,0x10a5a804,0x6aa99267,0x6282ea24}},	//   _gedr, сион, shef, _enoo,
   {{0x6e298cd8,0x7d099e4f,0x656d0a63,0x26d901e8}},	//   _keeb, _hues, _asah, foso_,
   {{0x7d018aa2,0x7d09808e,0xba7480f7,0xa7fc8085}},	//   _hils, _kues, _وانت, tdır,
   {{0x2d9db623,0xf1b98904,0x765bea25,0xc10880ff}},	//   nywe_, tašu_, _mbuy, _hỗn_,
   {{0x7d0985b4,0x98a7000d,0xb34583a7,0xb5fb68e6}},	//   _mues, čně_, cuçã, rdáp,
   {{0xb5fd803a,0x38a4007b,0x26d96a26,0x7d01c3a4}},	//   _zašt, _börn_, boso_, _mils,
   {{0x22490072,0x7d0980e7,0xa20623cd,0x26d9462f}},	//   ggak_, _oues, спад, coso_,
   {{0x7d099220,0x644107a3,0x8c4607a1,0xb5fb01a8}},	// [7020] _nues, ólic, _лепе, neál,
   {{0x6d46127c,0x7d019be9,0x765b8478,0x39524cfa}},	//   muka, _nils, _abuy, rtys_,
   {{0x69cf2a70,0x6e29db89,0x6d4b016d,0x39520150}},	//   _exce, _beeb, _ägar, stys_,
   {{0x7c2e42ee,0xdfcf0624,0x528600f7,0x213fea27}},	//   labr, رين_, _الحك, kruh_,
   {{0x7d09840e,0x7d01a08e,0x6d466a28,0x7ae40197}},	//   _cues, _bils, nuka, mlit,
   {{0x657b8a56,0x7ae40fc0,0xb5fd8110,0x7c2e6a29}},	//   _druh, llit, _rašt, nabr,
   {{0x6d461600,0x26d902e7,0x6f0081e4,0x3e7f0198}},	//   huka, yoso_, _timc, _jätä_,
   {{0x6d460393,0xb5fd81e2,0x6b8302ba,0x3944ea2a}},	//   kuka, _pašt, _ánge, tums_,
   {{0x6d4634c3,0x7d01861b,0xddcd0b24,0x7ae4198d}},	//   juka, _fils, _snaž, ilit,
   {{0xdb038117,0x6d461922,0x7ae428c6,0x39400083}},	//   szná, duka, hlit, iris_,
   {{0xb4e480dc,0xdb1e0118,0x201e8110,0x7c2e0084}},	//   नती_, _expú, rbti_, dabr,
   {{0x442eea2b,0xdced005c,0x6d463174,0x6e29ea2c}},	//   laf_, _krać, fuka, _xeeb,
   {{0xf1948364,0xd012803d,0xe9ff80ff,0x6d466a2d}},	//   _филь, _فلش_, _trạm_, guka,
   {{0x442ed14b,0x39406a2e,0x7c2e01fa,0x7ae46a2f}},	//   naf_, dris_, gabr, elit,
   {{0x38710358,0x443f02bb,0x26d949d7,0x5695041c}},	//   _razr_, ğu_, poso_, _макт,
   {{0x6d466a30,0xe821058c,0x1dda0b04,0x442eab3d}},	//   buka, यर्थ_, _युवत, haf_,
   {{0x656d15bd,0x442e879f,0xa3df8768,0x6e29c86f}},	// [7030] _usah, kaf_, _धुन_, _reeb,
   {{0x51f817ae,0xf8070a14,0x442e80fc,0x7ae43c72}},	//   сную_, счан, jaf_, alit,
   {{0xf7098104,0x7ae46a31,0x7d09ea32,0x39406a33}},	//   _lần_, blit, _sues, aris_,
   {{0x7d0985b4,0x394003ab,0xdced003b,0x657b816b}},	//   _pues, bris_, _brać, _pruh,
   {{0x7d09cadc,0x7d018029,0x24f98a14,0x6e298006}},	//   _ques, _pils, анды_, _veeb,
   {{0x2ecf00c8,0xcc898077,0x6e29ce58,0x7d0985a4}},	//   রতিষ, شنبه_, _weeb, _vues,
   {{0x61e2ea34,0x6e298069,0x212689c4,0x3ea2008b}},	//   _ayol, _teeb, _awoh_, ykkt_,
   {{0x290301cd,0x290b09cf,0x6d4600a4,0x765ba9da}},	//   _hija_, _kuca_, yuka, _ubuy,
   {{0xf7098104,0x7d018e1c,0xa3e58a74,0x657b82a0}},	//   _cần_, _tils, _नरक_, _uruh,
   {{0x3ea9059c,0xb5fb338d,0xd90c803d,0xf709801c}},	//   _alat_, reál, دیو_, _dần_,
   {{0x29031abf,0x3ea949d8,0x290b47ff,0x3e8a1242}},	//   _mija_, _blat_, _luca_, айно_,
   {{0x764bb286,0x29031abf,0x271780ff,0x291902f1}},	//   nggy, _lija_, _lăng_, _otsa_,
   {{0xf7098028,0x77e60e5b,0x6aad1bb7,0x29190282}},	//   _gần_, _कर्क_, dhaf, _ntsa_,
   {{0x27178104,0x3f77802e,0x3f9e8690,0x8fa59e18}},	//   _năng_, _tău_, bytu_, _мале,
   {{0x6d461904,0x7ae46a35,0x20078176,0x6fd90035}},	//   suka, tlit, _igni_, _बुलं,
   {{0x39404d7b,0x7c2e2475,0x442edfe3,0x290b2741}},	//   tris_, sabr, zaf_, _buca_,
   {{0x29030341,0x7ae44b4f,0x442e831d,0x2717801c}},	// [7040] _bija_, rlit, yaf_, _băng_,
   {{0x3e7f0009,0x290300d2,0x7a3f077f,0x271780ff}},	//   _tätä_, _cija_, _pàtà, _căng_,
   {{0xb4d60bb8,0x7ae46a36,0x29030168,0xadc38032}},	//   िकी_, plit, _dija_, _ifẹn,
   {{0x6aad6a37,0x2f5a8158,0xdced005c,0x7ce48722}},	//   chaf, ידענ, _prać, mòri,
   {{0x628637b3,0x20078698,0x29036a38,0x200382d4}},	//   _inko, _ogni_, _fija_, žjih_,
   {{0xdced003a,0x54b78d13,0xb4e48740,0x6aa40d1b}},	//   _vrać, огія_, नते_, lkif,
   {{0x443a6a39,0xbea68162,0xb649026b,0x644a8123}},	//   _mdp_, _давк, _emẹ̀, rgfi,
   {{0x5a3487eb,0x443a6a3a,0x442e831d,0x2007a168}},	//   чнит, _ldp_, saf_, _agni_,
   {{0x2104901b,0x80bf00c8,0x6e2284b9,0x50669287}},	//   रदेश_, ্তর্, mbob, отна,
   {{0xa3bb0006,0x61e286c0,0x3ea91581,0x271780ff}},	//   _आइल_, _vyol, _slat_, _xăng_,
   {{0x4ada016f,0xa2e695b9,0x73368019,0x987b0538}},	//   ढवाव, _дожд, _ذرائ, בריק,
   {{0x6d4297fe,0x443a20ae,0xadc38032,0xf70980ff}},	//   oroa, _adp_, _afẹn, _tần_,
   {{0x442c8038,0x443a6a3b,0xf99f09c4,0x6f040162}},	//   _ked_, _bdp_, _agèn_, _diic,
   {{0x62866a3c,0xdc0880eb,0x442c941f,0xa0679ef8}},	//   _anko, rēķi, _jed_, _мача_,
   {{0x442c8f06,0x6f0410da,0x6d42b88d,0x2717801c}},	//   _med_, _fiic, hroa, _răng_,
   {{0x290b02a5,0x7ce01f0f,0x3ea902e8,0x6d42ea3d}},	//   _puca_, förs, _ulat_, kroa,
   {{0xb80e858c,0x2007011f,0x81dc80ab,0x442c831d}},	// [7050] _सलाम_, žnim_, ণের_, _oed_,
   {{0x6d4292f5,0x8fe733e4,0x628614ee,0x6aad6a3e}},	//   droa, оцед, _enko, shaf,
   {{0x443125d8,0xdce29487,0x6e2d178f,0x6aad007b}},	//   maz_, jvođ, _keab, phaf,
   {{0x7d0d1083,0xdce282a5,0x41ca816f,0x59ca9905}},	//   _kuas, dvođ, ापास, ापार,
   {{0x27178028,0xa56792c8,0x25fe00d4,0x290333a0}},	//   _tăng_, تدان, रेपी_, _tija_,
   {{0x6e2d154c,0x9f350558,0x44316a3f,0x984817ae}},	//   _leab, _негі, naz_, _мяса_,
   {{0x394909ca,0x7ced8020,0x6e228041,0x95058019}},	//   luas_, gúra, bbob, _کہتے_,
   {{0x26cd8b80,0x443136b2,0xe3b08199,0x442cea40}},	//   _ujeo_, haz_, خره_, _eed_,
   {{0x057783f8,0x44311ee0,0x8d7784c0,0x7d0d0013}},	//   _بازد, kaz_, _بازا, _nuas,
   {{0x50db035a,0xdce40063,0x26ddbd66,0x442c8014}},	//   भविष, _ksią, lowo_, _ged_,
   {{0x2bdb34ec,0x25ee0076,0xd90f8065,0x39490282}},	//   _मुला, _घरही_, ریں_, huas_,
   {{0x443a111b,0x7529aeb1,0x7d0d4f74,0x39490359}},	//   _sdp_, _kwez, _buas, kuas_,
   {{0x443a130c,0x44314022,0x66dd0019,0x777a81c0}},	//   _pdp_, faz_, rékp, avtx,
   {{0xb4d612c7,0x75299af2,0x711a8039,0x44311c88}},	//   िके_, _mwez, _הוספ, gaz_,
   {{0x6e2d0013,0x7cf25986,0x75298234,0x07a58087}},	//   _feab, værd, _lwez, _хайн,
   {{0x6609baa0,0x7d0d082a,0xa5bb0118,0x2bdb0072}},	//   _ngek, _fuas, mbón, _मुळा,
   {{0xf2d28158,0x26c25df6,0x39492706,0xe297138c}},	// [7060] גען_, miko_, guas_, чат_,
   {{0x629985c6,0x6aa40aa2,0xb06301ac,0x60c1880a}},	//   _lowo, skif, jväč, nilm,
   {{0xdc9b0451,0xc5f68bb8,0x7d1bd34f,0x9e6690ee}},	//   _הייל, ेश्य_, _atus, звед,
   {{0x442cea41,0x6299ea42,0x26c23cfc,0x6d428ea4}},	//   _sed_, _nowo, niko_, troa,
   {{0xe5a385f1,0x6da38e17,0x7e760069,0xfce69d7b}},	//   ници, ница, _mayp, подо,
   {{0x442c81cd,0x6609907a,0x26c236d0,0x6d42811e}},	//   _qed_, _egek, hiko_, rroa,
   {{0x442cd81e,0x26c2376a,0x26dd8573,0x7d1b8009}},	//   _ved_, kiko_, bowo_, _etus,
   {{0xfa970158,0x62998e60,0xb909001c,0xf709801c}},	//   ִדיש_, _cowo, _nghị_, _cầm_,
   {{0x25fe146d,0xd90d84c0,0x26c26a43,0x3ea68101}},	//   रेमी_, لین_, diko_, mkot_,
   {{0xf48495e4,0xb4d64765,0x7c3a813c,0x3ea681a9}},	//   _تاری, िको_, _udtr, lkot_,
   {{0x7d0d0057,0x656402c4,0x26c21ffc,0x08570039}},	//   _suas, _apih, fiko_, הבים_,
   {{0x7d0d0867,0xeeab0470,0x6299ea44,0x76ab0991}},	//   _puas, сток_, _gowo, стов_,
   {{0x7d0d1155,0x60c1ea45,0x645c0c9f,0x2d800073}},	//   _quas, bilm, ffri, _crie_,
   {{0x2d8010f4,0xb5fb00f7,0x6f1c017f,0x645c0019}},	//   _drie_, neái, _otrc, gfri,
   {{0x44316a46,0x20073c6d,0x26c21768,0x7d0d0144}},	//   raz_, žnik_, biko_, _wuas,
   {{0x39490c52,0x6fbd0074,0x7cf20bc5,0x66e40226}},	//   tuas_, ्पसं, være, _поја,
   {{0x44310510,0x2d8002d6,0x25a203eb,0x00000000}},	// [7070] paz_, _grie_, cykl_, --,
   {{0x6e3b826c,0xb21b0366,0x7cf203ba,0x7529818e}},	//   _sdub, _knæk, tære, _rwez,
   {{0x8d1809d7,0x26ddb30b,0x7ae2ea47,0x0675a357}},	//   _وزیر_, towo_, _okot, дуля,
   {{0x3ea6ea48,0x394910e1,0x7529ea49,0x60c1ea4a}},	//   gkot_, puas_, _pwez, zilm,
   {{0xf65087bd,0xb60980eb,0x60c18850,0x26ddea4b}},	//   ائم_, višķ, yilm, rowo_,
   {{0x26c26a4c,0x2cac826c,0x7b0800f7,0x7ae2dba7}},	//   ziko_, _cldd_, _óstá, _akot,
   {{0x6299809a,0xfc3081a8,0x2fc50106,0x61e643bc}},	//   _powo, احه_, _älg_, _zykl,
   {{0x26c223f8,0x6e3bea4d,0x75298deb,0x00000000}},	//   xiko_, _udub, _twez, --,
   {{0x645c278e,0x7529822e,0x7d1bbb5b,0x3ebfc501}},	//   yfri, _uwez, _utus, _imut_,
   {{0xb4bc00cf,0xb5fb0013,0x6d4b820c,0x6299ea4e}},	//   _आगे_, ceái, muga, _wowo,
   {{0x60c18a0b,0x6d4b849f,0xf709801c,0x9a1281bc}},	//   rilm, luga, _tầm_, _pọtụ,
   {{0x2d8001e2,0x60c1ea4f,0xfd4b019d,0x291fac6b}},	//   _prie_, silm, _uloọ, ppua_,
   {{0x26c26725,0x6d59ea50,0x7afb8100,0x6d4bbd4f}},	//   riko_, ntwa, mmut, nuga,
   {{0x7ae9a7eb,0xdcfb826c,0x3ead8722,0x7afbd8ce}},	//   llet, _oruč, _llet_, lmut,
   {{0x6d4b8125,0x26c21fe8,0x3ead8009,0x290f807b}},	//   huga, piko_, _olet_, _huga_,
   {{0x2907ea51,0x6d4ba016,0x645c0ed0,0x7afb816a}},	//   _hina_, kuga, sfri, nmut,
   {{0x290f848f,0x2907ea52,0x68f5026c,0xd24f0019}},	// [7080] _juga_, _kina_, _bhzd, شنل_,
   {{0x2907822e,0x6d4bea53,0x25fe0128,0x212000dd}},	//   _jina_, duga, रेणी_, rpih_,
   {{0x29078589,0xe29a0eef,0x3ea68747,0xb4ca13ba}},	//   _mina_, _дан_, tkot_, लची_,
   {{0x9f968039,0x6d5996f7,0x6d4b819e,0x3d0a83eb}},	//   ודעה_, ftwa, fuga, ादले_,
   {{0x23c389c8,0xb5fb00f7,0x3ea6ea54,0x7ae9906f}},	//   _वेबद, teái, rkot_, dlet,
   {{0x6d4600dd,0x7ae2af9c,0x63a38114,0x3ebf9ab3}},	//   irka, _skot, fynn, _emut_,
   {{0x290fea55,0x7ae98d85,0xb5fb00f7,0x3ead80f1}},	//   _auga_, flet, reái, _flet_,
   {{0x7ae9a4df,0x2907b2d2,0xb5fb00f7,0x290fc8bb}},	//   glet, _aina_, seái, _buga_,
   {{0x7c3e0f28,0x286aabf3,0x2ee4826c,0xb5fb6a56}},	//   _odpr, орно_, _ikmf_, peái,
   {{0x26c0221e,0x63a38114,0x7ae98ab3,0x634a8085}},	//   _amio_, bynn, alet, _mənz,
   {{0x2907ea57,0xc1088028,0x291d82af,0xf21281bc}},	//   _dina_, _mỗi_, _etwa_, _dọrọ,
   {{0x2907ea58,0xc1088028,0x6d460639,0x7ae2ea59}},	//   _eina_, _lỗi_, frka, _ukot,
   {{0x2907ea5a,0xd9e30076,0xf21291d3,0xe4e700e8}},	//   _fina_, _कुढत_, _fọrọ, дівн,
   {{0x67d4838b,0x290784b9,0xdce4009a,0x443e8695}},	//   _полу, _gina_, _księ, _jdt_,
   {{0x6d4609ca,0xc108801c,0xad9b00e1,0x6d4b80c6}},	//   arka, _nỗi_, ncúz, zuga,
   {{0x6d4b818c,0x7d0881d0,0x6d46011f,0x7ae08096}},	//   yuga, _lids, brka, nomt,
   {{0x387800f7,0x64482e88,0xdcfb817f,0x19580d55}},	// [7090] _barr_, ódic, _sruč, маты_,
   {{0x3ead813c,0x29070bd7,0x1b1e00ab,0x6b750d9e}},	//   _slet_, öna_, _ফিরে_, _злоу,
   {{0x7ae9ea5b,0x7ae091ba,0x3eadc22a,0xae1c0c32}},	//   ylet, komt, _plet_, भुवन_,
   {{0x752d3d61,0x6d59822b,0xdb1e03a8,0x644303a7}},	//   _kwaz, ttwa, _expó, _ônib,
   {{0xdce981dd,0x7ae981cc,0x212b0114,0x660d0637}},	//   _sređ, vlet, _uwch_, _mgak,
   {{0x6d4b9c88,0xdce981dd,0x629d3529,0x6ef60118}},	//   ruga, _pređ, _hoso, mábe,
   {{0x629d20ed,0xdcfb8052,0x7ae9ea5c,0x6d4bbcb2}},	//   _koso, _uruč, tlet, suga,
   {{0x660d2e95,0xdce982ee,0x7982d5d1,0x60c500dd}},	//   _ngak, _vređ, _brow, lihm,
   {{0x2bdf83eb,0x7ae98558,0x7afbea5d,0x212b86c0}},	//   _पुरा, rlet, rmut, èch_,
   {{0x660d6a5e,0x26c0142f,0x3f588187,0x7ae9ea5f}},	//   _agak, _smio_, féu_, slet,
   {{0xdce9803a,0x752d3f6d,0x44278144,0x07a58a18}},	//   _uređ, _awaz, mbn_, ханн,
   {{0x629d1e24,0x6721805c,0x290f8503,0x79829106}},	//   _noso, rplj, _tuga_, _frow,
   {{0x628bea60,0xd7568065,0x0d8306c8,0x79828039}},	//   _ingo, ولیت_, глян, _grow,
   {{0x6f0980eb,0xfd4e81bc,0x9a1281bc,0x3f58b49a}},	//   _liec, _alkọ, _họpụ, béu_,
   {{0x7c3e8073,0x629d0573,0x68e1b3bc,0xeb9a1016}},	//   ópri, _boso, mold, чив_,
   {{0x6f09a19c,0xe29704ae,0x26c0026c,0xc3329101}},	//   _niec, нас_, _umio_, טול_,
   {{0x61430294,0xe9d72262,0xd94302d3,0x4427808e}},	// [70a0] лета, ект_, лети, kbn_,
   {{0x9c7c826f,0x68e1ea61,0x2bdb0128,0x2a6d8069}},	//   _akčn, nold, _मुका, heeb_,
   {{0x54570051,0x628b9c96,0xf457007c,0xe666845e}},	//   _אביב_, _ongo, _אייר_, етло,
   {{0x7d088022,0x68e18a38,0x629d0114,0xdce40084}},	//   _sids, hold, _goso, _priė,
   {{0xf9920bca,0x7e646a62,0x1a9b00be,0x6f09ea63}},	//   _صبح_, _mbip, _זיכע, _diec,
   {{0x628b8e6c,0x653b00be,0x661b838a,0x34bc8a27}},	//   _ango, לענד, _efuk, ्चेद,
   {{0x6f098012,0x7d08806a,0xd62aad6b,0x629d36ba}},	//   _fiec, _vids, _нове_, _yoso,
   {{0x7982809a,0x7e640133,0xb5fb0144,0x290a0061}},	//   _prow, _nbip, nfác, _hiba_,
   {{0x7d089277,0x68e1c235,0xf9928154,0x290a3f9c}},	//   _tids, fold, ابع_, _kiba_,
   {{0x628bbebe,0x68e18019,0xdfda8098,0x2d848ca3}},	//   _engo, gold, зъм_, _irme_,
   {{0xc5fb13e5,0x690900d2,0x752d3da9,0x65760a84}},	//   ृश्य_, _ožen, _swaz, _asyh,
   {{0x234ba3f7,0x290a071f,0x2a6d822c,0x7ae602c4}},	//   _رسمی_, _liba_, ceeb_, _nkkt,
   {{0x25a6ea64,0x38cbbd9b,0x68e1ea65,0x6ef60118}},	//   nyol_, _کانی_, bold, xábe,
   {{0x629d01bf,0x290a02a0,0x7e645309,0x752d06c0}},	//   _soso, _niba_, _ebip, _vwaz,
   {{0x629d1640,0xfbdb06b7,0x9a871156,0x1bd4228e}},	//   _poso, _मुखम, нуал, горя,
   {{0x629d19e7,0x290a0087,0x752d6a66,0x2d84ea67}},	//   _qoso, _aiba_, _twaz, _orme_,
   {{0x690924b2,0x629d05e4,0x290a020c,0x752d035c}},	// [70b0] _džen, _voso, _biba_, _uwaz,
   {{0x7e7d3839,0x6f09809a,0x6ef601df,0x5b151071}},	//   ldsp, _siec, rábe, _имот,
   {{0xe70b15e4,0x290a585c,0xdfd100f7,0x6f09ea68}},	//   ستان_, _diba_, جيا_, _piec,
   {{0x6ee781a8,0x2a6d81c0,0x26cfca6c,0x52a701a8}},	//   رسال, xeeb_, ungo_, _أصدق,
   {{0x6d5d6208,0x3a29036e,0x7e7d5d97,0xe8d90870}},	//   ntsa, mbap_, idsp, ntị_,
   {{0x7aed6a69,0xe7330250,0xdced005c,0x6f09809a}},	//   llat, _مصر_, _krađ, _wiec,
   {{0x0ee10076,0xe2998973,0x8c1c0051,0x6d5d0006}},	//   नवाड, дай_, לוגי, htsa,
   {{0x44336a6a,0x7ea600a9,0x7aed6a6b,0x7e7d013c}},	//   _lex_, _tópi, nlat, jdsp,
   {{0x6d4f0052,0x6aa98125,0xe9d99fb4,0x442782f7}},	//   juca, rkef, ьки_, pbn_,
   {{0x39490e67,0x7e7bea6c,0x6d4f6a6d,0x7aed425a}},	//   iras_, _haup, duca, hlat,
   {{0x7e7b9184,0x6ef60065,0x64419400,0x645e8722}},	//   _kaup, vább, _idli, òpie,
   {{0x38a41bc0,0x68e19753,0x39496a6e,0x628ba0b4}},	//   _hört_, sold, kras_, _ungo,
   {{0x394da95a,0x7e7b816f,0x6724807d,0xee3f003e}},	//   ques_, _maup, _čije, ckým_,
   {{0x7e7b91de,0x6ef88118,0x10a2816c,0x98a282ee}},	//   _laup, míbe, _вишн, _више,
   {{0x39496a6f,0x1d072659,0x6ef8801b,0x6ef60019}},	//   eras_, тери_, líbe, rább,
   {{0xc2433acb,0x394907a3,0x1b1380ab,0x7e7bb162}},	//   инск, fras_, _সবাই_, _naup,
   {{0x9426117e,0x39496a70,0x6d5b8069,0x6d4f6a71}},	// [70c0] _импе, gras_, _nqua, cuca,
   {{0xb5fb65a3,0xdd310085,0xf53703de,0x44331d5e}},	//   reát, ləşd, _שניי_, _gex_,
   {{0x44386a72,0xdced0025,0xb4c00076,0x63a70063}},	//   mar_, _građ, ूची_, cyjn,
   {{0x39492b72,0x7aed6a73,0xfaa61bcc,0x76a980e8}},	//   bras_, clat, _рамо, нтів_,
   {{0x7ae4025d,0x290a25f3,0xdce080eb,0x7e7b8036}},	//   moit, _tiba_, _apmā, _daup,
   {{0x55bb0039,0x7ae40009,0xf4d08264,0x5453804a}},	//   ומנו, loit, িত্ব, ивіт,
   {{0x3ea000c9,0xf70a001c,0xf1bf0118,0x38a402d0}},	//   _ooit_, _hầu_, _feás_, _dört_,
   {{0x44380695,0xf7770bea,0xee3f01ac,0x7ae46a74}},	//   har_, _בעלי_, tkým_, noit,
   {{0xb6a38f5a,0x26c4d6eb,0xbea38f9c,0x63a70035}},	//   _титл, _immo_, _татк, zyjn,
   {{0x44386a75,0xdd8f8013,0x7ae40009,0x7e7b807a}},	//   jar_, _بوك_, hoit, _zaup,
   {{0xd7f79a8f,0x7ae42d33,0xf8370039,0xbcfb00e7}},	//   кую_, koit, כנית_, ntée,
   {{0x673a807b,0x7c3880a9,0x443335db,0x7ae40364}},	//   rstj, lavr, _sex_, joit,
   {{0x44383a20,0x3ea002be,0x2bdb0074,0x673a807b}},	//   far_, _doit_, _मुजा, sstj,
   {{0x64d20076,0x403491b3,0x394900a9,0x6d4f6a27}},	//   _सदृश, _секс, vras_, ruca,
   {{0x9f588009,0x6909056f,0x25ad1cf3,0xc339801b}},	//   ärä_, _džel, šel_, žívá,
   {{0x39491864,0x6d4f0052,0xd838842b,0xf70a001c}},	//   tras_, puca, lač_, _bầu_,
   {{0xf70a0028,0x7aed1d2c,0x7ea60118,0x60f90e11}},	// [70d0] _cầu_, rlat, _cópu, еная_,
   {{0x2edb8c78,0xf70a001c,0x7e7bc092,0xdce9876c}},	//   यक्त, _dầu_, _saup, _iseć,
   {{0xf4120051,0x20070364,0xdced1c67,0x7ae426b9}},	//   _לפי_, äni_, _urađ, boit,
   {{0x60c89cbc,0x7ae404c3,0x4ea78098,0xa295102a}},	//   hidm, coit, ърза, _самі,
   {{0x3cdf85b3,0xe7e50076,0xd12692dc,0xd838979d}},	//   गवले_, _कडवा_, _دم_, kač_,
   {{0x6aad052a,0x387c82f9,0x6f0d03e1,0x26c48299}},	//   lkaf, _navr_, _liac, _emmo_,
   {{0x2ca11083,0x7e7b82d7,0x9f3400e8,0x69d980b9}},	//   _mohd_, _taup, _весі, _sxwe,
   {{0xdce9b4c1,0x6aad6a76,0x6ef8802a,0x6ef60061}},	//   _oseć, nkaf, tíbe, kába,
   {{0x44386a77,0x1017000f,0x2f1a8029,0x38a4016d}},	//   yar_, _तलाश_, _rīga_, _görs_,
   {{0x4438519e,0x3ea003d3,0x6ef885e4,0x7ae44395}},	//   xar_, _soit_, ríbe, zoit,
   {{0x1eca1927,0xb5fd81e2,0x61eb809a,0x6ef884c3}},	//   елни_, _rašy, _wygl, síbe,
   {{0x44380a73,0xaca38129,0x7fb3811c,0xba3983de}},	//   war_, _ruộn, nəqə, _װײַט,
   {{0x3ea04666,0x7ae46a78,0x6f0d6a79,0xe8ee81e2}},	//   _voit_, voit, _diac, _гл_,
   {{0x628f0698,0x2a7d822c,0xd83880d2,0x4438236f}},	//   _anco, _hawb_, cač_, uar_,
   {{0x3ea04a2c,0x2a7d81c0,0x6f0d0090,0x395f82d7}},	//   _toit_, _kawb_, _fiac, ltus_,
   {{0x44382dc4,0x670c0063,0x6909225d,0x6f0d0081}},	//   sar_, _सूचक_, _džem, _giac,
   {{0xceb402bf,0xe8fa1a0b,0x44384359,0x38b60aa2}},	// [70e0] _ilə_, ела_, par_, _lære_,
   {{0x48c40a49,0x628f19c3,0x47bf00ab,0x2a7d822c}},	//   ্ত্র, _enco, ্থনী, _lawb_,
   {{0x44446a7a,0x03a60993,0x6d4b9aa6,0x395f82f1}},	//   _id_, _сино, erga, htus_,
   {{0xd838805c,0x395f9247,0x2a7d81c5,0x44441706}},	//   zač_, ktus_, _nawb_, _hd_,
   {{0x8e570f60,0x64a68e02,0xdca6997b,0x395d81c0}},	//   רינג_, лада, лади, _nqws_,
   {{0xa3e812ee,0xd37a8991,0x38b603ba,0x6aa30162}},	//   _बडा_, ечи_, _bære_, _înfr,
   {{0x38a4016d,0x38b6006a,0x2a7d8114,0x6e398122}},	//   _förr_, _værd_, _bawb_, bawb,
   {{0x7644022e,0x66e6c81b,0xdee6ca58,0x7c3880fe}},	//   _ndiy, _соба, _соби, savr,
   {{0xd0108013,0xc05a902a,0x6f0d0013,0x2a7d81e9}},	//   يلة_, нін_, _riac, _dawb_,
   {{0x2ee680c9,0x2bdfbac3,0x444401c6,0x2ee95e5f}},	//   loof_, _पुका, _nd_, _skaf_,
   {{0x2a668021,0x6f0d2b38,0xd838803b,0x3f878024}},	//   _бълг, _piac, rač_, _crnu_,
   {{0x44446a7b,0xa3e80006,0xdce980ce,0x918692c5}},	//   _ad_, _बड़_, _pseć, _مجتم,
   {{0x44440f77,0x6f0d01ac,0x69092c08,0xe8948a08}},	//   _bd_, _viac, _džej, _валь,
   {{0x6aa2a4de,0x764407d9,0xceb40201,0xb17b810f}},	//   _hoof, _ediy, _elə_, _נטור,
   {{0xb8658077,0x32671fb4,0x6ef60019,0x6aa2ea7c}},	//   _خانو, лтав, sába, _koof,
   {{0x44446a7d,0x6e2487f4,0xb6c90019,0x2a7d81c0}},	//   _ed_, ñibl, _جاتے_, _xawb_,
   {{0x38350aac,0x3f8780d2,0xf84b1cad,0xaca3819d}},	// [70f0] инар, _zrnu_, ечей_, _skọl,
   {{0x26cb6a7e,0x201e82d6,0x3d18800f,0x6aad04fe}},	//   lico_, ncti_, _पढ़े_, skaf,
   {{0x3f8749b3,0x6d40a67f,0x64456a7f,0xe1ff0032}},	//   ínu_, _avma, _idhi, _gbón_,
   {{0x26cb1cdc,0x17f80307,0x1e0f816f,0x4444011a}},	//   nico_, اركة_, िशेष_, _zd_,
   {{0x395fea80,0xa56480a0,0xe618821e,0x2a7d81c0}},	//   xtus_, مدون, уді_, _rawb_,
   {{0x21290587,0xd4698604,0x6f02e53f,0x26cb00e5}},	//   mpah_, тике_, amoc, hico_,
   {{0xeb9982da,0x2a7d8114,0x6aa2838a,0x64450c93}},	//   тий_, _pawb_, _boof, _mdhi,
   {{0xf53f04b8,0x38b6581e,0xb1458ba8,0xe8e0001c}},	//   kså_, _være_, анил, _đứa_,
   {{0xe0d98ae7,0x81e700c8,0x20240125,0xd6d8902f}},	//   кви_, যের_, _árið_, _стр_,
   {{0x395fa8d1,0x05dea23a,0x229c001b,0x1f65960f}},	//   rtus_, _फुटब, _díky_, аком,
   {{0x395f8744,0x752401dd,0x2a7d8282,0x3160011b}},	//   stus_, _stiz, _tawb_, ztiz_,
   {{0x26cb1ce3,0x64451eb3,0x6e360079,0x66e605c2}},	//   gico_, _adhi, _qeyb, рома,
   {{0x59a5016f,0x6ef8e7c8,0xe9a89459,0x2d8925dc}},	//   _गॅलर, níba, _مدون_, _crae_,
   {{0x7cf2013c,0x7ae49640,0x44210122,0x69096a81}},	//   mærk, čite, _cfh_, _džek,
   {{0x44446a82,0x394dc3ff,0xdc0881a9,0x46b58526}},	//   _vd_, lres_, mēģi, ंसाह,
   {{0x3eb902af,0x394d8e67,0x3a2607b6,0x76441a73}},	//   chst_, ores_, рмаг, _udiy,
   {{0x394d862f,0x3d159344,0x3b070323,0x213f80ee}},	// [7100] nres_, _फूले_, рето_, nsuh_,
   {{0x394dd673,0x44446a83,0x270e8f12,0xd25981a9}},	//   ires_, _ud_, िद्र_, miņu_,
   {{0x7c3c6a84,0xee3aad6b,0x657b9258,0x69dd6a85}},	//   marr, вне_, _asuh, _exse,
   {{0x0d869505,0x7c3c0102,0x9f47801b,0x33db04de}},	//   илен, larr, _nyní_, _יחיד,
   {{0x6aa2a5ad,0x2ee69af4,0x9784003d,0xd2598ec3}},	//   _roof, roof_, _گیاه, niņu_,
   {{0x394d92af,0x7c3c0e9b,0x394001c5,0x78a3acb1}},	//   dres_, narr, msis_, _nonv,
   {{0x394d80c8,0x9f5c0364,0xa69684bd,0xf743351e}},	//   eres_, ävä_, _крај, _меро,
   {{0x26cb0511,0x7c3c2975,0x99668470,0x39406a86}},	//   xico_, harr, атол, osis_,
   {{0x7c3c00ad,0x26cb290f,0x62809819,0x39406a87}},	//   karr, vico_, rdmo, nsis_,
   {{0x78a393a0,0x7c3c6a88,0xa0a6a240,0x394067ea}},	//   _conv, jarr, ршил, isis_,
   {{0x3ea48613,0x7c3c2564,0x381702f6,0x69090858}},	//   _komt_, darr, יקים_, _džeh,
   {{0x394d9e9e,0xa1868a7f,0xf53f0bc5,0x39404761}},	//   bres_, _выкл, tså_, ksis_,
   {{0x26cb6a89,0x394d809f,0x7c3c011e,0x290e993a}},	//   rico_, cres_, farr, _tifa_,
   {{0x7c3c00ad,0x6458a133,0x443cea8a,0x2d8901b0}},	//   garr, ngvi, nav_, _vrae_,
   {{0x26cb1820,0xa3cc835a,0xdce984b7,0x39400915}},	//   pico_, रपट_, _speċ, esis_,
   {{0x443c81c5,0x2d891cdc,0x25608247,0x68e89e1a}},	//   hav_, _trae_, kòl_, lodd,
   {{0x26c90025,0x443c803a,0xae0301fe,0x6fd9000f}},	// [7110] _imao_, kav_, रेशन_, _मशहू,
   {{0x7c3c07d0,0x92d700c8,0x1a65003d,0x37ab302b}},	//   carr, িতে_, _گیری_, ктен_,
   {{0x443cea8b,0x61ef0242,0x3e860061,0xd0180b69}},	//   dav_, _wycl, sítő_, рфу_,
   {{0x22950b53,0x394001c5,0x394dc8a3,0x6ef8802a}},	//   _الحس, bsis_, yres_, tíba,
   {{0x98b30085,0x443cd55f,0x2bdf9c7b,0x3ea48609}},	//   şdır_, fav_, _पुजा, _domt_,
   {{0x394dd4ec,0x7cf2006a,0xb4db0722,0x6ef8ea8c}},	//   vres_, værk, cràt, ríba,
   {{0x3f8a017f,0x7ced81a8,0xd25981a9,0x291956c5}},	//   _grbu_, dúrt, ziņu_, _husa_,
   {{0x394dbab9,0x7c3c4395,0x6b830511,0x291959fd}},	//   tres_, zarr, _ángu, _kusa_,
   {{0x443c803a,0x394dad9c,0x29116a8d,0x7c3c0f3e}},	//   bav_, ures_, _kiza_, yarr,
   {{0x394d9e9e,0x29196a8e,0xdcf98591,0x26c96a1a}},	//   rres_, _musa_, _صفات_, _amao_,
   {{0x29116a8f,0x29196a90,0xb69b3296,0x14d69101}},	//   _miza_, _lusa_, rmân, _פועל_,
   {{0x394dae3a,0x6e3d033e,0x6ef60207,0x39402616}},	//   pres_, gasb, rábo, ysis_,
   {{0xe7f40c78,0x7c3c011e,0x81ac00c8,0x29190e6d}},	//   _अर्थ_, tarr, _কেন_, _nusa_,
   {{0x6efd6a91,0x78ba8a11,0x2911012b,0xdce9a3f9}},	//   vébe, chtv, _niza_, _opeč,
   {{0x7c3c04b9,0x6d4f1581,0x29190bb1,0x24810122}},	//   rarr, arca, _ausa_, _dahm_,
   {{0x7c3c1b54,0x29193394,0x25608247,0x6efd0019}},	//   sarr, _busa_, yòl_, tébe,
   {{0xe1fa013a,0x7c3c159d,0xa3c9897d,0xbcfb01a8}},	// [7120] уга_, parr, _लेस_, stéa,
   {{0xeb9a04ae,0x7c3c022b,0x2ca582c4,0x3ae180e1}},	//   _био_, qarr, _nold_, rópy_,
   {{0xbb8600f7,0x39406a92,0x25608247,0x443c9024}},	//   _الجي, ssis_, wòl_, vav_,
   {{0xe29a2f86,0xe7370abe,0x443a6a93,0xee3aa28e}},	//   _сам_, сец_, _hep_, унд_,
   {{0x443ca571,0x443a0d29,0x291902a0,0x291109a6}},	//   tav_, _kep_, _gusa_, _fiza_,
   {{0x443a5288,0x29113469,0x6562ea94,0x62841914}},	//   _jep_, _giza_, rtoh, ldio,
   {{0x961d8029,0x672482a5,0x6562ea95,0x3ea4e44b}},	//   _saņe, _čijo, stoh, _tomt_,
   {{0x443a2354,0xd00f00f7,0x65628168,0x7ae9811b}},	//   _lep_, _ألف_, ptoh, goet,
   {{0xd83a8196,0xd9fa001b,0x9c5aa3f7,0x98b8802e}},	//   лэн_, ्धित_, _مجاز_, илит_,
   {{0x2ca5b2c7,0x26c90140,0xa3c986ae,0x98ad81d6}},	//   _gold_, _smao_, _लेव_, ateľ_,
   {{0x6448ea96,0x68e8831d,0x389b007c,0xd01081a8}},	//   _iddi, rodd, איינ, بلد_,
   {{0x6e22816f,0xfaa384fa,0x6abb8511,0x68e88114}},	//   ncob, _нахо, chuf, sodd,
   {{0x62840355,0x7c3aa168,0x3a391c18,0xc0e6963f}},	//   ddio, _ketr, _resp_, _лодк,
   {{0xdcfb803a,0x443a6a97,0x68e8808e,0x66cf026b}},	//   _vruć, _cep_, qodd, _bòkè,
   {{0x443a08b6,0x872691cc,0x6aa60711,0x29196a98}},	//   _dep_, _اعتم, _bokf, _susa_,
   {{0x2919188c,0x8aa40a08,0x272481bc,0x443a02f9}},	//   _pusa_, пруд, _ịnwa_, _eep_,
   {{0xa1590221,0x19590a14,0x443a276f,0x6448ea99}},	// [7130] разу_, разы_, _fep_, _oddi,
   {{0x7ae98cdb,0x628406ae,0xa3b881a2,0x3a390299}},	//   zoet, adio, ङना_, _wesp_,
   {{0xb0658009,0x613f026b,0x836701a8,0x6282838a}},	//   llää, _bàlá, _ادخل, _oaoo,
   {{0x35f5943d,0x6448d5d1,0xdced0110,0x29192305}},	//   опер, _addi, _praė, _tusa_,
   {{0x7c3a8b2b,0x64a5a59a,0xee388d8e,0x5d678098}},	//   _betr, жала, сні_, стез,
   {{0x76598114,0xfbd009a7,0x61fd00eb,0x81cc80ab}},	//   sgwy, _آتی_, _izsl, _শুভ_,
   {{0x2ca58aa2,0x7ae9ea9a,0x045680f7,0x68fa01c6}},	//   _vold_, toet, زلية_, _כלשה,
   {{0xa92580e2,0x6448d7e9,0x6e228037,0x26d90866}},	//   одил, _eddi, ccob, érol_,
   {{0x76498ec9,0x26cfd8cf,0x69091148,0x7ae9cff6}},	//   _idey, migo_, _džev, roet,
   {{0x7ae48025,0x7c3ab66b,0x26cfdef5,0x25ed01ce}},	//   čita, _getr, ligo_, _घड़ी_,
   {{0x6d4400e1,0xf2e78a08,0x7ae9e0a7,0xe7398eef}},	//   _svia, _людо, poet, јем_,
   {{0x7c3aa1a2,0x7d1ba2d9,0x26cfc23d,0x2a6901c0}},	//   _zetr, _kuus, nigo_, jfab_,
   {{0xbcfb0065,0x443a53d4,0x21a58676,0x6e3b829c}},	//   rtén, _pep_, _филм, _meub,
   {{0x7d1bda42,0x6c360013,0x26cfae84,0x212d80ee}},	//   _muus, تفسا, higo_, mpeh_,
   {{0x25fe05e8,0x4425872c,0xc22701bc,0x644d80fc}},	//   रेजी_, _mfl_, _ụkọc, ɗait,
   {{0x6d405d34,0x7e6d3a48,0x26cf807a,0x6e3bb31e}},	//   ámas, _gbap, jigo_, _neub,
   {{0x26cfea9b,0x7d1bea9c,0x7d01b2a0,0xa5bb002a}},	// [7140] digo_, _nuus, _ohls, lcón,
   {{0x7649d039,0x25e302f1,0x3a3f8115,0x6ab99670}},	//   _adey, _टुटी_, haup_, _llwf,
   {{0xe61a96d4,0x7c3a90b6,0x2d8d8081,0xe7ef8dd2}},	//   аде_, _retr, _aree_, _घुमा_,
   {{0xa3e3064a,0x6d42ea9d,0x7d1bea9e,0x7d019388}},	//   _फुट_, tsoa, _buus, _ahls,
   {{0x7c3a9598,0x2d8d8020,0x6e22861b,0x857696a5}},	//   _petr, _cree_, rcob, تدائ,
   {{0x6d42b7b7,0x645c45ca,0x6e22ea9f,0x9b26b51e}},	//   rsoa, ngri, scob, офил,
   {{0x6d4280a9,0xa2c10054,0x7c3ab42c,0xb4ca809a}},	//   ssoa, रोक्, _vetr, _लगी_,
   {{0xc2988895,0x22400239,0xf96a97ae,0x442581e0}},	//   ских_, naik_, арой_, _efl_,
   {{0x7d1bdd73,0x69c08503,0x25642b0d,0x26d901d6}},	//   _guus, uzme, jöl_, érom_,
   {{0x6f1c6aa0,0x7af60428,0x92ca8264,0x6e3b82f9}},	//   _kurc, hlyt, লকে_, _zeub,
   {{0xb4d6853e,0x22406292,0x645c0140,0x2d806aa1}},	//   ाची_, kaik_, dgri, _asie_,
   {{0x6f1c5f64,0x7d1b82a3,0x216a8ff7,0xa96a8d5f}},	//   _murc, _yuus, _види_, _вида_,
   {{0x291f81e8,0x2ab8810c,0x2d801b88,0x256419db}},	//   cqua_, _géba_, _csie_, göl_,
   {{0x645c0854,0x26cf9d1b,0xa2a68a27,0x6f1c1d5e}},	//   ggri, zigo_, टॉर्, _ourc,
   {{0x0b8812e1,0xaca38028,0x93884872,0x7af60b81}},	//   ости_, _xuốn, оста_, flyt,
   {{0x6d480063,0x201820bc,0x2d80002a,0xf1bf81d6}},	//   ądar, _agri_, _fsie_, žšej_,
   {{0x6e3bda4a,0x26cfa925,0xa2c120e9,0xb9550081}},	// [7150] _reub, vigo_, रोग्, яващ,
   {{0xa2ca81ab,0x6f1c3824,0xddc98087,0x3ea900ff}},	//   तोत्, _burc, _aceş, _hoat_,
   {{0x26cf984f,0x78a71487,0x2fc70028,0x2240510e}},	//   tigo_, _vojv, àng_, baik_,
   {{0x6f1c034a,0x4b7a0158,0xef180110,0x98a90bda}},	//   _durc, _פארו, імі_, mpač_,
   {{0x26cf83cd,0xceb400be,0xd83b0196,0x798901b9}},	//   rigo_, ויף_, _вэб_, _ġeww,
   {{0x7d7c010f,0x7aed6aa2,0xdced3dbb,0x26cf9c61}},	//   ינדו, loat, _opač, sigo_,
   {{0x7ae48353,0x29030267,0x5c380039,0x69090b80}},	//   čitn, _ihja_, חרון_, _džet,
   {{0xc2458171,0x63a803ba,0x3b09011c,0x7bdc03de}},	//   чник, ødni, nmaq_, יקוו,
   {{0xddc41809,0x3a3f82f7,0x84678081,0xdced0196}},	//   _obiš, raup_, _мъже, _apač,
   {{0x6457a6d5,0x6d59eaa3,0x44258176,0xdce401b9}},	//   óxid, muwa, _ufl_, _oriġ,
   {{0xf7718277,0xc5e90bea,0x6d59ae7f,0x291fc58e}},	//   راد_, _עד_, luwa, squa_,
   {{0x7e7982d5,0x195981e2,0xe1ff07f1,0x248584fe}},	//   newp, _гады_, _ozó_, _halm_,
   {{0x6d59b6ba,0x2485a70c,0x645c6aa4,0xeab08c3b}},	//   nuwa, _kalm_, tgri, _جعل_,
   {{0xa50a00b3,0x2eb88d14,0xc21281c6,0x98a001a1}},	//   сега_, _आत्त, _נהג_, mpić_,
   {{0x291d81cd,0x6d599e60,0xddcf0087,0xfce32306}},	//   _huwa_, huwa, tecţ, хоро,
   {{0x291d9a9b,0xa2cc035a,0xdbd788e5,0xee3a02ac}},	//   _kuwa_, _सगळ्, määr, _уни_,
   {{0x3e5b0039,0x6f0401bc,0x201811ee,0x6f1c6aa5}},	// [7160] _הדפס, _ihic, _pgri_, _surc,
   {{0xb4ca901b,0x6d46209b,0x6d59e1d8,0x6f1c0039}},	//   _लगे_, mska, duwa, _purc,
   {{0xb4e80076,0x6d46006f,0x7c3e0029,0xe807184a}},	//   यकी_, lska, _iepr, वेला_,
   {{0x2721eaa6,0x127a00f7,0xeafa026a,0x6d598041}},	//   _món_, _احدث_, _درخت_, fuwa,
   {{0x6d46088b,0x7c3e6aa7,0xdbce080a,0x6d5984b9}},	//   nska, _kepr, _bıça, guwa,
   {{0xb4d6853e,0xf7461a19,0x62866aa8,0x6d466aa9}},	//   ाचे_, _него, _hako, iska,
   {{0x2ca51bd9,0x62866aaa,0x248580dd,0x69c402a6}},	//   öldi_, _kako, _dalm_, lzie,
   {{0x6286085d,0x6d599855,0x6d464485,0x6aa4313d}},	//   _jako, buwa, kska, njif,
   {{0x628654dd,0x69c44ac3,0x58868048,0xdced6aab}},	//   _mako, nzie, пына, _spač,
   {{0x6d466aac,0x62860d8b,0xfca98481,0x27218129}},	//   dska, _lako, _والو_, _bón_,
   {{0xd0418201,0x443e80eb,0x6f040229,0x3d1583b7}},	//   nilə, _iet_, _bhic, _फूटे_,
   {{0x443e9302,0x6286005c,0xa3cd06b7,0x6f043f55}},	//   _het_, _nako, _शेष_, _chic,
   {{0xbcfb003e,0x50b78077,0x443ed70d,0xf0b78077}},	//   stém, زدید_, _ket_, زایش_,
   {{0x69c44094,0x6f0401bc,0x212b81a8,0x272181a8}},	//   dzie, _ehic, íche_, _fón_,
   {{0x443e9302,0x291d83c3,0x6d460359,0x62864100}},	//   _met_, _zuwa_, aska, _bako,
   {{0x443eeaad,0x6d5980a4,0xcff783c8,0xd0418085}},	//   _let_, yuwa, _מצוה_, dilə,
   {{0xdd9103f8,0x764d5d3f,0x3b090085,0xa3cd00c2}},	// [7170] _شود_, _iday, rmaq_, _शेर_,
   {{0x7c3e105d,0x443eb2c7,0xdddbac90,0x26cd8904}},	//   _gepr, _net_, _nauš, _smeo_,
   {{0x6d5980a4,0x62866aae,0xdd02011f,0x69c4180b}},	//   wuwa, _fako, _žućk, azie,
   {{0xae01000f,0x6d59e1d3,0x7c289151,0x2485eaaf}},	//   _ईरान_, tuwa, _afdr, _salm_,
   {{0x69091fa6,0x443ec6ce,0xe945004e,0x24858833}},	//   _džer, _bet_, _ترجی, _palm_,
   {{0x443eb1f6,0x291d80a4,0x6d59cffd,0x752d004f}},	//   _cet_, _ruwa_, ruwa, _mtaz,
   {{0x443e88f8,0x6d5980a4,0x628620d7,0x764d0079}},	//   _det_, suwa, _yako, _oday,
   {{0x443e80c9,0x6d461f9f,0x7bc3812b,0x764d331a}},	//   _eet_, yska, rznu, _nday,
   {{0x27218813,0x443ee1d6,0xaca30135,0x31696ab0}},	//   _són_, _fet_, _anọg, ntaz_,
   {{0x443eeab1,0xd90f8065,0x764d6ab2,0x6f040df6}},	//   _get_, ھیں_, _aday, _shic,
   {{0xdee60003,0x66e60049,0x64438888,0x752d203c}},	//   дони, дона, mani, _ataz,
   {{0x6443eab3,0x443e8a0f,0x7c3e123c,0x6d462fbc}},	//   lani, _zet_, _sepr, tska,
   {{0xe8ee8193,0x628607dd,0x2b40805c,0x6299837a}},	//   _ал_, _rako, ćice_, _inwo,
   {{0x6d466ab4,0x6f04004c,0x6443eab5,0x628606c1}},	//   rska, _whic, nani, _sako,
   {{0x7c3e020f,0x6d461277,0x62861619,0x752d0247}},	//   _vepr, sska, _pako, _etaz,
   {{0xe297002e,0x6d46267f,0x6289eab6,0x69c41d9d}},	//   мас_, pska, ndeo, tzie,
   {{0x6443eab7,0xf2d2812a,0x672482a5,0x20e184c5}},	// [7180] kani, דען_, _čiji, _पदाध,
   {{0x7ae9003b,0x69c41a62,0x62863e4c,0xfd5f001c}},	//   četa, rzie, _wako, _luyệ,
   {{0x6443c75a,0x62861620,0x443eeab8,0x6d498087}},	//   dani, _tako, _ret_, _avea,
   {{0xd0418201,0x443eae52,0xd6d98558,0x2d920168}},	//   rilə, _set_, пті_, _krye_,
   {{0x6443c0a6,0xdce287aa,0xdddba46d,0x1c2206a7}},	//   fani, stoč, _pauš, _मलाल_,
   {{0x62998edc,0x3e4e801c,0x843880f7,0x1603223a}},	//   _anwo, ột_, أكثر_, रेटर_,
   {{0x443e8711,0xf487853d,0xd7f201a8,0xd90d0019}},	//   _vet_, بانی, _شكر_, _ایل_,
   {{0x3e868110,0x29180041,0x225f8b20,0xed5adc30}},	//   _būtų_, _hira_, gguk_, _моб_,
   {{0x29185912,0x443eeab9,0x6457a132,0xfd5f001c}},	//   _kira_, _tet_, óxic, _duyệ,
   {{0xd90d8416,0x291802a3,0xb4e82a18,0x47348c40}},	//   مین_, _jira_, यको_, ннос,
   {{0xf98f803d,0x085704de,0x90570039,0x205700be}},	//   هبی_, ובים_, וסיף_, וייל_,
   {{0x569411d2,0x29181f1a,0x3ea6eaba,0x7d1700b9}},	//   вают, _lira_, njot_, _sixs,
   {{0x2d84800d,0x6ef880f7,0xe9da9ef5,0x2f1a8ec3}},	//   _jsme_, ríbh, _بذات_, _rīgu_,
   {{0x29180091,0x7e640101,0xbca501a8,0x00000000}},	//   _nira_, _ecip, رمزي, --,
   {{0x36d52748,0xbcfb0174,0x2cac8114,0x38cb8fd3}},	//   _покр, ntéi, _modd_, _بانی_,
   {{0xe1888028,0x34db816f,0x5f040992,0x7640828f}},	//   _kỳ_, _बद्द, _изја, _nemy,
   {{0x7e7d0a15,0x34951e18,0x2bcf0327,0x752d547a}},	// [7190] mesp, _запр, _हेरा, _utaz,
   {{0x6d5d2a8a,0x4427007e,0x31696244,0x6443eabb}},	//   musa, _ün_, rtaz_, xani,
   {{0x6443b404,0x291800ad,0x69090024,0xdfd100f7}},	//   vani, _dira_, _džep, ديا_,
   {{0x64438610,0xcf9380be,0x7e7d0b82,0x6b856abc}},	//   wani, כטע_, nesp, _ishg,
   {{0x64438d78,0x6d5d2e07,0x29186abd,0x6ef61243}},	//   tani, nusa, _fira_, cábu,
   {{0x29186abe,0xd0068065,0xf5928019,0x39496abf}},	//   _gira_, _مل_, الوج, msas_,
   {{0xa3c9825e,0x64438b5d,0x6d5d535b,0x2cac9106}},	//   _लेख_, rani, husa, _dodd_,
   {{0x715984fa,0x3a290239,0x29180b8e,0x7e7d453e}},	//   прос_, ncap_, _zira_, jesp,
   {{0x7e7d1a40,0xe9d99fb4,0x2cac8114,0x6ea3064a}},	//   desp, яки_, _fodd_, गानु,
   {{0xa3c1229e,0x29180509,0x39496ac0,0x7e645171}},	//   ्छा_, _xira_, isas_, _scip,
   {{0x65760358,0xfd5f001c,0x644181a9,0xe80a86ae}},	//   _spyh, _tuyệ, _ieli, हेला_,
   {{0x39492338,0x6441c2a9,0x7e7d1781,0xee370d8e}},	//   ksas_, _heli, gesp, нню_,
   {{0x3ead81d8,0x6441eac1,0x6d5d6ac2,0x249a02f7}},	//   _moet_, _keli, gusa, _pnpm_,
   {{0x7afbb65d,0x3156810f,0x6441866b,0x2d92067f}},	//   llut, _ניצן_, _jeli, _vrye_,
   {{0x64419a67,0xd5b800eb,0xeabf6ac3,0xa2a6864a}},	//   _meli, ņā_, _blù_, टॉक्,
   {{0xef198063,0x291815d7,0xfd4a0098,0x7afbeac4}},	//   _niż_, _sira_, _език_, nlut,
   {{0x6d5d1a47,0x29186190,0x2056142e,0xeabf0706}},	// [71a0] cusa, _pira_, етер, _dlù_,
   {{0x6441ac6a,0xdcfb8042,0x7afbeac5,0x6604005d}},	//   _neli, _oruđ, hlut, _izik,
   {{0x29186015,0x7afbeac6,0x44380286,0xef1982a6}},	//   _vira_, klut, mbr_, _biż_,
   {{0x291804bf,0x9f580168,0x75208c53,0x3ead87f1}},	//   _wira_, _hyrë_, _pumz, _coet_,
   {{0x6441eac7,0x3ead8a0f,0xef198609,0x26c00c53}},	//   _beli, _doet_, _diż_, _mlio_,
   {{0x6441eac8,0x224204b7,0x7e7d5207,0xdca391d5}},	//   _celi, _hekk_, zesp, лачи,
   {{0xc5f180c8,0x26c06ac9,0x7afb808b,0x764629e4}},	//   জেলা_, _olio_, flut, kaky,
   {{0x224201cd,0x7afb8ce9,0x78200006,0x6d5d020d}},	//   _jekk_, glut, _बलुक_, yusa,
   {{0x63b5009a,0xbcfb5783,0x50668a30,0xed579810}},	//   zyzn, stéi, нтна, _пот_,
   {{0x6441eaca,0xd6fb34c7,0x2918bebf,0x78ae6acb}},	//   _geli, ृष्ठ_, öra_, _jobv,
   {{0x7e7d2127,0x0f23a357,0x26c00362,0x7e628c53}},	//   tesp, льям, _blio_, ogop,
   {{0x6d5d103b,0x7d1abd5e,0x7afbb49a,0x22420176}},	//   tusa, _hits, clut, _nekk_,
   {{0xa2c41344,0x7d1aeacc,0x6441b7f2,0x2746826b}},	//   रसन्, _kits, _yeli, _bíná_,
   {{0x26c000e5,0x7d1d8580,0x2abc046d,0x660402ad}},	//   _elio_, _èsse, _bíbo_, _dzik,
   {{0xf76f8077,0x387eeacd,0x6d5d6397,0x7d1aeace}},	//   _هاي_, metr_, susa, _mits,
   {{0x6d5d2a69,0x7d1aeacf,0x39496ad0,0x442c8af8}},	//   pusa, _lits, tsas_, _lfd_,
   {{0x645a10dd,0xddc98968,0x38c90019,0x224200d9}},	// [71b0] ótic, _obeš, وائی_, _dekk_,
   {{0x7d1aead1,0x90280a8e,0x7b158088,0x81e28264}},	//   _nits, ецца_, _ršum, _ধরা_,
   {{0x39495b5b,0x2242021e,0x798611fd,0x64476ad2}},	//   ssas_, _fekk_, _eskw, maji,
   {{0x64472c6a,0xc5d580e8,0x4615803d,0x2242008b}},	//   laji, кіль, نوار, _gekk_,
   {{0x6441b126,0x7d1aead3,0x3ead837a,0x09db00ab}},	//   _peli, _bits, _voet_, _দরকা,
   {{0x442c88f1,0xd0450201,0x644734f5,0x64418168}},	//   _cfd_, yihə, naji, _qeli,
   {{0x61fc8085,0x7d1a8901,0x672d816b,0x3eada525}},	//   ərli, _dits, _čajo, _toet_,
   {{0x6441ead4,0x442cead5,0x628d311a,0x1db300c2}},	//   _weli, _efd_, ndao, ुनात,
   {{0x64418dc6,0x7afb82f7,0x7d1a9f6f,0x2b40805c}},	//   _teli, rlut, _fits, ćica_,
   {{0x7afb8e23,0x7d1ab637,0x40959c79,0x8c3c87c0}},	//   slut, _gits, трит, _boğu,
   {{0x81d700ab,0x629d4742,0x6f1bead6,0x76466ad7}},	//   িথি_, _onso, _kiuc, taky,
   {{0x38b60125,0x6d598a0f,0x8c3c817b,0x623598ba}},	//   _væri_, orwa, _doğu, _реду,
   {{0x95990c6e,0x0d9901bb,0x0d832005,0x764600dd}},	//   нтру_, нтры_, алян, raky,
   {{0x76466ad8,0x629d6ad9,0x395f8a5b,0x628beada}},	//   saky, _anso, muus_, _hago,
   {{0x8c431814,0x04430811,0x628beadb,0x316d80e7}},	//   ресе, ресн, _kago, ltez_,
   {{0x628b9eb9,0x3afa80f1,0xd5b212c8,0x7db604ad}},	//   _jago, tëpi_, _نفع_, _асоц,
   {{0x628b9b52,0x64476adc,0x69c9aea8,0x316d8cf8}},	// [71c0] _mago, baji, nzee, ntez_,
   {{0x7ae4803b,0x629d02ec,0x81ac00c8,0x6723eadd}},	//   čiti, _enso, _কেউ_, _kunj,
   {{0x752400f3,0x6723836e,0x7d1aeade,0x6fc1864a}},	//   _huiz, _junj, _rits, शनिं,
   {{0x6f09eadf,0x6aa98024,0x672d826c,0x7d1ac7b8}},	//   _chec, jjef, _čajl, _sits,
   {{0x7d1acdd7,0x6f1b9295,0x6d4beae0,0x64a69a12}},	//   _pits, _diuc, gsga, када,
   {{0x628b82c4,0x752468c0,0xdce982a6,0xc0450e06}},	//   _aago, _muiz, _preġ, _مخفو,
   {{0x44446ae1,0x628bc45b,0x07a307a1,0x67238642}},	//   _me_, _bago, _карн, _nunj,
   {{0x44446ae2,0xbcfb0019,0x661b2bea,0xe7eb06a7}},	//   _le_, ltét, žuki, _जुटा_,
   {{0xf2d30bea,0x628b811e,0x44442ba9,0xc05a8a18}},	//   יעה_, _dago, _oe_, мін_,
   {{0x7d1aa40d,0x1bed8006,0x7aed826c,0x628b85ee}},	//   _uits, _चुकल_, čata, _eago,
   {{0xa0a38196,0x6aa98144,0x2fc98326,0x64476ae3}},	//   ршыл, bjef, _ƙaga_, vaji,
   {{0x67238699,0x628be4bd,0x44446ae4,0x26c6808e}},	//   _dunj, _gago, _ae_, nhoo_,
   {{0x4444073a,0x64476ae5,0x316d82be,0x6280eae6}},	//   _be_, taji, ctez_, memo,
   {{0x44446ae7,0x628b912b,0x6280dd03,0x752400f3}},	//   _ce_, _zago, lemo, _duiz,
   {{0x64475791,0xa3cd01aa,0x56950b69,0x628bb104}},	//   raji, _शेख_, _байт, _yago,
   {{0x44445c06,0x6280bde1,0x64476ae8,0xf2c405a8}},	//   _ee_, nemo, saji, асун,
   {{0x44446ae9,0x8cb3801b,0x26d9005d,0x75242008}},	// [71d0] _fe_, _अवलो, miso_, _guiz,
   {{0x44446aea,0x26d9140a,0x6f09826c,0x628081e5}},	//   _ge_, liso_, _shec, hemo,
   {{0x6280cba5,0x15f4053d,0x2d9d0118,0xa5c7008b}},	//   kemo, _مسیح, _áweb_, _fróð,
   {{0xf7738158,0x26d9029b,0x291ceaeb,0x6d4b874d}},	//   יקע_, niso_, _liva_, tsga,
   {{0x44446aec,0x6445426b,0x2249079f,0xed5991b3}},	//   _ye_, _kehi, maak_, хол_,
   {{0x40341525,0x44440104,0x628b8461,0x395f8198}},	//   _верс, _xe_, _sago, vuus_,
   {{0x628be4fd,0x58d40767,0x6f09eaed,0xdce080eb}},	//   _pago, _торт, _thec, _apmē,
   {{0xc2070b85,0xc3340051,0x64456aee,0x316d80e7}},	//   _शराब_, בוק_, _lehi, ttez_,
   {{0xbcfb0065,0xdb150019,0x291c9fca,0x26d91268}},	//   ntés, gyzé, _biva_, diso_,
   {{0x61fd016b,0x316de31b,0x628ba5f4,0x69c9890d}},	//   _mysl, rtez_, _wago, rzee,
   {{0x44440051,0x628beaef,0xca758a41,0x628090dd}},	//   _re_, _tago, _булы, bemo,
   {{0xed5a3aa3,0x628090dd,0xcfc500c8,0x44211c83}},	//   ном_, cemo, _এখান, _agh_,
   {{0x44446af0,0x75240018,0x64451d6a,0xe0df06c4}},	//   _pe_, _quiz, _behi, _gwòg_,
   {{0x44440b18,0x6723eaf1,0xbfb5bb76,0x291cb194}},	//   _qe_, _tunj, _محبت, _giva_,
   {{0x4444658d,0xb5fb0065,0x394deaf2,0x7ae48353}},	//   _ve_, lgál, lses_, čitv,
   {{0x4444004c,0x26d91a47,0x394d82e6,0x0e660cec}},	//   _we_, ciso_, oses_, _скин,
   {{0x44446af3,0x3ea06af4,0x394d85ef,0x64456af5}},	// [71e0] _te_, _init_, nses_, _fehi,
   {{0x44446af6,0x7e69928e,0x644500ad,0xe1f73aa3}},	//   _ue_, _acep, _gehi, угу_,
   {{0x3ea01c33,0x657b82d5,0x22491a62,0xf8bf0580}},	//   _knit_, _apuh, baak_, _atés_,
   {{0xfaa61240,0xf2a618f6,0x394d81bf,0x628084c3}},	//   _само, _симп, kses_, xemo,
   {{0x62808548,0x7ae46af7,0x3ea0008e,0x7d1e14c7}},	//   vemo, mnit, _mnit_, _kips,
   {{0x7ae44453,0xbcfb0061,0x53348110,0x690b002a}},	//   lnit, ltér, аект, güed,
   {{0x6280a4ba,0x27f7003e,0x09dc903e,0x394dd26f}},	//   temo, čené_, मप्य, eses_,
   {{0x7ae40a92,0x7d1e002e,0x969585c2,0x8c3c880a}},	//   nnit, _lips, _круш, _coğr,
   {{0x8c3c82bb,0x26d90098,0x200780b9,0x7ae46798}},	//   _doğr, viso_, _azni_, init,
   {{0x7ae46872,0x22490fbc,0x20c0851e,0x3ea06af8}},	//   hnit, zaak_, _eòin_, _anit_,
   {{0x7ae40bc8,0x64450cf4,0x644ad9a5,0x290280eb}},	//   knit, _rehi, mafi, ēka_,
   {{0x64451a67,0x2f9703de,0x656f0799,0x61469073}},	//   _sehi, אכטן_, ttch, _беда,
   {{0x442102c4,0x25bf0019,0x26d96af9,0x7ae46afa}},	//   _pgh_, ául_, riso_, dnit,
   {{0x40349515,0x5f948e8e,0x644a85a3,0x656f6afb}},	//   _текс, _викт, nafi, rtch,
   {{0xd6d10c2a,0x60da8458,0x7792815b,0x2246808e}},	//   _وقت_, mitm, _ایجا, _keok_,
   {{0xfebb0077,0xa6ab0277,0x5a35013a,0x59d98540}},	//   _ساعت_, _سابق_, рнат, _बेडर,
   {{0x224900c9,0x644a9b52,0x442103ac,0x200b809a}},	// [71f0] raak_, kafi, _tgh_, ęcie_,
   {{0x04671b47,0x44211a2e,0x61fd026f,0x7ae46afc}},	//   _стим, _ugh_, _vysl, anit,
   {{0x64578510,0x644ad235,0xf80706d2,0x672d9320}},	//   óxim, dafi, учан, _čajk,
   {{0x66f70bb8,0xbcfb54ec,0x6d5d0998,0x394d84dc}},	//   ीतिक_, ctér, orsa, yses_,
   {{0xe5a59a34,0x6d4f00f7,0xa2ba0935,0x212900dd}},	//   рили, nsca, _एकत्, qqah_,
   {{0x644aeafd,0xd7fb4688,0x00000000,0x00000000}},	//   gafi, _зуб_, --, --,
   {{0x38b6035f,0x628f0704,0x6d5d0799,0x60daa6fd}},	//   _vært_, _kaco, hrsa, ditm,
   {{0x290101cd,0x6d5d0042,0x6f0d6afe,0x394dcddb}},	//   llha_, krsa, _nhac, tses_,
   {{0x91e5a28e,0x645e8228,0x672704b9,0x394deaff}},	//   ропе, ópic, _hujj, uses_,
   {{0x764beb00,0x394d8b39,0x3a2d81a1,0x6f0d018e}},	//   lagy, rses_, scep_, _ahac,
   {{0x394d8806,0x7d1e14c7,0x6f0d0219,0x672709ab}},	//   sses_, _rips, _bhac, _jujj,
   {{0x6f0d6b01,0x89d695e4,0xe1ff0144,0x7d1e6b02}},	//   _chac, اویر_, _oyó_, _sips,
   {{0x6f0d6b03,0xcb128051,0x7ae4826c,0xf50611d5}},	//   _dhac, _ולא_, čitt, измо,
   {{0x764bd8c9,0xb4c20f85,0x6609912e,0x60da8965}},	//   hagy, ्फे_, _mzek, citm,
   {{0x6d5d5bae,0xbcfb282c,0x6f0d0c49,0x6d4f6b04}},	//   arsa, ttér, _fhac, asca,
   {{0x6f0d6b05,0xd13201a8,0x3ea001c6,0x6aad008b}},	//   _ghac, قمر_, _unit_, gjaf,
   {{0x7d1e0502,0x628f02b7,0x2d8c00eb,0x7ae40ca9}},	// [7200] _tips, _daco, ādes_, rnit,
   {{0xe3ba0112,0xbcfb637c,0x67270c2e,0xa5bb2620}},	//   _або_, stér, _bujj, rcót,
   {{0x5c5b0051,0x628f6b06,0xb4c22311,0xbcfb0c83}},	//   _בדיק, _faco, ंसी_, ptér,
   {{0x539b0039,0x628f10e4,0x6d440035,0x644ab73c}},	//   _סיכו, _gaco, _kwia, wafi,
   {{0x66098063,0x7aed82a5,0x644aeb07,0x7bce35f5}},	//   _czek, čatl, tafi, lzbu,
   {{0xd37adc30,0x224682f7,0xc448803d,0xd9430f80}},	//   вчи_, _seok_, ایان_, _фери,
   {{0x6609eb08,0x69dd81ac,0xf2c681a1,0x672703f7}},	//   _ezek, úsen, исин, _gujj,
   {{0x644abdc1,0xbcfb6567,0x628f01df,0x6e242eda}},	//   safi, prég, _xaco, _ngib,
   {{0x60f88098,0xaca40032,0x644aace1,0x63bc18b6}},	//   лния_, _arọw, pafi, hyrn,
   {{0x6d5d02a5,0x6f02a7f5,0x8c66826a,0x7ae901f4}},	//   vrsa, lloc, _خطرن, četi,
   {{0x627e0035,0xe811864a,0x6f0d6b09,0x3f98816b}},	//   _złoż, डेला_, _phac, íru_,
   {{0xaca4019d,0x6448eb0a,0x98ab80eb,0x7bdb81c6}},	//   _drọw, _hedi, īcā_, _בקבו,
   {{0x628f2477,0xe8948b73,0x9934806b,0xa1588bda}},	//   _raco, _галь, _افتت, _салу_,
   {{0x644890d1,0x628f2934,0x6d4f0f35,0x91bb81c6}},	//   _jedi, _saco, rsca, _במדי,
   {{0x6f0d0219,0x628f3089,0x6aa2eb0b,0xd9e880ab}},	//   _thac, _paco, _knof, _পরিম,
   {{0x644882fe,0x1b1911e9,0x8aa415b5,0x6f028087}},	//   _ledi, ужбы_, оруд, jloc,
   {{0x6d44009a,0x51871454,0x672d826c,0x200542e4}},	// [7210] _gwia, шува, _čaji, _šli_,
   {{0x92d700c8,0x6448eb0c,0xd9e880ab,0x4ddc0039}},	//   াকে_, _nedi, _পরাম, _שחזו,
   {{0x33950013,0x628f6921,0x66098061,0xb60804e8}},	//   _الجز, _taco, _szek, _tuší,
   {{0x2b5e128a,0x99890824,0x628402df,0x66c66b0d}},	//   átce_, mbaž_, ceio, _kóka,
   {{0x6448a32e,0x9a128133,0x764b997a,0x356b9156}},	//   _bedi, _dọkụ, ragy, трен_,
   {{0xdfc6eb0e,0x04428767,0x6448ac92,0x8c42898d}},	//   _في_, пешн, _cedi, пеше,
   {{0xde678098,0xbcfb0866,0xe8d90133,0x7afd0af8}},	//   _възп, crée, gwụ_, _kkst,
   {{0x6f0286e7,0xa7fc82d0,0x66098cdb,0x3a98862c}},	//   cloc, rgıl, _tzek, атью_,
   {{0x7e7b8caa,0xe8f9a74b,0xa2ba152c,0x627e066f}},	//   _ibup, лли_, _एकस्, _ułoż,
   {{0x6448c0f4,0x26dd82ec,0x60d883a8,0x66d6007a}},	//   _gedi, liwo_, _cmvm, mški,
   {{0x25db85e8,0x34948b69,0x7ae481a1,0x2cf58072}},	//   _खेती_, _фахр, čitr, ेतील_,
   {{0x66c6007b,0x26dd8e80,0x5b158226,0x7bce016b}},	//   _bóka, niwo_, _умет, vzbu,
   {{0xa2a48ebf,0x7529e3ab,0x7e7b8133,0x6448d94b}},	//   कार्, _juez, _mbup, _yedi,
   {{0x764982a3,0x66d60110,0x7bce39c2,0xa5da80be}},	//   _leey, iški, tzbu, אַלי,
   {{0xdce2805c,0x7e7beb0f,0x78a3b33f,0xa3aa8697}},	//   stoć, _obup, _innv, खमय_,
   {{0x443301c0,0x86461d7b,0xd49180ff,0x7c2500b9}},	//   _efx_, _униж, _là_, _eghr,
   {{0x95560bbe,0x6d44574a,0x463b03de,0x26dd8326}},	// [7220] _اخبا, _uwia, _געפע, diwo_,
   {{0x7afd6b10,0x6566076d,0xb4db0722,0x6c8600f7}},	//   _ekst, mukh, ssàr, _الدم,
   {{0x78b50289,0x6448d02d,0x644e6b11,0xee3a9a19}},	//   _dozv, _redi, mabi, гне_,
   {{0x644e5e7e,0x644887d5,0x61e904c4,0xf4130051}},	//   labi, _sedi, _žele, _מפת_,
   {{0x1dd2800f,0x673b005c,0x6448a7eb,0x22406b12}},	//   _देखत, _čuje, _pedi, mbik_,
   {{0x6fca823c,0x644e6b13,0x7e7ba970,0x6f02be3d}},	//   ानमं, nabi, _ebup, sloc,
   {{0x6448d15a,0x09b580ab,0xdb09826f,0x6f02d0a3}},	//   _vedi, _জেলা, žnýc, ploc,
   {{0x6566005d,0x4425eb14,0x76498def,0xdd2d0084}},	//   kukh, _egl_, _geey, vėžy,
   {{0x644e6b15,0x41de001b,0x75298118,0x39524c86}},	//   kabi, _नेमस, _guez, nsys_,
   {{0x7e6d249a,0xd90d80d5,0xfbc80540,0xa2d80a27}},	//   _scap, نین_, रनाम, नोत्,
   {{0x2d800a8e,0x644e4a6c,0xda7a8081,0xa507c987}},	//   _apie_, dabi, _бял_, _уефа_,
   {{0x490f0d86,0xcebb0326,0xb5fb01a8,0x41d9a5e8}},	//   _तीनो_, _kuƙi_, lgái, _बेवस,
   {{0x200b8063,0x3a268580,0xd7c780d7,0x26c783ed}},	//   ęcia_, _igop_, لویه_, ënoi_,
   {{0x1fa69109,0x6ce7373a,0x316015a0,0x26cb18bd}},	//   _григ, сіме, driz_, shco_,
   {{0x78b5003e,0xf8db8039,0x2a69008e,0x2419076a}},	//   _rozv, _תחומ, tgab_, ровы_,
   {{0x7e6d09ca,0x65660234,0x7b1585f3,0xada601d6}},	//   _ucap, bukh, _ušut, _spúš,
   {{0x7c2500b9,0x2d99841c,0xa2da001b,0xcfd60264}},	// [7230] _tghr, _àsex_, _नगर्, _তুলন,
   {{0x644e32a3,0x660d1768,0x764f0035,0x9055004a}},	//   cabi, _izak, lacy, івец,
   {{0x7bde92ca,0xddcd0035,0x752988dc,0x224013ec}},	//   úpul, _udał, _suez, bbik_,
   {{0x764f3f52,0x8f9b81c6,0x3f9c80fe,0x395f8084}},	//   nacy, טיבי, _mrvu_, yrus_,
   {{0x98c50214,0x316001e8,0x94258721,0x61e4cb1f}},	//   ştır_, criz_, омле, _žiln,
   {{0x76499a25,0x66d60110,0x60c701a1,0x224b0252}},	//   _weey, rški, _uljm, _heck_,
   {{0x3ea49727,0xd49180ff,0x764f009a,0x44259839}},	//   _fnmt_, _và_, kacy, _vgl_,
   {{0x644e6b16,0xcfb200ab,0x7b158267,0x6b830187}},	//   zabi, _টেকন, _ašur, _ângu,
   {{0x4425861b,0x644e1382,0x0595803d,0x7e6481a8}},	//   _tgl_, yabi, _بازگ, óipe,
   {{0xf77187bd,0x212b0051,0xe0d9a349,0x4431811c}},	//   واج_, _much_, рво_, _üz_,
   {{0x644e0e7b,0xd0098193,0x16aa038d,0xb69b0187}},	//   vabi, рене_, авни_, rlân,
   {{0x644e2d84,0x764f230d,0x395feb17,0x3f9c80c3}},	//   wabi, gacy, prus_, _drvu_,
   {{0x644e3c36,0x7afb8e35,0x61ed8503,0xa50a15a6}},	//   tabi, mout, _žalf, иема_,
   {{0x7ae9eb18,0x660d01a1,0x2eb68035,0x66d0026b}},	//   lnet, _dzak, _अक्त, _bòkù,
   {{0x212b0943,0xa5bb25a7,0x36e90019,0x660d3ebe}},	//   _auch_, scóp, _گروپ_, _ezak,
   {{0x7ae990c3,0x316026de,0x212b01ec,0x644e4290}},	//   nnet, triz_, _buch_, sabi,
   {{0xe0da14b7,0x644e6b19,0x7ae992a5,0x2b40811f}},	// [7240] ава_, pabi, inet, ćici_,
   {{0x3160011e,0x66046b1a,0x212b0a7a,0x7afbeb1b}},	//   rriz_, _iyik, _duch_, hout,
   {{0x212b02af,0x2905eb1c,0x7afbeb1d,0xd7ff0162}},	//   _euch_, illa_, kout, _ţări_,
   {{0x28d99094,0xe29a1269,0x2eb9816f,0xbcfb00e7}},	//   योति, _там_, _आवृत, préc,
   {{0x7ae9936f,0x94aaa7cb,0xddcd009a,0x7afbeb1e}},	//   dnet, итка_, _gdań, dout,
   {{0xd0e8004e,0x7ae9811b,0x659b0e82,0x764f6b1f}},	//   _اکرم_, enet, יינק, zacy,
   {{0xf76791fb,0xd4678b30,0x7afbeb20,0x1fb55c30}},	//   _تا_, ције_, fout, _естр,
   {{0x2905eb21,0x7afba1bf,0x6738826c,0x62965207}},	//   ella_, gout, _rtvj, ndyo,
   {{0xcb131a0f,0x045a826a,0x764f00f3,0x68fa8087}},	//   ולה_, _نجات_, vacy, totd,
   {{0x3f9c803a,0x1d0a8698,0x26c902a5,0xb17b03de}},	//   _prvu_, _тези_, _slao_, סטיר,
   {{0x660d0065,0x7afbe3dc,0x7ae9d501,0xa09b00be}},	//   _szak, bout, bnet, בייט,
   {{0x99e880ab,0x29058009,0xd6db3ca1,0x7642eb22}},	//   _পরীক, alla_, рто_, nboy,
   {{0x764f1111,0xf6538039,0x67240590,0x2bde950e}},	//   racy, וצר_, _diij, _केतू_,
   {{0x7ae0e487,0x61ed8110,0x02b800d4,0x6fb681a8}},	//   limt, _žalg, _इकॉन, _ومشا,
   {{0x57f3838c,0x212b6b23,0x53340adb,0x224b6b24}},	//   _општ, _such_, дест, _peck_,
   {{0x690b009f,0x25a6007a,0x7982819d,0xb88281d0}},	//   güen, _šole_, _kpow, řídi,
   {{0x69c0d62a,0x660d6b25,0x645a80e1,0xd52d027d}},	// [7250] nyme, _uzak, _odti, _dựn,
   {{0xf8070f16,0xcf9b0b30,0x7ae08e9d,0x7ae9801b}},	//   очен, ије_, himt, znet,
   {{0x764d00b9,0x7d07026c,0x7ae9a45f,0x37ab1a1b}},	//   _keay, mljs, ynet, штан_,
   {{0x0f7b8039,0x7982809a,0x645a8748,0xe8a78c2d}},	//   שראל, _opow, _adti, _कच्च,
   {{0xa3df0e1a,0x29059a21,0xdca58468,0xf53f01a3}},	//   _देत_, ylla_, зали, npå_,
   {{0x91ba0039,0x69c0b3ab,0xd7ca8072,0xab9800d7}},	//   _המשי, dyme, ानाच, _اخیر_,
   {{0x447c0158,0x7982826b,0x7afb814f,0xdcfb8140}},	//   ינגע, _apow, tout, _upuč,
   {{0xd2a98364,0xfbd0803d,0xe7fe8105,0xdffe83b7}},	//   ские_, خته_, _उड़ा_, _उड़द_,
   {{0xa3db8b85,0xaca381bc,0x213980f1,0x2905eb26}},	//   _ढेर_, _ahụl, ësh_, tlla_,
   {{0x7ae9eb27,0x6d4980fc,0x88c98389,0x98bd65ba}},	//   snet, _iwea, слов_, ोसिए,
   {{0xb8e392e0,0x07a58b73,0x660400b9,0x7ae9cb1f}},	//   _एक_, чанн, _syik, pnet,
   {{0xe298835f,0x752d05ee,0x6a94804a,0x3f830af8}},	//   _має_, _buaz, _оріє, _mpju_,
   {{0xe0cea5bc,0x6b5080f7,0x7ebf03ed,0x3eab136f}},	//   _зв_, _tógá, _nëpu, _šité_,
   {{0x213f859c,0x40878992,0x913a8039,0x69d490f7}},	//   mpuh_, _фудб, _העסק, _बेटी,
   {{0x68e1eb28,0xf99f5ba7,0x6e298326,0x99dd816b}},	//   mild, _arè_, _ogeb, raňu,
   {{0x8b23039d,0x6e29eb29,0x61e96b2a,0x28de103e}},	//   едсе, _ngeb, _žela, फोनि,
   {{0xf9831bf2,0x798d6b2b,0x753b862b,0xf99f010c}},	// [7260] нгто, gwaw, _ntuz, _crè_,
   {{0x765beb2c,0x6e29838a,0xb4660d15,0x68e1b6b2}},	//   _aduy, _ageb, _экол, nild,
   {{0x753bb071,0xf99f03ec,0x752d1fa4,0x66e68468}},	//   _atuz, _erè_, _zuaz, пожа,
   {{0x68e18d35,0x690b07e0,0xf99f0247,0x798d0365}},	//   hild, qüen, _frè_, bwaw,
   {{0x68e19739,0xa50a867c,0x1d0a8ae7,0xe29b01c6}},	//   kild, беда_, беди_, _השכר,
   {{0x3940267f,0x7afb007a,0x2d9203ec,0x6562eb2d}},	//   mpis_, čute, _msye_, rroh,
   {{0x6fb60b76,0x79828035,0xbcfb0061,0x68e1a2f8}},	//   _عمرا, _spow, krén, dild,
   {{0x994c0038,0x78b88d02,0x66c6008b,0x6562eb2e}},	//   _môže_, _sovv, _bókm, proh,
   {{0x672e026c,0x64438106,0x7ae0d70d,0x2d9feb2f}},	//   _hubj, bbni, rimt, _grue_,
   {{0xbf0505fc,0x26c6eb30,0x7ae0b76c,0xd90e803d}},	//   रत्न_, lkoo_, simt, دیت_,
   {{0xb4e8816f,0x25a000b9,0xb2268049,0x7d070267}},	//   मची_, _aril_, _емел, vljs,
   {{0x6b9c012b,0x25a0110f,0x0b0000ab,0xe0df0176}},	//   dvrg, _bril_, ্দুল_, _awòl_,
   {{0x68e1e27f,0x91d4a701,0x68fe0a0f,0xaaa9801b}},	//   bild, _बेचै, kopd, कारक,
   {{0x013783c8,0xf53f01a3,0x690b0118,0x2ceb6b31}},	//   _צרות_, rpå_, güel, сьмо_,
   {{0xa87b8039,0x187b8039,0xd25b0fe6,0xe0df0242}},	//   _האור, _הטוב, йца_, _dwòl_,
   {{0x59de0fce,0x3d23046d,0xbcfb0061,0x31690cdb}},	//   _नेहर, _béwì_, ntéz, tuaz_,
   {{0x44f510f8,0xc2c400f7,0x394000e4,0x98b9041c}},	// [7270] _опис, ريكي, gpis_, олат_,
   {{0x7e7d1254,0x798d14d9,0x66f201a9,0x6e298362}},	//   lfsp, rwaw, māka, _sgeb,
   {{0x2fc70104,0x66f200eb,0x753beb32,0x41c881d0}},	//   áng_, lāka, _stuz, ाईँस,
   {{0xa63480e8,0xf99f06c0,0xd0920085,0x68e18965}},	//   енці, _trè_, _müəs, zild,
   {{0x7aed03c3,0xfe70803f,0x3d09816f,0x66f200eb}},	//   mnat, ادم_, ितले_, nāka,
   {{0x2fc70104,0x2bde8006,0x83399156,0x39590216}},	//   ơng_, _केहू_, очит_, _ivss_,
   {{0x6443eb33,0x20c9807b,0xddc2c2e3,0xe45081a8}},	//   rbni, _búin_, rgoš, اضه_,
   {{0x7aed20f5,0x5694a749,0x2480805c,0x6d49c3e8}},	//   nnat, _паст, đima_, _twea,
   {{0x61ed805c,0xf4879b10,0xac278d94,0xa3df0074}},	//   _žalb, _нужн, _ефек, _देस_,
   {{0x629d81ac,0x3ea90722,0x3b090359,0x7aed0428}},	//   ôsob, _anat_, hlaq_, hnat,
   {{0x68e1817b,0x3e8a15a6,0x656b9fb7,0x394027aa}},	//   rild, ойно_, lugh, zpis_,
   {{0x32e386c0,0x68e1eb34,0x3940008b,0xee370d55}},	//   _dèyè_, sild, ypis_, мню_,
   {{0x68e18612,0x7bc3828f,0x66f201a9,0x7afc8061}},	//   pild, lynu, gāka, _írta,
   {{0xa3df01b6,0xe8f8b73a,0x7aed6b35,0x2bd1975d}},	//   _देह_, _елі_, enat, तनपा,
   {{0x02c90076,0xeb97280f,0xbcfb6b36,0x26cdb736}},	//   रसंभ, мир_, prén, _oleo_,
   {{0x7aed20dc,0x3940005c,0x2127801c,0x66f200eb}},	//   gnat, tpis_, _hinh_, bāka,
   {{0x21278104,0x09e30391,0xa3e48540,0x672e33fe}},	// [7280] _kinh_, вотн, _पेन_, _subj,
   {{0xdcfb803b,0x7aed0a4f,0xa3df0744,0x3ea90639}},	//   _osuđ, anat, _देव_, _znat_,
   {{0x21278028,0x443a6b37,0x68fe0bfd,0x212feb38}},	//   _minh_, _ifp_, ropd, _lugh_,
   {{0x21278028,0x67000bb8,0x273380ff,0x39406668}},	//   _linh_, ैतिक_, _mãn_, ppis_,
   {{0x7ae46b39,0xb5fb0019,0x471b03de,0x20561e7d}},	//   miit, lgár, קונג, _отвр,
   {{0x7ae4043d,0x2127801c,0xb4e8816f,0xed59016b}},	//   liit, _ninh_, मचे_, áži_,
   {{0x201e0324,0x9f88007b,0x6f0406ec,0xd823393f}},	//   _àti_, _góða_, _okic, _адри,
   {{0x6b830106,0xdce6016b,0x78bc333a,0x21278362}},	//   _änge, dukč, _horv, _ainh_,
   {{0x645e06b9,0x78bc156e,0x2127801c,0x69c46b3a}},	//   _odpi, _korv, _binh_, nyie,
   {{0x7aed003a,0x7ae46b3b,0x443a377d,0x6f043a2f}},	//   znat, hiit, _nfp_, _akic,
   {{0x20c980f7,0x2127801c,0x442c808e,0x7aed6b3c}},	//   _iúil_, _dinh_, _igd_, ynat,
   {{0xa1c687eb,0x25a60353,0x752880cd,0x66f200eb}},	//   _обед, _šola_, _hidz, tāka,
   {{0x7aed0988,0x6282eb3d,0x20078085,0x78bc067f}},	//   vnat, _iboo, _eyni_, _oorv,
   {{0x66f200eb,0xf76f80d7,0x61e902d4,0xf4840469}},	//   rāka, دای_, _želo, кусн,
   {{0xa3df0935,0x3b0902a6,0x25ad0493,0xc059b73a}},	//   _देश_, tlaq_, ţel_, _хіі_,
   {{0x7ce908ae,0x2bb6805e,0x3ea902d5,0x32646b3e}},	//   džre, _अपना, _unat_, ктув,
   {{0x7aed6b3f,0x2bff0fcc,0xaca30870,0xa3df0740}},	// [7290] rnat, _शुरू_, _abụg, _देर_,
   {{0x21278028,0x273704b7,0x7528d619,0x62828122}},	//   _xinh_, _aħna_, _nidz, _lboo,
   {{0x64553f2b,0x7d0510e1,0x78bc0bfe,0x6d4d1cfe}},	//   mazi, _ikhs, _dorv, _hwaa,
   {{0xa29e800d,0x6d4d4150,0x7c3a9989,0x7528808e}},	//   _खोल्, _kwaa, _aftr, _aidz,
   {{0x78bc005f,0xca240d9e,0x442ceb40,0x6e2d0122}},	//   _forv, _афри, _bgd_, _mgab,
   {{0x6455499f,0xeb99dc59,0x6282a57a,0x8b958eef}},	//   nazi, зик_, _aboo, ерич,
   {{0x780d8cf0,0xa3ca8327,0x21278129,0x6d4d0c2e}},	//   _हरेक_, रैल_, _rinh_, _lwaa,
   {{0x21278104,0x6e2d1e98,0x2d4d027f,0x2901026f}},	//   _sinh_, _ngab, kže_, loha_,
   {{0x15f3b281,0x645536d0,0x68ef8511,0x6abd2f3e}},	//   _आखिर_, kazi, écdo, _mosf,
   {{0x6f041918,0x2d4d0fee,0xb4be0006,0x6e2d13b6}},	//   _skic, dže_, _आवे_, _agab,
   {{0x64556ac9,0x6d4d466a,0x2127801c,0x6609808e}},	//   dazi, _awaa, _vinh_, _hyek,
   {{0x6282846d,0x7ac488ed,0x61ea8061,0xa5bb0216}},	//   _gboo, _исче, ámlá, lcóy,
   {{0x67298063,0x21278028,0x6d59800b,0xe9ce9b47}},	//   _miej, _tinh_, nswa, _ск_,
   {{0x6d4d0cda,0xbebd81e2,0x6f1d64da,0x2b91826c}},	//   _dwaa, _siūl, amsc, _kšc_,
   {{0x62998f33,0x6abd0b80,0xdee62306,0x443a0037}},	//   _kawo, _bosf, _поки, _vfp_,
   {{0x78bc4e7c,0x629beb41,0x61e481ac,0x6729a19c}},	//   _sorv, nduo, _žili, _niej,
   {{0xe9da067c,0x64a66b42,0xdca61240,0x64551898}},	// [72a0] чка_, _запа, _запи, bazi,
   {{0x64550698,0xc05900e8,0x6299e6a7,0xdce281b9}},	//   cazi, дії_, _lawo, rroċ,
   {{0x6d4d0a0f,0x75288abf,0x9e66916b,0x66098234}},	//   _zwaa, _ridz, евед, _ayek,
   {{0x62998953,0xd0418201,0x20c980f7,0x481680be}},	//   _nawo, rhlə, _súil_, ײַבן_,
   {{0xe5a39285,0x442ce3cd,0xdd94853b,0x6594a5fc}},	//   лици, _pgd_, талы, талу,
   {{0x2480817f,0x6e3b838a,0x66098176,0xf99f0242}},	//   đimo_, _efub, _dyek, _myèl_,
   {{0x7ac68009,0x2ca7002a,0x6299eb43,0x752881a9}},	//   еспе, _ónde_, _bawo, _vidz,
   {{0x7528809a,0x645536d0,0xd25080f7,0x629b87cd}},	//   _widz, zazi, جنة_, gduo,
   {{0x6299b753,0x64556b44,0x4c86a714,0x6d598c93}},	//   _dawo, yazi, _плав, cswa,
   {{0xa3c2005e,0xeb9a89a5,0xbcfb1db6,0xd7fa8ce5}},	//   ्ना_, _низ_, trém, зум_,
   {{0xa3df0063,0x64551aae,0x6d4d01b0,0x2caceb45}},	//   _दें_, vazi, _swaa, _indd_,
   {{0x645511b7,0x56941af1,0x6299bfb0,0xf99f02d6}},	//   wazi, гают, _gawo, _byèl_,
   {{0x64556b46,0x7ae28aba,0x2918022b,0x6f1d0865}},	//   tazi, _imot, _ohra_, rmsc,
   {{0x7ae2803e,0x2d4d0042,0x6299809a,0xdce2826f}},	//   _hmot, rže_, _zawo, kroč,
   {{0x645527a1,0x6299801d,0xa73781a8,0x7b058118}},	//   razi, _yawo, _كثير_, cóus,
   {{0xdce28353,0x645567a2,0x291802f7,0x290ceb47}},	//   droč, sazi, _ahra_, llda_,
   {{0x6455499f,0xe9f80163,0x29016b48,0x69d682d0}},	// [72b0] pazi, енті_, toha_, _üyed,
   {{0x629b8084,0xe4e5909b,0x67299c28,0x657d6b49}},	//   zduo, _औषधि_, _siej, mtsh,
   {{0xec360051,0x660987cf,0x6d4088db,0xe81c150e}},	//   _באתר_, _syek, _atma, भेला_,
   {{0x6d59eb4a,0xf4120039,0x291802c4,0xb8c826ee}},	//   tswa, _כפי_, _ehra_, _खो_,
   {{0x9f5c8364,0x672985a4,0x657d005d,0x656f054a}},	//   _hyvä_, _viej, ntsh, nuch,
   {{0xdce2d792,0x6299ab5f,0x6d59cfa2,0xbcfb0144}},	//   broč, _sawo, rswa, mués,
   {{0x6d59eb4b,0x09c9816f,0x6299d941,0x6d40eb4c}},	//   sswa, िन्य, _pawo, _etma,
   {{0x656f2647,0xada680e1,0xeab180f7,0x290ceb4d}},	//   kuch, _slúž, شعب_, elda_,
   {{0x629b81e2,0x36d48009,0x3eadeb4e,0x656f019d}},	//   rduo, _сотр, _inet_, juch,
   {{0xa3d103b7,0x656f003e,0x3ebf8fb0,0x25a6007a}},	//   वना_, duch, _hout_, _šolo_,
   {{0x366a1511,0x644bb52c,0x3ebf86c0,0xf99f06c0}},	//   мано_, čnič, _kout_, _syèl_,
   {{0x656f6b4f,0xed5a2c38,0xdee60bc7,0xfe7201a8}},	//   fuch, мом_, томи, جدد_,
   {{0x316d82be,0x3eadeb50,0xf1d98035,0x3ebf8299}},	//   quez_, _mnet_, _बेचन, _mout_,
   {{0x7d0397bb,0x71d6807c,0x7ae28f28,0x31696b51}},	//   nons, _בונד_, _zmot, draz_,
   {{0xe7e1035a,0xe7b282e3,0x3eadeb52,0x6d400177}},	//   _गेला_, _نمود, _onet_, ímab,
   {{0xc3328bea,0x656f52b2,0x212a125b,0x657d1d14}},	//   שון_, buch, _sibh_, btsh,
   {{0x656f00ab,0x3b0701f3,0xeabf00ff,0x0eaf064a}},	// [72c0] cuch, тето_, _giùm_, टारड,
   {{0x07a605e9,0x7d0380e8,0x3ebf92b6,0xe0431777}},	//   казн, jons, _aout_, инуи,
   {{0x7d03b327,0x3ebf9b27,0x6d4082a6,0xa3df0b49}},	//   dons, _bout_, _stma, _देऊ_,
   {{0xcfa90013,0x316921d5,0xdd1101d0,0x3ebfeb53}},	//   عالم_, braz_, mýšl, _cout_,
   {{0x29078e3a,0x7d03d77c,0x3ebf83ec,0x6f0282ed}},	//   _okna_, fons, _dout_, rooc,
   {{0x7d03bf88,0x26c00118,0x7ae2a8fc,0x50435c30}},	//   gons, _loio_, _smot, _верб,
   {{0x3ebfdbdd,0xa3e803b7,0x7e0f01a2,0x656f686e}},	//   _fout_, _मेम_, _सर्ग_, zuch,
   {{0xb8650065,0xf8ca853f,0x49748073,0x3ebf9c25}},	//   _لاہو, िस्प, глис, _gout_,
   {{0x0d7783f8,0x6d408186,0xa3df243f,0xc8788214}},	//   _لینک_, _utma, _देई_, liği_,
   {{0x30a68750,0x52bf0e00,0x1be394df,0xa8a69baa}},	//   трив, _एक्स, _केवल_, трик,
   {{0x6458a5ed,0x08570039,0x656f6b54,0x443e9dd5}},	//   mavi, כבים_, wuch, _ift_,
   {{0x6458aed0,0xe24680f7,0xdce600eb,0x656f6b55}},	//   lavi, _شخصي, vukā, tuch,
   {{0x2002809a,0x443e8019,0xbcfb0019,0x28a68072}},	//   łki_, _kft_, nség, _कोथि,
   {{0x645899b8,0x656f45f2,0x657d6b56,0x315783de}},	//   navi, ruch, rtsh, _יידן_,
   {{0x68e881f2,0x656f0352,0x6d466b57,0x657d6b58}},	//   midd, such, apka, stsh,
   {{0x656f0870,0x63a527b1,0xc8788214,0x68e8eb59}},	//   puch, _vrhn, diği_, lidd,
   {{0x5a342386,0x3ebf8242,0x22494a85,0x7d03aeae}},	// [72d0] рнут, _rout_, rbak_, yons,
   {{0x64588b48,0x660d1c38,0x7d1a81a1,0x3ebf867f}},	//   javi, _iyak, _nhts, _sout_,
   {{0x7d03eb5a,0x3ebf8bfe,0x672d0c53,0x32d18091}},	//   vons, _pout_, _kiaj, _láya_,
   {{0xbcfb428b,0x248587d5,0x660d4087,0xadc4046d}},	//   dréi, _sblm_, _kyak, _abẹw,
   {{0x629d27e4,0xbcfb3ca8,0x3cf807d2,0x6d5d6b5b}},	//   _iaso, gség, _سعید_, nssa,
   {{0xb97a0051,0x6d5d6b5c,0x6458eb5d,0x629d0019}},	//   _אנשי, issa, gavi, _haso,
   {{0x3ebfeb5e,0x7d03ad73,0x629d486f,0x68e8e11f}},	//   _tout_, rons, _kaso, didd,
   {{0x629d3a74,0x81de80c8,0x7d03c926,0x672d3759}},	//   _jaso, _দুই_, sons, _niaj,
   {{0x7d03eb5f,0x660d3623,0x629d24f1,0x35f5a133}},	//   pons, _nyak, _maso, _спар,
   {{0x2ecc01cb,0x629d057b,0x68e88ec8,0x26c00118}},	//   ास्त, _laso, gidd, _soio_,
   {{0xd2518013,0x660d6196,0x28d995bc,0x26c003a8}},	//   _هنا_, _ayak, योगि, _poio_,
   {{0xc332804c,0x28b18074,0x656b8087,0x660d020c}},	//   _הוא_, जाहि, orgh, _byak,
   {{0x672d0812,0x01658a13,0x7ae980e1,0x68e8c577}},	//   _diaj, _скло, miet, bidd,
   {{0x7ae9a57b,0x515a8039,0x660d1061,0x6abb82d4}},	//   liet, _טכנו, _dyak, ljuf,
   {{0x629d2135,0xbea60a08,0xbcfb0019,0x2905aef3}},	//   _baso, _байк, zség, mola_,
   {{0xd00e8013,0x2905a9f0,0x7ae9eb60,0xe2972710}},	//   _علي_, lola_, niet, лас_,
   {{0x660d1fc5,0x6458eb61,0x3f8a0101,0x6da602ac}},	// [72e0] _gyak, yavi, _spbu_, _сипа,
   {{0x7ae9eb62,0xc8788214,0x317f811b,0x69c981b4}},	//   hiet, tiği_, ituz_, iyee,
   {{0x7ae9eb63,0x629d6b64,0x3f5180eb,0x2f190019}},	//   kiet, _faso, nšu_, sége_,
   {{0x629d0247,0xbcfb6b65,0x2905eb66,0x443ed454}},	//   _gaso, tség, hola_, _sft_,
   {{0x2905eb67,0x7ae9a798,0x69c981c0,0xbddb0866}},	//   kola_, diet, jyee, ccèd,
   {{0x629d58eb,0x2f158106,0x628401e8,0x75360144}},	//   _zaso, råga_, lfio, _muyz,
   {{0xbcfb0065,0xa3e4923a,0x929d809a,0x629d2fdd}},	//   sség, _पेश_, woła, _yaso,
   {{0xa3bc0665,0x645882d7,0x7e640010,0x7ae9cff6}},	//   _आपन_, savi, _ndip, giet,
   {{0x3f518029,0x6d4401e9,0x6da39860,0x62840114}},	//   ešu_, _ntia, _лита, ifio,
   {{0x7e64123c,0xb603826f,0xe97b00be,0x64588085}},	//   _adip, ýšen, עניש, qavi,
   {{0x7ae98920,0xbec280f1,0x2286e8f4,0x68e88e05}},	//   biet, _çësh, _булг, ridd,
   {{0x68e89e1a,0x7ae9b277,0x6d5d04fe,0xbcfb1a1f}},	//   sidd, ciet, tssa, isée,
   {{0x672d3b50,0x2905eb68,0x6d5d6b69,0x62fc0264}},	//   _viaj, bola_, ussa, ্ষায়_,
   {{0x290596cb,0x660d004f,0x629d1fdc,0x6722ea94}},	//   cola_, _vyak, _saso, hmoj,
   {{0xd5a48986,0xa3df101b,0x6d4402f9,0x629d06a4}},	//   _کہ_, _देख_, _etia, _paso,
   {{0x3d1a0105,0x63a88503,0x6d5d3f82,0x6b9b066f}},	//   _मीठे_, _mrdn, pssa, ługo,
   {{0xdcfb8025,0x085502c7,0x20180748,0x286b1715}},	// [72f0] _upuć, иваю, _azri_, ерео_,
   {{0x63a8aebd,0xe6c0803a,0x629d341a,0x7ae9811b}},	//   _ordn, _čišć, _waso, ziet,
   {{0x5f9509b5,0x629d6b6a,0x963592e9,0x7a2b82d0}},	//   риет, _taso, анец, _kötü,
   {{0xbcfb0036,0xa283003d,0x290583df,0x69c9eb6b}},	//   sséd, _دیرو, zola_, yyee,
   {{0x7ae99ffe,0xe80b800f,0x29058365,0x4e7892c8}},	//   viet, _सुना_, yola_, احمد_,
   {{0x64a5b38c,0x7ae9809a,0x690b002a,0x93459b2f}},	//   рака, wiet, güet, анке,
   {{0xe2999052,0x7ae9c9d4,0x273a80f1,0x39495660}},	//   вай_, tiet, _nën_, lpas_,
   {{0x05158a49,0x2bb68bb8,0x64573c6e,0x69db811e}},	//   াদের_, _अपरा, _lexi, tzue,
   {{0x2905eb32,0xe8f994b7,0x50b5bb17,0xc8b58d15}},	//   tola_, кли_, асну, асны,
   {{0x9f859269,0x273a80f1,0x69db816a,0x317f8102}},	//   агод, _bën_, rzue, rtuz_,
   {{0x7ae9dbbb,0x6d442167,0x25a9009c,0x63a880d2}},	//   piet, _stia, _aral_, _grdn,
   {{0x28d98054,0x2905b328,0x2d8d81bc,0x25a92461}},	//   योजि, sola_, _kpee_, _bral_,
   {{0x224d8573,0x20d580e8,0x66f200eb,0x25a90037}},	//   mbek_, _війс, nāki, _cral_,
   {{0xccf28158,0xc5f28039,0x20f4313a,0x2905eb6c}},	//   ַכן_, קדם_, _आदेश_, qola_,
   {{0x42562657,0xfbc30d9e,0x6b830106,0x395fa7a5}},	//   итат, обро, _ängl, lsus_,
   {{0x7a2b8182,0xaa465b5d,0x4a462597,0x3a3fd62f}},	//   _götü, реал, рнав, ncup_,
   {{0x7d0705f5,0xe2971182,0x00e61597,0x60c38bd6}},	// [7300] bojs, шат_, ажан, _konm,
   {{0x38c80416,0xf1bf04c3,0xe0d73fe7,0x61e6807b}},	//   داری_, _agás_, аву_, úkli,
   {{0x39491d7e,0x81cb8264,0xdb019b88,0x3ea06b6d}},	//   apas_, রছি_, _arlí, _kait_,
   {{0x4aca01fe,0x395fe5e9,0xaaca02f1,0xe5c69fb4}},	//   _रविव, ksus_, _रविक, исло,
   {{0x3a3f9b11,0x6722eb6e,0x224d81a1,0xbcfb00e7}},	//   dcup_, rmoj, dbek_, ssée,
   {{0xa29e800d,0x60c383ec,0xf366828b,0x3ea02b92}},	//   _खोज्, _nonm, атин, _lait_,
   {{0x316ddb48,0xbcfb0866,0xee3a961a,0x316022f8}},	//   erez_, prév, _анб_, lsiz_,
   {{0x645c3490,0x8f9b098a,0x22401495,0x2fc73a53}},	//   hari, _בילי, ncik_, änge_,
   {{0xee0aa155,0x31600457,0x66f200eb,0x63a8d579}},	//   _реал_, nsiz_, cāki, _wrdn,
   {{0x645c3a5c,0x60c382ba,0x28a69c4f,0xf48484c0}},	//   jari, _conm, _कोशि, _داری,
   {{0x645707f4,0x224003ac,0x26c48041,0x10370039}},	//   _rexi, kcik_, _komo_, יטים_,
   {{0x25a90205,0x28a6a23a,0x3160007e,0x3ea00219}},	//   _pral_, _कोरि, ksiz_, _cait_,
   {{0x25a69989,0xe5c423e7,0x316d8162,0x60c3eb6f}},	//   nvol_, осро, crez_, _fonm,
   {{0x645c0423,0x7d020307,0x26c4e4b5,0x60c382d6}},	//   gari, _íosl, _lomo_, _gonm,
   {{0x3ea006e3,0xa3bc035a,0xd0f580d4,0x7d07017f}},	//   _fait_, _आपण_, ीकरण_, rojs,
   {{0x5a3500b3,0x66e40073,0xdbdc816b,0x645c02f1}},	//   снат, _моја, jším, aari,
   {{0x765d4463,0x7afa0125,0x7c874b60,0xbcfb008b}},	// [7310] masy, étta, _куне, frét,
   {{0x44990153,0x765d0e7e,0x394928c6,0x3ea00102}},	//   _свою_, lasy, rpas_, _zait_,
   {{0x26c48db7,0x442704be,0x9295272e,0xfc46016b}},	//   _bomo_, _àn_, _ланц, číte_,
   {{0x26c48510,0x765d2ac5,0x61e9005c,0x39490687}},	//   _como_, nasy, _želu, ppas_,
   {{0x8c459a1a,0x6da5835f,0x395f811c,0xd05a8085}},	//   беле, сила, xsus_, sitə,
   {{0x316d82be,0x7c8782ff,0xbcfb00e7,0x64418122}},	//   vrez_, руде, crét, _qfli,
   {{0x765d0e87,0x3946eb70,0x6f0d6b71,0x22594955}},	//   kasy, _atos_, _okac, _kesk_,
   {{0x7aed511e,0x645c6b72,0x2139020f,0x395f8074}},	//   niat, zari, _kush_, tsus_,
   {{0x645c5531,0x20028059,0x3a3fe4da,0xf99180f7}},	//   yari, şkil_, rcup_, سبة_,
   {{0x14778c48,0x316de31b,0x6f0d4dd5,0x645c43f0}},	//   _خارج, rrez_, _akac, xari,
   {{0x395f82be,0x85048875,0x645c6966,0x3ea015d7}},	//   ssus_, _بولن, vari, _pait_,
   {{0x765d1f10,0xc4c901c6,0x31606b73,0x2b818035}},	//   gasy, _אג_, ysiz_, móc_,
   {{0x7d1e0af8,0x7aed0be5,0xa969813a,0x95830fe6}},	//   _phps, diat, _сила_, пляе,
   {{0x2d82173d,0x2ed4863a,0x60daeb74,0x22938019}},	//   rtke_, _दत्त, chtm, _دلچس,
   {{0x4adb8074,0x2d826b75,0x7af61be9,0x799d05ee}},	//   _बताव, stke_, tnyt, _assw,
   {{0x645c42b0,0x7aed6b76,0x7f3a8158,0x31606b77}},	//   sari, giat, _געקו, tsiz_,
   {{0x5d860013,0xe8fa2355,0xe80b83ca,0x39468122}},	// [7320] _الخل, гла_, _सुता_, _xtos_,
   {{0x3160080a,0x645c5128,0x7af6119b,0x26c4e8fb}},	//   rsiz_, qari, snyt, _somo_,
   {{0x4444004c,0xbbb68744,0x7aed0ab3,0xbcfb008b}},	//   _if_, _अपेक, biat, rrét,
   {{0x667680f7,0x7aed160c,0xe8e08028,0x673b00c3}},	//   إدار, ciat, _thủy_, _čujt,
   {{0x2cea825d,0x63f70fd3,0x21390db1,0xb33c8372}},	//   лько_, _نفیس_, _gush_, _irħi,
   {{0xc9530bea,0x765d0247,0x3ea0800d,0x6d56031d}},	//   _ממש_, zasy, žit_, _mwya,
   {{0x25a6a4c2,0x765d06c0,0xdbdc816b,0x0ec80075}},	//   svol_, yasy, pším, _लवंड,
   {{0x26c48098,0x6aa4243c,0x656f031d,0x3946816a}},	//   _uomo_, ndif, yrch, _ptos_,
   {{0x444467ac,0xc05a8221,0x765d3a9c,0x66f200eb}},	//   _of_, лін_, vasy, nāku,
   {{0x7aed6ac9,0xdd8f82e3,0x656f1c18,0x7afb007a}},	//   ziat, _سوم_, vrch, čuti,
   {{0x765d2046,0xa3e82303,0x48a78a14,0x60da83e4}},	//   tasy, _मेल_, стым_, rhtm,
   {{0x44444305,0x645ac292,0xe3b18065,0x60da8168}},	//   _af_, _heti, _کرے_, shtm,
   {{0x765d3a7f,0x645a8812,0x7aed1aae,0xd24f80f7}},	//   rasy, _keti, viat, _أنه_,
   {{0x98a38009,0x765d3971,0x897b8039,0x7aed0035}},	//   _ниче, sasy, _ערוצ, wiat,
   {{0x765d2588,0x2f120061,0x7aed4a2b,0xd00f81a8}},	//   pasy, zági_, tiat, _كله_,
   {{0x44446b78,0x645a877b,0x61ed943c,0xbcfb0019}},	//   _ef_, _leti, _žali, trés,
   {{0x6aa2804f,0x7984076d,0x1ef801a8,0x273e1d5e}},	// [7330] _maof, gtiw, _دعوة_, _aïn_,
   {{0x4aa90076,0x7aed6b79,0xb33c8197,0xa3abb850}},	//   _चोरव, siat, _erħi, खिम_,
   {{0x661b8063,0x7aed4cc8,0x2d921ba4,0x629637ac}},	//   _szuk, piat, čneš_, beyo,
   {{0xbcfb02be,0x645a8706,0xe8b586ab,0x6aa28174}},	//   prés, _aeti, _अच्च, _naof,
   {{0x645ab665,0x2bd10074,0x356bb02b,0x7afd0bfd}},	//   _beti, सनका, урен_, _ijst,
   {{0xa3e801ce,0x1b498d70,0x2489825b,0xf99f6b7a}},	//   _मेँ_, азки_, đamo_, _dyèt_,
   {{0x2f120019,0xc7c40790,0xdb09816b,0xfd108199}},	//   sági_, _ести, žníc, رجه_,
   {{0xa3bc0105,0xcf9204de,0x6d4b804a,0x66f201a9}},	//   _आपस_, _קטן_, ppga, nākt,
   {{0x69d687d9,0xe0d994b7,0x7e6981bc,0x661beb7b}},	//   _üyel, иви_, _idep, _uzuk,
   {{0xe6c5005c,0x645aeb7c,0x1f65968a,0x6d49851e}},	//   _češć, _geti, оком, _itea,
   {{0xa3e80403,0xdbf2000d,0x69100006,0xb8d190d0}},	//   _में_, _příp, päev, _ऑफ_,
   {{0x753b8010,0x60c70bd6,0x823480d7,0xd62a02de}},	//   _kuuz, _lojm, _فرها, ионе_,
   {{0x645a8182,0x69cb013c,0xdd0e861c,0x753b85ee}},	//   _yeti, øgel, nışl, _juuz,
   {{0x7afd026c,0x394dbb7c,0x753bdc86,0xf77180d7}},	//   _ajst, mpes_, _muuz, _قاب_,
   {{0xda5a1182,0x62960242,0xf99f313c,0x44441532}},	//   ираш_, teyo, _asè_, _vf_,
   {{0x7d0a80d2,0x25b506a5,0x8c3c83bf,0x225f89d1}},	//   zofs, ñaló_, _mağa, nauk_,
   {{0x02ca0a74,0x62965ba7,0xe0df06c0,0x44441532}},	// [7340] _रवीन, reyo, _pwòp_, _tf_,
   {{0x78a3eb7d,0x26c2003a,0x0ef4eb7e,0x394dd568}},	//   _janv, ljko_, ेक्स_, ipes_,
   {{0xee3ace78,0x79846a2b,0x66f20029,0x60c72bf8}},	//   ане_, stiw, sāku, _dojm,
   {{0x268a8307,0x645a9a67,0x2fc7016d,0x78a39f1b}},	//   شخصي_, _seti, änga_, _lanv,
   {{0x645aaab9,0x659680f7,0x226501d0,0xba480084}},	//   _peti, تجار, řský_, grįž,
   {{0x53348729,0x6d4980f7,0x7e698135,0x6562ad68}},	//   пект, _dtea, _edep, rsoh,
   {{0xdfd20013,0x39400239,0xf4878fd3,0x645aeb7f}},	//   _غير_, lqis_, تانی, _veti,
   {{0x78a3a40d,0x249800f3,0x7d0a826c,0x25a00118}},	//   _aanv, herm_, sofs, _osil_,
   {{0x645abffc,0x78a3b194,0x673c0198,0x2c110074}},	//   _teti, _banv, _hurj, _दुनू_,
   {{0x23650353,0x2a600069,0x673c27a5,0x320f0019}},	//   šlji_, haib_, _kurj, ügyi_,
   {{0x4a468dbd,0x2a668098,0x25a029c5,0xd7fa82df}},	//   _днев, _дълг, _asil_, руп_,
   {{0x3ea6c51c,0xfd57846d,0xd6d9066f,0xb3578061}},	//   ndot_, _alaṣ, ół_, _بیٹا_,
   {{0x2d86867f,0xdb0181a8,0xc33381c6,0xda1e908a}},	//   ntoe_, _urlá, _חוף_, _परित_,
   {{0x3ea68198,0xd12f81e2,0xe57180be,0x98a78162}},	//   hdot_, _іх_, ײַך_, _vină_,
   {{0xd25b2748,0x92c712c0,0x66fc9911,0xac190eef}},	//   ица_, ощад, jčko, сову_,
   {{0xa3ab8f12,0x290ca876,0x7a390071,0xda1e8075}},	//   खित_, loda_, спар_, _परात_,
   {{0x497517d4,0x60c710d1,0x78a38085,0xdd0e811c}},	// [7350] ялас, _pojm, _yanv, xışl,
   {{0x7e7d128d,0x37ab098d,0xa9bb01a2,0xd2500019}},	//   lgsp, итен_, _ईपीए, ٹنے_,
   {{0x2a600359,0x765b808e,0xf99f06c0,0x6d49da51}},	//   baib_, _peuy, _pyès_, _stea,
   {{0x41ca95fb,0x7e7d1277,0x59ca8054,0x539a02f6}},	//   िहास, ngsp, िहार, _פירו,
   {{0xdd9b804a,0x290c8816,0x64a10609,0x8c3c8380}},	//   рше_, koda_, _eġiż, _sağa,
   {{0xdd0e8085,0x03a5af2f,0x673c02a6,0x7a412294}},	//   rışl, зико, _furj, _fátó,
   {{0x60080a14,0x290c805d,0x673c6b80,0x54580039}},	//   _днём_, doda_, _gurj, חסון_,
   {{0xc7b2004c,0x78a3eb81,0x93fc0039,0x6d4980b9}},	//   _אבל_, _sanv, ילוי, _ttea,
   {{0x394d80e7,0x7bd88754,0xf4878a4c,0xd49b81ae}},	//   upes_, _čauš, _мужн, _вре_,
   {{0x395902d5,0xdea38019,0xedb48290,0xae2080c2}},	//   _mwss_, _ریڈی, _تحفظ, _बरतन_,
   {{0x9f450009,0xb5fda7aa,0x78a3a419,0x26c900fc}},	//   _älä_, _odšk, _vanv, _boao_,
   {{0xfaff0b18,0xa3e485e8,0x394de5e9,0x61ed87dd}},	//   _një_, _पेट_, ppes_, _žalu,
   {{0x290c83c3,0xbcfb016a,0xbddb1b01,0xf1a7b6ab}},	//   boda_, trép, scèn, _френ,
   {{0x6cd60013,0x7afbeb82,0x386101ec,0x290cd100}},	//   أقسا, lnut, jahr_, coda_,
   {{0xd141866f,0xf65f0646,0x00000000,0x00000000}},	//   snąć_, rkær_, --, --,
   {{0x39461570,0xb1461263,0x32d1826b,0x7afbe92c}},	//   знаг, знал, _báyi_, nnut,
   {{0x3ea4806a,0x25a011ee,0x386101ec,0x867b01c6}},	// [7360] _ramt_, _usil_, fahr_, _הרפו,
   {{0xe9d72344,0x3ea493c2,0x7afb9dc1,0x673c07b8}},	//   чку_, _samt_, hnut, _purj,
   {{0x7afb98a6,0x645e00eb,0x98aa0162,0x443a6b83}},	//   knut, _iepi, _aibă_, _igp_,
   {{0x290c9351,0xfaff00f1,0x59db82f1,0x645e02d0}},	//   zoda_, _gjë_, यनार, _hepi,
   {{0x7afb803e,0xa3e4a076,0x3ea6d64f,0x1ea980f7}},	//   dnut, _पेज_, rdot_, تالي_,
   {{0x645e06a4,0x2d868cfa,0xeaf68aed,0x5fcb92c6}},	//   _jepi, rtoe_, ुक्त_, ाहाल,
   {{0x290c803b,0x2d868a53,0xbc6781a8,0x443a226d}},	//   voda_, stoe_, سمين_, _mgp_,
   {{0x645e30e6,0x7afb803a,0x290ceb84,0xbea392e9}},	//   _lepi, gnut, woda_, _паск,
   {{0x61e46b85,0x2ca5813c,0x7d0e2a4f,0xfe208074}},	//   nzil, _fald_, kobs, _बरिस_,
   {{0x81ae0a49,0x645e3761,0xf98f80a0,0x2ed500c2}},	//   _কথা_, _nepi, ابي_, दस्त,
   {{0xb4d88fe4,0x3f638009,0xa3e48beb,0x7c3a8122}},	//   ासी_, нтяб, _पेच_, _igtr,
   {{0xd6db067c,0x290ceb86,0x7e62804f,0x7afb8140}},	//   сто_, soda_, naop, cnut,
   {{0x290ca17b,0x628281ed,0x7e7d18a1,0x690f8366}},	//   poda_, _icoo, rgsp, røer,
   {{0x293780be,0x248d0668,0x645e6b87,0xdcef0087}},	//   _זאגן_, đemo_, _cepi, ducă,
   {{0x645e2823,0x9b580087,0x7e629ae3,0x6aa6555c}},	//   _depi, зист_, kaop, _bakf,
   {{0x38178bea,0x60cab19c,0x68ee0722,0x443a4f3a}},	//   _מקום_, _hofm, _ambd, _egp_,
   {{0xa2ce064a,0x7e6d1312,0x3ced809a,0x69c08122}},	// [7370] _सवर्, _idap, _अगले_, nxme,
   {{0x6d4d38dc,0x6f0f047f,0x7d0e04dc,0x645e1e5b}},	//   _itaa, locc, cobs, _gepi,
   {{0x6aa6008e,0xdb08816a,0xee4a819d,0xf79901f9}},	//   _fakf, _ardí, _ịdịn, تناب_,
   {{0x6f0f047f,0xfaff00f1,0xf40300ab,0x7e62802a}},	//   nocc, _ujë_, _এরপর_, gaop,
   {{0xdca5a28e,0x64a589f7,0x64d1016f,0xa2c08f1b}},	//   дали, дала, _सकाळ, वान्,
   {{0x6d4d004f,0xe8d90133,0x71d60e82,0x777a9fa4}},	//   _mtaa, ftụ_, _חושד_, kutx,
   {{0x7afb9ee0,0xb0b080d4,0x78698061,0x2ca597ab}},	//   tnut, जयनग, _jövő, _vald_,
   {{0xe9d98607,0x612200e7,0x7e6d6b88,0x2ca5ce3b}},	//   жки_, rôle, _ndap, _wald_,
   {{0xc69283c8,0xc8c880d4,0x6e3b8420,0x3f418580}},	//   _באן_, ाउंट, _igub, _sóu_,
   {{0x672400f1,0x6f19831d,0xbddb0866,0x65698db1}},	//   _shij, llwc, rcèl, _iveh,
   {{0x645e6b89,0x6d4d3d8b,0x7afb803e,0x61e40c9f}},	//   _repi, _ataa, pnut, zzil,
   {{0x645e003d,0x443a0ae6,0x3f678279,0x0378804e}},	//   _sepi, _sgp_, rđu_, _رحمت_,
   {{0x186998a0,0xa0698f27,0xb33c8197,0x6e3b912e}},	//   _дали_, _дала_, _isħa, _mgub,
   {{0x78a70b48,0xee3701e2,0x79898a53,0x7e6d09c4}},	//   _najv, ьня_, mtew, _edap,
   {{0xa3e80076,0xdc4581e2,0x7d0e37e4,0x6f0f01e8}},	//   _मेख_, jūči, robs, bocc,
   {{0x7b3c05f5,0x66046b8a,0x2a7fa676,0xdce40390}},	//   _očuv, _txik, ngub_, _ivič,
   {{0x8c3c8a0b,0x7989eb8b,0x6aa61238,0x2bba0c9a}},	// [7380] _bağl, ntew, _vakf, _उपका,
   {{0xddc40087,0x7649dd3f,0xe6c98bcf,0x6aa66b8c}},	//   _ediţ, _afey, _čašć, _wakf,
   {{0x8c3c87c0,0x28c40540,0x130a0d15,0x6aa612cf}},	//   _dağl, लॉगि, _мной_, _takf,
   {{0xe61a8895,0xf42a0009,0x61e41d5e,0x7e6d00ee}},	//   оде_, _enää_, pzil, _xdap,
   {{0xdd908bca,0x6aa98080,0x83fc8699,0xfce6c5a5}},	//   اوت_, ddef, _međe, модо,
   {{0xb4d88076,0x6e3bb6d0,0xa533804a,0x7e6287b6}},	//   ासे_, _egub, вніч, saop,
   {{0xf76789d7,0x7791015b,0x7e6282c4,0xbb4795a9}},	//   _جا_, _میلا, paop, ولون_,
   {{0xf96a8198,0x291a0144,0xff24cf77,0x416a82ee}},	//   орой_, llpa_, _سبزی, ојом_,
   {{0xcb130039,0x6d5b819d,0x26c682f7,0x8c3c807e}},	//   כלה_, _gwua, mjoo_, _yağl,
   {{0x6e3b9ce9,0x41bb00be,0xba3b07f1,0x7b1303ed}},	//   _zgub, קציע, _raïm, nçur,
   {{0x6d4d33fc,0x7e60ac17,0xdce4026f,0xd838a368}},	//   _staa, _kemp, _cvič, ječe_,
   {{0x6d40b71b,0x7e608455,0xb8d586ae,0x25a4ba92}},	//   _kuma, _jemp, _चो_, _ksml_,
   {{0x7e60845c,0x6d40bf6c,0x94190085,0xbcfb0866}},	//   _memp, _juma, əyən_, ssém,
   {{0x6d40b6ed,0x7e60a63b,0x6f0f047f,0x777aa5d5}},	//   _muma, _lemp, socc, putx,
   {{0x3d16823c,0x6d40ab7c,0xbbc9000d,0x78a708ae}},	//   _पीछे_, _luma, रहेक, _rajv,
   {{0x8c3c8afe,0x7e60e064,0x6d40eb8d,0x3e880e06}},	//   _sağl, _nemp, _ouma, rító_,
   {{0x6d40eb8e,0x26d901e2,0xeabf00ff,0xb5fd8dcc}},	// [7390] _numa, ūros_, _chùa_, _keše,
   {{0x657d09ae,0x3ea9074c,0x7e60aeaa,0xf0fb20e9}},	//   mush, _haat_, _aemp, ्वेद_,
   {{0x657d5bee,0x7e60eb8f,0x6d406950,0x8c4403a7}},	//   lush, _bemp, ímav, _шеќе,
   {{0x6d40e6ec,0x7e60cfb4,0xa3e80beb,0xb5fd8450}},	//   _buma, _cemp, _मेट_, _leše,
   {{0x6d40eb90,0x5067028b,0x3ea9038e,0x657d10fa}},	//   _cuma, _отва, _maat_, nush,
   {{0x20182320,0x3ea9240d,0x6d40eb91,0xa3ab873c}},	//   _fyri_, _laat_, _duma, खिल_,
   {{0xeb91826a,0x657d364e,0xd6e00035,0x6d40eb92}},	//   اظت_, hush, ółki_, _euma,
   {{0x657d005d,0x7e60859c,0x32190009,0x3ea93da9}},	//   kush, _gemp, _kysy_, _naat_,
   {{0x6d40bbd5,0x7afa0125,0x6aa9848d,0x7d049b88}},	//   _guma, étti, rdef, éisc,
   {{0x7e60eb93,0x657d471c,0x47c58009,0x629b8114}},	//   _zemp, dush, ебов, seuo,
   {{0x32558aca,0x6d40eb94,0x79898a15,0x81e780ab}},	//   _звер, _zuma, stew, _মুখ_,
   {{0x6d40cfbf,0x2249026c,0x657d390d,0xe0bf8264}},	//   _yuma, jcak_, fush, ইসেন,
   {{0x6d408079,0x657d150f,0x58d584fa,0x5d670198}},	//   _xuma, gush, _подт, ниям_,
   {{0x332deb95,0x26d903ed,0x09f681c6,0x98a2bcb3}},	//   lmex_, ëror_, _אמנם_, _бише,
   {{0x69cb1d31,0xd838cb1f,0x232a0be2,0x141a01a8}},	//   ägen, teče_, зови_, سيرة_,
   {{0x3ea90613,0x657d6b96,0x8c3c8214,0x2fd8928d}},	//   _gaat_, bush, _rağm, ørge_,
   {{0xc3329a0f,0x7e60bab9,0x8c460dc0,0xa2c08b84}},	// [73a0] רון_, _remp, _пепе, वात्,
   {{0x7e60eb97,0x6d4094ff,0x7e666b98,0x7d5703de}},	//   _semp, _ruma, lakp, _רייד_,
   {{0x6d40eb99,0x7e60903b,0x7c3e0122,0x7d1c00b9}},	//   _suma, _pemp, _igpr, mlrs,
   {{0x040b0104,0x6d40dd84,0x8c1580ab,0x28c4064a}},	//   _lượn, _puma, াধান_, लॉजि,
   {{0x683408ae,0x6d40bdd5,0x7ae4311a,0x13d50264}},	//   dždž, _quma, mhit, _হইয়,
   {{0xdb0501ec,0x66df0168,0x5ba68425,0x49180327}},	//   _erhä, _mëka, ериз, _बीचो_,
   {{0xb5fd979d,0x910310ca,0x969680a9,0x2f190019}},	//   _reše, _спре, _праш, ségi_,
   {{0x6d40ad80,0x6b83016d,0x657d0314,0xada6a21f}},	//   _tuma, _ånge, yush, _пабл,
   {{0x6d40c000,0x7e660359,0xdee3be3d,0x66e3814c}},	//   _uuma, dakp, _соти, _сота,
   {{0x3ea96b9a,0xc05785a8,0x63b7823e,0xbcfb0061}},	//   _saat_, нію_, çanè, rsék,
   {{0x443eeb9b,0x273a8084,0x60ce0122,0x7ae413fa}},	//   _igt_, _būna_, _mobm, khit,
   {{0x753a811e,0x09e68003,0x657d365d,0x6e2405ee}},	//   _hitz, _поен, tush, _bzib,
   {{0xe9738077,0x1af780be,0x7ae46b9c,0xc2e9866e}},	//   _مهند, _אמאל_, dhit, _تعلم_,
   {{0x657d2e3f,0x3ea92525,0x6e24026c,0x2edd8f1b}},	//   rush, _waat_, _dzib, _मत्त,
   {{0x3ea9178f,0x25bf002e,0x6e240316,0xad1b8039}},	//   _taat_, ţul_, _ezib, פולר,
   {{0x41e71ae5,0x3da70112,0x753a8102,0x657d4f80}},	//   ніза, _зроб, _litz, push,
   {{0x22490573,0x5a351354,0x6e240af8,0xfc300061}},	// [73b0] rcak_, тнат, _gzib, لحہ_,
   {{0x2bba000c,0x394f0029,0xf8070f16,0x6f1d2e76}},	//   _उपचा, īgs_, нчен, llsc,
   {{0xc10401a8,0x7ae401f6,0x6e2405ee,0x2ae7826b}},	//   دولي, bhit, _zzib, _lákọ_,
   {{0x443e867f,0x753a8102,0x7ae43f47,0xb1841e1e}},	//   _agt_, _aitz, chit, šťas,
   {{0x443e8072,0x6da59775,0xada58150,0x753a8c45}},	//   _bgt_, тила, талл, _bitz,
   {{0xd378003a,0xeb999d32,0x443ecb23,0x3ea9b6f0}},	//   šće_, дик_, _cgt_, žat_,
   {{0xa3c30074,0xc1c9801b,0x753a8102,0x443e816a}},	//   ्हि_, ाङ्ग, _ditz, _dgt_,
   {{0x3942008e,0x443e8bfd,0x9f348163,0x753a8f3e}},	//   _yuks_, _egt_, _бесі, _eitz,
   {{0xceb2878d,0x798d2949,0x443e802a,0x2360817f}},	//   _דין_, ntaw, _fgt_, ćija_,
   {{0xa3c30576,0x24858144,0x2ae7826b,0x76598114}},	//   ्हा_, _uclm_, _dákọ_, lbwy,
   {{0x661bc7d0,0x672981c0,0xe80b903e,0x29010187}},	//   _hyuk, _khej, _सुखा_, inha_,
   {{0x92eb92dc,0x753a8102,0x798d177c,0x6134011c}},	//   _عراق_, _zitz, ktaw, rülə,
   {{0x040b0028,0x6aad3efd,0xfdc000ab,0x09d600ab}},	//   _tượn, ddaf, উন্ড, _সেনা,
   {{0xe9d88112,0x6aaba51d,0x661b8deb,0x764d112e}},	//   _які_, _hagf, _myuk, _efay,
   {{0x2d9e026f,0x7ae40199,0x398b8aa2,0x5f060081}},	//   ňte_, thit, løs_, _изка,
   {{0x06f60077,0x69c40102,0x6f0402f7,0xe297309d}},	//   _جستج, txie, _ujic, кас_,
   {{0x61e9a48d,0x261904e5,0x7ae40744,0xf2d280be}},	// [73c0] nzel, _युपी_, rhit, בען_,
   {{0x7d7b0bea,0x7ae43a2f,0xbebb0168,0x9ffa01ad}},	//   _קניו, shit, smët, وراء_,
   {{0x7ae45589,0xcc770039,0x7f43823e,0xdd1c80e1}},	//   phit, _בעיה_, _junq, _nášh,
   {{0x753a82af,0x798d3f73,0x6d440c53,0xcf9283de}},	//   _sitz, btaw, _kuia, שטא_,
   {{0xa2c08bb8,0x673b8458,0x753aeb9d,0x61e981ed}},	//   वास्, _diuj, _pitz, jzel,
   {{0x7e646004,0xd90d0065,0x2b5e8748,0x62840037}},	//   _leip, _ٹیم_, _pwtc_, lgio,
   {{0x6609eb9e,0x443e80ff,0x61e98bfd,0xb5fd8824}},	//   _exek, _vgt_, ezel, _pešc,
   {{0xbcfb6b9f,0x78aa8267,0xbebb0168,0x753a8192}},	//   rséi, _safv, hmër, _witz,
   {{0x7f438c15,0x6da38002,0xbd8a8077,0x6aabc6be}},	//   _aunq, _кита, _زنان_, _dagf,
   {{0x753a8a0f,0x6729baa8,0x443ebe06,0xbebb0168}},	//   _uitz, _zhej, _ugt_, jmër,
   {{0x04439980,0x47350d5f,0x7f4381df,0x03a3835f}},	//   _техн, лнос, _cunq, _вихо,
   {{0x2cac9a49,0x7f438081,0x73369e91,0x7e6408f1}},	//   _hadd_, _dunq, _شرائ, _ceip,
   {{0x2918056c,0xe8948e02,0xd90e8065,0x6d44041c}},	//   _okra_, _баль, _ویب_, _cuia,
   {{0x6fb487bd,0x40a8853d,0x291800ee,0x79808e8c}},	//   _ممتا, _سختی_, _nkra_, mumw,
   {{0xa3abbb04,0xb5fd895e,0x629f0085,0xac181bb1}},	//   खिए_, _meša, teqo, вору_,
   {{0x62840698,0x291ebffd,0x3863006a,0x798d607c}},	//   ggio, llta_, _sejr_, ttaw,
   {{0x6f028023,0x6aad09ca,0x533453bf,0x291ee4e3}},	// [73d0] dnoc, rdaf, ретт, olta_,
   {{0x798d6ba0,0x273b0110,0x661b89c4,0x7ae2e7f1}},	//   rtaw, _kūno_, _ryuk, _llot,
   {{0x798d6ba1,0x661b859c,0x0675a15c,0x61e9eba2}},	//   staw, _syuk, гуля, zzel,
   {{0xf7700c2a,0x8f148221,0xcf9380be,0x201c83ac}},	//   زام_, афіч, יטע_, _myvi_,
   {{0x442583ec,0xa4d580e8,0x83fc8088,0x356b8087}},	//   _szl_, лоді, _ređa, френ_,
   {{0xd0068013,0x057480f7,0xa2db001b,0x6aabeba3}},	//   _هل_, شاهد, नसक्, _sagf,
   {{0xeb99a9c9,0xb5fd8efd,0x7ae2b03e,0xf4848a67}},	//   хий_, _deša, _blot, ручн,
   {{0x61e98a11,0xdd1c81ac,0xd1858a0e,0x6f02c3ca}},	//   tzel, _vášh, глий, cnoc,
   {{0x61fb050b,0xa91d81d0,0x3f814584,0xd83882d4}},	//   _žulj, huže, luhu_, veča_,
   {{0x7e644a30,0x61e9e86e,0xdce98824,0xbc5695d8}},	//   _seip, rzel, _kveč, čšíc,
   {{0x7ae2eba4,0x25a90587,0x6441eba5,0xa91d817f}},	//   _flot, _asal_, _igli, juže,
   {{0xa91d803b,0x291ea130,0xa68304fa,0x61e98061}},	//   duže, alta_, блюд, pzel,
   {{0xa2c09a46,0x3f811a7b,0xd12e803d,0xd838890c}},	//   वार्, huhu_, تمی_, reča_,
   {{0xd83882d4,0x717280d7,0x7cf4011c,0xdce9b732}},	//   seča_, _اهوا, _kürə, _oveč,
   {{0x3bd50009,0x75ea8019,0xe29a06e6,0x7e645c28}},	//   аютс, _közé, нав_, _teip,
   {{0x425505fa,0xe7f9073c,0xef1f0085,0x3f8101b4}},	//   итут, ्पना_, clü_, duhu_,
   {{0x612b0019,0xf2d280be,0xb2260b79,0x316dd2c5}},	// [73e0] küld, זען_, умал, nsez_,
   {{0x6441803d,0x3ea24ddb,0x26d26ba6,0x63b70144}},	//   _ngli, lekt_, _hoyo_, _frxn,
   {{0x2a692c54,0xb5fd9432,0x645c079a,0x26d26ba7}},	//   baab_, _reša, mbri, _koyo_,
   {{0xa3c31d01,0x645c6ba8,0x6441a117,0x26d21cfe}},	//   ्हर_, lbri, _agli, _joyo_,
   {{0xb5fdac08,0x26d20010,0x3ead8358,0x2d826ba9}},	//   _peša, _moyo_, _daet_, nuke_,
   {{0x50432133,0x3f8116f2,0x291e0019,0xd9b2064a}},	//   _герб, buhu_, _óta_, ीमीट,
   {{0xb5fd9c78,0x2d8f8722,0x645c01a8,0x7ae2b3fe}},	//   _veša, atge_, ibri, _plot,
   {{0x7980823d,0x5fbb0039,0xe73795d1,0x6441ebaa}},	//   tumw, _אצלנ, _бес_, _egli,
   {{0xb5fd8858,0xdce99b39,0xa91d9f3a,0x3ea2412d}},	//   _teša, _zveč, dužb, dekt_,
   {{0x26c002f7,0xc7af0065,0x2d826064,0x78a1ad00}},	//   _anio_, _بڑے_, duke_, gelv,
   {{0xba3b21bf,0x645c6bab,0x26d20f33,0xc91701c6}},	//   _haït, dbri, _boyo_, רחית_,
   {{0x7c2582af,0x7ae2ebac,0xc9868087,0x5186a2f0}},	//   ühre, _ulot, _буки, _бука,
   {{0xef1f0214,0x612b0285,0x78a1ebad,0xb5fd8968}},	//   rlü_, lüle, belv, _lešn,
   {{0xa3c30076,0xa91d8067,0x1fa68c9d,0x26c06bae}},	//   ्हल_, tuže, _бриг, _enio_,
   {{0xe8140576,0x612b1238,0x241914ef,0xac191515}},	//   _तुला_, nüle, товы_, тову_,
   {{0x32551444,0xddc0801b,0x4a550ca0,0x2d822bd7}},	//   рвар, _nemů, ркас, buke_,
   {{0x645c235a,0xdce9c24d,0x39468110,0x50f52386}},	// [73f0] bbri, _sveč, _juos_, азат,
   {{0xd37805f5,0x270d80d4,0x656f4964,0x0f0d83b6}},	//   šća_, िक्र_, msch, िक्स_,
   {{0x92952749,0x656f0e83,0x33200580,0x351c01c6}},	//   _канц, lsch, blix_, _אוזנ,
   {{0x8aa7181d,0x7d1a8074,0x35b5824f,0x3f816baf}},	//   _срод, _akts, ибер, ruhu_,
   {{0x656f6bb0,0x7c289087,0x298b0d70,0x7cf40085}},	//   nsch, _azdr, _ясно_, _sürə,
   {{0x2ee201cb,0x88bc801b,0x656f583a,0x61ed01f6}},	//   _पत्त, změr, isch, mzal,
   {{0xdce9b4c1,0x656f01ec,0x25fc06a7,0xa2dc0816}},	//   _uveč, hsch, _लेनी_, _नवम्,
   {{0x645c0669,0x656f5ec1,0xc245c168,0x61ed2aa0}},	//   zbri, ksch, шник, ozal,
   {{0x9c879168,0x61ed43b5,0xa48780f7,0x6aaf0229}},	//   _مشاه, nzal, _مجان, _macf,
   {{0xe0d9872f,0x656f3d2a,0xf77180f7,0x644181e0}},	//   тво_, dsch, ياج_, _ugli,
   {{0xa91d8067,0x316d82be,0x672d0e35,0x26d200ee}},	//   tužb, ssez_, _bhaj, _poyo_,
   {{0x672d4e70,0x645c151e,0x7e6b96fb,0x2d820074}},	//   _chaj, wbri, nagp, tuke_,
   {{0x6b83a2bb,0x3ea212d2,0x7ae98448,0xb5fd8bda}},	//   lung, rekt_, mhet, _mešo,
   {{0x2d820d11,0x7ae9a660,0xed57002e,0x28c90a0d}},	//   ruke_, lhet, рор_, राफि,
   {{0x6b83979b,0x660d0004,0x2d823553,0x7f470282}},	//   nung, _exak, suke_, _nujq,
   {{0x7ae98711,0x2d8269e5,0x645c05f8,0x656f01ec}},	//   nhet, puke_, sbri, bsch,

   {{0x6b838a5a,0xe9d70767,0x786610ca,0xfd4e81bc}},	// [7400] hung, акт_, иказ, _dakọ,
   {{0x6b839281,0x205622f0,0x6d562c01,0x7f470168}},	//   kung, ртар, _itya, _bujq,
   {{0x44440747,0x6299ebb1,0x6b8381e2,0x7ae9805d}},	//   _ig_, _obwo, jung, khet,
   {{0x6b8389ed,0x5a960003,0xfd4e819d,0x656400b4}},	//   dung, _троф, _gakọ, _kwih,
   {{0x6f09830b,0x7ae9ebb2,0x7ceb02af,0x69c98282}},	//   _djec, dhet, _dürf, jxee,
   {{0x6b838a8c,0x6f0985a4,0x6e29826c,0xb5fd8754}},	//   fung, _ejec, _dzeb, _tešn,
   {{0x6b83ebb3,0x444445e3,0x39468176,0x7afb8081}},	//   gung, _mg_, _suos_, fiut,
   {{0x7ae9904d,0x612b60e3,0xa31088fd,0x7c288353}},	//   ghet, rüle, ावेज_, _vzdr,
   {{0x444415f8,0xe1ff02ba,0xc05a8a4c,0x612b45ea}},	//   _og_, _león_, кін_, süle,
   {{0x44446bb4,0x6b838859,0x0cc100c8,0x8c4398ba}},	//   _ng_, bung, _উত্ত, _дефе,
   {{0x7d18816b,0x6b8380b4,0x61ed499f,0x7afb9c28}},	//   movs, cung, zzal, biut,
   {{0x44440a1c,0x656f6039,0x7ae99eed,0x7afb9f50}},	//   _ag_, tsch, chet, ciut,
   {{0x44442dbe,0xd9549125,0x2369812b,0xca9784de}},	//   _bg_, _انتخ, ćaje_, _כדאי_,
   {{0x656f1736,0x44443915,0xdb0d8009,0x3990823e}},	//   rsch, _cg_, äköi, màs_,
   {{0x656f2644,0x44446bb5,0x7f848013,0x67228084}},	//   ssch, _dg_, _العن, kloj,
   {{0x4444240f,0xd2580604,0x083b8051,0x61ed0102}},	//   _eg_, ицу_, _בעול, tzal,
   {{0x6b83a479,0xa91debb6,0x90991cc7,0x6f0985f3}},	// [7410] zung, luža, лват_, _rjec,
   {{0x261a8740,0x6f09920e,0x6b838b5e,0x7ae98019}},	//   _बड़ी_, _sjec, yung, zhet,
   {{0xba3b6bb7,0x2ba6836d,0x7e6b809c,0x64456bb8}},	//   _païs, _कैला, tagp, _ighi,
   {{0x44444573,0x7ceb01ec,0x7ae98168,0x6b83b08f}},	//   _zg_, _bürg, xhet, vung,
   {{0x4444045c,0x6b83a290,0x6f09ebb9,0xb5fd8b67}},	//   _yg_, wung, _vjec, _vešo,
   {{0x588401e5,0xb4e18035,0x2fc70106,0x7d18ad6d}},	//   _мыса, दसे_, ängs_, govs,
   {{0x7ae9ebba,0xe299ebbb,0x7e6b9049,0xbcfb00e7}},	//   thet, гай_, pagp, nséq,
   {{0x9f058591,0x6f1b8234,0xa91d825b,0x69c9811b}},	//   _اورو, _ukuc, duža, txee,
   {{0x60d517aa,0x7ae9b43f,0x7afbebbc,0xdce9816b}},	//   _kozm, rhet, riut, _uveď,
   {{0x6b83cef1,0x64450104,0x1c1ba30f,0xdce400c3}},	//   pung, _nghi, _पुथल_, _ivić,
   {{0x7ae98234,0x69c69a50,0x6d41820d,0x7d07026c}},	//   phet, äker, _iila, dnjs,
   {{0xed5a3aa3,0x6d41d9c8,0x6717a0f2,0x629982a0}},	//   лом_, _hila, तविक_, _ubwo,
   {{0x6d41a34d,0x6d4b03d3,0x225f8458,0x249a00b9}},	//   _kila, _égal, mbuk_, _pbpm_,
   {{0x3a368039,0x7bdc1ba1,0xe1ff2509,0xdff90035}},	//   _פרסם_, tyru, _peón_, ्पाद_,
   {{0x6d419b25,0xd3b50009,0xcb031862,0xf99f2b5f}},	//   _mila, ость, रचंड_, _apè_,
   {{0x612f8bc5,0x44446bbd,0x6d41ebbe,0x9e660371}},	//   følg, _wg_, _lila, _увид,
   {{0x44445171,0x3f858365,0xa3a80b9f,0x6d418cdb}},	// [7420] _tg_, lulu_, _खैर_, _oila,
   {{0x44446bbf,0x6d41ebc0,0xb4e68105,0xac8619a5}},	//   _ug_, _nila, _पते_, _угол,
   {{0x6b9e23fe,0x7e69890c,0x7d188140,0xe3b887c0}},	//   _uppg, _beep, vovs, _ayın_,
   {{0x6d41ebc1,0x612f9277,0xb5fd8196,0x2bbd864a}},	//   _aila, bølg, _tešl, ्मना,
   {{0x6d419dde,0x7e69bbb0,0x3f85bed0,0x7ce6807b}},	//   _bila, _deep, hulu_, _aðra,
   {{0x3f8594ee,0x6d41820f,0x28c90701,0x0ee203b7}},	//   kulu_, _cila, राणि, _पतझड,
   {{0x6d4187ba,0x7d18ebc2,0xcec381d0,0x25ada671}},	//   _dila, rovs, áří_, _esel_,
   {{0x7d18a0a7,0xa3b9073c,0xcfd080c8,0x68fe033e}},	//   sovs, चित_, ানমন, lipd,
   {{0x6d419fcc,0xddcd06ec,0x26c48144,0x7d189f27}},	//   _fila, _odaš, _inmo_, povs,
   {{0x6d41ea1a,0x3990809f,0x291a6b81,0x3f859a14}},	//   _gila, ràs_, nopa_, fulu_,
   {{0xf98f89d7,0x3f85ebc3,0x8f35143d,0x61301614}},	//   وبی_, gulu_, женц, mäld,
   {{0xa91d8052,0x6d41ebc4,0xa25b0187,0x3990823e}},	//   ruža, _zila, _anôn, pàs_,
   {{0x6f0388f1,0x317febc5,0x44210748,0x2fc700ff}},	//   énci, cruz_, _syh_, ̣ng_,
   {{0x44270104,0x6448173d,0xa2d492c6,0x6d418438}},	//   _ơn_, ždin, यॉर्, _xila,
   {{0x2bbd8a16,0x60d509a4,0xd82f8087,0x56952f92}},	//   ्मया, _rozm, _хэ_, _дайт,
   {{0x925900a9,0x7ceb007e,0x6ee60177,0x00000000}},	//   раат_, _sürd, _tóba, --,
   {{0x60f90110,0x3ea6c36d,0x60d56bc6,0x7e6994cf}},	// [7430] аная_, deot_, _pozm, _reep,
   {{0x28c901c4,0x291a4302,0x7e69ebc7,0xfc4701d0}},	//   राधि, gopa_, _seep, číst_,
   {{0x44276bc8,0x6d41ebc9,0x7ae30087,0xf77011cc}},	//   _án_, _rila, _înto, فان_,
   {{0x6d419600,0x7ceb6bca,0xdb1f0198,0x60c48326}},	//   _sila, _würd, äväk, _ɗima,
   {{0xb5fd81e2,0x3f85ab16,0x7aed451c,0xa91d812b}},	//   _iešk, zulu_, mhat, dužn,
   {{0x7aed58c9,0x6d41bdd5,0x23c492c7,0x87e71374}},	//   lhat, _qila, वमंद, _любе,
   {{0x6d41894d,0x2ee95c81,0x6f0d017f,0xaac583eb}},	//   _vila, _olaf_, _ojac, वालक,
   {{0x6d418c9e,0xa2cc016f,0x3b090197,0x25ad808e}},	//   _wila, हाय्, nnaq_, _tsel_,
   {{0x6d41ebcb,0xed598067,0x225f8859,0x2a7900b9}},	//   _tila, _brže_, rbuk_, _mdsb_,
   {{0x10a59a34,0x3eb20085,0x2ee900ee,0x225f9b6b}},	//   цион, _sayt_, _alaf_, sbuk_,
   {{0x7aed029b,0x1eca0abe,0xa6ca0abe,0x25a0065d}},	//   khat, ални_, ална_, _spil_,
   {{0x7d1e06ab,0xa91d8945,0x2ca7da4b,0xf77200be}},	//   _skps, drže, lend_, וקט_,
   {{0x94040085,0x7aed081b,0x6f0d0b67,0x3f85eb6c}},	//   əmə_, dhat, _djac, sulu_,
   {{0x628f114e,0x3f85ebcc,0x6e2d0253,0x64919f3a}},	//   _acco, pulu_, _dzab, _užič,
   {{0x0443079e,0x8c431c79,0xb5fdbdbf,0x6e2d6bcd}},	//   дерн, дере, _bešk, _ezab,
   {{0x7aed2123,0xb4e686b7,0x2ca7ebce,0x0d860009}},	//   ghat, _पत्_, hend_, _длин,
   {{0xe8fa141e,0x7ceb07d9,0x25a006cb,0x2ca7d00d}},	// [7440] ала_, _süre, _upil_, kend_,
   {{0x6ab683eb,0xddc08353,0x628f047f,0x394b107c}},	//   _अफ्र, _nemš, _ecco, _ducs_,
   {{0x7d1c68c1,0x232a035f,0xab2a035f,0x32461f96}},	//   mors, _вони_, _вона_, _менг,
   {{0xe5c68198,0x6da6a481,0x68fe00c3,0x7d1c0e06}},	//   жско, жида, sipd, lors,
   {{0xc27b025f,0x2b5a6bcf,0x82361ab3,0x2ca7b2c7}},	//   _דרכי, _htpc_, _گرگا, fend_,
   {{0xd37a85f1,0x7d1c035f,0x7ae40f52,0x2ca7a7d0}},	//   ачи_, nors, lkit, gend_,
   {{0xaac585b3,0x613000f2,0xa91d8052,0x248087d9}},	//   वांक, räld, tužn, ğim_,
   {{0x7ae40e11,0x248087d9,0x6e2420c4,0x6ab61670}},	//   nkit, şim_, _oyib, ndyf,
   {{0xc3330bea,0x23698067,0x83fcc579,0x3994016d}},	//   ווה_, ćaja_, _međi, näs_,
   {{0x7aed0019,0x83fc8668,0x7d1c127a,0x20070035}},	//   zhat, _leđi, jors, źnie_,
   {{0x6e2d0065,0x64488122,0x224680ee,0x7ae40198}},	//   _szab, _igdi, _tgok_, kkit,
   {{0x7996009a,0xd9469fab,0x224682c4,0x6e2400b4}},	//   ktyw, _деди, _ugok_, _byib,
   {{0x7d1c02fe,0xd62701a8,0x6e240a03,0x6a9b81c6}},	//   fors, تعدي, _cyib, _כשאנ,
   {{0x7d1c025b,0x99fb8039,0xe3b30060,0x395982df}},	//   gors, _דפדפ, ورز_, ísse_,
   {{0x7aed6bd0,0x3edf082e,0xb5fd8da8,0x63be01f4}},	//   that, _abụọ_, _pešk, _crpn,
   {{0xd838a368,0x25b00364,0xb606920e,0x7ae413d2}},	//   ječi_, ällä_, _kršć, gkit,
   {{0x7aed6bd1,0x6f1d5c1f,0xb5fd801b,0x6e2d00b4}},	// [7450] rhat, mosc, _vešk, _uzab,
   {{0x7aed33ec,0xa2a181fe,0x7d1c0081,0x1601064a}},	//   shat, _कॉन्, cors, _लेयर_,
   {{0xb5fd803a,0x7aed6bd2,0x2ca7ebd3,0x7e6d00dd}},	//   _tešk, phat, vend_, _keap,
   {{0x6f1d0819,0x6d456bd4,0x2ca78cfa,0x1dc69344}},	//   nosc, _hiha, wend_, लमंत,
   {{0x7cf000f2,0x63a1826f,0x7ceb0085,0x7cef8edd}},	//   _därf, _spln, _gürc, _jørg,
   {{0x6d455d23,0xf1bf2336,0x7e6d2305,0xb5fd99ce}},	//   _jiha, _irá_, _leap, _ješi,
   {{0x6d4501ae,0xb5fda648,0x2ca787b3,0x0442ebd5}},	//   _miha, _meši, rend_, нешн,
   {{0x6d452e35,0x7e6d6bd6,0x29016bd7,0x2ca78c4d}},	//   _liha, _neap, liha_, send_,
   {{0xceb2be22,0x7d1c07d9,0xe8f99eef,0x44458019}},	//   _אין_, yors, йли_, _فراہ,
   {{0xa3cb000d,0xb5fd865c,0xb4ea016f,0x6d456bd8}},	//   लमा_, _neši, _मते_, _niha,
   {{0x7ae401e2,0x7afd000b,0x7d1c1a69,0x63a1816b}},	//   ykit, _omst, vors, _upln,
   {{0x7e6d0ae3,0x6f1d59ed,0x7d1c4a15,0x25bf89ff}},	//   _ceap, gosc, wors, _krul_,
   {{0x7cf00006,0x6d456bd9,0x63be574c,0xb5fd8390}},	//   _järg, _biha, _srpn, _beši,
   {{0x78b5011f,0xe1f0830f,0x6d4503bf,0x6d4d00b9}},	//   _nazv, _جسم_, _ciha, _duaa,
   {{0x6d4507d5,0x7d1c0065,0xb5fd8110,0xe73a0ae7}},	//   _diha, rors, _deši, _лек_,
   {{0x7d1c34d7,0x9ad38135,0x934318f6,0x6f1d00e5}},	//   sors, _dịgh, енсе, cosc,
   {{0x6d450091,0x7ae43e66,0x6d5b8282,0x612b0061}},	// [7460] _fiha, rkit, _ntua, rüln,
   {{0x7ae458ec,0x6d450959,0x7e7b8c30,0xf6170039}},	//   skit, _giha, _adup, _מחפש_,
   {{0x6d5b80a9,0xc2c60013,0x2d8f016d,0x09a88128}},	//   _atua, _فيدي, _äger_, _कन्य,
   {{0xf1bf07ca,0x61460fcb,0x7cef8bc5,0xe737813a}},	//   _frá_, _нема, _lørd, пех_,
   {{0xd8389024,0x29016bda,0xf1bf01a8,0xd1388084}},	//   reči_, biha_, _grá_, ymą_,
   {{0x4425800d,0x6d5b81a8,0xd83882d4,0x612b22f8}},	//   _byl_, _dtua, seči_, nüll,
   {{0xdc3600be,0x07a32eab,0xab38854c,0xb90c8032}},	//   האַט_, _парн, опку_, _eemọ_,
   {{0x7cf00106,0x7ceb0085,0x6d5b8168,0xd25081a8}},	//   _färg, _müra, _ftua, خنة_,
   {{0x25fc06ae,0xb60601f4,0x6f1d6bdb,0xf65f1277}},	//   _लेली_, nošč, vosc, kjær_,
   {{0x60f8835f,0x3ea00242,0x261582f1,0x6f02c300}},	//   іння_, _abit_, _फुटी_, lioc,
   {{0xb5fdebdc,0x6d452625,0xd1388d42,0xdceb8267}},	//   _reši, _riha, rmą_, _šićk,
   {{0x6d456bdd,0x6f0281dd,0x6d4d008e,0x7cf00106}},	//   _siha, nioc, _puaa, _lärd,
   {{0x6d45098c,0xb5fda46f,0x612b02af,0x290113c8}},	//   _piha, _peši, füll, yiha_,
   {{0x2ed9800c,0xd12f835f,0x317b898a,0x6f028037}},	//   _भक्त, _їх_, _פרומ, hioc,
   {{0x291e8503,0x50b780f7,0x6d4509fa,0x290c9235}},	//   mota_, _ردود_, _viha, mnda_,
   {{0x7c250a56,0x628d0b80,0xf1bf03cd,0x2d9f6bde}},	//   _vyhr, ugao, _prá_, çues_,
   {{0x7cef84d6,0xdb240061,0x69c00118,0xb5fdebdf}},	// [7470] _høre, írás, _ámel, _teši,
   {{0x291eebe0,0x7cef813c,0x3cf8809a,0x3eab0039}},	//   nota_, _køre, ्चों_, lect_,
   {{0x6d5b998d,0x29012637,0x2d8b1b25,0x5eb00264}},	//   _stua, riha_, luce_, টারে,
   {{0x291eebe1,0xfbbd8768,0x3eb9013c,0x6f028081}},	//   hota_, ्मसम, ndst_, gioc,
   {{0x83fc8025,0xe81d000f,0x7cf0016d,0x3eab002e}},	//   _među, _बुरा_, _färd, iect_,
   {{0xa2d900d4,0x6aa9ca3e,0x69d682d0,0x03a5910e}},	//   फॉर्, weef, _üyey, дико,
   {{0xeb999fbc,0x291eebe2,0x3a268122,0x290c8326}},	//   ций_, dota_, _ayop_, dnda_,
   {{0xa91d8b5d,0x290c9b22,0x6130016d,0x3eab0e9e}},	//   drža, enda_, mäla, ject_,
   {{0x6aa9ebe3,0x6ed1064a,0x386e8c0b,0x7cf0039c}},	//   reef, धानु, _befr_, _häre,
   {{0xd378005c,0x26c92420,0xddc40110,0x2d8b079a}},	//   šći_, _anao_, _neiš, duce_,
   {{0x273580f2,0x7cf00006,0x16aa0d69,0x3eab44fa}},	//   gång_, _järe, овни_, fect_,
   {{0x7cef8aa2,0xd838b5b2,0x98a280eb,0x441a80be}},	//   _døre, ječu_, ēkā_, _וועס,
   {{0xb8e38a49,0x2d8b0025,0xdce982ee,0xba74936d}},	//   _এক_, guce_, _cveć, _سانت,
   {{0x58d484fa,0x7cef821e,0x291ec69d,0xb606007a}},	//   _почт, _føre, cota_, vošč,
   {{0x9d431ddf,0x1543002e,0xe81d06a7,0x7cef806a}},	//   терд, терм, _बुला_, _gøre,
   {{0x91d183bb,0x2d8b6be4,0x7d03ebe5,0x99e39c18}},	//   _तपाई, buce_, hins, žňuj,
   {{0x7d0380a4,0x39462005,0x45360198,0xb0c9086a}},	// [7480] kins, днаг, _охот, रांग,
   {{0x26c90025,0x3947808e,0x394febe6,0x49990009}},	//   _znao_, _jins_, _mugs_, ятся_,
   {{0x7cf000f2,0x6f029601,0x09d600ab,0x26c90122}},	//   _värd, tioc, _সেখা, _ynao_,
   {{0x7cf000f2,0x6fb08bb8,0xc6a38226,0x3947dd63}},	//   _däre, _जनसं, врши, _lins_,
   {{0x6f02ebe7,0x290cad85,0x7d0384b9,0x395d8069}},	//   rioc, ynda_, fins, _ntws_,
   {{0xdb0a8bc5,0x7d03800b,0x6f0290d3,0xa3e506a7}},	//   lvfø, gins, sioc, बैक_,
   {{0x291e95d8,0x612b0074,0xe2080035,0x3eab0144}},	//   vota_, külj, _wróć_, yect_,
   {{0x27e70257,0x7cef83ba,0x7ceb5b64,0x291e8609}},	//   ønne_, _røre, _nürn, wota_,
   {{0x60dc6be8,0x7cefd986,0x7d049a1f,0x2d5407b8}},	//   _korm, _søre, éiss, _näe_,
   {{0xf6518117,0x1604a0d5,0x2d8b0042,0x6562ad68}},	//   _لئے_, _शेयर_, vuce_, mpoh,
   {{0x3947809f,0xdce9cbab,0x56950294,0x645a9764}},	//   _dins_, _sveć, нант, _ifti,
   {{0x394787ca,0x291ea6e8,0x6d48a5e0,0xfbd38039}},	//   _eins_, sota_, _hida, _שתף_,
   {{0x39479209,0x6d48854e,0xf1bf002a,0x3eab4918}},	//   _fins_, _kida, _ayán_, rect_,
   {{0x28d21344,0x2d993177,0x67240c2e,0x6d48ebe9}},	//   साफि, rtse_, _ekij, _jida,
   {{0x6d48bf2a,0xdceb81cd,0x7cf005ec,0x28d2064a}},	//   _mida, stgħ, _bärb, सानि,
   {{0x612b09ce,0x6d4889ca,0x7d03ebea,0x69c2800b}},	//   rülm, _lida, zins, _kroe,
   {{0x60dc3ab0,0xb5fd800d,0xdce98024,0x7d03e3dd}},	// [7490] _borm, _ješt, _uveć, yins,
   {{0xb5fd8301,0xc8c92724,0x6d488079,0xa3ce801b}},	//   _mešt, राइट, _nida, शमा_,
   {{0xdb1a9099,0x60dc1520,0x3f8c803a,0xb5fd816b}},	//   _artí, _dorm, nudu_, _lešt,
   {{0x7d038157,0x6d48ebeb,0x656d3c07,0xff25803d}},	//   wins, _aida, _kwah, ربای,
   {{0xb5fd803a,0x6d48d9b7,0xdca5bbae,0x7cf001ec}},	//   _nešt, _bida, еали, _wäre,
   {{0x6d48956b,0x394febec,0x60dc6bed,0x3f8c8359}},	//   _cida, _rugs_, _gorm, kudu_,
   {{0xa3c106b7,0x75cb016f,0x2735816d,0x764d01b4}},	//   ूमि_, ामुळ, tånd_, _ogay,
   {{0x645a87ca,0x764d6bee,0x69c292af,0xdb0501ec}},	//   _efti, _ngay, _broe, _erhö,
   {{0x31798065,0x7d03d482,0x69c2831d,0x80b60035}},	//   ész_, pins, _croe, _उसमे,
   {{0xe8f69fc8,0xf1b2010f,0x6d48ebef,0x6724005c}},	//   ель_, נסי_, _gida, _skij,
   {{0x78b88098,0x3947ebf0,0x3f8c8cb7,0xd4988071}},	//   _davv, _vins_, gudu_, _юрт_,
   {{0x3947c613,0xb5fdabea,0xa3bc8768,0x9ad381bc}},	//   _wins_, _fešt, इटर_, _dịch,
   {{0x69c2a26f,0xc332804c,0xfc46016b,0xa91d81d6}},	//   _groe, _עוד_, číme_, huži,
   {{0x6ee604c3,0x3999c649,0x7ae9ebf1,0x3f8cebf2}},	//   _móbi, mès_, lket, budu_,
   {{0x3999ebf3,0x03a30009,0xfaa66bf4,0x656d1ab3}},	//   lès_, лиро, наво, _ewah,
   {{0x7ae988bf,0xa91d8024,0x60dc6bf5,0xb5e8826b}},	//   nket, duži, _sorm, _bẹ́r,
   {{0x3999ebf6,0x60dc221b,0x6e29ae03,0xbbbd83eb}},	// [74a0] nès_, _porm, _nyeb, ्मुक,
   {{0x2905ebf7,0xb223228e,0x26f0097d,0xa2a180d4}},	//   nila_, умул, _चतुर_, _कॉस्,
   {{0x60dc387f,0x7ae9a948,0xd12f00f7,0x6d489b98}},	//   _vorm, kket, حمل_, _rida,
   {{0x6d4892cf,0x6e29ebf8,0x6b7b0039,0x7ae98088}},	//   _sida, _byeb, _צרכנ, jket,
   {{0x60dc43cb,0x6d489039,0x2905ead1,0x7f49ebf9}},	//   _torm, _pida, kila_, _dieq,
   {{0xd378003a,0xa91debfa,0xb5fd81ac,0x3999ebfb}},	//   šću_, buži, _rešt, dès_,
   {{0x6d488687,0xfd690135,0xa3d48ada,0x3dd880ab}},	//   _vida, _bipụ, тойч, _দেখল,
   {{0x69c294c1,0xd00f0124,0x7c28826f,0xb5fd8b67}},	//   _proe, _الف_, _vydr, _pešt,
   {{0x6d488852,0xa92a8048,0x6e9380f7,0x3999e115}},	//   _tida, зіне_, _حلقا, gès_,
   {{0x69c28b3c,0xb5fdb251,0x6722b5b1,0x290584b9}},	//   _vroe, _vešt, looj, gila_,
   {{0x28d2823c,0xa0a381e5,0xe1ef803d,0x612f9dd5}},	//   ताबि, ушыл, لسی_, møll,
   {{0x3f8c9f19,0x69c2ebfc,0x7ae9ce3c,0x3999ebfd}},	//   rudu_, _troe, cket, bès_,
   {{0x2905ebfe,0xc0e688cc,0x399982be,0x3f8c805c}},	//   bila_, _подк, cès_, sudu_,
   {{0x63a880ee,0x3f8c8115,0x6722822c,0xfd6901bc}},	//   _kpdn, pudu_, hooj, _zipụ,
   {{0xd7efebff,0x9f47826f,0x80cd86a7,0xe3b00019}},	//   _су_, šné_, तारे, یرہ_,
   {{0x656d0435,0xe7fa02f1,0x7cf00799,0x27478032}},	//   _twah, _एइजा_, _pärc, _mìnì_,
   {{0xfeb80077,0x02e10894,0x7f49ad08,0xa91d817f}},	// [74b0] _سايت_, _नवीन, _rieq, kržl,
   {{0xa91d8052,0x7ae9811e,0x25a9008e,0x6d4f9a1f}},	//   tuži, zket, _ipal_, _écai,
   {{0x7d07003a,0x2d8081ac,0x61300198,0xa91d8968}},	//   mijs, šiel_, mäll, držl,
   {{0x7d076c00,0xa91d8796,0x39b202d6,0x7bc50197}},	//   lijs, ruži, _fņs_, _irhu,
   {{0xa3b9058c,0x7cf00338,0x7c2d8326,0xb27603de}},	//   चिक_, _hära, ƙark, _בערג_,
   {{0x7d070a20,0x2a690072,0x2905ac88,0xf77304e3}},	//   nijs, lbab_, xila_, _مار_,
   {{0x7ae9ec01,0x947480d7,0xb4aa8327,0x6114047f}},	//   tket, ادها, गड़े_, _сдру,
   {{0x63ba006a,0x3999ec02,0x635181a9,0x799b80fc}},	//   ætni, tès_, _jāni, ttuw,
   {{0x7cf000f2,0x7ae9a816,0x26cd8216,0x61301cab}},	//   _lära, rket, _ineo_, käll,
   {{0x3eafc751,0x3999c5dc,0x61301c50,0x7ae9ca2b}},	//   legt_, rès_, jäll, sket,
   {{0x2d8f803b,0x12e780e8,0x25a96c03,0x7bc501c0}},	//   luge_, _підг, _apal_, _nrhu,
   {{0xb8e89c4f,0x752394c6,0x3999d3d4,0x7cf48362}},	//   _लो_, lonz, pès_, _eàrd,
   {{0x2905eba5,0xdce4003a,0xd7f88012,0x61300cb4}},	//   pila_, _sviđ, ază_, fäll,
   {{0xda1c03b7,0xbcfb4aa6,0x7c24b349,0x7cf00338}},	//   _भुगत_, spén, şire, _bära,
   {{0xb4b20a16,0x232a44cc,0x25a91868,0xab2a1ba5}},	//   _ऐसी_, дови_, _epal_, дова_,
   {{0x6a8307b6,0x7cf00106,0x6134823e,0xb95b0362}},	//   илса, _dära, màla, _crìo,
   {{0xee3a0698,0x7523979f,0x7d070b67,0x9c7c807a}},	// [74c0] _юни_, konz, bijs, _hoče,
   {{0x7d070805,0xb95b0104,0x9c7cd717,0xa2a18f85}},	//   cijs, _trìn, _koče, क्त्,
   {{0xdce404a8,0xdb01a509,0x752380e5,0x2a690300}},	//   _uviđ, _aplí, donz, bbab_,
   {{0x2d8f8fa3,0x2d808029,0x69c48110,0x224f82f7}},	//   fuge_, šiem_, _šiem, _nggk_,
   {{0x80b2835a,0x8e5703c8,0x6b830106,0x9c7c807a}},	//   _असले, דינג_, _ångr, _loče,
   {{0x26cd822e,0x7989ec04,0x7523aeae,0x645c6c05}},	//   _eneo_, drew, gonz, ncri,
   {{0x69ddd95b,0x6f04047f,0x9c7c82d4,0x79898037}},	//   äsen, _omic, _noče, erew,
   {{0x66e3867c,0x2732001b,0x501b0039,0x2fc7006a}},	//   _коса, dáno_, _חולו, ænge_,
   {{0x66e38f2e,0x09e400ab,0x78bc16e1,0x50669bcc}},	//   _тота, _নেতা, _karv, ктна,
   {{0x6f041f65,0x48aa8162,0x30a3804a,0x75238db1}},	//   _amic, фтим_, арюв, conz,
   {{0x61300009,0x7d07026c,0x6ee60333,0x0fd08264}},	//   väll, vijs, _lóbu, ান্ধ,
   {{0x9c7c803a,0x78bc6c06,0x6f0400c3,0x7d0701ed}},	//   _doče, _larv, _cmic, wijs,
   {{0x613004b8,0x442c8355,0xf0b78077,0x7d07115c}},	//   täll, _hyd_, رایش_, tijs,
   {{0x7cf00006,0x78bc3447,0x3ebb04b7,0x6f046c07}},	//   _pära, _narv, _waqt_, _emic,
   {{0x2bc592ee,0x2b4b00ee,0xa2b894fc,0x013781c6}},	//   विया, _picc_, ्यप्, _שרות_,
   {{0x7b641b47,0x59b68075,0x61300009,0x32641454}},	//   ртре, _अनार, säll, итув,
   {{0x78bc1cf3,0x442c8aa2,0x23698668,0x645c0144}},	// [74d0] _barv, _lyd_, ćaji_, bcri,
   {{0x7bc50267,0x7cf00106,0x3eaf8192,0x6e2d308f}},	//   _trhu, _härn, wegt_, _iyab,
   {{0x69c62d9d,0x7cef8022,0x7cf01d31,0x1dcb06a7}},	//   _erke, _børn, _kärn, ामकत,
   {{0x7cf0016d,0x7af6026f,0x959994bc,0x98b901a9}},	//   _järn, chyt, етку_, _pusē_,
   {{0x78bc3c10,0xa2b884c5,0x2732001b,0x690b01b9}},	//   _farv, ्यन्, záno_, rżeb,
   {{0x2d8fec08,0x7aed6c09,0x442c831d,0xb4bd81ce}},	//   ruge_, lkat, _byd_, इये_,
   {{0xeab180f7,0x67d42139,0x7523ec0a,0x212780b9}},	//   معة_, _кору, ronz, _rknh_,
   {{0x7aed6c0b,0x69c60186,0x442caa30,0x2489817b}},	//   nkat, _yrke, _dyd_, şam_,
   {{0x7aed01e2,0xe0d1804e,0x6e2d5a5f,0x62829a14}},	//   ikat, مزد_, _nyab, _ddoo,
   {{0x9c7c90d1,0x6ff38201,0xb4b20063,0xdb1a816b}},	//   _poče, ləcə, _ऐसे_, _vrtá,
   {{0x6e360063,0x7aed6c0c,0xdee6393f,0xd70a01e2}},	//   _szyb, kkat, гони, енне_,
   {{0x7c2582af,0x6e2d20d7,0x630589a7,0x7cf4823e}},	//   ühru, _byab, _حوصل, _vàre,
   {{0xe9ce86d2,0xc8788201,0x98a595e0,0x2718807a}},	//   _ук_, bağ_, _биле, nčna_,
   {{0xa91d8289,0x9c7ca3f9,0xdc4381d0,0x6e2d6c0d}},	//   tužu, _toče, _léči, _dyab,
   {{0x9c7c80ce,0xc2610135,0x6e2d060e,0x833a0185}},	//   _uoče, _ụdịr, _eyab, ечат_,
   {{0x645c0218,0x7cf000f2,0x7aed12e8,0x78bc2d5c}},	//   scri, _gärn, gkat, _sarv,
   {{0x61e9c450,0x4a750a8e,0x10a60dc8,0xf8b7816f}},	// [74e0] nyel, рыст, лиан, _असाय,
   {{0x4a431819,0x7aed038a,0x45fb01c6,0xb5fd81d6}},	//   снув, akat, _נהיג, _rešp,
   {{0x749b0051,0x7e76007b,0x7af64092,0x78bc58e5}},	//   _אייפ, _keyp, phyt, _varv,
   {{0xe61ac90d,0x6d561e7f,0x7aed03d5,0x66769650}},	//   нде_, _kuya, ckat, ادار,
   {{0x78bc03ff,0xf7678117,0xc27b02f6,0xd17517ae}},	//   _tarv, _گا_, _ארכי, _высы,
   {{0x7ae30012,0x2fc794e4,0x412a00e8,0x6564004f}},	//   _într, _orng_, _чого_, _mtih,
   {{0xf767803f,0x7cf00106,0x746980e8,0xae048054}},	//   _دا_, _läro, трів_, _शेरन_,
   {{0x7cefa26d,0x6d5603e4,0x41b49ef7,0x6466011c}},	//   _føro, _ouya, لمبر, əriş,
   {{0x69c41b3a,0x61e98065,0xdce40063,0x442c9d33}},	//   nvie, gyel, _zwią, _wyd_,
   {{0x7f42a08e,0x442c879f,0xdd8f8c48,0x2fc7808e}},	//   lmoq, _tyd_, _روم_, _brng_,
   {{0xd9d1035a,0x7cf00006,0x7aed00f1,0x6e2d03ac}},	//   _सप्ट, _pärn, ykat, _syab,
   {{0x7ceb0afe,0x69c401e2,0x63ba809a,0x6d562290}},	//   _türk, kvie, _istn, _buya,
   {{0x2d8b26b9,0x6d560661,0x7cf00589,0x7a7b8e82}},	//   urce_, _cuya, _värn, _טראס,
   {{0x6130016d,0x69c46c0e,0xe81d03db,0x6d5649b5}},	//   sälj, dvie, _बुझा_, _duya,
   {{0x7aed6c0f,0x66f4800f,0x65643690,0x6abd6c10}},	//   tkat, _आतंक_, _etih, _pasf,
   {{0x7cf0016d,0x81ae00ab,0x7bc88140,0xb5fb136f}},	//   _härl, কিন_, _mrdu, dbáv,
   {{0x7aed6c11,0x6d566c12,0x9f4783bb,0x7cf0016d}},	// [74f0] rkat, _guya, ání_, _kärl,
   {{0x7aed6c13,0x7bc8ec14,0x98a7a6d2,0x6729a582}},	//   skat, _ordu, čiću_, _skej,
   {{0xb8dd0fd5,0x7c2902af,0x9f47801b,0x61fb8c9f}},	//   _आस_, ßerd, šní_, zzul,
   {{0xf7700307,0xb8ec023c,0xf9900019,0x29180144}},	//   سام_, _शो_, تبہ_, _ejra_,
   {{0x6ff38201,0x7bc88102,0x127a00be,0x7bc381c0}},	//   rəcə, _ardu, _בארע, wvnu,
   {{0x2eb2000d,0xbf020576,0x61fb811c,0x7bc88362}},	//   _जस्त, _लग्न_, vzul, _brdu,
   {{0x6ed8035a,0x2bc58bb8,0x3ea90854,0x7ae2b2c7}},	//   यामु, विधा, _obat_, _boot,
   {{0x61e982d6,0xa2e58767,0x61fba822,0xd1858037}},	//   tyel, роид, tzul, алий,
   {{0x69c00118,0x61fbd9f6,0x7ae282f9,0x88d581e2}},	//   _ámet, uzul, _doot, аўні,
   {{0x3ebfec15,0x20558162,0x3ea91e9e,0x94558326}},	//   _haut_, штир, _abat_, _zān,
   {{0x3dc91882,0x3ebf8029,0x69c437f6,0x6d56441a}},	//   _araw_, _kaut_, zvie, _suya,
   {{0xed5a00bf,0x798d0c2d,0xfe46245b,0x6d56114b}},	//   ком_, kraw, инно, _puya,
   {{0x2369803b,0x3ebf810b,0xdce2826f,0xed59812b}},	//   ćaju_, _maut_, zpoč, _brži_,
   {{0x6ee6002a,0x394ec28b,0xddc2826c,0x317f82d0}},	//   _cóbr, _gifs_, nboš, msuz_,
   {{0x8c4630bc,0x317f899b,0x04461485,0x6d560041}},	//   реве, lsuz_, ревн, _wuya,
   {{0x68e3d1d2,0x69c40029,0x1601101c,0xf1a980cf}},	//   _hond, tvie, _लेकर_, _कहान,
   {{0x68e3c001,0x09060c07,0x317f880a,0x26d2009c}},	// [7500] _kond, апан, nsuz_, _inyo_,
   {{0xe8f73031,0xa2cc816f,0x26d201c0,0x27391dbb}},	//   алу_, _दोन्, _hnyo_, ména_,
   {{0x68e3a7eb,0xd90d00d5,0x69c46b5b,0x3ebfec16}},	//   _mond, ریف_, svie, _baut_,
   {{0x46a69f96,0x3ebf8087,0xbea68110,0x26c0011b}},	//   радв, _caut_, радк, _jaio_,
   {{0x26c00e67,0x82360077,0x7f42ec17,0x287621f6}},	//   _maio_, _خردا, rmoq, _выбр,
   {{0x6b818183,0x68e38102,0x051480ab,0xa0670087}},	//   _bvlg, _nond, িত্র_, _вара_,
   {{0x3ebf83d3,0x7cf000f2,0xdb01826f,0x7ae29c11}},	//   _faut_, _närm, _splá, _poot,
   {{0xbab88895,0xf1a68a8e,0x38781722,0x9c7c9ee0}},	//   угих_, арон, _herr_, _doča,
   {{0x68e38205,0xdcfb803a,0x7cf026f5,0x635c01f4}},	//   _bond, _zvuč, _pärl, _očno,
   {{0x9c7ca4b2,0x26d2020d,0x7ae2a892,0x290780b9}},	//   _foča, _anyo_, _woot, _cmna_,
   {{0x68e3ec18,0x7cf004b8,0x7ae28006,0x63ba9de4}},	//   _dond, _värl, _toot, _ustn,
   {{0x7cf0016d,0xd36f80d7,0x6d4f80e7,0x387800b9}},	//   _därm, _آهن_, _écar, _lerr_,
   {{0x6f038813,0xae01035a,0xed598699,0x443a1fa4}},	//   ènci, _लेखन_, _prži_, _azp_,
   {{0x68e38065,0x2bbd84c5,0x29078101,0x26d26c19}},	//   _gond, ्मचा, _gmna_, _enyo_,
   {{0x26c00118,0xc1b68cf0,0x81cd80ab,0x61b6bed8}},	//   _faio_, _अनुग, রহণ_, _अनुष,
   {{0x290ce845,0x68e38613,0x7cf003ff,0x3ea91083}},	//   lida_, _zond, _järj, _ubat_,
   {{0xdddb803a,0x4c9514ed,0x3ebf8359,0x6d43948c}},	// [7510] _oduš, _липс, _raut_, ymna,
   {{0x290ce845,0xd8790250,0x26c00102,0x798d00fc}},	//   nida_, امات_, _zaio_, rraw,
   {{0x25ad8422,0x3ebfa914,0xdead09ab,0x902801e2}},	//   _spel_, _paut_, _shaƙ, ацца_,
   {{0x798d0063,0x290cb08a,0x02a71401,0x7e7d1ae3}},	//   praw, hida_, _тром, nasp,
   {{0x51840254,0x3ebf80e7,0x28b786a7,0x443a01ed}},	//   _мура, _vaut_, _असलि, _zzp_,
   {{0x9c7caf62,0xa91d992c,0x61ed01f6,0x438581a8}},	//   _poča, prži, myal, ملتق,
   {{0x290ca6d5,0x68e38e9c,0x3b0980bf,0x316682f7}},	//   dida_, _rond, леко_, _atoz_,
   {{0x68e3aba9,0x5694a154,0x7e7d6c1a,0xfbd08154}},	//   _sond, _маст, jasp, بته_,
   {{0x61ed1c9a,0x6f098a54,0x290c8c9f,0x224b816d}},	//   nyal, _imec, fida_, äck_,
   {{0x39590352,0x290caeaa,0xa3d786b7,0x672d300f}},	//   _muss_, gida_, ामद_, _akaj,
   {{0x9c7c812b,0xfbd080f7,0x26c06c1b,0x68e3ec1c}},	//   _kočn, _يتم_, _paio_, _vond,
   {{0x7cf000f2,0x1efa00f7,0x7e7d020d,0x613d80e7}},	//   _värm, اعدة_, gasp, dèle,
   {{0x290c8c52,0xd25682f6,0x9c7c8353,0x7cf001ec}},	//   bida_, _השנה_, _močn, _wärm,
   {{0x290ca6d5,0x69cb82af,0xed5994f0,0x68fa8f67}},	//   cida_, _irge, _muž_, chtd,
   {{0x6f958307,0x7f858013,0xa3d7a836,0xf74620bf}},	//   _العض, _البن, ामि_, _леко,
   {{0x6ab58076,0x9c7c9234,0x39596c1d,0x7cf00198}},	//   _अघोर, _nočn, _buss_, _kärk,
   {{0x7cf00009,0x9f460061,0x6e3b8135,0xd5b10129}},	// [7520] _järk, szló_, _nzub, ắc_,
   {{0x20562749,0xa3d79308,0x7cf00879,0x2d823eaf}},	//   стар, ामा_, _märk, mske_,
   {{0x9c7ca46d,0x7afb805d,0xe45703c8,0x2a7900c3}},	//   _bočn, khut, _לייט_, _fesb_,
   {{0x290c82a0,0x6e9380f7,0xf7439821,0xf72980e8}},	//   zida_, كلما, пехо, ацій_,
   {{0x94128201,0xd90d0117,0xa2b8bed8,0x290c82ed}},	//   əyə_, ریہ_, ्यस्, yida_,
   {{0x26c0a597,0x290cd9b0,0xed598289,0x6f098135}},	//   žio_, xida_, _duž_, _emec,
   {{0x69cbec1e,0x290ccc3b,0x9f47826f,0x6e3b81bc}},	//   _arge, vida_, šná_, _ezub,
   {{0xbea3a659,0xbf168875,0x290c87d8,0x27322294}},	//   _наск, _اورب, wida_, báni_,
   {{0x290cb472,0x7e7d62b9,0xed598bcf,0x7ceb5868}},	//   tida_, vasp, _bržu_, _kürt,
   {{0x2d82003a,0x7e7d0573,0x7e64046d,0x3ce58711}},	//   dske_, wasp, _afip, _golv_,
   {{0x33f6965d,0xdeb507ac,0x69cbc853,0xe4d784c0}},	//   _учас, обны, _erge, _دولت_,
   {{0x7afba85a,0x290c97ab,0x7ae666dd,0xd6db1ddf}},	//   chut, sida_, _nokt, уто_,
   {{0xeb14823c,0xa2d581aa,0xfa368277,0x69cb80c3}},	//   तचीत_, भार्, _اراد, _grge,
   {{0x290c90ba,0x51628135,0x2a790695,0x9c7c816b}},	//   qida_, _gọọm, _sesb_, _močo,
   {{0xe7e300c8,0x3cfa0105,0x672d0088,0xdb1aad5d}},	//   _মধ্য, _उतरे_, _tkaj, _asté,
   {{0x61ed4d7b,0x290a534f,0x39592127,0x672d0a5a}},	//   tyal, _amba_, _puss_, _ukaj,
   {{0x9c7c9807,0x6f0f00e5,0x2d820e06,0x00000000}},	// [7530] _ročn, micc, cske_, --,
   {{0x61ed1fe0,0x7cf000f2,0x6f0f6c1f,0xed5980ce}},	//   ryal, _närh, licc, _ruž_,
   {{0x61ed6c20,0xaac42d05,0xc5e680ab,0xdfd100f7}},	//   syal, _लोकक, _খেলা_, بيا_,
   {{0xed598503,0x7cef83ba,0x635c0bcf,0x6f0f0037}},	//   _puž_, _tørk, _očnj, nicc,
   {{0x7cef83ba,0x1a9a00be,0x9c7c80c3,0x7ceb5c7c}},	//   _høri, _דירע, _vočn, _fürt,
   {{0x92d580c8,0x80b7864a,0x273225ce,0x6f0f0037}},	//   _হতে_, _असें, ráni_, hicc,
   {{0x9c7cc587,0x09d1835a,0x7ae60214,0x7afb805d}},	//   _točn, तम्य, _yokt, thut,
   {{0x2d823c10,0x442100ff,0x7e6280e5,0x7ceb325b}},	//   yske_, _mxh_, ccop, _kürs,
   {{0xe8f99541,0x44298063,0x7afb8859,0x6f0f433a}},	//   или_, ła_, rhut, dicc,
   {{0xa3cc0a74,0x672b820f,0x9f85a57e,0x7afbb094}},	//   लिम_, logj, огод, shut,
   {{0xf0920bea,0xef1a34d6,0x6d41a733,0x7e7b8ad4}},	//   וני_, имо_, _ihla, _keup,
   {{0x2d822cdb,0x7cf00009,0x2f5491d2,0x6d5bbb44}},	//   tske_, _tärk, ятьс, _kuua,
   {{0xa2b88105,0xed5a1b47,0x2d8418cc,0x7cf00106}},	//   ्यर्, рог_, éme_, _häri,
   {{0xa069aaee,0x2d8205fa,0xfd6481bc,0x2a7f81ec}},	//   _така_, rske_, _afrị, laub_,
   {{0xf0b8815b,0x69c9cf0e,0x6d418234,0x28c286a7}},	//   _دانش_, lvee, _mhla, _वोटि,
   {{0x2d820289,0xed5a0003,0xf26a04fa,0xa3cc00d4}},	//   pske_, _кои_, риал_, लिब_,
   {{0x6d41cb89,0xe9da1232,0xb5fb0236,0x60c3caf5}},	// [7540] _ohla, шка_, lcán, _kanm,
   {{0xe0d70ef5,0x60c396ce,0x3eadc500,0x2a7f8282}},	//   ову_, _janm, _abet_, haub_,
   {{0x14d70158,0x7cf02e6d,0x09b6825e,0x60c38247}},	//   _וויל_, _näri, _अन्य, _manm,
   {{0x60c38247,0x6d419790,0x27e7016d,0x7ceb6c21}},	//   _lanm, _ahla, änna_, _fürs,
   {{0xf5b68bbe,0x60c3839c,0x61303a53,0x6d418834}},	//   تصاد, _oanm, fält, _bhla,
   {{0x6d41ec22,0xf366828b,0x7e62879a,0x7af98176}},	//   _chla, отин, scop, _alwt,
   {{0xbcfb02be,0x439486d2,0x46ca01d0,0x8fa30162}},	//   mpét, чайс, ियाह, _оаре,
   {{0x60c3838e,0x7cf0016d,0x656981b9,0x6d418234}},	//   _aanm, _däri, _fteh, _ehla,
   {{0xe5a68ab2,0xaaa68c78,0x60c38970,0x2cb81699}},	//   _физи, क्षक, _banm, kerd_,
   {{0x6d418068,0xa3ba0b9f,0x2d80a52a,0x80d0009a}},	//   _ghla, _आईं_, šies_, _डोमे,
   {{0x4438c936,0x60c3ec23,0x26c4a00f,0xfaa6910b}},	//   _ár_, _danm, _kamo_, _мажо,
   {{0x74138077,0x26c6ec24,0x2cb8090d,0x7cfdec25}},	//   _توما, ndoo_, eerd_, _pèrg,
   {{0x60c38205,0xdced0024,0x25a6d826,0x6280e415}},	//   _fanm, _svađ, ntol_, mamo,
   {{0x4aa6b011,0x6f0f2d60,0x2cb84c84,0x80a186a7}},	//   क्रव, sicc, gerd_, _खाये,
   {{0x26118105,0x6f0f246c,0x613005ec,0xd7e69138}},	//   _देनी_, picc, häls, _філо,
   {{0x62808662,0xda0c0063,0x60c38247,0x26c4ec26}},	//   namo, _सेहत_, _zanm, _namo_,
   {{0x68e72f82,0x3eb911de,0x67ff8019,0x798402e8}},	// [7550] _pojd, mest_, _tájé, gsiw,
   {{0x4ad18076,0x3eb90778,0x8b08001b,0x2d993fe0}},	//   _दोनव, lest_, _pořá, muse_,
   {{0x65698352,0x6280ec27,0x74150c48,0x2d990074}},	//   _steh, kamo, _روحا, luse_,
   {{0x3eb9245f,0xf8b78bb8,0x6280ec28,0x2d9901df}},	//   nest_, _अस्प, jamo, ouse_,
   {{0x443e8117,0xd5bb99b5,0xb0658009,0xd469879e}},	//   _azt_, рсе_, nkää, биле_,
   {{0x9f44450e,0x7cf00006,0x9c7c8042,0x3ac78129}},	//   ájú_, _päri, _uočl, _ốp_,
   {{0x2a7f85b6,0x60c3ec29,0x3eb90074,0x2d996c2a}},	//   taub_, _ranm, kest_, huse_,
   {{0xa3cc0a74,0x3eb902fd,0x8c1c012a,0x61300364}},	//   लित_, jest_, יווי, sält,
   {{0x443e8065,0x25bf8886,0xdce41408,0x60c38bb1}},	//   _ezt_, _usul_, _stič, _panm,
   {{0x6f0d6c2b,0x2d99688f,0xdb1e45dc,0xe8f995e0}},	//   _amac, duse_, _espè, сло_,
   {{0xccf2804c,0x395fec2c,0xf092093f,0x628082ba}},	//   _רכב_, squs_, ענט_, bamo,
   {{0x7cf00406,0x69cf03a8,0x628086ea,0x2ca1051e}},	//   _järv, _orce, camo, _achd_,
   {{0xcb128039,0x60c3ec2d,0x2d990074,0x0d830b79}},	//   _אלא_, _tanm, guse_, нлян,
   {{0x6f0d088e,0xb606816b,0x7bc18122,0xa3cf92c6}},	//   _emac, _ukáž, _kslu, शिप_,
   {{0xdce40efd,0xa50718f6,0xb5fd939c,0x1d071e9d}},	//   _utič, чера_, _ofšo, чери_,
   {{0xaabd8540,0x7cf026f5,0x877a83de,0x612f9277}},	//   ्यिक, _närv, _פאפי, pøls,
   {{0xc3328039,0xe8fa0dc0,0x26c4bef3,0xe71701c6}},	// [7560] תון_, бла_, _ramo_, _מחקר_,
   {{0x7bc1811f,0x49990364,0x79840114,0x9c7c8115}},	//   _oslu, ются_, rsiw, _počm,
   {{0x4abd9b7e,0xaabd8c78,0x628095e6,0x69cf01f4}},	//   ्याव, ्याक, yamo, _erce,
   {{0x6280ba3b,0x273204c3,0xe73a8009,0x628fbcd4}},	//   xamo, máns_, щее_, ócol,
   {{0x237f003a,0x273203a2,0x69cf0699,0xbcfb00e7}},	//   ćuje_, láns_, _grce, mpér,
   {{0x7ae401dd,0x7f5c5983,0x4c949d51,0x3f8781a1}},	//   ljit, _turq, фикс, _ovnu_,
   {{0x628090dd,0x26c4803a,0x60230abe,0x66028065}},	//   tamo, _tamo_, _здра, szok,
   {{0x7ae42ce1,0xada68056,0x7af60110,0x25a68115}},	//   njit, _набл, nkyt, ptol_,
   {{0x3f9a1249,0x7cef9277,0x7cfd89c4,0xd7f88493}},	//   lupu_, _rørv, _sère, rcăm_,
   {{0x6f0d330f,0x2d990074,0x7cef804a,0xfcaa80d7}},	//   _smac, vuse_, _sørv, _دارو_,
   {{0x3eb91c1d,0x6280ec2e,0x6f1d05a4,0xdb1e6c2f}},	//   test_, pamo, érco, _espé,
   {{0x2d990006,0x7f440cd4,0x273204c3,0xb0658198}},	//   tuse_, _chiq, dáns_, tkää,
   {{0x3eb920a5,0x7ae404a8,0x6d4aec30,0x60db00fc}},	//   rest_, djit, omfa, _ɗumb,
   {{0x3eb90665,0x69c2da1d,0x2d99032a,0x48e393f1}},	//   sest_, _isoe, ruse_, _почв,
   {{0x3eb90065,0x6e2400a9,0x2d992249,0x8fa384ae}},	//   pest_, _exib, suse_, _заје,
   {{0x78ba8065,0x7ae400f1,0x6f0d2ce4,0x2d990087}},	//   letv, gjit, _umac, puse_,
   {{0x442d009a,0x672f009a,0x7cef806a,0x27320061}},	// [7570] łe_, mocj, _kørt, ránt_,
   {{0x51f811e9,0x81ae00ab,0x9c7c816b,0x656d0a5a}},	//   чную_, কিং_, _dočk, _itah,
   {{0x6f1d6c31,0xdb039c18,0x2732002a,0x09a9b26c}},	//   onsc, stné, cáns_, _कह्य,
   {{0x69cf026c,0x6f1d2e76,0x645aec32,0x6d5f2751}},	//   _trce, nnsc, _agti, _kuqa,
   {{0x6f1d526f,0x7cf042ec,0xd1388110,0x4993004e}},	//   insc, _värv, klą_, _سیار,
   {{0x6d5f393e,0x3f85ec33,0x11da0039,0x3af8826b}},	//   _muqa, yslu_, _וחשב, _bépo_,
   {{0x6d570a50,0x2366026c,0x6d5f4d3d,0x68e3008b}},	//   _mixa, _čojk_, _luqa, öndu,
   {{0x80db0076,0x60c726b8,0x752e0bcf,0x629f005d}},	//   नावे, _hajm, zobz, ngqo,
   {{0xb1459d51,0x656d2fc0,0x765b93a4,0x6594c1ce}},	//   мнил, _ntah, _iguy, _пату,
   {{0x248c8122,0x271882d4,0x7f446c34,0x6f1d14cf}},	//   _gddm_, včni_, _shiq, ensc,
   {{0x7bc1803b,0x7cf00074,0x656d0a5a,0x26118035}},	//   _uslu, _märt, _atah, _देती_,
   {{0x60c7020f,0xa3cc0935,0x7c2907d9,0x6441ec35}},	//   _lajm, लिस_, ğerl, _izli,
   {{0x7cef8aa2,0x443c0084,0x6d450362,0x2bc598a9}},	//   _ført, _šv_, _bhha, विका,
   {{0x60c715d8,0x3e7c0104,0x273203a2,0x7afd4c84}},	//   _najm, ật_, táns_, _alst,
   {{0x656d113b,0x7f4400ee,0xa3e086ab,0xa7fc82d0}},	//   _etah, _thiq, दमय_, ncıl,
   {{0x765bec36,0x6d5f426c,0x27325d34,0x6d57023e}},	//   _nguy, _fuqa, ráns_, _eixa,
   {{0x7af607ac,0x60c72009,0x273203a8,0x442587b6}},	// [7580] rkyt, _bajm, sáns_, _lxl_,
   {{0x7af661ec,0x6441b6c5,0x7afd6c37,0x3f9a6c38}},	//   skyt, _ozli, _elst, tupu_,
   {{0xa2a6001b,0x59ba0074,0x6ea50f3d,0x60c73e83}},	//   _छाप्, _उनकर, _कामु, _dajm,
   {{0x9c7c8805,0xee3aa920,0x7aeb8a53,0x78ba8061}},	//   _točk, оне_, _nogt, zetv,
   {{0x628412f5,0xd5b084e3,0x6441ad8d,0x6b9c6c39}},	//   maio, افت_, _azli, lurg,
   {{0x3f9a3661,0x29130118,0x7cf00192,0x6d4aec3a}},	//   pupu_, cixa_, _gärt, umfa,
   {{0x78ba819c,0x2bd104e5,0x9c7c81a1,0xa2a506d4}},	//   vetv, हिया, _joči, ङ्क्,
   {{0x7cef8aa2,0x2005af16,0x60c7009a,0x7cf0329f}},	//   _børs, dzli_, _zajm, _kärs,
   {{0x7aeb81b0,0x9c7c807a,0x224200b9,0xa2a6001b}},	//   _dogt, _loči, _jzkk_, _छान्,
   {{0x7c2d807e,0x6b9c011b,0x7cf00338,0x9404011c}},	//   şara, kurg, _märs, şmə_,
   {{0x656d6c3b,0x78ba920e,0x9c7c807a,0xb5fb0118}},	//   _stah, retv, _noči, rcám,
   {{0x7cef8a38,0x656080b8,0x79964be9,0x6b9c008b}},	//   _førs, _kumh, kryw, durg,
   {{0xdb1a80a9,0x7792803d,0x6560e066,0x7cf00338}},	//   _estã, ریکا, _jumh, _närs,
   {{0xa2b8928a,0x9c7c8669,0x672f2358,0x7996002f}},	//   ्यक्, _boči, socj, dryw,
   {{0x7c340c5c,0xd00fa707,0x6b9c0ba0,0x7aeb822c}},	//   верх, _рф_, gurg, _yogt,
   {{0x60c70067,0xa3cf9199,0xaf0801a8,0xcf2701bd}},	//   _sajm, शित_, _يقوم_, _ترتي,
   {{0x6aad04b9,0x656d1e8f,0x6560802a,0x291e933e}},	// [7590] rfaf, _utah, _numh, onta_,
   {{0x7b6704fa,0x272403bf,0xa3cc06af,0xf1c880ff}},	//   _отме, mına_, लिश_, _mỡ_,
   {{0x291e8e71,0x6b45ec3c,0x2724080a,0x6f0280f7}},	//   inta_, lóge, lına_, fhoc,
   {{0x7bc50423,0x7cf0016d,0x7cef806a,0x7afd0d1a}},	//   _ishu, _färs, _nørr, _ulst,
   {{0x6560b956,0x27240182,0x60c70390,0xe57881e2}},	//   _cumh, nına_, _tajm, дзі_,
   {{0xa3c3801b,0x7d156c3d,0xdb1a8118,0x7cef821e}},	//   _září_, nizs, _ortó, _rørs,
   {{0xe3b19fbe,0xeb99d9dc,0x4ada8076,0xcfa40162}},	//   ارت_, чий_, भांव, _ишти,
   {{0x6f02835c,0x2b46adca,0x84580039,0x442594a6}},	//   choc, _choc_, ובוס_, _vxl_,
   {{0x9f52001b,0xf1c880ff,0x7d15026c,0xb5290032}},	//   ází_, _cỡ_, kizs, _atọ̀,
   {{0x2eed8cfa,0xdb1a809f,0x2724061c,0x6b45a620}},	//   _hoef_, _està, dına_, dóge,
   {{0xe73a11b3,0x7996009a,0x644181a9,0x3ea60103}},	//   зен_, zryw, _uzli, нинг,
   {{0x291e94f2,0x7b030074,0x272407c0,0x60db09ab}},	//   anta_, _jõud, fına_, _ɗuma,
   {{0x9c7c9bf2,0xf1c880ff,0x7bc55a17,0xdb03928a}},	//   _soči, _gỡ_, _ashu, ntní,
   {{0xb0ce009a,0x25bf02df,0x2eed8901,0xdb038174}},	//   _होंग, çula_, _loef_, itní,
   {{0x7cf000f2,0xb602000d,0x628433ab,0x261180dc}},	//   _särs, _žádn, taio, _देसी_,
   {{0x7b030074,0x272407c0,0x27f88aa2,0x39580197}},	//   _nõud, bına_, ørne_, _sirs_,
   {{0x7989a948,0x409601cf,0x46dd01a2,0x6b458144}},	// [75a0] nsew, ерет, यारह, cóge,
   {{0x7cf00879,0xa0a30087,0x6b9c5093,0x02bd800c}},	//   _värs, лауд, purg, ्युन,
   {{0xb9080105,0x9c7c8668,0x7cf00884,0x6f02ec3e}},	//   _मच_, _uoči, _färr, thoc,
   {{0x261185b3,0xb5aa8013,0x3cde02f1,0xdb1abfe5}},	//   _देही_, كاتك_, खावे_, _ostá,
   {{0x291e82a3,0x9c7c8639,0x39586c3f,0x2d9d80b4}},	//   ynta_, _močv, _tirs_, guwe_,
   {{0x69c65c23,0x636783bf,0x6f02ec40,0xf1c880ff}},	//   _iske, _sına, shoc, _rỡ_,
   {{0x6f02810c,0x44441502,0x52bd80c2,0x67243a48}},	//   phoc, _jz_, ्यूस, _ojij,
   {{0xe6ca090a,0xc7d70051,0x6e968872,0x26118128}},	//   ियोज, _אולי_, _سلطا, _देवी_,
   {{0xc1b78fe6,0x645a0267,0x25660428,0x76442eae}},	//   елых_, žtih, _nôl_, _nziy,
   {{0xf2df0104,0xa2d5816f,0x3958a317,0xf1c880ff}},	//   _nhân_, _मोठ्, örs_, _vỡ_,
   {{0xdb1ac07d,0x7cef8aa2,0x76444b1b,0x80ca00ab}},	//   _está, _tørr, _aziy, রাপ্,
   {{0x27240182,0xaaa788af,0xa3bd92ee,0xdbc78074}},	//   tına_, _गायक, इबर_, _pöör,
   {{0x44446c41,0x2b5913f0,0x7c3a8114,0x443a1061}},	//   _az_, _risc_, _hytr, _ayp_,
   {{0x27240459,0xf2df0028,0x672401bc,0x2b5900ee}},	//   rına_, _chân_, _ejij, _sisc_,
   {{0x44442191,0x6d5aec42,0x2724084a,0xdb1e0510}},	//   _cz_, _mita, sına_, _espí,
   {{0x7c3a8081,0x083b8039,0xdbc782f1,0x53341697}},	//   _mytr, _מעול, _töör, гест,
   {{0x44441738,0x80ca00c8,0x325512a0,0x0f5800be}},	// [75b0] _ez_, রান্, твар, _איהם_,
   {{0x7bc501e9,0x6d5aa8aa,0x68ee07f1,0x673d2157}},	//   _tshu, _nita, _cobd, llsj,
   {{0x3f9e811e,0x2d8b009a,0x69c6011e,0x3cde1d70}},	//   nutu_, lsce_, _eske, खारे_,
   {{0x6d5ac802,0x3ee48098,0xa3cf99ee,0x2d9da235}},	//   _aita, лючв, शिस_, tuwe_,
   {{0x6d5acb22,0x64a584f6,0x3f9e823d,0xa2a603a4}},	//   _bita, вала, hutu_, _छात्,
   {{0x6d5aec43,0x3f9ea256,0x26c9805c,0xa3bd801b}},	//   _cita, kutu_, žao_, इबल_,
   {{0x6d5a878a,0x6282838e,0xdb03827f,0x261181ce}},	//   _dita, _beoo, stní, _देरी_,
   {{0x02bd8076,0xe9d99317,0x8e8480f7,0x0ed0016f}},	//   ्येन, дки_, _ملفه, _तोंड,
   {{0x6d5a80a4,0x2d8b009a,0xa2a28aed,0x79898176}},	//   _fita, jsce_, _गार्, usew,
   {{0x6d5aec44,0x79898295,0xd12e80a0,0x2bc2a594}},	//   _gita, rsew, يمي_, _वैवा,
   {{0x3f9ee3f7,0x79898609,0x2d9909ff,0x52b581a8}},	//   gutu_, ssew, erse_, _لماذ,
   {{0x6d5aec45,0x7aef3b40,0x6806810c,0x6e3b808e}},	//   _zita, _noct, _séjé, _kyub,
   {{0xf2df0028,0x7ae9ec46,0x44446c47,0x644509da}},	//   _phân_, mjet, _sz_, _azhi,
   {{0x7ae9ec48,0x3f9e854e,0x44445862,0xdddb825b}},	//   ljet, butu_, _pz_, _oduž,
   {{0xed570dc8,0x28a6acdd,0x6d4e00f1,0x2d990333}},	//   тор_, _खाति, rmba, arse_,
   {{0x38c80bca,0x7afb8575,0x61e42bfa,0x2fc782c4}},	//   کاری_, nkut, txil, _isng_,
   {{0xf2df0028,0x7aef0be5,0x7d0181a8,0x5a633760}},	// [75c0] _thân_, _doct, _olls, ркуб,
   {{0x443a6c49,0x44446c4a,0x29058234,0x61e4434e}},	//   _typ_, _tz_, nhla_, rxil,
   {{0x444441f3,0xc8b50110,0x7afbe690,0x248786c0}},	//   _uz_, ысты, kkut, danm_,
   {{0x6d5aec4b,0x7d01872c,0x7f49ec4c,0x7ae9969b}},	//   _sita, _alls, _cheq, jjet,
   {{0x6d5a8025,0x7ae981c8,0x6f1d0acf,0x2905bb07}},	//   _pita, djet, érci, khla_,
   {{0xe0464566,0x684600c4,0x1d3385a8,0x65640198}},	//   _анги, _анга, анія, _muih,
   {{0x9fc70767,0x17c7091e,0x69c4009a,0xb5fb01a8}},	//   _игра_, _игри_, lwie, rcái,
   {{0x6d5aec4d,0x7afbea48,0x6aa4164d,0xb5fb00f7}},	//   _wita, gkut, ngif, scái,
   {{0x44328063,0x6d5abe85,0x7c3a8035,0xee378048}},	//   ły_, _tita, _wytr, _ант_,
   {{0xa3cf823c,0x6d5a802e,0x9c7cad7d,0x7afbdb89}},	//   शिश_, _uita, _poču, akut,
   {{0xa09b0158,0x27396c4e,0x69c401ec,0x2d803c51}},	//   וייט, ként_, hwie, _awie_,
   {{0x3f9e88bf,0x973d00ce,0x7d1890aa,0x6722b7f7}},	//   rutu_, kuće, livs, nnoj,
   {{0x973d0024,0xf19482c7,0x6564010c,0x3f9eec4f}},	//   juće, _силь, _cuih, sutu_,
   {{0x973d02a5,0x3f9eec50,0x77638118,0x2d800035}},	//   duće, putu_, _funx, _dwie_,
   {{0xd7efec51,0x9388039d,0x386e8118,0x7ceb01ec}},	//   _ту_, кста_, _iffr_, _kürz,
   {{0x99800035,0x905781c6,0x7d18811a,0x2cad01d0}},	//   dził_, _בסוף_, hivs, řed_,
   {{0xdb1a80f2,0x973d0a20,0xdb1e0118,0x45d50992}},	// [75d0] _istä, guće, _arpó, _сопс,
   {{0xc7ad8065,0x3dc902d5,0x7f498168,0x2739016b}},	//   _بڑی_, _isaw_, _sheq, rénu_,
   {{0xccf20051,0x6e3b87d5,0x753501b9,0x248786c0}},	//   _הכי_, _syub, mozz, vanm_,
   {{0x07a4240f,0x75352e6c,0x395ca280,0x7bd70609}},	//   раїн, lozz, _livs_, _irxu,
   {{0x3da7867c,0x7ae98e54,0xa18401bb,0xa6349138}},	//   треб, vjet, _высл, анці,
   {{0x7535623d,0x6b558084,0xa3cf9107,0xf773066e}},	//   nozz, _išgi, शिल_, _نار_,
   {{0xa3cc0321,0x22468019,0x3ea90369,0x7ae9ec52}},	//   लिए_, _azok_, _ocat_, tjet,
   {{0x24878205,0x05c3064a,0x7cfd810c,0xf36680d7}},	//   sanm_, षबाब, _tèro, دئوی,
   {{0x7ae9c41c,0x9c7c9c18,0xdced0bda,0x7afbec53}},	//   rjet, _počt, _atač, rkut,
   {{0x7ae9d337,0x0cce00ab,0x7763bc3f,0x6f198428}},	//   sjet, _রক্ত, _punx, liwc,
   {{0x3ce70076,0x7ae9ec54,0xb4cf816f,0x65640198}},	//   ञाने_, pjet, षयी_, _suih,
   {{0x290581a1,0x6f198428,0x24858252,0x7cf48362}},	//   shla_, niwc, _helm_, _fàrs,
   {{0xe0ce8021,0x29036c55,0x6aa40186,0x59b793e5}},	//   _лв_, _olja_, vgif, _अहिर,
   {{0x333f82a6,0xc99280f7,0xdb1a8198,0x753500df}},	//   llux_, _الوظ, _estä, gozz,
   {{0x656406cb,0x798d0428,0x6aa407b3,0x3ea90242}},	//   _wuih, esaw, tgif, _fcat_,
   {{0xdce4005c,0x69c446e9,0x2365817f,0x3169011c}},	//   _otić, twie, _mulj_, fqaz_,
   {{0x09e311b3,0x91e301f3,0x6aa40be7,0x75352d08}},	// [75e0] ботн, боте, rgif, bozz,
   {{0x26c22bc0,0x27390548,0x69c4686e,0x51560c4f}},	//   leko_, béns_, rwie, утбу,
   {{0x6f041bc0,0x6aa400f2,0x28a69344,0xdb1a8009}},	//   _klic, pgif, _खासि, _ystä,
   {{0x2bd1035a,0xdb9b036b,0x26c2011e,0x973d00d2}},	//   हिरा, _אסטר, neko_, puće,
   {{0xa3cc03eb,0x6d5e4572,0x63ba82f7,0x6f042aa0}},	//   लिक_, _kipa, _sptn, _mlic,
   {{0x60c18364,0x6f04009f,0xa7860124,0x236580c3}},	//   jelm, _llic, _مشرو, _bulj_,
   {{0x60c1a976,0x628610e1,0x6d5e0010,0x7d188b81}},	//   delm, _keko, _mipa, rivs,
   {{0x6d5e6c56,0x26c2120e,0x7cf4809f,0x291a6c57}},	//   _lipa, jeko_, _càrr, lipa_,
   {{0xdced0efc,0x58868071,0x60ce0282,0x26c2011e}},	//   _stač, лына, _kabm, deko_,
   {{0x57b48396,0x6d5e2ece,0x62866c58,0x60c1ec59}},	//   абот, _nipa, _leko, gelm,
   {{0xdb03826f,0x6f046c5a,0xeb9789a0,0x394280eb}},	//   stná, _blic, _бих_, ēks_,
   {{0x62860052,0x26c20578,0x291a002e,0x6d5e011e}},	//   _neko, geko_, hipa_, _aipa,
   {{0x60c1ec5b,0xf2df001c,0x7b030074,0x291a6c5c}},	//   belm, _giây_, _nõua, kipa_,
   {{0x6f04347d,0x656f80e7,0x6d5e6c5d,0x273c84e8}},	//   _elic, _éche, _cipa, mínu_,
   {{0x6d5e078a,0x753524c5,0x6286171a,0x26c20102}},	//   _dipa, rozz, _beko, beko_,
   {{0x7b640193,0x41e705e9,0x443ea699,0x628609c4}},	//   стре, ліза, _myt_, _ceko,
   {{0x161c01fe,0xad2704c1,0x6f1d0118,0xb11501e5}},	// [75f0] _पेपर_, _مردو, ércu, амаш,
   {{0x4a541a1a,0x0edd035a,0x6fa88540,0x6d5e1341}},	//   скус, याकड, _कमां, _gipa,
   {{0x443eec5e,0xdce4012b,0xf77000f7,0x6eac06a7}},	//   _nyt_, _stić, كان_, _झामु,
   {{0x6286105d,0x2fca00b9,0x1b7a00be,0x28d506ab}},	//   _geko, _dsbg_, _שטרע, _डोरि,
   {{0xa684835f,0x443eec5f,0x60c198e8,0x7aed5953}},	//   слід, _ayt_, yelm, mjat,
   {{0x7aed6b4d,0x26c200ad,0x443e9e1e,0x2903003a}},	//   ljat, zeko_, _byt_, _ulja_,
   {{0x2bd80f1b,0x60c183a7,0x26c20737,0x1d06847f}},	//   डिया, velm, yeko_, рещи_,
   {{0x41b584fa,0x16168105,0x26c2011b,0xe6108180}},	//   асот, _देवर_, xeko_, _کشف_,
   {{0x60c195c8,0x54a78b8c,0x6289831d,0x31af0457}},	//   telm, _محاف, raeo, nüz_,
   {{0xa2d58778,0x6f16151f,0xbc6880f7,0x6b45818a}},	//   _मोर्, _smyc, _ممكن_, cógn,
   {{0x26c26c60,0x6d5e063f,0x28a6800f,0x60c1ec61}},	//   teko_, _ripa, _खारि, relm,
   {{0x6d5e5cda,0x7f4d4a94,0x7aed1369,0x63a3c1cb}},	//   _sipa, _chaq, jjat, munn,
   {{0x7f4d02c1,0x6d5e4b20,0xd8f58077,0x63a3ec62}},	//   _dhaq, _pipa, _پزشک, lunn,
   {{0x62860859,0x26c243b5,0xdca604bd,0x4e96003d}},	//   _seko, seko_, јави, دشگر,
   {{0x07a58b33,0x6d5e6c63,0x63a3808b,0xa3d5847d}},	//   _тайн, _vipa, nunn, िटि_,
   {{0x2b40151e,0x7c3e026f,0x672980f1,0xaabda9b7}},	//   ulic_, _vypr, _njej, ्यटक,
   {{0x61fb871f,0x61e99daf,0x62863251,0x63a38c9a}},	// [7600] nyul, nxel, _veko, hunn,
   {{0xa3d585b3,0xe9d72344,0x63a3abed,0xc8e006b7}},	//   िटा_, шку_, kunn, नाइट,
   {{0x62866c64,0x0fd917ae,0x63a39bd0,0x9e668f04}},	//   _teko, льцы_, junn, авед,
   {{0x7d1c10d7,0xe9a655e6,0xf9878077,0x2055079e}},	//   lirs, _камп, _وب_, стур,
   {{0x70c58105,0x6286807b,0x63be00b9,0xae168006}},	//   _वसूल, ðkom, _hppn, _देशन_,
   {{0x80ca00c8,0x26070327,0x63a3ec65,0x67298144}},	//   রাহ্, हनती_, funn, _ejej,
   {{0xb5fb0073,0xb4e68105,0x69d98114,0x63a3ec66}},	//   ncár, _बची_, _arwe, gunn,
   {{0xb6a39a19,0xbea39052,0x672980f1,0x7b030074}},	//   _мисл, _маск, _gjej, _lõun,
   {{0x9f5910ab,0xdb070061,0x38c8803d,0x443e8428}},	//   árí_, ntjá, هادی_, _wyt_,
   {{0x7f4d02c1,0xa3e603bb,0xd90e8bca,0x63a3c1cb}},	//   _shaq, पमा_, بیت_, bunn,
   {{0x644880d2,0x69d982af,0x473550f6,0x7d1c6c67}},	//   _uzdi, _erwe, йнос, dirs,
   {{0x88bc81d0,0x273ccb9b,0xd8388088,0xd041811c}},	//   cněn, míns_, ngči_, ndlə,
   {{0x973d003b,0xceb38039,0x7ae2ec68,0x7d1c2f21}},	//   guća, חיר_, _inot, firs,
   {{0xb0d50072,0x7d1c5a98,0xd90e80d7,0x31af22f8}},	//   _डोंग, girs, _آید_, vüz_,
   {{0x27320019,0xd7fa84ae,0x7aed6c69,0x9b680a2e}},	//   hány_, _јул_, tjat, ишта_,
   {{0x29185a21,0xe70509a7,0x63be00b9,0xdb1a9af9}},	//   _amra_, _دستی, _dppn, _astú,
   {{0x7aed6c6a,0x7d1c0511,0x6f1d0e83,0xb5fb002a}},	// [7610] rjat, birs, misc, acár,
   {{0x6f1d6c6b,0x7d1c0333,0x7bdaec6c,0x7c290192}},	//   lisc, cirs, _ortu, ßers,
   {{0x7aed375d,0x83f939c3,0x8e3800d7,0xa267047f}},	//   pjat, _сенс_, _مسیر_, _въгл,
   {{0xb8fe101c,0x6f1d6c6d,0xec360051,0x63a3ec6e}},	//   _दो_, nisc, _לאתר_, vunn,
   {{0x261185e8,0xd0870198,0x88bc81d0,0x63a380fc}},	//   _देखी_, _выби, vněn, wunn,
   {{0x63a3a3c6,0x2bd3b2dd,0x7ae28039,0xfbd180f7}},	//   tunn, थिला, _anot, كتب_,
   {{0x672980f2,0xaca3082e,0x7f428036,0x88bc81d0}},	//   _tjej, _adịg, bloq, tněn,
   {{0x2bd805b3,0x63a3955f,0x7bda9665,0xcac98009}},	//   डिता, runn, _drtu, угие_,
   {{0x6f1d6c6f,0x88bc81d0,0x80ca00ab,0x7d1c0085}},	//   disc, rněn, রার্, yirs,
   {{0x09059109,0x60c502af,0x7ae2ec70,0x63a3ec71}},	//   спон, nehm, _enot, punn,
   {{0x68f502a5,0x6f1d527b,0x83aba21f,0x7e640122}},	//   _mozd, fisc, _штаб_, _pgip,
   {{0x6d4380f2,0x81c680c8,0x6f1d0e83,0x0a188077}},	//   llna, _উপর_, gisc, افیک_,
   {{0x2d8403d3,0xe8ee9a34,0x2f55035f,0xa3cf83dd}},	//   ème_, _ел_, ютьс, शिक_,
   {{0xd37e9487,0x4aa78424,0x7ae2b102,0x6f1d01a8}},	//   šćen_, _गाँव, _znot, aisc,
   {{0x65618073,0x7d1c55bf,0x68fca651,0xe29a03c5}},	//   _milh, rirs, örde, лав_,
   {{0x6441c702,0x6aa9ec72,0xadf9897d,0x27f883ca}},	//   _myli, ngef, ्नान_, ärne_,
   {{0xe9da07ac,0x7d1c6c73,0xb5fb0020,0x64a6174a}},	// [7620] ыка_, pirs, scár, _лапа,
   {{0x26d226df,0x343a0277,0xb4e6800f,0x27322aa8}},	//   _hayo_, _مسجد_, _बचे_, vány_,
   {{0x26d2049f,0x63be094c,0x6441a28f,0xdb07007b}},	//   _kayo_, _uppn, _nyli, stjá,
   {{0x7b030074,0xdd8f003d,0x69c9864e,0x26d25998}},	//   _jõul, _توی_, kwee, _jayo_,
   {{0x26d231a2,0xdd8f9368,0x6561ec74,0x644a017f}},	//   _mayo_, فون_, _bilh, šlić,
   {{0x6441972b,0xd1321a37,0x26d23cbf,0x68f5007a}},	//   _byli, _رمز_, _layo_, _gozd,
   {{0x973d0025,0x8fa3067c,0xb6060353,0x64419532}},	//   dućn, _наре, lišč, _cyli,
   {{0x26d26c75,0x64418514,0x68e3ec76,0x497486f9}},	//   _nayo_, _dyli, _annd, олис,
   {{0x65618073,0xdce2805c,0xe29f807b,0x32029e1e}},	//   _filh, spođ, óða_, áky_,
   {{0xa2da00d4,0x973d003a,0x656f82be,0xdd8f80f7}},	//   _पोस्, gućn, _écha, _أول_,
   {{0x6f1d43a6,0x3202803e,0x61e48110,0x06e412c6}},	//   tisc, šky_, _šild, गांव_,
   {{0xb7db007c,0x26d24a96,0x656980fc,0x2d498333}},	//   אקטי, _cayo_, _yueh, núen_,
   {{0xe89482c7,0x7afda9dd,0x7cfd809f,0xb606007a}},	//   _даль, öste, _sèri, jišč,
   {{0xb6060db7,0xf76f8077,0x6f1d6c6d,0x3ceb83ca}},	//   dišč, بای_, sisc, चाये_,
   {{0x68f50e04,0x6f1d6c77,0x249f03bf,0xb4fb83c8}},	//   _rozd, pisc, ğum_, נפלי,
   {{0x6ec48fd5,0x26d215d4,0xae9b01a8,0xaca3026b}},	//   _रसगु, _gayo_, _إضغط_, _idọg,
   {{0x291e8009,0x50f51a47,0x6f0281d6,0xb4fa852a}},	// [7630] oita_, озат, dkoc, ्साय_,
   {{0x291e95bd,0x29076c78,0xb88200e1,0x26d21d61}},	//   nita_, óna_, _šírk, _zayo_,
   {{0xf84b0656,0x672d026c,0x26d21d61,0x68f51f3a}},	//   учай_, _kjaj, _yayo_, _vozd,
   {{0x291eec79,0x2a6681c0,0x17f801a8,0x7d1a9dba}},	//   hita_, _ngob_, حركة_, _amts,
   {{0x291e84d2,0xa3aba38c,0x65618187,0x290c8079}},	//   kita_, कून_, _pilh, khda_,
   {{0x672d235d,0x21ba00be,0xdb0389b9,0x973d0669}},	//   _ljaj, _דזשא, punë, kućo,
   {{0x051680f7,0x973d01dd,0x6561a3ea,0x81bb00ab}},	//   تيوب_, jućo, _vilh, _আছি_,
   {{0x69c98051,0x8c1c00be,0x6f02826c,0x973d00d2}},	//   twee, טווי, ckoc, dućo,
   {{0x291ecc49,0x6441864c,0x656195f8,0x6aa980e3}},	//   fita_, _wyli, _tilh, rgef,
   {{0x69c9a808,0x26d26c7a,0xc10580f7,0x6aa981ec}},	//   rwee, _sayo_, زوجي, sgef,
   {{0xb17b04b8,0x69c9800b,0x26d2009c,0x973d0503}},	//   _fråg, swee, _payo_, gućo,
   {{0xe73a0767,0x050600ab,0x69cf3020,0x69dd29d1}},	//   рем_, _ঈদের_, _osce, _orse,
   {{0x291ed85b,0xee3705e9,0x95830fe6,0x200382d4}},	//   bita_, жня_, мляе, šji_,
   {{0x973d012b,0x628b811b,0x290c8229,0x26d26340}},	//   vrće, _hego, chda_, _wayo_,
   {{0x26d202b8,0xc7460199,0x628b8642,0x69cf5dec}},	//   _tayo_, _وضعي, _kego, _asce,
   {{0x28ac0b3b,0xa22a0323,0x7bc18118,0xb606007a}},	//   _चाहि, ажба_, _mplu, tišč,
   {{0x628b8065,0x3b0700b3,0xdce08087,0x256f061c}},	// [7640] _mego, цето_, _jumă, _gül_,
   {{0x628bbd9b,0xa2da000c,0xf53f0082,0xa3e9800d}},	//   _lego, _पोर्, står_, ममा_,
   {{0x69cf2e88,0x2d4981df,0x7bc18069,0x69dd6c7b}},	//   _esce, túen_, _nplu, _erse,
   {{0x91e65b5d,0x444413c8,0x63a101ac,0x628b9fb0}},	//   _доме, _iy_, álne, _nego,
   {{0x44442674,0x6f028a0f,0x7bc18358,0xf2df0028}},	//   _hy_, rkoc, _aplu, _châu_,
   {{0x44446c7c,0x6f099b7d,0x291e8102,0x6f02ec7d}},	//   _ky_, _elec, xita_, skoc,
   {{0x44442674,0x261a850a,0x628b8a58,0x0eaa00d4}},	//   _jy_, _मेरी_, _bego, _कांड,
   {{0x444400f8,0xaec39317,0x3945809f,0x1e869bcc}},	//   _my_, _обсл, ells_, _флам,
   {{0x291edb92,0x753c0063,0x628bc2df,0x61e481a1}},	//   tita_, korz, _dego, _šilb,
   {{0x672d003b,0xeb9a8698,0x44444521,0x644102f1}},	//   _sjaj, _виж_, _oy_, ülik,
   {{0x44440082,0x291e87d5,0xdce982a5,0xe1ff00ff}},	//   _ny_, rita_, _steć, _ngón_,
   {{0x290cd7c4,0x628bd5f2,0xa2da2769,0x76440a03}},	//   shda_, _gego, _पोल्, _byiy,
   {{0x44446c7e,0x753c6c7f,0x291eec80,0xe0cf803d}},	//   _ay_, forz, pita_, رزی_,
   {{0x44446c81,0x628b8102,0x224b81ec,0x387f00ce}},	//   _by_, _zego, ücke_, _đuro_,
   {{0x44440578,0x987b83c8,0xcb1b0073,0x7644071f}},	//   _cy_, _דרוק, аќа_, _eyiy,
   {{0x44446c82,0x290a0046,0x539b807c,0x63a70289}},	//   _dy_, _alba_, יילו, rujn,
   {{0x44444577,0x88bc801b,0xf53f3552,0x5d8401a8}},	// [7650] _ey_, vněj, tråd_, _قليل,
   {{0xd49b0676,0x4444031d,0x6f098a0f,0x2bcb016f}},	//   _три_, _fy_, _slec, ाबदा,
   {{0x6f0986da,0x6d47135a,0x444402ec,0xb8d31d70}},	//   _plec, mlja, _gy_, _टा_,
   {{0xdb0383f8,0x69dd00dd,0x6d47007b,0x2be00105}},	//   puné, _trse, llja, _पछता,
   {{0x628b81c1,0x237f005c,0x7bc1b0a6,0xdb070106}},	//   _rego, ćuju_, _splu, rtjä,
   {{0x628bd1db,0xdb07016d,0x88bc81d0,0x929d8035}},	//   _sego, stjä, sněj, dkła,
   {{0x6b4595d8,0xe299b3c2,0x656d03ac,0x4900016f}},	//   lógi, бай_, _luah, _शकतो_,
   {{0xb17b228f,0x753c5c1f,0x6aad1aa4,0x6f1b82a0}},	//   _tråd, zorz, ngaf, _umuc,
   {{0x6d47011a,0x672b80e8,0x673d082c,0x25708580}},	//   klja, mngj, dosj, _gàl_,
   {{0xa3bb87bd,0x6565326a,0xbef600c2,0x635c0242}},	//   _ناصر_, _nihh, ुघ्न_, _dčny,
   {{0x6d4194e5,0x753c6c83,0x644501c0,0x60d56c84}},	//   _ikla, vorz, _nyhi, _mazm,
   {{0x44445cd9,0x656d0458,0x753c009a,0x291c81f6}},	//   _ry_, _buah, worz, _emva_,
   {{0x44446c85,0x91e58dae,0x753c6c86,0x7b0e826b}},	//   _sy_, _холе, torz, _dùud,
   {{0x2d9e026f,0x657b8010,0x91f681c6,0xb97a825f}},	//   čte_, _mtuh, _ממנו_, _הנסי,
   {{0xe8df001c,0x987a83de,0x7af9b3c7,0x63860110}},	//   _ngực_, _פאקט, _kowt, ягва,
   {{0x6b63522f,0x63ae813c,0xe3630d9e,0x7e69a4ff}},	//   екса, _åbne, екси, _ngep,
   {{0x6d47252d,0x753c0211,0x5bb888fd,0x6ebc10be}},	// [7660] blja, porz, _आह्व, ष्णु,
   {{0x44446c87,0x20561ddf,0x3ebf833e,0x7e69d413}},	//   _ty_, птер, _abut_, _agep,
   {{0x44446c88,0x78a3007b,0x212600d2,0x36c6a84f}},	//   _uy_, ónva, đoh_, збег,
   {{0x60c88063,0x6d41809c,0x48dd8fb2,0x248c928a}},	//   zedm, _akla, _कोसो_, _sedm_,
   {{0x6284040e,0x26c0004f,0xae16a724,0xa4d4804a}},	//   mbio, _mbio_, _देखन_, долі,
   {{0xb4d698e6,0x60d536c4,0x29058bda,0x673d0140}},	//   िये_, _gazm, jkla_, zosj,
   {{0x69c2837a,0xf21486a7,0x7af9b603,0x644500b9}},	//   _spoe, _तेज़_, _bowt, _xyhi,
   {{0x6d41ec89,0x79a69bc1,0x7cfd810c,0x62840f3e}},	//   _ekla, прое, _bèrs, nbio,
   {{0x6da38ff0,0x60d5017b,0xd5c08006,0xada3db4d}},	//   _пита, _yazm, _एहिज, _патл,
   {{0x6722949e,0x26c00091,0xdce406ec,0x290582d5}},	//   lioj, _abio_, _otiđ, gkla_,
   {{0x6602aaab,0x8f35228e,0x673d6c8a,0xe1ef804e}},	//   lyok, денц, tosj, نسی_,
   {{0x60c8ad9b,0xe7ed82f1,0xb903ac4f,0x67228084}},	//   sedm, _छपरा_, _पो_, nioj,
   {{0xb0ac035a,0xa2d58076,0x6602ec8b,0x673d4d5a}},	//   _चांग, _मोट्, nyok, rosj,
   {{0x2ec993ba,0x2905816d,0xeb05125f,0x38c88019}},	//   _रस्त, ckla_, रस्त_, _ذاتی_,
   {{0x58bb8039,0x6d470669,0x00bb8039,0x673d05f3}},	//   _המוצ, rlja, _המומ, posj,
   {{0x6d470025,0x656d6c8c,0x5bb8062c,0x66029a14}},	//   slja, _tuah, ялся_, kyok,
   {{0xb606016b,0xd2340081,0x2bcb0035,0x26cb6c8d}},	// [7670] _práš, ентъ, ाबहा, meco_,
   {{0xb4d68c33,0x26cb4a96,0x2bce0105,0x8af00085}},	//   ियो_, leco_, _हैवा, lməl,
   {{0x20070b4c,0x6f0d6c8e,0x628401e8,0x60d50115}},	//   áni_, _klac, bbio, _vazm,
   {{0x6d41c31e,0x26cb02df,0xe9df492b,0x2121008e}},	//   _skla, neco_, _trú_, sihh_,
   {{0x20070805,0xd5bbadc7,0x9f5c801b,0x3f983076}},	//   šni_, ссе_, ává_, _evru_,
   {{0xee38835f,0x6f0d51fb,0x1dde00ba,0x26cb07b6}},	//   чні_, _llac, मितत, heco_,
   {{0x6f0d084a,0x628f0812,0x6d41816b,0x26cb09c4}},	//   _olac, _keco, _vkla, keco_,
   {{0x64410063,0x07098013,0x36d49017,0x2ef581e5}},	//   żliw, _بيري_, _поср, _ўзар,
   {{0x59e006af,0x290584e8,0xdb1a9b88,0x6d4187b6}},	//   नियर, tkla_, _astó, _tkla,
   {{0x27390065,0x48058cde,0xf1d28063,0x6f0d13a9}},	//   mény_, дпов, तिजन, _alac,
   {{0x6f0d087b,0x628f6c73,0x26cb0216,0xbea6259a}},	//   _blac, _oeco, feco_, манк,
   {{0x6f0d01e4,0x628f16eb,0x7523da17,0x2b490267}},	//   _clac, _neco, linz, jlac_,
   {{0x6f0d009a,0x213ecfa2,0x7bc501f6,0xee3a0a18}},	//   _dlac, both_, _aphu, інг_,
   {{0xd8258992,0x332d808e,0x628f0580,0xd009802e}},	//   _одли, lnex_, _aeco, _меле_,
   {{0x04431b53,0x8c432457,0x6f0d6c8f,0x628f0039}},	//   верн, вере, _flac, _beco,
   {{0x6f0d6c90,0x26c00025,0x25ee816f,0x752382a0}},	//   _glac, _ubio_, _आपली_, hinz,
   {{0xe8fa069b,0x628f4793,0x31679100,0x62846c91}},	// [7680] ола_, _deco, _kinz_, rbio,
   {{0x8cbf80dc,0x66028010,0x629d5502,0x9c7c82d6}},	//   ल्मो, vyok, _edso, _enčj,
   {{0x7a6a07b6,0x628f00e5,0x6b45ca09,0x8af0011c}},	//   _минг_, _feco, lógu, lməm,
   {{0xe5c6941e,0xe80e83b7,0xa3e1890f,0x628f00f3}},	//   дско, ानता_, दिन_, _geco,
   {{0x67228110,0x27390061,0x333fddf5,0x8af0029a}},	//   rioj, gény_, doux_, nməm,
   {{0xd37aaa15,0x6722949e,0x9f5f04e8,0x7afdd8e5}},	//   очи_, sioj, ryté_, östn,
   {{0x69dd813c,0x22468590,0x68fc365a,0xbebb01ed}},	//   æsen, _syok_, _iord, diën,
   {{0x68fc6c92,0x63aa80dd,0x2b4064bc,0xc2988eef}},	//   _hord, rufn, noic_, чких_,
   {{0x68fc3f2a,0x26cb5f6b,0xbebd8084,0x7523a6fd}},	//   _kord, veco_, _smūg, binz,
   {{0x68fc6c93,0x6f0d5345,0xcce680f7,0x6d5c017f}},	//   _jord, _slac, _تسري, jmra,
   {{0x68fc3d7f,0x6f0d4918,0x3f98826f,0x7c6580f7}},	//   _mord, _plac, éru_, _كامل,
   {{0x6d4aa911,0x656880f1,0x522680a9,0xdb1aec94}},	//   llfa, _hidh, _офла, _estò,
   {{0x628f0c8c,0x68fc1ad7,0x26cb3e3d,0x22468122}},	//   _reco, _oord, reco_, _uyok_,
   {{0x68fc006f,0x628f114e,0x656896bb,0xbebb01ed}},	//   _nord, _seco, _jidh, ciën,
   {{0x6f0d6c95,0x3eaf9252,0x628f01e8,0xd6db245b}},	//   _tlac, yggt_, _peco, _дтп_,
   {{0x6568820f,0x973d0582,0x6448e7a7,0x35b54add}},	//   _lidh, kući, _mydi, _збир,
   {{0x68fc24c0,0x973d0067,0x6568925b,0x6448ec96}},	// [7690] _bord, jući, _oidh, _lydi,
   {{0x973d0289,0x2b490669,0x7b178087,0x6568ec97}},	//   dući, slac_, nţur, _nidh,
   {{0xf77007bd,0x44271918,0x68fc4695,0xb4cb016f}},	//   لان_, _än_, _dord, ळजी_,
   {{0x61e2ec98,0x6568ec99,0x629d0366,0x25a6ec9a}},	//   _orol, _aidh, _udso, frol_,
   {{0x68fc3b39,0x973d003a,0x656888ce,0x427a03c8}},	//   _ford, gući, _bidh, _מארג,
   {{0x7afd1838,0x78718019,0x6568a4ee,0x2d9967ea}},	//   _host, _művé, _cidh, isse_,
   {{0x7523ec9b,0xc61f809a,0xe2998254,0x61e28114}},	//   rinz, _मेरठ_, пай_, _arol,
   {{0x7e6d3aa0,0x25a68cc0,0x7afd2707,0x7523a4e7}},	//   _ngap, brol_, _jost, sinz,
   {{0x68fc6c9c,0xbebb00f3,0x61e2ec9d,0x7523804f}},	//   _yord, tiën, _crol, pinz,
   {{0x7afd6c9e,0x68fc04c3,0x6d450282,0x7e6d6c9f}},	//   _lost, _xord, _nkha, _agap,
   {{0xb8d78b9f,0x7afd038e,0xff2611d0,0x2d8d88f9}},	//   _छा_, _oost, емно, _hwee_,
   {{0x7afd3a68,0x6da60ba5,0x7769808e,0x6d456ca0}},	//   _nost, нима, _jiex, _akha,
   {{0x656882a3,0x7e7b804f,0x7aeb810c,0xa3ab8072}},	//   _yidh, _mfup, _ingt, कूर_,
   {{0x257404b8,0x656882a3,0x7afd6ca1,0xd1968039}},	//   _väl_, _xidh, _aost, _טכני_,
   {{0xa3e70f04,0xdddb88fc,0xd3721a3c,0x7afd5de0}},	//   ндра_, _neuž, اهر_, _bost,
   {{0x7afd07b5,0x6d45005d,0x68fc6ca2,0xdb0384e8}},	//   _cost, _ekha, _sord, ytný,
   {{0x4a750196,0xcb1280be,0x68fc5819,0xdc3c0390}},	// [76a0] тыст, אלן_, _pord, _išča,
   {{0x46c1000d,0x38c8004e,0x290e0dfa,0x4f960087}},	//   ष्ठह, باری_, ófa_, ерду,
   {{0x8cd906bf,0x7afd6ca3,0x7649eca4,0x66060e34}},	//   _फोटो, _fost, _ayey, lykk,
   {{0x7afd6ca5,0x68fc0e9e,0xb907058c,0x216a245b}},	//   _gost, _word, _मो_, _ними_,
   {{0x6f1d0722,0x63ae0690,0x45d4a0bf,0x2bd801d0}},	//   èrci, lubn, толс, डिका,
   {{0x7afd21a9,0x62962692,0x25a684c3,0x9f590013}},	//   _zost, layo, rrol_, árú_,
   {{0xf3668ab2,0xa3abeca6,0x1fb50226,0xdb039b2c}},	//   нтин, कूल_, _истр, stný,
   {{0xa067138c,0x6e938013,0x6296022e,0xdd92dc11}},	//   _часа_, _ملفا, nayo, _مور_,
   {{0x88bc81d0,0x6568b00b,0xe737e246,0xb53a10ab}},	//   knět, _tidh, _чет_, _atọ́,
   {{0x3ea009da,0x92cc00ab,0x61e2910f,0x7b15816a}},	//   _adit_, লায়_, _vrol, _náuf,
   {{0xf53f00f2,0x62964a11,0x2d8000b9,0x4034a2ea}},	//   från_, kayo, _atie_, тенс,
   {{0x61e28687,0xbebb00f3,0x6fb18cfd,0x7b0306ae}},	//   _trol, ciël, _अमरू, _jõut,
   {{0x7afd6ca7,0x629604a7,0xc33382f6,0x2d996ca8}},	//   _rost, dayo, _גוף_, usse_,
   {{0x7afd380b,0xd24f80f7,0x3ea00039,0x63a105bf}},	//   _sost, _انه_, _edit_, álno,
   {{0x63ae0042,0xd00f8dc0,0xa29501e2,0xf0939101}},	//   gubn, _сф_, каві, _ענק_,
   {{0xa3e19a87,0x62966ca9,0x3958008e,0xdb1880e1}},	//   दित_, gayo, _ahrs_, ftvé,
   {{0x7afd3a68,0x4ac281ab,0x9f5f0061,0x30a70dfd}},	// [76b0] _vost, व्यव, sztó_, ерев,
   {{0x273c816b,0xaa6437cd,0x7afd00b9,0xb17b0106}},	//   míny_, утск, _wost, _från,
   {{0x28150416,0x7afd2c6a,0x56958009,0x62966caa}},	//   خواس, _tost, вает, bayo,
   {{0x7afd424d,0x62966cab,0xfe708199,0x316a02f9}},	//   _uost, cayo, مده_, _eibz_,
   {{0x4ea489f7,0x02bc82f1,0xdb1e2ab5,0xdb07128a}},	//   урха, ्जैन, _espó, nují,
   {{0xf9920bea,0xfaff01b0,0x7c3402d0,0x03a5a964}},	//   _דרך_, _hoë_, _çerç, вико,
   {{0xdce5007a,0x776980b9,0xdb07128a,0xf53f267f}},	//   _nihč, _tiex, hují, yrån_,
   {{0x2d8da40d,0x2bc2816f,0x7e7b8c53,0xb4ce03ca}},	//   _twee_, _शहरा, _ufup, _रस्_,
   {{0x3dc901c0,0x0edd809a,0xbebb110f,0x7e648503}},	//   _npaw_, _नोएड, riël, žipr,
   {{0x26cfc92f,0x60099634,0xdb07001b,0x3ea0008e}},	//   lego_, дном_, dují, _sdit_,
   {{0xe73a0dcd,0x2d800087,0x7b030074,0x3dc902d5}},	//   ден_, _stie_, _jõus, _apaw_,
   {{0x26cf8063,0xe2908013,0xfbd284de,0x26dd81ec}},	//   nego_, _هذه_, _כתב_, ndwo_,
   {{0xe0cea296,0xc3328039,0x273c816b,0x00e3853d}},	//   _кв_, _דוא_, gíny_, _متغی,
   {{0xa3b589a3,0x290b80eb,0xa5a986a7,0x62961855}},	//   _जमा_, īcas_, _घिनौ, wayo,
   {{0x6296132f,0x7b030074,0x66061af1,0x6726330c}},	//   tayo, _nõus, sykk, pikj,
   {{0x6d43bed0,0x2d80802e,0x3f85ccae,0x29116183}},	//   hona, ţiei_, mplu_, _alza_,
   {{0x6d43af16,0x973d0668,0x26cf8cc7,0x62966cac}},	// [76c0] kona, guću, dego_, rayo,
   {{0x6d4394e0,0x62966cad,0x2eed808e,0x224b01e0}},	//   jona, sayo, _anef_, _dyck_,
   {{0xf9f980ab,0x6296033e,0x224b0118,0x3f9c00e7}},	//   েছিল_, payo, _eyck_, évu_,
   {{0x6d4e636c,0x8fa30d46,0x443a002a,0xd7ef00f7}},	//   llba, раце, _ixp_, تكم_,
   {{0xdb1e0063,0x9db7845a,0x6d43abee,0xe7699c12}},	//   _wspó, ندوز_, fona, رحمن_,
   {{0x80c10bb8,0x6d43e1cd,0x260e82f1,0x6b558084}},	//   र्दे, gona, तैषी_, _išgy,
   {{0x25ee809a,0x61e6026c,0x60dc0834,0x59e00035}},	//   _आपकी_, _hrkl, _iarm, निवर,
   {{0x26cf809a,0x61d895a6,0x61e600fe,0x6d4e0192}},	//   cego_, емия_, _krkl, hlba,
   {{0x6d439e98,0x0566917e,0x6f008083,0x6b4584f0}},	//   bona, _аван, _iomc, tógr,
   {{0x6d43da8f,0x61e6017f,0x998d8035,0x70ac8072}},	//   cona, _mrkl, dzeń_, चलेल,
   {{0xd0078003,0xf6518065,0xb4ae8935,0x3cdb81ab}},	//   веќе_, _نئے_, कली_, _गोटे_,
   {{0x60dc6629,0x75270a0f,0x6f0080b9,0x7c3a82a6}},	//   _larm, wijz, _jomc, _ixtr,
   {{0x6f0380a9,0x6f008024,0x6b45816a,0x7527090d}},	//   ênci, _momc, pógr, tijz,
   {{0x26cfecae,0x25f5816f,0x062423e7,0x6f00ba16}},	//   zego_, ्हती_, рфюм, _lomc,
   {{0x212ba246,0x752700f3,0x26cf82e7,0x57d106ae}},	//   èche_, rijz, yego_, _सनेह,
   {{0x6d4e0998,0xdb0701d0,0x26cfecaf,0x6d48810c}},	//   alba, pují, xego_, _lkda,
   {{0x998d809a,0x61e4811f,0xc093046d,0x2fca05ee}},	// [76d0] czeń_, _šilj, _aláṣ, _apbg_,
   {{0x26cfecb0,0x67240025,0x2bab0105,0x764d04b9}},	//   wego_, _zmij, _छिपा, _iyay,
   {{0x3d080063,0x26cfecb1,0x60dc6cb2,0x61e66cb3}},	//   _सकते_, tego_, _darm, _erkl,
   {{0x6d48ecb4,0x2bf2001b,0x6d43ecb5,0x7982ecb6}},	//   _akda, ीहरू_, wona, _otow,
   {{0x6d43ecb7,0x26cf823b,0xddc581a0,0xdca595b7}},	//   tona, rego_, убли, гали,
   {{0xe79500d5,0x7b030074,0x26cfecb8,0x3f4782f1}},	//   _مارک, _tõus, sego_, tõus_,
   {{0x5f946cb9,0x6f0080b9,0x7982d413,0xe7870251}},	//   _вист, _fomc, _atow, _југо,
   {{0xe9d99eef,0xf1b78105,0x799b8300,0x6d43ca2b}},	//   еки_, _आमदन, tsuw, sona,
   {{0x6d43ecba,0x764d0a5a,0x60dc6cbb,0x7aef0573}},	//   pona, _nyay, _yarm, _mnct,
   {{0x672402fd,0x32090079,0x6d438079,0x29118c83}},	//   _smij, iyay_, qona, óza_,
   {{0xd8258103,0x26d983a8,0x60259bcc,0xe4f08054}},	//   удни, _ósos_, удна, चारि_,
   {{0xa3e705b3,0x9c1481bc,0x7b0a03c1,0x290c82c4}},	//   पिन_, _kọnz, _výuk, akda_,
   {{0x64400085,0x24980197,0x61e901a1,0xdb1c03ed}},	//   əmiy, tarm_, _šeln, strë,
   {{0x69d999e7,0x7afbad2e,0x998d8035,0x5887a462}},	//   _iswe, ljut, rzeń_, _рыда,
   {{0xf99f0205,0x6d4e0101,0x32090079,0x61e60267}},	//   _avè_, rlba, eyay_, _srkl,
   {{0x7afb8500,0x672406ec,0x28c6170c,0x80c1559b}},	//   njut, _umij, र्नि, र्से,
   {{0x60dc6cbc,0xdb1c19a7,0x7f3b03de,0x387f011c}},	// [76e0] _parm, ntré, _רעפו, _şura_,
   {{0xe9d701bb,0xfd690870,0x7f49913b,0x61e600c3}},	//   ыку_, _mkpụ, _akeq, _vrkl,
   {{0x60dc2924,0xa68689b8,0xdee6b51e,0xbeaa803d}},	//   _varm, глед, ложи, فهان_,
   {{0x69cba40d,0x6d5a820f,0xee3a8a8e,0x7f5b8144}},	//   _opge, _shta, нне_, _chuq,
   {{0x7d018510,0x7afb90d3,0x2579823e,0x1c1c82f1}},	//   _bols, djut, _cèl_, _भेजल_,
   {{0x7d01ecbd,0x394587f1,0x25798f33,0x6ab66cbe}},	//   _cols, jols_, _dèl_, lgyf,
   {{0xfd690135,0x69d9ecbf,0x61e46cc0,0x6e3b913b}},	//   _akpụ, _aswe, lvil, _exub,
   {{0xdced011c,0x29038338,0x6ab60428,0x25798242}},	//   _otağ, öjan_, ngyf, _fèl_,
   {{0x7d01ae6c,0x62348cdf,0xee378081,0x3914ccf4}},	//   _fols, репу, _бнт_, имир,
   {{0x41bb00be,0x64568085,0x973d026c,0x91bb03de}},	//   עציע, əyin, mrći, עמיי,
   {{0xbf10035a,0x473514d6,0x5ede00ab,0x58f700be}},	//   ासून_, инос, যানে, אמיע_,
   {{0x7bdaecc1,0xa3e19094,0xd6db0221,0x61e46cc2}},	//   _istu, दिर_, хто_, kvil,
   {{0x776d062f,0x3fc8804e,0x2bd08035,0x160c01a2}},	//   _viax, ردگی_, थौरा, हनगर_,
   {{0x61db84de,0x61e4623a,0x69c08084,0xdb1a841c}},	//   _נקוד, dvil, mtme, _estô,
   {{0x94058201,0x61e4573d,0xa87b8039,0x69c0ecc3}},	//   _belə_, evil, _ארוח, ltme,
   {{0x2bac8d1c,0x2d848699,0x69c08cda,0xd5d48072}},	//   _घटना, _otme_, otme, _धनंज,
   {{0x69c0ecc4,0x3f9ec003,0xa5f90012,0xdb03841c}},	// [76f0] ntme, lstu_, _репу_, sunç,
   {{0x69c0d21b,0x7bda8074,0x3209057b,0xa3b5916e}},	//   itme, _ostu, ryay_, _जमल_,
   {{0x2579d93d,0x7d0186a8,0xff07a133,0x6d47014c}},	//   _sèl_, _rols, лядн, moja,
   {{0x7d01ecc5,0x2d9d82a0,0x3f9ed7d8,0xd5fb819d}},	//   _sols, tswe_, istu_, _ndụ,
   {{0x7d01909b,0xdb070125,0x6cf086af,0x51841501}},	//   _pols, stjó, चांग_, _гуса,
   {{0x3f9eaec0,0x6d471ffe,0x290f00eb,0x63a5801b}},	//   kstu_, noja, īgas_, áhno,
   {{0xaa0d800d,0x9992009a,0x7d01c549,0x3945823e}},	//   िन्छ_, czył_, _vols, vols_,
   {{0x29030f84,0x7d01ecc6,0x3d10826b,0x69c08e20}},	//   _hoja_, _wols, _fàwo_, ftme,
   {{0x29030025,0x7afb8006,0xf4d98ae7,0xa2dd0105}},	//   _koja_, rjut, _имаш_, _पसन्,
   {{0x672bb518,0xdb1c0c83,0x7d0180b9,0x7afb94c7}},	//   ligj, rtré, _uols, sjut,
   {{0x2903264b,0x6d471482,0xdb1c6cc7,0x7b15802a}},	//   _moja_, doja, stré, _cáuc,
   {{0x290300a9,0xf746264e,0x3945907c,0x96661bb6}},	//   _loja_, ремо, sols_, икне,
   {{0xe7374b8d,0x6d47441a,0xf1d9801b,0x69d9ec75}},	//   рея_, foja, _भनिन, _uswe,
   {{0x2bdc9344,0x2bda903e,0x2ed280a5,0x7c3883ed}},	//   _मनमा, भिचा, _सस्त, _çarç,
   {{0xe29a05c2,0xfc031033,0xab2a004a,0x5ecb0264}},	//   кав_, опро, вова_, িয়ে,
   {{0x672b820f,0x25a0004a,0x628d02d5,0x6a864bfc}},	//   jigj, _tvil_, gbao, рлаа,
   {{0xdca63b4c,0x64a60b01,0xcb670328,0xa9261343}},	// [7700] _капи, _капа, рате_, адал,
   {{0x0ce080ab,0xa0a61cce,0x29030dd7,0x236f8168}},	//   _বক্ত, ражд, _coja_, _ligj_,
   {{0x9c7c811f,0x29030168,0x98be8ec3,0x629b83e4}},	//   _jače, _doja_, notā_, kauo,
   {{0xeab2003f,0x539b0051,0x52753cb3,0x61e4345e}},	//   _بعد_, _ביטו, _гуру, pvil,
   {{0xd838941f,0x80c100d4,0x25a080f7,0x6f040035}},	//   mače_, _रॉके, éil_, _moic,
   {{0xd8388669,0xdc19009a,0x290303ed,0xa4d4902a}},	//   lače_, _włąc, _goja_, сокі,
   {{0x6f16016d,0xf8c61664,0x28c6073c,0xed578eef}},	//   _olyc, र्णय, र्णि, јој_,
   {{0xa3e705e8,0x2ba7800f,0x31c6a155,0xd838c8f0}},	//   पित_, _गिरा, асов, nače_,
   {{0x8af00201,0x7d01007b,0xd257943b,0x28c62b51}},	//   lməs, ölsk, иць_, र्थि,
   {{0xdde98077,0x9c7c8289,0x69c08039,0xc8669ddf}},	//   _حرفه_, _bače, rtme, итни,
   {{0x6d476cc8,0x6f046cc9,0x7bdadb5d,0x69c0a4cf}},	//   voja, _boic, _ustu, stme,
   {{0x28c6000c,0x3f9e9ab2,0x6d476cca,0x6f0428c9}},	//   र्ति, rstu_, woja, _coic,
   {{0x6d4706f7,0x2ee02d68,0x6f0400f7,0xd838936f}},	//   toja, _daif_, _doic, dače_,
   {{0x6d470084,0x7afd8338,0x644d89ab,0xf806804a}},	//   uoja, östv, ƙait, _вчин,
   {{0x6d476ccb,0x9f591931,0x29036ccc,0x8af00201}},	//   roja, áró_, _roja_, ymət,
   {{0x29036ccd,0xd8388353,0x200f826f,0x3a751957}},	//   _soja_, gače_, íliš_, слар,
   {{0x9c7c8db7,0x6d47365d,0x212c8090,0xcad781c6}},	// [7710] _zače, poja, oidh_, סומת_,
   {{0x6cd50bca,0x777881c0,0x7c3e00b9,0x27ea0706}},	//   _اقدا, _kuvx, _fxpr, _brbn_,
   {{0xd8388904,0x20070087,0x39498118,0x29030088}},	//   bače_, âni_, _íase_, _voja_,
   {{0x63678019,0x7d05026c,0xb95b026b,0x35f5902a}},	//   _tűni, _hohs, _apìt, йпер,
   {{0x8af0011c,0x645a9fa4,0xe4ec108a,0x7c3b0850}},	//   rmət, _azti, _छोडि_, ğuru,
   {{0x28c606bf,0x69dd3975,0x62828091,0x973d026c}},	//   र्दि, _isse, _afoo, mrću,
   {{0xab29979e,0x443e8118,0x3edf0032,0x6ee181bc}},	//   лока_, _cxt_, _agọọ_, _ịbuw,
   {{0x5c380039,0x443e8118,0x2bb88035,0xd43801c6}},	//   ירון_, _dxt_, _इमरा, יטוי_,
   {{0x3ce28076,0x672984cd,0x9c7c90d3,0x212c80f7}},	//   _टोके_, _imej, _sače, fidh_,
   {{0x2903807b,0xa3c906af,0x6f0401a8,0xa2c934ec}},	//   ðja_, ोबा_, _soic, _हॉस्,
   {{0x6f040081,0x311d914f,0x66e662ab,0x2011b835}},	//   _poic, योगः_, бона, ázi_,
   {{0x6d5e00f1,0x212c8068,0x69dd1fe4,0x27320353}},	//   _shpa, aidh_, _osse, kšne_,
   {{0x99858013,0xd83887df,0xda788698,0x7d0500ee}},	//   _التو, vače_, _тях_, _bohs,
   {{0x30798158,0x332d81b9,0x9c7c81a1,0xd5fa825f}},	//   _גאַנ, liex_, _tače, אפשר,
   {{0xd838826f,0x69dd3277,0x67298353,0x62999a03}},	//   tače_, _asse, _omej, _kewo,
   {{0x673ba0a7,0x62998247,0xf7431fcb,0x9f485292}},	//   _njuj, _jewo, _нещо, _orné_,
   {{0xd83884c4,0x6299db41,0x61fb913b,0x7bc386ae}},	// [7720] rače_, _mewo, nxul, htnu,
   {{0x673b8870,0x320d8079,0x6729804f,0x644802f1}},	//   _ajuj, iyey_, _amej, üdis,
   {{0x69dd2a4b,0xd8388369,0xa1568039,0xa2d8903e}},	//   _esse, pače_, צבעה_, _मसल्,
   {{0x7bde003a,0xe61a8088,0xdfcf1ddd,0x63ae928d}},	//   _ispu, лде_, عين_, _åbni,
   {{0xdb1c282b,0xa50a89a0,0x1d0aa0bf,0x67298609}},	//   ntrí, леда_, леди_, _dmej,
   {{0x7ae46cce,0x69c40612,0x6729b861,0x62998242}},	//   ldit, mtie, _emej, _aewo,
   {{0x62998574,0xdee68cdf,0x320d8079,0x61eb8428}},	//   _bewo, _лови, eyey_, _argl,
   {{0xef91003d,0xa03701c6,0x5214a3e7,0x2b4082d4}},	//   _آیند, _האלה_, ждит, čico_,
   {{0x64a6a18c,0x80dc80c8,0x629983ec,0x249a0388}},	//   _газа, বাস্, _dewo, _oepm_,
   {{0xf8d80321,0x69c46ccf,0xdce981b9,0x7ae46cd0}},	//   ड़िय, itie, _tweġ, hdit,
   {{0x32ca8b71,0x212c8ad0,0x332d84b7,0x6d4ac184}},	//   _было_, ridh_, biex_, mofa,
   {{0x62998574,0x69c444a9,0xab66838b,0x61e48110}},	//   _gewo, ktie, _увел, _šilu,
   {{0x5fda8e1a,0x7ae41e41,0x7bde6cd1,0xf8d806a7}},	//   _बनवल, ddit, _aspu, ड़ाय,
   {{0x80dc80ab,0x5f9495b7,0xa3ac86a7,0x63b5017f}},	//   বাহ্, _дикт, _कटा_, tuzn,
   {{0x7ae28074,0x93880009,0xdb1c0333,0xac181027}},	//   _kaot, йста_, atrí, бору_,
   {{0x69c4270c,0x15fa92c7,0xd138d5f8,0x28c60cf0}},	//   ftie, ्हार_, lną_, र्सि,
   {{0x7bde3ef3,0x7ae29581,0x90991ef8,0xd0438326}},	// [7730] _espu, _maot, иват_, _banɗ,
   {{0x6729c28e,0x672f009a,0x29c2807b,0x7bc3826f}},	//   _smej, licj, iða_, ytnu,
   {{0x660f00f2,0x69c420b5,0x7ae40609,0xb901123a}},	//   lyck, atie, bdit, _दस_,
   {{0x69c420e3,0xb65a0091,0x636f026b,0xd366a3c8}},	//   btie, _abẹ́, _dònì, _زه_,
   {{0xd24691fb,0x69c444c8,0xf77092dc,0xf8a9003d}},	//   _آن_, ctie, رام_, _نگاه_,
   {{0x212a02af,0x629f008e,0x25a9ecd2,0xd0438326}},	//   _gmbh_, laqo, šalo_, _ganɗ,
   {{0x7ae286e7,0xd138809a,0xff538060,0xfd59826b}},	//   _baot, dną_, _فخر_, _kubẹ,
   {{0x17689109,0x130980e8,0xd1388110,0x3eb98257}},	//   _груп_, рний_, eną_, _øst_,
   {{0x659499b5,0x7ae2833e,0x28c61c42,0xdc0501a2}},	//   _нату, _daot, र्वि, रहुड_,
   {{0x660f01d0,0x77c997c7,0xaca40133,0x61eb8824}},	//   dyck, алог_, twọk, _vrgl,
   {{0x69c4011e,0x672f051c,0x61e488fc,0x7ae2851e}},	//   ztie, ficj, _šilt, _faot,
   {{0x7ae28635,0x798d00e4,0xfbd081f9,0x657b9ae3}},	//   _gaot, kpaw, _ستم_, _kuuh,
   {{0xa3e18778,0x69c404b7,0x98a591d5,0xd54a01a8}},	//   दिक_, xtie, _диле, لجسم_,
   {{0x9c7c8b67,0x3ea90722,0x3f6600e7,0xdd7a80be}},	//   _kača, _edat_, _cœur_, יטשל,
   {{0x61e98364,0x9c7c8052,0xeb9a0558,0x68e39149}},	//   lvel, _jača, риб_, _iand,
   {{0x6f1d01ec,0xa3ea890f,0x29078102,0x16098c28}},	//   chsc, मित_, _hona_, वहार_,
   {{0x68e3ecd3,0xfce6095a,0x2907ecd4,0xf2d2898a}},	// [7740] _kand, _допо, _kona_, וען_,
   {{0x68e3a823,0x29078c30,0xe8f73de7,0xd838b8b7}},	//   _jand, _jona_, олу_, lača_,
   {{0x68e3dc68,0x2907a900,0x28c606bf,0x7bde005c}},	//   _mand, _mona_, र्षि, _uspu,
   {{0x69c46cd5,0xa3c90b86,0x2907c60c,0x645e6cd6}},	//   ptie, ोबर_, _lona_, _izpi,
   {{0x6d4a8541,0x212a00dd,0xbebb0168,0xe5a3802e}},	//   tofa, _tmbh_, shëg, дичи,
   {{0x68e3ecd7,0x62841f65,0x7ae28c5e,0x28c64476}},	//   _nand, lcio, _saot, र्शि,
   {{0x26c002ba,0x61e99de6,0x7ae297c9,0xa4fb35c4}},	//   _ocio_, evel, _paot, ילסט,
   {{0xf1a68c8e,0x68e390f4,0x9c7cb78b,0xe73a8098}},	//   орон, _aand, _dača, _теб_,
   {{0x2907ecd8,0xd8388503,0x628406a5,0x80ca016f}},	//   _bona_, dača_, icio, स्थे,
   {{0x68e3c089,0x29c28125,0x2918ecd9,0x26c00118}},	//   _cand, rða_, óra_, _acio_,
   {{0x68e3ecda,0x2907ecdb,0x7ae28074,0x6f1d5b9e}},	//   _dand, _dona_, _taot, thsc,
   {{0x660f151f,0xd8388669,0xd1388035,0x80ca0b84}},	//   tyck, gača_, sną_, स्ते,
   {{0x9c7c9807,0x68e3ecdc,0xfa3680d5,0x645e0102}},	//   _zača, _fand, _براد, _azpi,
   {{0x32d50028,0x62861412,0x660f016d,0x29078041}},	//   _ấy_, _afko, ryck, _gona_,
   {{0xc04f9a84,0x7d08813c,0xd838842b,0x9c83816b}},	//   _ці_, _mods, bača_, _účes,
   {{0x68e3d74d,0xd83880fe,0x6aa081f8,0x398082d6}},	//   _zand, cača_, namf, _kòs_,
   {{0x68e3ecdd,0x29078418,0xbebb0a53,0x290105e7}},	// [7750] _yand, _yona_, biër, tjha_,
   {{0x6284349a,0x68e3ecde,0x26d96cdf,0x98ac8110}},	//   acio, _xand, leso_, rodė_,
   {{0x974300ce,0x3cfe81fe,0x61e9ece0,0x657ba551}},	//   šćuj, लाने_, zvel, _suuh,
   {{0x62846ce1,0x7d1a8bc5,0x63b8a35d,0x9c7cc573}},	//   ccio, _alts, duvn, _rača,
   {{0xfe7083f8,0x672d3462,0x291e84bf,0x2369008e}},	//   نده_, _mmaj, khta_, mmaj_,
   {{0xd8388024,0x039582bc,0x7d088079,0xb4d582f1}},	//   zača_, прия, _cods, िजे_,
   {{0x8ccd000f,0xeb99aa46,0x7ed792dc,0x629d0359}},	//   द्यो, щий_, _وزرا, _keso,
   {{0x11d980f7,0x27320353,0x629d00e5,0x61e9cc05}},	//   موعة_, kšna_, _jeso, tvel,
   {{0xdb1c4b7e,0xd83882a5,0x629d236f,0x29078915}},	//   ntrá, vača_, _meso, _pona_,
   {{0x2ba58029,0x68e3bdd5,0x7d08a171,0x9c7c9c67}},	//   pēc_, _qand, _gods, _tača,
   {{0xd838842b,0x6f1b94df,0x777c01df,0x61e99c77}},	//   tača_, _kluc, _xurx, svel,
   {{0x68e383c3,0xe73a284f,0x3ce58082,0xe6460e8e}},	//   _wand, сем_, _halv_, земп,
   {{0xe9ce9439,0xd838803a,0x2907ece2,0x645e009a}},	//   _як_, rača_, _tona_, _szpi,
   {{0x291ebfe5,0x81c100ab,0xb4c802f1,0x6f1bc994}},	//   chta_, ংবা_, ोजे_, _lluc,
   {{0x629d6ce3,0xd83882a5,0xbebb1699,0x26d902c4}},	//   _beso, pača_, riër, beso_,
   {{0x26d9160a,0x98a5802e,0x629d3003,0x26c000d2}},	//   ceso_, bilă_, _ceso, _ucio_,
   {{0x28c2901b,0x61ed803a,0x25a982a5,0xf1b9ece4}},	// [7760] _शामि, _šalj, šalj_, nuš_,
   {{0x672d369f,0x62843227,0x78a1a25b,0xdb1c023e}},	//   _zmaj, scio, nalv, strà,
   {{0x629d0980,0x6f1b8037,0xa5bb4aa6,0x6f09dc60}},	//   _feso, _bluc, nzón, _boec,
   {{0x444404b7,0x629d079f,0x78a1dcc4,0x3f8707d0}},	//   _ix_, _geso, halv, ínua_,
   {{0x6f029770,0x7d08890f,0x5fdda0d5,0x50bd81a2}},	//   rjoc, _pods, _फैसल, ्भाष,
   {{0x3ea2092e,0xa06a046e,0x78a18144,0xdb0ab45e}},	//   hakt_, _гага_, jalv, ntfö,
   {{0xe7b680ab,0x7d08ab09,0x3dc6ece5,0xdb0701d6}},	//   _জন্য, _vods, stow_, vujú,
   {{0xdee3ece6,0x6120017b,0x66e3a80f,0xa03b00be}},	//   _поси, _bölg, _поса, _העלפ,
   {{0x6d4e28de,0xcad7010f,0x7ae60687,0x63b885b9}},	//   koba, לוקת_, _makt, suvn,
   {{0x672d14da,0x9c7c905e,0x78a19482,0x290a0091}},	//   _smaj, _začn, galv, _joba_,
   {{0x6d4e6ce7,0x26d96553,0x25a682d5,0xdb0700e1}},	//   doba, teso_, lsol_, rujú,
   {{0x3f8a8341,0x7ae61c1f,0x291eb87b,0x200282a5}},	//   ību_, _nakt, shta_, ćki_,
   {{0x629d30cc,0x6d4e6ce8,0xdb0700e1,0x9c7c80fe}},	//   _reso, foba, pujú, _jačo,
   {{0x6d4e156c,0x60188098,0x26d92087,0x629d6ce9}},	//   goba, _моля_, seso_, _seso,
   {{0x629d6cea,0x7ae647ea,0x26d96183,0x291ceacb}},	//   _peso, _bakt, peso_, _ilva_,
   {{0xe7f00a0d,0x7ae600f1,0x083b8496,0x60dad868}},	//   घटना_, _cakt, _לעול, letm,
   {{0x7ae60f6e,0x9f479a07,0x6d4e2f26,0x629d02d4}},	// [7770] _dakt, íní_, boba, _veso,
   {{0x290a0854,0x629d3937,0x60da8214,0x236901a1}},	//   _coba_, _weso, netm, smaj_,
   {{0xdb1c6ceb,0xdbdc0144,0xa3e1108a,0x59ac0c28}},	//   strá, báñe, _धनि_, _चिअर,
   {{0x25a90b81,0x61e2936f,0xde1981a8,0x657f01f6}},	//   _kval_, _osol, يقات_, _kuqh,
   {{0x6f1b80f3,0x84e58073,0x63658118,0xa5098185}},	//   _vluc, долж, lóng, жела_,
   {{0x3ea21799,0xd83882d4,0x65770372,0x7ae65c9a}},	//   zakt_, jačo_, _jixh, _zakt,
   {{0x44446cec,0x9c7c9601,0x67d4204c,0x61e2ac88}},	//   _xx_, _tačn, _пору, _asol,
   {{0x68e76b5a,0x7b1581ac,0x6d4e3327,0x63a8808e}},	//   _hajd, _záuj, zoba, _dvdn,
   {{0xe29f1c86,0x78a19753,0x61200019,0xc245a45b}},	//   _með_, talv, _föld, ьник,
   {{0x80bd816f,0xdb0380f7,0x36e606a7,0xaca381bc}},	//   _शाळे, isné, _जोड़ी_, _maịl,
   {{0xf7460b26,0x3ea254c2,0x2ba780d4,0xa9c4803d}},	//   дено, takt_, _गिटा, وزیو,
   {{0x61200019,0x272200ff,0x291c97ab,0x09f981a8}},	//   _zöld, _móng_, _elva_, _وفاة_,
   {{0x6d4e1f3a,0x7ae66ced,0x3ea204fe,0x44446cee}},	//   toba, _rakt, rakt_, _sx_,
   {{0x68e71eee,0x7ae9ecef,0x7ae654bb,0x61ed6cf0}},	//   _najd, ldet, _sakt, dval,
   {{0x6d4e3724,0x290a1b2a,0x27220028,0x7ae600f1}},	//   roba, _roba_, _nóng_, _pakt,
   {{0x6d4e0cb7,0x7ae9ecf1,0xc0528039,0x8f9a8496}},	//   soba, ndet, _שזה_, _ויקי,
   {{0x69c9c1ec,0x26d20578,0x7ae60357,0xc3328039}},	// [7780] ntee, _ibyo_, _vakt, דון_,
   {{0x7ae60393,0x27220028,0x3ead8214,0x68e701c0}},	//   _wakt, _bóng_, _adet_, _cajd,
   {{0x28cf95fb,0x7ae66cf2,0x69c98364,0x3ce706af}},	//   त्यि, _takt, htee, _छोटे_,
   {{0x7ae9bc8a,0x69c9ecf3,0x3a3f2bea,0xa25b00e7}},	//   jdet, ktee, _župe_, _icôn,
   {{0xd6e080c8,0x68e74411,0xa5da915f,0x7ae9ecf4}},	//   ণালয, _fajd, تبار_, ddet,
   {{0xa3ea901b,0x3ea0007b,0x09bc80c8,0x27320353}},	//   मिल_, _leit_, _অনলা, kšno_,
   {{0x25a6bda4,0xdb1c006a,0x63bc01fa,0x2d800bfd}},	//   ssol_, rtræ, nurn, _luie_,
   {{0xf8ce801c,0x69c9aa06,0xdb1c4660,0x8af00085}},	//   _cứng_, ftee, stræ, zlən,
   {{0xdb1c0efa,0x63bc6cf5,0x69c981b4,0x67228c53}},	//   mträ, hurn, gtee, mhoj,
   {{0x6aa403ae,0x63bc6cf6,0xdb1c05ec,0x26d21088}},	//   haif, kurn, lträ, _abyo_,
   {{0x8c3c87d9,0x2018ecf7,0x9c8383fb,0x60da8214}},	//   _beğe, ári_, _účas, retm,
   {{0xdb1c0b2f,0x63bc6cf8,0x7d1e1b39,0x69c98079}},	//   nträ, durn, _alps, btee,
   {{0x8c3c87d9,0x69c98a0f,0x673d1be9,0x61e28234}},	//   _değe, ctee, rnsj, _usol,
   {{0x61ed564f,0x26d202ec,0x63bc6cf9,0x63b5066f}},	//   vval, _ebyo_, furn, trzn,
   {{0x63bc003a,0xc60700c8,0x3ea02ca2,0x69a41513}},	//   gurn, _লেখা_, _feit_, _चौबी,
   {{0x61ed81e2,0xe2f801e5,0x61ed07b3,0xa3b68035}},	//   _šali, месі_, tval, _जिन_,
   {{0x62340134,0x80c800c8,0x68e76cfa,0x2722001c}},	// [7790] вету, রজন্, _pajd, _sóng_,
   {{0x3ea00352,0x7ae98019,0x644501e9,0x3f871243}},	//   _zeit_, zdet, _txhi, ínuo_,
   {{0x61ed0f52,0x753540ba,0x69c98102,0xf6500019}},	//   sval, mizz, ztee, _مئی_,
   {{0x753509ba,0x19951006,0xd2500117,0x6f0d23ed}},	//   lizz, _памя, انے_, _joac,
   {{0x25a98fcf,0x2ee90867,0x68e700ee,0xa3e7063a}},	//   éal_, _maaf_, _tajd, पिक_,
   {{0x753501c1,0x2edc0996,0x2366826f,0x7bca84e1}},	//   nizz, _बस्त, _ahoj_, ftfu,
   {{0xc7c416d4,0x4fc40191,0x78a502f7,0x43758162}},	//   _исти, _иста, mahv, нуит,
   {{0x69c98364,0x23668069,0x753501e8,0x67228c53}},	//   ttee, _choj_, hizz, choj,
   {{0x7ae99d6b,0x28cf18b1,0xe1f1806b,0x26dd8247}},	//   rdet, स्थि, اسب_, mewo_,
   {{0x3ea00352,0x7ae9b119,0x26ddecfb,0x6aa46cfc}},	//   _seit_, sdet, lewo_, zaif,
   {{0x753504b7,0x69c9938e,0x637581a1,0x6f0d6cfd}},	//   dizz, stee, _ušno, _boac,
   {{0x69c9e744,0x28cf000c,0x61200061,0x501a01c6}},	//   ptee, स्ति, _kölc, פורו,
   {{0x4a9a80be,0x3ea00357,0x6b819bc8,0xdb1c0aaa}},	//   _זינג, _veit_, _hulg, ntrå,
   {{0x3ea001ec,0x2b4200b9,0xc0e2beb1,0x6b8186ae}},	//   _weit_, _sjkc_, _бошк, _kulg,
   {{0x6aa400f6,0x6b81c9cf,0x680a8085,0xf8b2825f}},	//   taif, _julg, nədl, _עשה_,
   {{0xf7d68039,0x0cdc8743,0x2ee91306,0x6289ecfe}},	//   _נופש_, _यस्म, _gaaf_, nceo,
   {{0xe9d74365,0x6df300f7,0x6aa42bbe,0x75356b4b}},	// [77a0] нкт_, _مكيا, raif, bizz,
   {{0x7535047f,0x63bc6cff,0x7e6423a0,0xebe61383}},	//   cizz, purn, _izip, _зооп,
   {{0xf1ac0540,0xe50380c2,0x28c283eb,0x749b01c6}},	//   _चिकन, लानि_, _शासि, _מייפ,
   {{0x28cf8b3b,0xe5c6a804,0x26c23f06,0x73e32306}},	//   त्ति, еско, ngko_, _союз,
   {{0xdb1c3a53,0xceb304de,0xed5a8eef,0x127b03de}},	//   rträ, ריד_, под_, _מאכע,
   {{0x61e6003a,0x53e6817a,0xdb1c6d00,0x09d880ab}},	//   _iskl, ециа, strä, তিমা,
   {{0xd9430a94,0x99bc80c8,0x61430110,0xdb1c0106}},	//   _сери, _অনেক, _сера, pträ,
   {{0x200d0059,0x9c7ca30a,0x2b401c83,0x28c281fe}},	//   çmiş_, _kačk, nnic_, _शाहि,
   {{0x7e6401bc,0xf98f9190,0x2b404909,0x2bac8072}},	//   _nzip, یبی_, inic_, _घटका,
   {{0x2b40237a,0x9c7c931b,0x6fc4016f,0x6b81805f}},	//   hnic_, _mačk, ांपू, _fulg,
   {{0x4438e71b,0x6f0d555f,0x7535022b,0x23668069}},	//   _är_, _poac, vizz, _thoj_,
   {{0x3cfe9d01,0x78a500d2,0x29038106,0x09d880ab}},	//   लावे_, zahv, öjar_, তিবা,
   {{0x7535235a,0xd6e300ab,0xe33780be,0x657a8c14}},	//   tizz, যালয, _אראפ_, _kith,
   {{0x636580ab,0x2b40805c,0x645a816b,0x22590338}},	//   róne, čicu_, _kyti, _rysk_,
   {{0x753540ba,0x6b8184c3,0xd90e826a,0xf3670705}},	//   rizz, _xulg, _نیک_, етан,
   {{0x67d3000d,0x9c7cdbb4,0x75356b4b,0xdbdc016a}},	//   nějš, _bačk, sizz, _cáña,
   {{0x3a75196e,0x7b64160f,0x290e8041,0x680a8085}},	// [77b0] тлар, утре, _kofa_, zədl,
   {{0x657aed01,0xb4df816f,0x98be81d0,0x52dd864a}},	//   _nith, _तसे_, votě_, _मस्स,
   {{0x7b1c82be,0x61e66d02,0x43950993,0x78a518c2}},	//   _réun, _eskl, _шанс, rahv,
   {{0xf77088ca,0x657a954c,0x8ccd0996,0xdb01803e}},	//   مان_, _aith, द्रो, _ovlá,
   {{0x6463003b,0x645a8176,0x657a8c49,0x6b8182f1}},	//   štić, _ayti, _bith, _sulg,
   {{0x7aed0dde,0x271e090f,0x6b81ed03,0x657a803d}},	//   ldat, _पत्र_, _pulg, _cith,
   {{0x657a81e4,0xdb1c0bbd,0x7aed0e8e,0xfaf181a8}},	//   _dith, strå, odat, لثة_,
   {{0x6b81d787,0xf99f0247,0xb4cd0bb8,0x657aa73d}},	//   _vulg, _kwè_, रभु_, _eith,
   {{0x657a9995,0xf99f06c0,0x645a9761,0x628988d8}},	//   _fith, _jwè_, _eyti, rceo,
   {{0xdb1c0168,0x7982d818,0x9f5f04e8,0x3f83304e}},	//   turë, _duow, rytý_, _kuju_,
   {{0x3f83063e,0x9783803d,0x7afd000b,0x2ca7b96a}},	//   _juju_, دیبه, _onst, mand_,
   {{0xa29580e8,0x657a8234,0x765b808e,0x2d9f8133}},	//   _раді, _zith, _kyuy, _kwue_,
   {{0xd00e853d,0x2b404453,0x290ea32d,0xf99f06c4}},	//   ملی_, vnic_, _fofa_, _nwè_,
   {{0x7afd29ed,0x2ca79598,0xe0d985a8,0xdbdc01fa}},	//   _anst, nand_, _цвк_, _báða,
   {{0x64a327ae,0xdb0183fb,0xfaa6096b,0xdca31509}},	//   раса, _zvlá, каво, раси,
   {{0x78a38bc5,0x2b0486b7,0x7aed009c,0x2ca7ed04}},	//   _henv, वायु_, gdat, hand_,
   {{0x7aebacf5,0xe8ea0087,0x21a610ef,0x02e20105}},	// [77c0] _magt, ммад_, тизм, _पसीन,
   {{0x7afd0bd6,0x31230196,0x2ca7b962,0x7aeba67f}},	//   _enst, адуг, jand_, _lagt,
   {{0xb4663fe7,0x657abc69,0x3f8300d2,0x25ad9f6c}},	//   _школ, _rith, _cuju_, _avel_,
   {{0x7aeb9066,0x9c7c9408,0x28c60af3,0x657abaa0}},	//   _nagt, _tačk, र्जि, _sith,
   {{0x776982a3,0x54360416,0x67d3001b,0x657a8387}},	//   _dhex, _سرگر, vějš, _pith,
   {{0xd9461e7d,0x2ca7ed05,0x61466d06,0x61e40c53}},	//   _реги, gand_, _рега, mwil,
   {{0xc7a32596,0x9c7c8668,0x8fa6373a,0x7bce5743}},	//   _виск, _jači, _шаве, ntbu,
   {{0xdd92806b,0x657a8051,0x645a850f,0x9f4a8722}},	//   _نور_, _with, _vyti, _urbà_,
   {{0x78a3ed07,0xe737e2ab,0xd8389b39,0x9966bbae}},	//   _benv, _рет_, mači_, ктол,
   {{0xd1050a74,0xd838811f,0xd83a81e5,0x8af00085}},	//   रायण_, lači_, дэм_, rməy,
   {{0x61edc24d,0x94069ef7,0x2d9205ee,0x61e46d08}},	//   _šalt, _جواه, _atye_, hwil,
   {{0xb8f989a3,0x78a385f8,0xd838a944,0x65950087}},	//   _डॉ_, _eenv, nači_, ламу,
   {{0xa3ea83eb,0x61e400f3,0xa3de809a,0x290ee639}},	//   मिक_, jwil, दौर_, _tofa_,
   {{0xc27b8f60,0x78a3832b,0x2d84804f,0xba3b0cfa}},	//   _חרדי, _genv, _mume_, _beïn,
   {{0x69c0ed09,0x2d84ed0a,0xd8389502,0x46b48697}},	//   lume, _lume_, kači_, ुलाह,
   {{0x28c60076,0xc8c63852,0x3ea4813c,0xd1389f80}},	//   र्घि, र्घट, _nemt_, lią_,
   {{0x9c7c8eef,0x2d84802e,0x60f913cd,0x7aed1b25}},	// [77d0] _dači, _nume_, нная_, rdat,
   {{0x7bda803b,0x7aed3e4b,0xdce8801b,0xdbde8118}},	//   _optu, sdat, _vidě, _líña,
   {{0x7aed0186,0x76b9ed0b,0xba3b03b2,0x69cd64e3}},	//   pdat, елер_, _geïn, stae,
   {{0x9c13819d,0xd838811f,0x63ba00e1,0x9c7c85f3}},	//   _bọnk, gači_, átne, _gači,
   {{0x2d84abcb,0x3cfe826c,0x7bda80eb,0xd1388110}},	//   _cume_, _bntv_, _aptu, kią_,
   {{0x9c7ced0c,0x8c45bcb3,0x7aebe8f9,0x69c0ed0d}},	//   _zači, леле, _sagt, dume,
   {{0x7aeb97ef,0x2d8481df,0x31340009,0x78a380e7}},	//   _pagt, _eume_, _терр, _renv,
   {{0x7b1587a3,0x2d848b2c,0x6d551d02,0xd838826c}},	//   _náut, _fume_, hoza, cači_,
   {{0xa3e3800f,0x2ca7c168,0x78b2007b,0x61200106}},	//   _पैर_, pand_, _ákvö, _möln,
   {{0x7aeb9a69,0x6009968a,0x80e100ab,0x41058198}},	//   _wagt, еном_, নাক্, узов,
   {{0x29110a2b,0xd05c0201,0xec158154,0x3ea61229}},	//   _moza_, _barə, _حواد, линг,
   {{0xc9f587bd,0x51f5804e,0x69c0c100,0x61e4002f}},	//   _مستع, _مستر, bume, ywil,
   {{0x6d439627,0x69c08918,0x2d8400e7,0xd1388035}},	//   onna, cume, ême_, bią_,
   {{0x9c7c807d,0x2722009f,0xd83881dd,0x26cf016d}},	//   _sači, _dóna_, zači_, _ögon_,
   {{0x2ca594d1,0x68e1d503,0x39898dfa,0x9c7c8110}},	//   _meld_, meld, _hús_, _pači,
   {{0x28cf8eb4,0xa3b6809a,0xba3b009f,0x7d1c1c67}},	//   त्रि, _जिस_, _veïn, skrs,
   {{0xd838803b,0x6724220e,0xb1460652,0x626600a9}},	// [77e0] vači_, _ilij, гнал, уваа,
   {{0x28cf0128,0xdcfb812b,0x68e1b6b2,0x2d848088}},	//   स्लि, _otuđ, neld, _rume_,
   {{0x9c7c81e2,0x67246d0e,0x69c0b931,0x9b460eca}},	//   _tači, _klij, zume, _مندو,
   {{0x68e1d033,0x6d43ed0f,0x69c0c8a9,0x78a880c3}},	//   held, enna, yume, zadv,
   {{0x6724120e,0xd838803b,0x363680f7,0xdd8f80f7}},	//   _mlij, rači_, دراس, كون_,
   {{0xd838811f,0x69c0a4d3,0x9c7c8bda,0xb5fd82d4}},	//   sači_, vume, _mačv, _izšl,
   {{0xd37aad55,0xd838817f,0xa0672b59,0x7ae0a254}},	//   нчи_, pači_, _бара_, temt,
   {{0x6d4391cd,0xd3788da4,0x5b148703,0x79862e5e}},	//   anna, _opće_, рмит, _kukw,
   {{0x79860010,0x6aa6008d,0x6d550533,0xdbde8118}},	//   _jukw, _mekf, yoza, _víña,
   {{0x2ca5905d,0x69c0b060,0x67245797,0x68e1d033}},	//   _geld_, rume, _alij, geld,
   {{0x67240613,0x6d5a84b7,0x6ac689a7,0xd1388d42}},	//   _blij, _ikta, _مقام, rią_,
   {{0x68ee4954,0x78a8c3e8,0xd1388110,0x9c7cabea}},	//   _labd, sadv, sią_, _bačv,
   {{0x6282ecbf,0x672400c3,0x6f1d5778,0x395e890d}},	//   _igoo, _dlij, rksc, plts_,
   {{0x672421ab,0x7e7d81ac,0xceb40085,0x25ec81ab}},	//   _elij, _úspe, _edə_, _आईनी_,
   {{0x6d550019,0x291140e6,0xa3ea92c6,0xaca3019d}},	//   roza, _roza_, मिट_, _ngụg,
   {{0x290c803a,0x57fb8051,0x798652e3,0xab6203bf}},	//   ljda_, _טלוו, _bukw, şünc,
   {{0x291149da,0xaca3019d,0x6d5a8d77,0x6d488390}},	// [77f0] _poza_, _agụg, _okta, _ojda,
   {{0x68ee02c1,0x291eed10,0xb2740cec,0x657e0122}},	//   _cabd, nkta_, слуш, _giph,
   {{0x72d529c9,0xa2d00a16,0x29110b67,0x1a65003d}},	//   _конф, _डॉक्, _voza_, _چیزی_,
   {{0x539a0051,0x6d5a81cd,0xfaff020f,0xef1f0457}},	//   _שירו, _akta, _unë_, nkü_,
   {{0xdbde87ca,0x6605884b,0xd838abea,0x636580e1}},	//   _síða, рпла, maču_, fónn,
   {{0x5bb5d9a2,0x68ee0079,0x273209d1,0x6282bbdf}},	//   асиф, _gabd, ršni_, _agoo,
   {{0x2ca5837a,0x68e1a5ed,0x39898118,0x61204503}},	//   _veld_, veld, _sús_, _möll,
   {{0xe9d98607,0x7c2b8d11,0x2ca5831d,0x68e19412}},	//   вки_, _đorđ, _weld_, weld,
   {{0x13de00c8,0x63a4807d,0x7aef0229,0x13068009}},	//   ডিয়, ćina, _mact, рный_,
   {{0xe8f68e02,0x9c7c80fe,0x672402ce,0x7d7980d5}},	//   аль_, _račv, _slij, _شمار_,
   {{0x6c848013,0x3eab1c33,0x68e18e20,0xd706060a}},	//   _المم, fact_, reld, азни,
   {{0x7bc3bc50,0x398980f7,0x539a8039,0x25a0802e}},	//   munu, _tús_, _ייעו, ţile_,
   {{0x7b7491fb,0x7bc3d71a,0x776d0079,0xa9a5996e}},	//   _اطلا, lunu, _dhax, _тилд,
   {{0x59a9108a,0x78a7000d,0xdca30cae,0x4a44a1d2}},	//   _चौधर, _nejv, жари, _унів,
   {{0xbb5601a8,0x68ee0162,0x2336161a,0x79860326}},	//   لنسب, _rabd, ахар, _sukw,
   {{0x7aef6d11,0x958611c7,0xf7720117,0x68ee045f}},	//   _cact, _клие, _بات_, _sabd,

   {{0x7bc3a916,0x67f004be,0x09b580be,0x645e0035}},	// [7800] hunu, kójá, יפּט_, _wypi,
   {{0x3f87b6c8,0x9c7c9f27,0x68ee1fd7,0x201a0168}},	//   _kunu_, _začu, _qabd, typi_,
   {{0x4ea6d1ff,0x2ba5000f,0x78a756a6,0x3f879c67}},	//   арла, गीदा, _dejv, _junu_,
   {{0x7bc3dcca,0xe80686ce,0x7a2c0036,0xa6e2007b}},	//   dunu, षमता_, _côté, áðhe,
   {{0xcd06831f,0x55069dc7,0x1a9b00be,0x68ee0326}},	//   ички, ичка, _ביכע, _tabd,
   {{0x21a302a4,0x7ae44926,0x7e6984a8,0x636580e1}},	//   _фирм, leit, _dzep, fóno,
   {{0x7bc3ed12,0x66e69ad8,0x237f026f,0xb226807b}},	//   gunu, _кова, ňuje_, kvæð,
   {{0xb0248142,0x7ae46d13,0x3f9a0198,0xdb1c13de}},	//   _ngườ, neit, mppu_, drrë,
   {{0x9c7c836f,0x69c423ed,0x7bc3838a,0xacea8187}},	//   _raču, nuie, aunu, _имаа_,
   {{0x3f878182,0x9c7c803b,0x7bde120c,0x7ae42d8e}},	//   _bunu_, _saču, _oppu, heit,
   {{0x7ae46d14,0x776281df,0x61eb809f,0x291eed15}},	//   keit, olox, _esgl, rkta_,
   {{0x7ae41f5e,0xe29a8ff0,0xdc3b81c6,0x6124a5d9}},	//   jeit, _рад_, _בעבר, _dòla,
   {{0x7bde22c9,0xd8388024,0x6b88d55f,0x9f658019}},	//   _appu, vaču_, _hudg, ítés_,
   {{0x80c22c4f,0x61200201,0x2d9943e8,0x7c2b87c0}},	//   _लागे, _bölm, rpse_, _ömrü,
   {{0x7ae453bc,0x06bc80c8,0x7aef05dc,0x80aa1055}},	//   feit, _ইউনি, _pact, टरने,
   {{0x6d58ed16,0x6b88a79e,0x69dd026c,0x7ae4011b}},	//   hova, _mudg, _ppse, geit,
   {{0x69c41220,0x6d58a842,0xd838812b,0x673d0d86}},	// [7810] guie, kova, raču_, misj,
   {{0x2b498289,0x6d5885b9,0x7bc3807e,0x3ea901c6}},	//   čaci_, jova, yunu, _heat_,
   {{0x7ae42b29,0x6d47003a,0x7e698019,0x3ea900ee}},	//   beit, mnja, _szep, _keat_,
   {{0x926b0196,0x7ae40548,0x14c9816f,0xef19822b}},	//   _арга_, ceit, _राहण, _biża_,
   {{0x6aad09ca,0x69c40087,0x6d5884e8,0x7e60810c}},	//   maaf, cuie, fova, _cymp,
   {{0x3ea90af9,0x6365ed17,0x7bc3ce5b,0xfce58171}},	//   _leat_, tóno, tunu, соко,
   {{0xd7c9003d,0x628681d6,0x25640338,0x2d810af8}},	//   _حوزه_, ľkon, följ_, _mihe_,
   {{0x7bc385b2,0x68e50009,0x6aad26e8,0x7f5b805d}},	//   runu, lehd, naaf, _ukuq,
   {{0x6d589807,0x7bc3d044,0x65949ac9,0x3d948c9d}},	//   bova, sunu, _мату, _митр,
   {{0x7bc3e940,0x6d588efc,0x3f87811f,0x7ae402af}},	//   punu, cova, _punu_, zeit,
   {{0x6d470289,0xbb858013,0x673d026c,0x141981a8}},	//   dnja, _الصي, fisj, _حياة_,
   {{0x7ae404c3,0x2d810198,0x643a83de,0x3f8780fe}},	//   xeit, _aihe_, _געענ, _vunu_,
   {{0x7ae46d18,0xcb128039,0xaa088591,0x6aad0079}},	//   veit, _מלא_, _نزول_, daaf,
   {{0x2d9e003e,0x409580f7,0x7ae427f9,0x395c8267}},	//   ďte_, _الغر, weit, _gkvs_,
   {{0x612004b8,0x7ae45ad3,0x61e9ed19,0xab2a197b}},	//   _följ, teit, lwel, гова_,
   {{0xe7ec95bc,0x69c46d1a,0x6aad2525,0x935a186e}},	//   _जनता_, tuie, gaaf, ургу_,
   {{0x7ae46d1b,0x61e9d2b2,0x6d47005c,0x81d58264}},	// [7820] reit, nwel, bnja, হিক_,
   {{0x7ae46d1c,0x6d470024,0x2d810578,0xd00a1182}},	//   seit, cnja, _gihe_, лезе_,
   {{0x7ae44f25,0x61e9ed08,0xa2e60c9b,0x6d5e019d}},	//   peit, hwel, _лонд, _ikpa,
   {{0x61e9c206,0xd3788d26,0x8cdac1c6,0x290300c3}},	//   kwel, _opća_, प्नो, _enja_,
   {{0x69c41e09,0x9c7c8353,0x612101bc,0x25640338}},	//   quie, _načr, _ịlek, jölk_,
   {{0x40ab1e29,0x256981a8,0x6f161a14,0xef1982a6}},	//   _مخفی_, túla_, _loyc, _viża_,
   {{0x6f046d1d,0x63a4805c,0x661d009a,0x6d5e0870}},	//   _onic, ćino, zysk, _mkpa,
   {{0x070c85e8,0x6d58ed1e,0x6d4702a5,0x4900001b}},	//   _सचिव_, sova, znja, राको_,
   {{0x6d588f20,0x5e4a9541,0x28cf23e6,0x442080eb}},	//   pova, _спам_, स्कि, ņi_,
   {{0x3f8a10e1,0x6f042d2d,0x6722ed1f,0x644f8035}},	//   _kubu_, _anic, lkoj, _ście,
   {{0xa3e70d38,0x6d4704c4,0xb5fd85b9,0xf1b980e1}},	//   _मैं_, vnja, _vyše, vyše_,
   {{0x0dcb1ccf,0x6d5e0870,0x95cb028b,0x6aad0079}},	//   луги_, _akpa, луга_, xaaf,
   {{0xe287853d,0x673d4a9c,0x61e98234,0xdb0a8118}},	//   _اطمی, risj, cwel, nsfí,
   {{0x92c500ab,0x3039803d,0x673d00e8,0x3f9801a9}},	//   _এসে_, اتیک_, sisj, _otru_,
   {{0xc2eb80ab,0x67228009,0x6aad004f,0x4034d0f6}},	//   কারি_, kkoj, taaf, _фейс,
   {{0x6d470fda,0x1fce00ab,0x69c0ac5b,0xc29919b8}},	//   snja, রবাস, orme, рках_,
   {{0x8af00201,0x3f8a00e4,0x6aad1b98,0xb1150951}},	// [7830] vlət, _aubu_, raaf, омаш,
   {{0x6d4002be,0x69c08c41,0x213edc45,0xa3e880d4}},	//   émat, irme, nith_, यबा_,
   {{0xdbe30118,0x61e98234,0x61248176,0x201e8196}},	//   _téña, zwel, _lòlo, nyti_,
   {{0x95998638,0x3f8a00a4,0x7bc7580a,0x61e9acce}},	//   атку_, _dubu_, muju, ywel,
   {{0xd5bbbd73,0x7bd50cdb,0x7bc7365d,0xa2270a19}},	//   усе_, ltzu, luju, _طرحه,
   {{0x201e81e2,0xa1942485,0x0395a3e7,0x61ef07f1}},	//   kyti_, _харч, ория, _iscl,
   {{0xeb99d9dc,0xdb1c160a,0x251c0158,0x213eb52a}},	//   ший_, ctró, רווא, dith_,
   {{0x201e81e2,0x8af00201,0x7d17002a,0xb0658009}},	//   dyti_, llər, _loxs, hdää,
   {{0x6b82e89d,0x7bc76d20,0x61e99699,0xe61380f7}},	//   _diog, huju, uwel, _عشر_,
   {{0x8af00201,0x61e9949d,0x7bc76d21,0x6f041388}},	//   nlər, rwel, kuju, _snic,
   {{0xa0698e17,0xfbdd83b7,0x18698abe,0x61e9ed22}},	//   рана_, _महिम, рани_, swel,
   {{0x81e000ab,0x6b82eac3,0x2b490088,0xdddb80c3}},	//   থিত_, _giog, jnac_, _zguš,
   {{0x92678077,0x8af00201,0x7d1714cf,0x20d5804a}},	//   _ادام, klər, _boxs, _дійс,
   {{0x53dd800c,0x6b82826c,0xfbdd8519,0x2bc69b7e}},	//   _महाश, _ziog, _महाम, रूवा,
   {{0x48ee835a,0xa87980be,0x672989a4,0x8af00085}},	//   _असतो_, _דאַר, _olej, dlər,
   {{0xe29a03a7,0x798382af,0x3f8a2bea,0xab660221}},	//   раа_, _hinw, _rubu_, івал,
   {{0x6aab8065,0x8af00085,0x79838a63,0x3f9800c3}},	// [7840] _megf, flər, _kinw, _stru_,
   {{0x6729b7d7,0x6aab8019,0x798390e4,0xd91007d2}},	//   _alej, _legf, _jinw, ریز_,
   {{0x4fea0dc0,0x61ef1621,0x6d5c1ee5,0xdd998176}},	//   рмен_, _escl, mora, _atň_,
   {{0x9e669383,0xd6d980e8,0x2c17001b,0xadc30091}},	//   овед, йті_, नहरू_, _afẹf,
   {{0x672299ff,0x672981c0,0x8af00085,0x6b82851e}},	//   rkoj, _dlej, blər, _riog,
   {{0x412a0c8e,0xdb1c07e2,0x7af60110,0x07a61133}},	//   _того_, ctrò, ldyt, _магн,
   {{0xdcfa80eb,0x6b82847f,0xdfd25b66,0x6729ed23}},	//   _citā, _piog, _تيز_, _flej,
   {{0x6d5c1044,0x81bd00ab,0x213e8428,0x798b83f7}},	//   hora, _আহত_, with_, _bugw,
   {{0x7bc70668,0x69d63a92,0xaca4046d,0xb0658198}},	//   zuju, ntye, _atọw, ydää,
   {{0x6d5c3e45,0x201e81e2,0xdddb825b,0xdce880eb}},	//   jora, tyti_, _uguš, _vidē,
   {{0xe51f808e,0x28cf0128,0x213e9995,0xf0930039}},	//   _भवति_, स्टि, rith_, ונת_,
   {{0x201e8110,0x8af00201,0x798381ec,0x3f848326}},	//   ryti_, zlər, _einw, _jimu_,
   {{0x7bc7059c,0xceb38039,0x6d5c6d24,0x8af00085}},	//   wuju, ויר_, fora, ylər,
   {{0x6d5c463d,0x7bc725f3,0x291845b9,0x61e284be}},	//   gora, tuju, _nora_, _ipol,
   {{0x68e8ed25,0x8af00085,0x44256d26,0x389b81c6}},	//   medd, vlər, ál_, _דיונ,
   {{0x7bc769aa,0x68e8ed27,0x61fd025b,0x7bd50102}},	//   ruju, ledd, _prsl, rtzu,
   {{0x8c3c8179,0x2cac8355,0x29186d28,0x9487002e}},	// [7850] _deği, _oedd_, _bora_, _мынд,
   {{0x25fe858c,0x6d5c4793,0x68e8cd09,0xc8671c79}},	//   लिनी_, cora, nedd, отеи,
   {{0x8af00086,0x6729ed29,0x29184941,0xddc40654}},	//   rlər, _plej, _dora_, _iziš,
   {{0x61e2ed2a,0xd3668077,0xf7708872,0x8af00085}},	//   _opol, _سه_, نان_, slər,
   {{0xd2468307,0x29180931,0x7de78013,0xc33200be}},	//   _أن_, _fora_, تسام, _טוט_,
   {{0xd0068307,0x636583a2,0x291816c9,0x3eafc56c}},	//   _كل_, móni, _gora_, sagt_,
   {{0x61ed6d2b,0x2bc6801b,0x61e28d88,0x6365b4cd}},	//   lwal, रूला, _apol, lóni,
   {{0x130980e8,0x7e7d826f,0xc8788214,0x6d5c07c6}},	//   сний_, _úspo, ceği_, zora,
   {{0x61ed1175,0x636585e4,0x68f55162,0x7b1c8036}},	//   nwal, nóni, _kazd, _réut,
   {{0x68f521a9,0x68e88365,0x3ead8fb0,0x2cb13135}},	//   _jazd, gedd, _heet_, jazd_,
   {{0xb4e78076,0x6d5c1429,0x25a90812,0x61ed242a}},	//   यजी_, vora, _awal_, hwal,
   {{0x61ed55d6,0x6d5c08c4,0xd5b800eb,0xbebb0168}},	//   kwal, wora, ņām_, dhës,
   {{0x68e8a223,0x2d85ed2c,0x7ae98074,0x6365807b}},	//   bedd, _kile_, meet, jóni,
   {{0x61ed52fa,0x3ead88ae,0x7ae9cc1a,0x6365816a}},	//   dwal, _leet_, leet, dóni,
   {{0xf0928039,0x6d5c6d2d,0x69c9bf18,0xe1ff04be}},	//   _אנו_, rora, luee, _aró_,
   {{0x6d5c4a24,0x63658511,0xa0269e71,0x2d85ed2e}},	//   sora, fóni, stöö, _lile_,
   {{0x6d5c11d6,0x26d20578,0x29186532,0x61fb83b2}},	// [7860] pora, _icyo_, _pora_, nvul,
   {{0x3f848010,0x26df8135,0x0e5702f6,0x29180df6}},	//   _simu_, _abuo_, _משפט_, _qora_,
   {{0x7ae998d0,0xe9ff00ff,0x29186d2f,0x2cac804a}},	//   keet, _tiếc_, _vora_, _redd_,
   {{0x2d85ed30,0x68e8b16b,0x63658118,0x7bc1026c}},	//   _aile_, zedd, bóni, šluc,
   {{0x3ead81e0,0x7ae9ed31,0xaad50beb,0x63658118}},	//   _deet_, deet, _डॉटक, cóni,
   {{0x2b918028,0x68f513ec,0x6d4a9984,0x644f809a}},	//   _bác_, _gazd, unfa, _ścia,
   {{0x61e28259,0x2b918142,0x3f84822e,0x6d4a9d31}},	//   _spol, _các_, _timu_, rnfa,
   {{0x2d85832f,0xa3ad85b3,0x2907a1cb,0xb998835f}},	//   _eile_, _कबर_, _anna_, ових_,
   {{0x2d85862d,0x68f5017b,0x05769e91,0x68e8ed32}},	//   _file_, _yazd, _فائد, tedd,
   {{0x7d1a016d,0x3a3704de,0x859b8039,0xfe45815b}},	//   ötsl, פרים_, _לשמו, _تکمی,
   {{0x7d088022,0x69c46d33,0x7ae9a256,0xbebb0168}},	//   _inds, hrie, beet, dhër,
   {{0x2d85ed34,0x69c43b52,0x68e8ed35,0x290781e8}},	//   _zile_, krie, sedd, _enna_,
   {{0xc3338039,0x7d1aa42d,0x68e885ee,0x61e2ed36}},	//   _אוף_, _kots, pedd, _upol,
   {{0x14df8cce,0xc16f835f,0x69c43aea,0xbebb00f1}},	//   प्पण, _її_, drie, thës,
   {{0x7d1ae465,0x63a90067,0x2b918028,0x61ed2fe2}},	//   _mots, ćeno, _xác_, wwal,
   {{0x69c400ed,0x61ed6069,0x6b860ad4,0x63659e00}},	//   frie, twal, _cikg, tóni,
   {{0x69c4564f,0x239580eb,0x6b866d37,0x2907ed38}},	// [7870] grie, _māja_, _dikg, _ynna_,
   {{0x6365960a,0x7bca8418,0x61ed6d39,0x98b90071}},	//   róni, kufu, rwal, ілет_,
   {{0x68f51601,0x29070459,0x61ed2693,0x69c400c6}},	//   _vazd, ına_, swal, arie,
   {{0x2d8584be,0x7bc38024,0x63658e15,0x2b91801c}},	//   _sile_, vrnu, póni, _rác_,
   {{0x2a6690af,0xa3cf835a,0x6e228065,0x7d1a8417}},	//   _nyob_, वून_, gyob, _bots,
   {{0x3eada40d,0x85e8835f,0x7ae9ed3a,0xf99203c8}},	//   _weet_, ядів_, weet, _ברך_,
   {{0x2d85822e,0x7ae99711,0xdd918117,0xdbf78424}},	//   _vile_, teet, روں_, ंटेड_,
   {{0x69c9a6a1,0xf773815b,0x394c8039,0xfd4e81bc}},	//   tuee, _ساز_, ends_, _kekọ,
   {{0x1dd19516,0x4cb300c8,0x7d1a9be9,0x20188009}},	//   _समित, _জানু, _fots, ärin_,
   {{0x2b918104,0x672d512e,0x2d858ad0,0x7ae992e5}},	//   _tác_, _alaj, _uile_, seet,
   {{0x61200125,0x672d6d3b,0x6f1b86c0,0x69c401ac}},	//   _tölv, _blaj, _kouc, zrie,
   {{0xe28e8fbb,0x98ad9010,0x26cf8288,0xf8dd03ca}},	//   _ја_, ının_, nggo_, न्तय,
   {{0x6f1ba1bf,0xee37054c,0x61200019,0x799d0069}},	//   _mouc, дня_, _költ, _ntsw,
   {{0x684592b2,0x69c45b48,0x6f1b9243,0x290780e8}},	//   _онла, vrie, _louc, _unna_,
   {{0x3cf0809a,0xeb971073,0x23695400,0x69c46d3c}},	//   _इससे_, дис_, flaj_, wrie,
   {{0x6d439066,0x23690e72,0x69c40367,0x61ed8110}},	//   hina, glaj_, trie, _šaly,
   {{0x63a4856f,0x798700f3,0x2a6681c0,0xf2d280be}},	// [7880] ćini, _bijw, _xyob_, כען_,
   {{0x69c68353,0x69c44a2b,0x672d0042,0xfd4e81bc}},	//   škeg, rrie, _zlaj, _dekọ,
   {{0x6f1ba246,0x23696d3d,0x7f428264,0x28dd0b04}},	//   _bouc, blaj_, tioq, न्धि,
   {{0x69c41edd,0x7d1a8074,0x6fc5816f,0x9f5d00e1}},	//   prie, _sots, _विनं, _prvé_,
   {{0x7d1ad397,0xdd8f8c3b,0x9f658019,0x80ad00ab}},	//   _pots, لون_, ítás_, _চার্,
   {{0x6d43b3e1,0x7bcaed3e,0xb0dd52d5,0x6f09bee9}},	//   gina, tufu, न्दग, _enec,
   {{0xfbcf80a0,0x7d1a81a1,0x395eed3f,0x6d4e4538}},	//   لتي_, _vots, vots_, inba,
   {{0x1b7780f7,0x7bcaed40,0x6600808e,0xba3b1412}},	//   وصية_, rufu, _trmk, _geïs,
   {{0x6d43ed41,0x7bd89f3a,0x3ea6ed42,0x9663932a}},	//   bina, stvu, mbot_, _акте,
   {{0xb5fd85b9,0x3ea68428,0x6120007b,0x7d08806a}},	//   _myšl, lbot_, _tölu, _unds,
   {{0xcb6a9b10,0x672d275e,0x395e81a9,0x9982928a}},	//   _даже_, _plaj, rots_, šků_,
   {{0x6d4e6d43,0x613200ec,0x3a269bdc,0x61e66d44}},	//   enba, _fælg, _омег, _opkl,
   {{0x7ae2b496,0x61320366,0x672d18f1,0x6664047f}},	//   _ibot, _kæld, _vlaj, върз,
   {{0xb3470073,0xfd4eba48,0xdb150061,0x63538493}},	//   _opçõ, _rekọ, mszé, măna,
   {{0x61e60110,0xd30f80ff,0xfd4e81bc,0x3ea680e4}},	//   _apkl, _mệnh_, _sekọ, kbot_,
   {{0x68f88022,0x9f4c877f,0x290a0247,0x91f28105}},	//   _havd, _èdè_, _anba_, _अनाज_,
   {{0x7ae28077,0x497510fc,0x291c9619,0x6365ac6c}},	// [7890] _mbot, елас, _kova_, mónt,
   {{0x6d43b5d7,0xeb1b835a,0x3dc680f5,0x6f1bed45}},	//   xina, _फक्त_, drow_, _souc,
   {{0xa3d600a5,0x6f1b956b,0xe610803d,0xa3e7009a}},	//   _समय_, _pouc, یشه_, _मैच_,
   {{0x6d43ed46,0x68f88168,0x41c7064a,0x291c94cb}},	//   wina, _lavd, _लिपस, _lova_,
   {{0x6d43ed47,0xd30f8028,0xfce5a8df,0x6f1bc480}},	//   tina, _bệnh_, еоло, _vouc,
   {{0x7aed467c,0x0d84835f,0x68f8807a,0x7ae29bb7}},	//   leat, влін, _navd, _abot,
   {{0x61320022,0x3ea6ed48,0x6f1b824d,0xf8b2007c}},	//   _sælg, bbot_, _touc, _תשל_,
   {{0xdb1c6d49,0x3dc6b32d,0x20030326,0x6f09ed4a}},	//   strö, brow_, _irji_, _unec,
   {{0x6d43d8a0,0xa2d08ebf,0x61200019,0x2734001c}},	//   pina, _धार्, _tölt, _hãng_,
   {{0x63a90e78,0x6132013c,0x291c88e9,0x63ba007a}},	//   ćenj, _vælg, _cova_, štni,
   {{0x291c8392,0x3f91185b,0x6d418197,0x7aed31c4}},	//   _dova_, _juzu_, _imla, keat,
   {{0xdb1c02be,0x6565008e,0x06b000ab,0x6fc0a207}},	//   ntrô, _akhh, _কাহি, _विरू,
   {{0x7aed0102,0xa6db007b,0x273400ff,0x281280d7}},	//   deat, miðl, _lãng_, نویس,
   {{0x7afb8102,0x621a807c,0x61320366,0xdd8f0290}},	//   ldut, _מונק, _kæle, صوف_,
   {{0x6d4e04fe,0x64570118,0x69c213ba,0x187580be}},	//   rnba, _cxxi, _लिही, _אײַך_,
   {{0x3ebf86cb,0x636583a8,0x291c81a1,0x23b10935}},	//   _ndut_, cónt, _zova_, _जबरद,
   {{0x6fc59d01,0xb0b6800f,0x6462009a,0x6286826f}},	// [78a0] _विडं, _आजमग, _świę, žkov,
   {{0x25a003ec,0x20566cfd,0x3ea69916,0xb5fd816b}},	//   _itil_, нтер, wbot_, _vyšl,
   {{0x9c7c9807,0xb4ac0996,0xe29a0638,0x27e782f7}},	//   _obča, खरी_, _нан_, _jpnn_,
   {{0xbbe900d5,0x3f91011e,0x200c04b7,0x66046d4b}},	//   _کریم_, _duzu_, _ġdid_, _krik,
   {{0x3ea6b975,0x7d1e6d4c,0x0cd49242,0x69db80f1}},	//   rbot_, _kops, волю, jtue,
   {{0x7afb8118,0x3dc681c6,0x6604003d,0x2d926d4d}},	//   edut, rrow_, _mrik, _muye_,
   {{0x26c06d4e,0x7bce6d4f,0x3f9126d2,0x3ea68362}},	//   _odio_, nubu, _guzu_, pbot_,
   {{0x26c0022e,0x291ca67f,0x68f88ec3,0x66046d50}},	//   _ndio_, _sova_, _savd, _orik,
   {{0x3202803e,0x7bce0867,0x3f896b76,0x3945ed51}},	//   íky_, hubu, _riau_, fils_,
   {{0x26c06d52,0x7bce6394,0xc05a8196,0xadb781a8}},	//   _adio_, kubu, зім_, _أهلا_,
   {{0x39960ae1,0x59c281ab,0x6604376a,0x2d920326}},	//   _læs_, _शिवर, _arik, _auye_,
   {{0xe2928013,0xd378b6c5,0x38c6846d,0xceeb01a8}},	//   _إذا_, _opći_, _bírà_, أردن_,
   {{0xae0383db,0xa3d3035a,0x3945809f,0x69db8f0c}},	//   लियन_, हून_, bils_, ctue,
   {{0x66040bc5,0x291c847f,0x3945ed53,0xd7f080f7}},	//   _drik, _uova_, cils_, _نكت_,
   {{0x81dc80c8,0x66041b02,0x63658118,0x4034917f}},	//   ডিও_, _erik, cóns, _шекс,
   {{0x66046d54,0x2b098035,0xd05c0326,0xdb07021e}},	//   _frik, वाएँ_, _harɗ, nsjø,
   {{0xf9930c2b,0x98c709b8,0x3f91011f,0x58d5249a}},	// [78b0] ابر_, فغان, _suzu_, коат,
   {{0x7bce6d55,0x7aed4893,0x33290df6,0x6f0d136f}},	//   bubu, seat, skax_, _hnac,
   {{0x80d88a74,0x6d476d56,0xf8b383c8,0x853c0039}},	//   _माने, mija, רשע_, _מגזי,
   {{0x23668069,0x6d418267,0xdcfe0162,0x998901d6}},	//   _nkoj_, _smla, _tipă, dzať_,
   {{0xf7708277,0x6f0d6d57,0x7ed4dc11,0x69db9a1f}},	//   حال_, _mnac, ازما, xtue,
   {{0x8c458254,0x518401a1,0xcd980039,0xfce5e519}},	//   келе, _буса, עדות_, токо,
   {{0x3945907c,0xaca301bc,0x63ad825b,0x6f0d0bfd}},	//   vils_, _akịd, ćano, _onac,
   {{0x4905035a,0x64410035,0x533283a7,0x05c9975d}},	//   _होतो_, źliw, иејт, _रिपब,
   {{0xc6928051,0x65958f04,0x44298029,0x3945c7ce}},	//   _כאן_, _разу, ņa_, tils_,
   {{0x6d418fc4,0x6f0d66bd,0x95ee001b,0x7afb8037}},	//   _umla, _anac, _छनौट_, sdut,
   {{0x69dbbfae,0x7d1e007d,0xf09204de,0x39459e9e}},	//   stue, _rops, יני_, rils_,
   {{0x7d1e1601,0x0caa0ebf,0x4427ed58,0x69dbed59}},	//   _sops, कर्म, myn_, ptue,
   {{0x693592bc,0x49bb9381,0xb6ba8039,0x7d1e6d5a}},	//   _инду, _راشد_, וצרי, _pops,
   {{0x6da31927,0x2360803b,0x7bce028d,0xb4ac0540}},	//   рира, čije_, tubu, खरे_,
   {{0x628f3cc0,0x4427c07e,0x6b8bed5b,0x7d1e0087}},	//   _bgco, nyn_, _kigg, _vops,
   {{0x7bce3a8f,0x6b8b822b,0x26c0111b,0x628f09ab}},	//   rubu, _jigg, _udio_, _cgco,
   {{0x6d476d5c,0xcb670c6e,0xe9da035f,0x7bce1152}},	// [78c0] bija, тате_, ька_, subu,
   {{0x6b8ba280,0x64590063,0x7d1e0efd,0x442781b0}},	//   _ligg, _świe, _uops, kyn_,
   {{0x69c98613,0x8cd70035,0x2cb80866,0xfaff03ed}},	//   hree, _बातो, mard_, _ikën_,
   {{0x4427831d,0xe5a68cc1,0xe5c6a857,0x69c9a6a5}},	//   dyn_, види, вско, kree,
   {{0xf2d31a63,0x527502fb,0xca750a41,0xdce18176}},	//   _דער_, _буру, _буры, _eklč,
   {{0x2cb81009,0x69c9802e,0x44278114,0xb9070264}},	//   nard_, dree, fyn_, _মো_,
   {{0xd9433d65,0x61431155,0x44278428,0x6b8bcbf0}},	//   _тери, _тера, gyn_, _bigg,
   {{0x236d8353,0x51f88009,0x96a200d4,0x9a86904b}},	//   glej_, ению_, _क्लॉ, купл,
   {{0x7de584c1,0x63a9003a,0x25ec809a,0x87558098}},	//   _مسلم, ćeni, _आईटी_, _сърц,
   {{0x68fc6347,0x6f0d3dbc,0x25a6a26e,0x4427831d}},	//   _jard, _snac, mpol_, byn_,
   {{0x44388082,0x68fc4b55,0x63a48025,0x6b8bc8c8}},	//   _år_, _mard, ćins, _figg,
   {{0xfaa6a028,0x68fc6968,0x6d470ae9,0x69c9a023}},	//   _радо, _lard, wija, bree,
   {{0xa2d790a1,0x628681ac,0x6602c9e9,0x2d8c9ffc}},	//   _यात्, ľkos, nvok, _kide_,
   {{0x2d8ced5d,0x6b8bcab0,0x6143c184,0x02cb001b}},	//   _jide_, _zigg, _кеча, िल्न,
   {{0xa5cc800f,0x25698061,0x2d8ced5e,0xb8208264}},	//   _समझौ, múlt_, _mide_, _ফেরত_,
   {{0x2d8ce3f4,0x68fc058f,0x6d475f83,0x656e0083}},	//   _lide_, _aard, sija, albh,
   {{0x68fc6d5f,0x3a753b5f,0x3eb9103d,0x27ea0101}},	// [78d0] _bard, улар, mast_, _apbn_,
   {{0x44f527b9,0x44278198,0x3da40081,0x660284dc}},	//   _спос, yyn_, _тръб, dvok,
   {{0x68fc5128,0x6d456d60,0x5184096f,0x628f01e8}},	//   _dard, _imha, рута, _tgco,
   {{0x3eb96d61,0x2d8c83d3,0x68fc0362,0x6602143c}},	//   nast_, _aide_, _eard, _šoki,
   {{0x4427ce06,0x2d8c9beb,0x2d9c007a,0x6720d464}},	//   wyn_, _bide_, _čvek_, _domj,
   {{0x4427bf5d,0x68fc24d5,0x6b8ba1fb,0x7afd15c1}},	//   tyn_, _gard, _sigg, _hast,
   {{0xe2998a8e,0x7afd6d62,0x2d8c8091,0x6b8ba127}},	//   най_, _kast, _dide_, _pigg,
   {{0x4427c285,0x69c9a6a1,0x3eb91796,0x2b9880e7}},	//   ryn_, tree, jast_, _déc_,
   {{0x3eb92e6d,0x3a29208b,0x7afd2872,0xc3340039}},	//   dast_, nyap_, _mast, יוק_,
   {{0x68fc1613,0x69c98a62,0x2d8cc154,0x629b847f}},	//   _xard, rree, _gide_, scuo,
   {{0x6b8bde84,0x777b81c0,0x5eab00ab,0x2cb86d63}},	//   _tigg, _khux, _কাজে, vard_,
   {{0x6d4511cd,0x69c9a32d,0x752181ec,0x3eb92a4c}},	//   _amha, pree, _holz, gast_,
   {{0x2d4d0267,0xc0e58323,0xd49180ff,0x7e6d018e}},	//   džeb_, _болк, _làm_, _cyap,
   {{0x7afd0665,0x3f8dd548,0x78b51b40,0x6ed60006}},	//   _aast, _lieu_, _nezv, _भावु,
   {{0x66028824,0x68fc593c,0x3eb906ae,0x7e6d3328}},	//   zvok, _rard, bast_, _eyap,
   {{0x68fc3340,0x7afd05d8,0x765b8085,0x2cb80036}},	//   _sard, _cast, _oxuy, sard_,
   {{0x68fc277d,0x9f5e83d3,0x7afd6a7c,0xa3b380dc}},	// [78e0] _pard, _été_, _dast, जीत_,
   {{0x63ad803a,0x68fc1b37,0x98be8087,0x7afd27d3}},	//   ćanj, _qard, mită_, _east,
   {{0x68fc6d64,0x8caa1094,0xddcd003b,0x78b5002e}},	//   _vard, _ज्यो, _izaš, _dezv,
   {{0x5fc90540,0x25a68b17,0x2d8c8039,0x3fb90019}},	//   ांजल, tpol_, _side_, ئپنگ_,
   {{0x2d8c82ba,0x3f8ded65,0x7ae400dd,0xe4e68221}},	//   _pide_, _dieu_, mfit, гійн,
   {{0x7ae45d43,0x25a6ed66,0x7521907c,0x61461dc7}},	//   lfit, rpol_, _colz, _сега,
   {{0xc61c80c8,0x0b8a891d,0x25a6dce7,0x75219502}},	//   _দেখা_, нсии_, spol_, _dolz,
   {{0x3cf08063,0x7afd002a,0x436780a9,0xfbac1993}},	//   _इसके_, _xast, лајн_, टीएम,
   {{0x64a6e8f4,0x5f11835a,0x3eb92938,0xdca69bdc}},	//   _база, णार्_, vast_, _бази,
   {{0x200780c3,0xc23701c6,0xa6db008b,0x98be8493}},	//   _brni_, טרפו_, miði, dită_,
   {{0x04938307,0x7c938013,0x20078067,0x3eb90357}},	//   _المح, _المص, _crni_, tast_,
   {{0x6d4a8c93,0x7bc1017f,0x6d8b0609,0x798e038a}},	//   lifa, šluk, _eżal, _libw,
   {{0x3eb96d67,0x7afd2397,0xdb0a8aa2,0x88cc00ab}},	//   rast_, _rast, dsfø, র্যক,
   {{0x6d4aed68,0xb4c104c5,0x260a06a7,0xdb01d3d4}},	//   nifa, ुले_, ामजी_, _atlè,
   {{0x8ca4000f,0x3eb95a4b,0x3cec801b,0xd00f982d}},	//   कड़ो, past_, _आउने_, _уф_,
   {{0x6d4a8010,0xa2a00fd5,0xe2f80558,0x98be8162}},	//   hifa, गुल्, лесі_, bită_,
   {{0x7afd0181,0x6d4a914c,0x2b496d69,0x98be8162}},	// [78f0] _vast, kifa, riac_, cită_,
   {{0x2b4901ac,0x6d4a804f,0xf1c801a8,0x3f8d8129}},	//   siac_, jifa, اولى_, _sieu_,
   {{0x200757bb,0x63adabea,0x6d4abcc0,0x3a2902c4}},	//   íni_, ćank, difa, syap_,
   {{0x672f009a,0x7521ceca,0x7afd01a8,0xa2d08072}},	//   nkcj, _solz, _uast, _धाग्,
   {{0xfad6093f,0xeef800be,0x6d4a80dd,0x7521c9d8}},	//   _דורך_, טמאר_, fifa, _polz,
   {{0x69cd0355,0x85300300,0x6d4a9267,0x78ba8824}},	//   mrae, _kuɗa, gifa, jatv,
   {{0x3f8d80ff,0xc2938019,0x98be8162,0x2911010c}},	//   _tieu_, میاب, zită_, _inza_,
   {{0x1309a45b,0x3cfe8c93,0x798e0deb,0x6d4a8901}},	//   тний_, _eatv_, _zibw, aifa,
   {{0x65158019,0x20078b67,0x6d4a8b5e,0x798e0a03}},	//   _پوائ, _srni_, bifa, _yibw,
   {{0x2360825b,0x39459383,0x29016d6a,0x60098604}},	//   čija_, рног, ndha_, вном_,
   {{0xe73a0381,0xa2f591c7,0xb4c38bbc,0x2eff81ec}},	//   вен_, _впеч, ्ली_, _kauf_,
   {{0x6609ed6b,0xc9f58019,0x9f5d00e1,0x6d55623d}},	//   _krek, _نستع, _prvá_, enza,
   {{0x3f8224b2,0x2911016a,0x63a501a8,0x6d8b022b}},	//   rmku_, _onza_, _athn, _eżam,
   {{0x64590063,0x69cd4e06,0x98be8087,0x6abb81ec}},	//   _świa, drae, rită_, lauf,
   {{0x29012eb7,0x8883803d,0xdb01c28b,0xd46a1860}},	//   ddha_, _دیدن, _atlé, тиве_,
   {{0x97c4803d,0x6d550511,0x6d4ab41a,0x9f5d016b}},	//   _اتوم, anza, zifa, _trvá_,
   {{0x63a55e99,0xe0da0fe7,0xb1461908,0xe297105c}},	// [7900] _ethn, ква_, анал, рау_,
   {{0x399b8073,0xf09280be,0x78bb00e7,0x6abbed6c}},	//   _mês_, ַנד_, _œuvr, hauf,
   {{0xa2e6087e,0x28dd800d,0x6abb81ec,0x6609ed6d}},	//   _конд, _मानि, kauf, _arek,
   {{0x66e68a08,0xdee6c249,0x7c2e82af,0x66098357}},	//   рода, роди, _übri, _brek,
   {{0x6b840b3c,0x22a681d0,0x3ea9816a,0x6d4a9d56}},	//   mmig, níků_, ñata_, tifa,
   {{0x6609ed6e,0x6b8401b4,0x80dd6d6f,0x03c680ae}},	//   _drek, lmig, _पाये, асим,
   {{0x6d4a8cf6,0x6d8b0609,0xdb150061,0xb6060824}},	//   rifa, _bżaj, lszá, ljšč,
   {{0x6609ed70,0x6b840876,0x6d4a805d,0x3ce9811f}},	//   _frek, nmig, sifa, đava_,
   {{0x24f68d31,0x3f980010,0xe5a3bbae,0x6609cd5a}},	//   _вчер, _huru_, _мити, _grek,
   {{0x3f980cd6,0x6b8401ec,0x637e8168,0xf8b303de}},	//   _kuru_, hmig, këng, ֿשר_,
   {{0x3f986d71,0xb4d287e6,0x6d489c66,0x6f00ed72}},	//   _juru_, वली_, _imda, _kamc,
   {{0x09e6a53e,0x6f02d862,0x91e68abe,0x141781a8}},	//   _водн, ndoc, _воде, _خيمة_,
   {{0x51f692c8,0x6f0086ec,0x2bc48133,0x291181a8}},	//   _خسار, _mamc, _ịche_, ánaí_,
   {{0xa3b3a539,0x69c0c0de,0x58d381a1,0x3d198054}},	//   जीव_, msme, _дошт, पाये_,
   {{0x3f986d73,0xb17b83de,0x397b83de,0xf99f0176}},	//   _nuru_, _שטור, _שטונ, _erèl_,
   {{0x69cd0197,0x394c82e6,0x9e670019,0x6b8402d5}},	//   trae, lids_, _پابن, gmig,
   {{0x645e4480,0x6d48dd97,0x69c0ed74,0x63ad8668}},	// [7910] _expi, _omda, nsme, ćani,
   {{0x3f986d75,0x2eff80e7,0xa0a71501,0x69cd0114}},	//   _buru_, _sauf_, ршал, rrae,
   {{0x3f980369,0x69cd6798,0x29016d76,0x63a90140}},	//   _curu_, srae, rdha_, ćens,
   {{0x6609bfd7,0x6f00be5b,0x6d488f70,0x69c080eb}},	//   _prek, _camc, _amda, ksme,
   {{0x6605aaed,0x64a5ae15,0xdef8a1f6,0x69c0869f}},	//   спла, бала, рых_, jsme,
   {{0xa3be023c,0xee388221,0xdb1c0511,0xb4c381a2}},	//   ुंच_, шні_, buró, ्ले_,
   {{0xadc38028,0x237d81c0,0xdb1c0118,0x6abb8192}},	//   _trắn, _phwj_, curó, tauf,
   {{0x66098de8,0x6d48e350,0x612d9de9,0xcc5801c6}},	//   _trek, _emda, _túlk, יסוק_,
   {{0x6abb81ec,0x69c0a3ea,0x798501c0,0x13068198}},	//   rauf, gsme, omhw, сный_,
   {{0x9be7835f,0x23e780e8,0x27fc80b9,0x6f008088}},	//   _відк, _відв, _bsvn_, _zamc,
   {{0x612d8019,0xe8df0028,0x40498c6c,0x237d8069}},	//   _júli, _ngọc_, упно_, _thwj_,
   {{0x22958013,0x7d0183a6,0xaa9581a8,0xe73a0d15}},	//   _الإس, _hals, _الإث, уем_,
   {{0xa3da035a,0x528580f7,0xf99f0176,0x2b4d866f}},	//   डून_, _الشك, _brèm_, miec_,
   {{0xdce39234,0xdca30e17,0x7bd56d77,0x394ccc46}},	//   konč, зари, fuzu, cids_,
   {{0x61fd00dd,0x7d01ed78,0xd4918129,0x20188198}},	//   _assl, _mals, _bài_, ärit_,
   {{0x2b4da1a9,0x3f980870,0xdce3856f,0x2b9c001b}},	//   niec_, _ruru_, donč, _víc_,
   {{0x200a003b,0x6132013c,0x3f986d79,0x3b070081}},	// [7920] _srbi_, _fæll, _suru_, щето_,
   {{0xdb150065,0x3f980133,0xb4c3800d,0x6b843241}},	//   rszá, _puru_, ्लो_, smig,
   {{0x6d4e62b8,0xdb150019,0x6f008bcf,0xa4fb0e82}},	//   miba, sszá, _pamc, _גליט,
   {{0x1e868012,0xee3a8eef,0x7d01ed7a,0x98b8061c}},	//   блем, лне_, _aals, ızın_,
   {{0x7d01ed7b,0x81e700ab,0x239581a9,0x3f9801bc}},	//   _bals, ভিউ_, _māju_, _wuru_,
   {{0xb4d28f22,0x6d4e4040,0x3f983c50,0x69c08186}},	//   वले_, niba, _turu_, vsme,
   {{0x69d60216,0x7d01ed7c,0x4adc9107,0xa13703de}},	//   luye, _dals, _यादव, _פאלק_,
   {{0xe44f8013,0x6d4e0ddd,0xe73781bb,0x7af6007b}},	//   عضو_, hiba, _лес_, neyt,
   {{0xa92a8071,0x394c83a6,0x69c0ed7d,0x69d6189d}},	//   гіне_, tids_, usme, nuye,
   {{0x6d4e2ebc,0xa3d30074,0x69c0afb1,0xce379101}},	//   jiba, हूँ_, rsme, _האמת_,
   {{0x9c7c9fe7,0x3f9203c3,0x394c8106,0x5eaa00ab}},	//   _obči, _biyu_, rids_, _কয়ে,
   {{0xe29a9697,0x61e412a5,0x973d0d26,0x3f8686c0}},	//   _сад_, ktil, opći, nmou_,
   {{0x8b658013,0x518681e2,0xe66704fa,0x637e80f1}},	//   _بالم, _лука, стно, rënd,
   {{0x61e423b1,0x7bd56d7e,0x6d4e5c0d,0x394a090d}},	//   dtil, tuzu, giba, _nmbs_,
   {{0xa3d30b85,0x6b9a8722,0x0ed89513,0xf2c70048}},	//   हूं_, _jutg, _डांड, йсан,
   {{0xe616007a,0xdb038106,0x387c80c3,0x7bd56d7f}},	//   žišč, ssnö, _izvr_, ruzu,
   {{0x388e82bf,0x6d4e0b5e,0x7bd500b4,0x25ac016b}},	// [7930] lər_, biba, suzu, čilý_,
   {{0x660d661a,0xaa7b026f,0x2be20740,0x27058129}},	//   _irak, _obýv, _पहचा, _ồn_,
   {{0xd0110277,0xa295102a,0xaa950dc0,0x61e46415}},	//   بلا_, _мані, _минч, atil,
   {{0x660d6d80,0x69d60234,0x61e46d81,0xb4c382f1}},	//   _krak, buye, btil, ्ल्_,
   {{0x5fc50076,0x2cb200f2,0x388e8201,0x7d01d01e}},	//   _लटकल, _ändå_, hər_, _pals,
   {{0xc3010a49,0x78ad8289,0x2b4d809a,0x6d588a35}},	//   _একটি_, _đavo, wiec_, gnva,
   {{0x7d01bd3b,0xeab180f7,0xe3b28065,0xcda9803d}},	//   _vals, وعة_, ورٹ_, _چهره_,
   {{0x388e8201,0x29032420,0x6d4e5ca4,0x6d5898c7}},	//   dər_, _haja_, ziba, anva,
   {{0x7d01eba8,0x799980dd,0x6d4e01d4,0x612d8061}},	//   _tals, _quww, yiba, _múlv,
   {{0x388e8201,0x95578277,0x4fe98b69,0x47c596df}},	//   fər_, _اخرا, амон_, обов,
   {{0x290303b7,0x660d6d6d,0x388e8201,0x25a94457}},	//   _maja_, _arak, gər_, _atal_,
   {{0x7c2e016b,0x61e43b53,0x7bc38502,0x6d4e6d82}},	//   vybr, ytil, msnu, wiba,
   {{0xc3328039,0x5fc59305,0x3ead25ca,0x683f846d}},	//   _קוד_, _विकल, ñeta_, _bádé,
   {{0x388e8201,0x290301ec,0x7ae9c555,0x2cba0144}},	//   bər_, _naja_, lfet, _qepd_,
   {{0x69cb00ab,0x6d4e6d83,0x660d6d84,0xe7b580f7}},	//   ágen, riba, _erak, _بمعد,
   {{0x660d20e4,0xe2971092,0x61e44530,0x4911800d}},	//   _frak, жат_, ttil, ताको_,
   {{0x29033b7a,0x2d930cf8,0x7af6008b,0x6b5e81a9}},	// [7940] _baja_, _fixe_, reyt, nīga,
   {{0x38cb19f4,0x2905829b,0x29030264,0xb17b016d}},	//   لامی_, ndla_, _caja_, _spår,
   {{0x660d1784,0xb4d6000f,0x22400061,0x69d60fa3}},	//   _zrak, हली_, szik_, suye,
   {{0x6b9ac3b6,0x644800e1,0x69d60036,0x9411811c}},	//   _rutg, údiu, puye, _üzə_,
   {{0x388e8085,0x29033b7a,0x6f046d85,0xee838162}},	//   zər_, _faja_, _maic, мышо,
   {{0x69c4489a,0x442e8123,0x61320366,0x3f868118}},	//   msie, tyf_, _mælk, smou_,
   {{0x7ae9ad08,0x69c4270c,0x6d5886b1,0x6f160176}},	//   ffet, lsie, rnva, _onyc,
   {{0x4420803a,0x442e879f,0x78bc0223,0x31c691d2}},	//   ći_, ryf_, _herv, осов,
   {{0xb99784d9,0x316e80b9,0x2903453f,0x78bc6d86}},	//   овых_, _pkfz_, _yaja_, _kerv,
   {{0x2ee0026c,0x6b9a8362,0x69c44543,0x388e811c}},	//   _acif_, _tutg, isie, tər_,
   {{0x80d000c8,0xc05a90ac,0x25a91ee0,0x2005007b}},	//   স্থ্, ріп_, _stal_, _álit_,
   {{0x69c46d87,0x752888ae,0x6722d559,0x7bd88f8e}},	//   ksie, _hodz, njoj, muvu,
   {{0x7528d619,0x76429149,0x95d80009,0x7bd8a49b}},	//   _kodz, nzoy, одят_, luvu,
   {{0x69c4368e,0x2369811a,0x3af50129,0x660d6d88}},	//   dsie, čaje_, _ấp_, _vrak,
   {{0x2903059e,0x69c41c28,0x6f0401e4,0x4fb381a8}},	//   _raja_, esie, _faic, _قصير,
   {{0x290313b8,0xc2990fbf,0x31a083ec,0x7528d6bd}},	//   _saja_, сках_, _kòz_, _lodz,
   {{0x78bc6d89,0x660d6d8a,0x7f4d21e7,0xa2dc20e9}},	// [7950] _berv, _urak, _imaq, _फार्,
   {{0x7bd8b883,0x48ab02cb,0xc17800e8,0x7528ae63}},	//   kuvu, ртам_, оїх_, _nodz,
   {{0x29030074,0x28dd824c,0x5f9509b5,0xbf73846d}},	//   _vaja_, _मासि, чиет, _apàṣ,
   {{0x29031eb3,0x80dd02f1,0x67228168,0x753a811b}},	//   _waja_, _पावे, gjoj, _altz,
   {{0xe4f781ce,0x5f1c11c6,0x64a5814c,0x78bc29c3}},	//   ंजलि_, यात्_, пала, _ferv,
   {{0x6b828019,0x64a58ba7,0x75288035,0x7d05336e}},	//   _ahog, чака, _codz, _jahs,
   {{0x9c7c8353,0x6b828635,0x0edb016f,0x7d056d8b}},	//   _obču, _bhog, _भांड, _mahs,
   {{0x28dd853e,0x6b828083,0xdce70dcc,0x31a082d6}},	//   _माहि, _chog, dojč, _bòz_,
   {{0xe4e78160,0x7ae9939a,0xda0e0054,0x6f045a4a}},	//   _міжн, rfet, सियत_, _raic,
   {{0x75288063,0xa2cb04c5,0x7ae9bac8,0x6b5e81a9}},	//   _godz, तृत्, sfet, rīga,
   {{0x3ea08b7c,0x6b828083,0x63ad82ce,0x1869ca52}},	//   žite_, _fhog, ćans, сани_,
   {{0x3d1985b3,0x290384c4,0x2576007b,0xe3b08a47}},	//   पावे_, žja_, mæli_, _شرم_,
   {{0x7d056667,0x61330214,0x6b89a26d,0x799d1ab3}},	//   _bahs, _kılı, mmeg, _nusw,
   {{0xb4d632dd,0xcfe98077,0x200e826c,0x6b89ed8c}},	//   हले_, _هفته_, _frfi_, lmeg,
   {{0x799d02af,0x7d050be6,0x6f0401e4,0x60c1ed8d}},	//   _ausw, _dahs, _taic, malm,
   {{0x3f670098,0x799d46c7,0xe29a07b6,0x69c422ab}},	//   _нищо_, _busw, саа_, tsie,
   {{0x6abd072a,0x78bc570d,0x26c21855,0xa8238065}},	// [7960] _desf, _perv, mako_, _رکھن,
   {{0x01bd8a49,0x26c26d8e,0x69c40412,0x6aa46d8f}},	//   _আমাদ, lako_, rsie, scif,
   {{0x78bc24de,0x75288063,0x80dd01d0,0x79950242}},	//   _verv, _rodz, _पारे, _dizw,
   {{0x26c24b14,0xe61aad59,0x6b8980f3,0x8f9a807c}},	//   nako_, йде_, jmeg, ציני,
   {{0x78bc4123,0x75288b04,0x60c18065,0xddcb8214}},	//   _terv, _podz, kalm, ğişi,
   {{0x6d5c394e,0x6b82ed90,0x3ae80065,0x7bd8ed91}},	//   nnra, _shog, _ابھی_, tuvu,
   {{0x06c700c8,0x8af00201,0x673b86a5,0x60c18019}},	//   ষ্টি, ynəl, _fluj, dalm,
   {{0xdce7003b,0xd90d803d,0x320f80e4,0x26c26d92}},	//   vojč, یین_, _brgy_, jako_,
   {{0xa3d6023c,0x26c26d93,0xadc3801c,0x2576803d}},	//   _समझ_, dako_, _trạn, _فهرس,
   {{0xe1ef880b,0x60c1ed94,0xd7fa80c4,0x6d5c1d14}},	//   اسي_, galm, бум_, jnra,
   {{0x64438063,0x7d051083,0x6b82925b,0x06e380ab}},	//   czni, _rahs, _thog, _নোটি,
   {{0x7d0541f6,0x6c7b80be,0x0ea706af,0x26c24b1a}},	//   _sahs, _פראד, कुंड, gako_,
   {{0x61330214,0x7d050122,0x6abd428b,0x27340129}},	//   _yılı, _pahs, _resf, _mãnh_,
   {{0xe6b9941b,0x2734001c,0x5ba707a1,0x26c26d95}},	//   _उज्ज, _lãnh_, зраз, aako_,
   {{0x0fd700ab,0x7e6401df,0x799d126a,0xdb18807b}},	//   _সন্ধ, _exip, _susw, rsvæ,
   {{0xb7db81c6,0x44316d96,0x7d055f52,0x26c20f3e}},	//   _הקהי, ryz_, _wahs, cako_,
   {{0x69bf80d4,0xd0470085,0x433b80be,0x7d056d97}},	// [7970] लीपी, əməs, צעמב, _tahs,
   {{0x673b8087,0x6729808e,0xdb188338,0x55bc025f}},	//   _sluj, _soej, lsvä, _המזו,
   {{0x67210a74,0x2fc71ab3,0x389b80be,0x673b8722}},	//   यापक_, éng_, ציאנ, _pluj,
   {{0xf7709a37,0xdb18816d,0x0675abca,0x6d8b022b}},	//   هان_, nsvä, муля, _eżat,
   {{0x28dd83b7,0xc1788084,0x2fc70129,0x7bc73c43}},	//   _मालि, klė_, ũng_, lsju,
   {{0x25de016f,0x26c26d98,0x7ae2957a,0x80d8a3bd}},	//   कंती_, zako_, _acot, _मागे,
   {{0xdb018feb,0xbbe88013,0x60c184a2,0x26c20365}},	//   _atlá, كريم_, valm, yako_,
   {{0x7aed2417,0x3b0900b9,0xeeb98081,0x7c2a02df}},	//   nfat, ndaq_, _флаш_, _àfre,
   {{0x26cd807a,0x26c212e5,0x7aed0114,0x6b89ed99}},	//   _ideo_, vako_, ifat, rmeg,
   {{0x26c2400f,0x9f4181a8,0xe125804a,0x3ea903ed}},	//   wako_, ithí_, ємни, _afat_,
   {{0x26c20379,0xfbd084c0,0xf7708065,0xf99f0242}},	//   tako_, _متن_, _شاہ_, _grèv_,
   {{0xd24e95e4,0x60c1d885,0x201102a5,0x994f07c0}},	//   انی_, salm, _mrzi_, yüş_,
   {{0x26c26d9a,0x60c19d3f,0x68faa08e,0x7afb83e4}},	//   rako_, palm, betd, meut,
   {{0x25ad8267,0x61e9e9f2,0x26c26d9b,0x3ebf81a1}},	//   _mtel_, mtel, sako_, _leut_,
   {{0x26c26d9c,0x212a0046,0x7aed15a4,0x64a300c5}},	//   pako_, _robh_, ffat, таса,
   {{0x2907ed9d,0x7afbdc28,0xb0dd8105,0x25aded9e}},	//   _hana_, neut, _माँग, _otel_,
   {{0x61e98cc9,0x2907ed9f,0x2d858101,0x20116da0}},	// [7980] ntel, _kana_, _ohle_, _arzi_,
   {{0x66046da1,0x2907eda2,0x23608503,0x994f080a}},	//   _isik, _jana_, čiji_, rüş_,
   {{0x2907dd37,0x351b0451,0x251b0158,0xe29a1ad8}},	//   _mana_, _ווינ, _וויא, _ман_,
   {{0x2907e90e,0x201102a5,0x25a0059e,0x48fa0b04}},	//   _lana_, _drzi_, _kuil_, _उसको_,
   {{0x7bdc1a67,0x26c00073,0x7afbeda3,0x25a002be}},	//   luru, _meio_, deut, _juil_,
   {{0x29079bb7,0xdb0a816d,0x6604004f,0x7ae2c35c}},	//   _nana_, nsfö, _msik, _scot,
   {{0x7bdc0393,0x61e9eda4,0x69cf81d0,0xa43889c7}},	//   nuru, etel, ácen, язку_,
   {{0x290791c9,0x69bf8035,0x63ba01d6,0xbebb03ed}},	//   _aana_, लीभी, átny, gjël,
   {{0x2907eda5,0x7bdc31ca,0x05768060,0x61e9eda6}},	//   _bana_, huru, _قائد, gtel,
   {{0x3ea90162,0xdb189be9,0x0d838087,0x2d858a2a}},	//   _sfat_, dsvå, _алун, _ghle_,
   {{0x29078025,0x66043129,0x7d1aeda7,0x7bdc0abf}},	//   _dana_, _asik, _ints, juru,
   {{0x81c400c8,0x7bdc5456,0xf09301c6,0x25a0051e}},	//   _এমন_, duru, כנת_, _buil_,
   {{0x61e9802e,0xdb188106,0x25a0198d,0xceb38039}},	//   ctel, rsvä, _cuil_, כיר_,
   {{0x961d80eb,0xd0109190,0x7bc7267f,0xdb0a8106}},	//   _uzņe, _ملت_, tsju, gsfö,
   {{0xdd940110,0x7bdc6da8,0x660458f2,0x9f590065}},	//   тары, guru, _esik, író_,
   {{0x2907b8f6,0x25a00635,0x7bc73fee,0xd138a337}},	//   _zana_, _fuil_, rsju, lką_,
   {{0x2907eda9,0x7d1a90f4,0x7aed0370,0x0dbb0bca}},	// [7990] _yana_, _onts, rfat, _باعث_,
   {{0x7bdc6daa,0xd1388d42,0x7d0885b7,0x7aed00df}},	//   buru, nką_, _nads, sfat,
   {{0x3ebf83d3,0x25ad90f4,0x395eedab,0x61e9edac}},	//   _peut_, _stel_, ints_, ztel,
   {{0xf1a71094,0x7d1aedad,0x61e9b0bd,0x69cf825a}},	//   _कंपन, _ants, ytel, _दिली,
   {{0xd2468013,0x3ebf82be,0x6b8d6dae,0x31a403bf}},	//   _إن_, _veut_, mmag, _göz_,
   {{0x3878007b,0x6b8d6daf,0xdd918019,0xf99f02d6}},	//   _fyrr_, lmag, ھوں_, _drèt_,
   {{0x290780a4,0x36d5824b,0x60c50590,0x7afb8009}},	//   _rana_, _повр, mahm, teut,
   {{0x2907dc6c,0x61e98956,0x7d1ad44f,0x395ec7e3}},	//   _sana_, ttel, _ents, ents_,
   {{0x2907edb0,0x61e98cfa,0x6d55125c,0xda0880ff}},	//   _pana_, utel, kiza, _cỏ_,
   {{0x7fd585a8,0x60c502af,0x7d0880eb,0x7bdc061c}},	//   німі, nahm, _gads, yuru,
   {{0x61e9edb1,0x6d438ad0,0x2907edb2,0xdee6024f}},	//   stel, mhna, _vana_, нони,
   {{0x61e9edb3,0x290785fe,0x395ebb51,0x7bdc6db4}},	//   ptel, _wana_, ants_, vuru,
   {{0x290780a4,0xee3713bf,0xf6521c12,0x26c003a7}},	//   _tana_, еня_, ائج_, _veio_,
   {{0x7bdc0faa,0x60c509ca,0x6d555df6,0x25a006a8}},	//   turu, jahm, giza, _vuil_,
   {{0x31a40182,0x60c5036e,0x6b8d008b,0x629c81d0}},	//   _söz_, dahm, fmag, ěrov,
   {{0x28e2035a,0x7bdc4ffd,0x660438b9,0xab2722a7}},	//   _पाहि, ruru, _tsik, носа_,
   {{0x2d96042f,0x66046db5,0x64a644e0,0xe9da34ba}},	// [79a0] _прос, _usik, _папа, яка_,
   {{0x7bdc3fae,0x6d552503,0x8cdb80d4,0x7cf38457}},	//   puru, ciza, _नागो, nırı,
   {{0x6d43dbae,0x313680be,0x7d08edb6,0x3d1d0072}},	//   dhna, ענעם_, _rads, मारे_,
   {{0x69c98364,0xf99f06c0,0x78bb0bcf,0x81cf0264}},	//   ksee, _prèt_, _đuve, _শহর_,
   {{0x6a9b0039,0x6f09810c,0x25760366,0x7cf382d0}},	//   _משכנ, _daec, bælt_, kırı,
   {{0xafe61fab,0xdd8f806b,0x6d438c5e,0xa3d40035}},	//   _погл, مون_, ghna, _हटा_,
   {{0x76968179,0x01630615,0x69c98009,0x69cb88dc}},	//   _büyü, _скро, esee, _avge,
   {{0x290a4004,0x2d9a0669,0xf99f1f1b,0x6d5564f0}},	//   _haba_, _lipe_, _grès_, ziza,
   {{0x0566acd1,0xd250803d,0x6d5543a9,0x853000fc}},	//   _зван, شند_, yiza, _huɗu,
   {{0x6d43ec40,0xda0880ff,0x290a003d,0x6602a892}},	//   chna, _vỏ_, _jaba_, mwok,
   {{0xdd8f806b,0xd138c702,0x6bd688ca,0x2360009a}},	//   _اول_, rką_, _ستار, knij_,
   {{0x290a6db7,0xd1388d42,0xda0880ff,0x2d9a0032}},	//   _laba_, ską_, _tỏ_, _aipe_,
   {{0xe1ff0118,0x6b4302f1,0x82339a27,0x68469d5e}},	//   _axón_, _jõge, _مروا, _bédé,
   {{0x236081dd,0x290a20b0,0x2d9a6db8,0x2c0d0072}},	//   čiju_, _naba_, _cipe_, हिलं_,
   {{0x99828110,0xe6df0135,0x291f001c,0x85300326}},	//   škų_, _agụụ_, _đua_, _nuɗu,
   {{0x6d555f79,0x23605a55,0x6b9c802a,0x7c258192}},	//   siza, gnij_, _érgu, ähri,
   {{0x290a0a87,0x6b8d5819,0xdb1c016d,0x684680e7}},	// [79b0] _baba_, rmag, dsrä, _fédé,
   {{0x3eb90352,0x6f1b8706,0x290cd479,0x602a811c}},	//   lbst_, _snuc, ndda_, həmm,
   {{0xb909491d,0x3f892056,0xf99f102d,0x290a6db9}},	//   _या_, _khau_, _près_, _daba_,
   {{0xe522001b,0x69c98df6,0xcb35047f,0x7cf385b2}},	//   माथि_, ysee, _ремъ, zırı,
   {{0x1d09a134,0xa5098468,0xdd9b8009,0x22840098}},	//   дели_, дела_, чше_, _бург,
   {{0x61ed23ea,0x290a03c3,0x3f8901c0,0x063800be}},	//   mtal, _gaba_, _lhau_, ענגט_,
   {{0xf99f03d3,0x3ce90fea,0xdfd80698,0x6f0990e4}},	//   _très_, _जाने_, _път_, _taec,
   {{0xe299af8b,0x3f890028,0x23698353,0x6f1b80d2}},	//   май_, _nhau_, čajo_, _unuc,
   {{0x339280f7,0x7cf3817b,0x13068009,0x290a6dba}},	//   جليز, tırı, тный_, _yaba_,
   {{0x69c9edbb,0x2ba985fc,0x61ed4a6a,0x63a182f1}},	//   rsee, _चंपा, ital, _tuln,
   {{0x6d41c43e,0xef862139,0xf746181f,0x61ed1a4b}},	//   _illa, клоп, вено, htal,
   {{0x61ed1fcf,0xbebb00f1,0x2d9a0136,0x7e7b82f7}},	//   ktal, njëh, _sipe_, _kyup,
   {{0xcb368051,0x3f8901e9,0x69c6801b,0x61ed6dbc}},	//   _שאני_, _dhau_, šker, jtal,
   {{0xa3bf0035,0x98a2a306,0x18a281e5,0x3afc027d}},	//   ुओं_, _кише, _кашм, _ập_,
   {{0x290a614a,0x61ed1447,0x03a66dbd,0x00000000}},	//   _raba_, etal, тибо, --,
   {{0x290a243d,0xdb01816d,0x61ed6dbe,0xf8b90129}},	//   _saba_, _utlä, ftal, _đũa_,
   {{0x2d9a08b3,0xc33282f6,0xdb1c016d,0x60c39c11}},	// [79c0] _tipe_, בון_, vsrä, _kenm,
   {{0x3ce90b85,0x290a01b4,0xe0d70eef,0x236d0088}},	//   _जाये_, _qaba_, кву_, čeja_,
   {{0x838a035f,0x40964b8d,0x60c383ec,0x290a0074}},	//   _обов_, трат, _menm, _vaba_,
   {{0x60c398e8,0xa3d7001b,0x290a1e98,0xc29402e3}},	//   _lenm, _सित_, _waba_, _میزب,
   {{0x290a31bb,0x290cedbf,0xdee3af49,0x26d202c4}},	//   _taba_, ydda_, рочи, _mdyo_,
   {{0x628613cf,0x660281bf,0x7ae40074,0xcdb70039}},	//   _izko, rwok, lgit, דפסה_,
   {{0x6d41810c,0xd47a03de,0x7e7b810c,0xd0070162}},	//   _dlla, ואַל, _eyup, _иере_,
   {{0x6d41b6bb,0xd5b2803d,0x7bca8b81,0x7ae43437}},	//   _ella, _نفر_, rsfu, ngit,
   {{0xada694b7,0x35a694b7,0xe5a6942c,0x44380114}},	//   _разл, _разг, _ризи, hyr_,
   {{0x3ea000e7,0x799c0326,0x2cac8326,0xc05a90ac}},	//   _agit_, _jirw, _ufdd_, дім_,
   {{0x60c399eb,0x3f8901c5,0x41d48f85,0x26c48392}},	//   _denm, _phau_, _दिवस, _kemo_,
   {{0x290a97aa,0x44386dc0,0x60c38fb0,0x200782f7}},	//   žba_, dyr_, _eenm, _dsni_,
   {{0x3eb90192,0xe7e481ab,0x26d20365,0x60c386c4}},	//   rbst_, _कमवा_, _ddyo_, _fenm,
   {{0xb4dd0d14,0x8e209246,0x61ed21ad,0xc693807c}},	//   डले_, лiк_, vtal, יאר_,
   {{0x3f892056,0x2d4d10d3,0x60c8839c,0x1c0281ab}},	//   _thau_, džet_, madm, लबिल_,
   {{0x61ed6dc1,0xeab30013,0x26c49bea,0x2249011e}},	//   ttal, شعر_, _nemo_, tzak_,
   {{0x43944566,0x799c2f56,0xdb019f0a,0x661603ed}},	// [79d0] ратс, _birw, _utlå, _gryk,
   {{0x61ed0eb9,0x6d588025,0x58b80013,0x60c8af77}},	//   rtal, jiva, نامج_, nadm,
   {{0x66740077,0x6286011b,0x26c49cfe,0x61e08380}},	//   _مدیر, _ezko, _bemo_, huml,
   {{0x26c48052,0x2366803a,0x61ed62c8,0x673d00e8}},	//   _cemo_, _njoj_, ptal, nksj,
   {{0x6f0d6dc2,0x61e0d52c,0x799c1bad,0x22da025f}},	//   _maac, juml, _firw, _אחרא,
   {{0x6d5897a6,0x6b9d0637,0x236680c3,0x6f0d6dc3}},	//   giva, _hisg, _ajoj_, _laac,
   {{0x60c38247,0x29010088,0x764b0019,0x60c88144}},	//   _renm, meha_, _ügyf, dadm,
   {{0x4429803a,0x2901598e,0x60c38242,0x6b9d0197}},	//   ća_, leha_, _senm, _jisg,
   {{0x6d58a92b,0x6b9d3cdb,0x69cd0428,0x60c3edc4}},	//   biva, _misg, nsae, _penm,
   {{0x6d588025,0x6d41a66a,0x8145803d,0x9f5886c0}},	//   civa, _ulla, اندن, _aprè_,
   {{0x25b2109b,0x68e50c5e,0x6ec7897d,0x6b650196}},	//   _styl_, ighd, ारपु, jėgo,
   {{0xe1f18077,0x29cf00eb,0xe7e48105,0x8af0011c}},	//   _هست_, kļa_, _कमरा_, nnət,
   {{0xcb128051,0x44380355,0x60c38cab,0x7f3a80be}},	//   _ללא_, wyr_, _tenm, גערו,
   {{0x290102ce,0x44386dc5,0x6da31a19,0xe816073c}},	//   jeha_, tyr_, сира, णिमा_,
   {{0x62860063,0x04430554,0x8c431878,0x443e6dc6}},	//   _szko, берн, бере, át_,
   {{0x6d588025,0x66160bc5,0x3ea002c4,0x6b9d0037}},	//   ziva, _tryk, _ugit_, _cisg,
   {{0xc3328496,0x443808dc,0xdb1883ba,0xdb018580}},	// [79e0] זון_, syr_, rsvø, _culé,
   {{0x6d58e1d6,0x88d58264,0x26c48037,0x7ae46dc7}},	//   xiva, ত্রক, _semo_, sgit,
   {{0x3ce92e06,0x6d58e34b,0x6609b328,0xcae38035}},	//   _जाते_, viva, _asek, _गांड_,
   {{0x6aad00e5,0x5276053b,0x69dbedc8,0x59d48a27}},	//   ccaf, _бугу, krue, _दिलर,
   {{0xee3a876a,0x26c4807a,0x7bce0b81,0x62860ec3}},	//   энд_, _vemo_, lsbu, _uzko,
   {{0x18a30554,0xa0a31e9d,0x27e100ee,0x6b8b85ee}},	//   _гарм, _гард, buhn_, _ahgg,
   {{0x6d58c4b2,0x26c48353,0x7bce14fb,0xec3600be}},	//   riva, _temo_, nsbu, טאַר_,
   {{0x660606cb,0x395a6966,0x20184a85,0x53349a47}},	//   kwkk, lips_, _irri_, реит,
   {{0x0d8689c7,0x6f0d02a3,0x9e668b9b,0x6d589bda}},	//   _блан, _raac, _свад, piva,
   {{0x61e090d7,0x7f4419d7,0x6f0d52e6,0x7bce6dc9}},	//   ruml, _aliq, _saac, ksbu,
   {{0x7bce1601,0x637e80f1,0x9f58b7ba,0xd8db03de}},	//   jsbu, hëni, _apré_, עקטר,
   {{0x7f442cd0,0xfaa69016,0x2ee68a53,0x7bce04dc}},	//   _cliq, _садо, ngof_, dsbu,
   {{0x66e60592,0x2d4d025b,0x3ce90074,0x6b9d6dca}},	//   _कारक_, džer_, _जादे_, _risg,
   {{0xe8949a8f,0x237900b9,0x3d0f0035,0x20186dcb}},	//   _каль, _sksj_, ायें_, _orri_,
   {{0xa3e40a27,0x7a488029,0x27f7826f,0x2d9e837f}},	//   _नमः_, sūtī, čená_, _mite_,
   {{0x2d9e8186,0x290e87ca,0xa2b54365,0x236d007a}},	//   _lite_, _hafa_, рбач, čejo_,
   {{0x290e80a4,0xc299176e,0x1dc68778,0x26cb00e5}},	// [79f0] _kafa_, тках_, रीमत, maco_,
   {{0xf1da0fb2,0x26cb016a,0x290ea3c0,0xdb150061}},	//   यंजन, laco_, _jafa_, tszó,
   {{0x6d450201,0xa3a9858c,0x29016dcc,0x6d570372}},	//   _ilha, _गंध_, reha_, _imxa,
   {{0x7ff40013,0x273b0168,0x2d9e851e,0x290e9e1d}},	//   إسلا, _bëni_, _aite_, _lafa_,
   {{0x6cc59c0e,0x3d0a035a,0x29010b44,0x398b8aa2}},	//   айла, ायचे_, peha_, løse_,
   {{0xabd599e3,0xdfc684a3,0x6609807a,0x8cba12e0}},	//   ациј, _وي_, _vsek, ्रयो,
   {{0x2d9eedcd,0x2d99810c,0x00000000,0x00000000}},	//   _dite_, _èsem_, --, --,
   {{0x6609d885,0xb33b07d9,0x613f82df,0x2b49027d}},	//   _tsek, _hiçb, _pêlo, nhac_,
   {{0x6d450073,0xaca30032,0x290e9896,0xb1458cf3}},	//   _olha, _ajọd, _bafa_, инил,
   {{0xe9ff00ff,0x69dbded2,0x2d9e85ed,0x290e82d6}},	//   _giấc_, rrue, _gite_, _cafa_,
   {{0xa0699c79,0x8c679c68,0x290e8300,0x1869831f}},	//   тана_, _стад, _dafa_, тани_,
   {{0x7d03c23a,0x6d450300,0x61fd47a5,0x3a75c4e0}},	//   lens, _alha, _opsl, _клер,
   {{0x6d4501c0,0x290e8915,0x7d038cfa,0x93948019}},	//   _blha, _fafa_, oens, _اجلا,
   {{0x7d03edce,0x82348077,0xc0e28ca0,0x60c701d0}},	//   nens, _درما, _дошк, _nejm,
   {{0xb7b000c8,0x30798158,0x207980be,0x32190359}},	//   _চট্ট, _באַנ, _באַא, _arsy_,
   {{0x60d500b9,0x6d456dcf,0xa3d70ad5,0x200a02f7}},	//   _adzm, _elha, _सिर_, _rsbi_,
   {{0xeb971156,0x395a03a6,0x3b0718a0,0xdcfa801b}},	// [7a00] рит_, tips_, шето_, _chtě,
   {{0x7bce01e0,0x1aee00ab,0xa63b01c6,0x777b85e7}},	//   psbu, _চোখে_, _סגיר, _akux,
   {{0x7d03edd0,0xc7968110,0x2d9eedd1,0x395a43e8}},	//   dens, арды, _rite_, rips_,
   {{0x91e614b7,0x6d5c5f84,0x2d9ebc72,0x28e21c4f}},	//   _коме, lira, _site_, _पाकि,
   {{0x7d038cf7,0xd64e8133,0x3f8db936,0x613f8123}},	//   fens, mọkụ_, _dheu_, _pêll,
   {{0x7d03d778,0x60c70088,0x764b0061,0x2b40026c}},	//   gens, _gejm, _ügye, lkic_,
   {{0x2d9ecdb6,0x0fe080c8,0x9b5898ba,0xe4ee154b}},	//   _vite_, _বন্ধ, ликт_, _जानि_,
   {{0x6d5c6dd2,0xcfb70051,0x290eafe2,0x60c7001b}},	//   hira, _כללי_, _safa_, _zejm,
   {{0x6d5c6dd3,0x7d03a26b,0x2d9eedd4,0xd5a50105}},	//   kira, bens, _tite_, _गूंज,
   {{0x6d5c1d95,0x7d03a41a,0x2d9e8087,0xa3d740f2}},	//   jira, cens, _uite_, _सिल_,
   {{0x94068077,0x61e4010a,0x13068098,0xb8ce8128}},	//   _خواه, huil, _взем, _कल_,
   {{0x644e0b67,0x6d5c0ba3,0xd49180ff,0x290ec7ef}},	//   dzbi, eira, _này_, _wafa_,
   {{0x26cb6dd5,0x224d809a,0x6d450282,0xee870fe6}},	//   raco_, czek_, _plha, рыно,
   {{0x657d8b18,0x6d5c24fc,0x97a69ad8,0x26cb041c}},	//   _ësht, gira, _крил, saco_,
   {{0xf2c710f8,0x443c8019,0x939701a8,0x26cb07b6}},	//   исан, nyv_, لجرا, paco_,
   {{0x442d003a,0x7d03a7c1,0x60c76dd6,0x4fb3936d}},	//   će_, zens, _sejm, _بصور,
   {{0x6d5c1efb,0x443f0029,0x61e46aa5,0x443c8144}},	// [7a10] bira, ņu_, guil, hyv_,
   {{0x2b4687e2,0x7d039045,0x660d6381,0x23698805}},	//   _lloc_, xens, _isak, čaji_,
   {{0x7d03edd7,0x2d8302a5,0x69c00168,0xe81986a7}},	//   vens, mlje_, _çmen, धिया_,
   {{0x7d0384b2,0xd3668199,0x2d834292,0xdb01804a}},	//   wens, _ره_, llje_, _utlø,
   {{0x25a913b8,0x60c7269d,0x61e405ae,0x88de80ab}},	//   _jual_, _tejm, cuil, ব্যক,
   {{0x6d4aedd8,0x25a90890,0xb4d1816f,0xd4699860}},	//   ghfa, _mual_, वणे_, лиле_,
   {{0x2b46e27a,0xbebb0168,0x58d40087,0x320927d3}},	//   _bloc_, njës, _фост, lway_,
   {{0x660d4e10,0x386981a1,0x13098087,0x224d8cdb}},	//   _osak, _ćar_, уний_, tzek_,
   {{0x6d5c4a82,0x29114a05,0x7d0390b6,0x660d0c8b}},	//   yira, _kaza_, pens, _nsak,
   {{0x5d8580f7,0x39458ca0,0x661b948e,0x6d4ad377}},	//   _الطل, сног, _iruk, chfa,
   {{0xe73a044f,0x224da422,0x29116dd9,0x93278019}},	//   ген_, szek_, _maza_, _پران,
   {{0x6d5c3be0,0x32090637,0x25a909c5,0x26c90118}},	//   wira, kway_, _bual_, _ceao_,
   {{0xf1a79fab,0x25a905b4,0x9b748013,0xe28e9401}},	//   _трен, _cual_, _بالص, _ха_,
   {{0x61e40009,0x7c3c03ba,0x9f5880e5,0x32090c6b}},	//   vuil, tyrr, _aprì_, dway_,
   {{0x6d5c6dda,0x2905912e,0x8c430765,0x32091c33}},	//   rira, mela_, пере, eway_,
   {{0x290591e8,0x3ea0812b,0xaec6196e,0xce5a00d7}},	//   lela_, žiti_, _убил, _مشخص_,
   {{0x29110745,0x3209435f,0x2d8300ce,0x612d8019}},	// [7a20] _baza_, gway_, blje_, _súly,
   {{0x2905c3b5,0xe2970d46,0x291105e4,0xeeeb001c}},	//   nela_, сау_, _caza_, ượng_,
   {{0x3ead267b,0x61e415ba,0x32093a19,0x29110326}},	//   žete_, suil, away_, _daza_,
   {{0x661b979a,0x6f0602a5,0x29058234,0x80c6001b}},	//   _bruk, nekc, hela_, िरहे,
   {{0x61e42321,0x6b8400f2,0x2905829b,0x63a88754}},	//   quil, mlig, kela_, _sudn,
   {{0x29058582,0x2911054e,0x28e20540,0xbebb03ed}},	//   jela_, _gaza_, _पाटि, njër,
   {{0x68e36ddb,0x60262597,0x7ae98192,0x661b9c00}},	//   ónde, _удва, fget, _eruk,
   {{0x6b840bfa,0x661b8448,0x1de0852a,0x7ae9a91e}},	//   nlig, _fruk, _निपत, gget,
   {{0xdb018118,0x3ce902f1,0x2905dc72,0xcb1301c6}},	//   _gulí, _जाले_, fela_, ללה_,
   {{0x3a370051,0x290584bb,0x63a88019,0x795894ed}},	//   צרים_, gela_, _tudn, риор_,
   {{0x2d83003b,0x6c868013,0x6b845bc2,0x7f5d19c5}},	//   vlje_, _الام, klig, tisq,
   {{0x6b845eb3,0x8f47160f,0x09e6ab3f,0x398f0192}},	//   jlig, сход, _годн, müse_,
   {{0x25a92670,0x2905cf67,0x7f5d05db,0x6b840f06}},	//   _qual_, bela_, risq, dlig,
   {{0x29059845,0x660d0db7,0x80de00c8,0x63a280f7}},	//   cela_, _vsak, ন্ত্, _hion,
   {{0x63a28010,0x7bda192c,0x853b84de,0x291126ef}},	//   _kion, štun, נגלי, _raza_,
   {{0x660d03c3,0x6b840f06,0x2d8306ec,0x63a2804f}},	//   _tsak, glig, slje_, _jion,
   {{0x6d488117,0x63a2eddc,0x660d0726,0x6d5a8f06}},	// [7a30] _olda, _mion, _usak, _omta,
   {{0x394748a0,0x63a29581,0x210303b7,0x32093260}},	//   óns_, _lion, रजेश_, rway_,
   {{0xe4ee0b75,0x320900dd,0x6b84139a,0x4c950af0}},	//   _जाति_, sway_, blig, _финс,
   {{0x6d4880ad,0x2905c82e,0xc7b380be,0x3cfb801b}},	//   _alda, zela_, לבע_, ल्ने_,
   {{0xbf470324,0x628281c5,0x29110388,0x2905926f}},	//   únṣe_, _nyoo, _taza_, yela_,
   {{0x81b780c8,0xfe708fc5,0xf2b38f12,0x7d071b40}},	//   _ছিল_, ردن_, ीर्घ, nejs,
   {{0x2905c080,0x395e815d,0x7ae98c4d,0xf8ae07d2}},	//   vela_, dits_, tget, _شکل_,
   {{0x80de00c8,0xe9d99541,0x63a2808c,0x661beddd}},	//   ন্দ্, аки_, _cion, _truk,
   {{0x63a2911b,0xc9a681a0,0x661b82a0,0x7f498197}},	//   _dion, овые_, _uruk, _ileq,
   {{0x92e98a49,0x672415f5,0x26cf92e5,0x395ee8f6}},	//   য়ে_, _snij, lago_, gits_,
   {{0xa3cb01fe,0x2905b5be,0x5f060af2,0x1cb887bd}},	//   रीम_, rela_, озна, _طالب_,
   {{0x2905edde,0x26cfe96e,0x7c2a023e,0xbf8780ff}},	//   sela_, nago_, _àfri, _điền_,
   {{0x6b840e23,0x80ba8054,0x23788061,0xaa58a134}},	//   vlig, _श्वे, _írja_, _лицу_,
   {{0x2369803a,0x7afd0367,0x395ecf42,0x7e9a807c}},	//   čaju_, _abst, cits_, יסרו,
   {{0x6b840687,0x64a30be4,0x26cf9210,0xdca35f05}},	//   tlig, дара, kago_, дари,
   {{0x63a2822c,0x236915ab,0x96ba0073,0xeeeb00ff}},	//   _xion, gnaj_, _туку_, ưỡng_,
   {{0x6b840f06,0x26cf9ffc,0x628281c5,0xa3cb066f}},	// [7a40] rlig, dago_, _xyoo, रीब_,
   {{0x7afd02c4,0x6d43cc84,0xf99f0176,0x0903274b}},	//   _ebst, jkna, _krèy_, мпун,
   {{0xb9020063,0x6b84257d,0xcc8a0077,0xc6a6a659}},	//   _नए_, plig, _خنده_, орли,
   {{0x34b490f7,0xe61a917e,0x1e8680a9,0x4eba80ab}},	//   ुर्द, иде_, олем, ুল্ল,
   {{0x63a29d15,0xdd8f80d7,0x929d866f,0x2b4718ad}},	//   _rion, چون_, wełn, _înca_,
   {{0xdd8f806b,0x6d4e6ddf,0xf99f0176,0x26cf838a}},	//   نون_, nhba, _orèy_, aago_,
   {{0xf746932a,0x26cfb537,0x22400019,0x395ea651}},	//   _дево, bago_, lyik_, vits_,
   {{0x7d070933,0x3ce082d0,0x657c0122,0x5a349577}},	//   zejs, şiv_, horh, знит,
   {{0x63a2822e,0x395e8557,0x6f1d91b9,0x6d4e5c52}},	//   _vion, tits_, _ósca, khba,
   {{0x3f86e567,0x929d809a,0x321d831d,0xdb08816a}},	//   llou_, pełn, _drwy_, _mudé,
   {{0xe81d08fd,0x63a2cf3f,0x6d4e00f7,0x213809d1}},	//   फिया_, _tion, dhba, _morh_,
   {{0x80ba885d,0x2b5f8162,0x201c8824,0xa3df852a}},	//   _श्रे, ciuc_, _vrvi_, _तित_,
   {{0x3326ec8d,0xfd5784be,0x657c0aa2,0x079b83c8}},	//   _inox_, _adaṣ, forh, יסטל,
   {{0x2369009a,0xb4d5016f,0x22400637,0x26cf8cdb}},	//   wnaj_, हणे_, dyik_, zago_,
   {{0x7d076de0,0x26cfab6b,0x93bc8162,0x3f86cd18}},	//   rejs, yago_, _drăg, klou_,
   {{0x67198327,0x27f395d8,0x26cf9fa4,0x00000000}},	//   _नोंक_, žaní_, xago_, --,
   {{0xaf4b07d2,0x26cfb2b5,0x2369016b,0x7d070035}},	// [7a50] _مشکل_, vago_, rnaj_, pejs,
   {{0x3495138c,0x6d4e02af,0xcd00009a,0xdb088144}},	//   _напр, chba, ęści_, _dudé,
   {{0x26cf8637,0xb8d30540,0x213809d1,0x2fc700d7}},	//   tago_, _ऑल_, _dorh_, èng_,
   {{0xaca301bc,0x4758804a,0xbf58804a,0xa3cb0b99}},	//   _chụd, орія_, орії_, रीण_,
   {{0x7bc8831d,0x26cf9c88,0xdd1481ac,0x59e22bef}},	//   _awdu, rago_, _dĺžk, _पियर,
   {{0x7aed58ce,0xd0a28091,0x2ea81d40,0xa50986e9}},	//   lgat, _gẹgẹ, _गल्त, сека_,
   {{0x26cfede1,0x6d43a32f,0x2b4b0748,0x26c2009a}},	//   pago_, rkna, _klcc_, ybko_,
   {{0x7aed4450,0x3f868722,0x05dc0697,0x3f9901a1}},	//   ngat, clou_, _बिलब, jmsu_,
   {{0xa3cb0744,0x5d558db4,0x02028162,0x2b5f8493}},	//   रीत_, _екат, езын, riuc_,
   {{0x3ea90013,0x2eb61305,0xa3ab02f1,0xe3b39ef7}},	//   _agat_, ूर्त, खदा_, _قرص_,
   {{0xf3f080f7,0x48fd085d,0x657c6de2,0xb33b1a1f}},	//   _لأن_, र्यो_, vorh, _niço,
   {{0x321d831d,0x3f6a06f9,0x23fa81c6,0x2d810234}},	//   _trwy_, симо_, _לפעמ, _akhe_,
   {{0x657c10c9,0xf1a70105,0x7afb8c7e,0xdb0184e8}},	//   torh, _कंगन, mfut, _gulá,
   {{0x7aed6de3,0x61e9ede4,0xb226807b,0x7bda0110}},	//   egat, muel, stæð, štum,
   {{0xf746144c,0xa066a29c,0x18668dbd,0x93bc8087}},	//   _неко, _наша_, _наши_, _grăd,
   {{0x25a581cd,0x23b18e14,0x7aed364f,0x8b95658c}},	//   _lill_, _máj_, ggat, друч,
   {{0xe2973e11,0x7afb83e4,0x6b650196,0x00000000}},	// [7a60] зат_, ifut, jėgu, --,
   {{0xf8bd9513,0x7aed011b,0x9f4600d7,0xe9d70a4c}},	//   ोरिय, agat, dulé_, яку_,
   {{0x61e9ede5,0x2252009a,0x31660267,0xdb240019}},	//   huel, szyk_, đoz_, _ہوگی,
   {{0x61e9ede6,0x25a58219,0x4422a329,0x2d87ede7}},	//   kuel, _aill_, _čk_, elne_,
   {{0x539b010f,0xd6cf8154,0x61e98216,0xceb304de}},	//   _ליטו, اقه_, juel, גיד_,
   {{0xf9878117,0x25a58635,0x6604314f,0x61e9d4be}},	//   _سب_, _cill_, _mpik, duel,
   {{0x69dd8038,0xb4ac8105,0x200c047f,0x60260190}},	//   ásen, _गली_, _èdi_, _эдва,
   {{0xe3af8077,0x2d87b0e6,0x25ada79a,0x98a30956}},	//   درو_, alne_, _fuel_, _чисе,
   {{0x6d5e6de8,0x64430214,0xdcf88c22,0xdb1c3b51}},	//   _ompa, _üniv, lovč, rprè,
   {{0x25fb85b3,0x63a60687,0x7aed0019,0x6d5e00ee}},	//   ोबरी_, _likn, zgat, _nmpa,
   {{0xc05a81e5,0x66046de9,0xdcf8842b,0x764280fc}},	//   сіп_, _apik, novč, lyoy,
   {{0x6d5e0db7,0x69d66dea,0x6f1606e7,0x61e9923d}},	//   _ampa, ksye, _cayc, buel,
   {{0x61e985b4,0x764280a4,0x5fce0768,0x62860711}},	//   cuel, nyoy, _हौसल, _nyko,
   {{0x61e42e2f,0xdcf889d1,0x753a8102,0x7aed0362}},	//   dril, kovč, _jotz, wgat,
   {{0x0133990c,0x66046deb,0xd4040c40,0x1dd900d4}},	//   _سعود, _epik, няти, _भटकत,
   {{0x7aed0087,0x3ce90074,0x3ea916fb,0x6286067f}},	//   ugat, _जाके_, _ugat_, _byko,
   {{0x7aed420d,0x7bd50019,0xd7f88087,0x63a64556}},	// [7a70] rgat, sszu, ltă_, _dikn,
   {{0x7aed243a,0x48ab1986,0x69c481b9,0xa41c86a7}},	//   sgat, стам_, _ħiel, पटाप_,
   {{0xd7f88012,0x60ce0144,0x61e40100,0x2ef599b8}},	//   ntă_, _debm, aril, дзер,
   {{0xf77396a5,0xf1dd809a,0x25a5edec,0xadc4046d}},	//   راض_, _मिलन, _sill_, _ayẹw,
   {{0x25ada4c1,0x61e9eded,0x764282d5,0x7f4d0197}},	//   _quel_, xuel, gyoy, _mlaq,
   {{0x61e985a4,0xc2120039,0x61e2007a,0x6b828032}},	//   vuel, _שהם_, šolc, _akog,
   {{0x25a5d425,0xe9ff001c,0x753ab11d,0x3b9583a7}},	//   _vill_, _khắc_, _dotz, мјит,
   {{0x25a59964,0xb2259509,0x7528de88,0x7f4d0609}},	//   _will_, дмил, _endz, _nlaq,
   {{0x25a584b5,0x6d47473f,0xf77089a7,0x44210115}},	//   _till_, kkja, _صاف_, _lrh_,
   {{0x6b82edee,0xdb1c2d1a,0x48f2001b,0x753a8cdb}},	//   _ekog, rpré, ुभयो_, _gotz,
   {{0xdee60dc0,0xdb1c07e2,0x65638073,0x6b4e846d}},	//   мони, spré, minh, _dùgb,
   {{0xd90f8117,0x6563edef,0x501a0039,0x6d5e09ca}},	//   ئیں_, linh, קורו, _smpa,
   {{0x61e989b2,0x236da19c,0xa2948221,0xe8ee817c}},	//   quel, mnej_, _заці, _ил_,
   {{0x236d9988,0x6b89a0a5,0x61e40850,0x6563d193}},	//   lnej_, lleg, vril, ninh,
   {{0x6da30abe,0x628f8024,0xe5a31155,0xd7f88087}},	//   тира, škoć, тири, ctă_,
   {{0x6b898357,0xe9ff0028,0x65639217,0x236dedf0}},	//   nleg, _chắc_, hinh, nnej_,
   {{0xe1f981e2,0x6563cddc,0x6f19831d,0x6d5e0359}},	// [7a80] ntų_, kinh, ddwc, _tmpa,
   {{0x6d5e0397,0x69d602e7,0x62860a21,0x65638187}},	//   _umpa, rsye, _vyko, jinh,
   {{0x62860063,0x65638073,0xa00a05ff,0x6b89b6bd}},	//   _wyko, dinh, تقال_, kleg,
   {{0x61e4003a,0xe1f981e2,0xdcf88088,0x6443d5f8}},	//   pril, ktų_, rovč, dyni,
   {{0x236da1a9,0x7d17029a,0x6b89821e,0x60ce01c0}},	//   dnej_, _yaxs, dleg, _tebm,
   {{0x6b828687,0x6563b171,0xf8b2052a,0x64438114}},	//   _skog, ginh, _जलिय, fyni,
   {{0x6b89b9d7,0x69cb81b4,0x64431238,0x212a0706}},	//   fleg, _awge, _ünit, _inbh_,
   {{0x27f7000d,0x521492b2,0xd0418085,0x6b898357}},	//   žení_, едит, qalə, gleg,
   {{0x29186df1,0x6d470125,0x6563d93b,0x26c6e0cb}},	//   _kara_, ykja, binh, mboo_,
   {{0x29186df2,0xd8f880e8,0x270e8424,0x656383a7}},	//   _jara_, чної_, _ससुर_, cinh,
   {{0x29182c07,0x6b89cc4e,0x236dedf3,0x7f4d473a}},	//   _mara_, bleg, bnej_, _plaq,
   {{0x29186df4,0xd7f8802e,0xb7d88065,0x6b89809a}},	//   _lara_, rtă_, _ہوتا_, cleg,
   {{0xd7f8802e,0xdb08b88a,0x29180162,0x56941af1}},	//   stă_, _judí, _oara_, кают,
   {{0x29185a62,0xd7f88087,0x77608118,0x6b80edf5}},	//   _nara_, ptă_, _lmmx, lomg,
   {{0xe7e58d38,0x5ba722ea,0x6d476df6,0xdb1a8866}},	//   _किया_, драз, rkja, _atté,
   {{0x44210bc1,0x6563d1c0,0x290ca92b,0x6b80901f}},	//   _vrh_, zinh, leda_, nomg,
   {{0x29184225,0x60c90088,0x64438035,0x851a0054}},	// [7a90] _bara_, _đemb, zyni, _फोकट_,
   {{0x29180763,0x290cd746,0x4421026f,0x6563d93b}},	//   _cara_, neda_, _trh_, xinh,
   {{0x29186df7,0x656383a7,0xe9ff001c,0x248980fc}},	//   _dara_, vinh, _thắc_, ƙami_,
   {{0x05e084e5,0x290c8098,0xdb08816b,0xe1f98084}},	//   _निशब, heda_, _budí, ytų_,
   {{0x29186df8,0x65638073,0x236d81ac,0x16220ebf}},	//   _fara_, tinh, vnej_, मियर_,
   {{0x29184f9d,0x290c920e,0x61ed1600,0x6443edf9}},	//   _gara_, jeda_, mual, tyni,
   {{0x673ba252,0x6563edfa,0x6b89cb48,0x236da1a9}},	//   _touj, rinh, tleg, tnej_,
   {{0x291835be,0x65639677,0x38b50b4c,0x6b51016d}},	//   _zara_, sinh, _fúró_, _fåge,
   {{0x236da1a9,0x29186dfb,0x6b89caae,0x656383a7}},	//   rnej_, _yara_, rleg, pinh,
   {{0x6b89a055,0xdb0600f1,0xe1f98110,0x290c82f1}},	//   sleg, _pikë, rtų_, geda_,
   {{0xe1f981e2,0x6b899c0f,0x61ed2d2a,0xef1981b9}},	//   stų_, pleg, hual, _każ_,
   {{0x44263404,0xa822b026,0xb33b00f1,0x61ed0102}},	//   _čo_, اکون, _diçk, kual,
   {{0x290cedfc,0x3ea4016d,0xdb0883a8,0x25bf8609}},	//   beda_, ämt_, _xudí, _jtul_,
   {{0x290c8333,0x98aa001b,0xdb050019,0x61ed137c}},	//   ceda_, _době_, _ruhá, dual,
   {{0xf1bf0307,0x291837a9,0x61fbc3e3,0xa3cb016f}},	//   _atá_, _rara_, ltul, रील_,
   {{0xdbd60074,0x3eadc6eb,0x61fbb82d,0xa3c28a27}},	//   _rääg, _nget_, otul, ्ठत_,
   {{0x29186dfd,0x61fb8abf,0x3f821c8c,0x6f0400b4}},	// [7aa0] _para_, ntul, moku_, _ibic,
   {{0x5e5700be,0x3f826dfe,0x29180085,0xdce38110}},	//   _נייע_, loku_, _qara_, monė,
   {{0x29182666,0x3ead808e,0x25bf8326,0x6e2402d4}},	//   _vara_, _bget_, _atul_, _hrib,
   {{0x291801cd,0x60c3017b,0x25bf8239,0x3ae80065}},	//   _wara_, ınma, _btul_, _کبھی_,
   {{0x7981ac0b,0x61ed0867,0xef198372,0x8af0011c}},	//   kolw, cual, _daż_, rhəd,
   {{0x59b51094,0x69c46dff,0x3ead904a,0x3f822817}},	//   _अंतर, mpie, _eget_, hoku_,
   {{0x290cee00,0xf8a70701,0xdee69950,0x66e69511}},	//   veda_, _कृपय, _пови, _пова,
   {{0x31c69242,0x2d858214,0xe805050d,0x6b510efa}},	//   нсов, _ekle_, _रहता_, _tåge,
   {{0x290c805c,0x61fbbd52,0x69c46e01,0x49748615}},	//   teda_, gtul, npie, клис,
   {{0x2ee030f8,0x6f042fea,0x09f70039,0xdb06010c}},	//   _adif_, _abic, עמים_, _diké,
   {{0xb4cc8701,0x61ed1717,0xf65f8125,0x6e2400b4}},	//   लरी_, zual, _þær_, _arib,
   {{0x7d1aee02,0x3ead0aa2,0x98aa01d0,0x3f8208f9}},	//   _hats, øet_, _sobě_, goku_,
   {{0x7d1aee03,0x614686c8,0x290c8072,0xd9469fa2}},	//   _kats, _педа, peda_, _педи,
   {{0x0217810f,0xc69383c8,0xd90e803d,0x2d850036}},	//   _נחום_, טאר_, _اید_, ôle_,
   {{0x7d1a83c3,0xef1f03bf,0x6e240c2e,0xc88581ec}},	//   _mats, nlük_, _erib, ößte_,
   {{0xb33b0085,0xa3e895b2,0x26d26e04,0xfaff03ed}},	//   _kiçi, _बिन_, _geyo_, _ajër_,
   {{0x3da71878,0x6e246e05,0xb5a71663,0x672d6e06}},	// [7ab0] _проб, _grib, _прой, _inaj,
   {{0x6f0f2d11,0x7d1aa3be,0x6f1d1991,0xa3c280c2}},	//   lecc, _nats, ldsc, ्ठा_,
   {{0x61ed1441,0xfe702385,0x2d830984,0x69c401e8}},	//   sual, _ندی_, moje_, apie,
   {{0x6458aec0,0x2d831d73,0xdc3600be,0x6f0f5bc0}},	//   dzvi, loje_, _סארט_, necc,
   {{0x7d1ad80b,0x6b8d54fb,0x5f749a00,0x645880e1}},	//   _bats, mlag, دالر, ezvi,
   {{0x2d831d73,0x7d1a9e03,0x6b8d10b6,0xdb088580}},	//   noje_, _cats, llag, _audà,
   {{0x7d1a84bb,0x2ef58992,0xef1981b9,0x4cca80ab}},	//   _dats, _извр, _taż_, _রাখু,
   {{0x6b8d2709,0x61fbee07,0xb33b0315,0x6f1d00f3}},	//   nlag, ttul, _biçi, jdsc,
   {{0xfe738065,0x2d835ed8,0x7d1acc05,0x11d680f7}},	//   _صدر_, koje_, _fats, نوية_,
   {{0x2d8301e2,0x98a58aac,0x61fbc1f6,0x6d4a8edc}},	//   joje_, кипе, rtul, ckfa,
   {{0x69c40063,0xf8b202f6,0x6f1bee08,0x6f0f12cc}},	//   zpie, ישי_, _kauc, fecc,
   {{0x66162280,0x7981cee1,0x6b8d40d1,0x61fb8087}},	//   _psyk, solw, jlag, ptul,
   {{0x780d000c,0x6b8d6e09,0xa3d411bc,0x7d1aee0a}},	//   सबुक_, dlag, सीन_, _yats,
   {{0x0cb000c8,0x4d15054c,0x3f82012b,0x2d836e0b}},	//   কর্ত, льст, soku_, goje_,
   {{0x69dd0186,0x6b8d4255,0xdbcc002a,0x6b6788f9}},	//   _avse, flag, _póñe, _gègè,
   {{0x6f042eaa,0x6609d438,0x6b8d1fc9,0x6f1b87c6}},	//   _ubic, _opek, glag, _nauc,
   {{0xf2d28158,0x03a32ed9,0xef1f0214,0x69dbd94c}},	// [7ac0] יען_, рито, zlük_, nsue,
   {{0x672d3e1d,0x25d7093f,0x63abee0c,0xd5b7000f}},	//   _znaj, _שוין_, _lign, _इंतज,
   {{0x69c41f8b,0x6f1b96a0,0x7d1a8336,0x07a681b5}},	//   spie, _bauc, _rats, важн,
   {{0x7d1a8bfa,0xdee68a7c,0x0bb70051,0x69db8be7}},	//   _sats, тоди, _שלכם_, ksue,
   {{0x6b8400e7,0x7d1acb61,0x61e9817f,0xed5a9539}},	//   moig, _pats, jrel, мод_,
   {{0xa8061a19,0x44258187,0x61e998ad,0x63abaad0}},	//   _изгл, _brl_, drel, _aign,
   {{0x6609843b,0x6f0f0876,0x63abd7d9,0x3f6a8ae7}},	//   _epek, yecc, _bign, _живо_,
   {{0x7d1ab6ba,0x6f0f04c3,0x6f1b82be,0x5b14895d}},	//   _wats, xecc, _gauc, умит,
   {{0x7d1aee0d,0x6f0f6e0e,0xf74383a7,0x9cf6802e}},	//   _tats, vecc, _тето, _ачеш,
   {{0x63ab8357,0x35dc0035,0x6b8d007a,0x7d1a822c}},	//   _eign, _बिज़, zlag, _uats,
   {{0x6f0f2d11,0x2d836e0f,0x61e9a6a8,0x63abee10}},	//   tecc, voje_, arel, _fign,
   {{0x6b8400e7,0xf99f03ec,0x2d5402f1,0x69db8661}},	//   joig, _apèl_, _näeb_, bsue,
   {{0x6f0f11b9,0x2d831d73,0x61e99238,0x7ae2c5e1}},	//   recc, toje_, crel, _idot,
   {{0xe9ff0104,0x644581ec,0xac190073,0x0cbf0f21}},	//   _nhạc_, ähig, ногу_, ्रेम,
   {{0x2d83028f,0x6b8d20e4,0x7bdc2417,0x1af58264}},	//   roje_, tlag, gsru, _আসতে_,
   {{0x291c8182,0x97a411e9,0x672d0010,0x2d832ed0}},	//   _hava_, _крыл, _unaj, soje_,
   {{0x49751878,0x6b8d0456,0x291c9ba4,0x20186e11}},	// [7ad0] глас, rlag, _kava_, _asri_,
   {{0x6b8d3dbc,0x6f1bee12,0x29cf42ac,0x291e8019}},	//   slag, _sauc, rża_, ndta_,
   {{0x6c350c2b,0x6b8d10cc,0x7ae28009,0x30a7180f}},	//   _صفحا, plag, _odot, трав,
   {{0x7bc72991,0x61e98aaa,0x291cee13,0xc2e880ab}},	//   mpju, yrel, _lava_, ক্তি_,
   {{0xdef887ac,0x4425ee14,0xfce5a45b,0x201e00d2}},	//   тых_, _srl_, голо, _štit_,
   {{0x63ab8213,0x7ae2ee15,0xe3b0004e,0x0d84902a}},	//   _sign, _adot, _دری_, алін,
   {{0x97a78048,0x26d944ec,0x63aba7f5,0xdb088333}},	//   _арал, kaso_, _pign, _sudá,
   {{0x61e98003,0xe4e308fd,0xb8821dc1,0x3f8901c0}},	//   trel, कृति_, číta, _nkau_,
   {{0x2249048f,0x63abe14d,0x291ccb40,0x28a70ebf}},	//   nyak_, _vign, _bava_, _कृति,
   {{0x61e9ca6c,0x291c92d0,0x3f8900dd,0x7ae28102}},	//   rrel, _cava_, _akau_, _edot,
   {{0x69db9b56,0x63ab820d,0x3a2680f3,0x291cb6b2}},	//   ssue, _tign, _erop_, _dava_,
   {{0x69c11807,0x61e9ee16,0x628b809a,0x26d90c2e}},	//   _člen, prel, _tygo, gaso_,
   {{0xcdf60a7f,0x09e58009,0x55f60e11,0x291c8037}},	//   ычны, _солн, ычну, _fava_,
   {{0x6d41bfae,0x60d50259,0x3f8900b9,0x7bdc6e17}},	//   _jola, _nezm, _ekau_, tsru,
   {{0x6b510502,0x5faf0e10,0xf992807c,0x26d96e18}},	//   _såga, _जंगल, _הרג_, baso_,
   {{0x26d905e4,0x7c2eee19,0x6d4193fa,0x13d1801b}},	//   caso_, _ábre, _lola, _सबैभ,
   {{0x0eaa035f,0x60d55434,0xa3d40540,0x7bdc1388}},	// [7ae0] _який_, _bezm, _सौर_, ssru,
   {{0x6b510186,0x6d41ee1a,0x291c8118,0x2ecc836d}},	//   _våga, _nola, _xava_, ार्त,
   {{0xd0488201,0x40961ba2,0x46ea8e17,0x60d5002e}},	//   fadə, урат, еден_, _dezm,
   {{0xf1bf0333,0x291c0390,0x27e7066e,0x6d41c1ef}},	//   _irán_, žva_, ánna_, _aola,
   {{0x6d41ee1b,0x1634af92,0xdee38323,0xe9ff0129}},	//   _bola, реля, сочи, _thạc_,
   {{0xa3cb073c,0xa3b81993,0x7af60084,0x3f8f82f1}},	//   रीक_, _चढा_, lgyt, algu_,
   {{0x4ab8023c,0xab5c8029,0x69c283b2,0xfbaa8049}},	//   _अलाव, _atļa, _stoe, нтий_,
   {{0x7d1e0181,0x6d418307,0xb6a6bf21,0x33203a65}},	//   _laps, _eola, _библ, ndix_,
   {{0x6d41e737,0xdd8f881b,0x316a813a,0x26d900e5}},	//   _fola, _کول_, ешно_, vaso_,
   {{0x6d41a63d,0x7d1e000d,0x6d4e0a0f,0xdb0b823e}},	//   _gola, _naps, jkba, _ligè,
   {{0xb4c2823c,0x31370051,0x893700be,0x291c82d6}},	//   ूरी_, אריך_, אריע_, _vava_,
   {{0x3a2683d3,0x60c487d9,0x6d41ac89,0xa3b80105}},	//   _trop_, _şimd, _zola, _चढ़_,
   {{0x26d9044b,0xe29280f7,0x291cdf6b,0x246e8201}},	//   raso_, _اذا_, _tava_, _həm_,
   {{0x040e00c8,0x74ca9c7b,0x6d58ee1c,0xf65f0366}},	//   হিনী_, _स्मृ, nhva, lbæk_,
   {{0x070486ce,0x26d96e1d,0x88bb80be,0x06f68a27}},	//   रभाव_, paso_, _אזוי, ीभाव_,
   {{0x60daa8cd,0x98bc8176,0xae221370,0xe31502ee}},	//   latm, _movč_, मिशन_, јмањ,
   {{0x5a3500b3,0x23692823,0xdb0bc092,0xce68259a}},	// [7af0] шнат, riaj_, _digè, _брэд_,
   {{0x7c28ee1e,0x660d1629,0x2369009a,0xdce380c3}},	//   _ordr, _ipak, siaj_, tinč,
   {{0xa3cb09a3,0x8ccb3b04,0xd011026a,0xdb1c1c18}},	//   रीख_, _त्यो, تلا_, sprá,
   {{0x398b8aa2,0x660d0133,0xdce38be4,0x644a8035}},	//   løst_, _kpak, rinč, dyfi,
   {{0x6d41a7d3,0xa91c80e1,0x7c28ee1f,0x8ca78075}},	//   _pola, voľn, _ardr, टेनो,
   {{0x660d38fc,0xa5098c9d,0x6d4181b4,0x60da80dd}},	//   _mpak, тека_, _qola, jatm,
   {{0xeab180f7,0x8cc19391,0x60da8380,0x36d58084}},	//   يعة_, रुषो, datm, _вобр,
   {{0x0b4587b6,0x05b500d4,0x660d09a4,0x7e7b8cdb}},	//   рнин, ंदाब, _opak, _txup,
   {{0x5f448c2b,0x660d02d5,0x6d4e067f,0x63af01b4}},	//   _انقل, _npak, ykba, _micn,
   {{0x63af1601,0xe61088ca,0x291308f1,0x6d58816b}},	//   _licn, _عشق_, nexa_, chva,
   {{0x6b511918,0x660d1600,0x2d87ee20,0x200103f8}},	//   _någo, _apak, mone_, nthi_,
   {{0x63af0706,0x6e29e43a,0x3f6a13b4,0x00000000}},	//   _nicn, _kreb, тимо_, --,
   {{0x7bc56ac5,0x43848013,0x7f3a8158,0x0ab48c48}},	//   _athu, _النق, דערו, _احمد,
   {{0x2d87ee21,0x69c9affb,0xa0a5c1da,0x660d00dd}},	//   none_, mpee, _калд, _dpak,
   {{0x6f09a08f,0xdca61285,0x64a623cd,0xdfd180f7}},	//   _obec, рави, рава, _بيع_,
   {{0x6e298140,0x3a2d026c,0x2d87b5db,0x589481a8}},	//   _oreb, _šepa_, hone_, _اجهز,
   {{0xe8fa5d22,0x52aa130f,0x2d8786ee,0xc33282f6}},	// [7b00] кла_, твам_, kone_, חון_,
   {{0x2d87b2e7,0x7c2a002a,0xf1bf0129,0x38cb01f9}},	//   jone_, _áfro, _trán_, نامی_,
   {{0x2d87ee22,0x661b94c7,0x46ba0fcc,0xd10203b6}},	//   done_, _asuk, _इलाह, र्षण_,
   {{0x61ed3655,0x6e29af78,0xe5c6bc20,0x661b8748}},	//   bral, _breb, аско, _bsuk,
   {{0x2d87caa1,0x6e299193,0x63a4547c,0x0cd1801b}},	//   fone_, _creb, mmin, हरूम,
   {{0x2d87b204,0xb5fb0019,0xcbe6be11,0xb4c280c2}},	//   gone_, szág, ации, ूरे_,
   {{0x6ca38081,0xa9670249,0xad9b016a,0x60daa0db}},	//   оръж, _тира_, ntúa, vatm,
   {{0x6d5880fe,0x644aee23,0xa3cb1370,0xf1bf0f09}},	//   shva, ryfi, रीट_, _orál_,
   {{0x63a464e3,0x2d879b8f,0x644ad8f8,0x9982801b}},	//   imin, bone_, syfi, íků_,
   {{0x6602cef1,0x63a42fd7,0x67208c53,0x717481a8}},	//   mtok, hmin, _hamj, إهدا,
   {{0x6602ec09,0x60da8850,0x63a46e24,0xeb36b026}},	//   ltok, ratm, kmin, _پراخ,
   {{0x8cca81ab,0xdce38029,0x6722ee25,0x61ed6e26}},	//   _स्तो, minā, ndoj, yral,
   {{0x60dad3fb,0x6602ee27,0xdce380eb,0x661b80b9}},	//   patm, ntok, linā, _xsuk,
   {{0x6b5810ab,0x61ed0965,0x672080c3,0x61e2913b}},	//   _nígb, vral, _lamj, _ivol,
   {{0x06d780ab,0x6b55bb7a,0x6b510106,0x394301f4}},	//   _হাসি, _hága, _fågl, _rojs_,
   {{0x672082ce,0x63a43b1d,0x2d87ee28,0x63b7016d}},	//   _namj, gmin, zone_, _vuxn,
   {{0xa3cb00d4,0x660d1eb3,0x2d87b624,0x2913002a}},	// [7b10] रीज_, _upak, yone_, texa_,
   {{0x61ed0dde,0x63a4402d,0x98c7361c,0x60d8826c}},	//   rral, amin, рсал, _jevm,
   {{0x2913062f,0x61ed1325,0x63a4094d,0x7bc5314f}},	//   rexa_, sral, bmin, _uthu,
   {{0x6e29a39f,0x61e2807d,0xdce38029,0x2d87bbd3}},	//   _preb, _ovol, dinā, wone_,
   {{0x6d450006,0x539a010f,0xfe709a37,0x1af580ab}},	//   _koha, _תירו, وده_, _আসলে_,
   {{0x6d455a91,0x6e299487,0xb4c1c19f,0x2abd026b}},	//   _joha, _vreb, ंडे_, _fábó_,
   {{0x6d453b6a,0xb5fb0118,0x0445ee29,0x2d87a91e}},	//   _moha, nzáb, сейн, rone_,
   {{0x6e29ee2a,0xe299ab3f,0x661bee2b,0x2d879fcb}},	//   _treb, лай_, _tsuk, sone_,
   {{0x2d87ee2c,0x316c8859,0x26ddee2d,0x661b8234}},	//   pone_, fidz_, mawo_, _usuk,
   {{0x672082fd,0x6d4503f2,0x69c98009,0xdce380eb}},	//   _zamj, _noha, rpee, binā,
   {{0x1b1f80c8,0x04958013,0x69c9837a,0xdce38029}},	//   ভাবে_, _الاح, spee, cinā,
   {{0x2f566983,0x8c490085,0x09cd00ab,0x63a4011c}},	//   стос, _maşı, _লিনা, xmin,
   {{0x6d452158,0xa3b0800f,0x7521ee2e,0x877a80be}},	//   _boha, _टूट_, _kalz, רארי,
   {{0x04461a19,0xada62597,0x6d456e2f,0x6b898299}},	//   бегн, сагл, _coha, loeg,
   {{0x61e2803e,0x63a40074,0x224d8019,0x75218214}},	//   _zvol, tmin, lyek_, _malz,
   {{0x67560077,0x236d809a,0xaca38133,0x6b899384}},	//   _دختر, niej_, _adịl, noeg,
   {{0xeb970ca4,0xdce38029,0x224d8019,0x26dd8234}},	// [7b20] сит_, zinā, nyek_, dawo_,
   {{0xa3e8864a,0x8c49017b,0xb4e68697,0xad9b0118}},	//   _बिल_, _başı, _भये_, ptúa,
   {{0x236d8063,0x6d5c0ad0,0x672080f1,0xd8da80be}},	//   kiej_, mhra, _pamj, רקער,
   {{0x8c490201,0x656e3496,0x6602b4e1,0x6d4500e1}},	//   _daşı, libh, ttok, _zoha,
   {{0x6d4508b1,0xa3d403eb,0xca750071,0x644e423d}},	//   _yoha, सीर_, _дуры, lybi,
   {{0x7521a784,0xdb1c01ec,0x7a0a00eb,0x6602ee30}},	//   _calz, sprä, rētā, rtok,
   {{0xf86316d4,0xf36695b5,0x61e2ee31,0x06d780ab}},	//   _евро, йтин, _svol, _হারি,
   {{0xf0633bea,0x2b400754,0x60d8880a,0xdce380eb}},	//   _эксп, njic_, _sevm, rinā,
   {{0xdce38029,0x75218197,0x224d8019,0x2d8a3ebe}},	//   sinā, _falz, gyek_, kobe_,
   {{0x8c4902bb,0x26c2009a,0x644e0084,0x290a80e1}},	//   _yaşı, ecko_, kybi, ýba_,
   {{0xaab8058c,0x61f601e0,0x23810110,0x2d8a6e32}},	//   _अलंक, huyl, lėje_, dobe_,
   {{0x224d861b,0x442cee33,0x2fc7808e,0x290281d0}},	//   byek_, _ird_, _dtng_, řka_,
   {{0x238101e2,0x442c82f7,0x6e2200eb,0x8af00085}},	//   nėje_, _hrd_, _šobr, rhəl,
   {{0x67d4845d,0x6d5c02cd,0xb4e6800d,0x26dd83f7}},	//   _доку, ghra, _भयो_, zawo_,
   {{0x60de00dd,0x64b906a7,0x93bc8162,0x4fc69246}},	//   dapm, _आलीश, _brăi, _усла,
   {{0x443f003a,0xa91c81ac,0x63ba811f,0x442c91e6}},	//   ću_, koľk, _mutn, _mrd_,
   {{0x6d5c0ad0,0xe820923a,0x3f8b00d2,0xdb0881ac}},	// [7b30] bhra, यिका_, mocu_, _budú,
   {{0x6d5c06f6,0x236d8063,0x442c93c2,0x6e2d1171}},	//   chra, ziej_, _ord_, _irab,
   {{0x44275ccf,0x63ba83fb,0x6e2d10e8,0x6e220118}},	//   _én_, _nutn, _hrab, _áobr,
   {{0xdddb8a56,0x75218799,0x2a60022c,0x3cfe8037}},	//   _využ, _salz, bzib_, _actv_,
   {{0x442c9bfb,0x6b8982d8,0xf1272325,0x63ba826c}},	//   _ard_, voeg, _льво, _autn,
   {{0x67d54571,0x8c490214,0x442cee34,0x63ba8bb1}},	//   _могу, _taşı, _brd_, _butn,
   {{0x58d40256,0x6b583b7a,0xdb1c1235,0x3f8b0b80}},	//   _хост, _híga, språ, kocu_,
   {{0x225f811e,0x6d5c016b,0xc1788084,0x6d8d81df}},	//   tzuk_, zhra, enė_, túas,
   {{0x24898063,0x656e029b,0x3dc9022c,0xa3e586a7}},	//   łam_, yibh, _ntaw_, _भटक_,
   {{0x6f0d3051,0x6009968a,0x764f009a,0xb4b80327}},	//   _abac, аном_, dycy, _छले_,
   {{0x236d809a,0x442cc456,0x3dc9008e,0x6e2d4a2b}},	//   piej_, _grd_, _ataw_, _arab,
   {{0x6e2d3516,0x5ea800ab,0x16aa0ae7,0x9eaa2482}},	//   _brab, _ক্ষে, ивни_, ивна_,
   {{0x6d5c11cd,0x200a8214,0x656e0197,0x25b28214}},	//   thra, çbir_, tibh, _ünlü_,
   {{0x6e2d6e35,0x644e0d42,0x2fc7808e,0x6f0d59a5}},	//   _drab, tybi, _ttng_, _ebac,
   {{0x6e2d00ad,0xa34a0081,0x656e2305,0xd3ba0048}},	//   _erab, азва_, ribh, ругі_,
   {{0x7afbee36,0x42ca0254,0x6b55a363,0xe81e8105}},	//   ngut, рган_, _mágo, _बनता_,
   {{0xb1460a95,0xe0da0b01,0xc8788085,0x39460084}},	// [7b40] онал, ива_, mağa_, онаг,
   {{0x409611cf,0xaca3819d,0x6724004f,0x6f0d0b80}},	//   орет, _adọl, _haij, _zbac,
   {{0x93bc8087,0xb17b0106,0x3cfe8144,0x443c8118}},	//   _trăi, _tvån, _rctv_, xxv_,
   {{0x3cfe89e1,0x25b7003d,0x11d6102a,0x23810084}},	//   _sctv_, _دهید_, _мігр, tėje_,
   {{0x672400eb,0x442c88ae,0xe53481e2,0x63ba8699}},	//   _maij, _srd_, зель, _sutn,
   {{0x442cee37,0x61e4080a,0x6b5583a8,0x6b966e38}},	//   _prd_, msil, _bágo, llyg,
   {{0x6b5c80e7,0x200581a1,0x39940198,0x23810084}},	//   _lége, jtli_, jäsi_, sėje_,
   {{0x8cca8ebf,0x61e46e39,0x672418b2,0x7afbd25e}},	//   _स्रो, osil, _naij, ggut,
   {{0x3947a0c6,0x60dc2ada,0x645801b9,0x61e43f3c}},	//   _bons_, _kerm, _żvil, nsil,
   {{0x60dc0886,0x3a370039,0x6b558118,0x442cee3a}},	//   _jerm, קרים_, _fágo, _trd_,
   {{0x6d5a8009,0x61e41bef,0x3947cf42,0x5f950087}},	//   _ilta, hsil, _dons_, зинт,
   {{0xd6db0fbb,0x6e2d061b,0x672401c0,0x61e46e3b}},	//   што_, _prab, _caij, ksil,
   {{0x6d48ee3c,0x3947809f,0xdb060009,0x67240267}},	//   _koda, _fons_, _mikä, _daij,
   {{0x60dc6e3d,0x6ad3000f,0xc5f382f6,0xd5b801e2}},	//   _nerm, तर्र, ודש_, ўся_,
   {{0x63a2aeea,0x29c08028,0x5c046e3e,0x6b966e3f}},	//   _khon, _hòa_, мята, flyg,
   {{0x6f0d0025,0xa3dc853f,0x7ae0ee40,0x53341c79}},	//   _ubac, तीय_, namt, мест,
   {{0x60dc2b15,0x776d07f4,0x63a29e66,0x61e40c27}},	// [7b50] _berm, _imax, _mhon, gsil,
   {{0x6d48ee41,0x60dc010b,0x7ae098b3,0x8cca84c5}},	//   _noda, _cerm, hamt, _स्लो,
   {{0x60dc1277,0x3f159d3d,0x63a28114,0xdce700eb}},	//   _derm, здес, _ohon, cijā,
   {{0x441a0051,0xdcf8800d,0x4421020f,0x6b5c8b4c}},	//   _פורס, pově, _ish_, _légb,
   {{0x60dc6e42,0x6d48da4a,0xbc68003d,0x5f0000d4}},	//   _ferm, _boda, _همین_, ष्ट्_,
   {{0x6d48ee43,0x8d659317,0x60dc079a,0xdb0bce2a}},	//   _coda, явле, _germ, _vigí,
   {{0x6d48885d,0x63a28090,0x7aef8118,0x00000000}},	//   _doda, _bhon, ócto, --,
   {{0x63a2ee44,0x44216e45,0xe9d99bc1,0xc245b3d9}},	//   _chon, _msh_, бки_, зник,
   {{0x63a291e7,0xe1f180f7,0xddc6009a,0x95c88b26}},	//   _dhon, رسة_, zykł, _духа_,
   {{0x395e8051,0x60dc01df,0x7afb833e,0xc69280be}},	//   ghts_, _xerm, sgut, _טאן_,
   {{0x63a281a8,0x7d7a80be,0xad9b023e,0x67242168}},	//   _fhon, _פרעג, rtúl, _paij,
   {{0x7c2a07a3,0x6d488a0f,0xed598a20,0x6b8d008e}},	//   _áfri, _zoda, _duže_, joag,
   {{0xc60980ab,0x2005801b,0x539a81c6,0x899f026b}},	//   লিকা_, stli_, _פינו, _díẹ̀,
   {{0x69d98372,0x395eee46,0x6b5c8019,0x63a2ee47}},	//   _iwwe, chts_, _vége, _zhon,
   {{0x68e1ed67,0x913a8039,0x63a98084,0x7e628037}},	//   mald, _לעסק, omen, zzop,
   {{0x68e1b665,0xbb430dc7,0x63a9a574,0x3f788088}},	//   lald, неск, nmen, rčuk_,
   {{0x63a9ee48,0x80de80ab,0xb18381d0,0xdfa512c5}},	// [7b60] imen, _মাত্, šťuj, _تحوي,
   {{0xdca617f9,0x68e1ee49,0x64a612a0,0x63a9d95b}},	//   _напи, nald, _напа, hmen,
   {{0x63a9ee4a,0x60dc1d56,0xf99f0032,0x249f0326}},	//   kmen, _verm, _apès_, ƙuma_,
   {{0x6d48e911,0x63a992d3,0x2d981836,0x61e46e4b}},	//   _soda, jmen, llre_, psil,
   {{0xa3b5000f,0x68e1a22f,0x63a2ee4c,0x63a981b5}},	//   _छूट_, kald, _rhon, dmen,
   {{0x63be231b,0x63a9a5d2,0x63a294f2,0xd5b9821e}},	//   _kupn, emen, _shon, ісі_,
   {{0x63a29fb8,0x7d18ee4d,0x7ae0b5fc,0x6d5a81d0}},	//   _phon, revs, tamt, _vlta,
   {{0x80de80c8,0x987b00be,0x5a3480b3,0x291a06c2}},	//   _মাধ্, _האלט, днит, lepa_,
   {{0xa3dc823c,0x6d48ac04,0x7ae084b9,0x68e18a64}},	//   _तौर_, _toda, ramt, fald,
   {{0x63a9c58e,0x7ae090f6,0x6d5acf3f,0x68e18dde}},	//   amen, samt, _ulta, gald,
   {{0x7ae08a20,0x69d981cd,0xa91c81ac,0x80de80ab}},	//   pamt, _ewwe, koľv, _মাদ্,
   {{0x389b00be,0x29c0801c,0x628281c5,0x63a9ee4e}},	//   מיינ, _tòa_, _txoo, cmen,
   {{0x7d0300f2,0x68e1811e,0xa3c2809a,0xf1bf0028}},	//   _önsk, bald, _एंड_, _trái_,
   {{0x61438a94,0x68e185dc,0x5e578158,0x291a120e}},	//   _печа, cald, ליכע_, jepa_,
   {{0xdb1a85e4,0x6d5500f3,0x439500e8,0xab95004a}},	//   _auté, rkza, давс, диві,
   {{0x6b58002a,0xa87b84de,0x69be02f1,0x88bc81d0}},	//   _dígo, _לאור, _वंशी, zděl,
   {{0x248d0063,0xa3dc816f,0x752500b9,0x6b8d011b}},	// [7b70] łem_, तीत_, _tahz, roag,
   {{0x92cd00ab,0xa8a700ae,0xaca3019d,0x30a717d6}},	//   রণে_, прек, _akụd, прев,
   {{0xb4d9085d,0xf990019f,0xaf2000ab,0xa3e89370}},	//   ारी_, ابق_, ধারণ_, _बिग_,
   {{0x60c502af,0x99800699,0x68e1811b,0xe7fe0327}},	//   schm, rviš_, zald, _उमरा_,
   {{0xe2ab003d,0x7bda81b9,0x63be050b,0x6b84811f}},	//   _دادن_, _awtu, _zupn, čigl,
   {{0x628001e2,0xdb1704c3,0x213836f8,0x518720bf}},	//   _žmog, _muxí, _gnrh_, _хума,
   {{0xea008104,0x63a9d020,0x68e1be80,0xa3d78074}},	//   _đại_, tmen, vald, ़ीं_,
   {{0xb4d91008,0x63a9837f,0x5f948162,0x7f5b913b}},	//   ारु_, umen, _зист, _uluq,
   {{0x32091f14,0x68e1811e,0x3f8f811f,0x4ea784bd}},	//   ntay_, tald, mogu_, _хрва,
   {{0x57e99594,0xdb0b816a,0xd5b187c3,0xdb1c1277}},	//   одом_, _digá, _شفا_, sprø,
   {{0x68e1ee4f,0x63a9ee50,0xdb170187,0x2455806b}},	//   rald, pmen, _auxí, _تناس,
   {{0x68e18dde,0x8367819f,0xdb170118,0xe73a22ea}},	//   sald, _عدال, _buxí, цем_,
   {{0x68e1ee51,0xb4d90074,0xb606811f,0x25bf99cf}},	//   pald, ारू_, _gušć, _juul_,
   {{0xdb0f01df,0x64a601e2,0x61fbee52,0x63be6e53}},	//   _dicí, дага, muul, _pupn,
   {{0x3f8f8006,0xdbf2128a,0xaad1885d,0x9c7c8af8}},	//   kogu_, přít, _सभाक, _večg,
   {{0xf0928051,0xe9da11b1,0xf77209a7,0xdb170118}},	//   _שנה_, жка_, _جات_, _fuxí,
   {{0x2fcd003a,0xe2970381,0xb5fb02ba,0x32090079}},	// [7b80] _čega_, дат_, nzál, gtay_,
   {{0x6e244bf2,0x6b5cee54,0x23810084,0x6606a551}},	//   _isib, _méga, rėja_, _äkki,
   {{0x7d1c4cca,0x6b5c82be,0x9c7c8267,0xb8f60006}},	//   mers, _léga, _keče, _सभ_,
   {{0x320902a3,0x61fb9e89,0x2bc48105,0x3d008beb}},	//   btay_, kuul, _लंबा, _राहे_,
   {{0x291a019d,0x9c7c8e63,0x7ae46e55,0x6b5c83e6}},	//   pepa_, _meče, mait, _néga,
   {{0xe81e8e18,0x7ae464e3,0x9c7c82ee,0xdfd200f7}},	//   _बनला_, lait, _leče, _ليس_,
   {{0xab94835f,0x3f8f80fe,0xc10e80ff,0x139495a6}},	//   никі, bogu_, _bỗng_, никю,
   {{0x7ae45f53,0x18a34bfc,0x9c7c883d,0xb6068115}},	//   nait, _расм, _neče, _pušć,
   {{0x8bb380f7,0x25bf81b4,0x2127a2e4,0x6e2457c7}},	//   خصوص, _guul_, _banh_, _nsib,
   {{0x7ae4335f,0x2127801c,0x224b816d,0x6b5c8036}},	//   hait, _canh_, äcka_, _déga,
   {{0x7ae46e56,0x21278028,0xb2268125,0x9cd78039}},	//   kait, _danh_, fræð, _חובה_,
   {{0x7528acf7,0x2ee0026c,0x32094000,0xf1bf1c18}},	//   _hadz, _ceif_, ytay_, _krát_,
   {{0x7ae46e57,0x99669f72,0x7d1c6e58,0x09c88264}},	//   dait, _откл, fers, _শিকা,
   {{0xb4d93ed8,0x88bc801b,0xdce380c3,0x6d58888b}},	//   ारे_, zděj, rinć, nkva,
   {{0x7ae451a1,0x6e246e59,0x63a6026c,0xa3d902f1}},	//   fait, _esib, _bhkn, ठीं_,
   {{0xf1c300d4,0x799a8114,0x64430722,0x7ae4134c}},	//   _वंदन, lltw, _ànim, gait,
   {{0xf1bf0028,0x06ad00ab,0x753abcf9,0x9f46016b}},	// [7b90] _quá_, _ক্রি, _ontz, nulý_,
   {{0x752886e4,0x51f807ac,0x6f1d12a7,0x320902a3}},	//   _nadz, ьную_, lesc, rtay_,
   {{0x6ec3023c,0x9cd60039,0x32090079,0x7ae46e5a}},	//   रखपु, _אותה_, stay_, bait,
   {{0x6f1d6e5b,0x7c250efd,0x0fd5009a,0x753a811e}},	//   nesc, _ishr, डीगढ, _antz,
   {{0x8f9c0039,0x63ad1063,0x23810110,0xc10e827d}},	//   קידי, mman, lėjo_, _rỗng_,
   {{0x11da0051,0x64a5a7af,0xdca5a482,0x237f005c}},	//   _מחשב, нала, нали, čuju_,
   {{0x68e52b1b,0xaf078098,0x6837819d,0x21278129}},	//   mahd, _очак, _ọda, _ranh_,
   {{0x63ad4154,0x753a8b90,0x61fb8eea,0xed5980d2}},	//   nman, _entz, tuul, _duža_,
   {{0x2d910e4d,0x63ad0dba,0x8ccab4c7,0x75288748}},	//   koze_, iman, _स्को, _fadz,
   {{0xb5fb03b0,0x29010461,0xb4d96e5c,0x9c7cd6a6}},	//   rzál, ngha_, ारो_, _seče,
   {{0x61fb8e05,0x63ad6e5d,0x06ad00c8,0x6f1d0144}},	//   suul, kman, _ক্লি, fesc,
   {{0x6d890038,0x6f1d0e83,0x6729c7d0,0x238101e2}},	//   hľad, gesc, _jaej, dėjo_,
   {{0x80de80c8,0x7ae40a7f,0x7d1c340e,0x3f9e0029}},	//   _মার্, vait, ters, ētu_,
   {{0x61e9ee5e,0x6b9bc9d8,0x7bc1cc37,0x7ae46e5f}},	//   msel, llug, _kulu, wait,
   {{0x7ae464e3,0x61e9929d,0x7bc1859e,0xe946803d}},	//   tait, lsel, _julu, _سروی,
   {{0x7bc1ee60,0x63ad05b0,0x28d200d4,0xdc0380e1}},	//   _mulu, gman, दुनि, jčít,
   {{0x61e988e9,0x7ae46e61,0x7bc18886,0xf2d2812a}},	// [7ba0] nsel, rait, _lulu, טען_,
   {{0x7ae46e62,0x63ad6865,0x7bc18009,0x61e9aadb}},	//   sait, aman, _oulu, isel,
   {{0xdfcf0dd0,0x5ed180c8,0x7bc1ee63,0x7528ee64}},	//   ميل_, _হয়ে, _nulu, _radz,
   {{0xeaa78307,0xaa460ca0,0x61e9d49f,0x7528b3f6}},	//   _مع_, _земл, ksel, _sadz,
   {{0xee3a81e5,0x4425ee65,0x61e9aa52,0x75288ec3}},	//   янд_, _asl_, jsel, _padz,
   {{0x7bc1ee66,0x61e981eb,0x6b8282d6,0xb60602d4}},	//   _bulu, dsel, _sjog, mešč,
   {{0xa0a3284f,0x7bc18079,0x6b9bd1aa,0x6d58ed67}},	//   _бард, _culu, flug, rkva,
   {{0xa3e211be,0x7bc1c818,0x67c8800d,0x6d58ee67}},	//   नीय_, _dulu, _něja, skva,
   {{0x36679634,0x61e9929d,0x6f1d5862,0xd13080f7}},	//   _зато_, gsel, vesc, لمة_,
   {{0x63ad6e68,0x65a001ec,0x7bc1838a,0x04188264}},	//   zman, wöhn, _fulu, থিবী_,
   {{0x741384c1,0x63ad6e69,0xa3dc8816,0x61e9ee6a}},	//   _مولا, yman, तीश_, asel,
   {{0xb5fb0019,0xb4d9016f,0x6f02ee6b,0x63630074}},	//   szám, ार्_, ngoc, _kõne,
   {{0x28d183b7,0x6f1d0328,0xf710001c,0x2d91136f}},	//   _द्वि, resc, _tầng_, toze_,
   {{0xb5240b71,0x6b5104b8,0x6f1d002e,0x201807de}},	//   льск, _någr, sesc, _opri_,
   {{0x63ad07e2,0x6f1d180b,0x394e8106,0x7f9896dc}},	//   tman, pesc, _iofs_, líqu,
   {{0x6b55de81,0x23810110,0xdb17002a,0x409b81c6}},	//   _pági, rėjo_, _buxá, _מבוס,
   {{0x2d9106c0,0x2018047f,0x60db00ce,0xb5fb0061}},	// [7bb0] poze_, _apri_, _đumb, zzáj,
   {{0xfbd00065,0x9998002e,0xbebb0123,0x00000000}},	//   شتہ_, екут_, geëe, --,
   {{0x63ad6e6c,0x2d540074,0x6b5c8036,0x9f460144}},	//   pman, _päev_, _négo, culó_,
   {{0x291e8135,0x7ff41a00,0x572780f7,0x61e9af06}},	//   heta_, اسلا, عراق, ysel,
   {{0x291e96d8,0x7bc1afbb,0x5e5880e8,0xdb1a82df}},	//   keta_, _sulu, ниця_, _cutí,
   {{0x4a5a004c,0x291e9351,0x2b490024,0x672980b9}},	//   _חדשו, jeta_, ljac_, _waej,
   {{0xa3dc853e,0xdb1e00e7,0xf1bf66df,0x9c7c826c}},	//   तील_, _supé, _trás_, _rečc,
   {{0x61e98100,0x2b490052,0x7f988333,0x7ae28362}},	//   tsel, njac_, fíqu, _ceot,
   {{0xdcbb8364,0x291eee6d,0xdb0600f1,0x6b9bee6e}},	//   _еще_, feta_, _shkë, rlug,
   {{0x7bc1ee6f,0xdb1a841c,0x04678087,0x69c2a7d1}},	//   _tulu, _cutâ, _птем, _duoe,
   {{0x6b9bee70,0x8cca8305,0xf772006b,0x44258087}},	//   plug, _स्टो, لاح_, _usl_,
   {{0x61e994c7,0x78ba0177,0x2ac78032,0x69c00037}},	//   psel, _útve, _díbó_, _èmeg,
   {{0x291eaa09,0xc7b280be,0xd7f88087,0xdb1c01ec}},	//   beta_, יבט_, ară_, rprü,
   {{0x5e568158,0x291e9520,0xb6060353,0xdb1c01ec}},	//   דישע_, ceta_, vešč, sprü,
   {{0xf990990c,0xeb9a3650,0x69cb1fd6,0x9c7c8bcf}},	//   _ابن_, див_, ígen, _keča,
   {{0x68e3e9ab,0x332dbe9d,0x7ae2802a,0x9c7c81f4}},	//   _hend, ndex_, _xeot, _ječa,
   {{0x68e3b804,0xeb970dc8,0x98bc81d0,0x6b51183d}},	// [7bc0] _kend, тит_, _nově_, _pågr,
   {{0x20561d91,0x3d1101fe,0x68e3af39,0xa3c1a1e3}},	//   ктер, द्दे_, _jend, ंदा_,
   {{0xd12f187e,0xdb1a8118,0x38608326,0xe9df026b}},	//   تمل_, _sutí, _ƙiri_, _ewú_,
   {{0x291ebc95,0xed5988ae,0x9c7c826f,0x20070722}},	//   zeta_, _bužo_, _neča, ània_,
   {{0x291e8ce9,0x33200722,0x332d8079,0x660f8106}},	//   yeta_, meix_, ddex_, _äckl,
   {{0x68e3ed21,0xcbcd80ab,0x7ae28074,0x3320023e}},	//   _nend, _রয়েছ, _seot, leix_,
   {{0x291e803b,0x8af0011c,0x1fb681e5,0xd7068c9b}},	//   veta_, hkəm, _асар, _изви,
   {{0x040d8028,0x291e882e,0x3320009f,0x68e3ee71}},	//   _hướn, weta_, neix_, _aend,
   {{0x291e82a5,0x9c7c8eef,0x1d268fe7,0xa3e2064a}},	//   teta_, _deča, _имам, नीत_,
   {{0x68e3b55e,0xd5ae8117,0x29079b11,0xd7f8802e}},	//   _cend, _بہت_, _ccna_, tră_,
   {{0x68e38b6e,0x39570051,0x9f5f0009,0x93469229}},	//   _dend, דשים_, yttä_, _инже,
   {{0x68e38cfa,0x320d81b4,0x28a73262,0xa5f9062c}},	//   _eend, btey_, केटि, нему_,
   {{0x64588110,0x3320009f,0x3a2680b9,0xf1bf026b}},	//   lyvi, deix_, _usop_, _asán_,
   {{0x68e38430,0xd12f80f7,0xa2d5578b,0x6fcabbf1}},	//   _gend, _ومن_, युन्, _संपू,
   {{0x68e882a3,0x0713abef,0x30a38081,0xc04f80e8}},	//   madd, ण्डव_, _кръв, _ті_,
   {{0x3320009f,0x68e8ee72,0x68e3ee73,0x490e8cf0}},	//   geix_, ladd, _zend, त्रो_,
   {{0x6b5c82be,0x68e3b106,0x6e364c68,0x4423022c}},	// [7bd0] _régl, _yend, _gryb, swj_,
   {{0x6d5c148c,0x68e891c9,0x7bc10061,0x645894ef}},	//   ckra, nadd, ílus, kyvi,
   {{0x2d830024,0x1aef00ab,0xc7f50eef,0xe8d781c6}},	//   mnje_, ঙ্গে_, узећ, דובר_,
   {{0x290746e9,0xfaff0168,0xf40880ab,0x68e8ee74}},	//   żna_, _emër_, লবার_, hadd,
   {{0xd246987e,0xb90900c8,0x61ff0201,0x68e8ee75}},	//   _ان_, _যা_, quql, kadd,
   {{0x7bc500f6,0xac0992b2,0x672d0009,0x6b580531}},	//   _kuhu, енка_, _laaj, _rígi,
   {{0xeb998b9c,0x68e3a7eb,0x4c158013,0x7bc53e18}},	//   ник_, _rend, ابتس, _juhu,
   {{0xbebb020f,0x320d8358,0x7bc51e8f,0x15f592c7}},	//   ndës, ttey_, _muhu, ुंदर_,
   {{0x68e3810b,0x63bd5324,0x61ed6e76,0x7bc501da}},	//   _pend, _misn, nsal, _luhu,
   {{0x68e3820f,0x2d830052,0x63bd192c,0x68e88365}},	//   _qend, jnje_, _lisn, gadd,
   {{0x68e38e79,0x20010867,0xdee60aac,0x9c7c8132}},	//   _vend, nuhi_, лони, _teča,
   {{0x68e3ce69,0x2121358e,0xfc46928a,0x3ce586b1}},	//   _wend, hehh_, žích_, _helv_,
   {{0x68e88e05,0xfa3482e3,0x7ae98f3e,0x9f60008b}},	//   badd, _پرند, maet, _þrír_,
   {{0x7ae9831d,0x68e88079,0x68e3ee77,0x7bc56e78}},	//   laet, cadd, _uend, _buhu,
   {{0x6d5c6e79,0x63bd1ad4,0x332007e2,0x49b8880b}},	//   rkra, _bisn, teix_, _شاهد_,
   {{0x6e29a52d,0x7ae98355,0x629d0101,0x7bc56e7a}},	//   _oseb, naet, _byso, _duhu,
   {{0x61ed043b,0x3320009f,0xa3ab8bb8,0xd38702c7}},	// [7be0] gsal, reix_, _गठन_, уйте_,
   {{0x6f099cb1,0x61fb80ee,0x29c980ff,0xdb1988f9}},	//   _acec, irul, _múa_, _diwé,
   {{0x5ecd80ab,0x61ed6e7b,0x7bc502a0,0x2d9a0870}},	//   ারনে, asal, _guhu, _ikpe_,
   {{0x61fb80ee,0x672d0079,0x6db980e1,0x238580eb}},	//   krul, _xaaj, _dňam, dējo_,
   {{0xe505823c,0x7ae98355,0x80e300c8,0x68e88ef2}},	//   _राशि_, daet, _পার্, yadd,
   {{0x2001339d,0xad9b6e7c,0x16c10996,0x3a3ac1f4}},	//   buhi_, ltúr, _एल्ब, _čpp_,
   {{0xbebb020f,0x50b511d2,0x98a300eb,0xa92801a9}},	//   ndër, _всту, _tajā_, režģ,
   {{0x29c9ee7d,0x69c60b3f,0xf3638110,0x2d83007d}},	//   _búa_, _kuke, йтын, znje_,
   {{0xee3aee3e,0xa686891c,0x68e8ee7e,0x7f75813a}},	//   _яна_, _слад, tadd, _турц,
   {{0xd13080d5,0xb426826a,0x7764002a,0x301482fb}},	//   آمد_, _معصو, _alix, адор,
   {{0x68e8d462,0x69c60bc6,0xad9b0e14,0xddd0192c}},	//   radd, _luke, ktúr, _češl,
   {{0xa3c1ae06,0x70e101ce,0x68e89a25,0x7bc56e7f}},	//   ंदर_, _फ़्ल, sadd, _ruhu,
   {{0x62800a8e,0x9f5f026f,0x69c66e80,0x9b9380f7}},	//   _žmon, nuté_, _nuke, _النت,
   {{0x7bc5043d,0x776404c3,0xa903009a,0x672d60c5}},	//   _puhu, _elix, _लाइफ_, _waaj,
   {{0x69c6011e,0x2d832944,0x7ae63df9,0x77644fe2}},	//   _auke, rnje_, _bekt, _flix,
   {{0x61ed65d6,0x2d8300d2,0x69c61f34,0x256600e7}},	//   tsal, snje_, _buke, _rôle_,
   {{0x49750e02,0x6722aeaa,0x63bd2280,0x2d83115c}},	// [7bf0] алас, deoj, _visn, pnje_,
   {{0x629d0a56,0x61ed1600,0x69c657ba,0xeb21d330}},	//   _vyso, rsal, _duke, _मस्त_,
   {{0x629d0063,0x63bd5fac,0xa0a701cf,0x30a735aa}},	//   _wyso, _tisn, ушал, урав,
   {{0x3ce58a38,0x61ed58e5,0x9c7c99b7,0x6b55c28b}},	//   _selv_, psal, _pečn, _lágr,
   {{0x3d00b2dd,0x1d098b9c,0x2001059e,0x2d768035}},	//   _राखे_, вели_, suhi_, ałem_,
   {{0x6e298db7,0x29c9862f,0xf1a90592,0x9c7cd327}},	//   _vseb, _rúa_, _कठिन, _večn,
   {{0x29c9c92f,0x67d40009,0xfd6201bc,0xe05700d5}},	//   _súa_, _госу, _agwọ, _حیات_,
   {{0x9c7c876c,0xe2998a8e,0x23693091,0x78ba49b3}},	//   _tečn, кай_, nhaj_, _útva,
   {{0xe6678ef5,0x7ae98114,0xa3e58054,0x6e298234}},	//   _ство, raet, _बौर_, _useb,
   {{0x7ae980c6,0xdb0a00e1,0x29058b80,0x50b5869b}},	//   saet, ľnéh, ugla_, исну,
   {{0xa0a5a659,0x68e71abf,0x29058b80,0x670a05fc}},	//   ранд, _mejd, rgla_, _वादक_,
   {{0x29c987f4,0x7523c952,0x68e74c70,0xe8168074}},	//   _túa_, lenz, _lejd, _तहरा_,
   {{0xd945b4d6,0xfd4e846d,0x61e2bf2d,0x91e5951b}},	//   _вели, _afiṣ, _gwol, _толе,
   {{0x68e703fb,0x75239d20,0x3ea90886,0x69c60a03}},	//   _nejd, nenz, _dzat_, _ruke,
   {{0xad9b007b,0x69c60662,0x63630074,0x3ea901a1}},	//   ttúr, _suke, _sõna, _ezat_,
   {{0x7523979f,0xdb02801c,0xe363046e,0x38ac10ab}},	//   henz, _khoá, окси, _lórí_,

   {{0x6d418850,0x6b843cc0,0xdb1d01b3,0x7ae66e81}},	// [7c00] _onla, rnig, _misè, _vekt,
   {{0x2fc79635,0xb17b04b8,0x7ae603f8,0x69c601f4}},	//   _kung_, _svår, _wekt, _vuke,
   {{0x2d9843f7,0x752381dc,0x03a62659,0xb4fb0051}},	//   more_, denz, _вино, _בפיי,
   {{0x6d41a993,0x2fc78077,0x69c60009,0x66028110}},	//   _anla, _mung_, _tuke, tuok,
   {{0x645c423d,0x443a10dc,0xdce182d0,0x38ac0032}},	//   lyri, _hrp_, _aklı, _bórí_,
   {{0x7523b00f,0x660287ac,0x443a602b,0x291802c4}},	//   genz, ruok, _krp_, _ubra_,
   {{0x2fc7809c,0xf8aa00dc,0xa6ca8568,0x7b668113}},	//   _nung_, _करिय, _алба_, итие,
   {{0xe3af85ff,0x9f5f0036,0xaac60035,0x6d41b474}},	//   وري_, puté_, वशिक, _enla,
   {{0x752391e8,0x2d986e82,0x25be8699,0x3f86816b}},	//   benz, kore_, _titl_, mnou_,
   {{0xf8aa2e06,0x2fc78681,0x6b5c8019,0x3f8685b9}},	//   _कराय, _bung_, _mégi, lnou_,
   {{0x2fc78028,0x2d982887,0x6b5ca82c,0x01370039}},	//   _cung_, dore_, _légi, ברית_,
   {{0x2fc78028,0x3f868eb2,0x236903ed,0xdcf88196}},	//   _dung_, nnou_, xhaj_, tovė,
   {{0x7bc8c9f6,0x2d980051,0x2fc7808e,0x7c2200d2}},	//   _hudu, fore_, _eung_, _ćora,
   {{0x2d980578,0x443a6e83,0x236681c0,0x645c3b8d}},	//   gore_, _brp_, _hloj_, fyri,
   {{0x7bc889e1,0xdcfa80eb,0xe516123a,0x2fc789c4}},	//   _judu, _aktī, द्धि_, _gung_,
   {{0x7523e3d1,0x443a0748,0x7bc88b8f,0x88bb81c6}},	//   zenz, _drp_, _mudu, _במוז,
   {{0x3f868400,0x98a3009a,0x78eb0790,0x75239b8f}},	// [7c10] dnou_, _mają_, вьев_, yenz,
   {{0xb4e58076,0x2d986e84,0x6e2d2bd7,0x2fc782b8}},	//   _भजे_, core_, _isab, _yung_,
   {{0x752392bb,0xd87907bd,0x2fc70028,0x442716ce}},	//   venz, دمات_, êng_, _èn_,
   {{0xf7708872,0x3f990025,0x7523ee85,0x7bd7011b}},	//   وان_, nosu_, wenz, _itxu,
   {{0x7523a3b9,0x7aed3252,0x442cd819,0xd33603c8}},	//   tenz, maat, _asd_, _פרשה_,
   {{0x7bc8812b,0x7aed6e86,0x200e0722,0x645a01ec}},	//   _budu, laat, àfic_, ätig,
   {{0x7523ad08,0x7bc88079,0xf1b20039,0x3f86816b}},	//   renz, _cudu, _מסך_, bnou_,
   {{0x7aed530e,0x5f949d8f,0x7bc895bd,0x7523e9ae}},	//   naat, _дист, _dudu, senz,
   {{0x7523ee87,0x6e2d0555,0x7c3aee88,0x5ecd8264}},	//   penz, _nsab, _ertr, ারদে,
   {{0x6d418461,0x0fd9a1f6,0x2fc79a76,0x6e3bba48}},	//   _unla, льмы_, _pung_, _irub,
   {{0x7bc8dd23,0x6e3b826f,0x6e2d2e5f,0x315800be}},	//   _gudu, _hrub, _asab, ייזן_,
   {{0x32120364,0xdb02801c,0x3204a19c,0x2fc780ff}},	//   ytyy_, _thoá, bumy_, _vung_,
   {{0x2d98063f,0x98a587d9,0x657c1b03,0x443a10d1}},	//   tore_, rklı_, tirh, _srp_,
   {{0xceb28051,0x645c6e89,0x6b5cee8a,0x61d68051}},	//   פים_, tyri, _régi, _הוסף_,
   {{0x2d986e8b,0x2d879a29,0xa3e20006,0x645c8074}},	//   rore_, inne_, नीं_, _ürit,
   {{0x2d986e8c,0x2005ee8d,0x256b8bc5,0x7aed254a}},	//   sore_, muli_, _følg_, gaat,
   {{0x3f86826f,0xa1c311d0,0x2005b14f,0x7f440037}},	// [7c20] vnou_, збуд, luli_, _iniq,
   {{0x9c7c82ee,0x66063a9f,0x6f1bee8e,0x41df864a}},	//   _dečj, mukk, _abuc, पीएस,
   {{0x20058025,0xb17a893f,0x66060a52,0x7aed02a3}},	//   nuli_, נטער, lukk, baat,
   {{0x7aed6e8f,0x442c82ee,0x7bc8a060,0x2d87ee90}},	//   caat, _rsd_, _rudu, enne_,
   {{0xf2d3093f,0x63a42280,0xb1480077,0x7bc8c9c6}},	//   _מער_, mlin, _پیام_, _sudu,
   {{0x442cee91,0x78ba0019,0xf9879a00,0xbbe900d7}},	//   _psd_, _útvo, _رب_, _حریم_,
   {{0x3d0981fe,0x8884026a,0x6e3bba48,0x63a42f4b}},	//   _सारे_, _بیان, _erub, olin,
   {{0xd3268cde,0x66062460,0xbf16803d,0x51f88009}},	//   ськи, kukk, _دورب, анию_,
   {{0x6e3bee92,0x66062d27,0x7bc8a88e,0x637e8110}},	//   _grub, jukk, _wudu, gūna,
   {{0xb5fb0117,0x7bc8b550,0x63a452b2,0xa3a88127}},	//   zzás, _tudu, hlin, _खीर_,
   {{0x63a40e51,0x319b00be,0x20059598,0x63b6007b}},	//   klin, רבינ, guli_, kmyn,
   {{0xb76702a9,0xd0418085,0x66065998,0xad9b01d6}},	//   стой, nclə, fukk, krúc,
   {{0x63a40c63,0x7aed2b56,0x7a368875,0x88c000ab}},	//   dlin, vaat, _دعائ, েরিক,
   {{0x200582ec,0x7aed138a,0x9c7c8b67,0xb90c019d}},	//   buli_, waat, _rečj, rahụ_,
   {{0x2005b08f,0xd0b28085,0x317b81c6,0xa3dc8072}},	//   culi_, yğəm, _תרומ, तीच_,
   {{0x63a46e93,0xe3b0190c,0x63b6007b,0x317eee94}},	//   glin, فرق_, gmyn, litz_,
   {{0x6e2d2bd7,0x3d098e5b,0x9955110b,0x9c7c812b}},	// [7c30] _usab, _साले_, окац, _bečk,
   {{0x9c7c8353,0x7aed04a2,0xf77f27e9,0xed59992c}},	//   _večj, saat, liç_, _tuži_,
   {{0x9c7c8d2f,0x63a44968,0x6d450367,0x7aed4c37}},	//   _dečk, blin, _inha, paat,
   {{0x2d8c8d2f,0xceeb8077,0x7aed01b4,0x657ac7fd}},	//   _ajde_, اران_, qaat, _amth,
   {{0x2005ee95,0xf8ae053d,0x44211cfe,0x799ad9f6}},	//   zuli_, _یکم_, _hph_, kotw,
   {{0x9989009a,0x637e8084,0x81d40b69,0x23d5bacb}},	//   stał_, vūna, _хорх, оцир,
   {{0x4c6980e5,0x7afd82b7,0x6b5c80e7,0x442100b9}},	//   рийн_, ósto, _légu, _jph_,
   {{0x6fcfa6ee,0xe1f9a3fc,0x6f1b9d61,0x657a8234}},	//   _संबं, аги_, _ubuc, _emth,
   {{0x6e3b82a0,0xc8da816f,0x291cc64c,0x7769802a}},	//   _urub, _म्हट, _bbva_, _ilex,
   {{0x3eadee96,0x2005c86b,0x69dbc752,0x7f56011c}},	//   _izet_, tuli_, rpue, _soyq,
   {{0x69db80c8,0xcea90451,0xdb0400f7,0xfd1080f7}},	//   spue, _סי_, rmiú, _سجل_,
   {{0x60dc884a,0xae0d81a2,0x6d452b29,0x63a46e97}},	//   ırma, _समान_, _anha, xlin,
   {{0x3f9f80f6,0x63a46e98,0xe8ee951b,0xd1098077}},	//   _mkuu_, vlin, _ол_, _نقشه_,
   {{0x660606d9,0x6b898e8b,0xafe59cce,0x63a43ada}},	//   rukk, lneg, _докл, wlin,
   {{0x66060d7a,0x68e19fa6,0x63a432c7,0x6b5c846d}},	//   sukk, mbld, tlin, _eégu,
   {{0x44210a56,0xe80d035a,0x69cbabd4,0xf8b28039}},	//   _dph_, ांना_, _kuge, _קשה_,
   {{0x7aeb8065,0x7bdc1614,0x69cbee99,0xfaa317cb}},	// [7c40] _megt, spru, _juge, дато,
   {{0x69cbc141,0x7aeb9529,0x3f9f808e,0xdb0b8722}},	//   _muge, _legt, _akuu_, _aigü,
   {{0x69cbee9a,0x3ead81ac,0x1c1e0074,0x9c7c807a}},	//   _luge, _azet_, _पहिल_, _večk,
   {{0xee3a8374,0xe29a2386,0x69c39140,0xed598669}},	//   ине_, _вам_, _line, _mužu_,
   {{0x6b898e8b,0xe297102a,0x69c3811b,0x7c218176}},	//   dneg, _маю_, _oine, _aplr,
   {{0xafe614d6,0x7bc2ee9b,0x77699c4b,0x463b00be}},	//   _могл, _siou, _elex, יענע,
   {{0x317e9ebf,0x69cbc56c,0xdcf50087,0x77699ed3}},	//   vitz_, _auge, liză, _flex,
   {{0x395802be,0x69cbdb07,0x69c3a551,0x6b89ddf0}},	//   _hors_, _buge, _aine, gneg,
   {{0x69c3ee9c,0x914aa5af,0xf77f6e9d,0x39586e9e}},	//   _bine, ачна_, viç_, _kors_,
   {{0x55038153,0x6b5cd568,0x9c7c8bda,0x657a805d}},	//   _опуб, _régu, _leči, _umth,
   {{0x69c3aeaa,0x6b899840,0xcb6a9fab,0x6b5c887a}},	//   _dine, bneg, _каже_, _ségu,
   {{0x69c38943,0x2d9c803b,0x395802be,0x6b9b85db}},	//   _eine, love_, _lors_, coug,
   {{0x443ec3c9,0x3ead013c,0x69cbc50b,0x224b8106}},	//   _hrt_, ået_, _guge, äckt_,
   {{0x7d1b005c,0x395801e2,0x4421008e,0x27692181}},	//   đuso, _nors_, _pph_, _گشتی_,
   {{0xd37b045d,0x69cb82af,0x9c7c80d2,0xdea40326}},	//   ача_, _zuge, _beči, _maiƙ,
   {{0x56950364,0x69c3c717,0x443eee9f,0x3a2202f7}},	//   _найт, _zine, _mrt_, _bpkp_,
   {{0x9c7c82ee,0x60f901bb,0x39586ea0,0x4fb40a47}},	// [7c50] _deči, йная_, _bors_, _تصور,
   {{0x443eeea1,0xad9b0125,0x7bda81b9,0xc4c48065}},	//   _ort_, brúa, _ottu, _لے_,
   {{0x2d9ca8fc,0x4421008e,0x39586551,0xced88133}},	//   dove_, _uph_, _dors_, _ịzụr,
   {{0xe80c0665,0x6b5c8061,0x6602e4d2,0xf1bf1a5d}},	//   _हमरा_, _mégs, frok, _spád_,
   {{0x6b898db7,0x7bdaeea2,0x7aeb879f,0x662780f7}},	//   vneg, _attu, _regt, تراك,
   {{0xa3e2009a,0x69cb80b4,0x9c7c8301,0x6b898035}},	//   नीक_, _ruge, _zeči, wneg,
   {{0x6b899840,0x69c3dbda,0xdb1d0118,0x81cd00ab}},	//   tneg, _rine, _lisí, _রবি_,
   {{0x69c381bf,0x3f9fac07,0x66029a62,0x69cbbb11}},	//   _sine, _ukuu_, brok, _puge,
   {{0x8cd883bb,0x34a803bb,0x6b899ce9,0x443e86db}},	//   नुहो, _गर्द, rneg, _ert_,
   {{0x69c38a2a,0x8af00085,0x290c8106,0x6b89eea3}},	//   _qine, nkər, ggda_, sneg,
   {{0xe73a00b3,0xb4e7d78b,0xc7a60dc7,0x225f87d5}},	//   бен_, परी_, зинк, syuk_,
   {{0x69cbdafe,0x88d100ab,0x224b8338,0x52758087}},	//   _tuge, িরিক, äcks_, _нулу,
   {{0x69c3ad7b,0x1dcb8074,0x9c7ceea4,0xe28ea762}},	//   _tine, ादित, _reči, _ча_,
   {{0xe80c023c,0x2eeda4c2,0xd25684de,0xad9b008b}},	//   _हमला_, _leef_, _משנה_, trúa,
   {{0x98a28d5f,0x80aa009a,0x70aa0006,0x2b590722}},	//   _пише, _करें, _करेल, _bosc_,
   {{0x2d9c8024,0x39586ea5,0x1dcb80d4,0x3a2200ee}},	//   zove_, _sors_, ादात, _ppkp_,
   {{0x3f826ea6,0xe8fa02a9,0x9c7c8353,0x020604d9}},	// [7c60] miku_, йла_, _veči, язан,
   {{0xdce38110,0xe1f705e9,0x59ce864a,0x9f5f04e8}},	//   minė, ягу_, _हंसर, vrté_,
   {{0x2d9c85f5,0xdce38110,0xb4d823bd,0x64a61246}},	//   vove_, linė, ाडी_, _хана,
   {{0x6602eea7,0xe5c684ae,0x79818bb1,0xed5881d6}},	//   trok, пско, hilw, _soľ_,
   {{0x3958364c,0xdce38110,0xe5348009,0x6736008e}},	//   _tors_, ninė, дель, _mayj,
   {{0x6602d149,0x7bc601e0,0x09da80ab,0x237f1ee0}},	//   rrok, _hiku, _দিলা, ďuje_,
   {{0xdee69b95,0x66e69597,0x7bc6426d,0x3f823f12}},	//   _нови, _нова, _kiku, kiku_,
   {{0x6602eea8,0x07a38638,0xe76a9381,0x443ee9cd}},	//   prok, _засн, _احسن_, _vrt_,
   {{0xa2a20592,0x0e6681e2,0xa6aa990c,0x7ae46ea9}},	//   _कुम्, _экан, _طارق_, ibit,
   {{0x7bc66eaa,0x4973eb31,0xdce38084,0x443eb6b2}},	//   _liku, ельс, dinė, _trt_,
   {{0x3f822316,0xa3ac0327,0x9ad301bc,0x6b5c8036}},	//   fiku_, गता_, _kịta, _dégr,
   {{0x290283bf,0x6d5aeeab,0xdb0400e7,0x69da001b}},	//   şka_, _hota, blié, _čten,
   {{0x63a2eeac,0x61469a0b,0xd05c0201,0x8f9b83c8}},	//   _ikon, _неда, _verə, מיטי,
   {{0x6d5a8364,0x7bc60009,0xe5c40198,0xdb1d29c3}},	//   _jota, _aiku, ессо, _visí,
   {{0x6d5a86c1,0xaeec00c8,0x7bc6020c,0x7f592318}},	//   _mota, _কারণ_, _biku, _макс_,
   {{0x637104b8,0xdb1d003e,0x26c91f3a,0x7bc60573}},	//   _mång, _tisí, _ugao_, _ciku,
   {{0x2aab0758,0x637104b8,0x6d489c35,0x63a2822e}},	// [7c70] ство_, _lång, _onda, _mkon,
   {{0x6d5ae70d,0xd1388110,0x636302f1,0x6f1d14cf}},	//   _nota, ndą_, _mõni, lfsc,
   {{0x2d832e96,0x7bc66ead,0x7bc300e5,0xb9c401a8}},	//   mije_, _fiku, _ènuo, رقمي,
   {{0x6d48eeae,0x7bc60959,0xd36680d7,0x6d4f0699}},	//   _anda, _giku, _شه_, škač,
   {{0x6d5ac395,0x44330683,0x6b8d0362,0x80c58e1b}},	//   _bota, _hsx_, mnag, লুপ্,
   {{0x64a5bb17,0x63a2849f,0x6d5aa2a0,0xdca58256}},	//   мала, _akon, _cota, мали,
   {{0x6d5a8b91,0x26d287d9,0x7c22017f,0x764085ee}},	//   _dota, ıyor_, _ćork, _ermy,
   {{0x6b8d6eaf,0xc24584dd,0x2d836eb0,0xe9d992b2}},	//   nnag, дник, hije_, оки_,
   {{0x2d8300b4,0x69cf02ce,0x69c731ac,0x6b8d473a}},	//   kije_, _juce, _kije, inag,
   {{0x63710370,0x3f8202f7,0x2d830c97,0xdce38084}},	//   _hånd, wiku_, jije_, vinė,
   {{0x2d8302a5,0x637104b8,0x69c702fd,0x69cf0baf}},	//   dije_, _gång, _mije, _luce,
   {{0x69c7030b,0xdce381e2,0xdb0f0118,0x69cf0118}},	//   _lije, tinė, _micó, _ouce,
   {{0x27e0803a,0x63710448,0x69dd10af,0x7bc66eb1}},	//   _čine_, _månd, _ntse, _riku,
   {{0x2d836eb2,0x69c71eb9,0x7bc66eb3,0xdce38110}},	//   gije_, _nije, _siku, rinė,
   {{0x3f8207d8,0xdca312b2,0x64a30eab,0x69dd2a6b}},	//   piku_, вари, вара, _atse,
   {{0x63a9b816,0x69cf2934,0x6b8d6eb4,0x672b80f1}},	//   nlen, _buce, gnag, jegj,
   {{0x2d833f0f,0x69c71351,0x7ae43a70,0x7bc66eb5}},	// [7c80] bije_, _bije, rbit, _viku,
   {{0x69c7030b,0x63a9d2b2,0x69cf08e4,0x657e005d}},	//   _cije, hlen, _duce, _umph,
   {{0x69c76eb6,0xb8f608fd,0x63a9eeb7,0x443c0019}},	//   _dije, _हल_, klen, _év_,
   {{0xdb1d03a7,0xadeb03b6,0x6d5aeeb8,0x69cf00e5}},	//   _visã, जीवन_, _sota, _fuce,
   {{0x2bd210be,0xf1af0701,0x64419c80,0x4425eeb9}},	//   _दूता, _जीवन, _arli, _apl_,
   {{0x63a2eeba,0x6b843bf0,0x7e62810c,0x64418115}},	//   _skon, liig, ryop, _brli,
   {{0xa2a21094,0x63a9ab3d,0x20058267,0x7e6282d6}},	//   _कुत्, flen, jrli_, syop,
   {{0xdb0d0003,0x5a3497f9,0x63bbeebb,0x6d5a0074}},	//   rmaç, енит, gmun, ötaj,
   {{0x64419d6a,0x4425b04e,0x200580e5,0x6eaa0072}},	//   _erli, _epl_, erli_, _घरगु,
   {{0x6d48eebc,0x7bde0024,0x213800dd,0x58868196}},	//   _unda, _otpu, _jarh_, дыма,
   {{0x2d83003b,0x63a9eebd,0x9c7ceebe,0x776d002a}},	//   vije_, blen, _peču, _plax,
   {{0x6d0e8076,0x63a284e8,0x224982a5,0xd7cf8aad}},	//   _साँग_, _ukon, _šake_, _संरच,
   {{0x2d8300ce,0x9f6580e7,0x200581e8,0x7aef05d8}},	//   tije_, étés_, arli_, _rect,
   {{0x63710a38,0x7aef4918,0xe894917c,0x60178870}},	//   _måne, _sect, _паль, ụmah,
   {{0x69c7030b,0xd7ef8088,0xe5718158,0x63710370}},	//   _rije, _шу_, אַן_, _låne,
   {{0x2d8302a5,0x69c7111b,0x200ceebf,0x69cf34d3}},	//   sije_, _sije, mudi_, _puce,
   {{0x9ccb0087,0xe1f00064,0x7afdaa63,0x2eba816f}},	// [7c90] _мына_, لسل_, ósti, ेशोत,
   {{0x9f45877f,0x63bbeec0,0x69cf0144,0x63a9eec1}},	//   _ìlú_, zmun, _vuce, zlen,
   {{0x69c7030b,0x200c803b,0xb4eb0054,0x2fc901c5}},	//   _vije, nudi_, मरी_, _kiag_,
   {{0xf8df085d,0x20df0bb8,0x28df0aed,0xb0df06bf}},	//   _प्रय, _प्रध, _प्रि, _प्रग,
   {{0x69c7030b,0x200cc9ec,0xf773804e,0x69dd0b64}},	//   _tije, hudi_, _یار_, _utse,
   {{0xee389439,0x660b837a,0x2fc923f0,0x212c8168}},	//   ьні_, rugk, _liag_, jedh_,
   {{0x63a9eec2,0x43698607,0x03a596df,0x2d8100b9}},	//   tlen, зайн_, нико, _mmhe_,
   {{0x644180d2,0x2fc90069,0xdb1e0118,0x42559c79}},	//   _vrli, _niag_, _supú, етот,
   {{0x63a9eec3,0xcad281bc,0xa3b60035,0x0e8e882e}},	//   rlen, _pịrị, _चीफ_, sịrị_,
   {{0xa3b605fb,0x7d798eca,0x63bbeec4,0xa3cf0072}},	//   _चीन_, _عمار_, smun, शदा_,
   {{0x3ea914ec,0xe73a302b,0x63bbe193,0x2fc902d5}},	//   _ayat_, пен_, pmun, _biag_,
   {{0xe73a33d9,0x660004e8,0xd6d201a8,0x9c7c8af8}},	//   чем_, ámko, طقس_, _večt,
   {{0x2b1486b7,0x2fc96ec5,0x15ba0009,0xd7f88087}},	//   _धातु_, _diag_, зывы_, asă_,
   {{0x636302f1,0x200582d4,0x332d857b,0xfe7f0580}},	//   _mõnu, prli_, leex_, taïr_,
   {{0x6ea00eed,0xc4d281c6,0x3f6a0eef,0xa5bb066f}},	//   _गुरु, רגל_, _нико_, twór,
   {{0x92c380c8,0xe9da09c7,0x636a016b,0x645c87f1}},	//   ্রী_, зка_, _výno, _àrie,
   {{0x6b840074,0xe1f98084,0x67240314,0xe2972934}},	// [7ca0] riig, nsų_, _ibij, еат_,
   {{0x850e8fea,0xdff38441,0x2fc9022c,0x76440314}},	//   _साइट_, _आबाद_, _ziag_, _iriy,
   {{0x2fc9022c,0xaadf801b,0x63a0b327,0xaf068162}},	//   _yiag_, नडाक, yomn, епел,
   {{0x444462fb,0x09e60912,0x91e61232,0x68e3017b}},	//   _ir_, _помн, _поме, ında,
   {{0x6d5e3730,0xa3bd0105,0x163492c0,0x67244959}},	//   _kopa, इगर_, теля, _mbij,
   {{0x44444f3c,0x61e425cb,0x256f02f1,0x26cd8037}},	//   _kr_, mpil, _küla_, _egeo_,
   {{0x6724017f,0x6d5e445f,0x69d600f1,0x63a0eec6}},	//   _obij, _mopa, lqye, tomn,
   {{0x31c8c476,0xd3779d51,0x44440039,0x25740338}},	//   रद्ध, ечь_, _mr_, _fälg_,
   {{0xc2988765,0xdb040118,0x6d4b81a8,0x22406ec7}},	//   ьких_, nmiñ, álaí, nvik_,
   {{0x4444073a,0xc27b0451,0x200ceec8,0x63a080e1}},	//   _or_, פריי, tudi_, somn,
   {{0x63a0cda9,0x76445f58,0xb4cc8744,0xe8948110}},	//   pomn, _ariy, रखी_, тань,
   {{0xc6a7067c,0x200c98c3,0x4ea73d73,0xd7f88162}},	//   ерги, rudi_, ерга, rsă_,
   {{0x44446ec9,0x753a81ec,0x3d178074,0x200cb6d9}},	//   _ar_, _katz, _नामे_, sudi_,
   {{0x44443eb7,0x238c81d0,0x22402127,0xb4eb12c6}},	//   _br_, ději_, dvik_, मरे_,
   {{0x97a716d9,0x77930bca,0x850e858c,0x3d12058c}},	//   _прил, _میدا, _साईट_, _तारे_,
   {{0x53340785,0x644305e4,0xe3b305ff,0x9b580dc0}},	//   лест, _ánim, ارس_, нист_,
   {{0x444415f8,0x764401bf,0x61e41066,0x69cab1ac}},	// [7cb0] _er_, _griy, gpil, _kife,
   {{0x7c28eeca,0x23690933,0x93bc8162,0x7cd90198}},	//   _opdr, skaj_, _spăl, _юмор_,
   {{0x44445fdf,0x6b82895e,0x63630074,0x661d2b3a}},	//   _gr_, _omog, _sõnu, ltsk,
   {{0xdddd009a,0xb4bf06bf,0x661d5db3,0x673d1388}},	//   mysł, ेशी_, otsk, ndsj,
   {{0x753a80ad,0x63ad4482,0x660f1c33,0x7c28a52a}},	//   _batz, mlan, nuck, _apdr,
   {{0x44442065,0x63ad0b23,0x69ca831d,0xa2c48c1c}},	//   _yr_, llan, _nife, ाइन्,
   {{0xeb9980d6,0x32090e35,0x63ad6ecb,0x69aa0beb}},	//   мик_, lray_, olan, _जीटी,
   {{0x3f86eecc,0xdb009f1b,0x0b4582df,0x661d0687}},	//   ciou_, nomè, тнин, ktsk,
   {{0x63ad2bd3,0xdb1aeecd,0x660f02a5,0x27e08042}},	//   ilan, _autó, juck, _čina_,
   {{0x63ad029b,0x673b81e9,0x7f4d016a,0x672401a1}},	//   hlan, _hauj, _anaq, _sbij,
   {{0x2d87acdd,0x66e606cf,0x644501e9,0xdee62748}},	//   mine_, кона, _nrhi, кони,
   {{0x63ad2126,0x4444378a,0x6d5e3a66,0x764405cb}},	//   jlan, _rr_, _sopa, _priy,
   {{0x4444239f,0x2d87803c,0x7ae9eece,0x69ca9f19}},	//   _sr_, oine_, mbet, _fife,
   {{0xdb1d025d,0x444408f7,0x7ae98b81,0x673bbf73}},	//   _lisä, _pr_, lbet, _lauj,
   {{0xdca60284,0x64a62549,0x61fd1f20,0x68f70079}},	//   тави, тава, _avsl, daxd,
   {{0x673b8a8e,0x6724003b,0x2d87eecf,0x320919eb}},	//   _nauj, _ubij, hine_, fray_,
   {{0x6d5e3fae,0x7bcbcef1,0x644501ec,0x3209057b}},	// [7cc0] _topa, _migu, _erhi, gray_,
   {{0x44446ed0,0x63ad3f8c,0x2d87eed1,0x7af602c4}},	//   _tr_, alan, jine_, sayt,
   {{0x4444477d,0x2d878ee0,0x61e46ed2,0x61fb8085}},	//   _ur_, dine_, spil, hsul,
   {{0x6a860436,0x63ad2aa4,0x7bcbb787,0xe809a3bd}},	//   _алма, clan, _nigu, _विना_,
   {{0x9f594bac,0x63a42b92,0x63758c58,0x7ae984fe}},	//   éré_, moin, _mánd, dbet,
   {{0x63a4271b,0x7bcb87fc,0x2d879e68,0xb4cc816f}},	//   loin, _aigu, gine_, रखे_,
   {{0x69ca939a,0xbef2016f,0xe9df001c,0x291808c5}},	//   _rife, _अजून_, _trúc_, _icra_,
   {{0x442084b7,0xdb1a8722,0xdcee00e1,0x63a40198}},	//   ċi_, _autò, jobľ, noin,
   {{0x7bcb8859,0x171b8158,0x61fb97ef,0x75828fd3}},	//   _digu, _קומע, gsul, _پیغم,
   {{0x63ad6ed3,0x673b9dc1,0x63710687,0x717480f7}},	//   zlan, _zauj, _måna, اهدا,
   {{0x63ad6ed4,0x6375eed5,0x63a40009,0x7bda016a}},	//   ylan, _bánd, koin, ítul,
   {{0x7ae99a2e,0x7bcbc2c6,0x6375a509,0x63ad0085}},	//   cbet, _gigu, _cánd, xlan,
   {{0xa2a2159a,0x5f9450f6,0x6375a848,0x673d03ba}},	//   _कुल्, рият, _dánd, rdsj,
   {{0x661d003b,0x61e2eed6,0x63ad6ed7,0x58d3b031}},	//   rtsk, _itol, wlan, _кошт,
   {{0x63ad3aaa,0x661d2a07,0xb4bf0c28,0x7f5f011c}},	//   tlan, stsk, ेशे_, _toqq,
   {{0x63ad1793,0x7988c742,0x637583a8,0x7f4d07f1}},	//   ulan, lidw, _gánd, _unaq,
   {{0x80d70424,0x2d878169,0x29180144,0xdb04008b}},	// [7cd0] _बलदे, yine_, _bcra_, rmið,
   {{0xdb1d025d,0xd7e7035f,0xe9df002a,0xdb0085ec}},	//   _sisä, відо, _crúa_, llmä,
   {{0x31c42410,0x201e8009,0x7ae98214,0x77b60118}},	//   рств, ntti_, ybet, láxa,
   {{0x201e8364,0x63ad011c,0x61e2eed8,0x2d87dd03}},	//   itti_, qlan, _otol, wine_,
   {{0xf770819f,0x7bcb8098,0xfe7080a0,0x63b9831d}},	//   غام_, _rigu, يده_, _rhwn,
   {{0x2cac8355,0xe9df0020,0x7ae98428,0xa97903de}},	//   _bydd_, _grúa_, wbet, _טאָכ,
   {{0x2d878315,0x7ae99c11,0xdb040019,0x61e2eed9}},	//   rine_, tbet, lliá, _atol,
   {{0x2d87eeda,0x2cac831d,0x61fbcbf9,0x2246d994}},	//   sine_, _dydd_, tsul, _brok_,
   {{0x7ae98422,0x2d87c319,0x68f50065,0xe7849a02}},	//   rbet, pine_, _kezd, _туро,
   {{0x2cac831d,0x61fbafdb,0x68f51d40,0x7bcb8d56}},	//   _fydd_, rsul, _jezd, _wigu,
   {{0x7bcb833e,0x61e28133,0x61fb8170,0x378a05c2}},	//   _tigu, _etol, ssul, ебно_,
   {{0xeeeb0104,0x2018809f,0xd24e826a,0x77b88216}},	//   ường_, ària_, آنی_, píxe,
   {{0x5fcf8701,0x6561a651,0x79889a72,0x63a46a78}},	//   _संकल, _kolh, bidw, voin,
   {{0x6371016d,0x6b89eedb,0x39588106,0x5bbe0c32}},	//   _råna, lieg, örst_, ्द्व,
   {{0x232a3408,0xab2a013a,0x63a46edc,0x656183a7}},	//   нови_, нова_, toin, _molh,
   {{0xf0928051,0x69c18214,0x6b89d6bd,0x29030019}},	//   _לנו_, lmle, nieg, _adja_,
   {{0xf2d28159,0x63a464e3,0x68f5188a,0x256f0006}},	// [7ce0] מען_, roin, _bezd, _küll_,
   {{0x63a42cf0,0xdb00ad5d,0x6b89811b,0x764b0e06}},	//   soin, romé, hieg, _ágya,
   {{0x6b898063,0x9d1b00be,0x776081c0,0xf3f100ff}},	//   kieg, _אויט, _pomx, ật_,
   {{0x2d8a6edd,0xe9df016a,0xdfcf01a8,0x6b89eede}},	//   libe_, _irún_, سيه_, jieg,
   {{0x2cac8355,0x65618db7,0x6f0400b9,0xdb07002a}},	//   _sydd_, _bolh, _mdic, _émái,
   {{0x656183a7,0x660480e1,0xad9b01a8,0x201eb095}},	//   _colh, šiko, trúi, ytti_,
   {{0x3a202cb1,0x798881b9,0x50b8064a,0xd90d00b7}},	//   ltip_, vidw, _अरिष, _زین_,
   {{0x40930013,0x69ce6edf,0x3f84ba20,0x2246808e}},	//   _الفر, _hibe, _ummu_, _prok_,
   {{0x69ce620b,0x49748153,0x65618073,0xc174d0f6}},	//   _kibe, илис, _folh, илищ,
   {{0x6f04241f,0x2ee000dd,0xdb1e016b,0x753e008e}},	//   _adic, _afif_, _kupó, _napz,
   {{0xa3c40063,0x69ce6ee0,0x6b89eee1,0x7d1a80b9}},	//   एगा_, _mibe, bieg, _icts,
   {{0xa3d81d40,0x7c3ab642,0x236d81ac,0x201eecd0}},	//   ादन_, _istr, ckej_, rtti_,
   {{0x11548607,0x61e28019,0xb8cb9d17,0xf1ba801c}},	//   _вклю, _utol, _कु_, _thơ_,
   {{0x6f0405dc,0xda7b8051,0x442ca08b,0x1c18bc4f}},	//   _edic, _אנדר, _kpd_, _धमाल_,
   {{0x443a6ee2,0x68faeee3,0x80db81c6,0x753e6ee4}},	//   _csp_, matd, _אחוז, _dapz,
   {{0x1dd48996,0x68fa829a,0xdb198176,0xdb2181d6}},	//   ददात, latd, _chwè, _štúr,
   {{0x69ce3806,0xa2c0053e,0x8d870adb,0x50f51ed1}},	// [7cf0] _bibe, लेल्, _бунд, изат,
   {{0x637807f4,0x2d8a040e,0x3f8b003a,0xa5bb11b9}},	//   _aínd, cibe_, licu_, stób,
   {{0x69ce0812,0x443a3f21,0xdb1e01ca,0xb0353d0a}},	//   _dibe, _gsp_, _cupó, рнеш,
   {{0x3f8b28fc,0x68fa829a,0x3ead8168,0x3d1b0074}},	//   nicu_, hatd, _pyet_, _बाडे_,
   {{0x69ce3ada,0xe8010105,0x63780032,0x68fae49f}},	//   _fibe, _लटका_, _dínd, katd,
   {{0x69ce12e5,0x7aed0c39,0x6b89b975,0x6443826c}},	//   _gibe, lbat, wieg, tvni,
   {{0x636a007b,0x3f8b00ce,0x6b898f67,0x6561874c}},	//   _sýni, kicu_, tieg, _volh,
   {{0x442ca9fb,0x3f8b003a,0x7aed0102,0x6443d5ee}},	//   _dpd_, jicu_, nbat, rvni,
   {{0x7c3ab83c,0x3f8b0067,0x64488102,0x7bcf6ee5}},	//   _estr, dicu_, _erdi, _micu,
   {{0x7aed008e,0x236d81ac,0x7bcf3bfe,0x636a00e1}},	//   hbat, skej_, _licu, _výni,
   {{0x6e2d14ff,0xb8dd904f,0x637585a4,0x6b898f7d}},	//   _apab, _आर_, _cánc, pieg,
   {{0x76498205,0x443a6ee6,0xc7a600e8,0x3f8b05f3}},	//   _krey, _rsp_, римк, gicu_,
   {{0x6d890025,0x68fa829a,0xee3733c2,0x6b5c8061}},	//   ržan, batd, аня_, _négy,
   {{0x61e9eee7,0x7afb8364,0xeeeb0028,0xb17b0106}},	//   mpel, laut, ưởng_, _stån,
   {{0x2d8a3ec3,0x69dbeee8,0x69ce4d2c,0x63786ee9}},	//   ribe_, lque, _ribe, _líne,
   {{0x7afb8e37,0x6f042cf7,0x69ce083a,0x7aed31f2}},	//   naut, _udic, _sibe, gbat,
   {{0x69db9e9e,0xdb1e04c3,0x7bcf0458,0x69ce1e2c}},	// [7d00] nque, _supó, _dicu, _pibe,
   {{0x60e71505,0x7aed11c9,0x6f1bbcd4,0x6729da98}},	//   имум_, abat, _acuc, _abej,
   {{0x7aed00a4,0x20560f04,0x7afbde4e,0x645883a8}},	//   bbat, штар, kaut, xxvi,
   {{0x76498125,0xf8b28039,0x70d2d59b,0x7afbac28}},	//   _brey, חשב_, _सल्ल, jaut,
   {{0x69ce3f49,0xee7a95a8,0x28b80540,0x76498216}},	//   _tibe, خصات_, _अरवि, _crey,
   {{0x442cae43,0x3f8b012b,0x7649a445,0x7bd7011c}},	//   _ppd_, zicu_, _drey, _yuxu,
   {{0x7afb822e,0x998d809a,0x6e3b9793,0x6d89026c}},	//   faut, steś_, _esub, džal,
   {{0x200c8289,0x7649808b,0x7afbeeea,0x61e6008e}},	//   vrdi_, _frey, gaut, _ktkl,
   {{0x764990c9,0x637585e4,0x32000176,0x7e60016d}},	//   _grey, _sánc, nsiy_, ämpl,
   {{0x7aed0087,0xd90e804e,0x6448807a,0x200c82d4}},	//   zbat, ذیب_, _trdi, trdi_,
   {{0x7c3a9de3,0x68fa811c,0x7afbeeeb,0x6448eeec}},	//   _ustr, ratd, baut, _urdi,
   {{0x61e60067,0x44380114,0x69db8363,0x77640980}},	//   _otkl, dwr_, bque, _coix,
   {{0xa11683f8,0xdb00840e,0x3f8b003a,0x69db93ff}},	//   _نوشت, nomí, ricu_, cque,
   {{0x7bcf0698,0x3f8b00fe,0x61e90315,0xac191170}},	//   _sicu, sicu_, _çeli, логу_,
   {{0x61e60029,0x999980e1,0x44380114,0x7bcf0957}},	//   _atkl, ísť_, gwr_, _picu,
   {{0x88778039,0x8c3c8085,0x539800e8,0x7f40913b}},	//   _כתוב_, _uyğu, ався_, _namq,
   {{0x7bd702c1,0x7aed6eed,0x7bcf38b4,0x49750110}},	// [7d10] _wuxu, rbat, _vicu, блас,
   {{0x6375807b,0x7aed6692,0x9f588081,0x2fd86eee}},	//   _mána, sbat, _avrà_, _burg_,
   {{0x7bdea5a7,0x69db8feb,0xd246815b,0x75356eef}},	//   ípul, zque, _کن_, mezz,
   {{0x6e44003d,0x753567b6,0x7649eef0,0x68f89235}},	//   _انیم, lezz, _prey, _levd,
   {{0x6375807b,0xfce582a4,0x6b8d2763,0x0356007c}},	//   _nána, боло, miag, _הירש_,
   {{0xa80501df,0x290a91b9,0x75354555,0x063803de}},	//   _coñé, óbal_, nezz, ינדט_,
   {{0x7afb9608,0x69c520ad,0x28c303eb,0x65650372}},	//   taut, mmhe, वेशि, _mohh,
   {{0x6b8d4bbd,0x75350081,0x20011f33,0xd49802f6}},	//   niag, hezz, mshi_, יכות_,
   {{0x8e8580f7,0x637581a8,0x656502d5,0x81df8264}},	//   _الذه, _cána, _oohh, ধীন_,
   {{0x69db9ebb,0x6b8d00ad,0x61e9eef1,0x320deef2}},	//   rque, hiag, rpel, rrey_,
   {{0x69dba321,0xa0a5a597,0x6d419cbc,0x200167e0}},	//   sque, санд, _iala, nshi_,
   {{0x6d41b492,0x61e987b3,0xb17b01a3,0x2001004f}},	//   _hala, ppel, _stål, ishi_,
   {{0x6d419904,0xaaa7016f,0x75353333,0x200105ee}},	//   _kala, _कुलक, fezz, hshi_,
   {{0x6d41ad3a,0x6d43eef3,0x63a98fca,0x3d1200c2}},	//   _jala, ndna, loen, ़लें_,
   {{0xdd8f0b76,0x69d98c85,0xa3b3016f,0xf3f10129}},	//   روف_, _huwe, टतं_, ập_,
   {{0x6d41c786,0x69d9c9a0,0x660f026c,0xda030074}},	//   _lala, _kuwe, brck, _लिखत_,
   {{0x69d9a0b5,0x7af982a6,0x3de200ab,0x64430115}},	// [7d20] _juwe, _mewt, _বিকল, _šnit,
   {{0x63a980f3,0x865b0039,0x69d9eef4,0x3a3d80ee}},	//   hoen, _עדיי, _muwe, _mswp_,
   {{0xa2b40701,0x63a99fdc,0xa3b780d4,0x69d9c50b}},	//   _आरक्, koen, छता_, _luwe,
   {{0x7c3e003a,0x6d41d099,0x69c5037a,0x66040a35}},	//   _ispr, _aala, amhe, _kvik,
   {{0x471b0158,0x63a98cfa,0xa805002a,0x61e60711}},	//   רונג, doen, _poñé, _utkl,
   {{0xf8dc08fd,0xdb00eef5,0x7ae2b227,0xd2b701c6}},	//   _बलिय, romí, _sfot, _ללכת_,
   {{0x6d418595,0x6e22eef6,0x6fb68199,0xdc2a9ef7}},	//   _dala, stob, _همسا, استه_,
   {{0x5f968307,0x6d419a29,0x68f895dc,0xdb0083fb}},	//   _الرئ, _eala, _sevd, pomí,
   {{0x25be8748,0x2fdf01a1,0x8d1a87c3,0x637c89c4}},	//   _thtl_, _čugi_, _مزار_, _léng,
   {{0x6d41eef7,0xe80d035a,0xa3d81094,0x69d9eef8}},	//   _gala, ांचा_, ादा_, _duwe,
   {{0xa3df800f,0x2c0b826a,0x63a983a6,0x69d99407}},	//   _धूप_, _معنی_, boen, _euwe,
   {{0x443e8943,0x63a9ae83,0x289b03c8,0x656501a1}},	//   _ist_, coen, ריטא, _sohh,
   {{0x753501c1,0x6d41eef9,0x4aa709f2,0x0ab684e3}},	//   tezz, _yala, _कुंव, _احاد,
   {{0x7bda8d4f,0x6d41ab95,0x2d8e826c,0x236681c0}},	//   _kutu, _xala, nife_, _hooj_,
   {{0x753523b9,0x7bda8406,0x7aed802e,0x2001065f}},	//   rezz, _jutu, _întâ, xshi_,
   {{0xa5bb2511,0x25740106,0x23668140,0x7bda80ef}},	//   ctón, _häll_, _jooj_, _mutu,
   {{0x7c3e240a,0x6b8d07e8,0x75353333,0x2366822c}},	// [7d30] _espr, riag, pezz, _mooj_,
   {{0x7bda8e67,0x23668282,0x63a9eefa,0x443e8252}},	//   _outu, _looj_, zoen, _ost_,
   {{0x69c50013,0x6d41c022,0x7bdaa1b8,0x610b00eb}},	//   rmhe, _rala, _nutu, vēlē,
   {{0x20014941,0x63781f90,0xdb0d00f7,0x637c89c4}},	//   rshi_, _vínc, olaí, _jénd,
   {{0x672d00f1,0x637cb749,0x200102f7,0x787f8061}},	//   _mbaj, _ménd, sshi_, _kávé,
   {{0x7bda9efb,0x61ed6a30,0x6d4192b5,0x69d9a168}},	//   _butu, mpal, _qala, _ruwe,
   {{0x6d41dc17,0x6d43a67f,0x7bdae11f,0xdcf500eb}},	//   _vala, rdna, _cutu, lizē,
   {{0x6d41dc6d,0x236681c0,0x69d9809c,0xa2c0170c}},	//   _wala, _cooj_, _puwe, लेक्,
   {{0x443e9c8d,0x6d41cdeb,0x63a9eefb,0xe299af75}},	//   _est_, _tala, roen, рап_,
   {{0x672d6efc,0x2d8e83a7,0x3f8feefd,0xe8f984a9}},	//   _abaj, cife_, ligu_, шло_,
   {{0x25a08013,0x764d448d,0x7bdacb22,0x201e0106}},	//   éile_, _aray, _gutu, _ätit_,
   {{0x69d9eefe,0xd6d98035,0x637c88f9,0x764d4d9d}},	//   _tuwe, _mało_, _cénd, _bray,
   {{0x99d79a3c,0x764d1532,0x61ed2a90,0xa5bb6eff}},	//   _اتصا, _cray, jpal, rtón,
   {{0x764d02e8,0x9f4600f7,0x29cd01a1,0x2366822c}},	//   _dray, mplí_, _džak_, _zooj_,
   {{0x3d1b00cf,0x8c4335cc,0x6f09d619,0x2fc0125b}},	//   _बारे_, мере, _odec, _thig_,
   {{0x3f8f803a,0xdb0400f7,0x0aea01e5,0x66048bcf}},	//   jigu_, lliú, рдай_, šiki,
   {{0xe8fa1f3e,0x27e0803a,0xc33282f6,0x61ed1066}},	// [7d40] ила_, _čini_, וון_, gpal,
   {{0x6f09e26f,0x61e480f7,0x9f5f01ca,0xa5bb018a}},	//   _adec, _éile, butó_, ntól,
   {{0xb17a80be,0x6d890754,0xdb0401a8,0x9f5f0144}},	//   סטער, džah, iliú, cutó_,
   {{0xd378803b,0x7bdae7ca,0x68fe2df3,0x39430122}},	//   _kuće_, _rutu, sapd, _eajs_,
   {{0xe5c6a10d,0x236681c5,0x6f098114,0x7bda93a8}},	//   оско, _rooj_, _ddec, _sutu,
   {{0x1dbc0bb8,0x63a9075f,0x6f098214,0xdb008019}},	//   ोगित, čene, _edec, domá,
   {{0x475a8656,0xd00702de,0x6602e02b,0x66e686b5}},	//   _края_, _мере_, ssok, _мова,
   {{0x68fc6f00,0x637581df,0x7ae43648,0x63b6031d}},	//   _herd, _dáno, ncit, nlyn,
   {{0xde03a927,0xa5f78073,0x637c8118,0xdb00d26f}},	//   _опти, _меѓу_, _rénd, gomá,
   {{0x7bda8bb0,0x7ae40101,0x6f098035,0x637c8118}},	//   _tutu, hcit, _zdec, _sénd,
   {{0x236681c5,0x61ed6f01,0x443ee86e,0x25740106}},	//   _tooj_, zpal, _ust_, _väll_,
   {{0xdbf080ab,0x656883ed,0x68fc6f02,0x764d33e1}},	//   _টিপস_, _hodh, _lerd, _pray,
   {{0x6568ef03,0x61e200f7,0x637c8333,0xdb008144}},	//   _kodh, íoll, _vénd, comá,
   {{0x68fc02d0,0x656888f9,0xdb0d01a8,0xd49b0a4c}},	//   _nerd, _jodh, rlaí, арб_,
   {{0x9f47820f,0x7bc2bd3e,0x65688199,0x6378008b}},	//   ënë_, _khou, _modh, _sína,
   {{0xe517023c,0x764d6f04,0x6568c959,0x20070968}},	//   _ताकि_, _tray, _lodh, šnik_,
   {{0x68fc208b,0x637cb699,0x49751baa,0x29d500f7}},	// [7d50] _berd, _géne, плас, سياس,
   {{0x68fc6f05,0xdcf500eb,0x799a8edc,0xf84b0087}},	//   _cerd, rizē, nntw, ичей_,
   {{0x2d916f06,0x68fc1dcc,0x4735965d,0x61ed6f07}},	//   mize_, _derd, знес, spal,
   {{0x68fc05f8,0x61ed2b49,0x6f1d4c84,0x7ae42d60}},	//   _eerd, ppal, ngsc, ccit,
   {{0x6d452e8c,0x637c862f,0x65688387,0x7afd0029}},	//   _kaha, _xéne, _bodh, _iest,
   {{0x68fc6f08,0x2d916f09,0x6d4758ce,0x7afd05be}},	//   _gerd, nize_, ndja, _hest,
   {{0x6d4506df,0x290102a3,0x7afd238d,0x69dd13c2}},	//   _maha, maha_, _kest, _huse,
   {{0x6d456f0a,0x7afd085d,0x29016f0b,0xdb0090dd}},	//   _laha, _jest, laha_, tomá,
   {{0x68fc0182,0x69dd355d,0x9ad30133,0xdb0e80f7}},	//   _yerd, _juse, _dịga, ódál,
   {{0x6d453a19,0x61e6803e,0x6568803d,0x29013090}},	//   _naha, íkla, _godh, naha_,
   {{0xa3bd101c,0xfbdb081f,0x69d5019a,0x69dd6f0c}},	//   ेगा_, _मूलम, _mize, _luse,
   {{0x69d50b90,0x7afd6f0d,0xdb00816b,0x63ad0580}},	//   _lize, _nest, pomá, joan,
   {{0x2d9106c0,0x290141ab,0xa5bb0118,0x7bc9cd28}},	//   fize_, kaha_, ptól, mmeu,
   {{0x6d4527df,0x2d9102a0,0x69d50823,0x637c9753}},	//   _caha, gize_, _nize, _véne,
   {{0x7afd6f0e,0x290102c1,0x69c3ef0f,0x6d4519b0}},	//   _best, daha_, _ihne, _daha,
   {{0x7afd0259,0x63ad4183,0x6d570899,0x69dd0d54}},	//   _cest, goan, _enxa, _buse,
   {{0x7afd6f10,0x6d456480,0x7ae432a3,0x2d8402be}},	// [7d60] _dest, _faha, rcit, èmes_,
   {{0x7afd2cdd,0x7ae41137,0x0f148540,0x6441812b}},	//   _eest, scit, डल्स_, _osli,
   {{0x7afd05d8,0x69d559e7,0x656889c4,0x443c8069}},	//   _fest, _dize, _rodh, xwv_,
   {{0x68fc1736,0x6d452822,0x68e50046,0x69dd28bf}},	//   _werd, _zaha, achd, _fuse,
   {{0x68fc14ff,0x6d456f11,0x69d5164b,0x6441c18e}},	//   _terd, _yaha, _fize, _asli,
   {{0x7bc28051,0x7afd5105,0x69d5169d,0x25740106}},	//   _shou, _zest, _gize, _sälj_,
   {{0x777ba2a0,0x7bde4dfa,0x645812ca,0x7bc282c4}},	//   _flux, _jupu, _ávid, _phou,
   {{0x7afd07f4,0x63a48796,0xf743a516,0x8c1b007c}},	//   _xest, čino, _песо, צופי,
   {{0x62840698,0x257400f2,0xc3330051,0x7bde0642}},	//   nzio, _välj_, תוח_, _lupu,
   {{0xad9b0013,0x04468767,0x4427810c,0x63710711}},	//   gsúl, _незн, btn_, _våni,
   {{0xac768875,0x7bc28051,0x2d916f12,0x63ad004f}},	//   _عائش, _thou, vize_, yoan,
   {{0x6d456f13,0x62840102,0x929d809a,0x29011e8f}},	//   _saha, kzio, wałe, zaha_,
   {{0x29016f14,0x6e3d0a0f,0x2d916f15,0x0ec70540}},	//   yaha_, uwsb, tize_, रेंड,
   {{0xa2cd0bbc,0x69dd585b,0x7bde6f16,0x29010079}},	//   _दृष्, _ruse, _bupu, xaha_,
   {{0x2d911efb,0x92b900c8,0x6d476f17,0x63ad6f18}},	//   rize_, _চলে_, rdja, toan,
   {{0x2d9106a0,0x69dd2c28,0x7bde24df,0x1fa40110}},	//   size_, _puse, _dupu, _прыг,
   {{0x7afd05fa,0x6d45326e,0xa2cd0eb4,0x6375a5b3}},	// [7d70] _vest, _taha, _दृश्, _bánj,
   {{0x645801e2,0x9327003d,0x7afd27d0,0x291eae2e}},	//   _švie, _کردن, _west, ngta_,
   {{0x29016f19,0xb4bb901e,0xf1c800f7,0x62845e45}},	//   raha_, _घरे_, أولى_, azio,
   {{0x69dd343f,0x78b5026f,0x27f88c83,0x6f02826c}},	//   _tuse, _vyzv, árny_, gaoc,
   {{0xa3e30540,0xa3aa009a,0x091480ab,0x69d50061}},	//   _फंड_, खकर_, ত্যু_, _tize,
   {{0xdd9185ff,0x2901461f,0xed56bd93,0x361c01c6}},	//   ضوع_, qaha_, дош_, מודד,
   {{0x403429c9,0x201a00e5,0x98b81c28,0x8c428198}},	//   _перс, cupi_, _parą_, веще,
   {{0x291eea09,0x2b496f1a,0x77b60118,0xdce181a9}},	//   egta_, ndac_, páxi, _dolā,
   {{0x3a290057,0x7bc99de6,0x2bdf82f1,0x0eac0035}},	//   ntap_, rmeu, _पंवा, _टुंड,
   {{0x44278748,0x98bc80eb,0x60099594,0x6f0d0db1}},	//   ptn_, _savā_, оном_, _adac,
   {{0x7d03809e,0x07a60c5c,0xc7a61bc1,0x64418499}},	//   mans, данн, динк, _usli,
   {{0x22498301,0x54349ab3,0x00000000,0x00000000}},	//   _šaku_, _سرمر, --, --,
   {{0x7bde51d7,0xe28edd22,0xfaff0a53,0x2eff8866}},	//   _supu, _ра_, _voël_, _meuf_,
   {{0xa3b611bc,0x7bde234d,0x01c88019,0xdd998176}},	//   _चीज_, _pupu, _فونٹ_, _dwňg_,
   {{0xb4bb83b7,0x6ec200c2,0x2eff92b6,0x2aeb0133}},	//   _घरो_, रेजु, _oeuf_, _ụkọ_,
   {{0x05dd800f,0xd378803a,0x3947b487,0x2eff82be}},	//   मदाब, _kuća_, _hans_, _neuf_,
   {{0x3947dad3,0x6f029c67,0x27ed0088,0x7d0380ef}},	// [7d80] _kans_, vaoc, _čena_, kans,
   {{0x201a6f1b,0x62846f1c,0x63759931,0x1de18105}},	//   tupi_, rzio, _bánk, _पढ़त,
   {{0x7d03ef1d,0x3947a0bc,0x6f029c67,0x83c60468}},	//   dans, _mans_, taoc, _обож,
   {{0x4444073a,0x394795ab,0x9ad3019d,0x20070187}},	//   _is_, _lans_, _dịba, ânia_,
   {{0x6d89003a,0x7d03ef1e,0x66098b67,0x6f028b80}},	//   ržav, fans, _cvek, raoc,
   {{0x7d03a255,0x3947ec94,0x753c6f1f,0xa3e32539}},	//   gans, _nans_, nerz, _फूड_,
   {{0x67240499,0xac9795a9,0x63758032,0x63781b88}},	//   _ocij, ونها_, _kánh, _línm,
   {{0x7644113b,0x753c6f20,0xd3788267,0x5b7b00be}},	//   _osiy, herz, _buća_, ַריא,
   {{0x44440341,0xc298a306,0x753c4145,0x6f0d0a2a}},	//   _ls_, яких_, kerz, _rdac,
   {{0x44446f21,0x7d03ba16,0xd37880c3,0x636e8362}},	//   _os_, cans, _duća_, _cùnr,
   {{0x39479c8d,0x6d5ad80a,0x753c2644,0x7644054e}},	//   _dans_, _inta, derz, _asiy,
   {{0x6d48cf98,0x20118f09,0xf99f02d6,0x657e4290}},	//   _hada, ázia_, _avèl_, _alph,
   {{0x4444073a,0xdb0d07e2,0xa5bb00f7,0x753c01ec}},	//   _as_, llaç, ltói, ferz,
   {{0x6d4a9dba,0x394789ff,0x63adef22,0x637102fe}},	//   ndfa, _gans_, čane, _lånt,
   {{0x45d41f3e,0x1fa71928,0xa5bb00f7,0x6d488fa9}},	//   торс, _ориг, ntói, _mada,
   {{0x6d48ef23,0x645838a3,0x44442863,0x7d03ba16}},	//   _lada, _švic, _ds_, zans,
   {{0x44446f24,0x7d03854e,0x2eff826c,0x69d8a976}},	// [7d90] _es_, yans, _reuf_, _kive,
   {{0xc1788110,0x7c2aa67f,0x2eaa00be,0xca4880ff}},	//   nkė_, ktfr, _משפּ, _mờ_,
   {{0x63a4803a,0x69d88019,0x661d2d5f,0x7d03c6b2}},	//   činj, _mive, lusk, vans,
   {{0x69d8ad08,0x7d03ef25,0x8c1a0158,0x644557ba}},	//   _live, wans, _צורי, _ishi,
   {{0x6d4895e8,0x42790158,0xaaa7081f,0xdd9581e5}},	//   _bada, _זאָג, _कुचक, нады,
   {{0x6d48ef26,0x32091a2e,0x7bcd2daf,0xdb0d0187}},	//   _cada, msay_, lmau, flaç,
   {{0x7d0390fe,0xfc3184e3,0xabd58226,0x69c71dd5}},	//   rans, احت_, нциј, _ihje,
   {{0x3947a264,0x6d5a9a7e,0x7d03ef27,0x661d4f25}},	//   _sans_, _enta, sans, kusk,
   {{0x32096f28,0x7d03843c,0x6d48ef29,0xca48801c}},	//   nsay_, pans, _fada, _cờ_,
   {{0x6d48ef2a,0x64456f2b,0xf99180f7,0x661d6f2c}},	//   _gada, _oshi, طبخ_, dusk,
   {{0x2d83020f,0x7b6784fa,0x644502a0,0x673d6f2d}},	//   dhje_, _отде, _nshi, fesj,
   {{0x7d01a1cb,0x673d02be,0x92bd80ab,0xa3c28128}},	//   _hels, gesj, _আলী_, ूषण_,
   {{0x69c70364,0x753c06da,0x64456e0a,0x44446f2e}},	//   _ohje, terz, _ashi, _ss_,
   {{0x69d8ef2f,0x63bbb6d6,0x7bc6020f,0x44446f30}},	//   _give, llun, _shku, _ps_,
   {{0x44440057,0x64a31b1c,0xdca3188e,0x2905eb68}},	//   _qs_, гара, гари, mala_,
   {{0x2905da00,0x38788bc5,0xbb431597,0x753c0081}},	//   lala_, ørre_, леск, serz,
   {{0x44445a55,0xfce63296,0x644501f6,0x63bb82af}},	// [7da0] _ws_, _попо, _eshi, ilun,
   {{0x2905ef31,0x63bba3cf,0x27e98279,0x64450168}},	//   nala_, hlun, _čanj_, _fshi,
   {{0x44440fa9,0x6d89011f,0x69c700f1,0xc7b90668}},	//   _us_, ržat, _dhje, suđe_,
   {{0xdee695b5,0x6d48b7a5,0xdd200592,0x66e68470}},	//   ходи, _sada, _बाँध_, хода,
   {{0x6d48a9fb,0x63bbef32,0x7d018019,0x61e40372}},	//   _pada, dlun, _bels, qqil,
   {{0x2905a6fd,0x6d48ef33,0xd00a0bda,0xa3d80f97}},	//   jala_, _qada, _неге_, ादक_,
   {{0xc8b50071,0x63a28b67,0x6d48ef34,0x69d88ca9}},	//   _асты, _pjon, _vada, _rive,
   {{0x6d48a480,0x32669e7d,0x69d8e350,0x5a349bb6}},	//   _wada, етов, _sive, внит,
   {{0x6f06188a,0xe1ef84c0,0x7d01ef35,0x7bd99295}},	//   dakc, یسی_, _fels, _diwu,
   {{0x2905ef36,0xfd6901bc,0xdb0d1b01,0x7d01cb65}},	//   gala_, _dapụ, plaç, _gels,
   {{0x69d8c38a,0x63bbef37,0x26c489d1,0x387f0300}},	//   _vive, blun, _hzmo_, _ƙuri_,
   {{0x661d53ac,0x3209472e,0x6722aed0,0xf1b9c861}},	//   tusk, ysay_, ngoj, vuše_,
   {{0x69d88e67,0x2d8300f1,0x7d0194cf,0x6b840079}},	//   _tive, thje_, _yels, dhig,
   {{0xae028076,0x661d098c,0xceb383c8,0xbf0c816f}},	//   रीयन_, rusk, ריש_, हणुन_,
   {{0x61e28364,0x645c8207,0x7bd980a4,0x41c39a37}},	//   _huol, _árid, _yiwu, _حقوق,
   {{0x63a9011f,0x61e2d8ad,0x661d6f38,0x2d8300f1}},	//   čeno, _kuol, pusk, shje_,
   {{0x201eaad4,0x9ad301bc,0xdb1ba359,0x4fd80039}},	// [7db0] luti_, _bịaa, fluê, _אוהב_,
   {{0x644501e9,0x3d1b0006,0x660d113b,0x32093cc0}},	//   _tshi, _बाटे_, _ivak, rsay_,
   {{0xbf0c853e,0x6445310d,0x4ac50076,0x39a4230e}},	//   हणून_, _ushi, लेजव, уштв,
   {{0x29059ce8,0x7d018bc5,0x660d0669,0x29fd80e1}},	//   zala_, _sels, _kvak, yňa_,
   {{0x69c700f1,0x61e2827e,0x2905d019,0x201ea55a}},	//   _thje, _nuol, yala_, huti_,
   {{0x201e8867,0xe4e7835f,0x236900d2,0x29fd80e1}},	//   kuti_, хідн, ljaj_, vňa_,
   {{0xae0286a7,0x2246a190,0xa4938fd3,0x63bbb8c0}},	//   रीबन_, _asok_, دیات, tlun,
   {{0x660d003a,0x2905a01c,0xd9c9800c,0x201e9b68}},	//   _ovak, wala_, रष्ट, duti_,
   {{0x63bb9a21,0x7ae98493,0x7d01ef39,0x29cd0668}},	//   rlun, rcet, _tels, _užas_,
   {{0x63bb80e3,0x7ae98dff,0x3a3900ee,0x201eef3a}},	//   slun, scet, _mpsp_, futi_,
   {{0x2905e6b8,0x7d07026f,0xf99f0205,0x201eb394}},	//   rala_, dajs, _avèk_, guti_,
   {{0x213e831d,0x236900b9,0xc62600ab,0xf42700ab}},	//   aeth_, jjaj_, যবসা_, মবার_,
   {{0x213ea4dc,0x23690253,0xe9ce8fbf,0x81e600ab}},	//   beth_, djaj_, _вк_, _যৌন_,
   {{0x201eef3b,0x2905829b,0x660d219f,0x333f8036}},	//   buti_, qala_, _dvak, leux_,
   {{0x5c150e02,0xab2a1501,0x201e9d36,0x1c3902c7}},	//   льту, мова_, cuti_, нять_,
   {{0x26df804f,0x333f8036,0xbebb0168,0x236f810c}},	//   _nguo_, neux_, rfër, _jogj_,
   {{0xe2975063,0x91e3102f,0xe9da0721,0xbb432457}},	// [7dc0] ват_, иоте, дка_, шетк,
   {{0x6b843403,0x8c960221,0x63a48743,0x29030216}},	//   shig, _армі, čini, _ceja_,
   {{0x29036f3c,0x2d980751,0x63786f3d,0x6d5e2454}},	//   _deja_, mire_, _líni, _inpa,
   {{0x8a062028,0x2d986f3e,0x6d4e0a64,0x637c80e7}},	//   _изме, lire_, ldba, _réno,
   {{0x25fd8b9f,0x25740106,0x6722ef3f,0x29030168}},	//   रीली_, _fält_, rgoj, _feja_,
   {{0x2d986f40,0x6f046f41,0x63758125,0x61e28081}},	//   nire_, _leic, _mánu, _ruol,
   {{0xa2d623bd,0x50c61513,0xdb0401df,0x7c2e6f42}},	//   _मृत्, _वरिष, lliñ, ntbr,
   {{0x61e28364,0x2d982668,0x201eef43,0xe3af80a0}},	//   _puol, hire_, vuti_, يري_,
   {{0x69dc4141,0x2d980b5e,0x2fc90114,0x443a6f44}},	//   _kire, kire_, _rhag_, _lpp_,
   {{0x443a021e,0x61e28098,0x69dc02a3,0xa5458060}},	//   _opp_, _vuol, _jire, _مضمو,
   {{0x660d0025,0x99638071,0x213eef45,0x534681e5}},	//   _svak, ртыл, reth_, _ахла,
   {{0x6d5e1d31,0x61e28009,0xa3e6000f,0x3f86ef46}},	//   _anpa, _tuol, _पढ़_, nhou_,
   {{0x2d983d27,0x69dc2dfb,0x6f040083,0x6b828136}},	//   fire_, _oire, _deic, _ilog,
   {{0xe8549301,0x69dc2266,0x2d9846d6,0xdb11808b}},	//   _منتد, _nire, gire_, ðgön,
   {{0x2903020f,0x6f046f47,0x403482cb,0x6b82806a}},	//   _reja_, _feic, _сейс, _klog,
   {{0x290300a9,0x69dc5163,0x6d5e332c,0x2d9867e8}},	//   _seja_, _aire, _enpa, aire_,
   {{0x28ce8076,0x69dc3637,0x2d98505b,0xf1b98fee}},	// [7dd0] हेरि, _bire, bire_, luša_,
   {{0x69dc1142,0x7c3a93c7,0x6b82c5f7,0x2d983e61}},	//   _cire, _optr, _llog, cire_,
   {{0x290300a9,0xe7198013,0x6b8284be,0x443a1142}},	//   _veja_, فيات_, _olog, _gpp_,
   {{0x4aae0076,0x3f9926cc,0xf770880b,0xdb0401df}},	//   _झुकव, nisu_, يان_, bliñ,
   {{0x7bdd6f48,0x333f80e7,0xb28721f6,0x3ea98722}},	//   _iisu, veux_, _рынк, çat_,
   {{0x64a5896b,0xf1b9807d,0x69dc6f49,0x6b828ab3}},	//   лала, kuša_, _gire, _alog,
   {{0x7bdd0b3f,0xe8d9801c,0x637800f7,0x7aed0037}},	//   _kisu, _đỏ_, _síni, ocat,
   {{0x69dc25a1,0x7aed6f4a,0x2d98620b,0x2a6d009a}},	//   _zire, ncat, zire_, _żeby_,
   {{0xe9d99383,0x7bdd61cd,0x2d9835a7,0x333f82be}},	//   нки_, _misu, yire_, reux_,
   {{0x7bdd3b8b,0x6f0447c8,0x6b82ef4b,0x3b093a46}},	//   _lisu, _seic, _elog, haaq_,
   {{0x93f592b2,0xa3e31513,0x6b82ef4c,0x2d980d19}},	//   _спец, _फूल_, _flog, vire_,
   {{0x2d980e8c,0x7bdd01f7,0x63758511,0xdebb8300}},	//   wire_, _nisu, _cánt, _sauƙ,
   {{0x6f046f4d,0x64576f4e,0x7afb8590,0x7aed6f4f}},	//   _veic, _arxi, mbut, dcat,
   {{0xceb2804c,0x1a9a8158,0x3f86871d,0x4a9a80be}},	//   צים_, _אינע, zhou_, _אינג,
   {{0x2d986f50,0x6f04300a,0xc7b90668,0x7bdd1efb}},	//   rire_, _teic, suđa_, _bisu,
   {{0xe5200074,0x6e3b8035,0x7afbef51,0x25740338}},	//   _बाकि_, _opub, nbut, _päls_,
   {{0x69dc6f52,0x7bdd059c,0x320def53,0x49ca1a02}},	// [7de0] _pire, _disu, nsey_, елан_,
   {{0x6d5e0295,0x7aed0661,0x2d87807a,0x7afb810c}},	//   _unpa, acat, jhne_, hbut,
   {{0x443a5425,0xef1a8ae7,0x3f86879f,0x7649d4f7}},	//   _upp_, еме_, thou_, _asey,
   {{0x7aed0098,0xdc9b012a,0x77bd01df,0x068681a1}},	//   ccat, _טייל, téxi, лген,
   {{0xd5ba8a7f,0x63a40e20,0x3f86867f,0x69dc10b6}},	//   нск_, mnin, rhou_, _tire,
   {{0x63a46f54,0xf9878872,0xc0e31cff,0xa5bb6f55}},	//   lnin, _طب_, _горк, ltór,
   {{0xf98302de,0x6b82ef56,0x7649e9a4,0xf99f02d6}},	//   _угро, _plog, _esey, _avèw_,
   {{0x63a46f57,0x5214867c,0x08770158,0xf1b98668}},	//   nnin, адит, _געלט_, vuša_,
   {{0xe8d98104,0x3f84859c,0x6375c50e,0xa92a81e5}},	//   _đề_, _ilmu_, _ránt, ніне_,
   {{0xdd8f9b9a,0x442c8144,0x7afb9761,0x2d988338}},	//   _فوق_, _tqd_, abut, _öre_,
   {{0x63a4088b,0xc0578d13,0x7aed4f79,0x9f5f0009}},	//   knin, гія_, ycat, ystä_,
   {{0x6b82803b,0xe81c023c,0x63a41a16,0xf1b98289}},	//   _ulog, _पटना_, jnin, ruša_,
   {{0x63a40e23,0x7bdd0698,0x3f990289,0x957c809a}},	//   dnin, _risu, risu_, _ciąg,
   {{0x091a0a49,0xceb3812a,0x7bdd355b,0x63a418d6}},	//   ন্তু_, מיר_, _sisu, enin,
   {{0x7bdd4680,0x64581984,0x7ae2913b,0x63a4007b}},	//   _pisu, _ávil, _kgot, fnin,
   {{0x63a43417,0x98138b76,0x9ad301bc,0x7bc080ee}},	//   gnin, _ابوا, _fịla, nlmu,
   {{0x7aed6f58,0x3171007d,0x7bdd0ca9,0xbda7006b}},	// [7df0] rcat, _pozz_, _visu, _محدو,
   {{0x7aed17d6,0x7bdd6f59,0xdb04007b,0xa5bb6f5a}},	//   scat, _wisu, slið, dróg,
   {{0x7bdd24a0,0x31c40009,0x63a46f5b,0x7aed026c}},	//   _tisu, сств, bnin, pcat,
   {{0xa5bb0c52,0x7ae2e064,0xc7b9026c,0x3b090df6}},	//   ctór, _ngot, brđe_, qaaq_,
   {{0xd2469a00,0x11d900f7,0x44311fdc,0x2d878083}},	//   _بن_, _لوحة_, ltz_, thne_,
   {{0x7ae295c7,0x394e80dd,0x2715801c,0x3f84b36e}},	//   _agot, _nafs_, ền_, _elmu_,
   {{0x44316f5c,0x8bf080ab,0x799aab67,0x7afbb417}},	//   ntz_, _টিউন_, ditw, tbut,
   {{0x63ad95d8,0x69ca92c6,0x61e60380,0x4431011b}},	//   čano, _सीबी, _yukl, itz_,
   {{0xa3d604c5,0x7afb89bf,0x2d87d6a3,0xfaa5ab3f}},	//   िगत_, rbut, phne_, рапо,
   {{0x44236f5d,0x6375803e,0x661d0916,0x7ae28102}},	//   kuj_, _páns, drsk, _egot,
   {{0x63a44729,0xd7a9816f,0x661d1c59,0x2d85ad21}},	//   ynin, _कदाच, ersk, _ille_,
   {{0x201889e9,0x6d43beb0,0x3ebf8637,0x62358c4f}},	//   ária_, lena, _kyut_, _веду,
   {{0x63a46f5e,0x3984016d,0x59c51993,0x443116ee}},	//   vnin, _lösa_, वतार, etz_,
   {{0x6d43803a,0xe2c880e8,0x399b8032,0x443103e1}},	//   nena, _слід_, _dásè_, ftz_,
   {{0x44230063,0xa5070b9c,0x661d368e,0x6da31a19}},	//   guj_, реса_, arsk, цира,
   {{0x61e60503,0x6d4389e8,0x2907a8ee,0x6b9b847f}},	//   _pukl, hena, _hena_, niug,
   {{0x6d43cd15,0x2907ef5f,0x63a42d9a,0x6da600e8}},	// [7e00] kena, _kena_, rnin, _випа,
   {{0x63a4006f,0xa5bb3a2c,0x9f5f0bfa,0x61e61487}},	//   snin, stór, rstå_, _vukl,
   {{0x69c19da2,0x29079f1f,0x63a43f88,0x63780125}},	//   ille, _mena_, pnin, _sínu,
   {{0x2d858d1a,0x2907ef60,0x26178076,0x61e652d7}},	//   _alle_, _lena_, _निशी_, _tukl,
   {{0x2bdf80dc,0x7d0a90fd,0x3a3d82f7,0xf1b981a9}},	//   _पंजा, tafs, _npwp_, jušo_,
   {{0x5e5700be,0x7b3e0035,0x2907ef61,0x660408b1}},	//   יינע_, _dłuż, _nena_, _mwik,
   {{0x98a316d9,0xa0a322f6,0x18a3373a,0xa0670081}},	//   _дире, _дард, _дарм, _кара_,
   {{0x27e0025d,0x2d8586e3,0x6f0b913b,0xd378803b}},	//   _niin_, _elle_, cagc, _kući_,
   {{0x6d4394ff,0xfe0281ce,0x2907aebd,0x0566a21f}},	//   bena, रीशस_, _bena_, _кван,
   {{0x6d4391b9,0x63a90ed6,0x7c3e00e8,0x27e00362}},	//   cena, čeni, _oppr, _aiin_,
   {{0xe8d98142,0x2bdf90d0,0x2907811e,0x3ceb8740}},	//   _để_, _पंचा, _dena_, _चलते_,
   {{0x27e78358,0x7ae28353,0xf1b982a5,0x443e8a87}},	//   _dunn_, _ugot, vrše_, _ipt_,
   {{0x7c3e1162,0x27e02a22,0x2907cd8f,0x6f160428}},	//   _appr, _diin_, _fena_, _ddyc,
   {{0xe7e70076,0x443e80b9,0x442322d5,0x6f160035}},	//   _ओढला_, _kpt_, tuj_, _edyc,
   {{0x290cef62,0x7d08ef63,0xdb09a509,0x25b981a8}},	//   mada_, _meds, cleó, _ísle_,
   {{0x290cbf9a,0x6d43ef64,0x44230f66,0x052700c8}},	//   lada_, zena, ruj_, য়ের_,
   {{0x44236f65,0x29078234,0x6d43e350,0x637c802a}},	// [7e10] suj_, _yena_, yena, _céni,
   {{0x645aa5ca,0x637c83f8,0x63786f66,0x7d088082}},	//   _orti, _déni, _sínt, _neds,
   {{0x6f16031d,0x7b3e009a,0xa3c88fd5,0x6378002a}},	//   _ydyc, _służ, ोगा_, _pínt,
   {{0x290cef67,0x6d4391ee,0x637cdf1a,0x30d980be}},	//   hada_, wena, _féni, אַנע,
   {{0x7d088022,0x98a70459,0xf77091cc,0xbb3a00be}},	//   _beds, ını_, بال_, _גערי,
   {{0xd90f0bca,0x99850013,0x2d9cef68,0x2bdfa4bd}},	//   _آیا_, _السو, give_, _पूजा,
   {{0xeb998ba8,0x290cb241,0x29079651,0x645a9351}},	//   лик_, dada_, _rena_, _crti,
   {{0x2907ef69,0x443e8057,0x672d022c,0x1b49891d}},	//   _sena_, _dpt_, _ncaj, узии_,
   {{0x290cef6a,0x6d43bf83,0x645a810b,0x69c1809f}},	//   fada_, pena, _erti, tlle,
   {{0x8d748307,0x05748250,0x27e010b5,0x6f098708}},	//   _والا, _والد, _siin_, _heec,
   {{0x69c1831d,0x66e659dc,0x6d8a8019,0xb8ef8a27}},	//   rlle, йона, _حملہ_, _शर_,
   {{0x4cd080ab,0x29078234,0x69c1d03e,0x07a60162}},	//   _স্কু, _wena_, slle, самн,
   {{0x290cbf9a,0x2907822e,0x9ad30135,0x201ed819}},	//   bada_, _tena_, _dịka, arti_,
   {{0x61fb8859,0x225e03c1,0x6f09ef6b,0x27e78338}},	//   mpul, _čtk_, _leec, _tunn_,
   {{0x7ff5936d,0xf7f58591,0x673b8365,0x637cc0f7}},	//   _استا, _استد, _obuj, _séni,
   {{0x087680be,0x2d9c92ec,0x637c87bc,0xd3788b80}},	//   _לעצט_, zive_, _péni, _pući_,
   {{0xae1c825e,0x61fbb117,0x224902c4,0x66040ce7}},	// [7e20] _निधन_, npul, gwak_, _uwik,
   {{0x673bda7d,0x186a0eef,0xd378811f,0x39458806}},	//   _abuj, лази_, _vući_, nels_,
   {{0x63ad8805,0x7c3e0ffd,0x6ff38162,0x63780032}},	//   čanj, _uppr, _făce, _dínr,
   {{0x290c8510,0x443e802a,0xdc3b00be,0xcb6a02eb}},	//   zada_, _rpt_, _געטר, _саме_,
   {{0x290c9764,0x2d9cb057,0x39458e61,0x443e810b}},	//   yada_, tive_, kels_, _spt_,
   {{0xa1160416,0x860780f7,0x2d9a00b9,0x13bd00ab}},	//   _دوست, حقوق_, _jmpe_, _আওয়,
   {{0x308600f7,0x2d9c97af,0x3945ef6c,0x6e2602c4}},	//   _الأف, rive_, dels_, hukb,
   {{0x645aa944,0x7d08838e,0x290caad2,0x799e004f}},	//   _vrti, _weds, wada_, lipw,
   {{0x290c9f61,0xdb1be501,0xdb0403d3,0x3945ef6d}},	//   tada_, cluí, rniè, fels_,
   {{0x20188003,0x2166867c,0x99669ad8,0x301495ac}},	//   ário_, стиг, стил, одор,
   {{0xdb0f0019,0x443e86cb,0xc32a80f7,0x645ab187}},	//   ődés, _upt_, _مكان_, _urti,
   {{0x2d9a2444,0x290a6f6e,0x3a200bb1,0xe61f0187}},	//   _ampe_, _leba_, krip_, trô_,
   {{0x290c8852,0x8f9b8039,0x29186431,0x3d0501d0}},	//   pada_, ריכי, _odra_, वरले_,
   {{0x3a205b9e,0x291c0019,0xc69383c8,0x290cab95}},	//   drip_, óval_, לאר_, qada_,
   {{0x499b9a0f,0x3f9d8326,0xa2db54ea,0x96f92f42}},	//   _תשוב, yiwu_, पेन्, _кейт_,
   {{0x764d00a4,0x07a40992,0xec3400e8,0x26120072}},	//   _tsay, _најн, янсь, _तिची_,
   {{0x290a00ce,0x7dcdd03e,0x3a200cfa,0x6f0f6504}},	// [7e30] _beba_, núsc, grip_, macc,
   {{0x3f890069,0x6f098118,0x6f0f4338,0x290a6f6f}},	//   _hlau_, _seec, lacc, _ceba_,
   {{0x290a478b,0xa5bb5dea,0x7bc40196,0x2606a539}},	//   _deba_, prób, bliu, सीसी_,
   {{0xd7c904e5,0xd378803b,0x6d475896,0x657700f1}},	//   रतिच, _kuću_, leja, _hoxh,
   {{0xf7708064,0x7dcd8722,0x6db58b79,0x61ed029a}},	//   عام_, júsc, ойду, qqal,
   {{0xed59b24f,0x6d556f70,0xdb028125,0xce380039}},	//   рок_, ndza, _skoð, צאות_,
   {{0xe7c91199,0x25fd8054,0xb4e58032,0xd7c9016f}},	//   रताप, रीजी_, _afàì, रताच,
   {{0xa2d01d01,0x765b8104,0x69c52906,0x7dc03416}},	//   _दरम्, _truy, llhe, löst,
   {{0x6d472b25,0x6f0f2e88,0x6925943d,0x6458a81c}},	//   keja, dacc, омпа, avvi,
   {{0xe8df8104,0x6d4700dd,0x61fbef71,0x2d8301ed}},	//   _giới_, jeja, rpul, jkje_,
   {{0xa3d9146d,0x6f0f2b10,0x3945bb7c,0x3f895718}},	//   ाषा_, facc, rels_, _blau_,
   {{0x4427ef72,0x6f0f6f73,0x3945ef74,0x3f890722}},	//   mun_, gacc, sels_, _clau_,
   {{0x63bbb24d,0x3945ef75,0x70c61094,0x3f8901c0}},	//   moun, pels_, _वर्ल, _dlau_,
   {{0x6d4723c7,0x63a9ef76,0x63bbef77,0x637c8866}},	//   geja, lnen, loun, _dénu,
   {{0x44279c99,0xfce330bc,0x63a9a391,0x6e26222e}},	//   nun_, доро, onen, sukb,
   {{0x63a9e105,0x6f0f571d,0x6b8d26bc,0xbea634ba}},	//   nnen, cacc, ghag, _майк,
   {{0x44278260,0x6d476f78,0x61ebef79,0x7bc46f7a}},	// [7e40] hun_, beja, _jugl, rliu,
   {{0x44278e59,0x61e384be,0x64418cab,0x602605a8}},	//   kun_, _jinl, _opli, жджа,
   {{0x61eb8698,0x61e3ef7b,0xa2e60012,0x25e30105}},	//   _lugl, _minl, _монд, _टूटी_,
   {{0xe73a9bb1,0x6b8d6f7c,0xddc98063,0x4427be85}},	//   ред_, chag, _treś, dun_,
   {{0x63bb82ba,0x63a980e1,0x290a00e1,0x637c89c4}},	//   doun, dnen, _teba_, _mént,
   {{0xa2dabca9,0x4427ef7d,0x8c430214,0x7c668591}},	//   _पृष्, fun_, ışve, قابل,
   {{0x61eb8125,0x4427a25c,0x69b90a0d,0x0b8a9092}},	//   _augl, gun_, ्तरी, исии_,
   {{0x63bb85db,0x63a98257,0x2fc0022c,0x38608754}},	//   goun, gnen, _nkig_, _čir_,
   {{0x6f02b0f8,0xfbd30039,0x6f0f6f7e,0x224200b9}},	//   mboc, ותה_, vacc, _jpkk_,
   {{0x224200b9,0xba9b007c,0x2fc6a00a,0x63a985ee}},	//   _mpkk_, יספי, llog_, anen,
   {{0x4427d94c,0x6f0f6f7f,0x6c4a8065,0x2fc6d619}},	//   cun_, tacc, _خلاف_, olog_,
   {{0x63bbcc79,0x61eb95f8,0x61e390f6,0x91e68dc7}},	//   coun, _fugl, _einl, _доде,
   {{0x8bd78158,0xa2d686de,0x6d471afe,0xdb0981ec}},	//   _וואו_, मेश्, teja, ließ,
   {{0x63a0d34a,0x3cdc03ca,0x6f0f0653,0x26c500eb}},	//   limn, _गृहे_, sacc, ālo_,
   {{0x672ba496,0x6d476f80,0xfe6e07d2,0x2d836f81}},	//   yggj, reja, نگی_, rkje_,
   {{0x63a0a368,0x6d471d60,0xb4f886b7,0x27fe8101}},	//   nimn, seja, ुरुप_, mptn_,
   {{0x4427d7b3,0x6ce70221,0x51f801bb,0x6d470d8b}},	// [7e50] zun_, _міне, жную_, peja,
   {{0x6e22a19f,0x442790fe,0x63a9abea,0x6b8d6f82}},	//   drob, yun_, znen, shag,
   {{0x63bbbd34,0x7dc012d2,0x2366805c,0x6616026f}},	//   youn, röst, _onoj_, _zvyk,
   {{0x4427e5e5,0x63a9003e,0x2fc6817f,0x4fe80048}},	//   vun_, čens, glog_, імін_,
   {{0xaaf60451,0x4427b4dd,0x63bb81df,0x63a9ef83}},	//   _מזרח_, wun_, voun, vnen,
   {{0x4427ef84,0x6f0d1581,0xf2d203c8,0x61ebef85}},	//   tun_, _leac, _נעם_, _rugl,
   {{0x61e38091,0x1fa7cddf,0x61ebef86,0xfd500133}},	//   _rinl, _драг, _sugl, _achụ,
   {{0x4427ef87,0x6f0d0046,0x64418353,0x61eb8081}},	//   run_, _neac, _vpli, _pugl,
   {{0x26cd8025,0xe29987b6,0x13068009,0x6f1b86ec}},	//   _uzeo_, сап_, чный_, _iduc,
   {{0x442781da,0x61eb817f,0x63a980e1,0x637c802a}},	//   pun_, _vugl, snen, _sént,
   {{0x61e3ef88,0x637c8019,0x7c59803d,0x7dc00019}},	//   _vinl, _pént, _دلار_, zöss,
   {{0x6609d56d,0xe73a2796,0x7b648991,0x6f0d01a8}},	//   _kwek, щем_, _отче, _ceac,
   {{0x6f0d1a29,0xee3722b7,0x987782d4,0x1e832796}},	//   _deac, пня_, _išče_, елям,
   {{0x386a8013,0x6609b0a0,0xf1b981a9,0x645e00c3}},	//   óirí_, _mwek, kuši_, _prpi,
   {{0xaffe8104,0xf1b98029,0x637c81df,0x6f0d032f}},	//   _trướ, juši_, _tént, _feac,
   {{0x6d86807b,0xeb970b9c,0x6f0d6f89,0x66168110}},	//   _aðal, пис_, _geac, šyki,
   {{0xe8d98104,0x66098870,0x6b9d0609,0x6b846f8a}},	// [7e60] _độ_, _nwek, _dmsg, rkig,
   {{0x6f1b802e,0x63a0ef8b,0x645e0bc8,0x7dc48722}},	//   _aduc, zimn, _trpi, pòsi,
   {{0x757b0039,0x98a3116b,0x660993fa,0xdefa862c}},	//   _הטיפ, нифе, _awek, был_,
   {{0x91e61317,0x442a0074,0xdb24004e,0x444401c6}},	//   _номе, mub_, _توحی, _ip_,
   {{0x2fc680c9,0x44380b04,0x645c6f8c,0x83fc80c3}},	//   rlog_, ltr_, lvri, _mrđe,
   {{0x6f1b93a0,0x6f0288f1,0x6e22ef8d,0x44446f8e}},	//   _educ, sboc, rrob, _kp_,
   {{0x443840b2,0x442a0201,0x6609ef8f,0x645c0cab}},	//   ntr_, nub_, _ewek, nvri,
   {{0x44440039,0x20188267,0x660982d6,0xa7a78162}},	//   _mp_, šrik_, _fwek, _екса_,
   {{0x442a4850,0x6f0d1645,0xbebb00f1,0x3f86816b}},	//   hub_, _reac, ngët, mkou_,
   {{0x44440166,0x6f0d154c,0xb603800d,0x442a5658}},	//   _op_, _seac, ášen, kub_,
   {{0x6568ef90,0x4444009a,0xdd8f80f7,0x442a6f91}},	//   _indh, _np_, _حول_, jub_,
   {{0x3f868205,0x442a10b5,0x6d4aef92,0x637c8118}},	//   nkou_, dub_, lefa, _véns,
   {{0x44440f23,0xf1be0a74,0x657a8077,0x54f083eb}},	//   _ap_, ्तान, _koth, _चलाए_,
   {{0x6d4ade84,0xcaa580f7,0x44380789,0x657a85ee}},	//   nefa, _تصمي, ftr_, _joth,
   {{0x69da81ec,0x6f0d3cd7,0x442a2128,0x69c781b9}},	//   mmte, _teac, gub_, ċjet,
   {{0x69c8881a,0x657a8c54,0x6d4ade3a,0xa5bb0ce0}},	//   llde, _loth, hefa, crón,
   {{0x26dd0324,0x290eef93,0x201c0b67,0x2b4904bc}},	// [7e70] _àwo_, _kefa_, švil_, reac_,
   {{0x290e84b9,0x3a2900b9,0x657aca4c,0x442a06ae}},	//   _jefa_, ruap_, _noth, bub_,
   {{0x7bc2c59b,0xdb0d007b,0x3a290359,0x47359a83}},	//   _okou, blað, suap_, днес,
   {{0xb9040592,0x6568803d,0x2d8c811e,0x290eef94}},	//   _पृ_, _andh, _alde_, _lefa_,
   {{0x05960077,0x63ad5646,0xddc9802e,0xe6188558}},	//   _رایگ, mnan, _creş, зді_,
   {{0x657a8ad0,0x290e912e,0x44446f95,0x33f181df}},	//   _coth, _nefa_, _yp_, _páx_,
   {{0x6d5702c1,0x5fbd0076,0x63ad4ac4,0xeb999cad}},	//   _maxa, ईवाल, onan, жий_,
   {{0x63ad6f96,0xe1f999fe,0x3f86827f,0x69c8ccc3}},	//   nnan, оги_, ckou_, elde,
   {{0x6d4a8b40,0x6d570e1b,0x63ad2a1d,0x8e778591}},	//   befa, _oaxa, inan, _عارض,
   {{0x6d570079,0x64455b0c,0xdb00807b,0x442a6f97}},	//   _naxa, _ophi, rnmá, yub_,
   {{0x6d4180f2,0x8af98698,0x61e7002e,0x63ad088b}},	//   _ibla, _днес_, _mijl, knan,
   {{0x4444053e,0x69c8c384,0x637583a8,0x6b830162}},	//   _rp_, alde, _lánz, _îngh,
   {{0x6d572b95,0xceb40201,0xa3b88875,0x2bb880f7}},	//   _baxa, _edən_, _عامر_, _عامة_,
   {{0x7bc983d3,0x442a5f00,0xf0b8803d,0x7bc2801b}},	//   lleu, tub_, _کاهش_, _zkou,
   {{0xef1f0059,0x2905809f,0xf8d18fea,0x61fd00eb}},	//   mkün_, mbla_, _हरिय, _atsl,
   {{0x6d5882a5,0x442a6f98,0x645c1151,0x7e620118}},	//   zdva, rub_, rvri, _áopo,
   {{0x44386f99,0x442a26dc,0xc3328051,0x61e700f3}},	// [7e80] str_, sub_, כון_, _bijl,
   {{0x2617890a,0x44446f9a,0xe9d70c5c,0xf8d186b7}},	//   _निजी_, _tp_, дку_, _हराय,
   {{0x44440add,0x657aa305,0x3f8d80e7,0x3f86826f}},	//   _up_, _roth, _bleu_, tkou_,
   {{0x6d41ef9b,0xddc9802e,0x657aef9c,0x6d4abfb0}},	//   _abla, _preş, _soth, wefa,
   {{0x63a41572,0x6d4aef9d,0x3f86816b,0x69c88257}},	//   miin, tefa, rkou_, ylde,
   {{0xf98784c0,0x7bc2867f,0x3f86cd18,0x63a422d9}},	//   _شب_, _skou, skou_, liin,
   {{0x7bc98114,0x6d58b03e,0xb17680ff,0xf1b9826c}},	//   fleu, rdva, _nhượ, nušu_,
   {{0x290ee841,0x63a41e0e,0x63758b4e,0x6d41d2bc}},	//   _sefa_, niin, _kány, _ebla,
   {{0x657a809f,0x6d4aa3b5,0x998900e1,0x914aa17e}},	//   _toth, pefa, stať_, очна_,
   {{0x63ad09b3,0x66029cb8,0x63a40b8a,0x442a802a}},	//   znan, mpok, hiin, _ªb_,
   {{0x69c884b8,0xb5fd8699,0x63a4443e,0x63758019}},	//   rlde, _vrše, kiin, _lány,
   {{0x59d0000f,0x7bc99c33,0x39580082,0x6d5702a3}},	//   _तीसर, cleu, _lars_, _saxa,
   {{0x63ad19a1,0x63a430e0,0x395802c4,0x6d5701df}},	//   vnan, diin, _oars_, _paxa,
   {{0xea000104,0x395816fb,0xd6d9809a,0x7bc0ef9e}},	//   _xuất_, _nars_, _cały_, lomu,
   {{0x63ad6f9f,0x63a40087,0xb5fd826c,0x69cb8035}},	//   tnan, fiin, _kršc, हतरी,
   {{0x6d576525,0x69d40cce,0x63a419b0,0x7bc0efa0}},	//   _waxa, _बीबी, giin, nomu,
   {{0x6d576fa1,0xdce881d0,0x61e701ed,0xb60401d0}},	// [7e90] _taxa, _podě, _pijl, tvář,
   {{0xc4c4850c,0xef198063,0x66028831,0x63ad6fa2}},	//   _نے_, _może_, dpok, snan,
   {{0x31c41485,0xfe708077,0x27e9010b,0x63a402ec}},	//   тств, یده_, _kian_, biin,
   {{0x660d3c07,0xea00001c,0x8af00085,0x27e96fa3}},	//   _kwak, _suất_, ndəl, _jian_,
   {{0x27e900f7,0xdb0080f7,0x61e70282,0x61fd0b64}},	//   _mian_, cimé, _tijl, _utsl,
   {{0x660d2169,0x6e2bb784,0xc10500f7,0x39586fa4}},	//   _mwak, rugb, _سوري, _gars_,
   {{0x660d0a40,0xf99201c6,0x6fca9e1e,0x6e2b82c4}},	//   _lwak, _גרם_, kých, sugb,
   {{0x58d41e18,0x7bc9efa5,0xa5bb016a,0x29110a03}},	//   _рост, uleu, dróm, _heza_,
   {{0x7bc9efa6,0xb5c98117,0xa5bb2a63,0x26c902d5}},	//   rleu, _فورم_, tról, _nyao_,
   {{0x6d41825b,0x291131a7,0xf99200be,0x2cfb1513}},	//   _ubla, _jeza_, ָרט_, ्रोल_,
   {{0x2cfb023c,0x63a402a3,0x29115e42,0x27e93581}},	//   ्रैल_, yiin, _meza_, _bian_,
   {{0x2b5900f7,0x63ad9620,0xf8b200be,0x1cb8830f}},	//   _nasc_, čans, רשט_, _غالب_,
   {{0xe28eefa7,0x29c28125,0x27e944b9,0x3dc580b9}},	//   _са_, rðar_, _dian_, _kklw_,
   {{0xef1f0065,0x29110578,0x63758b4c,0x44278fb0}},	//   lkül_, _neza_, _rány, orn_,
   {{0xf8c68935,0x205488b0,0x8fa601cf,0x8c4311d2}},	//   _रुपय, _атыр, _паке, лере,
   {{0x27e90104,0x69c1efa8,0x44278834,0xe1fa1b3f}},	//   _gian_, lole, irn_, зга_,
   {{0xa3c08076,0x2911580a,0x63a40df8,0x39586b53}},	// [7ea0] ंकत_, _beza_, riin, _pars_,
   {{0x63bb036f,0x69c1a250,0x63a46fa9,0x291102d0}},	//   čuna, nole, siin, _ceza_,
   {{0x64a65d22,0x39586193,0x6d4e51d6,0x7bc0be7f}},	//   _чана, _vars_, meba, yomu,
   {{0x69c1bee9,0x6d5c2f9c,0x7e6454bb,0xd00f0199}},	//   hole, ldra, _krip, صله_,
   {{0x69c1e5c4,0xe5c6a028,0x7bc664de,0xb8f600c8}},	//   kole, нско, _ikku, _হল_,
   {{0xf3f181bc,0x6d4e6faa,0x7e644ef1,0x29116d4a}},	//   _bụ_, neba, _mrip, _geza_,
   {{0x961d06b7,0x68460009,0x53e68ada,0x7c2e42fc}},	//   _भट्ट_, _янва, нциа, nubr,
   {{0x6d4e6fab,0xddcd0087,0xf99f1ab3,0x29116ce2}},	//   heba, _oraş, _awèh_, _zeza_,
   {{0x7fd780be,0x4427b5ad,0xb5fd8bda,0x6fca816b}},	//   _טולס_, arn_, _vršc, vých,
   {{0x7c96824f,0x6d4e0639,0x69c1efac,0x27e935ad}},	//   _прец, jeba, gole, _sian_,
   {{0x7bc60125,0xa3d005e8,0xddcd0182,0x394ca1f3}},	//   _okku, षता_, _araş, reds_,
   {{0x6d5aefad,0x7e640573,0xb907950e,0xddcd0087}},	//   _hata, _brip, _मृ_, _braş,
   {{0x8f9b8f60,0x63a2b2db,0x3cfd856b,0x657e4206}},	//   ליטי, _imon, रुवे_, _boph,
   {{0x69c1efae,0x63a28069,0x6d5a8b17,0x7bc64575}},	//   cole, _hmon, _jata, _akku,
   {{0x6d5aefaf,0x3ce504b8,0xb5fd8067,0x27e93a20}},	//   _mata, älv_, _mrša, _tian_,
   {{0xa3c0901b,0xa3c285e8,0x5ba4054c,0x29112e4d}},	//   ंकि_, ृति_, груз, _seza_,
   {{0x29116fb0,0x660d3094,0xe1f30bbe,0x63a28609}},	// [7eb0] _peza_, _uwak, اسر_, _mmon,
   {{0x442ebb4f,0x63a28122,0x7bc602ec,0x661b80c3}},	//   kuf_, _lmon, _ekku, _rvuk,
   {{0x63a2efb1,0x2911003a,0x7c2e0511,0x442704be}},	//   _omon, _veza_, cubr, _ín_,
   {{0x6d5ac612,0x69de0580,0x69c1da17,0xda218074}},	//   _aata, ampe, zole, _मिलत_,
   {{0x7bcd3759,0x69c19f62,0xed59b160,0x3b0900b9}},	//   mlau, yole, дол_, mbaq_,
   {{0x64a58bac,0xdca5879e,0x6d5aaa92,0x83fc90d3}},	//   кала, кали, _cata, _srđa,
   {{0x6d5aefb2,0x69c18775,0x7bc6007b,0xe73f02f1}},	//   _data, vole, _ykku, lnõu_,
   {{0x69c19e54,0xc245a2fd,0x7bcd6fb3,0x44278a51}},	//   wole, вник, nlau, rrn_,
   {{0x69c1efb4,0xe9d9b0bc,0x6d4547cb,0x6d5c1a21}},	//   tole, мки_, _obha, ydra,
   {{0x6d5aefb5,0x6b89efb6,0xe8f68b79,0x63a2efb7}},	//   _gata, skeg, кль_, _emon,
   {{0x7bcd3d38,0x443caa23,0xe0cf80ab,0x69c19342}},	//   klau, ctv_, রশ্ন, role,
   {{0x7e643e15,0x6d456d01,0xf0ee009a,0x3984016d}},	//   _prip, _abha, _जल्द_, _höst_,
   {{0x6d5ac478,0x69c18b91,0x98b1817b,0x6d5c1345}},	//   _yata, pole, ızı_, tdra,
   {{0x7afd6fb8,0x443a0187,0xf1b9826c,0x9f4a823e}},	//   _afst, _pqp_, krši_, _rubí_,
   {{0x6d4e6fb9,0x64a301e5,0x6d5c1c11,0x6e3d33fc}},	//   reba, аара, rdra, atsb,
   {{0x7bcd09ed,0x2005efba,0x7afb8abf,0x39841614}},	//   glau, mpli_, ncut, _löst_,
   {{0x6f0907f4,0x6a831ea6,0xcb128158,0xf5060698}},	// [7ec0] ñece, алта, ילן_, _изпо,
   {{0x4c860ddc,0x3cf08035,0x443c9029,0x7afd008b}},	//   _алов, _चलें_, ytv_, _efst,
   {{0x8af00085,0x200586c0,0x7bcd5778,0x38cb0019}},	//   ndək, npli_, blau, وامی_,
   {{0xe7d080c8,0x7bcd6fbb,0x7bc60326,0x34b701c6}},	//   িদ্য, clau, _ukku, _יפים_,
   {{0x6d5ab955,0x442e8859,0xa3bf0105,0x753b2663}},	//   _pata, wuf_, इवर_, đuzv,
   {{0xdb0d02be,0x6d5a865f,0x63a2847f,0x3cfd801b}},	//   nnaî, _qata, _smon, रुले_,
   {{0x6d5a8214,0xb5fd8904,0x71a3087e,0x61ea8ca9}},	//   _vata, _vrša, _тарз, _rifl,
   {{0x6d5aaef4,0x7c839980,0x442e96b2,0x5a349928}},	//   _wata, руше, ruf_, гнит,
   {{0x6d5a9dde,0x442eb26e,0xa92a81e5,0x443c9434}},	//   _tata, suf_, міне_, stv_,
   {{0x69c30353,0xce3782f6,0x443cefbc,0x0e9b8039}},	//   čneg, _באמת_, ptv_, _חשמל,
   {{0x442e80dd,0xb42588ca,0x7d189e1e,0x7e62a2dc}},	//   quf_, _معنو, mavs, lvop,
   {{0x331a8416,0x7f428144,0x7d18d5ee,0x83838198}},	//   _آزاد_, nfoq, lavs, _выше,
   {{0x61eab2bc,0x95cb0073,0x07a401e2,0xdd9101a8}},	//   _tifl, дува_, раўн, موح_,
   {{0x7d188c79,0x6e3d04dc,0xc1be06a7,0x39840338}},	//   navs, rtsb, ्तोग, _möss_,
   {{0x7bcd1a88,0x4992803d,0x3a296fbd,0x6fc28072}},	//   tlau, _میکر, wrap_, षकां,
   {{0xf1b98052,0x69c7035f,0x63bb0805,0x3a29584a}},	//   vrši_, _skje, čuno, trap_,
   {{0x7bcd00e3,0x25f4016f,0x7d188669,0x7f5bbd3e}},	// [7ed0] rlau, ंदणी_, kavs, _rauq,
   {{0x7bcd2270,0xa2a7016f,0xdb00816b,0x661d005f}},	//   slau, _घेण्, dimí, mssk,
   {{0xa2c983bb,0x7d1880d2,0x395cb6f8,0x39840106}},	//   _हुन्, davs, _mavs_, _röst_,
   {{0x7e622944,0x443103bf,0x569595a6,0x2d8101ec}},	//   _šopi, muz_, лает, _hohe_,
   {{0x2d813e8a,0x2a6681c0,0x661d0b81,0x7afb82d0}},	//   _kohe_, _nrob_, nssk, vcut,
   {{0xaac6901c,0xbbcb8ebf,0x69c7021e,0xef1982a6}},	//   _लड़क, ात्क, _ukje, _doża_,
   {{0x44311d3c,0x03a5b33d,0x2d8100b9,0x628683ba}},	//   nuz_, лико, _mohe_, økon,
   {{0x69c500f1,0x2fc901c5,0xdb0402df,0x3869ebdb}},	//   lohe, _nkag_, rniç, _čar_,
   {{0x99159ae5,0xab5b019d,0x7dcd808b,0xe8d980ff}},	//   льні, _akük, húsi, _đố_,
   {{0x7afbb3c4,0x69c500f1,0x661d0370,0x27ed80ff}},	//   scut, nohe, dssk, _hien_,
   {{0xe73a310c,0x27ed81cd,0x5fb797a3,0x3cf0826f}},	//   нен_, _kien_, _अदाल, ňové_,
   {{0x2a66b0f8,0x44310a82,0x27ed81b9,0x39898118}},	//   _frob_, duz_, _jien_, _músi_,
   {{0x63a9efbe,0xa3c089a3,0x61458746,0x69c56fbf}},	//   mien, ंकर_, _бела, kohe,
   {{0x27edd548,0x69c500f1,0x2bcb83eb,0x6289ca91}},	//   _lien_, johe, ातका, myeo,
   {{0x6b96031d,0x44310cdb,0x41cf92c6,0xb5fd8140}},	//   thyg, guz_, _सीएस, _oršo,
   {{0x09be238c,0xe7bb0b04,0x6b8d221b,0x7f860144}},	//   ्त्य, _उदयप, gkag, _póqu,
   {{0xe29719ab,0x6f198063,0x3996013c,0x62898708}},	// [7ee0] гат_, dawc, _læse_, nyeo,
   {{0x63a9e422,0x7a470029,0x44314cc8,0x6604453f}},	//   hien, dītā, buz_, _itik,
   {{0x27edefc0,0x63a986a2,0x6f161c33,0x6bd60872}},	//   _bien_, kien, _keyc, _متحر,
   {{0x63a9efc1,0x6d5e5d7f,0xb5fd812b,0x4b560098}},	//   jien, _hapa, _vršn, _съот,
   {{0x6d5e6fc2,0x63a9de43,0x27ed92f9,0x9cb3003d}},	//   _kapa, dien, _dien_, _نمیت,
   {{0x8e57010f,0x69c54c46,0x6b830087,0x63a9910f}},	//   טינג_, cohe, _îngr, eien,
   {{0x69dc0352,0x6d5e6fc3,0x63a99ed4,0x672402ce}},	//   _ihre, _mapa, fien, _odij,
   {{0x6d5e6fc4,0x27ed8640,0xa2db063a,0x6f0b826c}},	//   _lapa, _gien_, पेक्, cbgc,
   {{0x22400763,0x61ee0239,0x38678118,0x44315447}},	//   ntik_, _kibl, _arnr_, zuz_,
   {{0x6d5e6fc5,0x291a0587,0x6e938013,0x27edaffc}},	//   _napa, napa_, _الكا, _zien_,
   {{0x66041bb7,0xeaaf815b,0x99638190,0x672405f3}},	//   _atik, قعی_, стыл, _bdij,
   {{0x645a8850,0x63a9bf55,0x69c500f1,0x661d20e4}},	//   _isti, cien, zohe, tssk,
   {{0x6d5e0397,0x628990e4,0x4ea7284f,0x395c80eb}},	//   _bapa, cyeo, урна, _tavs_,
   {{0x6b829333,0x2fc68613,0xbf108076,0x4431011e}},	//   _hoog, hoog_, ारुन_, tuz_,
   {{0x6d5e0595,0x66046544,0x6fd6026f,0x291a6fc6}},	//   _dapa, _etik, mácn, dapa_,
   {{0x44315b8d,0x6b82a6dc,0x9b581ac1,0x61ee5e0b}},	//   ruz_, _joog, лист_, _aibl,
   {{0x27ed83d3,0x69c5020f,0x69dc008c,0x6d48efc7}},	// [7ef0] _rien_, tohe, _bhre, _obda,
   {{0x6b8282c1,0x7f5f0201,0x645a981c,0x27ed84df}},	//   _loog, _haqq, _osti, _sien_,
   {{0x69c557ba,0x61ee273c,0x69dc0c41,0x629b81e8}},	//   rohe, _dibl, _dhre, zzuo,
   {{0x69c500f1,0x6d48bd34,0x63a981df,0x547a007c}},	//   sohe, _abda, xien, _סטרו,
   {{0x63a9efc8,0x6d5e07d9,0x27edefc9,0x291a03ac}},	//   vien, _yapa, _vien_, bapa_,
   {{0x201ea638,0x63a98063,0x320917ea,0x61ee63aa}},	//   ksti_, wien, mpay_, _gibl,
   {{0x27edbe28,0x6b82efca,0x63a9c475,0x7a4700eb}},	//   _tien_, _boog, tien, sītā,
   {{0x5f94a80f,0x3b8582ac,0x7f5f02a6,0x4421120b}},	//   _лист, рлиг, _naqq, _mvh_,
   {{0x201ead5c,0xe2999f84,0x320903ec,0x4999835f}},	//   esti_, тап_, npay_, втня_,
   {{0x63a98a4c,0xa9a5997b,0x7e69d68b,0xb5fb0019}},	//   sien, риод, _irep, tván,
   {{0xe8d98104,0x637c8019,0x6fd8a509,0x2240011b}},	//   _đồ_, _lény, líca, ztik_,
   {{0x66e60b01,0x6d5e17b9,0x7e69efcb,0xdee60ab2}},	//   иона, _sapa, _krep, иони,
   {{0x6fd886a5,0x291a1761,0x2d9800f7,0xcaf48065}},	//   níca, yapa_, thre_, _اسمب,
   {{0xceb2804c,0xc0e58381,0xf2d28496,0x32090c0b}},	//   קים_, _колк, _ועד_, dpay_,
   {{0x6d5e0364,0x61ee0024,0x291a0267,0xfce62c38}},	//   _vapa, _ribl, vapa_, рово,
   {{0x6b8282a3,0x6d5e0010,0x291a0010,0x7e698118}},	//   _xoog, _wapa, wapa_, _orep,
   {{0x6d5e6fcc,0x57250013,0xdb0083b0,0x291a25e0}},	// [7f00] _tapa, _طريق, nimá, tapa_,
   {{0x6fd8a509,0x2240011b,0x9d463b4c,0xa06a038b}},	//   díca, rtik_, _теод, каза_,
   {{0x291a0393,0xb5fb026f,0x7e69efcd,0xef1a8073}},	//   rapa_, hvál, _arep, вме_,
   {{0x637c8019,0x291a085c,0x7e2a86b5,0x6fd89984}},	//   _fény, sapa_, віка_, fíca,
   {{0x5de688cc,0x69dc3910,0x764d00b9,0x7f420144}},	//   ажда, _thre, _xpay, _ñoqu,
   {{0x7e69efce,0xe0da0d5f,0x23ba80eb,0xac26983a}},	//   _drep, _авг_, dīja_, афик,
   {{0x20b90364,0x7e69efcf,0xdb09816b,0xe6d3170c}},	//   _быть_, _erep, šnýc, _सर्ज,
   {{0x7d1c6fd0,0x291812ed,0x7ac68f27,0x201e9fb2}},	//   hars, _hera_, испе, vsti_,
   {{0x3a206fd1,0x29186fd2,0x7e699be9,0x1dc61a87}},	//   nsip_, _kera_, _grep, लकात,
   {{0x64a6c3f9,0x7f5f51a8,0x7d1c6b28,0x79838428}},	//   _каза, _saqq, jars, _conw,
   {{0x3f84efd3,0x29180292,0x645aefd4,0xf4878019}},	//   _komu_, _mera_, _usti, _پالی,
   {{0x201eeb17,0x29185122,0x320900e4,0x7f5f2795}},	//   rsti_, _lera_, ypay_, _qaqq,
   {{0x7d1c6fd5,0x6d8b0085,0xdb008118,0x23ba81a9}},	//   fars, _müav, cimá, cīja_,
   {{0x29182005,0x91e3817c,0xdb0401a8,0xd5b80198}},	//   _nera_, _доче, cniú, асс_,
   {{0xb05780f7,0x5fb88651,0x5f7712c8,0xd5b80081}},	//   _نشيط_, ेकाल, _ناظر, рся_,
   {{0x5bb80009,0xa2dd8bb8,0x987b81c6,0x386d01d0}},	//   ался_, _परम्, _ירוק, _čer_,
   {{0x764d105a,0xa90720bb,0x6f1d1d58,0x29181d6a}},	// [7f10] _upay, لبان, masc, _bera_,
   {{0x6f1d1d15,0x69c8c850,0xd1388110,0x69c782d4}},	//   lasc, node, ngą_, čjeg,
   {{0x6d5537a6,0x32090242,0x6ff3802e,0xd37101a8}},	//   meza, spay_, _făcu, _فهد_,
   {{0x7e698c6b,0x637c8019,0x6d5520e2,0x6f1d6fd6}},	//   _prep, _tény, leza, nasc,
   {{0xd37a0158,0x6db28063,0xdb00803e,0x63ad6fd7}},	//   _ערשט, kład, ximá, mian,
   {{0x2918497e,0x63ad00f8,0x98778904,0x6d554881}},	//   _gera_, lian, _ušće_, neza,
   {{0x88e50a49,0xf8e50a49,0xb8950013,0x40950013}},	//   _প্রক, _প্রথ, _الأع, _الأر,
   {{0x1fa496d4,0x63ad0c5a,0x61b183eb,0x7d1c0333}},	//   _друг, nian, ीक्ष, zars,
   {{0x7d1c6fd8,0x6f1d0722,0x6d554d22,0x957c809a}},	//   yars, dasc, keza, _piąt,
   {{0x290110dd,0x63ad6fd9,0x38978201,0x6fd604c3}},	//   ncha_, hian, lərə_, táco,
   {{0xa3d71370,0x63ad1f05,0x2d858042,0x6f1d6fda}},	//   िता_, kian, _iole_, fasc,
   {{0x7d1c6fdb,0x63ad325d,0xd498a276,0x6561efdc}},	//   wars, jian, _тру_, _halh,
   {{0x2d85efdd,0x29012e56,0x69c8efde,0x63ad2ad1}},	//   _kole_, kcha_, bode, dian,
   {{0xb8dd8a49,0x69c89c33,0x799aa5e5,0x6d550542}},	//   _আর_, code, chtw, geza,
   {{0x63ad1390,0x2d85c34d,0x232a44cc,0xab2a1895}},	//   fian, _mole_, лови_, лова_,
   {{0x29186fdf,0x7d1c1ed8,0x73990f88,0x63ad1aae}},	//   _sera_, sars, атус_, gian,
   {{0xa92630e1,0x29186fe0,0x6d556fe1,0x3f848091}},	// [7f20] йдал, _pera_, beza, _romu_,
   {{0x7d1c02ed,0x6443a67f,0x59c7998e,0xf2d28158}},	//   qars, ktni, रकिर, לען_,
   {{0x29180357,0xaaceb2dd,0x237f80ee,0x6443efe2}},	//   _vera_, _हुनक, kjuj_, jtni,
   {{0x29010ac7,0x2d858032,0x291845b7,0x764280e7}},	//   acha_, _aole_, _wera_, ttoy,
   {{0x59c7824c,0x6561a22e,0xdfcf80a0,0x6443d0d8}},	//   रकार, _balh, ريه_, etni,
   {{0xb9960013,0x64438e23,0x29010609,0x656182df}},	//   _السب, ftni, ccha_, _calh,
   {{0x2d858da6,0x3f84827f,0x65618673,0x69c8a771}},	//   _dole_, _tomu_, _dalh, vode,
   {{0x6fb6845b,0x6d551088,0x6b9b9ac4,0x09d08c2d}},	//   _امرا, zeza, ghug, हत्य,
   {{0x656183a7,0x27e68039,0x6b866d37,0x6d555a17}},	//   _falh, mmon_, _mokg, yeza,
   {{0x6f046fe3,0x2918bf95,0x63ad6fe4,0x645e08d8}},	//   _afic, úra_, zian, _ospi,
   {{0x6d55095e,0x69c8efe5,0xb915019d,0x2b8e00e1}},	//   veza, rode, _agbụ_, _tých_,
   {{0x6b9befe6,0x69c8efe7,0x6d555542,0x7d1ae6bf}},	//   chug, sode, weza, _hets,
   {{0x6f1d6fe8,0x41e680e8,0x98b88214,0xeabf046d}},	//   rasc, _ліка, ırı_, _adùn_,
   {{0x63ad009a,0xb606026c,0x27e6ea94,0xe894854c}},	//   wian, dašč, hmon_, _маль,
   {{0x63ad5101,0x291ee5d7,0x7d1a843d,0xfbdf001c}},	//   tian, mata_, _mets, _phê_,
   {{0x291ed5d6,0x27e681a1,0x52150d70,0x6d553328}},	//   lata_, jmon_, ждат, seza,
   {{0x63ad22bf,0x6d550511,0x29016fe9,0x75288035}},	// [7f30] rian, peza, tcha_, _oddz,
   {{0x63ad6835,0x6443efea,0x7e6d6feb,0xf99f0176}},	//   sian, ytni, _irap, _etèn_,
   {{0x290108a9,0x63ad063f,0x6616009a,0x98a781cc}},	//   rcha_, pian, _zwyk, _yanı_,
   {{0x291ec3e3,0x29015297,0x9be40221,0xdcee81d0}},	//   hata_, scha_, _ніяк, žděn,
   {{0x28cf8778,0x15f911bc,0xdce88110,0xbb3a00be}},	//   _सुनि, ंदिर_, _kodė, _דערי,
   {{0x6443efec,0xac09c7f9,0xdb0094c7,0x998001d6}},	//   ttni, анка_, himä, triť_,
   {{0x291ed5fe,0xef198063,0x7d1aefed,0x2fdf8ad0}},	//   data_, _też_, _dets, _thug_,
   {{0x2d8588c4,0x6561836e,0x3163026c,0x6f029bea}},	//   _wole_, _walh, _hajz_, ccoc,
   {{0x0cd606ce,0x291eefee,0x7bc983c9,0x2d85c20b}},	//   _धर्म, fata_, roeu, _tole_,
   {{0x291ea81c,0x6609c9d5,0x6b9b8010,0x89a99505}},	//   gata_, _itek, shug, рков_,
   {{0x6e246477,0x8af00201,0xa2c981d0,0xadf3066f}},	//   _svib, ndər, _हुर्, _इंजन_,
   {{0xe73a3391,0x7e6d09ca,0x35af8105,0x4425826c}},	//   шем_, _brap, _झगड़, _ivl_,
   {{0x291ec400,0x06cd00ab,0x7e6d4480,0xbddb6fef}},	//   bata_, রেসি, _crap, rtèn,
   {{0x7e6d009e,0x291ea87d,0xbddb009f,0x6f1bd399}},	//   _drap, cata_, stèn, _leuc,
   {{0xe8d980ff,0x67298e3a,0x5fc981d0,0xe9b88019}},	//   _đỗ_, _odej, िकाल, _دنوں_,
   {{0x7e6d2246,0xaace816f,0x130a0110,0x6609eff0}},	//   _frap, _हुडक, рнай_, _otek,
   {{0x442580eb,0xeb972d55,0x7e6d10b6,0x26c00118}},	// [7f40] _lvl_, цит_, _grap, _uxio_,
   {{0x3f82005c,0x67298032,0xbddb24df,0xb60655f6}},	//   ljku_, _adej, ntèl, rašč,
   {{0x645e120e,0x7d1a8982,0x44258683,0x6f1b8362}},	//   _uspi, _rets, _nvl_, _beuc,
   {{0x44380cf6,0x291ea9b2,0x7d1ab392,0x6e22eff1}},	//   mur_, zata_, _sets, tsob,
   {{0x291ecca9,0x91e61878,0x443810f5,0x7d1a8461}},	//   yata_, _моме, lur_, _pets,
   {{0x44446ff2,0x27e68286,0x798181c0,0x2007023e}},	//   _kq_, smon_, jjlw, ínic_,
   {{0x44386ff3,0x6f1ba85f,0x645c555f,0x7d1aeff4}},	//   nur_, _feuc, nwri, _vets,
   {{0x2480803a,0x44440098,0x291eeff5,0x7d1a9de6}},	//   ćim_, _mq_, wata_, _wets,
   {{0x44382d68,0x291ed187,0x7d1a8065,0xd2508077}},	//   hur_, tata_, _tets, رند_,
   {{0x44386890,0x7e6d2316,0x44440187,0x59dd86a7}},	//   kur_, _rrap, _oq_, _नीदर,
   {{0x2618090a,0x291edd43,0x7764107f,0x6d589024}},	//   बीसी_, rata_, _baix, meva,
   {{0x7764107f,0x291e96e8,0x7e6d6ff6,0xd36f80f7}},	//   _caix, sata_, _prap, _لهم_,
   {{0x291ee505,0x4444618a,0x35df800f,0x443802be}},	//   pata_, _aq_, _पीड़, eur_,
   {{0x44386ff7,0x6d588006,0x95cb35cc,0x0dcb0767}},	//   fur_, neva, рума_, руми_,
   {{0x44386ff8,0xfbab02a9,0x77641a7d,0x44250333}},	//   gur_, атай_, _faix, él_,
   {{0x2b918104,0x442d1b77,0x69a68c1c,0x81c380ab}},	//   _cách_, če_, टोरी, ্ষণ_,
   {{0xdce881e2,0x8d873cb3,0x291c8088,0x6d58c013}},	// [7f50] _todė, _дунд, _keva_, keva,
   {{0x44380763,0xa2dd8a0d,0x35df800f,0xa5bb002a}},	//   bur_, _परस्, _पीढ़, cróp,
   {{0x6d5899cf,0x291c809f,0xa3cac765,0x2b9c00e1}},	//   deva, _meva_, लका_, _síce_,
   {{0x65656ff9,0x291ceffa,0x9ee980f7,0xb8f30074}},	//   _hahh, _leva_, مفضل_, _हँ_,
   {{0x1d09891c,0xddc45f11,0xa3ab0af3,0x6447067f}},	//   бели_, _hriš, कोण_, ltji,
   {{0x2b9c03bb,0x6d5898d6,0xed599c79,0xce380039}},	//   _více_, geva, сок_, קאות_,
   {{0x6f1b8118,0x44442eaa,0x644701b0,0x61fd0686}},	//   _teuc, _xq_, ntji, _husl,
   {{0x2b91801c,0x291c8118,0x212100dd,0x61f5267c}},	//   _xách_, _aeva_, lahh_, _hizl,
   {{0x6609ba2f,0x60d55958,0x6d58d942,0x44385ed2}},	//   _utek, _hyzm, beva, zur_,
   {{0x291c8012,0x39458765,0x6fd60298,0x6d58a7f5}},	//   _ceva_, чног, máci, ceva,
   {{0x6fd601ac,0x64450069,0x77640ba3,0x6d418085}},	//   láci, _nqhi, _paix, _icla,
   {{0x44386ffb,0xf09200be,0x656543cd,0x6db28035}},	//   vur_, גנט_, _aahh, płac,
   {{0xa5bb6ffc,0x6fd60e14,0x44380077,0x77640722}},	//   tróp, náci, wur_, _vaix,
   {{0x44380cf6,0x2b918028,0x44446ffd,0xa50735aa}},	//   tur_, _sách_, _pq_, зера_,
   {{0x61fd02af,0x444416f0,0x3e5d86c0,0x64590035}},	//   _ausl, _qq_, _lňt_, _ćwic,
   {{0x6fd60e14,0x443812ed,0x61f50029,0x501a8039}},	//   káci, rur_, _aizl, _פופו,
   {{0x44386ffe,0x44440247,0x63bba2a5,0x61f5007e}},	// [7f60] sur_, _wq_, inun, _bizl,
   {{0x44386fff,0x63bb82af,0xdb19819d,0xddc416f2}},	//   pur_, hnun, _akwü, _friš,
   {{0x443800f1,0x6d58d71d,0x9f520032,0xb4fb0039}},	//   qur_, veva, _aiyé_, _לפיי,
   {{0xd9c784e5,0x6d41957a,0xa3d7152c,0x63bb84b7}},	//   रकुट, _acla, ितः_, jnun,
   {{0x6fd66e7c,0x6d58cddb,0xf1bf188b,0xc33302f6}},	//   gáci, teva, _iván_, _אור_,
   {{0xe5a38ba8,0x2fc002ee,0x61f5017b,0x6d4a80e7}},	//   ничи, _ljig_, _gizl, uffa,
   {{0x63bb91f8,0x6d5884c4,0x81c380c8,0x09e321d2}},	//   fnun, reva, ্ষা_, _чорн,
   {{0x291c8813,0x58bb0039,0x48e1016f,0x6d588100}},	//   _seva_, _המלצ, _करतो_, seva,
   {{0xacf68013,0x6d58f000,0x291cb4d5,0x8d1a803d}},	//   _فسات, peva, _peva_, _هزار_,
   {{0xe7d600ab,0x63bbf001,0xd90d803d,0x7d1e6906}},	//   _সংগঠ, anun, لیه_, _neps,
   {{0xd250826a,0xf8be03eb,0x68050084,0x291cbf88}},	//   رنگ_, ्थिय, _kėda, _veva_,
   {{0xd838a329,0x2d8c089c,0x48a78a14,0x6722804f}},	//   ruč_, öden_, ятым_, naoj,
   {{0xbddb02be,0x291c809f,0xb886802a,0xe1ff027d}},	//   stèm, _teva_, _baíñ, _trói_,
   {{0xddc41734,0x7d1e110a,0x25f400dc,0x6aa4026c}},	//   _priš, _ceps, ंदगी_, dzif,
   {{0x6fd60e14,0x58d3acaf,0x28ac54ea,0x38c880d7}},	//   záci, _пошт, _टेलि, _باشی_,
   {{0xb4bd035a,0x61fd01e2,0x644701b0,0x61f503bf}},	//   _अशी_, _pusl, rtji, _sizl,
   {{0x6fdd00e7,0xfb340071,0x672d0091,0x6fd8928a}},	// [7f70] léco, энтэ, _idaj, mích,
   {{0x660d1cb0,0x61f5011c,0x127b80be,0x6fd60298}},	//   _itak, _qizl, זאמע, váci,
   {{0xf9938158,0xe2f900e8,0x4af91317,0x2121008e}},	//   ערע_, _мені_, _меню_, rahh_,
   {{0x6fd60e14,0x290586a5,0x63bb1ba4,0xa5bb0118}},	//   táci, zcla_, čuns, isóm,
   {{0xb8d40663,0x8d7482e3,0x7c288711,0x59bf0a27}},	//   _जे_, کانا, _avdr, ्वदर,
   {{0x6fd60e14,0x660d0010,0xddc98035,0x236900c3}},	//   ráci, _mtak, _speł, ldaj_,
   {{0x22492b24,0x1b2180c8,0x2a6fb59e,0x66e38032}},	//   ltak_, _যাবে_, _srgb_, _bìkí,
   {{0x660d5ee2,0x23697002,0x2b9880e7,0xdfd180f7}},	//   _otak, ndaj_, _déco_, _شيء_,
   {{0x22497003,0x63bb80e3,0x660d5c39,0x6fdd26d5}},	//   ntak_, rnun, _ntak, técn,
   {{0x672d5ba7,0x2fcf90cc,0x38715908,0xf1bf532c}},	//   _adaj, logg_, _krzr_, ्विन,
   {{0x7523b623,0x660d6d2c,0xb88681df,0xa3bf01cb}},	//   manz, _atak, _raíñ, ेवा_,
   {{0x7d1e020f,0x2614800f,0x7523e4cc,0x661b8133}},	//   _seps, नीकी_, lanz, _kwuk,
   {{0xf1bf08af,0x614588cc,0x41bf0fb8,0x59bf0bc2}},	//   ्वान, _жела, ्वास, ्वार,
   {{0x7523f004,0x61fd803e,0xe9ff0104,0xe1ff0063}},	//   nanz, íslu, _hoặc_, _osób_,
   {{0xb886802a,0x660d4b14,0x330b01bc,0x8c43028e}},	//   _vaíñ, _etak, _ụbọ_, кере,
   {{0xee3a0656,0xb4ae035a,0x75238314,0x6b8bafbc}},	//   _дни_, _कधी_, hanz, _jogg,
   {{0x75238e8c,0x6d4f008b,0x6b8be2aa,0x6808928a}},	// [7f80] kanz, únað, _mogg, _věde,
   {{0x6b8b92f1,0x7e647005,0x2366012b,0x99890140}},	//   _logg, _isip, žoj_, traš_,
   {{0x6fd8b074,0x77668098,0x7523f006,0x757b0039}},	//   líci, дълж, danz, _וטיפ,
   {{0x7c3c47f7,0x6b8b8106,0x661b8db1,0x9ec680d7}},	//   murr, _nogg, _bwuk, وزشه,
   {{0x6f09062f,0x7523f007,0xe5c68284,0x5e5a8019}},	//   ñeci, fanz, мско, تجاج_,
   {{0x7523af56,0x6db2809a,0x2b404c46,0x61c780c2}},	//   ganz, ałan, lgic_, रकोष,
   {{0x3e8508cf,0x6b8b8079,0xd94317c8,0x6d5c7008}},	//   _këtë_, _bogg, _шери, iera,
   {{0x16198105,0x2b40026c,0xb5fd81f4,0xc0e314ef}},	//   _नौकर_, ngic_, _pršt, _роск,
   {{0x6d5c6725,0x7523a9da,0x7c3c3fae,0x6fd6002a}},	//   kera, banz, hurr, nácu,
   {{0x7523a784,0xc27b012a,0x7c3c011e,0x3014a59a}},	//   canz, קריי, kurr, ндор,
   {{0x31371a0f,0xe8df8104,0x130a8009,0x7e647009}},	//   ונים_, _thời_, _дней_, _asip,
   {{0x6568bb6a,0x7c3c6504,0x6b8bf00a,0x3f8683ec}},	//   _hadh, durr, _gogg, njou_,
   {{0x4ae28bb8,0x6d5c5866,0xaae28c78,0x6568906a}},	//   _परिव, fera, _परिक, _kadh,
   {{0x6d5c3c42,0x31678352,0x6600973c,0x28cf873c}},	//   gera, _ganz_, _mumk, _सुवि,
   {{0x6568b419,0x0cd400e8,0x7e640234,0x2d8c86f3}},	//   _madh, ворю, _esip, _mode_,
   {{0x69daaa6d,0x22492b24,0x672085f3,0x7523804f}},	//   llte, ttak_, _nemj, zanz,
   {{0x6d5c2aff,0x657a90f4,0x45d51b10,0xe8df801c}},	// [7f90] bera, _onth, _поис, _khởi_,
   {{0x6d5c04b8,0x22490289,0xf77091fb,0x443cdabd}},	//   cera, rtak_, یان_, kuv_,
   {{0xb9070403,0x75238211,0x2249700b,0x69da8014}},	//   _पर_, vanz, stak_, ilte,
   {{0x2d9ed680,0xa3ab1053,0x69da81ec,0x75238314}},	//   _alte_, कोश_, hlte, wanz,
   {{0x75238a5a,0x2d8cdf04,0x6568f00c,0x1d09bb8f}},	//   tanz, _bode_, _badh, пели_,
   {{0x7bc2a264,0x2d8cb5db,0x6b8b8098,0x6db2809a}},	//   _ajou, _code_, _sogg, słan,
   {{0x75238d02,0x6d45022e,0x6fd88e14,0x6b8bb4d7}},	//   ranz, _mcha, zíci, _pogg,
   {{0x61c7885d,0x6d5c0863,0x22158012,0x75239b19}},	//   रक्ष, zera, нфор, sanz,
   {{0x6568f00d,0x7c3c4a6c,0x3e3588ca,0x7523e522}},	//   _fadh, zurr, _سفار, panz,
   {{0x2d8c805f,0x6d45700e,0x6568f00c,0x6d5c700f}},	//   _gode_, _ncha, _gadh, xera,
   {{0x61f8803b,0x6d5c24c0,0xd00e815b,0x7afd0122}},	//   _divl, vera, یلی_, _ogst,
   {{0x6fd8f010,0x6d452738,0x6d5c571c,0x2bac866f}},	//   tíci, _acha, wera, yści_,
   {{0x6fd60feb,0x6e3d0747,0xdb040216,0xa1958110}},	//   dáct, gusb, xniñ, _падч,
   {{0x6145942c,0x7bdbc43e,0x75218061,0x6fd8b666}},	//   _чека, lluu, _jelz, ríci,
   {{0x6d5c7011,0xc4d280be,0x7f5d7012,0x6d453aaa}},	//   rera, ָגן_, besq, _dcha,
   {{0x6d5c7013,0xb4e0035a,0x6d454a96,0xd00e80f7}},	//   sera, _तरी_, _echa, _الي_,
   {{0xfaa34168,0x211a00f7,0xdb0f0061,0x5a0c83de}},	// [7fa0] гато, كتاب_, ájár, ַלאַ,
   {{0xe9d73de7,0x7c3c7014,0x6720df55,0x752181d0}},	//   еку_, purr, _semj, _nelz,
   {{0x3f9fac07,0x6568f015,0xe8df801c,0xd00f00d7}},	//   _bluu_, _radh, _khối_, ملل_,
   {{0xd6d9809a,0xa3de8006,0x67263b0f,0x69d53a8c}},	//   _był_, _दीं_, nakj, _ekze,
   {{0x2d8c956b,0x65688077,0x69d5026c,0xaace81af}},	//   _pode_, _padh, _fkze, _हुंक,
   {{0x63a47016,0xceb300be,0x644af017,0x6568c04b}},	//   lhin, ניג_, ttfi, _qadh,
   {{0x8fa68002,0x2d8ca6fd,0x6fd60019,0xb0cf86a7}},	//   _заве, _vode_, nács, _सुलग,
   {{0x65688f49,0x443cd8e5,0x63a47018,0xddc98087}},	//   _wadh, ruv_, nhin, _preţ,
   {{0x644ad4c2,0x8fa38764,0x6568f019,0x0a0a8133}},	//   stfi, _сате, _tadh, _bụụr,
   {{0xe4d680f7,0x7a5380f7,0x200e808e,0xa2c1001b}},	//   _كتاب, اضيا, _ptfi_, लपत्,
   {{0x63a4701a,0x893703de,0xc95301c6,0x3202136f}},	//   khin, ערטע_, אמת_, _luky_,
   {{0x6d45177a,0xe8df80ff,0x7c2aad91,0x7bdb81b4}},	//   _scha, _chối_, msfr, cluu,
   {{0xd6db50f6,0x63a451c6,0x7c2ad4b6,0x7f5d47e3}},	//   ято_, dhin, lsfr, resq,
   {{0xddc9f01b,0x99800084,0x127b80be,0x31348993}},	//   _kreš, irių_, _מאדע, _рекр,
   {{0x6fd8c07d,0xe0d48158,0x395e9e5e,0x0133853d}},	//   lícu, _בײַ_, mets_, _صعود,
   {{0x395ec923,0xa3ab0063,0x7c33826f,0x3a290144}},	//   lets_, कों_, _údrž, tsap_,
   {{0x27e90364,0x6fd602ba,0x44380083,0x6d450eba}},	// [7fb0] _ihan_, ráct, arr_, _tcha,
   {{0x6d45701c,0x395ef01d,0xa3e791bc,0x442cad38}},	//   _ucha, nets_, _मीन_, _ovd_,
   {{0x6fd882ba,0xbb1b02be,0x3a29701e,0x63a4701f}},	//   hícu, _boît, ssap_, bhin,
   {{0x63a41645,0x2a6681d0,0x7c2ac753,0xdb070198}},	//   chin, _osob_, dsfr, ämät,
   {{0x395ea09b,0x442cb43f,0x9f58823e,0x6d9d8706}},	//   kets_, _avd_, _durà_, _dèan,
   {{0x395e83d3,0x200e0722,0xddc980fe,0x442c8299}},	//   jets_, ífic_, _breš, _bvd_,
   {{0x395e8370,0x7c2aad91,0x27e95885,0xd46685a5}},	//   dets_, gsfr, _ohan_, вище_,
   {{0x58d42103,0x77d780f7,0x27e9001c,0x752181ed}},	//   _сост, _أغسط, _nhan_, _welz,
   {{0x35f58b87,0x272000c8,0xdcfe24a0,0x395e80e7}},	//   _апар, _ভালো_, _uopć, fets_,
   {{0x6fdd03d3,0xe4a7828b,0x6f0d002e,0x395e83a6}},	//   léch, _прео, _afac, gets_,
   {{0x07a60ea6,0xe73a1878,0xddc98025,0x8fa60698}},	//   ванн, мен_, _greš, ване,
   {{0x27e909c5,0x212580dd,0x63a40168,0x6fd88144}},	//   _chan_, salh_, xhin, bícu,
   {{0xe28ea40f,0x27e95ffa,0x59d10c28,0x395ea9c6}},	//   _та_, _dhan_, तकार, bets_,
   {{0x6d43a487,0x3202026f,0x2606041c,0x395ec7e3}},	//   ngna, _ruky_, _vôo_, cets_,
   {{0x63a426c8,0x44380176,0xb5fb0298,0x6d43a639}},	//   thin, urr_, tvár, igna,
   {{0x25e8823c,0x224d8370,0x6b89f020,0x6fd60019}},	//   _चीनी_, otek_, njeg, rács,
   {{0x224d8019,0x442a09d1,0xb5fb0061,0xb1461a47}},	// [7fc0] ntek_, ssb_, rvár, кнал,
   {{0x409614d6,0x63a47021,0xd5af00f7,0x63b6031d}},	//   крет, shin, _وفي_, siyn,
   {{0x69c1dc09,0x98b10214,0xdca609a0,0x657e01a8}},	//   inle, _bazı_, _рани, _inph,
   {{0x224db990,0xee0c8133,0x66040c85,0xd00f0199}},	//   ktek_, _aṅụr, _kuik, زله_,
   {{0x224df022,0x442c816d,0xe5348c73,0x67240a6f}},	//   jtek_, _svd_, гель, _meij,
   {{0x6d4380f2,0xdd8f80f7,0xddc9f023,0x7c2a848d}},	//   ggna, يون_, _preš, tsfr,
   {{0x395e84fe,0x8bc6ad55,0x20034f98,0x6604027c}},	//   vets_, ксид, _guji_, _luik,
   {{0x6fd89220,0x68e33ea8,0x6b89f024,0x442c81ed}},	//   tícu, ünde, gjeg, _vvd_,
   {{0x27e9031d,0x60270019,0x0566813a,0x395e84fe}},	//   _rhan_, _témá, _иван, tets_,
   {{0x27e91cee,0x4973976e,0xddc980eb,0x6fd89727}},	//   _shan_, альс, _treš, rícu,
   {{0x67242151,0x395eecc5,0x6b8982fd,0xb90a800f}},	//   _beij, rets_, bjeg, _मर_,
   {{0x2a668069,0x66042de7,0x69c1f025,0x395ebe88}},	//   _tsob_, _buik, anle, sets_,
   {{0x28d9000f,0x539b82f6,0x395e980a,0x6f0d9727}},	//   _बुनि, _קידו, pets_, ñaci,
   {{0xbbbd0076,0x7bc6076c,0x6604110f,0x61fc00d7}},	//   ्क्क, _ajku, _duik, _nirl,
   {{0x6724184f,0x27e94bc0,0xd40404fa,0xb33b479b}},	//   _feij, _than_, ияти, _alça,
   {{0x200300dd,0x21230267,0x6e2d8267,0xdcfa8609}},	//   _ruji_, _sejh_, šabi, _antċ,
   {{0x61fc0459,0x68e68201,0x98b107c0,0xe5c701e2}},	// [7fd0] _birl, əkda, _razı_, _асно,
   {{0x645ace3c,0x61bf000d,0x20030458,0x6fdd0333}},	//   _opti, ्वेष, _puji_, déci,
   {{0xa5bb01df,0x351a0039,0x224dd382,0xd47900be}},	//   dróx, _אותנ, ztek_, _װאָל,
   {{0xff25803d,0x224d885d,0x2240279e,0x5ecc80ab}},	//   ابای, ytek_, buik_, ়েছে,
   {{0xdd9587ac,0xf77088ca,0x26c98073,0x22840b79}},	//   лады, تال_, çao_, _кург,
   {{0xdce885c5,0x63a2f026,0x6d43820d,0x61fc7027}},	//   _aldı, _alon, ugna, _girl,
   {{0x6d43978e,0x20110102,0x26d282d0,0x6b89f028}},	//   rgna, _utzi_, üyor_, tjeg,
   {{0x2489803a,0x04568013,0x224d8019,0x160300d4}},	//   ćam_, الية_, ttek_, लदार_,
   {{0xe1f9a927,0x63a28197,0x236df029,0x6724702a}},	//   нги_, _dlon, rdej_, _reij,
   {{0x6724702b,0x63a2b392,0x224df02c,0x44210359}},	//   _seij, _elon, rtek_, _owh_,
   {{0x224df02d,0x6b89f02e,0x68458084,0x69c186b1}},	//   stek_, pjeg, ынна, rnle,
   {{0x660406f7,0x290ec26a,0x224d8061,0x6fd88118}},	//   _puik, _effa_, ptek_, lícr,
   {{0x7bd98135,0x4421010c,0x9b74bb76,0x2bc70af3}},	//   _ikwu, _awh_, _خالص, रचना,
   {{0xde031814,0x660335aa,0x8c460187,0x44210239}},	//   спри, спра, леге, _bwh_,
   {{0x672421aa,0x64a31662,0xdca32927,0x657e1029}},	//   _teij, бара, бари, _vnph,
   {{0x644e0004,0x3878813c,0x3996455b,0x61fc702f}},	//   rtbi, ærre_, _læst_, _sirl,
   {{0x3a2d8b50,0x644e364c,0xade3800f,0x77a60118}},	// [7fe0] nsep_, stbi, गतान_, _cóxe,
   {{0x8d6624a4,0x2240038e,0xa3e41a3b,0xc4862e65}},	//   _свое, ruik_, _पीर_, _блок,
   {{0x7e69b13c,0x765badcb,0xf99f023e,0x6fd88118}},	//   _asep, _apuy, _atès_, dícr,
   {{0x7bd98135,0xdd2f81d0,0x69c77030,0x7c2e06b1}},	//   _nkwu, měři, _ejje, msbr,
   {{0x6d410177,0x52e286ae,0xa5bb03a8,0x7e698061}},	//   ólag, _परेस, tróx, _csep,
   {{0x7bc401e2,0x61fc00f7,0xddcd0984,0x6fdd0b2c}},	//   lniu, _uirl, _kraš, réci,
   {{0x7794853d,0x2d9c87dd,0x7e69f031,0x2b9c1029}},	//   _پیشا, rkve_, _esep, _níck_,
   {{0x5a3497f9,0x69d881ac,0x6fdd03a7,0xa3e782f1}},	//   анит, _skve, péci, _मीद_,
   {{0xf1268987,0x6f9380f7,0x399601fa,0x63a2f032}},	//   льно, _القض, _fæst_, _vlon,
   {{0x865b83c8,0xddcd012b,0x776d0079,0x7bd98870}},	//   _אדמי, _oraš, _saax, _ekwu,
   {{0x3f92080a,0x63a280dd,0x61d700be,0x6df381a8}},	//   _boyu_, _tlon, רויף_, _اكلا,
   {{0xb8ec800f,0x7c2e013c,0xdb0d0187,0xdfd50049}},	//   _रख_, dsbr, miaç, ромы,
   {{0xdb0d00a9,0x2216cb8d,0x9f92007b,0xef1f0061}},	//   liaç, _сфер, ráð_, ljük_,
   {{0x290e80e5,0x776d01b4,0x2bcc8f1b,0xcad781c6}},	//   _uffa_, _waax, ावका, _עוגת_,
   {{0x2b9c0028,0xd37b47f9,0x7c2e21b4,0x11db8039}},	//   _kích_, нча_, gsbr, _רחוב,
   {{0xddcd0390,0xdce884e8,0xc2c501a8,0x7bc4524c}},	//   _draš, _nadč, ليزي, gniu,
   {{0x7762c03b,0x52e286a7,0x0ce1a207,0x5edc066f}},	// [7ff0] deox, _परोस, _फर्म, _गुप्_,
   {{0xa2c5801b,0xdb0081a8,0xdcfa82d6,0x5f5d0135}},	//   ापत्, dhmí, _antč, _ọnụọ,
   {{0xddcd2944,0x765b808e,0x315783de,0xe1e50072}},	//   _graš, _spuy, ריבן_, _कठीण_,
   {{0x2d93062f,0xbddb00e7,0x0eb9827e,0xdb0d3007}},	//   _hoxe_, ctèr, кулы_, diaç,
   {{0x366986eb,0xe80b8a27,0xddcd0af8,0x752a8299}},	//   тало_, _संभा_, _zraš, fafz,
   {{0xed598a29,0x6d476890,0x51872240,0x2d93011b}},	//   ток_, ngja, _сума, _joxe_,
   {{0x6fdd087a,0xcd980039,0x2b9c00ff,0x69d703a8}},	//   lécu, רדות_, _bích_, moxe,
   {{0x6b8d010b,0x69d7002a,0xa0c401a8,0x69c68061}},	//   njag, loxe, _ايفو, éken,
   {{0x69c51585,0x7c24826c,0x386081a1,0x49c9917e}},	//   onhe, ćira, _ćira_, клин_,
   {{0x69c5236c,0x499594c4,0x672bf033,0x6b8d440f}},	//   nnhe, ршит, lagj, hjag,
   {{0xdd7a8158,0xdb0d03a7,0x27ed801c,0x6563c590}},	//   _שטעל, ciaç, _khen_, menh,
   {{0xc5e90039,0x6e2d826c,0x7bd98870,0xdd2f81d0}},	//   _חד_, šabu, _ukwu, věři,
   {{0x6443a250,0x539a8039,0x2d937034,0x63a9808b}},	//   luni, _שינו, _boxe_, mhen,
   {{0x7c2e0448,0xddcd12b9,0x64a601e5,0x6563f035}},	//   tsbr, _praš, аага, nenh,
   {{0xab2a3210,0x1c3902c7,0x6443d958,0x232a20bf}},	//   кова_, лять_, nuni, кови_,
   {{0x920712c7,0x63a98956,0x63bbf036,0xda0880ff}},	//   _वंशज_, nhen, niun, _hỏa_,

  };
  // table_hash = 1305-8978, unused_entries = 116 (0.07%)

static const uint32 kQuadChrome0122_16SizeOne = 28727;  // One-langprob count
static const uint32 kQuadChrome0122_16IndSize = 28727;  // Largest subscript
static const uint32 kQuadChrome0122_16Ind[kQuadChrome0122_16IndSize] = {
  // [0000]
  0x00000000, 0x00000000, 0x08040709, 0x00000a24,   // -- --  bg.ru.uk_444 mk.un.un_900
  0x06000c13, 0x1a6b1cee, 0x0000131c, 0x04523508,   // sv.de.un_650 id.ceb.tl_422  et.un.un_800 zu.ha.fi_443
  0x236e05ec, 0x00000415, 0x2d162908, 0x03003f08,   // fr.hmn.ca_644 fi.un.un_700  sl.hr.sk_443 af.nl.un_430
  0x1c090daf, 0x00000d1c, 0x281e1c05, 0x13000914,   // ne.hi.mr_655 ne.un.un_800  id.ms.sw_333 hi.bh.un_660
  // [0010]
  0x00002815, 0x21520ea4, 0x0000111c, 0x0000181c,   // sw.un.un_700 is.ha.jw_433  ro.un.un_800 ga.un.un_800
  0x0000271c, 0x02212013, 0x06030ca4, 0x1f2864af,   // gd.un.un_800 sq.jw.da_665  sv.nl.de_433 lg.sw.cy_655
  0x05190b08, 0x00001215, 0x25131a07, 0x00000d15,   // es.gl.fr_443 hu.un.un_700  tl.et.eu_432 cs.un.un_700
  0x00002b15, 0x64005219, 0x11000721, 0x11001f18,   // vi.un.un_700 ha.lg.un_750  it.ro.un_860 cy.ro.un_740
  // [0020]
  0x19000b08, 0x00000724, 0x0000021c, 0x09000d21,   // es.gl.un_430 bg.un.un_900  da.un.un_800 ne.hi.un_860
  0x3216170e, 0x17163214, 0x11356805, 0x211611ee,   // sr.hr.bs_555 bs.hr.sr_666  ig.zu.ro_333 ro.hr.jw_422
  0x00002b1c, 0x00000f1c, 0x00001903, 0x64075204,   // vi.un.un_800 lv.un.un_800  gl.un.un_300 ha.it.lg_332
  0x0309060c, 0x040810ee, 0x00001115, 0x09003f0d,   // de.pl.nl_543 be.uk.ru_422  ro.un.un_700 af.pl.un_540
  // [0030]
  0x16092d5a, 0x0e0307a0, 0x00004a06, 0x55005308,   // sk.pl.hr_553 it.nl.is_322  yo.un.un_400 ht.rw.un_430
  0x21001e05, 0x0000090f, 0x0000050a, 0x00000701,   // ms.jw.un_330 pl.un.un_600  fr.un.un_500 it.un.un_200
  0x00002d1c, 0x00000115, 0x32171614, 0x32161714,   // sk.un.un_800 iw.un.un_700  hr.sr.bs_666 sr.hr.bs_666
  0x18002723, 0x00002115, 0x2d000d1b, 0x211812af,   // gd.ga.un_880 fa.un.un_700  cs.sk.un_770 ur.ar.fa_655
  // [0040]
  0x64351aad, 0x0000520f, 0x171632a4, 0x25196ba0,   // tl.zu.lg_643 ha.un.un_600  bs.hr.sr_433 ceb.gl.eu_322
  0x08030208, 0x532b1f0c, 0x00002724, 0x1b321704,   // da.nl.no_443 cy.vi.ht_543  gd.un.un_900 sr.bs.tr_332
  0x00001006, 0x0400110c, 0x0000080f, 0x2a1220a7,   // be.un.un_400 ro.ru.un_530  no.un.un_600 sq.hu.mt_532
  0x00000124, 0x0e210804, 0x21001213, 0x0000280f,   // en.un.un_900 no.jw.is_332  ur.fa.un_650 sw.un.un_600
  // [0050]
  0x06030cad, 0x0000011c, 0x1716320e, 0x35060a0c,   // sv.nl.de_643 en.un.un_800  bs.hr.sr_555 pt.de.zu_543
  0x09001307, 0x3b3117a0, 0x08040708, 0x1e001c14,   // bh.hi.un_420 sr.az.so_322  bg.ru.uk_443 id.ms.un_660
  0x2d092507, 0x1b00311a, 0x6b1011ec, 0x52352808,   // eu.pl.sk_432 az.tr.un_760  ro.lt.ceb_644 sw.zu.ha_443
  0x3217160e, 0x0000351c, 0x130d0912, 0x02000808,   // hr.sr.bs_555 zu.un.un_800  hi.ne.bh_654 no.da.un_430
  // [0060]
  0x211812ad, 0x0000120f, 0x042125ee, 0x0000091c,   // ur.ar.fa_643 hu.un.un_600  eu.jw.fi_422 pl.un.un_800
  0x12001822, 0x0000121c, 0x4a006e08, 0x321617af,   // ar.ur.un_870 hu.un.un_800  hmn.yo.un_430 sr.hr.bs_655
  0x27001822, 0x00006e15, 0x0000020f, 0x181221af,   // ga.gd.un_870 hmn.un.un_700  da.un.un_600 fa.ur.ar_655
  0x10110408, 0x17080408, 0x11253508, 0x0c08020d,   // ru.ro.be_443 ru.uk.sr_443  zu.eu.ro_443 da.no.sv_554
  // [0070]
  0x0f006e0c, 0x00001001, 0x00001c0f, 0x00000a15,   // hmn.lv.un_530 be.un.un_200  mr.un.un_600 pt.un.un_700
  0x00001315, 0x1c001307, 0x1c001305, 0x0000211c,   // bh.un.un_700 bh.mr.un_420  bh.mr.un_330 jw.un.un_800
  0x080225ee, 0x00003b15, 0x0000290f, 0x00000e15,   // eu.da.no_422 so.un.un_700  sl.un.un_600 is.un.un_700
  0x0100240d, 0x171632a9, 0x31001b13, 0x0704080d,   // yi.iw.un_540 bs.hr.sr_544  tr.az.un_650 uk.ru.bg_554
  // [0080]
  0x1f002a13, 0x0000070f, 0x0c080214, 0x1800271a,   // mt.cy.un_650 bg.un.un_600  da.no.sv_666 gd.ga.un_760
  0x0000100f, 0x00003115, 0x00003124, 0x0000110f,   // be.un.un_600 az.un.un_700  az.un.un_900 ro.un.un_600
  0x00001703, 0x311b03a9, 0x64006e07, 0x00000e0f,   // sr.un.un_300 nl.tr.az_544  hmn.lg.un_420 is.un.un_600
  0x2700181b, 0x17003204, 0x00001c01, 0x11040705,   // ga.gd.un_770 bs.sr.un_320  id.un.un_200 bg.ru.ro_333
  // [0090]
  0x27001814, 0x00004a0f, 0x2a281804, 0x31080c08,   // ga.gd.un_660 yo.un.un_600  ga.sw.mt_332 sv.no.az_443
  0x120c08af, 0x011a29a4, 0x080c3507, 0x520164ee,   // no.sv.hu_655 sl.tl.en_433  zu.sv.no_432 lg.en.ha_422
  0x00000715, 0x2a3b5307, 0x00000915, 0x16320d0c,   // bg.un.un_700 ht.so.mt_432  pl.un.un_700 cs.bs.hr_543
  0x00001a15, 0x320f0305, 0x08005308, 0x00002315,   // tl.un.un_700 nl.lv.bs_333  ht.no.un_430 ca.un.un_700
  // [00a0]
  0x21001819, 0x080a1707, 0x190b0aa4, 0x552132a0,   // ar.fa.un_750 sr.mk.uk_432  pt.es.gl_433 bs.jw.rw_322
  0x0000521c, 0x130d09af, 0x04253508, 0x10041ca0,   // ha.un.un_800 hi.ne.bh_655  zu.eu.fi_443 id.fi.lt_322
  0x0827180c, 0x00000a1c, 0x05042aa0, 0x00000b15,   // ga.gd.no_543 pt.un.un_800  mt.fi.fr_322 bn.un.un_700
  0x10080c0c, 0x00002524, 0x0a1707a9, 0x070a04af,   // sv.no.lt_543 eu.un.un_900  bg.sr.mk_544 ru.mk.bg_655
  // [00b0]
  0x3f03280d, 0x101120a9, 0x08020eaf, 0x07000a1a,   // sw.nl.af_554 sq.ro.lt_544  is.da.no_655 mk.bg.un_760
  0x00005515, 0x2d130855, 0x04110712, 0x21001218,   // rw.un.un_700 no.et.sk_442  bg.ro.ru_654 ur.fa.un_740
  0x35002812, 0x00001e01, 0x13090da9, 0x1a003522,   // sw.zu.un_640 ms.un.un_200  ne.hi.bh_544 zu.tl.un_870
  0x13090dec, 0x3f130313, 0x00002415, 0x080417af,   // ne.hi.bh_644 nl.et.af_665  yi.un.un_700 sr.ru.uk_655
  // [00c0]
  0x272821a9, 0x2508060c, 0x13000905, 0x00001601,   // jw.sw.gd_544 de.no.eu_543  hi.bh.un_330 hr.un.un_200
  0x07170a13, 0x070a10ee, 0x06002504, 0x2d003b04,   // mk.sr.bg_665 be.mk.bg_422  eu.de.un_320 so.sk.un_320
  0x00000b1c, 0x03003f1a, 0x17040aec, 0x181a6bad,   // bn.un.un_800 af.nl.un_760  mk.ru.sr_644 ceb.tl.ga_643
  0x3f040512, 0x16003207, 0x321716a4, 0x13000922,   // fr.fi.af_654 bs.hr.un_420  hr.sr.bs_433 hi.bh.un_870
  // [00d0]
  0x20004a0e, 0x28055304, 0x17163205, 0x20002522,   // yo.sq.un_550 ht.fr.sw_332  bs.hr.sr_333 eu.sq.un_870
  0x1c000909, 0x2100121a, 0x04001119, 0x0000210f,   // hi.mr.un_440 ur.fa.un_760  ro.ru.un_750 fa.un.un_600
  0x03023fa0, 0x0e000813, 0x532801a4, 0x20252804,   // af.da.nl_322 no.is.un_650  en.sw.ht_433 sw.eu.sq_332
  0x1c1309ec, 0x1e001c02, 0x536428ee, 0x2a000705,   // hi.bh.mr_644 id.ms.un_220  sw.lg.ht_422 it.mt.un_330
  // [00e0]
  0x10040107, 0x00002d0f, 0x17040813, 0x06000e08,   // en.fi.lt_432 sk.un.un_600  uk.ru.sr_665 is.de.un_430
  0x00001a06, 0x00000703, 0x3510010c, 0x0000050f,   // tl.un.un_400 it.un.un_300  en.lt.zu_543 fr.un.un_600
  0x00000815, 0x04070a09, 0x0e25100c, 0x00000f15,   // uk.un.un_700 mk.bg.ru_444  lt.eu.is_543 lv.un.un_700
  0x0e00020d, 0x01000608, 0x00001e03, 0x52000104,   // da.is.un_540 de.en.un_430  ms.un.un_300 en.ha.un_320
  // [00f0]
  0x1b3531ad, 0x00002015, 0x00000c15, 0x0000030f,   // az.zu.tr_643 sq.un.un_700  sv.un.un_700 nl.un.un_600
  0x25042907, 0x18006b04, 0x00002824, 0x00001815,   // sl.fi.eu_432 ceb.ga.un_320  sw.un.un_900 ar.un.un_700
  0x28000104, 0x13641a0c, 0x32003507, 0x6b061fa0,   // en.sw.un_320 tl.lg.et_543  zu.bs.un_420 cy.de.ceb_322
  0x00005203, 0x1800352c, 0x32171602, 0x00002b0f,   // ha.un.un_300 zu.ga.un_990  hr.sr.bs_222 vi.un.un_600
  // [0100]
  0x04001309, 0x00001c06, 0x00002515, 0x0a070407,   // et.fi.un_440 id.un.un_400  eu.un.un_700 ru.bg.mk_432
  0x00002b24, 0x1300090e, 0x00000c0a, 0x1c090da4,   // vi.un.un_900 hi.bh.un_550  sv.un.un_500 ne.hi.mr_433
  0x35285509, 0x1a556ba6, 0x04001e04, 0x1e001c0e,   // rw.sw.zu_444 ceb.rw.tl_521  ms.fi.un_320 id.ms.un_550
  0x00002101, 0x282a180d, 0x556410a4, 0x01002413,   // jw.un.un_200 ga.mt.sw_554  lt.lg.rw_433 yi.iw.un_650
  // [0110]
  0x00001015, 0x4a1b1007, 0x10000822, 0x0a0407ec,   // lt.un.un_700 lt.tr.yo_432  uk.be.un_870 bg.ru.mk_644
  0x00001f15, 0x00001603, 0x1c320da0, 0x00001224,   // cy.un.un_700 hr.un.un_300  cs.bs.id_322 ur.un.un_900
  0x00001901, 0x10641104, 0x16002904, 0x0000250f,   // gl.un.un_200 ro.lg.lt_332  sl.hr.un_320 eu.un.un_600
  0x0000310f, 0x1c556804, 0x0000251c, 0x32171605,   // az.un.un_600 ig.rw.id_332  eu.un.un_800 hr.sr.bs_333
  // [0120]
  0x31080ea0, 0x641355ad, 0x00006b06, 0x00003f03,   // is.no.az_322 rw.et.lg_643  ceb.un.un_400 af.un.un_300
  0x211218af, 0x00000e1c, 0x64003514, 0x091c13a4,   // ar.ur.fa_655 is.un.un_800  zu.lg.un_660 bh.mr.hi_433
  0x13000908, 0x00002b0a, 0x01002419, 0x32171609,   // hi.bh.un_430 vi.un.un_500  yi.iw.un_750 hr.sr.bs_444
  0x311b0408, 0x1b1f1a04, 0x27351b07, 0x040810a9,   // fi.tr.az_443 tl.cy.tr_332  tr.zu.gd_432 be.uk.ru_544
  // [0130]
  0x350e1b08, 0x1c352105, 0x16002919, 0x0000680f,   // tr.is.zu_443 jw.zu.id_333  sl.hr.un_750 ig.un.un_600
  0x0a0411af, 0x00006815, 0x35004a05, 0x1e0208a4,   // ro.ru.mk_655 ig.un.un_700  yo.zu.un_330 no.da.ms_433
  0x01321704, 0x0a071714, 0x170a0708, 0x55686407,   // sr.bs.en_332 sr.bg.mk_666  bg.mk.sr_443 lg.ig.rw_432
  0x00000215, 0x1b25350b, 0x25006b09, 0x0e351b12,   // da.un.un_700 zu.eu.tr_542  ceb.eu.un_440 tr.zu.is_654
  // [0140]
  0x32001602, 0x2a186b0c, 0x00002b2d, 0x0706310c,   // hr.bs.un_220 ceb.ga.mt_543  vi.un.un_A00 az.de.it_543
  0x00000b01, 0x270e1b60, 0x64006807, 0x20005304,   // es.un.un_200 tr.is.gd_664  ig.lg.un_420 ht.sq.un_320
  0x2d123b07, 0x0d01030c, 0x1c000b02, 0x55131005,   // so.hu.sk_432 nl.en.cs_543  es.id.un_220 lt.et.rw_333
  0x04001007, 0x281a130c, 0x1b0e2509, 0x08110407,   // be.ru.un_420 et.tl.sw_543  eu.is.tr_444 fi.ro.no_432
  // [0150]
  0x10000419, 0x13000b04, 0x04000a07, 0x0400081b,   // fi.lt.un_750 es.et.un_320  mk.ru.un_420 uk.ru.un_770
  0x1800211a, 0x0c251b0c, 0x0c052a05, 0x03005507,   // fa.ar.un_760 tr.eu.sv_543  mt.fr.sv_333 rw.nl.un_420
  0x0000241c, 0x0000242d, 0x35051b0c, 0x1200211a,   // yi.un.un_800 yi.un.un_A00  tr.fr.zu_543 fa.ur.un_760
  0x09000d05, 0x1e001c07, 0x4a006822, 0x4a3f030c,   // ne.hi.un_330 id.ms.un_420  ig.yo.un_870 nl.af.yo_543
  // [0160]
  0x08001022, 0x0d172dee, 0x0000110a, 0x0000080a,   // be.uk.un_870 sk.sr.cs_422  ro.un.un_500 no.un.un_500
  0x20283507, 0x172d29a4, 0x023f035a, 0x25351b12,   // zu.sw.sq_432 sl.sk.sr_433  nl.af.da_553 tr.zu.eu_654
  0x0000200f, 0x311b3504, 0x19000b02, 0x2d000d0e,   // sq.un.un_600 zu.tr.az_332  es.gl.un_220 cs.sk.un_550
  0x0a040804, 0x00000c0f, 0x3f003b02, 0x00001c15,   // uk.ru.mk_332 sv.un.un_600  so.af.un_220 mr.un.un_700
  // [0170]
  0x13040ea0, 0x07080408, 0x0d1b0e0c, 0x556b2807,   // is.fi.et_322 ru.uk.bg_443  is.tr.cs_543 sw.ceb.rw_432
  0x0000180a, 0x06001809, 0x00005301, 0x12000e0d,   // ar.un.un_500 ga.de.un_440  ht.un.un_200 is.hu.un_540
  0x04001711, 0x00001b24, 0x04000723, 0x31001b1b,   // sr.ru.un_630 tr.un.un_900  bg.ru.un_880 tr.az.un_770
  0x0a0417a4, 0x10000a0c, 0x12002120, 0x17163202,   // sr.ru.mk_433 pt.lt.un_530  fa.ur.un_850 bs.hr.sr_222
  // [0180]
  0x12002113, 0x1300042b, 0x1b00311b, 0x4a6b6804,   // fa.ur.un_650 fi.et.un_980  az.tr.un_770 ig.ceb.yo_332
  0x090a13ee, 0x04070a0c, 0x08000c13, 0x00000a0a,   // et.pt.pl_422 mk.bg.ru_543  sv.no.un_650 pt.un.un_500
  0x08040a0c, 0x0c060e07, 0x0a190b04, 0x04081705,   // mk.ru.uk_543 is.de.sv_432  es.gl.pt_332 sr.uk.ru_333
  0x12006408, 0x12000a09, 0x00005503, 0x00005506,   // lg.hu.un_430 pt.hu.un_440  rw.un.un_300 rw.un.un_400
  // [0190]
  0x04001008, 0x17000a0d, 0x0000060a, 0x0000112d,   // be.ru.un_430 mk.sr.un_540  de.un.un_500 ro.un.un_A00
  0x112a010b, 0x17000a19, 0x0000100a, 0x00002a03,   // en.mt.ro_542 mk.sr.un_750  be.un.un_500 mt.un.un_300
  0x0000040f, 0x18002113, 0x11002804, 0x0e080cad,   // fi.un.un_600 fa.ar.un_650  sw.ro.un_320 sv.no.is_643
  0x2d000c04, 0x00006806, 0x64002805, 0x21001221,   // sv.sk.un_320 ig.un.un_400  sw.lg.un_330 ur.fa.un_860
  // [01a0]
  0x1100041a, 0x00001701, 0x0d000905, 0x0c08020e,   // ru.ro.un_760 sr.un.un_200  hi.ne.un_330 da.no.sv_555
  0x040a1704, 0x311e1c04, 0x641e2807, 0x2100070d,   // sr.mk.ru_332 id.ms.az_332  sw.ms.lg_432 it.jw.un_540
  0x0000180f, 0x00000f0f, 0x091c1312, 0x1c001308,   // ar.un.un_600 lv.un.un_600  bh.mr.hi_654 bh.mr.un_430
  0x00002d15, 0x18001212, 0x1700110d, 0x1c0913ac,   // sk.un.un_700 ur.ar.un_640  ro.sr.un_540 bh.hi.mr_632
  // [01b0]
  0x00003f15, 0x0b230507, 0x0a0408ad, 0x05002305,   // af.un.un_700 fr.ca.es_432  uk.ru.mk_643 ca.fr.un_330
  0x00003b0f, 0x08001009, 0x1c0913af, 0x033f13ad,   // so.un.un_600 be.uk.un_440  bh.hi.mr_655 et.af.nl_643
  0x041005a4, 0x00002a15, 0x27001f05, 0x04001013,   // fr.lt.fi_433 mt.un.un_700  cy.gd.un_330 be.ru.un_650
  0x0000680a, 0x122118ec, 0x07642a0e, 0x21001c08,   // ig.un.un_500 ar.fa.ur_644  mt.lg.it_555 id.jw.un_430
  // [01c0]
  0x00006e06, 0x07002a22, 0x04001322, 0x6400352a,   // hmn.un.un_400 mt.it.un_870  et.fi.un_870 zu.lg.un_970
  0x13090d14, 0x00006e1c, 0x0000010f, 0x13003b12,   // ne.hi.bh_666 hmn.un.un_800  en.un.un_600 so.et.un_640
  0x321629a9, 0x352018a4, 0x19000b07, 0x090d1caf,   // sl.hr.bs_544 ga.sq.zu_433  es.gl.un_420 mr.ne.hi_655
  0x31001b12, 0x00002a24, 0x09001313, 0x040a0705,   // tr.az.un_640 mt.un.un_900  bh.hi.un_650 bg.mk.ru_333
  // [01d0]
  0x00000d0f, 0x1f3f27a4, 0x13091ca9, 0x55006422,   // cs.un.un_600 gd.af.cy_433  mr.hi.bh_544 lg.rw.un_870
  0x35005513, 0x122b200c, 0x00002d0a, 0x10000835,   // rw.zu.un_650 sq.vi.hu_543  sk.un.un_500 uk.be.un_A90
  0x03003f2b, 0x04100812, 0x1e1c21ec, 0x2400012b,   // af.nl.un_980 uk.be.ru_654  jw.id.ms_644 iw.yi.un_980
  0x2a000723, 0x321617a9, 0x3b006e07, 0x0000190a,   // it.mt.un_880 sr.hr.bs_544  hmn.so.un_420 gl.un.un_500
  // [01e0]
  0x00006b03, 0x3f0325a7, 0x0000101c, 0x0e0608a4,   // ceb.un.un_300 eu.nl.af_532  lt.un.un_800 no.de.is_433
  0x00002715, 0x00001003, 0x09001f12, 0x04002314,   // gd.un.un_700 be.un.un_300  cy.pl.un_640 ca.fi.un_660
  0x00000706, 0x00006e24, 0x040613a0, 0x3f080208,   // it.un.un_400 hmn.un.un_900  et.de.fi_322 da.no.af_443
  0x0000060f, 0x0000030a, 0x0f645513, 0x200304ee,   // de.un.un_600 nl.un.un_500  rw.lg.lv_665 fi.nl.sq_422
  // [01f0]
  0x1304200c, 0x1e211c12, 0x643f0307, 0x07000a1b,   // sq.fi.et_543 id.jw.ms_654  nl.af.lg_432 mk.bg.un_770
  0x17001602, 0x201904ee, 0x0000350f, 0x13002019,   // hr.sr.un_220 fi.gl.sq_422  zu.un.un_600 sq.et.un_750
  0x35002807, 0x2100120d, 0x00000e0a, 0x1e211c11,   // sw.zu.un_420 ur.fa.un_540  is.un.un_500 id.jw.ms_653
  0x55642509, 0x530523a7, 0x1c000914, 0x29002a19,   // eu.lg.rw_444 ca.fr.ht_532  hi.mr.un_660 mt.sl.un_750
  // [0200]
  0x05022d0c, 0x0000311c, 0x010c060c, 0x1f1218ee,   // sk.da.fr_543 az.un.un_800  de.sv.en_543 ga.hu.cy_422
  0x0600210c, 0x00005324, 0x0b133ba4, 0x0b0a1905,   // jw.de.un_530 ht.un.un_900  so.et.es_433 gl.pt.es_333
  0x0723190c, 0x2a1716eb, 0x3f190b09, 0x351a27ad,   // gl.ca.it_543 hr.sr.mt_662  es.gl.af_444 gd.tl.zu_643
  0x6400551a, 0x00001a0f, 0x0d0913a0, 0x0000201c,   // rw.lg.un_760 tl.un.un_600  bh.hi.ne_322 sq.un.un_800
  // [0210]
  0x190a08a4, 0x07002a13, 0x27003508, 0x0705010c,   // no.pt.gl_433 mt.it.un_650  zu.gd.un_430 en.fr.it_543
  0x00001b15, 0x02000e1a, 0x00000b03, 0x080220ee,   // tr.un.un_700 is.da.un_760  es.un.un_300 sq.da.no_422
  0x1105010b, 0x1800270d, 0x2d0a2302, 0x13071fa0,   // en.fr.ro_542 gd.ga.un_540  ca.pt.sk_222 cy.it.et_322
  0x1a0435ac, 0x1a20530c, 0x00000806, 0x12006b19,   // zu.fi.tl_632 ht.sq.tl_543  uk.un.un_400 ceb.hu.un_750
  // [0220]
  0x0100051b, 0x08001014, 0x55110507, 0x033f0608,   // fr.en.un_770 be.uk.un_660  fr.ro.rw_432 de.af.nl_443
  0x18271faf, 0x040708a9, 0x0a00171b, 0x06002009,   // cy.gd.ga_655 uk.bg.ru_544  sr.mk.un_770 sq.de.un_440
  0x0b0a19a9, 0x0000270a, 0x130704a7, 0x00002a0f,   // gl.pt.es_544 gd.un.un_500  fi.it.et_532 mt.un.un_600
  0x00006e0a, 0x0b0a2aee, 0x0000281c, 0x1a1c21a4,   // hmn.un.un_500 mt.pt.es_422  sw.un.un_800 jw.id.tl_433
  // [0230]
  0x213f1c04, 0x072004a6, 0x0b0723a4, 0x180e27ad,   // id.af.jw_332 fi.sq.it_521  ca.it.es_433 gd.is.ga_643
  0x00003515, 0x072a0da4, 0x180b1907, 0x070a17ad,   // zu.un.un_700 cs.mt.it_433  gl.es.ga_432 sr.mk.bg_643
  0x0c642805, 0x1c001e07, 0x170411ec, 0x09005508,   // sw.lg.sv_333 ms.id.un_420  ro.ru.sr_644 rw.pl.un_430
  0x1300091b, 0x28005522, 0x0000230a, 0x17080414,   // hi.bh.un_770 rw.sw.un_870  ca.un.un_500 ru.uk.sr_666
  // [0240]
  0x1801270c, 0x06005319, 0x0000530a, 0x1000020d,   // gd.en.ga_543 ht.de.un_750  ht.un.un_500 da.lt.un_540
  0x1b316b11, 0x28005314, 0x53211c55, 0x0000531c,   // ceb.az.tr_653 ht.sw.un_660  id.jw.ht_442 ht.un.un_800
  0x0c350807, 0x0700110c, 0x29002d13, 0x17000a23,   // no.zu.sv_432 ro.bg.un_530  sk.sl.un_650 mk.sr.un_880
  0x090d1c12, 0x53050111, 0x2d0d1755, 0x17071104,   // mr.ne.hi_654 en.fr.ht_653  sr.cs.sk_442 ro.bg.sr_332
  // [0250]
  0x21121812, 0x0a00171a, 0x01000604, 0x1632175a,   // ar.ur.fa_654 sr.mk.un_760  de.en.un_320 sr.bs.hr_553
  0x080410a0, 0x1b2d0d08, 0x04070a05, 0x02000813,   // be.ru.uk_322 cs.sk.tr_443  mk.bg.ru_333 no.da.un_650
  0x08041705, 0x292d0d0d, 0x09001c12, 0x321617a4,   // sr.ru.uk_333 cs.sk.sl_554  mr.hi.un_640 sr.hr.bs_433
  0x0c000202, 0x00000424, 0x1c0d0912, 0x24000112,   // da.sv.un_220 ru.un.un_900  hi.ne.mr_654 iw.yi.un_640
  // [0260]
  0x4a1e1c13, 0x06002305, 0x13001b09, 0x1b002502,   // id.ms.yo_665 ca.de.un_330  tr.et.un_440 eu.tr.un_220
  0x00000b0f, 0x1f2d0d60, 0x132911ee, 0x00003203,   // bn.un.un_600 cs.sk.cy_664  ro.sl.et_422 bs.un.un_300
  0x20211b12, 0x1b132512, 0x21001214, 0x00004a03,   // tr.jw.sq_654 eu.et.tr_654  ur.fa.un_660 yo.un.un_300
  0x00003201, 0x521203ac, 0x1b004a19, 0x2d000d14,   // bs.un.un_200 nl.hu.ha_632  yo.tr.un_750 cs.sk.un_660
  // [0270]
  0x351310a4, 0x0e35640c, 0x0b0a19ee, 0x0308020c,   // lt.et.zu_433 lg.zu.is_543  gl.pt.es_422 da.no.nl_543
  0x521e1c12, 0x11236808, 0x3500021a, 0x18211212,   // id.ms.ha_654 ig.ca.ro_443  da.zu.un_760 ur.fa.ar_654
  0x07001120, 0x0000170a, 0x290f03a0, 0x0d003511,   // ro.bg.un_850 sr.un.un_500  nl.lv.sl_322 zu.cs.un_630
  0x04000302, 0x00002b06, 0x04001019, 0x2d000d1a,   // nl.fi.un_220 vi.un.un_400  be.ru.un_750 cs.sk.un_760
  // [0280]
  0x04004a09, 0x030964a0, 0x00006e0f, 0x2b050311,   // yo.fi.un_440 lg.pl.nl_322  hmn.un.un_600 nl.fr.vi_653
  0x04001708, 0x1b001213, 0x00001f0a, 0x3f05030c,   // sr.ru.un_430 hu.tr.un_650  cy.un.un_500 nl.fr.af_543
  0x0000212d, 0x32161709, 0x211e1caf, 0x0a0717a4,   // jw.un.un_A00 sr.hr.bs_444  id.ms.jw_655 sr.bg.mk_433
  0x20006b04, 0x64001e04, 0x17000704, 0x102d0d0e,   // ceb.sq.un_320 ms.lg.un_320  bg.sr.un_320 cs.sk.lt_555
  // [0290]
  0x1800120d, 0x0f310d0b, 0x17000c08, 0x08040aa4,   // ur.ar.un_540 cs.az.lv_542  sv.sr.un_430 mk.ru.uk_433
  0x0a171105, 0x01001c04, 0x290d3202, 0x3f003511,   // ro.sr.mk_333 id.en.un_320  bs.cs.sl_222 zu.af.un_630
  0x12002d0d, 0x00000301, 0x0000310a, 0x00003524,   // sk.hu.un_540 nl.un.un_200  az.un.un_500 zu.un.un_900
  0x3f0305ec, 0x1c090607, 0x080213a4, 0x120b2d0c,   // fr.nl.af_644 de.pl.id_432  et.da.no_433 sk.es.hu_543
  // [02a0]
  0x0000551c, 0x3f3b04a4, 0x20230aee, 0x00003b1c,   // rw.un.un_800 fi.so.af_433  pt.ca.sq_422 so.un.un_800
  0x040a07a4, 0x17163209, 0x00002a0a, 0x04001a19,   // bg.mk.ru_433 bs.hr.sr_444  mt.un.un_500 tl.fi.un_750
  0x0d1c1308, 0x07041007, 0x6b0403ee, 0x13003b1b,   // bh.mr.ne_443 be.ru.bg_432  nl.fi.ceb_422 so.et.un_770
  0x070a17a0, 0x1e1c09a4, 0x6b3f04ad, 0x00000615,   // sr.mk.bg_322 pl.id.ms_433  fi.af.ceb_643 de.un.un_700
  // [02b0]
  0x042b13ee, 0x11001c04, 0x2d29520c, 0x13033ba4,   // et.vi.fi_422 id.ro.un_320  ha.sl.sk_543 so.nl.et_433
  0x130d0960, 0x3b3f0312, 0x161e1c04, 0x12001905,   // hi.ne.bh_664 nl.af.so_654  id.ms.hr_332 gl.hu.un_330
  0x00001a1c, 0x016b3bad, 0x19000b14, 0x31001b22,   // tl.un.un_800 so.ceb.en_643  es.gl.un_660 tr.az.un_870
  0x11070414, 0x64133fa4, 0x00000515, 0x0000312d,   // ru.bg.ro_666 af.et.lg_433  fr.un.un_700 az.un.un_A00
  // [02c0]
  0x0a0717ee, 0x00003b24, 0x03000522, 0x2d0d3baf,   // sr.bg.mk_422 so.un.un_900  fr.nl.un_870 so.cs.sk_655
  0x00001a01, 0x55354a04, 0x1e4a1c60, 0x0800041a,   // tl.un.un_200 yo.zu.rw_332  id.yo.ms_664 ru.uk.un_760
  0x3f684a12, 0x163f0355, 0x2800272a, 0x08041005,   // yo.ig.af_654 nl.af.hr_442  gd.sw.un_970 be.ru.uk_333
  0x2b0535ee, 0x1f001822, 0x3200160e, 0x036e640e,   // zu.fr.vi_422 ga.cy.un_870  hr.bs.un_550 lg.hmn.nl_555
  // [02d0]
  0x00001b0f, 0x23000304, 0x643b1ca4, 0x0a1707a4,   // tr.un.un_600 nl.ca.un_320  id.so.lg_433 bg.sr.mk_433
  0x0000290a, 0x00001a03, 0x00005303, 0x0f001007,   // sl.un.un_500 tl.un.un_300  ht.un.un_300 lt.lv.un_420
  0x3f000321, 0x1e1c31af, 0x11040813, 0x190b0405,   // nl.af.un_860 az.id.ms_655  uk.ru.ro_665 fi.es.gl_333
  0x04070a11, 0x683f0408, 0x04001713, 0x00000a03,   // mk.bg.ru_653 fi.af.ig_443  sr.ru.un_650 mk.un.un_300
  // [02e0]
  0x043b1aac, 0x522b3b05, 0x32080c0e, 0x12002119,   // tl.so.fi_632 so.vi.ha_333  sv.no.bs_555 fa.ur.un_750
  0x043b6b07, 0x1a000702, 0x01002304, 0x1a006b05,   // ceb.so.fi_432 it.tl.un_220  ca.en.un_320 ceb.tl.un_330
  0x6b001a09, 0x64002102, 0x00003137, 0x17000819,   // tl.ceb.un_440 jw.lg.un_220  az.un.un_B00 uk.sr.un_750
  0x0000641c, 0x00003b01, 0x0000170f, 0x09001c09,   // lg.un.un_800 so.un.un_200  sr.un.un_600 mr.hi.un_440
  // [02f0]
  0x100f55ec, 0x0000130f, 0x17212a07, 0x3b0313a4,   // rw.lv.lt_644 et.un.un_600  mt.jw.sr_432 et.nl.so_433
  0x0000552d, 0x1e531a0b, 0x2400011a, 0x00001c03,   // rw.un.un_A00 tl.ht.ms_542  iw.yi.un_760 id.un.un_300
  0x0e001009, 0x00002501, 0x311b1ea0, 0x17001002,   // lt.is.un_440 eu.un.un_200  ms.tr.az_322 be.sr.un_220
  0x53033fac, 0x3200161b, 0x0c080255, 0x040711ad,   // af.nl.ht_632 hr.bs.un_770  da.no.sv_442 ro.bg.ru_643
  // [0300]
  0x0000520a, 0x32171604, 0x2a200807, 0x213b2813,   // ha.un.un_500 hr.sr.bs_332  no.sq.mt_432 sw.so.jw_665
  0x16001e04, 0x0d1c090c, 0x64002a05, 0x00001824,   // ms.hr.un_320 hi.mr.ne_543  mt.lg.un_330 ar.un.un_900
  0x03121607, 0x55286408, 0x112507a4, 0x32001623,   // hr.hu.nl_432 lg.sw.rw_443  it.eu.ro_433 hr.bs.un_880
  0x12032011, 0x04101704, 0x25203ba4, 0x211812ec,   // sq.nl.hu_653 sr.be.ru_332  so.sq.eu_433 ur.ar.fa_644
  // [0310]
  0x13000819, 0x171107a0, 0x09033fad, 0x20282507,   // no.et.un_750 it.ro.sr_322  af.nl.pl_643 eu.sw.sq_432
  0x0000550f, 0x20001b12, 0x64003521, 0x19000a12,   // rw.un.un_600 tr.sq.un_640  zu.lg.un_860 pt.gl.un_640
  0x040a0760, 0x08041711, 0x0a171002, 0x041310a7,   // bg.mk.ru_664 sr.ru.uk_653  be.sr.mk_222 lt.et.fi_532
  0x060a070d, 0x00001f1c, 0x3f001c04, 0x070a17af,   // it.pt.de_554 cy.un.un_800  id.af.un_320 sr.mk.bg_655
  // [0320]
  0x0700171b, 0x13000919, 0x02005207, 0x0a000714,   // sr.bg.un_770 hi.bh.un_750  ha.da.un_420 bg.mk.un_660
  0x00004a2d, 0x290d53af, 0x00005201, 0x09001304,   // yo.un.un_A00 ht.cs.sl_655  ha.un.un_200 bh.hi.un_320
  0x070a1108, 0x07041004, 0x21001307, 0x0c00021a,   // ro.mk.bg_443 be.ru.bg_332  et.jw.un_420 da.sv.un_760
  0x251c1a04, 0x105507a4, 0x13211c04, 0x18002714,   // tl.id.eu_332 it.rw.lt_433  id.jw.et_332 gd.ga.un_660
  // [0330]
  0x11000712, 0x2d001914, 0x27001833, 0x19000b05,   // it.ro.un_640 gl.sk.un_660  ga.gd.un_A70 es.gl.un_330
  0x10000512, 0x203b21ec, 0x0c041304, 0x21005219,   // fr.lt.un_640 jw.so.sq_644  et.fi.sv_332 ha.jw.un_750
  0x00000c06, 0x2a5510ec, 0x1b000c02, 0x2d001011,   // sv.un.un_400 lt.rw.mt_644  sv.tr.un_220 lt.sk.un_630
  0x0d16290c, 0x4a0a07a7, 0x00006b15, 0x23006807,   // sl.hr.cs_543 it.pt.yo_532  ceb.un.un_700 ig.ca.un_420
  // [0340]
  0x121729a4, 0x00000f24, 0x166e320c, 0x3f000212,   // sl.sr.hu_433 lv.un.un_900  bs.hmn.hr_543 da.af.un_640
  0x03004a07, 0x1800350e, 0x2b280608, 0x0c121fa9,   // yo.nl.un_420 zu.ga.un_550  de.sw.vi_443 cy.hu.sv_544
  0x0c000836, 0x1f523b0b, 0x00000624, 0x1025070c,   // no.sv.un_AA0 so.ha.cy_542  de.un.un_900 it.eu.lt_543
  0x2b3f0308, 0x05131eee, 0x28080c0b, 0x20170307,   // nl.af.vi_443 ms.et.fr_422  sv.no.sw_542 nl.sr.sq_432
  // [0350]
  0x0b000702, 0x2b230e08, 0x0000061c, 0x00002915,   // it.es.un_220 is.ca.vi_443  de.un.un_800 sl.un.un_700
  0x0900291b, 0x00001f24, 0x1f182707, 0x0e000807,   // sl.pl.un_770 cy.un.un_900  gd.ga.cy_432 no.is.un_420
  0x6e6b6804, 0x1e001c05, 0x00001c1c, 0x64521f14,   // ig.ceb.hmn_332 id.ms.un_330  mr.un.un_800 cy.ha.lg_666
  0x09002807, 0x32001723, 0x01001e08, 0x0000081c,   // sw.pl.un_420 sr.bs.un_880  ms.en.un_430 uk.un.un_800
  // [0360]
  0x29000f21, 0x1c000919, 0x00002701, 0x23192504,   // lv.sl.un_860 hi.mr.un_750  gd.un.un_200 eu.gl.ca_332
  0x0000041c, 0x00006415, 0x0000020a, 0x0600010d,   // fi.un.un_800 lg.un.un_700  da.un.un_500 en.de.un_540
  0x315535a7, 0x32001607, 0x0000350a, 0x24000120,   // zu.rw.az_532 hr.bs.un_420  zu.un.un_500 iw.yi.un_850
  0x08023fee, 0x091c0dec, 0x1c001e04, 0x1600290d,   // af.da.no_422 ne.mr.hi_644  ms.id.un_320 sl.hr.un_540
  // [0370]
  0x0c080213, 0x0a1704ec, 0x00002a06, 0x05001909,   // da.no.sv_665 ru.sr.mk_644  mt.un.un_400 gl.fr.un_440
  0x0411170c, 0x0e120d07, 0x12000e09, 0x321208ac,   // sr.ro.ru_543 cs.hu.is_432  is.hu.un_440 no.hu.bs_632
  0x021808a4, 0x0000252d, 0x03003f14, 0x1300041b,   // no.ga.da_433 eu.un.un_A00  af.nl.un_660 fi.et.un_770
  0x21525507, 0x122d0d14, 0x050601af, 0x3f002304,   // rw.ha.jw_432 cs.sk.hu_666  en.de.fr_655 ca.af.un_320
  // [0380]
  0x1b00310e, 0x07000a23, 0x2a1f1a0c, 0x0b132355,   // az.tr.un_550 mk.bg.un_880  tl.cy.mt_543 ca.et.es_442
  0x23000619, 0x21005318, 0x12000413, 0x27002104,   // de.ca.un_750 ht.jw.un_740  fi.hu.un_650 jw.gd.un_320
  0x00000b06, 0x08170a08, 0x00006403, 0x1707040d,   // es.un.un_400 mk.sr.uk_443  lg.un.un_300 ru.bg.sr_554
  0x0a001723, 0x070a1714, 0x3f00031a, 0x6b006805,   // sr.mk.un_880 sr.mk.bg_666  nl.af.un_760 ig.ceb.un_330
  // [0390]
  0x321617a0, 0x04170a07, 0x02003204, 0x1e001c23,   // sr.hr.bs_322 mk.sr.ru_432  bs.da.un_320 id.ms.un_880
  0x1e182707, 0x170229a0, 0x07040a12, 0x1e1c21af,   // gd.ga.ms_432 sl.da.sr_322  mk.ru.bg_654 jw.id.ms_655
  0x11000612, 0x07130407, 0x06350eec, 0x2a0c0207,   // de.ro.un_640 fi.et.it_432  is.zu.de_644 da.sv.mt_432
  0x00000c01, 0x04071712, 0x100f5208, 0x2700060e,   // sv.un.un_200 sr.bg.ru_654  ha.lv.lt_443 de.gd.un_550
  // [03a0]
  0x3500041b, 0x0e2910ad, 0x12001907, 0x64005213,   // fi.zu.un_770 lt.sl.is_643  gl.hu.un_420 ha.lg.un_650
  0x0d130960, 0x5200281a, 0x08020ca4, 0x00000a0f,   // hi.bh.ne_664 sw.ha.un_760  sv.da.no_433 pt.un.un_600
  0x00001906, 0x10000818, 0x190b0a5a, 0x0c000f08,   // gl.un.un_400 uk.be.un_740  pt.es.gl_553 lv.sv.un_430
  0x00001e0a, 0x31086b02, 0x28005219, 0x08022102,   // ms.un.un_500 ceb.no.az_222  ha.sw.un_750 jw.da.no_222
  // [03b0]
  0x122d0d13, 0x1700160e, 0x3f000314, 0x2d0d18a4,   // cs.sk.hu_665 hr.sr.un_550  nl.af.un_660 ga.cs.sk_433
  0x32171bee, 0x53643b11, 0x1c090d0e, 0x09001308,   // tr.sr.bs_422 so.lg.ht_653  ne.hi.mr_555 bh.hi.un_430
  0x1b114a02, 0x17002307, 0x0800020e, 0x00000d24,   // yo.ro.tr_222 ca.sr.un_420  da.no.un_550 cs.un.un_900
  0x1700071a, 0x040a0713, 0x3f0902ec, 0x31001b1a,   // bg.sr.un_760 bg.mk.ru_665  da.pl.af_644 tr.az.un_760
  // [03c0]
  0x214a1c0c, 0x2d000d12, 0x3f0c0855, 0x00005224,   // id.yo.jw_543 cs.sk.un_640  no.sv.af_442 ha.un.un_900
  0x01236b04, 0x071708a4, 0x2d0e0c04, 0x0408100e,   // ceb.ca.en_332 uk.sr.bg_433  sv.is.sk_332 be.uk.ru_555
  0x01002412, 0x05001902, 0x00001306, 0x2d000d21,   // yi.iw.un_640 gl.fr.un_220  bh.un.un_400 cs.sk.un_860
  0x3f082daf, 0x19000a05, 0x0f0b10ac, 0x0d000e19,   // sk.no.af_655 pt.gl.un_330  lt.es.lv_632 is.cs.un_750
  // [03d0]
  0x050911a7, 0x351a55ac, 0x1e211c08, 0x0000051c,   // ro.pl.fr_532 rw.tl.zu_632  id.jw.ms_443 fr.un.un_800
  0x211735a4, 0x17000c07, 0x09200aad, 0x170413ec,   // zu.sr.jw_433 sv.sr.un_420  pt.sq.pl_643 et.fi.sr_644
  0x0f003f04, 0x080c02ad, 0x3b010604, 0x0900130c,   // af.lv.un_320 da.sv.no_643  de.en.so_332 bh.hi.un_530
  0x0c08060c, 0x0d091caf, 0x0000240f, 0x35002505,   // de.no.sv_543 mr.hi.ne_655  yi.un.un_600 eu.zu.un_330
  // [03e0]
  0x280c21a0, 0x28001807, 0x08020c04, 0x06001313,   // jw.sv.sw_322 ga.sw.un_420  sv.da.no_332 et.de.un_650
  0x00002801, 0x0e0c08ad, 0x2100050d, 0x00002003,   // sw.un.un_200 no.sv.is_643  fr.jw.un_540 sq.un.un_300
  0x0d00090c, 0x03002108, 0x0a285507, 0x0d000909,   // hi.ne.un_530 jw.nl.un_430  rw.sw.pt_432 hi.ne.un_440
  0x0000530f, 0x0000200a, 0x01641211, 0x0b1101a4,   // ht.un.un_600 sq.un.un_500  hu.lg.en_653 en.ro.es_433
  // [03f0]
  0x203229ad, 0x2d000d18, 0x0d002d12, 0x53070aa4,   // sl.bs.sq_643 cs.sk.un_740  sk.cs.un_640 pt.it.ht_433
  0x64003f1a, 0x082d1307, 0x354a280c, 0x0000640a,   // af.lg.un_760 et.sk.no_432  sw.yo.zu_543 lg.un.un_500
  0x00002124, 0x11070209, 0x531a1ca0, 0x2d000d19,   // fa.un.un_900 da.it.ro_444  id.tl.ht_322 cs.sk.un_750
  0x0c0e3f0c, 0x23000d04, 0x1b645508, 0x13000422,   // af.is.sv_543 cs.ca.un_320  rw.lg.tr_443 fi.et.un_870

  // [0400]
  0x2d000d20, 0x1e005309, 0x0900060d, 0x13000935,   // cs.sk.un_850 ht.ms.un_440  de.pl.un_540 hi.bh.un_A90
  0x1f001a02, 0x0e2d3f0c, 0x0400131a, 0x53080209,   // tl.cy.un_220 af.sk.is_543  et.fi.un_760 da.no.ht_444
  0x080e0ca9, 0x351f1860, 0x216b1aa9, 0x25131209,   // sv.is.no_544 ga.cy.zu_664  tl.ceb.jw_544 hu.et.eu_444
  0x1c3521ee, 0x0a0711ee, 0x19000b1b, 0x080c6e04,   // jw.zu.id_422 ro.bg.mk_422  es.gl.un_770 hmn.sv.no_332
  // [0410]
  0x2a00210c, 0x2d0e0da4, 0x08003f08, 0x6b3b520c,   // jw.mt.un_530 cs.is.sk_433  af.no.un_430 ha.so.ceb_543
  0x12061e04, 0x20115508, 0x12002122, 0x03063fa0,   // ms.de.hu_332 rw.ro.sq_443  fa.ur.un_870 af.de.nl_322
  0x286435af, 0x29000d13, 0x350713a7, 0x1a115508,   // zu.lg.sw_655 cs.sl.un_650  et.it.zu_532 rw.ro.tl_443
  0x00000a06, 0x0d2718a4, 0x01230708, 0x0f171602,   // pt.un.un_400 ga.gd.cs_433  it.ca.en_443 hr.sr.lv_222
  // [0420]
  0x00006b0a, 0x080c3ba7, 0x3f030ca4, 0x2000550d,   // ceb.un.un_500 so.sv.no_532  sv.nl.af_433 rw.sq.un_540
  0x09001312, 0x07040804, 0x0e20550c, 0x2700180e,   // bh.hi.un_640 uk.ru.bg_332  rw.sq.is_543 ga.gd.un_550
  0x00001f0f, 0x07001212, 0x211a280c, 0x17001605,   // cy.un.un_600 hu.it.un_640  sw.tl.jw_543 hr.sr.un_330
  0x04212855, 0x280e5508, 0x2d0d06a4, 0x0817040c,   // sw.jw.fi_442 rw.is.sw_443  de.cs.sk_433 ru.sr.uk_543
  // [0430]
  0x64211ea0, 0x1b521ea0, 0x2a131ea0, 0x061e1c05,   // ms.jw.lg_322 ms.ha.tr_322  ms.et.mt_322 id.ms.de_333
  0x13000121, 0x28005513, 0x100804a4, 0x522a5508,   // en.et.un_860 rw.sw.un_650  ru.uk.be_433 rw.mt.ha_443
  0x3b003114, 0x04551ea0, 0x10550fa4, 0x1a006b1b,   // az.so.un_660 ms.rw.fi_322  lv.rw.lt_433 ceb.tl.un_770
  0x1a000804, 0x0400131b, 0x27010ba0, 0x186b08a0,   // no.tl.un_320 et.fi.un_770  es.en.gd_322 no.ceb.ga_322
  // [0440]
  0x02070860, 0x0d09130c, 0x29000604, 0x6b551ea4,   // no.it.da_664 bh.hi.ne_543  de.sl.un_320 ms.rw.ceb_433
  0x1b3f0802, 0x21001f12, 0x1e046402, 0x686b1a08,   // no.af.tr_222 cy.jw.un_640  lg.fi.ms_222 tl.ceb.ig_443
  0x08000c1b, 0x250e0707, 0x161029a4, 0x1a00550c,   // sv.no.un_770 it.is.eu_432  sl.lt.hr_433 rw.tl.un_530
  0x35313bad, 0x07190e02, 0x06033fa4, 0x07081004,   // so.az.zu_643 is.gl.it_222  af.nl.de_433 be.uk.bg_332
  // [0450]
  0x322d0d04, 0x0100241a, 0x1f033ba9, 0x2d0c1a04,   // cs.sk.bs_332 yi.iw.un_760  so.nl.cy_544 tl.sv.sk_332
  0x01003f11, 0x211c1eec, 0x080206a4, 0x31001b19,   // af.en.un_630 ms.id.jw_644  de.da.no_433 tr.az.un_750
  0x211e1c0d, 0x31001b23, 0x18002121, 0x21181212,   // id.ms.jw_554 tr.az.un_880  fa.ar.un_860 ur.ar.fa_654
  0x1e001c2c, 0x04170808, 0x040a1707, 0x1c211e12,   // id.ms.un_990 uk.sr.ru_443  sr.mk.ru_432 ms.jw.id_654
  // [0460]
  0x113155a4, 0x6b001a07, 0x6b3f1aad, 0x041707ec,   // rw.az.ro_433 tl.ceb.un_420  tl.af.ceb_643 bg.sr.ru_644
  0x210f100c, 0x0e1104a4, 0x1c0d0960, 0x0a1008a4,   // lt.lv.jw_543 fi.ro.is_433  hi.ne.mr_664 uk.be.mk_433
  0x17040a07, 0x04170a04, 0x11170408, 0x213b1e04,   // mk.ru.sr_432 mk.sr.ru_332  ru.sr.ro_443 ms.so.jw_332
  0x0c0b2909, 0x00004a0a, 0x04070a04, 0x1b0c120c,   // sl.es.sv_444 yo.un.un_500  mk.bg.ru_332 hu.sv.tr_543
  // [0470]
  0x04081004, 0x100a070c, 0x3f0f2312, 0x23001902,   // be.uk.ru_332 bg.mk.be_543  ca.lv.af_654 gl.ca.un_220
  0x0e00080e, 0x6b041aa4, 0x19120a0b, 0x1e162902,   // no.is.un_550 tl.fi.ceb_433  pt.hu.gl_542 sl.hr.ms_222
  0x1e003504, 0x0100231a, 0x0d002a19, 0x1c000412,   // zu.ms.un_320 ca.en.un_760  mt.cs.un_750 fi.id.un_640
  0x28002521, 0x0d001302, 0x11006b13, 0x0000070a,   // eu.sw.un_860 bh.ne.un_220  ceb.ro.un_650 it.un.un_500
  // [0480]
  0x3f002518, 0x211812a4, 0x322a16ec, 0x1e001c1a,   // eu.af.un_740 ur.ar.fa_433  hr.mt.bs_644 id.ms.un_760
  0x17080a05, 0x536b250c, 0x0f21130c, 0x2a120804,   // mk.uk.sr_333 eu.ceb.ht_543  et.jw.lv_543 no.hu.mt_332
  0x090711ee, 0x311b2d07, 0x3f000619, 0x04112108,   // ro.it.pl_422 sk.tr.az_432  de.af.un_750 jw.ro.fi_443
  0x1f001c07, 0x06000c04, 0x351f2107, 0x1e001c2b,   // id.cy.un_420 sv.de.un_320  jw.cy.zu_432 id.ms.un_980
  // [0490]
  0x0c0123af, 0x2d0d090c, 0x21000b08, 0x00001106,   // ca.en.sv_655 pl.cs.sk_543  es.jw.un_430 ro.un.un_400
  0x01002320, 0x13002920, 0x24000118, 0x01002312,   // ca.en.un_850 sl.et.un_850  iw.yi.un_740 ca.en.un_640
  0x28002b13, 0x17321660, 0x1329110c, 0x083f6407,   // vi.sw.un_650 hr.bs.sr_664  ro.sl.et_543 lg.af.no_432
  0x53002102, 0x3200210d, 0x550652a4, 0x6b001a22,   // jw.ht.un_220 jw.bs.un_540  ha.de.rw_433 tl.ceb.un_870
  // [04a0]
  0x0e6b07ad, 0x19000b20, 0x04001314, 0x21001813,   // it.ceb.is_643 es.gl.un_850  et.fi.un_660 ar.fa.un_650
  0x0e132aa4, 0x210e0811, 0x29001212, 0x00006b1c,   // mt.et.is_433 no.is.jw_653  hu.sl.un_640 ceb.un.un_800
  0x16321708, 0x17000408, 0x521c1e0b, 0x0a2d0d11,   // sr.bs.hr_443 fi.sr.un_430  ms.id.ha_542 cs.sk.pt_653
  0x2700060d, 0x0a0708a4, 0x0000171c, 0x0e640255,   // de.gd.un_540 uk.bg.mk_433  sr.un.un_800 da.lg.is_442
  // [04b0]
  0x0a07110e, 0x08002019, 0x1a033fa4, 0x080c060d,   // ro.bg.mk_555 sq.no.un_750  af.nl.tl_433 de.sv.no_554
  0x0e3b3f04, 0x00000c2d, 0x170f290c, 0x00002a1c,   // af.so.is_332 sv.un.un_A00  sl.lv.sr_543 mt.un.un_800
  0x00000c1c, 0x00005215, 0x0f0413ad, 0x35005205,   // sv.un.un_800 ha.un.un_700  et.fi.lv_643 ha.zu.un_330
  0x11182712, 0x0a001722, 0x00004a15, 0x1c211e0c,   // gd.ga.ro_654 sr.mk.un_870  yo.un.un_700 ms.jw.id_543
  // [04c0]
  0x12002121, 0x182112ad, 0x060c02a4, 0x0000190f,   // fa.ur.un_860 ur.fa.ar_643  da.sv.de_433 gl.un.un_600
  0x17002908, 0x1c090dec, 0x08021fa9, 0x01080208,   // sl.sr.un_430 ne.hi.mr_644  cy.da.no_544 da.no.en_443
  0x2325190b, 0x16190b0d, 0x131e1c14, 0x3b00071b,   // gl.eu.ca_542 es.gl.hr_554  id.ms.et_666 it.so.un_770
  0x03001904, 0x28006808, 0x010553a0, 0x040810ad,   // gl.nl.un_320 ig.sw.un_430  ht.fr.en_322 be.uk.ru_643
  // [04d0]
  0x0e08025a, 0x080c1fee, 0x6b001a2b, 0x03053f07,   // da.no.is_553 cy.sv.no_422  tl.ceb.un_980 af.fr.nl_432
  0x071c640c, 0x110d0f12, 0x02000819, 0x281801ee,   // lg.id.it_543 lv.cs.ro_654  no.da.un_750 en.ga.sw_422
  0x2a002922, 0x1000041b, 0x03042509, 0x040708a4,   // sl.mt.un_870 ru.be.un_770  eu.fi.nl_444 uk.bg.ru_433
  0x0c080204, 0x0804170c, 0x24000119, 0x00003f24,   // da.no.sv_332 sr.ru.uk_543  iw.yi.un_750 af.un.un_900
  // [04e0]
  0x2500011a, 0x08020ca9, 0x1c000312, 0x18211211,   // en.eu.un_760 sv.da.no_544  nl.id.un_640 ur.fa.ar_653
  0x29000c0b, 0x1c001302, 0x1b001c04, 0x0600011a,   // sv.sl.un_520 bh.mr.un_220  id.tr.un_320 en.de.un_760
  0x2d000d09, 0x2d103207, 0x202a030c, 0x06033faf,   // cs.sk.un_440 bs.lt.sk_432  nl.mt.sq_543 af.nl.de_655
  0x09001f09, 0x25001314, 0x1f003519, 0x32002d04,   // cy.pl.un_440 et.eu.un_660  zu.cy.un_750 sk.bs.un_320
  // [04f0]
  0x190b0a0e, 0x0d0b1908, 0x211b0c04, 0x32294aad,   // pt.es.gl_555 gl.es.cs_443  sv.tr.jw_332 yo.sl.bs_643
  0x3f001b19, 0x2723050c, 0x080410ec, 0x0d051104,   // tr.af.un_750 fr.ca.gd_543  be.ru.uk_644 ro.fr.cs_332
  0x2d000a2b, 0x3b001821, 0x0700041a, 0x2d001e04,   // pt.sk.un_980 ga.so.un_860  ru.bg.un_760 ms.sk.un_320
  0x160c2907, 0x13000c13, 0x0c080205, 0x28551faf,   // sl.sv.hr_432 sv.et.un_650  da.no.sv_333 cy.rw.sw_655
  // [0500]
  0x211e1cad, 0x3b1e1ca0, 0x08020c0c, 0x32161705,   // id.ms.jw_643 id.ms.so_322  sv.da.no_543 sr.hr.bs_333
  0x321e0304, 0x063f35ad, 0x52001c02, 0x1e5528ad,   // nl.ms.bs_332 zu.af.de_643  id.ha.un_220 sw.rw.ms_643
  0x20321705, 0x3b00190d, 0x0d000912, 0x29001602,   // sr.bs.sq_333 gl.so.un_540  hi.ne.un_640 hr.sl.un_220
  0x00001237, 0x13000918, 0x352831a7, 0x102d0d13,   // ur.un.un_B00 hi.bh.un_740  az.sw.zu_532 cs.sk.lt_665
  // [0510]
  0x190b0a14, 0x19000b09, 0x090d1cac, 0x4a020d07,   // pt.es.gl_666 es.gl.un_440  mr.ne.hi_632 cs.da.yo_432
  0x0c001f19, 0x131f070c, 0x523528ec, 0x10002913,   // cy.sv.un_750 it.cy.et_543  sw.zu.ha_644 sl.lt.un_650
  0x55003514, 0x090d1c13, 0x35000a05, 0x1e1c350e,   // zu.rw.un_660 mr.ne.hi_665  pt.zu.un_330 zu.id.ms_555
  0x09002a0c, 0x035505a4, 0x0000270f, 0x11355508,   // mt.pl.un_530 fr.rw.nl_433  gd.un.un_600 rw.zu.ro_443
  // [0520]
  0x0b20550c, 0x216b2aad, 0x5300041b, 0x040a1702,   // rw.sq.es_543 mt.ceb.jw_643  fi.ht.un_770 sr.mk.ru_222
  0x2d120da4, 0x08210e55, 0x0d001c0c, 0x2d0d1812,   // cs.hu.sk_433 is.jw.no_442  mr.ne.un_530 ga.cs.sk_654
  0x52006413, 0x2a321708, 0x00001303, 0x2d0d12ac,   // lg.ha.un_650 sr.bs.mt_443  bh.un.un_300 hu.cs.sk_632
  0x352d1705, 0x1f000618, 0x06030ca0, 0x3b25030b,   // sr.sk.zu_333 de.cy.un_740  sv.nl.de_322 nl.eu.so_542
  // [0530]
  0x08040aa0, 0x230b0a0d, 0x21080e0b, 0x352864a4,   // mk.ru.uk_322 pt.es.ca_554  is.no.jw_542 lg.sw.zu_433
  0x32162912, 0x08060ca0, 0x080407ec, 0x0e001207,   // sl.hr.bs_654 sv.de.no_322  bg.ru.uk_644 hu.is.un_420
  0x01002408, 0x07101707, 0x29202aa0, 0x00000401,   // yi.iw.un_430 sr.be.bg_432  mt.sq.sl_322 ru.un.un_200
  0x11252009, 0x2100120e, 0x00001c24, 0x13000d09,   // sq.eu.ro_444 ur.fa.un_550  mr.un.un_900 ne.bh.un_440
  // [0540]
  0x1c00090e, 0x0e6428a4, 0x5500640d, 0x270e0813,   // hi.mr.un_550 sw.lg.is_433  lg.rw.un_540 no.is.gd_665
  0x0704170c, 0x28556408, 0x09553fec, 0x522a6455,   // sr.ru.bg_543 lg.rw.sw_443  af.rw.pl_644 lg.mt.ha_442
  0x19000a14, 0x20004a08, 0x00006803, 0x29002a12,   // pt.gl.un_660 yo.sq.un_430  ig.un.un_300 mt.sl.un_640
  0x100804af, 0x190a1f05, 0x28005207, 0x0200080d,   // ru.uk.be_655 cy.pt.gl_333  ha.sw.un_420 no.da.un_540
  // [0550]
  0x04550509, 0x180104a7, 0x066e6ba9, 0x05255313,   // fr.rw.fi_444 fi.en.ga_532  ceb.hmn.de_544 ht.eu.fr_665
  0x04081013, 0x28556412, 0x12520412, 0x2300051a,   // be.uk.ru_665 lg.rw.sw_654  fi.ha.hu_654 fr.ca.un_760
  0x00000803, 0x55001c08, 0x23000a1a, 0x23000808,   // no.un.un_300 id.rw.un_430  pt.ca.un_760 no.ca.un_430
  0x1e1c0ca6, 0x52281f0c, 0x2d1c21ee, 0x2d0d2911,   // sv.id.ms_521 cy.sw.ha_543  jw.id.sk_422 sl.cs.sk_653
  // [0560]
  0x4a001913, 0x31080ca0, 0x1c006422, 0x12202aad,   // gl.yo.un_650 sv.no.az_322  lg.id.un_870 mt.sq.hu_643
  0x3f006408, 0x6e2a05ee, 0x051310ee, 0x09060302,   // lg.af.un_430 fr.mt.hmn_422  lt.et.fr_422 nl.de.pl_222
  0x07000a04, 0x1a002d04, 0x12006b05, 0x091c1307,   // mk.bg.un_320 sk.tl.un_320  ceb.hu.un_330 bh.mr.hi_432
  0x00006e03, 0x103b1ea0, 0x112a0508, 0x1716320c,   // hmn.un.un_300 ms.so.lt_322  fr.mt.ro_443 bs.hr.sr_543
  // [0570]
  0x17005312, 0x13090d05, 0x04070a0d, 0x21001c04,   // ht.sr.un_640 ne.hi.bh_333  mk.bg.ru_554 id.jw.un_320
  0x063f0313, 0x046435a0, 0x13091cec, 0x10020fa4,   // nl.af.de_665 zu.lg.fi_322  mr.hi.bh_644 lv.da.lt_433
  0x00005524, 0x3b001905, 0x090d13af, 0x00003b06,   // rw.un.un_900 gl.so.un_330  bh.ne.hi_655 so.un.un_400
  0x290c0812, 0x06016e08, 0x3b2a1c07, 0x100f0608,   // no.sv.sl_654 hmn.en.de_443  id.mt.so_432 de.lv.lt_443
  // [0580]
  0x00002301, 0x0501060c, 0x1732165a, 0x28556ead,   // ca.un.un_200 de.en.fr_543  hr.bs.sr_553 hmn.rw.sw_643
  0x06001b0c, 0x0e000508, 0x00000324, 0x1e1c2114,   // tr.de.un_530 fr.is.un_430  nl.un.un_900 jw.id.ms_666
  0x35551a13, 0x13000c0d, 0x6b641a0c, 0x1c001604,   // tl.rw.zu_665 sv.et.un_540  tl.lg.ceb_543 hr.id.un_320
  0x1c09130e, 0x23002702, 0x356b1aa9, 0x13033faf,   // bh.hi.mr_555 gd.ca.un_220  tl.ceb.zu_544 af.nl.et_655
  // [0590]
  0x211e1c08, 0x2118120d, 0x0d09130e, 0x100a13a4,   // id.ms.jw_443 ur.ar.fa_554  bh.hi.ne_555 et.pt.lt_433
  0x04281908, 0x1a1e1c14, 0x07041005, 0x2100680e,   // gl.sw.fi_443 id.ms.tl_666  be.ru.bg_333 ig.jw.un_550
  0x551a64a9, 0x29001b19, 0x3f080c09, 0x04284a07,   // lg.tl.rw_544 tr.sl.un_750  sv.no.af_444 yo.sw.fi_432
  0x211e1c13, 0x08040aee, 0x1e1c21a9, 0x25001e0d,   // id.ms.jw_665 mk.ru.uk_422  jw.id.ms_544 ms.eu.un_540
  // [05a0]
  0x210c080c, 0x21002714, 0x32001707, 0x52001e08,   // no.sv.jw_543 gd.jw.un_660  sr.bs.un_420 ms.ha.un_430
  0x19000b12, 0x040708ec, 0x32170daf, 0x132a075a,   // es.gl.un_640 uk.bg.ru_644  cs.sr.bs_655 it.mt.et_553
  0x0800100e, 0x1e000f21, 0x31001b0c, 0x091c0da7,   // be.uk.un_550 lv.ms.un_860  tr.az.un_530 ne.mr.hi_532
  0x3b551a09, 0x033f2a0c, 0x1100270d, 0x55003204,   // tl.rw.so_444 mt.af.nl_543  gd.ro.un_540 bs.rw.un_320
  // [05b0]
  0x1b006b04, 0x02003f0e, 0x1b003109, 0x1c001309,   // ceb.tr.un_320 af.da.un_550  az.tr.un_440 bh.mr.un_440
  0x19000b19, 0x23052d07, 0x06006e07, 0x2d0d2905,   // es.gl.un_750 sk.fr.ca_432  hmn.de.un_420 sl.cs.sk_333
  0x236e0508, 0x2d000d13, 0x271f0107, 0x182709a4,   // fr.hmn.ca_443 cs.sk.un_650  en.cy.gd_432 pl.gd.ga_433
  0x230105ad, 0x12255508, 0x0e020811, 0x120d2d12,   // fr.en.ca_643 rw.eu.hu_443  no.da.is_653 sk.cs.hu_654
  // [05c0]
  0x09271eee, 0x1c1a1ea0, 0x070a1708, 0x53001819,   // ms.gd.pl_422 ms.tl.id_322  sr.mk.bg_443 ga.ht.un_750
  0x55316809, 0x31001b21, 0x35641ca4, 0x0235080c,   // ig.az.rw_444 tr.az.un_860  id.lg.zu_433 no.zu.da_543
  0x556b640d, 0x2300050c, 0x080621a0, 0x31532108,   // lg.ceb.rw_554 fr.ca.un_530  jw.de.no_322 jw.ht.az_443
  0x5264080c, 0x55311ca4, 0x230a0513, 0x011a2704,   // no.lg.ha_543 id.az.rw_433  fr.pt.ca_665 gd.tl.en_332
  // [05d0]
  0x2d001220, 0x13000804, 0x55083513, 0x0a07170c,   // hu.sk.un_850 no.et.un_320  zu.no.rw_665 sr.bg.mk_543
  0x191a6b11, 0x041c2112, 0x31353baf, 0x3f0f10a9,   // ceb.tl.gl_653 jw.id.fi_654  so.zu.az_655 lt.lv.af_544
  0x23000104, 0x04200804, 0x0a081713, 0x05001904,   // en.ca.un_320 no.sq.fi_332  sr.uk.mk_665 gl.fr.un_320
  0x190b23af, 0x2a200704, 0x1218210c, 0x20080607,   // ca.es.gl_655 it.sq.mt_332  fa.ar.ur_543 de.no.sq_432
  // [05e0]
  0x00001b03, 0x3f060808, 0x04211c5a, 0x19090a07,   // tr.un.un_300 no.de.af_443  id.jw.fi_553 pt.pl.gl_432
  0x19000b0e, 0x29063508, 0x0c3f0305, 0x00003506,   // es.gl.un_550 zu.de.sl_443  nl.af.sv_333 zu.un.un_400
  0x0d091314, 0x0800101a, 0x552305ac, 0x3f00290b,   // bh.hi.ne_666 be.uk.un_760  fr.ca.rw_632 sl.af.un_520
  0x06000c0c, 0x07000504, 0x00006401, 0x2305010c,   // sv.de.un_530 fr.it.un_320  lg.un.un_200 en.fr.ca_543
  // [05f0]
  0x236e0607, 0x07170aa9, 0x093b1f05, 0x32001605,   // de.hmn.ca_432 mk.sr.bg_544  cy.so.pl_333 hr.bs.un_330
  0x283b1f0d, 0x171632af, 0x081f0608, 0x05001113,   // cy.so.sw_554 bs.hr.sr_655  de.cy.no_443 ro.fr.un_650
  0x3f00031b, 0x6e06280c, 0x17000808, 0x0d13095a,   // nl.af.un_770 sw.de.hmn_543  no.sr.un_430 hi.bh.ne_553
  0x1c0913a4, 0x09121813, 0x2100280c, 0x122118af,   // bh.hi.mr_433 ga.hu.pl_665  sw.jw.un_530 ar.fa.ur_655
  // [0600]
  0x2a07010b, 0x080c02a4, 0x286e2b07, 0x16080208,   // en.it.mt_542 da.sv.no_433  vi.hmn.sw_432 da.no.hr_443
  0x0400171a, 0x130608a7, 0x35072507, 0x08040713,   // sr.ru.un_760 no.de.et_532  eu.it.zu_432 bg.ru.uk_665
  0x11000813, 0x00002a01, 0x0a170714, 0x3f1206ad,   // no.ro.un_650 mt.un.un_200  bg.sr.mk_666 de.hu.af_643
  0x011a2112, 0x12001f1b, 0x35006414, 0x21006807,   // jw.tl.en_654 cy.hu.un_770  lg.zu.un_660 ig.jw.un_420
  // [0610]
  0x0000092d, 0x07001012, 0x10000f13, 0x0000031c,   // hi.un.un_A00 be.bg.un_640  lv.lt.un_650 nl.un.un_800
  0x0b04050c, 0x040a1705, 0x040810a6, 0x1e1c04a9,   // fr.fi.es_543 sr.mk.ru_333  be.uk.ru_521 fi.id.ms_544
  0x351c210e, 0x2d002905, 0x04002713, 0x21001c0d,   // jw.id.zu_555 sl.sk.un_330  gd.fi.un_650 id.jw.un_540
  0x31001b14, 0x64556ba4, 0x090d1c07, 0x27001823,   // tr.az.un_660 ceb.rw.lg_433  mr.ne.hi_432 ga.gd.un_880
  // [0620]
  0x23080208, 0x314a3507, 0x05250107, 0x043f3109,   // da.no.ca_443 zu.yo.az_432  en.eu.fr_432 az.af.fi_444
  0x21001821, 0x05000804, 0x182d0d14, 0x190b04ad,   // ar.fa.un_860 no.fr.un_320  cs.sk.ga_666 fi.es.gl_643
  0x0a041108, 0x01033f60, 0x1b003120, 0x55006819,   // ro.ru.mk_443 af.nl.en_664  az.tr.un_850 ig.rw.un_750
  0x0000040a, 0x2b6b01a9, 0x181b2007, 0x00001915,   // fi.un.un_500 en.ceb.vi_544  sq.tr.ga_432 gl.un.un_700
  // [0630]
  0x1f2912af, 0x120407a0, 0x0d1219a0, 0x35006819,   // hu.sl.cy_655 it.fi.hu_322  gl.hu.cs_322 ig.zu.un_750
  0x6b3b1c07, 0x1800270e, 0x35645355, 0x1a006b08,   // id.so.ceb_432 gd.ga.un_550  ht.lg.zu_442 ceb.tl.un_430
  0x17081008, 0x29321604, 0x0d091cec, 0x0701270c,   // be.uk.sr_443 hr.bs.sl_332  mr.hi.ne_644 gd.en.it_543
  0x18002808, 0x064a3505, 0x05004a04, 0x2000070c,   // sw.ga.un_430 zu.yo.de_333  yo.fr.un_320 it.sq.un_530
  // [0640]
  0x2b006e07, 0x0602070c, 0x1e1c21a0, 0x551153ee,   // hmn.vi.un_420 it.da.de_543  jw.id.ms_322 ht.ro.rw_422
  0x35000a12, 0x050b10a0, 0x00000206, 0x1b3b310c,   // pt.zu.un_640 lt.es.fr_322  da.un.un_400 az.so.tr_543
  0x06001e04, 0x312518a4, 0x1c000905, 0x101a0c12,   // ms.de.un_320 ga.eu.az_433  hi.mr.un_330 sv.tl.lt_654
  0x09001f13, 0x091c13a9, 0x3f64030d, 0x0a071707,   // cy.pl.un_650 bh.mr.hi_544  nl.lg.af_554 sr.bg.mk_432
  // [0650]
  0x64001314, 0x1c000d13, 0x0a0407a4, 0x01000704,   // et.lg.un_660 ne.mr.un_650  bg.ru.mk_433 it.en.un_320
  0x17321655, 0x32162509, 0x04000719, 0x0b13040c,   // hr.bs.sr_442 eu.hr.bs_444  bg.ru.un_750 fi.et.es_543
  0x2d0d1214, 0x120b040c, 0x2b4a0714, 0x071708ec,   // hu.cs.sk_666 fi.es.hu_543  it.yo.vi_666 uk.sr.bg_644
  0x17001018, 0x0e000219, 0x6b020811, 0x3b003104,   // be.sr.un_740 da.is.un_750  no.da.ceb_653 az.so.un_320
  // [0660]
  0x02211c0c, 0x19000b04, 0x21001008, 0x0d1c1311,   // id.jw.da_543 es.gl.un_320  lt.jw.un_430 bh.mr.ne_653
  0x190853ee, 0x00001324, 0x3b001021, 0x21026b07,   // ht.no.gl_422 bh.un.un_900  lt.so.un_860 ceb.da.jw_432
  0x321716a9, 0x321716a0, 0x0a000712, 0x09000d07,   // hr.sr.bs_544 hr.sr.bs_322  bg.mk.un_640 ne.hi.un_420
  0x17000a12, 0x1b252aa4, 0x12001812, 0x0000090a,   // mk.sr.un_640 mt.eu.tr_433  ar.ur.un_640 pl.un.un_500
  // [0670]
  0x1c090d60, 0x19110bee, 0x1b313bec, 0x52001a0c,   // ne.hi.mr_664 es.ro.gl_422  so.az.tr_644 tl.ha.un_530
  0x1b1e1c02, 0x0b0a0cee, 0x070a1709, 0x17033f04,   // id.ms.tr_222 sv.pt.es_422  sr.mk.bg_444 af.nl.sr_332
  0x080410ad, 0x1c005207, 0x32311b55, 0x3f000708,   // be.ru.uk_643 ha.id.un_420  tr.az.bs_442 it.af.un_430
  0x17070a08, 0x55642807, 0x13071212, 0x00003f0f,   // mk.bg.sr_443 sw.lg.rw_432  hu.it.et_654 af.un.un_600
  // [0680]
  0x0e000812, 0x2b001c07, 0x12002a07, 0x2b001c02,   // no.is.un_640 id.vi.un_420  mt.hu.un_420 id.vi.un_220
  0x53355208, 0x31121b07, 0x2d080204, 0x0c000808,   // ha.zu.ht_443 tr.hu.az_432  da.no.sk_332 no.sv.un_430
  0x1a0b6b08, 0x0b521e07, 0x1e005207, 0x0c0e02ee,   // ceb.es.tl_443 ms.ha.es_432  ha.ms.un_420 da.is.sv_422
  0x35522a05, 0x351c21a7, 0x1e1c35ee, 0x0c00081a,   // mt.ha.zu_333 jw.id.zu_532  zu.id.ms_422 no.sv.un_760
  // [0690]
  0x092d0d0e, 0x161f2702, 0x6e080eec, 0x19000b13,   // cs.sk.pl_555 gd.cy.hr_222  is.no.hmn_644 es.gl.un_650
  0x35646b07, 0x25001e04, 0x292d0d55, 0x0d091305,   // ceb.lg.zu_432 ms.eu.un_320  cs.sk.sl_442 bh.hi.ne_333
  0x0000071c, 0x171632a0, 0x55643504, 0x04081708,   // it.un.un_800 bs.hr.sr_322  zu.lg.rw_332 sr.uk.ru_443
  0x04170aa0, 0x32000108, 0x28526b08, 0x2d001704,   // mk.sr.ru_322 en.bs.un_430  ceb.ha.sw_443 sr.sk.un_320
  // [06a0]
  0x645535a4, 0x080a07a4, 0x10002508, 0x044a2502,   // zu.rw.lg_433 bg.mk.uk_433  eu.lt.un_430 eu.yo.fi_222
  0x20001c05, 0x19000b0c, 0x531a6b07, 0x13000909,   // id.sq.un_330 es.gl.un_530  ceb.tl.ht_432 hi.bh.un_440
  0x03003f0e, 0x53006b04, 0x0c000f04, 0x00001301,   // af.nl.un_550 ceb.ht.un_320  lv.sv.un_320 et.un.un_200
  0x2500521a, 0x53292da4, 0x0000130a, 0x09001c13,   // ha.eu.un_760 sk.sl.ht_433  bh.un.un_500 mr.hi.un_650
  // [06b0]
  0x355564af, 0x0c000e04, 0x256413a0, 0x1f001e13,   // lg.rw.zu_655 is.sv.un_320  et.lg.eu_322 ms.cy.un_650
  0x285329a0, 0x08001021, 0x130153a0, 0x0d00090e,   // sl.ht.sw_322 be.uk.un_860  ht.en.et_322 hi.ne.un_550
  0x35286404, 0x09002908, 0x051f0111, 0x642868ee,   // lg.sw.zu_332 sl.pl.un_430  en.cy.fr_653 ig.sw.lg_422
  0x1e55280c, 0x312d0907, 0x08000223, 0x091c0daf,   // sw.rw.ms_543 pl.sk.az_432  da.no.un_880 ne.mr.hi_655
  // [06c0]
  0x00005315, 0x25005208, 0x1700290b, 0x18120e5a,   // ht.un.un_700 ha.eu.un_430  sl.sr.un_520 is.hu.ga_553
  0x00005306, 0x210c1f0c, 0x2527180c, 0x1b001904,   // ht.un.un_400 cy.sv.jw_543  ga.gd.eu_543 gl.tr.un_320
  0x100408a4, 0x190d0b0c, 0x1300270c, 0x21001c02,   // uk.ru.be_433 es.cs.gl_543  gd.et.un_530 id.jw.un_220
  0x0e001b14, 0x051f010c, 0x1c0d0909, 0x10000821,   // tr.is.un_660 en.cy.fr_543  hi.ne.mr_444 uk.be.un_860
  // [06d0]
  0x060e0f0c, 0x201b2ba4, 0x08041007, 0x0d321604,   // lv.is.de_543 vi.tr.sq_433  be.ru.uk_432 hr.bs.cs_332
  0x00000d06, 0x31006b07, 0x19200b12, 0x0f000919,   // ne.un.un_400 ceb.az.un_420  es.sq.gl_654 pl.lv.un_750
  0x07002a02, 0x3f040313, 0x09001107, 0x0c000e1a,   // mt.it.un_220 nl.fi.af_665  ro.pl.un_420 is.sv.un_760
  0x033f040d, 0x25121807, 0x1c000d0c, 0x28001e04,   // fi.af.nl_554 ga.hu.eu_432  ne.mr.un_530 ms.sw.un_320
  // [06e0]
  0x092555a7, 0x2d090d0c, 0x121821ec, 0x00000524,   // rw.eu.pl_532 cs.pl.sk_543  fa.ar.ur_644 fr.un.un_900
  0x16092907, 0x0e020fa9, 0x08070a05, 0x2b002704,   // sl.pl.hr_432 lv.da.is_544  mk.bg.uk_333 gd.vi.un_320
  0x532520a4, 0x07041707, 0x190b0a05, 0x0a041707,   // sq.eu.ht_433 sr.ru.bg_432  pt.es.gl_333 sr.ru.mk_432
  0x17321604, 0x23181f04, 0x04002d08, 0x23070ba4,   // hr.bs.sr_332 cy.ga.ca_332  sk.fi.un_430 es.it.ca_433
  // [06f0]
  0x1c0d09ec, 0x0804170e, 0x250723a0, 0x06050111,   // hi.ne.mr_644 sr.ru.uk_555  ca.it.eu_322 en.fr.de_653
  0x072a19ee, 0x31001f05, 0x27001f0d, 0x0f001021,   // gl.mt.it_422 cy.az.un_330  cy.gd.un_540 lt.lv.un_860
  0x1f05010c, 0x170407a4, 0x0a001021, 0x110504ee,   // en.fr.cy_543 bg.ru.sr_433  be.mk.un_860 fi.fr.ro_422
  0x5300550c, 0x0a071702, 0x4a00532a, 0x2b001c12,   // rw.ht.un_530 sr.bg.mk_222  ht.yo.un_970 id.vi.un_640
  // [0700]
  0x0d122d55, 0x1c0d09af, 0x1b063f5a, 0x0a071104,   // sk.hu.cs_442 hi.ne.mr_655  af.de.tr_553 ro.bg.mk_332
  0x3b005202, 0x080407a4, 0x00002703, 0x213b1f08,   // ha.so.un_220 bg.ru.uk_433  gd.un.un_300 cy.so.jw_443
  0x2b001c0c, 0x290f2dad, 0x043113af, 0x0c080e0c,   // id.vi.un_530 sk.lv.sl_643  et.az.fi_655 is.no.sv_543
  0x2d2920af, 0x292d0da4, 0x53001308, 0x2a0413ad,   // sq.sl.sk_655 cs.sk.sl_433  et.ht.un_430 et.fi.mt_643
  // [0710]
  0x35080214, 0x08000c0d, 0x0c0413a4, 0x00003106,   // da.no.zu_666 sv.no.un_540  et.fi.sv_433 az.un.un_400
  0x3b0955af, 0x3213040c, 0x100964a4, 0x3b001f05,   // rw.pl.so_655 fi.et.bs_543  lg.pl.lt_433 cy.so.un_330
  0x0e001213, 0x281129af, 0x55683505, 0x1b312d08,   // hu.is.un_650 sl.ro.sw_655  zu.ig.rw_333 sk.az.tr_443
  0x160f13a4, 0x282a5207, 0x095525a4, 0x35006405,   // et.lv.hr_433 ha.mt.sw_432  eu.rw.pl_433 lg.zu.un_330
  // [0720]
  0x106e06a4, 0x081004a4, 0x0000230f, 0x1f002702,   // de.hmn.lt_433 ru.be.uk_433  ca.un.un_600 gd.cy.un_220
  0x642835a7, 0x09312008, 0x35006b04, 0x0b0a3ba4,   // zu.sw.lg_532 sq.az.pl_443  ceb.zu.un_320 so.pt.es_433
  0x0e2d090c, 0x17040807, 0x0a001108, 0x1b292d07,   // pl.sk.is_543 uk.ru.sr_432  ro.mk.un_430 sk.sl.tr_432
  0x0e000c02, 0x2a00180d, 0x13122aa4, 0x17000a09,   // sv.is.un_220 ga.mt.un_540  mt.hu.et_433 mk.sr.un_440
  // [0730]
  0x0c083fee, 0x202d0d14, 0x2d1f2708, 0x35000b08,   // af.no.sv_422 cs.sk.sq_666  gd.cy.sk_443 es.zu.un_430
  0x231e1c0c, 0x0e1a6b08, 0x121013a7, 0x2855640b,   // id.ms.ca_543 ceb.tl.is_443  et.lt.hu_532 lg.rw.sw_542
  0x071013ee, 0x1f00270d, 0x0000012d, 0x352d0d13,   // et.lt.it_422 gd.cy.un_540  en.un.un_A00 cs.sk.zu_665
  0x09001c08, 0x3b5552a7, 0x2d0413ad, 0x6e00532a,   // mr.hi.un_430 ha.rw.so_532  et.fi.sk_643 ht.hmn.un_970
  // [0740]
  0x1300091a, 0x03005212, 0x1200180e, 0x00000d03,   // hi.bh.un_760 ha.nl.un_640  ga.hu.un_550 cs.un.un_300
  0x13001c08, 0x095511ee, 0x0000102d, 0x12006b09,   // id.et.un_430 ro.rw.pl_422  lt.un.un_A00 ceb.hu.un_440
  0x00001e06, 0x08001113, 0x2a002304, 0x64002813,   // ms.un.un_400 ro.uk.un_650  ca.mt.un_320 sw.lg.un_650
  0x03003f12, 0x08020c02, 0x012d0d0e, 0x17551155,   // af.nl.un_640 sv.da.no_222  cs.sk.en_555 ro.rw.sr_442
  // [0750]
  0x070411af, 0x11645513, 0x060c07a0, 0x033f2707,   // ro.ru.bg_655 rw.lg.ro_665  it.sv.de_322 gd.af.nl_432
  0x171632ee, 0x0c232b08, 0x1100550e, 0x13000513,   // bs.hr.sr_422 vi.ca.sv_443  rw.ro.un_550 fr.et.un_650
  0x0a040708, 0x0e04060c, 0x080411af, 0x20216412,   // bg.ru.mk_443 de.fi.is_543  ro.ru.uk_655 lg.jw.sq_654
  0x0e041e07, 0x033f1f0c, 0x04000e04, 0x2d002913,   // ms.fi.is_432 cy.af.nl_543  is.fi.un_320 sl.sk.un_650
  // [0760]
  0x27183507, 0x55110a05, 0x28643504, 0x211e1c0c,   // zu.ga.gd_432 pt.ro.rw_333  zu.lg.sw_332 id.ms.jw_543
  0x07171105, 0x04000821, 0x2805010c, 0x17070aa4,   // ro.sr.bg_333 uk.ru.un_860  en.fr.sw_543 mk.bg.sr_433
  0x0d0913a9, 0x253f0307, 0x0400100c, 0x05000b02,   // bh.hi.ne_544 nl.af.eu_432  be.ru.un_530 es.fr.un_220
  0x16321755, 0x00001a0a, 0x68203555, 0x1a0b6b0c,   // sr.bs.hr_442 tl.un.un_500  zu.sq.ig_442 ceb.es.tl_543
  // [0770]
  0x0d00091a, 0x280611ee, 0x0e020c14, 0x09005321,   // hi.ne.un_760 ro.de.sw_422  sv.da.is_666 ht.pl.un_860
  0x28353b0c, 0x2d000d22, 0x052b0c08, 0x6e003f08,   // so.zu.sw_543 cs.sk.un_870  sv.vi.fr_443 af.hmn.un_430
  0x13000d08, 0x10170a08, 0x0c00082c, 0x2d0d29a4,   // ne.bh.un_430 mk.sr.be_443  no.sv.un_990 sl.cs.sk_433
  0x2304010c, 0x3b0e11a4, 0x12682a08, 0x00004a24,   // en.fi.ca_543 ro.is.so_433  mt.ig.hu_443 yo.un.un_900
  // [0780]
  0x05003504, 0x251b1e0c, 0x0000272d, 0x3120010c,   // zu.fr.un_320 ms.tr.eu_543  gd.un.un_A00 en.sq.az_543
  0x6e1f1913, 0x07170a14, 0x0c00022c, 0x2902160c,   // gl.cy.hmn_665 mk.sr.bg_666  da.sv.un_990 hr.da.sl_543
  0x52000804, 0x00000e01, 0x1e211caf, 0x060e08a9,   // no.ha.un_320 is.un.un_200  id.jw.ms_655 no.is.de_544
  0x17002308, 0x24000122, 0x0c001912, 0x0c082307,   // ca.sr.un_430 iw.yi.un_870  gl.sv.un_640 ca.no.sv_432
  // [0790]
  0x04001113, 0x04001004, 0x280c550c, 0x25170aa0,   // ro.ru.un_650 be.ru.un_320  rw.sv.sw_543 pt.sr.eu_322
  0x1c6b55ad, 0x06006e12, 0x16002907, 0x230a19a0,   // rw.ceb.id_643 hmn.de.un_640  sl.hr.un_420 gl.pt.ca_322
  0x01296bee, 0x00000606, 0x11000108, 0x55521e0c,   // ceb.sl.en_422 de.un.un_400  en.ro.un_430 ms.ha.rw_543
  0x0f002302, 0x21283511, 0x170a11a4, 0x00003f1c,   // ca.lv.un_220 zu.sw.jw_653  ro.mk.sr_433 af.un.un_800
  // [07a0]
  0x3216290e, 0x04071004, 0x0e020c13, 0x0b0a190e,   // sl.hr.bs_555 be.bg.ru_332  sv.da.is_665 gl.pt.es_555
  0x05522aad, 0x286404ad, 0x20003f0d, 0x040c08a4,   // mt.ha.fr_643 fi.lg.sw_643  af.sq.un_540 no.sv.fi_433
  0x53001a0c, 0x2900110d, 0x17002d04, 0x0d2911a7,   // tl.ht.un_530 ro.sl.un_540  sk.sr.un_320 ro.sl.cs_532
  0x0400101a, 0x201c1ea0, 0x6b276e0c, 0x10062005,   // be.ru.un_760 ms.id.sq_322  hmn.gd.ceb_543 sq.de.lt_333
  // [07b0]
  0x1e1c1fa9, 0x2d0d1909, 0x55251c0c, 0x03000804,   // cy.id.ms_544 gl.cs.sk_444  id.eu.rw_543 no.nl.un_320
  0x0600032c, 0x230701a4, 0x00000a01, 0x0b5223a0,   // nl.de.un_990 en.it.ca_433  mk.un.un_200 ca.ha.es_322
  0x04001313, 0x2d0d12a0, 0x3b1c1eee, 0x21131ca6,   // et.fi.un_650 hu.cs.sk_322  ms.id.so_422 id.et.jw_521
  0x1200050d, 0x21181213, 0x033f050c, 0x05006419,   // fr.hu.un_540 ur.ar.fa_665  fr.af.nl_543 lg.fr.un_750
  // [07c0]
  0x1b003113, 0x08000611, 0x05282b07, 0x1821120c,   // az.tr.un_650 de.no.un_630  vi.sw.fr_432 ur.fa.ar_543
  0x07100413, 0x6b000412, 0x32000908, 0x1b1e1c05,   // ru.be.bg_665 fi.ceb.un_640  pl.bs.un_430 id.ms.tr_333
  0x0a040809, 0x31006b02, 0x00000e24, 0x10033f08,   // uk.ru.mk_444 ceb.az.un_220  is.un.un_900 af.nl.lt_443
  0x11050112, 0x10006b04, 0x0e5235ad, 0x211e1cee,   // en.fr.ro_654 ceb.lt.un_320  zu.ha.is_643 id.ms.jw_422
  // [07d0]
  0x0a002309, 0x131b31b3, 0x1200211b, 0x2d0d0e0e,   // ca.pt.un_440 az.tr.et_743  fa.ur.un_770 is.cs.sk_555
  0x06020c14, 0x1c001e0c, 0x313f010c, 0x1c090da0,   // sv.da.de_666 ms.id.un_530  en.af.az_543 ne.hi.mr_322
  0x09002a04, 0x00001b1c, 0x1710010c, 0x0f002314,   // mt.pl.un_320 tr.un.un_800  en.lt.sr_543 ca.lv.un_660
  0x13230c08, 0x29000d08, 0x11002a0e, 0x322d0d08,   // sv.ca.et_443 cs.sl.un_430  mt.ro.un_550 cs.sk.bs_443
  // [07e0]
  0x0a002313, 0x19000a2c, 0x0000231c, 0x13013b04,   // ca.pt.un_650 pt.gl.un_990  ca.un.un_800 so.en.et_332
  0x07001602, 0x040501ec, 0x13001c09, 0x050a230e,   // hr.it.un_220 en.fr.fi_644  mr.bh.un_440 ca.pt.fr_555
  0x25000512, 0x0500012b, 0x030208a4, 0x04070a13,   // fr.eu.un_640 en.fr.un_980  no.da.nl_433 mk.bg.ru_665
  0x1e111caf, 0x0c0523ec, 0x0a310eac, 0x2d0d0c09,   // id.ro.ms_655 ca.fr.sv_644  is.az.pt_632 sv.cs.sk_444
  // [07f0]
  0x12000a02, 0x00002303, 0x0a08040d, 0x050c23ad,   // pt.hu.un_220 ca.un.un_300  ru.uk.mk_554 ca.sv.fr_643
  0x0000191c, 0x29092da4, 0x3b003f05, 0x3f3b0313,   // gl.un.un_800 sk.pl.sl_433  af.so.un_330 nl.so.af_665
  0x11120807, 0x250b53a0, 0x05002313, 0x3500640c,   // no.hu.ro_432 ht.es.eu_322  ca.fr.un_650 lg.zu.un_530
  0x05002319, 0x32000d0d, 0x28001a13, 0x08100a05,   // ca.fr.un_750 cs.bs.un_540  tl.sw.un_650 mk.be.uk_333

  // [0800]
  0x06003113, 0x10033f0c, 0x0a25010c, 0x10005219,   // az.de.un_650 af.nl.lt_543  en.eu.pt_543 ha.lt.un_750
  0x0d320ba0, 0x16002908, 0x0500010d, 0x0a006402,   // es.bs.cs_322 sl.hr.un_430  en.fr.un_540 lg.pt.un_220
  0x08021b0c, 0x05000122, 0x1b003114, 0x2100181a,   // tr.da.no_543 en.fr.un_870  az.tr.un_660 ar.fa.un_760
  0x17272307, 0x2100050c, 0x0207080c, 0x0c002311,   // ca.gd.sr_432 fr.jw.un_530  no.it.da_543 ca.sv.un_630
  // [0810]
  0x0120680c, 0x0a080408, 0x211c1e11, 0x00002324,   // ig.sq.en_543 ru.uk.mk_443  ms.id.jw_653 ca.un.un_900
  0x6800080d, 0x160802a4, 0x13000913, 0x0703080c,   // no.ig.un_540 da.no.hr_433  hi.bh.un_650 no.nl.it_543
  0x250c2308, 0x110a0712, 0x0c002308, 0x21001208,   // ca.sv.eu_443 bg.mk.ro_654  ca.sv.un_430 ur.fa.un_430
  0x0a53680c, 0x1600290b, 0x130c2307, 0x091c1304,   // ig.ht.pt_543 sl.hr.un_520  ca.sv.et_432 bh.mr.hi_332
  // [0820]
  0x6408020d, 0x0200080c, 0x20002908, 0x29005502,   // da.no.lg_554 no.da.un_530  sl.sq.un_430 rw.sl.un_220
  0x00002906, 0x0b0a1902, 0x1b003111, 0x68005523,   // sl.un.un_400 gl.pt.es_222  az.tr.un_630 rw.ig.un_880
  0x32000d04, 0x12211812, 0x181f2712, 0x0207110c,   // cs.bs.un_320 ar.fa.ur_654  gd.cy.ga_654 ro.it.da_543
  0x32001604, 0x1f1729ee, 0x00006824, 0x060e3f55,   // hr.bs.un_320 sl.sr.cy_422  ig.un.un_900 af.is.de_442
  // [0830]
  0x20110f5a, 0x092d0d60, 0x55190bad, 0x0000010a,   // lv.ro.sq_553 cs.sk.pl_664  es.gl.rw_643 en.un.un_500
  0x27001813, 0x53311b0c, 0x32172909, 0x281827a4,   // ga.gd.un_650 tr.az.ht_543  sl.sr.bs_444 gd.ga.sw_433
  0x29005313, 0x08020714, 0x1b001e04, 0x3f001e0d,   // ht.sl.un_650 it.da.no_666  ms.tr.un_320 ms.af.un_540
  0x2818270e, 0x16000d04, 0x290668a9, 0x13002a1a,   // gd.ga.sw_555 cs.hr.un_320  ig.de.sl_544 mt.et.un_760
  // [0840]
  0x080c0e07, 0x13642a0c, 0x080255ec, 0x643207ee,   // is.sv.no_432 mt.lg.et_543  rw.da.no_644 it.bs.lg_422
  0x68002519, 0x0607080c, 0x1a6b1c0c, 0x07080a08,   // eu.ig.un_750 no.it.de_543  id.ceb.tl_543 mk.uk.bg_443
  0x043f0308, 0x075368a9, 0x1b003123, 0x10040855,   // nl.af.fi_443 ig.ht.it_544  az.tr.un_880 uk.ru.be_442
  0x07102708, 0x20000619, 0x19050b07, 0x203f0807,   // gd.lt.it_443 de.sq.un_750  es.fr.gl_432 no.af.sq_432
  // [0850]
  0x1b00310d, 0x03172007, 0x1c001e34, 0x0d1c09a9,   // az.tr.un_540 sq.sr.nl_432  ms.id.un_A80 hi.mr.ne_544
  0x21001c1a, 0x121e1c55, 0x2b27010c, 0x1f1827af,   // id.jw.un_760 id.ms.hu_442  en.gd.vi_543 gd.ga.cy_655
  0x0000320a, 0x211c1e0c, 0x2b641ca4, 0x6b033f0d,   // bs.un.un_500 ms.id.jw_543  id.lg.vi_433 af.nl.ceb_554
  0x211e1c09, 0x09000d0d, 0x06000113, 0x1007040c,   // id.ms.jw_444 cs.pl.un_540  en.de.un_650 ru.bg.be_543
  // [0860]
  0x08171112, 0x1b090ea4, 0x010a23a0, 0x55002d0d,   // ro.sr.uk_654 is.pl.tr_433  ca.pt.en_322 sk.rw.un_540
  0x6b3b31a9, 0x00000603, 0x00000506, 0x1e001c1b,   // az.so.ceb_544 de.un.un_300  fr.un.un_400 id.ms.un_770
  0x521603a0, 0x31131b08, 0x0d1c09ad, 0x0e0164ee,   // nl.hr.ha_322 tr.et.az_443  hi.mr.ne_643 lg.en.is_422
  0x110604a7, 0x112009ee, 0x050d2107, 0x29002d1a,   // fi.de.ro_532 pl.sq.ro_422  jw.cs.fr_432 sk.sl.un_760
  // [0870]
  0x0000681c, 0x031e3fa0, 0x12182113, 0x2d090d07,   // ig.un.un_800 af.ms.nl_322  fa.ar.ur_665 cs.pl.sk_432
  0x12190b13, 0x18001213, 0x19000b0d, 0x1e001c19,   // es.gl.hu_665 ur.ar.un_650  es.gl.un_540 id.ms.un_750
  0x0a040705, 0x0c00131b, 0x05001908, 0x2b1801a6,   // bg.ru.mk_333 et.sv.un_770  gl.fr.un_430 en.ga.vi_521
  0x0f095508, 0x1600290e, 0x0a04110c, 0x081f120c,   // rw.pl.lv_443 sl.hr.un_550  ro.ru.mk_543 hu.cy.no_543
  // [0880]
  0x122005a4, 0x11001f05, 0x1a080a12, 0x28556407,   // fr.sq.hu_433 cy.ro.un_330  pt.no.tl_654 lg.rw.sw_432
  0x06000c12, 0x131f35ee, 0x1e1c21a4, 0x190a2309,   // sv.de.un_640 zu.cy.et_422  jw.id.ms_433 ca.pt.gl_444
  0x11000104, 0x01033f02, 0x06080208, 0x0c000804,   // en.ro.un_320 af.nl.en_222  da.no.de_443 no.sv.un_320
  0x52001320, 0x202135ec, 0x18003504, 0x21042bee,   // et.ha.un_850 zu.jw.sq_644  zu.ga.un_320 vi.fi.jw_422
  // [0890]
  0x1e001c0c, 0x250418ad, 0x0f4a0a07, 0x4a52350c,   // id.ms.un_530 ga.fi.eu_643  pt.yo.lv_432 zu.ha.yo_543
  0x09001c0d, 0x0400171b, 0x292d03ec, 0x2b0e2104,   // mr.hi.un_540 sr.ru.un_770  nl.sk.sl_644 jw.is.vi_332
  0x0f1f5205, 0x190a23a0, 0x04060c67, 0x3f00061b,   // ha.cy.lv_333 ca.pt.gl_322  sv.de.fi_775 de.af.un_770
  0x04060c0c, 0x06001114, 0x02000809, 0x23190a02,   // sv.de.fi_543 ro.de.un_660  no.da.un_440 pt.gl.ca_222
  // [08a0]
  0x08200cad, 0x1b4a2504, 0x1b2906a4, 0x04130c55,   // sv.sq.no_643 eu.yo.tr_332  de.sl.tr_433 sv.et.fi_442
  0x2d190b07, 0x08022012, 0x1900050e, 0x55356404,   // es.gl.sk_432 sq.da.no_654  fr.gl.un_550 lg.zu.rw_332
  0x1a044a12, 0x18190b09, 0x13060c0c, 0x1b645504,   // yo.fi.tl_654 es.gl.ga_444  sv.de.et_543 rw.lg.tr_332
  0x2b006e2a, 0x1c55210c, 0x00003206, 0x0d1c1355,   // hmn.vi.un_970 jw.rw.id_543  bs.un.un_400 bh.mr.ne_442
  // [08b0]
  0x04001112, 0x28005509, 0x32002008, 0x21001c13,   // ro.ru.un_640 rw.sw.un_440  sq.bs.un_430 id.jw.un_650
  0x0f202912, 0x3f02040c, 0x08002b13, 0x2b0a6807,   // sl.sq.lv_654 fi.da.af_543  vi.no.un_650 ig.pt.vi_432
  0x6800552a, 0x12006e23, 0x172923a4, 0x68040aee,   // rw.ig.un_970 hmn.hu.un_880  ca.sl.sr_433 pt.fi.ig_422
  0x27002b34, 0x0c0802ac, 0x53001022, 0x0f002507,   // vi.gd.un_A80 da.no.sv_632  lt.ht.un_870 eu.lv.un_420
  // [08c0]
  0x0b1f13ec, 0x6b190a11, 0x2a00531b, 0x2a536e5a,   // et.cy.es_644 pt.gl.ceb_653  ht.mt.un_770 hmn.ht.mt_553
  0x09004a12, 0x1b003119, 0x190b18ee, 0x1308180c,   // yo.pl.un_640 az.tr.un_750  ga.es.gl_422 ga.no.et_543
  0x0e0a0107, 0x02006404, 0x18122112, 0x0802050e,   // en.pt.is_432 lg.da.un_320  fa.ur.ar_654 fr.da.no_555
  0x0400071b, 0x17161a0c, 0x2100280d, 0x00002024,   // bg.ru.un_770 tl.hr.sr_543  sw.jw.un_540 sq.un.un_900
  // [08d0]
  0x4a2a06ec, 0x026408af, 0x6b120e05, 0x056e3f0c,   // de.mt.yo_644 no.lg.da_655  is.hu.ceb_333 af.hmn.fr_543
  0x0d13090d, 0x17071008, 0x06002013, 0x0a063f07,   // hi.bh.ne_554 be.bg.sr_443  sq.de.un_650 af.de.pt_432
  0x18000708, 0x1f002a29, 0x1c10210c, 0x0f001b05,   // it.ga.un_430 mt.cy.un_960  jw.lt.id_543 tr.lv.un_330
  0x00000c03, 0x20002d1a, 0x1c211eaf, 0x01006e02,   // sv.un.un_300 sk.sq.un_760  ms.jw.id_655 hmn.en.un_220
  // [08e0]
  0x080213a0, 0x11006e1a, 0x1268640c, 0x2d6413a4,   // et.da.no_322 hmn.ro.un_760  lg.ig.hu_543 et.lg.sk_433
  0x11003b08, 0x1300041a, 0x2b3b1704, 0x212d0d55,   // so.ro.un_430 fi.et.un_760  sr.so.vi_332 cs.sk.jw_442
  0x041a11af, 0x2300190d, 0x2d13100c, 0x2d1064a4,   // ro.tl.fi_655 gl.ca.un_540  lt.et.sk_543 lg.lt.sk_433
  0x1f003208, 0x04000a13, 0x1b20180c, 0x6e00272a,   // bs.cy.un_430 mk.ru.un_650  ga.sq.tr_543 gd.hmn.un_970
  // [08f0]
  0x28060b04, 0x23001904, 0x1c005204, 0x1f080c05,   // es.de.sw_332 gl.ca.un_320  ha.id.un_320 sv.no.cy_333
  0x09233108, 0x011a6ba0, 0x3b3119a9, 0x10080209,   // az.ca.pl_443 ceb.tl.en_322  gl.az.so_544 da.no.lt_444
  0x020c08a4, 0x00002106, 0x200f29a4, 0x08003202,   // no.sv.da_433 fa.un.un_400  sl.lv.sq_433 bs.no.un_220
  0x2d001014, 0x0d0913af, 0x27061aa0, 0x1f2519a9,   // lt.sk.un_660 bh.hi.ne_655  tl.de.gd_322 gl.eu.cy_544
  // [0900]
  0x07001a09, 0x00003f01, 0x131b2008, 0x02000a19,   // tl.it.un_440 af.un.un_200  sq.tr.et_443 pt.da.un_750
  0x321617ee, 0x093f0308, 0x1a041812, 0x12000a0c,   // sr.hr.bs_422 nl.af.pl_443  ga.fi.tl_654 pt.hu.un_530
  0x1c000104, 0x271c04a0, 0x0d00091b, 0x10291a12,   // en.id.un_320 fi.id.gd_322  hi.ne.un_770 tl.sl.lt_654
  0x29321605, 0x00000306, 0x023b1f0d, 0x0d000908,   // hr.bs.sl_333 nl.un.un_400  cy.so.da_554 hi.ne.un_430
  // [0910]
  0x1b0c06ec, 0x680f0107, 0x07041008, 0x1c000d0e,   // de.sv.tr_644 en.lv.ig_432  be.ru.bg_443 ne.mr.un_550
  0x17166ba4, 0x00004a01, 0x29321704, 0x2900170c,   // ceb.hr.sr_433 yo.un.un_200  sr.bs.sl_332 sr.sl.un_530
  0x0523010c, 0x031b2807, 0x1a080ea0, 0x283b0904,   // en.ca.fr_543 sw.tr.nl_432  is.no.tl_322 pl.so.sw_332
  0x0a0407a9, 0x07040a08, 0x170a0712, 0x252b20ec,   // bg.ru.mk_544 mk.ru.bg_443  bg.mk.sr_654 sq.vi.eu_644
  // [0920]
  0x09000614, 0x296b1a08, 0x2a126e14, 0x0a100708,   // de.pl.un_660 tl.ceb.sl_443  hmn.hu.mt_666 bg.be.mk_443
  0x55643b14, 0x32170f02, 0x4a0c200e, 0x23110107,   // so.lg.rw_666 lv.sr.bs_222  sq.sv.yo_555 en.ro.ca_432
  0x27556460, 0x25050704, 0x1c054a12, 0x190a53af,   // lg.rw.gd_664 it.fr.eu_332  yo.fr.id_654 ht.pt.gl_655
  0x020c11af, 0x05190b0e, 0x0c060308, 0x05000e22,   // ro.sv.da_655 es.gl.fr_555  nl.de.sv_443 is.fr.un_870
  // [0930]
  0x28110513, 0x190a2314, 0x68311b13, 0x09002904,   // fr.ro.sw_665 ca.pt.gl_666  tr.az.ig_665 sl.pl.un_320
  0x00001137, 0x13091caf, 0x0a1923ad, 0x1a000c04,   // ro.un.un_B00 mr.hi.bh_655  ca.gl.pt_643 sv.tl.un_320
  0x110a1faf, 0x0723080c, 0x182027a4, 0x68071f0c,   // cy.pt.ro_655 no.ca.it_543  gd.sq.ga_433 cy.it.ig_543
  0x190b2dee, 0x2a006b07, 0x080a1014, 0x00002424,   // sk.es.gl_422 ceb.mt.un_420  be.mk.uk_666 yi.un.un_900
  // [0940]
  0x1e1c6ea0, 0x120f5211, 0x29000909, 0x0000062d,   // hmn.id.ms_322 ha.lv.hu_653  pl.sl.un_440 de.un.un_A00
  0x07080e0b, 0x0d00291a, 0x32230e07, 0x6e002b19,   // is.no.it_542 sl.cs.un_760  is.ca.bs_432 vi.hmn.un_750
  0x2a6b1aaf, 0x3b28520d, 0x1f05530b, 0x0300251a,   // tl.ceb.mt_655 ha.sw.so_554  ht.fr.cy_542 eu.nl.un_760
  0x0e000c0e, 0x1900230e, 0x03001208, 0x0a192307,   // sv.is.un_550 ca.gl.un_550  hu.nl.un_430 ca.gl.pt_432
  // [0950]
  0x3f1304ad, 0x070a170e, 0x3b006e08, 0x09006b04,   // fi.et.af_643 sr.mk.bg_555  hmn.so.un_430 ceb.pl.un_320
  0x0f4a3113, 0x2d100da4, 0x0400080d, 0x12001105,   // az.yo.lv_665 cs.lt.sk_433  uk.ru.un_540 ro.hu.un_330
  0x2b1605ec, 0x55006b1a, 0x0a0408af, 0x190a23ec,   // fr.hr.vi_644 ceb.rw.un_760  uk.ru.mk_655 ca.pt.gl_644
  0x102b050c, 0x0a001119, 0x1700290d, 0x01524a07,   // fr.vi.lt_543 ro.mk.un_750  sl.sr.un_540 yo.ha.en_432
  // [0960]
  0x05280ba9, 0x0f160da0, 0x00003b2d, 0x011f120c,   // es.sw.fr_544 cs.hr.lv_322  so.un.un_A00 hu.cy.en_543
  0x13002a19, 0x1b003108, 0x0400170c, 0x311b1c07,   // mt.et.un_750 az.tr.un_430  sr.ru.un_530 id.tr.az_432
  0x17002904, 0x4a2b01ee, 0x2d0d09af, 0x04081007,   // sl.sr.un_320 en.vi.yo_422  pl.cs.sk_655 be.uk.ru_432
  0x00002137, 0x13071f0c, 0x29080202, 0x08101107,   // fa.un.un_B00 cy.it.et_543  da.no.sl_222 ro.be.uk_432
  // [0970]
  0x2b005304, 0x03001607, 0x170a10a4, 0x08100708,   // ht.vi.un_320 hr.nl.un_420  be.mk.sr_433 bg.be.uk_443
  0x09110d07, 0x03291208, 0x0a102507, 0x525506a4,   // cs.ro.pl_432 hu.sl.nl_443  eu.lt.pt_432 de.rw.ha_433
  0x29002504, 0x2a094a08, 0x030208ec, 0x20042902,   // eu.sl.un_320 yo.pl.mt_443  no.da.nl_644 sl.fi.sq_222
  0x1b310e08, 0x09001302, 0x322907a9, 0x0c1b0e05,   // is.az.tr_443 bh.hi.un_220  it.sl.bs_544 is.tr.sv_333
  // [0980]
  0x00002306, 0x040764a9, 0x1300020e, 0x53000d04,   // ca.un.un_400 lg.it.fi_544  da.et.un_550 cs.ht.un_320
  0x2900101a, 0x072327a4, 0x0000122d, 0x08000422,   // lt.sl.un_760 gd.ca.it_433  ur.un.un_A00 ru.uk.un_870
  0x29001605, 0x1f0853ee, 0x01002418, 0x2b00270c,   // hr.sl.un_330 ht.no.cy_422  yi.iw.un_740 gd.vi.un_530
  0x041c1e12, 0x07000a0e, 0x29110f07, 0x072a11af,   // ms.id.fi_654 mk.bg.un_550  lv.ro.sl_432 ro.mt.it_655
  // [0990]
  0x27003b1a, 0x0a070412, 0x17000a1b, 0x08170aa4,   // so.gd.un_760 ru.bg.mk_654  mk.sr.un_770 mk.sr.uk_433
  0x32311b09, 0x3100090d, 0x0d000914, 0x04000718,   // tr.az.bs_444 pl.az.un_540  hi.ne.un_660 bg.ru.un_740
  0x3f002704, 0x1c0913a7, 0x063f0304, 0x1b003112,   // gd.af.un_320 bh.hi.mr_532  nl.af.de_332 az.tr.un_640
  0x29311ba0, 0x18002104, 0x2a093b0d, 0x2a311b0c,   // tr.az.sl_322 jw.ga.un_320  so.pl.mt_554 tr.az.mt_543
  // [09a0]
  0x0a0717af, 0x3f0e06a4, 0x07311b0d, 0x1c091314,   // sr.bg.mk_655 de.is.af_433  tr.az.it_554 bh.hi.mr_666
  0x2d0d0914, 0x17000a1a, 0x32001e04, 0x21001219,   // pl.cs.sk_666 mk.sr.un_760  ms.bs.un_320 ur.fa.un_750
  0x0704100c, 0x1c0d09a4, 0x0e0b0a05, 0x00005206,   // be.ru.bg_543 hi.ne.mr_433  pt.es.is_333 ha.un.un_400
  0x2a3b3112, 0x01203fa0, 0x3500550d, 0x06000804,   // az.so.mt_654 af.sq.en_322  rw.zu.un_540 no.de.un_320
  // [09b0]
  0x110417a4, 0x07040a02, 0x19000a09, 0x09292da0,   // sr.ru.ro_433 mk.ru.bg_222  pt.gl.un_440 sk.sl.pl_322
  0x11040713, 0x07001119, 0x64003504, 0x04110607,   // bg.ru.ro_665 ro.bg.un_750  zu.lg.un_320 de.ro.fi_432
  0x07170a0d, 0x05002012, 0x2a00072a, 0x2000051a,   // mk.sr.bg_554 sq.fr.un_640  it.mt.un_970 fr.sq.un_760
  0x131b0ca0, 0x1b001319, 0x28002018, 0x08022aee,   // sv.tr.et_322 et.tr.un_750  sq.sw.un_740 mt.da.no_422
  // [09c0]
  0x1a0c290d, 0x1c0d1302, 0x091c0d0c, 0x35005222,   // sl.sv.tl_554 bh.ne.mr_222  ne.mr.hi_543 ha.zu.un_870
  0x00002103, 0x27001e07, 0x0e061f07, 0x040810a4,   // jw.un.un_300 ms.gd.un_420  cy.de.is_432 be.uk.ru_433
  0x09001c1a, 0x0f1c1fa4, 0x1e001c09, 0x2300251a,   // mr.hi.un_760 cy.id.lv_433  id.ms.un_440 eu.ca.un_760
  0x07113512, 0x0f000519, 0x121b3112, 0x16321713,   // zu.ro.it_654 fr.lv.un_750  az.tr.hu_654 sr.bs.hr_665
  // [09d0]
  0x356b68ad, 0x00001606, 0x04351f0b, 0x055303a0,   // ig.ceb.zu_643 hr.un.un_400  cy.zu.fi_542 nl.ht.fr_322
  0x10283512, 0x171305ad, 0x1e282a04, 0x21001222,   // zu.sw.lt_654 fr.et.sr_643  mt.sw.ms_332 ur.fa.un_870
  0x12006407, 0x10682108, 0x1e001c04, 0x2a681fad,   // lg.hu.un_420 jw.ig.lt_443  id.ms.un_320 cy.ig.mt_643
  0x03202d07, 0x01026ba0, 0x6827180d, 0x0c00121a,   // sk.sq.nl_432 ceb.da.en_322  ga.gd.ig_554 hu.sv.un_760
  // [09e0]
  0x070a11af, 0x1c002109, 0x31121ca0, 0x31001912,   // ro.mk.bg_655 jw.id.un_440  id.hu.az_322 gl.az.un_640
  0x4a286409, 0x3f060308, 0x112d0d0d, 0x080e0608,   // lg.sw.yo_444 nl.de.af_443  cs.sk.ro_554 de.is.no_443
  0x06002507, 0x12000a19, 0x040717ad, 0x011e2107,   // eu.de.un_420 pt.hu.un_750  sr.bg.ru_643 jw.ms.en_432
  0x131e1c05, 0x06006b08, 0x28002014, 0x35271804,   // id.ms.et_333 ceb.de.un_430  sq.sw.un_660 ga.gd.zu_332
  // [09f0]
  0x06033fee, 0x3b6b1a07, 0x0d091311, 0x082102a4,   // af.nl.de_422 tl.ceb.so_432  bh.hi.ne_653 da.jw.no_433
  0x08001e05, 0x1b000811, 0x35211814, 0x08001007,   // ms.no.un_330 no.tr.un_630  ga.jw.zu_666 be.uk.un_420
  0x04001321, 0x104a0408, 0x1312040c, 0x10071208,   // et.fi.un_860 fi.yo.lt_443  fi.hu.et_543 hu.it.lt_443
  0x1f0705ec, 0x0f090da4, 0x080c02ee, 0x03003f04,   // fr.it.cy_644 cs.pl.lv_433  da.sv.no_422 af.nl.un_320
  // [0a00]
  0x112d0d12, 0x1a001b22, 0x3f003202, 0x0000550a,   // cs.sk.ro_654 tr.tl.un_870  bs.af.un_220 rw.un.un_500
  0x32052302, 0x2b000d04, 0x19231807, 0x1f001a04,   // ca.fr.bs_222 cs.vi.un_320  ga.ca.gl_432 tl.cy.un_320
  0x080410a4, 0x12002d09, 0x1c002b05, 0x1b00312c,   // be.ru.uk_433 sk.hu.un_440  vi.id.un_330 az.tr.un_990
  0x01002907, 0x1c000d08, 0x07000414, 0x00000315,   // sl.en.un_420 ne.mr.un_430  ru.bg.un_660 nl.un.un_700
  // [0a10]
  0x3f0603a4, 0x06000314, 0x03001f0d, 0x040a17a4,   // nl.de.af_433 nl.de.un_660  cy.nl.un_540 sr.mk.ru_433
  0x0400100d, 0x01003f04, 0x1c00091b, 0x120519a6,   // be.ru.un_540 af.en.un_320  hi.mr.un_770 gl.fr.hu_521
  0x10000814, 0x1800210c, 0x0f030cee, 0x13003119,   // uk.be.un_660 fa.ar.un_530  sv.nl.lv_422 az.et.un_750
  0x1f2718af, 0x1a352707, 0x1b1101a4, 0x110710ad,   // ga.gd.cy_655 gd.zu.tl_432  en.ro.tr_433 be.bg.ro_643
  // [0a20]
  0x321716af, 0x0d002d19, 0x072a05a7, 0x321723a0,   // hr.sr.bs_655 sk.cs.un_750  fr.mt.it_532 ca.sr.bs_322
  0x2a3555a9, 0x32170faf, 0x11000413, 0x1c000902,   // rw.zu.mt_544 lv.sr.bs_655  ru.ro.un_650 hi.mr.un_220
  0x04001011, 0x08040a08, 0x00002706, 0x20001904,   // be.ru.un_630 mk.ru.uk_443  gd.un.un_400 gl.sq.un_320
  0x0000682d, 0x12290407, 0x0a001714, 0x100f17a4,   // ig.un.un_A00 fi.sl.hu_432  sr.mk.un_660 sr.lv.lt_433
  // [0a30]
  0x040710ee, 0x0f3f3507, 0x1b2a31ad, 0x080c0212,   // be.bg.ru_422 zu.af.lv_432  az.mt.tr_643 da.sv.no_654
  0x03060cee, 0x08020eec, 0x25001604, 0x28010c55,   // sv.de.nl_422 is.da.no_644  hr.eu.un_320 sv.en.sw_442
  0x02000822, 0x1b6b1a12, 0x1c0d090c, 0x17005504,   // no.da.un_870 tl.ceb.tr_654  hi.ne.mr_543 rw.sr.un_320
  0x123204ee, 0x0a001719, 0x0b0a23af, 0x2a000721,   // fi.bs.hu_422 sr.mk.un_750  ca.pt.es_655 it.mt.un_860
  // [0a40]
  0x35006422, 0x04001005, 0x07001004, 0x0d00130d,   // lg.zu.un_870 be.ru.un_330  be.bg.un_320 bh.ne.un_540
  0x31006b04, 0x2a0f0714, 0x0a001c04, 0x182112a9,   // ceb.az.un_320 it.lv.mt_666  id.pt.un_320 ur.fa.ar_544
  0x04000612, 0x00000b24, 0x64001b20, 0x17000119,   // de.fi.un_640 bn.un.un_900  tr.lg.un_850 en.sr.un_750
  0x0800100d, 0x17070d07, 0x166b2dee, 0x6b1e1c05,   // be.uk.un_540 cs.it.sr_432  sk.ceb.hr_422 id.ms.ceb_333
  // [0a50]
  0x0c003104, 0x0c00060d, 0x04033f5a, 0x00003f0a,   // az.sv.un_320 de.sv.un_540  af.nl.fi_553 af.un.un_500
  0x28006812, 0x0a23010c, 0x2d000d23, 0x252d5305,   // ig.sw.un_640 en.ca.pt_543  cs.sk.un_880 ht.sk.eu_333
  0x32000308, 0x19530ba7, 0x2800550d, 0x3b000414,   // nl.bs.un_430 es.ht.gl_532  rw.sw.un_540 fi.so.un_660
  0x0e0d2d12, 0x043b2555, 0x641a53a7, 0x29210909,   // sk.cs.is_654 eu.so.fi_442  ht.tl.lg_532 pl.jw.sl_444
  // [0a60]
  0x283b03ee, 0x091c1311, 0x3f253bad, 0x55001a02,   // nl.so.sw_422 bh.mr.hi_653  so.eu.af_643 tl.rw.un_220
  0x0e080205, 0x2d0d2baf, 0x281c3107, 0x080a170b,   // da.no.is_333 vi.cs.sk_655  az.id.sw_432 sr.mk.uk_542
  0x07110408, 0x10285208, 0x092a280c, 0x25643b11,   // ru.ro.bg_443 ha.sw.lt_443  sw.mt.pl_543 so.lg.eu_653
  0x556428a4, 0x4a005520, 0x04005205, 0x04000304,   // sw.lg.rw_433 rw.yo.un_850  ha.fi.un_330 nl.fi.un_320
  // [0a70]
  0x100b1307, 0x551c5208, 0x1b002819, 0x0000522d,   // et.es.lt_432 ha.id.rw_443  sw.tr.un_750 ha.un.un_A00
  0x0d001308, 0x1c0d13a0, 0x31001c04, 0x642d6807,   // bh.ne.un_430 bh.ne.mr_322  id.az.un_320 ig.sk.lg_432
  0x55006b18, 0x110d3f04, 0x092d0d09, 0x0c2808a0,   // ceb.rw.un_740 af.cs.ro_332  cs.sk.pl_444 no.sw.sv_322
  0x070408a4, 0x2528520c, 0x4a25550c, 0x04001021,   // no.fi.it_433 ha.sw.eu_543  rw.eu.yo_543 be.ru.un_860
  // [0a80]
  0x686407a4, 0x3f130408, 0x31000804, 0x0c002d12,   // it.lg.ig_433 fi.et.af_443  no.az.un_320 sk.sv.un_640
  0x211e1c02, 0x3f000108, 0x2d0d35ec, 0x4a001e04,   // id.ms.jw_222 en.af.un_430  zu.cs.sk_644 ms.yo.un_320
  0x292a5512, 0x09100d08, 0x172a0c08, 0x2d0d3514,   // rw.mt.sl_654 cs.lt.pl_443  sv.mt.sr_443 zu.cs.sk_666
  0x55002823, 0x0b231908, 0x00001024, 0x211b1ea4,   // sw.rw.un_880 gl.ca.es_443  lt.un.un_900 ms.tr.jw_433
  // [0a90]
  0x0a10080c, 0x284a2105, 0x13000423, 0x28211cad,   // uk.be.mk_543 jw.yo.sw_333  fi.et.un_880 id.jw.sw_643
  0x0a040709, 0x1708110c, 0x120b190c, 0x010705a0,   // bg.ru.mk_444 ro.uk.sr_543  gl.es.hu_543 fr.it.en_322
  0x1e521ca4, 0x1a282714, 0x523f1c04, 0x180b280c,   // id.ha.ms_433 gd.sw.tl_666  id.af.ha_332 sw.es.ga_543
  0x1000311b, 0x1b000813, 0x042d0d08, 0x101117ee,   // az.lt.un_770 no.tr.un_650  cs.sk.fi_443 sr.ro.lt_422
  // [0aa0]
  0x231811a4, 0x04522013, 0x08000214, 0x072519a0,   // ro.ga.ca_433 sq.ha.fi_665  da.no.un_660 gl.eu.it_322
  0x2d005207, 0x040c1c04, 0x1e252007, 0x02001b18,   // ha.sk.un_420 id.sv.fi_332  sq.eu.ms_432 tr.da.un_740
  0x20000c08, 0x03233b13, 0x080c020c, 0x11200408,   // sv.sq.un_430 so.ca.nl_665  da.sv.no_543 fi.sq.ro_443
  0x0a17110c, 0x13090d09, 0x2d001904, 0x31321bec,   // ro.sr.mk_543 ne.hi.bh_444  gl.sk.un_320 tr.bs.az_644
  // [0ab0]
  0x250623a0, 0x0b0a290c, 0x0a171109, 0x25000705,   // ca.de.eu_322 sl.pt.es_543  ro.sr.mk_444 it.eu.un_330
  0x35005519, 0x07040a09, 0x08310ca4, 0x0d2d2912,   // rw.zu.un_750 mk.ru.bg_444  sv.az.no_433 sl.sk.cs_654
  0x1b0e2d07, 0x3b1b1aa9, 0x1600350c, 0x04201fa4,   // sk.is.tr_432 tl.tr.so_544  zu.hr.un_530 cy.sq.fi_433
  0x52353b0c, 0x3528550c, 0x170a0713, 0x11001e04,   // so.zu.ha_543 rw.sw.zu_543  bg.mk.sr_665 ms.ro.un_320
  // [0ac0]
  0x160e0da4, 0x042d0d13, 0x2b20110c, 0x1e1c4aa0,   // cs.is.hr_433 cs.sk.fi_665  ro.sq.vi_543 yo.id.ms_322
  0x3b0e0211, 0x063f03a4, 0x0e08020d, 0x2800181a,   // da.is.so_653 nl.af.de_433  da.no.is_554 ga.sw.un_760
  0x080407ad, 0x68182712, 0x100408a7, 0x131035a0,   // bg.ru.uk_643 gd.ga.ig_654  uk.ru.be_532 zu.lt.et_322
  0x680464a9, 0x27111807, 0x20003513, 0x0b0a19af,   // lg.fi.ig_544 ga.ro.gd_432  zu.sq.un_650 gl.pt.es_655
  // [0ad0]
  0x18002722, 0x25131bec, 0x21072aec, 0x2520190c,   // gd.ga.un_870 tr.et.eu_644  mt.it.jw_644 gl.sq.eu_543
  0x00001e0f, 0x13000912, 0x35552512, 0x11271811,   // ms.un.un_600 hi.bh.un_640  eu.rw.zu_654 ga.gd.ro_653
  0x282b6b02, 0x25000623, 0x04000714, 0x0a1711a4,   // ceb.vi.sw_222 de.eu.un_880  bg.ru.un_660 ro.sr.mk_433
  0x041f2013, 0x2b00010c, 0x061e1ca9, 0x111f200c,   // sq.cy.fi_665 en.vi.un_530  id.ms.de_544 sq.cy.ro_543
  // [0ae0]
  0x042520a4, 0x00000224, 0x062718a7, 0x271118af,   // sq.eu.fi_433 da.un.un_900  ga.gd.de_532 ga.ro.gd_655
  0x2309290c, 0x21190b0e, 0x03001c07, 0x17070a13,   // sl.pl.ca_543 es.gl.jw_555  id.nl.un_420 mk.bg.sr_665
  0x1b352104, 0x091c210c, 0x1f000914, 0x23643509,   // jw.zu.tr_332 jw.id.pl_543  pl.cy.un_660 zu.lg.ca_444
  0x0d1c0911, 0x1c0d0914, 0x1f002a07, 0x28553560,   // hi.mr.ne_653 hi.ne.mr_666  mt.cy.un_420 zu.rw.sw_664
  // [0af0]
  0x0a041712, 0x285268a4, 0x040a1709, 0x1c090d0c,   // sr.ru.mk_654 ig.ha.sw_433  sr.mk.ru_444 ne.hi.mr_543
  0x01061fa7, 0x20351104, 0x271118ad, 0x0d0913a6,   // cy.de.en_532 ro.zu.sq_332  ga.ro.gd_643 bh.hi.ne_521
  0x00002901, 0x2700182b, 0x02182711, 0x2818110c,   // sl.un.un_200 ga.gd.un_980  gd.ga.da_653 ro.ga.sw_543
  0x04110aa4, 0x684a55ec, 0x31001b2b, 0x6e006b05,   // mk.ro.ru_433 rw.yo.ig_644  tr.az.un_980 ceb.hmn.un_330
  // [0b00]
  0x161a2d12, 0x0a071108, 0x041710a4, 0x1b3101a4,   // sk.tl.hr_654 ro.bg.mk_443  be.sr.ru_433 en.az.tr_433
  0x09000d1a, 0x01000d0d, 0x31001b2c, 0x2b040707,   // ne.hi.un_760 cs.en.un_540  tr.az.un_990 it.fi.vi_432
  0x1b5225a7, 0x25001a04, 0x294a255a, 0x1b000804,   // eu.ha.tr_532 tl.eu.un_320  eu.yo.sl_553 no.tr.un_320
  0x041310af, 0x1152350c, 0x1225530d, 0x0e0f2a08,   // lt.et.fi_655 zu.ha.ro_543  ht.eu.hu_554 mt.lv.is_443
  // [0b10]
  0x0c1b310c, 0x1b0208a4, 0x25101a0c, 0x1e1c1a05,   // az.tr.sv_543 no.da.tr_433  tl.lt.eu_543 tl.id.ms_333
  0x1307530b, 0x64285560, 0x11311bad, 0x1c002105,   // ht.it.et_542 rw.sw.lg_664  tr.az.ro_643 jw.id.un_330
  0x0000202d, 0x251b4a5a, 0x0c1a6b0c, 0x1e1c520c,   // sq.un.un_A00 yo.tr.eu_553  ceb.tl.sv_543 ha.id.ms_543
  0x1e1c6405, 0x0e2553a0, 0x11136ba4, 0x27350d11,   // lg.id.ms_333 ht.eu.is_322  ceb.et.ro_433 cs.zu.gd_653
  // [0b20]
  0x211e1c05, 0x31000b1b, 0x04211c08, 0x1b000104,   // id.ms.jw_333 es.az.un_770  id.jw.fi_443 en.tr.un_320
  0x2d000d08, 0x282a010c, 0x07001704, 0x172902a7,   // cs.sk.un_430 en.mt.sw_543  sr.bg.un_320 da.sl.sr_532
  0x353b0dad, 0x1e1c2aa9, 0x251206ad, 0x3f0306a4,   // cs.so.zu_643 mt.id.ms_544  de.hu.eu_643 de.nl.af_433
  0x05001905, 0x2a2d6404, 0x3f032507, 0x0c00061a,   // gl.fr.un_330 lg.sk.mt_332  eu.nl.af_432 de.sv.un_760
  // [0b30]
  0x00001724, 0x52121807, 0x6b0a01a4, 0x04110713,   // sr.un.un_900 ga.hu.ha_432  en.pt.ceb_433 bg.ro.ru_665
  0x201107a9, 0x27000e21, 0x05000112, 0x293216ec,   // it.ro.sq_544 is.gd.un_860  en.fr.un_640 hr.bs.sl_644
  0x316b1baf, 0x052301af, 0x1e1c6b0c, 0x0d000922,   // tr.ceb.az_655 en.ca.fr_655  ceb.id.ms_543 hi.ne.un_870
  0x03003f1b, 0x162d1209, 0x25285508, 0x28006407,   // af.nl.un_770 hu.sk.hr_444  rw.sw.eu_443 lg.sw.un_420
  // [0b40]
  0x0200081a, 0x0817045a, 0x25311b0d, 0x2a002d1a,   // no.da.un_760 ru.sr.uk_553  tr.az.eu_554 sk.mt.un_760
  0x2900170e, 0x25311b13, 0x32251b13, 0x1a011bad,   // sr.sl.un_550 tr.az.eu_665  tr.eu.bs_665 tr.en.tl_643
  0x17002d08, 0x130d1cac, 0x64002818, 0x53120cad,   // sk.sr.un_430 mr.ne.bh_632  sw.lg.un_740 sv.hu.ht_643
  0x12004a08, 0x0d001909, 0x12004a05, 0x21011b08,   // yo.hu.un_430 gl.cs.un_440  yo.hu.un_330 tr.en.jw_443
  // [0b50]
  0x211e1ca4, 0x131a10a7, 0x28640507, 0x211218ec,   // id.ms.jw_433 lt.tl.et_532  fr.lg.sw_432 ar.ur.fa_644
  0x18190a04, 0x0b001b0d, 0x16001f08, 0x23000705,   // pt.gl.ga_332 tr.es.un_540  cy.hr.un_430 it.ca.un_330
  0x2500170d, 0x170d0f08, 0x25190b55, 0x07170aa4,   // sr.eu.un_540 lv.cs.sr_443  es.gl.eu_442 mk.sr.bg_433
  0x050601ec, 0x16002d08, 0x64005512, 0x07170a04,   // en.de.fr_644 sk.hr.un_430  rw.lg.un_640 mk.sr.bg_332
  // [0b60]
  0x0c000e02, 0x211c1108, 0x1b000a04, 0x646b12ad,   // is.sv.un_220 ro.id.jw_443  pt.tr.un_320 hu.ceb.lg_643
  0x0c000814, 0x11001f0e, 0x270118a7, 0x32001705,   // no.sv.un_660 cy.ro.un_550  ga.en.gd_532 sr.bs.un_330
  0x231c550b, 0x07001002, 0x1800050d, 0x05190bad,   // rw.id.ca_542 be.bg.un_220  fr.ga.un_540 es.gl.fr_643
  0x190405a0, 0x17001614, 0x2500190c, 0x0d001c0d,   // fr.fi.gl_322 hr.sr.un_660  gl.eu.un_530 mr.ne.un_540
  // [0b70]
  0x251f17a0, 0x04001022, 0x17002d0d, 0x08001019,   // sr.cy.eu_322 be.ru.un_870  sk.sr.un_540 be.uk.un_750
  0x13000e08, 0x090d13ec, 0x18211260, 0x521c1eee,   // is.et.un_430 bh.ne.hi_644  ur.fa.ar_664 ms.id.ha_422
  0x3f066ba0, 0x080410a9, 0x2b002d0c, 0x111a4aa0,   // ceb.de.af_322 be.ru.uk_544  sk.vi.un_530 yo.tl.ro_322
  0x29172da4, 0x080704ec, 0x2a001c02, 0x08021faf,   // sk.sr.sl_433 ru.bg.uk_644  id.mt.un_220 cy.da.no_655
  // [0b80]
  0x32001702, 0x08020ca0, 0x08020fee, 0x0a040702,   // sr.bs.un_220 sv.da.no_322  lv.da.no_422 bg.ru.mk_222
  0x091c0d08, 0x0900131a, 0x0d001c21, 0x07001109,   // ne.mr.hi_443 bh.hi.un_760  mr.ne.un_860 ro.it.un_440
  0x0800041b, 0x17002914, 0x04003b12, 0x13040cad,   // ru.uk.un_770 sl.sr.un_660  so.fi.un_640 sv.fi.et_643
  0x12211813, 0x281b53a4, 0x1b005214, 0x55003b07,   // ar.fa.ur_665 ht.tr.sw_433  ha.tr.un_660 so.rw.un_420
  // [0b90]
  0x06002519, 0x07000d08, 0x07171104, 0x19112308,   // eu.de.un_750 cs.it.un_430  ro.sr.bg_332 ca.ro.gl_443
  0x64205355, 0x20005319, 0x11230760, 0x1b000e13,   // ht.sq.lg_442 ht.sq.un_750  it.ca.ro_664 is.tr.un_650
  0x27001119, 0x00001c0a, 0x32000707, 0x170a04af,   // ro.gd.un_750 id.un.un_500  it.bs.un_420 ru.mk.sr_655
  0x0a081708, 0x18002b07, 0x52003204, 0x09001319,   // sr.uk.mk_443 vi.ga.un_420  bs.ha.un_320 bh.hi.un_750
  // [0ba0]
  0x52000e08, 0x170804a4, 0x080235ec, 0x19000a0e,   // is.ha.un_430 ru.uk.sr_433  zu.da.no_644 pt.gl.un_550
  0x23004a07, 0x0a07040b, 0x1e1c0ea0, 0x07001013,   // yo.ca.un_420 ru.bg.mk_542  is.id.ms_322 be.bg.un_650
  0x170411ee, 0x1f00012a, 0x0b0c0812, 0x27006e08,   // ro.ru.sr_422 en.cy.un_970  no.sv.es_654 hmn.gd.un_430
  0x0708100c, 0x040918a4, 0x2d010d07, 0x11190b04,   // be.uk.bg_543 ga.pl.fi_433  cs.en.sk_432 es.gl.ro_332
  // [0bb0]
  0x1b311ca0, 0x00006b0f, 0x1b07310c, 0x1c130d08,   // id.az.tr_322 ceb.un.un_600  az.it.tr_543 ne.bh.mr_443
  0x1a006e12, 0x1b3b0708, 0x10000f1a, 0x0f001705,   // hmn.tl.un_640 it.so.tr_443  lv.lt.un_760 sr.lv.un_330
  0x13090daf, 0x09121112, 0x07041705, 0x010a2304,   // ne.hi.bh_655 ro.hu.pl_654  sr.ru.bg_333 ca.pt.en_332
  0x090d1c0c, 0x08020c0e, 0x12182112, 0x3f00011a,   // mr.ne.hi_543 sv.da.no_555  fa.ar.ur_654 en.af.un_760
  // [0bc0]
  0x1f070fa4, 0x2900320d, 0x091c0d11, 0x0428250c,   // lv.it.cy_433 bs.sl.un_540  ne.mr.hi_653 eu.sw.fi_543
  0x1325040b, 0x0800021b, 0x2500041b, 0x070a08a4,   // fi.eu.et_542 da.no.un_770  fi.eu.un_770 uk.mk.bg_433
  0x162d29a4, 0x2b001319, 0x2100121b, 0x0e000c08,   // sl.sk.hr_433 et.vi.un_750  ur.fa.un_770 sv.is.un_430
  0x2b0421a4, 0x12054a07, 0x03005204, 0x32161702,   // jw.fi.vi_433 yo.fr.hu_432  ha.nl.un_320 sr.hr.bs_222
  // [0bd0]
  0x042825ad, 0x011308ee, 0x28042508, 0x0b2d1907,   // eu.sw.fi_643 no.et.en_422  eu.fi.sw_443 gl.sk.es_432
  0x04282555, 0x03180612, 0x1b005312, 0x13000c12,   // eu.sw.fi_442 de.ga.nl_654  ht.tr.un_640 sv.et.un_640
  0x280425a9, 0x01000d08, 0x00001706, 0x3b3f01ad,   // eu.fi.sw_544 cs.en.un_430  sr.un.un_400 en.af.so_643
  0x28192512, 0x08020c55, 0x0e003b12, 0x55001b13,   // eu.gl.sw_654 sv.da.no_442  so.is.un_640 tr.rw.un_650
  // [0be0]
  0x351a1bad, 0x08171009, 0x170a07af, 0x063f0ca0,   // tr.tl.zu_643 be.sr.uk_444  bg.mk.sr_655 sv.af.de_322
  0x17001013, 0x110501a4, 0x3b1e1c0e, 0x08023f05,   // lt.sr.un_650 en.fr.ro_433  id.ms.so_555 af.da.no_333
  0x52003121, 0x31003b14, 0x24000121, 0x1c091305,   // az.ha.un_860 so.az.un_660  iw.yi.un_860 bh.hi.mr_333
  0x25042812, 0x061f010b, 0x55256409, 0x27003514,   // sw.fi.eu_654 en.cy.de_542  lg.eu.rw_444 zu.gd.un_660
  // [0bf0]
  0x0400250d, 0x130f64a0, 0x216b1aec, 0x042825ec,   // eu.fi.un_540 lg.lv.et_322  tl.ceb.jw_644 eu.sw.fi_644
  0x6b3b52ee, 0x09001c20, 0x051123af, 0x063f2512,   // ha.so.ceb_422 mr.hi.un_850  ca.ro.fr_655 eu.af.de_654
  0x1f00351b, 0x112305a4, 0x08020c14, 0x552d0d13,   // zu.cy.un_770 fr.ca.ro_433  sv.da.no_666 cs.sk.rw_665
  0x123f3baf, 0x00000303, 0x05005304, 0x1b001f13,   // so.af.hu_655 nl.un.un_300  ht.fr.un_320 cy.tr.un_650

  // [0c00]
  0x3f002109, 0x351a55a4, 0x1f002108, 0x25005507,   // jw.af.un_440 rw.tl.zu_433  jw.cy.un_430 rw.eu.un_420
  0x06000419, 0x0f135504, 0x0b001c02, 0x040710ad,   // fi.de.un_750 rw.et.lv_332  id.es.un_220 be.bg.ru_643
  0x2300030c, 0x213b1c02, 0x52000504, 0x00001f01,   // nl.ca.un_530 id.so.jw_222  fr.ha.un_320 cy.un.un_200
  0x12001f23, 0x551b6bac, 0x17100808, 0x35001308,   // cy.hu.un_880 ceb.tr.rw_632  uk.be.sr_443 et.zu.un_430
  // [0c10]
  0x0d290a0b, 0x3f033baf, 0x55001b19, 0x20013fa0,   // pt.sl.cs_542 so.nl.af_655  tr.rw.un_750 af.en.sq_322
  0x2100351a, 0x19000b1a, 0x110a10ad, 0x05555304,   // zu.jw.un_760 es.gl.un_760  lt.pt.ro_643 ht.rw.fr_332
  0x32161707, 0x063f0307, 0x555305a4, 0x3f0306a9,   // sr.hr.bs_432 nl.af.de_432  fr.ht.rw_433 de.nl.af_544
  0x09000d14, 0x190b0aa0, 0x03003519, 0x033f3bee,   // ne.hi.un_660 pt.es.gl_322  zu.nl.un_750 so.af.nl_422
  // [0c20]
  0x0c07010c, 0x02200807, 0x292d32a0, 0x32125505,   // en.it.sv_543 no.sq.da_432  bs.sk.sl_322 rw.hu.bs_333
  0x080a0708, 0x3b09290c, 0x310420a7, 0x1a006b14,   // bg.mk.uk_443 sl.pl.so_543  sq.fi.az_532 ceb.tl.un_660
  0x1c001304, 0x1a120fa4, 0x182112ec, 0x18122160,   // bh.mr.un_320 lv.hu.tl_433  ur.fa.ar_644 fa.ur.ar_664
  0x1309270b, 0x09001c05, 0x0000640f, 0x07081709,   // gd.pl.et_542 mr.hi.un_330  lg.un.un_600 sr.uk.bg_444
  // [0c30]
  0x3f004a04, 0x170d29a4, 0x13000d14, 0x09130d12,   // yo.af.un_320 sl.cs.sr_433  ne.bh.un_660 ne.bh.hi_654
  0x1f001113, 0x18203b08, 0x321701a4, 0x232501a4,   // ro.cy.un_650 so.sq.ga_443  en.sr.bs_433 en.eu.ca_433
  0x07552a08, 0x11002508, 0x25001120, 0x122118ad,   // mt.rw.it_443 eu.ro.un_430  ro.eu.un_850 ar.fa.ur_643
  0x04000c21, 0x092d08a0, 0x07040813, 0x182701a4,   // sv.fi.un_860 no.sk.pl_322  uk.ru.bg_665 en.gd.ga_433
  // [0c40]
  0x070804af, 0x18002713, 0x3f060eee, 0x25190b02,   // ru.uk.bg_655 gd.ga.un_650  is.de.af_422 es.gl.eu_222
  0x120c08a0, 0x11002502, 0x090d1c14, 0x28355207,   // no.sv.hu_322 eu.ro.un_220  mr.ne.hi_666 ha.zu.sw_432
  0x18122111, 0x18002719, 0x25111c12, 0x2b002513,   // fa.ur.ar_653 gd.ga.un_750  id.ro.eu_654 eu.vi.un_650
  0x0604050c, 0x06003f05, 0x19120a07, 0x08000413,   // fr.fi.de_543 af.de.un_330  pt.hu.gl_432 ru.uk.un_650
  // [0c50]
  0x25001114, 0x170a1107, 0x0b0a19a4, 0x0000280a,   // ro.eu.un_660 ro.mk.sr_432  gl.pt.es_433 sw.un.un_500
  0x06003505, 0x070501a9, 0x00006424, 0x06002304,   // zu.de.un_330 en.fr.it_544  lg.un.un_900 ca.de.un_320
  0x12190b55, 0x533f0304, 0x0900280d, 0x5504280c,   // es.gl.hu_442 nl.af.ht_332  sw.pl.un_540 sw.fi.rw_543
  0x04100813, 0x64216b08, 0x2700181a, 0x0d0f040b,   // uk.be.ru_665 ceb.jw.lg_443  ga.gd.un_760 fi.lv.cs_542
  // [0c60]
  0x3f2b35a0, 0x6b002809, 0x321e1c55, 0x01003508,   // zu.vi.af_322 sw.ceb.un_440  id.ms.bs_442 zu.en.un_430
  0x1800272a, 0x522032a0, 0x041711ee, 0x07110a14,   // gd.ga.un_970 bs.sq.ha_322  ro.sr.ru_422 mk.ro.bg_666
  0x1e211c04, 0x1c1309af, 0x64003519, 0x00000103,   // id.jw.ms_332 hi.bh.mr_655  zu.lg.un_750 en.un.un_300
  0x040a1713, 0x17000a0c, 0x00001124, 0x3564550d,   // sr.mk.ru_665 mk.sr.un_530  ro.un.un_900 rw.lg.zu_554
  // [0c70]
  0x09321604, 0x211c5204, 0x3f031fee, 0x040810ec,   // hr.bs.pl_332 ha.id.jw_332  cy.nl.af_422 be.uk.ru_644
  0x52002d1a, 0x17000807, 0x25001121, 0x033f1f55,   // sk.ha.un_760 uk.sr.un_420  ro.eu.un_860 cy.af.nl_442
  0x091c0d13, 0x32002d07, 0x552853a4, 0x25001112,   // ne.mr.hi_665 sk.bs.un_420  ht.sw.rw_433 ro.eu.un_640
  0x530b1112, 0x13090d13, 0x28355212, 0x100f1707,   // ro.es.ht_654 ne.hi.bh_665  ha.zu.sw_654 sr.lv.lt_432
  // [0c80]
  0x53110b07, 0x3235090c, 0x0e081f07, 0x122d0d0e,   // es.ro.ht_432 pl.zu.bs_543  cy.no.is_432 cs.sk.hu_555
  0x552164a9, 0x033f28a4, 0x081102ec, 0x1c0d13ad,   // lg.jw.rw_544 sw.af.nl_433  da.ro.no_644 bh.ne.mr_643
  0x4a52060c, 0x5521350c, 0x08270607, 0x1a006404,   // de.ha.yo_543 zu.jw.rw_543  de.gd.no_432 lg.tl.un_320
  0x192301a4, 0x06080e07, 0x04000822, 0x201e1c07,   // en.ca.gl_433 is.no.de_432  uk.ru.un_870 id.ms.sq_432
  // [0c90]
  0x28211cee, 0x17040709, 0x050135a0, 0x00002806,   // id.jw.sw_422 bg.ru.sr_444  zu.en.fr_322 sw.un.un_400
  0x081f0204, 0x170f100c, 0x52000d13, 0x5300551a,   // da.cy.no_332 lt.lv.sr_543  cs.ha.un_650 rw.ht.un_760
  0x13210fa4, 0x0807100c, 0x13001c04, 0x170a0705,   // lv.jw.et_433 be.bg.uk_543  id.et.un_320 bg.mk.sr_333
  0x250605a7, 0x080a17a4, 0x28001e08, 0x07002a04,   // fr.de.eu_532 sr.mk.uk_433  ms.sw.un_430 mt.it.un_320
  // [0ca0]
  0x10040812, 0x32000408, 0x3500280d, 0x32000b04,   // uk.ru.be_654 fi.bs.un_430  sw.zu.un_540 es.bs.un_320
  0x0400111a, 0x08000512, 0x08021fa4, 0x6b18270d,   // ro.ru.un_760 fr.no.un_640  cy.da.no_433 gd.ga.ceb_554
  0x68521ea0, 0x07000108, 0x35006807, 0x3f000307,   // ms.ha.ig_322 en.it.un_430  ig.zu.un_420 nl.af.un_420
  0x27001821, 0x52280b07, 0x0a041105, 0x0c1204ad,   // ga.gd.un_860 es.sw.ha_432  ro.ru.mk_333 fi.hu.sv_643
  // [0cb0]
  0x13001814, 0x080704ad, 0x112953a0, 0x1a2a1e0c,   // ga.et.un_660 ru.bg.uk_643  ht.sl.ro_322 ms.mt.tl_543
  0x0c00061b, 0x27001819, 0x07081009, 0x35005512,   // de.sv.un_770 ga.gd.un_750  be.uk.bg_444 rw.zu.un_640
  0x01000618, 0x55642105, 0x550b530c, 0x211c1ead,   // de.en.un_740 jw.lg.rw_333  ht.es.rw_543 ms.id.jw_643
  0x532d3bee, 0x530b11ec, 0x532921ee, 0x230e5255,   // so.sk.ht_422 ro.es.ht_644  jw.sl.ht_422 ha.is.ca_442
  // [0cc0]
  0x1c002113, 0x04071104, 0x210c03ee, 0x0800170b,   // jw.id.un_650 ro.bg.ru_332  nl.sv.jw_422 sr.no.un_520
  0x0c070eee, 0x2d290d0e, 0x0c550611, 0x0900250d,   // is.it.sv_422 cs.sl.sk_555  de.rw.sv_653 eu.pl.un_540
  0x2723180c, 0x0b00110d, 0x1c130902, 0x2d0d0caf,   // ga.ca.gd_543 ro.es.un_540  hi.bh.mr_222 sv.cs.sk_655
  0x0f050408, 0x044a230c, 0x0d000923, 0x213b13ad,   // fi.fr.lv_443 ca.yo.fi_543  hi.ne.un_880 et.so.jw_643
  // [0cd0]
  0x04071709, 0x03053fee, 0x322117a0, 0x161710a6,   // sr.bg.ru_444 af.fr.nl_422  sr.jw.bs_322 lt.sr.hr_521
  0x0b000a0e, 0x3f002105, 0x1b000f0b, 0x020c0807,   // pt.es.un_550 jw.af.un_330  lv.tr.un_520 no.sv.da_432
  0x3b006e0c, 0x2d290d07, 0x03003f0c, 0x0000250a,   // hmn.so.un_530 cs.sl.sk_432  af.nl.un_530 eu.un.un_500
  0x1000292a, 0x27101812, 0x00000824, 0x08041104,   // sl.lt.un_970 ga.lt.gd_654  no.un.un_900 ro.ru.uk_332
  // [0ce0]
  0x2d0d1905, 0x2800211a, 0x0a182712, 0x04211f05,   // gl.cs.sk_333 jw.sw.un_760  gd.ga.pt_654 cy.jw.fi_333
  0x056e0aee, 0x080a1005, 0x07040aa9, 0x09005504,   // pt.hmn.fr_422 be.mk.uk_333  mk.ru.bg_544 rw.pl.un_320
  0x17291f0c, 0x1a006b13, 0x2013075a, 0x0c001121,   // cy.sl.sr_543 ceb.tl.un_650  it.et.sq_553 ro.sv.un_860
  0x0a041704, 0x1f520eec, 0x6b011aa4, 0x1a211e07,   // sr.ru.mk_332 is.ha.cy_644  tl.en.ceb_433 ms.jw.tl_432
  // [0cf0]
  0x09000d19, 0x1c1f21ad, 0x02000818, 0x07081708,   // ne.hi.un_750 jw.cy.id_643  no.da.un_740 sr.uk.bg_443
  0x6b001a14, 0x293120ee, 0x0e001c08, 0x23000108,   // tl.ceb.un_660 sq.az.sl_422  id.is.un_430 en.ca.un_430
  0x11000508, 0x041008a4, 0x03003f13, 0x080b1aa0,   // fr.ro.un_430 uk.be.ru_433  af.nl.un_650 tl.es.no_322
  0x0f2a1f08, 0x09001311, 0x171011a0, 0x536410a7,   // cy.mt.lv_443 bh.hi.un_630  ro.be.sr_322 lt.lg.ht_532
  // [0d00]
  0x1c00250b, 0x06005314, 0x2a000708, 0x01641aee,   // eu.id.un_520 ht.de.un_660  it.mt.un_430 tl.lg.en_422
  0x16111e04, 0x08022105, 0x3b132808, 0x19003f0c,   // ms.ro.hr_332 jw.da.no_333  sw.et.so_443 af.gl.un_530
  0x182753a4, 0x1c1f23a7, 0x2a1629a4, 0x012b1a07,   // ht.gd.ga_433 ca.cy.id_532  sl.hr.mt_433 tl.vi.en_432
  0x6b230b08, 0x3f0753a0, 0x08070413, 0x04111705,   // es.ca.ceb_443 ht.it.af_322  ru.bg.uk_665 sr.ro.ru_333
  // [0d10]
  0x3b00680d, 0x321617ec, 0x1000091b, 0x0800101b,   // ig.so.un_540 sr.hr.bs_644  pl.lt.un_770 be.uk.un_770
  0x0d001c19, 0x10000414, 0x1629120c, 0x181e1c09,   // mr.ne.un_750 ru.be.un_660  hu.sl.hr_543 id.ms.ga_444
  0x1b3f3107, 0x5300110b, 0x02000804, 0x1c211eee,   // az.af.tr_432 ro.ht.un_520  no.da.un_320 ms.jw.id_422
  0x090d1c11, 0x2a091f12, 0x52552355, 0x6b1a210c,   // mr.ne.hi_653 cy.pl.mt_654  ca.rw.ha_442 jw.tl.ceb_543
  // [0d20]
  0x0e6411a7, 0x2b00050c, 0x27230d07, 0x20000804,   // ro.lg.is_532 fr.vi.un_530  cs.ca.gd_432 no.sq.un_320
  0x3b00252a, 0x3b0908a4, 0x32001608, 0x6b1a2511,   // eu.so.un_970 no.pl.so_433  hr.bs.un_430 eu.tl.ceb_653
  0x2a032807, 0x12005312, 0x3f250ea4, 0x09350808,   // sw.nl.mt_432 ht.hu.un_640  is.eu.af_433 no.zu.pl_443
  0x551c1a0c, 0x1b0e2304, 0x212801a0, 0x32171655,   // tl.id.rw_543 ca.is.tr_332  en.sw.jw_322 hr.sr.bs_442
  // [0d30]
  0x2a3201ad, 0x040a0714, 0x1a520ead, 0x0900351a,   // en.bs.mt_643 bg.mk.ru_666  is.ha.tl_643 zu.pl.un_760
  0x2d0a05a4, 0x06000308, 0x2d0d1ea0, 0x1a0a64a0,   // fr.pt.sk_433 nl.de.un_430  ms.cs.sk_322 lg.pt.tl_322
  0x00000924, 0x1c214a11, 0x2b002102, 0x19645513,   // pl.un.un_900 yo.jw.id_653  jw.vi.un_220 rw.lg.gl_665
  0x0917350c, 0x2a07520c, 0x1b281308, 0x556e210c,   // zu.sr.pl_543 ha.it.mt_543  et.sw.tr_443 jw.hmn.rw_543
  // [0d40]
  0x11040a13, 0x551f2809, 0x0900101a, 0x0b214a0c,   // mk.ru.ro_665 sw.cy.rw_444  lt.pl.un_760 yo.jw.es_543
  0x5500041b, 0x100a17a4, 0x0a001004, 0x5235090d,   // fi.rw.un_770 sr.mk.be_433  be.mk.un_320 pl.zu.ha_554
  0x2128350c, 0x52000808, 0x1800212a, 0x4a00202a,   // zu.sw.jw_543 no.ha.un_430  fa.ar.un_970 sq.yo.un_970
  0x21002819, 0x32082da4, 0x641b35a4, 0x1b64280c,   // sw.jw.un_750 sk.no.bs_433  zu.tr.lg_433 sw.lg.tr_543
  // [0d50]
  0x355513ad, 0x21682a07, 0x52281705, 0x1b521c07,   // et.rw.zu_643 mt.ig.jw_432  sr.sw.ha_333 id.ha.tr_432
  0x21000804, 0x10000412, 0x09001c02, 0x4a00551a,   // no.jw.un_320 ru.be.un_640  id.pl.un_220 rw.yo.un_760
  0x11131a08, 0x3f1f09a4, 0x28114a05, 0x3f02080c,   // tl.et.ro_443 pl.cy.af_433  yo.ro.sw_333 no.da.af_543
  0x0e1b2a12, 0x1c0d0955, 0x0e1f2a5a, 0x17040708,   // mt.tr.is_654 hi.ne.mr_442  mt.cy.is_553 bg.ru.sr_443
  // [0d60]
  0x53124a04, 0x1b3508a4, 0x13006819, 0x07531112,   // yo.hu.ht_332 no.zu.tr_433  ig.et.un_750 ro.ht.it_654
  0x281b3513, 0x211c4a04, 0x2a1c1e0c, 0x04110a5a,   // zu.tr.sw_665 yo.id.jw_332  ms.id.mt_543 mk.ro.ru_553
  0x4a2504a4, 0x0a071708, 0x1b00350d, 0x181f2713,   // fi.eu.yo_433 sr.bg.mk_443  zu.tr.un_540 gd.cy.ga_665
  0x13020812, 0x1e1c21ee, 0x25071ca4, 0x0e2a0d07,   // no.da.et_654 jw.id.ms_422  id.it.eu_433 cs.mt.is_432
  // [0d70]
  0x08040712, 0x1300351b, 0x090d1cec, 0x1a6b5513,   // bg.ru.uk_654 zu.et.un_770  mr.ne.hi_644 rw.ceb.tl_665
  0x28033509, 0x2a351f12, 0x23190b0d, 0x081b12a9,   // zu.nl.sw_444 cy.zu.mt_654  es.gl.ca_554 hu.tr.no_544
  0x1700090c, 0x292808a0, 0x641e1c08, 0x08020aa4,   // pl.sr.un_530 no.sw.sl_322  id.ms.lg_443 pt.da.no_433
  0x3b1b060d, 0x2d05210c, 0x3b1b3202, 0x2d0d210c,   // de.tr.so_554 jw.fr.sk_543  bs.tr.so_222 jw.cs.sk_543
  // [0d80]
  0x1b0452ad, 0x0f1b12a7, 0x35041eee, 0x4a2052ec,   // ha.fi.tr_643 hu.tr.lv_532  ms.fi.zu_422 ha.sq.yo_644
  0x1a286455, 0x2a001108, 0x0900130d, 0x2d04680c,   // lg.sw.tl_442 ro.mt.un_430  bh.hi.un_540 ig.fi.sk_543
  0x0f000104, 0x21281c0c, 0x0652350c, 0x21001e04,   // en.lv.un_320 id.sw.jw_543  zu.ha.de_543 ms.jw.un_320
  0x2d6435a4, 0x1e091ca0, 0x1000081a, 0x10070a04,   // zu.lg.sk_433 id.pl.ms_322  uk.be.un_760 mk.bg.be_332
  // [0d90]
  0x07040a0c, 0x08041105, 0x3b1e1c04, 0x352821a0,   // mk.ru.bg_543 ro.ru.uk_333  id.ms.so_332 jw.sw.zu_322
  0x11080705, 0x321b3155, 0x2568060c, 0x1b090d07,   // bg.uk.ro_333 az.tr.bs_442  de.ig.eu_543 cs.pl.tr_432
  0x101c2ba9, 0x0912350c, 0x21534aa7, 0x11001602,   // vi.id.lt_544 zu.hu.pl_543  yo.ht.jw_532 hr.ro.un_220
  0x4a100aa7, 0x0a0711af, 0x070a1705, 0x12351b60,   // pt.lt.yo_532 ro.bg.mk_655  sr.mk.bg_333 tr.zu.hu_664
  // [0da0]
  0x1c0d090d, 0x0b001919, 0x3b1025a4, 0x3f031208,   // hi.ne.mr_554 gl.es.un_750  eu.lt.so_433 hu.nl.af_443
  0x1600320d, 0x201e2104, 0x2d0d520c, 0x2d0d1005,   // bs.hr.un_540 jw.ms.sq_332  ha.cs.sk_543 lt.cs.sk_333
  0x16321704, 0x111b12a9, 0x13124aa4, 0x1c211ea9,   // sr.bs.hr_332 hu.tr.ro_544  yo.hu.et_433 ms.jw.id_544
  0x170804ec, 0x1b112aaf, 0x08070a04, 0x121b0107,   // ru.uk.sr_644 mt.ro.tr_655  mk.bg.uk_332 en.tr.hu_432
  // [0db0]
  0x0e004a0e, 0x00005501, 0x0c120802, 0x081707a4,   // yo.is.un_550 rw.un.un_200  no.hu.sv_222 bg.sr.uk_433
  0x070a04ad, 0x00000f2d, 0x0708110c, 0x0000291c,   // ru.mk.bg_643 lv.un.un_A00  ro.uk.bg_543 sl.un.un_800
  0x233555ee, 0x52133ba0, 0x00000f03, 0x6435550e,   // rw.zu.ca_422 so.et.ha_322  lv.un.un_300 rw.zu.lg_555
  0x09001c0c, 0x0a170409, 0x200f1308, 0x18000e14,   // mr.hi.un_530 ru.sr.mk_444  et.lv.sq_443 is.ga.un_660
  // [0dc0]
  0x0a071107, 0x00000f01, 0x3f060305, 0x0f3b100b,   // ro.bg.mk_432 lv.un.un_200  nl.de.af_333 lt.so.lv_542
  0x55643508, 0x55002813, 0x1e1c1ba4, 0x17000a22,   // zu.lg.rw_443 sw.rw.un_650  tr.id.ms_433 mk.sr.un_870
  0x07041108, 0x110a1705, 0x0a1711ad, 0x052d0d04,   // ro.ru.bg_443 sr.mk.ro_333  ro.sr.mk_643 cs.sk.fr_332
  0x2d001702, 0x17070a5a, 0x101c1ea0, 0x32173ba0,   // sr.sk.un_220 mk.bg.sr_553  ms.id.lt_322 so.sr.bs_322
  // [0dd0]
  0x21001829, 0x11002104, 0x1c091307, 0x0a0704a9,   // ar.fa.un_960 jw.ro.un_320  bh.hi.mr_432 ru.bg.mk_544
  0x01230b05, 0x3b020fa0, 0x35215505, 0x11000b05,   // es.ca.en_333 lv.da.so_322  rw.jw.zu_333 es.ro.un_330
  0x13006b19, 0x030553a0, 0x4a133b55, 0x122813ec,   // ceb.et.un_750 ht.fr.nl_322  so.et.yo_442 et.sw.hu_644
  0x0a001007, 0x3b006b2b, 0x2500130d, 0x1117080c,   // be.mk.un_420 ceb.so.un_980  et.eu.un_540 uk.sr.ro_543
  // [0de0]
  0x11000518, 0x0e02080c, 0x3b6b6412, 0x1a6e200c,   // fr.ro.un_740 no.da.is_543  lg.ceb.so_654 sq.hmn.tl_543
  0x06003b14, 0x08001c05, 0x1c081e08, 0x1b3b1c55,   // so.de.un_660 id.no.un_330  ms.no.id_443 id.so.tr_442
  0x3f03080c, 0x270e0812, 0x070a0808, 0x64005504,   // no.nl.af_543 no.is.gd_654  uk.mk.bg_443 rw.lg.un_320
  0x130e1b55, 0x3500080d, 0x2d000919, 0x64003b18,   // tr.is.et_442 no.zu.un_540  pl.sk.un_750 so.lg.un_740
  // [0df0]
  0x122d1812, 0x10000f1b, 0x0e030604, 0x033f06af,   // ga.sk.hu_654 lv.lt.un_770  de.nl.is_332 de.af.nl_655
  0x1300092a, 0x080c2107, 0x00003b0a, 0x033f25a4,   // hi.bh.un_970 jw.sv.no_432  so.un.un_500 eu.af.nl_433
  0x133b04ec, 0x10093f05, 0x12000e13, 0x033f06ee,   // fi.so.et_644 af.pl.lt_333  is.hu.un_650 de.af.nl_422
  0x023f080c, 0x08041707, 0x12000e0e, 0x0a00070c,   // no.af.da_543 sr.ru.uk_432  is.hu.un_550 bg.mk.un_530
  // [0e00]
  0x0d1c095a, 0x10001a08, 0x04081012, 0x03286404,   // hi.mr.ne_553 tl.lt.un_430  be.uk.ru_654 lg.sw.nl_332
  0x092d0d13, 0x3b006422, 0x0000120a, 0x2d0d01af,   // cs.sk.pl_665 lg.so.un_870  hu.un.un_500 en.cs.sk_655
  0x212305ec, 0x03643ba4, 0x0706010c, 0x11070a09,   // fr.ca.jw_644 so.lg.nl_433  en.de.it_543 mk.bg.ro_444
  0x0b0d2dad, 0x281c21a0, 0x64136b07, 0x20280111,   // sk.cs.es_643 jw.id.sw_322  ceb.et.lg_432 en.sw.sq_653
  // [0e10]
  0x0d091ca4, 0x04001012, 0x07040860, 0x110c08a0,   // mr.hi.ne_433 lt.fi.un_640  uk.ru.bg_664 no.sv.ro_322
  0x12002d1a, 0x0b00190c, 0x31002a1a, 0x17070a0c,   // sk.hu.un_760 gl.es.un_530  mt.az.un_760 mk.bg.sr_543
  0x1c00130e, 0x3f060304, 0x1c00131b, 0x00000b0a,   // bh.mr.un_550 nl.de.af_332  bh.mr.un_770 es.un.un_500
  0x02000807, 0x08001714, 0x3b2127ac, 0x2d18120c,   // no.da.un_420 sr.uk.un_660  gd.jw.so_632 hu.ga.sk_543
  // [0e20]
  0x0e000804, 0x2a080605, 0x050123ee, 0x08020caf,   // no.is.un_320 de.no.mt_333  ca.en.fr_422 sv.da.no_655
  0x0e122d0b, 0x2d0d010c, 0x0f00530d, 0x0e002a2b,   // sk.hu.is_542 en.cs.sk_543  ht.lv.un_540 mt.is.un_980
  0x32170c05, 0x07000e0e, 0x210812ad, 0x3b18640e,   // sv.sr.bs_333 is.it.un_550  hu.no.jw_643 lg.ga.so_555
  0x0e0807af, 0x2900530d, 0x3b290da4, 0x53005202,   // it.no.is_655 ht.sl.un_540  cs.sl.so_433 ha.ht.un_220
  // [0e30]
  0x041128a9, 0x190a1111, 0x092811ec, 0x0d1309ad,   // sw.ro.fi_544 ro.pt.gl_653  ro.sw.pl_644 hi.bh.ne_643
  0x0e080260, 0x01005304, 0x28091112, 0x10000507,   // da.no.is_664 ht.en.un_320  ro.pl.sw_654 fr.lt.un_420
  0x016b1ba0, 0x11003b29, 0x29090da4, 0x060c0204,   // tr.ceb.en_322 so.ro.un_960  cs.pl.sl_433 da.sv.de_332
  0x0e093ba9, 0x281168a0, 0x2a0c3b60, 0x16290da4,   // so.pl.is_544 ig.ro.sw_322  so.sv.mt_664 cs.sl.hr_433
  // [0e40]
  0x18080213, 0x17000608, 0x3b2a09ec, 0x131b0c08,   // da.no.ga_665 de.sr.un_430  pl.mt.so_644 sv.tr.et_443
  0x0d091108, 0x09113baf, 0x080203af, 0x10115208,   // ro.pl.cs_443 so.ro.pl_655  nl.da.no_655 ha.ro.lt_443
  0x23002519, 0x0400110d, 0x170208a4, 0x28316b08,   // eu.ca.un_750 ro.ru.un_540  no.da.sr_433 ceb.az.sw_443
  0x290c0da4, 0x64005522, 0x3b2d115a, 0x03000222,   // cs.sv.sl_433 rw.lg.un_870  ro.sk.so_553 da.nl.un_870
  // [0e50]
  0x3f071208, 0x0e080208, 0x08090207, 0x162a5507,   // hu.it.af_443 da.no.is_443  da.pl.no_432 rw.mt.hr_432
  0x0832165a, 0x0e3b0814, 0x13000e05, 0x5303050c,   // hr.bs.no_553 no.so.is_666  is.et.un_330 fr.nl.ht_543
  0x03193513, 0x4a001c04, 0x35000804, 0x1c0913a9,   // zu.gl.nl_665 id.yo.un_320  no.zu.un_320 bh.hi.mr_544
  0x0c0206af, 0x06080e08, 0x321935a4, 0x25020708,   // de.da.sv_655 is.no.de_443  zu.gl.bs_433 it.da.eu_443
  // [0e60]
  0x21001c12, 0x06033f12, 0x08026eac, 0x10001704,   // id.jw.un_640 af.nl.de_654  hmn.da.no_632 sr.lt.un_320
  0x1b100aaf, 0x19001107, 0x29080260, 0x19000a1b,   // pt.lt.tr_655 ro.gl.un_420  da.no.sl_664 pt.gl.un_770
  0x043b1112, 0x07041002, 0x02061802, 0x04170a05,   // ro.so.fi_654 be.ru.bg_222  ga.de.da_222 mk.sr.ru_333
  0x07001208, 0x21001c0c, 0x09110d11, 0x19230b07,   // hu.it.un_430 id.jw.un_530  cs.ro.pl_653 es.ca.gl_432
  // [0e70]
  0x09000d09, 0x04113ba9, 0x11003202, 0x090411ad,   // ne.hi.un_440 so.ro.fi_544  bs.ro.un_220 ro.fi.pl_643
  0x3f190a14, 0x284a68a9, 0x1805535e, 0x1c1a0a07,   // pt.gl.af_666 ig.yo.sw_544  ht.fr.ga_652 pt.tl.id_432
  0x32171613, 0x20000104, 0x06003b12, 0x11072905,   // hr.sr.bs_665 en.sq.un_320  so.de.un_640 sl.it.ro_333
  0x2a00060e, 0x1f211aee, 0x6b1a53ec, 0x020b08a4,   // de.mt.un_550 tl.jw.cy_422  ht.tl.ceb_644 no.es.da_433
  // [0e80]
  0x09004a04, 0x13091c60, 0x0100240c, 0x0300061a,   // yo.pl.un_320 mr.hi.bh_664  yi.iw.un_530 de.nl.un_760
  0x083b0c04, 0x02080e5a, 0x08000421, 0x1a6b5312,   // sv.so.no_332 is.no.da_553  ru.uk.un_860 ht.ceb.tl_654
  0x090d1312, 0x0c041313, 0x3f031fec, 0x2900091a,   // bh.ne.hi_654 et.fi.sv_665  cy.nl.af_644 pl.sl.un_760
  0x64005505, 0x06001f22, 0x07041107, 0x0f2a53a0,   // rw.lg.un_330 cy.de.un_870  ro.ru.bg_432 ht.mt.lv_322
  // [0e90]
  0x1c0d09ac, 0x3b000c13, 0x0d181209, 0x122d0d60,   // hi.ne.mr_632 sv.so.un_650  hu.ga.cs_444 cs.sk.hu_664
  0x05070aa0, 0x253528a7, 0x0e0c1107, 0x0a0411a4,   // pt.it.fr_322 sw.zu.eu_532  ro.sv.is_432 ro.ru.mk_433
  0x0c270ea9, 0x0500231b, 0x1e1c20a4, 0x0e00251a,   // is.gd.sv_544 ca.fr.un_770  sq.id.ms_433 eu.is.un_760
  0x23033f07, 0x52006b1a, 0x0300011a, 0x10001702,   // af.nl.ca_432 ceb.ha.un_760  en.nl.un_760 sr.lt.un_220
  // [0ea0]
  0x06005514, 0x53002d04, 0x07171107, 0x19062709,   // rw.de.un_660 sk.ht.un_320  ro.sr.bg_432 gd.de.gl_444
  0x11002507, 0x18211214, 0x041008af, 0x532d0dad,   // eu.ro.un_420 ur.fa.ar_666  uk.be.ru_655 cs.sk.ht_643
  0x0c070e08, 0x162d0d64, 0x271808a0, 0x0a10170d,   // is.it.sv_443 cs.sk.hr_762  no.ga.gd_322 sr.be.mk_554
  0x05012a07, 0x2d3f0d11, 0x532d0dec, 0x0e1306a4,   // mt.en.fr_432 cs.af.sk_653  cs.sk.ht_644 de.et.is_433
  // [0eb0]
  0x09202d0c, 0x53002d13, 0x532d0d0c, 0x04100a02,   // sk.sq.pl_543 sk.ht.un_650  cs.sk.ht_543 mk.be.ru_222
  0x0d091c14, 0x522d53a4, 0x0d000904, 0x02050807,   // mr.hi.ne_666 ht.sk.ha_433  hi.ne.un_320 no.fr.da_432
  0x0e080609, 0x12000807, 0x0a000504, 0x3b09110c,   // de.no.is_444 no.hu.un_420  fr.pt.un_320 ro.pl.so_543
  0x13043ba4, 0x2d0d3fa9, 0x2d290909, 0x09000d08,   // so.fi.et_433 af.cs.sk_544  pl.sl.sk_444 ne.hi.un_430
  // [0ec0]
  0x190a2d14, 0x3f005313, 0x0c081308, 0x00000f0a,   // sk.pt.gl_666 ht.af.un_650  et.no.sv_443 lv.un.un_500
  0x1000521a, 0x09000d04, 0x043552a4, 0x1e080c02,   // ha.lt.un_760 ne.hi.un_320  ha.zu.fi_433 sv.no.ms_222
  0x3b00641a, 0x1a006b0d, 0x1800120e, 0x0c1208a4,   // lg.so.un_760 ceb.tl.un_540  ur.ar.un_550 no.hu.sv_433
  0x170304ad, 0x03050cee, 0x0a001908, 0x32092da4,   // fi.nl.sr_643 sv.fr.nl_422  gl.pt.un_430 sk.pl.bs_433
  // [0ed0]
  0x06080205, 0x171635a0, 0x2d3f3bec, 0x013502a0,   // da.no.de_333 zu.hr.sr_322  so.af.sk_644 da.zu.en_322
  0x4a3b640d, 0x250b19ec, 0x16292d0c, 0x0d002d22,   // lg.so.yo_554 gl.es.eu_644  sk.sl.hr_543 sk.cs.un_870
  0x18080209, 0x09251fad, 0x190a5309, 0x53200aa4,   // da.no.ga_444 cy.eu.pl_643  ht.pt.gl_444 pt.sq.ht_433
  0x06005308, 0x08000213, 0x12000e19, 0x230535ee,   // ht.de.un_430 da.no.un_650  is.hu.un_750 zu.fr.ca_422
  // [0ee0]
  0x32002d08, 0x1600290c, 0x251e1c11, 0x3f291b55,   // sk.bs.un_430 sl.hr.un_530  id.ms.eu_653 tr.sl.af_442
  0x07010b08, 0x0a052aee, 0x1c0913ad, 0x051b53ec,   // es.en.it_443 mt.fr.pt_422  bh.hi.mr_643 ht.tr.fr_644
  0x103f0312, 0x1103050b, 0x130464ad, 0x190a0507,   // nl.af.lt_654 fr.nl.ro_542  lg.fi.et_643 fr.pt.gl_432
  0x0a080208, 0x1c090d14, 0x526421af, 0x00001715,   // da.no.pt_443 ne.hi.mr_666  jw.lg.ha_655 sr.un.un_700
  // [0ef0]
  0x1c130905, 0x17290d07, 0x64003b21, 0x0b1918a9,   // hi.bh.mr_333 cs.sl.sr_432  so.lg.un_860 ga.gl.es_544
  0x201b3109, 0x171008a9, 0x13046413, 0x6e311ba9,   // az.tr.sq_444 uk.be.sr_544  lg.fi.et_665 tr.az.hmn_544
  0x20236e12, 0x5535640c, 0x02000c0e, 0x091f6b04,   // hmn.ca.sq_654 lg.zu.rw_543  sv.da.un_550 ceb.cy.pl_332
  0x0d002d1a, 0x16321760, 0x201b1c0c, 0x201025a4,   // sk.cs.un_760 sr.bs.hr_664  id.tr.sq_543 eu.lt.sq_433
  // [0f00]
  0x0d0f10a9, 0x08021214, 0x0c00130e, 0x19530b0c,   // lt.lv.cs_544 hu.da.no_666  et.sv.un_550 es.ht.gl_543
  0x0a171007, 0x3f060c09, 0x0c020812, 0x02000520,   // be.sr.mk_432 sv.de.af_444  no.da.sv_654 fr.da.un_850
  0x55321602, 0x122d0d04, 0x0d1c09a4, 0x1b040e04,   // hr.bs.rw_222 cs.sk.hu_332  hi.mr.ne_433 is.fi.tr_332
  0x03110511, 0x55526408, 0x090d13a6, 0x091c0d07,   // fr.ro.nl_653 lg.ha.rw_443  bh.ne.hi_521 ne.mr.hi_432
  // [0f10]
  0x030205af, 0x11000519, 0x0d001304, 0x0a071112,   // fr.da.nl_655 fr.ro.un_750  bh.ne.un_320 ro.bg.mk_654
  0x4a0811ee, 0x181f27ee, 0x04081109, 0x271f1008,   // ro.no.yo_422 gd.cy.ga_422  ro.uk.ru_444 lt.cy.gd_443
  0x21556411, 0x0f046b0c, 0x3b033fa9, 0x091c0dad,   // lg.rw.jw_653 ceb.fi.lv_543  af.nl.so_544 ne.mr.hi_643
  0x2a350702, 0x6b551aa4, 0x1c100fec, 0x521c6407,   // it.zu.mt_222 tl.rw.ceb_433  lv.lt.id_644 lg.id.ha_432
  // [0f20]
  0x292d0d09, 0x090d1cad, 0x1c001323, 0x0000532d,   // cs.sk.sl_444 mr.ne.hi_643  bh.mr.un_880 ht.un.un_A00
  0x181221ec, 0x17081007, 0x2d1e1c04, 0x04001704,   // fa.ur.ar_644 be.uk.sr_432  id.ms.sk_332 sr.ru.un_320
  0x0900290c, 0x0f001c04, 0x0d002505, 0x1805270c,   // sl.pl.un_530 id.lv.un_320  eu.cs.un_330 gd.fr.ga_543
  0x033f0eee, 0x063225a0, 0x1707110c, 0x17000423,   // is.af.nl_422 eu.bs.de_322  ro.bg.sr_543 ru.sr.un_880
  // [0f30]
  0x1c09120c, 0x04182712, 0x050a2305, 0x53002104,   // hu.pl.id_543 gd.ga.fi_654  ca.pt.fr_333 jw.ht.un_320
  0x27101f0e, 0x00001803, 0x0c110713, 0x180127ec,   // cy.lt.gd_555 ga.un.un_300  it.ro.sv_665 gd.en.ga_644
  0x35001c07, 0x2d0d09ee, 0x09001c11, 0x071108a0,   // id.zu.un_420 pl.cs.sk_422  mr.hi.un_630 no.ro.it_322
  0x1c1035a0, 0x0d000913, 0x00002503, 0x01091fa9,   // zu.lt.id_322 pl.cs.un_650  eu.un.un_300 cy.pl.en_544
  // [0f40]
  0x09001f2a, 0x3b18550c, 0x25521b09, 0x21551c12,   // cy.pl.un_970 rw.ga.so_543  tr.ha.eu_444 id.rw.jw_654
  0x1b0c555a, 0x2864550c, 0x3b21030c, 0x0c4a1105,   // rw.sv.tr_553 rw.lg.sw_543  nl.jw.so_543 ro.yo.sv_333
  0x2d0d04a0, 0x3b28210d, 0x0d092d11, 0x2d2305ad,   // fi.cs.sk_322 jw.sw.so_554  sk.pl.cs_653 fr.ca.sk_643
  0x092d0d14, 0x23520705, 0x32002909, 0x2300191a,   // cs.sk.pl_666 it.ha.ca_333  sl.bs.un_440 gl.ca.un_760
  // [0f50]
  0x68003b22, 0x10170aa9, 0x10000409, 0x09531212,   // so.ig.un_870 mk.sr.be_544  ru.be.un_440 hu.ht.pl_654
  0x0d0805ad, 0x071008ec, 0x04002707, 0x11035508,   // fr.no.cs_643 uk.be.bg_644  gd.fi.un_420 rw.nl.ro_443
  0x1e18270c, 0x286468ad, 0x17071112, 0x1f1101a7,   // gd.ga.ms_543 ig.lg.sw_643  ro.it.sr_654 en.ro.cy_532
  0x523f3baf, 0x21002021, 0x105232a0, 0x250428a9,   // so.af.ha_655 sq.jw.un_860  bs.ha.lt_322 sw.fi.eu_544
  // [0f60]
  0x01002421, 0x521f2509, 0x35212304, 0x552052a0,   // yi.iw.un_860 eu.cy.ha_444  ca.jw.zu_332 ha.sq.rw_322
  0x1a5213ec, 0x282d09af, 0x2d0d09a9, 0x0600030d,   // et.ha.tl_644 pl.sk.sw_655  pl.cs.sk_544 nl.de.un_540
  0x6b1e1ca9, 0x523b55af, 0x121b2804, 0x28076e08,   // id.ms.ceb_544 rw.so.ha_655  sw.tr.hu_332 hmn.it.sw_443
  0x3f062da0, 0x23052aa4, 0x28001002, 0x110c070c,   // sk.de.af_322 mt.fr.ca_433  lt.sw.un_220 it.sv.ro_543
  // [0f70]
  0x1b001f21, 0x321a6b0c, 0x04002822, 0x2a5327a0,   // cy.tr.un_860 ceb.tl.bs_543  sw.fi.un_870 gd.ht.mt_322
  0x2d293ba4, 0x080704a4, 0x5232170c, 0x011105a4,   // so.sl.sk_433 ru.bg.uk_433  sr.bs.ha_543 fr.ro.en_433
  0x230725a9, 0x2a072509, 0x070c110c, 0x033553ac,   // eu.it.ca_544 eu.it.mt_444  ro.sv.it_543 ht.zu.nl_632
  0x53000804, 0x062507a4, 0x11130707, 0x3f000909,   // no.ht.un_320 it.eu.de_433  it.et.ro_432 pl.af.un_440
  // [0f80]
  0x0a0711ad, 0x1308020d, 0x063f0305, 0x250409af,   // ro.bg.mk_643 da.no.et_554  nl.af.de_333 pl.fi.eu_655
  0x0b00280c, 0x13001c0c, 0x1e033f55, 0x12000d0d,   // sw.es.un_530 mr.bh.un_530  af.nl.ms_442 cs.hu.un_540
  0x10040a07, 0x09005204, 0x3f0608af, 0x0c2a0b09,   // mk.ru.be_432 ha.pl.un_320  no.de.af_655 es.mt.sv_444
  0x05201160, 0x1c0d1312, 0x64005514, 0x090b06a7,   // ro.sq.fr_664 bh.ne.mr_654  rw.lg.un_660 de.es.pl_532
  // [0f90]
  0x09003513, 0x0c0208ec, 0x1107250d, 0x16100da7,   // zu.pl.un_650 no.da.sv_644  eu.it.ro_554 cs.lt.hr_532
  0x21251ca0, 0x060b095a, 0x080c02af, 0x13000d05,   // id.eu.jw_322 pl.es.de_553  da.sv.no_655 ne.bh.un_330
  0x09110b09, 0x211218ad, 0x286b4a0b, 0x1c3b1eac,   // es.ro.pl_444 ar.ur.fa_643  yo.ceb.sw_542 ms.so.id_632
  0x07000a19, 0x684a09a9, 0x21002708, 0x11282da9,   // mk.bg.un_750 pl.yo.ig_544  gd.jw.un_430 sk.sw.ro_544
  // [0fa0]
  0x1e1c200c, 0x2d0d68af, 0x64095307, 0x05006402,   // sq.id.ms_543 ig.cs.sk_655  ht.pl.lg_432 lg.fr.un_220
  0x20002705, 0x12641109, 0x21002d0c, 0x0f09060c,   // gd.sq.un_330 ro.lg.hu_444  sk.jw.un_530 de.pl.lv_543
  0x64355204, 0x3b000104, 0x55002109, 0x3f0b0608,   // ha.zu.lg_332 en.so.un_320  jw.rw.un_440 de.es.af_443
  0x1e000223, 0x0f0506a4, 0x04001c02, 0x03063f0e,   // da.ms.un_880 de.fr.lv_433  id.fi.un_220 af.de.nl_555
  // [0fb0]
  0x3f000313, 0x110608a0, 0x1c0913ee, 0x0b06255a,   // nl.af.un_650 no.de.ro_322  bh.hi.mr_422 eu.de.es_553
  0x2d2b0c02, 0x102b1707, 0x060c0808, 0x2864550e,   // sv.vi.sk_222 sr.vi.lt_432  no.sv.de_443 rw.lg.sw_555
  0x0d1c13a4, 0x231f1902, 0x190b0a08, 0x17000a2b,   // bh.mr.ne_433 gl.cy.ca_222  pt.es.gl_443 mk.sr.un_980
  0x0f00030d, 0x1a004a22, 0x11070a0d, 0x08041004,   // nl.lv.un_540 yo.tl.un_870  mk.bg.ro_554 be.ru.uk_332
  // [0fc0]
  0x0e13040c, 0x1f1a250c, 0x136b1a04, 0x0e086ba4,   // fi.et.is_543 eu.tl.cy_543  tl.ceb.et_332 ceb.no.is_433
  0x06003514, 0x18002118, 0x052101a4, 0x1c001e2b,   // zu.de.un_660 fa.ar.un_740  en.jw.fr_433 ms.id.un_980
  0x0a081705, 0x0a0810a0, 0x28001305, 0x080a17a9,   // sr.uk.mk_333 be.uk.mk_322  et.sw.un_330 sr.mk.uk_544
  0x0d130911, 0x051f270d, 0x0d091c0c, 0x0500181a,   // hi.bh.ne_653 gd.cy.fr_554  mr.hi.ne_543 ga.fr.un_760
  // [0fd0]
  0x16520ea7, 0x2900201a, 0x1e002707, 0x21001212,   // is.ha.hr_532 sq.sl.un_760  gd.ms.un_420 ur.fa.un_640
  0x2d002019, 0x1c09130c, 0x18002a02, 0x2a076860,   // sq.sk.un_750 bh.hi.mr_543  mt.ga.un_220 ig.it.mt_664
  0x080c09a4, 0x1b113107, 0x171632ec, 0x0b0a52a4,   // pl.sv.no_433 az.ro.tr_432  bs.hr.sr_644 ha.pt.es_433
  0x281020ee, 0x070411a0, 0x4a0f53ee, 0x1325090b,   // sq.lt.sw_422 ro.ru.bg_322  ht.lv.yo_422 pl.eu.et_542
  // [0fe0]
  0x1200250d, 0x03020807, 0x53000b02, 0x050e06a0,   // eu.hu.un_540 no.da.nl_432  es.ht.un_220 de.is.fr_322
  0x0d001309, 0x100e0fad, 0x04001009, 0x17070a14,   // bh.ne.un_440 lv.is.lt_643  be.ru.un_440 mk.bg.sr_666
  0x1f130414, 0x1f002707, 0x130d09ec, 0x0b001912,   // fi.et.cy_666 gd.cy.un_420  hi.ne.bh_644 gl.es.un_640
  0x230725a4, 0x3f112d0c, 0x2d003204, 0x05002705,   // eu.it.ca_433 sk.ro.af_543  bs.sk.un_320 gd.fr.un_330
  // [0ff0]
  0x0408170d, 0x09002d35, 0x20002909, 0x080725a6,   // sr.uk.ru_554 sk.pl.un_A90  sl.sq.un_440 eu.it.no_521
  0x09000e12, 0x0f004a04, 0x0f09010b, 0x080a1708,   // is.pl.un_640 yo.lv.un_320  en.pl.lv_542 sr.mk.uk_443
  0x680f3f11, 0x04001a08, 0x2a006407, 0x3f0b2d0c,   // af.lv.ig_653 tl.fi.un_430  lg.mt.un_420 sk.es.af_543
  0x3229200c, 0x0e000c14, 0x0d102904, 0x29322008,   // sq.sl.bs_543 sv.is.un_660  sl.lt.cs_332 sq.bs.sl_443

  // [1000]
  0x3f050da4, 0x29002019, 0x2d002007, 0x2d072511,   // cs.fr.af_433 sq.sl.un_750  sq.sk.un_420 eu.it.sk_653
  0x03113faf, 0x2d6809ad, 0x0400101b, 0x09002d2b,   // af.ro.nl_655 pl.ig.sk_643  be.ru.un_770 sk.pl.un_980
  0x1c0d130c, 0x05002704, 0x0b000708, 0x09001219,   // bh.ne.mr_543 gd.fr.un_320  it.es.un_430 hu.pl.un_750
  0x3f1a6b07, 0x1e1c2514, 0x09070da4, 0x091e25a4,   // ceb.tl.af_432 eu.id.ms_666  cs.it.pl_433 eu.ms.pl_433
  // [1010]
  0x1b003122, 0x17162909, 0x052d01a4, 0x0600092b,   // az.tr.un_870 sl.hr.sr_444  en.sk.fr_433 pl.de.un_980
  0x1b003121, 0x2d11030d, 0x0a0408a4, 0x041707a4,   // az.tr.un_860 nl.ro.sk_554  uk.ru.mk_433 bg.sr.ru_433
  0x29003108, 0x2d093f12, 0x3f090d07, 0x13000923,   // az.sl.un_430 af.pl.sk_654  cs.pl.af_432 hi.bh.un_880
  0x13000921, 0x13251904, 0x1c001319, 0x35000c0c,   // hi.bh.un_860 gl.eu.et_332  bh.mr.un_750 sv.zu.un_530
  // [1020]
  0x080c0ea9, 0x040a0805, 0x05120a04, 0x6b1c1e0c,   // is.sv.no_544 uk.mk.ru_333  pt.hu.fr_332 ms.id.ceb_543
  0x29001704, 0x19000e05, 0x1b1a4a13, 0x04170807,   // sr.sl.un_320 is.gl.un_330  yo.tl.tr_665 uk.sr.ru_432
  0x08170aad, 0x00002b03, 0x08001013, 0x0e1b1304,   // mk.sr.uk_643 vi.un.un_300  be.uk.un_650 et.tr.is_332
  0x1f004a02, 0x53000512, 0x1c0d0907, 0x070417a4,   // yo.cy.un_220 fr.ht.un_640  hi.ne.mr_432 sr.ru.bg_433
  // [1030]
  0x03000508, 0x06002a04, 0x1a0e6405, 0x070804a4,   // fr.nl.un_430 mt.de.un_320  lg.is.tl_333 ru.uk.bg_433
  0x1a1b0504, 0x311b1fa9, 0x2b3b52a0, 0x3100520d,   // fr.tr.tl_332 cy.tr.az_544  ha.so.vi_322 ha.az.un_540
  0x3b2001a4, 0x13001c14, 0x3b0419a0, 0x1a1e1c08,   // en.sq.so_433 mr.bh.un_660  gl.fi.so_322 id.ms.tl_443
  0x1f1e1c60, 0x0e001319, 0x1c0913a0, 0x1c080c05,   // id.ms.cy_664 et.is.un_750  bh.hi.mr_322 sv.no.id_333
  // [1040]
  0x1b005204, 0x25001902, 0x0c00190d, 0x076412ad,   // ha.tr.un_320 gl.eu.un_220  gl.sv.un_540 hu.lg.it_643
  0x1f00550d, 0x0c001904, 0x080c5304, 0x4a3f1aa7,   // rw.cy.un_540 gl.sv.un_320  ht.sv.no_332 tl.af.yo_532
  0x0e000a09, 0x6b001a1a, 0x020c08af, 0x040810a0,   // pt.is.un_440 tl.ceb.un_760  no.sv.da_655 be.uk.ru_322
  0x172d290c, 0x0c000823, 0x1e0f1ca0, 0x0d1c0908,   // sl.sk.sr_543 no.sv.un_880  id.lv.ms_322 hi.mr.ne_443
  // [1050]
  0x2b4a1fa7, 0x1c130907, 0x040710a9, 0x0d1c0913,   // cy.yo.vi_532 hi.bh.mr_432  be.bg.ru_544 hi.mr.ne_665
  0x092d0d55, 0x131c0912, 0x07000422, 0x011f6b02,   // cs.sk.pl_442 hi.mr.bh_654  ru.bg.un_870 ceb.cy.en_222
  0x131e0e12, 0x0a1f1955, 0x1e211cec, 0x091218a7,   // is.ms.et_654 gl.cy.pt_442  id.jw.ms_644 ga.hu.pl_532
  0x1000110b, 0x06033f13, 0x2d0d2914, 0x27002807,   // ro.be.un_520 af.nl.de_665  sl.cs.sk_666 sw.gd.un_420
  // [1060]
  0x2a3f3b04, 0x1a005304, 0x1c033f11, 0x050c01a0,   // so.af.mt_332 ht.tl.un_320  af.nl.id_653 en.sv.fr_322
  0x170a0702, 0x0704170d, 0x1a006b22, 0x521e1c08,   // bg.mk.sr_222 sr.ru.bg_554  ceb.tl.un_870 id.ms.ha_443
  0x213b35ec, 0x20003214, 0x3b2128a9, 0x4a002021,   // zu.so.jw_644 bs.sq.un_660  sw.jw.so_544 sq.yo.un_860
  0x190b0aee, 0x5300201b, 0x0700682a, 0x12000804,   // pt.es.gl_422 sq.ht.un_770  ig.it.un_970 no.hu.un_320
  // [1070]
  0x171629a9, 0x0a00071a, 0x53003119, 0x07000a02,   // sl.hr.sr_544 bg.mk.un_760  az.ht.un_750 mk.bg.un_220
  0x080c0eee, 0x2d000d02, 0x09061f07, 0x280768ec,   // is.sv.no_422 cs.sk.un_220  cy.de.pl_432 ig.it.sw_644
  0x120c0809, 0x0c282508, 0x12006804, 0x29200d07,   // no.sv.hu_444 eu.sw.sv_443  ig.hu.un_320 cs.sq.sl_432
  0x05002304, 0x0553110b, 0x6800030e, 0x23190a13,   // ca.fr.un_320 ro.ht.fr_542  nl.ig.un_550 pt.gl.ca_665
  // [1080]
  0x033f12a4, 0x52002018, 0x06076807, 0x00001e15,   // hu.af.nl_433 sq.ha.un_740  ig.it.de_432 ms.un.un_700
  0x31283b0e, 0x20006e19, 0x31005304, 0x31003202,   // so.sw.az_555 hmn.sq.un_750  ht.az.un_320 bs.az.un_220
  0x55006402, 0x172d090c, 0x0d00130c, 0x00003537,   // lg.rw.un_220 pl.sk.sr_543  bh.ne.un_530 zu.un.un_B00
  0x08020cec, 0x0417100c, 0x310452ad, 0x1c291ead,   // sv.da.no_644 be.sr.ru_543  ha.fi.az_643 ms.sl.id_643
  // [1090]
  0x35522812, 0x0410085a, 0x07000a0d, 0x07005322,   // sw.ha.zu_654 uk.be.ru_553  mk.bg.un_540 ht.it.un_870
  0x1c130914, 0x031b1211, 0x0b1223ec, 0x32172a12,   // hi.bh.mr_666 hu.tr.nl_653  ca.hu.es_644 mt.sr.bs_654
  0x0f050107, 0x23190bec, 0x130c12a4, 0x09000d13,   // en.fr.lv_432 es.gl.ca_644  hu.sv.et_433 ne.hi.un_650
  0x311b0caf, 0x03643f08, 0x683f53ec, 0x284a5304,   // sv.tr.az_655 af.lg.nl_443  ht.af.ig_644 ht.yo.sw_332
  // [10a0]
  0x07000402, 0x09000d0e, 0x251827ad, 0x1a04250c,   // ru.bg.un_220 ne.hi.un_550  gd.ga.eu_643 eu.fi.tl_543
  0x4a2d12a9, 0x2006120c, 0x1213040c, 0x353f5207,   // hu.sk.yo_544 hu.de.sq_543  fi.et.hu_543 ha.af.zu_432
  0x1025270d, 0x0c080211, 0x0c000812, 0x00004a1c,   // gd.eu.lt_554 da.no.sv_653  no.sv.un_640 yo.un.un_800
  0x00000801, 0x3100200d, 0x09001f0c, 0x00006e2d,   // no.un.un_200 sq.az.un_540  cy.pl.un_530 hmn.un.un_A00
  // [10b0]
  0x3b033f09, 0x532105ec, 0x121b0ca7, 0x1a2728a4,   // af.nl.so_444 fr.jw.ht_644  sv.tr.hu_532 sw.gd.tl_433
  0x21131cee, 0x3b001319, 0x05000108, 0x6e202a05,   // id.et.jw_422 et.so.un_750  en.fr.un_430 mt.sq.hmn_333
  0x033b3f05, 0x08000608, 0x00003b03, 0x100f25a9,   // af.so.nl_333 de.no.un_430  so.un.un_300 eu.lv.lt_544
  0x080a07a0, 0x3f033b12, 0x091c0d12, 0x11000422,   // bg.mk.uk_322 so.nl.af_654  ne.mr.hi_654 ru.ro.un_870
  // [10c0]
  0x04000f1a, 0x6b001a1b, 0x28521a12, 0x031304a7,   // lv.fi.un_760 tl.ceb.un_770  tl.ha.sw_654 fi.et.nl_532
  0x0f314aa4, 0x0d00090d, 0x524a1fa9, 0x4a033f12,   // yo.az.lv_433 hi.ne.un_540  cy.yo.ha_544 af.nl.yo_654
  0x13090d0c, 0x3f000e05, 0x070a1713, 0x53080208,   // ne.hi.bh_543 is.af.un_330  sr.mk.bg_665 da.no.ht_443
  0x0e080ca4, 0x230b050e, 0x0504250c, 0x0d1c13af,   // sv.no.is_433 fr.es.ca_555  eu.fi.fr_543 bh.mr.ne_655
  // [10d0]
  0x09001c1b, 0x16000d08, 0x3b2a0fec, 0x1632170d,   // mr.hi.un_770 cs.hr.un_430  lv.mt.so_644 sr.bs.hr_554
  0x02080c04, 0x0e001f1b, 0x100a0813, 0x31001b29,   // sv.no.da_332 cy.is.un_770  uk.mk.be_665 tr.az.un_960
  0x04131aec, 0x01080ea4, 0x11003b1a, 0x1e1c3baf,   // tl.et.fi_644 is.no.en_433  so.ro.un_760 so.id.ms_655
  0x1e006b04, 0x190a0b14, 0x03001313, 0x12082104,   // ceb.ms.un_320 es.pt.gl_666  et.nl.un_650 jw.no.hu_332
  // [10e0]
  0x2b001e02, 0x211e1c04, 0x25230112, 0x1a12680e,   // ms.vi.un_220 id.ms.jw_332  en.ca.eu_654 ig.hu.tl_555
  0x2b001c04, 0x0e002808, 0x0b000713, 0x1c0d130e,   // id.vi.un_320 sw.is.un_430  it.es.un_650 bh.ne.mr_555
  0x17000d04, 0x03281355, 0x3b001f0d, 0x18002711,   // cs.sr.un_320 et.sw.nl_442  cy.so.un_540 gd.ga.un_630
  0x1100681b, 0x1b00530d, 0x070a0408, 0x0817110c,   // ig.ro.un_770 ht.tr.un_540  ru.mk.bg_443 ro.sr.uk_543
  // [10f0]
  0x21001114, 0x03113f0c, 0x271718ec, 0x03071808,   // ro.jw.un_660 af.ro.nl_543  ga.sr.gd_644 ga.it.nl_443
  0x03003f22, 0x0e001e04, 0x0e000619, 0x0d001307,   // af.nl.un_870 ms.is.un_320  de.is.un_750 bh.ne.un_420
  0x17070408, 0x081f0607, 0x2000280d, 0x021b0e05,   // ru.bg.sr_443 de.cy.no_432  sw.sq.un_540 is.tr.da_333
  0x04171008, 0x1e002818, 0x52001c04, 0x040711ec,   // be.sr.ru_443 sw.ms.un_740  id.ha.un_320 ro.bg.ru_644
  // [1100]
  0x18002a08, 0x24000113, 0x55202813, 0x02000e22,   // mt.ga.un_430 iw.yi.un_650  sw.sq.rw_665 is.da.un_870
  0x0800120c, 0x06002302, 0x01001f04, 0x1c000d12,   // hu.no.un_530 ca.de.un_220  cy.en.un_320 ne.mr.un_640
  0x2900170d, 0x070811a4, 0x0f001904, 0x080a1107,   // sr.sl.un_540 ro.uk.bg_433  gl.lv.un_320 ro.mk.uk_432
  0x6b100755, 0x2d0d10ec, 0x080417a0, 0x3f00030e,   // it.lt.ceb_442 lt.cs.sk_644  sr.ru.uk_322 nl.af.un_550
  // [1110]
  0x1a00211b, 0x09005512, 0x52004a0c, 0x0e001f13,   // jw.tl.un_770 rw.pl.un_640  yo.ha.un_530 cy.is.un_650
  0x125204ac, 0x0b0a23a9, 0x1f0b2307, 0x29172daf,   // fi.ha.hu_632 ca.pt.es_544  ca.es.cy_432 sk.sr.sl_655
  0x0900530d, 0x2a00550d, 0x25000521, 0x32001609,   // ht.pl.un_540 rw.mt.un_540  fr.eu.un_860 hr.bs.un_440
  0x0a001713, 0x2a000702, 0x1e211ca0, 0x1c002112,   // sr.mk.un_650 it.mt.un_220  id.jw.ms_322 jw.id.un_640
  // [1120]
  0x110827ad, 0x0d001c20, 0x092d0d08, 0x3217160c,   // gd.no.ro_643 mr.ne.un_850  cs.sk.pl_443 hr.sr.bs_543
  0x12002512, 0x12002123, 0x25000b08, 0x1300122b,   // eu.hu.un_640 fa.ur.un_880  es.eu.un_430 hu.et.un_980
  0x1c001f1a, 0x28081f04, 0x13001c0e, 0x16002911,   // cy.id.un_760 cy.no.sw_332  id.et.un_550 sl.hr.un_630
  0x3f1f13ee, 0x64041ca0, 0x00003503, 0x23000419,   // et.cy.af_422 id.fi.lg_322  zu.un.un_300 fi.ca.un_750
  // [1130]
  0x1c0d1305, 0x0a002818, 0x070a0812, 0x07000405,   // bh.ne.mr_333 sw.pt.un_740  uk.mk.bg_654 ru.bg.un_330
  0x0a00042a, 0x06351aa0, 0x051f0408, 0x0500070c,   // ru.mk.un_970 tl.zu.de_322  fi.cy.fr_443 it.fr.un_530
  0x10000819, 0x11000505, 0x2a04020c, 0x00003501,   // uk.be.un_750 fr.ro.un_330  da.fi.mt_543 zu.un.un_200
  0x13000305, 0x1c000922, 0x12082055, 0x04000808,   // nl.et.un_330 hi.mr.un_870  sq.no.hu_442 no.fi.un_430
  // [1140]
  0x0700010d, 0x08021aa0, 0x21001c07, 0x193b0bad,   // en.it.un_540 tl.da.no_322  id.jw.un_420 es.so.gl_643
  0x4a28640c, 0x291b280c, 0x081f0e08, 0x12071ba4,   // lg.sw.yo_543 sw.tr.sl_543  is.cy.no_443 tr.it.hu_433
  0x0000320f, 0x28006b04, 0x0100350e, 0x23001a04,   // bs.un.un_600 ceb.sw.un_320  zu.en.un_550 tl.ca.un_320
  0x556428ad, 0x29003213, 0x0507010c, 0x0d000902,   // sw.lg.rw_643 bs.sl.un_650  en.it.fr_543 hi.ne.un_220
  // [1150]
  0x130410a9, 0x3f000308, 0x64551a08, 0x04091fa9,   // lt.fi.et_544 nl.af.un_430  tl.rw.lg_443 cy.pl.fi_544
  0x01001109, 0x0a000709, 0x070411ad, 0x08110707,   // ro.en.un_440 it.pt.un_440  ro.ru.bg_643 it.ro.no_432
  0x0e0752ee, 0x06031b08, 0x53100908, 0x06033f0d,   // ha.it.is_422 tr.nl.de_443  pl.lt.ht_443 af.nl.de_554
  0x16002912, 0x050c6ba0, 0x2a290aaf, 0x18122114,   // sl.hr.un_640 ceb.sv.fr_322  pt.sl.mt_655 fa.ur.ar_666
  // [1160]
  0x2a096807, 0x06321709, 0x07050107, 0x01106ba0,   // ig.pl.mt_432 sr.bs.de_444  en.fr.it_432 ceb.lt.en_322
  0x1f010604, 0x040601a4, 0x231b0607, 0x2855350d,   // de.en.cy_332 en.de.fi_433  de.tr.ca_432 zu.rw.sw_554
  0x2100182a, 0x351a08a4, 0x070604ad, 0x110a1709,   // ar.fa.un_970 no.tl.zu_433  fi.de.it_643 sr.mk.ro_444
  0x2021280d, 0x052352ac, 0x0d1c1304, 0x25000a1a,   // sw.jw.sq_554 ha.ca.fr_632  bh.mr.ne_332 pt.eu.un_760
  // [1170]
  0x04081704, 0x5500251b, 0x0711040c, 0x28256ba4,   // sr.uk.ru_332 eu.rw.un_770  ru.ro.bg_543 ceb.eu.sw_433
  0x271828a9, 0x06002a0d, 0x53014aee, 0x2a27350c,   // sw.ga.gd_544 mt.de.un_540  yo.en.ht_422 zu.gd.mt_543
  0x25003504, 0x2868180d, 0x6b006408, 0x311b09a4,   // zu.eu.un_320 ga.ig.sw_554  lg.ceb.un_430 pl.tr.az_433
  0x10080460, 0x3b002704, 0x070a11a4, 0x0a0817a0,   // ru.uk.be_664 gd.so.un_320  ro.mk.bg_433 sr.uk.mk_322
  // [1180]
  0x68110708, 0x1c000705, 0x07000a14, 0x0429130d,   // it.ro.ig_443 it.id.un_330  mk.bg.un_660 et.sl.fi_554
  0x130e04ad, 0x0e00101b, 0x060501af, 0x356e20ad,   // fi.is.et_643 lt.is.un_770  en.fr.de_655 sq.hmn.zu_643
  0x16000907, 0x07001828, 0x3b684aa4, 0x13290913,   // pl.hr.un_420 ar.bg.un_950  yo.ig.so_433 pl.sl.et_665
  0x2a090f12, 0x2700350e, 0x1c00042a, 0x162a04a4,   // lv.pl.mt_654 zu.gd.un_550  fi.id.un_970 fi.mt.hr_433
  // [1190]
  0x12002114, 0x55281ea0, 0x4a096407, 0x1f001904,   // fa.ur.un_660 ms.sw.rw_322  lg.pl.yo_432 gl.cy.un_320
  0x0400071a, 0x3b130908, 0x04643b0c, 0x1a003b0d,   // bg.ru.un_760 pl.et.so_443  so.lg.fi_543 so.tl.un_540
  0x081704ad, 0x1c130908, 0x6e6b01a4, 0x08000c0e,   // ru.sr.uk_643 hi.bh.mr_443  en.ceb.hmn_433 sv.no.un_550
  0x3f3b645a, 0x080704a9, 0x2b1f2704, 0x04112355,   // lg.so.af_553 ru.bg.uk_544  gd.cy.vi_332 ca.ro.fi_442
  // [11a0]
  0x0e20060b, 0x0a684a08, 0x29092512, 0x015528a4,   // de.sq.is_542 yo.ig.pt_443  eu.pl.sl_654 sw.rw.en_433
  0x1c133b07, 0x04643f0c, 0x08534aa6, 0x1f003f21,   // so.et.id_432 af.lg.fi_543  yo.ht.no_521 af.cy.un_860
  0x17041007, 0x0e001908, 0x1a643b08, 0x0409290d,   // be.ru.sr_432 gl.is.un_430  so.lg.tl_443 sl.pl.fi_554
  0x1800212b, 0x4a006420, 0x64003b2b, 0x03280507,   // fa.ar.un_980 lg.yo.un_850  so.lg.un_980 fr.sw.nl_432
  // [11b0]
  0x0e5209a9, 0x10040708, 0x06356804, 0x04070a08,   // pl.ha.is_544 bg.ru.be_443  ig.zu.de_332 mk.bg.ru_443
  0x08021ba4, 0x64003b1b, 0x1b290914, 0x6435280c,   // tr.da.no_433 so.lg.un_770  pl.sl.tr_666 sw.zu.lg_543
  0x03003b0b, 0x23190b09, 0x2d003513, 0x2d082908,   // so.nl.un_520 es.gl.ca_444  zu.sk.un_650 sl.no.sk_443
  0x1c0913ec, 0x2d000d11, 0x1c090d5a, 0x1b000c07,   // bh.hi.mr_644 cs.sk.un_630  ne.hi.mr_553 sv.tr.un_420
  // [11c0]
  0x1800201a, 0x641a3b0c, 0x6b1a6812, 0x1929230c,   // sq.ga.un_760 so.tl.lg_543  ig.tl.ceb_654 ca.sl.gl_543
  0x28643b60, 0x31001114, 0x090d1ca0, 0x0a040713,   // so.lg.sw_664 ro.az.un_660  mr.ne.hi_322 bg.ru.mk_665
  0x643b1a09, 0x3b00640d, 0x046b1aa4, 0x070f68a4,   // tl.so.lg_444 lg.so.un_540  tl.ceb.fi_433 ig.lv.it_433
  0x18122113, 0x1f271813, 0x3f000a05, 0x0a0811a0,   // fa.ur.ar_665 ga.gd.cy_665  pt.af.un_330 ro.uk.mk_322
  // [11d0]
  0x04080aa4, 0x6b0a1f08, 0x0400081a, 0x4a00680d,   // mk.uk.ru_433 cy.pt.ceb_443  uk.ru.un_760 ig.yo.un_540
  0x093f0304, 0x17040a05, 0x211c1ea4, 0x17080704,   // nl.af.pl_332 mk.ru.sr_333  ms.id.jw_433 bg.uk.sr_332
  0x05070112, 0x12000e05, 0x0e1918a0, 0x2311100c,   // en.it.fr_654 is.hu.un_330  ga.gl.is_322 lt.ro.ca_543
  0x231119a4, 0x0a002319, 0x0f001318, 0x35001a07,   // gl.ro.ca_433 ca.pt.un_750  et.lv.un_740 tl.zu.un_420
  // [11e0]
  0x2d1009a9, 0x2800682a, 0x08042712, 0x271304ad,   // pl.lt.sk_544 ig.sw.un_970  gd.fi.no_654 fi.et.gd_643
  0x0807120c, 0x270e0655, 0x06000808, 0x21182712,   // hu.it.no_543 de.is.gd_442  no.de.un_430 gd.ga.jw_654
  0x0000352d, 0x04001014, 0x096b35a0, 0x27202114,   // zu.un.un_A00 be.ru.un_660  zu.ceb.pl_322 jw.sq.gd_666
  0x11000d08, 0x0a07100e, 0x21001c05, 0x4a202dee,   // cs.ro.un_430 be.bg.mk_555  id.jw.un_330 sk.sq.yo_422
  // [11f0]
  0x1168270c, 0x101123ac, 0x023b070c, 0x17110a04,   // gd.ig.ro_543 ca.ro.lt_632  it.so.da_543 mk.ro.sr_332
  0x0c19230c, 0x04080aad, 0x1e191108, 0x11092da9,   // ca.gl.sv_543 mk.uk.ru_643  ro.gl.ms_443 sk.pl.ro_544
  0x06000e1a, 0x0c091007, 0x09201702, 0x1200212a,   // is.de.un_760 lt.pl.sv_432  sr.sq.pl_222 fa.ur.un_970
  0x160712a7, 0x536b1aaf, 0x3b006b05, 0x1a6b0705,   // hu.it.hr_532 tl.ceb.ht_655  ceb.so.un_330 it.ceb.tl_333
  // [1200]
  0x132801a0, 0x182721af, 0x350f10af, 0x061e1c08,   // en.sw.et_322 jw.gd.ga_655  lt.lv.zu_655 id.ms.de_443
  0x203b28ad, 0x551a20a4, 0x2d111005, 0x31002023,   // sw.so.sq_643 sq.tl.rw_433  lt.ro.sk_333 sq.az.un_880
  0x010535a0, 0x19002319, 0x35312055, 0x0c02080c,   // zu.fr.en_322 ca.gl.un_750  sq.az.zu_442 no.da.sv_543
  0x08000719, 0x10231108, 0x32001614, 0x20005514,   // bg.uk.un_750 ro.ca.lt_443  hr.bs.un_660 rw.sq.un_660
  // [1210]
  0x53006407, 0x20351812, 0x1168230c, 0x1b1853a0,   // lg.ht.un_420 ga.zu.sq_654  ca.ig.ro_543 ht.ga.tr_322
  0x32166ba0, 0x1e110ba0, 0x20000d04, 0x2b001a04,   // ceb.hr.bs_322 es.ro.ms_322  cs.sq.un_320 tl.vi.un_320
  0x2010110d, 0x0a011a07, 0x3555520d, 0x232d100c,   // ro.lt.sq_554 tl.en.pt_432  ha.rw.zu_554 lt.sk.ca_543
  0x1b05350c, 0x023f08a4, 0x0d000f08, 0x1b132007,   // zu.fr.tr_543 no.af.da_433  lv.cs.un_430 sq.et.tr_432
  // [1220]
  0x19000b21, 0x6b551a08, 0x1a096b09, 0x2b1a6ba0,   // es.gl.un_860 tl.rw.ceb_443  ceb.pl.tl_444 ceb.tl.vi_322
  0x03012aee, 0x0e2a1004, 0x02000404, 0x021a6ba9,   // mt.en.nl_422 lt.mt.is_332  fi.da.un_320 ceb.tl.da_544
  0x1c2952a4, 0x17040705, 0x3f552a55, 0x28352014,   // ha.sl.id_433 bg.ru.sr_333  mt.rw.af_442 sq.zu.sw_666
  0x3531640c, 0x01001e07, 0x09003504, 0x200b1313,   // lg.az.zu_543 ms.en.un_420  zu.pl.un_320 et.es.sq_665
  // [1230]
  0x01060c04, 0x311a10a4, 0x170a0409, 0x05010605,   // sv.de.en_332 lt.tl.az_433  ru.mk.sr_444 de.en.fr_333
  0x292d0d14, 0x0c000813, 0x1f003513, 0x64002704,   // cs.sk.sl_666 no.sv.un_650  zu.cy.un_650 gd.lg.un_320
  0x00001b0a, 0x09003f02, 0x130d0914, 0x290d02a0,   // tr.un.un_500 af.pl.un_220  hi.ne.bh_666 da.cs.sl_322
  0x1c002107, 0x25000b02, 0x4a1a6ba0, 0x2a033fa0,   // jw.id.un_420 es.eu.un_220  ceb.tl.yo_322 af.nl.mt_322
  // [1240]
  0x07080409, 0x101e1c05, 0x04070813, 0x19000a07,   // ru.uk.bg_444 id.ms.lt_333  uk.bg.ru_665 pt.gl.un_420
  0x0d091c0b, 0x0411170d, 0x08001002, 0x0f00100d,   // mr.hi.ne_542 sr.ro.ru_554  be.uk.un_220 lt.lv.un_540
  0x19270aa4, 0x162d0d09, 0x040f18a0, 0x05000702,   // pt.gd.gl_433 cs.sk.hr_444  ga.lv.fi_322 it.fr.un_220
  0x521e25a9, 0x1e1c350c, 0x3b001013, 0x35003b09,   // eu.ms.ha_544 zu.id.ms_543  lt.so.un_650 so.zu.un_440
  // [1250]
  0x09130d11, 0x0d091307, 0x0e000c13, 0x5500100e,   // ne.bh.hi_653 bh.hi.ne_432  sv.is.un_650 lt.rw.un_550
  0x06033f04, 0x040e0ca7, 0x053211ee, 0x072705a0,   // af.nl.de_332 sv.is.fi_532  ro.bs.fr_422 fr.gd.it_322
  0x551e1c05, 0x532a0508, 0x170711af, 0x18002721,   // id.ms.rw_333 fr.mt.ht_443  ro.bg.sr_655 gd.ga.un_860
  0x28005505, 0x1e101c12, 0x27186eee, 0x1c090d08,   // rw.sw.un_330 id.lt.ms_654  hmn.ga.gd_422 ne.hi.mr_443
  // [1260]
  0x080a0709, 0x13090d11, 0x10000b02, 0x07170804,   // bg.mk.uk_444 ne.hi.bh_653  es.lt.un_220 uk.sr.bg_332
  0x08170a09, 0x1a645504, 0x06001b13, 0x35005504,   // mk.sr.uk_444 rw.lg.tl_332  tr.de.un_650 rw.zu.un_320
  0x3b000702, 0x10070409, 0x28001c02, 0x08020c11,   // it.so.un_220 ru.bg.be_444  id.sw.un_220 sv.da.no_653
  0x0c0208a7, 0x23190aa0, 0x1e0f18a0, 0x68003522,   // no.da.sv_532 pt.gl.ca_322  ga.lv.ms_322 zu.ig.un_870
  // [1270]
  0x29100411, 0x2d1b0d55, 0x1f002512, 0x0408100c,   // fi.lt.sl_653 cs.tr.sk_442  eu.cy.un_640 be.uk.ru_543
  0x35536812, 0x0c321ca0, 0x180427af, 0x08000209,   // ig.ht.zu_654 id.bs.sv_322  gd.fi.ga_655 da.no.un_440
  0x1c0d1307, 0x0f2920a4, 0x09000804, 0x3b001c08,   // bh.ne.mr_432 sq.sl.lv_433  no.pl.un_320 id.so.un_430
  0x551e1c0c, 0x3b000d22, 0x1004640c, 0x2d0d0a0c,   // id.ms.rw_543 cs.so.un_870  lg.fi.lt_543 pt.cs.sk_543
  // [1280]
  0x2d0d3bec, 0x55351c08, 0x040e640c, 0x531e1c04,   // so.cs.sk_644 id.zu.rw_443  lg.is.fi_543 id.ms.ht_332
  0x172d0d55, 0x07170a08, 0x1b003204, 0x07041012,   // cs.sk.sr_442 mk.sr.bg_443  bs.tr.un_320 be.ru.bg_654
  0x046408a0, 0x170a070c, 0x00000d0a, 0x0f006409,   // no.lg.fi_322 bg.mk.sr_543  cs.un.un_500 lg.lv.un_440
  0x0d000a08, 0x08000212, 0x19000b22, 0x04086407,   // pt.cs.un_430 da.no.un_640  es.gl.un_870 lg.no.fi_432
  // [1290]
  0x07080a05, 0x211c1aa4, 0x6400681b, 0x08000a12,   // mk.uk.bg_333 tl.id.jw_433  ig.lg.un_770 mk.uk.un_640
  0x0a1707ad, 0x1e1c210e, 0x0c000d1a, 0x1700030c,   // bg.sr.mk_643 jw.id.ms_555  cs.sv.un_760 nl.sr.un_530
  0x2d005304, 0x0d001c08, 0x131c1a04, 0x0f321705,   // ht.sk.un_320 mr.ne.un_430  tl.id.et_332 sr.bs.lv_333
  0x030e12af, 0x13003f07, 0x09250d07, 0x110b5507,   // hu.is.nl_655 af.et.un_420  cs.eu.pl_432 rw.es.ro_432
  // [12a0]
  0x100a1708, 0x0c0601af, 0x2a3b25ad, 0x1b000c04,   // sr.mk.be_443 en.de.sv_655  eu.so.mt_643 sv.tr.un_320
  0x190d0aa7, 0x04001307, 0x0e10640b, 0x050111ee,   // pt.cs.gl_532 et.fi.un_420  lg.lt.is_542 ro.en.fr_422
  0x2a523b12, 0x2d290dec, 0x2d0d0aaf, 0x05000a08,   // so.ha.mt_654 cs.sl.sk_644  pt.cs.sk_655 pt.fr.un_430
  0x11204aa0, 0x04120308, 0x101e1c04, 0x3f000808,   // yo.sq.ro_322 nl.hu.fi_443  id.ms.lt_332 no.af.un_430
  // [12b0]
  0x061e1c04, 0x3200010c, 0x08070408, 0x280f1105,   // id.ms.de_332 en.bs.un_530  ru.bg.uk_443 ro.lv.sw_333
  0x21252a04, 0x3b00311b, 0x5300050b, 0x0c002105,   // mt.eu.jw_332 az.so.un_770  fr.ht.un_520 jw.sv.un_330
  0x100711a7, 0x1700100b, 0x02000612, 0x07002a14,   // ro.bg.be_532 be.sr.un_520  de.da.un_640 mt.it.un_660
  0x170a1108, 0x12190a0c, 0x1f1827ec, 0x25001c04,   // ro.mk.sr_443 pt.gl.hu_543  gd.ga.cy_644 id.eu.un_320
  // [12c0]
  0x08070412, 0x0c0e0da4, 0x3f030204, 0x0c0208ee,   // ru.bg.uk_654 cs.is.sv_433  da.nl.af_332 no.da.sv_422
  0x040f1c04, 0x21001814, 0x1c000912, 0x091c13ad,   // id.lv.fi_332 ar.fa.un_660  hi.mr.un_640 bh.mr.hi_643
  0x1821120d, 0x0b23190c, 0x0b0a19a0, 0x3f072013,   // ur.fa.ar_554 gl.ca.es_543  gl.pt.es_322 sq.it.af_665
  0x23190b0e, 0x09131c10, 0x0d091c05, 0x3b000804,   // es.gl.ca_555 mr.bh.hi_642  mr.hi.ne_333 no.so.un_320
  // [12d0]
  0x07002308, 0x190b1fec, 0x06000c0e, 0x120d2d11,   // ca.it.un_430 cy.es.gl_644  sv.de.un_550 sk.cs.hu_653
  0x280f31a4, 0x553b1a0e, 0x19530507, 0x110408af,   // az.lv.sw_433 tl.so.rw_555  fr.ht.gl_432 uk.ru.ro_655
  0x11041760, 0x041353a0, 0x2d0d0aec, 0x52060eee,   // sr.ru.ro_664 ht.et.fi_322  pt.cs.sk_644 is.de.ha_422
  0x182112af, 0x0c0e29ad, 0x1e1c12a4, 0x080e0408,   // ur.fa.ar_655 sl.is.sv_643  hu.id.ms_433 fi.is.no_443
  // [12e0]
  0x0d1c09ec, 0x0a1704a9, 0x17292808, 0x3f032909,   // hi.mr.ne_644 ru.sr.mk_544  sw.sl.sr_443 sl.nl.af_444
  0x0c1e2504, 0x25006404, 0x080c1fa0, 0x0635080c,   // eu.ms.sv_332 lg.eu.un_320  cy.sv.no_322 no.zu.de_543
  0x216b1aad, 0x0a081004, 0x07040a0d, 0x033f6407,   // tl.ceb.jw_643 be.uk.mk_332  mk.ru.bg_554 lg.af.nl_432
  0x11002007, 0x0e002007, 0x0d0913ec, 0x17100811,   // sq.ro.un_420 sq.is.un_420  bh.hi.ne_644 uk.be.sr_653
  // [12f0]
  0x3f0208a9, 0x08020c09, 0x16000312, 0x01060ca6,   // no.da.af_544 sv.da.no_444  nl.hr.un_640 sv.de.en_521
  0x18013ba0, 0x25001904, 0x121b1807, 0x2d132912,   // so.en.ga_322 gl.eu.un_320  ga.tr.hu_432 sl.et.sk_654
  0x01532707, 0x033f2b07, 0x08020e0c, 0x1c002122,   // gd.ht.en_432 vi.af.nl_432  is.da.no_543 jw.id.un_870
  0x29321ca0, 0x21526bad, 0x061c2104, 0x12286405,   // id.bs.sl_322 ceb.ha.jw_643  jw.id.de_332 lg.sw.hu_333
  // [1300]
  0x11070a08, 0x0000182d, 0x3f000335, 0x0d1a6b08,   // mk.bg.ro_443 ar.un.un_A00  nl.af.un_A90 ceb.tl.cs_443
  0x013b5311, 0x1c0d0913, 0x3b3f030c, 0x0d122dad,   // ht.so.en_653 hi.ne.mr_665  nl.af.so_543 sk.hu.cs_643
  0x09000d2b, 0x3f080c08, 0x06310fa4, 0x0d2d1211,   // ne.hi.un_980 sv.no.af_443  lv.az.de_433 hu.sk.cs_653
  0x52004a04, 0x033b3fa4, 0x64005508, 0x0a07100c,   // yo.ha.un_320 af.so.nl_433  rw.lg.un_430 be.bg.mk_543
  // [1310]
  0x292d25ec, 0x1c0516a0, 0x13004a0d, 0x0b0a1914,   // eu.sk.sl_644 hr.fr.id_322  yo.et.un_540 gl.pt.es_666
  0x1203530c, 0x01005312, 0x033f1313, 0x07080413,   // ht.nl.hu_543 ht.en.un_640  et.af.nl_665 ru.uk.bg_665
  0x290919ee, 0x050a19a0, 0x18002014, 0x16292d07,   // gl.pl.sl_422 gl.pt.fr_322  sq.ga.un_660 sk.sl.hr_432
  0x64001b21, 0x091c135a, 0x2b5206a4, 0x10645304,   // tr.lg.un_860 bh.mr.hi_553  de.ha.vi_433 ht.lg.lt_332
  // [1320]
  0x2d0d1702, 0x3b081aa9, 0x033b01a9, 0x530208af,   // sr.cs.sk_222 tl.no.so_544  en.so.nl_544 no.da.ht_655
  0x0a080705, 0x1e005204, 0x2921120c, 0x1a250e08,   // bg.uk.mk_333 ha.ms.un_320  hu.jw.sl_543 is.eu.tl_443
  0x3f0364a0, 0x10003209, 0x17040aaf, 0x4a1a6bec,   // lg.nl.af_322 bs.lt.un_440  mk.ru.sr_655 ceb.tl.yo_644
  0x6b281a07, 0x2d000714, 0x55003519, 0x1a6b64a4,   // tl.sw.ceb_432 it.sk.un_660  zu.rw.un_750 lg.ceb.tl_433
  // [1330]
  0x170410af, 0x68061f07, 0x1f0453ee, 0x133f035a,   // be.ru.sr_655 cy.de.ig_432  ht.fi.cy_422 nl.af.et_553
  0x1f062305, 0x011f5355, 0x013f0305, 0x01033fa0,   // ca.de.cy_333 ht.cy.en_442  nl.af.en_333 af.nl.en_322
  0x12006423, 0x190b1109, 0x3f00032c, 0x53001c04,   // lg.hu.un_880 ro.es.gl_444  nl.af.un_990 id.ht.un_320
  0x08070a55, 0x1e1c6b0e, 0x18003b12, 0x352b4aa0,   // mk.bg.uk_442 ceb.id.ms_555  so.ga.un_640 yo.vi.zu_322
  // [1340]
  0x28006820, 0x00006b24, 0x1e1c01a0, 0x08171008,   // ig.sw.un_850 ceb.un.un_900  en.id.ms_322 be.sr.uk_443
  0x1c091309, 0x0c033fa0, 0x07100405, 0x07002a19,   // bh.hi.mr_444 af.nl.sv_322  ru.be.bg_333 mt.it.un_750
  0x101f18a9, 0x1f194aa4, 0x283552a0, 0x191f1011,   // ga.cy.lt_544 yo.gl.cy_433  ha.zu.sw_322 lt.cy.gl_653
  0x10522555, 0x120b25ee, 0x04170708, 0x041b3bad,   // eu.ha.lt_442 eu.es.hu_422  bg.sr.ru_443 so.tr.fi_643
  // [1350]
  0x0b124aaf, 0x17321608, 0x12006e11, 0x0b4a120c,   // yo.hu.es_655 hr.bs.sr_443  hmn.hu.un_630 hu.yo.es_543
  0x0a00071b, 0x19120b07, 0x04025204, 0x186b01a7,   // bg.mk.un_770 es.hu.gl_432  ha.da.fi_332 en.ceb.ga_532
  0x100305a0, 0x3b356405, 0x32002908, 0x120b4aec,   // fr.nl.lt_322 lg.zu.so_333  sl.bs.un_430 yo.es.hu_644
  0x0b001221, 0x07190a5a, 0x2800201b, 0x10080414,   // hu.es.un_860 pt.gl.it_553  sq.sw.un_770 ru.uk.be_666
  // [1360]
  0x202a07a4, 0x0a0811af, 0x12230b08, 0x0d002d2b,   // it.mt.sq_433 ro.uk.mk_655  es.ca.hu_443 sk.cs.un_980
  0x1c2164a7, 0x3216095a, 0x080c3ba4, 0x10000712,   // lg.jw.id_532 pl.hr.bs_553  so.sv.no_433 bg.be.un_640
  0x2100181b, 0x642a52a4, 0x32172a08, 0x2d0d21a0,   // ar.fa.un_770 ha.mt.lg_433  mt.sr.bs_443 jw.cs.sk_322
  0x6800101a, 0x121821ad, 0x1f000414, 0x2d000d05,   // lt.ig.un_760 fa.ar.ur_643  fi.cy.un_660 cs.sk.un_330
  // [1370]
  0x1c00090c, 0x1c1304ee, 0x190a1fa4, 0x1f0410ad,   // hi.mr.un_530 fi.et.id_422  cy.pt.gl_433 lt.fi.cy_643
  0x08040707, 0x02080c0c, 0x012d0d0d, 0x53000308,   // bg.ru.uk_432 sv.no.da_543  cs.sk.en_554 nl.ht.un_430
  0x12190bac, 0x080f040c, 0x4a230b05, 0x08171104,   // es.gl.hu_632 fi.lv.no_543  es.ca.yo_333 ro.sr.uk_332
  0x09000113, 0x120b2313, 0x20005523, 0x2a00091b,   // en.pl.un_650 ca.es.hu_665  rw.sq.un_880 pl.mt.un_770
  // [1380]
  0x12003b19, 0x18001214, 0x55001b0c, 0x0704080c,   // so.hu.un_750 ur.ar.un_660  tr.rw.un_530 uk.ru.bg_543
  0x03003f0d, 0x2d000d2c, 0x292a0f55, 0x23060313,   // af.nl.un_540 cs.sk.un_990  lv.mt.sl_442 nl.de.ca_665
  0x08000c04, 0x0d002d2a, 0x283b6407, 0x312a295a,   // sv.no.un_320 sk.cs.un_970  lg.so.sw_432 sl.mt.az_553
  0x040a07a9, 0x0000232d, 0x13000104, 0x04070a14,   // bg.mk.ru_544 ca.un.un_A00  en.et.un_320 mk.bg.ru_666
  // [1390]
  0x05001804, 0x0d1c0912, 0x3f2506ad, 0x01006e07,   // ga.fr.un_320 hi.mr.ne_654  de.eu.af_643 hmn.en.un_420
  0x0e0a23ee, 0x180f2712, 0x03190a04, 0x1a1c1ea9,   // ca.pt.is_422 gd.lv.ga_654  pt.gl.nl_332 ms.id.tl_544
  0x0f1017a4, 0x2d0d090e, 0x2a00071b, 0x13553504,   // sr.lt.lv_433 pl.cs.sk_555  it.mt.un_770 zu.rw.et_332
  0x0f001704, 0x526b3508, 0x0a100808, 0x1f000912,   // sr.lv.un_320 zu.ceb.ha_443  uk.be.mk_443 pl.cy.un_640
  // [13a0]
  0x2300010d, 0x28350908, 0x55352808, 0x0a2755a0,   // en.ca.un_540 pl.zu.sw_443  sw.zu.rw_443 rw.gd.pt_322
  0x35556ba4, 0x1a3555af, 0x641f07ee, 0x554a35ac,   // ceb.rw.zu_433 rw.zu.tl_655  it.cy.lg_422 zu.yo.rw_632
  0x52001004, 0x23001b07, 0x21556ba0, 0x1c1b1e0b,   // lt.ha.un_320 tr.ca.un_420  ceb.rw.jw_322 ms.tr.id_542
  0x0c00060c, 0x1300292a, 0x3b286b09, 0x2300120c,   // de.sv.un_530 sl.et.un_970  ceb.sw.so_444 hu.ca.un_530
  // [13b0]
  0x08001f12, 0x32061ea0, 0x28645560, 0x292d0d07,   // cy.no.un_640 ms.de.bs_322  rw.lg.sw_664 cs.sk.sl_432
  0x07081707, 0x196b64a7, 0x556864a4, 0x64552804,   // sr.uk.bg_432 lg.ceb.gl_532  lg.ig.rw_433 sw.rw.lg_332
  0x1e001c21, 0x29351605, 0x13001c19, 0x35110baf,   // id.ms.un_860 hr.zu.sl_333  mr.bh.un_750 es.ro.zu_655
  0x3f5564a4, 0x10001108, 0x11070808, 0x1000110c,   // lg.rw.af_433 ro.lt.un_430  uk.bg.ro_443 ro.be.un_530
  // [13c0]
  0x250b08a4, 0x071801a0, 0x0c0208a4, 0x25132907,   // no.es.eu_433 en.ga.it_322  no.da.sv_433 sl.et.eu_432
  0x52002519, 0x081f0d0c, 0x10645504, 0x02033f13,   // eu.ha.un_750 cs.cy.no_543  rw.lg.lt_332 af.nl.da_665
  0x3b00550c, 0x2511550c, 0x06080213, 0x100d0508,   // rw.so.un_530 rw.ro.eu_543  da.no.de_665 fr.cs.lt_443
  0x0e352108, 0x10000422, 0x04131ea0, 0x0f002919,   // jw.zu.is_443 ru.be.un_870  ms.et.fi_322 sl.lv.un_750
  // [13d0]
  0x19050b08, 0x08101705, 0x1a006b19, 0x190b1a55,   // es.fr.gl_443 sr.be.uk_333  ceb.tl.un_750 tl.es.gl_442
  0x6b0f1a07, 0x101b0aa0, 0x311b13a7, 0x0804115a,   // tl.lv.ceb_432 pt.tr.lt_322  et.tr.az_532 ro.ru.uk_553
  0x3509250c, 0x00000d2d, 0x31001b20, 0x68643507,   // eu.pl.zu_543 ne.un.un_A00  tr.az.un_850 zu.lg.ig_432
  0x07682ba6, 0x181f35ec, 0x00002006, 0x2300111b,   // vi.ig.it_521 zu.cy.ga_644  sq.un.un_400 ro.ca.un_770
  // [13e0]
  0x2b003512, 0x0302080c, 0x092d0dad, 0x35283ba4,   // zu.vi.un_640 no.da.nl_543  cs.sk.pl_643 so.sw.zu_433
  0x092d19a7, 0x091c1308, 0x2b003519, 0x0e00351b,   // gl.sk.pl_532 bh.mr.hi_443  zu.vi.un_750 zu.is.un_770
  0x3f122811, 0x11001902, 0x272b11ad, 0x3f002104,   // sw.hu.af_653 gl.ro.un_220  ro.vi.gd_643 jw.af.un_320
  0x1100120d, 0x2a001319, 0x32171660, 0x062504ec,   // hu.ro.un_540 et.mt.un_750  hr.sr.bs_664 fi.eu.de_644
  // [13f0]
  0x11002314, 0x0a0407af, 0x033f53a4, 0x1b123112,   // ca.ro.un_660 bg.ru.mk_655  ht.af.nl_433 az.hu.tr_654
  0x12001b1a, 0x0d130912, 0x172d2908, 0x0a001705,   // tr.hu.un_760 hi.bh.ne_654  sl.sk.sr_443 sr.mk.un_330
  0x23005307, 0x121b2d0c, 0x28003504, 0x1b1629a4,   // ht.ca.un_420 sk.tr.hu_543  zu.sw.un_320 sl.hr.tr_433
  0x033f23a9, 0x1e00180d, 0x356829ad, 0x53000504,   // ca.af.nl_544 ga.ms.un_540  sl.ig.zu_643 fr.ht.un_320

  // [1400]
  0x1a006b04, 0x170711a4, 0x0400120e, 0x2500121b,   // ceb.tl.un_320 ro.bg.sr_433  hu.fi.un_550 hu.eu.un_770
  0x1c13090d, 0x09000421, 0x0c3f0312, 0x00003f06,   // hi.bh.mr_554 fi.pl.un_860  nl.af.sv_654 af.un.un_400
  0x29321708, 0x19230aa0, 0x043b3507, 0x04070808,   // sr.bs.sl_443 pt.ca.gl_322  zu.so.fi_432 uk.bg.ru_443
  0x182b27a7, 0x0d091302, 0x05110aa0, 0x0612200c,   // gd.vi.ga_532 bh.hi.ne_222  pt.ro.fr_322 sq.hu.de_543
  // [1410]
  0x09005308, 0x55283b04, 0x3f000309, 0x2500040d,   // ht.pl.un_430 so.sw.rw_332  nl.af.un_440 fi.eu.un_540
  0x0d192d0b, 0x09005309, 0x0a001812, 0x24000134,   // sk.gl.cs_542 ht.pl.un_440  ga.pt.un_640 iw.yi.un_A80
  0x110203ee, 0x20553b07, 0x0a041713, 0x1c09130b,   // nl.da.ro_422 so.rw.sq_432  sr.ru.mk_665 bh.hi.mr_542
  0x3b551307, 0x09001c0b, 0x10041709, 0x2d0d29ee,   // et.rw.so_432 mr.hi.un_520  sr.ru.be_444 sl.cs.sk_422
  // [1420]
  0x17000719, 0x10040a09, 0x553b2113, 0x20553b12,   // bg.sr.un_750 mk.ru.be_444  jw.so.rw_665 so.rw.sq_654
  0x643b310c, 0x03090708, 0x2a000719, 0x120b19ee,   // az.so.lg_543 it.pl.nl_443  it.mt.un_750 gl.es.hu_422
  0x311b3b04, 0x1100070d, 0x1b005321, 0x1206020c,   // so.tr.az_332 it.ro.un_540  ht.tr.un_860 da.de.hu_543
  0x17080aaf, 0x0d001c1b, 0x04170a55, 0x08321604,   // mk.uk.sr_655 mr.ne.un_770  mk.sr.ru_442 hr.bs.no_332
  // [1430]
  0x080211a4, 0x04081011, 0x163217ad, 0x06080255,   // ro.da.no_433 be.uk.ru_653  sr.bs.hr_643 da.no.de_442
  0x00000e03, 0x3b1b6404, 0x520d1a0d, 0x55001c0d,   // is.un.un_300 lg.tr.so_332  tl.cs.ha_554 id.rw.un_540
  0x3f001b12, 0x10000823, 0x1f002013, 0x0800111a,   // tr.af.un_640 uk.be.un_880  sq.cy.un_650 ro.uk.un_760
  0x16001007, 0x040811a4, 0x131c09ec, 0x0a1b2304,   // lt.hr.un_420 ro.uk.ru_433  hi.mr.bh_644 ca.tr.pt_332
  // [1440]
  0x04132013, 0x0a070107, 0x040105ee, 0x08200e0c,   // sq.et.fi_665 en.it.pt_432  fr.en.fi_422 is.sq.no_543
  0x17081005, 0x0a1707ec, 0x2a006434, 0x03003f02,   // be.uk.sr_333 bg.sr.mk_644  lg.mt.un_A80 af.nl.un_220
  0x1710110d, 0x29122a14, 0x1032160d, 0x131b2507,   // ro.be.sr_554 mt.hu.sl_666  hr.bs.lt_554 eu.tr.et_432
  0x04170a12, 0x110825ee, 0x29200e0c, 0x1c120e0c,   // mk.sr.ru_654 eu.no.ro_422  is.sq.sl_543 is.hu.id_543
  // [1450]
  0x1200101b, 0x1f001a08, 0x28532111, 0x13042013,   // lt.hu.un_770 tl.cy.un_430  jw.ht.sw_653 sq.fi.et_665
  0x08000a1a, 0x12292aa4, 0x31040e0c, 0x3f0301a0,   // mk.uk.un_760 mt.sl.hu_433  is.fi.az_543 en.nl.af_322
  0x052311a4, 0x2118120c, 0x081011ee, 0x01552855,   // ro.ca.fr_433 ur.ar.fa_543  ro.be.uk_422 sw.rw.en_442
  0x20000821, 0x6404250c, 0x29091faf, 0x533b4aad,   // no.sq.un_860 eu.fi.lg_543  cy.pl.sl_655 yo.so.ht_643
  // [1460]
  0x202a0908, 0x06251b13, 0x092512ec, 0x09120e07,   // pl.mt.sq_443 tr.eu.de_665  hu.eu.pl_644 is.hu.pl_432
  0x3b00121a, 0x2a1229a4, 0x122a1b0c, 0x112718ad,   // hu.so.un_760 sl.hu.mt_433  tr.mt.hu_543 ga.gd.ro_643
  0x4a216ba0, 0x1f000c13, 0x00006e37, 0x233b1308,   // ceb.jw.yo_322 sv.cy.un_650  hmn.un.un_B00 et.so.ca_443
  0x041708a4, 0x09001305, 0x2a0708a4, 0x07004a08,   // uk.sr.ru_433 bh.hi.un_330  no.it.mt_433 yo.it.un_430
  // [1470]
  0x64110f08, 0x1100521a, 0x09202aa9, 0x25000804,   // lv.ro.lg_443 ha.ro.un_760  mt.sq.pl_544 no.eu.un_320
  0x101308a0, 0x2a2012ec, 0x1c1f1eee, 0x05110807,   // no.et.lt_322 hu.sq.mt_644  ms.cy.id_422 no.ro.fr_432
  0x13030607, 0x11006e22, 0x3b231f07, 0x3125230c,   // de.nl.et_432 hmn.ro.un_870  cy.ca.so_432 ca.eu.az_543
  0x27006e18, 0x051827a9, 0x1c351e0c, 0x2102080c,   // hmn.gd.un_740 gd.ga.fr_544  ms.zu.id_543 no.da.jw_543
  // [1480]
  0x08110414, 0x231e1c08, 0x0f00101b, 0x083f6e07,   // ru.ro.uk_666 id.ms.ca_443  lt.lv.un_770 hmn.af.no_432
  0x3213230c, 0x0708040c, 0x00006b01, 0x3216170c,   // ca.et.bs_543 ru.uk.bg_543  ceb.un.un_200 sr.hr.bs_543
  0x09211f04, 0x0527180d, 0x230b08a0, 0x19233b08,   // cy.jw.pl_332 ga.gd.fr_554  no.es.ca_322 so.ca.gl_443
  0x06000c07, 0x081704a4, 0x55004a04, 0x35006e04,   // sv.de.un_420 ru.sr.uk_433  yo.rw.un_320 hmn.zu.un_320
  // [1490]
  0x1f000c19, 0x321629ec, 0x170a12a4, 0x0b002704,   // sv.cy.un_750 sl.hr.bs_644  hu.pt.sr_433 gd.es.un_320
  0x0a5329ee, 0x09002104, 0x06130314, 0x1f213b11,   // sl.ht.pt_422 jw.pl.un_320  nl.et.de_666 so.jw.cy_653
  0x3b002304, 0x1300092c, 0x6823130c, 0x113507ec,   // ca.so.un_320 hi.bh.un_990  et.ca.ig_543 it.zu.ro_644
  0x0e3f1a07, 0x03063f07, 0x28001013, 0x4a2025a7,   // tl.af.is_432 af.de.nl_432  lt.sw.un_650 eu.sq.yo_532
  // [14a0]
  0x00001206, 0x0c126ba0, 0x0c000214, 0x23553ba4,   // ur.un.un_400 ceb.hu.sv_322  da.sv.un_660 so.rw.ca_433
  0x64100f0c, 0x20003519, 0x2b000c04, 0x1c090dad,   // lv.lt.lg_543 zu.sq.un_750  sv.vi.un_320 ne.hi.mr_643
  0x1200180c, 0x32001104, 0x28352113, 0x06033fa7,   // ga.hu.un_530 ro.bs.un_320  jw.zu.sw_665 af.nl.de_532
  0x230a1ea0, 0x070f1ea0, 0x1c351e11, 0x0a10110c,   // ms.pt.ca_322 ms.lv.it_322  ms.zu.id_653 ro.be.mk_543
  // [14b0]
  0x313f0307, 0x1f001902, 0x070a0405, 0x230b2107,   // nl.af.az_432 gl.cy.un_220  ru.mk.bg_333 jw.es.ca_432
  0x3b211e04, 0x2d0d12af, 0x0c024aad, 0x0a170708,   // ms.jw.so_332 hu.cs.sk_655  yo.da.sv_643 bg.sr.mk_443
  0x170708a4, 0x0e082a12, 0x03023f08, 0x11200212,   // uk.bg.sr_433 mt.no.is_654  af.da.nl_443 da.sq.ro_654
  0x17041004, 0x29002a04, 0x553564a0, 0x1e351c07,   // be.ru.sr_332 mt.sl.un_320  lg.zu.rw_322 id.zu.ms_432
  // [14c0]
  0x093b0da4, 0x0a3f03a4, 0x3f060a09, 0x03040608,   // cs.so.pl_433 nl.af.pt_433  pt.de.af_444 de.fi.nl_443
  0x040807a9, 0x04132012, 0x35286407, 0x0400130d,   // bg.uk.ru_544 sq.et.fi_654  lg.sw.zu_432 et.fi.un_540
  0x53020b05, 0x32006419, 0x20080c08, 0x293208a4,   // es.da.ht_333 lg.bs.un_750  sv.no.sq_443 no.bs.sl_433
  0x033f270c, 0x045331ee, 0x3200160d, 0x06000305,   // gd.af.nl_543 az.ht.fi_422  hr.bs.un_540 nl.de.un_330
  // [14d0]
  0x3f040308, 0x08033faf, 0x0308200c, 0x1f190bad,   // nl.fi.af_443 af.nl.no_655  sq.no.nl_543 es.gl.cy_643
  0x06286405, 0x1c000d14, 0x080417a4, 0x550464a9,   // lg.sw.de_333 ne.mr.un_660  sr.ru.uk_433 lg.fi.rw_544
  0x20000b19, 0x1e1c64a0, 0x2a001704, 0x0f081011,   // es.sq.un_750 lg.id.ms_322  sr.mt.un_320 lt.no.lv_653
  0x2d0d3b14, 0x1106190d, 0x016e0cad, 0x0d000919,   // so.cs.sk_666 gl.de.ro_554  sv.hmn.en_643 hi.ne.un_750
  // [14e0]
  0x08002a0c, 0x18000521, 0x521c21a4, 0x0900010d,   // mt.no.un_530 fr.ga.un_860  jw.id.ha_433 en.pl.un_540
  0x291e1c05, 0x211e1cec, 0x123525a4, 0x0b2307ad,   // id.ms.sl_333 id.ms.jw_644  eu.zu.hu_433 it.ca.es_643
  0x0e0c3f04, 0x29200908, 0x092010ac, 0x5300021a,   // af.sv.is_332 pl.sq.sl_443  lt.sq.pl_632 da.ht.un_760
  0x211e1c60, 0x07001114, 0x35006412, 0x1000040d,   // id.ms.jw_664 ro.it.un_660  lg.zu.un_640 fi.lt.un_540
  // [14f0]
  0x172d0d08, 0x08002919, 0x2700180d, 0x032008a0,   // cs.sk.sr_443 sl.no.un_750  ga.gd.un_540 no.sq.nl_322
  0x2b001119, 0x18273fa4, 0x170a11ee, 0x043509a4,   // ro.vi.un_750 af.gd.ga_433  ro.mk.sr_422 pl.zu.fi_433
  0x28100f05, 0x03063f09, 0x08200309, 0x06003f08,   // lv.lt.sw_333 af.de.nl_444  nl.sq.no_444 af.de.un_430
  0x1c130955, 0x2920030c, 0x1b1168a7, 0x1c001e22,   // hi.bh.mr_442 nl.sq.sl_543  ig.ro.tr_532 ms.id.un_870
  // [1500]
  0x06000a04, 0x08171005, 0x00002903, 0x1f006b04,   // pt.de.un_320 be.sr.uk_333  sl.un.un_300 ceb.cy.un_320
  0x11070509, 0x07040a05, 0x08070a09, 0x07080a13,   // fr.it.ro_444 mk.ru.bg_333  mk.bg.uk_444 mk.uk.bg_665
  0x040a0712, 0x17040804, 0x3555310c, 0x00000b2d,   // bg.mk.ru_654 uk.ru.sr_332  az.rw.zu_543 bn.un.un_A00
  0x551805a4, 0x01000c13, 0x1c00130c, 0x2800550c,   // fr.ga.rw_433 sv.en.un_650  bh.mr.un_530 rw.sw.un_530
  // [1510]
  0x0a111708, 0x0a081109, 0x0506110b, 0x0d091309,   // sr.ro.mk_443 ro.uk.mk_444  ro.de.fr_542 bh.hi.ne_444
  0x1e1c4a09, 0x0800170e, 0x09000d0c, 0x2d000d0c,   // yo.id.ms_444 sr.uk.un_550  cs.pl.un_530 cs.sk.un_530
  0x0d09130b, 0x170811ee, 0x08070aa0, 0x0a170705,   // bh.hi.ne_542 ro.uk.sr_422  mk.bg.uk_322 bg.sr.mk_333
  0x08110704, 0x1b6431a0, 0x01006b07, 0x09000c0d,   // bg.ro.uk_332 az.lg.tr_322  ceb.en.un_420 sv.pl.un_540
  // [1520]
  0x0b000a09, 0x1c1309a9, 0x12001f1a, 0x2700182c,   // pt.es.un_440 hi.bh.mr_544  cy.hu.un_760 ga.gd.un_990
  0x1f136ea0, 0x10081108, 0x0d2d01a7, 0x3f03010c,   // hmn.et.cy_322 ro.uk.be_443  en.sk.cs_532 en.nl.af_543
  0x55645311, 0x0600121a, 0x080a1709, 0x1b3152ad,   // ht.lg.rw_653 hu.de.un_760  sr.mk.uk_444 ha.az.tr_643
  0x00000d01, 0x53521aee, 0x231901a4, 0x18002729,   // ne.un.un_200 tl.ha.ht_422  en.gl.ca_433 gd.ga.un_960
  // [1530]
  0x1e0c1cee, 0x035206a4, 0x01000505, 0x3f032aa9,   // id.sv.ms_422 de.ha.nl_433  fr.en.un_330 mt.nl.af_544
  0x05121155, 0x1f065307, 0x05182711, 0x17110a08,   // ro.hu.fr_442 ht.de.cy_432  gd.ga.fr_653 mk.ro.sr_443
  0x063f2a04, 0x080411a7, 0x2a000a08, 0x2353010c,   // mt.af.de_332 ro.ru.uk_532  pt.mt.un_430 en.ht.ca_543
  0x04003b1b, 0x070a0409, 0x20321bee, 0x06030b02,   // so.fi.un_770 ru.mk.bg_444  tr.bs.sq_422 es.nl.de_222
  // [1540]
  0x3f082a07, 0x040817a4, 0x0c001c07, 0x29033f0c,   // mt.no.af_432 sr.uk.ru_433  id.sv.un_420 af.nl.sl_543
  0x01215302, 0x2b000b02, 0x0e000622, 0x3f211011,   // ht.jw.en_222 es.vi.un_220  de.is.un_870 lt.jw.af_653
  0x25685507, 0x06216ea0, 0x08132aa0, 0x090d130c,   // rw.ig.eu_432 hmn.jw.de_322  mt.et.no_322 bh.ne.hi_543
  0x1800272c, 0x2d0c02a9, 0x0b005507, 0x070417a0,   // gd.ga.un_990 da.sv.sk_544  rw.es.un_420 sr.ru.bg_322
  // [1550]
  0x021e64ad, 0x091c1313, 0x1f1e64a7, 0x1f000419,   // lg.ms.da_643 bh.mr.hi_665  lg.ms.cy_532 fi.cy.un_750
  0x0c022a04, 0x1e1c64ee, 0x351c31a0, 0x110901a4,   // mt.da.sv_332 lg.id.ms_422  az.id.zu_322 en.pl.ro_433
  0x10002a13, 0x031e1fec, 0x190a1aa9, 0x080264af,   // mt.lt.un_650 cy.ms.nl_644  tl.pt.gl_544 lg.da.no_655
  0x08001f19, 0x6e3f1ea4, 0x210a1e07, 0x08001c04,   // cy.no.un_750 ms.af.hmn_433  ms.pt.jw_432 id.no.un_320
  // [1560]
  0x321004a9, 0x3f6e2012, 0x07080460, 0x190b6e60,   // fi.lt.bs_544 sq.hmn.af_654  ru.uk.bg_664 hmn.es.gl_664
  0x29006422, 0x083b1f07, 0x640e1308, 0x05000802,   // lg.sl.un_870 cy.so.no_432  et.is.lg_443 no.fr.un_220
  0x03062007, 0x10001b2a, 0x3f036eac, 0x19000a23,   // sq.de.nl_432 tr.lt.un_970  hmn.nl.af_632 pt.gl.un_880
  0x351f6407, 0x11042505, 0x13000413, 0x01000705,   // lg.cy.zu_432 eu.fi.ro_333  fi.et.un_650 it.en.un_330
  // [1570]
  0x0407105a, 0x0b190a0d, 0x13043b12, 0x04091013,   // be.bg.ru_553 pt.gl.es_554  so.fi.et_654 lt.pl.fi_665
  0x4a0e2307, 0x1c072102, 0x036e3fa9, 0x17070a07,   // ca.is.yo_432 jw.it.id_222  af.hmn.nl_544 mk.bg.sr_432
  0x31006e0c, 0x06353ba4, 0x23190b04, 0x08041702,   // hmn.az.un_530 so.zu.de_433  es.gl.ca_332 sr.ru.uk_222
  0x171632a7, 0x1c3168a7, 0x0b000723, 0x216b0660,   // bs.hr.sr_532 ig.az.id_532  it.es.un_880 de.ceb.jw_664
  // [1580]
  0x08025205, 0x18002708, 0x0200640e, 0x10000609,   // ha.da.no_333 gd.ga.un_430  lg.da.un_550 de.lt.un_440
  0x071108a4, 0x6e003f11, 0x053f0d0c, 0x25080c08,   // uk.ro.bg_433 af.hmn.un_630  cs.af.fr_543 sv.no.eu_443
  0x21006412, 0x102305ec, 0x1b1e1ca9, 0x06092104,   // lg.jw.un_640 fr.ca.lt_644  id.ms.tr_544 jw.pl.de_332
  0x20091ba0, 0x29190b5a, 0x100f6eec, 0x4a1219ec,   // tr.pl.sq_322 es.gl.sl_553  hmn.lv.lt_644 gl.hu.yo_644
  // [1590]
  0x2a002507, 0x03063fa9, 0x2b172102, 0x0a070809,   // eu.mt.un_420 af.de.nl_544  jw.sr.vi_222 uk.bg.mk_444
  0x17040812, 0x0c311b08, 0x1f12100d, 0x070a1007,   // uk.ru.sr_654 tr.az.sv_443  lt.hu.cy_554 be.mk.bg_432
  0x35001107, 0x1b1e1c0d, 0x09001321, 0x2923190c,   // ro.zu.un_420 id.ms.tr_554  bh.hi.un_860 gl.ca.sl_543
  0x072311ee, 0x2300250d, 0x27281a0c, 0x071704a4,   // ro.ca.it_422 eu.ca.un_540  tl.sw.gd_543 ru.sr.bg_433
  // [15a0]
  0x23190b02, 0x0704080e, 0x232b1807, 0x1c106404,   // es.gl.ca_222 uk.ru.bg_555  ga.vi.ca_432 lg.lt.id_332
  0x04000707, 0x2d021112, 0x04000713, 0x0d0913ad,   // bg.ru.un_420 ro.da.sk_654  bg.ru.un_650 bh.hi.ne_643
  0x18002120, 0x21001812, 0x06031fee, 0x09005302,   // fa.ar.un_850 ar.fa.un_640  cy.nl.de_422 ht.pl.un_220
  0x17041105, 0x231901a0, 0x1b321705, 0x0f003f02,   // ro.ru.sr_333 en.gl.ca_322  sr.bs.tr_333 af.lv.un_220
  // [15b0]
  0x112801ee, 0x04081104, 0x1c130904, 0x53016ba0,   // en.sw.ro_422 ro.uk.ru_332  hi.bh.mr_332 ceb.en.ht_322
  0x311828ee, 0x080704af, 0x1a000212, 0x080a1704,   // sw.ga.az_422 ru.bg.uk_655  da.tl.un_640 sr.mk.uk_332
  0x1b4a04ee, 0x100a04af, 0x04004a0c, 0x270b6e04,   // fi.yo.tr_422 ru.mk.be_655  yo.fi.un_530 hmn.es.gd_332
  0x0d130908, 0x211e1c5a, 0x070408a0, 0x0a170405,   // hi.bh.ne_443 id.ms.jw_553  uk.ru.bg_322 ru.sr.mk_333
  // [15c0]
  0x0c040ba7, 0x0b000104, 0x070403af, 0x23353f13,   // es.fi.sv_532 en.es.un_320  nl.fi.it_655 af.zu.ca_665
  0x21000905, 0x0a2007a0, 0x35002514, 0x25190bee,   // pl.jw.un_330 it.sq.pt_322  eu.zu.un_660 es.gl.eu_422
  0x12000419, 0x033f5304, 0x20000323, 0x102d0f14,   // fi.hu.un_750 ht.af.nl_332  nl.sq.un_880 lv.sk.lt_666
  0x356b6404, 0x011105a0, 0x0602080c, 0x640a2aa4,   // lg.ceb.zu_332 fr.ro.en_322  no.da.de_543 mt.pt.lg_433
  // [15d0]
  0x6b001a05, 0x04170a08, 0x040a110c, 0x08006b07,   // tl.ceb.un_330 mk.sr.ru_443  ro.mk.ru_543 ceb.no.un_420
  0x21001a07, 0x1f21640c, 0x25005214, 0x1a002104,   // tl.jw.un_420 lg.jw.cy_543  ha.eu.un_660 jw.tl.un_320
  0x00002d06, 0x2a321604, 0x08100409, 0x1732160d,   // sk.un.un_400 hr.bs.mt_332  ru.be.uk_444 hr.bs.sr_554
  0x32311b60, 0x0900040c, 0x0b532502, 0x201101a4,   // tr.az.bs_664 fi.pl.un_530  eu.ht.es_222 en.ro.sq_433
  // [15e0]
  0x0a070409, 0x11321608, 0x520605a7, 0x04081060,   // ru.bg.mk_444 hr.bs.ro_443  fr.de.ha_532 be.uk.ru_664
  0x1200212b, 0x11321704, 0x1a000b04, 0x531b6b05,   // fa.ur.un_980 sr.bs.ro_332  es.tl.un_320 ceb.tr.ht_333
  0x3b001e08, 0x110231ee, 0x35073207, 0x53094a08,   // ms.so.un_430 az.da.ro_422  bs.it.zu_432 yo.pl.ht_443
  0x0600041a, 0x121b13a7, 0x1e1c25ec, 0x3f040e14,   // fi.de.un_760 et.tr.hu_532  eu.id.ms_644 is.fi.af_666
  // [15f0]
  0x2511130c, 0x2504135a, 0x29162da4, 0x4a640713,   // et.ro.eu_543 et.fi.eu_553  sk.hr.sl_433 it.lg.yo_665
  0x080c5204, 0x03321614, 0x2a00020d, 0x1704080b,   // ha.sv.no_332 hr.bs.nl_666  da.mt.un_540 uk.ru.sr_542
  0x0e080213, 0x12080260, 0x6b211a0c, 0x1c0d1309,   // da.no.is_665 da.no.hu_664  tl.jw.ceb_543 bh.ne.mr_444
  0x11080408, 0x170a0760, 0x07000a05, 0x10040704,   // ru.uk.ro_443 bg.mk.sr_664  mk.bg.un_330 bg.ru.be_332
  // [1600]
  0x1c001e08, 0x32001714, 0x0c000d08, 0x231101a4,   // ms.id.un_430 sr.bs.un_660  cs.sv.un_430 en.ro.ca_433
  0x0764250c, 0x1b252802, 0x0c005214, 0x32291609,   // eu.lg.it_543 sw.eu.tr_222  ha.sv.un_660 hr.sl.bs_444
  0x040f10af, 0x1f5301a4, 0x19000b23, 0x082523a4,   // lt.lv.fi_655 en.ht.cy_433  es.gl.un_880 ca.eu.no_433
  0x19000108, 0x09122509, 0x07081107, 0x17000419,   // en.gl.un_430 eu.hu.pl_444  ro.uk.bg_432 ru.sr.un_750
  // [1610]
  0x3f0802a7, 0x13002508, 0x07170408, 0x3b00190c,   // da.no.af_532 eu.et.un_430  ru.sr.bg_443 gl.so.un_530
  0x06000c0d, 0x0a11010c, 0x09250e55, 0x0a0417a0,   // sv.de.un_540 en.ro.pt_543  is.eu.pl_442 sr.ru.mk_322
  0x1c1e2d07, 0x10000408, 0x04081002, 0x19000b2c,   // sk.ms.id_432 ru.be.un_430  be.uk.ru_222 es.gl.un_990
  0x3525680e, 0x3b2d0d55, 0x03002313, 0x230a25a9,   // ig.eu.zu_555 cs.sk.so_442  ca.nl.un_650 eu.pt.ca_544
  // [1620]
  0x32000d07, 0x0a23075a, 0x120d03a4, 0x203503a7,   // cs.bs.un_420 it.ca.pt_553  nl.cs.hu_433 nl.zu.sq_532
  0x081017ad, 0x1211070e, 0x0d3135ad, 0x27000507,   // sr.be.uk_643 it.ro.hu_555  zu.az.cs_643 fr.gd.un_420
  0x07041708, 0x6b001a21, 0x0a001c02, 0x2b000702,   // sr.ru.bg_443 tl.ceb.un_860  id.pt.un_220 it.vi.un_220
  0x03062508, 0x21011302, 0x2b006b2a, 0x06030a09,   // eu.de.nl_443 et.en.jw_222  ceb.vi.un_970 pt.nl.de_444
  // [1630]
  0x07040aa4, 0x0a0804a4, 0x0e531b0c, 0x1c2055a4,   // mk.ru.bg_433 ru.uk.mk_433  tr.ht.is_543 rw.sq.id_433
  0x04001719, 0x1a006b36, 0x061b0312, 0x10042011,   // sr.ru.un_750 ceb.tl.un_AA0  nl.tr.de_654 sq.fi.lt_653
  0x0a070ba0, 0x04003204, 0x20281305, 0x1e2b1ca0,   // es.it.pt_322 bs.fi.un_320  et.sw.sq_333 id.vi.ms_322
  0x0d162d07, 0x1e313b05, 0x110a070c, 0x10040713,   // sk.hr.cs_432 so.az.ms_333  bg.mk.ro_543 bg.ru.be_665
  // [1640]
  0x2d0d290c, 0x1000042b, 0x3b311fa9, 0x2a3b07a4,   // sl.cs.sk_543 ru.be.un_980  cy.az.so_544 it.so.mt_433
  0x011321a9, 0x0300010c, 0x08163ba0, 0x06000c09,   // jw.et.en_544 en.nl.un_530  so.hr.no_322 sv.de.un_440
  0x13100f5a, 0x073b1307, 0x0600130e, 0x0a001222,   // lv.lt.et_553 et.so.it_432  et.de.un_550 hu.pt.un_870
  0x17080a04, 0x03003513, 0x2d5509ee, 0x17070a0d,   // mk.uk.sr_332 zu.nl.un_650  pl.rw.sk_422 mk.bg.sr_554
  // [1650]
  0x12211860, 0x21000c07, 0x080a1007, 0x0602010c,   // ar.fa.ur_664 sv.jw.un_420  be.mk.uk_432 en.da.de_543
  0x0d040c0c, 0x0f000608, 0x130b2aee, 0x27033fac,   // sv.fi.cs_543 de.lv.un_430  mt.es.et_422 af.nl.gd_632
  0x06171605, 0x1f311b0b, 0x2b001a09, 0x2a0d20ad,   // hr.sr.de_333 tr.az.cy_542  tl.vi.un_440 sq.cs.mt_643
  0x25645508, 0x07040814, 0x0f000709, 0x19250b07,   // rw.lg.eu_443 uk.ru.bg_666  it.lv.un_440 es.eu.gl_432
  // [1660]
  0x0d000918, 0x3100080d, 0x0a00101a, 0x10040813,   // hi.ne.un_740 no.az.un_540  be.mk.un_760 uk.ru.be_665
  0x1c000d1a, 0x31001a07, 0x01171602, 0x2a001705,   // ne.mr.un_760 tl.az.un_420  hr.sr.en_222 sr.mt.un_330
  0x0d5525a4, 0x313b2a0c, 0x28556405, 0x3b2303a0,   // eu.rw.cs_433 mt.so.az_543  lg.rw.sw_333 nl.ca.so_322
  0x2a00180c, 0x132d0d0d, 0x3f2821a4, 0x3f121fa0,   // ga.mt.un_530 cs.sk.et_554  jw.sw.af_433 cy.hu.af_322
  // [1670]
  0x00001f03, 0x210c1708, 0x251101a4, 0x11080405,   // cy.un.un_300 sr.sv.jw_443  en.ro.eu_433 ru.uk.ro_333
  0x00002037, 0x03005202, 0x0710040d, 0x04000a08,   // sq.un.un_B00 ha.nl.un_220  ru.be.bg_554 mk.ru.un_430
  0x070901a7, 0x1325050c, 0x101c2108, 0x110810a4,   // en.pl.it_532 fr.eu.et_543  jw.id.lt_443 be.uk.ro_433
  0x6b2a01a4, 0x52032d0d, 0x1b0812af, 0x10060fad,   // en.mt.ceb_433 sk.nl.ha_554  hu.no.tr_655 lv.de.lt_643
  // [1680]
  0x030412ad, 0x1b12250c, 0x080203a9, 0x202d290c,   // hu.fi.nl_643 eu.hu.tr_543  nl.da.no_544 sl.sk.sq_543
  0x292d0d5a, 0x100f0713, 0x532a2107, 0x11040860,   // cs.sk.sl_553 it.lv.lt_665  jw.mt.ht_432 uk.ru.ro_664
  0x1712010c, 0x120f2907, 0x04081712, 0x04110813,   // en.hu.sr_543 sl.lv.hu_432  sr.uk.ru_654 uk.ro.ru_665
  0x172a10a4, 0x3f100309, 0x02002902, 0x0a0501a9,   // lt.mt.sr_433 nl.lt.af_444  sl.da.un_220 en.fr.pt_544
  // [1690]
  0x13000608, 0x1b001021, 0x2d0d1fee, 0x2a000f1a,   // de.et.un_430 lt.tr.un_860  cy.cs.sk_422 lv.mt.un_760
  0x04033f55, 0x3f000318, 0x20000313, 0x040a170c,   // af.nl.fi_442 nl.af.un_740  nl.sq.un_650 sr.mk.ru_543
  0x4a001a02, 0x3f00030d, 0x0103070c, 0x32002a09,   // tl.yo.un_220 nl.af.un_540  it.nl.en_543 mt.bs.un_440
  0x1803270d, 0x251b3112, 0x10090f12, 0x12001304,   // gd.nl.ga_554 az.tr.eu_654  lv.pl.lt_654 et.hu.un_320
  // [16a0]
  0x06005208, 0x03063faf, 0x25041012, 0x21531e07,   // ha.de.un_430 af.de.nl_655  lt.fi.eu_654 ms.ht.jw_432
  0x11103baf, 0x1200181a, 0x0f292a60, 0x00001e24,   // so.lt.ro_655 ar.ur.un_760  mt.sl.lv_664 ms.un.un_900
  0x032718af, 0x032513a4, 0x0d092d55, 0x3f23030c,   // ga.gd.nl_655 et.eu.nl_433  sk.pl.cs_442 nl.ca.af_543
  0x250c08af, 0x25001221, 0x1e005209, 0x6b081aec,   // no.sv.eu_655 hu.eu.un_860  ha.ms.un_440 tl.no.ceb_644
  // [16b0]
  0x18276ba4, 0x684a53a4, 0x2a001c08, 0x53001f07,   // ceb.gd.ga_433 ht.yo.ig_433  id.mt.un_430 cy.ht.un_420
  0x0b193ba7, 0x0f001014, 0x1e211cac, 0x061125a7,   // so.gl.es_532 lt.lv.un_660  id.jw.ms_632 eu.ro.de_532
  0x292a0f13, 0x1253250c, 0x070a04a4, 0x3b002a1a,   // lv.mt.sl_665 eu.ht.hu_543  ru.mk.bg_433 mt.so.un_760
  0x0400291a, 0x52681ca4, 0x0710040c, 0x19052012,   // sl.fi.un_760 id.ig.ha_433  ru.be.bg_543 sq.fr.gl_654
  // [16c0]
  0x071827ad, 0x290e2aa9, 0x521f2aad, 0x3b531a13,   // gd.ga.it_643 mt.is.sl_544  mt.cy.ha_643 tl.ht.so_665
  0x13292a09, 0x05012304, 0x290f2a12, 0x0a1711ec,   // mt.sl.et_444 ca.en.fr_332  mt.lv.sl_654 ro.sr.mk_644
  0x292117a0, 0x17002508, 0x291721a4, 0x190a23a9,   // sr.jw.sl_322 eu.sr.un_430  jw.sr.sl_433 ca.pt.gl_544
  0x11000a12, 0x130910a4, 0x53002109, 0x070a1712,   // pt.ro.un_640 lt.pl.et_433  jw.ht.un_440 sr.mk.bg_654
  // [16d0]
  0x2a211755, 0x210d200d, 0x04130ca9, 0x033f28af,   // sr.jw.mt_442 sq.cs.jw_554  sv.et.fi_544 sw.af.nl_655
  0x0a0717a9, 0x101e1c08, 0x211e5202, 0x02310804,   // sr.bg.mk_544 id.ms.lt_443  ha.ms.jw_222 no.az.da_332
  0x2900250c, 0x0a071709, 0x25001022, 0x04000a22,   // eu.sl.un_530 sr.bg.mk_444  lt.eu.un_870 mk.ru.un_870
  0x23000a04, 0x10070aa0, 0x07041060, 0x080a04a4,   // pt.ca.un_320 mk.bg.be_322  be.ru.bg_664 ru.mk.uk_433
  // [16e0]
  0x101c1105, 0x10130404, 0x2a53010c, 0x35321602,   // ro.id.lt_333 fi.et.lt_332  en.ht.mt_543 hr.bs.zu_222
  0x07180407, 0x1c005319, 0x19350ba7, 0x0300211b,   // fi.ga.it_432 ht.id.un_750  es.zu.gl_532 jw.nl.un_770
  0x11211c07, 0x04131ba4, 0x3b005208, 0x2000110c,   // id.jw.ro_432 tr.et.fi_433  ha.so.un_430 ro.sq.un_530
  0x6b000913, 0x16202da0, 0x0306250d, 0x13681b09,   // pl.ceb.un_650 sk.sq.hr_322  eu.de.nl_554 tr.ig.et_444
  // [16f0]
  0x05000a04, 0x201b350b, 0x29001604, 0x23190ba0,   // pt.fr.un_320 zu.tr.sq_542  hr.sl.un_320 es.gl.ca_322
  0x1b003f21, 0x07641b08, 0x03120f12, 0x6e6b010c,   // af.tr.un_860 tr.lg.it_443  lv.hu.nl_654 en.ceb.hmn_543
  0x1c521e08, 0x4a111255, 0x3f031b0e, 0x6b001a13,   // ms.ha.id_443 hu.ro.yo_442  tr.nl.af_555 tl.ceb.un_650
  0x0a071004, 0x123b13ad, 0x10000423, 0x062827ad,   // be.bg.mk_332 et.so.hu_643  ru.be.un_880 gd.sw.de_643
  // [1700]
  0x06001f23, 0x01253f08, 0x1f230509, 0x641b5508,   // cy.de.un_880 af.eu.en_443  fr.ca.cy_444 rw.tr.lg_443
  0x0a3b19ee, 0x06001c04, 0x050601a4, 0x0600272b,   // gl.so.pt_422 id.de.un_320  en.de.fr_433 gd.de.un_980
  0x211b1cee, 0x10213507, 0x0e000d14, 0x0e2d0d05,   // id.tr.jw_422 zu.jw.lt_432  cs.is.un_660 cs.sk.is_333
  0x1c0d090e, 0x0f002702, 0x170903a4, 0x2a2032ee,   // hi.ne.mr_555 gd.lv.un_220  nl.pl.sr_433 bs.sq.mt_422
  // [1710]
  0x642006af, 0x04132507, 0x07201b0b, 0x5220040c,   // de.sq.lg_655 eu.et.fi_432  tr.sq.it_542 fi.sq.ha_543
  0x1300550d, 0x040711ee, 0x050723a4, 0x0900110c,   // rw.et.un_540 ro.bg.ru_422  ca.it.fr_433 ro.pl.un_530
  0x683f030c, 0x1b520409, 0x3f000620, 0x102b1107,   // nl.af.ig_543 fi.ha.tr_444  de.af.un_850 ro.vi.lt_432
  0x04000804, 0x0a00060d, 0x520e0409, 0x1b004a1b,   // no.fi.un_320 de.pt.un_540  fi.is.ha_444 yo.tr.un_770
  // [1720]
  0x64211ca7, 0x35002914, 0x080c06a4, 0x130435a4,   // id.jw.lg_532 sl.zu.un_660  de.sv.no_433 zu.fi.et_433
  0x211c68af, 0x19040705, 0x19000b0b, 0x0b001904,   // ig.id.jw_655 it.fi.gl_333  es.gl.un_520 gl.es.un_320
  0x55071b0c, 0x1c000204, 0x110b6e04, 0x092d0d05,   // tr.it.rw_543 da.id.un_320  hmn.es.ro_332 cs.sk.pl_333
  0x0b231911, 0x550f1ba4, 0x2b002821, 0x233b010c,   // gl.ca.es_653 tr.lv.rw_433  sw.vi.un_860 en.so.ca_543
  // [1730]
  0x120428ee, 0x270c010c, 0x52282b0b, 0x0d0506ad,   // sw.fi.hu_422 en.sv.gd_543  vi.sw.ha_542 de.fr.cs_643
  0x17292d12, 0x11000a0e, 0x0300062b, 0x2b280a60,   // sk.sl.sr_654 pt.ro.un_550  de.nl.un_980 pt.sw.vi_664
  0x12002504, 0x08311b0d, 0x0118060b, 0x020618ec,   // eu.hu.un_320 tr.az.no_554  de.ga.en_542 ga.de.da_644
  0x1b003105, 0x0000160f, 0x3b00230d, 0x31556413,   // az.tr.un_330 hr.un.un_600  ca.so.un_540 lg.rw.az_665
  // [1740]
  0x061f5255, 0x20006804, 0x2a3b04a4, 0x04000c07,   // ha.cy.de_442 ig.sq.un_320  fi.so.mt_433 sv.fi.un_420
  0x03003f34, 0x316b1a08, 0x1b0401a4, 0x2331520c,   // af.nl.un_A80 tl.ceb.az_443  en.fi.tr_433 ha.az.ca_543
  0x1b0c2aa4, 0x13200414, 0x040710a0, 0x31000522,   // mt.sv.tr_433 fi.sq.et_666  be.bg.ru_322 fr.az.un_870
  0x0b3b2d07, 0x1a6b0808, 0x25096b07, 0x0811040c,   // sk.so.es_432 no.ceb.tl_443  ceb.pl.eu_432 ru.ro.uk_543
  // [1750]
  0x030608a7, 0x3f0c230c, 0x10002914, 0x12002304,   // no.de.nl_532 ca.sv.af_543  sl.lt.un_660 ca.hu.un_320
  0x281e2a09, 0x03040807, 0x1e282912, 0x0200031b,   // mt.ms.sw_444 no.fi.nl_432  sl.sw.ms_654 nl.da.un_770
  0x64000421, 0x0f006b12, 0x0a002b29, 0x29001b0d,   // fi.lg.un_860 ceb.lv.un_640  vi.pt.un_960 tr.sl.un_540
  0x3f0307a4, 0x1c090d09, 0x17041009, 0x53001608,   // it.nl.af_433 ne.hi.mr_444  be.ru.sr_444 hr.ht.un_430
  // [1760]
  0x0b0a1fec, 0x64001a02, 0x0a002b18, 0x2b001a2a,   // cy.pt.es_644 tl.lg.un_220  vi.pt.un_740 tl.vi.un_970
  0x1b313b12, 0x643f3bad, 0x060c0255, 0x2a3b09af,   // so.az.tr_654 so.af.lg_643  da.sv.de_442 pl.so.mt_655
  0x255535ad, 0x180627ec, 0x0400082c, 0x110f10a4,   // zu.rw.eu_643 gd.de.ga_644  uk.ru.un_990 lt.lv.ro_433
  0x6b3127a4, 0x2d001604, 0x08041012, 0x3f021fa4,   // gd.az.ceb_433 hr.sk.un_320  be.ru.uk_654 cy.da.af_433
  // [1770]
  0x00000601, 0x2a3b31af, 0x2300060d, 0x09080c0d,   // de.un.un_200 az.so.mt_655  de.ca.un_540 sv.no.pl_554
  0x131c09ac, 0x08041704, 0x061335ad, 0x170a11ec,   // hi.mr.bh_632 sr.ru.uk_332  zu.et.de_643 ro.mk.sr_644
  0x05010708, 0x1b313513, 0x030608a4, 0x081306a4,   // it.en.fr_443 zu.az.tr_665  no.de.nl_433 de.et.no_433
  0x6b001a0e, 0x05000621, 0x21321704, 0x040708a6,   // tl.ceb.un_550 de.fr.un_860  sr.bs.jw_332 uk.bg.ru_521
  // [1780]
  0x1a64040c, 0x3f0603af, 0x03082508, 0x25190bec,   // fi.lg.tl_543 nl.de.af_655  eu.no.nl_443 es.gl.eu_644
  0x32162914, 0x01021302, 0x13080e07, 0x13000821,   // sl.hr.bs_666 et.da.en_222  is.no.et_432 no.et.un_860
  0x02550512, 0x06000819, 0x1c2120ad, 0x04001902,   // fr.rw.da_654 no.de.un_750  sq.jw.id_643 gl.fi.un_220
  0x1b133204, 0x08060302, 0x0e00181a, 0x211e1c55,   // bs.et.tr_332 nl.de.no_222  ga.is.un_760 id.ms.jw_442
  // [1790]
  0x1b003513, 0x2900020e, 0x13170855, 0x07006404,   // zu.tr.un_650 da.sl.un_550  no.sr.et_442 lg.it.un_320
  0x08060ea0, 0x131c0907, 0x08130e12, 0x186b1a08,   // is.de.no_322 hi.mr.bh_432  is.et.no_654 tl.ceb.ga_443
  0x311b5502, 0x20000305, 0x0c00082b, 0x1a216bad,   // rw.tr.az_222 nl.sq.un_330  no.sv.un_980 ceb.jw.tl_643
  0x35000619, 0x29001708, 0x040811ec, 0x06003512,   // de.zu.un_750 sr.sl.un_430  ro.uk.ru_644 zu.de.un_640
  // [17a0]
  0x20001a07, 0x081011a6, 0x1e0e0607, 0x09000d1b,   // tl.sq.un_420 ro.be.uk_521  de.is.ms_432 ne.hi.un_770
  0x1b0f0ea0, 0x3b250e0c, 0x08130c11, 0x27161ba0,   // is.lv.tr_322 is.eu.so_543  sv.et.no_653 tr.hr.gd_322
  0x0b002d07, 0x2d0952a4, 0x16292da4, 0x13000808,   // sk.es.un_420 ha.pl.sk_433  sk.sl.hr_433 no.et.un_430
  0x2a000913, 0x23001909, 0x0400100e, 0x080201a4,   // pl.mt.un_650 gl.ca.un_440  be.ru.un_550 en.da.no_433
  // [17b0]
  0x060e1ea9, 0x1f002719, 0x10030fee, 0x0c200fa4,   // ms.is.de_544 gd.cy.un_750  lv.nl.lt_422 lv.sq.sv_433
  0x0e130405, 0x520c1f0c, 0x1801050c, 0x351a6ba7,   // fi.et.is_333 cy.sv.ha_543  fr.en.ga_543 ceb.tl.zu_532
  0x05182bad, 0x6b0a1a07, 0x1c130960, 0x530c08ad,   // vi.ga.fr_643 tl.pt.ceb_432  hi.bh.mr_664 no.sv.ht_643
  0x28005202, 0x1e2d0d0c, 0x0f111205, 0x2d0d02a9,   // ha.sw.un_220 cs.sk.ms_543  hu.ro.lv_333 da.cs.sk_544
  // [17c0]
  0x183b1307, 0x0c086411, 0x0a0f110c, 0x27181a04,   // et.so.ga_432 lg.no.sv_653  ro.lv.pt_543 tl.ga.gd_332
  0x0a3f110c, 0x07033f09, 0x20103fec, 0x07080405,   // ro.af.pt_543 af.nl.it_444  af.lt.sq_644 ru.uk.bg_333
  0x07170a05, 0x00001101, 0x27001820, 0x11080aa7,   // mk.sr.bg_333 ro.un.un_200  ga.gd.un_850 pt.no.ro_532
  0x17290fa4, 0x10123fa4, 0x030b28ad, 0x11000f08,   // lv.sl.sr_433 af.hu.lt_433  sw.es.nl_643 lv.ro.un_430
  // [17d0]
  0x0900160d, 0x021b5307, 0x27351a04, 0x10122508,   // hr.pl.un_540 ht.tr.da_432  tl.zu.gd_332 eu.hu.lt_443
  0x0804100e, 0x55002012, 0x07001104, 0x17001b0c,   // be.ru.uk_555 sq.rw.un_640  ro.it.un_320 tr.sr.un_530
  0x0a3f060c, 0x2d3b6b0c, 0x0f0a11a4, 0x0c08020c,   // de.af.pt_543 ceb.so.sk_543  ro.pt.lv_433 da.no.sv_543
  0x6b0d2dee, 0x09000313, 0x0f6b100c, 0x2d0d310e,   // sk.cs.ceb_422 nl.pl.un_650  lt.ceb.lv_543 az.cs.sk_555
  // [17e0]
  0x531b310c, 0x1b0f190d, 0x6b551a13, 0x0b0a070b,   // az.tr.ht_543 gl.lv.tr_554  tl.rw.ceb_665 it.pt.es_542
  0x063f08a0, 0x1b004a14, 0x102a4aa9, 0x080302ad,   // no.af.de_322 yo.tr.un_660  yo.mt.lt_544 da.nl.no_643
  0x180227a6, 0x03000b04, 0x6b001a19, 0x19110a5a,   // gd.da.ga_521 es.nl.un_320  tl.ceb.un_750 pt.ro.gl_553
  0x100f11a4, 0x033b64ac, 0x0e00521b, 0x1a006b2b,   // ro.lv.lt_433 lg.so.nl_632  ha.is.un_770 ceb.tl.un_980
  // [17f0]
  0x3f0352a0, 0x0c203f55, 0x2a556b11, 0x0c3b6b0d,   // ha.nl.af_322 af.sq.sv_442  ceb.rw.mt_653 ceb.so.sv_554
  0x071711a4, 0x120f11a4, 0x06016ba0, 0x071211a4,   // ro.sr.bg_433 ro.lv.hu_433  ceb.en.de_322 ro.hu.it_433
  0x1e1c0e14, 0x04070aa9, 0x20090805, 0x06001f12,   // is.id.ms_666 mk.bg.ru_544  no.pl.sq_333 cy.de.un_640
  0x02131f60, 0x6b292a04, 0x01004a05, 0x312d0d13,   // cy.et.da_664 mt.sl.ceb_332  yo.en.un_330 cs.sk.az_665

  // [1800]
  0x10072a07, 0x3b006b13, 0x213b4aee, 0x1f2d0d13,   // mt.it.lt_432 ceb.so.un_650  yo.so.jw_422 cs.sk.cy_665
  0x08230ca0, 0x08120ead, 0x0a1105ec, 0x292d0d13,   // sv.ca.no_322 is.hu.no_643  fr.ro.pt_644 cs.sk.sl_665
  0x0e080caf, 0x32002907, 0x130c0807, 0x07001107,   // sv.no.is_655 sl.bs.un_420  no.sv.et_432 ro.bg.un_420
  0x55003202, 0x0f052304, 0x2a072312, 0x071710ee,   // bs.rw.un_220 ca.fr.lv_332  ca.it.mt_654 be.sr.bg_422
  // [1810]
  0x0a1711a0, 0x55126ba7, 0x06080cee, 0x21002704,   // ro.sr.mk_322 ceb.hu.rw_532  sv.no.de_422 gd.jw.un_320
  0x08041108, 0x1c0d09a7, 0x08000c23, 0x53644aee,   // ro.ru.uk_443 hi.ne.mr_532  sv.no.un_880 yo.lg.ht_422
  0x2a190a0d, 0x08000a14, 0x352832a0, 0x08002a1b,   // pt.gl.mt_554 mk.uk.un_660  bs.sw.zu_322 mt.no.un_770
  0x070425a4, 0x07171008, 0x17000c19, 0x0a170713,   // eu.fi.it_433 be.sr.bg_443  sv.sr.un_750 bg.sr.mk_665
  // [1820]
  0x190b0a0c, 0x17040a0c, 0x1b321702, 0x1f005304,   // pt.es.gl_543 mk.ru.sr_543  sr.bs.tr_222 ht.cy.un_320
  0x6b1a0404, 0x17270e04, 0x25030607, 0x6b1a6ea9,   // fi.tl.ceb_332 is.gd.sr_332  de.nl.eu_432 hmn.tl.ceb_544
  0x526b31a4, 0x0b190a0c, 0x0c080304, 0x6e000808,   // az.ceb.ha_433 pt.gl.es_543  nl.no.sv_332 no.hmn.un_430
  0x13003b1e, 0x08040a02, 0x6e6b1a0d, 0x0c005204,   // so.et.un_830 mk.ru.uk_222  tl.ceb.hmn_554 ha.sv.un_320
  // [1830]
  0x0200121a, 0x080206ee, 0x08002012, 0x27190a0d,   // hu.da.un_760 de.da.no_422  sq.no.un_640 pt.gl.gd_554
  0x09001c19, 0x12030655, 0x12000c12, 0x3b286ead,   // mr.hi.un_750 de.nl.hu_442  sv.hu.un_640 hmn.sw.so_643
  0x2d0d01a4, 0x3f000608, 0x071104a4, 0x110208a7,   // en.cs.sk_433 de.af.un_430  ru.ro.bg_433 no.da.ro_532
  0x016e1ca0, 0x02000812, 0x1f190a13, 0x09290a08,   // id.hmn.en_322 no.da.un_640  pt.gl.cy_665 pt.sl.pl_443
  // [1840]
  0x09002918, 0x6e000314, 0x04001020, 0x12060d0c,   // sl.pl.un_740 nl.hmn.un_660  be.ru.un_850 cs.de.hu_543
  0x120e0a0b, 0x2d0d35af, 0x1106230b, 0x1c12040c,   // pt.is.hu_542 zu.cs.sk_655  ca.de.ro_542 fi.hu.id_543
  0x6e200d0c, 0x06006b04, 0x0d1c13ad, 0x06002502,   // cs.sq.hmn_543 ceb.de.un_320  bh.mr.ne_643 eu.de.un_220
  0x0d12290d, 0x27190a60, 0x0c030207, 0x0a001913,   // sl.hu.cs_554 pt.gl.gd_664  da.nl.sv_432 gl.pt.un_650
  // [1850]
  0x530501a0, 0x060a0da9, 0x032506a4, 0x6e193bad,   // en.fr.ht_322 cs.pt.de_544  de.eu.nl_433 so.gl.hmn_643
  0x063f02a4, 0x64005212, 0x1a006b35, 0x13210aad,   // da.af.de_433 ha.lg.un_640  ceb.tl.un_A90 pt.jw.et_643
  0x4a1b5205, 0x6e005308, 0x033f0c55, 0x64005208,   // ha.tr.yo_333 ht.hmn.un_430  sv.af.nl_442 ha.lg.un_430
  0x2d090daf, 0x1f3f1a60, 0x0a230d08, 0x112d0d07,   // cs.pl.sk_655 tl.af.cy_664  cs.ca.pt_443 cs.sk.ro_432
  // [1860]
  0x170a110c, 0x1f0820a6, 0x09001c18, 0x55100cee,   // ro.mk.sr_543 sq.no.cy_521  mr.hi.un_740 sv.lt.rw_422
  0x10190a5a, 0x312d0dee, 0x03001802, 0x00001806,   // pt.gl.lt_553 cs.sk.az_422  ga.nl.un_220 ga.un.un_400
  0x1a001e0d, 0x0d001c12, 0x64523513, 0x64190a5a,   // ms.tl.un_540 mr.ne.un_640  zu.ha.lg_665 pt.gl.lg_553
  0x0a000804, 0x020e0c60, 0x04171007, 0x0a0d2307,   // no.pt.un_320 sv.is.da_664  be.sr.ru_432 ca.cs.pt_432
  // [1870]
  0x18683fee, 0x0a290daf, 0x0c160d07, 0x131a3555,   // af.ig.ga_422 cs.sl.pt_655  cs.hr.sv_432 zu.tl.et_442
  0x17290da4, 0x1a642809, 0x032a0cec, 0x19006b0c,   // cs.sl.sr_433 sw.lg.tl_444  sv.mt.nl_644 ceb.gl.un_530
  0x040a0709, 0x20001705, 0x11070805, 0x29060da4,   // bg.mk.ru_444 sr.sq.un_330  uk.bg.ro_333 cs.de.sl_433
  0x64683507, 0x352564a4, 0x21181211, 0x110a0412,   // zu.ig.lg_432 lg.eu.zu_433  ur.ar.fa_653 ru.mk.ro_654
  // [1880]
  0x00001c2d, 0x19130ba7, 0x00001a24, 0x190b2309,   // mr.un.un_A00 es.et.gl_532  tl.un.un_900 ca.es.gl_444
  0x3f2528ad, 0x09131cad, 0x06005302, 0x06080209,   // sw.eu.af_643 mr.bh.hi_643  ht.de.un_220 da.no.de_444
  0x250564ec, 0x2d0d5209, 0x2d0d0fa4, 0x12190b08,   // lg.fr.eu_644 ha.cs.sk_444  lv.cs.sk_433 es.gl.hu_443
  0x11001a04, 0x292d0d02, 0x11000a0d, 0x170a0755,   // tl.ro.un_320 cs.sk.sl_222  pt.ro.un_540 bg.mk.sr_442
  // [1890]
  0x0f001a04, 0x216435af, 0x351764ad, 0x16290908,   // tl.lv.un_320 zu.lg.jw_655  lg.sr.zu_643 pl.sl.hr_443
  0x31521304, 0x17070808, 0x3500640e, 0x08002708,   // et.ha.az_332 uk.bg.sr_443  lg.zu.un_550 gd.no.un_430
  0x256468ee, 0x27112312, 0x1135640c, 0x1c2a6407,   // ig.lg.eu_422 ca.ro.gd_654  lg.zu.ro_543 lg.mt.id_432
  0x0c000604, 0x0b000504, 0x0f001013, 0x00002b01,   // de.sv.un_320 fr.es.un_320  lt.lv.un_650 vi.un.un_200
  // [18a0]
  0x07000a22, 0x0f080ca0, 0x080a170c, 0x08170aa0,   // mk.bg.un_870 sv.no.lv_322  sr.mk.uk_543 mk.sr.uk_322
  0x1c1309a4, 0x35553112, 0x160d2dee, 0x08020e02,   // hi.bh.mr_433 az.rw.zu_654  sk.cs.hr_422 is.da.no_222
  0x09006411, 0x0d001c14, 0x12180ea9, 0x0400072a,   // lg.pl.un_630 mr.ne.un_660  is.ga.hu_544 bg.ru.un_970
  0x04001a02, 0x00001103, 0x1e1c3b05, 0x2d200907,   // tl.fi.un_220 ro.un.un_300  so.id.ms_333 pl.sq.sk_432
  // [18b0]
  0x07170a0e, 0x091c0da9, 0x68004a12, 0x3b006b0c,   // mk.sr.bg_555 ne.mr.hi_544  yo.ig.un_640 ceb.so.un_530
  0x0c000907, 0x110a0fa7, 0x0e000c0d, 0x533564ec,   // pl.sv.un_420 lv.pt.ro_532  sv.is.un_540 lg.zu.ht_644
  0x1c001313, 0x2528110c, 0x04071105, 0x085523a0,   // bh.mr.un_650 ro.sw.eu_543  ro.bg.ru_333 ca.rw.no_322
  0x11252812, 0x2b001702, 0x0b2511a9, 0x190906ee,   // sw.eu.ro_654 sr.vi.un_220  ro.eu.es_544 de.pl.gl_422
  // [18c0]
  0x685301a4, 0x042513a4, 0x04001312, 0x2500281a,   // en.ht.ig_433 et.eu.fi_433  et.fi.un_640 sw.eu.un_760
  0x0d1125a9, 0x04001323, 0x171108ad, 0x04033fad,   // eu.ro.cs_544 et.fi.un_880  uk.ro.sr_643 af.nl.fi_643
  0x0b033fa0, 0x1e251107, 0x030113a9, 0x252811af,   // af.nl.es_322 ro.eu.ms_432  et.en.nl_544 ro.sw.eu_655
  0x05002d0d, 0x4a001122, 0x3f3b0308, 0x3f3b01ad,   // sk.fr.un_540 ro.yo.un_870  nl.so.af_443 en.so.af_643
  // [18d0]
  0x13006405, 0x07001702, 0x1a000120, 0x6b6811a6,   // lg.et.un_330 sr.bg.un_220  en.tl.un_850 ro.ig.ceb_521
  0x041a0e0c, 0x1b002a04, 0x3f031307, 0x031364a9,   // is.tl.fi_543 mt.tr.un_320  et.nl.af_432 lg.et.nl_544
  0x4a2529a0, 0x1b203bad, 0x016b09ad, 0x3f00032b,   // sl.eu.yo_322 so.sq.tr_643  pl.ceb.en_643 nl.af.un_980
  0x133b64a9, 0x091c2104, 0x190b07ee, 0x12102108,   // lg.so.et_544 jw.id.pl_332  it.es.gl_422 jw.lt.hu_443
  // [18e0]
  0x121821a9, 0x28250d0c, 0x350a110c, 0x55000919,   // fa.ar.ur_544 cs.eu.sw_543  ro.pt.zu_543 pl.rw.un_750
  0x530868a0, 0x2d043205, 0x1c091312, 0x04100fee,   // ig.no.ht_322 bs.fi.sk_333  bh.hi.mr_654 lv.lt.fi_422
  0x12005304, 0x35001113, 0x28251160, 0x10000914,   // ht.hu.un_320 ro.zu.un_650  ro.eu.sw_664 pl.lt.un_660
  0x25001134, 0x11080412, 0x09006402, 0x23132a0c,   // ro.eu.un_A80 ru.uk.ro_654  lg.pl.un_220 mt.et.ca_543
  // [18f0]
  0x3b000307, 0x2d000d07, 0x3f031308, 0x1923530d,   // nl.so.un_420 cs.sk.un_420  et.nl.af_443 ht.ca.gl_554
  0x29001f05, 0x131f0c08, 0x040a11a4, 0x090306ad,   // cy.sl.un_330 sv.cy.et_443  ro.mk.ru_433 de.nl.pl_643
  0x3f0364ec, 0x2d0d0912, 0x25031308, 0x2b3f0112,   // lg.nl.af_644 pl.cs.sk_654  et.nl.eu_443 en.af.vi_654
  0x3b03135a, 0x250411a4, 0x130364a9, 0x110407a9,   // et.nl.so_553 ro.fi.eu_433  lg.nl.et_544 bg.ru.ro_544
  // [1900]
  0x132d290c, 0x0c2d0d13, 0x03136412, 0x25192aa4,   // sl.sk.et_543 cs.sk.sv_665  lg.et.nl_654 mt.gl.eu_433
  0x1a1e1c5a, 0x1c000d05, 0x0c131a02, 0x12002912,   // id.ms.tl_553 ne.mr.un_330  tl.et.sv_222 sl.hu.un_640
  0x0a071008, 0x0d0a23a0, 0x681202ad, 0x09004a02,   // be.bg.mk_443 ca.pt.cs_322  da.hu.ig_643 yo.pl.un_220
  0x1800121a, 0x10001c04, 0x0c3f08ee, 0x16003204,   // ur.ar.un_760 id.lt.un_320  no.af.sv_422 bs.hr.un_320
  // [1910]
  0x03010605, 0x0d00290c, 0x043b0c04, 0x281a2904,   // de.en.nl_333 sl.cs.un_530  sv.so.fi_332 sl.tl.sw_332
  0x25000c04, 0x2d120c12, 0x01002104, 0x0700640d,   // sv.eu.un_320 sv.hu.sk_654  jw.en.un_320 lg.it.un_540
  0x00000c24, 0x2500061a, 0x050c2104, 0x55121007,   // sv.un.un_900 de.eu.un_760  jw.sv.fr_332 lt.hu.rw_432
  0x1b002912, 0x55524a07, 0x110c1607, 0x0b000705,   // sl.tr.un_640 yo.ha.rw_432  hr.sv.ro_432 it.es.un_330
  // [1920]
  0x1f003b19, 0x21001818, 0x131e1c55, 0x2a001307,   // so.cy.un_750 ar.fa.un_740  id.ms.et_442 et.mt.un_420
  0x16122907, 0x17200dee, 0x4a122d12, 0x0a000722,   // sl.hu.hr_432 cs.sq.sr_422  sk.hu.yo_654 bg.mk.un_870
  0x07000409, 0x25002713, 0x6e2301ad, 0x182325a4,   // ru.bg.un_440 gd.eu.un_650  en.ca.hmn_643 eu.ca.ga_433
  0x32171608, 0x0725180c, 0x2a006b21, 0x02232907,   // hr.sr.bs_443 ga.eu.it_543  ceb.mt.un_860 sl.ca.da_432
  // [1930]
  0x6e190bad, 0x12004a12, 0x521323ad, 0x071806a7,   // es.gl.hmn_643 yo.hu.un_640  ca.et.ha_643 de.ga.it_532
  0x1000121a, 0x08111707, 0x3b280304, 0x182725af,   // hu.lt.un_760 sr.ro.uk_432  nl.sw.so_332 eu.gd.ga_655
  0x28680411, 0x04102a11, 0x07003204, 0x32051ea4,   // fi.ig.sw_653 mt.lt.fi_653  bs.it.un_320 ms.fr.bs_433
  0x05236eec, 0x3f07040c, 0x063f090c, 0x27251812,   // hmn.ca.fr_644 fi.it.af_543  pl.af.de_543 ga.eu.gd_654
  // [1940]
  0x190a06af, 0x55002d07, 0x3b686e08, 0x28046814,   // de.pt.gl_655 sk.rw.un_420  hmn.ig.so_443 ig.fi.sw_666
  0x276e5308, 0x250627a4, 0x09000f14, 0x18001114,   // ht.hmn.gd_443 gd.de.eu_433  lv.pl.un_660 ro.ga.un_660
  0x1b1a6b09, 0x03683b07, 0x0e130f0c, 0x09350807,   // ceb.tl.tr_444 so.ig.nl_432  lv.et.is_543 no.zu.pl_432
  0x04004a0d, 0x01035202, 0x1b316eec, 0x090407ee,   // yo.fi.un_540 ha.nl.en_222  hmn.az.tr_644 it.fi.pl_422
  // [1950]
  0x070a08a9, 0x3b003f21, 0x21530412, 0x3b002a0c,   // uk.mk.bg_544 af.so.un_860  fi.ht.jw_654 mt.so.un_530
  0x06090faf, 0x190a130c, 0x350e01a4, 0x07171007,   // lv.pl.de_655 et.pt.gl_543  en.is.zu_433 be.sr.bg_432
  0x21131ca0, 0x21001704, 0x12002812, 0x3f3b1104,   // id.et.jw_322 sr.jw.un_320  sw.hu.un_640 ro.so.af_332
  0x0f001108, 0x10200511, 0x080e1fa4, 0x1827250c,   // ro.lv.un_430 fr.sq.lt_653  cy.is.no_433 eu.gd.ga_543
  // [1960]
  0x2a3b6eec, 0x03020e05, 0x0113250c, 0x3f040704,   // hmn.so.mt_644 is.da.nl_333  eu.et.en_543 it.fi.af_332
  0x0600012a, 0x04190b0c, 0x271801ad, 0x110328a6,   // en.de.un_970 es.gl.fi_543  en.ga.gd_643 sw.nl.ro_521
  0x0f2a6e14, 0x07000f21, 0x01003b19, 0x35136ba7,   // hmn.mt.lv_666 lv.it.un_860  so.en.un_750 ceb.et.zu_532
  0x21001802, 0x02030607, 0x0a001704, 0x1a3f68a7,   // ar.fa.un_220 de.nl.da_432  sr.mk.un_320 ig.af.tl_532
  // [1970]
  0x6b00090d, 0x10190bec, 0x3f133b09, 0x17081002,   // pl.ceb.un_540 es.gl.lt_644  so.et.af_444 be.uk.sr_222
  0x190b2313, 0x060b04a4, 0x04076807, 0x4a190bee,   // ca.es.gl_665 fi.es.de_433  ig.it.fi_432 es.gl.yo_422
  0x1f1b0eec, 0x520e3512, 0x12006402, 0x070a17a4,   // is.tr.cy_644 zu.is.ha_654  lg.hu.un_220 sr.mk.bg_433
  0x08290c08, 0x6b1a0b0d, 0x0b002a07, 0x52120eaf,   // sv.sl.no_443 es.tl.ceb_554  mt.es.un_420 is.hu.ha_655
  // [1980]
  0x07040809, 0x03016b07, 0x1e315208, 0x08120407,   // uk.ru.bg_444 ceb.en.nl_432  ha.az.ms_443 fi.hu.no_432
  0x0a190b08, 0x3f2801a4, 0x040a1005, 0x0813040b,   // es.gl.pt_443 en.sw.af_433  be.mk.ru_333 fi.et.no_542
  0x2d00091a, 0x03003f09, 0x09001f1a, 0x0c086b09,   // pl.sk.un_760 af.nl.un_440  cy.pl.un_760 ceb.no.sv_444
  0x070817a0, 0x18002705, 0x091c130d, 0x03011f07,   // sr.uk.bg_322 gd.ga.un_330  bh.mr.hi_554 cy.en.nl_432
  // [1990]
  0x53524a07, 0x020306ad, 0x3f0b6b02, 0x1c091302,   // yo.ha.ht_432 de.nl.da_643  ceb.es.af_222 bh.hi.mr_222
  0x036b06ee, 0x18002704, 0x4a03680e, 0x191f0b0c,   // de.ceb.nl_422 gd.ga.un_320  ig.nl.yo_555 es.cy.gl_543
  0x4a006804, 0x281c1ea4, 0x2a000214, 0x03004a08,   // ig.yo.un_320 ms.id.sw_433  da.mt.un_660 yo.nl.un_430
  0x28215204, 0x68015307, 0x091c130c, 0x6400550e,   // ha.jw.sw_332 ht.en.ig_432  bh.mr.hi_543 rw.lg.un_550
  // [19a0]
  0x1c1b1e08, 0x0d292d12, 0x52286eee, 0x092d1007,   // ms.tr.id_443 sk.sl.cs_654  hmn.sw.ha_422 lt.sk.pl_432
  0x04070805, 0x07000413, 0x191f2308, 0x18000519,   // uk.bg.ru_333 fi.it.un_650  ca.cy.gl_443 fr.ga.un_750
  0x4a006814, 0x10080c04, 0x08070c09, 0x0a1107af,   // ig.yo.un_660 sv.no.lt_332  sv.it.no_444 bg.ro.mk_655
  0x09292507, 0x1e1c01a4, 0x18000a04, 0x1b0e25ad,   // eu.sl.pl_432 en.id.ms_433  pt.ga.un_320 eu.is.tr_643
  // [19b0]
  0x1a003b07, 0x1a006e1a, 0x3b00101b, 0x1227070d,   // so.tl.un_420 hmn.tl.un_760  lt.so.un_770 it.gd.hu_554
  0x2b076b07, 0x04101107, 0x00000a2d, 0x29171602,   // ceb.it.vi_432 ro.be.ru_432  pt.un.un_A00 hr.sr.sl_222
  0x04081008, 0x3b00530e, 0x190a0baf, 0x3b641f0d,   // be.uk.ru_443 ht.so.un_550  es.pt.gl_655 cy.lg.so_554
  0x13190b0c, 0x524a3b07, 0x3f1c1aa0, 0x23000719,   // es.gl.et_543 so.yo.ha_432  tl.id.af_322 it.ca.un_750
  // [19c0]
  0x0f2a3b08, 0x09531f04, 0x3b00010c, 0x050a0107,   // so.mt.lv_443 cy.ht.pl_332  en.so.un_530 en.pt.fr_432
  0x6e1f1a12, 0x0a001e05, 0x1f1807ec, 0x13003204,   // tl.cy.hmn_654 ms.pt.un_330  it.ga.cy_644 bs.et.un_320
  0x0c3510a4, 0x0c003202, 0x2d100aee, 0x182d6e02,   // lt.zu.sv_433 bs.sv.un_220  pt.lt.sk_422 hmn.sk.ga_222
  0x07052a07, 0x1b1231ec, 0x0d001704, 0x02001307,   // mt.fr.it_432 az.hu.tr_644  sr.cs.un_320 et.da.un_420
  // [19d0]
  0x1e100a07, 0x061b31af, 0x17090d07, 0x0e4a19a9,   // pt.lt.ms_432 az.tr.de_655  cs.pl.sr_432 gl.yo.is_544
  0x311b3b13, 0x1b002102, 0x18013bad, 0x35000705,   // so.tr.az_665 jw.tr.un_220  so.en.ga_643 it.zu.un_330
  0x253b1f0c, 0x040a075a, 0x2d2a0d0c, 0x12311ba4,   // cy.so.eu_543 bg.mk.ru_553  cs.mt.sk_543 tr.az.hu_433
  0x12002902, 0x071004ec, 0x6b681204, 0x3f2a07a0,   // sl.hu.un_220 ru.be.bg_644  hu.ig.ceb_332 it.mt.af_322
  // [19e0]
  0x04000d0d, 0x2d000c0c, 0x310f1ba9, 0x0a00172a,   // cs.fi.un_540 sv.sk.un_530  tr.lv.az_544 sr.mk.un_970
  0x1c1e12ad, 0x09132aa4, 0x2a1f6eec, 0x3b002a12,   // hu.ms.id_643 mt.et.pl_433  hmn.cy.mt_644 mt.so.un_640
  0x0d001c09, 0x0f180a04, 0x1800210e, 0x3b005304,   // mr.ne.un_440 pt.ga.lv_332  fa.ar.un_550 ht.so.un_320
  0x232a01a4, 0x04000c19, 0x090d13a7, 0x01533b0c,   // en.mt.ca_433 sv.fi.un_750  bh.ne.hi_532 so.ht.en_543
  // [19f0]
  0x1e1c0ea4, 0x4a255311, 0x122a53a9, 0x0a100707,   // is.id.ms_433 ht.eu.yo_653  ht.mt.hu_544 bg.be.mk_432
  0x21001223, 0x080a0414, 0x13080208, 0x11001e02,   // ur.fa.un_880 ru.mk.uk_666  da.no.et_443 ms.ro.un_220
  0x110a0714, 0x0a2301a4, 0x100711a0, 0x2000100e,   // bg.mk.ro_666 en.ca.pt_433  ro.bg.be_322 lt.sq.un_550
  0x1b123105, 0x23002508, 0x04081713, 0x041020ad,   // az.hu.tr_333 eu.ca.un_430  sr.uk.ru_665 sq.lt.fi_643
  // [1a00]
  0x21121814, 0x20321b0e, 0x07041104, 0x2b005305,   // ar.ur.fa_666 tr.bs.sq_555  ro.ru.bg_332 ht.vi.un_330
  0x03171604, 0x090d13ac, 0x05002504, 0x4a001819,   // hr.sr.nl_332 bh.ne.hi_632  eu.fr.un_320 ga.yo.un_750
  0x643555ee, 0x1b005322, 0x252a0708, 0x04101707,   // rw.zu.lg_422 ht.tr.un_870  it.mt.eu_443 sr.be.ru_432
  0x533b280b, 0x106b1aa4, 0x52002704, 0x2400012a,   // sw.so.ht_542 tl.ceb.lt_433  gd.ha.un_320 iw.yi.un_970
  // [1a10]
  0x211218ac, 0x030f0911, 0x100417a4, 0x0f002b0c,   // ar.ur.fa_632 pl.lv.nl_653  sr.ru.be_433 vi.lv.un_530
  0x00006406, 0x0f000923, 0x02000c09, 0x1b006419,   // lg.un.un_400 pl.lv.un_880  sv.da.un_440 lg.tr.un_750
  0x200f10a4, 0x17070a12, 0x10070a07, 0x08001702,   // lt.lv.sq_433 mk.bg.sr_654  mk.bg.be_432 sr.uk.un_220
  0x090d13a9, 0x09000f1a, 0x043119ee, 0x00000503,   // bh.ne.hi_544 lv.pl.un_760  gl.az.fi_422 fr.un.un_300
  // [1a20]
  0x0f000c04, 0x1f000c04, 0x0f000914, 0x0c083fa4,   // sv.lv.un_320 sv.cy.un_320  pl.lv.un_660 af.no.sv_433
  0x29000704, 0x64003b1a, 0x27001812, 0x1218210e,   // it.sl.un_320 so.lg.un_760  ga.gd.un_640 fa.ar.ur_555
  0x2b2d10ee, 0x1800271b, 0x211310a0, 0x520131ee,   // lt.sk.vi_422 gd.ga.un_770  lt.et.jw_322 az.en.ha_422
  0x1a003204, 0x111c2804, 0x01002704, 0x0f002d1a,   // bs.tl.un_320 sw.id.ro_332  gd.en.un_320 sk.lv.un_760
  // [1a30]
  0x3100101a, 0x080c1ca0, 0x0a4a1fad, 0x6b255307,   // lt.az.un_760 id.sv.no_322  cy.yo.pt_643 ht.eu.ceb_432
  0x0717110c, 0x291632a7, 0x071710ad, 0x18002119,   // ro.sr.bg_543 bs.hr.sl_532  be.sr.bg_643 fa.ar.un_750
  0x0a001919, 0x1c3b6407, 0x0c041211, 0x0d0913a4,   // gl.pt.un_750 lg.so.id_432  hu.fi.sv_653 bh.hi.ne_433
  0x18002114, 0x3b1f0c02, 0x3f2a010c, 0x04000618,   // fa.ar.un_660 sv.cy.so_222  en.mt.af_543 de.fi.un_740
  // [1a40]
  0x3f080205, 0x1b043204, 0x0c001213, 0x060e1304,   // da.no.af_333 bs.fi.tr_332  hu.sv.un_650 et.is.de_332
  0x521e1b07, 0x0e001b21, 0x1c090da9, 0x07000a09,   // tr.ms.ha_432 tr.is.un_860  ne.hi.mr_544 mk.bg.un_440
  0x02005307, 0x12002a0c, 0x0a001002, 0x29130407,   // ht.da.un_420 mt.hu.un_530  be.mk.un_220 fi.et.sl_432
  0x04060c0d, 0x29005304, 0x061e1c0d, 0x111f0e0c,   // sv.de.fi_554 ht.sl.un_320  id.ms.de_554 is.cy.ro_543
  // [1a50]
  0x04000c0d, 0x072a1f0b, 0x2a1119a4, 0x042a0708,   // sv.fi.un_540 cy.mt.it_542  gl.ro.mt_433 it.mt.fi_443
  0x19311ba4, 0x29000e12, 0x1b0221ee, 0x25131fee,   // tr.az.gl_433 is.sl.un_640  jw.da.tr_422 cy.et.eu_422
  0x16103bee, 0x0b002d08, 0x0e001f08, 0x04120c0c,   // so.lt.hr_422 sk.es.un_430  cy.is.un_430 sv.hu.fi_543
  0x2112180e, 0x182d0d02, 0x080b1ea0, 0x1a28520c,   // ar.ur.fa_555 cs.sk.ga_222  ms.es.no_322 ha.sw.tl_543
  // [1a60]
  0x2a0413a4, 0x6b1e1a0d, 0x0f000307, 0x00002437,   // et.fi.mt_433 tl.ms.ceb_554  nl.lv.un_420 yi.un.un_B00
  0x2a080c07, 0x0435520b, 0x081707a0, 0x1e001c22,   // sv.no.mt_432 ha.zu.fi_542  bg.sr.uk_322 id.ms.un_870
  0x08311b55, 0x06003f0c, 0x52282104, 0x0735550c,   // tr.az.no_442 af.de.un_530  jw.sw.ha_332 rw.zu.it_543
  0x25000923, 0x556406ec, 0x1a6b01af, 0x6b3128ad,   // pl.eu.un_880 de.lg.rw_644  en.ceb.tl_655 sw.az.ceb_643
  // [1a70]
  0x080c1214, 0x12110505, 0x646b1a5a, 0x3b005207,   // hu.sv.no_666 fr.ro.hu_333  tl.ceb.lg_553 ha.so.un_420
  0x20003b1b, 0x28002909, 0x02001a05, 0x55521aa9,   // so.sq.un_770 sl.sw.un_440  tl.da.un_330 tl.ha.rw_544
  0x5228255a, 0x3b00210e, 0x521b2509, 0x3b001e04,   // eu.sw.ha_553 jw.so.un_550  eu.tr.ha_444 ms.so.un_320
  0x112d0d08, 0x23190a11, 0x350a64a4, 0x0e005209,   // cs.sk.ro_443 pt.gl.ca_653  lg.pt.zu_433 ha.is.un_440
  // [1a80]
  0x17080aa0, 0x271e1c0d, 0x0925120e, 0x10080a07,   // mk.uk.sr_322 id.ms.gd_554  hu.eu.pl_555 mk.uk.be_432
  0x0800102b, 0x2100520e, 0x645507a9, 0x1300090c,   // be.uk.un_980 ha.jw.un_550  it.rw.lg_544 hi.bh.un_530
  0x06080e0c, 0x00002001, 0x12001114, 0x20295307,   // is.no.de_543 sq.un.un_200  ro.hu.un_660 ht.sl.sq_432
  0x682852a4, 0x28524a12, 0x1b043ba4, 0x08041013,   // ha.sw.ig_433 yo.ha.sw_654  so.fi.tr_433 be.ru.uk_665
  // [1a90]
  0x05004a07, 0x2952350d, 0x1a211c0b, 0x033f05af,   // yo.fr.un_420 zu.ha.sl_554  id.jw.tl_542 fr.af.nl_655
  0x09211aee, 0x1c002704, 0x0a131908, 0x53192304,   // tl.jw.pl_422 gd.id.un_320  gl.et.pt_443 ca.gl.ht_332
  0x201f0e05, 0x1000350c, 0x0e1b0413, 0x3b5228af,   // is.cy.sq_333 zu.lt.un_530  fi.tr.is_665 sw.ha.so_655
  0x03051f0e, 0x2a033ba9, 0x201b09a9, 0x211b1c08,   // cy.fr.nl_555 so.nl.mt_544  pl.tr.sq_544 id.tr.jw_443
  // [1aa0]
  0x042916a0, 0x53003f21, 0x321617a6, 0x0e131baf,   // hr.sl.fi_322 af.ht.un_860  sr.hr.bs_521 tr.et.is_655
  0x0e00351a, 0x1f002704, 0x3f3b03a4, 0x06640811,   // zu.is.un_760 gd.cy.un_320  nl.so.af_433 no.lg.de_653
  0x1f006b02, 0x06120eaf, 0x4a2b1c08, 0x013f050c,   // ceb.cy.un_220 is.hu.de_655  id.vi.yo_443 fr.af.en_543
  0x070f1312, 0x06000112, 0x10000708, 0x32163bee,   // et.lv.it_654 en.de.un_640  bg.be.un_430 so.hr.bs_422
  // [1ab0]
  0x3f0306af, 0x0c09100e, 0x0f000e19, 0x0000210a,   // de.nl.af_655 lt.pl.sv_555  is.lv.un_750 jw.un.un_500
  0x1b0f2955, 0x530d190c, 0x1b1f0612, 0x1a215309,   // sl.lv.tr_442 gl.cs.ht_543  de.cy.tr_654 ht.jw.tl_444
  0x062d0d5a, 0x5300210c, 0x0f2d0e05, 0x640e07ec,   // cs.sk.de_553 jw.ht.un_530  is.sk.lv_333 it.is.lg_644
  0x16095304, 0x230b010c, 0x170408a9, 0x20002a04,   // ht.pl.hr_332 en.es.ca_543  uk.ru.sr_544 mt.sq.un_320
  // [1ac0]
  0x0a1711a7, 0x04110704, 0x5209640c, 0x53000909,   // ro.sr.mk_532 bg.ro.ru_332  lg.pl.ha_543 pl.ht.un_440
  0x1a006b0e, 0x05531904, 0x010507a0, 0x0618520c,   // ceb.tl.un_550 gl.ht.fr_332  it.fr.en_322 ha.ga.de_543
  0x233f0507, 0x08170a05, 0x6e285512, 0x05045307,   // fr.af.ca_432 mk.sr.uk_333  rw.sw.hmn_654 ht.fi.fr_432
  0x323555a4, 0x1c0d09a0, 0x083f040c, 0x1f002a1a,   // rw.zu.bs_433 hi.ne.mr_322  fi.af.no_543 mt.cy.un_760
  // [1ad0]
  0x041711a0, 0x1a6b25a4, 0x11170a08, 0x35005514,   // ro.sr.ru_322 eu.ceb.tl_433  mk.sr.ro_443 rw.zu.un_660
  0x1e211c0c, 0x10001f13, 0x6b1b5308, 0x03003f19,   // id.jw.ms_543 cy.lt.un_650  ht.tr.ceb_443 af.nl.un_750
  0x08071705, 0x190b4a14, 0x31091bec, 0x10000404,   // sr.bg.uk_333 yo.es.gl_666  tr.pl.az_644 ru.be.un_320
  0x17001312, 0x0a162804, 0x0c001218, 0x0a000721,   // et.sr.un_640 sw.hr.pt_332  hu.sv.un_740 bg.mk.un_860
  // [1ae0]
  0x23075555, 0x1004080e, 0x07001805, 0x04002804,   // rw.it.ca_442 uk.ru.be_555  ga.it.un_330 sw.fi.un_320
  0x35552812, 0x08001023, 0x04110a13, 0x52642808,   // sw.rw.zu_654 be.uk.un_880  mk.ro.ru_665 sw.lg.ha_443
  0x092d1607, 0x2d4a0e05, 0x0f071007, 0x08020d0c,   // hr.sk.pl_432 is.yo.sk_333  lt.it.lv_432 cs.da.no_543
  0x2d120d12, 0x0c001308, 0x3f000322, 0x132a0755,   // cs.hu.sk_654 et.sv.un_430  nl.af.un_870 it.mt.et_442
  // [1af0]
  0x2d070d04, 0x04000812, 0x64002822, 0x04000c13,   // cs.it.sk_332 uk.ru.un_640  sw.lg.un_870 sv.fi.un_650
  0x01003f07, 0x2d0d6eee, 0x0a0411a0, 0x28005304,   // af.en.un_420 hmn.cs.sk_422  ro.ru.mk_322 ht.sw.un_320
  0x2d045304, 0x190a23ee, 0x0417110c, 0x0a1f23af,   // ht.fi.sk_332 ca.pt.gl_422  ro.sr.ru_543 ca.cy.pt_655
  0x6b235508, 0x551a21a4, 0x23001104, 0x07001a11,   // rw.ca.ceb_443 jw.tl.rw_433  ro.ca.un_320 tl.it.un_630
  // [1b00]
  0x03005504, 0x0500230c, 0x6400040d, 0x0e001a08,   // rw.nl.un_320 ca.fr.un_530  fi.lg.un_540 tl.is.un_430
  0x55001a22, 0x111e1ca0, 0x04130cee, 0x190a230c,   // tl.rw.un_870 id.ms.ro_322  sv.et.fi_422 ca.pt.gl_543
  0x0c000508, 0x2100230c, 0x6b6428ad, 0x1e1c55a9,   // fr.sv.un_430 ca.jw.un_530  sw.lg.ceb_643 rw.id.ms_544
  0x07285505, 0x031c01a4, 0x071e1c02, 0x2d000c0d,   // rw.sw.it_333 en.id.nl_433  id.ms.it_222 sv.sk.un_540
  // [1b10]
  0x07000421, 0x2b006b04, 0x063101a0, 0x20230a0b,   // fi.it.un_860 ceb.vi.un_320  en.az.de_322 pt.ca.sq_542
  0x21270bee, 0x0b6b55a4, 0x11190a13, 0x11001319,   // es.gd.jw_422 rw.ceb.es_433  pt.gl.ro_665 et.ro.un_750
  0x1b201309, 0x64005521, 0x1b351309, 0x0e07640d,   // et.sq.tr_444 rw.lg.un_860  et.zu.tr_444 lg.it.is_554
  0x0a1710ee, 0x252718ad, 0x5228200c, 0x2500110c,   // be.sr.mk_422 ga.gd.eu_643  sq.sw.ha_543 ro.eu.un_530
  // [1b20]
  0x1200051a, 0x17351355, 0x2800070c, 0x080a1104,   // fr.hu.un_760 et.zu.sr_442  it.sw.un_530 ro.mk.uk_332
  0x310106ee, 0x07000d04, 0x23000a14, 0x53010507,   // de.en.az_422 cs.it.un_320  pt.ca.un_660 fr.en.ht_432
  0x526b1aa4, 0x11030709, 0x32002308, 0x2006010c,   // tl.ceb.ha_433 it.nl.ro_444  ca.bs.un_430 en.de.sq_543
  0x0d002d18, 0x080213ec, 0x1f11230c, 0x070a10a0,   // sk.cs.un_740 et.da.no_644  ca.ro.cy_543 be.mk.bg_322
  // [1b30]
  0x110a23ec, 0x281a21a4, 0x213555a6, 0x2d0f0dec,   // ca.pt.ro_644 jw.tl.sw_433  rw.zu.jw_521 cs.lv.sk_644
  0x3b1f0ca4, 0x1200091b, 0x5500061a, 0x3b003119,   // sv.cy.so_433 pl.hu.un_770  de.rw.un_760 az.so.un_750
  0x522013a9, 0x17002907, 0x0b00050c, 0x2d0d290e,   // et.sq.ha_544 sl.sr.un_420  fr.es.un_530 sl.cs.sk_555
  0x0f350908, 0x21000c04, 0x1b6420ec, 0x0a1704a4,   // pl.zu.lv_443 sv.jw.un_320  sq.lg.tr_644 ru.sr.mk_433
  // [1b40]
  0x292d0d05, 0x02080c5a, 0x1c281ea0, 0x351301a0,   // cs.sk.sl_333 sv.no.da_553  ms.sw.id_322 en.et.zu_322
  0x21021c07, 0x2b274a0c, 0x25211011, 0x04001108,   // id.da.jw_432 yo.gd.vi_543  lt.jw.eu_653 ro.ru.un_430
  0x0c000612, 0x52116ba7, 0x06020ca4, 0x04100712,   // de.sv.un_640 ceb.ro.ha_532  sv.da.de_433 bg.be.ru_654
  0x2b004a14, 0x6b101aa0, 0x6b100c07, 0x523b1ea4,   // yo.vi.un_660 tl.lt.ceb_322  sv.lt.ceb_432 ms.so.ha_433
  // [1b50]
  0x172d0da4, 0x04004a0e, 0x64285255, 0x080411a9,   // cs.sk.sr_433 yo.fi.un_550  ha.sw.lg_442 ro.ru.uk_544
  0x1b190b0c, 0x11002819, 0x01000a07, 0x0d005221,   // es.gl.tr_543 sw.ro.un_750  pt.en.un_420 ha.cs.un_860
  0x2b00270e, 0x32236e0c, 0x35010aa6, 0x4a002b21,   // gd.vi.un_550 hmn.ca.bs_543  pt.en.zu_521 vi.yo.un_860
  0x2d0d1609, 0x05075505, 0x1b00230b, 0x106455ec,   // hr.cs.sk_444 rw.it.fr_333  ca.tr.un_520 rw.lg.lt_644
  // [1b60]
  0x0a000c05, 0x2d0f17a9, 0x052801a4, 0x0c0864a9,   // sv.pt.un_330 sr.lv.sk_544  en.sw.fr_433 lg.no.sv_544
  0x20283b11, 0x05010607, 0x03006804, 0x171011a4,   // so.sw.sq_653 de.en.fr_432  ig.nl.un_320 ro.be.sr_433
  0x07002a0e, 0x0804105a, 0x02016404, 0x1e1c2105,   // mt.it.un_550 be.ru.uk_553  lg.en.da_332 jw.id.ms_333
  0x01001a02, 0x3b001108, 0x552812a4, 0x3f312008,   // tl.en.un_220 ro.so.un_430  hu.sw.rw_433 sq.az.af_443
  // [1b70]
  0x6411200c, 0x1a6b530c, 0x07004a0c, 0x351255ad,   // sq.ro.lg_543 ht.ceb.tl_543  yo.it.un_530 rw.hu.zu_643
  0x55002821, 0x35106407, 0x322d1760, 0x29160da4,   // sw.rw.un_860 lg.lt.zu_432  sr.sk.bs_664 cs.hr.sl_433
  0x170a0809, 0x072a11a4, 0x103568ee, 0x1a000d04,   // uk.mk.sr_444 ro.mt.it_433  ig.zu.lt_422 cs.tl.un_320
  0x27281808, 0x190b01a4, 0x0d091c12, 0x0f0a3bee,   // ga.sw.gd_443 en.es.gl_433  mr.hi.ne_654 so.pt.lv_422
  // [1b80]
  0x681806ee, 0x6e2028a6, 0x2a110704, 0x55283560,   // de.ga.ig_422 sw.sq.hmn_521  it.ro.mt_332 zu.sw.rw_664
  0x0a00310c, 0x31101b0e, 0x55646808, 0x02000504,   // az.pt.un_530 tr.lt.az_555  ig.lg.rw_443 fr.da.un_320
  0x00001801, 0x1b196bec, 0x53231c04, 0x133b1855,   // ga.un.un_200 ceb.gl.tr_644  id.ca.ht_332 ga.so.et_442
  0x0c1c3f07, 0x556408a0, 0x1a55230c, 0x5500351b,   // af.id.sv_432 no.lg.rw_322  ca.rw.tl_543 zu.rw.un_770
  // [1b90]
  0x061b2507, 0x2a55075a, 0x18000e19, 0x0700042b,   // eu.tr.de_432 it.rw.mt_553  is.ga.un_750 ru.bg.un_980
  0x08110e07, 0x1708070e, 0x3b001813, 0x1b001122,   // is.ro.no_432 bg.uk.sr_555  ga.so.un_650 ro.tr.un_870
  0x13003b08, 0x0d292d04, 0x18002122, 0x03083fa9,   // so.et.un_430 sk.sl.cs_332  fa.ar.un_870 af.no.nl_544
  0x3b0c1ca0, 0x060c0412, 0x01002422, 0x112301a9,   // id.sv.so_322 fi.sv.de_654  yi.iw.un_870 en.ca.ro_544
  // [1ba0]
  0x04254aad, 0x10002013, 0x0a110707, 0x033f1e02,   // yo.eu.fi_643 sq.lt.un_650  bg.ro.mk_432 ms.af.nl_222
  0x16002905, 0x100817a4, 0x0802070c, 0x326b280c,   // sl.hr.un_330 sr.uk.be_433  it.da.no_543 sw.ceb.bs_543
  0x2d0d295a, 0x09003b05, 0x080411a4, 0x17080707,   // sl.cs.sk_553 so.pl.un_330  ro.ru.uk_433 bg.uk.sr_432
  0x0c103b12, 0x00001f06, 0x0d092d12, 0x28041a09,   // so.lt.sv_654 cy.un.un_400  sk.pl.cs_654 tl.fi.sw_444
  // [1bb0]
  0x010629a0, 0x041708af, 0x55136ba0, 0x0f1011ec,   // sl.de.en_322 uk.sr.ru_655  ceb.et.rw_322 ro.lt.lv_644
  0x3b1e1c60, 0x55001c02, 0x08070a0c, 0x21005204,   // id.ms.so_664 id.rw.un_220  mk.bg.uk_543 ha.jw.un_320
  0x0c00530d, 0x2d0d1007, 0x110407af, 0x05002802,   // ht.sv.un_540 lt.cs.sk_432  bg.ru.ro_655 sw.fr.un_220
  0x0c3b130c, 0x1a132804, 0x1a0e1ca4, 0x20251c07,   // et.so.sv_543 sw.et.tl_332  id.is.tl_433 id.eu.sq_432
  // [1bc0]
  0x06000c14, 0x070408af, 0x03083f05, 0x351f27ad,   // sv.de.un_660 uk.ru.bg_655  af.no.nl_333 gd.cy.zu_643
  0x0d2d4aad, 0x07010507, 0x17100a55, 0x3b351a08,   // yo.sk.cs_643 fr.en.it_432  mk.be.sr_442 tl.zu.so_443
  0x6b001318, 0x063b1e04, 0x190a03ee, 0x552164af,   // et.ceb.un_740 ms.so.de_332  nl.pt.gl_422 lg.jw.rw_655
  0x070410a0, 0x52002a21, 0x2d0302a4, 0x3200160b,   // be.ru.bg_322 mt.ha.un_860  da.nl.sk_433 hr.bs.un_520
  // [1bd0]
  0x04000e12, 0x0b322807, 0x28171608, 0x25010c0c,   // is.fi.un_640 sw.bs.es_432  hr.sr.sw_443 sv.en.eu_543
  0x066b01a4, 0x2a01250c, 0x25211c07, 0x11013fa0,   // en.ceb.de_433 eu.en.mt_543  id.jw.eu_432 af.en.ro_322
  0x0f172912, 0x12000e14, 0x13000419, 0x023b1a0c,   // sl.sr.lv_654 is.hu.un_660  fi.et.un_750 tl.so.da_543
  0x17070a05, 0x21001123, 0x3b00680c, 0x0e3f0612,   // mk.bg.sr_333 ro.jw.un_880  ig.so.un_530 de.af.is_654
  // [1be0]
  0x09060d14, 0x21003b20, 0x2b3f03ad, 0x02080c11,   // cs.de.pl_666 so.jw.un_850  nl.af.vi_643 sv.no.da_653
  0x251a10a4, 0x1000170d, 0x12000d13, 0x0925350c,   // lt.tl.eu_433 sr.be.un_540  cs.hu.un_650 zu.eu.pl_543
  0x20311eee, 0x08000c09, 0x07005204, 0x1b002519,   // ms.az.sq_422 sv.no.un_440  ha.it.un_320 eu.tr.un_750
  0x23001704, 0x1a210704, 0x04002112, 0x1b003118,   // sr.ca.un_320 it.jw.tl_332  jw.fi.un_640 az.tr.un_740
  // [1bf0]
  0x2b001e13, 0x04133b0d, 0x10001705, 0x6b1a180c,   // ms.vi.un_650 so.et.fi_554  sr.lt.un_330 ga.tl.ceb_543
  0x25004a04, 0x05190eee, 0x0e0d0aa9, 0x0b0a13a0,   // yo.eu.un_320 is.gl.fr_422  pt.cs.is_544 et.pt.es_322
  0x0e0c1c07, 0x062a3b12, 0x0a4a18a9, 0x06271813,   // id.sv.is_432 so.mt.de_654  ga.yo.pt_544 ga.gd.de_665
  0x3b001312, 0x4a0e18ec, 0x102d0d08, 0x1b001111,   // et.so.un_640 ga.is.yo_644  cs.sk.lt_443 ro.tr.un_630

  // [1c00]
  0x64004a07, 0x21351ca4, 0x040b20a7, 0x18002b21,   // yo.lg.un_420 id.zu.jw_433  sq.es.fi_532 vi.ga.un_860
  0x2a051faf, 0x2d184a5a, 0x07020812, 0x1c000d1b,   // cy.fr.mt_655 yo.ga.sk_553  no.da.it_654 ne.mr.un_770
  0x4a180ead, 0x2a0501ec, 0x1b002513, 0x4a001822,   // is.ga.yo_643 en.fr.mt_644  eu.tr.un_650 ga.yo.un_870
  0x2b0c10ee, 0x0e1125ad, 0x0400100b, 0x08250e0c,   // lt.sv.vi_422 eu.ro.is_643  be.ru.un_520 is.eu.no_543
  // [1c10]
  0x1f00250c, 0x3f000304, 0x1200181b, 0x4a000e1b,   // eu.cy.un_530 nl.af.un_320  ga.hu.un_770 is.yo.un_770
  0x180d4a13, 0x0c00040d, 0x2b0e0a08, 0x060810a4,   // yo.cs.ga_665 fi.sv.un_540  pt.is.vi_443 lt.no.de_433
  0x0d002d13, 0x08022aa0, 0x0a3b11a4, 0x03023513,   // sk.cs.un_650 mt.da.no_322  ro.so.pt_433 zu.da.nl_665
  0x31522312, 0x0100130d, 0x03070607, 0x0f001022,   // ca.ha.az_654 et.en.un_540  de.it.nl_432 lt.lv.un_870
  // [1c20]
  0x11100408, 0x131201a7, 0x1b105507, 0x2000030d,   // ru.be.ro_443 en.hu.et_532  rw.lt.tr_432 nl.sq.un_540
  0x2d0d10af, 0x53000502, 0x2a00200c, 0x252d0d0d,   // lt.cs.sk_655 fr.ht.un_220  sq.mt.un_530 cs.sk.eu_554
  0x0900100d, 0x17000a11, 0x552d01a7, 0x292025ac,   // lt.pl.un_540 mk.sr.un_630  en.sk.rw_532 eu.sq.sl_632
  0x2d002107, 0x55281008, 0x2d0e0c02, 0x4a0d2d0c,   // jw.sk.un_420 lt.sw.rw_443  sv.is.sk_222 sk.cs.yo_543
  // [1c30]
  0x09001021, 0x2b001f05, 0x2500641b, 0x01006b05,   // lt.pl.un_860 cy.vi.un_330  lg.eu.un_770 ceb.en.un_330
  0x0f1710ad, 0x31002509, 0x2b1801ee, 0x1b002509,   // lt.sr.lv_643 eu.az.un_440  en.ga.vi_422 eu.tr.un_440
  0x5535520c, 0x2d081aa0, 0x04080aaf, 0x1c090d11,   // ha.zu.rw_543 tl.no.sk_322  mk.uk.ru_655 ne.hi.mr_653
  0x0800022c, 0x102d29ee, 0x120c0213, 0x05013fa0,   // da.no.un_990 sl.sk.lt_422  da.sv.hu_665 af.en.fr_322
  // [1c40]
  0x53002808, 0x04001f02, 0x090d1c0d, 0x04090b55,   // sw.ht.un_430 cy.fi.un_220  mr.ne.hi_554 es.pl.fi_442
  0x0e282a05, 0x030f3fa4, 0x1a211ca0, 0x08000c2c,   // mt.sw.is_333 af.lv.nl_433  id.jw.tl_322 sv.no.un_990
  0x0600091b, 0x3f2901a4, 0x0e003207, 0x25001907,   // pl.de.un_770 en.sl.af_433  bs.is.un_420 gl.eu.un_420
  0x090f035a, 0x17162902, 0x0c3f2a02, 0x1c13095a,   // nl.lv.pl_553 sl.hr.sr_222  mt.af.sv_222 hi.bh.mr_553
  // [1c50]
  0x0c00040c, 0x012d0d04, 0x55093f12, 0x08005505,   // fi.sv.un_530 cs.sk.en_332  af.pl.rw_654 rw.no.un_330
  0x12020ca6, 0x10645308, 0x2d005308, 0x100711a4,   // sv.da.hu_521 ht.lg.lt_443  ht.sk.un_430 ro.bg.be_433
  0x2a060713, 0x09003f07, 0x2d102a07, 0x0900201a,   // it.de.mt_665 af.pl.un_420  mt.lt.sk_432 sq.pl.un_760
  0x3f000908, 0x07000f11, 0x4a005319, 0x091c21a4,   // pl.af.un_430 lv.it.un_630  ht.yo.un_750 jw.id.pl_433
  // [1c60]
  0x040f2d11, 0x55006419, 0x09000622, 0x3b00212a,   // sk.lv.fi_653 lg.rw.un_750  de.pl.un_870 jw.so.un_970
  0x01312aac, 0x09211a12, 0x1b002a07, 0x3200170e,   // mt.az.en_632 tl.jw.pl_654  mt.tr.un_420 sr.bs.un_550
  0x170708a0, 0x18033fad, 0x1f2a0e0e, 0x5512640c,   // uk.bg.sr_322 af.nl.ga_643  is.mt.cy_555 lg.hu.rw_543
  0x1c2a1e04, 0x23121f07, 0x053f10a0, 0x100223ec,   // ms.mt.id_332 cy.hu.ca_432  lt.af.fr_322 ca.da.lt_644
  // [1c70]
  0x640328ad, 0x130c10a0, 0x2d004a0e, 0x55080205,   // sw.nl.lg_643 lt.sv.et_322  yo.sk.un_550 da.no.rw_333
  0x010e3fa7, 0x2a11180c, 0x0c0855a9, 0x0e003f08,   // af.is.en_532 ga.ro.mt_543  rw.no.sv_544 af.is.un_430
  0x0f001707, 0x04070a07, 0x10002312, 0x1c0d0905,   // sr.lv.un_420 mk.bg.ru_432  ca.lt.un_640 hi.ne.mr_333
  0x21000907, 0x05005204, 0x12032309, 0x133b640d,   // pl.jw.un_420 ha.fr.un_320  ca.nl.hu_444 lg.so.et_554
  // [1c80]
  0x01005202, 0x1800210d, 0x0a1704af, 0x09002702,   // ha.en.un_220 fa.ar.un_540  ru.sr.mk_655 gd.pl.un_220
  0x122318ad, 0x10002012, 0x00000e2d, 0x0a001019,   // ga.ca.hu_643 sq.lt.un_640  is.un.un_A00 lt.pt.un_750
  0x55002508, 0x4a00182b, 0x1c100405, 0x080411ee,   // eu.rw.un_430 ga.yo.un_980  fi.lt.id_333 ro.ru.uk_422
  0x10006807, 0x0000052d, 0x050823a6, 0x03002304,   // ig.lt.un_420 fr.un.un_A00  ca.no.fr_521 ca.nl.un_320
  // [1c90]
  0x232b4aaf, 0x1e1c25af, 0x4a211ca9, 0x1200010d,   // yo.vi.ca_655 eu.id.ms_655  id.jw.yo_544 en.hu.un_540
  0x18004a2a, 0x111e1cec, 0x01003507, 0x1e3f1ca4,   // yo.ga.un_970 id.ms.ro_644  zu.en.un_420 id.af.ms_433
  0x1c21130c, 0x1b311ea0, 0x231e1c07, 0x090d1cee,   // et.jw.id_543 ms.az.tr_322  id.ms.ca_432 mr.ne.hi_422
  0x2a000c12, 0x1800270b, 0x1b682807, 0x072b6b0d,   // sv.mt.un_640 gd.ga.un_520  sw.ig.tr_432 ceb.vi.it_554
  // [1ca0]
  0x100a1713, 0x12006822, 0x210e4aa0, 0x2d002814,   // sr.mk.be_665 ig.hu.un_870  yo.is.jw_322 sw.sk.un_660
  0x350b5508, 0x521c530c, 0x1b1e1c12, 0x21006b05,   // rw.es.zu_443 ht.id.ha_543  id.ms.tr_654 ceb.jw.un_330
  0x28182713, 0x18004a21, 0x6429110c, 0x04000c0c,   // gd.ga.sw_665 yo.ga.un_860  ro.sl.lg_543 sv.fi.un_530
  0x4a0e1812, 0x080411ad, 0x322d0908, 0x0d4a230d,   // ga.is.yo_654 ro.ru.uk_643  pl.sk.bs_443 ca.yo.cs_554
  // [1cb0]
  0x554a28a4, 0x55000b04, 0x07000a07, 0x3b1b2a11,   // sw.yo.rw_433 es.rw.un_320  pt.it.un_420 mt.tr.so_653
  0x030602ee, 0x2000350e, 0x0300060c, 0x100a0507,   // da.de.nl_422 zu.sq.un_550  de.nl.un_530 fr.pt.lt_432
  0x281c2108, 0x18000921, 0x0f20350c, 0x10001c1a,   // jw.id.sw_443 pl.ga.un_860  zu.sq.lv_543 id.lt.un_760
  0x00001e1c, 0x17290fa9, 0x3b002a0b, 0x1100310d,   // ms.un.un_800 lv.sl.sr_544  mt.so.un_520 az.ro.un_540
  // [1cc0]
  0x13001f21, 0x17163211, 0x0e040f0c, 0x523b280d,   // cy.et.un_860 bs.hr.sr_653  lv.fi.is_543 sw.so.ha_554
  0x202a0e0c, 0x21005208, 0x53212a0c, 0x0700110e,   // is.mt.sq_543 ha.jw.un_430  mt.jw.ht_543 ro.bg.un_550
  0x28002022, 0x272111a4, 0x016b11a4, 0x32100f08,   // sq.sw.un_870 ro.jw.gd_433  ro.ceb.en_433 lv.lt.bs_443
  0x1b00680b, 0x070b23a9, 0x04080708, 0x0a070413,   // ig.tr.un_520 ca.es.it_544  bg.uk.ru_443 ru.bg.mk_665
  // [1cd0]
  0x170a07ad, 0x100721a4, 0x21091004, 0x04001122,   // bg.mk.sr_643 jw.it.lt_433  lt.pl.jw_332 ro.fi.un_870
  0x0d001c2a, 0x0a0807a9, 0x0c000113, 0x2821640c,   // mr.ne.un_970 bg.uk.mk_544  en.sv.un_650 lg.jw.sw_543
  0x230129a9, 0x120e0c08, 0x01000d04, 0x23016b04,   // sl.en.ca_544 sv.is.hu_443  cs.en.un_320 ceb.en.ca_332
  0x07190b09, 0x4a2b0e04, 0x35076408, 0x1c0e1ea4,   // es.gl.it_444 is.vi.yo_332  lg.it.zu_443 ms.is.id_433
  // [1ce0]
  0x0d004a1b, 0x0b184a5a, 0x1e002702, 0x070b0a14,   // yo.cs.un_770 yo.ga.es_553  gd.ms.un_220 pt.es.it_666
  0x3b073511, 0x0e1e1c04, 0x18004a35, 0x32091e0b,   // zu.it.so_653 id.ms.is_332  yo.ga.un_A90 ms.pl.bs_542
  0x1600250c, 0x09002909, 0x110e0c0d, 0x1e1c0a05,   // eu.hr.un_530 sl.pl.un_440  sv.is.ro_554 pt.id.ms_333
  0x06020ca0, 0x680b520c, 0x3b00521a, 0x19000a1a,   // sv.da.de_322 ha.es.ig_543  ha.so.un_760 pt.gl.un_760
  // [1cf0]
  0x1b1f31af, 0x2b184aec, 0x09002508, 0x29000d1a,   // az.cy.tr_655 yo.ga.vi_644  eu.pl.un_430 cs.sl.un_760
  0x2b184aa7, 0x0d002919, 0x08101708, 0x1b3555a4,   // yo.ga.vi_532 sl.cs.un_750  sr.be.uk_443 rw.zu.tr_433
  0x08000412, 0x1c003204, 0x2d684a11, 0x68002813,   // ru.uk.un_640 bs.id.un_320  yo.ig.sk_653 sw.ig.un_650
  0x040a1002, 0x191064ad, 0x1c002102, 0x170410a0,   // be.mk.ru_222 lg.lt.gl_643  jw.id.un_220 be.ru.sr_322
  // [1d00]
  0x091b530c, 0x1c001314, 0x64125509, 0x181a6b12,   // ht.tr.pl_543 bh.mr.un_660  rw.hu.lg_444 ceb.tl.ga_654
  0x313b5204, 0x6800252a, 0x31190a60, 0x3f0410a0,   // ha.so.az_332 eu.ig.un_970  pt.gl.az_664 lt.fi.af_322
  0x1c00210e, 0x23184aad, 0x12106804, 0x2d0d03a4,   // jw.id.un_550 yo.ga.ca_643  ig.lt.hu_332 nl.cs.sk_433
  0x1a6b28ee, 0x07531955, 0x6b681ea0, 0x0c1e1c5a,   // sw.ceb.tl_422 gl.ht.it_442  ms.ig.ceb_322 id.ms.sv_553
  // [1d10]
  0x09002113, 0x0d002b1a, 0x00004a37, 0x2a6b29a0,   // jw.pl.un_650 vi.cs.un_760  yo.un.un_B00 sl.ceb.mt_322
  0x03006e07, 0x07002707, 0x196b01ad, 0x0d1c1307,   // hmn.nl.un_420 gd.it.un_420  en.ceb.gl_643 bh.mr.ne_432
  0x1629680c, 0x64001b18, 0x0a00200e, 0x552864ec,   // ig.sl.hr_543 tr.lg.un_740  sq.pt.un_550 lg.sw.rw_644
  0x2a0e1008, 0x27002519, 0x0a001e02, 0x06006812,   // lt.is.mt_443 eu.gd.un_750  ms.pt.un_220 ig.de.un_640
  // [1d20]
  0x03000704, 0x2d0d09ec, 0x28005514, 0x126b1aa0,   // it.nl.un_320 pl.cs.sk_644  rw.sw.un_660 tl.ceb.hu_322
  0x23190ba9, 0x0b554a07, 0x0e3216ad, 0x281c1ea0,   // es.gl.ca_544 yo.rw.es_432  hr.bs.is_643 ms.id.sw_322
  0x1c212855, 0x1a00210c, 0x0e120c07, 0x0b080c05,   // sw.jw.id_442 jw.tl.un_530  sv.hu.is_432 sv.no.es_333
  0x1b1208a4, 0x2d0c0da4, 0x11121008, 0x04000a1b,   // no.hu.tr_433 cs.sv.sk_433  lt.hu.ro_443 mk.ru.un_770
  // [1d30]
  0x0d092d5a, 0x06000c08, 0x04171107, 0x1f003f0d,   // sk.pl.cs_553 sv.de.un_430  ro.sr.ru_432 af.cy.un_540
  0x04070aad, 0x4a2921a0, 0x1100550d, 0x0a006e04,   // mk.bg.ru_643 jw.sl.yo_322  rw.ro.un_540 hmn.pt.un_320
  0x52211c55, 0x2d0d2109, 0x0a00190d, 0x19110b04,   // id.jw.ha_442 jw.cs.sk_444  gl.pt.un_540 es.ro.gl_332
  0x31351baf, 0x070417ee, 0x10041755, 0x53002a04,   // tr.zu.az_655 sr.ru.bg_422  sr.fi.lt_442 mt.ht.un_320
  // [1d40]
  0x09000d12, 0x52101e0c, 0x3b3f6ea0, 0x13006e09,   // cs.pl.un_640 ms.lt.ha_543  hmn.af.so_322 hmn.et.un_440
  0x20123f04, 0x520f100d, 0x10000f12, 0x1f1b3b07,   // af.hu.sq_332 lt.lv.ha_554  lv.lt.un_640 so.tr.cy_432
  0x13201b07, 0x08003f05, 0x076411a0, 0x100f1ea9,   // tr.sq.et_432 af.no.un_330  ro.lg.it_322 ms.lv.lt_544
  0x0f00102c, 0x110113a4, 0x2d0d0614, 0x28521ea4,   // lt.lv.un_990 et.en.ro_433  de.cs.sk_666 ms.ha.sw_433
  // [1d50]
  0x281052a4, 0x0400110e, 0x101e1c60, 0x28001e02,   // ha.lt.sw_433 ro.ru.un_550  id.ms.lt_664 ms.sw.un_220
  0x11001b1a, 0x19230d04, 0x31000104, 0x520f10ec,   // tr.ro.un_760 cs.ca.gl_332  en.az.un_320 lt.lv.ha_644
  0x0700060b, 0x0f120ca0, 0x3b311b12, 0x640417a0,   // de.it.un_520 sv.hu.lv_322  tr.az.so_654 sr.fi.lg_322
  0x1811320c, 0x29122a55, 0x00000501, 0x06000a19,   // bs.ro.ga_543 mt.hu.sl_442  fr.un.un_200 pt.de.un_750
  // [1d60]
  0x1e1c0aa4, 0x3500551a, 0x08190a55, 0x06136ba0,   // pt.id.ms_433 rw.zu.un_760  pt.gl.no_442 ceb.et.de_322
  0x521012a4, 0x28121ea4, 0x292d09ad, 0x25006e07,   // hu.lt.ha_433 ms.hu.sw_433  pl.sk.sl_643 hmn.eu.un_420
  0x1c1e52ad, 0x120f10ad, 0x25000808, 0x25001222,   // ha.ms.id_643 lt.lv.hu_643  no.eu.un_430 hu.eu.un_870
  0x521008a4, 0x190a010c, 0x1000520d, 0x3f000104,   // no.lt.ha_433 en.pt.gl_543  ha.lt.un_540 en.af.un_320
  // [1d70]
  0x091c1355, 0x11202308, 0x18001911, 0x20001012,   // bh.mr.hi_442 ca.sq.ro_443  gl.ga.un_630 lt.sq.un_640
  0x0b6b1a0d, 0x31001104, 0x280335a0, 0x03000619,   // tl.ceb.es_554 ro.az.un_320  zu.nl.sw_322 de.nl.un_750
  0x03070aa0, 0x170a04a4, 0x10000309, 0x040711a7,   // pt.it.nl_322 ru.mk.sr_433  nl.lt.un_440 ro.bg.ru_532
  0x13091c14, 0x0b2827ee, 0x18000b05, 0x3b2728ad,   // mr.hi.bh_666 gd.sw.es_422  es.ga.un_330 sw.gd.so_643
  // [1d80]
  0x0564550e, 0x311b110d, 0x2d0f0913, 0x073f03a4,   // rw.lg.fr_555 ro.tr.az_554  pl.lv.sk_665 nl.af.it_433
  0x120c2a11, 0x0a101709, 0x03122a07, 0x272a1112,   // mt.sv.hu_653 sr.be.mk_444  mt.hu.nl_432 ro.mt.gd_654
  0x4a0252a0, 0x1c1309ad, 0x1c285207, 0x06020c09,   // ha.da.yo_322 hi.bh.mr_643  ha.sw.id_432 sv.da.de_444
  0x18190b02, 0x0723190d, 0x531811ee, 0x070a110c,   // es.gl.ga_222 gl.ca.it_554  ro.ga.ht_422 ro.mk.bg_543
  // [1d90]
  0x1f0518a7, 0x04000809, 0x1f0518ec, 0x68005519,   // ga.fr.cy_532 uk.ru.un_440  ga.fr.cy_644 rw.ig.un_750
  0x3f001e02, 0x283b52af, 0x2d321602, 0x08530eee,   // ms.af.un_220 ha.so.sw_655  hr.bs.sk_222 is.ht.no_422
  0x28050aee, 0x07000814, 0x0e2d0d60, 0x05041fa0,   // pt.fr.sw_422 uk.bg.un_660  cs.sk.is_664 cy.fi.fr_322
  0x350e280e, 0x030625ad, 0x041c4a04, 0x1e3b2807,   // sw.is.zu_555 eu.de.nl_643  yo.id.fi_332 sw.so.ms_432
  // [1da0]
  0x1b3f6ba0, 0x0f095255, 0x18270513, 0x093b130c,   // ceb.af.tr_322 ha.pl.lv_442  fr.gd.ga_665 et.so.pl_543
  0x07294a04, 0x522705a9, 0x3b524aee, 0x2827180b,   // yo.sl.it_332 fr.gd.ha_544  yo.ha.so_422 ga.gd.sw_542
  0x521b530c, 0x1700110e, 0x1a2125a0, 0x123f0309,   // ht.tr.ha_543 ro.sr.un_550  eu.jw.tl_322 nl.af.hu_444
  0x53000507, 0x180527ad, 0x1e001c36, 0x35001913,   // fr.ht.un_420 gd.fr.ga_643  id.ms.un_AA0 gl.zu.un_650
  // [1db0]
  0x1e1c0fa4, 0x0c2b1ca7, 0x1800051a, 0x1e1c310c,   // lv.id.ms_433 id.vi.sv_532  fr.ga.un_760 az.id.ms_543
  0x0f000804, 0x1b3b1f13, 0x052d0d13, 0x2327180c,   // no.lv.un_320 cy.so.tr_665  cs.sk.fr_665 ga.gd.ca_543
  0x03003f36, 0x17311bad, 0x080206a0, 0x212d0d0e,   // af.nl.un_AA0 tr.az.sr_643  de.da.no_322 cs.sk.jw_555
  0x1b532d07, 0x0300050d, 0x0000032d, 0x09020c07,   // sk.ht.tr_432 fr.nl.un_540  nl.un.un_A00 sv.da.pl_432
  // [1dc0]
  0x05001823, 0x0d002d21, 0x103f1aa0, 0x1e1c050c,   // ga.fr.un_880 sk.cs.un_860  tl.af.lt_322 fr.id.ms_543
  0x1b1a530c, 0x19005504, 0x120427a4, 0x07000a13,   // ht.tl.tr_543 rw.gl.un_320  gd.fi.hu_433 mk.bg.un_650
  0x1a316ea4, 0x2d0d3b0d, 0x312b0aa0, 0x12080207,   // hmn.az.tl_433 so.cs.sk_554  pt.vi.az_322 da.no.hu_432
  0x20033f07, 0x1c2a2104, 0x24000133, 0x022a0bee,   // af.nl.sq_432 jw.mt.id_332  iw.yi.un_A70 es.mt.da_422
  // [1dd0]
  0x3b061012, 0x3200210c, 0x052d0d11, 0x17006e04,   // lt.de.so_654 jw.bs.un_530  cs.sk.fr_653 hmn.sr.un_320
  0x4a005204, 0x0800020d, 0x211e1ca7, 0x10003202,   // ha.yo.un_320 da.no.un_540  id.ms.jw_532 bs.lt.un_220
  0x19211f08, 0x0f1613a7, 0x090f10a4, 0x6b1c11ee,   // cy.jw.gl_443 et.hr.lv_532  lt.lv.pl_433 ro.id.ceb_422
  0x32001209, 0x12001819, 0x1a001c07, 0x0a071705,   // hu.bs.un_440 ar.ur.un_750  id.tl.un_420 sr.bg.mk_333
  // [1de0]
  0x171668ee, 0x1e1c2702, 0x0d0802a0, 0x3216290c,   // ig.hr.sr_422 gd.id.ms_222  da.no.cs_322 sl.hr.bs_543
  0x09002914, 0x093f030c, 0x03003f05, 0x3f523205,   // sl.pl.un_660 nl.af.pl_543  af.nl.un_330 bs.ha.af_333
  0x27001807, 0x12000e12, 0x3f1101a4, 0x21100ca4,   // ga.gd.un_420 is.hu.un_640  en.ro.af_433 sv.lt.jw_433
  0x0a070805, 0x03063508, 0x0e0b19a7, 0x2400010e,   // uk.bg.mk_333 zu.de.nl_443  gl.es.is_532 iw.yi.un_550
  // [1df0]
  0x17002d12, 0x1f1a6ba4, 0x1b2008a0, 0x19110bec,   // sk.sr.un_640 ceb.tl.cy_433  no.sq.tr_322 es.ro.gl_644
  0x0f2d0912, 0x6b190b04, 0x02120455, 0x520e10ee,   // pl.sk.lv_654 es.gl.ceb_332  fi.hu.da_442 lt.is.ha_422
  0x2d002918, 0x1812210e, 0x026408ac, 0x3518270c,   // sl.sk.un_740 fa.ur.ar_555  no.lg.da_632 gd.ga.zu_543
  0x27005302, 0x0e1918a7, 0x04001018, 0x03132904,   // ht.gd.un_220 ga.gl.is_532  be.ru.un_740 sl.et.nl_332
  // [1e00]
  0x190a0b05, 0x192302a4, 0x350152ee, 0x21002304,   // es.pt.gl_333 da.ca.gl_433  ha.en.zu_422 ca.jw.un_320
  0x0f1710a9, 0x09080213, 0x23000713, 0x1f002705,   // lt.sr.lv_544 da.no.pl_665  it.ca.un_650 gd.cy.un_330
  0x2804130d, 0x23190ba4, 0x3b000423, 0x13090dad,   // et.fi.sw_554 es.gl.ca_433  fi.so.un_880 ne.hi.bh_643
  0x2b012aee, 0x0b0a18ec, 0x6b043ba9, 0x25030608,   // mt.en.vi_422 ga.pt.es_644  so.fi.ceb_544 de.nl.eu_443
  // [1e10]
  0x281b1ea0, 0x1000040c, 0x03090d12, 0x1800211b,   // ms.tr.sw_322 ru.be.un_530  cs.pl.nl_654 fa.ar.un_770
  0x3b280412, 0x061209ad, 0x0f280412, 0x18190ba7,   // fi.sw.so_654 pl.hu.de_643  fi.sw.lv_654 es.gl.ga_532
  0x10080408, 0x1c090da7, 0x02006407, 0x4a002821,   // ru.uk.be_443 ne.hi.mr_532  lg.da.un_420 sw.yo.un_860
  0x192d0d13, 0x52003b05, 0x0d002d0d, 0x04100f12,   // cs.sk.gl_665 so.ha.un_330  sk.cs.un_540 lv.lt.fi_654
  // [1e20]
  0x1104100c, 0x0a190ba7, 0x4a683b0c, 0x09000619,   // be.ru.ro_543 es.gl.pt_532  so.ig.yo_543 de.pl.un_750
  0x1f190b0e, 0x04071107, 0x03001f04, 0x1c00250d,   // es.gl.cy_555 ro.bg.ru_432  cy.nl.un_320 eu.id.un_540
  0x10213b04, 0x12002112, 0x1800122a, 0x12000c0d,   // so.jw.lt_332 fa.ur.un_640  ur.ar.un_970 sv.hu.un_540
  0x02001f02, 0x211b5302, 0x0a0128a7, 0x033f21a0,   // cy.da.un_220 ht.tr.jw_222  sw.en.pt_532 jw.af.nl_322
  // [1e30]
  0x0c00022a, 0x28000421, 0x4a3b6808, 0x0a001814,   // da.sv.un_970 fi.sw.un_860  ig.so.yo_443 ga.pt.un_660
  0x0d17160e, 0x283b040d, 0x11002b11, 0x0b00180e,   // hr.sr.cs_555 fi.so.sw_554  vi.ro.un_630 ga.es.un_550
  0x04003b22, 0x20532513, 0x18190ba0, 0x3b006809,   // so.fi.un_870 eu.ht.sq_665  es.gl.ga_322 ig.so.un_440
  0x2b182812, 0x04004a22, 0x521e3ba4, 0x281827ec,   // sw.ga.vi_654 yo.fi.un_870  so.ms.ha_433 gd.ga.sw_644
  // [1e40]
  0x2b271811, 0x2a000707, 0x2a1f2b04, 0x20311ba7,   // ga.gd.vi_653 it.mt.un_420  vi.cy.mt_332 tr.az.sq_532
  0x00000106, 0x355528ad, 0x1800170c, 0x1c311ead,   // en.un.un_400 sw.rw.zu_643  sr.ga.un_530 ms.az.id_643
  0x03045304, 0x07010602, 0x640e1b0c, 0x111e6b0c,   // ht.fi.nl_332 de.en.it_222  tr.is.lg_543 ceb.ms.ro_543
  0x1b3564ec, 0x28522a12, 0x2b001907, 0x25190ba9,   // lg.zu.tr_644 mt.ha.sw_654  gl.vi.un_420 es.gl.eu_544
  // [1e50]
  0x161328a9, 0x020c0813, 0x040e2aa4, 0x321752ec,   // sw.et.hr_544 no.sv.da_665  mt.is.fi_433 ha.sr.bs_644
  0x09006412, 0x0c000e2b, 0x0e1a52af, 0x20210755,   // lg.pl.un_640 is.sv.un_980  ha.tl.is_655 it.jw.sq_442
  0x070b110c, 0x27001836, 0x06005513, 0x063f03a0,   // ro.es.it_543 ga.gd.un_AA0  rw.de.un_650 nl.af.de_322
  0x68005522, 0x0800200e, 0x0c1308a0, 0x6b680bee,   // rw.ig.un_870 sq.no.un_550  no.et.sv_322 es.ig.ceb_422
  // [1e60]
  0x6b005208, 0x1b3111a9, 0x08043f05, 0x074a68ad,   // ha.ceb.un_430 ro.az.tr_544  af.fi.no_333 ig.yo.it_643
  0x11101805, 0x641207a7, 0x1f18270d, 0x55000b02,   // ga.lt.ro_333 it.hu.lg_532  gd.ga.cy_554 es.rw.un_220
  0x050701a4, 0x2128680c, 0x205232a0, 0x08020c12,   // en.it.fr_433 ig.sw.jw_543  bs.ha.sq_322 sv.da.no_654
  0x282a27ee, 0x06202307, 0x4a556812, 0x11002521,   // gd.mt.sw_422 ca.sq.de_432  ig.rw.yo_654 eu.ro.un_860
  // [1e70]
  0x1f311e12, 0x04001319, 0x07001908, 0x1e1c6b02,   // ms.az.cy_654 et.fi.un_750  gl.it.un_430 ceb.id.ms_222
  0x31283b07, 0x030e3f07, 0x0f001f07, 0x28133b55,   // so.sw.az_432 af.is.nl_432  cy.lv.un_420 so.et.sw_442
  0x03060808, 0x200e1f11, 0x3f130308, 0x0e521aa9,   // no.de.nl_443 cy.is.sq_653  nl.et.af_443 tl.ha.is_544
  0x020c08ec, 0x170407a9, 0x13033fa4, 0x5528350c,   // no.sv.da_644 bg.ru.sr_544  af.nl.et_433 zu.sw.rw_543
  // [1e80]
  0x1e1c250c, 0x12002919, 0x21001a1b, 0x022d0e12,   // eu.id.ms_543 sl.hu.un_750  tl.jw.un_770 is.sk.da_654
  0x04033b04, 0x0c00091a, 0x214a68ad, 0x3b033f55,   // so.nl.fi_332 pl.sv.un_760  ig.yo.jw_643 af.nl.so_442
  0x050a2802, 0x04133b07, 0x4a113f0c, 0x131f2704,   // sw.pt.fr_222 so.et.fi_432  af.ro.yo_543 gd.cy.et_332
  0x28004a08, 0x082a0107, 0x68023b08, 0x28005508,   // yo.sw.un_430 en.mt.no_432  so.da.ig_443 rw.sw.un_430
  // [1e90]
  0x0a041305, 0x18001219, 0x3f2b1cee, 0x17001304,   // et.fi.pt_333 ur.ar.un_750  id.vi.af_422 et.sr.un_320
  0x033f3baf, 0x12001821, 0x0e126407, 0x190a0505,   // so.af.nl_655 ar.ur.un_860  lg.hu.is_432 fr.pt.gl_333
  0x6455350d, 0x2a212805, 0x122a6407, 0x09000707,   // zu.rw.lg_554 sw.jw.mt_333  lg.mt.hu_432 it.pl.un_420
  0x190a25a9, 0x04170705, 0x05002307, 0x0c0501a4,   // eu.pt.gl_544 bg.sr.ru_333  ca.fr.un_420 en.fr.sv_433
  // [1ea0]
  0x2a1b5208, 0x2b533b05, 0x35645512, 0x530d2d11,   // ha.tr.mt_443 so.ht.vi_333  rw.lg.zu_654 sk.cs.ht_653
  0x08100413, 0x52122aa7, 0x170a10ee, 0x4a001321,   // ru.be.uk_665 mt.hu.ha_532  be.mk.sr_422 et.yo.un_860
  0x04033f09, 0x190f0bec, 0x036813a4, 0x17231fad,   // af.nl.fi_444 es.lv.gl_644  et.ig.nl_433 cy.ca.sr_643
  0x081017a4, 0x3f033b08, 0x64522a60, 0x04133bec,   // sr.be.uk_433 so.nl.af_443  mt.ha.lg_664 so.et.fi_644
  // [1eb0]
  0x641201a4, 0x1c211e04, 0x070116a0, 0x28002104,   // en.hu.lg_433 ms.jw.id_332  hr.en.it_322 jw.sw.un_320
  0x29203107, 0x0d000a02, 0x3b64520b, 0x12006414,   // az.sq.sl_432 pt.cs.un_220  ha.lg.so_542 lg.hu.un_660
  0x183f1fad, 0x17005207, 0x550b18a4, 0x23000509,   // cy.af.ga_643 ha.sr.un_420  ga.es.rw_433 fr.ca.un_440
  0x042835ee, 0x08071012, 0x022d0d60, 0x180153ee,   // zu.sw.fi_422 be.bg.uk_654  cs.sk.da_664 ht.en.ga_422
  // [1ec0]
  0x250328a0, 0x28001705, 0x64082aad, 0x2a210eee,   // sw.nl.eu_322 sr.sw.un_330  mt.no.lg_643 is.jw.mt_422
  0x19230bec, 0x07522aa4, 0x0a006408, 0x321655a0,   // es.ca.gl_644 mt.ha.it_433  lg.pt.un_430 rw.hr.bs_322
  0x2d170d14, 0x190b6b05, 0x0e001219, 0x291f3ba7,   // cs.sr.sk_666 ceb.es.gl_333  hu.is.un_750 so.cy.sl_532
  0x6b685305, 0x18092711, 0x55136408, 0x063f08a4,   // ht.ig.ceb_333 gd.pl.ga_653  lg.et.rw_443 no.af.de_433
  // [1ed0]
  0x25001219, 0x0a07110c, 0x2b002308, 0x02000108,   // hu.eu.un_750 ro.bg.mk_543  ca.vi.un_430 en.da.un_430
  0x05000b04, 0x27000912, 0x0e3f0804, 0x0f285255,   // es.fr.un_320 pl.gd.un_640  no.af.is_332 ha.sw.lv_442
  0x29005208, 0x1a6b0c0c, 0x20132807, 0x06050104,   // ha.sl.un_430 sv.ceb.tl_543  sw.et.sq_432 en.fr.de_332
  0x08000718, 0x0a070f04, 0x19050b55, 0x071017ee,   // bg.uk.un_740 lv.it.pt_332  es.fr.gl_442 sr.be.bg_422
  // [1ee0]
  0x0d002d08, 0x1c2128a4, 0x292d1007, 0x2b000b05,   // sk.cs.un_430 sw.jw.id_433  lt.sk.sl_432 es.vi.un_330
  0x100a0712, 0x0a000104, 0x12000a14, 0x0a171160,   // bg.mk.be_654 en.pt.un_320  pt.hu.un_660 ro.sr.mk_664
  0x2a203560, 0x01000208, 0x1a002709, 0x07005202,   // zu.sq.mt_664 da.en.un_430  gd.tl.un_440 ha.it.un_220
  0x18190b05, 0x0500110d, 0x2d290d0c, 0x04080711,   // es.gl.ga_333 ro.fr.un_540  cs.sl.sk_543 bg.uk.ru_653
  // [1ef0]
  0x07000813, 0x0964350c, 0x07002712, 0x07040aa0,   // uk.bg.un_650 zu.lg.pl_543  gd.it.un_640 mk.ru.bg_322
  0x056b0aa0, 0x18001209, 0x2d001223, 0x18002112,   // pt.ceb.fr_322 ur.ar.un_440  hu.sk.un_880 fa.ar.un_640
  0x17000712, 0x64000119, 0x3b1a6baf, 0x55006409,   // bg.sr.un_640 en.lg.un_750  ceb.tl.so_655 lg.rw.un_440
  0x040817a7, 0x231f3f02, 0x0b2319ec, 0x6b3b01a4,   // sr.uk.ru_532 af.cy.ca_222  gl.ca.es_644 en.so.ceb_433
  // [1f00]
  0x322518ee, 0x322d0da4, 0x092a040c, 0x1a003b35,   // ga.eu.bs_422 cs.sk.bs_433  fi.mt.pl_543 so.tl.un_A90
  0x0f080c55, 0x10002813, 0x3f042aa4, 0x1b1e3111,   // sv.no.lv_442 sw.lt.un_650  mt.fi.af_433 az.ms.tr_653
  0x3b000122, 0x27006402, 0x0c00080e, 0x285201af,   // en.so.un_870 lg.gd.un_220  no.sv.un_550 en.ha.sw_655
  0x07041702, 0x3b531a0d, 0x126b1a02, 0x06000c19,   // sr.ru.bg_222 tl.ht.so_554  tl.ceb.hu_222 sv.de.un_750
  // [1f10]
  0x53001a14, 0x2800641a, 0x642835ad, 0x25002721,   // tl.ht.un_660 lg.sw.un_760  zu.sw.lg_643 gd.eu.un_860
  0x6b1a3b13, 0x2a3b64a4, 0x106429ec, 0x0e005512,   // so.tl.ceb_665 lg.so.mt_433  sl.lg.lt_644 rw.is.un_640
  0x0b002319, 0x1e004a04, 0x20001b04, 0x05005307,   // ca.es.un_750 yo.ms.un_320  tr.sq.un_320 ht.fr.un_420
  0x00000906, 0x5500290e, 0x1000291a, 0x2d00230d,   // hi.un.un_400 sl.rw.un_550  sl.lt.un_760 ca.sk.un_540
  // [1f20]
  0x0c00081b, 0x016b1a14, 0x31121307, 0x0f530408,   // no.sv.un_770 tl.ceb.en_666  et.hu.az_432 fi.ht.lv_443
  0x6b1a3ba9, 0x17080a09, 0x02000835, 0x32002904,   // so.tl.ceb_544 mk.uk.sr_444  no.da.un_A90 sl.bs.un_320
  0x0800122c, 0x25181b0c, 0x3b000113, 0x1a003b23,   // hu.no.un_990 tr.ga.eu_543  en.so.un_650 so.tl.un_880
  0x531a6ba9, 0x0f2a1012, 0x3f0603a6, 0x1e000607,   // ceb.tl.ht_544 lt.mt.lv_654  nl.de.af_521 de.ms.un_420
  // [1f30]
  0x12530e07, 0x282110a6, 0x32001e07, 0x2800520e,   // is.ht.hu_432 lt.jw.sw_521  ms.bs.un_420 ha.sw.un_550
  0x64005509, 0x1f3b08ec, 0x3b1204a4, 0x281e52a4,   // rw.lg.un_440 no.so.cy_644  fi.hu.so_433 ha.ms.sw_433
  0x04211c02, 0x08002813, 0x32001708, 0x1f050107,   // id.jw.fi_222 sw.no.un_650  sr.bs.un_430 en.fr.cy_432
  0x0f191107, 0x52206404, 0x08071709, 0x28171307,   // ro.gl.lv_432 lg.sq.ha_332  sr.bg.uk_444 et.sr.sw_432
  // [1f40]
  0x020c29a4, 0x12250da0, 0x524a1aad, 0x270c0ea0,   // sl.sv.da_433 cs.eu.hu_322  tl.yo.ha_643 is.sv.gd_322
  0x1c5209a4, 0x10182aad, 0x23194aee, 0x0e000d1a,   // pl.ha.id_433 mt.ga.lt_643  yo.gl.ca_422 cs.is.un_760
  0x033f0c5a, 0x25190b09, 0x280f1fa4, 0x35006404,   // sv.af.nl_553 es.gl.eu_444  cy.lv.sw_433 lg.zu.un_320
  0x06001f21, 0x181f2707, 0x3f0e08af, 0x6e001f14,   // cy.de.un_860 gd.cy.ga_432  no.is.af_655 cy.hmn.un_660
  // [1f50]
  0x10000707, 0x010825ad, 0x2329120c, 0x0d12040c,   // it.lt.un_420 eu.no.en_643  hu.sl.ca_543 fi.hu.cs_543
  0x1b005202, 0x552035a0, 0x3f030eee, 0x2164550c,   // ha.tr.un_220 zu.sq.rw_322  is.nl.af_422 rw.lg.jw_543
  0x04122a07, 0x012a1213, 0x1764520c, 0x060c135a,   // mt.hu.fi_432 hu.mt.en_665  ha.lg.sr_543 et.sv.de_553
  0x0a190b5a, 0x12000408, 0x04000a1a, 0x2b00060d,   // es.gl.pt_553 fi.hu.un_430  mk.ru.un_760 de.vi.un_540
  // [1f60]
  0x351a6b0b, 0x3b001308, 0x35286409, 0x25315204,   // ceb.tl.zu_542 et.so.un_430  lg.sw.zu_444 ha.az.eu_332
  0x0d1c135a, 0x1123070c, 0x20000612, 0x081a6b0b,   // bh.mr.ne_553 it.ca.ro_543  de.sq.un_640 ceb.tl.no_542
  0x17005502, 0x101f27ee, 0x3b000c0e, 0x35645504,   // rw.sr.un_220 gd.cy.lt_422  sv.so.un_550 rw.lg.zu_332
  0x53000c05, 0x1b256b05, 0x0a1711af, 0x13005208,   // sv.ht.un_330 ceb.eu.tr_333  ro.sr.mk_655 ha.et.un_430
  // [1f70]
  0x28641ea0, 0x2a103b0d, 0x170704a4, 0x644a27ad,   // ms.lg.sw_322 so.lt.mt_554  ru.bg.sr_433 gd.yo.lg_643
  0x3f003b05, 0x534a3ba4, 0x6b1a3b0b, 0x06255507,   // so.af.un_330 so.yo.ht_433  so.tl.ceb_542 rw.eu.de_432
  0x21005519, 0x3b002a04, 0x2b3108a0, 0x07100b08,   // rw.jw.un_750 mt.so.un_320  no.az.vi_322 es.lt.it_443
  0x101a5307, 0x52112a0c, 0x19120707, 0x29080ca9,   // ht.tl.lt_432 mt.ro.ha_543  it.hu.gl_432 sv.no.sl_544
  // [1f80]
  0x09001018, 0x050c2aa4, 0x642a0b08, 0x1a070aa4,   // lt.pl.un_740 mt.sv.fr_433  es.mt.lg_443 pt.it.tl_433
  0x08100aa4, 0x12684aad, 0x551e1c5a, 0x18016ba0,   // mk.be.uk_433 yo.ig.hu_643  id.ms.rw_553 ceb.en.ga_322
  0x6b2a07ee, 0x6410550c, 0x641a6b05, 0x0f00060d,   // it.mt.ceb_422 rw.lt.lg_543  ceb.tl.lg_333 de.lv.un_540
  0x3b641108, 0x01023ba0, 0x06001b12, 0x640c2a0c,   // ro.lg.so_443 so.da.en_322  tr.de.un_640 mt.sv.lg_543
  // [1f90]
  0x190a0ba9, 0x0a1110ad, 0x12233b07, 0x3f133b07,   // es.pt.gl_544 be.ro.mk_643  so.ca.hu_432 so.et.af_432
  0x1f0c0204, 0x0d002912, 0x07001008, 0x6b010304,   // da.sv.cy_332 sl.cs.un_640  lt.it.un_430 nl.en.ceb_332
  0x0c004a07, 0x102829a4, 0x0e002502, 0x290b07a7,   // yo.sv.un_420 sl.sw.lt_433  eu.is.un_220 it.es.sl_532
  0x12160d07, 0x190a6402, 0x3f03070c, 0x3b000908,   // cs.hr.hu_432 lg.pt.gl_222  it.nl.af_543 pl.so.un_430
  // [1fa0]
  0x170a10a6, 0x17000809, 0x040a11a0, 0x290d2d11,   // be.mk.sr_521 uk.sr.un_440  ro.mk.ru_322 sk.cs.sl_653
  0x00002506, 0x07081112, 0x100f1705, 0x250853a9,   // eu.un.un_400 ro.uk.bg_654  sr.lv.lt_333 ht.no.eu_544
  0x530d1004, 0x17101108, 0x12290da0, 0x0a001709,   // lt.cs.ht_332 ro.be.sr_443  cs.sl.hu_322 sr.mk.un_440
  0x0d00180d, 0x0b072907, 0x096b1f04, 0x1f3b550b,   // ga.cs.un_540 sl.it.es_432  cy.ceb.pl_332 rw.so.cy_542
  // [1fb0]
  0x6b000104, 0x2910070c, 0x02001305, 0x07291aa7,   // en.ceb.un_320 it.lt.sl_543  et.da.un_330 tl.sl.it_532
  0x04000819, 0x0d00020b, 0x35002808, 0x28001a04,   // uk.ru.un_750 da.cs.un_520  sw.zu.un_430 tl.sw.un_320
  0x2b000113, 0x1e1c3509, 0x06002a14, 0x1e4a6402,   // en.vi.un_650 zu.id.ms_444  mt.de.un_660 lg.yo.ms_222
  0x04001121, 0x1f272da4, 0x2100122b, 0x0e042a08,   // ro.ru.un_860 sk.gd.cy_433  ur.fa.un_980 mt.fi.is_443
  // [1fc0]
  0x122a070c, 0x070a11ad, 0x29002d22, 0x311b200c,   // it.mt.hu_543 ro.mk.bg_643  sk.sl.un_870 sq.tr.az_543
  0x066b1aee, 0x64001219, 0x1a106bad, 0x2a041208,   // tl.ceb.de_422 hu.lg.un_750  ceb.lt.tl_643 hu.fi.mt_443
  0x10080411, 0x05001a04, 0x55006404, 0x07000808,   // ru.uk.be_653 tl.fr.un_320  lg.rw.un_320 no.it.un_430
  0x28003b09, 0x03073fa0, 0x1200640d, 0x12001b08,   // so.sw.un_440 af.it.nl_322  lg.hu.un_540 tr.hu.un_430
  // [1fd0]
  0x11070aaf, 0x190a0bec, 0x13002011, 0x070305a0,   // mk.bg.ro_655 es.pt.gl_644  sq.et.un_630 fr.nl.it_322
  0x2d002909, 0x55281ca4, 0x0b002304, 0x3b312a0c,   // sl.sk.un_440 id.sw.rw_433  ca.es.un_320 mt.az.so_543
  0x2b001f07, 0x25000622, 0x08020112, 0x1a006b09,   // cy.vi.un_420 de.eu.un_870  en.da.no_654 ceb.tl.un_440
  0x3f002507, 0x0c000221, 0x04170813, 0x6b1a5214,   // eu.af.un_420 da.sv.un_860  uk.sr.ru_665 ha.tl.ceb_666
  // [1fe0]
  0x1b1a6ba4, 0x321603ec, 0x0c033f55, 0x052a01a0,   // ceb.tl.tr_433 nl.hr.bs_644  af.nl.sv_442 en.mt.fr_322
  0x3f2a0707, 0x2835640e, 0x3f080ca4, 0x2d00291a,   // it.mt.af_432 lg.zu.sw_555  sv.no.af_433 sl.sk.un_760
  0x251a6b12, 0x321b06ee, 0x0a001112, 0x0e3f4a0c,   // ceb.tl.eu_654 de.tr.bs_422  ro.mk.un_640 yo.af.is_543
  0x3b005322, 0x06006814, 0x060a23a4, 0x0a311b13,   // ht.so.un_870 ig.de.un_660  ca.pt.de_433 tr.az.pt_665
  // [1ff0]
  0x0c0e13a0, 0x09000104, 0x52310c07, 0x04521a04,   // et.is.sv_322 en.pl.un_320  sv.az.ha_432 tl.ha.fi_332
  0x321116a0, 0x06080c05, 0x3f042a0c, 0x0752290c,   // hr.ro.bs_322 sv.no.de_333  mt.fi.af_543 sl.ha.it_543
  0x1213040d, 0x10003207, 0x11521e0b, 0x0427180c,   // fi.et.hu_554 bs.lt.un_420  ms.ha.ro_542 ga.gd.fi_543
  0x52002512, 0x2a0f2813, 0x10000f0d, 0x3b0807a9,   // eu.ha.un_640 sw.lv.mt_665  lv.lt.un_540 it.no.so_544

  // [2000]
  0x29090dad, 0x55080213, 0x4a2718a4, 0x52002a1a,   // cs.pl.sl_643 da.no.rw_665  ga.gd.yo_433 mt.ha.un_760
  0x08024aee, 0x07001014, 0x6b081005, 0x040313a9,   // yo.da.no_422 be.bg.un_660  lt.no.ceb_333 et.nl.fi_544
  0x31005204, 0x20001704, 0x12001f05, 0x3f001a02,   // ha.az.un_320 sr.sq.un_320  cy.hu.un_330 tl.af.un_220
  0x060d3f0c, 0x1e181c0c, 0x2a00312a, 0x16006b08,   // af.cs.de_543 id.ga.ms_543  az.mt.un_970 ceb.hr.un_430
  // [2010]
  0x193f1f0c, 0x29121604, 0x4a16310c, 0x321607a4,   // cy.af.gl_543 hr.hu.sl_332  az.hr.yo_543 it.hr.bs_433
  0x09520d0b, 0x521807a4, 0x553564af, 0x11231905,   // cs.ha.pl_542 it.ga.ha_433  lg.zu.rw_655 gl.ca.ro_333
  0x312319a4, 0x1b0f6eee, 0x12114aa4, 0x13001e1a,   // gl.ca.az_433 hmn.lv.tr_422  yo.ro.hu_433 ms.et.un_760
  0x6b1a640c, 0x27251155, 0x051255ad, 0x08230560,   // lg.tl.ceb_543 ro.eu.gd_442  rw.hu.fr_643 fr.ca.no_664
  // [2020]
  0x21002505, 0x23122905, 0x55211e08, 0x08033f07,   // eu.jw.un_330 sl.hu.ca_333  ms.jw.rw_443 af.nl.no_432
  0x1f00100d, 0x1a646b12, 0x01000607, 0x0e130608,   // lt.cy.un_540 ceb.lg.tl_654  de.en.un_420 de.et.is_443
  0x0a04170c, 0x0e002a1a, 0x55001114, 0x05006e34,   // sr.ru.mk_543 mt.is.un_760  ro.rw.un_660 hmn.fr.un_A80
  0x0d0952a0, 0x23060512, 0x05002d04, 0x1709070c,   // ha.pl.cs_322 fr.de.ca_654  sk.fr.un_320 it.pl.sr_543
  // [2030]
  0x040e13ec, 0x21001a0d, 0x6e00231a, 0x3f1f0c04,   // et.is.fi_644 tl.jw.un_540  ca.hmn.un_760 sv.cy.af_332
  0x0a0155ee, 0x09072a08, 0x033568a9, 0x2535550c,   // rw.en.pt_422 mt.it.pl_443  ig.zu.nl_544 rw.zu.eu_543
  0x683b52ec, 0x18276eaf, 0x3f1b050c, 0x2504130c,   // ha.so.ig_644 hmn.gd.ga_655  fr.tr.af_543 et.fi.eu_543
  0x642555ee, 0x4a005205, 0x31206ea7, 0x31536407,   // rw.eu.lg_422 ha.yo.un_330  hmn.sq.az_532 lg.ht.az_432
  // [2040]
  0x031b5504, 0x2d0b29a4, 0x3f03190c, 0x53551c0b,   // rw.tr.nl_332 sl.es.sk_433  gl.nl.af_543 id.rw.ht_542
  0x21003f1b, 0x05006e11, 0x6b1a53a4, 0x033f52ee,   // af.jw.un_770 hmn.fr.un_630  ht.tl.ceb_433 ha.af.nl_422
  0x2a3555ad, 0x03003b08, 0x04071113, 0x13002821,   // rw.zu.mt_643 so.nl.un_430  ro.bg.ru_665 sw.et.un_860
  0x1108170c, 0x3b033fec, 0x3f212aac, 0x52286404,   // sr.uk.ro_543 af.nl.so_644  mt.jw.af_632 lg.sw.ha_332
  // [2050]
  0x52065512, 0x521e1fad, 0x1f1e1c12, 0x530c23ee,   // rw.de.ha_654 cy.ms.ha_643  id.ms.cy_654 ca.sv.ht_422
  0x2a002813, 0x08000e0d, 0x2b006e0c, 0x4a182dad,   // sw.mt.un_650 is.no.un_540  hmn.vi.un_530 sk.ga.yo_643
  0x130f0602, 0x06101fa9, 0x231301a0, 0x0e080707,   // de.lv.et_222 cy.lt.de_544  en.et.ca_322 it.no.is_432
  0x550c08a0, 0x06281fad, 0x10005208, 0x0717080c,   // no.sv.rw_322 cy.sw.de_643  ha.lt.un_430 uk.sr.bg_543
  // [2060]
  0x10004a05, 0x08070a0d, 0x1e1c10af, 0x07101708,   // yo.lt.un_330 mk.bg.uk_554  lt.id.ms_655 sr.be.bg_443
  0x0655520e, 0x00001f2d, 0x201b3112, 0x12004a09,   // ha.rw.de_555 cy.un.un_A00  az.tr.sq_654 yo.hu.un_440
  0x23001f1a, 0x08020da4, 0x4a6e6ba0, 0x1b162908,   // cy.ca.un_760 cs.da.no_433  ceb.hmn.yo_322 sl.hr.tr_443
  0x23111f13, 0x356420a4, 0x1b315504, 0x06001f1a,   // cy.ro.ca_665 sq.lg.zu_433  rw.az.tr_332 cy.de.un_760
  // [2070]
  0x3229170b, 0x5564130c, 0x2d000205, 0x311a280c,   // sr.sl.bs_542 et.lg.rw_543  da.sk.un_330 sw.tl.az_543
  0x2d0d0214, 0x1a001f1b, 0x1c0d09ad, 0x05013f07,   // da.cs.sk_666 cy.tl.un_770  hi.ne.mr_643 af.en.fr_432
  0x11170808, 0x1300040e, 0x64045512, 0x5200280d,   // uk.sr.ro_443 fi.et.un_550  rw.fi.lg_654 sw.ha.un_540
  0x13350460, 0x64292807, 0x101a130c, 0x64000a07,   // fi.zu.et_664 sw.sl.lg_432  et.tl.lt_543 pt.lg.un_420
  // [2080]
  0x68004a14, 0x0c033f04, 0x211e1f12, 0x52101fa4,   // yo.ig.un_660 af.nl.sv_332  cy.ms.jw_654 cy.lt.ha_433
  0x29351307, 0x02000c04, 0x2700180c, 0x551a6b12,   // et.zu.sl_432 sv.da.un_320  ga.gd.un_530 ceb.tl.rw_654
  0x0300270d, 0x3f062307, 0x6b060cad, 0x1c001e12,   // gd.nl.un_540 ca.de.af_432  sv.de.ceb_643 ms.id.un_640
  0x5535680c, 0x1e1c1f0c, 0x00003103, 0x2d090d12,   // ig.zu.rw_543 cy.id.ms_543  az.un.un_300 cs.pl.sk_654
  // [2090]
  0x0d033fa4, 0x10251fa7, 0x3f2821a0, 0x6b6801ee,   // af.nl.cs_433 cy.eu.lt_532  jw.sw.af_322 en.ig.ceb_422
  0x07080260, 0x08121b0c, 0x645228ac, 0x070411a6,   // da.no.it_664 tr.hu.no_543  sw.ha.lg_632 ro.ru.bg_521
  0x07170412, 0x092d3f08, 0x0a170805, 0x08020c05,   // ru.sr.bg_654 af.sk.pl_443  uk.sr.mk_333 sv.da.no_333
  0x190b2305, 0x18000713, 0x1b001313, 0x013b0ca0,   // ca.es.gl_333 it.ga.un_650  et.tr.un_650 sv.so.en_322
  // [20a0]
  0x1328350c, 0x2d2913ee, 0x041310a4, 0x17000a0e,   // zu.sw.et_543 et.sl.sk_422  lt.et.fi_433 mk.sr.un_550
  0x1f27180c, 0x13000108, 0x130c2aa4, 0x16321707,   // ga.gd.cy_543 en.et.un_430  mt.sv.et_433 sr.bs.hr_432
  0x10521aad, 0x04311304, 0x640813a4, 0x201801af,   // tl.ha.lt_643 et.az.fi_332  et.no.lg_433 en.ga.sq_655
  0x02006b04, 0x06002a0c, 0x01003104, 0x4a005504,   // ceb.da.un_320 mt.de.un_530  az.en.un_320 rw.yo.un_320
  // [20b0]
  0x64005507, 0x1e006b05, 0x061f08a4, 0x2800351a,   // rw.lg.un_420 ceb.ms.un_330  no.cy.de_433 zu.sw.un_760
  0x1a003512, 0x063f0308, 0x55284aa7, 0x1c132a10,   // zu.tl.un_640 nl.af.de_443  yo.sw.rw_532 mt.et.id_642
  0x1f3f2aa0, 0x091b3fa0, 0x35005202, 0x18211209,   // mt.af.cy_322 af.tr.pl_322  ha.zu.un_220 ur.fa.ar_444
  0x0f003f05, 0x2a1b53a0, 0x64321604, 0x07170aaf,   // af.lv.un_330 ht.tr.mt_322  hr.bs.lg_332 mk.sr.bg_655
  // [20c0]
  0x1b11530c, 0x2a1b08a4, 0x0e070807, 0x1e1c64a9,   // ht.ro.tr_543 no.tr.mt_433  no.it.is_432 lg.id.ms_544
  0x3500680c, 0x645528ee, 0x230a05ec, 0x3b125355,   // ig.zu.un_530 sw.rw.lg_422  fr.pt.ca_644 ht.hu.so_442
  0x1c641eaf, 0x1e1c640c, 0x072a1fee, 0x532a11a4,   // ms.lg.id_655 lg.id.ms_543  cy.mt.it_422 ro.mt.ht_433
  0x35123b05, 0x64551c07, 0x2d000b04, 0x1e1c55a0,   // so.hu.zu_333 id.rw.lg_432  es.sk.un_320 rw.id.ms_322
  // [20d0]
  0x091e1c08, 0x13000304, 0x4a00211a, 0x211a55a4,   // id.ms.pl_443 nl.et.un_320  jw.yo.un_760 rw.tl.jw_433
  0x0000282d, 0x0d130913, 0x012a6ea0, 0x64005523,   // sw.un.un_A00 hi.bh.ne_665  hmn.mt.en_322 rw.lg.un_880
  0x13090da4, 0x1a556b08, 0x170a04ad, 0x08000c02,   // ne.hi.bh_433 ceb.rw.tl_443  ru.mk.sr_643 sv.no.un_220
  0x0c000708, 0x06040312, 0x53052aa0, 0x04131a07,   // it.sv.un_430 nl.fi.de_654  mt.fr.ht_322 tl.et.fi_432
  // [20e0]
  0x0c0308a0, 0x0b00250c, 0x3500280c, 0x033f2aee,   // no.nl.sv_322 eu.es.un_530  sw.zu.un_530 mt.af.nl_422
  0x0e080c04, 0x082502a0, 0x200f1009, 0x3564550c,   // sv.no.is_332 da.eu.no_322  lt.lv.sq_444 rw.lg.zu_543
  0x08092a07, 0x0d1c09af, 0x6b6803a4, 0x1e1c55a4,   // mt.pl.no_432 hi.mr.ne_655  nl.ig.ceb_433 rw.id.ms_433
  0x111b31af, 0x1700200c, 0x1255640c, 0x070a01a4,   // az.tr.ro_655 sq.sr.un_530  lg.rw.hu_543 en.pt.it_433
  // [20f0]
  0x0e000c04, 0x5509680d, 0x1c090d13, 0x1c0d13af,   // sv.is.un_320 ig.pl.rw_554  ne.hi.mr_665 bh.ne.mr_655
  0x1c551e0c, 0x07130455, 0x0f002d13, 0x041b310d,   // ms.rw.id_543 fi.et.it_442  sk.lv.un_650 az.tr.fi_554
  0x1b11290c, 0x16321711, 0x1e1c55ec, 0x531b3160,   // sl.ro.tr_543 sr.bs.hr_653  rw.id.ms_644 az.tr.ht_664
  0x1e641c0c, 0x1828090c, 0x23001e13, 0x02041304,   // id.lg.ms_543 pl.sw.ga_543  ms.ca.un_650 et.fi.da_332
  // [2100]
  0x55006b11, 0x29092dad, 0x1c5221a0, 0x0a000422,   // ceb.rw.un_630 sk.pl.sl_643  jw.ha.id_322 ru.mk.un_870
  0x55000104, 0x1f001221, 0x20002902, 0x6b6853a4,   // en.rw.un_320 hu.cy.un_860  sl.sq.un_220 ht.ig.ceb_433
  0x066b1a07, 0x170a07ee, 0x19211fa4, 0x2d3b1108,   // tl.ceb.de_432 bg.mk.sr_422  cy.jw.gl_433 ro.so.sk_443
  0x012a07ad, 0x17040855, 0x1f002b1b, 0x3f020ea4,   // it.mt.en_643 uk.ru.sr_442  vi.cy.un_770 is.da.af_433
  // [2110]
  0x2a1118ee, 0x2b001f0d, 0x2b002302, 0x0c005302,   // ga.ro.mt_422 cy.vi.un_540  ca.vi.un_220 ht.sv.un_220
  0x291b0ba4, 0x1f3b3f12, 0x31091b12, 0x31000707,   // es.tr.sl_433 af.so.cy_654  tr.pl.az_654 it.az.un_420
  0x100a0709, 0x64012704, 0x0c1b3108, 0x113129a0,   // bg.mk.be_444 gd.en.lg_332  az.tr.sv_443 sl.az.ro_322
  0x113b0f07, 0x0c530802, 0x23072da4, 0x53005214,   // lv.so.ro_432 no.ht.sv_222  sk.it.ca_433 ha.ht.un_660
  // [2120]
  0x080e0c02, 0x013153ee, 0x18052709, 0x1a126bec,   // sv.is.no_222 ht.az.en_422  gd.fr.ga_444 ceb.hu.tl_644
  0x05533b05, 0x04130c05, 0x12002a05, 0x08000c05,   // so.ht.fr_333 sv.et.fi_333  mt.hu.un_330 sv.no.un_330
  0x1c00130b, 0x10020caf, 0x55531fa7, 0x18002707,   // bh.mr.un_520 sv.da.lt_655  cy.ht.rw_532 gd.ga.un_420
  0x070811ad, 0x060a1ba4, 0x100a08a4, 0x06052304,   // ro.uk.bg_643 tr.pt.de_433  uk.mk.be_433 ca.fr.de_332
  // [2130]
  0x2704180c, 0x12001309, 0x0a001912, 0x08001008,   // ga.fi.gd_543 et.hu.un_440  gl.pt.un_640 be.uk.un_430
  0x0400170e, 0x2555640c, 0x09061f0d, 0x55296405,   // sr.ru.un_550 lg.rw.eu_543  cy.de.pl_554 lg.sl.rw_333
  0x08000411, 0x110817a4, 0x03173fa0, 0x0e0802ad,   // ru.uk.un_630 sr.uk.ro_433  af.sr.nl_322 da.no.is_643
  0x0a2d0d0e, 0x110a07a4, 0x041107ec, 0x111e1c0d,   // cs.sk.pt_555 bg.mk.ro_433  bg.ro.ru_644 id.ms.ro_554
  // [2140]
  0x0c2301a4, 0x0a230611, 0x28006419, 0x0900200e,   // en.ca.sv_433 de.ca.pt_653  lg.sw.un_750 sq.pl.un_550
  0x320917a4, 0x1f003b13, 0x64550705, 0x010653a0,   // sr.pl.bs_433 so.cy.un_650  it.rw.lg_333 ht.de.en_322
  0x09290da4, 0x1103250c, 0x05001c02, 0x352011a4,   // cs.sl.pl_433 eu.nl.ro_543  id.fr.un_220 ro.sq.zu_433
  0x5201050d, 0x0a080708, 0x254a11a7, 0x0c0552a0,   // fr.en.ha_554 bg.uk.mk_443  ro.yo.eu_532 ha.fr.sv_322
  // [2150]
  0x16066855, 0x280a520c, 0x2d0d11a4, 0x022a070c,   // ig.de.hr_442 ha.pt.sw_543  ro.cs.sk_433 it.mt.da_543
  0x0a04100c, 0x08070aa4, 0x6b2707ad, 0x080e0c07,   // be.ru.mk_543 mk.bg.uk_433  it.gd.ceb_643 sv.is.no_432
  0x092d0d12, 0x213f1c07, 0x18012504, 0x033f0ca0,   // cs.sk.pl_654 id.af.jw_432  eu.en.ga_332 sv.af.nl_322
  0x10040809, 0x1132165a, 0x3f192707, 0x0a292d07,   // uk.ru.be_444 hr.bs.ro_553  gd.gl.af_432 sk.sl.pt_432
  // [2160]
  0x171b2107, 0x1b001804, 0x0f043202, 0x12553b08,   // jw.tr.sr_432 ga.tr.un_320  bs.fi.lv_222 so.rw.hu_443
  0x215564ad, 0x01113507, 0x353f0313, 0x11072da4,   // lg.rw.jw_643 zu.ro.en_432  nl.af.zu_665 sk.it.ro_433
  0x1c002104, 0x64552812, 0x0700521b, 0x1e001f2a,   // jw.id.un_320 sw.rw.lg_654  ha.it.un_770 cy.ms.un_970
  0x1c003f04, 0x171625ee, 0x0e023fa0, 0x021e1c02,   // af.id.un_320 eu.hr.sr_422  af.da.is_322 id.ms.da_222
  // [2170]
  0x35000307, 0x08023fa4, 0x1c1b29ee, 0x0e0c120c,   // nl.zu.un_420 af.da.no_433  sl.tr.id_422 hu.sv.is_543
  0x25182713, 0x1a35550c, 0x03002707, 0x290d1baf,   // gd.ga.eu_665 rw.zu.tl_543  gd.nl.un_420 tr.cs.sl_655
  0x01052aa4, 0x32003b05, 0x01000907, 0x21004a07,   // mt.fr.en_433 so.bs.un_330  pl.en.un_420 yo.jw.un_420
  0x201f55a4, 0x09251108, 0x0a0710a4, 0x20253b05,   // rw.cy.sq_433 ro.eu.pl_443  be.bg.mk_433 so.eu.sq_333
  // [2180]
  0x09002a0e, 0x21001205, 0x050602a0, 0x0d05010c,   // mt.pl.un_550 ur.fa.un_330  da.de.fr_322 en.fr.cs_543
  0x0e231e04, 0x07001823, 0x06353f0c, 0x033f0f0c,   // ms.ca.is_332 ga.it.un_880  af.zu.de_543 lv.af.nl_543
  0x252868a7, 0x0b00110b, 0x2d006e0e, 0x0e53040c,   // ig.sw.eu_532 ro.es.un_520  hmn.sk.un_550 fi.ht.is_543
  0x1000111a, 0x531e1ca9, 0x1b356412, 0x12035204,   // ro.be.un_760 id.ms.ht_544  lg.zu.tr_654 ha.nl.hu_332
  // [2190]
  0x12002102, 0x2d000d2a, 0x4a311b11, 0x5535210c,   // jw.hu.un_220 cs.sk.un_970  tr.az.yo_653 jw.zu.rw_543
  0x3500190e, 0x106b1a11, 0x13640e09, 0x214a1aad,   // gl.zu.un_550 tl.ceb.lt_653  is.lg.et_444 tl.yo.jw_643
  0x28553512, 0x28291905, 0x02006809, 0x27071f0c,   // zu.rw.sw_654 gl.sl.sw_333  ig.da.un_440 cy.it.gd_543
  0x09002d12, 0x2d093bec, 0x061b03ad, 0x2d0d29af,   // sk.pl.un_640 so.pl.sk_644  nl.tr.de_643 sl.cs.sk_655
  // [21a0]
  0x17110704, 0x1c2b0307, 0x09003204, 0x06002509,   // bg.ro.sr_332 nl.vi.id_432  bs.pl.un_320 eu.de.un_440
  0x0d321608, 0x0f020807, 0x08006b0e, 0x3b4a3fad,   // hr.bs.cs_443 no.da.lv_432  ceb.no.un_550 af.yo.so_643
  0x1007110c, 0x09002d19, 0x04001908, 0x53000b04,   // ro.bg.be_543 sk.pl.un_750  gl.fi.un_430 es.ht.un_320
  0x040a2108, 0x0c000819, 0x07001709, 0x32171309,   // jw.pt.fi_443 no.sv.un_750  sr.bg.un_440 et.sr.bs_444
  // [21b0]
  0x28351c07, 0x250d2a07, 0x0655645a, 0x52082aa0,   // id.zu.sw_432 mt.cs.eu_432  lg.rw.de_553 mt.no.ha_322
  0x0c000e08, 0x06680312, 0x0f2852a0, 0x0c000e1b,   // is.sv.un_430 nl.ig.de_654  ha.sw.lv_322 is.sv.un_770
  0x10002108, 0x10090f0c, 0x28121b05, 0x100f32a0,   // jw.lt.un_430 lv.pl.lt_543  tr.hu.sw_333 bs.lv.lt_322
  0x07130411, 0x32000708, 0x20321607, 0x05005308,   // fi.et.it_653 it.bs.un_430  hr.bs.sq_432 ht.fr.un_430
  // [21c0]
  0x08040ea7, 0x25192305, 0x292d1604, 0x210435ec,   // is.fi.no_532 ca.gl.eu_333  hr.sk.sl_332 zu.fi.jw_644
  0x52642a07, 0x0f2d0d04, 0x32171611, 0x3b005204,   // mt.lg.ha_432 cs.sk.lv_332  hr.sr.bs_653 ha.so.un_320
  0x1a256bee, 0x6b251ca0, 0x08042aad, 0x0c040807,   // ceb.eu.tl_422 id.eu.ceb_322  mt.fi.no_643 no.fi.sv_432
  0x03001608, 0x1f27010c, 0x64005511, 0x3b3f030e,   // hr.nl.un_430 en.gd.cy_543  rw.lg.un_630 nl.af.so_555
  // [21d0]
  0x13040514, 0x2d0d1605, 0x1000081b, 0x0800010d,   // fr.fi.et_666 hr.cs.sk_333  uk.be.un_770 en.no.un_540
  0x1e4a6812, 0x090d2d11, 0x35551e0c, 0x18002111,   // ig.yo.ms_654 sk.cs.pl_653  ms.rw.zu_543 fa.ar.un_630
  0x130c04a4, 0x131064ee, 0x042a0713, 0x0c130ea9,   // fi.sv.et_433 lg.lt.et_422  it.mt.fi_665 is.et.sv_544
  0x13001707, 0x060364a0, 0x2d0c0d55, 0x1221180c,   // sr.et.un_420 lg.nl.de_322  cs.sv.sk_442 ar.fa.ur_543
  // [21e0]
  0x100f1e07, 0x2d0d2aee, 0x040901a4, 0x0d091c11,   // ms.lv.lt_432 mt.cs.sk_422  en.pl.fi_433 mr.hi.ne_653
  0x0e645511, 0x1c002108, 0x0c050707, 0x3b002a02,   // rw.lg.is_653 jw.id.un_430  it.fr.sv_432 mt.so.un_220
  0x64041311, 0x211e1cac, 0x3b6455ad, 0x0531010c,   // et.fi.lg_653 id.ms.jw_632  rw.lg.so_643 en.az.fr_543
  0x0e06180c, 0x64685512, 0x3f120205, 0x13000d07,   // ga.de.is_543 rw.ig.lg_654  da.hu.af_333 ne.bh.un_420
  // [21f0]
  0x3f13080c, 0x13001b18, 0x0e000419, 0x0c0102a0,   // no.et.af_543 tr.et.un_740  fi.is.un_750 da.en.sv_322
  0x08040a14, 0x09001f0d, 0x1000041a, 0x0e101b08,   // mk.ru.uk_666 cy.pl.un_540  ru.be.un_760 tr.lt.is_443
  0x01281fee, 0x2b004a23, 0x07040c08, 0x0c000e07,   // cy.sw.en_422 yo.vi.un_880  sv.fi.it_443 is.sv.un_420
  0x07682107, 0x27000b04, 0x4a2b2713, 0x3b190b55,   // jw.ig.it_432 es.gd.un_320  gd.vi.yo_665 es.gl.so_442
  // [2200]
  0x271f29a4, 0x23312504, 0x35002802, 0x12000c13,   // sl.cy.gd_433 eu.az.ca_332  sw.zu.un_220 sv.hu.un_650
  0x11231f0c, 0x3100230e, 0x27002b21, 0x091c0d0e,   // cy.ca.ro_543 ca.az.un_550  vi.gd.un_860 ne.mr.hi_555
  0x19072508, 0x0a0411ee, 0x2b002714, 0x55250e0c,   // eu.it.gl_443 ro.ru.mk_422  gd.vi.un_660 is.eu.rw_543
  0x08000b07, 0x551c2108, 0x28003205, 0x553b6404,   // es.no.un_420 jw.id.rw_443  bs.sw.un_330 lg.so.rw_332
  // [2210]
  0x060355a9, 0x532925a0, 0x353f080c, 0x3b64130c,   // rw.nl.de_544 eu.sl.ht_322  no.af.zu_543 et.lg.so_543
  0x0f28090b, 0x17190b05, 0x190b0a04, 0x1100270e,   // pl.sw.lv_542 es.gl.sr_333  pt.es.gl_332 gd.ro.un_550
  0x081710a0, 0x19170a05, 0x202d35a4, 0x1a006b1a,   // be.sr.uk_322 pt.sr.gl_333  zu.sk.sq_433 ceb.tl.un_760
  0x2b004a1b, 0x091f12ad, 0x02001904, 0x0a171005,   // yo.vi.un_770 hu.cy.pl_643  gl.da.un_320 be.sr.mk_333
  // [2220]
  0x520425a0, 0x6428550d, 0x0452530c, 0x64003b08,   // eu.fi.ha_322 rw.sw.lg_554  ht.ha.fi_543 so.lg.un_430
  0x531109a4, 0x3f070fa4, 0x13001817, 0x4a002b14,   // pl.ro.ht_433 lv.it.af_433  ga.et.un_730 vi.yo.un_660
  0x35556ba0, 0x1b312aa4, 0x10020f05, 0x3f001902,   // ceb.rw.zu_322 mt.az.tr_433  lv.da.lt_333 gl.af.un_220
  0x092855ad, 0x19091fa4, 0x12006b08, 0x0802250c,   // rw.sw.pl_643 cy.pl.gl_433  ceb.hu.un_430 eu.da.no_543
  // [2230]
  0x290723a0, 0x03001212, 0x03112705, 0x12000921,   // ca.it.sl_322 hu.nl.un_640  gd.ro.nl_333 pl.hu.un_860
  0x20116e08, 0x036455a4, 0x1700190e, 0x190b1fa4,   // hmn.ro.sq_443 rw.lg.nl_433  gl.sr.un_550 cy.es.gl_433
  0x3f00551a, 0x170f3502, 0x1c090d12, 0x1f190b0c,   // rw.af.un_760 zu.lv.sr_222  ne.hi.mr_654 es.gl.cy_543
  0x282d4aad, 0x056b1104, 0x1b001112, 0x18120805,   // yo.sk.sw_643 ro.ceb.fr_332  ro.tr.un_640 no.hu.ga_333
  // [2240]
  0x04080705, 0x033f0aa6, 0x0400531a, 0x1b0804ee,   // bg.uk.ru_333 pt.af.nl_521  ht.fi.un_760 fi.no.tr_422
  0x10000714, 0x0f5304ee, 0x0500531a, 0x6b1b0805,   // bg.be.un_660 fi.ht.lv_422  ht.fr.un_760 no.tr.ceb_333
  0x0a0553ad, 0x35001319, 0x52190b02, 0x5300052b,   // ht.fr.pt_643 et.zu.un_750  es.gl.ha_222 fr.ht.un_980
  0x04060c04, 0x10004a04, 0x011606a0, 0x1b1911a7,   // sv.de.fi_332 yo.lt.un_320  de.hr.en_322 ro.gl.tr_532
  // [2250]
  0x25001f0c, 0x0e2a0708, 0x05005322, 0x53000807,   // cy.eu.un_530 it.mt.is_443  ht.fr.un_870 no.ht.un_420
  0x29002108, 0x17000805, 0x4a006407, 0x090d1c05,   // jw.sl.un_430 uk.sr.un_330  lg.yo.un_420 mr.ne.hi_333
  0x01072aa0, 0x190b01af, 0x0f00201a, 0x0c000204,   // mt.it.en_322 en.es.gl_655  sq.lv.un_760 da.sv.un_320
  0x4a000104, 0x0f3217a4, 0x080c2aa4, 0x3f0c08a4,   // en.yo.un_320 sr.bs.lv_433  mt.sv.no_433 no.sv.af_433
  // [2260]
  0x020c3fee, 0x131c09ad, 0x0a110708, 0x0d530514,   // af.sv.da_422 hi.mr.bh_643  bg.ro.mk_443 fr.ht.cs_666
  0x53000523, 0x0c3f0309, 0x25004a07, 0x0508025a,   // fr.ht.un_880 nl.af.sv_444  yo.eu.un_420 da.no.fr_553
  0x6b553505, 0x2a1b13ee, 0x200e0608, 0x1600060c,   // zu.rw.ceb_333 et.tr.mt_422  de.is.sq_443 de.hr.un_530
  0x020c0804, 0x08000202, 0x3f006b08, 0x1f033f0d,   // no.sv.da_332 da.no.un_220  ceb.af.un_430 af.nl.cy_554
  // [2270]
  0x0e00100c, 0x3b2a6b07, 0x641055a4, 0x2d1f0ba0,   // lt.is.un_530 ceb.mt.so_432  rw.lt.lg_433 es.cy.sk_322
  0x1a0e2112, 0x1a1031ad, 0x17001111, 0x200e06a7,   // jw.is.tl_654 az.lt.tl_643  ro.sr.un_630 de.is.sq_532
  0x356b1a12, 0x131c09af, 0x091f0e07, 0x0135640c,   // tl.ceb.zu_654 hi.mr.bh_655  is.cy.pl_432 lg.zu.en_543
  0x13080ca4, 0x0e000b02, 0x2a32165a, 0x0704050c,   // sv.no.et_433 es.is.un_220  hr.bs.mt_553 fr.fi.it_543
  // [2280]
  0x0c080209, 0x1b53520c, 0x21531ca0, 0x3228550c,   // da.no.sv_444 ha.ht.tr_543  id.ht.jw_322 rw.sw.bs_543
  0x10002d0d, 0x0a1707ee, 0x0c081207, 0x35282a02,   // sk.lt.un_540 bg.sr.mk_422  hu.no.sv_432 mt.sw.zu_222
  0x286425a0, 0x20070460, 0x13122a04, 0x08645512,   // eu.lg.sw_322 fi.it.sq_664  mt.hu.et_332 rw.lg.no_654
  0x0c002a07, 0x5235640b, 0x080711a4, 0x020c0812,   // mt.sv.un_420 lg.zu.ha_542  ro.bg.uk_433 no.sv.da_654
  // [2290]
  0x553564a4, 0x0f291b0b, 0x1b081307, 0x2a000c0b,   // lg.zu.rw_433 tr.sl.lv_542  et.no.tr_432 sv.mt.un_520
  0x12004a04, 0x532555a9, 0x04080760, 0x040613a4,   // yo.hu.un_320 rw.eu.ht_544  bg.uk.ru_664 et.de.fi_433
  0x060c0e12, 0x55282308, 0x3f006e04, 0x6400282a,   // is.sv.de_654 ca.sw.rw_443  hmn.af.un_320 sw.lg.un_970
  0x081710a4, 0x07190b04, 0x1c13090c, 0x1700112a,   // be.sr.uk_433 es.gl.it_332  hi.bh.mr_543 ro.sr.un_970
  // [22a0]
  0x11190a04, 0x0200052b, 0x25080e07, 0x1a5564af,   // pt.gl.ro_332 fr.da.un_980  is.no.eu_432 lg.rw.tl_655
  0x25280ea0, 0x08060e0d, 0x52555308, 0x070417af,   // is.sw.eu_322 is.de.no_554  ht.rw.ha_443 sr.ru.bg_655
  0x080c0260, 0x645235ad, 0x535535a0, 0x25001304,   // da.sv.no_664 zu.ha.lg_643  zu.rw.ht_322 et.eu.un_320
  0x53000708, 0x09050407, 0x130e0c04, 0x18000419,   // it.ht.un_430 fi.fr.pl_432  sv.is.et_332 fi.ga.un_750
  // [22b0]
  0x0d001c0b, 0x11004a0c, 0x05000413, 0x04003508,   // mr.ne.un_520 yo.ro.un_530  fi.fr.un_650 zu.fi.un_430
  0x522a6bad, 0x041305af, 0x273b3fee, 0x1100081a,   // ceb.mt.ha_643 fr.et.fi_655  af.so.gd_422 uk.ro.un_760
  0x0c083f04, 0x05000412, 0x03080255, 0x6400350e,   // af.no.sv_332 fi.fr.un_640  da.no.nl_442 zu.lg.un_550
  0x03061307, 0x05003f1a, 0x1153290c, 0x1f000d04,   // et.de.nl_432 af.fr.un_760  sl.ht.ro_543 cs.cy.un_320
  // [22c0]
  0x031306a4, 0x08023f0e, 0x040e1307, 0x0a110107,   // de.et.nl_433 af.da.no_555  et.is.fi_432 en.ro.pt_432
  0x115308a9, 0x07050112, 0x23004a08, 0x050208a4,   // no.ht.ro_544 en.fr.it_654  yo.ca.un_430 no.da.fr_433
  0x050a3b12, 0x2a0507ec, 0x06000823, 0x041110a4,   // so.pt.fr_654 it.fr.mt_644  no.de.un_880 be.ro.ru_433
  0x080c0255, 0x04006807, 0x0c010eee, 0x6b0c0812,   // da.sv.no_442 ig.fi.un_420  is.en.sv_422 no.sv.ceb_654
  // [22d0]
  0x1708105a, 0x321b0e0b, 0x0410080c, 0x0a080205,   // be.uk.sr_553 is.tr.bs_542  uk.be.ru_543 da.no.pt_333
  0x3f0308ac, 0x6e00090b, 0x29040da0, 0x041305a4,   // no.nl.af_632 pl.hmn.un_520  cs.fi.sl_322 fr.et.fi_433
  0x0b2319a0, 0x28130455, 0x21552804, 0x00000937,   // gl.ca.es_322 fi.et.sw_442  sw.rw.jw_332 hi.un.un_B00
  0x04080205, 0x6e016b04, 0x1f001320, 0x07000822,   // da.no.fi_333 ceb.en.hmn_332  et.cy.un_850 uk.bg.un_870
  // [22e0]
  0x07231108, 0x535528ad, 0x3f1f0212, 0x02030e07,   // ro.ca.it_443 sw.rw.ht_643  da.cy.af_654 is.nl.da_432
  0x53002b0d, 0x17162d05, 0x1b003514, 0x01000f0b,   // vi.ht.un_540 sk.hr.sr_333  zu.tr.un_660 lv.en.un_520
  0x1e271ca0, 0x21521e04, 0x04170805, 0x18003514,   // id.gd.ms_322 ms.ha.jw_332  uk.sr.ru_333 zu.ga.un_660
  0x2818270c, 0x04081fee, 0x09291b55, 0x04170aa6,   // gd.ga.sw_543 cy.no.fi_422  tr.sl.pl_442 mk.sr.ru_521
  // [22f0]
  0x10001112, 0x016b3507, 0x213f0311, 0x0a000419,   // ro.be.un_640 zu.ceb.en_432  nl.af.jw_653 ru.mk.un_750
  0x1a0953a0, 0x27005204, 0x0a1011a4, 0x1f292d55,   // ht.pl.tl_322 ha.gd.un_320  ro.be.mk_433 sk.sl.cy_442
  0x31001b0d, 0x1b6b1a08, 0x080717a4, 0x0d292d07,   // tr.az.un_540 tl.ceb.tr_443  sr.bg.uk_433 sk.sl.cs_432
  0x1c005502, 0x041708a9, 0x1b532108, 0x3110110c,   // rw.id.un_220 uk.sr.ru_544  jw.ht.tr_443 ro.lt.az_543
  // [2300]
  0x040717a9, 0x3f1c03a4, 0x01000f0c, 0x1c130909,   // sr.bg.ru_544 nl.id.af_433  lv.en.un_530 hi.bh.mr_444
  0x290d2dec, 0x27001808, 0x04000813, 0x28001808,   // sk.cs.sl_644 ga.gd.un_430  uk.ru.un_650 ga.sw.un_430
  0x1e2d1c0c, 0x120a2304, 0x2d0d17a0, 0x180e1fa7,   // id.sk.ms_543 ca.pt.hu_332  sr.cs.sk_322 cy.is.ga_532
  0x1c181ea4, 0x09553ba9, 0x0a001721, 0x0d0913a7,   // ms.ga.id_433 so.rw.pl_544  sr.mk.un_860 bh.hi.ne_532
  // [2310]
  0x0e000c05, 0x1c00090b, 0x29120312, 0x2d1129a7,   // sv.is.un_330 hi.mr.un_520  nl.hu.sl_654 sl.ro.sk_532
  0x530a1108, 0x1b002d04, 0x20002a13, 0x0e120ca9,   // ro.pt.ht_443 sk.tr.un_320  mt.sq.un_650 sv.hu.is_544
  0x04110708, 0x01001f05, 0x1704070b, 0x09001607,   // bg.ro.ru_443 cy.en.un_330  bg.ru.sr_542 hr.pl.un_420
  0x051a3555, 0x03013f02, 0x23000a23, 0x09011f04,   // zu.tl.fr_442 af.en.nl_222  pt.ca.un_880 cy.en.pl_332
  // [2320]
  0x00000e06, 0x23050b07, 0x2b001e08, 0x211c1eee,   // is.un.un_400 es.fr.ca_432  ms.vi.un_430 ms.id.jw_422
  0x190a6b02, 0x041008ec, 0x1f1118af, 0x180c06ad,   // ceb.pt.gl_222 uk.be.ru_644  ga.ro.cy_655 de.sv.ga_643
  0x11000414, 0x2d0d1602, 0x0e000612, 0x4a000512,   // ru.ro.un_660 hr.cs.sk_222  de.is.un_640 fr.yo.un_640
  0x130306ad, 0x3f000a08, 0x033f0613, 0x0c000822,   // de.nl.et_643 pt.af.un_430  de.af.nl_665 no.sv.un_870
  // [2330]
  0x3100530e, 0x0100060b, 0x6b3f0212, 0x29000313,   // ht.az.un_550 de.en.un_520  da.af.ceb_654 nl.sl.un_650
  0x1b002a0c, 0x0c0217a4, 0x190b0aec, 0x10000913,   // mt.tr.un_530 sr.da.sv_433  pt.es.gl_644 pl.lt.un_650
  0x10000f23, 0x13643b07, 0x210b075a, 0x21000105,   // lv.lt.un_880 so.lg.et_432  it.es.jw_553 en.jw.un_330
  0x53000713, 0x20002b14, 0x0a2319ee, 0x04071111,   // it.ht.un_650 vi.sq.un_660  gl.ca.pt_422 ro.bg.ru_653
  // [2340]
  0x0b112da4, 0x040a08a9, 0x0d001312, 0x25521f13,   // sk.ro.es_433 uk.mk.ru_544  bh.ne.un_640 cy.ha.eu_665
  0x08041709, 0x0a133f04, 0x1e1c1902, 0x01080205,   // sr.ru.uk_444 af.et.pt_332  gl.id.ms_222 da.no.en_333
  0x0a110f0c, 0x0a000719, 0x07001904, 0x06021ea9,   // lv.ro.pt_543 bg.mk.un_750  gl.it.un_320 ms.da.de_544
  0x08030555, 0x21001a08, 0x4a1f5307, 0x091253ee,   // fr.nl.no_442 tl.jw.un_430  ht.cy.yo_432 ht.hu.pl_422
  // [2350]
  0x080212af, 0x0f0410af, 0x00001b2d, 0x071704ec,   // hu.da.no_655 lt.fi.lv_655  tr.un.un_A00 ru.sr.bg_644
  0x17002919, 0x10001707, 0x53190a13, 0x08041055,   // sl.sr.un_750 sr.lt.un_420  pt.gl.ht_665 be.ru.uk_442
  0x09002a08, 0x19000a0b, 0x07002a1a, 0x201953a9,   // mt.pl.un_430 pt.gl.un_520  mt.it.un_760 ht.gl.sq_544
  0x01001f19, 0x32001712, 0x2d001907, 0x0f001119,   // cy.en.un_750 sr.bs.un_640  gl.sk.un_420 ro.lv.un_750
  // [2360]
  0x0a0125a0, 0x1c1e1b0d, 0x1e1c2d0c, 0x0a001904,   // eu.en.pt_322 tr.ms.id_554  sk.id.ms_543 gl.pt.un_320
  0x64000a04, 0x0a553509, 0x0e00350d, 0x1c000711,   // pt.lg.un_320 zu.rw.pt_444  zu.is.un_540 it.id.un_630
  0x29321608, 0x10352d0c, 0x1c006804, 0x0f1004a7,   // hr.bs.sl_443 sk.zu.lt_543  ig.id.un_320 fi.lt.lv_532
  0x0e0608ec, 0x3f0e1c04, 0x111b1211, 0x20002307,   // no.de.is_644 id.is.af_332  hu.tr.ro_653 ca.sq.un_420
  // [2370]
  0x13003513, 0x1b644a13, 0x203f0107, 0x101304a6,   // zu.et.un_650 yo.lg.tr_665  en.af.sq_432 fi.et.lt_521
  0x1a3f03ee, 0x1b053b05, 0x2d132905, 0x210a06ee,   // nl.af.tl_422 so.fr.tr_333  sl.et.sk_333 de.pt.jw_422
  0x03173f02, 0x06003f21, 0x0100110c, 0x10211aa9,   // af.sr.nl_222 af.de.un_860  ro.en.un_530 tl.jw.lt_544
  0x0d002d0b, 0x0d003519, 0x08001119, 0x2d0a0da4,   // sk.cs.un_520 zu.cs.un_750  ro.uk.un_750 cs.pt.sk_433
  // [2380]
  0x12002312, 0x0a2d190c, 0x06020811, 0x1c020f55,   // ca.hu.un_640 gl.sk.pt_543  no.da.de_653 lv.da.id_442
  0x21001811, 0x2100120c, 0x1708040c, 0x071b010c,   // ar.fa.un_630 ur.fa.un_530  ru.uk.sr_543 en.tr.it_543
  0x35001e08, 0x68553513, 0x25190ba7, 0x130411ec,   // ms.zu.un_430 zu.rw.ig_665  es.gl.eu_532 ro.fi.et_644
  0x0d001c1a, 0x1b13040c, 0x01210cee, 0x2a000a07,   // mr.ne.un_760 fi.et.tr_543  sv.jw.en_422 pt.mt.un_420
  // [2390]
  0x4a251b07, 0x06020c05, 0x06000d13, 0x643523ec,   // tr.eu.yo_432 sv.da.de_333  cs.de.un_650 ca.zu.lg_644
  0x1220130c, 0x08000e0e, 0x68006422, 0x20002d04,   // et.sq.hu_543 is.no.un_550  lg.ig.un_870 sk.sq.un_320
  0x130b0c05, 0x2b553504, 0x080c0313, 0x1a3564a9,   // sv.es.et_333 zu.rw.vi_332  nl.sv.no_665 lg.zu.tl_544
  0x0f132907, 0x072d0d55, 0x03083f08, 0x29002d0d,   // sl.et.lv_432 cs.sk.it_442  af.no.nl_443 sk.sl.un_540
  // [23a0]
  0x68003514, 0x64001608, 0x0a0c1e04, 0x010802a4,   // zu.ig.un_660 hr.lg.un_430  ms.sv.pt_332 da.no.en_433
  0x130928a0, 0x0a0908a0, 0x02000e13, 0x13000d0c,   // sw.pl.et_322 no.pl.pt_322  is.da.un_650 ne.bh.un_530
  0x55642855, 0x6b251b11, 0x0e0827ad, 0x21645504,   // sw.lg.rw_442 tr.eu.ceb_653  gd.no.is_643 rw.lg.jw_332
  0x20005205, 0x16000a05, 0x1a2d0a07, 0x2513640c,   // ha.sq.un_330 pt.hr.un_330  pt.sk.tl_432 lg.et.eu_543
  // [23b0]
  0x1a28355a, 0x08022a02, 0x64552107, 0x323f030d,   // zu.sw.tl_553 mt.da.no_222  jw.rw.lg_432 nl.af.bs_554
  0x03003204, 0x190b07a0, 0x3f0413a4, 0x321613a4,   // bs.nl.un_320 it.es.gl_322  et.fi.af_433 et.hr.bs_433
  0x04163f04, 0x2a00070e, 0x08006412, 0x05524aee,   // af.hr.fi_332 it.mt.un_550  lg.no.un_640 yo.ha.fr_422
  0x0704100d, 0x1c000d0d, 0x04001c04, 0x180827ee,   // be.ru.bg_554 ne.mr.un_540  id.fi.un_320 gd.no.ga_422
  // [23c0]
  0x17005202, 0x31001a02, 0x0725130c, 0x25006807,   // ha.sr.un_220 tl.az.un_220  et.eu.it_543 ig.eu.un_420
  0x041f01a4, 0x526b1a04, 0x0e130408, 0x3f001318,   // en.cy.fi_433 tl.ceb.ha_332  fi.et.is_443 et.af.un_740
  0x21001807, 0x28001e1a, 0x0e001802, 0x12091602,   // ar.fa.un_420 ms.sw.un_760  ga.is.un_220 hr.pl.hu_222
  0x21641c0c, 0x0a1710ec, 0x2b3f21a0, 0x3500061a,   // id.lg.jw_543 be.sr.mk_644  jw.af.vi_322 de.zu.un_760
  // [23d0]
  0x0c0f13a4, 0x074a10a7, 0x645568ac, 0x0b190a55,   // et.lv.sv_433 lt.yo.it_532  ig.rw.lg_632 pt.gl.es_442
  0x19002113, 0x641e1ca9, 0x032552a0, 0x08040705,   // jw.gl.un_650 id.ms.lg_544  ha.eu.nl_322 bg.ru.uk_333
  0x060e0c60, 0x1a1c6ba9, 0x1a116b07, 0x23251902,   // sv.is.de_664 ceb.id.tl_544  ceb.ro.tl_432 gl.eu.ca_222
  0x521e1c07, 0x2752280c, 0x64171aa4, 0x033f13a0,   // id.ms.ha_432 sw.ha.gd_543  tl.sr.lg_433 et.af.nl_322
  // [23e0]
  0x17041108, 0x030701a4, 0x52250607, 0x17321613,   // ro.ru.sr_443 en.it.nl_433  de.eu.ha_432 hr.bs.sr_665
  0x0d000412, 0x11001034, 0x1c000d09, 0x0400070d,   // fi.cs.un_640 be.ro.un_A80  ne.mr.un_440 bg.ru.un_540
  0x08070a02, 0x25072a14, 0x08020ea4, 0x04282aee,   // mk.bg.uk_222 mt.it.eu_666  is.da.no_433 mt.sw.fi_422
  0x036b21ee, 0x06001108, 0x13001107, 0x1a101c07,   // jw.ceb.nl_422 ro.de.un_430  ro.et.un_420 id.lt.tl_432
  // [23f0]
  0x18006e07, 0x060c0708, 0x1c210f0c, 0x21121aa9,   // hmn.ga.un_420 it.sv.de_443  lv.jw.id_543 tl.hu.jw_544
  0x6b1f07a4, 0x17130ea7, 0x31001319, 0x12002118,   // it.cy.ceb_433 is.et.sr_532  et.az.un_750 fa.ur.un_740
  0x0c002504, 0x2d0d29a0, 0x0c000220, 0x1f0c64a4,   // eu.sv.un_320 sl.cs.sk_322  da.sv.un_850 lg.sv.cy_433
  0x040a0809, 0x1c311ea9, 0x0e000c1a, 0x07006412,   // uk.mk.ru_444 ms.az.id_544  sv.is.un_760 lg.it.un_640

  // [2400]
  0x1c13010c, 0x040a11ac, 0x11070a14, 0x12001818,   // en.et.id_543 ro.mk.ru_632  mk.bg.ro_666 ar.ur.un_740
  0x27001c04, 0x291325a4, 0x08000e13, 0x2a011fec,   // id.gd.un_320 eu.et.sl_433  is.no.un_650 cy.en.mt_644
  0x032923ad, 0x133f0312, 0x2a050707, 0x0a111705,   // ca.sl.nl_643 nl.af.et_654  it.fr.mt_432 sr.ro.mk_333
  0x062a0307, 0x03003f23, 0x01521eee, 0x0000082d,   // nl.mt.de_432 af.nl.un_880  ms.ha.en_422 uk.un.un_A00
  // [2410]
  0x0a041709, 0x06001e1a, 0x06006421, 0x553f35a7,   // sr.ru.mk_444 ms.de.un_760  lg.de.un_860 zu.af.rw_532
  0x12001a02, 0x09003b19, 0x13000a07, 0x08020cee,   // tl.hu.un_220 so.pl.un_750  pt.et.un_420 sv.da.no_422
  0x01093fee, 0x08000208, 0x0c070107, 0x2a3f35ee,   // af.pl.en_422 da.no.un_430  en.it.sv_432 zu.af.mt_422
  0x253b050c, 0x130a08a0, 0x033f08ad, 0x19000a0c,   // fr.so.eu_543 no.pt.et_322  no.af.nl_643 pt.gl.un_530
  // [2420]
  0x0a002807, 0x6b2928a9, 0x0900121a, 0x19000b11,   // sw.pt.un_420 sw.sl.ceb_544  hu.pl.un_760 es.gl.un_630
  0x13002b11, 0x5200350d, 0x55180508, 0x133b0112,   // vi.et.un_630 zu.ha.un_540  fr.ga.rw_443 en.so.et_654
  0x0b001107, 0x1f001c0d, 0x06093512, 0x6800641a,   // ro.es.un_420 id.cy.un_540  zu.pl.de_654 lg.ig.un_760
  0x03283fa7, 0x556b1a12, 0x0a07170e, 0x03002a04,   // af.sw.nl_532 tl.ceb.rw_654  sr.bg.mk_555 mt.nl.un_320
  // [2430]
  0x6b5520a4, 0x27283207, 0x033f1308, 0x11001604,   // sq.rw.ceb_433 bs.sw.gd_432  et.af.nl_443 hr.ro.un_320
  0x10041704, 0x1c0d1314, 0x174a1ca0, 0x061132a4,   // sr.ru.be_332 bh.ne.mr_666  id.yo.sr_322 bs.ro.de_433
  0x06122514, 0x21282da7, 0x6b000c04, 0x55351c02,   // eu.hu.de_666 sk.sw.jw_532  sv.ceb.un_320 id.zu.rw_222
  0x13006404, 0x352852a4, 0x04281807, 0x1c00130d,   // lg.et.un_320 ha.sw.zu_433  ga.sw.fi_432 bh.mr.un_540
  // [2440]
  0x06000f19, 0x20642807, 0x09002a19, 0x311255ec,   // lv.de.un_750 sw.lg.sq_432  mt.pl.un_750 rw.hu.az_644
  0x64001c07, 0x3f000e07, 0x0400130c, 0x130409a4,   // id.lg.un_420 is.af.un_420  et.fi.un_530 pl.fi.et_433
  0x12000919, 0x06040112, 0x2a045208, 0x08110708,   // pl.hu.un_750 en.fi.de_654  ha.fi.mt_443 bg.ro.uk_443
  0x2b001704, 0x19271811, 0x190a18ec, 0x2a0604a4,   // sr.vi.un_320 ga.gd.gl_653  ga.pt.gl_644 fi.de.mt_433
  // [2450]
  0x03000419, 0x0807100d, 0x042a0808, 0x17000a20,   // fi.nl.un_750 be.bg.uk_554  no.mt.fi_443 mk.sr.un_850
  0x253f0304, 0x1c2025a7, 0x05060707, 0x040717a4,   // nl.af.eu_332 eu.sq.id_532  it.de.fr_432 sr.bg.ru_433
  0x043b0e07, 0x10552104, 0x0d172d07, 0x04000814,   // is.so.fi_432 jw.rw.lt_332  sk.sr.cs_432 uk.ru.un_660
  0x090c0da7, 0x0f090613, 0x64003522, 0x1f080204,   // cs.sv.pl_532 de.pl.lv_665  zu.lg.un_870 da.no.cy_332
  // [2460]
  0x04006405, 0x2d0d2909, 0x0410110c, 0x2a00030c,   // lg.fi.un_330 sl.cs.sk_444  ro.be.ru_543 nl.mt.un_530
  0x2b001214, 0x040102a0, 0x1700081b, 0x17001905,   // hu.vi.un_660 da.en.fi_322  uk.sr.un_770 gl.sr.un_330
  0x091c130b, 0x040a11ee, 0x08042a12, 0x040910a4,   // bh.mr.hi_542 ro.mk.ru_422  mt.fi.no_654 lt.pl.fi_433
  0x0400070c, 0x162d0d04, 0x6408040c, 0x2d001705,   // it.fi.un_530 cs.sk.hr_332  fi.no.lg_543 sr.sk.un_330
  // [2470]
  0x2855520c, 0x1c3b1e0c, 0x20122a0c, 0x2312050c,   // ha.rw.sw_543 ms.so.id_543  mt.hu.sq_543 fr.hu.ca_543
  0x23072504, 0x0e006b04, 0x0e006b07, 0x11052307,   // eu.it.ca_332 ceb.is.un_320  ceb.is.un_420 ca.fr.ro_432
  0x1e121c0c, 0x6455280c, 0x322752ee, 0x0b251f0c,   // id.hu.ms_543 sw.rw.lg_543  ha.gd.bs_422 cy.eu.es_543
  0x0f101ea4, 0x23002709, 0x0813020c, 0x0400132b,   // ms.lt.lv_433 gd.ca.un_440  da.et.no_543 et.fi.un_980
  // [2480]
  0x3b005223, 0x04071705, 0x170a0707, 0x27001904,   // ha.so.un_880 sr.bg.ru_333  bg.mk.sr_432 gl.gd.un_320
  0x23190a04, 0x07100813, 0x3500281b, 0x27001a08,   // pt.gl.ca_332 uk.be.bg_665  sw.zu.un_770 tl.gd.un_430
  0x182701a7, 0x19120baf, 0x6b3f0307, 0x1100132a,   // en.gd.ga_532 es.hu.gl_655  nl.af.ceb_432 et.ro.un_970
  0x091f350c, 0x0600350e, 0x2a2835ad, 0x55182708,   // zu.cy.pl_543 zu.de.un_550  zu.sw.mt_643 gd.ga.rw_443
  // [2490]
  0x521e1cad, 0x4a001219, 0x0b0107a0, 0x1b1a640c,   // id.ms.ha_643 hu.yo.un_750  it.en.es_322 lg.tl.tr_543
  0x29162da0, 0x55121f12, 0x08000e1a, 0x6e321604,   // sk.hr.sl_322 cy.hu.rw_654  is.no.un_760 hr.bs.hmn_332
  0x2d0d2902, 0x1200350d, 0x0700110d, 0x64041305,   // sl.cs.sk_222 zu.hu.un_540  ro.bg.un_540 et.fi.lg_333
  0x0b0a23a4, 0x091c1e11, 0x1e1f0fee, 0x09110a0c,   // ca.pt.es_433 ms.id.pl_653  lv.cy.ms_422 pt.ro.pl_543
  // [24a0]
  0x3200161a, 0x0c3f02a0, 0x320625a7, 0x23000b02,   // hr.bs.un_760 da.af.sv_322  eu.de.bs_532 es.ca.un_220
  0x070a04a7, 0x01251fee, 0x20001113, 0x120c1ea4,   // ru.mk.bg_532 cy.eu.en_422  ro.sq.un_650 ms.sv.hu_433
  0x1b006804, 0x190b12ec, 0x20030807, 0x2111070c,   // ig.tr.un_320 hu.es.gl_644  no.nl.sq_432 it.ro.jw_543
  0x051201a4, 0x0f321702, 0x06080f04, 0x10120911,   // en.hu.fr_433 sr.bs.lv_222  lv.no.de_332 pl.hu.lt_653
  // [24b0]
  0x050401a4, 0x07552807, 0x17003207, 0x0e00050e,   // en.fi.fr_433 sw.rw.it_432  bs.sr.un_420 fr.is.un_550
  0x1b12030c, 0x25003f04, 0x130c2aa7, 0x172a0808,   // nl.hu.tr_543 af.eu.un_320  mt.sv.et_532 no.mt.sr_443
  0x3101050c, 0x21171604, 0x1300210d, 0x08120208,   // fr.en.az_543 hr.sr.jw_332  jw.et.un_540 da.hu.no_443
  0x354a6805, 0x1c000d07, 0x53001907, 0x0c231004,   // ig.yo.zu_333 ne.mr.un_420  gl.ht.un_420 lt.ca.sv_332
  // [24c0]
  0x0c000108, 0x0700051b, 0x03003f18, 0x05193f08,   // en.sv.un_430 fr.it.un_770  af.nl.un_740 af.gl.fr_443
  0x0105190c, 0x12002a0d, 0x052301ee, 0x09110613,   // gl.fr.en_543 mt.hu.un_540  en.ca.fr_422 de.ro.pl_665
  0x17080aa4, 0x12053107, 0x09200f08, 0x02093202,   // mk.uk.sr_433 az.fr.hu_432  lv.sq.pl_443 bs.pl.da_222
  0x05000113, 0x101b28a0, 0x091f68a7, 0x2a000108,   // en.fr.un_650 sw.tr.lt_322  ig.cy.pl_532 en.mt.un_430
  // [24d0]
  0x20132107, 0x27351aa0, 0x045319ee, 0x64003523,   // jw.et.sq_432 tl.zu.gd_322  gl.ht.fi_422 zu.lg.un_880
  0x284a0a12, 0x050801a4, 0x311b5511, 0x0c1827a7,   // pt.yo.sw_654 en.no.fr_433  rw.tr.az_653 gd.ga.sv_532
  0x13212512, 0x010d1904, 0x09005214, 0x011827a4,   // eu.jw.et_654 gl.cs.en_332  ha.pl.un_660 gd.ga.en_433
  0x08001f08, 0x21061fad, 0x3f000323, 0x05005305,   // cy.no.un_430 cy.de.jw_643  nl.af.un_880 ht.fr.un_330
  // [24e0]
  0x531e1704, 0x683564a9, 0x28036402, 0x030b3f5a,   // sr.ms.ht_332 lg.zu.ig_544  lg.nl.sw_222 af.es.nl_553
  0x3b5335ee, 0x6452090c, 0x52000918, 0x55006421,   // zu.ht.so_422 pl.ha.lg_543  pl.ha.un_740 lg.rw.un_860
  0x29002004, 0x282a21ec, 0x285564ac, 0x230507a4,   // sq.sl.un_320 jw.mt.sw_644  lg.rw.sw_632 it.fr.ca_433
  0x281a6b04, 0x6b1a1b0c, 0x3b00270e, 0x1b5228af,   // ceb.tl.sw_332 tr.tl.ceb_543  gd.so.un_550 sw.ha.tr_655
  // [24f0]
  0x055301a4, 0x645528a4, 0x0900640e, 0x2a281ea0,   // en.ht.fr_433 sw.rw.lg_433  lg.pl.un_550 ms.sw.mt_322
  0x310c28a4, 0x02002714, 0x1a52350c, 0x080c1f0c,   // sw.sv.az_433 gd.da.un_660  zu.ha.tl_543 cy.sv.no_543
  0x28352a13, 0x09003514, 0x1a553b11, 0x04005223,   // mt.zu.sw_665 zu.pl.un_660  so.rw.tl_653 ha.fi.un_880
  0x2500550d, 0x1b1c52ad, 0x09005213, 0x1c2135a7,   // rw.eu.un_540 ha.id.tr_643  ha.pl.un_650 zu.jw.id_532
  // [2500]
  0x1e3b0ca0, 0x2852090b, 0x6e641a12, 0x17001108,   // sv.so.ms_322 pl.ha.sw_542  tl.lg.hmn_654 ro.sr.un_430
  0x09521ca4, 0x216b550c, 0x130408a0, 0x2d0d25a0,   // id.ha.pl_433 rw.ceb.jw_543  no.fi.et_322 eu.cs.sk_322
  0x110a1313, 0x0b001907, 0x13174aa4, 0x0c00021b,   // et.pt.ro_665 gl.es.un_420  yo.sr.et_433 da.sv.un_770
  0x28001e22, 0x1f112713, 0x1a001f07, 0x55281ca0,   // ms.sw.un_870 gd.ro.cy_665  cy.tl.un_420 id.sw.rw_322
  // [2510]
  0x13552108, 0x0b00190d, 0x0c000523, 0x13001221,   // jw.rw.et_443 gl.es.un_540  fr.sv.un_880 hu.et.un_860
  0x25281ca0, 0x200b07a4, 0x04000a09, 0x2a281e07,   // id.sw.eu_322 it.es.sq_433  mk.ru.un_440 ms.sw.mt_432
  0x1f055305, 0x1b0553a7, 0x07250aad, 0x040a11a6,   // ht.fr.cy_333 ht.fr.tr_532  pt.eu.it_643 ro.mk.ru_521
  0x29002d14, 0x0c000e13, 0x32110da0, 0x100721a0,   // sk.sl.un_660 is.sv.un_650  cs.ro.bs_322 jw.it.lt_322
  // [2520]
  0x520507a7, 0x3b640413, 0x1b000c12, 0x081711a0,   // it.fr.ha_532 fi.lg.so_665  sv.tr.un_640 ro.sr.uk_322
  0x0f201155, 0x3f000302, 0x0d171ead, 0x4a2d0d60,   // ro.sq.lv_442 nl.af.un_220  ms.sr.cs_643 cs.sk.yo_664
  0x04643ba7, 0x21641a02, 0x10000f19, 0x09181fad,   // so.lg.fi_532 tl.lg.jw_222  lv.lt.un_750 cy.ga.pl_643
  0x0413255a, 0x00002924, 0x08130eee, 0x05002321,   // eu.et.fi_553 sl.un.un_900  is.et.no_422 ca.fr.un_860
  // [2530]
  0x1b0d350c, 0x1a003b19, 0x05001222, 0x533105a9,   // zu.cs.tr_543 so.tl.un_750  hu.fr.un_870 fr.az.ht_544
  0x1b096ea0, 0x08100aa9, 0x190b0709, 0x043b680b,   // hmn.pl.tr_322 mk.be.uk_544  it.es.gl_444 ig.so.fi_542
  0x12000508, 0x1c000908, 0x0b006e04, 0x121b310c,   // fr.hu.un_430 hi.mr.un_430  hmn.es.un_320 az.tr.hu_543
  0x19000119, 0x52005308, 0x100708a4, 0x11040808,   // en.gl.un_750 ht.ha.un_430  uk.bg.be_433 uk.ru.ro_443
  // [2540]
  0x01003513, 0x0b0512ad, 0x013f0504, 0x01001c08,   // zu.en.un_650 hu.fr.es_643  fr.af.en_332 id.en.un_430
  0x23120511, 0x0a006e0b, 0x0b000a21, 0x5305010c,   // fr.hu.ca_653 hmn.pt.un_520  pt.es.un_860 en.fr.ht_543
  0x230b0504, 0x1707100c, 0x043b640c, 0x283519ee,   // fr.es.ca_332 be.bg.sr_543  lg.so.fi_543 gl.zu.sw_422
  0x64133b0c, 0x0b1219ee, 0x0e686b12, 0x524a3bee,   // so.et.lg_543 gl.hu.es_422  ceb.ig.is_654 so.yo.ha_422
  // [2550]
  0x110a1712, 0x1300040d, 0x190a3f05, 0x092d02ee,   // sr.mk.ro_654 fi.et.un_540  af.pt.gl_333 da.sk.pl_422
  0x642055a0, 0x116418ad, 0x13013ba0, 0x192d1ca0,   // rw.sq.lg_322 ga.lg.ro_643  so.en.et_322 id.sk.gl_322
  0x320829a0, 0x0500122c, 0x13005513, 0x0a006e0c,   // sl.no.bs_322 hu.fr.un_990  rw.et.un_650 hmn.pt.un_530
  0x03050111, 0x0a006e08, 0x05001219, 0x1a1e1c04,   // en.fr.nl_653 hmn.pt.un_430  hu.fr.un_750 id.ms.tl_332
  // [2560]
  0x202925a7, 0x070a2513, 0x4a00251a, 0x0b2107ee,   // eu.sl.sq_532 eu.pt.it_665  eu.yo.un_760 it.jw.es_422
  0x2700250e, 0x532a0704, 0x6b1a2508, 0x640a19a4,   // eu.gd.un_550 it.mt.ht_332  eu.tl.ceb_443 gl.pt.lg_433
  0x072a20a4, 0x0717100e, 0x07000e13, 0x11050ea4,   // sq.mt.it_433 be.sr.bg_555  is.it.un_650 is.fr.ro_433
  0x013b3f08, 0x060c045a, 0x2a190a08, 0x356828a4,   // af.so.en_443 fi.sv.de_553  pt.gl.mt_443 sw.ig.zu_433
  // [2570]
  0x28046e07, 0x32001308, 0x0e130c04, 0x32172aa4,   // hmn.fi.sw_432 et.bs.un_430  sv.et.is_332 mt.sr.bs_433
  0x53000107, 0x1a006b20, 0x0b35130c, 0x1e1c20af,   // en.ht.un_420 ceb.tl.un_850  et.zu.es_543 sq.id.ms_655
  0x28645512, 0x25072a08, 0x3b006414, 0x10000f0e,   // rw.lg.sw_654 mt.it.eu_443  lg.so.un_660 lv.lt.un_550
  0x64551ca0, 0x3f020ca9, 0x0a17080b, 0x19000804,   // id.rw.lg_322 sv.da.af_544  uk.sr.mk_542 no.gl.un_320
  // [2580]
  0x311b2507, 0x10000b05, 0x17002a04, 0x160103ee,   // eu.tr.az_432 es.lt.un_330  mt.sr.un_320 nl.en.hr_422
  0x190b21ee, 0x1c215307, 0x25003204, 0x6432280c,   // jw.es.gl_422 ht.jw.id_432  bs.eu.un_320 sw.bs.lg_543
  0x6b1a5312, 0x6425550d, 0x0a0408a0, 0x1f001b0c,   // ht.tl.ceb_654 rw.eu.lg_554  uk.ru.mk_322 tr.cy.un_530
  0x3f0a06a0, 0x19010e0c, 0x29002705, 0x322d0d0d,   // de.pt.af_322 is.en.gl_543  gd.sl.un_330 cs.sk.bs_554
  // [2590]
  0x23001908, 0x182311ee, 0x350e2a0d, 0x13010ead,   // gl.ca.un_430 ro.ca.ga_422  mt.is.zu_554 is.en.et_643
  0x1c090d05, 0x06685555, 0x04001105, 0x17001005,   // ne.hi.mr_333 rw.ig.de_442  ro.ru.un_330 be.sr.un_330
  0x0409250d, 0x2a001c04, 0x04001002, 0x25352855,   // eu.pl.fi_554 id.mt.un_320  be.ru.un_220 sw.zu.eu_442
  0x23180eaf, 0x0c1102a0, 0x3100522b, 0x280652a4,   // is.ga.ca_655 da.ro.sv_322  ha.az.un_980 ha.de.sw_433
  // [25a0]
  0x05004a1a, 0x55002521, 0x1107520c, 0x552a5213,   // yo.fr.un_760 eu.rw.un_860  ha.it.ro_543 ha.mt.rw_665
  0x080a1f04, 0x0b182308, 0x531028a0, 0x190b0a09,   // cy.pt.no_332 ca.ga.es_443  sw.lt.ht_322 pt.es.gl_444
  0x23121307, 0x0b0a20a4, 0x250a23af, 0x0b0a11ee,   // et.hu.ca_432 sq.pt.es_433  ca.pt.eu_655 ro.pt.es_422
  0x1a211108, 0x03013fa0, 0x3f092da4, 0x080710a4,   // ro.jw.tl_443 af.en.nl_322  sk.pl.af_433 be.bg.uk_433
  // [25b0]
  0x32002a05, 0x2d3f09a9, 0x230e1907, 0x12004a0c,   // mt.bs.un_330 pl.af.sk_544  gl.is.ca_432 yo.hu.un_530
  0x11200c11, 0x06002322, 0x041108af, 0x68083fa4,   // sv.sq.ro_653 ca.de.un_870  uk.ro.ru_655 af.no.ig_433
  0x190b3f12, 0x52002823, 0x06003f18, 0x0b093f08,   // af.es.gl_654 sw.ha.un_880  af.de.un_740 af.pl.es_443
  0x11100812, 0x0b090f04, 0x12080caf, 0x2d0d05ec,   // uk.be.ro_654 lv.pl.es_332  sv.no.hu_655 fr.cs.sk_644
  // [25c0]
  0x182d0d1a, 0x030f0408, 0x03090613, 0x3f000f09,   // cs.sk.ga_776 fi.lv.nl_443  de.pl.nl_665 lv.af.un_440
  0x010c3fa7, 0x0c1101a0, 0x1100101a, 0x190b060c,   // af.sv.en_532 en.ro.sv_322  be.ro.un_760 de.es.gl_543
  0x1e1c0a09, 0x0407530c, 0x25190b04, 0x35211c55,   // pt.id.ms_444 ht.it.fi_543  es.gl.eu_332 id.jw.zu_442
  0x10006b18, 0x17080908, 0x120d2da9, 0x3b0620ad,   // ceb.lt.un_740 pl.no.sr_443  sk.cs.hu_544 sq.de.so_643
  // [25d0]
  0x2a033f08, 0x1b0b3507, 0x03000513, 0x12001319,   // af.nl.mt_443 zu.es.tr_432  fr.nl.un_650 et.hu.un_750
  0x2a0e64ad, 0x25002309, 0x1c5521ad, 0x11002321,   // lg.is.mt_643 ca.eu.un_440  jw.rw.id_643 ca.ro.un_860
  0x0f311b5a, 0x2700230d, 0x3b3f07a4, 0x29230509,   // tr.az.lv_553 ca.gd.un_540  it.af.so_433 fr.ca.sl_444
  0x27002302, 0x3f00020c, 0x1c12210d, 0x12190a09,   // ca.gd.un_220 da.af.un_530  jw.hu.id_554 pt.gl.hu_444
  // [25e0]
  0x041e1c55, 0x0500191a, 0x12190a13, 0x64005220,   // id.ms.fi_442 gl.fr.un_760  pt.gl.hu_665 ha.lg.un_850
  0x0e0f1055, 0x06000319, 0x2d0d0fee, 0x031205a0,   // lt.lv.is_442 nl.de.un_750  lv.cs.sk_422 fr.hu.nl_322
  0x090d13ee, 0x07101faf, 0x102d1ea0, 0x1e1c28af,   // bh.ne.hi_422 cy.lt.it_655  ms.sk.lt_322 sw.id.ms_655
  0x320e2d08, 0x0e001007, 0x01002005, 0x10321605,   // sk.is.bs_443 lt.is.un_420  sq.en.un_330 hr.bs.lt_333
  // [25f0]
  0x17041355, 0x190a1305, 0x0f08100c, 0x281e1c08,   // et.fi.sr_442 et.pt.gl_333  lt.no.lv_543 id.ms.sw_443
  0x5500280c, 0x556452ec, 0x1a6b3f11, 0x0d006e07,   // sw.rw.un_530 ha.lg.rw_644  af.ceb.tl_653 hmn.cs.un_420
  0x1a04520c, 0x53016ba9, 0x1c04280c, 0x132a1055,   // ha.fi.tl_543 ceb.en.ht_544  sw.fi.id_543 lt.mt.et_442
  0x11080aa4, 0x3f2d1f12, 0x1304050c, 0x2b050107,   // mk.uk.ro_433 cy.sk.af_654  fr.fi.et_543 en.fr.vi_432
  // [2600]
  0x64556ba9, 0x1f002d0e, 0x030908ec, 0x2d00061b,   // ceb.rw.lg_544 sk.cy.un_550  no.pl.nl_644 de.sk.un_770
  0x1a133bad, 0x16006805, 0x0a07040d, 0x08005521,   // so.et.tl_643 ig.hr.un_330  ru.bg.mk_554 rw.no.un_860
  0x1b310e0c, 0x55133b5a, 0x323f2da0, 0x1a553b08,   // is.az.tr_543 so.et.rw_553  sk.af.bs_322 so.rw.tl_443
  0x041319a4, 0x28135505, 0x120e010c, 0x1f002d0c,   // gl.et.fi_433 rw.et.sw_333  en.is.hu_543 sk.cy.un_530
  // [2610]
  0x0c643b09, 0x01040e04, 0x1000010d, 0x202d0d60,   // so.lg.sv_444 is.fi.en_332  en.lt.un_540 cs.sk.sq_664
  0x0f52100c, 0x0b19550c, 0x010e1008, 0x10190a13,   // lt.ha.lv_543 rw.gl.es_543  lt.is.en_443 pt.gl.lt_665
  0x1a6b5207, 0x2521100c, 0x0a6827a4, 0x6e182711,   // ha.ceb.tl_432 lt.jw.eu_543  gd.ig.pt_433 gd.ga.hmn_653
  0x270f10af, 0x01005508, 0x13683b0c, 0x08021805,   // lt.lv.gd_655 rw.en.un_430  so.ig.et_543 ga.da.no_333
  // [2620]
  0x190a0b02, 0x16193bee, 0x120c0ead, 0x0b00070c,   // es.pt.gl_222 so.gl.hr_422  is.sv.hu_643 it.es.un_530
  0x1b280909, 0x200f55a4, 0x190b0a12, 0x083f0614,   // pl.sw.tr_444 rw.lv.sq_433  pt.es.gl_654 de.af.no_666
  0x273128a4, 0x3b000213, 0x12201704, 0x55000107,   // sw.az.gd_433 da.so.un_650  sr.sq.hu_332 en.rw.un_420
  0x130c3b04, 0x0c005304, 0x2a0713ee, 0x2d0d2a0e,   // so.sv.et_332 ht.sv.un_320  et.it.mt_422 mt.cs.sk_555
  // [2630]
  0x080711a0, 0x091c1360, 0x130c3ba9, 0x64001b0b,   // ro.bg.uk_322 bh.mr.hi_664  so.sv.et_544 tr.lg.un_520
  0x0d062504, 0x553b6408, 0x2d0d12a6, 0x16005504,   // eu.de.cs_332 lg.so.rw_443  hu.cs.sk_521 rw.hr.un_320
  0x04130f0c, 0x05000e13, 0x0e05080c, 0x21041007,   // lv.et.fi_543 is.fr.un_650  no.fr.is_543 lt.fi.jw_432
  0x06031812, 0x1f003b21, 0x170a10af, 0x1206080c,   // ga.nl.de_654 so.cy.un_860  be.mk.sr_655 no.de.hu_543
  // [2640]
  0x070501ec, 0x011e28a7, 0x09101aa4, 0x13005222,   // en.fr.it_644 sw.ms.en_532  tl.lt.pl_433 ha.et.un_870
  0x06000322, 0x0e1304af, 0x3f3b02af, 0x28003513,   // nl.de.un_870 fi.et.is_655  da.so.af_655 zu.sw.un_650
  0x2d0d32a0, 0x02040eec, 0x1a2b3507, 0x1600280d,   // bs.cs.sk_322 is.fi.da_644  zu.vi.tl_432 sw.hr.un_540
  0x0a07085a, 0x231f1213, 0x0411080b, 0x1f3f0312,   // uk.bg.mk_553 hu.cy.ca_665  uk.ro.ru_542 nl.af.cy_654
  // [2650]
  0x040813af, 0x13000c04, 0x64041a0c, 0x3b190a04,   // et.no.fi_655 sv.et.un_320  tl.fi.lg_543 pt.gl.so_332
  0x0b351a0c, 0x10003b08, 0x4a6e6b08, 0x0704110c,   // tl.zu.es_543 so.lt.un_430  ceb.hmn.yo_443 ro.ru.bg_543
  0x0f1b31af, 0x04000a05, 0x2d052507, 0x2b00271b,   // az.tr.lv_655 mk.ru.un_330  eu.fr.sk_432 gd.vi.un_770
  0x312164ee, 0x1205530c, 0x02000f14, 0x213f0307,   // lg.jw.az_422 ht.fr.hu_543  lv.da.un_660 nl.af.jw_432
  // [2660]
  0x0a001208, 0x011307a0, 0x1a043b12, 0x16001707,   // hu.pt.un_430 it.et.en_322  so.fi.tl_654 sr.hr.un_420
  0x520e3b60, 0x0d003504, 0x11000c0c, 0x53133505,   // so.is.ha_664 zu.cs.un_320  sv.ro.un_530 zu.et.ht_333
  0x21005508, 0x1c1e21ad, 0x2300270d, 0x081206a4,   // rw.jw.un_430 jw.ms.id_643  gd.ca.un_540 de.hu.no_433
  0x0a071013, 0x170704ad, 0x2d0d1904, 0x0e060805,   // be.bg.mk_665 ru.bg.sr_643  gl.cs.sk_332 no.de.is_333
  // [2670]
  0x0a00231b, 0x08063f05, 0x06040355, 0x0c0f080c,   // ca.pt.un_770 af.de.no_333  nl.fi.de_442 no.lv.sv_543
  0x00003f2d, 0x23200b02, 0x3b006b08, 0x033f270e,   // af.un.un_A00 es.sq.ca_222  ceb.so.un_430 gd.af.nl_555
  0x1a001318, 0x12023f60, 0x2900030e, 0x172d0d0c,   // et.tl.un_740 af.da.hu_664  nl.sl.un_550 cs.sk.sr_543
  0x121b250d, 0x0b050308, 0x05002502, 0x08000c07,   // eu.tr.hu_554 nl.fr.es_443  eu.fr.un_220 sv.no.un_420
  // [2680]
  0x180227a0, 0x07190b02, 0x250e0ca7, 0x04003b19,   // gd.da.ga_322 es.gl.it_222  sv.is.eu_532 so.fi.un_750
  0x21001834, 0x043f3b0c, 0x022b010c, 0x3b553504,   // ar.fa.un_A80 so.af.fi_543  en.vi.da_543 zu.rw.so_332
  0x2d120d09, 0x3b123208, 0x170710a0, 0x556b1aa7,   // cs.hu.sk_444 bs.hu.so_443  be.bg.sr_322 tl.ceb.rw_532
  0x0a122d11, 0x08023f09, 0x05210eb2, 0x6b351aee,   // sk.hu.pt_653 af.da.no_444  is.jw.fr_732 tl.zu.ceb_422
  // [2690]
  0x04022aa4, 0x31203b55, 0x3b6b1aad, 0x6400281b,   // mt.da.fi_433 so.sq.az_442  tl.ceb.so_643 sw.lg.un_770
  0x230d0aee, 0x3f031aaf, 0x09080e0c, 0x190a12ac,   // pt.cs.ca_422 tl.nl.af_655  is.no.pl_543 hu.pt.gl_632
  0x11001a22, 0x0c001e08, 0x6b284a07, 0x3b1a3504,   // tl.ro.un_870 ms.sv.un_430  yo.sw.ceb_432 zu.tl.so_332
  0x1c3b520c, 0x2000320c, 0x230219a6, 0x3b2821af,   // ha.so.id_543 bs.sq.un_530  gl.da.ca_521 jw.sw.so_655
  // [26a0]
  0x553b6baf, 0x133f0307, 0x18076bee, 0x033f0409,   // ceb.so.rw_655 nl.af.et_432  ceb.it.ga_422 fi.af.nl_444
  0x131617ad, 0x3f133b0c, 0x13002105, 0x35002721,   // sr.hr.et_643 so.et.af_543  jw.et.un_330 gd.zu.un_860
  0x050711a4, 0x526b2da4, 0x04005218, 0x35644a0c,   // ro.it.fr_433 sk.ceb.ha_433  ha.fi.un_740 yo.lg.zu_543
  0x1b2b1ca7, 0x17000721, 0x19000512, 0x3b321604,   // id.vi.tr_532 bg.sr.un_860  fr.gl.un_640 hr.bs.so_332
  // [26b0]
  0x08132504, 0x08001705, 0x21004a11, 0x0a2307a4,   // eu.et.no_332 sr.uk.un_330  yo.jw.un_630 it.ca.pt_433
  0x11006e07, 0x181e0413, 0x2a002708, 0x53182707,   // hmn.ro.un_420 fi.ms.ga_665  gd.mt.un_430 gd.ga.ht_432
  0x20123205, 0x05006b07, 0x05124a0c, 0x211f1107,   // bs.hu.sq_333 ceb.fr.un_420  yo.hu.fr_543 ro.cy.jw_432
  0x121a6b5a, 0x55003522, 0x55000d13, 0x23002012,   // ceb.tl.hu_553 zu.rw.un_870  cs.rw.un_650 sq.ca.un_640
  // [26c0]
  0x020535a4, 0x1e1c2705, 0x523b6b12, 0x2d0d1314,   // zu.fr.da_433 gd.id.ms_333  ceb.so.ha_654 et.cs.sk_666
  0x201206ad, 0x10190f13, 0x0d050aa9, 0x1b0a0507,   // de.hu.sq_643 lv.gl.lt_665  pt.fr.cs_544 fr.pt.tr_432
  0x35000121, 0x2b002508, 0x20005202, 0x031c5307,   // en.zu.un_860 eu.vi.un_430  ha.sq.un_220 ht.id.nl_432
  0x0d321705, 0x04094aa9, 0x033f0ca9, 0x0d1c130b,   // sr.bs.cs_333 yo.pl.fi_544  sv.af.nl_544 bh.mr.ne_542
  // [26d0]
  0x3b0b35a4, 0x1a006804, 0x3217165a, 0x640a350c,   // zu.es.so_433 ig.tl.un_320  hr.sr.bs_553 zu.pt.lg_543
  0x1a056ba7, 0x0b0a1909, 0x52003511, 0x1e1c010c,   // ceb.fr.tl_532 gl.pt.es_444  zu.ha.un_630 en.id.ms_543
  0x23044aaf, 0x122d0d1b, 0x1b215308, 0x351e1c0e,   // yo.fi.ca_655 cs.sk.hu_777  ht.jw.tr_443 id.ms.zu_555
  0x13003b20, 0x64283bec, 0x190a0ba4, 0x3b002821,   // so.et.un_850 so.sw.lg_644  es.pt.gl_433 sw.so.un_860
  // [26e0]
  0x53643513, 0x0a00230d, 0x0b2b19a0, 0x353b32a0,   // zu.lg.ht_665 ca.pt.un_540  gl.vi.es_322 bs.so.zu_322
  0x0b0a12b2, 0x3b2152ee, 0x2b4a64ad, 0x190b0aa9,   // hu.pt.es_732 ha.jw.so_422  lg.yo.vi_643 pt.es.gl_544
  0x3b006407, 0x053b1c04, 0x2a001e02, 0x1e0728a0,   // lg.so.un_420 id.so.fr_332  ms.mt.un_220 sw.it.ms_322
  0x25556b0c, 0x0b1a3b12, 0x1c130913, 0x190b110e,   // ceb.rw.eu_543 so.tl.es_654  hi.bh.mr_665 ro.es.gl_555
  // [26f0]
  0x23190a08, 0x21001235, 0x2a5268ad, 0x3b003507,   // pt.gl.ca_443 ur.fa.un_A90  ig.ha.mt_643 zu.so.un_420
  0x171664a0, 0x0c001314, 0x0e3b05ad, 0x03000212,   // lg.hr.sr_322 et.sv.un_660  fr.so.is_643 da.nl.un_640
  0x116420a4, 0x64001904, 0x0c083fa0, 0x3b6428ec,   // sq.lg.ro_433 gl.lg.un_320  af.no.sv_322 sw.lg.so_644
  0x643b3fa9, 0x00002d03, 0x13250204, 0x0c0f1014,   // af.so.lg_544 sk.un.un_300  da.eu.et_332 lt.lv.sv_666
  // [2700]
  0x08071008, 0x1c091311, 0x0e0206a4, 0x050716a0,   // be.bg.uk_443 bh.hi.mr_653  de.da.is_433 hr.it.fr_322
  0x1000290c, 0x100b4a55, 0x0a190b55, 0x0800040c,   // sl.lt.un_530 yo.es.lt_442  es.gl.pt_442 ru.uk.un_530
  0x0a0b2908, 0x06002104, 0x0802130c, 0x1c211ea7,   // sl.es.pt_443 jw.de.un_320  et.da.no_543 ms.jw.id_532
  0x3f002a04, 0x19000b29, 0x104a2913, 0x0c0b200c,   // mt.af.un_320 es.gl.un_960  sl.yo.lt_665 sq.es.sv_543
  // [2710]
  0x0a1017ec, 0x25121fa7, 0x10000a21, 0x29104a07,   // sr.be.mk_644 cy.hu.eu_532  mk.be.un_860 yo.lt.sl_432
  0x08170405, 0x07006b12, 0x10041aa4, 0x190b0a02,   // ru.sr.uk_333 ceb.it.un_640  tl.fi.lt_433 pt.es.gl_222
  0x21282011, 0x3f091ca0, 0x281327a0, 0x18042707,   // sq.sw.jw_653 id.pl.af_322  gd.et.sw_322 gd.fi.ga_432
  0x0600520e, 0x190b05a4, 0x09001904, 0x01050da0,   // ha.de.un_550 fr.es.gl_433  gl.pl.un_320 cs.fr.en_322
  // [2720]
  0x10001904, 0x31042505, 0x3b2820a0, 0x11232704,   // gl.lt.un_320 eu.fi.az_333  sq.sw.so_322 gd.ca.ro_332
  0x0d0913ee, 0x32090511, 0x211029a4, 0x29000a13,   // bh.hi.ne_422 fr.pl.bs_653  sl.lt.jw_433 pt.sl.un_650
  0x1e1c21a6, 0x294a0b07, 0x32291602, 0x05000a12,   // jw.id.ms_521 es.yo.sl_432  hr.sl.bs_222 pt.fr.un_640
  0x3b1a21a4, 0x20351ea0, 0x100811a0, 0x6b131a08,   // jw.tl.so_433 ms.zu.sq_322  ro.uk.be_322 tl.et.ceb_443
  // [2730]
  0x091c13a7, 0x191009a7, 0x04001212, 0x1b003519,   // bh.mr.hi_532 pl.lt.gl_532  hu.fi.un_640 zu.tr.un_750
  0x023b2155, 0x1a352807, 0x32522907, 0x08002722,   // jw.so.da_442 sw.zu.tl_432  sl.ha.bs_432 gd.no.un_870
  0x0a000509, 0x21000518, 0x040127a0, 0x2164280d,   // fr.pt.un_440 fr.jw.un_740  gd.en.fi_322 sw.lg.jw_554
  0x3b002109, 0x1f00011a, 0x162932a7, 0x643528ad,   // jw.so.un_440 en.cy.un_760  bs.sl.hr_532 sw.zu.lg_643
  // [2740]
  0x0f01070c, 0x07001b04, 0x64283508, 0x13000d1b,   // it.en.lv_543 tr.it.un_320  zu.sw.lg_443 ne.bh.un_770
  0x0c3f2507, 0x35526455, 0x4a53050c, 0x072501a0,   // eu.af.sv_432 lg.ha.zu_442  fr.ht.yo_543 en.eu.it_322
  0x070a170c, 0x0a1710a7, 0x0413100e, 0x0800040e,   // sr.mk.bg_543 be.sr.mk_532  lt.et.fi_555 ru.uk.un_550
  0x050625ad, 0x1a6428ad, 0x1a00281a, 0x080a07ad,   // eu.de.fr_643 sw.lg.tl_643  sw.tl.un_760 bg.mk.uk_643
  // [2750]
  0x17002702, 0x3b003519, 0x19070b12, 0x292d1602,   // gd.sr.un_220 zu.so.un_750  es.it.gl_654 hr.sk.sl_222
  0x123b21a7, 0x2a272107, 0x6b682704, 0x0f033fa0,   // jw.so.hu_532 jw.gd.mt_432  gd.ig.ceb_332 af.nl.lv_322
  0x29201111, 0x16292aee, 0x351a2708, 0x526853a0,   // ro.sq.sl_653 mt.sl.hr_422  gd.tl.zu_443 ht.ig.ha_322
  0x130d0913, 0x2000251a, 0x1b001114, 0x252a04af,   // hi.ne.bh_665 eu.sq.un_760  ro.tr.un_660 fi.mt.eu_655
  // [2760]
  0x10090408, 0x6e00060d, 0x17001118, 0x13001902,   // fi.pl.lt_443 de.hmn.un_540  ro.sr.un_740 gl.et.un_220
  0x0e1304a4, 0x3b000205, 0x2a000c04, 0x100f1602,   // fi.et.is_433 da.so.un_330  sv.mt.un_320 hr.lv.lt_222
  0x1f20275a, 0x091c0d5a, 0x041e1cad, 0x28553505,   // gd.sq.cy_553 ne.mr.hi_553  id.ms.fi_643 zu.rw.sw_333
  0x6e0e0ba0, 0x21040ca0, 0x321729a4, 0x53001902,   // es.is.hmn_322 sv.fi.jw_322  sl.sr.bs_433 gl.ht.un_220
  // [2770]
  0x0c3f0204, 0x17000d07, 0x210e1211, 0x20292a60,   // da.af.sv_332 cs.sr.un_420  hu.is.jw_653 mt.sl.sq_664
  0x13041b55, 0x132029ad, 0x04000104, 0x2904530c,   // tr.fi.et_442 sl.sq.et_643  en.fi.un_320 ht.fi.sl_543
  0x4a00522a, 0x011b6ba0, 0x091f0405, 0x043b1bac,   // ha.yo.un_970 ceb.tr.en_322  fi.cy.pl_333 tr.so.fi_632
  0x25201c05, 0x0d001012, 0x3f250ba4, 0x08001604,   // id.sq.eu_333 lt.cs.un_640  es.eu.af_433 hr.no.un_320
  // [2780]
  0x2a070caf, 0x01000d19, 0x191a0a0d, 0x04064aa0,   // sv.it.mt_655 cs.en.un_750  pt.tl.gl_554 yo.de.fi_322
  0x190b07af, 0x080a2705, 0x1c321605, 0x3b1b0e05,   // it.es.gl_655 gd.pt.no_333  hr.bs.id_333 is.tr.so_333
  0x254a3ba4, 0x08070ba0, 0x29051f0b, 0x011b3ba4,   // so.yo.eu_433 es.it.no_322  cy.fr.sl_542 so.tr.en_433
  0x06001f14, 0x03004a1a, 0x01001f0c, 0x1908100c,   // cy.de.un_660 yo.nl.un_760  cy.en.un_530 lt.no.gl_543
  // [2790]
  0x083502a4, 0x0b0a35ee, 0x2d0d12ec, 0x20523208,   // da.zu.no_433 zu.pt.es_422  hu.cs.sk_644 bs.ha.sq_443
  0x120d0e07, 0x00003101, 0x070804ad, 0x53071111,   // is.cs.hu_432 az.un.un_200  ru.uk.bg_643 ro.it.ht_653
  0x07002507, 0x03005313, 0x6b00010c, 0x3102080c,   // eu.it.un_420 ht.nl.un_650  en.ceb.un_530 no.da.az_543
  0x190a01a9, 0x18002734, 0x3f006b04, 0x2d290d14,   // en.pt.gl_544 gd.ga.un_A80  ceb.af.un_320 cs.sl.sk_666
  // [27a0]
  0x02001f14, 0x2500070c, 0x182527af, 0x11002513,   // cy.da.un_660 it.eu.un_530  gd.eu.ga_655 eu.ro.un_650
  0x250a0107, 0x10001305, 0x640d2d07, 0x0d530507,   // en.pt.eu_432 et.lt.un_330  sk.cs.lg_432 fr.ht.cs_432
  0x64351fee, 0x170a11a6, 0x2d0d29ec, 0x23253ba9,   // cy.zu.lg_422 ro.mk.sr_521  sl.cs.sk_644 so.eu.ca_544
  0x533f030b, 0x32176409, 0x080710a0, 0x081007a0,   // nl.af.ht_542 lg.sr.bs_444  be.bg.uk_322 bg.be.uk_322
  // [27b0]
  0x18052713, 0x29001609, 0x1f100408, 0x25072a12,   // gd.fr.ga_665 hr.sl.un_440  fi.lt.cy_443 mt.it.eu_654
  0x185532a0, 0x53050d0c, 0x5264040c, 0x53052912,   // bs.rw.ga_322 cs.fr.ht_543  fi.lg.ha_543 sl.fr.ht_654
  0x02060d08, 0x1008040c, 0x281e1c60, 0x1f251807,   // cs.de.da_443 ru.uk.be_543  id.ms.sw_664 ga.eu.cy_432
  0x0d000920, 0x132053ee, 0x52002a08, 0x2725180b,   // hi.ne.un_850 ht.sq.et_422  mt.ha.un_430 ga.eu.gd_542
  // [27c0]
  0x1e1c20a6, 0x0600290c, 0x182725ad, 0x1f001021,   // sq.id.ms_521 sl.de.un_530  eu.gd.ga_643 lt.cy.un_860
  0x3f0b5504, 0x23001122, 0x07010ba0, 0x12000621,   // rw.es.af_332 ro.ca.un_870  es.en.it_322 de.hu.un_860
  0x534a05ad, 0x230525a9, 0x282023ee, 0x08040a04,   // fr.yo.ht_643 eu.fr.ca_544  ca.sq.sw_422 mk.ru.uk_332
  0x203b2a11, 0x06041313, 0x28352104, 0x3f080213,   // mt.so.sq_653 et.fi.de_665  jw.zu.sw_332 da.no.af_665
  // [27d0]
  0x3f0601a4, 0x08000205, 0x0d0913ac, 0x18000104,   // en.de.af_433 da.no.un_330  bh.hi.ne_632 en.ga.un_320
  0x05002808, 0x550135a0, 0x31121b05, 0x64321704,   // sw.fr.un_430 zu.en.rw_322  tr.hu.az_333 sr.bs.lg_332
  0x6413060c, 0x1700270c, 0x0c1a6b07, 0x19310aad,   // de.et.lg_543 gd.sr.un_530  ceb.tl.sv_432 pt.az.gl_643
  0x281a2aa0, 0x2a000e21, 0x1704100e, 0x311e1c09,   // mt.tl.sw_322 is.mt.un_860  be.ru.sr_555 id.ms.az_444
  // [27e0]
  0x02212a07, 0x6b0b07ad, 0x130208a7, 0x1c101ea0,   // mt.jw.da_432 it.es.ceb_643  no.da.et_532 ms.lt.id_322
  0x1f006b07, 0x08202aad, 0x06035307, 0x35271813,   // ceb.cy.un_420 mt.sq.no_643  ht.nl.de_432 ga.gd.zu_665
  0x2b050a5a, 0x1b002307, 0x2a060408, 0x12000104,   // pt.fr.vi_553 ca.tr.un_420  fi.de.mt_443 en.hu.un_320
  0x28311ba4, 0x13040609, 0x030413ad, 0x0a00200c,   // tr.az.sw_433 de.fi.et_444  et.fi.nl_643 sq.pt.un_530
  // [27f0]
  0x2d003202, 0x11040a0c, 0x080203a0, 0x28006b0b,   // bs.sk.un_220 mk.ru.ro_543  nl.da.no_322 ceb.sw.un_520
  0x3f3b1a07, 0x05000704, 0x2000350c, 0x6b5301ec,   // tl.so.af_432 it.fr.un_320  zu.sq.un_530 en.ht.ceb_644
  0x041a3b0e, 0x1f00061a, 0x6b270111, 0x110a2308,   // so.tl.fi_555 de.cy.un_760  en.gd.ceb_653 ca.pt.ro_443
  0x2d102913, 0x06643f05, 0x53001f23, 0x07192312,   // sl.lt.sk_665 af.lg.de_333  cy.ht.un_880 ca.gl.it_654

  // [2800]
  0x06050fee, 0x25000702, 0x1a0768a6, 0x13002518,   // lv.fr.de_422 it.eu.un_220  ig.it.tl_521 eu.et.un_740
  0x071704a9, 0x3f0403a4, 0x1b2a31a4, 0x070a08ec,   // ru.sr.bg_544 nl.fi.af_433  az.mt.tr_433 uk.mk.bg_644
  0x3b033f12, 0x04061008, 0x133f03ec, 0x19005521,   // af.nl.so_654 lt.de.fi_443  nl.af.et_644 rw.gl.un_860
  0x05001a0d, 0x35002822, 0x53074a0c, 0x0a1708a4,   // tl.fr.un_540 sw.zu.un_870  yo.it.ht_543 uk.sr.mk_433
  // [2810]
  0x10002811, 0x060e1a07, 0x0e35520c, 0x55002819,   // sw.lt.un_630 tl.is.de_432  ha.zu.is_543 sw.rw.un_750
  0x211352ee, 0x053f03a9, 0x2500010d, 0x01002102,   // ha.et.jw_422 nl.af.fr_544  en.eu.un_540 jw.en.un_220
  0x081304a4, 0x683b3104, 0x0d352d13, 0x11032dee,   // fi.et.no_433 az.so.ig_332  sk.zu.cs_665 sk.nl.ro_422
  0x08000708, 0x1c0d13a6, 0x09001102, 0x35000311,   // bg.uk.un_430 bh.ne.mr_521  ro.pl.un_220 nl.zu.un_630
  // [2820]
  0x201125a0, 0x130c06a7, 0x1100250b, 0x11005308,   // eu.ro.sq_322 de.sv.et_532  eu.ro.un_520 ht.ro.un_430
  0x190f0ba4, 0x0b2519a7, 0x200603ec, 0x190b0a55,   // es.lv.gl_433 gl.eu.es_532  nl.de.sq_644 pt.es.gl_442
  0x3217160d, 0x19111804, 0x13033f60, 0x190a0b09,   // hr.sr.bs_554 ga.ro.gl_332  af.nl.et_664 es.pt.gl_444
  0x12000513, 0x04000802, 0x550464a0, 0x1100530d,   // fr.hu.un_650 no.fi.un_220  lg.fi.rw_322 ht.ro.un_540
  // [2830]
  0x641955ad, 0x11120107, 0x0f090760, 0x193f0308,   // rw.gl.lg_643 en.hu.ro_432  it.pl.lv_664 nl.af.gl_443
  0x283152a9, 0x530413a4, 0x091c0da0, 0x25126bad,   // ha.az.sw_544 et.fi.ht_433  ne.mr.hi_322 ceb.hu.eu_643
  0x0802060b, 0x55531aa4, 0x68002820, 0x0a041007,   // de.da.no_542 tl.ht.rw_433  sw.ig.un_850 be.ru.mk_432
  0x0b070209, 0x53002821, 0x1e180705, 0x1b273b07,   // da.it.es_444 sw.ht.un_860  it.ga.ms_333 so.gd.tr_432
  // [2840]
  0x2800010d, 0x2806030c, 0x292d0da9, 0x07190bee,   // en.sw.un_540 nl.de.sw_543  cs.sk.sl_544 es.gl.it_422
  0x0900270e, 0x280627ee, 0x64080707, 0x2d096407,   // gd.pl.un_550 gd.de.sw_422  it.no.lg_432 lg.pl.sk_432
  0x4a190b08, 0x23531f0c, 0x2a081ba0, 0x03070b09,   // es.gl.yo_443 cy.ht.ca_543  tr.no.mt_322 es.it.nl_444
  0x190b23a9, 0x07081055, 0x31001e0d, 0x0a0410a0,   // ca.es.gl_544 be.uk.bg_442  ms.az.un_540 be.ru.mk_322
  // [2850]
  0x644a5505, 0x1012110c, 0x040a21ee, 0x04000702,   // rw.yo.lg_333 ro.hu.lt_543  jw.pt.fi_422 bg.ru.un_220
  0x0a284a07, 0x283503ad, 0x08041111, 0x17000413,   // yo.sw.pt_432 nl.zu.sw_643  ro.ru.uk_653 ru.sr.un_650
  0x201101a0, 0x64321fa7, 0x2d0d06af, 0x08520e12,   // en.ro.sq_322 cy.bs.lg_532  de.cs.sk_655 is.ha.no_654
  0x0b00121a, 0x2000351b, 0x00000f06, 0x0600271a,   // hu.es.un_760 zu.sq.un_770  lv.un.un_400 gd.de.un_760
  // [2860]
  0x070601a4, 0x355206ad, 0x3f030212, 0x06010508,   // en.de.it_433 de.ha.zu_643  da.nl.af_654 fr.en.de_443
  0x05102807, 0x272501a4, 0x232719ec, 0x21531008,   // sw.lt.fr_432 en.eu.gd_433  gl.gd.ca_644 lt.ht.jw_443
  0x0e190b60, 0x11072508, 0x20001123, 0x3f050313,   // es.gl.is_664 eu.it.ro_443  ro.sq.un_880 nl.fr.af_665
  0x0b55520c, 0x11252dad, 0x10081708, 0x01060808,   // ha.rw.es_543 sk.eu.ro_643  sr.uk.be_443 no.de.en_443
  // [2870]
  0x1c1e2560, 0x080c25ee, 0x17000104, 0x251107a9,   // eu.ms.id_664 eu.sv.no_422  en.sr.un_320 it.ro.eu_544
  0x28000c0e, 0x0c080202, 0x12000f04, 0x19001104,   // sv.sw.un_550 da.no.sv_222  lv.hu.un_320 ro.gl.un_320
  0x1a350712, 0x53001a07, 0x0e2d4a07, 0x52552809,   // it.zu.tl_654 tl.ht.un_420  yo.sk.is_432 sw.rw.ha_444
  0x1c2123a0, 0x1100071a, 0x0b271904, 0x0f001f19,   // ca.jw.id_322 it.ro.un_760  gl.gd.es_332 cy.lv.un_750
  // [2880]
  0x022108a4, 0x31122805, 0x1e1c12af, 0x1a286b07,   // no.jw.da_433 sw.hu.az_333  hu.id.ms_655 ceb.sw.tl_432
  0x070a11a0, 0x0a1708a9, 0x1a12285a, 0x07202507,   // ro.mk.bg_322 uk.sr.mk_544  sw.hu.tl_553 eu.sq.it_432
  0x07000612, 0x1a286b0c, 0x2a033f5a, 0x0f092d12,   // de.it.un_640 ceb.sw.tl_543  af.nl.mt_553 sk.pl.lv_654
  0x116864ee, 0x11252dee, 0x21001e0d, 0x55354a07,   // lg.ig.ro_422 sk.eu.ro_422  ms.jw.un_540 yo.zu.rw_432
  // [2890]
  0x35000808, 0x130b1aa0, 0x2800640d, 0x0207055a,   // no.zu.un_430 tl.es.et_322  lg.sw.un_540 fr.it.da_553
  0x21000305, 0x1f003521, 0x35556413, 0x08553508,   // nl.jw.un_330 zu.cy.un_860  lg.rw.zu_665 zu.rw.no_443
  0x07642a14, 0x0e18190d, 0x0627180d, 0x21001809,   // mt.lg.it_666 gl.ga.is_554  ga.gd.de_554 ar.fa.un_440
  0x033f2007, 0x0c3b1ea4, 0x3f1123a0, 0x231110a4,   // sq.af.nl_432 ms.so.sv_433  ca.ro.af_322 lt.ro.ca_433
  // [28a0]
  0x17131ca0, 0x07041760, 0x01036b04, 0x250b64a4,   // id.et.sr_322 sr.ru.bg_664  ceb.nl.en_332 lg.es.eu_433
  0x13002722, 0x182127a0, 0x190b6409, 0x051e1c0c,   // gd.et.un_870 gd.jw.ga_322  lg.es.gl_444 id.ms.fr_543
  0x0e0c04a9, 0x1b02230c, 0x53002819, 0x641c1e0c,   // fi.sv.is_544 ca.da.tr_543  sw.ht.un_750 ms.id.lg_543
  0x311c0bee, 0x3b1025a9, 0x070b6455, 0x1e1c1aaf,   // es.id.az_422 eu.lt.so_544  lg.es.it_442 tl.id.ms_655
  // [28b0]
  0x1a216b05, 0x0b271812, 0x550764a4, 0x131c0913,   // ceb.jw.tl_333 ga.gd.es_654  lg.it.rw_433 hi.mr.bh_665
  0x530121a0, 0x18272813, 0x0f002722, 0x2552530c,   // jw.en.ht_322 sw.gd.ga_665  gd.lv.un_870 ht.ha.eu_543
  0x2a000e1a, 0x6b0e275a, 0x554a070c, 0x4a645207,   // is.mt.un_760 gd.is.ceb_553  it.yo.rw_543 ha.lg.yo_432
  0x210103a0, 0x01532712, 0x1f3f010c, 0x05001105,   // nl.en.jw_322 gd.ht.en_654  en.af.cy_543 ro.fr.un_330
  // [28c0]
  0x3f1a6b11, 0x3f102509, 0x3f1235a0, 0x04531e07,   // ceb.tl.af_653 eu.lt.af_444  zu.hu.af_322 ms.ht.fi_432
  0x10002d14, 0x232b1ca0, 0x18001f08, 0x55524a12,   // sk.lt.un_660 id.vi.ca_322  cy.ga.un_430 yo.ha.rw_654
  0x25000307, 0x18005305, 0x27131ca0, 0x01193b04,   // nl.eu.un_420 ht.ga.un_330  id.et.gd_322 so.gl.en_332
  0x27041307, 0x12311bad, 0x68000a1b, 0x0e3f0807,   // et.fi.gd_432 tr.az.hu_643  pt.ig.un_770 no.af.is_432
  // [28d0]
  0x296455a4, 0x0f13100b, 0x0c005307, 0x2d0d6ea4,   // rw.lg.sl_433 lt.et.lv_542  ht.sv.un_420 hmn.cs.sk_433
  0x0b55645a, 0x18090d0c, 0x5208550c, 0x28051e07,   // lg.rw.es_553 cs.pl.ga_543  rw.no.ha_543 ms.fr.sw_432
  0x64000b05, 0x3f311ba9, 0x12132708, 0x17043f08,   // es.lg.un_330 tr.az.af_544  gd.et.hu_443 af.fi.sr_443
  0x101b2108, 0x211309a0, 0x17001c08, 0x081711ee,   // jw.tr.lt_443 pl.et.jw_322  id.sr.un_430 ro.sr.uk_422
  // [28e0]
  0x190a1814, 0x3200171b, 0x20533511, 0x286455ec,   // ga.pt.gl_666 sr.bs.un_770  zu.ht.sq_653 rw.lg.sw_644
  0x1c0720ee, 0x2d120d0e, 0x2d0f2904, 0x0a0553ee,   // sq.it.id_422 cs.hu.sk_555  sl.lv.sk_332 ht.fr.pt_422
  0x32172955, 0x1b0931a4, 0x2d0d1f0c, 0x062d0309,   // sl.sr.bs_442 az.pl.tr_433  cy.cs.sk_543 nl.sk.de_444
  0x2305211d, 0x0d091cac, 0x20002a09, 0x2a001212,   // jw.fr.ca_852 mr.hi.ne_632  mt.sq.un_440 hu.mt.un_640
  // [28f0]
  0x080c0204, 0x55061305, 0x13002908, 0x2d0920ec,   // da.sv.no_332 et.de.rw_333  sl.et.un_430 sq.pl.sk_644
  0x6b080cec, 0x12206e04, 0x12052108, 0x171629a0,   // sv.no.ceb_644 hmn.sq.hu_332  jw.fr.hu_443 sl.hr.sr_322
  0x64043bee, 0x03060508, 0x041b3107, 0x04643bad,   // so.fi.lg_422 fr.de.nl_443  az.tr.fi_432 so.lg.fi_643
  0x16002d05, 0x06003f13, 0x170708a9, 0x3b022712,   // sk.hr.un_330 af.de.un_650  uk.bg.sr_544 gd.da.so_654
  // [2900]
  0x0c002704, 0x3b046404, 0x100417ad, 0x10000429,   // gd.sv.un_320 lg.fi.so_332  sr.ru.be_643 ru.be.un_960
  0x210518ac, 0x190a07af, 0x0c081f07, 0x290c08ee,   // ga.fr.jw_632 it.pt.gl_655  cy.no.sv_432 no.sv.sl_422
  0x19001804, 0x20002a0d, 0x0c12170c, 0x0f120c0c,   // ga.gl.un_320 mt.sq.un_540  sr.hu.sv_543 sv.hu.lv_543
  0x6e1720a4, 0x010c0aa6, 0x20006e13, 0x0700290d,   // sq.sr.hmn_433 pt.sv.en_521  hmn.sq.un_650 sl.it.un_540
  // [2910]
  0x2a0c25a0, 0x08001f02, 0x120c2a07, 0x08010c04,   // eu.sv.mt_322 cy.no.un_220  mt.sv.hu_432 sv.en.no_332
  0x21001e02, 0x08053f08, 0x04006b04, 0x281a6407,   // ms.jw.un_220 af.fr.no_443  ceb.fi.un_320 lg.tl.sw_432
  0x20001318, 0x3b131e07, 0x06190504, 0x0608020d,   // et.sq.un_740 ms.et.so_432  fr.gl.de_332 da.no.de_554
  0x2d0f100c, 0x08021bee, 0x07000104, 0x04002513,   // lt.lv.sk_543 tr.da.no_422  en.it.un_320 eu.fi.un_650
  // [2920]
  0x10170405, 0x3f0604a4, 0x0b006404, 0x350107ee,   // ru.sr.be_333 fi.de.af_433  lg.es.un_320 it.en.zu_422
  0x080204a9, 0x19000709, 0x27186ba7, 0x08070405,   // fi.da.no_544 it.gl.un_440  ceb.ga.gd_532 ru.bg.uk_333
  0x20006e0c, 0x1c5535a9, 0x213f23a4, 0x29001304,   // hmn.sq.un_530 zu.rw.id_544  ca.af.jw_433 et.sl.un_320
  0x35001302, 0x04181760, 0x06001b21, 0x040853a4,   // et.zu.un_220 sr.ar.ru_664  tr.de.un_860 ht.no.fi_433
  // [2930]
  0x1b110a07, 0x520e3b07, 0x083f06a0, 0x13043bec,   // pt.ro.tr_432 so.is.ha_432  de.af.no_322 so.fi.et_644
  0x11000a07, 0x0b113107, 0x08523b12, 0x3f001f04,   // pt.ro.un_420 az.ro.es_432  so.ha.no_654 cy.af.un_320
  0x0803130c, 0x0f2864ee, 0x10256404, 0x230511a4,   // et.nl.no_543 lg.sw.lv_422  lg.eu.lt_332 ro.fr.ca_433
  0x080601a0, 0x2d1720a6, 0x23100509, 0x130412ec,   // en.de.no_322 sq.sr.sk_521  fr.lt.ca_444 hu.fi.et_644
  // [2940]
  0x0f2d0908, 0x1f122713, 0x0b00641a, 0x28082007,   // pl.sk.lv_443 gd.hu.cy_665  lg.es.un_760 sq.no.sw_432
  0x29171605, 0x2300101a, 0x10230c08, 0x0e00130c,   // hr.sr.sl_333 lt.ca.un_760  sv.ca.lt_443 et.is.un_530
  0x03002a08, 0x2a005207, 0x230e0aee, 0x1013230c,   // mt.nl.un_430 ha.mt.un_420  pt.is.ca_422 ca.et.lt_543
  0x085320ec, 0x05230355, 0x170a1fad, 0x05012308,   // sq.ht.no_644 nl.ca.fr_442  cy.pt.sr_643 ca.en.fr_443
  // [2950]
  0x0a00100d, 0x640701a0, 0x1b136407, 0x1e1b31a0,   // be.mk.un_540 en.it.lg_322  lg.et.tr_432 az.tr.ms_322
  0x0f1b1a0c, 0x2300252b, 0x53001104, 0x682864af,   // tl.tr.lv_543 eu.ca.un_980  ro.ht.un_320 lg.sw.ig_655
  0x1f5305a4, 0x10041e05, 0x23000523, 0x12000923,   // fr.ht.cy_433 ms.fi.lt_333  fr.ca.un_880 pl.hu.un_880
  0x6b4a680c, 0x64120f0c, 0x28000f22, 0x13283b60,   // ig.yo.ceb_543 lv.hu.lg_543  lv.sw.un_870 so.sw.et_664
  // [2960]
  0x13003b19, 0x03041308, 0x3f0523a9, 0x52282012,   // so.et.un_750 et.fi.nl_443  ca.fr.af_544 sq.sw.ha_654
  0x0a04080c, 0x2b014a0b, 0x1123050c, 0x20285508,   // uk.ru.mk_543 yo.en.vi_542  fr.ca.ro_543 rw.sw.sq_443
  0x121304ec, 0x3b060514, 0x0a0419a0, 0x01090cee,   // fi.et.hu_644 fr.de.so_666  gl.fi.pt_322 sv.pl.en_422
  0x3b00282a, 0x1e1c08a0, 0x52202808, 0x31015505,   // sw.so.un_970 no.id.ms_322  sw.sq.ha_443 rw.en.az_333
  // [2970]
  0x35006813, 0x034a3ba4, 0x0828350c, 0x0c003b08,   // ig.zu.un_650 so.yo.nl_433  zu.sw.no_543 so.sv.un_430
  0x0d0929ad, 0x27002522, 0x04001214, 0x1c00352a,   // sl.pl.cs_643 eu.gd.un_870  hu.fi.un_660 zu.id.un_970
  0x1a0e3b08, 0x1b040eaf, 0x11050355, 0x5220550c,   // so.is.tl_443 is.fi.tr_655  nl.fr.ro_442 rw.sq.ha_543
  0x1002080c, 0x11183baf, 0x6800520e, 0x35641ca0,   // no.da.lt_543 so.ga.ro_655  ha.ig.un_550 id.lg.zu_322
  // [2980]
  0x12184a04, 0x1101130c, 0x550f6404, 0x01130455,   // yo.ga.hu_332 et.en.ro_543  lg.lv.rw_332 fi.et.en_442
  0x03133b08, 0x10251faf, 0x3b041311, 0x31111ba9,   // so.et.nl_443 cy.eu.lt_655  et.fi.so_653 tr.ro.az_544
  0x28096bad, 0x6b356855, 0x311b4a11, 0x310764ee,   // ceb.pl.sw_643 ig.zu.ceb_442  yo.tr.az_653 lg.it.az_422
  0x051b3bad, 0x52205511, 0x170229a9, 0x056435a6,   // so.tr.fr_643 rw.sq.ha_653  sl.da.sr_544 zu.lg.fr_521
  // [2990]
  0x23110508, 0x20002a07, 0x521e1c04, 0x06311baf,   // fr.ro.ca_443 mt.sq.un_420  id.ms.ha_332 tr.az.de_655
  0x55642811, 0x2d096e08, 0x09003f19, 0x0d001902,   // sw.lg.rw_653 hmn.pl.sk_443  af.pl.un_750 gl.cs.un_220
  0x05126804, 0x06256405, 0x214a5204, 0x0e04135a,   // ig.hu.fr_332 lg.eu.de_333  ha.yo.jw_332 et.fi.is_553
  0x3f2016a0, 0x06110704, 0x0b121908, 0x071b110c,   // hr.sq.af_322 it.ro.de_332  gl.hu.es_443 ro.tr.it_543
  // [29a0]
  0x25120412, 0x0864130c, 0x0f0625a4, 0x21050ea4,   // fi.hu.eu_654 et.lg.no_543  eu.de.lv_433 is.fr.jw_433
  0x121304a4, 0x2d00170d, 0x210e1c0c, 0x1f000919,   // fi.et.hu_433 sr.sk.un_540  id.is.jw_543 pl.cy.un_750
  0x07060dad, 0x3b1e1c14, 0x171029a9, 0x2300112a,   // cs.de.it_643 id.ms.so_666  sl.lt.sr_544 ro.ca.un_970
  0x1f1c1eec, 0x030f0502, 0x3b026e11, 0x2000031a,   // ms.id.cy_644 fr.lv.nl_222  hmn.da.so_653 nl.sq.un_760
  // [29b0]
  0x2d0f090c, 0x3f320702, 0x1200110c, 0x642855ad,   // pl.lv.sk_543 it.bs.af_222  ro.hu.un_530 rw.sw.lg_643
  0x100419ad, 0x53321708, 0x35282155, 0x13000d0e,   // gl.fi.lt_643 sr.bs.ht_443  jw.sw.zu_442 ne.bh.un_550
  0x23002521, 0x6b002a05, 0x13002a02, 0x0b0f1012,   // eu.ca.un_860 mt.ceb.un_330  mt.et.un_220 lt.lv.es_654
  0x12640713, 0x12000913, 0x190b0c05, 0x23062560,   // it.lg.hu_665 pl.hu.un_650  sv.es.gl_333 eu.de.ca_664
  // [29c0]
  0x640503ee, 0x4a2155a0, 0x3f006e08, 0x0b190a04,   // nl.fr.lg_422 rw.jw.yo_322  hmn.af.un_430 pt.gl.es_332
  0x0e001902, 0x1b00210c, 0x0c000208, 0x0f000d12,   // gl.is.un_220 jw.tr.un_530  da.sv.un_430 cs.lv.un_640
  0x0b25190c, 0x040811a9, 0x03010602, 0x2a004a05,   // gl.eu.es_543 ro.uk.ru_544  de.en.nl_222 yo.mt.un_330
  0x0e042aa0, 0x255228ad, 0x040e4a12, 0x2b0801ad,   // mt.fi.is_322 sw.ha.eu_643  yo.is.fi_654 en.no.vi_643
  // [29d0]
  0x0c0801a7, 0x07001f0c, 0x3f031f0d, 0x2000680e,   // en.no.sv_532 cy.it.un_530  cy.nl.af_554 ig.sq.un_550
  0x6b113fa0, 0x5300050e, 0x06205505, 0x040a11ec,   // af.ro.ceb_322 fr.ht.un_550  rw.sq.de_333 ro.mk.ru_644
  0x06003f02, 0x036e13ad, 0x35005521, 0x0507030b,   // af.de.un_220 et.hmn.nl_643  rw.zu.un_860 nl.it.fr_542
  0x0c001f08, 0x06040c08, 0x18001119, 0x2008520c,   // cy.sv.un_430 sv.fi.de_443  ro.ga.un_750 ha.no.sq_543
  // [29e0]
  0x1008040e, 0x2d0d1faf, 0x351a6b08, 0x3216290d,   // ru.uk.be_555 cy.cs.sk_655  ceb.tl.zu_443 sl.hr.bs_554
  0x0c006412, 0x232b19ee, 0x28522a0c, 0x08526407,   // lg.sv.un_640 gl.vi.ca_422  mt.ha.sw_543 lg.ha.no_432
  0x2a131ea4, 0x192a1ea0, 0x0b003521, 0x350b6ba9,   // ms.et.mt_433 ms.mt.gl_322  zu.es.un_860 ceb.es.zu_544
  0x19020b08, 0x06000c1b, 0x18252705, 0x4a55640d,   // es.da.gl_443 sv.de.un_770  gd.eu.ga_333 lg.rw.yo_554
  // [29f0]
  0x211c6409, 0x041011ee, 0x081207a7, 0x0e642504,   // lg.id.jw_444 ro.be.ru_422  it.hu.no_532 eu.lg.is_332
  0x0d122d0c, 0x3b2a10a9, 0x0328350c, 0x556435ec,   // sk.hu.cs_543 lt.mt.so_544  zu.sw.nl_543 zu.lg.rw_644
  0x3b000a04, 0x64531008, 0x130e4a04, 0x10001c08,   // pt.so.un_320 lt.ht.lg_443  yo.is.et_332 id.lt.un_430
  0x0805115a, 0x170d2d0c, 0x212a01ac, 0x13110ca4,   // ro.fr.no_553 sk.cs.sr_543  en.mt.jw_632 sv.ro.et_433
  // [2a00]
  0x116435a9, 0x13211ea4, 0x25004a19, 0x3f2808a0,   // zu.lg.ro_544 ms.jw.et_433  yo.eu.un_750 no.sw.af_322
  0x01212da0, 0x13321602, 0x01003b13, 0x0c2d0d08,   // sk.jw.en_322 hr.bs.et_222  so.en.un_650 cs.sk.sv_443
  0x4a002a13, 0x11000c07, 0x292d25a7, 0x0a000b07,   // mt.yo.un_650 sv.ro.un_420  eu.sk.sl_532 es.pt.un_420
  0x325535a4, 0x100f3f05, 0x04001721, 0x3b001b19,   // zu.rw.bs_433 af.lv.lt_333  sr.ru.un_860 tr.so.un_750
  // [2a10]
  0x6b0f13a0, 0x013f28a0, 0x13001021, 0x10000307,   // et.lv.ceb_322 sw.af.en_322  lt.et.un_860 nl.lt.un_420
  0x020b0a0d, 0x0a0717ad, 0x3104010c, 0x6b5305ec,   // pt.es.da_554 sr.bg.mk_643  en.fi.az_543 fr.ht.ceb_644
  0x1c000d22, 0x353b2808, 0x04251008, 0x101302a7,   // ne.mr.un_870 sw.so.zu_443  lt.eu.fi_443 da.et.lt_532
  0x0e021307, 0x0e000608, 0x2b003b09, 0x3b001314,   // et.da.is_432 de.is.un_430  so.vi.un_440 et.so.un_660
  // [2a20]
  0x03643b08, 0x4a002102, 0x1a3b6b12, 0x016b6804,   // so.lg.nl_443 jw.yo.un_220  ceb.so.tl_654 ig.ceb.en_332
  0x13100fad, 0x0d00092c, 0x0f0313a6, 0x35043f04,   // lv.lt.et_643 hi.ne.un_990  et.nl.lv_521 af.fi.zu_332
  0x03133ba4, 0x0c040eee, 0x32173fee, 0x0d1c0955,   // so.et.nl_433 is.fi.sv_422  af.sr.bs_422 hi.mr.ne_442
  0x55126409, 0x08111013, 0x2d0c1fa4, 0x3f031aee,   // lg.hu.rw_444 be.ro.uk_665  cy.sv.sk_433 tl.nl.af_422
  // [2a30]
  0x02006e04, 0x2d0c09ec, 0x3f3b035a, 0x0c003f04,   // hmn.da.un_320 pl.sv.sk_644  nl.so.af_553 af.sv.un_320
  0x12003205, 0x2a0129a6, 0x3f07230c, 0x31130407,   // bs.hu.un_330 sl.en.mt_521  ca.it.af_543 fi.et.az_432
  0x033f13a4, 0x6b0523a0, 0x0b03050c, 0x6800551b,   // et.af.nl_433 ca.fr.ceb_322  fr.nl.es_543 rw.ig.un_770
  0x3f00131a, 0x04020812, 0x0b0a190c, 0x68002d05,   // et.af.un_760 no.da.fi_654  gl.pt.es_543 sk.ig.un_330
  // [2a40]
  0x11100107, 0x2a00680e, 0x162d29a0, 0x10190b13,   // en.lt.ro_432 ig.mt.un_550  sl.sk.hr_322 es.gl.lt_665
  0x046b25a0, 0x275231a4, 0x081104ec, 0x0d1c13ee,   // eu.ceb.fi_322 az.ha.gd_433  ru.ro.uk_644 bh.mr.ne_422
  0x19001008, 0x12060407, 0x2307125a, 0x0a0701a9,   // lt.gl.un_430 fi.de.hu_432  hu.it.ca_553 en.it.pt_544
  0x0c0e08a0, 0x2a000713, 0x18000a08, 0x08020e05,   // no.is.sv_322 it.mt.un_650  pt.ga.un_430 is.da.no_333
  // [2a50]
  0x100b0a08, 0x2d0d060e, 0x0300020c, 0x030c06a0,   // pt.es.lt_443 de.cs.sk_555  da.nl.un_530 de.sv.nl_322
  0x13090d0e, 0x121b2512, 0x23050313, 0x133f3b07,   // ne.hi.bh_555 eu.tr.hu_654  nl.fr.ca_665 so.af.et_432
  0x2b3b010c, 0x0f041355, 0x0e2d0daf, 0x52102814,   // en.so.vi_543 et.fi.lv_442  cs.sk.is_655 sw.lt.ha_666
  0x10000a09, 0x321755af, 0x0f100807, 0x521a210b,   // pt.lt.un_440 rw.sr.bs_655  no.lt.lv_432 jw.tl.ha_542
  // [2a60]
  0x0e100f0c, 0x131011a4, 0x0a1a010c, 0x190a0b0e,   // lv.lt.is_543 ro.lt.et_433  en.tl.pt_543 es.pt.gl_555
  0x25000f2b, 0x0c033fee, 0x08026ba4, 0x1e3f25ec,   // lv.eu.un_980 af.nl.sv_422  ceb.da.no_433 eu.af.ms_644
  0x10252313, 0x0e1a6b12, 0x2a0810a4, 0x25000f1a,   // ca.eu.lt_665 ceb.tl.is_654  lt.no.mt_433 lv.eu.un_760
  0x2b190b09, 0x271806a4, 0x04003f07, 0x2723010c,   // es.gl.vi_444 de.ga.gd_433  af.fi.un_420 en.ca.gd_543
  // [2a70]
  0x0a000108, 0x0807110c, 0x53211ca9, 0x31202a0c,   // en.pt.un_430 ro.bg.uk_543  id.jw.ht_544 mt.sq.az_543
  0x3b061f09, 0x2864555a, 0x25646b0c, 0x062552ec,   // cy.de.so_444 rw.lg.sw_553  ceb.lg.eu_543 ha.eu.de_644
  0x3f230607, 0x521b2a0c, 0x01531e02, 0x3f230505,   // de.ca.af_432 mt.tr.ha_543  ms.ht.en_222 fr.ca.af_333
  0x0e06075a, 0x1b21550c, 0x12080e13, 0x05645307,   // it.de.is_553 rw.jw.tr_543  is.no.hu_665 ht.lg.fr_432
  // [2a80]
  0x1a1b64a7, 0x3f321604, 0x0c1329a4, 0x13002702,   // lg.tr.tl_532 hr.bs.af_332  sl.et.sv_433 gd.et.un_220
  0x21002522, 0x131c0d12, 0x1e1c68ec, 0x091155a7,   // eu.jw.un_870 ne.mr.bh_654  ig.id.ms_644 rw.ro.pl_532
  0x21646bad, 0x210609a9, 0x5255640c, 0x3b13120d,   // ceb.lg.jw_643 pl.de.jw_544  lg.rw.ha_543 hu.et.so_554
  0x0e190b5a, 0x35556407, 0x3b282507, 0x55091aee,   // es.gl.is_553 lg.rw.zu_432  eu.sw.so_432 tl.pl.rw_422
  // [2a90]
  0x0d001702, 0x122164a9, 0x23000113, 0x55521ea4,   // sr.cs.un_220 lg.jw.hu_544  en.ca.un_650 ms.ha.rw_433
  0x12012307, 0x6b230108, 0x12006404, 0x060325a7,   // ca.en.hu_432 en.ca.ceb_443  lg.hu.un_320 eu.nl.de_532
  0x0a00041b, 0x120123ee, 0x050123a7, 0x0f0410a4,   // ru.mk.un_770 ca.en.hu_422  ca.en.fr_532 lt.fi.lv_433
  0x110f1055, 0x1f00170c, 0x3f2d250c, 0x0803010c,   // lt.lv.ro_442 sr.cy.un_530  eu.sk.af_543 en.nl.no_543
  // [2aa0]
  0x00002803, 0x04252105, 0x08100f05, 0x1600020c,   // sw.un.un_300 jw.eu.fi_333  lv.lt.no_333 da.hr.un_530
  0x230b11a4, 0x1e1c6ea4, 0x20356404, 0x0e060f13,   // ro.es.ca_433 hmn.id.ms_433  lg.zu.sq_332 lv.de.is_665
  0x12000d18, 0x25132355, 0x55182704, 0x12006419,   // cs.hu.un_740 ca.et.eu_442  gd.ga.rw_332 lg.hu.un_750
  0x25001a02, 0x080e0207, 0x12211c02, 0x250711a7,   // tl.eu.un_220 da.is.no_432  id.jw.hu_222 ro.it.eu_532
  // [2ab0]
  0x1f000a04, 0x08051e04, 0x64006802, 0x6b012307,   // pt.cy.un_320 ms.fr.no_332  ig.lg.un_220 ca.en.ceb_432
  0x1c1e2a08, 0x19000a02, 0x060f10ad, 0x091c0d02,   // mt.ms.id_443 pt.gl.un_220  lt.lv.de_643 ne.mr.hi_222
  0x12641aa0, 0x2300050e, 0x0b2d0207, 0x6b1a0212,   // tl.lg.hu_322 fr.ca.un_550  da.sk.es_432 da.tl.ceb_654
  0x01036ba4, 0x0e04130c, 0x283b55ad, 0x030113a7,   // ceb.nl.en_433 et.fi.is_543  rw.so.sw_643 et.en.nl_532
  // [2ac0]
  0x0b1827ad, 0x191c0aee, 0x0d091c0e, 0x1e00550e,   // gd.ga.es_643 pt.id.gl_422  mr.hi.ne_555 rw.ms.un_550
  0x64555313, 0x6b1a53a9, 0x1f0729ee, 0x2d1b3111,   // ht.rw.lg_665 ht.tl.ceb_544  sl.it.cy_422 az.tr.sk_653
  0x351a6bad, 0x5568350e, 0x5500522a, 0x3f5364ad,   // ceb.tl.zu_643 zu.ig.rw_555  ha.rw.un_970 lg.ht.af_643
  0x062718a0, 0x1b6b53a6, 0x53351c0c, 0x1200641b,   // ga.gd.de_322 ht.ceb.tr_521  id.zu.ht_543 lg.hu.un_770
  // [2ad0]
  0x05271808, 0x1f000104, 0x284a3ba7, 0x0e00200d,   // ga.gd.fr_443 en.cy.un_320  so.yo.sw_532 sq.is.un_540
  0x0e072a08, 0x05002109, 0x1c006b04, 0x1e1c04ec,   // mt.it.is_443 jw.fr.un_440  ceb.id.un_320 fi.id.ms_644
  0x16004a07, 0x3b6b1a09, 0x3f030408, 0x133f040c,   // yo.hr.un_420 tl.ceb.so_444  fi.nl.af_443 fi.af.et_543
  0x3b55520e, 0x170f13ee, 0x1b31520d, 0x551b530e,   // ha.rw.so_555 et.lv.sr_422  ha.az.tr_554 ht.tr.rw_555
  // [2ae0]
  0x533564ee, 0x212d1107, 0x042153a4, 0x2b00680d,   // lg.zu.ht_422 ro.sk.jw_432  ht.jw.fi_433 ig.vi.un_540
  0x0f092aa4, 0x55356413, 0x645352a9, 0x20005322,   // mt.pl.lv_433 lg.zu.rw_665  ha.ht.lg_544 ht.sq.un_870
  0x0c2168a0, 0x0100050e, 0x13006b0e, 0x2d0d04a4,   // ig.jw.sv_322 fr.en.un_550  ceb.et.un_550 fi.cs.sk_433
  0x03080205, 0x170a040b, 0x080a0713, 0x08003f13,   // da.no.nl_333 ru.mk.sr_542  bg.mk.uk_665 af.no.un_650
  // [2af0]
  0x112d0d05, 0x1f006413, 0x1b006821, 0x04321702,   // cs.sk.ro_333 lg.cy.un_650  ig.tr.un_860 sr.bs.fi_222
  0x071101a4, 0x11001c0d, 0x2b003504, 0x685228ec,   // en.ro.it_433 id.ro.un_540  zu.vi.un_320 sw.ha.ig_644
  0x192528ad, 0x0c001f05, 0x0c051fee, 0x0400102b,   // sw.eu.gl_643 cy.sv.un_330  cy.fr.sv_422 be.ru.un_980
  0x536b2012, 0x0e0521a0, 0x01002429, 0x2d1e1c08,   // sq.ceb.ht_654 jw.fr.is_322  yi.iw.un_960 id.ms.sk_443
  // [2b00]
  0x203552ad, 0x3f1c3105, 0x01001f08, 0x0a2a520c,   // ha.zu.sq_643 az.id.af_333  cy.en.un_430 ha.mt.pt_543
  0x4a1152a4, 0x3f006b0c, 0x0a005204, 0x282008a0,   // ha.ro.yo_433 ceb.af.un_530  ha.pt.un_320 no.sq.sw_322
  0x1b213508, 0x321629af, 0x0e3506a9, 0x312018a7,   // zu.jw.tr_443 sl.hr.bs_655  de.zu.is_544 ga.sq.az_532
  0x0300200e, 0x0c000e0d, 0x130e1855, 0x2100201b,   // sq.nl.un_550 is.sv.un_540  ga.is.et_442 sq.jw.un_770
  // [2b10]
  0x23070b02, 0x1c002119, 0x1c090d0d, 0x3f0306ac,   // es.it.ca_222 jw.id.un_750  ne.hi.mr_554 de.nl.af_632
  0x2b0601a6, 0x251e1c13, 0x2800350c, 0x033f1bee,   // en.de.vi_521 id.ms.eu_665  zu.sw.un_530 tr.af.nl_422
  0x2a1a6b12, 0x291304ad, 0x200401a4, 0x04001c0d,   // ceb.tl.mt_654 fi.et.sl_643  en.fi.sq_433 id.fi.un_540
  0x2a6b20ee, 0x17005512, 0x0f04130d, 0x17321611,   // sq.ceb.mt_422 rw.sr.un_640  et.fi.lv_554 hr.bs.sr_653
  // [2b20]
  0x190b4a05, 0x05040709, 0x05002902, 0x53130808,   // yo.es.gl_333 it.fi.fr_444  sl.fr.un_220 no.et.ht_443
  0x0800121b, 0x1e1c4aa4, 0x06010407, 0x050704a9,   // hu.no.un_770 yo.id.ms_433  fi.en.de_432 fi.it.fr_544
  0x21081ca4, 0x1f000613, 0x3b205212, 0x1207045a,   // id.no.jw_433 de.cy.un_650  ha.sq.so_654 fi.it.hu_553
  0x17100805, 0x1c001321, 0x200852a0, 0x0d641308,   // uk.be.sr_333 bh.mr.un_860  ha.no.sq_322 et.lg.cs_443
  // [2b30]
  0x20106804, 0x29004a0d, 0x11202aa4, 0x12070408,   // ig.lt.sq_332 yo.sl.un_540  mt.sq.ro_433 fi.it.hu_443
  0x135525af, 0x21005514, 0x1c211ea4, 0x521b3109,   // eu.rw.et_655 rw.jw.un_660  ms.jw.id_433 az.tr.ha_444
  0x12000721, 0x64552555, 0x06001308, 0x06071b04,   // it.hu.un_860 eu.rw.lg_442  et.de.un_430 tr.it.de_332
  0x05000722, 0x1b001f19, 0x13041aa4, 0x04071007,   // it.fr.un_870 cy.tr.un_750  tl.fi.et_433 be.bg.ru_432
  // [2b40]
  0x04004a05, 0x1b211e0c, 0x1b002019, 0x10002512,   // yo.fi.un_330 ms.jw.tr_543  sq.tr.un_750 eu.lt.un_640
  0x05641b07, 0x311a6bec, 0x041207a4, 0x2a063fa4,   // tr.lg.fr_432 ceb.tl.az_644  it.hu.fi_433 af.de.mt_433
  0x6b081a0d, 0x071204ec, 0x12000814, 0x35003112,   // tl.no.ceb_554 fi.hu.it_644  no.hu.un_660 az.zu.un_640
  0x2a000c09, 0x013b2005, 0x072a08a0, 0x032d0d05,   // sv.mt.un_440 sq.so.en_333  no.mt.it_322 cs.sk.nl_333
  // [2b50]
  0x081e25a4, 0x130d0909, 0x2a040709, 0x32290908,   // eu.ms.no_433 hi.ne.bh_444  it.fi.mt_444 pl.sl.bs_443
  0x061331a0, 0x1e68200c, 0x3f04130b, 0x3b4a290c,   // az.et.de_322 sq.ig.ms_543  et.fi.af_542 sl.yo.so_543
  0x2a070214, 0x07000a0b, 0x20311bec, 0x31005211,   // da.it.mt_666 mk.bg.un_520  tr.az.sq_644 ha.az.un_630
  0x19005207, 0x082a4a04, 0x2a0705ad, 0x53004a04,   // ha.gl.un_420 yo.mt.no_332  fr.it.mt_643 yo.ht.un_320
  // [2b60]
  0x233f0207, 0x03080ca4, 0x1c0d13a4, 0x27050da0,   // da.af.ca_432 sv.no.nl_433  bh.ne.mr_433 cs.fr.gd_322
  0x061b12a4, 0x08021ba0, 0x204a27ec, 0x06002102,   // hu.tr.de_433 tr.da.no_322  gd.yo.sq_644 jw.de.un_220
  0x6b066ea0, 0x20003b04, 0x4a250504, 0x1a6b55ee,   // hmn.de.ceb_322 so.sq.un_320  fr.eu.yo_332 rw.ceb.tl_422
  0x3b00110c, 0x0b051904, 0x04080507, 0x2a0412ec,   // ro.so.un_530 gl.fr.es_332  fr.no.fi_432 hu.fi.mt_644
  // [2b70]
  0x1708045a, 0x52313b0c, 0x0a190b13, 0x523b2113,   // ru.uk.sr_553 so.az.ha_543  es.gl.pt_665 jw.so.ha_665
  0x68002b21, 0x32291712, 0x2a001b0c, 0x31521aa9,   // vi.ig.un_860 sr.sl.bs_654  tr.mt.un_530 tl.ha.az_544
  0x2d001c02, 0x216b0a07, 0x230f1304, 0x3b1a52a9,   // id.sk.un_220 pt.ceb.jw_432  et.lv.ca_332 ha.tl.so_544
  0x1c211aa9, 0x5321520c, 0x18001204, 0x0c0a08ee,   // tl.jw.id_544 ha.jw.ht_543  ur.ar.un_320 no.pt.sv_422
  // [2b80]
  0x52003b1a, 0x4a643505, 0x31523b0c, 0x17164a0c,   // so.ha.un_760 zu.lg.yo_333  so.ha.az_543 yo.hr.sr_543
  0x282b04ec, 0x313b52ec, 0x5221310c, 0x2d00040c,   // fi.vi.sw_644 ha.so.az_644  az.jw.ha_543 fi.sk.un_530
  0x2b04280c, 0x4a3b5208, 0x2b000421, 0x111f070c,   // sw.fi.vi_543 ha.so.yo_443  fi.vi.un_860 it.cy.ro_543
  0x0e1308a4, 0x07001a23, 0x530e1ca4, 0x355231a4,   // no.et.is_433 tl.it.un_880  id.is.ht_433 az.ha.zu_433
  // [2b90]
  0x06053f04, 0x10002b1a, 0x0400050c, 0x206b070c,   // af.fr.de_332 vi.lt.un_760  fr.fi.un_530 it.ceb.sq_543
  0x110410a4, 0x31003b19, 0x091f52a4, 0x09075508,   // be.ru.ro_433 so.az.un_750  ha.cy.pl_433 rw.it.pl_443
  0x0704115a, 0x531b3109, 0x0807110e, 0x3b005519,   // ro.ru.bg_553 az.tr.ht_444  ro.bg.uk_555 rw.so.un_750
  0x08001a0b, 0x3b1a31ec, 0x08530408, 0x01681f04,   // tl.no.un_520 az.tl.so_644  fi.ht.no_443 cy.ig.en_332
  // [2ba0]
  0x13000d2a, 0x68280755, 0x042b0712, 0x0f521355,   // ne.bh.un_970 it.sw.ig_442  it.vi.fi_654 et.ha.lv_442
  0x2b000419, 0x020e08ad, 0x28042b13, 0x17000a14,   // fi.vi.un_750 no.is.da_643  vi.fi.sw_665 mk.sr.un_660
  0x133b06a7, 0x06003f0e, 0x06180e04, 0x311e1c5a,   // de.so.et_532 af.de.un_550  is.ga.de_332 id.ms.az_553
  0x2917070c, 0x21101fee, 0x642809ad, 0x0a0728ad,   // it.sr.sl_543 cy.lt.jw_422  pl.sw.lg_643 sw.it.pt_643
  // [2bb0]
  0x23200a14, 0x2a0f52ec, 0x27060207, 0x00000a37,   // pt.sq.ca_666 ha.lv.mt_644  da.de.gd_432 pt.un.un_B00
  0x0a190b12, 0x1a0755a4, 0x0b09060c, 0x28005205,   // es.gl.pt_654 rw.it.tl_433  de.pl.es_543 ha.sw.un_330
  0x1e1c100c, 0x1a126ba7, 0x521206ad, 0x2d0a23ee,   // lt.id.ms_543 ceb.hu.tl_532  de.hu.ha_643 ca.pt.sk_422
  0x0103250c, 0x0f0a4aa0, 0x18001f1a, 0x1e3b04ee,   // eu.nl.en_543 yo.pt.lv_322  cy.ga.un_760 fi.so.ms_422
  // [2bc0]
  0x35000d04, 0x07041f5a, 0x2100550c, 0x1a0f35ad,   // cs.zu.un_320 cy.fi.it_553  rw.jw.un_530 zu.lv.tl_643
  0x29170aaf, 0x080204a4, 0x1e006b07, 0x35006b21,   // pt.sr.sl_655 fi.da.no_433  ceb.ms.un_420 ceb.zu.un_860
  0x17002921, 0x52311ea4, 0x081004af, 0x1e001904,   // sl.sr.un_860 ms.az.ha_433  ru.be.uk_655 gl.ms.un_320
  0x28000805, 0x082b010c, 0x19070aa0, 0x190b200c,   // no.sw.un_330 en.vi.no_543  pt.it.gl_322 sq.es.gl_543
  // [2bd0]
  0x02002913, 0x3b2355a0, 0x10002821, 0x686b1a0d,   // sl.da.un_650 rw.ca.so_322  sw.lt.un_860 tl.ceb.ig_554
  0x6400552a, 0x01002307, 0x066e0405, 0x35005507,   // rw.lg.un_970 ca.en.un_420  fi.hmn.de_333 rw.zu.un_420
  0x251e1ca7, 0x1708100c, 0x0e002108, 0x0a135207,   // id.ms.eu_532 be.uk.sr_543  jw.is.un_430 ha.et.pt_432
  0x6e001c13, 0x130823a9, 0x12001e0d, 0x07190f04,   // id.hmn.un_650 ca.no.et_544  ms.hu.un_540 lv.gl.it_332
  // [2be0]
  0x52042008, 0x190a23af, 0x292555a9, 0x551c1e11,   // sq.fi.ha_443 ca.pt.gl_655  rw.eu.sl_544 ms.id.rw_653
  0x21003b22, 0x6b556412, 0x04002022, 0x3b293204,   // so.jw.un_870 lg.rw.ceb_654  sq.fi.un_870 bs.sl.so_332
  0x64002922, 0x09001008, 0x321716ee, 0x29200d0c,   // sl.lg.un_870 lt.pl.un_430  hr.sr.bs_422 cs.sq.sl_543
  0x090501a4, 0x080e040c, 0x1f001008, 0x090d13ad,   // en.fr.pl_433 fi.is.no_543  lt.cy.un_430 bh.ne.hi_643
  // [2bf0]
  0x01001f02, 0x17114aa0, 0x351e1c04, 0x07170a0b,   // cy.en.un_220 yo.ro.sr_322  id.ms.zu_332 mk.sr.bg_542
  0x1f006e0c, 0x253216ee, 0x520412a9, 0x0f1b1307,   // hmn.cy.un_530 hr.bs.eu_422  hu.fi.ha_544 et.tr.lv_432
  0x2d0d16a4, 0x08061f0c, 0x25002314, 0x21002329,   // hr.cs.sk_433 cy.de.no_543  ca.eu.un_660 ca.jw.un_960
  0x0a1704a7, 0x0300252a, 0x2a002321, 0x1f183b0c,   // ru.sr.mk_532 eu.nl.un_970  ca.mt.un_860 so.ga.cy_543

  // [2c00]
  0x29000307, 0x35005502, 0x1b05010c, 0x23002513,   // nl.sl.un_420 rw.zu.un_220  en.fr.tr_543 eu.ca.un_650
  0x0b000108, 0x3b003511, 0x010b18ee, 0x2800680e,   // en.es.un_430 zu.so.un_630  ga.es.en_422 ig.sw.un_550
  0x3200170c, 0x1e1c13af, 0x04080e05, 0x35096412,   // sr.bs.un_530 et.id.ms_655  is.no.fi_333 lg.pl.zu_654
  0x13100412, 0x1328030b, 0x03040ca4, 0x0b3b28af,   // fi.lt.et_654 nl.sw.et_542  sv.fi.nl_433 sw.so.es_655
  // [2c10]
  0x070817ee, 0x21001a13, 0x280364ee, 0x21203fa0,   // sr.uk.bg_422 tl.jw.un_650  lg.nl.sw_422 af.sq.jw_322
  0x55286404, 0x3f000c07, 0x1a354a07, 0x21001e07,   // lg.sw.rw_332 sv.af.un_420  yo.zu.tl_432 ms.jw.un_420
  0x55006807, 0x03006402, 0x03061b07, 0x0d2d190d,   // ig.rw.un_420 lg.nl.un_220  tr.de.nl_432 gl.sk.cs_554
  0x1a3b4a0b, 0x13080c04, 0x534a52a0, 0x521a1e07,   // yo.so.tl_542 sv.no.et_332  ha.yo.ht_322 ms.tl.ha_432
  // [2c20]
  0x312a3b0d, 0x13000118, 0x0c006b07, 0x033f530c,   // so.mt.az_554 en.et.un_740  ceb.sv.un_420 ht.af.nl_543
  0x10040a05, 0x1a4a52a6, 0x1e1c2d02, 0x3f040ea0,   // mk.ru.be_333 ha.yo.tl_521  sk.id.ms_222 is.fi.af_322
  0x10000f09, 0x52003104, 0x091c13af, 0x04001329,   // lv.lt.un_440 az.ha.un_320  bh.mr.hi_655 et.fi.un_960
  0x190b0fee, 0x09000c07, 0x3255350b, 0x13030407,   // lv.es.gl_422 sv.pl.un_420  zu.rw.bs_542 fi.nl.et_432
  // [2c30]
  0x1e1c5214, 0x3b136e05, 0x06201ea4, 0x080211ec,   // ha.id.ms_666 hmn.et.so_333  ms.sq.de_433 ro.da.no_644
  0x27181f05, 0x0c0827a4, 0x281e3bac, 0x13190a13,   // cy.ga.gd_333 gd.no.sv_433  so.ms.sw_632 pt.gl.et_665
  0x08170413, 0x2d000614, 0x080e6ba0, 0x070810a0,   // ru.sr.uk_665 de.sk.un_660  ceb.is.no_322 be.uk.bg_322
  0x4a685208, 0x04060cee, 0x036b68ec, 0x4a6413ec,   // ha.ig.yo_443 sv.de.fi_422  ig.ceb.nl_644 et.lg.yo_644
  // [2c40]
  0x64552114, 0x522a4a55, 0x053f230d, 0x642713a9,   // jw.rw.lg_666 yo.mt.ha_442  ca.af.fr_554 et.gd.lg_544
  0x6800031a, 0x641c2104, 0x1c0d13ec, 0x08026b02,   // nl.ig.un_760 jw.id.lg_332  bh.ne.mr_644 ceb.da.no_222
  0x0c101f07, 0x2b121ca0, 0x0e100855, 0x6e1f53ec,   // cy.lt.sv_432 id.hu.vi_322  no.lt.is_442 ht.cy.hmn_644
  0x316407a9, 0x16190a55, 0x1e003119, 0x1c130daf,   // it.lg.az_544 pt.gl.hr_442  az.ms.un_750 ne.bh.mr_655
  // [2c50]
  0x1b1c1e07, 0x0664035a, 0x033f0414, 0x2a0a1802,   // ms.id.tr_432 nl.lg.de_553  fi.af.nl_666 ga.pt.mt_222
  0x28003b20, 0x090b3507, 0x1a4a6b02, 0x1e1b2aee,   // so.sw.un_850 zu.es.pl_432  ceb.yo.tl_222 mt.tr.ms_422
  0x0b283512, 0x190a1105, 0x0704180c, 0x6b000704,   // zu.sw.es_654 ro.pt.gl_333  ga.fi.it_543 it.ceb.un_320
  0x0206085a, 0x2d321605, 0x23000a12, 0x3f0e080b,   // no.de.da_553 hr.bs.sk_333  pt.ca.un_640 no.is.af_542
  // [2c60]
  0x080210a4, 0x27646ba7, 0x0f001019, 0x286b52ee,   // lt.da.no_433 ceb.lg.gd_532  lt.lv.un_750 ha.ceb.sw_422
  0x16352d55, 0x17003504, 0x11002719, 0x3f03040c,   // sk.zu.hr_442 zu.sr.un_320  gd.ro.un_750 fi.nl.af_543
  0x2800552a, 0x04102511, 0x04000f04, 0x64000413,   // rw.sw.un_970 eu.lt.fi_653  lv.fi.un_320 fi.lg.un_650
  0x18001905, 0x536b0102, 0x134a350c, 0x29000713,   // gl.ga.un_330 en.ceb.ht_222  zu.yo.et_543 it.sl.un_650
  // [2c70]
  0x643f0305, 0x3f3b4aa0, 0x09100412, 0x1e1c6ba0,   // nl.af.lg_333 yo.so.af_322  fi.lt.pl_654 ceb.id.ms_322
  0x13271104, 0x6b181108, 0x02006b0d, 0x13000b07,   // ro.gd.et_332 ro.ga.ceb_443  ceb.da.un_540 es.et.un_420
  0x190b28ec, 0x13091cad, 0x55280ba4, 0x35060eaf,   // sw.es.gl_644 mr.hi.bh_643  es.sw.rw_433 is.de.zu_655
  0x1b230aee, 0x6400031b, 0x04006422, 0x5321070c,   // pt.ca.tr_422 nl.lg.un_770  lg.fi.un_870 it.jw.ht_543
  // [2c80]
  0x3b060ea4, 0x1107080c, 0x21054a04, 0x11001607,   // is.de.so_433 uk.bg.ro_543  yo.fr.jw_332 hr.ro.un_420
  0x64130412, 0x64046804, 0x12311b55, 0x19001f1b,   // fi.et.lg_654 ig.fi.lg_332  tr.az.hu_442 cy.gl.un_770
  0x35001904, 0x31000308, 0x18004a07, 0x53000517,   // gl.zu.un_320 nl.az.un_430  yo.ga.un_420 fr.ht.un_730
  0x2500531a, 0x1c001a02, 0x321710a4, 0x08021902,   // ht.eu.un_760 tl.id.un_220  lt.sr.bs_433 gl.da.no_222
  // [2c90]
  0x2d0d16a0, 0x64002820, 0x190b23a4, 0x320a0304,   // hr.cs.sk_322 sw.lg.un_850  ca.es.gl_433 nl.pt.bs_332
  0x090627a7, 0x0a001605, 0x041a6ba0, 0x1c1e0655,   // gd.de.pl_532 hr.pt.un_330  ceb.tl.fi_322 de.ms.id_442
  0x4a00250e, 0x181127a4, 0x35004a0d, 0x11270108,   // eu.yo.un_550 gd.ro.ga_433  yo.zu.un_540 en.gd.ro_443
  0x6b190b0d, 0x1c001f05, 0x231811a7, 0x0a041055,   // es.gl.ceb_554 cy.id.un_330  ro.ga.ca_532 be.ru.mk_442
  // [2ca0]
  0x020c080c, 0x016b18ee, 0x08033f0c, 0x073f0308,   // no.sv.da_543 ga.ceb.en_422  af.nl.no_543 nl.af.it_443
  0x0500111a, 0x2d180da4, 0x64001104, 0x21000d04,   // ro.fr.un_760 cs.ga.sk_433  ro.lg.un_320 cs.jw.un_320
  0x032a2013, 0x0e1f640d, 0x056b5204, 0x072710ad,   // sq.mt.nl_665 lg.cy.is_554  ha.ceb.fr_332 lt.gd.it_643
  0x05042005, 0x016b6ea0, 0x05041307, 0x080a17ad,   // sq.fi.fr_333 hmn.ceb.en_322  et.fi.fr_432 sr.mk.uk_643
  // [2cb0]
  0x31041312, 0x21005304, 0x01530c09, 0x0c061313,   // et.fi.az_654 ht.jw.un_320  sv.ht.en_444 et.de.sv_665
  0x13251107, 0x31020807, 0x09001602, 0x1300070e,   // ro.eu.et_432 no.da.az_432  hr.pl.un_220 it.et.un_550
  0x1813040c, 0x04182708, 0x0f254aec, 0x3f000b02,   // fi.et.ga_543 gd.ga.fi_443  yo.eu.lv_644 es.af.un_220
  0x11001b13, 0x07033f13, 0x29032da9, 0x063f230c,   // tr.ro.un_650 af.nl.it_665  sk.nl.sl_544 ca.af.de_543
  // [2cc0]
  0x2829130b, 0x0e3f06a4, 0x190e0107, 0x553528af,   // et.sl.sw_542 de.af.is_433  en.is.gl_432 sw.zu.rw_655
  0x08001807, 0x13001914, 0x01043b04, 0x2a002908,   // ga.no.un_420 gl.et.un_660  so.fi.en_332 sl.mt.un_430
  0x3200290c, 0x0f1e3f0c, 0x2900551b, 0x050a23ec,   // sl.bs.un_530 af.ms.lv_543  rw.sl.un_770 ca.pt.fr_644
  0x2a031f07, 0x3b000b05, 0x08041fec, 0x553b100b,   // cy.nl.mt_432 es.so.un_330  cy.fi.no_644 lt.so.rw_542
  // [2cd0]
  0x05000a21, 0x0810170c, 0x055255a4, 0x4a6b6813,   // pt.fr.un_860 sr.be.uk_543  rw.ha.fr_433 ig.ceb.yo_665
  0x08021fa0, 0x29090fa4, 0x05001005, 0x080225a0,   // cy.da.no_322 lv.pl.sl_433  lt.fr.un_330 eu.da.no_322
  0x0e002922, 0x0f3b550b, 0x5529130c, 0x16000804,   // sl.is.un_870 rw.so.lv_542  et.sl.rw_543 no.hr.un_320
  0x07104a0c, 0x0000132d, 0x6e04680c, 0x13552908,   // yo.lt.it_543 bh.un.un_A00  ig.fi.hmn_543 sl.rw.et_443
  // [2ce0]
  0x0500530e, 0x20005308, 0x04032aee, 0x16005507,   // ht.fr.un_550 ht.sq.un_430  mt.nl.fi_422 rw.hr.un_420
  0x09001604, 0x190527ec, 0x0c12060c, 0x13003f02,   // hr.pl.un_320 gd.fr.gl_644  de.hu.sv_543 af.et.un_220
  0x04074a0c, 0x190a0414, 0x036404ad, 0x2a645204,   // yo.it.fi_543 fi.pt.gl_666  fi.lg.nl_643 ha.lg.mt_332
  0x1b033b07, 0x07000a34, 0x02085307, 0x100b5507,   // so.nl.tr_432 mk.bg.un_A80  ht.no.da_432 rw.es.lt_432
  // [2cf0]
  0x04000514, 0x3f002d08, 0x05640709, 0x553b52af,   // fr.fi.un_660 sk.af.un_430  it.lg.fr_444 ha.so.rw_655
  0x23050708, 0x3f1a6b0c, 0x1c132a04, 0x2d003207,   // it.fr.ca_443 ceb.tl.af_543  mt.et.id_332 bs.sk.un_420
  0x0506520c, 0x1c0935ad, 0x311b0aa0, 0x0c020608,   // ha.de.fr_543 zu.pl.id_643  pt.tr.az_322 de.da.sv_443
  0x0c080e04, 0x08190b04, 0x030c3f04, 0x31001904,   // is.no.sv_332 es.gl.no_332  af.sv.nl_332 gl.az.un_320
  // [2d00]
  0x030c08a4, 0x1f2708a4, 0x130752ad, 0x13080205,   // no.sv.nl_433 no.gd.cy_433  ha.it.et_643 da.no.et_333
  0x2a0e05a4, 0x0d1c130c, 0x032a060c, 0x3b3f040c,   // fr.is.mt_433 bh.mr.ne_543  de.mt.nl_543 fi.af.so_543
  0x07002a09, 0x3f080c04, 0x032d2a04, 0x08101713,   // mt.it.un_440 sv.no.af_332  mt.sk.nl_332 sr.be.uk_665
  0x1b0131ee, 0x2a063f0c, 0x1632170b, 0x0c086ba0,   // az.en.tr_422 af.de.mt_543  sr.bs.hr_542 ceb.no.sv_322
  // [2d10]
  0x4a006819, 0x23190b13, 0x09001f22, 0x2a006e19,   // ig.yo.un_750 es.gl.ca_665  cy.pl.un_870 hmn.mt.un_750
  0x030c3f02, 0x060d05a0, 0x250b19ee, 0x5200230d,   // af.sv.nl_222 fr.cs.de_322  gl.es.eu_422 ca.ha.un_540
  0x20102912, 0x130d09a9, 0x2319050c, 0x290d1602,   // sl.lt.sq_654 hi.ne.bh_544  fr.gl.ca_543 hr.cs.sl_222
  0x284a5514, 0x2d1029ad, 0x0c052704, 0x28211ca0,   // rw.yo.sw_666 sl.lt.sk_643  gd.fr.sv_332 id.jw.sw_322
  // [2d20]
  0x20190bee, 0x27000802, 0x281e6ba0, 0x1a28640c,   // es.gl.sq_422 no.gd.un_220  ceb.ms.sw_322 lg.sw.tl_543
  0x05083ba0, 0x13171608, 0x530405ad, 0x121e1c04,   // so.no.fr_322 hr.sr.et_443  fr.fi.ht_643 id.ms.hu_332
  0x290413a4, 0x09001613, 0x0b001e04, 0x29130911,   // et.fi.sl_433 hr.pl.un_650  ms.es.un_320 pl.et.sl_653
  0x2a001904, 0x07001604, 0x16001308, 0x0e003b1b,   // gl.mt.un_320 hr.it.un_320  et.hr.un_430 so.is.un_770
  // [2d30]
  0x4a25520c, 0x1f100fa0, 0x352a075a, 0x04002522,   // ha.eu.yo_543 lv.lt.cy_322  it.mt.zu_553 eu.fi.un_870
  0x4a6b10a4, 0x3252080c, 0x18522813, 0x100f1eee,   // lt.ceb.yo_433 no.ha.bs_543  sw.ha.ga_665 ms.lv.lt_422
  0x64003202, 0x1b533255, 0x131c1e07, 0x2a5220a7,   // bs.lg.un_220 bs.ht.tr_442  ms.id.et_432 sq.ha.mt_532
  0x35005523, 0x050307a6, 0x161364a0, 0x10066e04,   // rw.zu.un_880 it.nl.fr_521  lg.et.hr_322 hmn.de.lt_332
  // [2d40]
  0x3f022aec, 0x080419a0, 0x6e002019, 0x06032702,   // mt.da.af_644 gl.fi.no_322  sq.hmn.un_750 gd.nl.de_222
  0x0f291ca4, 0x2d0f10ec, 0x1b00121b, 0x060e0c05,   // id.sl.lv_433 lt.lv.sk_644  hu.tr.un_770 sv.is.de_333
  0x3b000419, 0x0e1b3bad, 0x1b214a05, 0x0f0313a0,   // fi.so.un_750 so.tr.is_643  yo.jw.tr_333 et.nl.lv_322
  0x07046408, 0x030c13a4, 0x0d1309a7, 0x291703af,   // lg.fi.it_443 et.sv.nl_433  hi.bh.ne_532 nl.sr.sl_655
  // [2d50]
  0x2a001f1a, 0x0b0323ee, 0x230a6e07, 0x063f0e05,   // cy.mt.un_760 ca.nl.es_422  hmn.pt.ca_432 is.af.de_333
  0x12033fa4, 0x0a0711a0, 0x2520040b, 0x28000119,   // af.nl.hu_433 ro.bg.mk_322  fi.sq.eu_542 en.sw.un_750
  0x6b55640c, 0x08000713, 0x641e290c, 0x1c1e2712,   // lg.rw.ceb_543 bg.uk.un_650  sl.ms.lg_543 gd.ms.id_654
  0x10041304, 0x190b05ee, 0x082a07af, 0x13001e05,   // et.fi.lt_332 fr.es.gl_422  it.mt.no_655 ms.et.un_330
  // [2d60]
  0x2b000704, 0x20321605, 0x3b1304ad, 0x193223a6,   // it.vi.un_320 hr.bs.sq_333  fi.et.so_643 ca.bs.gl_521
  0x1f211ea0, 0x281752a0, 0x070a2809, 0x211a1ea7,   // ms.jw.cy_322 ha.sr.sw_322  sw.pt.it_444 ms.tl.jw_532
  0x20001e04, 0x033f0ea9, 0x23002d19, 0x0800171b,   // ms.sq.un_320 is.af.nl_544  sk.ca.un_750 sr.uk.un_770
  0x06231108, 0x3200290e, 0x103f06ac, 0x20001f12,   // ro.ca.de_443 sl.bs.un_550  de.af.lt_632 cy.sq.un_640
  // [2d70]
  0x2b000e05, 0x20000413, 0x646b53a4, 0x17192907,   // is.vi.un_330 fi.sq.un_650  ht.ceb.lg_433 sl.gl.sr_432
  0x13015304, 0x0e0c31af, 0x18255204, 0x232007a4,   // ht.en.et_332 az.sv.is_655  ha.eu.ga_332 it.sq.ca_433
  0x070f25ad, 0x13310eb2, 0x10684a55, 0x21001107,   // eu.lv.it_643 is.az.et_732  yo.ig.lt_442 ro.jw.un_420
  0x281168a6, 0x172d2912, 0x190a28af, 0x0a106b04,   // ig.ro.sw_521 sl.sk.sr_654  sw.pt.gl_655 ceb.lt.pt_332
  // [2d80]
  0x64001a08, 0x3b006e04, 0x4a0b2507, 0x100a19a4,   // tl.lg.un_430 hmn.so.un_320  eu.es.yo_432 gl.pt.lt_433
  0x35555205, 0x0c080e08, 0x0c000418, 0x0802060c,   // ha.rw.zu_333 is.no.sv_443  fi.sv.un_740 de.da.no_543
  0x531b52a6, 0x6800070e, 0x1e250704, 0x032805a7,   // ha.tr.ht_521 it.ig.un_550  it.eu.ms_332 fr.sw.nl_532
  0x0b003b21, 0x31001e04, 0x040806a0, 0x6435120c,   // so.es.un_860 ms.az.un_320  de.no.fi_322 hu.zu.lg_543
  // [2d90]
  0x12000a20, 0x08020ea0, 0x0a1811a4, 0x1e2d0d55,   // pt.hu.un_850 is.da.no_322  ro.ga.pt_433 cs.sk.ms_442
  0x3f000412, 0x1b310cec, 0x21134aa0, 0x061332ad,   // fi.af.un_640 sv.az.tr_644  yo.et.jw_322 bs.et.de_643
  0x23251904, 0x0b0103ad, 0x0c0e0107, 0x2d0d32a4,   // gl.eu.ca_332 nl.en.es_643  en.is.sv_432 bs.cs.sk_433
  0x13000509, 0x063f1bee, 0x081e3155, 0x193b1212,   // fr.et.un_440 tr.af.de_422  az.ms.no_442 hu.so.gl_654
  // [2da0]
  0x13000712, 0x203117a0, 0x0c076ba0, 0x2a005321,   // it.et.un_640 sr.az.sq_322  ceb.it.sv_322 ht.mt.un_860
  0x3f1a6ba0, 0x0b052108, 0x022835ec, 0x1b2d0d05,   // ceb.tl.af_322 jw.fr.es_443  zu.sw.da_644 cs.sk.tr_333
  0x231107af, 0x2d12205a, 0x02080c60, 0x252d6807,   // it.ro.ca_655 sq.hu.sk_553  sv.no.da_664 ig.sk.eu_432
  0x323b0808, 0x19000618, 0x0c006408, 0x04001e08,   // no.so.bs_443 de.gl.un_740  lg.sv.un_430 ms.fi.un_430
  // [2db0]
  0x2d122912, 0x290e1905, 0x5300051b, 0x13000518,   // sl.hu.sk_654 gl.is.sl_333  fr.ht.un_770 fr.et.un_740
  0x09553512, 0x321620ad, 0x212852ee, 0x120208a4,   // zu.rw.pl_654 sq.hr.bs_643  ha.sw.jw_422 no.da.hu_433
  0x522128a7, 0x64285211, 0x52002114, 0x130f21a4,   // sw.jw.ha_532 ha.sw.lg_653  jw.ha.un_660 jw.lv.et_433
  0x6b190a0d, 0x1e281c04, 0x17002a07, 0x1c211e11,   // pt.gl.ceb_554 id.sw.ms_332  mt.sr.un_420 ms.jw.id_653
  // [2dc0]
  0x1f000121, 0x051109ad, 0x1c2113ad, 0x17000814,   // en.cy.un_860 pl.ro.fr_643  et.jw.id_643 uk.sr.un_660
  0x1e1c52ec, 0x3f090f08, 0x11093fa0, 0x100411ad,   // ha.id.ms_644 lv.pl.af_443  af.pl.ro_322 ro.ru.be_643
  0x09002912, 0x0419210c, 0x070905a4, 0x53001a02,   // sl.pl.un_640 jw.gl.fi_543  fr.pl.it_433 tl.ht.un_220
  0x351a4a0c, 0x1c211bad, 0x2a25350c, 0x19680b0c,   // yo.tl.zu_543 tr.jw.id_643  zu.eu.mt_543 es.ig.gl_543
  // [2dd0]
  0x1704100c, 0x0a1c21a7, 0x091217a0, 0x25001e13,   // be.ru.sr_543 jw.id.pt_532  sr.hu.pl_322 ms.eu.un_650
  0x0c021ca0, 0x032511ee, 0x12050907, 0x08001e0d,   // id.da.sv_322 ro.eu.nl_422  pl.fr.hu_432 ms.no.un_540
  0x553b20ec, 0x0a100408, 0x135564a0, 0x6b132aa0,   // sq.so.rw_644 fi.lt.pt_443  lg.rw.et_322 mt.et.ceb_322
  0x05070b08, 0x0b311b1d, 0x28006b0d, 0x0e031bec,   // es.it.fr_443 tr.az.es_852  ceb.sw.un_540 tr.nl.is_644
  // [2de0]
  0x212035a4, 0x100a520d, 0x550e350c, 0x082331ad,   // zu.sq.jw_433 ha.pt.lt_554  zu.is.rw_543 az.ca.no_643
  0x113f6404, 0x030618a9, 0x3b000707, 0x643f030c,   // lg.af.ro_332 ga.de.nl_544  it.so.un_420 nl.af.lg_543
  0x12001f14, 0x070b0a09, 0x08001709, 0x35062511,   // cy.hu.un_660 pt.es.it_444  sr.uk.un_440 eu.de.zu_653
  0x1a070e0d, 0x07081104, 0x10190b02, 0x042028a0,   // is.it.tl_554 ro.uk.bg_332  es.gl.lt_222 sw.sq.fi_322
  // [2df0]
  0x04136408, 0x04004a19, 0x13060c04, 0x12006b0d,   // lg.et.fi_443 yo.fi.un_750  sv.de.et_332 ceb.hu.un_540
  0x0e1206ec, 0x1e1c2014, 0x10201107, 0x2a112014,   // de.hu.is_644 sq.id.ms_666  ro.sq.lt_432 sq.ro.mt_666
  0x13001f1a, 0x011e68a0, 0x080253a0, 0x0400181a,   // cy.et.un_760 ig.ms.en_322  ht.da.no_322 ga.fi.un_760
  0x312a21a0, 0x061a2808, 0x21061c07, 0x6b2d0dad,   // jw.mt.az_322 sw.tl.de_443  id.de.jw_432 cs.sk.ceb_643
  // [2e00]
  0x641c21a0, 0x285206af, 0x2a292704, 0x6b00210d,   // jw.id.lg_322 de.ha.sw_655  gd.sl.mt_332 jw.ceb.un_540
  0x64280da0, 0x04002812, 0x09001c22, 0x13006b08,   // cs.sw.lg_322 sw.fi.un_640  mr.hi.un_870 ceb.et.un_430
  0x051e1c04, 0x13640408, 0x17321607, 0x041355a4,   // id.ms.fr_332 fi.lg.et_443  hr.bs.sr_432 rw.et.fi_433
  0x5564200c, 0x296435ee, 0x20551c07, 0x040313ee,   // sq.lg.rw_543 zu.lg.sl_422  id.rw.sq_432 et.nl.fi_422
  // [2e10]
  0x062832a0, 0x64003f08, 0x23002a08, 0x19000d19,   // bs.sw.de_322 af.lg.un_430  mt.ca.un_430 cs.gl.un_750
  0x52283513, 0x10170a05, 0x2a003533, 0x1e555208,   // zu.sw.ha_665 mk.sr.be_333  zu.mt.un_A70 ha.rw.ms_443
  0x25352807, 0x04293507, 0x5204100c, 0x201235a0,   // sw.zu.eu_432 zu.sl.fi_432  lt.fi.ha_543 zu.hu.sq_322
  0x01000511, 0x12003f05, 0x02031ca0, 0x64523b08,   // fr.en.un_630 af.hu.un_330  id.nl.da_322 so.ha.lg_443
  // [2e20]
  0x03001f20, 0x320d2aa4, 0x28526405, 0x050f55a0,   // cy.nl.un_850 mt.cs.bs_433  lg.ha.sw_333 rw.lv.fr_322
  0x25001913, 0x08001029, 0x55200c05, 0x17202a04,   // gl.eu.un_650 be.uk.un_960  sv.sq.rw_333 mt.sq.sr_332
  0x3b006813, 0x350664a0, 0x190b2308, 0x13001c22,   // ig.so.un_650 lg.de.zu_322  ca.es.gl_443 mr.bh.un_870
  0x113218ee, 0x551228a4, 0x0800100b, 0x0b002507,   // ga.bs.ro_422 sw.hu.rw_433  be.uk.un_520 eu.es.un_420
  // [2e30]
  0x1653280b, 0x3b285204, 0x530c1208, 0x28531309,   // sw.ht.hr_542 ha.sw.so_332  hu.sv.ht_443 et.ht.sw_444
  0x0b0a05a9, 0x041e1c5a, 0x01270511, 0x0b321704,   // fr.pt.es_544 id.ms.fi_553  fr.gd.en_653 sr.bs.es_332
  0x29172a07, 0x206455ad, 0x05001c04, 0x06111704,   // mt.sr.sl_432 rw.lg.sq_643  id.fr.un_320 sr.ro.de_332
  0x1e1c09ec, 0x190b050e, 0x355355a9, 0x20285511,   // pl.id.ms_644 fr.es.gl_555  rw.ht.zu_544 rw.sw.sq_653
  // [2e40]
  0x3f5228ad, 0x55351cad, 0x4a133b5a, 0x68001e04,   // sw.ha.af_643 id.zu.rw_643  so.et.yo_553 ms.ig.un_320
  0x6800090d, 0x4a0313a4, 0x64133b11, 0x64092a0d,   // pl.ig.un_540 et.nl.yo_433  so.et.lg_653 mt.pl.lg_554
  0x55005319, 0x160f0da7, 0x686455a9, 0x680603a4,   // ht.rw.un_750 cs.lv.hr_532  rw.lg.ig_544 nl.de.ig_433
  0x07080205, 0x35005308, 0x03556405, 0x230128ee,   // da.no.it_333 ht.zu.un_430  lg.rw.nl_333 sw.en.ca_422
  // [2e50]
  0x040a07a7, 0x3f1f030e, 0x0802010c, 0x250301a6,   // bg.mk.ru_532 nl.cy.af_555  en.da.no_543 en.nl.eu_521
  0x1f063fa4, 0x3f6b0304, 0x21001902, 0x55283514,   // af.de.cy_433 nl.ceb.af_332  gl.jw.un_220 zu.sw.rw_666
  0x553509a4, 0x0c061302, 0x5500530e, 0x1f006e2a,   // pl.zu.rw_433 et.de.sv_222  ht.rw.un_550 hmn.cy.un_970
  0x03133f12, 0x190512ac, 0x28006405, 0x52645512,   // af.et.nl_654 hu.fr.gl_632  lg.sw.un_330 rw.lg.ha_654
  // [2e60]
  0x092835a0, 0x28351c0c, 0x531a2813, 0x09000f0c,   // zu.sw.pl_322 id.zu.sw_543  sw.tl.ht_665 lv.pl.un_530
  0x1c351e12, 0x0a0704a0, 0x2a3f03a9, 0x033f06a9,   // ms.zu.id_654 ru.bg.mk_322  nl.af.mt_544 de.af.nl_544
  0x033f06ad, 0x311b2a17, 0x033f6b02, 0x3b00211b,   // de.af.nl_643 mt.tr.az_753  ceb.af.nl_222 jw.so.un_770
  0x12000c04, 0x13000c19, 0x55285202, 0x236b0e04,   // sv.hu.un_320 sv.et.un_750  ha.sw.rw_222 is.ceb.ca_332
  // [2e70]
  0x23200b13, 0x2a6b1a0c, 0x041017ad, 0x19641355,   // es.sq.ca_665 tl.ceb.mt_543  sr.be.ru_643 et.lg.gl_442
  0x011f2aee, 0x3b3508a4, 0x18000611, 0x204a1a0b,   // mt.cy.en_422 no.zu.so_433  de.ga.un_630 tl.yo.sq_542
  0x080c1fec, 0x645255a4, 0x4a526807, 0x11040708,   // cy.sv.no_644 rw.ha.lg_433  ig.ha.yo_432 bg.ru.ro_443
  0x3f044a09, 0x216b1a05, 0x095213a0, 0x216b1a08,   // yo.fi.af_444 tl.ceb.jw_333  et.ha.pl_322 tl.ceb.jw_443
  // [2e80]
  0x08000c21, 0x0b032ba7, 0x3f321cee, 0x0a006b05,   // sv.no.un_860 vi.nl.es_532  id.bs.af_422 ceb.pt.un_330
  0x3b285513, 0x1c1f1aa4, 0x2535640c, 0x3b130e0c,   // rw.sw.so_665 tl.cy.id_433  lg.zu.eu_543 is.et.so_543
  0x190b2314, 0x2a2007ee, 0x0e351c07, 0x2b0c0507,   // ca.es.gl_666 it.sq.mt_422  id.zu.is_432 fr.sv.vi_432
  0x6b211a13, 0x1f061a07, 0x680d06a7, 0x6b002108,   // tl.jw.ceb_665 tl.de.cy_432  de.cs.ig_532 jw.ceb.un_430
  // [2e90]
  0x11000e13, 0x111a6bad, 0x1f2a550c, 0x20285204,   // is.ro.un_650 ceb.tl.ro_643  rw.mt.cy_543 ha.sw.sq_332
  0x643f35ad, 0x2100352b, 0x32005504, 0x553568ec,   // zu.af.lg_643 zu.jw.un_980  rw.bs.un_320 ig.zu.rw_644
  0x09522a11, 0x6418275a, 0x0410530b, 0x535535af,   // mt.ha.pl_653 gd.ga.lg_553  ht.lt.fi_542 zu.rw.ht_655
  0x01093507, 0x3f080308, 0x01070513, 0x68556408,   // zu.pl.en_432 nl.no.af_443  fr.it.en_665 lg.rw.ig_443
  // [2ea0]
  0x0d063b0c, 0x093b285a, 0x27001321, 0x283b64a9,   // so.de.cs_543 sw.so.pl_553  et.gd.un_860 lg.so.sw_544
  0x09000309, 0x5500642a, 0x0000292d, 0x16640955,   // nl.pl.un_440 lg.rw.un_970  sl.un.un_A00 pl.lg.hr_442
  0x0300640d, 0x16530ca0, 0x23000b07, 0x07100409,   // lg.nl.un_540 sv.ht.hr_322  es.ca.un_420 ru.be.bg_444
  0x13061ea0, 0x0d001f1a, 0x55006407, 0x03520107,   // ms.de.et_322 cy.cs.un_760  lg.rw.un_420 en.ha.nl_432
  // [2eb0]
  0x3b231907, 0x5500352b, 0x0807045a, 0x18002b2b,   // gl.ca.so_432 zu.rw.un_980  ru.bg.uk_553 vi.ga.un_980
  0x102531a0, 0x232a0da7, 0x10000d13, 0x52002104,   // az.eu.lt_322 cs.mt.ca_532  cs.lt.un_650 jw.ha.un_320
  0x25521313, 0x21063f12, 0x55251a12, 0x1300121a,   // et.ha.eu_665 af.de.jw_654  tl.eu.rw_654 hu.et.un_760
  0x3b211c07, 0x08002a05, 0x643f55af, 0x1c001904,   // id.jw.so_432 mt.no.un_330  rw.af.lg_655 gl.id.un_320
  // [2ec0]
  0x32000f08, 0x07110405, 0x0d005208, 0x043b03ee,   // lv.bs.un_430 ru.ro.bg_333  ha.cs.un_430 nl.so.fi_422
  0x0a110f11, 0x033f0205, 0x063f2b0b, 0x1f190704,   // lv.ro.pt_653 da.af.nl_333  vi.af.de_542 it.gl.cy_332
  0x09003202, 0x05013b02, 0x3f350da7, 0x101117a0,   // bs.pl.un_220 so.en.fr_222  cs.zu.af_532 sr.ro.lt_322
  0x1f090d07, 0x0c001b19, 0x28004a21, 0x201b1008,   // cs.pl.cy_432 tr.sv.un_750  yo.sw.un_860 lt.tr.sq_443
  // [2ed0]
  0x20001008, 0x1c1e2111, 0x53281602, 0x2b001f09,   // lt.sq.un_430 jw.ms.id_653  hr.sw.ht_222 cy.vi.un_440
  0x1b10200b, 0x29002007, 0x21004a23, 0x6b2b280d,   // sq.lt.tr_542 sq.sl.un_420  yo.jw.un_880 sw.vi.ceb_554
  0x4a000a19, 0x17110808, 0x55213511, 0x13052008,   // pt.yo.un_750 uk.ro.sr_443  zu.jw.rw_653 sq.fr.et_443
  0x233f6b07, 0x2700051b, 0x2a084aa0, 0x2d1b20ee,   // ceb.af.ca_432 fr.gd.un_770  yo.no.mt_322 sq.tr.sk_422
  // [2ee0]
  0x05001914, 0x19230f5a, 0x5255350d, 0x0e2a0faf,   // gl.fr.un_660 lv.ca.gl_553  zu.rw.ha_554 lv.mt.is_655
  0x3f180b5a, 0x0a55280c, 0x16110da4, 0x19116407,   // es.ga.af_553 sw.rw.pt_543  cs.ro.hr_433 lg.ro.gl_432
  0x05230b02, 0x6b6428a4, 0x2b003521, 0x162b32ee,   // es.ca.fr_222 sw.lg.ceb_433  zu.vi.un_860 bs.vi.hr_422
  0x2000190d, 0x09283507, 0x13033f05, 0x0d12090c,   // gl.sq.un_540 zu.sw.pl_432  af.nl.et_333 pl.hu.cs_543
  // [2ef0]
  0x20101304, 0x116b35a9, 0x06093f02, 0x0f006404,   // et.lt.sq_332 zu.ceb.ro_544  af.pl.de_222 lg.lv.un_320
  0x52002813, 0x201013a9, 0x182705af, 0x1a002813,   // sw.ha.un_650 et.lt.sq_544  fr.gd.ga_655 sw.tl.un_650
  0x3b121107, 0x2500111a, 0x3b1e550e, 0x12642811,   // ro.hu.so_432 ro.eu.un_760  rw.ms.so_555 sw.lg.hu_653
  0x16192307, 0x202a07a7, 0x0c1306ac, 0x0d091c08,   // ca.gl.hr_432 it.mt.sq_532  de.et.sv_632 mr.hi.ne_443
  // [2f00]
  0x64003204, 0x68352804, 0x11100412, 0x070810ee,   // bs.lg.un_320 sw.zu.ig_332  ru.be.ro_654 be.uk.bg_422
  0x0f2a0d07, 0x551321ad, 0x08022da4, 0x520e09a7,   // cs.mt.lv_432 jw.et.rw_643  sk.da.no_433 pl.is.ha_532
  0x1a0e6ba4, 0x17000e08, 0x18001221, 0x645568a4,   // ceb.is.tl_433 is.sr.un_430  ur.ar.un_860 ig.rw.lg_433
  0x0112130c, 0x2300052a, 0x64352855, 0x32100ea7,   // et.hu.en_543 fr.ca.un_970  sw.zu.lg_442 is.lt.bs_532
  // [2f10]
  0x0700230c, 0x53001921, 0x35001e02, 0x201b32a0,   // ca.it.un_530 gl.ht.un_860  ms.zu.un_220 bs.tr.sq_322
  0x5364550c, 0x281e35ad, 0x09001e04, 0x55680aa4,   // rw.lg.ht_543 zu.ms.sw_643  ms.pl.un_320 pt.ig.rw_433
  0x6b5325a0, 0x08021eee, 0x071108a7, 0x3f530511,   // eu.ht.ceb_322 ms.da.no_422  uk.ro.bg_532 fr.ht.af_653
  0x05002112, 0x18000e08, 0x00002a2d, 0x0e1025a6,   // jw.fr.un_640 is.ga.un_430  mt.un.un_A00 eu.lt.is_521
  // [2f20]
  0x4a0e130d, 0x32000e08, 0x18001604, 0x191355a0,   // et.is.yo_554 is.bs.un_430  hr.ga.un_320 rw.et.gl_322
  0x0d4a1902, 0x03003202, 0x3b000304, 0x55351bee,   // gl.yo.cs_222 bs.nl.un_220  nl.so.un_320 tr.zu.rw_422
  0x290f0d07, 0x060a25ad, 0x21311b5a, 0x2d1e1c02,   // cs.lv.sl_432 eu.pt.de_643  tr.az.jw_553 id.ms.sk_222
  0x1c0f01ee, 0x10005305, 0x3b275508, 0x08170aaf,   // en.lv.id_422 ht.lt.un_330  rw.gd.so_443 mk.sr.uk_655
  // [2f30]
  0x0b00230d, 0x1f1c21a0, 0x100a0805, 0x1800170e,   // ca.es.un_540 jw.id.cy_322  uk.mk.be_333 sr.ga.un_550
  0x03002013, 0x1e1c230c, 0x64001021, 0x2a071ca9,   // sq.nl.un_650 ca.id.ms_543  lt.lg.un_860 id.it.mt_544
  0x100e64a4, 0x25001c13, 0x2d292008, 0x1b003b04,   // lg.is.lt_433 id.eu.un_650  sq.sl.sk_443 so.tr.un_320
  0x05011e07, 0x2a1168a4, 0x20000e05, 0x52284a0b,   // ms.en.fr_432 ig.ro.mt_433  is.sq.un_330 yo.sw.ha_542
  // [2f40]
  0x1a6b1e0c, 0x1c2d0d14, 0x080407a9, 0x13110707,   // ms.ceb.tl_543 cs.sk.id_666  bg.ru.uk_544 it.ro.et_432
  0x06040305, 0x2a103b04, 0x0d11230e, 0x2a070413,   // nl.fi.de_333 so.lt.mt_332  ca.ro.cs_555 fi.it.mt_665
  0x2a1264ad, 0x071117a4, 0x101225ad, 0x04100707,   // lg.hu.mt_643 sr.ro.bg_433  eu.hu.lt_643 bg.be.ru_432
  0x0e001022, 0x1e1c3505, 0x64282a12, 0x0b000a29,   // lt.is.un_870 zu.id.ms_333  mt.sw.lg_654 pt.es.un_960
  // [2f50]
  0x52136e04, 0x3f030c04, 0x1e001012, 0x08066b02,   // hmn.et.ha_332 sv.nl.af_332  lt.ms.un_640 ceb.de.no_222
  0x1f006e19, 0x083f25a0, 0x2a645509, 0x196e1a12,   // hmn.cy.un_750 eu.af.no_322  rw.lg.mt_444 tl.hmn.gl_654
  0x061252a4, 0x13072a5a, 0x31002704, 0x6e001f22,   // ha.hu.de_433 mt.it.et_553  gd.az.un_320 cy.hmn.un_870
  0x1a0b6ea7, 0x12000705, 0x1108040c, 0x120802ee,   // hmn.es.tl_532 it.hu.un_330  ru.uk.ro_543 da.no.hu_422
  // [2f60]
  0x310e1a07, 0x3500201a, 0x0d292daf, 0x1a0e270c,   // tl.is.az_432 sq.zu.un_760  sk.sl.cs_655 gd.is.tl_543
  0x640a3507, 0x02002704, 0x1600090c, 0x1f04050c,   // zu.pt.lg_432 gd.da.un_320  pl.hr.un_530 fr.fi.cy_543
  0x0b190a08, 0x6e00050d, 0x5500111b, 0x0d000a12,   // pt.gl.es_443 fr.hmn.un_540  ro.rw.un_770 pt.cs.un_640
  0x313b1ea0, 0x113f25ad, 0x072916a9, 0x1000130c,   // ms.so.az_322 eu.af.ro_643  hr.sl.it_544 et.lt.un_530
  // [2f70]
  0x11004a02, 0x123f6ba4, 0x103127ad, 0x2d1307a0,   // yo.ro.un_220 ceb.af.hu_433  gd.az.lt_643 it.et.sk_322
  0x35080c0d, 0x04000705, 0x1e00640d, 0x03006b08,   // sv.no.zu_554 bg.ru.un_330  lg.ms.un_540 ceb.nl.un_430
  0x051c21a0, 0x18032307, 0x190d2d0c, 0x18002109,   // jw.id.fr_322 ca.nl.ga_432  sk.cs.gl_543 fa.ar.un_440
  0x2b2a25a0, 0x0a0704ec, 0x2d0d0ba0, 0x2d0f0704,   // eu.mt.vi_322 ru.bg.mk_644  es.cs.sk_322 it.lv.sk_332
  // [2f80]
  0x2a072013, 0x4a5325ad, 0x2d002911, 0x1b0464a4,   // sq.it.mt_665 eu.ht.yo_643  sl.sk.un_630 lg.fi.tr_433
  0x08001108, 0x0717045a, 0x0410170c, 0x191f0b12,   // ro.uk.un_430 ru.sr.bg_553  sr.be.ru_543 es.cy.gl_654
  0x53552811, 0x0f001313, 0x2d001214, 0x10001122,   // sw.rw.ht_653 et.lv.un_650  hu.sk.un_660 ro.be.un_870
  0x0d0f2807, 0x526428ad, 0x0e6b64a0, 0x211204a9,   // sw.lv.cs_432 sw.lg.ha_643  lg.ceb.is_322 fi.hu.jw_544
  // [2f90]
  0x132855af, 0x0b001004, 0x0804070d, 0x1f005502,   // rw.sw.et_655 lt.es.un_320  bg.ru.uk_554 rw.cy.un_220
  0x19000302, 0x111355a9, 0x19000104, 0x190b1005,   // nl.gl.un_220 rw.et.ro_544  en.gl.un_320 lt.es.gl_333
  0x32000808, 0x1a352804, 0x03001804, 0x200552a4,   // no.bs.un_430 sw.zu.tl_332  ga.nl.un_320 ha.fr.sq_433
  0x0e0c0807, 0x03055508, 0x0f28130c, 0x20003204,   // no.sv.is_432 rw.fr.nl_443  et.sw.lv_543 bs.sq.un_320
  // [2fa0]
  0x050311a4, 0x062a250c, 0x0f5210a4, 0x10002520,   // ro.nl.fr_433 eu.mt.de_543  lt.ha.lv_433 eu.lt.un_850
  0x05003b05, 0x521b2860, 0x3b002519, 0x6b28350c,   // so.fr.un_330 sw.tr.ha_664  eu.so.un_750 zu.sw.ceb_543
  0x35100f08, 0x06002513, 0x213f06ee, 0x4a100f11,   // lv.lt.zu_443 eu.de.un_650  de.af.jw_422 lv.lt.yo_653
  0x20321ca0, 0x1b1013a6, 0x1e4a52ac, 0x0805230c,   // id.bs.sq_322 et.lt.tr_521  ha.yo.ms_632 ca.fr.no_543
  // [2fb0]
  0x0f1335a4, 0x100e0f09, 0x2a2855ec, 0x130f25a4,   // zu.et.lv_433 lv.is.lt_444  rw.sw.mt_644 eu.lv.et_433
  0x10282104, 0x12190b04, 0x1c35210c, 0x1e1c64a4,   // jw.sw.lt_332 es.gl.hu_332  jw.zu.id_543 lg.id.ms_433
  0x251e1c0d, 0x52006822, 0x1c1b10a4, 0x6b001e08,   // id.ms.eu_554 ig.ha.un_870  lt.tr.id_433 ms.ceb.un_430
  0x3f000804, 0x1b3b5512, 0x080255a4, 0x551352a9,   // no.af.un_320 rw.so.tr_654  rw.da.no_433 ha.et.rw_544
  // [2fc0]
  0x2800551a, 0x551b3b08, 0x52001a22, 0x641a52ad,   // rw.sw.un_760 so.tr.rw_443  tl.ha.un_870 ha.tl.lg_643
  0x101708a4, 0x52211cac, 0x4a1b5512, 0x31003b12,   // uk.sr.be_433 id.jw.ha_632  rw.tr.yo_654 so.az.un_640
  0x130f1013, 0x5228350c, 0x1b005521, 0x1a552105,   // lt.lv.et_665 zu.sw.ha_543  rw.tr.un_860 jw.rw.tl_333
  0x6b001a35, 0x1100130c, 0x1a001b20, 0x523b1bad,   // tl.ceb.un_A90 et.ro.un_530  tr.tl.un_850 tr.so.ha_643
  // [2fd0]
  0x55281e0b, 0x550c64ec, 0x211a1e07, 0x1107685a,   // ms.sw.rw_542 lg.sv.rw_644  ms.tl.jw_432 ig.it.ro_553
  0x110f2104, 0x25005221, 0x0f11285a, 0x3b001b08,   // jw.lv.ro_332 ha.eu.un_860  sw.ro.lv_553 tr.so.un_430
  0x2811680c, 0x21356eee, 0x3b520f08, 0x12001107,   // ig.ro.sw_543 hmn.zu.jw_422  lv.ha.so_443 ro.hu.un_420
  0x28521b08, 0x35645560, 0x64041055, 0x35531a08,   // tr.ha.sw_443 rw.lg.zu_664  lt.fi.lg_442 tl.ht.zu_443
  // [2fe0]
  0x556428a9, 0x0418130d, 0x2a005205, 0x1e21280c,   // sw.lg.rw_544 et.ga.fi_554  ha.mt.un_330 sw.jw.ms_543
  0x1b041ead, 0x210f520c, 0x0812185a, 0x0528010c,   // ms.fi.tr_643 ha.lv.jw_543  ga.hu.no_553 en.sw.fr_543
  0x1c0f1e0c, 0x281a55a4, 0x1b5355ad, 0x181125ad,   // ms.lv.id_543 rw.tl.sw_433  rw.ht.tr_643 eu.ro.ga_643
  0x08170a02, 0x030f10a9, 0x120f3b0c, 0x3b1b55ec,   // mk.sr.uk_222 lt.lv.nl_544  so.lv.hu_543 rw.tr.so_644
  // [2ff0]
  0x09642811, 0x351b550c, 0x1204525a, 0x11090709,   // sw.lg.pl_653 rw.tr.zu_543  ha.fi.hu_553 it.pl.ro_444
  0x1e1c030c, 0x522a3bec, 0x1318040c, 0x2700042a,   // nl.id.ms_543 so.mt.ha_644  fi.ga.et_543 fi.gd.un_970
  0x281e68a4, 0x2009520c, 0x29001c13, 0x033f6404,   // ig.ms.sw_433 ha.pl.sq_543  id.sl.un_650 lg.af.nl_332
  0x2500031a, 0x182702a0, 0x0518040c, 0x1b0c0208,   // nl.eu.un_760 da.gd.ga_322  fi.ga.fr_543 da.sv.tr_443

  // [3000]
  0x02123f0c, 0x180768a0, 0x181f23a4, 0x07001902,   // af.hu.da_543 ig.it.ga_322  ca.cy.ga_433 gl.it.un_220
  0x0f1a04ad, 0x100e3ba4, 0x281304ad, 0x31000a0d,   // fi.tl.lv_643 so.is.lt_433  fi.et.sw_643 pt.az.un_540
  0x3f2527a0, 0x133f2904, 0x0f1827ec, 0x2a003b14,   // gd.eu.af_322 sl.af.et_332  gd.ga.lv_644 so.mt.un_660
  0x131e0ea0, 0x07045208, 0x12055205, 0x642855a4,   // is.ms.et_322 ha.fi.it_443  ha.fr.hu_333 rw.sw.lg_433
  // [3010]
  0x0a2a070e, 0x0d1c0907, 0x1200251a, 0x10182704,   // it.mt.pt_555 hi.mr.ne_432  eu.hu.un_760 gd.ga.lt_332
  0x10040f08, 0x0c0229a4, 0x111e21a9, 0x211c52ec,   // lv.fi.lt_443 sl.da.sv_433  jw.ms.ro_544 ha.id.jw_644
  0x03136e05, 0x3b202aa7, 0x2b001113, 0x32055212,   // hmn.et.nl_333 mt.sq.so_532  ro.vi.un_650 ha.fr.bs_654
  0x11081708, 0x253f100c, 0x12290e12, 0x230f0aa4,   // sr.uk.ro_443 lt.af.eu_543  is.sl.hu_654 pt.lv.ca_433
  // [3020]
  0x53000702, 0x12132a08, 0x100f0413, 0x20115504,   // it.ht.un_220 mt.et.hu_443  fi.lv.lt_665 rw.ro.sq_332
  0x0f052709, 0x06040f0b, 0x00001201, 0x0a2b010c,   // gd.fr.lv_444 lv.fi.de_542  ur.un.un_200 en.vi.pt_543
  0x05232907, 0x35000421, 0x29643504, 0x0a00070e,   // sl.ca.fr_432 fi.zu.un_860  zu.lg.sl_332 bg.mk.un_550
  0x3b003f09, 0x0f0428ee, 0x3f3b0304, 0x3b046ba9,   // af.so.un_440 sw.fi.lv_422  nl.so.af_332 ceb.fi.so_544
  // [3030]
  0x6e00010d, 0x1017080c, 0x07002105, 0x530c1ba4,   // en.hmn.un_540 uk.sr.be_543  jw.it.un_330 tr.sv.ht_433
  0x2d090d0d, 0x20001819, 0x20001702, 0x3f1a03a9,   // cs.pl.sk_554 ga.sq.un_750  sr.sq.un_220 nl.tl.af_544
  0x0b0a03a4, 0x0a250ead, 0x060b270c, 0x016b31a0,   // nl.pt.es_433 is.eu.pt_643  gd.es.de_543 az.ceb.en_322
  0x0b3b5512, 0x1f53080b, 0x3f000c04, 0x6b1a550d,   // rw.so.es_654 no.ht.cy_542  sv.af.un_320 rw.tl.ceb_554
  // [3040]
  0x031827a4, 0x100725a7, 0x133b070c, 0x05190b13,   // gd.ga.nl_433 eu.it.lt_532  it.so.et_543 es.gl.fr_665
  0x3b211308, 0x321c2107, 0x2d0d23a0, 0x1a201208,   // et.jw.so_443 jw.id.bs_432  ca.cs.sk_322 hu.sq.tl_443
  0x0b0c64a4, 0x53272012, 0x216b1a5a, 0x091f5304,   // lg.sv.es_433 sq.gd.ht_654  tl.ceb.jw_553 ht.cy.pl_332
  0x27001108, 0x1e1c10ec, 0x17001308, 0x1e1c11ec,   // ro.gd.un_430 lt.id.ms_644  et.sr.un_430 ro.id.ms_644
  // [3050]
  0x551a530d, 0x6435550c, 0x321725ec, 0x21003b05,   // ht.tl.rw_554 rw.zu.lg_543  eu.sr.bs_644 so.jw.un_330
  0x080c3ba9, 0x06023fa9, 0x0711100c, 0x1107010c,   // so.sv.no_544 af.da.de_544  lt.ro.it_543 en.it.ro_543
  0x0602230c, 0x21521aa4, 0x0c083107, 0x0511180c,   // ca.da.de_543 tl.ha.jw_433  az.no.sv_432 ga.ro.fr_543
  0x10002809, 0x04031ca0, 0x1709520c, 0x281053a4,   // sw.lt.un_440 id.nl.fi_322  ha.pl.sr_543 ht.lt.sw_433
  // [3060]
  0x0c0708a0, 0x0710230c, 0x3f3b03af, 0x106455a4,   // no.it.sv_322 ca.lt.it_543  nl.so.af_655 rw.lg.lt_433
  0x061225ad, 0x25001e08, 0x1e130409, 0x0800290d,   // eu.hu.de_643 ms.eu.un_430  fi.et.ms_444 sl.no.un_540
  0x2310110c, 0x5212070c, 0x06000508, 0x16113107,   // ro.lt.ca_543 it.hu.ha_543  fr.de.un_430 az.ro.hr_432
  0x10006407, 0x0f0a100d, 0x03006e19, 0x2564550d,   // lg.lt.un_420 lt.pt.lv_554  hmn.nl.un_750 rw.lg.eu_554
  // [3070]
  0x06055311, 0x28645505, 0x0f1a130d, 0x3f351307,   // ht.fr.de_653 rw.lg.sw_333  et.tl.lv_554 et.zu.af_432
  0x2d000a09, 0x6e686b05, 0x0e001707, 0x1e1c130c,   // pt.sk.un_440 ceb.ig.hmn_333  sr.is.un_420 et.id.ms_543
  0x1b282a55, 0x11001009, 0x04101c07, 0x11050404,   // mt.sw.tr_442 lt.ro.un_440  id.lt.fi_432 fi.fr.ro_332
  0x070a2355, 0x08023fa0, 0x08115308, 0x16530408,   // ca.pt.it_442 af.da.no_322  ht.ro.no_443 fi.ht.hr_443
  // [3080]
  0x1768130c, 0x6b0913a4, 0x04133508, 0x1a64280b,   // et.ig.sr_543 et.pl.ceb_433  zu.et.fi_443 sw.lg.tl_542
  0x04081702, 0x09131c11, 0x17002109, 0x31321708,   // sr.uk.ru_222 mr.bh.hi_653  jw.sr.un_440 sr.bs.az_443
  0x32080c04, 0x21000a08, 0x32003b08, 0x35002011,   // sv.no.bs_332 pt.jw.un_430  so.bs.un_430 sq.zu.un_630
  0x0b6b3ba0, 0x213b1ca4, 0x0a003b19, 0x5500350c,   // so.ceb.es_322 id.so.jw_433  so.pt.un_750 zu.rw.un_530
  // [3090]
  0x55003b18, 0x3b1e1c08, 0x210c13af, 0x6e00210c,   // so.rw.un_740 id.ms.so_443  et.sv.jw_655 jw.hmn.un_530
  0x35285512, 0x0e000412, 0x4a6e6804, 0x28553b60,   // rw.sw.zu_654 fi.is.un_640  ig.hmn.yo_332 so.rw.sw_664
  0x232811a7, 0x1004085a, 0x32170fec, 0x0b2d0d0d,   // ro.sw.ca_532 uk.ru.be_553  lv.sr.bs_644 cs.sk.es_554
  0x09000108, 0x0a071002, 0x6e016ba7, 0x0a524aee,   // en.pl.un_430 be.bg.mk_222  ceb.en.hmn_532 yo.ha.pt_422
  // [30a0]
  0x28006414, 0x0d00041a, 0x0d2928a6, 0x13001f04,   // lg.sw.un_660 fi.cs.un_760  sw.sl.cs_521 cy.et.un_320
  0x25000a07, 0x3b0b210c, 0x0e002a04, 0x112305ad,   // pt.eu.un_420 jw.es.so_543  mt.is.un_320 fr.ca.ro_643
  0x211c1113, 0x2d0d01ee, 0x0e001c1a, 0x35213b08,   // ro.id.jw_665 en.cs.sk_422  id.is.un_760 so.jw.zu_443
  0x2b170ba0, 0x1e1c0ea9, 0x3f20090c, 0x32170ead,   // es.sr.vi_322 is.id.ms_544  pl.sq.af_543 is.sr.bs_643
  // [30b0]
  0x08022014, 0x1b680e09, 0x01001e04, 0x4a643b08,   // sq.da.no_666 is.ig.tr_444  ms.en.un_320 so.lg.yo_443
  0x182b20a4, 0x2d00190e, 0x13643b0b, 0x0a000e2a,   // sq.vi.ga_433 gl.sk.un_550  so.lg.et_542 is.pt.un_970
  0x081f0c0c, 0x2d0d28a0, 0x02003504, 0x643b13a4,   // sv.cy.no_543 sw.cs.sk_322  zu.da.un_320 et.so.lg_433
  0x0a040855, 0x04000908, 0x133b6407, 0x1031110c,   // uk.ru.mk_442 pl.fi.un_430  lg.so.et_432 ro.az.lt_543
  // [30c0]
  0x012d0d55, 0x27002018, 0x06110302, 0x0a170811,   // cs.sk.en_442 sq.gd.un_740  nl.ro.de_222 uk.sr.mk_653
  0x64133baf, 0x0335285a, 0x10110708, 0x32171ca0,   // so.et.lg_655 sw.zu.nl_553  it.ro.lt_443 id.sr.bs_322
  0x02000619, 0x3b136408, 0x316b1ba4, 0x2d0d01a9,   // de.da.un_750 lg.et.so_443  tr.ceb.az_433 en.cs.sk_544
  0x1900010c, 0x19122d55, 0x0e2a200c, 0x6b000919,   // en.gl.un_530 sk.hu.gl_442  sq.mt.is_543 pl.ceb.un_750
  // [30d0]
  0x531c0e04, 0x1f11070b, 0x680d04ad, 0x53050e05,   // is.id.ht_332 it.ro.cy_542  fi.cs.ig_643 is.fr.ht_333
  0x02000a04, 0x0e1b010c, 0x13280e0c, 0x201b3b07,   // pt.da.un_320 en.tr.is_543  is.sw.et_543 so.tr.sq_432
  0x1b001e13, 0x23002b2b, 0x4a643b0c, 0x072a1309,   // ms.tr.un_650 vi.ca.un_980  so.lg.yo_543 et.mt.it_444
  0x043b6408, 0x2b1c1e12, 0x2a550e0c, 0x230a0b5a,   // lg.so.fi_443 ms.id.vi_654  is.rw.mt_543 es.pt.ca_553
  // [30e0]
  0x13643b13, 0x10000807, 0x12290fad, 0x230a0108,   // so.lg.et_665 uk.be.un_420  lv.sl.hu_643 en.pt.ca_443
  0x13121f12, 0x6b010607, 0x29091309, 0x20120304,   // cy.hu.et_654 de.en.ceb_432  et.pl.sl_444 nl.hu.sq_332
  0x0e641aec, 0x6b1f06ac, 0x3f1e01a7, 0x52355504,   // tl.lg.is_644 de.cy.ceb_632  en.ms.af_532 rw.zu.ha_332
  0x1e1c5509, 0x310e2da4, 0x192d1205, 0x2d1b53ad,   // rw.id.ms_444 sk.is.az_433  hu.sk.gl_333 ht.tr.sk_643
  // [30f0]
  0x1c2120af, 0x180e12b4, 0x3b1355af, 0x0e071c0c,   // sq.jw.id_655 hu.is.ga_754  rw.et.so_655 id.it.is_543
  0x032b1cee, 0x11132813, 0x07130e55, 0x1f0e2512,   // id.vi.nl_422 sw.et.ro_665  is.et.it_442 eu.is.cy_654
  0x0b231904, 0x3b002808, 0x29072da0, 0x2a180911,   // gl.ca.es_332 sw.so.un_430  sk.it.sl_322 pl.ga.mt_653
  0x13002805, 0x28094a0d, 0x1a645311, 0x13111aee,   // sw.et.un_330 yo.pl.sw_554  ht.lg.tl_653 tl.ro.et_422
  // [3100]
  0x2d3b550c, 0x0e092907, 0x0f002913, 0x253555ad,   // rw.so.sk_543 sl.pl.is_432  sl.lv.un_650 rw.zu.eu_643
  0x3b64550c, 0x0e002a13, 0x1b553507, 0x641a55a4,   // rw.lg.so_543 mt.is.un_650  zu.rw.tr_432 rw.tl.lg_433
  0x6421550c, 0x53000719, 0x130e55a4, 0x6e25040d,   // rw.jw.lg_543 it.ht.un_750  rw.is.et_433 fi.eu.hmn_554
  0x0810070c, 0x35285514, 0x042528a9, 0x25002823,   // bg.be.uk_543 rw.sw.zu_666  sw.eu.fi_544 sw.eu.un_880
  // [3110]
  0x2a00290e, 0x644a68a4, 0x1c352112, 0x25282308,   // sl.mt.un_550 ig.yo.lg_433  jw.zu.id_654 ca.sw.eu_443
  0x171629ee, 0x4a28680c, 0x080e1011, 0x02002504,   // sl.hr.sr_422 ig.sw.yo_543  lt.is.no_653 eu.da.un_320
  0x2a00291a, 0x06005304, 0x18002804, 0x282025af,   // sl.mt.un_760 ht.de.un_320  sw.ga.un_320 eu.sq.sw_655
  0x6e280407, 0x2500230d, 0x28251e0c, 0x29190707,   // fi.sw.hmn_432 ca.eu.un_540  ms.eu.sw_543 it.gl.sl_432
  // [3120]
  0x17071002, 0x07291604, 0x1b125204, 0x202825ad,   // be.bg.sr_222 hr.sl.it_332  ha.hu.tr_332 eu.sw.sq_643
  0x2104250c, 0x25130707, 0x04001c08, 0x2b00191b,   // eu.fi.jw_543 it.et.eu_432  id.fi.un_430 gl.vi.un_770
  0x2d00180e, 0x35004a09, 0x162a2904, 0x521e4aa7,   // ga.sk.un_550 yo.zu.un_440  sl.mt.hr_332 yo.ms.ha_532
  0x080a02a0, 0x1f006e09, 0x29100faf, 0x162905a7,   // da.pt.no_322 hmn.cy.un_440  lv.lt.sl_655 fr.sl.hr_532
  // [3130]
  0x133116ee, 0x6b0501a4, 0x201a6b12, 0x1f0918a4,   // hr.az.et_422 en.fr.ceb_433  ceb.tl.sq_654 ga.pl.cy_433
  0x08000a02, 0x2d000914, 0x2d0d120e, 0x09213f07,   // mk.uk.un_220 pl.sk.un_660  hu.cs.sk_555 af.jw.pl_432
  0x23002902, 0x07000819, 0x1c0d0908, 0x55286b04,   // sl.ca.un_220 uk.bg.un_750  hi.ne.mr_443 ceb.sw.rw_332
  0x4a005308, 0x28002a04, 0x130802ee, 0x120a1fee,   // ht.yo.un_430 mt.sw.un_320  da.no.et_422 cy.pt.hu_422
  // [3140]
  0x18011f04, 0x19180bee, 0x1f520b04, 0x1a005502,   // cy.en.ga_332 es.ga.gl_422  es.ha.cy_332 rw.tl.un_220
  0x10202504, 0x111c1ead, 0x20523fa4, 0x20216b60,   // eu.sq.lt_332 ms.id.ro_643  af.ha.sq_433 ceb.jw.sq_664
  0x683520ee, 0x5528200c, 0x0a0711a6, 0x031101a4,   // sq.zu.ig_422 sq.sw.rw_543  ro.bg.mk_521 en.ro.nl_433
  0x09103fa4, 0x0b0603af, 0x2809040c, 0x20003507,   // af.lt.pl_433 nl.de.es_655  fi.pl.sw_543 zu.sq.un_420
  // [3150]
  0x2500201a, 0x100904ac, 0x180711af, 0x072025ee,   // sq.eu.un_760 fi.pl.lt_632  ro.it.ga_655 eu.sq.it_422
  0x1b1120a6, 0x28521e0c, 0x553f20ec, 0x050401a6,   // sq.ro.tr_521 ms.ha.sw_543  sq.af.rw_644 en.fi.fr_521
  0x1e2025a9, 0x09022d0c, 0x1b523507, 0x051f2308,   // eu.sq.ms_544 sk.da.pl_543  zu.ha.tr_432 ca.cy.fr_443
  0x252307a7, 0x21006b09, 0x52004a13, 0x07092d0b,   // it.ca.eu_532 ceb.jw.un_440  yo.ha.un_650 sk.pl.it_542
  // [3160]
  0x04000a02, 0x2d070ba4, 0x286b1a08, 0x0e3b52a0,   // mk.ru.un_220 es.it.sk_433  tl.ceb.sw_443 ha.so.is_322
  0x213b1e11, 0x6b1a1fad, 0x3f010704, 0x1c1a1ea9,   // ms.so.jw_653 cy.tl.ceb_643  it.en.af_332 ms.tl.id_544
  0x2b0128a0, 0x1a003b20, 0x213b1e08, 0x1200640b,   // sw.en.vi_322 so.tl.un_850  ms.so.jw_443 lg.hu.un_520
  0x170a1004, 0x03060912, 0x25002013, 0x521a6b5a,   // be.mk.sr_332 pl.de.nl_654  sq.eu.un_650 ceb.tl.ha_553
  // [3170]
  0x083f27a0, 0x0e6b1a07, 0x1c3568ee, 0x52280960,   // gd.af.no_322 tl.ceb.is_432  ig.zu.id_422 pl.sw.ha_664
  0x64005222, 0x2d0a050c, 0x0b072304, 0x03133f04,   // ha.lg.un_870 fr.pt.sk_543  ca.it.es_332 af.et.nl_332
  0x103f0412, 0x640c520c, 0x09110f14, 0x0400062b,   // fi.af.lt_654 ha.sv.lg_543  lv.ro.pl_666 de.fi.un_980
  0x1c521e0b, 0x200a07a4, 0x03000929, 0x0d0105a4,   // ms.ha.id_542 it.pt.sq_433  pl.nl.un_960 fr.en.cs_433
  // [3180]
  0x18120e08, 0x2d042a0c, 0x531a2107, 0x010608a0,   // is.hu.ga_443 mt.fi.sk_543  jw.tl.ht_432 no.de.en_322
  0x25071807, 0x18311b0d, 0x04131104, 0x20002504,   // ga.it.eu_432 tr.az.ga_554  ro.et.fi_332 eu.sq.un_320
  0x35281c08, 0x20050204, 0x0e00230e, 0x1a521e0c,   // id.sw.zu_443 da.fr.sq_332  ca.is.un_550 ms.ha.tl_543
  0x2d0d1105, 0x100e120c, 0x1e210107, 0x0c0711a7,   // ro.cs.sk_333 hu.is.lt_543  en.jw.ms_432 ro.it.sv_532
  // [3190]
  0x0a050112, 0x122a2008, 0x12080c0d, 0x2a6425a9,   // en.fr.pt_654 sq.mt.hu_443  sv.no.hu_554 eu.lg.mt_544
  0x0c006404, 0x180a0ca9, 0x6b3b1aec, 0x17111055,   // lg.sv.un_320 sv.pt.ga_544  tl.so.ceb_644 be.ro.sr_442
  0x116820a9, 0x3f0902a0, 0x080223a0, 0x06006408,   // sq.ig.ro_544 da.pl.af_322  ca.da.no_322 lg.de.un_430
  0x03063fee, 0x3f120c07, 0x1a080205, 0x111e1c04,   // af.de.nl_422 sv.hu.af_432  da.no.tl_333 id.ms.ro_332
  // [31a0]
  0x53351204, 0x0c6408a0, 0x6b1a0ba4, 0x25190b0d,   // hu.zu.ht_332 no.lg.sv_322  es.tl.ceb_433 es.gl.eu_554
  0x050a3f08, 0x110410af, 0x06005204, 0x29003204,   // af.pt.fr_443 be.ru.ro_655  ha.de.un_320 bs.sl.un_320
  0x2d000e20, 0x1a311ead, 0x12001e13, 0x162d68a0,   // is.sk.un_850 ms.az.tl_643  ms.hu.un_650 ig.sk.hr_322
  0x28001219, 0x12071108, 0x281a180c, 0x5200641a,   // hu.sw.un_750 ro.it.hu_443  ga.tl.sw_543 lg.ha.un_760
  // [31b0]
  0x120a2d0d, 0x12072a12, 0x1b0e0c0c, 0x6b1a5212,   // sk.pt.hu_554 mt.it.hu_654  sv.is.tr_543 ha.tl.ceb_654
  0x252164a6, 0x0b182707, 0x0b071107, 0x1c2155a9,   // lg.jw.eu_521 gd.ga.es_432  ro.it.es_432 rw.jw.id_544
  0x11251ea0, 0x09251813, 0x553564ad, 0x6b1a520d,   // ms.eu.ro_322 ga.eu.pl_665  lg.zu.rw_643 ha.tl.ceb_554
  0x551a64a4, 0x0e00190e, 0x2a0f2155, 0x6b645509,   // lg.tl.rw_433 gl.is.un_550  jw.lv.mt_442 rw.lg.ceb_444
  // [31c0]
  0x272d0d0e, 0x6b000712, 0x64001008, 0x040f25af,   // cs.sk.gd_555 it.ceb.un_640  lt.lg.un_430 eu.lv.fi_655
  0x04002504, 0x254a6407, 0x293b520c, 0x13002022,   // eu.fi.un_320 lg.yo.eu_432  ha.so.sl_543 sq.et.un_870
  0x64555211, 0x322a1712, 0x20005504, 0x64551ba9,   // ha.rw.lg_653 sr.mt.bs_654  rw.sq.un_320 tr.rw.lg_544
  0x211b520c, 0x0d001604, 0x1600170c, 0x35084aee,   // ha.tr.jw_543 hr.cs.un_320  sr.hr.un_530 yo.no.zu_422
  // [31d0]
  0x110625a4, 0x1c001f08, 0x1335520b, 0x046425a7,   // eu.de.ro_433 cy.id.un_430  ha.zu.et_542 eu.lg.fi_532
  0x023f1f12, 0x1c281ea9, 0x09001222, 0x0b0407ec,   // cy.af.da_654 ms.sw.id_544  hu.pl.un_870 it.fi.es_644
  0x0f101c0c, 0x0c071f07, 0x1e3b2a11, 0x04071109,   // id.lt.lv_543 cy.it.sv_432  mt.so.ms_653 ro.bg.ru_444
  0x130f100d, 0x28204aa0, 0x1f3b52a9, 0x1e1c3109,   // lt.lv.et_554 yo.sq.sw_322  ha.so.cy_544 az.id.ms_444
  // [31e0]
  0x1e1c52ee, 0x13041ba9, 0x210a0b05, 0x252d0d60,   // ha.id.ms_422 tr.fi.et_544  es.pt.jw_333 cs.sk.eu_664
  0x1b00320c, 0x0a2319a0, 0x20001f02, 0x0f254aee,   // bs.tr.un_530 gl.ca.pt_322  cy.sq.un_220 yo.eu.lv_422
  0x2d010209, 0x06006e22, 0x13250d0c, 0x1c0e6ead,   // da.en.sk_444 hmn.de.un_870  cs.eu.et_543 hmn.is.id_643
  0x6b001c13, 0x0c311b13, 0x6b1a0107, 0x01250307,   // id.ceb.un_650 tr.az.sv_665  en.tl.ceb_432 nl.eu.en_432
  // [31f0]
  0x1100171a, 0x10040e08, 0x1a6b4a13, 0x3b4a070c,   // sr.ro.un_760 is.fi.lt_443  yo.ceb.tl_665 it.yo.so_543
  0x6b1a1e0c, 0x1f001214, 0x18050807, 0x1c3f030c,   // ms.tl.ceb_543 hu.cy.un_660  no.fr.ga_432 nl.af.id_543
  0x08031ca0, 0x52216b13, 0x2d1806a7, 0x021208ee,   // id.nl.no_322 ceb.jw.ha_665  de.ga.sk_532 no.hu.da_422
  0x161b5255, 0x203202ad, 0x216b1a11, 0x13211ca6,   // ha.tr.hr_442 da.bs.sq_643  tl.ceb.jw_653 id.jw.et_521
  // [3200]
  0x1b0705a9, 0x271218a6, 0x5521280c, 0x4a64040c,   // fr.it.tr_544 ga.hu.gd_521  sw.jw.rw_543 fi.lg.yo_543
  0x2b002104, 0x2b211c08, 0x110701a4, 0x08271307,   // jw.vi.un_320 id.jw.vi_443  en.it.ro_433 et.gd.no_432
  0x071209a7, 0x0b232da4, 0x21041c11, 0x2d0d20af,   // pl.hu.it_532 sk.ca.es_433  id.fi.jw_653 sq.cs.sk_655
  0x321019ee, 0x0e0208af, 0x08002504, 0x1e1b3111,   // gl.lt.bs_422 no.da.is_655  eu.no.un_320 az.tr.ms_653
  // [3210]
  0x170710ee, 0x31201c07, 0x1c5255a6, 0x52002502,   // be.bg.sr_422 id.sq.az_432  rw.ha.id_521 eu.ha.un_220
  0x190b11a6, 0x080321a0, 0x0c216ea7, 0x122008a9,   // ro.es.gl_521 jw.nl.no_322  hmn.jw.sv_532 no.sq.hu_544
  0x316e3b12, 0x2b3b120c, 0x530a05a9, 0x10002a21,   // so.hmn.az_654 hu.so.vi_543  fr.pt.ht_544 mt.lt.un_860
  0x11074aa0, 0x07112304, 0x0100080d, 0x1a000808,   // yo.it.ro_322 ca.ro.it_332  no.en.un_540 no.tl.un_430
  // [3220]
  0x29005205, 0x28270ba4, 0x6b1c1aa4, 0x52351a13,   // ha.sl.un_330 es.gd.sw_433  tl.id.ceb_433 tl.zu.ha_665
  0x162307a0, 0x1a522113, 0x0e3b0da0, 0x09000705,   // it.ca.hr_322 jw.ha.tl_665  cs.so.is_322 it.pl.un_330
  0x092852ad, 0x03071105, 0x2864100c, 0x3b285212,   // ha.sw.pl_643 ro.it.nl_333  lt.lg.sw_543 ha.sw.so_654
  0x290f32ee, 0x0600640b, 0x68002a08, 0x68005214,   // bs.lv.sl_422 lg.de.un_520  mt.ig.un_430 ha.ig.un_660
  // [3230]
  0x52281aa9, 0x313b2a08, 0x533b28a0, 0x2d0d100c,   // tl.sw.ha_544 mt.so.az_443  sw.so.ht_322 lt.cs.sk_543
  0x0e6b1aa7, 0x3f005205, 0x13043b0c, 0x02090512,   // tl.ceb.is_532 ha.af.un_330  so.fi.et_543 fr.pl.da_654
  0x3f113507, 0x285209ad, 0x0810110c, 0x3b3521ec,   // zu.ro.af_432 pl.ha.sw_643  ro.be.uk_543 jw.zu.so_644
  0x27282504, 0x211a2807, 0x2b040804, 0x020906a0,   // eu.sw.gd_332 sw.tl.jw_432  no.fi.vi_332 de.pl.da_322
  // [3240]
  0x64354a07, 0x13003b0d, 0x21095212, 0x2d0306ec,   // yo.zu.lg_432 so.et.un_540  ha.pl.jw_654 de.nl.sk_644
  0x281a520c, 0x52002804, 0x0c1c31a0, 0x230205ad,   // ha.tl.sw_543 sw.ha.un_320  az.id.sv_322 fr.da.ca_643
  0x215535ee, 0x553f2dee, 0x2d090607, 0x35643ba7,   // zu.rw.jw_422 sk.af.rw_422  de.pl.sk_432 so.lg.zu_532
  0x18000514, 0x01005308, 0x010335a0, 0x110408a4,   // fr.ga.un_660 ht.en.un_430  zu.nl.en_322 uk.ru.ro_433
  // [3250]
  0x31536405, 0x2d001707, 0x3b130408, 0x0c350205,   // lg.ht.az_333 sr.sk.un_420  fi.et.so_443 da.zu.sv_333
  0x0413110c, 0x20071b55, 0x03060204, 0x311b0107,   // ro.et.fi_543 tr.it.sq_442  da.de.nl_332 en.tr.az_432
  0x64321708, 0x051364af, 0x10110712, 0x31001b05,   // sr.bs.lg_443 lg.et.fr_655  it.ro.lt_654 tr.az.un_330
  0x08321609, 0x2a52280c, 0x53132a04, 0x2a6b010c,   // hr.bs.no_444 sw.ha.mt_543  mt.et.ht_332 en.ceb.mt_543
  // [3260]
  0x3b000108, 0x2a00010d, 0x0d1c0904, 0x081f28a9,   // en.so.un_430 en.mt.un_540  hi.mr.ne_332 sw.cy.no_544
  0x530d3fee, 0x07005313, 0x0f6b01ad, 0x106b55ee,   // af.cs.ht_422 ht.it.un_650  en.ceb.lv_643 rw.ceb.lt_422
  0x23070508, 0x050c0809, 0x35001c02, 0x686b010c,   // fr.it.ca_443 no.sv.fr_444  id.zu.un_220 en.ceb.ig_543
  0x091c13ee, 0x13002a13, 0x3b001c0d, 0x1c0d095a,   // bh.mr.hi_422 mt.et.un_650  id.so.un_540 hi.ne.mr_553
  // [3270]
  0x281c6402, 0x18006b09, 0x0727010c, 0x686b350c,   // lg.id.sw_222 ceb.ga.un_440  en.gd.it_543 zu.ceb.ig_543
  0x0a2305a4, 0x35001704, 0x0c2a01a4, 0x072301a4,   // fr.ca.pt_433 sr.zu.un_320  en.mt.sv_433 en.ca.it_433
  0x130108a4, 0x181127a7, 0x122a0708, 0x160932ee,   // no.en.et_433 gd.ro.ga_532  it.mt.hu_443 bs.pl.hr_422
  0x1c001329, 0x04003f04, 0x2a003114, 0x05001702,   // bh.mr.un_960 af.fi.un_320  az.mt.un_660 sr.fr.un_220
  // [3280]
  0x523b2855, 0x0d091312, 0x051a01a4, 0x1e1c1714,   // sw.so.ha_442 bh.hi.ne_654  en.tl.fr_433 sr.id.ms_666
  0x05090707, 0x191729a9, 0x12001c04, 0x211e290c,   // it.pl.fr_432 sl.sr.gl_544  id.hu.un_320 sl.ms.jw_543
  0x08100aec, 0x21352711, 0x3b0464a4, 0x35002908,   // mk.be.uk_644 gd.zu.jw_653  lg.fi.so_433 sl.zu.un_430
  0x08022005, 0x64352111, 0x1f3f0408, 0x1635290c,   // sq.da.no_333 jw.zu.lg_653  fi.af.cy_443 sl.zu.hr_543
  // [3290]
  0x0b190a13, 0x3b00352a, 0x1e3b0d12, 0x08170712,   // pt.gl.es_665 zu.so.un_970  cs.so.ms_654 bg.sr.uk_654
  0x06130c0c, 0x0f131005, 0x0a00110c, 0x190b0c09,   // sv.et.de_543 lt.et.lv_333  ro.mk.un_530 sv.es.gl_444
  0x641e2505, 0x29000f05, 0x03003b18, 0x171b250b,   // eu.ms.lg_333 lv.sl.un_330  so.nl.un_740 eu.tr.sr_542
  0x080e1f05, 0x554a6460, 0x16291ca0, 0x061304ec,   // cy.is.no_333 lg.yo.rw_664  id.sl.hr_322 fi.et.de_644
  // [32a0]
  0x04080c0c, 0x640a3b11, 0x23000609, 0x11000709,   // sv.no.fi_543 so.pt.lg_653  de.ca.un_440 it.ro.un_440
  0x27132dad, 0x0b0c0255, 0x310c080c, 0x0e6b2714,   // sk.et.gd_643 da.sv.es_442  no.sv.az_543 gd.ceb.is_666
  0x29003519, 0x1c111e0c, 0x31002a13, 0x10090fac,   // zu.sl.un_750 ms.ro.id_543  mt.az.un_650 lv.pl.lt_632
  0x12002721, 0x3f120207, 0x2017290c, 0x20322a02,   // gd.hu.un_860 da.hu.af_432  sl.sr.sq_543 mt.bs.sq_222
  // [32b0]
  0x02066bee, 0x1a6b3b12, 0x10002d19, 0x1e000305,   // ceb.de.da_422 so.ceb.tl_654  sk.lt.un_750 nl.ms.un_330
  0x27555209, 0x06000702, 0x0c0a04ec, 0x11000c1b,   // ha.rw.gd_444 it.de.un_220  fi.pt.sv_644 sv.ro.un_770
  0x10070413, 0x041b3f08, 0x523b550c, 0x04003f1a,   // ru.bg.be_665 af.tr.fi_443  rw.so.ha_543 af.fi.un_760
  0x31002a0e, 0x0f310c02, 0x04271813, 0x080e29a4,   // mt.az.un_550 sv.az.lv_222  ga.gd.fi_665 sl.is.no_433
  // [32c0]
  0x020611ee, 0x13030c05, 0x2a1e5205, 0x101827ad,   // ro.de.da_422 sv.nl.et_333  ha.ms.mt_333 gd.ga.lt_643
  0x0e001222, 0x2705010c, 0x04001822, 0x06000104,   // hu.is.un_870 en.fr.gd_543  ga.fi.un_870 en.de.un_320
  0x2d100faf, 0x1c2b640c, 0x11002809, 0x1f091855,   // lv.lt.sk_655 lg.vi.id_543  sw.ro.un_440 ga.pl.cy_442
  0x3b2b04a7, 0x16291704, 0x08006b02, 0x21552860,   // fi.vi.so_532 sr.sl.hr_332  ceb.no.un_220 sw.rw.jw_664
  // [32d0]
  0x4a113b04, 0x68271813, 0x28000423, 0x1f5311a4,   // so.ro.yo_332 ga.gd.ig_665  fi.sw.un_880 ro.ht.cy_433
  0x681a6b12, 0x130410a4, 0x08003f02, 0x071a100c,   // ceb.tl.ig_654 lt.fi.et_433  af.no.un_220 lt.tl.it_543
  0x271107a4, 0x0b00520d, 0x11002a04, 0x00006b2d,   // it.ro.gd_433 ha.es.un_540  mt.ro.un_320 ceb.un.un_A00
  0x3b002814, 0x0d001318, 0x180e2702, 0x0e003204,   // sw.so.un_660 bh.ne.un_740  gd.is.ga_222 bs.is.un_320
  // [32e0]
  0x062a680b, 0x64130f08, 0x1c214aa0, 0x3507640c,   // ig.mt.de_542 lv.et.lg_443  yo.jw.id_322 lg.it.zu_543
  0x04201305, 0x0f111313, 0x052701a4, 0x2100100d,   // et.sq.fi_333 et.ro.lv_665  en.gd.fr_433 lt.jw.un_540
  0x1f6b35ee, 0x041801a4, 0x35130f09, 0x011827ad,   // zu.ceb.cy_422 en.ga.fi_433  lv.et.zu_444 gd.ga.en_643
  0x28133514, 0x073b27ad, 0x171a5255, 0x281f200c,   // zu.et.sw_666 gd.so.it_643  ha.tl.sr_442 sq.cy.sw_543
  // [32f0]
  0x0f136408, 0x07100a07, 0x6b2a2713, 0x1e04130c,   // lg.et.lv_443 mk.be.bg_432  gd.mt.ceb_665 et.fi.ms_543
  0x68041312, 0x0a28350c, 0x021b1808, 0x080201af,   // et.fi.ig_654 zu.sw.pt_543  ga.tr.da_443 en.da.no_655
  0x1000011a, 0x533f010c, 0x180506a9, 0x0c00030c,   // en.lt.un_760 en.af.ht_543  de.fr.ga_544 nl.sv.un_530
  0x32160909, 0x27061e05, 0x17232102, 0x533f13ad,   // pl.hr.bs_444 ms.de.gd_333  jw.ca.sr_222 et.af.ht_643
  // [3300]
  0x20000219, 0x25033f09, 0x023f13a4, 0x0f642805,   // da.sq.un_750 af.nl.eu_444  et.af.da_433 sw.lg.lv_333
  0x521328ad, 0x1a0c6ba4, 0x3f1327a4, 0x0420130c,   // sw.et.ha_643 ceb.sv.tl_433  gd.et.af_433 et.sq.fi_543
  0x19001012, 0x11000121, 0x10001f23, 0x09004a08,   // lt.gl.un_640 en.ro.un_860  cy.lt.un_880 yo.pl.un_430
  0x12002008, 0x2a001e07, 0x0c2552a4, 0x091827af,   // sq.hu.un_430 ms.mt.un_420  ha.eu.sv_433 gd.ga.pl_655
  // [3310]
  0x19530b08, 0x09271812, 0x35006822, 0x3b3f1b08,   // es.ht.gl_443 ga.gd.pl_654  ig.zu.un_870 tr.af.so_443
  0x04111708, 0x051f18a4, 0x0d001e07, 0x10070a13,   // sr.ro.ru_443 ga.cy.fr_433  ms.cs.un_420 mk.bg.be_665
  0x5300682a, 0x041355ec, 0x642855af, 0x065301a4,   // ig.ht.un_970 rw.et.fi_644  rw.sw.lg_655 en.ht.de_433
  0x0603530c, 0x2a182709, 0x2d0d06a9, 0x3f1320a9,   // ht.nl.de_543 gd.ga.mt_444  de.cs.sk_544 sq.et.af_544
  // [3320]
  0x18092713, 0x35002313, 0x040d2dad, 0x0600280e,   // gd.pl.ga_665 ca.zu.un_650  sk.cs.fi_643 sw.de.un_550
  0x09270605, 0x18272a0c, 0x0306270c, 0x12003508,   // de.gd.pl_333 mt.gd.ga_543  gd.de.nl_543 zu.hu.un_430
  0x64003508, 0x195306a4, 0x0f006819, 0x06003b19,   // zu.lg.un_430 de.ht.gl_433  ig.lv.un_750 so.de.un_750
  0x2500530c, 0x01003f02, 0x1e1c3ba4, 0x270918af,   // ht.eu.un_530 af.en.un_220  so.id.ms_433 ga.pl.gd_655
  // [3330]
  0x091827a9, 0x21000c0c, 0x6805060c, 0x07002a0c,   // gd.ga.pl_544 sv.jw.un_530  de.fr.ig_543 mt.it.un_530
  0x32172aa9, 0x0e020c0c, 0x0603285a, 0x181f270c,   // mt.sr.bs_544 sv.da.is_543  sw.nl.de_553 gd.cy.ga_543
  0x4a1e1ca4, 0x64006814, 0x16001208, 0x2a001f34,   // id.ms.yo_433 ig.lg.un_660  hu.hr.un_430 cy.mt.un_A80
  0x181327ee, 0x08170408, 0x21002011, 0x0e000818,   // gd.et.ga_422 ru.sr.uk_443  sq.jw.un_630 no.is.un_740
  // [3340]
  0x23000708, 0x02131a08, 0x250e52ee, 0x2a001e04,   // it.ca.un_430 tl.et.da_443  ha.is.eu_422 ms.mt.un_320
  0x080a1109, 0x0f1f2aa4, 0x644a2aa4, 0x2000051f,   // ro.mk.uk_444 mt.cy.lv_433  mt.yo.lg_433 fr.sq.un_840
  0x2b093f07, 0x1b001108, 0x550964a0, 0x68172aa4,   // af.pl.vi_432 ro.tr.un_430  lg.pl.rw_322 mt.sr.ig_433
  0x131923ad, 0x68052b05, 0x0328090c, 0x080e2504,   // ca.gl.et_643 vi.fr.ig_333  pl.sw.nl_543 eu.is.no_332
  // [3350]
  0x08101711, 0x4a002312, 0x4a3f090b, 0x21004a04,   // sr.be.uk_653 ca.yo.un_640  pl.af.yo_542 yo.jw.un_320
  0x64004a2c, 0x2d001902, 0x05104a09, 0x02002718,   // yo.lg.un_990 gl.sk.un_220  yo.lt.fr_444 gd.da.un_740
  0x32121707, 0x11132aa4, 0x6400532a, 0x3b065305,   // sr.hu.bs_432 mt.et.ro_433  ht.lg.un_970 ht.de.so_333
  0x0a0407ac, 0x12001012, 0x010809a7, 0x18000512,   // bg.ru.mk_632 lt.hu.un_640  pl.no.en_532 fr.ga.un_640
  // [3360]
  0x1204060d, 0x116b1a07, 0x13041155, 0x32001719,   // de.fi.hu_554 tl.ceb.ro_432  ro.fi.et_442 sr.bs.un_750
  0x351b31ee, 0x0406110c, 0x640428a4, 0x1f1a3507,   // az.tr.zu_422 ro.de.fi_543  sw.fi.lg_433 zu.tl.cy_432
  0x64006b08, 0x3f0428ac, 0x1b001a09, 0x641e5207,   // ceb.lg.un_430 sw.fi.af_632  tl.tr.un_440 ha.ms.lg_432
  0x180627a7, 0x033f3b05, 0x2a002108, 0x05292aee,   // gd.de.ga_532 so.af.nl_333  jw.mt.un_430 mt.sl.fr_422
  // [3370]
  0x3f003b1b, 0x1a006e04, 0x53001913, 0x25136bec,   // so.af.un_770 hmn.tl.un_320  gl.ht.un_650 ceb.et.eu_644
  0x643528a4, 0x04100eec, 0x1e002021, 0x291107ee,   // sw.zu.lg_433 is.lt.fi_644  sq.ms.un_860 it.ro.sl_422
  0x0f002a29, 0x2a0752ec, 0x1c005307, 0x045203a0,   // mt.lv.un_960 ha.it.mt_644  ht.id.un_420 nl.ha.fi_322
  0x2d121902, 0x11521008, 0x2d000e13, 0x03001b21,   // gl.hu.sk_222 lt.ha.ro_443  is.sk.un_650 tr.nl.un_860
  // [3380]
  0x1c041aa0, 0x111735a7, 0x0e000a0c, 0x10000a04,   // tl.fi.id_322 zu.sr.ro_532  pt.is.un_530 mk.be.un_320
  0x08002102, 0x283b1a07, 0x040e23a6, 0x533f03a4,   // jw.no.un_220 tl.so.sw_432  ca.is.fi_521 nl.af.ht_433
  0x0d35040e, 0x0e001004, 0x02041308, 0x03533fa4,   // fi.zu.cs_555 lt.is.un_320  et.fi.da_443 af.ht.nl_433
  0x170a100c, 0x12001808, 0x0c00110c, 0x040f2aec,   // be.mk.sr_543 ga.hu.un_430  ro.sv.un_530 mt.lv.fi_644
  // [3390]
  0x1310115a, 0x111704a4, 0x01003504, 0x3b1712ec,   // ro.lt.et_553 ru.sr.ro_433  zu.en.un_320 hu.sr.so_644
  0x55006b04, 0x2a060112, 0x0e000104, 0x1b533504,   // ceb.rw.un_320 en.de.mt_654  en.is.un_320 zu.ht.tr_332
  0x08020ea9, 0x080207a0, 0x080223ac, 0x0503640c,   // is.da.no_544 it.da.no_322  ca.da.no_632 lg.nl.fr_543
  0x09000321, 0x28006b20, 0x19050b0c, 0x190a05a6,   // nl.pl.un_860 ceb.sw.un_850  es.fr.gl_543 fr.pt.gl_521
  // [33a0]
  0x20002802, 0x045528a0, 0x070f5207, 0x190a13ee,   // sw.sq.un_220 sw.rw.fi_322  ha.lv.it_432 et.pt.gl_422
  0x08013fa7, 0x27001112, 0x082913a4, 0x2d0d0a05,   // af.en.no_532 ro.gd.un_640  et.sl.no_433 pt.cs.sk_333
  0x5313350c, 0x2a0c08a4, 0x352513a4, 0x18002504,   // zu.et.ht_543 no.sv.mt_433  et.eu.zu_433 eu.ga.un_320
  0x29096804, 0x04323507, 0x68131f07, 0x25202109,   // ig.pl.sl_332 zu.bs.fi_432  cy.et.ig_432 jw.sq.eu_444
  // [33b0]
  0x3f00680d, 0x3b136413, 0x06350c08, 0x230d1213,   // ig.af.un_540 lg.et.so_665  sv.zu.de_443 hu.cs.ca_665
  0x354a5207, 0x10003204, 0x2064130c, 0x03553555,   // ha.yo.zu_432 bs.lt.un_320  et.lg.sq_543 zu.rw.nl_442
  0x040a19ee, 0x093125a9, 0x2a4a28ad, 0x25001c08,   // gl.pt.fi_422 eu.az.pl_544  sw.yo.mt_643 id.eu.un_430
  0x12002508, 0x53002004, 0x28000404, 0x28002a02,   // eu.hu.un_430 sq.ht.un_320  fi.sw.un_320 mt.sw.un_220
  // [33c0]
  0x35202507, 0x55125309, 0x08071004, 0x644a3baf,   // eu.sq.zu_432 ht.hu.rw_444  be.bg.uk_332 so.yo.lg_655
  0x0a051107, 0x130c35a7, 0x3b23250c, 0x3b001a02,   // ro.fr.pt_432 zu.sv.et_532  eu.ca.so_543 tl.so.un_220
  0x641f28ad, 0x282a6ba4, 0x25041108, 0x1a00011a,   // sw.cy.lg_643 ceb.mt.sw_433  ro.fi.eu_443 en.tl.un_760
  0x020c0808, 0x2835640c, 0x53000104, 0x02100807,   // no.sv.da_443 lg.zu.sw_543  en.ht.un_320 no.lt.da_432
  // [33d0]
  0x0e081fad, 0x011a2114, 0x1e1c52a4, 0x130427ad,   // cy.no.is_643 jw.tl.en_666  ha.id.ms_433 gd.fi.et_643
  0x211e04a4, 0x3f030113, 0x18000622, 0x1300641a,   // fi.ms.jw_433 en.nl.af_665  de.ga.un_870 lg.et.un_760
  0x0600101a, 0x08000408, 0x030f3f08, 0x3f1a010b,   // lt.de.un_760 ru.uk.un_430  af.lv.nl_443 en.tl.af_542
  0x1300640e, 0x321617ad, 0x640413ad, 0x2b001a0d,   // lg.et.un_550 sr.hr.bs_643  et.fi.lg_643 tl.vi.un_540
  // [33e0]
  0x0e061faf, 0x21000108, 0x23031908, 0x4a005518,   // cy.de.is_655 en.jw.un_430  gl.nl.ca_443 rw.yo.un_740
  0x040807a4, 0x3b530555, 0x00002d2d, 0x1a002821,   // bg.uk.ru_433 fr.ht.so_442  sk.un.un_A00 sw.tl.un_860
  0x03080113, 0x290b530c, 0x031a0112, 0x25216bad,   // en.no.nl_665 ht.es.sl_543  en.tl.nl_654 ceb.jw.eu_643
  0x282055a4, 0x28005229, 0x550a2307, 0x551a6b08,   // rw.sq.sw_433 ha.sw.un_960  ca.pt.rw_432 ceb.tl.rw_443
  // [33f0]
  0x1a01210c, 0x3b5528ec, 0x2a104aa9, 0x06190a09,   // jw.en.tl_543 sw.rw.so_644  yo.lt.mt_544 pt.gl.de_444
  0x3b20520c, 0x1e001119, 0x092d0faf, 0x040609b3,   // ha.sq.so_543 ro.ms.un_750  lv.sk.pl_655 pl.de.fi_743
  0x55251a05, 0x12000302, 0x52552012, 0x1c6425a0,   // tl.eu.rw_333 nl.hu.un_220  sq.rw.ha_654 eu.lg.id_322
  0x063f030c, 0x6b013ba7, 0x2000010d, 0x03250a02,   // nl.af.de_543 so.en.ceb_532  en.sq.un_540 pt.eu.nl_222

  // [3400]
  0x3b015208, 0x083f12a9, 0x10182755, 0x52553ba9,   // ha.en.so_443 hu.af.no_544  gd.ga.lt_442 so.rw.ha_544
  0x00002d24, 0x53050c11, 0x283555ac, 0x6b001a29,   // sk.un.un_900 sv.fr.ht_653  rw.zu.sw_632 tl.ceb.un_960
  0x07080aa4, 0x051f28ee, 0x121c6405, 0x036406a0,   // mk.uk.bg_433 sw.cy.fr_422  lg.id.hu_333 de.lg.nl_322
  0x255213ec, 0x2b1827af, 0x0c060107, 0x1113320d,   // et.ha.eu_644 gd.ga.vi_655  en.de.sv_432 bs.et.ro_554
  // [3410]
  0x6b3b2007, 0x680f20a6, 0x0c060407, 0x1e211c07,   // sq.so.ceb_432 sq.lv.ig_521  fi.de.sv_432 id.jw.ms_432
  0x07203b07, 0x20683f05, 0x06000412, 0x080c02a9,   // so.sq.it_432 af.ig.sq_333  fi.de.un_640 da.sv.no_544
  0x552801a4, 0x2800200d, 0x5535280c, 0x070a11a6,   // en.sw.rw_433 sq.sw.un_540  sw.zu.rw_543 ro.mk.bg_521
  0x114a18a0, 0x0e062705, 0x19280aa0, 0x18005312,   // ga.yo.ro_322 gd.de.is_333  pt.sw.gl_322 ht.ga.un_640
  // [3420]
  0x1f0306ad, 0x2d1b0107, 0x1b0f52ee, 0x12051f0c,   // de.nl.cy_643 en.tr.sk_432  ha.lv.tr_422 cy.fr.hu_543
  0x27181f0c, 0x161732a7, 0x2a0653ec, 0x6b182708,   // cy.ga.gd_543 bs.sr.hr_532  ht.de.mt_644 gd.ga.ceb_443
  0x061827ec, 0x213f6807, 0x29002a1b, 0x12003f08,   // gd.ga.de_644 ig.af.jw_432  mt.sl.un_770 af.hu.un_430
  0x0e000707, 0x09130408, 0x063b55a4, 0x1e1c2a14,   // it.is.un_420 fi.et.pl_443  rw.so.de_433 mt.id.ms_666
  // [3430]
  0x13002905, 0x05640107, 0x20002a22, 0x55286413,   // sl.et.un_330 en.lg.fr_432  mt.sq.un_870 lg.sw.rw_665
  0x2a2029af, 0x070501a0, 0x09080e07, 0x6b000108,   // sl.sq.mt_655 en.fr.it_322  is.no.pl_432 en.ceb.un_430
  0x53010ca0, 0x12180804, 0x00001a2d, 0x01006419,   // sv.en.ht_322 no.ga.hu_332  tl.un.un_A00 lg.en.un_750
  0x20092d11, 0x03006422, 0x0a18050c, 0x0c00080c,   // sk.pl.sq_653 lg.nl.un_870  fr.ga.pt_543 no.sv.un_530
  // [3440]
  0x2518270e, 0x31182709, 0x0a002814, 0x29071805,   // gd.ga.eu_555 gd.ga.az_444  sw.pt.un_660 ga.it.sl_333
  0x0200060c, 0x1b091ca0, 0x0e3b1fa4, 0x081013a4,   // de.da.un_530 id.pl.tr_322  cy.so.is_433 et.lt.no_433
  0x55356e0c, 0x08020f05, 0x31191fec, 0x1f68200c,   // hmn.zu.rw_543 lv.da.no_333  cy.gl.az_644 sq.ig.cy_543
  0x04050112, 0x053f060c, 0x28684aaf, 0x08040c04,   // en.fr.fi_654 de.af.fr_543  yo.ig.sw_655 sv.fi.no_332
  // [3450]
  0x0f0e52a9, 0x061e1ca4, 0x521a6414, 0x681f4aa9,   // ha.is.lv_544 id.ms.de_433  lg.tl.ha_666 yo.cy.ig_544
  0x042a0e11, 0x1304290c, 0x04132107, 0x20042a0c,   // is.mt.fi_653 sl.fi.et_543  jw.et.fi_432 mt.fi.sq_543
  0x18030655, 0x13290413, 0x11070408, 0x041312a4,   // de.nl.ga_442 fi.sl.et_665  ru.bg.ro_443 hu.et.fi_433
  0x283b130c, 0x3f3b09ec, 0x12000c08, 0x1732160c,   // et.so.sw_543 pl.so.af_644  sv.hu.un_430 hr.bs.sr_543
  // [3460]
  0x1e1c53ee, 0x1a643511, 0x16006808, 0x2b001308,   // ht.id.ms_422 zu.lg.tl_653  ig.hr.un_430 et.vi.un_430
  0x0d001602, 0x1b3b2804, 0x2b0301ad, 0x5200282c,   // hr.cs.un_220 sw.so.tr_332  en.nl.vi_643 sw.ha.un_990
  0x1b005208, 0x28002513, 0x21532508, 0x21005312,   // ha.tr.un_430 eu.sw.un_650  eu.ht.jw_443 ht.jw.un_640
  0x10002102, 0x126e1b04, 0x322d1702, 0x1b0129a0,   // jw.lt.un_220 tr.hmn.hu_332  sr.sk.bs_222 sl.en.tr_322
  // [3470]
  0x103f5211, 0x28531cad, 0x0a000809, 0x1e0c1ca0,   // ha.af.lt_653 id.ht.sw_643  no.pt.un_440 id.sv.ms_322
  0x190b01a9, 0x12064a07, 0x35002134, 0x180a0560,   // en.es.gl_544 yo.de.hu_432  jw.zu.un_A80 fr.pt.ga_664
  0x0802210e, 0x1e006812, 0x19230b08, 0x1f00070b,   // jw.da.no_555 ig.ms.un_640  es.ca.gl_443 it.cy.un_520
  0x351a21a9, 0x11003505, 0x6b091a07, 0x321701ee,   // jw.tl.zu_544 zu.ro.un_330  tl.pl.ceb_432 en.sr.bs_422
  // [3480]
  0x1b000420, 0x3b00041b, 0x2b016b0c, 0x0a112704,   // fi.tr.un_850 fi.so.un_770  ceb.en.vi_543 gd.ro.pt_332
  0x1f2718a4, 0x551b1aec, 0x20211ca4, 0x020e08a4,   // ga.gd.cy_433 tl.tr.rw_644  id.jw.sq_433 no.is.da_433
  0x1b1a1ea9, 0x21183555, 0x110b0907, 0x1c000a04,   // ms.tl.tr_544 zu.ga.jw_442  pl.es.ro_432 pt.id.un_320
  0x1b351ea4, 0x3528520c, 0x3564280c, 0x0c201f0c,   // ms.zu.tr_433 ha.sw.zu_543  sw.lg.zu_543 cy.sq.sv_543
  // [3490]
  0x28551e07, 0x0a236b02, 0x1a521ea0, 0x13103bec,   // ms.rw.sw_432 ceb.ca.pt_222  ms.ha.tl_322 so.lt.et_644
  0x1b022907, 0x061c6ea6, 0x35001a09, 0x530c0208,   // sl.da.tr_432 hmn.id.de_521  tl.zu.un_440 da.sv.ht_443
  0x5328050c, 0x1100010c, 0x23000b04, 0x06056eee,   // fr.sw.ht_543 en.ro.un_530  es.ca.un_320 hmn.fr.de_422
  0x21642809, 0x20131eee, 0x2b6452a0, 0x13121b0c,   // sw.lg.jw_444 ms.et.sq_422  ha.lg.vi_322 tr.hu.et_543
  // [34a0]
  0x011852a4, 0x1f006e12, 0x1b35550c, 0x101104ad,   // ha.ga.en_433 hmn.cy.un_640  rw.zu.tr_543 ru.ro.be_643
  0x3b203112, 0x0b0501a4, 0x2d0d0ba4, 0x25070cec,   // az.sq.so_654 en.fr.es_433  es.cs.sk_433 sv.it.eu_644
  0x100413ad, 0x121e25a0, 0x2a1e310c, 0x08000220,   // et.fi.lt_643 eu.ms.hu_322  az.ms.mt_543 da.no.un_850
  0x6b110c07, 0x132820ad, 0x3511550c, 0x0b4a1908,   // sv.ro.ceb_432 sq.sw.et_643  rw.ro.zu_543 gl.yo.es_443
  // [34b0]
  0x55271ea4, 0x1a001c04, 0x0a002d0d, 0x312b1c0c,   // ms.gd.rw_433 id.tl.un_320  sk.pt.un_540 id.vi.az_543
  0x353b1e04, 0x0f0c1304, 0x21356408, 0x0b0f0ca4,   // ms.so.zu_332 et.sv.lv_332  lg.zu.jw_443 sv.lv.es_433
  0x085327a4, 0x27180c0b, 0x1004070c, 0x3f1b13af,   // gd.ht.no_433 sv.ga.gd_542  bg.ru.be_543 et.tr.af_655
  0x18283fa9, 0x3f1b1260, 0x12000a07, 0x17110aa4,   // af.sw.ga_544 hu.tr.af_664  pt.hu.un_420 mk.ro.sr_433
  // [34c0]
  0x08004a04, 0x321617ac, 0x1b006404, 0x1c211eec,   // yo.no.un_320 sr.hr.bs_632  lg.tr.un_320 ms.jw.id_644
  0x100417a9, 0x12001707, 0x251e1c08, 0x0d091c60,   // sr.ru.be_544 sr.hu.un_420  id.ms.eu_443 mr.hi.ne_664
  0x6e2718ad, 0x0a000307, 0x082706ad, 0x0a1e25ad,   // ga.gd.hmn_643 nl.pt.un_420  de.gd.no_643 eu.ms.pt_643
  0x270d0607, 0x12002d04, 0x1c1e2511, 0x3b000619,   // de.cs.gd_432 sk.hu.un_320  eu.ms.id_653 de.so.un_750
  // [34d0]
  0x210a25ee, 0x4a2d18af, 0x12131b08, 0x21000507,   // eu.pt.jw_422 ga.sk.yo_655  tr.et.hu_443 fr.jw.un_420
  0x03211b0c, 0x163217a7, 0x0708170c, 0x12000708,   // tr.jw.nl_543 sr.bs.hr_532  sr.uk.bg_543 it.hu.un_430
  0x06130a05, 0x191327a9, 0x031a3f04, 0x06000521,   // pt.et.de_333 gd.et.gl_544  af.tl.nl_332 fr.de.un_860
  0x1e002514, 0x1f00210e, 0x03001f19, 0x130627a0,   // eu.ms.un_660 jw.cy.un_550  cy.nl.un_750 gd.de.et_322
  // [34e0]
  0x06001a04, 0x2a00040c, 0x053217a0, 0x31135204,   // tl.de.un_320 fi.mt.un_530  sr.bs.fr_322 ha.et.az_332
  0x13000e18, 0x033f1b08, 0x13000b02, 0x1f001807,   // is.et.un_740 tr.af.nl_443  es.et.un_220 ga.cy.un_420
  0x521b1ea4, 0x19001a02, 0x23070e0c, 0x0f001b12,   // ms.tr.ha_433 tl.gl.un_220  is.it.ca_543 tr.lv.un_640
  0x13091c12, 0x081107a9, 0x1732520c, 0x1c292aaf,   // mr.hi.bh_654 bg.ro.uk_544  ha.bs.sr_543 mt.sl.id_655
  // [34f0]
  0x04061311, 0x08020e09, 0x13060508, 0x2b1e1c0d,   // et.de.fi_653 is.da.no_444  fr.de.et_443 id.ms.vi_554
  0x2b0221a0, 0x0f002813, 0x171629af, 0x1b072a09,   // jw.da.vi_322 sw.lv.un_650  sl.hr.sr_655 mt.it.tr_444
  0x05110111, 0x19211a0d, 0x2b115204, 0x070a10a7,   // en.ro.fr_653 tl.jw.gl_554  ha.ro.vi_332 be.mk.bg_532
  0x6b003513, 0x32005207, 0x070c0412, 0x050201ee,   // zu.ceb.un_650 ha.bs.un_420  fi.sv.it_654 en.da.fr_422
  // [3500]
  0x170f0404, 0x0100070e, 0x0d001818, 0x29132a12,   // fi.lv.sr_332 it.en.un_550  ga.cs.un_740 mt.et.sl_654
  0x2d0d0905, 0x0b231208, 0x646b1a14, 0x213b2804,   // pl.cs.sk_333 hu.ca.es_443  tl.ceb.lg_666 sw.so.jw_332
  0x05073f08, 0x13041207, 0x0d2a5312, 0x180427a0,   // af.it.fr_443 hu.fi.et_432  ht.mt.cs_654 gd.fi.ga_322
  0x07003512, 0x18000408, 0x09000f20, 0x643b28a4,   // zu.it.un_640 fi.ga.un_430  lv.pl.un_850 sw.so.lg_433
  // [3510]
  0x1a040fec, 0x041707a9, 0x28003b1a, 0x3b21520c,   // lv.fi.tl_644 bg.sr.ru_544  so.sw.un_760 ha.jw.so_543
  0x19120b0c, 0x6b160807, 0x2703180e, 0x2511285a,   // es.hu.gl_543 no.hr.ceb_432  ga.nl.gd_555 sw.ro.eu_553
  0x2a002012, 0x2d002a09, 0x10000e18, 0x1218270d,   // sq.mt.un_640 mt.sk.un_440  is.lt.un_740 gd.ga.hu_554
  0x28003114, 0x033f02af, 0x170704a9, 0x030a07a0,   // az.sw.un_660 da.af.nl_655  ru.bg.sr_544 it.pt.nl_322
  // [3520]
  0x0e0906a0, 0x27062a55, 0x0f1629a9, 0x03011855,   // de.pl.is_322 mt.de.gd_442  sl.hr.lv_544 ga.en.nl_442
  0x642810ad, 0x23285502, 0x35092805, 0x061e1c14,   // lt.sw.lg_643 rw.sw.ca_222  sw.pl.zu_333 id.ms.de_666
  0x07000804, 0x32002108, 0x64201ea4, 0x0f060704,   // uk.bg.un_320 jw.bs.un_430  ms.sq.lg_433 it.de.lv_332
  0x1732160b, 0x0500270c, 0x09033f11, 0x5304050c,   // hr.bs.sr_542 gd.fr.un_530  af.nl.pl_653 fr.fi.ht_543
  // [3530]
  0x16290d12, 0x20171ea0, 0x2a1e3108, 0x2d0d4aa9,   // cs.sl.hr_654 ms.sr.sq_322  az.ms.mt_443 yo.cs.sk_544
  0x1a2564a4, 0x1b3268a4, 0x11000f19, 0x68001a13,   // lg.eu.tl_433 ig.bs.tr_433  lv.ro.un_750 tl.ig.un_650
  0x030f2a07, 0x135525a4, 0x0b2d1008, 0x35033f0c,   // mt.lv.nl_432 eu.rw.et_433  lt.sk.es_443 af.nl.zu_543
  0x06130855, 0x0d122d08, 0x0b2319a9, 0x062b27a6,   // no.et.de_442 sk.hu.cs_443  gl.ca.es_544 gd.vi.de_521
  // [3540]
  0x351b64ec, 0x21102d07, 0x52000208, 0x2000210d,   // lg.tr.zu_644 sk.lt.jw_432  da.ha.un_430 jw.sq.un_540
  0x06085308, 0x20356408, 0x2a071ea4, 0x12002a19,   // ht.no.de_443 lg.zu.sq_443  ms.it.mt_433 mt.hu.un_750
  0x1604530c, 0x11041312, 0x1e6807ad, 0x52000221,   // ht.fi.hr_543 et.fi.ro_654  it.ig.ms_643 da.ha.un_860
  0x211a4a0c, 0x0d1c0960, 0x1304640c, 0x29641b0c,   // yo.tl.jw_543 hi.mr.ne_664  lg.fi.et_543 tr.lg.sl_543
  // [3550]
  0x12001e04, 0x2d0d1ba4, 0x020c080d, 0x1300350c,   // ms.hu.un_320 tr.cs.sk_433  no.sv.da_554 zu.et.un_530
  0x35551308, 0x53002b14, 0x286435a4, 0x2a003107,   // et.rw.zu_443 vi.ht.un_660  zu.lg.sw_433 az.mt.un_420
  0x0600021b, 0x27083f0c, 0x0d092d08, 0x35041307,   // da.de.un_770 af.no.gd_543  sk.pl.cs_443 et.fi.zu_432
  0x2a230c5a, 0x0c001704, 0x1e1c2109, 0x050418ad,   // sv.ca.mt_553 sr.sv.un_320  jw.id.ms_444 ga.fi.fr_643
  // [3560]
  0x033f0605, 0x10002a0c, 0x093216a4, 0x0c1b1304,   // de.af.nl_333 mt.lt.un_530  hr.bs.pl_433 et.tr.sv_332
  0x04131b0c, 0x1c1e2155, 0x3f311ba4, 0x080201a0,   // tr.et.fi_543 jw.ms.id_442  tr.az.af_433 en.da.no_322
  0x0c13040c, 0x132a3f09, 0x0425030c, 0x0e002121,   // fi.et.sv_543 af.mt.et_444  nl.eu.fi_543 jw.is.un_860
  0x35081355, 0x1013350c, 0x25120709, 0x4a232107,   // et.no.zu_442 zu.et.lt_543  it.hu.eu_444 jw.ca.yo_432
  // [3570]
  0x1a6b3f13, 0x013f060c, 0x08004a02, 0x53231f55,   // af.ceb.tl_665 de.af.en_543  yo.no.un_220 cy.ca.ht_442
  0x072501a4, 0x2a000121, 0x04000b07, 0x033f060d,   // en.eu.it_433 en.mt.un_860  es.fi.un_420 de.af.nl_554
  0x1c272107, 0x253f0655, 0x64286860, 0x0428130c,   // jw.gd.id_432 de.af.eu_442  ig.sw.lg_664 et.sw.fi_543
  0x53000322, 0x642868af, 0x07042a0c, 0x071868a0,   // nl.ht.un_870 ig.sw.lg_655  mt.fi.it_543 ig.ga.it_322
  // [3580]
  0x212a20ad, 0x27006b05, 0x080e2012, 0x6404680e,   // sq.mt.jw_643 ceb.gd.un_330  sq.is.no_654 ig.fi.lg_555
  0x103f13a7, 0x20000e1b, 0x311b3f13, 0x3f01130c,   // et.af.lt_532 is.sq.un_770  af.tr.az_665 et.en.af_543
  0x112a01a4, 0x114a6407, 0x533f2aa9, 0x041321a7,   // en.mt.ro_433 lg.yo.ro_432  mt.af.ht_544 jw.et.fi_532
  0x16004a04, 0x046821ad, 0x21006e07, 0x171632a6,   // yo.hr.un_320 jw.ig.fi_643  hmn.jw.un_420 bs.hr.sr_521
  // [3590]
  0x1f103b0c, 0x64011f05, 0x20006e08, 0x033f01a7,   // so.lt.cy_543 cy.en.lg_333  hmn.sq.un_430 en.af.nl_532
  0x033f6ead, 0x0b0f29ee, 0x6e00202b, 0x07100411,   // hmn.af.nl_643 sl.lv.es_422  sq.hmn.un_980 ru.be.bg_653
  0x1a003509, 0x080e235a, 0x352164a4, 0x6e033f13,   // zu.tl.un_440 ca.is.no_553  lg.jw.zu_433 af.nl.hmn_665
  0x0e0f1fad, 0x53001605, 0x19002104, 0x644a21ec,   // cy.lv.is_643 hr.ht.un_330  jw.gl.un_320 jw.yo.lg_644
  // [35a0]
  0x033f6ea4, 0x172a1104, 0x3b003f19, 0x1f6828a9,   // hmn.af.nl_433 ro.mt.sr_332  af.so.un_750 sw.ig.cy_544
  0x04001e02, 0x10280405, 0x101f1105, 0x1200551b,   // ms.fi.un_220 fi.sw.lt_333  ro.cy.lt_333 rw.hu.un_770
  0x10001c02, 0x27001f19, 0x17001007, 0x08250411,   // id.lt.un_220 cy.gd.un_750  lt.sr.un_420 fi.eu.no_653
  0x25006b07, 0x27001f07, 0x12000713, 0x4a1235ec,   // ceb.eu.un_420 cy.gd.un_420  it.hu.un_650 zu.hu.yo_644
  // [35b0]
  0x00006837, 0x13006e13, 0x173216a7, 0x1c3b1e07,   // ig.un.un_B00 hmn.et.un_650  hr.bs.sr_532 ms.so.id_432
  0x08040a11, 0x0f006e02, 0x0f0e1005, 0x1f030ca0,   // mk.ru.uk_653 hmn.lv.un_220  lt.is.lv_333 sv.nl.cy_322
  0x1b351105, 0x64135202, 0x080c1bec, 0x01180eee,   // ro.zu.tr_333 ha.et.lg_222  tr.sv.no_644 is.ga.en_422
  0x0e4a0609, 0x55211e05, 0x68002508, 0x16002004,   // de.yo.is_444 ms.jw.rw_333  eu.ig.un_430 sq.hr.un_320
  // [35c0]
  0x073f6e0c, 0x27002a08, 0x311b3b0d, 0x32002804,   // hmn.af.it_543 mt.gd.un_430  so.tr.az_554 sw.bs.un_320
  0x0000240a, 0x271e1fa4, 0x1e1b0609, 0x080205af,   // yi.un.un_500 cy.ms.gd_433  de.tr.ms_444 fr.da.no_655
  0x1f232512, 0x1f060812, 0x0000160a, 0x2768530c,   // eu.ca.cy_654 no.de.cy_654  hr.un.un_500 ht.ig.gd_543
  0x170407af, 0x0f2b0308, 0x080252a4, 0x20000f14,   // bg.ru.sr_655 nl.vi.lv_443  ha.da.no_433 lv.sq.un_660
  // [35d0]
  0x19181104, 0x5500682a, 0x4a001a2b, 0x0f1a530b,   // ro.ga.gl_332 ig.rw.un_970  tl.yo.un_980 ht.tl.lv_542
  0x0c3b3fa0, 0x271808a9, 0x1b250c07, 0x3b001921,   // af.so.sv_322 no.ga.gd_544  sv.eu.tr_432 gl.so.un_860
  0x13352905, 0x0c1153ad, 0x03133f07, 0x2b000108,   // sl.zu.et_333 ht.ro.sv_643  af.et.nl_432 en.vi.un_430
  0x190701a4, 0x10311b5a, 0x20136807, 0x0a0723a9,   // en.it.gl_433 tr.az.lt_553  ig.et.sq_432 ca.it.pt_544
  // [35e0]
  0x1a311b09, 0x09023fa0, 0x6413040c, 0x1b001012,   // tr.az.tl_444 af.da.pl_322  fi.et.lg_543 lt.tr.un_640
  0x1a3b1e12, 0x04106eee, 0x101b3113, 0x3b6b1a0c,   // ms.so.tl_654 hmn.lt.fi_422  az.tr.lt_665 tl.ceb.so_543
  0x0d5553ee, 0x6e00531a, 0x050729a0, 0x3b6b1ca4,   // ht.rw.cs_422 ht.hmn.un_760  sl.it.fr_322 id.ceb.so_433
  0x184a6e04, 0x6b080108, 0x12316ead, 0x3b1a1c07,   // hmn.yo.ga_332 en.no.ceb_443  hmn.az.hu_643 id.tl.so_432
  // [35f0]
  0x53311b14, 0x036b3fa0, 0x21003b13, 0x12002819,   // tr.az.ht_666 af.ceb.nl_322  so.jw.un_650 sw.hu.un_750
  0x2a0452ad, 0x29000607, 0x12211aa0, 0x0a000412,   // ha.fi.mt_643 de.sl.un_420  tl.jw.hu_322 ru.mk.un_640
  0x643b1a0c, 0x13270eec, 0x16006b04, 0x2a101b13,   // tl.so.lg_543 is.gd.et_644  ceb.hr.un_320 tr.lt.mt_665
  0x28211a0c, 0x1e1a03ec, 0x52003b0c, 0x521a1b09,   // tl.jw.sw_543 nl.tl.ms_644  so.ha.un_530 tr.tl.ha_444
  // [3600]
  0x0d090bba, 0x1e6b1a13, 0x06002119, 0x01002702,   // bn.hi.ne_843 tl.ceb.ms_665  jw.de.un_750 gd.en.un_220
  0x27060ead, 0x081805ad, 0x1e3b1cec, 0x321b53a0,   // is.de.gd_643 fr.ga.no_643  id.so.ms_644 ht.tr.bs_322
  0x25001b22, 0x52123104, 0x230a010c, 0x01686b04,   // tr.eu.un_870 az.hu.ha_332  en.pt.ca_543 ceb.ig.en_332
  0x0a00050c, 0x1716290c, 0x055507a4, 0x1b00120d,   // fr.pt.un_530 sl.hr.sr_543  it.rw.fr_433 hu.tr.un_540
  // [3610]
  0x29001702, 0x0c0608a4, 0x10061f0b, 0x64031aa7,   // sr.sl.un_220 no.de.sv_433  cy.de.lt_542 tl.nl.lg_532
  0x18270eaf, 0x103b520c, 0x09000d02, 0x27180ead,   // is.gd.ga_655 ha.so.lt_543  ne.hi.un_220 is.ga.gd_643
  0x0b231913, 0x0e2a270c, 0x0a1f25a4, 0x271811a0,   // gl.ca.es_665 gd.mt.is_543  eu.cy.pt_433 ro.ga.gd_322
  0x081011a0, 0x1e554a04, 0x20020555, 0x19001307,   // ro.be.uk_322 yo.rw.ms_332  fr.da.sq_442 et.gl.un_420
  // [3620]
  0x3f0a01ad, 0x13201005, 0x1e3b1ca4, 0x2835550c,   // en.pt.af_643 lt.sq.et_333  id.so.ms_433 rw.zu.sw_543
  0x53000119, 0x1118270c, 0x23201ca0, 0x2a1b13a7,   // en.ht.un_750 gd.ga.ro_543  id.sq.ca_322 et.tr.mt_532
  0x11202304, 0x523b1e05, 0x1b005519, 0x201b5312,   // ca.sq.ro_332 ms.so.ha_333  rw.tr.un_750 ht.tr.sq_654
  0x3f002119, 0x176e20ad, 0x17002102, 0x06000f02,   // jw.af.un_750 sq.hmn.sr_643  jw.sr.un_220 lv.de.un_220
  // [3630]
  0x13006e04, 0x3b001909, 0x210520ad, 0x3f0b23a4,   // hmn.et.un_320 gl.so.un_440  sq.fr.jw_643 ca.es.af_433
  0x27310c02, 0x1c000920, 0x52001702, 0x1b005513,   // sv.az.gd_222 hi.mr.un_850  sr.ha.un_220 rw.tr.un_650
  0x2d0d21af, 0x1600080c, 0x6b0607ee, 0x20285208,   // jw.cs.sk_655 no.hr.un_530  it.de.ceb_422 ha.sw.sq_443
  0x1e1c13a4, 0x0b05210b, 0x0e001b2b, 0x28202108,   // et.id.ms_433 jw.fr.es_542  tr.is.un_980 jw.sq.sw_443
  // [3640]
  0x00002a37, 0x551b53ad, 0x16001c04, 0x11051707,   // mt.un.un_B00 ht.tr.rw_643  id.hr.un_320 sr.fr.ro_432
  0x0c003204, 0x1a000713, 0x3f1f0707, 0x35061faf,   // bs.sv.un_320 it.tl.un_650  it.cy.af_432 cy.de.zu_655
  0x11000704, 0x0d004a08, 0x1b0d31a0, 0x130d1c11,   // it.ro.un_320 yo.cs.un_430  az.cs.tr_322 mr.ne.bh_653
  0x02000c13, 0x1b3f0311, 0x28355512, 0x3f000704,   // sv.da.un_650 nl.af.tr_653  rw.zu.sw_654 it.af.un_320
  // [3650]
  0x0a0807af, 0x100e1aee, 0x07282008, 0x0e311b11,   // bg.uk.mk_655 tl.is.lt_422  sq.sw.it_443 tr.az.is_653
  0x20070ca4, 0x2d0d130c, 0x64205508, 0x162d29a9,   // sv.it.sq_433 et.cs.sk_543  rw.sq.lg_443 sl.sk.hr_544
  0x0213290c, 0x21051007, 0x11003105, 0x19060a0c,   // sl.et.da_543 lt.fr.jw_432  az.ro.un_330 pt.de.gl_543
  0x322a53a0, 0x04001305, 0x6e00062a, 0x52211ea4,   // ht.mt.bs_322 et.fi.un_330  de.hmn.un_970 ms.jw.ha_433
  // [3660]
  0x10060107, 0x4a1e1c08, 0x076e27ad, 0x113f0312,   // en.de.lt_432 id.ms.yo_443  gd.hmn.it_643 nl.af.ro_654
  0x1b53120c, 0x080225a4, 0x23000a08, 0x1e2535ee,   // hu.ht.tr_543 eu.da.no_433  pt.ca.un_430 zu.eu.ms_422
  0x0c68120c, 0x03096ead, 0x21001904, 0x03063f13,   // hu.ig.sv_543 hmn.pl.nl_643  gl.jw.un_320 af.de.nl_665
  0x201b320c, 0x19110b12, 0x0f6e11ad, 0x6e000512,   // bs.tr.sq_543 es.ro.gl_654  ro.hmn.lv_643 fr.hmn.un_640
  // [3670]
  0x3b00350d, 0x27000419, 0x28352dad, 0x0400251a,   // zu.so.un_540 fi.gd.un_750  sk.zu.sw_643 eu.fi.un_760
  0x17250302, 0x122b2107, 0x132355ee, 0x04004a11,   // nl.eu.sr_222 jw.vi.hu_432  rw.ca.et_422 yo.fi.un_630
  0x0a0708ad, 0x55283ba4, 0x122a6e02, 0x2a00051b,   // uk.bg.mk_643 so.sw.rw_433  hmn.mt.hu_222 fr.mt.un_770
  0x1f52070d, 0x060e04a9, 0x4a2d0d0e, 0x043b2aa4,   // it.ha.cy_554 fi.is.de_544  cs.sk.yo_555 mt.so.fi_433
  // [3680]
  0x0e2d0d0e, 0x08030e0c, 0x27531c07, 0x640e2a05,   // cs.sk.is_555 is.nl.no_543  id.ht.gd_432 mt.is.lg_333
  0x0408020d, 0x172a0f04, 0x2b002702, 0x313b640c,   // da.no.fi_554 lv.mt.sr_332  gd.vi.un_220 lg.so.az_543
  0x170f29ad, 0x0b001008, 0x0d160fa0, 0x230501af,   // sl.lv.sr_643 lt.es.un_430  lv.hr.cs_322 en.fr.ca_655
  0x041011ec, 0x29000d0d, 0x09002d07, 0x070e5208,   // ro.be.ru_644 cs.sl.un_540  sk.pl.un_420 ha.is.it_443
  // [3690]
  0x52001704, 0x27001a05, 0x0e080ca7, 0x0553010c,   // sr.ha.un_320 tl.gd.un_330  sv.no.is_532 en.ht.fr_543
  0x03056407, 0x17552907, 0x2a352d09, 0x313b3507,   // lg.fr.nl_432 sl.rw.sr_432  sk.zu.mt_444 zu.so.az_432
  0x040f27a9, 0x12190ba4, 0x022a0808, 0x281b3112,   // gd.lv.fi_544 es.gl.hu_433  no.mt.da_443 az.tr.sw_654
  0x180e27a9, 0x201e1c0c, 0x0e3b5209, 0x29003208,   // gd.is.ga_544 id.ms.sq_543  ha.so.is_444 bs.sl.un_430
  // [36a0]
  0x20111b0d, 0x050713a4, 0x21002702, 0x35641ea4,   // tr.ro.sq_554 et.it.fr_433  gd.jw.un_220 ms.lg.zu_433
  0x05312aa6, 0x07081208, 0x033f52ad, 0x0f1f5309,   // mt.az.fr_521 hu.no.it_443  ha.af.nl_643 ht.cy.lv_444
  0x095564ad, 0x281b3204, 0x0e6408a0, 0x171107a4,   // lg.rw.pl_643 bs.tr.sw_332  no.lg.is_322 bg.ro.sr_433
  0x530b1ca4, 0x0b0e2a07, 0x10000719, 0x3f2106af,   // id.es.ht_433 mt.is.es_432  it.lt.un_750 de.jw.af_655
  // [36b0]
  0x2b005308, 0x271f1813, 0x31001b07, 0x27180e0c,   // ht.vi.un_430 ga.cy.gd_665  tr.az.un_420 is.ga.gd_543
  0x18000c1a, 0x18002b1a, 0x191c1e0c, 0x100429a0,   // sv.ga.un_760 vi.ga.un_760  ms.id.gl_543 sl.fi.lt_322
  0x1f003202, 0x13092504, 0x35005208, 0x0f190ba4,   // bs.cy.un_220 eu.pl.et_332  ha.zu.un_430 es.gl.lv_433
  0x16000e19, 0x08000e21, 0x171c0807, 0x320f0a08,   // is.hr.un_750 is.no.un_860  no.id.sr_432 pt.lv.bs_443
  // [36c0]
  0x03004a04, 0x081a2111, 0x19230aaf, 0x17092d09,   // yo.nl.un_320 jw.tl.no_653  pt.ca.gl_655 sk.pl.sr_444
  0x2000530e, 0x32001612, 0x281035ad, 0x25190aad,   // ht.sq.un_550 hr.bs.un_640  zu.lt.sw_643 pt.gl.eu_643
  0x2a001604, 0x3b201fa7, 0x03000202, 0x35080205,   // hr.mt.un_320 cy.sq.so_532  da.nl.un_220 da.no.zu_333
  0x182d3507, 0x202a06ad, 0x27212a07, 0x13003511,   // zu.sk.ga_432 de.mt.sq_643  mt.jw.gd_432 zu.et.un_630
  // [36d0]
  0x3500250c, 0x17162aa0, 0x18013f07, 0x2700011a,   // eu.zu.un_530 mt.hr.sr_322  af.en.ga_432 en.gd.un_760
  0x31001b35, 0x2d0d0e14, 0x1f23060c, 0x270f1ea0,   // tr.az.un_A90 is.cs.sk_666  de.ca.cy_543 ms.lv.gd_322
  0x110a05af, 0x16002808, 0x271f0ea0, 0x0a192312,   // fr.pt.ro_655 sw.hr.un_430  is.cy.gd_322 ca.gl.pt_654
  0x2d0d10a4, 0x06000f12, 0x553507af, 0x182711ee,   // lt.cs.sk_433 lv.de.un_640  it.zu.rw_655 ro.gd.ga_422
  // [36e0]
  0x08190aa0, 0x1c216411, 0x041e1c05, 0x1f00062a,   // pt.gl.no_322 lg.jw.id_653  id.ms.fi_333 de.cy.un_970
  0x016b5307, 0x28002d0d, 0x0e3f0812, 0x6b086404,   // ht.ceb.en_432 sk.sw.un_540  no.af.is_654 lg.no.ceb_332
  0x17071011, 0x28176407, 0x3f3135af, 0x28556b04,   // be.bg.sr_653 lg.sr.sw_432  zu.az.af_655 ceb.rw.sw_332
  0x35092113, 0x5500641b, 0x182d0d20, 0x641035ee,   // jw.pl.zu_665 lg.rw.un_770  cs.sk.ga_875 zu.lt.lg_422
  // [36f0]
  0x32291604, 0x2b000707, 0x2d0d6e0e, 0x12101a08,   // hr.sl.bs_332 it.vi.un_420  hmn.cs.sk_555 tl.lt.hu_443
  0x3f1a6bec, 0x0f6435a6, 0x05012bee, 0x1b0612ee,   // ceb.tl.af_644 zu.lg.lv_521  vi.en.fr_422 hu.de.tr_422
  0x01001902, 0x0911120c, 0x0d001904, 0x23060a02,   // gl.en.un_220 hu.ro.pl_543  gl.cs.un_320 pt.de.ca_222
  0x07110aa4, 0x05002122, 0x060d0960, 0x64001012,   // mk.ro.bg_433 jw.fr.un_870  pl.cs.de_664 lt.lg.un_640
  // [3700]
  0x12002914, 0x0f2d2912, 0x3f1827ad, 0x080205ec,   // sl.hu.un_660 sl.sk.lv_654  gd.ga.af_643 fr.da.no_644
  0x3f1168a4, 0x27002a13, 0x31006e14, 0x2a0720a4,   // ig.ro.af_433 mt.gd.un_650  hmn.az.un_660 sq.it.mt_433
  0x01083bee, 0x3f006e14, 0x120b1911, 0x31056eee,   // so.no.en_422 hmn.af.un_660  gl.es.hu_653 hmn.fr.az_422
  0x12002a14, 0x3f030208, 0x0d091205, 0x4a001212,   // mt.hu.un_660 da.nl.af_443  hu.pl.cs_333 hu.yo.un_640
  // [3710]
  0x3b1e31a7, 0x23056ea0, 0x2700061a, 0x21192312,   // az.ms.so_532 hmn.fr.ca_322  de.gd.un_760 ca.gl.jw_654
  0x110717a4, 0x27000513, 0x1c130912, 0x3f00270e,   // sr.bg.ro_433 fr.gd.un_650  hi.bh.mr_654 gd.af.un_550
  0x12000404, 0x09293508, 0x3209290c, 0x64351a08,   // fi.hu.un_320 zu.sl.pl_443  sl.pl.bs_543 tl.zu.lg_443
  0x0c2d0d0c, 0x09041313, 0x071108ad, 0x353128ee,   // cs.sk.sv_543 et.fi.pl_665  uk.ro.bg_643 sw.az.zu_422
  // [3720]
  0x6e005321, 0x21640408, 0x1a006408, 0x04080cec,   // ht.hmn.un_860 fi.lg.jw_443  lg.tl.un_430 sv.no.fi_644
  0x11190b08, 0x11170aa4, 0x04000e1a, 0x080602af,   // es.gl.ro_443 mk.sr.ro_433  is.fi.un_760 da.de.no_655
  0x03003b12, 0x05000205, 0x18002102, 0x190b53a0,   // so.nl.un_640 da.fr.un_330  jw.ga.un_220 ht.es.gl_322
  0x092d0d0c, 0x1c001e1a, 0x35001708, 0x6b041a0c,   // cs.sk.pl_543 ms.id.un_760  sr.zu.un_430 tl.fi.ceb_543
  // [3730]
  0x170929a4, 0x092d29a4, 0x0f2d0d08, 0x32162905,   // sl.pl.sr_433 sl.sk.pl_433  cs.sk.lv_443 sl.hr.bs_333
  0x4a110709, 0x04002808, 0x0b000a07, 0x11071005,   // it.ro.yo_444 sw.fi.un_430  pt.es.un_420 lt.it.ro_333
  0x1c000d18, 0x13072007, 0x08001005, 0x0d6b1a0c,   // ne.mr.un_740 sq.it.et_432  be.uk.un_330 tl.ceb.cs_543
  0x64002807, 0x11000702, 0x28683bec, 0x1a290ea0,   // sw.lg.un_420 it.ro.un_220  so.ig.sw_644 is.sl.tl_322
  // [3740]
  0x32175307, 0x2d120aac, 0x4a00530e, 0x1a203bee,   // ht.sr.bs_432 pt.hu.sk_632  ht.yo.un_550 so.sq.tl_422
  0x1a043b09, 0x6421685a, 0x09006421, 0x075552a4,   // so.fi.tl_444 ig.jw.lg_553  lg.pl.un_860 ha.rw.it_433
  0x0b2d0aa0, 0x21190ba4, 0x05000b0e, 0x53000916,   // pt.sk.es_322 es.gl.jw_433  es.fr.un_550 pl.ht.un_720
  0x2a351a0c, 0x0d091c5a, 0x0d001219, 0x0305070c,   // tl.zu.mt_543 mr.hi.ne_553  hu.cs.un_750 it.fr.nl_543
  // [3750]
  0x04080a08, 0x080a1714, 0x1c311ea0, 0x53005204,   // mk.uk.ru_443 sr.mk.uk_666  ms.az.id_322 ha.ht.un_320
  0x130d1c0d, 0x0413640c, 0x642a350d, 0x12046408,   // mr.ne.bh_554 lg.et.fi_543  zu.mt.lg_554 lg.fi.hu_443
  0x091a6bec, 0x28006e07, 0x291613a4, 0x6b042a04,   // ceb.tl.pl_644 hmn.sw.un_420  et.hr.sl_433 mt.fi.ceb_332
  0x13200f07, 0x0d002a04, 0x120b1814, 0x351a4aee,   // lv.sq.et_432 mt.cs.un_320  ga.es.hu_666 yo.tl.zu_422
  // [3760]
  0x0800110c, 0x10000f21, 0x21000b04, 0x120b23af,   // ro.uk.un_530 lv.lt.un_860  es.jw.un_320 ca.es.hu_655
  0x015305ad, 0x0802055a, 0x25000912, 0x00002337,   // fr.ht.en_643 fr.da.no_553  pl.eu.un_640 ca.un.un_B00
  0x03043f08, 0x68001222, 0x25005522, 0x4a006412,   // af.fi.nl_443 hu.ig.un_870  rw.eu.un_870 lg.yo.un_640
  0x11002012, 0x2a29120c, 0x35000907, 0x55001c1a,   // sq.ro.un_640 hu.sl.mt_543  pl.zu.un_420 id.rw.un_760
  // [3770]
  0x27524a55, 0x062308a4, 0x551b1a0c, 0x1100680d,   // yo.ha.gd_442 no.ca.de_433  tl.tr.rw_543 ig.ro.un_540
  0x1f520d07, 0x3f0d53a9, 0x110a230e, 0x1a526ba4,   // cs.ha.cy_432 ht.cs.af_544  ca.pt.ro_555 ceb.ha.tl_433
  0x201b530c, 0x1a3f2912, 0x080c0d0c, 0x0f103507,   // ht.tr.sq_543 sl.af.tl_654  cs.sv.no_543 zu.lt.lv_432
  0x0c021008, 0x2d003505, 0x08201f12, 0x11105507,   // lt.da.sv_443 zu.sk.un_330  cy.sq.no_654 rw.lt.ro_432
  // [3780]
  0x6b3b21a4, 0x0504530c, 0x531a100c, 0x20110a07,   // jw.so.ceb_433 ht.fi.fr_543  lt.tl.ht_543 pt.ro.sq_432
  0x033f6807, 0x31201e04, 0x322a070b, 0x64135508,   // ig.af.nl_432 ms.sq.az_332  it.mt.bs_542 rw.et.lg_443
  0x271118ee, 0x0d000508, 0x180127ee, 0x29003202,   // ga.ro.gd_422 fr.cs.un_430  gd.en.ga_422 bs.sl.un_220
  0x0a1f19af, 0x29002d08, 0x31002819, 0x2b005205,   // gl.cy.pt_655 sk.sl.un_430  sw.az.un_750 ha.vi.un_330
  // [3790]
  0x0b1819ee, 0x286b1aec, 0x091c13ec, 0x681827a7,   // gl.ga.es_422 tl.ceb.sw_644  bh.mr.hi_644 gd.ga.ig_532
  0x531b6b55, 0x27000919, 0x03190bad, 0x1e3168a0,   // ceb.tr.ht_442 pl.gd.un_750  es.gl.nl_643 ig.az.ms_322
  0x23001e04, 0x0f64130c, 0x2a005219, 0x07002819,   // ms.ca.un_320 et.lg.lv_543  ha.mt.un_750 sw.it.un_750
  0x1f090ba4, 0x6855280c, 0x683b280c, 0x35061fee,   // es.pl.cy_433 sw.rw.ig_543  sw.so.ig_543 cy.de.zu_422
  // [37a0]
  0x0b072312, 0x033f640d, 0x250e1a04, 0x28004a04,   // ca.it.es_654 lg.af.nl_554  tl.is.eu_332 yo.sw.un_320
  0x0d531f0b, 0x0f001c08, 0x55001907, 0x531b680c,   // cy.ht.cs_542 id.lv.un_430  gl.rw.un_420 ig.tr.ht_543
  0x04006413, 0x53214aa7, 0x12076409, 0x1a6b2102,   // lg.fi.un_650 yo.jw.ht_532  lg.it.hu_444 jw.ceb.tl_222
  0x53003507, 0x11002b13, 0x0d1b1ca4, 0x0c0e64a7,   // zu.ht.un_420 vi.ro.un_650  id.tr.cs_433 lg.is.sv_532
  // [37b0]
  0x0306050d, 0x115306a4, 0x0b19535a, 0x0c553507,   // fr.de.nl_554 de.ht.ro_433  ht.gl.es_553 zu.rw.sv_432
  0x21001e13, 0x0a190b0d, 0x03001119, 0x1100190c,   // ms.jw.un_650 es.gl.pt_554  ro.nl.un_750 gl.ro.un_530
  0x55282009, 0x53202812, 0x05005302, 0x550c08ad,   // sq.sw.rw_444 sw.sq.ht_654  ht.fr.un_220 no.sv.rw_643
  0x08020ca6, 0x1c311e0b, 0x4a001b2b, 0x0700040d,   // sv.da.no_521 ms.az.id_542  tr.yo.un_980 ru.bg.un_540
  // [37c0]
  0x1c00210c, 0x136404ec, 0x17000d0d, 0x6400041a,   // jw.id.un_530 fi.lg.et_644  cs.sr.un_540 fi.lg.un_760
  0x1c2b1eee, 0x35001121, 0x12556408, 0x25553b12,   // ms.vi.id_422 ro.zu.un_860  lg.rw.hu_443 so.rw.eu_654
  0x17100460, 0x1c080ea0, 0x1b686455, 0x52122860,   // ru.be.sr_664 is.no.id_322  lg.ig.tr_442 sw.hu.ha_664
  0x2d0d0a0e, 0x1704110e, 0x55000307, 0x21001e09,   // pt.cs.sk_555 ro.ru.sr_555  nl.rw.un_420 ms.jw.un_440
  // [37d0]
  0x4a350e0d, 0x1e211cee, 0x28352aa0, 0x3f3b13a9,   // is.zu.yo_554 id.jw.ms_422  mt.zu.sw_322 et.so.af_544
  0x4a0b1aee, 0x680128a6, 0x1c1621ee, 0x20003208,   // tl.es.yo_422 sw.en.ig_521  jw.hr.id_422 bs.sq.un_430
  0x0a0623af, 0x121819a0, 0x0817070c, 0x6b1a0faf,   // ca.de.pt_655 gl.ga.hu_322  bg.sr.uk_543 lv.tl.ceb_655
  0x060325ee, 0x230b0a08, 0x1729280c, 0x07170860,   // eu.nl.de_422 pt.es.ca_443  sw.sl.sr_543 uk.sr.bg_664
  // [37e0]
  0x283153a4, 0x1b110709, 0x20550707, 0x3b1f3555,   // ht.az.sw_433 it.ro.tr_444  it.rw.sq_432 zu.cy.so_442
  0x0c001c04, 0x082d0d05, 0x21053ba4, 0x0b18190c,   // id.sv.un_320 cs.sk.no_333  so.fr.jw_433 gl.ga.es_543
  0x172935a0, 0x3b122107, 0x3564310d, 0x0e0801a0,   // zu.sl.sr_322 jw.hu.so_432  az.lg.zu_554 en.no.is_322
  0x0a5227a4, 0x6e290fa4, 0x2b001e04, 0x09003213,   // gd.ha.pt_433 lv.sl.hmn_433  ms.vi.un_320 bs.pl.un_650
  // [37f0]
  0x0a110705, 0x28311b5a, 0x311b3509, 0x3520310c,   // bg.ro.mk_333 tr.az.sw_553  zu.tr.az_444 az.sq.zu_543
  0x2b001602, 0x3b001f1a, 0x2d000f13, 0x04000c05,   // hr.vi.un_220 cy.so.un_760  lv.sk.un_650 sv.fi.un_330
  0x2a2d1f07, 0x09190eee, 0x122111a7, 0x0d2d0e11,   // cy.sk.mt_432 is.gl.pl_422  ro.jw.hu_532 is.sk.cs_653
  0x3b003505, 0x29000804, 0x1f002d1a, 0x31005214,   // zu.so.un_330 no.sl.un_320  sk.cy.un_760 ha.az.un_660

  // [3800]
  0x536b1aad, 0x09131012, 0x6b6823ee, 0x0c001902,   // tl.ceb.ht_643 lt.et.pl_654  ca.ig.ceb_422 gl.sv.un_220
  0x1b001c08, 0x09286408, 0x551b4a07, 0x1f000808,   // id.tr.un_430 lg.sw.pl_443  yo.tr.rw_432 no.cy.un_430
  0x0a1f2da4, 0x6b01110c, 0x55004a1a, 0x232a0709,   // sk.cy.pt_433 ro.en.ceb_543  yo.rw.un_760 it.mt.ca_444
  0x312855ee, 0x311c52ad, 0x0c0901ad, 0x09250307,   // rw.sw.az_422 ha.id.az_643  en.pl.sv_643 nl.eu.pl_432
  // [3810]
  0x0f1c1ea4, 0x112d1207, 0x1b1f530c, 0x1a063b07,   // ms.id.lv_433 hu.sk.ro_432  ht.cy.tr_543 so.de.tl_432
  0x3f100f09, 0x1b066baf, 0x1b000e1a, 0x1f2a53ec,   // lv.lt.af_444 ceb.de.tr_655  is.tr.un_760 ht.mt.cy_644
  0x2d1a230c, 0x1200111a, 0x683f100c, 0x521b0ea0,   // ca.tl.sk_543 ro.hu.un_760  lt.af.ig_543 is.tr.ha_322
  0x0a005507, 0x1b0a0e0c, 0x350c16a0, 0x2a313bad,   // rw.pt.un_420 is.pt.tr_543  hr.sv.zu_322 so.az.mt_643
  // [3820]
  0x234a28a7, 0x351a11a4, 0x350613af, 0x08021309,   // sw.yo.ca_532 ro.tl.zu_433  et.de.zu_655 et.da.no_444
  0x1b003b1b, 0x0f006e13, 0x530b21a9, 0x13062a12,   // so.tr.un_770 hmn.lv.un_650  jw.es.ht_544 mt.de.et_654
  0x2a6425ad, 0x18041155, 0x6e000113, 0x18005321,   // eu.lg.mt_643 ro.fi.ga_442  en.hmn.un_650 ht.ga.un_860
  0x0a2923a0, 0x28001104, 0x2a0320ee, 0x23000d0e,   // ca.sl.pt_322 ro.sw.un_320  sq.nl.mt_422 cs.ca.un_550
  // [3830]
  0x2a0f6e12, 0x203217a4, 0x040710af, 0x6e00011a,   // hmn.lv.mt_654 sr.bs.sq_433  be.bg.ru_655 en.hmn.un_760
  0x012005ee, 0x0d001213, 0x100925ad, 0x06110da0,   // fr.sq.en_422 hu.cs.un_650  eu.pl.lt_643 cs.ro.de_322
  0x212b010c, 0x02000c07, 0x29172da9, 0x1b200a05,   // en.vi.jw_543 sv.da.un_420  sk.sr.sl_544 pt.sq.tr_333
  0x23000a0c, 0x0510270c, 0x68552813, 0x101c1e0c,   // pt.ca.un_530 gd.lt.fr_543  sw.rw.ig_665 ms.id.lt_543
  // [3840]
  0x6b003109, 0x1a283bac, 0x1e1c25ee, 0x311b3b08,   // az.ceb.un_440 so.sw.tl_632  eu.id.ms_422 so.tr.az_443
  0x201b0f04, 0x282a2307, 0x11011f0c, 0x01002807,   // lv.tr.sq_332 ca.mt.sw_432  cy.en.ro_543 sw.en.un_420
  0x3f005505, 0x0d091ca9, 0x040d2d0c, 0x321608a4,   // rw.af.un_330 mr.hi.ne_544  sk.cs.fi_543 no.hr.bs_433
  0x0d202d12, 0x6800251b, 0x3b1f210c, 0x1e00530c,   // sk.sq.cs_654 eu.ig.un_770  jw.cy.so_543 ht.ms.un_530
  // [3850]
  0x130d090e, 0x25210405, 0x13090d12, 0x1320040d,   // hi.ne.bh_555 fi.jw.eu_333  ne.hi.bh_654 fi.sq.et_554
  0x0c00210c, 0x13002505, 0x090164ee, 0x2d040daf,   // jw.sv.un_530 eu.et.un_330  lg.en.pl_422 cs.fi.sk_655
  0x0b271a12, 0x12355555, 0x55001b22, 0x21001a19,   // tl.gd.es_654 rw.zu.hu_442  tr.rw.un_870 tl.jw.un_750
  0x210d0908, 0x02083f07, 0x08002d0d, 0x641325a7,   // pl.cs.jw_443 af.no.da_432  sk.no.un_540 eu.et.lg_532
  // [3860]
  0x0c080e13, 0x2a006807, 0x0b55680c, 0x6b001e04,   // is.no.sv_665 ig.mt.un_420  ig.rw.es_543 ms.ceb.un_320
  0x1b120c0c, 0x06036ba0, 0x1f004a08, 0x0b1e25a0,   // sv.hu.tr_543 ceb.nl.de_322  yo.cy.un_430 eu.ms.es_322
  0x0e061207, 0x23001c02, 0x1200231a, 0x6b551a04,   // hu.de.is_432 id.ca.un_220  ca.hu.un_760 tl.rw.ceb_332
  0x2800681a, 0x0e190b08, 0x1b0e0cad, 0x2a2016a4,   // ig.sw.un_760 es.gl.is_443  sv.is.tr_643 hr.sq.mt_433
  // [3870]
  0x1c21100c, 0x17521a12, 0x126b1faf, 0x6b1f1a60,   // lt.jw.id_543 tl.ha.sr_654  cy.ceb.hu_655 tl.cy.ceb_664
  0x311b28a9, 0x1e272007, 0x291f0d07, 0x6b1a1e12,   // sw.tr.az_544 sq.gd.ms_432  cs.cy.sl_432 ms.tl.ceb_654
  0x55311b11, 0x20002819, 0x1a216ba9, 0x3b002018,   // tr.az.rw_653 sw.sq.un_750  ceb.jw.tl_544 sq.so.un_740
  0x121a6bad, 0x05001022, 0x642853ad, 0x3f031313,   // ceb.tl.hu_643 lt.fr.un_870  ht.sw.lg_643 et.nl.af_665
  // [3880]
  0x356423a4, 0x310c1b12, 0x1a6b120c, 0x5564350e,   // ca.lg.zu_433 tr.sv.az_654  hu.ceb.tl_543 zu.lg.rw_555
  0x0b120505, 0x3564135a, 0x205535ee, 0x0264010c,   // fr.hu.es_333 et.lg.zu_553  zu.rw.sq_422 en.lg.da_543
  0x6431250d, 0x0600200d, 0x2d190b0d, 0x08060fee,   // eu.az.lg_554 sq.de.un_540  es.gl.sk_554 lv.de.no_422
  0x25071b0c, 0x3f001a08, 0x31125304, 0x1f190a05,   // tr.it.eu_543 tl.af.un_430  ht.hu.az_332 pt.gl.cy_333
  // [3890]
  0x250c0307, 0x03000214, 0x6b6468a7, 0x131f6b0d,   // nl.sv.eu_432 da.nl.un_660  ig.lg.ceb_532 ceb.cy.et_554
  0x2800352a, 0x31110dee, 0x1f1a1ea0, 0x01205255,   // zu.sw.un_970 cs.ro.az_422  ms.tl.cy_322 ha.sq.en_442
  0x190b25a0, 0x072555a7, 0x1110310c, 0x20351c05,   // eu.es.gl_322 rw.eu.it_532  az.lt.ro_543 id.zu.sq_333
  0x68002019, 0x2d0d29ac, 0x351b3114, 0x1c101e07,   // sq.ig.un_750 sl.cs.sk_632  az.tr.zu_666 ms.lt.id_432
  // [38a0]
  0x5320110d, 0x036b20a7, 0x64280208, 0x29321614,   // ro.sq.ht_554 sq.ceb.nl_532  da.sw.lg_443 hr.bs.sl_666
  0x20282d07, 0x19120ba4, 0x100208a4, 0x19000a2a,   // sk.sw.sq_432 es.hu.gl_433  no.da.lt_433 pt.gl.un_970
  0x0f003504, 0x25122aa0, 0x6b0b1a05, 0x121a6b05,   // zu.lv.un_320 mt.hu.eu_322  tl.es.ceb_333 ceb.tl.hu_333
  0x121a0cad, 0x0b006412, 0x120c1aa7, 0x3b1b355a,   // sv.tl.hu_643 lg.es.un_640  tl.sv.hu_532 zu.tr.so_553
  // [38b0]
  0x06201107, 0x180e12ad, 0x12194a04, 0x64004a02,   // ro.sq.de_432 hu.is.ga_643  yo.gl.hu_332 yo.lg.un_220
  0x12000b02, 0x2d0d19a0, 0x02063f05, 0x17162905,   // es.hu.un_220 gl.cs.sk_322  af.de.da_333 sl.hr.sr_333
  0x196468ad, 0x1a001308, 0x3555640d, 0x0d122dec,   // ig.lg.gl_643 et.tl.un_430  lg.rw.zu_554 sk.hu.cs_644
  0x55000c07, 0x2d3520a4, 0x350413af, 0x131c04ad,   // sv.rw.un_420 sq.zu.sk_433  et.fi.zu_655 fi.id.et_643
  // [38c0]
  0x080c0ead, 0x120c1313, 0x281213a4, 0x09131c13,   // is.sv.no_643 et.sv.hu_665  et.hu.sw_433 mr.bh.hi_665
  0x0c1e0ba4, 0x2d1355a7, 0x29071cee, 0x110108a0,   // es.ms.sv_433 rw.et.sk_532  id.it.sl_422 no.en.ro_322
  0x13041e12, 0x133b1a09, 0x2b005521, 0x0a0c0607,   // ms.fi.et_654 tl.so.et_444  rw.vi.un_860 de.sv.pt_432
  0x0c061f0c, 0x01192304, 0x0e231905, 0x52006e0e,   // cy.de.sv_543 ca.gl.en_332  gl.ca.is_333 hmn.ha.un_550
  // [38d0]
  0x643f68a4, 0x2d033504, 0x0f0c13a4, 0x682835a4,   // ig.af.lg_433 zu.nl.sk_332  et.sv.lv_433 zu.sw.ig_433
  0x0811100c, 0x2d10130c, 0x1b085308, 0x55103ba0,   // be.ro.uk_543 et.lt.sk_543  ht.no.tr_443 so.lt.rw_322
  0x31086811, 0x05002317, 0x35551e0e, 0x2000121b,   // ig.no.az_653 ca.fr.un_730  ms.rw.zu_555 hu.sq.un_770
  0x13001a08, 0x00001c37, 0x0f003204, 0x31521b08,   // tl.et.un_430 mr.un.un_B00  bs.lv.un_320 tr.ha.az_443
  // [38e0]
  0x10286813, 0x0e1218af, 0x52281fa6, 0x28356807,   // ig.sw.lt_665 ga.hu.is_655  cy.sw.ha_521 ig.zu.sw_432
  0x13000e0e, 0x642868ad, 0x291735ee, 0x32291707,   // is.et.un_550 ig.sw.lg_643  zu.sr.sl_422 sr.sl.bs_432
  0x01646ba4, 0x17005304, 0x21001105, 0x290828ee,   // ceb.lg.en_433 ht.sr.un_320  ro.jw.un_330 sw.no.sl_422
  0x21003512, 0x012518a4, 0x210420a4, 0x2055280d,   // zu.jw.un_640 ga.eu.en_433  sq.fi.jw_433 sw.rw.sq_554
  // [38f0]
  0x311168a4, 0x161f4aa6, 0x09072aee, 0x20681a07,   // ig.ro.az_433 yo.cy.hr_521  mt.it.pl_422 tl.ig.sq_432
  0x191a6b08, 0x170708a6, 0x205228a4, 0x21112707,   // ceb.tl.gl_443 uk.bg.sr_521  sw.ha.sq_433 gd.ro.jw_432
  0x28136809, 0x21003509, 0x0c001e04, 0x53683bad,   // ig.et.sw_444 zu.jw.un_440  ms.sv.un_320 so.ig.ht_643
  0x6864285a, 0x216420a4, 0x1131280c, 0x1c020e12,   // sw.lg.ig_553 sq.lg.jw_433  sw.az.ro_543 is.da.id_654
  // [3900]
  0x1f0c06a9, 0x18102755, 0x551b31a9, 0x06182708,   // de.sv.cy_544 gd.lt.ga_442  az.tr.rw_544 gd.ga.de_443
  0x64684a12, 0x17000f08, 0x081f270c, 0x09002102,   // yo.ig.lg_654 lv.sr.un_430  gd.cy.no_543 jw.pl.un_220
  0x292d170c, 0x64311bad, 0x121b100c, 0x316828af,   // sr.sk.sl_543 tr.az.lg_643  lt.tr.hu_543 sw.ig.az_655
  0x19040b07, 0x282a3504, 0x3b18010b, 0x2a200e0c,   // es.fi.gl_432 zu.mt.sw_332  en.ga.so_542 is.sq.mt_543
  // [3910]
  0x1800010c, 0x100b070c, 0x21002829, 0x2b092a04,   // en.ga.un_530 it.es.lt_543  sw.jw.un_960 mt.pl.vi_332
  0x18031311, 0x1700550c, 0x28002a1a, 0x642868a9,   // et.nl.ga_653 rw.sr.un_530  mt.sw.un_760 ig.sw.lg_544
  0x13002119, 0x52006409, 0x5264680c, 0x292d35af,   // jw.et.un_750 lg.ha.un_440  ig.lg.ha_543 zu.sk.sl_655
  0x1e6b1aaf, 0x0a0923a0, 0x2d001208, 0x10045308,   // tl.ceb.ms_655 ca.pl.pt_322  hu.sk.un_430 ht.fi.lt_443
  // [3920]
  0x1304110c, 0x1e551fa4, 0x1e2864a4, 0x3f0913a4,   // ro.fi.et_543 cy.rw.ms_433  lg.sw.ms_433 et.pl.af_433
  0x18273ba4, 0x114a1704, 0x02080ca7, 0x68170911,   // so.gd.ga_433 sr.yo.ro_332  sv.no.da_532 pl.sr.ig_653
  0x35120708, 0x1100291a, 0x0e1310ec, 0x1a1e5507,   // it.hu.zu_443 sl.ro.un_760  lt.et.is_644 rw.ms.tl_432
  0x270521ad, 0x16003b08, 0x0f2a250c, 0x646b1a08,   // jw.fr.gd_643 so.hr.un_430  eu.mt.lv_543 tl.ceb.lg_443
  // [3930]
  0x0d190b08, 0x2d17290d, 0x4a3b1a0c, 0x042d0d5a,   // es.gl.cs_443 sl.sr.sk_554  tl.so.yo_543 cs.sk.fi_553
  0x251135a0, 0x52092d08, 0x27002007, 0x09003507,   // zu.ro.eu_322 sk.pl.ha_443  sq.gd.un_420 zu.pl.un_420
  0x13110413, 0x6b061a02, 0x0f2a280c, 0x1e0a5204,   // fi.ro.et_665 tl.de.ceb_222  sw.mt.lv_543 ha.pt.ms_332
  0x551628a7, 0x3121520c, 0x1e003b07, 0x070a1104,   // sw.hr.rw_532 ha.jw.az_543  so.ms.un_420 ro.mk.bg_332
  // [3940]
  0x271805a4, 0x0410280c, 0x1f0e0b04, 0x07111705,   // fr.ga.gd_433 sw.lt.fi_543  es.is.cy_332 sr.ro.bg_333
  0x32031ca0, 0x0e003202, 0x551a350c, 0x1c090d55,   // id.nl.bs_322 bs.is.un_220  zu.tl.rw_543 ne.hi.mr_442
  0x18201e07, 0x3b135304, 0x030635ad, 0x211a270c,   // ms.sq.ga_432 ht.et.so_332  zu.de.nl_643 gd.tl.jw_543
  0x07002313, 0x20553507, 0x06002707, 0x190b68a4,   // ca.it.un_650 zu.rw.sq_432  gd.de.un_420 ig.es.gl_433
  // [3950]
  0x20002305, 0x4a3f03a4, 0x12000f1a, 0x01006404,   // ca.sq.un_330 nl.af.yo_433  lv.hu.un_760 lg.en.un_320
  0x35100708, 0x10004a0d, 0x1b182712, 0x642835a9,   // it.lt.zu_443 yo.lt.un_540  gd.ga.tr_654 zu.sw.lg_544
  0x060302ee, 0x05120aa4, 0x112a070c, 0x0a000819,   // da.nl.de_422 pt.hu.fr_433  it.mt.ro_543 uk.mk.un_750
  0x3b1b31a4, 0x12350308, 0x271f2a12, 0x0e001122,   // az.tr.so_433 nl.zu.hu_443  mt.cy.gd_654 ro.is.un_870
  // [3960]
  0x0c002007, 0x11530b05, 0x03005307, 0x21311b12,   // sq.sv.un_420 es.ht.ro_333  ht.nl.un_420 tr.az.jw_654
  0x53311b07, 0x3f1264a4, 0x2a3f1a08, 0x022a03ec,   // tr.az.ht_432 lg.hu.af_433  tl.af.mt_443 nl.mt.da_644
  0x033f35a9, 0x1b315312, 0x033f01a4, 0x1800521a,   // zu.af.nl_544 ht.az.tr_654  en.af.nl_433 ha.ga.un_760
  0x5521350e, 0x04063f05, 0x0a0810a9, 0x0e001f05,   // zu.jw.rw_555 af.de.fi_333  be.uk.mk_544 cy.is.un_330
  // [3970]
  0x080e270c, 0x6b531a0c, 0x280255a7, 0x120335af,   // gd.is.no_543 tl.ht.ceb_543  rw.da.sw_532 zu.nl.hu_655
  0x081b0c0b, 0x06002a07, 0x110155a4, 0x25005512,   // sv.tr.no_542 mt.de.un_420  rw.en.ro_433 rw.eu.un_640
  0x1c1b1aa9, 0x03642812, 0x02080e0b, 0x2a020eee,   // tl.tr.id_544 sw.lg.nl_654  is.no.da_542 is.da.mt_422
  0x033f55a9, 0x3f215305, 0x1c1a21ad, 0x6412350c,   // rw.af.nl_544 ht.jw.af_333  jw.tl.id_643 zu.hu.lg_543
  // [3980]
  0x122d0aee, 0x082812a4, 0x081a2155, 0x3217520c,   // pt.sk.hu_422 hu.sw.no_433  jw.tl.no_442 ha.sr.bs_543
  0x35211a04, 0x6811275a, 0x1f033faf, 0x13211aa7,   // tl.jw.zu_332 gd.ro.ig_553  af.nl.cy_655 tl.jw.et_532
  0x6828030e, 0x1f00181b, 0x1c0e21ad, 0x0f190bec,   // nl.sw.ig_555 ga.cy.un_770  jw.is.id_643 es.gl.lv_644
  0x092d11a4, 0x321711af, 0x641a2814, 0x3f031aa0,   // ro.sk.pl_433 ro.sr.bs_655  sw.tl.lg_666 tl.nl.af_322
  // [3990]
  0x12001c0d, 0x3b041e05, 0x2855110c, 0x0900190d,   // id.hu.un_540 ms.fi.so_333  ro.rw.sw_543 gl.pl.un_540
  0x553268a7, 0x1a1e2104, 0x1e1c210c, 0x25001105,   // ig.bs.rw_532 jw.ms.tl_332  jw.id.ms_543 ro.eu.un_330
  0x08021a05, 0x2d001019, 0x23033f60, 0x103f1307,   // tl.da.no_333 lt.sk.un_750  af.nl.ca_664 et.af.lt_432
  0x090f2813, 0x121e5504, 0x32291ca0, 0x08041113,   // sw.lv.pl_665 rw.ms.hu_332  id.sl.bs_322 ro.ru.uk_665
  // [39a0]
  0x12002b22, 0x072001ee, 0x122b4a0c, 0x25000419,   // vi.hu.un_870 en.sq.it_422  yo.vi.hu_543 fi.eu.un_750
  0x55642005, 0x04083f12, 0x355564ad, 0x2d0d6ba0,   // sq.lg.rw_333 af.no.fi_654  lg.rw.zu_643 ceb.cs.sk_322
  0x64524aa4, 0x3f030655, 0x0e0d2b11, 0x0f2a2905,   // yo.ha.lg_433 de.nl.af_442  vi.cs.is_653 sl.mt.lv_333
  0x072a010c, 0x3f001219, 0x0a6455ad, 0x353b5512,   // en.mt.it_543 hu.af.un_750  rw.lg.pt_643 rw.so.zu_654
  // [39b0]
  0x355206a4, 0x0a6410ee, 0x6e0b5307, 0x2d0d1ca0,   // de.ha.zu_433 lt.lg.pt_422  ht.es.hmn_432 id.cs.sk_322
  0x553b28ec, 0x3b5255ad, 0x6b040f0c, 0x0e002714,   // sw.so.rw_644 rw.ha.so_643  lv.fi.ceb_543 gd.is.un_660
  0x4a2855a9, 0x211b29a9, 0x290e1e08, 0x120f1a08,   // rw.sw.yo_544 sl.tr.jw_544  ms.is.sl_443 tl.lv.hu_443
  0x120f040d, 0x01190b05, 0x0c0813a7, 0x121a0ca9,   // fi.lv.hu_554 es.gl.en_333  et.no.sv_532 sv.tl.hu_544
  // [39c0]
  0x52681b08, 0x04005323, 0x3f0635a4, 0x0800110e,   // tr.ig.ha_443 ht.fi.un_880  zu.de.af_433 ro.uk.un_550
  0x12230f05, 0x525355a4, 0x05000e07, 0x55086407,   // lv.ca.hu_333 rw.ht.ha_433  is.fr.un_420 lg.no.rw_432
  0x19530b5a, 0x3b554a05, 0x03001204, 0x07001f05,   // es.ht.gl_553 yo.rw.so_333  hu.nl.un_320 cy.it.un_330
  0x5305520b, 0x6b05530c, 0x201b0fee, 0x12531a04,   // ha.fr.ht_542 ht.fr.ceb_543  lv.tr.sq_422 tl.ht.hu_332
  // [39d0]
  0x295305a4, 0x3b2864a0, 0x07530507, 0x0c520a04,   // fr.ht.sl_433 lg.sw.so_322  fr.ht.it_432 pt.ha.sv_332
  0x2a001f14, 0x0f001209, 0x28002004, 0x06000e14,   // cy.mt.un_660 hu.lv.un_440  sq.sw.un_320 is.de.un_660
  0x121a0fa4, 0x2800030c, 0x6412550c, 0x1a356b02,   // lv.tl.hu_433 nl.sw.un_530  rw.hu.lg_543 ceb.zu.tl_222
  0x12000819, 0x64551b13, 0x06036408, 0x083f03ad,   // no.hu.un_750 tr.rw.lg_665  lg.nl.de_443 nl.af.no_643
  // [39e0]
  0x05530d12, 0x28556460, 0x53020508, 0x55641060,   // cs.ht.fr_654 lg.rw.sw_664  fr.da.ht_443 lt.lg.rw_664
  0x04003502, 0x531b0e0d, 0x0f000e12, 0x0435110c,   // zu.fi.un_220 is.tr.ht_554  is.lv.un_640 ro.zu.fi_543
  0x08000c19, 0x356455ec, 0x3b1b0e55, 0x32311b05,   // sv.no.un_750 rw.lg.zu_644  is.tr.so_442 tr.az.bs_333
  0x10006422, 0x352852ad, 0x13292da4, 0x273b2aee,   // lg.lt.un_870 ha.sw.zu_643  sk.sl.et_433 mt.so.gd_422
  // [39f0]
  0x0b2319a4, 0x02002108, 0x212a200c, 0x1f000b1b,   // gl.ca.es_433 jw.da.un_430  sq.mt.jw_543 es.cy.un_770
  0x09112da0, 0x041b0f0c, 0x09010d05, 0x10130b08,   // sk.ro.pl_322 lv.tr.fi_543  cs.en.pl_333 es.et.lt_443
  0x35001f21, 0x05074aa0, 0x35552814, 0x530a110c,   // cy.zu.un_860 yo.it.fr_322  sw.rw.zu_666 ro.pt.ht_543
  0x2300271b, 0x0a1e1c0c, 0x0a073507, 0x08000108,   // gd.ca.un_770 id.ms.pt_543  zu.it.pt_432 en.no.un_430
  // [3a00]
  0x281a11a4, 0x060e0ca4, 0x1c080205, 0x0b001b08,   // ro.tl.sw_433 sv.is.de_433  da.no.id_333 tr.es.un_430
  0x105335a4, 0x2a0a04ee, 0x32170da4, 0x2835530e,   // zu.ht.lt_433 fi.pt.mt_422  cs.sr.bs_433 ht.zu.sw_555
  0x2a0c3204, 0x2a013207, 0x311b35a0, 0x29530107,   // bs.sv.mt_332 bs.en.mt_432  zu.tr.az_322 en.ht.sl_432
  0x2a3b1fa7, 0x311b21af, 0x03026e0c, 0x043f0eec,   // cy.so.mt_532 jw.tr.az_655  hmn.da.nl_543 is.af.fi_644
  // [3a10]
  0x0e0f0807, 0x29322d14, 0x530a1c0c, 0x291153ac,   // no.lv.is_432 sk.bs.sl_666  id.pt.ht_543 ht.ro.sl_632
  0x35003b19, 0x08122aa0, 0x19003504, 0x1700101b,   // so.zu.un_750 mt.hu.no_322  zu.gl.un_320 be.sr.un_770
  0x53002704, 0x3b1a6ba4, 0x2a0e06a4, 0x0d3b13ad,   // gd.ht.un_320 ceb.tl.so_433  de.is.mt_433 et.so.cs_643
  0x11311b0d, 0x076435ec, 0x281e1cad, 0x1c1f1e55,   // tr.az.ro_554 zu.lg.it_644  id.ms.sw_643 ms.cy.id_442
  // [3a20]
  0x52001e04, 0x01036ba0, 0x1a2807af, 0x190a0709,   // ms.ha.un_320 ceb.nl.en_322  it.sw.tl_655 it.pt.gl_444
  0x2d0d55af, 0x1c1a2508, 0x2d0d250d, 0x645525af,   // rw.cs.sk_655 eu.tl.id_443  eu.cs.sk_554 eu.rw.lg_655
  0x0e2b120c, 0x31130808, 0x0b1029a9, 0x1b3529a7,   // hu.vi.is_543 no.et.az_443  sl.lt.es_544 sl.zu.tr_532
  0x0a002d04, 0x170a0813, 0x3512280e, 0x55002809,   // sk.pt.un_320 uk.mk.sr_665  sw.hu.zu_555 sw.rw.un_440
  // [3a30]
  0x06000814, 0x0c1306a4, 0x01311ba4, 0x55352d0d,   // no.de.un_660 de.et.sv_433  tr.az.en_433 sk.zu.rw_554
  0x21230512, 0x1b1152a7, 0x522855ee, 0x0e0464a0,   // fr.ca.jw_654 ha.ro.tr_532  rw.sw.ha_422 lg.fi.is_322
  0x160f2d08, 0x061f0e04, 0x1364040c, 0x3b0a19a9,   // sk.lv.hr_443 is.cy.de_332  fi.lg.et_543 gl.pt.so_544
  0x53000608, 0x1100520d, 0x4a35640e, 0x11210f0c,   // de.ht.un_430 ha.ro.un_540  lg.zu.yo_555 lv.jw.ro_543
  // [3a40]
  0x0b64350d, 0x06210913, 0x1c215205, 0x1f023f55,   // zu.lg.es_554 pl.jw.de_665  ha.jw.id_333 af.da.cy_442
  0x12002302, 0x0c192aee, 0x3b001c02, 0x130f01a4,   // ca.hu.un_220 mt.gl.sv_422  id.so.un_220 en.lv.et_433
  0x4a006812, 0x17202d07, 0x2d2318ad, 0x05000d1a,   // ig.yo.un_640 sk.sq.sr_432  ga.ca.sk_643 cs.fr.un_760
  0x080c0207, 0x1e52250c, 0x03000121, 0x273f010c,   // da.sv.no_432 eu.ha.ms_543  en.nl.un_860 en.af.gd_543
  // [3a50]
  0x25114aa4, 0x212728a7, 0x1c090dee, 0x0c000614,   // yo.ro.eu_433 sw.gd.jw_532  ne.hi.mr_422 de.sv.un_660
  0x1c2a1e07, 0x6b0a010b, 0x0c00030e, 0x6b03010c,   // ms.mt.id_432 en.pt.ceb_542  nl.sv.un_550 en.nl.ceb_543
  0x0f062d08, 0x556b1a07, 0x2a063fad, 0x0e171355,   // sk.de.lv_443 tl.ceb.rw_432  af.de.mt_643 et.sr.is_442
  0x0e00280c, 0x112a2308, 0x03066b02, 0x182b1c04,   // sw.is.un_530 ca.mt.ro_443  ceb.de.nl_222 id.vi.ga_332
  // [3a60]
  0x1f004a04, 0x01033fa9, 0x0f291f08, 0x100c6bad,   // yo.cy.un_320 af.nl.en_544  cy.sl.lv_443 ceb.sv.lt_643
  0x073512a9, 0x01002a04, 0x1e1c23a4, 0x1c2a210c,   // hu.zu.it_544 mt.en.un_320  ca.id.ms_433 jw.mt.id_543
  0x0700230e, 0x09000a07, 0x1a1f13a9, 0x321721a4,   // ca.it.un_550 pt.pl.un_420  et.cy.tl_544 jw.sr.bs_433
  0x01032704, 0x1f033f09, 0x6b132da4, 0x18000a13,   // gd.nl.en_332 af.nl.cy_444  sk.et.ceb_433 pt.ga.un_650
  // [3a70]
  0x2100250d, 0x17292d0e, 0x1e1a13a4, 0x3f172913,   // eu.jw.un_540 sk.sl.sr_555  et.tl.ms_433 sl.sr.af_665
  0x01002521, 0x1c1f21a4, 0x4a1b17a0, 0x1211070c,   // eu.en.un_860 jw.cy.id_433  sr.tr.yo_322 it.ro.hu_543
  0x28311b08, 0x060c0304, 0x065308a7, 0x16060e12,   // tr.az.sw_443 nl.sv.de_332  no.ht.de_532 is.de.hr_654
  0x0d192011, 0x03131fac, 0x29005214, 0x1a1b535a,   // sq.gl.cs_653 cy.et.nl_632  ha.sl.un_660 ht.tr.tl_553
  // [3a80]
  0x53003521, 0x1b1119ee, 0x052d0912, 0x2a000421,   // zu.ht.un_860 gl.ro.tr_422  pl.sk.fr_654 fi.mt.un_860
  0x190b11a0, 0x11162da7, 0x311e3b0c, 0x06113ba0,   // ro.es.gl_322 sk.hr.ro_532  so.ms.az_543 so.ro.de_322
  0x312a1c09, 0x641620ee, 0x3f1a1f11, 0x10000809,   // id.mt.az_444 sq.hr.lg_422  cy.tl.af_653 uk.be.un_440
  0x5300200e, 0x271e130c, 0x32172daf, 0x21555204,   // sq.ht.un_550 et.ms.gd_543  sk.sr.bs_655 ha.rw.jw_332
  // [3a90]
  0x08350c07, 0x531b4aee, 0x04005307, 0x1c0f21a0,   // sv.zu.no_432 yo.tr.ht_422  ht.fi.un_420 jw.lv.id_322
  0x190b4a0c, 0x083f6412, 0x1b125307, 0x531219a0,   // yo.es.gl_543 lg.af.no_654  ht.hu.tr_432 gl.hu.ht_322
  0x2b003204, 0x016b020c, 0x3f005520, 0x551b5304,   // bs.vi.un_320 da.ceb.en_543  rw.af.un_850 ht.tr.rw_332
  0x1b005314, 0x090d2013, 0x02036409, 0x1b006412,   // ht.tr.un_660 sq.cs.pl_665  lg.nl.da_444 lg.tr.un_640
  // [3aa0]
  0x21003521, 0x111b3113, 0x1100250e, 0x08041713,   // zu.jw.un_860 az.tr.ro_665  eu.ro.un_550 sr.ru.uk_665
  0x55352813, 0x0c040614, 0x3f001208, 0x033f1f60,   // sw.zu.rw_665 de.fi.sv_666  hu.af.un_430 cy.af.nl_664
  0x52002a05, 0x11170a05, 0x12002705, 0x0d001e04,   // mt.ha.un_330 mk.sr.ro_333  gd.hu.un_330 ms.cs.un_320
  0x04036405, 0x201e270c, 0x1a21275a, 0x3f1b0607,   // lg.nl.fi_333 gd.ms.sq_543  gd.jw.tl_553 de.tr.af_432
  // [3ab0]
  0x0b002a04, 0x1b001e02, 0x0721270c, 0x05271811,   // mt.es.un_320 ms.tr.un_220  gd.jw.it_543 ga.gd.fr_653
  0x2a1106ee, 0x1b2a03ee, 0x1e271f0d, 0x102718a4,   // de.ro.mt_422 nl.mt.tr_422  cy.gd.ms_554 ga.gd.lt_433
  0x081c1ea9, 0x05001e08, 0x18082704, 0x03201b14,   // ms.id.no_544 ms.fr.un_430  gd.no.ga_332 tr.sq.nl_666
  0x0600320c, 0x21005302, 0x1b121ea9, 0x28003f14,   // bs.de.un_530 ht.jw.un_220  ms.hu.tr_544 af.sw.un_660
  // [3ac0]
  0x1e283f08, 0x08070aad, 0x180504ee, 0x0d130955,   // af.sw.ms_443 mk.bg.uk_643  fi.fr.ga_422 hi.bh.ne_442
  0x0125050c, 0x07000e11, 0x1b273114, 0x3f350311,   // fr.eu.en_543 is.it.un_630  az.gd.tr_666 nl.zu.af_653
  0x0c002304, 0x3b2d29ee, 0x071008a4, 0x04170aa9,   // ca.sv.un_320 sl.sk.so_422  uk.be.bg_433 mk.sr.ru_544
  0x1e1c280e, 0x04000c1b, 0x29091104, 0x21001022,   // sw.id.ms_555 sv.fi.un_770  ro.pl.sl_332 lt.jw.un_870
  // [3ad0]
  0x202813a4, 0x6b11130c, 0x3f000204, 0x041113af,   // et.sw.sq_433 et.ro.ceb_543  da.af.un_320 et.ro.fi_655
  0x32170f14, 0x35030a04, 0x2511135a, 0x23022da0,   // lv.sr.bs_666 pt.nl.zu_332  et.ro.eu_553 sk.da.ca_322
  0x0e2811ee, 0x1e291cec, 0x01000805, 0x052a3b04,   // ro.sw.is_422 id.sl.ms_644  no.en.un_330 so.mt.fr_332
  0x21131160, 0x2300350c, 0x3b033f60, 0x112017ee,   // ro.et.jw_664 zu.ca.un_530  af.nl.so_664 sr.sq.ro_422
  // [3ae0]
  0x13042009, 0x190b05ad, 0x0e041308, 0x0f202855,   // sq.fi.et_444 fr.es.gl_643  et.fi.is_443 sw.sq.lv_442
  0x16072a07, 0x070d4a05, 0x6428130c, 0x01112aee,   // mt.it.hr_432 yo.cs.it_333  et.sw.lg_543 mt.ro.en_422
  0x1b120608, 0x05003119, 0x23003f07, 0x1c292860,   // de.hu.tr_443 az.fr.un_750  af.ca.un_420 sw.sl.id_664
  0x061e1cec, 0x081213ad, 0x2301050c, 0x1e1c6b09,   // id.ms.de_644 et.hu.no_643  fr.en.ca_543 ceb.id.ms_444
  // [3af0]
  0x050701ec, 0x120e0cad, 0x03080cad, 0x216b13ee,   // en.it.fr_644 sv.is.hu_643  sv.no.nl_643 et.ceb.jw_422
  0x05101f0c, 0x06001f09, 0x13004a07, 0x6b293507,   // cy.lt.fr_543 cy.de.un_440  yo.et.un_420 zu.sl.ceb_432
  0x19201107, 0x0e005313, 0x28133f0d, 0x05005317,   // ro.sq.gl_432 ht.is.un_650  af.et.sw_554 ht.fr.un_730
  0x1c061e04, 0x200911a9, 0x1e1c6ba4, 0x136b0e04,   // ms.de.id_332 ro.pl.sq_544  ceb.id.ms_433 is.ceb.et_332
  // [3b00]
  0x11002a13, 0x080e1fec, 0x1e1c06a9, 0x120964ad,   // mt.ro.un_650 cy.is.no_644  de.id.ms_544 lg.pl.hu_643
  0x130d09ad, 0x1f001a13, 0x0f08120c, 0x6e6b68a0,   // hi.ne.bh_643 tl.cy.un_650  hu.no.lv_543 ig.ceb.hmn_322
  0x643506ec, 0x03050108, 0x2808120c, 0x3b002819,   // de.zu.lg_644 en.fr.nl_443  hu.no.sw_543 sw.so.un_750
  0x21082007, 0x255513a4, 0x132112ee, 0x0e1e1c0d,   // sq.no.jw_432 et.rw.eu_433  hu.jw.et_422 id.ms.is_554
  // [3b10]
  0x1b100cad, 0x13002308, 0x352768af, 0x040c0608,   // sv.lt.tr_643 ca.et.un_430  ig.gd.zu_655 de.sv.fi_443
  0x0c00041a, 0x01000c04, 0x120523af, 0x040a1008,   // fi.sv.un_760 sv.en.un_320  ca.fr.hu_655 be.mk.ru_443
  0x27352812, 0x1b002104, 0x080c0e13, 0x64043505,   // sw.zu.gd_654 jw.tr.un_320  is.sv.no_665 zu.fi.lg_333
  0x203f0313, 0x12006b12, 0x130821a4, 0x0200551a,   // nl.af.sq_665 ceb.hu.un_640  jw.no.et_433 rw.da.un_760
  // [3b20]
  0x3b55350c, 0x0c0608ec, 0x0413125a, 0x0f3f0308,   // zu.rw.so_543 no.de.sv_644  hu.et.fi_553 nl.af.lv_443
  0x64060e5a, 0x211c310c, 0x1b092da4, 0x18005507,   // is.de.lg_553 az.id.jw_543  sk.pl.tr_433 rw.ga.un_420
  0x02001f1a, 0x5364120c, 0x071f0213, 0x01060ca4,   // cy.da.un_760 hu.lg.ht_543  da.cy.it_665 sv.de.en_433
  0x230b05ac, 0x08040307, 0x10321708, 0x131a3b14,   // fr.es.ca_632 nl.fi.no_432  sr.bs.lt_443 so.tl.et_666
  // [3b30]
  0x2d0d3b0e, 0x2d0d0702, 0x28043ba9, 0x3b130311,   // so.cs.sk_555 it.cs.sk_222  so.fi.sw_544 nl.et.so_653
  0x643f1aa4, 0x011353a0, 0x041e5205, 0x166b2008,   // tl.af.lg_433 ht.et.en_322  ha.ms.fi_333 sq.ceb.hr_443
  0x321608ec, 0x12080209, 0x3b4a64ad, 0x03683b12,   // no.hr.bs_644 da.no.hu_444  lg.yo.so_643 so.ig.nl_654
  0x033f3bad, 0x641a6b60, 0x0a070811, 0x1c033bee,   // so.af.nl_643 ceb.tl.lg_664  uk.bg.mk_653 so.nl.id_422
  // [3b40]
  0x190b23a0, 0x1e1b1a08, 0x531827af, 0x64133b05,   // ca.es.gl_322 tl.tr.ms_443  gd.ga.ht_655 so.et.lg_333
  0x1300280c, 0x270401a9, 0x043f1aee, 0x2d090da0,   // sw.et.un_530 en.fi.gd_544  tl.af.fi_422 cs.pl.sk_322
  0x1a6b1b0d, 0x133f0411, 0x0a0710ad, 0x032a2da0,   // tr.ceb.tl_554 fi.af.et_653  be.bg.mk_643 sk.mt.nl_322
  0x07171155, 0x0d1f3102, 0x04311bad, 0x32001c04,   // ro.sr.it_442 az.cy.cs_222  tr.az.fi_643 id.bs.un_320
  // [3b50]
  0x190a0b0c, 0x0500230e, 0x06000f08, 0x2d0d0ea0,   // es.pt.gl_543 ca.fr.un_550  lv.de.un_430 is.cs.sk_322
  0x283132a0, 0x290d3504, 0x230b19ad, 0x16000b07,   // bs.az.sw_322 zu.cs.sl_332  gl.es.ca_643 es.hr.un_420
  0x07052107, 0x1a1f0111, 0x1a002702, 0x1c211e07,   // jw.fr.it_432 en.cy.tl_653  gd.tl.un_220 ms.jw.id_432
  0x53041e0c, 0x0c0106a9, 0x071f1804, 0x170a1160,   // ms.fi.ht_543 de.en.sv_544  ga.cy.it_332 ro.mk.sr_664
  // [3b60]
  0x1a011f0d, 0x1a6b0407, 0x211228a4, 0x08020309,   // cy.en.tl_554 fi.ceb.tl_432  sw.hu.jw_433 nl.da.no_444
  0x13201002, 0x1b003209, 0x054a6b0c, 0x04002312,   // lt.sq.et_222 bs.tr.un_440  ceb.yo.fr_543 ca.fi.un_640
  0x5207210c, 0x0e00180e, 0x283b1ea4, 0x190b1105,   // jw.it.ha_543 ga.is.un_550  ms.so.sw_433 ro.es.gl_333
  0x0d131c0d, 0x55283509, 0x1b000f21, 0x29181eee,   // mr.bh.ne_554 zu.sw.rw_444  lv.tr.un_860 ms.ga.sl_422
  // [3b70]
  0x53680707, 0x0c131b07, 0x310910af, 0x170f1ba7,   // it.ig.ht_432 tr.et.sv_432  lt.pl.az_655 tr.lv.sr_532
  0x29283512, 0x20001a02, 0x21181208, 0x051c0e02,   // zu.sw.sl_654 tl.sq.un_220  ur.ar.fa_443 is.id.fr_222
  0x130f1207, 0x190b120c, 0x12000b04, 0x3b1e280c,   // hu.lv.et_432 hu.es.gl_543  es.hu.un_320 sw.ms.so_543
  0x23000507, 0x12230507, 0x32200faf, 0x13060707,   // fr.ca.un_420 fr.ca.hu_432  lv.sq.bs_655 it.de.et_432
  // [3b80]
  0x210f1b11, 0x190b2da9, 0x53000f08, 0x0e1f250c,   // tr.lv.jw_653 sk.es.gl_544  lv.ht.un_430 eu.cy.is_543
  0x1a001c13, 0x23111855, 0x13040f08, 0x040d2055,   // id.tl.un_650 ga.ro.ca_442  lv.fi.et_443 sq.cs.fi_442
  0x2a100f12, 0x680d01a4, 0x25100f13, 0x35006b12,   // lv.lt.mt_654 en.cs.ig_433  lv.lt.eu_665 ceb.zu.un_640
  0x3f2a28a4, 0x1f000e1a, 0x230c1aa9, 0x0407175a,   // sw.mt.af_433 is.cy.un_760  tl.sv.ca_544 sr.bg.ru_553
  // [3b90]
  0x53080eec, 0x351a5302, 0x0f13170c, 0x25171b0c,   // is.no.ht_644 ht.tl.zu_222  sr.et.lv_543 tr.sr.eu_543
  0x00002737, 0x116b0f07, 0x18005302, 0x6b071aaf,   // gd.un.un_B00 lv.ceb.ro_432  ht.ga.un_220 tl.it.ceb_655
  0x08001b0e, 0x18005307, 0x3b040e04, 0x190b68a0,   // tr.no.un_550 ht.ga.un_420  is.fi.so_332 ig.es.gl_322
  0x11200d0c, 0x53281b05, 0x100411a0, 0x200c2304,   // cs.sq.ro_543 tr.sw.ht_333  ro.ru.be_322 ca.sv.sq_332
  // [3ba0]
  0x64190bad, 0x1a5321a9, 0x05532012, 0x04250fee,   // es.gl.lg_643 jw.ht.tl_544  sq.ht.fr_654 lv.eu.fi_422
  0x1120010c, 0x2d0d27af, 0x06521b0c, 0x191a0b0b,   // en.sq.ro_543 gd.cs.sk_655  tr.ha.de_543 es.tl.gl_542
  0x10001602, 0x2a005314, 0x0e013b04, 0x1e281c0c,   // hr.lt.un_220 ht.mt.un_660  so.en.is_332 id.sw.ms_543
  0x0f003207, 0x0b190aad, 0x170a1104, 0x0e022507,   // bs.lv.un_420 pt.gl.es_643  ro.mk.sr_332 eu.da.is_432
  // [3bb0]
  0x01001a04, 0x3152280d, 0x0b0a0714, 0x131a28ac,   // tl.en.un_320 sw.ha.az_554  it.pt.es_666 sw.tl.et_632
  0x09190b0c, 0x25006813, 0x011b20a4, 0x2d001a05,   // es.gl.pl_543 ig.eu.un_650  sq.tr.en_433 tl.sk.un_330
  0x3500641a, 0x013b6bad, 0x35201aa4, 0x09001334,   // lg.zu.un_760 ceb.so.en_643  tl.sq.zu_433 bh.hi.un_A80
  0x0b290d0c, 0x0b0a0c11, 0x2d0d1014, 0x3b526408,   // cs.sl.es_543 sv.pt.es_653  lt.cs.sk_666 lg.ha.so_443
  // [3bc0]
  0x1a3b6b0c, 0x3f031c04, 0x211a6b0c, 0x3b001a19,   // ceb.so.tl_543 id.nl.af_332  ceb.tl.jw_543 tl.so.un_750
  0x16005512, 0x0911200c, 0x0a0d2dec, 0x17292aa4,   // rw.hr.un_640 sq.ro.pl_543  sk.cs.pt_644 mt.sl.sr_433
  0x06001707, 0x11081008, 0x1600100d, 0x02001213,   // sr.de.un_420 be.uk.ro_443  lt.hr.un_540 hu.da.un_650
  0x07283513, 0x23111905, 0x35003204, 0x3f351c04,   // zu.sw.it_665 gl.ro.ca_333  bs.zu.un_320 id.zu.af_332
  // [3bd0]
  0x3f112514, 0x2b3f10ec, 0x1b07120c, 0x21033f0c,   // eu.ro.af_666 lt.af.vi_644  hu.it.tr_543 af.nl.jw_543
  0x23271f0c, 0x6b3b1a0c, 0x31002d08, 0x060f1fa7,   // cy.gd.ca_543 tl.so.ceb_543  sk.az.un_430 cy.lv.de_532
  0x3b521a0c, 0x03001004, 0x28000d04, 0x3b281a0c,   // tl.ha.so_543 lt.nl.un_320  cs.sw.un_320 tl.sw.so_543
  0x120a4aaf, 0x28131aa0, 0x05230b08, 0x64003b13,   // yo.pt.hu_655 tl.et.sw_322  es.ca.fr_443 so.lg.un_650
  // [3be0]
  0x553b1aad, 0x3b312008, 0x2055310c, 0x04000214,   // tl.so.rw_643 sq.az.so_443  az.rw.sq_543 da.fi.un_660
  0x29200f04, 0x1a043b05, 0x3b521b0c, 0x12000f13,   // lv.sq.sl_332 so.fi.tl_333  tr.ha.so_543 lv.hu.un_650
  0x0a120ea0, 0x02011207, 0x11100460, 0x0e1321a7,   // is.hu.pt_322 hu.en.da_432  ru.be.ro_664 jw.et.is_532
  0x232d0daf, 0x0e000d0d, 0x041028a4, 0x0a250b07,   // cs.sk.ca_655 cs.is.un_540  sw.lt.fi_433 es.eu.pt_432
  // [3bf0]
  0x0f0413af, 0x0d091cad, 0x6b683107, 0x351c2a0c,   // et.fi.lv_655 mr.hi.ne_643  az.ig.ceb_432 mt.id.zu_543
  0x060a0308, 0x23060704, 0x29001122, 0x20253b07,   // nl.pt.de_443 it.de.ca_332  ro.sl.un_870 so.eu.sq_432
  0x1e050807, 0x55001e13, 0x1c13090e, 0x03112d08,   // no.fr.ms_432 ms.rw.un_650  hi.bh.mr_555 sk.ro.nl_443
  0x18003202, 0x122003ee, 0x0b002307, 0x283f0a12,   // bs.ga.un_220 nl.sq.hu_422  ca.es.un_420 pt.af.sw_654

  // [3c00]
  0x230b12ad, 0x353b28ad, 0x4a530708, 0x1b0c3ba0,   // hu.es.ca_643 sw.so.zu_643  it.ht.yo_443 so.sv.tr_322
  0x042523af, 0x3b3510a4, 0x1f351bec, 0x552835ad,   // ca.eu.fi_655 lt.zu.so_433  tr.zu.cy_644 zu.sw.rw_643
  0x0e521bec, 0x18000704, 0x181b27a4, 0x0e000a04,   // tr.ha.is_644 it.ga.un_320  gd.tr.ga_433 pt.is.un_320
  0x35642809, 0x06553512, 0x1004170d, 0x282d3513,   // sw.lg.zu_444 zu.rw.de_654  sr.ru.be_554 zu.sk.sw_665
  // [3c10]
  0x0800020b, 0x1e313504, 0x020e550c, 0x32006807,   // da.no.un_520 zu.az.ms_332  rw.is.da_543 ig.bs.un_420
  0x53112a04, 0x35311ba4, 0x050713a0, 0x120b23a4,   // mt.ro.ht_332 tr.az.zu_433  et.it.fr_322 ca.es.hu_433
  0x0f00680c, 0x09000d33, 0x6e003b20, 0x1a6b4a0c,   // ig.lv.un_530 ne.hi.un_A70  so.hmn.un_850 yo.ceb.tl_543
  0x2b0c0611, 0x040208ec, 0x186e64a4, 0x2d00092a,   // de.sv.vi_653 no.da.fi_644  lg.hmn.ga_433 pl.sk.un_970
  // [3c20]
  0x17071004, 0x1a013b07, 0x07006e08, 0x2d091fec,   // be.bg.sr_332 so.en.tl_432  hmn.it.un_430 cy.pl.sk_644
  0x23214a05, 0x2b136ba0, 0x2d0d12b2, 0x682917a4,   // yo.jw.ca_333 ceb.et.vi_322  hu.cs.sk_732 sr.sl.ig_433
  0x120c0f0c, 0x10070804, 0x25351905, 0x2d0d23af,   // lv.sv.hu_543 uk.bg.be_332  gl.zu.eu_333 ca.cs.sk_655
  0x3113640d, 0x1b003202, 0x133b3fa4, 0x0235680c,   // lg.et.az_554 bs.tr.un_220  af.so.et_433 ig.zu.da_543
  // [3c30]
  0x6b2318a4, 0x3b003102, 0x01006b02, 0x28012aa4,   // ga.ca.ceb_433 az.so.un_220  ceb.en.un_220 mt.en.sw_433
  0x121e1c07, 0x322d2905, 0x07005508, 0x16006e08,   // id.ms.hu_432 sl.sk.bs_333  rw.it.un_430 hmn.hr.un_430
  0x191223a7, 0x1c2a2102, 0x31181b14, 0x030635a7,   // ca.hu.gl_532 jw.mt.id_222  tr.ga.az_666 zu.de.nl_532
  0x03061812, 0x07100a05, 0x32101655, 0x1900230c,   // ga.de.nl_654 mk.be.bg_333  hr.lt.bs_442 ca.gl.un_530
  // [3c40]
  0x06040c12, 0x1b2531a4, 0x64551ea0, 0x090c0808,   // sv.fi.de_654 az.eu.tr_433  ms.rw.lg_322 no.sv.pl_443
  0x082835ee, 0x53000509, 0x1b00230e, 0x1a356ba4,   // zu.sw.no_422 fr.ht.un_440  ca.tr.un_550 ceb.zu.tl_433
  0x2b6b1c11, 0x0d00290e, 0x356864ec, 0x3b355555,   // id.ceb.vi_653 sl.cs.un_550  lg.ig.zu_644 rw.zu.so_442
  0x64253513, 0x19121307, 0x0c001f2b, 0x131c0911,   // zu.eu.lg_665 et.hu.gl_432  cy.sv.un_980 hi.mr.bh_653
  // [3c50]
  0x1b1321a4, 0x3f001e04, 0x6b001c05, 0x110708a4,   // jw.et.tr_433 ms.af.un_320  id.ceb.un_330 uk.bg.ro_433
  0x073f010c, 0x251819a0, 0x080204ee, 0x2d120513,   // en.af.it_543 gl.ga.eu_322  fi.da.no_422 fr.hu.sk_665
  0x531907af, 0x191a5511, 0x1c211ea0, 0x23055312,   // it.gl.ht_655 rw.tl.gl_653  ms.jw.id_322 ht.fr.ca_654
  0x52126b02, 0x190b070e, 0x200f5505, 0x10294aec,   // ceb.hu.ha_222 it.es.gl_555  rw.lv.sq_333 yo.sl.lt_644
  // [3c60]
  0x551f4a0c, 0x2d551908, 0x16000d0c, 0x1b27530b,   // yo.cy.rw_543 gl.rw.sk_443  cs.hr.un_530 ht.gd.tr_542
  0x2a23060c, 0x4a051905, 0x531e0307, 0x19283555,   // de.ca.mt_543 gl.fr.yo_333  nl.ms.ht_432 zu.sw.gl_442
  0x00005337, 0x0e182712, 0x1f071104, 0x1b000521,   // ht.un.un_B00 gd.ga.is_654  ro.it.cy_332 fr.tr.un_860
  0x550a07a4, 0x171629a4, 0x19002004, 0x250602af,   // it.pt.rw_433 sl.hr.sr_433  sq.gl.un_320 da.de.eu_655
  // [3c70]
  0x20521aa0, 0x200b2704, 0x05000104, 0x0b004a02,   // tl.ha.sq_322 gd.es.sq_332  en.fr.un_320 yo.es.un_220
  0x060313ee, 0x5552280c, 0x10003b14, 0x3f31050c,   // et.nl.de_422 sw.ha.rw_543  so.lt.un_660 fr.az.af_543
  0x2a0c060c, 0x07191aa4, 0x0a081009, 0x0c0628a0,   // de.sv.mt_543 tl.gl.it_433  be.uk.mk_444 sw.de.sv_322
  0x1a1011a4, 0x21251eee, 0x551364ec, 0x081c1e11,   // ro.lt.tl_433 ms.eu.jw_422  lg.et.rw_644 ms.id.no_653
  // [3c80]
  0x64211ca4, 0x1f3b0413, 0x52131b13, 0x131021a0,   // id.jw.lg_433 fi.so.cy_665  tr.et.ha_665 jw.lt.et_322
  0x16006b0c, 0x27066ea0, 0x1a553513, 0x6e005314,   // ceb.hr.un_530 hmn.de.gd_322  zu.rw.tl_665 ht.hmn.un_660
  0x64121fa0, 0x070168a0, 0x292d0d11, 0x6b1b53a4,   // cy.hu.lg_322 ig.en.it_322  cs.sk.sl_653 ht.tr.ceb_433
  0x17066e07, 0x0718270c, 0x6b1b1a11, 0x291a6eee,   // hmn.de.sr_432 gd.ga.it_543  tl.tr.ceb_653 hmn.tl.sl_422
  // [3c90]
  0x3f6408a4, 0x12091812, 0x280855a4, 0x351b5505,   // no.lg.af_433 ga.pl.hu_654  rw.no.sw_433 rw.tr.zu_333
  0x12182312, 0x09002008, 0x12006e04, 0x64520304,   // ca.ga.hu_654 sq.pl.un_430  hmn.hu.un_320 nl.ha.lg_332
  0x111b13a4, 0x0d043f04, 0x0f1123ad, 0x53003519,   // et.tr.ro_433 af.fi.cs_332  ca.ro.lv_643 zu.ht.un_750
  0x10251113, 0x13041a0c, 0x106b1a05, 0x043f52a4,   // ro.eu.lt_665 tl.fi.et_543  tl.ceb.lt_333 ha.af.fi_433
  // [3ca0]
  0x130825ad, 0x170a080c, 0x29000a08, 0x1f006e23,   // eu.no.et_643 uk.mk.sr_543  pt.sl.un_430 hmn.cy.un_880
  0x3f0308af, 0x111e0707, 0x64033f12, 0x040208a4,   // no.nl.af_655 it.ms.ro_432  af.nl.lg_654 no.da.fi_433
  0x23001216, 0x1c0d0911, 0x1b190aa4, 0x0d122d07,   // hu.ca.un_720 hi.ne.mr_653  pt.gl.tr_433 sk.hu.cs_432
  0x3f1b2512, 0x1b1e1c08, 0x17042a07, 0x100b1912,   // eu.tr.af_654 id.ms.tr_443  mt.fi.sr_432 gl.es.lt_654
  // [3cb0]
  0x0e032daf, 0x6e000f08, 0x3b001a07, 0x0a001702,   // sk.nl.is_655 lv.hmn.un_430  tl.so.un_420 sr.mk.un_220
  0x120655a4, 0x13160da4, 0x0c0d2912, 0x0b23110c,   // rw.de.hu_433 cs.hr.et_433  sl.cs.sv_654 ro.ca.es_543
  0x1e13200c, 0x0d190aa9, 0x3f181f0d, 0x2d002302,   // sq.et.ms_543 pt.gl.cs_544  cy.ga.af_554 ca.sk.un_220
  0x55200f0c, 0x3b551b60, 0x4a006802, 0x351a6b13,   // lv.sq.rw_543 tr.rw.so_664  ig.yo.un_220 ceb.tl.zu_665
  // [3cc0]
  0x01003b04, 0x0c0325ee, 0x1e1c55ee, 0x28556b12,   // so.en.un_320 eu.nl.sv_422  rw.id.ms_422 ceb.rw.sw_654
  0x25213513, 0x1a6b5555, 0x350321af, 0x19100bec,   // zu.jw.eu_665 rw.ceb.tl_442  jw.nl.zu_655 es.lt.gl_644
  0x0f190b0d, 0x32006b08, 0x130d2da0, 0x55212511,   // es.gl.lv_554 ceb.bs.un_430  sk.cs.et_322 eu.jw.rw_653
  0x171325ee, 0x02033f0e, 0x4a5231af, 0x28213b12,   // eu.et.sr_422 af.nl.da_555  az.ha.yo_655 so.jw.sw_654
  // [3cd0]
  0x35003b07, 0x190a0f0e, 0x32162907, 0x276e2a07,   // so.zu.un_420 lv.pt.gl_555  sl.hr.bs_432 mt.hmn.gd_432
  0x190a0ba0, 0x6b1e1c0d, 0x181923a4, 0x271801af,   // es.pt.gl_322 id.ms.ceb_554  ca.gl.ga_433 en.ga.gd_655
  0x18010505, 0x4a135507, 0x1c3b1e0d, 0x030e3f04,   // fr.en.ga_333 rw.et.yo_432  ms.so.id_554 af.is.nl_332
  0x250c3f08, 0x081a6bad, 0x06182713, 0x19122da7,   // af.sv.eu_443 ceb.tl.no_643  gd.ga.de_665 sk.hu.gl_532
  // [3ce0]
  0x0312250c, 0x1b251ea9, 0x060328a0, 0x1e1a1c11,   // eu.hu.nl_543 ms.eu.tr_544  sw.nl.de_322 id.tl.ms_653
  0x0e082108, 0x04252108, 0x0c210812, 0x181b35ad,   // jw.no.is_443 jw.eu.fi_443  no.jw.sv_654 zu.tr.ga_643
  0x271f01a9, 0x25092da0, 0x0c530e13, 0x211c6804,   // en.cy.gd_544 sk.pl.eu_322  is.ht.sv_665 ig.id.jw_332
  0x272001a9, 0x271918ee, 0x06081355, 0x026b1a0d,   // en.sq.gd_544 ga.gl.gd_422  et.no.de_442 tl.ceb.da_554
  // [3cf0]
  0x02001a12, 0x1100181a, 0x1e211ca9, 0x20110fa4,   // tl.da.un_640 ga.ro.un_760  id.jw.ms_544 lv.ro.sq_433
  0x6b1b28ac, 0x212a28a4, 0x132928a4, 0x08230611,   // sw.tr.ceb_632 sw.mt.jw_433  sw.sl.et_433 de.ca.no_653
  0x3b1f5202, 0x03002513, 0x642718ec, 0x1900311b,   // ha.cy.so_222 eu.nl.un_650  ga.gd.lg_644 az.gl.un_770
  0x6b002508, 0x0d1c130d, 0x190b11a4, 0x09135555,   // eu.ceb.un_430 bh.mr.ne_554  ro.es.gl_433 rw.et.pl_442
  // [3d00]
  0x52000f1a, 0x01072d05, 0x11050708, 0x124a1308,   // lv.ha.un_760 sk.it.en_333  it.fr.ro_443 et.yo.hu_443
  0x230d2da9, 0x23011b0c, 0x19002d0d, 0x01000921,   // sk.cs.ca_544 tr.en.ca_543  sk.gl.un_540 pl.en.un_860
  0x12046baf, 0x02180607, 0x040a0702, 0x25190aa4,   // ceb.fi.hu_655 de.ga.da_432  bg.mk.ru_222 pt.gl.eu_433
  0x19521a0d, 0x06030f07, 0x080e03ad, 0x28004a13,   // tl.ha.gl_554 lv.nl.de_432  nl.is.no_643 yo.sw.un_650
  // [3d10]
  0x0d006814, 0x315528a4, 0x080218ee, 0x20285304,   // ig.cs.un_660 sw.rw.az_433  ga.da.no_422 ht.sw.sq_332
  0x0205010c, 0x031c08ad, 0x3b3564af, 0x324a5508,   // en.fr.da_543 no.id.nl_643  lg.zu.so_655 rw.yo.bs_443
  0x2d0d4aa6, 0x0c0a0809, 0x0a002108, 0x0a00010c,   // yo.cs.sk_521 no.pt.sv_444  jw.pt.un_430 en.pt.un_530
  0x550128a4, 0x0c000621, 0x025508af, 0x100a04ee,   // sw.en.rw_433 de.sv.un_860  no.rw.da_655 fi.pt.lt_422
  // [3d20]
  0x060c010c, 0x350255af, 0x190b070c, 0x19002d08,   // en.sv.de_543 rw.da.zu_655  it.es.gl_543 sk.gl.un_430
  0x2d0d0cee, 0x190b18ec, 0x020c08ee, 0x01001904,   // sv.cs.sk_422 ga.es.gl_644  no.sv.da_422 gl.en.un_320
  0x050a3b04, 0x1a53010c, 0x0c06030c, 0x1055010c,   // so.pt.fr_332 en.ht.tl_543  nl.de.sv_543 en.rw.lt_543
  0x0a005519, 0x6455050b, 0x234a050b, 0x64030607,   // rw.pt.un_750 fr.rw.lg_542  fr.yo.ca_542 de.nl.lg_432
  // [3d30]
  0x550c025a, 0x041110af, 0x1f354a05, 0x23004a12,   // da.sv.rw_553 be.ro.ru_655  yo.zu.cy_333 yo.ca.un_640
  0x28001c04, 0x283b35ad, 0x4a000708, 0x1300030c,   // id.sw.un_320 zu.so.sw_643  it.yo.un_430 nl.et.un_530
  0x0e0f1011, 0x2168200c, 0x08005304, 0x10000f2b,   // lt.lv.is_653 sq.ig.jw_543  ht.no.un_320 lv.lt.un_980
  0x0e03100c, 0x35644aa4, 0x05006e04, 0x0b191812,   // lt.nl.is_543 yo.lg.zu_433  hmn.fr.un_320 ga.gl.es_654
  // [3d40]
  0x08132a0e, 0x643568af, 0x0e002d13, 0x3f036e08,   // mt.et.no_555 ig.zu.lg_655  sk.is.un_650 hmn.nl.af_443
  0x04001a0e, 0x07002322, 0x136b1a07, 0x085528ee,   // tl.fi.un_550 ca.it.un_870  tl.ceb.et_432 sw.rw.no_422
  0x01060c0c, 0x31041b21, 0x1e026407, 0x1f131aee,   // sv.de.en_543 tr.fi.az_876  lg.da.ms_432 tl.et.cy_422
  0x3b000a12, 0x28011805, 0x3b0d52a0, 0x1a3b6ba0,   // pt.so.un_640 ga.en.sw_333  ha.cs.so_322 ceb.so.tl_322
  // [3d50]
  0x550664a0, 0x120635a4, 0x126b1a60, 0x06093f04,   // lg.de.rw_322 zu.de.hu_433  tl.ceb.hu_664 af.pl.de_332
  0x291135a9, 0x3f060c14, 0x0a000616, 0x070511af,   // zu.ro.sl_544 sv.de.af_666  de.pt.un_720 ro.fr.it_655
  0x1a036ba4, 0x0c251e0c, 0x171110a4, 0x190a2305,   // ceb.nl.tl_433 ms.eu.sv_543  be.ro.sr_433 ca.pt.gl_333
  0x28352008, 0x04080305, 0x041a6b0c, 0x284a350c,   // sq.zu.sw_443 nl.no.fi_333  ceb.tl.fi_543 zu.yo.sw_543
  // [3d60]
  0x0e060ca9, 0x5300350d, 0x29552808, 0x6b102904,   // sv.de.is_544 zu.ht.un_540  sw.rw.sl_443 sl.lt.ceb_332
  0x0d253b11, 0x17081105, 0x4a003522, 0x3f0112a9,   // so.eu.cs_653 ro.uk.sr_333  zu.yo.un_870 hu.en.af_544
  0x0e2a080d, 0x2a070c07, 0x35115504, 0x1f283512,   // no.mt.is_554 sv.it.mt_432  rw.ro.zu_332 zu.sw.cy_654
  0x32002911, 0x253f01a4, 0x19230aa9, 0x010c1f05,   // sl.bs.un_630 en.af.eu_433  pt.ca.gl_544 cy.sv.en_333
  // [3d70]
  0x08291607, 0x2821120c, 0x29001f14, 0x1004110c,   // hr.sl.no_432 hu.jw.sw_543  cy.sl.un_660 ro.ru.be_543
  0x6b033f05, 0x20251b0c, 0x1c062107, 0x1c1b1ea0,   // af.nl.ceb_333 tr.eu.sq_543  jw.de.id_432 ms.tr.id_322
  0x1e061ca4, 0x250c08a4, 0x35646813, 0x0e08010c,   // id.de.ms_433 no.sv.eu_433  ig.lg.zu_665 en.no.is_543
  0x52311b60, 0x123f0305, 0x1100062b, 0x0c002908,   // tr.az.ha_664 nl.af.hu_333  de.ro.un_980 sl.sv.un_430
  // [3d80]
  0x18001e02, 0x2907090c, 0x531827ad, 0x0c0729a4,   // ms.ga.un_220 pl.it.sl_543  gd.ga.ht_643 sl.it.sv_433
  0x1e1c27a4, 0x1b6b1a0e, 0x21521eee, 0x2d100d14,   // gd.id.ms_433 tl.ceb.tr_555  ms.ha.jw_422 cs.lt.sk_666
  0x2a031a07, 0x083521a4, 0x35000a0d, 0x28006412,   // tl.nl.mt_432 jw.zu.no_433  pt.zu.un_540 lg.sw.un_640
  0x2d121aa0, 0x090a18ec, 0x03643f12, 0x12003504,   // tl.hu.sk_322 ga.pt.pl_644  af.lg.nl_654 zu.hu.un_320
  // [3d90]
  0x04006407, 0x290c5307, 0x0a00121b, 0x17000a04,   // lg.fi.un_420 ht.sv.sl_432  hu.pt.un_770 mk.sr.un_320
  0x11231e07, 0x0400280c, 0x0b230a07, 0x121301af,   // ms.ca.ro_432 sw.fi.un_530  pt.ca.es_432 en.et.hu_655
  0x0264680c, 0x130e2007, 0x68526413, 0x12002108,   // ig.lg.da_543 sq.is.et_432  lg.ha.ig_665 jw.hu.un_430
  0x0d001c04, 0x3b312aac, 0x02000122, 0x23001219,   // id.cs.un_320 mt.az.so_632  en.da.un_870 hu.ca.un_750
  // [3da0]
  0x130e0ca4, 0x1c002502, 0x08026eee, 0x13106e07,   // sv.is.et_433 eu.id.un_220  hmn.da.no_422 hmn.lt.et_432
  0x0a002310, 0x230b01a4, 0x19251f07, 0x52352812,   // ca.pt.un_620 en.es.ca_433  cy.eu.gl_432 sw.zu.ha_654
  0x6e080209, 0x3f005302, 0x190b25a6, 0x0200130d,   // da.no.hmn_444 ht.af.un_220  eu.es.gl_521 et.da.un_540
  0x17100412, 0x21001302, 0x170f3204, 0x04000a33,   // ru.be.sr_654 et.jw.un_220  bs.lv.sr_332 mk.ru.un_A70
  // [3db0]
  0x09290f0c, 0x4a005322, 0x352555a9, 0x0600071a,   // lv.sl.pl_543 ht.yo.un_870  rw.eu.zu_544 it.de.un_760
  0x3f0c0302, 0x18111eee, 0x3f016402, 0x16062508,   // nl.sv.af_222 ms.ro.ga_422  lg.en.af_222 eu.de.hr_443
  0x0c006e0c, 0x19002302, 0x2b006e0e, 0x162d0d0d,   // hmn.sv.un_530 ca.gl.un_220  hmn.vi.un_550 cs.sk.hr_554
  0x03000c08, 0x19060bee, 0x050b07ee, 0x16001702,   // sv.nl.un_430 es.de.gl_422  it.es.fr_422 sr.hr.un_220
  // [3dc0]
  0x1b082502, 0x1b002809, 0x53004a19, 0x07534a5a,   // eu.no.tr_222 sw.tr.un_440  yo.ht.un_750 yo.ht.it_553
  0x0a100704, 0x180a1902, 0x120420ac, 0x3f0c0313,   // bg.be.mk_332 gl.pt.ga_222  sq.fi.hu_632 nl.sv.af_665
  0x131b0e07, 0x192d0bec, 0x190e0a0c, 0x5306020e,   // is.tr.et_432 es.sk.gl_644  pt.is.gl_543 da.de.ht_555
  0x19120b04, 0x18001902, 0x11283511, 0x31002919,   // es.hu.gl_332 gl.ga.un_220  zu.sw.ro_653 sl.az.un_750
  // [3dd0]
  0x1b003b12, 0x05003208, 0x21231ca9, 0x1b682513,   // so.tr.un_640 bs.fr.un_430  id.ca.jw_544 eu.ig.tr_665
  0x524a68a9, 0x31003b0c, 0x4a000713, 0x01006e04,   // ig.yo.ha_544 so.az.un_530  it.yo.un_650 hmn.en.un_320
  0x09282107, 0x35314a07, 0x6b121007, 0x203564ac,   // jw.sw.pl_432 yo.az.zu_432  lt.hu.ceb_432 lg.zu.sq_632
  0x12000f18, 0x02005204, 0x3b020c0c, 0x3b352107,   // lv.hu.un_740 ha.da.un_320  sv.da.so_543 jw.zu.so_432
  // [3de0]
  0x040a07ec, 0x21190bad, 0x060d35a4, 0x20002513,   // bg.mk.ru_644 es.gl.jw_643  zu.cs.de_433 eu.sq.un_650
  0x552804a4, 0x68005513, 0x21106ba4, 0x17080aa7,   // fi.sw.rw_433 rw.ig.un_650  ceb.lt.jw_433 mk.uk.sr_532
  0x09253511, 0x0413080c, 0x5511280c, 0x25000f21,   // zu.eu.pl_653 no.et.fi_543  sw.ro.rw_543 lv.eu.un_860
  0x2a6b13a9, 0x10531ca4, 0x642555a9, 0x11126807,   // et.ceb.mt_544 id.ht.lt_433  rw.eu.lg_544 ig.hu.ro_432
  // [3df0]
  0x1e1c3b04, 0x1a075307, 0x02000314, 0x07004a11,   // so.id.ms_332 ht.it.tl_432  nl.da.un_660 yo.it.un_630
  0x033f2102, 0x1a6b1308, 0x52251a0d, 0x53255514,   // jw.af.nl_222 et.ceb.tl_443  tl.eu.ha_554 rw.eu.ht_666
  0x07005305, 0x20002104, 0x1a00070d, 0x0325130c,   // ht.it.un_330 jw.sq.un_320  it.tl.un_540 et.eu.nl_543
  0x52001907, 0x18315304, 0x0c082a0d, 0x4a0964a9,   // gl.ha.un_420 ht.az.ga_332  mt.no.sv_554 lg.pl.yo_544
  // [3e00]
  0x0f130408, 0x0955290c, 0x03095308, 0x1100031b,   // fi.et.lv_443 sl.rw.pl_543  ht.pl.nl_443 nl.ro.un_770
  0x230511af, 0x68162da4, 0x6b002304, 0x031f0604,   // ro.fr.ca_655 sk.hr.ig_433  ca.ceb.un_320 de.cy.nl_332
  0x093f2da4, 0x070a1004, 0x192a0714, 0x0f212aa4,   // sk.af.pl_433 be.mk.bg_332  it.mt.gl_666 mt.jw.lv_433
  0x010435a0, 0x04101308, 0x08020cad, 0x2825135a,   // zu.fi.en_322 et.lt.fi_443  sv.da.no_643 et.eu.sw_553
  // [3e10]
  0x1125130c, 0x070a1113, 0x1e251a08, 0x10111fee,   // et.eu.ro_543 ro.mk.bg_665  tl.eu.ms_443 cy.ro.lt_422
  0x2d002902, 0x322d29a4, 0x2535130c, 0x350f130c,   // sl.sk.un_220 sl.sk.bs_433  et.zu.eu_543 et.lv.zu_543
  0x2800131b, 0x1b01130c, 0x35042805, 0x011f0b12,   // et.sw.un_770 et.en.tr_543  sw.fi.zu_333 es.cy.en_654
  0x04133205, 0x3200090c, 0x23001112, 0x5364280c,   // bs.et.fi_333 pl.bs.un_530  ro.ca.un_640 sw.lg.ht_543
  // [3e20]
  0x1c0e10ad, 0x28001a07, 0x01002434, 0x13350ead,   // lt.is.id_643 tl.sw.un_420  yi.iw.un_A80 is.zu.et_643
  0x09131c12, 0x12182dad, 0x03061ca4, 0x061803a0,   // mr.bh.hi_654 sk.ga.hu_643  id.de.nl_433 nl.ga.de_322
  0x032b3f07, 0x070811a0, 0x162d2908, 0x0b0105af,   // af.vi.nl_432 ro.uk.bg_322  sl.sk.hr_443 fr.en.es_655
  0x28351b0c, 0x0e043504, 0x23006408, 0x040721a9,   // tr.zu.sw_543 zu.fi.is_332  lg.ca.un_430 jw.it.fi_544
  // [3e30]
  0x04132105, 0x1e041307, 0x041a6b08, 0x043513a4,   // jw.et.fi_333 et.fi.ms_432  ceb.tl.fi_443 et.zu.fi_433
  0x040d11ee, 0x2b001a02, 0x21006b02, 0x28213b07,   // ro.cs.fi_422 tl.vi.un_220  ceb.jw.un_220 so.jw.sw_432
  0x03051105, 0x32126e0c, 0x0900180c, 0x166e2912,   // ro.fr.nl_333 hmn.hu.bs_543  ga.pl.un_530 sl.hmn.hr_654
  0x256409a4, 0x0a000705, 0x53006e22, 0x0a1b530c,   // pl.lg.eu_433 bg.mk.un_330  hmn.ht.un_870 ht.tr.pt_543
  // [3e40]
  0x2d6e2912, 0x07081014, 0x28641f0c, 0x6e001e0d,   // sl.hmn.sk_654 be.uk.bg_666  cy.lg.sw_543 ms.hmn.un_540
  0x0b000808, 0x11000b0c, 0x12206eec, 0x1c645512,   // no.es.un_430 es.ro.un_530  hmn.sq.hu_644 rw.lg.id_654
  0x2d0f110c, 0x1b0604ad, 0x040f2aa6, 0x08060208,   // ro.lv.sk_543 fi.de.tr_643  mt.lv.fi_521 da.de.no_443
  0x28555207, 0x0c18275a, 0x25000412, 0x1c641e0c,   // ha.rw.sw_432 gd.ga.sv_553  fi.eu.un_640 ms.lg.id_543
  // [3e50]
  0x0f002105, 0x070a1011, 0x29002023, 0x011311ad,   // jw.lv.un_330 be.mk.bg_653  sq.sl.un_880 ro.et.en_643
  0x061c1e12, 0x29001e08, 0x6e00532c, 0x0f5511ad,   // ms.id.de_654 ms.sl.un_430  ht.hmn.un_990 ro.rw.lv_643
  0x2d12110c, 0x4a11020b, 0x1e002a04, 0x01001804,   // ro.hu.sk_543 da.ro.yo_542  mt.ms.un_320 ga.en.un_320
  0x02292da9, 0x2b521807, 0x0e321713, 0x3b6864a0,   // sk.sl.da_544 ga.ha.vi_432  sr.bs.is_665 lg.ig.so_322
  // [3e60]
  0x29551e0d, 0x550711af, 0x1e1c040e, 0x231120a4,   // ms.rw.sl_554 ro.it.rw_655  fi.id.ms_555 sq.ro.ca_433
  0x4a121902, 0x060e1713, 0x25000414, 0x1217290c,   // gl.hu.yo_222 sr.is.de_665  fi.eu.un_660 sl.sr.hu_543
  0x1104170c, 0x13040660, 0x1e001b05, 0x205329a9,   // sr.ru.ro_543 de.fi.et_664  tr.ms.un_330 sl.ht.sq_544
  0x2a3120a7, 0x112805a7, 0x06521107, 0x18252804,   // sq.az.mt_532 fr.sw.ro_532  ro.ha.de_432 sw.eu.ga_332
  // [3e70]
  0x081a0c02, 0x09006e2c, 0x06046411, 0x2a2852ad,   // sv.tl.no_222 hmn.pl.un_990  lg.fi.de_653 ha.sw.mt_643
  0x080204ec, 0x55281aa4, 0x1f001814, 0x0e4a120c,   // fi.da.no_644 tl.sw.rw_433  ga.cy.un_660 hu.yo.is_543
  0x17002a13, 0x2a640412, 0x350f1fa7, 0x201232af,   // mt.sr.un_650 fi.lg.mt_654  cy.lv.zu_532 bs.hu.sq_655
  0x6421200c, 0x23004a05, 0x19001f19, 0x281b64a4,   // sq.jw.lg_543 yo.ca.un_330  cy.gl.un_750 lg.tr.sw_433
  // [3e80]
  0x10000805, 0x2d006e08, 0x1f006421, 0x29002d05,   // no.lt.un_330 hmn.sk.un_430  lg.cy.un_860 sk.sl.un_330
  0x2500030d, 0x4a000804, 0x530601ad, 0x0e004a13,   // nl.eu.un_540 no.yo.un_320  en.de.ht_643 yo.is.un_650
  0x0c000104, 0x1c1e1a07, 0x2000131a, 0x255321ad,   // en.sv.un_320 tl.ms.id_432  et.sq.un_760 jw.ht.eu_643
  0x08201ba4, 0x2b27180e, 0x522753ec, 0x52122ba9,   // tr.sq.no_433 ga.gd.vi_555  ht.gd.ha_644 vi.hu.ha_544
  // [3e90]
  0x07045205, 0x2a1e1c12, 0x0000161c, 0x13042aec,   // ha.fi.it_333 id.ms.mt_654  hr.un.un_800 mt.fi.et_644
  0x2706250c, 0x1300520c, 0x1c0f1fa9, 0x640452ad,   // eu.de.gd_543 ha.et.un_530  cy.lv.id_544 ha.fi.lg_643
  0x09130d0d, 0x6b073b07, 0x25002d13, 0x532552af,   // ne.bh.hi_554 so.it.ceb_432  sk.eu.un_650 ha.eu.ht_655
  0x4a1a52ec, 0x0c000309, 0x022d17a4, 0x521f4aaf,   // ha.tl.yo_644 nl.sv.un_440  sr.sk.da_433 yo.cy.ha_655
  // [3ea0]
  0x2d04290b, 0x29205504, 0x0e060305, 0x1627010c,   // sl.fi.sk_542 rw.sq.sl_332  nl.de.is_333 en.gd.hr_543
  0x123f0360, 0x52531e04, 0x042012a7, 0x0b1a6bee,   // nl.af.hu_664 ms.ht.ha_332  hu.sq.fi_532 ceb.tl.es_422
  0x1b000619, 0x0e4a12b6, 0x3f1b1e14, 0x1b001a14,   // de.tr.un_750 hu.yo.is_766  ms.tr.af_666 tl.tr.un_660
  0x130c0255, 0x31201b0c, 0x130f010c, 0x32292dee,   // da.sv.et_442 tr.sq.az_543  en.lv.et_543 sk.sl.bs_422
  // [3eb0]
  0x321707a4, 0x0a00170d, 0x6e3b060c, 0x6b0c0455,   // it.sr.bs_433 sr.mk.un_540  de.so.hmn_543 fi.sv.ceb_442
  0x6e001c0d, 0x10171104, 0x1c002904, 0x55000a12,   // id.hmn.un_540 ro.sr.be_332  sl.id.un_320 pt.rw.un_640
  0x320d2955, 0x130208a4, 0x02100609, 0x2a006b19,   // sl.cs.bs_442 no.da.et_433  de.lt.da_444 ceb.mt.un_750
  0x520f06af, 0x1c002508, 0x6400350c, 0x130e0caf,   // de.lv.ha_655 eu.id.un_430  zu.lg.un_530 sv.is.et_655
  // [3ec0]
  0x20230509, 0x1e006e05, 0x203f10a0, 0x01006808,   // fr.ca.sq_444 hmn.ms.un_330  lt.af.sq_322 ig.en.un_430
  0x0e271860, 0x2a091b07, 0x161e6ea7, 0x23130960,   // ga.gd.is_664 tr.pl.mt_432  hmn.ms.hr_532 pl.et.ca_664
  0x0c136ea7, 0x27185305, 0x020c1fa4, 0x6e011107,   // hmn.et.sv_532 ht.ga.gd_333  cy.sv.da_433 ro.en.hmn_432
  0x0c0e53ad, 0x060e180c, 0x23001021, 0x53050eaf,   // ht.is.sv_643 ga.is.de_543  lt.ca.un_860 is.fr.ht_655
  // [3ed0]
  0x351c1ead, 0x0f1f130c, 0x271853af, 0x01522802,   // ms.id.zu_643 et.cy.lv_543  ht.ga.gd_655 sw.ha.en_222
  0x03643fa4, 0x08090e07, 0x271f0e0c, 0x18290111,   // af.lg.nl_433 is.pl.no_432  is.cy.gd_543 en.sl.ga_653
  0x0d1c090d, 0x3f2903a4, 0x182708a4, 0x1e1c35a4,   // hi.mr.ne_554 nl.sl.af_433  no.gd.ga_433 zu.id.ms_433
  0x18030605, 0x080e6b02, 0x0e27250c, 0x080c53af,   // de.nl.ga_333 ceb.is.no_222  eu.gd.is_543 ht.sv.no_655
  // [3ee0]
  0x122164a0, 0x53000612, 0x320e17a9, 0x180e53a4,   // lg.jw.hu_322 de.ht.un_640  sr.is.bs_544 ht.is.ga_433
  0x4a086ba9, 0x182753ec, 0x0818530b, 0x29002121,   // ceb.no.yo_544 ht.gd.ga_644  ht.ga.no_542 jw.sl.un_860
  0x024a6bee, 0x03003504, 0x083f0308, 0x6b213512,   // ceb.yo.da_422 zu.nl.un_320  nl.af.no_443 zu.jw.ceb_654
  0x52030607, 0x1318060c, 0x074a2107, 0x09005502,   // de.nl.ha_432 de.ga.et_543  jw.yo.it_432 rw.pl.un_220
  // [3ef0]
  0x12060a13, 0x213555a4, 0x3b1e2104, 0x070b0a05,   // pt.de.hu_665 rw.zu.jw_433  jw.ms.so_332 pt.es.it_333
  0x522d5508, 0x0420080c, 0x35070b07, 0x3b190bad,   // rw.sk.ha_443 no.sq.fi_543  es.it.zu_432 es.gl.so_643
  0x55641b55, 0x10005307, 0x060e1ca0, 0x1b201312,   // tr.lg.rw_442 ht.lt.un_420  id.is.de_322 et.sq.tr_654
  0x0f001907, 0x286452a4, 0x131a6b12, 0x0e001f18,   // gl.lv.un_420 ha.lg.sw_433  ceb.tl.et_654 cy.is.un_740
  // [3f00]
  0x11532aec, 0x29002105, 0x06291eee, 0x0b0a1ea0,   // mt.ht.ro_644 jw.sl.un_330  ms.sl.de_422 ms.pt.es_322
  0x21291711, 0x083b2a55, 0x1a6b210c, 0x0100180e,   // sr.sl.jw_653 mt.so.no_442  jw.ceb.tl_543 ga.en.un_550
  0x55062805, 0x64006b19, 0x2d0d21ec, 0x21281fa4,   // sw.de.rw_333 ceb.lg.un_750  jw.cs.sk_644 cy.sw.jw_433
  0x64520909, 0x212d0d13, 0x1c005221, 0x5500170e,   // pl.ha.lg_444 cs.sk.jw_665  ha.id.un_860 sr.rw.un_550
  // [3f10]
  0x1f030e55, 0x20000e0d, 0x1e211ca4, 0x10211ca4,   // is.nl.cy_442 is.sq.un_540  id.jw.ms_433 id.jw.lt_433
  0x2135520c, 0x32160eee, 0x0d2d2110, 0x1e1c2104,   // ha.zu.jw_543 is.hr.bs_422  jw.sk.cs_642 jw.id.ms_332
  0x033f04ec, 0x32000702, 0x2d003f13, 0x550719a6,   // fi.af.nl_644 it.bs.un_220  af.sk.un_650 gl.it.rw_521
  0x171304ec, 0x0a000304, 0x55005304, 0x2a0405ee,   // fi.et.sr_644 nl.pt.un_320  ht.rw.un_320 fr.fi.mt_422
  // [3f20]
  0x0d2d2111, 0x11001705, 0x2d002119, 0x071a0caf,   // jw.sk.cs_653 sr.ro.un_330  jw.sk.un_750 sv.tl.it_655
  0x03000707, 0x211b0b12, 0x1e111b07, 0x25186808,   // it.nl.un_420 es.tr.jw_654  tr.ro.ms_432 ig.ga.eu_443
  0x6e001e12, 0x083b0e04, 0x3b001323, 0x35000f07,   // ms.hmn.un_640 is.so.no_332  et.so.un_880 lv.zu.un_420
  0x270e1808, 0x09006409, 0x283f35ad, 0x091b53ad,   // ga.is.gd_443 lg.pl.un_440  zu.af.sw_643 ht.tr.pl_643
  // [3f30]
  0x31001118, 0x211f135a, 0x0321080b, 0x53000a21,   // ro.az.un_740 et.cy.jw_553  no.jw.nl_542 pt.ht.un_860
  0x18122d60, 0x1a284aa6, 0x311b0aac, 0x2a001f09,   // sk.hu.ga_664 yo.sw.tl_521  pt.tr.az_632 cy.mt.un_440
  0x110c03ec, 0x1a281012, 0x64001f1b, 0x2d0d4aee,   // nl.sv.ro_644 lt.sw.tl_654  cy.lg.un_770 yo.cs.sk_422
  0x2a000104, 0x013b2d0b, 0x0a062512, 0x52003202,   // en.mt.un_320 sk.so.en_542  eu.de.pt_654 bs.ha.un_220
  // [3f40]
  0x133f06a4, 0x31121b11, 0x231127a0, 0x094a6404,   // de.af.et_433 tr.hu.az_653  gd.ro.ca_322 lg.yo.pl_332
  0x120a01af, 0x3b000223, 0x0d3f01a4, 0x68000104,   // en.pt.hu_655 da.so.un_880  en.af.cs_433 en.ig.un_320
  0x061b13ec, 0x215352ee, 0x6b1a5505, 0x04000e20,   // et.tr.de_644 ha.ht.jw_422  rw.tl.ceb_333 is.fi.un_850
  0x28680313, 0x0e0c1fad, 0x0b1123ee, 0x53022507,   // nl.ig.sw_665 cy.sv.is_643  ca.ro.es_422 eu.da.ht_432
  // [3f50]
  0x1f002911, 0x21121c11, 0x09003b12, 0x1029040b,   // sl.cy.un_630 id.hu.jw_653  so.pl.un_640 fi.sl.lt_542
  0x2d3528a0, 0x0b00010c, 0x10000812, 0x311a3507,   // sw.zu.sk_322 en.es.un_530  uk.be.un_640 zu.tl.az_432
  0x012911a4, 0x642a3512, 0x6435210d, 0x083b0caf,   // ro.sl.en_433 zu.mt.lg_654  jw.zu.lg_554 sv.so.no_655
  0x081f310c, 0x1f000408, 0x20006407, 0x322d10a0,   // az.cy.no_543 fi.cy.un_430  lg.sq.un_420 lt.sk.bs_322
  // [3f60]
  0x28003521, 0x083f0313, 0x19200b5a, 0x2d001e0c,   // zu.sw.un_860 nl.af.no_665  es.sq.gl_553 ms.sk.un_530
  0x31182712, 0x081c0e08, 0x4a18270c, 0x554a6408,   // gd.ga.az_654 is.id.no_443  gd.ga.yo_543 lg.yo.rw_443
  0x0c1c530c, 0x3f1e64a9, 0x0802190c, 0x2d0d1614,   // ht.id.sv_543 lg.ms.af_544  gl.da.no_543 hr.cs.sk_666
  0x1304280c, 0x2864350c, 0x1c0464a6, 0x20310fad,   // sw.fi.et_543 zu.lg.sw_543  lg.fi.id_521 lv.az.sq_643
  // [3f70]
  0x13000617, 0x552a530c, 0x1e001308, 0x52006e07,   // de.et.un_730 ht.mt.rw_543  et.ms.un_430 hmn.ha.un_420
  0x160b1104, 0x351e64a9, 0x0c2916a4, 0x64001304,   // ro.es.hr_332 lg.ms.zu_544  hr.sl.sv_433 et.lg.un_320
  0x521a250c, 0x0c232008, 0x040e0c12, 0x2d320aa0,   // eu.tl.ha_543 sq.ca.sv_443  sv.is.fi_654 pt.bs.sk_322
  0x166e1707, 0x12001829, 0x29211c08, 0x0b0a2daf,   // sr.hmn.hr_432 ar.ur.un_960  id.jw.sl_443 sk.pt.es_655
  // [3f80]
  0x18271112, 0x0b2507a0, 0x020c08a0, 0x3f2125ac,   // ro.gd.ga_654 it.eu.es_322  no.sv.da_322 eu.jw.af_632
  0x0b2d0a07, 0x316428a6, 0x07235205, 0x2d0d4aa4,   // pt.sk.es_432 sw.lg.az_521  ha.ca.it_333 yo.cs.sk_433
  0x29000c04, 0x31272a08, 0x1f29010c, 0x05080205,   // sv.sl.un_320 mt.gd.az_443  en.sl.cy_543 da.no.fr_333
  0x1e1c1aee, 0x3f0f0da4, 0x01072a11, 0x190a11a0,   // tl.id.ms_422 cs.lv.af_433  mt.it.en_653 ro.pt.gl_322
  // [3f90]
  0x2810110d, 0x3f00110c, 0x312029a0, 0x13000209,   // ro.lt.sw_554 ro.af.un_530  sl.sq.az_322 da.et.un_440
  0x522a6808, 0x4a122d07, 0x32162a09, 0x273b06a4,   // ig.mt.ha_443 sk.hu.yo_432  mt.hr.bs_444 de.so.gd_433
  0x4a523b5a, 0x6b006e0c, 0x23003b11, 0x250411af,   // so.ha.yo_553 hmn.ceb.un_530  so.ca.un_630 ro.fi.eu_655
  0x556453a4, 0x12131bee, 0x4a6421a0, 0x3b252a0c,   // ht.lg.rw_433 tr.et.hu_422  jw.lg.yo_322 mt.eu.so_543
  // [3fa0]
  0x05000f36, 0x0910250c, 0x32162d0c, 0x19280ba7,   // lv.fr.un_AA0 eu.lt.pl_543  sk.hr.bs_543 es.sw.gl_532
  0x0c0e0812, 0x0d0a0b60, 0x0e3f030c, 0x10252da4,   // no.is.sv_654 es.pt.cs_664  nl.af.is_543 sk.eu.lt_433
  0x12090111, 0x68132514, 0x0425640c, 0x68006b13,   // en.pl.hu_653 eu.et.ig_666  lg.eu.fi_543 ceb.ig.un_650
  0x536b1107, 0x2a1f01ec, 0x20002507, 0x2d0d0eee,   // ro.ceb.ht_432 en.cy.mt_644  eu.sq.un_420 is.cs.sk_422
  // [3fb0]
  0x1f006404, 0x1f000112, 0x20092509, 0x5513255a,   // lg.cy.un_320 en.cy.un_640  eu.pl.sq_444 eu.et.rw_553
  0x532a6404, 0x6b00680d, 0x010511af, 0x194a0ba0,   // lg.mt.ht_332 ig.ceb.un_540  ro.fr.en_655 es.yo.gl_322
  0x202910a9, 0x0c0625af, 0x1e1c0e0e, 0x251355a4,   // lt.sl.sq_544 eu.de.sv_655  is.id.ms_555 rw.et.eu_433
  0x10252a0d, 0x0e002d18, 0x1c3b210c, 0x2a002509,   // mt.eu.lt_554 sk.is.un_740  jw.so.id_543 eu.mt.un_440
  // [3fc0]
  0x2a020812, 0x20040607, 0x31190a0c, 0x092a0711,   // no.da.mt_654 de.fi.sq_432  pt.gl.az_543 it.mt.pl_653
  0x080c23a7, 0x02040804, 0x2b002313, 0x53002a02,   // ca.sv.no_532 no.fi.da_332  ca.vi.un_650 mt.ht.un_220
  0x1b080214, 0x3f031304, 0x1300350e, 0x12060c02,   // da.no.tr_666 et.nl.af_332  zu.et.un_550 sv.de.hu_222
  0x0c0801a4, 0x250c2aec, 0x270511ad, 0x010a1f0c,   // en.no.sv_433 mt.sv.eu_644  ro.fr.gd_643 cy.pt.en_543
  // [3fd0]
  0x2a00250d, 0x07534aa7, 0x05006b02, 0x10000c08,   // eu.mt.un_540 yo.ht.it_532  ceb.fr.un_220 sv.lt.un_430
  0x030802ec, 0x5300060c, 0x03080213, 0x10002d08,   // da.no.nl_644 de.ht.un_530  da.no.nl_665 sk.lt.un_430
  0x3b002322, 0x4a000e19, 0x08026e14, 0x64206805,   // ca.so.un_870 is.yo.un_750  hmn.da.no_666 ig.sq.lg_333
  0x3b2a18a4, 0x02311bad, 0x05003f02, 0x136416a4,   // ga.mt.so_433 tr.az.da_643  af.fr.un_220 hr.lg.et_433
  // [3fe0]
  0x64001312, 0x21033b0c, 0x020408ee, 0x1e1a1ca0,   // et.lg.un_640 so.nl.jw_543  no.fi.da_422 id.tl.ms_322
  0x08022a05, 0x18002d0d, 0x2a0d1e0b, 0x1008170c,   // mt.da.no_333 sk.ga.un_540  ms.cs.mt_542 sr.uk.be_543
  0x3b52250c, 0x07001f1a, 0x120420a4, 0x01080260,   // eu.ha.so_543 cy.it.un_760  sq.fi.hu_433 da.no.en_664
  0x18272313, 0x04102304, 0x02080c07, 0x326e10a4,   // ca.gd.ga_665 ca.lt.fi_332  sv.no.da_432 lt.hmn.bs_433
  // [3ff0]
  0x53106e08, 0x040a100c, 0x080203ec, 0x07256ea7,   // hmn.lt.ht_443 be.mk.ru_543  nl.da.no_644 hmn.eu.it_532
  0x06000207, 0x2b006e04, 0x0d131c04, 0x3f0c080c,   // da.de.un_420 hmn.vi.un_320  mr.bh.ne_332 no.sv.af_543
  0x100a11ee, 0x293f53ee, 0x1c090d07, 0x08000302,   // ro.mk.be_422 ht.af.sl_422  ne.hi.mr_432 nl.no.un_220
  0x1b211ea4, 0x20001804, 0x6b1f0507, 0x0a2120a7,   // ms.jw.tr_433 ga.sq.un_320  fr.cy.ceb_432 sq.jw.pt_532

  // [4000]
  0x3b001a04, 0x21531c07, 0x0a291a09, 0x0e000f1b,   // tl.so.un_320 id.ht.jw_432  tl.sl.pt_444 lv.is.un_770
  0x3b1a55a0, 0x641a55ad, 0x0b23180e, 0x321b2055,   // rw.tl.so_322 rw.tl.lg_643  ga.ca.es_555 sq.tr.bs_442
  0x6b2a18a4, 0x0f091014, 0x0a190bad, 0x6b1935ee,   // ga.mt.ceb_433 lt.pl.lv_666  es.gl.pt_643 zu.gl.ceb_422
  0x21230b09, 0x521e3b0c, 0x18002812, 0x352864af,   // es.ca.jw_444 so.ms.ha_543  sw.ga.un_640 lg.sw.zu_655
  // [4010]
  0x020608a0, 0x12000505, 0x19250b0c, 0x13000411,   // no.de.da_322 fr.hu.un_330  es.eu.gl_543 fi.et.un_630
  0x32171ea4, 0x100a0408, 0x23180ba0, 0x290c090c,   // ms.sr.bs_433 ru.mk.be_443  es.ga.ca_322 pl.sv.sl_543
  0x230b0ea4, 0x080a040c, 0x273b250c, 0x1000190e,   // is.es.ca_433 ru.mk.uk_543  eu.so.gd_543 gl.lt.un_550
  0x3f030807, 0x55003108, 0x28072d08, 0x290207ee,   // no.nl.af_432 az.rw.un_430  sk.it.sw_443 it.da.sl_422
  // [4020]
  0x190b4a0e, 0x07063b07, 0x53001e04, 0x31523ba4,   // yo.es.gl_555 so.de.it_432  ms.ht.un_320 so.ha.az_433
  0x3f3b01a9, 0x0c0803ec, 0x3b271f12, 0x31035512,   // en.so.af_544 nl.no.sv_644  cy.gd.so_654 rw.nl.az_654
  0x192d0d5a, 0x2a3b2112, 0x03061f07, 0x190b0a13,   // cs.sk.gl_553 jw.so.mt_654  cy.de.nl_432 pt.es.gl_665
  0x29002d18, 0x3b042813, 0x1300110e, 0x066407a4,   // sk.sl.un_740 sw.fi.so_665  ro.et.un_550 it.lg.de_433
  // [4030]
  0x64072aec, 0x23060407, 0x286b1a60, 0x05004a0d,   // mt.it.lg_644 fi.de.ca_432  tl.ceb.sw_664 yo.fr.un_540
  0x19252aa4, 0x03122755, 0x2135640c, 0x1f3525a9,   // mt.eu.gl_433 gd.hu.nl_442  lg.zu.jw_543 eu.zu.cy_544
  0x2012070c, 0x29161904, 0x230a0707, 0x01001907,   // it.hu.sq_543 gl.hr.sl_332  it.pt.ca_432 gl.en.un_420
  0x03001c04, 0x23012aa4, 0x11001f0c, 0x13040555,   // id.nl.un_320 mt.en.ca_433  cy.ro.un_530 fr.fi.et_442
  // [4040]
  0x25001a07, 0x3f08040c, 0x0500120d, 0x05110708,   // tl.eu.un_420 fi.no.af_543  hu.fr.un_540 it.ro.fr_443
  0x1f1a5212, 0x27002b13, 0x53004a34, 0x01060708,   // ha.tl.cy_654 vi.gd.un_650  yo.ht.un_A80 it.de.en_443
  0x2b534aad, 0x21203bad, 0x1a685307, 0x1e1c3ba9,   // yo.ht.vi_643 so.sq.jw_643  ht.ig.tl_432 so.id.ms_544
  0x23281fac, 0x2b4a5360, 0x1a356407, 0x051a6ba9,   // cy.sw.ca_632 ht.yo.vi_664  lg.zu.tl_432 ceb.tl.fr_544
  // [4050]
  0x2b002719, 0x53004a22, 0x1a2009a4, 0x175535a4,   // gd.vi.un_750 yo.ht.un_870  pl.sq.tl_433 zu.rw.sr_433
  0x1013040c, 0x07110a55, 0x206b1c07, 0x12002309,   // fi.et.lt_543 mk.ro.bg_442  id.ceb.sq_432 ca.hu.un_440
  0x2119120c, 0x53004a20, 0x07004a29, 0x121b0908,   // hu.gl.jw_543 yo.ht.un_850  yo.it.un_960 pl.tr.hu_443
  0x64001b14, 0x3f03210c, 0x28001604, 0x21171aa4,   // tr.lg.un_660 jw.nl.af_543  hr.sw.un_320 tl.sr.jw_433
  // [4060]
  0x0b0a1a02, 0x03023f02, 0x2900281a, 0x210620a0,   // tl.pt.es_222 af.da.nl_222  sw.sl.un_760 sq.de.jw_322
  0x10641aa4, 0x231b1108, 0x2d002819, 0x284a5212,   // tl.lg.lt_433 ro.tr.ca_443  sw.sk.un_750 ha.yo.sw_654
  0x1c1e280c, 0x29352811, 0x17005204, 0x2953280c,   // sw.ms.id_543 sw.zu.sl_653  ha.sr.un_320 sw.ht.sl_543
  0x190b64a0, 0x0b0a230e, 0x04005314, 0x0a230b0b,   // lg.es.gl_322 ca.pt.es_555  ht.fi.un_660 es.ca.pt_542
  // [4070]
  0x4a52280c, 0x35645304, 0x0e551b08, 0x091c13a0,   // sw.ha.yo_543 ht.lg.zu_332  tr.rw.is_443 bh.mr.hi_322
  0x285568a0, 0x05520aee, 0x08002121, 0x1e2d6411,   // ig.rw.sw_322 pt.ha.fr_422  jw.no.un_860 lg.sk.ms_653
  0x1b3b6412, 0x2800100d, 0x10086b55, 0x07022da0,   // lg.so.tr_654 lt.sw.un_540  ceb.no.lt_442 sk.da.it_322
  0x28005213, 0x0a190b60, 0x0c001f0c, 0x03006418,   // ha.sw.un_650 es.gl.pt_664  cy.sv.un_530 lg.nl.un_740
  // [4080]
  0x0a173507, 0x1e1c5205, 0x1e006e0c, 0x101e1c0e,   // zu.sr.pt_432 ha.id.ms_333  hmn.ms.un_530 id.ms.lt_555
  0x29000b02, 0x286e6812, 0x2a070aa4, 0x6400521b,   // es.sl.un_220 ig.hmn.sw_654  pt.it.mt_433 ha.lg.un_770
  0x2d001307, 0x2100190c, 0x1c251e60, 0x041e1c14,   // et.sk.un_420 gl.jw.un_530  ms.eu.id_664 id.ms.fi_666
  0x53002016, 0x136b0412, 0x203f040d, 0x2a3b29a9,   // sq.ht.un_720 fi.ceb.et_654  fi.af.sq_554 sl.so.mt_544
  // [4090]
  0x3f003b0c, 0x4a030c0b, 0x05002104, 0x090c13a4,   // so.af.un_530 sv.nl.yo_542  jw.fr.un_320 et.sv.pl_433
  0x0f00092b, 0x283b2514, 0x1e1b0e08, 0x0f00520c,   // pl.lv.un_980 eu.so.sw_666  is.tr.ms_443 ha.lv.un_530
  0x12200812, 0x1a6452af, 0x200812a9, 0x05201eaf,   // no.sq.hu_654 ha.lg.tl_655  hu.no.sq_544 ms.sq.fr_655
  0x6455520b, 0x6b1b35a9, 0x201b05a4, 0x643555ad,   // ha.rw.lg_542 zu.tr.ceb_544  fr.tr.sq_433 rw.zu.lg_643
  // [40a0]
  0x115228a9, 0x1311040e, 0x522102a9, 0x19005204,   // sw.ha.ro_544 fi.ro.et_555  da.jw.ha_544 ha.gl.un_320
  0x55213509, 0x64121aad, 0x355228a9, 0x190807a4,   // zu.jw.rw_444 tl.hu.lg_643  sw.ha.zu_544 it.no.gl_433
  0x05110d05, 0x55042a0c, 0x2d0d02ee, 0x230b0a14,   // cs.ro.fr_333 mt.fi.rw_543  da.cs.sk_422 pt.es.ca_666
  0x235564a9, 0x2003120c, 0x2b121b0c, 0x354a52ad,   // lg.rw.ca_544 hu.nl.sq_543  tr.hu.vi_543 ha.yo.zu_643
  // [40b0]
  0x12000e2a, 0x09041805, 0x21001119, 0x1a356413,   // is.hu.un_970 ga.fi.pl_333  ro.jw.un_750 lg.zu.tl_665
  0x3f21090c, 0x1821270c, 0x030502ee, 0x200802a9,   // pl.jw.af_543 gd.jw.ga_543  da.fr.nl_422 da.no.sq_544
  0x1017070c, 0x31001c02, 0x642a0712, 0x1c21520c,   // bg.sr.be_543 id.az.un_220  it.mt.lg_654 ha.jw.id_543
  0x25072a0c, 0x01271802, 0x07321709, 0x2a2507af,   // mt.it.eu_543 ga.gd.en_222  sr.bs.it_444 it.eu.mt_655
  // [40c0]
  0x356b28a4, 0x28551209, 0x6b1f1a09, 0x0f1352a0,   // sw.ceb.zu_433 hu.rw.sw_444  tl.cy.ceb_444 ha.et.lv_322
  0x211629a9, 0x06003b0d, 0x21001e22, 0x10001221,   // sl.hr.jw_544 so.de.un_540  ms.jw.un_870 hu.lt.un_860
  0x0a1c1eec, 0x3f002722, 0x211c04a4, 0x1e3b10a4,   // ms.id.pt_644 gd.af.un_870  fi.id.jw_433 lt.so.ms_433
  0x044a1ca4, 0x1b190b13, 0x101b3508, 0x0e004a21,   // id.yo.fi_433 es.gl.tr_665  zu.tr.lt_443 yo.is.un_860
  // [40d0]
  0x351b1ca4, 0x02000312, 0x4a000e29, 0x171e1c5a,   // id.tr.zu_433 nl.da.un_640  is.yo.un_960 id.ms.sr_553
  0x12001702, 0x32161ca9, 0x171b290c, 0x0e2b4a11,   // sr.hu.un_220 id.hr.bs_544  sl.tr.sr_543 yo.vi.is_653
  0x11030a07, 0x0a001105, 0x101303a9, 0x09033f0d,   // pt.nl.ro_432 ro.mk.un_330  nl.et.lt_544 af.nl.pl_554
  0x28521aa9, 0x2d090dee, 0x3f080ea4, 0x0e03080c,   // tl.ha.sw_544 cs.pl.sk_422  is.no.af_433 no.nl.is_543
  // [40e0]
  0x1b52120c, 0x3b0f25a9, 0x35101ba4, 0x0f0b04ee,   // hu.ha.tr_543 eu.lv.so_544  tr.lt.zu_433 fi.es.lv_422
  0x28351b07, 0x4a0e2dec, 0x31002904, 0x0b4a18ac,   // tr.zu.sw_432 sk.is.yo_644  sl.az.un_320 ga.yo.es_632
  0x0e08135a, 0x3b13290c, 0x1a0f2a0d, 0x13351aad,   // et.no.is_553 sl.et.so_543  mt.lv.tl_554 tl.zu.et_643
  0x13356b02, 0x1b281ea4, 0x1b002713, 0x55001f0c,   // ceb.zu.et_222 ms.sw.tr_433  gd.tr.un_650 cy.rw.un_530
  // [40f0]
  0x1807010c, 0x25033fa9, 0x090d1307, 0x350e2511,   // en.it.ga_543 af.nl.eu_544  bh.ne.hi_432 eu.is.zu_653
  0x31003f0d, 0x042511a4, 0x686404a4, 0x19052305,   // af.az.un_540 ro.eu.fi_433  fi.lg.ig_433 ca.fr.gl_333
  0x080a17a6, 0x27033f08, 0x01192102, 0x0b3568a9,   // sr.mk.uk_521 af.nl.gd_443  jw.gl.en_222 ig.zu.es_544
  0x04006419, 0x04642108, 0x68216414, 0x080e25a4,   // lg.fi.un_750 jw.lg.fi_443  lg.jw.ig_666 eu.is.no_433
  // [4100]
  0x55000804, 0x10250707, 0x29000f1b, 0x053f015a,   // no.rw.un_320 it.eu.lt_432  lv.sl.un_770 en.af.fr_553
  0x0f6b11af, 0x23000511, 0x3135200b, 0x556435ee,   // ro.ceb.lv_655 fr.ca.un_630  sq.zu.az_542 zu.lg.rw_422
  0x0a110808, 0x190a21a0, 0x040d3b0c, 0x111a04ee,   // uk.ro.mk_443 jw.pt.gl_322  so.cs.fi_543 fi.tl.ro_422
  0x3f033b0c, 0x2d006402, 0x0a015502, 0x0e122307,   // so.nl.af_543 lg.sk.un_220  rw.en.pt_222 ca.hu.is_432
  // [4110]
  0x03203505, 0x032a0412, 0x19050ba4, 0x6b0468a4,   // zu.sq.nl_333 fi.mt.nl_654  es.fr.gl_433 ig.fi.ceb_433
  0x206b1aa4, 0x281e3207, 0x080220a9, 0x100f13ad,   // tl.ceb.sq_433 bs.ms.sw_432  sq.da.no_544 et.lv.lt_643
  0x0c020e0c, 0x042d0da9, 0x1e1c0ca4, 0x02090808,   // is.da.sv_543 cs.sk.fi_544  sv.id.ms_433 no.pl.da_443
  0x0c3f180c, 0x0e1f0c12, 0x3b181ba0, 0x0c6b2305,   // ga.af.sv_543 sv.cy.is_654  tr.ga.so_322 ca.ceb.sv_333
  // [4120]
  0x041a13a4, 0x043f1308, 0x13001a21, 0x120413af,   // et.tl.fi_433 et.af.fi_443  tl.et.un_860 et.fi.hu_655
  0x04134aa0, 0x1a001e02, 0x1c212708, 0x3b0108a7,   // yo.et.fi_322 ms.tl.un_220  gd.jw.id_443 no.en.so_532
  0x031f1b0c, 0x0e0803ec, 0x112a2313, 0x1b531f0c,   // tr.cy.nl_543 nl.no.is_644  ca.mt.ro_665 cy.ht.tr_543
  0x642035a4, 0x0800030c, 0x252820af, 0x112706ee,   // zu.sq.lg_433 nl.no.un_530  sq.sw.eu_655 de.gd.ro_422
  // [4130]
  0x1c0913a6, 0x3f2a1fa4, 0x3f3b6404, 0x2555355a,   // bh.hi.mr_521 cy.mt.af_433  lg.so.af_332 zu.rw.eu_553
  0x552868a4, 0x68281b09, 0x20356402, 0x0f64280d,   // ig.sw.rw_433 tr.sw.ig_444  lg.zu.sq_222 sw.lg.lv_554
  0x1e646808, 0x1e07280c, 0x04131114, 0x1f170608,   // ig.lg.ms_443 sw.it.ms_543  ro.et.fi_666 de.sr.cy_443
  0x072531a9, 0x0b1905a9, 0x35255508, 0x11313205,   // az.eu.it_544 fr.gl.es_544  rw.eu.zu_443 bs.az.ro_333
  // [4140]
  0x060a31a4, 0x286455a4, 0x280a5307, 0x20171ba4,   // az.pt.de_433 rw.lg.sw_433  ht.pt.sw_432 tr.sr.sq_433
  0x10000e05, 0x090306a0, 0x1b002807, 0x11291e09,   // is.lt.un_330 de.nl.pl_322  sw.tr.un_420 ms.sl.ro_444
  0x53003523, 0x53202aa9, 0x194a010c, 0x20552508,   // zu.ht.un_880 mt.sq.ht_544  en.yo.gl_543 eu.rw.sq_443
  0x35310f0c, 0x10070f0c, 0x52061c0c, 0x250f0611,   // lv.az.zu_543 lv.it.lt_543  id.de.ha_543 de.lv.eu_653
  // [4150]
  0x64033fa4, 0x11073155, 0x0d0906a0, 0x0d120607,   // af.nl.lg_433 az.it.ro_442  de.pl.cs_322 de.hu.cs_432
  0x1b005308, 0x1b02080c, 0x0a250705, 0x092d06a7,   // ht.tr.un_430 no.da.tr_543  it.eu.pt_333 de.sk.pl_532
  0x1711080c, 0x06003209, 0x20062aac, 0x27000612,   // uk.ro.sr_543 bs.de.un_440  mt.de.sq_632 de.gd.un_640
  0x2b001a12, 0x016b0207, 0x2b6b31a0, 0x010e64a4,   // tl.vi.un_640 da.ceb.en_432  az.ceb.vi_322 lg.is.en_433
  // [4160]
  0x31001704, 0x0d000612, 0x0e030613, 0x3b526404,   // sr.az.un_320 de.cs.un_640  de.nl.is_665 lg.ha.so_332
  0x122d10a4, 0x06000e0e, 0x643f1ba0, 0x1b3b3113,   // lt.sk.hu_433 is.de.un_550  tr.af.lg_322 az.so.tr_665
  0x11000807, 0x682135a9, 0x17000820, 0x01073104,   // no.ro.un_420 zu.jw.ig_544  uk.sr.un_850 az.it.en_332
  0x27186408, 0x0100531b, 0x2a060460, 0x0f102daf,   // lg.ga.gd_443 ht.en.un_770  fi.de.mt_664 sk.lt.lv_655
  // [4170]
  0x35531105, 0x0900030c, 0x092a2504, 0x68006e21,   // ro.ht.zu_333 nl.pl.un_530  eu.mt.pl_332 hmn.ig.un_860
  0x06003f1b, 0x162901a0, 0x5313045a, 0x070f1009,   // af.de.un_770 en.sl.hr_322  fi.et.ht_553 lt.lv.it_444
  0x06030e0c, 0x013528a0, 0x060f0c13, 0x2a2307a4,   // is.nl.de_543 sw.zu.en_322  sv.lv.de_665 it.ca.mt_433
  0x20000719, 0x3b251a05, 0x033f0fa4, 0x0b072d0c,   // it.sq.un_750 tl.eu.so_333  lv.af.nl_433 sk.it.es_543
  // [4180]
  0x102a0f0c, 0x2b100f0d, 0x04002d1a, 0x11006b04,   // lv.mt.lt_543 lv.lt.vi_554  sk.fi.un_760 ceb.ro.un_320
  0x17000a07, 0x641e350c, 0x0500210d, 0x0e001313,   // mk.sr.un_420 zu.ms.lg_543  jw.fr.un_540 et.is.un_650
  0x23555208, 0x07252aa9, 0x1c281ea4, 0x28002d04,   // ha.rw.ca_443 mt.eu.it_544  ms.sw.id_433 sk.sw.un_320
  0x1e00070c, 0x21534a08, 0x1b1c210d, 0x21101a5a,   // it.ms.un_530 yo.ht.jw_443  jw.id.tr_554 tl.lt.jw_553
  // [4190]
  0x311035a0, 0x0f000312, 0x21351ca7, 0x1a004a12,   // zu.lt.az_322 nl.lv.un_640  id.zu.jw_532 yo.tl.un_640
  0x191007a0, 0x3b25550c, 0x11522812, 0x0a1011a0,   // it.lt.gl_322 rw.eu.so_543  sw.ha.ro_654 ro.be.mk_322
  0x5500110e, 0x21071e0c, 0x07001719, 0x21006805,   // ro.rw.un_550 ms.it.jw_543  sr.bg.un_750 ig.jw.un_330
  0x3b520ea9, 0x0d292d0c, 0x23111c07, 0x13091c0c,   // is.ha.so_544 sk.sl.cs_543  id.ro.ca_432 mr.hi.bh_543
  // [41a0]
  0x18001019, 0x0700291a, 0x55522da7, 0x25521114,   // lt.ga.un_750 sl.it.un_760  sk.ha.rw_532 ro.ha.eu_666
  0x01063fa0, 0x1c0927a0, 0x23201108, 0x25231109,   // af.de.en_322 gd.pl.id_322  ro.sq.ca_443 ro.ca.eu_444
  0x1a001e04, 0x21251a11, 0x2b1f6bac, 0x312a3bee,   // ms.tl.un_320 tl.eu.jw_653  ceb.cy.vi_632 so.mt.az_422
  0x1c1b1e07, 0x04100805, 0x311b1ea9, 0x1200100d,   // ms.tr.id_432 uk.be.ru_333  ms.tr.az_544 lt.hu.un_540
  // [41b0]
  0x200727ad, 0x25105504, 0x0e183f07, 0x07112daf,   // gd.it.sq_643 rw.lt.eu_332  af.ga.is_432 sk.ro.it_655
  0x11002312, 0x1a536b13, 0x036e53ee, 0x190b230b,   // ca.ro.un_640 ceb.ht.tl_665  ht.hmn.nl_422 ca.es.gl_542
  0x13112312, 0x0e6b3fee, 0x090d20ad, 0x2a002514,   // ca.ro.et_654 af.ceb.is_422  sq.cs.pl_643 eu.mt.un_660
  0x28006b18, 0x0e04105a, 0x10000e07, 0x0b192355,   // ceb.sw.un_740 lt.fi.is_553  is.lt.un_420 ca.gl.es_442
  // [41c0]
  0x3b0506ad, 0x040652a9, 0x060e3fa9, 0x3f002b1b,   // de.fr.so_643 ha.de.fi_544  af.is.de_544 vi.af.un_770
  0x64125204, 0x10040faf, 0x1c0d0902, 0x216e1ea7,   // ha.hu.lg_332 lv.fi.lt_655  hi.ne.mr_222 ms.hmn.jw_532
  0x2b000a19, 0x11202904, 0x4a000c12, 0x08006404,   // pt.vi.un_750 sl.sq.ro_332  sv.yo.un_640 lg.no.un_320
  0x230b180c, 0x110a10a4, 0x11000a1a, 0x64325202,   // ga.es.ca_543 be.mk.ro_433  mk.ro.un_760 ha.bs.lg_222
  // [41d0]
  0x132a2805, 0x0500180d, 0x2b000a12, 0x070823a4,   // sw.mt.et_333 ga.fr.un_540  pt.vi.un_640 ca.no.it_433
  0x0f082aa4, 0x083f2aa7, 0x235201a4, 0x0a056413,   // mt.no.lv_433 mt.af.no_532  en.ha.ca_433 lg.fr.pt_665
  0x2a0f08a4, 0x041f6b55, 0x100a11a0, 0x076b13ee,   // no.lv.mt_433 ceb.cy.fi_442  ro.mk.be_322 et.ceb.it_422
  0x01191ea4, 0x1c231eee, 0x25001807, 0x06092a14,   // ms.gl.en_433 ms.ca.id_422  ga.eu.un_420 mt.pl.de_666
  // [41e0]
  0x1e041ca4, 0x20030f07, 0x2a3216a4, 0x19004a07,   // id.fi.ms_433 lv.nl.sq_432  hr.bs.mt_433 yo.gl.un_420
  0x030c2bee, 0x0f080214, 0x0b003504, 0x050119a7,   // vi.sv.nl_422 da.no.lv_666  zu.es.un_320 gl.en.fr_532
  0x2b0727a0, 0x0c1c03a4, 0x020c0fa7, 0x1e1c2107,   // gd.it.vi_322 nl.id.sv_433  lv.sv.da_532 jw.id.ms_432
  0x3b04130c, 0x0c0704af, 0x2d1f2509, 0x25002702,   // et.fi.so_543 fi.it.sv_655  eu.cy.sk_444 gd.eu.un_220
  // [41f0]
  0x0e00110d, 0x1c1f2007, 0x10170a13, 0x16000f0c,   // ro.is.un_540 sq.cy.id_432  mk.sr.be_665 lv.hr.un_530
  0x16003211, 0x09101b08, 0x1b001e09, 0x1c3b64a6,   // bs.hr.un_630 tr.lt.pl_443  ms.tr.un_440 lg.so.id_521
  0x28211aa0, 0x062a07ac, 0x1b3b1311, 0x0e040ca4,   // tl.jw.sw_322 it.mt.de_632  et.so.tr_653 sv.fi.is_433
  0x113b010c, 0x06253ba0, 0x1e6e1cad, 0x190b08a4,   // en.so.ro_543 so.eu.de_322  id.hmn.ms_643 no.es.gl_433
  // [4200]
  0x6e6b4a04, 0x6e1e2108, 0x0f252da4, 0x023f08a9,   // yo.ceb.hmn_332 jw.ms.hmn_443  sk.eu.lv_433 no.af.da_544
  0x2123050c, 0x1b1c1ead, 0x3f003507, 0x2964550c,   // fr.ca.jw_543 ms.id.tr_643  zu.af.un_420 rw.lg.sl_543
  0x4a00270c, 0x27005322, 0x29003f1a, 0x174a290c,   // gd.yo.un_530 ht.gd.un_870  af.sl.un_760 sl.yo.sr_543
  0x02060c0d, 0x12202508, 0x180e050b, 0x03060f12,   // sv.de.da_554 eu.sq.hu_443  fr.is.ga_542 lv.de.nl_654
  // [4210]
  0x285520ec, 0x0c060eaf, 0x530221a4, 0x110a0da4,   // sq.rw.sw_644 is.de.sv_655  jw.da.ht_433 cs.pt.ro_433
  0x3f082107, 0x351664ec, 0x351820af, 0x1c3f1aa7,   // jw.no.af_432 lg.hr.zu_644  sq.ga.zu_655 tl.af.id_532
  0x642021a4, 0x23006405, 0x4a0f07a4, 0x28253108,   // jw.sq.lg_433 lg.ca.un_330  it.lv.yo_433 az.eu.sw_443
  0x281b2905, 0x28001b18, 0x04201112, 0x18282707,   // sl.tr.sw_333 tr.sw.un_740  ro.sq.fi_654 gd.sw.ga_432
  // [4220]
  0x3125200c, 0x030f06a7, 0x060e0309, 0x0b0a2360,   // sq.eu.az_543 de.lv.nl_532  nl.is.de_444 ca.pt.es_664
  0x180b270c, 0x0e001c04, 0x08131ea4, 0x2d0d4a09,   // gd.es.ga_543 id.is.un_320  ms.et.no_433 yo.cs.sk_444
  0x251801a4, 0x2711180d, 0x00000203, 0x181227ee,   // en.ga.eu_433 ga.ro.gd_554  da.un.un_300 gd.hu.ga_422
  0x1200351b, 0x066b0c08, 0x281227a0, 0x11072a0c,   // zu.hu.un_770 sv.ceb.de_443  gd.hu.sw_322 mt.it.ro_543
  // [4230]
  0x1e1c1aa9, 0x6b211ea9, 0x063f5507, 0x0b001114,   // tl.id.ms_544 ms.jw.ceb_544  rw.af.de_432 ro.es.un_660
  0x29130908, 0x08021f0c, 0x07101fa7, 0x1021010c,   // pl.et.sl_443 cy.da.no_543  cy.lt.it_532 en.jw.lt_543
  0x6b1a130e, 0x17352004, 0x2d120e12, 0x04002105,   // et.tl.ceb_555 sq.zu.sr_332  is.hu.sk_654 jw.fi.un_330
  0x321609ec, 0x10001f05, 0x0d0855ec, 0x681b35a7,   // pl.hr.bs_644 cy.lt.un_330  rw.no.cs_644 zu.tr.ig_532
  // [4240]
  0x1c642107, 0x29121e07, 0x12070fa7, 0x250f1a02,   // jw.lg.id_432 ms.hu.sl_432  lv.it.hu_532 tl.lv.eu_222
  0x3f04035a, 0x320c020c, 0x1e3f130d, 0x531901a9,   // nl.fi.af_553 da.sv.bs_543  et.af.ms_554 en.gl.ht_544
  0x3f0c6ea4, 0x0a08170c, 0x02006e19, 0x6e002d1a,   // hmn.sv.af_433 sr.uk.mk_543  hmn.da.un_750 sk.hmn.un_760
  0x0c310611, 0x32001008, 0x5500522c, 0x270208a4,   // de.az.sv_653 lt.bs.un_430  ha.rw.un_990 no.da.gd_433
  // [4250]
  0x27006b0d, 0x3f6b6eec, 0x1c130911, 0x6428520c,   // ceb.gd.un_540 hmn.ceb.af_644  hi.bh.mr_653 ha.sw.lg_543
  0x0932310d, 0x0c000607, 0x64555202, 0x3f6e1fa9,   // az.bs.pl_554 de.sv.un_420  ha.rw.lg_222 cy.hmn.af_544
  0x1f02030c, 0x1e1c1aa4, 0x04003513, 0x35186b0c,   // nl.da.cy_543 tl.id.ms_433  zu.fi.un_650 ceb.ga.zu_543
  0x036e270e, 0x04081eee, 0x096e2d11, 0x04130fad,   // gd.hmn.nl_555 ms.no.fi_422  sk.hmn.pl_653 lv.et.fi_643
  // [4260]
  0x6b3513a4, 0x6b100aa4, 0x021a6bad, 0x126410a0,   // et.zu.ceb_433 pt.lt.ceb_433  ceb.tl.da_643 lt.lg.hu_322
  0x53001904, 0x19051108, 0x520821a0, 0x060819a0,   // gl.ht.un_320 ro.fr.gl_443  jw.no.ha_322 gl.no.de_322
  0x04110aad, 0x04002a07, 0x64001e02, 0x1e1c0414,   // mk.ro.ru_643 mt.fi.un_420  ms.lg.un_220 fi.id.ms_666
  0x1c3b1ea4, 0x4a64280c, 0x10641305, 0x12211ea4,   // ms.so.id_433 sw.lg.yo_543  et.lg.lt_333 ms.jw.hu_433
  // [4270]
  0x0a35040d, 0x231228a0, 0x531f35a4, 0x080f1012,   // fi.zu.pt_554 sw.hu.ca_322  zu.cy.ht_433 lt.lv.no_654
  0x08021a14, 0x1c201e11, 0x551a6bee, 0x0802270d,   // tl.da.no_666 ms.sq.id_653  ceb.tl.rw_422 gd.da.no_554
  0x25001c02, 0x2a6407af, 0x1b000613, 0x13002502,   // id.eu.un_220 it.lg.mt_655  de.tr.un_650 eu.et.un_220
  0x182821ad, 0x2d162804, 0x203f1ca4, 0x03021faf,   // jw.sw.ga_643 sw.hr.sk_332  id.af.sq_433 cy.da.nl_655
  // [4280]
  0x121e2a08, 0x6e033fa4, 0x201b3208, 0x2d050da6,   // mt.ms.hu_443 af.nl.hmn_433  bs.tr.sq_443 cs.fr.sk_521
  0x0f041aee, 0x08001f0c, 0x0a0410ad, 0x25351207,   // tl.fi.lv_422 cy.no.un_530  be.ru.mk_643 hu.zu.eu_432
  0x1012040c, 0x04231208, 0x352b1fa0, 0x0b000a02,   // fi.hu.lt_543 hu.ca.fi_443  cy.vi.zu_322 pt.es.un_220
  0x0120270c, 0x3b131e12, 0x0f291705, 0x02002a14,   // gd.sq.en_543 ms.et.so_654  sr.sl.lv_333 mt.da.un_660
  // [4290]
  0x1a000104, 0x1b041c05, 0x12002012, 0x3b133f08,   // en.tl.un_320 id.fi.tr_333  sq.hu.un_640 af.et.so_443
  0x040c3f07, 0x1a6b0bec, 0x0c19040d, 0x1f3b18ec,   // af.sv.fi_432 es.ceb.tl_644  fi.gl.sv_554 ga.so.cy_644
  0x1a6b0f0c, 0x1f523fa4, 0x6b003b09, 0x11256b0c,   // lv.ceb.tl_543 af.ha.cy_433  so.ceb.un_440 ceb.eu.ro_543
  0x68213b08, 0x0e355512, 0x0f101f02, 0x3b0b6b04,   // so.jw.ig_443 rw.zu.is_654  cy.lt.lv_222 ceb.es.so_332
  // [42a0]
  0x1c11210c, 0x0a291cee, 0x090d13a0, 0x351f0311,   // jw.ro.id_543 id.sl.pt_422  bh.ne.hi_322 nl.cy.zu_653
  0x1f6b1a08, 0x13083f09, 0x1c1e6ea7, 0x3b1f0cec,   // tl.ceb.cy_443 af.no.et_444  hmn.ms.id_532 sv.cy.so_644
  0x05550208, 0x13002d04, 0x19236eee, 0x160d175a,   // da.rw.fr_443 sk.et.un_320  hmn.ca.gl_422 sr.cs.hr_553
  0x09002a13, 0x6e001e08, 0x10006e08, 0x19005308,   // mt.pl.un_650 ms.hmn.un_430  hmn.lt.un_430 ht.gl.un_430
  // [42b0]
  0x10190b0c, 0x6406550c, 0x1b3125a9, 0x183b27a4,   // es.gl.lt_543 rw.de.lg_543  eu.az.tr_544 gd.so.ga_433
  0x08061805, 0x0f136ead, 0x061f0ea4, 0x52556bad,   // ga.de.no_333 hmn.et.lv_643  is.cy.de_433 ceb.rw.ha_643
  0x522a285a, 0x124a530e, 0x080c1a09, 0x05001f13,   // sw.mt.ha_553 ht.yo.hu_555  tl.sv.no_444 cy.fr.un_650
  0x0c21200c, 0x55112aec, 0x526b1805, 0x083f030c,   // sq.jw.sv_543 mt.ro.rw_644  ga.ceb.ha_333 nl.af.no_543
  // [42c0]
  0x080e0660, 0x52006b0e, 0x64063507, 0x1200201a,   // de.is.no_664 ceb.ha.un_550  zu.de.lg_432 sq.hu.un_760
  0x17001122, 0x27000a02, 0x6b004a0d, 0x28065202,   // ro.sr.un_870 pt.gd.un_220  yo.ceb.un_540 ha.de.sw_222
  0x20211205, 0x646b3509, 0x551718a4, 0x12080c60,   // hu.jw.sq_333 zu.ceb.lg_444  ga.sr.rw_433 sv.no.hu_664
  0x0c181a08, 0x2106550c, 0x080c200c, 0x13033f0c,   // tl.ga.sv_443 rw.de.jw_543  sq.sv.no_543 af.nl.et_543
  // [42d0]
  0x02133f0c, 0x1f001014, 0x1f2d1807, 0x0b1008a0,   // af.et.da_543 lt.cy.un_660  ga.sk.cy_432 no.lt.es_322
  0x1e1c3bec, 0x0b1b19a0, 0x06005519, 0x06002821,   // so.id.ms_644 gl.tr.es_322  rw.de.un_750 sw.de.un_860
  0x1e6b1a0d, 0x201f03a0, 0x530e1f05, 0x05003113,   // tl.ceb.ms_554 nl.cy.sq_322  cy.is.ht_333 az.fr.un_650
  0x2d013b07, 0x100f09ee, 0x2a041a0b, 0x0f005304,   // so.en.sk_432 pl.lv.lt_422  tl.fi.mt_542 ht.lv.un_320
  // [42e0]
  0x13534aa4, 0x311b5208, 0x231a210c, 0x0f00170d,   // yo.ht.et_433 ha.tr.az_443  jw.tl.ca_543 sr.lv.un_540
  0x2d0d29a9, 0x102d01a4, 0x17111fec, 0x644a2808,   // sl.cs.sk_544 en.sk.lt_433  cy.ro.sr_644 sw.yo.lg_443
  0x1f001602, 0x2500642b, 0x3b6b100d, 0x2a0c3bad,   // hr.cy.un_220 lg.eu.un_980  lt.ceb.so_554 so.sv.mt_643
  0x0c001318, 0x0c2012a7, 0x07190b13, 0x29004a1a,   // et.sv.un_740 hu.sq.sv_532  es.gl.it_665 yo.sl.un_760
  // [42f0]
  0x2a001b19, 0x04641eee, 0x10001604, 0x1e1c1a0c,   // tr.mt.un_750 ms.lg.fi_422  hr.lt.un_320 tl.id.ms_543
  0x28000a0d, 0x35004a19, 0x2500200e, 0x1729100c,   // pt.sw.un_540 yo.zu.un_750  sq.eu.un_550 lt.sl.sr_543
  0x19002d04, 0x110305a0, 0x291055ad, 0x2b206eee,   // sk.gl.un_320 fr.nl.ro_322  rw.lt.sl_643 hmn.sq.vi_422
  0x0f000707, 0x0c040dee, 0x210906a7, 0x0900311a,   // it.lv.un_420 cs.fi.sv_422  de.pl.jw_532 az.pl.un_760
  // [4300]
  0x1827280c, 0x250407ad, 0x1b002813, 0x0125200c,   // sw.gd.ga_543 it.fi.eu_643  sw.tr.un_650 sq.eu.en_543
  0x1b002a11, 0x3f0e0214, 0x3f355505, 0x19520bee,   // mt.tr.un_630 da.is.af_666  rw.zu.af_333 es.ha.gl_422
  0x53231807, 0x2b2718a4, 0x12645308, 0x0c000414,   // ga.ca.ht_432 ga.gd.vi_433  ht.lg.hu_443 fi.sv.un_660
  0x32291711, 0x080219a0, 0x233b13ec, 0x3500031a,   // sr.sl.bs_653 gl.da.no_322  et.so.ca_644 nl.zu.un_760
  // [4310]
  0x64353104, 0x4a00521b, 0x09120da0, 0x52006420,   // az.zu.lg_332 ha.yo.un_770  cs.hu.pl_322 lg.ha.un_850
  0x0000642d, 0x256b4aee, 0x35063f13, 0x12211c08,   // lg.un.un_A00 yo.ceb.eu_422  af.de.zu_665 id.jw.hu_443
  0x1e061c04, 0x321629a4, 0x644a3504, 0x3f2d29a4,   // id.de.ms_332 sl.hr.bs_433  zu.yo.lg_332 sl.sk.af_433
  0x10001114, 0x0d292d10, 0x290d2d0c, 0x35204aa0,   // ro.be.un_660 sk.sl.cs_642  sk.cs.sl_543 yo.sq.zu_322
  // [4320]
  0x35006420, 0x01310204, 0x3f000702, 0x06130c11,   // lg.zu.un_850 da.az.en_332  it.af.un_220 sv.et.de_653
  0x250c1304, 0x272d0d05, 0x104a6808, 0x121c1ea4,   // et.sv.eu_332 cs.sk.gd_333  ig.yo.lt_443 ms.id.hu_433
  0x12001a2a, 0x080205ac, 0x28005502, 0x11001721,   // tl.hu.un_970 fr.da.no_632  rw.sw.un_220 sr.ro.un_860
  0x0e1a1205, 0x1c1a1e12, 0x536b1a08, 0x2a011308,   // hu.tl.is_333 ms.tl.id_654  tl.ceb.ht_443 et.en.mt_443
  // [4330]
  0x291320ad, 0x1a005509, 0x20531212, 0x1c3b6ba4,   // sq.et.sl_643 rw.tl.un_440  hu.ht.sq_654 ceb.so.id_433
  0x0c190b0d, 0x212b3509, 0x2a07270c, 0x1e000619,   // es.gl.sv_554 zu.vi.jw_444  gd.it.mt_543 de.ms.un_750
  0x52000707, 0x190b2360, 0x190b230e, 0x0e645204,   // it.ha.un_420 ca.es.gl_664  ca.es.gl_555 ha.lg.is_332
  0x0b0a1811, 0x08070a14, 0x07100a14, 0x080201a9,   // ga.pt.es_653 mk.bg.uk_666  mk.be.bg_666 en.da.no_544
  // [4340]
  0x29001904, 0x096b1a12, 0x05070e04, 0x55293505,   // gl.sl.un_320 tl.ceb.pl_654  is.it.fr_332 zu.sl.rw_333
  0x033f1fac, 0x0a006b22, 0x1f1811af, 0x080253a4,   // cy.af.nl_632 ceb.pt.un_870  ro.ga.cy_655 ht.da.no_433
  0x3b3f0309, 0x1f0f1112, 0x02060807, 0x0e00232b,   // nl.af.so_444 ro.lv.cy_654  no.de.da_432 ca.is.un_980
  0x1f000c22, 0x0a004a07, 0x04001904, 0x0f001604,   // sv.cy.un_870 yo.pt.un_420  gl.fi.un_320 hr.lv.un_320
  // [4350]
  0x3f311aad, 0x2528640c, 0x6853010b, 0x090627ec,   // tl.az.af_643 lg.sw.eu_543  en.ht.ig_542 gd.de.pl_644
  0x11051b5a, 0x3100531b, 0x4a005304, 0x190b5205,   // tr.fr.ro_553 ht.az.un_770  ht.yo.un_320 ha.es.gl_333
  0x1807110d, 0x23000804, 0x20072313, 0x1a252307,   // ro.it.ga_554 no.ca.un_320  ca.it.sq_665 ca.eu.tl_432
  0x18270112, 0x190a29a9, 0x190b0a60, 0x28186ba7,   // en.gd.ga_654 sl.pt.gl_544  pt.es.gl_664 ceb.ga.sw_532
  // [4360]
  0x060c27a4, 0x53041012, 0x08020fa9, 0x1a6b2511,   // gd.sv.de_433 lt.fi.ht_654  lv.da.no_544 eu.ceb.tl_653
  0x35641a0c, 0x100411ee, 0x08252855, 0x18270608,   // tl.lg.zu_543 ro.ru.be_422  sw.eu.no_442 de.gd.ga_443
  0x1c4a210b, 0x1f0601ec, 0x1e1c1a0e, 0x1c121ea9,   // jw.yo.id_542 en.de.cy_644  tl.id.ms_555 ms.hu.id_544
  0x0a110405, 0x201304a9, 0x033f0d12, 0x3b030f0d,   // ru.ro.mk_333 fi.et.sq_544  cs.af.nl_654 lv.nl.so_554
  // [4370]
  0x231a1109, 0x554a530b, 0x21091f07, 0x2a1f0111,   // ro.tl.ca_444 ht.yo.rw_542  cy.pl.jw_432 en.cy.mt_653
  0x20001305, 0x2b6455a4, 0x091f2aa0, 0x23000c08,   // et.sq.un_330 rw.lg.vi_433  mt.cy.pl_322 sv.ca.un_430
  0x55001a0d, 0x1b113113, 0x0e1220ee, 0x0a000f08,   // tl.rw.un_540 az.ro.tr_665  sq.hu.is_422 lv.pt.un_430
  0x0c0d0412, 0x060b25ad, 0x112a23ec, 0x051123a0,   // fi.cs.sv_654 eu.es.de_643  ca.mt.ro_644 ca.ro.fr_322
  // [4380]
  0x641a01ad, 0x1812200c, 0x19002513, 0x1f00092a,   // en.tl.lg_643 sq.hu.ga_543  eu.gl.un_650 pl.cy.un_970
  0x08002512, 0x1e2a310c, 0x2a091f0c, 0x08002534,   // eu.no.un_640 az.mt.ms_543  cy.pl.mt_543 eu.no.un_A80
  0x1b1f0b0c, 0x6e003f0e, 0x07190a09, 0x053f0312,   // es.cy.tr_543 af.hmn.un_550  pt.gl.it_444 nl.af.fr_654
  0x19110a0e, 0x5264060c, 0x2a002314, 0x6e0a3108,   // pt.ro.gl_555 de.lg.ha_543  ca.mt.un_660 az.pt.hmn_443
  // [4390]
  0x136b3b12, 0x06000523, 0x040c13a4, 0x20050b0c,   // so.ceb.et_654 fr.de.un_880  et.sv.fi_433 es.fr.sq_543
  0x03001021, 0x0a002508, 0x12024aa6, 0x20000308,   // lt.nl.un_860 eu.pt.un_430  yo.da.hu_521 nl.sq.un_430
  0x1713520c, 0x28643b08, 0x1b6e0fa7, 0x64080205,   // ha.et.sr_543 so.lg.sw_443  lv.hmn.tr_532 da.no.lg_333
  0x1a106ba9, 0x6b1a1ea4, 0x55685209, 0x6e000f1a,   // ceb.lt.tl_544 ms.tl.ceb_433  ha.ig.rw_444 lv.hmn.un_760
  // [43a0]
  0x1f000b04, 0x0d002502, 0x3f072aa4, 0x101711a4,   // es.cy.un_320 eu.cs.un_220  mt.it.af_433 ro.sr.be_433
  0x0c001804, 0x27004a07, 0x03000623, 0x5216280c,   // ga.sv.un_320 yo.gd.un_420  de.nl.un_880 sw.hr.ha_543
  0x321f07ad, 0x3564530c, 0x0b0a11ec, 0x10002a02,   // it.cy.bs_643 ht.lg.zu_543  ro.pt.es_644 mt.lt.un_220
  0x3b313511, 0x64553ba7, 0x04030f04, 0x3b28550c,   // zu.az.so_653 so.rw.lg_532  lv.nl.fi_332 rw.sw.so_543
  // [43b0]
  0x1e000a07, 0x11070111, 0x25643513, 0x64282514,   // pt.ms.un_420 en.it.ro_653  zu.lg.eu_665 eu.sw.lg_666
  0x6b0d3ba9, 0x25003507, 0x01000302, 0x6452280d,   // so.cs.ceb_544 zu.eu.un_420  nl.en.un_220 sw.ha.lg_554
  0x2a1806ee, 0x3b1c04ad, 0x1b001607, 0x35251212,   // de.ga.mt_422 fi.id.so_643  hr.tr.un_420 hu.eu.zu_654
  0x3100060c, 0x051f0713, 0x3f00100e, 0x0413060c,   // de.az.un_530 it.cy.fr_665  lt.af.un_550 de.et.fi_543
  // [43c0]
  0x12090307, 0x08182712, 0x3b551a04, 0x11271808,   // nl.pl.hu_432 gd.ga.no_654  tl.rw.so_332 ga.gd.ro_443
  0x0a081013, 0x132811a4, 0x0a35640d, 0x6b31550c,   // be.uk.mk_665 ro.sw.et_433  lg.zu.pt_554 rw.az.ceb_543
  0x352a3b0c, 0x173216ad, 0x23000702, 0x13002707,   // so.mt.zu_543 hr.bs.sr_643  it.ca.un_220 gd.et.un_420
  0x1b0306ad, 0x1c001a04, 0x0c001809, 0x251a3114,   // de.nl.tr_643 tl.id.un_320  ga.sv.un_440 az.tl.eu_666
  // [43d0]
  0x04292aee, 0x041a6bee, 0x232a20a4, 0x19230aa7,   // mt.sl.fi_422 ceb.tl.fi_422  sq.mt.ca_433 pt.ca.gl_532
  0x110118a7, 0x05130808, 0x3f1e1c08, 0x18080cad,   // ga.en.ro_532 no.et.fr_443  id.ms.af_443 sv.no.ga_643
  0x35002008, 0x050a0ba0, 0x35002121, 0x25001b0d,   // sq.zu.un_430 es.pt.fr_322  jw.zu.un_860 tr.eu.un_540
  0x0e1009a0, 0x320f21a4, 0x1b210112, 0x043f2a05,   // pl.lt.is_322 jw.lv.bs_433  en.jw.tr_654 mt.af.fi_333
  // [43e0]
  0x1f003f05, 0x00000403, 0x214a3b0c, 0x13006b04,   // af.cy.un_330 fi.un.un_300  so.yo.jw_543 ceb.et.un_320
  0x2500320c, 0x3f0e0205, 0x2a0c0408, 0x04191c07,   // bs.eu.un_530 da.is.af_333  fi.sv.mt_443 id.gl.fi_432
  0x01000304, 0x1e1c2814, 0x3f523ba4, 0x071c1ead,   // nl.en.un_320 sw.id.ms_666  so.ha.af_433 ms.id.it_643
  0x0a003b0e, 0x103b19a4, 0x070511a4, 0x123b280c,   // so.pt.un_550 gl.so.lt_433  ro.fr.it_433 sw.so.hu_543
  // [43f0]
  0x0a003b07, 0x3b003f12, 0x0600180c, 0x3f0108ee,   // so.pt.un_420 af.so.un_640  ga.de.un_530 no.en.af_422
  0x08023baf, 0x080f0ea4, 0x351f4a09, 0x0700200c,   // so.da.no_655 is.lv.no_433  yo.cy.zu_444 sq.it.un_530
  0x2b001102, 0x04100705, 0x2d000104, 0x2d0d310c,   // ro.vi.un_220 bg.be.ru_333  en.sk.un_320 az.cs.sk_543
  0x1a000e13, 0x6b1e1c11, 0x17005507, 0x23001c08,   // is.tl.un_650 id.ms.ceb_653  rw.sr.un_420 id.ca.un_430

  // [4400]
  0x5200680e, 0x0c640808, 0x27002b0d, 0x04133f0c,   // ig.ha.un_550 no.lg.sv_443  vi.gd.un_540 af.et.fi_543
  0x13640414, 0x04132511, 0x0719200c, 0x2d0d20ee,   // fi.lg.et_666 eu.et.fi_653  sq.gl.it_543 sq.cs.sk_422
  0x230a520b, 0x1e1c4aec, 0x6e0b4aa4, 0x080420ee,   // ha.pt.ca_542 yo.id.ms_644  yo.es.hmn_433 sq.fi.no_422
  0x35006434, 0x311b1211, 0x20320413, 0x1300200c,   // lg.zu.un_A80 hu.tr.az_653  fi.bs.sq_665 sq.et.un_530
  // [4410]
  0x212d2808, 0x20003202, 0x1b001a04, 0x0e2807a9,   // sw.sk.jw_443 bs.sq.un_220  tl.tr.un_320 it.sw.is_544
  0x321a4aa7, 0x170a0405, 0x0c092da0, 0x2a051308,   // yo.tl.bs_532 ru.mk.sr_333  sk.pl.sv_322 et.fr.mt_443
  0x0b1b5205, 0x53311e0c, 0x1c000b04, 0x311b0ba0,   // ha.tr.es_333 ms.az.ht_543  es.id.un_320 es.tr.az_322
  0x0b002904, 0x321620a9, 0x643b6b13, 0x4a643b13,   // sl.es.un_320 sq.hr.bs_544  ceb.so.lg_665 so.lg.yo_665
  // [4420]
  0x290820ee, 0x1b042012, 0x08201608, 0x3b2864af,   // sq.no.sl_422 sq.fi.tr_654  hr.sq.no_443 lg.sw.so_655
  0x0e1b3160, 0x272a1804, 0x311b0eee, 0x04170702,   // az.tr.is_664 ga.mt.gd_332  is.tr.az_422 bg.sr.ru_222
  0x1e524a02, 0x35213fa0, 0x6e000619, 0x27070308,   // yo.ha.ms_222 af.jw.zu_322  de.hmn.un_750 nl.it.gd_443
  0x532513ec, 0x0600270d, 0x0600291a, 0x1a643b12,   // et.eu.ht_644 gd.de.un_540  sl.de.un_760 so.lg.tl_654
  // [4430]
  0x0f1006a9, 0x2d0d06ec, 0x06000302, 0x0c1906a7,   // de.lt.lv_544 de.cs.sk_644  nl.de.un_220 de.gl.sv_532
  0x52006e22, 0x1a002a08, 0x0a000404, 0x25000914,   // hmn.ha.un_870 mt.tl.un_430  ru.mk.un_320 pl.eu.un_660
  0x354a1aa4, 0x555364ec, 0x082902a4, 0x13000420,   // tl.yo.zu_433 lg.ht.rw_644  da.sl.no_433 fi.et.un_850
  0x235321a9, 0x1b002504, 0x04003b08, 0x28002304,   // jw.ht.ca_544 eu.tr.un_320  so.fi.un_430 ca.sw.un_320
  // [4440]
  0x03060e0c, 0x01103fa4, 0x0916290c, 0x0b23010c,   // is.de.nl_543 af.lt.en_433  sl.hr.pl_543 en.ca.es_543
  0x123152ee, 0x08006402, 0x06250c05, 0x1e000c08,   // ha.az.hu_422 lg.no.un_220  sv.eu.de_333 sv.ms.un_430
  0x19070aec, 0x0e202a0d, 0x07000a36, 0x18000808,   // pt.it.gl_644 mt.sq.is_554  mk.bg.un_AA0 no.ga.un_430
  0x0d042d0c, 0x03001602, 0x0605010c, 0x1c000305,   // sk.fi.cs_543 hr.nl.un_220  en.fr.de_543 nl.id.un_330
  // [4450]
  0x1e1c35a9, 0x53050607, 0x18001708, 0x1100290d,   // zu.id.ms_544 de.fr.ht_432  sr.ga.un_430 sl.ro.un_540
  0x0e0c2aad, 0x160d29ad, 0x53002707, 0x25001f1b,   // mt.sv.is_643 sl.cs.hr_643  gd.ht.un_420 cy.eu.un_770
  0x190a07a4, 0x13002314, 0x2a00112a, 0x64551a0c,   // it.pt.gl_433 ca.et.un_660  ro.mt.un_970 tl.rw.lg_543
  0x52553b08, 0x1e1c2112, 0x04292da4, 0x1a536b09,   // so.rw.ha_443 jw.id.ms_654  sk.sl.fi_433 ceb.ht.tl_444
  // [4460]
  0x25102807, 0x273f53a0, 0x2b004a09, 0x53001e0d,   // sw.lt.eu_432 ht.af.gd_322  yo.vi.un_440 ms.ht.un_540
  0x3b640f08, 0x3f001904, 0x2700290e, 0x062a6e12,   // lv.lg.so_443 gl.af.un_320  sl.gd.un_550 hmn.mt.de_654
  0x0e2b4a0c, 0x2a12080b, 0x2d1819a0, 0x271007a0,   // yo.vi.is_543 no.hu.mt_542  gl.ga.sk_322 it.lt.gd_322
  0x06001607, 0x550531ad, 0x28121fec, 0x2b004a21,   // hr.de.un_420 az.fr.rw_643  cy.hu.sw_644 yo.vi.un_860
  // [4470]
  0x01032a02, 0x21011aee, 0x21251fad, 0x0f000702,   // mt.nl.en_222 tl.en.jw_422  cy.eu.jw_643 it.lv.un_220
  0x07252904, 0x0b05010c, 0x13091c09, 0x64001a19,   // sl.eu.it_332 en.fr.es_543  mr.hi.bh_444 tl.lg.un_750
  0x1b2855a9, 0x3b523108, 0x19001c04, 0x1a1c6b08,   // rw.sw.tr_544 az.ha.so_443  id.gl.un_320 ceb.id.tl_443
  0x02040807, 0x02063112, 0x132025a4, 0x3b21640b,   // no.fi.da_432 az.de.da_654  eu.sq.et_433 lg.jw.so_542
  // [4480]
  0x01001104, 0x17200907, 0x31351b08, 0x13002a0e,   // ro.en.un_320 pl.sq.sr_432  tr.zu.az_443 mt.et.un_550
  0x191b350c, 0x0c0821a0, 0x5531350c, 0x6431520c,   // zu.tr.gl_543 jw.no.sv_322  zu.az.rw_543 ha.az.lg_543
  0x19003118, 0x1f001b13, 0x283f06a4, 0x3f010310,   // az.gl.un_740 tr.cy.un_650  de.af.sw_433 nl.en.af_642
  0x203117ee, 0x55311b0d, 0x0d0553a7, 0x351b310d,   // sr.az.sq_422 tr.az.rw_554  ht.fr.cs_532 az.tr.zu_554
  // [4490]
  0x1121280c, 0x3217290c, 0x1e1c1a14, 0x1b0f1008,   // sw.jw.ro_543 sl.sr.bs_543  tl.id.ms_666 lt.lv.tr_443
  0x04123fa9, 0x1e002504, 0x08022714, 0x0f1004a4,   // af.hu.fi_544 eu.ms.un_320  gd.da.no_666 fi.lt.lv_433
  0x232153ec, 0x190b18a0, 0x131004a4, 0x4a1f2855,   // ht.jw.ca_644 ga.es.gl_322  fi.lt.et_433 sw.cy.yo_442
  0x1b0f1012, 0x0655350c, 0x2b182702, 0x1835555a,   // lt.lv.tr_654 zu.rw.de_543  gd.ga.vi_222 rw.zu.ga_553
  // [44a0]
  0x0b232708, 0x28004a0e, 0x0a001e0c, 0x1710040c,   // gd.ca.es_443 yo.sw.un_550  ms.pt.un_530 ru.be.sr_543
  0x6b121aaf, 0x01020fa0, 0x1253050e, 0x2010040c,   // tl.hu.ceb_655 lv.da.en_322  fr.ht.hu_555 fi.lt.sq_543
  0x1935640c, 0x0f002d04, 0x0429200e, 0x071710a0,   // lg.zu.gl_543 sk.lv.un_320  sq.sl.fi_555 be.sr.bg_322
  0x31063b07, 0x3b003204, 0x53180ba0, 0x21002b08,   // so.de.az_432 bs.so.un_320  es.ga.ht_322 vi.jw.un_430
  // [44b0]
  0x136e2512, 0x111e1912, 0x13000708, 0x05124aee,   // eu.hmn.et_654 gl.ms.ro_654  it.et.un_430 yo.hu.fr_422
  0x0307350c, 0x2d002020, 0x100f35ad, 0x05640704,   // zu.it.nl_543 sq.sk.un_850  zu.lv.lt_643 it.lg.fr_332
  0x06350314, 0x27001804, 0x09105305, 0x061b030c,   // nl.zu.de_666 ga.gd.un_320  ht.lt.pl_333 nl.tr.de_543
  0x1f000705, 0x4a5504af, 0x191a2107, 0x122b19ad,   // it.cy.un_330 fi.rw.yo_655  jw.tl.gl_432 gl.vi.hu_643
  // [44c0]
  0x051103a9, 0x291055a4, 0x1a4a3504, 0x2011530c,   // nl.ro.fr_544 rw.lt.sl_433  zu.yo.tl_332 ht.ro.sq_543
  0x07003522, 0x0a1c2dee, 0x05011111, 0x05110304,   // zu.it.un_870 sk.id.pt_422  ro.en.fr_653 nl.ro.fr_332
  0x11000322, 0x31003512, 0x32006407, 0x32212d07,   // nl.ro.un_870 zu.az.un_640  lg.bs.un_420 sk.jw.bs_432
  0x08170a0c, 0x021a3f0d, 0x2307110e, 0x21001a04,   // mk.sr.uk_543 af.tl.da_554  ro.it.ca_555 tl.jw.un_320
  // [44d0]
  0x190b230c, 0x52102907, 0x206b35ad, 0x35094aa7,   // ca.es.gl_543 sl.lt.ha_432  zu.ceb.sq_643 yo.pl.zu_532
  0x20051305, 0x3b063f0c, 0x1c211360, 0x022b250c,   // et.fr.sq_333 af.de.so_543  et.jw.id_664 eu.vi.da_543
  0x11052da4, 0x2a290fa4, 0x03001113, 0x03010505,   // sk.fr.ro_433 lv.sl.mt_433  ro.nl.un_650 fr.en.nl_333
  0x16000108, 0x2d290d05, 0x64355513, 0x2505010d,   // en.hr.un_430 cs.sl.sk_333  rw.zu.lg_665 en.fr.eu_554
  // [44e0]
  0x10001105, 0x281a01af, 0x3b203108, 0x12061305,   // ro.be.un_330 en.tl.sw_655  az.sq.so_443 et.de.hu_333
  0x5553350c, 0x0d002a0d, 0x042113af, 0x02003f12,   // zu.ht.rw_543 mt.cs.un_540  et.jw.fi_655 af.da.un_640
  0x32006b02, 0x0d0f2d0c, 0x02003f1a, 0x0723095a,   // ceb.bs.un_220 sk.lv.cs_543  af.da.un_760 pl.ca.it_553
  0x10001a04, 0x1c35250c, 0x04292809, 0x3f0208a4,   // tl.lt.un_320 eu.zu.id_543  sw.sl.fi_444 no.da.af_433
  // [44f0]
  0x35000912, 0x11005212, 0x080201ee, 0x08023f0c,   // pl.zu.un_640 ha.ro.un_640  en.da.no_422 af.da.no_543
  0x17680cee, 0x132311ec, 0x252813a9, 0x020e08af,   // sv.ig.sr_422 ro.ca.et_644  et.sw.eu_544 no.is.da_655
  0x3b6435ee, 0x072368a7, 0x1103010c, 0x13281a08,   // zu.lg.so_422 ig.ca.it_532  en.nl.ro_543 tl.sw.et_443
  0x013f09ad, 0x101a1e0c, 0x122d6ba0, 0x17002312,   // pl.af.en_643 ms.tl.lt_543  ceb.sk.hu_322 ca.sr.un_640
  // [4500]
  0x35001a04, 0x212a1ca4, 0x2d0d20a4, 0x0c001302,   // tl.zu.un_320 id.mt.jw_433  sq.cs.sk_433 et.sv.un_220
  0x2829175a, 0x12003514, 0x0a130413, 0x18002304,   // sr.sl.sw_553 zu.hu.un_660  fi.et.pt_665 ca.ga.un_320
  0x2800521b, 0x200803ee, 0x1e131ca4, 0x21006407,   // ha.sw.un_770 nl.no.sq_422  id.et.ms_433 lg.jw.un_420
  0x0700112a, 0x12060cac, 0x12004a18, 0x21003204,   // ro.bg.un_970 sv.de.hu_632  yo.hu.un_740 bs.jw.un_320
  // [4510]
  0x3b1b52af, 0x0f001214, 0x23051fa9, 0x5200531b,   // ha.tr.so_655 hu.lv.un_660  cy.fr.ca_544 ht.ha.un_770
  0x0118270c, 0x0e00270d, 0x6b041a04, 0x321610a4,   // gd.ga.en_543 gd.is.un_540  tl.fi.ceb_332 lt.hr.bs_433
  0x1e1c1a09, 0x180111ee, 0x1c031ea9, 0x0d005305,   // tl.id.ms_444 ro.en.ga_422  ms.nl.id_544 ht.cs.un_330
  0x12001a04, 0x2a000802, 0x1e000c05, 0x3b112da4,   // tl.hu.un_320 no.mt.un_220  sv.ms.un_330 sk.ro.so_433
  // [4520]
  0x29006804, 0x1b00041b, 0x060e10a9, 0x352827ee,   // ig.sl.un_320 fi.tr.un_770  lt.is.de_544 gd.sw.zu_422
  0x18551f07, 0x31202511, 0x1e00531a, 0x1c521eee,   // cy.rw.ga_432 eu.sq.az_653  ht.ms.un_760 ms.ha.id_422
  0x1f0627a4, 0x0c042a0b, 0x18002822, 0x1200061a,   // gd.de.cy_433 mt.fi.sv_542  sw.ga.un_870 de.hu.un_760
  0x2a000711, 0x090a0ba0, 0x3b110fa4, 0x01002a0d,   // it.mt.un_630 es.pt.pl_322  lv.ro.so_433 mt.en.un_540
  // [4530]
  0x0c000407, 0x0a112a08, 0x0a1004ee, 0x2d0d18ec,   // fi.sv.un_420 mt.ro.pt_443  ru.be.mk_422 ga.cs.sk_644
  0x281e35a4, 0x1f0701a4, 0x09006e0e, 0x060301a0,   // zu.ms.sw_433 en.it.cy_433  hmn.pl.un_550 en.nl.de_322
  0x03000604, 0x532b180b, 0x0e2d2a07, 0x063f2705,   // de.nl.un_320 ga.vi.ht_542  mt.sk.is_432 gd.af.de_333
  0x0a070ba4, 0x17163207, 0x0c005504, 0x52002807,   // es.it.pt_433 bs.hr.sr_432  rw.sv.un_320 sw.ha.un_420
  // [4540]
  0x0100061a, 0x17041060, 0x1e3f035a, 0x3f00050d,   // de.en.un_760 be.ru.sr_664  nl.af.ms_553 fr.af.un_540
  0x06121b1e, 0x35002919, 0x28002702, 0x210a3bad,   // tr.hu.de_863 sl.zu.un_750  gd.sw.un_220 so.pt.jw_643
  0x19070b60, 0x11033f08, 0x16003507, 0x0805010c,   // es.it.gl_664 af.nl.ro_443  zu.hr.un_420 en.fr.no_543
  0x0107050d, 0x0300280c, 0x0b18070b, 0x08130207,   // fr.it.en_554 sw.nl.un_530  it.ga.es_542 da.et.no_432
  // [4550]
  0x12001b14, 0x0200111b, 0x060c030c, 0x12231804,   // tr.hu.un_660 ro.da.un_770  nl.sv.de_543 ga.ca.hu_332
  0x190b28a4, 0x1b000702, 0x3f001c02, 0x1800060c,   // sw.es.gl_433 it.tr.un_220  id.af.un_220 de.ga.un_530
  0x01352107, 0x23006b08, 0x020428ee, 0x0e000212,   // jw.zu.en_432 ceb.ca.un_430  sw.fi.da_422 da.is.un_640
  0x100f29ec, 0x3f082007, 0x190b1aa9, 0x21132909,   // sl.lv.lt_644 sq.no.af_432  tl.es.gl_544 sl.et.jw_444
  // [4560]
  0x13040c02, 0x10130f0c, 0x321713ee, 0x06040eee,   // sv.fi.et_222 lv.et.lt_543  et.sr.bs_422 is.fi.de_422
  0x07002302, 0x31000b02, 0x0a041702, 0x21050aa9,   // ca.it.un_220 es.az.un_220  sr.ru.mk_222 pt.fr.jw_544
  0x1b0f5302, 0x1652090c, 0x27120e07, 0x293b3202,   // ht.lv.tr_222 pl.ha.hr_543  is.hu.gd_432 bs.so.sl_222
  0x08000619, 0x1c3231a4, 0x055325a0, 0x0e000c0b,   // de.no.un_750 az.bs.id_433  eu.ht.fr_322 sv.is.un_520
  // [4570]
  0x2a102505, 0x04171011, 0x1e1c280c, 0x29001607,   // eu.lt.mt_333 be.sr.ru_653  sw.id.ms_543 hr.sl.un_420
  0x03643b0c, 0x2a000807, 0x08002308, 0x3b006412,   // so.lg.nl_543 no.mt.un_420  ca.no.un_430 lg.so.un_640
  0x11003f13, 0x321716ac, 0x163528a6, 0x271206a4,   // af.ro.un_650 hr.sr.bs_632  sw.zu.hr_521 de.hu.gd_433
  0x043264a0, 0x0900270c, 0x0435280d, 0x55046412,   // lg.bs.fi_322 gd.pl.un_530  sw.zu.fi_554 lg.fi.rw_654
  // [4580]
  0x1727110b, 0x19250b55, 0x3f06080c, 0x3f100c0b,   // ro.gd.sr_542 es.eu.gl_442  no.de.af_543 sv.lt.af_542
  0x28003b13, 0x3f0320a4, 0x521c1eec, 0x32291612,   // so.sw.un_650 sq.nl.af_433  ms.id.ha_644 hr.sl.bs_654
  0x203b520c, 0x100d2d12, 0x21255307, 0x0c031355,   // ha.so.sq_543 sk.cs.lt_654  ht.eu.jw_432 et.nl.sv_442
  0x2d001218, 0x020e08a9, 0x2300070c, 0x0e003118,   // hu.sk.un_740 no.is.da_544  it.ca.un_530 az.is.un_740
  // [4590]
  0x120603a0, 0x233555af, 0x10081713, 0x31001014,   // nl.de.hu_322 rw.zu.ca_655  sr.uk.be_665 lt.az.un_660
  0x18130411, 0x191755ac, 0x11006413, 0x19000721,   // fi.et.ga_653 rw.sr.gl_632  lg.ro.un_650 it.gl.un_860
  0x211c6ea7, 0x320f1707, 0x181e1c0c, 0x0d00530d,   // hmn.id.jw_532 sr.lv.bs_432  id.ms.ga_543 ht.cs.un_540
  0x645511ee, 0x1a046b13, 0x196e0aad, 0x3b0925ad,   // ro.rw.lg_422 ceb.fi.tl_665  pt.hmn.gl_643 eu.pl.so_643
  // [45a0]
  0x251155a4, 0x2a093b12, 0x020108ad, 0x12000318,   // rw.ro.eu_433 so.pl.mt_654  no.en.da_643 nl.hu.un_740
  0x115320a9, 0x04080aa0, 0x23001911, 0x2810640c,   // sq.ht.ro_544 mk.uk.ru_322  gl.ca.un_630 lg.lt.sw_543
  0x0300041b, 0x1c0a6e08, 0x09532aa4, 0x27180a13,   // fi.nl.un_770 hmn.pt.id_443  mt.ht.pl_433 pt.ga.gd_665
  0x0a0401a4, 0x0c085507, 0x0a186ea0, 0x3b090eec,   // en.fi.pt_433 rw.no.sv_432  hmn.ga.pt_322 is.pl.so_644
  // [45b0]
  0x16002a08, 0x073f1111, 0x1c5521a4, 0x0e085511,   // mt.hr.un_430 ro.af.it_653  jw.rw.id_433 rw.no.is_653
  0x4a5568a0, 0x123f030d, 0x06293fa4, 0x55002a0e,   // ig.rw.yo_322 nl.af.hu_554  af.sl.de_433 mt.rw.un_550
  0x1f00231a, 0x29002507, 0x32000305, 0x281a6b12,   // ca.cy.un_760 eu.sl.un_420  nl.bs.un_330 ceb.tl.sw_654
  0x1e230ba9, 0x28000d19, 0x6b190b09, 0x106b280c,   // es.ca.ms_544 cs.sw.un_750  es.gl.ceb_444 sw.ceb.lt_543
  // [45c0]
  0x3b001019, 0x0a2a0709, 0x131a280c, 0x0e191012,   // lt.so.un_750 it.mt.pt_444  sw.tl.et_543 lt.gl.is_654
  0x160f29a9, 0x0f000421, 0x27002312, 0x181b31a7,   // sl.lv.hr_544 fi.lv.un_860  ca.gd.un_640 az.tr.ga_532
  0x25072704, 0x17551304, 0x20033f5a, 0x25000613,   // gd.it.eu_332 et.rw.sr_332  af.nl.sq_553 de.eu.un_650
  0x68003535, 0x27115509, 0x2a0427a0, 0x212a07a0,   // zu.ig.un_A90 rw.ro.gd_444  gd.fi.mt_322 it.mt.jw_322
  // [45d0]
  0x52211aa9, 0x19090aaf, 0x050d1905, 0x2d0d0aa9,   // tl.jw.ha_544 pt.pl.gl_655  gl.cs.fr_333 pt.cs.sk_544
  0x0e2b2808, 0x1e181ca4, 0x031a2107, 0x2809550b,   // sw.vi.is_443 id.ga.ms_433  jw.tl.nl_432 rw.pl.sw_542
  0x10002119, 0x310e0cee, 0x2d0d11a0, 0x32172009,   // jw.lt.un_750 sv.is.az_422  ro.cs.sk_322 sq.sr.bs_444
  0x532305ad, 0x040a17ad, 0x644a52ee, 0x6412230c,   // fr.ca.ht_643 sr.mk.ru_643  ha.yo.lg_422 ca.hu.lg_543
  // [45e0]
  0x3b290f0c, 0x68004a07, 0x3b211a08, 0x01002707,   // lv.sl.so_543 yo.ig.un_420  tl.jw.so_443 gd.en.un_420
  0x6b04010c, 0x0e002b19, 0x05002302, 0x13006e22,   // en.fi.ceb_543 vi.is.un_750  ca.fr.un_220 hmn.et.un_870
  0x08002905, 0x1c532860, 0x1300120d, 0x0f071e05,   // sl.no.un_330 sw.ht.id_664  hu.et.un_540 ms.it.lv_333
  0x21111707, 0x0f312907, 0x52000d0d, 0x2a0b0405,   // sr.ro.jw_432 sl.az.lv_432  cs.ha.un_540 fi.es.mt_333
  // [45f0]
  0x010e08a4, 0x0b64110c, 0x18000909, 0x2a1f1109,   // no.is.en_433 ro.lg.es_543  pl.ga.un_440 ro.cy.mt_444
  0x2d170da4, 0x16073b07, 0x321c1e0c, 0x23002014,   // cs.sr.sk_433 so.it.hr_432  ms.id.bs_543 sq.ca.un_660
  0x3f000207, 0x4a170b07, 0x21001f02, 0x0d004a19,   // da.af.un_420 es.sr.yo_432  cy.jw.un_220 yo.cs.un_750
  0x03001f07, 0x2928040c, 0x12081fad, 0x1f002722,   // cy.nl.un_420 fi.sw.sl_543  cy.no.hu_643 gd.cy.un_870
  // [4600]
  0x032928a7, 0x550368a6, 0x051108af, 0x13000307,   // sw.sl.nl_532 ig.nl.rw_521  no.ro.fr_655 nl.et.un_420
  0x06000c29, 0x311b1220, 0x23000610, 0x291302ee,   // sv.de.un_960 hu.tr.az_875  de.ca.un_620 da.et.sl_422
  0x03043f5a, 0x1f003f14, 0x0c002004, 0x27003b04,   // af.fi.nl_553 af.cy.un_660  sq.sv.un_320 so.gd.un_320
  0x4a00351b, 0x060108a4, 0x3f060f12, 0x03000614,   // zu.yo.un_770 no.en.de_433  lv.de.af_654 de.nl.un_660
  // [4610]
  0x31001702, 0x232a0514, 0x04001a04, 0x01003f09,   // sr.az.un_220 fr.mt.ca_666  tl.fi.un_320 af.en.un_440
  0x52283fa9, 0x1a4a680c, 0x64312808, 0x271819a9,   // af.sw.ha_544 ig.yo.tl_543  sw.az.lg_443 gl.ga.gd_544
  0x326428a6, 0x283b520c, 0x130e0b04, 0x1e1c28ee,   // sw.lg.bs_521 ha.so.sw_543  es.is.et_332 sw.id.ms_422
  0x0764550c, 0x3100061b, 0x3f0f10ad, 0x1e003b0d,   // rw.lg.it_543 de.az.un_770  lt.lv.af_643 so.ms.un_540
  // [4620]
  0x0f2d10af, 0x112d64ad, 0x18190b5a, 0x20071aad,   // lt.sk.lv_655 lg.sk.ro_643  es.gl.ga_553 tl.it.sq_643
  0x190b280c, 0x556b2508, 0x06030204, 0x13551e07,   // sw.es.gl_543 eu.ceb.rw_443  da.nl.de_332 ms.rw.et_432
  0x111b0b02, 0x0e5220ee, 0x1c090d0b, 0x35080208,   // es.tr.ro_222 sq.ha.is_422  ne.hi.mr_542 da.no.zu_443
  0x0d1c090b, 0x4a00281a, 0x180301a6, 0x190b07a4,   // hi.mr.ne_542 sw.yo.un_760  en.nl.ga_521 it.es.gl_433
  // [4630]
  0x20001e02, 0x35091f05, 0x211a6b14, 0x6b001109,   // ms.sq.un_220 cy.pl.zu_333  ceb.tl.jw_666 ro.ceb.un_440
  0x0f3f035a, 0x0c25020c, 0x066b550d, 0x08251108,   // nl.af.lv_553 da.eu.sv_543  rw.ceb.de_554 ro.eu.no_443
  0x130d09a4, 0x3b3f35ad, 0x2d00290b, 0x1b643b5a,   // hi.ne.bh_433 zu.af.so_643  sl.sk.un_520 so.lg.tr_553
  0x021a1213, 0x5525520c, 0x0e2d19af, 0x3b126bad,   // hu.tl.da_665 ha.eu.rw_543  gl.sk.is_655 ceb.hu.so_643
  // [4640]
  0x09002304, 0x523b2a07, 0x09060107, 0x09001121,   // ca.pl.un_320 mt.so.ha_432  en.de.pl_432 ro.pl.un_860
  0x3b3f64af, 0x285355ec, 0x353b1aa4, 0x251203a7,   // lg.af.so_655 rw.ht.sw_644  tl.so.zu_433 nl.hu.eu_532
  0x2801180c, 0x2300531a, 0x1c163bee, 0x0000042d,   // ga.en.sw_543 ht.ca.un_760  so.hr.id_422 ru.un.un_A00
  0x19230ba0, 0x0e003f14, 0x29006b21, 0x110417af,   // es.ca.gl_322 af.is.un_660  ceb.sl.un_860 sr.ru.ro_655
  // [4650]
  0x23001114, 0x1300031a, 0x250a280c, 0x17000702,   // ro.ca.un_660 nl.et.un_760  sw.pt.eu_543 bg.sr.un_220
  0x0c003509, 0x04170802, 0x072305a4, 0x02000d08,   // zu.sv.un_440 uk.sr.ru_222  fr.ca.it_433 cs.da.un_430
  0x2d091f11, 0x04190a13, 0x28011807, 0x11033f0c,   // cy.pl.sk_653 pt.gl.fi_665  ga.en.sw_432 af.nl.ro_543
  0x6b68010c, 0x4a2b0ead, 0x040a08ad, 0x133f0aaf,   // en.ig.ceb_543 is.vi.yo_643  uk.mk.ru_643 pt.af.et_655
  // [4660]
  0x0e000214, 0x2d191008, 0x532d090c, 0x182704ad,   // da.is.un_660 lt.gl.sk_443  pl.sk.ht_543 fi.gd.ga_643
  0x23072004, 0x120c28a4, 0x05000422, 0x0c521b0c,   // sq.it.ca_332 sw.sv.hu_433  fi.fr.un_870 tr.ha.sv_543
  0x04130ca6, 0x3b281aad, 0x283b6412, 0x04170a02,   // sv.et.fi_521 tl.sw.so_643  lg.so.sw_654 mk.sr.ru_222
  0x05033f0c, 0x2010530c, 0x55005212, 0x322852a7,   // af.nl.fr_543 ht.lt.sq_543  ha.rw.un_640 ha.sw.bs_532
  // [4670]
  0x16090dad, 0x68641a11, 0x52003b21, 0x09282d09,   // cs.pl.hr_643 tl.lg.ig_653  so.ha.un_860 sk.sw.pl_444
  0x1a556bad, 0x06005212, 0x3f001819, 0x4a005202,   // ceb.rw.tl_643 ha.de.un_640  ga.af.un_750 ha.yo.un_220
  0x212852ec, 0x35211e0c, 0x533528ad, 0x6b092107,   // ha.sw.jw_644 ms.jw.zu_543  sw.zu.ht_643 jw.pl.ceb_432
  0x07271808, 0x55643513, 0x1a282105, 0x5200101a,   // ga.gd.it_443 zu.lg.rw_665  jw.sw.tl_333 lt.ha.un_760
  // [4680]
  0x25001309, 0x23001f05, 0x0f002808, 0x320e280c,   // et.eu.un_440 cy.ca.un_330  sw.lv.un_430 sw.is.bs_543
  0x35645204, 0x28005533, 0x12001e11, 0x10001321,   // ha.lg.zu_332 rw.sw.un_A70  ms.hu.un_630 et.lt.un_860
  0x10040805, 0x4a6825af, 0x18002307, 0x6e001022,   // uk.ru.be_333 eu.ig.yo_655  ca.ga.un_420 lt.hmn.un_870
  0x21321608, 0x0c1f08a9, 0x190b5505, 0x0a1b2355,   // hr.bs.jw_443 no.cy.sv_544  rw.es.gl_333 ca.tr.pt_442
  // [4690]
  0x210e1fa0, 0x0c2a0208, 0x5528680c, 0x55645213,   // cy.is.jw_322 da.mt.sv_443  ig.sw.rw_543 ha.lg.rw_665
  0x35642755, 0x05000309, 0x2a1e32a0, 0x13680fa4,   // gd.lg.zu_442 nl.fr.un_440  bs.ms.mt_322 lv.ig.et_433
  0x52285508, 0x521e31a7, 0x13002514, 0x286855a4,   // rw.sw.ha_443 az.ms.ha_532  eu.et.un_660 rw.ig.sw_433
  0x2012550c, 0x21003b0b, 0x25006821, 0x522755ee,   // rw.hu.sq_543 so.jw.un_520  ig.eu.un_860 rw.gd.ha_422
  // [46a0]
  0x133564ee, 0x10081705, 0x3b2a0712, 0x2d0d5205,   // lg.zu.et_422 sr.uk.be_333  it.mt.so_654 ha.cs.sk_333
  0x641a550c, 0x11200e0c, 0x075564ad, 0x21000312,   // rw.tl.lg_543 is.sq.ro_543  lg.rw.it_643 nl.jw.un_640
  0x311e55ee, 0x02080c13, 0x213f1355, 0x110805a4,   // rw.ms.az_422 sv.no.da_665  et.af.jw_442 fr.no.ro_433
  0x2a001b13, 0x1a003b1b, 0x230e0c12, 0x2303010c,   // tr.mt.un_650 so.tl.un_770  sv.is.ca_654 en.nl.ca_543
  // [46b0]
  0x1c090d02, 0x1e00250e, 0x04002d04, 0x06020304,   // ne.hi.mr_222 eu.ms.un_550  sk.fi.un_320 nl.da.de_332
  0x28002a0b, 0x17100704, 0x20000c0c, 0x032b0804,   // mt.sw.un_520 bg.be.sr_332  sv.sq.un_530 no.vi.nl_332
  0x0e002304, 0x3b122a02, 0x1a1e0804, 0x321629a0,   // ca.is.un_320 mt.hu.so_222  no.ms.tl_332 sl.hr.bs_322
  0x32170fa4, 0x132a12ad, 0x08000e07, 0x08112bee,   // lv.sr.bs_433 hu.mt.et_643  is.no.un_420 vi.ro.no_422
  // [46c0]
  0x0c104aa7, 0x163168a4, 0x11041005, 0x01001307,   // yo.lt.sv_532 ig.az.hr_433  be.ru.ro_333 et.en.un_420
  0x212d05a7, 0x130f04ec, 0x32552907, 0x64001c02,   // fr.sk.jw_532 fi.lv.et_644  sl.rw.bs_432 id.lg.un_220
  0x012123ee, 0x23311bad, 0x2b000302, 0x64080ca7,   // ca.jw.en_422 tr.az.ca_643  nl.vi.un_220 sv.no.lg_532
  0x1b321608, 0x3b0117a0, 0x100f01a4, 0x082d1f07,   // hr.bs.tr_443 sr.en.so_322  en.lv.lt_433 cy.sk.no_432
  // [46d0]
  0x21251eaf, 0x13351ea4, 0x5500130e, 0x10190a09,   // ms.eu.jw_655 ms.zu.et_433  et.rw.un_550 pt.gl.lt_444
  0x12351bee, 0x070553a4, 0x6400550b, 0x12172004,   // tr.zu.hu_422 ht.fr.it_433  rw.lg.un_520 sq.sr.hu_332
  0x32350607, 0x12205508, 0x12645512, 0x2d172304,   // de.zu.bs_432 rw.sq.hu_443  rw.lg.hu_654 ca.sr.sk_332
  0x211a250c, 0x18002b04, 0x553b2da0, 0x3f001608,   // eu.tl.jw_543 vi.ga.un_320  sk.so.rw_322 hr.af.un_430
  // [46e0]
  0x1213100c, 0x521b3112, 0x1664555a, 0x23120dee,   // lt.et.hu_543 az.tr.ha_654  rw.lg.hr_553 cs.hu.ca_422
  0x01190a0c, 0x4a64550d, 0x1f521aa4, 0x1a525508,   // pt.gl.en_543 rw.lg.yo_554  tl.ha.cy_433 rw.ha.tl_443
  0x523b1e12, 0x2a000919, 0x3264250c, 0x20002102,   // ms.so.ha_654 pl.mt.un_750  eu.lg.bs_543 jw.sq.un_220
  0x64251ba4, 0x25645511, 0x09000c19, 0x29556412,   // tr.eu.lg_433 rw.lg.eu_653  sv.pl.un_750 lg.rw.sl_654
  // [46f0]
  0x08025302, 0x033f10a4, 0x1900130d, 0x0c4a5208,   // ht.da.no_222 lt.af.nl_433  et.gl.un_540 ha.yo.sv_443
  0x2b120608, 0x16645508, 0x09000319, 0x03133f0d,   // de.hu.vi_443 rw.lg.hr_443  nl.pl.un_750 af.et.nl_554
  0x01061f07, 0x5500642c, 0x4a686b07, 0x534a5512,   // cy.de.en_432 lg.rw.un_990  ceb.ig.yo_432 rw.yo.ht_654
  0x1900050b, 0x112955a4, 0x120e2d12, 0x011905a4,   // fr.gl.un_520 rw.sl.ro_433  sk.is.hu_654 fr.gl.en_433
  // [4700]
  0x010a0455, 0x0a3b200c, 0x09001012, 0x25550407,   // fi.pt.en_442 sq.so.pt_543  lt.pl.un_640 fi.rw.eu_432
  0x16041312, 0x13045505, 0x213b1aa7, 0x32002a07,   // et.fi.hr_654 rw.fi.et_333  tl.so.jw_532 mt.bs.un_420
  0x20352107, 0x553513ee, 0x52201312, 0x1c00092c,   // jw.zu.sq_432 et.zu.rw_422  et.sq.ha_654 hi.mr.un_990
  0x531a1255, 0x35125505, 0x103217a6, 0x19520ea4,   // hu.tl.ht_442 rw.hu.zu_333  sr.bs.lt_521 is.ha.gl_433
  // [4710]
  0x35251a05, 0x0a190b11, 0x293203ee, 0x534a52ee,   // tl.eu.zu_333 es.gl.pt_653  nl.bs.sl_422 ha.yo.ht_422
  0x3b211c0d, 0x01040555, 0x07000c0e, 0x3500251a,   // id.jw.so_554 fr.fi.en_442  sv.it.un_550 eu.zu.un_760
  0x17100a11, 0x68641aa4, 0x19230b0b, 0x193b0bee,   // mk.be.sr_653 tl.lg.ig_433  es.ca.gl_542 es.so.gl_422
  0x13005504, 0x1b001902, 0x2004550c, 0x21006404,   // rw.et.un_320 gl.tr.un_220  rw.fi.sq_543 lg.jw.un_320
  // [4720]
  0x1e271813, 0x643529a4, 0x35001314, 0x64191aa0,   // ga.gd.ms_665 sl.zu.lg_433  et.zu.un_660 tl.gl.lg_322
  0x17352904, 0x162d07a0, 0x086420a0, 0x1e0903a4,   // sl.zu.sr_332 it.sk.hr_322  sq.lg.no_322 nl.pl.ms_433
  0x031b53ad, 0x31080205, 0x68001b04, 0x10005204,   // ht.tr.nl_643 da.no.az_333  tr.ig.un_320 ha.lt.un_320
  0x2d0d1aee, 0x291613a7, 0x6b1a3bec, 0x052d0d0d,   // tl.cs.sk_422 et.hr.sl_532  so.tl.ceb_644 cs.sk.fr_554
  // [4730]
  0x123f0c0c, 0x321855a4, 0x35001e04, 0x55290713,   // sv.af.hu_543 rw.ga.bs_433  ms.zu.un_320 it.sl.rw_665
  0x060b2004, 0x29160407, 0x28295507, 0x23190507,   // sq.es.de_332 fi.hr.sl_432  rw.sl.sw_432 fr.gl.ca_432
  0x28642307, 0x0e6b1a02, 0x01000507, 0x2d250a05,   // ca.lg.sw_432 tl.ceb.is_222  fr.en.un_420 pt.eu.sk_333
  0x190b0e05, 0x11001904, 0x08120c05, 0x080e2aec,   // is.es.gl_333 gl.ro.un_320  sv.hu.no_333 mt.is.no_644
  // [4740]
  0x04101713, 0x1b000b05, 0x35006402, 0x55093bee,   // sr.be.ru_665 es.tr.un_330  lg.zu.un_220 so.pl.rw_422
  0x0d292dec, 0x28011fee, 0x2a042da9, 0x2b006b12,   // sk.sl.cs_644 cy.en.sw_422  sk.fi.mt_544 ceb.vi.un_640
  0x321c2aee, 0x1c2b0aac, 0x3f27280c, 0x0b0928a4,   // mt.id.bs_422 pt.vi.id_632  sw.gd.af_543 sw.pl.es_433
  0x2d292aec, 0x6b1a6807, 0x2a2b1a07, 0x27006b08,   // mt.sl.sk_644 ig.tl.ceb_432  tl.vi.mt_432 ceb.gd.un_430
  // [4750]
  0x6b2d07a0, 0x06000e21, 0x25000b04, 0x020c0855,   // it.sk.ceb_322 is.de.un_860  es.eu.un_320 no.sv.da_442
  0x01000602, 0x013f03ad, 0x2d2029ad, 0x2a002b05,   // de.en.un_220 nl.af.en_643  sl.sq.sk_643 vi.mt.un_330
  0x033f4aac, 0x29000f0e, 0x09002d0d, 0x64076802,   // yo.af.nl_632 lv.sl.un_550  sk.pl.un_540 ig.it.lg_222
  0x0d2d290d, 0x20001f1a, 0x64000307, 0x022b0aec,   // sl.sk.cs_554 cy.sq.un_760  nl.lg.un_420 pt.vi.da_644
  // [4760]
  0x0e030ca7, 0x13080260, 0x0a1e0113, 0x012b3bee,   // sv.nl.is_532 da.no.et_664  en.ms.pt_665 so.vi.en_422
  0x0c1009a4, 0x13000d19, 0x016b08a0, 0x3b033f05,   // pl.lt.sv_433 ne.bh.un_750  no.ceb.en_322 af.nl.so_333
  0x290d17a9, 0x07093fa4, 0x3f000e14, 0x022b1207,   // sr.cs.sl_544 af.pl.it_433  is.af.un_660 hu.vi.da_432
  0x27080e04, 0x233101a4, 0x21250e05, 0x181f280c,   // is.no.gd_332 en.az.ca_433  is.eu.jw_333 sw.cy.ga_543
  // [4770]
  0x2d0d28a9, 0x0f351304, 0x031827ec, 0x0f0706a9,   // sw.cs.sk_544 et.zu.lv_332  gd.ga.nl_644 de.it.lv_544
  0x13001907, 0x05275307, 0x6811060c, 0x04191113,   // gl.et.un_420 ht.gd.fr_432  de.ro.ig_543 ro.gl.fi_665
  0x190a05a4, 0x0a051912, 0x641f3504, 0x3f035309,   // fr.pt.gl_433 gl.fr.pt_654  zu.cy.lg_332 ht.nl.af_444
  0x0f2913ee, 0x0c2927a7, 0x032b010c, 0x2d0d06ac,   // et.sl.lv_422 gd.sl.sv_532  en.vi.nl_543 de.cs.sk_632
  // [4780]
  0x060501a4, 0x07111755, 0x05010d09, 0x050d53ad,   // en.fr.de_433 sr.ro.bg_442  cs.en.fr_444 ht.cs.fr_643
  0x6800060d, 0x030928a0, 0x526b1a60, 0x133525a0,   // de.ig.un_540 sw.pl.nl_322  tl.ceb.ha_664 eu.zu.et_322
  0x0d2d1213, 0x0d555209, 0x6b4a350d, 0x25005304,   // hu.sk.cs_665 ha.rw.cs_444  zu.yo.ceb_554 ht.eu.un_320
  0x256b1ca0, 0x0f003b12, 0x291e1c08, 0x1f0135a4,   // id.ceb.eu_322 so.lv.un_640  id.ms.sl_443 zu.en.cy_433
  // [4790]
  0x210f1c09, 0x21551f0c, 0x3b072a11, 0x0b0a01ee,   // id.lv.jw_444 cy.rw.jw_543  mt.it.so_653 en.pt.es_422
  0x2d001211, 0x0a0c3b0b, 0x53006e07, 0x201a280c,   // hu.sk.un_630 so.sv.pt_542  hmn.ht.un_420 sw.tl.sq_543
  0x080206a9, 0x35250ba4, 0x2800270e, 0x31002308,   // de.da.no_544 es.eu.zu_433  gd.sw.un_550 ca.az.un_430
  0x02000513, 0x2a290f12, 0x09006404, 0x073125a9,   // fr.da.un_650 lv.sl.mt_654  lg.pl.un_320 eu.az.it_544
  // [47a0]
  0x281b2007, 0x2168280c, 0x25120107, 0x1b072a5a,   // sq.tr.sw_432 sw.ig.jw_543  en.hu.eu_432 mt.it.tr_553
  0x19052308, 0x3f020312, 0x0a071ca4, 0x10000a02,   // ca.fr.gl_443 nl.da.af_654  id.it.pt_433 mk.be.un_220
  0x17000822, 0x06070413, 0x17101112, 0x0500070e,   // uk.sr.un_870 fi.it.de_665  ro.be.sr_654 it.fr.un_550
  0x17111012, 0x3516280c, 0x2a080e11, 0x033f01af,   // be.ro.sr_654 sw.hr.zu_543  is.no.mt_653 en.af.nl_655
  // [47b0]
  0x1c1353ee, 0x0a2d19a0, 0x1b093bad, 0x64000f19,   // ht.et.id_422 gl.sk.pt_322  so.pl.tr_643 lv.lg.un_750
  0x12001e02, 0x1b2d090c, 0x64356b07, 0x0b0a2305,   // ms.hu.un_220 pl.sk.tr_543  ceb.zu.lg_432 ca.pt.es_333
  0x6b003505, 0x046b130c, 0x0c1e3511, 0x4a5535ad,   // zu.ceb.un_330 et.ceb.fi_543  zu.ms.sv_653 zu.rw.yo_643
  0x0d092da0, 0x1c0d1ea0, 0x211e1b07, 0x55352804,   // sk.pl.cs_322 ms.cs.id_322  tr.ms.jw_432 sw.zu.rw_332
  // [47c0]
  0x04000711, 0x55316407, 0x322b12ad, 0x0c235507,   // bg.ru.un_630 lg.az.rw_432  hu.vi.bs_643 rw.ca.sv_432
  0x32290fa4, 0x1900120b, 0x093b5213, 0x046b1a0c,   // lv.sl.bs_433 hu.gl.un_520  ha.so.pl_665 tl.ceb.fi_543
  0x1f00180d, 0x526b090c, 0x4a2135ec, 0x35002707,   // ga.cy.un_540 pl.ceb.ha_543  zu.jw.yo_644 gd.zu.un_420
  0x211b53ee, 0x3b001c04, 0x0f2305a4, 0x05000c1a,   // ht.tr.jw_422 id.so.un_320  fr.ca.lv_433 sv.fr.un_760
  // [47d0]
  0x2b001c09, 0x171007af, 0x182729ad, 0x2a531c0c,   // id.vi.un_440 bg.be.sr_655  sl.gd.ga_643 id.ht.mt_543
  0x171104a4, 0x1c006b0d, 0x08000f12, 0x2d100d05,   // ru.ro.sr_433 ceb.id.un_540  lv.no.un_640 cs.lt.sk_333
  0x320f2308, 0x11002905, 0x023f08a6, 0x292d1607,   // ca.lv.bs_443 sl.ro.un_330  no.af.da_521 hr.sk.sl_432
  0x290f1f12, 0x64000305, 0x35131a09, 0x1e1c27a0,   // cy.lv.sl_654 nl.lg.un_330  tl.et.zu_444 gd.id.ms_322
  // [47e0]
  0x233f2aee, 0x230f05a4, 0x20121fec, 0x230105a4,   // mt.af.ca_422 fr.lv.ca_433  cy.hu.sq_644 fr.en.ca_433
  0x0f1035ac, 0x1b3f060c, 0x19211c0c, 0x25005514,   // zu.lt.lv_632 de.af.tr_543  id.jw.gl_543 rw.eu.un_660
  0x23000b1b, 0x17001f0c, 0x1b000d04, 0x1b3113ad,   // es.ca.un_770 cy.sr.un_530  cs.tr.un_320 et.az.tr_643
  0x13001e20, 0x0c6b08a4, 0x0e10250c, 0x2800350e,   // ms.et.un_850 no.ceb.sv_433  eu.lt.is_543 zu.sw.un_550
  // [47f0]
  0x5300281b, 0x5335090c, 0x0b23190d, 0x0e0b02ad,   // sw.ht.un_770 pl.zu.ht_543  gl.ca.es_554 da.es.is_643
  0x11100da0, 0x0f002522, 0x2d091aaf, 0x52002504,   // cs.lt.ro_322 eu.lv.un_870  tl.pl.sk_655 eu.ha.un_320
  0x55641b04, 0x07101705, 0x0f1008a0, 0x232d0704,   // tr.lg.rw_332 sr.be.bg_333  no.lt.lv_322 it.sk.ca_332
  0x093f06a4, 0x2b00350c, 0x55004a0d, 0x11000707,   // de.af.pl_433 zu.vi.un_530  yo.rw.un_540 it.ro.un_420

  // [4800]
  0x1a1b1f0c, 0x3f2b2107, 0x2500131a, 0x020c0a0c,   // cy.tr.tl_543 jw.vi.af_432  et.eu.un_760 pt.sv.da_543
  0x1f001e22, 0x042853af, 0x100f130c, 0x102518ad,   // ms.cy.un_870 ht.sw.fi_655  et.lv.lt_543 ga.eu.lt_643
  0x096b3bee, 0x121a05ad, 0x080203ee, 0x6b181aee,   // so.ceb.pl_422 fr.tl.hu_643  nl.da.no_422 tl.ga.ceb_422
  0x11270555, 0x521e25ad, 0x295310a4, 0x1f002522,   // fr.gd.ro_442 eu.ms.ha_643  lt.ht.sl_433 eu.cy.un_870
  // [4810]
  0x190f2512, 0x06041207, 0x080e2b02, 0x20251a13,   // eu.lv.gl_654 hu.fi.de_432  vi.is.no_222 tl.eu.sq_665
  0x3b000411, 0x20352813, 0x270f04a0, 0x681f0faf,   // fi.so.un_630 sw.zu.sq_665  fi.lv.gd_322 lv.cy.ig_655
  0x1c002a04, 0x122005ad, 0x1f04180d, 0x0a0804af,   // mt.id.un_320 fr.sq.hu_643  ga.fi.cy_554 ru.uk.mk_655
  0x3b003202, 0x203b5555, 0x12310513, 0x6b1a2105,   // bs.so.un_220 rw.so.sq_442  fr.az.hu_665 jw.tl.ceb_333
  // [4820]
  0x52002021, 0x09002b14, 0x2000552a, 0x131c0960,   // sq.ha.un_860 vi.pl.un_660  rw.sq.un_970 hi.mr.bh_664
  0x321729a0, 0x13000902, 0x033f0e55, 0x6b2128ee,   // sl.sr.bs_322 hi.bh.un_220  is.af.nl_442 sw.jw.ceb_422
  0x202852ec, 0x1104085a, 0x23002b1a, 0x0c000b02,   // ha.sw.sq_644 uk.ru.ro_553  vi.ca.un_760 es.sv.un_220
  0x2a001a0c, 0x20132311, 0x2500351a, 0x550f050b,   // tl.mt.un_530 ca.et.sq_653  zu.eu.un_760 fr.lv.rw_542
  // [4830]
  0x080207ee, 0x2d1029a4, 0x0107030c, 0x2a000e12,   // it.da.no_422 sl.lt.sk_433  nl.it.en_543 is.mt.un_640
  0x3521280c, 0x08003b2c, 0x643b52af, 0x04351313,   // sw.jw.zu_543 so.no.un_990  ha.so.lg_655 et.zu.fi_665
  0x05032308, 0x201f27af, 0x28002133, 0x17000b08,   // ca.nl.fr_443 gd.cy.sq_655  jw.sw.un_A70 es.sr.un_430
  0x32001a07, 0x0604180c, 0x1a0507a4, 0x4a000a12,   // tl.bs.un_420 ga.fi.de_543  it.fr.tl_433 pt.yo.un_640
  // [4840]
  0x100f0c11, 0x0c0e0405, 0x03181c02, 0x316452ad,   // sv.lv.lt_653 fi.is.sv_333  id.ga.nl_222 ha.lg.az_643
  0x1205010c, 0x0a08110c, 0x06200705, 0x070e1fa4,   // en.fr.hu_543 ro.uk.mk_543  it.sq.de_333 cy.is.it_433
  0x20005313, 0x190a1fa9, 0x07001f0e, 0x3255520c,   // ht.sq.un_650 cy.pt.gl_544  cy.it.un_550 ha.rw.bs_543
  0x01003204, 0x0a006b07, 0x16205507, 0x210a1ba0,   // bs.en.un_320 ceb.pt.un_420  rw.sq.hr_432 tr.pt.jw_322
  // [4850]
  0x13001f07, 0x2a001222, 0x13040aa0, 0x1b03060c,   // cy.et.un_420 hu.mt.un_870  pt.fi.et_322 de.nl.tr_543
  0x06001c02, 0x0a190b0b, 0x052307ee, 0x17291e05,   // id.de.un_220 es.gl.pt_542  it.ca.fr_422 ms.sl.sr_333
  0x5200352c, 0x06006b0e, 0x1000061b, 0x29001613,   // zu.ha.un_990 ceb.de.un_550  de.lt.un_770 hr.sl.un_650
  0x641c2113, 0x1c091310, 0x2b6b01ee, 0x212027ee,   // jw.id.lg_665 bh.hi.mr_642  en.ceb.vi_422 gd.sq.jw_422
  // [4860]
  0x3f2301ad, 0x17001608, 0x082701ad, 0x271f1808,   // en.ca.af_643 hr.sr.un_430  en.gd.no_643 ga.cy.gd_443
  0x01076b08, 0x0c522155, 0x253f3b11, 0x136804ee,   // ceb.it.en_443 jw.ha.sv_442  so.af.eu_653 fi.ig.et_422
  0x03041ea4, 0x04000322, 0x045210a7, 0x1a1364ee,   // ms.fi.nl_433 nl.fi.un_870  lt.ha.fi_532 lg.et.tl_422
  0x0e1806ad, 0x4a351308, 0x19170b55, 0x64003b0c,   // de.ga.is_643 et.zu.yo_443  es.sr.gl_442 so.lg.un_530
  // [4870]
  0x32291605, 0x0e6b1a5a, 0x10000a23, 0x1c3b1ea0,   // hr.sl.bs_333 tl.ceb.is_553  mk.be.un_880 ms.so.id_322
  0x1a64115a, 0x08354aad, 0x1e1a110c, 0x0d001008,   // ro.lg.tl_553 yo.zu.no_643  ro.tl.ms_543 lt.cs.un_430
  0x025208a0, 0x290d17a4, 0x6b1a110c, 0x3f1b21ad,   // no.ha.da_322 sr.cs.sl_433  ro.tl.ceb_543 jw.tr.af_643
  0x1b000312, 0x6b1a350d, 0x1c2111a7, 0x211c35ee,   // nl.tr.un_640 zu.tl.ceb_554  ro.jw.id_532 zu.id.jw_422
  // [4880]
  0x6b112108, 0x25002802, 0x11006419, 0x111a640c,   // jw.ro.ceb_443 sw.eu.un_220  lg.ro.un_750 lg.tl.ro_543
  0x13044aa4, 0x0e6421a9, 0x643b280e, 0x046864af,   // yo.fi.et_433 jw.lg.is_544  sw.so.lg_555 lg.ig.fi_655
  0x3125110c, 0x1b3f030c, 0x1a0b6b04, 0x311135a4,   // ro.eu.az_543 nl.af.tr_543  ceb.es.tl_332 zu.ro.az_433
  0x1c006e08, 0x03130604, 0x25005504, 0x08021ca0,   // hmn.id.un_430 de.et.nl_332  rw.eu.un_320 id.da.no_322
  // [4890]
  0x201b0e09, 0x311b1112, 0x111e520d, 0x11002504,   // is.tr.sq_444 ro.tr.az_654  ha.ms.ro_554 eu.ro.un_320
  0x28070605, 0x03001705, 0x2506130c, 0x0a0208a4,   // de.it.sw_333 sr.nl.un_330  et.de.eu_543 no.da.pt_433
  0x52002012, 0x64000104, 0x0f002a07, 0x06232511,   // sq.ha.un_640 en.lg.un_320  mt.lv.un_420 eu.ca.de_653
  0x08320c07, 0x030a2560, 0x1c1b0ea4, 0x64550b08,   // sv.bs.no_432 eu.pt.nl_664  is.tr.id_433 es.rw.lg_443
  // [48a0]
  0x0000192d, 0x1a004a0c, 0x1b2a25a0, 0x200208a4,   // gl.un.un_A00 yo.tl.un_530  eu.mt.tr_322 no.da.sq_433
  0x6b061fa7, 0x063f6413, 0x0b681805, 0x2a002807,   // cy.de.ceb_532 lg.af.de_665  ga.ig.es_333 sw.mt.un_420
  0x201205af, 0x551a6b0c, 0x2d0d0b14, 0x6452210c,   // fr.hu.sq_655 ceb.tl.rw_543  es.cs.sk_666 jw.ha.lg_543
  0x130520ad, 0x3f0123a7, 0x085507a0, 0x03160ea0,   // sq.fr.et_643 ca.en.af_532  it.rw.no_322 is.hr.nl_322
  // [48b0]
  0x16170dad, 0x0e270813, 0x0b2d0d14, 0x01006407,   // cs.sr.hr_643 no.gd.is_665  cs.sk.es_666 lg.en.un_420
  0x13004a02, 0x030805a0, 0x1a201e07, 0x13002005,   // yo.et.un_220 fr.no.nl_322  ms.sq.tl_432 sq.et.un_330
  0x3f2111a7, 0x35132811, 0x08250e04, 0x68005219,   // ro.jw.af_532 sw.et.zu_653  is.eu.no_332 ha.ig.un_750
  0x0c552812, 0x1f353f12, 0x105525af, 0x1a316b09,   // sw.rw.sv_654 af.zu.cy_654  eu.rw.lt_655 ceb.az.tl_444
  // [48c0]
  0x68100f07, 0x2507130c, 0x256b290c, 0x0b000718,   // lv.lt.ig_432 et.it.eu_543  sl.ceb.eu_543 it.es.un_740
  0x07286b08, 0x25106ba4, 0x06211e12, 0x0600210e,   // ceb.sw.it_443 ceb.lt.eu_433  ms.jw.de_654 jw.de.un_550
  0x08006b04, 0x2b210612, 0x4a0b20af, 0x09532da4,   // ceb.no.un_320 de.jw.vi_654  sq.es.yo_655 sk.ht.pl_433
  0x25002813, 0x32040f05, 0x2a04100c, 0x532a6ba0,   // sw.eu.un_650 lv.fi.bs_333  lt.fi.mt_543 ceb.mt.ht_322
  // [48d0]
  0x530f0405, 0x13256bac, 0x13042a0d, 0x0e00201b,   // fi.lv.ht_333 ceb.eu.et_632  mt.fi.et_554 sq.is.un_770
  0x1e0425ad, 0x0f2853a4, 0x52002123, 0x1f000307,   // eu.fi.ms_643 ht.sw.lv_433  jw.ha.un_880 nl.cy.un_420
  0x310c02ad, 0x321653ee, 0x1c121ea0, 0x080229ec,   // da.sv.az_643 ht.hr.bs_422  ms.hu.id_322 sl.da.no_644
  0x061c21ad, 0x2100060c, 0x2100060e, 0x1c351e08,   // jw.id.de_643 de.jw.un_530  de.jw.un_550 ms.zu.id_443
  // [48e0]
  0x1e211cad, 0x55001a09, 0x3b3513ee, 0x530304ad,   // id.jw.ms_643 tl.rw.un_440  et.zu.so_422 fi.nl.ht_643
  0x04523bad, 0x10032aaf, 0x250f4aa4, 0x1e002102,   // so.ha.fi_643 mt.nl.lt_655  yo.lv.eu_433 jw.ms.un_220
  0x1f00090d, 0x0b6b4aee, 0x17162da4, 0x0d001614,   // pl.cy.un_540 yo.ceb.es_422  sk.hr.sr_433 hr.cs.un_660
  0x2b182d07, 0x3b12350c, 0x02001e02, 0x11001907,   // sk.ga.vi_432 zu.hu.so_543  ms.da.un_220 gl.ro.un_420
  // [48f0]
  0x2d0d32a9, 0x21093ba0, 0x12002b0c, 0x6b6831ad,   // bs.cs.sk_544 so.pl.jw_322  vi.hu.un_530 az.ig.ceb_643
  0x1104530c, 0x0e06035a, 0x31250fa9, 0x10040a0d,   // ht.fi.ro_543 nl.de.is_553  lv.eu.az_544 mk.ru.be_554
  0x4a0b28a4, 0x190b11af, 0x2d0d0b0e, 0x08004a07,   // sw.es.yo_433 ro.es.gl_655  es.cs.sk_555 yo.no.un_420
  0x0f00031a, 0x526b25ee, 0x12003f19, 0x02285514,   // nl.lv.un_760 eu.ceb.ha_422  af.hu.un_750 rw.sw.da_666
  // [4900]
  0x09291fa4, 0x25004a13, 0x080210a0, 0x026b08a9,   // cy.sl.pl_433 yo.eu.un_650  lt.da.no_322 no.ceb.da_544
  0x07186e02, 0x1a6b0e07, 0x0223110c, 0x1108100c,   // hmn.ga.it_222 is.ceb.tl_432  ro.ca.da_543 be.uk.ro_543
  0x0f102a13, 0x1800110c, 0x55041aee, 0x0f000621,   // mt.lt.lv_665 ro.ga.un_530  tl.fi.rw_422 de.lv.un_860
  0x08071713, 0x041711ec, 0x4a042a0c, 0x231807ad,   // sr.bg.uk_665 ro.sr.ru_644  mt.fi.yo_543 it.ga.ca_643
  // [4910]
  0x0b000919, 0x180a2304, 0x19530b07, 0x0c0108a0,   // pl.es.un_750 ca.pt.ga_332  es.ht.gl_432 no.en.sv_322
  0x55530708, 0x110c68ee, 0x6b2504ad, 0x5200251b,   // it.ht.rw_443 ig.sv.ro_422  fi.eu.ceb_643 eu.ha.un_770
  0x051101a4, 0x062a08a4, 0x07000f1a, 0x23132513,   // en.ro.fr_433 no.mt.de_433  lv.it.un_760 eu.et.ca_665
  0x25002009, 0x09001c2a, 0x08130e09, 0x03126e07,   // sq.eu.un_440 mr.hi.un_970  is.et.no_444 hmn.hu.nl_432
  // [4920]
  0x0405250d, 0x1218050c, 0x0f1a040c, 0x0c052305,   // eu.fr.fi_554 fr.ga.hu_543  fi.tl.lv_543 ca.fr.sv_333
  0x04286b0d, 0x1a012aad, 0x04000608, 0x0d0b18a4,   // ceb.sw.fi_554 mt.en.tl_643  de.fi.un_430 ga.es.cs_433
  0x1119520c, 0x02000b05, 0x3f002a0d, 0x0e002b13,   // ha.gl.ro_543 es.da.un_330  mt.af.un_540 vi.is.un_650
  0x061152a4, 0x2a120ca4, 0x29182302, 0x00001924,   // ha.ro.de_433 sv.hu.mt_433  ca.ga.sl_222 gl.un.un_900
  // [4930]
  0x083f100b, 0x110f1305, 0x061308a4, 0x0f0603a0,   // lt.af.no_542 et.lv.ro_333  no.et.de_433 nl.de.lv_322
  0x110e04ee, 0x0552280d, 0x120e180e, 0x521e28a4,   // fi.is.ro_422 sw.ha.fr_554  ga.is.hu_555 sw.ms.ha_433
  0x0511230c, 0x4a12180c, 0x032852a0, 0x1c100f0c,   // ca.ro.fr_543 ga.hu.yo_543  ha.sw.nl_322 lv.lt.id_543
  0x02110e0c, 0x05000e29, 0x0e121808, 0x0a680704,   // is.ro.da_543 is.fr.un_960  ga.hu.is_443 it.ig.pt_332
  // [4940]
  0x12041302, 0x20005208, 0x054a5312, 0x0a3553ad,   // et.fi.hu_222 ha.sq.un_430  ht.yo.fr_654 ht.zu.pt_643
  0x07110413, 0x313555ad, 0x53054a0c, 0x190b1009,   // ru.ro.bg_665 rw.zu.az_643  yo.fr.ht_543 lt.es.gl_444
  0x0a001308, 0x12002904, 0x292d0f0c, 0x1118010c,   // et.pt.un_430 sl.hu.un_320  lv.sk.sl_543 en.ga.ro_543
  0x1e251cad, 0x0d00092a, 0x08040ca4, 0x0c0e13ac,   // id.eu.ms_643 hi.ne.un_970  sv.fi.no_433 et.is.sv_632
  // [4950]
  0x13006e07, 0x0f001702, 0x356407a4, 0x11201eee,   // hmn.et.un_420 sr.lv.un_220  it.lg.zu_433 ms.sq.ro_422
  0x12002807, 0x1b00130c, 0x1100100c, 0x07350408,   // sw.hu.un_420 et.tr.un_530  lt.ro.un_530 fi.zu.it_443
  0x2a190b05, 0x21002013, 0x0b1912ac, 0x190a0702,   // es.gl.mt_333 sq.jw.un_650  hu.gl.es_632 it.pt.gl_222
  0x06001214, 0x131220a4, 0x12285508, 0x32160d14,   // hu.de.un_660 sq.hu.et_433  rw.sw.hu_443 cs.hr.bs_666
  // [4960]
  0x12001f0e, 0x53002913, 0x55311aa4, 0x3b002102,   // cy.hu.un_550 sl.ht.un_650  tl.az.rw_433 jw.so.un_220
  0x0300060e, 0x0308010c, 0x29160ca6, 0x1b002302,   // de.nl.un_550 en.no.nl_543  sv.hr.sl_521 ca.tr.un_220
  0x08020605, 0x063f03ad, 0x130c1012, 0x35002d08,   // de.da.no_333 nl.af.de_643  lt.sv.et_654 sk.zu.un_430
  0x0c00132a, 0x042813ec, 0x0c3f1f5a, 0x06020508,   // et.sv.un_970 et.sw.fi_644  cy.af.sv_553 fr.da.de_443
  // [4970]
  0x13091c11, 0x12132aa0, 0x2b011b5a, 0x536431ad,   // mr.hi.bh_653 mt.et.hu_322  tr.en.vi_553 az.lg.ht_643
  0x11100f05, 0x19003b02, 0x0217080c, 0x2a554a07,   // lv.lt.ro_333 so.gl.un_220  no.sr.da_543 yo.rw.mt_432
  0x100e020c, 0x050601a7, 0x216468a4, 0x1b3106ec,   // da.is.lt_543 en.de.fr_532  ig.lg.jw_433 de.az.tr_644
  0x64211c05, 0x2d0d1e02, 0x10000e21, 0x101c1ea6,   // id.jw.lg_333 ms.cs.sk_222  is.lt.un_860 ms.id.lt_521
  // [4980]
  0x040f21a4, 0x120f1304, 0x0802310c, 0x0c5204a9,   // jw.lv.fi_433 et.lv.hu_332  az.da.no_543 fi.ha.sv_544
  0x050b070d, 0x07530413, 0x1f1108a4, 0x07170a02,   // it.es.fr_554 fi.ht.it_665  no.ro.cy_433 mk.sr.bg_222
  0x1a002d1a, 0x201b130d, 0x530802a9, 0x0e063560,   // sk.tl.un_760 et.tr.sq_554  da.no.ht_544 zu.de.is_664
  0x641b5208, 0x17001133, 0x273b180c, 0x0e1227a9,   // ha.tr.lg_443 ro.sr.un_A70  ga.so.gd_543 gd.hu.is_544
  // [4990]
  0x3b041112, 0x1f00110c, 0x3b1b2109, 0x52002802,   // ro.fi.so_654 ro.cy.un_530  jw.tr.so_444 sw.ha.un_220
  0x1f002304, 0x53520413, 0x08352812, 0x28356460,   // ca.cy.un_320 fi.ha.ht_665  sw.zu.no_654 lg.zu.sw_664
  0x19122dec, 0x212a1a04, 0x04181f08, 0x3b1b250c,   // sk.hu.gl_644 tl.mt.jw_332  cy.ga.fi_443 eu.tr.so_543
  0x21003b2a, 0x53042108, 0x0c0e2aa7, 0x25000707,   // so.jw.un_970 jw.fi.ht_443  mt.is.sv_532 it.eu.un_420
  // [49a0]
  0x641a280c, 0x100a170c, 0x3f002113, 0x290e2d0c,   // sw.tl.lg_543 sr.mk.be_543  jw.af.un_650 sk.is.sl_543
  0x08022905, 0x1e1f52a4, 0x131018a4, 0x072a550c,   // sl.da.no_333 ha.cy.ms_433  ga.lt.et_433 rw.mt.it_543
  0x64552aaf, 0x27190a08, 0x3b046802, 0x2d29020e,   // mt.rw.lg_655 pt.gl.gd_443  ig.fi.so_222 da.sl.sk_555
  0x2a00060c, 0x06250f13, 0x4a0455a6, 0x55641a08,   // de.mt.un_530 lv.eu.de_665  rw.fi.yo_521 tl.lg.rw_443
  // [49b0]
  0x190b0509, 0x16001a0c, 0x5528130b, 0x2d0d0eaf,   // fr.es.gl_444 tl.hr.un_530  et.sw.rw_542 is.cs.sk_655
  0x2a3531ec, 0x1a311baf, 0x0e000311, 0x271835af,   // az.zu.mt_644 tr.az.tl_655  nl.is.un_630 zu.ga.gd_655
  0x0e292d13, 0x320f17a4, 0x120e0aa4, 0x17041111,   // sk.sl.is_665 sr.lv.bs_433  pt.is.hu_433 ro.ru.sr_653
  0x1200092b, 0x28063505, 0x3f0c1fee, 0x125364a0,   // pl.hu.un_980 zu.de.sw_333  cy.sv.af_422 lg.ht.hu_322
  // [49c0]
  0x131b1207, 0x25521a0c, 0x043f4aad, 0x3f2503af,   // hu.tr.et_432 tl.ha.eu_543  yo.af.fi_643 nl.eu.af_655
  0x3b122011, 0x20000521, 0x111e1c09, 0x0f293ba4,   // sq.hu.so_653 fr.sq.un_860  id.ms.ro_444 so.sl.lv_433
  0x160f55a4, 0x081113ad, 0x05005212, 0x53070560,   // rw.lv.hr_433 et.ro.no_643  ha.fr.un_640 fr.it.ht_664
  0x350e130c, 0x0f00290c, 0x16293ba4, 0x0a001319,   // et.is.zu_543 sl.lv.un_530  so.sl.hr_433 et.pt.un_750
  // [49d0]
  0x0b1819a4, 0x2300110d, 0x5202310b, 0x11202313,   // gl.ga.es_433 ro.ca.un_540  az.da.ha_542 ca.sq.ro_665
  0x0802040c, 0x321655a4, 0x102a1e0b, 0x07002304,   // fi.da.no_543 rw.hr.bs_433  ms.mt.lt_542 ca.it.un_320
  0x23002a04, 0x101716ac, 0x11000919, 0x2900550c,   // mt.ca.un_320 hr.sr.lt_632  pl.ro.un_750 rw.sl.un_530
  0x0f092905, 0x061a09a7, 0x282535a7, 0x2011010c,   // sl.pl.lv_333 pl.tl.de_532  zu.eu.sw_532 en.ro.sq_543
  // [49e0]
  0x131104ec, 0x0813680c, 0x2d0d04af, 0x17110460,   // fi.ro.et_644 ig.et.no_543  fi.cs.sk_655 ru.ro.sr_664
  0x6425130c, 0x64092aad, 0x0e520813, 0x110f0404,   // et.eu.lg_543 mt.pl.lg_643  no.ha.is_665 fi.lv.ro_332
  0x20112313, 0x1e005307, 0x321753ee, 0x64095511,   // ca.ro.sq_665 ht.ms.un_420  ht.sr.bs_422 rw.pl.lg_653
  0x1e1c28a4, 0x25315307, 0x18000308, 0x19004a04,   // sw.id.ms_433 ht.az.eu_432  nl.ga.un_430 yo.gl.un_320
  // [49f0]
  0x1c201eec, 0x2d0d1c05, 0x68190a13, 0x1a2a53af,   // ms.sq.id_644 id.cs.sk_333  pt.gl.ig_665 ht.mt.tl_655
  0x19110b08, 0x014a03a0, 0x1e52280c, 0x014a08a4,   // es.ro.gl_443 nl.yo.en_322  sw.ha.ms_543 no.yo.en_433
  0x0e0825ee, 0x082b0ea4, 0x103228a4, 0x0327180c,   // eu.no.is_422 is.vi.no_433  sw.bs.lt_433 ga.gd.nl_543
  0x08005204, 0x0b000507, 0x27033f05, 0x31201ba4,   // ha.no.un_320 fr.es.un_420  af.nl.gd_333 tr.sq.az_433
  // [4a00]
  0x27185214, 0x201e52ad, 0x20002302, 0x35003b14,   // ha.ga.gd_666 ha.ms.sq_643  ca.sq.un_220 so.zu.un_660
  0x640c080c, 0x52001b09, 0x130401a9, 0x32001618,   // no.sv.lg_543 tr.ha.un_440  en.fi.et_544 hr.bs.un_740
  0x55033f60, 0x4a001214, 0x53002802, 0x070f110e,   // af.nl.rw_664 hu.yo.un_660  sw.ht.un_220 ro.lv.it_555
  0x2d0d4a0c, 0x12313f07, 0x07030fee, 0x04102104,   // yo.cs.sk_543 af.az.hu_432  lv.nl.it_422 jw.lt.fi_332
  // [4a10]
  0x21000707, 0x6b55280c, 0x122903a0, 0x131e1c0c,   // it.jw.un_420 sw.rw.ceb_543  nl.sl.hu_322 id.ms.et_543
  0x080252a0, 0x09003f04, 0x1c5523a4, 0x08020da9,   // ha.da.no_322 af.pl.un_320  ca.rw.id_433 cs.da.no_544
  0x2700071b, 0x251a01af, 0x5200070e, 0x272118a0,   // it.gd.un_770 en.tl.eu_655  it.ha.un_550 ga.jw.gd_322
  0x18001223, 0x0b11235a, 0x12003b13, 0x52000712,   // ur.ar.un_880 ca.ro.es_553  so.hu.un_650 it.ha.un_640
  // [4a20]
  0x1a003b05, 0x060c20a4, 0x2025115a, 0x230c0e12,   // so.tl.un_330 sq.sv.de_433  ro.eu.sq_553 is.sv.ca_654
  0x210b190c, 0x3b001919, 0x550921ec, 0x0425230c,   // gl.es.jw_543 gl.so.un_750  jw.pl.rw_644 ca.eu.fi_543
  0x27185207, 0x23040aa0, 0x08064a08, 0x25000104,   // ha.ga.gd_432 pt.fi.ca_322  yo.de.no_443 en.eu.un_320
  0x3f051312, 0x2a280707, 0x28040aa4, 0x041329ee,   // et.fr.af_654 it.sw.mt_432  pt.fi.sw_433 sl.et.fi_422
  // [4a30]
  0x18002702, 0x522a07a7, 0x2a0609ad, 0x2d001f08,   // gd.ga.un_220 it.mt.ha_532  pl.de.mt_643 cy.sk.un_430
  0x0e004a08, 0x35686b12, 0x29000b09, 0x3f092a12,   // yo.is.un_430 ceb.ig.zu_654  es.sl.un_440 mt.pl.af_654
  0x17110a0e, 0x640107ee, 0x29006429, 0x092a3f12,   // mk.ro.sr_555 it.en.lg_422  lg.sl.un_960 af.mt.pl_654
  0x09006804, 0x3f31100c, 0x033f6412, 0x05033f08,   // ig.pl.un_320 lt.az.af_543  lg.af.nl_654 af.nl.fr_443
  // [4a40]
  0x4a3568ec, 0x102a07a0, 0x08040aa6, 0x12041aad,   // ig.zu.yo_644 it.mt.lt_322  mk.ru.uk_521 tl.fi.hu_643
  0x53211ca4, 0x0f131bad, 0x136b11ad, 0x04281a0c,   // id.jw.ht_433 tr.et.lv_643  ro.ceb.et_643 tl.sw.fi_543
  0x2b004a19, 0x18010ca7, 0x1e002813, 0x1c132107,   // yo.vi.un_750 sv.en.ga_532  sw.ms.un_650 jw.et.id_432
  0x3500010d, 0x09001329, 0x3f003504, 0x12000422,   // en.zu.un_540 bh.hi.un_960  zu.af.un_320 fi.hu.un_870
  // [4a50]
  0x0a640702, 0x0f102a0e, 0x07001712, 0x161b1a08,   // it.lg.pt_222 mt.lt.lv_555  sr.bg.un_640 tl.tr.hr_443
  0x08020302, 0x13282507, 0x11170a13, 0x041a1ea4,   // nl.da.no_222 eu.sw.et_432  mk.sr.ro_665 ms.tl.fi_433
  0x0a00040e, 0x286825ee, 0x130425ee, 0x1f001912,   // ru.mk.un_550 eu.ig.sw_422  eu.fi.et_422 gl.cy.un_640
  0x02133b05, 0x01082a07, 0x19230ba9, 0x04006b2a,   // so.et.da_333 mt.no.en_432  es.ca.gl_544 ceb.fi.un_970
  // [4a60]
  0x19001216, 0x3f10040c, 0x04000735, 0x170911a4,   // hu.gl.un_720 fi.lt.af_543  bg.ru.un_A90 ro.pl.sr_433
  0x1f353f02, 0x0d092dee, 0x3b005302, 0x17250d0c,   // af.zu.cy_222 sk.pl.cs_422  ht.so.un_220 cs.eu.sr_543
  0x315235a6, 0x190b2304, 0x0e000705, 0x270e08a7,   // zu.ha.az_521 ca.es.gl_332  it.is.un_330 no.is.gd_532
  0x0700250d, 0x3b062bee, 0x19005304, 0x03643f05,   // eu.it.un_540 vi.de.so_422  ht.gl.un_320 af.lg.nl_333
  // [4a70]
  0x03023f5a, 0x28130460, 0x0a002a12, 0x1c00350d,   // af.da.nl_553 fi.et.sw_664  mt.pt.un_640 zu.id.un_540
  0x2d0d3bee, 0x3b1a3513, 0x1a00350c, 0x0a002a0d,   // so.cs.sk_422 zu.tl.so_665  zu.tl.un_530 mt.pt.un_540
  0x283b3560, 0x050235ee, 0x17080208, 0x18010502,   // zu.so.sw_664 zu.da.fr_422  da.no.sr_443 fr.en.ga_222
  0x182007af, 0x0c131e07, 0x0b001819, 0x311711ec,   // it.sq.ga_655 ms.et.sv_432  ga.es.un_750 ro.sr.az_644
  // [4a80]
  0x11003b1e, 0x645235a4, 0x3b005520, 0x08003f0e,   // so.ro.un_830 zu.ha.lg_433  rw.so.un_850 af.no.un_550
  0x06013505, 0x03002504, 0x321c2508, 0x0b2319a7,   // zu.en.de_333 eu.nl.un_320  eu.id.bs_443 gl.ca.es_532
  0x3f3110ec, 0x2d0d120c, 0x522520a6, 0x2a190709,   // lt.az.af_644 hu.cs.sk_543  sq.eu.ha_521 it.gl.mt_444
  0x1a6b3b07, 0x0f003209, 0x3b351ca0, 0x013f06a4,   // so.ceb.tl_432 bs.lv.un_440  id.zu.so_322 de.af.en_433
  // [4a90]
  0x0f04050c, 0x18001c02, 0x190b0a0d, 0x2809070b,   // fr.fi.lv_543 id.ga.un_220  pt.es.gl_554 it.pl.sw_542
  0x0b000513, 0x190b055a, 0x0b005304, 0x08003f1b,   // fr.es.un_650 fr.es.gl_553  ht.es.un_320 af.no.un_770
  0x3f000f19, 0x17160fee, 0x073b6404, 0x041a2107,   // lv.af.un_750 lv.hr.sr_422  lg.so.it_332 jw.tl.fi_432
  0x0e002012, 0x311003a7, 0x011853a0, 0x09006818,   // sq.is.un_640 nl.lt.az_532  ht.ga.en_322 ig.pl.un_740
  // [4aa0]
  0x0e326405, 0x55000a08, 0x2b1f0755, 0x090f04a9,   // lg.bs.is_333 pt.rw.un_430  it.cy.vi_442 fi.lv.pl_544
  0x06040f14, 0x03065504, 0x12001902, 0x07100f12,   // lv.fi.de_666 rw.de.nl_332  gl.hu.un_220 lv.lt.it_654
  0x130e0f0c, 0x190b25a4, 0x3f2a0bad, 0x0f2d1007,   // lv.is.et_543 eu.es.gl_433  es.mt.af_643 lt.sk.lv_432
  0x3f000f04, 0x033f25ec, 0x060e08a4, 0x310418a4,   // lv.af.un_320 eu.af.nl_644  no.is.de_433 ga.fi.az_433
  // [4ab0]
  0x6400030d, 0x133f3ba0, 0x0e04090c, 0x190d35ec,   // nl.lg.un_540 so.af.et_322  pl.fi.is_543 zu.cs.gl_644
  0x040f52ad, 0x0c0f03a4, 0x101c0404, 0x27282008,   // ha.lv.fi_643 nl.lv.sv_433  fi.id.lt_332 sq.sw.gd_443
  0x35053f07, 0x32002708, 0x3b061908, 0x193555ec,   // af.fr.zu_432 gd.bs.un_430  gl.de.so_443 rw.zu.gl_644
  0x0e3b2708, 0x09182705, 0x2928550c, 0x113b10ec,   // gd.so.is_443 gd.ga.pl_333  rw.sw.sl_543 lt.so.ro_644
  // [4ac0]
  0x0f096ba6, 0x55086ba4, 0x18000720, 0x03000611,   // ceb.pl.lv_521 ceb.no.rw_433  it.ga.un_850 de.nl.un_630
  0x0a180709, 0x18271c07, 0x162d32a0, 0x07182708,   // it.ga.pt_444 id.gd.ga_432  bs.sk.hr_322 gd.ga.it_443
  0x4a176407, 0x10170413, 0x64190b08, 0x091e1cad,   // lg.sr.yo_432 ru.sr.be_665  es.gl.lg_443 id.ms.pl_643
  0x213b0911, 0x0a271055, 0x190b2805, 0x162953a4,   // pl.so.jw_653 lt.gd.pt_442  sw.es.gl_333 ht.sl.hr_433
  // [4ad0]
  0x18192708, 0x6400071a, 0x2800271b, 0x1b002829,   // gd.gl.ga_443 it.lg.un_760  gd.sw.un_770 sw.tr.un_960
  0x112855af, 0x070511ac, 0x1c521e0c, 0x053f5505,   // rw.sw.ro_655 ro.fr.it_632  ms.ha.id_543 rw.af.fr_333
  0x230e0bee, 0x0f1a09a7, 0x2021520c, 0x07230608,   // es.is.ca_422 pl.tl.lv_532  ha.jw.sq_543 de.ca.it_443
  0x07000120, 0x0a170814, 0x644a5312, 0x52001122,   // en.it.un_850 uk.sr.mk_666  ht.yo.lg_654 ro.ha.un_870
  // [4ae0]
  0x0c0a11a4, 0x32281bee, 0x524a1aa7, 0x1e010c02,   // ro.pt.sv_433 tr.sw.bs_422  tl.yo.ha_532 sv.en.ms_222
  0x0700102b, 0x0e002d08, 0x03002102, 0x2a030605,   // be.bg.un_980 sk.is.un_430  jw.nl.un_220 de.nl.mt_333
  0x0e005204, 0x23072a08, 0x0f080ea7, 0x1f0b1a07,   // ha.is.un_320 mt.it.ca_443  is.no.lv_532 tl.es.cy_432
  0x100a07a6, 0x21231ca0, 0x25091b07, 0x19100ba0,   // it.pt.lt_521 id.ca.jw_322  tr.pl.eu_432 es.lt.gl_322
  // [4af0]
  0x3b0e0b04, 0x0d0e2da4, 0x0d0e0ba0, 0x170752ee,   // es.is.so_332 sk.is.cs_433  es.is.cs_322 ha.it.sr_422
  0x271223ee, 0x52005314, 0x20190b08, 0x20001807,   // ca.hu.gd_422 ht.ha.un_660  es.gl.sq_443 ga.sq.un_420
  0x070b3104, 0x2d0d2a02, 0x19120b12, 0x200c1a08,   // az.es.it_332 mt.cs.sk_222  es.hu.gl_654 tl.sv.sq_443
  0x122152ee, 0x0b0a2da7, 0x080e1212, 0x080402a4,   // ha.jw.hu_422 sk.pt.es_532  hu.is.no_654 da.fi.no_433
  // [4b00]
  0x21035207, 0x0a086405, 0x25200b07, 0x105207ac,   // ha.nl.jw_432 lg.no.pt_333  es.sq.eu_432 it.ha.lt_632
  0x0717100b, 0x3b202811, 0x55002102, 0x28553ba0,   // be.sr.bg_542 sw.sq.so_653  jw.rw.un_220 so.rw.sw_322
  0x0e000405, 0x0b030e55, 0x190c0bad, 0x28000c07,   // fi.is.un_330 is.nl.es_442  es.sv.gl_643 sv.sw.un_420
  0x17282d07, 0x310f2504, 0x093f0aa7, 0x2000290c,   // sk.sw.sr_432 eu.lv.az_332  pt.af.pl_532 sl.sq.un_530
  // [4b10]
  0x1b042a12, 0x062a35a4, 0x551b520c, 0x07000a20,   // mt.fi.tr_654 zu.mt.de_433  ha.tr.rw_543 mk.bg.un_850
  0x6400250d, 0x0413680d, 0x25000b14, 0x01031fa7,   // eu.lg.un_540 ig.et.fi_554  es.eu.un_660 cy.nl.en_532
  0x0725555a, 0x28000313, 0x55642513, 0x64555204,   // rw.eu.it_553 nl.sw.un_650  eu.lg.rw_665 ha.rw.lg_332
  0x200c08ee, 0x07005214, 0x1c11310c, 0x0d002904,   // no.sv.sq_422 ha.it.un_660  az.ro.id_543 sl.cs.un_320
  // [4b20]
  0x0f004a07, 0x3f1352ee, 0x64255512, 0x1f052308,   // yo.lv.un_420 ha.et.af_422  rw.eu.lg_654 ca.fr.cy_443
  0x3f076407, 0x16002a04, 0x55250da4, 0x532a07a4,   // lg.it.af_432 mt.hr.un_320  cs.eu.rw_433 it.mt.ht_433
  0x283b68ac, 0x1b1029ec, 0x23192512, 0x1703110c,   // ig.so.sw_632 sl.lt.tr_644  eu.gl.ca_654 ro.nl.sr_543
  0x280a6808, 0x554a64af, 0x525528ad, 0x0c64550d,   // ig.pt.sw_443 lg.yo.rw_655  sw.rw.ha_643 rw.lg.sv_554
  // [4b30]
  0x2a090ba0, 0x01051307, 0x0a180e04, 0x13090d08,   // es.pl.mt_322 et.fr.en_432  is.ga.pt_332 ne.hi.bh_443
  0x2d3b0d0c, 0x6b3b5512, 0x160d32a7, 0x2868010c,   // cs.so.sk_543 rw.so.ceb_654  bs.cs.hr_532 en.ig.sw_543
  0x27001e04, 0x55041308, 0x0e002804, 0x02355212,   // ms.gd.un_320 et.fi.rw_443  sw.is.un_320 ha.zu.da_654
  0x09681fa0, 0x2100200b, 0x1b3525a0, 0x16001f04,   // cy.ig.pl_322 sq.jw.un_520  eu.zu.tr_322 cy.hr.un_320
  // [4b40]
  0x55006412, 0x01081fa0, 0x2a0712ec, 0x270907a0,   // lg.rw.un_640 cy.no.en_322  hu.it.mt_644 it.pl.gd_322
  0x11053509, 0x27351807, 0x1b00280b, 0x10000a1a,   // zu.fr.ro_444 ga.zu.gd_432  sw.tr.un_520 mk.be.un_760
  0x12080ea4, 0x23043504, 0x020b0a05, 0x3f3508a4,   // is.no.hu_433 zu.fi.ca_332  pt.es.da_333 no.zu.af_433
  0x0b0813a9, 0x0a0c5211, 0x0f02290c, 0x0c1f0ea7,   // et.no.es_544 ha.sv.pt_653  sl.da.lv_543 is.cy.sv_532
  // [4b50]
  0x551a6412, 0x2d0d10a9, 0x293517ee, 0x6b551b08,   // lg.tl.rw_654 lt.cs.sk_544  sr.zu.sl_422 tr.rw.ceb_443
  0x0b2d05a4, 0x2a052107, 0x55282aa4, 0x0713110c,   // fr.sk.es_433 jw.fr.mt_432  mt.sw.rw_433 ro.et.it_543
  0x2013110c, 0x11122112, 0x6431550c, 0x110f29a4,   // ro.et.sq_543 jw.hu.ro_654  rw.az.lg_543 sl.lv.ro_433
  0x130223a7, 0x55641ca0, 0x52213ba4, 0x0e03250c,   // ca.da.et_532 id.lg.rw_322  so.jw.ha_433 eu.nl.is_543
  // [4b60]
  0x17000707, 0x0f00130c, 0x1b1325a9, 0x120e08a4,   // it.sr.un_420 et.lv.un_530  eu.et.tr_544 no.is.hu_433
  0x29081ba7, 0x10001b04, 0x231121a4, 0x3500070d,   // tr.no.sl_532 tr.lt.un_320  jw.ro.ca_433 it.zu.un_540
  0x031b2512, 0x04100a5a, 0x101b20ec, 0x01251804,   // eu.tr.nl_654 mk.be.ru_553  sq.tr.lt_644 ga.eu.en_332
  0x29071705, 0x05132a07, 0x1e061213, 0x25031b09,   // sr.it.sl_333 mt.et.fr_432  hu.de.ms_665 tr.nl.eu_444
  // [4b70]
  0x530602a0, 0x2a002d08, 0x3f0103ee, 0x1c0f3512,   // da.de.ht_322 sk.mt.un_430  nl.en.af_422 zu.lv.id_654
  0x0d001114, 0x20001b21, 0x090e100c, 0x18002a04,   // ro.cs.un_660 tr.sq.un_860  lt.is.pl_543 mt.ga.un_320
  0x04003504, 0x521f3baf, 0x11281360, 0x030e1b04,   // zu.fi.un_320 so.cy.ha_655  et.sw.ro_664 tr.is.nl_332
  0x1900060b, 0x270b23a4, 0x2d0d180c, 0x25232aaf,   // de.gl.un_520 ca.es.gd_433  ga.cs.sk_543 mt.ca.eu_655
  // [4b80]
  0x1a122104, 0x18012aad, 0x1c0853ee, 0x1f180f5a,   // jw.hu.tl_332 mt.en.ga_643  ht.no.id_422 lv.ga.cy_553
  0x21002019, 0x0e18270d, 0x02003202, 0x1c282107,   // sq.jw.un_750 gd.ga.is_554  bs.da.un_220 jw.sw.id_432
  0x07006b21, 0x162935ee, 0x0b0a2314, 0x111b310d,   // ceb.it.un_860 zu.sl.hr_422  ca.pt.es_666 az.tr.ro_554
  0x286b52a0, 0x04110805, 0x323b21ad, 0x18190a09,   // ha.ceb.sw_322 uk.ro.ru_333  jw.so.bs_643 pt.gl.ga_444
  // [4b90]
  0x35001605, 0x2a5220ac, 0x1e5528ee, 0x1a6b1b60,   // hr.zu.un_330 sq.ha.mt_632  sw.rw.ms_422 tr.ceb.tl_664
  0x041306ad, 0x06001902, 0x131a2012, 0x033b3f0c,   // de.et.fi_643 gl.de.un_220  sq.tl.et_654 af.so.nl_543
  0x116b64ee, 0x08000723, 0x23190da0, 0x0e001904,   // lg.ceb.ro_422 bg.uk.un_880  cs.gl.ca_322 gl.is.un_320
  0x2d00120c, 0x0c006b04, 0x1225270d, 0x1800351a,   // hu.sk.un_530 ceb.sv.un_320  gd.eu.hu_554 zu.ga.un_760
  // [4ba0]
  0x0308350c, 0x2835185a, 0x32082aa0, 0x1a550455,   // zu.no.nl_543 ga.zu.sw_553  mt.no.bs_322 fi.rw.tl_442
  0x35001819, 0x2b000808, 0x1e1c020e, 0x182827af,   // ga.zu.un_750 no.vi.un_430  da.id.ms_555 gd.sw.ga_655
  0x291617a9, 0x0d006b07, 0x31646ba0, 0x321716ec,   // sr.hr.sl_544 ceb.cs.un_420  ceb.lg.az_322 hr.sr.bs_644
  0x05004a12, 0x28001e13, 0x28642107, 0x21283b0c,   // yo.fr.un_640 ms.sw.un_650  jw.lg.sw_432 so.sw.jw_543
  // [4bb0]
  0x64040b02, 0x0e0c210d, 0x18352155, 0x233511ad,   // es.fi.lg_222 jw.sv.is_554  jw.zu.ga_442 ro.zu.ca_643
  0x685564a9, 0x64215508, 0x2a006e08, 0x271e1cac,   // lg.rw.ig_544 rw.jw.lg_443  hmn.mt.un_430 id.ms.gd_632
  0x033f3105, 0x0d1029a4, 0x29171614, 0x02001f21,   // az.af.nl_333 sl.lt.cs_433  hr.sr.sl_666 cy.da.un_860
  0x18003521, 0x10001e0c, 0x2d004a07, 0x01000802,   // zu.ga.un_860 ms.lt.un_530  yo.sk.un_420 no.en.un_220
  // [4bc0]
  0x2b000122, 0x356b1f0b, 0x1c1e2112, 0x2a002705,   // en.vi.un_870 cy.ceb.zu_542  jw.ms.id_654 gd.mt.un_330
  0x131228a4, 0x19230b0c, 0x1f3568a0, 0x4a271ba4,   // sw.hu.et_433 es.ca.gl_543  ig.zu.cy_322 tr.gd.yo_433
  0x0c1f3b0e, 0x071c05a0, 0x190a2509, 0x1c27200c,   // so.cy.sv_555 fr.id.it_322  eu.pt.gl_444 sq.gd.id_543
  0x11053f0c, 0x03006404, 0x0b122305, 0x3b232104,   // af.fr.ro_543 lg.nl.un_320  ca.hu.es_333 jw.ca.so_332
  // [4bd0]
  0x23001205, 0x0e081309, 0x190b20ee, 0x056b0c08,   // hu.ca.un_330 et.no.is_444  sq.es.gl_422 sv.ceb.fr_443
  0x04136807, 0x646813a7, 0x6b2a070c, 0x18000305,   // ig.et.fi_432 et.ig.lg_532  it.mt.ceb_543 nl.ga.un_330
  0x190a2307, 0x3f036411, 0x180135a7, 0x23132807,   // ca.pt.gl_432 lg.nl.af_653  zu.en.ga_532 sw.et.ca_432
  0x05110309, 0x64134a5a, 0x28072a0c, 0x04212804,   // nl.ro.fr_444 yo.et.lg_553  mt.it.sw_543 sw.jw.fi_332
  // [4be0]
  0x1c003202, 0x113128a4, 0x0e6455ec, 0x06001104,   // bs.id.un_220 sw.az.ro_433  rw.lg.is_644 ro.de.un_320
  0x171632ac, 0x06012007, 0x352a2012, 0x6b0105a0,   // bs.hr.sr_632 sq.en.de_432  sq.mt.zu_654 fr.en.ceb_322
  0x6e1b53a9, 0x3f000913, 0x55001f02, 0x190b0505,   // ht.tr.hmn_544 pl.af.un_650  cy.rw.un_220 fr.es.gl_333
  0x28686412, 0x645328ec, 0x21016ba0, 0x080c12a4,   // lg.ig.sw_654 sw.ht.lg_644  ceb.en.jw_322 hu.sv.no_433
  // [4bf0]
  0x27000104, 0x072028ee, 0x2a00351a, 0x35181c07,   // en.gd.un_320 sw.sq.it_422  zu.mt.un_760 id.ga.zu_432
  0x09000413, 0x3f6b5507, 0x070a64ad, 0x28000b02,   // fi.pl.un_650 rw.ceb.af_432  lg.pt.it_643 es.sw.un_220
  0x0f290707, 0x13001a04, 0x06190bec, 0x350968a9,   // it.sl.lv_432 tl.et.un_320  es.gl.de_644 ig.pl.zu_544
  0x17000a02, 0x112123a4, 0x2a07180c, 0x022825a4,   // mk.sr.un_220 ca.jw.ro_433  ga.it.mt_543 eu.sw.da_433

  // [4c00]
  0x0c0e3fee, 0x02005305, 0x1a640914, 0x102313a9,   // af.is.sv_422 ht.da.un_330  pl.lg.tl_666 et.ca.lt_544
  0x3f1053ec, 0x1b000305, 0x521e0f13, 0x03073fa9,   // ht.lt.af_644 nl.tr.un_330  lv.ms.ha_665 af.it.nl_544
  0x1a5568a0, 0x0d1c09ac, 0x190b0aa6, 0x0a000507,   // ig.rw.tl_322 hi.mr.ne_632  pt.es.gl_521 fr.pt.un_420
  0x0a0810ad, 0x53102509, 0x55005221, 0x311b55a9,   // be.uk.mk_643 eu.lt.ht_444  ha.rw.un_860 rw.tr.az_544
  // [4c10]
  0x082a25ad, 0x0e001f22, 0x29080ca4, 0x3f27100b,   // eu.mt.no_643 cy.is.un_870  sv.no.sl_433 lt.gd.af_542
  0x4a001a12, 0x04532507, 0x0a004a05, 0x281225af,   // tl.yo.un_640 eu.ht.fi_432  yo.pt.un_330 eu.hu.sw_655
  0x0c060404, 0x28006423, 0x25006422, 0x100f2508,   // fi.de.sv_332 lg.sw.un_880  lg.eu.un_870 eu.lv.lt_443
  0x3b2a6812, 0x231b3ba4, 0x11310d07, 0x201b6e08,   // ig.mt.so_654 so.tr.ca_433  cs.az.ro_432 hmn.tr.sq_443
  // [4c20]
  0x08311804, 0x10286413, 0x1b293102, 0x08020a09,   // ga.az.no_332 lg.sw.lt_665  az.sl.tr_222 pt.da.no_444
  0x32251f08, 0x52064a08, 0x08252707, 0x1f3105a4,   // cy.eu.bs_443 yo.de.ha_443  gd.eu.no_432 fr.az.cy_433
  0x3f021bad, 0x1c642809, 0x2a1f05ec, 0x1f002104,   // tr.da.af_643 sw.lg.id_444  fr.cy.mt_644 jw.cy.un_320
  0x01550507, 0x1b07350c, 0x111335ec, 0x1e251ba4,   // fr.rw.en_432 zu.it.tr_543  zu.et.ro_644 tr.eu.ms_433
  // [4c30]
  0x090d2da9, 0x521f645a, 0x13351108, 0x10000619,   // sk.cs.pl_544 lg.cy.ha_553  ro.zu.et_443 de.lt.un_750
  0x3b080260, 0x1700082c, 0x28271808, 0x13000409,   // da.no.so_664 uk.sr.un_990  ga.gd.sw_443 fi.et.un_440
  0x171608a0, 0x32133508, 0x12000212, 0x08000a09,   // no.hr.sr_322 zu.et.bs_443  da.hu.un_640 mk.uk.un_440
  0x210b1ca4, 0x2818010c, 0x283564a4, 0x35070508,   // id.es.jw_433 en.ga.sw_543  lg.zu.sw_433 fr.it.zu_443
  // [4c40]
  0x13000314, 0x1f010611, 0x555364a7, 0x05002b0c,   // nl.et.un_660 de.en.cy_653  lg.ht.rw_532 vi.fr.un_530
  0x531135a4, 0x1a643bee, 0x01002302, 0x13003507,   // zu.ro.ht_433 so.lg.tl_422  ca.en.un_220 zu.et.un_420
  0x130711a4, 0x11005207, 0x101e250c, 0x130711ec,   // ro.it.et_433 ha.ro.un_420  eu.ms.lt_543 ro.it.et_644
  0x114a3508, 0x0d003202, 0x28005302, 0x2500290d,   // zu.yo.ro_443 bs.cs.un_220  ht.sw.un_220 sl.eu.un_540
  // [4c50]
  0x55001c04, 0x13031a14, 0x1a133b60, 0x08060c09,   // id.rw.un_320 tl.nl.et_666  so.et.tl_664 sv.de.no_444
  0x0a080460, 0x6b133b04, 0x130e08a9, 0x3b2a25a9,   // ru.uk.mk_664 so.et.ceb_332  no.is.et_544 eu.mt.so_544
  0x03642502, 0x211c2a05, 0x1a6b35a4, 0x19206408,   // eu.lg.nl_222 mt.id.jw_333  zu.ceb.tl_433 lg.sq.gl_443
  0x13091ca4, 0x063153a4, 0x2b250cad, 0x20321ba0,   // mr.hi.bh_433 ht.az.de_433  sv.eu.vi_643 tr.bs.sq_322
  // [4c60]
  0x1f101ea9, 0x190b06ba, 0x0b0a2302, 0x044a550c,   // ms.lt.cy_544 de.es.gl_843  ca.pt.es_222 rw.yo.fi_543
  0x25000813, 0x68005322, 0x100a1108, 0x351355a7,   // no.eu.un_650 ht.ig.un_870  ro.mk.be_443 rw.et.zu_532
  0x1f001018, 0x18272b5a, 0x3b2720ec, 0x0710080c,   // lt.cy.un_740 vi.gd.ga_553  sq.gd.so_644 uk.be.bg_543
  0x31000e13, 0x13110ca0, 0x311b4aa7, 0x13086eec,   // is.az.un_650 sv.ro.et_322  yo.tr.az_532 hmn.no.et_644
  // [4c70]
  0x05001704, 0x20002a02, 0x10001f1b, 0x27185204,   // sr.fr.un_320 mt.sq.un_220  cy.lt.un_770 ha.ga.gd_332
  0x3f201ca0, 0x10001f21, 0x050a1fa0, 0x234a0b02,   // id.sq.af_322 cy.lt.un_860  cy.pt.fr_322 es.yo.ca_222
  0x0a005305, 0x6b000120, 0x1f00182c, 0x28002312,   // ht.pt.un_330 en.ceb.un_850  ga.cy.un_990 ca.sw.un_640
  0x1812270c, 0x64251307, 0x3b110407, 0x0e522105,   // gd.hu.ga_543 et.eu.lg_432  fi.ro.so_432 jw.ha.is_333
  // [4c80]
  0x0c120207, 0x0f120eee, 0x25001f08, 0x251b520c,   // da.hu.sv_432 is.hu.lv_422  cy.eu.un_430 ha.tr.eu_543
  0x0c000307, 0x1e231fa0, 0x28001f07, 0x05351308,   // nl.sv.un_420 cy.ca.ms_322  cy.sw.un_420 et.zu.fr_443
  0x6b554a55, 0x04130d0c, 0x251b13ec, 0x3b640707,   // yo.rw.ceb_442 cs.et.fi_543  et.tr.eu_644 it.lg.so_432
  0x324a3504, 0x13040a0c, 0x4a000520, 0x28006818,   // zu.yo.bs_332 pt.fi.et_543  fr.yo.un_850 ig.sw.un_740
  // [4c90]
  0x13114aa0, 0x284a55a4, 0x27011807, 0x18310812,   // yo.ro.et_322 rw.yo.sw_433  ga.en.gd_432 no.az.ga_654
  0x2b030508, 0x31200f05, 0x2a00551a, 0x135568a0,   // fr.nl.vi_443 lv.sq.az_333  rw.mt.un_760 ig.rw.et_322
  0x01003b09, 0x01131ba4, 0x25000508, 0x640f5512,   // so.en.un_440 tr.et.en_433  fr.eu.un_430 rw.lv.lg_654
  0x2a180604, 0x6b520c07, 0x01000b05, 0x033555af,   // de.ga.mt_332 sv.ha.ceb_432  es.en.un_330 rw.zu.nl_655
  // [4ca0]
  0x352528ee, 0x18001f20, 0x061c0502, 0x32000612,   // sw.eu.zu_422 cy.ga.un_850  fr.id.de_222 de.bs.un_640
  0x55002a1a, 0x3b211aec, 0x2a0764ec, 0x35000d13,   // mt.rw.un_760 tl.jw.so_644  lg.it.mt_644 cs.zu.un_650
  0x3b205208, 0x211c3104, 0x1c0921ee, 0x1e120607,   // ha.sq.so_443 az.id.jw_332  jw.pl.id_422 de.hu.ms_432
  0x2100251b, 0x205511a4, 0x2a00111b, 0x291c1a0c,   // eu.jw.un_770 ro.rw.sq_433  ro.mt.un_770 tl.id.sl_543
  // [4cb0]
  0x1a2a11ec, 0x35040805, 0x28551b0d, 0x20525508,   // ro.mt.tl_644 no.fi.zu_333  tr.rw.sw_554 rw.ha.sq_443
  0x1c111ea4, 0x52112a08, 0x213b5508, 0x3b531808,   // ms.ro.id_433 mt.ro.ha_443  rw.so.jw_443 ga.ht.so_443
  0x1a0b3b09, 0x55011fee, 0x28521108, 0x205211a4,   // so.es.tl_444 cy.en.rw_422  ro.ha.sw_443 ro.ha.sq_433
  0x010b0a09, 0x01313bee, 0x55281108, 0x20213b0c,   // pt.es.en_444 so.az.en_422  ro.sw.rw_443 so.jw.sq_543
  // [4cc0]
  0x0e000702, 0x31211b0c, 0x16202912, 0x2a000307,   // it.is.un_220 tr.jw.az_543  sl.sq.hr_654 nl.mt.un_420
  0x17005221, 0x106b1a0d, 0x551128ad, 0x250668ee,   // ha.sr.un_860 tl.ceb.lt_554  sw.ro.rw_643 ig.de.eu_422
  0x25001108, 0x04112aa4, 0x1c6b1e0c, 0x102a1160,   // ro.eu.un_430 mt.ro.fi_433  ms.ceb.id_543 ro.mt.lt_664
  0x640a3505, 0x03002307, 0x201a110c, 0x041a110c,   // zu.pt.lg_333 ca.nl.un_420  ro.tl.sq_543 ro.tl.fi_543
  // [4cd0]
  0x3b003122, 0x021008a4, 0x55682107, 0x0e1729ac,   // az.so.un_870 no.lt.da_433  jw.ig.rw_432 sl.sr.is_632
  0x3f32290c, 0x1c231107, 0x10020f13, 0x16351aad,   // sl.bs.af_543 ro.ca.id_432  lv.da.lt_665 tl.zu.hr_643
  0x172007a9, 0x026b3f07, 0x1e1c1309, 0x23530560,   // it.sq.sr_544 af.ceb.da_432  et.id.ms_444 fr.ht.ca_664
  0x0e290f0c, 0x230e3f04, 0x29001e21, 0x0e006419,   // lv.sl.is_543 af.is.ca_332  ms.sl.un_860 lg.is.un_750
  // [4ce0]
  0x0a230c04, 0x23290bee, 0x182027ad, 0x28135213,   // sv.ca.pt_332 es.sl.ca_422  gd.sq.ga_643 ha.et.sw_665
  0x23005305, 0x07002504, 0x3b001e13, 0x120364ee,   // ht.ca.un_330 eu.it.un_320  ms.so.un_650 lg.nl.hu_422
  0x1b0a4a60, 0x523b0b55, 0x13001602, 0x32003105,   // yo.pt.tr_664 es.so.ha_442  hr.et.un_220 az.bs.un_330
  0x3568640c, 0x64001f02, 0x0a00640c, 0x01002d04,   // lg.ig.zu_543 cy.lg.un_220  lg.pt.un_530 sk.en.un_320
  // [4cf0]
  0x08021b02, 0x3b041309, 0x171321ad, 0x2a0918ee,   // tr.da.no_222 et.fi.so_444  jw.et.sr_643 ga.pl.mt_422
  0x07170405, 0x12005204, 0x0f001323, 0x18051108,   // ru.sr.bg_333 ha.hu.un_320  et.lv.un_880 ro.fr.ga_443
  0x190b27a0, 0x1e04640c, 0x06001008, 0x211c4aad,   // gd.es.gl_322 lg.fi.ms_543  lt.de.un_430 yo.id.jw_643
  0x100407ec, 0x322129a0, 0x5300680c, 0x121a27a7,   // bg.ru.be_644 sl.jw.bs_322  ig.ht.un_530 gd.tl.hu_532
  // [4d00]
  0x352168a9, 0x2b00180c, 0x07000114, 0x550a1bee,   // ig.jw.zu_544 ga.vi.un_530  en.it.un_660 tr.pt.rw_422
  0x2d3b1ea6, 0x0d001a04, 0x3b1f1e05, 0x55000d08,   // ms.so.sk_521 tl.cs.un_320  ms.cy.so_333 cs.rw.un_430
  0x0501110c, 0x64001f19, 0x181127af, 0x252023a0,   // ro.en.fr_543 cy.lg.un_750  gd.ro.ga_655 ca.sq.eu_322
  0x1c1e3f0c, 0x6423350d, 0x25556808, 0x122952a6,   // af.ms.id_543 zu.ca.lg_554  ig.rw.eu_443 ha.sl.hu_521
  // [4d10]
  0x06002704, 0x0b1f5208, 0x285255a0, 0x55020812,   // gd.de.un_320 ha.cy.es_443  rw.ha.sw_322 no.da.rw_654
  0x0455280d, 0x3f001e07, 0x1728290d, 0x0d003520,   // sw.rw.fi_554 ms.af.un_420  sl.sw.sr_554 zu.cs.un_850
  0x3f000d04, 0x01681b0d, 0x042111a4, 0x10270408,   // cs.af.un_320 tr.ig.en_554  ro.jw.fi_433 fi.gd.lt_443
  0x11282009, 0x13525513, 0x2a0955a7, 0x041c550c,   // sq.sw.ro_444 rw.ha.et_665  rw.pl.mt_532 rw.id.fi_543
  // [4d20]
  0x646b550c, 0x02045208, 0x3555280c, 0x080255ee,   // rw.ceb.lg_543 ha.fi.da_443  sw.rw.zu_543 rw.da.no_422
  0x523b21a4, 0x31113bec, 0x190b35ad, 0x17551e0d,   // jw.so.ha_433 so.ro.az_644  zu.es.gl_643 ms.rw.sr_554
  0x080205a4, 0x553f1f07, 0x070408ac, 0x13210c05,   // fr.da.no_433 cy.af.rw_432  uk.ru.bg_632 sv.jw.et_333
  0x190a23a4, 0x100c08af, 0x0821350c, 0x29072aee,   // ca.pt.gl_433 no.sv.lt_655  zu.jw.no_543 mt.it.sl_422
  // [4d30]
  0x1113350c, 0x1812210b, 0x190b1aee, 0x25350308,   // zu.et.ro_543 fa.ur.ar_542  tl.es.gl_422 nl.zu.eu_443
  0x2d521aee, 0x291705ad, 0x0c2925a9, 0x64001902,   // tl.ha.sk_422 fr.sr.sl_643  eu.sl.sv_544 gl.lg.un_220
  0x551a2812, 0x1a641c0c, 0x11351fee, 0x28016405,   // sw.tl.rw_654 id.lg.tl_543  cy.zu.ro_422 lg.en.sw_333
  0x6b1a2814, 0x35003b0d, 0x0f0c08af, 0x3b1052a9,   // sw.tl.ceb_666 so.zu.un_540  no.sv.lv_655 ha.lt.so_544
  // [4d40]
  0x09352513, 0x1a3b5212, 0x1e1c2155, 0x0a072d05,   // eu.zu.pl_665 ha.so.tl_654  jw.id.ms_442 sk.it.pt_333
  0x293525a9, 0x190b55ec, 0x35645509, 0x170a2d07,   // eu.zu.sl_544 rw.es.gl_644  rw.lg.zu_444 sk.pt.sr_432
  0x0c0f040c, 0x19003b19, 0x0a3b190c, 0x0e1f0c0d,   // fi.lv.sv_543 so.gl.un_750  gl.so.pt_543 sv.cy.is_554
  0x082a07a7, 0x1c351ea4, 0x28321613, 0x21006e0d,   // it.mt.no_532 ms.zu.id_433  hr.bs.sw_665 hmn.jw.un_540
  // [4d50]
  0x1b64350d, 0x31000a19, 0x020c08a9, 0x3b281e0c,   // zu.lg.tr_554 pt.az.un_750  no.sv.da_544 ms.sw.so_543
  0x17003512, 0x0a0b190b, 0x6b184a11, 0x321729af,   // zu.sr.un_640 gl.es.pt_542  yo.ga.ceb_653 sl.sr.bs_655
  0x083f0c0c, 0x084a6b02, 0x20000807, 0x35000b04,   // sv.af.no_543 ceb.yo.no_222  no.sq.un_420 es.zu.un_320
  0x050b0a04, 0x0d000221, 0x3f0d11ee, 0x012523ad,   // pt.es.fr_332 da.cs.un_860  ro.cs.af_422 ca.eu.en_643
  // [4d60]
  0x35002818, 0x130c010b, 0x28310b05, 0x3b012aee,   // sw.zu.un_740 en.sv.et_542  es.az.sw_333 mt.en.so_422
  0x2a3b11ad, 0x010309a6, 0x11350502, 0x121311ec,   // ro.so.mt_643 pl.nl.en_521  fr.zu.ro_222 ro.et.hu_644
  0x0500271b, 0x1f312308, 0x05200107, 0x52270c12,   // gd.fr.un_770 ca.az.cy_443  en.sq.fr_432 sv.gd.ha_654
  0x10131108, 0x1e005202, 0x00001b06, 0x286b35a0,   // ro.et.lt_443 ha.ms.un_220  tr.un.un_400 zu.ceb.sw_322
  // [4d70]
  0x1053680d, 0x35520eee, 0x1e0413a0, 0x68086b0c,   // ig.ht.lt_554 is.ha.zu_422  et.fi.ms_322 ceb.no.ig_543
  0x55116807, 0x251211ad, 0x3b001113, 0x3f001108,   // ig.ro.rw_432 ro.hu.eu_643  ro.so.un_650 ro.af.un_430
  0x200c080c, 0x1e2a11ec, 0x0d0a0ea9, 0x21005307,   // no.sv.sq_543 ro.mt.ms_644  is.pt.cs_544 ht.jw.un_420
  0x1327110c, 0x23101307, 0x0a251108, 0x062a3f55,   // ro.gd.et_543 et.lt.ca_432  ro.eu.pt_443 af.mt.de_442
  // [4d80]
  0x0c0a080b, 0x2109550d, 0x0e283508, 0x020c2305,   // no.pt.sv_542 rw.pl.jw_554  zu.sw.is_443 ca.sv.da_333
  0x32002a19, 0x19110a05, 0x17001c04, 0x16520c07,   // mt.bs.un_750 pt.ro.gl_333  id.sr.un_320 sv.ha.hr_432
  0x160b1fa7, 0x080e3f0c, 0x0a53030c, 0x212a1c12,   // cy.es.hr_532 af.is.no_543  nl.ht.pt_543 id.mt.jw_654
  0x3b081ca7, 0x102017ee, 0x5500121b, 0x32001b0d,   // id.no.so_532 sr.sq.lt_422  hu.rw.un_770 tr.bs.un_540
  // [4d90]
  0x16553508, 0x280f520c, 0x1752290c, 0x072327a0,   // zu.rw.hr_443 ha.lv.sw_543  sl.ha.sr_543 gd.ca.it_322
  0x202832a0, 0x190b11ec, 0x0f105208, 0x0800031b,   // bs.sw.sq_322 ro.es.gl_644  ha.lt.lv_443 nl.no.un_770
  0x04000835, 0x0b292d12, 0x53551bec, 0x1b553504,   // uk.ru.un_A90 sk.sl.es_654  tr.rw.ht_644 zu.rw.tr_332
  0x0d132d12, 0x21003108, 0x10280da4, 0x0b090709,   // sk.et.cs_654 az.jw.un_430  cs.sw.lt_433 it.pl.es_444
  // [4da0]
  0x09122707, 0x3b002104, 0x1725280c, 0x17001e07,   // gd.hu.pl_432 jw.so.un_320  sw.eu.sr_543 ms.sr.un_420
  0x04282560, 0x28555312, 0x32171b0c, 0x28001905,   // eu.sw.fi_664 ht.rw.sw_654  tr.sr.bs_543 gl.sw.un_330
  0x0c0f1005, 0x0d290912, 0x01190b13, 0x081218af,   // lt.lv.sv_333 pl.sl.cs_654  es.gl.en_665 ga.hu.no_655
  0x25640c55, 0x25211ca9, 0x641a4aaf, 0x00000737,   // sv.lg.eu_442 id.jw.eu_544  yo.tl.lg_655 it.un.un_B00
  // [4db0]
  0x01000707, 0x2a1107a7, 0x1e1c29af, 0x0b070aee,   // it.en.un_420 it.ro.mt_532  sl.id.ms_655 pt.it.es_422
  0x09006e04, 0x2b00181b, 0x050820af, 0x31000712,   // hmn.pl.un_320 ga.vi.un_770  sq.no.fr_655 it.az.un_640
  0x31041ba9, 0x3b131f0c, 0x130b6bec, 0x202a13a4,   // tr.fi.az_544 cy.et.so_543  ceb.es.et_644 et.mt.sq_433
  0x060c1205, 0x6b001334, 0x08006b13, 0x6b130d11,   // hu.sv.de_333 et.ceb.un_A80  ceb.no.un_650 cs.et.ceb_653
  // [4dc0]
  0x64352108, 0x1e3b1312, 0x352955a4, 0x0a07310c,   // jw.zu.lg_443 et.so.ms_654  rw.sl.zu_433 az.it.pt_543
  0x0964550c, 0x1b23310c, 0x080213ee, 0x21283507,   // rw.lg.pl_543 az.ca.tr_543  et.da.no_422 zu.sw.jw_432
  0x06000504, 0x6b112004, 0x106428a4, 0x1a6452a7,   // fr.de.un_320 sq.ro.ceb_332  sw.lg.lt_433 ha.lg.tl_532
  0x55311ba4, 0x23181f12, 0x0c356b55, 0x1a006b02,   // tr.az.rw_433 cy.ga.ca_654  ceb.zu.sv_442 ceb.tl.un_220
  // [4dd0]
  0x12001c02, 0x10000104, 0x200f10af, 0x08120c02,   // id.hu.un_220 en.lt.un_320  lt.lv.sq_655 sv.hu.no_222
  0x19001813, 0x2800680c, 0x6b000d13, 0x13006b13,   // ga.gl.un_650 ig.sw.un_530  cs.ceb.un_650 ceb.et.un_650
  0x1a1255ee, 0x190b13a0, 0x53124a02, 0x08001304,   // rw.hu.tl_422 et.es.gl_322  yo.hu.ht_222 et.no.un_320
  0x0a002a08, 0x1a002102, 0x35002307, 0x0a11175a,   // mt.pt.un_430 jw.tl.un_220  ca.zu.un_420 sr.ro.mk_553
  // [4de0]
  0x0e1308ec, 0x09000e09, 0x050c11a4, 0x136b2aa0,   // no.et.is_644 is.pl.un_440  ro.sv.fr_433 mt.ceb.et_322
  0x211c01a9, 0x2a5204ad, 0x2100170c, 0x11521a0d,   // en.id.jw_544 fi.ha.mt_643  sr.jw.un_530 tl.ha.ro_554
  0x0b004a1a, 0x0911230b, 0x082302ee, 0x6b521aa9,   // yo.es.un_760 ca.ro.pl_542  da.ca.no_422 tl.ha.ceb_544
  0x21232aee, 0x520e2805, 0x4a005213, 0x21551ea9,   // mt.ca.jw_422 sw.is.ha_333  ha.yo.un_650 ms.rw.jw_544
  // [4df0]
  0x090b2508, 0x28684a0d, 0x550b1bee, 0x28104aec,   // eu.es.pl_443 yo.ig.sw_554  tr.es.rw_422 yo.lt.sw_644
  0x08031208, 0x1b55310e, 0x4a55520c, 0x012305ad,   // hu.nl.no_443 az.rw.tr_555  ha.rw.yo_543 fr.ca.en_643
  0x23070207, 0x1b312012, 0x21006812, 0x522555a4,   // da.it.ca_432 sq.az.tr_654  ig.jw.un_640 rw.eu.ha_433
  0x2d1218af, 0x522168ec, 0x1e212a12, 0x31003b2b,   // ga.hu.sk_655 ig.jw.ha_644  mt.jw.ms_654 so.az.un_980
  // [4e00]
  0x130f0409, 0x21553bad, 0x521b0807, 0x20282755,   // fi.lv.et_444 so.rw.jw_643  no.tr.ha_432 gd.sw.sq_442
  0x1b3504a4, 0x4a1b0f11, 0x3f001f19, 0x31001e07,   // fi.zu.tr_433 lv.tr.yo_653  cy.af.un_750 ms.az.un_420
  0x32286b07, 0x00001337, 0x23072013, 0x2a230f04,   // ceb.sw.bs_432 bh.un.un_B00  sq.it.ca_665 lv.ca.mt_332
  0x12061b04, 0x0617130e, 0x20003b0d, 0x551c1ba4,   // tr.de.hu_332 et.sr.de_555  so.sq.un_540 tr.id.rw_433
  // [4e10]
  0x250413af, 0x553552a0, 0x31002a07, 0x161335a4,   // et.fi.eu_655 ha.zu.rw_322  mt.az.un_420 zu.et.hr_433
  0x01062705, 0x5300200c, 0x1c0e1204, 0x020301a4,   // gd.de.en_333 sq.ht.un_530  hu.is.id_332 en.nl.da_433
  0x0f005202, 0x06005218, 0x282a18a4, 0x0d321708,   // ha.lv.un_220 ha.de.un_740  ga.mt.sw_433 sr.bs.cs_443
  0x0d001e02, 0x25125555, 0x06200c04, 0x35555212,   // ms.cs.un_220 rw.hu.eu_442  sv.sq.de_332 ha.rw.zu_654
  // [4e20]
  0x250f13ee, 0x2300290c, 0x05002714, 0x0711050c,   // et.lv.eu_422 sl.ca.un_530  gd.fr.un_660 fr.ro.it_543
  0x21550a04, 0x07050c05, 0x3b255208, 0x051a02ee,   // pt.rw.jw_332 sv.fr.it_333  ha.eu.so_443 da.tl.fr_422
  0x23002107, 0x0f00061a, 0x0a002305, 0x68281e12,   // jw.ca.un_420 de.lv.un_760  ca.pt.un_330 ms.sw.ig_654
  0x06020fad, 0x16000507, 0x2a000c07, 0x03001c02,   // lv.da.de_643 fr.hr.un_420  sv.mt.un_420 id.nl.un_220
  // [4e30]
  0x0e002a07, 0x25296808, 0x2000090e, 0x1e1c0cee,   // mt.is.un_420 ig.sl.eu_443  pl.sq.un_550 sv.id.ms_422
  0x68002a0c, 0x080e10a4, 0x321703a0, 0x13000621,   // mt.ig.un_530 lt.is.no_433  nl.sr.bs_322 de.et.un_860
  0x2d180ba9, 0x0c0308a9, 0x06310f02, 0x6b000608,   // es.ga.sk_544 no.nl.sv_544  lv.az.de_222 de.ceb.un_430
  0x0603010c, 0x02060107, 0x271101a9, 0x250803a0,   // en.nl.de_543 en.de.da_432  en.ro.gd_544 nl.no.eu_322
  // [4e40]
  0x054a09a9, 0x05000213, 0x2b0121ee, 0x27181fad,   // pl.yo.fr_544 da.fr.un_650  jw.en.vi_422 cy.ga.gd_643
  0x19113b05, 0x02042ba0, 0x25054aa7, 0x1f00030d,   // so.ro.gl_333 vi.fi.da_322  yo.fr.eu_532 nl.cy.un_540
  0x2a08120e, 0x1b3b31ec, 0x050d01ec, 0x6b1f1a5a,   // hu.no.mt_555 az.so.tr_644  en.cs.fr_644 tl.cy.ceb_553
  0x0e001119, 0x080235a4, 0x033f21af, 0x04111ba4,   // ro.is.un_750 zu.da.no_433  jw.af.nl_655 tr.ro.fi_433
  // [4e50]
  0x3f100a07, 0x522855ec, 0x031c1e0c, 0x0c031907,   // pt.lt.af_432 rw.sw.ha_644  ms.id.nl_543 gl.nl.sv_432
  0x133b6405, 0x27201f0c, 0x030c19ee, 0x0c045212,   // lg.so.et_333 cy.sq.gd_543  gl.sv.nl_422 ha.fi.sv_654
  0x64006821, 0x310453ec, 0x06210eee, 0x0464130c,   // ig.lg.un_860 ht.fi.az_644  is.jw.de_422 et.lg.fi_543
  0x1a00532a, 0x01030faf, 0x0e000a19, 0x052923a0,   // ht.tl.un_970 lv.nl.en_655  pt.is.un_750 ca.sl.fr_322
  // [4e60]
  0x2d0d1ea4, 0x68536b0c, 0x03270613, 0x35251c12,   // ms.cs.sk_433 ceb.ht.ig_543  de.gd.nl_665 id.eu.zu_654
  0x12000b14, 0x23013f0c, 0x043b2707, 0x18000a18,   // es.hu.un_660 af.en.ca_543  gd.so.fi_432 pt.ga.un_740
  0x0e181912, 0x55350612, 0x2000270e, 0x08021b05,   // gl.ga.is_654 de.zu.rw_654  gd.sq.un_550 tr.da.no_333
  0x524a20a4, 0x29535513, 0x25681309, 0x29005212,   // sq.yo.ha_433 rw.ht.sl_665  et.ig.eu_444 ha.sl.un_640
  // [4e70]
  0x68005312, 0x2d535505, 0x1312530b, 0x21250c08,   // ht.ig.un_640 rw.ht.sk_333  ht.hu.et_542 sv.eu.jw_443
  0x11000b08, 0x1b006b19, 0x03000714, 0x2d0f0d0c,   // es.ro.un_430 ceb.tr.un_750  it.nl.un_660 cs.lv.sk_543
  0x111707af, 0x0a5355a4, 0x092025a9, 0x211b020c,   // bg.sr.ro_655 rw.ht.pt_433  eu.sq.pl_544 da.tr.jw_543
  0x07002a07, 0x286420af, 0x13324a02, 0x20000c1a,   // mt.it.un_420 sq.lg.sw_655  yo.bs.et_222 sv.sq.un_760
  // [4e80]
  0x0a16230c, 0x64682109, 0x182b28a0, 0x313f0fad,   // ca.hr.pt_543 jw.ig.lg_444  sw.vi.ga_322 lv.af.az_643
  0x2021130c, 0x32000f19, 0x4a00120d, 0x3f080f04,   // et.jw.sq_543 lv.bs.un_750  hu.yo.un_540 lv.no.af_332
  0x18003f04, 0x0a006b0b, 0x55001e08, 0x29001c02,   // af.ga.un_320 ceb.pt.un_520  ms.rw.un_430 id.sl.un_220
  0x020608a9, 0x1c130d12, 0x080221ee, 0x27006b34,   // no.de.da_544 ne.bh.mr_654  jw.da.no_422 ceb.gd.un_A80
  // [4e90]
  0x123501a9, 0x0c270805, 0x283518a9, 0x2b35050c,   // en.zu.hu_544 no.gd.sv_333  ga.zu.sw_544 fr.zu.vi_543
  0x3f1f0e60, 0x1c131eac, 0x1f002714, 0x21041eee,   // is.cy.af_664 ms.et.id_632  gd.cy.un_660 ms.fi.jw_422
  0x6b030ca0, 0x05202b04, 0x13352aee, 0x2300040d,   // sv.nl.ceb_322 vi.sq.fr_332  mt.zu.et_422 fi.ca.un_540
  0x0d180aaf, 0x20002122, 0x171b2304, 0x11001c09,   // pt.ga.cs_655 jw.sq.un_870  ca.tr.sr_332 id.ro.un_440
  // [4ea0]
  0x0d3119ee, 0x11002a0c, 0x6b20230c, 0x080212ee,   // gl.az.cs_422 mt.ro.un_530  ca.sq.ceb_543 hu.da.no_422
  0x292a0dee, 0x1f0827ac, 0x1b003b0e, 0x1b2a04ad,   // cs.mt.sl_422 gd.no.cy_632  so.tr.un_550 fi.mt.tr_643
  0x1b002a19, 0x07005504, 0x041711a6, 0x04641804,   // mt.tr.un_750 rw.it.un_320  ro.sr.ru_521 ga.lg.fi_332
  0x35002b07, 0x550728af, 0x0d00550d, 0x20551702,   // vi.zu.un_420 sw.it.rw_655  rw.cs.un_540 sr.rw.sq_222
  // [4eb0]
  0x350364ec, 0x09001a04, 0x2d0d0aee, 0x18003507,   // lg.nl.zu_644 tl.pl.un_320  pt.cs.sk_422 zu.ga.un_420
  0x55641a13, 0x35533105, 0x20006413, 0x350d64ad,   // tl.lg.rw_665 az.ht.zu_333  lg.sq.un_650 lg.cs.zu_643
  0x09000513, 0x351a13af, 0x3b04200c, 0x352564ec,   // fr.pl.un_650 et.tl.zu_655  sq.fi.so_543 lg.eu.zu_644
  0x180452a0, 0x1e1064ad, 0x041b35a9, 0x03110208,   // ha.fi.ga_322 lg.lt.ms_643  zu.tr.fi_544 da.ro.nl_443
  // [4ec0]
  0x2d060dad, 0x1100531b, 0x1c121eaf, 0x0e2a23a7,   // cs.de.sk_643 ht.ro.un_770  ms.hu.id_655 ca.mt.is_532
  0x271813a4, 0x296416ee, 0x5300190d, 0x04120a04,   // et.ga.gd_433 hr.lg.sl_422  gl.ht.un_540 pt.hu.fi_332
  0x2d2916a7, 0x352532ee, 0x11002908, 0x0a0813ee,   // hr.sl.sk_532 bs.eu.zu_422  sl.ro.un_430 et.no.pt_422
  0x1e1a53a4, 0x03120aad, 0x1a352811, 0x183527a7,   // ht.tl.ms_433 pt.hu.nl_643  sw.zu.tl_653 gd.zu.ga_532
  // [4ed0]
  0x20001c08, 0x10003f13, 0x07170802, 0x0f286412,   // id.sq.un_430 af.lt.un_650  uk.sr.bg_222 lg.sw.lv_654
  0x04643512, 0x08111711, 0x190a2da4, 0x0a111304,   // zu.lg.fi_654 sr.ro.uk_653  sk.pt.gl_433 et.ro.pt_332
  0x05232b08, 0x292d08a0, 0x2d0d13a0, 0x6b3f0312,   // vi.ca.fr_443 no.sk.sl_322  et.cs.sk_322 nl.af.ceb_654
  0x05101fec, 0x08030611, 0x0e1c1aa4, 0x68350d07,   // cy.lt.fr_644 de.nl.no_653  tl.id.is_433 cs.zu.ig_432
  // [4ee0]
  0x21521b09, 0x1f09350c, 0x02080e55, 0x032d20a4,   // tr.ha.jw_444 zu.pl.cy_543  is.no.da_442 sq.sk.nl_433
  0x173129a4, 0x211820af, 0x0e3553a9, 0x12552107,   // sl.az.sr_433 sq.ga.jw_655  ht.zu.is_544 jw.rw.hu_432
  0x32292da0, 0x53350a08, 0x072a3505, 0x06552805,   // sk.sl.bs_322 pt.zu.ht_443  zu.mt.it_333 sw.rw.de_333
  0x2a001304, 0x1b060c12, 0x07003502, 0x2d0d21a4,   // et.mt.un_320 sv.de.tr_654  zu.it.un_220 jw.cs.sk_433
  // [4ef0]
  0x216b52a0, 0x2800210d, 0x0b1f23af, 0x291353a0,   // ha.ceb.jw_322 jw.sw.un_540  ca.cy.es_655 ht.et.sl_322
  0x20001222, 0x64212305, 0x122a0408, 0x201f0107,   // hu.sq.un_870 ca.jw.lg_333  fi.mt.hu_443 en.cy.sq_432
  0x031e010c, 0x250b01ee, 0x20131e0c, 0x530913a9,   // en.ms.nl_543 en.es.eu_422  ms.et.sq_543 et.pl.ht_544
  0x0800210d, 0x2d003b22, 0x552d0314, 0x52000112,   // jw.no.un_540 so.sk.un_870  nl.sk.rw_666 en.ha.un_640
  // [4f00]
  0x174a52af, 0x061f18a4, 0x2d0d35ee, 0x201164a0,   // ha.yo.sr_655 ga.cy.de_433  zu.cs.sk_422 lg.ro.sq_322
  0x20005521, 0x1000080d, 0x08002022, 0x21014a07,   // rw.sq.un_860 uk.be.un_540  sq.no.un_870 yo.en.jw_432
  0x68355512, 0x165504ee, 0x55000b09, 0x160e04a4,   // rw.zu.ig_654 fi.rw.hr_422  es.rw.un_440 fi.is.hr_433
  0x522a10ad, 0x2b002511, 0x13000f02, 0x280b55a4,   // lt.mt.ha_643 eu.vi.un_630  lv.et.un_220 rw.es.sw_433
  // [4f10]
  0x0c0809af, 0x1c3f2807, 0x5301280c, 0x321752a0,   // pl.no.sv_655 sw.af.id_432  sw.en.ht_543 ha.sr.bs_322
  0x072d2907, 0x20002107, 0x07001321, 0x3125280c,   // sl.sk.it_432 jw.sq.un_420  et.it.un_860 sw.eu.az_543
  0x165228a4, 0x021b17a0, 0x071f2904, 0x1b1a6b0d,   // sw.ha.hr_433 sr.tr.da_322  sl.cy.it_332 ceb.tl.tr_554
  0x011311a0, 0x6e003f04, 0x050e1fee, 0x32031e07,   // ro.et.en_322 af.hmn.un_320  cy.is.fr_422 ms.nl.bs_432
  // [4f20]
  0x1c531f04, 0x21352812, 0x0b231fec, 0x131f31a9,   // cy.ht.id_332 sw.zu.jw_654  cy.ca.es_644 az.cy.et_544
  0x2b006b07, 0x04002507, 0x522125a0, 0x1a1b6bad,   // ceb.vi.un_420 eu.fi.un_420  eu.jw.ha_322 ceb.tr.tl_643
  0x1c3b27a4, 0x04251ca7, 0x19272d07, 0x35133113,   // gd.so.id_433 id.eu.fi_532  sk.gd.gl_432 az.et.zu_665
  0x31005321, 0x132506a4, 0x1a215312, 0x12251b08,   // ht.az.un_860 de.eu.et_433  ht.jw.tl_654 tr.eu.hu_443
  // [4f30]
  0x032a130c, 0x1a3b0ba0, 0x18000804, 0x12200607,   // et.mt.nl_543 es.so.tl_322  no.ga.un_320 de.sq.hu_432
  0x27130405, 0x1f1a1bee, 0x0c060ea0, 0x01004a02,   // fi.et.gd_333 tr.tl.cy_422  is.de.sv_322 yo.en.un_220
  0x16000607, 0x251064a4, 0x09000c04, 0x0a000d12,   // de.hr.un_420 lg.lt.eu_433  sv.pl.un_320 cs.pt.un_640
  0x080c020d, 0x182b01ad, 0x20003504, 0x27181ca0,   // da.sv.no_554 en.vi.ga_643  zu.sq.un_320 id.ga.gd_322
  // [4f40]
  0x1c3b1eaf, 0x07042a60, 0x23000504, 0x0b000e05,   // ms.so.id_655 mt.fi.it_664  fr.ca.un_320 is.es.un_330
  0x2012130c, 0x2d0d0aa4, 0x53006b0b, 0x080e0413,   // et.hu.sq_543 pt.cs.sk_433  ceb.ht.un_520 fi.is.no_665
  0x080253ec, 0x0d000a0e, 0x104a2008, 0x25070ea0,   // ht.da.no_644 pt.cs.un_550  sq.yo.lt_443 is.it.eu_322
  0x1b001a02, 0x64553505, 0x081b040c, 0x020c52a7,   // tl.tr.un_220 zu.rw.lg_333  fi.tr.no_543 ha.sv.da_532
  // [4f50]
  0x13201f12, 0x190a18a6, 0x1000270e, 0x0d071304,   // cy.sq.et_654 ga.pt.gl_521  gd.lt.un_550 et.it.cs_332
  0x0f030ea7, 0x02292d08, 0x280e13ad, 0x3b00682a,   // is.nl.lv_532 sk.sl.da_443  et.is.sw_643 ig.so.un_970
  0x1f2701a4, 0x04050c11, 0x182327a4, 0x290d1f04,   // en.gd.cy_433 sv.fr.fi_653  gd.ca.ga_433 cy.cs.sl_332
  0x120306ee, 0x21040204, 0x08060c02, 0x0c02035a,   // de.nl.hu_422 da.fi.jw_332  sv.de.no_222 nl.da.sv_553
  // [4f60]
  0x29090f0e, 0x0c021f07, 0x04030611, 0x02001f11,   // lv.pl.sl_555 cy.da.sv_432  de.nl.fi_653 cy.da.un_630
  0x522d04ac, 0x35000e09, 0x3f080f07, 0x0a003508,   // fi.sk.ha_632 is.zu.un_440  lv.no.af_432 zu.pt.un_430
  0x21531bad, 0x080e2a09, 0x0c231fa4, 0x1e0e1ca0,   // tr.ht.jw_643 mt.is.no_444  cy.ca.sv_433 id.is.ms_322
  0x32021fee, 0x080e64a0, 0x1b531a0c, 0x17110aa7,   // cy.da.bs_422 lg.is.no_322  tl.ht.tr_543 mk.ro.sr_532
  // [4f70]
  0x2d0d4aec, 0x12001a12, 0x0e182dad, 0x0f002704,   // yo.cs.sk_644 tl.hu.un_640  sk.ga.is_643 gd.lv.un_320
  0x1f001e04, 0x190a11ee, 0x0e003521, 0x1200210e,   // ms.cy.un_320 ro.pt.gl_422  zu.is.un_860 fa.ur.un_550
  0x190b4aa0, 0x01001e02, 0x0c0e0308, 0x190b4a09,   // yo.es.gl_322 ms.en.un_220  nl.is.sv_443 yo.es.gl_444
  0x12005202, 0x17001e04, 0x02031304, 0x200c11ee,   // ha.hu.un_220 ms.sr.un_320  et.nl.da_332 ro.sv.sq_422
  // [4f80]
  0x552028a4, 0x020f080c, 0x2902030c, 0x0a11040c,   // sw.sq.rw_433 no.lv.da_543  nl.da.sl_543 ru.ro.mk_543
  0x314a1eee, 0x1e6b1ca4, 0x06030e11, 0x06106b08,   // ms.yo.az_422 id.ceb.ms_433  is.nl.de_653 ceb.lt.de_443
  0x05232011, 0x1b003508, 0x32131607, 0x074a19a0,   // sq.ca.fr_653 zu.tr.un_430  hr.et.bs_432 gl.yo.it_322
  0x20252a07, 0x31682105, 0x180501ec, 0x19005319,   // mt.eu.sq_432 jw.ig.az_333  en.fr.ga_644 ht.gl.un_750
  // [4f90]
  0x2d001f1a, 0x110a080c, 0x1f003f1a, 0x5300231d,   // cy.sk.un_760 uk.mk.ro_543  af.cy.un_760 ca.ht.un_820
  0x13080ea7, 0x0e03010c, 0x112501ad, 0x0f006e08,   // is.no.et_532 en.nl.is_543  en.eu.ro_643 hmn.lv.un_430
  0x52003b13, 0x021b6b12, 0x2b212512, 0x25006b1a,   // so.ha.un_650 ceb.tr.da_654  eu.jw.vi_654 ceb.eu.un_760
  0x04250513, 0x2500680d, 0x6b2125a0, 0x25002122,   // fr.eu.fi_665 ig.eu.un_540  eu.jw.ceb_322 jw.eu.un_870
  // [4fa0]
  0x2a002904, 0x6b000e13, 0x1f003f08, 0x100c3f13,   // sl.mt.un_320 is.ceb.un_650  af.cy.un_430 af.sv.lt_665
  0x53072305, 0x64315504, 0x3b045207, 0x28000713,   // ca.it.ht_333 rw.az.lg_332  ha.fi.so_432 it.sw.un_650
  0x35521a07, 0x1c213108, 0x2b6b2512, 0x0c106b0c,   // tl.ha.zu_432 az.jw.id_443  eu.ceb.vi_654 ceb.lt.sv_543
  0x05005312, 0x2d0d18ee, 0x030511ee, 0x1e521f07,   // ht.fr.un_640 ga.cs.sk_422  ro.fr.nl_422 cy.ha.ms_432
  // [4fb0]
  0x0b110560, 0x255535a4, 0x55351211, 0x2d001602,   // fr.ro.es_664 zu.rw.eu_433  hu.zu.rw_653 hr.sk.un_220
  0x10002104, 0x0c1a0604, 0x1b0953ad, 0x29175307,   // jw.lt.un_320 de.tl.sv_332  ht.pl.tr_643 ht.sr.sl_432
  0x31193507, 0x232719ee, 0x295255a4, 0x5511350c,   // zu.gl.az_432 gl.gd.ca_422  rw.ha.sl_433 zu.ro.rw_543
  0x686b01a6, 0x0f100112, 0x27006807, 0x1b311aa9,   // en.ceb.ig_521 en.lt.lv_654  ig.gd.un_420 tl.az.tr_544
  // [4fc0]
  0x0a201b12, 0x063120ee, 0x311b1a14, 0x2300181a,   // tr.sq.pt_654 sq.az.de_422  tl.tr.az_666 ga.ca.un_760
  0x32161309, 0x1c130d09, 0x0f101aa7, 0x010f13ec,   // et.hr.bs_444 ne.bh.mr_444  tl.lt.lv_532 et.lv.en_644
  0x53322912, 0x233f01a9, 0x010e050c, 0x6e000104,   // sl.bs.ht_654 en.af.ca_544  fr.is.en_543 en.hmn.un_320
  0x060f0107, 0x52001014, 0x180123a9, 0x04521313,   // en.lv.de_432 lt.ha.un_660  ca.en.ga_544 et.ha.fi_665
  // [4fd0]
  0x13005307, 0x05001e02, 0x3b01280c, 0x23001f21,   // ht.et.un_420 ms.fr.un_220  sw.en.so_543 cy.ca.un_860
  0x35643112, 0x181027ec, 0x10281aad, 0x31525504,   // az.lg.zu_654 gd.lt.ga_644  tl.sw.lt_643 rw.ha.az_332
  0x6e00012b, 0x35110aa4, 0x1b1a3108, 0x6e00100e,   // en.hmn.un_980 pt.ro.zu_433  az.tl.tr_443 lt.hmn.un_550
  0x2d0d03a9, 0x1a001e1a, 0x082a010d, 0x172a070b,   // nl.cs.sk_544 ms.tl.un_760  en.mt.no_554 it.mt.sr_542
  // [4fe0]
  0x091308ad, 0x131a1ca4, 0x01002a07, 0x1a216bee,   // no.et.pl_643 id.tl.et_433  mt.en.un_420 ceb.jw.tl_422
  0x356b6409, 0x283520a0, 0x01203b07, 0x1b106b60,   // lg.ceb.zu_444 sq.zu.sw_322  so.sq.en_432 ceb.lt.tr_664
  0x1f1235ad, 0x0f556460, 0x6b013b07, 0x32132d0b,   // zu.hu.cy_643 lg.rw.lv_664  so.en.ceb_432 sk.et.bs_542
  0x0c0110ee, 0x1b253113, 0x28090407, 0x08002713,   // lt.en.sv_422 az.eu.tr_665  fi.pl.sw_432 gd.no.un_650
  // [4ff0]
  0x641b31ec, 0x172d29a0, 0x0d004a12, 0x641a1e12,   // az.tr.lg_644 sl.sk.sr_322  yo.cs.un_640 ms.tl.lg_654
  0x190a10a4, 0x181223a9, 0x3f002514, 0x045228ad,   // lt.pt.gl_433 ca.hu.ga_544  eu.af.un_660 sw.ha.fi_643
  0x1f00010c, 0x0f095304, 0x6855200c, 0x1e31100c,   // en.cy.un_530 ht.pl.lv_332  sq.rw.ig_543 lt.az.ms_543
  0x281b35ad, 0x55005208, 0x55000714, 0x550525a4,   // zu.tr.sw_643 ha.rw.un_430  it.rw.un_660 eu.fr.rw_433

  // [5000]
  0x3f002b0d, 0x0f005219, 0x190b12a4, 0x110129a4,   // vi.af.un_540 ha.lv.un_750  hu.es.gl_433 sl.en.ro_433
  0x12190ea9, 0x1e1a1ca4, 0x0d071313, 0x206e1a0c,   // is.gl.hu_544 id.tl.ms_433  et.it.cs_665 tl.hmn.sq_543
  0x1c002b21, 0x68004a0d, 0x1e3b1c0c, 0x521e280c,   // vi.id.un_860 yo.ig.un_540  id.so.ms_543 sw.ms.ha_543
  0x1b5553ec, 0x3f0301ad, 0x01271812, 0x3b042007,   // ht.rw.tr_644 en.nl.af_643  ga.gd.en_654 sq.fi.so_432
  // [5010]
  0x25000629, 0x53045211, 0x1e131c07, 0x1f000621,   // de.eu.un_960 ha.fi.ht_653  id.et.ms_432 de.cy.un_860
  0x016b35a0, 0x2b641c0c, 0x131104ee, 0x1a2821a4,   // zu.ceb.en_322 id.lg.vi_543  fi.ro.et_422 jw.sw.tl_433
  0x1c1316a0, 0x641a350c, 0x1a2155a9, 0x6b1a1ca9,   // hr.et.id_322 zu.tl.lg_543  rw.jw.tl_544 id.tl.ceb_544
  0x02283502, 0x21005504, 0x1e1c04a4, 0x23006e07,   // zu.sw.da_222 rw.jw.un_320  fi.id.ms_433 hmn.ca.un_420
  // [5020]
  0x01001b08, 0x1e1c5302, 0x0c532308, 0x200d3ba9,   // tr.en.un_430 ht.id.ms_222  ca.ht.sv_443 so.cs.sq_544
  0x0c1b5305, 0x1f005204, 0x0e00522a, 0x283f5308,   // ht.tr.sv_333 ha.cy.un_320  ha.is.un_970 ht.af.sw_443
  0x6b6853a7, 0x6e003204, 0x6b003507, 0x2b3f16a7,   // ht.ig.ceb_532 bs.hmn.un_320  zu.ceb.un_420 hr.af.vi_532
  0x3f1e1c0c, 0x025208a4, 0x291b0fa4, 0x2a0d3b07,   // id.ms.af_543 no.ha.da_433  lv.tr.sl_433 so.cs.mt_432
  // [5030]
  0x01001604, 0x213f060c, 0x1b6e1604, 0x03001308,   // hr.en.un_320 de.af.jw_543  hr.hmn.tr_332 et.nl.un_430
  0x526b1b0c, 0x0e0c5308, 0x28001314, 0x1e1c0ca9,   // tr.ceb.ha_543 ht.sv.is_443  et.sw.un_660 sv.id.ms_544
  0x35002104, 0x3b004a08, 0x172916ad, 0x0b0a19a7,   // jw.zu.un_320 yo.so.un_430  hr.sl.sr_643 gl.pt.es_532
  0x130110a4, 0x521f3b07, 0x19002308, 0x20102812,   // lt.en.et_433 so.cy.ha_432  ca.gl.un_430 sw.lt.sq_654
  // [5040]
  0x3f641307, 0x01231a08, 0x27001008, 0x020408a4,   // et.lg.af_432 tl.ca.en_443  lt.gd.un_430 no.fi.da_433
  0x6b000d08, 0x643f3ba4, 0x522b010c, 0x192b0ba9,   // cs.ceb.un_430 so.af.lg_433  en.vi.ha_543 es.vi.gl_544
  0x550603ad, 0x0f0b53a4, 0x0a0e52a7, 0x321752a9,   // nl.de.rw_643 ht.es.lv_433  ha.is.pt_532 ha.sr.bs_544
  0x35033fee, 0x0204080c, 0x170b295a, 0x4a003b23,   // af.nl.zu_422 no.fi.da_543  sl.es.sr_553 so.yo.un_880
  // [5050]
  0x0e5227a9, 0x13116408, 0x4a001113, 0x255511a6,   // gd.ha.is_544 lg.ro.et_443  ro.yo.un_650 ro.rw.eu_521
  0x135527ac, 0x1a3b0bee, 0x0a002704, 0x4a191e07,   // gd.rw.et_632 es.so.tl_422  gd.pt.un_320 ms.gl.yo_432
  0x2b1c2707, 0x25186405, 0x6b3b2709, 0x641155a4,   // gd.id.vi_432 lg.ga.eu_333  gd.so.ceb_444 rw.ro.lg_433
  0x046b13a4, 0x2d296460, 0x0d1b3b07, 0x64281a05,   // et.ceb.fi_433 lg.sl.sk_664  so.tr.cs_432 tl.sw.lg_333
  // [5060]
  0x011f55a0, 0x4a1b0107, 0x524a1e12, 0x0a100712,   // rw.cy.en_322 en.tr.yo_432  ms.yo.ha_654 bg.be.mk_654
  0x684a3b08, 0x28113512, 0x1a68350c, 0x033513a9,   // so.yo.ig_443 zu.ro.sw_654  zu.ig.tl_543 et.zu.nl_544
  0x3f03350c, 0x32161109, 0x29020c60, 0x1b11130c,   // zu.nl.af_543 ro.hr.bs_444  sv.da.sl_664 et.ro.tr_543
  0x31001607, 0x351a0c07, 0x09006e34, 0x03113508,   // hr.az.un_420 sv.tl.zu_432  hmn.pl.un_A80 zu.ro.nl_443
  // [5070]
  0x1b113512, 0x031c1102, 0x03006e0e, 0x1c1b1eee,   // zu.ro.tr_654 ro.id.nl_222  hmn.nl.un_550 ms.tr.id_422
  0x190b5209, 0x2d0d6e11, 0x1100351b, 0x02250811,   // ha.es.gl_444 hmn.cs.sk_653  zu.ro.un_770 no.eu.da_653
  0x5311350c, 0x042752ad, 0x0d131113, 0x0c0620a4,   // zu.ro.ht_543 ha.gd.fi_643  ro.et.cs_665 sq.de.sv_433
  0x07191f07, 0x1b01530c, 0x10003122, 0x3f13110c,   // cy.gl.it_432 ht.en.tr_543  az.lt.un_870 ro.et.af_543
  // [5080]
  0x113513af, 0x100711ec, 0x1f0e06a7, 0x052321ad,   // et.zu.ro_655 ro.bg.be_644  de.is.cy_532 jw.ca.fr_643
  0x012135af, 0x31252a0c, 0x13310cac, 0x3f0305a6,   // zu.jw.en_655 mt.eu.az_543  sv.az.et_632 fr.nl.af_521
  0x4a001a09, 0x1a3b040c, 0x1b3212a7, 0x6b041f04,   // tl.yo.un_440 fi.so.tl_543  hu.bs.tr_532 cy.fi.ceb_332
  0x1e002104, 0x6e000a1b, 0x030c3f60, 0x21003b08,   // jw.ms.un_320 pt.hmn.un_770  af.sv.nl_664 so.jw.un_430
  // [5090]
  0x1e086e0c, 0x1200021a, 0x043b4aa0, 0x02006b02,   // hmn.no.ms_543 da.hu.un_760  yo.so.fi_322 ceb.da.un_220
  0x6b1a2107, 0x110305ee, 0x056e1f0c, 0x02273f07,   // jw.tl.ceb_432 fr.nl.ro_422  cy.hmn.fr_543 af.gd.da_432
  0x530a52a9, 0x3b001a13, 0x1e00211a, 0x030c3f0c,   // ha.pt.ht_544 tl.so.un_650  jw.ms.un_760 af.sv.nl_543
  0x1b006b0c, 0x11030512, 0x0e003113, 0x04000621,   // ceb.tr.un_530 fr.nl.ro_654  az.is.un_650 de.fi.un_860
  // [50a0]
  0x0d1c13a7, 0x3b1a040c, 0x2b0a6eec, 0x03000c05,   // bh.mr.ne_532 fi.tl.so_543  hmn.pt.vi_644 sv.nl.un_330
  0x0c0204ad, 0x01680ea4, 0x311b0707, 0x3500040c,   // fi.da.sv_643 is.ig.en_433  it.tr.az_432 fi.zu.un_530
  0x2a002504, 0x3f1a210c, 0x020305a9, 0x0e0c0613,   // eu.mt.un_320 jw.tl.af_543  fr.nl.da_544 de.sv.is_665
  0x2b00160e, 0x0311050c, 0x0501235a, 0x20521fad,   // hr.vi.un_550 fr.ro.nl_543  ca.en.fr_553 cy.ha.sq_643
  // [50b0]
  0x11000717, 0x01002802, 0x08072a0d, 0x1b0c31a4,   // it.ro.un_730 sw.en.un_220  mt.it.no_554 az.sv.tr_433
  0x00001737, 0x0400172c, 0x210d32a0, 0x530308a9,   // sr.un.un_B00 sr.ru.un_990  bs.cs.jw_322 no.nl.ht_544
  0x25002a05, 0x311b4aa4, 0x25005314, 0x060b03a4,   // mt.eu.un_330 yo.tr.az_433  ht.eu.un_660 nl.es.de_433
  0x21006e04, 0x53190111, 0x555352a9, 0x4a213f11,   // hmn.jw.un_320 en.gl.ht_653  ha.ht.rw_544 af.jw.yo_653
  // [50c0]
  0x0f106e60, 0x204a2112, 0x131b680c, 0x02003f29,   // hmn.lt.lv_664 jw.yo.sq_654  ig.tr.et_543 af.da.un_960
  0x13004a19, 0x081b0255, 0x021c2ba7, 0x2820070c,   // yo.et.un_750 da.tr.no_442  vi.id.da_532 it.sq.sw_543
  0x3f640755, 0x086e4aa0, 0x0705520c, 0x29191c08,   // it.lg.af_442 yo.hmn.no_322  ha.fr.it_543 id.gl.sl_443
  0x52132512, 0x4a1b02ee, 0x1a6e2855, 0x250603a9,   // eu.et.ha_654 da.tr.yo_422  sw.hmn.tl_442 nl.de.eu_544
  // [50d0]
  0x550d0504, 0x134a02a4, 0x2b681808, 0x04000922,   // fr.cs.rw_332 da.yo.et_433  ga.ig.vi_443 pl.fi.un_870
  0x10006e2a, 0x3200520b, 0x3f1768a4, 0x11253b0c,   // hmn.lt.un_970 ha.bs.un_520  ig.sr.af_433 so.eu.ro_543
  0x3f00090c, 0x1a005521, 0x07006e05, 0x2a030905,   // pl.af.un_530 rw.tl.un_860  hmn.it.un_330 pl.nl.mt_333
  0x19090b0c, 0x06523fa4, 0x1b000c0e, 0x1100522a,   // es.pl.gl_543 af.ha.de_433  sv.tr.un_550 ha.ro.un_970
  // [50e0]
  0x6b311ba4, 0x0f6e0714, 0x680208af, 0x3f10230c,   // tr.az.ceb_433 it.hmn.lv_666  no.da.ig_655 ca.lt.af_543
  0x02532908, 0x021b11a6, 0x31022507, 0x0d291ea0,   // sl.ht.da_443 ro.tr.da_521  eu.da.az_432 ms.sl.cs_322
  0x0a6e2b05, 0x080203a4, 0x11081ea0, 0x0c100fa4,   // vi.hmn.pt_333 nl.da.no_433  ms.no.ro_322 lv.lt.sv_433
  0x030f090c, 0x1f0309ad, 0x09201b0c, 0x0b000609,   // pl.lv.nl_543 pl.nl.cy_643  tr.sq.pl_543 de.es.un_440
  // [50f0]
  0x030f29a9, 0x68356ea4, 0x103f0405, 0x6b130f07,   // sl.lv.nl_544 hmn.zu.ig_433  fi.af.lt_333 lv.et.ceb_432
  0x1f0364a9, 0x2a180a09, 0x040807ec, 0x10060e04,   // lg.nl.cy_544 pt.ga.mt_444  bg.uk.ru_644 is.de.lt_332
  0x0f103fa7, 0x0e3b0408, 0x02081107, 0x0c041fa0,   // af.lt.lv_532 fi.so.is_443  ro.no.da_432 cy.fi.sv_322
  0x06001f04, 0x1a211c08, 0x0200012a, 0x1e531ca4,   // cy.de.un_320 id.jw.tl_443  en.da.un_970 id.ht.ms_433
  // [5100]
  0x23003b04, 0x28001813, 0x170708ad, 0x0553020c,   // so.ca.un_320 ga.sw.un_650  uk.bg.sr_643 da.ht.fr_543
  0x0e1b0f04, 0x25000908, 0x05006807, 0x190b0705,   // lv.tr.is_332 pl.eu.un_430  ig.fr.un_420 it.es.gl_333
  0x011f28a6, 0x0b004a04, 0x1153050c, 0x683f27a9,   // sw.cy.en_521 yo.es.un_320  fr.ht.ro_543 gd.af.ig_544
  0x321b5308, 0x352718ec, 0x251c1e0c, 0x08020114,   // ht.tr.bs_443 ga.gd.zu_644  ms.id.eu_543 en.da.no_666
  // [5110]
  0x25041ea7, 0x1e28110c, 0x10111ba7, 0x53112512,   // ms.fi.eu_532 ro.sw.ms_543  tr.ro.lt_532 eu.ro.ht_654
  0x190a05ec, 0x17291eec, 0x0d091c0d, 0x066403a4,   // fr.pt.gl_644 ms.sl.sr_644  mr.hi.ne_554 nl.lg.de_433
  0x29101f0c, 0x642d0d13, 0x21002a07, 0x6b1001a7,   // cy.lt.sl_543 cs.sk.lg_665  mt.jw.un_420 en.lt.ceb_532
  0x191f2108, 0x68000321, 0x21001f0c, 0x060801a0,   // jw.cy.gl_443 nl.ig.un_860  cy.jw.un_530 en.no.de_322
  // [5120]
  0x07012a02, 0x101253ee, 0x0c004a02, 0x6b091aa9,   // mt.en.it_222 ht.hu.lt_422  yo.sv.un_220 tl.pl.ceb_544
  0x6b6818ee, 0x080602ee, 0x680906ad, 0x28111aa9,   // ga.ig.ceb_422 da.de.no_422  de.pl.ig_643 tl.ro.sw_544
  0x3b002008, 0x1e1c6ba9, 0x231e05a4, 0x1329090d,   // sq.so.un_430 ceb.id.ms_544  fr.ms.ca_433 pl.sl.et_554
  0x2d04050c, 0x53006b19, 0x13004a04, 0x07230da4,   // fr.fi.sk_543 ceb.ht.un_750  yo.et.un_320 cs.ca.it_433
  // [5130]
  0x060e0860, 0x0e002d0c, 0x3b552807, 0x20011f11,   // no.is.de_664 sk.is.un_530  sw.rw.so_432 cy.en.sq_653
  0x08020607, 0x131112a4, 0x3b311b08, 0x1c131a60,   // de.da.no_432 hu.ro.et_433  tr.az.so_443 tl.et.id_664
  0x12001804, 0x100f20af, 0x350d2908, 0x052a2708,   // ga.hu.un_320 sq.lv.lt_655  sl.cs.zu_443 gd.mt.fr_443
  0x68131e07, 0x20313b12, 0x07212a0c, 0x0c2808ee,   // ms.et.ig_432 so.az.sq_654  mt.jw.it_543 no.sw.sv_422
  // [5140]
  0x13252a0c, 0x0d002704, 0x135520a4, 0x03061fa9,   // mt.eu.et_543 gd.cs.un_320  sq.rw.et_433 cy.de.nl_544
  0x051b530d, 0x28356ea4, 0x200d55a4, 0x0900310d,   // ht.tr.fr_554 hmn.zu.sw_433  rw.cs.sq_433 az.pl.un_540
  0x2b06250c, 0x2a042560, 0x08020fa4, 0x03001e04,   // eu.de.vi_543 eu.fi.mt_664  lv.da.no_433 ms.nl.un_320
  0x041e1a08, 0x21281a0c, 0x130b3bad, 0x0b1e6ea0,   // tl.ms.fi_443 tl.sw.jw_543  so.es.et_643 hmn.ms.es_322
  // [5150]
  0x02052aee, 0x072b1faf, 0x3b534aad, 0x1b102a04,   // mt.fr.da_422 cy.vi.it_655  yo.ht.so_643 mt.lt.tr_332
  0x216e2707, 0x01002505, 0x1a3b6e0c, 0x18061f0c,   // gd.hmn.jw_432 eu.en.un_330  hmn.so.tl_543 cy.de.ga_543
  0x282a6408, 0x0f2304af, 0x07002d1a, 0x1a556b0e,   // lg.mt.sw_443 fi.ca.lv_655  sk.it.un_760 ceb.rw.tl_555
  0x23041112, 0x022508a4, 0x043f1ca4, 0x31001805,   // ro.fi.ca_654 no.eu.da_433  id.af.fi_433 ga.az.un_330
  // [5160]
  0x25060407, 0x3b1f10ec, 0x0d092daf, 0x25002708,   // fi.de.eu_432 lt.cy.so_644  sk.pl.cs_655 gd.eu.un_430
  0x112825a9, 0x1a6b10ad, 0x1e1a1c0c, 0x060c1b0c,   // eu.sw.ro_544 lt.ceb.tl_643  id.tl.ms_543 tr.sv.de_543
  0x6b1e1a11, 0x0f0401a4, 0x046b1caf, 0x08315308,   // tl.ms.ceb_653 en.fi.lv_433  id.ceb.fi_655 ht.az.no_443
  0x1800252b, 0x1852100c, 0x190a05a7, 0x0b00030e,   // eu.ga.un_980 lt.ha.ga_543  fr.pt.gl_532 nl.es.un_550
  // [5170]
  0x13092d04, 0x07001807, 0x0f5528ee, 0x25091ea4,   // sk.pl.et_332 ga.it.un_420  sw.rw.lv_422 ms.pl.eu_433
  0x0a07200c, 0x011f0fa7, 0x0b0306a4, 0x033f1705,   // sq.it.pt_543 lv.cy.en_532  de.nl.es_433 sr.af.nl_333
  0x12000614, 0x1f0a0205, 0x190a2304, 0x270b18a4,   // de.hu.un_660 da.pt.cy_333  ca.pt.gl_332 ga.es.gd_433
  0x20073ba4, 0x0a04010b, 0x05100fa4, 0x524a2804,   // so.it.sq_433 en.fi.pt_542  lv.lt.fr_433 sw.yo.ha_332
  // [5180]
  0x111a27a4, 0x53133fa4, 0x1a001812, 0x3b0a1aa7,   // gd.tl.ro_433 af.et.ht_433  ga.tl.un_640 tl.pt.so_532
  0x1f041aad, 0x291713a9, 0x00000903, 0x2a110712,   // tl.fi.cy_643 et.sr.sl_544  hi.un.un_300 it.ro.mt_654
  0x0a002d11, 0x6b000a22, 0x05091f07, 0x4a32160e,   // sk.pt.un_630 pt.ceb.un_870  cy.pl.fr_432 hr.bs.yo_555
  0x19000a21, 0x6b130507, 0x530d2705, 0x13001a02,   // pt.gl.un_860 fr.et.ceb_432  gd.cs.ht_333 tl.et.un_220
  // [5190]
  0x02130807, 0x0a230eaf, 0x3b52010c, 0x06000a12,   // no.et.da_432 is.ca.pt_655  en.ha.so_543 pt.de.un_640
  0x1f002302, 0x315206af, 0x2000522b, 0x2d0d6b02,   // ca.cy.un_220 de.ha.az_655  ha.sq.un_980 ceb.cs.sk_222
  0x641f5508, 0x64000614, 0x4a000704, 0x311b12b4,   // rw.cy.lg_443 de.lg.un_660  it.yo.un_320 hu.tr.az_754
  0x250b23a7, 0x0664550d, 0x23190a0e, 0x08002507,   // ca.es.eu_532 rw.lg.de_554  pt.gl.ca_555 eu.no.un_420
  // [51a0]
  0x1e1c0b0c, 0x05001f19, 0x06552112, 0x1f002822,   // es.id.ms_543 cy.fr.un_750  jw.rw.de_654 sw.cy.un_870
  0x230d0b04, 0x681b3112, 0x063f09ad, 0x0a2d11af,   // es.cs.ca_332 az.tr.ig_654  pl.af.de_643 ro.sk.pt_655
  0x2a00310d, 0x08100ea9, 0x02000e09, 0x1c28290c,   // az.mt.un_540 is.lt.no_544  is.da.un_440 sl.sw.id_543
  0x4a555202, 0x1f0c25a7, 0x0a2913a4, 0x1b4a6ba4,   // ha.rw.yo_222 eu.sv.cy_532  et.sl.pt_433 ceb.yo.tr_433
  // [51b0]
  0x1c2521ad, 0x1a041fa7, 0x115313a0, 0x3f002813,   // jw.eu.id_643 cy.fi.tl_532  et.ht.ro_322 sw.af.un_650
  0x1a1c1fa0, 0x06132807, 0x20113f07, 0x3b5568a9,   // cy.id.tl_322 sw.et.de_432  af.ro.sq_432 ig.rw.so_544
  0x2b272860, 0x20002721, 0x0b0c250c, 0x2a0827a0,   // sw.gd.vi_664 gd.sq.un_860  eu.sv.es_543 gd.no.mt_322
  0x1f006823, 0x5368055a, 0x190b05af, 0x0a003505,   // ig.cy.un_880 fr.ig.ht_553  fr.es.gl_655 zu.pt.un_330
  // [51c0]
  0x35000a21, 0x1003520c, 0x2d001107, 0x1000251a,   // pt.zu.un_860 ha.nl.lt_543  ro.sk.un_420 eu.lt.un_760
  0x6e1f2bec, 0x28521c0c, 0x28002704, 0x280c1a07,   // vi.cy.hmn_644 id.ha.sw_543  gd.sw.un_320 tl.sv.sw_432
  0x01202811, 0x3b18280c, 0x13283ba4, 0x6b00682a,   // sw.sq.en_653 sw.ga.so_543  so.sw.et_433 ig.ceb.un_970
  0x172855a9, 0x0f071308, 0x0f321005, 0x033b6411,   // rw.sw.sr_544 et.it.lv_443  lt.bs.lv_333 lg.so.nl_653
  // [51d0]
  0x011e2ba0, 0x033b1a0b, 0x3f002504, 0x052b01a6,   // vi.ms.en_322 tl.so.nl_542  eu.af.un_320 en.vi.fr_521
  0x32003107, 0x3f020fa0, 0x21002808, 0x11190baf,   // az.bs.un_420 lv.da.af_322  sw.jw.un_430 es.gl.ro_655
  0x041321af, 0x28523b07, 0x072a0405, 0x5300231a,   // jw.et.fi_655 so.ha.sw_432  fi.mt.it_333 ca.ht.un_760
  0x01002a02, 0x012805ee, 0x2b6b040c, 0x212b1c09,   // mt.en.un_220 fr.sw.en_422  fi.ceb.vi_543 id.vi.jw_444
  // [51e0]
  0x532b28ee, 0x0c000d04, 0x10171111, 0x1828680c,   // sw.vi.ht_422 cs.sv.un_320  ro.sr.be_653 ig.sw.ga_543
  0x0000072d, 0x1f5327a9, 0x324a17a0, 0x5200042c,   // it.un.un_A00 gd.ht.cy_544  sr.yo.bs_322 fi.ha.un_990
  0x102b680d, 0x2b000712, 0x0e0425ad, 0x201923a9,   // ig.vi.lt_554 it.vi.un_640  eu.fi.is_643 ca.gl.sq_544
  0x523b01af, 0x0e0452ad, 0x1b0e31af, 0x13090d5a,   // en.so.ha_655 ha.fi.is_643  az.is.tr_655 ne.hi.bh_553
  // [51f0]
  0x11040da4, 0x552528a4, 0x202723a4, 0x52183ba4,   // cs.fi.ro_433 sw.eu.rw_433  ca.gd.sq_433 so.ga.ha_433
  0x2800291a, 0x1a002113, 0x00000142, 0x6b1a10a7,   // sl.sw.un_760 jw.tl.un_650  en.un.un_C00 lt.tl.ceb_532
  0x061e1f07, 0x310b0eee, 0x1b0e3108, 0x1f00230c,   // cy.ms.de_432 is.es.az_422  az.is.tr_443 ca.cy.un_530
  0x0e04520c, 0x19040b0c, 0x16130404, 0x08000702,   // ha.fi.is_543 es.fi.gl_543  fi.et.hr_332 it.no.un_220
  // [5200]
  0x6b2d1a07, 0x251364a4, 0x0e231f12, 0x07001812,   // tl.sk.ceb_432 lg.et.eu_433  cy.ca.is_654 ga.it.un_640
  0x08231fa4, 0x18551b07, 0x352028af, 0x1b005304,   // cy.ca.no_433 tr.rw.ga_432  sw.sq.zu_655 ht.tr.un_320
  0x23002a22, 0x0f100e12, 0x06082308, 0x6b1a1308,   // mt.ca.un_870 is.lt.lv_654  ca.no.de_443 et.tl.ceb_443
  0x060b1fa0, 0x1712080b, 0x20001c0c, 0x551021ec,   // cy.es.de_322 no.hu.sr_542  id.sq.un_530 jw.lt.rw_644
  // [5210]
  0x4a0d52ee, 0x3b212012, 0x094a1307, 0x55006e04,   // ha.cs.yo_422 sq.jw.so_654  et.yo.pl_432 hmn.rw.un_320
  0x0a051960, 0x191f0a04, 0x1c0429a0, 0x2d0d35a9,   // gl.fr.pt_664 pt.cy.gl_332  sl.fi.id_322 zu.cs.sk_544
  0x2d0d6b14, 0x1e1c10ee, 0x190b3b05, 0x03011007,   // ceb.cs.sk_666 lt.id.ms_422  so.es.gl_333 lt.en.nl_432
  0x531b0ba4, 0x10006b12, 0x060120a0, 0x1b1c6ba4,   // es.tr.ht_433 ceb.lt.un_640  sq.en.de_322 ceb.id.tr_433
  // [5220]
  0x01353fa0, 0x4a2368a4, 0x02001a0d, 0x3b1f6baf,   // af.zu.en_322 ig.ca.yo_433  tl.da.un_540 ceb.cy.so_655
  0x3b001a20, 0x3b2a29a9, 0x1a0931a0, 0x193b0b55,   // tl.so.un_850 sl.mt.so_544  az.pl.tl_322 es.so.gl_442
  0x2302010c, 0x3f0f0112, 0x6400091b, 0x110d2911,   // en.da.ca_543 en.lv.af_654  pl.lg.un_770 sl.cs.ro_653
  0x13010f11, 0x55071c04, 0x08071160, 0x0a0817ee,   // lv.en.et_653 id.it.rw_332  ro.bg.uk_664 sr.uk.mk_422
  // [5230]
  0x0f00011a, 0x1b030aee, 0x6b001212, 0x080229a4,   // en.lv.un_760 pt.nl.tr_422  hu.ceb.un_640 sl.da.no_433
  0x0e002908, 0x55003112, 0x16001a07, 0x0d1e1c13,   // sl.is.un_430 az.rw.un_640  tl.hr.un_420 id.ms.cs_665
  0x68013ba7, 0x2d29010c, 0x04132304, 0x2d0d35a4,   // so.en.ig_532 en.sl.sk_543  ca.et.fi_332 zu.cs.sk_433
  0x06000713, 0x35006e07, 0x126468ad, 0x29000c14,   // it.de.un_650 hmn.zu.un_420  ig.lg.hu_643 sv.sl.un_660
  // [5240]
  0x55356808, 0x04002322, 0x0a2119a4, 0x0b121907,   // ig.zu.rw_443 ca.fi.un_870  gl.jw.pt_433 gl.hu.es_432
  0x1e001304, 0x06000e0c, 0x203564a9, 0x192d0b07,   // et.ms.un_320 is.de.un_530  lg.zu.sq_544 es.sk.gl_432
  0x08120eee, 0x09292008, 0x641a6ba7, 0x3b6855a7,   // is.hu.no_422 sq.sl.pl_443  ceb.tl.lg_532 rw.ig.so_532
  0x10000802, 0x080c0e05, 0x1c521eec, 0x2d0d230c,   // uk.be.un_220 is.sv.no_333  ms.ha.id_644 ca.cs.sk_543
  // [5250]
  0x1e1c3b14, 0x6b2d12a9, 0x4a1a5511, 0x1a2d1208,   // so.id.ms_666 hu.sk.ceb_544  rw.tl.yo_653 hu.sk.tl_443
  0x1b2920ad, 0x201029a4, 0x1b072014, 0x10000704,   // sq.sl.tr_643 sl.lt.sq_433  sq.it.tr_666 it.lt.un_320
  0x25040308, 0x551b200c, 0x212d1209, 0x4a005221,   // nl.fi.eu_443 sq.tr.rw_543  hu.sk.jw_444 ha.yo.un_860
  0x2125120c, 0x1c0d090b, 0x0c081a08, 0x3b13030c,   // hu.eu.jw_543 hi.ne.mr_542  tl.no.sv_443 nl.et.so_543
  // [5260]
  0x4a00682c, 0x1000072b, 0x121f1104, 0x0a190513,   // ig.yo.un_990 bg.be.un_980  ro.cy.hu_332 fr.gl.pt_665
  0x3f2512a4, 0x28250da0, 0x1a122d11, 0x0b0a05a4,   // hu.eu.af_433 cs.eu.sw_322  sk.hu.tl_653 fr.pt.es_433
  0x2d29120d, 0x1c1a1212, 0x520e01af, 0x12001c1a,   // hu.sl.sk_554 hu.tl.id_654  en.is.ha_655 id.hu.un_760
  0x08001707, 0x640313ee, 0x1a001105, 0x19002304,   // sr.uk.un_420 et.nl.lg_422  ro.tl.un_330 ca.gl.un_320
  // [5270]
  0x01023fa0, 0x23190704, 0x0106280d, 0x111b1605,   // af.da.en_322 it.gl.ca_332  sw.de.en_554 hr.tr.ro_333
  0x1f0105a0, 0x0d092d0c, 0x55006823, 0x13040ca0,   // fr.en.cy_322 sk.pl.cs_543  ig.rw.un_880 sv.fi.et_322
  0x6b526813, 0x04644a08, 0x4a002513, 0x0c030609,   // ig.ha.ceb_665 yo.lg.fi_443  eu.yo.un_650 de.nl.sv_444
  0x03005304, 0x53312009, 0x08000321, 0x6800550e,   // ht.nl.un_320 sq.az.ht_444  nl.no.un_860 rw.ig.un_550
  // [5280]
  0x020308a9, 0x273b2011, 0x09642504, 0x0a000735,   // no.nl.da_544 sq.so.gd_653  eu.lg.pl_332 bg.mk.un_A90
  0x23200413, 0x271c010c, 0x3b1b1fec, 0x68003b1b,   // fi.sq.ca_665 en.id.gd_543  cy.tr.so_644 so.ig.un_770
  0x04002019, 0x0b251908, 0x684a0408, 0x061a3bad,   // sq.fi.un_750 gl.eu.es_443  fi.yo.ig_443 so.tl.de_643
  0x100e3f13, 0x0320060c, 0x6b683b05, 0x35551a09,   // af.is.lt_665 de.sq.nl_543  so.ig.ceb_333 tl.rw.zu_444
  // [5290]
  0x6e352108, 0x3b196ea9, 0x0d000504, 0x2a2023a9,   // jw.zu.hmn_443 hmn.gl.so_544  fr.cs.un_320 ca.sq.mt_544
  0x3b3f1308, 0x35281205, 0x6b1b09a4, 0x06000204,   // et.af.so_443 hu.sw.zu_333  pl.tr.ceb_433 da.de.un_320
  0x21521c11, 0x2700351a, 0x35000108, 0x68255508,   // id.ha.jw_653 zu.gd.un_760  en.zu.un_430 rw.eu.ig_443
  0x352804ad, 0x2523520b, 0x35000613, 0x320f6804,   // fi.sw.zu_643 ha.ca.eu_542  de.zu.un_650 ig.lv.bs_332
  // [52a0]
  0x64521a04, 0x35006829, 0x350a07a9, 0x1268550d,   // tl.ha.lg_332 ig.zu.un_960  it.pt.zu_544 rw.ig.hu_554
  0x1b000308, 0x68002818, 0x1c063502, 0x28533b14,   // nl.tr.un_430 sw.ig.un_740  zu.de.id_222 so.ht.sw_666
  0x09213507, 0x3500522a, 0x350d0909, 0x100953ec,   // zu.jw.pl_432 ha.zu.un_970  pl.cs.zu_444 ht.pl.lt_644
  0x06021113, 0x21686404, 0x190a200c, 0x171013a4,   // ro.da.de_665 lg.ig.jw_332  sq.pt.gl_543 et.lt.sr_433
  // [52b0]
  0x0f190d0b, 0x3525090c, 0x06003508, 0x55282108,   // cs.gl.lv_542 pl.eu.zu_543  zu.de.un_430 jw.sw.rw_443
  0x2b131ca9, 0x35551aa9, 0x200c0208, 0x1e100708,   // id.et.vi_544 tl.rw.zu_544  da.sv.sq_443 it.lt.ms_443
  0x552021a4, 0x3f3b6b08, 0x2b271e0c, 0x0c1b080c,   // jw.sq.rw_433 ceb.so.af_443  ms.gd.vi_543 no.tr.sv_543
  0x35002702, 0x061b310d, 0x251a350c, 0x090d13a4,   // gd.zu.un_220 az.tr.de_554  zu.tl.eu_543 bh.ne.hi_433
  // [52c0]
  0x254a68ac, 0x1e001a04, 0x033f1b0c, 0x0f5510ec,   // ig.yo.eu_632 tl.ms.un_320  tr.af.nl_543 lt.rw.lv_644
  0x11551e08, 0x11000514, 0x0b000511, 0x6b1b53ec,   // ms.rw.ro_443 fr.ro.un_660  fr.es.un_630 ht.tr.ceb_644
  0x35526baf, 0x051104a4, 0x102001ad, 0x20005509,   // ceb.ha.zu_655 fi.ro.fr_433  en.sq.lt_643 rw.sq.un_440
  0x356b13ac, 0x03002021, 0x11003b04, 0x1f1118ac,   // et.ceb.zu_632 sq.nl.un_860  so.ro.un_320 ga.ro.cy_632
  // [52d0]
  0x21523b0c, 0x5528130e, 0x293b130c, 0x311c55a0,   // so.ha.jw_543 et.sw.rw_555  et.so.sl_543 rw.id.az_322
  0x3b2519a9, 0x09130d13, 0x1b101ea0, 0x1a001707,   // gl.eu.so_544 ne.bh.hi_665  ms.lt.tr_322 sr.tl.un_420
  0x04290304, 0x10006814, 0x68002012, 0x521b4a0c,   // nl.sl.fi_332 ig.lt.un_660  sq.ig.un_640 yo.tr.ha_543
  0x5221530c, 0x3b556412, 0x1800280e, 0x311b5312,   // ht.jw.ha_543 lg.rw.so_654  sw.ga.un_550 ht.tr.az_654
  // [52e0]
  0x0c4a6e02, 0x1a004a1b, 0x060105ec, 0x64556814,   // hmn.yo.sv_222 yo.tl.un_770  fr.en.de_644 ig.rw.lg_666
  0x03002a12, 0x2a23110d, 0x68003b19, 0x645335af,   // mt.nl.un_640 ro.ca.mt_554  so.ig.un_750 zu.ht.lg_655
  0x551e1f04, 0x04200ca0, 0x64005302, 0x110603ec,   // cy.ms.rw_332 sv.sq.fi_322  ht.lg.un_220 nl.de.ro_644
  0x311b4aac, 0x1f645511, 0x100a07a0, 0x17080405,   // yo.tr.az_632 rw.lg.cy_653  bg.mk.be_322 ru.uk.sr_333
  // [52f0]
  0x0a0817ec, 0x05000b0c, 0x0d00531a, 0x6e1a6baf,   // sr.uk.mk_644 es.fr.un_530  ht.cs.un_760 ceb.tl.hmn_655
  0x0c002a1b, 0x16286408, 0x033f0aaf, 0x2a112308,   // mt.sv.un_770 lg.sw.hr_443  pt.af.nl_655 ca.ro.mt_443
  0x1a5564a4, 0x23110d12, 0x35002a07, 0x1f1a6bec,   // lg.rw.tl_433 cs.ro.ca_654  mt.zu.un_420 ceb.tl.cy_644
  0x523f230c, 0x1800191a, 0x1a003b14, 0x271f0208,   // ca.af.ha_543 gl.ga.un_760  so.tl.un_660 da.cy.gd_443
  // [5300]
  0x1355520e, 0x1f0727a9, 0x32003505, 0x13003519,   // ha.rw.et_555 gd.it.cy_544  zu.bs.un_330 zu.et.un_750
  0x0f64550d, 0x3b211b0c, 0x351b13a4, 0x1a101e07,   // rw.lg.lv_554 tr.jw.so_543  et.tr.zu_433 ms.lt.tl_432
  0x1107130c, 0x64006819, 0x284a645a, 0x170925a7,   // et.it.ro_543 ig.lg.un_750  lg.yo.sw_553 eu.pl.sr_532
  0x2d29100c, 0x35280713, 0x13046408, 0x05110713,   // lt.sl.sk_543 it.sw.zu_665  lg.fi.et_443 it.ro.fr_665
  // [5310]
  0x1e101c0c, 0x2d170d07, 0x12082907, 0x120721ad,   // id.lt.ms_543 cs.sr.sk_432  sl.no.hu_432 jw.it.hu_643
  0x291625ee, 0x3b355304, 0x21005202, 0x35646808,   // eu.hr.sl_422 ht.zu.so_332  ha.jw.un_220 ig.lg.zu_443
  0x3f3b1f12, 0x322a09a4, 0x1e004a19, 0x0500101b,   // cy.so.af_654 pl.mt.bs_433  yo.ms.un_750 lt.fr.un_770
  0x29204a13, 0x0200201a, 0x53001602, 0x202a2104,   // yo.sq.sl_665 sq.da.un_760  hr.ht.un_220 jw.mt.sq_332
  // [5320]
  0x022008ad, 0x172952a7, 0x0a182708, 0x0c20080c,   // no.sq.da_643 ha.sl.sr_532  gd.ga.pt_443 no.sq.sv_543
  0x180e2709, 0x11033fec, 0x120e0cee, 0x2d1729af,   // gd.is.ga_444 af.nl.ro_644  sv.is.hu_422 sl.sr.sk_655
  0x033f2311, 0x2d0807ac, 0x0e250504, 0x0206080c,   // ca.af.nl_653 it.no.sk_632  fr.eu.is_332 no.de.da_543
  0x0d091c07, 0x11000522, 0x1f2327a9, 0x11033f60,   // mr.hi.ne_432 fr.ro.un_870  gd.ca.cy_544 af.nl.ro_664
  // [5330]
  0x13091cac, 0x1c6e1e07, 0x231918a4, 0x03002804,   // mr.hi.bh_632 ms.hmn.id_432  ga.gl.ca_433 sw.nl.un_320
  0x0e020604, 0x206432a4, 0x1a6407ad, 0x2032160d,   // de.da.is_332 bs.lg.sq_433  it.lg.tl_643 hr.bs.sq_554
  0x21002029, 0x0613250c, 0x032555a9, 0x1e2021af,   // sq.jw.un_960 eu.et.de_543  rw.eu.nl_544 jw.sq.ms_655
  0x09550e08, 0x082002af, 0x11061fa4, 0x4a0c6804,   // is.rw.pl_443 da.sq.no_655  cy.de.ro_433 ig.sv.yo_332
  // [5340]
  0x1f002321, 0x3f55070c, 0x100907a4, 0x1f3b07ad,   // ca.cy.un_860 it.rw.af_543  it.pl.lt_433 it.so.cy_643
  0x16042904, 0x011803a0, 0x103b29a0, 0x190113a4,   // sl.fi.hr_332 nl.ga.en_322  sl.so.lt_322 et.en.gl_433
  0x6e2b4aa0, 0x0c002d0d, 0x35006b02, 0x133f0c08,   // yo.vi.hmn_322 sk.sv.un_540  ceb.zu.un_220 sv.af.et_443
  0x030764a7, 0x100b2da0, 0x3b000729, 0x64002108,   // lg.it.nl_532 sk.es.lt_322  it.so.un_960 jw.lg.un_430
  // [5350]
  0x3f0c350c, 0x6e0a1f0c, 0x13232508, 0x285521a9,   // zu.sv.af_543 cy.pt.hmn_543  eu.ca.et_443 jw.rw.sw_544
  0x1906050c, 0x042013ad, 0x2118280c, 0x10002d04,   // fr.de.gl_543 et.sq.fi_643  sw.ga.jw_543 sk.lt.un_320
  0x101f3b13, 0x3b00040c, 0x0a0b19ad, 0x6b001a11,   // so.cy.lt_665 fi.so.un_530  gl.es.pt_643 tl.ceb.un_630
  0x190a0c0c, 0x550c2da0, 0x130c2d07, 0x08171014,   // sv.pt.gl_543 sk.sv.rw_322  sk.sv.et_432 be.sr.uk_666
  // [5360]
  0x52003504, 0x68190b13, 0x55282907, 0x3f036455,   // zu.ha.un_320 es.gl.ig_665  sl.sw.rw_432 lg.nl.af_442
  0x32060fa0, 0x4a00212a, 0x554a6812, 0x520b5504,   // lv.de.bs_322 jw.yo.un_970  ig.yo.rw_654 rw.es.ha_332
  0x02005513, 0x1b646808, 0x101b4aee, 0x551e4aa4,   // rw.da.un_650 ig.lg.tr_443  yo.tr.lt_422 yo.ms.rw_433
  0x11000307, 0x532105a6, 0x32002018, 0x0b4a6808,   // nl.ro.un_420 fr.jw.ht_521  sq.bs.un_740 ig.yo.es_443
  // [5370]
  0x35684aec, 0x190b0207, 0x06110a08, 0x122911a0,   // yo.ig.zu_644 da.es.gl_432  pt.ro.de_443 ro.sl.hu_322
  0x28092913, 0x0e180d12, 0x02003513, 0x18001f0e,   // sl.pl.sw_665 cs.ga.is_654  zu.da.un_650 cy.ga.un_550
  0x3b00011b, 0x11000735, 0x3b180913, 0x190306a4,   // en.so.un_770 bg.ro.un_A90  pl.ga.so_665 de.nl.gl_433
  0x52646b04, 0x1e132107, 0x52001a1b, 0x211b1207,   // ceb.lg.ha_332 jw.et.ms_432  tl.ha.un_770 hu.tr.jw_432
  // [5380]
  0x0700350d, 0x681b5308, 0x2500120d, 0x3500022b,   // zu.it.un_540 ht.tr.ig_443  hu.eu.un_540 da.zu.un_980
  0x1e022505, 0x01062ba0, 0x1e3b1a12, 0x03080e08,   // eu.da.ms_333 vi.de.en_322  tl.so.ms_654 is.no.nl_443
  0x1b1e21a4, 0x093b6e0c, 0x52190bec, 0x0b0223ee,   // jw.ms.tr_433 hmn.so.pl_543  es.gl.ha_644 ca.da.es_422
  0x02001807, 0x09003b0e, 0x08060205, 0x5331120c,   // ga.da.un_420 so.pl.un_550  da.de.no_333 hu.az.ht_543
  // [5390]
  0x0709110c, 0x0a1925ad, 0x25190e0c, 0x066b1aad,   // ro.pl.it_543 eu.gl.pt_643  is.gl.eu_543 tl.ceb.de_643
  0x12092512, 0x201f11ad, 0x1c6b53a0, 0x06002307,   // eu.pl.hu_654 ro.cy.sq_643  ht.ceb.id_322 ca.de.un_420
  0x230621a4, 0x21000607, 0x251710af, 0x110925a0,   // jw.de.ca_433 de.jw.un_420  lt.sr.eu_655 eu.pl.ro_322
  0x552a25a4, 0x3f081208, 0x4a0512a9, 0x040513a0,   // eu.mt.rw_433 hu.no.af_443  hu.fr.yo_544 et.fr.fi_322
  // [53a0]
  0x02185504, 0x68004a21, 0x230a0e05, 0x55640611,   // rw.ga.da_332 yo.ig.un_860  is.pt.ca_333 de.lg.rw_653
  0x0c030502, 0x4a07230c, 0x040a17a6, 0x1c1a2b11,   // fr.nl.sv_222 ca.it.yo_543  sr.mk.ru_521 vi.tl.id_653
  0x1b0d55a0, 0x10001313, 0x086b270d, 0x101b0f60,   // rw.cs.tr_322 et.lt.un_650  gd.ceb.no_554 lv.tr.lt_664
  0x13041eee, 0x6e033f0d, 0x1e1c35a0, 0x1b06210c,   // ms.fi.et_422 af.nl.hmn_554  zu.id.ms_322 jw.de.tr_543
  // [53b0]
  0x1c1a1e07, 0x29004a04, 0x683506af, 0x6b2b010c,   // ms.tl.id_432 yo.sl.un_320  de.zu.ig_655 en.vi.ceb_543
  0x0b1f100d, 0x0c121fad, 0x08023502, 0x07001f23,   // lt.cy.es_554 cy.hu.sv_643  zu.da.no_222 cy.it.un_880
  0x06202aa9, 0x03350612, 0x1c1225ee, 0x0c061fac,   // mt.sq.de_544 de.zu.nl_654  eu.hu.id_422 cy.de.sv_632
  0x0a001f20, 0x0c002018, 0x52071fa4, 0x08000402,   // cy.pt.un_850 sq.sv.un_740  cy.it.ha_433 ru.uk.un_220
  // [53c0]
  0x016b1007, 0x68642508, 0x10080405, 0x0700252c,   // lt.ceb.en_432 eu.lg.ig_443  ru.uk.be_333 eu.it.un_990
  0x29311ba9, 0x68185512, 0x20001e13, 0x190b01ee,   // tr.az.sl_544 rw.ga.ig_654  ms.sq.un_650 en.es.gl_422
  0x130601a6, 0x110704a9, 0x20000d20, 0x0e2a1609,   // en.de.et_521 ru.bg.ro_544  cs.sq.un_850 hr.mt.is_444
  0x101f1ca0, 0x171606a4, 0x21066404, 0x1e12520b,   // id.cy.lt_322 de.hr.sr_433  lg.de.jw_332 ha.hu.ms_542
  // [53d0]
  0x0d002304, 0x04202308, 0x1c061e12, 0x23082007,   // ca.cs.un_320 ca.sq.fi_443  ms.de.id_654 sq.no.ca_432
  0x2300530d, 0x311f0e0c, 0x1255680d, 0x551a3b08,   // ht.ca.un_540 is.cy.az_543  ig.rw.hu_554 so.tl.rw_443
  0x04202105, 0x31011802, 0x28042007, 0x1b250e08,   // jw.sq.fi_333 ga.en.az_222  sq.fi.sw_432 is.eu.tr_443
  0x2325280c, 0x041052ad, 0x1a0e2009, 0x0f10530b,   // sw.eu.ca_543 ha.lt.fi_643  sq.is.tl_444 ht.lt.lv_542
  // [53e0]
  0x355225a4, 0x051e5302, 0x3b2717ee, 0x521e1fa4,   // eu.ha.zu_433 ht.ms.fr_222  sr.gd.so_422 cy.ms.ha_433
  0x290917a0, 0x12135213, 0x231101af, 0x012927a4,   // sr.pl.sl_322 ha.et.hu_665  en.ro.ca_655 gd.sl.en_433
  0x1f002a04, 0x180327af, 0x012311a4, 0x020b6b0c,   // mt.cy.un_320 gd.nl.ga_655  ro.ca.en_433 ceb.es.da_543
  0x2100071a, 0x52002908, 0x094a5212, 0x05000c13,   // it.jw.un_760 sl.ha.un_430  ha.yo.pl_654 sv.fr.un_650
  // [53f0]
  0x28073508, 0x52051ea0, 0x1353250b, 0x531725ee,   // zu.it.sw_443 ms.fr.ha_322  eu.ht.et_542 eu.sr.ht_422
  0x1b250408, 0x25073ba0, 0x070e0aec, 0x1b4a6809,   // fi.eu.tr_443 so.it.eu_322  pt.is.it_644 ig.yo.tr_444
  0x6800022c, 0x04201b13, 0x2a000804, 0x1b00531a,   // da.ig.un_990 tr.sq.fi_665  no.mt.un_320 ht.tr.un_760
  0x2b2301ad, 0x070c25af, 0x55521f07, 0x2b1c01a4,   // en.ca.vi_643 eu.sv.it_655  cy.ha.rw_432 en.id.vi_433

  // [5400]
  0x11005302, 0x120d350c, 0x68000822, 0x280d03a4,   // ht.ro.un_220 zu.cs.hu_543  no.ig.un_870 nl.cs.sw_433
  0x35164a0c, 0x07000622, 0x12003522, 0x681b3b0e,   // yo.hr.zu_543 de.it.un_870  zu.hu.un_870 so.tr.ig_555
  0x0607050c, 0x525328ee, 0x18080c0d, 0x130852a9,   // fr.it.de_543 sw.ht.ha_422  sv.no.ga_554 ha.no.et_544
  0x04171819, 0x324a13ad, 0x23684aec, 0x52005512,   // ar.sr.ru_765 et.yo.bs_643  yo.ig.ca_644 rw.ha.un_640
  // [5410]
  0x4a685355, 0x68132309, 0x0635290c, 0x55004a07,   // ht.ig.yo_442 ca.et.ig_444  sl.zu.de_543 yo.rw.un_420
  0x3f201112, 0x0c0504ee, 0x0100682b, 0x042011ee,   // ro.sq.af_654 fi.fr.sv_422  ig.en.un_980 ro.sq.fi_422
  0x02170cec, 0x20681313, 0x190b010c, 0x0768010b,   // sv.sr.da_644 et.ig.sq_665  en.es.gl_543 en.ig.it_542
  0x2d004a13, 0x202552a0, 0x0e001704, 0x19313b0d,   // yo.sk.un_650 ha.eu.sq_322  sr.is.un_320 so.az.gl_554
  // [5420]
  0x092564a4, 0x35000a35, 0x0d0655ad, 0x03010ca4,   // lg.eu.pl_433 pt.zu.un_A90  rw.de.cs_643 sv.en.nl_433
  0x0c000f18, 0x0e000c2b, 0x050e01af, 0x1029130c,   // lv.sv.un_740 sv.is.un_980  en.is.fr_655 et.sl.lt_543
  0x522313a9, 0x02270812, 0x1255110b, 0x32272d0c,   // et.ca.ha_544 no.gd.da_654  ro.rw.hu_542 sk.gd.bs_543
  0x321601ee, 0x070111a9, 0x20556860, 0x123f1fa9,   // en.hr.bs_422 ro.en.it_544  ig.rw.sq_664 cy.af.hu_544
  // [5430]
  0x0600181a, 0x061203a9, 0x252d1112, 0x02061208,   // ga.de.un_760 nl.hu.de_544  ro.sk.eu_654 hu.de.da_443
  0x2d0d0fa6, 0x0713010c, 0x20190bec, 0x250711a4,   // lv.cs.sk_521 en.et.it_543  es.gl.sq_644 ro.it.eu_433
  0x29006807, 0x12006e0d, 0x6e000c0e, 0x11095505,   // ig.sl.un_420 hmn.hu.un_540  sv.hmn.un_550 rw.pl.ro_333
  0x6e000c12, 0x1a003f1a, 0x0c001012, 0x0a00530c,   // sv.hmn.un_640 af.tl.un_760  lt.sv.un_640 ht.pt.un_530
  // [5440]
  0x28682a0d, 0x28682907, 0x280152a0, 0x291668ac,   // mt.ig.sw_554 sl.ig.sw_432  ha.en.sw_322 ig.hr.sl_632
  0x190a0ea0, 0x685521a9, 0x11050760, 0x53002504,   // is.pt.gl_322 jw.rw.ig_544  it.fr.ro_664 eu.ht.un_320
  0x680555a4, 0x16001019, 0x030f68ee, 0x25070607,   // rw.fr.ig_433 lt.hr.un_750  ig.lv.nl_422 de.it.eu_432
  0x25000f13, 0x283553ee, 0x12002805, 0x3500060c,   // lv.eu.un_650 ht.zu.sw_422  sw.hu.un_330 de.zu.un_530
  // [5450]
  0x0a0523ec, 0x0f006813, 0x291603ee, 0x1a6b18ee,   // ca.fr.pt_644 ig.lv.un_650  nl.hr.sl_422 ga.ceb.tl_422
  0x08001c02, 0x0c353baf, 0x4a00210c, 0x08273fa0,   // id.no.un_220 so.zu.sv_655  jw.yo.un_530 af.gd.no_322
  0x531628ee, 0x04063512, 0x1b3552af, 0x4a002807,   // sw.hr.ht_422 zu.de.fi_654  ha.zu.tr_655 sw.yo.un_420
  0x52534aaf, 0x32550b0c, 0x1e251702, 0x6b311b13,   // yo.ht.ha_655 es.rw.bs_543  sr.eu.ms_222 tr.az.ceb_665
  // [5460]
  0x172568ad, 0x2d320d07, 0x1f003b08, 0x28001a0e,   // ig.eu.sr_643 cs.bs.sk_432  so.cy.un_430 tl.sw.un_550
  0x12001602, 0x31000a04, 0x13090dac, 0x2506550c,   // hr.hu.un_220 pt.az.un_320  ne.hi.bh_632 rw.de.eu_543
  0x020608a4, 0x533504a0, 0x1200550d, 0x32160ba4,   // no.de.da_433 fi.zu.ht_322  rw.hu.un_540 es.hr.bs_433
  0x311b1fa4, 0x04351aa4, 0x11104a02, 0x042564a4,   // cy.tr.az_433 tl.zu.fi_433  yo.lt.ro_222 lg.eu.fi_433
  // [5470]
  0x28093505, 0x55640da4, 0x311b08a9, 0x2302110c,   // zu.pl.sw_333 cs.lg.rw_433  no.tr.az_544 ro.da.ca_543
  0x31006b19, 0x184a0daf, 0x31001a04, 0x0811060d,   // ceb.az.un_750 cs.yo.ga_655  tl.az.un_320 de.ro.no_554
  0x09022305, 0x31001f13, 0x5500120d, 0x681b5508,   // ca.da.pl_333 cy.az.un_650  hu.rw.un_540 rw.tr.ig_443
  0x03000108, 0x190a05af, 0x2d0d0ea9, 0x13000212,   // en.nl.un_430 fr.pt.gl_655  is.cs.sk_544 da.et.un_640
  // [5480]
  0x270e1812, 0x11232508, 0x29001c04, 0x1c32210d,   // ga.is.gd_654 eu.ca.ro_443  id.sl.un_320 jw.bs.id_554
  0x09002519, 0x0601230c, 0x191b0aec, 0x135304ad,   // eu.pl.un_750 ca.en.de_543  pt.tr.gl_644 fi.ht.et_643
  0x10170713, 0x28001f19, 0x0c2a230c, 0x211205a6,   // bg.sr.be_665 cy.sw.un_750  ca.mt.sv_543 fr.hu.jw_521
  0x020508a4, 0x062308a7, 0x2d120cac, 0x021f0807,   // no.fr.da_433 no.ca.de_532  sv.hu.sk_632 no.cy.da_432
  // [5490]
  0x17000c13, 0x18201313, 0x0600051a, 0x03060412,   // sv.sr.un_650 et.sq.ga_665  fr.de.un_760 fi.de.nl_654
  0x0e0f13ad, 0x1e1c06ac, 0x0f110e08, 0x0c000305,   // et.lv.is_643 de.id.ms_632  is.ro.lv_443 nl.sv.un_330
  0x270e010c, 0x3f00041a, 0x090c0812, 0x1f06230c,   // en.is.gd_543 fi.af.un_760  no.sv.pl_654 ca.de.cy_543
  0x53002514, 0x111310ec, 0x21003b1b, 0x1b000408,   // eu.ht.un_660 lt.et.ro_644  so.jw.un_770 fi.tr.un_430
  // [54a0]
  0x21101c0c, 0x6b1a68ac, 0x116b6e08, 0x05181311,   // id.lt.jw_543 ig.tl.ceb_632  hmn.ceb.ro_443 et.ga.fr_653
  0x28000b0e, 0x0f001e13, 0x1b06030d, 0x050a12ad,   // es.sw.un_550 ms.lv.un_650  nl.de.tr_554 hu.pt.fr_643
  0x230a0e55, 0x12001302, 0x06031f13, 0x4a0e1805,   // is.pt.ca_442 et.hu.un_220  cy.nl.de_665 ga.is.yo_333
  0x322820a6, 0x1f2b35ac, 0x52046e12, 0x1a0405a0,   // sq.sw.bs_521 zu.vi.cy_632  hmn.fi.ha_654 fr.fi.tl_322
  // [54b0]
  0x120f6808, 0x35001221, 0x1a1f2111, 0x6e1001a9,   // ig.lv.hu_443 hu.zu.un_860  jw.cy.tl_653 en.lt.hmn_544
  0x11101713, 0x21082011, 0x06000c02, 0x06041b07,   // sr.be.ro_665 sq.no.jw_653  sv.de.un_220 tr.fi.de_432
  0x31041ba4, 0x03041ba7, 0x1b02030c, 0x21002004,   // tr.fi.az_433 tr.fi.nl_532  nl.da.tr_543 sq.jw.un_320
  0x16002702, 0x056b0709, 0x05000607, 0x0e3217a6,   // gd.hr.un_220 it.ceb.fr_444  de.fr.un_420 sr.bs.is_521
  // [54c0]
  0x11006408, 0x2500640d, 0x08020eee, 0x103b35a4,   // lg.ro.un_430 lg.eu.un_540  is.da.no_422 zu.so.lt_433
  0x1a5505ad, 0x31031b07, 0x130425ec, 0x020e0c09,   // fr.rw.tl_643 tr.nl.az_432  eu.fi.et_644 sv.is.da_444
  0x09013f12, 0x091f1a12, 0x3b250b0e, 0x03123bee,   // af.en.pl_654 tl.cy.pl_654  es.eu.so_555 so.hu.nl_422
  0x103f0d11, 0x4a283505, 0x29003505, 0x2d1b25ec,   // cs.af.lt_653 zu.sw.yo_333  zu.sl.un_330 eu.tr.sk_644
  // [54d0]
  0x64063ba4, 0x551f13a7, 0x1e211c55, 0x1a073b0c,   // so.de.lg_433 et.cy.rw_532  id.jw.ms_442 so.it.tl_543
  0x641368a9, 0x0b0a07a4, 0x043f1305, 0x096b4a04,   // ig.et.lg_544 it.pt.es_433  et.af.fi_333 yo.ceb.pl_332
  0x283b10ec, 0x35526402, 0x0a23195a, 0x082a1205,   // lt.so.sw_644 lg.ha.zu_222  gl.ca.pt_553 hu.mt.no_333
  0x6b005212, 0x6b285209, 0x35000722, 0x061809ad,   // ha.ceb.un_640 ha.sw.ceb_444  it.zu.un_870 pl.ga.de_643
  // [54e0]
  0x0d1c1312, 0x2718310c, 0x04554aaf, 0x4a001b1b,   // bh.mr.ne_654 az.ga.gd_543  yo.rw.fi_655 tr.yo.un_770
  0x1200040e, 0x212568ad, 0x08022a0c, 0x20533f08,   // fi.hu.un_550 ig.eu.jw_643  mt.da.no_543 af.ht.sq_443
  0x211b640d, 0x191325ee, 0x1c090dac, 0x3f002018,   // lg.tr.jw_554 eu.et.gl_422  ne.hi.mr_632 sq.af.un_740
  0x0a000519, 0x08020c0d, 0x533f230c, 0x0c003f02,   // fr.pt.un_750 sv.da.no_554  ca.af.ht_543 af.sv.un_220
  // [54f0]
  0x031a3faf, 0x1e1c10a4, 0x020f11ad, 0x3200550c,   // af.tl.nl_655 lt.id.ms_433  ro.lv.da_643 rw.bs.un_530
  0x3f002021, 0x2500272b, 0x0d00521a, 0x35004a12,   // sq.af.un_860 gd.eu.un_980  ha.cs.un_760 yo.zu.un_640
  0x35256ba4, 0x06032709, 0x04110a05, 0x08000e05,   // ceb.eu.zu_433 gd.nl.de_444  mk.ro.ru_333 is.no.un_330
  0x126b1a0d, 0x2d0d07a6, 0x212518a4, 0x183f1105,   // tl.ceb.hu_554 it.cs.sk_521  ga.eu.jw_433 ro.af.ga_333
  // [5500]
  0x252307a0, 0x0d006b04, 0x28000a05, 0x08020614,   // it.ca.eu_322 ceb.cs.un_320  pt.sw.un_330 de.da.no_666
  0x116b27a0, 0x0e6b5307, 0x0429090c, 0x04642508,   // gd.ceb.ro_322 ht.ceb.is_432  pl.sl.fi_543 eu.lg.fi_443
  0x350153a7, 0x681a2507, 0x2d3b6405, 0x04642512,   // ht.en.zu_532 eu.tl.ig_432  lg.so.sk_333 eu.lg.fi_654
  0x0d356eac, 0x0c081b09, 0x0c310808, 0x04191f11,   // hmn.zu.cs_632 tr.no.sv_444  no.az.sv_443 cy.gl.fi_653
  // [5510]
  0x68130414, 0x08004a0d, 0x4a6468a0, 0x04162da9,   // fi.et.ig_666 yo.no.un_540  ig.lg.yo_322 sk.hr.fi_544
  0x080b310c, 0x100464a4, 0x16002708, 0x3b1b045a,   // az.es.no_543 lg.fi.lt_433  gd.hr.un_430 fi.tr.so_553
  0x0d092d07, 0x130c04a6, 0x31000c0d, 0x12532812,   // sk.pl.cs_432 fi.sv.et_521  sv.az.un_540 sw.ht.hu_654
  0x21283bad, 0x0a0f0d11, 0x23311b0d, 0x353b6807,   // so.sw.jw_643 cs.lv.pt_653  tr.az.ca_554 ig.so.zu_432
  // [5520]
  0x31081b12, 0x530568ec, 0x16002504, 0x2a006404,   // tr.no.az_654 ig.fr.ht_644  eu.hr.un_320 lg.mt.un_320
  0x68002108, 0x683521a4, 0x53006e12, 0x3b006821,   // jw.ig.un_430 jw.zu.ig_433  hmn.ht.un_640 ig.so.un_860
  0x6e1e1c13, 0x043b03a9, 0x253b04ad, 0x040925ee,   // id.ms.hmn_665 nl.so.fi_544  fi.so.eu_643 eu.pl.fi_422
  0x281e1c0c, 0x03043b12, 0x043f2509, 0x25003b22,   // id.ms.sw_543 so.fi.nl_654  eu.af.fi_444 so.eu.un_870
  // [5530]
  0x31003207, 0x55281a12, 0x1f180911, 0x090a2da4,   // bs.az.un_420 tl.sw.rw_654  pl.ga.cy_653 sk.pt.pl_433
  0x130f1ba4, 0x080c1eec, 0x35315505, 0x3b004a13,   // tr.lv.et_433 ms.sv.no_644  rw.az.zu_333 yo.so.un_650
  0x25003b18, 0x10526412, 0x033b040d, 0x645355ad,   // so.eu.un_740 lg.ha.lt_654  fi.so.nl_554 rw.ht.lg_643
  0x08200ead, 0x3b00042a, 0x2853100c, 0x0f022508,   // is.sq.no_643 fi.so.un_970  lt.ht.sw_543 eu.da.lv_443
  // [5540]
  0x2d0d0fa9, 0x08021bec, 0x6400280d, 0x6b003204,   // lv.cs.sk_544 tr.da.no_644  sw.lg.un_540 bs.ceb.un_320
  0x28032b12, 0x08021baf, 0x06102304, 0x2b190513,   // vi.nl.sw_654 tr.da.no_655  ca.lt.de_332 fr.gl.vi_665
  0x2b00051a, 0x081b0208, 0x2b071112, 0x23072bad,   // fr.vi.un_760 da.tr.no_443  ro.it.vi_654 vi.it.ca_643
  0x19000e0c, 0x2a130708, 0x08021b12, 0x1b00080d,   // is.gl.un_530 it.et.mt_443  tr.da.no_654 no.tr.un_540
  // [5550]
  0x17000802, 0x3f000504, 0x2b051f0c, 0x31051bec,   // uk.sr.un_220 fr.af.un_320  cy.fr.vi_543 tr.fr.az_644
  0x021b0808, 0x04052b08, 0x1c130da4, 0x2b1104a9,   // no.tr.da_443 vi.fr.fi_443  ne.bh.mr_433 fi.ro.vi_544
  0x042b05af, 0x04005208, 0x23002b07, 0x3b000e12,   // fr.vi.fi_655 ha.fi.un_430  vi.ca.un_420 is.so.un_640
  0x0c000802, 0x1c130dad, 0x531f05ad, 0x01005302,   // no.sv.un_220 ne.bh.mr_643  fr.cy.ht_643 ht.en.un_220
  // [5560]
  0x23110404, 0x3b101aec, 0x323b1aa4, 0x012321a4,   // fi.ro.ca_332 tl.lt.so_644  tl.so.bs_433 jw.ca.en_433
  0x3f1f0308, 0x256b550c, 0x6b255311, 0x55080cad,   // nl.cy.af_443 rw.ceb.eu_543  ht.eu.ceb_653 sv.no.rw_643
  0x0a000511, 0x531b0507, 0x531c05ee, 0x05000a1a,   // fr.pt.un_630 fr.tr.ht_432  fr.id.ht_422 pt.fr.un_760
  0x3b1a5512, 0x35006407, 0x0c002707, 0x6e003f2b,   // rw.tl.so_654 lg.zu.un_420  gd.sv.un_420 af.hmn.un_980
  // [5570]
  0x3f6e0811, 0x0d03110c, 0x20001e11, 0x19182760,   // no.hmn.af_653 ro.nl.cs_543  ms.sq.un_630 gd.ga.gl_664
  0x04120faf, 0x27086ead, 0x052718ec, 0x031c3fad,   // lv.hu.fi_655 hmn.no.gd_643  ga.gd.fr_644 af.id.nl_643
  0x6e052314, 0x2a001a04, 0x040d6b0c, 0x6b3528a6,   // ca.fr.hmn_666 tl.mt.un_320  ceb.cs.fi_543 sw.zu.ceb_521
  0x161c290c, 0x213b20ad, 0x2d090c09, 0x10556405,   // sl.id.hr_543 sq.so.jw_643  sv.pl.sk_444 lg.rw.lt_333
  // [5580]
  0x2b086813, 0x101f0411, 0x2a070407, 0x11000622,   // ig.no.vi_665 fi.cy.lt_653  fi.it.mt_432 de.ro.un_870
  0x0f1210a9, 0x6b1e1cec, 0x2b006e22, 0x211e050c,   // lt.hu.lv_544 id.ms.ceb_644  hmn.vi.un_870 fr.ms.jw_543
  0x1a2052a0, 0x0e003504, 0x29005202, 0x25521baf,   // ha.sq.tl_322 zu.is.un_320  ha.sl.un_220 tr.ha.eu_655
  0x1b3108a4, 0x1c1e520b, 0x18283ba0, 0x070911ad,   // no.az.tr_433 ha.ms.id_542  so.sw.ga_322 ro.pl.it_643
  // [5590]
  0x1c000f02, 0x6e002b2a, 0x4a5352a4, 0x190a0daf,   // lv.id.un_220 vi.hmn.un_970  ha.ht.yo_433 cs.pt.gl_655
  0x35006e1a, 0x1304525a, 0x35080e02, 0x290e090c,   // hmn.zu.un_760 ha.fi.et_553  is.no.zu_222 pl.is.sl_543
  0x3f25100c, 0x030507a4, 0x351b5555, 0x1c0d09a9,   // lt.eu.af_543 it.fr.nl_433  rw.tr.zu_442 hi.ne.mr_544
  0x2a105505, 0x090d3b07, 0x080c1c02, 0x19235302,   // rw.lt.mt_333 so.cs.pl_432  id.sv.no_222 ht.ca.gl_222
  // [55a0]
  0x170c21a4, 0x2b1c3fa7, 0x06070e0c, 0x211c08a4,   // jw.sv.sr_433 af.id.vi_532  is.it.de_543 no.id.jw_433
  0x061368a0, 0x1e000c02, 0x13002b19, 0x531001a4,   // ig.et.de_322 sv.ms.un_220  vi.et.un_750 en.lt.ht_433
  0x25046812, 0x13046b14, 0x132d0408, 0x03085311,   // ig.fi.eu_654 ceb.fi.et_666  fi.sk.et_443 ht.no.nl_653
  0x2b000104, 0x1c004a04, 0x6e272355, 0x110a07a0,   // en.vi.un_320 yo.id.un_320  ca.gd.hmn_442 it.pt.ro_322
  // [55b0]
  0x120c1bec, 0x132b2807, 0x2a211905, 0x27530ea4,   // tr.sv.hu_644 sw.vi.et_432  gl.jw.mt_333 is.ht.gd_433
  0x0b111908, 0x130c0413, 0x6e6b3502, 0x20000b09,   // gl.ro.es_443 fi.sv.et_665  zu.ceb.hmn_222 es.sq.un_440
  0x355521ee, 0x02203f12, 0x0400642a, 0x292a0eee,   // jw.rw.zu_422 af.sq.da_654  lg.fi.un_970 is.mt.sl_422
  0x1c0d09ee, 0x181b0e04, 0x0802030c, 0x1b000e08,   // hi.ne.mr_422 is.tr.ga_332  nl.da.no_543 is.tr.un_430
  // [55c0]
  0x25001705, 0x21132d08, 0x06003205, 0x1f35090c,   // sr.eu.un_330 sk.et.jw_443  bs.de.un_330 pl.zu.cy_543
  0x11550b05, 0x280518a4, 0x682a4aad, 0x520306ad,   // es.rw.ro_333 ga.fr.sw_433  yo.mt.ig_643 de.nl.ha_643
  0x3f030faf, 0x0304210c, 0x092d3f04, 0x133b030c,   // lv.nl.af_655 jw.fi.nl_543  af.sk.pl_332 nl.so.et_543
  0x1c1712ad, 0x080204a0, 0x0f4a68ec, 0x211268ec,   // hu.sr.id_643 fi.da.no_322  ig.yo.lv_644 ig.hu.jw_644
  // [55d0]
  0x2a18010c, 0x5200010d, 0x0f101b08, 0x0a001012,   // en.ga.mt_543 en.ha.un_540  tr.lt.lv_443 lt.pt.un_640
  0x1300682b, 0x120f10a4, 0x52006808, 0x64001c1a,   // ig.et.un_980 lt.lv.hu_433  ig.ha.un_430 id.lg.un_760
  0x25556b55, 0x1b033f0d, 0x2a02010d, 0x28002a12,   // ceb.rw.eu_442 af.nl.tr_554  en.da.mt_554 mt.sw.un_640
  0x0d112da0, 0x08520207, 0x6e0a13ee, 0x09281ca4,   // sk.ro.cs_322 da.ha.no_432  et.pt.hmn_422 id.sw.pl_433
  // [55e0]
  0x0c003107, 0x21031fa4, 0x5200201b, 0x68283505,   // az.sv.un_420 cy.nl.jw_433  sq.ha.un_770 zu.sw.ig_333
  0x17095208, 0x13556ba4, 0x0a11100c, 0x160752ee,   // ha.pl.sr_443 ceb.rw.et_433  be.ro.mk_543 ha.it.hr_422
  0x20001107, 0x201152a0, 0x0f2a070c, 0x21045308,   // ro.sq.un_420 ha.ro.sq_322  it.mt.lv_543 ht.fi.jw_443
  0x120c2aa0, 0x4a2a070c, 0x0c002904, 0x0a521107,   // mt.sv.hu_322 it.mt.yo_543  sl.sv.un_320 ro.ha.pt_432
  // [55f0]
  0x6b2a2dec, 0x0b00111a, 0x21003f07, 0x52001102,   // sk.mt.ceb_644 ro.es.un_760  af.jw.un_420 ro.ha.un_220
  0x0a002302, 0x12131f08, 0x29001012, 0x13251260,   // ca.pt.un_220 cy.et.hu_443  lt.sl.un_640 hu.eu.et_664
  0x10000919, 0x11120aa0, 0x0d1c09a7, 0x356812a4,   // pl.lt.un_750 pt.hu.ro_322  hi.mr.ne_532 hu.ig.zu_433
  0x3f003b13, 0x0a100702, 0x1300680d, 0x2d110d0c,   // so.af.un_650 bg.be.mk_222  ig.et.un_540 cs.ro.sk_543
  // [5600]
  0x0e001e02, 0x2a0628af, 0x2d290913, 0x1f294aad,   // ms.is.un_220 sw.de.mt_655  pl.sl.sk_665 yo.sl.cy_643
  0x12003105, 0x09530407, 0x521312a7, 0x3f004a1a,   // az.hu.un_330 fi.ht.pl_432  hu.et.ha_532 yo.af.un_760
  0x196b0bad, 0x23280714, 0x0e1b2008, 0x0455530c,   // es.ceb.gl_643 it.sw.ca_666  sq.tr.is_443 ht.rw.fi_543
  0x31641b0d, 0x130e23ee, 0x211b3114, 0x080a05a9,   // tr.lg.az_554 ca.is.et_422  az.tr.jw_666 fr.pt.no_544
  // [5610]
  0x25100ead, 0x5500080d, 0x282555a9, 0x2b000722,   // is.lt.eu_643 no.rw.un_540  rw.eu.sw_544 it.vi.un_870
  0x03681f0c, 0x0e0635ec, 0x0f000320, 0x10530408,   // cy.ig.nl_543 zu.de.is_644  nl.lv.un_850 fi.ht.lt_443
  0x04001b08, 0x09001704, 0x1e021ca4, 0x201b6411,   // tr.fi.un_430 sr.pl.un_320  id.da.ms_433 lg.tr.sq_653
  0x0e051ba4, 0x0c080da0, 0x063f1ca4, 0x55131a0c,   // tr.fr.is_433 cs.no.sv_322  id.af.de_433 tl.et.rw_543
  // [5620]
  0x0c352a04, 0x1a64550c, 0x350264a4, 0x060b55a4,   // mt.zu.sv_332 rw.lg.tl_543  lg.da.zu_433 rw.es.de_433
  0x063564a4, 0x0e003b07, 0x55061a05, 0x206e0112,   // lg.zu.de_433 so.is.un_420  tl.de.rw_333 en.hmn.sq_654
  0x16002307, 0x08040b02, 0x0c000502, 0x5531210c,   // ca.hr.un_420 es.fi.no_222  fr.sv.un_220 jw.az.rw_543
  0x0e2909a4, 0x1b033205, 0x4a000d04, 0x1e1c2102,   // pl.sl.is_433 bs.nl.tr_333  cs.yo.un_320 jw.id.ms_222
  // [5630]
  0x1b35310c, 0x07112d0c, 0x120720af, 0x20280ead,   // az.zu.tr_543 sk.ro.it_543  sq.it.hu_655 is.sw.sq_643
  0x6b6423ad, 0x3f0453a9, 0x531e3fad, 0x0f1b0512,   // ca.lg.ceb_643 ht.fi.af_544  af.ms.ht_643 fr.tr.lv_654
  0x08020c08, 0x35250608, 0x68553505, 0x2d000912,   // sv.da.no_443 de.eu.zu_443  zu.rw.ig_333 pl.sk.un_640
  0x6b002713, 0x0b5511a4, 0x03002009, 0x25015505,   // gd.ceb.un_650 ro.rw.es_433  sq.nl.un_440 rw.en.eu_333
  // [5640]
  0x0a080e12, 0x2d080d07, 0x642835ee, 0x350a550c,   // is.no.pt_654 cs.no.sk_432  zu.sw.lg_422 rw.pt.zu_543
  0x0a251b08, 0x1f0419ee, 0x0c083555, 0x0e1f06a9,   // tr.eu.pt_443 gl.fi.cy_422  zu.no.sv_442 de.cy.is_544
  0x271f060c, 0x0a230ea9, 0x081f0508, 0x08000c11,   // de.cy.gd_543 is.ca.pt_544  fr.cy.no_443 sv.no.un_630
  0x1e1b28ad, 0x0c025509, 0x01000a04, 0x2a000f08,   // sw.tr.ms_643 rw.da.sv_444  pt.en.un_320 lv.mt.un_430
  // [5650]
  0x1b00250c, 0x0329640c, 0x28646808, 0x0b1f070c,   // eu.tr.un_530 lg.sl.nl_543  ig.lg.sw_443 it.cy.es_543
  0x080c05ec, 0x05002702, 0x0c000a05, 0x2a000204,   // fr.sv.no_644 gd.fr.un_220  pt.sv.un_330 da.mt.un_320
  0x2d0d13a4, 0x01091f04, 0x285218a9, 0x52006b02,   // et.cs.sk_433 cy.pl.en_332  ga.ha.sw_544 ceb.ha.un_220
  0x0d282d07, 0x08040e12, 0x35550255, 0x0800060e,   // sk.sw.cs_432 is.fi.no_654  da.rw.zu_442 de.no.un_550
  // [5660]
  0x10000f07, 0x03001b02, 0x09016ba4, 0x0c00291a,   // lv.lt.un_420 tr.nl.un_220  ceb.en.pl_433 sl.sv.un_760
  0x3f1306a0, 0x1810270e, 0x080206af, 0x0c080708,   // de.et.af_322 gd.lt.ga_555  de.da.no_655 it.no.sv_443
  0x0a00072c, 0x0b0507a4, 0x320916ee, 0x06293f02,   // bg.mk.un_990 it.fr.es_433  hr.pl.bs_422 af.sl.de_222
  0x061225a7, 0x070b2314, 0x0d052113, 0x2d210d12,   // eu.hu.de_532 ca.es.it_666  jw.fr.cs_665 cs.jw.sk_654
  // [5670]
  0x6b011fa9, 0x1a023f04, 0x28001a22, 0x03000520,   // cy.en.ceb_544 af.da.tl_332  tl.sw.un_870 fr.nl.un_850
  0x6b352112, 0x08110308, 0x354a5514, 0x3b00290e,   // jw.zu.ceb_654 nl.ro.no_443  rw.yo.zu_666 sl.so.un_550
  0x05002311, 0x25000a04, 0x21001012, 0x2d0d4a05,   // ca.fr.un_630 pt.eu.un_320  lt.jw.un_640 yo.cs.sk_333
  0x64351902, 0x25271204, 0x6800211a, 0x1008110c,   // gl.zu.lg_222 hu.gd.eu_332  jw.ig.un_760 ro.uk.be_543
  // [5680]
  0x06001122, 0x12001704, 0x16001107, 0x4a21050e,   // ro.de.un_870 sr.hu.un_320  ro.hr.un_420 fr.jw.yo_555
  0x64014aa7, 0x0d131c0c, 0x2d0d05a9, 0x25202112,   // yo.en.lg_532 mr.bh.ne_543  fr.cs.sk_544 jw.sq.eu_654
  0x17072907, 0x0600550d, 0x28006e13, 0x4a006b04,   // sl.it.sr_432 rw.de.un_540  hmn.sw.un_650 ceb.yo.un_320
  0x1b002520, 0x272d5507, 0x030b01a9, 0x211e1804,   // eu.tr.un_850 rw.sk.gd_432  en.es.nl_544 ga.ms.jw_332
  // [5690]
  0x53003f35, 0x1c041360, 0x320901ac, 0x233f53ec,   // af.ht.un_A90 et.fi.id_664  en.pl.bs_632 ht.af.ca_644
  0x0c53210c, 0x53001c2b, 0x53233fad, 0x19530a04,   // jw.ht.sv_543 id.ht.un_980  af.ca.ht_643 pt.ht.gl_332
  0x05532308, 0x04005221, 0x2d180d12, 0x53003f1a,   // ca.ht.fr_443 ha.fi.un_860  cs.ga.sk_654 af.ht.un_760
  0x1004520c, 0x182d0d0c, 0x27070b08, 0x550e53a9,   // ha.fi.lt_543 cs.sk.ga_543  es.it.gd_443 ht.is.rw_544
  // [56a0]
  0x29020ea4, 0x16044aa0, 0x2d0d1809, 0x35016ba0,   // is.da.sl_433 yo.fi.hr_322  ga.cs.sk_444 ceb.en.zu_322
  0x53113f55, 0x3f005334, 0x0d001709, 0x53006419,   // af.ro.ht_442 ht.af.un_A80  sr.cs.un_440 lg.ht.un_750
  0x1b00522b, 0x03533f12, 0x18000d21, 0x20000534,   // ha.tr.un_980 af.ht.nl_654  cs.ga.un_860 fr.sq.un_A80
  0x10001f19, 0x644a35ad, 0x190b35ee, 0x3b0f520c,   // cy.lt.un_750 zu.yo.lg_643  zu.es.gl_422 ha.lv.so_543
  // [56b0]
  0x230f0608, 0x09523bad, 0x101304ad, 0x18000d13,   // de.lv.ca_443 so.ha.pl_643  fi.et.lt_643 cs.ga.un_650
  0x521b4aad, 0x10011f12, 0x09001220, 0x131c095a,   // yo.tr.ha_643 cy.en.lt_654  hu.pl.un_850 hi.mr.bh_553
  0x251c21a9, 0x2a000512, 0x19000609, 0x09215509,   // jw.id.eu_544 fr.mt.un_640  de.gl.un_440 rw.jw.pl_444
  0x03023fa9, 0x09000f08, 0x053f2312, 0x231925a4,   // af.da.nl_544 lv.pl.un_430  ca.af.fr_654 eu.gl.ca_433
  // [56c0]
  0x351b1208, 0x07192b13, 0x1000522c, 0x3f030e05,   // hu.tr.zu_443 vi.gl.it_665  ha.lt.un_990 is.nl.af_333
  0x05251012, 0x521108a4, 0x4a2b0fad, 0x031125ad,   // lt.eu.fr_654 no.ro.ha_433  lv.vi.yo_643 eu.ro.nl_643
  0x2d0d68a0, 0x0d001812, 0x551228af, 0x310c2aa4,   // ig.cs.sk_322 ga.cs.un_640  sw.hu.rw_655 mt.sv.az_433
  0x0c250808, 0x6e0752ad, 0x1f07190c, 0x0d0f2dec,   // no.eu.sv_443 ha.it.hmn_643  gl.it.cy_543 sk.lv.cs_644
  // [56d0]
  0x2b00251b, 0x0a1b110c, 0x28526e0e, 0x2b236ea9,   // eu.vi.un_770 ro.tr.pt_543  hmn.ha.sw_555 hmn.ca.vi_544
  0x0f11250d, 0x07521f08, 0x55001b20, 0x6e1352ec,   // eu.ro.lv_554 cy.ha.it_443  tr.rw.un_850 ha.et.hmn_644
  0x2d0d3fa4, 0x03130111, 0x033f20ad, 0x061f0308,   // af.cs.sk_433 en.et.nl_653  sq.af.nl_643 nl.cy.de_443
  0x040a0f12, 0x130329ee, 0x2b041012, 0x521125af,   // lv.pt.fi_654 sl.nl.et_422  lt.fi.vi_654 eu.ro.ha_655
  // [56e0]
  0x1e1c68a4, 0x0c3b0ea6, 0x012d05a0, 0x03001e02,   // ig.id.ms_433 is.so.sv_521  fr.sk.en_322 ms.nl.un_220
  0x6b01050c, 0x06192507, 0x010d050c, 0x010305ad,   // fr.en.ceb_543 eu.gl.de_432  fr.cs.en_543 fr.nl.en_643
  0x2a001112, 0x23001008, 0x23053f09, 0x060305a0,   // ro.mt.un_640 lt.ca.un_430  af.fr.ca_444 fr.nl.de_322
  0x35000304, 0x010607ec, 0x2d0d06ee, 0x1053020c,   // nl.zu.un_320 it.de.en_644  de.cs.sk_422 da.ht.lt_543
  // [56f0]
  0x1e271ca9, 0x274a2107, 0x532b52a4, 0x0f6e20a9,   // id.gd.ms_544 jw.yo.gd_432  ha.vi.ht_433 sq.hmn.lv_544
  0x02253bad, 0x0c251a0c, 0x10290dad, 0x643b1f0d,   // so.eu.da_643 tl.eu.sv_543  cs.sl.lt_643 cy.so.lg_554
  0x2b522dee, 0x1e2855a0, 0x3b1752a4, 0x1f00530e,   // sk.ha.vi_422 rw.sw.ms_322  ha.sr.so_433 ht.cy.un_550
  0x68100504, 0x2b1f27a4, 0x1900520b, 0x1e536e0c,   // fr.lt.ig_332 gd.cy.vi_433  ha.gl.un_520 hmn.ht.ms_543
  // [5700]
  0x0a00021a, 0x1c521a0c, 0x1f001a1b, 0x251f2708,   // da.pt.un_760 tl.ha.id_543  tl.cy.un_770 gd.cy.eu_443
  0x2d0d3fee, 0x16000104, 0x21271c08, 0x536e1f0c,   // af.cs.sk_422 en.hr.un_320  id.gd.jw_443 cy.hmn.ht_543
  0x051c1a0c, 0x321a16ee, 0x07056407, 0x6e000d0d,   // tl.id.fr_543 hr.tl.bs_422  lg.fr.it_432 cs.hmn.un_540
  0x21006818, 0x10002009, 0x3255210c, 0x040912a4,   // ig.jw.un_740 sq.lt.un_440  jw.rw.bs_543 hu.pl.fi_433
  // [5710]
  0x3f0305a0, 0x03023f14, 0x05001f0e, 0x320f0da0,   // fr.nl.af_322 af.da.nl_666  cy.fr.un_550 cs.lv.bs_322
  0x64002502, 0x171329ee, 0x0c2a290c, 0x160d2905,   // eu.lg.un_220 sl.et.sr_422  sl.mt.sv_543 sl.cs.hr_333
  0x23000614, 0x3f211ea4, 0x0e311b08, 0x1f1e270c,   // de.ca.un_660 ms.jw.af_433  tr.az.is_443 gd.ms.cy_543
  0x64004a19, 0x08000704, 0x35211aad, 0x283b5208,   // yo.lg.un_750 bg.uk.un_320  tl.jw.zu_643 ha.so.sw_443
  // [5720]
  0x1b0e310c, 0x1b3113a0, 0x08171b07, 0x32001220,   // az.is.tr_543 et.az.tr_322  tr.sr.no_432 hu.bs.un_850
  0x190a01ee, 0x182d120c, 0x4a003b08, 0x680f3b0c,   // en.pt.gl_422 hu.sk.ga_543  so.yo.un_430 so.lv.ig_543
  0x04023107, 0x3b1e68a4, 0x20131004, 0x6b004a2b,   // az.da.fi_432 ig.ms.so_433  lt.et.sq_332 yo.ceb.un_980
  0x283b0fad, 0x1c1b210c, 0x1c1f18a0, 0x0a0c070c,   // lv.so.sw_643 jw.tr.id_543  ga.cy.id_322 it.sv.pt_543
  // [5730]
  0x6b13010c, 0x684a3b0c, 0x122a130d, 0x20043b0c,   // en.et.ceb_543 so.yo.ig_543  et.mt.hu_554 so.fi.sq_543
  0x1c0312a7, 0x4a003b18, 0x0d1c09ee, 0x55003534,   // hu.nl.id_532 so.yo.un_740  hi.mr.ne_422 zu.rw.un_A80
  0x52006813, 0x1b1c3b0c, 0x03066402, 0x3b044a07,   // ig.ha.un_650 so.id.tr_543  lg.de.nl_222 yo.fi.so_432
  0x08021aa4, 0x05006b04, 0x1e6b01ee, 0x256835ad,   // tl.da.no_433 ceb.fr.un_320  en.ceb.ms_422 zu.ig.eu_643
  // [5740]
  0x02062a11, 0x0b002314, 0x16000e05, 0x08002304,   // mt.de.da_653 ca.es.un_660  is.hr.un_330 ca.no.un_320
  0x13000113, 0x100e16a0, 0x23001307, 0x0500130d,   // en.et.un_650 hr.is.lt_322  et.ca.un_420 et.fr.un_540
  0x0e211caf, 0x024a1cad, 0x1a002807, 0x0b000a12,   // id.jw.is_655 id.yo.da_643  sw.tl.un_420 pt.es.un_640
  0x16000d19, 0x55000302, 0x0200290b, 0x1b003207,   // cs.hr.un_750 nl.rw.un_220  sl.da.un_520 bs.tr.un_420
  // [5750]
  0x050c070c, 0x313f2008, 0x190b09a4, 0x3b211e0d,   // it.sv.fr_543 sq.af.az_443  pl.es.gl_433 ms.jw.so_554
  0x043b0305, 0x216b1c09, 0x1c041e11, 0x04683b0c,   // nl.so.fi_333 id.ceb.jw_444  ms.fi.id_653 so.ig.fi_543
  0x190b1a08, 0x21041e0c, 0x17322955, 0x133f1812,   // tl.es.gl_443 ms.fi.jw_543  sl.bs.sr_442 ga.af.et_654
  0x1b31680d, 0x033f3ba9, 0x4a683bad, 0x2a2103ac,   // ig.az.tr_554 so.af.nl_544  so.ig.yo_643 nl.jw.mt_632
  // [5760]
  0x121b0d0b, 0x32681a08, 0x0d2512a9, 0x1c1e3b12,   // cs.tr.hu_542 tl.ig.bs_443  hu.eu.cs_544 so.ms.id_654
  0x190b1faf, 0x68354a12, 0x121b1c12, 0x32161ea9,   // cy.es.gl_655 yo.zu.ig_654  id.tr.hu_654 ms.hr.bs_544
  0x190b03a4, 0x06100c04, 0x1a003b12, 0x031a1309,   // nl.es.gl_433 sv.lt.de_332  so.tl.un_640 et.tl.nl_444
  0x4a3b285a, 0x0802180c, 0x19002119, 0x350206a4,   // sw.so.yo_553 ga.da.no_543  jw.gl.un_750 de.da.zu_433
  // [5770]
  0x3f030907, 0x250d1208, 0x1a2b18a0, 0x042029ad,   // pl.nl.af_432 hu.cs.eu_443  ga.vi.tl_322 sl.sq.fi_643
  0x2a000a1b, 0x06120305, 0x3500252a, 0x0400281a,   // pt.mt.un_770 nl.hu.de_333  eu.zu.un_970 sw.fi.un_760
  0x03000607, 0x1b121ca4, 0x033f1e0d, 0x0c001f11,   // de.nl.un_420 id.hu.tr_433  ms.af.nl_554 cy.sv.un_630
  0x29001208, 0x640752a4, 0x182a270c, 0x0b2955ee,   // hu.sl.un_430 ha.it.lg_433  gd.mt.ga_543 rw.sl.es_422
  // [5780]
  0x251118ec, 0x641235ec, 0x17200655, 0x05001811,   // ga.ro.eu_644 zu.hu.lg_644  de.sq.sr_442 ga.fr.un_630
  0x231907a4, 0x06001221, 0x190b2311, 0x2d002307,   // it.gl.ca_433 hu.de.un_860  ca.es.gl_653 ca.sk.un_420
  0x1000250e, 0x550d3555, 0x211c1f0c, 0x1c0d13a9,   // eu.lt.un_550 zu.cs.rw_442  cy.id.jw_543 bh.ne.mr_544
  0x3b0b2b12, 0x550105a0, 0x2a20520c, 0x08020daf,   // vi.es.so_654 fr.en.rw_322  ha.sq.mt_543 cs.da.no_655
  // [5790]
  0x1c6412ad, 0x1700280d, 0x2d0d3202, 0x35001a02,   // hu.lg.id_643 sw.sr.un_540  bs.cs.sk_222 tl.zu.un_220
  0x07280b08, 0x1200642a, 0x1b2753a0, 0x32002807,   // es.sw.it_443 lg.hu.un_970  ht.gd.tr_322 sw.bs.un_420
  0x2d0d0c05, 0x190b07a9, 0x6e002b12, 0x072b19a0,   // sv.cs.sk_333 it.es.gl_544  vi.hmn.un_640 gl.vi.it_322
  0x1c1127a0, 0x2700210e, 0x08021f0e, 0x2b000119,   // gd.ro.id_322 jw.gd.un_550  cy.da.no_555 en.vi.un_750
  // [57a0]
  0x3b001602, 0x28315504, 0x55201105, 0x1b312bec,   // hr.so.un_220 rw.az.sw_332  ro.sq.rw_333 vi.az.tr_644
  0x050129ec, 0x29006821, 0x11071a13, 0x0e21160c,   // sl.en.fr_644 ig.sl.un_860  tl.it.ro_665 hr.jw.is_543
  0x253b5208, 0x190b18a9, 0x552d1f05, 0x354a6413,   // ha.so.eu_443 ga.es.gl_544  cy.sk.rw_333 lg.yo.zu_665
  0x28125507, 0x02121fa0, 0x551220a0, 0x120c17ee,   // rw.hu.sw_432 cy.hu.da_322  sq.hu.rw_322 sr.sv.hu_422
  // [57b0]
  0x130608ee, 0x55682d07, 0x0c0e1fad, 0x311b25ad,   // no.de.et_422 sk.ig.rw_432  cy.is.sv_643 eu.tr.az_643
  0x2a006813, 0x16282909, 0x282a64af, 0x19180ba4,   // ig.mt.un_650 sl.sw.hr_444  lg.mt.sw_655 es.ga.gl_433
  0x68554a12, 0x2812290c, 0x55002021, 0x0e004a04,   // yo.rw.ig_654 sl.hu.sw_543  sq.rw.un_860 yo.is.un_320
  0x281809ad, 0x531b13a4, 0x16643204, 0x19250ba4,   // pl.ga.sw_643 et.tr.ht_433  bs.lg.hr_332 es.eu.gl_433
  // [57c0]
  0x644a6812, 0x0c000e21, 0x3f095311, 0x2d290d12,   // ig.yo.lg_654 is.sv.un_860  ht.pl.af_653 cs.sl.sk_654
  0x31003b04, 0x3f010f05, 0x29000508, 0x64002a14,   // so.az.un_320 lv.en.af_333  fr.sl.un_430 mt.lg.un_660
  0x190b18a6, 0x01003102, 0x0b190a60, 0x311a1bec,   // ga.es.gl_521 az.en.un_220  pt.gl.es_664 tr.tl.az_644
  0x1f3b030c, 0x19080307, 0x0f1064ad, 0x16000b04,   // nl.so.cy_543 nl.no.gl_432  lg.lt.lv_643 es.hr.un_320
  // [57d0]
  0x10640407, 0x29642109, 0x1c002807, 0x28003b07,   // fi.lg.lt_432 jw.lg.sl_444  sw.id.un_420 so.sw.un_420
  0x2d0d1fa4, 0x1a6e64a7, 0x32162105, 0x190b03a0,   // cy.cs.sk_433 lg.hmn.tl_532  jw.hr.bs_333 nl.es.gl_322
  0x0f000412, 0x07005302, 0x050f010c, 0x3216070c,   // fi.lv.un_640 ht.it.un_220  en.lv.fr_543 it.hr.bs_543
  0x02010807, 0x031b0e04, 0x282a18a0, 0x2904550c,   // no.en.da_432 is.tr.nl_332  ga.mt.sw_322 rw.fi.sl_543
  // [57e0]
  0x190b1a0c, 0x080212a4, 0x25002305, 0x31000c04,   // tl.es.gl_543 hu.da.no_433  ca.eu.un_330 sv.az.un_320
  0x64350b09, 0x07230b08, 0x113507a7, 0x29644a0c,   // es.zu.lg_444 es.ca.it_443  it.zu.ro_532 yo.lg.sl_543
  0x1a000707, 0x64001214, 0x06250304, 0x4a005513,   // it.tl.un_420 hu.lg.un_660  nl.eu.de_332 rw.yo.un_650
  0x182811ec, 0x1a004a07, 0x0e520ca4, 0x3f001c12,   // ro.sw.ga_644 yo.tl.un_420  sv.ha.is_433 id.af.un_640
  // [57f0]
  0x042910a9, 0x2152120c, 0x23201308, 0x52252312,   // lt.sl.fi_544 hu.ha.jw_543  et.sq.ca_443 ca.eu.ha_654
  0x0f5204ac, 0x2a101708, 0x12005223, 0x23000f1a,   // fi.ha.lv_632 sr.lt.mt_443  ha.hu.un_880 lv.ca.un_760
  0x23005219, 0x1a162102, 0x03001f12, 0x11001813,   // ha.ca.un_750 jw.hr.tl_222  cy.nl.un_640 ga.ro.un_650
  0x23053fee, 0x0e11250c, 0x04000c11, 0x0821520c,   // af.fr.ca_422 eu.ro.is_543  sv.fi.un_630 ha.jw.no_543

  // [5800]
  0x18102704, 0x2a1710ad, 0x172a10ac, 0x3b056ba9,   // gd.lt.ga_332 lt.sr.mt_643  lt.mt.sr_632 ceb.fr.so_544
  0x3b4a6ba9, 0x072a1fad, 0x180d0ba0, 0x09062dad,   // ceb.yo.so_544 cy.mt.it_643  es.cs.ga_322 sk.de.pl_643
  0x1f296ea4, 0x210302ee, 0x55001e04, 0x523555ac,   // hmn.sl.cy_433 da.nl.jw_422  ms.rw.un_320 rw.zu.ha_632
  0x554a0508, 0x190a35a4, 0x6b2511af, 0x130c0fec,   // fr.yo.rw_443 zu.pt.gl_433  ro.eu.ceb_655 lv.sv.et_644
  // [5810]
  0x2a52130c, 0x68004a1a, 0x0a1110a4, 0x1a00531a,   // et.ha.mt_543 yo.ig.un_760  lt.ro.pt_433 ht.tl.un_760
  0x1b0802a0, 0x3f3b1aad, 0x283f5314, 0x0c030e04,   // da.no.tr_322 tl.so.af_643  ht.af.sw_666 is.nl.sv_332
  0x03002104, 0x13000704, 0x272b3bad, 0x4a00642b,   // jw.nl.un_320 it.et.un_320  so.vi.gd_643 lg.yo.un_980
  0x254a6808, 0x526e2512, 0x0200082a, 0x282764ad,   // ig.yo.eu_443 eu.hmn.ha_654  no.da.un_970 lg.gd.sw_643
  // [5820]
  0x2029120c, 0x2b6e25a9, 0x11061213, 0x230668af,   // hu.sl.sq_543 eu.hmn.vi_544  hu.de.ro_665 ig.de.ca_655
  0x2500532b, 0x232b1f13, 0x1f001c04, 0x0b310ea4,   // ht.eu.un_980 cy.vi.ca_665  id.cy.un_320 is.az.es_433
  0x313f1f55, 0x25001f14, 0x23005202, 0x0e000b04,   // cy.af.az_442 cy.eu.un_660  ha.ca.un_220 es.is.un_320
  0x12030811, 0x6e005222, 0x0b0e3108, 0x3b000913,   // no.nl.hu_653 ha.hmn.un_870  az.is.es_443 pl.so.un_650
  // [5830]
  0x181f01a4, 0x081110a4, 0x0b003105, 0x6e2b1114,   // en.cy.ga_433 be.ro.uk_433  az.es.un_330 ro.vi.hmn_666
  0x3b1a060c, 0x04236e04, 0x1e002118, 0x101a6b13,   // de.tl.so_543 hmn.ca.fi_332  jw.ms.un_740 ceb.tl.lt_665
  0x0b002822, 0x0b311b12, 0x6b000612, 0x0212060c,   // sw.es.un_870 tr.az.es_654  de.ceb.un_640 de.hu.da_543
  0x52001f18, 0x0a006805, 0x5553290c, 0x08020609,   // cy.ha.un_740 ig.pt.un_330  sl.ht.rw_543 de.da.no_444
  // [5840]
  0x3555680b, 0x18000702, 0x1e1c20ee, 0x09001a09,   // ig.rw.zu_542 it.ga.un_220  sq.id.ms_422 tl.pl.un_440
  0x2a100f09, 0x1a011b04, 0x04001133, 0x53003504,   // lv.lt.mt_444 tr.en.tl_332  ro.ru.un_A70 zu.ht.un_320
  0x0b001a20, 0x3200031a, 0x21003f04, 0x1c1e1307,   // tl.es.un_850 nl.bs.un_760  af.jw.un_320 et.ms.id_432
  0x6b1f3f11, 0x03000113, 0x554a68ee, 0x03000c02,   // af.cy.ceb_653 en.nl.un_650  ig.yo.rw_422 sv.nl.un_220
  // [5850]
  0x171a250c, 0x17682da0, 0x1e521c12, 0x04522aad,   // eu.tl.sr_543 sk.ig.sr_322  id.ha.ms_654 mt.ha.fi_643
  0x1a25350c, 0x55351a12, 0x554a35a9, 0x531f520d,   // zu.eu.tl_543 tl.zu.rw_654  zu.yo.rw_544 ha.cy.ht_554
  0x3f1b1f07, 0x1e681ca9, 0x2352090c, 0x11005507,   // cy.tr.af_432 id.ig.ms_544  pl.ha.ca_543 rw.ro.un_420
  0x52001a08, 0x6b686eee, 0x0e0d21a0, 0x253b10a4,   // tl.ha.un_430 hmn.ig.ceb_422  jw.cs.is_322 lt.so.eu_433
  // [5860]
  0x1a5255ac, 0x32000605, 0x2d000704, 0x040b5502,   // rw.ha.tl_632 de.bs.un_330  it.sk.un_320 rw.es.fi_222
  0x03200b14, 0x2d0d12b3, 0x08005312, 0x13001c02,   // es.sq.nl_666 hu.cs.sk_743  ht.no.un_640 id.et.un_220
  0x12001b12, 0x16173207, 0x12004a2b, 0x2d1a21ee,   // tr.hu.un_640 bs.sr.hr_432  yo.hu.un_980 jw.tl.sk_422
  0x320a0f5a, 0x2b00182c, 0x530b120c, 0x171329a0,   // lv.pt.bs_553 ga.vi.un_990  hu.es.ht_543 sl.et.sr_322
  // [5870]
  0x1c003b07, 0x00002b37, 0x18004a1b, 0x131c090d,   // so.id.un_420 vi.un.un_B00  yo.ga.un_770 hi.mr.bh_554
  0x1c253bec, 0x1b2129ee, 0x080c13ec, 0x2a00130d,   // so.eu.id_644 sl.jw.tr_422  et.sv.no_644 et.mt.un_540
  0x351325af, 0x041029a4, 0x4a190a13, 0x05191bee,   // eu.et.zu_655 sl.lt.fi_433  pt.gl.yo_665 tr.gl.fr_422
  0x0a004a14, 0x3f00010c, 0x11551ba4, 0x17291bad,   // yo.pt.un_660 en.af.un_530  tr.rw.ro_433 tr.sl.sr_643
  // [5880]
  0x253521a6, 0x080525a4, 0x105223a7, 0x2a002309,   // jw.zu.eu_521 eu.fr.no_433  ca.ha.lt_532 ca.mt.un_440
  0x03001218, 0x04006b07, 0x0801070d, 0x203528ec,   // hu.nl.un_740 ceb.fi.un_420  it.en.no_554 sw.zu.sq_644
  0x18001e18, 0x04132dee, 0x2b003f08, 0x13003502,   // ms.ga.un_740 sk.et.fi_422  af.vi.un_430 zu.et.un_220
  0x551e1c14, 0x0f291009, 0x28000d0d, 0x05640ca0,   // id.ms.rw_666 lt.sl.lv_444  cs.sw.un_540 sv.lg.fr_322
  // [5890]
  0x01000702, 0x1100020c, 0x1b2752a4, 0x08022502,   // it.en.un_220 da.ro.un_530  ha.gd.tr_433 eu.da.no_222
  0x2d2904af, 0x04000d12, 0x0f001308, 0x534a21ee,   // fi.sl.sk_655 cs.fi.un_640  et.lv.un_430 jw.yo.ht_422
  0x20212a04, 0x531f2aad, 0x0f093107, 0x351a53ec,   // mt.jw.sq_332 mt.cy.ht_643  az.pl.lv_432 ht.tl.zu_644
  0x016b52ee, 0x100f1ba6, 0x2d0d09a4, 0x28214a0c,   // ha.ceb.en_422 tr.lv.lt_521  pl.cs.sk_433 yo.jw.sw_543
  // [58a0]
  0x09001a0d, 0x190b2310, 0x2d0d17a9, 0x1e1c31a4,   // tl.pl.un_540 ca.es.gl_642  sr.cs.sk_544 az.id.ms_433
  0x532a09ec, 0x2d1b310d, 0x0e001604, 0x080c21a0,   // pl.mt.ht_644 az.tr.sk_554  hr.is.un_320 jw.sv.no_322
  0x2a083b13, 0x100f285a, 0x110b0408, 0x04000e0e,   // so.no.mt_665 sw.lv.lt_553  fi.es.ro_443 is.fi.un_550
  0x351a31ad, 0x28000412, 0x52002a13, 0x5500211a,   // az.tl.zu_643 fi.sw.un_640  mt.ha.un_650 jw.rw.un_760
  // [58b0]
  0x016b04ee, 0x351008a9, 0x04000a2a, 0x642035ad,   // fi.ceb.en_422 no.lt.zu_544  pt.fi.un_970 zu.sq.lg_643
  0x1b001707, 0x07060360, 0x2b002a0d, 0x321710b3,   // sr.tr.un_420 nl.de.it_664  mt.vi.un_540 lt.sr.bs_743
  0x27230509, 0x2a0823af, 0x13093b02, 0x321735ee,   // fr.ca.gd_444 ca.no.mt_655  so.pl.et_222 zu.sr.bs_422
  0x1a093b07, 0x160c320c, 0x3217530c, 0x10041baf,   // so.pl.tl_432 bs.sv.hr_543  ht.sr.bs_543 tr.fi.lt_655
  // [58c0]
  0x551b6ea0, 0x0e1a0b0c, 0x11001c07, 0x10530dad,   // hmn.tr.rw_322 es.tl.is_543  id.ro.un_420 cs.ht.lt_643
  0x051801a4, 0x02522109, 0x13091c07, 0x1f2a2360,   // en.ga.fr_433 jw.ha.da_444  mr.hi.bh_432 ca.mt.cy_664
  0x1e1c2108, 0x1a00121a, 0x1e003202, 0x16002a12,   // jw.id.ms_443 hu.tl.un_760  bs.ms.un_220 mt.hr.un_640
  0x32000607, 0x31103f04, 0x12001307, 0x190b0aaf,   // de.bs.un_420 af.lt.az_332  et.hu.un_420 pt.es.gl_655
  // [58d0]
  0x055568a0, 0x10252908, 0x02103fec, 0x3f00101a,   // ig.rw.fr_322 sl.eu.lt_443  af.lt.da_644 lt.af.un_760
  0x0f00292b, 0x130111a4, 0x2900090c, 0x0b006b18,   // sl.lv.un_980 ro.en.et_433  pl.sl.un_530 ceb.es.un_740
  0x1a3b090c, 0x09270607, 0x0a6b2a07, 0x0b25190d,   // pl.so.tl_543 de.gd.pl_432  mt.ceb.pt_432 gl.eu.es_554
  0x09002a22, 0x1004120e, 0x11000a17, 0x2d0d29a7,   // mt.pl.un_870 hu.fi.lt_555  pt.ro.un_730 sl.cs.sk_532
  // [58e0]
  0x29000813, 0x110464a0, 0x6b006405, 0x0b001f09,   // no.sl.un_650 lg.fi.ro_322  lg.ceb.un_330 cy.es.un_440
  0x0c3f64ec, 0x13000c07, 0x52643b12, 0x0a315555,   // lg.af.sv_644 sv.et.un_420  so.lg.ha_654 rw.az.pt_442
  0x29000e08, 0x0a3b1907, 0x011325ee, 0x0900550c,   // is.sl.un_430 gl.so.pt_432  eu.et.en_422 rw.pl.un_530
  0x100453ad, 0x25191f04, 0x55202112, 0x096468ac,   // ht.fi.lt_643 cy.gl.eu_332  jw.sq.rw_654 ig.lg.pl_632
  // [58f0]
  0x52001904, 0x352813a7, 0x04003511, 0x1c090d04,   // gl.ha.un_320 et.sw.zu_532  zu.fi.un_630 ne.hi.mr_332
  0x320c25a4, 0x2a1320a9, 0x1b1a6bad, 0x102a3b11,   // eu.sv.bs_433 sq.et.mt_544  ceb.tl.tr_643 so.mt.lt_653
  0x09000e0d, 0x0e0c2511, 0x2a272504, 0x25003f02,   // is.pl.un_540 eu.sv.is_653  eu.gd.mt_332 af.eu.un_220
  0x070a25ad, 0x53093508, 0x681c27ac, 0x0d090aa0,   // eu.pt.it_643 zu.pl.ht_443  gd.id.ig_632 pt.pl.cs_322
  // [5900]
  0x0d091f07, 0x32175305, 0x1e1c2a0c, 0x52310507,   // cy.pl.cs_432 ht.sr.bs_333  mt.id.ms_543 fr.az.ha_432
  0x28171112, 0x11002a1b, 0x073b0b09, 0x0c000421,   // ro.sr.sw_654 mt.ro.un_770  es.so.it_444 fi.sv.un_860
  0x18006b07, 0x0d016ba0, 0x09006e11, 0x1b1a53a4,   // ceb.ga.un_420 ceb.en.cs_322  hmn.pl.un_630 ht.tl.tr_433
  0x02091f13, 0x1e1c2805, 0x11055208, 0x1e1c68a9,   // cy.pl.da_665 sw.id.ms_333  ha.fr.ro_443 ig.id.ms_544
  // [5910]
  0x080c3fee, 0x640968ec, 0x1e1c52a9, 0x29002304,   // af.sv.no_422 ig.pl.lg_644  ha.id.ms_544 ca.sl.un_320
  0x20326812, 0x0464685a, 0x170f03ac, 0x3f032da4,   // ig.bs.sq_654 ig.lg.fi_553  nl.lv.sr_632 sk.nl.af_433
  0x05642308, 0x03001109, 0x1b3555ec, 0x0c003504,   // ca.lg.fr_443 ro.nl.un_440  rw.zu.tr_644 zu.sv.un_320
  0x060e27a9, 0x64355212, 0x64552014, 0x2a00121b,   // gd.is.de_544 ha.zu.lg_654  sq.rw.lg_666 hu.mt.un_770
  // [5920]
  0x640e13ec, 0x232b0555, 0x52533bad, 0x060103ad,   // et.is.lg_644 fr.vi.ca_442  so.ht.ha_643 nl.en.de_643
  0x551f0708, 0x0b0a230c, 0x1b5264a4, 0x08001b18,   // it.cy.rw_443 ca.pt.es_543  lg.ha.tr_433 tr.no.un_740
  0x20000e14, 0x112123af, 0x133f1b0c, 0x0c311307,   // is.sq.un_660 ca.jw.ro_655  tr.af.et_543 et.az.sv_432
  0x321603a4, 0x2500210e, 0x29173fa4, 0x2b000a09,   // nl.hr.bs_433 jw.eu.un_550  af.sr.sl_433 pt.vi.un_440
  // [5930]
  0x2a2d09a6, 0x0a002b0d, 0x64000512, 0x12000c18,   // pl.sk.mt_521 vi.pt.un_540  fr.lg.un_640 sv.hu.un_740
  0x09011fac, 0x3f0c12a6, 0x0810020c, 0x08021702,   // cy.en.pl_632 hu.sv.af_521  da.lt.no_543 sr.da.no_222
  0x230b25a9, 0x03070ca0, 0x28002d12, 0x2b000a07,   // eu.es.ca_544 sv.it.nl_322  sk.sw.un_640 pt.vi.un_420
  0x1b005502, 0x21005321, 0x684a315a, 0x0d2d09a4,   // rw.tr.un_220 ht.jw.un_860  az.yo.ig_553 pl.sk.cs_433
  // [5940]
  0x011f0c08, 0x53002114, 0x35000204, 0x0700231d,   // sv.cy.en_443 jw.ht.un_660  da.zu.un_320 ca.it.un_820
  0x04123fa0, 0x3b2b01ee, 0x556468ec, 0x08023faf,   // af.hu.fi_322 en.vi.so_422  ig.lg.rw_644 af.da.no_655
  0x08020705, 0x681a20ee, 0x3f130e0c, 0x35311b12,   // it.da.no_333 sq.tl.ig_422  is.et.af_543 tr.az.zu_654
  0x07000507, 0x31211b07, 0x5321230e, 0x23001c04,   // fr.it.un_420 tr.jw.az_432  ca.jw.ht_555 id.ca.un_320
  // [5950]
  0x352d530e, 0x08001311, 0x100923a7, 0x2d002a05,   // ht.sk.zu_555 et.no.un_630  ca.pl.lt_532 mt.sk.un_330
  0x230b3107, 0x6e6b01ad, 0x10041702, 0x52002109,   // az.es.ca_432 en.ceb.hmn_643  sr.ru.be_222 jw.ha.un_440
  0x20001104, 0x290a1b07, 0x27000807, 0x1300060b,   // ro.sq.un_320 tr.pt.sl_432  no.gd.un_420 de.et.un_520
  0x095510ad, 0x0a192107, 0x321609af, 0x190b1f0c,   // lt.rw.pl_643 jw.gl.pt_432  pl.hr.bs_655 cy.es.gl_543
  // [5960]
  0x0d002521, 0x55003b13, 0x2d291104, 0x0100280d,   // eu.cs.un_860 so.rw.un_650  ro.sl.sk_332 sw.en.un_540
  0x166b0909, 0x072d010c, 0x0700190e, 0x2a001b09,   // pl.ceb.hr_444 en.sk.it_543  gl.it.un_550 tr.mt.un_440
  0x2d0d12a4, 0x01276ba0, 0x211c2812, 0x093f10a4,   // hu.cs.sk_433 ceb.gd.en_322  sw.id.jw_654 lt.af.pl_433
  0x291805ec, 0x310e1b13, 0x12002909, 0x050c010c,   // fr.ga.sl_644 tr.is.az_665  sl.hu.un_440 en.sv.fr_543
  // [5970]
  0x07004a02, 0x52684a13, 0x310e1f12, 0x253568a0,   // yo.it.un_220 yo.ig.ha_665  cy.is.az_654 ig.zu.eu_322
  0x1e1c2909, 0x0900120c, 0x041e12ad, 0x2100080e,   // sl.id.ms_444 hu.pl.un_530  hu.ms.fi_643 no.jw.un_550
  0x1609295a, 0x1e003104, 0x1e1c2509, 0x19350711,   // sl.pl.hr_553 az.ms.un_320  eu.id.ms_444 it.zu.gl_653
  0x1e044aa0, 0x03002d14, 0x29210705, 0x03013fa9,   // yo.fi.ms_322 sk.nl.un_660  it.jw.sl_333 af.en.nl_544
  // [5980]
  0x1f311b13, 0x0528190d, 0x0c0831ec, 0x05002007,   // tr.az.cy_665 gl.sw.fr_554  az.no.sv_644 sq.fr.un_420
  0x04001209, 0x1e001208, 0x08000218, 0x12000d08,   // hu.fi.un_440 hu.ms.un_430  da.no.un_740 cs.hu.un_430
  0x00002042, 0x063f0111, 0x122d210e, 0x200d04af,   // sq.un.un_C00 en.af.de_653  jw.sk.hu_555 fi.cs.sq_655
  0x04001e13, 0x1e1c0d09, 0x32001e02, 0x175307a7,   // ms.fi.un_650 cs.id.ms_444  ms.bs.un_220 it.ht.sr_532
  // [5990]
  0x311b1e09, 0x536e070b, 0x18311b09, 0x08311309,   // ms.tr.az_444 it.hmn.ht_542  tr.az.ga_444 et.az.no_444
  0x08020305, 0x23310511, 0x201b1ea4, 0x23041302,   // nl.da.no_333 fr.az.ca_653  ms.tr.sq_433 et.fi.ca_222
  0x64005202, 0x19182b0c, 0x060727a0, 0x1e001c34,   // ha.lg.un_220 vi.ga.gl_543  gd.it.de_322 id.ms.un_A80
  0x18270aa9, 0x2b210605, 0x250703a0, 0x64001f22,   // pt.gd.ga_544 de.jw.vi_333  nl.it.eu_322 cy.lg.un_870
  // [59a0]
  0x201b4a07, 0x53002523, 0x08001104, 0x251b68af,   // yo.tr.sq_432 eu.ht.un_880  ro.uk.un_320 ig.tr.eu_655
  0x18006e0e, 0x07003504, 0x522807a4, 0x0b005505,   // hmn.ga.un_550 zu.it.un_320  it.sw.ha_433 rw.es.un_330
  0x27091808, 0x2900202a, 0x1b001004, 0x53256bad,   // ga.pl.gd_443 sq.sl.un_970  lt.tr.un_320 ceb.eu.ht_643
  0x0c684aa0, 0x3f1f0913, 0x03083fad, 0x0c001b0b,   // yo.ig.sv_322 pl.cy.af_665  af.no.nl_643 tr.sv.un_520
  // [59b0]
  0x3b2319a7, 0x04132a0c, 0x28001902, 0x1e122512,   // gl.ca.so_532 mt.et.fi_543  gl.sw.un_220 eu.hu.ms_654
  0x643f29a4, 0x2503090b, 0x20212509, 0x1e251c0c,   // sl.af.lg_433 pl.nl.eu_542  eu.jw.sq_444 id.eu.ms_543
  0x28001702, 0x25001812, 0x28000e04, 0x21001b2b,   // sr.sw.un_220 ga.eu.un_640  is.sw.un_320 tr.jw.un_980
  0x2d1f0d07, 0x284a31a9, 0x0400090e, 0x0c3f0fee,   // cs.cy.sk_432 az.yo.sw_544  pl.fi.un_550 lv.af.sv_422
  // [59c0]
  0x0d000807, 0x100c1bee, 0x1e291ca4, 0x55212012,   // no.cs.un_420 tr.sv.lt_422  id.sl.ms_433 sq.jw.rw_654
  0x211e1aa9, 0x17251c0c, 0x00000201, 0x1b000c1b,   // tl.ms.jw_544 id.eu.sr_543  da.un.un_200 sv.tr.un_770
  0x1e1c25a9, 0x551b68af, 0x19310b55, 0x1c4a1ea4,   // eu.id.ms_544 ig.tr.rw_655  es.az.gl_442 ms.yo.id_433
  0x64001f12, 0x190a11a9, 0x68534a60, 0x270631a7,   // cy.lg.un_640 ro.pt.gl_544  yo.ht.ig_664 az.de.gd_532
  // [59d0]
  0x28100612, 0x1b0b08a0, 0x08101b08, 0x35211ca9,   // de.lt.sw_654 no.es.tr_322  tr.lt.no_443 id.jw.zu_544
  0x0c523b08, 0x13211ba4, 0x68000219, 0x32162005,   // so.ha.sv_443 tr.jw.et_433  da.ig.un_750 sq.hr.bs_333
  0x0a231913, 0x3b190a0d, 0x3b1b1012, 0x08000734,   // gl.ca.pt_665 pt.gl.so_554  lt.tr.so_654 bg.uk.un_A80
  0x04081113, 0x23002a1a, 0x232013a7, 0x181011a0,   // ro.no.fi_665 mt.ca.un_760  et.sq.ca_532 ro.lt.ga_322
  // [59e0]
  0x1e171c04, 0x35201b08, 0x166b0eee, 0x04201b0b,   // id.sr.ms_332 tr.sq.zu_443  is.ceb.hr_422 tr.sq.fi_542
  0x0406130d, 0x3f1b06ad, 0x014a0c04, 0x32000a08,   // et.de.fi_554 de.tr.af_643  sv.yo.en_332 pt.bs.un_430
  0x0b0a0eec, 0x2d290da4, 0x3b281a02, 0x081f02ee,   // is.pt.es_644 cs.sl.sk_433  tl.sw.so_222 da.cy.no_422
  0x080c0412, 0x32000704, 0x2a0c0812, 0x1a27180e,   // fi.sv.no_654 it.bs.un_320  no.sv.mt_654 ga.gd.tl_555
  // [59f0]
  0x18191f08, 0x6e532ba4, 0x53206e05, 0x1f3f0213,   // cy.gl.ga_443 vi.ht.hmn_433  hmn.sq.ht_333 da.af.cy_665
  0x2a3b0a08, 0x0a1b6e12, 0x09002804, 0x10005313,   // pt.so.mt_443 hmn.tr.pt_654  sw.pl.un_320 ht.lt.un_650
  0x6e0d2dee, 0x190b08a0, 0x311b6e04, 0x19181f0c,   // sk.cs.hmn_422 no.es.gl_322  hmn.tr.az_332 cy.ga.gl_543
  0x29272b13, 0x1a00521a, 0x211a1e12, 0x0c0a2913,   // vi.gd.sl_665 ha.tl.un_760  ms.tl.jw_654 sl.pt.sv_665
  // [5a00]
  0x351a64a9, 0x1a0a68ee, 0x29000a2c, 0x53183ba4,   // lg.tl.zu_544 ig.pt.tl_422  pt.sl.un_990 so.ga.ht_433
  0x08001e08, 0x52000c04, 0x3b1135ee, 0x080232a4,   // ms.no.un_430 sv.ha.un_320  zu.ro.so_422 bs.da.no_433
  0x16293bad, 0x29001313, 0x101709a4, 0x12000618,   // so.sl.hr_643 et.sl.un_650  pl.sr.lt_433 de.hu.un_740
  0x6b183bee, 0x0f105313, 0x3b000c19, 0x3b002913,   // so.ga.ceb_422 ht.lt.lv_665  sv.so.un_750 sl.so.un_650
  // [5a10]
  0x250631a4, 0x04280f04, 0x29063ba4, 0x01006b14,   // az.de.eu_433 lv.sw.fi_332  so.de.sl_433 ceb.en.un_660
  0x17003107, 0x28311baf, 0x16005307, 0x35002804,   // az.sr.un_420 tr.az.sw_655  ht.hr.un_420 sw.zu.un_320
  0x281a555a, 0x181b27ac, 0x3f0313ad, 0x1911180c,   // rw.tl.sw_553 gd.tr.ga_632  et.nl.af_643 ga.ro.gl_543
  0x0a1a6bad, 0x4a001902, 0x21551aa4, 0x0e256ba9,   // ceb.tl.pt_643 gl.yo.un_220  tl.rw.jw_433 ceb.eu.is_544
  // [5a20]
  0x0c1117a4, 0x27003202, 0x19130ba4, 0x52000422,   // sr.ro.sv_433 bs.gd.un_220  es.et.gl_433 fi.ha.un_870
  0x27000b02, 0x133f6405, 0x55006b0e, 0x0c130a08,   // es.gd.un_220 lg.af.et_333  ceb.rw.un_550 pt.et.sv_443
  0x04201f0d, 0x13643f05, 0x3f1a1208, 0x0e041fee,   // cy.sq.fi_554 af.lg.et_333  hu.tl.af_443 cy.fi.is_422
  0x276b1a12, 0x5300212a, 0x210c52a7, 0x29132008,   // tl.ceb.gd_654 jw.ht.un_970  ha.sv.jw_532 sq.et.sl_443
  // [5a30]
  0x0305020c, 0x531f0bee, 0x0c0e0407, 0x172905ee,   // da.fr.nl_543 es.cy.ht_422  fi.is.sv_432 fr.sl.sr_422
  0x1e005221, 0x1b3111a4, 0x310827a0, 0x68002b0d,   // ha.ms.un_860 ro.az.tr_433  gd.no.az_322 vi.ig.un_540
  0x103f68a6, 0x230b64a4, 0x060c6bec, 0x1f1b0e0c,   // ig.af.lt_521 lg.es.ca_433  ceb.sv.de_644 is.tr.cy_543
  0x52350e5a, 0x3f1a0213, 0x0c002108, 0x210b1805,   // is.zu.ha_553 da.tl.af_665  jw.sv.un_430 ga.es.jw_333
  // [5a40]
  0x111201a7, 0x053f0309, 0x043b13af, 0x2a00681b,   // en.hu.ro_532 nl.af.fr_444  et.so.fi_655 ig.mt.un_770
  0x061801a4, 0x08180cac, 0x0300682b, 0x020f0c0c,   // en.ga.de_433 sv.ga.no_632  ig.nl.un_980 sv.lv.da_543
  0x0c1304a4, 0x07181907, 0x0b002707, 0x0e000308,   // fi.et.sv_433 gl.ga.it_432  gd.es.un_420 nl.is.un_430
  0x1e1c64af, 0x29256804, 0x0c04060e, 0x68003f21,   // lg.id.ms_655 ig.eu.sl_332  de.fi.sv_555 af.ig.un_860
  // [5a50]
  0x0c0504ac, 0x112701ad, 0x190a0e09, 0x1b311a08,   // fi.fr.sv_632 en.gd.ro_643  is.pt.gl_444 tl.az.tr_443
  0x6e006404, 0x09006e07, 0x230e2da0, 0x05313f04,   // lg.hmn.un_320 hmn.pl.un_420  sk.is.ca_322 af.az.fr_332
  0x21002804, 0x01002714, 0x233b05ec, 0x2d520dec,   // sw.jw.un_320 gd.en.un_660  fr.so.ca_644 cs.ha.sk_644
  0x644a52ad, 0x0f1725a0, 0x07190bec, 0x68005508,   // ha.yo.lg_643 eu.sr.lv_322  es.gl.it_644 rw.ig.un_430
  // [5a60]
  0x040c0660, 0x281f0aee, 0x68002a05, 0x6b1a2907,   // de.sv.fi_664 pt.cy.sw_422  mt.ig.un_330 sl.tl.ceb_432
  0x55005302, 0x1e1c13ec, 0x03023fee, 0x193b25a4,   // ht.rw.un_220 et.id.ms_644  af.da.nl_422 eu.so.gl_433
  0x02201f12, 0x04283bad, 0x101b09a0, 0x0e312b55,   // cy.sq.da_654 so.sw.fi_643  pl.tr.lt_322 vi.az.is_442
  0x193f0b07, 0x3b002919, 0x08131807, 0x1f001b19,   // es.af.gl_432 sl.so.un_750  ga.et.no_432 tr.cy.un_750
  // [5a70]
  0x68004a35, 0x1b3f13af, 0x1200020d, 0x0406250b,   // yo.ig.un_A90 et.af.tr_655  da.hu.un_540 eu.de.fi_542
  0x10092daf, 0x2d000920, 0x1000641a, 0x3f000634,   // sk.pl.lt_655 pl.sk.un_850  lg.lt.un_760 de.af.un_A80
  0x3b003f0c, 0x043b29ee, 0x6b0610a0, 0x0f001c02,   // af.so.un_530 sl.so.fi_422  lt.de.ceb_322 id.lv.un_220
  0x133b5504, 0x4a005207, 0x21001a02, 0x1c110a04,   // rw.so.et_332 ha.yo.un_420  tl.jw.un_220 pt.ro.id_332
  // [5a80]
  0x2d290dad, 0x0b2364ee, 0x110f2daf, 0x0f042d0c,   // cs.sl.sk_643 lg.ca.es_422  sk.lv.ro_655 sk.fi.lv_543
  0x062a0914, 0x3b271812, 0x21136807, 0x2b005502,   // pl.mt.de_666 ga.gd.so_654  ig.et.jw_432 rw.vi.un_220
  0x07112312, 0x02031fec, 0x0a0318a4, 0x02093ba7,   // ca.ro.it_654 cy.nl.da_644  ga.nl.pt_433 so.pl.da_532
  0x6b2035a9, 0x0d0f2da4, 0x16070aad, 0x233b27a9,   // zu.sq.ceb_544 sk.lv.cs_433  pt.it.hr_643 gd.so.ca_544
  // [5a90]
  0x2d000a19, 0x35003f0c, 0x29041809, 0x0a212960,   // pt.sk.un_750 af.zu.un_530  ga.fi.sl_444 sl.jw.pt_664
  0x010e25ad, 0x190b04ee, 0x25000407, 0x646b13ee,   // eu.is.en_643 fi.es.gl_422  fi.eu.un_420 et.ceb.lg_422
  0x0b001012, 0x1b0231a4, 0x1b23020c, 0x190a1a14,   // lt.es.un_640 az.da.tr_433  da.ca.tr_543 tl.pt.gl_666
  0x2021350c, 0x282552a0, 0x19001208, 0x100f1c0c,   // zu.jw.sq_543 ha.eu.sw_322  hu.gl.un_430 id.lv.lt_543
  // [5aa0]
  0x6e070912, 0x11292da0, 0x1a0f1e12, 0x21200e12,   // pl.it.hmn_654 sk.sl.ro_322  ms.lv.tl_654 is.sq.jw_654
  0x321703ee, 0x09190b09, 0x08020e0e, 0x21066b12,   // nl.sr.bs_422 es.gl.pl_444  is.da.no_555 ceb.de.jw_654
  0x190f0b0c, 0x53053faf, 0x25000212, 0x2d180d0d,   // es.lv.gl_543 af.fr.ht_655  da.eu.un_640 cs.ga.sk_554
  0x0f001219, 0x290f0da0, 0x052852ad, 0x032d1007,   // hu.lv.un_750 cs.lv.sl_322  ha.sw.fr_643 lt.sk.nl_432
  // [5ab0]
  0x3f071060, 0x093f0fee, 0x1a6b55ad, 0x1f23190d,   // lt.it.af_664 lv.af.pl_422  rw.ceb.tl_643 gl.ca.cy_554
  0x1b2555ac, 0x0b251955, 0x3b55640d, 0x2d1219a9,   // rw.eu.tr_632 gl.eu.es_442  lg.rw.so_554 gl.hu.sk_544
  0x070f52ad, 0x09085507, 0x6b1a2a12, 0x352a53a4,   // ha.lv.it_643 rw.no.pl_432  mt.tl.ceb_654 ht.mt.zu_433
  0x122d190c, 0x13006e0d, 0x3b6e6b08, 0x2d2307a9,   // gl.sk.hu_543 hmn.et.un_540  ceb.hmn.so_443 it.ca.sk_544
  // [5ac0]
  0x18001307, 0x35001a19, 0x55014aee, 0x1b1a010c,   // et.ga.un_420 tl.zu.un_750  yo.en.rw_422 en.tl.tr_543
  0x133b1aad, 0x130f1008, 0x1f3f030e, 0x192d0aa4,   // tl.so.et_643 lt.lv.et_443  nl.af.cy_555 pt.sk.gl_433
  0x25002302, 0x2d280707, 0x641e28a0, 0x186810a4,   // ca.eu.un_220 it.sw.sk_432  sw.ms.lg_322 lt.ig.ga_433
  0x6b1a2a09, 0x17003f1a, 0x120b04a4, 0x0e23180d,   // mt.tl.ceb_444 af.sr.un_760  fi.es.hu_433 ga.ca.is_554
  // [5ad0]
  0x1a6b2a12, 0x27050712, 0x2d0d05af, 0x043f0312,   // mt.ceb.tl_654 it.fr.gd_654  fr.cs.sk_655 nl.af.fi_654
  0x03052102, 0x0100250d, 0x016e6ba0, 0x2a001912,   // jw.fr.nl_222 eu.en.un_540  ceb.hmn.en_322 gl.mt.un_640
  0x11002702, 0x082a06ee, 0x0700191b, 0x19000707,   // gd.ro.un_220 de.mt.no_422  gl.it.un_770 it.gl.un_420
  0x01051fac, 0x1c211e0b, 0x6b2521a4, 0x3f0c0813,   // cy.fr.en_632 ms.jw.id_542  jw.eu.ceb_433 no.sv.af_665
  // [5ae0]
  0x0c180e05, 0x2b005319, 0x05270408, 0x52283b13,   // is.ga.sv_333 ht.vi.un_750  fi.gd.fr_443 so.sw.ha_665
  0x052312a4, 0x090b6b02, 0x122d0aac, 0x523b5508,   // hu.ca.fr_433 ceb.es.pl_222  pt.sk.hu_632 rw.so.ha_443
  0x0e000513, 0x353b5507, 0x050e0fa4, 0x64531aa0,   // fr.is.un_650 rw.so.zu_432  lv.is.fr_433 tl.ht.lg_322
  0x1a206b0d, 0x0500211a, 0x053111ad, 0x2d120aa0,   // ceb.sq.tl_554 jw.fr.un_760  ro.az.fr_643 pt.hu.sk_322
  // [5af0]
  0x19070aee, 0x092d3fee, 0x033b0d07, 0x07111805,   // pt.it.gl_422 af.sk.pl_422  cs.so.nl_432 ga.ro.it_333
  0x041828a6, 0x230731a0, 0x07116807, 0x31354aaf,   // sw.ga.fi_521 az.it.ca_322  ig.ro.it_432 yo.zu.az_655
  0x190c0aee, 0x06080ca6, 0x0b3b07a0, 0x12531013,   // pt.sv.gl_422 sv.no.de_521  it.so.es_322 lt.ht.hu_665
  0x190e0aad, 0x013f070c, 0x55001309, 0x1e201a05,   // pt.is.gl_643 it.af.en_543  et.rw.un_440 tl.sq.ms_333
  // [5b00]
  0x0e6864a4, 0x181f2807, 0x23110aa9, 0x64350e05,   // lg.ig.is_433 sw.cy.ga_432  pt.ro.ca_544 is.zu.lg_333
  0x6b1f1804, 0x2b1e3f02, 0x2100110d, 0x6455110c,   // ga.cy.ceb_332 af.ms.vi_222  ro.jw.un_540 ro.rw.lg_543
  0x04002121, 0x10352a13, 0x09052a0c, 0x680735af,   // jw.fi.un_860 mt.zu.lt_665  mt.fr.pl_543 zu.it.ig_655
  0x0200350c, 0x03001707, 0x10080212, 0x23000521,   // zu.da.un_530 sr.nl.un_420  da.no.lt_654 fr.ca.un_860
  // [5b10]
  0x2353250c, 0x0a1b1904, 0x3b00111b, 0x0a002123,   // eu.ht.ca_543 gl.tr.pt_332  ro.so.un_770 jw.pt.un_880
  0x23001923, 0x5264530c, 0x10000b08, 0x20061f0c,   // gl.ca.un_880 ht.lg.ha_543  es.lt.un_430 cy.de.sq_543
  0x1b2d35af, 0x4a000b02, 0x31001902, 0x05230ead,   // zu.sk.tr_655 es.yo.un_220  gl.az.un_220 is.ca.fr_643
  0x281a0408, 0x55002519, 0x530f215a, 0x1000090c,   // fi.tl.sw_443 eu.rw.un_750  jw.lv.ht_553 pl.lt.un_530
  // [5b20]
  0x55285213, 0x6b521a09, 0x10311bec, 0x080613ee,   // ha.sw.rw_665 tl.ha.ceb_444  tr.az.lt_644 et.de.no_422
  0x0400230c, 0x1b1a25a4, 0x1c000d02, 0x0f100cad,   // ca.fi.un_530 eu.tl.tr_433  ne.mr.un_220 sv.lt.lv_643
  0x292d0f07, 0x0b121902, 0x0c001c02, 0x6b002813,   // lv.sk.sl_432 gl.hu.es_222  id.sv.un_220 sw.ceb.un_650
  0x203132a0, 0x55253112, 0x4a5528a4, 0x080e0fad,   // bs.az.sq_322 az.eu.rw_654  sw.rw.yo_433 lv.is.no_643
  // [5b30]
  0x045228a9, 0x533f05a7, 0x101a1ea4, 0x094a6860,   // sw.ha.fi_544 fr.af.ht_532  ms.tl.lt_433 ig.yo.pl_664
  0x256b1a60, 0x20183508, 0x016b0507, 0x3b2808a0,   // tl.ceb.eu_664 zu.ga.sq_443  fr.ceb.en_432 no.sw.so_322
  0x282055af, 0x4a355304, 0x2a5325a6, 0x351f680c,   // rw.sq.sw_655 ht.zu.yo_332  eu.ht.mt_521 ig.cy.zu_543
  0x53023f08, 0x1100180e, 0x0b000613, 0x190b050c,   // af.da.ht_443 ga.ro.un_550  de.es.un_650 fr.es.gl_543
  // [5b40]
  0x2d001112, 0x53006808, 0x10010fad, 0x081f0cec,   // ro.sk.un_640 ig.ht.un_430  lv.en.lt_643 sv.cy.no_644
  0x0605190c, 0x6b3b19ad, 0x4a000d13, 0x0a0702a4,   // gl.fr.de_543 gl.so.ceb_643  cs.yo.un_650 da.it.pt_433
  0x2d000508, 0x124a0509, 0x3b060b05, 0x3f000519,   // fr.sk.un_430 fr.yo.hu_444  es.de.so_333 fr.af.un_750
  0x4a2a13ad, 0x070a100e, 0x4a002b0d, 0x2b001809,   // et.mt.yo_643 be.mk.bg_555  vi.yo.un_540 ga.vi.un_440
  // [5b50]
  0x0a2d05a9, 0x3f3507a7, 0x6b681aec, 0x551304ee,   // fr.sk.pt_544 it.zu.af_532  tl.ig.ceb_644 fi.et.rw_422
  0x20002502, 0x64002a0d, 0x110b23ad, 0x0e184a14,   // eu.sq.un_220 mt.lg.un_540  ca.es.ro_643 yo.ga.is_666
  0x07001a2b, 0x1a0e64af, 0x182a27ee, 0x0c000a08,   // tl.it.un_980 lg.is.tl_655  gd.mt.ga_422 pt.sv.un_430
  0x06002d04, 0x17001104, 0x6b1a55a4, 0x0d1c1fa0,   // sk.de.un_320 ro.sr.un_320  rw.tl.ceb_433 cy.id.cs_322
  // [5b60]
  0x07000e0c, 0x01063ba7, 0x0b4a280c, 0x64551c11,   // is.it.un_530 so.de.en_532  sw.yo.es_543 id.rw.lg_653
  0x1200060d, 0x2d350da4, 0x21001202, 0x2100030e,   // de.hu.un_540 cs.zu.sk_433  ur.fa.un_220 nl.jw.un_550
  0x27002013, 0x0d2910a4, 0x036b68a0, 0x552d2855,   // sq.gd.un_650 lt.sl.cs_433  ig.ceb.nl_322 sw.sk.rw_442
  0x04132912, 0x0300350e, 0x2d004a11, 0x100b0fa7,   // sl.et.fi_654 zu.nl.un_550  yo.sk.un_630 lv.es.lt_532
  // [5b70]
  0x101a1305, 0x0a2728a0, 0x321a0307, 0x2d1f0ca4,   // et.tl.lt_333 sw.gd.pt_322  nl.tl.bs_432 sv.cy.sk_433
  0x12101313, 0x06001304, 0x1b553bec, 0x4a6b350c,   // et.lt.hu_665 et.de.un_320  so.rw.tr_644 zu.ceb.yo_543
  0x2d001813, 0x253507ee, 0x13554a02, 0x060c3fa4,   // ga.sk.un_650 it.zu.eu_422  yo.rw.et_222 af.sv.de_433
  0x32000104, 0x28181ba4, 0x070e1f02, 0x120a2105,   // en.bs.un_320 tr.ga.sw_433  cy.is.it_222 jw.pt.hu_333
  // [5b80]
  0x0f000b04, 0x0c351807, 0x0a000b04, 0x1b000a07,   // es.lv.un_320 ga.zu.sv_432  es.pt.un_320 pt.tr.un_420
  0x10076b08, 0x551764ee, 0x0968285a, 0x35311fa7,   // ceb.it.lt_443 lg.sr.rw_422  sw.ig.pl_553 cy.az.zu_532
  0x09130404, 0x13006407, 0x1b3152ee, 0x1335100c,   // fi.et.pl_332 lg.et.un_420  ha.az.tr_422 lt.zu.et_543
  0x2a20550d, 0x25001b14, 0x200709ad, 0x07001018,   // rw.sq.mt_554 tr.eu.un_660  pl.it.sq_643 be.bg.un_740
  // [5b90]
  0x683b130c, 0x12251fad, 0x11002309, 0x21283b04,   // et.so.ig_543 cy.eu.hu_643  ca.ro.un_440 so.sw.jw_332
  0x20646bec, 0x6800132c, 0x181f55ee, 0x53250f08,   // ceb.lg.sq_644 et.ig.un_990  rw.cy.ga_422 lv.eu.ht_443
  0x1c64210d, 0x13201014, 0x0c55250c, 0x29000304,   // jw.lg.id_554 lt.sq.et_666  eu.rw.sv_543 nl.sl.un_320
  0x0e002705, 0x0d091c13, 0x01001807, 0x3f0203a0,   // gd.is.un_330 mr.hi.ne_665  ga.en.un_420 nl.da.af_322
  // [5ba0]
  0x0f046408, 0x1f002b13, 0x13183b0c, 0x0c072aad,   // lg.fi.lv_443 vi.cy.un_650  so.ga.et_543 mt.it.sv_643
  0x1f002b19, 0x3b1f6b0b, 0x04103ba9, 0x53004a0d,   // vi.cy.un_750 ceb.cy.so_542  so.lt.fi_544 yo.ht.un_540
  0x182120a9, 0x35041a09, 0x0c032aee, 0x3110120c,   // sq.jw.ga_544 tl.fi.zu_444  mt.nl.sv_422 hu.lt.az_543
  0x0d292da0, 0x523b10af, 0x183b27ec, 0x3b11100d,   // sk.sl.cs_322 lt.so.ha_655  gd.so.ga_644 lt.ro.so_554
  // [5bb0]
  0x0653030c, 0x3b0c52af, 0x11251011, 0x0f3b13ec,   // nl.ht.de_543 ha.sv.so_655  lt.eu.ro_653 et.so.lv_644
  0x0d001707, 0x031a6bee, 0x2d0d1f14, 0x311b0c0c,   // sr.cs.un_420 ceb.tl.nl_422  cy.cs.sk_666 sv.tr.az_543
  0x12113512, 0x0d3b27ee, 0x0431100c, 0x0f002304,   // zu.ro.hu_654 gd.so.cs_422  lt.az.fi_543 ca.lv.un_320
  0x20003f04, 0x205521a9, 0x0804020e, 0x68195508,   // af.sq.un_320 jw.rw.sq_544  da.fi.no_555 rw.gl.ig_443
  // [5bc0]
  0x0b0a0702, 0x2d1128ad, 0x3f080ca6, 0x016b0eee,   // it.pt.es_222 sw.ro.sk_643  sv.no.af_521 is.ceb.en_422
  0x681c3507, 0x64213507, 0x0e52550c, 0x08026405,   // zu.id.ig_432 zu.jw.lg_432  rw.ha.is_543 lg.da.no_333
  0x03250f60, 0x1610200c, 0x1b4a68af, 0x0a531cee,   // lv.eu.nl_664 sq.lt.hr_543  ig.yo.tr_655 id.ht.pt_422
  0x190b55ee, 0x29136402, 0x071f27ec, 0x55253b0c,   // rw.es.gl_422 lg.et.sl_222  gd.cy.it_644 so.eu.rw_543
  // [5bd0]
  0x281a1204, 0x211a64ad, 0x105528a9, 0x325525a7,   // hu.tl.sw_332 lg.tl.jw_643  sw.rw.lt_544 eu.rw.bs_532
  0x09006b0d, 0x250f0baf, 0x0c034a0c, 0x2d000308,   // ceb.pl.un_540 es.lv.eu_655  yo.nl.sv_543 nl.sk.un_430
  0x0e001b07, 0x2d033bee, 0x0b002102, 0x3f100b0c,   // tr.is.un_420 so.nl.sk_422  jw.es.un_220 es.lt.af_543
  0x280e52a4, 0x53033faf, 0x2d0d0909, 0x132718ec,   // ha.is.sw_433 af.nl.ht_655  pl.cs.sk_444 ga.gd.et_644
  // [5be0]
  0x18120307, 0x2b000621, 0x11002519, 0x071a10a4,   // nl.hu.ga_432 de.vi.un_860  eu.ro.un_750 lt.tl.it_433
  0x1f3b090d, 0x06001704, 0x04131005, 0x1200040c,   // pl.so.cy_554 sr.de.un_320  lt.et.fi_333 fi.hu.un_530
  0x06530112, 0x55106408, 0x2d0d1fad, 0x102928a4,   // en.ht.de_654 lg.lt.rw_443  cy.cs.sk_643 sw.sl.lt_433
  0x0a2a05ee, 0x0335100c, 0x20006807, 0x13031ea7,   // fr.mt.pt_422 lt.zu.nl_543  ig.sq.un_420 ms.nl.et_532
  // [5bf0]
  0x6b1a1f0c, 0x0f1f060c, 0x1a09210c, 0x53001b12,   // cy.tl.ceb_543 de.cy.lv_543  jw.pl.tl_543 tr.ht.un_640
  0x28001a19, 0x16291007, 0x5535290c, 0x0d092d04,   // tl.sw.un_750 lt.sl.hr_432  sl.zu.rw_543 sk.pl.cs_332
  0x033f0fec, 0x10000922, 0x046e1304, 0x3b1b31ec,   // lv.af.nl_644 pl.lt.un_870  et.hmn.fi_332 az.tr.so_644
  0x53091b07, 0x2100092a, 0x182d0dec, 0x6e683b04,   // tr.pl.ht_432 pl.jw.un_970  cs.sk.ga_644 so.ig.hmn_332

  // [5c00]
  0x212007ee, 0x120964a7, 0x311b6408, 0x20000a07,   // it.sq.jw_422 lg.pl.hu_532  lg.tr.az_443 pt.sq.un_420
  0x1055130c, 0x1b006e08, 0x13003b34, 0x030e0208,   // et.rw.lt_543 hmn.tr.un_430  so.et.un_A80 da.is.nl_443
  0x0b0a01a4, 0x01000e04, 0x0503190c, 0x282519ec,   // en.pt.es_433 is.en.un_320  gl.nl.fr_543 gl.eu.sw_644
  0x3f28310c, 0x35002904, 0x27001f23, 0x1f006b23,   // az.sw.af_543 sl.zu.un_320  cy.gd.un_880 ceb.cy.un_880
  // [5c10]
  0x20281007, 0x182112ee, 0x2b13010c, 0x64554a08,   // lt.sw.sq_432 ur.fa.ar_422  en.et.vi_543 yo.rw.lg_443
  0x010753ee, 0x06033555, 0x2d0a0dec, 0x10001212,   // ht.it.en_422 zu.nl.de_442  cs.pt.sk_644 hu.lt.un_640
  0x5500310c, 0x64353114, 0x2a3f0aa0, 0x0a2d2504,   // az.rw.un_530 az.zu.lg_666  pt.af.mt_322 eu.sk.pt_332
  0x203f130c, 0x35182813, 0x0a1f2d11, 0x09001907,   // et.af.sq_543 sw.ga.zu_665  sk.cy.pt_653 gl.pl.un_420
  // [5c20]
  0x55314a5a, 0x06000f04, 0x03290608, 0x1b042aa0,   // yo.az.rw_553 lv.de.un_320  de.sl.nl_443 mt.fi.tr_322
  0x4a0725ad, 0x235305a9, 0x04252309, 0x20000302,   // eu.it.yo_643 fr.ht.ca_544  ca.eu.fi_444 nl.sq.un_220
  0x04001f04, 0x2d0d0609, 0x190b0702, 0x12001f12,   // cy.fi.un_320 de.cs.sk_444  it.es.gl_222 cy.hu.un_640
  0x53012bec, 0x320c1708, 0x3b001f14, 0x1b00100e,   // vi.en.ht_644 sr.sv.bs_443  cy.so.un_660 lt.tr.un_550
  // [5c30]
  0x08000a04, 0x03001311, 0x07000519, 0x6b531a14,   // mk.uk.un_320 et.nl.un_630  fr.it.un_750 tl.ht.ceb_666
  0x0a2327a4, 0x53001f1b, 0x4a001909, 0x061e0804,   // gd.ca.pt_433 cy.ht.un_770  gl.yo.un_440 no.ms.de_332
  0x3f2a0714, 0x55006814, 0x35551108, 0x01532702,   // it.mt.af_666 ig.rw.un_660  ro.rw.zu_443 gd.ht.en_222
  0x64006829, 0x27001c02, 0x2500101a, 0x11000e2a,   // ig.lg.un_960 id.gd.un_220  lt.eu.un_760 is.ro.un_970
  // [5c40]
  0x202821a4, 0x0c0203a0, 0x321602ee, 0x21000e0c,   // jw.sw.sq_433 nl.da.sv_322  da.hr.bs_422 is.jw.un_530
  0x09201f08, 0x05001f05, 0x133b0308, 0x1f53230c,   // cy.sq.pl_443 cy.fr.un_330  nl.so.et_443 ca.ht.cy_543
  0x68181fa9, 0x3f640955, 0x2a0523a9, 0x252009a4,   // cy.ga.ig_544 pl.lg.af_442  ca.fr.mt_544 pl.sq.eu_433
  0x32160f0e, 0x6b01200d, 0x3f280a12, 0x53006813,   // lv.hr.bs_555 sq.en.ceb_554  pt.sw.af_654 ig.ht.un_650
  // [5c50]
  0x6b3f130c, 0x282153ec, 0x3b001e02, 0x0103060d,   // et.af.ceb_543 ht.jw.sw_644  ms.so.un_220 de.nl.en_554
  0x20005302, 0x532103a4, 0x18352712, 0x29000d17,   // ht.sq.un_220 nl.jw.ht_433  gd.zu.ga_654 cs.sl.un_730
  0x1b3132a0, 0x11170aec, 0x0f68640e, 0x642b35af,   // bs.az.tr_322 mk.sr.ro_644  lg.ig.lv_555 zu.vi.lg_655
  0x281335a9, 0x080e0c13, 0x03645307, 0x3f030912,   // zu.et.sw_544 sv.is.no_665  ht.lg.nl_432 pl.nl.af_654
  // [5c60]
  0x21000302, 0x0b135204, 0x091c13a6, 0x2d0d0414,   // nl.jw.un_220 ha.et.es_332  bh.mr.hi_521 fi.cs.sk_666
  0x18002302, 0x08200207, 0x071310ad, 0x1b312109,   // ca.ga.un_220 da.sq.no_432  lt.et.it_643 jw.az.tr_444
  0x53001c07, 0x1e1c0faf, 0x0a231908, 0x6b001818,   // id.ht.un_420 lv.id.ms_655  gl.ca.pt_443 ga.ceb.un_740
  0x521a28a9, 0x3b001a0d, 0x07001f13, 0x3b133fa0,   // sw.tl.ha_544 tl.so.un_540  cy.it.un_650 af.et.so_322
  // [5c70]
  0x55062108, 0x10001723, 0x68003508, 0x35092812,   // jw.de.rw_443 sr.be.un_880  zu.ig.un_430 sw.pl.zu_654
  0x5525680d, 0x685553af, 0x133b520d, 0x280535ee,   // ig.eu.rw_554 ht.rw.ig_655  ha.so.et_554 zu.fr.sw_422
  0x0300021a, 0x68551b12, 0x6425350c, 0x130410ec,   // da.nl.un_760 tr.rw.ig_654  zu.eu.lg_543 lt.fi.et_644
  0x12000608, 0x25120fa4, 0x1f000c0e, 0x192003a0,   // de.hu.un_430 lv.hu.eu_433  sv.cy.un_550 nl.sq.gl_322
  // [5c80]
  0x643552a7, 0x2a001f07, 0x1b640f11, 0x1c211607,   // ha.zu.lg_532 cy.mt.un_420  lv.lg.tr_653 hr.jw.id_432
  0x321620af, 0x1a212308, 0x640f280c, 0x06002534,   // sq.hr.bs_655 ca.jw.tl_443  sw.lv.lg_543 eu.de.un_A80
  0x64280f13, 0x28535508, 0x092d0f04, 0x35102513,   // lv.sw.lg_665 rw.ht.sw_443  lv.sk.pl_332 eu.lt.zu_665
  0x102d070c, 0x64533b05, 0x08111005, 0x121b53ee,   // it.sk.lt_543 so.ht.lg_333  be.ro.uk_333 ht.tr.hu_422
  // [5c90]
  0x13350612, 0x194a64a0, 0x282d0f08, 0x05230a0d,   // de.zu.et_654 lg.yo.gl_322  lv.sk.sw_443 pt.ca.fr_554
  0x291b17a9, 0x03061312, 0x191323a7, 0x210452ad,   // sr.tr.sl_544 et.de.nl_654  ca.et.gl_532 ha.fi.jw_643
  0x2300190b, 0x555325af, 0x03000907, 0x192a0aad,   // gl.ca.un_520 eu.ht.rw_655  pl.nl.un_420 pt.mt.gl_643
  0x1f000a1a, 0x270a4a13, 0x211b55a6, 0x5531250c,   // pt.cy.un_760 yo.pt.gd_665  rw.tr.jw_521 eu.az.rw_543
  // [5ca0]
  0x3b2d5512, 0x2d0953a0, 0x2d00060c, 0x1c0d13ee,   // rw.sk.so_654 ht.pl.sk_322  de.sk.un_530 bh.ne.mr_422
  0x553135a4, 0x682752a4, 0x21000723, 0x1029680d,   // zu.az.rw_433 ha.gd.ig_433  it.jw.un_880 ig.sl.lt_554
  0x35003b2b, 0x190721a0, 0x01003502, 0x35002014,   // so.zu.un_980 jw.it.gl_322  zu.en.un_220 sq.zu.un_660
  0x29065202, 0x0a122d0d, 0x044a21ee, 0x31251311,   // ha.de.sl_222 sk.hu.pt_554  jw.yo.fi_422 et.eu.az_653
  // [5cb0]
  0x254a1a12, 0x08002b04, 0x0b102807, 0x0d292d11,   // tl.yo.eu_654 vi.no.un_320  sw.lt.es_432 sk.sl.cs_653
  0x04000905, 0x6400130d, 0x3f0c1f14, 0x07003108,   // pl.fi.un_330 et.lg.un_540  cy.sv.af_666 az.it.un_430
  0x55002d04, 0x1b0513ee, 0x0d1652ee, 0x29006e08,   // sk.rw.un_320 et.fr.tr_422  ha.hr.cs_422 hmn.sl.un_430
  0x07000418, 0x0b0929ee, 0x251b07ad, 0x050755a7,   // ru.bg.un_740 sl.pl.es_422  it.tr.eu_643 rw.it.fr_532
  // [5cc0]
  0x6e036b04, 0x022d290e, 0x016b64a0, 0x283210a9,   // ceb.nl.hmn_332 sl.sk.da_555  lg.ceb.en_322 lt.bs.sw_544
  0x08000304, 0x014a1307, 0x6b521c0b, 0x133255ee,   // nl.no.un_320 et.yo.en_432  id.ha.ceb_542 rw.bs.et_422
  0x063552a0, 0x29190a0d, 0x13002108, 0x01281307,   // ha.zu.de_322 pt.gl.sl_554  jw.et.un_430 et.sw.en_432
  0x1a1c0c0d, 0x02200602, 0x52554a08, 0x080212ec,   // sv.id.tl_554 de.sq.da_222  yo.rw.ha_443 hu.da.no_644
  // [5cd0]
  0x03001e0d, 0x211268a9, 0x320816a4, 0x0b0a11ac,   // ms.nl.un_540 ig.hu.jw_544  hr.no.bs_433 ro.pt.es_632
  0x0c1c53ad, 0x1e1c1aec, 0x1a206ea0, 0x13002017,   // ht.id.sv_643 tl.id.ms_644  hmn.sq.tl_322 sq.et.un_730
  0x68130204, 0x3f00550c, 0x1b002013, 0x0c270607,   // da.et.ig_332 rw.af.un_530  sq.tr.un_650 de.gd.sv_432
  0x32162909, 0x0c02120c, 0x27061ead, 0x23061f12,   // sl.hr.bs_444 hu.da.sv_543  ms.de.gd_643 cy.de.ca_654
  // [5ce0]
  0x082a02a0, 0x0c051304, 0x03020c0d, 0x35002302,   // da.mt.no_322 et.fr.sv_332  sv.da.nl_554 ca.zu.un_220
  0x230b3ba4, 0x0c6b08a0, 0x01030602, 0x2a001804,   // so.es.ca_433 no.ceb.sv_322  de.nl.en_222 ga.mt.un_320
  0x0c3f2907, 0x0c520608, 0x18002d18, 0x251b0ba0,   // sl.af.sv_432 de.ha.sv_443  sk.ga.un_740 es.tr.eu_322
  0x531a520c, 0x55521bad, 0x5264550c, 0x5300211a,   // ha.tl.ht_543 tr.ha.rw_643  rw.lg.ha_543 jw.ht.un_760
  // [5cf0]
  0x18230713, 0x53006422, 0x6b1a1213, 0x2505190c,   // it.ca.ga_665 lg.ht.un_870  hu.tl.ceb_665 gl.fr.eu_543
  0x6b0e125a, 0x09102504, 0x1b2864a0, 0x161304a4,   // hu.is.ceb_553 eu.lt.pl_332  lg.sw.tr_322 fi.et.hr_433
  0x0f0310ec, 0x31002102, 0x256b3b09, 0x3f0c25a4,   // lt.nl.lv_644 jw.az.un_220  so.ceb.eu_444 eu.sv.af_433
  0x6b3153af, 0x3f531e08, 0x120a07a9, 0x033b3fac,   // ht.az.ceb_655 ms.ht.af_443  it.pt.hu_544 af.so.nl_632
  // [5d00]
  0x280a2104, 0x20000609, 0x0a033f14, 0x35002102,   // jw.pt.sw_332 de.sq.un_440  af.nl.pt_666 jw.zu.un_220
  0x080a10ec, 0x1c002a13, 0x190b04a9, 0x052723a4,   // be.mk.uk_644 mt.id.un_650  fi.es.gl_544 ca.gd.fr_433
  0x031f27ad, 0x27000621, 0x272311af, 0x6b201a0b,   // gd.cy.nl_643 de.gd.un_860  ro.ca.gd_655 tl.sq.ceb_542
  0x5517040c, 0x02001a07, 0x641b55ee, 0x05072004,   // fi.sr.rw_543 tl.da.un_420  rw.tr.lg_422 sq.it.fr_332
  // [5d10]
  0x53091113, 0x280c1060, 0x271f2308, 0x0600230d,   // ro.pl.ht_665 lt.sv.sw_664  ca.cy.gd_443 ca.de.un_540
  0x10006414, 0x17531baf, 0x16000c0b, 0x53001222,   // lg.lt.un_660 tr.ht.sr_655  sv.hr.un_520 hu.ht.un_870
  0x25005204, 0x19050a07, 0x3b002107, 0x2307680c,   // ha.eu.un_320 pt.fr.gl_432  jw.so.un_420 ig.it.ca_543
  0x1b0e1307, 0x100a20a9, 0x051a20ee, 0x2a100504,   // et.is.tr_432 sq.pt.lt_544  sq.tl.fr_422 fr.lt.mt_332
  // [5d20]
  0x641b1307, 0x1e4a1ca4, 0x07001707, 0x3b005221,   // et.tr.lg_432 id.yo.ms_433  sr.it.un_420 ha.so.un_860
  0x03000702, 0x3528170c, 0x08525312, 0x53001e1a,   // it.nl.un_220 sr.sw.zu_543  ht.ha.no_654 ms.ht.un_760
  0x252d29a0, 0x06100f0d, 0x09002302, 0x53001113,   // sl.sk.eu_322 lv.lt.de_554  ca.pl.un_220 ro.ht.un_650
  0x3f030fa4, 0x1c002709, 0x521e050c, 0x0727110c,   // lv.nl.af_433 gd.id.un_440  fr.ms.ha_543 ro.gd.it_543
  // [5d30]
  0x250210ac, 0x0c130fa4, 0x27002b04, 0x523b2508,   // lt.da.eu_632 lv.et.sv_433  vi.gd.un_320 eu.so.ha_443
  0x1200190d, 0x35130412, 0x1c005302, 0x68001e0d,   // gl.hu.un_540 fi.et.zu_654  ht.id.un_220 ms.ig.un_540
  0x016b21a0, 0x31006812, 0x3b311ea9, 0x20001902,   // jw.ceb.en_322 ig.az.un_640  ms.az.so_544 gl.sq.un_220
  0x55523bec, 0x552752a9, 0x311a52ec, 0x3b004a02,   // so.ha.rw_644 ha.gd.rw_544  ha.tl.az_644 yo.so.un_220
  // [5d40]
  0x32001b08, 0x213b520c, 0x35645212, 0x07001e04,   // tr.bs.un_430 ha.so.jw_543  ha.lg.zu_654 ms.it.un_320
  0x1b1a3ba9, 0x28002114, 0x272118af, 0x356431a7,   // so.tl.tr_544 jw.sw.un_660  ga.jw.gd_655 az.lg.zu_532
  0x0f10270e, 0x351a28af, 0x0b0f1008, 0x060c020e,   // gd.lt.lv_555 sw.tl.zu_655  lt.lv.es_443 da.sv.de_555
  0x112b28a4, 0x21313ba4, 0x523b31a9, 0x182927ee,   // sw.vi.ro_433 so.az.jw_433  az.so.ha_544 gd.sl.ga_422
  // [5d50]
  0x31645509, 0x2d0d1aa4, 0x55002113, 0x6b5552ec,   // rw.lg.az_444 tl.cs.sk_433  jw.rw.un_650 ha.rw.ceb_644
  0x1a3531ec, 0x64682812, 0x0d020c12, 0x0b0710af,   // az.zu.tl_644 sw.ig.lg_654  sv.da.cs_654 lt.it.es_655
  0x0b1f6b11, 0x32172da4, 0x08060207, 0x211b6ea0,   // ceb.cy.es_653 sk.sr.bs_433  da.de.no_432 hmn.tr.jw_322
  0x063f0aee, 0x19000704, 0x2d0d3205, 0x25193107,   // pt.af.de_422 it.gl.un_320  bs.cs.sk_333 az.gl.eu_432
  // [5d60]
  0x0c001a07, 0x55043b0c, 0x1b0a1a07, 0x0c000a02,   // tl.sv.un_420 so.fi.rw_543  tl.pt.tr_432 pt.sv.un_220
  0x2700050d, 0x1c002d04, 0x13090d55, 0x1e2125a0,   // fr.gd.un_540 sk.id.un_320  ne.hi.bh_442 eu.jw.ms_322
  0x12553504, 0x1f55520c, 0x18003518, 0x11172911,   // zu.rw.hu_332 ha.rw.cy_543  zu.ga.un_740 sl.sr.ro_653
  0x35001822, 0x013527a0, 0x103b5507, 0x0f3b3511,   // ga.zu.un_870 gd.zu.en_322  rw.so.lt_432 zu.so.lv_653
  // [5d70]
  0x130f6b0c, 0x1c130d04, 0x080612a4, 0x3b004a19,   // ceb.lv.et_543 ne.bh.mr_332  hu.de.no_433 yo.so.un_750
  0x101113a0, 0x1101070c, 0x3553050c, 0x04120f55,   // et.ro.lt_322 it.en.ro_543  fr.ht.zu_543 lv.hu.fi_442
  0x0e0713a7, 0x20231304, 0x10072512, 0x200523a9,   // et.it.is_532 et.ca.sq_332  eu.it.lt_654 ca.fr.sq_544
  0x0c082aad, 0x041b270b, 0x0e0429ac, 0x20002807,   // mt.no.sv_643 gd.tr.fi_542  sl.fi.is_632 sw.sq.un_420
  // [5d80]
  0x1a001c02, 0x3b526460, 0x29355212, 0x1c036b02,   // id.tl.un_220 lg.ha.so_664  ha.zu.sl_654 ceb.nl.id_222
  0x3f6b1a12, 0x1f016804, 0x21002a02, 0x2d0f29a4,   // tl.ceb.af_654 ig.en.cy_332  mt.jw.un_220 sl.lv.sk_433
  0x0a001920, 0x0b000a1e, 0x0e12080c, 0x29200fee,   // gl.pt.un_850 pt.es.un_830  no.hu.is_543 lv.sq.sl_422
  0x11006818, 0x13090d0d, 0x10042307, 0x25006e04,   // ig.ro.un_740 ne.hi.bh_554  ca.fi.lt_432 hmn.eu.un_320
  // [5d90]
  0x102852a0, 0x0c080412, 0x0e041bad, 0x08040212,   // ha.sw.lt_322 fi.no.sv_654  tr.fi.is_643 da.fi.no_654
  0x68000d13, 0x2d002514, 0x6b2d550c, 0x033f080c,   // cs.ig.un_650 eu.sk.un_660  rw.sk.ceb_543 no.af.nl_543
  0x0502010c, 0x16001104, 0x536b2807, 0x111923ee,   // en.da.fr_543 ro.hr.un_320  sw.ceb.ht_432 ca.gl.ro_422
  0x016e02ee, 0x0e124aa9, 0x2a00041b, 0x522d3fa0,   // da.hmn.en_422 yo.hu.is_544  fi.mt.un_770 af.sk.ha_322
  // [5da0]
  0x1208350c, 0x080220af, 0x552d0d0d, 0x2a686b07,   // zu.no.hu_543 sq.da.no_655  cs.sk.rw_554 ceb.ig.mt_432
  0x102528a4, 0x2d00041a, 0x042d5504, 0x32006e07,   // sw.eu.lt_433 fi.sk.un_760  rw.sk.fi_332 hmn.bs.un_420
  0x2b00250e, 0x1a6b55a9, 0x1000070e, 0x3b353112,   // eu.vi.un_550 rw.ceb.tl_544  it.lt.un_550 az.zu.so_654
  0x20071aa0, 0x5500680e, 0x25531f05, 0x3b001902,   // tl.it.sq_322 ig.rw.un_550  cy.ht.eu_333 gl.so.un_220
  // [5db0]
  0x052868ee, 0x0f181ea9, 0x356820a4, 0x32003f08,   // ig.sw.fr_422 ms.ga.lv_544  sq.ig.zu_433 af.bs.un_430
  0x190a050c, 0x10282507, 0x0b0a25a4, 0x01646b02,   // fr.pt.gl_543 eu.sw.lt_432  eu.pt.es_433 ceb.lg.en_222
  0x16120dee, 0x1e0c1c0c, 0x052a0408, 0x322a160c,   // cs.hu.hr_422 id.sv.ms_543  fi.mt.fr_443 hr.mt.bs_543
  0x3f0704a4, 0x04003112, 0x080b060c, 0x12061b07,   // fi.it.af_433 az.fi.un_640  de.es.no_543 tr.de.hu_432
  // [5dc0]
  0x072a0a0c, 0x3f250b0d, 0x285535a4, 0x1008250c,   // pt.mt.it_543 es.eu.af_554  zu.rw.sw_433 eu.no.lt_543
  0x132704a7, 0x1a3525a4, 0x64551fa4, 0x08280207,   // fi.gd.et_532 eu.zu.tl_433  cy.rw.lg_433 da.sw.no_432
  0x03062a08, 0x050704a4, 0x290a350c, 0x13120409,   // mt.de.nl_443 fi.it.fr_433  zu.pt.sl_543 fi.hu.et_444
  0x0305040c, 0x2d19350b, 0x012027ee, 0x082a0455,   // fi.fr.nl_543 zu.gl.sk_542  gd.sq.en_422 fi.mt.no_442
  // [5dd0]
  0x52006e2a, 0x0c002102, 0x04554a0d, 0x1c291e04,   // hmn.ha.un_970 jw.sv.un_220  yo.rw.fi_554 ms.sl.id_332
  0x1c001a07, 0x20231f0d, 0x55121ea4, 0x081220a6,   // tl.id.un_420 cy.ca.sq_554  ms.hu.rw_433 sq.hu.no_521
  0x19230b13, 0x35124aee, 0x1e001704, 0x271128af,   // es.ca.gl_665 yo.hu.zu_422  sr.ms.un_320 sw.ro.gd_655
  0x12000c0b, 0x1c1e3b04, 0x011f09a7, 0x1f00060e,   // sv.hu.un_520 so.ms.id_332  pl.cy.en_532 de.cy.un_550
  // [5de0]
  0x29000108, 0x3f002102, 0x6b000709, 0x313519ad,   // en.sl.un_430 jw.af.un_220  it.ceb.un_440 gl.zu.az_643
  0x280e35a4, 0x04133ba7, 0x0c2a200d, 0x10001f0e,   // zu.is.sw_433 so.et.fi_532  sq.mt.sv_554 cy.lt.un_550
  0x01130a05, 0x25102805, 0x09001213, 0x35001a12,   // pt.et.en_333 sw.lt.eu_333  hu.pl.un_650 tl.zu.un_640
  0x190b01a0, 0x10002704, 0x1e1c0dee, 0x190a0faf,   // en.es.gl_322 gd.lt.un_320  cs.id.ms_422 lv.pt.gl_655
  // [5df0]
  0x02006b07, 0x130f0ba4, 0x6b68350c, 0x2a0703a4,   // ceb.da.un_420 es.lv.et_433  zu.ig.ceb_543 nl.it.mt_433
  0x0f210bee, 0x2a000504, 0x28002505, 0x523b21ec,   // es.jw.lv_422 fr.mt.un_320  eu.sw.un_330 jw.so.ha_644
  0x2d3b0d07, 0x2d0d080c, 0x191c0ba0, 0x0e006b12,   // cs.so.sk_432 no.cs.sk_543  es.id.gl_322 ceb.is.un_640
  0x356864a4, 0x07193b05, 0x0b076b07, 0x4a3b52ec,   // lg.ig.zu_433 so.gl.it_333  ceb.it.es_432 ha.so.yo_644
  // [5e00]
  0x1f2012af, 0x1e000808, 0x071a4aa0, 0x0b003204,   // hu.sq.cy_655 no.ms.un_430  yo.tl.it_322 bs.es.un_320
  0x0a063fad, 0x1f00521a, 0x35010407, 0x20182905,   // af.de.pt_643 ha.cy.un_760  fi.en.zu_432 sl.ga.sq_333
  0x202d55a0, 0x080d02ee, 0x0d00350e, 0x06002702,   // rw.sk.sq_322 da.cs.no_422  zu.cs.un_550 gd.de.un_220
  0x1b0f1304, 0x11000c04, 0x1f000d18, 0x2305080c,   // et.lv.tr_332 sv.ro.un_320  cs.cy.un_740 no.fr.ca_543
  // [5e10]
  0x1b131007, 0x081710ec, 0x19050b12, 0x19530a08,   // lt.et.tr_432 be.sr.uk_644  es.fr.gl_654 pt.ht.gl_443
  0x13003f13, 0x3f031055, 0x23001013, 0x3f032760,   // af.et.un_650 lt.nl.af_442  lt.ca.un_650 gd.nl.af_664
  0x10003f19, 0x10000312, 0x1b6e10a4, 0x1c4a1ea0,   // af.lt.un_750 nl.lt.un_640  lt.hmn.tr_433 ms.yo.id_322
  0x1a2d21a0, 0x290f18ad, 0x32311705, 0x11531ba0,   // jw.sk.tl_322 ga.lv.sl_643  sr.az.bs_333 tr.ht.ro_322
  // [5e20]
  0x55211009, 0x122a3505, 0x2d0d0f0c, 0x55046bad,   // lt.jw.rw_444 zu.mt.hu_333  lv.cs.sk_543 ceb.fi.rw_643
  0x52200fa4, 0x12210408, 0x10030ead, 0x29040ea4,   // lv.sq.ha_433 fi.jw.hu_443  is.nl.lt_643 is.fi.sl_433
  0x18001b0e, 0x0c2b27ad, 0x6b0f21a9, 0x3f000223,   // tr.ga.un_550 gd.vi.sv_643  jw.lv.ceb_544 da.af.un_880
  0x52202707, 0x033f1812, 0x1c1f1e12, 0x6e271809,   // gd.sq.ha_432 ga.af.nl_654  ms.cy.id_654 ga.gd.hmn_444
  // [5e30]
  0x1106070c, 0x0412280c, 0x3f110304, 0x162528a6,   // it.de.ro_543 sw.hu.fi_543  nl.ro.af_332 sw.eu.hr_521
  0x122821a4, 0x4a0e6805, 0x3f020608, 0x1c201e12,   // jw.sw.hu_433 ig.is.yo_333  de.da.af_443 ms.sq.id_654
  0x27040512, 0x05010408, 0x0a003502, 0x170f1a08,   // fr.fi.gd_654 fi.en.fr_443  zu.pt.un_220 tl.lv.sr_443
  0x18090555, 0x19040508, 0x0b0a19a6, 0x2d12290c,   // fr.pl.ga_442 fr.fi.gl_443  gl.pt.es_521 sl.hu.sk_543
  // [5e40]
  0x0c0406a7, 0x0d093f0e, 0x25285512, 0x0f1001a4,   // de.fi.sv_532 af.pl.cs_555  rw.sw.eu_654 en.lt.lv_433
  0x0a1129a0, 0x25000714, 0x081023af, 0x08230f08,   // sl.ro.pt_322 it.eu.un_660  ca.lt.no_655 lv.ca.no_443
  0x290821a6, 0x1f2a3ba4, 0x21002802, 0x29002d02,   // jw.no.sl_521 so.mt.cy_433  sw.jw.un_220 sk.sl.un_220
  0x11103107, 0x190a52ee, 0x100f040c, 0x20273fa0,   // az.lt.ro_432 ha.pt.gl_422  fi.lv.lt_543 af.gd.sq_322
  // [5e50]
  0x286b5304, 0x2d0d2505, 0x180b1fa0, 0x52201fa4,   // ht.ceb.sw_332 eu.cs.sk_333  cy.es.ga_322 cy.sq.ha_433
  0x29001723, 0x1c13090b, 0x1712200c, 0x535204ad,   // sr.sl.un_880 hi.bh.mr_542  sq.hu.sr_543 fi.ha.ht_643
  0x2d0d1209, 0x12000307, 0x556401a4, 0x25030f55,   // hu.cs.sk_444 nl.hu.un_420  en.lg.rw_433 lv.nl.eu_442
  0x131f03ad, 0x0a003f04, 0x35030a02, 0x02003f07,   // nl.cy.et_643 af.pt.un_320  pt.nl.zu_222 af.da.un_420
  // [5e60]
  0x202503ad, 0x2d1e2304, 0x551a68ec, 0x2b322dad,   // nl.eu.sq_643 ca.ms.sk_332  ig.tl.rw_644 sk.bs.vi_643
  0x05351102, 0x21000204, 0x35295512, 0x27060211,   // ro.zu.fr_222 da.jw.un_320  rw.sl.zu_654 da.de.gd_653
  0x682855ad, 0x0b2318a4, 0x1e071c07, 0x07000502,   // rw.sw.ig_643 ga.ca.es_433  id.it.ms_432 fr.it.un_220
  0x2a005302, 0x1e1b1aaf, 0x2d1c0804, 0x3220170c,   // ht.mt.un_220 tl.tr.ms_655  no.id.sk_332 sr.sq.bs_543
  // [5e70]
  0x021b1fa7, 0x2a004a0d, 0x32172905, 0x0728350d,   // cy.tr.da_532 yo.mt.un_540  sl.sr.bs_333 zu.sw.it_554
  0x0f090304, 0x321631a0, 0x09681107, 0x210c1a04,   // nl.pl.lv_332 az.hr.bs_322  ro.ig.pl_432 tl.sv.jw_332
  0x276b06ee, 0x0c006805, 0x12111304, 0x01523f04,   // de.ceb.gd_422 ig.sv.un_330  et.ro.hu_332 af.ha.en_332
  0x320512ee, 0x091a64ec, 0x1b00640e, 0x08270cad,   // hu.fr.bs_422 lg.tl.pl_644  lg.tr.un_550 sv.gd.no_643
  // [5e80]
  0x0e003f21, 0x0b000a1b, 0x03272a04, 0x1c006e04,   // af.is.un_860 pt.es.un_770  mt.gd.nl_332 hmn.id.un_320
  0x0c002a05, 0x0b070a07, 0x3500210c, 0x16000c07,   // mt.sv.un_330 pt.it.es_432  jw.zu.un_530 sv.hr.un_420
  0x0f000604, 0x0a1a6eee, 0x29071308, 0x52353fa0,   // de.lv.un_320 hmn.tl.pt_422  et.it.sl_443 af.zu.ha_322
  0x0a291008, 0x12201ba7, 0x08076b04, 0x03273f12,   // lt.sl.pt_443 tr.sq.hu_532  ceb.it.no_332 af.gd.nl_654
  // [5e90]
  0x273f230c, 0x02126bee, 0x190b23a6, 0x036b3faf,   // ca.af.gd_543 ceb.hu.da_422  ca.es.gl_521 af.ceb.nl_655
  0x100220a4, 0x2d0d25ee, 0x6b003f07, 0x01006402,   // sq.da.lt_433 eu.cs.sk_422  af.ceb.un_420 lg.en.un_220
  0x53352508, 0x05011fee, 0x190b2509, 0x070a12a9,   // eu.zu.ht_443 cy.en.fr_422  eu.es.gl_444 hu.pt.it_544
  0x132935a0, 0x093516ee, 0x040a1f05, 0x132325af,   // zu.sl.et_322 hr.zu.pl_422  cy.pt.fi_333 eu.ca.et_655
  // [5ea0]
  0x52281eaf, 0x05092309, 0x04003f13, 0x08352312,   // ms.sw.ha_655 ca.pl.fr_444  af.fi.un_650 ca.zu.no_654
  0x03002321, 0x20001e0d, 0x0a0b1960, 0x100701a9,   // ca.nl.un_860 ms.sq.un_540  gl.es.pt_664 en.it.lt_544
  0x1121010c, 0x05010807, 0x1100201b, 0x080717ec,   // en.jw.ro_543 no.en.fr_432  sq.ro.un_770 sr.bg.uk_644
  0x04641a09, 0x355209ad, 0x27016ba0, 0x35092802,   // tl.lg.fi_444 pl.ha.zu_643  ceb.en.gd_322 sw.pl.zu_222
  // [5eb0]
  0x033f06a6, 0x4a0f28ee, 0x21533b04, 0x02000c22,   // de.af.nl_521 sw.lv.yo_422  so.ht.jw_332 sv.da.un_870
  0x28000920, 0x32203509, 0x290d12af, 0x1c000c05,   // pl.sw.un_850 zu.sq.bs_444  hu.cs.sl_655 sv.id.un_330
  0x020e08ec, 0x1e211c60, 0x1c000c18, 0x6b2864ac,   // no.is.da_644 id.jw.ms_664  sv.id.un_740 lg.sw.ceb_632
  0x0b1912a9, 0x1c0f6eee, 0x07282a13, 0x11000f12,   // hu.gl.es_544 hmn.lv.id_422  mt.sw.it_665 lv.ro.un_640
  // [5ec0]
  0x32000f04, 0x0c0603a0, 0x120d2012, 0x1b001604,   // lv.bs.un_320 nl.de.sv_322  sq.cs.hu_654 hr.tr.un_320
  0x3f230512, 0x126425af, 0x290353af, 0x3b000c05,   // fr.ca.af_654 eu.lg.hu_655  ht.nl.sl_655 sv.so.un_330
  0x0a3b13af, 0x556b680d, 0x2d120daf, 0x18120bec,   // et.so.pt_655 ig.ceb.rw_554  cs.hu.sk_655 es.hu.ga_644
  0x68133b12, 0x253f03ad, 0x032d0513, 0x03000502,   // so.et.ig_654 nl.af.eu_643  fr.sk.nl_665 fr.nl.un_220
  // [5ed0]
  0x55005204, 0x68003f1a, 0x25002002, 0x533f6b02,   // ha.rw.un_320 af.ig.un_760  sq.eu.un_220 ceb.af.ht_222
  0x03270c07, 0x08171208, 0x212864a0, 0x033f0dee,   // sv.gd.nl_432 hu.sr.no_443  lg.sw.jw_322 cs.af.nl_422
  0x10000907, 0x130823ad, 0x010a19ee, 0x10023f0c,   // pl.lt.un_420 ca.no.et_643  gl.pt.en_422 af.da.lt_543
  0x0c05080c, 0x0f060512, 0x1b525508, 0x091953ec,   // no.fr.sv_543 fr.de.lv_654  rw.ha.tr_443 ht.gl.pl_644
  // [5ee0]
  0x281125ad, 0x1f0c020c, 0x1c006402, 0x21013bee,   // eu.ro.sw_643 da.sv.cy_543  lg.id.un_220 so.en.jw_422
  0x19110a0c, 0x1800190d, 0x17290fad, 0x291e1c13,   // pt.ro.gl_543 gl.ga.un_540  lv.sl.sr_643 id.ms.sl_665
  0x3f055312, 0x04005302, 0x32002104, 0x190a0b07,   // ht.fr.af_654 ht.fi.un_220  jw.bs.un_320 es.pt.gl_432
  0x1f52640c, 0x07160a07, 0x05000d04, 0x3b521e12,   // lg.ha.cy_543 pt.hr.it_432  cs.fr.un_320 ms.ha.so_654
  // [5ef0]
  0x08010bee, 0x033f10ad, 0x06000d04, 0x27001308,   // es.en.no_422 lt.af.nl_643  cs.de.un_320 et.gd.un_430
  0x6b531a09, 0x6b641a05, 0x25066b02, 0x1f3b2aee,   // tl.ht.ceb_444 tl.lg.ceb_333  ceb.de.eu_222 mt.so.cy_422
  0x025208af, 0x0c2a07a9, 0x083f0508, 0x321e1c14,   // no.ha.da_655 it.mt.sv_544  fr.af.no_443 id.ms.bs_666
  0x0e216ba0, 0x6b1a55af, 0x64183fa7, 0x35006e0e,   // ceb.jw.is_322 rw.tl.ceb_655  af.ga.lg_532 hmn.zu.un_550
  // [5f00]
  0x316e1307, 0x321606ec, 0x31001111, 0x06001805,   // et.hmn.az_432 de.hr.bs_644  ro.az.un_630 ga.de.un_330
  0x2d004a05, 0x11000408, 0x051a6860, 0x06000b05,   // yo.sk.un_330 ru.ro.un_430  ig.tl.fr_664 es.de.un_330
  0x25036ba0, 0x21111a0c, 0x190a6eec, 0x52113107,   // ceb.nl.eu_322 tl.ro.jw_543  hmn.pt.gl_644 az.ro.ha_432
  0x0b0a10a6, 0x1b002709, 0x0e280caf, 0x08006e0d,   // lt.pt.es_521 gd.tr.un_440  sv.sw.is_655 hmn.no.un_540
  // [5f10]
  0x55253b08, 0x1632170c, 0x01282bad, 0x6b1f0c09,   // so.eu.rw_443 sr.bs.hr_543  vi.sw.en_643 sv.cy.ceb_444
  0x32000804, 0x25042008, 0x53000521, 0x0b0a2309,   // no.bs.un_320 sq.fi.eu_443  fr.ht.un_860 ca.pt.es_444
  0x11051fa0, 0x203f1304, 0x2d0d0b02, 0x0f082804,   // cy.fr.ro_322 et.af.sq_332  es.cs.sk_222 sw.no.lv_332
  0x08005219, 0x190b0ea4, 0x3f00280c, 0x1f6b2707,   // ha.no.un_750 is.es.gl_433  sw.af.un_530 gd.ceb.cy_432
  // [5f20]
  0x11050304, 0x1b001702, 0x3f000e21, 0x556b2812,   // nl.fr.ro_332 sr.tr.un_220  is.af.un_860 sw.ceb.rw_654
  0x3f001f14, 0x05040f0c, 0x05001b14, 0x0d1c13a0,   // cy.af.un_660 lv.fi.fr_543  tr.fr.un_660 bh.mr.ne_322
  0x05000829, 0x3f000f23, 0x10006e1a, 0x013f23af,   // no.fr.un_960 lv.af.un_880  hmn.lt.un_760 ca.af.en_655
  0x68001c22, 0x520e1a5a, 0x23075308, 0x0164180c,   // id.ig.un_870 tl.is.ha_553  ht.it.ca_443 ga.lg.en_543
  // [5f30]
  0x532852ad, 0x030f0111, 0x282568af, 0x0f003f23,   // ha.sw.ht_643 en.lv.nl_653  ig.eu.sw_655 af.lv.un_880
  0x28133bec, 0x060c0860, 0x103528a9, 0x1e1c52af,   // so.et.sw_644 no.sv.de_664  sw.zu.lt_544 ha.id.ms_655
  0x2d210da4, 0x1b000e04, 0x08020f07, 0x09520ea9,   // cs.jw.sk_433 is.tr.un_320  lv.da.no_432 is.ha.pl_544
  0x1005280d, 0x13042508, 0x1f0802ee, 0x180413a9,   // sw.fr.lt_554 eu.fi.et_443  da.no.cy_422 et.fi.ga_544
  // [5f40]
  0x092155af, 0x28100508, 0x080c2aec, 0x0b070112,   // rw.jw.pl_655 fr.lt.sw_443  mt.sv.no_644 en.it.es_654
  0x08520e05, 0x64683bec, 0x0b0a0eee, 0x17072055,   // is.ha.no_333 so.ig.lg_644  is.pt.es_422 sq.it.sr_442
  0x180727a0, 0x110e0f04, 0x1e001a0c, 0x2a0807a9,   // gd.it.ga_322 lv.is.ro_332  tl.ms.un_530 it.no.mt_544
  0x04050fa9, 0x683b6412, 0x35215212, 0x3b071e02,   // lv.fr.fi_544 lg.so.ig_654  ha.jw.zu_654 ms.it.so_222
  // [5f50]
  0x2d0d23ec, 0x190510ad, 0x3b006402, 0x271018a9,   // ca.cs.sk_644 lt.fr.gl_643  lg.so.un_220 ga.lt.gd_544
  0x0b000208, 0x0f080e08, 0x0c065213, 0x55640b07,   // da.es.un_430 is.no.lv_443  ha.de.sv_665 es.lg.rw_432
  0x6b4a550c, 0x02183b55, 0x350b0304, 0x280903a4,   // rw.yo.ceb_543 so.ga.da_442  nl.es.zu_332 nl.pl.sw_433
  0x3b090407, 0x1c001e20, 0x6453550d, 0x521a1b0c,   // fi.pl.so_432 ms.id.un_850  rw.ht.lg_554 tr.tl.ha_543
  // [5f60]
  0x321608af, 0x19003102, 0x186e27a7, 0x083b1b0d,   // no.hr.bs_655 az.gl.un_220  gd.hmn.ga_532 tr.so.no_554
  0x190b27a4, 0x13005204, 0x216468a0, 0x062a070c,   // gd.es.gl_433 ha.et.un_320  ig.lg.jw_322 it.mt.de_543
  0x27180605, 0x1101230c, 0x2d0d68a4, 0x0f000a08,   // de.ga.gd_333 ca.en.ro_543  ig.cs.sk_433 pt.lv.un_430
  0x183b5213, 0x3b27250c, 0x21111aa4, 0x2a1b6ba4,   // ha.so.ga_665 eu.gd.so_543  tl.ro.jw_433 ceb.tr.mt_433
  // [5f70]
  0x281a1b0c, 0x100b2804, 0x18000313, 0x1331110c,   // tr.tl.sw_543 sw.es.lt_332  nl.ga.un_650 ro.az.et_543
  0x1c641ea0, 0x082501a4, 0x030501a9, 0x05005504,   // ms.lg.id_322 en.eu.no_433  en.fr.nl_544 rw.fr.un_320
  0x1f05040c, 0x641135a4, 0x18210fa4, 0x0d1613ad,   // fi.fr.cy_543 zu.ro.lg_433  lv.jw.ga_433 et.hr.cs_643
  0x1029350c, 0x322935a4, 0x17286b08, 0x04111a02,   // zu.sl.lt_543 zu.sl.bs_433  ceb.sw.sr_443 tl.ro.fi_222
  // [5f80]
  0x1b311208, 0x212a290c, 0x16002107, 0x10130f08,   // hu.az.tr_443 sl.mt.jw_543  jw.hr.un_420 lv.et.lt_443
  0x16006408, 0x1c2a1ea0, 0x1017040c, 0x190f0bad,   // lg.hr.un_430 ms.mt.id_322  ru.sr.be_543 es.lv.gl_643
  0x201b060c, 0x2800041b, 0x190b23ac, 0x030c2013,   // de.tr.sq_543 fi.sw.un_770  ca.es.gl_632 sq.sv.nl_665
  0x131827a9, 0x04032704, 0x030806ee, 0x041c25a9,   // gd.ga.et_544 gd.nl.fi_332  de.no.nl_422 eu.id.fi_544
  // [5f90]
  0x103f04a7, 0x0a002104, 0x0e001812, 0x3f5310a4,   // fi.af.lt_532 jw.pt.un_320  ga.is.un_640 lt.ht.af_433
  0x0d000f12, 0x273f03af, 0x0a2311af, 0x64001602,   // lv.cs.un_640 nl.af.gd_655  ro.ca.pt_655 hr.lg.un_220
  0x3f032704, 0x3f001f2a, 0x1f3f100c, 0x011f10ee,   // gd.nl.af_332 cy.af.un_970  lt.af.cy_543 lt.cy.en_422
  0x072320a4, 0x211e1a08, 0x1a4a2813, 0x2d18270d,   // sq.ca.it_433 tl.ms.jw_443  sw.yo.tl_665 gd.ga.sk_554
  // [5fa0]
  0x10116ea6, 0x0e2a0b08, 0x4a003113, 0x10072d12,   // hmn.ro.lt_521 es.mt.is_443  az.yo.un_650 sk.it.lt_654
  0x270b18af, 0x1900281a, 0x0f1310ec, 0x08001913,   // ga.es.gd_655 sw.gl.un_760  lt.et.lv_644 gl.no.un_650
  0x05002a02, 0x27003b0c, 0x64133508, 0x0b0a5202,   // mt.fr.un_220 so.gd.un_530  zu.et.lg_443 ha.pt.es_222
  0x21001604, 0x1a006e0d, 0x5200050d, 0x3229080b,   // hr.jw.un_320 hmn.tl.un_540  fr.ha.un_540 no.sl.bs_542
  // [5fb0]
  0x100f0c09, 0x4a0b0a14, 0x17523b08, 0x3b0403a9,   // sv.lv.lt_444 pt.es.yo_666  so.ha.sr_443 nl.fi.so_544
  0x2b006b02, 0x0e101307, 0x6b1c0408, 0x0405310c,   // ceb.vi.un_220 et.lt.is_432  fi.id.ceb_443 az.fr.fi_543
  0x312a6b04, 0x31201f07, 0x2909320d, 0x3b6413a4,   // ceb.mt.az_332 cy.sq.az_432  bs.pl.sl_554 et.lg.so_433
  0x315220a7, 0x3f061fa4, 0x07021007, 0x2021040c,   // sq.ha.az_532 cy.de.af_433  lt.da.it_432 fi.jw.sq_543
  // [5fc0]
  0x1a216b60, 0x640a4aa0, 0x5200200c, 0x64011fee,   // ceb.jw.tl_664 yo.pt.lg_322  sq.ha.un_530 cy.en.lg_422
  0x0a5210a4, 0x28203bad, 0x18000121, 0x11163211,   // lt.ha.pt_433 so.sq.sw_643  en.ga.un_860 bs.hr.ro_653
  0x1a002722, 0x1e251c07, 0x182b2709, 0x1c271e07,   // gd.tl.un_870 id.eu.ms_432  gd.vi.ga_444 ms.gd.id_432
  0x52005304, 0x52556812, 0x644a115a, 0x2d000f11,   // ht.ha.un_320 ig.rw.ha_654  ro.yo.lg_553 lv.sk.un_630
  // [5fd0]
  0x11004a23, 0x1a255512, 0x686b280c, 0x1b1821ee,   // yo.ro.un_880 rw.eu.tl_654  sw.ceb.ig_543 jw.ga.tr_422
  0x6b1e1aa4, 0x282055a7, 0x1e1c1fee, 0x1e251ca4,   // tl.ms.ceb_433 rw.sq.sw_532  cy.id.ms_422 id.eu.ms_433
  0x0f091212, 0x201b1104, 0x1a00250d, 0x0f02270c,   // hu.pl.lv_654 ro.tr.sq_332  eu.tl.un_540 gd.da.lv_543
  0x1a3b4a14, 0x55111a09, 0x10132014, 0x03000e08,   // yo.so.tl_666 tl.ro.rw_444  sq.et.lt_666 is.nl.un_430
  // [5fe0]
  0x53003202, 0x17005302, 0x0d530aee, 0x53001e02,   // bs.ht.un_220 ht.sr.un_220  pt.ht.cs_422 ms.ht.un_220
  0x270618ac, 0x1e1c520e, 0x681a11a4, 0x230225ec,   // ga.de.gd_632 ha.id.ms_555  ro.tl.ig_433 eu.da.ca_644
  0x351a3f0c, 0x0e103f07, 0x10000c1a, 0x321752a4,   // af.tl.zu_543 af.lt.is_432  sv.lt.un_760 ha.sr.bs_433
  0x4a00180d, 0x2d022955, 0x1716550c, 0x6e0f1014,   // ga.yo.un_540 sl.da.sk_442  rw.hr.sr_543 lt.lv.hmn_666
  // [5ff0]
  0x271f4a60, 0x041a0fa4, 0x0f2510ad, 0x013f290c,   // yo.cy.gd_664 lv.tl.fi_433  lt.eu.lv_643 sl.af.en_543
  0x190b23ec, 0x6b0604a4, 0x29164a0c, 0x16231f08,   // ca.es.gl_644 fi.de.ceb_433  yo.hr.sl_543 cy.ca.hr_443
  0x1c351f04, 0x05321fee, 0x3b002721, 0x1f1b1213,   // cy.zu.id_332 cy.bs.fr_422  gd.so.un_860 hu.tr.cy_665
  0x3200530c, 0x270f04a6, 0x52350f08, 0x00000406,   // ht.bs.un_530 fi.lv.gd_521  lv.zu.ha_443 ru.un.un_400

  // [6000]
  0x2327040c, 0x112327a9, 0x681c6408, 0x23071fa4,   // fi.gd.ca_543 gd.ca.ro_544  lg.id.ig_443 cy.it.ca_433
  0x0600040e, 0x0c64080b, 0x0b0952ac, 0x070b2808,   // fi.de.un_550 no.lg.sv_542  ha.pl.es_632 sw.es.it_443
  0x0955520c, 0x21524aa9, 0x28523bad, 0x20002d12,   // ha.rw.pl_543 yo.ha.jw_544  so.ha.sw_643 sk.sq.un_640
  0x356b01ee, 0x0f311bec, 0x13113b11, 0x6b0a28a0,   // en.ceb.zu_422 tr.az.lv_644  so.ro.et_653 sw.pt.ceb_322
  // [6010]
  0x21681aad, 0x32162a14, 0x2d043fad, 0x193f0b11,   // tl.ig.jw_643 mt.hr.bs_666  af.fi.sk_643 es.af.gl_653
  0x182735ec, 0x21000a04, 0x556b2802, 0x07112112,   // zu.gd.ga_644 pt.jw.un_320  sw.ceb.rw_222 jw.ro.it_654
  0x1b0e520c, 0x021a5507, 0x21205512, 0x080c3faf,   // ha.is.tr_543 rw.tl.da_432  rw.sq.jw_654 af.sv.no_655
  0x53200908, 0x09113b0c, 0x05232aad, 0x093b1112,   // pl.sq.ht_443 so.ro.pl_543  mt.ca.fr_643 ro.so.pl_654
  // [6020]
  0x1b2a5212, 0x083f02a0, 0x1f060905, 0x1c0c1a0c,   // ha.mt.tr_654 da.af.no_322  pl.de.cy_333 tl.sv.id_543
  0x23530cee, 0x20000a2b, 0x0300681a, 0x1f2b07af,   // sv.ht.ca_422 pt.sq.un_980  ig.nl.un_760 it.vi.cy_655
  0x2d1310ee, 0x1f0135ad, 0x200835ad, 0x04002a04,   // lt.et.sk_422 zu.en.cy_643  zu.no.sq_643 mt.fi.un_320
  0x2d006808, 0x08023505, 0x1a526ba0, 0x2b005314,   // ig.sk.un_430 zu.da.no_333  ceb.ha.tl_322 ht.vi.un_660
  // [6030]
  0x041352a9, 0x1f6b2102, 0x190b1a14, 0x1c521ea0,   // ha.et.fi_544 jw.ceb.cy_222  tl.es.gl_666 ms.ha.id_322
  0x0a0905a0, 0x18001a07, 0x3f6e1312, 0x3b19070c,   // fr.pl.pt_322 tl.ga.un_420  et.hmn.af_654 it.gl.so_543
  0x35280755, 0x280306ec, 0x23001604, 0x19100b02,   // it.sw.zu_442 de.nl.sw_644  hr.ca.un_320 es.lt.gl_222
  0x1107270c, 0x031853a0, 0x645520a4, 0x120b0aa9,   // gd.it.ro_543 ht.ga.nl_322  sq.rw.lg_433 pt.es.hu_544
  // [6040]
  0x68092812, 0x112007ad, 0x53006e04, 0x3f6e0307,   // sw.pl.ig_654 it.sq.ro_643  hmn.ht.un_320 nl.hmn.af_432
  0x3b2907a7, 0x280705af, 0x276b07ee, 0x4a006e04,   // it.sl.so_532 fr.it.sw_655  it.ceb.gd_422 hmn.yo.un_320
  0x115568ec, 0x3f036e05, 0x3512030c, 0x684a25ec,   // ig.rw.ro_644 hmn.nl.af_333  nl.hu.zu_543 eu.yo.ig_644
  0x53684a08, 0x321721a9, 0x0a6b070c, 0x052707ad,   // yo.ig.ht_443 jw.sr.bs_544  it.ceb.pt_543 it.gd.fr_643
  // [6050]
  0x2a3b0712, 0x232511ee, 0x27060312, 0x0a07280c,   // it.so.mt_654 ro.eu.ca_422  nl.de.gd_654 sw.it.pt_543
  0x272806a9, 0x311b6b13, 0x4a0f68ad, 0x4a2568a9,   // de.sw.gd_544 ceb.tr.az_665  ig.lv.yo_643 ig.eu.yo_544
  0x644a5512, 0x20024a02, 0x17002d35, 0x68293f5a,   // rw.yo.lg_654 yo.da.sq_222  sk.sr.un_A90 af.sl.ig_553
  0x32163f14, 0x1c2764a4, 0x0a014aa0, 0x1c00170c,   // af.hr.bs_666 lg.gd.id_433  yo.en.pt_322 sr.id.un_530
  // [6060]
  0x080221a4, 0x2a000d08, 0x6e6b1fa0, 0x211b1caf,   // jw.da.no_433 cs.mt.un_430  cy.ceb.hmn_322 id.tr.jw_655
  0x21003504, 0x64132a07, 0x1e1c52a0, 0x043b1ea7,   // zu.jw.un_320 mt.et.lg_432  ha.id.ms_322 ms.so.fi_532
  0x19050ba0, 0x2a006421, 0x682a640c, 0x0f27100d,   // es.fr.gl_322 lg.mt.un_860  lg.mt.ig_543 lt.gd.lv_554
  0x061b31a0, 0x646b35ad, 0x0e002507, 0x1a52530c,   // az.tr.de_322 zu.ceb.lg_643  eu.is.un_420 ht.ha.tl_543
  // [6070]
  0x07310e04, 0x1120530c, 0x1f270f09, 0x060704a9,   // is.az.it_332 ht.sq.ro_543  lv.gd.cy_444 fi.it.de_544
  0x5355210c, 0x1c101ea9, 0x281f27a6, 0x64002a19,   // jw.rw.ht_543 ms.lt.id_544  gd.cy.sw_521 mt.lg.un_750
  0x072b110c, 0x040812a4, 0x030152a0, 0x21041a0c,   // ro.vi.it_543 hu.no.fi_433  ha.en.nl_322 tl.fi.jw_543
  0x2a005213, 0x27002823, 0x03683f0d, 0x1e6425a4,   // ha.mt.un_650 sw.gd.un_880  af.ig.nl_554 eu.lg.ms_433
  // [6080]
  0x0a120612, 0x3b001105, 0x64211aa9, 0x0d173bad,   // de.hu.pt_654 ro.so.un_330  tl.jw.lg_544 so.sr.cs_643
  0x2b0155a0, 0x102506a4, 0x2a643f04, 0x35041f0c,   // rw.en.vi_322 de.eu.lt_433  af.lg.mt_332 cy.fi.zu_543
  0x0e1809ec, 0x0e06130c, 0x68000608, 0x2d2917ee,   // pl.ga.is_644 et.de.is_543  de.ig.un_430 sr.sl.sk_422
  0x073164a7, 0x6b6806ec, 0x52190b13, 0x0b2753a0,   // lg.az.it_532 de.ig.ceb_644  es.gl.ha_665 ht.gd.es_322
  // [6090]
  0x0a002307, 0x2b53270c, 0x1f062bee, 0x25002321,   // ca.pt.un_420 gd.ht.vi_543  vi.de.cy_422 ca.eu.un_860
  0x21521aec, 0x06531f11, 0x0c530604, 0x23552aa0,   // tl.ha.jw_644 cy.ht.de_653  de.ht.sv_332 mt.rw.ca_322
  0x11130605, 0x4a1a11a9, 0x08002d08, 0x122855ee,   // de.et.ro_333 ro.tl.yo_544  sk.no.un_430 rw.sw.hu_422
  0x0a001134, 0x20291711, 0x1b0768a9, 0x19001f02,   // ro.pt.un_A80 sr.sl.sq_653  ig.it.tr_544 cy.gl.un_220
  // [60a0]
  0x0d1016a4, 0x130c0614, 0x3f00291a, 0x020553af,   // hr.lt.cs_433 de.sv.et_666  sl.af.un_760 ht.fr.da_655
  0x6b010713, 0x29130460, 0x1c1e2104, 0x25000302,   // it.en.ceb_665 fi.et.sl_664  jw.ms.id_332 nl.eu.un_220
  0x1e2d0d14, 0x1e101c04, 0x213b5512, 0x27001105,   // cs.sk.ms_666 id.lt.ms_332  rw.so.jw_654 ro.gd.un_330
  0x0c0229ad, 0x55132a0c, 0x205528ec, 0x071035a4,   // sl.da.sv_643 mt.et.rw_543  sw.rw.sq_644 zu.lt.it_433
  // [60b0]
  0x063f3508, 0x0f006423, 0x100f1a12, 0x683f06ad,   // zu.af.de_443 lg.lv.un_880  tl.lv.lt_654 de.af.ig_643
  0x216b28ad, 0x2735110c, 0x4a0f52a4, 0x133b6b14,   // sw.ceb.jw_643 ro.zu.gd_543  ha.lv.yo_433 ceb.so.et_666
  0x080253ee, 0x2000211b, 0x64683ba7, 0x354a530c,   // ht.da.no_422 jw.sq.un_770  so.ig.lg_532 ht.yo.zu_543
  0x27100f09, 0x19050ba7, 0x68003505, 0x055331ec,   // lv.lt.gd_444 es.fr.gl_532  zu.ig.un_330 az.ht.fr_644
  // [60c0]
  0x0f1320a9, 0x10006b0d, 0x292d3f05, 0x01002905,   // sq.et.lv_544 ceb.lt.un_540  af.sk.sl_333 sl.en.un_330
  0x352820af, 0x28003b18, 0x010910a0, 0x0b3507a4,   // sq.sw.zu_655 so.sw.un_740  lt.pl.en_322 it.zu.es_433
  0x32191704, 0x3b281308, 0x643b13a0, 0x01002b07,   // sr.gl.bs_332 et.sw.so_443  et.so.lg_322 vi.en.un_420
  0x53003f09, 0x3b281f02, 0x08120cee, 0x23001f12,   // af.ht.un_440 cy.sw.so_222  sv.hu.no_422 cy.ca.un_640
  // [60d0]
  0x12042a12, 0x680112a0, 0x6b2052a9, 0x23001235,   // mt.fi.hu_654 hu.en.ig_322  ha.sq.ceb_544 hu.ca.un_A90
  0x283b1fee, 0x0c081905, 0x644a0911, 0x20006822,   // cy.so.sw_422 gl.no.sv_333  pl.yo.lg_653 ig.sq.un_870
  0x53163fa9, 0x6b005523, 0x52136860, 0x3f68640c,   // af.hr.ht_544 rw.ceb.un_880  ig.et.ha_664 lg.ig.af_543
  0x3f2a2512, 0x25180aaf, 0x0201080c, 0x320f20a4,   // eu.mt.af_654 pt.ga.eu_655  no.en.da_543 sq.lv.bs_433
  // [60e0]
  0x3b2820ad, 0x202b08ee, 0x64521fa9, 0x1b001220,   // sq.sw.so_643 no.vi.sq_422  cy.ha.lg_544 hu.tr.un_850
  0x1e551ca9, 0x642810a4, 0x06350ea0, 0x3f035509,   // id.rw.ms_544 lt.sw.lg_433  is.zu.de_322 rw.nl.af_444
  0x21131e07, 0x21103507, 0x28002120, 0x283b55ee,   // ms.et.jw_432 zu.lt.jw_432  jw.sw.un_850 rw.so.sw_422
  0x230308a4, 0x64013f0c, 0x2a1955ee, 0x214a1ca4,   // no.nl.ca_433 af.en.lg_543  rw.gl.mt_422 id.yo.jw_433
  // [60f0]
  0x6b080213, 0x1121520c, 0x353255a4, 0x0a080405,   // da.no.ceb_665 ha.jw.ro_543  rw.bs.zu_433 ru.uk.mk_333
  0x3b002805, 0x2d520d08, 0x3b536b08, 0x1c0e4aac,   // sw.so.un_330 cs.ha.sk_443  ceb.ht.so_443 yo.is.id_632
  0x28000707, 0x0f001e07, 0x3f2864ac, 0x291310af,   // it.sw.un_420 ms.lv.un_420  lg.sw.af_632 lt.et.sl_655
  0x1e1c6414, 0x19230a11, 0x64041eee, 0x050806ee,   // lg.id.ms_666 pt.ca.gl_653  ms.fi.lg_422 de.no.fr_422
  // [6100]
  0x0b18020c, 0x4a0453a0, 0x530504a4, 0x284a5208,   // da.ga.es_543 ht.fi.yo_322  fi.fr.ht_433 ha.yo.sw_443
  0x3f3b02a0, 0x060308a4, 0x052d27a0, 0x32162911,   // da.so.af_322 no.nl.de_433  gd.sk.fr_322 sl.hr.bs_653
  0x0f100713, 0x5305640c, 0x0a1205af, 0x04056407,   // it.lt.lv_665 lg.fr.ht_543  fr.hu.pt_655 lg.fr.fi_432
  0x070255af, 0x1b1304ec, 0x1809050c, 0x316b1ca0,   // rw.da.it_655 fi.et.tr_644  fr.pl.ga_543 id.ceb.az_322
  // [6110]
  0x08021caf, 0x23011e0c, 0x072823a4, 0x132a0ca9,   // id.da.no_655 ms.en.ca_543  ca.sw.it_433 sv.mt.et_544
  0x010c0404, 0x5300230e, 0x3b0b0411, 0x0b0a235a,   // fi.sv.en_332 ca.ht.un_550  fi.es.so_653 ca.pt.es_553
  0x01050407, 0x551b640c, 0x0f0e13af, 0x0d271860,   // fi.fr.en_432 lg.tr.rw_543  et.is.lv_655 ga.gd.cs_664
  0x0d122d0d, 0x3b3f1313, 0x12254a13, 0x3b005213,   // sk.hu.cs_554 et.af.so_665  yo.eu.hu_665 ha.so.un_650
  // [6120]
  0x29165207, 0x27092513, 0x292d2008, 0x282a68ad,   // ha.hr.sl_432 eu.pl.gd_665  sq.sk.sl_443 ig.mt.sw_643
  0x0b1923a6, 0x27643b13, 0x531e4aa4, 0x521b2308,   // ca.gl.es_521 so.lg.gd_665  yo.ms.ht_433 ca.tr.ha_443
  0x080e180c, 0x231827a9, 0x3f2a0605, 0x11000e21,   // ga.is.no_543 gd.ga.ca_544  de.mt.af_333 is.ro.un_860
  0x2a040f0c, 0x29110da7, 0x035325ee, 0x4a250655,   // lv.fi.mt_543 cs.ro.sl_532  eu.ht.nl_422 de.eu.yo_442
  // [6130]
  0x21251c12, 0x125225a9, 0x18000919, 0x1a1c52af,   // id.eu.jw_654 eu.ha.hu_544  pl.ga.un_750 ha.id.tl_655
  0x190b25ee, 0x6b002504, 0x521a1e11, 0x1f0618a4,   // eu.es.gl_422 eu.ceb.un_320  ms.tl.ha_653 ga.de.cy_433
  0x6b351a12, 0x3b06270e, 0x291f06af, 0x13002817,   // tl.zu.ceb_654 gd.de.so_555  de.cy.sl_655 sw.et.un_730
  0x231f6ea9, 0x52682504, 0x080e6b5a, 0x521b25ec,   // hmn.cy.ca_544 eu.ig.ha_332  ceb.is.no_553 eu.tr.ha_644
  // [6140]
  0x130452a0, 0x0452070c, 0x21073fad, 0x10251213,   // ha.fi.et_322 it.ha.fi_543  af.it.jw_643 hu.eu.lt_665
  0x09002a02, 0x0c1e2305, 0x0f2d04a4, 0x0f6b1a0d,   // mt.pl.un_220 ca.ms.sv_333  fi.sk.lv_433 tl.ceb.lv_554
  0x0b0a1b09, 0x16000c04, 0x3b2a5208, 0x052a5202,   // tr.pt.es_444 sv.hr.un_320  ha.mt.so_443 ha.mt.fr_222
  0x640428af, 0x0700050e, 0x160710ee, 0x1009680e,   // sw.fi.lg_655 fr.it.un_550  lt.it.hr_422 ig.pl.lt_555
  // [6150]
  0x17291607, 0x271825ad, 0x25001f2b, 0x282120ec,   // hr.sl.sr_432 eu.ga.gd_643  cy.eu.un_980 sq.jw.sw_644
  0x68042107, 0x351e5209, 0x642510a7, 0x08130405,   // jw.fi.ig_432 ha.ms.zu_444  lt.eu.lg_532 fi.et.no_333
  0x32111e0b, 0x4a001018, 0x110725af, 0x0b350507,   // ms.ro.bs_542 lt.yo.un_740  eu.it.ro_655 fr.zu.es_432
  0x07081213, 0x68122114, 0x102718ec, 0x231f0a02,   // hu.no.it_665 jw.hu.ig_666  ga.gd.lt_644 pt.cy.ca_222
  // [6160]
  0x0a072da9, 0x1a6b2d0c, 0x2d1925a4, 0x643b07ad,   // sk.it.pt_544 sk.ceb.tl_543  eu.gl.sk_433 it.so.lg_643
  0x31001007, 0x02001705, 0x1a04680c, 0x23160a07,   // lt.az.un_420 sr.da.un_330  ig.fi.tl_543 pt.hr.ca_432
  0x0a003114, 0x11006b02, 0x2d2928a7, 0x1e000505,   // az.pt.un_660 ceb.ro.un_220  sw.sl.sk_532 fr.ms.un_330
  0x23071fa0, 0x120421a0, 0x081025a0, 0x041328ee,   // cy.it.ca_322 jw.fi.hu_322  eu.lt.no_322 sw.et.fi_422
  // [6170]
  0x0a111712, 0x10271f12, 0x10000b19, 0x23281909,   // sr.ro.mk_654 cy.gd.lt_654  es.lt.un_750 gl.sw.ca_444
  0x01003b02, 0x643b6804, 0x11002d0d, 0x1a001902,   // so.en.un_220 ig.so.lg_332  sk.ro.un_540 gl.tl.un_220
  0x0e23080c, 0x1a00020c, 0x281b1c0c, 0x522835a4,   // no.ca.is_543 da.tl.un_530  id.tr.sw_543 zu.sw.ha_433
  0x556e2804, 0x10000e13, 0x2a521bad, 0x19041309,   // sw.hmn.rw_332 is.lt.un_650  tr.ha.mt_643 et.fi.gl_444
  // [6180]
  0x16283508, 0x23181ea0, 0x55281f0c, 0x07000b02,   // zu.sw.hr_443 ms.ga.ca_322  cy.sw.rw_543 es.it.un_220
  0x2b004a0c, 0x21001f22, 0x202821ad, 0x21001b1a,   // yo.vi.un_530 cy.jw.un_870  jw.sw.sq_643 tr.jw.un_760
  0x2800091a, 0x3f032012, 0x211c2008, 0x0e551e0c,   // pl.sw.un_760 sq.nl.af_654  sq.id.jw_443 ms.rw.is_543
  0x0f3f0ca9, 0x020f0807, 0x101721a7, 0x08050f07,   // sv.af.lv_544 no.lv.da_432  jw.sr.lt_532 lv.fr.no_432
  // [6190]
  0x291a21a4, 0x2d0220ec, 0x040e28af, 0x0c003f0e,   // jw.tl.sl_433 sq.da.sk_644  sw.is.fi_655 af.sv.un_550
  0x16321712, 0x02002304, 0x35001b12, 0x35002a1a,   // sr.bs.hr_654 ca.da.un_320  tr.zu.un_640 mt.zu.un_760
  0x010603ee, 0x18055502, 0x1b2023a6, 0x1c051e07,   // nl.de.en_422 rw.fr.ga_222  ca.sq.tr_521 ms.fr.id_432
  0x0a050fa7, 0x011b13ee, 0x3f27130c, 0x04100e08,   // lv.fr.pt_532 et.tr.en_422  et.gd.af_543 is.lt.fi_443
  // [61a0]
  0x1300102c, 0x64201109, 0x35551b07, 0x01072005,   // lt.et.un_990 ro.sq.lg_444  tr.rw.zu_432 sq.it.en_333
  0x18273bec, 0x2300270b, 0x21121ea9, 0x01002119,   // so.gd.ga_644 gd.ca.un_520  ms.hu.jw_544 jw.en.un_750
  0x28042107, 0x2d006b04, 0x200513ee, 0x17290d05,   // jw.fi.sw_432 ceb.sk.un_320  et.fr.sq_422 cs.sl.sr_333
  0x1c2a070c, 0x12020812, 0x1e211baf, 0x082d250c,   // it.mt.id_543 no.da.hu_654  tr.jw.ms_655 eu.sk.no_543
  // [61b0]
  0x6b002522, 0x03001a08, 0x6b080eaf, 0x21001602,   // eu.ceb.un_870 tl.nl.un_430  is.no.ceb_655 hr.jw.un_220
  0x321729a9, 0x6b4a1a07, 0x536b05ee, 0x2d0d17a4,   // sl.sr.bs_544 tl.yo.ceb_432  fr.ceb.ht_422 sr.cs.sk_433
  0x11202508, 0x35131ea0, 0x13356808, 0x4a3f3b08,   // eu.sq.ro_443 ms.et.zu_322  ig.zu.et_443 so.af.yo_443
  0x27112304, 0x272d2a07, 0x09003520, 0x25092aee,   // ca.ro.gd_332 mt.sk.gd_432  zu.pl.un_850 mt.pl.eu_422
  // [61c0]
  0x6e185212, 0x12003b0d, 0x3f4a13a4, 0x07280b13,   // ha.ga.hmn_654 so.hu.un_540  et.yo.af_433 es.sw.it_665
  0x25211fa4, 0x122b3b0d, 0x6b6817a6, 0x062d0f07,   // cy.jw.eu_433 so.vi.hu_554  sr.ig.ceb_521 lv.sk.de_432
  0x0768280c, 0x2d0d0ca4, 0x106825ad, 0x281c010b,   // sw.ig.it_543 sv.cs.sk_433  eu.ig.lt_643 en.id.sw_542
  0x0b251a08, 0x0700210c, 0x01271112, 0x27191812,   // tl.eu.es_443 jw.it.un_530  ro.gd.en_654 ga.gl.gd_654
  // [61d0]
  0x1c6b0cad, 0x2d5511ad, 0x68016b0d, 0x1a00520d,   // sv.ceb.id_643 ro.rw.sk_643  ceb.en.ig_554 ha.tl.un_540
  0x3b681b0c, 0x3b1a28a9, 0x5300230c, 0x320216a4,   // tr.ig.so_543 sw.tl.so_544  ca.ht.un_530 hr.da.bs_433
  0x3b1a5209, 0x180b2708, 0x17211c0e, 0x21281c08,   // ha.tl.so_444 gd.es.ga_443  id.jw.sr_555 id.sw.jw_443
  0x121b55a4, 0x01000614, 0x1b3168af, 0x05551104,   // rw.tr.hu_433 de.en.un_660  ig.az.tr_655 ro.rw.fr_332
  // [61e0]
  0x1a52310c, 0x04641309, 0x1e1f1ca4, 0x0c6b2aec,   // az.ha.tl_543 et.lg.fi_444  id.cy.ms_433 mt.ceb.sv_644
  0x0a2119ad, 0x04134a13, 0x08212a0c, 0x3f3b2504,   // gl.jw.pt_643 yo.et.fi_665  mt.jw.no_543 eu.so.af_332
  0x640e5508, 0x1b681a0c, 0x2d0d4aa0, 0x0e002a33,   // rw.is.lg_443 tl.ig.tr_543  yo.cs.sk_322 mt.is.un_A70
  0x2d0d08a4, 0x13271860, 0x231729ec, 0x03233fa0,   // no.cs.sk_433 ga.gd.et_664  sl.sr.ca_644 af.ca.nl_322
  // [61f0]
  0x21641705, 0x0f2301a9, 0x180f01ad, 0x126403a9,   // sr.lg.jw_333 en.ca.lv_544  en.lv.ga_643 nl.lg.hu_544
  0x19014aa0, 0x29071f0d, 0x080f2908, 0x0e00272a,   // yo.en.gl_322 cy.it.sl_554  sl.lv.no_443 gd.is.un_970
  0x0818270d, 0x3b001007, 0x0b2d1904, 0x551b35ee,   // gd.ga.no_554 lt.so.un_420  gl.sk.es_332 zu.tr.rw_422
  0x0a073b05, 0x53130eee, 0x00001203, 0x09001f02,   // so.it.pt_333 is.et.ht_422  ur.un.un_300 cy.pl.un_220
  // [6200]
  0x04281b55, 0x211304ec, 0x1b1110a4, 0x25130460,   // tr.sw.fi_442 fi.et.jw_644  lt.ro.tr_433 fi.et.eu_664
  0x113104ee, 0x08006b20, 0x2d120dad, 0x0f000720,   // fi.az.ro_422 ceb.no.un_850  cs.hu.sk_643 it.lv.un_850
  0x5200250b, 0x07001a1a, 0x0a1219a9, 0x64005308,   // eu.ha.un_520 tl.it.un_760  gl.hu.pt_544 ht.lg.un_430
  0x0b001708, 0x08090304, 0x3f2103ac, 0x1b1011af,   // sr.es.un_430 nl.pl.no_332  nl.jw.af_632 ro.lt.tr_655
  // [6210]
  0x1a6b2814, 0x23053ba0, 0x06180812, 0x216e0e04,   // sw.ceb.tl_666 so.fr.ca_322  no.ga.de_654 is.hmn.jw_332
  0x234a1812, 0x0e0b1a08, 0x0f200907, 0x076b11a0,   // ga.yo.ca_654 tl.es.is_443  pl.sq.lv_432 ro.ceb.it_322
  0x29001222, 0x3b1f6e0d, 0x2a072513, 0x23180d0c,   // hu.sl.un_870 hmn.cy.so_554  eu.it.mt_665 cs.ga.ca_543
  0x27010cee, 0x12005302, 0x5200210c, 0x280f2504,   // sv.en.gd_422 ht.hu.un_220  jw.ha.un_530 eu.lv.sw_332
  // [6220]
  0x0a251ca7, 0x1e3b3508, 0x104a0f11, 0x08023f02,   // id.eu.pt_532 zu.so.ms_443  lv.yo.lt_653 af.da.no_222
  0x123104af, 0x1e531c04, 0x536b4a04, 0x3b352a12,   // fi.az.hu_655 id.ht.ms_332  yo.ceb.ht_332 mt.zu.so_654
  0x1e0d3155, 0x07190a14, 0x280f0d04, 0x16003f12,   // az.cs.ms_442 pt.gl.it_666  cs.lv.sw_332 af.hr.un_640
  0x12520407, 0x55000513, 0x2a000618, 0x1f195214,   // fi.ha.hu_432 fr.rw.un_650  de.mt.un_740 ha.gl.cy_666
  // [6230]
  0x64001209, 0x16131e08, 0x0b1720ee, 0x0c271809,   // hu.lg.un_440 ms.et.hr_443  sq.sr.es_422 ga.gd.sv_444
  0x12101f09, 0x13050455, 0x535228a9, 0x2b006808,   // cy.lt.hu_444 fi.fr.et_442  sw.ha.ht_544 ig.vi.un_430
  0x552811af, 0x0a1229ee, 0x02001012, 0x1e1c1bac,   // ro.sw.rw_655 sl.hu.pt_422  lt.da.un_640 tr.id.ms_632
  0x31000904, 0x12000702, 0x1200680c, 0x0a000d08,   // pl.az.un_320 it.hu.un_220  ig.hu.un_530 cs.pt.un_430
  // [6240]
  0x100f090c, 0x21124aee, 0x071117ad, 0x042852ad,   // pl.lv.lt_543 yo.hu.jw_422  sr.ro.bg_643 ha.sw.fi_643
  0x190a25ec, 0x3f061ea4, 0x0a000707, 0x211c35a0,   // eu.pt.gl_644 ms.de.af_433  it.pt.un_420 zu.id.jw_322
  0x05001912, 0x10131ea4, 0x03120660, 0x043525ad,   // gl.fr.un_640 ms.et.lt_433  de.hu.nl_664 eu.zu.fi_643
  0x535229af, 0x0f11130d, 0x21273fa0, 0x01005505,   // sl.ha.ht_655 et.ro.lv_554  af.gd.jw_322 rw.en.un_330
  // [6250]
  0x2a003f0d, 0x081b02ad, 0x3f13060c, 0x081b1305,   // af.mt.un_540 da.tr.no_643  de.et.af_543 et.tr.no_333
  0x3b2d35a9, 0x321709a4, 0x1e1c18a4, 0x271f18ad,   // zu.sk.so_544 pl.sr.bs_433  ga.id.ms_433 ga.cy.gd_643
  0x3f3552a0, 0x21523fad, 0x211f3507, 0x2d0a23af,   // ha.zu.af_322 af.ha.jw_643  zu.cy.jw_432 ca.pt.sk_655
  0x210f1c0c, 0x1a001008, 0x52004a02, 0x1c031eee,   // id.lv.jw_543 lt.tl.un_430  yo.ha.un_220 ms.nl.id_422
  // [6260]
  0x03131ba7, 0x1f122b07, 0x021008a0, 0x020e0812,   // tr.et.nl_532 vi.hu.cy_432  no.lt.da_322 no.is.da_654
  0x08020314, 0x6b55045a, 0x2035530c, 0x35201708,   // nl.da.no_666 fi.rw.ceb_553  ht.zu.sq_543 sr.sq.zu_443
  0x04311b08, 0x642804ee, 0x06311b08, 0x09071813,   // tr.az.fi_443 fi.sw.lg_422  tr.az.de_443 ga.it.pl_665
  0x2b002a02, 0x3f000f13, 0x23534a08, 0x190b1114,   // mt.vi.un_220 lv.af.un_650  yo.ht.ca_443 ro.es.gl_666
  // [6270]
  0x181013a4, 0x09172dee, 0x2400010c, 0x4a1e550c,   // et.lt.ga_433 sk.sr.pl_422  iw.yi.un_530 rw.ms.yo_543
  0x190b0da4, 0x0a2d23ec, 0x311b09a7, 0x19050a0b,   // cs.es.gl_433 ca.sk.pt_644  pl.tr.az_532 pt.fr.gl_542
  0x520e0412, 0x170e16a4, 0x181123a4, 0x080c02a0,   // fi.is.ha_654 hr.is.sr_433  ca.ro.ga_433 da.sv.no_322
  0x0d00160c, 0x01000205, 0x190a55af, 0x060c0fee,   // hr.cs.un_530 da.en.un_330  rw.pt.gl_655 lv.sv.de_422
  // [6280]
  0x0b2312ec, 0x1f0e5355, 0x6e005522, 0x1e00030d,   // hu.ca.es_644 ht.is.cy_442  rw.hmn.un_870 nl.ms.un_540
  0x190a3205, 0x190b2312, 0x0f32250d, 0x0b005207,   // bs.pt.gl_333 ca.es.gl_654  eu.bs.lv_554 ha.es.un_420
  0x230a0bec, 0x52002d0d, 0x100c0ea9, 0x03054a02,   // es.pt.ca_644 sk.ha.un_540  is.sv.lt_544 yo.fr.nl_222
  0x05520655, 0x19120a0d, 0x0d102d12, 0x2d0d23a4,   // de.ha.fr_442 pt.hu.gl_554  sk.lt.cs_654 ca.cs.sk_433
  // [6290]
  0x01251fa0, 0x230a19a9, 0x12003202, 0x1e043b12,   // cy.eu.en_322 gl.pt.ca_544  bs.hu.un_220 so.fi.ms_654
  0x29126ea4, 0x2d0d1fec, 0x06030fad, 0x524a10ad,   // hmn.hu.sl_433 cy.cs.sk_644  lv.nl.de_643 lt.yo.ha_643
  0x130f08a4, 0x3b006e02, 0x04002308, 0x23000e19,   // no.lv.et_433 hmn.so.un_220  ca.fi.un_430 is.ca.un_750
  0x09100faf, 0x310264ec, 0x6b000307, 0x04283b09,   // lv.lt.pl_655 lg.da.az_644  nl.ceb.un_420 so.sw.fi_444
  // [62a0]
  0x21001210, 0x092a0f13, 0x06006804, 0x0900020e,   // hu.jw.un_620 lv.mt.pl_665  ig.de.un_320 da.pl.un_550
  0x1b316b0c, 0x05093f08, 0x0d062da9, 0x07002b07,   // ceb.az.tr_543 af.pl.fr_443  sk.de.cs_544 vi.it.un_420
  0x10006405, 0x090f05a9, 0x07000e07, 0x04001702,   // lg.lt.un_330 fr.lv.pl_544  is.it.un_420 sr.ru.un_220
  0x291c0e04, 0x645505a0, 0x082d0d13, 0x1c001f12,   // is.id.sl_332 fr.rw.lg_322  cs.sk.no_665 cy.id.un_640
  // [62b0]
  0x1300100c, 0x3b290eee, 0x3f270c07, 0x286b550c,   // lt.et.un_530 is.sl.so_422  sv.gd.af_432 rw.ceb.sw_543
  0x1b1304a4, 0x042031ad, 0x35135508, 0x1b313505,   // fi.et.tr_433 az.sq.fi_643  rw.et.zu_443 zu.az.tr_333
  0x1a553508, 0x13001702, 0x03130407, 0x312d1b07,   // zu.rw.tl_443 sr.et.un_220  fi.et.nl_432 tr.sk.az_432
  0x3f1210af, 0x033f0404, 0x4a002b19, 0x1819110c,   // lt.hu.af_655 fi.af.nl_332  vi.yo.un_750 ro.gl.ga_543
  // [62c0]
  0x250120a4, 0x00002837, 0x2d0d11af, 0x03006e04,   // sq.en.eu_433 sw.un.un_B00  ro.cs.sk_655 hmn.nl.un_320
  0x68001f1a, 0x0a552008, 0x1f5564af, 0x23112004,   // cy.ig.un_760 sq.rw.pt_443  lg.rw.cy_655 sq.ro.ca_332
  0x0a000e02, 0x190a4a09, 0x556852af, 0x200102a0,   // is.pt.un_220 yo.pt.gl_444  ha.ig.rw_655 da.en.sq_322
  0x3f6b1a0e, 0x356e2b05, 0x3f001805, 0x1000230d,   // tl.ceb.af_555 vi.hmn.zu_333  ga.af.un_330 ca.lt.un_540
  // [62d0]
  0x01050808, 0x556b1ca0, 0x0e6b1305, 0x6b001e22,   // no.fr.en_443 id.ceb.rw_322  et.ceb.is_333 ms.ceb.un_870
  0x286852a7, 0x0b0764a4, 0x2a1f25af, 0x1e104aee,   // ha.ig.sw_532 lg.it.es_433  eu.cy.mt_655 yo.lt.ms_422
  0x2b005202, 0x31281ca4, 0x3f0a1804, 0x050753ec,   // ha.vi.un_220 id.sw.az_433  ga.pt.af_332 ht.it.fr_644
  0x1a5325a4, 0x521c6808, 0x2b530f05, 0x55001319,   // eu.ht.tl_433 ig.id.ha_443  lv.ht.vi_333 et.rw.un_750
  // [62e0]
  0x64006b05, 0x350e0c0e, 0x3f00520c, 0x530f1305,   // ceb.lg.un_330 sv.is.zu_555  ha.af.un_530 et.lv.ht_333
  0x11002102, 0x072053a7, 0x1964550c, 0x070e53ad,   // jw.ro.un_220 ht.sq.it_532  rw.lg.gl_543 ht.is.it_643
  0x042a10ec, 0x355364ec, 0x09102d12, 0x091f6809,   // lt.mt.fi_644 lg.ht.zu_644  sk.lt.pl_654 ig.cy.pl_444
  0x6855110c, 0x2564230b, 0x3f4a6808, 0x18684a04,   // ro.rw.ig_543 ca.lg.eu_542  ig.yo.af_443 yo.ig.ga_332
  // [62f0]
  0x55004a34, 0x13000f1a, 0x1b4a2808, 0x010628ee,   // yo.rw.un_A80 lv.et.un_760  sw.yo.tr_443 sw.de.en_422
  0x09525512, 0x042513ad, 0x1028160c, 0x0e02200c,   // rw.ha.pl_654 et.eu.fi_643  hr.sw.lt_543 sq.da.is_543
  0x6e25130d, 0x281b35ee, 0x32101707, 0x2a0f10af,   // et.eu.hmn_554 zu.tr.sw_422  sr.lt.bs_432 lt.lv.mt_655
  0x1f066809, 0x1e1c04af, 0x04002511, 0x12001a23,   // ig.de.cy_444 fi.id.ms_655  eu.fi.un_630 tl.hu.un_880
  // [6300]
  0x354a53ec, 0x19030ba4, 0x31002702, 0x681f06af,   // ht.yo.zu_644 es.nl.gl_433  gd.az.un_220 de.cy.ig_655
  0x030b060e, 0x4a2125a7, 0x130c25a9, 0x19350b07,   // de.es.nl_555 eu.jw.yo_532  eu.sv.et_544 es.zu.gl_432
  0x28124aec, 0x03042802, 0x03353fa4, 0x110405af,   // yo.hu.sw_644 sw.fi.nl_222  af.zu.nl_433 fr.fi.ro_655
  0x1b0a25ac, 0x3b2a19ec, 0x06032a0c, 0x032012ec,   // eu.pt.tr_632 gl.mt.so_644  mt.nl.de_543 hu.sq.nl_644
  // [6310]
  0x52201ba7, 0x3f1303a9, 0x09000305, 0x1b533104,   // tr.sq.ha_532 nl.et.af_544  nl.pl.un_330 az.ht.tr_332
  0x352d0ca4, 0x1e1c0b05, 0x0a230ea4, 0x321b0e13,   // sv.sk.zu_433 es.id.ms_333  is.ca.pt_433 is.tr.bs_665
  0x28126eee, 0x11550e07, 0x121023a0, 0x05002513,   // hmn.hu.sw_422 is.rw.ro_432  ca.lt.hu_322 eu.fr.un_650
  0x2d0d2108, 0x55000908, 0x05235309, 0x53050aa7,   // jw.cs.sk_443 pl.rw.un_430  ht.ca.fr_444 pt.fr.ht_532
  // [6320]
  0x21000704, 0x31283b02, 0x0213080c, 0x644a0411,   // it.jw.un_320 so.sw.az_222  no.et.da_543 fi.yo.lg_653
  0x6e6855ad, 0x6819200d, 0x25286bee, 0x00002537,   // rw.ig.hmn_643 sq.gl.ig_554  ceb.sw.eu_422 eu.un.un_B00
  0x6b2a5507, 0x0455250c, 0x13520455, 0x20045502,   // rw.mt.ceb_432 eu.rw.fi_543  fi.ha.et_442 rw.fi.sq_222
  0x201a5207, 0x200429ee, 0x0621010c, 0x2d290d0d,   // ha.tl.sq_432 sl.fi.sq_422  en.jw.de_543 cs.sl.sk_554
  // [6330]
  0x28116802, 0x53003b12, 0x29210aee, 0x52002913,   // ig.ro.sw_222 so.ht.un_640  pt.jw.sl_422 sl.ha.un_650
  0x3b1a2aa0, 0x0f1810a9, 0x2a1e1c09, 0x0e2909ac,   // mt.tl.so_322 lt.ga.lv_544  id.ms.mt_444 pl.sl.is_632
  0x033f290c, 0x04103b11, 0x28685208, 0x13006804,   // sl.af.nl_543 so.lt.fi_653  ha.ig.sw_443 ig.et.un_320
  0x02536804, 0x0e003f05, 0x0d090f14, 0x0d2d0208,   // ig.ht.da_332 af.is.un_330  lv.pl.cs_666 da.sk.cs_443
  // [6340]
  0x52553509, 0x681c1eac, 0x6455680d, 0x2d0d2355,   // zu.rw.ha_444 ms.id.ig_632  ig.rw.lg_554 ca.cs.sk_442
  0x0c205260, 0x64355508, 0x043b0912, 0x0500250b,   // ha.sq.sv_664 rw.zu.lg_443  pl.so.fi_654 eu.fr.un_520
  0x35002114, 0x0c1808ac, 0x2d002512, 0x1300101b,   // jw.zu.un_660 no.ga.sv_632  eu.sk.un_640 lt.et.un_770
  0x552120a4, 0x25000f08, 0x235205ad, 0x1e28520c,   // sq.jw.rw_433 lv.eu.un_430  fr.ha.ca_643 ha.sw.ms_543
  // [6350]
  0x35005305, 0x0c002302, 0x060105a0, 0x0f033f13,   // ht.zu.un_330 ca.sv.un_220  fr.en.de_322 af.nl.lv_665
  0x6b681c05, 0x291e060c, 0x1e1c2aa4, 0x68642008,   // id.ig.ceb_333 de.ms.sl_543  mt.id.ms_433 sq.lg.ig_443
  0x0b100a13, 0x641b3109, 0x0b000804, 0x080e100d,   // pt.lt.es_665 az.tr.lg_444  no.es.un_320 lt.is.no_554
  0x0c0a550c, 0x2321200c, 0x2b001905, 0x230705ec,   // rw.pt.sv_543 sq.jw.ca_543  gl.vi.un_330 fr.it.ca_644
  // [6360]
  0x101325ad, 0x19002b19, 0x07683ba7, 0x311b3bec,   // eu.et.lt_643 vi.gl.un_750  so.ig.it_532 so.tr.az_644
  0x1c091ea4, 0x2b002013, 0x55203513, 0x28203512,   // ms.pl.id_433 sq.vi.un_650  zu.sq.rw_665 zu.sq.sw_654
  0x1a103108, 0x121e3513, 0x20111bad, 0x3b1b1ea7,   // az.lt.tl_443 zu.ms.hu_665  tr.ro.sq_643 ms.tr.so_532
  0x060c08a9, 0x1e1c2aee, 0x553b1b09, 0x0508060c,   // no.sv.de_544 mt.id.ms_422  tr.so.rw_444 de.no.fr_543
  // [6370]
  0x3b1b5507, 0x0b1221ee, 0x08021ca4, 0x20282907,   // rw.tr.so_432 jw.hu.es_422  id.da.no_433 sl.sw.sq_432
  0x0a006e1b, 0x321710ec, 0x64000708, 0x06010cee,   // hmn.pt.un_770 lt.sr.bs_644  it.lg.un_430 sv.en.de_422
  0x352520ad, 0x31082702, 0x2b316e07, 0x11000a2a,   // sq.eu.zu_643 gd.no.az_222  hmn.az.vi_432 mk.ro.un_970
  0x12050a0e, 0x2900350c, 0x190b0dec, 0x3b3f1305,   // pt.fr.hu_555 zu.sl.un_530  cs.es.gl_644 et.af.so_333
  // [6380]
  0x1335530c, 0x554a35a0, 0x13041608, 0x1f040ea4,   // ht.zu.et_543 zu.yo.rw_322  hr.fi.et_443 is.fi.cy_433
  0x312913ad, 0x020a07a0, 0x2d212b12, 0x1a002912,   // et.sl.az_643 it.pt.da_322  vi.jw.sk_654 sl.tl.un_640
  0x08003b12, 0x3f2821ad, 0x322925ad, 0x0e001a12,   // so.no.un_640 jw.sw.af_643  eu.sl.bs_643 tl.is.un_640
  0x64251a0c, 0x21003b18, 0x352521ad, 0x2128080d,   // tl.eu.lg_543 so.jw.un_740  jw.eu.zu_643 no.sw.jw_554
  // [6390]
  0x0e080b04, 0x04001b13, 0x284a10a6, 0x55273bec,   // es.no.is_332 tr.fi.un_650  lt.yo.sw_521 so.gd.rw_644
  0x216435a9, 0x32002507, 0x1c2a28ad, 0x211e2807,   // zu.lg.jw_544 eu.bs.un_420  sw.mt.id_643 sw.ms.jw_432
  0x01280802, 0x64255508, 0x2d0d17ee, 0x0e0806a7,   // no.sw.en_222 rw.eu.lg_443  sr.cs.sk_422 de.no.is_532
  0x20643512, 0x1b0903ec, 0x1a526412, 0x1c071e0c,   // zu.lg.sq_654 nl.pl.tr_644  lg.ha.tl_654 ms.it.id_543
  // [63a0]
  0x25551c11, 0x20281e12, 0x20002b2a, 0x21526ba0,   // id.rw.eu_653 ms.sw.sq_654  vi.sq.un_970 ceb.ha.jw_322
  0x082821a4, 0x3f6b3b0c, 0x06002808, 0x082b18ad,   // jw.sw.no_433 so.ceb.af_543  sw.de.un_430 ga.vi.no_643
  0x0a001602, 0x1c6e1e11, 0x2900270d, 0x19250ba0,   // hr.pt.un_220 ms.hmn.id_653  gd.sl.un_540 es.eu.gl_322
  0x283564ec, 0x186e0a0c, 0x320d1f04, 0x190b53ee,   // lg.zu.sw_644 pt.hmn.ga_543  cy.cs.bs_332 ht.es.gl_422
  // [63b0]
  0x1f076e0d, 0x19250b12, 0x211b310d, 0x6b680b0c,   // hmn.it.cy_554 es.eu.gl_654  az.tr.jw_554 es.ig.ceb_543
  0x030e2513, 0x13003f0e, 0x180a3107, 0x020e0860,   // eu.is.nl_665 af.et.un_550  az.pt.ga_432 no.is.da_664
  0x1e005212, 0x3f020605, 0x0d5304ad, 0x102509ee,   // ha.ms.un_640 de.da.af_333  fi.ht.cs_643 pl.eu.lt_422
  0x3f090409, 0x55122105, 0x3500532a, 0x21311b08,   // fi.pl.af_444 jw.hu.rw_333  ht.zu.un_970 tr.az.jw_443
  // [63c0]
  0x25062b04, 0x19000505, 0x21003f02, 0x1a003107,   // vi.de.eu_332 fr.gl.un_330  af.jw.un_220 az.tl.un_420
  0x1006090b, 0x1e1c2bee, 0x1c201eaf, 0x1c111e04,   // pl.de.lt_542 vi.id.ms_422  ms.sq.id_655 ms.ro.id_332
  0x3f1105a7, 0x1a55250c, 0x281a01a7, 0x53280504,   // fr.ro.af_532 eu.rw.tl_543  en.tl.sw_532 fr.sw.ht_332
  0x6b6e68a0, 0x29002a0d, 0x0100071b, 0x191b0a07,   // ig.hmn.ceb_322 mt.sl.un_540  it.en.un_770 pt.tr.gl_432
  // [63d0]
  0x0500681b, 0x06003520, 0x130504a9, 0x030727a0,   // ig.fr.un_770 zu.de.un_850  fi.fr.et_544 gd.it.nl_322
  0x6b003b1a, 0x2d00350d, 0x130411ee, 0x64281208,   // so.ceb.un_760 zu.sk.un_540  ro.fi.et_422 hu.sw.lg_443
  0x1c0405a0, 0x091f31ad, 0x03000412, 0x11130460,   // fr.fi.id_322 az.cy.pl_643  fi.nl.un_640 fi.et.ro_664
  0x05003b07, 0x35005212, 0x180b6ba0, 0x21002a19,   // so.fr.un_420 ha.zu.un_640  ceb.es.ga_322 mt.jw.un_750
  // [63e0]
  0x130452ad, 0x0500020b, 0x01536402, 0x2a005202,   // ha.fi.et_643 da.fr.un_520  lg.ht.en_222 ha.mt.un_220
  0x1c000729, 0x17291008, 0x0f3f10ec, 0x530609af,   // it.id.un_960 lt.sl.sr_443  lt.af.lv_644 pl.de.ht_655
  0x11074a12, 0x1a1053a0, 0x55002807, 0x05006b19,   // yo.it.ro_654 ht.lt.tl_322  sw.rw.un_420 ceb.fr.un_750
  0x29020dee, 0x28010404, 0x041f09ec, 0x181f3b02,   // cs.da.sl_422 fi.en.sw_332  pl.cy.fi_644 so.cy.ga_222
  // [63f0]
  0x2a003b2a, 0x072b01ee, 0x2800160e, 0x0c0e0b0c,   // so.mt.un_970 en.vi.it_422  hr.sw.un_550 es.is.sv_543
  0x02005319, 0x0b0a55a4, 0x0e0a23a0, 0x525525a7,   // ht.da.un_750 rw.pt.es_433  ca.pt.is_322 eu.rw.ha_532
  0x132864a0, 0x08002807, 0x28000807, 0x52641a05,   // lg.sw.et_322 sw.no.un_420  no.sw.un_420 tl.lg.ha_333
  0x1a2a53a7, 0x3f280f0c, 0x16006405, 0x1c281e0c,   // ht.mt.tl_532 lv.sw.af_543  lg.hr.un_330 ms.sw.id_543

  // [6400]
  0x09006b23, 0x29071fee, 0x6b2a0607, 0x092804a4,   // ceb.pl.un_880 cy.it.sl_422  de.mt.ceb_432 fi.sw.pl_433
  0x6e2a53af, 0x1e6b1c07, 0x530f0cad, 0x2a072704,   // ht.mt.hmn_655 id.ceb.ms_432  sv.lv.ht_643 gd.it.mt_332
  0x2d000a05, 0x3f6803a4, 0x06002a02, 0x050c0909,   // pt.sk.un_330 nl.ig.af_433  mt.de.un_220 pl.sv.fr_444
  0x641b3113, 0x121604ad, 0x0a311112, 0x032a09ec,   // az.tr.lg_665 fi.hr.hu_643  ro.az.pt_654 pl.mt.nl_644
  // [6410]
  0x292a0713, 0x01640ba0, 0x2d00081a, 0x09550fa4,   // it.mt.sl_665 es.lg.en_322  no.sk.un_760 lv.rw.pl_433
  0x090f06af, 0x13002807, 0x1e1c6bee, 0x1c1921ee,   // de.lv.pl_655 sw.et.un_420  ceb.id.ms_422 jw.gl.id_422
  0x181f1ca9, 0x1e1f2711, 0x2d002907, 0x21275505,   // id.cy.ga_544 gd.cy.ms_653  sl.sk.un_420 rw.gd.jw_333
  0x6e0407a0, 0x251b2da4, 0x230f1807, 0x2a050eaf,   // it.fi.hmn_322 sk.tr.eu_433  ga.lv.ca_432 is.fr.mt_655
  // [6420]
  0x1b522113, 0x5300040c, 0x07062512, 0x27000b13,   // jw.ha.tr_665 fi.ht.un_530  eu.de.it_654 es.gd.un_650
  0x52641a0c, 0x2a0a23a9, 0x4a131b12, 0x183f08a9,   // tl.lg.ha_543 ca.pt.mt_544  tr.et.yo_654 no.af.ga_544
  0x2a002b0d, 0x0e002913, 0x043b1305, 0x040610ec,   // vi.mt.un_540 sl.is.un_650  et.so.fi_333 lt.de.fi_644
  0x100604a4, 0x2b001a22, 0x322010a7, 0x291f1e0b,   // fi.de.lt_433 tl.vi.un_870  lt.sq.bs_532 ms.cy.sl_542
  // [6430]
  0x680501a7, 0x09002902, 0x1e002302, 0x0f103ba7,   // en.fr.ig_532 sl.pl.un_220  ca.ms.un_220 so.lt.lv_532
  0x3f3b3508, 0x132b210b, 0x1b185212, 0x062031ad,   // zu.so.af_443 jw.vi.et_542  ha.ga.tr_654 az.sq.de_643
  0x073f19a7, 0x071e1aee, 0x02000607, 0x322d1609,   // gl.af.it_532 tl.ms.it_422  de.da.un_420 hr.sk.bs_444
  0x64553f07, 0x190a2005, 0x19680d07, 0x131135a4,   // af.rw.lg_432 sq.pt.gl_333  cs.ig.gl_432 zu.ro.et_433
  // [6440]
  0x323504ee, 0x3f4a0313, 0x21204aa6, 0x1f2d0d0d,   // fi.zu.bs_422 nl.yo.af_665  yo.sq.jw_521 cs.sk.cy_554
  0x183b6804, 0x4a553b12, 0x133b2813, 0x042d0fa4,   // ig.so.ga_332 so.rw.yo_654  sw.so.et_665 lv.sk.fi_433
  0x030213ad, 0x2a003f21, 0x68552804, 0x02080c0d,   // et.da.nl_643 af.mt.un_860  sw.rw.ig_332 sv.no.da_554
  0x0b3f10a4, 0x3f02180c, 0x55110ba0, 0x061225ee,   // lt.af.es_433 ga.da.af_543  es.ro.rw_322 eu.hu.de_422
  // [6450]
  0x23051aa4, 0x6b1a2a0c, 0x09100ca0, 0x275564ac,   // tl.fr.ca_433 mt.tl.ceb_543  sv.lt.pl_322 lg.rw.gd_632
  0x021f080c, 0x3b0413a0, 0x6804130e, 0x3f133b05,   // no.cy.da_543 et.fi.so_322  et.fi.ig_555 so.et.af_333
  0x08063f13, 0x0b0519ee, 0x06032013, 0x353f2813,   // af.de.no_665 gl.fr.es_422  sq.nl.de_665 sw.af.zu_665
  0x03533bee, 0x10000605, 0x16320304, 0x0c060813,   // so.ht.nl_422 de.lt.un_330  nl.bs.hr_332 no.de.sv_665
  // [6460]
  0x03533fa0, 0x06133fa9, 0x11000b1b, 0x1a276b09,   // af.ht.nl_322 af.et.de_544  es.ro.un_770 ceb.gd.tl_444
  0x1a076b07, 0x52080c13, 0x080e520b, 0x1b230cee,   // ceb.it.tl_432 sv.no.ha_665  ha.is.no_542 sv.ca.tr_422
  0x0d000607, 0x211a2b07, 0x6b003b04, 0x19000d08,   // de.cs.un_420 vi.tl.jw_432  so.ceb.un_320 cs.gl.un_430
  0x3b35200c, 0x120b05af, 0x06251f60, 0x07006b0e,   // sq.zu.so_543 fr.es.hu_655  cy.eu.de_664 ceb.it.un_550
  // [6470]
  0x011b0507, 0x13001609, 0x2d0d050e, 0x356468a9,   // fr.tr.en_432 hr.et.un_440  fr.cs.sk_555 ig.lg.zu_544
  0x53162913, 0x126b52a0, 0x0d2d120b, 0x00001615,   // sl.hr.ht_665 ha.ceb.hu_322  hu.sk.cs_542 hr.un.un_700
  0x0b001804, 0x0b0a13ee, 0x081f0208, 0x310f1207,   // ga.es.un_320 et.pt.es_422  da.cy.no_443 hu.lv.az_432
  0x120a0d14, 0x010b0f0c, 0x02003f02, 0x3216230c,   // cs.pt.hu_666 lv.es.en_543  af.da.un_220 ca.hr.bs_543
  // [6480]
  0x283b1ead, 0x27051b0c, 0x2a2007ec, 0x64011aa4,   // ms.so.sw_643 tr.fr.gd_543  it.sq.mt_644 tl.en.lg_433
  0x2a121f0c, 0x1b041f08, 0x06121fa7, 0x20006b12,   // cy.hu.mt_543 cy.fi.tr_443  cy.hu.de_532 ceb.sq.un_640
  0x040908af, 0x12003519, 0x1e1c68a0, 0x0c532008,   // no.pl.fi_655 zu.hu.un_750  ig.id.ms_322 sq.ht.sv_443
  0x19250bec, 0x52283b0c, 0x2b64050b, 0x0c000702,   // es.eu.gl_644 so.sw.ha_543  fr.lg.vi_542 it.sv.un_220
  // [6490]
  0x190b31a0, 0x3f641f07, 0x681828af, 0x2d041f0c,   // az.es.gl_322 cy.lg.af_432  sw.ga.ig_655 cy.fi.sk_543
  0x0d6b1aec, 0x03061207, 0x281235ad, 0x06283fa4,   // tl.ceb.cs_644 hu.de.nl_432  zu.hu.sw_643 af.sw.de_433
  0x186b27ec, 0x10181f05, 0x535201a4, 0x6b683b0c,   // gd.ceb.ga_644 cy.ga.lt_333  en.ha.ht_433 so.ig.ceb_543
  0x68270608, 0x05032aee, 0x290209ad, 0x31002004,   // de.gd.ig_443 mt.nl.fr_422  pl.da.sl_643 sq.az.un_320
  // [64a0]
  0x0d201212, 0x6b533bee, 0x060327ad, 0x212a53af,   // hu.sq.cs_654 so.ht.ceb_422  gd.nl.de_643 ht.mt.jw_655
  0x68062809, 0x1a1227a9, 0x4a3b1109, 0x2a1f23af,   // sw.de.ig_444 gd.hu.tl_544  ro.so.yo_444 ca.cy.mt_655
  0x105268a9, 0x536e2a14, 0x03280608, 0x1e1c07af,   // ig.ha.lt_544 mt.hmn.ht_666  de.sw.nl_443 it.id.ms_655
  0x180968a4, 0x061a35a9, 0x041f130e, 0x2a114a12,   // ig.pl.ga_433 zu.tl.de_544  et.cy.fi_555 yo.ro.mt_654
  // [64b0]
  0x3f2a0e05, 0x05003b12, 0x086b68af, 0x3508060c,   // is.mt.af_333 so.fr.un_640  ig.ceb.no_655 de.no.zu_543
  0x01083555, 0x0b004a0d, 0x211a28a6, 0x32534aad,   // zu.no.en_442 yo.es.un_540  sw.tl.jw_521 yo.ht.bs_643
  0x040e1e0c, 0x3f212b0e, 0x3f011f0d, 0x0b20050d,   // ms.is.fi_543 vi.jw.af_555  cy.en.af_554 fr.sq.es_554
  0x01001802, 0x10006805, 0x32003b13, 0x0a0f0e08,   // ga.en.un_220 ig.lt.un_330  so.bs.un_650 is.lv.pt_443
  // [64c0]
  0x52001b22, 0x04000520, 0x16101704, 0x286b100c,   // tr.ha.un_870 fr.fi.un_850  sr.lt.hr_332 lt.ceb.sw_543
  0x3f6b1aa0, 0x3f2301ee, 0x02080c12, 0x211c6411,   // tl.ceb.af_322 en.ca.af_422  sv.no.da_654 lg.id.jw_653
  0x080e020b, 0x3b682008, 0x020c085a, 0x68003b0e,   // da.is.no_542 sq.ig.so_443  no.sv.da_553 so.ig.un_550
  0x28350605, 0x643208ee, 0x282523a4, 0x64003f13,   // de.zu.sw_333 no.bs.lg_422  ca.eu.sw_433 af.lg.un_650
  // [64d0]
  0x03183fa4, 0x4a6b1ba4, 0x090802ee, 0x53081907,   // af.ga.nl_433 tr.ceb.yo_433  da.no.pl_422 gl.no.ht_432
  0x2d060daf, 0x35171aa4, 0x0f00251b, 0x040b1313,   // cs.de.sk_655 tl.sr.zu_433  eu.lv.un_770 et.es.fi_665
  0x172910a6, 0x043f64ee, 0x03006b04, 0x190b4aa4,   // lt.sl.sr_521 lg.af.fi_422  ceb.nl.un_320 yo.es.gl_433
  0x6400080d, 0x080227ee, 0x04002a1b, 0x1a092811,   // no.lg.un_540 gd.da.no_422  mt.fi.un_770 sw.pl.tl_653
  // [64e0]
  0x200c6eec, 0x32281a0c, 0x02080460, 0x04001808,   // hmn.sv.sq_644 tl.sw.bs_543  fi.no.da_664 ga.fi.un_430
  0x180631a0, 0x6e00200e, 0x10002d11, 0x0d202da9,   // az.de.ga_322 sq.hmn.un_550  sk.lt.un_630 sk.sq.cs_544
  0x1b04520c, 0x53212312, 0x0e0f045a, 0x0d006807,   // ha.fi.tr_543 ca.jw.ht_654  fi.lv.is_553 ig.cs.un_420
  0x641b0409, 0x0d082da0, 0x13006402, 0x13001b02,   // fi.tr.lg_444 sk.no.cs_322  lg.et.un_220 tr.et.un_220
  // [64f0]
  0x645535af, 0x2a040a0c, 0x0a2105af, 0x03131fa6,   // zu.rw.lg_655 pt.fi.mt_543  fr.jw.pt_655 cy.et.nl_521
  0x35016412, 0x00001242, 0x231b0aad, 0x2331250c,   // lg.en.zu_654 ur.un.un_C00  pt.tr.ca_643 eu.az.ca_543
  0x29250d12, 0x1e002a0b, 0x20536ba9, 0x066b1ca4,   // cs.eu.sl_654 mt.ms.un_520  ceb.ht.sq_544 id.ceb.de_433
  0x04201307, 0x0b001a08, 0x06001a0d, 0x555235a4,   // et.sq.fi_432 tl.es.un_430  tl.de.un_540 zu.ha.rw_433
  // [6500]
  0x0e53010c, 0x0b0a19ec, 0x1b233109, 0x136828ad,   // en.ht.is_543 gl.pt.es_644  az.ca.tr_444 sw.ig.et_643
  0x27000704, 0x4a6828ec, 0x3b5255a9, 0x0a006e14,   // it.gd.un_320 sw.ig.yo_644  rw.ha.so_544 hmn.pt.un_660
  0x1a2952ee, 0x1b00681a, 0x6b002822, 0x2d280713,   // ha.sl.tl_422 ig.tr.un_760  sw.ceb.un_870 it.sw.sk_665
  0x2a1628ee, 0x12001608, 0x07006809, 0x190b0109,   // sw.hr.mt_422 hr.hu.un_430  ig.it.un_440 en.es.gl_444
  // [6510]
  0x320f2907, 0x641a1313, 0x11000d16, 0x2a1a53a4,   // sl.lv.bs_432 et.tl.lg_665  cs.ro.un_720 ht.tl.mt_433
  0x130419a7, 0x030f08a4, 0x190b2302, 0x211219a0,   // gl.fi.et_532 no.lv.nl_433  ca.es.gl_222 gl.hu.jw_322
  0x0a0b19ee, 0x04080aa7, 0x0d2908a7, 0x3229160e,   // gl.es.pt_422 mk.uk.ru_532  no.sl.cs_532 hr.sl.bs_555
  0x2a35190b, 0x25121b12, 0x29130405, 0x5232200c,   // gl.zu.mt_542 tr.hu.eu_654  fi.et.sl_333 sq.bs.ha_543
  // [6520]
  0x13352512, 0x0b181907, 0x2d0d55a0, 0x551b040c,   // eu.zu.et_654 gl.ga.es_432  rw.cs.sk_322 fi.tr.rw_543
  0x041c4aa4, 0x00003b37, 0x2b322711, 0x4a550408,   // yo.id.fi_433 so.un.un_B00  gd.bs.vi_653 fi.rw.yo_443
  0x1c0a1a0c, 0x013552a0, 0x2b206eec, 0x200325ec,   // tl.pt.id_543 ha.zu.en_322  hmn.sq.vi_644 eu.nl.sq_644
  0x13060da9, 0x3f0703a4, 0x280121a7, 0x09006822,   // cs.de.et_544 nl.it.af_433  jw.en.sw_532 ig.pl.un_870
  // [6530]
  0x050f0714, 0x133f21a4, 0x10001e04, 0x1c2921af,   // it.lv.fr_666 jw.af.et_433  ms.lt.un_320 jw.sl.id_655
  0x3f642509, 0x033f6812, 0x04172911, 0x2b211aec,   // eu.lg.af_444 ig.af.nl_654  sl.sr.fi_653 tl.jw.vi_644
  0x1b000f1b, 0x10312008, 0x55211f07, 0x3b005508,   // lv.tr.un_770 sq.az.lt_443  cy.jw.rw_432 rw.so.un_430
  0x52136b09, 0x1c00190e, 0x25191caf, 0x2700070e,   // ceb.et.ha_444 gl.id.un_550  id.gl.eu_655 it.gd.un_550
  // [6540]
  0x292025a6, 0x28641e0c, 0x215213a4, 0x532a2007,   // eu.sq.sl_521 ms.lg.sw_543  et.ha.jw_433 sq.mt.ht_432
  0x201b250d, 0x1c212b0d, 0x13072004, 0x1a522ba7,   // eu.tr.sq_554 vi.jw.id_554  sq.it.et_332 vi.ha.tl_532
  0x4a1819ee, 0x080c0213, 0x20071205, 0x05201f07,   // gl.ga.yo_422 da.sv.no_665  hu.it.sq_333 cy.sq.fr_432
  0x520f210c, 0x051b0313, 0x280f64a4, 0x101764ee,   // jw.lv.ha_543 nl.tr.fr_665  lg.lv.sw_433 lg.sr.lt_422
  // [6550]
  0x251b2a09, 0x05003f0b, 0x52284aee, 0x07002812,   // mt.tr.eu_444 af.fr.un_520  yo.sw.ha_422 sw.it.un_640
  0x1b2025ac, 0x120a180b, 0x642831af, 0x190b28af,   // eu.sq.tr_632 ga.pt.hu_542  az.sw.lg_655 sw.es.gl_655
  0x0a042704, 0x21002320, 0x102304a7, 0x28522055,   // gd.fi.pt_332 ca.jw.un_850  fi.ca.lt_532 sq.ha.sw_442
  0x55000612, 0x32160405, 0x0e2820ac, 0x200812ad,   // de.rw.un_640 fi.hr.bs_333  sq.sw.is_632 hu.no.sq_643
  // [6560]
  0x251e64a0, 0x190564a0, 0x531b0512, 0x641b050d,   // lg.ms.eu_322 lg.fr.gl_322  fr.tr.ht_654 fr.tr.lg_554
  0x5500030e, 0x313b280d, 0x020621ec, 0x0500190b,   // nl.rw.un_550 sw.so.az_554  jw.de.da_644 gl.fr.un_520
  0x321620a4, 0x3216130c, 0x10002304, 0x043f0809,   // sq.hr.bs_433 et.hr.bs_543  ca.lt.un_320 no.af.fi_444
  0x3b0602a9, 0x321731a0, 0x112005af, 0x120d0f05,   // da.de.so_544 az.sr.bs_322  fr.sq.ro_655 lv.cs.hu_333
  // [6570]
  0x121b3f55, 0x311b3f08, 0x1c1a21a4, 0x3100130e,   // af.tr.hu_442 af.tr.az_443  jw.tl.id_433 et.az.un_550
  0x04253512, 0x1b313faf, 0x190b2d0c, 0x1b003f12,   // zu.eu.fi_654 af.az.tr_655  sk.es.gl_543 af.tr.un_640
  0x551f6bac, 0x0b0d01a4, 0x20531c0c, 0x1e1c3bee,   // ceb.cy.rw_632 en.cs.es_433  id.ht.sq_543 so.id.ms_422
  0x52000d21, 0x1e00350d, 0x1e041cee, 0x06111307,   // cs.ha.un_860 zu.ms.un_540  id.fi.ms_422 et.ro.de_432
  // [6580]
  0x55290dad, 0x092a3507, 0x0b0a1f05, 0x1100011a,   // cs.sl.rw_643 zu.mt.pl_432  cy.pt.es_333 en.ro.un_760
  0x06551307, 0x1c1a1e04, 0x6b2104ee, 0x21000f0c,   // et.rw.de_432 ms.tl.id_332  fi.jw.ceb_422 lv.jw.un_530
  0x172007ee, 0x210f6807, 0x13000f09, 0x3f02100c,   // it.sq.sr_422 ig.lv.jw_432  lv.et.un_440 lt.da.af_543
  0x100817ec, 0x1b00010d, 0x01310cee, 0x20000c18,   // sr.uk.be_644 en.tr.un_540  sv.az.en_422 sv.sq.un_740
  // [6590]
  0x0900210d, 0x0b190aee, 0x3f0806ee, 0x250f2908,   // jw.pl.un_540 pt.gl.es_422  de.no.af_422 sl.lv.eu_443
  0x2d000808, 0x250f08a4, 0x640452a7, 0x0f3202a9,   // no.sk.un_430 no.lv.eu_433  ha.fi.lg_532 da.bs.lv_544
  0x686428af, 0x121906ad, 0x09291713, 0x050255af,   // sw.lg.ig_655 de.gl.hu_643  sr.sl.pl_665 rw.da.fr_655
  0x2a13255a, 0x122523a4, 0x0b190a5a, 0x31292d09,   // eu.et.mt_553 ca.eu.hu_433  pt.gl.es_553 sk.sl.az_444
  // [65a0]
  0x1e003102, 0x080212a0, 0x312d2913, 0x2d0d1902,   // az.ms.un_220 hu.da.no_322  sl.sk.az_665 gl.cs.sk_222
  0x200511a0, 0x100f020b, 0x02051305, 0x5500011a,   // ro.fr.sq_322 da.lv.lt_542  et.fr.da_333 en.rw.un_760
  0x28182a13, 0x01130507, 0x29312d13, 0x316e2da6,   // mt.ga.sw_665 fr.et.en_432  sk.az.sl_665 sk.hmn.az_521
  0x1306250c, 0x31292dac, 0x190a07ee, 0x31292d13,   // eu.de.et_543 sk.sl.az_632  it.pt.gl_422 sk.sl.az_665
  // [65b0]
  0x012a1fa0, 0x09645502, 0x0f6e290b, 0x124a5209,   // cy.mt.en_322 rw.lg.pl_222  sl.hmn.lv_542 ha.yo.hu_444
  0x292a11a7, 0x061b3fa0, 0x0d0804a9, 0x130c28a4,   // ro.mt.sl_532 af.tr.de_322  fi.no.cs_544 sw.sv.et_433
  0x0a192bb2, 0x1e005512, 0x1c0d0904, 0x2d005334,   // vi.gl.pt_732 rw.ms.un_640  hi.ne.mr_332 ht.sk.un_A80
  0x0f2920ec, 0x2800022a, 0x02121bee, 0x1f00210b,   // sq.sl.lv_644 da.sw.un_970  tr.hu.da_422 jw.cy.un_520
  // [65c0]
  0x3100292b, 0x072b2aa0, 0x0f0c0904, 0x06100305,   // sl.az.un_980 mt.vi.it_322  pl.sv.lv_332 nl.lt.de_333
  0x3509640c, 0x350655ad, 0x55131ea0, 0x551b28ad,   // lg.pl.zu_543 rw.de.zu_643  ms.et.rw_322 sw.tr.rw_643
  0x090c1e0c, 0x234a1907, 0x35286402, 0x2a1a28a9,   // ms.sv.pl_543 gl.yo.ca_432  lg.sw.zu_222 sw.tl.mt_544
  0x11040faf, 0x09110f0c, 0x2a001302, 0x200a1ba4,   // lv.fi.ro_655 lv.ro.pl_543  et.mt.un_220 tr.pt.sq_433
  // [65d0]
  0x1a20520d, 0x23060e11, 0x1b523113, 0x2520520c,   // ha.sq.tl_554 is.de.ca_653  az.ha.tr_665 ha.sq.eu_543
  0x194a2d04, 0x211f35a0, 0x042552af, 0x52000d04,   // sk.yo.gl_332 zu.cy.jw_322  ha.eu.fi_655 cs.ha.un_320
  0x1f4a52ec, 0x531f35ad, 0x0925210c, 0x182d0a07,   // ha.yo.cy_644 zu.cy.ht_643  jw.eu.pl_543 pt.sk.ga_432
  0x4a3152ec, 0x19111308, 0x31233b0c, 0x1c3b4aad,   // ha.az.yo_644 et.ro.gl_443  so.ca.az_543 yo.so.id_643
  // [65e0]
  0x0d31045a, 0x03095305, 0x0613010c, 0x27000505,   // fi.az.cs_553 ht.pl.nl_333  en.et.de_543 fr.gd.un_330
  0x286421ad, 0x04003121, 0x21045508, 0x29251bec,   // jw.lg.sw_643 az.fi.un_860  rw.fi.jw_443 tr.eu.sl_644
  0x350e645a, 0x08021305, 0x3b2a31ac, 0x0c5511a7,   // lg.is.zu_553 et.da.no_333  az.mt.so_632 ro.rw.sv_532
  0x131f200c, 0x53311a14, 0x0d35295a, 0x6e133113,   // sq.cy.et_543 tl.az.ht_666  sl.zu.cs_553 az.et.hmn_665
  // [65f0]
  0x31131e07, 0x5301190c, 0x05001107, 0x1e132aaf,   // ms.et.az_432 gl.en.ht_543  ro.fr.un_420 mt.et.ms_655
  0x31521e0c, 0x53281b13, 0x0f001005, 0x3b316e08,   // ms.ha.az_543 tr.sw.ht_665  lt.lv.un_330 hmn.az.so_443
  0x181135ad, 0x13213112, 0x0d001322, 0x0f1132a0,   // zu.ro.ga_643 az.jw.et_654  bh.ne.un_870 bs.ro.lv_322
  0x1c041e07, 0x28160f04, 0x2d0d0709, 0x08003519,   // ms.fi.id_432 lv.hr.sw_332  it.cs.sk_444 zu.no.un_750
  // [6600]
  0x0a00190b, 0x0e003107, 0x080213a9, 0x320728a0,   // gl.pt.un_520 az.is.un_420  et.da.no_544 sw.it.bs_322
  0x1b133113, 0x531b5555, 0x321708a0, 0x5200030c,   // az.et.tr_665 rw.tr.ht_442  no.sr.bs_322 nl.ha.un_530
  0x312a1fad, 0x20551104, 0x0d1c13ec, 0x3f002312,   // cy.mt.az_643 ro.rw.sq_332  bh.mr.ne_644 ca.af.un_640
  0x1f002807, 0x021a6bee, 0x091725a6, 0x4a1153a0,   // sw.cy.un_420 ceb.tl.da_422  eu.sr.pl_521 ht.ro.yo_322
  // [6610]
  0x2b184a02, 0x0d000813, 0x526425a4, 0x1c110a02,   // yo.ga.vi_222 no.cs.un_650  eu.lg.ha_433 pt.ro.id_222
  0x3b535512, 0x0b0220a7, 0x061f23a4, 0x1a6807a7,   // rw.ht.so_654 sq.da.es_532  ca.cy.de_433 it.ig.tl_532
  0x64286802, 0x55282514, 0x5200252a, 0x3f256412,   // ig.sw.lg_222 eu.sw.rw_666  eu.ha.un_970 lg.eu.af_654
  0x03001320, 0x531b250e, 0x190b25ec, 0x134a6409,   // et.nl.un_850 eu.tr.ht_555  eu.es.gl_644 lg.yo.et_444
  // [6620]
  0x18232dac, 0x04200fad, 0x521b25ee, 0x3f001e21,   // sk.ca.ga_632 lv.sq.fi_643  eu.tr.ha_422 ms.af.un_860
  0x1b0b53ee, 0x171f32ee, 0x211c3f12, 0x35004a02,   // ht.es.tr_422 bs.cy.sr_422  af.id.jw_654 yo.zu.un_220
  0x3f25030d, 0x05000c04, 0x25003f1a, 0x350208ac,   // nl.eu.af_554 sv.fr.un_320  af.eu.un_760 no.da.zu_632
  0x08211b08, 0x2d0d13af, 0x040e52a4, 0x080252a9,   // tr.jw.no_443 et.cs.sk_655  ha.is.fi_433 ha.da.no_544
  // [6630]
  0x1b020307, 0x1c064aa6, 0x0e181fad, 0x040655ec,   // nl.da.tr_432 yo.de.id_521  cy.ga.is_643 rw.de.fi_644
  0x182752a9, 0x270e53ad, 0x6b6827ee, 0x013f64a6,   // ha.gd.ga_544 ht.is.gd_643  gd.ig.ceb_422 lg.af.en_521
  0x1002040c, 0x18005209, 0x0e275307, 0x3f030a11,   // fi.da.lt_543 ha.ga.un_440  ht.gd.is_432 pt.nl.af_653
  0x28686e0b, 0x55061e0c, 0x18130612, 0x080255a0,   // hmn.ig.sw_542 ms.de.rw_543  de.et.ga_654 rw.da.no_322
  // [6640]
  0x5500040d, 0x010f0302, 0x16092912, 0x682852a0,   // fi.rw.un_540 nl.lv.en_222  sl.pl.hr_654 ha.sw.ig_322
  0x131011a0, 0x180c3fa4, 0x1a000423, 0x1e091005,   // ro.lt.et_322 af.sv.ga_433  fi.tl.un_880 lt.pl.ms_333
  0x23002104, 0x3b1f640c, 0x076b1aa9, 0x17162da0,   // jw.ca.un_320 lg.cy.so_543  tl.ceb.it_544 sk.hr.sr_322
  0x23050e0e, 0x1f1b0205, 0x1e0e1ca4, 0x08070209,   // is.fr.ca_555 da.tr.cy_333  id.is.ms_433 da.it.no_444
  // [6650]
  0x1e002907, 0x311b18af, 0x0f2a3fa4, 0x190b1eaf,   // sl.ms.un_420 ga.tr.az_655  af.mt.lv_433 ms.es.gl_655
  0x310e080c, 0x251607a4, 0x32041cee, 0x04005212,   // no.is.az_543 it.hr.eu_433  id.fi.bs_422 ha.fi.un_640
  0x320a3108, 0x2804550c, 0x3b3119ee, 0x213b1fec,   // az.pt.bs_443 rw.fi.sw_543  gl.az.so_422 cy.so.jw_644
  0x06120207, 0x352507af, 0x23310ead, 0x4a002317,   // da.hu.de_432 it.eu.zu_655  is.az.ca_643 ca.yo.un_730
  // [6660]
  0x211b1eaf, 0x3f286804, 0x1b002007, 0x1f52130c,   // ms.tr.jw_655 ig.sw.af_332  sq.tr.un_420 et.ha.cy_543
  0x0f002d0d, 0x0d2d290b, 0x1a536404, 0x1e001b13,   // sk.lv.un_540 sl.sk.cs_542  lg.ht.tl_332 tr.ms.un_650
  0x040c13a0, 0x35250604, 0x1f0e0408, 0x172868a0,   // et.sv.fi_322 de.eu.zu_332  fi.is.cy_443 ig.sw.sr_322
  0x6b1a04a4, 0x17001b07, 0x3b00271a, 0x04002304,   // fi.tl.ceb_433 tr.sr.un_420  gd.so.un_760 ca.fi.un_320
  // [6670]
  0x04271160, 0x3f0e040c, 0x041f0e11, 0x28354aa0,   // ro.gd.fi_664 fi.is.af_543  is.cy.fi_653 yo.zu.sw_322
  0x6e53290c, 0x190a3b05, 0x2d290da0, 0x2d090d13,   // sl.ht.hmn_543 so.pt.gl_333  cs.sl.sk_322 cs.pl.sk_665
  0x040503a4, 0x05040612, 0x3b4a355a, 0x2505040b,   // nl.fr.fi_433 de.fi.fr_654  zu.yo.so_553 fi.fr.eu_542
  0x1113530c, 0x090d17ad, 0x1b354a07, 0x11001221,   // ht.et.ro_543 sr.cs.pl_643  yo.zu.tr_432 hu.ro.un_860
  // [6680]
  0x1c531eee, 0x1b023104, 0x12354a12, 0x641035ad,   // ms.ht.id_422 az.da.tr_332  yo.zu.hu_654 zu.lt.lg_643
  0x0d131c13, 0x0b5255ee, 0x2d120d0c, 0x1e1c05ee,   // mr.bh.ne_665 rw.ha.es_422  cs.hu.sk_543 fr.id.ms_422
  0x07000411, 0x0b0a12ee, 0x20002d0d, 0x2a002502,   // ru.bg.un_630 hu.pt.es_422  sk.sq.un_540 eu.mt.un_220
  0x1125100c, 0x17004a05, 0x4a2011ad, 0x0400530e,   // lt.eu.ro_543 yo.sr.un_330  ro.sq.yo_643 ht.fi.un_550
  // [6690]
  0x0e006404, 0x2b004a07, 0x3b002504, 0x6b352aa9,   // lg.is.un_320 yo.vi.un_420  eu.so.un_320 mt.zu.ceb_544
  0x1f090ea4, 0x0b091109, 0x041f4aa7, 0x09000408,   // is.pl.cy_433 ro.pl.es_444  yo.cy.fi_532 fi.pl.un_430
  0x1a4a6bee, 0x6412280c, 0x213120ec, 0x1c0f52ee,   // ceb.yo.tl_422 sw.hu.lg_543  sq.az.jw_644 ha.lv.id_422
  0x0f082007, 0x213b640e, 0x0c2a4a08, 0x6b005521,   // sq.no.lv_432 lg.so.jw_555  yo.mt.sv_443 rw.ceb.un_860
  // [66a0]
  0x3f3b6807, 0x4a641b5a, 0x133b0407, 0x3b3f13ad,   // ig.so.af_432 tr.lg.yo_553  fi.so.et_432 et.af.so_643
  0x53040d14, 0x1a3110a9, 0x351a100d, 0x356b53a4,   // cs.fi.ht_666 lt.az.tl_544  lt.tl.zu_554 ht.ceb.zu_433
  0x20212dee, 0x1a5510a9, 0x182a2007, 0x3252100c,   // sk.jw.sq_422 lt.rw.tl_544  sq.mt.ga_432 lt.ha.bs_543
  0x531a2a05, 0x2b003202, 0x07000b0e, 0x2d530d12,   // mt.tl.ht_333 bs.vi.un_220  es.it.un_550 cs.ht.sk_654
  // [66b0]
  0x181f23ad, 0x311b100c, 0x2d0d53a9, 0x1f2109ad,   // ca.cy.ga_643 lt.tr.az_543  ht.cs.sk_544 pl.jw.cy_643
  0x1b3110ec, 0x083525a0, 0x531b10a4, 0x130f1112,   // lt.az.tr_644 eu.zu.no_322  lt.tr.ht_433 ro.lv.et_654
  0x64000804, 0x0800050b, 0x2a641f55, 0x1c004a19,   // no.lg.un_320 fr.no.un_520  cy.lg.mt_442 yo.id.un_750
  0x2a003b19, 0x19002807, 0x1a0228a4, 0x0c3f080c,   // so.mt.un_750 sw.gl.un_420  sw.da.tl_433 no.af.sv_543
  // [66c0]
  0x28252aaf, 0x10011102, 0x1e101ca4, 0x0c060a0c,   // mt.eu.sw_655 ro.en.lt_222  id.lt.ms_433 pt.de.sv_543
  0x2d000e07, 0x3500290b, 0x04280fa4, 0x211b52ee,   // is.sk.un_420 sl.zu.un_520  lv.sw.fi_433 ha.tr.jw_422
  0x1a2b55a7, 0x21001f09, 0x351b640c, 0x050b1ea4,   // rw.vi.tl_532 cy.jw.un_440  lg.tr.zu_543 ms.es.fr_433
  0x350f0e05, 0x131c09a9, 0x04001f29, 0x1c120fa4,   // is.lv.zu_333 hi.mr.bh_544  cy.fi.un_960 lv.hu.id_433
  // [66d0]
  0x162917a4, 0x53291ea0, 0x060a0e13, 0x21031e08,   // sr.sl.hr_433 ms.sl.ht_322  is.pt.de_665 ms.nl.jw_443
  0x190a28ec, 0x55282102, 0x27002102, 0x2b641207,   // sw.pt.gl_644 jw.sw.rw_222  jw.gd.un_220 hu.lg.vi_432
  0x283208ee, 0x0b002323, 0x212d1c12, 0x2a005508,   // no.bs.sw_422 ca.es.un_880  id.sk.jw_654 rw.mt.un_430
  0x0a0d010c, 0x16001b08, 0x1c210714, 0x192d0aad,   // en.cs.pt_543 tr.hr.un_430  it.jw.id_666 pt.sk.gl_643
  // [66e0]
  0x1e281ca0, 0x122528a4, 0x2d0d1ca4, 0x55002912,   // id.sw.ms_322 sw.eu.hu_433  id.cs.sk_433 sl.rw.un_640
  0x1b0d100c, 0x3f2d0fa7, 0x3217350c, 0x290e0caf,   // lt.cs.tr_543 lv.sk.af_532  zu.sr.bs_543 sv.is.sl_655
  0x131c0908, 0x1b032dad, 0x29002721, 0x231b01a4,   // hi.mr.bh_443 sk.nl.tr_643  gd.sl.un_860 en.tr.ca_433
  0x55641aa7, 0x3f041909, 0x251055ec, 0x1f643baf,   // tl.lg.rw_532 gl.fi.af_444  rw.lt.eu_644 so.lg.cy_655
  // [66f0]
  0x1b641108, 0x060c20b4, 0x6b00111b, 0x64551105,   // ro.lg.tr_443 sq.sv.de_754  ro.ceb.un_770 ro.rw.lg_333
  0x521e21af, 0x1a00551a, 0x0b28535a, 0x640c1314,   // jw.ms.ha_655 rw.tl.un_760  ht.sw.es_553 et.sv.lg_666
  0x2a313502, 0x6b681aa4, 0x21060e05, 0x02002a07,   // zu.az.mt_222 tl.ig.ceb_433  is.de.jw_333 mt.da.un_420
  0x2d324aee, 0x28203ba4, 0x2300072c, 0x0b1219a0,   // yo.bs.sk_422 so.sq.sw_433  it.ca.un_990 gl.hu.es_322
  // [6700]
  0x12103f08, 0x28001212, 0x074a1608, 0x03001702,   // af.lt.hu_443 hu.sw.un_640  hr.yo.it_443 sr.nl.un_220
  0x25112313, 0x64192a04, 0x18004a04, 0x351a5204,   // ca.ro.eu_665 mt.gl.lg_332  yo.ga.un_320 ha.tl.zu_332
  0x1c2106a0, 0x23191113, 0x3b0e06a0, 0x2500180e,   // de.jw.id_322 ro.gl.ca_665  de.is.so_322 ga.eu.un_550
  0x530e55a4, 0x0e000d04, 0x08021f02, 0x136b55ec,   // rw.is.ht_433 cs.is.un_320  cy.da.no_222 rw.ceb.et_644
  // [6710]
  0x52201ba4, 0x21190205, 0x52070f0c, 0x13001821,   // tr.sq.ha_433 da.gl.jw_333  lv.it.ha_543 ga.et.un_860
  0x13110e05, 0x3b1e110c, 0x11200707, 0x686b3ba4,   // is.ro.et_333 ro.ms.so_543  it.sq.ro_432 so.ceb.ig_433
  0x11022a0d, 0x0700351b, 0x53026eaf, 0x00000c37,   // mt.da.ro_554 zu.it.un_770  hmn.da.ht_655 sv.un.un_B00
  0x10070aad, 0x110e55a4, 0x081353a0, 0x03020755,   // mk.bg.be_643 rw.is.ro_433  ht.et.no_322 it.da.nl_442
  // [6720]
  0x062507af, 0x3b4a200c, 0x2025060c, 0x31006e07,   // it.eu.de_655 sq.yo.so_543  de.eu.sq_543 hmn.az.un_420
  0x4a002d21, 0x6455250c, 0x35006804, 0x2d055312,   // sk.yo.un_860 eu.rw.lg_543  ig.zu.un_320 ht.fr.sk_654
  0x20292aee, 0x03000d08, 0x120e1112, 0x0f006b33,   // mt.sl.sq_422 cs.nl.un_430  ro.is.hu_654 ceb.lv.un_A70
  0x323525ee, 0x2064070c, 0x1c551ea9, 0x1a6b070c,   // eu.zu.bs_422 it.lg.sq_543  ms.rw.id_544 it.ceb.tl_543
  // [6730]
  0x1e1c3514, 0x2b4a1cad, 0x55041313, 0x043b2010,   // zu.id.ms_666 id.yo.vi_643  et.fi.rw_665 sq.so.fi_642
  0x2a00050c, 0x18001313, 0x190e0ba4, 0x0e001807,   // fr.mt.un_530 et.ga.un_650  es.is.gl_433 ga.is.un_420
  0x11130404, 0x55526413, 0x0e1b1f55, 0x0c003b12,   // fi.et.ro_332 lg.ha.rw_665  cy.tr.is_442 so.sv.un_640
  0x53001f02, 0x1a1b4aad, 0x04003202, 0x0d1c1313,   // cy.ht.un_220 yo.tr.tl_643  bs.fi.un_220 bh.mr.ne_665
  // [6740]
  0x2913170c, 0x190b18af, 0x070c2a13, 0x1a4a640c,   // sr.et.sl_543 ga.es.gl_655  mt.sv.it_665 lg.yo.tl_543
  0x04130312, 0x29000405, 0x21001e18, 0x16003504,   // nl.et.fi_654 fi.sl.un_330  ms.jw.un_740 zu.hr.un_320
  0x091f3faf, 0x27044a02, 0x03096412, 0x05072a13,   // af.cy.pl_655 yo.fi.gd_222  lg.pl.nl_654 mt.it.fr_665
  0x190b1f09, 0x190b35ec, 0x0f001c0b, 0x1e1c4aa9,   // cy.es.gl_444 zu.es.gl_644  id.lv.un_520 yo.id.ms_544
  // [6750]
  0x105535a4, 0x1f311b09, 0x2a00032a, 0x52002829,   // zu.rw.lt_433 tr.az.cy_444  nl.mt.un_970 sw.ha.un_960
  0x2910120c, 0x2a5507ad, 0x533135a7, 0x033f1ca4,   // hu.lt.sl_543 it.rw.mt_643  zu.az.ht_532 id.af.nl_433
  0x19230b60, 0x55000e23, 0x031c3b12, 0x1c0219a7,   // es.ca.gl_664 is.rw.un_880  so.id.nl_654 gl.da.id_532
  0x0c0e1bec, 0x0e00520c, 0x121809ec, 0x1e3f1c0c,   // tr.is.sv_644 ha.is.un_530  pl.ga.hu_644 id.af.ms_543
  // [6760]
  0x1e1c11a4, 0x041a1b0c, 0x21202ba0, 0x28684aac,   // ro.id.ms_433 tr.tl.fi_543  vi.sq.jw_322 yo.ig.sw_632
  0x351a52af, 0x2a0731a9, 0x1c521fa0, 0x1c0e1eee,   // ha.tl.zu_655 az.it.mt_544  cy.ha.id_322 ms.is.id_422
  0x1a0453ec, 0x10353fa0, 0x525504a4, 0x25063ba4,   // ht.fi.tl_644 af.zu.lt_322  fi.rw.ha_433 so.de.eu_433
  0x3f2a230c, 0x033f1c12, 0x20022a5a, 0x530f5507,   // ca.mt.af_543 id.af.nl_654  mt.da.sq_553 rw.lv.ht_432
  // [6770]
  0x172935ac, 0x68001a0c, 0x070a1aec, 0x13552813,   // zu.sl.sr_632 tl.ig.un_530  tl.pt.it_644 sw.rw.et_665
  0x2a0721a4, 0x646b1e0c, 0x05001217, 0x1f0a4aad,   // jw.it.mt_433 ms.ceb.lg_543  hu.fr.un_730 yo.pt.cy_643
  0x3f000612, 0x20000605, 0x23000d19, 0x321b2dee,   // de.af.un_640 de.sq.un_330  cs.ca.un_750 sk.tr.bs_422
  0x1f031ea4, 0x182a10a0, 0x1c1f1e0c, 0x52310ea7,   // ms.nl.cy_433 lt.mt.ga_322  ms.cy.id_543 is.az.ha_532
  // [6780]
  0x113b0309, 0x1655030c, 0x172d0d14, 0x315368a9,   // nl.so.ro_444 nl.rw.hr_543  cs.sk.sr_666 ig.ht.az_544
  0x1b3b1305, 0x08022dee, 0x21031313, 0x02003b13,   // et.so.tr_333 sk.da.no_422  et.nl.jw_665 so.da.un_650
  0x11530612, 0x0f001112, 0x10062aec, 0x6b092da0,   // de.ht.ro_654 ro.lv.un_640  mt.de.lt_644 sk.pl.ceb_322
  0x3b001808, 0x1c641e07, 0x092d0fee, 0x55283bad,   // ga.so.un_430 ms.lg.id_432  lv.sk.pl_422 so.sw.rw_643
  // [6790]
  0x1f276ba7, 0x3b12100d, 0x0a1027a7, 0x29000522,   // ceb.gd.cy_532 lt.hu.so_554  gd.lt.pt_532 fr.sl.un_870
  0x64004a13, 0x64284aad, 0x082927a0, 0x29053fa0,   // yo.lg.un_650 yo.sw.lg_643  gd.sl.no_322 af.fr.sl_322
  0x13001804, 0x525531ee, 0x2a050fa4, 0x2a252104,   // ga.et.un_320 az.rw.ha_422  lv.fr.mt_433 jw.eu.mt_332
  0x03001b19, 0x1e1c53af, 0x29086ea0, 0x18000510,   // tr.nl.un_750 ht.id.ms_655  hmn.no.sl_322 fr.ga.un_620
  // [67a0]
  0x19160bac, 0x2d0d2907, 0x35002507, 0x291f07ad,   // es.hr.gl_632 sl.cs.sk_432  eu.zu.un_420 it.cy.sl_643
  0x3b1e2aad, 0x2d0d160e, 0x2d0d0ab6, 0x2d001e02,   // mt.ms.so_643 hr.cs.sk_555  pt.cs.sk_766 ms.sk.un_220
  0x3b281bad, 0x6800290c, 0x0c020e04, 0x3b3155a4,   // tr.sw.so_643 sl.ig.un_530  is.da.sv_332 rw.az.so_433
  0x00000137, 0x08000e18, 0x070a2360, 0x13090dee,   // en.un.un_B00 is.no.un_740  ca.pt.it_664 ne.hi.bh_422
  // [67b0]
  0x11005504, 0x08095305, 0x4a681f0c, 0x28040e08,   // rw.ro.un_320 ht.pl.no_333  cy.ig.yo_543 is.fi.sw_443
  0x19001e05, 0x20004a12, 0x2a1207ad, 0x3229170c,   // ms.gl.un_330 yo.sq.un_640  it.hu.mt_643 sr.sl.bs_543
  0x321709af, 0x23181aac, 0x52350555, 0x036806ee,   // pl.sr.bs_655 tl.ga.ca_632  fr.zu.ha_442 de.ig.nl_422
  0x31532011, 0x02080e07, 0x20000208, 0x080264ee,   // sq.ht.az_653 is.no.da_432  da.sq.un_430 lg.da.no_422
  // [67c0]
  0x2d0d0cec, 0x00000637, 0x350455a0, 0x04005508,   // sv.cs.sk_644 de.un.un_B00  rw.fi.zu_322 rw.fi.un_430
  0x073f08a9, 0x53201f0c, 0x08021005, 0x20350fad,   // no.af.it_544 cy.sq.ht_543  lt.da.no_333 lv.zu.sq_643
  0x190b23ee, 0x0c030802, 0x10005508, 0x07110a05,   // ca.es.gl_422 no.nl.sv_222  rw.lt.un_430 mk.ro.bg_333
  0x35210cad, 0x12110fa0, 0x08022b0c, 0x08002d02,   // sv.jw.zu_643 lv.ro.hu_322  vi.da.no_543 sk.no.un_220
  // [67d0]
  0x280813ee, 0x06271fa0, 0x16100d07, 0x1a001608,   // et.no.sw_422 cy.gd.de_322  cs.lt.hr_432 hr.tl.un_430
  0x0c003512, 0x530b0aa6, 0x190b1fee, 0x20082da0,   // zu.sv.un_640 pt.es.ht_521  cy.es.gl_422 sk.no.sq_322
  0x55000707, 0x181a4a12, 0x2a0753a0, 0x070b4a13,   // it.rw.un_420 yo.tl.ga_654  ht.it.mt_322 yo.es.it_665
  0x6b55520c, 0x0f002505, 0x4a5529a9, 0x1a5228ec,   // ha.rw.ceb_543 eu.lv.un_330  sl.rw.yo_544 sw.ha.tl_644
  // [67e0]
  0x52005521, 0x022808ad, 0x52071c07, 0x522d03a9,   // rw.ha.un_860 no.sw.da_643  id.it.ha_432 nl.sk.ha_544
  0x55005333, 0x0f523bad, 0x096b2007, 0x35286812,   // ht.rw.un_A70 so.ha.lv_643  sq.ceb.pl_432 ig.sw.zu_654
  0x18000504, 0x274a110d, 0x1300050c, 0x1e051ca0,   // fr.ga.un_320 ro.yo.gd_554  fr.et.un_530 id.fr.ms_322
  0x532b2dec, 0x64554aec, 0x4a1601ec, 0x19020ba4,   // sk.vi.ht_644 yo.rw.lg_644  en.hr.yo_644 es.da.gl_433
  // [67f0]
  0x1c101e0c, 0x2000230e, 0x2968100c, 0x1e1c2160,   // ms.lt.id_543 ca.sq.un_550  lt.ig.sl_543 jw.id.ms_664
  0x17000e05, 0x0a2a2104, 0x1e001312, 0x1c0e1e13,   // is.sr.un_330 jw.mt.pt_332  et.ms.un_640 ms.is.id_665
  0x110b68ad, 0x2d2b0d13, 0x532052a6, 0x06002d0e,   // ig.es.ro_643 cs.vi.sk_665  ha.sq.ht_521 sk.de.un_550
  0x033f0e11, 0x551b25ec, 0x131b520d, 0x29312504,   // is.af.nl_653 eu.tr.rw_644  ha.tr.et_554 eu.az.sl_332

  // [6800]
  0x192a070c, 0x6b3518a6, 0x04200e12, 0x01532a09,   // it.mt.gl_543 ga.zu.ceb_521  is.sq.fi_654 mt.ht.en_444
  0x131b2907, 0x0f006419, 0x190a0da4, 0x0a0b1907,   // sl.tr.et_432 lg.lv.un_750  cs.pt.gl_433 gl.es.pt_432
  0x081a02ee, 0x07130404, 0x351f5308, 0x3b1e1cec,   // da.tl.no_422 fi.et.it_332  ht.cy.zu_443 id.ms.so_644
  0x12533ba4, 0x19180b12, 0x4a641b08, 0x1b00070e,   // so.ht.hu_433 es.ga.gl_654  tr.lg.yo_443 it.tr.un_550
  // [6810]
  0x0f050208, 0x1c004a02, 0x1e002112, 0x551c20ad,   // da.fr.lv_443 yo.id.un_220  jw.ms.un_640 sq.id.rw_643
  0x3b1f0712, 0x2a1220ee, 0x353b100c, 0x06002804,   // it.cy.so_654 sq.hu.mt_422  lt.so.zu_543 sw.de.un_320
  0x0a53010c, 0x201105a9, 0x16290f0c, 0x532a3fad,   // en.ht.pt_543 fr.ro.sq_544  lv.sl.hr_543 af.mt.ht_643
  0x270608af, 0x321711a0, 0x551701a4, 0x20001b0e,   // no.de.gd_655 ro.sr.bs_322  en.sr.rw_433 tr.sq.un_550
  // [6820]
  0x04006b02, 0x202129a9, 0x53206404, 0x051c04a4,   // ceb.fi.un_220 sl.jw.sq_544  lg.sq.ht_332 fi.id.fr_433
  0x20102514, 0x25041a0c, 0x10000e0e, 0x0e000604,   // eu.lt.sq_666 tl.fi.eu_543  is.lt.un_550 de.is.un_320
  0x03213faf, 0x1110530d, 0x09021f12, 0x19051113,   // af.jw.nl_655 ht.lt.ro_554  cy.da.pl_654 ro.fr.gl_665
  0x27002d05, 0x01040512, 0x201f3fec, 0x253104ac,   // sk.gd.un_330 fr.fi.en_654  af.cy.sq_644 fi.az.eu_632
  // [6830]
  0x10252a07, 0x0e001f02, 0x080225af, 0x0c17120c,   // mt.eu.lt_432 cy.is.un_220  eu.da.no_655 hu.sr.sv_543
  0x0729120c, 0x1000280c, 0x171168a4, 0x0d000c04,   // hu.sl.it_543 sw.lt.un_530  ig.ro.sr_433 sv.cs.un_320
  0x133512ad, 0x11001b11, 0x020c13ac, 0x13204a04,   // hu.zu.et_643 tr.ro.un_630  et.sv.da_632 yo.sq.et_332
  0x320d1107, 0x080235ee, 0x12312813, 0x1e1c18a9,   // ro.cs.bs_432 zu.da.no_422  sw.az.hu_665 ga.id.ms_544
  // [6840]
  0x3211200c, 0x111b17a0, 0x172a2bee, 0x0c000521,   // sq.ro.bs_543 sr.tr.ro_322  vi.mt.sr_422 fr.sv.un_860
  0x170810ec, 0x0b003b08, 0x1f275307, 0x28200b02,   // be.uk.sr_644 so.es.un_430  ht.gd.cy_432 es.sq.sw_222
  0x286409a4, 0x020c0811, 0x291611ad, 0x16003f0c,   // pl.lg.sw_433 no.sv.da_653  ro.hr.sl_643 af.hr.un_530
  0x16023207, 0x11000c29, 0x100f2a60, 0x0209080c,   // bs.da.hr_432 sv.ro.un_960  mt.lv.lt_664 no.pl.da_543
  // [6850]
  0x29205309, 0x0c230aa9, 0x25202814, 0x0a2319ad,   // ht.sq.sl_444 pt.ca.sv_544  sw.sq.eu_666 gl.ca.pt_643
  0x09101fad, 0x1b102aad, 0x211c640c, 0x29251b07,   // cy.lt.pl_643 mt.lt.tr_643  lg.id.jw_543 tr.eu.sl_432
  0x13001014, 0x190a5202, 0x02002d21, 0x35520f0c,   // lt.et.un_660 ha.pt.gl_222  sk.da.un_860 lv.ha.zu_543
  0x130f280c, 0x270b2807, 0x230619a0, 0x2d0d18ba,   // sw.lv.et_543 sw.es.gd_432  gl.de.ca_322 ga.cs.sk_843
  // [6860]
  0x0468030c, 0x323564ac, 0x684a3505, 0x060701ad,   // nl.ig.fi_543 lg.zu.bs_632  zu.yo.ig_333 en.it.de_643
  0x6e2d2b0c, 0x64000705, 0x19130aec, 0x3f081c0c,   // vi.sk.hmn_543 it.lg.un_330  pt.et.gl_644 id.no.af_543
  0x0100062c, 0x08021a0e, 0x026e27a0, 0x00001f42,   // de.en.un_990 tl.da.no_555  gd.hmn.da_322 cy.un.un_C00
  0x044a350c, 0x09001702, 0x06000908, 0x25200612,   // zu.yo.fi_543 sr.pl.un_220  pl.de.un_430 de.sq.eu_654
  // [6870]
  0x070c2d07, 0x080418ad, 0x18000607, 0x17161ba0,   // sk.sv.it_432 ga.fi.no_643  de.ga.un_420 tr.hr.sr_322
  0x070c3bee, 0x1a1935ee, 0x4a002305, 0x0f203209,   // so.sv.it_422 zu.gl.tl_422  ca.yo.un_330 bs.sq.lv_444
  0x1b5253a9, 0x190c230c, 0x31006b29, 0x25230611,   // ht.ha.tr_544 ca.sv.gl_543  ceb.az.un_960 de.ca.eu_653
  0x0c0823ec, 0x4a000702, 0x3b1b4aa7, 0x081e0c11,   // ca.no.sv_644 it.yo.un_220  yo.tr.so_532 sv.ms.no_653
  // [6880]
  0x070435ee, 0x1a003f08, 0x28351e11, 0x0d311fa4,   // zu.fi.it_422 af.tl.un_430  ms.zu.sw_653 cy.az.cs_433
  0x3b2004a0, 0x1b071ca0, 0x110529ee, 0x070f01a4,   // fi.sq.so_322 id.it.tr_322  sl.fr.ro_422 en.lv.it_433
  0x0a122dee, 0x204a2308, 0x0806020d, 0x6e2a1faf,   // sk.hu.pt_422 ca.yo.sq_443  da.de.no_554 cy.mt.hmn_655
  0x1f132a0c, 0x3f00071a, 0x07000208, 0x13001121,   // mt.et.cy_543 it.af.un_760  da.it.un_430 ro.et.un_860
  // [6890]
  0x0e001e0d, 0x05005202, 0x230b0a05, 0x1a6e5204,   // ms.is.un_540 ha.fr.un_220  pt.es.ca_333 ha.hmn.tl_332
  0x050607ec, 0x0a252102, 0x2b1f200b, 0x2a12530c,   // it.de.fr_644 jw.eu.pt_222  sq.cy.vi_542 ht.hu.mt_543
  0x6b1e20ee, 0x3b001b13, 0x033f29a4, 0x31531208,   // sq.ms.ceb_422 tr.so.un_650  sl.af.nl_433 hu.ht.az_443
  0x3f4a530c, 0x25001f18, 0x08002313, 0x08024aa0,   // ht.yo.af_543 cy.eu.un_740  ca.no.un_650 yo.da.no_322
  // [68a0]
  0x1b3b6ba0, 0x3f001702, 0x11685307, 0x08050cee,   // ceb.so.tr_322 sr.af.un_220  ht.ig.ro_432 sv.fr.no_422
  0x3b1b6bad, 0x641f1baf, 0x1f19115a, 0x0c1f520c,   // ceb.tr.so_643 tr.cy.lg_655  ro.gl.cy_553 ha.cy.sv_543
  0x1f2d53a7, 0x1e351c0c, 0x0d532d0c, 0x1e000205,   // ht.sk.cy_532 id.zu.ms_543  sk.ht.cs_543 da.ms.un_330
  0x10180c07, 0x2b31530c, 0x1c00010d, 0x0d1b3f0c,   // sv.ga.lt_432 ht.az.vi_543  en.id.un_540 af.tr.cs_543
  // [68b0]
  0x03124aee, 0x12051ba4, 0x2a070612, 0x0b2d1955,   // yo.hu.nl_422 tr.fr.hu_433  de.it.mt_654 gl.sk.es_442
  0x190b3502, 0x290525ad, 0x1c061eee, 0x1900250d,   // zu.es.gl_222 eu.fr.sl_643  ms.de.id_422 eu.gl.un_540
  0x231105a7, 0x12250560, 0x0b191811, 0x210535ee,   // fr.ro.ca_532 fr.eu.hu_664  ga.gl.es_653 zu.fr.jw_422
  0x20051b55, 0x6400200d, 0x1105255a, 0x25001707,   // tr.fr.sq_442 sq.lg.un_540  eu.fr.ro_553 sr.eu.un_420
  // [68c0]
  0x6b000304, 0x162909a9, 0x3f030daf, 0x21070fec,   // nl.ceb.un_320 pl.sl.hr_544  cs.nl.af_655 lv.it.jw_644
  0x1620100c, 0x523b0bee, 0x1a4a6bec, 0x0d091c09,   // lt.sq.hr_543 es.so.ha_422  ceb.yo.tl_644 mr.hi.ne_444
  0x0f531014, 0x3f031a0c, 0x1a104aad, 0x051127a0,   // lt.ht.lv_666 tl.nl.af_543  yo.lt.tl_643 gd.ro.fr_322
  0x3229160c, 0x08000604, 0x07181108, 0x072d1fa0,   // hr.sl.bs_543 de.no.un_320  ro.ga.it_443 cy.sk.it_322
  // [68d0]
  0x126403a0, 0x3b1f1aa7, 0x1a0a6b09, 0x081302ec,   // nl.lg.hu_322 tl.cy.so_532  ceb.pt.tl_444 da.et.no_644
  0x1e1c0ba0, 0x27000408, 0x1a533512, 0x13001019,   // es.id.ms_322 fi.gd.un_430  zu.ht.tl_654 lt.et.un_750
  0x09030fa0, 0x10521a0d, 0x1f52100d, 0x06056e02,   // lv.nl.pl_322 tl.ha.lt_554  lt.ha.cy_554 hmn.fr.de_222
  0x136e1aad, 0x0c1e0211, 0x12111007, 0x21351fa0,   // tl.hmn.et_643 da.ms.sv_653  lt.ro.hu_432 cy.zu.jw_322
  // [68e0]
  0x190a1eee, 0x13013ba7, 0x3b3f6405, 0x070d0e07,   // ms.pt.gl_422 so.en.et_532  lg.af.so_333 is.cs.it_432
  0x29170f0c, 0x274a6808, 0x0a001809, 0x3b006e20,   // lv.sr.sl_543 ig.yo.gd_443  ga.pt.un_440 hmn.so.un_850
  0x2b1a52a0, 0x0f130460, 0x0802060e, 0x522a68af,   // ha.tl.vi_322 fi.et.lv_664  de.da.no_555 ig.mt.ha_655
  0x3f080b0c, 0x1a0328a9, 0x203b31ad, 0x0b0208ac,   // es.no.af_543 sw.nl.tl_544  az.so.sq_643 no.da.es_632
  // [68f0]
  0x062b11ec, 0x090d1fad, 0x251811af, 0x32201b08,   // ro.vi.de_644 cy.cs.pl_643  ro.ga.eu_655 tr.sq.bs_443
  0x071011ee, 0x6e00190d, 0x010c230c, 0x52256b12,   // ro.be.bg_422 gl.hmn.un_540  ca.sv.en_543 ceb.eu.ha_654
  0x4a6b2b0d, 0x023f060c, 0x311b0505, 0x554a2812,   // vi.ceb.yo_554 de.af.da_543  fr.tr.az_333 sw.yo.rw_654
  0x52002a36, 0x012706a0, 0x0c1f1c02, 0x6b312155,   // mt.ha.un_AA0 de.gd.en_322  id.cy.sv_222 jw.az.ceb_442
  // [6900]
  0x1304310c, 0x00000e37, 0x03251bee, 0x0a23210d,   // az.fi.et_543 is.un.un_B00  tr.eu.nl_422 jw.ca.pt_554
  0x211b5507, 0x1a3521ee, 0x0d002107, 0x04000113,   // rw.tr.jw_432 jw.zu.tl_422  jw.cs.un_420 en.fi.un_650
  0x02061fee, 0x072501ad, 0x1f016ba0, 0x552125a4,   // cy.de.da_422 en.eu.it_643  ceb.en.cy_322 eu.jw.rw_433
  0x6806250c, 0x290d6e0c, 0x3b00250d, 0x21255213,   // eu.de.ig_543 hmn.cs.sl_543  eu.so.un_540 ha.eu.jw_665
  // [6910]
  0x1e1c0f14, 0x10003f0c, 0x18000c07, 0x126413ee,   // lv.id.ms_666 af.lt.un_530  sv.ga.un_420 et.lg.hu_422
  0x083b0204, 0x353b2d07, 0x1b00190d, 0x52040360,   // da.so.no_332 sk.so.zu_432  gl.tr.un_540 nl.fi.ha_664
  0x072a1e11, 0x523118a4, 0x20551008, 0x55281b13,   // ms.mt.it_653 ga.az.ha_433  lt.rw.sq_443 tr.sw.rw_665
  0x256b2da4, 0x52001b1a, 0x1c171ea0, 0x102a550d,   // sk.ceb.eu_433 tr.ha.un_760  ms.sr.id_322 rw.mt.lt_554
  // [6920]
  0x321628a4, 0x01000b02, 0x04526405, 0x53212bad,   // sw.hr.bs_433 es.en.un_220  lg.ha.fi_333 vi.jw.ht_643
  0x2932350c, 0x2a0964af, 0x6e2b2807, 0x0b2307a0,   // zu.bs.sl_543 lg.pl.mt_655  sw.vi.hmn_432 it.ca.es_322
  0x1e1c2aec, 0x213b1b0c, 0x35281ba4, 0x6b01180e,   // mt.id.ms_644 tr.so.jw_543  tr.sw.zu_433 ga.en.ceb_555
  0x130e0407, 0x1b1025a0, 0x31111b07, 0x6b0a55a0,   // fi.is.et_432 eu.lt.tr_322  tr.ro.az_432 rw.pt.ceb_322
  // [6930]
  0x311b5212, 0x023f20ac, 0x1213170c, 0x522b11a0,   // ha.tr.az_654 sq.af.da_632  sr.et.hu_543 ro.vi.ha_322
  0x070527a4, 0x201216ee, 0x1b002d19, 0x291b2d0c,   // gd.fr.it_433 hr.hu.sq_422  sk.tr.un_750 sk.tr.sl_543
  0x35552a60, 0x2d200d12, 0x0a0807ee, 0x1100102b,   // mt.rw.zu_664 cs.sq.sk_654  bg.uk.mk_422 be.ro.un_980
  0x2d291fa4, 0x53201b0c, 0x2900171a, 0x1b003f04,   // cy.sl.sk_433 tr.sq.ht_543  sr.sl.un_760 af.tr.un_320
  // [6940]
  0x3100210c, 0x162953a7, 0x1a3b6413, 0x190b05ec,   // jw.az.un_530 ht.sl.hr_532  lg.so.tl_665 fr.es.gl_644
  0x102901a0, 0x180a32a0, 0x08022d0c, 0x03006818,   // en.sl.lt_322 bs.pt.ga_322  sk.da.no_543 ig.nl.un_740
  0x13684a04, 0x181912a9, 0x1e1a1c07, 0x100364ad,   // yo.ig.et_332 hu.gl.ga_544  id.tl.ms_432 lg.nl.lt_643
  0x0d1918a4, 0x2823530d, 0x271820af, 0x206e6ba0,   // ga.gl.cs_433 ht.ca.sw_554  sq.ga.gd_655 ceb.hmn.sq_322
  // [6950]
  0x0d122d04, 0x0d1912ec, 0x3f02010c, 0x190b1209,   // sk.hu.cs_332 hu.gl.cs_644  en.da.af_543 hu.es.gl_444
  0x190b2da4, 0x194a0b07, 0x12184a13, 0x13001a34,   // sk.es.gl_433 es.yo.gl_432  yo.ga.hu_665 tl.et.un_A80
  0x4a2a0d12, 0x1f006e07, 0x255521af, 0x19270aad,   // cs.mt.yo_654 hmn.cy.un_420  jw.rw.eu_655 pt.gd.gl_643
  0x0a0c27ad, 0x020601af, 0x234a2bad, 0x31553555,   // gd.sv.pt_643 en.de.da_655  vi.yo.ca_643 zu.rw.az_442
  // [6960]
  0x2d002a02, 0x20001c02, 0x04001f18, 0x6b2818ad,   // mt.sk.un_220 id.sq.un_220  cy.fi.un_740 ga.sw.ceb_643
  0x074a2712, 0x0500520c, 0x03000104, 0x02086ea7,   // gd.yo.it_654 ha.fr.un_530  en.nl.un_320 hmn.no.da_532
  0x1b005211, 0x0c00270e, 0x2b274aec, 0x2a002d12,   // ha.tr.un_630 gd.sv.un_550  yo.gd.vi_644 sk.mt.un_640
  0x130e0f04, 0x10005202, 0x6b251a13, 0x01000807,   // lv.is.et_332 ha.lt.un_220  tl.eu.ceb_665 no.en.un_420
  // [6970]
  0x3b250ca4, 0x06020eee, 0x64000e14, 0x1b000302,   // sv.eu.so_433 is.da.de_422  is.lg.un_660 nl.tr.un_220
  0x53000d22, 0x20080caf, 0x1b0c08af, 0x535520a0,   // cs.ht.un_870 sv.no.sq_655  no.sv.tr_655 sq.rw.ht_322
  0x64066ba7, 0x322d6ea0, 0x53000d20, 0x061304a7,   // ceb.de.lg_532 hmn.sk.bs_322  cs.ht.un_850 fi.et.de_532
  0x351b04af, 0x550635a0, 0x25554a09, 0x201f6807,   // fi.tr.zu_655 zu.de.rw_322  yo.rw.eu_444 ig.cy.sq_432
  // [6980]
  0x25104aee, 0x06296e13, 0x28001b1b, 0x170a08ec,   // yo.lt.eu_422 hmn.sl.de_665  tr.sw.un_770 uk.mk.sr_644
  0x5306640d, 0x1e1c28a9, 0x12184aec, 0x231128a4,   // lg.de.ht_554 sw.id.ms_544  yo.ga.hu_644 sw.ro.ca_433
  0x531a0111, 0x19350a60, 0x3200110c, 0x0a191155,   // en.tl.ht_653 pt.zu.gl_664  ro.bs.un_530 ro.gl.pt_442
  0x1c1e21a7, 0x13253fa4, 0x1b000913, 0x106828ad,   // jw.ms.id_532 af.eu.et_433  pl.tr.un_650 sw.ig.lt_643
  // [6990]
  0x32292dad, 0x32252da4, 0x0e0302a4, 0x3216110c,   // sk.sl.bs_643 sk.eu.bs_433  da.nl.is_433 ro.hr.bs_543
  0x23006e21, 0x1a003f14, 0x050420ee, 0x28552a05,   // hmn.ca.un_860 af.tl.un_660  sq.fi.fr_422 mt.rw.sw_333
  0x3b023faf, 0x1e0d1cad, 0x2b001219, 0x08113f60,   // af.da.so_655 id.cs.ms_643  hu.vi.un_750 af.ro.no_664
  0x3f000221, 0x3f021107, 0x17001612, 0x096b28a4,   // da.af.un_860 ro.da.af_432  hr.sr.un_640 sw.ceb.pl_433
  // [69a0]
  0x0f271005, 0x1a001011, 0x1c1309ac, 0x4a001c0e,   // lt.gd.lv_333 lt.tl.un_630  hi.bh.mr_632 id.yo.un_550
  0x35005312, 0x0e0c130c, 0x0f05100c, 0x105313af,   // ht.zu.un_640 et.sv.is_543  lt.fr.lv_543 et.ht.lt_655
  0x06530e0c, 0x130406a0, 0x1c1e2108, 0x08021e09,   // is.ht.de_543 de.fi.et_322  jw.ms.id_443 ms.da.no_444
  0x08021cee, 0x2b074a12, 0x2a350707, 0x072b4a12,   // id.da.no_422 yo.it.vi_654  it.zu.mt_432 yo.vi.it_654
  // [69b0]
  0x033564af, 0x04000604, 0x6b09350d, 0x4a1c2512,   // lg.zu.nl_655 de.fi.un_320  zu.pl.ceb_554 eu.id.yo_654
  0x13020ea4, 0x28136b09, 0x162d21a9, 0x07640507,   // is.da.et_433 ceb.et.sw_444  jw.sk.hr_544 fr.lg.it_432
  0x050b01af, 0x0b0a2109, 0x110607ec, 0x0e3f2aee,   // en.es.fr_655 jw.pt.es_444  it.de.ro_644 mt.af.is_422
  0x202a32a4, 0x072155a9, 0x1c1e5508, 0x2d0d1805,   // bs.mt.sq_433 rw.jw.it_544  rw.ms.id_443 ga.cs.sk_333
  // [69c0]
  0x2b68280d, 0x32171ca4, 0x0c031304, 0x0f4a1013,   // sw.ig.vi_554 id.sr.bs_433  et.nl.sv_332 lt.yo.lv_665
  0x0d131c11, 0x1b001308, 0x35552804, 0x2a071e12,   // mr.bh.ne_653 et.tr.un_430  sw.rw.zu_332 ms.it.mt_654
  0x68002512, 0x0f4a2707, 0x1c001804, 0x1e2104a0,   // eu.ig.un_640 gd.yo.lv_432  ga.id.un_320 fi.jw.ms_322
  0x1f001307, 0x03002907, 0x35010fa4, 0x53000f19,   // et.cy.un_420 sl.nl.un_420  lv.en.zu_433 lv.ht.un_750
  // [69d0]
  0x32173fa0, 0x31001302, 0x100b1ca4, 0x0a07680c,   // af.sr.bs_322 et.az.un_220  id.es.lt_433 ig.it.pt_543
  0x285268ad, 0x23090ba0, 0x29100f04, 0x1b000d0d,   // ig.ha.sw_643 es.pl.ca_322  lv.lt.sl_332 cs.tr.un_540
  0x170b1c07, 0x3f111307, 0x6e3153a7, 0x0b000c05,   // id.es.sr_432 et.ro.af_432  ht.az.hmn_532 sv.es.un_330
  0x4a001205, 0x020c11a4, 0x20523b07, 0x1f00211a,   // hu.yo.un_330 ro.sv.da_433  so.ha.sq_432 jw.cy.un_760
  // [69e0]
  0x08021ea0, 0x211a68a4, 0x25190c07, 0x01643f0c,   // ms.da.no_322 ig.tl.jw_433  sv.gl.eu_432 af.lg.en_543
  0x3f131e0c, 0x28006805, 0x01060509, 0x23071ea4,   // ms.et.af_543 ig.sw.un_330  fr.de.en_444 ms.it.ca_433
  0x041307af, 0x12190508, 0x1e1c21ac, 0x04523514,   // it.et.fi_655 fr.gl.hu_443  jw.id.ms_632 zu.ha.fi_666
  0x0c280f07, 0x1c1e525a, 0x030611a9, 0x096b53a7,   // lv.sw.sv_432 ha.ms.id_553  ro.de.nl_544 ht.ceb.pl_532
  // [69f0]
  0x1e1c29a4, 0x11061fa7, 0x11000304, 0x4a00350c,   // sl.id.ms_433 cy.de.ro_532  nl.ro.un_320 zu.yo.un_530
  0x033f2004, 0x3b2028a0, 0x200613ad, 0x1e1c11a9,   // sq.af.nl_332 sw.sq.so_322  et.de.sq_643 ro.id.ms_544
  0x1f002d08, 0x3f00040c, 0x19210ba4, 0x2a002702,   // sk.cy.un_430 fi.af.un_530  es.jw.gl_433 gd.mt.un_220
  0x1c1b27ee, 0x0b272307, 0x25313b08, 0x0e0c4a5a,   // gd.tr.id_422 ca.gd.es_432  so.az.eu_443 yo.sv.is_553
  // [6a00]
  0x1c251e12, 0x4a130e11, 0x0205080c, 0x29111e0b,   // ms.eu.id_654 is.et.yo_653  no.fr.da_543 ms.ro.sl_542
  0x0d292da4, 0x130523a9, 0x0c0f230c, 0x12135304,   // sk.sl.cs_433 ca.fr.et_544  ca.lv.sv_543 ht.et.hu_332
  0x27183f14, 0x103b0f12, 0x12532304, 0x0807175a,   // af.ga.gd_666 lv.so.lt_654  ca.ht.hu_332 sr.bg.uk_553
  0x0e033f13, 0x2b0125ee, 0x292311ac, 0x5331130c,   // af.nl.is_665 eu.en.vi_422  ro.ca.sl_632 et.az.ht_543
  // [6a10]
  0x2d0d0a14, 0x5313020c, 0x533b130c, 0x080209ad,   // pt.cs.sk_666 da.et.ht_543  et.so.ht_543 pl.da.no_643
  0x3f0613ad, 0x05533fee, 0x07000e04, 0x016b1305,   // et.de.af_643 af.ht.fr_422  is.it.un_320 et.ceb.en_333
  0x29002a2b, 0x0a2027a0, 0x4a006b0c, 0x3b133108,   // mt.sl.un_980 gd.sq.pt_322  ceb.yo.un_530 az.et.so_443
  0x0e0c4aa0, 0x1e6e3ba0, 0x02002907, 0x13043b02,   // yo.sv.is_322 so.hmn.ms_322  sl.da.un_420 so.fi.et_222
  // [6a20]
  0x32191f08, 0x19231108, 0x6b113bec, 0x0f161713,   // cy.gl.bs_443 ro.ca.gl_443  so.ro.ceb_644 sr.hr.lv_665
  0x29006404, 0x55286402, 0x0b001a04, 0x1c2d1ea0,   // lg.sl.un_320 lg.sw.rw_222  tl.es.un_320 ms.sk.id_322
  0x1a1e10a4, 0x0e1c06a9, 0x103f0fac, 0x1e1c1fa4,   // lt.ms.tl_433 de.id.is_544  lv.af.lt_632 cy.id.ms_433
  0x6e003b19, 0x13551205, 0x0f003114, 0x0b003b05,   // so.hmn.un_750 hu.rw.et_333  az.lv.un_660 so.es.un_330
  // [6a30]
  0x21641a0c, 0x061353a6, 0x2a0619a0, 0x13002319,   // tl.lg.jw_543 ht.et.de_521  gl.de.mt_322 ca.et.un_750
  0x1c3564a9, 0x21291855, 0x6b0110a0, 0x032806ad,   // lg.zu.id_544 ga.sl.jw_442  lt.en.ceb_322 de.sw.nl_643
  0x192a0b07, 0x0b0a32a0, 0x321e17ee, 0x16001b04,   // es.mt.gl_432 bs.pt.es_322  sr.ms.bs_422 tr.hr.un_320
  0x02530807, 0x310f10a0, 0x28680e05, 0x531225a7,   // no.ht.da_432 lt.lv.az_322  is.ig.sw_333 eu.hu.ht_532
  // [6a40]
  0x523f3b07, 0x133b0b02, 0x35000920, 0x4a2825ad,   // so.af.ha_432 es.so.et_222  pl.zu.un_850 eu.sw.yo_643
  0x09524aee, 0x07001b21, 0x09252da9, 0x16354aa0,   // yo.ha.pl_422 tr.it.un_860  sk.eu.pl_544 yo.zu.hr_322
  0x216b1c5a, 0x28005312, 0x31531b0c, 0x183b095a,   // id.ceb.jw_553 ht.sw.un_640  tr.ht.az_543 pl.so.ga_553
  0x2d0d250c, 0x163b35a0, 0x1a6e28ec, 0x311b0405,   // eu.cs.sk_543 zu.so.hr_322  sw.hmn.tl_644 fi.tr.az_333
  // [6a50]
  0x552a3512, 0x1e160ea4, 0x02280807, 0x32006b20,   // zu.mt.rw_654 is.hr.ms_433  no.sw.da_432 ceb.bs.un_850
  0x12040f0d, 0x0e10190c, 0x0a001817, 0x21000c23,   // lv.fi.hu_554 gl.lt.is_543  ga.pt.un_730 sv.jw.un_880
  0x10230eaf, 0x2d0d5502, 0x23520ca4, 0x1b121f0c,   // is.ca.lt_655 rw.cs.sk_222  sv.ha.ca_433 cy.hu.tr_543
  0x03291313, 0x071306ee, 0x646855a9, 0x020d08ee,   // et.sl.nl_665 de.et.it_422  rw.ig.lg_544 no.cs.da_422
  // [6a60]
  0x35556bec, 0x100f1fac, 0x20006818, 0x07002d04,   // ceb.rw.zu_644 cy.lv.lt_632  ig.sq.un_740 sk.it.un_320
  0x2112230c, 0x311202ee, 0x645553ec, 0x050207a0,   // ca.hu.jw_543 da.hu.az_422  ht.rw.lg_644 it.da.fr_322
  0x090f01a4, 0x0720080c, 0x31182aa7, 0x18121baf,   // en.lv.pl_433 no.sq.it_543  mt.ga.az_532 tr.hu.ga_655
  0x28000619, 0x192311a7, 0x53001012, 0x230f0b13,   // de.sw.un_750 ro.ca.gl_532  lt.ht.un_640 es.lv.ca_665
  // [6a70]
  0x27000a08, 0x0a002102, 0x3b1c5212, 0x110723ad,   // pt.gd.un_430 jw.pt.un_220  ha.id.so_654 ca.it.ro_643
  0x19000412, 0x522a1ea9, 0x120e520e, 0x52001e22,   // fi.gl.un_640 ms.mt.ha_544  ha.is.hu_555 ms.ha.un_870
  0x051104ad, 0x191c11ee, 0x0d212aec, 0x6b12070d,   // fi.ro.fr_643 ro.id.gl_422  mt.jw.cs_644 it.hu.ceb_554
  0x25003b12, 0x013b07ac, 0x0a29070c, 0x3b27280c,   // so.eu.un_640 it.so.en_632  it.sl.pt_543 sw.gd.so_543
  // [6a80]
  0x3f086eee, 0x32170f05, 0x032b0c08, 0x2700022a,   // hmn.no.af_422 lv.sr.bs_333  sv.vi.nl_443 da.gd.un_970
  0x05202509, 0x0b002302, 0x13014aee, 0x10000d04,   // eu.sq.fr_444 ca.es.un_220  yo.en.et_422 cs.lt.un_320
  0x25040ea4, 0x1929070c, 0x17131ba4, 0x13005314,   // is.fi.eu_433 it.sl.gl_543  tr.et.sr_433 ht.et.un_660
  0x0e4a0b08, 0x172855ee, 0x2852640c, 0x531129a0,   // es.yo.is_443 rw.sw.sr_422  lg.ha.sw_543 sl.ro.ht_322
  // [6a90]
  0x1e1c0a02, 0x12000314, 0x6e002d08, 0x16641bec,   // pt.id.ms_222 nl.hu.un_660  sk.hmn.un_430 tr.lg.hr_644
  0x04002012, 0x6b042007, 0x2a1b3113, 0x0a001b1a,   // sq.fi.un_640 sq.fi.ceb_432  az.tr.mt_665 tr.pt.un_760
  0x073525a0, 0x291f2da0, 0x253f1307, 0x0b0a1ca0,   // eu.zu.it_322 sk.cy.sl_322  et.af.eu_432 id.pt.es_322
  0x13043fac, 0x25353fa4, 0x64043b04, 0x190a2312,   // af.fi.et_632 af.zu.eu_433  so.fi.lg_332 ca.pt.gl_654
  // [6aa0]
  0x1b170907, 0x05000d0d, 0x32091004, 0x52641ca0,   // pl.sr.tr_432 cs.fr.un_540  lt.pl.bs_332 id.lg.ha_322
  0x030e0f07, 0x190b05a0, 0x2b002323, 0x1e1c2111,   // lv.is.nl_432 fr.es.gl_322  ca.vi.un_880 jw.id.ms_653
  0x1752550c, 0x04293b08, 0x2564290c, 0x322916ee,   // rw.ha.sr_543 so.sl.fi_443  sl.lg.eu_543 hr.sl.bs_422
  0x08023fec, 0x290d01a9, 0x124a2aa0, 0x18272a04,   // af.da.no_644 en.cs.sl_544  mt.yo.hu_322 mt.gd.ga_332
  // [6ab0]
  0x092d25a0, 0x310e0111, 0x4a3b1ba7, 0x252d0909,   // eu.sk.pl_322 en.is.az_653  tr.so.yo_532 pl.sk.eu_444
  0x0f0c3fa9, 0x09522da4, 0x080227a4, 0x093552a9,   // af.sv.lv_544 sk.ha.pl_433  gd.da.no_433 ha.zu.pl_544
  0x275302ad, 0x042053a7, 0x21201cee, 0x3b2531ad,   // da.ht.gd_643 ht.sq.fi_532  id.sq.jw_422 az.eu.so_643
  0x10003102, 0x520c23ec, 0x0b236b05, 0x130f0c02,   // az.lt.un_220 ca.sv.ha_644  ceb.ca.es_333 sv.lv.et_222
  // [6ac0]
  0x0f100a11, 0x3b1b10a9, 0x1a5513a4, 0x07002702,   // pt.lt.lv_653 lt.tr.so_544  et.rw.tl_433 gd.it.un_220
  0x0f276bee, 0x35000e19, 0x086b2aee, 0x1c1b1e0d,   // ceb.gd.lv_422 is.zu.un_750  mt.ceb.no_422 ms.tr.id_554
  0x17293b0c, 0x25000718, 0x033b1ba9, 0x02000702,   // so.sl.sr_543 it.eu.un_740  tr.so.nl_544 it.da.un_220
  0x3f5213af, 0x090d3105, 0x012806a0, 0x316b13ee,   // et.ha.af_655 az.cs.pl_333  de.sw.en_322 et.ceb.az_422
  // [6ad0]
  0x040c1312, 0x1a005204, 0x29520f55, 0x011b55a0,   // et.sv.fi_654 ha.tl.un_320  lv.ha.sl_442 rw.tr.en_322
  0x1f683ba7, 0x0a002a02, 0x11002811, 0x041b640b,   // so.ig.cy_532 mt.pt.un_220  sw.ro.un_630 lg.tr.fi_542
  0x1a00102a, 0x641f0607, 0x6b1f55ee, 0x23552107,   // lt.tl.un_970 de.cy.lg_432  rw.cy.ceb_422 jw.rw.ca_432
  0x681e550c, 0x35001c13, 0x03520ead, 0x0353010c,   // rw.ms.ig_543 id.zu.un_650  is.ha.nl_643 en.ht.nl_543
  // [6ae0]
  0x08020c07, 0x0b6e2012, 0x4a1805af, 0x0b530fee,   // sv.da.no_432 sq.hmn.es_654  fr.ga.yo_655 lv.ht.es_422
  0x21182b13, 0x280f2aa9, 0x53000a08, 0x11055214,   // vi.ga.jw_665 mt.lv.sw_544  pt.ht.un_430 ha.fr.ro_666
  0x1e1c28a6, 0x4a531f14, 0x4a0c64a9, 0x080264a0,   // sw.id.ms_521 cy.ht.yo_666  lg.sv.yo_544 lg.da.no_322
  0x534a640e, 0x6b681f07, 0x314a250c, 0x12171609,   // lg.yo.ht_555 cy.ig.ceb_432  eu.yo.az_543 hr.sr.hu_444
  // [6af0]
  0x4a001135, 0x1c171eec, 0x231302a4, 0x3f532013,   // ro.yo.un_A90 ms.sr.id_644  da.et.ca_433 sq.ht.af_665
  0x1a016ba0, 0x324a2aa0, 0x23112aac, 0x06291105,   // ceb.en.tl_322 mt.yo.bs_322  mt.ro.ca_632 ro.sl.de_333
  0x1a6b20ee, 0x04553ba0, 0x0d162dac, 0x6b180ca0,   // sq.ceb.tl_422 so.rw.fi_322  sk.hr.cs_632 sv.ga.ceb_322
  0x016813a0, 0x550e3508, 0x1f002b11, 0x010605ee,   // et.ig.en_322 zu.is.rw_443  vi.cy.un_630 fr.de.en_422
  // [6b00]
  0x123b1aac, 0x052853a9, 0x131a1f02, 0x27003b2b,   // tl.so.hu_632 ht.sw.fr_544  cy.tl.et_222 so.gd.un_980
  0x1c0b180c, 0x1800680c, 0x020507ec, 0x522328a4,   // ga.es.id_543 ig.ga.un_530  it.fr.da_644 sw.ca.ha_433
  0x645312ec, 0x1f2b18ee, 0x31521bec, 0x030d3f0e,   // hu.ht.lg_644 ga.vi.cy_422  tr.ha.az_644 af.cs.nl_555
  0x10001b1b, 0x12000e07, 0x00001837, 0x293564af,   // tr.lt.un_770 is.hu.un_420  ar.un.un_B00 lg.zu.sl_655
  // [6b10]
  0x021708a9, 0x1a350ea4, 0x1e1221a0, 0x551a1b0c,   // no.sr.da_544 is.zu.tl_433  jw.hu.ms_322 tr.tl.rw_543
  0x02005302, 0x255528a9, 0x1b552908, 0x13001004,   // ht.da.un_220 sw.rw.eu_544  sl.rw.tr_443 lt.et.un_320
  0x06082aa0, 0x01111b0c, 0x351b4aa0, 0x04030d05,   // mt.no.de_322 tr.ro.en_543  yo.tr.zu_322 cs.nl.fi_333
  0x0b000420, 0x2d0d53a0, 0x531905ee, 0x55000913,   // fi.es.un_850 ht.cs.sk_322  fr.gl.ht_422 pl.rw.un_650
  // [6b20]
  0x3f0503a0, 0x0c230409, 0x21003104, 0x28530111,   // nl.fr.af_322 fi.ca.sv_444  az.jw.un_320 en.ht.sw_653
  0x01535502, 0x55351baf, 0x20002312, 0x060e29a6,   // rw.ht.en_222 tr.zu.rw_655  ca.sq.un_640 sl.is.de_521
  0x0b000e07, 0x211c3513, 0x100d2dee, 0x64001a13,   // is.es.un_420 zu.id.jw_665  sk.cs.lt_422 tl.lg.un_650
  0x55001e02, 0x1c062007, 0x190d20a0, 0x200805a0,   // ms.rw.un_220 sq.de.id_432  sq.cs.gl_322 fr.no.sq_322
  // [6b30]
  0x07053ba0, 0x081004ac, 0x2d0d07ee, 0x090f2955,   // so.fr.it_322 ru.be.uk_632  it.cs.sk_422 sl.lv.pl_442
  0x311b0fa0, 0x01000404, 0x0d2d2107, 0x1b2a35a7,   // lv.tr.az_322 fi.en.un_320  jw.sk.cs_432 zu.mt.tr_532
  0x18192705, 0x130464a0, 0x281223ee, 0x06006402,   // gd.gl.ga_333 lg.fi.et_322  ca.hu.sw_422 lg.de.un_220
  0x31091b04, 0x2b000307, 0x07000811, 0x07012a14,   // tr.pl.az_332 nl.vi.un_420  uk.bg.un_630 mt.en.it_666
  // [6b40]
  0x1c001704, 0x2b001019, 0x10170709, 0x21536405,   // sr.id.un_320 lt.vi.un_750  bg.sr.be_444 lg.ht.jw_333
  0x643135af, 0x03532702, 0x532507a9, 0x0e270c55,   // zu.az.lg_655 gd.ht.nl_222  it.eu.ht_544 sv.gd.is_442
  0x2d005504, 0x6e003512, 0x35283f09, 0x2a006414,   // rw.sk.un_320 zu.hmn.un_640  af.sw.zu_444 lg.mt.un_660
  0x31000302, 0x13002a09, 0x1c162bee, 0x0b2868ee,   // nl.az.un_220 mt.et.un_440  vi.hr.id_422 ig.sw.es_422
  // [6b50]
  0x1c003f02, 0x2d0d2502, 0x53000912, 0x21000504,   // af.id.un_220 eu.cs.sk_222  pl.ht.un_640 fr.jw.un_320
  0x3568060d, 0x060b2804, 0x080602a0, 0x1e1c0308,   // de.ig.zu_554 sw.es.de_332  da.de.no_322 nl.id.ms_443
  0x0d6e1ca0, 0x3b006420, 0x20001608, 0x0f000407,   // id.hmn.cs_322 lg.so.un_850  hr.sq.un_430 fi.lv.un_420
  0x04000519, 0x0f102907, 0x05005335, 0x2d0d050c,   // fr.fi.un_750 sl.lt.lv_432  ht.fr.un_A90 fr.cs.sk_543
  // [6b60]
  0x100f0313, 0x35316402, 0x0700030e, 0x25091013,   // nl.lv.lt_665 lg.az.zu_222  nl.it.un_550 lt.pl.eu_665
  0x091153ad, 0x0a0512bb, 0x290f350c, 0x2a2564ec,   // ht.ro.pl_643 hu.fr.pt_854  zu.lv.sl_543 lg.eu.mt_644
  0x64002d13, 0x06040504, 0x64520409, 0x21006402,   // sk.lg.un_650 fr.fi.de_332  fi.ha.lg_444 lg.jw.un_220
  0x31003507, 0x1e000404, 0x042010af, 0x532a4aa0,   // zu.az.un_420 fi.ms.un_320  lt.sq.fi_655 yo.mt.ht_322
  // [6b70]
  0x170a2111, 0x321768ac, 0x11522508, 0x1b003102,   // jw.pt.sr_653 ig.sr.bs_632  eu.ha.ro_443 az.tr.un_220
  0x18030612, 0x132d29a0, 0x1e211ca7, 0x31251bec,   // de.nl.ga_654 sl.sk.et_322  id.jw.ms_532 tr.eu.az_644
  0x321f0ead, 0x1e1c2da4, 0x53004a0b, 0x35315502,   // is.cy.bs_643 sk.id.ms_433  yo.ht.un_520 rw.az.zu_222
  0x0e211b0c, 0x530f0514, 0x0d13090b, 0x130420a0,   // tr.jw.is_543 fr.lv.ht_666  hi.bh.ne_542 sq.fi.et_322
  // [6b80]
  0x13005202, 0x16005304, 0x13002304, 0x0a002804,   // ha.et.un_220 ht.hr.un_320  ca.et.un_320 sw.pt.un_320
  0x64094a09, 0x23003505, 0x0f5529a0, 0x190b2907,   // yo.pl.lg_444 zu.ca.un_330  sl.rw.lv_322 sl.es.gl_432
  0x55006812, 0x040b530c, 0x53002521, 0x3f6403a0,   // ig.rw.un_640 ht.es.fi_543  eu.ht.un_860 nl.lg.af_322
  0x0b0528a7, 0x52003f04, 0x101b1112, 0x1c003504,   // sw.fr.es_532 af.ha.un_320  ro.tr.lt_654 zu.id.un_320
  // [6b90]
  0x182721a9, 0x213b1aaf, 0x53002702, 0x2d1235af,   // jw.gd.ga_544 tl.so.jw_655  gd.ht.un_220 zu.hu.sk_655
  0x520625ec, 0x0d000b04, 0x20553513, 0x07001e0d,   // eu.de.ha_644 es.cs.un_320  zu.rw.sq_665 ms.it.un_540
  0x1b121aa7, 0x210e1a09, 0x311b1cec, 0x07001e02,   // tl.hu.tr_532 tl.is.jw_444  id.tr.az_644 ms.it.un_220
  0x21203b0d, 0x25115309, 0x2d0d25af, 0x18000b02,   // so.sq.jw_554 ht.ro.eu_444  eu.cs.sk_655 es.ga.un_220
  // [6ba0]
  0x1e1f1c0c, 0x6b52090c, 0x2a0703a0, 0x08022302,   // id.cy.ms_543 pl.ha.ceb_543  nl.it.mt_322 ca.da.no_222
  0x08020e14, 0x16296b07, 0x3b000b02, 0x52002119,   // is.da.no_666 ceb.sl.hr_432  es.so.un_220 jw.ha.un_750
  0x0f000e09, 0x13252d08, 0x551005a0, 0x0c0802ee,   // is.lv.un_440 sk.eu.et_443  fr.lt.rw_322 da.no.sv_422
  0x3509040d, 0x06083fa0, 0x0a0f6b07, 0x2d0d3ba4,   // fi.pl.zu_554 af.no.de_322  ceb.lv.pt_432 so.cs.sk_433
  // [6bb0]
  0x0c030612, 0x09066413, 0x12202114, 0x061e21a9,   // de.nl.sv_654 lg.de.pl_665  jw.sq.hu_666 jw.ms.de_544
  0x64001a34, 0x1e1c2308, 0x320d17a0, 0x03002318,   // tl.lg.un_A80 ca.id.ms_443  sr.cs.bs_322 ca.nl.un_740
  0x2a276ba7, 0x32002013, 0x122135af, 0x040710a6,   // ceb.gd.mt_532 sq.bs.un_650  zu.jw.hu_655 be.bg.ru_521
  0x110427a9, 0x06000919, 0x21353b04, 0x00006b37,   // gd.fi.ro_544 pl.de.un_750  so.zu.jw_332 ceb.un.un_B00
  // [6bc0]
  0x1e1a1c12, 0x044a1f07, 0x0f2d0d13, 0x685264ad,   // id.tl.ms_654 cy.yo.fi_432  cs.sk.lv_665 lg.ha.ig_643
  0x256835a0, 0x190a0bee, 0x2d0d31ee, 0x3f001313,   // zu.ig.eu_322 es.pt.gl_422  az.cs.sk_422 et.af.un_650
  0x4a0e2ba9, 0x2a4a07af, 0x191206a6, 0x215204ec,   // vi.is.yo_544 it.yo.mt_655  de.hu.gl_521 fi.ha.jw_644
  0x1b6b6802, 0x3564250e, 0x1300061a, 0x0c002b04,   // ig.ceb.tr_222 eu.lg.zu_555  de.et.un_760 vi.sv.un_320
  // [6bd0]
  0x20123512, 0x121e1c14, 0x12003529, 0x1320030d,   // zu.hu.sq_654 id.ms.hu_666  zu.hu.un_960 nl.sq.et_554
  0x046b4a0e, 0x04100aec, 0x11100f13, 0x04132a07,   // yo.ceb.fi_555 mk.be.ru_644  lv.lt.ro_665 mt.et.fi_432
  0x55001b08, 0x32255514, 0x1b552a08, 0x32002902,   // tr.rw.un_430 rw.eu.bs_666  mt.rw.tr_443 sl.bs.un_220
  0x32172911, 0x35001e1a, 0x20000508, 0x32172d0c,   // sl.sr.bs_653 ms.zu.un_760  fr.sq.un_430 sk.sr.bs_543
  // [6be0]
  0x2a0f55a4, 0x2d681a08, 0x104a0f07, 0x130103a6,   // rw.lv.mt_433 tl.ig.sk_443  lv.yo.lt_432 nl.en.et_521
  0x0d005214, 0x1b185204, 0x05010c08, 0x270a18af,   // ha.cs.un_660 ha.ga.tr_332  sv.en.fr_443 ga.pt.gd_655
  0x0e3b12ad, 0x1c533bee, 0x0300350c, 0x1b101307,   // hu.so.is_643 so.ht.id_422  zu.nl.un_530 et.lt.tr_432
  0x10016ba0, 0x27171fa4, 0x35001a2b, 0x256b5212,   // ceb.en.lt_322 cy.sr.gd_433  tl.zu.un_980 ha.ceb.eu_654
  // [6bf0]
  0x0f230560, 0x02250812, 0x2d0d2855, 0x052353ad,   // fr.ca.lv_664 no.eu.da_654  sw.cs.sk_442 ht.ca.fr_643
  0x041710a0, 0x251b0413, 0x53232112, 0x166b1a0c,   // be.sr.ru_322 fi.tr.eu_665  jw.ca.ht_654 tl.ceb.hr_543
  0x2b006412, 0x31002a05, 0x2d0d1017, 0x21532312,   // lg.vi.un_640 mt.az.un_330  lt.cs.sk_753 ca.ht.jw_654
  0x3f1f0208, 0x21532307, 0x17111e0c, 0x0000172d,   // da.cy.af_443 ca.ht.jw_432  ms.ro.sr_543 sr.un.un_A00

  // [6c00]
  0x3217030c, 0x033f04ee, 0x21235312, 0x1c25210c,   // nl.sr.bs_543 fi.af.nl_422  ht.ca.jw_654 jw.eu.id_543
  0x1f013fa9, 0x11191fa0, 0x0c6808ee, 0x646b35a0,   // af.en.cy_544 cy.gl.ro_322  no.ig.sv_422 zu.ceb.lg_322
  0x114a16a4, 0x120425af, 0x556407ee, 0x2a003509,   // hr.yo.ro_433 eu.fi.hu_655  it.lg.rw_422 zu.mt.un_440
  0x04521ba4, 0x1a00530c, 0x022d0305, 0x041c1313,   // tr.ha.fi_433 ht.tl.un_530  nl.sk.da_333 et.id.fi_665
  // [6c10]
  0x0302185a, 0x1c251eec, 0x21056ea7, 0x0e250fac,   // ga.da.nl_553 ms.eu.id_644  hmn.fr.jw_532 lv.eu.is_632
  0x2731250c, 0x060405ec, 0x1c110605, 0x20003102,   // eu.az.gd_543 fr.fi.de_644  de.ro.id_333 az.sq.un_220
  0x3f030ba9, 0x64006812, 0x16173212, 0x231907ad,   // es.nl.af_544 ig.lg.un_640  bs.sr.hr_654 it.gl.ca_643
  0x0e030808, 0x130c080e, 0x07050b08, 0x270752ac,   // no.nl.is_443 no.sv.et_555  es.fr.it_443 ha.it.gd_632
  // [6c20]
  0x1b536b09, 0x0600310e, 0x2d0d2714, 0x080e02ac,   // ceb.ht.tr_444 az.de.un_550  gd.cs.sk_666 da.is.no_632
  0x53192811, 0x21002302, 0x6b00101a, 0x6b103513,   // sw.gl.ht_653 ca.jw.un_220  lt.ceb.un_760 zu.lt.ceb_665
  0x0a0b10a7, 0x02005312, 0x13550208, 0x551b180c,   // lt.es.pt_532 ht.da.un_640  da.rw.et_443 ga.tr.rw_543
  0x0b011904, 0x4a23530e, 0x0b6e19ee, 0x19050a55,   // gl.en.es_332 ht.ca.yo_555  gl.hmn.es_422 pt.fr.gl_442
  // [6c30]
  0x3f2823ee, 0x0c001813, 0x023b3f0d, 0x2d0e0dad,   // ca.sw.af_422 ga.sv.un_650  af.so.da_554 cs.is.sk_643
  0x3b00200b, 0x1b160fa4, 0x35002b29, 0x06180eee,   // sq.so.un_520 lv.hr.tr_433  vi.zu.un_960 is.ga.de_422
  0x282d0d0e, 0x11200fee, 0x3f001005, 0x2d060d0c,   // cs.sk.sw_555 lv.sq.ro_422  lt.af.un_330 cs.de.sk_543
  0x0b0a4aa4, 0x12003113, 0x18061fee, 0x100502ee,   // yo.pt.es_433 az.hu.un_650  cy.de.ga_422 da.fr.lt_422
  // [6c40]
  0x27061807, 0x31001234, 0x0628530c, 0x0a000d04,   // ga.de.gd_432 hu.az.un_A80  ht.sw.de_543 cs.pt.un_320
  0x556b2da9, 0x28550613, 0x32162014, 0x060d12a4,   // sk.ceb.rw_544 de.rw.sw_665  sq.hr.bs_666 hu.cs.de_433
  0x0c1604a4, 0x0d0c2da4, 0x553228ad, 0x086431a4,   // fi.hr.sv_433 sk.sv.cs_433  sw.bs.rw_643 az.lg.no_433
  0x64010ba0, 0x552109ec, 0x2d0d12bb, 0x1325280c,   // es.en.lg_322 pl.jw.rw_644  hu.cs.sk_854 sw.eu.et_543
  // [6c50]
  0x68001704, 0x0811175a, 0x321620ec, 0x10041b04,   // sr.ig.un_320 sr.ro.uk_553  sq.hr.bs_644 tr.fi.lt_332
  0x32162a0e, 0x0c002914, 0x1a001605, 0x176428ad,   // mt.hr.bs_555 sl.sv.un_660  hr.tl.un_330 sw.lg.sr_643
  0x64531713, 0x060304a9, 0x170c0612, 0x030619ee,   // sr.ht.lg_665 fi.nl.de_544  de.sv.sr_654 gl.de.nl_422
  0x320e2802, 0x1e1c0f07, 0x0200042b, 0x1e001a02,   // sw.is.bs_222 lv.id.ms_432  fi.da.un_980 tl.ms.un_220
  // [6c60]
  0x105525ac, 0x2d131212, 0x64040e08, 0x202928ec,   // eu.rw.lt_632 hu.et.sk_654  is.fi.lg_443 sw.sl.sq_644
  0x3f0429a4, 0x084a0e07, 0x52640e07, 0x31000e09,   // sl.fi.af_433 is.yo.no_432  is.lg.ha_432 is.az.un_440
  0x551135ec, 0x23001313, 0x13042909, 0x070b06a4,   // zu.ro.rw_644 et.ca.un_650  sl.fi.et_444 de.es.it_433
  0x1c2d25a0, 0x07030612, 0x080c6412, 0x07060309,   // eu.sk.id_322 de.nl.it_654  lg.sv.no_654 nl.de.it_444
  // [6c70]
  0x352129a6, 0x040e2102, 0x351f06a4, 0x080221a0,   // sl.jw.zu_521 jw.is.fi_222  de.cy.zu_433 jw.da.no_322
  0x1b1a0a07, 0x28355509, 0x27005319, 0x03060714,   // pt.tl.tr_432 rw.zu.sw_444  ht.gd.un_750 it.de.nl_666
  0x182d0e0c, 0x112155af, 0x35531aaf, 0x1b2006ac,   // is.sk.ga_543 rw.jw.ro_655  tl.ht.zu_655 de.sq.tr_632
  0x2000642b, 0x321609ee, 0x3b001a36, 0x0b2a19af,   // lg.sq.un_980 pl.hr.bs_422  tl.so.un_AA0 gl.mt.es_655
  // [6c80]
  0x1607280c, 0x640d01ec, 0x1f00202a, 0x07062a12,   // sw.it.hr_543 en.cs.lg_644  sq.cy.un_970 mt.de.it_654
  0x1e1c0fee, 0x1f003f36, 0x230f09ee, 0x20002b0d,   // lv.id.ms_422 af.cy.un_AA0  pl.lv.ca_422 vi.sq.un_540
  0x1a6b2ba7, 0x35135304, 0x20001604, 0x35121e08,   // vi.ceb.tl_532 ht.et.zu_332  hr.sq.un_320 ms.hu.zu_443
  0x1e1c2802, 0x2b000a02, 0x0c000318, 0x0b110604,   // sw.id.ms_222 pt.vi.un_220  nl.sv.un_740 de.ro.es_332
  // [6c90]
  0x270518af, 0x19251004, 0x3b12080c, 0x08022309,   // ga.fr.gd_655 lt.eu.gl_332  no.hu.so_543 ca.da.no_444
  0x53002305, 0x0d2d270d, 0x10003f05, 0x2a3b2811,   // ca.ht.un_330 gd.sk.cs_554  af.lt.un_330 sw.so.mt_653
  0x0c000714, 0x27182860, 0x3f001f12, 0x110d55a4,   // it.sv.un_660 sw.ga.gd_664  cy.af.un_640 rw.cs.ro_433
  0x1c1b28a0, 0x052707a7, 0x0e006e08, 0x190b55a0,   // sw.tr.id_322 it.gd.fr_532  hmn.is.un_430 rw.es.gl_322
  // [6ca0]
  0x1e2135ac, 0x2718070e, 0x13071bee, 0x2a111814,   // zu.jw.ms_632 it.ga.gd_555  tr.it.et_422 ga.ro.mt_666
  0x3b354a13, 0x16290aa9, 0x130d090c, 0x0b0a0da6,   // yo.zu.so_665 pt.sl.hr_544  hi.ne.bh_543 cs.pt.es_521
  0x020c05ee, 0x521a6bad, 0x6b553507, 0x193b0ba0,   // fr.sv.da_422 ceb.tl.ha_643  zu.rw.ceb_432 es.so.gl_322
  0x64551ba0, 0x1b6b0ba4, 0x0900551b, 0x35001902,   // tr.rw.lg_322 es.ceb.tr_433  rw.pl.un_770 gl.zu.un_220
  // [6cb0]
  0x185509ad, 0x64550960, 0x0621090c, 0x080206ec,   // pl.rw.ga_643 pl.rw.lg_664  pl.jw.de_543 de.da.no_644
  0x1b001a12, 0x536421a0, 0x09536404, 0x21121005,   // tl.tr.un_640 jw.lg.ht_322  lg.ht.pl_332 lt.hu.jw_333
  0x55002902, 0x0a000823, 0x1a0510a4, 0x1b2731ee,   // sl.rw.un_220 uk.mk.un_880  lt.fr.tl_433 az.gd.tr_422
  0x071b0513, 0x052918a0, 0x12001f0c, 0x01005502,   // fr.tr.it_665 ga.sl.fr_322  cy.hu.un_530 rw.en.un_220
  // [6cc0]
  0x0e12040e, 0x04132a14, 0x120f0e07, 0x0c061b04,   // fi.hu.is_555 mt.et.fi_666  is.lv.hu_432 tr.de.sv_332
  0x1001230c, 0x08022305, 0x3f000904, 0x120805a4,   // ca.en.lt_543 ca.da.no_333  pl.af.un_320 fr.no.hu_433
  0x10200fa4, 0x191123a0, 0x21091ca0, 0x320f165a,   // lv.sq.lt_433 ca.ro.gl_322  id.pl.jw_322 hr.lv.bs_553
  0x20230baf, 0x176852a6, 0x1300250b, 0x0f0510ee,   // es.ca.sq_655 ha.ig.sr_521  eu.et.un_520 lt.fr.lv_422
  // [6cd0]
  0x1b000412, 0x0c001e02, 0x171029a0, 0x211355ec,   // fi.tr.un_640 ms.sv.un_220  sl.lt.sr_322 rw.et.jw_644
  0x52350ea4, 0x063f0b0c, 0x25290f12, 0x641a2108,   // is.zu.ha_433 es.af.de_543  lv.sl.eu_654 jw.tl.lg_443
  0x6435230c, 0x120e090c, 0x4a0a52a9, 0x2718230c,   // ca.zu.lg_543 pl.is.hu_543  ha.pt.yo_544 ca.ga.gd_543
  0x0d000208, 0x311b55a4, 0x190a2aee, 0x642d35ad,   // da.cs.un_430 rw.tr.az_433  mt.pt.gl_422 zu.sk.lg_643
  // [6ce0]
  0x11290f07, 0x19230b0d, 0x17002008, 0x20063f09,   // lv.sl.ro_432 es.ca.gl_554  sq.sr.un_430 af.de.sq_444
  0x290d17a6, 0x01093b0b, 0x0a1108ec, 0x55093b0b,   // sr.cs.sl_521 so.pl.en_542  uk.ro.mk_644 so.pl.rw_542
  0x32100ba0, 0x55000819, 0x1a0b530b, 0x0d022d60,   // es.lt.bs_322 no.rw.un_750  ht.es.tl_542 sk.da.cs_664
  0x23251914, 0x0f121008, 0x050607a0, 0x1206250c,   // gl.eu.ca_666 lt.hu.lv_443  it.de.fr_322 eu.de.hu_543
  // [6cf0]
  0x32000207, 0x022008a4, 0x0d6b2d0c, 0x043f1313,   // da.bs.un_420 no.sq.da_433  sk.ceb.cs_543 et.af.fi_665
  0x2a071baf, 0x1c1e3b07, 0x1e000e13, 0x0e2d1212,   // tr.it.mt_655 so.ms.id_432  is.ms.un_650 hu.sk.is_654
  0x231f0e07, 0x011c0ea7, 0x32166ea0, 0x0900640c,   // is.cy.ca_432 is.id.en_532  hmn.hr.bs_322 lg.pl.un_530
  0x64521e02, 0x11000a02, 0x02001804, 0x08210eee,   // ms.ha.lg_222 pt.ro.un_220  ga.da.un_320 is.jw.no_422
  // [6d00]
  0x06200c13, 0x351827ec, 0x252a5312, 0x1a6b0b04,   // sv.sq.de_665 gd.ga.zu_644  ht.mt.eu_654 es.ceb.tl_332
  0x060805a4, 0x200111ec, 0x071711ec, 0x19072313,   // fr.no.de_433 ro.en.sq_644  ro.sr.bg_644 ca.it.gl_665
  0x06351f0c, 0x2505350c, 0x131911ad, 0x071711a6,   // cy.zu.de_543 zu.fr.eu_543  ro.gl.et_643 ro.sr.bg_521
  0x17162da6, 0x130e35ee, 0x17102aa4, 0x130407a0,   // sk.hr.sr_521 zu.is.et_422  mt.lt.sr_433 it.fi.et_322
  // [6d10]
  0x0c100f05, 0x015318a0, 0x1b210e08, 0x0e0704a7,   // lv.lt.sv_333 ga.ht.en_322  is.jw.tr_443 fi.it.is_532
  0x04100614, 0x0e100c04, 0x3f2d0d13, 0x2d0b19af,   // de.lt.fi_666 sv.lt.is_332  cs.sk.af_665 gl.es.sk_655
  0x190a0e14, 0x063b35ec, 0x06113fad, 0x190a0609,   // is.pt.gl_666 zu.so.de_644  af.ro.de_643 de.pt.gl_444
  0x041f06ad, 0x110768a7, 0x0d202d0c, 0x04000f13,   // de.cy.fi_643 ig.it.ro_532  sk.sq.cs_543 lv.fi.un_650
  // [6d20]
  0x1c281e55, 0x28351313, 0x061f35a4, 0x2a002007,   // ms.sw.id_442 et.zu.sw_665  zu.cy.de_433 sq.mt.un_420
  0x18021f07, 0x0c6402af, 0x2d180dec, 0x0c1f640c,   // cy.da.ga_432 da.lg.sv_655  cs.ga.sk_644 lg.cy.sv_543
  0x174a28ac, 0x17022a0c, 0x09004a1b, 0x523b64af,   // sw.yo.sr_632 mt.da.sr_543  yo.pl.un_770 lg.so.ha_655
  0x5300280b, 0x25551007, 0x4a002814, 0x0e00230c,   // sw.ht.un_520 lt.rw.eu_432  sw.yo.un_660 ca.is.un_530
  // [6d30]
  0x31051ba7, 0x3b1e250b, 0x0c0b64ee, 0x2d000620,   // tr.fr.az_532 eu.ms.so_542  lg.es.sv_422 de.sk.un_850
  0x532811ec, 0x64021f0c, 0x17002804, 0x35003f02,   // ro.sw.ht_644 cy.da.lg_543  sw.sr.un_320 af.zu.un_220
  0x11001a02, 0x093b060c, 0x270364ee, 0x17161e02,   // tl.ro.un_220 de.so.pl_543  lg.nl.gd_422 ms.hr.sr_222
  0x272a1fad, 0x1b006e13, 0x0628640d, 0x05230fa7,   // cy.mt.gd_643 hmn.tr.un_650  lg.sw.de_554 lv.ca.fr_532
  // [6d40]
  0x550628a7, 0x3b28530c, 0x1e121a12, 0x032b3fa0,   // sw.de.rw_532 ht.sw.so_543  tl.hu.ms_654 af.vi.nl_322
  0x3f1702a0, 0x530d05ad, 0x1c213b0e, 0x2331100c,   // da.sr.af_322 fr.cs.ht_643  so.jw.id_555 lt.az.ca_543
  0x12002702, 0x0e040cec, 0x55003504, 0x53001007,   // gd.hu.un_220 sv.fi.is_644  zu.rw.un_320 lt.ht.un_420
  0x13200f05, 0x4a006405, 0x19070b07, 0x311e1a12,   // lv.sq.et_333 lg.yo.un_330  es.it.gl_432 tl.ms.az_654
  // [6d50]
  0x204a6412, 0x05000f13, 0x1f114a07, 0x0f00230e,   // lg.yo.sq_654 lv.fr.un_650  yo.ro.cy_432 ca.lv.un_550
  0x080220a4, 0x351c1a0c, 0x32160fa4, 0x53232807,   // sq.da.no_433 tl.id.zu_543  lv.hr.bs_433 sw.ca.ht_432
  0x3f101fa7, 0x3f2520ee, 0x04120da0, 0x64000219,   // cy.lt.af_532 sq.eu.af_422  cs.hu.fi_322 da.lg.un_750
  0x171c21a9, 0x285368ec, 0x190b1ba0, 0x1f20090c,   // jw.id.sr_544 ig.ht.sw_644  tr.es.gl_322 pl.sq.cy_543
  // [6d60]
  0x1b552aa7, 0x0e0c1314, 0x133b080b, 0x056b0807,   // mt.rw.tr_532 et.sv.is_666  no.so.et_542 no.ceb.fr_432
  0x0c1b1009, 0x552b0508, 0x55281ca7, 0x0800130d,   // lt.tr.sv_444 fr.vi.rw_443  id.sw.rw_532 et.no.un_540
  0x28532a0c, 0x052d11a0, 0x21002a23, 0x20000f07,   // mt.ht.sw_543 ro.sk.fr_322  mt.jw.un_880 lv.sq.un_420
  0x03050604, 0x254a550d, 0x32200ea7, 0x13091c5a,   // de.fr.nl_332 rw.yo.eu_554  is.sq.bs_532 mr.hi.bh_553
  // [6d70]
  0x2a000e0c, 0x212a6813, 0x28003502, 0x312a2804,   // is.mt.un_530 ig.mt.jw_665  zu.sw.un_220 sw.mt.az_332
  0x23002008, 0x4a2568ad, 0x183b2012, 0x11312012,   // sq.ca.un_430 ig.eu.yo_643  sq.so.ga_654 sq.az.ro_654
  0x53232005, 0x32044a02, 0x1a00030d, 0x100f3b14,   // sq.ca.ht_333 yo.fi.bs_222  nl.tl.un_540 so.lv.lt_666
  0x08000908, 0x170429a0, 0x556425ee, 0x252855a0,   // pl.no.un_430 sl.fi.sr_322  eu.lg.rw_422 rw.sw.eu_322
  // [6d80]
  0x180e090c, 0x110510a0, 0x211f55a0, 0x25231e0c,   // pl.is.ga_543 lt.fr.ro_322  rw.cy.jw_322 ms.ca.eu_543
  0x13002522, 0x18001107, 0x05001b04, 0x0f043f14,   // eu.et.un_870 ro.ga.un_420  tr.fr.un_320 af.fi.lv_666
  0x2d0d08a0, 0x1e211c0b, 0x04005513, 0x281e1ba9,   // no.cs.sk_322 id.jw.ms_542  rw.fi.un_650 tr.ms.sw_544
  0x12000202, 0x0c1b53ee, 0x166425ad, 0x19110b09,   // da.hu.un_220 ht.tr.sv_422  eu.lg.hr_643 es.ro.gl_444
  // [6d90]
  0x28001805, 0x64105502, 0x64042dee, 0x64256b11,   // ga.sw.un_330 rw.lt.lg_222  sk.fi.lg_422 ceb.eu.lg_653
  0x2a0f120c, 0x04001602, 0x00000901, 0x202a1b07,   // hu.lv.mt_543 hr.fi.un_220  pl.un.un_200 tr.mt.sq_432
  0x556425ec, 0x1e120da0, 0x6400252b, 0x64251008,   // eu.lg.rw_644 cs.hu.ms_322  eu.lg.un_980 lt.eu.lg_443
  0x2900251a, 0x28520e0d, 0x52111ba4, 0x3b526ba9,   // eu.sl.un_760 is.ha.sw_554  tr.ro.ha_433 ceb.ha.so_544
  // [6da0]
  0x11005205, 0x1300352b, 0x2d0d280c, 0x231f06ad,   // ha.ro.un_330 zu.et.un_980  sw.cs.sk_543 de.cy.ca_643
  0x113f1308, 0x52551ba9, 0x023f1213, 0x551a35a4,   // et.af.ro_443 tr.rw.ha_544  hu.af.da_665 zu.tl.rw_433
  0x6b552512, 0x6800522c, 0x551e250c, 0x05011a0d,   // eu.rw.ceb_654 ha.ig.un_990  eu.ms.rw_543 tl.en.fr_554
  0x12002520, 0x13251012, 0x130c05ec, 0x0a131204,   // eu.hu.un_850 lt.eu.et_654  fr.sv.et_644 hu.et.pt_332
  // [6db0]
  0x280911ac, 0x03040da4, 0x0d0c13a7, 0x12113f08,   // ro.pl.sw_632 cs.fi.nl_433  et.sv.cs_532 af.ro.hu_443
  0x1b55280d, 0x0802280c, 0x0d062d0c, 0x353b640d,   // sw.rw.tr_554 sw.da.no_543  sk.de.cs_543 lg.so.zu_554
  0x20000702, 0x350f3ba4, 0x35525512, 0x043f3ba4,   // it.sq.un_220 so.lv.zu_433  rw.ha.zu_654 so.af.fi_433
  0x12000208, 0x17000402, 0x31021b55, 0x1f0e0cee,   // da.hu.un_430 ru.sr.un_220  tr.da.az_442 sv.is.cy_422
  // [6dc0]
  0x1f080213, 0x2a005223, 0x3b0b68ee, 0x0f003b0c,   // da.no.cy_665 ha.mt.un_880  ig.es.so_422 so.lv.un_530
  0x53001f0e, 0x021f08ec, 0x12002b1a, 0x121f2da0,   // cy.ht.un_550 no.cy.da_644  vi.hu.un_760 sk.cy.hu_322
  0x08022007, 0x1a063fa0, 0x19001f07, 0x0e002512,   // sq.da.no_432 af.de.tl_322  cy.gl.un_420 eu.is.un_640
  0x20291a09, 0x050720ec, 0x0a5206a4, 0x322012ad,   // tl.sl.sq_444 sq.it.fr_644  de.ha.pt_433 hu.sq.bs_643
  // [6dd0]
  0x0200190d, 0x011868ee, 0x1c1e1a0c, 0x1e551c0c,   // gl.da.un_540 ig.ga.en_422  tl.ms.id_543 id.rw.ms_543
  0x05001a0b, 0x190a5505, 0x0d09290d, 0x0d292d0d,   // tl.fr.un_520 rw.pt.gl_333  sl.pl.cs_554 sk.sl.cs_554
  0x1c181e04, 0x100f5211, 0x642916a9, 0x0b0e19a4,   // ms.ga.id_332 ha.lv.lt_653  hr.sl.lg_544 gl.is.es_433
  0x27281813, 0x25001008, 0x171b35ac, 0x18282bee,   // ga.sw.gd_665 lt.eu.un_430  zu.tr.sr_632 vi.sw.ga_422
  // [6de0]
  0x16000207, 0x190a0b11, 0x532d0604, 0x643b070e,   // da.hr.un_420 es.pt.gl_653  de.sk.ht_332 it.so.lg_555
  0x4a0c28a0, 0x04000b02, 0x0402280d, 0x132d0904,   // sw.sv.yo_322 es.fi.un_220  sw.da.fi_554 pl.sk.et_332
  0x043f64a0, 0x25002107, 0x53001e11, 0x6b201aa0,   // lg.af.fi_322 jw.eu.un_420  ms.ht.un_630 tl.sq.ceb_322
  0x20000c02, 0x060c0513, 0x092568a0, 0x1f1a0aa6,   // sv.sq.un_220 fr.sv.de_665  ig.eu.pl_322 pt.tl.cy_521
  // [6df0]
  0x2a092d60, 0x3b6852a9, 0x320d2aa7, 0x6e092d12,   // sk.pl.mt_664 ha.ig.so_544  mt.cs.bs_532 sk.pl.hmn_654
  0x68214a0c, 0x35000302, 0x2a080eac, 0x68184aa9,   // yo.jw.ig_543 nl.zu.un_220  is.no.mt_632 yo.ga.ig_544
  0x11520e0e, 0x091f1012, 0x2b520aa7, 0x3b4a520c,   // is.ha.ro_555 lt.cy.pl_654  pt.ha.vi_532 ha.yo.so_543
  0x3b1917a4, 0x0a001c0d, 0x2a2035a9, 0x0b3f04a4,   // sr.gl.so_433 id.pt.un_540  zu.sq.mt_544 fi.af.es_433
  // [6e00]
  0x1900290c, 0x2a000f05, 0x120852a7, 0x521304ec,   // sl.gl.un_530 lv.mt.un_330  ha.no.hu_532 fi.et.ha_644
  0x3b002502, 0x02000f19, 0x4a002812, 0x2a640e07,   // eu.so.un_220 lv.da.un_750  sw.yo.un_640 is.lg.mt_432
  0x210952ee, 0x0802290c, 0x35525507, 0x20291055,   // ha.pl.jw_422 sl.da.no_543  rw.ha.zu_432 lt.sl.sq_442
  0x02050812, 0x1a52060b, 0x1b00070c, 0x10000d0d,   // no.fr.da_654 de.ha.tl_542  it.tr.un_530 cs.lt.un_540
  // [6e10]
  0x050253a0, 0x1e641cee, 0x05010fa4, 0x0a001305,   // ht.da.fr_322 id.lg.ms_422  lv.en.fr_433 et.pt.un_330
  0x18110713, 0x072a1208, 0x112d2104, 0x23000c04,   // it.ro.ga_665 hu.mt.it_443  jw.sk.ro_332 sv.ca.un_320
  0x352568a0, 0x0b0e19a7, 0x25000d04, 0x190a0ca4,   // ig.eu.zu_322 gl.is.es_532  cs.eu.un_320 sv.pt.gl_433
  0x022b0e0b, 0x1a006b0b, 0x23050209, 0x1b181fee,   // is.vi.da_542 ceb.tl.un_520  da.fr.ca_444 cy.ga.tr_422
  // [6e20]
  0x10072014, 0x07005514, 0x210753a7, 0x0e000913,   // sq.it.lt_666 rw.it.un_660  ht.it.jw_532 pl.is.un_650
  0x121e10a7, 0x0f10200c, 0x28185202, 0x120d04a4,   // lt.ms.hu_532 sq.lt.lv_543  ha.ga.sw_222 fi.cs.hu_433
  0x17000908, 0x1008070e, 0x16112da4, 0x01005207,   // pl.sr.un_430 bg.uk.be_555  sk.ro.hr_433 ha.en.un_420
  0x190b0708, 0x1c006419, 0x06102aa4, 0x190a0502,   // it.es.gl_443 lg.id.un_750  mt.lt.de_433 fr.pt.gl_222
  // [6e30]
  0x20041205, 0x0e070da9, 0x29682d11, 0x051227a0,   // hu.fi.sq_333 cs.it.is_544  sk.ig.sl_653 gd.hu.fr_322
  0x113155a0, 0x0c2a10af, 0x13236b14, 0x2d0d0b0c,   // rw.az.ro_322 lt.mt.sv_655  ceb.ca.et_666 es.cs.sk_543
  0x1f000202, 0x110468a0, 0x1c1929a0, 0x132904ec,   // da.cy.un_220 ig.fi.ro_322  sl.gl.id_322 fi.sl.et_644
  0x52131013, 0x083132a0, 0x080710ac, 0x02080c55,   // lt.et.ha_665 bs.az.no_322  be.bg.uk_632 sv.no.da_442
  // [6e40]
  0x28216ba4, 0x1f350f12, 0x1107050c, 0x1f183b07,   // ceb.jw.sw_433 lv.zu.cy_654  fr.it.ro_543 so.ga.cy_432
  0x2753180c, 0x1e201c0c, 0x6b030612, 0x52531807,   // ga.ht.gd_543 id.sq.ms_543  de.nl.ceb_654 ga.ht.ha_432
  0x250405ec, 0x3127250c, 0x100e21af, 0x3217040c,   // fr.fi.eu_644 eu.gd.az_543  jw.is.lt_655 fi.sr.bs_543
  0x27051f07, 0x321217a0, 0x2d0d31a0, 0x020e250c,   // cy.fr.gd_432 sr.hu.bs_322  az.cs.sk_322 eu.is.da_543
  // [6e50]
  0x6b6401ec, 0x190b2511, 0x3b64280d, 0x1c001602,   // en.lg.ceb_644 eu.es.gl_653  sw.lg.so_554 hr.id.un_220
  0x2d0d05ee, 0x52181008, 0x52131008, 0x5200181b,   // fr.cs.sk_422 lt.ga.ha_443  lt.et.ha_443 ga.ha.un_770
  0x6b0a0604, 0x07003520, 0x251a1f13, 0x0728110c,   // de.pt.ceb_332 zu.it.un_850  cy.tl.eu_665 ro.sw.it_543
  0x1c130d05, 0x1b0e21a7, 0x013f1314, 0x28521f12,   // ne.bh.mr_333 jw.is.tr_532  et.af.en_666 cy.ha.sw_654
  // [6e60]
  0x1e1c6409, 0x2531180c, 0x31681808, 0x551021a9,   // lg.id.ms_444 ga.az.eu_543  ga.ig.az_443 jw.lt.rw_544
  0x0f000907, 0x531b0707, 0x6b641b12, 0x0c133108,   // pl.lv.un_420 it.tr.ht_432  tr.lg.ceb_654 az.et.sv_443
  0x1b000f04, 0x1b3109a7, 0x11001308, 0x352b28ee,   // lv.tr.un_320 pl.az.tr_532  et.ro.un_430 sw.vi.zu_422
  0x0e0c1ba4, 0x322a68a0, 0x0e3f1b02, 0x131a2113,   // tr.sv.is_433 ig.mt.bs_322  tr.af.is_222 jw.tl.et_665
  // [6e70]
  0x060823ee, 0x530628a7, 0x0c1f3bad, 0x25350313,   // ca.no.de_422 sw.de.ht_532  so.cy.sv_643 nl.zu.eu_665
  0x1e2a3b07, 0x3b5264ec, 0x0a1a0408, 0x080228af,   // so.mt.ms_432 lg.ha.so_644  fi.tl.pt_443 sw.da.no_655
  0x11525507, 0x03203f08, 0x3b5520a4, 0x1e006405,   // rw.ha.ro_432 af.sq.nl_443  sq.rw.so_433 lg.ms.un_330
  0x18122dec, 0x2b000e1a, 0x3b0e64ec, 0x55312805,   // sk.hu.ga_644 is.vi.un_760  lg.is.so_644 sw.az.rw_333
  // [6e80]
  0x2b001007, 0x0d1208ad, 0x532055af, 0x1e6b1c0c,   // lt.vi.un_420 no.hu.cs_643  rw.sq.ht_655 id.ceb.ms_543
  0x012005ad, 0x2a6435ec, 0x0400030d, 0x0d202812,   // fr.sq.en_643 zu.lg.mt_644  nl.fi.un_540 sw.sq.cs_654
  0x0800060b, 0x10201f0c, 0x0b1205ec, 0x07002021,   // de.no.un_520 cy.sq.lt_543  fr.hu.es_644 sq.it.un_860
  0x0755200c, 0x210464a6, 0x3b0b52a0, 0x033b1ba0,   // sq.rw.it_543 lg.fi.jw_521  ha.es.so_322 tr.so.nl_322
  // [6e90]
  0x095505a4, 0x0a551107, 0x16091b08, 0x6b1a0eaf,   // fr.rw.pl_433 ro.rw.pt_432  tr.pl.hr_443 is.tl.ceb_655
  0x062725ec, 0x0f312512, 0x16203207, 0x0b310cee,   // eu.gd.de_644 eu.az.lv_654  bs.sq.hr_432 sv.az.es_422
  0x1c080cec, 0x0500061a, 0x64001321, 0x05016ba0,   // sv.no.id_644 de.fr.un_760  et.lg.un_860 ceb.en.fr_322
  0x551b11a7, 0x1b20310d, 0x022a080b, 0x1a000307,   // ro.tr.rw_532 az.sq.tr_554  no.mt.da_542 nl.tl.un_420
  // [6ea0]
  0x11123f0d, 0x180c0609, 0x0f2a07ec, 0x29000914,   // af.hu.ro_554 de.sv.ga_444  it.mt.lv_644 pl.sl.un_660
  0x32101712, 0x05122aec, 0x20132a0c, 0x25033f13,   // sr.lt.bs_654 mt.hu.fr_644  mt.et.sq_543 af.nl.eu_665
  0x2d0d2a05, 0x0a1307ee, 0x106b0f0c, 0x0c001114,   // mt.cs.sk_333 it.et.pt_422  lv.ceb.lt_543 ro.sv.un_660
  0x0d0f2d07, 0x09204aee, 0x6b071ca0, 0x64051309,   // sk.lv.cs_432 yo.sq.pl_422  id.it.ceb_322 et.fr.lg_444
  // [6eb0]
  0x32175505, 0x20135508, 0x162955a4, 0x35282008,   // rw.sr.bs_333 rw.et.sq_443  rw.sl.hr_433 sq.sw.zu_443
  0x6b051208, 0x28000e1a, 0x32161eaf, 0x29001b09,   // hu.fr.ceb_443 is.sw.un_760  ms.hr.bs_655 tr.sl.un_440
  0x0c2304ee, 0x10001e02, 0x2d0d2a0c, 0x081a0e04,   // fi.ca.sv_422 ms.lt.un_220  mt.cs.sk_543 is.tl.no_332
  0x1c0e1e0c, 0x06081aa4, 0x160d1707, 0x1e1c2905,   // ms.is.id_543 tl.no.de_433  sr.cs.hr_432 sl.id.ms_333
  // [6ec0]
  0x12003118, 0x320d1bee, 0x091b1208, 0x1c031b0c,   // az.hu.un_740 tr.cs.bs_422  hu.tr.pl_443 tr.nl.id_543
  0x3f230ea7, 0x052927a0, 0x120905a4, 0x020c08a7,   // is.ca.af_532 gd.sl.fr_322  fr.pl.hu_433 no.sv.da_532
  0x29002319, 0x0f1f1813, 0x023f03af, 0x18006405,   // ca.sl.un_750 ga.cy.lv_665  nl.af.da_655 lg.ga.un_330
  0x190a2dec, 0x0b191212, 0x111e20a4, 0x21070608,   // sk.pt.gl_644 hu.gl.es_654  sq.ms.ro_433 de.it.jw_443
  // [6ed0]
  0x0a1b2b0c, 0x17212d07, 0x08020f09, 0x251b32af,   // vi.tr.pt_543 sk.jw.sr_432  lv.da.no_444 bs.tr.eu_655
  0x311f1ba4, 0x12184a0c, 0x2a2868a9, 0x031f09a7,   // tr.cy.az_433 yo.ga.hu_543  ig.sw.mt_544 pl.cy.nl_532
  0x010464a0, 0x28000a02, 0x20051b0c, 0x0b3f06ee,   // lg.fi.en_322 pt.sw.un_220  tr.fr.sq_543 de.af.es_422
  0x05000408, 0x2d123502, 0x282a3f02, 0x013b2aee,   // fi.fr.un_430 zu.hu.sk_222  af.mt.sw_222 mt.so.en_422
  // [6ee0]
  0x21125507, 0x062a09ad, 0x12050fee, 0x0f003112,   // rw.hu.jw_432 pl.mt.de_643  lv.fr.hu_422 az.lv.un_640
  0x2a001802, 0x55001112, 0x0f002a04, 0x0802350c,   // ga.mt.un_220 ro.rw.un_640  mt.lv.un_320 zu.da.no_543
  0x05190a14, 0x19180bec, 0x123510ac, 0x521a0612,   // pt.gl.fr_666 es.ga.gl_644  lt.zu.hu_632 de.tl.ha_654
  0x190b25ac, 0x521c110c, 0x030620ad, 0x126407a9,   // eu.es.gl_632 ro.id.ha_543  sq.de.nl_643 it.lg.hu_544
  // [6ef0]
  0x6b005305, 0x1c051ea4, 0x013b0b07, 0x12060eee,   // ht.ceb.un_330 ms.fr.id_433  es.so.en_432 is.de.hu_422
  0x281a64ec, 0x0d002312, 0x25002907, 0x111b3b0c,   // lg.tl.sw_644 ca.cs.un_640  sl.eu.un_420 so.tr.ro_543
  0x03002112, 0x311b64a9, 0x25032812, 0x250f0ca7,   // jw.nl.un_640 lg.tr.az_544  sw.nl.eu_654 sv.lv.eu_532
  0x4a0b6408, 0x17003b04, 0x2128640d, 0x120e2d04,   // lg.es.yo_443 so.sr.un_320  lg.sw.jw_554 sk.is.hu_332
  // [6f00]
  0x03193fa4, 0x090f25a0, 0x25001b07, 0x20002118,   // af.gl.nl_433 eu.lv.pl_322  tr.eu.un_420 jw.sq.un_740
  0x19530b55, 0x23001f0c, 0x640a1ba4, 0x100b0408,   // es.ht.gl_442 cy.ca.un_530  tr.pt.lg_433 fi.es.lt_443
  0x1b001f0c, 0x53001b1b, 0x3b001a2c, 0x32283bad,   // cy.tr.un_530 tr.ht.un_770  tl.so.un_990 so.sw.bs_643
  0x3f35640e, 0x190a08a9, 0x032508a9, 0x2d060d11,   // lg.zu.af_555 no.pt.gl_544  no.eu.nl_544 cs.de.sk_653
  // [6f10]
  0x190a01a4, 0x55003b2a, 0x53000d19, 0x3b1c1eac,   // en.pt.gl_433 so.rw.un_970  cs.ht.un_750 ms.id.so_632
  0x55003b23, 0x550153ee, 0x1f006807, 0x21132a07,   // so.rw.un_880 ht.en.rw_422  ig.cy.un_420 mt.et.jw_432
  0x280411a0, 0x13283bad, 0x11001702, 0x1e211c0d,   // ro.fi.sw_322 so.sw.et_643  sr.ro.un_220 id.jw.ms_554
  0x202d07ac, 0x1f52535a, 0x52531f0c, 0x06000913,   // it.sk.sq_632 ht.ha.cy_553  cy.ht.ha_543 pl.de.un_650
  // [6f20]
  0x32060707, 0x6e190a0e, 0x2d0d2955, 0x1e04530c,   // it.de.bs_432 pt.gl.hmn_555  sl.cs.sk_442 ht.fi.ms_543
  0x06230baf, 0x680952af, 0x1f3b0a5a, 0x5300320c,   // es.ca.de_655 ha.pl.ig_655  pt.so.cy_553 bs.ht.un_530
  0x271a6bad, 0x2a27520c, 0x3b0f1fa9, 0x3f4a35ee,   // ceb.tl.gd_643 ha.gd.mt_543  cy.lv.so_544 zu.yo.af_422
  0x25001318, 0x0800091a, 0x07082b13, 0x0c010212,   // et.eu.un_740 pl.no.un_760  vi.no.it_665 da.en.sv_654
  // [6f30]
  0x05010614, 0x112521ad, 0x0c06350e, 0x1e3b3112,   // de.en.fr_666 jw.eu.ro_643  zu.de.sv_555 az.so.ms_654
  0x31121005, 0x1b0e120c, 0x1e1c64ec, 0x0d3121a0,   // lt.hu.az_333 hu.is.tr_543  lg.id.ms_644 jw.az.cs_322
  0x1c041eee, 0x011b0eee, 0x202855a0, 0x07281a0c,   // ms.fi.id_422 is.tr.en_422  rw.sw.sq_322 tl.sw.it_543
  0x0b1153af, 0x2d002319, 0x0718645a, 0x0f002012,   // ht.ro.es_655 ca.sk.un_750  lg.ga.it_553 sq.lv.un_640
  // [6f40]
  0x110755af, 0x1800061b, 0x03230cee, 0x071328a9,   // rw.it.ro_655 de.ga.un_770  sv.ca.nl_422 sw.et.it_544
  0x1e290fad, 0x27351fee, 0x3f000a14, 0x1f001819,   // lv.sl.ms_643 cy.zu.gd_422  pt.af.un_660 ga.cy.un_750
  0x11003b14, 0x646b1b0c, 0x1e1c07a4, 0x0b230aa0,   // so.ro.un_660 tr.ceb.lg_543  it.id.ms_433 pt.ca.es_322
  0x081f0e04, 0x0a070f12, 0x3100231b, 0x530b6ba0,   // is.cy.no_332 lv.it.pt_654  ca.az.un_770 ceb.es.ht_322
  // [6f50]
  0x55070509, 0x210c2bee, 0x071321a7, 0x6b005307,   // fr.it.rw_444 vi.sv.jw_422  jw.et.it_532 ht.ceb.un_420
  0x100e0cad, 0x190a1809, 0x08005302, 0x080e010c,   // sv.is.lt_643 ga.pt.gl_444  ht.no.un_220 en.is.no_543
  0x11071c07, 0x55211c09, 0x0b120a5a, 0x2d0d02ec,   // id.it.ro_432 id.jw.rw_444  pt.hu.es_553 da.cs.sk_644
  0x5300250c, 0x2000091b, 0x08020c5a, 0x1c211e08,   // eu.ht.un_530 pl.sq.un_770  sv.da.no_553 ms.jw.id_443
  // [6f60]
  0x0c3518ec, 0x23002005, 0x0a003b11, 0x53002908,   // ga.zu.sv_644 sq.ca.un_330  so.pt.un_630 sl.ht.un_430
  0x0a002514, 0x29096e0c, 0x190b18a4, 0x0a283b0c,   // eu.pt.un_660 hmn.pl.sl_543  ga.es.gl_433 so.sw.pt_543
  0x35000212, 0x55002a29, 0x520a3b12, 0x06012b04,   // da.zu.un_640 mt.rw.un_960  so.pt.ha_654 vi.en.de_332
  0x062301a7, 0x3f03230e, 0x18174a02, 0x6e00230d,   // en.ca.de_532 ca.nl.af_555  yo.sr.ga_222 ca.hmn.un_540
  // [6f70]
  0x173132ee, 0x171e1107, 0x1e521c11, 0x19000702,   // bs.az.sr_422 ro.ms.sr_432  id.ha.ms_653 it.gl.un_220
  0x030f3fad, 0x03053f13, 0x29132dec, 0x04280dee,   // af.lv.nl_643 af.fr.nl_665  sk.et.sl_644 cs.sw.fi_422
  0x35104aa7, 0x3b200f12, 0x1e00100c, 0x1b1f31ee,   // yo.lt.zu_532 lv.sq.so_654  lt.ms.un_530 az.cy.tr_422
  0x05682813, 0x1f4a0e08, 0x110c07a0, 0x5200071b,   // sw.ig.fr_665 is.yo.cy_443  it.sv.ro_322 it.ha.un_770
  // [6f80]
  0x10000f05, 0x03000819, 0x120855a7, 0x022d080b,   // lv.lt.un_330 no.nl.un_750  rw.no.hu_532 no.sk.da_542
  0x0e4a52a9, 0x32030eee, 0x10160707, 0x1b524a0d,   // ha.yo.is_544 is.nl.bs_422  it.hr.lt_432 yo.ha.tr_554
  0x0c006b02, 0x061103ec, 0x13253b5a, 0x1c351eee,   // ceb.sv.un_220 nl.ro.de_644  so.eu.et_553 ms.zu.id_422
  0x020c03a0, 0x0b0f25a0, 0x131c08ee, 0x4a3f68ec,   // nl.sv.da_322 eu.lv.es_322  no.id.et_422 ig.af.yo_644
  // [6f90]
  0x213b0213, 0x13002919, 0x230b080e, 0x2d2a4a07,   // da.so.jw_665 sl.et.un_750  no.es.ca_555 yo.mt.sk_432
  0x0b006402, 0x28001f04, 0x0e136409, 0x21003119,   // lg.es.un_220 cy.sw.un_320  lg.et.is_444 az.jw.un_750
  0x21313b13, 0x060d1fad, 0x6e002b09, 0x061b12af,   // so.az.jw_665 cy.cs.de_643  vi.hmn.un_440 hu.tr.de_655
  0x3f1f35ee, 0x350231a0, 0x10043509, 0x0e081aee,   // zu.cy.af_422 az.da.zu_322  zu.fi.lt_444 tl.no.is_422
  // [6fa0]
  0x101235ee, 0x193b0a08, 0x0c042107, 0x52002102,   // zu.hu.lt_422 pt.so.gl_443  jw.fi.sv_432 jw.ha.un_220
  0x3f0f050c, 0x050621ee, 0x32051707, 0x11071760,   // fr.lv.af_543 jw.de.fr_422  sr.fr.bs_432 sr.bg.ro_664
  0x3b002d04, 0x04133b05, 0x0c1f08a0, 0x1c681e55,   // sk.so.un_320 so.et.fi_333  no.cy.sv_322 ms.ig.id_442
  0x056421a7, 0x1b286b08, 0x0b231109, 0x1a6b520e,   // jw.lg.fr_532 ceb.sw.tr_443  ro.ca.es_444 ha.ceb.tl_555
  // [6fb0]
  0x20001911, 0x4a002108, 0x1e1c0da4, 0x04060e04,   // gl.sq.un_630 jw.yo.un_430  cs.id.ms_433 is.de.fi_332
  0x0c00280c, 0x250f550d, 0x080229ee, 0x35642507,   // sw.sv.un_530 rw.lv.eu_554  sl.da.no_422 eu.lg.zu_432
  0x3f020308, 0x1e08550c, 0x12052aa7, 0x351123a0,   // nl.da.af_443 rw.no.ms_543  mt.fr.hu_532 ca.ro.zu_322
  0x112923ee, 0x00000101, 0x19090b12, 0x553220ad,   // ca.sl.ro_422 en.un.un_200  es.pl.gl_654 sq.bs.rw_643
  // [6fc0]
  0x0b00052b, 0x280f10ad, 0x531a1c0c, 0x1a6b1ca0,   // fr.es.un_980 lt.lv.sw_643  id.tl.ht_543 id.ceb.tl_322
  0x1c0f1ea4, 0x17291aa9, 0x6b251aa9, 0x320929ee,   // ms.lv.id_433 tl.sl.sr_544  tl.eu.ceb_544 sl.pl.bs_422
  0x0b050fec, 0x2b100faf, 0x3b6b64a6, 0x0e29100c,   // lv.fr.es_644 lv.lt.vi_655  lg.ceb.so_521 lt.sl.is_543
  0x1a1204a9, 0x0b00210c, 0x0e0811ec, 0x033f68a0,   // fi.hu.tl_544 jw.es.un_530  ro.no.is_644 ig.af.nl_322
  // [6fd0]
  0x27522904, 0x1e1c53a4, 0x0452550c, 0x2d0d0ea4,   // sl.ha.gd_332 ht.id.ms_433  rw.ha.fi_543 is.cs.sk_433
  0x32002504, 0x280e520d, 0x180a07a0, 0x19000908,   // eu.bs.un_320 ha.is.sw_554  it.pt.ga_322 pl.gl.un_430
  0x311b52a7, 0x076b1fa4, 0x093507ee, 0x092152ad,   // ha.tr.az_532 cy.ceb.it_433  it.zu.pl_422 ha.jw.pl_643
  0x08123b09, 0x2d0d53a4, 0x2d0603ee, 0x072805af,   // so.hu.no_444 ht.cs.sk_433  nl.de.sk_422 fr.sw.it_655
  // [6fe0]
  0x32171aa6, 0x190b35a4, 0x02002a02, 0x230b530c,   // tl.sr.bs_521 zu.es.gl_433  mt.da.un_220 ht.es.ca_543
  0x681b0708, 0x0d092da7, 0x28000b09, 0x050108a0,   // it.tr.ig_443 sk.pl.cs_532  es.sw.un_440 no.en.fr_322
  0x161118a7, 0x01530ca0, 0x0c09020e, 0x550b4aee,   // ga.ro.hr_532 sv.ht.en_322  da.pl.sv_555 yo.es.rw_422
  0x0e000c20, 0x13002d22, 0x521155ad, 0x23002112,   // sv.is.un_850 sk.et.un_870  rw.ro.ha_643 jw.ca.un_640
  // [6ff0]
  0x166429a0, 0x08025502, 0x202b31ee, 0x1b310e60,   // sl.lg.hr_322 rw.da.no_222  az.vi.sq_422 is.az.tr_664
  0x0c0d3f04, 0x21526407, 0x211020a4, 0x1f000e2a,   // af.cs.sv_332 lg.ha.jw_432  sq.lt.jw_433 is.cy.un_970
  0x23110ead, 0x20006e04, 0x0c190a14, 0x1b0e2aad,   // is.ro.ca_643 hmn.sq.un_320  pt.gl.sv_666 mt.is.tr_643
  0x192d0eb4, 0x0b230aad, 0x211f200c, 0x0e1f2009,   // is.sk.gl_754 pt.ca.es_643  sq.cy.jw_543 sq.cy.is_444

  // [7000]
  0x291317a0, 0x0b006b04, 0x53112012, 0x533f1c0b,   // sr.et.sl_322 ceb.es.un_320  sq.ro.ht_654 id.af.ht_542
  0x06072aa9, 0x281a350d, 0x190b07ec, 0x321707ee,   // mt.it.de_544 zu.tl.sw_554  it.es.gl_644 it.sr.bs_422
  0x110f25ad, 0x2835210e, 0x080e3fa0, 0x530325ad,   // eu.lv.ro_643 jw.zu.sw_555  af.is.no_322 eu.nl.ht_643
  0x3b002121, 0x28183b5a, 0x6e006813, 0x0c192504,   // jw.so.un_860 so.ga.sw_553  ig.hmn.un_650 eu.gl.sv_332
  // [7010]
  0x0a00232b, 0x64550c0d, 0x05002102, 0x08250c08,   // ca.pt.un_980 sv.rw.lg_554  jw.fr.un_220 sv.eu.no_443
  0x190a250d, 0x28182008, 0x2a0a6b12, 0x0c0806ee,   // eu.pt.gl_554 sq.ga.sw_443  ceb.pt.mt_654 de.no.sv_422
  0x041a1fad, 0x181a27ad, 0x1a0835ee, 0x321016a4,   // cy.tl.fi_643 gd.tl.ga_643  zu.no.tl_422 hr.lt.bs_433
  0x351f2812, 0x230f02a4, 0x1e000b04, 0x273518af,   // sw.cy.zu_654 da.lv.ca_433  es.ms.un_320 ga.zu.gd_655
  // [7020]
  0x6400290b, 0x2855010c, 0x09122a0e, 0x16292da6,   // sl.lg.un_520 en.rw.sw_543  mt.hu.pl_555 sk.sl.hr_521
  0x20001214, 0x063f08ac, 0x196401a7, 0x2b1c01a6,   // hu.sq.un_660 no.af.de_632  en.lg.gl_532 en.id.vi_521
  0x0812290c, 0x2d090205, 0x03000405, 0x041e1902,   // sl.hu.no_543 da.pl.sk_333  fi.nl.un_330 gl.ms.fi_222
  0x25091208, 0x250d1ba4, 0x2a00201b, 0x521331ee,   // hu.pl.eu_443 tr.cs.eu_433  sq.mt.un_770 az.et.ha_422
  // [7030] --- double_langprob_start=7037 ---
  0x2a00640e, 0x5368350e, 0x030d200c, 0x20000e07,   // lg.mt.un_550 zu.ig.ht_555  sq.cs.nl_543 is.sq.un_420
  0x0a112d04, 0x080635a0, 0x286b11a0,               // sk.ro.pt_332 zu.de.no_322  ro.ceb.sw_322
                                                    //
  };

//  COMPILE_ASSERT(28727 <= 32768, k_indirectbits_too_small);

extern const CLD2TableSummary kQuad_obj = {
  kQuadChrome0122_16,
  kQuadChrome0122_16Ind,
  kQuadChrome0122_16SizeOne,
  kQuadChrome0122_16Size,
  kQuadChrome0122_16KeyMask,
  kQuadChrome0122_16BuildDate,
  kQuadChrome0122_16RecognizedLangScripts,
};

static const uint32 kQuadChrome0122_16_2Size = 8192;    // Bucket count
static const uint32 kQuadChrome0122_16_2KeyMask = 0xffffe000;    // Mask hash key

static const IndirectProbBucket4 kQuadChrome0122_16_2[kQuadChrome0122_16_2Size] = {
  // hash_indirect[4], tokens[4] in UTF-8
   {{0x6563a002,0x6443a003,0x6fdfa004,0x2d932005}},	// [000] kenh, huni, pêch, _foxe_,
   {{0x63bbc006,0x69db8007,0x109b0008,0x764f2009}},	//   hiun, _akue, _סביב, önyö,
   {{0x7afce00a,0xf536e00b,0x25a9400c,0x6d59c00d}},	//   žrtv, שטער_, bhal_, _obwa,
   {{0x7ddec00e,0x6e24000f,0xeae66010,0x3207e011}},	//   pësi, _kwib, _करीत_, _muny_,
   {{0xddc42012,0x99984013,0x63bbc014,0xa91d8015}},	//   _mriž, strų_, diun, _požr,
   {{0x0877000b,0x2451a016,0x77644017,0x98a32018}},	//   יענט_, _bơm_, leix, lajā_,
   {{0x26cd8019,0xddc2e01a,0x7c85601b,0x2ca0800a}},	//   _exeo_, _prož, _луѓе, šid_,
   {{0x7c66801c,0x7d04001d,0x7416801e,0xdb0d401f}},	//   _پارل, _ngis, _نورا, riaç,
   {{0xe8d9e016,0x2007e020,0xa3d74021,0x44236022}},	//   _đỡ_, _auni_, ाकत_, _zwj_,
   {{0x27ed8023,0x321a6024,0x44248025,0xbbd0e026}},	//   _zhen_, oppy_, _iwm_, सकेक,
   {{0x63bae027,0x6ed62026,0x1ddfa028,0x59dfa029}},	//   ritn, _मुलु, _पीटत, _पीटर,
   {{0x2007e02a,0x7c2f002b,0xac19002c,0x2419002d}},	//   _duni_, tscr, лому_, ломы_,
   {{0x7528a02e,0xdb03a02f,0x98a24030,0x229cc031}},	//   _kedz, cinó, _bekč_, _dákú_,
   {{0xd83f8032,0x53d6a033,0x7bd8a034,0x7d040035}},	//   _účet_, धविश, novu, _egis,
   {{0x25f34010,0x212b0036,0x63a64037,0x2007e038}},	//   ंगली_, pach_, _blkn, _guni_,
   {{0x6563a039,0x7afdc03a,0x291ee03b,0xdcfc603c}},	//   zenh, ľstv, lbta_, _sorğ,
   {{0x6b8d403d,0x69d7603e,0x6443a03f,0xfe09e016}},	// [010] rjag, toxe, zuni, _tắc_,
   {{0xa3e6e040,0x67c1c041,0x69db8042,0x0a51e043}},	//   पति_, rēji, _skue, _بھیج,
   {{0x7ddde044,0x7bd8a045,0xa3bc2046,0x7ff42047}},	//   mèst, dovu, _आगत_, _بسيا,
   {{0x44236048,0xdfc6c049,0x67c8c04a,0xb0be604b}},	//   _vwj_, _ري_, dějo, ्थजग,
   {{0x6727604c,0xed59c04d,0x3ce00022,0xd6ab8049}},	//   _tejj, niže_, _xyiv_, خدام_,
   {{0x672d404e,0xa349a04f,0x20090037,0x3e176050}},	//   laaj, узка_, _muai_, _نظرس,
   {{0x212ce051,0x3f9fc052,0x31582053,0x6d5aa030}},	//   dadh_, tkuu_, ייגן_, _dbta,
   {{0x69c98054,0x69cae055,0xdfd48056,0x62804057}},	//   _ujee, _ajfe, _досы, _ámoc,
   {{0x7bdd4058,0x3f9fc054,0x64456059,0x69d8a05a}},	//   _mksu, rkuu_, luhi, bove,
   {{0x4431205b,0xee3f005c,0x2475a041,0x3f9fc04e}},	//   ksz_, drý_, _tām_, skuu_,
   {{0x2ee0005d,0x59c7405e,0x4424805f,0xddc42060}},	//   _syif_, रचार, _zwm_, _priž,
   {{0x6d4bc057,0xdcfd4061,0x13a7e062,0x69d98063}},	//   _ucga, _ansč, انگی_, nowe,
   {{0x44312064,0x68e1a065,0x9c7ca066,0xda08c067}},	//   esz_, _hyld, _vyče, _tỏa_,
   {{0x2007e068,0x3171605d,0xa01b4069,0xb276c053}},	//   _tuni_, _nazz_, _kröf, _לענג_,
   {{0x443ee06a,0x98a32041,0x2365e06b,0xe73a406c}},	//   crt_, tajā_, melj_, лев_,
   {{0x6445606d,0x2a6d806e,0xdced406f,0x63bc2070}},	//   duhi, _oseb_, adač, sirn,
   {{0x46ea404d,0x32090071,0x69d8a072,0x65644073}},	// [020] удан_, _guay_, yove, reih,
   {{0x65660074,0xe8f74075,0x44770076,0xe80ac077}},	//   lekh, слу_, _פעיל_, _हंसा_,
   {{0x75298078,0x386d8071,0x7bde2079,0xee3a607a}},	//   _beez, _aser_, _ikpu, уне_,
   {{0x29dc807b,0x06d1807c,0x6d984057,0x3a3fc07d}},	//   vías_, ়েছি, _vías, krup_,
   {{0xdb0e6057,0x7e56807e,0x6609807d,0x98a4c041}},	//   _embá, стец, _cuek, kamā_,
   {{0xa97a200b,0xe9df2049,0xdb1ae00e,0x25b8607f}},	//   ראַכ, ltúr_, ritë, _umrl_,
   {{0x8c436080,0x443e6081,0x6b840082,0xdb060064}},	//   _нере, _ít_, _onig, nikó,
   {{0xb800207c,0xdb1ae083,0x20024068,0xa814c084}},	//   ্ঠিত_, mité, _jiki_, одиш,
   {{0xfd0fc085,0x5ebb400b,0x6ab2e086,0x8f9b4087}},	//   رجي_, ָזיק, ुप्र, טיקי,
   {{0x67c1c041,0x69de2088,0xddcd2089,0x200a608a}},	//   dēju, _nkpe, _krať, _kubi_,
   {{0x2258e052,0x3860008b,0xcb04008c,0x4df8408d}},	//   шины_, _apir_, रखंड_, ंगाई_,
   {{0x6446008e,0x443ee08f,0xd2510049,0xa5bb6031}},	//   fuki, rrt_, ونج_, _awól,
   {{0xddc2e041,0xb5fb603e,0xeabf4090,0x27fc802e}},	//   _esoš, _tráx, _ceùl_, ívny_,
   {{0xa2c5c010,0x67c54013,0x61142091,0xfe37c00b}},	//   ापर्, mėji, здру, _פרוי_,
   {{0x200a6092,0x3d950093,0x5ba74094,0x71bbe095}},	//   _nubi_, _микр, браз, _תצוג,
   {{0x69de2096,0x2d8c2097,0x8aa7003b,0x21204098}},	//   _ekpe, öder_, _грод, gbih_,
   {{0x85b96099,0x63a2809a,0xe450409b,0xc1b9609c}},	// [030] алас_, dkon, فضل_, алах_,
   {{0x200a609d,0x5a34409e,0xfe09e067,0x6440c049}},	//   _bubi_, янут, _mắn_, irmi,
   {{0x660ae09f,0x67298096,0x98afe04d,0x98b860a0}},	//   _jufk, _peej, ćaće_, _barı_,
   {{0x8f474052,0x443fc0a1,0x6b84e0a2,0x8afdc0a3}},	//   _уход, yru_, _ɗiga, deřn,
   {{0xd246c0a4,0x7ae2c0a5,0x317160a6,0x4425a0a7}},	//   _تن_, _nyot, _tazz_, _swl_,
   {{0xa2b860a8,0x37cf007c,0x63a760a9,0x65aa4066}},	//   ्पश्, রতির, _uljn, _výhe,
   {{0xa2c140aa,0x80da807c,0x443fc0ab,0x2903e0a9}},	//   लपक्, _বৃদ্, wru_, žjak_,
   {{0xa3e9404a,0xdb0bc0ac,0x2fc940ad,0x2a6d8048}},	//   यति_, _omgå, nnag_, _tseb_,
   {{0x320a6066,0xf1bf006f,0xfe09e067,0x6d4b80ae}},	//   _zuby_, diá_, _cắn_, mgga,
   {{0x200360af,0x61e440b0,0x6d5c605d,0x644600b1}},	//   _jiji_, zlil, _xbra, vuki,
   {{0x64472098,0x386000b2,0x6d4f40b3,0x4426c0b4}},	//   juji, _spir_, _occa, _ewo_,
   {{0x212b406f,0x2451e0b5,0x9f5860b6,0x8b67c0b7}},	//   _nech_, rám_, _mirá_, _دائم,
   {{0x69dbc0b8,0xa2e660b9,0x399c404a,0x25bfc0ba}},	//   moue, _कर्ज_, _míst_, miul_,
   {{0x656600bb,0x008620bc,0x63a280bd,0xb4fa80be}},	//   sekh, олго, zkon, יפרי,
   {{0x63bb80bf,0xa06a20c0,0x6603e0c1,0x2fcd8037}},	//   _omun, шава_, _iink, _ojeg_,
   {{0xdb01e049,0xc052e076,0x798400c2,0xe3bf0057}},	//   chlá, _חזה_, _uniw, ciñ_,
   {{0x69c9c0c3,0xb886c0c4,0xa3e60028,0x25e300c5}},	// [040] inee, mtíð, _बीए_, _टीटी_,
   {{0x63a980c6,0x4427e0c7,0x660bc058,0x644720c8}},	//   _alen, _kwn_, _mugk, buji,
   {{0x7bdc20c9,0x7dd60009,0x200360ca,0x7e7d40cb}},	//   moru, dász, _diji_, _ersp,
   {{0x9f5860cc,0xec7a80cd,0x7bdae0ce,0x2d85a061}},	//   _dirá_, ипе_, zotu, _anle_,
   {{0x938aa0cf,0xeafa20d0,0xdb1c20d1,0x200b40d2}},	//   иска_, _حرکت_, tirè, _guci_,
   {{0x7a1520c2,0x200360d3,0xe3bf00d4,0x2b4fc0d5}},	//   _wąte, _giji_, ziñ_, _acgc_,
   {{0x6da680d6,0x9939a0d7,0x7a11a0d8,0x8fa680d9}},	//   _дива, сячу_, _pāta, _даве,
   {{0x68e400da,0xe29a80db,0x2002c0dc,0x7e9b200b}},	//   _oyid, _каб_, öki_, יסצו,
   {{0x672bc0dd,0x0b8ae0de,0x3ea040df,0x54ee80c2}},	//   _degj, асни_, nyit_, _जरिए_,
   {{0x81f6a0e0,0x672f00c2,0x7d1b604d,0xdb1d00e1}},	//   _بہتر_, wacj, _đusk, misé,
   {{0x63bb80e2,0x6ac640e3,0x6441e0e4,0x7bdae0e5}},	//   _ymun, लपुर, grli, rotu,
   {{0x75eda0e6,0xc486c0e7,0x27e000e8,0x7bdae0e9}},	//   púzc, _млек, _ckin_, sotu,
   {{0x7ae4000f,0x212b40ea,0xa2d6c0eb,0xf1bf002e}},	//   _cyit, _rech_, _بيشت, riá_,
   {{0x1dbca0ec,0x27e000ed,0x7bdc20ee,0x67efe065}},	//   ्चित, _ekin_, goru, tøje,
   {{0x644280ef,0x212b40f0,0x8438e049,0xa3bc20f1}},	//   hroi, _pech_, _اكبر_, _आगर_,
   {{0x02a30079,0x7e62c037,0x63a440f2,0x764280f3}},	//   _apụọ, _kpop, gkin, kroy,
   {{0x7aed00f4,0x98a32064,0x3f86c066,0x200ca0f5}},	// [050] _uzat, dają_, _mnou_, _ludi_,
   {{0x200480f6,0x81c2c07c,0x601360f7,0x6568e0f8}},	//   _aimi_, ৃতি_, _aħma, nedh,
   {{0x212b40b3,0x200480f9,0x2367a07f,0x200b40a2}},	//   _tech_, _bimi_, venj_, _wuci_,
   {{0x644280fa,0x45d540fb,0x9f5860fc,0x27e680fd}},	//   froi, _хомс, _virá_, glon_,
   {{0x6448e0fe,0x0c2480ff,0x399c40c4,0xab5dc0c2}},	//   hudi, дмін, _víst_, niże,
   {{0x69dd0100,0x7b646101,0x6d4d4102,0xeb96a103}},	//   hose, _отсе, lgaa, зиш_,
   {{0xe739c104,0x3167a105,0x25bfc0ba,0x98ba2106}},	//   бей_, renz_, tiul_, _yapı_,
   {{0xfe6e4043,0x69dd0107,0x64576048,0x3f994108}},	//   _جگہ_, jose, mtxi, _josu_,
   {{0x69c9c109,0x6604010a,0x6442810b,0xa3db2033}},	//   rnee, _riik, croi, ़वा_,
   {{0xd6c6810c,0x27e00076,0x7ae3e10d,0x6e29810e}},	//   _عملی, _skin_, _pynt, _iweb,
   {{0x320d810f,0x6441e110,0xe9da0111,0x6448e112}},	//   _huey_, urli, йко_, gudi,
   {{0x7bcb8113,0x660bc114,0x6441e115,0x69cb8116}},	//   nngu, _tugk, rrli, nnge,
   {{0x68e3e117,0x920be118,0x2611a119,0xa3db611a}},	//   _wynd, _सूरज_, _háo_, डका_,
   {{0xdb15211b,0x660d0037,0x7c29811c,0x6604011d}},	//   tizá, _duak, _mwer, _wiik,
   {{0x386dc11e,0x8e83211f,0xcb12e095,0x69dd0120}},	//   lwer_, нгре, _אלו_, bose,
   {{0x3f986121,0x394dc122,0x7643a058,0x7bdc2123}},	//   _soru_, nges_, irny, soru,
   {{0x44290124,0xfe09e119,0x9f428125,0xdce3a126}},	// [060] _gwa_, _mắm_, _óké_, denč,
   {{0x7bc0c127,0x69c1e128,0x64412129,0x98a5e12a}},	//   zimu, nile, álic, cală_,
   {{0x2ca0412b,0x44290030,0x7c29812c,0xddc9a12d}},	//   syid_, _zwa_, _awer, _brež,
   {{0x21024013,0x5f4620e0,0x6e29811d,0x9f404071}},	//   _ačiū_, _بنگل, _bweb, rmió_,
   {{0x212d8037,0xa3cbe010,0xff03812e,0x20048012}},	//   _deeh_, रचा_, няшн, _vimi_,
   {{0x46db212f,0x2d99400f,0x27e68130,0x201ee131}},	//   _मुँह, _zose_, slon_, ypti_,
   {{0x2d994132,0xdce3a133,0xdbc76134,0x7c364135}},	//   _yose_, benč, töös, lsyr,
   {{0x69c380e0,0x6d9cc049,0x6b99c136,0x75244108}},	//   énet, _réas, _cowg, nbiz,
   {{0x7643a137,0x66064138,0xdcebc041,0x7bc1e12a}},	//   arny, _mikk, _pagā, filu,
   {{0xa1c3a139,0xaf12c125,0xb21b0069,0x6c33813a}},	//   _збуд, _aụtụ, lvæg, _أفلا,
   {{0x442a613b,0x7bdd013c,0x69c0c13d,0x7988a00f}},	//   _jwb_, tosu, pime, _indw,
   {{0x65b0204e,0x6568e0eb,0x7524413e,0x6444413f}},	//   _lähd, sedh, jbiz, krii,
   {{0x98a5a041,0x67244140,0x76444141,0x63aae057}},	//   _ielā_, dbij, jriy, _tlfn,
   {{0x65b0204e,0x44446142,0x77ade057,0x24800143}},	//   _nähd, kr_, _púxe, _drim_,
   {{0x66064144,0x69cb8145,0x69dd0146,0x31694108}},	//   _bikk, ynge, pose, teaz_,
   {{0x44446147,0x2ba9a148,0x63a60149,0x1994414a}},	//   dr_, _कत्थ, ckkn, нася,
   {{0xa2bea14b,0x113c0076,0xdb1d014c,0x9c194049}},	// [070] _वेस्, _התחל, rnsä, زياء_,
   {{0x6443a14d,0x6d4d414e,0x7ae6414f,0x09c5804b}},	//   yrni, sgaa, _dykt, लच्य,
   {{0x7bcb8150,0x44446151,0x67244152,0x44386065}},	//   tngu, gr_, bbij, _cvr_,
   {{0x65608153,0x9f5ea0f9,0x69c28154,0x386dc155}},	//   _cbmh, _dití_, gioe, ywer_,
   {{0x78a12156,0xf8aea0e0,0x9f964076,0xd838a157}},	//   älvf, یکم_, _חדרה_, _avč_,
   {{0xdcfc603b,0x442a6048,0xfa780095,0xedf7c158}},	//   _norė, _fwb_, פעות_, ुद्ध_,
   {{0xd4986159,0xdb03e089,0x2006c15a,0x6280815b}},	//   _ерт_, _plní, _bioi_, _ermo,
   {{0xd8382066,0xcda98050,0x7c29815c,0xbc566066}},	//   áči_, _بهره_, _twer, žšíc,
   {{0xe1f9c013,0x2005a15d,0x6280815e,0xa3da815f}},	//   rmų_, _tili_, _grmo, ठकर_,
   {{0xdb1e2004,0x442a6022,0x644b8160,0x2d890161}},	//   _empê, _ywb_, mugi, _anae_,
   {{0xdb082162,0xfe09e016,0x799b8163,0x386dc095}},	//   _élém, _tắm_, _kouw, swer_,
   {{0x2006c067,0x76444164,0x69de6165,0x21e420cb}},	//   _gioi_, yriy, zope, höht_,
   {{0x644b8166,0xfd4ee088,0x69de6167,0x8db5e0ff}},	//   nugi, _jenụ, yope, _оскі,
   {{0xb5fb6168,0x44446169,0x2ca9e04a,0x3f89016a}},	//   _spán, yr_, _řadu_, _enau_,
   {{0x65b0216b,0x91e6416c,0x68e640ff,0x764b80ae}},	//   _nähe, дове, _sykd, hugy,
   {{0x2360016d,0x27e9416e,0x2fcdc16f,0xdb1c2019}},	//   _ubij_, glan_, nneg_, mirí,
   {{0x7bc28170,0x6e36403b,0x76444054,0x66076171}},	// [080] viou, usyb, uriy, _bijk,
   {{0x76444172,0x200fc173,0x61e9c174,0x6aa28167}},	//   rriy, _mugi_, hlel, vyof,
   {{0x7bde6175,0x1d0a4176,0xb4db40f9,0x6444410a}},	//   ropu, _мени_, _adàd, srii,
   {{0x6b9b8177,0x2007e178,0x660f4179,0x29d7417a}},	//   _coug, _lini_, _fuck, għad_,
   {{0x2613e016,0x4422017b,0x69c3a17c,0x660f40cb}},	//   _lão_, npk_, fine, _guck,
   {{0x69c3817d,0x61fbc17e,0x443860ba,0x69c2817f}},	//   éner, emul, _tvr_, sioe,
   {{0xb1134125,0xa2bea180,0xe3b90181,0xa967a182}},	//   _tụta, _वेश्, rsız_, фија_,
   {{0xdb1c2183,0x200ee184,0x2240a06f,0x644b8185}},	//   dirí, _rufi_, čik_, bugi,
   {{0x212fc037,0x6281a186,0xdb1c6187,0x7bc3a188}},	//   _degh_, _erlo, _amré, binu,
   {{0x2613e016,0x26070028,0x7bc3a189,0x61fbc18a}},	//   _bão_, _सूजी_, cinu, amul,
   {{0x3178618b,0xdb1e218c,0x799c616f,0x61e8e18d}},	//   _marz_, _impè, _morw, rldl,
   {{0x61e9c18e,0x7ac6c18f,0x2d9e2190,0x200fc191}},	//   clel, _осле, öten_, _fugi_,
   {{0xd378a143,0x69cb6009,0x6ce4014f,0x79fbc076}},	//   _kać_, égek, віре, _ולאח,
   {{0x0cd4e192,0xe4c7c0eb,0xddc9e04a,0xa5c6c193}},	//   _полю, _تصمی, kteř, bjóð,
   {{0x224b0037,0x7bc08194,0x27e04037,0x63ad0194}},	//   suck_, _ommu, foin_, _tlan,
   {{0x60d5605d,0x22468195,0x6608a196,0xdb072052}},	//   _rxzm, krok_, _lidk, kijö,
   {{0x7777217a,0x79898197,0x24584052,0x645ae198}},	// [090] _taxx, _rnew, мать_, ltti,
   {{0x644b8132,0xd378a199,0xf993619a,0x5c75219b}},	//   vugi, _nać_, خبر_, _злот,
   {{0x2458e026,0x5335419c,0x6b9b8012,0xc808e067}},	//   ném_, _пент, _poug, _cởi_,
   {{0xa295419d,0x68e76066,0x4421619e,0xe3c2419f}},	//   _замі, _vyjd, rph_, tmış_,
   {{0x61e0c1a0,0x9f5880d5,0x251a41a1,0xa3b62026}},	//   doml, _auró_, _מורא, चोक_,
   {{0xdb18a1a2,0x6562c1a3,0x6281a1a4,0xe3c24181}},	//   tivá, _aboh, _prlo, rmış_,
   {{0x6e2d01a5,0xc2e7a1a6,0x644b81a7,0x7d0d01a8}},	//   _lwab, গেনি_, sugi, _ogas,
   {{0xf41f4156,0xceb261a9,0x644601aa,0xdb1e21ab}},	//   _träd_, _עין_, yrki, _empè,
   {{0xf771e1ac,0x3ce90048,0x7bc3a1ad,0xcc178050}},	//   هاد_, _nyav_, pinu, _آذرب,
   {{0x6f0d000f,0x753520f7,0x2613e1ae,0xdb1c21af}},	//   _agac, jazz, _pão_, tirí,
   {{0x6ac801b0,0xddc601b1,0x7c2d01b2,0x65c60101}},	//   रप्र, ебни, _awar, ебна,
   {{0x9984c13a,0x8d7601b3,0x31794064,0xdb1c21af}},	//   _للمو, راجا, _nasz_, rirí,
   {{0xe9f9e1b4,0x80d9607c,0x443a21b5,0x23ae4069}},	//   _енді_, ভেচ্, _svp_, _nýja_,
   {{0x7d0d01b6,0x27e161b7,0x3cf54077,0x7bc561b8}},	//   _egas, john_, ्धने_, jihu,
   {{0x799d41b9,0x638321ba,0x4422005d,0x27e041bb}},	//   _bosw, ыгра, spk_, toin_,
   {{0xeb9741bc,0xed640066,0xe61a41bd,0x6283e0e6}},	//   нис_, _drží_, зда_, _irno,
   {{0x6d560132,0x765bc1be,0x2b400098,0x178660fb}},	// [0a0] _icya, ntuy, _idic_, нгам,
   {{0x290d81bf,0xe1f2219a,0xa5bb60f9,0x7bc5600f}},	//   _agea_, _حسب_, _atób, gihu,
   {{0xb14681c0,0x75d36049,0xe1f241c1,0x65ab20cb}},	//   енел, ديلا, _مسح_, _mühl,
   {{0x80daa026,0xa2daa026,0x501b2076,0x765bc0ae}},	//   _पुगे, _पुग्, _מוטו, ktuy,
   {{0x7c2281c2,0x61e6417a,0x3ce90048,0xdb1e61c3}},	//   upor, _ikkl, _xyav_, lipí,
   {{0x798bc1c4,0x7bc601c5,0x442001c6,0x765ae052}},	//   _angw, hiku, _mti_, ytty,
   {{0x387240e2,0x412a81c7,0x765c21c8,0x442000f9}},	//   lwyr_, _ново_, ntry, _lti_,
   {{0xedc8e1c9,0x7bc081ca,0x7bc60167,0x2c26c0ff}},	//   िच्छ, _ummu, jiku, ньог,
   {{0xdb1e21cb,0xc7c6e1cc,0x387241cd,0xb88681ce}},	//   _empé, есни, nwyr_, _blíž,
   {{0x6282c1cf,0x9f588017,0x7abb4076,0x61e0c1d0}},	//   _vroo, _turó_, פציו, soml,
   {{0x61fe61d1,0xddcd21d2,0xf363e1d3,0x6e2d01d4}},	//   impl, _praž, утын, _swab,
   {{0xd469a13a,0x645c21d5,0xb4cca1d6,0x38cba050}},	//   _تحكم_, dtri, रपी_, _عالی_,
   {{0x753521d7,0xddcd21d8,0x65ab2105,0x21ef6105}},	//   tazz, _vraž, _fühl, fühl_,
   {{0x645c2105,0xb894e049,0x61e281d9,0x7c94e049}},	//   ftri, _للتع, hool, _للتص,
   {{0x645c21da,0x7bc2c05d,0x777aa1db,0x2d9ea14f}},	//   gtri, _kmou, _matx, _mote_,
   {{0x6e3ae1dc,0xdb18a1dd,0xdb1c21de,0x6dab01df}},	//   mstb, livä, tirã, rƙas,
   {{0x7c2441e0,0x3df521e1,0x656d41e2,0x717961e3}},	// [0b0] gpir, _изис, reah, мбар_,
   {{0x201161e4,0x442d81e5,0x75f60026,0xa91d81e6}},	//   _puzi_, _rwe_, ráze, _inži,
   {{0x765d01e7,0x6e3ae1e8,0x22a741e9,0x6e208194}},	//   ltsy, nstb, _bíkú_, _atmb,
   {{0x27e161ea,0x660ae143,0xa5bb60f9,0xa03a200b}},	//   sohn_, _lifk, _awót, _קערפ,
   {{0x8a1841eb,0xaf12c088,0x539a4076,0x3f9ea1ec}},	//   _пояс_, _rụpụ, _חירו, _botu_,
   {{0x7ddd00e0,0x69c2c1ed,0x66098064,0xcb66a16c}},	//   gész, _amoe, _wiek, ваше_,
   {{0x69d56171,0xdb1c21ee,0x9e3561ef,0xdb0f0057}},	//   _ijze, nirá, _шевч, nicó,
   {{0xceb8e064,0x442d800f,0x68e36105,0x656f01f0}},	//   dzę_, _twe_, ündu, jech,
   {{0x443ce1f1,0x6448e1f2,0x212941f3,0x61ed41f4}},	//   _avv_, erdi, ibah_, ilal,
   {{0x7c3ae1f5,0x387fc1f6,0x4c85e1f7,0x2132005d}},	//   fstr, rvur_, влов, _seyh_,
   {{0xa91d8098,0x3869012a,0x657b81f8,0x7bc721f9}},	//   _anži, _apar_, _kauh, diju,
   {{0x2ca7a0c4,0xdb0f0057,0x799e21fa,0x656e21fb}},	//   mynd_, dicó, _sopw, webh,
   {{0x7c3ae1fc,0x6729c1fd,0xe56ee12a,0x657b81e7}},	//   astr, mbej, _кз_, _mauh,
   {{0x7c3ae1fe,0x7bc601ff,0x6f0f4057,0x6f1d4200}},	//   bstr, siku, _agcc, _afsc,
   {{0xed5a4201,0x7bc3e202,0x6449c203,0xcf92a087}},	//   мов_, _imnu, lrei, סטל_,
   {{0x765c209a,0xd00f0043,0x273c6026,0xb602c069}},	//   rtry, صلہ_, kání_, _þátt,
   {{0x7bc72204,0x6e3c6205,0x7e698206,0x6449c207}},	// [0c0] biju, _svrb, _npep, nrei,
   {{0x61e3a208,0xa2b78209,0x7c24420a,0x7aebc013}},	//   jonl, ्छन्, rpir, _mygt,
   {{0xf1c6020b,0x442fc048,0x2d9e4004,0x27e7e05d}},	//   _लगान, _lwg_, êtes_, _mknn_,
   {{0x657aa20c,0x09d5e07c,0x248d420d,0x18a6820e}},	//   _sath, _সীমা, _šeme_, каем,
   {{0x61e3a20f,0xaca44088,0x777aa108,0x7c3bc143}},	//   fonl, _kpọt, _patx, jsur,
   {{0xdb0b8069,0x201aa1ae,0x35c84028,0x7649c210}},	//   rigð, ípio_, _रगड़, drey,
   {{0x2b586211,0x69c40212,0x6449c213,0xd04d00e8}},	//   _icrc_, _omie, erei, _fyaɗ,
   {{0xadf84064,0x2489c00a,0x44224214,0x61e44052}},	//   ंगटन_, _šama_, _ktk_, noil,
   {{0x7c3bc215,0x4422405d,0xa3b660a8,0xa806a0ba}},	//   gsur, _jtk_, _जता_, _азал,
   {{0xa2bb8216,0x21382217,0x27edc218,0x7aebc065}},	//   _शेट्, jarh_, alen_, _dygt,
   {{0x2bafa219,0x61e4404e,0x4256a21a,0x61ed421b}},	//   जघरा, koil, _штат, ylal,
   {{0x645d00ff,0x7649c069,0x67f8804a,0x75f8804a}},	//   ttsi, brey, bíje, bíze,
   {{0x6449c21c,0x1074021d,0x6282821e,0x200ca0e8}},	//   crei, аляю, nvoo, _kidi_,
   {{0x8f34e21f,0xfe6fe062,0x261761f6,0x65664220}},	//   _секц, حدی_, _bħol_, _abkh,
   {{0x2fcd20e4,0x53342221,0x645d0222,0x9f43200e}},	//   đeg_, рест, stsi, lojë_,
   {{0xa01b4156,0x442fc223,0x62816057,0x77b02156}},	//   _fröl, _ywg_, _áloi, _växa,
   {{0x657c61cd,0xfe70413a,0xdb0080e0,0x200b4224}},	// [0d0] _barh, يدك_, _elmú, _vici_,
   {{0x660d0187,0x200ca225,0x39586153,0x4c952226}},	//   _hiak, _nidi_, _ccrs_, _биос,
   {{0x3958402e,0xdce40227,0x443ea228,0x7bc52229}},	//   _šesť_, _iniġ, _nvt_, _imhu,
   {{0xdb1ae22a,0x2fc7a22b,0x81458050,0x9f43200e}},	//   litä, wing_, انشن, kojë_,
   {{0x777c6054,0x657b8052,0x7c22c22c,0xdb072156}},	//   _farx, _vauh, _ntor, shjä,
   {{0xdb0760e0,0xdb1ae22d,0x7aebc22e,0x2fc94048}},	//   _eljá, nitä, _rygt, liag_,
   {{0x6e22c22f,0x6e95a230,0x2486c231,0xfc3f4232}},	//   _atob, العا, _arom_, _hví_,
   {{0x7ff5c233,0xfe738050,0x63a080e8,0x27edc234}},	//   دستا, _پدر_, _gomn, ulen_,
   {{0x7c3bc235,0x68ed0236,0x6f1bc237,0x2486c238}},	//   usur, _nyad, rcuc, _crom_,
   {{0x7d1bc239,0x200ca082,0xdddba23a,0x6d42c024}},	//   scus, _gidi_, _fruš, _edoa,
   {{0x27e90058,0xbb55c050,0x7c3bc23b,0x660bc0ae}},	//   _bkan_, _مناب, ssur, _tigk,
   {{0xdea3a043,0xaca3c096,0x6281e23c,0x973ca23d}},	//   _میڈی, _atụm, rvlo, _voće,
   {{0x61e5623e,0x2bc641b0,0x63ad423f,0x245c604a}},	//   kohl, रोफा, dkan, zím_,
   {{0x69c8e240,0x26198067,0x2d98e241,0x2bc60028}},	//   cide, _mèo_, öret_, _लगवा,
   {{0x61e4404e,0x61464242,0xb7dae0be,0x75d2e243}},	//   toil, лева, _אקסי, _ديوا,
   {{0xa6960244,0x777c6005,0x3a224037,0xaca3c125}},	//   _број, _sarx, _ptkp_, _njịk,
   {{0x6aa9c245,0x7aed0246,0x05666247,0xfe0a0119}},	// [0e0] nyef, _gyat, лван, _dắt_,
   {{0x7c3ea248,0x4427a037,0xb17b0249,0xdb1e6057}},	//   špri, kpn_, blås, fipá,
   {{0x5336e00b,0x98a6224a,0xf539c06f,0xf536e00b}},	//   רנען_, _сине, kať_, רטער_,
   {{0xe29a424b,0x200ca24c,0xaf36824d,0x7bc8e24e}},	//   _зам_, _sidi_, ارات, zidu,
   {{0x61fb824f,0x07a6a250,0x8fa6a251,0xa2cb4026}},	//   _dhul, ладн, ладе, _सेप्,
   {{0x61fb8079,0x63a1a252,0x7bc8e253,0x44f3e254}},	//   _ehul, _coln, xidu, _ọ_,
   {{0xc9532095,0xdca36255,0x61fb8256,0xa5bb60c2}},	//   צמה_, _лари, _fhul, _twór,
   {{0x2d804257,0x9f43200e,0x200ca258,0x6738a259}},	//   ndie_, tojë_, _widi_, savj,
   {{0x27e6825a,0x8556a25b,0x6602825c,0x35b4e25d}},	//   moon_, _مخاط, mmok, ибир,
   {{0x63ad425e,0x104ae1ef,0x237fc143,0x27e9025f}},	//   zkan, нями_, aduj_, _skan_,
   {{0xa2cb4260,0xb603a261,0x2139000e,0xe81a80c2}},	//   _सेन्, íšen, tash_, _फंडा_,
   {{0x7a152064,0x69c9c171,0xe45f004e,0xa01b4156}},	//   _wątk, ciee, ttö_, _dröj,
   {{0xb21b422e,0x395a2030,0x62868012,0x44f3e031}},	//   _præm, _bcps_, _škoj, _ẹ_,
   {{0x6d564025,0xa01b4262,0x21390263,0x69c64264}},	//   egya, _fröj, sash_, _amke,
   {{0x753ae265,0x31712266,0x6e24003c,0x66028267}},	//   matz, rezz_, _etib, kmok,
   {{0x753560f7,0x65ab2268,0xb5a44013,0x29120194}},	//   _sezz, _mühi, бруй, _ggya_,
   {{0xec0a0067,0x443ee269,0x4423626a,0x7c3e626b}},	// [0f0] _vết_, lst_, _stj_, espr,
   {{0x60d3e041,0x7e6d026c,0x2489026d,0x673ae26e}},	//   ņemš, _ipap, _iram_, natj,
   {{0x5695226f,0xb87b4270,0x76b3e03c,0x63a1a064}},	//   _тант, _oxíg, təyə, _roln,
   {{0x68ee6271,0x628441b4,0x61e56272,0xa857e076}},	//   _dybd, bvio, sohl, ריאה_,
   {{0x443ee105,0x2369000e,0xfc3f0273,0x3cf300c2}},	//   hst_, _mbaj_, nsí_, _घरों_,
   {{0x61e72274,0x3a248057,0x2fc6c0ae,0x69d52105}},	//   nojl, _dtmp_, _amog_, nnze,
   {{0xa91dc098,0x9f6b80db,0x7bc9c275,0x3f91600f}},	//   hdže, _праз_, tieu, _inzu_,
   {{0x13d220ec,0xe045c276,0x629a2052,0x31b8c009}},	//   _सद्भ, ании, ätoi, _nézd_,
   {{0x984881e1,0x6446c03b,0xdb18e277,0x7bcb8278}},	//   _бяха_, škin, _omvä, migu,
   {{0x4465e279,0x237f8223,0x753ae27a,0x62898037}},	//   авов, _hauj_, gatz, _ireo,
   {{0x2489027b,0x232a027c,0x28c7427d,0x69c9c27e}},	//   _aram_, кони_, _रेसि, piee,
   {{0x888aa00b,0xdb0d027f,0xb4e5e031,0xd7060280}},	//   _שרײַ, _amañ, _alàà, изни,
   {{0x67d20041,0x753ae108,0x38bbe0f9,0x777f0227}},	//   nāji, batz, _báré_, _daqx,
   {{0x69cb8281,0x753bc282,0xdfd22049,0x443ee283}},	//   hige, lauz, زيز_, bst_,
   {{0x69cb8284,0x6da64052,0xac16e1e3,0x7bcb8285}},	//   kige, аива, _коју_, kigu,
   {{0xa92641d3,0x6d5b8286,0xa5264056,0x7bcaa287}},	//   рдал, _ncua, рмад, zifu,
   {{0x69cb8288,0x660f4289,0x7c29c28a,0xb425428b}},	// [100] dige, _dick, nper, معلو,
   {{0x6441a04a,0x7c29c28c,0xcb12e00b,0x1e3b0076}},	//   _ovli, iper, ַלד_, _שגיא,
   {{0x386d828d,0x63a3e28e,0x644d428f,0xb607a041}},	//   _aper_, _monn, arai, _mašī,
   {{0x1a2a80ff,0xb4e66290,0x317ea105,0xaca46291}},	//   вжди_, _पडी_, _satz_, _nwụr,
   {{0xdce1a03b,0x7e7b8009,0xa2ca2292,0x2e3c60f9}},	//   _kalė, _csup, _हेत्, _báfá_,
   {{0x98a4804a,0x66028293,0x973ca294,0x2fc7e1e7}},	//   _země_, smok, _boća, _nmng_,
   {{0x7880a295,0x69d64296,0x03968297,0xdca66298}},	//   dává, onye, _края, _тави,
   {{0xef18a041,0x6288a299,0x77b84005,0x2fc7e0ae}},	//   _daļa_, _vrdo, _fíxe, _amng_,
   {{0x7c29c29a,0xb997c052,0x443fc1e7,0xbcfb029b}},	//   gper, рвых_, gsu_, gfél,
   {{0x200fc069,0xed59c29c,0x237f805d,0x6b82829d}},	//   _eigi_, dižu_, _zauj_, ldog,
   {{0x443fc29e,0xd378e29f,0x63b602a0,0x63a402a1}},	//   asu_, noći_, _blyn, _boin,
   {{0x224dc2a2,0x3f80001f,0xaca46079,0x31c702a3}},	//   brek_, _caiu_, _gwụr, рсов,
   {{0xdcfc62a4,0xddcd6089,0x6d5c62a5,0x23b542a6}},	//   _barċ, braň, _ocra, _nåja_,
   {{0x394d2105,0x6442c2a7,0x261c22a8,0x7bcb82a9}},	//   ßes_, _ivoi, _bío_, zigu,
   {{0x03c742aa,0x94a822ab,0xb87b4009,0x660f42ac}},	//   асам, атта_, _nyír, _pick,
   {{0x798082ad,0x4255e043,0xd5b842ae,0x5b1542af}},	//   _namw, _انٹر, асу_, смат,
   {{0x752d42b0,0x753d02b1,0x6d412069,0x7bcb80fa}},	// [110] rbaz, masz, ólas, vigu,
   {{0xa91d803b,0x261c22b2,0x69cb82b3,0xa2cb42b4}},	//   _maže, _fío_, wige, _सेण्,
   {{0x644d42b5,0x7c29c2b6,0x660f42b7,0x2d81600e}},	//   srai, zper, _tick, rdhe_,
   {{0x67d202b8,0x798282b9,0x237f8022,0x48fe0026}},	//   tāji, gdow, _qauj_, रेको_,
   {{0xe6cba069,0x201862ba,0x27e942bb,0xb21b00c4}},	//   _íbúð, _euri_, moan_, kvæm,
   {{0x2d8122bc,0x6722c1e9,0x69cd41cd,0x85e8a0ff}},	//   _jahe_, _afoj, liae, адів_,
   {{0x38754106,0x0bb82076,0x69cb82bd,0x7c29c2be}},	//   şarı_, שלום_, pige, wper,
   {{0x27e7a0d1,0x673c22bf,0x2139400e,0x656982c0}},	//   sonn_, zarj, _jesh_, _ubeh,
   {{0x6440c2c1,0x628ae1cd,0x7c29c0d5,0x753bc2c2}},	//   gsmi, _arfo, uper, rauz,
   {{0xaca34088,0x4426c2c3,0x67f0604e,0x61e8e2c4}},	//   _adịb, _dto_, täji, godl,
   {{0x200fc2c5,0x2bc480a8,0x2d92005d,0x2cace1cd}},	//   _tigi_, लोवा, _pnye_, gydd_,
   {{0x673d00ff,0x2139400e,0xed5702c6,0x753d0009}},	//   gasj, _nesh_, бою_, gasz,
   {{0x7bcd42c7,0x644fc2c8,0xa91d82c9,0x98a041e4}},	//   diau, ácid, _gaže, mbić_,
   {{0xa2c242ca,0x64a622cb,0xf77f01de,0xdca2c2cc}},	//   _रेग्, бага, boço_, _хаши,
   {{0xe7e442cd,0xa91d82ce,0x290c22cf,0x6813e0ba}},	//   ककला_, _zaže, äda_, _pădu,
   {{0x224042d0,0x69d76057,0x2d8322be,0x3d2840eb}},	//   tsik_, enxe, adje_, شتری_,
   {{0x67f60066,0x644e22d1,0x27f242d2,0x07a342d3}},	// [120] nájm, srbi, rlyn_, чатн,
   {{0x27ff80f9,0x25a5a2d4,0x044622d5,0x6ee12079}},	//   _ahun_, _noll_, _леон, _ịbel,
   {{0x2bb96010,0x7bcd403b,0x0a4a6052,0xb5fb60f9}},	//   _इतरा, biau, узей_, _apás,
   {{0x628bc2d6,0x7e6282d7,0xb73a813a,0xa3bc4086}},	//   _orgo, ttop, اثاء_, _अति_,
   {{0x6f156012,0x95caa2d8,0x27ff82d9,0x25a5a2da}},	//   _fgzc, лука_, _dhun_, _boll_,
   {{0x3f8242db,0x69c982dc,0x6d5c62dd,0x38cba050}},	//   _haku_, _emee, _ucra, گاهی_,
   {{0xdfd2813a,0x9c87006f,0x37cde07c,0x6b81a2de}},	//   _فيس_, _kočí, রকার, _dalg,
   {{0xdbf10026,0xb8ce807c,0xdb1e62df,0x77b5c057}},	//   _příb, _ওই_, sipä, _páxa,
   {{0x1a9a400b,0x7bce22e0,0x201a22e1,0x29cd22e2}},	//   ריִע, kibu, _lupi_, džan_,
   {{0x1543a2e3,0xc07b40be,0x25a5a0fd,0xe7d6e07c}},	//   _неум, נטיש, _goll_, হত্য,
   {{0x644402e4,0x96f8e1fc,0xc986c12a,0x5186c2e5}},	//   _avii, рент_, _гули, _гула,
   {{0x224082d1,0x6b844171,0x25a5a105,0x78a12156}},	//   šiku_, jdig, _zoll_, älvm,
   {{0x644282e6,0x8b03a04a,0xa3e5c077,0xddc4206f}},	//   nsoi, ěřen, पकर_, _spiš,
   {{0x6b8442e7,0xf1bf6057,0x7bce22e8,0x673d02e9}},	//   edig, _atán_, gibu, sasj,
   {{0xdb01a2ea,0xa91dc00a,0x75f8806f,0x956200a2}},	//   _polé, ldža, vízn, _imمn,
   {{0x5c0742eb,0x2fc902ec,0x2011620f,0xb5fb21af}},	//   сяга, _umag_, _sizi_, ctán,
   {{0x656d02ed,0x644002ee,0x69cf02ef,0x953962f0}},	// [130] _ibah, ámit, mice, изат_,
   {{0x27e942f1,0xb5fb60f9,0x4427e05d,0x27374067}},	//   soan_, _apár, _ytn_, ần_,
   {{0xa63561b4,0x201162f2,0x78ad42f3,0x7a3f42f4}},	//   інді, _vizi_, syav, _bàtá,
   {{0x442902f5,0x69d8a2f6,0xb17b42f7,0x628d02f8}},	//   _kta_, enve, _sjåf, _krao,
   {{0xa91dc2f9,0x7ae4a121,0x6d5982fa,0x8c45807a}},	//   jdža, şitl, rgwa, целе,
   {{0x6e2d42fb,0x7dc9200a,0x3e61a0e0,0x661aa2fc}},	//   mpab, džsk, tót_, _butk,
   {{0x27ff82fd,0x79956105,0x6605c2fe,0x6b82c2ff}},	//   _thun_, _inzw, опка, _baog,
   {{0xaba9c14a,0x21f90089,0x63a76300,0x69cf0301}},	//   рвиз_, dého_, _hojn, jice,
   {{0x61e9c302,0x6b81a303,0x2d836304,0x0d99e099}},	//   roel, _talg, _kaje_, атны_,
   {{0x69ce2305,0xfc45e05c,0xdcf8e041,0x75240024}},	//   xibe, žíme_, _savā, _sfiz,
   {{0x2fcdc306,0x63bbc1fb,0xdca5e307,0xa5bb6031}},	//   pieg_, phun, цани, _atók,
   {{0x4e1d8308,0x2a7dc05f,0x628d0309,0x65bfc0f9}},	//   _पढाई_, _tswb_, _brao, _dàhù,
   {{0x333fc162,0x6443a30a,0x661b8046,0x3e45a018}},	//   maux_, lsni, _juuk, lēt_,
   {{0x25b940ae,0xab29e30b,0x7c2d430c,0x3f82430d}},	//   _alsl_, _тока_, dpar, _saku_,
   {{0x03a6030e,0x6b83e30f,0x213b017b,0x7c2d4310}},	//   _мико, _iang, _feqh_, epar,
   {{0x6b83e311,0x452a4312,0xbebb000e,0x628d0256}},	//   _hang, ржан_, rbër, _frao,
   {{0x7c2d4313,0x61eb8314,0x0dca6056,0xdb068315}},	// [140] gpar, dogl, алай_, ümün,
   {{0x79840316,0x7c24c13a,0xe81d8033,0xdb0e6317}},	//   _haiw, _éire, _पढ़ा_, _albá,
   {{0x3f6a4318,0x65b5c261,0x3f824319,0xe5a6431a}},	//   _кино_, _náho, _taku_, _дини,
   {{0x673aa31b,0x2d824286,0x3e45a018,0xb5fb2049}},	//   _setj, _uake_, dēt_, htál,
   {{0x7c2d4090,0x661aa31c,0x6d5bc1e2,0x7a4061e9}},	//   cpar, _sutk, dgua, _bátá,
   {{0x7bcbc1cd,0x26c20108,0x7983e0a2,0x1c3982cb}},	//   _amgu, izko_, _nanw, сяць_,
   {{0x442dc31d,0xdb03e31e,0x69d8a31f,0xc7b8c320}},	//   epe_, _foné, rnve, _luđe_,
   {{0x938ac084,0x442a6321,0xdb008322,0x466ac323}},	//   рска_, _itb_, _homí, аром_,
   {{0x2d83600f,0x63a28324,0x3f82c06f,0x753c6325}},	//   _yaje_, mjon, ľku_, _kerz,
   {{0x21f90326,0x628e6066,0x65b020cb,0x270ee03c}},	//   tého_, _krbo, _fähi, tən_,
   {{0x7983e327,0x3e45a041,0xa2ca2328,0x656d00ae}},	//   _danw, cēt_, _हेल्, _pbah,
   {{0x661c6329,0x3f86832a,0x2d84832b,0x6458a32c}},	//   _murk, ndou_, _jame_, muvi,
   {{0x4444632d,0x28c50260,0x6015a03b,0x395f0018}},	//   hs_, _लेखि, _išma, ļus_,
   {{0x9f5a20d1,0x7bcae0bb,0x65c0e031,0x3866832e}},	//   _sipò_, _umfu, _dáhù, itor_,
   {{0x7bcf032f,0x442a614f,0x6e2dc17a,0x661c6330}},	//   picu, _ntb_, _ħabi, _nurk,
   {{0x5f944331,0x2d9e2156,0x65b5c1ce,0x44204332}},	//   мист, öter_, _náhl, fqi_,
   {{0x31694333,0x1af1a07c,0x545541e1,0xf1bf0049}},	// [150] rfaz_, _চলছে_, яват, mhá_,
   {{0x6b840334,0x6602c07d,0x7bdae069,0x249d805f}},	//   _zaig, _lhok, nntu, vxwm_,
   {{0x2d83606e,0x64444335,0xe7198049,0xdb03e2a8}},	//   _vaje_, asii, ميات_, _poné,
   {{0x661c6336,0x248d81ab,0x127a200b,0x05b94043}},	//   _durk, _prem_, _פארע, _اگست_,
   {{0x628e6337,0xcb9a4095,0xa5f9a338,0x7643a037}},	//   _erbo, _הסרט, беду_, wsny,
   {{0xd6580076,0x79852339,0xd378e33a,0x6602c33b}},	//   קיות_, _jahw, jeć_, _ahok,
   {{0x6280833c,0x0577833d,0x629820fa,0x8d77833e}},	//   _esmo, _وارد, _àvot, _وارا,
   {{0x44394223,0xee39c33f,0x7bdae340,0x02a30079}},	//   _kws_, бни_, entu, _awọọ,
   {{0x7643a341,0x6e298342,0xd2518343,0x673d4344}},	//   ssny, _uteb, _سنا_, _mesj,
   {{0x79852058,0xd131a13a,0x77bcc057,0x69cd00fd}},	//   _nahw, _أما_, _réxe, _amae,
   {{0x9ee9a28b,0x44204345,0xa7fd0181,0x1815e046}},	//   _افضل_, zqi_, rtın, णदेव_,
   {{0x64444054,0x2c640346,0x628f4019,0x39404048}},	//   ysii, töd_, _orco, xais_,
   {{0x4279800b,0x661d4347,0x7bdae048,0x3a2f805d}},	//   זאָג, _nusk, bntu, npgp_,
   {{0x66156348,0x44446349,0x6b83e34a,0x7bcd034b}},	//   _nizk, ys_, _uang, _emau,
   {{0x661d434c,0xf1b9a2d1,0x656f4020,0xb5fb207b}},	//   _ausk, _guše_, _bbch, ctám,
   {{0x9c26434d,0xc7b8c0e4,0x661d409a,0x442a604d}},	//   здад, _tuđe_, _busk, _rtb_,
   {{0x753c634e,0xdee3434f,0x673d4350,0x2b404351}},	// [160] _perz, еоти, _desj, raic_,
   {{0x39420352,0x661c6353,0xb4b80354,0x6445600e}},	//   laks_, _purk, चनी_, fshi,
   {{0xdb0d0355,0x63a98356,0x27edc357,0x39404358}},	//   _plaç, _boen, koen_, pais_,
   {{0xe1ff2359,0x2009412a,0x7644435a,0x80cd835b}},	//   ntón_, cmai_, psiy, _देहे,
   {{0x7bc3800e,0x628f8057,0x69dae35c,0x29cd2143}},	//   ënua, _ácol, ynte, džaj_,
   {{0x661e235d,0x6d40c35e,0x68f60052,0x60c2835f}},	//   _kupk, wama, _myyd, rzom,
   {{0x66040265,0x3f85a360,0x38c8a0eb,0x629a6361}},	//   _ohik, _dalu_, غاتی_, _štof,
   {{0x3942010a,0xdef9a362,0x4439405f,0xdcfc6018}},	//   jaks_, цыі_, _yws_, _garā,
   {{0x44394223,0x6f02a0f9,0x442b4363,0x39420046}},	//   _xws_, _bíbí, _xtc_, daks_,
   {{0x6ce6e013,0x63a98171,0xe1ff2019,0x273ac119}},	//   зіме, _zoen, etón_, ẫn_,
   {{0x61ee2364,0x2009403b,0x27edc365,0xd378e320}},	//   dobl, ymai_, boen_, reć_,
   {{0x7bce603e,0xba9ba076,0x629a60fa,0x4efba0be}},	//   _lmbu, _לסבי, _àtou, _פלאג,
   {{0xbcfb4366,0x753d4367,0x5c072368,0x201ea229}},	//   _océa, _resz, зява, _huti_,
   {{0x673d4369,0xa91ca02e,0x9f5dc1e9,0x9178c031}},	//   _sesj, _maľo, _fiwó_, _fẹ́_,
   {{0x657ae36a,0x6445636b,0x6842e031,0x2cb3004a}},	//   meth, xshi, _dídá, _řadě_,
   {{0x60c440cb,0x2246836c,0x3209436d,0x2d87a36e}},	//   fzim, ksok_, umay_, zdne_,
   {{0x2009436f,0x44394370,0x765ae371,0x201ea372}},	// [170] rmai_, _qws_, luty, _luti_,
   {{0x27edc373,0x63bb8026,0x63a98374,0x673f000e}},	//   zoen_, _slun, _soen, _heqj,
   {{0xb4d76077,0x752560cb,0x7bdd0375,0x27e4202e}},	//   ापे_, rchz, onsu, émne_,
   {{0x31358376,0x442b4004,0x64456377,0x44394048}},	//   федр, _ttc_, rshi, _tws_,
   {{0x645ae378,0x657ae379,0x6445637a,0x3f99437b}},	//   huti, keth, sshi, _insu_,
   {{0x9f47e06f,0x321ea064,0x628f8005,0x201ea37c}},	//   _okná_, _buty_, _ácom, _buti_,
   {{0xe739c04e,0x213ea37d,0x3f86c0ca,0xb7b5c119}},	//   оей_, _deth_, _baou_, _dụn,
   {{0x2fdf82f8,0x98b8212a,0x3f89437e,0x9605e37f}},	//   _ujug_, lară_, ndau_, रष्ट_,
   {{0x3f85a380,0x3942010a,0x6b876381,0x4439c382}},	//   _talu_, vaks_, _kajg, ès_,
   {{0x69c0c00a,0x321ea0a2,0x98b820ba,0x0c25e12a}},	//   ahme, _futy_, nară_, ммон,
   {{0x3cf0a05c,0x38694383,0x256fa0b0,0x656d4384}},	//   čové_, htar_, rılı_, kfah,
   {{0x7c3b8385,0xb1134125,0xdb1aa157,0x7a1c2361}},	//   _kwur, _mụba, _altè, _učti,
   {{0x201ea2e2,0x657ae386,0xdb008387,0x2b4d805d}},	//   _zuti_, beth, _komá, _mdec_,
   {{0x6b89c388,0x63bd4171,0x657ae2f8,0x6e2d0049}},	//   ldeg, _alsn, ceth, _dtab,
   {{0x2c87204a,0x6604000e,0xe2f820e0,0x98ba6389}},	//   vídá_, _thik, سورڈ_, kapā_,
   {{0x60db438a,0x7989c38b,0x442d838c,0x3f87e38d}},	//   _žuma, ndew, _ote_, _hanu_,
   {{0xa3af438e,0x41aa638f,0x442d8390,0x3a2d6391}},	// [180] _कवर_, ован_, _nte_, _čepa_,
   {{0xdb008392,0x2d87e393,0x3f8641ce,0x7bc1e394}},	//   _romà, _jane_, žou_, nhlu,
   {{0xe1f9c03b,0x64498395,0x7c3b82f4,0xf8bf0396}},	//   klų_, _avei, _awur, ncén_,
   {{0x442ca397,0x38694398,0xe29a4399,0x2a694022}},	//   _rtd_, btar_, _дам_, btab_,
   {{0xe1ff2009,0x442ca39a,0xdfcf8049,0x201ea39b}},	//   któl_, _std_, جين_, _suti_,
   {{0x6b876098,0x7bce60bb,0x4432439c,0xdce0c018}},	//   _gajg, _umbu, mpy_, zemē,
   {{0xe297a39d,0x2e4aa14a,0xf623639e,0x752981b6}},	//   дај_, цяло_, _адсо, _ffez,
   {{0xbbbb239f,0xd130c13a,0x628403a0,0x20186108}},	//   _उत्क, دمة_, _osio, _hiri_,
   {{0x7c2de3a1,0xdb08a162,0x657ae3a2,0x7e69c23c}},	//   _čara, _modé, teth, gtep,
   {{0x765ae3a3,0x7d1b80a9,0xa09b4053,0xa91d809f}},	//   tuty, _zgus, קייט, _lažl,
   {{0x6d4e605d,0x777ae265,0x799aa00f,0xa3c220c5}},	//   _mdba, retx, _intw, ंसन_,
   {{0xadc38067,0xa194012e,0x7c2083a4,0xbb940052}},	//   _miến, ваюч, _kumr, вающ,
   {{0x7bc1e048,0x66172108,0x777ae108,0x4fc6e3a5}},	//   bhlu, _pixk, petx, _оска,
   {{0x442003a6,0x6e2083a7,0x201863a8,0x64552098}},	//   _dui_, _mumb, _niri_, trzi,
   {{0x61e2c042,0xdb01a05c,0x7c2083a9,0x29024037}},	//   _kjol, _kolá, _lumr, _azka_,
   {{0x391543aa,0x6627e3ab,0x6d4e6229,0x3eae03ac}},	//   ембр, žské, _adba, ëjtë_,
   {{0xdbd6a04e,0x28f8404e,0x386943ad,0x7c2e6041}},	// [190] _kään, деть_, utar_, _atbr,
   {{0x657d03ae,0xa2ca23af,0x69c283b0,0x63a56022}},	//   lesh, _हेक्, ehoe, ujhn,
   {{0x3944c3b1,0x645c23b2,0x81e4a07c,0xdb0403b3}},	//   kams_, curi, নতা_, _goiâ,
   {{0x657d03b4,0xdbd6a10a,0x29d7417a,0x6d4083b5}},	//   nesh, _lään, għat_, _cema,
   {{0x798763b6,0xee3883b7,0x443ce048,0x6d4f43b8}},	//   _tajw, дні_, _lwv_, _idca,
   {{0x6d40810a,0x201863b9,0x7988a1cd,0xf789e1de}},	//   _eema, _giri_, _cadw, _maçã_,
   {{0xdb03e3ba,0x6d408076,0x7bdde3bb,0x1fb5c12a}},	//   _poní, _fema, ésum, еспр,
   {{0xc91823bc,0x2d87e3bd,0xceb26095,0x6448e3be}},	//   וחות_, _sane_, _גיל_, dsdi,
   {{0x395fc3bf,0x645d03c0,0x321943c1,0xc175a1e1}},	//   rgus_, jusi, _misy_, _плащ,
   {{0x6b88a3c2,0x69d52055,0x09dc43c3,0x6560c13a}},	//   _gadg, jize, _यद्य, agmh,
   {{0x7c208098,0x6d4083c4,0x25ad83c5,0x63ad03c6}},	//   _zumr, _yema, _koel_, _boan,
   {{0x645c23c7,0xcb1263c8,0xdb00822e,0x8cb060c5}},	//   vuri, טלי_, _domæ, ंहतो,
   {{0x6285200f,0x61fbc121,0x291dc3c9,0xef19817a}},	//   _asho, mlul, _igwa_, _bażi_,
   {{0x437523ca,0xdb09c04e,0xa3ab2029,0xf1bf43cb}},	//   куст, rkeä, कॉल_, _alá_,
   {{0x201863cc,0x6373a3cd,0xdce403ce,0x657d03cf}},	//   _riri_, mını, _obić, besh,
   {{0x657d03d0,0x3eb8e3d1,0x25ad83d2,0xd8d6e1a1}},	//   cesh, ørte_, _noel_, _רוקט_,
   {{0x3956601b,0x442123d3,0x3cfe602e,0xfbd14026}},	// [1a0] ењет, _euh_, _štv_, _सगरम,
   {{0xac86201b,0xe1f763d4,0xb4e0404b,0xaca44079}},	//   _згол, егу_, _तशी_, _nrụt,
   {{0xd94643d5,0x25ad82be,0x7c2083d6,0x7988a3d7}},	//   _пени, _boel_, _sumr, _radw,
   {{0x6846834f,0x3940813a,0xaca44079,0x186a83d8}},	//   енда, úis_, _arụt, зади_,
   {{0xb21b0042,0x61fbc174,0x69d643d9,0x628523da}},	//   lvær, dlul, miye, _zsho,
   {{0xdb01a3db,0x7bc3a3dc,0xead4a3dd,0xb345a01b}},	//   _solá, ghnu, коль, vaçã,
   {{0x394243de,0xbcfb0004,0x6373a3df,0x7c2e63e0}},	//   _keks_, nfér, dını, _utbr,
   {{0x61fbc3e1,0x69d643e2,0x442243e3,0x442fc05d}},	//   glul, niye, _kuk_, _btg_,
   {{0xdb01a3e4,0x442ee3e5,0x394680eb,0xe9df006f}},	//   _volá, _stf_, maos_, vnú_,
   {{0x660d4041,0xafdb20ff,0xbbad43e6,0xef1f03df}},	//   zmak, rsøk, _टक्क, rdüm_,
   {{0x63ad03e7,0x6448e03b,0x7bd523e8,0x645e63e9}},	//   _poan, usdi, vizu, nupi,
   {{0x6d4563ea,0x69d64054,0xdddba23d,0x3f8a63eb}},	//   zaha, jiye, _isuš, _labu_,
   {{0x63ad03ec,0xecd04077,0x98b8014a,0x2e46e0f9}},	//   _voan, _सेलफ, елят_, _bífá_,
   {{0x6373a3ed,0xdced03ee,0x5ea6607c,0x443ce286}},	//   cını, _ubač, _গেছে, _twv_,
   {{0x7bd523ef,0x661aa3f0,0xd90ee3f1,0x69d643f2}},	//   rizu, _mitk, _دید_, fiye,
   {{0x3cfbe095,0x628283f3,0x645d03f4,0x98ad429c}},	//   _מלונ, kwoo, pusi, _žeđ_,
   {{0x672d0011,0x63ae6364,0xa01b03f5,0x6d4fc3f6}},	// [1b0] _ifaj, _bobn, rvös, ócai,
   {{0x660d43f7,0x61fd03f8,0x62864037,0x224943f9}},	//   smak, llsl, _dsko, rsak_,
   {{0x3b2e8079,0x32090119,0xa3c0c3fa,0x25ad81cf}},	//   _ịyị_, _khay_, ँसा_, _poel_,
   {{0x3fcf807c,0x661aa3fb,0x9e3583fc,0x248d420d}},	//   িক্ষ, _aitk, ведч, _šemu_,
   {{0x44224265,0x6b8d43fd,0x316f8057,0x6b898292}},	//   _guk_, mdag, rfgz_, _vaeg,
   {{0x79898187,0x25a943fe,0x6e21a3ff,0xab5b40cb}},	//   _waew, ljal_, _pulb, _flüc,
   {{0xf991c049,0x443ea400,0x44268401,0x7e6d4402}},	//   لبة_, _cwt_, aqo_, ltap,
   {{0x44224403,0xc6942087,0x63ae606e,0xe65d8121}},	//   _yuk_, ראק_, _zobn, ştığ,
   {{0x7529c024,0x2485a05d,0xba748047,0x69c3a0ca}},	//   rcez, _wslm_, _مالت, phne,
   {{0x7c22c194,0x443f8385,0x32090054,0x6e21a404}},	//   _duor, _iwu_, _ahay_, _tulb,
   {{0xeadc2405,0xd709e04e,0xdee5e406,0x66e5e407}},	//   _ধর্ম, ьное_, тони, тона,
   {{0x32090408,0x645f40bb,0x3ebaa14f,0x2b47a409}},	//   _chay_, kuqi, øpte_, lanc_,
   {{0x850c040a,0x4c83040b,0xa91dc40c,0x69d64106}},	//   सेंट_, аляв, jdži, viye,
   {{0x2b47a40d,0x23bd21e9,0xeab0c049,0xfce6240e}},	//   nanc_, _dìjo_, _دعم_, вого,
   {{0x386dc40f,0xdb01a410,0x69d64411,0xbb432412}},	//   lter_, _dolç, tiye, реск,
   {{0x16218026,0xc2c6013a,0x27e04413,0x60d6c013}},	//   मदार_, _ليبي, unin_, _žymi,
   {{0x7e6d4414,0x69c1a415,0x44236416,0x798bc417}},	// [1c0] gtap, _olle, _auj_, _magw,
   {{0x27ed4418,0x645e6419,0x7c23e082,0xdb04041a}},	//   čena_, tupi, _kunr, _goiá,
   {{0x224d80d1,0x2002a03b,0x0b4680ff,0xc1bb21a9}},	//   _avek_, _ūkio_, внен, _חמיש,
   {{0x7c2de41b,0x63a9c41c,0x0696e00b,0x2487e41d}},	//   _čarl, jjen, כדעם_, _msnm_,
   {{0xb5fb201f,0x765980e2,0x63bbc41e,0x6562800e}},	//   rtáv, grwy, dkun, rgoh,
   {{0x6d44041f,0x7c240420,0x66098166,0x44320071}},	//   _leia, _muir, _ehek, _mty_,
   {{0xdca36421,0x83fd0422,0x29d203de,0xe1268423}},	//   _кари, luđe, ršaj_, _амби,
   {{0x68ed400e,0x6d472424,0x6b8bc425,0xdb07214f}},	//   _ëndë, zaja, _cagg, rkjø,
   {{0x798bc426,0x6d472427,0x661aa428,0x44236286}},	//   _dagw, yaja, _titk, _zuj_,
   {{0x3f9dc125,0x4423605f,0x7c23e3f6,0x6457a03e}},	//   _enwu_, _yuj_, _bunr, áxic,
   {{0x20090067,0x44236022,0x6b8d4155,0x2d8ca106}},	//   _phai_, _xuj_, ydag, _iade_,
   {{0x6d472429,0x63a9c42a,0x39448088,0x68fc642b}},	//   waja, cjen, _jems_, _myrd,
   {{0x1958e20e,0x44320067,0xe29800db,0xdb18a046}},	//   _залы_, _cty_, ваў_, rivõ,
   {{0x7bc2c04a,0x6fdec018,0x61e642a4,0xbcfb0071}},	//   _hlou, dīci, _ajkl, bgén,
   {{0x2d8ca42c,0xc7c7042d,0xf1b9842e,0x7640805f}},	//   _made_, _аспи, _hiše_, _lwmy,
   {{0x6d43e42f,0x7e6d4430,0x3ce90286,0x661c6090}},	//   _zena, ttap, _txav_, _airk,
   {{0x2fc680eb,0x9f4ce431,0x3495003b,0xdb052009}},	// [1d0] dhog_, hodí_, _сапр, _dohá,
   {{0x44236048,0x69d8a07f,0x26c9416d,0xa28320d0}},	//   _puj_, jive, rzao_, _پیرو,
   {{0x63af4432,0x661c6433,0x7e60c434,0x67d541b1}},	//   _tocn, _dirk, hump, _бону,
   {{0x68fb808b,0xdb03a0cb,0xbddb6163,0x27e6c012}},	//   _pyud, rknü, _avèt, _njon_,
   {{0x38794435,0x39494436,0x6adba437,0x6288a08b}},	//   _upsr_, maas_, यप्र, _asdo,
   {{0x2d8ca438,0x1d09a439,0x661c643a,0x2d9ea0b6}},	//   _cade_, нели_, _girk, _cnte_,
   {{0x2d8ca43b,0x63bbc43c,0xddc4612a,0x3f8ca43d}},	//   _dade_, tkun, stiţ, _dadu_,
   {{0x3949443e,0x2d81643f,0x443f8440,0x3f816098}},	//   naas_, lehe_, _twu_, lehu_,
   {{0x69d8a441,0x3947a442,0x7e60c443,0x7bd8a444}},	//   bive, pans_, gump, bivu,
   {{0x6b8bc00d,0x1db98010,0x6d452445,0x39494054}},	//   _wagg, _आवडत, _neha, haas_,
   {{0x216a0446,0x2bb8a447,0x201ce018,0x39494448}},	//   нини_, _अवता, _divi_, kaas_,
   {{0xf7720449,0x60002156,0xbf0fa046,0xe1ff20c2}},	//   حاد_, römm, ाधीन_, otów_,
   {{0x7e60c359,0xa01b60e0,0x6b8d023c,0x2d816187}},	//   cump, _csök, _daag, kehe_,
   {{0x6e23e44a,0x2d8ca057,0x6145e01b,0xddc46013}},	//   _tunb, _xade_, _сека, ktiš,
   {{0x69d9844b,0xe2a8e13a,0xe299e2a3,0x4376444c}},	//   kiwe, _لاين_, _чай_, луат,
   {{0xa766044d,0xb5fb206f,0x7dd4203c,0xf2d2a00b}},	//   _скид, tuác, _müsə, צען_,
   {{0x7bc4044e,0xdce1e013,0x27ffc052,0xe81bc118}},	// [1e0] _iliu, telė, ilun_, _पूछा_,
   {{0x65698037,0x728a21e3,0x3860421c,0x69d8a44f}},	//   _aceh, _због_, ruir_, xive,
   {{0x69d8a450,0x7afd4451,0x83fd023d,0x645bc049}},	//   vive, _eyst, suđe, hrui,
   {{0x929d8064,0x3f8d803e,0xf1bf6452,0x645bc23c}},	//   _czło, _caeu_, _stát_, krui,
   {{0x61e28453,0x386040b8,0xdb08a454,0xe2978455}},	//   rnol, quir_, _vodí, лац_,
   {{0x645bc456,0x98bee12a,0xbe8aa457,0x7434a458}},	//   drui, nată_, есие_, анкф,
   {{0xdb1e2459,0x7bd8a45a,0x61e4445b,0x6684601c}},	//   _impó, rivu, onil, _خیال,
   {{0x9054c45c,0x8b958104,0x6d46445d,0xdcfc245e}},	//   авиц, _круч, _jeka, jerč,
   {{0x7980c0b1,0x798e645f,0x6441a0f7,0x386ea460}},	//   remw, _kabw, _ewli, stfr_,
   {{0x4274e461,0x6b81e462,0xfd65a291,0x3f9ea463}},	//   агос, gelg, _metụ, _untu_,
   {{0x61e44464,0x6d4aa465,0xb5fb2009,0xd917e052}},	//   knil, mafa, ktár, лью_,
   {{0x0ecf2466,0x31668467,0x7bc2c468,0x764e2469}},	//   _हेगड, ngoz_, _ulou, dsby,
   {{0xdb076071,0x7c26446a,0x6fb8a04b,0x2906c125}},	//   _mojá, _nukr, _अवां, _uzoa_,
   {{0xb5fb201f,0x798d0054,0x7afd446b,0x5334e46c}},	//   etár, _waaw, _ryst, _тект,
   {{0xa91d803b,0x201ea46d,0x7bc40256,0x69c7246e}},	//   _važi, _miti_, _fliu, rhje,
   {{0xb0c4846f,0x8aa70470,0xa8a70471,0x2bbb013a}},	//   वनाग, _брод, _брок, _ساعة_,
   {{0xdb1d013a,0xbebb40dd,0x752d4472,0x03d56473}},	// [1f0] bhsá, _afër, rcaz, ажаю,
   {{0xd5672474,0x661e220d,0x6d4aa475,0xa7fb2005}},	//   _стип, _gipk, jafa, buña,
   {{0x3f83204d,0xe3bf607b,0x4426c476,0x7afde04a}},	//   meju_, _cuña_, _luo_, řstv,
   {{0x8937813a,0x09e1e477,0xb5fb2478,0x6d464479}},	//   اعضا, _पद्य, ctár, _geka,
   {{0x4429447a,0x69d9847b,0xb7b5a125,0xddc4647c}},	//   qqa_, riwe, _dịn, stiš,
   {{0x7bdae47d,0xd246e0b7,0x69d9847e,0x7bd5647f}},	//   jitu, _ون_, siwe, _umzu,
   {{0x79828005,0x6b828480,0x4425a481,0x6b81e482}},	//   beow, beog, _qul_, velg,
   {{0x69c3e06f,0xdb1d4069,0x2d832483,0x7981e484}},	//   _slne, _umsó, heje_, welw,
   {{0xdb098069,0xae152485,0x6e948486,0x290c613a}},	//   _gleð, णगान_, _литу, _údar_,
   {{0x645bc487,0x61e98488,0x249940c7,0x2b46c157}},	//   rrui, _hjel, _mrsm_, _eeoc_,
   {{0x2d8ee489,0x3946c48a,0xd5b9848b,0x645bc48c}},	//   _dafe_, _feos_, _आवाज, srui,
   {{0xaca36079,0x6e27605d,0x224dc48d,0xa91dc07f}},	//   _gwục, _mujb, psek_, režb,
   {{0x03a5e48e,0xdb08a049,0x61fb8167,0xaca3c079}},	//   _вило, _iodá, _mkul, _mmịk,
   {{0x61e98143,0x09de404b,0x2d8fc48f,0x69c52153}},	//   _ljel, नच्य, _hage_, _clhe,
   {{0x6723e490,0x28d9c2b4,0x753d0009,0x78a9c322}},	//   _ignj, _बेति, bbsz, lxev,
   {{0x09e30491,0x69c40492,0x3946c057,0x798e6493}},	//   _мощн, _ulie, _xeos_, _sabw,
   {{0x09c161a6,0x0b466494,0x3f8fc495,0xe1fa6496}},	// [200] োচনা, инан, _magu_, вга_,
   {{0x8af00497,0xe29a6498,0x7c276499,0xaca3c079}},	//   _edəc, каз_, _bujr, _amịk,
   {{0x98a6249a,0x4427e49b,0x6e220024,0x05772076}},	//   _тине, _jun_, _èobb, _דגים_,
   {{0xea76e49c,0x7bdae49d,0x7bc8e00e,0x628bc0fd}},	//   יגער_, zitu, zhdu, _osgo,
   {{0x2a7dc022,0x69dae49e,0x249940ae,0x7bdae284}},	//   _npwb_, yite, _grsm_, yitu,
   {{0x3ce0c49f,0xf50a64a0,0xdb0ae1af,0xdfcfa4a1}},	//   _živo_, _англ_, _sofí, وين_,
   {{0x201ea4a2,0xd378e4a3,0x61e984a4,0x80b6207c}},	//   _viti_, niće_, _fjel, ৃপক্,
   {{0x6b8444a5,0xe7c1007c,0xa3d3e033,0xf1bf6057}},	//   neig, _উদ্য, सोस_, _juán_,
   {{0x29000022,0x27f824a6,0x2d99807b,0x9df8e4a7}},	//   _nyia_, korn_, _ósea_, лнит_,
   {{0x2259c3e4,0x3947e017,0x6fc4e153,0x660d04a8}},	//   áska_, _cens_, _bòca, _shak,
   {{0x7786c4a9,0x660d0174,0x3086a4aa,0x60cd44ab}},	//   _влез, _phak, _خلاف, zzam,
   {{0xdebba4ac,0xf1b984ad,0xd378e3a1,0x6442c064}},	//   _שמאל, _kiša_, diće_, _twoi,
   {{0x5f9404ae,0x2d8324af,0x91e6e4b0,0x6b8444b1}},	//   цият, teje_, _коде, deig,
   {{0x6d56018c,0x69dae00e,0x27e6805d,0x7bdae00e}},	//   _edya, qite, hnon_, qitu,
   {{0xe0e8c07c,0x0ce1607c,0x6d4764b2,0xdb1d01ae}},	//   _পরিভ, _ভর্ত, _reja, visõ,
   {{0x6d4b84b3,0x660d0296,0x27e904b4,0x394ce065}},	//   xaga, _uhak, _ujan_, lads_,
   {{0x91fd0041,0x26e2a0c2,0x2418420e,0x27e68114}},	// [210] stās, गपुर_, роты_, dnon_,
   {{0x61e984b5,0x6671e050,0x69c644b6,0xa3b76010}},	//   _sjel, _بگیر, _elke, _जवळ_,
   {{0x3ed964b7,0x4095213a,0x66028069,0x7c29605c}},	//   دواج_, _الجر, flok, _čers,
   {{0x69c9c048,0x78a24089,0x660284b8,0x225e202e}},	//   xhee, ťova, glok, átke_,
   {{0x394904b9,0x7f476022,0x182184ba,0x2bba0028}},	//   _meas_, _tejq, मदेव_, _उकसा,
   {{0x629aa012,0xb602e066,0x68336227,0xdcfe204a}},	//   _brto, _žánr, _aħde, _napě,
   {{0x61e984bb,0x442904bc,0xdb08a05c,0x69c9c200}},	//   _tjel, _lua_, _podá, thee,
   {{0x4998c04e,0x442900ba,0x2d84c4bd,0x61e9807f}},	//   атья_, _oua_, geme_, _ujel,
   {{0x657b84be,0x4427e4bf,0x5fa9c0c2,0xdb08a066}},	//   _ibuh, _sun_, काबल, _vodá,
   {{0x78bd0052,0xd6dba4c0,0x7e63a050,0x68e48049}},	//   dysv, _ите_, punp, úide,
   {{0x6e28a24f,0xb1134088,0x3f9164c1,0xe61a04c2}},	//   _gudb, _bụka, _mazu_, лдо_,
   {{0x5184c02d,0x3949012a,0x3a2902a8,0x3f84c4c3}},	//   _муча, _ceas_, _buap_, cemu_,
   {{0x34abc049,0x7bdc24c4,0xe3bf6019,0x69a4c11a}},	//   _جداً_, tiru, _nuño_, कारी,
   {{0x6e3bc4c5,0x6723e2e2,0x2901205d,0xfe70c0eb}},	//   mpub, _ugnj, _byha_, _زده_,
   {{0xd435e25b,0x8fa644c6,0x07a641bc,0x4427e054}},	//   _اعتب, баве, бавн, _uun_,
   {{0x7ae124c7,0x44200037,0x645ce00a,0x3e71e009}},	//   últa, _uii_, šric, mát_,
   {{0x2a7f8022,0x6e3bc4c8,0x4421217a,0xbea344c9}},	// [220] _npub_, npub, _fih_, патк,
   {{0x5d86213a,0xb5fb24ca,0xd8d7000b,0x645e64cb}},	//   _الدل, nuál, _לופט_, trpi,
   {{0x7e6560c7,0x69d9c4cc,0x6fc604cd,0x248d84ce}},	//   guhp, _omwe, _zóca, _asem_,
   {{0xf0d28291,0x798600c1,0x6e28a4cf,0x443a64d0}},	//   bịlọ, nekw, _rudb, rpp_,
   {{0x6ba52069,0x3e71e0e0,0x2d9204d1,0xdcf604d2}},	//   _útgá, hát_, _maye_, _obyč,
   {{0xf1b980e4,0x3e71e4d3,0x232764d4,0x69dd00bb}},	//   _viša_, kát_, _гори_, zise,
   {{0xc3332095,0x63a404d5,0xf8c824d6,0xa91dc4d7}},	//   לוג_, _onin, रनिय, veža,
   {{0xa8576095,0x69c76098,0x442244d8,0x6569c4d9}},	//   _לילה_, _zlje, _jik_, ggeh,
   {{0x25ef64da,0x442244db,0xe29784dc,0x629b803b}},	//   _आदमी_, _mik_, _лат_, _gruo,
   {{0xa4b74095,0x2d84c4dd,0x660444de,0xd62aa4df}},	//   צליה_, seme_, hlik, _боже_,
   {{0x02b304e0,0x7c298105,0xc7afc04e,0x69daa4e1}},	//   ुन्न, _zuer, _её_, _imte,
   {{0x442a64e2,0x2d92005d,0x63b60090,0x69dde0fa}},	//   _mub_, _caye_, _coyn, éser,
   {{0x7bdd04e3,0x107404e4,0x2bfa64e5,0x2bbf44e6}},	//   risu, пляю, ्तां_, _एकबा,
   {{0x63a404e7,0x4438607d,0x7f4d4054,0x6ca6e4e8}},	//   _enin, _otr_, waaq, _гриж,
   {{0x660444e9,0x63b564ea,0x7de54013,0x6377e095}},	//   flik, _rozn, lėsi, _הגוף_,
   {{0x6fc06105,0x7c2d44eb,0x4421207d,0xa3abc466}},	//   _höch, tqar, _wih_, खाय_,
   {{0xbbeb24b7,0xa3e8a010,0x78c6216d,0x3dc904ec}},	// [230] _مردم_, मचा_, _čuvš, _ilaw_,
   {{0x442244ed,0x7f4f0197,0x2bbb6049,0x2d9204ee}},	//   _eik_, lacq, دارة_, _zaye_,
   {{0xa3be24ef,0x2bbea0e3,0x3ebee4f0,0x7d7be1a1}},	//   _आवत_, ्सना, nytt_, רנבו,
   {{0x225c605c,0x6d5ea4f1,0xfd10613a,0xfbcee07c}},	//   ávka_, ópan, رجل_, িচিত,
   {{0x6d58e4f2,0x7ae4c4f3,0x80da607c,0x6f02c096}},	//   _odva, _žitn, _বুদ্, _nyoc,
   {{0x2d85e4f4,0xdb1b8017,0x7bc284f5,0x6b87200e}},	//   xele_, _lluç, akou, nejg,
   {{0xa2db04f6,0xd5ae80e0,0x7c2984f7,0x442a64f8}},	//   _पेस्, رہے_, _wuer, _gub_,
   {{0x7c22c4f9,0x2d9324fa,0xe3b9c4fb,0x7bcd44fc}},	//   _cior, _laxe_, рби_, nhau,
   {{0x6603a03a,0x6d4e24fd,0x27ff84fe,0xb7b5c079}},	//   plnk, yaba, _ikun_, _bụr,
   {{0xd7fba091,0x394f8069,0x2fc900ae,0x6d4e24ff}},	//   _суб_, lags_, _alag_, xaba,
   {{0xb5fde500,0xf98604b0,0x1d09e501,0x69c98502}},	//   bušn, огно, рени_, _klee,
   {{0x27ff81d7,0x216a0503,0x78a4c504,0x656b805d}},	//   _jkun_, шими_, _šive, nggh,
   {{0x00e5c043,0x6e2de098,0xe919c0ff,0x8af0003c}},	//   _بتای, _čabu, _тоді_, _edən,
   {{0x61b68505,0x657d4506,0x7bc98507,0x27e9c0e4}},	//   _अक्ष, _absh, _lleu, čanu_,
   {{0x80db007c,0x7f4f0024,0xcfaa0508,0x3f920509}},	//   _যুদ্, bacq, _ناظم_, _tayu_,
   {{0x290422b8,0x6d4ae50a,0xd378e06a,0x6604450b}},	//   āma_, _zefa, mića_, ulik,
   {{0x394f850c,0xe1f7412e,0x546a42fe,0x386040fa}},	// [240] dags_, ігу_, разм_, urir_,
   {{0x69db81bf,0x644040dd,0x7d03e50d,0xb7b5a079}},	//   _amue, _çmim, _kyns, _dịk,
   {{0xd378e50e,0x7c23e07d,0x3086650f,0xdb0e6510}},	//   nića_, _minr, تلاف, _tobí,
   {{0x7bcd4511,0x443a20c2,0x7ae36049,0x2903600e}},	//   chau, _itp_, únta, _dyja_,
   {{0x91fd0041,0xf38d000b,0x2486606f,0x7bde6050}},	//   duāl, טראָ, ňom_, pipu,
   {{0x27ed8435,0x27e04512,0x69c28513,0x7ae4c04d}},	//   _ejen_, liin_, skoe, _žito,
   {{0xa3bfe046,0x3a2a60ae,0x2167a1e3,0x3160a106}},	//   ीसन_, _uubp_, цији_, ğiz_,
   {{0x3e55e041,0x2005e514,0x7c23e515,0x61fbc516}},	//   dāt_, elli_, _ainr, goul,
   {{0x3f98c04a,0xa5bb61e9,0xa96aa517,0x7c22c0ba}},	//   ěru_, _atóy, _виза_, _vior,
   {{0xe80ac518,0x69c3a519,0x27e9451a,0x44248095}},	//   _हीरा_, ckne, znan_, _him_,
   {{0x443a251b,0xa91dc51c,0x61fae0d5,0xf1d9e51d}},	//   _ntp_, bežo, rotl, योधन,
   {{0x61b7651e,0x442ca51f,0x7c3aa17a,0xc6a70520}},	//   _आक्ष, _iud_, _ittr, орги,
   {{0x3e74404e,0x27e04521,0x6b9641cd,0xddcd612a}},	//   jät_, diin_, ddyg, ntaţ,
   {{0x69ce210f,0x7d03e522,0x442b4523,0x6e23e524}},	//   ghbe, _fyns, _ruc_, _ginb,
   {{0x7c240054,0x27e94525,0xdb0080c2,0xc1052049}},	//   _fiir, tnan_, _komó, سوري,
   {{0x7bcd4526,0x3a2b4071,0xd6db006c,0x27e04527}},	//   uhau, _pucp_, _вто_, giin_,
   {{0x6fc60057,0x6d412106,0x2d87a528,0xb4c6a026}},	// [250] _zóco, ılab, yene_, उनु_,
   {{0x443ee200,0x6455617b,0x6833613e,0x6b88e529}},	//   opt_, _pvzi, _aħda, nedg,
   {{0x3f87a52a,0xaa95613a,0x7bdf452b,0x1b1ce07c}},	//   venu_, ثلاث, piqu, পুরে_,
   {{0x2249052c,0x61fbc057,0x443ee52d,0xab5b00cb}},	//   _kwak_, xoul, ipt_, chüt,
   {{0xa13640be,0xd6db852e,0x6282c022,0xe5a5a52f}},	//   _מארק_, јте_, _npoo, зили,
   {{0x61fbc163,0x61fd0530,0x200560c4,0xb5fde012}},	//   woul, hosl, _óli_, gušl,
   {{0x7c2bc531,0x6fc2206f,0x21290532,0xdd0ea3df}},	//   _sugr, _dôch, _ogah_, rışm,
   {{0x78a68533,0x2d894011,0x6e23e534,0x27ff8535}},	//   _škve, neae_, _sinb, _ukun_,
   {{0x7d03e536,0xddcd612a,0x6d41e537,0xf1b9a20d}},	//   _syns, ctaţ, tbla, _sušu_,
   {{0x25a6c057,0x49b8a1b3,0xa3ae6538,0x6f03e1cd}},	//   _enol_, _والد_, काय_, _pync,
   {{0x61fc2042,0xab2a02a3,0x27e04054,0x6e23e135}},	//   vorl, йона_, yiin_, _vinb,
   {{0x9f5ea163,0x7c2d0539,0xdb0760f9,0x2cb8e156}},	//   _aktè_, _buar, _bojú, ärda_,
   {{0x80b1a53a,0xd9bd807c,0xe8eec53b,0xf1b9853c}},	//   _अपडे, _আগাম, _чл_, _moš_,
   {{0xdd9240d0,0x78a68069,0x6e2d0037,0x63b8e53d}},	//   کور_, _ákve, _duab, _govn,
   {{0x7c24053e,0x18a3253f,0x69c44540,0xd00ee049}},	//   _tiir, нарм, tkie, _حلو_,
   {{0x656d4541,0x7c2d0542,0x5bb8a029,0xb7b5a079}},	//   ggah, _fuar, _अव्व, _dịi,
   {{0x4425a543,0x442d80fa,0x629bc052,0x7d040544}},	// [260] _oil_, _nue_, nvuo, _uyis,
   {{0xdc9b0545,0x7d1a6069,0x69dd40bb,0x317f812a}},	//   _פסיכ, _útsk, _emse, _abuz_,
   {{0x249f8546,0x7bde2547,0x7bcbc548,0x2ca00320}},	//   _arum_, _impu, _olgu, _hrid_,
   {{0x7649811d,0x394d8549,0xd7af004b,0x5faf004b}},	//   _bwey, _cees_, टायच, टायल,
   {{0x7bc56022,0xf194a54a,0x6005c019,0xd00aa54b}},	//   bkhu, диль, cómi, беде_,
   {{0x4424854c,0x2b98c067,0xf2d3400b,0x7f5b81ab}},	//   _wim_, _ức_, _טער_, _eduq,
   {{0x59cc0010,0xd7cc0010,0xb5fb2069,0x2bc1604b}},	//   ासार, ासाच, krán, _शकता,
   {{0x249f854d,0x5838c12a,0x3253a14a,0x673640c2}},	//   _frum_, озия_, хвър, ncyj,
   {{0xa91dc54e,0x61e0c3df,0x6d4d0134,0x7bde2194}},	//   ležj, riml, _reaa, _ompu,
   {{0xe3a4a54f,0xdb01a183,0x6e2e6550,0x60c0c277}},	//   _تشری, _coló, _kubb, rymm,
   {{0xdcf52041,0x7c3aa551,0x645a2552,0x394d8223}},	//   rdzī, _uttr, štij, _yees_,
   {{0x394d0019,0x6b88e012,0xdd8fc553,0x386940a2}},	//   úes_, sedg, _موم_, yuar_,
   {{0x64a3c554,0x386940dd,0x6602c031,0x1ee70555}},	//   _паца, xuar_, _ikok, سوسی_,
   {{0x6d5c6556,0x3869400e,0x64b5604a,0xfbcfe049}},	//   _ndra, vuar_, _hřiš, _متى_,
   {{0xe97be095,0xa97be076,0x4b7be557,0xb93a4088}},	//   _הנוש, _האוכ, _האוו, _ọmụr,
   {{0x2ca00558,0xddeb20eb,0x62840090,0x6005c559}},	//   _frid_, _گربه_, _fpio, tómi,
   {{0x645520e0,0xe664455a,0xa3ca035b,0x66f4419c}},	// [270] sszi, етхо, लघर_, епту,
   {{0x7bcd055b,0x2b4d8005,0xddcd6143,0xf99f40ca}},	//   _hlau, _seec_, ftaš, _chèr_,
   {{0x2484805d,0x4425a55c,0x26c7604a,0x853001df}},	//   _apmm_, _ril_, áno_, _haɗa,
   {{0x28de455d,0x4425a55e,0xf09f4016,0x3e75655f}},	//   _नेवि, _sil_, _trà_, råt_,
   {{0x61e1e560,0x7dcfa271,0x920ce028,0x32094561}},	//   yill, _løse, हताज_, mlay_,
   {{0x27ed40e4,0x69c72488,0x7bcd0562,0x2adea10a}},	//   čenu_, nkje, _llau, _केहु_,
   {{0x8464614a,0xf1a9c0c2,0xfc64614a,0x293821a1}},	//   _пъте, कालन, _пътн, לאגן_,
   {{0x442d8563,0x32094090,0x2d8b053d,0xdb01a564}},	//   _tue_, nlay_, jece_, _soló,
   {{0x442d810a,0xdb01a565,0x9327a566,0xc3344095}},	//   _uue_, _colò, _فران, עוץ_,
   {{0x6d45628f,0x7bcd0013,0xde16e049,0xa2d68567}},	//   nbha, _alau, وقيت_, _मेट्,
   {{0x9d0be07c,0xaf37c54f,0x442ee296,0x2009403b}},	//   রশ্ন_, _فرشت, _cuf_, klai_,
   {{0x6b8b8568,0x6458e098,0x6d456569,0x67d4c04e}},	//   negg, _dvvi, hbha, _поху,
   {{0xb5fde56a,0x27edc56b,0x7bc6004e,0x68e9423d}},	//   nušk, mnen_, rkku, _žedn,
   {{0x4426c56c,0x61fe60d5,0x61e3a56d,0xe3bf42a8}},	//   _zio_, xopl, ninl, _riña_,
   {{0x7d06404e,0x69cd01cd,0xdb18e56e,0xabf6009e}},	//   _syks, _flae, _novè, _очищ,
   {{0x6441e56f,0x7e644570,0x6d5c6197,0x629c2110}},	//   mpli, trip, _sdra, rvro,
   {{0x6e276200,0x6d4e607d,0x29116571,0xd12f2043}},	// [280] _bijb, _peba, _azza_, امہ_,
   {{0x63a98572,0x04466052,0x2bcc0573,0x6609c0bb}},	//   _anen, дежн, ासवा, hlek,
   {{0x7e644574,0x225e00c2,0x6eb5239f,0xdb0f40fc}},	//   srip, ątku_, _उपयु, _vocá,
   {{0xddcd6575,0x83838052,0x6d456420,0x6b8b8576}},	//   rtaš, выше, abha, gegg,
   {{0x442fc223,0x661bc0a9,0x4427e577,0xa3cde578}},	//   _nug_, dmuk, _oin_, रसा_,
   {{0xb5fde579,0x63a9857a,0x3a26c1cd,0x7d78a049}},	//   sušj, _enen, _siop_, سمبر_,
   {{0x443dc07d,0x64b56026,0xc246612e,0x27edc105}},	//   _atw_, _přiš, _інак, fnen_,
   {{0x63bb8030,0xcb132095,0x2d98657b,0x26040005}},	//   _goun, כלו_, _hare_, iños_,
   {{0x443ce57c,0x2485a229,0x3f8b0012,0xdb19c0ca}},	//   _stv_, _eplm_, vecu_, _jowè,
   {{0x7bcd057d,0xa2a20026,0x27edc57e,0x63a9806f}},	//   _slau, खिन्, anen_, _znen,
   {{0xd12fa57f,0x63bb8580,0x63bc6076,0x200940fd}},	//   _ضمن_, _youn, _morn, ylai_,
   {{0x7dc3410a,0xceb3a053,0xdb0d40c4,0x394683b0}},	//   _tõsi, _שיף_, kkað, nbos_,
   {{0x5c0721e1,0x621bc053,0xb5fb2581,0xf09f40f9}},	//   дява, _וואק, brál, _ayàn_,
   {{0x3f824020,0x8c14807c,0x7dc06582,0x51842583}},	//   _abku_, িদিন_, _möss, куса,
   {{0x85300068,0xbcfb00fa,0x7dd14584,0x27e32585}},	//   _waɗa, ggér, _låse, rijn_,
   {{0x7bc72586,0x442fc223,0xb17b4587,0x2a66805d}},	//   skju, _yug_, _småb, krob_,
   {{0xdb1aa588,0x61ed4589,0x9f586069,0x4815658a}},	// [290] _botë, rnal, _skrá_, емас,
   {{0x2909058b,0x63bb849b,0x6d45658c,0x6609c0e0}},	//   _iyaa_, _soun, ubha, zlek,
   {{0x6b8b814a,0xb5fde06e,0xa3c600a8,0x2009458d}},	//   tegg, kršn, _एवम_, plai_,
   {{0x7c28a58e,0x7f552071,0x386681cd,0xb4db458f}},	//   _aidr, lazq, fror_, _deàr,
   {{0x61e3a590,0xddc9a04a,0x6b8d4591,0x2d8ce592}},	//   tinl, _zveř, meag, kede_,
   {{0x9f4200dd,0x26c4c03b,0x443ea593,0x3e78e0e0}},	//   tikë_, dymo_, _btt_, két_,
   {{0x61e3a594,0x6b8b8197,0x6b686009,0x7e6d4595}},	//   rinl, pegg, ségü, luap,
   {{0x61e3a3ed,0x9f58203a,0xfc3f413a,0x2486c07d}},	//   sinl, vorí_, _tríd_, _bpom_,
   {{0x60160326,0xba25e159,0xe3bf403e,0x644ea17a}},	//   náme, ндик, _liño_, _ħbie,
   {{0x44290596,0xc6924095,0x6609c597,0x66040598}},	//   _aia_, נאי_, slek, _skik,
   {{0x5faca599,0x443ea0e8,0x4431659a,0x2c78e59b}},	//   चारल, _gtt_, _juz_, géd_,
   {{0xb21b659c,0x4427e59d,0xdcebc17a,0x7643a037}},	//   _spæl, _win_, _nagħ, mpny,
   {{0x7c29859e,0x2d8364bb,0x6459802b,0x61e4459f}},	//   _mier, _obje_, nswi, viil,
   {{0xa91dc5a0,0x764d00ca,0x69c8e5a1,0x7641e5a2}},	//   ježi, _dway, ckde, pply,
   {{0xfc3f41e9,0x3eb5c12a,0x2d9945a3,0xdcebc13e}},	//   _atí_, ţetă_, _base_, _bagħ,
   {{0xee3a45a4,0x98ac003c,0xaca381e9,0x7bc9c5a5}},	//   зна_, şdı_, _ayọn, nkeu,
   {{0xe0da41e1,0x386dc5a6,0x2d994057,0x8fa625a7}},	// [2a0] чва_, nuer_, _dase_, _запе,
   {{0x317fc0c7,0x9f5ca066,0xdb1ae049,0x447b00be}},	//   hfuz_, pové_, chtó, _צניע,
   {{0x44320016,0x3f986018,0x056685a8,0x6fcde057}},	//   _huy_, _varu_, евен, _xúca,
   {{0x3e79c0d1,0xa6db40c4,0x2d8ce5a9,0x3d1525aa}},	//   kèt_, _veðr, zede_, _धरते_,
   {{0x3d06e10a,0xdd99805c,0x645985ab,0x224d8037}},	//   _सुने_, _daň_, gswi, _cwek_,
   {{0x7c2985ac,0x245aa018,0x60160019,0x63bd4089}},	//   _eier, tīm_, námb, _zosn,
   {{0x78a2c5ad,0x443205ae,0x6829603b,0xd90d80e0}},	//   _srov, _luy_, _užda, میہ_,
   {{0x3f9a2041,0x249f40e4,0xd84f0079,0x39498069}},	//   _lapu_, _šumi_, _bọlb_, ðast_,
   {{0x444465af,0x3ea2c0c4,0x7999c5b0,0x798e200d}},	//   lp_, íkt_, _daww, kebw,
   {{0x798405b1,0x3f9a2012,0x444465b2,0x7c2985b3}},	//   _abiw, _napu_, op_, _zier,
   {{0x44446157,0x443ea041,0x6d5525b4,0xe0be61a6}},	//   np_, _utt_, vaza, _আধুন,
   {{0x6aa405b5,0x44290048,0x386dc5b6,0x7c29817a}},	//   _brif, _qia_, buer_, _xier,
   {{0xdd8fc13a,0x2ca04504,0x799aa5b7,0xc458004e}},	//   _دون_, jvid_, _katw, ниях_,
   {{0x2ca04277,0x6fcb203c,0x2005206f,0x2d9945b8}},	//   dvid_, _gücl, ôli_, _sase_,
   {{0xdb1c60dd,0x27e685b9,0xdb1565ba,0x98a90098}},	//   _dorë, kion_, _pozí, _igač_,
   {{0x3ebe2277,0x752d05bb,0x659445bc,0xdb1aa3bb}},	//   ätta_, _ugaz, ласу, _coté,
   {{0x7c298355,0x3f9945bd,0x24f845be,0x32016066}},	// [2b0] _rier, _vasu_, енты_, tohy_,
   {{0xb21b2065,0xd056a03c,0x20186153,0x65608049}},	//   dtæg, şbəx, _chri_, _admh,
   {{0x765ae5bf,0x644085c0,0x659585c1,0xb4bd65c2}},	//   nsty, _atmi, кажу, ेने_,
   {{0x7d0985c3,0x645985c4,0xa2a4a5c5,0x765ae5c6}},	//   _pyes, tswi, किन्, isty,
   {{0xa4a5e0f9,0x444465c7,0x9f494049,0x799aa2ad}},	//   _asọ̀, ap_, nnaí_, _batw,
   {{0x3206c5c8,0x645985c9,0xb5fb207b,0x7999c5ca}},	//   _akoy_, rswi, cuát, _saww,
   {{0xa3e925cb,0x2ec9c5cc,0xc3342076,0xe296a14a}},	//   _मगन_, िन्त, נוק_, ващ_,
   {{0x3e79c5cd,0xddc2a03b,0x7dd26065,0x6b9d05ce}},	//   tèt_, ruoš, _væse, jdsg,
   {{0x200325cf,0x7e6f0012,0x7fd5e5d0,0xa283c5d1}},	//   koji_, jucp, віні, ایتو,
   {{0x799aa5d2,0x442a6223,0x28d00029,0xe530603c}},	//   _gatw, _xib_, हनसि, _müğə,
   {{0x216a05d3,0x78a405d4,0x9991e0e0,0xbebdc03b}},	//   мини_, _sriv, öző_, ncūz,
   {{0x2d9a25d5,0x3f8f80e2,0x59a6e12f,0x2d9d85d6}},	//   _sape_, negu_, _कोठर, ndwe_,
   {{0x3f9a25d7,0x799b85d8,0x32020066,0x2d998057}},	//   _papu_, _mauw, roky_, _óseu_,
   {{0x6a85e19b,0x444465d9,0xdce1a315,0xf1bf4071}},	//   _алка, yp_, _halı, _diám_,
   {{0x07a325da,0x3f8f8108,0x660d45db,0x7e7d05dc}},	//   јасн, kegu_, flak, atsp,
   {{0xf1b9823d,0x443325dd,0xb222c0c4,0x673bc431}},	//   _kišu_, _dux_, _þætt, ncuj,
   {{0xf1b5e578,0x501b0095,0x7e7c212d,0xdb1c2049}},	// [2c0] _अचान, _קופו, strp, thró,
   {{0x3ea045de,0x98a0000a,0x7c2ae5df,0x9f4a25e0}},	//   rvit_, _agić_, _xifr, robó_,
   {{0x7c36400e,0x66028035,0x8e3a05e1,0xdb0640c2}},	//   sqyr, took, _عسکر_, _pokó,
   {{0x6b9aa48d,0x9c82606e,0xaa4682d7,0x83fd00a9}},	//   _satg, ščob, ведл, buđu,
   {{0x27e7a5e2,0x799b85e3,0x61e405e4,0x7641a013}},	//   finn_, _dauw, _mmil, _atly,
   {{0x9d4365e5,0x6602800d,0xda022021,0xe4e3a026}},	//   _верд, sook, लकित_, _केहि_,
   {{0x7dc3410a,0xfc3f407b,0xab646106,0x539b6076}},	//   _tõst, _iría_, rdüğ, _קילו,
   {{0xbeb78026,0xd8768043,0x3f8ea167,0xad9b40f9}},	//   _šíře, _لائب, sefu_, _akúj,
   {{0xdb172005,0xdb0ae0fa,0x3e7c65e6,0x60c720c2}},	//   _roxí, _infé, lít_, zyjm,
   {{0x71a3a5e7,0xd9bf45e8,0x798285e9,0x799b80c2}},	//   _кауз, _एक्ट, lfow, _zauw,
   {{0x2ba6e010,0x6d58a5ea,0x6b9c65eb,0x78a28066}},	//   _कोणा, mava, _marg, lvov,
   {{0x7c2bc1e2,0x386945ec,0xa91ce06f,0xbb46c5ed}},	//   _gigr, yrar_, deľt, _редк,
   {{0x8bd7c076,0x6b9d05ee,0x41e725d0,0x200325ef}},	//   _בואו_, rdsg, віва, toji_,
   {{0x2d852066,0x7dcfa5f0,0x60c00277,0x799c65f1}},	//   ýle_, _løsn, ämma, _narw,
   {{0x200325f2,0xa3b3a010,0x257d85f3,0xd378e2e2}},	//   roji_, टात_, náló_, jići_,
   {{0x7bc081a5,0x2d9ee5f4,0x938b01e1,0x6603a5f5}},	//   _nomu, ldte_, _цска_, zonk,
   {{0x442ca5f6,0x2489006e,0x394641af,0x395905f7}},	// [2d0] _oid_, _upam_, ñosa_, mass_,
   {{0x68ee213a,0xb8db453a,0x7d0d05f8,0x2004c5f9}},	//   ándá, _अप_, _iyas, homi_,
   {{0x320dc5fa,0x48dea10a,0x3204c5fb,0xa3d02077}},	//   yley_, _कइगो_, komy_, वघर_,
   {{0xb5fb21de,0xe819e077,0x8af785fc,0xe4a4214f}},	//   cuár, _नीना_, _çəkm, _трьо,
   {{0x6b9c65fd,0x26c7a0e2,0x07f820d0,0x69c085fe}},	//   _farg, wyno_, _سریع_, _dome,
   {{0x7c2bc5ff,0x2d912600,0x799c6601,0xdce1a602}},	//   _sigr, neze_, _garw, _salı,
   {{0xc2936050,0x7c2bc603,0xb4bfa604,0x61e8e066}},	//   _خیاب, _pigr, ुने_, didl,
   {{0x6b9c6605,0x3ea6c606,0xd3a48607,0x09ca807c}},	//   _zarg, _brot_, _круп, লোবা,
   {{0xe4e784a4,0x7dc60608,0x799d4296,0x7d048609}},	//   _рівн, _móst, _masw, üist,
   {{0xb5fde3ee,0x7dc60005,0x6d55660a,0x2bcc03af}},	//   jušt, _lóst, _jeza, ास्थ,
   {{0xa3ea00de,0x442d860b,0x645bc60c,0x1bea01c7}},	//   една_, _kie_, ssui, едни_,
   {{0xa3b6860d,0x2004c60e,0xa06a060f,0x7d0d0610}},	//   जाय_, comi_, нама_, _byas,
   {{0xd37a800b,0xed59c611,0x3ea6c612,0x9f47a3ac}},	//   ערשט, maž_, _grot_, jinë_,
   {{0xdee62613,0x799d4614,0xfce62075,0xa3aca4e6}},	//   гоги, _aasw, гого, गाए_,
   {{0x3f87e615,0x7bc1a616,0x29c3c333,0x09cc407c}},	//   _ibnu_, _molu, _uñas_, রোফা,
   {{0x2005e617,0x6fc605e0,0x799c6258,0xd6d9c064}},	//   loli_, _cóct, _sarw, wały_,
   {{0x64a60618,0x18674619,0x3958261a,0x3b86661b}},	// [2e0] _сапа, лати_, pars_, ллаг,
   {{0x69c1a61c,0x7bc0861d,0x27e940c7,0x7643e07d}},	//   _nole, _somu, aian_, _ktny,
   {{0x8b56e00b,0xc332e095,0x7dca40c4,0x442d861e}},	//   ריעס_, צוא_, _lýsi, _bie_,
   {{0x2a7fc61f,0xd378e0e4,0xf1a3c064,0x9f5825df}},	//   ktub_, rići_, _खोलन, forç_,
   {{0x2005e620,0xa3b68621,0x66056622,0x799e24ec}},	//   koli_, जाब_, bohk, _kapw,
   {{0x66060623,0xd378e0a9,0x60dbc018,0x25a04046}},	//   hokk, pići_, dzum, ldil_,
   {{0xb5fb20e0,0xa3a94010,0x3f6a8624,0x74136555}},	//   sság, _गोड_, _пиво_, _طوفا,
   {{0x6d598625,0x64440194,0xa2a2e0a8,0x2ba4a626}},	//   cawa, _otii, गिस्, _गोरा,
   {{0xd130e13a,0x9fb8805c,0x46a38627,0xf487854f}},	//   يمة_, nčí_, _латв, _مالی,
   {{0x27e94628,0x6e2e6629,0xc6934095,0x5d54e62a}},	//   zian_, _jibb, צאת_, шкот,
   {{0x96f8e62b,0x7d0d0440,0xe8d90096,0x249a204d}},	//   тент_, _syas, _mbụ_, _nspm_,
   {{0x7c22862c,0x3d05c5cb,0x2e16c13a,0x61eaa62d}},	//   nmor, _हुवे_, _صباح, lifl,
   {{0xbcfb462e,0x6e2e6022,0x6b9d462f,0x2d9ce630}},	//   _adén, _oibb, _rasg, _tave_,
   {{0x6aa9429f,0x26dbc076,0x6f0d00b1,0x7d0d0631}},	//   _šefo, _אקדמ, _vyac, _vyas,
   {{0x7dc60632,0x37ab4633,0x6d4b8054,0xa157e095}},	//   _póst, нтан_, ybga, _גבוה_,
   {{0x9f47a0dd,0x442ee634,0xb886806f,0x2499405d}},	//   tinë_, _hif_, _zníž, _pssm_,
   {{0x6d5564fa,0x6e2e6635,0x29186636,0xfc3fa05c}},	// [2f0] _peza, _bibb, _azra_, _čím_,
   {{0x6d598637,0x61e52174,0x6aa8a638,0xb33ca17a}},	//   wawa, _umhl, _ordf, _jaħd,
   {{0x2ca90066,0x02a760fb,0xdb1aa639,0x25a0417a}},	//   _hrad_, ырам, _botí, bdil_,
   {{0x78874041,0xa3df80c2,0xe45f4069,0x7c2280f0}},	//   tīvā, धों_, _tvö_, gmor,
   {{0x49b8263a,0xe50be046,0x2d9dc011,0x1287863b}},	//   _شاید_, _सुनि_, _rawe_, امتی_,
   {{0xada5a03b,0x6d4d463c,0x442ee63d,0xfe45a63e}},	//   ракл, lbaa, _nif_, анко,
   {{0xdb0640e0,0xabd5c52e,0x2249436c,0x6d5725fc}},	//   _inká, ициј, lpak_, _mexa,
   {{0x6609863f,0x60dbc640,0x6e2e6012,0x9e9580eb}},	//   _ukek, tzum, _zibb, _پارچ,
   {{0x629aa641,0x6d5605cd,0x2ca90048,0x3f87e07d}},	//   _esto, _reya, _nrad_, _pbnu_,
   {{0xed59806e,0xf1f945cb,0x7c2e6642,0x7dd5c0e6}},	//   _kožo_, ्कड़_, _xibr, _básc,
   {{0x64440643,0x2ca9012a,0x60c9c644,0x6ce4a0ff}},	//   _stii, _arad_, syem, _ліце,
   {{0x442ee645,0x9f5ca066,0x6d4d4171,0x6299c0a2}},	//   _eif_, mová_, jbaa, _tswo,
   {{0x8934c646,0xc2ec607c,0x394dc647,0x76452069}},	//   _اعما, _করছি_, mbes_, _athy,
   {{0x7649c4b7,0xe0462197,0xfaa5e648,0x69c2c030}},	//   mpey, инги, _вако, _zooe,
   {{0xa3ccc55d,0x2d9e206f,0xdbcf606f,0x442fc649}},	//   _रकम_, ľte_, bľúb, _kig_,
   {{0x6d4d464a,0x0b46434f,0x27e7e1e7,0xfc3f4071}},	//   gbaa, рнан, _hmnn_, _crío_,
   {{0xe61a264b,0x9f5ca64c,0x8af0003c,0xee37464d}},	// [300] _иди_, hová_, _edər, инт_,
   {{0xb4c20010,0xed59864e,0x2480464f,0x79898650}},	//   ंही_, _božo_, rtim_, _abew,
   {{0x2007a651,0xfc3f4359,0x6d5bc652,0x78a98653}},	//   doni_, _frío_, kaua, _arev,
   {{0x442fc031,0xdb1ae654,0x7afd4037,0x69c40655}},	//   _nig_, rktø, _fxst, _joie,
   {{0x81cd807c,0x913b000b,0x2d852017,0x200683c5}},	//   ষোভ_, דענק, òleg_, rooi_,
   {{0x7c24403c,0x0466a656,0x7dcb210a,0x9f90a031}},	//   lmir, атим, _püsi, _bàá_,
   {{0xae0604e6,0x853001df,0xdb0f4011,0x9f91c1e9}},	//   रवान_, _daɗi, _ancè, _báà_,
   {{0x7dd8413a,0x298ac657,0xdb18e1ce,0x442ee658}},	//   _físe, тско_, _nová, _sif_,
   {{0x6aa98659,0xab5b03df,0xab27865a,0xdfdae1e1}},	//   _gref, kkür, _вота_, вън_,
   {{0x66e6a656,0x14cae052,0x69d6065b,0x127b8053}},	//   _коза, выми_, _alye, _באמע,
   {{0x3958665c,0xd5b7e65d,0xe737a04e,0x6280c65e}},	//   _mers_, рсы_, _тех_, stmo,
   {{0xb4c22026,0xe6950052,0x7bc40090,0x7de7014f}},	//   ्नै_, бимы, _coiu, ріод,
   {{0x7c2f465f,0x6d572005,0x58870056,0x926b014a}},	//   _ricr, _pexa, шына, ърна_,
   {{0x60160005,0x7dd5c049,0xc88485fc,0x69d60660}},	//   bámo, _tásc, mağı_, _elye,
   {{0xb4d121d6,0xb5fb2661,0xd7f82662,0x64464663}},	//   वने_, drát, руя_, _atki,
   {{0x3207a664,0x27ff4098,0x9f98c0f9,0x62828665}},	//   zony_, čuno_, _béé_, ktoo,
   {{0x61eb814a,0x7f5c2666,0xd9048050,0x9df9662a}},	// [310] vigl, barq, _آی_, гнат_,
   {{0xcb9920ff,0xdb0ae1ae,0x2007a00e,0x6d58e667}},	//   _свої_, _infâ, xoni_, _jeva,
   {{0x76452156,0x61eb8576,0x79952668,0x78a98057}},	//   _uthy, tigl, mezw, _srev,
   {{0x69c52669,0x63a2866a,0x7995266b,0x6608e06e}},	//   _hohe, gdon, lezw, hodk,
   {{0x660d0167,0xdca5804d,0x9b45a049,0x6fd5c019}},	//   _mkak, сали, منشو, _náca,
   {{0x0cb6a07c,0xaca32088,0x25a120a2,0x6fd8404a}},	//   জনৈত, _ndịd, _jahl_, _více,
   {{0x60cd466c,0x24954315,0x6282866d,0x61eb866e}},	//   lyam, şamı_, atoo, pigl,
   {{0xa3b5666f,0xe3b38343,0xd0f821a9,0x9f5ca326}},	//   झाव_, _برس_, ימות_, rová_,
   {{0x2007a670,0x9f5ca05c,0xcdb84095,0x6fcb203c}},	//   poni_, sová_, שפחה_, _hücu,
   {{0x61fb8536,0x3cff4064,0x69c40004,0x6d5bc671}},	//   _hjul, _रखने_, _soie, saua,
   {{0x7bc3e672,0xa5bb0673,0x81d6c07c,0x11d6013a}},	//   _vonu, rmón, _সদর_, متحد,
   {{0x27e9007d,0xb5fb2674,0x629d4675,0xdb0f4676}},	//   _cman_, krás, _osso, _encé,
   {{0xa069c677,0x6283a0a9,0x60cd400f,0x9045c678}},	//   _сала_, ltno, jyam, _انته,
   {{0x799523cf,0x395d8223,0xd91a8679,0x6608e025}},	//   gezw, haws_, טורל, codk,
   {{0xf99f0355,0x61fb867a,0x216a467b,0x6fd0267c}},	//   glès_, _ojul, ливи_, _häck,
   {{0x3860467d,0x1a2a467e,0xa3cac077,0x2a60467f}},	//   tsir_, ужби_, रॉप_, tsib_,
   {{0xe3b2225b,0x7f5c202f,0x62828054,0x3a200561}},	// [320] _فرد_, parq, xtoo, _ihip_,
   {{0x320d80ca,0x6609c680,0x291201df,0x25bfc681}},	//   _akey_, hoek, _iyya_, hjul_,
   {{0x2a604682,0x61ee2683,0x319b2095,0x6609c684}},	//   ssib_, mibl, _גבינ, koek,
   {{0x53e5814f,0xab5d80c2,0xb21b222e,0x9f4b03ac}},	//   оціа, _poża, ntæn, vicë_,
   {{0x44394685,0xdce64686,0x44316687,0x61fb80a6}},	//   _gus_, _takı, _fiz_, _djul,
   {{0xddc4649f,0xd838a04d,0x44320163,0x39594057}},	//   briš, _puč_, _liy_, _zess_,
   {{0xa3ca0688,0x44200689,0x63a084f2,0x395a268a}},	//   ोसा_, _ohi_, _tamn, _meps_,
   {{0x7995268b,0x6d43e3b0,0x4f65868c,0xe50be0c5}},	//   zezw, _afna, _واقف, _सुधि_,
   {{0x69dae68d,0x63b38326,0x9603e0c2,0x853000a2}},	//   thte, šení, रकूट_, _kaɗu,
   {{0x7f44005d,0x389b4095,0x6aa94098,0x78a9400a}},	//   _afiq, ניינ, _šefk, _ševk,
   {{0x44200569,0x69c52046,0x4432068e,0x7e62868f}},	//   _bhi_, _rohe, _biy_, lsop,
   {{0x9f4d80dd,0x69c52058,0x63a44690,0x0c26c691}},	//   _vjeç_, _sohe, jdin, _умен,
   {{0x7995249e,0xdb1d4692,0x2246c114,0x6892e0e0}},	//   tezw, _posí, _utok_, _کیجئ,
   {{0x2fc6c693,0x867bc694,0x6d5e6695,0x83fd00e4}},	//   _hoog_, _תרגו, japa, vrđu,
   {{0x7bc640bb,0x27e90037,0x7a296013,0x44268696}},	//   _boku, _tman_, _užti, kmo_,
   {{0x25a12105,0x443a2697,0x60188005,0xb5fb2698}},	//   _wahl_, _dup_, dímo, grár,
   {{0x200a235f,0x798d0699,0x2281a0e0,0x394160fa}},	// [330] bobi_, _ibaw, zók_, tchs_,
   {{0x2fc6c05f,0x61ee269a,0x200b069b,0xb5fb20e0}},	//   _loog_, cibl, loci_, rrás,
   {{0xddcd603b,0x69c5a052,0xb5fb2005,0xe61f4119}},	//   ptaž, öhem, brár, _thô_,
   {{0x63a2c167,0x27edc69c,0x395a269d,0x7dd84057}},	//   _naon, xien_, _zeps_, _vísc,
   {{0x69d8e510,0x2ed1a026,0xb5fda066,0x7dd5c066}},	//   _olve, तन्त, _avša, _básn,
   {{0x395ee017,0xa3c3469e,0xdcfc2018,0xdb1ae69f}},	//   jats_, ्सक_, cerē, nktó,
   {{0x59a6e026,0xf1c9a0f9,0x201f8067,0x6025c03b}},	//   _कोइर, _aláì_, _thui_, одка,
   {{0x2d8ac0e0,0x6d5f4401,0x78ad06a0,0x7f5f46a1}},	//   őben_, naqa, _orav, naqq,
   {{0x6d5aa6a2,0x85b9a6a3,0x7bdbc6a4,0x63a2c6a5}},	//   _feta, _клас_, rhuu, _daon,
   {{0x6fd02277,0xb801407c,0x6d59c4b7,0x649ee29f}},	//   _väck, ্ষিত_, _wewa, kšić,
   {{0x27e0a068,0x3a20005d,0x649ee6a6,0x62844108}},	//   ɗin_, _phip_, jšić, ztio,
   {{0xe819e029,0xdb040049,0x29c9e019,0x2465a018}},	//   _नीरा_, _iniú, _púas_, mēm_,
   {{0x2b4d04cd,0xdb00800e,0x443a26a7,0x15fb66a8}},	//   ñeca_, _ramë, _sup_, ्वार_,
   {{0x224dc6a9,0xab29e1bc,0xdb0d0057,0xa3ab8046}},	//   mpek_, _кола_, _coañ, _कोस_,
   {{0x61ee26aa,0xe73a46ab,0x78ad06ac,0x412a23d5}},	//   ribl, иев_, _erav, рово_,
   {{0x657bc6ad,0x660f46ae,0x7f5b84cd,0x6d5f46af}},	//   nguh, _ckck, _neuq, gaqa,
   {{0x61ebc05d,0x973ca143,0x443fc227,0x26174057}},	// [340] _mmgl, _laća, nqu_, cçom_,
   {{0xe69306b0,0x95f486b1,0x7dcb2105,0x628446b2}},	//   _کلید, ेक्ट_, _düss, rtio,
   {{0x5faf0010,0x78ad006e,0x601d06b3,0x6d5aa6b4}},	//   _जोडल, _zrav, léma, _reta,
   {{0x7e6286b5,0x8c35a0f9,0xb33b41de,0x60188005}},	//   tsop, _as̟o, _taça, rímo,
   {{0x3ea9412a,0x25a3617a,0xdb008396,0x2fc6c6b6}},	//   cvat_, _fajl_, _kamé, _roog_,
   {{0x2bd2c010,0x2d8d8079,0x69d9c6b7,0xc2914050}},	//   तस्थ, _ebee_, _alwe, _سیمب,
   {{0x2fc6c6b8,0x30a3a20e,0x2d9826b9,0x63a2c425}},	//   _poog_, дрыв, iere_, _paon,
   {{0x6aa940e4,0x6d5aa6ba,0xaa66c6bb,0xd90da050}},	//   _šefi, _weta, оток, دیم_,
   {{0x614140e0,0xa37b01ae,0xc5f8e041,0x2fc7e6bc}},	//   _háló, nhõe, tnē_, _bong_,
   {{0xd7f7e4e4,0x186aa6bd,0x23604022,0x388e4018}},	//   жую_, _важи_, haij_, mērā_,
   {{0x200b0068,0x443b01d7,0x7f5c6005,0x6aad06be}},	//   toci_, _suq_, _merq, _sraf,
   {{0x628606bf,0x6aad00ba,0xd0ebc04b,0x764d41e7}},	//   ftko, _praf, _जेवण_, ypay,
   {{0x370706c0,0x3949e6c1,0x2ba3c026,0x6835a013}},	//   ючов, _şase_, _खोटा, _išda,
   {{0x6d4646c2,0xdb0ae02f,0xdde24143,0x7c3ee6c3}},	//   _afka, _enfá, _ćušk, _épro,
   {{0x31604037,0x320ce6c4,0x600fe271,0xa802820f}},	//   faiz_, mody_, rømt, şıya,
   {{0xad9b42f4,0x6560c6c5,0xd9ff06c6,0x2b49e3ee}},	//   _ojúe, namh, _उदित_, _đaci_,
   {{0x0459413a,0x69daa12a,0x7f5c6227,0xe9df0049}},	// [350] صلاة_, _olte, _berq, mhú_,
   {{0x7658e022,0x7f5c66c7,0x200ce0fd,0x2901205f}},	//   _kwvy, _cerq, nodi_, _txha_,
   {{0x7a35a20d,0x6e3c66c8,0x7c22c534,0x9f490187}},	//   _ošta, _curb, _ohor, _amaé_,
   {{0x443ce4e2,0x7c3b86c9,0x248686ca,0x2d9906cb}},	//   _muv_, _puur, ftom_, nese_,
   {{0x6560c6cc,0x2d990197,0x26f6e0c2,0xd945a6cd}},	//   damh, iese_, ँपुर_, пели,
   {{0x2d9906ce,0x6e3c6337,0x2ba7c067,0xf1a3c0c2}},	//   hese_, _furb, _ốc_, _खोजन,
   {{0xdb01a6cf,0x2d9906d0,0x9f4ce004,0x61ed06d1}},	//   _kalé, kese_, cidé_, _omal,
   {{0x6e3566d2,0x3ead86d3,0x6d5c66d4,0x9599c4a0}},	//   _hizb, _tret_, _zera, стку_,
   {{0x395fc6d5,0x249f818c,0xdb01a6d6,0x3866c20d}},	//   raus_, _usum_, _malé, _cvor_,
   {{0x7f5d4004,0x63a406d7,0xa3c90021,0x6e3d46d8}},	//   _lesq, _sain, लॉस_, _musb,
   {{0x601606d9,0xb33b4057,0x1d09e6da,0x68296013}},	//   lámi, _naço, сени_, _uždu,
   {{0x2440c0d1,0xdb0bc03e,0x628603e0,0x37bda07c}},	//   _fòm_, _engá, ttko, _অতির,
   {{0x98abe121,0x3ea1200e,0x2fda207d,0xe449c049}},	//   ılık_, _asht_, _plpg_, _التى_,
   {{0x853ce013,0x600fe271,0x22840009,0xdd99c431}},	//   ndėl, røms, rök_, leň_,
   {{0x6d4566db,0x6d5c66dc,0x98a5e3ed,0x291e26dd}},	//   dcha, _rera, palı_, åta_,
   {{0x2d812096,0xe1ff20c2,0xdb0f46de,0x27ed81e7}},	//   _eche_, wrót_, _encí, _nmen_,
   {{0x3ea1200e,0x75d34049,0x6e3d4025,0xdb1d4066}},	// [360] _esht_, ريكا, _cusb, _posá,
   {{0xa7fd06df,0x7bdb8194,0x3ceca10a,0xe1ff41e9}},	//   nsın, _aluu, _अइले_, _ejó_,
   {{0xd910254f,0x7f5c66e0,0xb4d666e1,0x7bc286e2}},	//   _شیر_, _verq, िने_, tjou,
   {{0x6d5c66e3,0x934386e4,0x6014e5df,0x24868076}},	//   _wera, енце, ràmi, ttom_,
   {{0xa1164050,0x74138050,0x644162f8,0x27ff813e}},	//   _روست, روها, _élin, _djun_,
   {{0x7c29c06f,0x7c3e26e5,0x3f990108,0x9f5ca02e}},	//   emer, _kupr, zesu_, lovú_,
   {{0x6d5d46e6,0x61ee66e7,0x7c29c0cb,0x20000291}},	//   _yesa, _imbl, fmer, _ojii_,
   {{0x7d040057,0x69c446e8,0x8fa38013,0xada380db}},	//   _oxis, njie, _пасе, _пасл,
   {{0x7416a343,0xb4ac6028,0x26c04057,0xfc3f004a}},	//   _فورا, _कछु_, nxio_, tvím_,
   {{0x6d5e26e9,0x6e9384aa,0x63a646ea,0x9f9426eb}},	//   _nepa, _سلما, _lakn, _jää_,
   {{0x2b4d02a8,0x38c8e6ec,0x53990052,0x7ddda187}},	//   ñeco_, زادی_, овня_, _fèsb,
   {{0x9c8701ce,0x3ddfc171,0x656280ce,0x671f63fa}},	//   _načí, chuw_, naoh, _भरसक_,
   {{0x61ee66ed,0x395ea037,0x7f5d46ee,0xdb00807b}},	//   _ombl, _kets_, _resq, _inmó,
   {{0xaa66e6ef,0x7d1dc6f0,0x3ea12037,0x3866805d}},	//   _етик, üsse, _psht_, isor_,
   {{0x6e3d46f1,0xd48fe07a,0xdb05600e,0xb17b022e}},	//   _susb, _яр_, rdhë, rhåb,
   {{0x69dc66f2,0xd117e053,0x6d5e21e7,0x69cae6f3}},	//   _alre, _מקוה_, _eepa, _hofe,
   {{0xdb01a6f4,0xb5fb2019,0x6d5d46f5,0xe0df40f9}},	// [370] _valé, lsám, _vesa, _efòn_,
   {{0x799ae6f6,0x69cae057,0x67e06156,0x7bc986f7}},	//   netw, _jofe, _nöjd, _soeu,
   {{0x98a7a315,0xdb160157,0x27e046f8,0x75484009}},	//   yanı_, _anyè, bhin_, észí,
   {{0x7e9be00b,0x7dd5c066,0x3a248071,0x25e88028}},	//   מסבו, _pásm, _chmp_, चोली_,
   {{0x7bdd46f9,0x98a7a6fa,0x25a5a6fb,0xe5a5a6bb}},	//   _ilsu, vanı_, _pall_, дили,
   {{0x76ba4076,0x69cae0fd,0xf9c7a6fc,0x6d4720c2}},	//   _ומשפ, _nofe, ящен, ncja,
   {{0x78a2c04d,0x27ed807d,0x6aa2c2f4,0x78ad4046}},	//   _asov, _tmen_, _asof, lvav,
   {{0x56b82095,0x63b8e030,0x394686fd,0x9999604a}},	//   לפון_, _anvn, ccos_, _kusů_,
   {{0xdb1c61ae,0xdd99c06f,0xa2828050,0x98a7a315}},	//   _porç, reň_, _لینو, ranı_,
   {{0x7ddcc057,0x27e1017a,0x7dd84071,0x6b82c2dd}},	//   _pésc, _ċina_, _aísl, _ecog,
   {{0x66e5e6fe,0x6d5f06ff,0x7dd02277,0x38cac050}},	//   фона, _beqa, _mäst, مایی_,
   {{0x7e698013,0x200f8700,0x764d0614,0x24894701}},	//   _kvep, nogi_, _btay, ktam_,
   {{0x644bc3e0,0xdb0ae105,0x398fa0b0,0x09e30702}},	//   _utgi, _anfä, pısı_, тоян,
   {{0x7bcbc071,0x62956171,0x6b9bc703,0x601d0057}},	//   _hogu, _opzo, leug, bémo,
   {{0x644d0004,0x6d5f017b,0x753b8704,0x25a94705}},	//   _etai, _feqa, _oguz, fdal_,
   {{0x395f8706,0xe1f200eb,0x9f942052,0x38668707}},	//   _neus_, _جست_, _sää_, ysor_,
   {{0x63a64708,0x6563a709,0xfc3f4049,0xb4d7870a}},	// [380] _vakn, kanh, _cuí_, ानो_,
   {{0x6fdcc004,0x6aa400bb,0xc58ee067,0x00da6049}},	//   _méca, _isif, _lồng_, يبات_,
   {{0x7a01c018,0x3f9a604d,0xb33ca0f7,0x27e0470b}},	//   zēta, repu_, _daħl, phin_,
   {{0x7bcbc70c,0x3eb20066,0x799ae0c2,0x601de425}},	//   _nogu, _kryt_, zetw, kèmo,
   {{0x4425a70d,0x0443870e,0xac0aa70f,0x24894710}},	//   _bhl_, вечн, онда_, ctam_,
   {{0xafdb6042,0x4425a153,0xf1bf4067,0x7763a017}},	//   _støv, _chl_, _thác_, ganx,
   {{0x316d8019,0x9f5822a8,0xf7728711,0x63ade0a2}},	//   _fdez_, loró_, _لاء_, _ɗant,
   {{0x2d804712,0x7ddcc071,0x69d88018,0x2613c41a}},	//   ngie_, _bésa, īves, dãos_,
   {{0x5a34e14a,0x6563a713,0x442b003e,0xfcaa86ec}},	//   ннит, banh, vmc_, _بازو_,
   {{0x44386054,0xddc9e714,0x6f0da20f,0x63a9c715}},	//   _jir_, treš, şaca, aden,
   {{0xdb1c6042,0x2613c1ae,0x44446716,0x69cbc717}},	//   _forå, gãos_, nq_, _foge,
   {{0x3f9ca718,0xafdb614f,0x2b51e106,0x63a8a719}},	//   levu_, _utøv, ızca_, _hadn,
   {{0x7bcae71a,0x61fd06b5,0xb8f3c1a6,0x3eadc143}},	//   _tofu, rnsl, _হে_, cvet_,
   {{0x799c22ad,0x4fc6e71b,0x69d8a71c,0x224003c5}},	//   gerw, _ісла, nkve, _duik_,
   {{0x4034271d,0x78a4071e,0x3b4c4125,0x1d4c4079}},	//   терс, _esiv, _ọdịk, _ọdịm,
   {{0x63a760e0,0x386901d8,0x656e6153,0x2905217a}},	//   _sajn, _tvar_, _adbh, ħla_,
   {{0xd7e720ff,0x63a76022,0x25a9471f,0x799d0720}},	// [390] _жіно, _pajn, rdal_, mesw,
   {{0x6fd4a355,0x24894721,0x78ad4722,0x63a9c723}},	//   _fàci, rtam_, rvav, zden,
   {{0x656444ec,0xbcfb42f4,0x78ad459f,0xaca32079}},	//   baih, _adét, svav, _mpịg,
   {{0x9f5820e6,0x24894724,0x61e28725,0x63baa726}},	//   boró_, ptam_, ghol, _antn,
   {{0xf99241a9,0x6e2d4727,0x24444728,0x44386729}},	//   _ערך_, mmab, _göm_, _fir_,
   {{0x61f52181,0x628aa271,0x6602c052,0x6a85a06c}},	//   nizl, ftfo, _ajok, елка,
   {{0xd5fba125,0xfc46206f,0x61e2872a,0x291860a2}},	//   _asụ, žíva_, bhol, _gyra_,
   {{0x6fdda5df,0x6e92a049,0x6563a72b,0x7e7bc320}},	//   _dèca, اليا, sanh, tuup,
   {{0x2d9d872c,0x4426c72d,0x2918600e,0x2b4b4012}},	//   mewe_, _dho_, _zyra_, _mfcc_,
   {{0x7bcbc72e,0x2d9ca72f,0x7c2d4730,0x60e9e731}},	//   _wogu, ceve_, hmar, змом_,
   {{0xef19e54a,0x69cbc732,0x9f4b0733,0x7ac4a734}},	//   ямо_, _toge, ficà_, _исце,
   {{0x799c2735,0xdb0bc736,0x64408737,0x2cb201cd}},	//   werw, _angå, _yumi, _pryd_,
   {{0x7ccae5fc,0xe8034738,0xe6a8404a,0x9f47a106}},	//   lərl, रचना_, _příš, ginç_,
   {{0x270e8067,0x64a62013,0x69c12046,0x644821de}},	//   ộng_, нага, ölep, ídio,
   {{0xfce62739,0x809f60a8,0xc0e6273a,0x6441a73b}},	//   хово, _गैले, ховк, _juli,
   {{0x63a9873c,0x3ea0473d,0x61e2873e,0x6e2d4114}},	//   _naen, twit_, xhol, gmab,
   {{0x27e00497,0xe9da673f,0x6441a740,0x442dc741}},	// [3a0] _ilin_, пка_, _luli, ime_,
   {{0xbcfb41e9,0x2fdf80ae,0x3d112010,0x26e5a07c}},	//   _adés, _alug_, _दुवे_, _কখনো_,
   {{0x2003e742,0x38c5000e,0xb17b4065,0x39494022}},	//   čjih_, _tërë_, _slåe, bcas_,
   {{0x2d820743,0x44394744,0x65660745,0x2a694022}},	//   ngke_, _gis_, nakh, bsab_,
   {{0x7e69c065,0x76444746,0x2fcd81e7,0x6561a747}},	//   jsep, qqiy, _doeg_, _belh,
   {{0x2d8ea0fa,0xe4a6a4c2,0xa520804b,0xd25aa159}},	//   uffe_, ерио, _बरीच_, пци_,
   {{0xdb156748,0xe2976470,0x27ffc069,0xdcfc2041}},	//   _dozó, _пар_, fnun_, derī,
   {{0x2d9ca749,0x69c0c437,0x66040385,0x8026863b}},	//   seve_, वाधी, _njik, _سرزم,
   {{0x75240610,0x60c44005,0x32078009,0x98ab0181}},	//   _nziz, nxim, énye_, yacı_,
   {{0x6441a054,0x8e978087,0xf1bae067,0xa5bb074a}},	//   _fuli, _אדמו_, _thơm_, ológ,
   {{0x91a6e125,0x4426c74b,0xd6d7e74c,0x61e4474d}},	//   _atọ_, _tho_, етя_, khil,
   {{0x04dba095,0x201125fb,0x1ae6c74e,0x656600bb}},	//   _מקבל, wozi_, _поем, gakh,
   {{0x6e3aa17a,0x9f4b05df,0x6d4aa049,0x442ea74f}},	//   _kitb, ricà_, ocfa, omf_,
   {{0x7afb40e4,0xf1bf4067,0x7c3aa750,0x7c2d4751}},	//   _žuto, _chán_, _jitr, wmar,
   {{0x38694068,0xe4e420ff,0x29dc4005,0x656600bb}},	//   wsar_, гітн, _vían_, bakh,
   {{0x7a25c2c8,0xb6060066,0x7bdf0071,0x7ddcc752}},	//   póte, _pláš, _ulqu, _méso,
   {{0x63a98753,0xd838c030,0x9f9c40f9,0x24986631}},	// [3b0] _raen, _asčk_, _díà_, _aprm_,
   {{0xdb01a5e0,0x443a2754,0x44290755,0x7ccae03c}},	//   _salí, _gip_, _hha_, yərl,
   {{0x6fdcc005,0xe1f1a050,0x25aa6756,0x34d98026}},	//   _néco, یست_, _dabl_, भन्द,
   {{0xdb1aa757,0xdfd5419c,0x98ace19f,0x2ca6c0fd}},	//   _intè, _ромы, nadı_, _osod_,
   {{0x6fd6e0fa,0x98a58758,0x10a580de,0x443b0759}},	//   _tâch, тиле, тилн, _miq_,
   {{0x25a9875a,0xf994200b,0x443a2017,0xeb96a6bd}},	//   žal_, ָרק_, _xip_, виш_,
   {{0xed59807f,0x2fc76069,0xd2620018,0x656601fb}},	//   _anže_, öngu_, _ziņā_, yakh,
   {{0xe739c75b,0x4427e75c,0x77672022,0x3a290067}},	//   мей_, _shn_, hajx, _nhap_,
   {{0x6d49c75d,0xf8bf8066,0x2499417b,0x6442c75e}},	//   rcea, _šéf_, _jpsm_, _cuoi,
   {{0x7641a035,0xdb01a1ae,0x442ea057,0x7d09875f}},	//   _tuly, _calã, cmf_, _ixes,
   {{0x27e00760,0xd6dba04e,0x6441a761,0xdb03e030}},	//   _plin_, _эта_, _uuli, _annò,
   {{0xa06a0762,0xdb1c6763,0x3167a764,0x3940e0ba}},	//   мама_, _corù, lanz_, _şist_,
   {{0xdb06406f,0x20076098,0x3e416013,0xdb1aa157}},	//   _také, čnij_, _dėti_, _antè,
   {{0x3f832765,0x7dd840c4,0x63abc0c4,0xd24ec711}},	//   ggju_, _tísk, _hagn, _بنو_,
   {{0x703a403b,0x442f8025,0xdb08a0d5,0x96632766}},	//   дчас_, kmg_, _cadè, икре,
   {{0xeb97412a,0x2d832171,0xd00f0049,0xddcd607f}},	//   кис_, agje_, _ولو_, vraš,
   {{0x7643e767,0x2367a768,0xe0434769,0x61f64121}},	// [3c0] _huny, kanj_, инти, riyl,
   {{0x69cf4057,0x61f643ed,0x7e7e676a,0x6805403b}},	//   _eoce, siyl, tupp, rėda,
   {{0x63ad476b,0x69dbc04e,0x7d1b84ec,0x7dd4a5df}},	//   bdan, kkue, _ayus, _màst,
   {{0x7c3ee024,0x27e08049,0x6443e76c,0x69dc276d}},	//   _èpre, óin_, _muni, lkre,
   {{0x6b82876e,0x69c9c098,0x25aa676f,0x7c298770}},	//   rgog, djee, _tabl_, _dher,
   {{0x25a04771,0xb4de40c2,0xdb01a031,0x9cd70076}},	//   leil_, तनी_, _balà, כונה_,
   {{0xdb08a187,0xdb03e089,0x9f5ca089,0x3263a772}},	//   _kadé, _baní, cový_, атыв,
   {{0x225e205c,0xdb01a01f,0x63aae069,0xa01b2009}},	//   átky_, _salã, _safn, ltöt,
   {{0x2367a23d,0x6d408773,0x8c468774,0x7763e775}},	//   banj_, _igma, _резе, _benx,
   {{0x27e68776,0xbbd12026,0xf1bae119,0x7dd4a0b8}},	//   lhon_, _सकेक, _khơi_, _càst,
   {{0x63ad4777,0x25bea778,0xb97b6095,0xddc2a064}},	//   ydan, _intl_, וניי, zpoś,
   {{0x27e68426,0xa785c1ac,0x44290779,0x6fd5c071}},	//   nhon_, _مشهو, _qha_, _bácu,
   {{0x051f207c,0xf8bf60a8,0xfc3f40f9,0x69cf477a}},	//   _দলের_, _एप्प, _asín_, _roce,
   {{0xf1bf4067,0x69dc277b,0x5c042099,0x6ab6077c}},	//   _pháo_, gkre, аяса, _dryf,
   {{0x6280c77d,0x63ad414f,0xed5f8066,0x2d83277e}},	//   lumo, tdan, ážka_, rgje_,
   {{0x442f077f,0x5fc5c04b,0x2018618c,0x7c2de197}},	//   _òg_, वायल, _akri_, _èarr,
   {{0x6fdcc0fa,0x442a66f8,0x24804017,0x63ad008b}},	// [3d0] _récl, _bhb_, guim_, _iaan,
   {{0x2d876780,0x6e298781,0xf1bf4067,0x3b546782}},	//   üne_, _sheb, _tháo_, икур,
   {{0x7ae9c783,0x7c298784,0x601ec00e,0x61e2c785}},	//   zzet, _pher, rëmj, _olol,
   {{0x7ddda5cd,0x9f5ca05c,0x1a654043,0xdd01c23d}},	//   _pèso, rový_, _میری_, _žučn,
   {{0x3b098786,0xbc19a0db,0x6568e787,0xf1bf4788}},	//   çaq_, нікі_, kadh, _iná_,
   {{0x6e3c6789,0xe4f602b4,0xfc3f0005,0x27e68561}},	//   _girb, ीपति_, lvís_, ahon_,
   {{0xc984a78a,0x7c3b878b,0x6563e78c,0xb17b0262}},	//   ручи, _tiur, _renh, thål,
   {{0x443ce022,0x764520c7,0x25adc78d,0xa3ab80c2}},	//   _aiv_, _muhy, udel_, _कोच_,
   {{0x25adc78c,0x65640105,0x601de5df,0x7c2ae049}},	//   rdel_, _reih, lèmi, _bhfr,
   {{0x47c5e78e,0x69dbc78f,0x7aa5e1b1,0x2d83a065}},	//   убов, skue, гиоз, _øje_,
   {{0x77640790,0x69c46010,0x68e9c791,0x3255a792}},	//   _peix, राती, szed, _свер,
   {{0x9ac4c17a,0x23694793,0x6016a1de,0x7bcb8133}},	//   _biċċ, jaaj_, lâmp, njgu,
   {{0xdb1aa066,0xe8dfa119,0x69dc2794,0x6443e795}},	//   _motý, _diễm_, tkre, _wuni,
   {{0x69dd0052,0xaae5e566,0xdb08a18c,0x7643e796}},	//   akse, _مسعو, _sadé, _tuny,
   {{0xe81ba028,0x442a6797,0xf3f0e13a,0x3ea90798}},	//   _पीछा_, _rhb_, _بأن_, _esat_,
   {{0xdca64799,0xbea6479a,0x29050181,0x8c43620f}},	//   лаби, лабк, ğlar_, ışla,
   {{0x7c3c679b,0x443ce022,0xdb064157,0x6b84479c}},	// [3e0] _pirr, _yiv_, _ankò, rgig,
   {{0x79898020,0xef17479d,0x2904203c,0x20032361}},	//   _acew, уму_, şmaq_, cnji_,
   {{0x69c2a79e,0xdceae5f9,0xf99f4187,0xcb6a45d0}},	//   लासी, ćiće, _ijèn_, _пане_,
   {{0x5f462062,0x7986079f,0x7a3ee018,0x3ebf47a0}},	//   _جنگل, ngkw, _jūta, _šute_,
   {{0x248047a1,0x6281e7a2,0x2449c7a3,0xdce0c018}},	//   quim_, hulo, _núm_, kamā,
   {{0x601d07a4,0x27e687a5,0x656641e7,0xaca48088}},	//   rémi, shon_, _hekh, _ntụp,
   {{0xa5bb4049,0x63ae61e7,0x1ae66052,0x998d806f}},	//   _shói, _iabn, _совм, _sieť_,
   {{0x644647a6,0x200323ce,0xa01b2277,0x9874c080}},	//   _kuki, znji_, ntör, алиц,
   {{0x80a407a7,0x63ae6022,0x090687a8,0xd91086b0}},	//   _चैले, _kabn, _спан, _بیش_,
   {{0x27134016,0x7dd5c13a,0x97a6e07a,0x443ce286}},	//   ệng_, _sást, урил, _qiv_,
   {{0xa01b27a9,0x1959002d,0xb97b600b,0x764647aa}},	//   ktör, каны_, ענטי, _luky,
   {{0x9a86c7ab,0x6280c019,0x443247ac,0x7528a018}},	//   _букл, pumo, jmy_, _izdz,
   {{0x7dd5c4cd,0x69dd00ff,0xdb18e019,0xb4de4046}},	//   _vást, rkse, _inví, तनो_,
   {{0xe7bf607c,0xd7c7a010,0x3a2b4071,0x61e400bb}},	//   _ইত্য, लायच, _shcp_, _elil,
   {{0x539be095,0x7d1d4249,0x7dd5c13a,0x65652098}},	//   _ניהו, _syss, _tást, _vehh,
   {{0x6d5c27ad,0xdb0bc56e,0x3b55401f,0xa3e9004a}},	//   abra, _bagè, ркар, _यति_,
   {{0x5fc5c010,0xa2c60466,0xb33b01ae,0x8c4360b0}},	// [3f0] वातल, ामण्, beça, ışma,
   {{0xdcfc2018,0x212906fa,0x443247ae,0xad9b40c4}},	//   sgrā, _izah_, amy_, _kjúk,
   {{0x9f59000e,0xa3e907af,0x5f186466,0x4395403b}},	//   jisë_, _यता_, _बुद्_, _канс,
   {{0x2bc321d6,0xa5678062,0x63a1e7b0,0x644647b1}},	//   शावा, ادان, zeln, _fuki,
   {{0x98b12315,0x6281e7b2,0xdcebc17a,0x6d41a1e7}},	//   mazı_, zulo, _ibgħ, _pgla,
   {{0x7987205d,0xd47a4053,0x2be207b3,0x867a4076}},	//   ngjw, _באשל, _पत्थ, _ברשו,
   {{0xd24ea7b4,0x68ed47b5,0x228f47b6,0x7a01c041}},	//   ونو_, lzad, lük_, lēti,
   {{0x2a6dc10a,0x7df460c2,0x244aa067,0x7bdf40da}},	//   tseb_, yńsk, _dùm_, nkqu,
   {{0x394dc146,0x660982e2,0x386dc7b7,0x661b8096}},	//   rces_, _ijek, user_, _ikuk,
   {{0x61fae1e7,0x8467a1e1,0xe8dfa016,0x443ea121}},	//   gitl, _бъде, _niệm_, _git_,
   {{0x9f5900dd,0x656767b8,0x1d09e1c7,0x7843a0e0}},	//   cisë_, _mejh, тени_, _bőve,
   {{0x1959c7b9,0x656b87ba,0x7c3e27bb,0x3a2d805d}},	//   _рады_, nagh, _sipr, _jhep_,
   {{0xaa4604a4,0x61e9c7bc,0xfc49e067,0xb6060031}},	//   регл, mhel, _bậc_, _aláá,
   {{0x7c2d07bd,0x61fbc7be,0x3f8b47bf,0x0eb32046}},	//   _ehar, liul, _accu_, ुमंड,
   {{0x6283a7c0,0x443f8057,0x67e3410a,0xa96727c1}},	//   nuno, _oiu_, _sõja, риса_,
   {{0xd848c016,0x442047c2,0x764647c3,0x78ba606f}},	//   _họa_, uli_, _puky, _štvo,

   {{0x656b87c4,0x1f6667c5,0x6fdcc004,0x645567c6}},	// [400] dagh, икам, _déch, _atzi,
   {{0x60c9c5df,0x661b87c7,0xa3ea27c8,0x660980f9}},	//   ixem, _akuk, _मति_, _ajek,
   {{0x68ed403e,0x27e947c9,0x7b6687ca,0x61fc27cb}},	//   azad, bhan_, атле, mirl,
   {{0x69c1a7cc,0x443f8355,0x61fbc167,0x2367e7cd}},	//   _anle, _ciu_, jiul, _lenj_,
   {{0x61fc213a,0x2fcdc2e2,0xe9f92031,0xf3c920eb}},	//   oirl, djeg_, _asẹ_, _شبیه_,
   {{0x442d87ce,0x61fc27cf,0x0ca68290,0x6283a7d0}},	//   _ehe_, nirl, _गनीम, funo,
   {{0x68fb403a,0x98b24121,0x9f45e04a,0x6d5d0025}},	//   _ľudi, mayı_, chlé_, ybsa,
   {{0xdb00803a,0x7e62c0d1,0x69c1a7d1,0x61fc27d2}},	//   _pamä, _pwop, _enle, hirl,
   {{0x63a3a0e2,0x973ce504,0x27f867d3,0xb376a050}},	//   benn, deća, _kmrn_, _نداش,
   {{0x6283a7d4,0x9f5822a8,0x644087d5,0x2d8ae106}},	//   buno, biré_, _himi, übe_,
   {{0x91e6c7d6,0x764087d7,0x270247d8,0x0bb76095}},	//   _коже, _kimy, लपुर_, בלים_,
   {{0x7aed42b1,0xdb1aa017,0x7e62c157,0xe4f967d9}},	//   yzat, _fotò, _twop, ्पति_,
   {{0x9f5907da,0x201827db,0x6568a050,0x2bc964f6}},	//   nisé_, fori_, _kedh, रामा,
   {{0x67fec041,0x321827dc,0x7e64048d,0x6fdcc0fa}},	//   rīju, gory_, _dwip, _séch,
   {{0x7c2287dd,0x6568a7de,0x67fec041,0x27e04020}},	//   klor, _medh, sīju, fkin_,
   {{0x3edf0125,0xe3b041b3,0x600803df,0x6618a066}},	//   _apụọ_, ورق_, nıml, hovk,
   {{0x2d8ca7df,0x809f6064,0xe695013a,0xdcf5603c}},	// [410] _ocde_, _गैजे, _الخد, _razı,
   {{0x6447612b,0xd6db67e0,0x660980ff,0x6283a7e1}},	//   _puji, кте_, _sjek, yuno,
   {{0xb4e16010,0xfa34213a,0x6808c04a,0x60080106}},	//   धने_, _بريد, vědn, kıml,
   {{0x644087e2,0x27e047e3,0x7c2287e4,0x6568a614}},	//   _cimi, ckin_, glor, _aedh,
   {{0x224900c7,0x7cfc6271,0x644760a2,0x6abaa7e5}},	//   _juak_, _pårø, _wuji, _artf,
   {{0x61fd07e6,0x78baa199,0x6aad0167,0x764d403c}},	//   hisl, _brtv, _msaf, mqay,
   {{0x3ea947e7,0x3f87a098,0x64556108,0xbab5a20e}},	//   lwat_, rgnu_, _utzi, сёлы,
   {{0x27e6c071,0x1a6880d0,0x2367e64e,0x6f04c7e8}},	//   _clon_, _چینی_, _senj_, _žica,
   {{0x5ef9607c,0xd7f887e9,0x61fbc12a,0x6448a187}},	//   _অডিও_, _тур_, riul, _eudi,
   {{0x63a447ea,0x6448a7eb,0x7bc2c095,0x27fd81cd}},	//   zein, _fudi, _enou, liwn_,
   {{0x60dbc7ec,0x6aad07ed,0x61fbc12a,0x7a23810a}},	//   syum, _asaf, piul, võtj,
   {{0x3ead8012,0x61e9c1fb,0x201907ee,0xef1f00b0}},	//   _kset_, qhel, gosi_, rgün_,
   {{0x6b9b87ef,0x7ddf000e,0xe730c7f0,0xd848c119}},	//   _mbug, _mësh, _قصه_, _tọa_,
   {{0x973ce6be,0x7ddf000e,0x2bc5c7f1,0xe8df8067}},	//   seća, _lësh, वावा, _ngọn_,
   {{0xdb01e0e0,0x320687f2,0x66e327f3,0xc255e50f}},	//   kelé, ynoy_, пора, _اختت,
   {{0xa3b827f4,0x2d8d8022,0x2291e009,0x395fc7f5}},	//   _घोर_, _ncee_, mák_, nbus_,
   {{0xf4130095,0x644087f6,0x61fc27f7,0x321826c4}},	// [420] _מפה_, _rimi, pirl, pory_,
   {{0x00ca2399,0xdce3e2f9,0x20182746,0xc9aa27f8}},	//   _блок_, _lenč, qori_, _свое_,
   {{0xdb03e01f,0x656e20bb,0xb86567f9,0xa1364050}},	//   _danç, mabh, قانو, _گردش,
   {{0x765c20ae,0xed5a414a,0x3d18c7fa,0x9f5903bb}},	//   mpry, _щом_, _पडले_, tisé_,
   {{0xeafa8085,0x7989c7fb,0xad9b4031,0x25f6c029}},	//   درات_, dgew, _ajúw, एफसी_,
   {{0x656e26f1,0x2d8a27fc,0x41c967fd,0x80d1407c}},	//   nabh, ngbe_, राणस, _সেক্,
   {{0xa3cc4026,0x6618a05c,0x7641a0e2,0xd467a1e3}},	//   लाप_, rovk, _dily, бије_,
   {{0x6e2444ec,0x6b89c1cf,0x69d607fe,0x7989c7ff}},	//   nlib, ggeg, _noye, ggew,
   {{0x7bd56786,0x6d46408b,0x765bc114,0x78bb84f0}},	//   _yozu, _mgka, gpuy, _gruv,
   {{0xd910e555,0x7648a1e7,0x9f44c2a8,0x31c6e052}},	//   ویش_, _tudy, timó_, ссив,
   {{0x69c401d7,0xfbc40010,0x61e28800,0xf54f4125}},	//   _bnie, षांम, okol, _kụta_,
   {{0xf400607c,0x5693e09e,0x7c29417a,0x24804801}},	//   ্তির_, чают, ċerk, krim_,
   {{0xa3cc4802,0xead4c09c,0x64486197,0xdb076803}},	//   लान_, _фоль, _èdif, _majá,
   {{0x2291e804,0x6d464805,0xfc49a089,0x61fd0806}},	//   bák_, _agka, slíš_, sisl,
   {{0x9b58212a,0x69d60807,0x43950808,0x9f5a60fa}},	//   сист_, _foye, _дайс, cipé_,
   {{0xa5bb4071,0x6aad035f,0xdb03e809,0x61e2880a}},	//   _ahór, _tsaf, _sanç, jkol,
   {{0xe1ff080b,0x4424c10a,0x61e28300,0x7642c0ce}},	// [430] mió_, ilm_, dkol, _mioy,
   {{0xdd310064,0x9f45620f,0x61e2880c,0x6e244035}},	//   _mężc, _ölü_, ekol, alib,
   {{0x6441a80d,0x2bc7a04b,0x61e340ba,0x660d01b4}},	//   _rili, लासा, _înlo, _kjak,
   {{0x3ebe2065,0x19ab480e,0x60da2046,0xf8bf4031}},	//   ætte_, _стоп_, ätme, _ayée_,
   {{0xdb052121,0xa5bb4049,0x6287280f,0x62952108}},	//   _bahç, _fhór, lujo, ltzo,
   {{0x7a05403b,0x660d000a,0x32094810,0x973ce23d}},	//   dėti, _ljak, lnay_, jećo,
   {{0x656f0811,0x6b89c812,0x02b3a021,0xdb08a017}},	//   kach, tgeg, ंटेन, _cadà,
   {{0xb068a049,0x656f0813,0xe1ff0071,0x395fc006}},	//   حصول_, jach, jió_, ubus_,
   {{0xd848c814,0x60cd4815,0x6441a816,0x7658e03b}},	//   _wọn_, nxam, _tili, _atvy,
   {{0xcf39e0ff,0x2251e066,0x61ed4817,0xdb1e2106}},	//   ичні_, ízko_, hhal, _popü,
   {{0x060a009e,0x6280c58f,0x69c40306,0x8e0a01b1}},	//   инок_, armo, _pnie, инов_,
   {{0x2291e723,0xeaba0818,0x644ae00f,0x3634c049}},	//   rák_, айм_, _dufi, _فرنس,
   {{0xdb03a066,0x81aca07c,0xf770c819,0xe56ee81a}},	//   dené, গার_, _سان_, _оз_,
   {{0x69d72057,0xed59e81b,0x7bc3e765,0x9f45e019}},	//   _coxe, _ток_, _unnu, riló_,
   {{0x6609c296,0x644bc81c,0x656bc0c7,0x752d081d}},	//   onek, _hugi, _kegh, _ezaz,
   {{0x6443e81e,0x543606b0,0xceb2a0be,0xa6ca001e}},	//   _hini, _برتر, ויל_, _نوبل_,
   {{0x3a20048d,0x4425e81f,0xf34ec079,0x2fc0c049}},	// [440] _ikip_, oll_, _kụrụ_, _óige_,
   {{0x201f8820,0xdb1c6069,0x6443e821,0x6281e23c}},	//   _akui_, _borð, _jini, orlo,
   {{0xd9464822,0xeb9a412a,0x5ea66047,0xf8c9e0aa}},	//   _мени, _кин_, تمال, िमिय,
   {{0x64a68823,0x61e98425,0x27edc07f,0x2bdc6026}},	//   жада, _clel, jhen_, _मकवा,
   {{0xf1bf4016,0xa6dee067,0x779140e0,0x93fe204b}},	//   _cháu_, _ngưn, _سیلا, _उगाच_,
   {{0xdb1aa824,0x7524000f,0x2716e04a,0xf34ec088}},	//   _antá, _myiz, něné_, _nụrụ_,
   {{0xafe6812a,0x9f5ca089,0x5333a825,0x6d46c089}},	//   _довл, nivé_, мешт, žkam,
   {{0xd49ac826,0xe1ff05df,0x6d47600e,0x6458e098}},	//   аро_, xió_, _zgja, _rtvi,
   {{0x661ae827,0x3eafc119,0x9f47a2a8,0x973ce20d}},	//   totk, _csgt_, ginó_, tećo,
   {{0x33d5a139,0x6fdcc004,0x764bc1e7,0x7643e1df}},	//   _ніхт, _récu, _dugy, _ciny,
   {{0x2475e041,0x69c64828,0x32094025,0xdce72018}},	//   gām_, _onke, ynay_, kajā,
   {{0x2b408552,0x7a202009,0x29dc40e6,0xdb03a005}},	//   žicu_, zött, _mías_, xené,
   {{0x6281e829,0x2fc6c08b,0x47ada1a6,0x9f47a82a}},	//   arlo, _inog_, চারী, cinó_,
   {{0xd250e13a,0xbddb4355,0x36d5282b,0x7643e82c}},	//   _كنت_, _cièn, погр, _giny,
   {{0x63a7282d,0x63b522b8,0xf96b41e1,0x3a20007d}},	//   rejn, rdzn, ирай_, _fkip_,
   {{0x61e44644,0x6288e82e,0x7bd8e488,0x5334282f}},	//   gkil, mudo, _hovu, фест,
   {{0x68fb406f,0x69d72057,0x752d0830,0x321ca066}},	// [450] _ľuds, _toxe, _uzaz, kovy_,
   {{0x2d8ce831,0x27edc0e8,0x68120018,0x3f8ce832}},	//   ngde_, zhen_, rāde, ngdu_,
   {{0x644521e7,0xd848c125,0x2d8ce833,0x6d5520c2}},	//   _iihi, _sọl_, igde_, mcza,
   {{0xdb01a049,0x61ff4786,0x6dc781c1,0xd848c291}},	//   _talú, qiql, غزال, _pọl_,
   {{0x3ebea65f,0xb2ab8834,0xed59a835,0x24f883fc}},	//   _artt_, ртеж_, бол_, онцы_,
   {{0x6288e836,0x656bc197,0x644520a2,0xb4e74292}},	//   kudo, _segh, _jihi, बनी_,
   {{0x6443e837,0xb4e3c026,0x9f5ee017,0x7643e838}},	//   _rini, नन्_, mitè_, _riny,
   {{0xf1b9c3ce,0xf771c57f,0x64452839,0x2475e041}},	//   koše_, راب_, _lihi, vām_,
   {{0xdb0f407b,0xc7b283c8,0x212d8361,0xeab0868c}},	//   _incó, _אבן_, _uzeh_, _لعل_,
   {{0x4432083a,0x28bda83b,0x2001683c,0xe8f6c03b}},	//   _shy_, ्मदि, nihi_, ялы_,
   {{0xc617a79e,0x69c7683d,0x2716e04a,0x24894223}},	//   दकीय_, _mnje, věné_, huam_,
   {{0x224d805d,0xeb9a0792,0x2d8ce54c,0xade9e0eb}},	//   _kuek_, щим_, agde_, _گفتم_,
   {{0xdb03e83e,0x7bc76171,0xddcd683f,0x6459c840}},	//   _janú, _onju, draž, _utwi,
   {{0xed572841,0x44442842,0xd11c4843,0x2ca9a0c2}},	//   зор_, _qi_, _भुषण_, ładu_,
   {{0x412a2844,0x75e060e0,0x200c41ae,0x9f5ee00e}},	//   сово_, _közv, édio_, zitë_,
   {{0x60dce845,0x2fd86846,0x798d4847,0x67efa065}},	//   ärme, _sorg_, ggaw, _højd,
   {{0x64452848,0x63b56041,0xf1b9c2e2,0x32020066}},	// [460] _fihi, _bazn, coše_, miky_,
   {{0x657b8849,0x69d9c095,0x4abda3af,0x6296484a}},	//   _aduh, _lowe, ्माव, rtyo,
   {{0x4426884b,0x25a9484c,0xdb060009,0x02a8c84d}},	//   tlo_, beal_, deké, _कन्न,
   {{0x628fe064,0x0446404e,0x7bc7611d,0x6249484e}},	//   ńcow, _немн, _enju, _džob,
   {{0xf1c7a010,0x656445c8,0x25a00037,0xdb18e156}},	//   लांन, mbih, _mbil_, _invå,
   {{0xe3b8e121,0xa533884f,0x69c7609f,0x9f590066}},	//   rlık_, хніч, _gnje, visí_,
   {{0x9f5ee00e,0x18a36850,0xa01b2851,0x8afdc04a}},	//   sitë_, _парм, krön, kařs,
   {{0x64464068,0x6d552064,0x2fc7e187,0x26c00852}},	//   _jiki, zcza, _anng_, _orio_,
   {{0x6d552064,0x3ebf8853,0x776d0057,0x6d48a143}},	//   ycza, _grut_, _reax, _tgda,
   {{0x764e6610,0x2d8ce854,0x25a00046,0x236d805f}},	//   _kuby, ugde_, _abil_, _zeej_,
   {{0x661d0855,0x9f5ee856,0x2d8ce110,0x776d003e}},	//   tosk, nité_, rgde_, _peax,
   {{0x76452037,0xb904e857,0x63a8e858,0xaca441e9}},	//   _sihy, _नथ_, sedn, _awọt,
   {{0x64452859,0x69daa85a,0x63b60025,0xdce7604d}},	//   _pihi, _kote, _dayn, _rejč,
   {{0x19582056,0x307bc0be,0x2d9c4009,0x765c6262}},	//   зары_, _פאונ, ővel_, _otry,
   {{0x7bc8a05d,0x69d9c85b,0x69daa85c,0x6298a4d9}},	//   _mndu, _yowe, _mote, ntvo,
   {{0x26c0085d,0x78ad4614,0xdb0bc2a8,0xdb1aa156}},	//   _frio_, twav, _hagá, _intä,
   {{0x7646408b,0x73d9685e,0x386901df,0x63b5685f}},	// [470] _diky, одар_, _uwar_, _pazn,
   {{0x4ab0e260,0x44212037,0x9f582024,0xceb403c8}},	//   _जनाव, _ukh_, cirà_, _טיפ_,
   {{0x20032860,0x2452c016,0x321d8064,0x236d8048}},	//   miji_, _lâm_, towy_, _peej_,
   {{0xa2c0a861,0x98b90315,0x2a604022,0x2cadc1cd}},	//   विन्, lası_, bpib_, ywed_,
   {{0x7bdaa862,0x201ee863,0xb9224088,0xb17b45ee}},	//   _botu, koti_, _mkpị_, _blåv,
   {{0x6abbc864,0x64464865,0x27e682c7,0x3ebf812a}},	//   vvuf, _ziki, akon_, _vrut_,
   {{0xe299a866,0x236d805f,0xdb0f4019,0x6d47e0a9}},	//   цай_, _teej_, _mací, žjak,
   {{0xb9c5813a,0x44236037,0x764f4867,0xb4db4090}},	//   _تقري, _hkj_, _kucy, _agài,
   {{0x69c98868,0x656f4869,0x765b800f,0x52df407c}},	//   _inee, _mech, _utuy, _নেতৃ,
   {{0x69c98048,0x2452c016,0x2451a016,0x68e1610a}},	//   _hnee, _dâm_, _tám_, _ülds,
   {{0x644e686a,0xb21b286b,0x61ed086c,0x3eadc3b0}},	//   _xubi, træn, _blal, swet_,
   {{0x2734483e,0x9f58286d,0xddc2e86e,0xd6d8a04e}},	//   _júní_, dirá_, _gvož, _эту_,
   {{0xddcd286f,0x64464605,0xa3cc4870,0x8af04497}},	//   _svaš, _riki, लास_, hbər,
   {{0xc332c095,0x9f4b0333,0x61ed0871,0x660dc06e}},	//   _סוג_, ficó_, _elal, čaku,
   {{0x81bce041,0x69b2e010,0x44294872,0x50432607}},	//   klēj, _असती, fla_, терб,
   {{0x6603a873,0xbbdaa021,0x290ec00a,0xdb03a066}},	//   hink, _बक्क, šmaš_, jení,
   {{0xe2974874,0x78a96875,0xf1c96010,0xcf92c49c}},	// [480] мат_, _ćeva, रांन, כטן_,
   {{0x7c29c876,0xa3cc4877,0x5ef38295,0xee376878}},	//   hler, लाह_, ्छन्_, дну_,
   {{0x645d4879,0x2fc90058,0x9f5821af,0x644f4057}},	//   _etsi, _ynag_, cirá_, _euci,
   {{0xe45f4156,0xda0e0010,0x090685a7,0x27eca05d}},	//   _bröd_, ाचित_, мпен, _sldn_,
   {{0xc1734095,0xe3b8e3df,0xb05b0277,0x4420487a}},	//   _בחר_, ydı_, rväg, moi_,
   {{0x6d59c87b,0x2365e098,0xa06a687c,0x27ed887d}},	//   _afwa, jblj_, _мага_, _elen_,
   {{0xdb0720e0,0x2d96887e,0xc6e8e07c,0x7ae3a14f}},	//   tejé, _орас, _পশ্চ, gynt,
   {{0x69db887f,0x7ddcc1af,0xdb00c5df,0x6e29c880}},	//   _goue, _césp, temà, gleb,
   {{0x5186e881,0x3ea9e361,0xdb0520f9,0x973ce143}},	//   муна, _ćata_, _dahù, meći,
   {{0x752fe064,0x7e628882,0x660081e7,0x200dc0ba}},	//   ęczn, mpop, _hmmk, anei_,
   {{0x44204883,0xca48c016,0x61ed0884,0x660d4121}},	//   koi_, _mời_, _plal, ynak,
   {{0x4420400e,0xd378a320,0xd257e0db,0xdb1c6262}},	//   joi_, _doće_, ьць_, _inrä,
   {{0x2247e885,0xfbdf4016,0xdb0bc886,0x69dc6887}},	//   _fink_, _biên_, _tagá, _oore,
   {{0xdb03a04a,0x6448a888,0x7fb8e0eb,0x395a2733}},	//   zení, _jidi, _رهبر_, _cfps_,
   {{0xdb08e0e0,0x61ed0889,0x3e7aa041,0x24868153}},	//   kedé, _tlal, nīt_, hrom_,
   {{0x62856066,0x63b8e3d1,0x660d488a,0x26c24320}},	//   vrho, _havn, unak, _brko_,
   {{0x6d5aa88b,0x2bd144ef,0x6447607d,0x7e62888c}},	// [490] _ofta, हाबा, _piji, jpop,
   {{0x7a120041,0x69c9888d,0x2129088e,0x69db8030}},	//   nātn, _snee, _iyah_, _soue,
   {{0x7c29c121,0x625361d7,0x6249488f,0x660d4037}},	//   yler, _għol, _džoa, pnak,
   {{0x44204890,0x3f158891,0x7c24005d,0xd1318049}},	//   coi_, ндес, _xkir, هما_,
   {{0xf77080a4,0xed59a892,0xa3cc4290,0x7af64064}},	//   شان_, пол_, लार_, czyt,
   {{0x9f98c069,0x28bda893,0xdcf8e030,0x1c008894}},	//   _séð_, ्मलि, _advč, लोबल_,
   {{0x6e20c1af,0x2bd2e04b,0x2ca6c895,0xdd946099}},	//   fomb, ताना, _apod_, _шары,
   {{0xfe438896,0x69cae897,0x9e48006f,0x69dc6898}},	//   _شکای, _anfe, _keďž, _zore,
   {{0x7bdd4426,0xc245e503,0x7648a899,0x442161e2}},	//   _mosu, нник, _fidy, ooh_,
   {{0x0e65e4c9,0xf1d2637f,0x3c32006f,0x4420489a}},	//   нкон, सायन, dáva_, zoi_,
   {{0xdb0e689b,0xe9ff8016,0xf99f014a,0x6729807d}},	//   _kabá, _giản_, ffè_, _hyej,
   {{0x68e4489c,0x02bda290,0x60c2c89d,0x98a0c03b}},	//   yyid, ्मीन, _from, _šią_,
   {{0x4420489e,0x25adc89f,0x65752037,0x64a5c0db}},	//   voi_, meel_, fazh, _чала,
   {{0xba39e00b,0x63b9c17a,0xe80200c5,0xdce720c2}},	//   _צײַט, _hawn, _लगवा_, zają,
   {{0x69dd48a0,0xe1ff6064,0xa3e3c010,0x3d1a2843}},	//   _bose, _twój_, _नका_, _मुखे_,
   {{0x25b860fa,0xa2c0a8a1,0x7bcae143,0x6724817a}},	//   _sarl_, वित्, _znfu, żiji,
   {{0xf1d0e081,0x63bbc669,0xc4bda077,0x2ecb08a2}},	// [4a0] _mạnh_, idun, ्मुख, ामृत,
   {{0x2bd2e55d,0x442168a3,0x660560c7,0x1f66219d}},	//   ताया, goh_, gihk, _яком,
   {{0x68e448a4,0xdcf4829f,0x973ce29f,0x7bdc6069}},	//   syid, đači, teći, _voru,
   {{0x6d5980bb,0x7c2aa1cd,0x69dd48a5,0xd36f8049}},	//   gcwa, wlfr, _gose, مهم_,
   {{0x63a408a6,0x660568a7,0x973ce0e4,0xbcfb41e9}},	//   _mbin, bihk, reći, _aféf,
   {{0x660608a8,0xb05b467c,0x248688a9,0xdb1aa057}},	//   hikk, _krän, rrom_, _intú,
   {{0x644988aa,0x67224041,0x22442066,0xe4da60e0}},	//   _fiei, ļoju, ímky_, _عورت_,
   {{0x3266c8ab,0x6448a8ac,0x69dd48ad,0x63a40291}},	//   нтов, _widi, _xose, _nbin,
   {{0xa3d0a8ae,0x69cbc037,0xbc6a8050,0x26c048af}},	//   षाद_, _dnge, _رمان_, nvio_,
   {{0x9f4ce8b0,0xa2c0a8b1,0x2d800031,0x6e21e8b2}},	//   vidó_, विद्, _adie_, golb,
   {{0x63ae2026,0xf1b9c8b3,0x7dd840e0,0x2129043d}},	//   debn, soša_, _dísz, _syah_,
   {{0x660608b4,0x2298e8b5,0xad9b0049,0x3c32002e}},	//   gikk, rék_, ciúl, táva_,
   {{0x3205e05c,0x629bc8b6,0x7bdd44b4,0x629c21e2}},	//   bily_, ctuo, _rosu, etro,
   {{0x63a4000d,0x442b00d5,0x6d4e68b7,0xdb01e057}},	//   _ebin, slc_, _ngba, selá,
   {{0xdb1aa071,0xf1c5c026,0x386d200a,0x68306156}},	//   _antú, वाचन, ćero_, tädn,
   {{0x69de205d,0x6d4d0054,0xf77348b8,0x99cf407c}},	//   _eope, _ugaa, طار_, রস্ক,
   {{0x7c2288b9,0x69de21e2,0xbbe140a8,0x2cb241cd}},	// [4b0] door, _fope, _नवीक, gwyd_,
   {{0x64498057,0x69de2119,0xfd50e125,0x6fb868ba}},	//   _siei, _gope, _rudị, нгур_,
   {{0x628f08bb,0x629c28bc,0xb4e984e5,0x7bdd48bd}},	//   luco, ctro, मन्_, _tosu,
   {{0x987a2087,0x63af0066,0x27e9405d,0x6b6740fa}},	//   _קארט, necn, qkan_, _dégâ,
   {{0x44386133,0x69c168be,0xe8dfa067,0x7bdf08bf}},	//   _fhr_, _óleo, _phỏm_, _moqu,
   {{0xeb9f44a4,0xdee288c0,0x2005e03c,0xe5a5a45c}},	//   _gjør_, роши, xili_, тики,
   {{0x25a48143,0x80bda029,0x69cbc07d,0xad9b0049}},	//   _fbml_, ्में, _pnge, tiúl,
   {{0x644ae8c1,0x248dc8c2,0x63a4a098,0x442ce8c3}},	//   _aifi, tuem_, đina, eld_,
   {{0x25adc110,0x75e060e0,0xdcee6026,0x6606059f}},	//   reel_, _közp, _odbě, vikk,
   {{0x2292c4b7,0x629bc03b,0xe9df413a,0x6577600e}},	//   گلیس, rtuo, _siúl_, naxh,
   {{0x3ea908c4,0x442328c5,0x35c688c6,0x63b9c227}},	//   _apat_, doj_, _रोड़, _tawn,
   {{0x69de28c7,0x1ad8807c,0x63a52090,0x224b48c8}},	//   _sope, _দেয়া, _abhn, _nick_,
   {{0x9f4f807b,0xe3aee7e9,0x63baa037,0x644bc1e7}},	//   ligó_, _кб_, _yatn, _iigi,
   {{0x6e2d48c9,0x6825c019,0x7c2d48ca,0x6d5d48cb}},	//   elab, códr, elar, _afsa,
   {{0x63ae203a,0x7a13c12a,0x683888cc,0xed572331}},	//   rebn, năto, líde, тос_,
   {{0xb7bc8405,0x60c408cd,0x644bc8ce,0x6d5bc8cf}},	//   _অক্ট, _trim, _jigi, ncua,
   {{0xe3ba607a,0x7a3888d0,0x1d074501,0x248948d1}},	// [4c0] мба_, níte, вети_, gram_,
   {{0xf1d26029,0xa25b48d2,0x64c5600a,0x6e2d48d3}},	//   साधन, _trôn, kčić, alab,
   {{0x3ddf8200,0xf98648d4,0x443a205d,0x248941ae}},	//   _bouw_, _игно, _ihp_, aram_,
   {{0x644bc5f1,0x186768d5,0xa3c8e8d6,0x7aeb4009}},	//   _nigi, таци_, _लोन_, ölté,
   {{0x442ce8d7,0xf9930095,0x6d5c2090,0x26c5a108}},	//   yld_, שרד_, ocra, _arlo_,
   {{0x27e00004,0x6289c6bf,0x2fcd8037,0x644bc8d8}},	//   _loin_, dreo, _eneg_, _aigi,
   {{0xe7a42437,0x764bc8d9,0x7bce68da,0x4426c8db}},	//   ख्यप, _bigy, _inbu, _pko_,
   {{0x201248dc,0xe4e3a0ff,0x0b8ac762,0xd848e8dd}},	//   nnyi_, рішн, фски_, _lọt_,
   {{0x7a3880e0,0x644ae2a8,0xfbd6004a,0x317820c2}},	//   gíte, _pifi, धानम, karz_,
   {{0x443fc8de,0xee37a8df,0x27e007ad,0x09d0e1a6}},	//   amu_, _ану_, _aoin_, িস্থ,
   {{0x442ce8e0,0xd5afc8e1,0xd00fa50f,0x61e088e2}},	//   rld_, _кс_, _ظلم_, _koml,
   {{0x6289c8e3,0x6a86c8e4,0xb4fba00b,0x3ea90037}},	//   breo, _алда, _קלאר, _ppat_,
   {{0xea00e067,0x7c2d48e5,0x68388057,0xd848e8e6}},	//   _chảy_, vlar, cíde, _bọt_,
   {{0x27e00256,0xfbdf4016,0x2458a016,0xe918e71b}},	//   _eoin_, _viêm_, _kém_, _полі_,
   {{0x2d5828e7,0x7c24413a,0x624968e8,0x973ce0a9}},	//   тись_, foir, _džol, teću,
   {{0xf8b6c0e3,0x61f641cd,0x996448e9,0x69cd0167}},	//   _अनाय, ghyl, итул, _unae,
   {{0x195921ba,0x3ea90426,0x98bee6fa,0x3869a29c}},	// [4d0] _папы_, _upat_, matı_, ćari_,
   {{0x35b528ea,0x44276067,0xa3d5e260,0x98bee315}},	//   _сбор, ôn_, हाय_, latı_,
   {{0x7c2448eb,0x68e8e0e2,0x443fc8ec,0x63a288ed}},	//   boir, nydd, ymu_, ffon,
   {{0xfd1f4031,0x69ce68ee,0x98bee315,0x2007a0bb}},	//   _adìe_, _enbe, natı_, wini_,
   {{0x2ba50437,0xc178e013,0x3b8488ef,0x1da50861}},	//   ग्या, nkės_, рліг, ग्यत,
   {{0xdb06404a,0x1a684050,0x442dc8f0,0x9f4002d9}},	//   _jaký, _شیمی_, wle_, _cliù_,
   {{0x3a2908f1,0x31790367,0xa3cfc8f2,0x58d468f3}},	//   _okap_, kasz_, शाल_, _корт,
   {{0x64c5623d,0x442ea110,0x85048010,0xa3d70028}},	//   rčić, alf_, _शेवट_, साफ_,
   {{0x4a5488f4,0x0a49e4a7,0x75f5c026,0x6575607d}},	//   _вкус, нзий_, _náze, _kezh,
   {{0x644bc8f5,0x27e008f6,0x6b82c8f7,0x200948f8}},	//   _wigi, _soin_, _edog, hiai_,
   {{0x2009403b,0x7a3888f9,0xa91d850e,0x7c3b88fa}},	//   kiai_, síte, _udžb, _khur,
   {{0x394fc62c,0x752d0284,0x28c782ca,0x7bdae3ac}},	//   _uggs_, _byaz, लिपि, ajtu,
   {{0x645568fb,0x2d83616d,0x7c3b88fc,0x35a5e056}},	//   _luzi, _odje_, _mhur, _балг,
   {{0xec35a053,0x65756530,0xab5d82a4,0xd378e8fd}},	//   טאָר_, _nezh, _inżu, cać_,
   {{0x539ae095,0x201908fe,0x7c3b8291,0x9324e0eb}},	//   _ניקו, éric_, _ohur, _پرون,
   {{0x4425e8ff,0x63bc610a,0xdb01e277,0x9c138125}},	//   lol_, _sarn, relä, _sọnl,
   {{0x25f7e7d9,0x7a360057,0x8f75471b,0xdb0e20c4}},	// [4e0] एसपी_, cáta, русі, ndbú,
   {{0x61ed4900,0x7c298901,0x27edc037,0xb14347ab}},	//   akal, _aker, hken_, снул,
   {{0x179b200b,0x66e62850,0x6455601f,0x61e0849f}},	//   _אייב, _сона, _cuzi, _poml,
   {{0x249fc902,0x63bc6903,0xe3b2433e,0x7c3b8904}},	//   ktum_, _warn, _ارد_, _chur,
   {{0xead48905,0x91e6a54a,0x5c06a12e,0x42d54013}},	//   роль, лоде, ляка, _кіру,
   {{0x2fc04906,0x61ee21e2,0xdcbaa1e1,0x2fcfc907}},	//   ldig_, nkbl, ещи_, _angg_,
   {{0x61e08908,0x6609c23c,0x645dc0c4,0x224d805d}},	//   _toml, fiek, ísin, _fiek_,
   {{0x2bd26909,0x7984090a,0x38668156,0x5d54c62a}},	//   सावा, _ndiw, ppor_, шкит,
   {{0x2ca0490b,0x25d7400b,0xc796a0a4,0xd378e064}},	//   ntid_, רופן_, _مشاب, tać_,
   {{0xad9b013a,0x21f1c066,0x60cdc1e4,0xa96aa13a}},	//   miúi, _váha_, _šamc, _أمام_,
   {{0x752d00c7,0xdb03a90c,0xad9b013a,0xf9936095}},	//   _syaz, venç, liúi, זרת_,
   {{0x4426890d,0x2ca0410a,0x75f84026,0x6441e90e}},	//   noo_, ktid_, _jízd, amli,
   {{0x5187290f,0x6b8400e2,0xad9b0049,0x644d0057}},	//   лува, _ddig, niúi, _viai,
   {{0xf41f6277,0x682da910,0x69c0c911,0x3083c049}},	//   _iväg_, túdi, ldme, _الوف,
   {{0x59b8c0c2,0x3f8760c4,0xad9b0049,0x9f5ee912}},	//   _आसार, ónum_, hiúi, citá_,
   {{0xb4c04913,0xf1d2e914,0x2fc048c4,0x3a2a607d}},	//   ंटू_, तावन, gdig_, _akbp_,
   {{0x557568f4,0xdbd26046,0xa295471b,0x3a268155}},	// [4f0] игат, _füüs, разі, doop_,
   {{0x224d8915,0x9f5120b6,0x6e3c606f,0x27edc916}},	//   _siek_, rizó_, _chrb, zken_,
   {{0x7c3b8090,0x44b561fc,0xdb0f0057,0x41558917}},	//   _phur, рбес, decé, авес,
   {{0x628b883d,0x569540fb,0xce95414a,0xa3ce0918}},	//   trgo, _камт, _камъ, राए_,
   {{0xdb172919,0xed59c00a,0xeb99a91a,0x7a3601ce}},	//   _maxí, jdža_, вил_, kátn,
   {{0x88c5a13a,0x6609c064,0x25bdc1cd,0xac776555}},	//   لتعل, wiek, _sawl_, _مارش,
   {{0x4425e91b,0x7777217a,0x28c5a91c,0x14b0e37f}},	//   vol_, _mexx, विधि, _जनगण,
   {{0x270ea03c,0x644e691d,0xddc9a055,0x6a85c14a}},	//   _dən_, _zibi, _uvež, алиа,
   {{0xde5980ff,0xfa3480eb,0x443ce91e,0x45d5a0ba}},	//   _разі_, _طرفد, _bhv_, _коас,
   {{0x7a120041,0x656d4058,0x78bb8361,0x764f40c2}},	//   māti, hbah, _isuv, _licy,
   {{0x3ea5e423,0x4427a91f,0x7cd9a33e,0x25bf8920}},	//   шинг, mon_, _جواز_, _kaul_,
   {{0xd9460921,0x63be2922,0x3f85a133,0xdb076009}},	//   иени, _sapn, _hdlu_, _hajó,
   {{0x200a2923,0xed4ec924,0xdb03a925,0xdb1c600e}},	//   tibi_, _фо_, senä, _parë,
   {{0x6145e926,0x7e64005c,0xdce3a927,0x64572928}},	//   _кела, _vtip, lanđ, _buxi,
   {{0x6443a929,0x63a9892a,0x4426892b,0x4427a92c}},	//   imni, _oben, yoo_, ion_,
   {{0x656d492d,0x69c1e92e,0x7a360066,0xdb1e20dd}},	//   gbah, ldle, máto, _hapë,
   {{0x61e3e92f,0x7a2b60e0,0x442b4143,0xa206603b}},	// [500] _konl, yütt, _dkc_, апад,
   {{0x307b0095,0x2722a06f,0x657bc1ae,0x645ee930}},	//   _שאינ, nčné_, hauh, _épic,
   {{0x78bb82df,0x60c98931,0x23776050,0xdb1c6396}},	//   _asuv, _arem, شمند_, _karé,
   {{0x705300d0,0x3ead8098,0x8fa68103,0x2d9820d1}},	//   _دنیا, _bpet_, раде, lgre_,
   {{0x660aa820,0x3ead8932,0x649a8933,0xa3d70934}},	//   tifk, _cpet_, ттер_, सात_,
   {{0x657c2935,0x6444404e,0x3ead807d,0x7a3d00e0}},	//   narh, lmii, _dpet_, méte,
   {{0x645bc071,0xb6068361,0xd33560db,0xd00760ba}},	//   equi, _pašć, _гэты, _тере_,
   {{0x6ca6c936,0x66164052,0x443ce937,0x786680ff}},	//   арож, nnyk, _shv_, _вказ,
   {{0x94a98938,0x69c0c14f,0x387fc939,0x2617417a}},	//   _مطلق_, rdme, gsur_, dħol_,
   {{0x53e6e0ba,0xdb156009,0x245bc18b,0x2258693a}},	//   рциа, _hazá, _dêm_, _kurk_,
   {{0x3fc8e0d0,0x869aa93b,0xec376095,0x7a36093c}},	//   ندگی_, _штат_, שאיר_, gáto,
   {{0xa3d2610a,0x69c2893d,0x2480493e,0x69c0893f}},	//   वाँ_, ndoe, ksim_, _jame,
   {{0x644f4940,0x98b80866,0x61e40941,0xdb1c6057}},	//   _rici, алят_, _doil, _daré,
   {{0x683d0005,0x68360942,0x6282c943,0x6280c944}},	//   déde, ládl, _ivoo, msmo,
   {{0x7c28e945,0x02b6c893,0x6e272946,0x245c20e0}},	//   modr, _अनुन, rojb, _cím_,
   {{0x78a28089,0x80ad8405,0x69c08947,0xdb18e0e0}},	//   ktov, চিত্, _name, _javí,
   {{0x67ea4069,0xdb238315,0xa3b6a0c2,0x6284803b}},	// [510] _nýju, ürül, ज़ा_, šioj,
   {{0xf3676948,0xb8ff4026,0xeb936949,0x44446194}},	//   ртан, _थप_, تظر_, gm_,
   {{0xa3d0a10a,0x752f40c2,0x25bf894a,0xe94540eb}},	//   षाई_, _wycz, _paul_, _گردی,
   {{0x3869494b,0x69c0894c,0x2d99094d,0x66eae03c}},	//   ppar_, _came, ngse_, məkd,
   {{0x7a3d01af,0xfd108678,0x660d494e,0xf1bf0009}},	//   céte, وجه_, miak, llás_,
   {{0xa01b2262,0x289a0053,0x61e52227,0x6812094f}},	//   mrös, ריװא, _johl, rādi,
   {{0x3866c01f,0x6e2d080c,0x6443a950,0x62952098}},	//   _ator_, _okab, rmni, nuzo,
   {{0x81c3e07c,0xc9182694,0xef1fe106,0x2d982199}},	//   _একই_, יחות_, şük_, zgre_,
   {{0xf1d2e010,0x61e3e951,0x63b520e0,0x316dc071}},	//   तांन, _ponl, kezn, rbez_,
   {{0xdb08a057,0x200ce952,0x64456420,0xdb1c6050}},	//   _cadó, gidi_, nmhi, _saré,
   {{0x7a158064,0x7bc1e046,0x660d4953,0xdb056954}},	//   jątk, rdlu, kiak, behå,
   {{0xc692649c,0xf3e92694,0x186a0955,0xa159c956}},	//   האט_, _אף_, лами_, _саду_,
   {{0x290be064,0x7a30604e,0x6458e005,0x7056013a}},	//   ńca_, säti, _euvi, إنسا,
   {{0xd999e0d0,0xe36326c0,0xdb0f4005,0x2007e098}},	//   _صنعت_, зкри, _facú, _umni_,
   {{0xa3a9a578,0xe695e13a,0x660980e4,0x6295200a}},	//   ग्य_, _العد, _omek, guzo,
   {{0x443f8016,0x7ddda5cd,0x51f6010c,0xf662c088}},	//   _nhu_, _vèsy, _دستر, _họọr,
   {{0xf662c125,0xe7e94028,0x5baa603b,0x81ccc07c}},	// [520] _kọọr, _टकरा_, лкам_, _রকম_,
   {{0xab8c8121,0x200e0064,0xa7fcc20f,0x9947412a}},	//   _çözü, ślić_, _atıl, спуб_,
   {{0x44446957,0xcf572095,0x6459c958,0x74adc07c}},	//   rm_, _לבית_, _luwi, কটিউ,
   {{0x26ca6959,0x7bc1a1e7,0x2aa080d1,0x78a2895a}},	//   _vrbo_, _aalu, tòb_, ttov,
   {{0x661b85f9,0xd378a23d,0x63b64025,0x6838804a}},	//   _djuk, _peć_, meyn, bídn,
   {{0x3ea0c04e,0xe2a700c4,0x92df207c,0x7bc0895b}},	//   _äiti_, óðir_, _দেয়_, _wamu,
   {{0x7bc1a95c,0x657e6174,0xf1b32095,0x60cbc090}},	//   _dalu, maph, פסה_, _argm,
   {{0x67f5c333,0x7bc08296,0x5f94c67b,0x9f4240d1}},	//   _pája, _uamu, циит, _pokè_,
   {{0x4062c95d,0x7bc1a95e,0x443ea007,0x657d095f}},	//   _bọọl, _falu, _tht_, vash,
   {{0xf2e78050,0x6c36a062,0x28c94960,0x65640961}},	//   _دکمه_, _افطا, रिति, _afih,
   {{0x78a442df,0xdd910085,0x442a2962,0x6ca3e052}},	//   htiv, وود_, dob_, пряж,
   {{0x68ed435f,0x7c2aa2a8,0x62964963,0xdb0f403e}},	//   yyad, lofr, kuyo, _vacú,
   {{0x200ce964,0x69c1a965,0x200a6167,0x6e28e06e}},	//   pidi_, _yale, _ombi_, podb,
   {{0xdb1aa966,0x67d4e967,0x4062c088,0x69c44018}},	//   _latí, _фоку, _gọọl, edie,
   {{0x7bc2c968,0xa3d26969,0x657d096a,0xb4d1496b}},	//   _kaou, वाई_, pash, वम्_,
   {{0x69c4496c,0xdb0b803e,0xdb0f0919,0x7bcb6018}},	//   gdie, hegá, lecí, ēgum,
   {{0x44c86315,0x1a5b413a,0x61e5204a,0x7988a0ae}},	// [530] _ağ_, اشرة_, _tohl, _oddw,
   {{0x442b096d,0xf1b9c96e,0xa3b0296f,0x6009603c}},	//   loc_, roši_, _टॉप_, _kömə,
   {{0x2bbdc04a,0x6aa4407d,0xfc3f4016,0x645aa970}},	//   ्यमा, atif, _thí_, _nuti,
   {{0xe7f5604b,0x43748971,0xdb0f01de,0x38a1a972}},	//   _इतका_, пушт, mecâ, vór_,
   {{0x201c801f,0xe70b8050,0x3f8900ce,0x6286c013}},	//   évia_, دتان_, _mdau_, škoj,
   {{0x237d8022,0x657aa0eb,0x2ba6c0ec,0xf771a049}},	//   sawj_, _ceth, क्सा, ذات_,
   {{0x91bfa125,0x6142a3d8,0x16d1c064,0x4429c016}},	//   _atụ_, меша, तम्ब, _ưa_,
   {{0x7aea6097,0x60cd0973,0x291f805f,0x4fe9c974}},	//   äfte, _oram, _txua_, рмин_,
   {{0x200dc975,0x2bcf87f1,0x2bdd011a,0x2a690048}},	//   riei_, _सोया, याना, _ntab_,
   {{0x69c4406f,0xc9a6e04e,0x5285e976,0x2cbf80ae}},	//   zdie, овье_, огоб, _isud_,
   {{0x3ebea05d,0xe9ff8067,0x38cac050,0x442b0017}},	//   _gstt_, _nhẫn_, هایی_, foc_,
   {{0xddcd6098,0x81bce041,0x1b4a0977,0x69dce156}},	//   jsaž, slēp, изни_, örer,
   {{0x657aa174,0xddc2a018,0x6459c1e7,0x645aa978}},	//   _yeth, lpoš, _uuwi, _zuti,
   {{0xf3f14067,0x2a6dc022,0xae024077,0xd7f14119}},	//   ện_, mpeb_, रोईन_, ễn_,
   {{0xd347e050,0x7a360089,0xb147e0eb,0x271583c3}},	//   _دیده_, nátk, _دیدم_, तपुर_,
   {{0x6b9bc979,0x25ad238a,0x7a30697a,0x6aa4497b}},	//   ngug, đela_, hätt, ttif,
   {{0x7bd60132,0xc7b2c1a9,0x6d4ee23d,0x2a690037}},	// [540] _inyu, ובן_, žbat, _gtab_,
   {{0x61e76143,0x602620ff,0x63b6403c,0xdb18e97c}},	//   _cojl, _єдна, seyn, _havá,
   {{0xf74621bc,0x78ad204a,0x569360ff,0xa01b2156}},	//   _фено, čová, даєт, prör,
   {{0x5fdd0010,0x6296497d,0x200f897e,0x67f842a8}},	//   यायल, puyo, gigi_, _fíja,
   {{0x254ee03c,0x657aa360,0x6013417a,0x6366e04a}},	//   zəl_, _peth, għmu, nční,
   {{0x200a697f,0x79898980,0x69c40981,0xa3b02029}},	//   _umbi_, _edew, _laie, _टॉम_,
   {{0x59ca0982,0x200ea983,0x2bdd0984,0xdb1c2017}},	//   ियार, rifi_, यामा, ndrà,
   {{0x442fc05d,0x63a9c1cd,0x62844013,0x660f0066}},	//   _ckg_, gfen, osio, xick,
   {{0x59a6c437,0xfba6c11a,0x75fcc0e0,0x26cd80ae}},	//   क्षर, क्षम, _néze, _greo_,
   {{0x660f0985,0xc3334095,0x80bb207c,0x27f8e069}},	//   wick, ווח_, _উপস্, órn_,
   {{0x442b0986,0x96c28029,0x657c6121,0x41de2026}},	//   toc_, लिकॉ, _merh, मानस,
   {{0xc5f420e8,0x69c40987,0x69c3e194,0x320b0926}},	//   _ruɓa_, _caie, _eane, рхон_,
   {{0x7a13c12a,0x38cbc043,0x63a0817b,0x61e8a988}},	//   gătu, _پانی_, _mcmn, _kodl,
   {{0xc6938989,0xdb152009,0x628e8018,0x3ea68018}},	//   ואש_, lezé, _ābol, itot_,
   {{0xf77f05df,0x6286468f,0xadeec98a,0x61e8a7ac}},	//   paç_, _avko, _जवान_, _modl,
   {{0x69c40108,0x2c60c0d1,0x6d586013,0xf54f4125}},	//   _gaie, _kòd_, žval, _rụba_,
   {{0x60cd098b,0x8ccdc064,0x7bc3e6d2,0x78b3e0e4}},	// [550] _uram, तियो, _yanu, čevš,
   {{0xf770625b,0xdb18e066,0xdb17203c,0x6281204a}},	//   نام_, _zavá, _naxç, álos,
   {{0xf402a07c,0x35b5898c,0x61e12069,0xdb18a241}},	//   ৎকার_, збер, öllu, ndvä,
   {{0x2bb7e870,0x799d0812,0xaca34125,0x6aa561cd}},	//   _अस्थ, ngsw, _ahục, rthf,
   {{0x645c698d,0xa969a080,0x3e60c0d1,0x61e8a0fd}},	//   _euri, била_, _nòt_, _bodl,
   {{0x645d40ae,0x2366c012,0x7bc72009,0x29076049}},	//   _iusi, _afoj_, ndju, únas_,
   {{0x6e95a13a,0x38a400e0,0x442ce98e,0x765c6054}},	//   ألعا, zör_, dod_, _gury,
   {{0x2249498f,0x7c2d4265,0x251c200b,0x26cd8990}},	//   nmak_, noar, יווא, _treo_,
   {{0x61fb8991,0x2011246d,0x7e698992,0x7642c18c}},	//   _ilul, kizi_, _utep, _dhoy,
   {{0xaf05e1e1,0xa91dc993,0x69c52994,0x60c9c995}},	//   зпол, jaže, _nahe, rvem,
   {{0x61e98996,0x2fc48058,0x20112997,0x22494106}},	//   _koel, _yamg_, dizi_, kmak_,
   {{0x442fc998,0xfe70a0eb,0x7a322999,0x7bc3e99a}},	//   _ukg_, _شدم_, hætt, _wanu,
   {{0x7a36099b,0x455ac1a9,0x2011299c,0x6d59c99d}},	//   náti, _הכנס, fizi_, _igwa,
   {{0x9f47e00e,0xf1b9c99e,0xcb6721fc,0x644fe017}},	//   _jonë_, leš_, заре_, ïcid,
   {{0xdb1c699f,0x69c409a0,0x2d8040ba,0x63af458f}},	//   _parí, _taie, taie_, _bbcn,
   {{0xa5bb49a1,0xe1ff09a2,0x6b81e0f9,0x7649c121}},	//   _skór, chó_, lalg, nmey,
   {{0xd347e050,0xd5af413a,0xdb9b0008,0x69c721e4}},	// [560] _دیگه_, طفل_, _הספר, bdje,
   {{0x6146203b,0xb21b2069,0xdcfc29a3,0x7980c9a4}},	//   _непа, nsæl, larč, zamw,
   {{0xe7bdc180,0x628609a5,0x6456011d,0x2ec6613a}},	//   ्याप, lsko, _kiyi, ثقاف,
   {{0x443160ca,0x628449a6,0x7981e9a7,0x28c949a8}},	//   _ekz_, psio, halw, रिशि,
   {{0x645c6605,0x60c1a058,0x3e61e067,0x645609a9}},	//   _wuri, _aslm, _lót_, _miyi,
   {{0x3ea689aa,0x765c6064,0x6736004e,0x6f0289ab}},	//   rtot_, _tury, _myyj, rzoc,
   {{0xb05b49ac,0xdb1aa9ad,0x63b8a026,0x7980c9ae}},	//   _fräs, _batá, revn, tamw,
   {{0xb05b4277,0xfaa68498,0x3e60c163,0xdca689af}},	//   _gräs, _набо, _pòt_, _наби,
   {{0x2d8209b0,0x6142a1e9,0xdb1c61de,0xa967c01b}},	//   dake_, _bílí, _farã, чиња_,
   {{0xf1aaa050,0xe9df4016,0xa2f4e0ff,0x2ef4e9b1}},	//   _داره_, _khúc_, дпоч, дзор,
   {{0x765600e8,0xf1b9c9b2,0x644882f3,0xa91dc0a9}},	//   _biyy, beš_, _èdis, važe,
   {{0xf1b9c261,0xaadba095,0x76440030,0x442ea9b3}},	//   ceš_, _לחבר, _chiy, lof_,
   {{0x2d8169b4,0x69c529b5,0x6abd0171,0x26cfc012}},	//   yahe_, _pahe, uwsf, _grgo_,
   {{0x171bc095,0x9980403b,0xf1dac9b6,0x442ce9b7}},	//   _פוגע, klių_, भावन, qod_,
   {{0x201129b8,0x28f8204e,0xd90f2050,0x7bd8e9b9}},	//   rizi_, перь_, ایج_, _invu,
   {{0x660d09ba,0xbbb9a0e3,0x442ea9bb,0x7bc529bc}},	//   _umak, _इस्क, hof_, _wahu,
   {{0xd378a50e,0x224949bd,0x7c2e29be,0x2d9ee110}},	// [570] _hoću_, rmak_, bobr, ogte_,
   {{0x61eae00a,0x7bc6417b,0x7e6d09bf,0x26c12286}},	//   _jofl, _eaku, _itap, _tsho_,
   {{0x6d4089c0,0xdb1c6355,0x22494121,0xa7fb69c1}},	//   _azma, _carà, pmak_, _nuñe,
   {{0x63bae0e0,0x7bc649c2,0x09aaa07c,0x7aea6156}},	//   hetn, _gaku, _গোলা, äfta,
   {{0x25e0c9c3,0x64556024,0xdb1ae277,0xf3f3613a}},	//   कानी_, _tizi, ldtä, _كأس_,
   {{0x2fc949c4,0x645f09c5,0x614720fa,0xfe7020eb}},	//   ldag_, _muqi, célé, _جدی_,
   {{0x60c2c9c6,0x628729c7,0x9f47e00e,0x2d8209c8}},	//   _asom, nsjo, _vonë_, yake_,
   {{0xb4e96604,0xdcf8e143,0x628609c9,0x798d00bb}},	//   यही_, _cevč, ysko, _ndaw,
   {{0xf1b9c42e,0x60c2c0e0,0x7bc769ca,0x9f5a64cd}},	//   reš_, _csom, _kaju, cipó_,
   {{0xdb1c69cb,0x386d89cc,0xdb0e6057,0x7963c1e9}},	//   _hará, _iter_, _gabó, _bíwó,
   {{0x2eac28c6,0x7c2e2552,0x6b81e9cd,0xea004016}},	//   _चहेत, vobr, ralg, _loạt_,
   {{0xe7d8407c,0x2ef5c955,0x6b81e9ce,0x443909cf}},	//   _সত্য, _озер, salg, gls_,
   {{0x522ac49c,0x6457224f,0xddcd0064,0xfc3f2183}},	//   _ווײַ, _bixi, _biał, rtín_,
   {{0xfc3f29d0,0x69c9c684,0x44212037,0x63bbc9d1}},	//   stín_, ldee, _cjh_, leun,
   {{0x2fc7e0ae,0x2d8d8088,0xdca32826,0xa0a329d2}},	//   _iang_, _odee_, кари, кард,
   {{0x24442277,0xc8c94029,0x6f044200,0x61ebc9d3}},	//   döme_, रिंट, tzic, _jogl,
   {{0x4444242c,0xdb03a05c,0xf412c095,0x69c649d4}},	// [580] _th_, vený, דפן_, _vake,
   {{0x69c649d5,0x61f649d6,0x98b06381,0x683889d7}},	//   _wake, skyl, žači_, mídi,
   {{0x63bc29d8,0x9980403b,0xdb03a9d9,0x386d80eb}},	//   mern, ulių_, genü, _ater_,
   {{0x629c29da,0x78a9c0dd,0x3f8760c4,0x225f80ae}},	//   muro, ktev, ónur_, _buuk_,
   {{0x645729db,0x69c9c9dc,0xdbc6a10a,0x6aa9c00a}},	//   _yixi, ddee, _mööb, jtef,
   {{0x64572939,0xe9df4016,0x6d5b89dd,0x0a6aa7f8}},	//   _xixi, _thúc_, _egua, ории_,
   {{0x3a22400a,0x661d006f,0xe81fa9de,0xa3df204b}},	//   _kjkp_, ynsk, _बदरा_, णात_,
   {{0x63bae037,0x69d5c37f,0x828ac052,0xef18a018}},	//   wetn, भागी, особ_, _ceļa_,
   {{0x80c449df,0x2fc7e9e0,0x629c29e1,0x78a9c9e2}},	//   रिटे, _bang_, huro, gtev,
   {{0x69c9c054,0x4422407d,0x68388057,0x3e644262}},	//   adee, _ljk_, dídi, _möt_,
   {{0x2fc7e9e3,0xa3bda9e4,0x645729e5,0xbcfb00fa}},	//   _dang_, ेयर_, _rixi, rcém,
   {{0x83fcc0e4,0x998940c2,0x63bae31b,0x2d8329e6}},	//   _buđe, ział_, setn, waje_,
   {{0x6b808058,0xaac78295,0xd5a50029,0x60c2c9e7}},	//   _memg, लिएक, ग्गज, _usom,
   {{0x442240c7,0x442f89e8,0x69caa9e9,0xdb03a057}},	//   _ajk_, zog_, ndfe, cenó,
   {{0x395ce005,0x6b844049,0x533429ea,0x660280bb}},	//   _igvs_, faig, верт, khok,
   {{0x628720ff,0xa008013a,0x7bc769eb,0xdcc8c067}},	//   rsjo, _يقول_, _saju, _kỉ_,
   {{0xe9df4016,0x660289ec,0xdb1d42a8,0x7e6d09ed}},	// [590] _chúa_, dhok, _basá, _utap,
   {{0x2fc949ee,0x3f84c9ef,0xcec8c016,0xeddbc37f}},	//   sdag_, hamu_, _mộ_, _मच्छ,
   {{0xcec8c081,0x2d84c9f0,0xed59c2f9,0x6288e9f1}},	//   _lộ_, kame_, leže_, nsdo,
   {{0x6d5c69f2,0xceb2200b,0xa91d89f3,0x63bd0013}},	//   _egra, _גיט_, _leže, nesn,
   {{0x2fc909f4,0x69c769f5,0x6d41a0c2,0xef1981f6}},	//   _maag_, _taje, _szla, _beża_,
   {{0x6cd280e0,0xf745a07a,0xd945a14a,0xb05b09f6}},	//   اقوا, нело, нели, lväs,
   {{0x442f83a1,0x7bc8a9f7,0x6fa50010,0x644d49f8}},	//   pog_, _dadu, _काढू, omai,
   {{0x69c8a090,0x78a9c9f9,0x6b85612b,0x660289fa}},	//   _eade, ttev, lahg, chok,
   {{0xf8c8c081,0x63bc29fb,0xddc98041,0x443129fc}},	//   _cứ_, yern, _pieņ, koz_,
   {{0x89a9e9fd,0x644d4049,0x2d812079,0x60006009}},	//   чков_, hmai, _nehe_, _töme,
   {{0x66152265,0x7c22c488,0x26d1e9fe,0x2fc7e9ff}},	//   dizk, _fjor, ízo_, _vang_,
   {{0x60c400e4,0x201eea00,0x63bd0a01,0x63bc2a02}},	//   _psim, anti_, gesn, wern,
   {{0x24894022,0xed350099,0xbddb4061,0x61ed0a03}},	//   jsam_, вэрэ, _chèm, _doal,
   {{0x6b81a041,0x44312a04,0x20020a05,0x11d9e049}},	//   _jelg, goz_, shki_, _روعة_,
   {{0xc5f2a00b,0x6459c236,0x27ff83df,0x44224058}},	//   נדל_, _kiwi, _olun_, _pjk_,
   {{0x7bc9807d,0x2bcf8010,0x63bd0a06,0x629c2a07}},	//   _naeu, _सोला, cesn, ruro,
   {{0xa3cb2a08,0xdb172057,0x6b85617b,0x224dc06e}},	// [5a0] _रोक_, _xaxú, fahg, imek_,
   {{0x2d812669,0x59d1c10a,0xfd47065d,0x6289c273}},	//   _gehe_, _दोसर, _язык_, iseo,
   {{0x8f9b200b,0x248945c8,0x9f45a066,0x69cb82be}},	//   _ציטי, asam_, _bolí_, fdge,
   {{0x7bcf801f,0xa9268a09,0x7a360912,0xb05b0262}},	//   _ócul, ндел, pátu, mvär,
   {{0xb05b0241,0x7985600f,0xc95540db,0x248941cd}},	//   lvär, bahw, _атры, csam_,
   {{0x3f84ca0a,0x09e3a04f,0x63bd0a0b,0x22594066}},	//   wamu_, лочн, zesn, _zisk_,
   {{0x8cd3220b,0x9d436a0c,0xeac8c016,0xa3ea87ca}},	//   डियो, _берд, _sỹ_, _едва_,
   {{0x629e6a0d,0xb4b0a10a,0xb14880e0,0xcb0ac14a}},	//   mupo, _ओही_, _قیام_, зход_,
   {{0x3a26aa0e,0x6d43ea0f,0x2d85e042,0x7659c0e2}},	//   _змаг, _azna, fale_, _diwy,
   {{0xaca44291,0x63a28a10,0x7c240296,0xeac9e2f4}},	//   _ahịr, lgon, _ajir, _bẹ_,
   {{0x2bdd0a11,0x98b3638a,0x7c3bca12,0x69ddaa11}},	//   याला, čeće_, blur, पारी,
   {{0x6288ea13,0xdcc8c016,0xb05b0156,0x628aa271}},	//   rsdo, _tỉ_, dvär, msfo,
   {{0x7bdc6110,0x6f06e0fa,0xddc420a9,0xe61f01ae}},	//   _onru, _bébé, _stiš, rnô_,
   {{0xb5fdaa14,0x9f5dc0ca,0xdb1ae0fa,0x2fc903c5}},	//   _tuše, _alwè_, heté, _waag_,
   {{0xe9df4049,0x7f4401fb,0x5fce60aa,0x399ac19f}},	//   _dhún_, _eziq, _होइल, cüsü_,
   {{0xd7cf8a15,0x765aaa16,0x61ee6090,0xbedb20f9}},	//   _सोंच, _lity, _aobl, _aṣòw,
   {{0x7bcaea17,0x442361f3,0x4c944a18,0x2d824a19}},	// [5b0] _kafu, _pjj_, литс, _deke_,
   {{0x764d4a1a,0x24894a1b,0x64584425,0x628aaa1c}},	//   smay, rsam_, _èvin, ksfo,
   {{0x25de22b4,0x3f824143,0x23694098,0xfbdfa119}},	//   खारी_, _feku_, pcaj_, _đê_,
   {{0xe719813a,0x645aaa1d,0x628aa78c,0x6d452a1e}},	//   ويات_, _aiti, dsfo, _izha,
   {{0x7bdd4a1f,0x765aaa20,0x69a1e010,0x27e94a21}},	//   _insu, _bity, _खाली, mjan_,
   {{0x61ee6a22,0x6448a153,0x6aad40ce,0x527420eb}},	//   _gobl, _chdi, mtaf, _جایز,
   {{0x9f4de3df,0x224dc121,0x63a32069,0x628aaa23}},	//   ünün_, tmek_, _önnu, gsfo,
   {{0xe8d90031,0xb606c09f,0x7e61aa24,0x660dc06f}},	//   _agọ_, ješć, _vulp, ďako,
   {{0x3f836a25,0x27e94a26,0xa3e50148,0x9f5ca024}},	//   _keju_, ijan_, नान_, rivò_,
   {{0x5b1484c9,0x765aaa27,0xc1cb2010,0x7bdd40ae}},	//   _смут, _gity, ायोग, _lnsu,
   {{0xcd2bca28,0x7bcaea29,0xd5dd0046,0xfdf58a2a}},	//   _کسان_, _dafu, यांज, _आवास_,
   {{0x3f85e046,0xc332a087,0x1515ca2b,0x24442156}},	//   salu_, _דוב_, _идея, döma_,
   {{0x628b8a2c,0x7bcaea2d,0x6b86017b,0xf652800b}},	//   nsgo, _fafu, rakg, יצט_,
   {{0x2d87a8ef,0x7bdd4a2e,0xe787e251,0x7d09c00a}},	//   nane_, _ansu, _чудо, mzes,
   {{0x2aabca2f,0x15f4aa30,0x764e200e,0xa3e2a04b}},	//   løb_, _अवसर_, rmby, धात_,
   {{0x6e240a31,0x3f87aa32,0x61ee6a33,0x66044037}},	//   _ujib, hanu_, _sobl, uhik,
   {{0xb05b2277,0x25b2c121,0xe45a6a34,0x9f5ee4cd}},	// [5c0] rvär, _öyle_, джа_, citó_,
   {{0xb05b2a35,0x6b83ea36,0x2d82431d,0x76498054}},	//   svär, _jeng, _weke_, _ahey,
   {{0x38abc042,0x645aaa37,0x61ef413a,0x61e9c0ff}},	//   hør_, _riti, _focl, kjel,
   {{0xe29a8143,0xddc3e0e0,0x645b82d9,0x7e6dea38}},	//   дад_, _minő, _ciui, _čapl,
   {{0x2d87aa39,0x78ad4017,0xc178e03b,0x442200e0}},	//   fane_, ctav, ybė_, ink_,
   {{0x6b83ea3a,0x6d464a3b,0x79840197,0x7bce25c4}},	//   _neng, _izka, _leiw, ndbu,
   {{0x3940c3c0,0xdb1c2639,0x27e0e098,0x60c44a3c}},	//   _šis_, feré, _đin_, lwim,
   {{0x645aaa3d,0x765b80ae,0xddc980c2,0x38abc271}},	//   _witi, _giuy, _mieś, før_,
   {{0x3f98c3df,0x63a44a3e,0x3eadc065,0xb606c490}},	//   ğru_, igin, gtet_, vešć,
   {{0x6ebda029,0x645aa54c,0xa91dca3f,0xaca44096}},	//   _वैकु, _uiti, pažn, _nhọr,
   {{0xa5c6e0f9,0x2fdea03e,0x2cadca40,0x60c44105}},	//   _abóò, _intg_, ated_, hwim,
   {{0xaca44088,0x69de20d1,0x26c6c286,0xdb156066}},	//   _ahọr, _anpe, _tsoo_, _nazý,
   {{0xa3df2a41,0x7d09c064,0x3f848a42,0x645c613a}},	//   णाल_, czes, _memu_, _oiri,
   {{0xe4d4e938,0x6602ca43,0x443361f6,0x645c6a44}},	//   _مقتد, _hlok, xox_, _niri,
   {{0x19954866,0xdb18a1de,0xdb1e206f,0xf1a74936}},	//   лавя, levâ, _napä, кран,
   {{0x60d600dd,0x2d848a45,0x6b83ea46,0x31354a47}},	//   _frym, _neme_, _zeng, гебр,
   {{0x60d60a48,0x7e640a49,0x3869e0a9,0x765c6a4a}},	// [5d0] _grym, _guip, _čari_, _biry,
   {{0x2d87aa4b,0x7bc0ca4c,0x645b8090,0x7c2281cd}},	//   xane_, hemu, _siui, enor,
   {{0x69c0ca4d,0x8934001c,0xfb156553,0xf1aa0982}},	//   keme, _معیا, دواج, _कामन,
   {{0x7bc0ca4e,0x6e352274,0x60d5616d,0x4426ca4f}},	//   jemu, lozb, _vrzm, _njo_,
   {{0x645d48c4,0x588443fc,0x61e9ca50,0x12e44099}},	//   _iisi, _выса, vjel, _кірг,
   {{0x7bcbca51,0xb5fda16d,0x7988e403,0x645d4a52}},	//   _sagu, _buša, jadw, _hisi,
   {{0xa3a9aa53,0xad9b0049,0x61fbca54,0xed59ca55}},	//   ग्ग_, thúl, tkul, deža_,
   {{0x38abc042,0x645c6a56,0x2cadca57,0x7d09c186}},	//   tør_, _ziri, tted_, tzes,
   {{0x644ae13a,0x7a3d0a58,0x645c6a59,0x3f87aa5a}},	//   _bhfi, céti, _yiri, panu_,
   {{0x3fce207c,0x61e9ca5b,0x765d4a5c,0x38abc271}},	//   _রক্ষ, sjel, _lisy, rør_,
   {{0x7a388a5d,0x38720584,0x3ea04a5e,0x7c29406e}},	//   mítr, _styr_, zuit_, čerj,
   {{0x7d1ce049,0x15e4004b,0x7524ca5f,0x6724c066}},	//   úrsa, गाधर_, _žize, _žije,
   {{0x629ae62c,0x3eba2037,0xab5d817a,0xdb01ea60}},	//   arto, _sppt_, _bażi, nflú,
   {{0x3f85a2e2,0xab29ea61,0x6fde2064,0x645d4a62}},	//   _jelu_, _пола_, माइं, _aisi,
   {{0x69ce2a63,0x2fc04a64,0x645c6a65,0x4427e05d}},	//   rdbe, teig_, _riri, _ijn_,
   {{0x443fc181,0x20190a66,0x61fd0a67,0x60d60a68}},	//   nlu_, cisi_, cksl, _trym,
   {{0x44386435,0x645c6a69,0x63a44a6a,0x6e228a6b}},	// [5e0] _pkr_, _piri, rgin, vnob,
   {{0x2d85aa6c,0x443fca6d,0xa50a6a6e,0xd8398030}},	//   _nele_, hlu_, неза_, _akō_,
   {{0x5a16e00b,0x3ea20a6f,0xb7d682f4,0xa8064315}},	//   נקען_, lukt_, _aṣay, tlığ,
   {{0x831b200b,0x78a0c72c,0x5336e00b,0xdc9b23c8}},	//   _טויז, yumv, אנען_, _איטל,
   {{0x2d85aa70,0x443ee5ec,0x81ce007c,0x877b000b}},	//   _bele_, ylt_, রাপ_, גאני,
   {{0xdb01a005,0x645d4a71,0xbe86668c,0x7a306105}},	//   _eclí, _zisi, _مجرو, hätz,
   {{0x20190a72,0x5faa0010,0x295561e1,0x443fca73}},	//   yisi_, _काढल, _вътр, flu_,
   {{0x7c244a74,0x3a3a2037,0xa3ab8046,0x57a6ca75}},	//   nnir, _lkpp_, _खाय_, ушка,
   {{0x3204805d,0xb21b6065,0x2dd7c049,0x60cdc143}},	//   _ilmy_, _ivær, طبية_, _šamr,
   {{0x78a28a2b,0x32b7c13a,0xdcfaa12a,0x2d85aa76}},	//   muov, ادية_, _cetă, _gele_,
   {{0x7988e1cd,0x2d8a2a77,0xaca32079,0xb5fda320}},	//   radw, dabe_, _kwụg, _kušn,
   {{0x443fca78,0x25e0c04b,0x443a2a79,0x69ce6a7a}},	//   clu_, काळी_, _akp_, _labe,
   {{0x60c9805d,0x765e2194,0xdb1ae07b,0x61fd0a7b}},	//   _xsem, _bipy, metí, rksl,
   {{0xd250e28b,0x2fcd050e,0x6440c1ea,0x645e2a7c}},	//   _بنت_, žeg_, llmi, _cipi,
   {{0x628e25ee,0xfc3f2a7d,0x731b20f9,0xafdb022e}},	//   gsbo, ktív_, _bìjẹ, rløb,
   {{0xddc2aa7e,0x6282ca7f,0x645d46a1,0x44f502a3}},	//   jpož, _kwoo, _qisi, _впис,
   {{0xbcfb4a80,0x656d4a81,0xa3c264f6,0x26c904a3}},	// [5f0] _afér, rcah, ्यं_, _usao_,
   {{0x2bdd0a82,0x44290a83,0xd99961b3,0x7a3de5df}},	//   याका, _hja_, ئنات_, tèti,
   {{0x645f0004,0x656f0024,0x9f47ea84,0x765d4a85}},	//   _épis, occh, _koná_, _tisy,
   {{0xe8d7e076,0xdb156019,0x60060071,0x248dca86}},	//   טובר_, _sazó, _tóme, ysem_,
   {{0x66f701b0,0x765f0786,0x61ed4a87,0x443fca88}},	//   ुनिक_, _miqy, mjal, vlu_,
   {{0x683de355,0x32094a89,0x248dc06e,0xa3b0a40a}},	//   pèdi, lhay_, vsem_, ट्ल_,
   {{0xd8390098,0x3dd7207c,0x2aaf403c,0x38af420f}},	//   jučo_, _সকাল, lüb_, lür_,
   {{0x32094a8a,0x67ff000e,0xaca32125,0xa5bb0005}},	//   nhay_, _bëjm, _gwụg, lióf,
   {{0x3f85aa8b,0x60c98a8c,0x628f0064,0xfde6ca8d}},	//   _telu_, _usem, jsco, рдык_,
   {{0x7bcf4a8e,0x66160042,0x27e001d7,0x41a7c029}},	//   _lacu, _smyk, _snin_, _गावस,
   {{0x22404a8f,0x645e2a90,0x764d0a91,0xd5e60a92}},	//   ylik_, _ripi, _bhay, ажни,
   {{0xc106013a,0x22160a93,0x26d94024,0x2c6b8065}},	//   لوجي, рфор, _orso_, _kød_,
   {{0x20094a94,0x27edc00e,0x044622d3,0xef18e018}},	//   dhai_, mjen_, иемн, daļu_,
   {{0x6609c1d7,0x69cf40ae,0x46f5e0ff,0x225f8a95}},	//   lhek, _aace, _вчит, _liuk_,
   {{0xdb0aaa96,0x69cf4a97,0x7afbc5fc,0x78bd4a98}},	//   lefò, _bace, lyut, _apsv,
   {{0x27edca99,0x66040a9a,0xa3d30010,0x2d8b0a9b}},	//   njen_, _ulik, _होऊ_, cace_,
   {{0x443a2a9c,0x0d866a9d,0xa3d169e4,0x18a64a9e}},	// [600] _tkp_, илан, वयं_, разм,
   {{0x6aa3a105,0x7bc3aa9f,0x6e3b8aa0,0x27edc00e}},	//   kunf, jenu, _akub, hjen_,
   {{0x27edc0dd,0x6705eaa1,0x201a6aa2,0xdce8e041}},	//   kjen_, शनिक_, ripi_, vadī,
   {{0x3f87eaa3,0xe8fa8aa4,0xdca64aa5,0x661aeaa6}},	//   _lenu_, кле_, _ками, zitk,
   {{0x661ae07d,0xdb0b8510,0x7c298aa7,0x224d82f8}},	//   yitk, degó, _djer, _dhek_,
   {{0x44382aa8,0x25a681cd,0x25aa60ae,0x69cf4015}},	//   nor_, sgol_, _ucbl_, _zace,
   {{0x6b8b8035,0x082ac8f4,0xa3c80aa9,0x2cb24aaa}},	//   bagg, кции_, ैया_, ltyd_,
   {{0x27edc00e,0xe5a38aab,0x69c44aac,0xa2c360a8}},	//   gjen_, _миси, neie, रबर्,
   {{0x644d0aad,0x65696121,0x6fa7c033,0x3f8b029c}},	//   _rhai, _şehi, _गारं, vacu_,
   {{0x6abe20ff,0x2d8b0068,0x44382aae,0xceb34095}},	//   _oppf, wace_, jor_, קית_,
   {{0x7d0de605,0x2d87eaaf,0x661aeab0,0x3a38223c}},	//   _ƙasa, _dene_, ritk, dorp_,
   {{0xb4c6e295,0x661aeab1,0x7988aab2,0x644d0048}},	//   _उनी_, sitk, _hedw, _qhai,
   {{0x3f87eab3,0x44382488,0xe9470691,0x628f0024}},	//   _fenu_, for_, рхно, usco,
   {{0x3cee8064,0x60db423d,0x2d8b0ab4,0x1866e1e3}},	//   _आपने_, _šumo, sace_, _књиг,
   {{0x6e94eab5,0xdb1c22ee,0xe7fb4010,0x44268ab6}},	//   _البا, berí, _एकदा_, kno_,
   {{0xa3bb04aa,0xdb172005,0x2d87eab7,0x1473e0e0}},	//   _شاعر_, _saxó, _zene_, _باوج,
   {{0x478b6491,0x6b8b8ab8,0x2167626f,0xc953c00b}},	// [610] всем_, vagg, атег, ַמע_,
   {{0x44268ab9,0x2d876aba,0x201b403c,0xc7b8e16d}},	//   eno_, úne_, siqi_, biđe_,
   {{0xe719613a,0x69c44abb,0x6d4085dd,0x7e608abc}},	//   ديات_, beie, _ayma, _bimp,
   {{0x2a690048,0x2d98e064,0xe29f0232,0xb05b6156}},	//   _kuab_, órej_, orð_, _späd,
   {{0x6b8b8abd,0x60daaabe,0x2a690022,0x26cca057}},	//   ragg, _artm, _juab_, _asdo_,
   {{0x6b8b8abf,0x2006cac0,0xf991a13a,0xd838e07f}},	//   sagg, _aloi_, سبت_, joč_,
   {{0xdb0b8ac1,0x27edc588,0xac946ac2,0x2a690048}},	//   tegó, tjen_, _марш, _luab_,
   {{0x16348503,0xdb0e2ac3,0x6ebb4295,0x2d87eac4}},	//   _деся, ékér, _उहाँ, _sene_,
   {{0x69c3aac5,0x2d87eac6,0x2d8ceac7,0xdb0b8ac8}},	//   pene, _pene_, fade_, regó,
   {{0x3206c019,0x61e2cac9,0x6006e3fc,0xdb18aaca}},	//   _eloy_, _enol, йным_, devæ,
   {{0x63ad0037,0xddc66013,0x6609c0bb,0x7afbc05d}},	//   _bcan, _sukū, phek, syut,
   {{0x3255cacb,0x3f87eacc,0xb5fd8361,0x2cbf807d}},	//   _увер, _wenu_, _fiše, _kpud_,
   {{0x60060057,0x3a382156,0x6b8d4acd,0xdb1c21af}},	//   _cóma, torp_, daag, rerí,
   {{0xdb0600eb,0x6d41aace,0x59aa0acf,0x7e96c1b3}},	//   ngké, _kyla, _कावर, _انور_,
   {{0x69c44ad0,0xf8bf40f9,0xddcd212a,0x7643a07d}},	//   teie, _apé_, _staţ, ilny,
   {{0x1f66439e,0x6607616d,0x249fcad1,0x60dce271}},	//   скам, _aljk, orum_, ærme,
   {{0xdb18e071,0xc044e067,0xa01b2156,0x249fcad2}},	// [620] _favó, _đoạt_, rsör, nrum_,
   {{0xe8194ad3,0xe0584050,0x20004025,0x49ca2ad4}},	//   नोबा_, _چیست_, skii_, _слон_,
   {{0x6b898ad5,0x69ad239f,0x09f72095,0x7c2dc06e}},	//   _beeg, _जाती, _המים_, čarj,
   {{0x2a690022,0x81cc407c,0x3f8ce066,0x6443aad6}},	//   _yuab_, লাহ_, zadu_, elni,
   {{0xb4e0a4e5,0x6d41a20f,0x38b1e3e4,0x44d82098}},	//   दम्_, _ayla, hár_, _hč_,
   {{0x41e2a064,0xaca40125,0xdee66ad7,0x63a9cad8}},	//   पाइस, _adịw, _логи, egen,
   {{0x23698ad9,0x64428ada,0xdca362a3,0x2d8ceadb}},	//   žaja_, ploi, _нари, vade_,
   {{0x9874cadc,0x3a3a6277,0x201caadd,0x7bf8c331}},	//   олиц, lopp_, sivi_, рнир_,
   {{0x44446ade,0x2902cadf,0x201a2071,0xf76fc7f0}},	//   ol_, áka_, _ompi_, راي_,
   {{0xf09f014a,0x7cde812a,0x2ca04ae0,0xea012067}},	//   vrà_, _cărţ, irid_, _đắt_,
   {{0x7bc60ae1,0xd7efcae2,0x89dba095,0x2d8ceae3}},	//   feku, _еу_, _תחבי, rade_,
   {{0x3f8ea296,0x38612ae4,0x2a690286,0x44d7e12a}},	//   lafu_, _sihr_, _puab_, _dă_,
   {{0x2ca0405d,0xdb18e019,0x44facae5,0xade5c10a}},	//   jrid_, _pavó, _حراج_, कारन_,
   {{0x7bd82ae6,0x25ad017a,0x2a690022,0xdb0f80fa}},	//   _óvul, żel_, _vuab_, édér,
   {{0x661d0ae7,0xfc3f2359,0x443eaae8,0x44446ae9}},	//   pisk, guía_, _mkt_, dl_,
   {{0x3f8eaaea,0xf09f0024,0x61f5619f,0x9f4ca425}},	//   hafu_, prà_, _sozl, _modà_,
   {{0x26dce098,0xa3ba410a,0x6443a944,0xdb18a1dd}},	// [630] _hrvo_, _आउर_, ylni, levä,
   {{0x6b8d4aeb,0x7e7d0aec,0xbddb4aed,0x21676aee}},	//   saag, mpsp, _chèr, стаг,
   {{0x3ea0400e,0x7c28eaef,0x61e52174,0xdb1aa019}},	//   arit_, indr, _inhl, _mató,
   {{0x8d87804e,0x201eeaf0,0xa91dcaf1,0x6e3aeaf2}},	//   сужд, hiti_, saži, hotb,
   {{0x7e61a07d,0x35de2028,0xda78a06f,0x443b475f}},	//   _pilp, _फोड़, _atď_, moq_,
   {{0x69c724bd,0x44446af3,0x2d8a6af4,0xd006aaf5}},	//   neje, cl_, _gebe_, жеше_,
   {{0x7bc60af6,0x92e9807c,0x2baa0af7,0x6d42caf8}},	//   yeku, মনে_, _काला, _ayoa,
   {{0x2bd906e1,0x7c2d0af9,0xb05b2105,0x6e2d0050}},	//   _बोला, _njar, swäh, _njab,
   {{0x6443a05c,0xa3e9aafa,0x7cde812a,0x443ea7a0}},	//   plni, याद_, _părţ, _fkt_,
   {{0x3ea5e10a,0x115c400b,0x6e2d0afb,0x201eeafc}},	//   tult_, נדזע, _ajab, giti_,
   {{0x25dde010,0xa3e50afd,0xa3ea0afe,0xb4e3e046}},	//   _कोणी_, नां_, адна_, नमे_,
   {{0xcad66095,0x201a20c7,0x290be064,0x38b1eaff}},	//   קורת_, _smpi_, ąca_, rár_,
   {{0x2903e06e,0x3a294b00,0xe2dac0e0,0xc483093b}},	//   šja_, dnap_, _پانچ_, мляк,
   {{0x201fc03b,0xee3f406f,0xa7fb4071,0x3a2d8320}},	//   liui_, _aký_, _riña, _ljep_,
   {{0x661b8b01,0x3f8a6b02,0x2d8f8b03,0xdd8ee049}},	//   _omuk, _rebu_, kage_, _شوي_,
   {{0x3f8b4480,0xa3e50861,0x200dc1ae,0x201fc03b}},	//   _cecu_, नाः_, nhei_, niui_,
   {{0x661e6b04,0xbddb4004,0x64444665,0x3ea04aaa}},	// [640] tipk, _chèq, rlii, urit_,
   {{0x7c2d00dd,0x3ea04b05,0xbb1b0004,0x2bd1c010}},	//   _zjar, rrit_, raît, _दोघा,
   {{0x2d8f8004,0xfc3f21af,0x660d41fb,0xf1bf0009}},	//   fage_, quía_, bhak, knál_,
   {{0x661e68a4,0x3a3f8345,0x3ea7a292,0x2d8b43ed}},	//   sipk, _ckup_, dunt_, _gece_,
   {{0x201eeb06,0x8e570087,0x661b805d,0x443eab07}},	//   yiti_, קינג_, _dmuk, _pkt_,
   {{0xdd92601c,0x2d8b412a,0x9f4fc071,0xddd56018}},	//   _زور_, _zece_, _cogí_, _aizņ,
   {{0x66098b08,0xdb1c60dd,0x321eeb09,0x3ea7ab0a}},	//   _flek, _mbrë, vity_, gunt_,
   {{0xf1bf0803,0x69d64b0b,0x3f8f8b0c,0xdcbac14a}},	//   gnál_, ndye, cagu_, ащо_,
   {{0x2fc7ab0d,0x29004b0e,0x225e4066,0x7e63eb0f}},	//   beng_, nyia_, ítky_, _binp,
   {{0x2fc7ab10,0x7c3c2071,0xd9c74046,0x7c2d0b11}},	//   ceng_, jorr, _लस्ट, _sjar,
   {{0xd83904ad,0x7c3bcb12,0x321ee42c,0x104b004e}},	//   luči_, bour, rity_, иями_,
   {{0x320dc10f,0x6b8226be,0xdb1d204a,0x2d8cab13}},	//   chey_, _đoga, ázít, _hede_,
   {{0x2d8cab14,0x3f8ca096,0xed5acb15,0xf9938557}},	//   _kede_, _kedu_, _тод_, ורר_,
   {{0x38b44156,0x63bb2422,0x60c2cb16,0xa91dcb17}},	//   där_, đuno, _ipom, gažu,
   {{0x2d8cab18,0x3f820058,0xdb1c2b19,0xf485063b}},	//   _mede_, bbku_, terá, _کابی,
   {{0x7a3fa004,0x386ca066,0x7e7d0b1a,0x83fcc143}},	//   nêtr, _mudr_, ppsp, _buđi,
   {{0x200a6037,0x3a2940e0,0x38b44156,0x2fc7ab1b}},	// [650] _blbi_, rnap_, gär_, yeng_,
   {{0x35b108c6,0x2d8cab1c,0x78a28b1d,0xd37b6b1e}},	//   _झाड़, _nede_, drov, рча_,
   {{0x81ce007c,0x2d83200e,0xc7b221a9,0x798d0037}},	//   রার_, mbje_, _אבי_, _keaw,
   {{0xb87b4b1f,0x61f8e271,0x44294b20,0xdb1c62a8}},	//   _príd, _lovl, qna_, _aaró,
   {{0x443cab21,0x3f8cab22,0xeb76400b,0x2bb2235b}},	//   fov_, _bedu_, _מערץ_, _जामा,
   {{0xf1b9c29c,0x28b9a13a,0xa91d8b23,0x6d4f42a8}},	//   diša_, مطبخ_, _ježi, _izca,
   {{0xeb99cb24,0x6b8bc14a,0x7c29c042,0xc7b9c0e0}},	//   бий_, _pegg, tner, tfő_,
   {{0xa91d8b25,0x7c29cb26,0x95f5eb27,0xddc1c143}},	//   _leži, uner, ेस्ट_, _bulš,
   {{0x7c3bc12a,0x6b9b8114,0x7c29cb28,0xf1bf0387}},	//   rour, _idug, rner, rnál_,
   {{0x7e7b8b29,0x7c3bc095,0x69d56b2a,0x11d5e049}},	//   _itup, sour, _jaze, ستخد,
   {{0x6d440b2b,0xee3a02d7,0xa91dc326,0xe1fb4010}},	//   _syia, йно_, važu, _एकूण_,
   {{0xd12ec555,0x78b6404e,0xf1b9c04d,0xb2baa095}},	//   ئمی_, ytyv, biša_, _למער,
   {{0xa91d8500,0xa3ac6a41,0xdee5c103,0x66e5c423}},	//   _beži, _गाल_, _холи, _хола,
   {{0x61f9c054,0x78a9c333,0x63ad4b2c,0xf1bf41e9}},	//   _howl, muev, egan, _abá_,
   {{0xdb1c2602,0x66e32b2d,0x6d4f42a8,0xed59cb2e}},	//   _üzün, нора, _azca, deži_,
   {{0x80b1e07c,0x68fceb2f,0x661c6b30,0x83fcc012}},	//   _জনপ্, ärde, _smrk, _puđi,
   {{0xb95b40f9,0x24890125,0x2d9127ef,0x6441a015}},	// [660] _abìb, _gwam_, baze_, _okli,
   {{0x4a436b31,0x63ad4b32,0x04466251,0x25bf8b33}},	//   енув, agan, чезн, _abul_,
   {{0x26df8125,0xdb1d4b34,0xb5fb40e0,0xf1bf0066}},	//   _aruo_, _basó, _kiál, znám_,
   {{0x38c88062,0x68e32005,0xdb0524d2,0x443d8b35}},	//   قاتی_, _ánda, _uchá, gow_,
   {{0xdb1c6317,0x2d924b36,0x200ea6ae,0x6b844b37}},	//   _paró, maye_, thfi_, mbig,
   {{0x6b9b8b38,0xec168011,0x6e21eb02,0x6aa28733}},	//   _edug, _کورد, jilb, rrof,
   {{0x2a64805d,0x22468b39,0x5886a013,0xdb1d4b3a}},	//   _timb_, plok_, чыла, _absè,
   {{0xa3dca046,0xc181c0e0,0x386d80cb,0x2d924b3b}},	//   _तोर_, پیوٹ, _fuer_, naye_,
   {{0x9f4eeb3c,0xdca38b3d,0x64a38afe,0xe8e0c119}},	//   _sofà_, _пати, _пата, _đồi_,
   {{0xd776a13a,0x69d60b3e,0x6e228b3f,0x6b8e6320}},	//   _رائع, _aaye, liob, _jebg,
   {{0x26de6098,0x7bcaa167,0xdcf6003c,0x660f000e}},	//   _štoj_, mefu, _peyğ, thck,
   {{0xa3d7cb40,0x27e6c0ae,0x2ee001cd,0xab5b0b41}},	//   ायः_, _unon_, _brif_, nfüg,
   {{0x23ac6b42,0x7c21eb43,0x9f45a0d1,0x69d60b44}},	//   _चांद, bilr, _anlè_, _daye,
   {{0x69caab45,0x9c83206f,0x2005e106,0x9605437f}},	//   nefe, účov, ckli_, रस्ट_,
   {{0x49bbe008,0xc1bbe095,0x3f912b46,0x3bbbe557}},	//   _המוס, _המוש, razu_, _המוד,
   {{0xa7fb42b2,0x69caab47,0x38b60b48,0xa5bb4031}},	//   _viño, hefe, bær_, _ajór,
   {{0x8f9c0095,0x69d56b49,0x2fc94256,0x27e90b4a}},	// [670] _היחי, _paze, reag_, _inan_,
   {{0xdb0780fa,0x39474018,0x7bc08194,0x2bf981a6}},	//   _élég, āns_, _abmu, _আগেই_,
   {{0xb5fd82c9,0x7fd5814f,0x63ad4b4b,0xda0cc0f1}},	//   _dišn, ділі, pgan, िघात_,
   {{0x7bd56b4c,0x7641a013,0x38b56584,0x6b844025}},	//   _wazu, _skly, rår_, cbig,
   {{0x3e71a081,0xa3ace010,0xa5bb4069,0x92ad607c}},	//   _sát_, गला_, _fjór, কবে_,
   {{0x7c3e6024,0x466b6b4d,0x3e71a04a,0xdb1c2156}},	//   copr, _грам_, _pát_, berä,
   {{0x6263c0e0,0x1dd7e021,0x69d72b4e,0x7d0280ae}},	//   _főol, _भोगत, _maxe, ayos,
   {{0x1309c09e,0x386d80fa,0xc1740020,0x63bd0171}},	//   жний_, _tuer_, _kaɗe_, jfsn,
   {{0xdb1c60c4,0x61e98b4f,0x25adcb50,0x7bcb8b51}},	//   _harð, _inel, rgel_, megu,
   {{0xad9b0232,0x61faa156,0x99ddc05c,0x9f4eeb52}},	//   skúl, _gotl, plňo, _sofá_,
   {{0x44232b53,0x22494b54,0x2d924068,0x61e98b55}},	//   dij_, klak_, yaye_, _knel,
   {{0x6448e265,0x442ceb56,0x38b60042,0x7ae36052}},	//   aldi, and_, tær_, änty,
   {{0x6449c31b,0x81d0a07c,0x69d72025,0x61e8ab57}},	//   mlei, ষার_, _baxe, _yndl,
   {{0x2d924b58,0xb5fb4359,0x200c2b59,0x35fbe050}},	//   waye_, _diám, ódi_, _درصد_,
   {{0xde6d0016,0x614325e5,0x7c2d4069,0x7bd60b5a}},	//   _vươn, вера, fnar, _tayu,
   {{0xa3b1cb5b,0xa5bb003a,0x6e23ab5c,0x6aa12632}},	//   ञ्च_, lión, hinb, álfa,
   {{0xa3d927f4,0x76440b5d,0x60c9600a,0x7c294066}},	// [680] _ठोक_, _ikiy, _ćema, čerp,
   {{0x62964b5e,0x6449c105,0x7c2da049,0x7d06810a}},	//   rsyo, hlei, éarl, _üksi,
   {{0x62964b5f,0x7643e037,0x0403407c,0x200d8488}},	//   ssyo, _mkny, রোধী_, _blei_,
   {{0x629640d1,0xc314c07c,0x2d8fcb60,0x27e9e0e8}},	//   psyo, াপতি_, _nege_, _ɗana_,
   {{0xe7e32010,0xdb1e2b61,0x2fc1217b,0x6d4760c4}},	//   खाचा_, _tapó, _ybhg_, _eyja,
   {{0xdb1c204e,0x7e6e6022,0x753600ae,0xa3aea04b}},	//   perä, _tubp, _mxyz, _काळ_,
   {{0x7d044b62,0x7c228b63,0x07a3639d,0x9f4361e9}},	//   lyis, pior, _јасн, _dojó_,
   {{0x61fc6b64,0xe1ff4057,0xc6f8cb65,0x7bcaa1b7}},	//   _horl, _lión_, зних_, sefu,
   {{0x7bcaab66,0x61faa2f7,0x3e7b8b67,0x6f0445f1}},	//   pefu, _totl, _câtă_, nyic,
   {{0xa5bb006f,0x660d0b68,0x44f4e73f,0x31574053}},	//   gión, _slak, епос, ויפן_,
   {{0x6449cb69,0x61fc6b6a,0xa3b6c033,0xb4bc604b}},	//   blei, _morl, _जाप_, _अहो_,
   {{0x6dc4800a,0xceb8ea0b,0x0906c1c0,0x7c2e21b9}},	//   _učač, rtę_, _опен, enbr,
   {{0x1169c555,0xceb8eb6b,0x63b40089,0x62828b6c}},	//   _علوی_, stę_, _žená, npoo,
   {{0x25756ac3,0x69c1a05d,0xdb1e20d1,0xe1ff407b}},	//   _múló_, _xble, _rapò, _ción_,
   {{0x660d0b6d,0x2019eb6e,0x394d400a,0x7c2d4b6f}},	//   _tlak, ësie_, _šes_, tnar,
   {{0x44dee17a,0x600b2046,0x44200b70,0x7bdaeb71}},	//   _iċ_, _gümn, _gmi_, ldtu,
   {{0xa3e88b72,0xcd04204a,0x2904cb73,0xdb098b74}},	// [690] बाई_, vněž_, nyma_, _oceá,
   {{0xf3ff4016,0x7c2d4b75,0xa3eac960,0x9f8920c4}},	//   _giãn_, snar, माँ_, _góðu_,
   {{0x7649c121,0x7c2da049,0x08f80062,0xe7e4004b}},	//   yley, éarm, _فریب_, गाचा_,
   {{0x7bc1a13b,0x6440cb76,0x6298ab77,0x44442b78}},	//   _sblu, jomi, dsvo, _zk_,
   {{0x3d17a7a7,0x3f8fc939,0x26c6c05f,0x6d476064}},	//   _भेजे_, _regu_, _npoo_, _wyja,
   {{0xc3324095,0x443fc157,0xb4cb435b,0xdb1c2156}},	//   _תוך_, wou_, लबी_, rdrö,
   {{0xa3eac029,0xe3b1c13a,0x6449cb79,0xeb99c1fc}},	//   मां_, هرة_, tlei, пий_,
   {{0x6440cb7a,0x248ca057,0xeb99c04e,0x44212b7b}},	//   gomi, _dwdm_, чии_, _lmh_,
   {{0x68e2c2d9,0x3947e3e0,0x0e35a955,0x63ada35f}},	//   _crod, _syns_, _знаю, ɗann,
   {{0x7c244b7c,0x7ae2cb7d,0x69c1ab7e,0x4424c256}},	//   ziir, _drot, _uble, aim_,
   {{0xb4be24ef,0x38b8eb7f,0x6449cb80,0x6d48a1cd}},	//   _इहे_, gér_, plei, _gyda,
   {{0x4424cb81,0x64a60b82,0x44212256,0xd875c13a}},	//   cim_, нама, _amh_, _كاتب,
   {{0xb3b1008c,0x62998b83,0xea9fe1e9,0x38690b84}},	//   _झारख, nswo, _baṣi_, _diar_,
   {{0x4444213e,0x69dbc108,0x9c7ca381,0x3e7523e0}},	//   _qk_, ldue, _hrča, _båt_,
   {{0x78bbcb85,0x7c2e2b86,0x44212aaa,0x68e2c6c4}},	//   ltuv, rnbr, _dmh_, _zrod,
   {{0xfc3f2359,0x7c36200a,0x7bdbcb87,0x61fd4b88}},	//   rría_, _šarč, nduu, _cosl,
   {{0xa3b6e295,0x7bd9cb89,0xdcf460a9,0x9c7ca143}},	// [6a0] ङ्क_, _mawu, đačk, _mrča,
   {{0x25bfcb8a,0xb5fb6b8b,0x41c10026,0x68e3e391}},	//   hful_, _suár, ष्ठस, _krnd,
   {{0x78bbc2df,0x2fd86b8c,0x61ebcb8d,0x2a7f80ae}},	//   htuv, _varg_, _ongl, _atub_,
   {{0x7e698064,0xdd8f833e,0x78bbcb8e,0x2a69005f}},	//   _ciep, موم_, ktuv, _xiab_,
   {{0x3f868b8f,0x7bdbcb90,0xc8b6402d,0xa5bb0071}},	//   rbou_, dduu, _ясны, diól,
   {{0xb3cf607c,0x998940c2,0x62812019,0x7ae40b91}},	//   রাউজ, chał_, ílog, _mrit,
   {{0x7f498a43,0x5334a04e,0xb4be24ef,0x39e764c9}},	//   _eyeq, ъект, _इहो_, _ядро_,
   {{0xd9436b92,0xb6bb61a9,0x69d8eb93,0x69c3eb94}},	//   _сеси, _מצלי, _save, _abne,
   {{0x6d48ab95,0x442241e7,0x7bd9cb96,0x3eadc1ab}},	//   _wyda, _mmk_, _dawu, guet_,
   {{0xb906a07c,0x9f45a071,0xe3bf003e,0x625341de}},	//   _পথ_, _coló_, diña_, içoa,
   {{0x6440cb97,0x69dbcb98,0x62588049,0x644642e4}},	//   pomi, bdue, ríof, _okki,
   {{0xb87b004a,0x68e40b99,0x69dc2b9a,0xa3e76466}},	//   jvíc, _brid, edre, _मोन_,
   {{0x2d920b9b,0x7bdc2b9c,0xf8cf40c5,0x7bd8eb9d}},	//   _deye_, fdru, _सैंय, _tavu,
   {{0xdb1c627f,0x24520b9e,0xd7f82093,0x78adc066}},	//   _abrí, ráma_, нус_, ňový,
   {{0x9980403a,0x61ebc1cd,0xa3aea148,0x07e74b9f}},	//   zniť_, _yngl, _काई_, нцам,
   {{0xe3bf0005,0x80c22ba0,0x69dc2ba1,0x6ed3a5fc}},	//   biña_, _लहरे, adre, _qəbə,
   {{0x4034404e,0x7b74413a,0xb5fda6a6,0x69cf0ba2}},	// [6b0] уетс, اطفا, _mušr, mece,
   {{0x2fd941cd,0xb4bf0ba3,0x2fcdc022,0xb4cd0046}},	//   _wasg_, ीबी_, zeeg_, रबी_,
   {{0x3f916ba4,0x02b10960,0xd4e467ca,0xaefb41e9}},	//   _vezu_, _जमुन, люци, _agùt,
   {{0x38baa00e,0x2d216010,0x76428025,0x7c256098}},	//   dër_, _मधील_, gooy, sihr,
   {{0xfd964694,0x69dd0ba5,0x38baaaaa,0xfbb8607c}},	//   _בדרך_, idse, eër_, ীয়ত,
   {{0x764d4ba6,0x6e22cba7,0x7c260163,0x2fcdc31d}},	//   llay, _amob, zikr, weeg_,
   {{0x41b100c2,0x7bcf00b1,0x9c7ca143,0x8c3d0181}},	//   _झांस, kecu, _prča, luğu,
   {{0x69cf0ba8,0x2d8947d3,0x6441eba9,0x2ca9428f}},	//   jece, nbae_, woli, orad_,
   {{0x4ec3a1a6,0x25bfcbaa,0xa3ace04b,0xe3bf003e}},	//   ্মেল, rful_, गलं_, xiña_,
   {{0x2b9c6026,0x764d4bab,0x1309e04e,0x68e40bac}},	//   mácí_, hlay, дной_, _rrid,
   {{0x2d9205cd,0x7ae4003b,0x24800bad,0x2ca94066}},	//   _peye_, _srit, _stim_, hrad_,
   {{0x6281abae,0x62856baf,0x7bdaabb0,0x7bdb807d}},	//   _itlo, ipho, _zatu, _jauu,
   {{0x7bdaabb1,0x7bdc2bb2,0xb5fd803b,0x7bce2bb3}},	//   _yatu, tdru, _aišk, tebu,
   {{0xf1c4a37f,0x33d5284f,0x7d060bb4,0x4425ebb5}},	//   ल्पन, ліст, ryks, qil_,
   {{0x6d4ae0e2,0x3e76486b,0x78bd0bb6,0x3ea94bb7}},	//   _gyfa, _sæt_, atsv, erat_,
   {{0x3f894bb8,0x7bdb88c4,0x69cf0bb9,0x7bdc2bba}},	//   gbau_, _nauu, cece, sdru,
   {{0xe9da6bbb,0x6e240bbc,0x3ea94bbd,0xba3b25df}},	// [6c0] мка_, _imib, grat_, tuït,
   {{0x81ce01a6,0x764d4bbe,0xaf062bbf,0x20000187}},	//   রাও_, alay, _апол, _hoii_,
   {{0x764d4bc0,0x44224bc1,0xa3b36ba0,0xa3d5a861}},	//   blay, _tmk_, _टार_, िजन_,
   {{0x7989c171,0x4427a3f6,0xb87b027f,0xbea361ba}},	//   jbew, ein_, lvía, рацк,
   {{0x3ea94bc2,0x8c3d0106,0x644283c5,0x6d556035}},	//   crat_, cuğu, rooi, _ezza,
   {{0x7c22cbc3,0x629aebc4,0x6aa9c0fd,0x6383616c}},	//   _smor, ysto, dref, _вгра,
   {{0xf7732076,0x41dd8bc5,0x62856bc6,0x69dd022e}},	//   סקה_, _नोकस, cpho, ydse,
   {{0x34c2a38e,0xa3b64acf,0x7659cbc7,0x6b89cbc8}},	//   _शहीद, च्च_, _chwy, gbeg,
   {{0x62588bc9,0x44324bca,0xe3baabcb,0x20d3e12a}},	//   ríod, iny_, _оба_, _aţi_,
   {{0x61ed006a,0x7afce156,0x3a2481e7,0x7bc28bcc}},	//   _snal, ärto, _hmmp_, lfou,
   {{0x26c9016d,0xb95b40f9,0x65950bcd,0x6448a041}},	//   _spao_, _abìl, лану, _ikdi,
   {{0x0326c312,0x27ff0069,0x7ac6cbce,0xa5bb40f9}},	//   _иден, ðun_, _аске, _amón,
   {{0xdcf52041,0x25a127d3,0x629aebcf,0x403408e9}},	//   pazī, _pdhl_, ssto, реяс,
   {{0xc0aaebd0,0x7bc64020,0xf1bf0057,0xb4bec3fa}},	//   _قابل_, _abku, cián_, ँझी_,
   {{0xd378a0e4,0x333a2057,0x9f47e071,0x07a3e39d}},	//   _gaće_, _cxpx_, _donó_, _тајн,
   {{0x228426bb,0xae1f05cb,0x2ca9487d,0xdcfc604d}},	//   рург, मोशन_, trad_, _nerđ,
   {{0x3f982bd1,0x9f5ea0dd,0x26c9006a,0x5d554bd2}},	// [6d0] baru_, _botë_, _upao_, укат,
   {{0x25e2a295,0x61ee6037,0x6e28e0e4,0x644d4bd3}},	//   _टोली_, _cnbl, nidb, slai,
   {{0x8c3de106,0x44324b46,0x2d9900ba,0x6b682009}},	//   muşt, bny_, oase_, _végü,
   {{0x7643abd4,0x2ca9406f,0xb8cb6626,0x69dc6bd5}},	//   wony, prad_, _खि_, _eare,
   {{0xceeb8555,0x6282c286,0x7659c1cd,0x8fa5abd6}},	//   بران_, _ntoo, _rhwy, гале,
   {{0xdce8a03c,0x201e4018,0x629d0bd7,0xf1bf0005}},	//   _addı, ītie_, isso, xián_,
   {{0x5e58200b,0x3f990bd8,0x6ecf8026,0xafdb046b}},	//   דיגע_, kasu_, _धनकु, nløs,
   {{0xa3eac38e,0xa3c16bd9,0x8af7c497,0x27ed8bda}},	//   माग_, ंभव_, _çəki, _unen_,
   {{0xb5fd8361,0xa5358052,0xfc3f203e,0xfe45e01b}},	//   _niši, _снач, luíu_, лнио,
   {{0xe8f9ebdb,0x443249a1,0x63a2cbdc,0x2d982bdd}},	//   ело_, zny_, _edon, xare_,
   {{0xbef380aa,0xabb5c1b3,0xaad8cbde,0x224dcbdf}},	//   _आपुन_, _مماث, _बैठक, plek_,
   {{0x2d990174,0x6601a04a,0x3f99035d,0xb8ebe960}},	//   gase_, _holk, gasu_, _रङ_,
   {{0xb05b604e,0x18a5cbe0,0x645aa052,0x386d8be1}},	//   _epäi, _салм, _yhti, _mier_,
   {{0xddcd2be2,0x290940ae,0x60060be3,0xee3f2066}},	//   _etaž, dyaa_, _rómu, brým_,
   {{0x8fa640db,0x03a64be4,0x8c1ae095,0x44324be5}},	//   лаве, ливо, _רוצי, tny_,
   {{0x6e29cbe6,0xa3e5a077,0xb5fd86a6,0x69dd494c}},	//   nieb, _बोस_, _fiši, _case,
   {{0x2cbfcbe7,0x6b956be8,0x7bdd4be9,0x7d1bcbea}},	// [6e0] ntud_, _bezg, _dasu, nzus,
   {{0xb8cc4a53,0xb05b2052,0x28a6c046,0x9d1b01a1}},	//   _गि_, ttäe, _खिसि, _נויט,
   {{0x6e29c200,0x09e68beb,0x7bc28bec,0x41aa816c}},	//   kieb, ложн, tfou, евен_,
   {{0x2bc02bed,0xf2d32087,0x4425a1cd,0x7e7ee0e0}},	//   श्रा, _פער_, _aml_, _éppe,
   {{0x8cd3c077,0xc7a38471,0x69c44363,0x3e78a119}},	//   _बैलो, сичк, mfie, _sét_,
   {{0x644601fb,0x6b960bee,0x644980a2,0xfc3f203e}},	//   hoki, _leyg, _ekei, buíu_,
   {{0x2fddc048,0x2d990bef,0x7ae44bf0,0x6e28e3de}},	//   _bawg_, yase_, lvit, vidb,
   {{0x244e805c,0xe3bf027f,0x7bdd4054,0x6b98a249}},	//   kými_, viño_, _xasu, savg,
   {{0x7e6d065f,0x2245e042,0x69c16984,0xb87b40f9}},	//   _riap, folk_, र्वी, _aríj,
   {{0x32bb400b,0x290a2013,0x4086ebf1,0x27e04052}},	//   עזיד, kyba_, лумб, hdin_,
   {{0x6d4d00c7,0x7f4d0058,0x44294bf2,0xe9ff8067}},	//   _syaa, _syaq, yia_, _chặn_,
   {{0xe8d7a095,0xb4d4e077,0x63a2cbf3,0x6ee6c243}},	//   _תואר_, _हनी_, _udon, _مستل,
   {{0xdddbe38a,0x63a401cd,0x69c8a0ae,0x3f9a6bf4}},	//   spuš, _ddin, _kbde, kapu_,
   {{0x69dd4bf5,0xd576e052,0x3f9900b1,0x44e3a106}},	//   _sase, _судь, sasu_, _yı_,
   {{0x6016e01f,0x3ea00bf6,0x7ccaa497,0x799aebf7}},	//   _câme, _evit_, _hərb, matw,
   {{0x6b9aebf8,0x9f5eabf9,0x6288e197,0x7abbe0be}},	//   latg, _coté_, mpdo, _נצחו,
   {{0x9477401e,0x69c8a06e,0x37ab662a,0x20012046}},	// [6f0] ادرا, _obde, етен_, _tohi_,
   {{0x4438607d,0x6fb22064,0x60cd0bfa,0x442a2bfb}},	//   _cjr_, _जाएं, _ipam, cib_,
   {{0x3e7980d1,0x6013820f,0x6113e03c,0x7ae44bfc}},	//   _sèt_, _açma, tələ, avit,
   {{0xd6d861ba,0x7bde249f,0x4429400e,0x6601abfd}},	//   ыту_, _zapu, qia_, _solk,
   {{0x2d94203a,0x6601abfe,0x6113e03c,0x3ec4404a}},	//   ždeň_, _polk, rələ, ěstí_,
   {{0x386d8363,0x6258813a,0x3dddc058,0x867c000b}},	//   _wier_, tíoc, _saww_, ערוו,
   {{0x80d58029,0x3d0ee0c2,0x9f424052,0x8015cbff}},	//   _मैरे, ानों_, _enkä_, ифиц,
   {{0x6b8d4c00,0x673b8048,0x7999805d,0x4425a1f6}},	//   nbag, _txuj, qaww, _wml_,
   {{0x6d4e61e2,0x64460c01,0xee39ebd2,0x7af68052}},	//   _zyba, voki, кни_, äytt,
   {{0x27e04381,0xb5fb4049,0x6f1bc0c2,0x7d1bcc02}},	//   zdin_, _fhág, rzuc, rzus,
   {{0x2fddc286,0xd131a13a,0x69c44c03,0x2247a1f6}},	//   _tawg_, _بما_, yfie, monk_,
   {{0x244e8066,0xe366060f,0x6d5d803e,0xed598012}},	//   tými_, икни, _úsas, _kzž_,
   {{0x68e44004,0x661d000e,0x3eaceb83,0x7d012156}},	//   xvid, ërka, ardt_, älsn,
   {{0x2fdf8286,0x6b9bcc04,0x1dd9e010,0xa136c00b}},	//   _laug_, laug, _बघित, _דאנק_,
   {{0x699641e1,0x9f5ea04a,0x249fc765,0xe9df41de}},	//   ирах, _poté_, lsum_, _baú_,
   {{0xe8e06016,0xb38640ba,0x3b864099,0xcb12a00b}},	//   _hiệp_, рлал, рлаг, קלן_,
   {{0x7bde2c05,0x62852c06,0x27e00569,0x14266c07}},	// [700] _tapu, _etho, _iain_, адам,
   {{0x442a2c08,0xa3e5a46f,0xc7b8e098,0x6016e2e5}},	//   qib_, _बोल_, biđu_, _zâmb,
   {{0x2247a0d1,0x799c2c09,0xf1bf40e6,0x3eadcc0a}},	//   donk_, marw, _imán_, hret_,
   {{0xdce1e6df,0x6603e0bb,0x3eadc4b5,0xb5fb4c0b}},	//   nalı, _lonk, kret_, _diás,
   {{0x80c4007c,0x245c8066,0xb5fb4019,0xdce0c19f}},	//   শিক্, jíme_, _viát, yamı,
   {{0x799c2068,0x442b0c0c,0x30a6abcb,0x02a6a2d8}},	//   narw, zic_, арив, арим,
   {{0x9999003a,0x82a3612a,0xdce0c3ed,0xdce1e0b0}},	//   losť_, _марж, vamı, kalı,
   {{0x57f4cc0d,0x6015c326,0x3f804c0e,0x28a7a260}},	//   спит, _rámc, nciu_, _गिरि,
   {{0x799c2c0f,0x6d59c0c2,0xdefacc10,0x3e7c2c11}},	//   karw, _czwa, тый_, _lít_,
   {{0x4427ec12,0x46c72c13,0x9e06ec14,0xbea6a0ff}},	//   _cmn_, _लहलह, рчил, _важк,
   {{0x397ba087,0x799c2068,0xbb46a1e1,0x78ad4c15}},	//   _סטאנ, darw, _тежк, zrav,
   {{0x2ca044ef,0x6b9ae5df,0xb8cee7f4,0x2d8040c2}},	//   ksid_, satg, _ओट_, jcie_,
   {{0x61e281d1,0x60102262,0x787ee018,0x628aa363}},	//   idol, _täml, _dīva, lpfo,
   {{0x9999006f,0x3f9cac16,0x2486c006,0xbb84e13a}},	//   dosť_, navu_, _itom_, _الغي,
   {{0x64472c17,0x443a2037,0xe45300b7,0x66160c18}},	//   roji, _djp_, _وضع_, _flyk,
   {{0xdce1e19f,0x9dab014a,0x64472c19,0xf1b9c143}},	//   calı, _ръка_, soji, bišu_,
   {{0x2d9cac1a,0x7875a03b,0xcf9b601b,0x799d00b1}},	// [710] kave_, _išve, вје_, masw,
   {{0x80dae20b,0x27e00c1b,0x44290048,0x2ca76333}},	//   _बनाइ, _zain_, _hma_, ándo_,
   {{0xdc3c2076,0x22524c1c,0x7bd52c1d,0x78ad459f}},	//   _בעזר, blyk_, mezu, srav,
   {{0x1b05807c,0x3f804197,0x2485a63f,0x20048c1e}},	//   _শেষে_, cciu_, _rtlm_, _comi_,
   {{0x7648ec1f,0x2ca04c20,0x3204839c,0xb9c4813a}},	//   kody, csid_, _domy_, تقني,
   {{0x7c2b8c21,0x600fa271,0x7ae98c22,0x1404004b}},	//   sigr, _tømm, _vret, _लव्ह_,
   {{0x68e98c23,0x60c28af8,0x2a786c24,0x2d816090}},	//   _wred, atom, _gurb_, mche_,
   {{0x2d986088,0x6603ec25,0x29382095,0x442cec26}},	//   _zere_, _sonk, יאון_, eid_,
   {{0x799c2068,0x6f0d4c27,0x2d986121,0x6603ec28}},	//   yarw, nyac, _yere_, _ponk,
   {{0x7c2d4c29,0xf8ae8050,0x2d986057,0x245c806f}},	//   hiar, _سکه_, _xere_, ríme_,
   {{0x2cadc23d,0x26c12022,0x59a74010,0x245c8326}},	//   sred_, _nqho_, गणार, síme_,
   {{0x799c2068,0xe9df4067,0x2d9d8c2a,0x2ca04025}},	//   warw, _thúy_, nawe_, ysid_,
   {{0xdce3ac2b,0x7bdac1a9,0x3954e03a,0x5285c13a}},	//   manı, _תקנו, _časť_, _التك,
   {{0x27e00c2c,0x61e1ac2d,0xb7bdc12a,0x2005ac2e}},	//   _wain_, _jall, diţi, _joli_,
   {{0x81cd007c,0x639ae053,0xdcebc1f6,0x61e28c2f}},	//   রয়_, _עסקנ, _begħ, ydol,
   {{0x38a3e03c,0x661603d1,0xf2d2e00b,0x7c3b8c30}},	//   mır_, _ulyk, _זעה_, _njur,
   {{0x7d0d40e0,0x6e364a0e,0x2bbde029,0x7ccaa03c}},	// [720] gyas, rnyb, ्भपा, _məra,
   {{0xc301c07c,0x3ea20c31,0x68fb0076,0x80ca41a6}},	//   এনপি_, mskt_, _עליה, রিল্,
   {{0xdce3a3cd,0x7c2d4c32,0x386000c7,0xad5a64e4}},	//   kanı, biar, _khir_, урах_,
   {{0x2d9d84b7,0x44382c33,0x6f0d4071,0x3f99413e}},	//   gawe_, lnr_, byac, _gesu_,
   {{0x9f498069,0xdcfc2041,0x7aedc066,0x7e2aa71b}},	//   ðað_, karī, _šatn, ліка_,
   {{0x60c4400e,0x6e298096,0xb95b41e9,0xb87b41e9}},	//   mtim, _emeb, _abìw, _aríw,
   {{0xdcfae041,0x859b6095,0x7ccaa5fc,0x2486cc34}},	//   ratī, _תשלו, _bəra, _stom_,
   {{0x2d9a2c35,0xf1bf0009,0x5b14c052,0x661bc426}},	//   _lepe_, riák_, жмит, ghuk,
   {{0xc224a0eb,0xdcfae018,0xb5fd8013,0x99804013}},	//   _وکتو, patī, _višt, lnių_,
   {{0x44290c36,0x61e1ac37,0x1dd86033,0x3e41403b}},	//   _sma_, _gall, ड़ित, mėte_,
   {{0x4bfb6087,0xa3c941b0,0x6d5aac38,0x0dcac0ff}},	//   אליס, ल्ड_, _uzta, _були_,
   {{0xaaa9ec39,0x9e66cc3a,0x786b21d7,0x78602156}},	//   _किरक, _увед, _iżvi, hövd,
   {{0x2d994197,0x2a600025,0x7ae20143,0xdb00804a}},	//   _rese_, _dhib_, _šotr, _odmí,
   {{0x442eac3b,0x61e44bfc,0x3959c105,0x65760009}},	//   nif_, edil, üsse_, _egyh,
   {{0x799d0296,0x5333ec3c,0x9f41600e,0x6e2d4c3d}},	//   pasw, _нешт, rdhë_, tiab,
   {{0x2d9eec3e,0x0855412e,0x506744e4,0xb7bdc12a}},	//   late_, іваю, стга, tiţi,
   {{0xb87b0066,0x6e2e2c3f,0x53996052,0x66064c40}},	// [730] zvíj, bibb, ивая_, _dokk,
   {{0xdce3a6df,0x68ed0c41,0x2d816c42,0x6b9aa013}},	//   zanı, _irad, uche_, _netg,
   {{0x61e44c43,0x66064c44,0x3f8161cd,0xb5fb4c45}},	//   bdil, _fokk, rchu_, _chác,
   {{0x4cbbe00b,0x63a8a0e8,0x224b0030,0x3206c1e7}},	//   רמאג, _addn, nock_, _nooy_,
   {{0xbddb40f9,0x2bc66077,0x7c2ae8ef,0x2d9d8c46}},	//   _ajèg, र्हा, _omfr, rawe_,
   {{0xa3b6cc47,0x853ca03b,0x628d4c48,0x2d8320c2}},	//   _जाउ_, _idėj, mpao, ncje_,
   {{0x28dd437f,0xf991c13a,0x600a406f,0x661d000a}},	//   _नैति, وبة_, _týmt, khsk,
   {{0x99800c49,0x225f807d,0x0609cc4a,0x61e1ac4b}},	//   _omiš_, _uhuk_, рник_, _wall,
   {{0x1dc66c4c,0x27ffcc4d,0x66076022,0xe619ec4e}},	//   र्वत, rjun_, _kojk, иди_,
   {{0xdce3a3df,0x61e1a6f1,0x6b840ab8,0xf625e0ff}},	//   sanı, _uall, _sfig, ідно,
   {{0x6b9b817b,0x78602c4f,0x26dea1e7,0xc17400e8}},	//   _keug, növe, _gsto_, _haɗi_,
   {{0x2006c3be,0x7e7b8c50,0x644b8c51,0x799aa0d1}},	//   _gooi_, _kuup, nogi, _zetw,
   {{0x44382c52,0x41c2c077,0x60c44746,0xa9a5ebbf}},	//   tnr_, _वॉटस, xtim, _дилд,
   {{0x2d81e10a,0x442f8c53,0x66076143,0x78602009}},	//   _ühe_, hig_, _nojk, köve,
   {{0x7d036277,0x6b82810f,0x7aed0c54,0xe0df4031}},	//   änsl, ycog, _erat, _asò_,
   {{0x64470552,0x28dca292,0x44390090,0xdfd24049}},	//   čkic, _मनसि, cns_, بير_,
   {{0x644aac55,0x3207ec56,0x68e9c009,0x628d4c57}},	// [740] yofi, _kony_, nved, gpao,
   {{0xb05b667c,0xa3e220c5,0xb5fb4119,0x80d700c2}},	//   _spär, _नोच_, _phác, यबरे,
   {{0x62898a49,0xe7d9c028,0x6015c3ab,0xb4c7e10a}},	//   _ateo, ढ़ाप, _námo, _उहो_,
   {{0x6b9aac58,0x46ea8c59,0x6d5e2c5a,0x76a061e9}},	//   _setg, иден_, _izpa, _aáyá,
   {{0x442a6c5b,0x764140e0,0x92e6a07c,0x91a6c0f9}},	//   _tmb_, élye, _পথে_, _ajo̟_,
   {{0x2cb240e2,0xee37a056,0x78a28c5c,0x63a98c5d}},	//   mryd_, онч_, rsov, _eden,
   {{0x6d5c6c5e,0x644b8733,0x44390c5f,0x6aa28c60}},	//   _uzra, bogi, yns_, ssof,
   {{0x2bc66c61,0xddc9812a,0x799c6c62,0x6b844c63}},	//   र्रा, _vieţ, _herw, ncig,
   {{0xc17401df,0xb4c9010a,0x81cfa07c,0xdb076030}},	//   _faɗi_, _ईहे_, ষয়_, _adjè,
   {{0x7e7c6c64,0x2007ec65,0x136aec66,0x68ed000e}},	//   _kurp, _coni_, ишни_, _rrad,
   {{0xb97b61a9,0x25a90057,0x61e2c466,0x7ae9c024}},	//   יניי, _pdal_, _taol, avet,
   {{0xa2cd6c67,0x7c3e2b0c,0x2007e030,0x81c261a6}},	//   _सहस्, _ajpr, _eoni_, ্যি_,
   {{0x7336c0e0,0x2ee00057,0x7ae9c993,0x2eed80ae}},	//   _برائ, _csif_, cvet, _xref_,
   {{0x60c56c68,0x7c2f0c69,0xdfcfe049,0x27e68052}},	//   ythm, sicr, _ليه_, hdon_,
   {{0xdce5603c,0x644b8c6a,0x3a2ca071,0x443ea197}},	//   yahı, yogi, _mmdp_, _mjt_,
   {{0x7afce10a,0xbddb40f9,0x09acc07c,0x7bda20fa}},	//   ärtu, _akèr, ক্রা, ôtur,
   {{0xd37b6c6b,0x61e3e3df,0xb4e54290,0x40352a18}},	// [750] аче_, _yanl, पटे_, _неис,
   {{0xd25160b7,0x3eb820cb,0x628d4c6c,0x51f865d0}},	//   رنا_, burt_, rpao, оную_,
   {{0x4cd3c07c,0x799c6c6d,0x644b8c6e,0x59c42029}},	//   তিযু, _derw, togi, _लॉटर,
   {{0x69caa09a,0x245c80c4,0x6015c803,0x7bce6035}},	//   effe, tíma_, _rámo, _ebbu,
   {{0x25aa6098,0x7ccc6041,0x387ce143,0x3eb90046}},	//   _fdbl_, vērš, _luvr_, nust_,
   {{0x38694c6f,0x799d4561,0xfc04a0ff,0xab5b0105}},	//   lmar_, _hesw, мпіо, rfüh,
   {{0xab5b0669,0x439589fd,0x5ba78af5,0x442cac70}},	//   sfüh, _навс, _мраз, _dmd_,
   {{0x13e4207c,0x7ae9c00e,0x68e9c018,0x2eed8c71}},	//   মায়, tvet, tved, _tref_,
   {{0x2be0804b,0x6d46e106,0x7bc9cc72,0x3a2d80d5}},	//   _नसता, şkal, rfeu, _imep_,
   {{0x80d22405,0x6015c0e0,0x7bd8a1e1,0x68e9cc73}},	//   হিত্, _támo, cevu, rved,
   {{0x68e9cc74,0x59cb44ba,0xe945c8b5,0x81bd61a6}},	//   sved, ाभार, _کرای, _আসা_,
   {{0xe61f602e,0xb33b45fc,0x7ae9c009,0x799d4c75}},	//   _stôl_, _keçd, pvet, _nesw,
   {{0x3eb90c76,0x644d4108,0xdb1c23f5,0x8d5601ba}},	//   gust_, doai, nerö, яточ,
   {{0xfc3f42a8,0xa06a20fb,0x25a04561,0x2d9dc229}},	//   _ají_, сага_, wail_, _hewe_,
   {{0xe3b2013a,0x799d4c77,0x99fae076,0x64436089}},	//   _كرة_, _besw, _לפספ, čnil,
   {{0xbc764049,0xe73720ba,0xac864c78,0x2618cc79}},	//   كهرب, чес_, згал, _léon_,
   {{0x934341fc,0x6b844054,0x55bb0076,0x2bdca026}},	// [760] енте, rcig, _המפו, _यसला,
   {{0x224dcc7a,0x2d85ec7b,0xb904455d,0x2d9ce005}},	//   hoek_, ncle_, _भई_, _xeve_,
   {{0x248b405d,0x64414c7c,0xa3c9410a,0xa5bb41e9}},	//   _etcm_, élic, ल्ह_, _amóu,
   {{0x7c2d0c7d,0x69c1a090,0x38694057,0x7bc1ac7e}},	//   _xmar, _acle, cmar_, _aclu,
   {{0x1e83412e,0x66098b83,0x6e3bc143,0x7ded0053}},	//   _плям, _doek, dnub, יקאַ,
   {{0xf8b020e3,0x3fe6e07c,0x69caac7f,0x78a244d2}},	//   _जटाय, _পক্ষ, uffe, šovs,
   {{0x69caa0e2,0x2bc2e8ae,0x877b200b,0x27e68c80}},	//   rffe, _शाबा, זאצי, pdon_,
   {{0xb2268c81,0xbb3b61a9,0xdb1c2c82,0xb5fb0c83}},	//   _эмбл, _העלי, berö, rmák,
   {{0x0ef4e20b,0x8c4381e1,0x0c26ac84,0x764e206f}},	//   इम्स_, _чете, _еман, koby,
   {{0x63a0c069,0x9f516071,0x7c42c143,0x3f868005}},	//   samn, _gozó_, _štrč, lcou_,
   {{0x44312c85,0x61e64c86,0x61e5207f,0x6fc16c87}},	//   viz_, _oakl, _rahl, र्टू,
   {{0x201ee00e,0x2d868030,0xa5bb4071,0x60126069}},	//   shti_, ncoe_, _ilóg, _dæmi,
   {{0x78a60708,0x0cd7407c,0x5e25c0e0,0xfc3f21af}},	//   gskv, _সপ্ত, _تعلق, esía_,
   {{0xb5fb4c88,0x67244c89,0x644e2c8a,0xe8d90125}},	//   _chán, dzij, gobi, _uzọ_,
   {{0xe1ff4119,0x644d4c8b,0x69d980ce,0x764d4c8c}},	//   _nhóc_, toai, yewe, toay,
   {{0x6443606e,0x2d9eac8d,0xc299439e,0x9c7ca066}},	//   čnim, _lete_, жках_, _urču,
   {{0x644e21df,0x61e52c8e,0x25a16c8f,0x660983c5}},	// [770] bobi, _tahl, tahl_, _roek,
   {{0x661b809a,0x69daec90,0x2ca6808b,0xfc3f203e}},	//   _sluk, nete, dsod_, rrís_,
   {{0x6e3d01dc,0x69d981cf,0xf4852555,0x44204c91}},	//   onsb, tewe, _تاخی, bhi_,
   {{0x7e7d4098,0xf1bf0c92,0x7ae2cc93,0xa3dd0046}},	//   _tusp, ngá_, _osot, ड़ि_,
   {{0x601f00dd,0x3f9ea012,0x661d4156,0x69cb8c94}},	//   _këmb, _betu_, _ilsk, rfge,
   {{0xe3b8a03c,0x69cd41cd,0x7bdaec95,0x6ecaa5fc}},	//   _alıb_, lfae, jetu, _təbl,
   {{0x63a28c96,0x27e6c5c8,0xa4d460ff,0x7ae2cc97}},	//   baon, _baon_, _порі, _asot,
   {{0x63a282d9,0x61f8e061,0x3e642156,0x443f8c98}},	//   caon, _anvl, möte_, _uju_,
   {{0x27e94577,0xf99f4b16,0xc17400e8,0x8ca9aa53}},	//   idan_, _blèz_, _yaɗu_, _टिको,
   {{0xc87f4105,0x248d8c99,0xbebb000e,0x7e640095}},	//   _muß_, _item_, tzën, _ship,
   {{0x6d452022,0xa3c8c029,0x186a00de,0x4d65e0ff}},	//   _nxha, _लॉक_, жани_, ьков,
   {{0xe4d4a0e0,0x2d9ea361,0x443245dd,0xf0926053}},	//   _ستمب, _zete_, xiy_, כנט_,
   {{0x7bdaec9a,0x3ea0ac9b,0xe44eec9c,0xe29705be}},	//   betu, ćite_, _аж_, мая_,
   {{0x7bdaec9d,0xe45f2052,0x60c9cc9e,0x0478e0eb}},	//   cetu, stön_, mtem, _کليک_,
   {{0x4252e0e0,0x200a6c9f,0x764e2ca0,0x248d80ae}},	//   _جنور, _robi_, roby, _ltem_,
   {{0x6d440ca1,0xdb1c2ca2,0xdb1b827f,0x63ad0ca3}},	//   _txia, ngré, _acuí, _gdan,
   {{0xa5bb403e,0xed57401b,0x037a2062,0x6b6720fa}},	// [780] _amós, дот_, _وحدت_, tégé,
   {{0x63ad0ca4,0x27e7e030,0x8d634052,0x2ca6806e}},	//   _zdan, _jann_, твуе, vsod_,
   {{0xa2a40046,0x9f42c03a,0xd9462874,0x661e217b}},	//   _कबड्, ľké_, _цени, _ilpk,
   {{0x2d9eaca5,0x7bdc2ca6,0x6441a143,0xf77f41ae}},	//   _sete_, leru, _ajli, _taça_,
   {{0x25a0010a,0xd6d08ca7,0x3f8689fe,0x69daeca8}},	//   _meil_, اقت_, rcou_, yete,
   {{0xb21b6065,0x3eaf022e,0xdce8a06f,0x69dae0b8}},	//   _stæv, _ægte_, _vedľ, xete,
   {{0xa6e1e069,0x7bdc20ba,0x291d20e8,0xa3be0ca9}},	//   óðle, ieru, _ƙwai_, आला_,
   {{0xd257c7b9,0x68206156,0x9f45a163,0x27e7e153}},	//   мцы_, _döde, _malè_, _aann_,
   {{0x442eecaa,0x3f9ea012,0x7c228cab,0xd6dac0ff}},	//   _pmf_, _tetu_, mhor, іти_,
   {{0x27e94cac,0xb463aa34,0x6015c13a,0x3958c041}},	//   zdan_, _акул, _lámh, ārs_,
   {{0x7a206cad,0x7aed486f,0x7ccaa497,0x260228c6}},	//   _göte, zvat, _mərk, शानी_,
   {{0x200cacae,0x442fc425,0x27e94caf,0x320ca089}},	//   _hodi_, _gmg_, xdan_, _hody_,
   {{0x63a08106,0x27e94cb0,0xd90fc0e0,0xc8c8c0eb}},	//   _memn, vdan_, _نیٹ_, _روغن_,
   {{0xdb1c6912,0xdce2ccb1,0xb8d70466,0x9f45a2f4}},	//   _acrí, _ugođ, _चट_, _balè_,
   {{0x25a000ff,0x3866c05d,0x200b4011,0x69cbccb2}},	//   _feil_, _khor_, _poci_, थ्वी,
   {{0xa5bb40f9,0xa3cb0180,0x60102105,0x9f45a0f9}},	//   _amór, र्श_, _sämt, _dalè_,
   {{0x80a02010,0x61faa23c,0x046727f3,0x7c228cb3}},	// [790] गीबे, _ontl, _отом, dhor,
   {{0x27e94cb4,0xa3cb0cb5,0x7865c01f,0x7bdd0cb6}},	//   sdan_, र्र_, móve, lesu,
   {{0x7a3605f9,0x645aecb7,0xdb1bc019,0x61e76cb8}},	//   lšta, ilti, rgué, _vajl,
   {{0xa29460ff,0xdb1c6049,0x387f8cb9,0x7c228147}},	//   таці, _gcrí, _puur_, ghor,
   {{0x7e6d4cba,0x61e9ccbb,0x7ae400ae,0x3e61c0c4}},	//   mmap, vdel, _xsit, jóta_,
   {{0x200cacbc,0xd366e047,0x7e6d4cbd,0x81d3007c}},	//   _codi_, _مه_, lmap, _হোম_,
   {{0xdb03a00e,0x38794143,0x7bdd0469,0x69dbc105}},	//   manë, _kisr_, kesu, teue,
   {{0xee3f0326,0x7a36003b,0x3ebe6277,0xaca38088}},	//   jný_, kšta, _åtta_, _arụn,
   {{0x3ea94cbe,0x973cecbf,0x3dcdc1e2,0x7bc52066}},	//   nsat_, vaća, rfew_, _ochu,
   {{0x63a3acc0,0x63a08cc1,0x200ca1cd,0x7bc40cc2}},	//   qann, _zemn, _godi_, _sciu,
   {{0x62808071,0x69c4a909,0xe9ffc067,0x81bca041}},	//   _zumo, _राती, _ngầm_, _slēg,
   {{0xdb040005,0x660d0037,0x7bc52cc3,0x69dc2cc4}},	//   _adiá, _coak, _achu, were,
   {{0xb5fb42b2,0xd378e29f,0x6281acc5,0x9f9d0069}},	//   _chám, veće_, _hulo, ræði_,
   {{0x201e2cc6,0x7d04804e,0xa3cf6029,0x20190052}},	//   óti_, äisi, _वॉल_, aksi_,
   {{0x9f45acc7,0x7e5601b1,0x63a1a041,0x60102156}},	//   _balé_, _птиц, _meln, _säms,
   {{0xee3f0066,0x09e34cc8,0xd00740de,0x3c3ac041}},	//   cný_, лосн, несе_, tīvi_,
   {{0x5275412a,0xd54740ba,0xb907253a,0x671fc37f}},	// [7a0] туру, епте_, _मै_, यनिक_,
   {{0x44200223,0x25a5e00c,0x386dc105,0xaf9a204e}},	//   _hli_, nall_, hmer_, _этих_,
   {{0x62808cc9,0x6b964193,0x7c228095,0x320ca153}},	//   _sumo, pbyg, thor, _rody_,
   {{0x5ab7200b,0x78a9ccca,0x1a9ae00b,0x6fc2604b}},	//   _אלטע_, ksev, פינע, _लावू,
   {{0x61e8accb,0x386dcccc,0x25a5eccd,0x69c64944}},	//   _padl, dmer_, kall_, _icke,
   {{0xfc3f0026,0x7d0ee065,0x386dc06f,0x25a5ecce}},	//   zní_, øbsk, emer_, jall_,
   {{0xf1d22893,0x63a324ef,0x63a08ccf,0x50436cd0}},	//   द्यन, _õnne, _temn, _серб,
   {{0xaa0d2026,0x2a66c022,0x61e8a10e,0x81d4207c}},	//   _सक्छ_, _qhob_, _wadl, _সোম_,
   {{0x6281acd1,0x63a1acd2,0x69c0ccd3,0x1c46a242}},	//   _eulo, _feln, rgme, _знам,
   {{0xf3ff4067,0x69c283c5,0xb05b29f6,0x3a200cd4}},	//   _nhãn_, lgoe, ltäv, _alip_,
   {{0x6281acd5,0xa3dd04ef,0x7bdd0cd6,0x69c64944}},	//   _gulo, ड़ल_, tesu, _ocke,
   {{0x78bd02df,0x63a56cd7,0x69c28cd8,0x7bc1e022}},	//   tusv, zahn, ngoe, aglu,
   {{0xee3f6026,0x6281a534,0xf1d00119,0x44200153}},	//   _svým_, _zulo, _tạng_, _dli_,
   {{0x9325c009,0x7e7d8cd9,0xdb02c1ae,0x7a360013}},	//   _جرمن, _èspe, _adoç, ršta,
   {{0x6281a0d5,0x7bdd02df,0x22aca04a,0x656400bb}},	//   _xulo, pesu, něk_, _ezih,
   {{0x3a200cda,0x443160ce,0xb4e12738,0x2ca94cdb}},	//   _glip_, _smz_, _धनी_, tsad_,
   {{0xe803a026,0xe8df8125,0x645560ae,0xdb01e3ab}},	// [7b0] लामा_, _kwụa_, _pkzi, valé,
   {{0x765d0cdc,0x4ea76cdd,0xda7b2cde,0x3ea94cdf}},	//   llsy, ерда, _ням_, rsat_,
   {{0x2a69005f,0x44212098,0xdd91813a,0x6ad98010}},	//   _khab_, _ilh_, لوا_, णब्र,
   {{0x9f5fc069,0x6015c005,0xa3bb43e6,0x386900a2}},	//   kkuð_, _támi, _घाट_, _jhar_,
   {{0x1dd305c5,0x66e58407,0x61ed4ce0,0x7dd3a121}},	//   ध्यत, тола, mdal, yısı,
   {{0x21294ce1,0xa136400b,0xa3d2e010,0x61ed4ce2}},	//   mzah_, _יארק_, ह्म_, ldal,
   {{0x92e8a049,0x24590066,0x63a1ab8e,0x38690534}},	//   فريق_, lému_, _veln, _ohar_,
   {{0x7bc1e022,0x7ccaa5fc,0xdb03a530,0xcec188fd}},	//   wglu, _xəri, nané, _pięć_,
   {{0x7989cce3,0x9f47e00e,0x63a7200a,0x21294037}},	//   rcew, _tanë_, kajn, nzah_,
   {{0x61ed4052,0x2129405d,0x69c1ece4,0x6b89c024}},	//   hdal, izah_, ugle, sceg,
   {{0xf745e5a8,0x7dd3a20f,0x60cd41dd,0x26388098}},	//   тено, rısı, htam, mčor_,
   {{0x44332ce5,0x9a84a1fc,0x22404746,0x2374a0a4}},	//   _amx_, _суфл, xnik_, _صالح,
   {{0xdb064089,0x9f47ec1e,0x60cd4ce6,0x38690ce7}},	//   _odká, _mané_, jtam, _dhar_,
   {{0x61fd44f0,0x7bc3ace8,0x3ebee13e,0x3cfe6057}},	//   _ansl, ngnu, butt_, _átvg_,
   {{0xf3ff401f,0x60102097,0x660f4149,0xf09f41e9}},	//   _chão_, _dämp, _bock, _awà_,
   {{0x26cdc504,0x200fc0e0,0x44320037,0x7e7b8007}},	//   oteo_, _jogi_, _umy_, _niup,
   {{0x6e244ce9,0x63a3ecea,0xa0a64013,0x25a3604d}},	// [7c0] rhib, _kenn, тазд, _bejl_,
   {{0xdb1d4057,0x61eae054,0x61ed4ceb,0x61ebc68f}},	//   _absó, _xafl, adal, _lagl,
   {{0x7bde6cec,0x6ecaa03c,0x62840ced,0x61fe2cee}},	//   repu, _təbi, _huio, _inpl,
   {{0xdb1c2966,0x6441e105,0x22aca026,0x7e7b812a}},	//   ngrí, hnli, věk_, _ciup,
   {{0x25a36a2f,0x27e04cef,0x6272e064,0x6283ecf0}},	//   _fejl_, mein_, _głow, _luno,
   {{0xdb04001b,0x27edccf1,0x63a2ccf2,0x7ae4449e}},	//   _ediç, eden_, _seon, mwit,
   {{0x29182cf3,0x64a360fb,0x7a3ec041,0x2d800cf4}},	//   nyra_, _васа, līti, _ogie_,
   {{0x3ce6ccf5,0x7e7b8114,0x6cedc79e,0x200fc071}},	//   _psov_, _giup, जिंग_, _cogi_,
   {{0x63a3ecf6,0xdb20ecf7,0x6283e509,0x62836066}},	//   _benn, _àtún, _auno, ínov,
   {{0xdb008cf8,0xae056893,0x49baa01c,0x27e04cf9}},	//   _remè, रायन_, _زائد_, hein_,
   {{0x33294227,0x2a69005f,0x21bb6095,0x539ba3c8}},	//   zzax_, _phab_, וזיא, _חיבו,
   {{0xd6d2c4aa,0xe7b48046,0x3ebfccfa,0x3ce6c286}},	//   _نقص_, ुलिप, buut_, _tsov_,
   {{0x26da207d,0xe8056026,0x2246c0c7,0x23c9a4ba}},	//   _appo_, रामा_, _ijok_, _रामद,
   {{0x68f600fd,0x3ebee0cb,0x7a3ec018,0x4425ecfb}},	//   _dryd, putt_, dīti, chl_,
   {{0x55582691,0x03c74362,0xc27be087,0x9f412cfc}},	//   варя_, ксам, _קרוי, _bahá_,
   {{0x6b8081e7,0xd838ecfd,0x27e04cfe,0xe3c9c057}},	//   _ngmg, lič_, gein_, mañá_,
   {{0x44212345,0x32094037,0x245c8066,0x394980c2}},	// [7d0] _tlh_, rjay_, cími_, żasz_,
   {{0x9f448355,0x63a40108,0x2ee90cff,0x61ed488b}},	//   _camí_, _zein, _isaf_, sdal,
   {{0x9f436d00,0x7e7b8098,0x2d8123c9,0x6d5b817b}},	//   _tají_, _piup, _ighe_, _syua,
   {{0xbde5e0f9,0x644280fa,0x28ac4d01,0x3a2681e7}},	//   _abẹ̀, gnoi, _चिचि, ghop_,
   {{0x6d4ec105,0x61ebc1cd,0x7e7d4d02,0xd838e07f}},	//   ßbal, _ragl, _iisp, kič_,
   {{0xe8d90125,0x25a94054,0x64552d03,0x251c0087}},	//   _ayị_, laal_, nozi, וודא,
   {{0x200fc561,0x78ad4cde,0x4993c050,0x442681fb}},	//   _pogi_, lsav, لیار, bho_,
   {{0x63ad8069,0x26cdcd04,0x317c2095,0x32cbc0ff}},	//   ðand, tteo_, ורומ, tøy_,
   {{0xd378e29f,0x34b2c13a,0x7d04804e,0xa7fce121}},	//   veća_, مميز, äist, klıd,
   {{0xf993a25b,0x661bcd05,0x27edcd06,0x63a8ed07}},	//   _ضبط_, skuk, sden_, gadn,
   {{0xe807238e,0x7c22c8cd,0x6d5d4d08,0x25a9421e}},	//   शाना_, _flor, _lysa, kaal_,
   {{0x6e22cd09,0x7e7d4d0a,0xaca34125,0x2604cd0b}},	//   _glob, _nisp, _akọc, वाणी_,
   {{0x6b9bcd0c,0xdcee2315,0x7643ad0d,0x63a3ed0e}},	//   mbug, vabı, onny, _tenn,
   {{0x395e0041,0x34b2c050,0x59c60010,0x60db8d0f}},	//   āts_, _اموز, _वावर, _mpum,
   {{0x6d5d424f,0x70d26033,0x2ee90079,0x28c6a8a2}},	//   _aysa, _सहेल, _esaf_, रूपि,
   {{0x61ed0ad5,0x69c98286,0x69c56d10,0x6e92e13a}},	//   _gaal, _ncee, eghe, _اليا,
   {{0xdb06059b,0x7ae98079,0x2604cd11,0xaca44125}},	// [7e0] kaké, _nset, वाती_, _otụt,
   {{0x26c20166,0x7ae44d12,0x7e7d4d13,0xaca44079}},	//   muko_, rwit, _eisp, _ntụt,
   {{0x68e98d14,0xe2976d15,0x60c1ed16,0x7d09000e}},	//   _ased, гах_, nulm, _tërë,
   {{0xc178203b,0x24976050,0x4426804a,0x225fcd17}},	//   žės_, انند_, uho_, jluk_,
   {{0xdb00cd18,0x3e4cc04a,0x26c20d19,0x69c600cb}},	//   tamí, něte_, nuko_, igke,
   {{0x25a5ad1a,0x6459c0b1,0x60c1ed1b,0x628641e7}},	//   _cell_, _akwi, kulm, _iuko,
   {{0x26c2049e,0x7c22cd1c,0x83fdc0e0,0x21676197}},	//   huko_, _plor, klőd, _бири_,
   {{0x6d5e2d1d,0x3a3a6851,0xb5fb413a,0x4422c0e0}},	//   _mypa, lipp_, _phái, ók_,
   {{0x57468423,0x81e7607c,0x610ae03c,0x64552c55}},	//   _снаб, ভার_, məli, yozi,
   {{0x6459cd1e,0xf1c6e026,0x26c20d1f,0x2000012a}},	//   _ekwi, _část_, duko_, _anii_,
   {{0xe457600b,0x32576095,0xb05b2156,0x7c240090}},	//   רייט_, רסים_, ktär, _blir,
   {{0x64a6ccde,0x443a6d20,0x44446d21,0x61e28d22}},	//   _бада, hip_, hn_, neol,
   {{0x68e9805d,0x25a94d23,0xddc9c106,0x64444401}},	//   _xsed, vaal_, lleş, dnii,
   {{0x8c43ed24,0x61ed0d25,0x7e7d40d1,0x3e414013}},	//   _лече, _waal, _sisp, mėti_,
   {{0xdddbc602,0x443a6d26,0xddc9c0b0,0x3e414013}},	//   nmuş, dip_, nleş, lėti_,
   {{0x201201df,0x43954099,0x60c28d27,0x26c20d28}},	//   _goyi_, раас, kuom, buko_,
   {{0x44446d29,0x3e41403b,0x76552064,0x6b82c167}},	// [7f0] fn_, nėti_, pozy, _mgog,
   {{0x25a94d2a,0x8574471b,0x47352d2b,0x6aad4d2c}},	//   saal_, слух, _внос, rsaf,
   {{0x7e7d4d2d,0xddc8a143,0x60db865a,0xe803a567}},	//   _tisp, _bidž, _spum, लासा_,
   {{0x5fc76010,0x7982cd2e,0x61e28d2f,0xceb3e0be}},	//   _लावल, _ngow, geol, מיע_,
   {{0x44294d30,0x25a5a507,0xb33b403c,0x60c1ed31}},	//   mha_, _pell_, _keçm, zulm,
   {{0x4424803c,0x443b4d32,0x6b82cd33,0x48b5a2a3}},	//   _elm_, liq_, _agog, ащит,
   {{0x25a5ad34,0xe8080026,0x442940a2,0x63a9cd35}},	//   _vell_, षामा_, oha_, taen,
   {{0xc888a13a,0x26c20d36,0xa802c315,0x0d85c662}},	//   دخول_, yuko_, şınm, шлин,
   {{0xd347c0eb,0xf1bf0049,0x7ae98d37,0x672d4d38}},	//   دیشه_, thán_, _uset, nzaj,
   {{0x225fcd39,0x391480ba,0x7c360232,0x8539e0a2}},	//   sluk_, _умур, _smyr, _haɗɗ,
   {{0x2cadc095,0x4425ad3a,0x9f5e6067,0x9f42c06f}},	//   ssed_, _ill_, _ôtô_, ľká_,
   {{0x44294d3b,0x6459c00f,0x63a76d3c,0x25a0e143}},	//   jha_, _ukwi, _lejn, _đile_,
   {{0xd90fe043,0xde05e0ff,0x7afb4cb1,0x59daa029}},	//   تیں_, _впли, _šutn, _मॉडर,
   {{0x387f8d3d,0x752d4098,0x6da32d3e,0x99832013}},	//   _liur_, dzaz, жира, dijų_,
   {{0x6286c05c,0x63a64d3f,0x443b4d40,0x61ee6d41}},	//   íkov, _pekn, fiq_, _rabl,
   {{0x6d5e2032,0x2249000e,0x26c20167,0x6abce0c4}},	//   _vypa, _gjak_, puko_, árfe,

   {{0x66e60d42,0x63a76d43,0x81c1607c,0xb0690343}},	// [800] _топа, _bejn, ্জন_, _حصول_,
   {{0x61ee6d44,0x386d8037,0x3c3f4052,0x3ead017a}},	//   _qabl, _aher_, tävä_, ġett_,
   {{0x38604017,0x443b45fc,0x78a26098,0xe6d4a3fa}},	//   plir_, biq_, ćovo, _दहेज,
   {{0xfbd2237f,0xdb03ed45,0xeaa7c049,0x44446d46}},	//   द्रम, _venè, _وع_, sn_,
   {{0x64460d47,0x8539e0a2,0xe809c870,0x44248012}},	//   inki, _daɗɗ, वाना_, _vlm_,
   {{0x61e28d48,0xdca34d49,0x60c2803b,0x4425a071}},	//   seol, _фари, ruom, _cll_,
   {{0x387ead4a,0xb87b61e9,0x68eda0c2,0xb7db63c8}},	//   _vitr_, _asíw, ładn, _שקלי,
   {{0xd90dc050,0x63aaa069,0xa3de65cb,0xb05b2d4b}},	//   کیه_, safn, ढ़क_, präg,
   {{0x44386d4c,0x390ac0fb,0xa3d6291c,0xd846ed4d}},	//   _kmr_, тэйн_, सभा_, ихоп,
   {{0x60de20ff,0x3eb8c06e,0x3e414013,0x24800090}},	//   _oppm, črt_, rėti_, _aiim_,
   {{0x201ee03b,0xb87b606f,0x7e6d0d4e,0x443cad4f}},	//   rkti_, _príz, _phap, miv_,
   {{0xd25800ff,0x7c3bc12a,0x2bc2e437,0xdb5ac052}},	//   иця_, ciur, _शाका, _июл_,
   {{0x3ea9a4ad,0x81ac607c,0x4aa6e35b,0x5e94c13a}},	//   ćate_, _গান_, _कौरव, _التط,
   {{0x20c96010,0x7c264614,0x7c3c2108,0x28b740c2}},	//   ांमध, _alkr, girr, ेंसि,
   {{0x44204d50,0x2ba74244,0x5fd78914,0x443b4d51}},	//   fki_, ијав, ण्डल, tiq_,
   {{0x60dd40c7,0x27e32d52,0x2249029c,0xe1ff4067}},	//   _ppsm, sejn_, _ujak_, _khói_,
   {{0xdb03a03a,0xa3cc06c6,0xf773c00b,0x6e3d0d53}},	// [810] vaní, _लात_, ַקע_, misb,
   {{0xdb03e005,0x7afaa194,0x3ec3e04a,0x6015cd54}},	//   _sené, _ortt, _ústí_, _lámp,
   {{0x6288a0e6,0xdb01a065,0x672d40c2,0xfb8741ba}},	//   _nudo, _udlø, szaj, _выгн,
   {{0x05962050,0x1dc9a010,0x442940f7,0x7e628d55}},	//   _پایگ, _राहत, qha_, glop,
   {{0xc29386b0,0x7c3bc017,0x68faad56,0x6eaa008d}},	//   زیاب, viur, _artd, जीपु,
   {{0x1ee760e0,0xe3b1a050,0x99824157,0x7c3d00ae}},	//   _پوری_, سرت_, _ankň_, hisr,
   {{0x81e9a07c,0x9f47e04a,0x4439470b,0x3d20e028}},	//   যাল_, _paní_, _kms_, मनों_,
   {{0x13aa854f,0x26c4cd57,0x1dc9a893,0x61e56d58}},	//   _منفی_, fumo_, _रावत, lehl,
   {{0x645d4037,0x6447212d,0x645980c2,0x34948d59}},	//   _mksi, knji, mowi, _матр,
   {{0x9f4c2326,0x6602cd5a,0x69cd0019,0x69c8e342}},	//   ždé_, _enok, _acae, ggde,
   {{0x44204d5b,0x7ccaa03c,0xa5bb40f9,0x68fb8066}},	//   yki_, _fərq, _alóm, _hrud,
   {{0x69d9c00f,0x24890153,0x765980c2,0x7aed0227}},	//   _ubwe, _buam_, nowy, _bsat,
   {{0xf8bf0004,0x3075e1c7,0xd6cee050,0x7c3c2d5c}},	//   gré_, _лукс, وقی_, tirr,
   {{0x69dde009,0xe3b8ed5d,0x656bc227,0x7afb8d5e}},	//   őseb, lkın_, _izgh, _mrut,
   {{0xab272d5f,0x68e9c0e2,0x25a90057,0x765980c2}},	//   бора_, lwed, _feal_, kowy,
   {{0x60c4404e,0x24890022,0x68fb8d60,0x25a9028f}},	//   tuim, _fuam_, _orud, _geal_,
   {{0x973ce29f,0x61e56105,0x76598064,0xf8bf0004}},	// [820] vaći, fehl, dowy, cré_,
   {{0xb4e40028,0x3b0a660c,0x3dc9408b,0x3a204d61}},	//   नबी_, лезо_, agaw_, skip_,
   {{0x9f4eed62,0x68e9c105,0x60c6048d,0xe804804b}},	//   _cafè_, hwed, lukm, ळाला_,
   {{0x443a208b,0xb346e1ae,0x98a0400a,0x24890223}},	//   _hmp_, leçõ, jzić_, _yuam_,
   {{0x7a23410a,0xdb01ad63,0xdb008d64,0x24890022}},	//   _mõtl, _delí, _temí, _xuam_,
   {{0x765c6d65,0x7e628d66,0x6288ad67,0xe4a6ad68}},	//   _ukry, slop, _pudo, брио,
   {{0x6f1d00c2,0x645e2088,0x7e6288da,0xd25ac0de}},	//   zysc, _mkpi, plop, лци_,
   {{0x3ebfc2a4,0xf2e88050,0x644722e2,0x26c4cd69}},	//   frut_, _نکته_, znji, tumo_,
   {{0x25a90d6a,0xf98fc13a,0x270ee03c,0x9f4ee0d1}},	//   _real_, ربي_, məni_, _zafè_,
   {{0x443a2037,0x6016e12a,0x63ad4035,0xba23aae2}},	//   _nmp_, _câmp, zaan, _едук,
   {{0x629c2d6b,0x25a9010a,0xeb97a076,0x64472098}},	//   jpro, _peal_, _הדבר_, vnji,
   {{0x2d912064,0xf8bf0d6c,0xc0cb0d6d,0x4427e071}},	//   wcze_, tré_, луге_, _eln_,
   {{0x629c2d53,0xe043cd6e,0xa805c019,0xdcfc613e}},	//   epro, _энци, señá, _ferħ,
   {{0x7a260d6f,0x629c29cd,0x69caa59c,0xdb03ad70}},	//   _vóta, fpro, ngfe, laná,
   {{0x644fe004,0xdc3be00b,0x3a22005d,0x61e60d71}},	//   écie, _געגר, bkkp_, bekl,
   {{0x7e644d72,0x68ed035f,0x9f5161de,0x44f8a119}},	//   glip, _tsad, _fazê_, _mĩ_,
   {{0x52156d73,0x4815687c,0xe8056010,0x764d0296}},	// [830] одат, омас, राला_, _ijay,
   {{0x7afc6037,0x6448ed74,0xb4e94d75,0xb5fb4d76}},	//   _brrt, nndi, _मनी_, _chár,
   {{0x44290aaa,0x7c2b8227,0xdb160030,0x6281a208}},	//   _kla_, thgr, _adyè, _rilo,
   {{0xa5f948c0,0xa2c0e37f,0x60c56058,0x7afc6037}},	//   _тему_, _विन्, ruhm, _drrt,
   {{0x63a98d77,0x6e954093,0xdcf5219f,0x9f47e2a8}},	//   _veen, _фигу, mazı, _maná_,
   {{0xe894454a,0x765980c2,0xd5bf4018,0x2c4cc04a}},	//   _харь, sowy, žādu_, věda_,
   {{0xec6b8471,0x442200ff,0x69c9c171,0xe299a03b}},	//   _брак_, ykk_, tgee, шай_,
   {{0x6e2d4d78,0xbb48613a,0x68e9c105,0x7ae9cd79}},	//   nhab, _الفن_, twed, twet,
   {{0x27e5e097,0x98a04927,0x786fe042,0x6e298d7a}},	//   teln_, rzić_, høve, _ileb,
   {{0xfe42e0ff,0x765aed7b,0x2ca9c17a,0x5ba9e63e}},	//   дньо, goty, _ħadd_, шком_,
   {{0x67d5c4a4,0xfc3f005c,0xf988a049,0x6e2d4d7c}},	//   _можу, fií_, _انمي_, khab,
   {{0x26c7ad7d,0x443eed7e,0x27e5ed7f,0xfc3f0066}},	//   muno_, ait_, seln_, gií_,
   {{0xb5fb00b5,0x9f51600e,0x26c5e11d,0x764d0d80}},	//   plán, _bazë_, sulo_, _djay,
   {{0x7bcf4d81,0x2249c0e4,0x4adda578,0x27f20054}},	//   _accu, čaku_, _महाव, _wayn_,
   {{0x186a0d82,0x6495a1f6,0xb346e1de,0x25eee04b}},	//   _каки_, _fġie, reçõ, _असती_,
   {{0x6283ed83,0xb4664a0e,0x628bcd84,0xccf2a095}},	//   _hino, ікал, _kugo, וכל_,
   {{0x25a04d85,0x27e7a0d1,0x94056029,0xd7c9a578}},	// [840] rbil_, kenn_, रांच_, _रांच,
   {{0x26c04d86,0xa3dc8437,0x55e364c2,0x6283e04a}},	//   rrio_, त्न_, моуб, _jino,
   {{0x765c2d87,0xae03ad88,0x78a76022,0xd46a44a7}},	//   mory, लाईन_, _cwjv, _вине_,
   {{0x7c2d4d89,0x2005ad8a,0x26c7a65f,0x7c3e6d8b}},	//   char, _anli_, duno_, sipr,
   {{0xdd94a0fb,0x27e68d8c,0x7649cd8d,0x6282c3c5}},	//   палы, reon_, dney, _rioo,
   {{0x27e7a090,0x236d8143,0x27e68d8e,0xdb044057}},	//   genn_, _dzej_, seon_, caiá,
   {{0x9f4cad8f,0x69caa149,0xe5c6cb2d,0xddcd47a0}},	//   _andò_, rgfe, оспо, lmaš,
   {{0x2900e0db,0x765c2d90,0x6283e04e,0x628bcd91}},	//   _čia_, hory, _aino, _bugo,
   {{0x27e7a157,0x6faa204b,0x212040c7,0x629e6052}},	//   benn_, करां, nyih_, lppo,
   {{0x6448e39a,0x68ed8d92,0x443ee153,0x6e2d41df}},	//   undi, çade, uit_, zhab,
   {{0x9354c043,0x442dcd93,0x59cf6447,0x1958e3fc}},	//   _کراچ, bhe_, स्टर, саны_,
   {{0x0dc7c73f,0x95c7c52f,0x261c42a8,0xe3b2c062}},	//   _души_, _душа_, _míos_, _آرا_,
   {{0x249a207d,0x81b6e07c,0x51840d94,0x4424c037}},	//   _atpm_, ঙ্গ_, дура, mkm_,
   {{0x442a65f2,0xc05b214f,0xddcd4d95,0x09b4e1a6}},	//   _nlb_, рім_, dmaš, জ্জা,
   {{0x6e2d4d96,0x973ca40c,0x539be1a9,0xb5fb0009}},	//   thab, _beći, _דיוו, llám,
   {{0x442a6d97,0xe8d90291,0xb5fb4066,0x682b203c}},	//   _alb_, _agụ_, _cháp, _büdc,
   {{0xfbd32d98,0x26022a53,0x8d872d99,0x6b8de5fc}},	// [850] _तापम, शाखी_, _мунд, _şagi,
   {{0x442dc00e,0x442a6016,0xf3676d9a,0xad9b41ae}},	//   zhe_, _clb_, отен, _inúm,
   {{0x60184005,0x161f079e,0xdb03a5fc,0x83988125}},	//   _tímp, _पवार_, manç, _ịhụg,
   {{0x155a2095,0x7afd44f3,0x68eda0c2,0x61e8e0ae}},	//   _לכתב, _trst, ładk, hedl,
   {{0x06fb08c6,0x62852d9b,0xdb008057,0x1b1d007c}},	//   एटिव_, _kiho, _pemá, _পেতে_,
   {{0xa3e20216,0x7e79600b,0x26c7a1cd,0x6618e20d}},	//   _नॉन_, _לאָז, tuno_, _novk,
   {{0x7aed4d9c,0x20194d9d,0x6283ed9e,0x44ed4c49}},	//   lwat, _kosi_, _rino, _hž_,
   {{0x63ad0d9f,0x7c298265,0xe6c4c0a9,0x7bcd4da0}},	//   _nean, _uler, _žešć, ngau,
   {{0xd706c04e,0x443ce071,0xf77f01ae,0x442ea098}},	//   зные_, _bmv_, deço_, bhf_,
   {{0xdb008065,0x80e1207c,0x63abc1b9,0x629b8561}},	//   _bemæ, _পছন্, _wegn, _ituo,
   {{0x3ea90da1,0x2ca90da2,0x443fcda3,0xab65e936}},	//   _awat_, _awad_, piu_, явол,
   {{0x7c2dc05c,0x3ea900d1,0xfaff40dd,0xdee60da4}},	//   ďars, _bwat_, _orë_, поми,
   {{0x62852da5,0x61e9cda6,0x644b8da7,0x2806e04a}},	//   _biho, meel, ingi, ávní_,
   {{0xeb972a92,0x6a65cda8,0x317ac095,0x5edae07c}},	//   зир_, dófi, _פרסמ, _বছরে,
   {{0x0e6a413a,0xa3bc8da9,0x20194daa,0x09b001a6}},	//   مصري_, _आयल_, _bosi_, _কাঠা,
   {{0x61e9cdab,0x3ebf064e,0x60d6404e,0x69dbc0ca}},	//   neel, šuta_, ttym, nfue,
   {{0x6e244dac,0x6adbedad,0xa2c34029,0x9f4ca066}},	// [860] rkib, _बहुर, िंग्, _radí_,
   {{0x261c4dae,0xddcd46a6,0x4efb0053,0x20186025}},	//   _píos_, rmaš, _פליג, _qori_,
   {{0x141b20be,0xa3aecdaf,0xdcf6420f,0x1ee860eb}},	//   _הויב, करम_, rayı, توای_,
   {{0x98a08db0,0x644b8cc5,0x26ca2d87,0x2242014f}},	//   šič_, gngi, mubo_, nikk_,
   {{0x61f60db1,0x261c413a,0x442a608b,0xa5bb41e9}},	//   _mayl, _fíor_, _tlb_, _alów,
   {{0xa8a6aa9d,0x7ae40d84,0xfec3c07c,0x30a6a60f}},	//   прик, _mpit, ্বাধ, прив,
   {{0x6440cdb2,0xb8668db3,0xe6a90982,0x3f8a6291}},	//   timi, _فارو, _कब्ज, _igbu_,
   {{0xa3d9edb4,0x61f60db5,0x289b20be,0x81e9a07c}},	//   ड्स_, _nayl, זיקא, যাগ_,
   {{0x44268db6,0xb8d3a960,0x6aa980e2,0x6618e022}},	//   mko_, _जौ_, _gwef, _povk,
   {{0x765e6db7,0x76b8e662,0x248ca17b,0x64428db8}},	//   nopy, олор_, _tudm_, lioi,
   {{0x29000db9,0x69dc2dba,0x69dae9cd,0xdb0f0359}},	//   _aria_, dfre, rfte, macé,
   {{0xdb03e1ae,0x62852dbb,0xae0284f6,0x29000030}},	//   _senã, _siho, _रोमन_, _bria_,
   {{0x62852dbc,0xe1ff0dbd,0x81c8207c,0x7641edbe}},	//   _piho, blón_, োজন_, bily,
   {{0x442ca0c7,0x27e942f8,0xa2c48a53,0xcf2ec20f}},	//   _jld_, wean_, _रिन्, ığım_,
   {{0x27e94dbf,0x63ad0dc0,0x78a924ad,0x5fc60010}},	//   tean_, _tean, ćevo, _वाचल,
   {{0x7a2a406f,0x3e720066,0x34dc8914,0x6a65cdc1}},	//   _pýta, táte_, _यहूद, tófi,
   {{0x20090dc2,0xd7670043,0xc1bc0095,0x68302277}},	// [870] _inai_, _ڈاکٹ, _המחש, _bädd,
   {{0x26cb0dc3,0x7ed40049,0x9c13c079,0x6d482049}},	//   muco_, _أزيا, _tọgh, údac,
   {{0x7afd0042,0x2019404e,0x60c446ac,0x68ed4dc4}},	//   lvst, _tosi_, arim, swad,
   {{0x7a2fa0ff,0xc95221a9,0x8d74633e,0x05746938}},	//   _møte, _ימי_, رالا, رالد,
   {{0x60c44dc5,0x443ea5fc,0xdb0ae057,0x6441edc6}},	//   crim, _bmt_, _defé, yili,
   {{0x7e62cdc7,0x628642a9,0x628f841a,0x443eadc8}},	//   _akop, _ziko, _écom, _cmt_,
   {{0x44268dc9,0x9f45e0fa,0xfbbf0567,0xf0f9a5cb}},	//   bko_, pelé_, ्लाम, ्मेद_,
   {{0x64428dca,0x9f47a06f,0xdb076026,0x63ae616d}},	//   cioi, nené_, _její, _zebn,
   {{0x7641edcb,0x61f606fa,0x9f5ea0d5,0x69dc20fd}},	//   tily, _rayl, _entà_, yfre,
   {{0x61e9cdcc,0x6619c037,0x4b25e0ff,0x68302052}},	//   seel, _wowk, дмов, _käde,
   {{0x442d8dcd,0x7641edce,0xa25b201b,0x443f8dcf}},	//   _kle_, rily, trôn, _kmu_,
   {{0x2bdd6260,0x9f47a05c,0xdb03edd0,0xa96a0dd1}},	//   न्ता, jené_, _cená, жима_,
   {{0x682b2dd2,0x2101623d,0x68302097,0xdb06407b}},	//   _süda, lčić_, _läde, _pekí,
   {{0x682fa042,0x26ca2644,0x3b0a204e,0x4427a17b}},	//   _føde, tubo_, оего_, nkn_,
   {{0x69dc2dd3,0x44268013,0x38694a88,0x1ddfa969}},	//   rfre, yko_, flar_, प्यत,
   {{0x6443add4,0x4427a13b,0x09e34a00,0x6e2d0018}},	//   hini, hkn_, косн, _glab,
   {{0x21674878,0x4427a17b,0x7e64072c,0x62864dd5}},	// [880] дити_, kkn_, _ikip, _viko,
   {{0x3ea048cc,0xb0dda918,0x38694dd6,0xf1bf4dd7}},	//   rpit_, _महंग, alar_, _lláh_,
   {{0x661b8163,0x26ca21fb,0x3ea04106,0x7e69cdd8}},	//   _bouk, qubo_, spit_, klep,
   {{0x442d8dd9,0x38694dda,0xf987c25b,0xddc1e06f}},	//   _cle_, clar_, _لب_, silň,
   {{0x9f404ddb,0xa3cc0ddc,0x63ae6022,0x661b80ca}},	//   rdió_, _लाई_, _tebn, _douk,
   {{0x2cb860a9,0x68ed81ae,0x66098ddd,0x798bc1b6}},	//   _tvrd_, çada, _enek, _aggw,
   {{0xc0e3a55a,0x4426849f,0x628e608b,0xdb83612a}},	//   војк, pko_, _uubo, _агри,
   {{0x661c6dde,0x29024ddf,0x38604de0,0xb6a3c119}},	//   _hork, _krka_, noir_, _thấ,
   {{0x6b63893b,0x67244132,0x01638de1,0x26c5ec48}},	//   _акта, nyij, _акто, erlo_,
   {{0x7e640167,0xdb03e066,0x443ea05d,0xdb052066}},	//   _akip, _sená, _umt_, _lehá,
   {{0x6e2060ba,0x661c6cde,0x9726a0eb,0xdb1aa0b8}},	//   _îmbu, _mork, _تفاو, _ectò,
   {{0x7874e017,0x64a6c03b,0x27e121e7,0x60e7c156}},	//   dàve, _жада, _sbhn_, örmå,
   {{0x09d7c1a6,0x63be20d5,0xd838c0ca,0xe667214f}},	//   _দোকা, _bdpn, _dwčt_, дтво,
   {{0x7d048052,0x3e6e802e,0xf99f4030,0x38694c8a}},	//   äisy, kýto_, _enèl_, wlar_,
   {{0xe8004033,0x9f47ade2,0xb5fb0049,0x3e45c018}},	//   _लोहा_, tené_, hlái, cēts_,
   {{0x4ea74244,0xc6a7490f,0xd6f2cafa,0xf1b98066}},	//   држа, држи, _अनाथ_, _koše_,
   {{0x9f47a03a,0x58844099,0x7a302de3,0x443f800a}},	// [890] rené_, тыра, _säte, _rmu_,
   {{0xdcfae3df,0x3869420f,0x356b6103,0x44272067}},	//   latı, slar_, орен_, _ôn_,
   {{0x26ccede4,0xd251454f,0xb5fd86a6,0x27f860fd}},	//   nudo_, _مند_, _akša, _darn_,
   {{0x60cb8d72,0x7870697a,0x682de057,0xdfa7413a}},	//   tugm, räva, _múda, _تحدي,
   {{0x442d8de5,0x4427a8a7,0x628761ae,0x6b8d0c57}},	//   _vle_, tkn_, _tijo, _mgag,
   {{0x6288ade6,0x661ce156,0xeb99ade7,0x9f42404a}},	//   _cido, örkl, чик_, _jaký_,
   {{0x69d724ef,0x694521e4,0x2489005d,0xdcfae315}},	//   _बानी, _učeć, _oiam_, katı,
   {{0xae09c077,0x442d8de8,0x3e746105,0x248fc05d}},	//   वाइन_, _ule_, räte_, _pugm_,
   {{0x7fd5e407,0x7d02c8e0,0xa3e58029,0x224dcde9}},	//   ніні, _cros, _बॉय_, rnek_,
   {{0x6f02c00c,0x6ec0e4e6,0x699fc1b0,0xb5fdc64e}},	//   _droc, _विशु, _ग्री, doše,
   {{0xe0460702,0xd24ec01c,0x60cd4dea,0xf99f4011}},	//   енни, شنی_, huam, _anèm_,
   {{0xc7b8adeb,0x661d47c6,0x3495c39d,0xc8692095}},	//   _vođe_, _nosk, _задр, _הן_,
   {{0xd12eedec,0x44294ded,0xad27c01e,0x7d02cdee}},	//   لمی_, dka_, _تراو, _gros,
   {{0x68260057,0x26cce4f8,0xb5fb0057,0x61e2c07f}},	//   _módi, budo_, toác, _zbol,
   {{0x64456054,0xb4ada4ef,0x2604c010,0x5884e1ba}},	//   dihi, _कबो_, वाची_, _рыца,
   {{0xd7dfa046,0x628980c2,0x61e2c17b,0x201ce0a9}},	//   प्तच, _nieo, _xbol, _zovi_,
   {{0x442fcdef,0x787601ae,0x6f03e066,0x69d6000f}},	// [8a0] _mlg_, gáve, _hrnc, _icye,
   {{0xd12f20e0,0xa3e58077,0x6b8d0df0,0x5efe8292}},	//   جمہ_, _बॉब_, _zgag, लिस्_,
   {{0xa68640d6,0xe1c9adf1,0x6288adf2,0xfeba2ca7}},	//   _плод, _राजघ, _rido, _عادت_,
   {{0x2bd2a010,0x4a9b200b,0x1e1ceaf7,0x7e61edf3}},	//   _साहा, _מיטג, _पक्ष_, holp,
   {{0x44f1a0db,0xa06aadf4,0x63b64054,0x67d4a677}},	//   _aš_, пада_, mayn, волу,
   {{0xf1b98098,0xdb03e121,0x7c29c3f3,0x78ada361}},	//   _roše_, _genç, eker, ćavn,
   {{0x8858cdf5,0x7e7e61e7,0x6abd00c2,0xed576df6}},	//   микс_, mmpp, _ऍट्र, _зор_,
   {{0xa3cc010a,0x64460df7,0xddcbe098,0xd90da050}},	//   _लाग_, jiki, _čiši, تیم_,
   {{0xd7faec84,0xe8056010,0x26cdc019,0x682ec153}},	//   пун_, राचा_, gueo_, _cùda,
   {{0xd010c043,0x61ed4df8,0x26c7adf9,0x2c86a031}},	//   الک_, zeal, brno_, _dídì_,
   {{0x44f1a00a,0x3a750dfa,0x24890286,0x3a376095}},	//   _gš_, клор, _piam_, גרים_,
   {{0x24890dfb,0xf1b980a9,0x64456dfc,0xadf4c5cb}},	//   _qiam_, _toše_, zihi, _आसिन_,
   {{0xdca3c0ff,0x201eadfd,0xdb0e607b,0x6fa6c6a8}},	//   _бачи, _koti_, _debé, _ट्यू,
   {{0xf9f1007c,0x63adedfe,0x442ee94b,0xa49b42d9}},	//   টাইল_, _đang, _ulf_, _bròn,
   {{0x64460dff,0xb5fdc86e,0x69c08e00,0xa49b4392}},	//   biki, soše, _odme, _cròn,
   {{0x7876001f,0xddcf8e01,0xbbcb4026,0x63b64e02}},	//   táve, _žeže, िलेक, gayn,
   {{0xf9c765ed,0xdb064066,0x9f42406f,0x6495a227}},	// [8b0] ещен, _peká, _taký_, _aġil,
   {{0x61ee2e03,0xddde2143,0xc058684f,0x61fd0e04}},	//   cebl, _tipš, ніх_, ldsl,
   {{0x628aee05,0x68260e06,0x533526bb,0xdcfc219f}},	//   _mifo, _sódi, _рент, barı,
   {{0x68ed8e07,0x64456e08,0xb6ba2076,0x68260530}},	//   çado, sihi, _קצרי, _pódi,
   {{0xdb0764cd,0xfd664088,0x68302046,0x61fd01b9}},	//   _dejá, _mkpị, _häda, idsl,
   {{0x69d56064,0x7642ce09,0xa5bb4e0a,0x290480a9}},	//   _ucze, _amoy, _glór, _drma_,
   {{0xa3d2a077,0xb3d2a010,0x9f42c03a,0xed156043}},	//   _वार_, _सारख, ľký_, _جہاں_,
   {{0x7e6d40e0,0x60dd0e0b,0x7e91a018,0x61fd0065}},	//   nlap, ktsm, _jāpi, jdsl,
   {{0x09e0c07c,0x3ea0e0e4,0x60dbc04e,0x3ce90286}},	//   _মোহা, _čita_, utum, _npav_,
   {{0xdb0f0e0c,0x7c2b8277,0x601ee04a,0x6441ae0d}},	//   gací, lkgr, _námě, _umli,
   {{0xf9926095,0x26cf8e0e,0x6515a711,0xe6c7a13a}},	//   ירי_, lugo_, _جوائ, _ستاي,
   {{0x60dd0e0f,0x9f47a06f,0x26c9420d,0x25a94089}},	//   ftsm, není_, krao_, jbal_,
   {{0xdb0f0e10,0x64460547,0xdcfc2181,0x628eee11}},	//   bací, riki, varı, íbor,
   {{0xb5fdc098,0xa0a30e12,0x628aee13,0xdb0f0019}},	//   bošc, рард, _gifo, cací,
   {{0x7e628194,0x60dd05dc,0xeb9725a8,0x1f592e14}},	//   yoop, atsm, тис_, ешть_,
   {{0x61ee231d,0xcfcaa07c,0xdb03e04e,0x61fb8e15}},	//   sebl, ল্পন, _venä, _naul,
   {{0x27e043ad,0x26c944ad,0x7e63ae16,0x27fd80e2}},	// [8c0] rfin_, grao_, konp, ddwn_,
   {{0xb69b401f,0x60c9c004,0xddc283de,0x69c1a0bb}},	//   _trân, irem, dloš, _ndle,
   {{0x2247a31d,0xdb098057,0xf767ca28,0x09b821a6}},	//   dink_, _odeó, _چا_, _জাপা,
   {{0xfbdf0016,0x69c1ae17,0x386dce18,0x61e92480}},	//   hiên_, _adle, jler_, đele,
   {{0xe8e228c6,0x61faae19,0x7ae98057,0xe2978e1a}},	//   _पहुच, _patl, _cpet, вач_,
   {{0xf99f42f8,0x6da3614f,0xfc3f207b,0x61faae1b}},	//   _anèh_, _вира, opía_, _qatl,
   {{0xa2c48c87,0x7a23410a,0xc6c3c07c,0x61e32106}},	//   _रिव्, _tõtt, ্বোচ, _önle,
   {{0xdcfd03cd,0x5186c5be,0xd7068967,0xaca42125}},	//   zası, купа, _изби, _akịt,
   {{0x9f4b04cd,0x7c2086f1,0x9f4fce1c,0xa686ae1d}},	//   pecé_, _iomr, _pagá_, _алад,
   {{0x386dc76d,0xe9df0049,0x7e6d4e1e,0x61e28e1f}},	//   aler_, giún_, zlap, lfol,
   {{0xa3d6210a,0x68314156,0x2c758156,0xdb0f0089}},	//   हलन_, _låda, låda_, rací,
   {{0x644724b7,0x8143c050,0xd36fa7f0,0x9f5200f9}},	//   wiji, اپیم, _بهم_, _bayà_,
   {{0x3ea68163,0x9f5862a8,0xecc7014a,0xdb152e20}},	//   npot_, _daré_, ъщно, mazé,
   {{0xf1b98143,0x61ef0e21,0x63b8a271,0x68302e22}},	//   _moša_, secl, navn, _päda,
   {{0x9f586017,0x8ccc8077,0xf487e0eb,0x35d88046}},	//   _faré_, _समझो, _شاهی, _डाढ़,
   {{0x660d0e23,0x64472e24,0x27fce271,0x63b8a271}},	//   _unak, siji, _havn_, havn,
   {{0x3d0d4064,0xd7d2a046,0xb5fdc041,0x44316e25}},	// [8d0] समें_, _सांच, noša, _plz_,
   {{0xdb00ce26,0x26deee27,0x26cf800f,0xb5fd8012}},	//   lamó, otto_, vugo_, _ekšl,
   {{0x4420007d,0x387fc5fc,0x6835c0c4,0xe0df0197}},	//   _yoi_, ymur_, _háde, ltò_,
   {{0x26d120c1,0x628d0e28,0x61e28271,0xb5fdc018}},	//   muzo_, _jiao, gfol, koša,
   {{0xb5fb00e0,0x27ef8584,0x22494a03,0x9f47a06f}},	//   llás, regn_, miak_, rení_,
   {{0x44332037,0x628bc106,0xdb08a64c,0x9f47a1ce}},	//   _jlx_, _sigo, _sedá, sení_,
   {{0x9f47a032,0x81b9007c,0x3cef808d,0xb7d5c1e9}},	//   pení_, _চান_, _इनके_, _aṣat,
   {{0x6e208e29,0x998fc03a,0xa3e324da,0xc1b9c13a}},	//   _gomb, ťaže_, फ्त_, رابط_,
   {{0x26dee65f,0x2906c005,0x7e698e2a,0x387fce2b}},	//   etto_, _croa_, _ikep, rmur_,
   {{0x6fd8e010,0x44212e2c,0x96d54c87,0x35b980c5}},	//   _माणू, _noh_, यूयॉ, _उजड़,
   {{0x9f586e2d,0x78a2ce2e,0x628bc0ca,0x06860926}},	//   _paré_, _etov, _tigo, лгон,
   {{0xfbdfa010,0x629a205c,0x23dfad0b,0x212948a7}},	//   प्रम, ítom, प्रद, kyah_,
   {{0x6e21ae2f,0x7c2d4e30,0x656bc05d,0x44f52026}},	//   _kolb, dkar, _uygh, _ať_,
   {{0x656d01e7,0xd040e03c,0x212948a7,0x27ffc265}},	//   _dyah, kumə, dyah_, ldun_,
   {{0xed572e31,0x69c3e026,0x69d8e010,0xa7fb0057}},	//   гор_, _idne, _माती, coño,
   {{0x44442e32,0xf1b9c320,0x44332733,0x7a314584}},	//   _wm_, naš_, _elx_, _påta,
   {{0xe09ec079,0xb5fb0009,0xfc3f2510,0x7e644071}},	// [8e0] _kọọ_, rlát, mpín_, roip,
   {{0x2907e88e,0x442dce33,0x629600ae,0xb5fb0e34}},	//   _krna_, hke_, _iuyo, slát,
   {{0xa56508b5,0xa3d2a046,0xa3baae35,0xdb07206f}},	//   _مدین, वलस_, _अजब_, zajú,
   {{0x68fce065,0xdbd740cb,0xb5fb0a7d,0xdb08a009}},	//   ærdi, mäßi, llár, _ülés,
   {{0x78520041,0x627c00c2,0x6d5fa5fc,0x2ca68114}},	//   tāvj, _głoś, şqal, upod_,
   {{0x61e28e36,0xf1b9804d,0xe09ec079,0x7c2e2b83}},	//   sfol, _voša_, _nọọ_, nkbr,
   {{0xe8070295,0xaa66ce37,0xaae6a343,0x787603e4}},	//   षयमा_, лтик, استو, záva,
   {{0x69c3e0fd,0x68260009,0x27f24e38,0x3b06ce39}},	//   _adne, _móds, neyn_, _proq_,
   {{0x2907ee3a,0x8fa6a7f3,0x049ec125,0x7c9ec079}},	//   _arna_, _базе, _bọọd_, _bọọl_,
   {{0xe29fc83e,0x7c2d4e3b,0x44224e3c,0xdb1645cd}},	//   íða_, zkar, _lok_, rayè,
   {{0x26c00e3d,0x656d0b2b,0x7d93a13a,0xf1b9c7a0}},	//   _avio_, _syah, _المؤ, baš_,
   {{0x6449c8aa,0x7d044944,0x3866831d,0xe29ace3e}},	//   ciei, kvis, noor_, _зад_,
   {{0xc5f3c095,0xd90f06b0,0x74c0e3af,0x2907ee3f}},	//   _לדף_, سید_, _विकृ, _erna_,
   {{0x7c2d4e40,0x961d8041,0xe0df0024,0x2a668286}},	//   wkar, _viņi, rtò_, hoob_,
   {{0x62982e41,0xa3e6a010,0x5334207a,0xdb0e289b}},	//   _évol, य्य_, берт, tabá,
   {{0x9f47a06f,0x62828022,0x682b25fc,0x26d12e42}},	//   nená_, jmoo, _müdi, ruzo_,
   {{0x644aae43,0xdb03a05c,0x61fd4e44,0x69d7c8c6}},	// [8f0] kifi, daný, _vasl, _यासी,
   {{0x69c4003a,0x63baee45,0x64464098,0x29090098}},	//   _zdie, natn, _emki, _iraa_,
   {{0xdb0bc0e0,0x7a36e0fa,0x1c0048b1,0xbcfb42f4}},	//   _megá, _gâte, _लोकल_, _ayét,
   {{0x68ed0058,0x7d044071,0x9f47a066,0x62828054}},	//   _kpad, bvis, jená_, gmoo,
   {{0x61ff0c43,0xb3ba4095,0xf8bf0e46,0xb87b62b2}},	//   _maql, _במרכ, nsé_, _osíx,
   {{0x1aebe07c,0xa3e7c914,0xdb0bc322,0xb5fdc098}},	//   টিতে_, म्न_, _negá, gošn,
   {{0x7c22ce47,0x6449c057,0x7876005c,0x6e21a026}},	//   _boor, tiei, dávn, _volb,
   {{0x6009ce48,0x2d9ee12a,0x9f45a017,0x248ee227}},	//   тним_, ecte_, _saló_, _aifm_,
   {{0x61e98e49,0xe739c926,0x2003c026,0x27ffce4a}},	//   _ibel, теп_, ěji_, rdun_,
   {{0x661bc342,0x1c45eadc,0x1309e04e,0xaae7a13a}},	//   sjuk, рном, вной_, _مسؤو,
   {{0x63ad4e4b,0x787880b6,0x78a409ce,0x9f47a05c}},	//   kban, líva, _stiv, bená_,
   {{0xb87b6005,0x62960e4c,0x764b84ec,0x6455265f}},	//   _esíx, _puyo, nigy, enzi,
   {{0xdb01ee4d,0xae004e4e,0xe8f70e4f,0x25adce50}},	//   taló, _लोगन_, аля_, mbel_,
   {{0x645dee51,0x63baee52,0x68384005,0xdb0f4e53}},	//   ésid, catn, _míde, _cecí,
   {{0x60cd45fb,0x7ae32277,0x2a7dc05f,0x6297203e}},	//   eram, _äntl, _khwb_, _cuxo,
   {{0x20116e54,0xaca38079,0x644b8b87,0x62960e55}},	//   _anzi_, _arọn, jigi, _tuyo,
   {{0x6aa4ce56,0x20120e57,0x87ba6052,0x3e7c8066}},	// [900] _çift, _inyi_, вует_, níte_,
   {{0x656f4e58,0x6283a16d,0x3ce04e59,0x7c23e2a8}},	//   _dych, jmno, rtiv_, _jonr,
   {{0x63bbce5a,0x2619a20b,0x44224e5b,0x1ddde46f}},	//   kaun, पानी_, _tok_, _मानत,
   {{0x63bbc041,0x09068474,0x91e68e5c,0x7d044e5d}},	//   jaun, ипен, роде, pvis,
   {{0x46f68892,0x38668e5e,0x63bbce5f,0xb5fdce60}},	//   рчет, roor_, daun, tošn,
   {{0xf2c6a312,0xd90d8555,0x7d098e61,0x69db8019}},	//   асин, عیل_, _dres, _ecue,
   {{0x6e22ce62,0xdb0bc066,0x26df8e63,0x27fea31b}},	//   _poob, _regá, _equo_, _vatn_,
   {{0xddcd46ca,0x4814ce64,0x644b8e65,0x4423605f}},	//   zmaž, смис, cigi, _zoj_,
   {{0x6e23ee66,0x26c040fd,0x2498617b,0xdca382d8}},	//   _bonb, nsio_, _hurm_, _мати,
   {{0x66028e67,0x91a6c0c2,0x212b0066,0xa3e7c1c9}},	//   ldok, _ट्रै, vych_, म्ब_,
   {{0x7bc64e68,0xde88e067,0xc914e07c,0x4ac2c010}},	//   _odku, _dịp_, ান্ত_, _शिकव,
   {{0x629800e4,0x26cdce69,0xe786c07a,0x3e720049}},	//   _čvor, breo_, _куло, náth_,
   {{0x63bc27e4,0xddc28064,0xdce08041,0xe1ff45df}},	//   farn, wnoś, _izmē, _raó_,
   {{0x644b8e6a,0x2bdde7b3,0x63bae227,0xf8bf0e6b}},	//   zigi, _माया, qatn, rsé_,
   {{0x87042691,0x645dee6c,0xc7b8a29c,0x61ff0e6d}},	//   ояте, ésie, _međ_, _taql,
   {{0x44f8a067,0x44c12013,0xdb0080cb,0x66008e6e}},	//   _mũ_, rė_, _bemü, _namk,
   {{0x7e6d0e6f,0xdb1ae00e,0x628f4e70,0x60cd45df}},	// [910] _ikap, katë, _vico, uram,
   {{0xa81460bc,0x44248e71,0x644b8e72,0x25e30870}},	//   одуш, _aom_, wigi, ट्री_,
   {{0x9f5ea00e,0xf09f4067,0x7cec2009,0xa7fce5fc}},	//   _datë_, _trào_, _vörö, nlıq,
   {{0x442360c2,0x66028e73,0x67282156,0xdb01a066}},	//   _woj_, gdok, ädje, _celý,
   {{0x7cec20e0,0x7e6d0167,0xee87665d,0xe8004e74}},	//   _törö, _mkap, _выво, _लोटा_,
   {{0x3e7c8032,0x44e28067,0x2ca5a057,0xe8df4067}},	//   víte_, _dư_, _ptld_, _chục_,
   {{0x7afc605d,0x2499417b,0x6283a16d,0x62834024}},	//   _gsrt, _husm_, rmno, _ènos,
   {{0x20012e75,0x5f0827a7,0xcf582694,0x764d48a4}},	//   _lahi_, हित्_, יבות_, niay,
   {{0x25adce76,0x9f5ea0d1,0x672d4e77,0x64498e78}},	//   rbel_, _latè_, nyaj, _imei,
   {{0x30e7a4a4,0x4424805f,0x644d4e79,0x645b8361}},	//   _відб, _zom_, hiai, _hjui,
   {{0x69d8e046,0x63bd0e7a,0x2c7200e0,0xa3bb87f4}},	//   _मारी, fasn, ládi_, _आजा_,
   {{0x6285658f,0xb995c13a,0x2bddc466,0x6e252090}},	//   hmho, _الإب, क्खू_, _aohb,
   {{0x644d4e7b,0x2bdcc55d,0x539ac095,0x53dc2870}},	//   diai, _याता, _עיסו, _बादश,
   {{0x07a32e7c,0x6495a361,0xdb0ae851,0xdb1980eb}},	//   зарн, _išib, _befä, gawé,
   {{0x9f95e10a,0x20012a88,0xb05b2156,0x7a2ec58f}},	//   _müük_, _dahi_, vrät, _bùth,
   {{0x7bc7673b,0x7aef4e7d,0x20120079,0x44e1a071}},	//   _adju, _bpct, _unyi_, ió_,
   {{0x25a04653,0x87b941d3,0x69c76320,0x14c840eb}},	// [920] rcil_, руст_, _bdje, شهای_,
   {{0x4425a9d1,0x44e08d8f,0xdb1600d1,0x60c92018}},	//   _nol_, vò_, _reyè, ņema,
   {{0x5f0625be,0x764d413b,0x657b8e7e,0x3a248e7f}},	//   _узна, biay, _azuh, _pomp_,
   {{0x44f8a067,0xaa7b6e80,0xb900646f,0xf1b98320}},	//   _rũ_, _spýt, _दम_, _ceš_,
   {{0xa2c2410a,0x27e68e81,0xc7b8a143,0x44e1a057}},	//   _लिट्, rfon_, _peđ_, eó_,
   {{0x3e36654f,0x6c36654f,0x44e08e82,0xdb01a0e0}},	//   _افسر, _افسا, rò_, _felü,
   {{0x66008e83,0x63b8ee84,0x28d80ba0,0x81c2807c}},	//   _tamk, _revn, भूति, ্ভব_,
   {{0x224dce85,0x3ea76e86,0x6e3bce87,0x4425ae88}},	//   giek_, ínte_, ghub, _eol_,
   {{0x4425a8c5,0x9f4940c4,0x9f4ce06f,0x7a2b2046}},	//   _fol_, ndað_, redí_, _kütt,
   {{0x3a25a1e7,0x26cac07f,0xd491a119,0xa3ca6a53}},	//   _golp_, čbo_, _gì_, ोलि_,
   {{0x290ae1ae,0xe3bf4057,0xdd90e25b,0x7a2b2e89}},	//   íba_, _loña_, بود_, _mütt,
   {{0x60c28e8a,0x3cf94295,0x63be6058,0x7ae44e8b}},	//   osom, _उनले_, hapn, ktit,
   {{0x6265c13a,0x629aae8c,0x66044e8d,0x648960e4}},	//   _بالق, _huto, ddik, _iživ,
   {{0x2348e050,0x2bdb0e8e,0x6458a451,0x68fce22e}},	//   _پستی_, _भावा, nnvi, ærds,
   {{0x63a2865f,0x4877413a,0x68e44e8f,0x25e102b4}},	//   kcon, مدرس, etid, _कापी_,
   {{0x6299c037,0x44386090,0x3179c0c2,0x3a26c363}},	//   _yuwo, _alr_, ższe_, _joop_,
   {{0x7878882d,0x7ae4492d,0x91b962f0,0xe3bf407b}},	// [930] tívn, gtit, игат_, _coña_,
   {{0x44386e90,0xaca4c079,0x63be6d3d,0x44e1ae91}},	//   _clr_, _adịz, gapn, yó_,
   {{0xdce8a026,0xdb0f407b,0xa195427c,0x44204e92}},	//   _vzdě, _decá, _манч, bji_,
   {{0x4426ce93,0x6601ae94,0x33758e95,0x644f0e96}},	//   _noo_, _salk, огер, nici,
   {{0x7d032e97,0xcee88553,0x290b40ba,0x25bd8c8a}},	//   bírá, مرون_, _urca_, rawl_,
   {{0xbcfb4004,0xdb1ae4b7,0x224dc0c2,0x2486806f}},	//   _exéc, patè, wiek_, amom_,
   {{0x7c3bce98,0x44394e99,0x02a2e088,0x6299ce9a}},	//   thur, _kls_, _blọọ, _suwo,
   {{0x69c8a11d,0x2617620b,0xddd4e23d,0xed1580e0}},	//   _edde, नावी_, _čaši, _وہاں_,
   {{0xc0528087,0x7c3bce9b,0x6f0d0125,0x7c43c274}},	//   _חזן_, rhur, _nrac, _ćurč,
   {{0x44e1ae9c,0x26c20015,0x752f0064,0xb95b41e9}},	//   pó_, vsko_, dycz, _adìk,
   {{0x6e276e9d,0x26c200c2,0x35d320c2,0xbb55a0eb}},	//   _mojb, wsko_, _ताज़, _بناب,
   {{0x02a2e125,0x7d0dc057,0x7bdae05f,0x7b206274}},	//   _glọọ, _áaso, agtu, _ušuš,
   {{0x63be613b,0xcd2bc711,0x3e560041,0xdb1c2050}},	//   yapn, _حسان_, nāti_, maré,
   {{0xb05b6277,0xdb08a03e,0xdb0d2066,0x80ca61a6}},	//   _svän, _redú, _škál, _রহস্,
   {{0xa2c24295,0x3ea90e9e,0x764e2e9f,0x20024e5a}},	//   _लिङ्, _etat_, riby, _paki_,
   {{0x6d054077,0xee374ea0,0x41aa427c,0x60c48ea1}},	//   रिंग_, онс_, рван_, šimi,
   {{0x7ae442a8,0x26c2cea2,0xec4a604e,0x9c26667b}},	// [940] utit, škov_, азал_, одад,
   {{0xf77226ec,0xb4ea4a53,0xb5fb40f9,0x7ae44ea3}},	//   _ياد_, _मही_, _ajád, rtit,
   {{0x442046e8,0x6f0d029f,0x9f586057,0xe8168010}},	//   pji_, _zrac, _bará_, णाला_,
   {{0x44e3e15a,0x2aaa80de,0x6d41e09f,0x629aaea4}},	//   iñ_, атко_, izla, _ruto,
   {{0x4427eea5,0x63bb8ea6,0x63ad84cd,0x60c2803b}},	//   _oon_, _deun, ñana, usom,
   {{0x20036ea7,0xbddb0162,0x63a44ea8,0x3af9400b}},	//   _gaji_, nièr, lcin, _פּרע,
   {{0x9f586ea9,0xd838a299,0x34b70d0b,0xd6d0a049}},	//   _fará_, _vlč_, _अब्द, رقة_,
   {{0x69dbceaa,0x3ae40eab,0x6d41e05d,0x69d60d0b}},	//   ggue, köp_, dzla, _भागी,
   {{0x25ebce4e,0x80c48029,0x7d09ceac,0x290d80ba}},	//   _अउरी_, _रिटे, gves, _grea_,
   {{0x63bc6654,0xdb1c2ead,0x3942000a,0x27f82eae}},	//   _jern, parè, dzks_, jern_,
   {{0xd25104b7,0x63bc6eaf,0x68e40eb0,0x6fdd6010}},	//   فند_, _mern, _aqid, _पासू,
   {{0x20068eb1,0x09b4c07c,0x29000037,0x32068c57}},	//   ndoi_, _টাকা, _bsia_, ndoy_,
   {{0xa5bb4057,0x5fba6026,0xb606c2e2,0x78adc066}},	//   _ilóx, इराल, rašć, čový,
   {{0x26c7603a,0x752f0064,0x7bdc2eb2,0x44fae1d3}},	//   ánok_, rycz, ggru, _tū_,
   {{0x43942eb3,0x29000eb4,0x2bdc2eb5,0x0dcb0eb6}},	//   дарс, _esia_, _बारा, _купи_,
   {{0x200368a4,0x63a44174,0x6fdd6010,0xafdb0042}},	//   _saji_, gcin, _पाहू, riøs,
   {{0xe04b2050,0x7d0d0eb7,0x629c6eb8,0x7aedeeb9}},	// [950] _نشده_, _uras, _auro, _ćati,
   {{0x9f4b44cd,0x26d82eba,0x69dc2ebb,0xf1b9800a}},	//   _sacó_, buro_, cgre, _tošk_,
   {{0xdb08e886,0x629c6133,0x5695604e,0x7c2284a4}},	//   madó, _curo, чает, fjor,
   {{0x6281a515,0x49082bc5,0xfad62095,0x8ccc6738}},	//   _shlo, हिरो_, _צורך_, _हिरो,
   {{0x24894ebc,0x200488c4,0x8c1a4095,0xf99081ac}},	//   mmam_, _dami_, _הורי, نبه_,
   {{0x35e145cb,0xdb08eebd,0x2be2604b,0xb5fdcebe}},	//   _फाड़, nadó, _पाया, pošk,
   {{0x61e9cebf,0x23984079,0xa49b40b8,0x25eca046}},	//   tfel, _ọji_, _eròt, _आउरी_,
   {{0x60c5600e,0x3b0d8037,0x787604d2,0x200481df}},	//   mshm, _treq_, rávk, _gami_,
   {{0xe8e0c016,0xed5986be,0x290ee0e8,0x98b24064}},	//   _đợi_, _beže_, _arfa_, rzyć_,
   {{0x6281aec0,0x7a302105,0x69dbc07b,0x7c298b9c}},	//   _uhlo, _täti, sgue, _hoer,
   {{0xbddb0004,0xdb03e057,0x200480bb,0x629c6928}},	//   vièr, _renó, _yami_, _xuro,
   {{0x6aaae07c,0xc0492095,0x2cadcec1,0x63bd4c8e}},	//   _কিশো, _גז_, pped_, _nesn,
   {{0x7c2987ff,0x02dbab27,0x69cbc0ae,0x443ee256}},	//   _moer, _यमुन, _idge, bht_,
   {{0x60c560dd,0xd945eec2,0x386dc110,0xfbd3e0d0}},	//   kshm, _нели, loer_, _آتش_,
   {{0x290fc058,0x6e3b8ec3,0x638327a8,0x63bd4ec4}},	//   _hrga_, _olub, егра, _besn,
   {{0x26d90ec5,0xba234331,0x9f4b2009,0x27f82ec6}},	//   buso_, ндск, áját_, sern_,
   {{0x60c560dd,0xe29f4069,0x9989400a,0xb146462a}},	// [960] eshm, _yrði_, tkaš_, чнал,
   {{0xaf9a621a,0x320485cf,0x6296063f,0xdb1aa00e}},	//   стах_, _samy_, _hiyo, _qetë,
   {{0x6e3b8885,0x99894274,0x69c0cec7,0x0404a07c}},	//   _blub, rkaš_, yame, লামী_,
   {{0x63bd4ec8,0x2611a290,0x7c3b8907,0x6e28a06e}},	//   _gesn, _धोबी_, _clur, _sodb,
   {{0x62960ec9,0x6284000c,0x225f8143,0x26c5206f}},	//   _miyo, _mhio, _djuk_, álov_,
   {{0xdd90a043,0x7ae4c052,0x645c2090,0x7bc0ceca}},	//   نڈا_, _äiti, nnri, wamu,
   {{0x69c0cea3,0x09c7007c,0xf1be0026,0xed598ecb}},	//   tame, ষ্টা, ्णान, _reže_,
   {{0x443fc17a,0x4394ce12,0x645ae5fa,0x62956ecc}},	//   ghu_, майс, wnti, _zizo,
   {{0xfe458555,0x98a4c013,0x23dc28d6,0xdb08e315}},	//   _تکلی, kymą_, _बांद, sadü,
   {{0x81b9007c,0x09c50010,0x2a60088e,0x442a6ecd}},	//   _চাই_, वण्य, _ajib_, _job_,
   {{0x2d800ece,0xe41ae06f,0x44290ecf,0x645d0ed0}},	//   _azie_, _kľúč, _poa_, ério,
   {{0x0e9ba095,0x6d444ed1,0xed59ced2,0x39576095}},	//   _השאל, kzia, saža_, לשים_,
   {{0x644e6ed3,0x2005ab01,0xb87b2168,0x442a6048}},	//   _ombi, _yali_, stím, _oob_,
   {{0xc05b2a0e,0x7d02ced4,0xb7b5a079,0xb5fb40f9}},	//   сім_, _isos, _họr, _akáp,
   {{0x9f5a21af,0x629d408b,0x63bd4ed5,0xb17b0065}},	//   _papá_, _suso, _pesn, dgåe,
   {{0x66064ed6,0x62840ed7,0x80cd8c87,0x61faeed8}},	//   _cakk, _ghio, _सिले, letl,
   {{0x8d77413a,0x66064bec,0x63bd4ed9,0xa3dfc010}},	// [970] سارا, _dakk, _vesn, _तास_,
   {{0xaad4ceda,0x17580076,0xe3bf407b,0x7c2ae733}},	//   _दिनक, _מסחר_, _toño_, _jofr,
   {{0x02a426fc,0xa3c2a180,0xf773633e,0xbddb00d1}},	//   _прям, ्णन_, راط_, chèc,
   {{0x7bc1eedb,0xddcd4edc,0x66064edd,0xe0d0624d}},	//   zalu, blaš, _gakk, ازل_,
   {{0x6440c13a,0xfaff00b6,0x645d0ede,0x2bdde3af}},	//   dhmi, nwë_, insi, _माला,
   {{0x7c298b64,0xddc4416d,0x7c2aeedf,0x69d8e04b}},	//   _woer, moiš, _nofr, _मागी,
   {{0x6f0d407b,0x2007aee0,0x7d0d4ee1,0x2089c7ca}},	//   lvac, rdni_, lvas, ойки_,
   {{0x7bc1eee2,0x32094ded,0x443ce052,0x9f59000e}},	//   walu, nday_, _alv_, gesë_,
   {{0x66076ee3,0x6d43a0e0,0x1306c04e,0x200940a2}},	//   _kajk, szna, дный_, idai_,
   {{0x05dc2295,0x645bc12a,0x68e16156,0x64838046}},	//   _बाइब, snui, _älds, sõid,
   {{0x60c4803b,0x7d0d42df,0x6d456ee4,0x62960ee5}},	//   šimt, hvas, nzha, _piyo,
   {{0x7ec2eac3,0x78a96ee6,0x29116098,0x2611aee7}},	//   _sípá, _čevl, _mrza_, _धोती_,
   {{0x66064ee8,0x69cd01cd,0xd01220e0,0xec6ee331}},	//   _rakk, _ddae, پلز_, _ап_,
   {{0xddcd4ee9,0x7c2ae1cd,0x7bc7e069,0x68384057}},	//   vlaš, _gofr, ðjud, _pído,
   {{0x22404050,0x81e6407c,0x224fc037,0xdb1c6eea}},	//   thik_, _যোগ_, _kmgk_, _verë,
   {{0x799b8eeb,0xb5fb0057,0xd838c320,0x2fdfc0ae}},	//   _nguw, gnád, _kuča_, ngug_,
   {{0x27edc105,0xdb01a105,0x2fc0c10a,0x2baf24ba}},	// [980] ifen_, _gelö, _õige_, _ज्वा,
   {{0x7c36403b,0x7a3fe004,0x7d040eec,0x261c0010}},	//   skyr, _fête, _isis, यावी_,
   {{0x3207e42c,0x7ae9ceed,0xae1b200b,0x141b200b}},	//   _many_, htet, _וויכ, _וויב,
   {{0x3209424f,0xb8e4407c,0x26da6eee,0x2007eeef}},	//   cday_, _এম_, rupo_, _lani_,
   {{0x290246ca,0x7c3d000e,0xe7e60573,0xbea38ef0}},	//   _uska_, ërri, _काना_, вачк,
   {{0x63a98ef1,0x69c44ef2,0x7d0400ce,0x2006c8c1}},	//   _efen, laie, _msis, _saoi_,
   {{0x38a449ac,0x3e560041,0x16db0308,0x8c3b6105}},	//   _hör_, nāts_, _बम्ब, _fußb,
   {{0x26068ef3,0xe81c6021,0x2007e436,0x683ccef4}},	//   _सोची_, नावा_, _aani_, _béda,
   {{0x61faeef5,0x3207e017,0xab5ce041,0xa3adc028}},	//   tetl, _bany_, daļa, कड़_,
   {{0x645d0ef6,0xdfd0e4a1,0xddc8e064,0xdb0400c4}},	//   wnsi, ديد_, widł, _reið,
   {{0xbbd76087,0x9986c066,0xda6fc20e,0x61ed4a88}},	//   וויץ_, _ulož_, _ая_, yfal,
   {{0x6e3e2361,0x201a2cd9,0x60dc2ef7,0x290481e7}},	//   _alpb, _anpi_, durm, _ksma_,
   {{0x0936cef8,0x2007eef9,0x443ea08b,0x442681ae}},	//   _تراج, _fani_, _klt_, ijo_,
   {{0x6aa08efa,0x2056e0ff,0x260f0d01,0xed598012}},	//   _mumf, _ютер, _तोरी_, _ježa_,
   {{0xdb1c2a5d,0x443eaefb,0x25a901d7,0x62972005}},	//   barí, _mlt_, _tfal_, _vixo,
   {{0x2498628f,0xbddb4efc,0x2007eefd,0xea9f2031}},	//   _airm_, _amèr, _zani_, _aiṣe_,
   {{0xe80f2029,0x682fa271,0xb5fdc133,0x62972efe}},	// [990] ायदा_, _mødr, mošt, _tixo,
   {{0xb3a983df,0x38a44156,0x69c3a0d5,0x32094eff}},	//   ğımı, _dör_, xane, sday_,
   {{0x64896f00,0x7d0d4f01,0xc108c067,0x7c2d015a}},	//   _džip, svas, _lỗ_, _koar,
   {{0x6298ef02,0x442b4f03,0x3157e00b,0x76552157}},	//   _livo, _uoc_, ויבן_, lizy,
   {{0x660762f9,0x7c2d01fc,0x443ead4c,0xfb358056}},	//   _tajk, _moar, _blt_, эндэ,
   {{0xdb1c21af,0x25b283ed,0x6fdde077,0x6e2d0019}},	//   zarí, ıyla_, _माइं, _loab,
   {{0x61fbcf04,0x7a3cc59b,0x45d5809e,0xb5fdc133}},	//   teul, _séta, _повс, košt,
   {{0x2c640497,0x2bdb0010,0x27edc669,0x3e746277}},	//   kıda_, _भागा, ufen_, sätt_,
   {{0x2007ef05,0xdb18a195,0x61e52066,0x24994071}},	//   _pani_, ravá, _ochl, _mism_,
   {{0x51848818,0x26dca03b,0xed59c47c,0xe3b1e13a}},	//   _руса, buvo_, sažo_, درة_,
   {{0x25e1038e,0x2ca00f06,0x6443a6a5,0xdb1d4005}},	//   _काशी_, _suid_, mhni, _desé,
   {{0x78a0800f,0x7bc56f07,0xcfe9c050,0x3958e049}},	//   _yumv, hahu, _رفته_, úrsa_,
   {{0xdb1e20dd,0xdb1c2966,0x98e5c13a,0xc108c016}},	//   _tepë, rarí, _أكتو, _gỗ_,
   {{0x7bc1af08,0x3ea005df,0x69cf4f09,0x443e2009}},	//   _jelu, _vuit_, _adce, ót_,
   {{0x6299cf0a,0x5e964049,0x99804013,0xdb1c2f0b}},	//   _kiwo, فلسط, ykių_, parí,
   {{0x61fc2f0c,0xc32321ba,0xafdb4042,0x60d64f0d}},	//   serl, ымск, _smør, trym,
   {{0xd9434f0e,0x9c82c05c,0xed5a0b92,0xab664f0f}},	// [9a0] гети, íčin, _хоп_, хвал,
   {{0x9f404f10,0x6aa08f11,0x6b840f12,0x7a302156}},	//   lgië_, _rumf, _izig, _väts,
   {{0x1636e00b,0x6608a530,0x44268f13,0x2d9dc088}},	//   ענער_, _radk, tjo_, _ogwe_,
   {{0x667686b0,0xdb1aee20,0xdfd28050,0x3a3ea07d}},	//   ردار, natá, ايش_, _sltp_,
   {{0x26dd848d,0x2905a106,0xe61f4067,0xdb18ef14}},	//   guwo_, _asla_, _khôn_, _reví,
   {{0x7bc56f15,0x442d8057,0x644282df,0x7bce6065}},	//   cahu, _eoe_, shoi, _udbu,
   {{0x316c0064,0x443ea149,0x645d0050,0x9663663e}},	//   ędzy_, _vlt_, érik, _скре,
   {{0x2c6400b0,0x3f7b6053,0x442d8f16,0x6443af17}},	//   yıda_, _זאלס, _goe_, ahni,
   {{0xc6f7c7b9,0xed59849f,0x442caf18,0x9c7d0098}},	//   еных_, _teža_, _tod_, stčk,
   {{0xb806a043,0x7656403c,0x3f9dc385,0x78a1a197}},	//   _سکتے_, hiyy, _egwu_, _fulv,
   {{0xe816a0c5,0xb7bd812a,0x3ea24f19,0x44446f1a}},	//   _धोया_, _soţi, _lukt_, ih_,
   {{0xdb1aef1b,0xe508c081,0x60dd02df,0x69c60f1c}},	//   gatá, _tỷ_, tusm, gake,
   {{0xdb056f1d,0x7bc56f1e,0x3ea122df,0x7e640030}},	//   rché, yahu, _suht_, _djip,
   {{0x9606e13a,0x2c640181,0xfc3f4049,0xdb056f1f}},	//   _سبتم, rıda_, _slí_, sché,
   {{0x44cca026,0xbd682f20,0x6146e0fa,0x44390098}},	//   ně_, ерте_, _délé, pks_,
   {{0xb21b0065,0xb8f7007c,0x6b9e2057,0x9f47a066}},	//   dlæg, _সহ_, _egpg, jený_,
   {{0xb87b29fe,0x68302156,0x61e28f21,0x3a2d8854}},	// [9b0] tuíd, _vädr, dgol, _roep_,
   {{0x99676f22,0x7a36e004,0x442d8f23,0x78a2c691}},	//   нтел, _bâti, _soe_, _muov,
   {{0x200a6f24,0x7bc1af25,0x78a2c052,0x443f8f26}},	//   _dabi_, _relu, _luov, _plu_,
   {{0x2906c265,0x3ea2468f,0x7a35c1de,0xb9096c67}},	//   _osoa_, _fukt_, _táti, _मम_,
   {{0x5184487c,0xd009af27,0xbddb45df,0xdb1aa057}},	//   _бура, деле_, _elèc, _detí,
   {{0xbddb4f28,0x8d748ca7,0x660d4f29,0x7bc72f2a}},	//   _flèc, داما, ldak, naju,
   {{0x2fc5e3d1,0x48bdc07c,0x443f8f2b,0x442d85b2}},	//   valg_, _আমের, _tlu_, _toe_,
   {{0x443f8f2c,0x200a635f,0x29020064,0xb803607c}},	//   _ulu_, _zabi_, ywka_, _উচিত_,
   {{0x200b4a45,0x98f484aa,0x9e65e9b1,0x60c9c004}},	//   _maci_, _مثلا, квид, usem,
   {{0x5d54864d,0xc3344694,0x64564bd4,0x7c2f4197}},	//   _скут, רוץ_, ziyi, _locr,
   {{0x5589e6fe,0xd46a0f2d,0x6b8400e0,0xb21b086b}},	//   ьбом_, дине_, _szig, klæd,
   {{0x2fc5e042,0x6289805d,0xbbd1af2e,0x60c9c046}},	//   salg_, _jheo, _सयुक, psem,
   {{0x09cc607c,0x7e6940a9,0x6724417a,0x3f9f80ce}},	//   র্টা, čepl, xxij, _mguu_,
   {{0x2d9c603a,0x44294424,0x7a3dab3a,0x9f47a326}},	//   ľvek_, eja_, _mèto, zený_,
   {{0x2175e00b,0x6145e143,0xdca62f2f,0xa3e8cf30}},	//   _בײַם_, _шека, таби, _बाम_,
   {{0x6e3bcf31,0xf2d2a00b,0x6e29cf32,0x244d200a}},	//   nkub, יעל_, njeb, džmu_,
   {{0x9f47a05c,0x6495c098,0x03a6673f,0x64564f33}},	// [9c0] vený_, _ašik, визо, riyi,
   {{0x76444f34,0x44446f35,0x3f9f8079,0x14d4c010}},	//   shiy, uh_, _aguu_, _दिसण,
   {{0xa5d9200b,0x77698057,0x69c4062c,0x4dd9200b}},	//   _אַרי, _axex, _keie, _אַרױ,
   {{0xdb1c2359,0x7d160f36,0xed5a804e,0x78a406eb}},	//   cará, _krys, мое_, _kuiv,
   {{0x6aa3e4cd,0xd838a29c,0x626581b3,0x7d094057}},	//   _lunf, _liče_, دالق, _áesp,
   {{0xddcd4064,0xa3e96028,0x2d80c1d7,0x9f5ca0fa}},	//   ciał, _याय_, _ġie_, levé_,
   {{0x9f47af37,0x661d4488,0x7d044f38,0x71766047}},	//   denó_, _ynsk, lwis, _شهرا,
   {{0x2619ca11,0xdb18e05c,0x7c3bcf39,0xfe6fc4a1}},	//   भागी_, _nevá, gkur, يدي_,
   {{0x2ca64ab5,0xf653442c,0x57eaa01f,0x660bcf3a}},	//   íodh_, יצה_, _одам_, _dagk,
   {{0x660d4f3b,0x6a788f3c,0x78a3ef3d,0x8af6e5fc}},	//   zdak, rífu, _bunv, _çəkd,
   {{0x7c29ca2f,0x787d0e41,0xd48fcf3e,0x3949e068}},	//   bjer, lévi, _вр_, _ƙasa_,
   {{0x6f160f3f,0x25a0065f,0x7bc72f40,0x629c600e}},	//   _bryc, _cgil_, waju, _liro,
   {{0x69c40f41,0xa2a245cb,0x442eef42,0x78a40f43}},	//   _deie, _कूल्, _tof_, _cuiv,
   {{0xd7f82967,0x7d160f44,0xcf938076,0x7bc3ef45}},	//   кус_, _drys, יטר_, _genu,
   {{0xf1bf8066,0x9f532005,0xa3d54143,0x6738a009}},	//   áška_, _raxó_, ловч, nyvj,
   {{0x61e44f46,0x69c3ef47,0x46d28148,0x53342f48}},	//   ggil, _zene, _सिंह, шест,
   {{0x22590536,0x645761cb,0x660d4a88,0xc6a44312}},	// [9d0] misk_, tixi, rdak, архи,
   {{0x69c3e4fa,0xe1f06ab5,0x7bc8ef49,0x201ea13b}},	//   _xene, قسم_, nadu, _nnti_,
   {{0xda786f4a,0x645a45df,0x26cd816d,0xb87b6057}},	//   тят_, ètic, _sveo_, _mpíx,
   {{0x645a4004,0xdb1d4057,0x7bc8ef4b,0x64576025}},	//   étit, _hesí, hadu, sixi,
   {{0xb87b241d,0xdb1c6f4c,0x7a35c0c4,0x9479af4d}},	//   btít, _cerâ, _mátt, нску_,
   {{0x69dd6010,0x200cab33,0x69c8ef4e,0x442fcf4f}},	//   _पाटी, _cadi_, jade, _sog_,
   {{0x320caf50,0xb87b2017,0xdb1d4019,0x7bc8ef51}},	//   _dady_, ltís, _mesí, dadu,
   {{0x6442cf52,0x6edb8290,0x2246817b,0x2909004e}},	//   _cloi, _निपु, chok_, _osaa_,
   {{0x97ea8686,0x6e3bcf53,0x26cd829f,0x44316163}},	//   ıştı, rkub, _uveo_, _koz_,
   {{0x629c6f54,0x27e90f55,0x6e29cf56,0x201ea037}},	//   _xiro, _acan_, sjeb, _gnti_,
   {{0x660bccd1,0x29090096,0x7d044f57,0xb5fb41e9}},	//   _tagk, _asaa_, zwis, _ajám,
   {{0xd838a0a9,0x2fc5a3e0,0x7d0440c2,0x765980fd}},	//   _viče_, _helg_, ywis, niwy,
   {{0x515600fb,0x69c40f58,0xeaaec07a,0x7bc9c187}},	//   утну, _veie, _ый_, maeu,
   {{0x7bc8ef59,0x25adc0b6,0x2a79405d,0x60cd4f5a}},	//   cadu, lcel_, _aksb_, dsam,
   {{0x629d4ea3,0xbb4326bb,0x15432143,0xa2ca87d9}},	//   _biso, берк, берм, _सौन्,
   {{0xdb18eaca,0x7d044f5b,0x60da6277,0x2a786742}},	//   _bevæ, twis, _åtmi, _skrb_,
   {{0x69c52f5c,0x27f24f5d,0x765981cd,0x644400ce}},	// [9e0] _fehe, rfyn_, diwy, _ilii,
   {{0x1a062aab,0xc0062d2b,0x629ee5df,0x1615c4ef}},	//   _спом, _спок, _èpoc, _दोसर_,
   {{0xdb1c6f5e,0x91a90f5f,0x28c68216,0xb0c68064}},	//   _terí, _hoá_, रीनि, रीनग,
   {{0xdd8f61ac,0xf7464407,0x7bc8ef60,0x50db200b}},	//   سون_, _бемо, zadu, _אקטא,
   {{0x4420048d,0xda7aa4c9,0x629e2f61,0x69c52f62}},	//   _mni_, няк_, _kipo, _yehe,
   {{0x7bc6400e,0x69c52108,0x9985e013,0xf41f0052}},	//   _heku, _xehe, nklų_, lmät_,
   {{0x6442c12a,0x9c14c125,0x7658a163,0x7bc8ef63}},	//   _ploi, _dọny, rivy, vadu,
   {{0xdb1aa510,0x60dbcf64,0xb5fb41e9,0x44cee013}},	//   _cetá, frum, _ajáj, vę_,
   {{0xdb0446c7,0x216781e3,0x0524a07c,0x8966804f}},	//   mbió, _бити_, বনের_, _скаж,
   {{0xe45f2277,0x64440f65,0x64a6a0ff,0x7ae0cf66}},	//   rsök_, _alii, _бажа, rumt,
   {{0x9c7d006a,0x2d98ef67,0x68e1ef68,0x64440153}},	//   jučc, äre_, guld, _blii,
   {{0x629e2f69,0x44200f6a,0x71f7e043,0x44ceeb6b}},	//   _aipo, _cni_, پریس_, rę_,
   {{0xb4c10010,0x44ee6261,0xade60046,0x7ae2803b}},	//   ुळे_, hý_, _कारन_, nuot,
   {{0x629e2f6b,0x25e1040a,0x2a79405d,0x629d4f6c}},	//   _cipo, _काकी_, _sksb_, _siso,
   {{0x3317e1b3,0xb87b21af,0x2139000e,0x44316f6d}},	//   _مزيد_, guía, sysh_, _roz_,
   {{0x44ee6066,0x36d5404e,0x69c52f6e,0x7e644c57}},	//   dý_, иобр, _wehe, gnip,
   {{0x7ae2803b,0x69caa97e,0xb9994f6f,0x200eef70}},	// [9f0] juot, kafe, твах_, _kafi_,
   {{0x629e2f71,0xb05b2277,0x3dc6c05d,0x7c208030}},	//   _gipo, gsät, _leow_, _anmr,
   {{0xdb0e6105,0x61e98cb1,0x2be8a5cb,0x629f041a}},	//   _gebü, _pcel, च्छू_, _épos,
   {{0x39158acb,0x27e68f72,0x44316f73,0xf42a0052}},	//   имер, ggon_, _woz_, mpää_,
   {{0xf21a212f,0x765aef74,0x998ca04a,0x7ae28013}},	//   _फोड़_, kity, _bodů_, guot,
   {{0xa2c18295,0xdb18e04e,0xe80d4026,0x645560bb}},	//   रीष्, _kevä, ाएका_, _umzi,
   {{0xaa9580ff,0xf625c09e,0x63bbc4d9,0x6a788322}},	//   _вивч, идко, tbun, rífr,
   {{0xd1bb8555,0xa2a2639f,0x61e98f75,0x7bc7600f}},	//   _سارا_, गदर्, _ucel, _heju,
   {{0x44d16f76,0x87e7a4aa,0xdb1c601f,0x53478f77}},	//   lą_, _مثال, _terã, _схва,
   {{0x28dc0bc5,0xdb0d0057,0xa2dd40aa,0xe29f40c4}},	//   _बिबि, _neañ, _पिन्, _lið_,
   {{0x60260f78,0xafdb0065,0x8bd5c1ac,0xd8260470}},	//   адна, dkøb, _نقاش, адни,
   {{0x443ee200,0xd756c050,0x9f58265f,0x5c560f79}},	//   akt_, الیت_, verà_, ртоф,
   {{0x442dcf7a,0x765ae5fb,0x657e2f7b,0x64896361}},	//   mje_, bity, _syph, _džiz,
   {{0xafe2e0c0,0x6603af7c,0x44200403,0xa2d70d88}},	//   _дошл, nenk, _wni_, _बिर्,
   {{0xb779e49c,0x5d79e49c,0x7ae2803b,0x2aab8065}},	//   _באַש, _באַק, zuot, _løb_,
   {{0xb33ca17a,0x200fc187,0x68434f7d,0xfe434f7e}},	//   _jgħa, _jagi_, онса, онсо,
   {{0xd007433f,0x63a40d72,0x237f8286,0x63a9006e}},	// [a00] шете_, _igin, _nyuj_, ženc,
   {{0x28ddc8a1,0x41b66aa5,0x248d81e7,0x2fc7e43d}},	//   _मिनि, рсат, _ahem_, _jeng_,
   {{0x2fc7ef7f,0xdb052065,0x09066f80,0x4fc6803b}},	//   _meng_, _afhæ, рпен, асла,
   {{0x7ae28f81,0x68e3af82,0xdb1c6359,0x249f8820}},	//   tuot, dund, _cerá, _cium_,
   {{0x69c76f83,0xc5fee07c,0xddc1e06e,0x7e6dc098}},	//   _feje, ্ঞতা_, dolž, čapl,
   {{0x442dc064,0x2c1c6064,0x38ab8042,0xaa466f84}},	//   eje_, नाओं_, _dør_, _тегл,
   {{0x7bcaaf85,0xdb0bc765,0x200ee0e8,0xdb1d401f}},	//   rafu, _segð, _rafi_, _tesã,
   {{0x10a36bff,0x60c2c0d1,0xb5fb03e4,0x8cd70021}},	//   _фитн, _pwom, gnál, _बिलो,
   {{0x5186c139,0x3ead6098,0x7a35c97c,0x2338c04e}},	//   шука, _četi_, _pátr, уппы_,
   {{0x2ca7ef86,0x7afe20ff,0xa2db807d,0x69da2be3}},	//   _bund_, _oppt, _नित्, ótel,
   {{0xe8df4067,0xd838c06e,0x09b4a466,0x273ccf87}},	//   _tiệc_, _luči_, ुरीय, _bánú_,
   {{0x63a2c296,0xdb19c0cb,0x6251803a,0x6448ef88}},	//   _ugon, _bewä, sťov, shdi,
   {{0x200ee068,0x6445205f,0x9989004d,0x2246cf89}},	//   _tafi_, _plhi, _boaš_, _ilok_,
   {{0x442241f3,0x5fe26960,0x68e44f8a,0x291a207d}},	//   _ank_, _पागल, duid, _brpa_,
   {{0x629f0037,0x7bc76f8b,0x660f4f8c,0xdb1e6134}},	//   _tiqo, _reju, _pack, napä,
   {{0xb87b2017,0x92b3e711,0x29194f8d,0x9f5ca04a}},	//   dríe, _بحوا, _prsa_, jeví_,
   {{0xf1bf0f8e,0x20032f8f,0xf1a76c4e,0x765c2f90}},	// [a10] mbá_, peji_, арен, biry,
   {{0x2004cf91,0x7bcb8d0d,0x683cce41,0x74bdef92}},	//   hemi_, wagu, _dédi, वीकृ,
   {{0x753d00e0,0xd041c03c,0x245944a7,0x80f56f93}},	//   lysz, _evlə, _бань_, спех,
   {{0xf39101e9,0x44224f94,0x2004cf95,0xa2db8bed}},	//   _aṣia_, _gnk_, jemi_, _निद्,
   {{0x93fa4095,0xa28264b7,0x3b6441e1,0x2ee4c422}},	//   _גלרי, _کیلو, _дърв, jumf_,
   {{0x645d0f96,0x44d16f76,0xa969a8df,0xe81b45cb}},	//   hisi, pą_, лила_, _पोता_,
   {{0xd49b831a,0x7bcb8f97,0xd5aea085,0x38668f98}},	//   _ара_, pagu, رفي_, bnor_,
   {{0x7d0d0f99,0xccf26095,0x69c8a054,0x645d0f9a}},	//   _osas, _מכל_, _eede, jisi,
   {{0x645c2f9b,0x765d0f9c,0x7bc8a0c7,0x98a3c03b}},	//   yiri, disy, _fedu, ąjį_,
   {{0x3e7ba004,0x4a45ef9d,0x79e7e0e0,0x60cd8098}},	//   rêts_, снов, جودہ_, šams,
   {{0x44262067,0x3f860f9e,0x320fc066,0x7d1b8f9f}},	//   _đo_, _šou_, _tagy_, _hrus,
   {{0x645c2fa0,0x2004c04a,0x68384066,0xdb1522a8}},	//   wiri, cemi_, _lídr, hazó,
   {{0x8e74c13a,0xaad4c295,0x1474c13a,0xed5982f9}},	//   _بالض, _दिएक, _بالج, _beži_,
   {{0x291a216d,0x711ac095,0xdb0281ae,0x261808ae}},	//   _prpa_, _תוספ, scoç, _बोरी_,
   {{0x61fb8fa1,0x62828fa2,0x9c7d029f,0x6efd0156}},	//   _obul, yloo, mučn, _påbö,
   {{0xf8a58050,0xb87b21de,0x442360ca,0x6f1b8fa3}},	//   _يک_, quín, _anj_, _oruc,
   {{0x20124006,0x9ce821a6,0x66060fa4,0x61f64fa5}},	// [a20] rdyi_, খবেন_, mekk, rfyl,
   {{0x09d08010,0x232a645c,0x32120038,0xa3be27f4}},	//   हण्य, лози_, _hayy_, आरओ_,
   {{0x2004cfa6,0x69ce2fa7,0x1fb562eb,0x7bce2fa8}},	//   yemi_, mabe, юстр, mabu,
   {{0x2005efa9,0x9f59407b,0x2ca9005f,0x03268691}},	//   heli_, _casó_, _yuad_, йден,
   {{0x21d866b0,0x66e3827c,0x20120faa,0x7ff7410c}},	//   _نژاد_, зоча, _mayi_, _اسپا,
   {{0x20116fab,0x7d1b8fac,0x62844732,0x62828fad}},	//   _gazi_, _drus, llio, sloo,
   {{0x645d0fae,0xfce361fc,0x64b76098,0xb3a98602}},	//   yisi, _норо, _aćif, ğırı,
   {{0x09e1207c,0x6283a88c,0x69ce2faf,0xbb3b600b}},	//   ম্পা, alno, habe, _געלי,
   {{0x80d8c010,0x2ee041cd,0x66060b80,0x62844fb0}},	//   _मिळे, nrif_, dekk, ilio,
   {{0x27e94018,0x645d0fb1,0x9411603c,0x9c7d053d}},	//   zgan_, wisi, _bizə_, gučn,
   {{0x2717e081,0xbb86a13a,0x6e360403,0x645aafb2}},	//   _căn_, _الاي, _boyb, _imti,
   {{0x78a1a200,0x6441e31d,0x3ea24064,0xe0df065f}},	//   _zilv, akli, _nikt_, trò_,
   {{0x2ca903d2,0xd85161e9,0x9f5ee2a8,0x7bce2f3d}},	//   _quad_, _bọ̀_, metí_, fabu,
   {{0xdb1e2510,0x4d7bc00b,0x24446156,0x769f01e9}},	//   _sepá, _ערגע, _sömn_, _bàyì,
   {{0xce6b4c14,0x2bf7e1a9,0x644b600e,0x64428052}},	//   град_, _המון_, ëgim, kkoi,
   {{0x8c3d812a,0x6e240187,0x38ae20c4,0xbddb4187}},	//   _mişc, _gnib, _dýr_, _ilèk,
   {{0xdd944056,0x645aa194,0xb87b2057,0x2ee040fd}},	// [a30] заты, _omti, quío, grif_,
   {{0x9f5a2fb3,0x9f5940f9,0xbfed4079,0x6aad43ac}},	//   _capó_, _basò_, _ṅụọ_, rqaf,
   {{0x61e9cfb4,0x6aaae854,0xb5fb0066,0x1635414a}},	//   ygel, _juff, piád, _деня,
   {{0xb9016180,0xa5f98fb5,0x9f5ee04a,0xdd7be1a1}},	//   _दि_, реду_, jetí_, נטאל,
   {{0xa3ea8d0b,0xbcfb49fe,0xab298fb6,0x7ae566eb}},	//   _मार_, _exér, рола_, suht,
   {{0x7bcae089,0xdd314064,0x69caefb7,0x6f1b8fb8}},	//   _nefu, zęśc, _nefe, _vruc,
   {{0xd1bb8049,0xc2126557,0x1a29cfb9,0x7ae72089}},	//   _ماذا_, _קהל_, ижки_, nujt,
   {{0x7bcf0fba,0x26dfc2a8,0x81c1207c,0xeaf886b0}},	//   jacu, truo_, ুলি_, _گرفت_,
   {{0x6aaae105,0xe733825b,0x69ce2fbb,0xaca38067}},	//   _auff, _عصر_, yabe, _trốn,
   {{0x66060fbc,0x7982c08b,0x99488049,0x25a6c187}},	//   wekk, _dyow, _الكل_, _egol_,
   {{0x291ce40c,0x2461403b,0x764d4174,0x6aaaefbd}},	//   _crva_, nėms_, khay, _cuff,
   {{0x28f9c04e,0x61eb8fbe,0x645e6fbf,0x28e0839f}},	//   _ведь_, nggl, zipi, _निमि,
   {{0x764d4fc0,0xfe42c0ff,0xdb01a065,0x644021ae}},	//   dhay, _іншо, _aflø, êmio,
   {{0x80b04029,0x7e7bcfc1,0x44f1efc2,0x69cbcfc3}},	//   _अंबे, loup, pá_, _hege,
   {{0x7643a88e,0xf21ec033,0x2bfba029,0xf3f9c12a}},	//   ikny, _मोड़_, ल्यू_, enţi_,
   {{0x7c240fc4,0x1ae600ba,0x69cf028e,0xb81a2a08}},	//   _unir, _доим, cace, _फोरम_,
   {{0x75d3413a,0x44c7e0e0,0xd838c143,0x6442800a}},	// [a40] بيقا, lő_, _guču_, vkoi,
   {{0x386d8fc5,0x387f8fc6,0x69cae03e,0x628441e4}},	//   _ajer_, _akur_, _xefe, slio,
   {{0x25eb64d6,0x2beb6219,0xe7eda010,0x69c1efc7}},	//   _चारी_, _चारू_, च्छा_, ible,
   {{0x2bb4aa82,0x4425afc8,0xdb1ae3d1,0x7983e11e}},	//   ुर्थ, _anl_, ratø, _mynw,
   {{0x6b83eb48,0x491d00a8,0x7e7bcfc9,0x2007a1fb}},	//   _lyng, मियो_, doup, feni_,
   {{0x76444fca,0x69cf0fcb,0x69d9cfcc,0xdfd260eb}},	//   lkiy, zace, _adwe, _زير_,
   {{0xf84ace14,0x78a2cfcd,0x7c06813a,0x60cd804d}},	//   ичий_, _piov, _وبرك, šamp,
   {{0x27e0a3df,0x3ea2c277,0x386d8488,0x66164fce}},	//   şin_, ökt_, _gjer_, ndyk,
   {{0x44386fcf,0x3218c026,0x645c6037,0x444465b2}},	//   _kor_, ěry_, _kmri, ok_,
   {{0x3207a6c4,0xdb1c6052,0x69c28fd0,0xb87b2057}},	//   ceny_, _terä, lboe, tuím,
   {{0x7644435f,0x64444052,0x7e7c2d53,0x6b840fd1}},	//   kkiy, kkii, dorp, _ayig,
   {{0x69c28f10,0x64a6c0db,0x7e7bcfd2,0x2fcca098}},	//   nboe, _дада, coup, _hedg_,
   {{0x22490fd3,0x1a9b849c,0x2beb6010,0x62560066}},	//   _vlak_, ייטע, _चालू_, yšov,
   {{0xa5bb4e1c,0x9f5a20d1,0x290b00c2,0xb0660052}},	//   _enól, _rapò_, rwca_, ttää,
   {{0x644ae037,0x6d40c02d,0x69c281cf,0x2ca36171}},	//   _ilfi, lyma, kboe, _rijd_,
   {{0x68e28fd4,0x7c38e156,0x7ae28fd5,0x3207a1ce}},	//   krod, _hovr, krot, zeny_,
   {{0x7c38e0e4,0x4426cfd6,0xfbab609e,0xe8df6016}},	// [a50] _kovr, _mno_, атей_, _thừa_,
   {{0xf8bf07a4,0xb87b21af,0x3255284f,0x644d4fd7}},	//   mpé_, bría, _хвор, shai,
   {{0x7bcd0037,0xdb078057,0x29024012,0x3207afd8}},	//   _keau, _ámús, _epka_, veny_,
   {{0x6d40c03b,0x645c6fd9,0x69c2823c,0x5a3587ca}},	//   kyma, _emri, gboe, янет,
   {{0xb5fdc29f,0x444461e2,0x069b6050,0x25a9812d}},	//   niše, bk_, _نخست_, žalo_,
   {{0xd126e13a,0x26c90167,0x7d0d4fda,0xfaa5afdb}},	//   _كم_, _mwao_, mwas, пако,
   {{0x3ffc249c,0x28ddc4ef,0x78a3efdc,0xdb18a6df}},	//   יפגע, _मिहि, _rinv, cavü,
   {{0x7d02c049,0xe68e403c,0x6449812a,0x27e960ba}},	//   _bpos, _məşğ, _ulei, şină_,
   {{0x6615603b,0xddc3e04d,0x6b83efdd,0x7bcbcfde}},	//   _kazk, _ajnš, _syng, _vegu,
   {{0x1dcb6292,0x1bf2a0c2,0xb5fdc16d,0x6abb8079}},	//   िरित, _घायल_, diše, _ituf,
   {{0x44394fdf,0xa5bb407b,0x68e8efe0,0xfbcf8466}},	//   _oos_, _anóm, gudd, _हजाम,
   {{0x80b3007c,0xdb1260e0,0xdb07600e,0x6d40cfe1}},	//   _জিজ্, égév, _agjë, byma,
   {{0x09e3607c,0x3ea5a0ca,0x6aa3e0f7,0xa2dd4077}},	//   ন্যা, _kilt_, _tinf, _पिष्,
   {{0x44d5e018,0x25fd6914,0xe73a220e,0x3af56156}},	//   pā_, र्मी_, бег_, kåp_,
   {{0x8c4600ba,0x3ebfc07d,0x38b1a009,0x291e2fe2}},	//   _неке, lput_, _jár_, íta_,
   {{0x6aad0fe3,0x2167201f,0x09e3607c,0x673ce1dd}},	//   _fuaf, чиси_, ন্মা, ärje,
   {{0xdcf4a422,0x62872fe4,0x38b1a13a,0x38604054}},	// [a60] _đačk, bljo, _lár_, riir_,
   {{0x5ed3607c,0xd91b000b,0x8b96645c,0x3af44262}},	//   _সহজে, _פויל, преч, räp_,
   {{0x44394fe5,0xaca44088,0x7a3cc004,0xc43b2095}},	//   _fos_, _ahụt, _métr, _התיי,
   {{0x3a3a2551,0xb7eac028,0x3ea5a049,0x44d7a12a}},	//   _hopp_, _टाइम_, _ailt_, dă_,
   {{0x66160fe6,0x69c28b83,0x1a9b400b,0xb05b210a}},	//   _mayk, rboe, _ליטע, späe,
   {{0x7bc28fe7,0x24868fe8,0x82d7000b,0x80d0a07c}},	//   sbou, slom_, לונג_, সংস্,
   {{0x7e60cfe9,0x7ae28fea,0xa7fb0057,0x6608e271}},	//   timp, srot, hiña, vedk,
   {{0x54b8cf4a,0x7ae8e249,0x200a2feb,0x68e8e11d}},	//   огия_, vudt, hebi_, vudd,
   {{0x291f800e,0xdee38312,0x443a2fec,0xdd90c062}},	//   _grua_, _поти, _oop_, کوک_,
   {{0x68e8e035,0x2eb5871b,0x7bce60eb,0x2fcd805f}},	//   tudd, _ісус, _jebu, _zeeg_,
   {{0x7d03e037,0x2fcd8022,0x44d86f50,0x55bba076}},	//   _cpns, _yeeg_, nč_, _המבו,
   {{0x60d64fed,0x765e2fee,0x61ed4025,0x7c39c401}},	//   ksym, _ampy, xgal, _gowr,
   {{0x6e3aa0f7,0xfaf7c8b5,0x3ce94286,0x81cc01a6}},	//   _kotb, _فروغ_, xuav_, _লাশ_,
   {{0xbeed0fef,0x76892069,0xdca3eff0,0xe81d0ff1}},	//   _जमीन_, mþyk, _зачи, _बोरा_,
   {{0x7c3aaff2,0x443a2846,0x68e4410a,0xd7cc8010}},	//   _motr, _dop_, erid, ाराच,
   {{0xf1bfa016,0x6aa6405d,0x672162c9,0xaa584fb5}},	//   _đám_, _cikf, _šljo, пису_,
   {{0xa7fb04fa,0x6fc30e35,0xa2d708ae,0x7a3daff3}},	// [a70] ciña, _व्यं, _बिट्, _mètr,
   {{0x929da064,0x9f404069,0x768b6121,0xddc8e098}},	//   _opła, rfið_, rüyo, hodž,
   {{0x9f5eaff4,0xddc8e098,0x60c98aaa,0xdb1aeff5}},	//   _mató_, kodž, _swem, mató,
   {{0x3cddc033,0x9cd62076,0x2cad8071,0x81b000a2}},	//   _खिले_, _קורה_, _pued_, _kaɓa,
   {{0x3eaeeff6,0x6609cff7,0x69cf4018,0xdb156071}},	//   _luft_, veek, _iece, _pezó,
   {{0x6fbf2077,0xfaf8e018,0x81b000e8,0x2fcd83c5}},	//   ्रिं, ktī_, _maɓa, _weeg_,
   {{0x3ea5accd,0x7a3cc004,0x200b006f,0x61fbcff8}},	//   _vilt_, _rétr, keci_, tful,
   {{0x3cdea12f,0x27ff813b,0x7ae9c108,0xdb02cff9}},	//   _गिरे_, _ubun_, tuet, _egoí,
   {{0x14ddc010,0xd5b1a067,0x7d1c249f,0x2ca6c0fd}},	//   _मिळण, _các_, zvrs, _diod_,
   {{0x6e3b8ffa,0x69cf4ffb,0x7c3b8ffc,0x7ae9c108}},	//   _houb, _lece, _hour, ruet,
   {{0x491447a7,0x764d0157,0xc7b2a095,0x7d1bc59f}},	//   _नैनो_, _blay, _סבא_, svus,
   {{0x7ae48b53,0xc1c628b1,0x9c7d00e4,0x644d0ffd}},	//   šite, वर्ग, trča, _clai,
   {{0x386dc8ef,0xd1b8c8b5,0x64bae13e,0xa2c1804b}},	//   mner_, _رانا_, _aċid, रीच्,
   {{0x7c3aa057,0x68e44ffe,0xe8df4119,0x7ae44fff}},	//   _xotr, vrid, _chọc_, vrit,
   {{0xb5fb0803,0x69c45000,0x69cf5001,0x63833002}},	//   vnáv, tbie, _bece, вгра,
   {{0x7c3b9003,0xb5fb4057,0xb87b213a,0xbf2820f9}},	//   _nour, _amáb, brío, _aṣòr,
   {{0xd91060d0,0xd5af2043,0x69ce6065,0x6d43a1cd}},	// [a80] گیز_, افہ_, _pebe, hyna,
   {{0xe29761d3,0x6aa76200,0x7aeb9004,0xff5f0004}},	//   дау_, _cijf, dugt, raît_,
   {{0xf8d22ad3,0x3ea7ec90,0x7c298037,0x68e44090}},	//   _तबिय, _mint_, _bner, srid,
   {{0x2a6dd005,0x5ee0e5cb,0x3ea7ed53,0xdb03e049}},	//   jneb_, _किस्_, _lint_, _ngní,
   {{0x17c7414f,0x2d87e155,0x2ac441e9,0x2d9161b6}},	//   _ігри_, _lyne_, _débò_, _ezze_,
   {{0x38b41006,0x22469007,0x3ea6cc2c,0x6721a0a9}},	//   _mär_, skok_, _siot_, _brlj,
   {{0x212240c7,0xdb052067,0xb5fb0803,0x2bc47008}},	//   _hrkh_, _nghì, dián, _ल्या,
   {{0x9c7d00a9,0x69c5a069,0x3914cf27,0x6721a3ee}},	//   ručk, ðher, емир, _drlj,
   {{0x2ca7e725,0xd7e6e71b,0x5fb260c2,0xd90ea0e0}},	//   _bind_, міно, _जलाल, _چیت_,
   {{0x7c3c6108,0x2bcc83af,0x7e6081e7,0xb5fdc098}},	//   _jorr, ारवा, _hmmp, tišc,
   {{0x386dc2bd,0x7c3b8095,0x81b001df,0xdb1af009}},	//   bner_, _your, _saɓa, vató,
   {{0x6e3b8005,0xb33ca17a,0xb87b2049,0x63adf00a}},	//   _xoub, _ngħi, trío, _şant,
   {{0x6e3c6854,0x629601e7,0x58872052,0x2bbfe180}},	//   _oorb, _dhyo, дыва, _श्वा,
   {{0x36d4e0ff,0xe167c0eb,0x7d1d022e,0x69a02321}},	//   _зокр, _تضمی, rvss, _गृही,
   {{0xdb1af00b,0x7e6d436c,0x442d700c,0x78a8b00d}},	//   rató, tnap, _đe_, _midv,
   {{0x200cf00e,0xd5b800ff,0x3ce6900f,0xdb172071}},	//   ledi_, _ось_, krov_, _sexó,
   {{0x67294098,0xdef8465d,0x61fe6885,0x81ca607c}},	// [a90] _šejb, дых_, ffpl, োলন_,
   {{0x2a64c1fc,0x200cf010,0x6280cdd8,0x3ce6875a}},	//   himb_, nedi_, homo, drov_,
   {{0xe3b04043,0x6aa76200,0x69c7200e,0x78a76171}},	//   ارہ_, _vijf, mbje, _vijv,
   {{0xddc2823d,0x22842156,0x7bd53011,0x62560098}},	//   tnoš, sökt_, lazu, nšop,
   {{0x386dc042,0x442b5012,0xdee586bd,0xfbd08050}},	//   vner_, _inc_, холи, شتن_,
   {{0x02e08857,0x6e3b8157,0x64906052,0x442a7013}},	//   _निरभ, _woub, läin, _gnb_,
   {{0x7c3b9014,0x63ad1015,0x3ea7e090,0x6722c1e9}},	//   _tour, _ogan, _rint_, _aroj,
   {{0x44f8ee11,0x2ca90022,0x7c2ae105,0x65946734}},	//   dé_, _niad_, _anfr, _расу,
   {{0x64aaa04a,0x25ad9016,0x628521fb,0xd706c052}},	//   _přic, _igel_, _okho, еные_,
   {{0x2ca7e0dd,0x6721a0e4,0x628b9017,0xd9ee210a}},	//   _qind_, _trlj, llgo, _जाइत_,
   {{0x44f8ee41,0x65694066,0x79898939,0x63adf018}},	//   gé_, _žehl, _hyew, _şans,
   {{0x60cd02e0,0x7659819f,0xd838a6ca,0x38b40262}},	//   _bwam, _çayı, _riči_, _pär_,
   {{0xddc45019,0x660d4265,0xa49b61e9,0xc56bc50f}},	//   jniš, deak, _apòm, _بحال_,
   {{0x44f9c163,0x661bd01a,0x6449c052,0x2451c066}},	//   mè_, lduk, lkei, _dáme_,
   {{0x63bb8ee2,0x38b400cb,0x68fbd01b,0x6e3d43c5}},	//   _ofun, _wär_, ltud, _bosb,
   {{0x6449d01c,0x6485c057,0x7e76204d,0x6e3d501d}},	//   nkei, cóit, _šapč, _cosb,
   {{0x7aed501e,0x68fbc9fe,0xadee2010,0x44f9c0d1}},	// [aa0] guat, ntud, _जाऊन_, nè_,
   {{0x4ad3edf1,0x628b8996,0x69d5301f,0x32194095}},	//   _दबाव, elgo, caze, _easy_,
   {{0x20195020,0x2484805d,0x09d8a07c,0x68fbc046}},	//   _fasi_, _pkmm_, সলমা, htud,
   {{0xdb01f021,0x442b42a8,0x60c28552,0x2ee69022}},	//   lcló, _gnc_, tpom, trof_,
   {{0x69d65023,0x20187024,0x23722041,0x200ce0e0}},	//   maye, _tari_, šajā_, yedi_,
   {{0x2fc69025,0x67240320,0xb87b2057,0x661bc2c7}},	//   sbog_, _mrij, buíu, eduk,
   {{0x201a3019,0x60c287c1,0x1bee204b,0x27e01026}},	//   _mapi_, spom, _जाईल_, _odin_,
   {{0x75241027,0x6618e274,0x64a39028,0xd497c1ba}},	//   _oriz, _savk, _баса, нры_,
   {{0x7bdf0153,0x57cc8026,0x6618e6ca,0x7bd527ed}},	//   _rdqu, ारीह, _pavk, yazu,
   {{0x63a48edc,0x69d65029,0x07a6a19d,0x443ce048}},	//   žins, haye, _зазн, _qov_,
   {{0x6723e875,0xe8026eb5,0x7bd5302a,0x38b64271}},	//   _crnj, र्या_, vazu, _lær_,
   {{0x442cb02b,0xa3c3c260,0x386688cd,0x201a2561}},	//   _hnd_, ्रण_, nior_, _aapi_,
   {{0x661ab02c,0x7524012a,0x4ab54033,0xc43bc095}},	//   _katk, _criz, _अंधव, _מתאי,
   {{0x66040b01,0x7c3d4939,0xe80260ec,0x386685f1}},	//   _ebik, _sosr, र्मा_, hior_,
   {{0x7bc72cad,0x7c2bd02d,0x69d6502e,0xddc9902f}},	//   rbju, _yngr, faye, _lješ,
   {{0x69d53030,0x7bd65031,0xdb0aa156,0x1fcd61a6}},	//   saze, gayu, bbfö, _লাইস,
   {{0xc4c48043,0x6e2d1032,0x747c00be,0x067c01a9}},	// [ab0] _دے_, _inab, _מנהג, _מנהל,
   {{0x2bee2064,0x998dc23d,0x83fdc0e0,0x661ab033}},	//   _जाएं_, nješ_, lnőt, _natk,
   {{0x5b2461ba,0x7c2d068f,0xf12461ba,0xc885e105}},	//   льца, _knar, льцо, äßig_,
   {{0xddc9816d,0x22b82299,0xdb1aa019,0x3cea404b}},	//   _bješ, _učka_, _letó, _चमचे_,
   {{0xcc342896,0x64482277,0xa2cd4ca9,0x661d0109}},	//   _شریع, ödig, दीश्, idsk,
   {{0xa509a90f,0x78a98105,0x68e323d1,0x98be2013}},	//   дека_, _wiev, _ånds, štą_,
   {{0x44faa0dd,0xa1946197,0x93c6412a,0xa3d540c2}},	//   gë_, _барч, sfăş, _सजा_,
   {{0xa295803b,0x6e2d1034,0xaca3a1e9,0xdb03e3f6}},	//   _рабі, _nnab, _ipọn, _ngná,
   {{0xdb1aa06f,0xa3b94969,0x661bd035,0x32cf40c2}},	//   _betó, _चलन_, rduk, nży_,
   {{0x6723e3ce,0x6485c13a,0x644ab036,0xdb1aa057}},	//   _prnj, góir, ckfi, _cetó,
   {{0x29090037,0xc7b261a9,0x44f9d037,0x69d65038}},	//   _apaa_, יבי_, sè_, yaye,
   {{0x6281f039,0x3f6a103a,0x443eb03b,0x6485c13a}},	//   solo, димо_, _zot_, róis,
   {{0x7bc9d03c,0x249fd03d,0x3776087c,0x60c4e07f}},	//   mbeu, mmum_, тынс, _čime,
   {{0xc0e2c618,0x2d8c0041,0x6723e6ca,0xa2e62052}},	//   _тошк, āde_, _trnj, когд,
   {{0x6b63303e,0x6715e12f,0x7c3e206f,0x69d64a97}},	//   акра, _तनिक_, _vopr, taye,
   {{0x6604103f,0x6283b040,0x3dc94114,0x3eaa617a}},	//   _ubik, hono, gbaw_, _sibt_,
   {{0x93434b92,0x7bd65041,0x23d1a064,0x6e3e3042}},	// [ac0] анте, rayu, हराद, _topb,
   {{0x64a63043,0x443f8653,0x0715e66f,0x68e9cc1e}},	//   _шапа, _aou_, _तनाव_, ired,
   {{0x7bd64a85,0xd8770043,0x6493403c,0x69cee0c4}},	//   payu, _سمیت_, mçin, ðbei,
   {{0x076a833e,0x91e69044,0x5ee90148,0xdee37045}},	//   وماً_, тоде, _जिम्_, роци,
   {{0xd5b1a119,0x3ea05046,0x69c9d047,0x2ca04046}},	//   _cáo_, mmit_, dbee, mmid_,
   {{0xb7d8a049,0x76ac6106,0xdcf5c04a,0x975b0076}},	//   روبا_, _eşya, ůběh, ודנט,
   {{0xa3c1a5cb,0x200ea1cd,0x81d901a6,0xe8042e8e}},	//   ंड़_, refi_, ালত_, श्या_,
   {{0x442d858f,0x8c43804d,0xe4e3a0a8,0x38c8a0f9}},	//   _gne_, _кесе, _गिरि_, _aìrò_,
   {{0x66029048,0xb505801e,0x6aaae944,0x7afd0156}},	//   mfok, _مظلو, _piff, xtst,
   {{0x22f78095,0xad259049,0x44faa00e,0x63bc21e4}},	//   _בזמן_, _حرفو, pë_, jcrn,
   {{0x3958a536,0xd345a050,0x661b904a,0x2ac8a1e9}},	//   _års_, _میوه_, _yauk, _dìbò_,
   {{0x2ee9504b,0x98aa403b,0x3ce9904c,0x60daf04d}},	//   yraf_, mybė_, šave_, rstm,
   {{0x661d104e,0x764081e7,0x60dbc143,0x5fb26046}},	//   rdsk, _momy, csum, जशाल,
   {{0x6486e069,0xdb1c704f,0x2ca04046,0xe2982362}},	//   rðis, _berü, emid_, каў_,
   {{0x26c25050,0xadf7e13a,0xc7c7039d,0xdb0440e0}},	//   _atko_, _شروط_, _испи, kció,
   {{0x3ce940ca,0xbbcc8026,0x64409051,0x3ea04114}},	//   trav_, ारोक, _nomi, gmit_,
   {{0xdddc616d,0x6283b052,0x6724c00a,0x7d18e04d}},	// [ad0] _skrš, yono, _šijj, _hsvs,
   {{0xa2b0027d,0x2ee95053,0xfaff000e,0x1d6b633e}},	//   ंदर्, rraf_, mtë_, وصاً_,
   {{0x6ad1a046,0x201cf054,0xd3a7684f,0xd25147f0}},	//   _सबेर, _mavi_, трап, _هند_,
   {{0x62806057,0x67220143,0x7c2e615a,0x6d1e9055}},	//   _ímon, _šoji, _enbr, पिंग_,
   {{0x81d6207c,0x91e5a01b,0x69d8b056,0x629aa012}},	//   _হাত_, голе, fave, _bhto,
   {{0x69d8ae04,0x661c7057,0x2006c057,0x7ae9d058}},	//   gave, _gark, _aboi_, vret,
   {{0x39494cc5,0x64409059,0xa01b0851,0xdddc62d1}},	//   lyas_, _fomi, nlös, _ukrš,
   {{0x80d2807c,0x644d505a,0x3a2d8d5e,0xae1be98a}},	//   _সমর্, nkai, _unep_, _भोजन_,
   {{0xe800b05b,0x8cbb8050,0x2717a03c,0x201123cf}},	//   ल्हा_, _آدرس_, _mənə_, kezi_,
   {{0xa3c3c39f,0x62856066,0x7bc9c0f0,0x248dd05c}},	//   ्रह_, noho, sbeu, slem_,
   {{0xa06a0cdd,0x798d0650,0xe1ff007b,0x248dd05d}},	//   еана_, _ayaw, rión_, plem_,
   {{0x661d505e,0xddd6405c,0x6285632c,0xdb0565e0}},	//   _nask, chyň, hoho, lchó,
   {{0x3869505f,0xdb1d4019,0x6b8d00b1,0x6f074018}},	//   diar_, _mesó, _cyag, nībā,
   {{0x9f582197,0x39494dce,0x7bd99060,0x2cad9061}},	//   derò_, dyas_, hawu, _lied_,
   {{0x7c2f013a,0x610aa03c,0x201dd062,0xd00a412a}},	//   áirí, _gəld, _kawi_, неве_,
   {{0x3dcd607c,0x8c3d812a,0x70d1a026,0x62898088}},	//   _লাগল, _fişi, _सबैल, _nkeo,
   {{0x69d980bb,0x6d5bc3e8,0xb87b3063,0xed57401f}},	// [ae0] dawe, nzua, ruír, гот_,
   {{0x661c7064,0xed5a621a,0xc1cc9065,0xdb1af066}},	//   _qark, ноз_, ार्ग, ratö,
   {{0x3ead8067,0x9d462e1a,0xd9462ae2,0x7bd57067}},	//   _biet_, _сенд, _сени, _dezu,
   {{0x201dc058,0x69d8a1b7,0xa2cb0077,0x629b9068}},	//   _nawi_, wave, तीक्, _chuo,
   {{0xa06aa520,0x6e3bc098,0x7e69c14e,0xa3b9410a}},	//   нада_, djub, diep, _चलत_,
   {{0x764e3069,0xd252633e,0x26dca00a,0x9873aa0e}},	//   nkby, _انس_, tsvo_, бліц,
   {{0x6722880f,0x4420506a,0x3eaca042,0x60c40da8}},	//   svoj, odi_, _vidt_, _ltim,
   {{0x69d5706b,0x61e4106c,0x8fa6906d,0x2bc060ec}},	//   _zeze, _ndil, _бабе, शुरा,
   {{0x3254e1fc,0x78a28425,0x6aad06f9,0xa2dd4028}},	//   ивир, mmov, _riaf, _पिछ्,
   {{0x2d8cb06e,0xdb04403e,0x6d48f06f,0x291a3070}},	//   _tyde_, nciñ, tyda, _ospa_,
   {{0x9b94e1fc,0x69d600a0,0x78ad0024,0xa194ec78}},	//   ринц, _beye, _piav, ранч,
   {{0xc3336095,0x6ac3c07c,0x442fc1e7,0x24869071}},	//   צור_, _শিরো, _gng_, noom_,
   {{0x629c605c,0xdd252041,0xf3ff01ae,0x290da0a9}},	//   _ohro, dīša, sião_, čkaš_,
   {{0x9f582024,0x3cf1c066,0xa546e009,0x2717a03c}},	//   verò_, ňový_, _مضبو, _sənə_,
   {{0x6604417a,0xfe7f25df,0xa4d520ff,0xa91d8261}},	//   ffik, duït_, робі, _vyži,
   {{0x7bd57072,0x9f582197,0x24184772,0x2449e765}},	//   _sezu, terò_, лосы_, _rúmi_,
   {{0x629c600c,0xdb1d4057,0x69d56108,0xfaff000e}},	// [af0] _bhro, _resó, _peze, qtë_,
   {{0x69d98296,0x36d52b1e,0x7d1dc065,0xd37b64c2}},	//   wawe, _коор, æssi, нче_,
   {{0x53352307,0x629c628f,0x98518064,0x57b583d5}},	//   _тент, _dhro, nąć_, абет,
   {{0x6f0d0088,0x9f5c604a,0xa3b9410a,0xa3d65073}},	//   _kpac, ývá_, _चलि_, हरण_,
   {{0x6d5d1074,0xb814e033,0x2919418b,0x67244143}},	//   nzsa, तजाम_, _ussa_, cvij,
   {{0xcb69b075,0x6aaf4143,0xd009abcb,0x201eb044}},	//   кале_, _hicf, теке_, _cati_,
   {{0x7e69cb83,0xe454620e,0x6e3bc6be,0x7a41604a}},	//   tiep, _укры, tjub, _vítě,
   {{0x6d5bc265,0x7aed5076,0x21290381,0x3eb980b6}},	//   tzua, orat, _orah_, _ésto_,
   {{0x6ec1e041,0x44216569,0x7e69c09a,0xddd4017a}},	//   _mēbe, odh_, riep, ħaża,
   {{0x3209036d,0x6aae6048,0xdd252018,0x9a87a12a}},	//   _abay_, _xibf, zīša, _субл,
   {{0x69d60b02,0x7f75e280,0xe29a01e3,0x29004265}},	//   _peye, рупц, као_, ztia_,
   {{0x6442c171,0x38cae050,0xa06a0504,0x7e6b808b}},	//   _gooi, کایی_, тама_, nigp,
   {{0x201ea058,0x62872c48,0xe8e02067,0x624600f9}},	//   _yati_, fojo, _kiệt_, _bóor,
   {{0xb5fdc03b,0x7e66405d,0x69d60194,0x6da5e4c2}},	//   kišk, _smkp, _weye, _кила,
   {{0x9f582069,0xdd252041,0x7aed403a,0xdddc206a}},	//   gerð_, tīša, erat, gorš,
   {{0x6724c391,0x69dbc105,0xdb1c3077,0x629c7078}},	//   _šiji, naue, ncré, _shro,
   {{0x7aed5079,0x248a6037,0xdd252041,0x2d85307a}},	// [b00] grat, _pkbm_, rīša, üler_,
   {{0x7d16431d,0x6443f07b,0x4420507c,0x9adb01a1}},	//   rwys, _joni, sdi_, _שחיט,
   {{0x7aed507d,0x6f1b8057,0xb5fdc03b,0xe28680ba}},	//   arat, _asuc, gišk, алжи,
   {{0x7bdaf07e,0x44316200,0x6287102f,0x3a20005d}},	//   zatu, _enz_, čkog, _jaip_,
   {{0x2901600c,0x7529907f,0x6442c3be,0x60c97019}},	//   atha_, _crez, _rooi, _čeme,
   {{0xb5fdd080,0x7642d081,0x290ca05d,0x7bd72057}},	//   bišk, _sooy, _ppda_, _xexu,
   {{0xe3e9200b,0xdee365a8,0xfbcfa07c,0x29016049}},	//   אַפֿ, _мори, _রাখত, ctha_,
   {{0x5a34c3d5,0x6d4b9082,0xe81468c6,0xd90da6ec}},	//   снит, byga, ड़वा_, عین_,
   {{0x25fd6914,0x6247c071,0x610aa03c,0xb4e50292}},	//   र्की_, _años, _qəlb, _पटे_,
   {{0xa2e6a63e,0x64440090,0x3eb87083,0x6272a0c2}},	//   _вожд, _aoii, _kurt_, dłog,
   {{0xa3d768ae,0x7643e4b7,0x2fd8612a,0x62873084}},	//   सरत_, _dony, _merg_, vojo,
   {{0x7c209085,0xe704c050,0xe4db8026,0xd186c4e4}},	//   _jamr, _هستی, zšíř, _клей,
   {{0x44320026,0x27e6c35f,0x7c209086,0x64960049}},	//   _dny_, _idon_, _mamr, páin,
   {{0xea01c016,0x248ca17b,0x7ae2d087,0x68ed5088}},	//   _đẩy_, _jkdm_, _ivot, vrad,
   {{0x7e7de2a8,0x6e3ce277,0xa3e6804b,0xb05b2052}},	//   éspe, örbu, पणा_, npäi,
   {{0x200a6c65,0xd378e04d,0x877ba053,0x6e228143}},	//   _abbi_, gaće_, דאלי, jdob,
   {{0x451ca07c,0x291e629f,0x7aed5089,0x26c52013}},	// [b10] থমিক_, _štap_, urat, ūlo_,
   {{0xb5fdc03b,0x6443f08a,0x270ea03c,0x78b8e106}},	//   tišk, _xoni, _kənd_, _kuvv,
   {{0x3eb86017,0xfbd22095,0x62584049,0x6459908b}},	//   _curt_, _מתי_, _díob, thwi,
   {{0xd378e143,0x7ae2c133,0x24542262,0x23bd4031}},	//   caće_, _ovot, _jämn_, _dájó_,
   {{0xa2cb0010,0x6445259f,0x64960049,0x386900a2}},	//   तीच्, _kohi, dáil, _mmar_,
   {{0x6288e037,0x7bc2c005,0xdd282041,0x66152265}},	//   jodo, _afou, lēša, nezk,
   {{0x999a2041,0xc2126095,0x2903308c,0x3669d08d}},	//   _kopš_, _מהם_, ntja_, лако_,
   {{0x7bdc308e,0x7529908f,0x3eb95090,0x260f6028}},	//   zaru, _trez, _kust_, ड़की_,
   {{0x7bdd1091,0x4bd9e823,0x7d1b9092,0x69dd1093}},	//   dasu, льня_, _usus, dase,
   {{0x98c622e2,0x27e6c163,0x6b9b9094,0x2ab761f6}},	//   _žuči_, _edon_, _izug, _aħbi_,
   {{0x4432007d,0x4c8602a3,0x249f9095,0x29012022}},	//   _pny_, йлов, _khum_, _nqha_,
   {{0x7a3f00dd,0x229903e4,0x237dc05f,0xb9208096}},	//   _këty, téka_, _txwj_, _narị_,
   {{0x645bc256,0x8b68c0ff,0x68e9029c,0x7e7ec009}},	//   mhui, _київ_, šedn, éppe,
   {{0xb5fdc35d,0x65c33096,0x2a6dc02e,0xfbc33097}},	//   diši, збра, lieb_, збро,
   {{0x69d9d098,0x394dc0e0,0x2002e497,0x64453099}},	//   _kewe, lyes_, əki_, _dohi,
   {{0x7bdd109a,0xe8e04016,0x69d9d09b,0x44320258}},	//   casu, _suốt_, _jewe, _uny_,
   {{0xbbb84010,0xe29745d3,0xe8146033,0x69d9c07d}},	// [b20] _अलीक, сат_, ड़ला_, _mewe,
   {{0x68f52e01,0x69dc309c,0xb69b28d4,0xd9f9e077}},	//   buzd, qare, ltân, ्भित_,
   {{0x2ee04004,0x7ae400ff,0x290fc1e2,0x3ea00561}},	//   ssif_, _hvit, _lpga_, _khit_,
   {{0x7ae40488,0x443fcd79,0xfd50e1e9,0xb69b22e5}},	//   _kvit, jju_, _aidọ, ntân,
   {{0x9f4044cd,0xf772413a,0xb9216088,0x09cfa07c}},	//   rgió_, _راح_, _kasị_, _রাজা,
   {{0x9416803c,0x6e228b0a,0x6e20909d,0x6f02909e}},	//   _əgər_, sdob, _wamb, rtoc,
   {{0x6288f09f,0x3d01a064,0x6e21a025,0x7ae2c0e4}},	//   vodo, gów_, _dalb, _svot,
   {{0x6288e064,0x2480c12d,0x68e40987,0xdd1c2066}},	//   wodo, čimo_, _ovid, káže,
   {{0x645c2625,0x236050a0,0xb6a38ae2,0xb05b2052}},	//   khri, nzij_, _хитл, späi,
   {{0xddc3a1fc,0x443fc2f4,0x634ae497,0x7d0450a1}},	//   rinţ, aju_, yənd, itis,
   {{0x994aa50f,0x4614f0a2,0x7c2450a3,0x9f452181}},	//   _حلال_, موکر, kdir, ülü_,
   {{0x628ab0a4,0x877b60be,0x7645207d,0x6d4d50a5}},	//   lofo, ראטי, _sohy, yyaa,
   {{0x7c2450a6,0x644530a7,0x66152265,0x68e290a8}},	//   ddir, _pohi, tezk, nsod,
   {{0xa3cb4010,0x44e3e181,0x7bdaa00e,0x7ae90098}},	//   रुन_, bı_, _jetu, šeto,
   {{0x2600a5e8,0x7e6d50a9,0xd12ff0aa,0x7ea96013}},	//   _रानी_, tiap, _эх_, _užpi,
   {{0x3ea00057,0x2240400e,0x6abaa121,0x628ab0ab}},	//   _ghit_, gjik_, _mutf, hofo,
   {{0xdd282041,0x7d1e20ae,0x66032009,0xeabf4067}},	// [b30] rēša, _esps, _önko, _trùm_,
   {{0x386dc200,0x5c7530ac,0x7c22ca53,0x44d680c2}},	//   zier_, _флот, _laor, dł_,
   {{0x4422477c,0x104b874c,0xdd9b6bd2,0x984b8297}},	//   _fak_, ляди_, уша_, ляда_,
   {{0x644646ae,0x19a870ad,0x6e22c552,0xb5fdc015}},	//   _goki, ступ_, _naob, piši,
   {{0x70554050,0x68e410ae,0x9239a739,0x2a6dc02e}},	//   _هنگا, _xvid, ичку_, vieb_,
   {{0x442250af,0x7bdf4da8,0xe3bf4071,0x2fdd8022}},	//   _zak_, laqu, _dañe_, sawg_,
   {{0x249f90b0,0x7bd9c17b,0x7c22c030,0x8459c12a}},	//   _thum_, _pewu, _baor, ирит_,
   {{0x09e1e010,0x25e1e021,0x237f8223,0x27e910b1}},	//   पण्य, पण्ण, _txuj_, _ndan_,
   {{0x69daa987,0xe3bf4005,0x09d8a07c,0x7c22c515}},	//   _fete, _gañe_, _সারা, _daor,
   {{0x645bd0b2,0x3d01a064,0xdd1c2066,0x7c2450b3}},	//   shui, pów_, váže, zdir,
   {{0x69d9d0b4,0x2c0b6292,0xbb45e0d7,0x64a60936}},	//   _tewe, स्यं_, ценк, жана,
   {{0x7de640e0,0x7d0440c4,0x60c9807d,0xdb1c6106}},	//   _késő, ytis, _ktem, _terö,
   {{0x7bdaaaf8,0x28b550b5,0xafe5e052,0x60cd423d}},	//   _yetu, _अंगि, _долл, jpam,
   {{0xda0b6033,0x27e910b6,0xe939e0d0,0x69db8aaa}},	//   स्मत_, _edan_, _نسبت_, _leue,
   {{0x764650b7,0x96ba30b8,0x1faa2fb9,0x7bdf400e}},	//   _poky, ругу_, ркви_, faqu,
   {{0x31afc19f,0x31604108,0x7d0450b9,0xe1ff00c2}},	//   _gözü_, tziz_, ttis, diów_,
   {{0xc5d9207c,0x6446403b,0xd378e0e4,0x68e40454}},	// [b40] _তারপ, _voki, maća_, _uvid,
   {{0x212004b7,0x2d9670ba,0x7c2410bb,0x8b9662d3}},	//   _isih_, орес, _hair, ореч,
   {{0xdd0f2121,0x2905e2a8,0x7bdb8037,0x09d8a07c}},	//   mışt, ntla_, _beuu, _সালা,
   {{0x7c2610bc,0x634ae03c,0x87b9412e,0x6e23f0bd}},	//   ndkr, lənc, _гурт_, _lanb,
   {{0xcaa5813a,0xdca670be,0x69db90bf,0x69dab0c0}},	//   أصلي, _мами, _deue, _pete,
   {{0xab2a70c1,0xe9f90016,0x7529c0e0,0x2246c058}},	//   _кога_, _khả_, dvez, _sook_,
   {{0x7c22c04d,0x7659c1cd,0x81cfe07c,0x261ba026}},	//   _paor, _blwy, ষণা_, _यसरी_,
   {{0x7c2410c2,0x27e050c3,0x260b67f4,0x7c23e996}},	//   _nair, nain_, ठ्ठी_, _aanr,
   {{0x44268e12,0x4974d0c4,0x212d90c5,0x998dc106}},	//   mdo_, ялис, _greh_, rdeş_,
   {{0xb50e6028,0x6e23f0c6,0xa7fce0b0,0x61e9807f}},	//   _सहाय_, _canb, lnız, _zdel,
   {{0x6802c026,0x21200b39,0x7659c0e2,0xb5fb0910}},	//   _půjč, _asih_, _flwy, diár,
   {{0x644290c7,0x69c440c2,0xd7f7c9af,0x6618b0c8}},	//   njoi, jcie, _душ_, levk,
   {{0x8af8003c,0xe3afe0e0,0xddc2c0ba,0xd91000e0}},	//   _şərt, ٹری_, _emoţ, نیٹ_,
   {{0x68e450c9,0x270ea03c,0x09d34077,0x61e0c181}},	//   dsid, _gənc_, तर्य, laml,
   {{0x6e240004,0xcddb45da,0x9f5ef0ca,0x628b85d2}},	//   _faib, иња_, retó_, yogo,
   {{0xa8a44139,0x3ced3019,0xa3d92ef3,0x27e910cb}},	//   друк, čev_, ारह_, _udan_,
   {{0x64476026,0xb5fdc2c9,0xdb0e6031,0xb606a06f}},	// [b50] _poji, mišt, _agbà, _kráľ,
   {{0x69db8017,0x3f81205f,0xfbd06049,0x7bdf4c1e}},	//   _seue, _txhu_, نتم_, saqu,
   {{0x64476490,0x200120fd,0x69db90cc,0x30158607}},	//   _voji, _ichi_, _peue, здер,
   {{0xb17be00b,0x9d1a2095,0x69dc70cd,0x81d9007c}},	//   סטאר, _פורט, _eere, ালক_,
   {{0x69db8017,0xcfab2062,0xf77088b5,0x80dc61a6}},	//   _veue, _حاکم_, پان_, মূল্,
   {{0x94ba4095,0x44236022,0xbbb92026,0x628b8284}},	//   _למשת, _uaj_, _आलोक, sogo,
   {{0x6e252227,0x201910ce,0x78bd4249,0x6284d0cf}},	//   _mahb, kesi_, _husv, čion,
   {{0x78a2c032,0x787ec041,0x44268054,0x7c23f0d0}},	//   _chov, tīva, cdo_, _sanr,
   {{0x41b5d0d1,0x201910d2,0x61fbd0d3,0x201830d4}},	//   _ہمار, desi_, rgul, yeri_,
   {{0x98a92133,0x2ca950d5,0x7bdc603e,0x57b845cb}},	//   _brač_, hmad_, _xeru, _अल्ह,
   {{0x69c10026,0xdce7c121,0x7ae5600e,0xb5fdc00a}},	//   ělen, ğlık, nsht, fišt,
   {{0xfbcfa518,0x7bc5628f,0xdce7c121,0x6aa2c037}},	//   _स्तम, hchu, şlık, _ghof,
   {{0x6e23e60a,0xdbd9083e,0x321830d6,0x6258413a}},	//   _tanb, ræði, tery_, _bíon,
   {{0x645b8355,0xaadd80a8,0xd019c0c2,0x8b08204a}},	//   _llui, नीयक, leń_, jdří,
   {{0xceb2a3bc,0xdca64080,0x69dc70d7,0x6abd4669}},	//   תים_, зави, _rere, _ausf,
   {{0xb5fdc16d,0xf1bf0019,0xa3b825cb,0x2451c1e9}},	//   cišt, ldán_, _छलक_, _bámi_,
   {{0x29120167,0x6abc70d8,0x78bc70d9,0xcaa50678}},	// [b60] _upya_, _surf, _surv, _تصوي,
   {{0xc079e067,0xe9f90067,0xada630da,0xb87b29d7}},	//   _điệp_, _thả_, _напл, nsíl,
   {{0x69de2b9a,0xe8026028,0x7bde20ba,0x1c0260c2}},	//   _iepe, र्गा_, _iepu, र्गल_,
   {{0xdd8f601e,0x746980ff,0x7bdc70db,0x7520805d}},	//   دوم_, орів_, _weru, _psmz,
   {{0x2007403c,0xe29aa0fb,0x20076017,0x7ae610dc}},	//   əni_, бад_, ònic_, nskt,
   {{0x6490604e,0x2907a29c,0x1994a368,0x7c5a6049}},	//   räis, ftna_, маля, _السر_,
   {{0xfaa370dd,0x69dd50de,0x6493403c,0x80dbe07c}},	//   _чаро, _yese, rçiv, _মৎস্,
   {{0x628e2132,0x442490df,0x44268054,0x78a2c048}},	//   hobo, _uam_, qdo_, _qhov,
   {{0x61e0d0e0,0x851b0028,0x645da013,0xe803691c}},	//   raml, _पैंट_, _įsiv, _लामा_,
   {{0x7e6d00ae,0x20c1e119,0xd3e4a0eb,0x20c0c119}},	//   _smap, _bói_, _آقای, _vòi_,
   {{0xcfe1007c,0xcf8da0eb,0xfe45a63b,0x4f66aae5}},	//   _ভাবন, _پژو_, _تکنی, _عاطف,
   {{0x6b82c022,0xb606a066,0xf8aac60f,0x76bba076}},	//   _txog, _dráž, _увек_, _המאפ,
   {{0x7ac70d2b,0x321907ac,0xa3be008d,0x7eb5c012}},	//   ясне, resy_, ेड़_, _ušpa,
   {{0x98a9235d,0x8ca240c2,0x7522cf60,0x7bde2018}},	//   _trač_, _कीबो, _isoz, _cepu,
   {{0x3ebea046,0x4c9550e1,0x7c38f0e2,0x6aa40090}},	//   _jutt_, дивс, _invr, _fhif,
   {{0x5eb44841,0x61e28046,0x5597e076,0xeb97e076}},	//   ейст, jaol, _מדוע_, _מדור_,
   {{0x2ca950e3,0xad9b41e9,0x28b70029,0xa2b560ff}},	// [b70] rmad_, _abúr, _इंटि, дбач,
   {{0x645f400e,0x44386425,0xd019c0c2,0xe3bf42a8}},	//   shqi, _cnr_, zeń_, _daña_,
   {{0x7f1961ac,0xa1340555,0x2c0ee04b,0xb5fb03ab}},	//   تياز_, _قریش, त्यू_, chác,
   {{0x7ae560dd,0x2fdea005,0x645c70e4,0x7bc8a054}},	//   rsht, _aetg_, _elri, _afdu,
   {{0xe3bf42b2,0x645d40f7,0x68e5605d,0xf1b98012}},	//   _gaña_, _ilsi, sshd, _hašk_,
   {{0xef188a0e,0x7ae5600e,0x60cd0167,0x660da16d}},	//   ямі_, psht, _mtam, đako,
   {{0x752d50e5,0x7afaf0e6,0x61ed10e7,0x3a25a68f}},	//   lvaz, jutt, _odal, _valp_,
   {{0x60cd10e8,0xfbd390e9,0xa29480ff,0xcac9c04e}},	//   _otam, _ستر_, _засі, огие_,
   {{0xa3a96026,0x2d98eaf4,0x63bb90ea,0x764ae0ce}},	//   खेर_, üren_, _igun, _bofy,
   {{0x6fb1604b,0x4425b0eb,0x4426cb26,0x2bffc1a6}},	//   _जणां, _ual_, _eao_, ্যেই_,
   {{0x3ebea14f,0x27e20058,0x3555a1b3,0x64aac04a}},	//   _gutt_, takn_, _تناز, _přit,
   {{0x9ce7e043,0x628e30ec,0xecd560c2,0xdb1c20cb}},	//   _ہوتے_, wobo, डीएफ, rbrü,
   {{0x61fe6277,0xb5fb4326,0x9c7cd0ed,0x6e2650ee}},	//   ygpl, _mlád, _ovčj, _rakb,
   {{0x3ebf804e,0x60cd10ef,0xe3bf4005,0xda0ee067}},	//   _muut_, _dtam, _raña_, _hỏng_,
   {{0x92e8e13a,0xe1ff10f0,0x644bc35f,0x44386090}},	//   _فريق_, giós_, _kogi, _rnr_,
   {{0x61e3b0f1,0x98a3424a,0x10a3439d,0x69d52022}},	//   hanl, висе, висн, abze,
   {{0x672d484e,0x3cf54064,0x6e26423c,0x1d074474}},	// [b80] gvaj, एंगे_, _vakb, мети_,
   {{0x61ed10f2,0x672410f3,0x752400bb,0x27ed8ce6}},	//   _zdal, _isij, _isiz, _aden_,
   {{0xa057200b,0x7c29d0f4,0xe9ff8016,0xdb03e057}},	//   _חסיד_, kder, _soạn_, _ignó,
   {{0xf8bf45e0,0x64922065,0x644bd0f5,0x29094025}},	//   _fué_, pæis, _nogi, btaa_,
   {{0x60c9403c,0x7d09c00e,0x3e77417a,0x94aab0f6}},	//   _çemp, jtes, għtu_, отка_,
   {{0xdd1d21ce,0x3a27e0ae,0x3e720013,0x644bc090}},	//   lášt, _nanp_, kšto_, _aogi,
   {{0x69c98035,0xeb97654a,0x90c3653f,0x09e2c1a6}},	//   _ffee, _жир_, _абсе, _যাবা,
   {{0x7766005d,0x8fa370f7,0x6e29d0f8,0x7d09d0f9}},	//   kzkx, _расе, gdeb, ftes,
   {{0xf50381e1,0xd7cfa180,0x7afc30fa,0x20048037}},	//   _изто, _स्वच, hurt, _icmi_,
   {{0x2745000e,0x661c2749,0x6579a049,0x0c26a19d}},	//   _lënë_, jerk, ábhá, _імен,
   {{0x27e010fb,0xddc400e4,0xc7b8e53d,0x2129c579}},	//   _bein_, _smiš, jeđe_, _šaht_,
   {{0xd9ad007c,0x201cb0fc,0x61e0807f,0x2246848d}},	//   _ক্ষম, levi_, _jeml, njok_,
   {{0x7d09d0fd,0xfc67c01c,0xed5800db,0x644af0fe}},	//   ctes, _تخلی, доў_, _tofi,
   {{0x7afaf0ff,0x3e7ac018,0x752d4361,0xddc9d100}},	//   putt, dīti_, vvaz, mieš,
   {{0xdd9420db,0xa3b15101,0x2745000e,0x752400bb}},	//   вары, टेन_, _bënë_, _esiz,
   {{0x7c276050,0x2cb86420,0xe1ff0017,0x3ce986ca}},	//   _sajr, _aird_, riós_, šavi_,
   {{0xd7d02216,0x1fabaaa1,0xaca32125,0xddc9c041}},	// [b90] _त्वच, _चण्ड, _ajụg, nieš,
   {{0x3b0941f6,0xcf9b61e3,0x443a3102,0x2cbf9103}},	//   rtaq_, оје_, _gnp_, _ruud_,
   {{0x03d62095,0x61e4428f,0x3de3e07c,0x3a29031d}},	//   _אותם_, bail, _মামল, _kaap_,
   {{0x7c28a10a,0x603e812a,0xfe100067,0x2c6d200a}},	//   _aadr, _rămâ, _lắng_, dždi_,
   {{0x3a291104,0x6e2761d7,0x61e3b105,0x09e2207c}},	//   _maap_, _tajb, tanl, _বাতা,
   {{0x6282d106,0x38a1d107,0x68fbc052,0x7afbc052}},	//   _ajoo, dóra_, vuud, vuut,
   {{0x3ea6c153,0x629af108,0x2bae6914,0x2055d109}},	//   _bhot_, dlto, झेदा, етпр,
   {{0x7c29d10a,0xfbb82095,0xdd9585be,0x6f09d10b}},	//   uder, ופות_, _забы, ttec,
   {{0x2b908050,0xfe0ee067,0x38a1d10c,0x4427f10d}},	//   _پیوس, _vững_, góra_, _pan_,
   {{0x6009ebcb,0x6e3b8022,0x6e29807d,0x68fbd10e}},	//   чном_, _hnub, _haeb, ruud,
   {{0xd6cee896,0xd70b407c,0x20004025,0x2d994271}},	//   یقی_, রিয়া_, ygii_, _lyse_,
   {{0x68fc2271,0xf1bfa119,0x4429110f,0x26050b27}},	//   vurd, _đáy_, _caa_, _वाणी_,
   {{0x44291110,0x200ac03c,0x2745000e,0xdbc68046}},	//   _daa_, əbi_, _rënë_, _tööd,
   {{0x7c298aaa,0x7860603c,0x61e440a2,0x7c28b111}},	//   _laer, _mövc, wail, _xadr,
   {{0x96960da4,0x7c3b8916,0xf0fe64d6,0xb5fb0049}},	//   _приш, _onur, _उमेद_, mhán,
   {{0xa3cb410a,0xfbda007c,0x9f4204b7,0xf41f4156}},	//   रुल_, _থাকত, haké_, _skär_,
   {{0xd9f3f112,0x65b68602,0x5f4660e0,0x752400bb}},	// [ba0] _आयात_, _mühü, کنال, _usiz,
   {{0x6013a3df,0xdbd64052,0xf1b989a3,0xcfb70076}},	//   nımı, _sääd, _gaši_, _אלפי_,
   {{0xb346e1ae,0x779420d0,0x26c1208b,0x20c60067}},	//   maçõ, _شیرا, _guho_, _hôi_,
   {{0x62957113,0x68fce5df,0x7ae9d114,0x61e61115}},	//   _ekzo, àrdi, kset, nakl,
   {{0x224d854c,0x4525e1a6,0x6e3b813e,0xb4dec046}},	//   _doek_, যমিক_, _dnub, _तबे_,
   {{0xdceb00e4,0xd467b116,0xb346e1ae,0xe805a7af}},	//   šićn, ниче_, naçõ, _राणा_,
   {{0x35a37117,0x7afd1118,0x20c60067,0xfaff000e}},	//   _барг, zust, _lôi_, jzën_,
   {{0x60c1a025,0x64599083,0x2005a2a4,0xf99f40f9}},	//   _dulm, ckwi, _ecli_, _gbès_,
   {{0x60c0808b,0x7afe7119,0x201cb11a,0xb5fca13e}},	//   _uumm, lupt, pevi_, _alġe,
   {{0xb602e295,0x7afd06eb,0x60c1a197,0x3eadd11b}},	//   _část, vust, _fulm, amet_,
   {{0x7afd023c,0x60c1b11c,0x63a4111d,0xa5f9111e}},	//   wust, _gulm, _azin, мену_,
   {{0x2cadc037,0x5186c0ba,0x69c0111f,0x26c12552}},	//   cmed_, _пула, žmen, _ruho_,
   {{0x442a61ae,0xf1b98018,0x75264012,0x61e57120}},	//   _oab_, _paši_, _nskz, yahl,
   {{0x61e1a17a,0x24804037,0x20052009,0x7afe7121}},	//   _xell, enim_, üli_, kupt,
   {{0x29882822,0x1995214a,0x26c25122,0xdff4c10a}},	//   есто_, тавя, _auko_, _इयाद_,
   {{0x442a7123,0x7c2af124,0x4b37e076,0xa3cb44e5}},	//   _aab_, _hafr, _טרול_, रुं_,
   {{0x59d4013a,0x6702a04b,0xb4dec10a,0x3f9e20c4}},	// [bb0] _صغير, रंडक_, _तबो_, ýtur_,
   {{0xaaa50ff1,0x224d8f06,0x3eb94200,0x3eadc121}},	//   _गीतक, _soek_, _wist_, zmet_,
   {{0x7afe61f6,0x764e66c4,0x7c2ae04a,0x290ce746}},	//   gupt, _doby, _mafr, ntda_,
   {{0x43759125,0x64960049,0x61e56745,0xf993e053}},	//   култ, láir, sahl, ארע_,
   {{0x85b84841,0x20c60119,0x61e561fb,0x09d8a1a6}},	//   _плюс_, _xôi_, pahl, _সাজা,
   {{0x80d3807c,0xc7b8a098,0x443ce098,0x6e2d5126}},	//   _সিদ্, _lađu_, _nnv_, ldab,
   {{0xc984673f,0x442b5127,0x27e68d87,0x9f420050}},	//   _бути, _kac_, baon_, raké_,
   {{0x443cf128,0xc7b8a29f,0x7aed1129,0xcd4280e0}},	//   _anv_, _nađu_, _ovat, _چھوٹ,
   {{0x51878084,0xef19c0ff,0xd706c04e,0x22848498}},	//   _чува, ємо_, вные_, _сург,
   {{0x201ef12a,0x64aac020,0x442b512b,0x3e7ac018}},	//   geti_, _aƙid, _lac_, dītu_,
   {{0x7d0d4419,0x20c60067,0xb346e1ae,0xf1d2c4ba}},	//   htas, _sôi_, vaçõ, _ध्वन,
   {{0x443cf12b,0x6e2d4022,0x442ce1cd,0x7c2ae227}},	//   _env_, jdab, add_, _eafr,
   {{0x60c2c0e8,0x443cf12c,0xb8138077,0x7ebef12d}},	//   _guom, _fnv_, ण्यम_, _rūpe,
   {{0x31568053,0x10a6312e,0x61e6112f,0x443cec1e}},	//   דישן_, тигн, sakl, _gnv_,
   {{0xdee3245c,0xafe32607,0x2ca9028f,0x38a42156}},	//   иори, росл, _fhad_, göra_,
   {{0xdcf4400a,0x3e646b2f,0x6d444265,0x61e3f130}},	//   žačk, _möte_, txia, _henl,
   {{0xa80666fe,0x7d0d4d72,0x80c8407c,0xf7460a09}},	// [bc0] кзал, gtas, _লিঙ্, _репо,
   {{0xe3b8e602,0x3f9a27ac,0x4463690f,0x037a67f9}},	//   mdır_, _typu_, авув, وحات_,
   {{0x09e69131,0xf1b9816d,0x61e41132,0x661e659b}},	//   воен, _mašu_, _keil, repk,
   {{0x68fe607d,0x90e68050,0xd25980ff,0x644f4143}},	//   rupd, نستن, нці_, _goci,
   {{0xf11ef133,0x645ae342,0xa06ab0ac,0x2ee000d1}},	//   _बन्द_, ykti, мада_, _jwif_,
   {{0x61e41134,0xdce1a20f,0xc7b821e4,0x66045135}},	//   _leil, _aylı, žđu_, lgik,
   {{0xc0e37136,0x60c403f6,0xe297612a,0x78bab137}},	//   _воск, _luim, _рар_, _vitv,
   {{0xbbc100a8,0x645c200e,0x765bc114,0x6abb8197}},	//   _एलेक, hkri, gkuy, _giuf,
   {{0x9f494069,0x7eb8f138,0x2ca901cd,0x0906839d}},	//   ngað_, нгис_, _rhad_, _шпан,
   {{0x443dc0e2,0x61e3f139,0x61e2d13a,0x60c3ef87}},	//   _enw_, _cenl, _weol, _bunm,
   {{0x2c146029,0x442dc271,0x6e2bd13b,0xb87b24d2}},	//   न्यू_, bde_, _fagb, príz,
   {{0xb87b21ae,0x752440b1,0x201eeed9,0x442ae06e}},	//   nsív, kwiz, seti_, žb_,
   {{0x290dc07b,0xd877213a,0xda65c049,0x39468609}},	//   ctea_, ناسب, _حالي, nxos_,
   {{0x60c3e0f9,0x442b512b,0x26c48cc5,0x394686c7}},	//   _funm, _sac_, _mumo_, ixos_,
   {{0xac19513c,0x645d000e,0x200765df,0x25a52156}},	//   нову_, ëris, ònim_, åll_,
   {{0x2004c939,0x80d3807c,0x9c7d0013,0x4e0ee026}},	//   ngmi_, _সিস্, ksči, त्रै_,
   {{0x78bc600a,0x60c4113d,0x2900513e,0x7524513f}},	// [bd0] _birv, _guim, guia_, gwiz,
   {{0x6aa99140,0xd37b667b,0x648b6018,0x21291141}},	//   _shef, мче_, kļie, _isah_,
   {{0x442dc654,0x9f4e00e0,0x27e37142,0x9ed96b15}},	//   yde_, önöm_, _vejn_, хмет_,
   {{0x442b5143,0x41b4c7d9,0xe0df40d1,0x5fb4c077}},	//   _uac_, ुशास, _twò_, ुशाल,
   {{0xe9d880db,0xee3f403a,0xed46c0e0,0x3959005d}},	//   ткі_, _iný_, _اپ_, nyss_,
   {{0xc1b84139,0x6e2d0054,0x68ed4bf2,0xf1b9c579}},	//   _шлях_, _laab, msad, ješa_,
   {{0xe3b8e181,0xd7e3004b,0x62829144,0x9f47a00e}},	//   zdır_, पराच, bnoo, manë_,
   {{0x3e7ac041,0x0c25d145,0x2499417b,0x7af6803b}},	//   dīts_, умин, _jksm_, šyta,
   {{0x645bc2bb,0x387c80fa,0xf77f01ae,0x625cc7da}},	//   rkui, èvre_, daço_, _géom,
   {{0x68ed401f,0x645bd146,0x1dc7b101,0x61e52f75}},	//   isad, skui, _ललित, _nehl,
   {{0x442d80eb,0x6d599147,0xf1b98fe8,0x3ce000d1}},	//   _kae_, lywa, _vašu_, _swiv_,
   {{0xe43c404a,0x6e2d0025,0x8335c233,0x9f45e066}},	//   _příč, _caab, _مرتض, nalé_,
   {{0xc879c3df,0x27e08232,0x81e9607c,0x61e8f148}},	//   miş_, ðini_, _যান_, badl,
   {{0x7aed5149,0x3f9e0041,0xfc3f40f9,0x7e62c2c9}},	//   dsat, ātu_, _aní_, _zlop,
   {{0xfe70e0d0,0xa96a239d,0x672440f7,0x95e961a6}},	//   _بدن_, хива_, wwij, খলাম_,
   {{0x442d914a,0xc006114b,0x3eaa605d,0x1df3e029}},	//   _nae_, _спик, _shbt_, _आयुष_,
   {{0x61e5314c,0x2d850121,0x7ae9006f,0x42562ca7}},	// [be0] _fehl, şler_, šetr, _منظر,
   {{0x291a217b,0x2bd0279e,0x68fbc05d,0x6e2d000d}},	//   _tppa_, तुशा, irud, _zaab,
   {{0x6724514d,0xf1a82295,0x6e2d0ad5,0xfba8314e}},	//   swij, _गरिन, _yaab, _गरिम,
   {{0x443f8037,0xb4fb24ac,0x7aed4025,0x6b7b2679}},	//   _cnu_, _אפטי, bsat, _טרינ,
   {{0xf8c8c016,0x20c9c016,0x7e760057,0x6296514f}},	//   _mức_, _núi_, _mmyp, moyo,
   {{0xb4c04518,0xf772a043,0x6e20cc75,0x4421643d}},	//   ँदी_, یاں_, wemb, ceh_,
   {{0xb8eb8738,0xd378e381,0x443ea013,0x60c64264}},	//   _रू_, paći_, _vnt_, _hukm,
   {{0x6e2e7150,0x6d41635d,0x5454d151,0x62953152}},	//   _habb, _šlag, рвит, zozo,
   {{0x127b849c,0x7c2d1153,0xa8574095,0x270ea03c}},	//   _נאמע, _raar, טיקה_, _məni_,
   {{0x60c64ce1,0xb9094291,0x5c14007c,0x3f14e331}},	//   _mukm, _achị_, িযোগ_, адос,
   {{0x44221154,0x3606c0a4,0x61e5205d,0x249fc8a3}},	//   fek_, _مواف, _rehl, blum_,
   {{0x6e2e7155,0x60c53074,0x21b500ff,0xdee6d156}},	//   _labb, _ruhm, ийня, _боди,
   {{0x7c93c13a,0xd9e46029,0x7d028013,0x290160a9}},	//   _النص, गरात_, nuos, zuha_,
   {{0x7c229157,0x25eee04b,0xae03698a,0x69ba40c2}},	//   heor, _आयटी_, _लाइन_, ्शनी,
   {{0x62953158,0x634ae03c,0x6d5980c2,0x4421615e}},	//   rozo, kəni, zywa, veh_,
   {{0xddcd5159,0x2bdd6260,0x7ae2d15a,0x291ce1de}},	//   snaž, यर्थ, _kwot, _ipva_,
   {{0x634ae497,0x442ee797,0xf3ff001f,0x69dc315b}},	// [bf0] dəni, _kaf_, lhão_, bbre,
   {{0x2901715c,0x443f915d,0xe70400e0,0x3ea0515e}},	//   tuha_, _snu_, _اسٹی, alit_,
   {{0x2614655d,0x442d8292,0xc879c602,0xfbd681a6}},	//   न्धी_, _pae_, yiş_, _হয়ত,
   {{0x6d598064,0x44e1a03b,0x473583a5,0x6f028197}},	//   tywa, vų_, инес, fuoc,
   {{0x2903204e,0x29112265,0x2901715f,0x61458677}},	//   luja_, ltza_, suha_, рела,
   {{0x2c146a08,0x5fcfaaa1,0x9f47a050,0x2bd58077}},	//   न्दू_, _स्खल, lané_, _ड्रा,
   {{0x32582095,0x83fd80e0,0x6845d156,0x270ea03c}},	//   רסום_, _előa, инка, _yəni_,
   {{0x2baa7160,0x29021161,0x764d5162,0x3ebea31b}},	//   _करता, yuka_, njay, _eitt_,
   {{0x44e1a013,0x27e6c155,0xb225e7ab,0xe664840e}},	//   sų_, _deon_, ампл, _утро,
   {{0x69c2ce3b,0xaa7b6d3f,0x61eb9163,0x9f47b164}},	//   _egoe, _zvýr, lagl, hané_,
   {{0xfe46004e,0xc4f8a4a1,0xe80a0033,0xa9a5e2f0}},	//   анно, _معنا_, _वादा_, ринд,
   {{0x7c2f450e,0x54a7cdb3,0x61e77165,0xb5fb413a}},	//   _nacr, _صحاف, _lejl, _slán,
   {{0x76b2e064,0xdee5c60f,0x8c45eef0,0x673b4098}},	//   _płyt, _толи, _веле, _šujn,
   {{0x05a8c0ff,0x3ebf805d,0x270ea03c,0xe7f20026}},	//   _свій_, _liut_, _səni_, _आएका_,
   {{0xddcd0686,0x60c65166,0xcec8c016,0x7afd1167}},	//   _ulaş, _sukm, _tộc_, arst,
   {{0x7e7bc13b,0x6e23b168,0x6aad1169,0x3f8c217a}},	//   niup, henb, _ghaf, ħdu_,

   {{0x61eb916a,0xe29a601f,0xb89b0095,0x29112265}},	// [c00] dagl, ваа_, _בבקש, atza_,
   {{0x6aa4c1d7,0x7c2e6025,0x60c6420d,0xe45f6156}},	//   ċifi, _qabr, _vukm, _stör_,
   {{0x6e23b16b,0x6e2e665f,0x7e7c200a,0xd946316c}},	//   denb, _vabb, mirp, _тени,
   {{0xeabf465f,0x7d02916d,0x61eb865f,0x68e4116e}},	//   _giù_, tuos, gagl, _kwid,
   {{0xf9924938,0x2fd16012,0x634ae5fc,0x61eaa765}},	//   _ذبح_, _ffzg_, rəni, tafl,
   {{0x5c73a0ff,0x81b5607c,0x7ae4116f,0xe283a471}},	//   оліт, ছুই_, _mwit, олчи,
   {{0x7c22807b,0x3266c52f,0x721b6557,0x2bd340c5}},	//   peor, итив, _שולח, धुवा,
   {{0xd576893b,0x8af0403c,0xddcd020d,0x245c41e9}},	//   _кузь, yyəl, _omaš, _bími_,
   {{0xbebb600e,0x32cb814f,0x7d028425,0x3ebea4f0}},	//   _rrëz, _gøy_, quos, _titt_,
   {{0x6738e098,0x6e244105,0xb5fb4031,0x44325170}},	//   _prvj, heib, _alál, hdy_,
   {{0xdd94e056,0x7e7ae156,0x7ae41171,0x7d03b172}},	//   саны, ritp, _awit, cuns,
   {{0x7d0365df,0xd498007a,0x6d5bc022,0x7ae4000f}},	//   ànsi, иря_, byua, _bwit,
   {{0x236dc064,0x78a2805c,0xac18e04d,0xd378e29c}},	//   czej_, ilov, _болу_, vaću_,
   {{0x7ae40058,0x3d0760c2,0x38694025,0x60c09173}},	//   _dwit, _हमले_, whar_, _limm,
   {{0xee87004e,0x2c1624e5,0x4df88295,0xf0b420ff}},	//   _выпо, द्धं_, ुलाई_, ійсь,
   {{0x4e196c87,0x60c09174,0x61e76065,0x6e23b175}},	//   न्नई_, _nimm, _sejl, zenb,
   {{0xa2caf176,0x61eb9177,0x611a8041,0xe9df1178}},	// [c10] _सूत्, vagl, nālā, mbú_,
   {{0x6f03a3ed,0x7e7d1179,0x7e6060ba,0x38a9a3e4}},	//   yunc, lisp, _împl, kúra_,
   {{0x61136026,0x7bc5317a,0x6e23b04d,0x7ae4117b}},	//   dělá, _ighu, venb, _zwit,
   {{0x83fd8009,0x3d074077,0x200ca194,0xbd446049}},	//   _előn, िंदे_, _acdi_, تنمي,
   {{0x5334404e,0xa5da000b,0x7c23a1e8,0x26088033}},	//   _деят, אַצי, tenr, _हारी_,
   {{0x95cb69b1,0x7eada06f,0x98a8004a,0xbcfb0009}},	//   _шума_, kúpe, _brně_, lzés,
   {{0x245c517c,0x6e23a5c4,0xb4c1b17d,0x649d0049}},	//   _sími_, renb, ंदे_, néis,
   {{0xc245d17e,0x3209492d,0x628ae055,0x442fc048}},	//   сник, ngay_, _ajfo, _qag_,
   {{0x225fd17f,0x6f056098,0xe939c63b,0x7c23a9cd}},	//   rkuk_, luhc, اسبت_, penr,
   {{0x224dc579,0x7c24401f,0x6d5d1180,0x2a66c098}},	//   sjek_, zeir, dysa, _elob_,
   {{0x44317181,0xe81968a1,0x27e7e0ff,0x24983182}},	//   _maz_, न्या_, _venn_, vorm_,
   {{0x201a205d,0x62860108,0x76880106,0x61ed5183}},	//   _sbpi_, unko, rıyo, jaal,
   {{0x60c1a013,0x2904d184,0x7c2560cb,0x628609ee}},	//   _kilm, cuma_, kehr, rnko,
   {{0xc0b2e016,0x76880121,0x7529d185,0x44317186}},	//   _mười_, pıyo, mwez, _naz_,
   {{0xcaa6413a,0x61ed5187,0x26088046,0xa967216c}},	//   مصري, faal, _हाली_, бира_,
   {{0x68e40227,0x61e99188,0x2c13e321,0xe9f90119}},	//   _twid, _neel, त्रं_, _khẽ_,
   {{0x291f8286,0x62872098,0xceb4403c,0xa3e7b008}},	// [c20] _npua_, bnjo, rmə_, परा_,
   {{0x6298b189,0x2a60422e,0x4432518a,0x7c2560cb}},	//   xovo, skib_, sdy_, gehr,
   {{0xb113c291,0x2912518b,0x27edca0c,0x629e2088}},	//   _bụkw, stya_, kaen_, _ikpo,
   {{0x61e8a089,0xe3bf01af,0x2effca94,0xa3af08c6}},	//   _sedl, leña_, kruf_, _करम_,
   {{0x753b918c,0x6443e04e,0x645600d1,0x86374095}},	//   _cruz, _onni, _moyi, _הרכב_,
   {{0x4424c064,0x60c1a054,0xa4d8a39e,0x200a318d}},	//   wem_, _cilm, адку_, ngbi_,
   {{0xb5fb40f9,0x27edd18e,0xb7db20be,0xf487a062}},	//   _amáy, faen_, אקצי, حانی,
   {{0x78a4518f,0xb881c06f,0x27e0517f,0x61e8b190}},	//   nliv, _šíre, nbin_, _wedl,
   {{0x753b9191,0x6d469192,0xe80d9193,0xdee3845c}},	//   _gruz, _škaf, _हाता_, _ноти,
   {{0x76441194,0x7e629195,0x26ca60bb,0x61ed400d}},	//   _aniy, lkop, _kubo_, zaal,
   {{0x2904cdc9,0x2129405d,0xd943b196,0xfe9b60be}},	//   suma_, zwah_, _нефи, ריימ,
   {{0x44321197,0xbddb4011,0xaa67095a,0x8c67031a}},	//   _cay_, _anèn, сток, стод,
   {{0x61ed5198,0x28be4292,0xd544e031,0x2e37c076}},	//   vaal, ्दनि, _bẹ̀r, _לראש_,
   {{0x29005199,0x76440814,0x61ed519a,0x656f0064}},	//   dria_, _eniy, waal, rzch,
   {{0x7c26119b,0x447be076,0x9f45ac1e,0xdd3a20ba}},	//   bekr, _תנוע, _pelé_, văţa,
   {{0x2900519c,0x38c94043,0x985d00c2,0x63a2c00d}},	//   fria_, لائی_, _błąd_, _kyon,
   {{0xbcfb00e0,0x61ee319d,0x90556423,0x463bc00b}},	// [c30] rzés, babl, овац, נעמע,
   {{0x6299919e,0x6dc76052,0x67ff4031,0x20094108}},	//   wowo, ссаж, _bàjà, sgai_,
   {{0x0ec4a626,0x99d7813a,0xfbab6056,0x645604ee}},	//   _लंगड, متشا, утай_, _yoyi,
   {{0x7e628c57,0x2c6ba065,0xf8c8c437,0x3e6ba0ff}},	//   gkop, _møde_, रदाय, _møte_,
   {{0x61e9919f,0x4425f1a0,0x212b01cd,0x62584049}},	//   _veel, yel_, nwch_, _tíor,
   {{0xb4db40f9,0x26c251a1,0xd378a012,0x351c0076}},	//   _aràg, _ziko_, _leću_, טודנ,
   {{0x6609c54c,0x63a2d1a2,0x61e991a3,0xb7fb083b}},	//   tgek, _ayon, _teel, ्लाम_,
   {{0x60dbd1a4,0x64572005,0x661c66ca,0x7e6291a5}},	//   tpum, _loxi, _zbrk, ckop,
   {{0xb5fb4082,0x2bdaf17d,0x6272a0c2,0x7d036057}},	//   _alák, _म्हा, głos, ánsf,
   {{0x0696e049,0x78a44454,0x60d8e0d5,0x63a1a0c2}},	//   ينية_, zliv, _btvm, _tyln,
   {{0xdb1fa04e,0x6e260009,0x44320095,0xf3f980ba}},	//   äväs, tekb, _pay_, _alţi_,
   {{0x6288f1a6,0x2c6ba3d1,0x764520fd,0xe81971a7}},	//   ando, _døde_, _anhy, न्ता_,
   {{0x26d94048,0x09c5207c,0x1c1ea0c2,0x7afb0274}},	//   _ntso_, ্রনা, _मॉडल_, šutn,
   {{0x95cbf1a8,0x7fb6c7f0,0x11da2049,0x81c141a6}},	//   _суда_, _ظهور_, شورة_, ুরা_,
   {{0x0595e050,0x645611a9,0x629e2098,0x63ad11aa}},	//   _باشگ, _toyi, _vkpo, _ezan,
   {{0x70b440e3,0x60c2c071,0x7bd562be,0x7e6d51ab}},	//   ंगेल, _xiom, _afzu, ghap,
   {{0x27e051ac,0x07a34455,0x26cb407b,0x2ca0008b}},	// [c40] rbin_, датн, _cuco_, _ikid_,
   {{0x249f805d,0x60c3e0a2,0x6d5e71ad,0xc4862b24}},	//   _akum_, _jinm, typa, _флок,
   {{0x26c251ae,0xb5fae053,0xd6cf64c7,0x7e6d40bb}},	//   _tiko_, שלעכ, نقل_, bhap,
   {{0xa5da6d0b,0x6289c0a9,0xd9464974,0x1b20c1a6}},	//   _प्रौ, jneo, _деми, বিতে_,
   {{0x28c36216,0x81e9607c,0xc5f3a07c,0xc1a6e029}},	//   _वंचि, _যার_, চ্ছা_, _ऑर्ग,
   {{0x63a400b1,0x248d8071,0x60c2d1af,0x395fc08b}},	//   _myin, _ejem_, _siom, dyus_,
   {{0x35a36e1d,0xe5a36974,0x20e820ba,0xed5a614f}},	//   _жарг, _жири, nşi_, _тов_,
   {{0x27eea069,0x2000a12a,0x65636065,0x7bc7600e}},	//   safn_, şii_, ønhe, _zgju,
   {{0xfd62f1b0,0x368ae26f,0xc7b8e098,0xf8af60e0}},	//   _fitọ, исон_, međi_, _سکے_,
   {{0x3ea691b1,0x61e286bf,0x60c3e38d,0x628391b2}},	//   llot_, lbol, _cinm, énov,
   {{0x3ea00561,0x443331b3,0xddc8e00a,0xe3b8e106}},	//   _bkit_, _rax_, pidž, ldız_,
   {{0x61ebd1b4,0x3ea0017b,0x248d01de,0x63a3e0fd}},	//   _gegl, _ckit_, õem_, _dynn,
   {{0x5d8504c7,0x2246c15a,0x6ecae466,0xa25b4926}},	//   سلسل, _inok_, _सूरु, _biôn,
   {{0xf8ca6292,0x20d08119,0xcfe741a6,0x7afb11b5}},	//   िदाय, _mài_, _ফাইন, šuto,
   {{0x7c28e0fd,0x26cb441a,0x7e6d51b6,0x6458e425}},	//   medr, _suco_, thap, _iovi,
   {{0x44f511b7,0x44332ded,0x63a7a22e,0xc7b8e012}},	//   _епис, _wax_, _øjne, jeđi_,
   {{0xa3af0046,0xe3bf05e0,0x63ad11b8,0xa3de8485}},	// [c50] _करि_, meño_, _uzan, _द्ध_,
   {{0x2a6dc6a6,0xa3a761e3,0x0b8840ff,0x2451c066}},	//   zheb_, ојек, істи_, _dámy_,
   {{0x61ed013b,0x26ccb1b9,0x60cd11ba,0xf429e052}},	//   _keal, _nudo_, _huam, lmää_,
   {{0x60cd0296,0x32d08016,0xf1af00a8,0x6fda4077}},	//   _kuam, _bày_, _घरान, युदं,
   {{0x6d4b4277,0x71278085,0x60cd11bb,0x3d07610a}},	//   ågad, ترال, _juam, _हमके_,
   {{0xd5e2c0f9,0x2bdae0aa,0x61e291bc,0xe8e02119}},	//   _alò, _म्ला, abol, _nhớt_,
   {{0x9a8780fb,0x25a9c49f,0xad9b4049,0x7c28e09a}},	//   _дуал, _šal_, _gcúr, dedr,
   {{0x98afe0e4,0xdb1c60e0,0x7e7b91bd,0x28af60c2}},	//   đače_, _ugrá, _umup, _जीति,
   {{0xb5fb11be,0x61ebd1bf,0xaca3c079,0x9f586030}},	//   tkán, _vegl, _nhụj, _adrè_,
   {{0x394dd1c0,0x9f4a6b3c,0x3dc90cc5,0x61ebcd53}},	//   rxes_, _bebè_, _agaw_, _wegl,
   {{0xe9d0a0a4,0xb5fb4071,0xbddb4733,0xdced402e}},	//   _شغل_, _tláh, _anèm, dzač,
   {{0x628b91c1,0xaca3c079,0xa3bd437f,0x2489c071}},	//   nngo, _kwọl, ेखा_, _ñam_,
   {{0x61ed11c2,0x29020054,0x628b91c3,0x6458e071}},	//   _deal, urka_, ingo, _fovi,
   {{0x63a3f1c4,0xad25e33e,0x200ce05d,0x09e2207c}},	//   _tynn, _فرعو, cgdi_, _বাঙা,
   {{0xbbaa61d6,0x7d09d1c5,0x5fcb8f92,0x61e288e5}},	//   _करेक, lues, िशाल, ybol,
   {{0x6281f1c6,0x6446e041,0xfd64a1e9,0x69c991c7}},	//   lilo, ēkie, _airọ, _ngee,
   {{0x290331c8,0x7ae98385,0x63a401fb,0xb4db4733}},	// [c60] arja_, _nwet, _uyin, _aràb,
   {{0x6a606262,0xd3e4263b,0x1dddb1c9,0xeb9a6926}},	//   _löfv, _تقدی, नुमत, биз_,
   {{0x2f160a2f,0x442951ca,0x20d08016,0x7d1651cb}},	//   læg_, bea_, _sài_, stys,
   {{0x213f8098,0x7d09c0dd,0x2ab200e0,0xdfcf813a}},	//   _bruh_, kues, lább_, هيم_,
   {{0x290a297e,0x1634a491,0xa3e24021,0x27f24054}},	//   luba_, деля, _न्य_, mayn_,
   {{0x213f805c,0x61fb91cc,0x6447629c,0x628b8ab8}},	//   _druh_, _edul, _gnji, ango,
   {{0x290a31cd,0x629d030f,0xd9b90308,0xd6d7a772}},	//   nuba_, yoso, _इण्ट, пты_,
   {{0xae0eabd9,0x3f6a804e,0x4420036c,0x78702156}},	//   _सावन_, _либо_, _nbi_, _hävd,
   {{0x9f45e066,0xa01b4069,0xb5fdc018,0x628281dd}},	//   valá_, _kjör, ukša, mioo,
   {{0xe678e0ff,0x29032cce,0x61e451ce,0x20d1a0c4}},	//   ійні_, yrja_, hbil, _fái_,
   {{0x7d044054,0x2918206f,0x290a31cf,0x67240143}},	//   hris, jtra_, juba_, _apij,
   {{0xb69b21ae,0xad9b4005,0x44294108,0x386691d0}},	//   grân, _ocúp, xea_, nkor_,
   {{0xe29ae93b,0x6f09c071,0x5334c16c,0xe534c54a}},	//   _лад_, cuec, _целт, _цель,
   {{0x6447c018,0x44294264,0xccf8a04a,0x7c38ab83}},	//   ējie, wea_, _kvě_, ndvr,
   {{0x69d5269f,0x8bec01a6,0x6e942926,0x386691d1}},	//   rcze, _কারন_, хиру, kkor_,
   {{0x39400110,0x7af520c2,0x6448a006,0xdb03e066}},	//   _fris_, rszt, _lndi, _uzná,
   {{0x5a35644c,0xb066004e,0xfbd0413a,0x7e6d11d2}},	// [c70] мнат, ssää, اتف_, _ilap,
   {{0x201f8143,0x27ed8095,0x7c29d1d3,0x290a31d4}},	//   _sbui_, _seen_, zeer, buba_,
   {{0xaca4e079,0x51f46049,0x7c29d1d5,0x7d09c00e}},	//   _ngọz, عسكر, yeer, zues,
   {{0x37e6a07c,0x628b866e,0xb5fdc018,0xaacfe7f4}},	//   _নাগর, ungo, ekšn, _संसक,
   {{0x20d30148,0x3ea94156,0xcc564008,0x9f4b004a}},	//   _धूमध, mlat_, _חברי_, kací_,
   {{0x61ee71d6,0xddc8a00a,0x9f4485df,0x6281e265}},	//   _gebl, _emdž, _demà_, xilo,
   {{0x6281f1d7,0x9f4b0326,0x224911d8,0x1dda40a8}},	//   vilo, dací_, _onak_, युवत,
   {{0x32d1a016,0x61ef51d9,0x7648b1da,0x69c3e0c2}},	//   _váy_, _jecl, _endy, _रणबी,
   {{0x26c5a0e8,0x61e4807b,0x2ca941cd,0xb5fb41de}},	//   _tilo_, ñile, ilad_, _fláv,
   {{0x61ef51db,0xddc3e0ba,0x4d65eca6,0xb5fb11dc}},	//   _lecl, _conş, дков, skál,
   {{0x382a08f4,0x672411dd,0x356bb1de,0x44200827}},	//   ожно_, _spij, _уран_, _pbi_,
   {{0x2a6d8037,0x290b0098,0x6279e066,0x1fc5207c}},	//   _jleb_, fuca_, jňov, ্রাস,
   {{0x6448b1df,0x7bcbd1e0,0x61aa71c9,0xddd8a2e2}},	//   _yndi, _iggu, _कर्ष, livš,
   {{0x60c4e41a,0x3f69e51b,0x386691e1,0x9f4f80fa}},	//   _éimp, _мило_, zkor_, gagé_,
   {{0x845a50da,0x4f9531e2,0x8fa33156,0x2ca94025}},	//   орат_, ерту, варе, flad_,
   {{0x290a31e3,0x2b4006f1,0x6f0b8174,0x2ca951e4}},	//   ruba_, _tric_, kugc, glad_,
   {{0x32d2c081,0xdca351e5,0x672400e4,0x60ce71e6}},	// [c80] _xây_, тати, _upij, _subm,
   {{0x66f30028,0x656280ce,0x26cee0e8,0x7ebf0013}},	//   _अबतक_, vyoh, _yufo_, _rūpi,
   {{0xee3a8fb5,0x69d9c171,0x68e4c17a,0xddd8a20d}},	//   жне_, _ofwe, _ħidm, jivš,
   {{0x6448a8a4,0x26dc6041,0x06e3c07c,0x2249017b}},	//   _sndi, īvo_, _মিনি, _xnak_,
   {{0x20d3e067,0xa51e26c6,0xddc2c143,0xaac580eb}},	//   _lãi_, _पहुच_, _ološ, رتمن,
   {{0xa3c1d1e7,0x6d41a058,0x200f8024,0x442251e8}},	//   ंधन_, _brla, aggi_, _hbk_,
   {{0x628e29cd,0x2ba50982,0x645b83d3,0x7d0b8013}},	//   inbo, _गुना, _foui, augs,
   {{0xa534c45c,0x9f45a004,0x786faaca,0x26cfc1df}},	//   енич, _delà_, _røve, _bugo_,
   {{0x62808dee,0x765ab1e9,0x65644054,0x41c9ea30}},	//   _immo, _toty, nyih, रशंस,
   {{0x5186e1eb,0x69cbcb11,0x224911ea,0x6d41a012}},	//   дума, _egge, _snak_, _frla,
   {{0xda0a08ae,0x6d41b1eb,0x25b20300,0x765c71ec}},	//   वलंत_, _grla, _azyl_, _mory,
   {{0x628e21b9,0x32062020,0xcec8c119,0x60c8a13e}},	//   enbo, _ɓoye_, _lội_, _hidm,
   {{0xa6db40c4,0x7ae291ed,0x44faa018,0x2c750031}},	//   _orða, npot, lī_, _aúdù_,
   {{0x291911ee,0x9f43206f,0xf7732050,0x3135303e}},	//   rtsa_, majú_, ناز_, негр,
   {{0xf2c740fb,0x62808227,0x7e6d11ef,0x290b0133}},	//   дсан, _ommo, _tlap, suca_,
   {{0x26cfc071,0x38a42156,0x628e31f0,0x443871f1}},	//   _yugo_, förs_, anbo, _aar_,
   {{0x9c130079,0x26cfc005,0x44224012,0x60c76361}},	// [c90] _fọre, _xugo_, _dbk_, _pijm,
   {{0x44386d81,0xe616406e,0xcec8e119,0xb5fdc018}},	//   _car_, čišč, _bội_, ekšl,
   {{0x2013a017,0x9f4325ba,0xb5fb51f2,0x6e22d1f3}},	//   òxim_, hajú_, _blát, _obob,
   {{0x7aed11f4,0x9f43206f,0x1bd58de7,0x22990066}},	//   _kwat, kajú_, ходя, téky_,
   {{0x442cf1f5,0xf1a500a8,0x443871f6,0x290cea36}},	//   ked_, _गुमन, _far_, huda_,
   {{0x7c38f1f7,0x8cb94158,0x9f43206f,0x201131f8}},	//   _navr, ्दको, dajú_, ngzi_,
   {{0x290ce71e,0x64ca71f9,0x442b91fa,0x6da2ab65}},	//   juda_, िदृश, _ºc_, лиша,
   {{0x68ed11fb,0x644991fc,0x443951fd,0xfc31c050}},	//   _owad, _unei, _jas_, احث_,
   {{0x442cf1fe,0x2bc36626,0xb5fb4066,0x79a7839d}},	//   fed_, _वृता, _hlás, _црве,
   {{0x628571ff,0xc3324694,0x7c22d200,0x60c9804e}},	//   niho, נוי_, _ebor, _hiem,
   {{0xe286033f,0x27efc3d1,0x3869431b,0x4423605d}},	//   елни, _tegn_, kkar_, _mbj_,
   {{0x38694156,0xac19ca0c,0x6e22c031,0x7c22c2f4}},	//   jkar_, _ходу_, _gbob, _gbor,
   {{0x270d8010,0x442cf201,0x7e69c0c4,0x3ea05202}},	//   _समोर_, bed_, mkep, voit_,
   {{0x7c22d203,0xa06a203b,0x7e69c271,0x7d0d405d}},	//   _zbor, чага_, lkep, duas,
   {{0x2617b204,0xaca3c125,0x8af0403c,0xe8180026}},	//   _नानी_, _ebụm, yyəs, _थापा_,
   {{0x38b20082,0xda0a0010,0x645d5205,0x645c7206}},	//   bára_, _वाटत_, _cosi, _sori,
   {{0x3ea05207,0x765d5208,0x7d0d5209,0x2d8761af}},	// [ca0] roit_, _dosy, guas, únen_,
   {{0x60c9804e,0x4439520a,0x6285720b,0xa3cc4028}},	//   _aiem, _eas_, giho, _ललक_,
   {{0x4422407d,0x644bd06b,0x9f43206f,0x961dc041}},	//   _tbk_, _ongi, zajú_, ziņa,
   {{0x4438720c,0x6e39c022,0x61e366df,0x6e3bc23d}},	//   _war_, _nawb, ınla, jdub,
   {{0xd838a42e,0xaca46088,0x60c9920d,0xb5fb462f}},	//   _pač_, _arụs, _diem, _elás,
   {{0x290cf20e,0x6e2e2576,0x2000007d,0xe45fc052}},	//   yuda_, nebb, _ldii_, öön_,
   {{0x4420520f,0x26d2008b,0x6e240291,0x69dc7210}},	//   ofi_, _luyo_, _obib, _ifre,
   {{0xdbc7210a,0x61f65211,0x6280835f,0x20124a45}},	//   _töök, nayl, _ummo, ngyi_,
   {{0x645e3212,0x91fca090,0xdb1d0009,0x8506850f}},	//   _oopi, _blāt, lcsö, _سوان,
   {{0xd250c555,0x7c2d4265,0x6e241213,0x7c3bd214}},	//   انک_, zear, _abib, adur,
   {{0x6d43e5a0,0xdb1c6005,0x6594f215,0x25a9007d}},	//   _crna, _agrú, тану, _syal_,
   {{0x7860603c,0x443a21cf,0x26d201e7,0x6458b005}},	//   _mövq, _aap_, _buyo_, ljvi,
   {{0x63a4a20f,0xbfab020e,0x2bdda04a,0x7ea5c057}},	//   şind, ятое_, नुवा, rópt,
   {{0x69dcc064,0x6e240fa1,0x7c3aabf2,0x64892098}},	//   śred, _ebib, _jatr, džic,
   {{0xe80a1160,0x38b20559,0x6e3ab216,0x3ced229f}},	//   _वाचा_, sára_, _matb, ćevo_,
   {{0xe8e02119,0x7bdc7217,0x7f4400d5,0x62861218}},	//   _chốt_, _afru, _friq, ciko,
   {{0x3eb866a6,0x9e077219,0x7689203b,0xf8bf00fa}},	// [cb0] _bhrt_, ечел, ržyb, mmé_,
   {{0x69daf21a,0x21290037,0x645d4d5e,0x80b34029}},	//   ncte, _ipah_, _wosi, _आठवे,
   {{0xf77f4004,0x6f0f121b,0x63a98114,0x7c2d521c}},	//   _reçu_, lucc, _syen, pear,
   {{0x3ea5a05d,0x6f1d0171,0xb87b60f9,0x61f64025}},	//   _sklt_, otsc, _awít, cayl,
   {{0x442dc374,0x60c9921d,0x6f0f121e,0x6e3ab21f}},	//   vee_, _viem, nucc, _batb,
   {{0x7cc900c2,0x80076627,0x442484cf,0x7d1d1220}},	//   _ośro, _ячме, _ebm_, itss,
   {{0xba74a68c,0x69c8204d,0x6f1d104d,0x3869c0a2}},	//   دانت, ždev, htsc, _ƴar_,
   {{0x7bdae0ba,0xf1650031,0x26d3248a,0x6f048a14}},	//   ectu, _ayọ̀_, _muxo_, šica,
   {{0x6e3bd221,0x26cb4737,0x9f4b1222,0x58d580ff}},	//   rdub, _mico_, yacá_, _розт,
   {{0x6f1bd223,0x78ad5224,0x6d43e4b4,0x20001225}},	//   rtuc, hlav, _prna, _sdii_,
   {{0x628723b1,0x63aae0e2,0x6d452048,0x21290037}},	//   dijo, _cyfn, _nrha, _apah_,
   {{0x9f5240fa,0x7d1bd226,0x644d0049,0xf772e062}},	//   sayé_, ptus, _cnai, شاپ_,
   {{0x7c3aa011,0x6e3b9227,0x5121a4ef,0x207ac00b}},	//   _yatr, _maub, _महुआ_, _קאנא,
   {{0x412a2792,0x7c3b9228,0x248680c2,0x3e646009}},	//   мого_, _laur, ziom_, _jött_,
   {{0xada62792,0x44205229,0x2c742277,0x6f1d122a}},	//   тавл, tfi_, _rädd_, atsc,
   {{0x61e9c1e8,0x7c2e322b,0x442ea3c1,0x6e2e322c}},	//   nbel, sebr, zef_, sebb,
   {{0x7d1c242e,0xbc1b0095,0x6b63487c,0x2ee0ce56}},	// [cc0] strs, _חופש, акта, _çift_,
   {{0x20042013,0x1f6630ba,0x09c5e1a6,0x9f4ce02e}},	//   ėmis_, _аком, _শ্যা, ladá_,
   {{0x68e4522d,0x7c3aa4d8,0x3860017b,0xa3a8d22e}},	//   spid, _ratr, _koir_, _खुन_,
   {{0xfce6922f,0x78ad4ed9,0x442f80f3,0x443b0054}},	//   водо, clav, geg_, _xaq_,
   {{0x6aa3a944,0x6f09c205,0x7d09c22e,0x6e3b9230}},	//   fonf, jrec, jres, _daub,
   {{0xdc08e041,0xa7fca20f,0x6728a05d,0x442f8046}},	//   _mēģi, _alır, _ppdj, aeg_,
   {{0x442f9231,0x764e6156,0x6d4640a9,0x229c8066}},	//   beg_, _inby, _hrka, zíky_,
   {{0x8c3ce3df,0x291ca0e0,0x6d41e6ca,0x7c3c7232}},	//   doğa, rtva_, dvla, _harr,
   {{0x4425a1e2,0x6f09d233,0x442ea024,0x290eb234}},	//   _fbl_, grec, pef_, sufa_,
   {{0x25e2c029,0x290a206e,0x4734e8ba,0x6e3b9235}},	//   _ट्री_, krba_, гнос, _zaub,
   {{0xa5bb40f9,0xe7bd207c,0x27f820fd,0x64a3e01b}},	//   _aból, _অভ্য, darn_, раќа,
   {{0x6b7ba087,0xf76feef8,0x59d52026,0x26c043de}},	//   _קראנ, تاً_, _दलहर, jmio_,
   {{0x7f4281ab,0x38b900e0,0x9b5801e1,0xdca3c1c0}},	//   nvoq, jére_, вият_, _таци,
   {{0x3e7540ff,0x26f3040a,0xb5fb42f4,0x7f429236}},	//   _måte_, _अबीर_, _aláp, ivoq,
   {{0x644d08c4,0x6d465237,0x9f4b406f,0x2ba505cb}},	//   _tnai, _arka, _vecí_, _गँवा,
   {{0x2a600037,0x6d4640a9,0x644d1238,0x6d416049}},	//   _goib_, _brka, _unai, _álai,
   {{0x6d46429f,0x961dc041,0x7c3c6729,0xa5bb5239}},	// [cd0] _crka, ziņo, _barr, _gból,
   {{0x442f8b9c,0x160ea6a8,0x2ba7523a,0xd56761b4}},	//   weg_, _सागर_, _कुणा, ктеп,
   {{0xb5fd84ad,0x442f923b,0x5bcb9008,0x7afd123c}},	//   _loše, teg_, िश्व, lsst,
   {{0x69dd00e0,0x63ad123d,0x644e723e,0xb4bf8033}},	//   ncse, _kyan, _enbi, ीदे_,
   {{0x38b9e004,0xef1f0181,0x93c920e0,0x7875c071}},	//   lère_, ntü_, _تاکہ_, _jáve,
   {{0xa3acc010,0x6288e4cd,0x7e6d523f,0x9f420326}},	//   _गरज_, jido, lkap, jaký_,
   {{0x68e2c1cd,0x3ec780db,0x291d9240,0x59a74f30}},	//   _atod, _асаб, stwa_, _कुतर,
   {{0x7afbd11b,0x6e3c62a4,0x7c3d405d,0x6d477241}},	//   tsut, _zarb, _jasr, _irja,
   {{0x38b9e0fa,0xaca36125,0x7c84809e,0x2d99c00e}},	//   hère_, _nrịb, _туре, çse_,
   {{0xd2598041,0x6602c088,0x68fbcc00,0x628407ad}},	//   _viņu_, _edok, rsud, _smio,
   {{0xb7d601e9,0x644f5242,0x24894013,0xf770a233}},	//   _aṣap, _onci, kiam_, _وام_,
   {{0xa3df0f30,0xf2c9200b,0x6f09d243,0x6d035244}},	//   दुल_, _זע_, prec, _लिंग_,
   {{0x69dac00b,0x7cd3e12a,0xc8cfe8b1,0x2b46c017}},	//   _אַוו, _mări, _संकट, _groc_,
   {{0x63ad1245,0xa80646df,0xd29520ff,0x7c229246}},	//   _dyan, zdığ, арсь, zfor,
   {{0x05a42028,0x7c965247,0x291fc04e,0x38b9e004}},	//   _खुशब, грац, ltua_, gère_,
   {{0x26c0416d,0xa3dff248,0x63ad0030,0x6a79e0f9}},	//   umio_, धुर_, _fyan, _fùfù,
   {{0x44313249,0x6e3d4037,0x261bd24a,0x6146124b}},	// [ce0] bez_, _dasb, _यानी_, _сепа,
   {{0x9f4ca066,0x66c96013,0xfaaa60eb,0xb4636407}},	//   _sedí_, _užkl, رهاي_, бкул,
   {{0x5d86613a,0x8c4681c0,0x645ce046,0x85f6e00b}},	//   دلال, леже, örii, רמעס_,
   {{0xfc3247f9,0x2489524c,0x7ae40143,0x6288f24d}},	//   _احد_, ciam_, _ktit, zido,
   {{0x2ca4c00a,0xf41f124e,0xab62803c,0x628521cd}},	//   vomd_, onär_, _şübh, _ymho,
   {{0x291ee48f,0x4432524f,0x2c71c04a,0xda7260e0}},	//   ytta_, ley_, _ráda_, _اُس_,
   {{0x68e2d250,0x25ad8187,0xbddb4733,0xfbb86ff1}},	//   _stod, _eyel_, _inèr, _अरिम,
   {{0xfaa69251,0x6f93613a,0x386dc939,0x68e4000a}},	//   _сабо, _الفض, gker_, _otid,
   {{0xb274e01b,0x60cd06a5,0x3a74f06d,0x2e16a6b0}},	//   илиш, _riam, илир, _مباح,
   {{0x27e00162,0x44324054,0x60c29252,0x2bc0d253}},	//   _afin_, hey_, lmom, शेषा,
   {{0x6286410d,0x2ba424ba,0xa2e6b254,0x291fc534}},	//   _omko, _खुला, _соед, atua_,
   {{0x3ea68110,0xb5fd8480,0x539ba0be,0x2912461d}},	//   noot_, _toše, _איבו, kuya_,
   {{0xa06af255,0x291fc987,0x9f512066,0x786b2046}},	//   _пада_, ctua_, razí_, _hüvi,
   {{0x60d600b0,0xe0df42d9,0x38b9eaed,0x6440d256}},	//   _duym, _bròn_, tère_, ldmi,
   {{0x7c3d5257,0x443dc0e8,0xdcbb41e1,0xceb3a087}},	//   _pasr, _yaw_, еща_, מיש_,
   {{0x60d5629c,0x443dd258,0x7640d259,0x6e3d525a}},	//   _ruzm, _xaw_, ndmy, _qasb,
   {{0x2ca68acd,0x6e9520ff,0x3b554d6d,0x9c140079}},	// [cf0] dood_, _випу, шкар, _mọlt,
   {{0x6d48b25b,0x2489525c,0xda78604f,0x9ed9216c}},	//   _orda, siam_, лях_, _имот_,
   {{0x386dd25d,0x660120c4,0x628fe0fa,0x998d00c2}},	//   yker_, ólku, écoi, żeń_,
   {{0x60c2925e,0x2485a17b,0x2912525f,0x261b2466}},	//   gmom, _smlm_, buya_, _बाडी_,
   {{0x64db2010,0x7e61b260,0x07a5839d,0x61f566fa}},	//   _मंडळ, _polp, јалн, _tezl,
   {{0x6d48a320,0xcb6680de,0x20048157,0x443dc076}},	//   _brda, раше_, _edmi_, _saw_,
   {{0x3ea5f261,0xe509e918,0x6289d262,0xe6dec088}},	//   volt_, _विधि_, tieo, _rịọ_,
   {{0x60ddc019,0x34958143,0x9b05c143,0xfaff03ac}},	//   ísmo, _табр, азид, ksë_,
   {{0xe456c099,0x6d48b263,0x2ba5046f,0x645bc333}},	//   ржы_, _erda, _गुला, rjui,
   {{0x6d499264,0x753b9265,0x161ca029,0x660404b4}},	//   _irea, _isuz, _नायर_, _sdik,
   {{0xe1ff0064,0x672d1266,0x3ea5e0e0,0xb035c04e}},	//   nków_, _apaj, rolt_, _внеш,
   {{0x614603fc,0xa6dee016,0xa96a01e3,0x6739c05f}},	//   аема, _trưn, вима_, _tswj,
   {{0x7ae53267,0x61f73268,0xe3b2050f,0xe9cec51b}},	//   _atht, _bexl, ترد_, _фк_,
   {{0x2b4905df,0x61fbd11b,0x4427e17b,0x6d444024}},	//   _drac_, laul, _ubn_, vvia,
   {{0xe81723af,0x26cfc610,0x44290c8a,0x6f0d5269}},	//   _तारा_, _kigo_, _fba_, erac,
   {{0xcec8e016,0x6d44c03b,0xa7fb403e,0x5ed7a07c}},	//   _hộp_, _šiai, _poña, _সবাই,
   {{0x06866de1,0xfc3f41ae,0x26cfc071,0x2240526a}},	// [d00] аган, _daí_, _migo_, rdik_,
   {{0xdb01a052,0x61fbd26b,0x38b907da,0x290dc0ba}},	//   _kylä, haul, méra_, irea_,
   {{0x6441f26c,0x60c2926d,0x61fc326e,0x1dabf26f}},	//   idli, tmom, marl, _घुमत,
   {{0x3205a0e8,0xe9a641b1,0x9f5822a8,0x7f8ce053}},	//   _adly_, _вамп, jaré_, ענאַ,
   {{0x61fbca81,0x3ea69270,0x6cc6a0d7,0x9f4324cd}},	//   daul, root_, айда, bajó_,
   {{0xcec8e067,0x60c45271,0x443eb272,0x2ca7a061}},	//   _nộp_, lmim, _qat_, gond_,
   {{0xd467a1e3,0x6d410018,0x290dd273,0xb5fb0009}},	//   рије_, ālai, erea_, rház,
   {{0xec1686b0,0xd838e06e,0x83fca04d,0x27edc009}},	//   _خورد, moči_, _dođa, gben_,
   {{0x29005274,0x1da50010,0xb273c4a4,0x61faeef5}},	//   nsia_, _गुंत, ільш, tatl,
   {{0xc7c6f275,0x69b94010,0x443ea153,0x2bc36046}},	//   исни, ्धती, _uat_, वेवा,
   {{0x752d1276,0x29005277,0x290dc12a,0xf8bf2004}},	//   _spaz, hsia_, area_, ntée_,
   {{0x7ebd00e0,0x76428f3d,0x4fa6c54a,0xe818ed0b}},	//   képe, ndoy, _киев, _दावा_,
   {{0x26cef278,0x7ae9c017,0xf27bc557,0xdb03e066}},	//   _tifo_, cpet, _בראש, _vyná,
   {{0x4efbc095,0x628b9279,0x248b000a,0x7d0d527a}},	//   _יהדו, zigo, sicm_, vras,
   {{0xe937e049,0xfc3f4071,0x3abbe557,0x6722927b}},	//   _نسيت_, _paí_, _שמונ, htoj,
   {{0x38a1c0c2,0x7cd3e12a,0x63af51ef,0x6f02c133}},	//   wórz_, _căru, _pycn, _kvoc,
   {{0xe2ab2938,0xb4b74028,0x66d5a013,0xcc341049}},	// [d10] _لادن_, _छठी_, _iške, _ذريع,
   {{0x6440927c,0x27edc0e0,0xe6136233,0x7e54614f}},	//   _aami, zben_, تشر_, овує,
   {{0x4426927d,0x27edc0e0,0x05a7527e,0x67228c64}},	//   ffo_, yben_, _कुरब, etoj,
   {{0xdb1c607b,0x7e554062,0x6288a090,0xb5fdc013}},	//   _agró, _انحص, _amdo, nkšt,
   {{0x6441f27f,0x28c80f92,0x60db6012,0xd91b8052}},	//   ydli, रगति, _čumu, тье_,
   {{0x61e2d280,0xc484a71b,0x26d87281,0x78a8e320}},	//   _afol, олік, _furo_, jodv,
   {{0x26d95282,0x96f86677,0x49170292,0x61fbd283}},	//   _huso_, _вест_, भूतो_, taul,
   {{0x83fca16d,0xf8db42b4,0x7875c02f,0x2ca7aaaa}},	//   _vođa, _बढाय, _báva, sond_,
   {{0x9f583284,0x61fc3285,0x98a92133,0xb4db42d9}},	//   raré_, yarl, _apač_, _brài,
   {{0x6f02c03a,0x27edc0e0,0x26d95286,0x61fbd287}},	//   _dvoc, sben_, _muso_, saul,
   {{0x81a9607c,0x07a5e376,0x141aa0be,0x26d86005}},	//   খের_, санн, _תועב, _xuro_,
   {{0xb87b7288,0xfc320049,0x6441b289,0x3e7660c4}},	//   _stíl, أحد_, _hali, _mæta_,
   {{0x38b2128a,0x889a8087,0xa059e711,0xe7a7528b}},	//   nári_, רברי, _مؤثر_, _कुलप,
   {{0x225fc0e0,0x7cd3f044,0xfd490125,0x27fd80fd}},	//   ljuk_, _săru, lomọ, hawn_,
   {{0x7643a037,0x6f02c361,0x7cd3f044,0x6d4bc012}},	//   idny, _zvoc, _păru, _hrga,
   {{0x7ebd08cc,0x28d004f6,0xb5fb11be,0xeabf528c}},	//   tépe, _सूचि, skár, _chù_,
   {{0x6e35204d,0x27e0528d,0x69d60009,0x63a9113e}},	// [d20] bezb, rcin_, _igye, üent,
   {{0xbddb128e,0x6aa9c3be,0x2f566792,0x2900413c}},	//   ndèn, hoef, йтес, rsia_,
   {{0xa96a328f,0x628e3290,0xdb1c6733,0x130a612a}},	//   _сина_, mibo, _agrò, уней_,
   {{0x2902c0db,0x6441b291,0xd838e42e,0x2900515e}},	//   škai_, _aali, roči_, psia_,
   {{0x225fc0e0,0x3ebf8569,0xf8bf20fa,0x44269292}},	//   djuk_, _dhut_, stée_, rfo_,
   {{0x628e3293,0x8b060064,0xbb3b0087,0x6440866b}},	//   nibo, częś, טעני, _wami,
   {{0x649601d7,0x4426800f,0x5f43a049,0x61e41294}},	//   rġij, pfo_, كنول, _ofil,
   {{0x261a0308,0x26d21295,0x6f040098,0xb176e016}},	//   _भाषी_, _niyo_, _ovic, _ngượ,
   {{0x7e665296,0xb5fdc041,0xe819c66f,0xb8ffaf30}},	//   _mokp, ekšs, _धारा_, _धू_,
   {{0x61e2814a,0x6aad088b,0x6d4bd297,0x527b600b}},	//   lcol, _skaf, _drga, ָנטא,
   {{0xa96aa085,0x499aa14a,0xd5b2c050,0x29021298}},	//   _حمام_, _стая_, _کفش_, eska_,
   {{0x6a6b20cb,0x75245299,0x7af601cd,0x06e721a6}},	//   _lüft, ktiz, _bwyt, _ফিলি,
   {{0x7d02929a,0x9f47e65f,0x05a74029,0x6d4bc012}},	//   nsos, _menù_, _कुंब, _grga,
   {{0x8c43f29b,0x6298a105,0x3f804013,0x26da20f9}},	//   _нече, nnvo, dziu_, _bupo_,
   {{0x26da329c,0x61fd129d,0x61e401cd,0x26d16019}},	//   _cupo_, pasl, _ffil, _rizo_,
   {{0xd6d82376,0x2902129e,0x76444f09,0x248900e8}},	//   стр_, bska_, gdiy, _umam_,
   {{0x68f601cd,0x7e7d0049,0x195841ba,0x6443a46b}},	// [d30] _gwyd, mhsp, баты_, ydni,
   {{0x51f861ba,0x6442c28f,0xf21f00c5,0x76444025}},	//   йную_, _laoi, _भाड़_, adiy,
   {{0xd9996049,0x20cd6012,0x629c6187,0x2c6ba22e}},	//   جنات_, _užim_, _djro, _mødt_,
   {{0x2901729f,0x6442c28f,0x7d1640ae,0xdb1f6193}},	//   rsha_, _naoi, buys, _ávís,
   {{0x4ad90010,0x6e2d01a7,0x29016227,0x61ff403c}},	//   ढदिव, _mbab, ssha_, maql,
   {{0x83fca2e2,0xc05b60ff,0x2c6ba271,0x63bd4018}},	//   _dođo, _сім_, _nødt_, _izsn,
   {{0x442ca07d,0x394952a0,0x225fc0e0,0x6cc5d2a1}},	//   _dbd_, lvas_, tjuk_, ойка,
   {{0x7b084069,0x61e28ea3,0x628e20bb,0x7643a037}},	//   _ástæ, ccol, zibo, sdny,
   {{0x61e3e435,0xb7bd812a,0x3ce90048,0x7641b2a2}},	//   _pfnl, _obţi, _ntav_, _taly,
   {{0x26c00b39,0x68ed421c,0x4489e307,0x656f12a3}},	//   _shio_, ipad, рбон_, dych,
   {{0xe7efa010,0x64456569,0x29020064,0x7f4d12a4}},	//   _घ्या_, idhi, wska_, _araq,
   {{0x2bbe4077,0x26da3022,0x22436320,0x442952a5}},	//   ्धमा, _rupo_, _lajk_, jfa_,
   {{0xdea3c043,0x645572a6,0x61fb8b56,0x27ff00c4}},	//   _ویڈی, _onzi, _meul, ðuna_,
   {{0x9f47a06f,0x6ff9a00b,0x479ac053,0x8f9ac1a1}},	//   zaný_, יפֿג, _דינס, _דיני,
   {{0xe2972ea0,0x7e66408b,0xf74332a7,0xe73a3156}},	//   цар_, _pokp, меро, шев_,
   {{0x7ae9804e,0x7c2d08b7,0x2a66c048,0x7e7d12a8}},	//   _otet, _gbar, _xoob_, chsp,
   {{0x7fd6284f,0xb466664d,0xceb44497,0x64556098}},	// [d40] _міні, окал, rlə_, _bnzi,
   {{0x3f8052a9,0x7c2d12aa,0xaec360ff,0x2d8052ab}},	//   rziu_, _zbar, дбул, rzie_,
   {{0x7c2d008b,0x9f4172ac,0xe9da92ad,0xddc08026}},	//   _ybar, nchè_, аке_, _pomů,
   {{0x136a8dd1,0xfbae004b,0xf2202046,0x9c87604a}},	//   ишли_, _घडाम, _बाड़_, _počá,
   {{0x9f5ca05c,0xddc2d2ae,0x2b4d8355,0x644404ec}},	//   mavé_, _slož, _crec_, _maii,
   {{0x3a2d8005,0xc1730095,0x3d120010,0x2a66c048}},	//   _ebep_, וחד_, _तिने_, _soob_,
   {{0x66dee041,0x6aaaa87d,0x61fab2af,0xd6d7a5be}},	//   _rīko, roff, _vetl, оты_,
   {{0x6443f2b0,0x2a66c286,0xf484a6b0,0x6aaab2b1}},	//   _aani, _qoob_, _کاری, soff,
   {{0x6f044283,0x2b4d81ab,0x2c1b2960,0x93bca12a}},	//   nsic, _grec_, _बालू_, _scăd,
   {{0x7c2d12b2,0x0f574095,0x6d4e72b3,0xf76fc049}},	//   _sbar, קיים_, _krba, ضاً_,
   {{0x656f0bca,0x2a66d2b4,0x98ba4061,0x3866caaa}},	//   wych, _toob_, _aspč_, _toor_,
   {{0xe292c6b0,0x764400a2,0x656f00c2,0x443823c5}},	//   _غذا_, _caiy, tych, eer_,
   {{0x27e6c163,0x6b8292b5,0x2b4012b6,0xe1ff0e53}},	//   _ifon_, nzog, _csic_, raó_,
   {{0x6a7cc004,0x95f54960,0x3ea9c49f,0xe821e7b3}},	//   _défe, ेण्ट_, čate_, _माया_,
   {{0x644361ae,0x39400019,0x7d0452b7,0x224681e7}},	//   ônim, _esis_, esis, kdok_,
   {{0x1dca8046,0x6e2d12b8,0x2b4947a0,0x9b894049}},	//   िधात, _ubab, tvac_, منزل_,
   {{0x142b2139,0x3ce906dd,0x6f044090,0xa3e00021}},	// [d50] _кіно_, _utav_, gsic, _तलत_,
   {{0x7af8e05f,0x291901a5,0xfc336049,0x6443e36b}},	//   _kwvt, musa_, بحر_, _xani,
   {{0x6600d2b9,0x291912ba,0xc6a78b1e,0x25a24097}},	//   kamk, lusa_, орди, _exkl_,
   {{0x644532bb,0xb5fd8143,0x2904d2bc,0x61e44425}},	//   _hahi, _vošo, ksma_, ccil,
   {{0xd126cab5,0x98176050,0x61fd4018,0xa85a4076}},	//   _ثم_, _وبسا, _iesl, _הדרכ,
   {{0x64472aaa,0x7c38a3c5,0x2c79a011,0xb5fd8133}},	//   ndji, gevr, _bèda_, _tošo,
   {{0x68e98064,0xb902810a,0x6d468e9d,0x61e5613a}},	//   _wted, _नू_, _škat, mchl,
   {{0x60db82df,0x442d8f12,0x6d4f40a9,0x2b4d92bd}},	//   _tuum, _ube_, _krca, _trec_,
   {{0x61fd4121,0x22648066,0x6d4f40ae,0x61e56256}},	//   _mesl, žská_, _jrca, ochl,
   {{0x6a7cd2be,0x291912bf,0x66dee041,0x200172c0}},	//   _réfe, dusa_, _tīkl, nahi_,
   {{0x66e8e295,0x9f5ee5cd,0xe739e7ca,0x644412c1}},	//   _někd, natè_, щен_, _paii,
   {{0x60dd52c2,0x6f044c37,0x3a382854,0xb87b6071}},	//   _ousm, ysic, werp_, _huíd,
   {{0x5ed2c07c,0x291912c3,0x7645205d,0x69d9cc98}},	//   _সবচে, gusa_, _bahy, _igwe,
   {{0x2cadc3c5,0x60c4e197,0x9f05e243,0x38b46052}},	//   loed_, _èimp, _فوتو, päri_,
   {{0x644532c4,0x7e7b92c5,0x200160eb,0x4439119d}},	//   _dahi, _olup, dahi_, bes_,
   {{0x6601f2c6,0x53a6084f,0x26ddd2c7,0x6d4f5192}},	//   lalk, _найб, _kuwo_, _brca,
   {{0xe0d74139,0x3aeb40e0,0x60c412c8,0x6d41b15f}},	// [d60] зву_, مبلی_, _ihim, _lsla,
   {{0x61e452c9,0x60dd52ca,0x60d572cb,0x200172cc}},	//   scil, _dusm, _cizm, gahi_,
   {{0x78b6406f,0x7bd9c079,0xf99220eb,0x9f47a089}},	//   plyv, _ogwu, _سبد_, ybná_,
   {{0x7e7b8057,0x6d5ca569,0x7eb4e5df,0xdca65097}},	//   _clup, _àrai, ràpi, _хами,
   {{0x60c2c07d,0x3897c12a,0x2245b2cd,0x41b94914}},	//   _rhom, cări_, _balk_, _आरएस,
   {{0x6601f2ce,0xd6d980ff,0x81d5407c,0x2905f2cf}},	//   jalk, іті_, _সড়ক_, ksla_,
   {{0x9f5ee0dd,0xa967a5da,0x443a72d0,0x6600d2d1}},	//   ratë_, зија_, mep_, tamk,
   {{0x387fd2d2,0xc19b6095,0x443912d3,0x0d7760eb}},	//   ghur_, _השלי, xes_, _عینک_,
   {{0x98a3812a,0x76aae052,0x442252d4,0x48aaf2d5}},	//   _чите, йтов_, _mck_, йтом_,
   {{0x4439011e,0x7bd9c385,0x3ae1e067,0x6600c9e9}},	//   wes_, _egwu, _bóp_, samk,
   {{0x3897c12a,0x2cace1cd,0x2cadc037,0xddc9c00a}},	//   zări_, rodd_, boed_, rkeš,
   {{0x66028167,0xb5fb0009,0xf1be41c9,0x387fc2a1}},	//   naok, aján, ्धान, chur_,
   {{0x661d12d6,0x9f5ee0d1,0x61e572d7,0x386900fc}},	//   rgsk, zatè_, ychl, _voar_,
   {{0x61fd4121,0x6d41b259,0x98bfa0a9,0x9f5ee089}},	//   _sesl, _ysla, _vruć_, haté_,
   {{0x68e9604d,0x44e1e031,0xf1a42bbb,0x291912d8}},	//   _čedo, _gó_, ертн, susa_,
   {{0x3897c12a,0x2db7e095,0x179be053,0xfd51c125}},	//   tări_, _מלון_, _ליוב, _nkeọ,
   {{0x7e698996,0x200ca1cd,0xa5bb52d9,0x443a600a}},	// [d70] _roep, _oddi_, _abór, fep_,
   {{0x60c9c1fc,0xf77048b8,0x7e6992da,0x3897c12a}},	//   zmem, داف_, _soep, rări_,
   {{0xb87b69fe,0x61e572db,0x6f1ae0a9,0x7e698d53}},	//   _ruíd, rchl, nutc, _poep,
   {{0x6d42c265,0xb87b6005,0x6a7360b0,0x6280d2dc}},	//   _osoa, _suíd, _sıfı, jhmo,
   {{0x63b560c2,0x443a6106,0xd469a8ba,0xa3b96077}},	//   _wyzn, bep_, жиле_, _चरक_,
   {{0x660bc058,0x6e22c0d5,0x764652dd,0x940165fc}},	//   _sdgk, _acob, _zaky, yihə_,
   {{0x6d346874,0x6d4d41cf,0x61e60156,0x787f000e}},	//   _перф, lvaa, yckl, _zëve,
   {{0x6a70267c,0x248d804d,0xa3c2f2de,0x7658e0ca}},	//   _häft, _umem_, ्धन_, _anvy,
   {{0xe821e8c6,0x200ca057,0x2245a095,0x9f582005}},	//   _मादा_, _fddi_, _talk_, iará_,
   {{0x3e89e0ff,0x4df4e09e,0x7d0992df,0xfe71e049}},	//   ійно_, няют, _ives, ئدة_,
   {{0x38960041,0x64a612e0,0x6601f2e1,0x7d1af2e2}},	//   kārt_, дана, ralk, guts,
   {{0x6448f2e3,0x2905e31b,0x68fb8125,0x39436071}},	//   addi, rsla_, _kwud, _msjs_,
   {{0x5d69caab,0x2905f2e4,0x7c3bd2e5,0xaca36088}},	//   _филм_, ssla_, meur, _anọc,
   {{0x200212e6,0x7d1bd2e7,0xaec4e0ff,0x6e2d4171}},	//   saki_, muus, _збіл, efab,
   {{0x60c412e8,0x2c7c4019,0x644652e9,0x7d1af2ea}},	//   _thim, _aída_, _paki, cuts,
   {{0x3994610a,0x9f47f2eb,0x3ea0000e,0x6b9b4012}},	//   _तs_, _menü_, _ujit_, _žuga,
   {{0x7d1bc2e4,0x4432000f,0x9f5825df,0x7647600f}},	// [d80] nuus, _iby_, sarà_, _bajy,
   {{0x200d805d,0x291a72ec,0x61e992ed,0xe73a260f}},	//   _adei_, tupa_, _afel, _део_,
   {{0xaca46125,0x2247e163,0x248052ee,0x3a3a6c31}},	//   _haịr, _mank_, phim_, repp_,
   {{0xed5a50aa,0x7d1bd2ef,0x6f1c2f55,0xa5bb407b}},	//   _дом_, kuus, murc, _icón,
   {{0xaca46096,0xc6f78139,0x44e3a071,0xc0e3804e}},	//   _asụs, дніх_, _añ_, вочк,
   {{0x3ead4364,0x69c0807f,0x7d1bd2f0,0x69db8108}},	//   čete_, _vzme, duus, _egue,
   {{0x442040fd,0xb05b4156,0x9c7cd09f,0x38960018}},	//   ogi_, _ohäl, _luče, nārs_,
   {{0x64476026,0x941e6982,0x44e452f1,0x2a7dc1cd}},	//   _zaji, _पाँच_, _kö_, _clwb_,
   {{0x6f1641cd,0x2907a025,0x68e445fc,0x764772f2}},	//   nryc, asna_, nqid, _yajy,
   {{0x1620c010,0x66044534,0x7c2412f3,0x6448f2f4}},	//   _यावर_, haik, _acir, uddi,
   {{0x6d5ca6be,0x7c2d41cd,0x018ae052,0x44e452f5}},	//   _šraf, yfar, ющий_, _lö_,
   {{0xae1d43fa,0x9f5820fc,0xdefac03b,0x3eb9a018}},	//   _फाइन_, xará_, _дык_, _īsti_,
   {{0x660452f6,0x6d42c12a,0x2247e143,0x6d43f2f7}},	//   daik, _usoa, _fank_, _esna,
   {{0x69dc72f8,0x442052f9,0xeb918053,0x443af2fa}},	//   _ngre, egi_, אָל_, _úp_,
   {{0xf548c096,0x6f1c20a2,0xb4cae04b,0xf413e557}},	//   _hụ_, gurc, लगी_, _ספק_,
   {{0x6d4d52fb,0x395212fc,0x200332fd,0x6e3c2197}},	//   tvaa, _frys_, saji_, aerb,
   {{0xf548c079,0x44316133,0x200329e6,0x9c7cc143}},	// [d90] _jụ_, _pbz_, paji_, _guče,
   {{0x3e71c069,0x44e44156,0x78a2c04d,0x645a0018}},	//   _hátt_, _dö_, _ljov, ētie,
   {{0x443cb2fe,0xb5fd8098,0x38b46277,0x6f0992ff}},	//   dev_, _hoši, värt_, _svec,
   {{0xb87b60f9,0x442040ae,0x442ea1b9,0x60d8e78c}},	//   _atít, cgi_, eff_, _livm,
   {{0x64477300,0x3a248057,0xd90f801c,0xf548c8dd}},	//   _taji, _dcmp_, شیا_, _nụ_,
   {{0x28bf4ba0,0x660080d4,0x638583bb,0x388cc0a3}},	//   ्षवि, _eemk, _aîné, měry_,
   {{0xd404a14f,0x7648a401,0xddc1a5f2,0x657987d2}},	//   тячи, _dady, _bolš, _şahı,
   {{0x62829301,0x05c34033,0x645aae96,0x6d4529fa}},	//   choo, _शराब, _enti, _msha,
   {{0x765b810f,0x7d0980a9,0x81d7c07c,0xa3cac010}},	//   _inuy, _uves, ়ুন_, ळेल_,
   {{0xdb0ec13a,0x7c3bd302,0xa3d011f9,0xda0f7303}},	//   ádál, seur, _वृष_, ाणित_,
   {{0x291d9304,0x27298049,0xaca3e079,0x386d8046}},	//   luwa_, lún_, _nzụk, _koer_,
   {{0x6e2520ca,0x6601b305,0x6e3d1306,0x6a72622e}},	//   _achb, _helk, gesb, _hæft,
   {{0x78bbc04a,0x61e9d307,0x4e03ac13,0x386d9308}},	//   mluv, mcel, _रजाई_, _moer_,
   {{0x62953309,0x7d09d30a,0x38a9a02e,0x249fc0c4}},	//   gizo, mses, túry_, lnum_,
   {{0x2a7f8497,0x660443fc,0x291d930b,0x3205e02e}},	//   _olub_, taik, huwa_, maly_,
   {{0x2005ea71,0x6601a0e0,0x4420530c,0x7f440058}},	//   lali_, _lelk, ugi_, _tsiq,
   {{0x7875c005,0xa7a74df4,0xfd65e067,0x7d1d130d}},	// [da0] _cávi, екта_, _nhuậ, cuss,
   {{0xb21b0065,0x291d8a2d,0x27e9530e,0x69c4130f}},	//   nhæn, duwa_, acan_, _izie,
   {{0x249fc069,0x15f404f6,0xee3a928f,0x386ca057}},	//   knum_, _आभार_, зне_, _rodr_,
   {{0x2a7f8d81,0x7d165310,0x3944807d,0x44fe204a}},	//   _club_, prys, _psms_, mů_,
   {{0x62964121,0x6284428f,0xdb01a121,0x645aa058}},	//   miyo, mhio, _eylü, _pnti,
   {{0x78a2ca2f,0x6448b311,0x6f09d312,0x3ea05313}},	//   _sjov, _qadi, dsec, lnit_,
   {{0x66061314,0x7ae1b315,0x442ea0e2,0xc60b007c}},	//   kakk, _cult, rff_, ষ্টা_,
   {{0x7bde205d,0x6448b316,0x6601a046,0x7d1d0037}},	//   _lgpu, _wadi, _eelk, yuss,
   {{0x7d09d317,0xfe202028,0xb21b0065,0x8fa3833f}},	//   gses, _बांस_, fhæn, _бате,
   {{0x2004d318,0x645ab319,0x6448a0ce,0x2002531a}},	//   sami_, _unti, _uadi, _leki_,
   {{0x7d1d131b,0x7ae1af68,0xe9df407b,0x26c6d31c}},	//   wuss, _gult, _baúl_, _thoo_,
   {{0x66060622,0xb5fd849f,0x62964535,0x877ba053}},	//   gakk, _poši, jiyo, _מאבי,
   {{0x69c2c167,0x7ae4e490,0x6489200a,0xcfaac711}},	//   _uzoe, _čitu, džir, _عاصم_,
   {{0x9f5ee431,0x7c3e678c,0xb05b0262,0xdcdfa3fa}},	//   latí_, jepr, kläg, _पूँछ,
   {{0x9f34214f,0x2249023c,0x77932050,0x6280931d}},	//   лері, _taak_, ایجا, _olmo,
   {{0xba7707f0,0x3ea0531e,0xae1e6026,0xfe1e604b}},	//   _ساعت, gnit_, _पाउन_, _पाउस_,
   {{0x61ed0277,0xad9b4f87,0x20024106,0x48140052}},	// [db0] _ifal, _adúr, _deki_, _смыс,
   {{0x78bd131f,0x261b21d6,0x6f0d1320,0xdb9c0095}},	//   llsv, _बाटी_, _ivac, _מסחר,
   {{0x7ae2c04e,0x4426c03e,0x443d9321,0x4ea46a00}},	//   _luot, _oco_, tew_, урта,
   {{0xd999813a,0x81ac007c,0x3ea05322,0xb0660052}},	//   ونات_, কেও_, cnit_, mpää,
   {{0x386d823c,0x645d4ea3,0x6483410a,0x291ef323}},	//   _voer_, _insi, _võid, huta_,
   {{0x628080e0,0x2c1e60c2,0xe739a8ef,0x1d164076}},	//   _elmo, _पाएं_, дек_, _בקשר_,
   {{0x386d8aaa,0x6602c143,0x9424e03c,0x61ed01cd}},	//   _toer_, _beok, _ötən_, _ofal,
   {{0x291d84ec,0xd9de2028,0x291900a9,0xee39cb92}},	//   puwa_, _मल्ट, krsa_, фни_,
   {{0x4102c04e,0xdfe5612f,0xddc2c2d1,0x7d09d196}},	//   азыв, _औलाद_, _pooš, uses,
   {{0xb4ab2026,0x752d5020,0x20037324,0x6abbd325}},	//   गको_, itaz, _jeji_, sluf,
   {{0x66061326,0x2018f327,0x7d0d1328,0x672d46eb}},	//   takk, ória_, _avas, htaj,
   {{0x672d5329,0x6833a20f,0x6386e0fa,0x26f0207c}},	//   ktaj, sıdı, _séné, _ছিলো_,
   {{0x672d4012,0x9f5ca066,0x2002532a,0x6484f03c}},	//   jtaj, mavá_, _reki_, _bòid,
   {{0x765d40d1,0x61ed00e2,0x644af32b,0x7eb88019}},	//   _ansy, _efal, _gafi, lípt,
   {{0x2919081f,0xe5170a2a,0x2b15254a,0x9103260f}},	//   arsa_, _तिथि_, льтр, ипре,
   {{0x63a98156,0x2bde2354,0x6a714b57,0x644d4493}},	//   _oxen, _मलका, _såfr, gdai,
   {{0x4cc8007c,0x6603e20e,0xa5074822,0x6d55732c}},	// [dc0] _রংপু, _kenk, кета_, _arza,
   {{0x2bc66861,0x44fe204a,0x764bc5c8,0x9c7cc012}},	//   _वरदा, pů_, _lagy, _muča,
   {{0x6d464064,0x7e7bd32d,0x2002532e,0x403360ff}},	//   _wska, kkup, _teki_, реєс,
   {{0x7d1e732f,0x38bac0dd,0xd7064501,0x6281a239}},	//   rups, përi_, _изми, _allo,
   {{0x2006813a,0x27e09330,0xb606206e,0x60c99331}},	//   raoi_, žino_, pušč, _dhem,
   {{0xca7661ba,0xbebb200e,0x60c99332,0x290ca171}},	//   _румы, stëv, _ehem, _pvda_,
   {{0x4a9b200b,0x1a9b200b,0x443fc253,0x37d5a07c}},	//   ויסג, ויסע, feu_, _স্বর,
   {{0x4427f333,0x68e2c013,0x7d1cb334,0x249820cb}},	//   _acn_, _puod, _årsm, hirm_,
   {{0xc6934095,0x4427f335,0x64960026,0x78785336}},	//   יאה_, _bcn_, tšin, _cívi,
   {{0x2486817a,0x4427e733,0x64960013,0xd8f8e0ff}},	//   lhom_, _ccn_, ušin, нної_,
   {{0x441b600b,0x261bc010,0x621b600b,0x6298a06e}},	//   וויס, _याची_, וויק, mivo,
   {{0x78a29337,0x44e72081,0x0446cf2d,0x60db8c12}},	//   nnov, _rõ_, _једн, _xium,
   {{0x3e754156,0xddc41338,0xe0df41e9,0xddd61339}},	//   _mått_, _poiš, _asòn_, _plyš,
   {{0x68e3edb2,0x68e40693,0x7ae3e265,0x8438e13a}},	//   _fund, _duid, _funt, _أكثر_,
   {{0x6282d33a,0xdee3e1e3,0x35c700c2,0x4423200e}},	//   _kloo, _који, रेज़, rgj_,
   {{0x44e72016,0x6abd6f92,0x3e754277,0x61ed0167}},	//   _võ_, ्ग्र, _nått_, _ufal,
   {{0xb05b0845,0xead4409e,0x645f133b,0x2120405d}},	// [dd0] smäs, роть, _inqi, guih_,
   {{0x644d46f1,0x60db933c,0xdce720c2,0x68e3f33d}},	//   sdai, _sium, zyję, _yund,
   {{0x60dc68f8,0x20cd6055,0x6b89c576,0xe1f9c013}},	//   _dirm, _džip_, zzeg, ybų_,
   {{0x224ca17b,0xb21b0065,0x78a281ce,0xb4bf8b5b}},	//   _aadk_, skæf, gnov, ुगे_,
   {{0x86256896,0xa82560d0,0x721a4008,0x3e742156}},	//   _مکال, _مکان, _אורח, _tätt_,
   {{0x32094524,0x61ed533e,0x03a5b33f,0xdb1aa009}},	//   laay_, lcal, лило, _sztá,
   {{0x6605206e,0xd5b87340,0xaca3a079,0xeb35a062}},	//   _mehk, _аст_, _ntụn, ارتخ,
   {{0xfd5e2088,0x7e7bc0e4,0x3949010a,0x9f5128cc}},	//   _anyị, ukup, _osas_, lazó_,
   {{0x2007b341,0xdd1243df,0x9555c13a,0xaca3a088}},	//   pani_, _müşt, اخبا, _atụn,
   {{0x6b89c0c2,0x660401dd,0x0dc89342,0x212dc17b}},	//   rzeg, _seik, _руси_, rteh_,
   {{0x443fd343,0x20049344,0x7ce7a121,0x99c0007c}},	//   peu_, _yemi_, _kırm, _ইলেক,
   {{0xdb0d1345,0x7ae4111b,0x44e8e004,0x3205a0e0}},	//   _azañ, _puit, _dû_, _hely_,
   {{0x764d0054,0x61fdc0c4,0x27edd2c2,0x3205a0fb}},	//   _daay, ðslu, mcen_, _kely_,
   {{0xdee3106d,0x9407a03c,0x7c298133,0x8f9ac1a1}},	//   сори, tinə_, _lcer, _איני,
   {{0x644d0025,0xa3abe354,0x9c130088,0x24991346}},	//   _faai, _कुच_, _kọle, bism_,
   {{0x61fbd347,0x6d499348,0x61464de1,0x753b8133}},	//   nbul, _osea, леба, _opuz,
   {{0xa81a6043,0x6e244ffe,0x81b5c07c,0xd2a744a7}},	// [de0] فتار_, rgib, ছের_, укте_,
   {{0x2005a046,0x4425f349,0x4a462da4,0x644d02be}},	//   _neli_, ngl_, _снов, _zaai,
   {{0x61e90c35,0x6441e12a,0xed45b34a,0x8d766049}},	//   žele, ieli, _بھ_, داءا,
   {{0xaca46125,0xfce68624,0xaaba80d0,0x127a4049}},	//   _krịs, годо, ردار_, _أحدث_,
   {{0x7c2981ce,0x628400ce,0x7641ea47,0x6496007f}},	//   _dcer, _mlio, kely, jšim,
   {{0x26c0534b,0x2242017a,0x2005b34c,0x248680f7}},	//   llio_, hekk_, _celi_, shom_,
   {{0x7640d34d,0x26ddc0d1,0xd8d7200b,0x6284134e}},	//   temy, _biwo_, נוצט_, _olio,
   {{0x26dce12d,0x75d68243,0x5b14caf5,0x6441f34f}},	//   _sivo_, _ميزا, амит, eeli,
   {{0x200a3350,0xf8b42029,0x44e9d351,0xb5fd835d}},	//   kabi_, ंकाय, _cú_, _vošt,
   {{0xdee6a080,0x44e9d352,0x9b58e90f,0x644e7353}},	//   _божи, _dú_, виот_, _jabi,
   {{0x09d7e07c,0x7ae6494b,0x44e9c06f,0x5275b075}},	//   _দ্বা, _lukt, _eú_, _туту,
   {{0x7d1bd354,0x39491355,0xf127012e,0x6442813a}},	//   brus, _psas_, льго, neoi,
   {{0x60dd5356,0xe6c4e069,0x46f6c691,0xf8bf00fa}},	//   _rism, þjóð, _счет, rlé_,
   {{0x2005229b,0x62841357,0x64428049,0xf8bf0066}},	//   úli_, _elio, heoi, slé_,
   {{0xc87961fc,0x29024125,0x6d5a709f,0x867be1a9}},	//   _îşi_, _awka_, _štan, _ארגו,
   {{0x56945358,0x57f540ff,0x6d58e037,0x66052171}},	//   баст, рпат, _irva, _wehk,
   {{0xe7f7c893,0x660aa05d,0x20094854,0x60cd1359}},	// [df0] ीरता_, kafk, raai_, _iham,
   {{0x200b135a,0xbebb200e,0x51872052,0x291ca0a9}},	//   laci_, rtës, _бума, krva_,
   {{0x7c2ae2a8,0xa3e90028,0x3ceae466,0x2243204d}},	//   _mcfr, _बला_, _घूमे_, mejk_,
   {{0x200b0ed9,0xa3c9f35b,0xd5b8735c,0x61e48b2e}},	//   naci_, लेट_, усу_, žiln,
   {{0x7ae9607f,0x3ce6c425,0x67228013,0x6f0f40ce}},	//   _četu, _nuov_, guoj, _uvcc,
   {{0x8704804e,0x6b8d4098,0xd3364679,0x764e735d}},	//   сяце, mzag, _דרשה_, _gaby,
   {{0x442b535e,0xa01b135f,0x9c7cc381,0xb5fb4049}},	//   _kcc_, rhöj, _vučn, _gnác,
   {{0x200b0fe8,0x7ae64187,0x26dea057,0x78adc16d}},	//   jaci_, _yukt, _eito_, čavo,
   {{0x0685f0f6,0x6283e05c,0x68e76098,0xfd4ca016}},	//   игин, _plno, _hujd, _khiể,
   {{0x26deb360,0x44eab361,0x644e7362,0x98a060a9}},	//   _gito_, _fù_, _xabi, rtić_,
   {{0xf771e0d0,0x442b4733,0x3da7a60c,0xa3cba010}},	//   زاد_, _occ_, _сраб, रेख_,
   {{0x200a3363,0x6d4f8005,0x7d1bd364,0x7521e05d}},	//   wabi_, _ácas, prus, rulz,
   {{0x98484497,0xa3c9e621,0x660641ef,0x9c130125}},	//   xşı_, लेज_, _rekk, _gọme,
   {{0x61e2c06e,0xdb052057,0xceb90064,0x7ccac0a2}},	//   _zgol, _exhí, stęp_, _iƙra,
   {{0x6abb80bf,0x78bb8b01,0x7ae76048,0xb8ce2028}},	//   _okuf, _okuv, _nujt, _कद_,
   {{0x7643b365,0x3207e037,0x200b1366,0x7d1cf367}},	//   heny, _heny_, caci_, árse,
   {{0x4e1a204e,0x60d70087,0xa20662d8,0xbebb200e}},	// [e00] _июня_, _דוקא_, ипад, rtër,
   {{0x66065368,0x9c7ca098,0x757b0008,0xc5d7c07c}},	//   _wekk, _kiče, _סטיפ, _সভাপ,
   {{0x764f5369,0x7643b36a,0x3207f36b,0xb146706d}},	//   _facy, deny, _meny_, рнел,
   {{0x3136e00b,0x6f04000f,0x7ae6536c,0x644e6781}},	//   ינעם_, _kwic, _tukt, _wabi,
   {{0x6497c12a,0x87038766,0x1154809c,0x201aa1de}},	//   rţil, ояще, склю, ópio_,
   {{0xed59936d,0xaca46125,0x7d02c00f,0x57f3a5da}},	//   _drž_, _krọs, _rwos, општ,
   {{0x2731a016,0xf8bf2004,0xa7b8a5be,0x6723b36e}},	//   _cơn_, quée_, ылку_, gunj,
   {{0x395a2057,0x6f02c0d1,0x629ae867,0x98a6880e}},	//   _mrps_, _pwoc, wito, _тибе,
   {{0x635ca1fc,0xc866e881,0xd90dc555,0x25bf8037}},	//   _sănă, атни, فین_, _gyul_,
   {{0x7643a037,0x3eb82536,0x60c28eac,0x200b136f}},	//   ceny, jort_, llom, waci_,
   {{0x6b8d5370,0x75244996,0xe457600b,0x200b1371}},	//   zzag, huiz, בייט_, taci_,
   {{0xa17ba00b,0x657af09b,0x3cfd8ca9,0x22820031}},	//   _שטאט, ryth, रीके_, _dóko_,
   {{0x24805297,0xfbd2c11a,0x2d9e226a,0x320b1372}},	//   dkim_, देशम, úten_, racy_,
   {{0x38624061,0x7ae09373,0x61e3e194,0x8c43ef0e}},	//   _ankr_, _limt, _ggnl, _мече,
   {{0xbc07430e,0x60c29374,0x98b88157,0x6d4722be}},	//   ичай, klom, _aprč_, uwja,
   {{0xa3cbae8e,0x394b4037,0x6b8d4108,0xf00b6067}},	//   रेट_, _pscs_, tzag, _đằng_,
   {{0x6443b375,0x60c29376,0x80c9e07c,0x7d0400fd}},	// [e10] yeni, dlom, রদর্, _gwis,
   {{0x6443b377,0xd838e05c,0x442ca05d,0x2cb83378}},	//   xeni, biče_, _ncd_, cord_,
   {{0x44eb8271,0x99677379,0xb767679a,0x26c32364}},	//   _sø_, штал, штай, mljo_,
   {{0x6443a9cd,0x7ebd007b,0x4fd9e00b,0x4ea4803b}},	//   weni, cépt, אַנד, орча,
   {{0x69c081cd,0x27ec206f,0x660763ac,0x6298eb83}},	//   _cyme, ždne_, _tejk, _omvo,
   {{0x20856711,0x291ee037,0xa5f8737a,0x2486d37b}},	//   _السّ, krta_, _веру_, _alom_,
   {{0xa3d73133,0x660b82ed,0xd6db8aa5,0xe299cafe}},	//   िधि_, pagk, _ата_, лак_,
   {{0xc3326095,0xe518c292,0x6abb8174,0x7ae0803b}},	//   _מול_, _दिशि_, _ukuf, _gimt,
   {{0x2007f37c,0x7643b37d,0x69c081cd,0xa3cba567}},	//   _peni_, peny, _gyme, रेज_,
   {{0x387fc0c4,0x628ab37e,0x61e400ad,0x200cf37f}},	//   skur_, chfo, _sgil, gadi_,
   {{0xe820c010,0xbb45f380,0x908aa043,0x5f13c0c5}},	//   _याचा_, щенк, _حملے_, _दिक्_,
   {{0xff50a062,0x660d5106,0xcb6a0f84,0x1bef8026}},	//   _زخم_, jaak, гаме_, _छलफल_,
   {{0x0d9a01d3,0x0d9901ba,0x442d9381,0x6e3b88f7}},	//   утны_, атры_, _mce_, _mbub,
   {{0x3ce9005f,0x69cbc098,0x44fbc057,0x200cf382}},	//   _duav_, _izge, _iª_, cadi_,
   {{0xa3b52028,0xbcf5e4c7,0x6da2f0da,0x7e7ce0cb}},	//   _छुआ_, _استغ, _ниша, örpe,
   {{0x7c3b2381,0x3eb90c8a,0xe297441b,0x69c1b383}},	//   đura, cost_, бас_, _myle,
   {{0x7c365384,0x7ae1a00c,0x7c29d385,0x21674b65}},	// [e20] rfyr, _oilt, iger, бити_,
   {{0x42263386,0x7e214029,0xdfcf428b,0xc619e07c}},	//   _удов, यलॉग_, ريل_, ত্রা_,
   {{0x6299c00d,0x442cb387,0x54772076,0x6d5b8046}},	//   _omwo, _rcd_, _הגיע_, _arua,
   {{0x200ce055,0x6b812042,0x6d5b9388,0x5fbae00b}},	//   zadi_, ølge, _brua, אצענ,
   {{0x64457062,0x7ae08022,0xbcfb40f9,0x391380ff}},	//   behi, _vimt, _aréf, змір,
   {{0x64461389,0x6d49c011,0xbae580ff,0x68e8affe}},	//   heki, dwea, іцій, _pudd,
   {{0xe7fb2028,0x66098079,0x2731f38a,0x39400037}},	//   ्रता_, _feek, ján_, _lpis_,
   {{0x994c806f,0x7c3b8291,0x2b40138b,0xc3332095}},	//   môže_, _gbur, _opic_, פוח_,
   {{0xe1efc1ac,0x6d4f8057,0x200a60a2,0x7afbc0f2}},	//   رسي_, _ácap, _kebi_, gput,
   {{0xb4b23303,0x442cb38c,0x9c7cc29c,0x7bcf8057}},	//   टको_, _ucd_, _kučk, _ºcur,
   {{0x3eb90418,0x320ce7ac,0x3abb6087,0x7e76138d}},	//   tost_, rady_, רמינ, _boyp,
   {{0x660d4025,0x8503d38e,0x6446138f,0x7afc207f}},	//   xaak, _کوون, geki, dprt,
   {{0x44295390,0xeb97c052,0x937ac68c,0xc9841391}},	//   vga_, _лиц_, _حصار_, пури,
   {{0xfd4d4016,0x660d5392,0x68fb400e,0x7c2ab393}},	//   _thoả, waak, _çudi, ngfr,
   {{0x39401394,0x660d5395,0xa2b96c67,0x66d5c013}},	//   _epis_, taak, ्तस्, _iškr,
   {{0xd0110043,0x7f4d0058,0x18a405da,0x6d408b83}},	//   _کلک_, _tsaq, _најм, _opma,
   {{0x7ae2ce88,0x9fe7613a,0x200ea35f,0x6287620d}},	// [e30] _miot, مساه, kafi_, _pljo,
   {{0xf8bf3396,0xf09f05df,0x7aed45dd,0xf807260f}},	//   rtés_, lià_, rqat, _учин,
   {{0xf8bf3397,0x64472167,0x68e99398,0x7bda6066}},	//   stés_, meji, _sued, _útul,
   {{0x66f1a2b8,0x4ac90dad,0xe29f0069,0x68e1b399}},	//   _nāka, रतिव, nið_, _sild,
   {{0x21698f77,0x3ea9539a,0xa9698f77,0x2019407d}},	//   рили_, mnat_, рила_, _idsi_,
   {{0x7bc6e0c2,0x26c4c197,0x6447339b,0x6d4f539c}},	//   ękuj, elmo_, neji, _isca,
   {{0xe8d92079,0xf771a19a,0x644612d8,0xb7b3e1a6}},	//   _arị_, ظات_, yeki, _ঘণ্ট,
   {{0x64552058,0xc7b26095,0x44ef010a,0x6e3b939d}},	//   hdzi, _חבל_, _oü_, _ubub,
   {{0x6447339e,0x628980f9,0x7ae2c265,0x68e1b39f}},	//   keji, _ileo, _diot, _tild,
   {{0x291fd3a0,0x27ffc17b,0x2cbf8133,0x7e760071}},	//   rrua_, sbun_, _hkud_, _soyp,
   {{0xc668a90f,0x68fbc133,0xddaba052,0x2ca953a1}},	//   _уште_, spud, _стал_, knad_,
   {{0xb05b13a2,0x7aeae76d,0x645533a3,0x2ee36171}},	//   slän, _duft, edzi, _lijf_,
   {{0x78ad02d1,0x78a9d3a4,0x78bbc28e,0xe7f900c5}},	//   _djav, mnev, mouv, ंड़ा_,
   {{0x24890bf2,0x78a9d3a5,0x248dd3a6,0xefb3c0eb}},	//   _elam_, lnev, lhem_, _ویژگ,
   {{0x660e2962,0xe7fc8026,0x7d1ca831,0x7aebc0c4}},	//   rabk, उँमा_, _årst, _hugt,
   {{0x7ae3f3a7,0x9f5200d1,0x07a600ff,0xf09f0017}},	//   _hint, _deyò_, _майн, cià_,
   {{0xdca350da,0x8af7403c,0x9f49206f,0x0ffa6049}},	// [e40] фати, _şəra, _škôl_, لعاب_,
   {{0x03a66691,0x67272245,0xb5fb407b,0xa7fca0b0}},	//   оизо, bujj, _unán, _anın,
   {{0x4fea81bc,0xf8bf2195,0x249fc05d,0x200ea098}},	//   амен_, ptér_, kium_, vafi_,
   {{0x320a605c,0x9c7cc29f,0x68e40025,0x200f93a8}},	//   _weby_, _vučk, _jiid, gagi_,
   {{0x6497c0ba,0x69c3e725,0xa01b11cc,0x7d0021e9}},	//   cţii, _lyne, kkön, _fàrò,
   {{0x68e413a9,0x442fc153,0x6b57e125,0x6d5e212d}},	//   _liid, _acg_, _ụgw, _krpa,
   {{0xa3d4a029,0x629c7356,0xc04681c1,0x80b973aa}},	//   सें_, _imro, _وخرو, ्तरे,
   {{0x7ae3f3ab,0x442fd3ac,0x64552a0b,0x3ea053ad}},	//   _aint, _ccg_, zdzi, niit_,
   {{0x3ea6a691,0x78ad006e,0xd7ef8049,0xb6a6b3ae}},	//   _диаг, _rjav, _شكل_, _диал,
   {{0x7aebd3af,0x6146b3b0,0xa3ab40c2,0x26c693b1}},	//   _dugt, _меза, गपत_, lloo_,
   {{0x6abc33b2,0xd00fcf20,0xa3cfe37f,0x249ef3b3}},	//   dorf, _оф_, _शरण_, ritm_,
   {{0x27e0850e,0x57f401e1,0x6e3e205d,0x69c3e42b}},	//   žinu_, мпют, _abpb, _dyne,
   {{0xc87fc669,0x320ca03a,0x20194057,0x2ca94342}},	//   öße_, _kedy_, _rdsi_, vnad_,
   {{0x38786156,0xee3f0066,0x69ce60a2,0x6721e2e2}},	//   _norr_, mným_, _ozbe, brlj,
   {{0x4fc42250,0xb05b097a,0x628d53b4,0xee3f005c}},	//   дста, lläm, thao, lným_,
   {{0xd9e30857,0x82f7e6b0,0xa3cfe046,0x6d5e2012}},	//   _गणपत_, _بروز_, _शरत_, _drpa,
   {{0x68e3eecc,0xee3f0066,0x27e901e7,0x7ae3f3b5}},	// [e50] _yind, nným_, _igan_, _yint,
   {{0x29090125,0x6ef3617a,0x9c7cc5f9,0x78bd0530}},	//   _iwaa_, _aħba, _duči, losv,
   {{0x64a402e2,0x9bf88079,0xf8bf20fa,0x200f93b6}},	//   rđiv, _ịsụg, grée_, tagi_,
   {{0x2ca04054,0x29090079,0x6448f3b7,0x63adc0c4}},	//   ciid_, _kwaa_, hedi, _þang,
   {{0x248c203b,0x161f212f,0xee3f0066,0x22494108}},	//   šimų_, _बयार_, jným_, meak_,
   {{0xee3f0d3f,0x69cf53b8,0x6d5d8069,0x6728e098}},	//   dným_, _izce, _ásam, kudj,
   {{0x68ed0256,0x7f4d417a,0x7f42c071,0xe8d92088}},	//   _luad, lwaq, _apoq, _nrọ_,
   {{0xd838f3b9,0xddc7202e,0x3a3ea1f6,0x6d41a07f}},	//   viča_, rejň, _ebtp_, _vpla,
   {{0x66d0697a,0x6448f3ba,0x78bbd3bb,0x6d4d4e47}},	//   säke, fedi, rouv, nwaa,
   {{0xa3cfee8e,0x200cb3bc,0x660bc7ff,0xc8798106}},	//   _शरद_, _gedi_, _wegk, _hoş_,
   {{0x660d13bd,0xb5fb40f9,0x317fc17b,0x6d4d4cc0}},	//   _beak, _anám, syuz_, hwaa,
   {{0x6abd13be,0x8517004b,0x6448e057,0x69c3e066}},	//   gosf, _तिखट_, aedi, _vyne,
   {{0xb4b7c010,0xaca3e291,0x6f152064,0x27e90058}},	//   चकी_, _ahụh, eszc, _dgan_,
   {{0x7c2d469b,0xfc3f41e9,0x7649c054,0x33294037}},	//   egar, _abí_, leey, duax_,
   {{0x7ae5220d,0x01632734,0x8704e049,0x7d0980bb}},	//   _diht, нкро, _قبيل, _lwes,
   {{0x443f93bf,0x273453c0,0x88d1a07c,0x6d4d53c1}},	//   _nbu_, tän_, াদিক, fwaa,
   {{0x18a633c2,0x9f5825df,0x395f8022,0x29090079}},	// [e60] _наим, taró_, _nrus_, _gwaa_,
   {{0xf421a07c,0x66f1a041,0x823640e0,0x90c3604e}},	//   প্তর_, _nāko, _کردا, ебуе,
   {{0x200ca4d8,0xa87b2095,0xf67b2095,0x645573c3}},	//   _redi_, _האיר, _האימ, _dazi,
   {{0x200cac6c,0xe7b36050,0x7bce6cfd,0x765613c4}},	//   _sedi_, رمند, _vzbu, _jayy,
   {{0x9f5833c5,0x26c24020,0x6d5c33c6,0x442ce3e0}},	//   paró_, _ikko_, lvra, ygd_,
   {{0x75228ab8,0x653b000b,0x6d4413c7,0xee3f04d2}},	//   rroz, מענד, _mpia, vným_,
   {{0x6d5c2693,0x6aa1e435,0xbb436c84,0x6b6661ba}},	//   nvra, dilf, _перк, _эква,
   {{0x660453c8,0x752453c9,0x6448e1cd,0x321240ae}},	//   nbik, oriz, wedi, nayy_,
   {{0x201133ca,0x7d0981cd,0x68e640a2,0xaed4e143}},	//   yazi_, _gwes, _mikd, моиш,
   {{0xf8be69e4,0x628bd3cb,0x7ae653cc,0xee3f0066}},	//   ्तिय, _elgo, _likt, rným_,
   {{0x2fc74016,0x7413a01e,0x644ab3cd,0x3ea210dc}},	//   ́ng_, _سونا, mefi, fikt_,
   {{0x66cda06f,0x2bd987f1,0x7c2d4025,0xd24fc0eb}},	//   núkn, बेवा, xgar, _منم_,
   {{0x645613ce,0xfc3f005c,0x60c2d3cf,0x3211204a}},	//   _dayi, lník_, _ikom, tazy_,
   {{0x7d164944,0x176ae27c,0xe3afe6ec,0x39a34046}},	//   dsys, _грип_, ئری_, _कs_,
   {{0x765601df,0x75280064,0x9412403c,0x543be00b}},	//   _fayy, ądza, liyə_, _לעגא,
   {{0x201253d0,0x27356156,0xb4db61e9,0x98c440ba}},	//   gayi_, vån_, _asàp, есул,
   {{0x3160035d,0x248693d1,0x443f807d,0xbc79693b}},	// [e70] _griz_, dkom_, _rbu_, обах_,
   {{0xed600013,0x6e3d04f7,0xddc9c361,0x765601df}},	//   įžti_, lfsb, nješ, _zayy,
   {{0x1a65854f,0x92598052,0x7d098a43,0x76560020}},	//   ویسی_, жает_, _swes, _yayy,
   {{0x22590536,0xfbd0613a,0x66f1a041,0x60c2d3d2}},	//   ndsk_, اتك_, _sāko, _nkom,
   {{0x3dc5a0e2,0x2d4d423d,0x69a2a077,0x81df007c}},	//   _sylw_, _uže_, _केबी, দুর_,
   {{0x6496016d,0xbcfb47df,0x660f4bea,0x3ead416d}},	//   nšir, _eréc, _heck, četu_,
   {{0x248693d3,0x20c1c049,0x3f8213d4,0xd9fea046}},	//   bkom_, dóir_, zyku_, _उभरत_,
   {{0xa3ad055d,0xb4b7ca53,0x61e98425,0x7c3d02be}},	//   कपा_, चके_, _ugel, jfsr,
   {{0xdd9483fc,0x3944817b,0x644ab3d5,0x6ba6a03c}},	//   _заты, _gpms_, befi, _əsgə,
   {{0x442dc6f1,0xdeff217a,0xfc3f0066,0x7d1a206f}},	//   sge_, ċċju_, bník_, átsk,
   {{0x765601e7,0x201253d6,0x3ea20018,0xc5f400a2}},	//   _payy, yayi_, tikt_, _laɓe_,
   {{0x7e7b93d7,0x20c1d3d8,0x68e76171,0xe73a0772}},	//   _joup, róis_, _lijd, оем_,
   {{0x3ebfd3d9,0xddc9c04d,0x60c9d3da,0x3ebef3db}},	//   mout_, bješ, mlem, bott_,
   {{0x645721ae,0x7e7b93dc,0x69a2a4e6,0x3ea203e0}},	//   _caxi, _loup, _केडी, sikt_,
   {{0xa01b09ac,0xed5724c2,0x2005f3dd,0x765600b0}},	//   rhör, мор_, mbli_, _tayy,
   {{0x628d0420,0x186753de,0xad9b4066,0x3f89c018}},	//   _glao, маси_, _neús, _ļauj_,
   {{0x644b93df,0xfc3f005c,0xb8d648c6,0x07a3522f}},	// [e80] degi, zník_, _जद_, ватн,
   {{0x7aee6022,0x79828167,0xd838a361,0x7d1653e0}},	//   _pubt, vyow, _omča_, rsys,
   {{0x3eadd3e1,0x443ca05d,0x64902046,0x644ab3e2}},	//   knet_, vfv_, _väid, vefi,
   {{0x0dca853f,0xd9104555,0xd1ca8772,0xe1f8b3e3}},	//   олей_, _میر_, олее_, ुर्ण_,
   {{0x1fbae3af,0x7bc64106,0x20c2e765,0xcce58049}},	//   _उड्ड, _uyku, iðir_, رسمي,
   {{0x61ebd3e4,0x6b83a1cd,0xb87b6019,0x6b8285d2}},	//   _aggl, fyng, _quít, ryog,
   {{0x2242405d,0x764b93e5,0x64902046,0xc5f4035f}},	//   _kbkk_, begy, _käib, _zaɓe_,
   {{0xfc3f0066,0x60dbc8c4,0x30a3c5be,0xd90da0eb}},	//   rník_, gmum, крыв, صیه_,
   {{0x321dc1cd,0xb97b4053,0x20c1c049,0x6d5e63d1}},	//   _ddwy_, ַנטי, tóir_, lvpa,
   {{0x7e698089,0x4974e399,0xd7f7e1eb,0x61ebcbcf}},	//   _znep, елос, мую_, _eggl,
   {{0x60f8e2cb,0x7e7b93e6,0xb05b0d6e,0xd2510243}},	//   яння_, _youp, lläi, هند_,
   {{0xc0aacca7,0x44f3e067,0x68e8aded,0x671e4077}},	//   _باطل_, _dã_, _hidd, _पिंक_,
   {{0x656fc105,0x26c04024,0xb4e913e7,0xeabf13e8}},	//   ächt, doio_, यदे_, roù_,
   {{0x68e8b3e9,0x3b53c0ff,0x032000c5,0xf77325d1}},	//   _jidd, _шкір, _बिरह_, پاس_,
   {{0x44f3e067,0x7ae76171,0x78ad4363,0x1833e049}},	//   _gã_, _rijt, tnav, _شروح,
   {{0x2bdbd133,0x2a690071,0x645af3ea,0x850541c1}},	//   मेवा, _unab_, ldti, فورن,
   {{0x2242405d,0x7bca6105,0xb83360f9,0xbcfb4049}},	// [e90] _dbkk_, üfun, _ajúṣ, _bréa,
   {{0x443ee669,0x68e8b3eb,0x2bc4a033,0x7d0d125e}},	//   nft_, _nidd, _लुभा, _iwas,
   {{0x3ce90048,0x69c8b3ec,0x60c9c121,0x78a3a052}},	//   _kiav_, _nyde, ylem, vinv,
   {{0x80d1007c,0x29016227,0x68e76171,0x6aa3a62c}},	//   _সূত্, rpha_, _wijd, winf,
   {{0x60c0d3ed,0x3eadc5f0,0x909841e1,0x290ca05d}},	//   domm, vnet_, _цвят_, _awda_,
   {{0x7ff5abd0,0x3ebfd3ee,0x7642c62e,0xf53641a9}},	//   رستا, wout_, _aboy, _אנשי_,
   {{0xdbd6e6eb,0x7ae8a426,0x3946c1ae,0x60dbd3ef}},	//   _jääk, _didt, _apos_, tmum,
   {{0xea9f81e9,0x101780e0,0x672613f0,0x7d026143}},	//   _daṣa_, _زبرد, yrkj, ćost,
   {{0x752d4024,0x64806052,0x661533f1,0x6f0d00a2}},	//   nuaz, _töit, kazk, _nwac,
   {{0x60c9d3f2,0x60dbc614,0x6562c0cb,0xa3b88466}},	//   slem, smum, _droh, _घुट_,
   {{0x2169e4c2,0x2738e508,0x2007b1c8,0x3d1640a8}},	//   чини_, gén_, mbni_, _पौने_,
   {{0xb05b4241,0xd7f8e0ba,0x63bb220f,0x7d0d13f3}},	//   _skän, acă_, ğunl, _bwas,
   {{0x6d5ce6dd,0x68fe27d3,0x2bd1e35b,0x7e6bc011}},	//   årar, _stpd, _हरवा, _ingp,
   {{0x2006812a,0x6459c054,0x6288f083,0x24894018}},	//   zboi_, _hawi, ckdo, ekam_,
   {{0x224e6497,0x27ed8200,0x6f028064,0x7bcb4105}},	//   _ölkə_, _ogen_, zpoc, ügun,
   {{0x2bfbe029,0x765bc00f,0xf772a053,0xfa0961a6}},	//   लुरू_, nduy, נקן_, _লাগল_,
   {{0xbcfb53f4,0x7bc98167,0x443fc167,0x22b8807f}},	// [ea0] _préa, _nyeu, ifu_, nčke_,
   {{0x224dc171,0x201f8167,0xb21b4065,0x799640c2}},	//   heek_, _adui_, _blæs, rzyw,
   {{0xdb1d4066,0x3947e17b,0xd7fa81fc,0x764e277b}},	//   _vysá, _jpns_, пул_, meby,
   {{0x83fca6be,0x26c213f5,0x645c33f6,0xe6128062}},	//   _inđi, noko_, ldri, اشا_,
   {{0xa3e2ac4c,0x9f4045df,0x98a7c04a,0x764404b7}},	//   नेन_, rció_, stně_, _mbiy,
   {{0x644e33f7,0x6459c5c8,0x20116106,0x628e60ae}},	//   nebi, _aawi, _gezi_, _ulbo,
   {{0x7d044e27,0x443fd3f8,0xce94c14a,0x9c7cb3f9}},	//   lpis, ffu_, какъ, _hičk,
   {{0x09e4407c,0xdee3845c,0x7d04404e,0x224dd3fa}},	//   _ফ্যা, _боси, opis, geek_,
   {{0x7d0453fb,0x68e8a17a,0xe572c4a1,0xe4a6f3fc}},	//   npis, _tidd, اطع_, ерно,
   {{0x9f4a61e9,0x444423d2,0x443fd3fd,0x443ee105}},	//   _agbé_, _nb_, afu_, uft_,
   {{0x6e950255,0x229507ca,0x26c20194,0x7d092098}},	//   вину, виня, foko_, ćesk,
   {{0x645c33fe,0x9bb7a095,0xf3ffa067,0x44f52584}},	//   edri, _אהבה_, _đãi_, _rå_,
   {{0xa887c7ca,0x3ce90048,0x69c9805f,0xbcfb53ff}},	//   _яйца_, _viav_, _xyee, _arén,
   {{0x644e3400,0xdfcfc13a,0x81c5007c,0x6f045401}},	//   gebi, _ايه_, ৌশল_, dpic,
   {{0x7e7d4130,0x765ab402,0x77641403,0xd32426fc}},	//   _posp, _maty, _erix, льти,
   {{0x672126ca,0x20116163,0x7af5205d,0x8aa444a0}},	//   šljo, _sezi_, rqzt, груд,
   {{0x648de13a,0x7d0448b2,0xf1a401ba,0xfaf340e0}},	// [eb0] _múin, gpis, _брэн, اثر_,
   {{0x645bc0ba,0x44443404,0x20d20049,0x201200a2}},	//   zdui, _gb_, náin_, _zeyi_,
   {{0x6f1c6098,0x6d5a6cf5,0x26c3203b,0x442122d9}},	//   _cvrc, _štar, mojo_, _idh_,
   {{0x9f40465f,0x25a606be,0x44443405,0x6aa72171}},	//   rciò_, _žoli_, _zb_, lijf,
   {{0x6d48ab8e,0x673d1406,0x20d90049,0x6fd54028}},	//   _apda, ntsj, méid_, _दरिं,
   {{0x6abae38e,0xaca36125,0x6aa2c1e9,0x26c21407}},	//   ईकोर, _kpọb, _amof, zoko_,
   {{0x648de069,0x7e6d1408,0xb882204a,0x60c28cfa}},	//   _búin, _onap, _říka, boom,
   {{0x32094bee,0x2739d409,0xa4d5884f,0x7e6d0079}},	//   nbay_, tèn_, _робі, _nnap,
   {{0x6d5a6057,0x26c3340a,0x6494a58f,0x9e15a0db}},	//   _átar, kojo_, _bàid, _адзі,
   {{0x644e2265,0x395fd40b,0x3947e037,0x645bd40c}},	//   xebi, rvus_, _ppns_, sdui,
   {{0x69cae0e2,0x26c2140d,0x2129540e,0x765b8068}},	//   _cyfe, toko_, hrah_, _kauy,
   {{0x7e7e27f7,0x4421228f,0x2ca7b40f,0x644f02a8}},	//   _sopp, _adh_, lind_, geci,
   {{0x644e3410,0x645ab411,0x32094401,0x61fbc61d}},	//   tebi, _yati, dbay_, mcul,
   {{0x645aa03c,0x765b835f,0x6aa60ad2,0x60c3a0ca}},	//   _xati, _lauy, sikf, nonm,
   {{0x673d02be,0x6d5ca0c4,0xe3b83412,0x6b8de0a2}},	//   atsj, _árat, çı_, _ƙagu,
   {{0x9c7ca64e,0x44213413,0x765b8068,0x6569400a}},	//   _pičk, _edh_, _nauy, _šeha,
   {{0x95834955,0xa3df7414,0x60c3b415,0x273aa0dd}},	// [ec0] алте, देस_, konm, zën_,
   {{0x225e0041,0x42c4407c,0x2a6d804a,0x6aa72171}},	//   ētku_, ্দেশ, _aneb_, cijf,
   {{0x212948a7,0x50b5612a,0xd826401b,0x98ad4106}},	//   arah_, усту, _идни, _çoğu_,
   {{0x645ab416,0x21295417,0x0d86831a,0x6b7ae053}},	//   _sati, brah_, клен, ורענ,
   {{0xb8f96021,0x929de0c2,0x60c3a4cf,0x645820c4}},	//   _ठी_, zpła, fonm, _óvis,
   {{0xfc036a0c,0x399b00be,0xb1466a93,0xe45f0262}},	//   _впро, וינד, _ингл, tlök_,
   {{0x9f586069,0x387f9418,0x6d498108,0x8fa6673f}},	//   _gerð_, _four_, _epea, _раве,
   {{0x3eb2404e,0x9c7cb3f9,0xab83b254,0x44387419}},	//   nnyt_, _miči, рушк, _hcr_,
   {{0xdd90c4aa,0xd94681e3,0x9c7ca015,0x69caeaaa}},	//   صود_, _јези, _liči, _syfe,
   {{0x9f98a326,0x7afdc530,0x273aa00e,0x98e6a049}},	//   lším_, ísta, pën_, _شكاو,
   {{0x20d20049,0x2d98a135,0x60cd541a,0x7aeaf41b}},	//   ráin_, _åre_, ylam, _vift,
   {{0xa9c3e4a4,0x2ebd253a,0x8c3dc6df,0x2013341c}},	//   рськ, ोत्त, nişl, _sexi_,
   {{0xe0df0024,0x20d203f6,0xa2b8541d,0x273c741e}},	//   rmò_, máil_, ्कन्, hín_,
   {{0x26c4d41f,0xf366e799,0x672f016d,0x673d1420}},	//   lomo_, _атин, rucj, rtsj,
   {{0x6aa722be,0x26c33421,0xd4983422,0x78ada3bb}},	//   rijf, rojo_, тря_, éavi,
   {{0xe802b423,0x60c3a061,0xd838e126,0x38ad200a}},	//   रुता_, zonm, diči_, džre_,
   {{0x9ed9616c,0x645e62be,0x61ed802e,0x32095424}},	// [ed0] емат_, fdpi, žalk, rbay_,
   {{0x273c7425,0x9418203c,0x634aa03c,0xa49b61e9}},	//   fín_, kirə_, _kənd, _awòr,
   {{0x7690204e,0x20d9013a,0x69c863d1,0x2bd5448b}},	//   _käyn, péid_, _ødel, _दरवा,
   {{0xbebd0018,0x634aa5fc,0x7c22d426,0xb4ccc04b}},	//   drīk, _zəng, _ndor, ळतो_,
   {{0x96b82050,0x3ea95427,0x2366c05f,0xf9908049}},	//   _سایز_, miat_, _nroj_, يبه_,
   {{0x20191428,0x2bc6c38e,0xaec4aa0e,0x7aed0e88}},	//   hasi_, _लड़ा, абіл, _liat,
   {{0x7aebc1e7,0x4439404d,0xfaa5d429,0x41e463b7}},	//   _pigt, _kcs_, лако, _віта,
   {{0x7aed08a4,0x799ae064,0x201907b9,0x4439405d}},	//   _niat, dztw, jasi_, _jcs_,
   {{0x645c6c0f,0x6609d42a,0x7d02c05d,0x5c15e65d}},	//   _yari, rbek, _ctos, льну,
   {{0x6609d42b,0x2fcd8187,0x7d02c3f6,0xaca3e088}},	//   sbek, _iyeg_, _dtos, mpịn,
   {{0x8c3dc121,0x69cd0037,0x273d542c,0x60db942d}},	//   lişm, _ayae, hìn_, _khum,
   {{0xe45f4156,0x27e9820d,0x68ed058f,0xbcfb40fa}},	//   _skön_, žanu_, _ciad, _prél,
   {{0x6d5ee026,0xf1a7a4ef,0xaa45ea8d,0x22b8806e}},	//   _špat, _केतन, _белл, nčka_,
   {{0x6e22c7ac,0x44f8a082,0x645d542e,0x9c7ca04d}},	//   _zdob, _yé_, _aasi, _piči,
   {{0xb8dc27c8,0x3ea9542f,0x442243ac,0x2b4b40d5}},	//   _अद_, fiat_, _pdk_, _apcc_,
   {{0x48c4407c,0x78a4049f,0xa3ea40de,0x7d1c21ae}},	//   ্দ্র, _umiv, едба_, rsrs,
   {{0x7d048041,0x799bd430,0x44f99431,0x9f98a026}},	// [ee0] ģisk, nzuw, _nè_, vším_,
   {{0x66161432,0x9419003c,0x0717f2de,0x645d4095}},	//   _heyk, disə_, _दबाव_, _easi,
   {{0x248dd433,0x26c5e197,0x98a6412a,0x1bba6049}},	//   kkem_, iolo_, _бине, رائع_,
   {{0xdb1ea162,0xa5bb41af,0x7b206066,0x628e3434}},	//   _évén, _idón, _náuš, lkbo,
   {{0x5fe04cb5,0xa3e04688,0xa3aa04ba,0x7bcd0286}},	//   पेशल, धेश_, _गेम_, _xyau,
   {{0x628e29e2,0x2a60410a,0x28d840aa,0x386fc030}},	//   nkbo, ldib_, _भीति, _angr_,
   {{0x9f98a066,0x2ba7a8f2,0x661980c2,0x6e240125}},	//   pším_, _केदा, bawk, _odib,
   {{0x6f036017,0x27f201e7,0x645d4caf,0x6b81214f}},	//   ínce, _ngyn_, _xasi, ølgi,
   {{0x68ed003a,0xb05b0669,0x44f8b239,0x0caae501}},	//   _riad, klär, _wé_, етни_,
   {{0x26c5f435,0xfb1b81a9,0x68ed1436,0x68ee617a}},	//   golo_, _נובמ, _siad, _jibd,
   {{0x29120187,0x61ea05fc,0x54776053,0xaa63e056}},	//   _awya_, əllə, אגיע_, стык,
   {{0x6f040425,0x81b961a6,0xeb9acaf5,0x20c9a3f6}},	//   _btic, _চরম_, _пие_, búis_,
   {{0x44395437,0x862724e4,0x984b214a,0x2366c00e}},	//   _rcs_, льве, нява_, _uroj_,
   {{0x2ca95438,0x6281b439,0x859bc095,0x656941e4}},	//   wiad_, _xolo, _אשדו, _šeho,
   {{0x6444471a,0xdd9420fb,0x7aed00f9,0x3219143a}},	//   ffii, бары, _tiat, pasy_,
   {{0x291ef43b,0x4444743c,0x6d5aa167,0xb05b13a2}},	//   msta_, ef_, _msta, rläs,
   {{0x4439401f,0x7bcd01e7,0x25f640c5,0x7c3ab43d}},	// [ef0] _vcs_, _uyau, ौड़ी_, _octr,
   {{0x69ce6f06,0x2ca941cd,0x443a217b,0x6d4d143e}},	//   _bybe, siad_, _gcp_, _ipaa,
   {{0x2a6044ec,0x20d4604e,0x60c56b39,0x3ea6c552}},	//   bdib_, päin_, rohm, _omot_,
   {{0x297a2087,0xa7fb41af,0xed5986be,0x80d3407c}},	//   _סטרא, _bañe, _psž_, _দূর্,
   {{0xdc36449c,0x645e2dd4,0x44fae00e,0x225ea187}},	//   _דארט_, _yapi, _lë_, _batk_,
   {{0x44f98163,0x656d806f,0x64902052,0xd019c0c2}},	//   _vè_, ťaho, _näil, wań_,
   {{0x4095c486,0x26c5e14a,0x44248065,0x7af7343f}},	//   ирит, volo_, _fdm_, _juxt,
   {{0x7af725fc,0x0685c5a8,0xa3dee0a3,0x4c85d440}},	//   _muxt, ргин, _běží_, рлив,
   {{0x661af441,0x23690048,0x6c84813a,0xe7e0c10a}},	//   fatk, _nraj_, _القم, खेला_,
   {{0x672d43ee,0x44fae00e,0x78a9cb83,0x248dcdd8}},	//   iraj, _bë_, siev, skem_,
   {{0x291ef442,0xade1a55d,0x39417443,0xbb45f444}},	//   gsta_, गेशन_, nths_, шенк,
   {{0x7c252256,0x64bc9445,0x39405446,0x9c7ca030}},	//   _adhr, mčic, ytis_, _chčf,
   {{0x64861447,0xa3e9c308,0x7ff4c449,0x645f0025}},	//   _sóis, _मणि_, _اسما, _daqi,
   {{0xa3da9112,0xa5bb40f9,0x672d5448,0x99582066}},	//   डेट_, _adóo, draj, ráže_,
   {{0x99582066,0x2b4ca17b,0x2abac018,0xd175220e}},	//   sáže_, _xpdc_, lība_, быты,
   {{0x2eeef449,0x660d544a,0xcf92a00b,0x752d4603}},	//   _ziff_, gbak, קטן_, fraz,
   {{0x6444544b,0x4fea53b0,0x68e28954,0x6d5ee005}},	// [f00] rfii, тман_, vmod, _ápar,
   {{0x6e3641cd,0x64902046,0x76498c75,0x38600076}},	//   sgyb, _käim, _abey, _hair_,
   {{0x867b2095,0x26c7a14a,0x645f144c,0x752d544d}},	//   _סרטו, dono_, _yaqi, araz,
   {{0x7bce6066,0x6b836277,0xab66863e,0xeb068a92}},	//   _vybu, änga, ивел, ачко,
   {{0x6283e037,0x7694a0f9,0x44fbd44e,0xdce2e7a0}},	//   _oono, _aàya, _nê_, _sroč,
   {{0x291ef44f,0x38600050,0x69ce6bca,0xafdb0271}},	//   ysta_, _lair_, _tybe, dføl,
   {{0xbbd31450,0x4425acc2,0x92d8407c,0xfdd30077}},	//   _सर्क, _ddl_, াদী_, _सर्फ,
   {{0x661ae820,0x20005451,0x6d5aacf5,0x2fcfc551}},	//   watk, ncii_, _vsta, _bygg_,
   {{0x44fc28e6,0x7d06405d,0x26c7a0bb,0x6d41e0c2}},	//   _lí_, _jtks, bono_, etla,
   {{0xd838a143,0x68e45452,0xdce2e29c,0x6296011d}},	//   _omči_, hmid, _troč, _alyo,
   {{0xd48fd453,0x99f7642c,0x6568a0dd,0x291ef454}},	//   _др_, יזיה_, _urdh, usta_,
   {{0x2aad2199,0xa2daa292,0x9c83c098,0x321ca066}},	//   džba_, _पीत्, _ščvr, lavy_,
   {{0x6283f455,0xe3b2cca7,0xaae5c33e,0x6d429456}},	//   _fono, _برا_, _اسلو, ntoa,
   {{0x68e44046,0x6d4e622e,0x752d44f3,0x645f1457}},	//   emid, _opba, vraz, _waqi,
   {{0x82a741ba,0x8aa75458,0x443ce5df,0xd4c5e13a}},	//   ашае, арад, _icv_, _اغني,
   {{0x26c7b459,0x80d1007c,0x60c7200e,0x442d345a}},	//   zono_, _সংক্, sojm, şe_,
   {{0x6b5c2342,0x7aef48cd,0x9f4a6031,0x7e628024}},	// [f10] _pågå, _vict, _agbà_, ddop,
   {{0xa3d7aa2a,0x2906c167,0x449861ba,0x2018745b}},	//   _सरल_, _mtoa_, авую_, _ceri_,
   {{0x44fc2031,0x6455345c,0x7e60945d,0xd5b826fc}},	//   _gí_, mezi, _bamp, _вся_,
   {{0xb87b641a,0xb4c0c026,0x2ef86110,0x29094052}},	//   _juíz, ंको_, _durf_, ppaa_,
   {{0x63bb23df,0xbebd0041,0x2ca90079,0x291e2199}},	//   ğunu, brīv, _mmad_, štat_,
   {{0x6d41e5fc,0x2fcfc249,0xbebd0041,0xaf3760d0}},	//   ytla, _rygg_, nsīb, _پرست,
   {{0x661bd45e,0x1a6864b7,0x60cd005c,0x26c7b45f}},	//   tauk, _خیلی_, _okam, rono_,
   {{0xb5fd9192,0x13b82095,0x291fd460,0x45b82095}},	//   _baše, יהול_, tsua_, יפול_,
   {{0x798d5461,0x6d5b8e96,0x64553462,0x200dd463}},	//   nyaw, _usua, kezi, rbei_,
   {{0x7ae4445e,0x64553464,0x291fc058,0xafdb0042}},	//   zmit, jezi, rsua_, rføl,
   {{0x7e609465,0x66dd10a2,0xe643c315,0xa2ba6437}},	//   _yamp, zéke, şmış, ्वत्,
   {{0x160bb466,0x661c3467,0x753521d7,0xbebd0041}},	//   _स्तर_, wark, duzz, esīb,
   {{0x80d1007c,0x7e61b468,0x443dc037,0xe3b1e10c}},	//   _সংখ্, _kalp, _icw_, ترک_,
   {{0x66dd00e0,0xf1b9c40c,0x78bb8262,0x2cadd469}},	//   véke, gaše_, _ljuv, lied_,
   {{0x753ca105,0x69a76aa9,0x64b746a6,0xdddc60ba}},	//   _ärzt, _टेली, pćil, _morţ,
   {{0xa924606f,0x64a34407,0x86994a75,0xb21b0065}},	//   _úžit, паса, атут_, skær,
   {{0x6455346a,0x3219448d,0x09e5607c,0x634aa03c}},	// [f20] bezi, _desy_, _প্লা, _məna,
   {{0x6455214a,0xaa7b406f,0x7e1088b1,0x3eadd46b}},	//   cezi, _chýb, ार्ग_, hiet_,
   {{0x44fc2049,0x69db8071,0x3eadd46c,0x41cec026}},	//   _uí_, _azue, kiet_, _हुनस,
   {{0x7e628187,0xdcee4013,0xb4db2017,0xe81a80a4}},	//   udop, vybė, ntàn, ازات_,
   {{0x2723e602,0x44fd0016,0x763b000b,0x98a066a6}},	//   hın_, _xì_, רענג, jrić_,
   {{0x6ab2c8b1,0x98a0650e,0xb4c2c046,0x6456546d}},	//   ुक्र, drić_, ृत्_, leyi,
   {{0x6d5c746e,0x66040434,0x3e856026,0xb8ff87c8}},	//   _usra, _ofik, _dítě_, _धी_,
   {{0x8c438093,0xb4d2004b,0x6d429273,0x68f9c194}},	//   _несе, वतो_, ptoa, _buwd,
   {{0x649cc13a,0xdee38052,0xb5fd8cf5,0x66d88066}},	//   _léig, _хоти, _inšp, líko,
   {{0x661d012b,0x0907c07c,0x3ea91234,0x415b400b}},	//   wask, _শিশু_, _smat_, נדיג,
   {{0x7bdaa041,0x7524146f,0x26ca3470,0x7d0aaa93}},	//   _uztu, _aviz, dobo_, _снег_,
   {{0x8c3dc03c,0x24804d52,0x98a062c9,0x7f44405d}},	//   yişi, jjim_, brić_, ktiq,
   {{0x26ca282a,0x27ed0052,0xb4c31471,0x66dd0009}},	//   fobo_, äen_, ्तौ_, tékb,
   {{0x661d1472,0x1994e4a0,0x2723e315,0x20020065}},	//   sask, _маля, bın_, acki_,
   {{0x66028037,0xd2d74049,0xf8bfe0fa,0xdce2a04d}},	//   kcok, مغرب, éée_, jvoč,
   {{0x645520bb,0x7d7900e0,0x67229473,0x661ab474}},	//   sezi, _نمبر_, ksoj, _letk,
   {{0x78ad5475,0xe1f04049,0x6f1600fd,0xbd022079}},	// [f30] riav, فسك_, _gwyc, _ọktọ,
   {{0x8c3dc3ed,0x26ca3476,0x75353477,0x6b8d4b0c}},	//   rişi, cobo_, puzz, ryag,
   {{0x628640e0,0x752400a9,0x2907600e,0x9df99478}},	//   _foko, _zviz, ëna_, анет_,
   {{0x7c28a095,0x29076018,0x443ea076,0xd05c80e8}},	//   _addr, īna_, _act_, _murɗ,
   {{0x764d106c,0x7afaa04e,0xa2c7c37f,0x98b8412a}},	//   _mbay, _autt, ावस्, stră_,
   {{0x0f1b60e0,0x1869b479,0x3eadd47a,0x2bd96062}},	//   _مغرب_, раки_, wiet_, _نازک_,
   {{0x28abe295,0xa5c38064,0x543c200b,0x64bc90b7}},	//   टोफि, _łódz, טעגא, sčia,
   {{0x4429147b,0x22494058,0x6490210a,0x6d45747c}},	//   _nda_, nfak_, _päik, mtha,
   {{0x2ee001cd,0x6495c049,0x3f42c0c4,0xc985c049}},	//   _rhif_, _fáin, gðu_, تشغي,
   {{0x2ed205c5,0x649024ef,0x7d098434,0x764d02a9}},	//   सत्त, _väik, _ites, _abay,
   {{0x6d5f0625,0x7afaa488,0x4429147d,0x3ce00022}},	//   _asqa, _gutt, _bda_, _phiv_,
   {{0x395dc022,0x2caf8171,0x25e1608d,0x644d0090}},	//   _tsws_, nigd_, _करनी_, _cbai,
   {{0xb4db25df,0x7c3e2143,0xa01b0149,0x78bd003e}},	//   rtàn, _pcpr, rköp, érva,
   {{0xb4db25df,0xa7fb4005,0x3ce68714,0x2bdc947e}},	//   stàn, _raña, zmov_, _बरसा,
   {{0x3ce0005f,0x6724817a,0xed5a22d7,0x290dd47f}},	//   _thiv_, ġiji, шов_, lpea_,
   {{0xa3a92010,0x66040c55,0x26cb1480,0x7d098066}},	//   _खेळ_, _ufik, coco_, _otes,
   {{0x629c3481,0x6d4560e2,0x7afb831d,0x2caf8200}},	// [f40] phro, etha, _nuut, digd_,
   {{0x44291482,0x7f445483,0x62865484,0x6ee96012}},	//   _zda_, rtiq, _woko, _ožbu,
   {{0xed5a68ea,0x7ce032f1,0x6d457485,0x201fc17b}},	//   рое_, göre, gtha, kaui_,
   {{0xf8bf20fa,0x7f445486,0x7c2de020,0x443eb487}},	//   rsée_, ptiq, _ɓara, _sct_,
   {{0x443f9488,0x7ae1a090,0x2499000e,0xc9838052}},	//   _dcu_, _bhlt, ërmi_, дущи,
   {{0x6724486e,0x752fe064,0x6723a6a6,0xe5a66aab}},	//   msij, ńczy, fsnj, _диги,
   {{0x321ee089,0xdddc7489,0xd130a049,0x41276143}},	//   vaty_, _forš, رمة_, _моро_,
   {{0x6d460469,0x2240005d,0x6496e0ba,0x6e3bd48a}},	//   ktka, _ncik_, _câin, ggub,
   {{0x66d0604e,0x4429148b,0x2258223c,0x236d8b47}},	//   säku, _rda_, kerk_, _grej_,
   {{0xa49b20d1,0xb87b6057,0x7524548c,0x656d000e}},	//   npòt, _quíx, isiz, _rrah,
   {{0x7f441441,0x321ee8db,0x7e640125,0xe3e8a050}},	//   _aqiq, raty_, _baip, _اکشن_,
   {{0x7e64148d,0x92cae07c,0x7658b48e,0x6d5c20fd}},	//   _caip, লগে_, levy, dwra,
   {{0x7cf5a013,0x69de2108,0x28dfb48f,0x64409490}},	//   _išra, _azpe, _पीडि, _mcmi,
   {{0xf8caa028,0xe7e1a026,0x769cc0f9,0x96a6e04b}},	//   ाकिय, गेका_, _déye, टोशॉ,
   {{0x7ce02277,0x349500d6,0x6e9500bc,0x22494106}},	//   förb, _накр, _нику, tfak_,
   {{0x90c4039d,0x6d456048,0x539be076,0x212d207f}},	//   _обје, vtha, _כיוו, čeh_,
   {{0xe719413a,0x656e6256,0x228720fb,0x249d8022}},	// [f50] صيات_, _arbh, _дунг, vhwm_,
   {{0x661c7491,0xa2b4204e,0x7afb82df,0x6d457492}},	//   _cerk, _обыч, _ruut, ttha,
   {{0xa907663b,0x661c7493,0xddc1a018,0x2caf82be}},	//   زبان, _derk, _valū, tigd_,
   {{0x660de00a,0x6738a579,0x7ce02728,0x7ae2c125}},	//   _đakm, duvj, röre, _nhot,
   {{0x7d022098,0x534450f6,0xc6175133,0x6e20d494}},	//   _čosi, _охра, तरीय_, damb,
   {{0xb5fd8552,0x22b60018,0x80a8a14f,0x2606a35b}},	//   _daša, rāki_, овів_, सुली_,
   {{0x78ad010a,0x7bc2c005,0x7afd5495,0xa2ba6086}},	//   _omav, _axou, _hust, ्वर्,
   {{0xa5bb4dc1,0xba778678,0x395f8022,0x224d807d}},	//   _adói, _باست, _tsus_, _ubek_,
   {{0x442b504a,0x68fc64cd,0xf1b98490,0xaca3a067}},	//   _mdc_, _zurd, _beše_, _quỳn,
   {{0x201cec35,0x68fc619f,0xa5bb4e1c,0xfd648088}},	//   _cevi_, _yurd, _teóf, _larị,
   {{0x6490210a,0x5f05e0db,0x186a1097,0xb5fd8012}},	//   _käiv, язна, бани_, _zaša,
   {{0x645980fd,0x2a65b006,0xa5bb4071,0xa7fce6fa}},	//   newi, _halb_, _geóg, ldıl,
   {{0x2be2c7c8,0x3f8f017a,0xbf9b01de,0xc7b8e29c}},	//   _परया, _żgur_, scên, rađa_,
   {{0xf8bf42f4,0x64bc8013,0x2bc6e028,0x7d097496}},	//   _ajé_, yčio, _रुका, _česn,
   {{0x96965497,0x09b8804b,0x66dec00e,0xd5b22049}},	//   праш, _अश्य, lëka, رفر_,
   {{0x68e9d498,0x2360005f,0x7af56041,0xf09f0090}},	//   nmed, _tsij_, _aizt, chà_,
   {{0xf539c06f,0x649cd2d4,0x6738a579,0xd00f20e0}},	// [f60] nuť_, _héic, zuvj, ئلہ_,
   {{0x66d0604e,0xc17300be,0xe1ff06d9,0x244fa3ed}},	//   väks, _נחת_, ndón_, nımı_,
   {{0x7afd4108,0x44220265,0x7ce5c057,0x3ebf8227}},	//   _eust, oak_, mórf, _bjut_,
   {{0x63a29499,0x6ba10121,0x629de3ac,0x76598155}},	//   tzon, _özgü, ësoj, gewy,
   {{0x44220265,0x3866864f,0x6724417a,0x7bcb417a}},	//   iak_, rdor_, qsij, żgur,
   {{0x644e749a,0x3ead80b8,0x68f56012,0x68e9c165}},	//   _ubbi, _emet_, _gizd, emed,
   {{0x81d4a07c,0x64598854,0xda65a13a,0x7afc6171}},	//   সেন_, bewi, باني, _uurt,
   {{0xb902807c,0xbddb549b,0xdb1c60c2,0x5ba6c5d0}},	//   _নং_, _ibèr, _wyró, зроз,
   {{0x3f804057,0xa87b4053,0x7c22846b,0x8c3dd49c}},	//   nxiu_, מאקר, maor, vişt,
   {{0x27f8e042,0xf8cc6064,0x7ae9d49d,0x5f94e3d5}},	//   ørn_, ़किय, amet, диот,
   {{0xb5fd835d,0x7ae9d49e,0x68e406f1,0x59be749f}},	//   _mašn, bmet, _bhid, ्थिर,
   {{0xa7fb4057,0xfaa3c03b,0xba17c049,0xddc1e009}},	//   _raño, _пахо, _فيما_, gelő,
   {{0x661d40d1,0x225914a0,0x7ae414a1,0x61fb02c9}},	//   _resk, resk_, _dhit, žulo,
   {{0x7cc1c2b8,0xf1be6180,0x1adca029,0x6562d4a2}},	//   mēra, ्थान, यतिथ, _isoh,
   {{0x27e00e3b,0x661e34a3,0xa4d5471b,0x7de720e0}},	//   _ezin_, _depk, дові, désé,
   {{0xf8bf207b,0x768fa14f,0x3264414f,0x7ae414a4}},	//   trés_, _høyt, нтув, _ghit,
   {{0xc311807c,0x200902a8,0x7af56108,0x443ee171}},	// [f70] _হয়নি_, _ifai_, _pizt, ogt_,
   {{0xa2c50914,0x3ea040ae,0x661d54a5,0xf8bf34a6}},	//   रवक्, ahit_, _wesk, rrés_,
   {{0x7ae9d4a7,0xb5fd8098,0x7afe2136,0x6e2d005d}},	//   ymet, _dašn, _gupt, _kdab,
   {{0x02a749b1,0xddcd006e,0x35b58799,0x20d20049}},	//   _хром, _znaš, мбер, láir_,
   {{0xd126c0a4,0x6702a088,0xbddb4061,0xf194814f}},	//   _جم_, _ọkpa, _ebèr, ниць,
   {{0x2a65a17a,0x66dd004a,0x7af7217a,0x6283a022}},	//   _qalb_, kéko, _jixt, ujno,
   {{0x66dd00e0,0x6e21f4a8,0xa7fce6fa,0x2298c187}},	//   jéko, valb, rdıl, _céko_,
   {{0xb3aa207c,0x3949403b,0x6e2d04fd,0xe7d0e0a8}},	//   _খুঁজ, otas_, _ndab, _हड़प,
   {{0x6efa6026,0x6490210a,0x9f586061,0x7ce02156}},	//   _vůbe, _käit, _agrè_, höra,
   {{0xb0bf6857,0x290bc041,0x648de049,0x3ea0400e}},	//   ्विग, īca_, _rúis, zhit_,
   {{0x68e9d4a9,0x6da5e423,0xe5a5f24b,0x6e21e48f}},	//   pmed, фина, фини, ralb,
   {{0x7d1b8088,0x2a694022,0x49148026,0x656d802e}},	//   _kwus, jdab_, नीको_, ťahu,
   {{0xe0cef4aa,0xc058c5d0,0x442334ab,0xa3ac54ac}},	//   _ав_, _хіх_, faj_, _कें_,
   {{0x672600ff,0x7af734ad,0xa3e2c4d6,0x20d205e0}},	//   rskj, _cixt, _धरत_, táis_,
   {{0x7ce02277,0x394954ae,0xcb6721fc,0x9f43e04e}},	//   göra, etas_, маре_, äjä_,
   {{0x2ca04058,0x6e23b4af,0x7f49c5df,0x39494af1}},	//   uhid_, hanb, oteq, ftas_,
   {{0x9f44004e,0xaec634b0,0x661e2106,0x4b260362}},	// [f80] ämä_, _обил, _tepk, _ўмов,
   {{0x6d49c00c,0x3ea040dd,0xb21b0065,0xb937000b}},	//   itea, shit_, hjæl, _קריג_,
   {{0xf9920050,0x04436192,0x290d8365,0xb4da20c2}},	//   _سبک_, техн, _atea_, ़ती_,
   {{0xa3c954b1,0x290ca229,0x648ec58f,0x7e69d4b2}},	//   _लुक_, _rtda_, _lùir, jdep,
   {{0xfe798026,0x7e69c0f7,0xb5fd85f9,0x6e2454b3}},	//   _dnů_, ddep, _tašn, maib,
   {{0xc3334087,0x6e24503c,0x61fb94b4,0x645af4b5}},	//   _בוש_, laib, _egul, xeti,
   {{0x645bc3d3,0x26cf94b6,0x66d184f0,0x660994b7}},	//   feui, bogo_, råkr, _ffek,
   {{0xafe360ff,0x443fd4b8,0x64902046,0x2ec983af}},	//   _росл, ggu_, _käis, िकृत,
   {{0x442ca0ca,0xdd8f86b0,0x2bbe6026,0x6d49c049}},	//   _tdd_, _پول_, ्थवा, gtea,
   {{0xb34782a4,0x443fd4b9,0xb17b4053,0x7c208944}},	//   _duħħ, agu_, קטיר, _hemr,
   {{0xf8376095,0x7d0094ba,0x628bd4bb,0xdeb5004e}},	//   ונית_, _hums, _fogo, ебны,
   {{0x3949403b,0x7d0094bc,0x6d49d4bd,0x6b836f67}},	//   ytas_, _kums, btea, ängi,
   {{0x645c2ea3,0x6490204e,0x7d09629f,0x2a7a2037}},	//   feri, _näis, _česm, _bnpb_,
   {{0x7d0094be,0x7ce5c005,0x765c277c,0x6298b4bf}},	//   _mums, tórg, gery, nkvo,
   {{0x1bd42702,0x67d42bcd,0x2a79405d,0xdfd8214a}},	//   воря, вору, _pnsb_, дът_,
   {{0x6e2094c0,0x2eca0bde,0xdced229f,0xf1b9816d}},	//   _nemb, रवृत, _irač, _leša_,
   {{0x7e7aa23c,0x394954c1,0x7d0d14c2,0xb5fd8143}},	// [f90] _ontp, utas_, _utas, _sašo,
   {{0x7e68a300,0x644d53f4,0x5a346e48,0x2b4954c3}},	//   _nadp, sfai, кнут, rtac_,
   {{0xb4bd2d88,0x649026eb,0x6e23b4c4,0x38358bd6}},	//   ेकी_, _väit, vanb, енер,
   {{0x765d01cd,0xa3e2a026,0x61e2d4c5,0xe80a94c6}},	//   nesy, नेछ_, _ozol, हुला_,
   {{0x7e68b4c7,0x61ad407c,0x6abd4ba0,0xdd32003c}},	//   _badp, _কুরআ, ्कीर, _məşq,
   {{0x6e20808b,0xb5fd8326,0x320945dd,0x765d01e7}},	//   _eemb, _zašl, lcay_, hesy,
   {{0xc7b8a274,0xff51a566,0x6e23b4c8,0xf1b98012}},	//   _peđa_, اخت_, ranb, _deša_,
   {{0x6e23b4c9,0xfdf82095,0x7c23af87,0x2b15d219}},	//   sanb, וצות_, sanr, ньор,
   {{0xd84ee016,0x645c34ca,0x21294050,0x752994cb}},	//   _vọng_, yeri, nsah_, _uvez,
   {{0x93bca12a,0x0d85e27c,0x316dc0e1,0x68ed54cc}},	//   _adău, елон, rvez_, hmad,
   {{0x628bd2cc,0x7e698493,0x248d8143,0xd49c41e9}},	//   _togo, _kaep, _koem_, _bọ̀_,
   {{0x776405fc,0x753bc167,0x442ef4cd,0xed5a14ce}},	//   _psix, puuz, _edf_, пом_,
   {{0x7d01b308,0x69cee105,0xdb0a2026,0x2d498951}},	//   _huls, über, čníh, núe_,
   {{0xcb36c1a1,0x62860012,0xddc40227,0x2a6900d4}},	//   _נאצי_, sjko, _iniż, _eaab_,
   {{0xdced24ad,0x649cd2d4,0x649a4143,0xd874e25b}},	//   _grač, _méin, птар_, _جانب,
   {{0xdce2e50e,0x649cc13a,0xa01b00e0,0x6441ea13}},	//   _proć, _léin, zköz, lgli,
   {{0x6441f4cf,0x00e665ef,0xee374013,0x6da34aab}},	// [fa0] ogli, ежан, энт_, гита,
   {{0x69d9d4d0,0x7d0094d1,0x60dbc72a,0x7641f23c}},	//   _mywe, _rums, hlum, ngly,
   {{0x7c209104,0x321820c7,0x20074064,0x290120b1}},	//   _pemr, mbry_, śnia_, _guha_,
   {{0x64a654d2,0x2a690022,0xa683454a,0x629d0013}},	//   _чама, _xaab_, _блюд, ūrov,
   {{0x69c76071,0xafdb03d1,0x3ebfd4d3,0x26c054d4}},	//   _exje, lfør, dnut_, mnio_,
   {{0x6e2094d5,0x3ea00017,0x78a294d6,0xb87b0057}},	//   _wemb, _llit_, shov, lmít,
   {{0x2ca0010a,0x442fd4d7,0x3ce6c022,0x672bc0ff}},	//   _olid_, _bdg_, _phov_, _avgj,
   {{0x442254d8,0x26c0465f,0x4425f4d9,0x6441f4da}},	//   _jek_, nnio_, eal_, egli,
   {{0x7af8e022,0x38690171,0x64a388df,0x22b6a0c2}},	//   _pivt, _raar_, _сата, ałka_,
   {{0x649cd447,0x1828a050,0x610c6121,0x6f01a197}},	//   _géin, _آقای_, _eğle, _fulc,
   {{0xd5baeb2d,0xa3d48292,0x2be2cb72,0xb637600b}},	//   яси_, _सुत_, _परवा, ערטס_,
   {{0x4424d4db,0xafdb05f0,0x673d14dc,0x7792c050}},	//   qam_, dfør, tusj, _میبا,
   {{0x38690aaa,0x6aa454dd,0x20094048,0x3cfa2030}},	//   _vaar_, dhif, vcai_, _bipv_,
   {{0x765d14de,0x60c40468,0x7eb6136d,0x69d8e271}},	//   sesy, _ejim, ršpa, _tyve,
   {{0xbcfb4009,0x41d065e8,0x2902431b,0x26d13099}},	//   _esél, _तुलस, _auka_, rozo_,
   {{0x68ed54a1,0x645d000e,0x768fa14f,0x69daa831}},	//   umad, qesi, _løyp, _myte,
   {{0x195847b9,0x29024345,0x634aa03c,0x25b70043}},	// [fb0] наты_, _cuka_, _dəni, _سندھ_,
   {{0x644534df,0x6eba6626,0x7e6994e0,0x60dd06bf}},	//   _uchi, ्वगु, _saep, llsm,
   {{0x442694e1,0x81d821a6,0x68ed40b0,0xb40e8125}},	//   fao_, ়েব_, pmad, _ịpịa_,
   {{0x4c954470,0x442254e2,0x7afaa121,0xa2c24026}},	//   _римс, _gek_, _aitt, रचण्,
   {{0x649cc049,0x4425f4e3,0x442fd4e4,0xb4bf54e5}},	//   _péin, yal_, _rdg_, ेवी_,
   {{0x248954e6,0x6e2727a0,0x212b0105,0x6e21b4e7}},	//   ljam_, najb, isch_, _qelb,
   {{0x9f47604e,0x6e22c105,0x753c8041,0x6fc9c029}},	//   änä_, _beob, _ārze, _हुजू,
   {{0x628f54e8,0x6f0961ce,0x397c20be,0xb17c2087}},	//   _joco, _čech, לטונ, לטור,
   {{0x81d7207c,0x44236d9d,0xa7fb407b,0x0682c0ba}},	//   িধি_, _kej_, _bañi, ргын,
   {{0x26c041e4,0x2ebc055d,0x97a7a406,0x7529d4e9}},	//   znio_, ोक्त, _прел, rsez,
   {{0x6d4d404e,0x6441f132,0x7c2614ea,0x60dbc3ed}},	//   htaa, rgli, takr, plum,
   {{0x6f02c14a,0x66096121,0x7bdb87aa,0xf3ff4067}},	//   _fuoc, _şekl, _kyuu, _ngã_,
   {{0x4427a108,0xb5fb0066,0x291dc125,0x645e73c7}},	//   oan_, zdáv, _uwwa_, yepi,
   {{0x26d2400d,0xed5a34eb,0x68fb8013,0x672d14ec}},	//   woyo_, мог_, _liud, _dvaj,
   {{0x6443b4ed,0x628f48a4,0xe3bf027f,0x7c22c037}},	//   igni, _boco, raña_, _yeor,
   {{0x38ad200a,0x2a6dc1cd,0xf65f0163,0x7e6d4114}},	//   džru_, ndeb_, ceæ_, gdap,
   {{0x6f03f4ee,0x4431600a,0x442374ef,0x386dd4f0}},	// [fc0] _hunc, _bdz_, _bej_, ider_,
   {{0x7e6bc561,0x7c3b60e8,0x7ae98f60,0x442254f1}},	//   _lagp, _ɓurg, _ahet, _wek_,
   {{0x7c23e058,0x26c30e9d,0x386dc17b,0xc7a620ff}},	//   _menr, čkov_, kder_, _ринк,
   {{0x78a1ac31,0x6d4d4054,0x7d0de098,0x6aa1b4f2}},	//   _allv, btaa, _časl, _allf,
   {{0xef17404e,0x7d03f4f3,0x69dab4f4,0xb05b4156}},	//   _имя_, _luns, _syte, _mjäl,
   {{0x61e64c5a,0xdd938013,0x66d88069,0x65938450}},	//   _izkl, рашы, víku, рашу,
   {{0x2d9834f5,0x394054f6,0x3cfde028,0x3f8080ba}},	//   nyre_, luis_, _रंगे_, ţiu_,
   {{0x3eb823f6,0x628f45df,0xdce2a199,0x83fca29c}},	//   hirt_, _xoco, kvoć, _mađi,
   {{0xa5bb4005,0x7e6bd4f7,0xe9d787f7,0x44236022}},	//   _león, _dagp, _акт_, _yej_,
   {{0xc7b8e29f,0x7ce029ac,0x2ee90058,0xd9e66021}},	//   lađi_, förm, _shaf_, _करात_,
   {{0x290494f8,0x83fce4bb,0x394054f9,0x291214fa}},	//   _huma_, jeđe, huis_, _atya_,
   {{0x394dd4fb,0xb5fd8055,0x7d0414fc,0x83fca2e2}},	//   btes_, _rašk, _buis, _nađi,
   {{0x0eb6a026,0xaca474fd,0x6d4e2b83,0x212b00cb}},	//   _अगाड, _apọs, etba, usch_,
   {{0x6abd43af,0x2abac018,0xf2c42052,0x645600b1}},	//   ्क्र, rību_, ассн, _ebyi,
   {{0xff042491,0x6448a098,0xb6074104,0x28f824a7}},	//   иятн, _mcdi, вязк, терь_,
   {{0x6e23ee3b,0xa3caa10a,0x442374fe,0x7f4d54ff}},	//   _zenb, _लखन_, _sej_, ttaq,
   {{0x2904801b,0x7afb9500,0x6443a78c,0x68e981cd}},	// [fd0] _numa_, _riut, ygni, _rhed,
   {{0x64bc803b,0xceb8e064,0x7afb9501,0x7e6d02df}},	//   ičiu, nię_, _siut, _haap,
   {{0x7e60d502,0x7afb9503,0x5f9526bb,0x4395241b}},	//   kemp, _piut, _синт, _санс,
   {{0x1de2c27d,0x7c28f504,0xc953e00b,0x83fce143}},	//   _परंत, hadr, ימע_, ceđe,
   {{0x394dc162,0x44446143,0xab8454aa,0x29845505}},	//   xtes_, bg_, _курк, _кырг,
   {{0x69dc6042,0x38a21506,0xb5fb00e0,0xc1056678}},	//   _fyre, _móra_, ldás, _موسي,
   {{0x3a248057,0x6443b507,0xddc1a04d,0xddc8a143}},	//   _femp_, rgni, _balš, _endž,
   {{0x69dd5508,0x6f03f509,0x7afd550a,0x7c252669}},	//   _kyse, _runc, _jist, _lehr,
   {{0x6e24150b,0x7c23e0fd,0x673ae54c,0xf1b79450}},	//   _reib, _penr, ertj, _अधिन,
   {{0x20012016,0x7c2520bd,0x6e24150c,0x27e6c143}},	//   _nghi_, _nehr, _seib, _dzon_,
   {{0x7d04150d,0x7ce02277,0x2913205f,0x2d82c156}},	//   _suis, börj, _ntxa_, äker_,
   {{0x6d4f150e,0x2375c711,0x634aa03c,0x4433350f}},	//   ftca, _ماتح, _cənu, _adx_,
   {{0x673ae3c5,0x6e28f510,0x7ce5c057,0x386d811e}},	//   artj, badb, córa, _maer_,
   {{0x55bac095,0x6576031d,0x661bc0a0,0xa5bb403e}},	//   _אמנו, _vryh, lbuk, _peón,
   {{0x64a640db,0x2d9e3511,0xed572e14,0x610c6602}},	//   гава, áte_, лор_, _oğla,
   {{0x661b64a3,0x18675512,0xc61e007c,0x7c29d513}},	//   _đuka, ласи_, _থাকা_, naer,
   {{0x78a40296,0xb87b0026,0x764440a0,0xee37020e}},	// [fe0] _iliv, blíb, rgiy, _сны_,
   {{0x5a662818,0xb4662792,0x68fd5514,0x610c620f}},	//   _скоб, _скол, _eisd, _ağla,
   {{0x672340e4,0xef1a61e1,0x7afc7515,0x26da2088}},	//   ćnja, хме_, _virt, _ikpo_,
   {{0xb4db2017,0x673b006e,0xfbd32095,0x20d90049}},	//   gràf, šuje, _לתת_, léir_,
   {{0x61e64018,0x3ce0414f,0x82d70053,0x26138028}},	//   _uzkl, mliv_, נונג_, दड़ी_,
   {{0x6ffbc2b8,0x60c45516,0xf96aa07a,0x6acccf30}},	//   _mācī, lnim, ерий_, ाव्र,
   {{0x249d8022,0x6d41ea43,0x6494b03c,0x6e28f517}},	//   bkwm_, jula, _bàir, vadb,
   {{0xa4f8801c,0x2905b518,0x69de217b,0x290480a5}},	//   _شکار_, _dula_, _mype, _tuma_,
   {{0x5e93813a,0x8626e1eb,0x6e26404d,0x38bac0f9}},	//   _القط, льне, _mekb, _aàrè_,
   {{0x44295519,0xfc46e04a,0x7e62810d,0x3b54e1d3}},	//   zaa_, _číst_, leop, акор,
   {{0xceb8e064,0x443321e2,0xda6fd51a,0xe3bf01af}},	//   rię_, _rdx_, _ля_, taño_,
   {{0x629de00e,0x7c29d51b,0xb5fd8552,0x60c4551c}},	//   ësor, caer, _saši, jnim,
   {{0x3eb9151d,0xa2d3c0eb,0x6602d51e,0xceb8e0c2}},	//   rist_, _اينت, _igok, pię_,
   {{0x3eba600e,0x4ea7239e,0x78a401fb,0x6d41f51f}},	//   jipt_, урма, _eliv, bula,
   {{0x81dd207c,0x69de239b,0xe78422d7,0x81b881a6}},	//   তেন_, _cype, буто, _ঘুম_,
   {{0x26c33520,0x7c2520cb,0xc9875521,0x2906c0ce}},	//   snjo_, _wehr, лузи, _kuoa_,
   {{0x7c253522,0xbbe1a026,0x2d8c2065,0x26c3207f}},	// [ff0] _tehr, _फर्क, øder_, pnjo_,
   {{0x20d913d8,0xb6032026,0x7afd5523,0x26155450}},	//   péis_, část, _wist, _फ्री_,
   {{0xdce46361,0x04c86049,0x78a40052,0x7ceda62f}},	//   zvić, دولي_, _yliv, lúrg,
   {{0xddde2026,0x6d5b805d,0xb4bed303,0xb4db2017}},	//   _např, _ppua, ँचो_, ctàr,
   {{0x68ff05fc,0x070be08d,0x7658e1ce,0x7aff000e}},	//   _miqd, _संभव_, _obvy, _miqt,
   {{0x6602c1b6,0xd126e243,0xd491a119,0x6495c3f6}},	//   _agok, _وم_, _tìm_, _náir,
   {{0xa2d63524,0xddc40013,0x6722c1e9,0x7e61e62c}},	//   णवत्, _maiš, _awoj, velp,
   {{0x64498057,0x673bd525,0x2905b526,0x6e356320}},	//   _ucei, truj, _vula_, _hdzb,
   {{0x2d98e042,0xd05d003c,0x77672048,0x200dd527}},	//   øren_, _üzər, hwjx, rcei_,
   {{0xddc4006a,0x4095e052,0x6495d447,0x26c901e9}},	//   _naiš, ррит, _páis, _ajao_,
   {{0x68ed1528,0x6a86034d,0x60c980ff,0x332dd529}},	//   _bhad, ална, _kjem, ssex_,
   {{0x3ced805d,0x7d0ea066,0x6495c057,0xe45f4156}},	//   _jhev_, žisé, _váis, _sjön_,
   {{0x6fdb2021,0x3ea9552a,0xa7fb0005,0x68ed152b}},	//   _मुबं, dhat_, teña, _dhad,
   {{0x6495c049,0x249fd52c,0x5c07ea00,0x7e63b52d}},	//   _gáir, lkum_, _сяда, nenp,
   {{0xb825007c,0x4cbae095,0xbcfb6066,0x7aed0569}},	//   _ভারত_, _במסג, _fréz, _fhat,
   {{0x6d5d46a6,0x64bac1d7,0x7c35605d,0x2ca9552e}},	//   _bpsa, nċip, _adzr, ghad_,

   {{0xb22673fc,0x7afe352f,0xb4c41530,0x3b8647ab}},	// [1000] имал, _tipt, ्वी_, шлаг,
   {{0x26da2125,0x249fc6fa,0xbcfb6030,0x221660fb}},	//   _ukpo_, hkum_, _kréy, рфар,
   {{0x7c264121,0x5be2d244,0x14c84050,0x26d83531}},	//   _tekr, _पर्व, _مهدی_, moro_,
   {{0x6d43b532,0x6d5e217a,0x67241533,0x2ca94569}},	//   duna, _ippa, _kwij, chad_,
   {{0x91fce041,0x7e63a5dc,0xe45f5137,0x3d1c20f9}},	//   ndār, fenp, _mjöl_, _fàwò_,
   {{0x35db212f,0x60db9534,0x7e63a0f0,0xfaa66501}},	//   _मुड़, _ekum, genp, _таго,
   {{0xfaa6c8df,0xe297a5da,0x5066c099,0x442b0bfb}},	//   ишин, рај_, атпа, yac_,
   {{0x2d686106,0x78a9c024,0xea002067,0x6281b535}},	//   _işe_, ghev, _giấu_, _enlo,
   {{0x6b9bd536,0x2ca041e7,0xa686b537,0x7ac6f538}},	//   gyug, ikid_, _клад, исое,
   {{0x68e29539,0x26d8353a,0x660402e0,0x722461a6}},	//   llod, joro_, _agik, _পাঁচ_,
   {{0x64a6d53b,0x2be2c021,0x672401e9,0x5886c20e}},	//   _кажа, _परका, _awij, _выла,
   {{0x08fac50f,0x7524000f,0x27e00030,0x2299a0f9}},	//   _شراب_, _bwiz, _byin_, _dèku_,
   {{0x26d82618,0x6f08a6bf,0x91e3c8ab,0x65764089}},	//   foro_, _hudc, _доце, jvyh,
   {{0x3944c041,0x7cedb53c,0xfa23407c,0x2907eee2}},	//   mums_, rúrg, _ফাইল_, _funa_,
   {{0xd6db4d9a,0x787c2277,0x6282c54c,0xfc3f4071}},	//   вта_, _såvä, _knoo, _alía_,
   {{0x38a46156,0x26c90167,0x6e3600c2,0x27e3a065}},	//   _röra_, _ujao_, _gdyb, _øjne_,
   {{0x5a35614a,0x90a700e0,0xb603a066,0xb4db2017}},	// [1010] йнат, _محکم, áško, tràd,
   {{0x63ad553d,0x6e28a78c,0x7d08a23c,0xda78604e}},	//   rzan, _nedb, _ouds, иях_,
   {{0x63ad553e,0x29090037,0x6724153f,0xfc3f4071}},	//   szan, _huaa_, _zwij, _elía_,
   {{0xdb03a066,0x7ea600c4,0x7ae29540,0x7f43a197}},	//   jzná, _kópa, glot, vunq,
   {{0x6e2b8bb8,0xee38884f,0x2bdb2064,0x66c80121}},	//   ragb, рні_, _मुता, dıkl,
   {{0x2bcfe66f,0x81e9007c,0xb4d0e026,0xd83ba099}},	//   _सुझा, _বলা_, वको_, тэд_,
   {{0x6aa9d541,0x3d0cc033,0x6e28a0e8,0xdf7380f9}},	//   thef, _डूबे_, _dedb, _bẹ̀é,
   {{0x644d0286,0x60c99542,0x1e85c39d,0xa3e8010a}},	//   _ncai, _ujem, слим, _भरल_,
   {{0xdd91a043,0x62957543,0x657aa0e2,0x249fc0c4}},	//   توں_, _kozo, _erth, rkum_,
   {{0xb7bdc12a,0xe3bf4019,0x6b9d01cd,0x3ea04534}},	//   naţi, _leño_, dysg, zkit_,
   {{0x62957544,0x6e2d5545,0x7ceda0e6,0x7d08a584}},	//   _mozo, kaab, gúre, _guds,
   {{0x6b9d01cd,0x26d91546,0x644d0090,0x39524052}},	//   fysg, goso_, _ccai, ytys_,
   {{0x6e298b83,0xf1bf4049,0x6abc20c4,0x7d01b547}},	//   _meeb, _seán_, tirf, _kils,
   {{0x7e656037,0x62957548,0x6f1bd549,0xd8398030}},	//   jehp, _nozo, mpuc, _blōk_,
   {{0x6f01a985,0x09e623ca,0xe5a33045,0xada32407}},	//   _milc, совн, пири, парл,
   {{0x442dc0ce,0x644d013a,0x67240200,0xe3bf4071}},	//   nae_, _gcai, _twij, _ceño_,
   {{0x7e9a250f,0x26d8354a,0x6f0980b6,0xf1b9c098}},	// [1020] _منظر_, poro_, _nuec, pašu_,
   {{0x6d44506d,0x29012f3d,0x673e67a0,0x3872446b}},	//   ruia, _giha_, trpj, sdyr_,
   {{0xe61a8aa4,0x7ce02156,0x3a29005d,0xc81560ff}},	//   где_, förv, _yeap_, юєть,
   {{0x7ce5c1af,0x6b836156,0xcf256049,0x7d01b54b}},	//   fórm, ånga, تركي, _ails,
   {{0x6283e110,0xdee6a423,0x2f568101,0x7c2d8765}},	//   _onno, боди, стес, ðara,
   {{0x224d848d,0xa01b0156,0x307a200b,0x442ce025}},	//   _ecek_, njör, ראַנ, xad_,
   {{0x7d01b54c,0xb9966049,0x4420554d,0x7c29954e}},	//   _dils, _الزب, obi_, _feer,
   {{0x7d098333,0x5066c297,0x7ae4554f,0x5fc80026}},	//   _fues, стка, nlit, रपाल,
   {{0x7c2e3550,0x95ca84c0,0x7d099551,0x657b85f9}},	//   kabr, _слаб_, _gues, _gruh,
   {{0x3944d552,0x4734e11f,0x44205553,0xa2c08046}},	//   rums_, онос, hbi_, लचक्,
   {{0x867ba095,0x62960258,0x6e2e20f7,0xdbe66026}},	//   _תרבו, _boyo, dabb, _करोड_,
   {{0xb5fdc35d,0x39405554,0x7cf064cf,0xb5fb0581}},	//   mešn, kris_, lärd, beál,
   {{0x44386320,0x6abd1555,0x4394cae2,0x6e2e2ab8}},	//   _odr_, risf, _фалс, fabb,
   {{0xa7fb0359,0x6e2e3241,0x60c4a13a,0x46f6e052}},	//   seño, gabb, éimh, _учет,
   {{0xb05b004e,0x6295606f,0x7ae45556,0x27e241e7}},	//   nnäk, _rozo, flit, _aykn_,
   {{0x29024068,0x5ba71156,0x3da70844,0x7ae45557}},	//   _cika_, _гроз, _гроб, glit,
   {{0x6d460efb,0x26c78004,0x60cd0132,0x6e2d4ad5}},	// [1030] cuka, énom_, _ijam, raab,
   {{0x2fc74016,0xaca38016,0xf99f00d1,0x3ebef558}},	//   ăng_, _khủn, myè_, nitt_,
   {{0x7d1bd43a,0xde198db3,0xce9541e1,0x78a29559}},	//   zpus, لقات_, _данъ, fkov,
   {{0x51874905,0x2006c119,0x7cefe46b,0xdb086009}},	//   _луга, _ngoi_, pørg, álás,
   {{0x6f098bda,0x7d0d46a1,0xb4db25df,0x7cf06156}},	//   _quec, qqas, cràc, färd,
   {{0x3206c0ae,0x657d555a,0x26da711a,0x8339a052}},	//   _agoy_, _irsh, copo_, ачит_,
   {{0x78a28066,0x6f01a018,0x3135755b,0x59a4a0c2}},	//   bkov, _vilc, _фебр, गैलर,
   {{0xf99f05df,0xdce9a480,0x3f77e12a,0xe299ccdd}},	//   ncès_, _iseč, _rău_, раи_,
   {{0x7c2af55c,0x3f77e12a,0x5fdb2d0b,0xf993813a}},	//   _befr, _său_, _मुसल, _عبر_,
   {{0x442ea0fd,0xa3e92010,0x6449d55d,0x4420555e}},	//   caf_, _बरं_, sgei, zbi_,
   {{0xf86604b0,0xe9a8c896,0x61ebc064,0x6e2e355f}},	//   овно, لدین_, _wzgl, vabb,
   {{0x3947b560,0x62852065,0x6b84c098,0x7d02d561}},	//   muns_, _anho, _šige, _gios,
   {{0x7c2e3562,0x7ae4400a,0x26190028,0x3ebfd563}},	//   tabr, vlit, पड़ी_, miut_,
   {{0xe8e04016,0x5fdb212f,0xdce423ee,0x61ed0037}},	//   _đốc_, _मुहल, _priđ, _dzal,
   {{0x7cefea2f,0x657d5564,0x6603230e,0x442b5565}},	//   gøre, _arsh, дпра, _bec_,
   {{0x4438613b,0x442f9566,0x6ab6a1b0,0x62853567}},	//   _sdr_, jag_, _अग्र, _enho,
   {{0x7eab2121,0x6d552265,0x7d04c13a,0x290b5568}},	// [1040] _süpe, atza, _éist, _cuca_,
   {{0x25de4010,0x78a99569,0x60c9c126,0x290b42dd}},	//   _कुणी_, _alev, hnem, _duca_,
   {{0x6561a048,0x442a756a,0xe96a6486,0xa3e646e1}},	//   _nplh, _veb_, раел_, _फरक_,
   {{0x7d7700d0,0xb5fdc06e,0x4b4ce00b,0x443a23ba}},	//   _امیر_, ješo, רגאַ, _hdp_,
   {{0xe8faa331,0x6f02c00c,0x290b40b1,0xbe8aada4}},	//   алд_, _rioc, _guca_, иске_,
   {{0x649cc13a,0x25f18028,0xccb7a0ff,0x6f04154e}},	//   _léit, ेशजी_, огії_, _liic,
   {{0x6e2af56b,0xf99f05cd,0x7d02c064,0xda65a13a}},	//   _refb, zyè_, _pios, ثاني,
   {{0x442f8054,0x9634cd73,0x2240a20f,0x6d41e786}},	//   cag_, чниц, şik_, drla,
   {{0x7c2bc91f,0xdddd00c2,0xa3d6a026,0x6130a1e9}},	//   _degr, zesł, _सडक_, _bólá,
   {{0x7d0bc054,0x6d40c851,0x3a2f0098,0x442ea0f7}},	//   _dugs, rrma, _žgp_, qaf_,
   {{0xf8bf0004,0x3947aa12,0x60dc356c,0x7d040052}},	//   tié_, cuns_, dorm, _biis,
   {{0x7d040054,0x442cb4b2,0x60dbc057,0x3206c08b}},	//   _ciis, _hed_, coum, _ugoy_,
   {{0xf8bf05a6,0x9c134088,0x44394b67,0x78fb81a1}},	//   rié_, _kọva, _rds_, יפטו,
   {{0x60dc20e8,0xf99f00d1,0x6ab78984,0x442f956d}},	//   gorm, ryè_, _आग्र, zag_,
   {{0x3ce68e9d,0x78ad556e,0x290b556f,0x7c229570}},	//   klov_, thav, _suca_, kbor,
   {{0x291ef571,0x7d040006,0x6f03f572,0x60cd0df7}},	//   mpta_, _giis, _zinc, _ujam,
   {{0x290ca0a9,0x29037573,0x255e8041,0x78ad414e}},	// [1050] _luda_, _pija_, nālā_, rhav,
   {{0x51873574,0xc9872769,0x7c2d1575,0xab8723b7}},	//   _дума, _думи, _hear, _думк,
   {{0x8027428b,0x290cb576,0xbc19812e,0x78ad40ff}},	//   _ورحم, _nuda_, білі_, phav,
   {{0x6f0d0296,0xf993e0be,0x26c4206f,0x6298f0cf}},	//   _kuac, ורע_, émov_, _lovo,
   {{0x7c2d1577,0x443a217b,0x0dc8401b,0x4421605d}},	//   _mear, _ydp_, _дури_, pbh_,
   {{0x7c2d1578,0xccf8e026,0x644d5579,0x25f0427d}},	//   _lear, jmě_, lgai, _आरती_,
   {{0x3d06e4ef,0x7762c005,0x60c9d57a,0x290480e8}},	//   _संगे_, _apox, tnem, _fima_,
   {{0x6d576022,0x26c16931,0x7c2d1575,0x78a98c1d}},	//   mtxa, liho_, _near, _ulev,
   {{0x3949407b,0xf77081b3,0x5f778050,0x7cf22271}},	//   nuas_, _لال_, _بازر, lære,
   {{0x7fd5e013,0xa3b6abde,0x2903eb2f,0xdddb816d}},	//   зімі, _चेक_, öja_, _gnuš,
   {{0xbb48a13a,0x6562c3ee,0x66e60d3e,0x4431357b}},	//   _ولكن_, _epoh, зона, daz_,
   {{0x9980c06f,0x216a014a,0x2905b57c,0x644120c4}},	//   _žiť_, бими_, _hila_, ólin,
   {{0x6f03e189,0x7c3b8098,0x38694cfc,0x09b87073}},	//   _tinc, _mdur, dear_, _आध्य,
   {{0x7ce4a355,0x5239e00b,0x442c28cc,0x3ae1d57d}},	//   tòri, _הײַנ, úd_, rópu_,
   {{0xea002081,0x7c3b957e,0x3869413a,0xdca600bc}},	//   _khẩu_, _odur, fear_, _наки,
   {{0x7c3b957f,0x7c2d80c4,0xb4c78026,0x6d3ae076}},	//   _ndur, ðarl, ैको_, _התקנ,
   {{0x443a207d,0x4431323e,0x7d0d1580,0xf709e067}},	// [1060] _tdp_, baz_, _guas, _mầm_,
   {{0x4d7b000b,0x66098af8,0xf709e067,0x7e69c54c}},	//   _פריע, _agek, _lầm_, heep,
   {{0x442ca095,0x7c2294a8,0x7529844b,0x35fa4050}},	//   _red_, tbor, _awez, _گردد_,
   {{0x26dd9581,0x6909400a,0x69c4c03b,0x645c29ee}},	//   gowo_, _džeb, _žiem, lfri,
   {{0x60c1f582,0x442cb583,0x2ee69584,0x9a12c125}},	//   kilm, _ped_, rlof_, _mọtụ,
   {{0x7c2441e2,0x7cf22271,0x7e757585,0x291ee300}},	//   lbir, bære, _gazp, ypta_,
   {{0x60c1e6df,0x75298088,0x5694c2a3,0x7e68e271}},	//   dilm, _ewez, дайт, vedp,
   {{0x44313586,0x661b6480,0x60de7587,0x7e756265}},	//   zaz_, _đuki, lopm, _zazp,
   {{0x443123ed,0x6e2d1588,0x6299c064,0xe646ad94}},	//   yaz_, _reab, _dowo, _неап,
   {{0x7cf18042,0x7b0b0041,0x9c134125,0x1c020077}},	//   råre, _kļuv, _họta, ोशनल_,
   {{0x38695589,0x9c134125,0xf98fc0d0,0x765c20fd}},	//   year_, _kọta, نبی_, dfry,
   {{0x629ab58a,0xb5fb013a,0x26c20265,0x7e68e4d8}},	//   _hoto, leái, giko_, sedp,
   {{0x4431358b,0x201860d1,0x3ea6958c,0x68e2d408}},	//   taz_, _ofri_, ikot_, _ikod,
   {{0xde8fc016,0xbcfb607b,0x7ceb6106,0xb9250125}},	//   _tịch_, _apén, gürl, _zipụ_,
   {{0x63a2955a,0x997e20ba,0x24c461a6,0x7d06494f}},	//   hyon, văţa_, ্তাহ, _biks,
   {{0xe8d92016,0x2d800042,0x4431358d,0x4de6610a}},	//   _trữ_, _frie_, saz_, _करजई_,
   {{0x3869558e,0xe719413a,0x6e2e758f,0x78ad1590}},	// [1070] rear_, زيات_, _bebb, _ilav,
   {{0x9bf4020e,0x4432436d,0x7c244035,0x7cd209cf}},	//   _языч, aay_, abir, māra,
   {{0x26cce01f,0x26c16610,0x6e244035,0x98bf012a}},	//   indo_, riho_, bbib, cută_,
   {{0x644f01fb,0x6d576265,0x6e2e6025,0xddd4c0a3}},	//   ngci, rtxa, _eebb, žařs,
   {{0x442d9591,0x69d823d1,0x78ad004d,0x60cd5592}},	//   _vee_, _øver, _mlav, mnam,
   {{0x6447c03b,0x68e941d7,0x6299c105,0x60cd5593}},	//   ėjim, ċedu, _sowo, lnam,
   {{0x24890030,0x7d0e6037,0x63a2948a,0x78ad0a0c}},	//   _onam_, _gubs, ayon, _olav,
   {{0xb4ac0026,0x7c256049,0xef19c496,0x92cda07c}},	//   _गते_, lbhr, оми_, রতে_,
   {{0x60c1f594,0x7e69cb83,0xdb08e066,0x6738e1f6}},	//   tilm, reep, vzdá, _avvj,
   {{0x7ae2d595,0x26def596,0x7e7601e7,0x7c222143}},	//   _ekot, goto_, _sayp, _đoro,
   {{0xa3e447af,0xeb99e677,0x3ce94163,0x765bc00f}},	//   _पुन_, цин_, klav_, pfuy,
   {{0x7ceb6315,0x6d445597,0x442ee363,0xddcd404d}},	//   dürm, yria, _eef_, zdaš,
   {{0x6f0640a2,0xb4db25df,0x290ee0a2,0xe72ed138}},	//   _rikc, rràn, _eufa_, _ше_,
   {{0xda0daaa1,0x26c32edc,0xcc12c125,0x44337598}},	//   िखित_, gijo_, _fọsị, jax_,
   {{0x78ad1599,0x2cad810a,0x6e2e60f7,0x61e640ff}},	//   _flav, _oled_, _rebb, _sykl,
   {{0x6e2e759a,0xf212c125,0x2d8002d9,0x7f44559b}},	//   _sebb, _họrọ, _trie_, triq,
   {{0x26c3359c,0x6616559d,0x7ae4159e,0x7d076200}},	// [1080] bijo_, rcyk, _ikit, _bijs,
   {{0x60cd46f1,0x81dd207c,0xbddb05df,0x7e60807d}},	//   anam, তেই_, rgèt, _sbmp,
   {{0x68e9d59f,0x2cad8a14,0x9a12c125,0x21204636}},	//   kled, _bled_, _mọrụ, spih_,
   {{0x63a28157,0xddcd15a0,0x6aaaf3aa,0x3ce955a1}},	//   tyon, _haaš, _छत्र, clav_,
   {{0x4ad22ff1,0x38aac58f,0x7c2e6a88,0x2d8f4262}},	//   _सदाव, _bùrn_, _tebr, äget_,
   {{0x6d4ab5a2,0x2be1c028,0xcc12c079,0xf212c079}},	//   tufa, _पड़ा, _nọrị, _nọrọ,
   {{0x6d4560e2,0x63a3a0ff,0x6f1c6579,0x387864b9}},	//   crha, gynn, _utrc, _iarr_,
   {{0x6d4b95a3,0x3f8241d8,0x387875a4,0x6d58b5a5}},	//   buga, _krku_, _harr_, rtva,
   {{0x81e0407c,0x2002c052,0xb4da8a53,0x290ef5a6}},	//   ধের_, äki_, ठकी_, _sufa_,
   {{0x26ccf5a7,0x38a9e0f9,0x24890425,0x6d46035d}},	//   undo_, _dúro_, _snam_, drka,
   {{0x387864b5,0xa7fce106,0x4424d5a8,0x6d4615a9}},	//   _marr_, ldız, pbm_, erka,
   {{0x4fc6c974,0x7ea06156,0xf8bf20fa,0x9c7cf5aa}},	//   _осла, _köps, ipée_, doče,
   {{0x27e6d5ab,0x26cea024,0x60c449c5,0x6aa340ba}},	//   _uyon_, onfo_, diim, _înfi,
   {{0x7c2f55ac,0x7ceb6315,0x68e415ad,0xdfd4e1ba}},	//   _secr, türm, _ekid, _полы,
   {{0xafdb0065,0x9d182762,0x7c2d80c4,0x290fc020}},	//   ggør, дост_, ðark, _zuga_,
   {{0x3f5735ae,0x394695af,0x816b062a,0xbebcc018}},	//   rçu_, kros_, _дроб_, _avīz,
   {{0xb5fdc06e,0x6d5af5b0,0x2bde949f,0x7afd15b1}},	// [1090] vešk, ltta, _फुला, mmst,
   {{0xa7752878,0x26cdd5b2,0x9c7cf5b3,0x6d4b8610}},	//   _злоч, zneo_, ločb, vuga,
   {{0x60cd41cf,0x92c3007c,0x6566405d,0x7ea4e017}},	//   pnam, ্তী_, _epkh, _còpi,
   {{0x7d076171,0x19954866,0x628ae0ae,0x7d08b5b4}},	//   _wijs, _замя, _lnfo, _aids,
   {{0x2366c05f,0x6b82c022,0xe76b825b,0x628af5b5}},	//   _npoj_, _nrog, تحان_, _onfo,
   {{0xa3c0e8a2,0xfaa7a09e,0x68e9d5b6,0x66c80106}},	//   ूपा_, ьшен, wled, lıkt,
   {{0x290fd5b7,0x7982d5b8,0x25a9806e,0x7d08a2d9}},	//   _suga_, _arow, šal_, _dids,
   {{0x63b160e4,0xb5fdc7a0,0x62899273,0x26c4c013}},	//   đenč, leši, _uneo, gimo_,
   {{0xc05ba84f,0xf1dfa10a,0x2f15294b,0x291ea582}},	//   _між_, _पुरन, _låg_, _etta_,
   {{0x26cdc504,0x0325e51b,0x3a3f8058,0xd838a2e2}},	//   sneo_, ндон, _hdup_, _poče_,
   {{0x61e98037,0x2f140156,0x7ea075b9,0x7cf06156}},	//   _hyel, _säg_, _köpr, kärn,
   {{0x6e3e2098,0x443175ba,0xe7e32033,0xfb24e050}},	//   _sdpb, _lez_, _गड़ा_, کریپ,
   {{0xf1c3a029,0x850be7b3,0x661b8167,0xe3aec04f}},	//   _वेतन, _संकट_, _mfuk, _сб_,
   {{0x7afd1308,0x7af60153,0x6d5bd331,0x6ef6003e}},	//   amst, _whyt, mtua, dábe,
   {{0xb4cbe010,0x2d98e271,0x44268025,0x6d5bc13c}},	//   रची_, øret_, ybo_, ltua,
   {{0x9c7cf5bb,0x81da807c,0x291e2041,0x7ae415bc}},	//   roče, ডেট_, īta_, _ukit,
   {{0xff244043,0x60c615bd,0x6ef60005,0x216755be}},	// [10a0] ئبری, mikm, gábe, нити_,
   {{0x394685da,0xb9db0095,0x6d5bd5bf,0xfc3f0049}},	//   vros_, _מחפש, itua, bhís_,
   {{0x63b64064,0x2367e05d,0x2d8f53a2,0x03a36517}},	//   szyn, _jpnj_, äger_, лифо,
   {{0x26c4d18c,0x3ea955c0,0xc878a6df,0x2d8244a3}},	//   ximo_, ckat_, _sağ_, _trke_,
   {{0x6d5bc0dd,0x7ea6001f,0xada34099,0x29120068}},	//   jtua, _cópi, _баял, _juya_,
   {{0x2b468017,0x2d58e0fa,0xd00fa243,0x80bca077}},	//   rroc_, yée_, مله_, ्चें,
   {{0x6205c03c,0x290a6561,0x629e2052,0x232a6af5}},	//   ərlə, _iiba_, _mopo, _хоби_,
   {{0xea002119,0xe60a80eb,0x6ee38046,0x2b468b67}},	//   _nhậu_, _رزرو_, sõbr, proc_,
   {{0x443ea683,0x60c60037,0x291175c1,0x6b8415c2}},	//   _tdt_, dikm, _zuza_, _nrig,
   {{0x6b83e037,0xb87b40f9,0x26c5f242,0x44321209}},	//   _brng, _akíl, gilo_, _aey_,
   {{0xddc3a12a,0x443215c3,0x6d5ae052,0xd2b76095}},	//   renţ, _bey_, utta, גלית_,
   {{0x6d5c35c4,0x7cd3c0ba,0x7982d5c5,0xea002119}},	//   dtra, păra, _trow, _chậu_,
   {{0x2f15294b,0x7eaa4066,0xb5fb4031,0x2a64805d}},	//   _såg_, _výpl, _abán, _mbmb_,
   {{0x2bd97303,0x44320025,0x92c3007c,0x6b840784}},	//   _बुझा, _eey_, ্তে_, _drig,
   {{0xd5afed94,0x443215c6,0x65696098,0x386053eb}},	//   _сс_, _fey_, _ćeho, ffir_,
   {{0x27e90561,0x67208320,0x6ef6003e,0x68e295c7}},	//   _tyan_, _otmj, tábe, jood,
   {{0x5455667b,0xa923a03b,0x9984013a,0x3d1127c8}},	// [10b0] кват, ąžin, _مليو, _दूरे_,
   {{0x59b0a292,0x6d4f15c8,0x6f0721e9,0x386dd5c9}},	//   जनार, muca, _débì, zeer_,
   {{0x6d5bc265,0x6d5d07ce,0x629d55ca,0x4427a6a6}},	//   ztua, ltsa, _toso, vbn_,
   {{0x7ec7c187,0x60c72363,0x2ea9abed,0x629f013e}},	//   _mèpè, lijm, कस्त, _joqo,
   {{0xa0364076,0xc88640cb,0x7f4d4926,0x09c9b1c9}},	//   _בארה_, ößen_, quaq, िप्य,
   {{0xe5a295cb,0x2a7ca098,0xf09f4067,0x628bc0ae}},	//   риши, gdvb_, _hoà_, _sngo,
   {{0x673ae200,0x68e1f5cc,0x7aed55cd,0x08d5c9fd}},	//   jstj, vold, olat, кция,
   {{0x6d4f15ce,0x394dd5cf,0x673ae584,0x290a62a9}},	//   kuca, tues_, dstj, _ziba_,
   {{0x6d48eac8,0x23690223,0x78a9d5d0,0x248d8019}},	//   erda, _npaj_, rkev, _inem_,
   {{0x394dd5d1,0x25e66029,0x78a9d5d2,0x6c74a33d}},	//   rues_, _जुडी_, skev, _مطمئ,
   {{0x68e1f5d3,0x79840b39,0x6d48e098,0x394dd5d4}},	//   rold, _sriw, grda, sues_,
   {{0x7cf6a0ba,0x443322be,0x6d5d15d5,0x2b4954c3}},	//   râre, _aex_, ftsa, krac_,
   {{0x26c5f5d6,0x68e1f5d7,0x68ed55d8,0x6d4f016d}},	//   pilo_, pold, dlad, guca,
   {{0x2b4955d9,0x6d4e35da,0x6d49d5db,0x68e3adf7}},	//   drac_, tuba, mrea, nond,
   {{0x42564b7a,0x09e62fb9,0xceb2e0be,0xc7b9c0e0}},	//   ктат, товн, _דיג_, lző_,
   {{0x79840403,0xf74a013a,0xe7e56033,0x6d5c35dc}},	//   _triw, _قلبي_, _कड़ा_, rtra,
   {{0x2120005d,0x6d4375dd,0xada34099,0x6b8415de}},	// [10c0] _utih_, ánan, аатл, _urig,
   {{0x96fa213a,0x26c7b5df,0xd0f44010,0xe610603c}},	//   _تعبر_, jino_, _आठवण_, _düşə,
   {{0x98c6020b,0xe0d560ff,0x68e295e0,0xe45a82f0}},	//   _लगाए, ують, tood, дже_,
   {{0x7e7b8071,0xa2c144e5,0x6441b5e1,0xd308e119}},	//   _caup, रोद्, _adli, _hệt_,
   {{0xdce2e431,0xd3484050,0xaa7b0431,0x7e7aa561}},	//   _spoč, _سیاه_, plýv, _patp,
   {{0x290b55e2,0x2d85a012,0x2ab0a1e9,0x7524c106}},	//   _zica_, _brle_, _bàba_, _çizi,
   {{0xd308e067,0x7c29ccf9,0x7ae295e3,0x443835e4}},	//   _mệt_, fber, poot, iar_,
   {{0x6e29c4ec,0x2918e41a,0x7d1b403e,0xb6a39537}},	//   gbeb, íram_, _éusc, _кисл,
   {{0xdc54a63b,0x2d8480ba,0x6d40004d,0xa067c60f}},	//   _مراک, _urme_, šmaj, тања_,
   {{0x673ae069,0x7cf06156,0xf70a0119,0x6d5d0022}},	//   tstj, kärm, _mầu_, vtsa,
   {{0x623500d7,0xee3f0066,0x26d24037,0x9e3515e5}},	//   лену, ským_, knyo_, ленч,
   {{0x6d5d15e6,0x443820fd,0x60c4000e,0xf8d2b1c9}},	//   ttsa, ear_, _cmim, _तदुप,
   {{0x7e7d009a,0xc649c049,0x6d5d15e7,0x6ef8807b}},	//   rdsp, _أجمل_, utsa, cíbe,
   {{0x6d5d0831,0x7d1d85df,0x7ac72bbb,0x3866c133}},	//   rtsa, _ésse, тсме, _hbor_,
   {{0x6d5d0ffe,0x26c48037,0x57a435e8,0x68ed55e9}},	//   stsa, _ommo_, ашта, tlad,
   {{0x32550501,0x497515ea,0x7ae455eb,0x3f5c6a60}},	//   _свир, _блис, goit, díu_,
   {{0x7ae3b45d,0x7e7b95ec,0x290b55ed,0x63a720c2}},	// [10d0] yont, _raup, _vica_, syjn,
   {{0x3a3835ee,0x6ef603cb,0xd838f5ef,0x717935f0}},	//   carp_, mába, nač_, _збор_,
   {{0x38b1d239,0xceb3e00b,0x7bceb5f1,0x25a52277}},	//   _lára_, סיע_, _žbun, älld_,
   {{0x9295439e,0x7ae3b5f2,0xac198250,0x7c222143}},	//   _самц, wont, ходу_, _đori,
   {{0x628f55f3,0x38b54277,0xe504020b,0x7e7c703c}},	//   _inco, _vård_, रगति_, _farp,
   {{0xeb9081b3,0x6f0bc1fb,0x6d5d42a4,0x63a00b57}},	//   تظم_, _sigc, _iqsa, ømni,
   {{0x289c200b,0x2eedd5f4,0x3f86c057,0x7eadeddb}},	//   ויגא, tlef_, _arou_, _dúpl,
   {{0x78ad55f5,0x3f86d5f6,0x48d1c07c,0x9c7ce07f}},	//   nkav, _brou_, াত্র, voča,
   {{0xa3b5f414,0x64686069,0x7e7d55f7,0xdce54041}},	//   चैन_, _þrið, _masp, _arhī,
   {{0x7cf60057,0xe453a68c,0x2d84420d,0xd838e12d}},	//   dára, _خضر_, _šmek_, gač_,
   {{0xa6ca033f,0x3a3820c4,0x200fc05d,0xbea60e12}},	//   елна_, varp_, _tggi_, ганк,
   {{0x78ad423d,0x6e3575f8,0x7cf06156,0x61ed011d}},	//   jkav, _lezb, värm, _byal,
   {{0x4a9ac0be,0x20cd26a6,0xd838e35d,0xd945d5f9}},	//   _רינג, džib_, bač_, _сели,
   {{0x290c35fa,0x38b66065,0xe1f0c19a,0x6e398048}},	//   öda_, _kære_, _بسم_, hawb,
   {{0xdb0620e0,0x7643e037,0x6d5e75fb,0xa3c9a5cb}},	//   nyké, _idny, xtpa, _लेम_,
   {{0x60c9d5fc,0x2a7fc10a,0x26182466,0x3eadcc90}},	//   niem, ndub_, बुजी_, nket_,
   {{0x7e7c75fd,0x395fd593,0x7ae455fe,0x38cb4050}},	// [10e0] _parp, ntus_, roit, رافی_,
   {{0x395fc04e,0x443835ff,0x7ae44052,0xb4dda026}},	//   itus_, qar_, soit, णको_,
   {{0x7e7c7600,0x7c3600c4,0xa91d8012,0x07a6287c}},	//   _varp, _keyr, _bržo, _санн,
   {{0x7e7e3601,0x27ed9602,0xbf0f8064,0x26ca3603}},	//   _happ, _byen_, ादून_, libo_,
   {{0x04438501,0x7c361604,0x8c4383d5,0x629bc098}},	//   сечн, _meyr, сече, djuo,
   {{0xdee3a6fc,0x24804181,0x23604022,0xbcfb20fa}},	//   бочи, ldim_, mtij_, ptée,
   {{0x6aa1b605,0x35a3612a,0x76440079,0x430ac04d}},	//   _dolf, _ларг, _odiy, нхим_,
   {{0x442002f4,0xa3dd0029,0xacea813a,0x60c9d606}},	//   _nfi_, _तुझ_, _أرسل_, giem,
   {{0xd838e530,0x6f029607,0x68fc7608,0x395fd609}},	//   tač_, mmoc, _khrd, gtus_,
   {{0x63a8e042,0x64440b3e,0x7ea3410a,0x7cf605ba}},	//   tydn, _adii, _lõpp, vára,
   {{0x645ab60a,0x2a7dc286,0x7524160b,0x7d0d160c}},	//   _icti, _fawb_, _atiz, _pias,
   {{0x6f02807b,0x6ef6160d,0x6aa1a197,0x6360a291}},	//   nmoc, tába, _zolf, _ịnwe,
   {{0xdb0465ba,0x9a86e1d3,0xc3878031,0x1c1928a2}},	//   nzió, _буйл, _bẹ́ẹ, _दलदल_,
   {{0x6ef6160e,0xb5fdc35d,0x4444249b,0xaca36125}},	//   rába, rešt, _cd_, _kwụb,
   {{0xa3cbe0c2,0x442000fd,0x2d856017,0x3135360f}},	//   _रेप_, _ffi_, _àlex_, ребр,
   {{0x290ef610,0x6d437611,0x30a4401f,0xd468060f}},	//   _hifa_, ánam, брув, _биће_,
   {{0x9259601b,0xdd944052,0x7afc6090,0x344b6af5}},	// [10f0] каат_, баты, _bhrt, ечен_,
   {{0x68e99612,0x9c7ce299,0x09d7e07c,0x656d0bae}},	//   _sked, zočn, _হরতা, _ipah,
   {{0xe7873613,0xef1f4105,0xd01144c7,0x78ad4018}},	//   _супо, _grün_, _ولد_, pkav,
   {{0xa3c3e04a,0xf8bf6187,0x2f0b4031,0x6d4b849f}},	//   náší_, _awét_, _dògì_, trga,
   {{0xaca36125,0x2244805d,0x7bdc605d,0x763a400b}},	//   _awụb, _ddmk_, _exru, _בערג,
   {{0x6b836277,0x64dee010,0x38b42241,0x26c6c0f9}},	//   ångs, नकोश, _kära_, _amoo_,
   {{0x7ae608b2,0x7c2d80c4,0x7cf60066,0x9ed87512}},	//   yokt, ðars, dárn, _смрт_,
   {{0x290ef614,0x6aa2d615,0x395fd616,0x58d580ff}},	//   _aifa_, _coof, ttus_, _тобт,
   {{0x7c3aec8a,0x2295a63b,0x6d46cf9e,0x290ef617}},	//   fatr, _پلاس, škan, _bifa_,
   {{0xa2a18c87,0xe765f28f,0x7c2d4af4,0x88bd0026}},	//   कॉर्, авоп, hbar, spěl,
   {{0xbd4ba13a,0xe8fa01cc,0x3f890108,0x443b400e}},	//   _سؤال_, кло_, _arau_, kaq_,
   {{0x7c2d4064,0xb4c140a8,0x395fd618,0x443b405d}},	//   jbar, ्चो_, ptus_, jaq_,
   {{0xb8de08ae,0x29020055,0x443b4716,0xa3c9a046}},	//   _इत_, rmka_, daq_, _लेत_,
   {{0x38b42156,0xa3e664d6,0x644b4193,0x6eefe22e}},	//   _bära_, _पडल_, ógin, købi,
   {{0xe73725d3,0xddc72cf5,0x7cefe14f,0x7c2d5619}},	//   иер_, tejš, jøri, fbar,
   {{0x14264a8d,0xb4d0404b,0x26ca361a,0xb4e040aa}},	//   рдам, वचे_, sibo_, दके_,
   {{0x7e7e361b,0xddc7242e,0x7a40629b,0x2c014010}},	// [1100] _tapp, rejš, játí, लेलं_,
   {{0x6aa40049,0xdb18a009,0x3d0fa0c2,0x394d0057}},	//   _hoif, szvé, ादों_, áese_,
   {{0x2360561c,0x2d85304e,0x394dc105,0x7d0f4256}},	//   stij_, ålet_, hres_, _fics,
   {{0x95ca803b,0x9c144096,0x7d06a009,0x1b1d807c}},	//   кула_, _kọmp, _éksz, _নিজে_,
   {{0x387f8403,0x4422561d,0x5f06ae12,0xdddc20e0}},	//   _daur_, _ifk_, азда, merő,
   {{0x2ab1d61e,0x7d02961f,0x6b899620,0x442dd621}},	//   _bábo_, smos, _dreg, ebe_,
   {{0x7989818b,0xdfcfa13a,0x645c6024,0x39405622}},	//   _erew, ويه_, _icri, lsis_,
   {{0x394dd623,0x8c3ca686,0x3cfdc048,0x290ee296}},	//   fres_, _doğa, _chwv_, _sifa_,
   {{0xf50ab624,0x649cc057,0x44205625,0x7cfd1626}},	//   _анал_, _méix, ici_, nére,
   {{0xd406e691,0x442dd4b7,0xfaa6f0c4,0xf992a6ec}},	//   ияни, abe_, ршин, _وبا_,
   {{0x44225627,0x7b096098,0x394dd628,0xdddd4041}},	//   _ofk_, _džuh, ares_, _pasū,
   {{0x6aa41629,0x6f0443ee,0x2b4042d1,0x6281eb56}},	//   _coif, jmic, ksic_, adlo,
   {{0x4420562a,0x6562962b,0x6280962c,0x78a40004}},	//   dci_, ntoh, _mamo, _doiv,
   {{0x6d40d62d,0xd838a0ca,0x6ce721b4,0x3f8903ac}},	//   msma, _alčz_, ріме, _vrau_,
   {{0x443b45fc,0xd6d8219c,0x7cf6003e,0x4a31e06f}},	//   taq_, ртя_, cáro, äčší_,
   {{0x5a3501fc,0xdced2098,0x6562800e,0x6f044361}},	//   _унит, _osać, ktoh, gmic,
   {{0x2a7f8dfb,0x2918762e,0x656280dd,0x92014a41}},	// [1110] _raub_, _aura_, jtoh, लेंज_,
   {{0x2a7f8286,0x443cb62f,0x44205630,0x68e8e1cd}},	//   _saub_, jav_, aci_, nodd,
   {{0x443b5631,0x7c38e54c,0x442dcc90,0x62808c75}},	//   paq_, _mevr, ybe_, _bamo,
   {{0x38b9a004,0x6d40d632,0x4438623c,0x2a7f805f}},	//   _mère_, ksma, _eer_, _qaub_,
   {{0x7aed0296,0x7bd84121,0x7cf18249,0x4abb2021}},	//   _mkat, şvur, nåri, _उताव,
   {{0x63ad5633,0x443cb634,0x7d07c0e0,0x9e3ca06f}},	//   myan, gav_, _éjsz, _poďa,
   {{0x27fa8064,0x3cfdc022,0x6a226043,0x7aed1635}},	//   ępna_, _phwv_, _رہنم, _okat,
   {{0x7cf600e0,0x2b49acb1,0x6d4f0552,0x62828054}},	//   váro, čac_, krca, cdoo,
   {{0x7c3bd21e,0x442164b9,0xdcb1c067,0x29187636}},	//   raur, och_, _của_, _zura_,
   {{0x26ccf535,0x6729c267,0x2918607d,0x7c22c12a}},	//   gido_, rpej, _yura_, _efor,
   {{0x7d045637,0xea002067,0x3cfdc022,0x20d2006f}},	//   ymis, _khấu_, _thwv_, hšie_,
   {{0xe50a0016,0x442f804d,0x24800022,0xc0c8c5d3}},	//   _cặp_, nbg_, _qaim_, _куче_,
   {{0x60c98096,0xe8076290,0x63ad4132,0x6aa3f15b}},	//   _mmem, वेता_, jyan, _tonf,
   {{0x6281b638,0x6abaf639,0x64464037,0xed59e013}},	//   _jalo, chtf, _sdki, _бок_,
   {{0x4420562f,0xa0a60407,0x7cfde004,0x4438763a}},	//   tci_, _гайд, gère, _rer_,
   {{0x60cd446a,0x672dc1d7,0x6e3c27cc,0xb920a031}},	//   giam, _ħajj, sarb, _aarọ_,
   {{0x63ad436c,0x29186a36,0x6a16628b,0x6b9bc2b2}},	// [1120] gyan, _sura_, مبار, nxug,
   {{0x60db80f9,0xee376376,0x60c98af6,0x4422163b}},	//   _ajum, йну_, _amem, lck_,
   {{0x61fb963c,0xb5fb4057,0x5d86213a,0x443a20ca}},	//   _azul, _acád, _الجل, _iep_,
   {{0x29120a2d,0xba16807c,0x7d1b606e,0xb87b40f9}},	//   _jiya_, ার্ড_, _čust, _ajíf,
   {{0x29120b33,0x2fd72555,0x6bd723f1,0xd838a07f}},	//   _miya_, _نوید_, _نویس_, _peč_,
   {{0x48e3a1e1,0x4439563d,0x61fb843d,0xdee3b63e}},	//   почв, _zes_, _dzul, почи,
   {{0x6d56563f,0x7c3e7640,0x44395641,0x9186a13a}},	//   luya, mapr, _yes_, إجتم,
   {{0x60db800e,0xd00a8501,0x6cd6833e,0x7cf60019}},	//   _gjum, _бебе_, _اقرا, fárm,
   {{0xf09f4016,0x7c3d012a,0x2fc0516b,0x6e3d0747}},	//   _giàu_, vasr, nzig_, vasb,
   {{0x29121642,0x757b40be,0x291a2aaa,0xbda6e1c1}},	//   _aiya_, נטיפ, _oupa_, محجو,
   {{0x7eade005,0x2d8ae9d7,0x63ad5643,0x2cb87644}},	//   _xúpi, íbe_, zyan, _mlrd_,
   {{0x6d43613a,0x2ca04feb,0x6d4f02e2,0xdcfba143}},	//   ánai, jjid_, trca, _pruć,
   {{0x6281b645,0x7c3d017b,0x6111c041,0x7cf06105}},	//   _yalo, rasr, _tālr, läru,
   {{0x9985e013,0xf8bf7646,0x66160009,0x9f34e14f}},	//   galų_, _atén_, _egyk, _декі,
   {{0x2ca6d5c7,0xdddd0009,0xa49b4733,0x5726e33d}},	//   _kood_, reső, _biòp, _ارتق,
   {{0x7cd3c12a,0x26ceb647,0x8cf5484f,0x3ea0400e}},	//   tări, hifo_, ізац, gjit_,
   {{0x4034404e,0x6fb8c028,0xdd9441d3,0x3ea6c136}},	// [1130] яетс, इनिं, паты, _moot_,
   {{0x6b8d1648,0x7cd3c12a,0x9d1bc095,0xb87b40f9}},	//   _irag, rări, טומט, _akít,
   {{0x257ae041,0x6281b649,0x09ada07c,0x7cd3c0ba}},	//   _jūl_, _ralo, _কেনা, sări,
   {{0x2ca6d071,0x6d5655e3,0x7cd3c0ba,0x63ad5086}},	//   _nood_, buya, pări, pyan,
   {{0x291a364a,0xfaa5ada4,0xdca5b097,0xb87b40f9}},	//   _zupa_, жало, жали, _ajíg,
   {{0x1fa9b64b,0x7cf88dc1,0x69c0c480,0x2eb1c026}},	//   икли_, bíro, dzme, जस्त,
   {{0x7cf8964c,0xea002119,0x5c5c2053,0x6d41e09a}},	//   círo, _thấu_, אדוק, xsla,
   {{0x60c989fa,0x7d1ab64d,0x2fdf8048,0x2d87b019}},	//   _umem, _duts, _txug_, rvne_,
   {{0xdbf20026,0x68e9c1cd,0x78bbc97a,0x386d80d5}},	//   _přír, roed, rhuv, _iber_,
   {{0x6e3b8885,0x78bbd64e,0x7e6d0e6a,0x672d4c8c}},	//   _heub, shuv, _abap, ipaj,
   {{0x2169ed73,0x2ca6c095,0x2912164f,0xa2af2026}},	//   шини_, _food_, _piya_, ुसन्,
   {{0x2901205d,0x2483600e,0x7c3e6b78,0x91a00088}},	//   _ahha_, _lajm_, zapr, _ndị_,
   {{0x7d1b82df,0x6e2482b2,0x7c3e61e7,0xe29fc069}},	//   _juus, ñibi, yapr, öðu_,
   {{0x998361f6,0xf8b580c2,0x69dcc106,0x6ab58028}},	//   _bejż_, ंसुप, ğret, ंसुर,
   {{0x644981ae,0x29120a85,0x7cf60803,0x798d1650}},	//   _odei, _tiya_, nárk, _eraw,
   {{0x3ea7e030,0x6e3e6037,0xfc3f0049,0x64498049}},	//   _hont_, wapb, caí_, _ndei,
   {{0xb5fb4005,0x3ea0405d,0x67299651,0x7ce5c005}},	// [1140] _acáb, rjit_, _ntej, fórz,
   {{0xb4c7e0c5,0x62841652,0x3eb24530,0x93bce0ba}},	//   _ईगो_, _haio, skyt_, mbăr,
   {{0xb05b0277,0x3e4cc03b,0xf772628b,0xa3c9a10a}},	//   miär, lėtų_, باء_, _लेल_,
   {{0x2ca7f653,0x6283e530,0xed5a54b0,0xd838a06e}},	//   _lond_, _lano, _ком_, _točk_,
   {{0x2ca6c200,0x44325654,0xf48786b0,0xdb0ee066}},	//   _rood_, mby_, تالی, ždém,
   {{0x2d800157,0x7af6404e,0x7ae9406e,0x7f429631}},	//   _msie_, llyt, čete, rsoq,
   {{0x26cf9655,0x3ea6d656,0x2d8d8125,0xa09b20be}},	//   bigo_, _poot_, _eree_, ייסט,
   {{0x7c3b8684,0x2005003c,0xd838b657,0xbe8ad2ad}},	//   _geur, əlif_, _moči_, рске_,
   {{0xd7fac3b7,0x3ea7f658,0xeeb7c0ff,0x7c244012}},	//   шук_, _bont_, ільш_, icir,
   {{0x6e3c6133,0x39583659,0x7c3b965a,0x7aeaa00e}},	//   _jerb, kurs_, _zeur, qoft,
   {{0xdd90e24d,0x6b8d0b39,0x3ea6c08b,0xac1900ff}},	//   روح_, _srag, _toot_, йону_,
   {{0x29132057,0xe297c143,0x212901e7,0x7e776119}},	//   _sixa_, _мах_, _ptah_, zexp,
   {{0x6283eed9,0x236683ac,0xfbc50599,0xd7fb0fdb}},	//   _fano, ntoj_, _लेखम, рун_,
   {{0x6296165b,0x69c28171,0x2484965c,0x672d4022}},	//   _enyo, izoe, _lamm_, vpaj,
   {{0xcd33e049,0x02a7409c,0x3958365d,0x2720c119}},	//   _قريب, орам, gurs_, _hòn_,
   {{0x4c944052,0x7640c5d2,0x628400fc,0xd838a320}},	//   мисс, namy, _gaio, _doči_,
   {{0x236683ac,0x4adba077,0x6d4452c1,0x651541c1}},	// [1150] jtoj_, _बदलव, gsia, سوائ,
   {{0x672d565e,0xd838b65f,0x7640c132,0xe8014064}},	//   rpaj, _foči_, hamy, लेगा_,
   {{0xddc402d1,0xa3c9a4da,0x61406ac3,0x7d1b82df}},	//   _ibiš, _लें_, _rálá, _suus,
   {{0xa879400b,0x317a200b,0x3946c9fe,0x7d1b9660}},	//   _פאָר, _פארד, _ovos_, _puus,
   {{0x24849661,0x27fea012,0x29095662,0x7640d663}},	//   _damm_, _aztn_, mmaa_, damy,
   {{0xcf580095,0x3d16a077,0xc17240be,0x6440c071}},	//   קבות_, _पंखे_, _רחם_, eami,
   {{0x6f02c28f,0xdddbc143,0x6915a1f6,0x201e40ba}},	//   _bhoc, dduš, _aġer, _ştii_,
   {{0x644ae133,0x237f8286,0x6f02d664,0x3eb9c069}},	//   _adfi, _tsuj_, _choc, óst_,
   {{0x6f1d540e,0x20d2006f,0x26d13665,0x2d8ee0e8}},	//   _jusc, jšia_, kizo_, _arfe_,
   {{0x62840265,0x7ebcc004,0xdce2e17a,0x44324431}},	//   _saio, _répe, _proġ, zby_,
   {{0x6440c97e,0x212dc993,0xe8e00067,0xf1a8c050}},	//   bami, speh_, _ngợi_, مایه_,
   {{0x6285208b,0x6d457666,0x2a782105,0x01faa076}},	//   _aaho, isha, werb_, _הפעל,
   {{0x2d813667,0x7c244199,0xa295e0ff,0x628401e2}},	//   _ashe_, vcir, _наді, _vaio,
   {{0x752960a9,0x80b981a6,0x1e84e14f,0x6f09d668}},	//   _čezn, েকট্, _олім, lmec,
   {{0x6abb9669,0x78bb800d,0xe29a4080,0xa09ae053}},	//   _oluf, _oluv, бав_, _ליסט,
   {{0x6441f66a,0x645c21cd,0xaa7b4069,0x6f1eb66b}},	//   lali, sgri, _skýr, ípci,
   {{0xcb130095,0xef1742ae,0xd00743d5,0x443cf66c}},	// [1160] _אלה_, зму_, зете_, _yev_,
   {{0x443dc659,0x26d1207b,0x7d09d66d,0x6f09c105}},	//   _lew_, cizo_, hmes, hmec,
   {{0x6aa8b66e,0x2721e069,0x7d04166f,0x24848037}},	//   _rodf, _jón_, _khis, _pamm_,
   {{0x7cf4e355,0xa5078dd1,0x7c3c60f7,0x7d1d5670}},	//   ràri, пеха_, _werr, _fuss,
   {{0xfe7060e0,0x24848030,0x6f1d4197,0x33f68049}},	//   _لگا_, _vamm_, _gusc, أساس,
   {{0x81be007c,0x7c3e2403,0x2d825671,0x7640c614}},	//   _আশা_, _jepr, _iske_, wamy,
   {{0x7640cedd,0x6f02d672,0x7c3b0069,0x291dd04a}},	//   tamy, _phoc, ðurk, _auwa_,
   {{0x1c1ea0c2,0x3afac00e,0x6266c13a,0x6f040088}},	//   _पलवल_, rëpo_, سابق, _nhic,
   {{0xaca3a067,0x291dd141,0xdee380ff,0x7c86ed82}},	//   _cuồn, _cuwa_, _чоти, пуне,
   {{0xdb1ae0e0,0x16014029,0x443ce05f,0xc1bb8095}},	//   sztí, लेटर_, _qev_, _הממש,
   {{0x7cefe042,0x7640c5f1,0x2d8fc3c5,0x4427e0d4}},	//   tørr, pamy, _erge_, _dfn_,
   {{0x2eb96148,0x443ce022,0x291dc0a2,0xbec36018}},	//   _इत्त, _wev_, _fuwa_, _ķīmi,
   {{0x291eb673,0x6f040054,0x3f8fc098,0x2721e057}},	//   _huta_, _dhic, _grgu_, _eón_,
   {{0xd041e03c,0x7c3e215e,0x7d041674,0x20d21675}},	//   kilə, _cepr, _ehis, ršia_,
   {{0xe1ff40e0,0x6d598ee4,0xb4bd2064,0x3b09403c}},	//   _szó_, zuwa, _आती_, tmaq_,
   {{0x62853676,0xfdf7e0be,0x7d040e70,0x2903605d}},	//   _waho, _מצות_, _ghis, _shja_,
   {{0x29095677,0x6d457678,0x64428351,0x20c0f03c}},	// [1170] rmaa_, wsha, daoi, _còig_,
   {{0x6288f679,0xddc40098,0x2d81205f,0x752d063f}},	//   nddo, _ubiš, _tshe_, _itaz,
   {{0xf579619a,0x26d24025,0x6f1e2012,0x7c25767a}},	//   تماع_, biyo_, _gupc, rchr,
   {{0xc333e095,0x6286567b,0x6e2560cb,0xf8aea062}},	//   תוף_, _gako, schb, یکل_,
   {{0x6b82c385,0xfaf8e018,0x2bc8567c,0x4e94a0eb}},	//   _nsog, klī_, _еуро_, کشنر,
   {{0xeb99a0d6,0x69096013,0x20cd204d,0x7cf18b57}},	//   жик_, _ežer, džik_, tårs,
   {{0x644d0153,0x6f172071,0x7d09d67d,0x0d8461ba}},	//   _odai, _mixc, tmes, _плён,
   {{0x7cf18042,0xdbd7a2df,0xa2c14077,0x752d0066}},	//   rårs, väär, रोच्, _otaz,
   {{0x27ff83df,0x6aaaf67e,0x60dbd67f,0x62877680}},	//   _uzun_, _boff, rnum, _kajo,
   {{0xfc3f5681,0xe9d9f0e1,0x6d5af682,0x7d1600a2}},	//   _leí_, жко_, futa, _siys,
   {{0xdddc63b1,0x291eb4e4,0x69c45683,0x98a06299}},	//   _karš, _guta_, zzie, spić_,
   {{0x644bca2f,0x2b52c6df,0x8d74a0d0,0x7641f684}},	//   _udgi, üncü_, _ساما, saly,
   {{0x6d4603fc,0xd041e03c,0x443ea095,0x7c3e3685}},	//   uska, zilə, _yet_, _pepr,
   {{0x6289d686,0xe739e2d3,0xfd5f0016,0x443f9687}},	//   ldeo, _дек_, _huyệ, _leu_,
   {{0x7769c3f5,0x26d25688,0xe45f1689,0x6443a425}},	//   ltex, tiyo_, giös_, iani,
   {{0x225fc97f,0x7c2d84cd,0xdddc603b,0x6e2d807b}},	//   nguk_, ñarl, _narš, ñabl,
   {{0xe9da4afe,0xda65413a,0x6143568a,0x7c3e368b}},	// [1180] цка_, عافي, кета, _tepr,
   {{0x224d88a7,0x3f91629f,0x26c0568c,0xb605e013}},	//   _adek_, _brzu_, shio_, _tušč,
   {{0x73065247,0xf1c3a013,0x6d4d8098,0x6299d1b0}},	//   _опоз, nešė_, šaal, _onwo,
   {{0x44290071,0xdb1ae009,0x753b85f1,0x917a4119}},	//   _xfa_, nztá, _bwuz, _cập_,
   {{0xe3b248b8,0x4e222295,0x2eeeb68d,0x7644568e}},	//   _شرح_, _मलाई_, toff_, maiy,
   {{0x7769c011,0x7bc6006e,0x6d5aeb0d,0x386dd68f}},	//   dtex, izku, yuta, efer_,
   {{0x386dcb28,0x7c248071,0x6aabc22e,0xff2360ba}},	//   ffer_, ñirs, _bogf, _амсо,
   {{0xb05b4277,0x38c8a0d0,0x6d5ae10a,0xf526d0ba}},	//   _gläd, _کاری_, vuta, мфон,
   {{0x6aabc1cd,0x6443adb2,0x3f14e8f3,0x9a12c079}},	//   _dogf, bani, ндис, _sọbụ,
   {{0xb4bd2064,0x7eade06f,0xeb91400b,0xbcfb20e0}},	//   _आते_, _súpr, אָט_, rték,
   {{0x2bd285c2,0x32576095,0x20d207a0,0x867b63c8}},	//   _देता, וסים_, ršin_, חריו,
   {{0x76444058,0x2293c049,0x20d3c0ba,0x7982c0a2}},	//   jaiy, _للمس, pţia_, _tsow,
   {{0x63a28733,0x21200187,0x20d20143,0xdfa6c049}},	//   nxon, _cuih_, pšin_, _تحضي,
   {{0x63a2841a,0x20d3c0ba,0x7cfd0666,0x6d473406}},	//   ixon, nţin_, péro, tsja,
   {{0x48ab403b,0x6127a106,0x2fc9e0a2,0x2d920614}},	//   отам_, _kıla, _ƙage_, _erye_,
   {{0x6a155690,0x44291691,0x260c004b,0x6d48e488}},	//   ембу, _ufa_, ठेही_, msda,
   {{0x6d473692,0x98b970ba,0x60c282a4,0x3d16c08d}},	// [1190] ssja, плат_, dhom, _पूछे_,
   {{0x2244c6a6,0x29187693,0x6289c098,0x690b20f7}},	//   hamk_, _cira_, zdeo, _eżer,
   {{0x628aa0e2,0x7c298105,0x24890bee,0x31694108}},	//   ddfo, _pfer, _kaam_, staz_,
   {{0x29187694,0xa3c9a077,0x6fd0404b,0x66c06156}},	//   _eira_, _लेग_, _ठेवू, _röke,
   {{0x225820d0,0x24891695,0x3949813a,0x291944ec}},	//   _عجیب_, _maam_, éas_, _iisa_,
   {{0x68e2c031,0xc104a049,0x7cfd0e1c,0x629aa187}},	//   _ajod, نوني, dérm, _cnto,
   {{0x6d4ef696,0x76408030,0x20cd26ca,0x917a4119}},	//   ábal, _femy, ržih_, _tập_,
   {{0x6915c05c,0x76456435,0x7769d697,0xd788c067}},	//   _všeo, lahy, ttex, _bể_,
   {{0x2d98f698,0x6d4ae3e0,0xf70a0119,0x752080ce}},	//   åren_, _avfa, _gầy_, _gumz,
   {{0x6288b699,0x6d5d169a,0xfaa7a056,0x80b9e0c2}},	//   _gado, dusa, _ўшан, इसें,
   {{0x7eb5d69b,0x6f18ea5f,0xc6a7c07a,0x7d0d4106}},	//   _lápi, _divc, _орди, kmas,
   {{0x2ec825e8,0x18a6026f,0x628b9308,0x7ebcc057}},	//   रफ्त, хамм, ndgo, _tépa,
   {{0xf1bf0049,0xd0a8e555,0xeb99c14a,0x20d5e71b}},	//   scán_, سطین_, _хил_, _пікс,
   {{0x6721b69c,0x3075204e,0x6d49c4b9,0x7c29d147}},	//   _kulj, кусс, msea, lcer,
   {{0x91e321bc,0x21200939,0x11d520ff,0x67222361}},	//   горе, _wuih_, вітр, _čojs,
   {{0x6b8401df,0x8fa641d3,0xadd6e0be,0x7641b69d}},	//   _tsig, набе, _רוקח_, _lely,
   {{0x9c7ce05c,0xf389e067,0x442a617b,0x6440969e}},	// [11a0] počt, _hả_, _pfb_, _remi,
   {{0x76460b5e,0x6f0d569f,0xb4636c84,0xe8f774d2}},	//   laky, amac, лкул, елу_,
   {{0x4429406f,0x395d8171,0x6d5c36a0,0x24890048}},	//   bca_, euws_, qura, _yaam_,
   {{0x2cad80fd,0x53a641c0,0x5c0684e4,0x44f68050}},	//   _coed_, _замб, няла, رساز,
   {{0x7ae396a1,0xb0d7240a,0x291a36a2,0xa2b196a3}},	//   énta, _डगमग, _kipa_, _अकर्,
   {{0x644560eb,0x644e6a7e,0x291956a4,0x7ebf000e}},	//   cahi, _udbi, _zisa_, _mëpa,
   {{0x7ae416a5,0xfce376a6,0x7cf604d2,0x69d82013}},	//   _ojit, _соро, nárs, _žvej,
   {{0x2907ec43,0x6441a10a,0x68e3e04d,0x6f18e143}},	//   _ahna_, _eeli, _ajnd, _sivc,
   {{0x6288b6a7,0x248916a8,0x6f18f1b5,0xceb8e0c2}},	//   _tado, _raam_, _pivc, tkę_,
   {{0x8c3d812a,0xa49b0017,0x7cf6006f,0x6b82808e}},	//   _roşi, ològ, kárs, mwog,
   {{0x6eb4e0c2,0xceb8ea0b,0x49baa0e0,0x7d0d56a9}},	//   ेसबु, rkę_, _عائد_, ymas,
   {{0x8289c0ff,0xdd12020f,0x6d48e732,0x644616aa}},	//   _осіб_, rüşl, rsda, gaki,
   {{0x27260067,0x629c62be,0xe0df0024,0xf09f42d9}},	//   _côn_, _onro, rnò_, _bhàn_,
   {{0x271ea088,0x645cec1e,0x13f4e14a,0x6442c7ad}},	//   _ọnya_, órid, _изля, _heoi,
   {{0x66040d28,0xddc8f6ab,0x27f3e066,0x6d5e6582}},	//   _ezik, ledž, čané_, jupa,
   {{0xd5fbe3c8,0x644616ac,0x68e94012,0x26c00090}},	//   _מפור, caki, čedo, _glio_,
   {{0x6d58b6ad,0x481540d6,0x09d5e07c,0x26d90066}},	// [11b0] hrva, тмас, _সুপা, érou_,
   {{0x65956fb5,0x26dfc0a9,0x3f9bc03e,0xa3bd666f}},	//   казу, znuo_, _áque_, इनल_,
   {{0xa2b261b0,0x200496ae,0x442956af,0x2d932005}},	//   _आकर्, _azmi_, pca_, _urxe_,
   {{0x6d58a098,0x254ca04a,0x48cf807c,0x6d4aa831}},	//   drva, děl_, িক্র, dsfa,
   {{0xa2a4c5c5,0x7982808b,0x09b5c1a6,0x63bb635f}},	//   कान्, gwow, _জেনা, _ƙuns,
   {{0xf77401a9,0x628ae066,0xb4be04e5,0x2ca94046}},	//   רקס_, _nafo, _इत्_, ljad_,
   {{0xf0942679,0xb8d9a04b,0x6d49c62c,0x09d5e1a6}},	//   טנס_, _चव_, wsea, _সুনা,
   {{0x6d49d6b0,0x59d28e35,0xf1b30029,0x6923a0a9}},	//   tsea, _देवर, ुनान, _uđem,
   {{0x644736b1,0xc692800b,0xb0c94029,0xaa7b0026}},	//   kaji, _דאן_, _रतनग, znýc,
   {{0x7d1b96b2,0x22460274,0x61fb85fc,0x60c4400e}},	//   _hius, _žok_, _iyul, zhim,
   {{0x7afbd6b3,0x6009e052,0x644736b4,0x628d40ae}},	//   plut, ьном_, daji, kdao,
   {{0x656d4644,0xe3b0c0d0,0xe61f4067,0x20d200a9}},	//   ktah, _گرم_, _ngô_, pšim_,
   {{0x6d4b86bf,0x628bc057,0x958303fc,0x41d056b5}},	//   nsga, _iago, аляе, _सेंस,
   {{0x6d5e6d87,0x7cf601a2,0x644736b6,0x6d4b94f2}},	//   yupa, társ, gaji, isga,
   {{0xf09f4016,0x764616b7,0x99804013,0xa06a553b}},	//   _chào_, paky, ybių_, мава_,
   {{0x7643f6b8,0xc952a0be,0x98bf00ba,0x628d4426}},	//   _heny, ימל_, rstă_, gdao,
   {{0x7c24e315,0xceb2c694,0x7523f556,0x61464f22}},	// [11c0] _şiri, בין_, _hunz, теза,
   {{0xed590326,0x8c3ca121,0x888ce00b,0x1fb663a5}},	//   áže_, _yoğu, ּראַ, ксер,
   {{0x546a83fc,0x387fc854,0x2247aaaa,0x60c456b9}},	//   даем_, keur_, dank_, phim,
   {{0x387fc0fa,0x628e36ba,0x290f80ae,0x248dd6bb}},	//   jeur_, ldbo, gmga_, jdem_,
   {{0x387fd6bc,0xa2b3a567,0x7e7e76bd,0x20cd216d}},	//   deur_, _अवश्, pepp, rživ_,
   {{0x254ca04a,0x248054ee,0x6263a1e3,0xc882c03c}},	//   těl_, leim_, авља, mişə_,
   {{0x6d5996be,0x6df6613a,0x8cb3a39f,0x75240c9d}},	//   arwa, _شكرا, _अवरो, _luiz,
   {{0x78a9c488,0x6b960064,0x4420008a,0x672401f6}},	//   gjev, _oryg, _ngi_, _ouij,
   {{0x6d4ab6bf,0x66d6003b,0x7d1ab6c0,0x8c3ca121}},	//   ssfa, eško, _tits, _soğu,
   {{0xcc12c125,0xddc8f6c1,0x26d8310f,0x7523ebef}},	//   _fọnị, redž, jiro_, _bunz,
   {{0x387fc31d,0x6f1c76c2,0x44200058,0x64440090}},	//   beur_, _mirc, _bgi_, _beii,
   {{0x69c9c022,0x387fc0fa,0x629e2061,0x98bf0013}},	//   bzee, ceur_, _anpo, kstą_,
   {{0x6723ec12,0x59d9c573,0xd130c8b5,0x7643f6c3}},	//   _eunj, _बेपर, _امت_, _feny,
   {{0x9f586057,0x442008fb,0x6360a088,0x67240363}},	//   _eyré_, _egi_, _ịnye, _duij,
   {{0x3ea956c4,0x7648f6c5,0x97252ef8,0xbddb40f9}},	//   tjat_, mady, افرو, _adèp,
   {{0x7648f147,0x442ce011,0x387241cd,0x656d4c04}},	//   lady, lcd_, gfyr_, ttah,
   {{0x7ebccf3c,0x628d428f,0xb7d90938,0x66c06156}},	// [11d0] _répl, rdao, _سودا_, _söka,
   {{0x539a0095,0xa5bb4698,0x7d0996c6,0x387fc52c}},	//   _ניתו, _agóc, _shes, zeur_,
   {{0x68f536c7,0x7d1c710f,0x442ee944,0xaca36125}},	//   mozd, _dirs, _mff_, _ntụb,
   {{0x7ceda005,0x62a54089,0xf5488125,0xa5c700c4}},	//   lúrx, ároč, fụ_, _gróð,
   {{0x628bd6c8,0xd5a6c0a4,0xee38884f,0x75240005}},	//   _rago, _اف_, тні_, _xuiz,
   {{0x6d4b809a,0xb4b1e021,0x6560c1e7,0xe057a0eb}},	//   rsga, _टके_, dumh, ئیات_,
   {{0x7643e4b4,0xbcfb20e0,0x78a9c00e,0x80ba4010}},	//   _reny, ltés, tjev, _एकमे,
   {{0x61fd4066,0x6723e133,0x6a85ce27,0x395fc052}},	//   _kysl, _runj, улиа, tuus_,
   {{0x7af520e0,0x7cfd0c0b,0x316dc004,0x8c3d803c}},	//   kozt, céri, utez_, _qoşu,
   {{0x60c2d6c9,0xceb4603c,0x7523ef59,0x5274a63b}},	//   _elom, qqət_, _punz, _نامز,
   {{0x395fd6ca,0x752400e6,0x316dd6cb,0xd048e03c}},	//   suus_, _suiz, stez_, nidə,
   {{0x442ef6cc,0x6d4f43ee,0x66d603de,0x291ce057}},	//   _eff_, _ovca, rško, _eiva_,
   {{0xfc470359,0xe918c0ff,0x7e9b6041,0x6724048a}},	//   ñías_, _році_, _kāpē, _quij,
   {{0x291dc0f2,0x6b960aaa,0x7db5e938,0x290b4030}},	//   _hiwa_, _vryg, _مصبا, _ahca_,
   {{0x291dd6cd,0xd5e40079,0x7ae3b6ce,0x3f8916cf}},	//   _kiwa_, _baị, innt, _esau_,
   {{0x44200958,0x290a60dd,0xa7d600a4,0x26d836d0}},	//   _ugi_, _shba_, _متخص, siro_,
   {{0x20d2029c,0x03a3464d,0x2bd9d6d1,0x7e6456d2}},	// [11e0] vših_, бито, _बेमा, rgip,
   {{0x6280d6d3,0xdd044315,0x7f3b0095,0x291ce0d5}},	//   zemo, ırır, _רעיו, _xiva_,
   {{0x68e28b83,0x3abae00b,0x79898434,0x7cd20018}},	//   tnod, עמענ, _asew, dārz,
   {{0x68468677,0x442dd6d4,0x2bd54010,0x136a8084}},	//   унда, jce_, _ठेवा, ешки_,
   {{0x99dd806f,0x60c40167,0x6e3bc20d,0x60d8a157}},	//   _peňa, _mlim, dbub, tivm,
   {{0x44224299,0x64465375,0x2b4dc098,0x3ce6c065}},	//   _hgk_, _heki, dsec_, _sjov_,
   {{0x291cf6d5,0x3cffc05d,0xf1a7e049,0x68e455c7}},	//   _riva_, fluv_, _اء_, onid,
   {{0x26da6296,0x442240c7,0x37e8c07c,0x6f1e2064}},	//   lipo_, _jgk_, _পরবর, _lipc,
   {{0x6280d6d6,0x6d5c2105,0x7cfec00e,0x8af065fc}},	//   remo, hrra, nëri, hrəm,
   {{0x628e76d7,0x386681cd,0x6d4e268f,0xb05b0156}},	//   _jabo, lgor_, ksba, rhäm,
   {{0x26d90733,0x2018e1dd,0xb9098088,0x6127a0b0}},	//   tiso_, äri_, _nchọ_, _yılm,
   {{0x628e6e96,0x7c3bc315,0x2bef407c,0x291dd6d8}},	//   _labo, cbur, চেয়ে_, _giwa_,
   {{0x7526405d,0x20cd2098,0x442ef6d9,0xcc12c125}},	//   _nukz, džir_, _tff_, _kọmị,
   {{0x6234f386,0x26d900bb,0xf1c2007f,0x59d620f1}},	//   _теку, siso_, dišč_, _डेहर,
   {{0xbcfb207b,0x26d901b6,0x644528cd,0x7ceda03e}},	//   guéa, piso_, _vehi, rúrx,
   {{0x644aaf2c,0x628e76da,0x7ae456db,0x59c488a2}},	//   hafi, _aabo, gnit, वनार,
   {{0x60f96052,0x3f856057,0x1958465d,0xa15842d5}},	// [11f0] вная_, _áluz_, латы_, лату_,
   {{0x25a52277,0x21294058,0x7c2d56dc,0x7c3bd6dd}},	//   älls_, rqah_, scar, zbur,
   {{0x711a2557,0x6d4f02a5,0x60c40052,0x6f0d0119}},	//   _שותפ, lsca, _ylim, _khac,
   {{0x644656de,0x69c1610a,0x4fd62095,0x224b0156}},	//   _geki, _ülem, _כותב_, nack_,
   {{0x291eb6df,0xd04aa03c,0x6f0d0256,0x644aa1df}},	//   _bita_, lifə, _mhac, fafi,
   {{0xf8bf11b2,0x6b89806e,0x0555a14a,0xd6d9c0c2}},	//   hké_, _vseg, атия, wił_,
   {{0x645560c2,0xd498614a,0xa3d4e077,0x30c9a009}},	//   _idzi, _сря_, _सेल_, _یورپ_,
   {{0x52d12e74,0x248d8071,0x26c94c1e,0x272ab6e0}},	//   सफुस, _uaem_, nhao_, _dùn_,
   {{0x7e9b6041,0x20d3c1fc,0x2019c04e,0x256f4ed8}},	//   _tāpē, nţii_, äsi_, nül_,
   {{0x27ff96e1,0x681bc041,0x7f5bc676,0x6561f6e2}},	//   _iyun_, _rādī, rruq, tulh,
   {{0x60c416e3,0x68e9814f,0x7c3bc77c,0x38bb000e}},	//   _plim, _kjed, pbur, _zëri_,
   {{0x95d9c052,0x6d5bc00e,0xcebae1df,0xef1701fc}},	//   _идет_, prua, _riƙe_, имэ_,
   {{0x645576e4,0x3eadc00e,0x7646477b,0x3ceb0066}},	//   _odzi, mjet_, _reky, _živé_,
   {{0xed5a2f2d,0x6d4e2305,0x59b565aa,0xaca46291}},	//   ког_, tsba, ंहार, _kwụs,
   {{0x272b8042,0x6d5c36e5,0x3f9941df,0xe1ff4031}},	//   _løn_, urra, _arsu_, _ayó_,
   {{0x60c409fa,0x7d0d16e6,0x2247eb83,0xc952e095}},	//   _ulim, _ghas, _henk_, _ומה_,
   {{0xc2466f27,0x9c134088,0x6d4e36e7,0x644ab6e8}},	// [1200] инак, _fọma, ssba, yafi,
   {{0x63a9d6e9,0x68e456ea,0x68fb96eb,0x628e6025}},	//   ixen, snid, _akud, _qabo,
   {{0x644aa03c,0x35a62517,0x7d01e569,0x7e26816c}},	//   vafi, _танг, ills, адеж,
   {{0xe73a96ec,0x27ff8c12,0x63bbd6ed,0x7bcd405f}},	//   вед_, _byun_, kyun, bzau,
   {{0xddd8a026,0x38669598,0xf194809e,0x290d8f1f}},	//   devš, rgor_, силь, _dhea_,
   {{0xd90da062,0x60f7a84f,0xd8436066,0x3f9a20a9}},	//   فیق_, анія_, ručí_, _krpu_,
   {{0x27ff81e9,0x27e0c0ba,0x290d8090,0x68e9822e}},	//   _eyun_, _ţin_, _fhea_, _fjed,
   {{0x3ebfd6ee,0x7eb840e0,0xb5fb4273,0x290d8037}},	//   gkut_, _típu, _abáy, _ghea_,
   {{0x25a0c6be,0x3cf822cf,0xa8054071,0x7d028a13}},	//   _šilb_, korv_, muñé, mlos,
   {{0x6233a1e3,0x5976a20e,0x9873e4e4,0x6e240c3f}},	//   _међу, _выду, ольц, _agib,
   {{0xfd532125,0x2ef82105,0x2163e07e,0x6d60a4d2}},	//   _dofọ, dorf_, отяг, ývač,
   {{0xbcfb2057,0xfaa3d138,0xe8d96088,0xd7fac0ba}},	//   guén, _махо, trị_, _иул_,
   {{0xf8bf16ef,0xa3dd76f0,0x7648b675,0x20d2006f}},	//   rké_, _तेन_, _kedy, jšiu_,
   {{0x2484d6f1,0x7b1060cb,0x7d0d02a8,0x4b7bc053}},	//   lemm_, läuf, _whas, _סאוו,
   {{0xd437e00b,0x78ad56f2,0x76476163,0x6f0296f3}},	//   _דרוק_, tjav, _rejy, kloc,
   {{0x30a4401b,0x7cfd0009,0x6283a7b3,0xbcfb22a8}},	//   орув, gért, zeno, cuén,
   {{0x2f0be22e,0x6728a320,0xaa7b0066,0x644b96f4}},	// [1210] søge_, _ludj, nným, vagi,
   {{0x2d9941e4,0x20d3c12a,0x7bce2361,0xa7fce106}},	//   _vrse_, rţii_, bzbu, ygıl,
   {{0xb995213a,0xa49b42d9,0xe3b00555,0x21276119}},	//   _الجب, _bhòt, _فری_, ênh_,
   {{0x78a2c071,0x8f9a2076,0x20d3c0ba,0x7cfd0009}},	//   _nnov, _עירי, pţii_, mérs,
   {{0x68e980dd,0xa2836050,0xcc12c088,0x3a248057}},	//   _vjed, _ویرو, _dọkị, _dgmp_,
   {{0x6728b6f5,0xb4d5e028,0x7528b6f6,0x141a43c8}},	//   _budj, _सगे_, _budz, _תושב,
   {{0xdddc36f7,0xd6582095,0x7c2d81af,0x2247e106}},	//   zdrž, ביות_, ñars, _renk_,
   {{0x68fb8174,0xb05b4156,0x15b8a1d3,0xe576a02d}},	//   _ukud, _oläm, рышы_, ёзы_,
   {{0x28a9c4e6,0x395eeb6c,0x7ebda187,0x3f8940fd}},	//   काबि, erts_, _lèpi, nwau_,
   {{0x26c5a0e8,0x21200037,0x7528a04d,0x2cbfd6f8}},	//   _ullo_, _siih_, _fudz, skud_,
   {{0x2cb8e156,0xdced604d,0x5f95a009,0x6728b6f9}},	//   örda_, jtač, _دلائ, _gudj,
   {{0x60dd16fa,0x7c84c739,0x20cac090,0x6448b6fb}},	//   gism, _муче, _cùid_, _zedi,
   {{0xfe70c25b,0x395ee3c5,0x628576fc,0xd36ee050}},	//   _آدم_, arts_, keho, وهی_,
   {{0x232702dd,0xa2d3d6fd,0x3a3fc037,0x69ce20cb}},	//   сори_, बोर्, lbup_, tzbe,
   {{0x0135e01e,0x68fd4037,0x7196e050,0x64a64fdb}},	//   _اعتد, _bksd, _هنوز_, бава,
   {{0xf8bf603e,0x65656037,0x7e7b8079,0x60c76012}},	//   _quén_, duhh, _nbup, _aljm,
   {{0x6aa416fe,0x1d0740de,0x3fe2807c,0x93bce0ba}},	// [1220] _inif, сети_, _বর্ষ, scăt,
   {{0xbcfb2004,0xb466260f,0x8e862049,0x386943f6}},	//   trée, _укол, _الده, agar_,
   {{0x64498105,0xfaff200e,0x0eba8099,0x7ce8020f}},	//   _beei, rtët_, луды_, yırl,
   {{0x91e6439e,0x6efd16ff,0xcebae1df,0x232a9700}},	//   _гоме, lébr, _miƙa_, годи_,
   {{0x7ebcc0e0,0xa3d9e960,0x9dba420e,0x2365e00a}},	//   _képv, _ठेस_, _сыну_, hulj_,
   {{0x954a6ca7,0x60dd1701,0x8fa67702,0x386d8058}},	//   _مشرق_, zism, _лаге, _ecer_,
   {{0x60dd1703,0xed3561d3,0x80a4c914,0xb05b1704}},	//   yism, _мэтэ, काले, shäi,
   {{0xa5bb4064,0xccf9c0c2,0xaa7b04d2,0x7e69ce36}},	//   _ogól, goś_, tným, ggep,
   {{0x7d045705,0x39aee03c,0xc6934095,0xf7438471}},	//   ilis, məsi_, לאה_, _нето,
   {{0x60dd0037,0xbcfb2057,0x443ee0cb,0xaa7b0089}},	//   wism, guél, ubt_, rným,
   {{0xaa7b0089,0x57b31706,0x8af065fc,0x60c29707}},	//   sným, ुन्ह, msəd, okom,
   {{0x635c60ba,0x48ab0731,0xbc1b6053,0xb87b0431}},	//   mănă, утом_, טויש, mník,
   {{0x9e4b21fc,0x6d5a203a,0x68e381af,0x02fa7708}},	//   ţămâ, átan, éndi, ्ताह_,
   {{0x7cfd0066,0x2904d709,0x7d04570a,0x38bc404a}},	//   térs, llma_, elis, _míru_,
   {{0xd6d836a6,0x7d04570b,0x91fce018,0x6285770c}},	//   стя_, flis, zgāj, veho,
   {{0x21291441,0x6602c00d,0x6b8d170d,0x6286170e}},	//   _tuah_, _kyok, _tsag, ceko,
   {{0x9ed9768a,0xb8d14029,0x63a9104e,0x7e7c6037}},	// [1230] амат_, _टच_, åend, _bbrp,
   {{0x59a8b244,0xa49b42d9,0xfaff23ac,0x80b881a6}},	//   कमार, _chòr, rtës_, _আগষ্,
   {{0x65656037,0x6d34202d,0x986540e0,0x39aee5fc}},	//   uuhh, _неэф, _ویسے_, fəsi_,
   {{0x7afaf70f,0x46a72292,0x6721a59c,0x2d9ce012}},	//   hott, खावह, _silj, _mrve_,
   {{0x68ed0167,0xdbe34057,0x62857710,0x68f98d8d}},	//   _mjad, _téño, peho, rowd,
   {{0x26def711,0x90c5a09e,0x644f1712,0xdce46143}},	//   jito_, юбле, haci, vtić,
   {{0x39aee03c,0xa3df2466,0x3ec48009,0x5fe00077}},	//   bəsi_, _देम_, ártó_, _पेनल,
   {{0x212b52dd,0xf8c94ba0,0x66c4e030,0x6b9b9713}},	//   _kuch_, रसिय, _bòko, _trug,
   {{0x752ae105,0x2d98e271,0xb05b00cb,0x7522c534}},	//   _aufz, æren_, nhäu, _dioz,
   {{0x4425a579,0xdb1c400e,0xb80de8c6,0x26c91280}},	//   _ugl_, tyrë, _हरदम_, _alao_,
   {{0xbef70010,0x2487a0d1,0x3f9ce012,0xe9df4019}},	//   ीतून_, menm_, _crvu_, _seúl_,
   {{0x224e2143,0x673bc052,0x6915c089,0x6458f714}},	//   _žfk_, ppuj, _všes, _edvi,
   {{0x2365e04d,0x232a0a0c,0xb05b404e,0x3495e45c}},	//   sulj_, роги_, _eläk, _мадр,
   {{0xa3158010,0x7e7d4105,0x7ebcc0fa,0x272f0106}},	//   तगुज_, _absp, _dépu, _dün_,
   {{0x7cfec0dd,0x24921715,0xdd1c81ce,0x60db9716}},	//   përt, _taym_, vážn, _omum,
   {{0xb6a343ca,0x764bc0e0,0x78a523d1,0x6458e066}},	//   мисл, _jegy, _enhv, _zdvi,
   {{0x644bd717,0x29120899,0x8b2640ff,0xcb6a4323}},	// [1240] _megi, _ihya_, ідже, разе_,
   {{0x6723f718,0x2905f719,0x7c656049,0x7ae9c5cf}},	//   _jinj, nlla_, كامل, hnet,
   {{0x39aee03c,0x60c9971a,0x25bfc17b,0xdd1c8066}},	//   təsi_, _blem, hyul_, rážn,
   {{0x7afbd629,0x3160571b,0x4427e037,0x764bd71c}},	//   jout, priz_, _lgn_, _negy,
   {{0x0caaa3a5,0x3f86602e,0x2d8f422e,0xddc880c2}},	//   итки_, ňou_, æget_, _żołn,
   {{0x60db8291,0x179b0087,0xe0df0024,0x25bfcbae}},	//   _emum, יינב, ziò_, dyul_,
   {{0x2912007d,0x60c292d6,0xb87b004a,0x68eda049}},	//   _ohya_, pkom, bníh, éada,
   {{0x68e9caca,0x68fbc968,0xa0678c4e,0x320ca4d2}},	//   gned, goud, _маса_, _vzdy_,
   {{0x2002c069,0x2cb8610a,0x2db7400b,0x3076a052}},	//   æki_, _kord_, ַלטן_, _мужс,
   {{0x68fc371d,0x60c4571e,0x7c3b62d1,0x6457c020}},	//   jord, hkim, _đurk, _ɗaiɗ,
   {{0xa2a7a6a8,0xa2b9a37f,0x6d5600ca,0x764bc009}},	//   चार्, ्सर्, _avya, _fegy,
   {{0x644bd71f,0x8afd00c2,0x7afaf720,0x4427f33c}},	//   _gegi, dręc, sott, _egn_,
   {{0x7c290012,0xae16c982,0x68fc2b28,0x99982013}},	//   žero, देशन_, ford, karų_,
   {{0x70dac0c5,0xd5b800db,0x6b82c425,0x67240194}},	//   _बगुल, іся_, _ipog, _eiij,
   {{0x4394252f,0x28bf4738,0xbcfb3721,0x6d586143}},	//   марс, _एकदि, quém, švaj,
   {{0x6568f722,0x629641e7,0x68e0ca88,0x6723f09d}},	//   mudh, gdyo, nimd, _zinj,
   {{0x62873723,0x6b82c1f6,0x3ce95724,0x6723f725}},	// [1250] pejo, _jpog, rnav_, _yinj,
   {{0x7afbc52c,0x394905c8,0x9c7cf5b3,0x6562815b}},	//   zout, _iwas_, biče, droh,
   {{0x3f824012,0xf09f4153,0x3ced8320,0x602de009}},	//   _epku_, _bhàt_, _pjev_, _hőmé,
   {{0x397be00b,0x7bc0c013,0x672d1726,0x6ab8e271}},	//   שטאנ, kymu, _kuaj, _lovf,
   {{0xa3cb010a,0xdc3f4326,0x644d0049,0x28a9c0a8}},	//   लनि_, níčk, _meai, कासि,
   {{0x6b8d5665,0x23694022,0x3ea6c013,0x3eb9491f}},	//   mwag, muaj_, _anot_, _host_,
   {{0xf2d2600b,0x387c2156,0x672bc00e,0x23694022}},	//   _װען_, _övre_, _sugj, luaj_,
   {{0x6603f727,0x644d0a98,0x65776022,0x24895728}},	//   _rynk, _neai, mtxh, neam_,
   {{0x6603f729,0x4427e07d,0x66e5e491,0x764bc0e0}},	//   _synk, _pgn_, зопа, _vegy,
   {{0x68e9d5cc,0x69c5e10a,0x644bd72a,0x68fbd3dc}},	//   sned, _ühek, _wegi, soud,
   {{0x39490a81,0x01bd807c,0x3eb94200,0x7641f72b}},	//   _awas_, _অধিদ, _oost_, rbly,
   {{0x644d1728,0xef0ec0ff,0x81e921a6,0x6723e0b1}},	//   _ceai, _їм_, _বরং_, _winj,
   {{0x672d00e6,0x59bd85c5,0x20040069,0x7643a022}},	//   _cuaj, ्निर, æmi_, obny,
   {{0x9c7ce49f,0x3a29172c,0x224d8171,0x2012a03c}},	//   tiče, _egap_, _leek_, əyib_,
   {{0x505a41ba,0x6d5520e0,0x8fa32471,0x65776048}},	//   йшая_, gsza, наре, jtxh,
   {{0x55bae095,0x2731a0c4,0xa3ab8026,0x3eb94e96}},	//   _למצו, _mán_, गमा_, _cost_,
   {{0x2ee04054,0x62960c57,0xab664866,0xdce3c299}},	// [1260] riif_, _iayo, явал, junč,
   {{0xdce3c490,0x7afc2025,0x26c5e013,0x80aa0acf}},	//   dunč, qort, nklo_, टावे,
   {{0xdebb2095,0xe9f9e067,0x224d82be,0x673b8796}},	//   _המיל, _đẻ_, _beek_, _atuj,
   {{0x6562972d,0x24895728,0xeb9f4271,0x186a972e}},	//   troh, ceam_, _frø_, сади_,
   {{0x200e209f,0x3eb8670b,0x765b8614,0x6e3b6106}},	//   šlić_, _tort_, _dduy, _şube,
   {{0x3eab617a,0x6b841682,0xcebae0a2,0x80d84077}},	//   ċità_, _mpig, _riƙo_, नोरे,
   {{0x7afd172f,0xf65f022e,0xe29a8474,0x753b8614}},	//   yost, mhæv_, _лав_, _etuz,
   {{0x62960abc,0x2731b730,0x3f9eb731,0x66cb203c}},	//   _nayo, _dán_, _vrtu_, _müka,
   {{0x7ae29732,0xb5fb4057,0xa3d4f733,0x68e0c181}},	//   miot, _edáf, _सेज_, rimd,
   {{0x672d00dd,0x68e1f734,0x4734f138,0x02c9439f}},	//   _ruaj, gild, мнос, _रत्न,
   {{0x644e6291,0x6aa8aa2f,0x78a8a86b,0x660645f0}},	//   _mebi, _indf, _indv, _lykk,
   {{0x7ae29735,0x44386194,0x6726407f,0x2347c0eb}},	//   niot, _lfr_, _nikj, _کلوپ_,
   {{0x98a780e4,0x2b40a23d,0x28a9c53a,0x8c43cff0}},	//   šići_, ćicu_, कारि, _чече,
   {{0x442901e2,0x6298ad53,0x645c600e,0x628aa09a}},	//   _wga_, ndvo, _ndri, nefo,
   {{0x6c7be095,0xe7842956,0x200520c4,0x4ddc6466}},	//   _האופ, нуто, æli_, _गेलै_,
   {{0x672d00dd,0x6606405d,0x96d840c2,0x2bde4857}},	//   _tuaj, _bykk, नोलॉ, _नेहा,
   {{0xaca34125,0x24895736,0x645c7737,0x60cd1738}},	// [1270] _nsụd, ream_, _bdri, _ilam,
   {{0x644e7739,0x290254b7,0xfaff0155,0xb05b00cb}},	//   _cebi, _ekka_, loë_, chär,
   {{0x2907a066,0x6295773a,0xdb0e8089,0x645c773b}},	//   vlna_, _vazo, ždýc, _ddri,
   {{0x2ee32200,0x7ae1e0d1,0xec6b45a7,0x6d56417b}},	//   lijf_, zilt, _урок_, bsya,
   {{0xc984573c,0x68e1e5fc,0x7e878013,0x644e71ef}},	//   _пури, yild, _įspė, _febi,
   {{0xc332400b,0x4444658f,0x2eba0158,0x2557a0ba}},	//   _בוך_, cb_, _उक्त, tăl_,
   {{0x386dc703,0xb05b0052,0x7ae1f73d,0xd164614a}},	//   tger_, tkäl, vilt, _пъти,
   {{0x7c29973e,0x7f59c90f,0x386dd73f,0x68e1eaaa}},	//   _uger, ојот_, uger_, wild,
   {{0x7aed4852,0xcd0280c2,0xa227a050,0x2f188052}},	//   inat, _dość_, _فراه, _хоть_,
   {{0x78bab740,0xf65f4065,0x5c74a583,0x67276b33}},	//   _gotv, _blæk_, _плут, _jijj,
   {{0x7aed552c,0x693c20a9,0x644562a1,0x208a1741}},	//   knat, _ičeg, ibhi, ойни_,
   {{0x2f146292,0xd00a001f,0xabfaa076,0x672774b7}},	//   mäge_, жеме_, _והער, _lijj,
   {{0x69c3b742,0x3ea7e098,0x2f1473a2,0xdce20018}},	//   lyne, _tnnt_, läge_, gulā,
   {{0x69080005,0x62961743,0x38732187,0x645d4e39}},	//   iñei, _wayo, _ccxr_, _adsi,
   {{0x1d07264d,0x46f601c7,0xe7372255,0x60cd0db2}},	//   фери_, _очит, дес_, _flam,
   {{0x6d564187,0x44387744,0x65645745,0x69d9410a}},	//   tsya, _sfr_, trih, _नइखी,
   {{0x628b9746,0x7d040a88,0x7bc3a261,0x443861f6}},	// [1280] dego, _ikis, hynu, _pfr_,
   {{0x3cfa6064,0x6d920927,0xa3bfa48b,0x39405747}},	//   ्तें_, ržać, ुना_, rpis_,
   {{0x644e6105,0xb4fae00b,0xb87b1284,0x628aa46b}},	//   _vebi, קלער, rnív, vefo,
   {{0x6e2d806e,0x656b8024,0x644f4a88,0x443a2012}},	//   žabn, fugh, _geci, _hfp_,
   {{0xe8faa87e,0x6d564058,0x6298a16d,0x764e7748}},	//   олд_, qsya, tdvo, _teby,
   {{0xdca3a471,0x29004108,0x64a3a1b1,0x6281a090}},	//   качи, loia_, кача, _cblo,
   {{0x6abaa143,0xf8d244e6,0x6d59c030,0x28b1eba0}},	//   _votf, _सताय, _avwa, जानि,
   {{0x78a98480,0x44383749,0x23c9c04b,0x2360a07f}},	//   _gnev, hcr_, िनंद, čij_,
   {{0xadba8049,0x225d40c2,0x2007ed5d,0x69d68026}},	//   _بهذا_, ówki_, _ayni_, _मेची,
   {{0x673e2579,0x2246974a,0x2900415a,0xc17ae14f}},	//   _otpj, lbok_, hoia_, оїм_,
   {{0x7ae4574b,0x68ed574c,0x29004534,0xda6fd741}},	//   kiit, ynad, koia_, _ия_,
   {{0xbfc6c1e1,0x6297374d,0x6d58ab48,0x7d02c167}},	//   _обек, _saxo, msva, _ukos,
   {{0xb33b401f,0x351bc00b,0x443941e2,0xc178e03b}},	//   _orça, _וואנ, _rfs_, stė_,
   {{0x7c84249a,0xbcfb2057,0x3cfa60c2,0x3166974e}},	//   кусе, ntéx, ्तों_, iroz_,
   {{0x442b574f,0x45d5211f,0x2ee322be,0x67d5214f}},	//   _pgc_, ховс, rijf_, хову,
   {{0x23668143,0x66d02262,0x68ed5750,0x6608a187}},	//   kroj_, _räke, unad, _mydk,
   {{0x6282c1b6,0x6298f751,0x02df40c5,0xb5fb0009}},	// [1290] _mboo, _kavo, _नगीन, rgás,
   {{0x6728a00a,0x2904958c,0x6d58b752,0x442b4071}},	//   _nidj, _akma_, ksva, _wgc_,
   {{0x644f5753,0x7d09d754,0x68e45755,0x78a9806e}},	//   _teci, yles, biid, _pnev,
   {{0x20090b39,0x21290037,0x645d4065,0x7d04005d}},	//   _kyai_, _jiah_, _udsi, _xkis,
   {{0x7d09d756,0x2129005d,0x7d00d757,0x2d4d01ce}},	//   vles, _miah_, doms, nže_,
   {{0x656b9758,0xe0576555,0x6d41e2f7,0xe802c148}},	//   rugh, _آیات_, ypla, _लड़ा_,
   {{0x6d58b02d,0x98a4b044,0x20c9e3f6,0x20116614}},	//   gsva, _sumă_, _dúil_, _uzzi_,
   {{0x236680e4,0x1fb5c470,0x64553759,0x26c94012}},	//   broj_, есор, hazi, nkao_,
   {{0xf770833e,0x320901e7,0x7bcea0cb,0x6d4d0291}},	//   _نال_, _nyay_, _übun, _nwaa,
   {{0x6298e65f,0xb881e066,0x6f09d75a,0x68e3b75b}},	//   _cavo, _číse, slec, qind,
   {{0x656d575c,0x6d598d53,0xa3df2046,0xdcfba0a9}},	//   huah, lswa, _देल_, _usuđ,
   {{0xdb00a733,0x6d4d0035,0xcdda6053,0x5fd8a04b}},	//   _armè, _bwaa, פֿיר, _भेटल,
   {{0x61fb2121,0x2be007af,0x2bc827d9,0x29016046}},	//   şull, _पेशा, रन्थ, koha_,
   {{0x2bb6aba0,0x765520c2,0x7529975d,0x6d422143}},	//   _अपमा, gazy, _liez, _čoab,
   {{0x6f01e06e,0x7d16175e,0x2d94e056,0x38c8463b}},	//   molc, _thys, _арыс, واری_,
   {{0x6d59975f,0xba23202d,0x3f87e037,0xe814e029}},	//   kswa, удск, _ipnu_, _डरता_,
   {{0x66099760,0xe046682b,0x7ae444c4,0x68e452e7}},	// [12a0] _nyek, ензи, riit, riid,
   {{0x442d9761,0x60c9d762,0x26d240b1,0x6306668c}},	//   _age_, hkem, shyo_, روال,
   {{0x22520561,0xdcffc04a,0x7bc6087c,0xb4cc208d}},	//   _keyk_, ívěs, lyku, लसी_,
   {{0x66c600c4,0xddc0804a,0x660994b7,0x20cac2d9}},	//   _bóki, _zemř, _byek, _cùil_,
   {{0x19948936,0x64565763,0x6da381c7,0x78bc6ffe}},	//   таля, mayi, лица, _torv,
   {{0x765641df,0x7ae61764,0x657bc0ae,0x2360807f}},	//   layy, hikt, dtuh, šijo_,
   {{0x9c839520,0x442d8057,0x7529805d,0x6f01f21e}},	//   ščar, _fge_, _fiez, dolc,
   {{0x42538ca7,0x2b4007a0,0xe297841b,0x7ae1a1f6}},	//   _منفر, _otic_, _пас_, _emlt,
   {{0x6d4451e1,0xe3b2c243,0x68e605fc,0x6f00d765}},	//   npia, ارع_, dikd, romc,
   {{0x442ca07d,0x6e2d1766,0xddc986be,0xdbd6a052}},	//   _ugd_, _sgab, _uceš, _pääo,
   {{0x28f908e9,0xa803203c,0x62840090,0x7b05c057}},	//   день_, _çıxm, _bbio, góus,
   {{0x20c0f03c,0xbcfb23bb,0x212a63f6,0x93f48321}},	//   _còir_, rrém, _libh_, _अशाच_,
   {{0xdb00a004,0x68e2c00f,0x64565767,0x212b8171}},	//   _armé, _imod, dayi, _écht_,
   {{0x2f97c095,0xab64a669,0x629aa265,0x212a6c8a}},	//   _נכון_, _grüß, _jato, _nibh_,
   {{0x7ae60d87,0x7d02859f,0x2f120009,0x25a04012}},	//   bikt, koos, sága_, evil_,
   {{0x6d4d1308,0x7c25e066,0x442ee187,0x212a658f}},	//   _twaa, _úhra, _hgf_, _aibh_,
   {{0x6d5c7768,0x7c84004e,0xc2996905,0x2d9e2249}},	// [12b0] _avra, _суще, мках_, åter_,
   {{0x3a2d8057,0x628400c2,0x656d405d,0x765641e7}},	//   _sgep_, _zbio, ruah, aayy,
   {{0x2d877769,0xf653e053,0x2901776a,0x6910659f}},	//   ïne_, רצע_, roha_, mäel,
   {{0x2905a066,0x394d808b,0x59b0c5cc,0x68e722be}},	//   _skla_, _pwes_, जमार, lijd,
   {{0x2249576b,0x6d59976c,0x2cbea17b,0x6d40805d}},	//   mbak_, uswa, _botd_, _ctma,
   {{0x7529976d,0xda62a54a,0x68e7376e,0x2249462c}},	//   _wiez, авши, nijd, lbak_,
   {{0x2bd9ccb5,0x2902176f,0x8aa4614a,0x973ca012}},	//   _बेजा, yoka_, _сряд, _prća,
   {{0x6564800a,0x22495770,0xddcd017a,0xd05525fc}},	//   šiha, nbak_, _bbaż, rizə,
   {{0x629ab771,0xa283a050,0x629d01cd,0x248dd772}},	//   _fato, _میشو, ddso, reem_,
   {{0x2369429f,0x2579c0d1,0xc3c8c13a,0x63a41773}},	//   iraj_, rèl_, عظيم_, _rrin,
   {{0xdd91a5d1,0x186a10da,0x3a75c8f3,0x8602a050}},	//   _خوا_, мани_, _алер, _پژوه,
   {{0x6d41a1f6,0x7ae6e187,0x628f048c,0x628520cb}},	//   _itla, éktr, geco, _abho,
   {{0x7d0d5774,0x2d8c217a,0x628e2aa8,0xda0df775}},	//   dlas, ħdem_, tebo, _हरकत_,
   {{0xa3dac7af,0x2369405d,0x200c0018,0xdce3c0ba}},	//   _डेट_, draj_, ādi_, bună,
   {{0x29194187,0xb4bfe98a,0xfaff23ac,0x2fc7a1e7}},	//   _bhsa_, ीसी_, prën_, nyng_,
   {{0x753ca0e0,0x7649c9a9,0x7d03b776,0xdb02e187}},	//   _érze, nbey, hons, _aroè,
   {{0x7ae72143,0x68e41777,0xb4d2527e,0x1d0742ab}},	// [12c0] bijt, _imid, _वती_, тети_,
   {{0x29033778,0x7d0d4046,0x6d445779,0x2fc68022}},	//   coja_, alas, rpia, vyog_,
   {{0x6d444556,0x2cbf8155,0xc00fe119,0x6d456119}},	//   spia, _boud_, _đuối_, gpha,
   {{0x25ad406e,0xd94688d4,0x0ea949df,0x0b8a8084}},	//   _šele_, веди, _चोपड, дски_,
   {{0x6bd6801e,0x9393813a,0xa3c20046,0x6d45728c}},	//   ختار, لجوا, ंहि_, apha,
   {{0x25a480ae,0xf8bf6067,0x7d076187,0xe283a926}},	//   _vrml_, _quét_, _gkjs, илчи,
   {{0x2fc6805f,0xdb1d2009,0xd91ac052,0xfce3695a}},	//   syog_, nysá, мьи_, _торо,
   {{0xa3c21706,0x6d5af77a,0x69c36052,0x23768711}},	//   ंहा_, vsta, änee, _لائح,
   {{0x57cae843,0x09cae437,0xbcfb2066,0x6282977b}},	//   ान्ह, ान्य, bréh, mfoo,
   {{0x9346a834,0x3ebf8171,0x26174010,0x7d0d577c}},	//   _анже, _zout_, पेटी_, zlas,
   {{0xddc8a064,0x7d0d55c3,0x290dca03,0x6f0d577d}},	//   _wedł, ylas, blea_, ylac,
   {{0x290dd77e,0x7769c03e,0x61faa071,0x77cacfb9}},	//   clea_, brex, _ixtl, _олег_,
   {{0x629d09ee,0x291a258f,0xc69381a1,0x656f0071}},	//   rdso, _bhpa_, באר_, uuch,
   {{0x9abca227,0x59b6b77f,0xd6d0e3f1,0xaa642423}},	//   _biċi, _अपार, _دقت_, итск,
   {{0x3cff5780,0xa9c4265d,0xe80f0292,0x03c422a3}},	//   लवले_, астк, _सरका_, астм,
   {{0x656aa049,0x48bd807c,0xbcfb3781,0x6f03b782}},	//   irfh, _আগ্র, guér, zonc,
   {{0xe7bd807c,0x20c2013a,0x5c0741e1,0x7658b2ec}},	// [12d0] _অধ্য, _tóir_, тява, kavy,
   {{0x316955bf,0x68e8e11d,0x22494b83,0x6e456049}},	//   rraz_, nidd, sbak_, انضم,
   {{0x69dae186,0x60c09783,0x6e946450,0x44276052}},	//   nzte, _bomm, риху, än_,
   {{0x26c00057,0xdea401df,0x63a64012,0xf8bf6071}},	//   _xoio_, _bunƙ, _frkn, _pués_,
   {{0xa3ad49de,0x6281f784,0xdea400a2,0x6d41ab6d}},	//   _कपट_, yflo, _cunƙ, _stla,
   {{0xf7736043,0x3ebf80d1,0x660d02ad,0x3ead869b}},	//   _پاس_, _wout_, _myak, _wnet_,
   {{0x6d42ca03,0xf52787ab,0x81e6a1a6,0x443eb785}},	//   _atoa, _афан, _যুব_, _dft_,
   {{0xe3a6a050,0x6d5f1631,0x2cad81cd,0x39468022}},	//   اشوی, _ovqa, _uned_, bpos_,
   {{0x629c733d,0x7658a167,0xdd94853f,0x60cd5786}},	//   _yaro, bavy, _каты, ikam,
   {{0xb4bfe046,0x6acc0077,0x25a6c030,0xbcfb3787}},	//   ीसे_, ास्र, _drol_, bréi,
   {{0x6d42cb8a,0x64557788,0x4b2600e7,0x03260143}},	//   _etoa, _mezi, лмов, лдон,
   {{0x6146168a,0x60c1b71d,0x25a6c057,0x673563ee}},	//   лема, _holm, _frol_, _muzj,
   {{0x20f89789,0x7d04578a,0x273980d1,0x958301ba}},	//   nčia_, vois, _jèn_, бляе,
   {{0x320c2064,0x6459978b,0xe689e049,0x5a47e362}},	//   żdym_, hawi, _أنثى_, _рэда,
   {{0x63a64098,0x6b6320ff,0x629c73c9,0x660d0bd4}},	//   _srkn, йкра, _raro, _eyak,
   {{0x7b106105,0x6d5c378c,0x6abbc1fd,0x629c65d1}},	//   räum, rsra, njuf, _saro,
   {{0xb928c291,0x21674878,0x69dbc0e6,0x69c9d78d}},	// [12e0] _akwụ_, лити_, nzue, nyee,
   {{0x629c778e,0x60cd480c,0x3cff429f,0x93b70095}},	//   _qaro, akam, čuva_, _עליו_,
   {{0x320d8054,0x44316079,0x6458b78f,0x160ac028}},	//   _ayey_, _dgz_, vavi, _हुनर_,
   {{0x3a3ea1e2,0x7d061790,0x2258a16d,0xdd126041}},	//   _sftp_, noks, _žrk_, _kļūs,
   {{0x7658b791,0x212d8187,0x7d1b9792,0x2904d793}},	//   tavy, _dieh_, _dhus, voma_,
   {{0x64560082,0x443f8096,0x75357794,0x629c7795}},	//   _leyi, _efu_, _fuzz, _uaro,
   {{0x75357796,0xf72ac1fc,0x7ae9cd53,0x60c1aa88}},	//   _guzz, нций_, fiet, _dolm,
   {{0x5a34cd9a,0x26c25797,0x28a4a857,0x9634c1bc}},	//   шнит, _joko_, _गोरि, шниц,
   {{0x6676a0a4,0x249dc048,0x8fa382dd,0x5046a39d}},	//   _مدار, _dawm_, _лате, _безб,
   {{0xc3334087,0x7afce06e,0x2738a005,0xf9934076}},	//   זוז_, črto, _tén_, צרת_,
   {{0x69c9c054,0x660d08a4,0x33f6a04e,0x2ef50f2f}},	//   ayee, _syak, _счас, изор,
   {{0x273984b7,0x81e6007c,0x672e613e,0x2ca0417b}},	//   _yèn_, _বুধ_, _libj, jdid_,
   {{0xd7f80834,0x2d9a2030,0x9f3502f7,0x629e3798}},	//   гур_, _aspe_, регі, _bapo,
   {{0x645980c2,0x249dc022,0x2d51e06e,0x53340b2d}},	//   zawi, _zawm_, bše_, серт,
   {{0xb2ab473a,0x672d0022,0xe4e4271b,0x6d46e3de}},	//   нтаж_, _tiaj, сіян, ćkas,
   {{0x60cd4013,0x75356197,0x2fc94d87,0x44320194}},	//   ukam, _ruzz, tyag_, _ggy_,
   {{0xa855633f,0x660d00bb,0x7d1c6090,0x75356425}},	// [12f0] икач, _uyak, _bhrs, _suzz,
   {{0xdc3ce03b,0x7d1b9799,0x68e9c018,0x25a905c8}},	//   kšči, _shus, zied, _iral_,
   {{0xdd9160a4,0xe7ebcbc5,0x25e6c021,0xa29fa10a}},	//   توا_, _जेना_, _जेसी_, _गोग्,
   {{0xdced2227,0x25a90181,0x3dc9408b,0x994806ec}},	//   _bsaħ, _kral_, pyaw_, _جلیل_,
   {{0x629e379a,0x60c1ac65,0xeb9987f8,0x69c6c0ff}},	//   _yapo, _polm, тил_, økel,
   {{0xa969a103,0x2169b64b,0x656d579b,0x6b8d0096}},	//   вика_, вики_, mrah, _mpag,
   {{0x2905e30b,0x2fc76277,0x6f1b928c,0x08d5c9fd}},	//   vola_, ängd_, _thuc, иция,
   {{0x443f979c,0x7d1b8296,0x443327d3,0x2905f79d}},	//   _ufu_, _uhus, _lgx_, wola_,
   {{0x26c36361,0x60c1b79e,0x39495308,0xdddae066}},	//   _kojo_, _tolm, npas_, latň,
   {{0x645af79f,0x2ed2448b,0x656d40c7,0xfaf3a0d0}},	//   gati, _सत्त, irah, _اثر_,
   {{0x6b8d0f3c,0x2d816d7e,0x2d51e480,0x645600d1}},	//   _apag, nthe_, uše_, _peyi,
   {{0xb605e082,0x2023a17a,0xd5b1cca7,0x656d57a0}},	//   _aláà, ħriġ_, _وفا_, krah,
   {{0x2d98e271,0x63a98a95,0x629e37a1,0x60dd000e}},	//   ærer_, _jren, _papo, ërma,
   {{0x26c2506c,0x249f84e2,0x6d5e77a2,0xa069f0da}},	//   _soko_, _laum_, yspa, _рака_,
   {{0x6d49d7a3,0x672e607f,0x68eb8006,0x7aeb8114}},	//   lpea, _ribj, kigd, kigt,
   {{0xd7fae095,0x629e20ce,0x765bc114,0x44332227}},	//   _בהצל, _wapo, nauy, _egx_,
   {{0x628440fd,0xa01b0e34,0xee374fb5,0x4127462a}},	// [1300] rfio, nföl, рну_, рото_,
   {{0x62899280,0x2ed2c39f,0xe3e72043,0x3865b7a4}},	//   _abeo, _तत्त, اکین_, _ndlr_,
   {{0xad9b403e,0xb4db65df,0x799b97a5,0x656d57a6}},	//   _axúd, _itàl, _asuw, arah,
   {{0xb3584043,0xa96762af,0x200c003c,0xdca649b1}},	//   _میرا_, рица_, ədir_, _тами,
   {{0xac0781fc,0x24078844,0x660fc105,0xe2974368}},	//   анца_, анци_, ückl, _тая_,
   {{0x4ed5639e,0x316dd1fa,0x6d5e77a7,0x3f82017b}},	//   _люст, drez_, pspa, itku_,
   {{0x63a997a8,0xd5b26009,0x249f8090,0x8c3d9412}},	//   _eren, _ظفر_, _faum_, _başd,
   {{0x7af6404e,0xdb1c4249,0x2489a29c,0x291dd1da}},	//   nnyt, byrå, đama_, _chwa_,
   {{0x24869019,0x9998207f,0x68f641cd,0x6441a1cd}},	//   mfom_, jbrž_, inyd, _ffli,
   {{0xdbdca066,0x25a697a9,0x2bc9204b,0x63a8a06e}},	//   lším, mvol_, रहमा, _trdn,
   {{0x60c40748,0x6aa08605,0xa3d67706,0x20f8803b}},	//   _boim, _kamf, िनि_, nčio_,
   {{0x7afb407f,0xdb00a0ba,0x236dcbe5,0x91b7c0eb}},	//   čutk, _urmâ, brej_, _چطور_,
   {{0x6d4521f6,0x6aa08037,0xf1022914,0x98bf0018}},	//   _stha, _mamf, लकूद_, lstī_,
   {{0x629f17aa,0xa3d78918,0x66d1468f,0x6d5ced70}},	//   _waqo, ानत_, _påko, áras,
   {{0x629f0037,0x9c7ce274,0x3945231d,0x0dcae90f}},	//   _taqo, jiči, ëls_, _јули_,
   {{0x9c7ce06f,0x273c37ab,0x764d4561,0x3946c0c2}},	//   diči, _dín_, ubay, _ktos_,
   {{0x249f97ac,0x6135a03b,0x7658e052,0x94194df5}},	// [1310] _raum_, _išle, _kevy, ужат_,
   {{0xd05c203c,0xf64777ad,0x2e3d40f9,0xba99214f}},	//   kirə, рхан, _báfó_, _своє_,
   {{0x7aeb8c8f,0x8c09007c,0x66d5ca84,0x200740c2}},	//   tigt, রেশন_, _láka, łni_,
   {{0x3f8161cd,0x249f8286,0xd05c203c,0x25a6006e}},	//   rthu_, _qaum_, dirə, _šoli_,
   {{0x26c48167,0x3946c022,0x6441a105,0xe5a5895a}},	//   _domo_, _ntos_, _pfli, сили,
   {{0x61fb37ae,0x270fc8b1,0x5887a0fb,0xe9d88013}},	//   şulu, ात्र_, рыда, шкі_,
   {{0x249f805f,0x7013c07c,0xf994200b,0x7158a0fb}},	//   _taum_, _হলেও_, ַרץ_, арыс_,
   {{0x765d005d,0x316dc004,0x04e7a07c,0xc3342095}},	//   jasy, trez_, খকের_, חוק_,
   {{0x81e4e07c,0x765d17af,0x3946c17b,0xdce74064}},	//   _ভুল_, dasy, _ctos_, cują,
   {{0x71d84095,0x3ea017b0,0x8387a04e,0x6d49d7b1}},	//   יוחד_, _sait_, _выде, rpea,
   {{0x2d8337b2,0x212fc28f,0x7658f7b3,0x765c37b4}},	//   jtje_, _tigh_, _devy, vary,
   {{0xf8dbc10a,0x2ca0005d,0x32d9a030,0xf09f57b5}},	//   _बतिय, _qaid_, _dèye_, _thày_,
   {{0x273c317c,0xdca5f7b6,0x7d0d0037,0x2bba2eda}},	//   _sín_, _гали, _dkas, _उपहा,
   {{0x2cbfd7b7,0x6459d7b8,0x7d09c1cd,0xdddd40c2}},	//   ljud_, _hewi, loes, _odsł,
   {{0x68ed40e2,0x98dbc20b,0x7ae997b9,0x63abc037}},	//   fiad, _बताए, _omet, _hrgn,
   {{0x3d09a010,0xcd2a51a8,0x273c37ba,0x798280c2}},	//   ाकडे_, ужбе_, _vín_, ytow,
   {{0x661b8291,0x693c2320,0x645c37bb,0x2bba2180}},	// [1320] _nzuk, _ičem, pari, _उपवा,
   {{0x273c2016,0x6441f7bc,0xd05d003c,0x2eedd04d}},	//   _tín_, ncli, disə, hief_,
   {{0x68ed57bd,0x1a9b200b,0x225877be,0x20f88391}},	//   biad, _גייע, _verk_, učio_,
   {{0x291ea480,0xdd8f619a,0x693ae227,0x63bce262}},	//   _shta_, عون_, _bċej, ärni,
   {{0x20f88013,0x787b000b,0x60dbd7bf,0x68fb8011}},	//   sčio_, אָוו, dhum, _djud,
   {{0x290a37c0,0x6cd6619a,0x398085df,0xd05c203c}},	//   noba_, _اقسا, ròs_, tirə,
   {{0x2722a016,0x7659c31d,0xddc1a009,0x60c12069}},	//   _lưng_, _bewy, _belő, ölmi,
   {{0x3ea243e0,0xe81ea0c2,0x7afb8156,0x60dbc114}},	//   _jakt_, येगा_, _gjut, ghum,
   {{0x798457c1,0xb5fb4031,0x7bce2066,0x3ea243e0}},	//   ntiw, _adáj, hybu, _makt_,
   {{0x7afb806e,0xe1ff4019,0x644414b7,0x764282a8}},	//   _zjut, _odón_, _afii, lcoy,
   {{0xac18e0d7,0x290a2b46,0xc0e6c04f,0x20d42052}},	//   рону_, doba_, _ложк, _päin_,
   {{0xdb08c057,0x2ed56ff1,0x693c2066,0xf79ac711}},	//   _ordé, _धत्त, _včel, _منصب_,
   {{0x3946c4ec,0x7643e037,0x629657c2,0x6aa441cd}},	//   _utos_, _ffny, deyo, ddif,
   {{0x6e360009,0x673ab7c3,0x2eeea05d,0x1bd4e808}},	//   _egyb, _kutj, niff_, _моля,
   {{0x6ce7084f,0x60c64488,0x67d43391,0x7d0d17c4}},	//   _гіпе, _bokm, пору, _tkas,
   {{0x6d5601cd,0x78a2c067,0x2ba9a077,0x2f44e088}},	//   _fwya, _jaov, किता, _ịgwa_,
   {{0x290a37c5,0xdcdce026,0x753ab7c6,0x799e2163}},	// [1330] boba_, यसपछ, _lutz, _espw,
   {{0xadebc4ef,0x2738a067,0xccf8e04a,0xa49b40f9}},	//   _जइसन_, _tĩnh_, nně_, _akòt,
   {{0x291f8048,0x26c5b7c7,0xa2bf6c87,0x999969af}},	//   _phua_, _rolo_, लॉग्, ркет_,
   {{0xd126c68c,0x78a2c6ca,0x48158e31,0x60dbc0bb}},	//   _زم_, _naov, омес, xhum,
   {{0x6c7a400b,0x91b6a077,0x2f0f60cb,0x26c5b7c8}},	//   _דארפ, _अपॉइ, fügt_, _polo_,
   {{0x7f4d4071,0x3ea257c9,0x9fc9a338,0xe8f8a2cb}},	//   mpaq, _zakt_, игла_, блі_,
   {{0xddd520c2,0x38690020,0x3cedc02e,0x9db9a099}},	//   lazł, _odar_, tiev_, рылу_,
   {{0x2ca366a6,0x63b46066,0x20d1c049,0x78a1a3c5}},	//   _hajd_, šený, _táim_, _walv,
   {{0xdce9e42e,0x39490022,0x3f9ea2bb,0x6d4d4b6c}},	//   sreč, _ntas_, _estu_, npaa,
   {{0xdce9f7ca,0x98f7a54f,0xab65e841,0x2d9f8037}},	//   preč, _اثرا, овол, _isue_,
   {{0xb4db60f9,0x6441f7cb,0xed59e60f,0xeaba095a}},	//   _atàk, rcli, јом_, айн_,
   {{0x6b8561cd,0xe80ac077,0x290a200f,0x7b1060cb}},	//   ithg, _हुवा_, woba_, läut,
   {{0x64586069,0xdd94c0db,0x628d0090,0x2b4900d5}},	//   ðvik, _нацы, _dbao, _ctac_,
   {{0x201dc0bb,0x60c657cc,0x657761fb,0x69ce2056}},	//   _izwi_, _sokm, kuxh, tybe,
   {{0xe5a32486,0xd62a2df6,0x2738a067,0x07a32407}},	//   мири, рове_, _vũng_, марн,
   {{0x25ad97cd,0x645b97ce,0x7e698291,0xddc760c2}},	//   _orel_, _neui, _ndep, _wejś,
   {{0x27060626,0xa3e70010,0x63a4ca60,0x78a457cf}},	// [1340] रवीर_, _येऊ_, _áint, rdiv,
   {{0x798455c5,0x66f20018,0xe8e0e119,0x186a6471}},	//   rtiw, rāku, _thụy_, ражи_,
   {{0xfc3f0359,0x645ab7d0,0x6d4997d1,0xdb0421de}},	//   ldía_, _reti, _atea, _triâ,
   {{0x41aa8967,0xccf8e026,0xb7c060f9,0x753b81b6}},	//   ивен_, zně_, _aṣá, _buuz,
   {{0xb4ca8029,0x7cf3417a,0x386057d2,0xa2c12077}},	//   _लकी_, għru, mair_, रॉक्,
   {{0x2d8525df,0x765dc069,0xdb6aa691,0x7d1657d3}},	//   àleg_, ðsyn, арил_, llys,
   {{0x63a9d7d4,0x8c3b4105,0x628e61f6,0x645c694f}},	//   even, _maßn, _ibbo, _ieri,
   {{0xeeb8c6bd,0x8bfc21a6,0x32d8c18c,0x398417d5}},	//   слиш_, _ইরান_, _béya_, kös_,
   {{0x656457d6,0xdd90c25b,0x2918c018,0x66fc8364}},	//   nsih, رود_, ēra_, lčko,
   {{0xd90de050,0x60c297d7,0x8574e54a,0x2498214f}},	//   هین_, ljom, плох, jerm_,
   {{0x26c7f7d8,0x2d9ea265,0xf8bf41bf,0x6d48a4a4}},	//   _dono_, _uste_, _miér_, _utda,
   {{0x60c297d9,0x645c77da,0x39490019,0x6298b7db}},	//   njom, _leri, _ptas_, levo,
   {{0xccf8e026,0x290b08d4,0x6aa401f6,0xa3ae4148}},	//   pně_, roca_, _daif, किफ_,
   {{0xe297e247,0xe7f28148,0x644657dc,0x6aa3e0fd}},	//   _мач_, _आइना_, _afki, _ganf,
   {{0x753c605d,0x518437dd,0x764440a2,0x24800733}},	//   _nurz, мута, fciy, _fcim_,
   {{0x444477de,0x63a4c057,0x6d46a143,0xdcee4018}},	//   ec_, _áins, _čkal, tubā,
   {{0x26c7f7df,0x3949c3ac,0xb33ca13e,0x62976089}},	// [1350] _yono_, _çast_, _irħu, texo,
   {{0x6d4d57e0,0x63ae6090,0x645b80fa,0x66d920f9}},	//   rpaa, _brbn, _seui, _fìka,
   {{0xd9eaa5aa,0x66ca4089,0x27e62020,0x3ce2e046}},	//   _झेलत_, _výkr, _ƙone_, _ओतने_,
   {{0x6721a098,0x63a9d593,0x8f3544d7,0x24990098}},	//   _shlj, yven, _немц, nesm_,
   {{0xa4f94010,0x443940ce,0xdce7619f,0x317917e1}},	//   ्कीच_, _igs_, şlıc, nusz_,
   {{0xe739b7e2,0x8c3d8746,0x6722c261,0x95cb6850}},	//   бек_, _daşa, _ahoj, _куба_,
   {{0xd378e0a9,0x39840009,0x395861cd,0x7b6477e3}},	//   juć_, zös_, _gwrs_, _отте,
   {{0xadc44031,0xb4d5c466,0x645d57e4,0x3a394143}},	//   _afẹs, हसे_, _jesi, _jgsp_,
   {{0x78a417e5,0x29030cfd,0xf3f9c0ba,0xc8ff61a6}},	//   _raiv, čkal_, faţa_, ্গীত_,
   {{0x2d85e42c,0x7aed0547,0x6efec041,0x753d553e}},	//   ttle_, _amat, rība, _musz,
   {{0x753d57e6,0x753577e7,0xa0a60143,0x66dda187}},	//   _lusz, _mizz, панд, _cèke,
   {{0x2b4b40ae,0xbddb4061,0x644572d4,0x2a604022}},	//   _otcc_, _afèm, hchi, xaib_,
   {{0x38604733,0x7aed0e01,0x6aa3e009,0x7de26009}},	//   vair_, _dmat, _tanf, _kísé,
   {{0x765d417b,0xb5fdc00a,0x64456cb8,0x398417e8}},	//   _aesy, gaše, jchi, rös_,
   {{0x44386187,0x2467e009,0x60232312,0x444477e9}},	//   _rgr_, _című_, едра, vc_,
   {{0xa3e668a2,0x934645a4,0x27f8e02e,0x2b594227}},	//   _बेग_, знае, úrne_, _bwsc_,
   {{0xb4ca00a8,0x7ce077ea,0x6d41e5fc,0x67357099}},	// [1360] ोसी_, _jörg, lqla, _bizj,
   {{0xb5fd8098,0x83fce29c,0x6fb34049,0x7ce06069}},	//   _kešf, sađe, عملا, _mörg,
   {{0x765d4435,0x7aed00e2,0x2baeea2a,0xbe3b2076}},	//   _fesy, _ymat, टिया, _לעית,
   {{0x629987ff,0x6445772f,0x7e60c5df,0x645c77eb}},	//   gewo, achi, xamp, _weri,
   {{0x673d46ca,0x673c60e8,0x7ae38b83,0x753c60cb}},	//   _gusj, _wurj, ënta, _wurz,
   {{0x59cbe4f6,0x2b5861de,0x9879216d,0xdb0be017}},	//   ाहार, _twrc_, ršću_, _urgè,
   {{0x60db97ec,0x6d59d7ed,0x8af0603c,0x62998d53}},	//   _flum, _awwa, ssəs, bewo,
   {{0xa3cc010a,0x60d647b9,0x29120800,0x681380c2}},	//   लहा_, nkym, _nkya_, _będą,
   {{0xed3581d3,0x2002c03c,0xe166c049,0x6f038057}},	//   _цэрэ, çki_, أدبي, énce,
   {{0xaa7b406f,0x07a6b0f6,0x03a6a474,0xa0c9a13a}},	//   _umýv, _назн, _низо, _وذلك_,
   {{0xf1f7c050,0x6722d7ee,0x7afbc3ab,0x1bf28ba0}},	//   قعیت_, _thoj, bnut, _आइडल_,
   {{0xda2080c5,0xdce466ca,0xdee3c192,0x66e3d7ef}},	//   _बरात_, brić, _похи, _поха,
   {{0xbcfb604a,0x6f0d40ba,0xdb0e83ac,0x765d416f}},	//   _svém, voac, _arbë, _resy,
   {{0x3a200361,0x753d469f,0x2012a03c,0x63bce156}},	//   _dzip_, _rusz, əyir_, ärns,
   {{0x7535711a,0x0f1b413a,0x22468037,0x9c7ce066}},	//   _rizz, مغرب_, kcok_, sičs,
   {{0x290ea0f9,0x753d4791,0x80c12077,0x2a7ee057}},	//   hofa_, _pusz, रॉजे, lgtb_,
   {{0x60c9854c,0xfc3f4d64,0x4735603b,0x68fd0156}},	// [1370] _roem, _caía_, днас, mnsd,
   {{0x60c997f0,0x692ac0a3,0x2d87a066,0x291917f1}},	//   _soem, _křes, ytne_, llsa_,
   {{0x6ce4614f,0xaa7b0089,0xddcde013,0x7afe0431}},	//   хіте, chýc, _įkūr, čstv,
   {{0x6463629c,0x60c44098,0xdb040271,0x3863217a}},	//   _štić, cjim, _ernæ, lajr_,
   {{0x6d4d0037,0x0b44814f,0x290ea912,0x6ec0d7f2}},	//   _jtaa, енін, fofa_, वानु,
   {{0x213ea58f,0x7c39c1cd,0xe8224077,0x7ff420eb}},	//   _buth_, _sgwr, _मरता_, _آسیا,
   {{0xf8b26557,0x6282c1f6,0x90d5c119,0x60c98155}},	//   _בשם_, _bcoo, _dùn, _toem,
   {{0x2ca957f3,0xdce2e143,0x9f5f80e0,0xdce463de}},	//   ndad_, _dvoč, áról_, trić,
   {{0xb05b0cad,0x2ca944cd,0x26cb42f8,0x3ea5a271}},	//   tjän, idad_, _moco_, _talt_,
   {{0x7ce063df,0xbddb4030,0xab5dc0c2,0x658aa5fc}},	//   _görd, _afèk, wyżs, _zəhm,
   {{0xf771c0d0,0x7e61f7f4,0x5f0600ff,0x443a2013}},	//   راک_, ralp, дзна, _rgp_,
   {{0xe3e4807c,0x66d02156,0x7afd102d,0xb4f94148}},	//   _ফুটব, _läkt, gnst, ्कोप_,
   {{0xb91580f9,0x823603f1,0xa7fb0019,0x61e220e8}},	//   _bibẹ_, بردا, taña, _ƙolo,
   {{0xed59e1e3,0x66d26069,0xe8e0c067,0x78a9d7f5}},	//   _док_, _tæki, ượt_, ldev,
   {{0x044647ca,0xaac4e6ec,0x63ad57f6,0x672417f7}},	//   дебн, _ستون, evan, _thij,
   {{0x6ee073a2,0x225f965a,0x6e3b97f8,0x26ca77f9}},	//   _möbe, _neuk_, _ngub, _sobo_,
   {{0x59ba37fa,0x442000b1,0x60d64013,0x2d8941e7}},	// [1380] _उपकर, _uzi_, rkym, gtae_,
   {{0x645f000e,0x2366816d,0x7d09407f,0x6b89c108}},	//   _zeqi, vsoj_, česa, iteg,
   {{0x26cb57fb,0xe9df02a8,0x290f8241,0x6283e071}},	//   _foco_, ncún_, foga_, _mcno,
   {{0x3ea7e987,0x398641de,0x3f9fc088,0xeaafa0e0}},	//   _lant_, pôs_, kwuu_, یٹن_,
   {{0x290eb7fc,0xe894a6fc,0xd9438924,0x777c2005}},	//   tofa_, еаль, вечи, lurx,
   {{0x7c3b8108,0xdb09a2a8,0x3ea7e0fd,0x657ae1fb}},	//   _egur, _freí, _nant_, yuth,
   {{0x69d86271,0xfa8ee119,0x778aa5fc,0x7c3b813e}},	//   øved, _bừng_, _təxm, _fgur,
   {{0x66cfa2f7,0x6b89cffe,0xa6db60c4,0x3ea7e363}},	//   _søkt, fteg, _guðb, _aant_,
   {{0xe7ee0da9,0x63a94057,0x7e63a227,0x6b89d7fd}},	//   _चेला_, _áent, banp, gteg,
   {{0xe0df25cd,0x7ae297fe,0x6284041a,0xdb0d2057}},	//   npòt_, lhot, _acio, _traé,
   {{0xa0a3e0fb,0x6f0f0024,0x38600256,0x6b960013}},	//   тшыл, tocc, _beir_, _apyg,
   {{0x25a057ff,0x83fca04d,0x7ae29800,0x386d817b}},	//   kwil_, _ceđe, nhot, _xder_,
   {{0x8c43c2d8,0x26cca5f2,0x3eba2037,0x0443d16c}},	//   _рече, _kodo_, _bnpt_, _речн,
   {{0xfc3f4019,0x2cb95801,0x290f80b1,0xd5b0e009}},	//   _caín_, _snsd_, zoga_, _مفت_,
   {{0x20d8c13a,0xb8e5007c,0xfd13457f,0x5ba3e0fb}},	//   _léim_, _এত_, نجر_, _арыз,
   {{0x38601384,0xe7ab806f,0x22490106,0x66dda187}},	//   _geir_, _ďaľš, _ufak_, _mèka,
   {{0x44224066,0x2bb1c0c2,0xb87b0057,0x3e880009}},	// [1390] _czk_, जिया, chía, sító_,
   {{0x2126c48d,0x333f8054,0xbf15613a,0xfc3f004a}},	//   _lhoh_, _ruux_, رواب, zdíl_,
   {{0x644980cb,0x8c9588ef,0x84e80555,0xaaa82bc5}},	//   _pfei, ерлі, _رفیق_, _छोटक,
   {{0xdbdc6765,0x501be076,0x394d80d5,0x3f895044}},	//   ráða, חובו, _ptes_, ptau_,
   {{0x60cd1693,0xbdf887f0,0x7e609802,0x260f74c6}},	//   _moam, ورها_, _demp, _तुरी_,
   {{0x64586069,0x443ce797,0x672d5803,0xf771a049}},	//   ðvit, _ngv_, lmaj, هاب_,
   {{0x6d5c61cd,0x2139400e,0x7ae29804,0x6e22d805}},	//   _gwra, _kish_, bhot, _azob,
   {{0x7b1600cc,0xbcfb6026,0x6d5d405d,0x213f8037}},	//   náut, _svéh, _kwsa, _tuuh_,
   {{0x7d034005,0x58848099,0xa7fb1806,0x83fca133}},	//   _ínsu, _шыра, daño, _ređe,
   {{0x39401807,0x8c3ca181,0xa3df2180,0x46dbc5cb}},	//   _ruis_, _yağm, थना_, _बतकह,
   {{0x3ea7f808,0xc6926087,0x2ca90025,0x3ea903c5}},	//   _vant_, נאט_, _baad_, _baat_,
   {{0xa7fb04cd,0x6d41b809,0xfc3f4005,0xf1b260be}},	//   gaño, _iula, _saín_, אסט_,
   {{0x60cd01fc,0x291e0041,0xb05b0052,0x83fce16d}},	//   _doam, ēta_, nkäy, rađa,
   {{0xbebb400e,0x64a2f3de,0x6f02c012,0x777c203e}},	//   _dhëm, _баша, _zjoc, turx,
   {{0xf8d3c028,0x60cd180a,0x628e2c1e,0xf2d2a053}},	//   _तवाय, _foam, rfbo, נעל_,
   {{0x2903600d,0x63a260c2,0x672d4143,0xa7fb0019}},	//   _ajja_, łonk, gmaj, caño,
   {{0x68368121,0x032661bc,0x09e343fc,0xfc3f4057}},	// [13a0] _müdü, едан, готн, _taín_,
   {{0x6e2400bb,0xdb0be2a8,0x629c23ac,0x7c2405f1}},	//   _izib, _orgí, qero, _izir,
   {{0x68e28b93,0x26ccb80b,0x443dc00d,0x7f40803c}},	//   thod, _rodo_, _ogw_, _sumq,
   {{0x68e2804a,0x44224012,0x891684c7,0x27e6980c}},	//   uhod, _tzk_, ربائ, tzon_,
   {{0xfd48c0f9,0xc1c8a0a3,0x7bdd85fc,0x78a8b75d}},	//   _damọ, िङ्ग, _üsul, _padv,
   {{0x63a64098,0x6105403b,0xd00f81ac,0x29004367}},	//   _iskn, mėla, حله_, lnia_,
   {{0x6e22c0e0,0x6d41b80d,0xdb0be01f,0x6adbc064}},	//   _szob, _cula, _orgâ, बसूर,
   {{0x61e16046,0x71f7a243,0x7d1bcc04,0xe876c5d1}},	//   _ülla, عروس_, glus, راعظ,
   {{0xb09b8095,0xa09b41a1,0x657e60bb,0x1a9b8053}},	//   _צימר, ליקט, luph, _צימע,
   {{0x629e61b9,0x026ae04e,0x6108c026,0xc66ae052}},	//   nepo, чший_, děle, чшие_,
   {{0x68f5380e,0x7c240284,0x2018e0c4,0xdbdee057}},	//   vizd, _azir, æri_, tíña,
   {{0xfbe04028,0x6449c0b8,0x1db2404b,0x7ae4407f}},	//   फनाम, ccei, ीमात, jhit,
   {{0x4dd3c949,0x693c206e,0x7f41a05d,0xba3b0017}},	//   _متوس, _očes, _zulq, veïd,
   {{0x7c240041,0x2ca90054,0x2139580f,0x44248037}},	//   _dzir, _waad_, _sish_, _mzm_,
   {{0x673ab28e,0x60cd01fc,0x62852066,0xf527482f}},	//   _mitj, _toam, _vcho, ефан,
   {{0x7cd8220f,0x68e44420,0x7ae45810,0x628520c2}},	//   _ağrı, ghid, ghit, _wcho,
   {{0xb87b5811,0xb2740052,0x95cb5109,0x7c2402a4}},	// [13b0] _alíc, _слыш, чува_, _gzir,
   {{0xd56401e1,0x39425812,0x443ea156,0x63a2854c}},	//   _стъп, _duks_, _ngt_, dwon,
   {{0x26cee926,0x66d260c4,0x7ce4e58f,0xa49b00d5}},	//   _mofo_, _rækt, _iòrd, cnòc,
   {{0x51874772,0x62829813,0xf65390e9,0xe8d12290}},	//   _пуга, ggoo, ائض_, _सकुच,
   {{0xf77f0106,0x78a98046,0x673aa07f,0xc7a5814a}},	//   nuç_, _vaev, _bitj, тилк,
   {{0x798d5814,0x6b8d4954,0x629e691e,0x6f1d00cb}},	//   mtaw, mtag, cepo, hlsc,
   {{0x6d41abfb,0x673ab815,0xceb421a9,0x2486d816}},	//   _qula, _ditj, טיס_, _bcom_,
   {{0x7e61ac8f,0xdb1be057,0x81d4e1a6,0x6d41b817}},	//   _welp, rxuí, _সেভ_, _vula,
   {{0x6d41b818,0x479480d0,0x67299819,0x26dc8018}},	//   _wula, _مجلس, _ihej, īvot_,
   {{0xccf8c04a,0xda67b81a,0x2900581b,0x59b32bde}},	//   _svět_, _سائي, znia_, ुमार,
   {{0x2295c049,0x27e941f3,0x25a6c0ca,0x2900581c}},	//   _للاس, hzan_, _esol_, ynia_,
   {{0x9d21e07c,0xcb6a062a,0x693c204d,0xe45f0156}},	//   নদেন_, маме_, _očer, sjön_,
   {{0x06b0e07c,0x798d4022,0x60dbc0ce,0x3327e363}},	//   _চকরি, jtaw, mkum, _thnx_,
   {{0xa01b0277,0x66d26065,0x249fd783,0x29004064}},	//   tför, _lækr, leum_, wnia_,
   {{0x2912581d,0xa7fb4071,0x45d2e39d,0x644d01cd}},	//   toya_, _reña, _војс, _ffai,
   {{0xfd62c088,0x6d43e08b,0xb90341ba,0x68e4417b}},	//   _netị, _iuna, азск, uhid,
   {{0x2912581e,0x3f8dc5df,0xaa466627,0xa7fb49c1}},	// [13c0] roya_, nteu_, везл, _peña,
   {{0x321a343a,0x39462052,0x98a0400a,0xdfcf413a}},	//   _typy_, _иног, kmić_, غيل_,
   {{0xa7fb403e,0x753aa2bd,0x661b81df,0x7e63e108}},	//   _veña, _ritz, _ayuk, _menp,
   {{0x443f981f,0x385a40e0,0xdb0400d5,0x63b56364}},	//   _cgu_, _تشدد_, _arnú, _drzn,
   {{0xa06785d0,0x29021820,0xf8b300be,0x3eab6052}},	//   тача_, inka_, ישא_, öitä_,
   {{0x3f9a2037,0xdce2e06f,0x98b88187,0x6d42c052}},	//   _kppu_, _spoľ, _bură_, _ruoa,
   {{0x4420c03b,0xa3c3e032,0xb0e20029,0x673aa488}},	//   _ši_, yšší_, _पतंग, _vitj,
   {{0x2bb48046,0xb5fb4049,0x60dbc0f2,0x20d42046}},	//   ूमदा, _meán, gkum, _käis_,
   {{0x6f029821,0x673aa17a,0x7ce60049,0x78abd822}},	//   mnoc, _titj, _mórd, _dagv,
   {{0x80d120c2,0x2ee685dc,0xb87b0049,0x29021823}},	//   _सकें, lhof_, thío, enka_,
   {{0x6aabd824,0x656d1825,0x61e9c0d4,0x287b61a9}},	//   _fagf, _svah, azel, ונימ,
   {{0x6f028105,0x2900c013,0x2ee685c4,0xeabf503c}},	//   nnoc, čias_, nhof_, _chùl_,
   {{0x2a648037,0x3f8dc017,0x7d029826,0x6f028322}},	//   _memb_, cteu_, inos, inoc,
   {{0x66d5c031,0x78abc012,0x2d805827,0x7d029828}},	//   _dáku, _zagv, duie_, hnos,
   {{0x60cf4012,0xd7f82052,0xdb0e8926,0x9c7ce530}},	//   _pocm, вут_, _arbí, lhčo,
   {{0xf837e076,0x69d6c106,0x27242262,0x2caca16f}},	//   _בנות_, _üyes, röna_, _ladd_,
   {{0x673c6dac,0x63b61829,0x3d0f0028,0xc1056049}},	// [13d0] _birj, _gryn, सवीं_, هوري,
   {{0x249fd0f2,0x78ad01dd,0x60dd09cd,0x6729800e}},	//   zeum_, _haav, lksm, _shej,
   {{0x78ad582a,0x7f43e03e,0x3eadd82b,0x316d8143}},	//   pdav, _xunq, ydet_, _svez_,
   {{0x98ad8064,0x63a44200,0x60dd003b,0xc0ab80e0}},	//   _mieć_, bwin, nksm, بائل_,
   {{0x2489017b,0x673c782c,0x26cfd82d,0xeab08711}},	//   _mcam_, _firj, _rogo_, تعل_,
   {{0x78ad0660,0x6135c013,0xd6dba54a,0xf4140076}},	//   _laav, _išli, ьте_, ספס_,
   {{0xfc3fc05c,0xef1f06df,0x443f817b,0xc33423c8}},	//   žím_, klü_, _tgu_, בוס_,
   {{0x6d43f82e,0x3ea164ef,0x7e63f82f,0x3ce6805c}},	//   _runa, leht_, _senp, chov_,
   {{0x7e63f830,0xeb1f804b,0x316d87a0,0x661d5831}},	//   _penp, बतीत_, _uvez_, _jysk,
   {{0x60dbd832,0xed59e926,0xfff68555,0x26d16a38}},	//   skum, ноо_, _حکمت_, _jozo_,
   {{0x4155a39d,0x644d4037,0x656d5833,0xe8df8079}},	//   _свес, kcai, hsah, _ndịa_,
   {{0x455aa076,0xdce7c018,0x28c400c2,0xf487c39d}},	//   _נכנס, ēlēj, षाधि, _јужн,
   {{0x2d816105,0x7e63e108,0xeabf5834,0x90e041e9}},	//   huhe_, _tenp, _chùm_, _dọ̀,
   {{0x877ac053,0x68e2c089,0x7ce60057,0x776d4b47}},	//   _נאצי, _zlod, _sórd, dsax,
   {{0xba208216,0x7ce06069,0xafe33835,0x6aad0025}},	//   _बर्फ_, _börn, борл, _faaf,
   {{0x63a99836,0x6da64423,0x25d6e0be,0x3ce68286}},	//   _osen, либа, _תוקן_, xhov_,
   {{0x2d8d8022,0x6b9b212a,0x6441a2f0,0x656d5837}},	// [13e0] _nqee_, ăuga, _ogli, gsah,
   {{0x644d400c,0xf3f9c0ba,0x3ebf8827,0xbd5b0076}},	//   acai, gaţi_, _anut_, _רכיש,
   {{0x2ca05838,0x63a45839,0x68e4004a,0x291a2079}},	//   peid_, swin, _klid, _ikpa_,
   {{0x657bd83a,0x298a898c,0x20d42046,0xf8bf4049}},	//   kruh, еско_, _täis_, _gné_,
   {{0x6aa1e954,0x80c466a8,0x645ae025,0x7981e1fb}},	//   kelf, रादे, ybti, hulw,
   {{0x2ee685dc,0x3320413e,0x7bd8a013,0x2918783b}},	//   shof_, llix_, tyvu, _ukra_,
   {{0x291a2385,0x23674098,0x661d583c,0x2d82183d}},	//   _mkpa_, ćnje_, _zysk, huke_,
   {{0xa6db4765,0x26d1783e,0xd90dc6b0,0x7ae40011}},	//   _viðg, _zozo_, ویل_, _nlit,
   {{0x386a383f,0x78a29840,0x7ae2cbb6,0x638aa1de}},	//   kabr_, meov, _vlot, _bênç,
   {{0x78a28320,0x6b80cc52,0xb05b4156,0x44f4e0ff}},	//   leov, rumg, _knäc, рпос,
   {{0x6f044320,0x656d405c,0x925902dd,0x4438e277}},	//   knic, zsah, кант_, är_,
   {{0x3f821791,0x28af0982,0x0446c084,0x7d094e60}},	//   fuku_, _जोखि, _седн, česk,
   {{0x6442c426,0x26d2018c,0x2d821841,0xd7c7e0eb}},	//   _igoi, _doyo_, guke_, نویه_,
   {{0x2a694025,0x6b81f842,0x7ae41843,0x3ead004a}},	//   waab_, bulg, _elit, žet_,
   {{0x6d46431b,0x63a240fa,0x26d17844,0x7d045845}},	//   _auka, çonn, _rozo_, fnis,
   {{0xd904863b,0x26d21846,0xf548c119,0xdce0e018}},	//   _ری_, _goyo_, _gục_, kumī,
   {{0x656d5847,0x70552043,0x612b6105,0x6d453819}},	// [13f0] usah, _پنجا, hüle, _wuha,
   {{0xeb0d81b0,0xe8162010,0x6f044197,0xa3b3898a}},	//   िक्त_, _दुवा_, anic, टिस_,
   {{0x63a9800d,0x7ce06c82,0x62857848,0xf3f9c12a}},	//   _ssen, _törn, rgho, raţi_,
   {{0x3f8320eb,0xbd05e0f9,0x6442cc88,0x213ea7ad}},	//   muju_, _amẹ́, _ngoi, _aith_,
   {{0x3949417a,0x2b46c067,0xddd0a04a,0x0878000b}},	//   qqas_, _nuoc_, _češt, רעדט_,
   {{0x69d98f06,0xe9b88043,0x81b9a0e8,0x612020cb}},	//   rywe, انوں_, _haɓɓ, völk,
   {{0x672d041b,0x612b6315,0x645bc1b9,0x3f820bc1}},	//   _ohaj, rüld, tbui, zuku_,
   {{0x752d0291,0x6d556108,0x63a98466,0x6d44e06f}},	//   _nhaz, _itza, _tsen, _čiap,
   {{0xa7fb01af,0x656f0171,0x2b46c067,0x7981ed28}},	//   bañi, jsch, _cuoc_, wulw,
   {{0x2b46c016,0x7ae4088b,0x7e6b9849,0x752d184a}},	//   _duoc_, _slit, lagp, _ahaz,
   {{0xe4c60d2b,0xa2c2abde,0x657bd84b,0x6d5980ae}},	//   айни, लार्, sruh, lpwa,
   {{0x656f1385,0x6126e069,0xf530c049,0xf1b98552}},	//   fsch, rðla, _فإن_, _krš_,
   {{0x61ed4098,0x656f116b,0x95830052,0xa158c71b}},	//   jzal, gsch, оляе, _бачу_,
   {{0x271e48b1,0x644f065f,0x62872536,0x6aa3b84c}},	//   पत्र_, acci, ggjo, nenf,
   {{0x25e8412f,0x7e66584d,0xb5fdc06e,0x3ea2184e}},	//   चैनी_, _pekp, kašk, pekt_,
   {{0x7ae4184f,0x66d5c066,0x3eafc065,0x26cdc00a}},	//   _ulit, _zákr, _jagt_, njeo_,

   {{0x5d6a533f,0x5fab60c2,0x656f00ca,0x64440561}},	// [1400] тизм_, _टैबल, csch, _igii,
   {{0x27edd770,0x63a90121,0x7e566d94,0x9e3a613a}},	//   izen_, çene, ртац, نساء_,
   {{0x6f045850,0x7a7b2087,0x68e9caaa,0x7d04a7a4}},	//   pnic, _בריס, khed, éism,
   {{0xe9da9826,0x41b306b0,0x969645da,0x2ee94751}},	//   кке_, _امیر, _трош, chaf_,
   {{0x6aa29851,0xa3e60026,0x61ed40c2,0x7d09800e}},	//   reof, पनि_, czal, _djes,
   {{0x249a205d,0x212d8425,0x6299c194,0x7c298018}},	//   _jbpm_, _eheh_, _abwo, _dzer,
   {{0x2fc769ac,0x27edc200,0x5f092029,0x6b844090}},	//   ängt_, ezen_, _सदस्_, luig,
   {{0xbcfb3852,0x7d099853,0xa3b384ba,0x61fb400a}},	//   nsér, _gjes, टिश_, _žuli,
   {{0x644041de,0x6d408025,0x6563e1f6,0x256ca1e9}},	//   _úmid, _iima, _awnh, _bólá_,
   {{0x672291c5,0x6b9e24a4,0x83fce0e4,0x612b6106}},	//   lloj, _oppg, lađi, püle,
   {{0x68e9c0bb,0x3867e1e7,0x3866c41a,0x7ce06156}},	//   bhed, _denr_, _teor_, _rörl,
   {{0x6f18ab81,0x69daf854,0x3946c013,0x69c9c022}},	//   lovc, ryte, _tuos_, bxee,
   {{0xf8c96292,0x799e2037,0x6d409855,0x656f0105}},	//   रामय, _appw, _mima, usch,
   {{0xa3da410a,0x2d84d856,0xd7f80772,0x3d1060c2}},	//   ़हन_, mume_, рую_, ़कों_,
   {{0xaca48088,0x644fe064,0x8f35135c,0x3ceea10a}},	//   _azọp, ścic, _лекц, _अतने_,
   {{0x9553e050,0x7afc228f,0x7ce22057,0x799e205d}},	//   _بخوا, airt, _fôro, _dppw,
   {{0xb5fdc42e,0xb995013a,0x692ac026,0x629aa06e}},	// [1410] vašk, _الخب, _břez, _obto,
   {{0x7afc3857,0x7d1b9858,0x7d098579,0x4545613a}},	//   cirt, _skus, _sjes, منطق,
   {{0xa6db4069,0x9259804e,0xf77367f9,0x2ee6d137}},	//   _viðb, гает_, تاذ_, _olof_,
   {{0xdb0d3859,0x6d4765f9,0x78a44095,0x60c2d85a}},	//   _braç, _vuja, ceiv, _nnom,
   {{0x8c3d812a,0x7d1b84d2,0x6aa3b85b,0x7e6773bd}},	//   _naşt, _vkus, tenf, _tejp,
   {{0x63ad0167,0x6125c07b,0x98adc6a6,0xfaa5b85c}},	//   _msan, tólo, rmeč_, сако,
   {{0xb5fdc0a9,0x78a3b85d,0x68fbd85e,0xc4466062}},	//   maši, renv, tiud, _ایمن_,
   {{0x7d09985f,0xfc4a6049,0x8c3d8106,0x63ad1860}},	//   _ujes, _tríú_, _başt, _osan,
   {{0x68fbc0dd,0xdb0d201f,0x63ad02e0,0xef19e14a}},	//   riud, _graç, _nsan, лми_,
   {{0x68e9d861,0x06c9e5be,0x6d409862,0x6125c019}},	//   shed, угой_, _zima, pólo,
   {{0x7a6a024a,0x27edc0e0,0x6d4097aa,0xdc6a05a8}},	//   линг_, szen_, _yima, ланд_,
   {{0x7ce2206f,0x4735d1b7,0xe5a6014a,0x6da6030b}},	//   _pôro, _унес, бими, бима,
   {{0x3f84d863,0x386dc042,0x291dd864,0x64452143}},	//   cumu_, maer_, _ikwa_, _bghi,
   {{0xaa7b003a,0x2b47e0a0,0x7d76c0d0,0x7afd1865}},	//   tkýc, _tunc_, _امور_, aist,
   {{0x41b524ae,0xa355e1ac,0x1fb52acb,0x248d80e4}},	//   остт, _اختص, остр, _ocem_,
   {{0xa2da6077,0xe3b2050f,0x628d0049,0x6b9cae22}},	//   पॉन्, _فرخ_, _gcao, _ärge,
   {{0xa3ab4ba0,0xf1aa4050,0x6aa45866,0x3ce04584}},	// [1420] _कैद_, دازه_, reif, rkiv_,
   {{0xf4846050,0x5e57010c,0x68fc22a4,0x7ce06052}},	//   تاری, _پلیس_, qird, _törm,
   {{0x41a6a0c2,0xf2df6119,0xdb154066,0x60d60106}},	//   _कैंस, _tuân_, žbác, _koym,
   {{0xe89480ff,0x4fea85a8,0x6d408bee,0x39490048}},	//   іаль, лмен_, _qima, _yuas_,
   {{0x7ceb20e0,0x290680e9,0x39490286,0xceb4403c}},	//   _fürd, rnoa_, _xuas_, mdə_,
   {{0x83fce29c,0x3d11e064,0xef1f2121,0x6d5af03d}},	//   sađi, ठकों_, ltür_, ypta,
   {{0x6d408fcf,0x2167a1e3,0x752291d7,0x629c7867}},	//   _tima, бији_, ploz, _ibro,
   {{0x67244f10,0x973cc4bb,0xa3c9a4da,0x63baa742}},	//   nlij, _opće, _ऊपर_, _vrtn,
   {{0x3ea4d868,0x63a9d869,0x6f18b86a,0x2d804071}},	//   remt_, gwen, povc, nrie_,
   {{0xa6db4069,0x628d013a,0x2ca681a4,0x2d80586b}},	//   _miða, _scao, leod_, irie_,
   {{0x25a00426,0x5335065a,0x3991e3cb,0x3cf060c2}},	//   _apil_, жент, gás_, _इतने_,
   {{0x63a9c4fd,0x68e2986c,0xa193e71b,0x612da069}},	//   bwen, nkod, чаюч, rúle,
   {{0x644fe064,0x2ca5e171,0x254ce04a,0x6d41a0bb}},	//   ścia, beld_, _tělo_, _yila,
   {{0x7afe600e,0x3ea5e018,0x3f85f86d,0x61054013}},	//   jipt, celt_, bulu_, mėli,
   {{0xb5fdd86e,0x25a9517f,0xf3f980ba,0x67244585}},	//   vaši, wwal_, _veţi_, flij,
   {{0x25a9586f,0x25ecc028,0x67245870,0x7d1ae0bb}},	//   twal_, आईपी_, glij, lots,
   {{0xa49b0017,0x2ca68046,0x6bda00e0,0x09e1604b}},	// [1430] riòd, deod_, _نوٹس_, पन्य,
   {{0x6e22cf7b,0x7d1af871,0xdb09f872,0xb33cc1f6}},	//   _myob, nots, rveç, _isħu,
   {{0x69de738e,0xb5fb4049,0xfb84603b,0x2fc76067}},	//   gype, _meái, зычн, ãng_,
   {{0x7d1af873,0x0cab467b,0x7ae28037,0xddc3a06e}},	//   hots, _стои_, gkot, janš,
   {{0x6f198064,0xb5fdc6a6,0x7ae8000e,0x28c96077}},	//   rowc, paši, ëjti, रादि,
   {{0x83fce490,0x61054013,0xb579b0c4,0xb87b0a7d}},	//   lađu, dėli, ащих_, chív,
   {{0x23608018,0x28daa2b4,0x3ce900ff,0x29095662}},	//   ģija_, _बकरि, _olav_, onaa_,
   {{0x83fce0e4,0x63a9d874,0x3ea5e105,0xfbdf01ae}},	//   nađu, twen, welt_, ncês_,
   {{0x63ad81ae,0xe5c78312,0x6e2d049e,0x3f85e174}},	//   çand, _усво, _nzab, wulu_,
   {{0x63a9d875,0x237fc058,0x5187b3f9,0x7c22cc57}},	//   rwen, rruj_, _гуда, _dyor,
   {{0xed59850e,0x628f414a,0xeaaec043,0x3255d876}},	//   _drže_, _occo, رٹی_, _двер,
   {{0x8234c050,0x291dc00f,0x2d85f877,0x6d42d878}},	//   _کرما, _ukwa_, rule_, _gioa,
   {{0x6d4ae057,0xfc3f4a60,0x7d09d406,0x7afb82dc}},	//   _eufa, _maís_, mnes, _mmut,
   {{0x3943662c,0xdb1ac1ab,0x6f0d1879,0x2d85f87a}},	//   _nijs_, _artè, _ejac, pule_,
   {{0xceb4403c,0xfaff031d,0x7afb8b01,0x3f87b0a3}},	//   tdə_, bië_, _omut, nunu_,
   {{0x7c3eed3f,0x7c2bed6d,0x2d80587b,0x3f80587c}},	//   _úpra, đorđ, trie_, triu_,
   {{0x1636c00b,0x2d87b87d,0x2e4ec088,0x3f87b87e}},	// [1440] ַנער_, hune_, _kọrọ_, hunu_,
   {{0x2ea6c8ae,0x3f87b87f,0x2d87b880,0x7524462f}},	//   _खस्त, kunu_, kune_, sliz,
   {{0x2ca7a1cf,0x68fe605d,0x389b200b,0x7d1bd881}},	//   dend_, ripd, _דיינ, kous,
   {{0x2d805882,0x644760dd,0x6d59d883,0xdce4629f}},	//   prie_, _egji, _otwa, ksić,
   {{0xa5bb40e0,0x5e58a052,0x6f09c530,0x3ea7b884}},	//   _szóv, биля_, dnec, fent_,
   {{0x6f1c28b6,0x394a7607,0x1c1dc4ef,0xa3bfc4e6}},	//   norc, _tubs_, _पड़ल_, ुमन_,
   {{0x2d87b885,0xe80100c2,0x7c22c0c7,0xab5b4046}},	//   gune_, _लेना_, _syor, _prüg,
   {{0xdce9e06a,0x27e04054,0x6aa72098,0x7c240088}},	//   dređ, oyin_, zejf, _oyir,
   {{0xb87b4069,0x68e45886,0x7ae44108,0x6d4af819}},	//   _slík, ikid, ikit, _sufa,
   {{0x6b829104,0x63ad9887,0xaefb61e9,0x6d440090}},	//   mrog, çane, _awùj, _aiia,
   {{0xf6536095,0xd6dac050,0x7c241888,0x7c23e1cd}},	//   וצת_, _پوشش_, _ayir, _cynr,
   {{0x70daa69e,0x7d1af889,0x39944052,0xfc46604a}},	//   _बकुल, sots, käs_, šího_,
   {{0x26c6c054,0x7b1fa1de,0x7f43e0b8,0x80ada1a6}},	//   _inoo_, pêut, _finq, চার্,
   {{0xdb00a105,0x7ce6188a,0x050b007c,0x6b828005}},	//   _ermö, _fóro, রতের_, irog,
   {{0x628f4071,0x2732a0ba,0xdb0d61de,0xdb1ad88b}},	//   _pcco, mând_, lvaç, _arté,
   {{0x2ca7b04d,0x3f816066,0x6d5d0469,0x290a2025}},	//   zend_, vrhu_, ppsa, anba_,
   {{0x44248187,0x29094054,0x3d94516c,0xdb1c800e}},	// [1450] _nym_, rnaa_, митр, _errë,
   {{0x7d1bc2b2,0xd25b6d94,0x7d00d518,0x7d0dc06f}},	//   zous, рца_, hims, časi,
   {{0x6d4d0939,0x6d452c57,0xb4e720c2,0xa5bb4009}},	//   _huaa, _iiha, पसी_, _azót,
   {{0x28c964e6,0xd126c8b8,0x394362be,0xaac974e5}},	//   राहि, _سم_, _wijs_, राहक,
   {{0x4993454f,0xa3b92914,0x6d45295f,0xa3a78949}},	//   _زیار, चिव_, _kiha, تحان,
   {{0x05962050,0xe8f8a19d,0xdcfbe0a9,0xf548c067}},	//   _بایگ, олі_, truč, _cụm_,
   {{0x69dce042,0x68e9848d,0x7ae980f7,0x612da005}},	//   ørel, _tled, _tlet, gúla,
   {{0x2d820042,0x6d4bcc05,0x3f87a983,0x53348d24}},	//   yrke_, _puga, runu_, _жест,
   {{0x3f87a3df,0xe81bb88c,0x26d940d1,0xb5fdc00a}},	//   sunu_, _पुरा_, _moso_, jašt,
   {{0x2d87b5ed,0x386d8e47,0x290b188d,0x61318156}},	//   pune_, _heer_, enca_, såld,
   {{0xaca34079,0x7d084066,0xdce9ecb1,0x66df000e}},	//   _awọd, édsk, uređ, _lëku,
   {{0x7aeae305,0x387a2143,0x7cf14584,0x291d8063}},	//   _elft, _sdpr_, _hårf, nowa_,
   {{0x6d4bd88e,0x2e4ec254,0x7aebc018,0x21332119}},	//   _uuga, _tọrọ_, _ilgt, _bhxh_,
   {{0x7cf0210a,0xeab24043,0xa879e00b,0x6aa9d88f}},	//   _märg, کٹر_, _האַר, leef,
   {{0x7e7b829f,0x20132057,0xb8e42bde,0x7e6d0005}},	//   _odup, _cxxi_, _एफ_, _feap,
   {{0x2732a12a,0x2bb0e026,0xa3bd8026,0xf1b2a00b}},	//   mâne_, _जनता, ेमा_, עסן_,
   {{0x3b864056,0xe5a355ea,0x394d9890,0xbebb03ac}},	// [1460] ялаг, нити, _nues_, ymëz,
   {{0x8b236052,0x1dbdb3aa,0x2fc00143,0x7cea40c4}},	//   едуе, ्मात, _irig_, _dýra,
   {{0x69cb4d4b,0x63ad54b7,0x7c25a0cb,0x70a9e026}},	//   äger, awan, ührl, _कसैल,
   {{0x6125d3c9,0xd9464406,0x6d453891,0x395fc07d}},	//   bóli, _неми, _ziha, kpus_,
   {{0x26da34d7,0x2d8a2c75,0x21269074,0xa6db40c4}},	//   _kopo_, lube_, rloh_, _miðl,
   {{0x7cfec03b,0x9966b892,0xe45f0156,0x63a4046d}},	//   tūro, птил, njör_, _mpin,
   {{0x2d8a3893,0x61e1f831,0x2ca00012,0x03a3695a}},	//   nube_, jyll, _obid_, _пиро,
   {{0x3f508016,0x29021894,0x74c47895,0x2d983896}},	//   _tàu_, jika_, राकृ, itre_,
   {{0x3f6781e1,0x2fc00286,0xddc1a35d,0x8c53c049}},	//   _нито_, _nrig_, _velš, رئيا,
   {{0xdb0d601f,0x61318042,0x7c26405d,0x7648a013}},	//   rvaç, råle, _mykr, _ugdy,
   {{0x7cefa3d1,0x6d4e7897,0x10a6c6fc,0xbc6ac050}},	//   _sørg, _juba, _нижн, _همان_,
   {{0x9f4e0066,0x386d8025,0x6e9f2026,0xdb0f6017}},	//   žným_, _xeer_, ख्नु, _escè,
   {{0x254ce026,0x2d78606e,0x61334106,0x37aea07c}},	//   _měli_, hče_, nçle, _কপির,
   {{0x96d82216,0x26da21ae,0x7d1e6098,0x7d029898}},	//   नॉलॉ, _copo_, jops, hios,
   {{0x4426cc12,0x06fda026,0x6b844cf9,0x765520c2}},	//   _hyo_, _říká_, erig, rczy,
   {{0x29021899,0x63ad509d,0x2fc0189a,0x79976048}},	//   cika_, twan, _frig_, vtxw,
   {{0x57c68010,0x2ca946d7,0x9ed969af,0x2b46c012}},	// [1470] लमोह, read_, омат_, _mioc_,
   {{0x399560ac,0xf1b0eca9,0x386d8aaa,0xa2c465c5}},	//   tås_, _जनान, _seer_, राग्,
   {{0x7522d89b,0x6125c07b,0x7d02989c,0x5faec0c2}},	//   _okoz, sóli, fios, _जैसल,
   {{0x4426d89d,0x6d4647c4,0x7afd4105,0x29016da2}},	//   _oyo_, _gika, _umst, siha_,
   {{0x3f8b0121,0x399566dd,0xab5b4105,0x6b844017}},	//   nucu_, sås_, _drüc, crig,
   {{0x6d5d4265,0xd246e13a,0x68ed0cbc,0x7aed0507}},	//   _itsa, _لن_, _llad, _llat,
   {{0x6721a42e,0x7522c098,0x2902189e,0xbcfb61e9}},	//   _vklj, _bkoz, yika_, _atég,
   {{0x6f02832a,0x6d4f589f,0xdce9a320,0x7e7b98a0}},	//   cioc, _kuca, _oveć, _udup,
   {{0x7bc08098,0x78a9c035,0x442b8067,0x629c2bca}},	//   _grmu, reev, _ác_, yfro,
   {{0xceb44497,0x290218a1,0x3f52c016,0x6f0d58a2}},	//   nlər_, wika_, _dâu_, hnac,
   {{0xf549e016,0x3dc12022,0x9eaa0c6c,0xb905e861}},	//   _tấm_, _nrhw_, овна_, _नव_,
   {{0xb5fb08cc,0x141aa00b,0xdced6315,0x6f0d58a3}},	//   rbán, _וועב, yrağ, jnac,
   {{0x26da3062,0xaa7b005c,0x7aed0064,0x6d5d4286}},	//   _popo_, ckým, _dlat, _ntsa,
   {{0x6d4658a4,0x2d8a259d,0x69c1a0e4,0xc172c095}},	//   _sika, tube_, _krle, _יחד_,
   {{0x68ed18a5,0xceb4403c,0x2d9916a8,0xbb432d68}},	//   _flad, dlər_, atse_, терк,
   {{0x3947e069,0x3ea007a0,0x2d8a20b1,0x290dc582}},	//   _hins_, _ubit_, rube_, nnea_,
   {{0x6d476d3d,0xe57a58a6,0x63a40296,0x752418a7}},	// [1480] _bija, юза_, _upin, _ikiz,
   {{0x6e2b4669,0x4427f8a8,0x6d476e99,0x443216f0}},	//   ügba, _kyn_, _cija, _izy_,
   {{0x21294820,0x6d5d4534,0x7c2640c2,0xeb9770e1}},	//   blah_, _etsa, _wykr, дих_,
   {{0xfce38501,0x644bc050,0x2b47e1cd,0x1867860f}},	//   кохо, _nggi, _linc_, даци_,
   {{0x7d044e38,0x2458acde,0x25ad6361,0x6729d8a9}},	//   miis, паль_, _ćele_, dlej,
   {{0x6459d2fb,0x4426c00f,0x3946d8aa,0x7d0290aa}},	//   _afwi, _ryo_, _sios_, sios,
   {{0x27362065,0x29000052,0x69ca2057,0x3ce6875a}},	//   mænd_, _omia_, _áfed, pkov_,
   {{0xf9932095,0x2cb878ab,0x60db80d1,0x7cf158ac}},	//   דרה_, _hard_, _goum, _gård,
   {{0x9486e0ba,0x2cb871e0,0x69c081fc,0xb7bec07c}},	//   мынд, _kard_, _urme, েন্ট,
   {{0x65c6a1e1,0x5436a566,0xd4c6a13a,0x6436a13a}},	//   _обза, _قرار, _تغري, _قراء,
   {{0xddc40013,0xe8df8067,0x7529d8ad,0x27358271}},	//   _reiš, _hiền_, blez, bånd_,
   {{0x2d8b18ae,0x7ce06156,0x9663c7f7,0x2129405d}},	//   tuce_, _körs, _акце, xlah_,
   {{0x7ce3410a,0x4426c631,0x7ae340ba,0x60dc6155}},	//   _kõrv, _uyo_, _înti, _oorm,
   {{0x3f8b00b0,0x2d8b18af,0x61120018,0x7bc2c229}},	//   rucu_, ruce_, rāla, _irou,
   {{0x7d044054,0xdd9420db,0xf20424a0,0x19942bcd}},	//   fiis, кары, вято, каря,
   {{0x7bc2c04a,0xe8d92125,0x7aed0046,0x403502f0}},	//   _krou, _itọ_, _ulat, _пейс,
   {{0x3f8ce17a,0xd838e35d,0x6d5863ab,0xde8f8067}},	// [1490] ludu_, reču_, ívan, hịch_,
   {{0x39490939,0x60db8bf9,0x0dcb21e1,0x798b800f}},	//   _hias_, _soum, _думи_, vugw,
   {{0xceb2200b,0x60db8653,0x305c8088,0xfbd080eb}},	//   _גיי_, _poum, _ịlụ_, یته_,
   {{0x80cd604b,0xb87b4019,0xceb4403c,0x7e7d422e}},	//   साहे, _clít, slər_, _udsp,
   {{0x6d5d43e0,0x60db8005,0xdbd6c2df,0x6130697a}},	//   _utsa, _voum, _jääm, mäln,
   {{0x7c28a31d,0x6aa2c057,0x98c4604e,0x6aad5488}},	//   _bydr, _abof, _иссл, leaf,
   {{0x8c3ce106,0xa3b38914,0x25a6c733,0x7c28a0fd}},	//   beği, टिङ_, _apol_, _cydr,
   {{0x6f03a4f2,0xb5fd8205,0x3f8698b0,0x6d48b8b1}},	//   sinc, _bešt, brou_, _eida,
   {{0x673bc7ac,0x6729c065,0xb5fd8320,0x78b8e614}},	//   rmuj, rlej, _pešu, _bavv,
   {{0xddc418b2,0x1f65ef20,0x69c2d658,0x4427eaaa}},	//   _afiş, нком, _droe, _pyn_,
   {{0x26dce1e2,0xddc640a9,0x2d8ce10a,0xead4a14a}},	//   _dovo_, _mekš, gude_, _шофь,
   {{0xd756c10c,0xa107c050,0x23cb0021,0x394fd8b3}},	//   بلیت_, _غذاه, ामंद, _tugs_,
   {{0x13a7c050,0x6909200a,0x9986e16d,0x6b8d42a8}},	//   _آنتی_, džeb, čiše_, juag,
   {{0x6134e5df,0x2b5f805d,0xddc98143,0x60dd458f}},	//   tàle, _mtuc_, _odež, _aosm,
   {{0x6da321c7,0x3eb86271,0x44291669,0x13c84914}},	//   лира, _rart_, _eya_, रम्भ,
   {{0x395e2041,0x69c0a98a,0x69dca5df,0x78bbc046}},	//   īts_, विती, _àree, nduv,
   {{0x656d00e2,0x27188e9d,0xd5a404ef,0x799bc068}},	// [14a0] _gwah, nčne_, _ओहिज, ntuw,
   {{0x3c6623b7,0x8c1b0095,0x3eadd8b4,0x7aef4071}},	//   _яког, _מופי, heet_, _elct,
   {{0xd00f613a,0x06868926,0x2904d8b5,0xc486851b}},	//   ملك_, еген, yima_, елек,
   {{0xdb1ba057,0x2905f8b6,0x39490048,0x80ca407c}},	//   _druí, hila_, _xias_, রসঙ্,
   {{0xaca46088,0xda638450,0x3ea04143,0x4429005f}},	//   _azụr, увчи, mfit_, _xya_,
   {{0xa8248050,0x3f86832a,0xf548e119,0xdd90a33e}},	//   _یکشن, rrou_, _tụi_, لوت_,
   {{0x3eadc3b0,0x6720c00e,0x78b8e024,0x57c9e290}},	//   feet_, tomj, _ravv, िमोह,
   {{0x2cace0e2,0xbb43882b,0x81af807c,0x78b8f8b7}},	//   wedd_, _беск, _ওপর_, _savv,
   {{0x3eace097,0x3f8dc5df,0x2d87b8b8,0xff06e03b}},	//   tedt_, gueu_, arne_, еянн,
   {{0x27320026,0x3f87a29c,0x13f3c052,0x644de315}},	//   vána_, brnu_, узья, _şair,
   {{0x69c3e143,0x61360066,0x23674098,0x3eace654}},	//   _crne, zále, ćnji_, redt_,
   {{0x26dea35f,0x39490048,0x3eaeb8b9,0x290420d1}},	//   _hoto_, _qias_, left_, èman_,
   {{0x48e6eacb,0x69c3f8ba,0xe8df8016,0xceb3800b}},	//   _подв, _erne, _hiển_, ניש_,
   {{0x24800786,0x2fc048ef,0x6aa4011d,0x78a40035}},	//   _edim_, dvig_, _ebif, _ebiv,
   {{0x3eb94095,0x8ccdea2a,0x69c4098d,0xab68e1f6}},	//   _past_, तारो, _erie, _beżż,
   {{0x78bab8bb,0xb063a06f,0x644d0400,0x61e6052d}},	//   _latv, _zväč, _ugai, bykl,
   {{0x27e680d1,0x7bc6804d,0x612b78bc,0x656d0668}},	// [14b0] jyon_, _škun, lüli, _uwah,
   {{0x6abd0b48,0x799d0022,0x3eaea143,0x2ee94b13}},	//   ldsf, mtsw, jeft_, skaf_,
   {{0x657af8bd,0x5f95614a,0x65608153,0x7b0b6018}},	//   nsth, тиет, _atmh, kļuv,
   {{0xc01c2016,0x6d4af8be,0x629560c2,0x7bcdc057}},	//   _lược_, _lifa, _wczo, _áaug,
   {{0x69d863d1,0x752d58bf,0xe9ffe119,0x6b8d58c0}},	//   øver, mlaz, _khải_, quag,
   {{0x3999c0d1,0xfaa5acd0,0x2126c1e7,0x8698a14a}},	//   vès_, тако, _akoh_, етът_,
   {{0x60cd01fb,0x5b14639d,0x3f8ea00f,0x27e685c8}},	//   _onam, _смрт, gufu_, ayon_,
   {{0x2a7f8054,0xb4ac60c5,0x9f52c066,0x7ce078c1}},	//   _udub_, कड़ी_, ždým_, _hörp,
   {{0x3eadd8c2,0x7bdce105,0xa6db40c4,0x3f87a098}},	//   reet_, ärun, _viðh, srnu_,
   {{0x2caf8200,0x61e618c3,0x3eadc831,0x6f07c56e}},	//   legd_, vykl, seet_, _bèbè,
   {{0x4ac68216,0xc01c2016,0x8ae7c0ff,0x2d82894b}},	//   _रोडव, _dược_, _підл, _åker_,
   {{0x2a720054,0xd7d14026,0xf1b26053,0x7d07c0eb}},	//   _qeyb_, समाच, בסט_, _dèrè,
   {{0x7d072768,0x7ceb2121,0x3f894022,0xc8f5e14a}},	//   fijs, _türl, jrau_, _издъ,
   {{0x7d0618c4,0x63a98167,0x6b89d8bd,0x6f0da049}},	//   siks, _mpen, mreg, éach,
   {{0x7c9642f0,0x7cf5c057,0xc692a0be,0xeb972bd2}},	//   крац, _cárg, יאם_, кир_,
   {{0x3f84229c,0x6d4af862,0x799d0022,0xa2c18026}},	//   čmu_, _zifa, btsw, _रोल्,
   {{0x4127467b,0x7d04139d,0x3f8958c5,0x399aa00e}},	// [14c0] тото_, _imis, grau_, zës_,
   {{0x98bea03b,0xb4636799,0xa3d5e0c2,0xee374fb5}},	//   _kitą_, икул, _सपा_, тну_,
   {{0x212dc0c7,0xceb2e095,0x127b200b,0xaefb78c6}},	//   kleh_, שיב_, _קאטע, _awùs,
   {{0x13e6007c,0x2739018c,0xe8034077,0x2167678e}},	//   _পেয়, réng_, _रेवा_, тици_,
   {{0x29068265,0x6f040143,0x3f8f835e,0xd9978009}},	//   rioa_, _mmic, gugu_, نخوا_,
   {{0x29068265,0x27e698c7,0x7c22417a,0x7d02c425}},	//   sioa_, ryon_, żors, _smos,
   {{0x39404013,0x66e3a01b,0x29068108,0x6b89cd53}},	//   omis_, роја, pioa_, ereg,
   {{0x8c1b61a9,0x64a6841b,0xb9e3a0ff,0x2d8ea0cb}},	//   _חולי, _шаба, ріши, rufe_,
   {{0x290481d7,0x0b46ae31,0x399aa0dd,0x78a28274}},	//   _imma_, _анан, sës_, mfov,
   {{0x6723a0ba,0x752d50e5,0x6ef4a090,0x6d4bd3f0}},	//   conj, zlaz, _bàbe, _eiga,
   {{0x6d4bd8c8,0x6d5a20c4,0xdddaa009,0x75244534}},	//   _figa, ítal, _tető, koiz,
   {{0x3ea9a29c,0x645bd8c9,0xcf936076,0x4bfba557}},	//   đate_, ccui, סטר_, _קלאס,
   {{0x6d586066,0x63a9805d,0x394b4017,0x213a2090}},	//   ívaj, _xpen, _rics_, _bhph_,
   {{0x48bd607c,0x6018ed15,0x7bc52133,0xd00fc0eb}},	//   _আক্র, _поля_, _prhu, _بله_,
   {{0x35e4203b,0x6d4bd8ca,0x2c5851b0,0x6f0730c5}},	//   ацтв, _yiga, _ọda_, rijc,
   {{0x7d0738cb,0x8c6441fc,0x3f57617a,0x6d4bd8cc}},	//   sijs, итуд, _dħul_, _xiga,
   {{0xf54a0016,0xab5d8227,0xdddc6106,0x291c6143}},	// [14d0] _cấu_, _arżn, _perş, čvan_,
   {{0x752d58cd,0x7cf5c0e0,0x6abc78ce,0x399c6049}},	//   slaz, _tárg, _carf, fís_,
   {{0x613600e0,0x78bb8004,0x8c3dd45a,0x2d58a0fa}},	//   lála, _pauv, leşt, _née_,
   {{0x249860ae,0x506440ff,0x3ebce3d1,0x6ef5ca7d}},	//   _ecrm_, _втра, _lavt_, _kábe,
   {{0x613600e0,0x78bb98cf,0x07a58501,0x6723b8d0}},	//   nála, _vauv, уалн, tonj,
   {{0x3f8f98d1,0xa3c04c87,0x8c3dc12a,0x2d58ae2d}},	//   rugu_, ंटर_, ieşt, _bée_,
   {{0x442ca1cd,0x27e958d2,0x10a5c14a,0xc878e181}},	//   _cyd_, lyan_, гийн, dağ_,
   {{0x27320026,0xe1ff0009,0x26cd804d,0xe3b0a047}},	//   váno_, tból_, _uneo_, تره_,
   {{0x2d9ef8d3,0xf771c19a,0x6abc60a2,0x442ca827}},	//   ette_, حاب_, _yarf, _eyd_,
   {{0x6d4bc050,0xe9d9e2d8,0x291248a7,0x2d912160}},	//   _wiga, еко_, znya_, kuze_,
   {{0x6e2d18d4,0x6605f497,0x442ca1cd,0x6d55749a}},	//   _ayab, упна, _gyd_, _juza,
   {{0x442d8b01,0x291244b4,0x9407603c,0x68ed58d5}},	//   _kye_, xnya_, ünə_, jkad,
   {{0x61360db3,0x6e2d000f,0x7ae1a106,0x7cf260ff}},	//   gála, _cyab, _kolt, _læra,
   {{0xe8d0898a,0x2cbfc10a,0x68ed4025,0x7c2d18d6}},	//   _सच्च, ldud_, ekad, _dyar,
   {{0x75298939,0x68ed4143,0x7d0402a4,0x2739e0fa}},	//   _okez, fkad, _tmis, gène_,
   {{0xa3b7c2b4,0xf992e087,0x3ebfd8d7,0xa91de12d}},	//   _चना_, _הרה_, ndut_, ružu,
   {{0x7c2d18d8,0x3f9fc04e,0x2b40542f,0x69c778d9}},	// [14e0] _gyar, ntuu_, rmic_, _arje,
   {{0x2d91295b,0x7cf14277,0x7bcb01ae,0x7d09d8da}},	//   buze_, _våra, _água, hies,
   {{0x3f9fc04e,0xdb0d227f,0xea76e00b,0x409b200b}},	//   htuu_, _grañ, רגער_, _אביס,
   {{0x6d5562e2,0x29124058,0x27e95122,0x61fbc037}},	//   _duza, qnya_, byan_, kzul,
   {{0x66e6a2fe,0x3f58a069,0x7bc65016,0x442cb8db}},	//   лода, _séu_, _urku, _syd_,
   {{0x6d5605d2,0x69c458dc,0xa2a1c567,0x672982f4}},	//   _muya, mvie, क्स्, _ekej,
   {{0x2d9244cd,0x68e1b8dd,0xa6db4765,0x69c28110}},	//   luye_, _dold, _viðv, svoe,
   {{0xc448c050,0x28ab8029,0x3cedc022,0x717680eb}},	//   نیان_, _टॉपि, gkev_, _مهرا,
   {{0x7cf5d8de,0x2d92400f,0x6130610a,0x3f924106}},	//   _bárb, nuye_, välj, nuyu_,
   {{0x2d8b00e4,0x7aed4265,0x8c3dc12a,0x2126807d}},	//   vrce_, zkat, veşt, looh_,
   {{0x4034e312,0x6ef5c03e,0x59b6c0a8,0x23608018}},	//   ренс, _sábe, _अनवर, ģiju_,
   {{0x28d2e437,0x2ca6d8df,0x61e5a105,0x21268098}},	//   ताहि, _ubod_, ähle, nooh_,
   {{0x588723fc,0x628401cd,0x7c2e78e0,0x6abe200f}},	//   лыва, _ddio, _lybr, _bapf,
   {{0xac97e13a,0x6d4e64fd,0x290a38e1,0x3f912108}},	//   _منها_, _niba, giba_, tuzu_,
   {{0x5186e0fb,0xd13b4df6,0x7e57a0be,0xe801010a}},	//   _сула, еха_, רסלב_, _लइका_,
   {{0x5577a00b,0x61360009,0xa3c24870,0x8c3dd49c}},	//   טעלן_, láln, ्मं_, peşt,
   {{0x7ae2c6eb,0x290a38e2,0x65954967,0x3ea905c8}},	// [14f0] _moot, biba_, разу, _ibat_,
   {{0x63ad18e3,0x68e2c4ef,0x27e958e4,0x442d98e5}},	//   _ipan, _lood, ryan_, _rye_,
   {{0x2bc30010,0x53354d59,0x62852011,0x66282089}},	//   शिवा, _вент, _idho, čské,
   {{0xd5b860fb,0x43954056,0xdd9544a7,0x2d8ce049}},	//   ысу_, _камс, _камы, irde_,
   {{0xc879c3ed,0x960da0a8,0x67256052,0x3cedc022}},	//   vaş_, िप्ट_, pohj, vkev_,
   {{0xc05ba0ff,0x69c3a037,0x6b8d4271,0xdd01e06f}},	//   хід_, tvne, mrag, _ľuďo,
   {{0x3ebea31b,0x25aca0ae,0xa2d80026,0xd2296049}},	//   _datt_, _cpdl_, याम्, _شكره_,
   {{0x2d936057,0x7ae1b8e6,0xa91de143,0xb385cf0e}},	//   muxe_, _wolt, mrži, алил,
   {{0x98a043ce,0x62852ea2,0x7ae1a576,0xe0d6c1ba}},	//   slić_, _odho, _tolt, рвы_,
   {{0x613603e4,0xe8df8067,0x3ebea2a4,0x2cbf9406}},	//   gáln, _biện_, _gatt_, _haud_,
   {{0x6da5e471,0xe80c4a30,0xe5a5eb92,0x7d09d8e7}},	//   шина, _सेना_, шини, pies,
   {{0x6b8d58e8,0x3325e17b,0xdb09e03e,0x7cf02262}},	//   krag, solx_, rveñ, _päro,
   {{0x9967cb2d,0x3ebea17b,0x7ceb20cb,0xe8eee26f}},	//   _стел, _yatt_, _züri, _дл_,
   {{0x80a1d073,0x2d92400f,0x7a4020e0,0x394fc04d}},	//   क्रे, vuye_, játé, _higs_,
   {{0xd62a38e9,0x6d57203e,0x6b8d57e7,0x7cefa14f}},	//   тове_, _cuxa, erag, _rørl,
   {{0x290a335e,0x225fccd4,0x6d4e62e8,0x2d92400f}},	//   siba_, ncuk_, _siba, tuye_,
   {{0xa2b8c0ec,0x8be9a07c,0x7cf4b8ea,0x798d4aaa}},	// [1500] ्यत्, _কেমন_, _làra, graw,
   {{0x577b000b,0x629b807b,0x7bc440ba,0x7e7bd8eb}},	//   _שטיצ, _acuo, rviu, haup,
   {{0x4ada051d,0x6d4e6296,0x63ad0143,0x7ae40052}},	//   _बचाव, _viba, _zpan, _koit,
   {{0xa3ba07f1,0x7b668056,0x26d17477,0x2bb6c295}},	//   _घना_, атке, _enzo_, _अनला,
   {{0xb146a0fb,0x2a6981af,0xa6db4069,0xe3b280a4}},	//   андл, ñaba_, _viðt, ترا_,
   {{0x7e7c2193,0x6d4458ec,0x68e406f1,0x6d428265}},	//   narp, lmia, _loid, smoa,
   {{0x7d0aa069,0x26d218ed,0x3af8c04a,0x612b78ee}},	//   rifs, _onyo_, _lépe_, rült,
   {{0x1fa6ca47,0x68e3f8ef,0x26d20b01,0x3f8dc41a}},	//   арог, _aond, _nnyo_, freu_,
   {{0x7ae3f8f0,0xdfd0c13a,0x7e7ae0b8,0xfbc940a3}},	//   _bont, سيد_, tatp, रियम,
   {{0x387878f1,0xb4d52292,0x5f94e471,0xa2cdf1c9}},	//   _jerr_, _सचे_, биот, ताग्,
   {{0x387860dd,0x2718842e,0x26c0003e,0x80b8cff1}},	//   _merr_, nčno_, _baio_, ्यदे,
   {{0xab5b4669,0xe8df8081,0x6f164064,0x442ee31d}},	//   _früh, _viện_, jnyc, _vyf_,
   {{0x7e7ae133,0x442ee1cd,0x81c7a018,0x4bd7c0eb}},	//   patp, _wyf_, rtēš, _نبود_,
   {{0x7e7c28a5,0x2fc918f2,0xd943eae2,0x7cf02241}},	//   garp, _vrag_, _дечи, _härj,
   {{0xbbb6c578,0x60c298f3,0x39586153,0x68f618f4}},	//   _अनुक, kdom, _nurs_, _flyd,
   {{0x629c78f5,0x248d20b0,0x8c1ba3c8,0x2fcd6012}},	//   _acro, şem_, דולי, _čeg_,
   {{0x7e7d18f6,0x63a298f7,0x38786ccc,0x6b55a013}},	// [1510] masp, jton, _berr_, _išge,
   {{0xf54a0016,0x63a29518,0xf8bf4050,0x7e7d18f8}},	//   _hấp_, dton, _waé_, lasp,
   {{0x2455824d,0x8af9a03c,0x6519463b,0xddc2c6ca}},	//   مناس, nləş, _مقدس_, _neož,
   {{0x63bb8037,0x9c7ca07f,0x6728e361,0x2b586197}},	//   _psun, _roča, hodj, _durc_,
   {{0x63a28b5e,0x7f3a4095,0x6d58f8f9,0x752d0167}},	//   gton, _תערו, _luva, _mkaz,
   {{0x61eb81cd,0x290cf8fa,0x7d0b8a13,0x6d5dc07b}},	//   rygl, jida_, sigs, ísam,
   {{0x7db4613a,0x6728e1e4,0x60c08024,0x60c298fb}},	//   _وصفا, dodj, _famm, bdom,
   {{0x613066eb,0x38786098,0x2bb0e7af,0xce948425}},	//   väli, _zerr_, _जनजा, _масъ,
   {{0xc6928053,0x26c000fc,0x3878605d,0x5ac6c20e}},	//   _מאן_, _raio_, _yerr_, слым_,
   {{0x5ea5e711,0x7cefa042,0x9c7ca38a,0x6d444064}},	//   حمدل, _mørk, _toča, zmia,
   {{0x6d4441cd,0x60c1a057,0x2721c066,0x7cf02156}},	//   ymia, _ialm, zóny_, _färj,
   {{0x81ae407c,0x61ed400d,0x8a1480e0,0x61322069}},	//   কিত_, kyal, _اظہا, mæli,
   {{0x78a92199,0x6ef5c057,0x26c138fc,0x6f098088}},	//   đevn, _gába, _baho_, _mmec,
   {{0x2a7d8ca1,0x612da005,0x6113c0ba,0x6f1b8320}},	//   hawb_, cúlt, dăli, _ljuc,
   {{0x7ae418fd,0xd94617ef,0x68e4010a,0xdbdc405c}},	//   _toit, _леки, _toid, ršíc,
   {{0x7d0d58fe,0x2a787773,0x4bda4052,0xfb86e555}},	//   gias, _serb_, льзя_, _ادوی,
   {{0x78b64098,0x0686679a,0x82970095,0x66eee857}},	// [1520] _čavč, йган, _הדפס_, _चकमक_,
   {{0x23b7a010,0xdfcf413a,0xdb1ac5df,0xc8d260a8}},	//   _आनंद, عيل_, _estè, साइट,
   {{0xf536e053,0x0b62c125,0xcc7ae00b,0x2a572076}},	//   צטער_, _mụọr, רװער, _לבין_,
   {{0x6d45628f,0xe9f902f4,0x2fc680e4,0x53a6464d}},	//   amha, _abẹ_, tvog_, _ламб,
   {{0x09e0607c,0x613618ff,0x213f818c,0x60c09900}},	//   _যেখা, váll, _dhuh_, _vamm,
   {{0x60c0811d,0x6d456420,0xf8bf40eb,0xe762d1b0}},	//   _wamm, cmha, _akéh_, _nọọs,
   {{0x81e6607c,0xceb32095,0xdbf1c04a,0x63a45901}},	//   _বের_, פיה_, _dřív, ltin,
   {{0x5f068099,0x7528e0c2,0x7c3aa06e,0x92d8a07c}},	//   _узба, wodz, _vztr, াসে_,
   {{0x69c72579,0x2000412a,0x60c44e88,0xac18c79d}},	//   zvje, nzii_, idim, ропу_,
   {{0x2bc945c5,0x610f6013,0x3ae74046,0x7d09802e}},	//   रिता, _gėlė, _lõpp_, _zmes,
   {{0xda6fc0db,0x290ce4a8,0xd8db600b,0x7e7d1902}},	//   _ня_, rida_, אקיר, tasp,
   {{0xdc3ba00b,0x7e629903,0xa91df904,0x39400153}},	//   _געבר, ncop, držu, _chis_,
   {{0x6f0d5905,0x290a6264,0xa1590917,0x5162c031}},	//   viac, _omba_, рагу_, _fọọm,
   {{0x6d4601f3,0xd6d7207c,0x55580d82,0xa99bc076}},	//   amka, হস্প, саря_, _עבור,
   {{0x26c32258,0x7d0d5906,0x6f0d5907,0xff294049}},	//   rdjo_, tias, tiac, لكسي_,
   {{0x798280c2,0x443ce012,0x7cf5c049,0x8c0061a6}},	//   ksow, _izv_, _lárn, ্থান_,
   {{0x7ae5203a,0x60c2c296,0x2d83600a,0x6eede0cc}},	// [1530] _toht, _maom, _svje_, _súbi,
   {{0x7529c167,0x212b1908,0x4e78668c,0x3b0dc037}},	//   zoez, loch_, محمد_, zieq_,
   {{0x80ca88ae,0x25a4d909,0x7d0d453f,0x96eb84e4}},	//   _सोहे, html_, pias, льда_,
   {{0x248900ae,0x41a9c10a,0xfc3f007b,0x61ed4106}},	//   _jdam_, _कहलस, nfío_, pyal,
   {{0xdbf1c04a,0x2919190a,0x3e4ee03c,0x3f8f990b}},	//   _přív, insa_, hət_, urgu_,
   {{0x2a7d8022,0x3e4ee5fc,0x70b3a35b,0x4b7c0053}},	//   sawb_, kət_, ंजेल, נאוו,
   {{0x6d58603a,0x6a9c2095,0x7bc7c041,0x0579a13a}},	//   ívat, אשונ, ājum, جمعة_,
   {{0xab65c7c5,0x6f65cc9d,0x6d59c0f2,0xfd4c6088}},	//   овил, овиз, _puwa, _obiọ,
   {{0x7ae76022,0x0edd0295,0x3ce5b90c,0x7c3b990d}},	//   _kojt, यानड, _tolv_, _uzur,
   {{0xd709e04e,0xe450813a,0x1309e04e,0x1fe4e07c}},	//   рное_, _أضف_, рной_, _ফেইস,
   {{0x60c5613a,0x39400286,0x6b840b48,0x273c990e}},	//   idhm, _phis_, _svig, lína_,
   {{0x2b83e03c,0x7ae7600e,0x7afd190f,0x2bba4026}},	//   rıc_, _lojt, ghst, _उनला,
   {{0x63a4490b,0x386d1910,0x6d5aa186,0x613600e0}},	//   xtin, ñera_, _zuta, lálk,
   {{0x6d5b948e,0x63be2037,0x1869e6fc,0x29191911}},	//   _muua, _pspn, _таки_, ansa_,
   {{0xddc3207a,0x3ce6c048,0x6916006e,0x6f0f0197}},	//   мбри, _yoov_, jšeg, bicc,
   {{0x61306105,0x672b8939,0x463ae00b,0x6f0f177e}},	//   hält, jogj, _דעצע, cicc,
   {{0x82fa00d0,0x656d4e87,0xe5a34bcd,0x63bbd912}},	// [1540] _مرکز_, gpah, мити, nwun,
   {{0x80d80010,0xeb91000b,0x60c41913,0x200052ab}},	//   यावे, _אָט_, _haim, rzii_,
   {{0x656980dd,0x25bf8bae,0x3eb83914,0x68e77915}},	//   _ateh, _asul_, mert_, _dojd,
   {{0x2d983916,0x7cfcc0e0,0x290f9917,0x4c3b2095}},	//   mure_, _kére, giga_, _כתיב,
   {{0x44209918,0x39408041,0x387fc753,0x87ba8052}},	//   çi_, ķis_, daur_, рует_,
   {{0x7cfcc0e0,0x6b845919,0x3eb8391a,0x141b4095}},	//   _mére, msig, nert_, _כוכב,
   {{0x7769991b,0xc8ca127e,0x20dd0010,0xbbba410a}},	//   _etex, ियाट, यामध, _उनुक,
   {{0xa3cdf91c,0x3e4ee5fc,0xddaac0ba,0x7e7b904d}},	//   रिन_, vət_, атол_, _geup,
   {{0xd012850f,0x69cc2010,0x6d5aa068,0x629c23b0}},	//   _غلط_, हिडी, _wuta, kgro,
   {{0x26c4991d,0x9980c03b,0x97a6e6fc,0xd8f8e0ff}},	//   _hamo_, _šių_, ормл, сної_,
   {{0x60c4191e,0xb4b6a0c2,0x6ef5ca7d,0x6f0f0197}},	//   _baim, ज़ी_, _kábl, ticc,
   {{0x3f982e05,0xdb1d6017,0x46d1c0c2,0xa3ca4f30}},	//   duru_, _essè, _दोपह, लटा_,
   {{0x3eb8391f,0x6f0f121e,0xdcfb0041,0x212b1920}},	//   fert_, ricc, gstā, roch_,
   {{0x7c22c17b,0x212b1921,0xfbc9437f,0x6ef920f9}},	//   _ixor, soch_, रिसम, _bìba,
   {{0x41e6ea0e,0x2d853922,0xa8eec026,0x67f10031}},	//   _філа, éle_, _जवाफ_, _bójú,
   {{0xae1ec2b4,0x25a6836c,0x443ea04d,0x7ae8a22e}},	//   _बखान_, ktol_, _mzt_, _lodt,
   {{0x7d0d1923,0x31b7a2b4,0x6b845924,0x2bcdc118}},	// [1550] _imas, _आन्ध, gsig, ़िया,
   {{0xd131601e,0x68e8a0fd,0x629c258f,0xfe706047}},	//   رما_, _nodd, cgro, ندم_,
   {{0x7f5b8054,0x7e7b8004,0x6cd54ef8,0x3f991925}},	//   _suuq, _peup, _فقدا, lusu_,
   {{0x6d41b926,0x60c4003e,0x7bce7927,0x6367c06f}},	//   _shla, _xaim, _drbu, nčný,
   {{0x6d41b928,0x2d99010a,0x6f0d0079,0x9f35a0ff}},	//   _phla, nuse_, _mmac, педі,
   {{0x1fd0c07c,0x7d0d1929,0x61e00156,0x6d5d5806}},	//   িহাস, _lmas, ämli, _iusa,
   {{0x3f84c018,0xd49b801b,0x0ec68857,0x7cf8404a}},	//   esmu_, _врз_, _रोकड, _mírn,
   {{0x66b4804e,0x7cf026eb,0x85bb8050,0xb065e052}},	//   _обсу, _väri, _پارس_, kkää,
   {{0xdd9181b3,0xc3344095,0xf991c13a,0x656985f9}},	//   _سوا_, ווק_, ربة_, _uteh,
   {{0x69c9d92a,0x4805e0ff,0x3d948702,0xb87b4057}},	//   rvee, зпов, _цифр, _elíx,
   {{0x2cb8392b,0x60c3e54c,0x2d99192c,0x80d80026}},	//   verd_, _vanm, euse_, याले,
   {{0x69ace877,0x443dc0c2,0x2d98392d,0xdce4207f}},	//   _जहरी, _tzw_, vure_, _vtič,
   {{0x60c406eb,0x6136192e,0x2cb82b83,0x7cf5c009}},	//   _vaim, náli, terd_, _járm,
   {{0x186726bd,0x7ae9810a,0x2d92592f,0xa0672df6}},	//   зари_, _loet, vrye_, зара_,
   {{0x2732a1fc,0x68fb9930,0x3eb820ff,0x7bcf4189}},	//   mânt_, _olud, rert_, _arcu,
   {{0x26c5a2ed,0x613d08aa,0x2d983931,0xc0e35932}},	//   _lalo_, péla, rure_, носк,
   {{0xae0c4029,0x6d5d5933,0x2fc00cc5,0x3f983934}},	// [1560] _सेशन_, _cusa, _usig_, suru_,
   {{0x69cc210a,0x6eedf935,0x39494013,0xfd1f41e9}},	//   हिदी, _túbu, amas_, _ejì_,
   {{0x6d440223,0x6d561936,0xf8bdc39f,0xa2d921b0}},	//   _khia, _kiya, ्याय, मार्,
   {{0x7ae982d2,0x4fc683fc,0xdb0587da,0x68e99937}},	//   _coet, зска, nthè, _coed,
   {{0x2718806e,0x6280caba,0x92e926b0,0x443ea0c2}},	//   nčni_, vamo, _طریق_, _szt_,
   {{0x7afb9938,0x26c5b939,0x7e7e33e2,0x66044167}},	//   _elut, _calo_, _jepp, mzik,
   {{0x25a6993a,0xf76fa050,0x9c7ca143,0x2560d93b}},	//   stol_, هاي_, _hočk, _sòl_,
   {{0x361b6095,0x61e1393c,0x6d5e2173,0x9c7ca04a}},	//   _הולד, älli, _mupa, _kočk,
   {{0x29112bb1,0x2056ac84,0xbcfb793d,0x7cf36181}},	//   yiza_, _етер, _stéi, _fırı,
   {{0x8626e936,0x98b8803b,0xfee9a13a,0x6d561280}},	//   зьме, _kurį_, _وعلى_, _aiya,
   {{0x645aac57,0xb5caa68c,0x6d42c016,0xdceb438a}},	//   _igti, _دوام_, _thoa, _žiča,
   {{0x6d49d93e,0x63a4c0ba,0x3866993f,0x7c22c108}},	//   cmea, _ţinu, ncor_, _txor,
   {{0xa5bb4005,0x703ac233,0xc8c82046,0x68e4400a}},	//   _axón, _اساس_, िएंट, djid,
   {{0x3f82c013,0x6d55c03e,0x7e7e2c65,0x2d9a7940}},	//   škus_, _ézar, _cepp, kupe_,
   {{0x368b48e4,0x7f556939,0x2561e3e4,0x387eb941}},	//   йсан_, _rizq, _gól_, _metr_,
   {{0x539be095,0x6d557942,0xf4082049,0x7cefa271}},	//   _היהו, _siza, سيقى_, _hørt,
   {{0xa5bb4057,0x6eefa065,0x690921e4,0x7ae98aaa}},	// [1570] _exón, _købt, džev, _roet,
   {{0xd7fc0076,0x27320057,0x7e7e2425,0xd25b60db}},	//   _להחל, báns_, _gepp, сца_,
   {{0x7ae98db2,0x3f8760b5,0xfe7040e0,0x656d01f6}},	//   _poet, énu_, ئدہ_, _htah,
   {{0x79856011,0xe8d93943,0x29190050,0xd2518886}},	//   rshw, _muọ_, érah_, ننا_,
   {{0x9989803a,0x6f00c049,0x6ea51303,0x6d5e3944}},	//   ťaž_, dhmc, _कानु, _zupa,
   {{0x2d51c04a,0x61361945,0x799af665,0xa49b458f}},	//   _všem_, ráli, kutw, _blòg,
   {{0x6d49d946,0x61361947,0x26c5b0aa,0x7ae37948}},	//   tmea, sáli, _valo_, öntu,
   {{0xa2a2d17d,0x6d573949,0x61360803,0x6d4a4197}},	//   _गाण्, _lixa, páli, _èfat,
   {{0x752f00c2,0x6d44194a,0x7f5f017a,0x25a7a171}},	//   docz, _rhia, _nuqq, stnl_,
   {{0x799ae167,0xca48a050,0xa49b4030,0x5589e8c0}},	//   futw, _کلمه_, _flòg, обом_,
   {{0x112bc6fc,0xdb01c065,0xb5fb0049,0x27320057}},	//   _люди_, _oplø, scál, xáns_,
   {{0x6d45394b,0x6d440048,0x3f85e069,0x6d572733}},	//   _ahha, _qhia, rslu_, _aixa,
   {{0x060702fe,0xe9dbe0eb,0xe8df8119,0x6d57215a}},	//   дняк_, _گذشت_, _nhọn_, _bixa,
   {{0xf1bcc982,0x60c640eb,0x61306262,0x6f1d1157}},	//   ्टरन, _sakm, jälp, ansc,
   {{0x78ad594c,0x2912594d,0x6da326bd,0xe9a320ff}},	//   ffav, tiya_, кира, карп,
   {{0x7c240265,0x9c7ca431,0x7cefa22e,0x29137615}},	//   _txir, _počk, _kørs, eixa_,
   {{0xdb0b0057,0x3eba612a,0xaec66297,0x46ea74b0}},	// [1580] _esfó, tept_, мбал, одан_,
   {{0xddc8b94e,0x6fb1e029,0x6d5e394f,0x68e45950}},	//   _redž, _जहां, _tupa, sjid,
   {{0x80a64aa1,0x6b898931,0x7cf5c0e0,0xddc8a6a6}},	//   _छापे, _aveg, _várj, _sedž,
   {{0x31be604a,0x6b838088,0x2d9a6282,0x3eba7951}},	//   _vůz_, _ọgar, rupe_, sept_,
   {{0x656d005d,0x094ab3fc,0x2ca040ae,0x914ab952}},	//   _xtah, очки_, mgid_, очка_,
   {{0x248d9953,0x78a2d796,0xdcfc4013,0x229481e9}},	//   _edem_, _scov, turė, _búkà_,
   {{0x3f869954,0x31601955,0x28cf8029,0xa2db6260}},	//   ssou_, _luiz_, _सोवि, नार्,
   {{0x63a9c828,0xddc8a098,0x6efcc050,0x78bc2747}},	//   ften, _tedž, _béba, herv,
   {{0x2004c38a,0x61fda5fc,0x5d54e16c,0x395f9956}},	//   uzmi_, _əsli, нкит, _guus_,
   {{0x7cf1478c,0x3374e450,0x2732b044,0x395eb957}},	//   _hårt, нгор, râns_, _tuts_,
   {{0x65609958,0x8e976076,0x611500bc,0xa7151593}},	//   _humh, ודיו_, едну, емні,
   {{0x6f029959,0x6f1d00cb,0x799c395a,0x6d57395b}},	//   nhoc, unsc, durw, _sixa,
   {{0x613883b8,0xb95b40f9,0xa294e84f,0x7cf14156}},	//   gíli, _asìn, _залі, _mårt,
   {{0x6abc395c,0xe60fe0d0,0x78bc395d,0xdb05995e}},	//   gerf, اشی_, gerv, rthé,
   {{0x799c200f,0x5757e076,0x672f07a0,0xf2c741d3}},	//   gurw, _קבוע_, pocj, мсан,
   {{0xa2d6e028,0x66252018,0xd25825d0,0x7cf02262}},	//   बाक्, _ārkā, ьця_, _bärs,
   {{0x44386090,0x6d58f95f,0x69dca057,0x3f8e6098}},	// [1590] _ayr_, _kiva, _áref, šful_,
   {{0x3eb200c2,0x80c9610a,0x3ea48012,0x291ef960}},	//   _zbyt_, _होखे, _acmt_, nnta_,
   {{0x65608090,0xf1c8c067,0x6b9d1961,0x6b9c3044}},	//   _aumh, _lỡ_, lusg, curg,
   {{0x62808753,0x7aed0265,0x2b5860ae,0x6f152106}},	//   _cemo, _joat, _eirc_, lizc,
   {{0x38c4a013,0x2f1ac018,0x387f862c,0xd838a030}},	//   kūrė_, cīgi_, _veur_, _ayč_,
   {{0x39595962,0x68ebd963,0x98c622e2,0xdb1ba049}},	//   _hiss_, _sogd, ćući_, _tsuí,
   {{0x291166df,0x2b46c153,0x78bd05ee,0xa295803b}},	//   _imza_, _bhoc_, kesv, _паві,
   {{0x6b899964,0x6b9d1965,0x61f86042,0x673ae54c}},	//   _tveg, kusg, øvle, eltj,
   {{0x78bbc004,0xc8aba14a,0x6138841a,0x39595966}},	//   reuv, _мъже_, xíli, _miss_,
   {{0x78a4065f,0x8af0603c,0xddd8a16d,0x6d4d4025}},	//   _sciv, qqət, savš, hmaa,
   {{0x68ed0593,0xb4db58c6,0x24800057,0x260fc621}},	//   _boad, _ahàm, _peim_, _तेरी_,
   {{0x3ce0c010,0x6abd0b45,0x6722c3ac,0x6abc3404}},	//   काणे_, gesf, _gjoj, werf,
   {{0x6d4d423c,0x6abc2732,0xb4db4153,0x799d13cd}},	//   dmaa, terf, _chàm, gusw,
   {{0x61388912,0xb4bc8029,0x62857967,0x6d4d4d53}},	//   ríli, _अस्_, jaho, emaa,
   {{0xe8168064,0x612803ed,0x7529416d,0x62857968}},	//   _देना_, tıld, čezn, daho,
   {{0x07a60974,0x645c7969,0x6abc2271,0xa3bef3e3}},	//   _заин, _sgri, serf, ुटर_,
   {{0x28dd0aa1,0x2ca04d22,0x2bd2c918,0x6d59d96a}},	// [15a0] यारि, rgid_, तिया, _miwa,
   {{0x6d4d41dd,0xaaac037f,0x628449fe,0x6285748b}},	//   amaa, ट्रक, saio, gaho,
   {{0x6284596b,0x499a639e,0x39586a98,0x2b59596c}},	//   paio, ятая_, _virs_, _fisc_,
   {{0x60c8b96d,0x4427e2a8,0x6ef5ce20,0x2bd2d96e}},	//   _sadm, _mxn_, _fábi, तिमा,
   {{0xddcd412a,0x753bd152,0x69c3622e,0xc95301a1}},	//   rbaţ, dluz, æner, אמא_,
   {{0x6561a066,0x2d9cb96f,0x66e3a39e,0x7d045970}},	//   _bulh, tuve_, лоча, lhis,
   {{0x044373b0,0x7cf15971,0xfc3f4057,0xb87b006f}},	//   _берн, _tårt, _icía_, rkíz,
   {{0x44443972,0x3dc20939,0x7d152098,0xcf932076}},	//   _mz_, kwkw_, zizs, אטה_,
   {{0xd11780be,0x0326a052,0x69dca143,0x925aa0eb}},	//   _נקמה_, _здан, _šred, _فشار_,
   {{0x67241973,0x291ef974,0xdbdbe0f9,0x753ae108}},	//   _ajij, unta_, _bààr, ultz,
   {{0x7aee65f9,0xed4fa050,0x61360e34,0x2900058f}},	//   _mobt, _اپل_, jáls, _blia_,
   {{0x62857975,0xf1c9e067,0x6d4d4054,0x7bc65976}},	//   zaho, _dạ_, xmaa, _osku,
   {{0x040b4016,0x6561b977,0x7cfcd978,0x78bd1979}},	//   _dưỡn, _zulh, _héro, resv,
   {{0x443f417a,0x2bc5b17d,0x656fd97a,0xe8b58106}},	//   _ġu_, विचा, íche, kışı,
   {{0x764401a5,0x4427e067,0x7a490041,0x69c657bb}},	//   _eziy, _gxn_, _sūtī, _aske,
   {{0x69dd8057,0x98a50018,0x6d4d597b,0x9f6038ff}},	//   _áseg, ēlē_, umaa, árás_,
   {{0x3959597c,0x10174050,0x7e6d0f8f,0x7cf02277}},	// [15b0] _viss_, ربرد, _ifap, _värr,
   {{0x3ea16095,0xbebce041,0x3ebef3e9,0x8e2776f4}},	//   ught_, lnīb, nett_, нфед,
   {{0xa2d06010,0x7bc5266b,0x60db8057,0xd4986013}},	//   _डोळ्, _ushu, _pnum, эрт_,
   {{0xe4e4812e,0xdbe402f4,0x395a202e,0x29012187}},	//   лічн, _béèr, _zips_, _hlha_,
   {{0x26118216,0xdca5a607,0xbea5a58a,0xa2a1e984}},	//   _देशी_, вали, валк, _खाल्,
   {{0x26ca797d,0x2d990049,0x2d8b197e,0x2d9d997f}},	//   _gabo_, irse_, isce_, ruwe_,
   {{0xa92804d2,0x7c2920cb,0x6d48a58f,0xf2d42053}},	//   nažé, ßerh, _dhda, טעס_,
   {{0x78a28098,0x6efcd980,0x26cb5981,0x62872530}},	//   cgov, _débo, _jaco_, hajo,
   {{0x20095982,0x26ca7983,0x13b48ef8,0x62873984}},	//   nzai_, _yabo_, _مصلح, kajo,
   {{0x779080e0,0x394905c8,0x9e07a822,0xdcfc4018}},	//   _ایوا, _ahas_, _пчел, turī,
   {{0x2d9ef985,0x8cd6e0c2,0x2b490256,0x60cd4013}},	//   gute_, बाजो, _bhac_, kdam,
   {{0xdb1ba108,0x23dd0077,0xb815c39d,0x6282c3b0}},	//   _iruñ, ममंद, _идеј, _geoo,
   {{0x7afbcfd6,0x6562c0a2,0x2b490025,0x78b56066}},	//   mkut, _guoh, _dhac_, _obzv,
   {{0x81e7407c,0x2eeee227,0x6d5ab986,0xed573702}},	//   বনা_, _goff_, _xita, коя_,
   {{0x2905e569,0x6b8d01f6,0x395a3987,0x98ad81f6}},	//   mhla_, _evag, _vips_, _gieħ_,
   {{0x2eeef988,0xa3e18026,0x7fd641b4,0x752401df}},	//   _zoff_, धमा_, кізі, _ujiz,
   {{0x6563f989,0xccf30095,0xb4db05df,0xdceac29c}},	// [15c0] _hunh, _ככה_, rmàt, žiće,
   {{0x60cd598a,0x26ca6054,0xc7d70076,0x799e60ce}},	//   adam, _qabo_, _יופי_, tupw,
   {{0xa50a4421,0x1d0a467b,0xdb0f6057,0x68fbc10a}},	//   _жена_, _жени_, _ascó, kkud,
   {{0x6563f98b,0x7afbc098,0x61e12156,0x65640167}},	//   _munh, jkut, ålle, _kuih,
   {{0x64a3998c,0x6d5b813b,0x26ca798d,0x2d9ef98e}},	//   рача, _diua, _tabo_, zute_,
   {{0x7cf26042,0x09c8e07c,0x26ddc0d1,0x62840108}},	//   _værs, ষমতা, _anwo_, _leio,
   {{0xcec36026,0x26cb4071,0x73e36792,0xdb1ba057}},	//   ářů_, _yaco_, _корз, _cruñ,
   {{0x4cc8a07c,0xab27c90f,0x7c3aa066,0x3ea280ff}},	//   লাধু, која_, _vytr, _økt_,
   {{0x7d03412a,0x7c292106,0x973d004d,0xff06e052}},	//   _înse, ğeri, nuće, вянн,
   {{0xc796a099,0x6722803b,0x3f9ef98f,0x60cae05d}},	//   _арды, lnoj, tutu_, _qafm,
   {{0x6b8d0954,0x5d5501e1,0x248481d7,0x4207a312}},	//   _svag, лкот, _kemm_, _инфо_,
   {{0x26cae42e,0x2d9ef990,0x60cbc426,0x68e9c579}},	//   žbo_, rute_, _gagm, cjed,
   {{0x6284015a,0x69d7e057,0x7bd7e005,0x6f02d8a3}},	//   _deio, _áxen, _áxun, _iloc,
   {{0x2905e4d2,0xd5b0e050,0x6f18a066,0xdb1e4153}},	//   chla_, _هفت_, nivc, _aspà,
   {{0x3949005f,0xa1582b7a,0x7aef4066,0xa438e0ff}},	//   _thas_, тару_, _poct, _язку_,
   {{0xbcfb64cd,0x21670052,0x78ada098,0x37045991}},	//   _cuén, _итог, đavi, ачув,
   {{0x7c8456f4,0x2b4a6569,0x7bcdc057,0x62873992}},	// [15d0] русе, _bhbc_, _áaut, pajo,
   {{0x26cca4fa,0x613d0004,0x6443403c,0x60cd5993}},	//   _nado_, déli, ənil, sdam,
   {{0x612806df,0x60cd1994,0xaaaa0c4c,0xf2b1807c}},	//   lıla, _kaam, _कामक, _ঘোষণ,
   {{0xf1b3e00b,0x28a7c046,0x7cf5c009,0x6916035d}},	//   יסע_, _गाधि, _járt, jšel,
   {{0x61280c2b,0x6d5d5995,0x69d56064,0x25f36010}},	//   nıla, _iisa, _wrze, ूनही_,
   {{0x6d5d5996,0xdb00e277,0x7cfcc057,0x7d02c157}},	//   _hisa, ntmä, _dérm, _alos,
   {{0x68e9c579,0x60c0d997,0x4fc46052,0xbebce041}},	//   tjed, femm, _кста, znīc,
   {{0x27e9b998,0x6d5c7999,0x7afd0200,0x6283f99a}},	//   ćan_, _zira, jkst, _seno,
   {{0x26ccb99b,0x26cdc019,0x3f42e069,0x7cff199c}},	//   _fado_, rdeo_, rðun_, _përn,
   {{0x6d5c686a,0x7e6d40c7,0x63bb8c96,0x6284199d}},	//   _xira, hcap, _ipun, _seio,
   {{0xd7c8a0eb,0xa2a50af7,0x7cfda011,0x6e3d4654}},	//   _لوله_, _काश्, _jèrm, _lysb,
   {{0x5a0ca00b,0x60c0c0fa,0x63a0c1fb,0x38612229}},	//   _קלאַ, cemm, bumn, _aghr_,
   {{0x26c1603a,0x333fc2a4,0x78a44042,0x48e0c0c2}},	//   keho_, mlux_, vgiv, कारो_,
   {{0x6da6207a,0x673521d7,0x3392c13a,0x2569c13a}},	//   лига, gozj, _الوز, _iúl_,
   {{0xd627234d,0x6285399e,0xb176e067,0x81e981a6}},	//   горе_, _deho, _trượ, মনি_,
   {{0xf2a340ba,0x60cd0b90,0x69d603ac,0xbebce018}},	//   йисп, _gaam, _trye, pnīc,
   {{0xa06a399f,0x26c219a0,0xd7f8a016,0x6b8d4644}},	// [15e0] _папа_, meko_, _ngăn_, gsag,
   {{0xcc36233e,0x6b9bd9a1,0x91e661c0,0x81e981a6}},	//   _مرجع, irug, лозе, মনা_,
   {{0x9f47805c,0xb8cc791c,0x2739003e,0xdb1e53c9}},	//   šný_, _गा_, céns_, _espá,
   {{0xbc1b200b,0xfce643d5,0x26ccb9a2,0x798d4022}},	//   _טויש, _сомо, _sado_, bsaw,
   {{0xd12f8049,0xaff540e0,0x752299a3,0xbcfb478d}},	//   أمن_, _پہلا_, rnoz, _diéd,
   {{0x63a1f86c,0x2907a0f7,0x613d19a4,0x6d5d59a5}},	//   kuln, ghna_, réli, _zisa,
   {{0x3ce0d133,0x26cca368,0x69c98af8,0xdfd0a13a}},	//   काले_, _vado_, _esee, زية_,
   {{0x443dc0e2,0x6b9bd9a6,0xaa7b403a,0x6f1981cd}},	//   _byw_, frug, _inýc, ciwc,
   {{0x8af0403c,0x171b800b,0x28e199a7,0x6b9bc8b2}},	//   mməd, _נומע, फारि, grug,
   {{0xd90de0d0,0x8af0403c,0x63a28167,0x3f14e471}},	//   وین_, lməd, muon, рдос,
   {{0x60cd01da,0x386983ee,0x6ef4a5df,0x59d2c026}},	//   _paam, žare_, _fàbr, तिहर,
   {{0x26c1600f,0x7d040ce5,0x443dc1cd,0x69dd8057}},	//   zeho_, _clis, _fyw_, _ásec,
   {{0x33f6c7b4,0xadf98148,0x8ff7d9a8,0x6b4b64f7}},	//   _حساس, ्नयन_, _مرور_, lüge,
   {{0xc6bf607c,0xf53f0584,0x27ff017a,0x59b8a984}},	//   _উচ্চ, slå_, ġun_, _आहार,
   {{0x6b4b6105,0x6f0419a9,0x29048181,0x1efbe053}},	//   nüge, _flic, _olma_, _אלגע,
   {{0x4275465f,0xf2df4067,0xb27541de,0x7f5d4746}},	//   ргас, _thâm_, рлаш, _qisq,
   {{0x248951f1,0x443dc022,0xd37147f0,0x351c0557}},	// [15f0] raam_, _xyw_, زها_, _רוחנ,
   {{0x6f0419aa,0x752459ab,0x798d4827,0x1da8e028}},	//   _zlic, aniz, rsaw, _कमात,
   {{0xfe1ae029,0xf647612e,0x6d4d0025,0x7deae03c}},	//   _फेमस_, ухан, _khaa, fəsi,
   {{0x6d5e39ac,0x60c1f8ee,0xba7420eb,0x0c7420eb}},	//   _zipa, zelm, _پایت, _پدید,
   {{0x91e599ad,0x7d1af9ae,0x6b656013,0x2b5ea090}},	//   роле, kits, _mėgi, _bitc_,
   {{0xe3b0254f,0x291a79af,0xeb99a0bc,0x6d4bc0a2}},	//   _بری_, cipa_, вик_, _shga,
   {{0x7cff000e,0xf075c0e0,0x3b06a14a,0x256ab03c}},	//   _përl, لیاں_, рещо_, _cùl_,
   {{0x2fd94098,0x1c1699b0,0x6ef84057,0x395ea07d}},	//   _krsg_, _देवल_, _fíbu, _eits_,
   {{0x2907a098,0x628aa1fb,0x63bb8167,0xab5b6046}},	//   phna_, bafo, _upun, _psüh,
   {{0x63a1e260,0x9f58400e,0x28a7c026,0xe787a12e}},	//   tuln, tyrë_, _गावि, _будо,
   {{0x60c3b3d7,0x8c45e192,0x28e2a3af,0x6f0419b1}},	//   menm, рене, पारि, _plic,
   {{0x33d5c139,0xcb6a1145,0x28d9ac87,0x68ed59b2}},	//   _вікт, каме_, _योति, jjad,
   {{0x7aed59b3,0x63a1f9b4,0x7f5f003c,0x26cfd719}},	//   djat, suln, _diqq, _iago_,
   {{0xa8568095,0x394d841a,0x8467e14a,0xd618c050}},	//   יירה_, _lhes_, _съде, _حتما_,
   {{0x673b800d,0x61fbc114,0xdb020851,0x26c20108}},	//   _okuj, lyul, ttlä, peko_,
   {{0x67244041,0x753b8096,0x056619b5,0xb22640d7}},	//   unij, _nkuz, _квин, амбл,
   {{0x60c3a1cf,0x7c3e2064,0x21a648ab,0x7b160066}},	// [1600] kenm, _wypr, ризм, yšuj,
   {{0xe0466406,0xef8639b6,0x67299973,0x673b87ed}},	//   анзи, _клоп, _ajej, _akuj,
   {{0x8ca7679e,0x6f1c39b7,0xcd29224d,0xc05960ff}},	//   _चारो, mirc, _حسين_, гії_,
   {{0x291a60a9,0x69d9d9b8,0xa5bb403e,0x26cfd9b9}},	//   sipa_, _orwe, _axóu, _nago_,
   {{0x60ce6022,0x88bce04a,0xe3b24949,0xfb37400b}},	//   _tabm, dněn, _برج_, _כאטש_,
   {{0x60c3b9ba,0xc7d70076,0x9ea7a60f,0x9713a71b}},	//   genm, יוני_, авља_, оміц,
   {{0x2120a06a,0xfbc7e33e,0x7cfccaed,0x7d1af9bb}},	//   đih_, _بت_, _héri, vits,
   {{0x6448a06f,0x8f9b2087,0x2900402d,0xdddc6143}},	//   _vzdi, דיקי, nkia_, _gerš,
   {{0x7b160066,0xa2db604b,0x7d1c2806,0xdb0219bc}},	//   pšuj, नाच्, kirs, pulê,
   {{0x443ea05d,0x7aed417a,0x273204d3,0x7f42956c}},	//   _tyt_, zjat, mány_, lloq,
   {{0x30d9600b,0xda6fc1fc,0x60d9600b,0x3cffc022}},	//   אַרע, _мя_, אַרג, bkuv_,
   {{0x6738b90b,0xe61ac844,0x2367e012,0x6f1bcd82}},	//   lovj, _иде_, _dunj_, ciuc,
   {{0x80a76984,0xa3c920c2,0x96470013,0x5067214a}},	//   _चाले, लौन_, рэнд, итва,
   {{0x644099bd,0x656099be,0x26c4d543,0x628b99bf}},	//   _mymi, _limh, lemo_, zago,
   {{0xfa77e1a9,0x68ed59c0,0x7cfcc004,0x06cf607c}},	//   _דעות_, tjad, _aéri, রামি,
   {{0x6287628e,0x5f73e25b,0x60c3a0f0,0x2cba2030}},	//   _sejo, _باور, zenm, _ebpd_,
   {{0x395f8017,0x6568a153,0x76b979c1,0x6738b9c2}},	// [1610] _rius_, _ludh, ллар_, kovj,
   {{0xd657c095,0x65608256,0xa857c076,0x5fc6a026}},	//   שימת_, _aimh, שימה_, लबाल,
   {{0x3135493b,0xdddc79c3,0x705520eb,0x68e2c291}},	//   _генр, _perš, _دندا, _onod,
   {{0xb6068098,0xf8c9e1e9,0xdb1ace06,0xa857e095}},	//   _opšć, _abẹ́_, _estú, ביבה_,
   {{0xee87604e,0x752999c4,0x7cff00dd,0x24890733}},	//   _выбо, _vjez, _përj, _meam_,
   {{0x6f1d1385,0xd006e711,0x248906f1,0x6288a197}},	//   hisc, _فل_, _leam_, _cedo,
   {{0xb3a9e497,0x6ef36026,0x43946323,0x60c3b9c5}},	//   _çıxı, _výbě, _марс, renm,
   {{0xdb03c00e,0x656fc3ab,0xaacf80a8,0x945d81e9}},	//   munë, ícho, _सोचक, _bańt,
   {{0x6d41e562,0x63a56058,0x6abb8079,0x26d179c6}},	//   tlla, luhn, _ibuf, _kazo_,
   {{0x7d09d9c7,0x6568a058,0x628d40ae,0x3cffc6b6}},	//   shes, _fudh, haao, skuv_,
   {{0x63a44171,0x7af579c8,0x7d1c39c9,0xdab9c0db}},	//   zuin, _mozt, virs, _былі_,
   {{0x7c3823d1,0x7ae2c6f1,0x6ef84019,0x7980c125}},	//   _øvri, _gnot, _líbr, _ịwec,
   {{0x7d1c39ca,0x61e12277,0x8fc7c343,0x38c840d0}},	//   tirs, ålln, _خزان, یاری_,
   {{0x78a9d9cb,0xa2ad2010,0x84e5c028,0x777bc03e}},	//   lgev, _जाण्, कावट_, mpux,
   {{0x78bb99cc,0x7d064041,0x236dc0dd,0x3f9ee29f}},	//   _obuv, _plks, lqej_, crtu_,
   {{0x0e664618,0x333919cd,0x63a459ce,0x3c6640db}},	//   скан, cosx_, tuin, скаг,
   {{0x9c82a03b,0x69c9d9cf,0x26d16ecc,0x6d4f59d0}},	// [1620] ščia, nwee, _bazo_, _dhca,
   {{0x2bd50010,0x26d162a8,0x6aa9c105,0x261963fa}},	//   दिरा, _cazo_, hgef, _येही_,
   {{0x23690048,0x387fc17b,0xa2ad28b1,0x69db8187}},	//   _zuaj_, kbur_, _जात्, _arue,
   {{0x23690048,0x2fc94006,0x78a9c171,0x2bef01a6}},	//   _yuaj_, bwag_, jgev, _চেয়ে_,
   {{0x6d4459d1,0x78a9c3b0,0xe5a388e9,0x6b45c057}},	//   mlia, dgev, зичи, rógl,
   {{0x31624037,0x2fcca005,0x76408066,0x68e2d9d2}},	//   _hikz_, _psdg_, _vymy, _snod,
   {{0x68e402f4,0x6aa9d9d3,0xa49b4031,0xfb1b6076}},	//   _onid, fgef, _amòy, _עולמ,
   {{0x656086a5,0x7bdaa066,0x6288a0eb,0x7986448d}},	//   _uimh, _vrtu, _wedo, _kwkw,
   {{0x6d4459d4,0xe8df8067,0xc006854a,0xb606007f}},	//   ilia, _nhộn_, _упак, nišč,
   {{0x26c5f9d5,0x25a5e94b,0xd8e6e8ab,0x7d0299d6}},	//   gelo_, full_, сцип, lkos,
   {{0x628e39d7,0x69da606e,0x26d219d8,0xfd4d8291}},	//   dabo, _štej, _bayo_, _nchọ,
   {{0x07a6ceb6,0x7f83ca28,0x2d9ef9d9,0x7ae2ca43}},	//   _гадн, _کلون, rrte_, _unot,
   {{0x14aa039f,0xfd4d8096,0xd0e5ca11,0xf09f4090}},	//   _कारण, _achọ, कारण_, _blàn_,
   {{0x7d028089,0xde58e362,0x8ca50077,0xf1c86021}},	//   hkos, _калі_, _काको, रबान,
   {{0x26c68098,0x0eb109a8,0x7d1d19da,0x7afa2262}},	//   keoo_, _झापड, piss, ötta,
   {{0x63a619db,0x628e2c57,0xa2d92567,0x7af60c1e}},	//   bukn, aabo, _फोर्, _goyt,
   {{0xc1b5a04a,0x63a6005d,0x7bcd1795,0xb4db42d9}},	// [1630] _अङ्ग, cukn, _usau, _bhàr,
   {{0x69dc79dc,0x831940eb,0x25a699dd,0x2f0ba22e}},	//   _brre, _چقدر_, duol_, _køge_,
   {{0x25bf99de,0x6f0340ba,0xaca36079,0x2c19611a}},	//   _spul_, _înco, _nyục, _येशू_,
   {{0x25a054e0,0xe8122b27,0x26d179df,0x3ce48019}},	//   bril_, _डेटा_, _wazo_, _cnmv_,
   {{0x2bd12626,0x656982a8,0x7d0d59e0,0xff51a8b5}},	//   हिका, _queh, mhas, وخت_,
   {{0xdb0d6049,0x13ba4053,0x4fb426ec,0x26c5f9e1}},	//   otaí, _דזשע, _بصیر, xelo_,
   {{0x1986a14a,0x442fc03e,0xf53f30dc,0x2d49a03e}},	//   общи_, _sxg_, mråd_, búen_,
   {{0xdb02078d,0x14d90010,0x6561b9e2,0x6f0d59e3}},	//   pulé, _बोलण, _wilh, nhac,
   {{0x26d200e6,0x2d9e0064,0xae168010,0x9c7ca35d}},	//   _rayo_, ątek_, _देऊन_, _inčn,
   {{0x161f80a8,0x25a5e00e,0x3494a8e4,0xdb074156}},	//   _मेयर_, tull_, _наур, ltjä,
   {{0x3ce60aa1,0x628e35f7,0x26c5e32a,0x6cc618a6}},	//   टाले_, vabo, relo_, ойна,
   {{0x320be064,0x7bdd4012,0xc7d66076,0x8afee0a2}},	//   ący_, _orsu, קורי_, _riƙe,
   {{0x7ae40026,0x60c60106,0x752d0163,0x7af72363}},	//   _vnit, rekm, _djaz, _boxt,
   {{0x753bd9e4,0xb4c9c180,0x6d4441cd,0x7ae3f9e5}},	//   louz, _लघु_, wlia, _unnt,
   {{0x27ffd9e6,0xab19271b,0x614325a7,0x39aea03c}},	//   lyun_, сцях_, фера, _həsr_,
   {{0x26c7b2c1,0x6d4459e7,0x212d800e,0x69dd4012}},	//   heno_, ulia, _njeh_, _brse,
   {{0x88bce04a,0x13a6b133,0xd7ef0049,0x6f02962f}},	// [1640] dněj, _गम्भ, _لكي_, vkoc,
   {{0xb606042e,0x7643e07d,0xb87b4005,0x752d08db}},	//   rišč, _kyny, _unín, _zjaz,
   {{0x6f0d46a5,0x0b5a861b,0x69c1a05f,0x7cff000e}},	//   bhac, арды_, _nple, _sëri,
   {{0x290cf9e8,0xb6038066,0x7643e1cd,0x69de2024}},	//   zhda_, _omáč, _myny, _irpe,
   {{0xdce0a1fc,0x291ef9e9,0x7cfcc009,0x7643f9ea}},	//   _numă, yita_, _mért, _lyny,
   {{0x6ea7c026,0x6563f955,0x628bd9eb,0x9c876089}},	//   _गाउँ, _ninh, _aego, ručí,
   {{0xf98fa4a1,0x7bdc6265,0x6f0999ec,0x656bc090}},	//   نبي_, _urru, _flec, _augh,
   {{0x90c399ed,0x673c207f,0x7d098944,0x764419ee}},	//   _обсе, horj, _gles, _oyiy,
   {{0x80d3e1a6,0x27ffc1e7,0x628f19ef,0x26c7a4f2}},	//   তান্, gyun_, vaco, beno_,
   {{0x62828d53,0xe8d92088,0x6563e0a2,0x7d1aa0c1}},	//   lboo, _kwụ_, _cinh, _umts,
   {{0xbcfb6005,0x3959e017,0x753ae108,0x644419f0}},	//   _quéi, ïssa_, rotz, _ayii,
   {{0x628299f1,0x61e2006e,0xa2ad2077,0x656bc197}},	//   nboo, _šola, _जाह्, _fugh,
   {{0x644419f2,0x3eb91385,0x6800c031,0xdcf8c018}},	//   _cyii, rfst_, _dájú, ssvē,
   {{0xbcfb4019,0x6281f9f3,0x7ae6400e,0xdb046aed}},	//   _cién, cblo, _ankt, quiè,
   {{0x2bd2c7af,0x7643f73b,0x69de2143,0x368b4df4}},	//   तिका, _gyny, _crpe, исан_,
   {{0x33754a00,0x3eaf40cb,0x2b4680ba,0x7bdd46ca}},	//   згар, ügt_, jloc_, _prsu,
   {{0x62828025,0x3f874098,0xbcfb6071,0x629ab9f4}},	// [1650] dboo, ćnuo_, _muév, _odto,
   {{0x69dd4361,0x7945c0c2,0x7d044194,0x26c7204a}},	//   _vrse, tówk, akis, _úno_,
   {{0xf53f30dc,0x656d19f5,0xf0788125,0x9c1311b0}},	//   rråd_, _huah, _ịgụn, kọka,
   {{0x27ffd9f6,0x753d0367,0xcdda200b,0x657a21b3}},	//   yyun_, nosz, _פֿיר, íthe,
   {{0x69cf59f7,0x6f1d4049,0x6281f9f8,0x2570858f}},	//   _usce, _imsc, yblo, _càl_,
   {{0xddc9c361,0xff7c0053,0xeb96911a,0xdb02046b}},	//   jceš, סטומ, чиш_, stlø,
   {{0x628bc1ae,0x7b03410a,0x656bd77e,0x07a5a905}},	//   _pego, _nõuk, _sugh, чайн,
   {{0x25deeba0,0x9943c106,0x21216098,0x161680c2}},	//   गिनी_, _dış_, lihh_, _देकर_,
   {{0x25a94095,0xdb09e1de,0x753bc057,0xa49b458f}},	//   nual_, nteç, rouz, _clòi,
   {{0x2904c08b,0x290dc0ce,0xa3b8a0eb,0x61e6c5ee}},	//   akma_, shea_, _ژانر_, åkla,
   {{0x68f8e143,0x7cfcc019,0xbcfb4071,0x7c2dc143}},	//   _dovd, _pért, _rién, _žard,
   {{0xdb23c050,0x27f8e156,0x672b93f0,0x7bcd40a2}},	//   _توصی, ärna_, nngj, kwau,
   {{0x316d8333,0x69de204a,0x60c9c11d,0xbcfb4071}},	//   _juez_, _srpe, meem, _pién,
   {{0xe7f38688,0xbb78c009,0x63a9c264,0xe689e049}},	//   _आपना_, _بلوچ_, muen, _انثى_,
   {{0xdee642d8,0xbcfb42a8,0x8c42e2d3,0x9f5e404a}},	//   пови, _vién, _пеше, ští_,
   {{0x141a4049,0xe9df59f9,0x2cadd9fa,0x7d06eb8e}},	//   ميزة_, _brú_, nged_, ūkst,
   {{0x80cee07c,0x444439fb,0x2fcdd16b,0x6d408012}},	// [1660] ়ার্, _wy_, nweg_, _rkma,
   {{0x63b6402d,0x7af8e286,0xe81680c2,0x7bde2012}},	//   rtyn, _xovt, _देगा_, _trpu,
   {{0xe9df4031,0x09b7c1a6,0x63a9c125,0x929dc0c2}},	//   _erú_, জিটা, huen, zkła,
   {{0xc8dacef3,0x656ee049,0x8afee0e8,0x6b8999fc}},	//   _मोंट, íbhi, _miƙa, _bweg,
   {{0xda168046,0x2b468425,0x49738cde,0xdcf740ba}},	//   _देखत_, rloc_, еліс, şcăr,
   {{0x656659fd,0x63a44e36,0x628291f1,0x61360009}},	//   _hikh, mrin, sboo, rály,
   {{0x8afee0e8,0x60c8e654,0x68f8f9fe,0xe814c077}},	//   _niƙa, vedm, _rovd, _तेजा_,
   {{0x2cadc5c7,0xe01dc0c2,0x290ea167,0xf8bf1922}},	//   gged_, _बेहद_, shfa_, tném_,
   {{0x8fa38d3e,0x656659ff,0x7af8e048,0x2a6a6037}},	//   _пате, _mikh, _povt, _kgbb_,
   {{0x69060057,0x65665a00,0x656e61fb,0xe297a12a}},	//   _dóem, _likh, _kubh, _нау_,
   {{0xb87b4032,0x127ba00b,0x7bdc200a,0x8afee0a2}},	//   _sním, _האבע, jvru, _ciƙa,
   {{0x628e65d1,0x656640c1,0x973d0012,0x6d41a0a3}},	//   _lebo, _nikh, mućk, _zkla,
   {{0xb9098079,0x60c0805d,0x60d60d8d,0x6916006f}},	//   _aghọ_, _mbmm, _daym, všet,
   {{0xa2bfa4e5,0x291ce00f,0x75228197,0xd378a133}},	//   ल्प्, _umva_, hioz, _zrća_,
   {{0x76bbe095,0x8c41e105,0x78ad5a01,0xa3d2404b}},	//   _המופ, ößte, tgav, विझ_,
   {{0x0f09aba0,0x26d82425,0x7cff03ac,0x76a2e0f9}},	//   _वत्स_, adro_, _përu, _fíyà,
   {{0x6566413b,0x6d42c296,0x75229a02,0x88bdc0c2}},	// [1670] _dikh, _mkoa, dioz, liśc,
   {{0x04f9807c,0x63aaa00a,0x4275306d,0x78ad5a03}},	//   _আগের_, kufn, _югос, sgav,
   {{0xd5b8e041,0xb9554691,0x3f8080ba,0x656e658f}},	//   ntā_, _овощ, ţiul_, _cubh,
   {{0xd491a119,0x7bc520bb,0xa3d3fa04,0x200f68fd}},	//   _còn_, _iphu, _सैफ_, ągi_,
   {{0x6d41a098,0x49744f93,0x29cd46ca,0x60d56d5d}},	//   _pkla, _пляс, _uža_, _tazm,
   {{0x7b160098,0x69dd0046,0x4dc3a07c,0x657d5526}},	//   nšur, ivse, ্মসং, _itsh,
   {{0x60c9c2df,0x7d0d0d16,0x32020066,0x2246c827}},	//   teem, _olas, zyky_, _ayok_,
   {{0x48e8007c,0x752d548c,0xb4d7c4da,0x6b8994b6}},	//   _পত্র, nnaz, ाये_, _tweg,
   {{0x3cf08066,0xb0aec029,0x2d817a05,0x29078013}},	//   ťové_, _टारग, lphe_, ūnas_,
   {{0xa2bdc216,0xdb03c333,0xe3ca84cd,0x6673e050}},	//   _वॉर्, muní, señó_, رگتر,
   {{0xbcfb64cd,0xa6ca0762,0xe81dc046,0x7bc4000e}},	//   _hués, олна_, _बेरा_, _spiu,
   {{0x68fb9a06,0xeab0c049,0x63a9c071,0xdb020071}},	//   _joud, _معه_, puen, pulí,
   {{0xe299e967,0xb8f60021,0x26ca3a07,0x672d5a08}},	//   _дал_, _हस_, tebo_, dnaj,
   {{0x63a44407,0xdb23e052,0x6d5bda09,0x752d5a0a}},	//   vrin, äräi, lmua, enaz,
   {{0x98ace04a,0xdbcbe005,0x2492408b,0x68e99a0b}},	//   hodě_, póñe, taym_, _oned,
   {{0x628f5a0c,0x26ca32c8,0xdb0d6105,0x68fb9a0d}},	//   _ceco, sebo_, traß, _noud,
   {{0xc7b9c0e0,0x65677a0e,0x224c604d,0x14aea04b}},	// [1680] ntő_, _bijh, _šdk_, _घालण,
   {{0x68e99a0f,0x6723a035,0x6d5bc00e,0x68fb81f6}},	//   _aned, jinj, hmua, _aoud,
   {{0x823620e0,0xd259c018,0x7523a425,0x6d5c2944}},	//   _زردا, meņu_, dinz, mmra,
   {{0x333fda10,0x4fc690aa,0x6603a064,0xa2bdc029}},	//   joux_, дска, dynk, _वॉल्,
   {{0x2fc5a037,0xe81dd303,0x63ab9a11,0x6d48e0c4}},	//   _aplg_, _बेला_, gugn, ylda,
   {{0xdee3a18f,0x26c240d4,0xdddc28fd,0x6d46e0a3}},	//   кочи, _hbko_, karż, ůkaz,
   {{0x656f5875,0x66044009,0x3b0a80ba,0x66029a12}},	//   _zuch, lyik, _дево_, syok,
   {{0x399b2095,0x63ab8c57,0x6d5bc022,0xe8e00119}},	//   קיפד, bugn, gmua, _trội_,
   {{0x8fa3c55a,0x6e94e331,0x88bdc064,0xd1b3863b}},	//   вање, нипу, wiśc, _لینک,
   {{0x7bc64125,0x7523b9f7,0x2907a156,0xbebb054c}},	//   _mpku, cinz, ckna_, giën,
   {{0x26cb0e06,0xdb0ac156,0x6d48e262,0x2b494025}},	//   teco_, ttfä, rlda, ylac_,
   {{0xa3df7a13,0xdce2e02e,0x3f42e0c4,0x2572c0fd}},	//   तित_, _uvoľ, gður_, _tâl_,
   {{0x2768e63b,0x8af0403c,0x33200011,0x2911204d}},	//   _کشتی_, rməl, _dmix_, thza_,
   {{0xdb0ac851,0xd703e14a,0x2124c049,0x23c2a0c2}},	//   stfä, _изчи, limh_, _शहाद,
   {{0xb065e2df,0x27390066,0x25a68c2c,0x9c7cba14}},	//   rjää, zény_, hrol_, _ančk,
   {{0x80bf2077,0xe6671512,0x657a2009,0x2124c351}},	//   _लॉरे, _отпо, ítha, nimh_,
   {{0x443f2064,0x7523ab01,0x6b82806e,0x26d87a15}},	// [1690] łu_, yinz, jpog, _baro_,
   {{0x6b8d01e7,0x224905c8,0x25a6816f,0x6d49c108}},	//   _iwag, _iyak_, drol_, zlea,
   {{0x6d4520bb,0xa295471b,0x2b4940d5,0xa3ab435b}},	//   _ikha, _пані, plac_, _गमक_,
   {{0x60c1a07d,0x80bb32de,0x798d0fae,0x25f46485}},	//   _sblm, श्रे, _kwaw, ंहजी_,
   {{0x7523b4e4,0xc3cb81b3,0x60cd5a16,0x31b8e009}},	//   tinz, تظام_, meam, héz_,
   {{0x26d9423d,0x2c0ee037,0x7afb8f73,0x6b8d02e0}},	//   _haso_, ानां_, _wout, _mwag,
   {{0x200985c0,0x2367e00e,0x68fb8157,0x8c42b0da}},	//   šai_, _rinj_, _toud, леше,
   {{0x61e2da17,0x6448a03b,0x68e981cd,0xfd64c079}},	//   _brol, _dydi, _uned, _ikwụ,
   {{0x34948808,0x6b8d1a18,0x333fda19,0x1d35a14a}},	//   _шатр, _nwag, roux_, _зная,
   {{0xfbd24095,0x2d8d8079,0x2120005d,0xb4ce2292}},	//   נתי_, _iwee_, _smih_, _रसे_,
   {{0xe1260279,0x69261a1a,0x7c294143,0x64dac04b}},	//   емни, емна, _žerl, _मोकळ,
   {{0x63ad5a1b,0x2d8d8079,0x70aa07fa,0xbebb0aaa}},	//   kuan, _kwee_, कलेल, siën,
   {{0x60cd40ef,0x26cce019,0x60dbd603,0xe3b204aa}},	//   deam, bedo_, mdum, درج_,
   {{0xfd64c125,0x63bbda1c,0x6ec161c9,0x6b9b80b1}},	//   _okwụ, mtun, र्मु, _mvug,
   {{0xf2d2a00b,0x1be730ba,0x75d3a03c,0x2bde0290}},	//   װען_, ндри_, _bəzə, मिहा,
   {{0x64410105,0x60cd5a1d,0x6d4400ce,0xdb021a1e}},	//   ßlic, geam, _ukia, bulá,
   {{0xb4cc0010,0x4fa34a92,0x6b8d1a1f,0xa6e6653f}},	// [16a0] रजी_, литв, _gwag, нжал,
   {{0xdbc6c10a,0x2cbfc939,0x386d9a20,0x249f81f6}},	//   _tööa, hfud_, _ager_, _adum_,
   {{0x68fc7a21,0xcd022064,0x2929206f,0x24868098}},	//   _vord, ęść_, ýtať_, tbom_,
   {{0xa96a4024,0x6b561a22,0x25adc4b4,0x6568aa36}},	//   _нима_, lágb, kuel_, _sidh,
   {{0x60c41a23,0x26da3a24,0xd12f84c7,0xe8df8119}},	//   _mbim, _kapo_, حمن_, _chốn_,
   {{0x6146604d,0x7aebda25,0xb17b4156,0xb4bca046}},	//   _чега, _angt, _krån, ेजे_,
   {{0x25a69a26,0x3ea000ca,0x6568ba27,0x2fc6c155}},	//   srol_, _odit_, _vidh, _spog_,
   {{0x60dbd518,0x91bb6076,0x61e2da28,0x3ebfc143}},	//   gdum, _ממלי, _prol, gfut_,
   {{0xef1aa42d,0x5ce3c052,0x27e0448f,0x764994b7}},	//   _ема_, ующа, nvin_, _gyey,
   {{0xb4db40f9,0x6d5d0022,0x6b8d00b1,0x0bb74076}},	//   _akàl, wmsa, _rwag, עלים_,
   {{0x62953a29,0x63bbda2a,0x2418e772,0x69d61a2b}},	//   vazo, atun, фоны_, _asye,
   {{0x26ceb953,0x6d4641e7,0x7c29404d,0x386d0271}},	//   lefo_, _nkka, _žerm, øer_,
   {{0xaca461e9,0x26d94e12,0x60daba2c,0xdb02046b}},	//   _ayọr, _raso_, _katm, kulæ,
   {{0xbebdc013,0xdb03c066,0xe66727f7,0x60c4011d}},	//   niūn, muná, етбо, _ebim,
   {{0xe9ff8016,0xb4bee626,0x35a6c033,0x26c05a2d}},	//   _khảo_, ुजी_, _खिड़, ffio_,
   {{0x798d1465,0xa3df6292,0x2249008b,0x2d8322be}},	//   _twaw, तिस_, _tyak_, rpje_,
   {{0x6ca768e7,0xa2b68026,0x31720187,0xa0a760ba}},	// [16b0] ереж, ैभन्, _guyz_, ешел,
   {{0x63af01e4,0x29095662,0x6b522065,0xdddc6012}},	//   mucn, skaa_, lægn, _derž,
   {{0xa3c5210a,0xe7e3e046,0x2d8d817b,0x27e48187}},	//   _एहि_, गिया_, _swee_, _armn_,
   {{0x237f9a2e,0x63bbda2f,0xc0ab4049,0x644aea53}},	//   _ptuj_, ytun, _عاجل_, _myfi,
   {{0x60dd0109,0x24895a30,0x26da20ce,0x68ed1a31}},	//   idsm, mbam_, _yapo_, _mnad,
   {{0x6722c1e9,0x7d09d4d9,0xf7740087,0x2f142156}},	//   _amoj, wkes, אקס_, _vägg_,
   {{0xe5346052,0x6b44a017,0x8f3460ff,0x7aed1a32}},	//   _серь, tògr, _серц, _onat,
   {{0x67272098,0x68ed1a18,0x7aed02dc,0x6d4d5a33}},	//   hijj, _nnad, _nnat, nlaa,
   {{0x61e4c049,0x26cf80c2,0x1fbdca2a,0x6f0340ba}},	//   _áill, mego_, ्बेड, _încu,
   {{0x7522da34,0xf8aa039f,0x2d9e204a,0x6d4d5a35}},	//   _emoz, कल्प, átek_, hlaa,
   {{0x61edc013,0x62964b87,0x25adda36,0xa3da60c2}},	//   _šald, yayo, suel_, ़िए_,
   {{0x66061729,0xeb9a048e,0x644afa37,0x8af045fc}},	//   tykk, мим_, _dyfi, rmək,
   {{0x7d06c04e,0x67272098,0x60daa19f,0x6d4d4025}},	//   ökse, fijj, _yatm, dlaa,
   {{0x656bda38,0x66060b48,0x63a9ce36,0x60db9a39}},	//   _high, rykk, mren, _laum,
   {{0x6b9bd126,0x644ae0fd,0xfaff477c,0xad9b0009}},	//   lsug, _gyfi, _boë_, nyúj,
   {{0x394dc2b2,0x26cf8064,0x63ae2089,0x44394733}},	//   nles_, jego_, rubn, _bxs_,
   {{0x16664e64,0x645561b6,0x26c041cd,0x68fe3a3a}},	// [16c0] твам, _azzi, rfio_, _topd,
   {{0xb17b4156,0x6b845a3b,0x63a9cfdb,0xdb00e5fc}},	//   _trån, rpig, iren, rumç,
   {{0x656bc00c,0xdbcc6005,0x6d4d53c1,0x69c98031}},	//   _oigh, _póña, blaa, _apee,
   {{0x6b8455cc,0xdcfec041,0xc6a3848e,0x2d4781de}},	//   ppig, īvīb, арши, dões_,
   {{0x31bdd88c,0x60db9a3c,0x645561b6,0x6d4e3a3d}},	//   ्बोध, _daum, _ezzi, olba,
   {{0xde58a12e,0xa2c1691c,0x62976057,0x6d59cf3d}},	//   налі_, र्द्, caxo, _ahwa,
   {{0xdb0740a3,0x68ee6227,0x26c5a0d4,0x273c8089}},	//   zují, _inbd, _dblo_, zíny_,
   {{0x31604030,0x3ced804d,0xa2a221c9,0x95d8d537}},	//   nmiz_, _gnev_, कृत्, едит_,
   {{0xdb046057,0x799bcc96,0x31bc6071,0x504690c4}},	//   ltiñ, gsuw, líz_, _реаб,
   {{0x86eaa049,0xed598133,0x9bb781a1,0x14aec04b}},	//   _تعرف_, _zhž_, _בהמה_, _टाकण,
   {{0x4c95067e,0x395fc022,0x656bc076,0x60cf0057}},	//   линс, bmus_, _figh, tecm,
   {{0x29000609,0xd026c14a,0x75240012,0xdb046057}},	//   _coia_, _имей, _cmiz, itiñ,
   {{0x7ff3c711,0x3944c013,0x83340a47,0x290000d4}},	//   _نسوا, moms_, рнях, _doia_,
   {{0xaca4e125,0x63bd1a3e,0xfbcfe0eb,0x629a2da8}},	//   _kpọz, rtsn, حتی_, ótop,
   {{0x6e94306d,0x9f44a00e,0x24784385,0x61e64013}},	//   рису, _armë_, _ọma_, _arkl,
   {{0x4734487c,0x0dc7e799,0x6298ba3f,0x2bf3804b}},	//   ансс, _руши_, havo, _आपलं_,
   {{0xe8d90016,0x2d782098,0x69da7a40,0x2571a0a9}},	// [16d0] _nhỉ_, _učen_, _štep, _išle_,
   {{0x395fca7d,0x59ce28c6,0x6d43a15a,0x61e12156}},	//   zmus_, _हैकर, xona, ålls,
   {{0x6d43a0e0,0x63a4813a,0x2d812174,0x78a2c06f}},	//   vona, áinn, _uthe_, _odov,
   {{0x2900003e,0x26dcfa41,0x7d164066,0x224b4156}},	//   _xoia_, _lavo_, chys, _tyck_,
   {{0x7d009a42,0x29012eed,0xfd5644ac,0x443f4016}},	//   _doms, _koha_, _תשרי_, _âu_,
   {{0xf1c72010,0x69cae0cb,0x78a2c0d5,0x7c2dc15e}},	//   _लहान, _opfe, _adov, _žaro,
   {{0xb4c16d0b,0x2d94a03b,0x656bc1da,0x6b82da43}},	//   ्जी_, арыс, _pigh, _atog,
   {{0x693c8490,0x3ea9b00a,0x394dda44,0xdb02a0c4}},	//   včeg, şat_, ules_, stoð,
   {{0x6298a089,0x3947e0c7,0x395fda45,0xb87b4057}},	//   bavo, _pkns_, rmus_, _uníu,
   {{0x6b9bda46,0x6d445a47,0x394dda48,0x29001a49}},	//   rsug, zoia, sles_, _soia_,
   {{0x2129417b,0x2bd8c028,0xaaab60a8,0x31604e39}},	//   kiah_, _बैठा, _चयनक, ymiz_,
   {{0x62957a4a,0x6f01ba4b,0x249829cd,0x4a74c12a}},	//   _lezo, _holc, warm_, _кышт,
   {{0xe5a5c967,0x6da5cc14,0x29012066,0xef286315}},	//   _сили, _сила, _boha_, lmüş_,
   {{0xf487e312,0x9d56225b,0x26dce013,0xdce3e018}},	//   _рудн, انست, _gavo_, _finā,
   {{0x6609c0e0,0xfaa64407,0x3ea24939,0x3945e9cf}},	//   lyek, лаво, _pdkt_, mols_,
   {{0x25bfc0ba,0x60dd4ce6,0x9f4020d5,0x53b7cba0}},	//   otul_, _casm, _triï_, _आमाश,
   {{0x2d8360dd,0xecea6d82,0x2f166065,0x7d008488}},	// [16e0] _atje_, ндал_, _læge_, _roms,
   {{0x98a7a013,0x7d0086af,0xf06340d9,0x26ddc0bb}},	//   monė_, _soms, скуп, _lawo_,
   {{0x94bb2095,0xa3b68010,0x2fcb4361,0x290dc052}},	//   _אמית, चून_, _epcg_, kkea_,
   {{0xd6d9814f,0x257985cd,0xd5ba807a,0x60dc7a4c}},	//   кті_, _bèl_, еск_, _warm,
   {{0x2578a011,0xdcfc820d,0xda7aa013,0xac978ae5}},	//   _sél_, _utrč, няй_, انها_,
   {{0x26ddcaf8,0xdb1c8156,0x661bc098,0x6f03412a}},	//   _aawo_, _sprä, dzuk, _încr,
   {{0x6d5b8569,0x2fc053a2,0x2b07e026,0xdb1be0fa}},	//   _fhua, ltig_, ाउनु_, ctué,
   {{0x6d461a4d,0x60c44157,0xf1bf0089,0x629560c1}},	//   joka, nfim, ytá_, _zezo,
   {{0x46b6a0a4,0x29025a4e,0x2578a171,0xa2c165c5}},	//   _محاس, _moka_, _wél_, र्व्,
   {{0x59dca026,0xfc4ac0f9,0x7d01a1f6,0xf77fc1ae}},	//   _मनपर, _akíó_, _gols, íça_,
   {{0x6b8405f1,0x290dc6be,0xdb1e800e,0x7528fa4f}},	//   _atig, bkea_, jtpë, ridz,
   {{0x78a2da50,0xa84ac13a,0x41e6c33e,0x2d49a019}},	//   _udov, _كلام_, _مستف, búes_,
   {{0x6d44c03b,0x31d1604a,0x644e60e8,0x26d251da}},	//   čiad, _सन्ध, _lybi, deyo_,
   {{0x59b8a79e,0x3dc660c2,0xdb1ee156,0x272b00ca}},	//   _इमार, łowy_, övän, _bònè_,
   {{0x7d0d5a51,0x29024551,0x627be1a9,0xe47be095}},	//   tkas, _boka_, _אנונ, _ארוכ,
   {{0x2571a2e2,0xfd4cc031,0x7d02da52,0xa7750192}},	//   _ušle_, _ailẹ, _joos, _клич,
   {{0x29012058,0x2d9eeb9c,0x6d5b8286,0x2bdce2ca}},	// [16f0] _toha_, lste_, _rhua, यिका,
   {{0xf09f4569,0x7bcd0d87,0xeb9f03d1,0xd257c076}},	//   _clàr_, _ipau, msø_, רשמה_,
   {{0x69daa1f6,0x6d5b805f,0xdc43804a,0x656e62d9}},	//   _nste, _phua, _véčk, _dibh,
   {{0x6d5b8223,0xd0118049,0x19b7e00b,0x2129417b}},	//   _qhua, يلا_, רפאר_, qiah_,
   {{0xbcfb4a7d,0x39a78474,0x25bfc0ba,0x7529c05a}},	//   _diét, ушев, xtul_, viez,
   {{0x212b128c,0xde05a423,0x945dc064,0xfce5b9c1}},	//   hich_, ипли, zeńs, роко,
   {{0xe8d90081,0x629afa53,0x41e46a0e,0xbcfb403e}},	//   _chị_, dato, _літа, _chég,
   {{0x26d369fe,0x2be28485,0x656f40ce,0x7c3b8534}},	//   lexo_, पिशा, _jich, _txur,
   {{0x6d473a54,0x7bcd0223,0x3945fa55,0x80de007c}},	//   koja, _npau, tols_, যাম্,
   {{0xd709e052,0x2d9ee7ff,0xdb046395,0x26c90194}},	//   тное_, fste_, ruiç, _abao_,
   {{0xe8d90125,0xb17b4342,0xf99f00d1,0x6aa7c07c}},	//   _ghị_, _bråk, syèl_, ক্ষো,
   {{0xf8660607,0x7d02d1f1,0xd946048e,0x61460470}},	//   ивно, _goos, реми, рема,
   {{0xd45601e1,0x9cd68095,0x2fdb01f6,0x4ac67a56}},	//   ртнь, בורה_, _csqg_, र्डव,
   {{0x6577200e,0x629ae8cd,0x26dea0d5,0xb05b1393}},	//   _buxh, cato, _xato_, pfän,
   {{0xc896455a,0x395dc05f,0x6f03e13a,0x78bb84a3}},	//   ирањ, _khws_, _ionc, _ocuv,
   {{0xac864494,0x3947a0fa,0x644e743a,0x656e6c91}},	//   ргал, hons_, _rybi, _sibh,
   {{0x8af04497,0x8b2661ba,0x21675a57,0x290374d3}},	// [1700] dmət, адае, рити_, _boja_,
   {{0xdb062121,0x7d03e94b,0x6d472019,0x6f03e930}},	//   dukç, _jons, coja, _jonc,
   {{0x2bde0eda,0xbcfb43bb,0x60c32009,0x26d25a58}},	//   मिका, _piét, _önma, peyo_,
   {{0xbcfb4019,0x4973603b,0x25ad006f,0x3fe6839d}},	//   _diés, іліс, šele_, ижев,
   {{0x98a32041,0x69c1e046,0x7bc1e10a,0x629afa59}},	//   lijā_, htle, htlu, yato,
   {{0x2d9ee969,0x3ce0005f,0xdb1d20e0,0x0cd31a5a}},	//   yste_, _laiv_, ttsé, _तस्म,
   {{0x98a32041,0x6da36c9d,0x6028c018,0xeb97706d}},	//   nijā_, _мира, zīmī, _вис_,
   {{0x7bdaa032,0x25a98130,0x61edda5b,0x2ee00011}},	//   _vstu, šala_, _šala, _naif_,
   {{0x6d472df7,0xaac66567,0x02c66292,0xe0df40ca}},	//   yoja, र्थक, र्थभ, _chòy_,
   {{0x7bc0da5c,0xada6a0ff,0x69c1fa5d,0x68e29a5e}},	//   rtmu, _важл, ftle, ldod,
   {{0xbca6c050,0x0f576095,0x68e08de6,0x212b1a5f}},	//   _نماي, שיים_, _kamd, tich_,
   {{0x645aba60,0xf8bf5a61,0xd7e6c14f,0x6b82a125}},	//   _izti, _amén_, _віко, _ọgwa,
   {{0x3ce00022,0xdc54c043,0x62972005,0x9c7ca04d}},	//   _daiv_, _اراک, _pexo, _tačd,
   {{0x2d9ee480,0xa3ae8295,0x28df40a8,0x8afee0a2}},	//   pste_, _किन_, _पोजि, _riƙw,
   {{0xb17b46dd,0x7ae29a62,0x6b560057,0x68fce046}},	//   _tråk, kdot, cágo, ördu,
   {{0x79690064,0x257c204a,0x212cf03c,0x6298e052}},	//   _oświ, _díl_, lidh_, _hevo,
   {{0xd3714678,0xaefb458f,0x69dc73c8,0x645cc5fc}},	// [1710] سها_, _biùr, _asre, əric,
   {{0x67ca4041,0x1ddae0c2,0x8aa728df,0xceb8e013}},	//   dējā, _बनात, _трид, ngę_,
   {{0x290489c8,0x3ce00022,0x2571a012,0x26d3603e}},	//   _boma_, _yaiv_, _ošla_, rexo_,
   {{0x7ae0817b,0x6b5d0ac3,0x7de0a0e0,0xdb1660e0}},	//   _camt, légb, zásá, rtyá,
   {{0x26cb4022,0x6d48f406,0x6b5600e0,0x4aa88407}},	//   _ibco_, koda, zágo, ркін_,
   {{0x672d5a63,0x29c28067,0x1c06e028,0xe164a049}},	//   liaj, _dưa_, शहाल_, يدوي,
   {{0x21290050,0x51846c6c,0xdb046052,0x835280e0}},	//   _omah_, _мута, ttiö, _کھلا,
   {{0x7ae0803b,0x28382095,0x3947b0d8,0x657a2049}},	//   _gamt, ינוך_, sons_, íthi,
   {{0xa3d2c033,0x692b0026,0x7528a098,0xe8d90088}},	//   हौल_, třen, _fmdz, _chọ_,
   {{0xe9d9e6fc,0x6298e2f9,0x63a2c9a3,0x249d8048}},	//   гко_, _cevo, _dvon, lawm_,
   {{0x3946009e,0x672d40ce,0x60d53a64,0x7d160ffe}},	//   йног, kiaj, dezm, _plys,
   {{0x68e1a59c,0xfaff000e,0x69cf4579,0x7ae0807d}},	//   _hald, gjë_, _opce, _xamt,
   {{0x2905aed9,0x33291a65,0x5d85c13a,0x6b5600e0}},	//   _kola_, _dmax_, _التل, ságo,
   {{0x2f18c009,0x6d48fa66,0x70b2204b,0x2bfa804b}},	//   _vége_, coda, जलेल, ्हतं_,
   {{0x75298026,0xb4c5e077,0x249d8022,0x31d48290}},	//   _omez, ॉजी_, kawm_, _धन्ध,
   {{0x394949fe,0xe6d060a8,0x753b9a67,0xdb046005}},	//   goas_, सज्ज, _njuz, driá,
   {{0xf8bf4187,0x63a3e194,0x98a32018,0x3f56222e}},	// [1720] _imél_, _hvnn, sijā_, læum_,
   {{0x2f1546dd,0xaa7b0431,0x68e09a68,0xaefb458f}},	//   _våga_, ndýn, _samd, _chùb,
   {{0x7d1bda69,0x25a05a6a,0x23600022,0x9d46493b}},	//   khus, ssil_, _khij_, _генд,
   {{0xf4872050,0x6299c7b1,0x8af0403c,0x9b25819d}},	//   _پایی, _newo, rməs, офіл,
   {{0xadc34067,0x7ae08022,0x69c1a227,0x24986095}},	//   _thạc, _vamt, _aqle, _term_,
   {{0x753b8125,0xdd8f4049,0x6143a8f4,0x5f067043}},	//   _ejuz, _سوف_, печа, _узга,
   {{0x3ce241e4,0xf4876043,0x6d4e60f7,0x2be04180}},	//   _kakv_, _چاہی, _ikba, निका,
   {{0x44205a6b,0xa06a8520,0x7644a106,0x69c44213}},	//   ozi_, _баба_, şiyo, otie,
   {{0x80df207c,0x629d1a6c,0x2905ba6d,0xdca6a423}},	//   মাত্, vaso, _fola_, _гази,
   {{0x7d065a6e,0xfc3f4019,0x7ae1ba6f,0x6f0640e8}},	//   _loks, _odín_, _galt, _lokc,
   {{0x69c45a70,0x443ea005,0xd6d50772,0x7d1bda71}},	//   htie, _uxt_, ожны, bhus,
   {{0x6d48fa72,0x6d4aba73,0x6f1bcf3c,0xa3e72148}},	//   soda, lofa, chuc, पिस_,
   {{0x672d5a74,0xdcef612a,0x321ee0c2,0x752d5a75}},	//   viaj, _jucă, szty_, viaz,
   {{0xdd90e50f,0x443f01d7,0x29052069,0xf7732049}},	//   _قوت_, ħu_, ðla_, كار_,
   {{0xd7f82a47,0x60d52157,0x6f065a76,0x33290cc2}},	//   бут_, rezm, _bokc, _tmax_,
   {{0x7ae2c046,0x249d8286,0xe29f4765,0x6e2dd099}},	//   _jaot, xawm_, _boða_, _žabi,
   {{0xa1584407,0xba99614f,0xc299654a,0x6f1d03f6}},	// [1730] сату_, иває_, иках_, mhsc,
   {{0xa3ce010a,0x69c3a089,0x657aa4cf,0x29186090}},	//   _रहत_, ytne, _outh, _clra_,
   {{0x80cae04b,0x2b5f8067,0x2d9e3520,0x2d87756e}},	//   त्ये, _phuc_, šter_, ëne_,
   {{0xa3aa6021,0xdcef60ba,0x6b589a77,0xa3b983f1}},	//   _गटर_, _bucă, sígn, لاتر_,
   {{0x68e1b8f8,0x26cca071,0x5ee1607c,0x6281fa78}},	//   _pald, _bbdo_, নাবে, yclo,
   {{0x777aba79,0x249d8022,0x27eca090,0xdb238009}},	//   _butx, sawm_, _brdn_, _کوری,
   {{0x657ab98a,0x6f1bd28c,0x2b5f8067,0x6ebfa3af}},	//   _cuth, thuc, _thuc_, ल्गु,
   {{0x75299a7a,0x67299a7b,0xc9a9c14a,0x61fbc108}},	//   _umez, _umej, авие_, txul,
   {{0x63a280e0,0x4ac67a13,0x69c57a7c,0x5bc9610a}},	//   cson, र्वव, lthe, _रहुव,
   {{0x69c5704d,0x6b8d476e,0xf1c3e026,0x3160000a}},	//   othe, ipag, _naší_, _shiz_,
   {{0x7d0762ce,0x23600022,0xe29f0069,0x68e2c569}},	//   _mojs, _phij_, fað_, _faod,
   {{0x212f813a,0xdb09e1af,0x27ed8f08,0x671de1c9}},	//   nigh_, rteñ, _kren_, योजक_,
   {{0x317a2012,0x505a0627,0xdb09e07b,0x629e7a7d}},	//   _supz_, ршня_, steñ, yapo,
   {{0x9f44a1ae,0x693c8261,0x3f8dda7e,0x61e9c0bb}},	//   _irmã_, jčen, mpeu_, mvel,
   {{0x869a4c59,0x23600022,0x6f06405d,0x6d4b9a7f}},	//   итат_, _thij_, _pokc, koga,
   {{0x27ed9a80,0x6abbda81,0x6d4aaf40,0x448a4517}},	//   _oren_, nguf, zofa, рбан_,
   {{0x6d4aa9fa,0x6b8d4b5e,0x60d65a82,0xd838e06e}},	// [1740] yofa, gpag, reym, mača_,
   {{0x27e01062,0x6b84c049,0x3ebf8253,0x7ae4400e}},	//   _isin_, _éige, _acut_, sdit,
   {{0x6b8989ca,0x7ae3fa83,0xed5a44c4,0x8c3b0105}},	//   _ateg, _mant, _вон_, raße,
   {{0x92b62896,0x938a8439,0x260ae077,0xa2ca60c2}},	//   _احکا, аска_, ाहती_, _सॉर्,
   {{0x2d4f65df,0xa3bbe0c2,0x3f8900c7,0x6b5d00fa}},	//   gües_, इंड_, _xtau_, néga,
   {{0x68e41a84,0x940b4497,0x212f86a5,0x63a45a85}},	//   _laid, _necə_, aigh_, msin,
   {{0x657aa058,0x66dfe013,0xdb09e071,0x29190b8e}},	//   _quth, iškė, greí, ūrai_,
   {{0x26d83a86,0x4ac66064,0x2ca04e88,0x2907e2d9}},	//   hero_, र्रव, naid_, _aona_,
   {{0x26d828fb,0x27ed9a87,0x80c16eb5,0xa2c161c9}},	//   kero_, _gren_, र्के, र्क्,
   {{0xcff74076,0x38cba555,0xad26e049,0x3ea05a88}},	//   קציה_, _نامی_, تربو, hait_,
   {{0xdb09e333,0x3f89012a,0x27e952cb,0x68e41540}},	//   creí, _stau_, zvan_, _baid,
   {{0x74ca6969,0x25b82187,0x8cca7244,0xdce40012}},	//   स्तृ, durl_, स्तो, _bunđ,
   {{0x68e40605,0x2fc69a89,0x63b8a05c,0x60c0805d}},	//   _daid, ntog_, luvn, _mcmm,
   {{0x25fc0028,0x940b403c,0xe8d90119,0x3949c0a3}},	//   _ऊपरी_, _gecə_, _thỏ_, čase_,
   {{0xc1c96064,0x63a45a8a,0x6d4b92cc,0x69c5658f}},	//   _रहेग, esin, yoga, xthe,
   {{0x692b0026,0xbcfb413a,0x2fc69a8b,0x98a20013}},	//   zřej, _bhéa, ktog_, tiką_,
   {{0x7c3b40a9,0x61ee62a4,0x0ca8414a,0x673aeb83}},	// [1750] _žurb, _arbl, ютри_, ontj,
   {{0x26d83a8c,0x61ee63ee,0x81cde07c,0x249fda8d}},	//   cero_, _brbl, রির_, zaum_,
   {{0x13d3c07c,0x6b8d5a8e,0x753ae108,0xdb1bfa8f}},	//   ়িয়, spag, intz, ntuá,
   {{0x6f1aa12a,0x5ead007c,0x6441a05d,0x27ed975e}},	//   _altc, ট্রে, _rxli, _pren_,
   {{0x82348050,0xdb09e1ae,0x7d076048,0xbbd9c026}},	//   ورها, queç, _tojs, _भनेक,
   {{0x2db80095,0x9ccba0fb,0x2d95a11f,0xdb1be803}},	//   קלון_, рыда_, прис, ktuá,
   {{0xdb07403a,0x7bc73a90,0xd9a81a91,0x69374098}},	//   dujú, ntju, _कट्ट, tćeh,
   {{0x26d83a92,0x212bc0d1,0x6562c090,0x2fdf8022}},	//   zero_, òch_, _choh, _tsug_,
   {{0xb17b4249,0x249fd3e0,0xe3b1c049,0x6f1b8071}},	//   _gråt, raum_, ررة_, _iluc,
   {{0x672d19a5,0x44b4add1,0xe576c1eb,0x291efa93}},	//   _amaj, _обус, язь_, ghta_,
   {{0x2907ecce,0x26d90631,0x7bc52048,0xdee600bc}},	//   _vona_, feso_, _nqhu, пони,
   {{0x3980c0d1,0x629d5a94,0xdb1c4066,0xdbd02066}},	//   _fòs_, _neso, ktrá, užív,
   {{0xee3700ff,0x21a30052,0x657d4003,0x291ee420}},	//   зня_, ниям, _nush, bhta_,
   {{0x5fbfa026,0x3ea05a95,0x63a446bf,0x6562c05d}},	//   _एमाल, wait_, vsin, _zhoh,
   {{0x551fc55d,0x629c6011,0xdb1be057,0xa96a01c0}},	//   _बताए_, _rero, ctuá, _лика_,
   {{0x63864926,0xec7a4e12,0xd83f0c49,0x628568db}},	//   згаа, спа_, ščak_, echo,
   {{0x3b07433f,0x69c72200,0x65641a11,0xb2bb0095}},	// [1760] чето_, atje, _ihih, _המפר,
   {{0x213f8187,0x212d818c,0x7c3b4a5f,0xe29a674c}},	//   _ajuh_, _ameh_, _žurc, саж_,
   {{0xc0472119,0x6d5641e7,0x41b668e4,0x777c6401}},	//   _mượn_, plya, ясат, _qurx,
   {{0x7d0987db,0xdb0ac156,0x7d08a07f,0xdddb8012}},	//   _coes, ltfö, _sods, _sfuš,
   {{0x2d98e359,0xdb046aaa,0x6f08ba96,0xaac10026}},	//   árez_, nsië, _podc, ष्टक,
   {{0xa9a66a18,0x39400143,0xb87b0009,0xdbc74046}},	//   _нигд, _ljis_, gdíj, tööt,
   {{0xf41f03f5,0x6e228009,0x52d86046,0x672e61f6}},	//   nbär_, szob, ड़ीस, _imbj,
   {{0xa6b5804e,0x98a4c03b,0x7ae643e0,0x3983a03c}},	//   _осущ, kimą_, _jakt, _qısa_,
   {{0xba3b43c5,0xa2c4a026,0x24869a97,0xdb07402e}},	//   _geïd, _राप्, mcom_, tujú,
   {{0xf55aa13a,0x6aa0cb48,0x98a5e0ba,0x3981f2d9}},	//   _الطب_, samf, vilă_, _bós_,
   {{0x3f591a98,0x3981e32a,0xbcfb1a99,0x8cc10148}},	//   séum_, _cós_, lméi, _वादो,
   {{0x290a7a9a,0xc7b36095,0x6d58b31f,0xe0cfe050}},	//   _loba_, עבר_, llva, پزی_,
   {{0x78bd1a9b,0x6d58a747,0x61207a9c,0x78a1fa9d}},	//   rgsv, olva, _köld, balv,
   {{0xdddbc12a,0x70770555,0xe6c888ae,0x61e2d5f3}},	//   scuţ, _کاغذ, रभुज, _isol,
   {{0xb87b4057,0x7ae522df,0x24868939,0x3d0d28c6}},	//   _faíl, _vaht, kcom_, _सकीं_,
   {{0x657d4393,0xd7bbe076,0x765560c2,0x776401f6}},	//   _push, _הצהר, _ryzy, _ghix,
   {{0x224d20c2,0x7b3c9a9e,0xdb0d61de,0x2486802e}},	// [1770] łek_, rčul, nuaç, dcom_,
   {{0x6b8d1a9f,0x61edd3f9,0x7d0980f0,0x673bdaa0}},	//   _itag, _šalk, _soes, znuj,
   {{0xdb046004,0x2ee5baa1,0x99d961c1,0x657e2229}},	//   isiè, _ralf_, تواء_, _guph,
   {{0xa3acc04b,0xdb0d63f6,0x32cfad5d,0x311485d0}},	//   गळा_, mraí, zıyı_, нфіс,
   {{0x2a612012,0xed5880ff,0xaf3760eb,0xdee5a517}},	//   _hzhb_, чої_, _فرست, доли,
   {{0x798d00ce,0xdb1c8049,0x6b560071,0x3ce94046}},	//   _mtaw, _bpró, rági, ldav_,
   {{0x78a1e2df,0x2d862320,0xa3d2a182,0x399ab12d}},	//   valv, _čoek_, војч, gūs_,
   {{0x27f86066,0x248694b3,0x6d58a005,0x6b560071}},	//   šený_, ccom_, alva, pági,
   {{0x61ed4dab,0xd0a8c13a,0x7e7b9aa2,0x2d99cbf9}},	//   nval, سطين_, _igup, èse_,
   {{0x2fc94105,0x98a4c03b,0x7c248569,0x399aaa98}},	//   itag_, vimą_, ùire, būs_,
   {{0xa96a0971,0x6aa1e78c,0x9d461aa3,0x6b8d07ef}},	//   жина_, ralf, денд, _atag,
   {{0x8fa6027c,0xdbd78052,0x3015c1ef,0x61e2c227}},	//   маме, päät, _одер, _fsol,
   {{0x78a1e5be,0x7ae9c061,0x6d5980d5,0x2cbfc954}},	//   palv, mdet, ilwa, mgud_,
   {{0x28cf7244,0x2fc94065,0x6b8d0049,0xf8cee067}},	//   स्मि, dtag_, _dtag, _hứng_,
   {{0xdb0adaa4,0x3ea20200,0x5894e13a,0x69c9d11b}},	//   rtfö, pakt_, _أجهز, ltee,
   {{0x6d4f00b8,0x7e7b9aa5,0x680ae03c,0xdb0acc31}},	//   coca, _ngup, qəda, stfö,
   {{0x68e7613e,0x7ae9daa6,0x31648143,0x6365c005}},	// [1780] _bajd, idet, _rhmz_, mónd,
   {{0x7ae9c04e,0xfe7268b8,0x6d4e3aa7,0xc05a7096}},	//   hdet, ندا_, qoba, орец_,
   {{0x68e7600a,0x6e462423,0xf8bf1aa8,0x04462691}},	//   _dajd, _ценз, ciés_, _ценн,
   {{0xaca3a096,0x6d41a143,0x61ed4018,0x7ae65aa9}},	//   _faịl, _ajla, bval, _uakt,
   {{0x60dbc2b2,0xdb04613a,0x97da8566,0x2ca00d77}},	//   deum, iriú, تظار_, _meid_,
   {{0x7ae9d683,0x317ea526,0x6d4f1aaa,0x28cfe4e5}},	//   edet, _putz_, zoca, त्मि,
   {{0x7b102105,0xda0e2604,0x1dd26dad,0x693c802e}},	//   _häus, सहित_, _सहित, nček,
   {{0x7ae9daab,0x8cca63af,0x68e9daac,0x27edc262}},	//   gdet, स्रो, gded, fven_,
   {{0x6b8de012,0x63bbdaad,0x81d6c1a6,0x61e40194}},	//   _čaga, guun, ায়ন_, _nsil,
   {{0x93fb40be,0x98a00064,0x60dc214f,0x78a08156}},	//   קליי, _imię_, jerm, _hemv,
   {{0x3d022216,0x34b76095,0x69c9c335,0x290ca0ae}},	//   शाने_, ופים_, atee, _ioda_,
   {{0x7bc8e23c,0xdbd961ae,0x92bee07c,0x63bbcb90}},	//   rtdu, cçõe, ঁজে_, buun,
   {{0x6aa08622,0x290cbaae,0x61e400e0,0x7ae8a493}},	//   _memf, _koda_, _csil, _kadt,
   {{0x68e8baaf,0x60dc38bd,0x6aa080da,0x7e62dab0}},	//   _jadd, germ, _lemf, _izop,
   {{0x5bdca969,0xead54662,0xa4d5412e,0x8c3dc5fc}},	//   _मनोव, новь, нові, maşa,
   {{0xdb0580dd,0x290cb673,0x78ad00bb,0xadc3c1e9}},	//   rshë, _loda_, _udav, _apẹj,
   {{0xd56727ca,0x58844056,0xe7bcc07c,0x6b8d0631}},	// [1790] _отоп, тыса, _অনুয, _utag,
   {{0x2fc95ab1,0x60dc3ab2,0x69cfa148,0xa91daebe}},	//   rtag_, cerm, _दहली, _kuže,
   {{0x7cd98491,0x2fc95ab3,0x7ae9dab4,0x63bc2071}},	//   змер_, stag_, ydet, curn,
   {{0x26dc000b,0x81d5c1a6,0x69c9c052,0x38b561e9}},	//   ַקומ, হিত_, ytee, _bùrà_,
   {{0x3ce90037,0x1959a20e,0xeb998318,0x61e4005d}},	//   _maav_, пады_, чил_, _xsil,
   {{0x25a947d2,0x02dc0026,0x41bc0076,0xdb1d222e}},	//   msal_, _बस्न, קצוע, stsæ,
   {{0xd378a012,0x3f812b23,0x2d813ab5,0x6aa09ab6}},	//   _dić_, _juhu_, _juhe_, _femf,
   {{0x75229ab7,0x26164010,0xfba35244,0x63a993df}},	//   choz, पैकी_, _ओबाम, _tven,
   {{0x60dbc7ad,0x3219c066,0x3ea01ab8,0xee39c2d7}},	//   reum, ásy_, _reit_, яни_,
   {{0x60c41ab9,0xa205f386,0x4425f972,0x68e9816f}},	//   _scim, епод, tzl_, _haed,
   {{0x7778faba,0xed59e098,0x7afb894b,0x63bbc6d1}},	//   _divx, juže_, _knut, suun,
   {{0xe29703dd,0xa91da0e4,0x8c1a6095,0xed59e29c}},	//   наю_, _duže, פורי, duže_,
   {{0xaca36125,0xdb1d2156,0x7981a08b,0x741607f0}},	//   _ayọc, ktsä, _hulw, روسا,
   {{0x7981aee2,0x2d5c8017,0xfd1f4425,0x5cd52823}},	//   _kulw, víem_, _alì_, кісх,
   {{0x7658e013,0x5239e053,0xf484f9ad,0xb4abe04b}},	//   _gyvy, _מײַנ, _ручн, गणी_,
   {{0x656d4d72,0x8af0403c,0x66e359ad,0x6b81babb}},	//   gmah, lməz, лоса, _mulg,
   {{0x05667342,0x78a440bc,0x377541ba,0xf772c053}},	// [17a0] еван, raiv, тырс, רקן_,
   {{0x3ea5fabc,0x2d5c85df,0x63b64c8a,0x7a0ae5fc}},	//   nalt_, ríem_, rryn, kətl,
   {{0x69caa097,0xdb062066,0x429b21a9,0x2571c143}},	//   xtfe, jské, _מסיב, _ešli_,
   {{0x80de007c,0x291ea939,0x6f0d0005,0x98ab00ba}},	//   যাক্, _slta_, _xoac, mică_,
   {{0x78a1babd,0x3ce0ea11,0x69374055,0x2d55814f}},	//   _belv, _कसले_, rćet, vået_,
   {{0x2b405abe,0x67229abf,0x3ea5e10a,0x628bdac0}},	//   lnic_, shoj, jalt_, _afgo,
   {{0x26dca490,0x68e99ac1,0x98ab01fc,0x9d437ac2}},	//   revo_, _faed, nică_, _серд,
   {{0x2d825ac3,0x290ca0c2,0x79808284,0xdb046057}},	//   _kuke_, _woda_, _tumw, muiñ,
   {{0x93c88043,0xb146a739,0xa3e87ac4,0x68e8bac5}},	//   _تازہ_, _знал, बिक_, _tadd,
   {{0x39404105,0xf1b34694,0x6d561304,0x6f0e62bd}},	//   hnis_, נסת_, _akya, _jobc,
   {{0x6e95009e,0x3f825ac6,0x7d0d03ac,0x07376076}},	//   кину, _luku_, _poas, תאים_,
   {{0x8c1ba095,0x2d813ac7,0x25a94025,0x39a6e0f9}},	//   _מובי, _ruhe_, ysal_, _aísá_,
   {{0x27e0c65f,0x7d0e61e7,0x6d440030,0x0b8b014a}},	//   _èin_, _oobs, _djia, ясни_,
   {{0x6456a5fc,0x613b4d6e,0x27e6c7e0,0xa3c00290}},	//   əyir, kälä, _ison_, ँढ़_,
   {{0x8af0403c,0x657abac8,0x3957e095,0xcf57e095}},	//   lməy, _mith, _רשום_, _רבות_,
   {{0xbcfb4004,0x39405ac9,0x6b82c167,0x611826fa}},	//   _thém, gnis_, _kuog, _ağlı,
   {{0x3ea68426,0x645aa013,0xdcfba012,0x8af045fc}},	// [17b0] daot_, _lyti, _suuč, nməy,
   {{0xce6b6657,0x3f8f4041,0xf9900049,0x7a0ae03c}},	//   пред_, īgu_, _ابي_, yətl,
   {{0x291f8048,0x290d8561,0xdb047377,0xe8df6119}},	//   _plua_, _poea_, guiñ, _ngục_,
   {{0x2b4050bf,0xcda80050,0x26c6c048,0x2c0e2295}},	//   cnic_, _تهیه_, _ncoo_, ठहरू_,
   {{0x777aa265,0x7aed40ba,0x6b82c013,0x6d5bc022}},	//   _bitx, mdat, _nuog, vlua,
   {{0x7c87a04e,0x81d6c07c,0xbc3820eb,0x29094855}},	//   худе, াটা_, _آسیا_, ljaa_,
   {{0x9412003c,0x78a2daca,0x9f4bfacb,0x29c98510}},	//   _deyə_, _beov, ící_, súa_,
   {{0x2ca5facc,0x78a1a3c5,0x63b8606f,0x6b886071}},	//   wald_, _welv, ávne, _édga,
   {{0x3ea37142,0xb4dd8046,0x26defacd,0x316ddace}},	//   _kejt_, तजी_, feto_, rmez_,
   {{0xbcfb004a,0x7aed5acf,0xdb0620a3,0x2ca361f6}},	//   hléd, hdat, pské, _jejd_,
   {{0x3ea5effe,0xd629e53f,0x765b8037,0xb4dd08c6}},	//   ralt_, фоне_, _hyuy, ड़ू_,
   {{0x4087c14a,0x33332ce5,0xe8044026,0x6aca20c2}},	//   _чужб, _amxx_, रममा_, िभ्र,
   {{0x61e1e1cd,0x290fdad0,0xfd5982f4,0x6b54e017}},	//   swll, _ioga_, _bibẹ, ràgr,
   {{0x2bd26028,0xaca3e088,0x27262067,0x3ea25ad1}},	//   _सहला, _kpọk, _mông_, _sekt_,
   {{0x3f8360eb,0x394059d3,0x27262016,0x693c8299}},	//   _nuju_, tnis_, _lông_, mčev,
   {{0x93434a47,0x3a3f4133,0x7aebc522,0xf99f40d1}},	//   ансе, _župa_, _jagt, _bwè_,
   {{0x2b405ad2,0x6d41fad3,0x7d1bd407,0x3ea240ff}},	// [17c0] rnic_, onla, ikus, _vekt_,
   {{0x6d41fad4,0x7d1bc134,0x656987d4,0x68ed5ad5}},	//   nnla, hkus, _aheh, adad,
   {{0x18a68e4f,0x765b80e8,0x321c6066,0x9f4da2a8}},	//   ваем, _ayuy, ávy_, _creí_,
   {{0xe9ffa016,0x6123410a,0xee3a95ea,0x2d836133}},	//   _nhằm_, _põle, мне_, _duje_,
   {{0x7c29dad6,0x98a7af76,0x201c600a,0xdce3e133}},	//   jzer, linę_, švi_, _linđ,
   {{0x78a41114,0x7c29d100,0x9c7cbad7,0xdb1b0071}},	//   _leiv, dzer, _kači, ruté,
   {{0xb8dabad8,0xec776399,0x6363810a,0x97a3a013}},	//   _आए_, _апр_, sõna, арыл,
   {{0x9c7caf9e,0xdb1b00fa,0xa06a8808,0x7aebc025}},	//   _mači, puté, _жаба_, _cagt,
   {{0xb87b0009,0xc8f2c148,0xf366e474,0x98ab08fd}},	//   ndít, _अफीम_, ктон, nicą_,
   {{0x657aa23c,0x2ca7a12a,0xf8eb0028,0x7bce3ad9}},	//   _uith, cand_, _जोड़ा_, ktbu,
   {{0x2369005f,0x3f848167,0x91820067,0x33750255}},	//   _phaj_, _humu_, yện_, лгор,
   {{0x9c13bada,0x61e45adb,0x6124e0d1,0x7aed4171}},	//   _kọnk, kwil, _sòld, xdat,
   {{0xaed4e1fc,0x27262119,0x6b8407ad,0xfb1bc076}},	//   _болш, _xông_, _cuig, _קודמ,
   {{0x69c0c0b1,0x7aed4187,0x8233e555,0x6aa3fadc}},	//   mume, wdat, اریا, _genf,
   {{0xb4bee518,0x6b5609fe,0x78a72d52,0x443ae046}},	//   इली_, rágr, rajv, _äp_,
   {{0x63ad84f3,0x69cd404e,0x63ad0042,0x2ca7badd}},	//   šani, ttae, _tvan, zand_,
   {{0x3f836c12,0x26c91ade,0x2139193d,0x195845be}},	// [17d0] _suju_, _icao_, mish_, таты_,
   {{0x3ea7aca2,0xdd114041,0x69cd4108,0x31c445da}},	//   xant_, _kļūd, rtae, јств,
   {{0x7c29dadf,0x7bcd53a7,0x6d55212d,0x27262016}},	//   zzer, stau, moza, _sông_,
   {{0x3cfea258,0x2ca7a5c4,0x3f848035,0x9f4920b8}},	//   _antv_, wand_, _bumu_, _braç_,
   {{0x14d640be,0x22498106,0x6d58e06e,0x4ac604e5}},	//   _גורל_, çak_, _okva, _वासव,
   {{0x6722c07b,0x3ea943c5,0x1869aa09,0xa069a520}},	//   _aloj, laat_, нали_, нала_,
   {{0xa493c54f,0x6aa3f890,0x39aee03b,0x4429c06f}},	//   لیات, _renf, jęs_, _ťa_,
   {{0x3ea94e9b,0xa6e5c9b1,0x6e29dae0,0x2ca7bae1}},	//   naat_, ужил, tzeb, sand_,
   {{0x3ea7a1ab,0x7983e082,0x78a406c7,0xa2ca68b1}},	//   pant_, _sunw, _reiv, स्क्,
   {{0x2fcdc258,0x7d09dae2,0x3ea95ae3,0x213901e7}},	//   rteg_, sjes, haat_, eish_,
   {{0x7d09c7a0,0x645d5ae4,0x693c849f,0x7aebdae5}},	//   pjes, _lysi, rčev, _tagt,
   {{0xbcfb413a,0x68ed0054,0xa3e444ef,0xa2d3e029}},	//   _fhéi, _caad, _भईल_, _बॉर्,
   {{0x2ca94054,0xb4dfcf30,0x6aa3e227,0xb05b0851}},	//   daad_, दजी_, _tenf, sgän,
   {{0x8afce064,0x2f18c0e0,0x6722c098,0xfaff400e}},	//   ględ, _régi_, _zloj, _anë_,
   {{0x7aed1ae6,0x9c7ce12d,0x2f142156,0x60c98143}},	//   _faat, teče, _sägs_, _ocem,
   {{0x63ad5598,0x61e441ea,0x248dc858,0x69db84cd}},	//   fsan, twil, ncem_, _opue,
   {{0x7bce37a7,0x777d4057,0xa2cae4e5,0x61260d64}},	// [17e0] stbu, _disx, त्क्, _cóle,
   {{0x9c7ce3de,0x68ed153f,0x3f85a052,0x61e449cd}},	//   seče, _zaad, _oulu_, rwil,
   {{0x2912035f,0x2ca94054,0x6d59cbd4,0xeb9a64a7}},	//   _koya_, baad_, _okwa, хие_,
   {{0x63ad4025,0xa91da0a9,0xf539c06f,0x0cbec1a6}},	//   bsan, _ruža, jiť_, _আস্ত,
   {{0x6d445ae7,0x35b688ea,0xb8dc8af7,0x29121ae8}},	//   mnia, ущес, _आय_, _moya_,
   {{0x2912017b,0xfc3f4005,0x657d539d,0x63bbd132}},	//   _loya_, _edís_, _zish, drun,
   {{0x7ae1fae9,0x69c1faea,0x6ed62029,0x186770ba}},	//   delt, jule, म्यु, _бари_,
   {{0xdc082041,0x29120322,0x2d849aeb,0xdb0d61ae}},	//   dēļa, _noya_, _tume_, traç,
   {{0x7aee6524,0x7a0ae03c,0x77928050,0x2ca5a0cb}},	//   _kabt, məti, _ایتا, _feld_,
   {{0x7c3b4e3d,0x6d445ac1,0x7ae29aec,0x680ae03c}},	//   _žurk, hnia, leot, lədi,
   {{0xf539c03a,0x6d565aed,0x6d5520e4,0x2d982927}},	//   biť_, koya, voza, jpre_,
   {{0xac190503,0xa91da0f5,0x92e0607c,0x6da6c90f}},	//   вому_, _južn, থায়_, _бида,
   {{0x21390db2,0x6d445aee,0xddcbfaef,0xfc3f0057}},	//   rish_, dnia, čišt, raío_,
   {{0x7aee6048,0xce94e1e1,0x657d41fb,0x2ca94054}},	//   _nabt, _такъ, _sish, waad_,
   {{0x645d53fb,0xceb4403c,0xc7b821ba,0x657d5af0}},	//   _sysi, rkən_, лёт_, _pish,
   {{0x63a2d3f3,0x5c07414a,0xf2075af1,0x67240171}},	//   _kwon, ляза, лязо, _glij,
   {{0x798640a2,0xdb1b0066,0x629c291e,0x6d43a0fd}},	// [17f0] _cukw, nutí, bbro, ynna,
   {{0x2ca9436d,0x645d406f,0x6d445af2,0x60c98024}},	//   saad_, _vysi, ania, _scem,
   {{0x657d5af3,0x6d565af4,0x60c5605d,0x7aee4052}},	//   _tish, boya, rghm, öntä,
   {{0x61207af5,0x25addaf6,0x8f9a2095,0xd9f08021}},	//   _höll, ysel_, _שירי, चिंत_,
   {{0xa3e5612f,0x636b620f,0x3f85baf7,0x6b864187}},	//   _बैर_, tünd, _sulu_, _gukg,
   {{0x6d59c306,0x9f4da049,0x4ea7a0ba,0x7bc1e6fa}},	//   _skwa, _breá_, урда, yulu,
   {{0xdb02a9c1,0xab5b2105,0x636b7af8,0x9f4da071}},	//   groñ, prüf, ründ, _creá_,
   {{0xdc2121d7,0x63a1203a,0x2d85baf9,0x6d5aacc5}},	//   _aċċe, álny, _vule_, _ekta,
   {{0x629bc03b,0xf576c13a,0x3ea5b9eb,0xfba52960}},	//   rbuo, جميع_, _telt_, गीतम,
   {{0x6d445afa,0xdb1c4042,0x69dd417b,0xdbdea765}},	//   znia, strø, _mpse, _tíða,
   {{0x2a690ce1,0x225f8c12,0x67240579,0x236d805f}},	//   _azab_, _hyuk_, _plij, _khej_,
   {{0x2498e3df,0x8503a046,0x6d59c544,0x657e20bb}},	//   ırma_, लावट_, _ukwa, _siph,
   {{0x68e1fafb,0x7404007c,0xe3c7a07c,0x8fa5cfdb}},	//   peld, উন্ট_, _শনিব, _тале,
   {{0x26c7b5ab,0xa96a2c6c,0x98ab0041,0x8235e050}},	//   ngno_, тига_, ējās_, _پرتا,
   {{0x29121afc,0x7a0ae03c,0x68e3ab55,0x398b8654}},	//   _toya_, yəti, iend, _løs_,
   {{0x67241afd,0x96ba10ac,0x21295afe,0x3ea7eb48}},	//   _ulij, _руку_, ghah_, _hent_,

   {{0x442dc547,0xdb09faff,0xe2ca6de1,0xb5fb40f9}},	// [1800] nze_, queó, клад_, _ayáb,
   {{0x69dc7b00,0x21294022,0x7f44400e,0x130360ff}},	//   _ppre, ahah_, sniq, озум,
   {{0x7aef48cd,0x068684c9,0xc6a687c1,0x2d85204a}},	//   _fact, аген, арли, ílet_,
   {{0x7c446098,0xeb9a8c4e,0xaad228b1,0xe3a7c8b8}},	//   _čurć, вид_, द्रक, _ور_,
   {{0x6aaaa11d,0x44208067,0x26e5e290,0xeb06bb01}},	//   taff, ái_, _कसूर_, ичко,
   {{0x69c3bb02,0x6d5b9b03,0x60cbc090,0xa91da6ca}},	//   fune, _ekua, _acgm, _dužo,
   {{0xdcc60029,0x8884c062,0x2d87e860,0x693c8098}},	//   _वांछ, میان, _nune_, učes,
   {{0x753af3d5,0x7d008071,0xa96a898c,0x21204364}},	//   witz, _unms, _риба_, nkih_,
   {{0x5506efdb,0x272ac067,0xeb06e279,0xa534e12a}},	//   ачна, _lùng_, ачно, йнич,
   {{0x69de223c,0x6d461b04,0x656280dd,0xdb1c4333}},	//   _oppe, enka, lloh, durí,
   {{0x25ec8033,0x9813c050,0xb8cee3fa,0x6d220c87}},	//   _आईडी_, مبیا, _ओज_, मसंग_,
   {{0x612b2046,0xdb046005,0x69c44a13,0x3f87ef8f}},	//   _külg, iriñ, kuie, _dunu_,
   {{0x8d94c13a,0x6d4561cd,0x3eab1b05,0xfd57a0f9}},	//   _التش, ynha, ract_, _abaṣ,
   {{0x3f87e133,0x673ae00e,0x80aa6077,0x3d04c7fa}},	//   _funu_, qitj, टरफे, वावे_,
   {{0x93882731,0x92a7455a,0x612079d3,0x0b882822}},	//   иста_, ијал, _völl, исти_,
   {{0xc27be00b,0x78a8ab30,0xfaff000e,0x8a7be095}},	//   _ברוי, _ledv, rmës_, _באות,
   {{0x26db0022,0xbcfb1b06,0x7988bb07,0x2129405d}},	// [1810] _ibqo_, cléa, _ludw, rhah_,
   {{0x2ca91b08,0x3949c06e,0x64a70028,0xf8ef80c5}},	//   _head_, časi_, _ख़ुश, _घोड़ा_,
   {{0x62852079,0x2d8ae06f,0x7d02c614,0x63a41b07}},	//   _igho, íbeh_, _onos, _zwin,
   {{0x5c759156,0xe50563fa,0x85056028,0xbd689116}},	//   блет, राहि_, राहट_, арче_,
   {{0x8af045fc,0x798080ca,0x67f06009,0xeef80989}},	//   tləv, _dimw, tójá, ימאר_,
   {{0x6aad4e47,0x6d473b09,0x6d5d40ae,0xdb04603e}},	//   laaf, nnja, _hksa, briñ,
   {{0xd37b80ba,0x3ea7e076,0x6aa8a16f,0x60da2466}},	//   _ача_, _rent_, _dedf, õtmi,
   {{0x0ae9c662,0x850565e8,0xd1056437,0x6d5c604a}},	//   удий_, रावट_, रावण_, _zkra,
   {{0xa1948905,0x661d0065,0x673d00ff,0x2bda8555}},	//   _матч, jysk, disj, _مالک_,
   {{0x6729c132,0x6f02db0a,0x3ea90019,0x8af0403c}},	//   shej, _enoc, _aeat_, llət,
   {{0x6aa99b0b,0x61fb800a,0x7bc56b5a,0x9c7ce742}},	//   _keef, _hrul, nuhu, teča,
   {{0x62853b0c,0xa3bb8028,0x27e94795,0x673c2037}},	//   _agho, _आटा_, kwan_, wirj,
   {{0x753de043,0x395838bb,0xc588c016,0x27e95b0d}},	//   észs, tors_, _hồn_, jwan_,
   {{0x661c3b0e,0x6d472143,0x6370610a,0x61e9db0f}},	//   tyrk, gnja, mäng, mwel,
   {{0x61ed09dd,0x7d1ce097,0xd838a06e,0x60db8ee2}},	//   _esal, örse, _peči_, _obum,
   {{0x39583b10,0x6362601f,0x86995b11,0x6aa99b12}},	//   sors_, môni, итут_, _neef,
   {{0x3946800a,0x3f890fb3,0xf388c067,0x39582b70}},	// [1820] vnos_, _guau_, _lợn_, pors_,
   {{0x6d58a942,0x2fd24156,0xdb04641a,0xed59c04a}},	//   xova, rtyg_, isiç, hož_,
   {{0xc333200b,0x27e94258,0xe73a5138,0x7e608dee}},	//   _מוז_, awan_, _бен_, _symp,
   {{0x984a8627,0xb4c28295,0x2d5c80b6,0xf38a8082}},	//   ляла_, ंले_, víes_, _aṣa_,
   {{0x69c61135,0x61ed005d,0xad9b41e9,0x7981b598}},	//   nuke, _xsal, _arúf, _bilw,
   {{0x60db8291,0x26d821cd,0x96f8a1fc,0xc588c119}},	//   _ebum, nfro_, рект_, _bồn_,
   {{0x3eaa6057,0xdb1d21ae,0x7988a17b,0x25bfc0ba}},	//   _iebt_, lusã, _qudw, erul_,
   {{0xa4918896,0x6d598064,0xbc1b6095,0x1ae4207c}},	//   _قیمت, cowa, _גולש, মায়া,
   {{0x6b81a0f7,0x3eb86037,0xe9a385da,0x673d014f}},	//   _filg, _kdrt_, _натп, visj,
   {{0x6d5e2088,0x8c46a4a7,0x95d8e01b,0x8afca0c2}},	//   _nkpa, _лезе, адот_, _chęt,
   {{0x2ca9010a,0x3eace0e0,0xe8d90067,0x27e000f9}},	//   _pead_, radt_, _chở_, _apin_,
   {{0x81bce2b8,0xc27b6087,0x6c86c13a,0x1959003b}},	//   dzēt, טריי, _الإم, рамы_,
   {{0x7d1dc0cb,0x5eab01a6,0x3f8a7b13,0xd8d78053}},	//   össe, _কাদে, _lubu_, זוכט_,
   {{0x87b7c3c8,0x2d6840cb,0x661d00c2,0x81df61a6}},	//   _פלוס_, ußen_, rysk, তিত_,
   {{0x7ae61b14,0x653be095,0x61ed005d,0x2fc05b15}},	//   bekt, _תעוד, _wsal, erig_,
   {{0xbcfb40f9,0x26c94480,0xa91da579,0x69c607c7}},	//   _ahér, ugao_, _ružm, buke,
   {{0x6aa994d0,0x7bc61b16,0xdb2400e0,0x69d82277}},	// [1830] _reef, cuku, _írás, _även,
   {{0xd13120d0,0x3f8a73c7,0x612b27d2,0xaefb503c}},	//   _آمد_, _bubu_, _büle, _chùr,
   {{0x2ba94033,0x65645b17,0xa2ce2437,0x27e940a2}},	//   _चौरा, blih, _तात्, swan_,
   {{0x01c94043,0x9df9826f,0xcf93e00b,0x2486c0a2}},	//   _پوسٹ_, инет_, לטע_, _ngom_,
   {{0xa2c4a295,0xdfc6c243,0xbddb45df,0x6b89865f}},	//   _राख्, _تي_, _exèr, _queg,
   {{0x3f824098,0xd5dd2028,0xad9b4031,0xdd86fb18}},	//   _ziku_, _पहाड़, _arúg, _يو_,
   {{0x7bd52e3b,0x8af04497,0x6d599b19,0x3d0ce0c2}},	//   ntzu, mlər, powa, ़ाने_,
   {{0x672d4605,0x61fb9b1a,0x25bfc12a,0x254cc04a}},	//   nhaj, _trul, trul_, těla_,
   {{0x27ed92b6,0x2d837b1b,0x3eadc271,0xe0df4030}},	//   _usen_, _kije_, raet_, _ajòk_,
   {{0x3eaf8654,0x6f1600b6,0x2d837037,0x69c61b1c}},	//   lagt_, _soyc, _jije_, vuke,
   {{0xd838a3a1,0x3669e0de,0x7ae72026,0x64416579}},	//   _beču_, рано_, dejt, _žlij,
   {{0x27e0c12a,0x3f836143,0x2ee5fb1d,0xdb1b0089}},	//   _ţine_, _liju_, self_, tutá,
   {{0xa2cc8578,0x1d09e01b,0x6d89406f,0x68e61b1e}},	//   _हास्, _вели_, _uľah, rekd,
   {{0x6d4d1b1f,0x6d5af39c,0x39494b8e,0x21290037}},	//   _ejaa, cota, enas_, _elah_,
   {{0x3ea05b20,0x69c600bb,0x2905b2c2,0x2d8b5b21}},	//   tbit_, suke, _mnla_, _auce_,
   {{0x2b495b22,0x6f040ea3,0x4d66412e,0x752d5241}},	//   gnac_, _unic, ікав, ghaz,
   {{0xe8c61160,0x3f824069,0x25a0a06a,0x27e01b23}},	// [1840] वलीच, _viku_, ćili_, _upin_,
   {{0x3f83616d,0xfe4665a8,0x753b9b24,0x5ec1207c}},	//   _ciju_, онзо, _amuz, শ্বে,
   {{0xe29767b9,0x80b10064,0x3f6a4c4e,0x79840079}},	//   цах_, _अजमे, _вино_, _kiiw,
   {{0x57cce00b,0x6d5c36dc,0x27f8a0c4,0x6d4140fa}},	//   רמאַ, lora, _árni_, élat,
   {{0x6d5ae167,0xc33300be,0x7d17203c,0x7b39e066}},	//   yota, ווא_, _yoxs, rňuj,
   {{0x6d5c2db2,0x3f8a6227,0x67298009,0x27e98017}},	//   nora, _tubu_, _elej, çana_,
   {{0x272f2105,0x76a9a0ff,0x6d48eb57,0x7f5c2057}},	//   _fünf_, стів_, vnda, iorq,
   {{0x3a3f4133,0x7af65b25,0x6287600e,0x75244108}},	//   _župi_, ndyt, _zgjo, nkiz,
   {{0x0ed2a010,0x78a2908f,0x7e641b26,0x6b8bc425}},	//   _सापड, mbov, _nyip, _cugg,
   {{0x01d001a6,0x7af64052,0x37e6aeb3,0xa3ce6077}},	//   িবাদ, hdyt, _мозг, _शमा_,
   {{0xe61f4016,0xab2ad096,0x0e8ec291,0x2fc7ab39}},	//   _ngôn_, _кожа_, _dịrị_, cung_,
   {{0x6d49c28f,0xf41f0052,0x69c3607f,0x78a22143}},	//   cnea, tyä_, šneg, _đova,
   {{0x2caca0e0,0x6d4abb27,0x201ee013,0x6d40d0aa}},	//   _kedd_, onfa, syti_, mima,
   {{0x7e6401e7,0x7983e1e7,0x3f848035,0x3eab5b28}},	//   _dyip, _ginw, _limu_, _sect_,
   {{0x636da049,0xdb062156,0x3f83604d,0x69d52108}},	//   núna, dskä, _riju_, utze,
   {{0x28dd605e,0xbdfb6050,0x2d8cb242,0x29187b29}},	//   न्नि, یرضا_, _mude_, _aora_,
   {{0x8af04497,0x5a354d9a,0x6d5c3a83,0x6f18e098}},	// [1850] tlər, чнат, bora, _kovc,
   {{0x61e2c08e,0x9967612e,0x6e676799,0x752d5b2a}},	//   _mpol, італ, отеж, shaz,
   {{0x39495b2b,0x6b8d1819,0xf77088b5,0x8c3dc106}},	//   pnas_, _huag, چان_, laşt,
   {{0x80cda7fa,0x636da049,0x68e8e1cd,0x2d8b4274}},	//   _साहे, dúna, hedd, _tuce_,
   {{0xfa964087,0x68e8eb87,0x80d87b2c,0x60cd4167}},	//   _מדרש_, kedd, न्हे, mgam,
   {{0x61ed4800,0x7bc8fb2d,0x2bdbe688,0xe7e000c5}},	//   mwal, kudu, _बहला, खौटा_,
   {{0xf62860ff,0x2d8ca0e8,0x3869c361,0x6d5bd4cd}},	//   _діти_, _cude_, _šar_, toua,
   {{0x6d40d747,0x69c28d53,0xa3bbe9e4,0xdb1be5df}},	//   gima, broe, ेंस_, truï,
   {{0x7e63e277,0x6b8d0004,0x4255a555,0x2729e019}},	//   _synp, _nuag, _کنار, _aúna_,
   {{0xfbd241a9,0xe80f1b2e,0x78abc3b0,0x75244108}},	//   עתי_, ामना_, _wegv, zkiz,
   {{0x2d85a088,0x09e1c07c,0x69c8fb2f,0x3f8580fa}},	//   _iile_, বিধা, gude, _élus_,
   {{0xd343c043,0x7b1cc057,0x3f85a6be,0x442055a6}},	//   _تفصی, _déus, _hilu_, yyi_,
   {{0x6130210a,0x7ed4c0d0,0xa159e71b,0x3ead88c3}},	//   _jälg, _آزما, _ладу_, _meet_,
   {{0xe7e38518,0x3b0a204e,0xb113c096,0xdb09e5e0}},	//   _गहना_, щего_, _bụgh, rreó,
   {{0x7f5d0019,0xfaa64974,0x2d9fc071,0xd00443c3}},	//   bosq, забо, lpue_, रम्भ_,
   {{0x6364b28e,0x2cad9b08,0x63a99b30,0x5fc2c4da}},	//   ròni, _need_, _owen, _शिमल,
   {{0x6365c019,0x63a98194,0x1aeee07c,0x68f57b31}},	// [1860] góni, _nwen, জারে_, _bazd,
   {{0x44205b32,0x68f61b33,0x75244108,0x39405b34}},	//   ryi_, _hayd, skiz, siis_,
   {{0x27ff82f4,0x44264f68,0x6b9b9b35,0x6d40c631}},	//   _arun_, šo_, _atug, yima,
   {{0x6d4b8e87,0x29195ab6,0x3f8cbb36,0x69d64c57}},	//   gnga, _gosa_, _rudu_, ptye,
   {{0x29187b37,0x68e8e035,0x27ff858f,0x61ed41fb}},	//   _tora_, yedd, _crun_, cwal,
   {{0x3991a13a,0xf767e0e0,0x3f8cbb38,0x672bc0c4}},	//   _bás_, _سا_, _pudu_, _algj,
   {{0x79864f65,0x63b64271,0x6d5d0a36,0x2730a016}},	//   _kikw, lsyn, yosa, _làng_,
   {{0x68e8f748,0x7b1cc162,0x973d0579,0x93fb2095}},	//   wedd, _réus, opće, מלצי,
   {{0x7986465b,0x5f76a0e0,0x636da049,0xb4b8804b}},	//   _mikw, _فائر, súna, चणी_,
   {{0x81df6405,0x9666a5e7,0x2cb24054,0x3991a049}},	//   তির_, _екзе, hayd_, _fás_,
   {{0x61ed4064,0xbc6aaca7,0xb09ba0be,0x6365c019}},	//   zwal, _امان_, _היבר, zóni,
   {{0x25a90163,0x798e62ad,0x39420046,0x63b65b39}},	//   _pwal_, _mubw, giks_, ksyn,
   {{0xbcfb00e0,0x6b8d1b3a,0x68f60025,0xd05c635f}},	//   llék, _quag, _dayd, _karɓ,
   {{0x58d3e90f,0x2d85210a,0x6365d320,0x61234046}},	//   _зошт, öle_, vóni, _tõlk,
   {{0x7af5606e,0x6d5d1b3b,0x798e600f,0xd8dbe076}},	//   _razt, posa, _nubw, _הקור,
   {{0xae9b013a,0x7d1aad85,0x6568e156,0xe1ff4395}},	//   _اضغط_, _lots, lldh, _pró_,
   {{0x70550050,0x68f5729e,0xdebc0076,0x8ccdbb3c}},	// [1870] _زندا, _pazd, _המחל, _सालो,
   {{0x7d1ab640,0x2a66c037,0x635200d8,0xfc4664d2}},	//   _nots, _myob_, māna, čína_,
   {{0x6d4b8c57,0x9f407b3d,0x78ae6071,0xd498220e}},	//   tnga, rvið_, _debv, _эры_,
   {{0x7d08bb3e,0x63722065,0x6d4b9b3f,0xb9156291}},	//   _ands, ræne, unga, _yabụ_,
   {{0xb8d3607c,0x61ed5b40,0x752d00e4,0x672d1b41}},	//   _টা_, qwal, _mlaz, _mlaj,
   {{0x7bcaaa71,0x68e9d0a5,0xf1b12f30,0x9c7ce07f}},	//   fufu, weed, _जबान, rečj,
   {{0x2a66c05d,0x46bf0026,0x2cad8046,0x672d1b42}},	//   _ayob_, ्लाह, _teed_, _olaj,
   {{0x2d86cab8,0x7f4d4227,0x29091a18,0x63bdc066}},	//   _cioe_, nnaq, _nnaa_, ásno,
   {{0x7bc3a0e4,0xe4e7a12e,0xfd4ea088,0x27ff8cd4}},	//   srnu, _ніжн, _jekọ, _urun_,
   {{0x61fbc1cf,0xa3d71008,0x66021b43,0x69cabb44}},	//   rvul, _सहज_, _šoko, bufe,
   {{0x69cb9b45,0x69d98105,0x68e9c046,0xfd4ea079}},	//   luge, ltwe, peed, _lekọ,
   {{0xd5d19008,0x28dd6026,0xe2971574,0x63b8605c}},	//   _समाज, न्ति, маю_, ávni,
   {{0x68f72caf,0x6d5e6167,0x7bc56105,0x291a3b46}},	//   _baxd, yopa, hrhu, _popa_,
   {{0x09e62501,0x1dc5e4e6,0x7af72057,0x59c5f895}},	//   могн, _विपत, _caxt, _विपर,
   {{0x3f8fc304,0xd62a214a,0x257460cb,0xd84f0125}},	//   _hugu_, цове_, näle_, wọta_,
   {{0xbebb000e,0xb4bc924a,0x69cb909d,0x7bcb8eca}},	//   shër, _आये_, kuge, kugu,
   {{0x18674b65,0xb928c096,0x8c435b47,0x61e9623d}},	// [1880] дати_, _anwụ_, вете, _ćela,
   {{0x8c430105,0x25a0540d,0x9f4b6197,0xe9ffa119}},	//   ößer, rpil_, _uscì_, _nhắm_,
   {{0xdb0ac0dd,0x7d1aa109,0x25a0486b,0x69cb86be}},	//   ënës, _rots, spil_, euge,
   {{0x628bc050,0x2d9c6018,0x3f9c6018,0x1dc5e148}},	//   _nggo, īve_, īvu_, _विनत,
   {{0x394d5b48,0xb0d2a028,0xa3ab85cb,0xf8b343c8}},	//   čest_, _सादग, _कौआ_, _בשר_,
   {{0x69d8a14f,0x6d4380fa,0x28dd7b49,0x6299c061}},	//   ttve, énar, न्दि, _afwo,
   {{0x3866c0c7,0xa91da013,0x6d429a47,0x3f8fdb4a}},	//   _syor_, _nužu, pioa, _augu_,
   {{0x92aea07c,0x2d9ce41d,0x3f8fc35f,0xa2be2180}},	//   কলে_, _rtve_, _bugu_, वृत्,
   {{0x7d1abb4b,0x63ada1e4,0x6365c069,0x2d8fc012}},	//   _tots, ćana, jónu, _cuge_,
   {{0x656409e6,0x692c4106,0xb7d4a1e9,0x7769db4c}},	//   _akih, rşey, _aṣed, alex,
   {{0x7c24400f,0xbcfb1b4d,0x6d4d4025,0xc588c067}},	//   hyir, lléi, ynaa, _mồi_,
   {{0x7e26c04e,0x39432200,0x6b88a0ae,0xaefb4031}},	//   _одеж, wijs_, _hidg, _akùn,
   {{0x752d03ee,0x63a28265,0x637601af,0x3f87e0a9}},	//   _vlaz, npon, dánd, _finu_,
   {{0x638805cd,0x27e6db4e,0x3f87e0e8,0x61fd0065}},	//   tènè, _ipon_, _ginu_, rvsl,
   {{0x200d012a,0x6d87c009,0x63760057,0x386d404d}},	//   ţei_, _műan, fánd, _šer_,
   {{0xa3cfa79e,0x636b66df,0xd30fc067,0x3d0ce046}},	//   वंत_, rünm, _lệnh_, ़ावे_,
   {{0x93780ca7,0xb345a01f,0x7bdae04e,0x7d1b8666}},	// [1890] _تصور_, niçã, lttu, _rous,
   {{0x7d1b9b4f,0x61314277,0x63ad1b50,0x25721b51}},	//   _sous, _såld, _iwan, mála_,
   {{0x2ef86669,0x25720886,0x6d4f19d2,0x7ae2db52}},	//   _darf_, lála_, onca, _obot,
   {{0x636fe0ff,0x2b0800c2,0x69cb8afc,0x4424c4d2}},	//   jønn, षाएँ_, tuge, kym_,
   {{0xbbeb850f,0x61314277,0x63a29b53,0x7d09842e}},	//   ترام_, _våld, gpon, _vnes,
   {{0x7bcb9b54,0xb345a01f,0x6f1c61cd,0x394dc10f}},	//   rugu, diçã, _gorc, wnes_,
   {{0xa2d734c6,0x7bcb810a,0x63ad1b55,0x3f8fdb56}},	//   _बान्, sugu, _lwan, _sugu_,
   {{0xa2d7607c,0x2bd3c029,0x636da4cd,0x6d4f02a8}},	//   _সফটও, _दमदा, múnm, ébal,
   {{0x657bc17b,0x64572057,0xa3c1c12f,0x3f87fb57}},	//   rmuh, _lxxi, ौंध_, _pinu_,
   {{0x21294622,0xf389e081,0xee39f1e5,0x809fc180}},	//   hkah_, _hải_, зно_, _ग्रे,
   {{0x216a025d,0x25a2017b,0x27342851,0xd009f255}},	//   зини_, wpkl_, _häng_, чене_,
   {{0xb345a1ae,0x7bc60098,0xef1981f6,0xe732050f}},	//   biçã, trku, _biżi_, اصد_,
   {{0xdb0be342,0x69dafb58,0x394f9b59,0x25720049}},	//   _avgå, atte, ings_, gála_,
   {{0x3d069b5a,0x6d4f11de,0x290b46c1,0x68f9c1cd}},	//   _सोने_, anca, _anca_, _hawd,
   {{0xc0e64792,0x2ca680e2,0x63a280e0,0xb113c088}},	//   новк, ybod_, zpon, _gụch,
   {{0x4425fb5b,0x63788639,0x63bb9b5c,0x3f9e2041}},	//   myl_, míng, _ovun, ītu_,
   {{0x7e698236,0x612b3b5d,0x61302156,0xf388e067}},	// [18a0] _nyep, _küll, _välb, _sợi_,
   {{0x3945fb5e,0x63718156,0x7afbc052,0xb14364a0}},	//   nils_, våna, hdut, гнул,
   {{0x61314536,0x63bb9b5f,0x7c24413b,0x6b899b60}},	//   _såle, _avun, syir, _bieg,
   {{0x809fc029,0x6135c069,0x0b8a8244,0xe9ffa067}},	//   _ग्ले, _hálf, пски_, _chậm_,
   {{0x9c7ce917,0x28f8a54a,0x98a7a03b,0x4af8a04e}},	//   reči, дель_, ninė_, делю_,
   {{0x7bdae0c4,0xc588e119,0xdfd0a243,0x7b2b01df}},	//   yttu, _tồi_, ليت_, nƙur,
   {{0x69ce2011,0x291dc0f9,0x27f25b61,0xd47a2053}},	//   nube, _bowa_, lwyn_, האַל,
   {{0xb345a01f,0x68fbcb5e,0x6d41a4de,0x31baa041}},	//   tiçã, gdud, _emla, rīz_,
   {{0xf8dd6afa,0xdef8a17a,0x65628037,0x612de06f}},	//   न्वय, _taċ_, mooh, _súla,
   {{0xa91d842e,0x3944c78b,0x69ce311d,0x2eaa2010}},	//   _nižj, sims_, kube, करोत,
   {{0x38690d3d,0x6603f6ad,0x2d4400e0,0x041ec07c}},	//   _syar_, _crnk, rűen_, _বেশী_,
   {{0x68e2c0a9,0x68ed5aff,0x63ad0167,0x69c72579}},	//   _ubod, xead, _pwan, vrje,
   {{0x660405d7,0x6d41a0e2,0x16038064,0x6f1d5b62}},	//   _crik, _ymla, लियर_, _rosc,
   {{0xe1ff08cc,0x612b2315,0x4425e04a,0x539bc087}},	//   rvó_, _güll, byl_, _ציוו,
   {{0x0697e095,0x7afaaea3,0x4425e0da,0x272e4069}},	//   _אדום_, _matt, cyl_, _sýna_,
   {{0x2d916274,0x63ad1b63,0x3f8a6214,0x3f9200e8}},	//   _ruze_, _twan, _aibu_, _fuyu_,
   {{0x6d897b64,0x6d9361d7,0x7d0d1b3f,0x68ed5575}},	// [18b0] _džan, _għaj, _inas, read,
   {{0x69dc2016,0xf38a0016,0x612b210a,0x69c7217a}},	//   btre, _rải_, _külm, prje,
   {{0x6f1d5b65,0x32049b66,0x7d0d06b5,0x66040098}},	//   _tosc, _army_, _knas, _zrik,
   {{0x629c6659,0x27e9007d,0x612600c4,0x3f921b67}},	//   _efro, _kpan_, _póli, _yuyu_,
   {{0x290ca17b,0x7bcf1b68,0x25560041,0x7afd0109}},	//   _bnda_, nucu, nāla_, idst,
   {{0x1869a251,0x69dd1b69,0xf9940087,0x02c2a12e}},	//   мали_, itse, ארס_, айшо,
   {{0xbe656085,0xd5e2c1e9,0x7bdd0046,0xb0d2a7f4}},	//   _شهري, _ayò, htsu, _सारग,
   {{0x3ea95b6a,0x7aef11e6,0x7afd1b6b,0x25746156}},	//   nbat_, ject, jdst, mäla_,
   {{0x6ea20077,0x6d473732,0x7afbd32c,0xb606805c}},	//   _क्षु, kija, rdut, _pláž,
   {{0x69cf08cd,0x4425fb6c,0x69c0006f,0x273543d1}},	//   duce, tyl_, ámem, _hånd_,
   {{0xbea60ad4,0x6f1e29be,0x66040463,0x7bdc315b}},	//   канк, _ropc, _srik, xtru,
   {{0x26c121e7,0x3f92017b,0x68fb8a98,0x236cfb6d}},	//   _adho_, _puyu_, _jaud, aldj_,
   {{0x291f8022,0x2d9339a1,0x3945fb6e,0xf8bf004a}},	//   _moua_, _auxe_, pils_, ckém_,
   {{0x6d473b6f,0x98a7a03b,0x6f0d1b28,0x629d5b70}},	//   gija, rinė_, _enac, _afso,
   {{0x290c220f,0x442c2049,0x6376a1ae,0x612b3b71}},	//   ıda_, ád_, lânc, _gülm,
   {{0x57d18738,0x442680a2,0x656d5655,0x2d8b4552}},	//   _समूह, yyo_, glah, _cice_,
   {{0xac864099,0x4427a1cd,0x6f1e3b72,0x25a01b73}},	// [18c0] тгал, hyn_, _topc, _util_,
   {{0xb5b700be,0x6ab64121,0x2d932057,0x63bbdb74}},	//   _שליח_, sayf, _fuxe_, isun,
   {{0xf6514043,0x80d72064,0x8fa62aee,0x20563358}},	//   لئے_, _बाते, _шане, _штир,
   {{0x25ad012a,0x2cb83b75,0x1e572076,0x6d897b76}},	//   ţele_, lard_, _ישיר_, _užan,
   {{0xb4c04216,0xb4ce43e6,0xa3ba433e,0x81e8607c}},	//   ीली_, रली_, _تاجر_, বিধ_,
   {{0xb87b007b,0x290d9b77,0x6d42db78,0x2366c262}},	//   nfía, _enea_, _smoa, _skoj_,
   {{0x8c4661fc,0x63bc62e2,0xe45f0728,0x798bd4b6}},	//   _реве, _uvrn, ngör_, _bigw,
   {{0xed57c55a,0x63bbcd3d,0x7bc9c105,0xf486c11f}},	//   кој_, fsun, freu, купн,
   {{0x28d327af,0xc6f7c65d,0x9f4da5e0,0xd186a425}},	//   _तालि, тных_, _creó_, _алай,
   {{0x6563a01f,0xa3cfa046,0xbcfb00fa,0x7bdd0048}},	//   conh, वंश_, hlét, vtsu,
   {{0xdb046359,0x656d5b17,0x69de7890,0x68fb936f}},	//   lsió, ylah, ntpe, _yaud,
   {{0x645ab60a,0x7bc9cb56,0x3f8ca05d,0x2d932005}},	//   _ixti, breu, _hidu_, _ruxe_,
   {{0x7bc9ce6c,0xb5fd8013,0x3eb8209a,0x4fc7014a}},	//   creu, _ryšk, fart_, ъсна,
   {{0x45d4ea09,0x2d8b4026,0x656d4054,0x5693e03b}},	//   _бокс, _sice_, wlah, _кашт,
   {{0x33200676,0xa2d38485,0x7ae298e8,0x27354271}},	//   _foix_, _डाल्, kfot, _låne_,
   {{0x7f5600dd,0x850d4029,0x6f0d1b79,0x69caa049}},	//   _gjyq, हाइट_, _unac, irfe,
   {{0x25a9a4ad,0x2ca95b7a,0x68fb9593,0xd2d2a3fa}},	// [18d0] ćali_, rbad_, _raud, _सांझ,
   {{0x656d5b7b,0x2ca9503c,0x612b2315,0x7e4728f3}},	//   slah, sbad_, _mülk, _ахме,
   {{0x61260459,0x68e280fd,0x69c9c05d,0x67208187}},	//   _vólv, ffod, zree, _bomj,
   {{0xdbd1210a,0x5a35862a,0x60db2098,0x92599254}},	//   _müüg, лнет, đumu, нает_,
   {{0x212121e7,0x6b8bc9ee,0xa3d4e077,0x68fb9b7c}},	//   _kohh_, _rigg, िंड_, _vaud,
   {{0x3eb90046,0xd491a067,0x69c9c854,0x6d48fb7d}},	//   hast_, _vào_, vree, jida,
   {{0x3eb9031b,0xdb062066,0x62868066,0x7e6d0194}},	//   kast_, jský, _úkon, _lyap,
   {{0x23690048,0x672d45ba,0xde8f4079,0x98bca12a}},	//   _nkaj_, nkaj, _aịza_, tivă_,
   {{0x54558eb6,0x4427a8ef,0x25bea105,0xaca321e9}},	//   _сват, syn_, _evtl_, _akọd,
   {{0x236dc75a,0x6376af4c,0xa3d44029,0x98ad8143}},	//   slej_, rânc, संत_, _mleč_,
   {{0x798d013b,0x394a1b7e,0x5cd5c4a1,0xe8df8067}},	//   _biaw, езно_, _مقاط, _ngừa_,
   {{0x8fa605e5,0x3495c1e3,0x28a3e04b,0xe5a60844}},	//   ламе, _садр, _ख्रि, лими,
   {{0x798d0753,0x33200004,0x6135c057,0x5184c0ba}},	//   _diaw, _voix_, _cále, _туфа,
   {{0x2d8c22cf,0x2d91fb7f,0x7e6d00ca,0xdc3a8053}},	//   öde_, ízes_, _dyap, געשר,
   {{0xe8df8125,0x62816261,0xe4f9db80,0x44294025}},	//   _amọn_, _úloh, ्यपि_, eya_,
   {{0x5c16404e,0x44295b81,0xfc3f40b6,0x798d00ae}},	//   льзу, fya_, _reír_, _giaw,
   {{0x6b8deab5,0x386d9b82,0x635c8e9d,0xe57a64fb}},	// [18e0] _éags, _nyer_, nčne, еза_,
   {{0x29dc6359,0xe8d0c295,0xbf9b41ae,0x81eaa07c}},	//   tía_, _सञ्च, _grêm, মিত_,
   {{0x6720994e,0x63706277,0x44294b87,0xaca3c291}},	//   _pomj, länk, aya_, _asọm,
   {{0xdcf4fb83,0x61fce5f0,0x27e654a6,0x386d8271}},	//   _čači, ærli, çons_, _byer_,
   {{0x9cd70095,0x7d1bc055,0xbef3e010,0x657b88a4}},	//   רונה_, djus, _असून_, _dhuh,
   {{0x29004e3b,0x3998a9fe,0x68e45b84,0x81e7207c}},	//   ldia_, _pés_, lfid, পির_,
   {{0x63a9640c,0x69cb854c,0x8b9570c4,0x656f01cd}},	//   _čeng, arge, _вруч, ylch,
   {{0x3998a5df,0x4253650f,0x63a40171,0x70536343}},	//   _vés_, _انفر, _otin, _انفا,
   {{0xdce2c29c,0x50d6a33e,0x442a2066,0x6b828ff8}},	//   _ukoč, _مزار, hyb_, mmog,
   {{0x5983a052,0xe80544ba,0xad9b42a8,0x39495a1e}},	//   _глуб, रिता_, _brúj, zias_,
   {{0xb893bb85,0x6b8d1b86,0x7e56bb87,0x798d1b88}},	//   _المع, _piag, _стац, _piaw,
   {{0x60c2c09f,0x40a8c050,0x2006db89,0xa2d7239f}},	//   _udom, _شخصی_, _troi_, _बाह्,
   {{0xa19501d3,0x3b0041f3,0x6d896490,0x637d0011}},	//   рагч, ddiq_, _džaj, héng,
   {{0xe9df0c24,0x6609445e,0xfd9ec096,0x2579e0fa}},	//   rtú_, _šeko, _gụọ_, tèle_,
   {{0xe3d18295,0x39495b8a,0x7afe2011,0xe9df06db}},	//   _सम्झ, tias_, _dapt, stú_,
   {{0xd6d85043,0xfd9ec088,0x672d40ce,0x63706851}},	//   лту_, _zụọ_, ukaj, bänk,
   {{0x612b2046,0x30a760cf,0x7c2aa0fd,0x3f858425}},	// [18f0] _lüli, грев, hyfr, _èlui_,
   {{0x61ed1b8b,0x68ff003c,0x39998163,0x6feaa03c}},	//   _ipal, _haqd, _rès_, _məcb,
   {{0x386d817b,0xdce9c16d,0x62882066,0xdb1b0005}},	//   _syer_, zmeđ, ždor, esté,
   {{0xdce9c5f2,0x80dc4290,0x68ff013e,0x7aff013e}},	//   tleč, _फाये, _jaqd, _jaqt,
   {{0xa29560ff,0xe8d92067,0x69cb9308,0x66044066}},	//   _вагі, _quỷ_, urge, cvik,
   {{0x2d8efb8c,0xfbc5eba0,0x56946cde,0x9f5ec0b8}},	//   _nife_, _विलम, _гарт, _artà_,
   {{0xf204614a,0x389e8291,0x2a7f002e,0xd8b8aae5}},	//   _лято, _ịre_, ľuby_, ادها_,
   {{0x29042018,0x6e3bd016,0x27274466,0x53349b8d}},	//   ēmai_, tzub, _tõnu_, _лест,
   {{0xa3b0ca82,0xe3b6c1ba,0x60db800f,0x7d126009}},	//   टील_, абы_, _icum, _újsá,
   {{0x66099b8e,0x27ed9b8f,0x6ab61b90,0xdb0203f5}},	//   _irek, _ipen_, _seyf, nslö,
   {{0x9984a13a,0x4384a13a,0x6135caba,0x610ba041}},	//   _اللو, _اللق, _cálc, _vēlē,
   {{0x7afe26c1,0x399aa0be,0x6933c050,0x0086078e}},	//   _sapt, _סינד, _دکتر, илно,
   {{0x3da7c78e,0x2738c18c,0x3eaddb91,0x768bc03c}},	//   _среб, _séng_, mbet_, _döyü,
   {{0x56b5a00b,0x66099b92,0x3eaddb93,0x46a5e39d}},	//   יפֿן_, _mrek, lbet_, _такв,
   {{0x63a5217b,0x60db8071,0x80daa026,0x6722c286}},	//   _cthn, _ocum, प्टे, _yooj,
   {{0x66098628,0x6abbc0cb,0x29117b94,0x66020431}},	//   _orek, nauf, _anza_, _šoku,
   {{0x7ae440dd,0x473600d0,0x3ead007b,0x0b4661d3}},	// [1900] rfit, _مرکز, ñete_, анан,
   {{0x63a9db95,0x3b00403c,0x09e664c2,0xddcd0012}},	//   ipen, sdiq_, иозн, _uzaš,
   {{0x4adde437,0xaca44079,0x7523fb96,0x61fb897e}},	//   _मानव, _agụt, _monz, _asul,
   {{0x84e6884f,0x27e05b97,0x539b21a9,0x69cd5b98}},	//   родж, ptin_, _שיכו, brae,
   {{0x6d5640bb,0x69c1a736,0x63a9c171,0x9ad40125}},	//   mnya, _avle, jpen, _rịlt,
   {{0x6abc2069,0x6b829b99,0x6723fb9a,0xed5a61fc}},	//   narf, smog, _nonj, _рог_,
   {{0x29121b9b,0xb3478227,0x63a9db9c,0x60db8153}},	//   _onya_, _baħħ, epen, _fcum,
   {{0x2d98ab0a,0xa91d8530,0x60db8049,0x6ed2bb9d}},	//   _érem_, _bižu, _gcum, _ठाकु,
   {{0xdb1c4005,0xdb1540e0,0x6abc3b9e,0x8cd7c029}},	//   luró, nszá, karf, _यारो,
   {{0xf1bf203a,0x4734e40e,0x3cff8048,0xdcfc8018}},	//   žšie_, снос, _zauv_, _turē,
   {{0x25746277,0x27354342,0x2d8fc64e,0x394b1b9f}},	//   väll_, _låna_, _fige_, tics_,
   {{0x35471593,0x3cff805f,0x853020e8,0x3f987ba0}},	//   рхов, _xauv_, _ruɗa, _muru_,
   {{0x394b1ba1,0x78bc2999,0x15a7c14a,0x25a6204d}},	//   rics_, farv, _къщи_, _čola_,
   {{0x29021ba2,0xf1bf0049,0xf669c0eb,0x78bc302d}},	//   adka_, rsá_, _صحنه_, garv,
   {{0x394b1ba3,0xa3d445e8,0x937be0be,0x757be1a1}},	//   pics_, सूस_, _שטות, _שטופ,
   {{0x6d56459b,0xef19a0c2,0x6d4b9ba4,0x490688a2}},	//   gnya, _duży_, xiga, _सोलो_,
   {{0x6f029ba5,0xf993c00b,0xe9ffa067,0x2eff8e89}},	// [1910] ddoc, ַרף_, _thầm_, _rauf_,
   {{0x637ec00e,0x66099ba6,0x9f4060d1,0x394cfba7}},	//   lënd, _rrek, ntiè_, nids_,
   {{0xceb22087,0x636b6105,0x04958049,0x938868ba}},	//   _מיי_, wüns, ملاح, рста_,
   {{0x26d90050,0xe807e4e5,0x3f987ba8,0x7bd53ba9}},	//   ngso_, षिता_, _duru_, muzu,
   {{0xfc058312,0x2d987baa,0xf0924095,0x61e288b2}},	//   спло, _eure_, _מנכ_, gtol,
   {{0xa2d38040,0x75356037,0x637ec00e,0x69c0c09a}},	//   _डाक्, _ulzz, hënd, dsme,
   {{0x7c2d4602,0x7bc2c0fa,0xdb090069,0x59c98028}},	//   lyar, _avou, nsdó, _रिवर,
   {{0x91cc6046,0x29013bab,0x78bd006f,0x442ce1cd}},	//   _हितै, _laha_, jasv, dyd_,
   {{0x29000296,0x68f520e0,0x929d8064,0xd706c04e}},	//   _raia_, kezd, _całe, сные_,
   {{0xd7e7a4a4,0xdce3e1d7,0x7bc2c026,0x3eaddbac}},	//   _відо, _minħ, _dvou, sbet_,
   {{0x29000302,0x2d8fdbad,0x3eb94017,0xc6890557}},	//   _paia_, _tige_, _oest_, _נא_,
   {{0x6135c459,0x200b5bae,0x2fc040e2,0xe9ffa016}},	//   _fála, _orci_, ysig_, _chấm_,
   {{0x7523e194,0x2d99400e,0x3085c049,0x637d003e}},	//   _tonz, _nuse_, _الشف, xéne,
   {{0x64a334d2,0x6136e0ba,0x2d917baf,0xa009e4c7}},	//   зара, _vâlc, _nize_, _مقتل_,
   {{0x251ae095,0x6d564058,0x637df4a6,0x27354156}},	//   _תוצא, tnya, rènd, _såna_,
   {{0x7999c0e8,0x3f4f6018,0xdb154009,0x6abc3bb0}},	//   _kuww, kļus_, tszá, sarf,
   {{0x6d565bb1,0x69c1e4a6,0x28d18308,0x2cb87bb2}},	// [1920] rnya, lsle, _हाजि, _perd_,
   {{0x2d9200a2,0x2fc05bb3,0xf7726049,0x2018e584}},	//   _hiye_, rsig_, ساء_, årig_,
   {{0x7bc1eb83,0x2cb87bb4,0xf3ec807c,0x2fc05bb5}},	//   nslu, _verd_, ওয়ার_, ssig_,
   {{0x3eb86283,0xecba81ac,0xfe05526f,0x93aa8049}},	//   _wert_, اطات_, रिशस_, هاتف_,
   {{0x6d5b807d,0x28db0bc5,0x601881eb,0x3eb86136}},	//   _djua, _भासि, роля_, _tert_,
   {{0x6f01a94c,0xe29773f9,0x69c1fbb6,0xdce0c041}},	//   _calc, _гар_, ksle, domā,
   {{0x7bd65bb7,0xdce4416d,0x442dc025,0x2d9a3bb8}},	//   luyu, glić, eye_, _jupe_,
   {{0x69c0dbb9,0x2360c06e,0xae180029,0x69c1e831}},	//   tsme, čijo_, दमान_, dsle,
   {{0x6f04503c,0x3f9a3bba,0x63788089,0x2d916544}},	//   idic, _lupu_, líno, _yize_,
   {{0x7bc280ca,0x602381ba,0xfe6f60e0,0xc8d880c5}},	//   msou, _эдуа, _آگے_, _डाँट,
   {{0x2d98eaaa,0xab96a13a,0x6568f7bf,0x3fcba062}},	//   êre_, _الصغ, rodh, _مدنی_,
   {{0xdced4261,0x69d52631,0x63a4812a,0x394ddb9f}},	//   tlač, vuze, ţinu, cies_,
   {{0x78baa03b,0x13ada07c,0x69c2831d,0x5118e4a0}},	//   _ketv, _গিয়, nsoe, _волю_,
   {{0x68e92098,0x2d9200f9,0xdce90106,0x3f994d94}},	//   đedo, _eiye_, ılıy, _rusu_,
   {{0x61fe2057,0x3f9a2827,0x6eaec0c2,0x6135c29b}},	//   _cspl, _cupu_, ीरपु, _máln,
   {{0x78baa12d,0xdb090069,0x3ebefbbb,0x16054077}},	//   _letv, rsdó, latt_, रिलर_,
   {{0x29025bbc,0x7bd64258,0x7f4d5bbd,0x29074026}},	// [1930] _daka_, guyu, riaq, ěna_,
   {{0x2126c48d,0x6440dbbe,0x200cb890,0x1cf10096}},	//   _looh_, izmi, _ordi_, _ọjọọ_,
   {{0x273b000e,0x2cbd8022,0x6d9361f6,0x7c2f1bbf}},	//   _tënd_, tawd_, _aħar, lycr,
   {{0xcebc203c,0x2d9b000e,0x443fc089,0xa6db00c4}},	//   _şəxs_, _kuqe_, yzu_, miðs,
   {{0x35e780ff,0x637de017,0xab5da2a4,0xb9018148}},	//   сцев, nènc, _avża, _दा_,
   {{0xc7d80095,0x443fc03c,0x69c1fbc0,0x4adde3af}},	//   מודי_, vzu_, ysle, _माधव,
   {{0xa3b3a857,0x7d02d819,0x26c902d1,0xb4db4090}},	//   जीं_, _baos, _odao_, _amài,
   {{0x80dba8ae,0x2007b019,0x612b20e0,0x6f02d03c}},	//   _नावे, rvni_, _küls, _caoc,
   {{0x442dc161,0x7deaa03c,0x69c1edee,0xdce442d1}},	//   uye_, _vəsa, wsle, slić,
   {{0x3bc3e497,0x7bc1e23c,0x637de355,0x6f045731}},	//   tıq_, tslu, dènc, zdic,
   {{0xe784b380,0x3d1d2b42,0xf2d26557,0x2b4dc0c2}},	//   _хуто, माने_, ועי_, piec_,
   {{0xcb6a05a4,0xa96a1255,0x442dc0d1,0x273540ff}},	//   раме_, рима_, pye_, _sånn_,
   {{0x69c52488,0x28db0857,0xbebb4aaa,0x69c3b41b}},	//   _avhe, _भारि, _voël, lsne,
   {{0x69c1e5af,0x656f4030,0x68ed15ca,0x78bb9a78}},	//   psle, _akch, _ebad, _leuv,
   {{0x7af6404e,0x7bc3acdc,0x67264037,0x5f064e64}},	//   teyt, nsnu, _pokj, озва,
   {{0x7ae9dbc1,0x26cc003b,0x2d932815,0xdb1c4069}},	//   nfet, ėdos_, _eixe_, gurð,
   {{0x15ba40fb,0xdb1b01ae,0x03266075,0x25adc07d}},	// [1940] рыбы_, bstâ, одан, npel_,
   {{0x61e44c99,0x7d03f4a8,0x7aed00dd,0x69d65bc2}},	//   rtil, _jans, _zbat, ruye,
   {{0x6f041819,0x6abe60b1,0xbd06c005,0x071e00b9}},	//   _kaic, rapf, ntéñ, _बचाव_,
   {{0xdcb6e8b1,0x63ad40ae,0x6ed7a026,0x7d040534}},	//   _आज्ञ, bpan, _ठाउँ, _jais,
   {{0x3ebfc0ae,0x6aa2977e,0x26c059e1,0xada38089}},	//   daut_, rcof, maio_, _neúč,
   {{0x63a98037,0x2574604e,0x320d9bc3,0xf1a6af0e}},	//   _dten, käli_, _drey_, орин,
   {{0x2d9fc2a8,0x394ea004,0x78baa651,0x3ebfc004}},	//   eque_, rifs_, _vetv, faut_,
   {{0x67029bc4,0x26c04024,0x63a9012a,0x60dbdbc5}},	//   _रोचक_, naio_, ţeni, ggum,
   {{0x6abc60c4,0x3ebee14f,0x5454cde7,0x200d9bc6}},	//   _kerf, tatt_, явит, _grei_,
   {{0x752286a6,0x637d01cb,0xf72ae19c,0x68ed0754}},	//   ljoz, déna, рций_, _sbad,
   {{0xeb9aa90f,0x28abc1b0,0x9f52e814,0x78bc7bc7}},	//   _тие_, _ट्वि, _èyí_, _merv,
   {{0x637de355,0x2730a067,0x799c60b1,0xad9b5bc8}},	//   tènc, _sành_, _murw, _krút,
   {{0x2bd299a7,0x69d8ac04,0x3ebeed2d,0xe133c362}},	//   _सिफा, luve, patt_, _іншы,
   {{0x3ebf46ca,0xdea280a2,0x3cf660c2,0x6d95a1f6}},	//   _žut_, rkoƙ, ीयों_, _iġar,
   {{0x637fa01f,0x69d8b65e,0x9e66e0d0,0xda6fe0ff}},	//   lênc, nuve, _باشن, _ця_,
   {{0x7d03e0d1,0x213a2cd1,0x63706156,0x6e282156}},	//   _zans, _elph_, käns, ädba,
   {{0x27e6800e,0x6edc4021,0x3d176026,0xdb1b0017}},	// [1950] jton_, _फारु, नाले_, mstà,
   {{0x2fd82cf9,0x3d056e4e,0x33291bc9,0x6abc7bca}},	//   burg_, _होखे_, _hoax_, _cerf,
   {{0x6374e5df,0x7bc44046,0x7af77555,0xdb18c22e}},	//   gàni, asiu, rext, msvæ,
   {{0x69d77bcb,0x27e69bcc,0x673aaa53,0x63760803}},	//   ruxe, fton_, _altj, vánk,
   {{0x6abd405d,0x2d895bcd,0xe1ff42a8,0x3d1c0a53}},	//   _iesf, mmae_, _usó_, याते_,
   {{0x442f9bce,0x69c3bbcf,0xa8580076,0x25720009}},	//   ryg_, tsne, חידה_, lált_,
   {{0x439464d7,0xe8d90291,0x6b9d4c57,0x6374e017}},	//   _царс, _ajọ_, _husg, càni,
   {{0x9623c07c,0x6441403c,0xf4126076,0x27e680ae}},	//   _বেগম_, _əlin, _אפל_, bton_,
   {{0xe80e4290,0xaadc2260,0x7c38b94e,0x637fa01f}},	//   सिया_, _बालक, _čarš, gênc,
   {{0xb4bb84ef,0x28abd450,0xfe45e7ca,0x78bd4071}},	//   _आजु_, _ट्रि, зноо, _lesv,
   {{0x1d0a0657,0x2c74a049,0xab5b20e0,0x3f89405d}},	//   бени_, rúdú_, tsün, kmau_,
   {{0x7d03e00d,0xc104c13a,0xf53f6584,0x6feaa03c}},	//   _wans, _يولي, _stål_, _məcl,
   {{0x6d5ae048,0x69d99bd0,0x26c04197,0x637fa1de}},	//   bnta, nuwe, vaio_, cênc,
   {{0x2d9c2009,0x69c57bd1,0x2fd83bd2,0xa3b0c077}},	//   _évek_, kshe, turg_, टीओ_,
   {{0xb4d7e04b,0xdb1b1bd3,0x6138404a,0x61e610bc}},	//   िली_, bstà, _díln, stkl,
   {{0x030b8028,0x2d9ddbd4,0xf1c7408d,0x6e964049}},	//   _सोलह_, _kuwe_, _लिखन, سلطا,
   {{0xda6348f3,0x79957bd5,0x6b957099,0x79840561}},	// [1960] евти, _bizw, _bizg, _ihiw,
   {{0x3d1d2010,0x2d9ddbd6,0x2905bbd7,0x673b8434}},	//   माणे_, _muwe_, _nala_, _aluj,
   {{0x27342cad,0x69c77bd8,0xe29760d7,0x60cbc098}},	//   _länk_, _cvje, чах_, _odgm,
   {{0xdce3a026,0x673b812a,0xaadc2026,0x78bc6171}},	//   plně, _cluj, _बाँक, _werv,
   {{0x2d4d3bd9,0x6b9c7bda,0x6b9d5bdb,0x67228052}},	//   džej_, _wurg, _gusg, rjoj,
   {{0x637fa1ae,0xf4878555,0x26c21bdc,0x60c1e0f7}},	//   vênc, سانی, hako_, jalm,
   {{0x7d7a8050,0xdb074156,0x6d5ae022,0x395f8227}},	//   _همسر_, rsjö, vnta, _fjus_,
   {{0xe80d2567,0xd00f6009,0x69c61bdd,0x27342262}},	//   हिता_, _حلف_, kske, _bänk_,
   {{0x69c60e9d,0x6f064435,0x76444315,0x44446105}},	//   jske, _makc, nziy, lz_,
   {{0xb8d3cc87,0x200d4927,0x637de0d1,0x75298167}},	//   _ज्_, _šeik_, tèna, _zoez,
   {{0x26c2080c,0x28dde969,0xfbd2b34a,0x67298037}},	//   fako_, _मारि, _ستا_, _yoej,
   {{0x6d4e766f,0x26c16610,0xe45760be,0x987b6076}},	//   _lmba, zaho_, לייט_, מריק,
   {{0x2905bbde,0x51873bdf,0x3f9eac0f,0x67245be0}},	//   _yala_, зува, _hutu_, djij,
   {{0x78bd4533,0x6ffbc095,0xf617c076,0x3d0c6466}},	//   _sesv, _להדפ, _מחדש_, _डोले_,
   {{0xde57e0ff,0x961d8018,0x20025be1,0x1897e049}},	//   _наші_, _izņe, _aski_, _عضوة_,
   {{0xaf044a00,0xda5be095,0x6b840425,0x3f9dc0e8}},	//   нчук, _לכול, _ghig, _yuwu_,
   {{0x2d9ebbe2,0x7d065448,0xa3d44026,0x25aca05d}},	// [1970] _lute_, _daks, संग_, _ltdl_,
   {{0x3ebebbe3,0x629aa0ae,0x6abe20cb,0x23d4c984}},	//   _nett_, _ngto, _gepf, _दिनद,
   {{0x6376a01f,0x65154043,0xdce9817a,0xd25100d0}},	//   câni, _ہوگئ, _jieħ, _سنگ_,
   {{0x63ad0037,0x6135c29b,0x7bc57be4,0x7bd99be5}},	//   _ktan, _pálm, rshu, tuwu,
   {{0xa3cf6a30,0x3ebead4b,0x2d9ebbe6,0x2207204a}},	//   _शिव_, _bett_, _aute_, bíhá_,
   {{0x27e95be7,0x69c73be8,0x656f1be9,0xe29ae067}},	//   mtan_, osje, hoch, _ngư_,
   {{0xba776896,0x7d065b14,0xb4d74028,0x60cd1bea}},	//   _راست, _yaks, _साफ़_, _odam,
   {{0x273c429b,0x2b4d8057,0xeab38049,0x20d5c71b}},	//   _kína_, _umec_, _سعر_, фікс,
   {{0x3ebebbeb,0x6f65a050,0x26c3206e,0x3d1c0148}},	//   _fett_, _قهرم, kajo_, यासे_,
   {{0x3ebea277,0x2bd28064,0x69dae372,0x68e2d284}},	//   _gett_, _सिता, fute, _ecod,
   {{0xd6e3207c,0xb4d90f30,0x61e8e0ae,0x6ed72984}},	//   য়ায, ालू_, gtdl, _बाजु,
   {{0x69c61bec,0x656f1bed,0x69d520c2,0x2d9dc0ce}},	//   tske, goch, drze, _tuwe_,
   {{0x2d9ea274,0x60cd1bee,0x29094025,0x69cea6dd}},	//   _zute_, _ddam, ddaa_, _åber,
   {{0x6376a1ae,0x63ad0037,0x9f84e0ff,0x799e21e7}},	//   tâni, _dtan, _згід, _pupw,
   {{0x27e94e3b,0xfd648016,0x10a32619,0xd0072338}},	//   etan_, _chuộ, тисн, мере_,
   {{0xc7d6e095,0x7e76004e,0x25746105,0xbb860049}},	//   _חוקי_, _tyyp, hält_, _تلبي,
   {{0xdb1b0069,0xaa4603fc,0x7d0773bd,0x5ed3207c}},	// [1980] fstæ, _цепл, _bajs, দ্ধে,
   {{0xe9d74503,0x2011650e,0x7afbc04e,0x6aa98031}},	//   ьку_, _brzi_, heut, _afef,
   {{0x61e9c6eb,0x61464103,0xad1b2087,0x831b200b}},	//   htel, _жена, _וויר, _וויז,
   {{0x973cc274,0x3f9ea552,0x70d8804b,0x395d8022}},	//   _kuće, _rutu_, डलेल, gnws_,
   {{0xb0dde08c,0x7d08e277,0x80c3e07c,0x6d4e6058}},	//   _मांग, ydds, _শান্, _tmba,
   {{0x68fc21e1,0x7d077bef,0x60c3bbf0,0x2d85a030}},	//   nerd, _gajs, ganm, _chle_,
   {{0x3157200b,0x2fc7a037,0x69da8028,0x395d8048}},	//   ויסן_, gsng_, _नमकी, bnws_,
   {{0x644040c4,0x85a6c01b,0x6f07615e,0x26c3207f}},	//   _ýmis, мјод, _zajc, zajo_,
   {{0x929d8064,0xd379029c,0x63ade04d,0xe2caa6bd}},	//   _zało, nuće_, _čana, _млад_,
   {{0x2d9ebbf1,0xb383a0ba,0x20048106,0x7afae70b}},	//   _tute_, _алул, _ismi_, uett,
   {{0x61e9dbf2,0xdb0ac277,0xd36fc1fc,0x3f52004d}},	//   atel, dsfö, _ач_, ršun_,
   {{0x6602dbf3,0xd37900e4,0x2cb1e20f,0x27e9419f}},	//   _tsok, kuće_, ızda_, ytan_,
   {{0xdce981d7,0x212b4653,0x60c447ad,0x61314536}},	//   _wieħ, _roch_, daim, _målt,
   {{0x2d986e3b,0x68fc3bf4,0x69c7214e,0xc4c48043}},	//   _nire_, gerd, tsje, _ھے_,
   {{0x5c06e1e1,0x7d08aaca,0xf773419a,0x212ca4b9}},	//   _цяла, _mads, نار_, _modh_,
   {{0x26c33bf5,0x8afea020,0x2c0b404b,0x26c000d4}},	//   sajo_, moƙu, हटलं_, _geio_,
   {{0xf99f528e,0x7bc73bf6,0x2d986704,0x637881ae}},	// [1990] _què_, ssju, _bire_, cíni,
   {{0x9f9ad8cf,0xfd648081,0x7bdd1bf7,0x69dc2310}},	//   mään_, _thuộ, musu, bure,
   {{0x7bdc2132,0x7bc8fa78,0x69dc2c3e,0x3f986265}},	//   curu, nsdu, cure, _diru_,
   {{0x60c3b141,0x273c4193,0x853020a2,0x98bf6181}},	//   wanm, _tína_, _ruɗi, ırın_,
   {{0xdb1b09ac,0x63760359,0xfad64095,0x7afd01fc}},	//   mstä, mánt, _אורך_, iest,
   {{0x321160c2,0x395d8022,0x5de5a297,0xdb1c8262}},	//   _trzy_, snws_, ежка, _avrä,
   {{0xdce44121,0x26c12320,0x7d09c15e,0x2ca0800a}},	//   nliğ, _meho_, tdes, žida_,
   {{0xda08c081,0x60c3bbf8,0x26c4dbf9,0x2d8ce23c}},	//   _bỏ_, sanm, gamo_, emde_,
   {{0x6562c07d,0x6d41f93d,0x6f09dbfa,0x4439dbfb}},	//   _djoh, thla, rdec, ás_,
   {{0x7d098187,0x7c8482f0,0x798d4939,0x25a003c5}},	//   _haes, _русе, hmaw, _ruil_,
   {{0xdbd722df,0x66e60a47,0x2d9940fa,0x6368020f}},	//   _jääv, нона, _oise_, yınd,
   {{0x9f47c06f,0x68e53bfc,0x9f480065,0x25560018}},	//   ktné_, _achd, _opnå_, vāls_,
   {{0xdb0ac277,0xdb1b0277,0x6d553bfd,0xb606c069}},	//   tsfö, dstä, fiza, rráð,
   {{0x25d6c00b,0x9c82e07f,0xdb18c68f,0xfce5e182}},	//   _נוצן_, ščam, rsvå, _чоко,
   {{0x26c120ca,0xdb0ac262,0xd8d6e1a1,0x2cab03f6}},	//   _deho_, rsfö, _טוסט_, éidí_,
   {{0x69dc2ffe,0x14e26010,0x7afc3a83,0xdb0ac156}},	//   rure, _पाहण, sert, ssfö,
   {{0x6d553bfe,0x3171355f,0xe3634977,0x291a2058}},	// [19a0] biza, bozz_, укти, _tnpa_,
   {{0x2d994155,0x63a449a6,0x2d8dc05d,0x2d9e21ae}},	//   _eise_, rqin, hmee_, ítes_,
   {{0xeb9a73ae,0x59d80010,0xaaddf423,0x59d280c5}},	//   чие_, भंकर, _माईक, _सिहर,
   {{0x2bd17bff,0xe9f901e9,0x2731c057,0x0ee2717d}},	//   _हिरा, _afẹ_, _máns_, _पावड,
   {{0x3ce10028,0x6281206f,0x2d52007f,0x26c121e7}},	//   कलते_, ýlov, jšem_, _yeho_,
   {{0x23a6003a,0xae1fe37f,0x59d307fa,0xa5a4a0c2}},	//   _môj_, यमान_, _तिसर, _चंदौ,
   {{0x7a46e004,0x6b63641b,0x39400d67,0x7deaa03c}},	//   _mété, _скра, _olis_, _kəsi,
   {{0x213f8320,0x657bccc5,0x59768013,0xff26814a}},	//   _gluh_, gluh, _чыгу, _ямбо,
   {{0x26c24381,0x6ce6e056,0x60c1ae5d,0xe81340f1}},	//   _meko_, ніне, _felm, ठिया_,
   {{0x26c25c00,0x69dd1c01,0xd90da062,0x61fb01de}},	//   _leko_, vuse, _وین_, çulm,
   {{0x69dd00c1,0x2d8cf2cd,0x26c4dc02,0x2013e005}},	//   wuse, rmde_, pamo_, _áxil_,
   {{0xbcfb4031,0x2a66c286,0x7deaa03c,0xdced42e2}},	//   _ajén, _txob_, _nəsi, mlać,
   {{0x6d44439b,0x60c1a071,0x68e28125,0xb4db40d5}},	//   dhia, _yelm, igod, _llàc,
   {{0xf53f4536,0x69de7c03,0xde8f4125,0x3f99410a}},	//   _slå_, kupe, _dịla_, _sisu_,
   {{0x7bdd0a85,0x799ab4b6,0x798d47d3,0x92682618}},	//   susu, _mitw, tmaw, ерта_,
   {{0x28db0028,0x6b8d42c7,0x613ccde0,0x4a7be076}},	//   _भाटि, umag, _mélo, _מרוב,
   {{0x63760886,0x752e61f6,0x290ce025,0x26c25c04}},	// [19b0] ránt, _bobz, odda_, _deko_,
   {{0xade4fc05,0x65c760e0,0x78a2403a,0x7d098360}},	//   _कमान_, _néhá, ľova, _saes,
   {{0x28e26086,0xb4dd227d,0x2d52006f,0x69caa143}},	//   _पारि, डली_, dšej_, jsfe,
   {{0x3ce6c048,0xacbb4004,0xd324854a,0x60c73c06}},	//   _ncov_, _coût, льчи, lajm,
   {{0x5b1441e1,0x290a6005,0x6d43a049,0x9a844627}},	//   _смят, _faba_, thna, _бурл,
   {{0x5ff56844,0xd184a84f,0xe0df42d9,0x7ae28108}},	//   _изгу, глій, _blòg_, agot,
   {{0x61ed5c07,0x3206c114,0x6132622e,0x69caa59c}},	//   ltal, _asoy_, _vælt, gsfe,
   {{0x9f5d003a,0x69c9d11b,0x290a7c08,0x5f94860f}},	//   _prvý_, tsee, _zaba_, _бист,
   {{0x63b48066,0x60c2c153,0x5f76c13a,0x78a9dc09}},	//   čený, _deom, خميس_, rcev,
   {{0xc6bc207c,0xe7a9ef7e,0x88bd80c2,0x7d0d4052}},	//   _অঞ্চ, мвол_, _pośw, hdas,
   {{0x39400de5,0x3f890090,0x6146016c,0x26c37c0a}},	//   _plis_, _bhau_, вена, _mejo_,
   {{0x26c37c0b,0xaca3c088,0x3f9a205d,0xd14bc049}},	//   _lejo_, _kpọm, _sipu_, _عشان_,
   {{0x60c60106,0x6d565929,0x69dee14f,0xaae2604b}},	//   rakm, viya, _åpen, _पालक,
   {{0x69cb926c,0x60c73c0c,0x27edd393,0x7d0bc069}},	//   isge, gajm, mten_, _hags,
   {{0x7d0bc0ae,0x7f4440fa,0xe5a62517,0x50b60aa4}},	//   _kags, thiq, тиби, _испу,
   {{0x273c405c,0x66f9cafa,0x7529dc0d,0x6e244108}},	//   _víno_, ्यटक_, njez, txib,
   {{0x6d444820,0x7a46e7fc,0x9e6600ff,0x61ed5c0e}},	// [19c0] rhia, _tété, _швид, gtal,
   {{0x69de6530,0x26c7bc0f,0x98a00098,0x7d0d5c10}},	//   tupe, jano_, _boić_, adas,
   {{0x82360896,0x200d4041,0x15fe4e4e,0x673bc2df}},	//   _سرکا, _šeit_, _उनकर_, kkuj,
   {{0x7bde7c11,0xe8d90016,0x63a3fc12,0x69de7c13}},	//   rupu, _thụ_, _munn, rupe,
   {{0x63a3fc14,0x69cb89cd,0x6b898054,0x6729c098}},	//   _lunn, gsge, _dheg, djej,
   {{0x27edc042,0xd12fa13a,0x14dde04b,0x6135c0c4}},	//   dten_, يمن_, _मागण, _málu,
   {{0x5fd4c4ef,0x63a41c15,0x212fc090,0x27e041d1}},	//   _दिहल, _luin, _bogh_, luin_,
   {{0x26c2d239,0xe3afe07c,0x35a74028,0x61385c16}},	//   úko_, _কিংব, _कूड़, _bíli,
   {{0xed5782fe,0x27e041d5,0x6135c0e0,0x25a68187}},	//   _рот_, nuin_, _nálu, qqol_,
   {{0x6b9c6068,0xbcfb40f9,0x87b78076,0x81abe07c}},	//   _jirg, _ajél, _סלבס_, গঠন_,
   {{0x6d58bc17,0x91ae407c,0x61ed4009,0x6aad00f0}},	//   miva, টওয়্, ztal, _pfaf,
   {{0x3f890022,0x2924c066,0x291dc1e7,0x61ed5c18}},	//   _qhau_, ávač_, _gnwa_, ytal,
   {{0x60c41c19,0x1bd4cb24,0x29004395,0x67d4c8ba}},	//   _deim, _соля, deia_, _солу,
   {{0xf99f00d1,0x44383c1a,0x26c486d8,0x799c6931}},	//   twèb_, fyr_, _lemo_, _nirw,
   {{0x60c73c1b,0x291ea058,0x78a2406f,0x4ea7401b}},	//   rajm, _mnta_, ľovn, врза,
   {{0x6d58b34f,0x15e30029,0x05d28029,0x7ae45286}},	//   hiva, कंदर_, _सिंब, ggit,
   {{0x2bda4626,0x395901d5,0x26c7ad72,0xc179003b}},	// [19d0] यंगा, miss_, yano_, stės_,
   {{0x4fc72471,0x44382042,0x7bdae1b9,0x50b72d98}},	//   _исма, byr_, ortu, _अभिष,
   {{0x44268928,0xb05b4105,0x26c37c1c,0x63a40171}},	//   exo_, _geän, _vejo_, _zuin,
   {{0xbd05e1e9,0x69cb8cef,0x6d41a00e,0x6f1d5c1d}},	//   _abẹ́, tsge, _slla, _unsc,
   {{0x7deaa03c,0x61ef1c1e,0xc6a76439,0xd2506043}},	//   _məsu, ntcl, _арби, منے_,
   {{0xf77f26fa,0x39468012,0x799c6194,0xdce0c0a3}},	//   ftçi_, ahos_, _girw, pomě,
   {{0xb0628052,0x6b899c1f,0x7ff5a678,0x6d41a00e}},	//   _ääni, _theg, استا, _vlla,
   {{0x2409d8cf,0x26c7bc20,0x6b9c7c21,0x60c5311b}},	//   ении_, sano_, _zirg, _lehm,
   {{0x89d98ca7,0xf8ae80e0,0x673bdc22,0x64a5f043}},	//   _سوار_, _رکن_, rkuj, лапа,
   {{0x7f42dc23,0x63789c24,0x2b1c60c2,0x66099c25}},	//   _eloq, sínt, नाएँ_, _isek,
   {{0x7ae562a1,0x27e05c26,0x60e8c156,0x28dccc87}},	//   ight, zuin_, ärmö, _याचि,
   {{0x7d0d0054,0x6e2165df,0x60c3e0e8,0xdb154009}},	//   _caas, _àlbu, _wenm, gszü,
   {{0x60c5200a,0x9f47c026,0xde8f4385,0x63a3e194}},	//   _behm, ntní_, _dịka_, _wunn,
   {{0x6b9d4351,0x3eadc0d5,0xe5a300ba,0x3ce9204b}},	//   _aisg, lcet_, сири, _जाणे_,
   {{0x2007e16d,0x7d0d1c27,0x09cc404b,0x39590e76}},	//   _usni_, _faas, ाळ्य, biss_,
   {{0x2d9ce2e2,0x3eaddc28,0x39582162,0x661b5c29}},	//   _zive_, ncet_, sirs_, _šuka,
   {{0x61ee3c2a,0x21201c2b,0xf2da6711,0x6d599c2c}},	// [19e0] stbl, _inih_, فظات_, diwa,
   {{0x7bdbc05d,0x7e7d5c2d,0x61e1e057,0x7d01effe}},	//   iruu, _dysp, oull, nels,
   {{0x637deb3a,0x6b9d4c1e,0x3a252156,0x2120004a}},	//   gèni, _fisg, älpt_, _knih_,
   {{0x2bd4c98a,0x4426827a,0x2d9dc49e,0x106a81fc}},	//   _दिला, txo_, _niwe_, нией_,
   {{0x65628089,0x65644088,0xa2ba2eda,0x539b4076}},	//   rnoh, mnih, ्रप्, _ריכו,
   {{0xfaa37c2e,0x6b9c6153,0x290212b8,0x2d805c2f}},	//   _гаро, _uirg, heka_, llie_,
   {{0x6d42c12a,0xb8cca292,0x29020fae,0x61fb9087}},	//   _ploa, _गल_, keka_, _epul,
   {{0x9f40604e,0x26ca2054,0xaea16315,0x237a2037}},	//   stiä_, habo_, ğışl, _lkpj_,
   {{0x7d0d0e38,0xbc6681e3,0x69c1a1d7,0x6b46a069}},	//   _raas, _свак, _ewle, _aðge,
   {{0x3706eaa4,0x7d0d19ae,0x8ff7c13a,0x6135c02f}},	//   учив, _saas, ارير_, _báls,
   {{0x7d0d0213,0x3f82e2b8,0xa2ba2aa1,0x60c9c194}},	//   _paas, ēku_, ्रन्, baem,
   {{0x64a6d11e,0x63706105,0x98a6c691,0x3f9ce0ce}},	//   _сада, gänz, _сиде, _wivu_,
   {{0xfc43e050,0x3636c50f,0x2b591c30,0xb9540052}},	//   لپیپ, _حراس, risc_, свящ,
   {{0x6d56000d,0x6f0d00ce,0x2d805308,0x63a527a0}},	//   _emya, _waac, elie_, _puhn,
   {{0x69ce22bd,0x657523e4,0x645ca00a,0x533541de}},	//   gsbe, rozh, _žrij, аевт,
   {{0x99d3e0e0,0x6d473c31,0xb33b6733,0x7bc2c0ca}},	//   _اتوا, shja, _puço, _kwou,
   {{0x69dc365a,0x2bc68026,0x9099414a,0xa3e4a2ca}},	// [19f0] arre, रीमा, тват_, भूत_,
   {{0x7e7d4066,0x6d44002e,0xb4db4733,0x63a65c32}},	//   _vysp, _zlia, _glàn, _dukn,
   {{0x05794049,0x26c5a0f2,0xa3e14077,0xdb09e1de}},	//   _لمدة_, _relo_, _धमक_, speç,
   {{0x78a48ebe,0x681ca0ba,0xdef8a2a4,0x491d2026}},	//   živn, _mădă, _abċ_, माको_,
   {{0x3949428f,0x02c5a457,0xf62581d3,0x752d5241}},	//   mhas_, айло, рдло, mjaz,
   {{0x29033a63,0x672d5019,0x69cf0049,0x7bda4076}},	//   neja_, ljaj, isce, _בקשו,
   {{0xddc2a491,0x7d0f5510,0xb0b50029,0x65c2a691}},	//   общи, _kacs, ंडाग, обща,
   {{0x25a5a355,0x8cc881ac,0x6f01e0cb,0x2fcddc33}},	//   _vull_, _موفق_, welc, tseg_,
   {{0x44294174,0x2d53c1fc,0x613f00dd,0x29033c34}},	//   nxa_, nţei_, _vëll, keja_,
   {{0x60cb8426,0xefb28050,0x7bdbc054,0x5a349c35}},	//   lagm, _بیوگ, rruu, _унут,
   {{0x24891c36,0x2d8d8022,0xa3e81c37,0x7bdd0a13}},	//   _azam_, _khee_, मून_, ersu,
   {{0xa3e5c029,0xad9b6057,0x6f03ae96,0x2bddc010}},	//   बंद_, _crúz, lenc, _मिपा,
   {{0x752d40ab,0x7bc2c5cd,0xc60e2046,0x80d0607c}},	//   djaz, _gwou, ाट्य_, স্ট্,
   {{0x6d49dbbf,0xa06a20db,0x2d9e3689,0x290efc38}},	//   lhea, вага_, öte_, _gafa_,
   {{0xdea20050,0xa879e00b,0x4279e00b,0x248909c0}},	//   _ویدی, _באַר, _באַג, _ezam_,
   {{0x6d440167,0x65699c39,0x26cb0c1e,0x26c7e0fd}},	//   _ulia, _njeh, caco_, _heno_,
   {{0x09e64cde,0x6f0f4cc2,0xe4f8c7c8,0x0c264312}},	// [1a00] розн, _dacc, ्जति_, шман,
   {{0xe6c56049,0x613da061,0x200b4090,0xb17b3c3a}},	//   متمي, _dèlk, _dsci_, står,
   {{0xaadb2095,0x32db21a9,0x35dc0028,0x60c77c3b}},	//   _בחיר, _בחינ, _बिड़, _dejm,
   {{0x1bf6e00b,0x09e6404e,0x69c41c3c,0x443a677c}},	//   יצער_, _комн, _kwie, ryp_,
   {{0x3f9eb610,0xfaa66bbb,0x5f06b342,0x212dc579}},	//   _pitu_, _ваго, изда, djeh_,
   {{0x2ae3c026,0x4153a0ff,0xf8c6208d,0x9f53a823}},	//   _गाउँ_, овіс, वरिय, овіч,
   {{0xe607e50f,0xcc24a07c,0x6ce60028,0x2bd28026}},	//   _بش_, বন্ধ_, _कांग_, _सिका,
   {{0x290332ff,0x2d9ebb67,0x29124614,0x320ac0c2}},	//   zeja_, _wite_, ndya_, łbym_,
   {{0xa2e6b254,0xb8fec9b6,0xdcf181d7,0x27f241cd}},	//   _возд, _तय_, _żgħa, ntyn_,
   {{0x752d4306,0x98a3a07a,0x25a6c65f,0x6370604e}},	//   zjaz, _дифе, _vuol_, täny,
   {{0x63b61c3d,0x39404134,0xd6c4c050,0xa3c97c3e}},	//   _atyn, kkis_, _همای, लीप_,
   {{0x60c8a48f,0x7f49dc3f,0x69cf1c40,0x48e920aa}},	//   _hedm, cheq, tsce, _जाहो_,
   {{0x6b829267,0x6f044fc7,0x661aa143,0x6445e046}},	//   ilog, deic, _hrtk, _ühin,
   {{0x63a09c41,0x6722c066,0x79a6e276,0x6aa401b6}},	//   _limn, _hnoj, _крие, _egif,
   {{0x7aefe066,0xf99f4cd9,0x290fcb33,0x201a26ca}},	//   žitý, _piè_, _yaga_, _crpi_,
   {{0xb09be0be,0x7e6d0265,0xa3c96033,0xf8b4a026}},	//   _ביור, _txap, लीफ_, ुरुप,
   {{0xa3c97c42,0x2d81675f,0xeabf0197,0x63a4c197}},	// [1a10] लीन_, tlhe_, mbù_, _èind,
   {{0xec71c49c,0x2904d791,0xf7706449,0x3946c057}},	//   פֿן_, hema_, وال_, _llos_,
   {{0x55594a2b,0x6d40c726,0xc678010c,0x3940405f}},	//   _баня_, kkma, _محیط_, bkis_,
   {{0x2bd2808d,0x63a7635d,0xfcab46ec,0x59d58049}},	//   _सिखा, _vujn, _جادو_, مغتر,
   {{0x60cd5c43,0x395940b6,0xed5880ff,0xf8b4a0c2}},	//   maam, _imss_, шої_, ुरूप,
   {{0x7db7633e,0x3946dc44,0xa3e80a82,0xbcfb0066}},	//   _نصرا, _alos_, मंत_, dném,
   {{0xdd9b81fc,0x7aed00d5,0x98f4a0a4,0x6eba24e5}},	//   _аша_, _ocat, تثنا, ्रतु,
   {{0x657b8174,0x6d5d1bab,0x2904dc45,0x6f0560c7}},	//   _ukuh, jisa, gema_, lehc,
   {{0x26ccf292,0x26c7fc46,0x613cc057,0xe579e62a}},	//   fado_, _peno_, _xéli, лзи_,
   {{0x61e686dd,0xa3c8e0a8,0x9985a049,0x2738c017}},	//   _åkla, _लौह_, _الطو, _béns_,
   {{0x61e56058,0x7c3bd15f,0x660d00da,0xb4db41e9}},	//   nuhl, syur, _asak, _alàm,
   {{0x59c4c026,0x200bc065,0x26c7efb3,0x6feaa03c}},	//   लीहर, æcis_, _weno_, _təcr,
   {{0x3a29c03c,0x4174c13a,0x5f74c13a,0x2374c13a}},	//   _çap_, _بالس, _بالر, _بالح,
   {{0x61e56174,0x59a76021,0x3959404d,0x9f406049}},	//   kuhl, गदार, _amss_, stiú_,
   {{0x63bbd570,0x6ade607c,0xbebb00dd,0xe64320ff}},	//   lpun, ন্ডো, gjës, перп,
   {{0xccc607ca,0xfd120ef8,0x661ce065,0x4205b1c9}},	//   _убий, _رجب_, ærke, _शनैः_,
   {{0x637d0050,0x63680602,0x99d6033e,0x75357c47}},	// [1a20] rént, nınm, _اتبا, _bozz,
   {{0x6f04503c,0x39405c48,0x61e45c49,0xc7b8a320}},	//   seic, skis_, ruil, _hrđe_,
   {{0x61e56058,0x7d04494b,0x6d59cb01,0xe9da6bcb}},	//   guhl, peis, _omwa, уке_,
   {{0x2b2100c2,0xd37980ff,0x0c2682cb,0x2904c057}},	//   याएँ_, ачі_, ймен, xema_,
   {{0x991664a4,0xb347001b,0xa2aa8029,0x61e61c4a}},	//   _льві, luçõ, टशब्, nukl,
   {{0x6d5d11c7,0x7d060134,0x6281a013,0x257204d3}},	//   zisa, heks, _bylo, rály_,
   {{0x236680e4,0x395ca156,0xd7faa425,0xdb078271}},	//   pnoj_, rivs_, уул_, _stjå,
   {{0x26cce096,0x463b649c,0x26ca600a,0x57b4dc4b}},	//   wado_, _געלע, _hebo_, обит,
   {{0x26ca6b39,0x29117412,0x63a1a90b,0xdb01ac1e}},	//   _kebo_, _yaza_, _filn, _milê,
   {{0x6d5d1b67,0xeb9ab7ad,0x67241c22,0x752416fb}},	//   wisa, _сиз_, _anij, _aniz,
   {{0xdd9507b9,0x5286a13a,0x2904c296,0xe97b600b}},	//   жаны, _الاك, pema_, רניש,
   {{0x63a1a1fc,0x2b5a2057,0xb34701ae,0x2fdfc5ce}},	//   _ziln, _ampc_, duçõ, brug_,
   {{0xa3cb2064,0x2d83220d,0x69da206f,0x79844063}},	//   रीन_, tlje_, áten, dliw,
   {{0x3f84c17a,0x7c220055,0xd90f2062,0x273c40c4}},	//   llmu_, _šorc, ریج_, _mínu_,
   {{0x6fb4e343,0x67357c4c,0x644f069f,0x20000030}},	//   _بمبا, _rozj, szci, _epii_,
   {{0x672407a0,0xbfa824dc,0x25a90037,0x322b471b}},	//   _gnij, стре_, _tual_, лізм_,
   {{0x61e60121,0x75357c4d,0x7d05603c,0x6d5e62f4}},	// [1a30] cukl, _pozz, tehs, fipa,
   {{0x973cc143,0x66df40f9,0x21248030,0x200955a6}},	//   _bućk, _bàkà, _anmh_, rwai_,
   {{0xe535404e,0x2b49017b,0x3f1589fd,0x60cd4052}},	//   _день, _klac_, ждес, paam,
   {{0x25aa7c4e,0xa301a843,0x501be076,0x6282c079}},	//   _dubl_, लज्ज_, טובו, _oyoo,
   {{0xbcfb00fa,0x26ca6f8f,0x777ae534,0x6d4d41b9}},	//   ciée, _febo_, kotx, mhaa,
   {{0x6e20427f,0x527a4076,0x2b4910bf,0x973cc133}},	//   _ámba, _כנרא, _llac_, _fućk,
   {{0x29133c4f,0x6282c51f,0x3ebfc0ae,0xa5bb43f6}},	//   _maxa_, _ayoo, tbut_, _bróg,
   {{0x6d48bc50,0x2905fc51,0xc245d3fc,0xf1d4c0c2}},	//   _elda, wela_, жник, _दिखन,
   {{0xdb1c8069,0x7d061729,0x05a6c04e,0x98a9403a}},	//   _evró, veks, овый_, kiaľ_,
   {{0x39490939,0x6d5ec162,0x3d19dc52,0x628bc42e}},	//   _alas_, épar, _मोरे_, _vzgo,
   {{0x63a2c6a5,0x6b8445d4,0x7d0729be,0xdced438a}},	//   _fion, ylig, dejs, hlađ,
   {{0xdced5bd8,0x78a2404d,0x69dce359,0x6d5d0004}},	//   klađ, žovi, área, érap,
   {{0xdb009c53,0x5f74c553,0x1539e0eb,0x6282c614}},	//   _dimè, _عامر, _پزشک_, _gyoo,
   {{0x6d428e3b,0xa3e6e077,0x63abc08b,0xdb01a1ae}},	//   zkoa, यूह_, _iugn, _silê,
   {{0x4176054f,0x6d5f4efb,0x26ca6546,0x3392e050}},	//   _وابس, fiqa, _rebo_, _تلوز,
   {{0xbcfb03ab,0x236d806e,0x973ca143,0x395fdc54}},	//   jnéh, _njej_, _mića, nius_,
   {{0xfd1f4067,0x27e053b1,0x3ce600c5,0x6283e0fd}},	// [1a40] _nhìu_, urin_, कलीं_, _hyno,
   {{0x6283fc55,0xf1e08914,0x23e087c8,0xdee3652f}},	//   _kyno, _निबन, _निबद, дофи,
   {{0x316d8098,0x48eb612f,0x9a6a613a,0xdce455aa}},	//   _bjez_, _चारो_, جمال_, lnič,
   {{0x98a681bc,0x06868bd6,0x6b844025,0xa5bb510c}},	//   циде, оген, qlig, _bród,
   {{0x6d428534,0xe5a38494,0x6569c02e,0x34a7414f}},	//   rkoa, фици, dneh, _євро_,
   {{0xadc322f4,0x6d445c56,0x6d5b8194,0x27e6808b}},	//   _afẹd, lkia, _emua, ruon_,
   {{0xb53a00f9,0x7f498fb3,0x6569c0cb,0x5693bc57}},	//   _akọ́, _fleq, fneh, машт,
   {{0xceb44497,0x236d80dd,0x387f017a,0x63a3e420}},	//   ncə_, _gjej_, żuri_, _ainn,
   {{0xfd4f4016,0xa3e5c077,0x22404396,0x61e1e057}},	//   _phiế, बूल_, nyik_, erll,
   {{0x6d5abc58,0xb603c02e,0x88bca04a,0x60c29c59}},	//   _umta, úšaj, _zněn, lbom,
   {{0x7d073c5a,0x777bc005,0x2731c009,0xceb4403c}},	//   vejs, boux, _lány_, kcə_,
   {{0x2d92005d,0x8fa6c34d,0x2d85e052,0xe9b7a043}},	//   _chye_, _даде, alle_, _بچوں_,
   {{0x657aef42,0xdb9b8087,0x26cb5c5b,0x4f65e0e0}},	//   poth, יסטר, _reco_, _کانف,
   {{0x63aae143,0x61e29063,0x657ae0bb,0x26cca4f8}},	//   _tufn, irol, qoth, _jedo_,
   {{0x63760009,0x6283e0fd,0x28c80077,0x78b02089}},	//   hány, _gyno, लरशि, _živý,
   {{0xd37900e4,0x63a41518,0x6602c088,0x6d5c7c5c}},	//   kući_, _giin, _kpok, _amra,
   {{0x7640cccc,0x25a362be,0x32555043,0x61e8fc5d}},	// [1a50] nymy, _pijl_, чвар, ludl,
   {{0x6d5b903c,0x7f4d5bd7,0xbef8cba0,0x63a40800}},	//   _smua, shaq, ्जुन_, _ziin,
   {{0xab98213a,0x26d120ca,0x20024012,0x61e8e426}},	//   _بخير_, mazo_, _epki_, nudl,
   {{0x661d429c,0x2907b1b6,0x6602dc5e,0xdb0b0156}},	//   _trsk, wena_, _opok, _utfä,
   {{0xe8d90088,0x6fc684ba,0x6569c06f,0x2bc68026}},	//   _amị_, रीलं, vneh, रीला,
   {{0x2126c08b,0x657d1c5f,0x63ad1c60,0x660d4284}},	//   _anoh_, hosh, _muan, mwak,
   {{0xeaf8a13a,0xe57388b8,0x61e8e1f3,0x201ea320}},	//   ترنت_, _قطر_, judl, _crti_,
   {{0x657d1c61,0xb4db458f,0x63a3fc62,0x2bff410a}},	//   josh, _blài, _sinn, _उहां_,
   {{0x442dc1ae,0x26d13c63,0x69dce195,0x613dabf2}},	//   uxe_, kazo_, áren, _bèlt,
   {{0x6d444265,0x657bc04a,0x26cca025,0x394dc393}},	//   zkia, souh, _gedo_, shes_,
   {{0x26d125e0,0x443fdc64,0x6284005d,0x63a40134}},	//   dazo_, syu_, _syio, _piin,
   {{0x657d1c65,0x63a3fa4c,0xa96a1255,0x6d4afc66}},	//   gosh, _winn, сима_, _elfa,
   {{0x63a53c67,0xdb01ae2d,0x81ada07c,0x4acb635b}},	//   _bihn, _ailé, _কবি_, िराव,
   {{0x63a3f03c,0x26d12019,0xdb1c40fa,0x7bc980ce}},	//   _uinn, gazo_, mpré, _mweu,
   {{0x69d520e0,0x21395c68,0x63ad0090,0x63a4111b}},	//   gsze, _bosh_, _euan, _tiin,
   {{0x20024058,0xf412a00b,0x63bb95ca,0xb33b61de}},	//   _ppki_, עפן_, _otun, _muçu,
   {{0xa3d60ba3,0x945f80e8,0x248ee143,0x69c98088}},	// [1a60] _हिट_, _fāɗ, _zzfm_, _nwee,
   {{0x6d46004e,0x629a6066,0x6d5d5c69,0x26d12889}},	//   lkka, _útok, _emsa, cazo_,
   {{0x913b2076,0x69c98035,0x26140485,0xdb01a011}},	//   _העיק, _awee, दिकी_, _gilé,
   {{0x63ad0020,0x44201c6a,0x68fbc098,0x2be08180}},	//   _yuan, _kri_, jfud, _निदा,
   {{0x25bf61e4,0xb4db4031,0x7d161c6b,0x26086148}},	//   _čule_, _alàw, _mays, _सनकी_,
   {{0xd37902e2,0x7d160054,0x69c981e2,0x657d0c55}},	//   rući_, _lays, _dwee, zosh,
   {{0x9f98c955,0x06e3c07c,0xdb0f6009,0x69c98035}},	//   овку_, _মসজি, _utcá, _ewee,
   {{0x7d08e54c,0x998920ba,0xf1be05c5,0x23dc1b2c}},	//   weds, _oraş_, ्ठान, _बिंद,
   {{0x69d65c6c,0xebe38244,0x69d52367,0x63ae7c6d}},	//   nsye, _потп, zsze, _hubn,
   {{0x68ed45e0,0xd7ddc010,0x65629c6e,0x753a2105}},	//   zgad, _मिरच, lioh, ötzl,
   {{0x7d09dc6f,0x6728a17a,0x201eb278,0x3a200011}},	//   bees, _indj, _urti_, _arip_,
   {{0x753aa108,0x98a7e04a,0xe0df4030,0x9c870089}},	//   _hotz, _koně_, _elòj_, _ničí,
   {{0x69d52064,0xdcf8a098,0x6b82c7a0,0x753aaa13}},	//   wsze, hovč, _ikog, _kotz,
   {{0x657d0617,0x8fa3e841,0x25a520c4,0x63a22425}},	//   sosh, _заче, öll_, _èonl,
   {{0x6fd90010,0xb604212e,0x753aaa03,0x317ee108}},	//   _भटकं, нятк, _motz, motz_,
   {{0x7d160054,0x657d074d,0x753aa108,0x53345c70}},	//   _gays, qosh, _lotz, нест,
   {{0xdb040005,0x290a31a1,0xc434e043,0x21290071}},	// [1a70] _etnó, beba_, _رکھت, _inah_,
   {{0x69d522b1,0x7afd1c71,0xfbd20095,0x9d146825}},	//   psze, lfst, _שתי_, ндуч,
   {{0x21394c8a,0x661bc530,0x69c98957,0x7d09cbbe}},	//   _tosh_, zvuk, _swee, yees,
   {{0x290b08d4,0x2bddc07d,0xdb0be1ab,0xf41f4156}},	//   neca_, _मिला, _eugè, _trä_,
   {{0x68434031,0x7ae48dc1,0x63bc6030,0x6dac60ba}},	//   _dídú, óita, _etrn, _aşad,
   {{0x290b1c72,0x2be24861,0xd040c03c,0xa49b40d1}},	//   heca_, _पिता, qamə, _ebòc,
   {{0xe8d901e9,0x2486c187,0xe51ecc13,0xf8ae80e0}},	//   _amọ_, _ayom_, _मोहि_, اکہ_,
   {{0x6e24d192,0xf0942087,0x290b05a0,0x2f54c8e7}},	//   _šiba, ענק_, jeca_, етьс,
   {{0x6561fc73,0x63ae61d8,0x395f98b3,0x6f09dbd7}},	//   tilh, _zubn, _imus_, reec,
   {{0xb4e601b0,0x7d161c74,0x673aa361,0x63af429c}},	//   कल्प_, _says, _gotj, _mucn,
   {{0x7d160004,0x6d4bc08b,0x753b9c75,0x69d76057}},	//   _pays, _tlga, _kouz, nsxe,
   {{0xa5b20064,0x34c622b4,0x63a76200,0xe9ff4067}},	//   _इंदौ, वर्द, _lijn, _nhắc_,
   {{0x7d172caf,0x5155e242,0x6b89c31b,0xd7f8e12a}},	//   _baxs, _отку, mleg, ată_,
   {{0x2480a106,0x2f18e052,0x26cfc108,0xd379029c}},	//   şime_, _ночь_, _hego_, duću_,
   {{0x35a321d3,0x6b503006,0xe1f9c013,0x316dc0ba}},	//   тарг, _näge, ltų_, onez_,
   {{0x378701e1,0x61e45c76,0xdb0782a8,0x290a3c77}},	//   _общо_, tril, _bují, seba_,
   {{0xd37900a9,0xed5a27f8,0x24f669fd,0x61e45c78}},	// [1a80] guću_, _мои_, дчер, uril,
   {{0xa3cb22b4,0x49ba2553,0x644280ce,0x6443b259}},	//   रीह_, _واجد_, vyoi, kyni,
   {{0xdfcf613a,0x673b8163,0x25ea4021,0x973ca143}},	//   ليل_, _bouj, _चमकी_, _sićo,
   {{0x236ddaee,0xdb02c057,0xb95b60f9,0x0b468376}},	//   jnej_, _tioé, _atìd, ьнен,
   {{0x6563a41a,0xdca380cf,0xf2d34053,0xb4db4017}},	//   finh, ваци, _בער_, _clàu,
   {{0x290b0055,0x25a6dc79,0x5694a425,0xe4570053}},	//   zeca_, _siol_, налт, וינט_,
   {{0x63af420d,0x7bcbc2a4,0xfbb041a6,0x6b640009}},	//   _zucn, _awgu, _ছবিত, zőga,
   {{0x61eab9d3,0x6b9bc0ae,0xb814c39d,0x61f8ab83}},	//   rufl, gmug, едиј, rtvl,
   {{0xe4e6e14f,0x3cfbbc7a,0x201e664e,0xd007c01b}},	//   мінн, ल्हे_, _štih_, дење_,
   {{0x753b8653,0x26cfc025,0x799ae022,0x93bca0ba}},	//   _zouz, _eego_, umtw, _crăc,
   {{0x25a6c057,0xc057e0ff,0x753c669f,0x61e61c7b}},	//   _tiol_, дія_, _morz, erkl,
   {{0x3a29c16d,0xa01b4052,0xb7d4c1e9,0xdcfaa2a4}},	//   _šape_, _syöm, _aṣeb, _bitħ,
   {{0x25afc6be,0x24920064,0x442240ff,0x753c6200}},	//   _gugl_, _czym_, _nrk_, _oorz,
   {{0x70ab8148,0x7984000d,0x9f4340a3,0xb4db4733}},	//   _छल्ल, _ekiw, rují_, _llàt,
   {{0x63a76171,0xf1a7487e,0x672ae2a4,0x6b51563b}},	//   _rijn, дран, _infj, _låge,
   {{0x7d18f971,0x291860f9,0x14bf21c9,0x6e22c187}},	//   _havs, _aara_, ्रहण, _krob,
   {{0x1eab2049,0xa01b4052,0xddc9c0c2,0x78ad0046}},	// [1a90] _وادي_, _työm, czeń, _igav,
   {{0xddc28064,0x67299c7c,0xadf2e69e,0x661d8069}},	//   szoś, _snej, _अमान_, _áski,
   {{0x69d8a200,0x58d54f2f,0x63a7600e,0x27e0813a}},	//   jsve, _понт, _vijn, áinn_,
   {{0xa83541e3,0x69d8a9ee,0x6e22c852,0x7bcd104a}},	//   _земљ, dsve, _orob, _kwau,
   {{0x9f5a40c4,0x6f0d50a1,0x9105b9c1,0x6443a1cd}},	//   _uppá_, meac, епле, wyni,
   {{0x673c7c7d,0x39495540,0x7643a04e,0xfbd026b0}},	//   _gorj, lkas_, tyny, _حتی_,
   {{0xd88364b7,0x290ce03b,0x57b4687c,0x3206c4ec}},	//   _شهری, deda_, _абст, _apoy_,
   {{0x6e946702,0x6443bc7e,0x3cff20c2,0x3f816066}},	//   _рису, ryni, श्ते_, lohu_,
   {{0x7d01bc7f,0x2d9d8b01,0x7989dc80,0x6006c3fc}},	//   _tbls, mmwe_, rlew, еным_,
   {{0x63a9804e,0x6aad1c81,0x2bdaf204,0x26cfc17b}},	//   _hien, _agaf, _भिखा, _wego_,
   {{0xbcfb00e6,0x39494046,0x25a91c82,0x1da8a028}},	//   rién, kkas_, _bial_, _छूटत,
   {{0x6f02c291,0x62898037,0x7c3ce156,0x48dbe026}},	//   _gboc, _kyeo, ärra, _गएको_,
   {{0xfce5e6fc,0x7d18faba,0x7bc1fc83,0x7d0d4ce5}},	//   _золо, _favs, splu, deas,
   {{0x79460064,0x21f8e18c,0x7d19c054,0x3eac2271}},	//   _mówi, béh_, _haws, ødt_,
   {{0xb8d8210a,0x279641e1,0xeb9a40c0,0xab2a5138}},	//   _छल_, ешар, зив_, пова_,
   {{0xe7374276,0x6fe12046,0x6f1bc8cd,0x41e12857}},	//   нес_, _फिरं, nduc, _फिरस,
   {{0x7d040132,0x6b502277,0x29195c84,0x2d821c85}},	// [1aa0] _ibis, _vägb, _dasa_, moke_,
   {{0x7c240082,0xa01b404e,0x06e3607c,0xb95b61e9}},	//   _irir, _myöh, ন্সি, _atìb,
   {{0x130a87b9,0xd910a050,0x9743429f,0x76444058}},	//   зней_, ییر_, šćav, syiy,
   {{0xdb1b1c86,0xfd4d8125,0x6f0d44b9,0x61fbdb14}},	//   sstö, _ighọ, ceac, ktul,
   {{0xd04085fc,0x6288a2a6,0xb4db4733,0x44225c87}},	//   _yemə, _sydo, _elàs, _urk_,
   {{0x99440602,0x6e24c098,0x44204167,0x27e08edc}},	//   yış_, _šibo, mvi_, šino_,
   {{0x7bc29c88,0x6ed6fc89,0x27e68058,0x3facc07c}},	//   spou, _मजबु, sron_, _গবেষ,
   {{0x2900566b,0x7bd8bc8a,0x8fa39c8b,0x9f4de052}},	//   nfia_, rsvu, _басе, hteä_,
   {{0xb603a041,0x88818050,0x213dc05d,0x69d8b492}},	//   āšan, _پیون, _dowh_, ssve,
   {{0x25a90a81,0x61ee25d9,0x7980c72c,0x26dea0ae}},	//   _sial_, kubl, somw, _udto_,
   {{0x61fbd617,0xdb1c8019,0x39576076,0x3157600b}},	//   atul, _atré, גשים_, גיין_,
   {{0x6d49dc8c,0x29028277,0x21f9c050,0x7d02c99d}},	//   ckea, _ökad_, bèh_, _ubos,
   {{0x61fbc12a,0x6e240cc2,0xf20403fc,0x60d52098}},	//   ctul, _crib, ляро, tazm,
   {{0xf99f6061,0x6b81e197,0x291cbc8d,0x7966e011}},	//   _apèn_, colg, ndva_, _déwè,
   {{0xf7734085,0x442046e8,0x26d16163,0x2d9ee105}},	//   هار_, evi_, _rezo_, mmte_,
   {{0x69da2004,0x26d16098,0x3949403b,0x69c08055}},	//   âtea, _sezo_, ukas_, _otme,
   {{0x7bdc6121,0x23cf827d,0x4423604d,0xb4bf01b0}},	// [1ab0] _avru, _सौंद, _srj_, ेरी_,
   {{0x2aee2064,0xa8a4453f,0xb4db5c8e,0x7985313a}},	//   _जाएँ_, урск, _plàs, _ukhw,
   {{0x2fd9213a,0x16bf2d98,0x69c09b43,0xceb4403c}},	//   _توجد_, ्रीब, _atme, mdən_,
   {{0x6b829994,0xf42a002e,0x6f1d02b7,0x9f4060c4}},	//   goog, späť_, ndsc, stið_,
   {{0x291a3344,0x237484aa,0x62868042,0x08f8201c}},	//   _yapa_, دالح, _økol, _غریب_,
   {{0xa3cc6033,0xdb040105,0x69d98d53,0x63a99c8f}},	//   _शौक_, _zunä, rswe, _wien,
   {{0xf770a28b,0x7bdafc90,0x3a24805d,0x6b829c91}},	//   حان_, jstu, _ermp_, boog,
   {{0x6f0f05df,0x3eb983ed,0x2d832003,0x236681d3}},	//   jecc, _üst_, hoje_, cioj_,
   {{0x7d1bc290,0x3f833c92,0x5724c049,0xc115a176}},	//   rdus, koju_, طريق, _имај,
   {{0x6b8d4669,0x7cd9a01c,0x672d1c93,0xd6848656}},	//   hlag, _آواز_, _anaj, _сусп,
   {{0x2d821b67,0x6b8d4831,0x2d833c94,0x798d5963}},	//   toke_, klag, doje_, klaw,
   {{0x8afce064,0x7d0e3c95,0x628ae1cd,0x6b81effe}},	//   wnęt, webs, _dyfo, solg,
   {{0x6566041e,0xee3701ef,0x3b1b013e,0xc4bf20c2}},	//   rikh, вня_, _daqq_, ्रूख,
   {{0x6566185f,0xd138e064,0x4425bc96,0x9f4de277}},	//   sikh, cją_, _krl_, fteå_,
   {{0x764de0a2,0x9479313c,0x64461c97,0x2d788133}},	//   _ƙayu, есту_, syki, nčec_,
   {{0x6e241c98,0x7d1b9c99,0xdb0e8019,0x6f0f0197}},	//   _trib, _naus, _tubé, cecc,
   {{0x629ca032,0x7bdbd11b,0xe5a34b2d,0xef1a604e}},	// [1ac0] _úrov, nsuu, рити, мма_,
   {{0xe29741fc,0xf2134405,0xf8e1e064,0x08c364d4}},	//   тау_, সমূহ_, पणिय, ибун,
   {{0xd5b9614f,0x66099655,0x9fa30057,0x7c22004d}},	//   есі_, _apek, cíón_, _šorh,
   {{0x6f1b9c9a,0x66e68b2d,0x6b8d5c9b,0x80cc8029}},	//   _cauc, тода, clag, ारें,
   {{0x6fb38230,0x7983a1cd,0x79828025,0x628ec0c2}},	//   لمنا, fonw, roow, ębok,
   {{0x69d86032,0xe8d90125,0x69c56048,0x6f0f0024}},	//   áves, _ikụ_, bphe, zecc,
   {{0x2dd7a13a,0x290f936e,0x399900e0,0x69c5703c}},	//   نبية_, bega_, lése_, cphe,
   {{0x39401bd3,0xdce6003b,0x1514c12a,0x26d82a03}},	//   _nois_, mokė, удия, haro_,
   {{0x3d178010,0x5d678b24,0xdb0f6005,0x26d83c9c}},	//   _नसते_, _ритм_, _sucé, karo_,
   {{0x6f1c620d,0xaca40079,0x2bb54028,0x6d409c9d}},	//   _jarc, _chọw, _अंसा, _homa,
   {{0x28f908e9,0x2bd00010,0x26d32057,0x7d1b835f}},	//   нень_, तीसा, _rexo_, _yaus,
   {{0x61fd0551,0x27e99c9e,0xfd1f40f9,0x7bdb6095}},	//   ttsl, šane_, _akìn_, וקטו,
   {{0xdb03e1ae,0x6d565c9f,0x26d83ca0,0x2d84c320}},	//   _dinâ, dhya, faro_, mome_,
   {{0x7bc2cf1f,0x929d80c2,0xa2c501a6,0x3f84dca1}},	//   _itou, _cały, ্লেখ, lomu_,
   {{0x61ef0098,0x1df8220e,0x1b0801a6,0x61fd0584}},	//   sucl, керы_, ষয়ে_, stsl,
   {{0x2bdc1ca2,0x3a26c065,0xdb01a530,0xdef8e17a}},	//   _बिचा, _krop_, _milá, diċi_,
   {{0x2d833ca3,0xa91dc3a1,0x27e95ca4,0x7d1b9a3c}},	// [1ad0] poje_, noža, uran_, _raus,
   {{0x2d876162,0x6568fca5,0x2d83e38a,0x63ad1ca6}},	//   ône_, nidh, čjeg_, _hian,
   {{0x99520066,0x6f029ca7,0x6f1c7ca8,0x60d76caf}},	//   láš_, ffoc, _darc, raxm,
   {{0x7c2a2069,0x27e95ca9,0xfd1f0031,0x7ae2ca05}},	//   _áfra, pran_, ndì_, _ndot,
   {{0x2d84caf1,0x6b83bc12,0x69da212d,0x0f36400b}},	//   dome_, tong, štet, _ערשט_,
   {{0x6568e0dd,0x69dd1caa,0x2b8e805c,0x75d28049}},	//   jidh, isse, hých_, حيوا,
   {{0x45d4604e,0x6f1b8105,0x2d8780fa,0xb5a781d3}},	//   _восс, _tauc, înes_, _арай,
   {{0x2ee9a03c,0x93bca067,0x99520066,0x69dbc265}},	//   şaf_, _trăn, káš_, tsue,
   {{0xfc31c13a,0x79898079,0x38608049,0x7d1b4057}},	//   صحة_, _ikew, úirt_, _óusu,
   {{0x29112320,0x4426dcab,0x8ccaba13,0x25ad8363}},	//   jeza_, _dro_, _स्पो, _hiel_,
   {{0x25ad9ac9,0x628bc064,0x6d41a0ef,0x399900e0}},	//   _kiel_, _wygo, _iola, zése_,
   {{0xa5bb5cac,0xf0926095,0xaca3e291,0xdb08c009}},	//   _pról, מני_, _ntụk, _tudá,
   {{0x2bddc033,0x6d4d4054,0x6569c04e,0x79898167}},	//   _मिटा, dkaa, mieh, _mkew,
   {{0xf8c6a738,0x645bc0ce,0x291cf4b7,0x394ce425}},	//   रुपय, mzui, _gava_, ckds_,
   {{0x1fb536a6,0x6d935cad,0x63b5609f,0x69dd0ffe}},	//   истр, rçan, _nuzn, asse,
   {{0x6f1c7cae,0x2508054f,0x26d83997,0x69dc3c7b}},	//   _sarc, _شرعی_, saro_, rsre,
   {{0xe1ff0333,0xdd92625b,0x6e93413a,0x7649dcaf}},	// [1ae0] ctó_, مور_, ملفا, nyey,
   {{0x79899280,0x799b81df,0xb8eb5065,0x79861cb0}},	//   _akew, _ahuw, _र्_, lokw,
   {{0x3cfb2095,0x6f1c777e,0x8afb20be,0x63b60067}},	//   _אלינ, _varc, _אפיק, _huyn,
   {{0x291ddcb1,0xed579cb2,0x61fca156,0xdb09e1ae}},	//   _nawa_, лох_, _ärli, mpeõ,
   {{0xa96aa04d,0x23cf8029,0x7f46b9b6,0xd6d9c064}},	//   нида_, सीलद, ледж, dał_,
   {{0x7d1d5cb3,0x79860bef,0x7f41a090,0x2d8780fa}},	//   _zass, hokw, _colq, îner_,
   {{0x68e414fd,0x7c229cb4,0x26d91cb5,0x7f40805f}},	//   _odid, svor, yaso_, _tomq,
   {{0x3a26dcb6,0x291cfcb7,0xbea684e4,0x645bc171}},	//   _prop_, _sava_, _бабк, fzui,
   {{0xed5786bb,0x06f6aca7,0x63bb6098,0x6448fb61}},	//   _сот_, _مساج, _čuni, wydi,
   {{0xdd04c106,0x845aa1c0,0x6448f5a5,0xa01b4052}},	//   ırıy, _прет_, tydi, _työv,
   {{0x33750d49,0x69c41cb8,0x4c94f0da,0x49750792}},	//   игор, _atie, ринс, илос,
   {{0xa3c96029,0x7649c00f,0x6569c06f,0x6568fcb9}},	//   लीट_, byey, cieh, sidh,
   {{0x2d85fcba,0x63ad1cbb,0xef1f06df,0x5ce720ff}},	//   bole_, _vian, rdü_, люва,
   {{0x7c244b48,0xe693c13a,0x63a29cbc,0x7c2f8057}},	//   dvir, _الهد, hmon, _ácre,
   {{0x6f044239,0x4427e08b,0x63a28011,0x6db2c0c2}},	//   ffic, _grn_, kmon, _wład,
   {{0x63ae61f3,0xa3b9fb5a,0x69c8e017,0x9d184844}},	//   _aibn, _अंत_, mpde, лост_,
   {{0x7d1d53e9,0x69de6684,0x5ed4207c,0xd7e08292}},	// [1af0] _vass, espe, _তারে, _निगच,
   {{0x2b99e0fa,0x69c73241,0x3a290197,0x799b81df}},	//   pèce_, ppje, _irap_, _shuw,
   {{0x44290326,0x6aa6407c,0x39425c4e,0x48156143}},	//   _hra_, গুলো, _foks_, рмес,
   {{0x7bc520bb,0x27ec2066,0xe0e701a6,0xdce440c2}},	//   _ithu, ádne_, গ্রহ_, knię,
   {{0x9fdfc07c,0x60cd4df7,0x2000412a,0xa3cf84da}},	//   _বঙ্গ, mbam, ctii_, वीं_,
   {{0xed516043,0x25ad8110,0x1869a7f7,0x60cd5cbd}},	//   _بھر_, _wiel_, кали_, lbam,
   {{0x200ca005,0x7f42c054,0x79860287,0x8835a1d3}},	//   _cpdi_, _booq, yokw, рэлц,
   {{0x3fe5d2ad,0x7d1f0b20,0xa3ea60aa,0x25aee153}},	//   ажив, _naqs, _मित_, _aifl_,
   {{0xdb162067,0x44291cbe,0x6702637f,0x947786ec}},	//   _duyê, _nra_, र्वक_, _صدرا,
   {{0x20d3c067,0x661b9cbf,0x60d72037,0x613cc0e0}},	//   ải_, _isuk, _nexm, _mély,
   {{0x291dc1fa,0xed5a053f,0x764b80fd,0x394dc037}},	//   _tawa_, вон_, lygy, pkes_,
   {{0xa96a1cc0,0x399ac00e,0x6d5a8013,0x6d598037}},	//   тима_, tëse_, _įtak, nhwa,
   {{0xbb84c13a,0x06f76573,0x60dbc0ce,0xa01b4052}},	//   _الني, ुभाव_, maum, _myös,
   {{0x39424012,0xb3d7807c,0x442c59e4,0x18a5f196}},	//   _soks_, _সমাজ, _čd_, _калм,
   {{0x6d9d013a,0x3a2907f2,0xdb1c80c4,0x63ae6364}},	//   féad, _erap_, _strí, _ribn,
   {{0x60dbc296,0x6d557cc1,0xdb162016,0x26da6296}},	//   naum, _alza, _xuyê, wapo_,
   {{0x3a291cc2,0x2baf88ae,0x1f6664a0,0x4aaa5cc3}},	// [1b00] _grap_, _जंजा, акам, ткан_,
   {{0x6d44010a,0xd00f063b,0x9e66254a,0x0e66204f}},	//   _hoia, _کلی_, _ввод, _вкон,
   {{0x3942403b,0xa01b404e,0xa2d9a033,0x8afce064}},	//   _toks_, _syöt, _नज़्, więk,
   {{0x1426852f,0x6d4410cd,0x7c298197,0x65664174}},	//   идем, _joia, _brer, _umkh,
   {{0xa91dcebe,0x27eddcc4,0x6d58bcc5,0x6d440733}},	//   tožn, jren_, thva, _moia,
   {{0xe5e58049,0x92ce41a6,0x63a4551d,0x07e6a825}},	//   إثني, _রায়_, lmin, ацим,
   {{0xa91ddcc6,0x12e9200b,0xdbcfc089,0x656b9cc7}},	//   rožn, אַפּ, _džín, bigh,
   {{0x6e2dc2d1,0xab748050,0x24536049,0xdb0780c4}},	//   _šaba, _انرژ, _بنفس, _stjö,
   {{0x6e298a03,0xdb03e005,0x6db2c0c2,0x0e668d15}},	//   _greb, _siná, _słab, _ткан,
   {{0x9abca227,0xda26e14f,0x442a6089,0x2d87bcc8}},	//   _baċe, аємо, _krb_, cone_,
   {{0xb87b41e9,0x6d43ee96,0x660e605d,0x6b502156}},	//   _adíl, _dona, _jpbk, _vägl,
   {{0x26d87973,0x7a0aa03c,0xb4d548c6,0x8c48420f}},	//   _lero_, _tətb, _सजे_, _kağı,
   {{0x75c1e018,0x7f43e1f6,0x7bcaa076,0xdcfbc6fa}},	//   _rēze, _fonq, lpfu, lluğ,
   {{0x26d87cc9,0x6d561703,0x442a6282,0x27e05cca}},	//   _nero_, _elya, _orb_, dsin_,
   {{0x613cc03e,0xf9c4e555,0xe8194028,0xdcfbc20f}},	//   _bélx, _احتی, नौना_, nluğ,
   {{0xe73801e3,0xc2e8c07c,0x23bc2009,0x61e2c02e}},	//   _већ_, ক্রি_, _díj_, _kvol,
   {{0x60dd01e7,0x6d43f650,0x96272041,0x2b920066}},	// [1b10] masm, _yona, _saņē, dách_,
   {{0x2ef5337a,0xdb0f738b,0xdb0bc2a8,0x629aa108}},	//   _узор, _tucí, _vigé, _ozto,
   {{0x2d87a197,0x7d152106,0x60dbd12b,0x644b81cd}},	//   vone_, mezs, yaum, wygi,
   {{0x291362b2,0xaca34079,0x20017ccb,0x63a446fa}},	//   sexa_, _anụb, rthi_, cmin,
   {{0x7afd40ae,0x67208a14,0x20016050,0xf1a4402d}},	//   _icst, _damj, sthi_, _фрэн,
   {{0x6b74a926,0x60c2c0f9,0x6b88e3ce,0x27edd40d}},	//   олчу, _afom, jodg, vren_,
   {{0x3dc6c037,0x2b920066,0x6d5afccc,0x9f43402e}},	//   _atow_, bách_, dhta, dujú_,
   {{0xe6782095,0xf8bf4639,0x7415c13a,0x387e00ba}},	//   יתוח_, _inés_, موعا, ştri_,
   {{0x3f87bb43,0xb345e1ae,0xaa49c052,0x7f43e071}},	//   ponu_, _noçã, уппа_, _ponq,
   {{0x21212037,0xaca321e9,0x26dd9ccd,0x63a44a88}},	//   _nahh_, _amọd, lawo_, zmin,
   {{0x5e95a13a,0x2b9c8026,0x7c95a13a,0x63a566a5}},	//   _الاط, síce_, _الاص, imhn,
   {{0xe8f71574,0x2d78804d,0x04c9cae5,0x69c9dcce}},	//   блю_, jčel_, _صوتي_, ppee,
   {{0x9f43406f,0x4279800b,0xdb1c80c2,0xee2eca8d}},	//   bujú_, ראָג, _zwró, _эн_,
   {{0x644d4f62,0x798d0194,0x41cf8077,0xa06a253f}},	//   dyai, _ekaw, सीएस, гага_,
   {{0x6d453ccf,0x2cac2156,0x6d988a60,0xe81fc077}},	//   _doha, ädd_, dían, बिका_,
   {{0x65698125,0xdb0d40cb,0x63a45cd0,0x213fc7a0}},	//   _nmeh, rmaß, umin, njuh_,
   {{0x98a3482f,0x78c6e0e0,0x7d018009,0xcebae0a2}},	// [1b20] зите, _érvé, záró, _haƙa_,
   {{0xef1a21e3,0x442b51a1,0x39920009,0x6d5bd833}},	//   _смо_, _drc_, dási_, hhua,
   {{0x26c04639,0xa2aa8982,0x232a833f,0xe3b260e0}},	//   pcio_, जेन्, ложи_, سرا_,
   {{0x2d8a3543,0x27fae14f,0x10a69479,0x2bb7e0ba}},	//   lobe_, _åpne_, биен, _căci_,
   {{0xfecfa07c,0xb87b0d64,0x26da3cd1,0x9f406052}},	//   _রাজধ, caíd, _kepo_, triä_,
   {{0xdce3a041,0x2d8a3cd2,0x225fc098,0x6d452005}},	//   tinā, nobe_, dzuk_, _xoha,
   {{0x9f43406f,0x60d8eb30,0x26d95cd3,0x2b920066}},	//   vujú_, _revm, _yeso_, pách_,
   {{0x26da2c35,0x7d165cd4,0x6b55c057,0x629c7944}},	//   _lepo_, neys, _pága, _izro,
   {{0x2d8ca05d,0x60ddc0c4,0xec7a8967,0x37aaf045}},	//   _tkde_, ðsma, _спа_, лтон_,
   {{0x6b8d1cd5,0x25a00143,0x501b4095,0x66045cd6}},	//   _skag, _ahil_, נויו, itik,
   {{0xdb1c804a,0x71790a18,0x6d453cd7,0x6d465cd8}},	//   _ztrá, ибор_, _roha, _ooka,
   {{0xb4c7404b,0x236dc0c2,0xdb0e62f8,0xd10a4077}},	//   _उभे_, ciej_, _dibé, ह्मण_,
   {{0xd467cc4e,0x7d1649a9,0x75245cd9,0x286b0423}},	//   _лице_, deys, ddiz, урно_,
   {{0x61f52098,0x63baa01a,0x96bafcda,0xd85160f9}},	//   tuzl, _kutn, _суду_, _bọ́_,
   {{0x6d9d0004,0xa3e50026,0x2c04807c,0x66045cdb}},	//   réab, _पटक_, লিয়ে_, etik,
   {{0x2121248d,0x3d066c87,0x201eaefb,0x6d4640e8}},	//   _wahh_, स्से_, _msti_, _coka,
   {{0x629c605d,0x661e205d,0x8b04404a,0x7ff70049}},	// [1b30] _azro, _espk, ířat, _اسعا,
   {{0xdd0e203c,0xdb0f4057,0x60de6037,0x26dd8035}},	//   mışd, _micé, gapm, wawo_,
   {{0xdb0e8698,0x61e41cdc,0x26d95796,0x50b58192}},	//   _subá, _zvil, _teso_, ослу,
   {{0x26c17cdd,0x26defcde,0x6d46c052,0xdb0be105}},	//   scho_, hato_, ökal, _zugä,
   {{0x201ea766,0x3945b5f6,0x6280805d,0x26dd811d}},	//   _asti_, _pols_, _cxmo, rawo_,
   {{0xdb076071,0x69cd4187,0x27e9812d,0x629d4018}},	//   _fijá, mpae, šano_, _izso,
   {{0x6d46411d,0x7c29400a,0xdb08a017,0x2d9f8067}},	//   _yoka, _šerh, _didà, _thue_,
   {{0x9b588f0e,0x22aee03c,0x5894a049,0x47c5c98c}},	//   _лист_, dək_, أجهز, обив,
   {{0x4429447b,0x2fc90286,0x316ddcdf,0x25e5a028}},	//   nva_, _ntag_, riez_, _टिकी_,
   {{0x0609e624,0xf1bf00e0,0x3945a17b,0x6a1480e0}},	//   анок_, tván_, _uols_, _عبقر,
   {{0x7c2d1ce0,0xf8bfc608,0x3946c05f,0xdce9cf9e}},	//   _arar, ñés_, _foos_, lieč,
   {{0x6d5d0049,0x4ca8007c,0x2d8b1ce1,0xdce9c143}},	//   ghsa, _ক্ষু, goce_, dneć,
   {{0xdee5e51b,0x7c2d0005,0x1b23207c,0x2d8a3ce2}},	//   _доли, _crar, মানে_, tobe_,
   {{0xa91dc05c,0x7a0aa03c,0x60db82d9,0x2b946156}},	//   kožk, _mətn, _leum, räck_,
   {{0x44295ce3,0x7c2d1ce4,0xa3aee04b,0x8b26401f}},	//   eva_, _erar, _कळत_, одве,
   {{0x3947ef8f,0x6e2d01e2,0x6f0d0088,0x7d0d0385}},	//   _hons_, _frab, _gbac, _gbas,
   {{0x6ab26077,0x5ea8007c,0x60de6037,0xcb12c557}},	// [1b40] जश्र, _ক্রে, tapm, ולן_,
   {{0x21a3601b,0x6d477ce5,0x23814013,0x6b584183}},	//   диум, _coja, vėje_, _díga,
   {{0x3205e42c,0x6d465ce6,0x46d02295,0x442001e2}},	//   ntly_, _toka, _त्यह, _hsi_,
   {{0x9f496069,0xa50a8fb5,0x1d0a878e,0x26dee024}},	//   stað_, реда_, реди_, zato_,
   {{0x44200026,0x88846555,0x629c6064,0x6dbc206f}},	//   _jsi_, _کیان, _wzro, _očak,
   {{0x6723f793,0x7c29c31b,0x6d59dce7,0x7d09dce8}},	//   _nanj, dver, _alwa, efes,
   {{0x7d09cf44,0x7c29dce9,0x66036822,0xd7f0a13a}},	//   ffes, ever, _опра, ركة_,
   {{0x49066026,0x3f8fc05d,0x75241cea,0x3946d258}},	//   स्रो_, _ckgu_, _naiz, _qoos_,
   {{0x44200b01,0x6d9885e0,0x2d8b177e,0x3946dceb}},	//   _nsi_, níam, voce_, _voos_,
   {{0x59d7a026,0x3a3aa156,0x8c1b8095,0xc7b98009}},	//   णीहर, äpps_, _דומי, _erős_,
   {{0x2004d657,0xb4ab8069,0x2d788cfd,0x75240265}},	//   stmi_, _íþró, jček_, _baiz,
   {{0xa9c3e0ff,0xc178e03b,0x6dbc2133,0x6b60e1e9}},	//   ьськ, snė_, _ečak, _bágù,
   {{0x6b5cc009,0x98b34041,0x2603e005,0x637ec018}},	//   _cége, ādīt_, año_, cīna,
   {{0x60c441ae,0xdb01a057,0x7053c0eb,0x2d8b004a}},	//   ecim, _silú, _تنها, soce_,
   {{0x80ddc07c,0xcebae0e8,0x9f406049,0x777ae048}},	//   _যাত্, _haƙo_, briú_, mntx,
   {{0x6d48b03c,0x6723fbf9,0x26160010,0x9992a06f}},	//   _loda, _zanj, _पैकी_, ždňa_,
   {{0x3eaf4669,0x6d48bcec,0xdcbb60ff,0x6e2d00b1}},	// [1b50] ägt_, _ooda, аще_, _urab,
   {{0x3f8ce0f7,0xceb40076,0x7d18b5aa,0x44f5253f}},	//   nodu_, _קיץ_, jevs, _эпос,
   {{0x6d4774ec,0x69c985b2,0x4974271b,0x5595401b}},	//   _voja, _stee, _ілюс, _наоѓ,
   {{0xed59a04a,0x6d48a6f1,0x2006800e,0x7c29c76d}},	//   _muže_, _aoda, ftoi_, yver,
   {{0xeb3a400b,0x656d00ae,0x7c2e60cb,0x33248227}},	//   _הערש, _mmah, _erbr, _damx_,
   {{0x399200e0,0x6e2041de,0x67253ced,0x21248153}},	//   lást_, _âmba, _jahj, _eamh_,
   {{0xa3cf8077,0x7523fcee,0x63bd5cef,0x60dd4106}},	//   वीज_, _ranz, _husn, _kesm,
   {{0x85b98844,0x63bd4827,0xceb26076,0x63bb99ae}},	//   _глас_, _kusn, _טים_, _tuun,
   {{0x61e90274,0xee36c3fc,0x442ee0ea,0x6f09c8c8}},	//   šelj, зны_, _arf_, rfec,
   {{0x29000024,0x6b5cc009,0x3f8cfab0,0x0cb84a2a}},	//   _scia_, _rége, godu_, _अल्म,
   {{0x2277a896,0x6b8d4534,0xc7b46076,0x63b56714}},	//   _بلاگ_, koag, ובץ_, _mizn,
   {{0xe456600b,0x7523fcf0,0x889aa095,0x6376006e}},	//   פירט_, _wanz, _הבעי, kšne,
   {{0x6d5b8022,0x395fdcf1,0x659ac0be,0x39490057}},	//   _mlua, mhus_, _פינק, _doas_,
   {{0xc104e13a,0x88bce04a,0xdb1ac017,0x9f4304d2}},	//   _يوني, nděl, _autè, čká_,
   {{0x7ae1fcf2,0xd24ee1ac,0x29191cf3,0x63bd4105}},	//   malt, _منو_, besa_, _ausn,
   {{0x27e6dcf4,0x442fc4b4,0xf8b98067,0x317f8490}},	//   _yvon_, _krg_, _ngũ_, _njuz_,
   {{0x5577000b,0x63a41cf5,0x26d240ae,0x6b965cf6}},	// [1b60] _מעקן_, _ihin, rbyo_, rlyg,
   {{0x6d989cf7,0x60dd410a,0x629600a2,0x6d5b9cf8}},	//   ríam, _eesm, _iyyo, _alua,
   {{0x98a24013,0xf53f0488,0x14ca8052,0x636060c4}},	//   _tokį_, kmål_, были_, _löng,
   {{0x68e1fcf9,0x60c56515,0x37bde07c,0x9f4221ce}},	//   hald, achm, _আবার, dské_,
   {{0xf3f12067,0xba764233,0x0cdbe046,0x2007bcfa}},	//   ợc_, _راحت, _मजूम, etni_,
   {{0x68e1fcfb,0x7ae1e052,0x61e2407f,0xe6d90077}},	//   jald, jalt, šols, _भज्ज,
   {{0x68e1fcfc,0x8af005fc,0x03a37cc3,0x7c2e6012}},	//   dald, _aləm, _чиро, _urbr,
   {{0x44224227,0x7ae1e090,0x63bd4058,0xceb321a9}},	//   _ksk_, ealt, _yusn, עיה_,
   {{0x0566bcfd,0x26ddc037,0x67264920,0x93bca12a}},	//   _еван, _dewo_, _makj, _arăt,
   {{0x394a62b7,0x291a7cfe,0x68e280ef,0xdb1d61ae}},	//   _jobs_, nepa_, laod, _ausê,
   {{0xf2dbc07c,0xdeefc12a,0x63a2cdb2,0x27e68547}},	//   _ধারণ, _пы_, _thon, lson_,
   {{0x7afd0018,0x8ccce447,0x2d8cedee,0x636060c4}},	//   ugst, _द्रो, sode_, _hönd,
   {{0x6283e2a8,0xc7c70de7,0x46a3ce95,0x7d02dcff}},	//   _exno, ясни, _зацв, _icos,
   {{0xed59a3ee,0x4a53c0ff,0x1874e0ff,0x4421200e}},	//   _tuže_, _якіс, _огля, _psh_,
   {{0x27e680a2,0x3171217a,0x80dc007c,0x44224095}},	//   hson_, rizz_, _ভার্, _ask_,
   {{0xa91dd62f,0x6d4ae77c,0x656e79ff,0x6c7be076}},	//   toži, _hofa, _ambh, _לאופ,
   {{0x25a9491f,0x3f8eb665,0x6725205d,0x7ae28114}},	// [1b70] rmal_, kofu_, _tahj, daot,
   {{0xa91ddd00,0x2d9906f1,0x69cd00ce,0x7bcd1b95}},	//   roži, llse_, _itae, _itau,
   {{0x29c1e016,0x63b56055,0x63a9dd01,0x60c57d02}},	//   _xóa_, _vizn, ymen, rchm,
   {{0x7ae1f035,0xdb066b41,0x0dba20e0,0x27e69bb0}},	//   zalt, _zukü, _گئیں_, fson_,
   {{0x443fc17a,0x63607137,0x27e69d03,0x7b026d6e}},	//   xxu_, _bönd, gson_, äytö,
   {{0xe736ad3e,0x7526435f,0xa3d42843,0x61faf1c7}},	//   деш_, _zakz, सीक_, kutl,
   {{0xb8e5a1b0,0x6e22cbb1,0x6726417b,0x63607d04}},	//   _एल_, _asob, _yakj, _dönd,
   {{0xe7ee04da,0xd4d9c139,0x0dc9c662,0x7aed183d}},	//   _जिला_, цькі_, олий_, _ndat,
   {{0x67277d05,0x7527635d,0x2b4b417b,0x80e160c2}},	//   _kajj, _kajz, _mocc_, _फ़ाइ,
   {{0x61e98a39,0x67277d06,0x21294058,0xbebce041}},	//   _ivel, _jajj, hdah_, ldīj,
   {{0x61fafd07,0xdbf2204a,0x7c2d5d08,0x6e22cee2}},	//   gutl, třít, hvar, _esob,
   {{0x6560c420,0x3255d342,0xed57014f,0x3a29c012}},	//   chmh, _овер, дою_, _šapu_,
   {{0xb8d6004b,0xdb1c8011,0x6d4ae7c1,0x3cfe6290}},	//   _जण_, _durè, _fofa, _लाले_,
   {{0x68ed1d09,0x6d5d5d0a,0x7d1bdd0b,0x7aed1a79}},	//   _edad, _alsa, leus, _edat,
   {{0x2bdd8b27,0x6b4fa488,0x3d0e9d0c,0x9f4de071}},	//   नीता, _høgs, ण्डे_, nreí_,
   {{0x7d1bdd0d,0x63a41d0e,0x9f584017,0x2127e067}},	//   neus, _uhin, ltrú_, _hanh_,
   {{0x91e344c4,0xe3a70555,0x0d862425,0x13d6a07c}},	// [1b80] коте, _تشوی, _олин, সওয়,
   {{0xef176052,0x995c8066,0xda666049,0x6609d0a9}},	//   мму_, díš_, واضي, itek,
   {{0x2127e067,0x442366de,0x63be2143,0x61ed800a}},	//   _manh_, _csj_, _uupn, šall,
   {{0x6d46049f,0xdcfb8143,0xa3c1b3e7,0x2127e067}},	//   njka, _fjuč, ंदन_, _lanh_,
   {{0x8b666555,0x3f8ea475,0x5edee07c,0x9abca17a}},	//   _قاسم, tofu_, _মাসে, _faċl,
   {{0x61fbd2f0,0x25bf8524,0xf1bf44d2,0x2ee00584}},	//   duul, _duul_, _práv_, _leif_,
   {{0x60c99d0f,0x44204d14,0x55772053,0x6609dd10}},	//   _ffem, lwi_, ועסן_, etek,
   {{0x6b54a5df,0xf70ee119,0xbcfb4187,0x64a682af}},	//   _màgi, _củng_, _gléd, _жаба,
   {{0xb0cfa010,0x6d4ae320,0x9f4542f4,0x28cfa1b0}},	//   _स्वग, _pofa, élé_, _स्वि,
   {{0x2900405d,0x9986e133,0x4cd8a07c,0xbcfb0049}},	//   hgia_, _broš_, _ঠাকু, dhéa,
   {{0x68e08c12,0x9c7ca504,0x6e2413d0,0x6b502156}},	//   _kemd, _beče, _asib, _lägs,
   {{0x9c7ce274,0x6d4bca77,0x6d5e3d11,0x3946913e}},	//   gača, _goga, _alpa, njos_,
   {{0x7d1ae98d,0x21295d12,0xed5f806f,0xa36760f9}},	//   pets, vdah_, úžia_, _bọ̀r,
   {{0x92bf007c,0xd04f45fc,0x6b4fa488,0xe1f1a0e0}},	//   ইরে_, _gecə, _høgr, _جسے_,
   {{0x442487d3,0x394b45df,0xa2cb2969,0xad9b2049}},	//   _lsm_, _pocs_, तुष्, ntúi,
   {{0xed59ab23,0x67277d13,0x6728bd14,0x25b86090}},	//   _muža_, _sajj, _ladj, _airl_,
   {{0x672774f8,0x7bc09d15,0x5ee3607c,0x21294a94}},	// [1b90] _pajj, _numu, _পাবে, rdah_,
   {{0x7d1c21af,0x2127e081,0x25094896,0x7d0d5d16}},	//   cers, _xanh_, _کردی_, sfas,
   {{0x68e45d17,0x61e99d18,0x394b40b8,0x6d58a584}},	//   baid, _svel, _tocs_, dkva,
   {{0xdb1d6e41,0x2b0ee0aa,0xbcfb4e1c,0x442ddd19}},	//   _musé, त्तु_, _emér, yve_,
   {{0x06e2207c,0x27e99b06,0x395ea0ca,0x77a5c005}},	//   _বাতি, éan_, _blts_, nóxe,
   {{0x69c09d1a,0x6b82caf8,0x7982c0f9,0x44237d1b}},	//   _dume, _ajog, _ajow, _tsj_,
   {{0xe611a6b0,0x69dc61cd,0x61fd1d1c,0x3eb3a156}},	//   اشت_, _gwre, husl, äxt_,
   {{0x69348307,0xe9d9d0f6,0x56b82095,0x68e57d1d}},	//   _инсу, пки_, ופון_, lahd,
   {{0x7529c0e0,0x96caa216,0xdb0e60e0,0xb87b013a}},	//   rdez, _स्कॉ, _hibá, daío,
   {{0x6b55cf3c,0x6f04149a,0x6728bd1e,0x1309e5be}},	//   _mági, _scic, _gadj, чной_,
   {{0xa3e6420b,0xf1b982e2,0xb5fb00e0,0x99520066}},	//   _यौन_, _kiš_, szál, ráž_,
   {{0x7bc087d2,0x7d1c3d1f,0x6d4d0005,0x6f052090}},	//   _yumu, wers, _coaa, _achc,
   {{0x7c252920,0x7bc1bd20,0x65752037,0x27e94156}},	//   _ashr, _hulu, fizh, jsan_,
   {{0x27e95d21,0x69c1bd22,0x44320aaa,0xd138e0c2}},	//   dsan_, _kule, _vry_, gląd_,
   {{0x6f1d1385,0x69cf4041,0xa879e00b,0x399900e0}},	//   besc, _atce, _מאַר, zési_,
   {{0x44205d23,0x7c241d24,0x2fc01518,0x44320095}},	//   twi_, _tsir, _tuig_, _try_,
   {{0xe1fa5c2e,0x291ca03c,0x24f668e9,0x6b8403c9}},	// [1ba0] яга_, yeva_, ечер, _ijig,
   {{0x673b8011,0x23814013,0x78a401fb,0x31720089}},	//   _anuj, bėjo_, _iziv, _hmyz_,
   {{0x68e086ae,0x6b840098,0xfce642d8,0x2129058b}},	//   _pemd, _kjig, _поно, _yaah_,
   {{0x5de681e1,0xed59a381,0x63ad5d25,0x06868407}},	//   ежда, _ruža_, cman, нген,
   {{0x7ae1bd26,0x69c1ba79,0x65628ee4,0x27e94025}},	//   _belt, _aule, rhoh, csan_,
   {{0xd943a0bc,0x680aa03c,0x9c7ce530,0x0877400b}},	//   лечи, _hədi, dačn, _װעלט_,
   {{0x7bce6277,0xb4dc6ef3,0x2d805d27,0x7ae09d28}},	//   _utbu, ठरी_, onie_, _temt,
   {{0x6b9bc069,0x4425ae25,0x68e1a046,0x5694cd2b}},	//   glug, _dsl_, _eeld, кайт,
   {{0xd90dc6b0,0x69c1bd29,0x3207c1d3,0xcebae0a2}},	//   تین_, _eule, нхэн_, _haƙi_,
   {{0x44447d2a,0x3f85220d,0x61fd0466,0x69c1bd2b}},	//   ox_, čluk_, vusl, _fule,
   {{0x98a4a046,0x63b8e048,0x2498e065,0xdbdbe071}},	//   _ओरिए, _vivn, ærm_, _báñe,
   {{0xdb01a86d,0x7ae1bd2c,0x6298e326,0x2d804064}},	//   _filó, _zelt, _vyvo, jnie_,
   {{0x2bb2e12f,0x9f478050,0x656457bf,0x69de20f9}},	//   ीददा, éné_, dhih, _awpe,
   {{0x6363410a,0x48ed0295,0x21290939,0xd5b8204e}},	//   _mõne, _आएको_, _waah_, есс_,
   {{0x2258204a,0x3da74af5,0xb90701a6,0x61eabd2d}},	//   _čeká_, ераб, _পা_, nsfl,
   {{0x2d87606e,0x61fd0493,0x2905217a,0x2d9242e0}},	//   čnem_, pusl, żla_, goye_,
   {{0x7f98807b,0x27e95d2e,0x2418402d,0x9f5a83bb}},	// [1bb0] níqu, usan_, ноты_, cupé_,
   {{0x68e2dd2f,0x7c2f8057,0x63bab7d7,0x9c7ce066}},	//   _leod, _ácri, _nitn, načo,
   {{0xdbd74052,0x2d8040c2,0x26c94098,0x78a40143}},	//   _säät, bnie_, pcao_, _zziv,
   {{0x45d5895a,0x69c1bd30,0x63a8a320,0x7ae73d31}},	//   водс, _rule, _ahdn, lajt,
   {{0x291d8068,0x9c7ce066,0x7ae1a052,0xdd91668c}},	//   rewa_, xačn, _pelt, _نوح_,
   {{0x660d5d32,0x6d5985e3,0x39494cdb,0x672d410a}},	//   mtak, skwa, ljas_, ldaj,
   {{0x6498a1e1,0x7ae2dd33,0xd7f861e3,0x3a26c0f9}},	//   нтър_, _beot, _пут_, _asop_,
   {{0x9c7cfd34,0x2019407d,0x7ae73d35,0x7777617a}},	//   tačn, _kpsi_, hajt, lixx,
   {{0x7ed5e0ff,0xe7848520,0x44232223,0x9f4d006f}},	//   кінч, _суро, hwj_, budú_,
   {{0xdb1c85f0,0xa2d98219,0x23600098,0x6b96141b}},	//   _strø, मरक्, _slij_, _skyg,
   {{0x660d5d36,0x316007a0,0x61e9dd37,0xed59a04d}},	//   htak, _pliz_, ssel, _hužo_,
   {{0x25646009,0x6aba6d70,0x63bb80ce,0x27ed8488}},	//   _zöld_, _útfe, _jiun, _kven_,
   {{0x2b4942d1,0x64444057,0x8477c031,0x4426c15e}},	//   djac_, xxii, _fáwẹ, _gso_,
   {{0x2a695d38,0x2d805d39,0x29050009,0x61ed162d}},	//   dzab_, wnie_, őlap_, _dval,
   {{0x660d4e3b,0x3ebf807d,0x4909a026,0xf796e949}},	//   etak, _ogut_, _सानो_, _جنوب_,
   {{0xc5f2a00b,0x6619c17b,0x93fae1a9,0xa2c31ac4}},	//   ידל_, _kpwk, _חלקי, रखण्,
   {{0x212b5118,0xcc8a0050,0xaa461d3a,0x27ffce38}},	// [1bc0] _dach_, _زنده_, _репл, nuun_,
   {{0xd36f213a,0x2ee3600a,0x399ac00e,0x4427e05d}},	//   _وهي_, _cejf_, rësi_, _ksn_,
   {{0x99802432,0x62898057,0x6faa41e3,0x63bb8090}},	//   _križ_, _axeo, _овог_, _biun,
   {{0x7ae410cd,0x69c41d3b,0xd910401c,0x20274052}},	//   _jeit, _kuie, _دیر_, äviä_,
   {{0x68e405a5,0x44446227,0x2b9c8066,0x63baaebe}},	//   _meid, sx_, níci_, _pitn,
   {{0x399900e0,0xae1cc5cb,0x6b55c581,0x6d4f5d3c}},	//   lést_, _बैगन_, _mágu, _zoca,
   {{0x63bb94ee,0xab646121,0x5f0681c7,0x317b2095}},	//   _fiun, rlüğ, _изва, ורסמ,
   {{0x63a99d3d,0x6da68977,0x2d542046,0xc05ac14f}},	//   _ghen, _риба, _käes_, діо_,
   {{0x2492a064,0x68e3fd3e,0x6d5c20c4,0x15ee0028}},	//   łym_, _bend, kkra, _जिगर_,
   {{0xdbd9a01f,0x6d5c34ec,0x2385c041,0x6f16004a}},	//   _açõe, jkra, rēja_, _abyc,
   {{0x2bbbc38e,0x3a26c0ca,0x217901ba,0xdd8fa343}},	//   _ऊंचा, _wsop_, ейны_, _بول_,
   {{0xe1ff04cd,0xbf13c0e0,0x63a9800e,0x9257e052}},	//   tuó_, _نومب, _xhen, тают_,
   {{0x69c3e143,0x7e69c0c2,0x2287012a,0x27ed046b}},	//   _eune, czep, тунг, éen_,
   {{0x040da067,0xceb38557,0x3f821d3f,0x48fe635b}},	//   _nướn, ייר_, anku_, _लागो_,
   {{0xf1a71342,0x69c3fd40,0xa18420db,0xdb1c9d41}},	//   _ирин, _gune, рыял, _aurí,
   {{0x2ee37d42,0x8ab7e095,0x24890048,0xe0b7e00b}},	//   _sejf_, _בלוג_, _txam_, _בלוט_,
   {{0x6600c058,0x63a980fd,0x69c416e9,0x7bc3e35f}},	// [1bd0] numk, _rhen, _guie, _zunu,
   {{0x3a291441,0x636600b6,0x212cbd43,0x80dd207c}},	//   _isap_, _póng, _nadh_, _বাক্,
   {{0x35f5634f,0x777760f7,0x9abca17a,0x4424c223}},	//   упер, rixx, _faċi, hwm_,
   {{0x4ae30afa,0xfe7040e0,0x6600dd44,0xdb18e187}},	//   परिव, حدہ_, kumk, _divé,
   {{0xa3e5bd45,0x2489801f,0x201940c7,0x672d1d46}},	//   बीन_, çam_, _upsi_, _maaj,
   {{0x68e8eb33,0x2409a7f8,0x9c7ca361,0x212ca153}},	//   jadd, енки_, _seča, _cadh_,
   {{0x68e8e336,0x63bd4e1e,0x6d5bdd47,0xdb0fe62e}},	//   dadd, _kisn, tkua, _àdép,
   {{0x2d833d48,0xe1f9c013,0xa925c9b1,0x2249a09f}},	//   hnje_, trų_, удил, ćak_,
   {{0xd9e35d49,0x68e8fd4a,0x6600dd4b,0x7c28a0ca}},	//   गठित_, fadd, gumk, _esdr,
   {{0x69c4e03a,0x6d5bd3a0,0x399900e0,0x320dc054}},	//   _čier, skua, zést_, rtey_,
   {{0x7bc53d4c,0xc4d2a095,0x7dc7a121,0x9f4224d2}},	//   _nuhu, _הגב_, _kısm, jská_,
   {{0xf99f00d1,0x7ae3fd4d,0xd435c33d,0xdb03fd4e}},	//   glè_, _went, _معتب, _pinó,
   {{0xe8e02067,0x7d04419f,0x3999004a,0x4424c0fd}},	//   _liễu_, vgis, vést_, cwm_,
   {{0x98a04098,0x6e20441a,0x2d820098,0x2001648d}},	//   ldić_, _âmbi, snke_, kuhi_,
   {{0xd00ee68c,0xa3dfdd4f,0xdb01e262,0xdb1aa011}},	//   _فلو_, धीर_, rmlä, _ditè,
   {{0x68e9c88e,0xa09ae053,0x040da067,0xc879c12a}},	//   naed, _איצט, _sướn, eaşi_,
   {{0x7a0aa03c,0x7c2999d7,0xd46748f4,0x39401d50}},	// [1be0] _hətt, _nser, гите_, _inis_,
   {{0xdd998061,0x7ae53d51,0x20021d52,0xdb1d6395}},	//   _akň_, _geht, muki_, _fusí,
   {{0x29c9dd53,0x672d0022,0x9bb72095,0x69c5200f}},	//   _lúa_, _yaaj, _תהיה_, _guhe,
   {{0x614653b0,0x60cd5d54,0x7c298133,0x2fd7663b}},	//   _сема, ccam, _bser, اوند_,
   {{0x040da016,0x7bc53d55,0x6721fd56,0x06e8607c}},	//   _tướn, _zuhu, kelj, _পাঠি,
   {{0x6458a03b,0xe8d90125,0xed598579,0xaca40096}},	//   tyvi, _ijụ_, _riže_, _nkọw,
   {{0xb90a8405,0xd5bacd3e,0xa3b5279e,0x6562c320}},	//   _মা_, нси_, जगत_, _ploh,
   {{0x7ae9c0e2,0x3d09ae4e,0xad9b203a,0x4154c242}},	//   gaet, _साथे_, ntúr, рвис,
   {{0x6721e35d,0x21678471,0x7ae65d57,0xa3dfc010}},	//   felj, _сити_, _mekt, धील_,
   {{0x6fdd8877,0x69c65d58,0x25a04f2c,0x60cd4e10}},	//   _नौटं, _muke, hlil_, zcam,
   {{0x7764055f,0x0d976095,0x44291d59,0x2d8327a0}},	//   _blix, רכים_, _ssa_, vnje_,
   {{0x403501ba,0x29068265,0x2b14666f,0x48a7e3fc}},	//   аемс, ngoa_, न्तु_, ытым_,
   {{0xd378e88c,0xf593c13a,0x9c57c050,0x63bd59dc}},	//   pić_, _النج, _مجوز_, _risn,
   {{0x6601e5cf,0x6721e143,0x6b584005,0xc69380be}},	//   bulk, celj, _mígu, מאר_,
   {{0x7bc65d5a,0x6b584057,0x63bd5d5b,0x6601fd5c}},	//   _auku, _lígu, _pisn, culk,
   {{0xc7c8c016,0xaca48088,0x2d9a2291,0x2918662f}},	//   _gốc_, _asọp, _ekpe_, _abra_,
   {{0xb606629f,0x3a2908c4,0x60c2c9fa,0x44387406}},	// [1bf0] _lišć, _usap_, _mgom, _arr_,
   {{0x20016eb0,0x9c7ca055,0x81e8007c,0x7bc53d5d}},	//   tuhi_, _rečn, মূহ_, _tuhu,
   {{0x7a0aa5fc,0xab5da227,0x2b146a2a,0xc879c0ba}},	//   _xətt, _bużn, न्धु_, raşi_,
   {{0x657afd5e,0x799aad87,0x9635834f,0x09dac1a6}},	//   hith, _aktw, инец, _দিনা,
   {{0x3f891d5f,0x05db40c2,0xa509aa92,0x69c6400f}},	//   _mjau_, मीखब, вела_, _guke,
   {{0xa3c1a029,0x23694037,0xee3880e0,0x752e60a2}},	//   ंदल_, lhaj_, اقوں_, _gabz,
   {{0x7ae9c1cd,0xf8b52028,0x20112265,0xcf582095}},	//   taet, ंधिय, ntzi_, רבות_,
   {{0x986a6315,0x27fc606f,0x672e6361,0x29c9c019}},	//   lığa_, ávne_, _zabj, _púa_,
   {{0x7aeb8b71,0x6fb9a425,0x3eb9c3f5,0x68eb8644}},	//   magt, _агар_, äst_, magd,
   {{0x7aeb9d60,0x3f84cd3d,0xb8fcd7f2,0x20032026}},	//   lagt, anmu_, _त्_, kuji_,
   {{0x63ad00ef,0x44395d61,0x7ae77d62,0x8d76001e}},	//   _bhan, _lrs_, _mejt, لاحا,
   {{0x7aeb9d63,0x68eb88c4,0x7c3b417a,0x27e0812a}},	//   nagt, nagd, _ġurn, ţine_,
   {{0x7db4c0d0,0x8d5ac0be,0x26d16200,0xb4d1c010}},	//   _اصلا, _שכני, _ofzo_, वडी_,
   {{0xdee321fc,0x60c2c0ba,0xbdfd41a6,0x98a240c2}},	//   жори, _zgom, ুবাদ_, _jaką_,
   {{0x0f7ae087,0xe29a2a92,0xe7e12021,0x63be3d64}},	//   _ברסל, тав_, गीला_, _vipn,
   {{0xbdfaa1a6,0x75d1a018,0x69c6527b,0xdb1d6733}},	//   _আহমদ_, _gāze, _puke, _ausà,

   {{0x7523bd65,0x8d76233e,0x212fd93d,0x442a6fcf}},	// [1c00] kenz, _نادا, _magh_, _ssb_,
   {{0x7bc6583b,0x798980f9,0xdb1d44b7,0x69c77d66}},	//   _vuku, _ajew, _lisè, _buje,
   {{0x6b5842ee,0xd02660fb,0x6da6425d,0xaec696f4}},	//   _sígu, рмей, _вина, абел,
   {{0x2d982ea3,0xd91086b0,0xd7fa803b,0x26076046}},	//   lore_, ثیر_, вук_, _हमरी_,
   {{0x765ae064,0xead4a772,0x75228381,0x44395d67}},	//   zyty, боль, reoz, _grs_,
   {{0x4438606e,0xb4dff1c9,0x3f983d68,0x99892089}},	//   _trr_, तरो_, noru_, _trať_,
   {{0xb4d1c04b,0x394ddd69,0x22476d4b,0xca48a050}},	//   वडू_, fjes_, änkt_, العه_,
   {{0x75244019,0x7414c13a,0xb4c2dd6a,0xe81e2028}},	//   neiz, موبا, ्डे_, _पहना_,
   {{0x69c76098,0x661e217b,0x8afee35f,0xa5bb61e9}},	//   _zuje, _lppk, _alƙa, _aróy,
   {{0xab5ca041,0x60c41d6b,0xdb156009,0xaaaa6028}},	//   _biļe, _agim, _kizá, _कराक,
   {{0x3f8689fe,0x656aa351,0x7c2bc683,0x61e400e8}},	//   onou_, mhfh, _esgr, _awil,
   {{0x645ae407,0x66044155,0x6db2e0c2,0x61e40030}},	//   ryti, kuik, _płas, _bwil,
   {{0x9f47603a,0x69c09d6c,0x752f4064,0x26086021}},	//   čnú_, _mime, _racz, ांडी_,
   {{0x6d4d4200,0x7f8805fc,0xdcf8a013,0x61e4018c}},	//   wjaa, lıql, rovė, _dwil,
   {{0x9c7ce2e2,0xd7c92050,0x26d166be,0x442ca05d}},	//   kači, اوره_, _rfzo_, _jsd_,
   {{0x7c2bc0e2,0x661e2058,0xd6d84739,0x63ad0445}},	//   _ysgr, _dppk, иту_, _uhan,
   {{0xed59829f,0x68e76361,0x6723a035,0x6603b1e1}},	// [1c10] _niža_, _pejd, yenj, zunk,
   {{0x2366c0dd,0x2418420e,0xdb09c049,0x443a214f}},	//   _lloj_, рофы_, imeá, _frp_,
   {{0x7bc8a050,0x2fc7e016,0x439541d3,0x2d76a0c2}},	//   _nudu, _xung_, _ганс, ałek_,
   {{0x6d9d0057,0x9f584197,0x27fe202e,0x3384814a}},	//   méas, strò_, átne_, оучв,
   {{0x68eb88c4,0x68e8b7eb,0x7aeb8b13,0x661d5d6d}},	//   ragd, _bedd, ragt, _upsk,
   {{0x69c77d6e,0xed59a299,0x7dd3613e,0x68eb80ae}},	//   _tuje, _kuži_, _aħse, sagd,
   {{0xdb1e3d6f,0x61fe60e4,0x68e8a1cd,0x25646105}},	//   _sipë, crpl, _dedd, _köln_,
   {{0xed59a05c,0x2d983d70,0x2004c65f,0x248d0064}},	//   _muži_, zore_, fumi_, żemy_,
   {{0x2004caf1,0x660567d3,0x7d1b8961,0x6603bd71}},	//   gumi_, luhk, _ibus, sunk,
   {{0x386dc105,0x68ed4054,0x7bc8a054,0x7aed57dc}},	//   rzer_, haad, _fudu, haat,
   {{0x657d0bc1,0x66056345,0xe6a568c6,0x69d72286}},	//   fish, nuhk, _करोड़, _ntxe,
   {{0x442d808b,0x394dc00e,0xd05c203c,0x3a3a2071}},	//   _kse_, qjes_, carə, _rrpp_,
   {{0x44295d72,0x7d09dd73,0x2d9dc088,0xe3c8c067}},	//   jwa_, mges, _ikwe_, _tựa_,
   {{0x7d09d59f,0x98a0886f,0x69dbc333,0x7c29dd74}},	//   lges, žić_, mpue, mwer,
   {{0x7aed5d75,0x7bc8a025,0xf1b984e5,0x26e701a6}},	//   faat, _xudu, ेदान, _কারো_,
   {{0xd113fd76,0xed59a29f,0xad9b203a,0x63760edc}},	//   त्रण_, _duži_, stúp, kšni,
   {{0x7bc09997,0x26c5a098,0x63660057,0x9f406049}},	// [1c20] _rimu, _oglo_, _góna, msiú_,
   {{0x7d1b8ea3,0x44201d77,0x6b5cc009,0x75260108}},	//   _abus, _ipi_, _végi, lekz,
   {{0x69c099ae,0x7c29c669,0xb9c106df,0x3f86805c}},	//   _pime, hwer, _üçün, tnou_,
   {{0x6e3b9d78,0xdb1e20d1,0x7bdc3d79,0x8fc5210c}},	//   _brub, _sipè, mpru, _گزین,
   {{0x3f869d7a,0x68f8654f,0x7c29c200,0x2005fd7b}},	//   rnou_, _نکاح_, jwer, huli_,
   {{0x290a2082,0x63a2849f,0x3f9dc079,0x9c7ce552}},	//   ngba_, slon, _akwu_, sači,
   {{0xdcf52041,0x2366c223,0x38c8e01c,0x1b7b600b}},	//   nizā, _ploj_, یادی_, _עטלע,
   {{0x442d9d7c,0xdd90c25b,0x4fd4cfb9,0x7d09dd7d}},	//   _fse_, بوب_, ожит, gges,
   {{0x27f2504e,0x7bc980fa,0x9c7ca143,0x442d8425}},	//   nsyn_, _gueu, _kečk, _gse_,
   {{0x3d1a235b,0x657d116f,0x69c8bd7e,0x2d9dc291}},	//   म्मे_, wish, _tude, _ekwe_,
   {{0xeb9f2042,0x69dc2e9d,0xa3be220b,0x2d991d7f}},	//   ktør_, jpre, ेदन_, tose_,
   {{0x68ed4054,0x65629d80,0xe572c50f,0x99670094}},	//   xaad, nkoh, _عطا_, стол,
   {{0xdbe2e057,0x225ac566,0x68ed4046,0x29183d81}},	//   _véñe, _حجاب_, vaad, ffra_,
   {{0x2d991d82,0xb87b03f6,0x995c80a3,0x25efa04b}},	//   sose_, daít, jíž_, ींची_,
   {{0xdce98e01,0x200040ba,0x68ed5d83,0x2cd64079}},	//   _umeć, erii_, taad, _ọhụ_,
   {{0x9f49613a,0x6e2d035f,0x6d9d0049,0x2b1a2026}},	//   rsaí_, _tsab, réas, म्बु_,
   {{0x442ee037,0x31352471,0x9f5f0326,0x5d557156}},	// [1c30] _hsf_, _депр, nutí_, окат,
   {{0xb8826326,0x317ef016,0x7bdd111b,0x6f1b8024}},	//   čína, nitz_, mpsu, _sbuc,
   {{0x2f1941ba,0x59d400e0,0x442efd84,0x61e641f6}},	//   _конь_, _وغیر, _jsf_, _ewkl,
   {{0x66056d3d,0x6f1c6143,0x02b52077,0x68ed4025}},	//   ruhk, _ebrc, ंधीन, qaad,
   {{0x06e8607c,0x31690552,0xb4e6c118,0xe1ff00c2}},	//   _পারি, _mlaz_, _बड़े_, rzów_,
   {{0x7645e0c4,0xabd5b512,0xe1ff00c2,0x44213d85}},	//   _áhyg, оциј, szów_, _kph_,
   {{0x68e995c7,0x7aef02be,0x657aa090,0x1b49d741}},	//   _teed, kact, _dmth, изки_,
   {{0x7bc1a0eb,0xf1cfe026,0x160ba0c2,0x7c3b800e}},	//   _wilu, _संबन, संबर_, _trur,
   {{0x69c1b562,0x443ce7c8,0x69cafbaa,0x9f605d86}},	//   _tile, _arv_, _aufe, érés_,
   {{0x27ffdd87,0xe619e45c,0x69c1a256,0x75d3e12a}},	//   rrun_, адо_, _uile, _răzb,
   {{0x69261d88,0xe12602ab,0x7c29c547,0x291ce143}},	//   омна, омни, swer, _dbva_,
   {{0xeb9a0758,0x657e6174,0x7bdbdd89,0x2bd0608d}},	//   рим_, ziph, ppuu, _तूफा,
   {{0x317ee10f,0x2005fd8a,0xa3e5ac87,0x752726a6}},	//   bitz_, suli_, बीर_, fejz,
   {{0x6b5cc004,0x7aebcaaa,0x256ba271,0x2005fcce}},	//   _dégu, _hegt, _føle_, puli_,
   {{0x7aee2025,0x7bc3e08b,0x3e4ee03c,0x6b84a049}},	//   rabt, _iinu, yəti_, éigi,
   {{0x7989dd8b,0xb4e88028,0x64432381,0xdce40df9}},	//   nnew, _मजे_, _šnic, _klič,
   {{0x44213d8c,0xe57a6d24,0x25646277,0x64436277}},	// [1c40] _eph_, аза_, _föll_, ånin,
   {{0xbcfb00e0,0x85062050,0x27f24654,0x63b6502d}},	//   nkén, _بودن, rsyn_, smyn,
   {{0x4f9680ba,0x656e2049,0xf1c9e067,0x2d9a7d8d}},	//   орду, mhbh, _mạo_, rope_,
   {{0x2007bd8e,0x657e6174,0x6b89dd8f,0x9f5cc04a}},	//   duni_, siph, jneg, prvé_,
   {{0xbddb4355,0x6e296361,0x7f4640c1,0x2d9a6022}},	//   _crèd, _ćebe, _inkq, pope_,
   {{0x6234aa6e,0xc0aa650f,0x636b38ee,0x291ddd90}},	//   зеку, _نازل_, _tüne, _abwa_,
   {{0xdbd1c1ae,0xa0a37cc3,0x69d9d4b6,0xd90da0eb}},	//   qüên, _жард, _atwe, ایم_,
   {{0x7aeaea95,0x3f9ea88e,0xdb064052,0x6b9bc143}},	//   _seft, _wktu_, _eikö, goug,
   {{0x6616403b,0x69cafd91,0x7bcae9c8,0x274ae192}},	//   ntyk, _sufe, _sufu, ачно_,
   {{0xdc3ea066,0x2918a569,0x02e30026,0x2613a1ae}},	//   líče, _ùra_, पर्न, bão_,
   {{0x39587d92,0x6d573d93,0x69d9c614,0x29d7617a}},	//   _mors_, _roxa, _etwe, _għad_,
   {{0xed59a2e2,0x443eb4b3,0x44212058,0x236ddd94}},	//   _dužu_, _irt_, _rph_, chej_,
   {{0x6d572005,0x799afc7f,0x69c3eea3,0x660281e7}},	//   _poxa, potw, _fine, nrok,
   {{0xf1c9e067,0x5334eae2,0x443ebd95,0x59ca6292}},	//   _gạo_, _хект, _krt_, िदार,
   {{0x95cb30da,0x163429fd,0x9e3421fc,0x63bb6425}},	//   руга_, меря, мерч, _èuni,
   {{0xdb1c6359,0x3201605c,0x7bcbd33d,0x2002000a}},	//   _dirí, vrhy_, _yugu, brki_,
   {{0x20040017,0x2d51c0e6,0x6b9d0057,0x799c20b1}},	// [1c50] àmit_, _páez_, mosg, borw,
   {{0x68ed1d96,0x4422405d,0x628be29c,0x8aa760e7}},	//   _head, _dpk_, šloš, оред,
   {{0x2d5c403e,0x69cee06f,0x9ad88125,0xb4d88291}},	//   _cíes_, íbeh, _ịrụg, _ịzụt,
   {{0x29d08031,0x2613a1de,0xab5d82a4,0x2d5c4733}},	//   _bàa_, vão_, _biża, _díes_,
   {{0x8af04497,0x2d9ca2e2,0xa2a24893,0x8d742050}},	//   rkət, fove_, _कुप्, _رایا,
   {{0x68ed1d97,0x21295d98,0x7bcbd743,0x20094037}},	//   _lead, leah_, _rugu, muai_,
   {{0x7989dd99,0x7bcbc046,0x6e3b4098,0x7ae28024}},	//   tnew, _sugu, _šubh, bbot,
   {{0x2b46c28f,0x7bc3fd9a,0xab5da17a,0x3f8b0143}},	//   _cnoc_, _sinu, _mużi, jncu_,
   {{0x2d9ca29c,0x6b9bc42c,0x6ed8a295,0x656f000c}},	//   bove_, roug, नुहु, dhch,
   {{0x2d8b1d9b,0x2d9d9d9c,0x7bdb8037,0x7c22c299}},	//   ence_, lowe_, _ituu, _dpor,
   {{0x6aa4013b,0x7c22ca43,0x6b89d542,0x31ae8066}},	//   _syif, _epor, pneg, lýza_,
   {{0x50cb827d,0x75357c47,0x7bcbdd9d,0x27e91d9e}},	//   िशिष, _lazz, _tugu, _bwan_,
   {{0x7bcd00b6,0x6728fd9f,0x656e228f,0xed599da0}},	//   _cuau, bedj, thbh, _mož_,
   {{0xd00ec13a,0x3ced8022,0x7bc52932,0x7529dd90}},	//   _صلى_, _leev_, _cihu, leez,
   {{0xf2d2e00b,0x27e904ec,0xdb1d413a,0x32433d85}},	//   _טעג_, _ewan_, _eisí, нерг,
   {{0x6b9c33e0,0x290ddda1,0x88ca44d4,0x3ced8022}},	//   sorg, ngea_, слав_, _neev_,
   {{0x7bcd0071,0x9b4640e0,0x61e98125,0x39587da2}},	// [1c60] _guau, _ہندو, _nwel, _pors_,
   {{0x6d59cf40,0x60c99650,0x636de019,0x7afb9da3}},	//   _lowa, _agem, _fúne, _adut,
   {{0x2b594e6c,0xc7268691,0xdb09858f,0x6d05a028}},	//   _fosc_, здей, _bheà, _राजग_,
   {{0x44317da4,0x6448617a,0xc7c6839d,0x31b20326}},	//   _dsz_, _ġdid, пски, báze_,
   {{0x27ee4026,0xdbd1c5df,0x7536005d,0xe5196046}},	//   álně_, qüèn, _mayz, न्हि_,
   {{0x7c240167,0x656bdda5,0x29d1a1e9,0x6b8b81e7}},	//   _mpir, _algh, _báa_, angg,
   {{0x442c60d1,0x6ba7401f,0x7bdb8f74,0x32182095}},	//   _èd_, _órgã, _etuu, ntry_,
   {{0x2eed8f10,0x8fa38967,0x3947f8ea,0x61d8c6e4}},	//   _geef_, _засе, _anns_, омия_,
   {{0x6d58f62a,0xe8e02081,0x27e05da6,0x66045da7}},	//   _pova, _chịu_, npin_, nrik,
   {{0x21201da8,0x79829da9,0x2fc5a098,0xb4bcc010}},	//   _abih_, liow, _gilg_, _आणी_,
   {{0xdd950013,0x656f000c,0x4432012b,0x7aed1daa}},	//   даны, thch, _asy_, _peat,
   {{0x69c65dab,0x44248435,0xa91dc0e4,0x7bc65791}},	//   _nike, _kpm_, tiže, _niku,
   {{0x65ab6105,0x6609c037,0xdce3a013,0x6234d096}},	//   fühl, cuek, ginė, _целу,
   {{0xe085c049,0xa91dc07f,0x2582e031,0x2d9d80c2}},	//   _تجمي, riže, _délè_, zowe_,
   {{0x200a30c5,0x443afdac,0x69c53dad,0x356b4471}},	//   gubi_, _ép_, _vihe, бран_,
   {{0x7ae44c96,0xf2dfa067,0xe81e22b4,0xdce3a013}},	//   gbit, _đâm_, _पहरा_, binė,
   {{0x89d9413a,0x6d5aa10a,0xdce3a03b,0x7c2d4171}},	// [1c70] زوار_, _oota, cinė, uwar,
   {{0x65a5c009,0x20191dae,0x656d1daf,0x23c320f9}},	//   róhi, mtsi_, _hlah, _déjì_,
   {{0x636b23cd,0x7c2d5db0,0x2d9d9db1,0x80a24010}},	//   _güna, swar, towe_, _कुठे,
   {{0x442dddb2,0x69dc6049,0x23668022,0x63a2cbef}},	//   ywe_, _dtre, gkoj_, _nkon,
   {{0x3a3f803c,0x45d44bbb,0xac0980ff,0x69ca6019}},	//   _qrup_, _пояс, інка_, ífer,
   {{0xb925613a,0x69dd5db3,0x7bc642a9,0x961820e0}},	//   _تفسي, _itse, _ziku, _بغیر_,
   {{0x26173db4,0x6d59c0c2,0x5c0461ba,0x69dc6071}},	//   nço_, _powa, _пята, _gtre,
   {{0xeafb80d0,0x61c8d450,0x5f75c1ac,0x5f77a0e0}},	//   _درست_, रदूष, باتر, _کارر,
   {{0x21201c67,0x69ce7db5,0xf1c70cb5,0xdb0d0057}},	//   _rbih_, _zube, _रंजन, _chaí,
   {{0x21200eb9,0x0667a0e0,0x7aef5db6,0xceb28076}},	//   _sbih_, _ٹائپ, _lect, _יין_,
   {{0x6b5cc0e0,0x6d59d372,0xdb076156,0x6d5b9db7}},	//   _végr, _towa, _ihjä, _koua,
   {{0x69dd410a,0x6b81edc9,0x92ec01a6,0x2240091e}},	//   _otse, silg, কল্প_, _prik_,
   {{0xbf9b201f,0x63702277,0xbcfb1db8,0x7bcf475c}},	//   rrên, _läne, ckém, _nucu,
   {{0x4425a04e,0x2242c065,0x1869f5ea,0xa069f0da}},	//   _kpl_, ække_, _мали_, _мала_,
   {{0x6d893db9,0xc7b2e095,0x7bc65dba,0xdce3a013}},	//   džad, _שבו_, _piku, sinė,
   {{0xb4c99c37,0x200a34b4,0x0410207c,0x20183dbb}},	//   ोडो_, rubi_, াবলী_, rtri_,
   {{0x1da96033,0x03a350ba,0x9ad34079,0x7aee6022}},	// [1c80] कतंत, тито, _aịsa, _pebt,
   {{0x7ae45dbc,0x3aec4067,0x4425a157,0x7e628167}},	//   sbit, ếp_, _opl_, vyop,
   {{0x6371446b,0x6d5b9dbd,0x7afa20c4,0x63a4015a}},	//   _bånd, _boua, óttu, _kkin,
   {{0x290f0156,0xbc6a8243,0xab5d813e,0xdaaa9690}},	//   _ögat_, يمان_, _diżo, овед_,
   {{0x63a9dca1,0x63714277,0x6faf6029,0x2fddc022}},	//   dlen, _sång, _जीवं, _ntwg_,
   {{0x63a400ae,0xf767e33e,0x26ca695d,0x2d9efdbe}},	//   _lkin, _شا_, _ugbo_, xote_,
   {{0x8b036026,0xa2a00621,0x7bce608b,0xdb040049}},	//   _úřad, _गुस्, _uubu, _dhiú,
   {{0x63a9dcab,0x4425a827,0xa3b52028,0x9343862b}},	//   glen, _dpl_, _छीन_, _инсе,
   {{0x3f9ef30f,0xf202a0c5,0x8706ea00,0x3ce68364}},	//   totu_, रूज़_, мяне, mbov_,
   {{0x2d8cfdbf,0x7f5c7dc0,0x2d8000fa,0x2fcfcff8}},	//   unde_, _jorq, _amie_, _dugg_,
   {{0x6441a29f,0xc7c8c016,0xcad2c079,0x69c88009}},	//   _grli, _mối_, _dịrị, _édes,
   {{0x95cb001b,0x63a9ddc1,0xe81fe046,0x4ab280f1}},	//   жува_, clen, _बहरा_, _जराव,
   {{0x9cc800fb,0xe7edc0c5,0x636b20cb,0x29050181}},	//   дыра_, चीदा_, _dünn, ğla_,
   {{0x2ca7e0e2,0xdb0d0057,0x61e28425,0x212b1dc2}},	//   _fynd_, _viañ, ipol, sech_,
   {{0x394d600a,0x776d00b6,0x3ead4098,0x4425a0ae}},	//   _đes_, _tlax, _šet_, _xpl_,
   {{0x656d1603,0x7bc76296,0x4426c088,0x3f84ddc3}},	//   _ulah, _siju, _kpo_, nimu_,
   {{0x200ce17a,0x7bc77dc4,0x8afee0e8,0x8f0ea0a8}},	// [1c90] ludi_, _piju, _alƙi, _सांझ_,
   {{0x2ca91dc5,0xdb0f4019,0xb87b5dc6,0x9f5f0049}},	//   _iyad_, _picó, _seís, irtí_,
   {{0x63a9ddc7,0x63bbddc8,0xd7f8e12a,0x63a0d02d}},	//   ylen, ymun, nsă_, komn,
   {{0x7afd4a2f,0x2fc90022,0x63a9c926,0x69c76939}},	//   _udst, _jiag_, xlen, _wije,
   {{0xba7460d0,0x2d84ddc9,0x7bc77dca,0x7c2227a0}},	//   _یافت, dime_, _tiju, _ćori,
   {{0x6d5ce156,0x660d4546,0x236945dd,0x4425b8af}},	//   öral, muak, lkaj_, _ppl_,
   {{0x9f422066,0x60cd0ee2,0xdca2a423,0x63bbddcb}},	//   jský_, _ogam, лаши, tmun,
   {{0x7bc8bdcc,0x7af52265,0x3ddea0ae,0x69d5e066}},	//   _eidu, hazt, _dttw_, ízem,
   {{0x7e99a050,0x63a3e05d,0x2d9fcaaa,0x61ed0291}},	//   _کنار_, _pknn, roue_, _nwal,
   {{0xdce99019,0xdbdcc069,0x3ea7e271,0x6366007b}},	//   _mleč, ráðh, _pynt_, _ióni,
   {{0x660d41f3,0x1ae7007c,0xc625c07c,0x6442c2dd}},	//   huak, _কাজে_, বিধা_, _eroi,
   {{0xfaff000e,0x25a0405d,0x61ed011d,0x7bc8bdcd}},	//   dhës_, xoil_, _bwal, _zidu,
   {{0x60db8296,0x6d8926a6,0x27ed80d1,0x752d40ba}},	//   _mfum, džab, _jwen_, deaz,
   {{0x2571c026,0x60cd0ee2,0x7539c0e8,0x997180c2}},	//   _dále_, _egam, _hawz, nął_,
   {{0xdfd2213a,0x27ed80d1,0xd7be4010,0x1fb64f6f}},	//   اير_, _lwen_, ्दलच, есар,
   {{0x6d4bc07d,0x7dc7c0e0,0x7f5d42a8,0x6569ddce}},	//   _jnga, _műso, _cosq, nkeh,
   {{0xb910a079,0x6aa98291,0xf1ca0119,0x8c1401a6}},	// [1ca0] _celụ_, _nyef, _nại_, িবহন_,
   {{0x3f84d1c7,0xd29b0095,0x4427eabb,0xba9b0008}},	//   zimu_, _משפט, _kpn_, _מספי,
   {{0x61fb9dcf,0x2619c067,0xdce44098,0x69c98071}},	//   _avul, hèo_, lkič, _biee,
   {{0x76441dd0,0x69c98037,0xd6c48050,0xf1ca0067}},	//   _kriy, _ciee, نمای, _bại_,
   {{0xdce98143,0x7bc8a046,0xb17b6831,0x6366007b}},	//   _gleč, _pidu, _ståe, _cóni,
   {{0xf8af40e0,0x5bbe4291,0x81be4125,0x29be4125}},	//   _چکے_, _ọchị_, _ọchọ_, _ọchụ_,
   {{0x5334c14a,0x29001dd1,0x4426ddd2,0x6d5d5dd3}},	//   вейт, _odia_, _spo_, _yosa,
   {{0x63661935,0x69c8bdd4,0x5bc8eafa,0x6da3c5da}},	//   _fóni, _wide, रद्व, лија,
   {{0x200dc01b,0x63a29dd5,0xadc36016,0x443241cd}},	//   guei_, moon, _hoạc, nwy_,
   {{0x9f42205c,0x6d5e39ff,0x02e0ddd6,0xbf9b2004}},	//   tský_, _nopa, _ग्रह_, trêm,
   {{0x661c207f,0x661bc108,0x69d6400e,0x66e3a0fb}},	//   jtrk, atuk, hqye, _соха,
   {{0xe0dfa016,0x395ea108,0x76440157,0x6b86008b}},	//   _đòi_, _hots_, _briy, gikg,
   {{0xb51060aa,0x22404143,0x7644018c,0x38c906ec}},	//   ालाय_, jvik_, _criy, بادی_,
   {{0x65b06105,0x4427e361,0x6033a5fc,0x76440827}},	//   wähn, _fpn_, _səmə, _driy,
   {{0x1fa71537,0x2fc90ca1,0x76441dd7,0xf20426fc}},	//   _приг, _tiag_, _eriy, лято,
   {{0x7af6408b,0x76440489,0x753aa534,0x5ba96260}},	//   gayt, _friy, _latz, कत्व,
   {{0x6aaae0e2,0x4ea701ba,0x2a668022,0xa2be679e}},	// [1cb0] _hyff, _ярка, jyob_, वेस्,
   {{0xdce98cfd,0xf1bf0057,0x752f00c2,0xe1cfe7f4}},	//   _vleč, lmá_, lecz, _सूँघ,
   {{0x443fc326,0x7bcae296,0x27ed80d1,0x61fc6361}},	//   zvu_, _mifu, _swen_, _cvrl,
   {{0x752f00c2,0x3eaa622e,0x6d5e2530,0x69cafd37}},	//   necz, _dybt_, _zopa, _life,
   {{0x22404066,0x6d5e2071,0x72ec0053,0x7ae482a8}},	//   cvik_, _yopa, פֿאַ, ñita,
   {{0xdb1ac005,0x6b82ce9a,0xdb00caed,0x7bcae9e7}},	//   _outó, _amog, lomè, _nifu,
   {{0x753aba02,0x98a7e04a,0xa5bb2057,0x63a29dd8}},	//   _datz, _daně_, ptóf, boon,
   {{0x60db8167,0x6ed54077,0x6724a055,0x672f0320}},	//   _ufum, युचु, đija, jecj,
   {{0xe89480ff,0xa535a81b,0x7bcae2ad,0x67d582cb}},	//   _бать, _инач, _bifu, _розу,
   {{0x4427fdd9,0xdcfae12a,0x290120ae,0x0b42e0db}},	//   _ppn_, vită, _ndha_, аньн,
   {{0x1d0a04c2,0x3f85fdda,0x753b8066,0xa50a0242}},	//   мени_, rilu_, _kauz, мена_,
   {{0x2d91214a,0x6e298291,0x7c298088,0x661d0a7b}},	//   enze_, _kpeb, _kper, ftsk,
   {{0x61e4e29c,0x9f5f004e,0x2d82405d,0x8afee35f}},	//   _čile, yttö_, _rmke_, _alƙu,
   {{0x320953e8,0x61e44041,0x6b82d330,0x61fbdddb}},	//   dray_, vpil, _zmog, msul,
   {{0x7bcbc9ae,0xfaa62470,0x25ee0046,0x661d0aaa}},	//   _kigu, таво, _अबकी_, atsk,
   {{0x63ad5ddc,0x98a76026,0x76441dd9,0x7ae9dddd}},	//   glan, žně_, _triy, nbet,
   {{0x3f8689fe,0x0e6353fc,0x60db6143,0x764400b1}},	// [1cc0] viou_, актн, _đumr, _uriy,
   {{0xbef20010,0xbc663116,0x9c12f1b0,0x22405dde}},	//   _अजुन_, _авок, _mọnd, rvik_,
   {{0xa2a2448b,0x1c09eaa1,0x5a9622a3,0x60cf4057}},	//   _कुर्, _विफल_, _шриф, _fgcm,
   {{0x395f87f7,0x32095ddf,0x61fbdde0,0xafe680db}},	//   _cous_, bray_, ksul, водл,
   {{0x673abde1,0x69cb0026,0xdbdf7de2,0x394ca0a2}},	//   _patj, _संघी, _bíót, _pnds_,
   {{0xa3b654ac,0x69cbc81f,0x7c299de3,0x77b8803e}},	//   _चीत_, _aige, _dper, díxe,
   {{0x7bcbc5d2,0x3c3ca04a,0xf78381f6,0x2fda60eb}},	//   _bigu, dává_, _baħħ_, _آورد_,
   {{0x4734ca18,0x60cde106,0x2ef820cb,0x200ea1b8}},	//   унис, _şamp, harf_, rufi_,
   {{0x442a6299,0x2d848098,0x1b0a207c,0xaca48088}},	//   _hpb_, _imme_, শ্যই_, _kpọp,
   {{0x7bcbc0c4,0x6d4d0aaa,0x2002c03b,0xed5986ca}},	//   _eigu, _snaa, škio_, _dižu_,
   {{0x2ef82105,0x6376e12a,0x637146dd,0x7bcae167}},	//   darf_, _lâng, _låna, _vifu,
   {{0x66e6c02d,0xf4136095,0xdce1e041,0x661d088b}},	//   _рода, ספר_, rklā, ttsk,
   {{0x63ad48ef,0x76429de4,0x69cae0f7,0x261c6057}},	//   vlan, nvoy, _tife, hío_,
   {{0x61edc6df,0xdb00cc7c,0x20094cc2,0x660f1393}},	//   _çala, domé, vrai_, ruck,
   {{0x7987200f,0xa2c043af,0x08f1607c,0x2246c012}},	//   rijw, लेस्, _চালু_, _hrok_,
   {{0x261c61af,0x81bcc041,0x6d4d0167,0x2fc04c57}},	//   dío_, _spēj, _unaa, gmig_,
   {{0xc05b014f,0x201efde5,0x32094025,0xdb00d890}},	// [1cd0] _цій_, ltti_, uray_, romè,
   {{0x261c61af,0x6603606f,0xf77364a1,0x201efde6}},	//   fío_, ánko, جار_, otti_,
   {{0x0ccb8aa1,0x395f9de7,0x02cb8028,0xe8cb81c9}},	//   िश्म, _pous_, िश्न, िश्च,
   {{0xd6db80ff,0xc477e076,0xe9f98488,0x20094425}},	//   єте_, כתבו_, енді_, prai_,
   {{0xf41f18cf,0xdb00c03e,0xdce2c23d,0x64464143}},	//   ntä_, comé, _zloć, _grki,
   {{0x7d02dde8,0x4639a1fc,0x7bcd0013,0x2126c18c}},	//   _ados, ечия_, _liau, _aboh_,
   {{0x2bda0aa1,0xb5958657,0x7bcbdde9,0x673d4424}},	//   _यूना, _бивш, _pigu, _kasj,
   {{0x229460ff,0x64464232,0xdced004d,0xe9a9c050}},	//   _тися, _yrki, _blač, رگان_,
   {{0x05848013,0x63a3a653,0x7bcbddea,0x753d4367}},	//   _турм, ponn, _vigu, _masz,
   {{0x6b840306,0x7ae6c121,0x2d87a6ff,0x27fe206e}},	//   _smig, ıkta, qine_, štni_,
   {{0xb4bf27f4,0xcb68a050,0x1869eb15,0xfb15c7f0}},	//   ेशो_, _جمله_, хани_, _مواج,
   {{0x6aad0bb1,0x7bcd0618,0x2a6940ae,0xceb26679}},	//   _byaf, _ciau, kyab_, מיי_,
   {{0x291e00c2,0xe44ec691,0xa2aa604b,0x2ef820c4}},	//   ęta_, _уж_, _जुन्, tarf_,
   {{0xdcef0041,0x69dcbdeb,0x7989d308,0xdee2e762}},	//   ficē, _érec, liew, _лоши,
   {{0x2d925dec,0xd011e13a,0x7bc1e105,0x46a42033}},	//   tnye_, _الع_, mmlu, _खुशह,
   {{0xb8864026,0x7989c064,0x6366003e,0x442a605d}},	//   hlíž, niew, _cónt, _rpb_,
   {{0xc7a901ac,0xdce40098,0x637849fe,0xc72660fb}},	// [1ce0] _جدول_, _alić, _líng, лдай,
   {{0x7bd57ded,0x2011211d,0x69d57dee,0x63bb8f60}},	//   _buzu, buzi_, _buze, _ahun,
   {{0xbb468a2b,0x201fc052,0x68f60025,0x4f0a8a2b}},	//   лежк, htui_, _keyd, енен_,
   {{0x14c88050,0x753c60c2,0x7c2bd9cf,0x9990806f}},	//   نهای_, _warz, _opgr, ťaži_,
   {{0xe918a12e,0x69d600e8,0x7bd600a2,0xef218018}},	//   волі_, _juye, _juyu, daļā_,
   {{0x6d4e7def,0xd838a066,0xdb0d000e,0x3326c0ae}},	//   _unba, _psč_, _thaç, _sbox_,
   {{0x63660069,0x6fba4626,0x8026a050,0x2a3561fc}},	//   _jóns, ्षपू, ارتم, _кэтр,
   {{0x7d0409ca,0x75245df0,0x6b88f2d4,0x5e9364c7}},	//   _ndis, nfiz, widg, _الفط,
   {{0xb716a13a,0x3494c866,0x3a204b10,0x6d89229f}},	//   _مباش, рапр, ntip_, džan,
   {{0x7bd57df1,0x90d5a067,0x61e2206e,0x37e3c07c}},	//   _yuzu, _hàn, _čoln, _মিশর,
   {{0xdb55004e,0x69d600a2,0x7bcd01ae,0x63784071}},	//   авны, _auye, _piau, _kínd,
   {{0x38694605,0x998963ed,0x7d040004,0x442ca06e}},	//   yyar_, ktaş_, _cdis, _ipd_,
   {{0x6448a066,0x442cbdf2,0x7afdc0c4,0x644ea057}},	//   _hrdi, _hpd_, ðste, _ábib,
   {{0x68e9600a,0xf487c062,0xdb03a017,0xa666e25b}},	//   _đedo, _حامی, gonè, _مطبو,
   {{0x63a61697,0x3f8941cd,0x6366007b,0x6376eb67}},	//   bokn, tiau_, _cóns, _vând,
   {{0x3d0f4077,0xb4db40d5,0x673d43ac,0xd90ee6ec}},	//   िलें_, _anàr, _qasj, _بیگ_,
   {{0x3f8b1df3,0xa3da6033,0x3d9520ff,0x32555342}},	// [1cf0] micu_, _डूब_, _випр, швар,
   {{0x3dcd8efb,0x70d1d008,0x6448aea3,0x66cbc786}},	//   _siew_, _हल्ल, _ordi, _hökü,
   {{0x63bb9df4,0xdcfbc143,0x64445df5,0x6561a1de}},	//   _phun, znuđ, avii, _rolh,
   {{0x7c2d0088,0x973ce0a9,0x636ec2f4,0xdb044057}},	//   _kpar, koćo, _bùnm, pliá,
   {{0x442b5646,0x21291104,0xf8078d24,0x7afafdf6}},	//   _upc_, _mbah_, учен, katt,
   {{0x69cf420d,0x443a20ae,0x68f981cd,0x68ed5df7}},	//   _hice, _ysp_, sawd, lbad,
   {{0x27e9590a,0x69cf4361,0xf99f6157,0x539a6557}},	//   lpan_, _kice, _avèg_, _יישו,
   {{0x68ed5df8,0x290ae0e0,0x201fc052,0x7bd72025}},	//   nbad, óban_, ttui_, _muxu,
   {{0x27e9523e,0x316dd2f7,0x7989d6cc,0x3075c20e}},	//   npan_, rkez_, riew, руйс,
   {{0x0c25e0fb,0x671ca861,0xb225e056,0x2bd84028}},	//   амон, _नायक_, амол, _भंसा,
   {{0x8af04497,0x3f8b02e2,0x44216095,0x69d6048d}},	//   rkəz, ficu_, nth_, _suye,
   {{0x186a0955,0x64434041,0x2d8b1df9,0x68460be0}},	//   вами_, ānij, gice_, анма,
   {{0xdd95e02d,0x66cbc106,0x63a61dfa,0x7afbd952}},	//   _кады, _dökü, rokn, maut,
   {{0x213f8058,0xcf92a00b,0x63a61dfb,0x290c05fc}},	//   _lauh_, ַטן_, sokn, şda_,
   {{0x673f00dd,0x3f8b0552,0x6b6641e1,0x7c3aa1e2}},	//   _faqj, bicu_, аква, _xstr,
   {{0x3f8b029f,0x68ed5dfc,0x64499dfd,0x7a40a0e0}},	//   cicu_, gbad, _orei, látá,
   {{0x39405747,0xe0434662,0x433b0053,0x69d72057}},	// [1d00] rdis_, онти, _יעקב, _euxe,
   {{0x01fb0053,0x2fcfc488,0x7abb0095,0x888627f8}},	//   _שפיל, _ligg_, _בצפו, _влож,
   {{0x27e94820,0x68ed5dfe,0x68fbc6eb,0x69cf5dff}},	//   apan_, bbad, kaud, _fice,
   {{0x7afc28c1,0x3940405d,0x61e9c05d,0x7bcf400f}},	//   lart, qdis_, kpel, _gicu,
   {{0x68fae5fc,0x44204025,0x97c6afb9,0x9ea78338}},	//   yatd, qti_, айде, авца_,
   {{0xc5ebe07c,0x69cf45b8,0x6563e1b7,0x645ce59f}},	//   _কিনা_, _zice, _nonh, ärik,
   {{0x9cd72095,0x20136037,0x61e9ce9b,0x76498bbe}},	//   בוצה_, cuxi_, epel, _erey,
   {{0x63a7200e,0x2904868e,0x2cafc488,0x28c70328}},	//   zojn, _udma_, _bygd_, रेडि,
   {{0x6563fe00,0x7763e057,0x4973c0ff,0x44200223}},	//   _bonh, _bonx, ільс, _nqi_,
   {{0x2509054f,0x20004054,0x69c45e01,0x65b060cb}},	//   گردی_, isii_, hmie, fähi,
   {{0x3eb8e94b,0x7c2d1e02,0x68fbcaf1,0x9f5d6050}},	//   årt_, _spar, baud, éwé_,
   {{0x200dde03,0x7c2d18d0,0x29182071,0x65b6004a}},	//   brei_, _ppar, egra_, sáhn,
   {{0x69d73e04,0x7afc3e05,0x63a720dd,0x442d817b}},	//   _suxe, fart, tojn, _xpe_,
   {{0x69d728aa,0x7c229e06,0x7c2d9e07,0xd6d0e7f0}},	//   _puxe, itor, çari, _عقب_,
   {{0xe1ff1e08,0x7c229e09,0x2b4006f1,0x29dc2019}},	//   ssó_, htor, _faic_, _cía_,
   {{0x3f8cec43,0x224d66ca,0x394007bc,0xb4b727fa}},	//   lidu_, _ček_, _gais_, _जरी_,
   {{0x76b9487e,0x3eaf51df,0x224911e1,0x98b948ba}},	// [1d10] улар_, ægt_, _urak_, улат_,
   {{0xdb03a359,0x68fd1e0a,0x201e25df,0x7af8e5f9}},	//   poné, lasd, àtic_, _jevt,
   {{0x533548f4,0x637844c7,0x39400022,0x2ef86071}},	//   _лент, _síne, _yais_, _derf_,
   {{0x7bd8efda,0x2d8cf49c,0x39400286,0x3d19610a}},	//   _muvu, hide_, _xais_, _पावे_,
   {{0x443cfe0b,0xb6044866,0x7c229e0c,0x3f8ce6ca}},	//   _lsv_, _мярк, gtor, kidu_,
   {{0x63ad00ae,0x2a3a4053,0x6b8b9e0d,0x77b88057}},	//   _lkan, _געשמ, sigg, ríxa,
   {{0xa91dc20d,0x6563e00a,0x65ab6105,0x44390048}},	//   liži, _ronh, bühr, hws_,
   {{0x200dc6ab,0x7c3b91f8,0x9ad34088,0x76499e0e}},	//   trei_, _tsur, _aịza, _trey,
   {{0x68fc3e0f,0x7e6d5e10,0x443ce041,0x644afe11}},	//   yard, nyap, _asv_, _arfi,
   {{0x02a7a3a5,0x27ffc0b0,0x6374a090,0x442ee05d}},	//   _крем, rsun_, _tàna, _bpf_,
   {{0x6d8922e2,0x69c57838,0x798d4820,0x442ee1ae}},	//   ržal, imhe, kiaw, _cpf_,
   {{0x320dc090,0xf1bf4067,0x2902c009,0x6375d9f9}},	//   prey_, _nhá_, ókat_, _fána,
   {{0x657ae256,0x6375c071,0x9cdac00b,0x63a9c155}},	//   bhth, _gána, _עקספ, moen,
   {{0x1ddb4064,0xdee32a61,0x7e6d5b14,0x395fc241}},	//   _बढ़त, зори, dyap, ljus_,
   {{0x4807265a,0x5f74e7f0,0x3eaae066,0x6e2f4030}},	//   йерн_, _ظاهر, čité_, _apcb,
   {{0x4422007d,0x659305da,0x6b8d5e12,0x7bd9cfae}},	//   ptk_, _нају, giag, _kuwu,
   {{0x753534b7,0x9f5f0066,0xf53f0262,0x7c2284cf}},	// [1d20] bezz, nutý_, rlåt_, xtor,
   {{0x799b9e13,0x65bd00e1,0x8afee0a2,0x75353c47}},	//   _ajuw, réhe, _koƙa, cezz,
   {{0x2ef86110,0x32020089,0xfbd260a4,0x07a644a0}},	//   _verf_, lsky_, ستا_, _ганн,
   {{0xdb00c1af,0x61fca271,0x3f89005d,0x2ef86854}},	//   tomí, _ærli, _xmau_, _werf_,
   {{0x25bf9e14,0xdb01a1ce,0x0b8aa1c7,0xdce28098}},	//   _dhul_, _sklá, лски_, hkoć,
   {{0x3940803b,0x7c245e15,0x64586052,0x68e2c197}},	//   žis_, mtir, ävis, _sfod,
   {{0x63ae605d,0x6146968a,0x63ab2057,0x7afe7356}},	//   _ikbn, _лева, _ígne, mapt,
   {{0x637cc18c,0x63a9c265,0x656640a2,0x8d9684c7}},	//   _méng, goen, _jokh, _الرش,
   {{0x26182033,0x6d445e16,0xb4d8c573,0x6719c148}},	//   बूती_, idia, _ाली_, _धारक_,
   {{0x7ae40132,0x291a6da1,0x32021e17,0x7c3e23c1}},	//   _afit, ngpa_, dsky_, _ospr,
   {{0xdb1c7b06,0x649aa4c2,0x644bde18,0x9999001b}},	//   _chré, _стар_, _ergi, икот_,
   {{0x65664174,0x63a8f6c7,0xf651a0e0,0x248041f3}},	//   _nokh, sodn, _کئے_, kzim_,
   {{0x6b8d4aa5,0x7bdabe19,0x644bc2c9,0x7a4320e0}},	//   viag, _hutu, _grgi, kítá,
   {{0xdcebacb1,0xd943e87e,0x6143e87c,0x637cc187}},	//   čići, _нечи, _неча, _béng,
   {{0x2366c048,0x443ebe1a,0xf773e076,0xc058219d}},	//   _kooj_, _jst_, _מקס_, біт_,
   {{0x2002129e,0x7c245e1b,0x636dea60,0x349500fb}},	//   bski_, ftir, _rúni, _майр,
   {{0x657d013a,0x2fc6829c,0x7d08accd,0xf53f10dc}},	// [1d30] mhsh, dmog_, _odds, slås_,
   {{0x68fab4b2,0xa91dc07f,0x29f680c2,0x6b8d5e1c}},	//   _netd, riži, dła_, siag,
   {{0x3a3ea0c7,0xdb0d4049,0x63a9c167,0x93e0204b}},	//   _nstp_, llaí, yoen, _खूपच_,
   {{0x69c08089,0xdce08030,0xdb01f945,0x637da011}},	//   _chme, _fomč, volí, _kèng,
   {{0x3f8dc017,0x2d991e1d,0x29f680c2,0x6374a0b8}},	//   vieu_, inse_, gła_, _càno,
   {{0x1be9a702,0x63aaa1cd,0xd5afa0e0,0x3cfd8022}},	//   адки_, gofn, رہا_, sawv_,
   {{0x69d9de1e,0x39424037,0x6b9b86dd,0x2e48614a}},	//   _suwe, _yaks_, _tjug, _лято_,
   {{0xdb03a1af,0x6009de1f,0x636b2105,0x249f8022}},	//   moní, аним_, _küns, _txum_,
   {{0x2ca9a064,0x7afab5d5,0x44399e20,0x644d1e21}},	//   ład_, _fett, _ès_, _nrai,
   {{0x9397a25b,0x68faa03c,0x98ba2041,0x7afaa095}},	//   _اجرا, _getd, _lapā_, _gett,
   {{0x6444c00a,0x7c244108,0x6fe1807c,0x7dc02009}},	//   _šiit, ztir, _নিয়ে, nöse,
   {{0x3a98e04e,0x443f81f6,0x3cca01c7,0x69d820e1}},	//   стью_, _ksu_, илно_, _évei,
   {{0x6566448d,0xdce4400a,0x7afe7e22,0x637cc011}},	//   _rokh, lkić, yapt, _dénd,
   {{0xc17420e8,0x7c3bc229,0x65b06134,0xdb1c6049}},	//   _buɗa_, mwur, näht, _thré,
   {{0x21294058,0x7f43f615,0x7a4320e0,0x09e329b1}},	//   ffah_, _ianq, vítá, досн,
   {{0x22460381,0xaca38079,0x6d557e23,0x61e98a88}},	//   _šoku_, _adọn, _anza, _otel,
   {{0xa76665a8,0x61e980ee,0x63ab8425,0xdb0d4049}},	// [1d40] окад, _ntel, dogn, claí,
   {{0x7f4445fc,0x201126a6,0x27edde24,0xaade2292}},	//   sdiq, brzi_, ipen_, _मलिक,
   {{0xee3a6461,0x3942592f,0x95869479,0x2d8f9e25}},	//   рне_, _taks_, олже, fige_,
   {{0x6d4574a1,0x224d9113,0x7afb8019,0x2d8f9e26}},	//   adha, _brek_, _ceut, gige_,
   {{0x27edc200,0x4fc6af6f,0xa3d48148,0x29005273}},	//   jpen_, оска, _सूख_, maia_,
   {{0x2d99e07b,0x443ea222,0x7d098052,0x2ca0817a}},	//   ésel_, _pst_, _edes, ħid_,
   {{0xdb00c5df,0xd37ac64b,0x2366c048,0xdce1a381}},	//   tomà, ичи_, _pooj_, _golč,
   {{0x93bcc1fc,0x3f8f86ca,0x644e7e27,0x69c1a1fb}},	//   _apăr, cigu_, _irbi, _ehle,
   {{0x6d43fe28,0x68e44057,0x69daa088,0x2e2400c4}},	//   _bana, icid, _wute, jöf_,
   {{0x64408c0a,0x543b849c,0xdb1aa01f,0xd6dafe29}},	//   _ismi, _דעמא, _vitó, шти_,
   {{0x6d44026f,0xb87b4019,0x973ce0a9,0x637cc07b}},	//   _baia, _afíl, noći, _pénd,
   {{0x9e66c4aa,0x44cee03c,0xd62ad2ad,0x9f5140e0}},	//   _واشن, rə_, _воде_, sszú_,
   {{0x7afc74bf,0x798f1e2a,0x637f03ac,0x4346f876}},	//   _oert, ricw, _lëng, _медв,
   {{0x98b9412a,0x7afc7e2b,0x291ca013,0xd378c012}},	//   _lasă_, _nert, ngva_, _duće_,
   {{0x44cee03c,0x984821e1,0x938b4c1e,0x39437af9}},	//   qə_, оята_, асаа_, _rajs_,
   {{0x6d56008b,0xdb0d4765,0xab5da0c2,0x63b6411e}},	//   _gnya, gmað, _duży, glyn,
   {{0x644d14d7,0x64410041,0xe87c43cd,0x439521e1}},	// [1d50] _urai, ālis, rüşü, _наис,
   {{0x344b64a9,0x3946801f,0x4431605d,0x3a3f8037}},	//   ичен_, edos_, _ppz_, _rsup_,
   {{0x77b06156,0x27edc265,0x64408b81,0xbb3a2076}},	//   växt, zpen_, _asmi, _העתי,
   {{0x7bc8e058,0x883a2095,0xe9d860db,0xf538000b}},	//   hmdu, _פתרו, ікі_, ַטור_,
   {{0x68fc7e2c,0xdee5a399,0xdb0982d9,0x316900a2}},	//   _ferd, поли, _bheò, _moaz_,
   {{0xdb01e4d3,0xa3dede2d,0xe739b342,0x63ad5652}},	//   kolá, _दूध_, сек_, loan,
   {{0xe4e4a139,0x6b8d1366,0xddc9e064,0xdb1c6005}},	//   фічн, _omag, rzeż, _eiró,
   {{0x7bc2c653,0x69dd49fa,0xb4bba2cd,0x03a8c13a}},	//   _chou, _kuse, _घरी_, يديو_,
   {{0x7529cfdc,0x98bf8a7e,0x7bd56bf7,0x6fab279e}},	//   rfez, _kauč_, _kizu, चकां,
   {{0x8d77a25b,0x637f000e,0x0577a1ac,0x7bdc6054}},	//   _بارا, _lënd, _بارد, _yuru,
   {{0xa91d803b,0x29d761d7,0xcea90053,0x6aa2c037}},	//   _amži, _għat_, _עי_, _exof,
   {{0x20191e2e,0xb92381e9,0x65b06105,0xcf8920be}},	//   fusi_, _aarẹ_, nähr, _גט_,
   {{0xee2eccde,0x64486057,0x2138205d,0x46abe10a}},	//   _ян_, _ádiv, terh_, _घुरह,
   {{0x32182a2a,0x7c2618e8,0xd378c012,0x65698090}},	//   tury_, rtkr, _vuće_, _loeh,
   {{0x3079e00b,0x63ad41fc,0x3ebe2551,0x69dd5e2f}},	//   _לאַנ, foan, ått_, _ause,
   {{0xa0a60de7,0x644f4098,0x18a602cb,0x06ab207c}},	//   _найд, _brci, _найм, _গৃহি,
   {{0xdb0d4069,0xdca350da,0x69d56f60,0x29005b95}},	// [1d60] rmað, еати, _bize, raia_,
   {{0x645ce0ac,0xdb0d40c4,0x6d453e30,0x69dd5e31}},	//   årig, smað, _gaha, _duse,
   {{0x7bd56265,0xdce2c07f,0x7d00de32,0x11d660eb}},	//   _dizu, _sooč, yams, ستاد,
   {{0x7bdd5e33,0xdb1c6b34,0xa3e44029,0xdb1d4057}},	//   _fusu, _piró, _पंप_, _disó,
   {{0x6568bd5c,0x29017e34,0x69d60d72,0x7bdd400f}},	//   _podh, baha_, _miye, _gusu,
   {{0xa3c2e295,0x2d8d8125,0x636de03e,0x6d45217a}},	//   ्दछ_, _emee_, _xúnt, _xaha,
   {{0x3945a4cf,0x644e7e35,0x62828048,0xb8f4a48b}},	//   _dals_, _urbi, szoo, _सः_,
   {{0x69c40016,0xdb1c6019,0x7e9b6095,0xdb01e326}},	//   _nhie, _tiró, _הסלו, volá,
   {{0x2007fe36,0x69dd4054,0x321a6066,0x6568a351}},	//   _avni_, _xuse, lupy_, _todh,
   {{0x29d761d7,0x69d602f4,0x7d00d02d,0x63ad51c6}},	//   _għas_, _aiye, sams, zoan,
   {{0xdb18e066,0x69c40090,0x636ec090,0x25add2da}},	//   _chvá, _bhie, _bùnt, boel_,
   {{0xdc2ac050,0xba2ac0eb,0xe6950052,0x7bd60827}},	//   _هسته_, _هستم_, димы, _ciyu,
   {{0x6fd6446f,0x2be4a07c,0xe9ff8067,0x7bd6036d}},	//   _मंजू, _গিয়ে_, _trấn_, _diyu,
   {{0x3d172021,0x645ce1dd,0x2139000e,0x62844b6b}},	//   तलें_, äris, sesh_, dzio,
   {{0x20191e37,0x4ea42adc,0x213900dd,0xae1d238e}},	//   susi_, ерта, pesh_, बंधन_,
   {{0xe3b8e6df,0x798d1e38,0x201a6341,0xdbd6e04e}},	//   llı_, _umaw, dupi_, sään,
   {{0x29017419,0x6f029e39,0x7f45205d,0x7ae571c7}},	// [1d70] taha_, daoc, _tahq, tcht,
   {{0x63ad5e3a,0x201a6167,0x673afe3b,0x261c4028}},	//   soan, fupi_, netj, मढ़ी_,
   {{0x2d925e3c,0x7ae57385,0x69d57e3d,0x63ad5da1}},	//   biye_, rcht, _vize, poan,
   {{0x6442c04e,0x7bdd5e3e,0x2d925df1,0xe3b8e602}},	//   _osoi, _tusu, ciye_, hlı_,
   {{0x3945b607,0x644f4261,0xb9058028,0x272fa19f}},	//   _pals_, _urci, _नल_, yını_,
   {{0x6722c2a8,0xdb1e2017,0xb8834066,0x673af7e9}},	//   _acoj, _hipò, rníč, jetj,
   {{0x25adc54c,0x7642c0f9,0x7ae60156,0x644d5e3f}},	//   toel_, _asoy, yckt, lvai,
   {{0x61ed1e40,0xe1ff0b0a,0xe7bf4c4c,0xa3dec077}},	//   _otal, nyós_, ्षिप, _दंश_,
   {{0x69c401cd,0x39495e41,0x799bd4a5,0x290d9e42}},	//   _rhie, idas_, rnuw, _idea_,
   {{0x69d73e43,0x8e09e95a,0xeaf8a050,0x291ee05d}},	//   _nixe, онов_, _فرمت_, ggta_,
   {{0x6f01e06e,0xaca34096,0x7d01e654,0xa3ad42cd}},	//   ralc, _baịb, rals, गवा_,
   {{0x3946c057,0xe8dfc079,0x6f01fe44,0x32090030}},	//   _gaos_, _kpọm_, salc, _bvay_,
   {{0xe3aee362,0xd469c3d5,0x60db80ce,0x8c45de45}},	//   _аб_, _филе_, _mgum, _целе,
   {{0xdb1c613a,0x2d92597d,0x657d4025,0x81e5207c}},	//   _phrí, wiye_, _alsh, _নিজ_,
   {{0x60db8035,0xb9063e46,0xd6f5407c,0x2d805b7c}},	//   _ogum, _फल_, _ছাড়া_, thie_,
   {{0x7d03aa0c,0x69c52009,0x78a4005f,0x660982f9}},	//   hans, _ehhe, _txiv, _ovek,
   {{0x65644d3d,0x656bce90,0x61e4e64e,0xb8d52026}},	// [1d80] rjih, _mogh, _čili, _छु_,
   {{0x753bc0c7,0x7644066b,0x637cce41,0x656bde47}},	//   heuz, _isiy, _ména, _logh,
   {{0x2d805b7c,0xa6ca20d0,0x637ffe48,0x443fc058}},	//   phie_, _گوگل_, _gêne, hwu_,
   {{0x661c29c0,0xe3b8e3ed,0x673c3e49,0x442a22a8}},	//   murk, zlı_, lerj, mtb_,
   {{0xd90d8896,0x661c2820,0x2900001f,0xb8f68010}},	//   صیل_, lurk, _meia_, _सण_,
   {{0x6f0458ea,0x29001134,0x2738c016,0xc1a8a010}},	//   laic, _leia_, _ẩn_, गवेग,
   {{0xa3c1f775,0x20068197,0x3ce6802e,0x69d84009}},	//   ंतन_, ssoi_, pcov_, _éves,
   {{0x64440f74,0x071e6033,0xdd99a030,0x44443404}},	//   _osii, _पाँव_, _awňd_, _ms_,
   {{0x6f03be4a,0xe3b8e3df,0xb4db40f9,0xa2d0e6e1}},	//   banc, tlı_, _baàj, डेन्,
   {{0x661c2dc9,0x61ed0187,0x64486057,0x290ca156}},	//   kurk, _rtal, _ádis, _udda_,
   {{0x660982e2,0xd5afd06d,0xe3b8e3df,0x44295e4b}},	//   _zvek, _ас_, rlı_, zta_,
   {{0x61e09e4c,0xe3b8e315,0x27e01e4d,0x2d9e4009}},	//   _kuml, slı_, _buin_, étel_,
   {{0x6f045e4e,0x63af04f3,0x6b9d0156,0xe4e720ff}},	//   daic, rocn, rnsg, дібн,
   {{0xd250e09b,0xe8e00119,0xc05805d0,0x60c2de4f}},	//   _منت_, _muội_, фію_, _izom,
   {{0x29001bd3,0x8d77413a,0x356b5e50,0x6d892098}},	//   _feia_, وارا, оран_, džat,
   {{0x69d8f890,0x6f008559,0x657e2090,0x63a2c037}},	//   _hive, _nemc, _elph, _jjon,
   {{0xfbdf5e51,0x644d40fa,0x8cc4c0c2,0x27e009f2}},	// [1d90] _quê_, uvai, ाइटो, _guin_,
   {{0x7dc02156,0x644d5e52,0xdb1c62d9,0x60c01e53}},	//   lösn, rvai, _chrà, ümme,
   {{0xdb1c7e54,0xa3e44cb5,0x39491813,0x6d49c1e2}},	//   _virð, _पंथ_, _kaas_, ydea,
   {{0x6d48a24f,0xf9d9e00b,0xc7b9000a,0x63a2de55}},	//   _aada, פֿעל, buđe_, _njon,
   {{0x7c29dd81,0x31a403df,0x69cb8c94,0x201b403c}},	//   xter, nıza_, rmge, quqi_,
   {{0x39491e56,0x63a2c052,0x637da0ca,0x7bd8ebef}},	//   _laas_, _ajon, _bèna, _nivu,
   {{0x3ce08066,0xbbbd68b1,0xe057a050,0x2fc6c6f1}},	//   živa_, ्गीक, بیات_, _bhog_,
   {{0x1309c4a4,0xc245c312,0x64452296,0x6d48b8ea}},	//   чний_, еник, _mshi, _eada,
   {{0x69d8e68f,0x461580a4,0x7bd8e00f,0x661c3e57}},	//   _bive, _سوار, _bivu, zurk,
   {{0xf1b9e143,0x67240012,0x63a2cf8f,0x3eb94926}},	//   kuše_, _scij, _ejon, _myst_,
   {{0x7ae48b6d,0x236d8098,0x661bdcce,0x656bc049}},	//   žite, _koej_, suuk, _togh,
   {{0x200b4133,0x70dc72de,0xf1b9f5aa,0x753d1e58}},	//   _ovci_, _बल्ल, duše_, gesz,
   {{0x7d04578a,0x6d48b04a,0x29001e59,0xab18c0ff}},	//   vais, _yada, _veia_, _цієї_,
   {{0x7d01be5a,0x3f8200dd,0x32095e5b,0x66d68121}},	//   _jels, shku_, dsay_, _hükü,
   {{0x6d89203b,0xe4e4e0ff,0xfd692088,0x6f0446f1}},	//   ežas, _річн, _hapụ, taic,
   {{0x6375c7fc,0x63bbcffe,0x661d16f6,0x69d8e107}},	//   _báni, nlun, busk, _zive,
   {{0x66e62841,0xd2a74825,0x6375c057,0x661d1e5c}},	// [1da0] _попа, екте_, _cáni, cusk,
   {{0x69d9de3e,0xfd692079,0x7d056efb,0x66164213}},	//   _liwe, _mapụ, gahs, rryk,
   {{0x63bbd137,0x7e612156,0x7d045df5,0x2905e0ba}},	//   klun, älpt, pais, iala_,
   {{0x6366003e,0x6609de5d,0x09e7207c,0xee49e067}},	//   _cónx, ksek, _ফিচা, _mẽ_,
   {{0x6609de5e,0x6133a181,0xa2d64047,0x26c7204a}},	//   jsek, kılı, _سيست, _únor_,
   {{0x29fdc06f,0x2904de5f,0x7bd9c0f9,0xa294a12e}},	//   dňa_, wama_, _aiwu, калі,
   {{0x3ebe6069,0x7d008106,0x69d9c035,0xa3e44466}},	//   _átt_, _tems, _biwe, _पूत_,
   {{0x7c2aad4c,0x63bbde60,0xa3e32028,0x7bd9c0a2}},	//   rtfr, glun, _फंस_, _ciwu,
   {{0xada6a099,0x6d5aa058,0x2905fe61,0xdb0d41ae}},	//   _заал, _tnta, fala_, slaç,
   {{0xf8abe067,0x8233c049,0x764294b7,0xc178e013}},	//   ười_, اريا, mwoy, ukė_,
   {{0x798440bb,0x2d800030,0x6721e077,0x661e61e7}},	//   khiw, _blie_, _मारक_, nupk,
   {{0x389b6087,0x7ae9cfdc,0xca48c016,0xaaa9be62}},	//   ליינ, ccet, _tờ_, _चुटक,
   {{0x59b06010,0x6d893e63,0x799531a1,0x7a36e5fc}},	//   जकार, džar, tizw, _bütö,
   {{0x2246c2f8,0x764280a2,0xadc441e9,0x63a411c7}},	//   _isok_, iwoy, _ikẹt, _ejin,
   {{0x27fea05d,0xf1bf20e0,0xf9c74a2b,0x5f95401b}},	//   _jwtn_, lták_, ещан, вивт,
   {{0x213eed90,0x201efe64,0xf1b9e9b2,0x32094a5c}},	//   leth_, muti_, ruše_, tsay_,
   {{0x69dabe65,0x02a30079,0xaac9c026,0x7bcd5e66}},	// [1db0] _oite, _kpọọ, ाइएक, rmau,
   {{0x200bc06f,0xa3092043,0x7bdabd0e,0x491b2026}},	//   ácii_, _کرکے_, _nitu, _बाटो_,
   {{0x6f05605d,0x2121605d,0x656e62a5,0xe717e3c8}},	//   rahc, rghh_, _dobh, תחבר_,
   {{0x3eb95e67,0x69daa0ef,0x645a6012,0x656e6090}},	//   _tyst_, _aite, _štic, _eobh,
   {{0x6d9602b8,0x6d4b81cf,0xb954409e,0x69dac0c2}},	//   kšan, rdga, _свящ, _पंजी,
   {{0x3b05e497,0x6d4d4acd,0x24894625,0x44386132}},	//   xalq_, ldaa, mzam_, _fpr_,
   {{0x69d9de68,0xadc441e9,0xcf582095,0xdcfb8066}},	//   _piwe, _akẹt, תבות_, _hluč,
   {{0x2246c037,0x9f5f0066,0x25742105,0x637cc004}},	//   _bsok_, ystá_, _hält_, _déno,
   {{0x4439417b,0x6d4afe69,0x290375a8,0xa3dd0033}},	//   _jps_, _bafa, _keja_, _तंग_,
   {{0x69daa00f,0x645a7e6a,0x673f400e,0x69da9e6b}},	//   _gite, _átic, heqj, _éter,
   {{0xa0a5fd85,0x2246cce1,0x7886f397,0x6f07206f}},	//   танд, _esok_, _révé, dajc,
   {{0x6455650e,0xed5700ff,0x6e2d5a12,0x1eeac043}},	//   _mrzi, вою_, ktab, _قومی_,
   {{0x2907b1c6,0xfebbe062,0x333fc0fa,0x3dc90025}},	//   oana_, _کاشت_, meux_, _dhaw_,
   {{0x66e2e5da,0xe0df40f9,0x64a62cde,0x29037e6c}},	//   _коша, _agò_, вага, _neja_,
   {{0xe1ff4031,0xa2d36026,0x66032731,0x394b5e6d}},	//   _awó_, भेम्, ипра, _bacs_,
   {{0x6569c0dd,0x6d4d4bae,0x69db8187,0x6f02c005}},	//   njeh, gdaa, _niue, _xeoc,
   {{0x6d4af2bb,0x6e2d4426,0xc9aa290f,0xdb0b807b}},	// [1dc0] _yafa, gtab, _овие_, gogí,
   {{0x6d4bcfcf,0x656f413a,0x25a05e6e,0x8ad6613a}},	//   _laga, _eoch, snil_, نتائ,
   {{0x61e403d3,0xe6bec1b0,0xdce44320,0x92bdc07c}},	//   _huil, _ऊर्ज, ljič, _আলো_,
   {{0x7c2d5e6f,0xa11381ac,0x61e41e70,0x333fc0fa}},	//   btar, لومت, _kuil, jeux_,
   {{0x7bc9868d,0x3ce09e71,0x2907be72,0x661e6037}},	//   _dheu, živo_, fana_, supk,
   {{0x1ea98085,0xd378c00a,0x656f55c9,0xdb08e009}},	//   راني_, _pućo_, _zoch, kodá,
   {{0x61e2de73,0x2d84c004,0x443a3e74,0x4394c4c2}},	//   _suol, thme_, _jpp_, лакс,
   {{0x6288fe75,0x3f983e76,0x656f5e77,0x7981ab45}},	//   vzdo, hiru_, _xoch, _ellw,
   {{0x69daa9bb,0xcf934694,0x49baadb3,0x75e7a121}},	//   _tite, יטה_, _قائد_, _hızl,
   {{0x6d4bc6a5,0x3f869e78,0xd130e19a,0x75e7a121}},	//   _eaga, lhou_, حمد_, _kızl,
   {{0x7bdc7e79,0x7d02ccbd,0xd91b6087,0x3f9ba004}},	//   _miru, _teos, וויל, èque_,
   {{0xaca46088,0x69dc7e7a,0x6d4e2d53,0x7644400f}},	//   _asịr, _lire, edba, kwiy,
   {{0x7c2d578e,0xb5fb00e0,0x7d07206e,0x3f812048}},	//   xtar, lyáz, tajs, _plhu_,
   {{0x290486c7,0x2d85e032,0xfd554088,0x6e20c631}},	//   _lema_, chle_, _fraị, mumb,
   {{0xe8d90125,0xdb1bc017,0x7d073e7b,0xd5b90018}},	//   _inọ_, fluè, rajs, utās_,
   {{0x660d986e,0x443a2007,0x5b144a2b,0x444460fd}},	//   šaki, _dpp_, имст, dw_,
   {{0xd1b800d0,0x656f5e7c,0x69c99e7d,0x44446547}},	// [1dd0] _جاوا_, _voch, _rhee, ew_,
   {{0x1b14e405,0xd9cb8328,0x2bc34029,0x7bdc662f}},	//   ত্রে_, िष्ट, _वीरा, _ciru,
   {{0x656f4115,0x248940c2,0x645a0041,0x48157882}},	//   _toch, szam_, ātie, умес,
   {{0x671d4cb5,0x27e48321,0x442dde7e,0x63a298c0}},	//   _फाटक_, _bumn_, yte_, gnon,
   {{0x637cc057,0xec35400b,0x44204d82,0x61e24049}},	//   _vénl, _גאָר_, cui_, íolt,
   {{0x3ea9817a,0x76556064,0x7aed42dd,0x7c3aa187}},	//   ħat_, _trzy, lcat, _bptr,
   {{0xdd946099,0x2d991e7f,0xe800c033,0x80ada07c}},	//   _тары, kise_, लीसा_, য়েন্,
   {{0x3f868530,0x6b82de80,0x7bdd4037,0xf1b9fc67}},	//   chou_, _clog, _jisu, duša_,
   {{0x7793a043,0x6d4bde81,0x69caeab5,0x6f041e82}},	//   _پیغا, _vaga, _bhfe, _reic,
   {{0xe1f9e80e,0x657bc5d9,0xc0c89882,0x61e3ea89}},	//   нго_, skuh, _русе_, _punl,
   {{0x2d87a28f,0x7f4d0054,0xadf5a7ca,0x7dc7c0e0}},	//   mhne_, _baaq, _спеш, _műsz,
   {{0x6e20c2a9,0x637f000e,0xdcfae013,0x888ca053}},	//   bumb, _dëno, kitė, _קראַ,
   {{0x44217e83,0x26068029,0xed4ee825,0x877a800b}},	//   huh_, सीपी_, _ло_, גארי,
   {{0x63b53e5c,0x200bc06f,0x6f040105,0xd378a579}},	//   gozn, áciu_, _weic, _tiće_,
   {{0x69c40064,0x2249017b,0xdbd1e10a,0x69dc7672}},	//   रतदी, _esak_, _müüj, _rire,
   {{0x2258e065,0x3f983e84,0x64560076,0x7f9425fc}},	//   ærke_, siru_, _tryi, _müqə,
   {{0xa7a74f4a,0x442d8223,0x733b000b,0x79840167}},	// [1de0] укта_, _nqe_, _טעקס, _iliw,
   {{0x6d40de85,0x25754156,0x64444401,0xed4621c0}},	//   zema, _sålt_, rwii, _сноп,
   {{0x661bde86,0xb9252125,0x7bdc7e87,0x7c21e05d}},	//   hruk, _lepụ_, _viru, nulr,
   {{0x6e20d9fc,0xa09b200b,0x20557043,0x7bdd5518}},	//   yumb, _טייט, штур, _gisu,
   {{0xdca3882b,0x7f41e3ac,0x6375c9d0,0x7dc7c009}},	//   баци, kelq, _láns, _fűsz,
   {{0x6b840355,0x6d40de88,0x6e20c160,0x63a28d1c}},	//   _llig, wema, vumb, snon,
   {{0xee3a6052,0x2d9901a5,0xa2d6d91c,0x7bdd40b1}},	//   _янв_, yise_, मेन्, _yisu,
   {{0x7afbcb5e,0xa5bb2183,0xe5c6c3fc,0x5e57200b}},	//   gbut, cróf, ысло, ריקע_,
   {{0x6b82c06e,0x63a45c62,0xcad2c125,0xbb3b400b}},	//   _vlog, inin, _gịlị, געפי,
   {{0x6b96010f,0x290a3e89,0x3d94ee37,0x1637c13a}},	//   _amyg, jaba_, риор, اسية_,
   {{0xa5bb2064,0xa3b4451d,0x7c2d000e,0x61e64561}},	//   któr, टवा_, _sqar, _lukl,
   {{0x2905a265,0x7dc02156,0x660d52c1,0x22490037}},	//   _zela_, lösh, ysak, _psak_,
   {{0x6eb04688,0x44216098,0x5f94014a,0x51873e8a}},	//   _अँगु, zuh_, сият, гува,
   {{0x290a3350,0x7d0abe8b,0x6d41e506,0xb865c896}},	//   gaba_, nafs, cela, _خامو,
   {{0x61e65b43,0x3da750ba,0x7aed40d5,0x6b8408e0}},	//   _aukl, граб, tcat, _flig,
   {{0x644ae0f7,0x4c13e68c,0x6602de8c,0x6d4e7e8d}},	//   _isfi, _ابوس, _kwok, _aaba,
   {{0xb87b4031,0x443b005d,0x3b094025,0x68e2c0ce}},	// [1df0] _afír, _upq_, raaq_, _mgod,
   {{0x7afd0669,0x8d77657f,0xf52726e4,0x25e66028}},	//   lbst, دارا, _сфин, _जूही_,
   {{0x660d59c1,0x44216037,0xf8b92029,0xa2d91073}},	//   ssak, uuh_, _इडिय, _नृत्,
   {{0x7ae48066,0x68e2c1fb,0x7c228197,0x320dc025}},	//   žitn, _ngod, fuor, ysey_,
   {{0xaf0480ff,0x44232ca4,0x6d4e6659,0x6602c096}},	//   спіл, luj_, _faba, _nwok,
   {{0x6edbc041,0x3f9a6098,0x6458e7f7,0x661d1e8e}},	//   _jābū, cipu_, _orvi, irsk,
   {{0x27f8806e,0x98b820ba,0x6498a14a,0x442ee0c1}},	//   _črne_, meră_, лтър_, _nqf_,
   {{0x64498cab,0x68fc20a9,0x7d076950,0x3f8940fd}},	//   _tsei, zbrd, _hejs, nhau_,
   {{0x64a5c3fc,0xdca5c471,0x27f8805c,0x443ce07d}},	//   рапа, рапи, čený_, _apv_,
   {{0x27e6de8f,0x661bc220,0x78a4cbe2,0x3869566b}},	//   _duon_, rruk, _živc, ixar_,
   {{0x442320e8,0x290a3e90,0x63bb817a,0xfd10a049}},	//   juj_, vaba_, _kkun, _رجل_,
   {{0x63bb81d7,0x7bdf0057,0x69de3e91,0x6b8400f7}},	//   _jkun, _ciqu, _sipe, _qlig,
   {{0xe8eeed59,0xc8d00077,0x799ae284,0x69cd00eb}},	//   _мл_, सेंट, bitw, _dhae,
   {{0x63bb80ae,0xbddb6030,0x637843f6,0x8cb12118}},	//   _lkun, _erèz, _línt, _आँखो,
   {{0x1219220e,0x63784005,0x3ebe2069,0x61e650aa}},	//   люты_, _oínt, ætt_, _sukl,
   {{0x2bbf5ad8,0x79840167,0x59b42026,0x6b89c747}},	//   ्षगा, _uliw, ंकहर, nheg,
   {{0x8c4606fc,0xdced194e,0x3f9a613b,0xa3c8c010}},	// [1e00] _тепе, _glađ, tipu_, ोगत_,
   {{0x69c1f0bf,0xda18c010,0x2fc0494b,0x69df1e92}},	//   nlle, _दिसत_, slig_, _éper,
   {{0x799c2bb1,0x3f894048,0x68e3e1e7,0x81e7e07c}},	//   mirw, bhau_, _mgnd, মীর_,
   {{0x3f895e93,0xa5bb207b,0x2fdf8005,0xcad2c088}},	//   chau_, tróg, _ciug_, _dịjị,
   {{0x98b820ba,0x799ae0b1,0xdca6882b,0x33d6614f}},	//   beră_, yitw, шади, _вівт,
   {{0xab0961b3,0x6d428108,0x6d445e94,0x7c228534}},	//   _متفق_, seoa, leia, ruor,
   {{0x6f0aa098,0xdca36399,0x44325e95,0x46a37e96}},	//   rafc, _дари, lty_, _дарв,
   {{0xea004081,0x69c1fe97,0x637840f9,0x8fa68799}},	//   _luật_, elle, _tínu, _табе,
   {{0x68e9612a,0x7d0aab83,0x44233e98,0x637cc011}},	//   _şedi, pafs, zuj_, _jéni,
   {{0x69c281cd,0xd378c012,0x6e3e214f,0x201ca9a3}},	//   lloe, _mući_, _oppb, prvi_,
   {{0x61e083df,0x7ae404b4,0x7bcd0286,0x2d9cb1c8}},	//   _kiml, _bgit, _phau, mive_,
   {{0x25a680e2,0x63a4d019,0x645abe99,0x77930050}},	//   nnol_, čins, _irti, تیبا,
   {{0x602aa03c,0x637da187,0x395254f2,0x7afd0325}},	//   _təms, _bènh, ddys_, rbst,
   {{0xdb056277,0x4ea73429,0x8cb0410a,0xe4a725d0}},	//   llhö, арба, _अँजो, арбо,
   {{0x7414e63b,0x443cfe9a,0x37075002,0xf206e14a}},	//   _اوبا, _upv_, ичав, _тяло,
   {{0x7d08b971,0x44313e9b,0x2d9cbe9c,0x201ee0a9}},	//   _leds, rtz_, hive_, mrti_,
   {{0xdb00c07b,0xa7870555,0x6e24521e,0x752d003c}},	// [1e10] lomó, _مشکو, guib, _icaz,
   {{0x6d43b9a1,0x2907fe9d,0x764d0427,0x290ceded}},	//   xena, _xena_, _isay, nada_,
   {{0x61e96504,0xd8b80050,0x656d46a6,0xa91d806f}},	//   _čels, _مدیا_, pjah, _dlžn,
   {{0x27e912f4,0x3f85a07d,0xac1940ff,0x60d9e00b}},	//   _kuan_, _sllu_, _йому_, אַנג,
   {{0x637cc004,0x6f08a037,0xb345a1ae,0xbcfb4049}},	//   _géni, _bedc, jeçã, _gnéa,
   {{0x248dc42e,0x3a3ea037,0x3dcd81e7,0xf745adf5}},	//   vzem_, _bptp_, _whew_, секо,
   {{0x672d03ee,0x69c28d53,0x6d43be9e,0x7f43a0b8}},	//   _ocaj, bloe, rena, renq,
   {{0x3f86c1ab,0x61e8be9f,0x6b9c3929,0x6e23a265}},	//   _clou_, _dudl, zirg, runb,
   {{0x645ca0c4,0xd24ec13a,0xe7eb612f,0x3a24c098}},	//   _árin, فني_, _जूता_, gump_,
   {{0x443f9ea0,0x9b74a13a,0x237fdea1,0x7d74a13a}},	//   _ipu_, _والص, skuj_, _والط,
   {{0x644d1ea2,0x2ca9c098,0xdce9c7a0,0x44337ea3}},	//   _asai, _žadd_, lječ, ntx_,
   {{0x63b990d6,0x4424dea4,0x6d457ea5,0x2d9d9ea6}},	//   nown, bum_, heha, niwe_,
   {{0x27e900ef,0x443f807d,0x3bd5ead4,0x6e3e205d}},	//   _cuan_, _jpu_, _люкс, _sppb,
   {{0x60c1a052,0x3f9940a2,0x7649c7b1,0xa8030057}},	//   _kylm, _amsu_, mwey, íñas,
   {{0x7dc6e83e,0x6563fea7,0x799c2a20,0x753b811d}},	//   iðsl, _innh, rirw, _obuz,
   {{0x44325ea8,0x29d781d7,0xb6a32702,0xfaa332a1}},	//   tty_, _għax_, числ, часо,
   {{0x27e9017b,0x61e09ea9,0xe8f700fb,0x3b866093}},	// [1e20] _guan_, _riml, _улы_, благ,
   {{0x7c245eaa,0x66186066,0x60c08156,0xdfcf6049}},	//   ruir, ávko, _rymm, فيق_,
   {{0x6e3e3eab,0xdb01e057,0x539ae0be,0x645b8090}},	//   _uppb, loló, ניעו, _arui,
   {{0x543b200b,0x4425e12a,0xd378c2e2,0x7df3e12a}},	//   _געטא, iul_, _tući_, _găse,
   {{0x9412a497,0xa3e7d6fd,0xb87b1eac,0x69c441ea}},	//   əcək_, _मूल_, ncíp, mlie,
   {{0x7c256435,0x6d457ead,0x26056010,0x7bc2804a}},	//   buhr, ceha, हीही_, slou,
   {{0x44337eae,0xdfd0c1ac,0x645b8200,0x8e86613a}},	//   ctx_, ويت_, _erui, _الأه,
   {{0xa91b4069,0xadfa00ec,0x2d9d80b1,0x645b8e96}},	//   _alþj, ्ठान_, ciwe_, _frui,
   {{0x290a605d,0x6e96813a,0x7d0e3eaf,0x2002e16d}},	//   _keba_, _الذا, kabs, ćkim_,
   {{0x39468510,0x443ea058,0xdb00caba,0xd90ee896}},	//   leos_, _tpt_, tomó, ریب_,
   {{0x91bb60be,0x7bc44013,0x6d460614,0x7aed8a38}},	//   רמיי, kliu, feka, žate,
   {{0x6562c04e,0x7d0d4054,0x3a24c76a,0x398ac0f9}},	//   _unoh, xaas, pump_, _bùse_,
   {{0x657dc262,0x321128fd,0xfa33c0eb,0x3945feb0}},	//   öshe, wszy_, _فرود, bels_,
   {{0xe81d2029,0xe29f0069,0x998963de,0x3ce52488}},	//   _फिदा_, naði_, ktaš_, ølv_,
   {{0x877ba0be,0x63792031,0x442680ce,0x1b7ba053}},	//   נאלי, _bìnr, huo_, נטלע,
   {{0x60f9465d,0x35a405da,0xb8cf007c,0xe9a405da}},	//   рная_, _најг, _কর_, _најп,
   {{0x7d0d4e38,0x798280c2,0x63ad1eb1,0xf1ab2050}},	// [1e30] raas, dkow, _ijan, _ماده_,
   {{0x3f877eb2,0x61ed4bb5,0x60cd1ea6,0xb4e90046}},	//   ónu_, rqal, _izam, _बलु_,
   {{0xdb176057,0xe3bf22a8,0x64408018,0x290eb819}},	//   noxé, cuña_, _apmi, dafa_,
   {{0x63bae089,0xe7c90eda,0x61eafda4,0xa1595eb3}},	//   hotn, रतिप, _mufl, _таму_,
   {{0x61e995f3,0x290ebeb4,0x645c6640,0x63b98064}},	//   _quel, fafa_, _erri, rown,
   {{0x9f4800dd,0xe7eda8c6,0x6fe8e026,0x644e6098}},	//   _punë_, _चंदा_, _těch, _fsbi,
   {{0x63bae037,0x94756050,0x29c9a03e,0x7d0999ae}},	//   dotn, _بگذا, búan_, _tees,
   {{0x61e1bd37,0x201fdcfd,0x09e2c9fd,0x290b4361}},	//   _will, trui_, мощн, _jeca_,
   {{0x61eae105,0xb4fb204b,0x6729deb5,0x3945edee}},	//   _aufl, ्राय_, rgej, tels_,
   {{0x61e1beb6,0xbca484a1,0xae1e40aa,0x2d8ce13a}},	//   _uill, _عملي, यूटन_, ghde_,
   {{0x44205eb7,0x753d4064,0x61e2deb8,0x76aba656}},	//   zri_, _obsz, _fiol, _став_,
   {{0x6d55364a,0x2d9a27d3,0x2d832171,0x672b8440}},	//   edza, _smpe_, ekje_, nggj,
   {{0x63a9deb9,0x6d9600e4,0x798d5eba,0x69c44110}},	//   mnen, kšav, dhaw, vlie,
   {{0x3f8dc1ae,0xc31f607c,0x50da8557,0xf1bf4788}},	//   lheu_, ন্তি_, יקרא, _aká_,
   {{0x644f5ebb,0xe732013a,0x25bf8121,0xdee3262b}},	//   _asci, _قصة_, _okul_, дори,
   {{0x290a7ebc,0x61e3febd,0x2918605d,0xdb01e017}},	//   _seba_, _hinl, _sdra_, colò,
   {{0xd62a43fc,0x6f0bc009,0xf50a6494,0xada34926}},	// [1e40] розе_, _megc, инал_, фатл,
   {{0x3f9a2037,0x61e41677,0x7d0bc009,0x637f000e}},	//   _umpu_, _hiil, _legs, _rëni,
   {{0x6441a05f,0x63bbc0ca,0x7bc4403b,0xf21e4064}},	//   _npli, koun, pliu, यूज़_,
   {{0x290f9ebe,0xaca3c079,0x7dcda5e0,0x63a9c05a}},	//   gaga_, _atọm, yúsc, jnen,
   {{0xade36028,0xe29f00c4,0x88cfe07c,0x645e2012}},	//   _कंचन_, taði_, রশিক, _hrpi,
   {{0xceb4a03c,0xdb1d456e,0x39528013,0x29c9a005}},	//   şəm_, _aksè, žys_, súan_,
   {{0x2d9efc98,0x7d0afebf,0x44216037,0x66d061e9}},	//   vite_, _refs, crh_, _dókí,
   {{0x2242417b,0x1c1d2028,0xdb03a69f,0x6b845ec0}},	//   _kpkk_, _फिसल_, fonó, nkig,
   {{0xb6a380ff,0x316ae0de,0x7dc033c0,0xdb1c6011}},	//   _житл, ашно_, nöss, _akré,
   {{0xaac03133,0x973ce29f,0xdb18a1ce,0x63bc3ec1}},	//   _शुभक, kiće, kové, jorn,
   {{0x61e3e3df,0x6b845182,0x3f8905df,0x6d472fdb}},	//   _dinl, kkig, _plau_, veja,
   {{0x6f029ec2,0x637cc7df,0xa3c94046,0x69cae0c2}},	//   nboc, _cént, _लीं_, _सीरी,
   {{0xb7db8095,0x39532057,0x290cbec3,0xe3b9003c}},	//   יקטי, _paxs_, _keda_, brın_,
   {{0x26c48425,0x644020ba,0x7d0287a0,0x637cc0e1}},	//   _mymo_, ămin, hbos, _vénu,
   {{0x6f0f065f,0x7dcda049,0xe8d9e067,0xdb09c105}},	//   pacc, núsa, _đệ_, nieß,
   {{0x61e40006,0x645d5ec4,0x765d40ae,0x63ad0df7}},	//   _giil, _prsi, _prsy, _ujan,
   {{0xe1f040d0,0x290f93a8,0x61e3ee39,0x68e76071}},	// [1e50] نسل_, vaga_, _yinl, _pgjd,
   {{0x67f361d7,0x63adc0f5,0x24840042,0x25bf808b}},	//   _aħja, čani, ømme_, _skul_,
   {{0x6da404ad,0x7d0d0d3d,0x63a9dec5,0xed59c29c}},	//   rđav, _keas, ynen, lože_,
   {{0x3947a31d,0xb5fb4326,0xbd05e1e9,0x637cc057}},	//   wens_, _prád, _afẹ́, _méns,
   {{0x394940ef,0x7d0d1ec6,0x2b47bec7,0x645d4c9d}},	//   meas_, _meas, tenc_, _ursi,
   {{0x752d5ec8,0x35cfe028,0x764d5ec9,0x7df3e12a}},	//   lgaz, _सीढ़, mway, _lăsa,
   {{0x6d48feca,0x3a2948a4,0x63a9c03a,0x6010a4c7}},	//   deda, luap_, tnen, _rómá,
   {{0xb5fb413a,0x0595a050,0x62359ecb,0x69c72098}},	//   _trád, _کارگ, _небу, hlje,
   {{0x61e3e271,0x764d5ca0,0x60b5a0e0,0x799c60fd}},	//   _pinl, nway, _کمائ, _ymrw,
   {{0x7bc72ee6,0x291138d1,0x6b844108,0xd83ba4a7}},	//   jlju, jaza_, zkig, _вэд_,
   {{0x6f0d1a38,0x63a9cb23,0xad9b60f9,0x644d5ecc}},	//   _beac, pnen, _awúk, hwai,
   {{0x661520c2,0x28dfc70a,0xdb18a066,0xaadfceda}},	//   dszk, _पृथि, vové, _पृथक,
   {{0xa2bfa028,0x61e401dd,0x673bc143,0x29113ecd}},	//   _लुत्, _viil, mfuj, faza_,
   {{0x290c3320,0x6d48fece,0x69c7264e,0x27fa207d}},	//   úda_, ceda, glje, _ptpn_,
   {{0x27ffc827,0x660994b4,0x91fca018,0xa96a40de}},	//   lpun_, _lwek, _grād, бива_,
   {{0x63a1fecf,0xe81d2021,0x2bcfe4ba,0x33f1ac7c}},	//   liln, _फिरा_, _सीता, _máx_,
   {{0x973ce0e4,0x2903355f,0x764d5ed0,0x0d8667e9}},	// [1e60] siće, bbja_, gway, план,
   {{0x6b844241,0x7778e022,0x63ab807d,0xe617484f}},	//   skig, _xovx, engn, яду_,
   {{0x6ac6613a,0x24805ed1,0xb77b2095,0x877b2095}},	//   أقام, syim_, _האיש, _האיי,
   {{0x7e612a2f,0x7c29c09a,0x7dc5c057,0x7d0160ba}},	//   ælpe, kuer, bósi, _pârâ,
   {{0x7dc5c005,0x4444240f,0xb6e38627,0xad9b2071}},	//   cósi, _hp_, нюшк, spúe,
   {{0x63ab8058,0x69c1a037,0xdb0d4069,0x69d99ed2}},	//   angn, _ckle, llað, amwe,
   {{0x290cbed3,0x61fb8f74,0x7f49c05d,0x04436f84}},	//   _veda_, _etul, feeq, _перн,
   {{0xe9448062,0x69c08013,0x68e981f6,0x6d48fed4}},	//   _ترسی, _ukme, _gged, weda,
   {{0xa5bb2459,0x63a0ded5,0xb5fb4019,0xaa58c075}},	//   drón, rimn, _tráe, ципу_,
   {{0x3f8681ce,0x35f4e2f0,0x41be67af,0x53be6bde}},	//   lkou_, мпор, ्तिस, ्तिश,
   {{0x6d4aa167,0xa3be498a,0x6e2446fa,0x6ff3e0ba}},	//   mefa, ेता_, hrib, _păca,
   {{0xa3d367f4,0x60c5204e,0x6e24557c,0x9f44a5df}},	//   _हीन_, _ryhm, krib, _humà_,
   {{0x764d474d,0x29112631,0x61ee781c,0x6e244007}},	//   xway, taza_, _lubl, jrib,
   {{0xdb153ed6,0xed59c35d,0x629ca0c4,0x27e6c090}},	//   pozí, rože_, _þros, _hion_,
   {{0xb5fb4ae6,0x6d561ed7,0x29033709,0x637f000e}},	//   _orác, _faya, rbja_, _bënt,
   {{0x63a28167,0x291122ad,0x61ed1ed8,0x83fca012}},	//   jion, saza_, _tual, _grđe,
   {{0x7bc7250e,0x92bf207c,0xb606a3ce,0x6b8d1ed9}},	// [1e70] plju, েশে_, lošć, _ilag,
   {{0x61ee6066,0x6fc5c0c2,0x60c52052,0x04fe81a6}},	//   _bubl, róci, _tyhm, ুলোর_,
   {{0x6d556c9d,0x7f556019,0x6d408037,0x63a29eda}},	//   _vaza, _vazq, _bbma, fion,
   {{0x6d97c12a,0xa49b458f,0x27e6c534,0x49052026}},	//   nţat, _beòt, _nion_, वरको_,
   {{0xdd95a0fb,0xa3c0c1b0,0x44442126,0xddeb41ac}},	//   мады, ंकन_, _zp_, _درجه_,
   {{0x7bc2dedb,0x6d4abedc,0x61e64108,0x25a203de}},	//   _akou, gefa, _zikl, zikl_,
   {{0xfd10a085,0x26c6c939,0x4424c1f6,0x657aabc6}},	//   اجه_, _ayoo_, erm_, _doth,
   {{0x2d8ca121,0x27fc606f,0x9f4360d1,0x7d1b9edd}},	//   _elde_, ívne_, _sijè_, _udus,
   {{0x6d561ede,0x26d16533,0x443900f7,0x66098167}},	//   _raya, _hzzo_, jts_, _uwek,
   {{0x443906bf,0x645bdedf,0x6281fd94,0xac85e627}},	//   dts_, rvui, tylo, дгол,
   {{0x3ce6406f,0x290ee121,0x3dc944ec,0x394a098c}},	//   ľovi_, _defa_, klaw_, озно_,
   {{0x6d599ee0,0x798d1ee1,0xa96a01e3,0xe8f70376}},	//   ndwa, _claw, цима_, млю_,
   {{0xa5bb2dc1,0x63ad5ee2,0x44391ee3,0x644521fb}},	//   rrón, dnan, gts_, _aphi,
   {{0x61e65dd9,0x6d560ed1,0x63a3a451,0x291249c8}},	//   _sikl, _waya, ninn, waya_,
   {{0x04b522a3,0x63ad4069,0x29136054,0x7643e037}},	//   естя, fnan, daxa_, _upny,
   {{0x2fc95655,0x27e7fee4,0x6f1d40a2,0x7bdbc052}},	//   glag_, _hinn_, _cdsc, nmuu,
   {{0x98a3473f,0x61e65ee5,0x61ef404d,0x7c2b8361}},	// [1e80] вите, _vikl, _cucl, jugr,
   {{0x63ad5ee6,0x290fdee7,0x776980fc,0xef1a65d0}},	//   anan, _lega_, _anex, іме_,
   {{0x6c4a650f,0x51f6001c,0x92650050,0x7bc9dee8}},	//   تلاف_, _عسکر, _قدیم, kleu,
   {{0xed59c143,0xd83e607f,0x5aca801f,0x7e695ee9}},	//   jdž_, ščob_, олем_, _šepe,
   {{0x657abeea,0x7bc9c1cd,0xeb9740ba,0x69c3f48f}},	//   _poth, dleu, _ция_, _okne,
   {{0x98beef76,0x20186939,0xaa58a878,0x6d408037}},	//   letą_, _tvri_, зику_, _wbma,
   {{0x63a28064,0x6da68e64,0xa5bb2005,0xcf576557}},	//   pion, _жива, dról, _קבלת_,
   {{0xb50a2260,0x7c372106,0xdb18a1ae,0xd378a20d}},	//   वरुप_, _çarş, moví, _mići_,
   {{0x7c38a171,0x6da3862b,0xa5bb2009,0xb906c037}},	//   stvr, _рита, rtóz, _यः_,
   {{0xf698e39d,0x80db407c,0x6568a050,0x44269eeb}},	//   звој_, যুক্, _undh, mro_,
   {{0x2b58689d,0x25bfc653,0x39587eec,0x9f448bf9}},	//   _marc_, boul_, _mars_, _aimé_,
   {{0x69d60157,0x6e95103a,0x63a45aad,0x8354c0eb}},	//   _chye, еиму, jiin, _سپتا,
   {{0x6d40206a,0x2905feed,0xb50a21b0,0x2918e13a}},	//   đman, bbla_, वरूप_, óras_,
   {{0x63ad40c2,0x5f0101a6,0xb606a6ca,0xe8d94079}},	//   wnan, ্লেখ_, pošć, nkụ_,
   {{0x04c92049,0xdb00c22e,0xd37b40c0,0x7c260155}},	//   سوري_, rnmæ, оча_, arkr,
   {{0xb4af2010,0x9df940de,0xea002067,0x69c0deee}},	//   _कशी_, знат_, _giật_, nome,
   {{0x6f0f41e1,0x7aed1eef,0x4fd56aa5,0x7bdd0262}},	// [1e90] _vecc, _igat, ежат, mmsu,
   {{0x6493203b,0x660d1ef0,0x2246c07d,0x6569806f}},	//   ežiū, _iwak, _mpok_, _sneh,
   {{0x660d0187,0xc7b9029c,0x7d1523ed,0x644521fb}},	//   _hwak, suđu_, mazs, _uphi,
   {{0x6e2b8114,0xa49b458f,0x7c2b9ef1,0x63a4535d}},	//   tugb, _deòr, tugr, ciin,
   {{0x77698067,0xa969b512,0x39587ef2,0x7aed01e2}},	//   _vnex, зила_, _fars_, _mgat,
   {{0x777c68ad,0x7c2b8c44,0x2055a6bd,0xac1970ac}},	//   _gorx, rugr, етир, _ногу_,
   {{0x199587b9,0x24899ef3,0x27e7e569,0xdb0e3ef4}},	//   _завя, šam_, _rinn_, tobú,
   {{0x656ae153,0x7dc5c069,0x9f45a089,0xc867814a}},	//   _anfh, jóst, _milé_, _отзи,
   {{0x98a0416d,0xdb01e78d,0x25bfc0ba,0x6fd60e1c}},	//   rgić_, lilé, roul_, náce,
   {{0x96b9ecde,0x25addef5,0xb176e067,0x25bfc3ac}},	//   зуму_, snel_, _phượ, soul_,
   {{0xf8b1e01c,0x2246def6,0x28a56077,0x2d894037}},	//   دکش_, _epok_, _गेमि, kkae_,
   {{0x660d0bb1,0x27e9081f,0x3f8ee167,0x27e7fef7}},	//   _bwak, _cian_, _elfu_, _winn_,
   {{0x7c2d4cb3,0x8c45d391,0x4439400e,0x80c8007c}},	//   juar, _челе, _nqs_, রেন্,
   {{0xc6928087,0xb176e016,0xdce4006e,0x60c98426}},	//   ראך_, _thượ, _unič, _myem,
   {{0x69d6000e,0x63a45ef8,0xf3f1a125,0x2b594017}},	//   _thye, tiin, _jụ_, _basc_,
   {{0x2b594017,0x69c41ef9,0x7bc520bb,0x9f45a1e9}},	//   _casc_, _ukie, _ekhu, _dilé_,
   {{0x809f8aa1,0x657d48c1,0x442ddefa,0x656bc058}},	// [1ea0] _खेले, _dosh, nue_, _mngh,
   {{0x63a56058,0x777c603c,0x3860c6a6,0x6fb6613a}},	//   gihn, _qorx, _širk_, رمضا,
   {{0x661b9efb,0x29117efc,0x657d400e,0x660d0171}},	//   _avuk, _deza_, _fosh, _zwak,
   {{0xaca3c088,0x442ddefd,0xc05a8056,0x5efda028}},	//   _chịk, kue_, зік_, रुस्_,
   {{0x6493203b,0x6376e1fc,0x63a56622,0x3d052010}},	//   ržiū, _vânz, bihn, वरचे_,
   {{0x2906832a,0x7e64c00a,0xa49b5efe,0x2d8fdeff}},	//   sboa_, _šipo, _teòr, _alge_,
   {{0xd04e803c,0x6d5c3f00,0x83fca20d,0x3cf0a046}},	//   _ədəb, idra, _brđa, _चलीं_,
   {{0x442ce9ee,0x7c3bdf01,0x09e381cc,0x63a081e7}},	//   vud_, ftur, _босн, _ummn,
   {{0x25a5ff02,0x63a60058,0x442cea25,0x27e90e88}},	//   fill_, dikn, wud_, _rian_,
   {{0x656bc1cd,0x25f40029,0x7d164054,0x38c8a555}},	//   _engh, ंदनी_, hays, _قاضی_,
   {{0x661b81d8,0xbcfb00e0,0xdd95003b,0x27e91f03}},	//   _zvuk, ndég, ваны, _pian_,
   {{0x27e90546,0x9f97400e,0x67108ba0,0x6d58f4d5}},	//   _qian_, rçë_, ारिक_, _wava,
   {{0x2fc6c1e2,0x62856037,0xb5fd8012,0x5fd2210a}},	//   _ikog_, zyho, _krša, _दीहल,
   {{0xb5fb4261,0xca57c087,0x26c90167,0xdcf8f019}},	//   _brán, _ניוז_, _vyao_, _kovč,
   {{0xf36743d5,0x8624209e,0x656bc0e2,0x6f153f04}},	//   нтан, льте, _yngh, razc,
   {{0x660d02ad,0x7e641f05,0x6d59c025,0xf215c118}},	//   _twak, _frip, _xawa, _दौड़_,
   {{0xe89441ef,0x161d2485,0x932760eb,0x9f47e061}},	// [1eb0] гать, _फिकर_, فران, _binè_,
   {{0xb7bde1fc,0x39594037,0x7bc520bb,0xd6db61fc}},	//   tuţi, _wass_, _ukhu, пте_,
   {{0x6d452174,0x60c98644,0xa3c0cba0,0xb5fb4317}},	//   _ibha, _syem, ंका_, _grán,
   {{0x2d8b0026,0xdb03bf06,0x236ca143,0xa91d806e}},	//   nkce_, miné, _andj_, _možg,
   {{0xdce9c579,0xd1164095,0xe10c000b,0x29094167}},	//   mjeć, _בקרה_, פּאָ, mbaa_,
   {{0x60c98167,0xbea5ab92,0xa49b40f9,0xa3cfe0c2}},	//   _vyem, калк, _afòg, _वीं_,
   {{0x94d465a8,0xead46052,0x1fb5c318,0xf4ffe0f9}},	//   _борц, _борь, ксир, _dẹlé_,
   {{0x60c981e7,0x7e7ea262,0x224906d6,0x6d5aa2a5}},	//   _tyem, äppa, _opak_, _eata,
   {{0x6d5aa57b,0x2489a041,0x6d4e3f07,0x7989df08}},	//   _fata, ņam_, yeba, rkew,
   {{0x7bcd59d3,0x6d440024,0x98bee0c2,0x3d27c0f9}},	//   hlau, _sbia, letę_, _bìwà_,
   {{0x7c3bdc62,0x2000012a,0x442dc095,0x394ddf09}},	//   stur, _stii_, sue_, pees_,
   {{0x8fa602a3,0x7d164054,0x7dcda06f,0x7c3bc8cd}},	//   таме, xays, kúsk, ptur,
   {{0xdb18ae97,0x5576800b,0x442f98eb,0xdce9c40c}},	//   lová, דערן_, nug_, djeć,
   {{0x63a2dee9,0x6d5aa025,0x61eaf412,0x62861f0a}},	//   _zmon, _xata, _gifl, ryko,
   {{0x711ae0be,0x9f4a82a8,0xf992e076,0x628606b5}},	//   _חוצפ, _subí_, _דרג_, syko,
   {{0x69d8e00e,0xdd924938,0xf8660844,0x7e640e96}},	//   _zhve, جور_, _авио, _trip,
   {{0x6d5c2a6f,0x2bf64c10,0xd70621e1,0x39405f0b}},	// [1ec0] pdra, тябр, _изпи, rfis_,
   {{0xdb008004,0x442f9f0c,0x63a72171,0xdfcf6243}},	//   _immé, dug_, cijn, قيق_,
   {{0x9f47e0fa,0xa3c2f706,0x317f8030,0x9f4de2a8}},	//   _ciné_, ंवत_, _bouz_, lpeó_,
   {{0xa3d20738,0xdcf8e361,0xf1bf204a,0x66044d6e}},	//   वति_, _rovč, hrál_, ppik,
   {{0xbad541d3,0x63a2c1f6,0x63a41f0d,0x29183f0e}},	//   _біры, _rmon, _mmin, oara_,
   {{0x4a9b0053,0xce6aa103,0x6448a012,0x661c6320}},	//   וינג, дрид_, _ppdi, _tvrk,
   {{0xe5a37196,0x63a41f0f,0xd7f8a016,0xa2ce8033}},	//   _тири, _omin, _trăm_, _तरक्,
   {{0x3869c1e4,0x6d4f0017,0x63a72171,0x3d0a6010}},	//   _šara_, xeca, zijn, िरके_,
   {{0x6d41ff10,0x661bcbae,0xd378a320,0x69d9df11}},	//   ffla, gsuk, _siću_, _dhwe,
   {{0xceb4003c,0xb5fd8012,0x27e05f12,0x69d9d72a}},	//   _edək_, _kršn, hmin_, _ehwe,
   {{0xf8bf4162,0xa2e6a491,0xdb18a1ce,0x63a4005d}},	//   _idée_, _рожд, cová, _bmin,
   {{0x6448012a,0x7c3d094b,0x78a4c552,0xa183c052}},	//   ădin, ttsr, _živu, _вышл,
   {{0x2bb380c5,0x81d8407c,0x6e29c005,0x6aa20143}},	//   ंचता, াদা_, creb, _žofr,
   {{0x7c3e69ee,0xc4d30148,0x601883f6,0x79808614}},	//   ktpr, _सरीख, _zúmá, _lomw,
   {{0x28e04077,0xdb1d027f,0x2d801890,0xc31381a6}},	//   पेसि, losí, _foie_, _হাসি_,
   {{0x7d18a042,0xa8064106,0x7bce3f13,0x33f8a071}},	//   havs, ktığ, albu, _méx_,
   {{0x7f5c6bee,0xdb03a13a,0xb87b40f9,0x17ed4046}},	// [1ed0] _barq, siné, _agír, जदेव_,
   {{0x1755214a,0x63a8e098,0xad9b61e9,0x6d453f14}},	//   _своя, nidn, _awúr, _ubha,
   {{0xa91d816d,0x80c9c026,0x2619c573,0x3cde6843}},	//   _lože, _हुने, _मौनी_, केले_,
   {{0x9f81c069,0xb8eb6028,0x443ee31b,0x7522c088}},	//   jóð_, _लड_, itt_, _ndoz,
   {{0xef18e041,0x4429417a,0x656f4baa,0xf4d1807c}},	//   kaļ_, qra_, _inch, িশ্ব,
   {{0x442b0420,0x28c6c10a,0x764ae065,0x237f80d1}},	//   irc_, _लड़ि, _opfy, _wouj_,
   {{0x290b0037,0x24894009,0x798080a2,0x27eca095}},	//   kbca_, lyam_, _fomw, _didn_,
   {{0xf8d30292,0x236d8037,0x1db7917d,0x60cd01b6}},	//   _सरूप, _unej_, _अदित, _oyam,
   {{0x291906dc,0xab5b0105,0x69db8088,0x69c981e7}},	//   dasa_, hlüs, _ihue, _ikee,
   {{0x7522d094,0x2fcddf15,0x6009e04e,0xdb0d00c4}},	//   _edoz, sleg_, нном_, _skað,
   {{0x26cd8037,0x44313f16,0xc984a04d,0x5b25c13a}},	//   _hyeo_, juz_, _тути, _مفضل,
   {{0xc105c049,0x24894194,0x7c29df17,0x6f1980c2}},	//   _صوتي, kyam_, prer, nawc,
   {{0x661d04a6,0xd945e501,0x27ed9f18,0x1545efdb}},	//   gssk, _бели, _mien_, _белм,
   {{0x6d5d4761,0x2005e1f6,0x291901e7,0x2d8dd662}},	//   _aasa, ppli_, aasa_, lkee_,
   {{0x69c98af8,0x2258e065,0xb184204a,0x6288e0c2}},	//   _okee, ærkt_, šťov, cydo,
   {{0x7f5d4004,0xf1bb0219,0x6f18a29c,0x5de64e12}},	//   _casq, _उदयन, zavc, ужба,
   {{0xb5fb00e0,0x629bc618,0x7db6268c,0x3a3fc907}},	// [1ee0] lván, nzuo, _مصدا, ntup_,
   {{0x69c5600e,0xdcfaa2d1,0x69df0197,0xe29a62fe}},	//   gohe, _potč, _èper, наз_,
   {{0x6da6426f,0x6289c07d,0x0c266df6,0x69db8049}},	//   _бина, hyeo, умен, _bhue,
   {{0xeb978878,0x66040058,0x27ed9f19,0x2f5640ff}},	//   лих_, _ktik, _cien_, _стос,
   {{0x69c56483,0x6f160037,0x6d43a17b,0x80cae969}},	//   bohe, _meyc, ffna, _सुने,
   {{0x59d84ef3,0x7d161e1b,0xea002067,0xdcfc6b23}},	//   _भीतर, _leys, _ngẫu_, _korč,
   {{0x44324c96,0x5694a2a3,0x443fdf1a,0x4c94a2a3}},	//   luy_, райт, etu_, рийс,
   {{0x7d0d8069,0x3ced0552,0x7df3e12a,0x224053c8}},	//   ðast, ževi_, _găsi, otik_,
   {{0x2fc5e105,0x7bdc74f4,0xf8b440c2,0x69c609e6}},	//   folg_, _khru, ंपिय, doke,
   {{0x2fc68374,0x7e6dc480,0xaa93813a,0x63a9cd7e}},	//   loog_, _šapc, _الكث, aien,
   {{0xf363e1ba,0x63a8ff1b,0x58d4f3f9,0x973ce274}},	//   стын, ridn, ронт, lićk,
   {{0x7dd600e0,0x6d5e3f1c,0x16200028,0x3946c0f2}},	//   tása, _aapa, _बिखर_, _ubos_,
   {{0x1439c050,0x7bc56167,0x443fdf1d,0x69dc7f1e}},	//   _لينک_, yohu, ctu_, _ohre,
   {{0xf99f65cd,0xf237c1a9,0x61ee6057,0x1a9bc00b}},	//   _jwèt_, _ערוץ_, _nibl, _אידע,
   {{0xfbd341ac,0xee3f01ce,0x395dc022,0xe91940ff}},	//   متر_, stý_, _yaws_, кові_,
   {{0x395dc05f,0x69c61f1f,0x67240320,0xa1585043}},	//   _xaws_, coke, _gdij, ласу_,
   {{0x248d2041,0xdb08e1ae,0x2d82435f,0x6560c049}},	// [1ef0] ņem_, vidê, _doke_, idmh,
   {{0x69dc7f20,0x63a9df21,0x6d5e3f22,0x69c9977b}},	//   _chre, zien, _gapa, _skee,
   {{0x248948a7,0x2d82407d,0x2cae403c,0x7bdc6256}},	//   syam_, _foke_, _əldə_, _dhru,
   {{0x7a474041,0x201eeaf1,0x2eb0810a,0x2837e00b}},	//   tītā, isti_, जपूत, רנאך_,
   {{0xe6d30029,0x69dc66a5,0xb5fb005c,0xfe35400b}},	//   _सरोज, _fhre, zván, _דאָך_,
   {{0x69dc628f,0x27ed9f23,0x61e28e27,0x7bdc628f}},	//   _ghre, _wien_, amol, _ghru,
   {{0x32095f24,0x6f1aecb1,0xf53820be,0xa8064121}},	//   lpay_, datc, אטור_, rtış,
   {{0x0c25cb67,0x637cc0e0,0xf625c520,0xd3468050}},	//   амин, _kény, адио, _نیمه_,
   {{0x69c73f25,0xd347a050,0xbb84813a,0x7bc72041}},	//   koje, _میشه_, _القي, koju,
   {{0xb4db40f9,0x2007a069,0xd49ba1e3,0x7bc60ee2}},	//   _abàk, ppni_, _пре_, woku,
   {{0x7bc61f26,0x6595df27,0xa3c307d3,0x395dc223}},	//   toku, _кажу, ्तं_, _taws_,
   {{0x6b82df28,0xfc30a50f,0x6fd06156,0x800ae0e0}},	//   _goog, _رحم_, täck, کریہ_,
   {{0x6f0905e0,0x201ee04e,0x395f9f29,0x6d5e3f2a}},	//   ñeca, asti_, _maus_, _papa,
   {{0x2d825f2b,0x765aa0e2,0x6e2d4af1,0xdcfc6098}},	//   _soke_, _ysty, drab, _porč,
   {{0xa3d5846f,0xa3c2ff2c,0x443e2004,0x6b83e8fc}},	//   हता_, ंवर_, ît_, _iong,
   {{0x7bdc7f2d,0x395f9f2e,0x7d1bda3c,0x3869017a}},	//   _shru, _naus_, naus, _frar_,
   {{0x637cc043,0x61ee65cd,0x443f8022,0x2360576e}},	// [1f00] _pénz, _pibl, _nqu_, rdij_,
   {{0x2d825f2f,0xdb08ff30,0x31601f31,0x645a20c4}},	//   _woke_, vidë, _haiz_, ætis,
   {{0x7d1bdf32,0xf3c961ac,0x7d0d5f33,0xed576b7a}},	//   kaus, ابقه_, bbas, рох_,
   {{0xdb1c6277,0x614692d5,0x395f9f34,0x6b83edee}},	//   _skrä, реда, _caus_, _long,
   {{0x06e4407c,0x7d1aee05,0x20568197,0x31601f35}},	//   _ফ্রি, yats, ртер, _maiz_,
   {{0x6b83f09d,0xdb08e5df,0x6b9601cd,0x0eba2028}},	//   _nong, cidè, _llyg, _उखाड,
   {{0x6609dbc3,0x6b9600fd,0x2eaed9a7,0xd017a772}},	//   epek, _olyg, ञप्त, афы_,
   {{0x31600265,0xdb08ff36,0x9f45c057,0x4422512c}},	//   _naiz_, midé, _zulú_, _kvk_,
   {{0x9f4ca026,0xcb67c55a,0x179b8087,0x4feaa103}},	//   _lidé_, рање_, _סימב, _аман_,
   {{0x3a2048c4,0x23c66a30,0x80f5298a,0xfc4ac031}},	//   isip_, वविद, _आलेख_, _abíó_,
   {{0x244080d1,0x6f0d5b66,0x201ef446,0x395f8286}},	//   lòm_, ybac, usti_, _yaus_,
   {{0x80bfaaa1,0xa91d816d,0x0446c4a9,0x44225f37}},	//   _लुटे, _koža, _ведн, _ovk_,
   {{0xda198064,0x37cc407c,0xfaff000e,0x23c66077}},	//   नीपत_, লগার, rcë_, ववाद,
   {{0x65608515,0x29024054,0xdb1c23e4,0x44205f38}},	//   _lamh, _afka_, torá, dsi_,
   {{0x69c042d1,0x44205f39,0x7bc72f68,0x6441e62c}},	//   čmen, esi_, roju, ctli,
   {{0x3f837f3a,0x637da5cd,0x65609480,0x8cddc5aa}},	//   _soju_, _dèny, _namh, _परमो,
   {{0x7c2d5f3b,0xdce6403b,0x395f9f3c,0x6f172071}},	// [1f10] urar, _mokė, _raus_, _texc,
   {{0x973ce29c,0x3866864e,0x7d1d1f3d,0x753b812a}},	//   fići, dvor_, lass, _scuz,
   {{0x3f8480ce,0xfbd040e0,0x7d0d462c,0x7d18e106}},	//   _bomu_, ستہ_, pbas, _mevs,
   {{0xdb09c200,0xf6502043,0x4422417b,0x395f8022}},	//   rieë, _کئی_, _fvk_, _qaus_,
   {{0x645a21d7,0x69c8f84e,0x29187629,0xe8200028}},	//   ħtie, kode, _fera_, _बिछा_,
   {{0xdb09c3c5,0x973ce20d,0x69c8e071,0x395f80a2}},	//   pieë, bići, jode, _waus_,
   {{0x7dcda7a1,0xe8df6081,0x395f8286,0x69c8ff3e}},	//   dúst, _trực_, _taus_, dode,
   {{0xa3d7466f,0x6f1d069d,0xdb00c3e4,0x23bac041}},	//   िति_, jasc, timá, tīja_,
   {{0x7d1bd3e0,0x291d9f3f,0x6f1c235f,0x31600e06}},	//   raus, mawa_, yarc, _raiz_,
   {{0x7d1c28ad,0x6b9ae163,0x69c8ff40,0x614187fc}},	//   xars, ghtg, gode, báló,
   {{0xe6b3a555,0x6b83f126,0xd3e6a062,0x645d4071}},	//   _بلاگ, _vong, _اقلی, _lssi,
   {{0x68ed805c,0x645d4e54,0x568ca00b,0x6b83e173}},	//   žadu, _ossi, _שטאַ, _wong,
   {{0xe8d9e016,0x6561a04a,0x7643a07d,0x69c12066}},	//   _đổ_, _kalh, ltny, člen,
   {{0xdcfe2055,0x7dcda019,0x237fc07f,0x9103214a}},	//   _topč, cúst, ljuj_, зпре,
   {{0x6561b629,0xe0d1eca7,0xdcfaa12a,0x6f1d0c48}},	//   _malh, _عزت_, _hotă, basc,
   {{0x29194510,0xa3c9c05e,0x969603b7,0x2d85a0f9}},	//   _cesa_, ोति_, _грош, _lole_,
   {{0xa9674f4a,0x61e44fc3,0xa3ba2050,0xcaf6613a}},	// [1f20] щита_, rmil, _مادر_, مساب,
   {{0x6fdd02b2,0x2d85a6be,0x3a204939,0x8af0403c}},	//   réce, _nole_, rsip_, ddət,
   {{0x291d8068,0x799bc05d,0x644f4071,0x291940e8}},	//   fawa_, khuw, _epci, _fesa_,
   {{0x7bc8ff41,0x7d19c40f,0x38cb8062,0xbddb3f42}},	//   zodu, _news, گامی_, ntèn,
   {{0x29187f43,0x260c610a,0x653b000b,0xf3f1a119}},	//   _tera_, डीजी_, רענד, _bị_,
   {{0xdb1e6057,0x6d4bd047,0x6d565f44,0x9b966049}},	//   bopá, _abga, leya, _الست,
   {{0x60db8096,0x7d1d15a6,0x442f8256,0x6443a065}},	//   _ezum, yass, arg_, gtni,
   {{0xb5fb413a,0x77645f45,0x7c24006e,0xd90dc6b0}},	//   _srái, ndix, _ovir, نیم_,
   {{0x3f85a098,0xd6d0c13a,0xf8dc8046,0x55774053}},	//   _folu_, بقة_, _बरिय, מעקן_,
   {{0x2d85bf46,0x25a906bf,0x628e203b,0xf3f1a079}},	//   _gole_, _smal_, kybo, _gị_,
   {{0x26c00037,0x6f0900b6,0x6fd886c7,0xcb136008}},	//   _axio_, ñeco, níco, הלת_,
   {{0xc6936053,0xdb1aa3d1,0x69dac049,0x798641a5}},	//   פאר_, _aktø, _صباح_, _nokw,
   {{0x7c22c098,0xb901037f,0x6d565f47,0x6e2282e0}},	//   _uvor, _थर_, deya, nsob,
   {{0x61fabf48,0x5694f521,0xd010e4c7,0xa91d9f49}},	//   _kutl, _малт, _قلت_, _nožn,
   {{0x6f029f4a,0x7afdc066,0xdb0aa1ab,0x6f1d1f4b}},	//   kcoc, žste, rifè, pasc,
   {{0x291a20f9,0x6d48ff4c,0x0615454a,0x27e007ad}},	//   _eepa_, lfda, ждаю, _ghin_,
   {{0x7d0280ae,0xdced01f6,0xdb00c052,0x2919515e}},	// [1f30] dcos, _flaġ, mimä, _vesa_,
   {{0x63bb8277,0x628f0011,0x753aff4d,0x44236037}},	//   _sjun, myco, ngtz, _pvj_,
   {{0x9f842046,0x64445f4e,0xdb01e22e,0x1bf24148}},	//   töö_, atii, bilæ, _आंचल_,
   {{0x398ba654,0x69d520cb,0x555520e0,0x333ea229}},	//   _løst_, llze, _اپگر, _actx_,
   {{0x6561a1ae,0xb5fd849f,0x6444412a,0xaacfe914}},	//   _palh, _krši, ctii, _सुनक,
   {{0x7761a5fc,0x2409ad59,0xdb1560ca,0xbddb60d5}},	//   _qalx, анки_, _ekzò, _epèr,
   {{0xeae5c07c,0x4999c8ea,0xb5fd8299,0xcfe9813a}},	//   _নভেম, ития_, _mrši, _نفسه_,
   {{0x91f90029,0xdb1c21ae,0x644578bf,0xc005c4a7}},	//   ंदाज_, porç, mthi, опик,
   {{0x6561ac9d,0xb17b0584,0x7643bf4f,0x6b9bdf50}},	//   _talh, rmål, stny, rhug,
   {{0x7d1abf51,0x6f1b926c,0x6d8b203c,0x7643a037}},	//   _gets, _heuc, _müas, ptny,
   {{0x7d1b87e7,0x764561cd,0xb5fb41ae,0x7dd069f6}},	//   _keus, nthy, _gráv, mäst,
   {{0xa2aac010,0x660d5f52,0x6d576025,0x98b36013}},	//   _जेव्, kpak, hexa, ždės_,
   {{0xa2d0c077,0x6f1b832a,0x44220013,0x44447f53}},	//   _डुप्, _meuc, usk_, zt_,
   {{0x6f029f54,0x200dd77e,0x7d1b81b9,0x6d4d097e}},	//   zcoc, mpei_, _leus, _ebaa,
   {{0x6d9cc13a,0x2b4d8326,0xbc19e488,0x394d805d}},	//   _féad, _obec_, _тілі_, _obes_,
   {{0x7c24003b,0x6d4d11b0,0x7c228707,0xdcfbc0a9}},	//   _tvir, _gbaa, ysor, kjuč,
   {{0x2d87ff55,0x6563e1e2,0xdb03a04a,0x05aa7f56}},	// [1f40] _kone_, _kanh, ziná, авай_,
   {{0x394d805d,0x38601f57,0x5bd28c4c,0x6d5657c2}},	//   _abes_, _isir_, तत्व, seya,
   {{0x7d1b8153,0x7bcb8912,0x66098f60,0x77640108}},	//   _beus, fogu, _atek, _kaix,
   {{0x6563f7bd,0x7d1b858f,0x6f1b8733,0xa96a42af}},	//   _lanh, _ceus, _ceuc, _тима_,
   {{0xb51e2033,0x6f1b903c,0x7bcaa475,0x7c838052}},	//   _बजाय_, _deuc, tofu, дуще,
   {{0x64a66056,0xf806abdb,0x291aa6db,0x61fb8054}},	//   _дага, очин, úpa_, _duul,
   {{0x66098916,0x39583308,0x7f49ce39,0xe9df207b}},	//   _etek, iers_, ffeq, ntúa_,
   {{0xdb03a942,0x776405df,0x207b6053,0x65641655}},	//   riná, _naix, _דאלא, _naih,
   {{0xef1f03df,0x395828c3,0xe2978d94,0x66094106}},	//   kkür_, kers_, _дат_, _çekt,
   {{0x7dd069f6,0x212904b4,0x6563f955,0x6729948f}},	//   mäss, _sdah_, _canh, _zdej,
   {{0x7dd07f58,0xb7db600b,0x22468eac,0xe4fb600b}},	//   läss, שקיי, ltok_, יפיש,
   {{0x6b8294b6,0xf1bf2026,0x9f5200d1,0x37ab045c}},	//   njog, hrát_, _jiyè_, ртон_,
   {{0x7c38a4ad,0x80cae180,0xdce9c579,0x39583b1d}},	//   luvr, _सुरे, bjeđ, fers_,
   {{0x291eff59,0x7c245f5a,0x4424c071,0x645c21cd}},	//   qata_, dsir, msm_, fwri,
   {{0x2b91c067,0x5f950052,0x769101e9,0x291ceaf1}},	//   _bách_, _никт, _bóyú, _ieva_,
   {{0x77640265,0x6d58a134,0x7dcfe271,0x25db20c2}},	//   _gaix, heva, søst, _खीरी_,
   {{0x6d577f5b,0x69cb9f5c,0x518724d4,0xd50b6396}},	// [1f50] texa, voge, _дуна, لغان_,
   {{0x78a2806f,0x26c12022,0x6564005d,0x80ddce74}},	//   dzov, _txho_, _zaih, _परसे,
   {{0xdb060de2,0xc8d23f5d,0x7dd0604e,0xe9df207b}},	//   liká, _दुपट, väst, ctúa_,
   {{0x443247ac,0x6f044024,0x4424c05d,0x6d4e600d}},	//   bry_, ccic, ksm_, _ebba,
   {{0xea008016,0xdb061f5e,0x224688b2,0xee38819d}},	//   _đảm_, niká, gtok_, жні_,
   {{0x4e164095,0x6b9d000e,0x57f46052,0x29dc8057}},	//   _מחשב_, ërgj, _опят, ríaa_,
   {{0x4426d9ae,0x2d9eff5f,0xdb0d41de,0x98bf8012}},	//   _avo_, dhte_, gnaç, _obuć_,
   {{0x6563e4ec,0xe619c7c1,0x7d1c6105,0x63ad008b}},	//   _sanh, бди_, _zers, _nman,
   {{0x6f1d521e,0x3964a04e,0xa2cd2b5b,0x753bc1df}},	//   _mesc, össä_, _दुस्, rguz,
   {{0xdb0603e4,0xdb1640e0,0x10a5f77e,0xdbd702df}},	//   diká, rnyé, зион, hääl,
   {{0x39582dee,0x5fbd591c,0x2ef5cd9a,0x9ad36079}},	//   vers_, ्काल, _езер, _dịgo,
   {{0x9f589f60,0x6ee10088,0x8c4960b0,0x8c4886fa}},	//   _puré_, _ịban, maşı, bağı,
   {{0xe72eee14,0x63ad1f61,0x8c4963df,0x644baa14}},	//   _пе_, _dman, laşı, žnič,
   {{0xdca5e491,0xaca3e096,0x39583f62,0x656401b4}},	//   _нали, _ahụi, uers_, _waih,
   {{0x6d59835f,0xe29739b5,0x09e642d8,0x251ae1a9}},	//   kewa, пар_, зовн, _הוצא,
   {{0x63ad0af2,0x44325f63,0x3a260e37,0xb883804a}},	//   _gman, try_, _емиг, _klíč,
   {{0x291dc031,0x88d1a07c,0x395838ab,0xa3c18d01}},	// [1f60] _mewa_, াধিক, pers_, ुवन_,
   {{0x7521e576,0x44443f64,0x7dd06052,0x6fd6006f}},	//   nalz, _tq_, väss, dáci,
   {{0xc332e095,0x27e94c8a,0x7d1d5f65,0x6f044098}},	//   תוב_, bman_, _fess, pcic,
   {{0x69ce22e8,0x7d1e2121,0xe73a968a,0x200763b8}},	//   lobe, _heps, сед_, ínia_,
   {{0x63bbdab3,0x65652939,0x2907ff66,0x9f5fe1de}},	//   dnun, _yahh, _ofna_, rquê_,
   {{0xae00a7fd,0x61fc7f67,0x39591ab3,0x78a28530}},	//   _लंदन_, _turl, zess_, rzov,
   {{0x9ea7655a,0x9f483239,0x9f44a0e6,0xb5fb49d0}},	//   _евра_, óhùn_, _sumó_, _frás,
   {{0x7d1e3f68,0xa91ca06f,0xb886e057,0x9f5840b6}},	//   _leps, _koľk, _laíñ, mpró_,
   {{0x98b1a041,0x4427faba,0xdca395cb,0xdcfc2041}},	//   ībām_, _avn_, _зати, nkrē,
   {{0xdce08432,0x2b942156,0x6721f241,0x61e2c095}},	//   _jamč, _däck_, galj, _whol,
   {{0xdb0f0057,0xa9350cde,0x6720c00e,0x7bce3f69}},	//   licé, менш, pamj, dobu,
   {{0xdb061f6a,0x27e94d8d,0x61e2d842,0xdb03a1de}},	//   tiká, xman_, _uhol, tinç,
   {{0x25a05f6b,0x6d42c0ba,0x61e41f6c,0x4427ff6d}},	//   dhil_, _icoa, _dhil, _evn_,
   {{0x69ce200d,0x7521e12a,0xa3dd0033,0xdce08098}},	//   gobe, calz, _तीर_, _namč,
   {{0xa2cd3733,0x660966be,0x61fe3f6e,0xbef7e13a}},	//   _दुश्, _čeko, _cupl, _عروض_,
   {{0xf1bf22ee,0x1cbbe095,0xb5fd838a,0xddc420e4}},	//   trás_, _למוע, _kršt, _vriš,
   {{0xfbdca0a3,0xb5fb41e9,0x7d057f6f,0xddc2e04a}},	// [1f70] यताम, _arár, tchs, _spoř,
   {{0xe7e106a8,0x213ee095,0xfd56e1e9,0xf1bf23cb}},	//   _गीता_, ngth_, _angẹ, rrás_,
   {{0x6f1d5f70,0x2d8a7f71,0x799b8c57,0x660d0167}},	//   _tesc, _dobe_, _pluw, _htak,
   {{0x9cb581ac,0x291ea1e7,0x6d41bf72,0x69d8ad53}},	//   ومات, _aeta_, _scla, elve,
   {{0x6b898200,0x957ce013,0x6b9b8854,0xb5fb4942}},	//   _voeg, rmąj, _vlug, _vrás,
   {{0x6448f2cf,0xb90b20f9,0x2d8af006,0x4425e04a}},	//   ktdi, _adiẹ_, öbel_, ysl_,
   {{0x7d060156,0x246ce04a,0x7e62c082,0x798983c5}},	//   ycks, _něm_, _asop, _toew,
   {{0x96272018,0x8c496315,0x672d1abf,0xaad0e148}},	//   _ieņē, raşı, _ndaj, _हड़क,
   {{0xb5fd864e,0x69ce23cf,0x7bce2bd4,0xf771e25b}},	//   _pršu, yobe, yobu, ناد_,
   {{0x6d5ae8cd,0x6d4d4025,0x9f5320fa,0xbebb4155}},	//   geta, hfaa, _fixé_, _geëe,
   {{0xdb18a05c,0xdb03a845,0x2369407f,0xee36e1fc}},	//   nový, rinä, kdaj_, мнэ_,
   {{0x2905f66b,0xb605d019,0x23694022,0x7bcf0057}},	//   scla_, _pešč, jdaj_, gocu,
   {{0xe9cee1c0,0x69c36e9d,0xa3cacc87,0xdb18a066}},	//   _ак_, čnej, लकर_, hový,
   {{0x6b8bdf73,0x69d98e0d,0x291e3de2,0x22494e1f}},	//   _hogg, hlwe, úta_, dtak_,
   {{0xd5b24049,0x29090071,0x6448e2a4,0x7d098088}},	//   نفس_, _ffaa_, ctdi, _ofes,
   {{0x213fcd3d,0x7c2613f0,0xaca380f9,0xdb18a326}},	//   nguh_, pskr, _afọn, dový,
   {{0xdb08ff74,0x656641e2,0xb9b30049,0x70dc80c2}},	// [1f80] lidá, _vakh, _جميع, _बरेल,
   {{0x7523bf75,0x60c4a0b0,0x7afb9f76,0x386ddf77}},	//   janz, şimi, _agut, iver_,
   {{0x28afc0a8,0x7c3bd7dc,0x59adc028,0xdb1aa0d1}},	//   _जेसि, huur, टफार, _oktò,
   {{0x69c1a143,0x3f8b4361,0xf1bf3f78,0xa91ca02e}},	//   _ajle, _gocu_, nsán_, _toľk,
   {{0x925a80a4,0x386dc200,0x7769c054,0xdb0e6069}},	//   تشار_, jver_, ddex, þjón,
   {{0x2906841a,0xdce44066,0x2d982009,0x7c3bdf79}},	//   scoa_, ndič, nkre_, duur,
   {{0xeb9a9f7a,0x443a600e,0x291f818c,0x61eab8da}},	//   _див_, qup_, _feua_, rmfl,
   {{0x6f1641cd,0x88bca0a3,0x7afb8614,0x3942c046}},	//   nbyc, _oděv, _ggut, üks_,
   {{0x2616e0c5,0x7dd88071,0xfd652119,0x6e3c27d4}},	//   _भौजी_, jísi, _chuồ, hurb,
   {{0xb33b4121,0x6fd8806f,0x6e3c20c4,0x67244363}},	//   _ilçe, díci, kurb, haij,
   {{0x80d6e07c,0x6b8bcd8f,0x657aa1fb,0x01376076}},	//   ডেন্, _fogg, _inth, ורית_,
   {{0x6600866b,0x20000194,0x6e3640c2,0x14afc04b}},	//   _kumk, _buii_, kryb, _जेवण,
   {{0x16dc82cd,0xc324607c,0x02e2cba0,0x67208058}},	//   _बरोब, _পানি_, _परिभ, _memj,
   {{0xa5bb2069,0xe8dfe067,0xdb08e057,0x2d8cbf7b}},	//   msók, _giỏi_, bidá, _jode_,
   {{0x2d8b4361,0x4bdb0049,0x8afee0e8,0x0463e0fb}},	//   _poce_, _وبعد_, _haƙo, _атым,
   {{0x2b49a3ce,0xdb18a066,0x6f0de490,0x5edd607c}},	//   đaci_, vový, _đaci, _বললে,
   {{0xdb02c1ae,0x27f87f7c,0x443ca048,0x7523a2ad}},	// [1f90] _emoç, _birn_, huv_, yanz,
   {{0x6568bf7d,0x7f5d07df,0x7c3c2265,0xdce1a098}},	//   _nadh, lesq, burr, _salč,
   {{0x473588ba,0x6e3d1f7e,0xdce1a12d,0xc178e013}},	//   енес, lusb, _palč, lmės_,
   {{0x75208071,0x4427a098,0x386dc46b,0x63b53f7f}},	//   _cemz, vsn_, yver_, lizn,
   {{0x92bba07c,0x6e3d1f80,0xdb03b88a,0xa509b342}},	//   _ঘরে_, nusb, minú, пела_,
   {{0x3edf0088,0xa3ab4e8e,0xfce5a7f7,0x6fd6007b}},	//   _arịọ_, कोर_, ноло, láct,
   {{0x37d6007c,0xa5c5a1e9,0x6568a011,0x2d8cad53}},	//   _সংঘর, _akóì, _dadh, _dode_,
   {{0xa2d624da,0x6568a28f,0x36d580ff,0x8afee0e8}},	//   _मुफ्, _eadh, _зобр, _baƙo,
   {{0xa3df3008,0x2d8ca1ae,0x69c2df81,0x7bc2c653}},	//   तता_, _fode_, _djoe, _djou,
   {{0xdaa9ebd2,0x7dd880c4,0x61ed5f82,0x3f8ca018}},	//   звод_, vísi, hmal, _godu_,
   {{0x61460520,0x917be067,0x752f40c2,0x672f4320}},	//   нена, _về_, _odcz, _odcj,
   {{0x6721bf83,0xa96a060f,0x6dbc8133,0x386040fd}},	//   _helj, чима_, včak, ywir_,
   {{0x7524403b,0x02cfe8ae,0x7f5c21ea,0x6601bf84}},	//   vaiz, _सुरभ, terq, _hulk,
   {{0x6721a143,0x81bd0018,0xa2caf065,0xd945ee64}},	//   _jelj, nsēj, _सुक्, _чеки,
   {{0xe299e139,0x7dd8807b,0x959a40ba,0x34dc9133}},	//   _хай_, sísi, птау_, _बर्द,
   {{0x69d56105,0x6fd61f85,0x7c3c235f,0x6d41f420}},	//   _akze, tácu, rurr, lgla,
   {{0xb4ea4010,0x7d16575d,0x97c3409e,0xea002067}},	// [1fa0] मधे_, rbys, уйте, _thắt_,
   {{0x65a0603c,0x7d1640e2,0x7ae40174,0x6c33413a}},	//   _söhb, sbys, _izit, افلا,
   {{0xfc3f0066,0x9f47e0f9,0x38605a31,0x644abf6f}},	//   nzín_, _binú_, swir_, xtfi,
   {{0x6568a047,0x6db2a064,0xd7078a75,0x63a28098}},	//   _sadh, ałal, енце_, uhon,
   {{0xdb00c0dd,0x3f9ea07d,0x63a45f86,0xa3bf404b}},	//   shmë, _pltu_, mhin, ेवर_,
   {{0xf1bf0326,0xa2cb6021,0x764aa156,0xcebae0a2}},	//   zná_, _तुक्, ttfy, _leƙa_,
   {{0x3afb200b,0x6601a0ca,0x6d5d0c55,0xa2e361b1}},	//   פּגע, _culk, yesa, _борд,
   {{0x7c3e6098,0x49086026,0xff5f03bb,0xf1bf002e}},	//   mupr, ाँको_, noît_, xná_,
   {{0x67260037,0x61f8e04d,0xe60fc63b,0xe73abf87}},	//   dakj, _pivl, یشی_, _неа_,
   {{0x2124c6a5,0xc6a6e1fc,0x29d74017,0x6d40c057}},	//   samh_, ерми, lçat_, sgma,
   {{0x3636a6b0,0x68e41f88,0x7ae406e6,0x44294ed8}},	//   _سراس, _azid, _azit, zsa_,
   {{0x23a46277,0x7c3d02df,0x2d83e156,0x9f4ee0f9}},	//   _höjd_, tusr, öjer_, _difá_,
   {{0x4429403c,0x7c29c009,0x61fabf89,0x12c441a6}},	//   xsa_, cser, _kitl, ্ধুদ,
   {{0x6c54e052,0x81dee1a6,0x5334e8ab,0x660fc02e}},	//   _акку, _দূর_, _рект, ícke,
   {{0x7ae41f8a,0x6d5e7602,0xdbd70052,0x443d81de}},	//   _ezit, depa, _pääh, zuw_,
   {{0x6602dc6e,0x2121205d,0x61faa31b,0xb2751f8b}},	//   _kuok, _wehh_, _litl, _алиш,
   {{0x9989606f,0xfc45e066,0x2d87a0c2,0x29183f8c}},	// [1fb0] hrať_, žíte_, yjne_, bbra_,
   {{0x63a44054,0xb6bc0076,0x28d22ba0,0x98c76a8d}},	//   ahin, _מצחי, _दुवि, нсел,
   {{0xbd0560f9,0x55ac200b,0xc7c468c0,0xe5c46399}},	//   _abéè, _זייַ, усти, усто,
   {{0x442b45df,0x6d9ccf1d,0x7f94a5df,0x98b9003b}},	//   _tvc_, _séan, _màqu, nesį_,
   {{0xa3c40969,0x6721ab53,0xd945b6a6,0x273ac6df}},	//   ्वत_, _pelj, вели, zünü_,
   {{0x20d520aa,0x61faa05c,0xdb0f0066,0xdce3e667}},	//   _धडाध, _citl, dicí, _sanč,
   {{0xa066a1e1,0x1866a1e1,0xada5c1d3,0xaca36079}},	//   ваща_, ващи_, какл, _kpọc,
   {{0x442cadee,0x34e1a0c2,0xe7e10028,0x61faa049}},	//   _dvd_, _फरीद, _गीला_, _eitl,
   {{0x25bfc12a,0x20037f8d,0x57f5a52f,0xdd8ec049}},	//   rnul_, _huji_, _апат, توي_,
   {{0x9989603a,0x3946c019,0xdced023d,0x09ca1008}},	//   brať_, _ecos_, _znać, रव्य,
   {{0xa3c0a010,0x7527229f,0xb4e024ef,0xe5a60822}},	//   ीवर_, dajz, _तरे_, вини,
   {{0x764d4106,0x2005e5fc,0x28d22843,0x6722c011}},	//   ktay, rqli_, _दुषि, _geoj,
   {{0x7c24a00a,0xdb052156,0xfe7901ba,0x273ac19f}},	//   ćire, _omhä, нёры_, sünü_,
   {{0x7dd600e0,0x2ca9400a,0x316ddf8e,0x290b0024}},	//   táss, dzad_, ldez_, acca_,
   {{0x224ddf8f,0x442b0049,0x799bc167,0x61ee200e}},	//   ltek_, asc_, okuw, rmbl,
   {{0x7d1b0069,0x25a004b4,0x656bc0f7,0x236dc00e}},	//   ðust, _ulil_, _jagh, ndej_,
   {{0x2fc0483e,0xa7fca602,0x764d4839,0x6603e154}},	// [1fc0] rnig_, _asıl, gtay, _hunk,
   {{0x69c1e31b,0x67240c26,0x75240105,0x70f6613a}},	//   nnle, _heij, _heiz, نسائ,
   {{0xd59b2076,0x179b2076,0x61e99f90,0xe286614a}},	//   _חביל, _חייב, _bhel, ължи,
   {{0x644d50b0,0x99d3a050,0x290d8005,0x61caa39f}},	//   btai, یتوا, _cfea_, ाक्ष,
   {{0x644d5f91,0x91fce041,0x70548ef8,0x61e989ec}},	//   ctai, nvār, انتا, _dhel,
   {{0xa3e28960,0x39942277,0x61e98025,0x35b6a14a}},	//   _नीर_, _gäst_, _ehel, ъщес,
   {{0x7d576989,0x1c396052,0x33f6807a,0xa3bec290}},	//   _שילד_, _пять_, _ачас, ँचल_,
   {{0x91e68974,0x443fc167,0xa91d820d,0xa2a0e010}},	//   _робе, fuu_, _božu, खनस्,
   {{0x6603e2a8,0x6f0d174f,0x6d44573b,0x61fc60b0}},	//   _aunk, _rfac, igia, _kirl,
   {{0xa3e7c2cd,0xa3e44029,0x6f0d0ab8,0x7c24a098}},	//   _मीठ_, _पीस_, _sfac, ćirb,
   {{0x6fd88005,0x61fc60ca,0x7b66c423,0x27e91f92}},	//   sícu, _mirl, _атле, _phan_,
   {{0x9f587284,0xf2d36008,0x2d8fdf93,0x63b8add8}},	//   _diré_, יעת_, _goge_, livn,
   {{0x442d0162,0x9f586005,0x7dd600e0,0x7dd8913e}},	//   ée_, _eiré_, tásr, líss,
   {{0xc7c42052,0x29000265,0x61bd45c5,0x6723ff94}},	//   асси, _egia_, ्क्ष, _genj,
   {{0x93fbe087,0xe1ff40f9,0x752400a2,0x75e5c009}},	//   _קלוי, _aróp_, _feiz, lóza,
   {{0x67272b01,0xad9b61e9,0x44391f95,0xddd9e030}},	//   sajj, _atúp, prs_, _apwň,
   {{0xd7f84bd6,0x3b55612a,0x7523e0bb,0x2d894057}},	// [1fd0] тур_, лкар, _yenz, rjae_,
   {{0x38691f96,0x765aa0c2,0x9c140125,0x63a2df97}},	//   _isar_, _opty, _kọns, _llon,
   {{0x656d0e38,0xa3c8a026,0x61fb9f98,0xf99223c8}},	//   _kaah, ोकन_, _piul, _הרי_,
   {{0x29d74395,0x2d8b009f,0x657d5f99,0x6d93819f}},	//   rças_, njce_, _unsh, _açar,
   {{0x2004800f,0x69c1e451,0x7ddec00e,0x236ca030}},	//   _cumi_, ynle, mësh, _badj_,
   {{0xe6136949,0x656d0054,0x7c2b89ee,0x261800c2}},	//   _نشر_, _laah, rsgr, बीटी_,
   {{0x7d0d4197,0x6d9cc049,0x6f04849f,0x29d903f6}},	//   ocas, _téal, žica, néas_,
   {{0x61e9846b,0x6440dcd9,0x442d8593,0xdfd5804e}},	//   _uhel, fumi, _tve_, _собы,
   {{0x44399f9a,0x7528e058,0x3f9160e4,0x644d0223}},	//   _ís_, fadz, _kozu_, _nqai,
   {{0x6dbc850e,0x60dd405d,0xea002067,0x66041edf}},	//   učav, _mysm, _giặt_, _ruik,
   {{0x20049e68,0x660405ac,0x7ddec00e,0x6aa9c0e0}},	//   _zumi_, _suik, kësh, szef,
   {{0x2d916274,0xf770c230,0xcd2bc63b,0x3f91620d}},	//   _loze_, _وان_, _آسان_, _lozu_,
   {{0x7523fad6,0x6728e361,0x6723ea19,0xff04c14a}},	//   _tenz, badj, _tenj, _тяхн,
   {{0xfc0307e0,0x290dc12a,0xa06a2362,0xa3e7c046}},	//   спро, lcea_, нага_, _मीत_,
   {{0x7e96e711,0x61fd5f9b,0x21294625,0x5a952841}},	//   _منور_, _bisl, faah_, артф,
   {{0xdb1c20c2,0x77a60071,0x61fd4089,0x69c76194}},	//   toró, _bóxe, _cisl, _ajje,
   {{0x3f91605d,0x4e1d0064,0x442004ec,0xd9e3a010}},	// [1fe0] _bozu_, बीआई_, _uwi_, गतात_,
   {{0x7f498019,0x7d0d4005,0xdb1d0057,0xaca3c125}},	//   _aceq, acas, bosó, _nkọk,
   {{0x527628e9,0x3f917cea,0x656d0167,0x6f0d40ae}},	//   _супу, _dozu_, _yaah, bcac,
   {{0x6f0d5f9c,0x42ca8618,0xafdb2271,0xd24f0555}},	//   ccac, нген_, støt, _بنی_,
   {{0xb4e2c028,0x70e2cd01,0xdb0f0019,0x84e66028}},	//   _धरे_, _परेल, nicá, _करवट_,
   {{0xa3e60518,0xb4266566,0x7bd9c096,0x63a41f97}},	//   _बीस_, _معرو, _akwu, _llin,
   {{0x6561e1dc,0x7ddec00e,0x201820d1,0x52e10afa}},	//   delh, lësi, npri_, _नर्स,
   {{0x63a40187,0x69d5264e,0x5f94db47,0x2005b225}},	//   _nlin, zoze, риит, _duli_,
   {{0x7ddec00e,0x48e3816c,0x28db2969,0x69c45f9d}},	//   nësi, _готв, _मुनि, inie,
   {{0x66064035,0x317ea00a,0x2609c1af,0x645c605d}},	//   _mukk, _untz_, _dúo_, _kpri,
   {{0x7641ff9e,0x69dabea3,0xdce3e041,0x7d1bdb3d}},	//   guly, _ikte, _panā, bbus,
   {{0x63a408cd,0xdc9b6095,0x645c7f9f,0x7528faee}},	//   _clin, גיטל, _mpri, sadz,
   {{0x27e05fa0,0x25b90098,0x6b9d1259,0xdce77fa1}},	//   dlin_, risl_, rksg, _rajč,
   {{0x244e6d3f,0x9f49413a,0x2005a068,0x656e79d0}},	//   kým_, rmaí_, _yuli_, _nabh,
   {{0x2d91776e,0xd084204e,0x9f47e04a,0xddc2e06e}},	//   _roze_, быти, _jiný_, _krož,
   {{0xc27be087,0x69d65fa2,0x2d9200a2,0xdb03a066}},	//   _טרוי, goye, _goye_, diný,
   {{0x7bdaa92d,0xa9c72343,0x61fd5fa3,0x656e7fa4}},	// [1ff0] _oktu, _مزدو, _visl, _babh,
   {{0x6606457b,0x61fe2006,0xbe8f41e9,0x7c2f0ce5}},	//   _dukk, _gipl, _aṣáj, mscr,
   {{0x2d9ef2fb,0x27e05fa5,0xddc2e06e,0x6d4affa6}},	//   ikte_, blin_, _orož, _mcfa,
   {{0xd5674421,0x9327801e,0x656e6420,0x7127868c}},	//   _стоп, اران, _eabh, ارال,
   {{0x63baed3d,0x15f6e029,0xc324607c,0x8afee020}},	//   kitn, ीदार_, _পারি_, _daƙi,
   {{0x629ae03b,0x69c3a232,0x3946803b,0x645d53c7}},	//   kyto, unne, agos_, _ipsi,
   {{0x61ed0098,0x442dc543,0x39544057,0x6e22c434}},	//   _ohal, wse_, _éasí_, _awob,
   {{0x2d9ee3c5,0xe3b380d0,0x6441ffa7,0x69daa14f}},	//   ekte_, _طرز_, vuli, _ekte,
   {{0x2006c067,0x23a46156,0xa3d90033,0x7a08e04a}},	//   _cuoi_, _höja_, ़कन_, _dětm,
   {{0x27e049c0,0x63bae5c8,0x6e3bc32a,0xe0d08ef8}},	//   zlin_, gitn, rrub, _رزق_,
   {{0x9f9745df,0x6e3bc156,0xb17aa00b,0x28cfef30}},	//   nçó_, srub, _שטער, _सुखि,
   {{0x645d5fa8,0x442fc4fa,0x7643aeca,0xa2b86738}},	//   _opsi, _tvg_, muny, ्पत्,
   {{0xfe09e016,0xdd14806f,0x8f9ac095,0xdb01a004}},	//   _bắc_, núši, _שיני, _allé,
   {{0x6d4733f0,0x3f8dc274,0x27e05ade,0x66065fa9}},	//   ggja, ljeu_, wlin_, _rukk,
   {{0x7643bfaa,0x7ae98098,0xf5064624,0x44236022}},	//   nuny, _lzet, изво, _nwj_,
   {{0xd1ba0043,0x4ad97d6a,0x212b1fab,0x66064e9b}},	//   _جاتا_, _बुधव, cach_, _pukk,

  };
  // table_hash = 5447-cf0f, unused_entries = 0 (0.00%)

static const uint32 kQuadChrome0122_16_2SizeOne = 8108;  // One-langprob count
static const uint32 kQuadChrome0122_16_2IndSize = 8108;  // Largest subscript
static const uint32 kQuadChrome0122_16_2Ind[kQuadChrome0122_16_2IndSize] = {
  // [0000]
  0x00000000, 0x00000000, 0x080c03a7, 0x20005504,   // -- --  nl.sv.no_532 rw.sq.un_320
  0x0000050f, 0x00001903, 0x00006b0a, 0x00002801,   // fr.un.un_600 gl.un.un_300  ceb.un.un_500 sw.un.un_200
  0x24000118, 0x0000120f, 0x00003203, 0x00002415,   // iw.yi.un_740 hu.un.un_600  bs.un.un_300 yi.un.un_700
  0x18002719, 0x0000641c, 0x0000200f, 0x00005515,   // gd.ga.un_750 lg.un.un_800  sq.un.un_600 rw.un.un_700
  // [0010]
  0x00001c15, 0x00002103, 0x00001601, 0x0000100f,   // mr.un.un_700 jw.un.un_300  hr.un.un_200 lt.un.un_600
  0x21190a02, 0x32002905, 0x00002b15, 0x0000230a,   // pt.gl.jw_222 sl.bs.un_330  vi.un.un_700 ca.un.un_500
  0x00000f0f, 0x19000b02, 0x16000d05, 0x00000a15,   // lv.un.un_600 es.gl.un_220  cs.hr.un_330 mk.un.un_700
  0x21001219, 0x21003523, 0x1821120d, 0x00000a0f,   // ur.fa.un_750 zu.jw.un_880  ur.fa.ar_554 pt.un.un_600
  // [0020]
  0x00005206, 0x1c091305, 0x00006e06, 0x281852a0,   // ha.un.un_400 bh.hi.mr_333  hmn.un.un_400 ha.ga.sw_322
  0x00000706, 0x00003b0f, 0x00000d15, 0x1c2d0d04,   // it.un.un_400 so.un.un_600  ne.un.un_700 cs.sk.id_332
  0x13000909, 0x1c000909, 0x3b2028a4, 0x010603a0,   // hi.bh.un_440 hi.mr.un_440  sw.sq.so_433 nl.de.en_322
  0x041008ec, 0x04001008, 0x00002d0a, 0x190a0b02,   // uk.be.ru_644 be.ru.un_430  sk.un.un_500 es.pt.gl_222
  // [0030]
  0x00005301, 0x00004a0a, 0x2d000d1a, 0x1300090e,   // ht.un.un_200 yo.un.un_500  cs.sk.un_760 hi.bh.un_550
  0x2d0d31a0, 0x0000640f, 0x182709a7, 0x00001c01,   // az.cs.sk_322 lg.un.un_600  pl.gd.ga_532 id.un.un_200
  0x1e001a04, 0x0312355a, 0x00002d15, 0x00001015,   // tl.ms.un_320 zu.hu.nl_553  sk.un.un_700 lt.un.un_700
  0x00003115, 0x1c131e0c, 0x00001906, 0x1b2825ee,   // az.un.un_700 ms.et.id_543  gl.un.un_400 eu.sw.tr_422
  // [0040]
  0x13090d14, 0x00000f15, 0x08000214, 0x0000121c,   // ne.hi.bh_666 lv.un.un_700  da.no.un_660 ur.un.un_800
  0x2153230c, 0x1000310e, 0x0000130f, 0x18002112,   // ca.ht.jw_543 az.lt.un_550  bh.un.un_600 fa.ar.un_640
  0x00006e0a, 0x0000180f, 0x00000d0f, 0x00001c0f,   // hmn.un.un_500 ar.un.un_600  cs.un.un_600 mr.un.un_600
  0x2a126408, 0x00001703, 0x00000415, 0x10080411,   // lg.hu.mt_443 sr.un.un_300  fi.un.un_700 ru.uk.be_653
  // [0050]
  0x00002115, 0x18002729, 0x0000040f, 0x0000240f,   // fa.un.un_700 gd.ga.un_960  fi.un.un_600 yi.un.un_600
  0x00003b15, 0x32001705, 0x0000100a, 0x00001901,   // so.un.un_700 sr.bs.un_330  be.un.un_500 gl.un.un_200
  0x1e001c02, 0x041a2807, 0x03002d08, 0x12003513,   // id.ms.un_220 sw.tl.fi_432  sk.nl.un_430 zu.hu.un_650
  0x2d000d14, 0x00001e01, 0x1c000d04, 0x00006e0f,   // cs.sk.un_660 ms.un.un_200  ne.mr.un_320 hmn.un.un_600
  // [0060]
  0x32291007, 0x00005306, 0x2100120e, 0x35000912,   // lt.sl.bs_432 ht.un.un_400  ur.fa.un_550 pl.zu.un_640
  0x00000915, 0x0000020f, 0x2d000d0e, 0x00002b0f,   // pl.un.un_700 da.un.un_600  cs.sk.un_550 vi.un.un_600
  0x00005215, 0x00000e15, 0x321716a9, 0x321629a4,   // ha.un.un_700 is.un.un_700  hr.sr.bs_544 sl.hr.bs_433
  0x040a07ec, 0x13551a07, 0x0000290f, 0x00002d0f,   // bg.mk.ru_644 tl.rw.et_432  sl.un.un_600 sk.un.un_600
  // [0070]
  0x0e1c21a0, 0x00000b01, 0x2d1c35a0, 0x0600040e,   // jw.id.is_322 es.un.un_200  zu.id.sk_322 fi.de.un_550
  0x1200350d, 0x0804170c, 0x0000010f, 0x1c000905,   // zu.hu.un_540 sr.ru.uk_543  iw.un.un_600 hi.mr.un_330
  0x1e006402, 0x0000680a, 0x0000111c, 0x19000b05,   // lg.ms.un_220 ig.un.un_500  ro.un.un_800 es.gl.un_330
  0x00000b15, 0x00001c03, 0x1100081a, 0x0000290a,   // bn.un.un_700 id.un.un_300  uk.ro.un_760 sl.un.un_500
  // [0080]
  0x0a0717a4, 0x00002b1c, 0x00004a15, 0x19080507,   // sr.bg.mk_433 vi.un.un_800  yo.un.un_700 fr.no.gl_432
  0x070a1714, 0x18002114, 0x1c0d0907, 0x01002412,   // sr.mk.bg_666 fa.ar.un_660  hi.ne.mr_432 yi.iw.un_640
  0x0000680f, 0x2d000d09, 0x556435a0, 0x00001a03,   // ig.un.un_600 cs.sk.un_440  zu.lg.rw_322 tl.un.un_300
  0x1c130911, 0x13000913, 0x28006413, 0x0e0c0607,   // hi.bh.mr_653 hi.bh.un_650  lg.sw.un_650 de.sv.is_432
  // [0090]
  0x00002701, 0x10081112, 0x64071c07, 0x0a0704a4,   // gd.un.un_200 ro.uk.be_654  id.it.lg_432 ru.bg.mk_433
  0x10070408, 0x00000115, 0x0000681c, 0x06000c0d,   // ru.bg.be_443 iw.un.un_700  ig.un.un_800 sv.de.un_540
  0x00003201, 0x00001006, 0x0c080205, 0x211218ad,   // bs.un.un_200 be.un.un_400  da.no.sv_333 ar.ur.fa_643
  0x1004080d, 0x3555640b, 0x04000813, 0x17321604,   // uk.ru.be_554 lg.rw.zu_542  uk.ru.un_650 hr.bs.sr_332
  // [00a0]
  0x1b003105, 0x101f2504, 0x00005201, 0x00000d0a,   // az.tr.un_330 eu.cy.lt_332  ha.un.un_200 cs.un.un_500
  0x121821af, 0x21002812, 0x3f003202, 0x18531902,   // fa.ar.ur_655 sw.jw.un_640  bs.af.un_220 gl.ht.ga_222
  0x0d000909, 0x32171605, 0x1c001304, 0x09002a0c,   // hi.ne.un_440 hr.sr.bs_333  bh.mr.un_320 mt.pl.un_530
  0x08020cec, 0x27001f19, 0x00006b06, 0x4a002813,   // sv.da.no_644 cy.gd.un_750  ceb.un.un_400 sw.yo.un_650
  // [00b0]
  0x31001b12, 0x0000550f, 0x08022a02, 0x07050112,   // tr.az.un_640 rw.un.un_600  mt.da.no_222 en.fr.it_654
  0x53004a0e, 0x0e2d0d08, 0x00000b06, 0x211218af,   // yo.ht.un_550 cs.sk.is_443  es.un.un_400 ar.ur.fa_655
  0x00002306, 0x131c090d, 0x0000110a, 0x00003515,   // ca.un.un_400 hi.mr.bh_554  ro.un.un_500 zu.un.un_700
  0x04000a08, 0x1b2d0d04, 0x0100240d, 0x3500642a,   // mk.ru.un_430 cs.sk.tr_332  yi.iw.un_540 lg.zu.un_970
  // [00c0]
  0x0a07170c, 0x0000350a, 0x0000090f, 0x3f0804ee,   // sr.bg.mk_543 zu.un.un_500  pl.un.un_600 fi.no.af_422
  0x00000e0f, 0x09001308, 0x040208a4, 0x00001e06,   // is.un.un_600 bh.hi.un_430  no.da.fi_433 ms.un.un_400
  0x2a2855ac, 0x55121104, 0x00005303, 0x0000060a,   // rw.sw.mt_632 ro.hu.rw_332  ht.un.un_300 de.un.un_500
  0x190a0b05, 0x04171112, 0x0000280a, 0x070a0408,   // es.pt.gl_333 ro.sr.ru_654  sw.un.un_500 ru.mk.bg_443
  // [00d0]
  0x1200211a, 0x00005315, 0x201c2105, 0x4a005205,   // fa.ur.un_760 ht.un.un_700  jw.id.sq_333 ha.yo.un_330
  0x00002501, 0x00002301, 0x08040707, 0x04081009,   // eu.un.un_200 ca.un.un_200  bg.ru.uk_432 be.uk.ru_444
  0x00000f03, 0x0a1710ad, 0x00003506, 0x0000101c,   // lv.un.un_300 be.sr.mk_643  zu.un.un_400 be.un.un_800
  0x1200130e, 0x00002015, 0x17070a12, 0x1c1e12ad,   // et.hu.un_550 sq.un.un_700  mk.bg.sr_654 hu.ms.id_643
  // [00e0]
  0x00001215, 0x12000509, 0x00001f1c, 0x0d001302,   // ur.un.un_700 fr.hu.un_440  cy.un.un_800 bh.ne.un_220
  0x32171609, 0x092504a4, 0x19000b04, 0x07170a11,   // hr.sr.bs_444 fi.eu.pl_433  es.gl.un_320 mk.sr.bg_653
  0x00005203, 0x04002508, 0x05001f05, 0x0000210f,   // ha.un.un_300 eu.fi.un_430  cy.fr.un_330 fa.un.un_600
  0x1c090da9, 0x1b1e25ad, 0x4a002a04, 0x18002707,   // ne.hi.mr_544 eu.ms.tr_643  mt.yo.un_320 gd.ga.un_420
  // [00f0]
  0x06000305, 0x091c13ee, 0x6b001a0e, 0x18002102,   // nl.de.un_330 bh.mr.hi_422  tl.ceb.un_550 jw.ga.un_220
  0x552d1ba4, 0x17002d05, 0x1e004a08, 0x00002a0f,   // tr.sk.rw_433 sk.sr.un_330  yo.ms.un_430 mt.un.un_600
  0x6b1820ee, 0x00004a03, 0x0000050a, 0x00001001,   // sq.ga.ceb_422 yo.un.un_300  fr.un.un_500 be.un.un_200
  0x19000a09, 0x00001f0f, 0x315228a4, 0x00000815,   // pt.gl.un_440 cy.un.un_600  sw.ha.az_433 uk.un.un_700
  // [0100]
  0x060435a0, 0x04070a0e, 0x02133b05, 0x17070a09,   // zu.fi.de_322 mk.bg.ru_555  so.et.da_333 mk.bg.sr_444
  0x10041107, 0x0000060f, 0x00001b0f, 0x17003507,   // ro.ru.be_432 de.un.un_600  tr.un.un_600 zu.sr.un_420
  0x0000250f, 0x08033f07, 0x00001315, 0x071105ee,   // eu.un.un_600 af.nl.no_432  et.un.un_700 fr.ro.it_422
  0x12002118, 0x02000804, 0x0900350c, 0x01006b04,   // fa.ur.un_740 no.da.un_320  zu.pl.un_530 ceb.en.un_320
  // [0110]
  0x03003f0e, 0x040807ad, 0x11522507, 0x00002b03,   // af.nl.un_550 bg.uk.ru_643  eu.ha.ro_432 vi.un.un_300
  0x00006b0f, 0x18000607, 0x210e0604, 0x013f1f07,   // ceb.un.un_600 de.ga.un_420  de.is.jw_332 cy.af.en_432
  0x13000912, 0x00002b0a, 0x1c000d12, 0x0d122d60,   // hi.bh.un_640 vi.un.un_500  ne.mr.un_640 sk.hu.cs_664
  0x285564a9, 0x00006415, 0x1f003f0d, 0x080a1704,   // lg.rw.sw_544 lg.un.un_700  af.cy.un_540 sr.mk.uk_332
  // [0120]
  0x1a1c6402, 0x00001b15, 0x230501a7, 0x1b4a1107,   // lg.id.tl_222 tr.un.un_700  en.fr.ca_532 ro.yo.tr_432
  0x68006422, 0x00006806, 0x292d0d04, 0x285535a4,   // lg.ig.un_870 ig.un.un_400  cs.sk.sl_332 zu.rw.sw_433
  0x4a0e1b0c, 0x2d0d1902, 0x0000110f, 0x211e1c5a,   // tr.is.yo_543 gl.cs.sk_222  ro.un.un_600 id.ms.jw_553
  0x4a642104, 0x16002904, 0x08001013, 0x0900130d,   // jw.lg.yo_332 sl.hr.un_320  be.uk.un_650 bh.hi.un_540
  // [0130]
  0x16002908, 0x044a0ea7, 0x0000551c, 0x00001603,   // sl.hr.un_430 is.yo.fi_532  rw.un.un_800 hr.un.un_300
  0x04001312, 0x08020c0c, 0x01003f04, 0x091e1c02,   // et.fi.un_640 sv.da.no_543  af.en.un_320 id.ms.pl_222
  0x080204a4, 0x08001014, 0x00001815, 0x1e001c05,   // fi.da.no_433 be.uk.un_660  ar.un.un_700 id.ms.un_330
  0x07042055, 0x042007a0, 0x00002a0a, 0x0f041355,   // sq.fi.it_442 it.sq.fi_322  mt.un.un_500 et.fi.lv_442
  // [0140]
  0x32092907, 0x1c3b2102, 0x0d003504, 0x00001701,   // sl.pl.bs_432 jw.so.id_222  zu.cs.un_320 sr.un.un_200
  0x03086407, 0x08021fa4, 0x2305010b, 0x18001f07,   // lg.no.nl_432 cy.da.no_433  en.fr.ca_542 cy.ga.un_420
  0x13000905, 0x06000c05, 0x0000070f, 0x0d091c0b,   // hi.bh.un_330 sv.de.un_330  bg.un.un_600 mr.hi.ne_542
  0x060c1f10, 0x1f0e0ca9, 0x03080204, 0x0000080f,   // cy.sv.de_642 sv.is.cy_544  da.no.nl_332 no.un.un_600
  // [0150]
  0x2b006b08, 0x0d6b1fee, 0x03122aa7, 0x00002703,   // ceb.vi.un_430 cy.ceb.cs_422  mt.hu.nl_532 gd.un.un_300
  0x3f002502, 0x00003f0a, 0x00000c0a, 0x0000530a,   // eu.af.un_220 af.un.un_500  sv.un.un_500 ht.un.un_500
  0x090d1c08, 0x0a17110c, 0x00002503, 0x20000604,   // mr.ne.hi_443 ro.sr.mk_543  eu.un.un_300 de.sq.un_320
  0x2a645504, 0x1a1604ee, 0x00002903, 0x09001c0e,   // rw.lg.mt_332 fi.hr.tl_422  sl.un.un_300 mr.hi.un_550
  // [0160]
  0x286455ee, 0x28005305, 0x00000515, 0x0000530f,   // rw.lg.sw_422 ht.sw.un_330  fr.un.un_700 ht.un.un_600
  0x3b00310e, 0x0300280c, 0x25001a04, 0x0000280f,   // az.so.un_550 sw.nl.un_530  tl.eu.un_320 sw.un.un_600
  0x2d0d0e0e, 0x3f0e3ba4, 0x1e1c1fee, 0x13000612,   // is.cs.sk_555 so.is.af_433  cy.id.ms_422 de.et.un_640
  0x0a000714, 0x17163202, 0x1f6b0eec, 0x00001f0a,   // bg.mk.un_660 bs.hr.sr_222  is.ceb.cy_644 cy.un.un_500
  // [0170]
  0x3b000119, 0x0000030a, 0x521b3ba4, 0x55002114,   // en.so.un_750 nl.un.un_500  so.tr.ha_433 jw.rw.un_660
  0x0000351c, 0x19110bee, 0x0a001719, 0x64010507,   // zu.un.un_800 es.ro.gl_422  sr.mk.un_750 fr.en.lg_432
  0x1c282008, 0x02180107, 0x00002a15, 0x00001e03,   // sq.sw.id_443 en.ga.da_432  mt.un.un_700 ms.un.un_300
  0x080201ee, 0x19122dad, 0x2b006407, 0x1f3f2504,   // en.da.no_422 sk.hu.gl_643  lg.vi.un_420 eu.af.cy_332
  // [0180]
  0x0d091caf, 0x31001b13, 0x17000a14, 0x18190b04,   // mr.hi.ne_655 tr.az.un_650  mk.sr.un_660 es.gl.ga_332
  0x25205207, 0x1a645507, 0x0600250d, 0x00002101,   // ha.sq.eu_432 rw.lg.tl_432  eu.de.un_540 jw.un.un_200
  0x111013ee, 0x12001104, 0x3b2864a4, 0x00003f01,   // et.lt.ro_422 ro.hu.un_320  lg.sw.so_433 af.un.un_200
  0x00002106, 0x01000802, 0x012711a0, 0x07041702,   // jw.un.un_400 no.en.un_220  ro.gd.en_322 sr.ru.bg_222
  // [0190]
  0x0c060404, 0x0a091107, 0x07040807, 0x00000e06,   // fi.de.sv_332 ro.pl.pt_432  uk.ru.bg_432 is.un.un_400
  0x00006401, 0x122d0d04, 0x3b000c0d, 0x00000703,   // lg.un.un_200 cs.sk.hu_332  sv.so.un_540 it.un.un_300
  0x081b04ad, 0x32001607, 0x21121812, 0x070a1004,   // fi.tr.no_643 hr.bs.un_420  ar.ur.fa_654 be.mk.bg_332
  0x00001124, 0x10000819, 0x01000204, 0x1b00310e,   // ro.un.un_900 uk.be.un_750  da.en.un_320 az.tr.un_550
  // [01a0]
  0x29000c05, 0x0100240c, 0x2d001219, 0x35556b07,   // sv.sl.un_330 yi.iw.un_530  hu.sk.un_750 ceb.rw.zu_432
  0x01002704, 0x6400351a, 0x00000b0f, 0x216455a0,   // gd.en.un_320 zu.lg.un_760  bn.un.un_600 rw.lg.jw_322
  0x6423250c, 0x24000119, 0x3b080e07, 0x05002304,   // eu.ca.lg_543 iw.yi.un_750  is.no.so_432 ca.fr.un_320
  0x18002119, 0x1004130e, 0x00000a0a, 0x19000b09,   // fa.ar.un_750 et.fi.lt_555  pt.un.un_500 es.gl.un_440
  // [01b0]
  0x1c0d0914, 0x0a040705, 0x2100010b, 0x18001213,   // hi.ne.mr_666 bg.ru.mk_333  en.jw.un_520 ur.ar.un_650
  0x00000801, 0x0c0305ee, 0x00006406, 0x01003504,   // uk.un.un_200 fr.nl.sv_422  lg.un.un_400 zu.en.un_320
  0x5200280e, 0x03003f04, 0x0400100d, 0x272504ec,   // sw.ha.un_550 af.nl.un_320  be.ru.un_540 fi.eu.gd_644
  0x170a07a4, 0x170a0405, 0x2b001e04, 0x00000b0a,   // bg.mk.sr_433 ru.mk.sr_333  ms.vi.un_320 es.un.un_500
  // [01c0]
  0x17001108, 0x18001209, 0x05001604, 0x2d0d1809,   // ro.sr.un_430 ur.ar.un_440  hr.fr.un_320 ga.cs.sk_444
  0x4a5352a0, 0x6b251304, 0x28001214, 0x170a0713,   // ha.ht.yo_322 et.eu.ceb_332  hu.sw.un_660 bg.mk.sr_665
  0x01100807, 0x1c000d05, 0x3b1e5204, 0x05001902,   // no.lt.en_432 ne.mr.un_330  ha.ms.so_332 gl.fr.un_220
  0x070a170c, 0x00001f15, 0x2d000d12, 0x03003f05,   // sr.mk.bg_543 cy.un.un_700  cs.sk.un_640 af.nl.un_330
  // [01d0]
  0x3f1235a0, 0x04001a05, 0x2d100dad, 0x00001003,   // zu.hu.af_322 tl.fi.un_330  cs.lt.sk_643 be.un.un_300
  0x1a002a07, 0x0c001a04, 0x091c130c, 0x00002a1c,   // mt.tl.un_420 tl.sv.un_320  bh.mr.hi_543 mt.un.un_800
  0x162d0d08, 0x13030109, 0x02001a04, 0x232b25ad,   // cs.sk.hr_443 en.nl.et_444  tl.da.un_320 eu.vi.ca_643
  0x03000c04, 0x13000412, 0x00000a06, 0x0000520a,   // sv.nl.un_320 fi.et.un_640  pt.un.un_400 ha.un.un_500
  // [01e0]
  0x126b1a11, 0x00000715, 0x00006b03, 0x0000171c,   // tl.ceb.hu_653 bg.un.un_700  ceb.un.un_300 sr.un.un_800
  0x171632a0, 0x065355ad, 0x322d1055, 0x00001a01,   // bs.hr.sr_322 rw.ht.de_643  lt.sk.bs_442 tl.un.un_200
  0x0c0603a0, 0x00004a06, 0x06002a02, 0x08100413,   // nl.de.sv_322 yo.un.un_400  mt.de.un_220 ru.be.uk_665
  0x1b002502, 0x19002105, 0x12190b04, 0x04000812,   // eu.tr.un_220 jw.gl.un_330  es.gl.hu_332 uk.ru.un_640
  // [01f0]
  0x03000912, 0x3b000707, 0x3f0625ad, 0x1c001e04,   // pl.nl.un_640 it.so.un_420  eu.de.af_643 ms.id.un_320
  0x281a6bee, 0x060e3fa4, 0x00002a01, 0x080717ee,   // ceb.tl.sw_422 af.is.de_433  mt.un.un_200 sr.bg.uk_422
  0x6b000418, 0x170f1007, 0x1c001a07, 0x0000350f,   // fi.ceb.un_740 lt.lv.sr_432  tl.id.un_420 zu.un.un_600
  0x00001115, 0x20286407, 0x1c012d07, 0x041013a4,   // ro.un.un_700 lg.sw.sq_432  sk.en.id_432 et.lt.fi_433
  // [0200]
  0x0000030f, 0x070a040c, 0x11002a0d, 0x08060fa4,   // nl.un.un_600 ru.mk.bg_543  mt.ro.un_540 lv.de.no_433
  0x550f4a55, 0x2d001604, 0x4a006e08, 0x080f0608,   // yo.lv.rw_442 hr.sk.un_320  hmn.yo.un_430 de.lv.no_443
  0x11002a02, 0x1c090dee, 0x10040f04, 0x09000d1b,   // mt.ro.un_220 ne.hi.mr_422  lv.fi.lt_332 ne.hi.un_770
  0x27183508, 0x32161702, 0x04001009, 0x31001b14,   // zu.ga.gd_443 sr.hr.bs_222  be.ru.un_440 tr.az.un_660
  // [0210]
  0x0e355504, 0x283b5304, 0x04002d0e, 0x04003f04,   // rw.zu.is_332 ht.so.sw_332  sk.fi.un_550 af.fi.un_320
  0x52002811, 0x211a1c0c, 0x1c00090e, 0x321617a6,   // sw.ha.un_630 id.tl.jw_543  hi.mr.un_550 sr.hr.bs_521
  0x06292504, 0x1c001312, 0x10040814, 0x311b1a0b,   // eu.sl.de_332 bh.mr.un_640  uk.ru.be_666 tl.tr.az_542
  0x230b0a05, 0x0804100b, 0x3f1303a9, 0x08170705,   // pt.es.ca_333 be.ru.uk_542  nl.et.af_544 bg.sr.uk_333
  // [0220]
  0x52002502, 0x0a08040b, 0x13000804, 0x00006e1c,   // eu.ha.un_220 ru.uk.mk_542  no.et.un_320 hmn.un.un_800
  0x23002907, 0x4a000705, 0x070417a0, 0x00002a03,   // sl.ca.un_420 it.yo.un_330  sr.ru.bg_322 mt.un.un_300
  0x3f2b03a0, 0x00005501, 0x0c00061a, 0x1a3f0112,   // nl.vi.af_322 rw.un.un_200  de.sv.un_760 en.af.tl_654
  0x554a680d, 0x040c0607, 0x0000020a, 0x64001902,   // ig.yo.rw_554 de.sv.fi_432  da.un.un_500 gl.lg.un_220
  // [0230]
  0x12211811, 0x0c296bee, 0x00000e03, 0x121821ec,   // ar.fa.ur_653 ceb.sl.sv_422  is.un.un_300 fa.ar.ur_644
  0x063f0302, 0x190b07a4, 0x1c28210d, 0x071e1c02,   // nl.af.de_222 it.es.gl_433  jw.sw.id_554 id.ms.it_222
  0x2b1127a0, 0x0507010c, 0x32161707, 0x05080107,   // gd.ro.vi_322 en.it.fr_543  sr.hr.bs_432 en.no.fr_432
  0x03003f13, 0x321716a4, 0x060d35a9, 0x03293bee,   // af.nl.un_650 hr.sr.bs_433  zu.cs.de_544 so.sl.nl_422
  // [0240]
  0x230701a4, 0x13000c0c, 0x0a1704a4, 0x21001813,   // en.it.ca_433 sv.et.un_530  ru.sr.mk_433 ar.fa.un_650
  0x0a001722, 0x1200640c, 0x531264a6, 0x041707ad,   // sr.mk.un_870 lg.hu.un_530  lg.hu.ht_521 bg.sr.ru_643
  0x0f291605, 0x08000c0e, 0x07040a04, 0x100407ee,   // hr.sl.lv_333 sv.no.un_550  mk.ru.bg_332 bg.ru.be_422
  0x52053ba0, 0x122118ad, 0x113525a9, 0x00003b1c,   // so.fr.ha_322 ar.fa.ur_643  eu.zu.ro_544 so.un.un_800
  // [0250]
  0x0410080c, 0x070a0807, 0x0b0a2da0, 0x11002304,   // uk.be.ru_543 uk.mk.bg_432  sk.pt.es_322 ca.ro.un_320
  0x4a006813, 0x08040aa9, 0x1800270e, 0x083f05ee,   // ig.yo.un_650 mk.ru.uk_544  gd.ga.un_550 fr.af.no_422
  0x1c002108, 0x321629a0, 0x6b043f05, 0x181221af,   // jw.id.un_430 sl.hr.bs_322  af.fi.ceb_333 fa.ur.ar_655
  0x04005205, 0x0a08070d, 0x290c2504, 0x09200f07,   // ha.fi.un_330 bg.uk.mk_554  eu.sv.sl_332 lv.sq.pl_432
  // [0260]
  0x1c000d08, 0x0d002d13, 0x00000c06, 0x1600200b,   // ne.mr.un_430 sk.cs.un_650  sv.un.un_400 sq.hr.un_520
  0x00002806, 0x00002515, 0x122a21a4, 0x10001c02,   // sw.un.un_400 eu.un.un_700  jw.mt.hu_433 id.lt.un_220
  0x131b31ad, 0x0c0e01a0, 0x0e000a07, 0x0f033fa4,   // az.tr.et_643 en.is.sv_322  pt.is.un_420 af.nl.lv_433
  0x6b4a1a12, 0x0a005307, 0x3f00230e, 0x0a001107,   // tl.yo.ceb_654 ht.pt.un_420  ca.af.un_550 ro.mk.un_420
  // [0270]
  0x23190bee, 0x0800020e, 0x0d003507, 0x4a001812,   // es.gl.ca_422 da.no.un_550  zu.cs.un_420 ga.yo.un_640
  0x321617a0, 0x2b030504, 0x07000a12, 0x00000c0f,   // sr.hr.bs_322 fr.nl.vi_332  mk.bg.un_640 sv.un.un_600
  0x290c35a0, 0x170408a4, 0x2300251a, 0x233153a0,   // zu.sv.sl_322 uk.ru.sr_433  eu.ca.un_760 ht.az.ca_322
  0x07000a05, 0x09001c1a, 0x0f3f03ec, 0x0b001908,   // mk.bg.un_330 mr.hi.un_760  nl.af.lv_644 gl.es.un_430
  // [0280]
  0x0a0817a0, 0x3b000614, 0x11000f04, 0x23000607,   // sr.uk.mk_322 de.so.un_660  lv.ro.un_320 de.ca.un_420
  0x6400550e, 0x64552504, 0x00006e15, 0x286435ad,   // rw.lg.un_550 eu.rw.lg_332  hmn.un.un_700 zu.lg.sw_643
  0x3f0c08a4, 0x01062008, 0x530425a4, 0x1200181a,   // no.sv.af_433 sq.de.en_443  eu.fi.ht_433 ar.ur.un_760
  0x0f103f04, 0x08001e04, 0x53000505, 0x18002713,   // af.lt.lv_332 ms.no.un_320  fr.ht.un_330 gd.ga.un_650
  // [0290]
  0x09001307, 0x00006815, 0x00001303, 0x033f2507,   // bh.hi.un_420 ig.un.un_700  bh.un.un_300 eu.af.nl_432
  0x17001607, 0x00000d1c, 0x00002815, 0x08071007,   // hr.sr.un_420 cs.un.un_800  sw.un.un_700 be.bg.uk_432
  0x170a07a0, 0x00001606, 0x203f08ee, 0x12000e0d,   // bg.mk.sr_322 hr.un.un_400  no.af.sq_422 is.hu.un_540
  0x32161705, 0x103b12ec, 0x1f3b4a5a, 0x32161709,   // sr.hr.bs_333 hu.so.lt_644  yo.so.cy_553 sr.hr.bs_444
  // [02a0]
  0x10001f19, 0x2700180e, 0x1b033faf, 0x080407af,   // cy.lt.un_750 ga.gd.un_550  af.nl.tr_655 bg.ru.uk_655
  0x00002a06, 0x2700180c, 0x08020cee, 0x28550507,   // mt.un.un_400 ga.gd.un_530  sv.da.no_422 fr.rw.sw_432
  0x00000b03, 0x356455af, 0x17081004, 0x07080aa0,   // es.un.un_300 rw.lg.zu_655  be.uk.sr_332 mk.uk.bg_322
  0x0c0601ee, 0x64005514, 0x1710080c, 0x0a071707,   // en.de.sv_422 rw.lg.un_660  uk.be.sr_543 sr.bg.mk_432
  // [02b0]
  0x25000305, 0x09001213, 0x0000190a, 0x55003f14,   // nl.eu.un_330 hu.pl.un_650  gl.un.un_500 af.rw.un_660
  0x0d0913a4, 0x10182707, 0x121b25ee, 0x0306010c,   // bh.hi.ne_433 gd.ga.lt_432  eu.tr.hu_422 en.de.nl_543
  0x00000f1c, 0x091a6b55, 0x07132504, 0x21002504,   // lv.un.un_800 ceb.tl.pl_442  eu.et.it_332 eu.jw.un_320
  0x131c2109, 0x06000207, 0x00000306, 0x2a322912,   // jw.id.et_444 da.de.un_420  nl.un.un_400 sl.bs.mt_654
  // [02c0]
  0x35080208, 0x080e0204, 0x0f002511, 0x0b001a09,   // da.no.zu_443 da.is.no_332  eu.lv.un_630 tl.es.un_440
  0x16293507, 0x4a002a0d, 0x04100811, 0x13006b04,   // zu.sl.hr_432 mt.yo.un_540  uk.be.ru_653 ceb.et.un_320
  0x0b190a0d, 0x321716ee, 0x091c0dad, 0x10000813,   // pt.gl.es_554 hr.sr.bs_422  ne.mr.hi_643 uk.be.un_650
  0x0a0717ee, 0x13001c1a, 0x2d002907, 0x0c001313,   // sr.bg.mk_422 mr.bh.un_760  sl.sk.un_420 et.sv.un_650
  // [02d0]
  0x6b1a25a4, 0x16321704, 0x1f003f08, 0x0a04070d,   // eu.tl.ceb_433 sr.bs.hr_332  af.cy.un_430 bg.ru.mk_554
  0x182a0c0c, 0x17040804, 0x11120704, 0x040708af,   // sv.mt.ga_543 uk.ru.sr_332  it.hu.ro_332 no.it.fi_655
  0x080a1712, 0x0000270a, 0x0c002005, 0x3b000419,   // sr.mk.uk_654 gd.un.un_500  sq.sv.un_330 fi.so.un_750
  0x64006812, 0x07001104, 0x1f191b55, 0x04001313,   // ig.lg.un_640 ro.it.un_320  tr.gl.cy_442 et.fi.un_650
  // [02e0]
  0x5500640e, 0x116b07a0, 0x17163205, 0x041707a7,   // lg.rw.un_550 it.ceb.ro_322  bs.hr.sr_333 bg.sr.ru_532
  0x04006407, 0x0a00110e, 0x04000513, 0x03063f12,   // lg.fi.un_420 ro.mk.un_550  fr.fi.un_650 af.de.nl_654
  0x64003509, 0x13000819, 0x190b0d05, 0x0708100e,   // zu.lg.un_440 no.et.un_750  cs.es.gl_333 be.uk.bg_555
  0x29001609, 0x00001a1c, 0x19000b14, 0x07201804,   // hr.sl.un_440 tl.un.un_800  es.gl.un_660 ga.sq.it_332
  // [02f0]
  0x07001113, 0x2b00250e, 0x120d0705, 0x21000707,   // ro.bg.un_650 eu.vi.un_550  it.cs.hu_333 it.jw.un_420
  0x00004a0f, 0x52002005, 0x16003f02, 0x0000080a,   // yo.un.un_600 sq.ha.un_330  af.hr.un_220 no.un.un_500
  0x0000210a, 0x29001704, 0x061f5207, 0x551a07ee,   // jw.un.un_500 sr.sl.un_320  ha.cy.de_432 it.tl.rw_422
  0x201610ad, 0x07272ba7, 0x08041007, 0x182b27a0,   // lt.hr.sq_643 vi.gd.it_532  be.ru.uk_432 gd.vi.ga_322
  // [0300]
  0x092d0d04, 0x32170c02, 0x07003f04, 0x1f1a13a0,   // cs.sk.pl_332 sv.sr.bs_222  af.it.un_320 et.tl.cy_322
  0x52005502, 0x060c0305, 0x09002a08, 0x040711ee,   // rw.ha.un_220 nl.sv.de_333  mt.pl.un_430 ro.bg.ru_422
  0x0d0913a9, 0x271718a9, 0x3f080cee, 0x1704070e,   // bh.hi.ne_544 ga.sr.gd_544  sv.no.af_422 bg.ru.sr_555
  0x090c02a0, 0x1c0f1305, 0x07000819, 0x28001a08,   // da.sv.pl_322 et.lv.id_333  uk.bg.un_750 tl.sw.un_430
  // [0310]
  0x02000304, 0x1a6b01a0, 0x070a1707, 0x3f6b1a07,   // nl.da.un_320 en.ceb.tl_322  sr.mk.bg_432 tl.ceb.af_432
  0x160729a0, 0x1b003113, 0x28001e13, 0x12001804,   // sl.it.hr_322 az.tr.un_650  ms.sw.un_650 ga.hu.un_320
  0x0a0704af, 0x0f522da0, 0x07001702, 0x0e000808,   // ru.bg.mk_655 sk.ha.lv_322  sr.bg.un_220 no.is.un_430
  0x321631a0, 0x00003f15, 0x19002108, 0x06080ea0,   // az.hr.bs_322 af.un.un_700  jw.gl.un_430 is.no.de_322
  // [0320]
  0x32001602, 0x00001c0a, 0x23001904, 0x041710a4,   // hr.bs.un_220 id.un.un_500  gl.ca.un_320 be.sr.ru_433
  0x200f35a0, 0x1000060c, 0x2d000d13, 0x4a1f5304,   // zu.lv.sq_322 de.lt.un_530  cs.sk.un_650 ht.cy.yo_332
  0x0d1c09af, 0x04522107, 0x19000a05, 0x202910ee,   // hi.mr.ne_655 jw.ha.fi_432  pt.gl.un_330 lt.sl.sq_422
  0x04645509, 0x010f3f07, 0x190a11a0, 0x010a110c,   // rw.lg.fi_444 af.lv.en_432  ro.pt.gl_322 ro.pt.en_543
  // [0330]
  0x1309040e, 0x0a071705, 0x23001c02, 0x19000b0c,   // fi.pl.et_555 sr.bg.mk_333  id.ca.un_220 es.gl.un_530
  0x68162507, 0x3b006407, 0x3b005208, 0x03000704,   // eu.hr.ig_432 lg.so.un_420  ha.so.un_430 it.nl.un_320
  0x0400170e, 0x213b3f07, 0x09321602, 0x045525ee,   // sr.ru.un_550 af.so.jw_432  hr.bs.pl_222 eu.rw.fi_422
  0x0a192307, 0x18122111, 0x2118120c, 0x170a0712,   // ca.gl.pt_432 fa.ur.ar_653  ur.ar.fa_543 bg.mk.sr_654
  // [0340]
  0x0f101104, 0x3f001c04, 0x08000c0d, 0x211812ad,   // ro.lt.lv_332 id.af.un_320  sv.no.un_540 ur.ar.fa_643
  0x211c2007, 0x211e1c02, 0x12000c0c, 0x3b001012,   // sq.id.jw_432 id.ms.jw_222  sv.hu.un_530 lt.so.un_640
  0x252d29ad, 0x3b04010c, 0x1c00280d, 0x25002102,   // sl.sk.eu_643 en.fi.so_543  sw.id.un_540 jw.eu.un_220
  0x0f100607, 0x0a00071a, 0x321620ee, 0x0a0811a0,   // de.lt.lv_432 bg.mk.un_760  sq.hr.bs_422 ro.uk.mk_322
  // [0350]
  0x050e250c, 0x27001812, 0x091a13ee, 0x131004a7,   // eu.is.fr_543 ga.gd.un_640  et.tl.pl_422 fi.lt.et_532
  0x091c13a7, 0x00002315, 0x3f1f0ca7, 0x080225ec,   // bh.mr.hi_532 ca.un.un_700  sv.cy.af_532 eu.da.no_644
  0x191023ad, 0x19000b0e, 0x1b1a31a7, 0x1c001307,   // ca.lt.gl_643 es.gl.un_550  az.tl.tr_532 bh.mr.un_420
  0x040c3ba0, 0x17001602, 0x3b6435a4, 0x0000520f,   // so.sv.fi_322 hr.sr.un_220  zu.lg.so_433 ha.un.un_600
  // [0360]
  0x21001f19, 0x32001702, 0x00001024, 0x00000303,   // cy.jw.un_750 sr.bs.un_220  be.un.un_900 nl.un.un_300
  0x00002906, 0x080225a9, 0x190b050e, 0x12000913,   // sl.un.un_400 eu.da.no_544  fr.es.gl_555 pl.hu.un_650
  0x10000713, 0x3f0809ad, 0x352001ac, 0x31003b05,   // bg.be.un_650 pl.no.af_643  en.sq.zu_632 so.az.un_330
  0x12001a04, 0x3b001a04, 0x09292da0, 0x1c000f05,   // tl.hu.un_320 tl.so.un_320  sk.sl.pl_322 lv.id.un_330
  // [0370]
  0x21006e07, 0x64041007, 0x20006404, 0x25000313,   // hmn.jw.un_420 lt.fi.lg_432  lg.sq.un_320 nl.eu.un_650
  0x033f1307, 0x020c3fa4, 0x04100812, 0x206b01a6,   // et.af.nl_432 af.sv.da_433  uk.be.ru_654 en.ceb.sq_521
  0x13005519, 0x21003519, 0x0800520b, 0x05005208,   // rw.et.un_750 zu.jw.un_750  ha.no.un_520 ha.fr.un_430
  0x281a1055, 0x1f2327a7, 0x1f061004, 0x1c090d0e,   // lt.tl.sw_442 gd.ca.cy_532  lt.de.cy_332 ne.hi.mr_555
  // [0380]
  0x13001f1a, 0x17001605, 0x052123a0, 0x18201b12,   // cy.et.un_760 hr.sr.un_330  ca.jw.fr_322 tr.sq.ga_654
  0x06001e02, 0x00006824, 0x1f003519, 0x0d122d0d,   // ms.de.un_220 ig.un.un_900  zu.cy.un_750 sk.hu.cs_554
  0x3b002507, 0x00000f01, 0x32171608, 0x281f3f04,   // eu.so.un_420 lv.un.un_200  hr.sr.bs_443 af.cy.sw_332
  0x684a250c, 0x1f005205, 0x13000914, 0x041117a4,   // eu.yo.ig_543 ha.cy.un_330  hi.bh.un_660 sr.ro.ru_433
  // [0390]
  0x556e6404, 0x16003204, 0x27002312, 0x2000010d,   // lg.hmn.rw_332 bs.hr.un_320  ca.gd.un_640 en.sq.un_540
  0x2b0e35ec, 0x19000a07, 0x12002104, 0x28002a04,   // zu.is.vi_644 pt.gl.un_420  jw.hu.un_320 mt.sw.un_320
  0x18235207, 0x17040704, 0x01000609, 0x21002804,   // ha.ca.ga_432 bg.ru.sr_332  de.en.un_440 sw.jw.un_320
  0x2d0d0914, 0x0a00171a, 0x0804100c, 0x090d1c13,   // pl.cs.sk_666 sr.mk.un_760  be.ru.uk_543 mr.ne.hi_665
  // [03a0]
  0x09041012, 0x321617a9, 0x0c123504, 0x04536408,   // lt.fi.pl_654 sr.hr.bs_544  zu.hu.sv_332 lg.ht.fi_443
  0x161b2807, 0x0a0408a0, 0x01233f07, 0x556408a0,   // sw.tr.hr_432 uk.ru.mk_322  af.ca.en_432 no.lg.rw_322
  0x08002513, 0x1e1c21ec, 0x17001122, 0x2d000d0d,   // eu.no.un_650 jw.id.ms_644  ro.sr.un_870 cs.sk.un_540
  0x0000200a, 0x0e005218, 0x016820a4, 0x091c0d0d,   // sq.un.un_500 ha.is.un_740  sq.ig.en_433 ne.mr.hi_554
  // [03b0]
  0x03003f09, 0x0f001019, 0x110501af, 0x0a000e19,   // af.nl.un_440 lt.lv.un_750  en.fr.ro_655 is.pt.un_750
  0x6855280c, 0x21001b05, 0x281e2a07, 0x1000081b,   // sw.rw.ig_543 tr.jw.un_330  mt.ms.sw_432 uk.be.un_770
  0x0a002304, 0x644a07a4, 0x0b2d0d05, 0x00000506,   // ca.pt.un_320 it.yo.lg_433  cs.sk.es_333 fr.un.un_400
  0x24000120, 0x010752ee, 0x03003f19, 0x10130f12,   // iw.yi.un_850 ha.it.en_422  af.nl.un_750 lv.et.lt_654
  // [03c0]
  0x0f00101b, 0x09002d08, 0x186b08a0, 0x13090d11,   // lt.lv.un_770 sk.pl.un_430  no.ceb.ga_322 ne.hi.bh_653
  0x643b3507, 0x03003f0d, 0x11006404, 0x130455ee,   // zu.so.lg_432 af.nl.un_540  lg.ro.un_320 rw.fi.et_422
  0x24000112, 0x55006808, 0x170a0714, 0x19001213,   // iw.yi.un_640 ig.rw.un_430  bg.mk.sr_666 hu.gl.un_650
  0x4a556813, 0x1b00311a, 0x171632a4, 0x283555ad,   // ig.rw.yo_665 az.tr.un_760  bs.hr.sr_433 rw.zu.sw_643
  // [03d0]
  0x016b3b07, 0x02000813, 0x01000505, 0x0300050c,   // so.ceb.en_432 no.da.un_650  fr.en.un_330 fr.nl.un_530
  0x17041004, 0x04070aa4, 0x16210e04, 0x2d090604,   // be.ru.sr_332 mk.bg.ru_433  is.jw.hr_332 de.pl.sk_332
  0x17040a0c, 0x6b3b1b55, 0x2b006b07, 0x2d0d18af,   // mk.ru.sr_543 tr.so.ceb_442  ceb.vi.un_420 ga.cs.sk_655
  0x18006e04, 0x08041011, 0x32171604, 0x31001b1a,   // hmn.ga.un_320 be.ru.uk_653  hr.sr.bs_332 tr.az.un_760
  // [03e0]
  0x0c000813, 0x0e001a14, 0x35311b14, 0x082d0c07,   // no.sv.un_650 tl.is.un_660  tr.az.zu_666 sv.sk.no_432
  0x122d0d0d, 0x0c000a0e, 0x13091caf, 0x112916a4,   // cs.sk.hu_554 pt.sv.un_550  mr.hi.bh_655 hr.sl.ro_433
  0x20001105, 0x1a004a08, 0x255255a7, 0x1e1c0fee,   // ro.sq.un_330 yo.tl.un_430  rw.ha.eu_532 lv.id.ms_422
  0x190a53a0, 0x31001b19, 0x321617a4, 0x10002008,   // ht.pt.gl_322 tr.az.un_750  sr.hr.bs_433 sq.lt.un_430
  // [03f0]
  0x062a0411, 0x12002112, 0x311b3b07, 0x643f035a,   // fi.mt.de_653 fa.ur.un_640  so.tr.az_432 nl.af.lg_553
  0x6b1a1007, 0x06000c07, 0x0000180a, 0x030408a4,   // lt.tl.ceb_432 sv.de.un_420  ga.un.un_500 no.fi.nl_433
  0x080e0c07, 0x1c121b07, 0x0d0913ee, 0x0f0127a0,   // sv.is.no_432 tr.hu.id_432  bh.hi.ne_422 gd.en.lv_322
  0x04001012, 0x6b000c05, 0x13002913, 0x1a1113a0,   // be.ru.un_640 sv.ceb.un_330  sl.et.un_650 et.ro.tl_322

  // [0400]
  0x1f002808, 0x00003b0a, 0x0e000404, 0x21001c08,   // sw.cy.un_430 so.un.un_500  fi.is.un_320 id.jw.un_430
  0x3f1311ec, 0x00000b1c, 0x0a111705, 0x08001004,   // ro.et.af_644 bn.un.un_800  sr.ro.mk_333 be.uk.un_320
  0x53002b14, 0x0d2018a0, 0x1c09130c, 0x08071011,   // vi.ht.un_660 ga.sq.cs_322  bh.hi.mr_543 be.bg.uk_653
  0x171632ee, 0x2d291107, 0x170a0404, 0x050601a4,   // bs.hr.sr_422 ro.sl.sk_432  ru.mk.sr_332 en.de.fr_433
  // [0410]
  0x3100230d, 0x3b1b5504, 0x040a1755, 0x0e005207,   // ca.az.un_540 rw.tr.so_332  sr.mk.ru_442 ha.is.un_420
  0x121a6b12, 0x231304ad, 0x05006e07, 0x351f1a05,   // ceb.tl.hu_654 fi.et.ca_643  hmn.fr.un_420 tl.cy.zu_333
  0x16290d07, 0x28001308, 0x19000a0c, 0x10001704,   // cs.sl.hr_432 et.sw.un_430  pt.gl.un_530 sr.lt.un_320
  0x52122aa4, 0x23190b05, 0x3b003f05, 0x1f130807,   // mt.hu.ha_433 es.gl.ca_333  af.so.un_330 no.et.cy_432
  // [0420]
  0x27001813, 0x170a0709, 0x3216170c, 0x070a1705,   // ga.gd.un_650 bg.mk.sr_444  sr.hr.bs_543 sr.mk.bg_333
  0x09000f08, 0x00000701, 0x00006b15, 0x28003513,   // lv.pl.un_430 it.un.un_200  ceb.un.un_700 zu.sw.un_650
  0x2a00121a, 0x351e28a4, 0x32160914, 0x08021fa9,   // hu.mt.un_760 sw.ms.zu_433  pl.hr.bs_666 cy.da.no_544
  0x0000011c, 0x070a11ee, 0x00002915, 0x68253ba4,   // en.un.un_800 ro.mk.bg_422  sl.un.un_700 so.eu.ig_433
  // [0430]
  0x13040e04, 0x0d002d0d, 0x3229160c, 0x3f3b29ee,   // is.fi.et_332 sk.cs.un_540  hr.sl.bs_543 sl.so.af_422
  0x35004a04, 0x00001e0a, 0x3b001a0e, 0x090d1cec,   // yo.zu.un_320 ms.un.un_500  tl.so.un_550 mr.ne.hi_644
  0x11073ba4, 0x07041705, 0x08005218, 0x3f535213,   // so.it.ro_433 sr.ru.bg_333  ha.no.un_740 ha.ht.af_665
  0x041b0e07, 0x1e1c21a4, 0x3b0f1a04, 0x212813ad,   // is.tr.fi_432 jw.id.ms_433  tl.lv.so_332 et.sw.jw_643
  // [0440]
  0x08001e02, 0x13321607, 0x0c0353ee, 0x6b351aad,   // ms.no.un_220 hr.bs.et_432  ht.nl.sv_422 tl.zu.ceb_643
  0x64135511, 0x35002905, 0x07080a04, 0x0d1c09ec,   // rw.et.lg_653 sl.zu.un_330  mk.uk.bg_332 hi.mr.ne_644
  0x043f3bee, 0x21121860, 0x4a005202, 0x356428a7,   // so.af.fi_422 ar.ur.fa_664  ha.yo.un_220 sw.lg.zu_532
  0x11080408, 0x1711040c, 0x28001013, 0x0a002302,   // ru.uk.ro_443 ru.ro.sr_543  lt.sw.un_650 ca.pt.un_220
  // [0450]
  0x07000a04, 0x08000e0c, 0x18000d1a, 0x232d1ba0,   // pt.it.un_320 is.no.un_530  cs.ga.un_760 tr.sk.ca_322
  0x0d002d08, 0x08101712, 0x033f2704, 0x0407110c,   // sk.cs.un_430 sr.be.uk_654  gd.af.nl_332 ro.bg.ru_543
  0x070a1002, 0x18001907, 0x0400550d, 0x04111312,   // be.mk.bg_222 gl.ga.un_420  rw.fi.un_540 et.ro.fi_654
  0x17070a05, 0x0f005207, 0x2d003202, 0x5355280d,   // mk.bg.sr_333 ha.lv.un_420  bs.sk.un_220 sw.rw.ht_554
  // [0460]
  0x011805ee, 0x081117a4, 0x0c06030c, 0x1e1c210c,   // fr.ga.en_422 sr.ro.uk_433  nl.de.sv_543 jw.id.ms_543
  0x04290e0d, 0x55353baf, 0x0000130a, 0x281b25ee,   // is.sl.fi_554 so.zu.rw_655  bh.un.un_500 eu.tr.sw_422
  0x35006809, 0x08000c05, 0x13001012, 0x08000208,   // ig.zu.un_440 sv.no.un_330  lt.et.un_640 da.no.un_430
  0x0a081702, 0x645528a4, 0x200802ad, 0x1c130914,   // sr.uk.mk_222 sw.rw.lg_433  da.no.sq_643 hi.bh.mr_666
  // [0470]
  0x080a1707, 0x04070a04, 0x0b00070c, 0x041008ad,   // sr.mk.uk_432 mk.bg.ru_332  it.es.un_530 uk.be.ru_643
  0x08170a05, 0x28000e13, 0x522104ad, 0x0d1c13ac,   // mk.sr.uk_333 is.sw.un_650  fi.jw.ha_643 bh.mr.ne_632
  0x0a190b5a, 0x643f0655, 0x313b2aad, 0x64005512,   // es.gl.pt_553 de.af.lg_442  mt.so.az_643 rw.lg.un_640
  0x1000290e, 0x28201108, 0x4a2835a9, 0x35000613,   // sl.lt.un_550 ro.sq.sw_443  zu.sw.yo_544 de.zu.un_650
  // [0480]
  0x32001708, 0x643b31a0, 0x3f0810a0, 0x2000550d,   // sr.bs.un_430 az.so.lg_322  lt.no.af_322 rw.sq.un_540
  0x35001f19, 0x1c0913a0, 0x0a171108, 0x033f27a4,   // cy.zu.un_750 bh.hi.mr_322  ro.sr.mk_443 gd.af.nl_433
  0x00000806, 0x53005202, 0x2a000b04, 0x09001c05,   // no.un.un_400 ha.ht.un_220  es.mt.un_320 mr.hi.un_330
  0x18000304, 0x21001c02, 0x041708a4, 0x0c000807,   // nl.ga.un_320 id.jw.un_220  uk.sr.ru_433 no.sv.un_420
  // [0490]
  0x321617ee, 0x0700041a, 0x35282aec, 0x1a006b0b,   // sr.hr.bs_422 ru.bg.un_760  mt.sw.zu_644 ceb.tl.un_520
  0x0a000405, 0x13281fee, 0x070a0804, 0x0000311c,   // ru.mk.un_330 cy.sw.et_422  uk.mk.bg_332 az.un.un_800
  0x08100408, 0x162032ee, 0x070a1155, 0x06000119,   // ru.be.uk_443 bs.sq.hr_422  ro.mk.bg_442 en.de.un_750
  0x0000241c, 0x25112005, 0x28005513, 0x16002907,   // yi.un.un_800 sq.ro.eu_333  rw.sw.un_650 sl.hr.un_420
  // [04a0]
  0x04081012, 0x21001819, 0x280e200c, 0x16321708,   // be.uk.ru_654 ar.fa.un_750  sq.is.sw_543 sr.bs.hr_443
  0x0000081c, 0x06100e04, 0x08020ea0, 0x0400110d,   // no.un.un_800 is.lt.de_332  is.da.no_322 ro.ru.un_540
  0x52000108, 0x0a00071b, 0x21181212, 0x642a0705,   // en.ha.un_430 bg.mk.un_770  ur.ar.fa_654 it.mt.lg_333
  0x01002419, 0x3216170e, 0x0000071c, 0x125553a7,   // yi.iw.un_750 sr.hr.bs_555  bg.un.un_800 ht.rw.hu_532
  // [04b0]
  0x040708a4, 0x08002719, 0x211e2005, 0x3b251908,   // uk.bg.ru_433 gd.no.un_750  sq.ms.jw_333 gl.eu.so_443
  0x1e001c04, 0x20000808, 0x3f00121b, 0x0000211c,   // id.ms.un_320 no.sq.un_430  hu.af.un_770 fa.un.un_800
  0x02001a02, 0x27001814, 0x1c0d09af, 0x32001614,   // tl.da.un_220 ga.gd.un_660  hi.ne.mr_655 hr.bs.un_660
  0x180a11a4, 0x080255a0, 0x351a1c04, 0x52000113,   // ro.pt.ga_433 rw.da.no_322  id.tl.zu_332 en.ha.un_650
  // [04c0]
  0x0a0711a9, 0x0f005513, 0x17070a07, 0x32092d04,   // ro.bg.mk_544 rw.lv.un_650  mk.bg.sr_432 sk.pl.bs_332
  0x04001105, 0x6b1c1aec, 0x100a07ec, 0x12001812,   // ro.fi.un_330 tl.id.ceb_644  bg.mk.be_644 ga.hu.un_640
  0x28536ba0, 0x080410a0, 0x192d0deb, 0x2d321602,   // ceb.ht.sw_322 be.ru.uk_322  cs.sk.gl_662 hr.bs.sk_222
  0x53006421, 0x19000b07, 0x1c213f12, 0x00000c01,   // lg.ht.un_860 es.gl.un_420  af.jw.id_654 sv.un.un_200
  // [04d0]
  0x20002802, 0x31355207, 0x0d002d12, 0x2d0d12af,   // sw.sq.un_220 ha.zu.az_432  sk.cs.un_640 hu.cs.sk_655
  0x080717a4, 0x253f4aee, 0x1c00130d, 0x10001709,   // sr.bg.uk_433 yo.af.eu_422  bh.mr.un_540 sr.lt.un_440
  0x53002104, 0x06033f04, 0x1300091a, 0x3f1220a4,   // jw.ht.un_320 af.nl.de_332  hi.bh.un_760 sq.hu.af_433
  0x04171104, 0x0d132807, 0x35001b12, 0x080a17a0,   // ro.sr.ru_332 sw.et.cs_432  tr.zu.un_640 sr.mk.uk_322
  // [04e0]
  0x1c0d1311, 0x03322aee, 0x6b006e0d, 0x11640408,   // bh.ne.mr_653 mt.bs.nl_422  hmn.ceb.un_540 fi.lg.ro_443
  0x08041008, 0x1c000902, 0x0d091305, 0x1b0435ad,   // be.ru.uk_443 hi.mr.un_220  bh.hi.ne_333 zu.fi.tr_643
  0x110a0714, 0x52533fa6, 0x0d092d0d, 0x31202aa7,   // bg.mk.ro_666 af.ht.ha_521  sk.pl.cs_554 mt.sq.az_532
  0x00001a0f, 0x0e1013a0, 0x35005202, 0x0000131c,   // tl.un.un_600 et.lt.is_322  ha.zu.un_220 bh.un.un_800
  // [04f0]
  0x0c00080e, 0x0e00190c, 0x16000d04, 0x2d002904,   // no.sv.un_550 gl.is.un_530  cs.hr.un_320 sl.sk.un_320
  0x3500110d, 0x016b04ad, 0x09001c07, 0x00000606,   // ro.zu.un_540 fi.ceb.en_643  mr.hi.un_420 de.un.un_400
  0x3b002904, 0x271118af, 0x0000190f, 0x071117a4,   // sl.so.un_320 ga.ro.gd_655  gl.un.un_600 sr.ro.bg_433
  0x0f0806a6, 0x35645508, 0x4a002a21, 0x3b1935ee,   // de.no.lv_521 rw.lg.zu_443  mt.yo.un_860 zu.gl.so_422
  // [0500]
  0x29171605, 0x17070a13, 0x3f0313af, 0x0400081a,   // hr.sr.sl_333 mk.bg.sr_665  et.nl.af_655 uk.ru.un_760
  0x0000170a, 0x0d091ca9, 0x3b001c08, 0x1f002313,   // sr.un.un_500 mr.hi.ne_544  id.so.un_430 ca.cy.un_650
  0x21001218, 0x52001a04, 0x64356804, 0x25123fee,   // ur.fa.un_740 tl.ha.un_320  ig.zu.lg_332 af.hu.eu_422
  0x020e0c05, 0x04000e13, 0x3217160e, 0x182112ec,   // sv.is.da_333 is.fi.un_650  hr.sr.bs_555 ur.fa.ar_644
  // [0510]
  0x0b001904, 0x68050607, 0x1a00041b, 0x25003f08,   // gl.es.un_320 de.fr.ig_432  fi.tl.un_770 af.eu.un_430
  0x1f3b0702, 0x18002705, 0x53190507, 0x04070aa0,   // it.so.cy_222 gd.ga.un_330  fr.gl.ht_432 mk.bg.ru_322
  0x0d09130e, 0x0c0106a4, 0x09291807, 0x08001705,   // bh.hi.ne_555 de.en.sv_433  ga.sl.pl_432 sr.no.un_330
  0x16000f16, 0x1c001311, 0x0d1c0913, 0x1c006402,   // lv.hr.un_720 bh.mr.un_630  hi.mr.ne_665 lg.id.un_220
  // [0520]
  0x170a0704, 0x1c043bee, 0x3f000212, 0x18022302,   // bg.mk.sr_332 so.fi.id_422  da.af.un_640 ca.da.ga_222
  0x3b006b0c, 0x534a1aa0, 0x06000a08, 0x13043b04,   // ceb.so.un_530 tl.yo.ht_322  pt.de.un_430 so.fi.et_332
  0x53081b07, 0x086b0c08, 0x101705a4, 0x552305ad,   // tr.no.ht_432 sv.ceb.no_443  fr.sr.lt_433 fr.ca.rw_643
  0x03005304, 0x10000304, 0x0a001723, 0x040a17a0,   // ht.nl.un_320 nl.lt.un_320  sr.mk.un_880 sr.mk.ru_322
  // [0530]
  0x2d000d05, 0x213210a4, 0x28211c07, 0x0000160a,   // cs.sk.un_330 lt.bs.jw_433  id.jw.sw_432 hr.un.un_500
  0x0000250a, 0x3b00520c, 0x0c080260, 0x0c3f03a0,   // eu.un.un_500 ha.so.un_530  da.no.sv_664 nl.af.sv_322
  0x1c090d07, 0x1b1f18ee, 0x1c0d0913, 0x17000718,   // ne.hi.mr_432 ga.cy.tr_422  hi.ne.mr_665 bg.sr.un_740
  0x0f001609, 0x17321655, 0x04133ba7, 0x04001004,   // hr.lv.un_440 hr.bs.sr_442  so.et.fi_532 be.ru.un_320
  // [0540]
  0x04000908, 0x210c6b04, 0x271b18af, 0x6b000119,   // pl.fi.un_430 ceb.sv.jw_332  ga.tr.gd_655 en.ceb.un_750
  0x55003518, 0x2400010e, 0x1c002107, 0x55000104,   // zu.rw.un_740 iw.yi.un_550  jw.id.un_420 en.rw.un_320
  0x11131bad, 0x6e000309, 0x08000413, 0x04001711,   // tr.et.ro_643 nl.hmn.un_440  ru.uk.un_650 sr.ru.un_630
  0x3f00030e, 0x0e001702, 0x2932170c, 0x21001214,   // nl.af.un_550 sr.is.un_220  sr.bs.sl_543 ur.fa.un_660
  // [0550]
  0x0e3b6404, 0x0c00081a, 0x321716a0, 0x18211208,   // lg.so.is_332 no.sv.un_760  hr.sr.bs_322 ur.fa.ar_443
  0x10041105, 0x21001213, 0x183107a0, 0x24000113,   // ro.ru.be_333 ur.fa.un_650  it.az.ga_322 iw.yi.un_650
  0x31000c04, 0x12002d04, 0x17000a22, 0x6e000e1a,   // sv.az.un_320 sk.hu.un_320  mk.sr.un_870 is.hmn.un_760
  0x19002104, 0x09000d19, 0x191b0da0, 0x02000c0c,   // jw.gl.un_320 ne.hi.un_750  cs.tr.gl_322 sv.da.un_530
  // [0560]
  0x1b04315a, 0x00001a06, 0x2000230b, 0x07011ea0,   // az.fi.tr_553 tl.un.un_400  ca.sq.un_520 ms.en.it_322
  0x23004a02, 0x4a1823b3, 0x18122160, 0x1c0d090e,   // yo.ca.un_220 ca.ga.yo_743  fa.ur.ar_664 hi.ne.mr_555
  0x6e6b0707, 0x0000271c, 0x4a6b6804, 0x06080cad,   // it.ceb.hmn_432 gd.un.un_800  ig.ceb.yo_332 sv.no.de_643
  0x2500070d, 0x6b1b3112, 0x53002107, 0x072a01a4,   // it.eu.un_540 az.tr.ceb_654  jw.ht.un_420 en.mt.it_433
  // [0570]
  0x03132507, 0x1e1c6409, 0x55356404, 0x1c091302,   // eu.et.nl_432 lg.id.ms_444  lg.zu.rw_332 bh.hi.mr_222
  0x21001112, 0x3210160d, 0x12000704, 0x5200250d,   // ro.jw.un_640 hr.lt.bs_554  it.hu.un_320 eu.ha.un_540
  0x09001c08, 0x32001609, 0x64213507, 0x52000808,   // mr.hi.un_430 hr.bs.un_440  zu.jw.lg_432 no.ha.un_430
  0x08002d04, 0x0f0e10a0, 0x08032502, 0x12182113,   // sk.no.un_320 lt.is.lv_322  eu.nl.no_222 fa.ar.ur_665
  // [0580]
  0x531c01a6, 0x12001809, 0x04000c04, 0x081710a0,   // en.id.ht_521 ga.hu.un_440  sv.fi.un_320 be.sr.uk_322
  0x0c08020d, 0x2a200307, 0x2a0c0e07, 0x020c08af,   // da.no.sv_554 nl.sq.mt_432  is.sv.mt_432 no.sv.da_655
  0x0000201c, 0x073101a4, 0x040a10a0, 0x3b001c05,   // sq.un.un_800 en.az.it_433  be.mk.ru_322 id.so.un_330
  0x180627ac, 0x211c23a9, 0x18001e05, 0x00002706,   // gd.de.ga_632 ca.id.jw_544  ms.ga.un_330 gd.un.un_400
  // [0590]
  0x041b31ad, 0x28182702, 0x08021baf, 0x190b23a0,   // az.tr.fi_643 gd.ga.sw_222  tr.da.no_655 ca.es.gl_322
  0x4a311b08, 0x04001c02, 0x2513110c, 0x29081ba4,   // tr.az.yo_443 id.fi.un_220  ro.et.eu_543 tr.no.sl_433
  0x023f08a6, 0x0d001c19, 0x5200090c, 0x12002108,   // no.af.da_521 mr.ne.un_750  pl.ha.un_530 jw.hu.un_430
  0x0e000804, 0x032b0107, 0x0f112d0c, 0x0400130e,   // no.is.un_320 en.vi.nl_432  sk.ro.lv_543 et.fi.un_550
  // [05a0]
  0x1732165a, 0x01060c0c, 0x010c0812, 0x070501af,   // hr.bs.sr_553 sv.de.en_543  no.sv.en_654 en.fr.it_655
  0x10070aa4, 0x0300040d, 0x02000512, 0x070408a4,   // mk.bg.be_433 fi.nl.un_540  fr.da.un_640 uk.ru.bg_433
  0x07170a05, 0x121b09ec, 0x1c001308, 0x1a066ba0,   // mk.sr.bg_333 pl.tr.hu_644  bh.mr.un_430 ceb.de.tl_322
  0x033f0808, 0x10000d19, 0x2b006b04, 0x3f02080c,   // no.af.nl_443 cs.lt.un_750  ceb.vi.un_320 no.da.af_543
  // [05b0]
  0x2a005209, 0x355564a6, 0x033f0107, 0x252006a0,   // ha.mt.un_440 lg.rw.zu_521  en.af.nl_432 de.sq.eu_322
  0x110d1211, 0x312a1fad, 0x0802050c, 0x031a64a4,   // hu.cs.ro_653 cy.mt.az_643  fr.da.no_543 lg.tl.nl_433
  0x35001113, 0x6b042511, 0x12002d13, 0x3516250c,   // ro.zu.un_650 eu.fi.ceb_653  sk.hu.un_650 eu.hr.zu_543
  0x10000a07, 0x2d321702, 0x10000419, 0x093f0c0e,   // mk.be.un_420 sr.bs.sk_222  ru.be.un_750 sv.af.pl_555
  // [05c0]
  0x0f00101a, 0x08040aad, 0x13001c18, 0x316b20ee,   // lt.lv.un_760 mk.ru.uk_643  mr.bh.un_740 sq.ceb.az_422
  0x3f030607, 0x091c0da9, 0x0910045a, 0x183f0107,   // de.nl.af_432 ne.mr.hi_544  fi.lt.pl_553 en.af.ga_432
  0x00001a0a, 0x3f0603a0, 0x2a005208, 0x0900130c,   // tl.un.un_500 nl.de.af_322  ha.mt.un_430 bh.hi.un_530
  0x13090da4, 0x0000531c, 0x03000212, 0x2d000d04,   // ne.hi.bh_433 ht.un.un_800  da.nl.un_640 cs.sk.un_320
  // [05d0]
  0x0800100d, 0x21001208, 0x64005505, 0x11070aaf,   // be.uk.un_540 ur.fa.un_430  rw.lg.un_330 mk.bg.ro_655
  0x01001e02, 0x1c111ea7, 0x642835a4, 0x6b001604,   // ms.en.un_220 ms.ro.id_532  zu.sw.lg_433 hr.ceb.un_320
  0x03281a07, 0x0e001a04, 0x17000a1a, 0x53000e04,   // tl.sw.nl_432 tl.is.un_320  mk.sr.un_760 is.ht.un_320
  0x03063fa4, 0x00003b01, 0x0d112304, 0x0000230f,   // af.de.nl_433 so.un.un_200  ca.ro.cs_332 ca.un.un_600
  // [05e0]
  0x19000b08, 0x21001202, 0x18000e18, 0x03005207,   // es.gl.un_430 ur.fa.un_220  is.ga.un_740 ha.nl.un_420
  0x136428ac, 0x1000111a, 0x18122d04, 0x07001119,   // sw.lg.et_632 ro.be.un_760  sk.hu.ga_332 ro.bg.un_750
  0x0d130911, 0x52095502, 0x04131104, 0x180e01a0,   // hi.bh.ne_653 rw.pl.ha_222  ro.et.fi_332 en.is.ga_322
  0x0c080e0d, 0x080704ad, 0x08020ca4, 0x17001005,   // is.no.sv_554 ru.bg.uk_643  sv.da.no_433 lt.sr.un_330
  // [05f0]
  0x0200081a, 0x0000550a, 0x10002908, 0x4a001218,   // no.da.un_760 rw.un.un_500  sl.lt.un_430 hu.yo.un_740
  0x1202080c, 0x093235ee, 0x01000307, 0x0f0113a0,   // no.da.hu_543 zu.bs.pl_422  nl.en.un_420 et.en.lv_322
  0x55354a11, 0x32001704, 0x01001f04, 0x09006405,   // yo.zu.rw_653 sr.bs.un_320  cy.en.un_320 lg.pl.un_330
  0x0000310f, 0x52000807, 0x11000104, 0x082a0e0c,   // az.un.un_600 no.ha.un_420  en.ro.un_320 is.mt.no_543
  // [0600]
  0x68201113, 0x3b002119, 0x1b003119, 0x53000704,   // ro.sq.ig_665 jw.so.un_750  az.tr.un_750 it.ht.un_320
  0x1c000d18, 0x0000521c, 0x08060ea4, 0x170804a4,   // ne.mr.un_740 ha.un.un_800  is.de.no_433 ru.uk.sr_433
  0x0b00190c, 0x23001908, 0x25005307, 0x3f552104,   // gl.es.un_530 gl.ca.un_430  ht.eu.un_420 jw.rw.af_332
  0x04000a0e, 0x0d0913a0, 0x23110707, 0x00001715,   // pt.fi.un_550 bh.hi.ne_322  it.ro.ca_432 sr.un.un_700
  // [0610]
  0x64005519, 0x1000290c, 0x27033fa0, 0x07170405,   // rw.lg.un_750 sl.lt.un_530  af.nl.gd_322 ru.sr.bg_333
  0x00006403, 0x3b1e1c08, 0x6b1964a4, 0x3500521a,   // lg.un.un_300 id.ms.so_443  lg.gl.ceb_433 ha.zu.un_760
  0x10000704, 0x0a0708a4, 0x0f002305, 0x00000403,   // bg.be.un_320 uk.bg.mk_433  ca.lv.un_330 ru.un.un_300
  0x170f0707, 0x1b003513, 0x3f682011, 0x1e312a12,   // it.lv.sr_432 zu.tr.un_650  sq.ig.af_653 mt.az.ms_654
  // [0620]
  0x2a290daf, 0x1c1309ec, 0x1e001c0d, 0x3f0304a7,   // cs.sl.mt_655 hi.bh.mr_644  id.ms.un_540 fi.nl.af_532
  0x04080aa4, 0x3b001e04, 0x1c001302, 0x08041004,   // mk.uk.ru_433 ms.so.un_320  bh.mr.un_220 be.ru.uk_332
  0x2000250c, 0x3b0e2aad, 0x07000a13, 0x170a11a0,   // eu.sq.un_530 mt.is.so_643  mk.bg.un_650 ro.mk.sr_322
  0x00000301, 0x231b3107, 0x05004a07, 0x190b0a04,   // nl.un.un_200 az.tr.ca_432  yo.fr.un_420 pt.es.gl_332
  // [0630]
  0x20001013, 0x28005504, 0x18000e1a, 0x08171104,   // lt.sq.un_650 rw.sw.un_320  is.ga.un_760 ro.sr.uk_332
  0x01530c0b, 0x52072a07, 0x1b003204, 0x64521a08,   // sv.ht.en_542 mt.it.ha_432  bs.tr.un_320 tl.ha.lg_443
  0x020c08ec, 0x23190b04, 0x2100121b, 0x12002114,   // no.sv.da_644 es.gl.ca_332  ur.fa.un_770 fa.ur.un_660
  0x3b3f0313, 0x08002304, 0x08041707, 0x2800550e,   // nl.af.so_665 ca.no.un_320  sr.ru.uk_432 rw.sw.un_550
  // [0640]
  0x0600250c, 0x0b0a01a4, 0x20001904, 0x11001314,   // eu.de.un_530 en.pt.es_433  gl.sq.un_320 et.ro.un_660
  0x6b001a14, 0x01002a02, 0x12182114, 0x20230555,   // tl.ceb.un_660 mt.en.un_220  fa.ar.ur_666 fr.ca.sq_442
  0x0a001014, 0x6b000213, 0x4a033fad, 0x0a071755,   // be.mk.un_660 da.ceb.un_650  af.nl.yo_643 sr.bg.mk_442
  0x0b2d0d55, 0x070a1104, 0x29001604, 0x2300200e,   // cs.sk.es_442 ro.mk.bg_332  hr.sl.un_320 sq.ca.un_550
  // [0650]
  0x354a6404, 0x20002d04, 0x1e211c04, 0x05005304,   // lg.yo.zu_332 sk.sq.un_320  id.jw.ms_332 ht.fr.un_320
  0x02000808, 0x5305230c, 0x0a170812, 0x0a071713,   // no.da.un_430 ca.fr.ht_543  uk.sr.mk_654 sr.bg.mk_665
  0x113f0e04, 0x53001f04, 0x0700110e, 0x53006413,   // is.af.ro_332 cy.ht.un_320  ro.bg.un_550 lg.ht.un_650
  0x1f0511ad, 0x10000414, 0x06130807, 0x0000070a,   // ro.fr.cy_643 ru.be.un_660  no.et.de_432 it.un.un_500
  // [0660]
  0x64005304, 0x12190e05, 0x04001112, 0x01001004,   // ht.lg.un_320 is.gl.hu_333  ro.ru.un_640 lt.en.un_320
  0x0d120960, 0x3b0413a9, 0x0a000508, 0x17002a04,   // pl.hu.cs_664 et.fi.so_544  fr.pt.un_430 mt.sr.un_320
  0x352855ad, 0x00000615, 0x10006b02, 0x35002814,   // rw.sw.zu_643 de.un.un_700  ceb.lt.un_220 sw.zu.un_660
  0x64001220, 0x133b64a0, 0x1a000704, 0x130d0912,   // hu.lg.un_850 lg.so.et_322  it.tl.un_320 hi.ne.bh_654
  // [0670]
  0x282a2905, 0x1c251e04, 0x20120e0e, 0x2d120e05,   // sl.mt.sw_333 ms.eu.id_332  is.hu.sq_555 is.hu.sk_333
  0x2d120d0e, 0x07230a04, 0x190523a4, 0x170a11af,   // cs.hu.sk_555 pt.ca.it_332  ca.fr.gl_433 ro.mk.sr_655
  0x21001814, 0x01002411, 0x35134a07, 0x07000a14,   // ar.fa.un_660 yi.iw.un_630  yo.et.zu_432 mk.bg.un_660
  0x06000c0c, 0x271e1c07, 0x0a1708a4, 0x13006e09,   // sv.de.un_530 id.ms.gd_432  uk.sr.mk_433 hmn.et.un_440
  // [0680]
  0x64033f0c, 0x52080204, 0x53132a07, 0x190b2309,   // af.nl.lg_543 da.no.ha_332  mt.et.ht_432 ca.es.gl_444
  0x033f25ec, 0x27001e0d, 0x00001b1c, 0x192a0aad,   // eu.af.nl_644 ms.gd.un_540  tr.un.un_800 pt.mt.gl_643
  0x0d0913a7, 0x04682513, 0x01352a07, 0x35095508,   // bh.hi.ne_532 eu.ig.fi_665  mt.zu.en_432 rw.pl.zu_443
  0x21181208, 0x2000270d, 0x31006b07, 0x08000c08,   // ur.ar.fa_443 gd.sq.un_540  ceb.az.un_420 sv.no.un_430
  // [0690]
  0x201703ee, 0x07000414, 0x19000d13, 0x3f00031a,   // nl.sr.sq_422 ru.bg.un_660  cs.gl.un_650 nl.af.un_760
  0x2400011a, 0x042128a4, 0x211e29ee, 0x3f1118a0,   // iw.yi.un_760 sw.jw.fi_433  sl.ms.jw_422 ga.ro.af_322
  0x12001902, 0x1c4a6b04, 0x190b31a0, 0x09000707,   // gl.hu.un_220 ceb.yo.id_332  az.es.gl_322 it.pl.un_420
  0x25232a04, 0x0f003202, 0x0d091302, 0x12000912,   // mt.ca.eu_332 bs.lv.un_220  bh.hi.ne_222 pl.hu.un_640
  // [06a0]
  0x13042da4, 0x31002a0c, 0x2a2920a7, 0x10070812,   // sk.fi.et_433 mt.az.un_530  sq.sl.mt_532 uk.bg.be_654
  0x3f040312, 0x2700181a, 0x00003206, 0x01000509,   // nl.fi.af_654 ga.gd.un_760  bs.un.un_400 fr.en.un_440
  0x0d1c09a4, 0x091c2104, 0x080231ee, 0x110a07a4,   // hi.mr.ne_433 jw.id.pl_332  az.da.no_422 bg.mk.ro_433
  0x1300070c, 0x551a6b12, 0x21001c07, 0x3b00350c,   // it.et.un_530 ceb.tl.rw_654  id.jw.un_420 zu.so.un_530
  // [06b0]
  0x12002119, 0x0d1c0955, 0x0c040107, 0x19052107,   // fa.ur.un_750 hi.mr.ne_442  en.fi.sv_432 jw.fr.gl_432
  0x052301a4, 0x08020c02, 0x13006e0c, 0x353f0304,   // en.ca.fr_433 sv.da.no_222  hmn.et.un_530 nl.af.zu_332
  0x3f006e0d, 0x0311085a, 0x64682160, 0x07040805,   // hmn.af.un_540 no.ro.nl_553  jw.ig.lg_664 uk.ru.bg_333
  0x1a002b12, 0x17070a0e, 0x00001706, 0x08020ca0,   // vi.tl.un_640 mk.bg.sr_555  sr.un.un_400 sv.da.no_322
  // [06c0]
  0x08000714, 0x1b00110c, 0x52023ba4, 0x190a050c,   // bg.uk.un_660 ro.tr.un_530  so.da.ha_433 fr.pt.gl_543
  0x092d0d09, 0x35001819, 0x0d09130c, 0x19002305,   // cs.sk.pl_444 ga.zu.un_750  bh.hi.ne_543 ca.gl.un_330
  0x016b110c, 0x03041312, 0x32171602, 0x320701a4,   // ro.ceb.en_543 et.fi.nl_654  hr.sr.bs_222 en.it.bs_433
  0x27186bee, 0x17070aa0, 0x13070305, 0x05214a04,   // ceb.ga.gd_422 mk.bg.sr_322  nl.it.et_333 yo.jw.fr_332
  // [06d0]
  0x214a13a6, 0x64130408, 0x283152a0, 0x532023ad,   // et.yo.jw_521 fi.et.lg_443  ha.az.sw_322 ca.sq.ht_643
  0x2a5325ee, 0x10040612, 0x212d0d04, 0x18000104,   // eu.ht.mt_422 de.fi.lt_654  cs.sk.jw_332 en.ga.un_320
  0x4a005204, 0x12190b08, 0x11070a05, 0x2d001812,   // ha.yo.un_320 es.gl.hu_443  mk.bg.ro_333 ga.sk.un_640
  0x52002104, 0x08000c0c, 0x23000b02, 0x1b003114,   // jw.ha.un_320 sv.no.un_530  es.ca.un_220 az.tr.un_660
  // [06e0]
  0x06001908, 0x130d1c12, 0x0c005304, 0x643b2a07,   // gl.de.un_430 mr.ne.bh_654  ht.sv.un_320 mt.so.lg_432
  0x070411ad, 0x281610ee, 0x64553507, 0x11002a0c,   // ro.ru.bg_643 lt.hr.sw_422  zu.rw.lg_432 mt.ro.un_530
  0x0f002a12, 0x0f100807, 0x1c121e04, 0x1300041a,   // mt.lv.un_640 no.lt.lv_432  ms.hu.id_332 fi.et.un_760
  0x2100120d, 0x16000b02, 0x0b0a2aa0, 0x081107a4,   // ur.fa.un_540 es.hr.un_220  mt.pt.es_322 bg.ro.uk_433
  // [06f0]
  0x31130612, 0x00002715, 0x3f0b01ad, 0x06002909,   // de.et.az_654 gd.un.un_700  en.es.af_643 sl.de.un_440
  0x190a05a0, 0x041b0802, 0x3f6b28a0, 0x531c05ad,   // fr.pt.gl_322 no.tr.fi_222  sw.ceb.af_322 fr.id.ht_643
  0x27001a04, 0x20000702, 0x1b003112, 0x0e0c1304,   // tl.gd.un_320 it.sq.un_220  az.tr.un_640 et.sv.is_332
  0x08000414, 0x120d2807, 0x0804100d, 0x2000350e,   // ru.uk.un_660 sw.cs.hu_432  be.ru.uk_554 zu.sq.un_550
  // [0700]
  0x29001f07, 0x0f001213, 0x08070413, 0x03002302,   // cy.sl.un_420 hu.lv.un_650  ru.bg.uk_665 ca.nl.un_220
  0x1b006408, 0x3b082a02, 0x233f030d, 0x12001f0c,   // lg.tr.un_430 mt.no.so_222  nl.af.ca_554 cy.hu.un_530
  0x080c0e13, 0x35046b04, 0x09000d04, 0x01000504,   // is.sv.no_665 ceb.fi.zu_332  ne.hi.un_320 fr.en.un_320
  0x23000f08, 0x2b002702, 0x170410a0, 0x17000402,   // lv.ca.un_430 gd.vi.un_220  be.ru.sr_322 ru.sr.un_220
  // [0710]
  0x0a0f1102, 0x1800120d, 0x201c28ee, 0x182b0aa0,   // ro.lv.pt_222 ur.ar.un_540  sw.id.sq_422 pt.vi.ga_322
  0x2d002908, 0x013b2d07, 0x2a003112, 0x08023bee,   // sl.sk.un_430 sk.so.en_432  az.mt.un_640 so.da.no_422
  0x640d28ee, 0x122a1fee, 0x04006404, 0x0800100e,   // sw.cs.lg_422 cy.mt.hu_422  lg.fi.un_320 be.uk.un_550
  0x3f0610ee, 0x040a08a4, 0x13003519, 0x1f0e0807,   // lt.de.af_422 uk.mk.ru_433  zu.et.un_750 no.is.cy_432
  // [0720]
  0x1e213f04, 0x0a0f1208, 0x10041305, 0x2d0d12a4,   // af.jw.ms_332 hu.lv.pt_443  et.fi.lt_333 hu.cs.sk_433
  0x11001214, 0x3f080204, 0x08002a07, 0x010c0504,   // hu.ro.un_660 da.no.af_332  mt.no.un_420 fr.sv.en_332
  0x1b000c0b, 0x2a000104, 0x0600350d, 0x1a0a350c,   // sv.tr.un_520 en.mt.un_320  zu.de.un_540 zu.pt.tl_543
  0x2800551a, 0x27182107, 0x55004a02, 0x203207a0,   // rw.sw.un_760 jw.ga.gd_432  yo.rw.un_220 it.bs.sq_322
  // [0730]
  0x016b0604, 0x0408170e, 0x080201a4, 0x00002303,   // de.ceb.en_332 sr.uk.ru_555  en.da.no_433 ca.un.un_300
  0x040a170d, 0x1f3f64a0, 0x020c08a9, 0x0a005504,   // sr.mk.ru_554 lg.af.cy_322  no.sv.da_544 rw.pt.un_320
  0x13000d05, 0x040817af, 0x0804070d, 0x0b230107,   // ne.bh.un_330 sr.uk.ru_655  bg.ru.uk_554 en.ca.es_432
  0x2800290e, 0x53002a07, 0x20020ca4, 0x0a0407a4,   // sl.sw.un_550 mt.ht.un_420  sv.da.sq_433 bg.ru.mk_433
  // [0740]
  0x2000640c, 0x11271807, 0x16002912, 0x6b1a2112,   // lg.sq.un_530 ga.gd.ro_432  sl.hr.un_640 jw.tl.ceb_654
  0x6b3f08ee, 0x1e003512, 0x00003103, 0x12003f04,   // no.af.ceb_422 zu.ms.un_640  az.un.un_300 af.hu.un_320
  0x09001904, 0x16002007, 0x0b122da0, 0x6e212b05,   // gl.pl.un_320 sq.hr.un_420  sk.hu.es_322 vi.jw.hmn_333
  0x08000713, 0x3b003512, 0x170807ee, 0x033f23a7,   // bg.uk.un_650 zu.so.un_640  bg.uk.sr_422 ca.af.nl_532
  // [0750]
  0x1e532aee, 0x1f000309, 0x23052104, 0x1f001c02,   // mt.ht.ms_422 nl.cy.un_440  jw.fr.ca_332 id.cy.un_220
  0x1f000704, 0x3f1c2702, 0x1f001704, 0x53230504,   // it.cy.un_320 gd.id.af_222  sr.cy.un_320 fr.ca.ht_332
  0x11040705, 0x31002011, 0x2d00290e, 0x100408a9,   // bg.ru.ro_333 sq.az.un_630  sl.sk.un_550 uk.ru.be_544
  0x2b002102, 0x27180555, 0x2b000708, 0x00003501,   // jw.vi.un_220 fr.ga.gd_442  it.vi.un_430 zu.un.un_200
  // [0760]
  0x29001105, 0x1a003b19, 0x0a07170e, 0x27002d08,   // ro.sl.un_330 so.tl.un_750  sr.bg.mk_555 sk.gd.un_430
  0x1e000607, 0x00000e0a, 0x07000412, 0x126b1a0c,   // de.ms.un_420 is.un.un_500  ru.bg.un_640 tl.ceb.hu_543
  0x29003207, 0x07001114, 0x13000c08, 0x21101ea0,   // bs.sl.un_420 ro.bg.un_660  sv.et.un_430 ms.lt.jw_322
  0x2a2301a0, 0x06080204, 0x0500070e, 0x04091fa7,   // en.ca.mt_322 da.no.de_332  it.fr.un_550 cy.pl.fi_532
  // [0770]
  0x21203bec, 0x532705a7, 0x10000412, 0x6b3b320d,   // so.sq.jw_644 fr.gd.ht_532  ru.be.un_640 bs.so.ceb_554
  0x171107a4, 0x203519ee, 0x04006b05, 0x1f311b08,   // bg.ro.sr_433 gl.zu.sq_422  ceb.fi.un_330 tr.az.cy_443
  0x28011802, 0x35006e18, 0x0b0a1fa0, 0x08002104,   // ga.en.sw_222 hmn.zu.un_740  cy.pt.es_322 jw.no.un_320
  0x00003f03, 0x6b6410ee, 0x0800200e, 0x27000822,   // af.un.un_300 lt.lg.ceb_422  sq.no.un_550 no.gd.un_870
  // [0780]
  0x06001b19, 0x3b3555a0, 0x0804110b, 0x1b2a0713,   // tr.de.un_750 rw.zu.so_322  ro.ru.uk_542 it.mt.tr_665
  0x6b001f12, 0x4a003b14, 0x0000310a, 0x3b2128a0,   // cy.ceb.un_640 so.yo.un_660  az.un.un_500 sw.jw.so_322
  0x4a002d0d, 0x1c2352a6, 0x08041712, 0x10002302,   // sk.yo.un_540 ha.ca.id_521  sr.ru.uk_654 ca.lt.un_220
  0x0c080209, 0x05002102, 0x0a0717af, 0x080225a0,   // da.no.sv_444 jw.fr.un_220  sr.bg.mk_655 eu.da.no_322
  // [0790]
  0x23190a13, 0x09001214, 0x08000419, 0x3b000b02,   // pt.gl.ca_665 hu.pl.un_660  ru.uk.un_750 es.so.un_220
  0x17060804, 0x21005204, 0x28556407, 0x3f001e02,   // no.de.sr_332 ha.jw.un_320  lg.rw.sw_432 ms.af.un_220
  0x20100fa6, 0x0a171104, 0x08001002, 0x25200e07,   // lv.lt.sq_521 ro.sr.mk_332  be.uk.un_220 is.sq.eu_432
  0x3b1e1304, 0x10081705, 0x09001c14, 0x3f1a6ba0,   // et.ms.so_332 sr.uk.be_333  mr.hi.un_660 ceb.tl.af_322
  // [07a0]
  0x32001605, 0x0a00230e, 0x131a6b13, 0x2b192307,   // hr.bs.un_330 ca.pt.un_550  ceb.tl.et_665 ca.gl.vi_432
  0x05002107, 0x5268200b, 0x32642808, 0x09001313,   // jw.fr.un_420 sq.ig.ha_542  sw.lg.bs_443 bh.hi.un_650
  0x070a11a4, 0x120c1bad, 0x1c006407, 0x08041002,   // ro.mk.bg_433 tr.sv.hu_643  lg.id.un_420 be.ru.uk_222
  0x2d0d09af, 0x18002704, 0x012d090d, 0x1c090d12,   // pl.cs.sk_655 gd.ga.un_320  pl.sk.en_554 ne.hi.mr_654
  // [07b0]
  0x120d09a4, 0x53006402, 0x2d6425a0, 0x0d000908,   // pl.cs.hu_433 lg.ht.un_220  eu.lg.sk_322 hi.ne.un_430
  0x1218210c, 0x190b31a4, 0x1b311213, 0x06051304,   // fa.ar.ur_543 az.es.gl_433  hu.az.tr_665 et.fr.de_332
  0x29203202, 0x04001013, 0x276b1a55, 0x21355355,   // bs.sq.sl_222 be.ru.un_650  tl.ceb.gd_442 ht.zu.jw_442
  0x0c001f12, 0x01003507, 0x28101112, 0x051c03ac,   // cy.sv.un_640 zu.en.un_420  ro.lt.sw_654 nl.id.fr_632
  // [07c0]
  0x206b1a0c, 0x17000a05, 0x132507a0, 0x23001a07,   // tl.ceb.sq_543 mk.sr.un_330  it.eu.et_322 tl.ca.un_420
  0x00006b24, 0x17040813, 0x25000f19, 0x6468355a,   // ceb.un.un_900 uk.ru.sr_665  lv.eu.un_750 zu.ig.lg_553
  0x00001306, 0x6b1a27ad, 0x04000714, 0x291b3107,   // bh.un.un_400 gd.tl.ceb_643  bg.ru.un_660 az.tr.sl_432
  0x060c0809, 0x53001704, 0x132506ee, 0x07311b55,   // no.sv.de_444 sr.ht.un_320  de.eu.et_422 tr.az.it_442
  // [07d0]
  0x17001f04, 0x1b2b05ec, 0x31001b0b, 0x00001c06,   // cy.sr.un_320 fr.vi.tr_644  tr.az.un_520 id.un.un_400
  0x35001a04, 0x1a0e3b05, 0x0407080c, 0x31281b14,   // tl.zu.un_320 so.is.tl_333  uk.bg.ru_543 tr.sw.az_666
  0x130d09ac, 0x09000d0e, 0x2100050e, 0x07001f04,   // hi.ne.bh_632 ne.hi.un_550  fr.jw.un_550 cy.it.un_320
  0x5300011a, 0x0c2521ee, 0x08212008, 0x05190b02,   // en.ht.un_760 jw.eu.sv_422  sq.jw.no_443 es.gl.fr_222
  // [07e0]
  0x171104a4, 0x0b006b08, 0x3b07110e, 0x6b010404,   // ru.ro.sr_433 ceb.es.un_430  ro.it.so_555 fi.en.ceb_332
  0x0c001f07, 0x010a2da0, 0x131b1aa0, 0x1e003f12,   // cy.sv.un_420 sk.pt.en_322  tl.tr.et_322 af.ms.un_640
  0x172916a0, 0x10040805, 0x0912250c, 0x520a1fa9,   // hr.sl.sr_322 uk.ru.be_333  eu.hu.pl_543 cy.pt.ha_544
  0x1b1e1c02, 0x28356404, 0x28352004, 0x686455a4,   // id.ms.tr_222 lg.zu.sw_332  sq.zu.sw_332 rw.lg.ig_433
  // [07f0]
  0x18002113, 0x0d1c1307, 0x01001a08, 0x170a1108,   // fa.ar.un_650 bh.mr.ne_432  tl.en.un_430 ro.mk.sr_443
  0x09001304, 0x531903a0, 0x171307ee, 0x08000705,   // bh.hi.un_320 nl.gl.ht_322  it.et.sr_422 it.no.un_330
  0x070a0412, 0x12001818, 0x13001c12, 0x016b3fee,   // ru.mk.bg_654 ar.ur.un_740  mr.bh.un_640 af.ceb.en_422
  0x12004a04, 0x13000918, 0x3105350c, 0x06033f0c,   // yo.hu.un_320 hi.bh.un_740  zu.fr.az_543 af.nl.de_543

  // [0800]
  0x28006407, 0x311b2007, 0x0d091c07, 0x122d0d08,   // lg.sw.un_420 sq.tr.az_432  mr.hi.ne_432 cs.sk.hu_443
  0x2d0d12ac, 0x1a006402, 0x31101b55, 0x31000504,   // hu.cs.sk_632 lg.tl.un_220  tr.lt.az_442 fr.az.un_320
  0x07001002, 0x31000a04, 0x2d091205, 0x0b00230d,   // be.bg.un_220 pt.az.un_320  hu.pl.sk_333 ca.es.un_540
  0x09006404, 0x1c0720a4, 0x07040aa0, 0x04002908,   // lg.pl.un_320 sq.it.id_433  mk.ru.bg_322 sl.fi.un_430
  // [0810]
  0x12053bac, 0x532b2807, 0x033f0613, 0x031c28ee,   // so.fr.hu_632 sw.vi.ht_432  de.af.nl_665 sw.id.nl_422
  0x00004a24, 0x23001909, 0x53000418, 0x520635ad,   // yo.un.un_900 gl.ca.un_440  fi.ht.un_740 zu.de.ha_643
  0x040710a0, 0x122118a9, 0x04080aa0, 0x04170708,   // be.bg.ru_322 ar.fa.ur_544  mk.uk.ru_322 bg.sr.ru_443
  0x6b0e1a12, 0x2500351a, 0x6b0e1aec, 0x18002709,   // tl.is.ceb_654 zu.eu.un_760  tl.is.ceb_644 gd.ga.un_440
  // [0820]
  0x211e1c55, 0x52002121, 0x0a1707a4, 0x08001012,   // id.ms.jw_442 jw.ha.un_860  bg.sr.mk_433 be.uk.un_640
  0x0c190b08, 0x17001113, 0x0a17070e, 0x1c002104,   // es.gl.sv_443 ro.sr.un_650  bg.sr.mk_555 jw.id.un_320
  0x060208a0, 0x0b033f04, 0x07000b02, 0x0a0417a0,   // no.da.de_322 af.nl.es_332  es.it.un_220 sr.ru.mk_322
  0x6423530c, 0x00002d1c, 0x29001f18, 0x110a1708,   // ht.ca.lg_543 sk.un.un_800  cy.sl.un_740 sr.mk.ro_443
  // [0830]
  0x35552812, 0x0c0208a4, 0x52000e08, 0x08033f08,   // sw.rw.zu_654 no.da.sv_433  is.ha.un_430 af.nl.no_443
  0x080411ee, 0x08000707, 0x04123509, 0x55112007,   // ro.ru.uk_422 bg.uk.un_420  zu.hu.fi_444 sq.ro.rw_432
  0x12556b0b, 0x6b3b1a12, 0x280131a0, 0x1c0d090c,   // ceb.rw.hu_542 tl.so.ceb_654  az.en.sw_322 hi.ne.mr_543
  0x293b52a0, 0x29321704, 0x00000e1c, 0x2d290dee,   // ha.so.sl_322 sr.bs.sl_332  is.un.un_800 cs.sl.sk_422
  // [0840]
  0x350955a7, 0x08070408, 0x056e2007, 0x1c0d1305,   // rw.pl.zu_532 ru.bg.uk_443  sq.hmn.fr_432 bh.ne.mr_333
  0x070a17af, 0x06040c07, 0x0c003f07, 0x6b521a14,   // sr.mk.bg_655 sv.fi.de_432  af.sv.un_420 tl.ha.ceb_666
  0x04005209, 0x1e1c55a0, 0x2d1b3104, 0x161a2d07,   // ha.fi.un_440 rw.id.ms_322  az.tr.sk_332 sk.tl.hr_432
  0x53002708, 0x13091ca9, 0x0f1017a0, 0x1000081a,   // gd.ht.un_430 mr.hi.bh_544  sr.lt.lv_322 uk.be.un_760
  // [0850]
  0x070a11a0, 0x06000c08, 0x07002507, 0x52001f02,   // ro.mk.bg_322 sv.de.un_430  eu.it.un_420 cy.ha.un_220
  0x03003f12, 0x0f00040c, 0x2d0d05ec, 0x091c1304,   // af.nl.un_640 fi.lv.un_530  fr.cs.sk_644 bh.mr.hi_332
  0x17290d07, 0x13041aa0, 0x530d0405, 0x3b356404,   // cs.sl.sr_432 tl.fi.et_322  fi.cs.ht_333 lg.zu.so_332
  0x05100107, 0x0b000a12, 0x17000804, 0x17000905,   // en.lt.fr_432 pt.es.un_640  uk.sr.un_320 pl.sr.un_330
  // [0860]
  0x3200520c, 0x09000d05, 0x112520ad, 0x35041004,   // ha.bs.un_530 ne.hi.un_330  sq.eu.ro_643 lt.fi.zu_332
  0x201b3204, 0x551e28a4, 0x07001013, 0x0900550c,   // bs.tr.sq_332 sw.ms.rw_433  be.bg.un_650 rw.pl.un_530
  0x3f3b03af, 0x53680107, 0x19003b19, 0x0e000212,   // nl.so.af_655 en.ig.ht_432  so.gl.un_750 da.is.un_640
  0x161f2aa4, 0x0a190b0d, 0x3200170c, 0x321716af,   // mt.cy.hr_433 es.gl.pt_554  sr.bs.un_530 hr.sr.bs_655
  // [0870]
  0x1c000908, 0x12003512, 0x2a0e2808, 0x250604ee,   // hi.mr.un_430 zu.hu.un_640  sw.is.mt_443 fi.de.eu_422
  0x0a1107a4, 0x17163209, 0x1b000614, 0x09001318,   // bg.ro.mk_433 bs.hr.sr_444  de.tr.un_660 bh.hi.un_740
  0x0800171a, 0x1b31040c, 0x04202bad, 0x3b3f0307,   // sr.uk.un_760 fi.az.tr_543  vi.sq.fi_643 nl.af.so_432
  0x04001007, 0x0c001f04, 0x0a001704, 0x05003f07,   // be.ru.un_420 cy.sv.un_320  sr.mk.un_320 af.fr.un_420
  // [0880]
  0x08021105, 0x0a170808, 0x35003f08, 0x09200408,   // ro.da.no_333 uk.sr.mk_443  af.zu.un_430 fi.sq.pl_443
  0x091f18af, 0x06006b04, 0x1200180e, 0x4a003f19,   // ga.cy.pl_655 ceb.de.un_320  ga.hu.un_550 af.yo.un_750
  0x3b4a53ac, 0x35000b04, 0x04006b04, 0x0e0c08a4,   // ht.yo.so_632 es.zu.un_320  ceb.fi.un_320 no.sv.is_433
  0x16000908, 0x023f0355, 0x1e001c07, 0x0f321702,   // pl.hr.un_430 nl.af.da_442  id.ms.un_420 sr.bs.lv_222
  // [0890]
  0x2b002304, 0x170711ee, 0x0a071113, 0x09001302,   // ca.vi.un_320 ro.bg.sr_422  ro.bg.mk_665 bh.hi.un_220
  0x0d091c60, 0x6b2d0dad, 0x2100121a, 0x06531f0d,   // mr.hi.ne_664 cs.sk.ceb_643  ur.fa.un_760 cy.ht.de_554
  0x29005308, 0x1b001e04, 0x25002014, 0x122d0d13,   // ht.sl.un_430 ms.tr.un_320  sq.eu.un_660 cs.sk.hu_665
  0x1c521e04, 0x06010507, 0x110405a4, 0x133b3f04,   // ms.ha.id_332 fr.en.de_432  fr.fi.ro_433 af.so.et_332
  // [08a0]
  0x1c6b1a04, 0x0d091cec, 0x13000902, 0x1e1c2102,   // tl.ceb.id_332 mr.hi.ne_644  hi.bh.un_220 jw.id.ms_222
  0x211e1c05, 0x0c002504, 0x2168280c, 0x1c001e08,   // id.ms.jw_333 eu.sv.un_320  sw.ig.jw_543 ms.id.un_430
  0x04000312, 0x12080aa7, 0x0a001908, 0x07170805,   // nl.fi.un_640 pt.no.hu_532  gl.pt.un_430 uk.sr.bg_333
  0x211c2aa0, 0x31001908, 0x1c0913a4, 0x230a0704,   // mt.id.jw_322 gl.az.un_430  bh.hi.mr_433 it.pt.ca_332
  // [08b0]
  0x19000b0b, 0x091c0d12, 0x12006b08, 0x0f321708,   // es.gl.un_520 ne.mr.hi_654  ceb.hu.un_430 sr.bs.lv_443
  0x64080202, 0x21001212, 0x190b23ee, 0x4a006819,   // da.no.lg_222 hu.jw.un_640  ca.es.gl_422 ig.yo.un_750
  0x122118af, 0x01033b0d, 0x170a115a, 0x0a1c21a0,   // ar.fa.ur_655 so.nl.en_554  ro.mk.sr_553 jw.id.pt_322
  0x1105010c, 0x1b006409, 0x190b0aa6, 0x0b0705ee,   // en.fr.ro_543 lg.tr.un_440  pt.es.gl_521 fr.it.es_422
  // [08c0]
  0x17080412, 0x18005204, 0x20230aa7, 0x033f01af,   // ru.uk.sr_654 ha.ga.un_320  pt.ca.sq_532 en.af.nl_655
  0x00001a15, 0x32002004, 0x09001312, 0x23042504,   // tl.un.un_700 sq.bs.un_320  bh.hi.un_640 eu.fi.ca_332
  0x0b000108, 0x130603ee, 0x252313ac, 0x3f020e0c,   // en.es.un_430 nl.de.et_422  et.ca.eu_632 is.da.af_543
  0x12000b04, 0x11000108, 0x682a52a9, 0x1c002012,   // es.hu.un_320 en.ro.un_430  ha.mt.ig_544 sq.id.un_640
  // [08d0]
  0x0b121812, 0x0c53010b, 0x05002b12, 0x64001113,   // ga.hu.es_654 en.ht.sv_542  vi.fr.un_640 ro.lg.un_650
  0x11000a08, 0x07171155, 0x131c09ad, 0x31020811,   // mk.ro.un_430 ro.sr.bg_442  hi.mr.bh_643 no.da.az_653
  0x21002704, 0x64001a12, 0x03000c05, 0x09002d0d,   // gd.jw.un_320 tl.lg.un_640  sv.nl.un_330 sk.pl.un_540
  0x64551213, 0x68002b0e, 0x3b4a6411, 0x08001704,   // hu.rw.lg_665 vi.ig.un_550  lg.yo.so_653 sr.uk.un_320
  // [08e0]
  0x6b00010c, 0x07111055, 0x6e1235a0, 0x271a1807,   // en.ceb.un_530 be.ro.bg_442  zu.hu.hmn_322 ga.tl.gd_432
  0x00000401, 0x0c311b07, 0x4a002b0c, 0x04000819,   // ru.un.un_200 tr.az.sv_432  vi.yo.un_530 uk.ru.un_750
  0x320f1707, 0x08001113, 0x07000419, 0x27051902,   // sr.lv.bs_432 ro.uk.un_650  ru.bg.un_750 gl.fr.gd_222
  0x09101fad, 0x051f07ee, 0x25005312, 0x00000803,   // cy.lt.pl_643 it.cy.fr_422  ht.eu.un_640 uk.un.un_300
  // [08f0]
  0x091f3b04, 0x09005311, 0x0d091c14, 0x08070aa0,   // so.cy.pl_332 ht.pl.un_630  mr.hi.ne_666 mk.bg.uk_322
  0x0a070414, 0x21095507, 0x251805ad, 0x21006807,   // ru.bg.mk_666 rw.pl.jw_432  fr.ga.eu_643 ig.jw.un_420
  0x1f000708, 0x18120d0b, 0x1c3b1eee, 0x25006404,   // it.cy.un_430 cs.hu.ga_542  ms.so.id_422 lg.eu.un_320
  0x2818270c, 0x0000090a, 0x190a05a6, 0x6b2a3b07,   // gd.ga.sw_543 pl.un.un_500  fr.pt.gl_521 so.mt.ceb_432
  // [0900]
  0x64101a5a, 0x554a0807, 0x0c0e08a0, 0x1e1c01ee,   // tl.lt.lg_553 no.yo.rw_432  no.is.sv_322 en.id.ms_422
  0x27000108, 0x10040812, 0x033f080c, 0x21006b07,   // en.gd.un_430 uk.ru.be_654  no.af.nl_543 ceb.jw.un_420
  0x16006b02, 0x0d1c130c, 0x552864ad, 0x0c003b04,   // ceb.hr.un_220 bh.mr.ne_543  lg.sw.rw_643 so.sv.un_320
  0x06230a0c, 0x6b3b0455, 0x023f13ec, 0x00000a1c,   // pt.ca.de_543 fi.so.ceb_442  et.af.da_644 mk.un.un_800
  // [0910]
  0x12000a0c, 0x020c13a0, 0x0b000a08, 0x091c13a9,   // pt.hu.un_530 et.sv.da_322  pt.es.un_430 bh.mr.hi_544
  0x09000d14, 0x10003f13, 0x1b00250d, 0x17001014,   // ne.hi.un_660 af.lt.un_650  eu.tr.un_540 be.sr.un_660
  0x130d09ec, 0x0d001904, 0x0a110408, 0x23002d08,   // hi.ne.bh_644 gl.cs.un_320  ru.ro.mk_443 sk.ca.un_430
  0x09000d12, 0x31552508, 0x02000302, 0x6b000104,   // ne.hi.un_640 eu.rw.az_443  nl.da.un_220 en.ceb.un_320
  // [0920]
  0x21001e02, 0x040a1107, 0x320f1012, 0x4a003112,   // ms.jw.un_220 ro.mk.ru_432  lt.lv.bs_654 az.yo.un_640
  0x041711ad, 0x130c0411, 0x00000a01, 0x163217a7,   // ro.sr.ru_643 fi.sv.et_653  mk.un.un_200 sr.bs.hr_532
  0x3b001907, 0x18000f19, 0x06293504, 0x286e3bad,   // gl.so.un_420 lv.ga.un_750  zu.sl.de_332 so.hmn.sw_643
  0x111f2512, 0x6b001a1a, 0x3f020ead, 0x203153ee,   // eu.cy.ro_654 tl.ceb.un_760  is.da.af_643 ht.az.sq_422
  // [0930]
  0x00000503, 0x1c005505, 0x27001c02, 0x17080405,   // fr.un.un_300 rw.id.un_330  id.gd.un_220 ru.uk.sr_333
  0x13091ca4, 0x16290e07, 0x080410ad, 0x2b086bee,   // mr.hi.bh_433 is.sl.hr_432  be.ru.uk_643 ceb.no.vi_422
  0x182112a9, 0x21001c05, 0x100313a0, 0x040810a9,   // ur.fa.ar_544 id.jw.un_330  et.nl.lt_322 be.uk.ru_544
  0x0d2d12a9, 0x253f03a4, 0x200f1b07, 0x556801ee,   // hu.sk.cs_544 nl.af.eu_433  tr.lv.sq_432 en.ig.rw_422
  // [0940]
  0x102007ee, 0x271811a4, 0x0a2d0d0b, 0x0b033fa4,   // it.sq.lt_422 ro.ga.gd_433  cs.sk.pt_542 af.nl.es_433
  0x00000c03, 0x0d2d2104, 0x32162aa9, 0x172901a4,   // sv.un.un_300 jw.sk.cs_332  mt.hr.bs_544 en.sl.sr_433
  0x0810110b, 0x12211813, 0x55000112, 0x0c000808,   // ro.be.uk_542 ar.fa.ur_665  en.rw.un_640 no.sv.un_430
  0x110701a4, 0x03023fa7, 0x04252dec, 0x00000f0a,   // en.it.ro_433 af.da.nl_532  sk.eu.fi_644 lv.un.un_500
  // [0950]
  0x0c00020e, 0x4a190b08, 0x4a00351a, 0x4a2520ee,   // da.sv.un_550 es.gl.yo_443  zu.yo.un_760 sq.eu.yo_422
  0x02000c08, 0x04000814, 0x0804170e, 0x3f000108,   // sv.da.un_430 uk.ru.un_660  sr.ru.uk_555 en.af.un_430
  0x00002124, 0x01003202, 0x07000405, 0x643555a4,   // jw.un.un_900 bs.en.un_220  fi.it.un_330 rw.zu.lg_433
  0x206b1aa4, 0x4a00681a, 0x200c12af, 0x28001207,   // tl.ceb.sq_433 ig.yo.un_760  hu.sv.sq_655 hu.sw.un_420
  // [0960]
  0x0d091309, 0x35004a11, 0x2d0d3bee, 0x6b1b35a4,   // bh.hi.ne_444 yo.zu.un_630  so.cs.sk_422 zu.tr.ceb_433
  0x2a071312, 0x28643560, 0x0e190b55, 0x040a07a4,   // et.it.mt_654 zu.lg.sw_664  es.gl.is_442 bg.mk.ru_433
  0x05005302, 0x09000d08, 0x0f2028ad, 0x0d091ca0,   // ht.fr.un_220 ne.hi.un_430  sw.sq.lv_643 mr.hi.ne_322
  0x23033f0c, 0x23551105, 0x0f321704, 0x131c0911,   // af.nl.ca_543 ro.rw.ca_333  sr.bs.lv_332 hi.mr.bh_653
  // [0970]
  0x021310a4, 0x11170a12, 0x12000b02, 0x3b100704,   // lt.et.da_433 mk.sr.ro_654  es.hu.un_220 it.lt.so_332
  0x04170a04, 0x2500111a, 0x0708170e, 0x0a080702,   // mk.sr.ru_332 ro.eu.un_760  sr.uk.bg_555 bg.uk.mk_222
  0x06002507, 0x281355af, 0x04000c0e, 0x312a0704,   // eu.de.un_420 rw.et.sw_655  sv.fi.un_550 it.mt.az_332
  0x182d0d05, 0x1a1b6ba4, 0x13006407, 0x1e1c21a9,   // cs.sk.ga_333 ceb.tr.tl_433  lg.et.un_420 jw.id.ms_544
  // [0980]
  0x06006807, 0x062313ec, 0x13090daf, 0x310f1b07,   // ig.de.un_420 et.ca.de_644  ne.hi.bh_655 tr.lv.az_432
  0x0d001c12, 0x09000613, 0x112723a0, 0x23001107,   // mr.ne.un_640 de.pl.un_650  ca.gd.ro_322 ro.ca.un_420
  0x35311bad, 0x01002408, 0x0d130908, 0x295528af,   // tr.az.zu_643 yi.iw.un_430  hi.bh.ne_443 sw.rw.sl_655
  0x080a07a4, 0x13002507, 0x2a0f1208, 0x53001b19,   // bg.mk.uk_433 eu.et.un_420  hu.lv.mt_443 tr.ht.un_750
  // [0990]
  0x68182ba4, 0x131a35a0, 0x28080c08, 0x29001707,   // vi.ga.ig_433 zu.tl.et_322  sv.no.sw_443 sr.sl.un_420
  0x553b06ee, 0x02041355, 0x3f000313, 0x2800070e,   // de.so.rw_422 et.fi.da_442  nl.af.un_650 it.sw.un_550
  0x35001c04, 0x02000e0d, 0x2164280c, 0x190a0b09,   // id.zu.un_320 is.da.un_540  sw.lg.jw_543 es.pt.gl_444
  0x321e55a0, 0x35006802, 0x16000f0b, 0x23002d04,   // rw.ms.bs_322 ig.zu.un_220  lv.hr.un_520 sk.ca.un_320
  // [09a0]
  0x0513110c, 0x2d0d09ec, 0x190a0b0c, 0x29001702,   // ro.et.fr_543 pl.cs.sk_644  es.pt.gl_543 sr.sl.un_220
  0x552835a9, 0x17080d07, 0x31002013, 0x35003f14,   // zu.sw.rw_544 cs.no.sr_432  sq.az.un_650 af.zu.un_660
  0x1c0d1302, 0x1b003b13, 0x12000f13, 0x2d000307,   // bh.ne.mr_222 so.tr.un_650  lv.hu.un_650 nl.sk.un_420
  0x06000c12, 0x0d1219a0, 0x2855640d, 0x08040705,   // sv.de.un_640 gl.hu.cs_322  lg.rw.sw_554 bg.ru.uk_333
  // [09b0]
  0x13002113, 0x04001705, 0x0d001604, 0x0e643fa0,   // jw.et.un_650 sr.ru.un_330  hr.cs.un_320 af.lg.is_322
  0x211a6bad, 0x133f0411, 0x0d130913, 0x1c3b2aa0,   // ceb.tl.jw_643 fi.af.et_653  hi.bh.ne_665 mt.so.id_322
  0x20556407, 0x553f03ad, 0x281a3505, 0x033f0608,   // lg.rw.sq_432 nl.af.rw_643  zu.tl.sw_333 de.af.nl_443
  0x55002819, 0x25001b19, 0x09001702, 0x1a0a280d,   // sw.rw.un_750 tr.eu.un_750  sr.pl.un_220 sw.pt.tl_554
  // [09c0]
  0x31001e05, 0x25190b04, 0x6b55640d, 0x0d001c1b,   // ms.az.un_330 es.gl.eu_332  lg.rw.ceb_554 mr.ne.un_770
  0x03083fa0, 0x3b006409, 0x4a006405, 0x092a0860,   // af.no.nl_322 lg.so.un_440  lg.yo.un_330 no.mt.pl_664
  0x28005207, 0x090408a0, 0x55216407, 0x19120b0c,   // ha.sw.un_420 no.fi.pl_322  lg.jw.rw_432 es.hu.gl_543
  0x1b2a07a0, 0x06003f04, 0x07080204, 0x00000f06,   // it.mt.tr_322 af.de.un_320  da.no.it_332 lv.un.un_400
  // [09d0]
  0x18000e08, 0x1c001f05, 0x041007a0, 0x231c210c,   // is.ga.un_430 cy.id.un_330  bg.be.ru_322 jw.id.ca_543
  0x080c0307, 0x01522807, 0x040e080b, 0x4a000a0d,   // nl.sv.no_432 sw.ha.en_432  no.is.fi_542 pt.yo.un_540
  0x02292d07, 0x0d2d0611, 0x16005507, 0x31006b04,   // sk.sl.da_432 de.sk.cs_653  rw.hr.un_420 ceb.az.un_320
  0x52643bec, 0x35072555, 0x1c0913a7, 0x0d00090c,   // so.lg.ha_644 eu.it.zu_442  bh.hi.mr_532 hi.ne.un_530
  // [09e0]
  0x2b1a01a0, 0x1f6b200d, 0x02033fa0, 0x6b6e2bad,   // en.tl.vi_322 sq.ceb.cy_554  af.nl.da_322 vi.hmn.ceb_643
  0x0d000919, 0x3b001905, 0x55002811, 0x2835550e,   // hi.ne.un_750 gl.so.un_330  sw.rw.un_630 rw.zu.sw_555
  0x3f122da0, 0x0e000607, 0x110408a4, 0x20210fa0,   // sk.hu.af_322 de.is.un_420  uk.ru.ro_433 lv.jw.sq_322
  0x2000210d, 0x3200280c, 0x0c000804, 0x4a002819,   // jw.sq.un_540 sw.bs.un_530  no.sv.un_320 sw.yo.un_750
  // [09f0]
  0x10552d0c, 0x0c0f3fee, 0x27005307, 0x160d2904,   // sk.rw.lt_543 af.lv.sv_422  ht.gd.un_420 sl.cs.hr_332
  0x1c033f07, 0x2a0d0908, 0x0c000412, 0x4a000613,   // af.nl.id_432 pl.cs.mt_443  fi.sv.un_640 de.yo.un_650
  0x18042709, 0x070c1307, 0x35002819, 0x026b1a55,   // gd.fi.ga_444 et.sv.it_432  sw.zu.un_750 tl.ceb.da_442
  0x1b5325ad, 0x0400070e, 0x19000a0e, 0x6e3f2b08,   // eu.ht.tr_643 bg.ru.un_550  pt.gl.un_550 vi.af.hmn_443
  // [0a00]
  0x07001008, 0x123f1007, 0x1c213fa0, 0x00002506,   // lt.it.un_430 lt.af.hu_432  af.jw.id_322 eu.un.un_400
  0x11002512, 0x20002812, 0x2d0d29a0, 0x6b2025a0,   // eu.ro.un_640 sw.sq.un_640  sl.cs.sk_322 eu.sq.ceb_322
  0x130d0913, 0x040807a0, 0x21356407, 0x10000912,   // hi.ne.bh_665 bg.uk.ru_322  lg.zu.jw_432 pl.lt.un_640
  0x04000808, 0x13041a07, 0x0800101a, 0x25122304,   // uk.ru.un_430 tl.fi.et_432  be.uk.un_760 ca.hu.eu_332
  // [0a10]
  0x0c0807ad, 0x1c000d14, 0x0500110d, 0x06003f08,   // it.no.sv_643 ne.mr.un_660  ro.fr.un_540 af.de.un_430
  0x171629a0, 0x090d13ad, 0x1b536408, 0x356452a4,   // sl.hr.sr_322 bh.ne.hi_643  lg.ht.tr_443 ha.lg.zu_433
  0x0a04170d, 0x21001602, 0x1a1b3b07, 0x060f1b07,   // sr.ru.mk_554 hr.jw.un_220  so.tr.tl_432 tr.lv.de_432
  0x023f08a0, 0x25182702, 0x311e29ac, 0x112301a4,   // no.af.da_322 gd.ga.eu_222  sl.ms.az_632 en.ca.ro_433
  // [0a20]
  0x64005521, 0x0c002904, 0x3b211f04, 0x080c0204,   // rw.lg.un_860 sl.sv.un_320  cy.jw.so_332 da.sv.no_332
  0x032911a0, 0x1e1c21a0, 0x6b0431ee, 0x55646ba4,   // ro.sl.nl_322 jw.id.ms_322  az.fi.ceb_422 ceb.lg.rw_433
  0x2100120b, 0x280652a0, 0x0d000912, 0x04000712,   // ur.fa.un_520 ha.de.sw_322  hi.ne.un_640 bg.ru.un_640
  0x0c00270d, 0x4a005212, 0x53641ea0, 0x00000215,   // gd.sv.un_540 ha.yo.un_640  ms.lg.ht_322 da.un.un_700
  // [0a30]
  0x130d0914, 0x28001e05, 0x4a1f5555, 0x162d6bee,   // hi.ne.bh_666 ms.sw.un_330  rw.cy.yo_442 ceb.sk.hr_422
  0x04071004, 0x13040c11, 0x21002808, 0x1b1007ee,   // be.bg.ru_332 sv.fi.et_653  sw.jw.un_430 it.lt.tr_422
  0x2d321604, 0x08003504, 0x252135a4, 0x0f002913,   // hr.bs.sk_332 zu.no.un_320  zu.jw.eu_433 sl.lv.un_650
  0x35002a08, 0x641e2104, 0x10033f07, 0x32160d0c,   // mt.zu.un_430 jw.ms.lg_332  af.nl.lt_432 cs.hr.bs_543
  // [0a40]
  0x3100010c, 0x1c0913ec, 0x4a003202, 0x00003503,   // en.az.un_530 bh.hi.mr_644  bs.yo.un_220 zu.un.un_300
  0x6b2a5504, 0x12005205, 0x35531ba4, 0x04081004,   // rw.mt.ceb_332 ha.hu.un_330  tr.ht.zu_433 be.uk.ru_332
  0x1f000c13, 0x25190b02, 0x31645504, 0x05013bee,   // sv.cy.un_650 es.gl.eu_222  rw.lg.az_332 so.en.fr_422
  0x351355ec, 0x0c6408a4, 0x081c2104, 0x20682907,   // rw.et.zu_644 no.lg.sv_433  jw.id.no_332 sl.ig.sq_432
  // [0a50]
  0x32161214, 0x25211aa4, 0x0c002812, 0x00001301,   // hu.hr.bs_666 tl.jw.eu_433  sw.sv.un_640 bh.un.un_200
  0x120408a0, 0x1716290c, 0x52645508, 0x12130112,   // no.fi.hu_322 sl.hr.sr_543  rw.lg.ha_443 en.et.hu_654
  0x050b19ee, 0x643b550c, 0x1716130c, 0x08122007,   // gl.es.fr_422 rw.so.lg_543  et.hr.sr_543 sq.hu.no_432
  0x53001a02, 0x230b19ee, 0x201153a4, 0x0f001702,   // tl.ht.un_220 gl.es.ca_422  ht.ro.sq_433 sr.lv.un_220
  // [0a60]
  0x0e001904, 0x040a17a4, 0x2710250c, 0x0c033f07,   // gl.is.un_320 sr.mk.ru_433  eu.lt.gd_543 af.nl.sv_432
  0x08062304, 0x1c4a5507, 0x31071baf, 0x01060ca0,   // ca.de.no_332 rw.yo.id_432  tr.it.az_655 sv.de.en_322
  0x08091f04, 0x23000804, 0x03100107, 0x2d0d16a0,   // cy.pl.no_332 no.ca.un_320  en.lt.nl_432 hr.cs.sk_322
  0x13000a07, 0x311f3507, 0x0a0711ee, 0x0c08030b,   // pt.et.un_420 zu.cy.az_432  ro.bg.mk_422 nl.no.sv_542
  // [0a70]
  0x173112a4, 0x64352808, 0x350453a4, 0x1b0e1f07,   // hu.az.sr_433 sw.zu.lg_443  ht.fi.zu_433 cy.is.tr_432
  0x0e001814, 0x170710a0, 0x4a3f03ee, 0x25005202,   // ga.is.un_660 be.bg.sr_322  nl.af.yo_422 ha.eu.un_220
  0x31051104, 0x682a1bee, 0x251f0107, 0x0c0608a0,   // ro.fr.az_332 tr.mt.ig_422  en.cy.eu_432 no.de.sv_322
  0x181c1fee, 0x2d001213, 0x32171655, 0x6400680d,   // cy.id.ga_422 hu.sk.un_650  hr.sr.bs_442 ig.lg.un_540
  // [0a80]
  0x2d0d4a09, 0x211e1c09, 0x09001c18, 0x29000e0d,   // yo.cs.sk_444 id.ms.jw_444  mr.hi.un_740 is.sl.un_540
  0x4a2d0d0d, 0x21001a04, 0x121b2004, 0x2a002804,   // cs.sk.yo_554 tl.jw.un_320  sq.tr.hu_332 sw.mt.un_320
  0x31001b07, 0x3b006b07, 0x3b2b6b07, 0x2d1721ad,   // tr.az.un_420 ceb.so.un_420  ceb.vi.so_432 jw.sr.sk_643
  0x0828350d, 0x04001002, 0x050711ee, 0x1b313fa0,   // zu.sw.no_554 be.ru.un_220  ro.it.fr_422 af.az.tr_322
  // [0a90]
  0x0f000707, 0x1c3521a4, 0x0a0817a4, 0x04000a05,   // it.lv.un_420 jw.zu.id_433  sr.uk.mk_433 mk.ru.un_330
  0x211c1e07, 0x2a001c02, 0x23005313, 0x525535a0,   // ms.id.jw_432 id.mt.un_220  ht.ca.un_650 zu.rw.ha_322
  0x10000f13, 0x321708ee, 0x28000807, 0x350705af,   // lv.lt.un_650 no.sr.bs_422  no.sw.un_420 fr.it.zu_655
  0x121b1ca7, 0x041708ec, 0x07041007, 0x321c16a0,   // id.tr.hu_532 uk.sr.ru_644  be.ru.bg_432 hr.id.bs_322
  // [0aa0]
  0x55643508, 0x0d00090e, 0x212964a0, 0x28354a12,   // zu.lg.rw_443 hi.ne.un_550  lg.sl.jw_322 yo.zu.sw_654
  0x040a1711, 0x0a000708, 0x2d290d0e, 0x050820ee,   // sr.mk.ru_653 bg.mk.un_430  cs.sl.sk_555 sq.no.fr_422
  0x0a0c0107, 0x130d09af, 0x00003f0f, 0x07170a13,   // en.sv.pt_432 hi.ne.bh_655  af.un.un_600 mk.sr.bg_665
  0x083f2302, 0x00001f24, 0x0b00011a, 0x1b002119,   // ca.af.no_222 cy.un.un_900  en.es.un_760 jw.tr.un_750
  // [0ab0]
  0x04120cee, 0x0c0204af, 0x06032702, 0x0d4a3202,   // sv.hu.fi_422 fi.da.sv_655  gd.nl.de_222 bs.yo.cs_222
  0x522105ee, 0x0000181c, 0x291c21ee, 0x32001208,   // fr.jw.ha_422 ar.un.un_800  jw.id.sl_422 hu.bs.un_430
  0x2a000708, 0x3b10290c, 0x190b0a0e, 0x1c000304,   // it.mt.un_430 sl.lt.so_543  pt.es.gl_555 nl.id.un_320
  0x55641aa4, 0x3b0607ad, 0x2d1b310c, 0x64000713,   // tl.lg.rw_433 it.de.so_643  az.tr.sk_543 it.lg.un_650
  // [0ac0]
  0x28211e02, 0x2d001223, 0x04100805, 0x12004a09,   // ms.jw.sw_222 hu.sk.un_880  uk.be.ru_333 yo.hu.un_440
  0x29311ba7, 0x0823250c, 0x08070ba0, 0x1b310c12,   // tr.az.sl_532 eu.ca.no_543  es.it.no_322 sv.az.tr_654
  0x09000b05, 0x230729a0, 0x08000212, 0x071704a4,   // es.pl.un_330 sl.it.ca_322  da.no.un_640 ru.sr.bg_433
  0x53352811, 0x033f3b12, 0x13100c0d, 0x0d1c1304,   // sw.zu.ht_653 so.af.nl_654  sv.lt.et_554 bh.mr.ne_332
  // [0ad0]
  0x253f06ec, 0x2d1b13ac, 0x06020cee, 0x091c13ad,   // de.af.eu_644 et.tr.sk_632  sv.da.de_422 bh.mr.hi_643
  0x070410a0, 0x64003b1a, 0x111709ac, 0x170a04a4,   // be.ru.bg_322 so.lg.un_760  pl.sr.ro_632 ru.mk.sr_433
  0x640306a4, 0x17163214, 0x210105a7, 0x290c1308,   // de.nl.lg_433 bs.hr.sr_666  fr.en.jw_532 et.sv.sl_443
  0x04070808, 0x2a1107ee, 0x3f1f0107, 0x0e2d0d5a,   // uk.bg.ru_443 it.ro.mt_422  en.cy.af_432 cs.sk.is_553
  // [0ae0]
  0x131827ec, 0x20103205, 0x0a1711af, 0x060c0107,   // gd.ga.et_644 bs.lt.sq_333  ro.sr.mk_655 en.sv.de_432
  0x03003204, 0x1800210e, 0x0b0a1905, 0x08020da0,   // bs.nl.un_320 fa.ar.un_550  gl.pt.es_333 cs.da.no_322
  0x31000c12, 0x1f000d13, 0x1f3528ee, 0x041364a0,   // sv.az.un_640 cs.cy.un_650  sw.zu.cy_422 lg.et.fi_322
  0x3f130c02, 0x5300050d, 0x040a1004, 0x3f050607,   // sv.et.af_222 fr.ht.un_540  be.mk.ru_332 de.fr.af_432
  // [0af0]
  0x532931a0, 0x10000f08, 0x25001c02, 0x27001f04,   // az.sl.ht_322 lv.lt.un_430  id.eu.un_220 cy.gd.un_320
  0x1b00060d, 0x07000a0e, 0x643528ad, 0x13001c08,   // de.tr.un_540 mk.bg.un_550  sw.zu.lg_643 mr.bh.un_430
  0x64004a04, 0x080e2107, 0x1c090dec, 0x523528ec,   // yo.lg.un_320 jw.is.no_432  ne.hi.mr_644 sw.zu.ha_644
  0x136455a0, 0x0d091cee, 0x070a10a4, 0x122d0eec,   // rw.lg.et_322 mr.hi.ne_422  be.mk.bg_433 is.sk.hu_644
  // [0b00]
  0x12001a02, 0x00006424, 0x53001c05, 0x641c02a0,   // tl.hu.un_220 lg.un.un_900  id.ht.un_330 da.id.lg_322
  0x291e1c04, 0x030e2007, 0x353153ad, 0x080209a4,   // id.ms.sl_332 sq.is.nl_432  ht.az.zu_643 pl.da.no_433
  0x16020807, 0x2d0d01ec, 0x12002304, 0x4a6b64a0,   // no.da.hr_432 en.cs.sk_644  ca.hu.un_320 lg.ceb.yo_322
  0x00005506, 0x1a6b2107, 0x23002814, 0x2b001c02,   // rw.un.un_400 jw.ceb.tl_432  sw.ca.un_660 id.vi.un_220
  // [0b10]
  0x1e1c2109, 0x3f0e0807, 0x0d010504, 0x02003f08,   // jw.id.ms_444 no.is.af_432  fr.en.cs_332 af.da.un_430
  0x21024aad, 0x07000a02, 0x53004a04, 0x10321704,   // yo.da.jw_643 mk.bg.un_220  yo.ht.un_320 sr.bs.lt_332
  0x0a033f60, 0x2d0d1214, 0x13060c02, 0x1c6b2107,   // af.nl.pt_664 hu.cs.sk_666  sv.de.et_222 jw.ceb.id_432
  0x1b080260, 0x29172d05, 0x0a1708a0, 0x0a002d10,   // da.no.tr_664 sk.sr.sl_333  uk.sr.mk_322 sk.pt.un_620
  // [0b20]
  0x3b002a0e, 0x31001105, 0x10002104, 0x16002d08,   // mt.so.un_550 ro.az.un_330  jw.lt.un_320 sk.hr.un_430
  0x080411a9, 0x162d2907, 0x64002502, 0x0d1c09ad,   // ro.ru.uk_544 sl.sk.hr_432  eu.lg.un_220 hi.mr.ne_643
  0x080201a0, 0x681e1c0d, 0x323b2d07, 0x211e1c60,   // en.da.no_322 id.ms.ig_554  sk.so.bs_432 id.ms.jw_664
  0x07033bee, 0x07000805, 0x1600290d, 0x13000c12,   // so.nl.it_422 uk.bg.un_330  sl.hr.un_540 sv.et.un_640
  // [0b30]
  0x0d002905, 0x07080a12, 0x643b27ee, 0x3b005204,   // sl.cs.un_330 mk.uk.bg_654  gd.so.lg_422 ha.so.un_320
  0x09001902, 0x27093b08, 0x5352280c, 0x6b213b04,   // gl.pl.un_220 so.pl.gd_443  sw.ha.ht_543 so.jw.ceb_332
  0x191368a7, 0x1c00210c, 0x2100230c, 0x52353105,   // ig.et.gl_532 jw.id.un_530  ca.jw.un_530 az.zu.ha_333
  0x07002308, 0x17070aa7, 0x3b004a05, 0x1c2128a9,   // ca.it.un_430 mk.bg.sr_532  yo.so.un_330 sw.jw.id_544
  // [0b40]
  0x1c000d02, 0x1200060b, 0x13091c60, 0x121b1fee,   // ne.mr.un_220 de.hu.un_520  mr.hi.bh_664 cy.tr.hu_422
  0x53003b0d, 0x06001f02, 0x2d0d09a4, 0x02000c0e,   // so.ht.un_540 cy.de.un_220  pl.cs.sk_433 sv.da.un_550
  0x0e08020e, 0x11100fee, 0x311b3b0d, 0x08020302,   // da.no.is_555 lv.lt.ro_422  so.tr.az_554 nl.da.no_222
  0x355528ec, 0x080a1104, 0x05193bee, 0x073511ee,   // sw.rw.zu_644 ro.mk.uk_332  so.gl.fr_422 ro.zu.it_422
  // [0b50]
  0x061f1305, 0x110a28ee, 0x0b000a0e, 0x321629af,   // et.cy.de_333 sw.pt.ro_422  pt.es.un_550 sl.hr.bs_655
  0x2b001a12, 0x3f0803a0, 0x053f0307, 0x0800020c,   // tl.vi.un_640 nl.no.af_322  nl.af.fr_432 da.no.un_530
  0x55535213, 0x0e124aa4, 0x6b211a09, 0x0d001308,   // ha.ht.rw_665 yo.hu.is_433  tl.jw.ceb_444 bh.ne.un_430
  0x251b6ba7, 0x311b5511, 0x1a006b1b, 0x2b005304,   // ceb.tr.eu_532 rw.tr.az_653  ceb.tl.un_770 ht.vi.un_320
  // [0b60]
  0x17293f12, 0x4a190b05, 0x04001213, 0x18002502,   // af.sl.sr_654 es.gl.yo_333  hu.fi.un_650 eu.ga.un_220
  0x3f050305, 0x1700081a, 0x082801ee, 0x00001103,   // nl.fr.af_333 uk.sr.un_760  en.sw.no_422 ro.un.un_300
  0x0c0e0804, 0x28272307, 0x1b051fa0, 0x10000914,   // no.is.sv_332 ca.gd.sw_432  cy.fr.tr_322 pl.lt.un_660
  0x06000302, 0x290d2da4, 0x20003f13, 0x0e290855,   // nl.de.un_220 sk.cs.sl_433  af.sq.un_650 no.sl.is_442
  // [0b70]
  0x0f002302, 0x02123f0c, 0x13091c0c, 0x0d000c08,   // ca.lv.un_220 af.hu.da_543  mr.hi.bh_543 sv.cs.un_430
  0x2d190d09, 0x1c0e25a6, 0x091710ad, 0x03083f04,   // cs.gl.sk_444 eu.is.id_521  lt.sr.pl_643 af.no.nl_332
  0x29002504, 0x130e0607, 0x17111007, 0x27001e02,   // eu.sl.un_320 de.is.et_432  lt.ro.sr_432 ms.gd.un_220
  0x683b11ee, 0x1f0c0e07, 0x35003207, 0x12000212,   // ro.so.ig_422 is.sv.cy_432  bs.zu.un_420 da.hu.un_640
  // [0b80]
  0x3f030808, 0x32002d08, 0x070a10a0, 0x3f000308,   // no.nl.af_443 sk.bs.un_430  be.mk.bg_322 nl.af.un_430
  0x1f002707, 0x10041307, 0x060e0ca0, 0x3b006413,   // gd.cy.un_420 et.fi.lt_432  sv.is.de_322 lg.so.un_650
  0x0b00270c, 0x35645208, 0x01004a02, 0x12190b5a,   // gd.es.un_530 ha.lg.zu_443  yo.en.un_220 es.gl.hu_553
  0x20000c05, 0x531f05ad, 0x0f001013, 0x0d2d3f0d,   // sv.sq.un_330 fr.cy.ht_643  lt.lv.un_650 af.sk.cs_554
  // [0b90]
  0x3b00640e, 0x2100280c, 0x0a071105, 0x17000108,   // lg.so.un_550 sw.jw.un_530  ro.bg.mk_333 en.sr.un_430
  0x5300060d, 0x0000091c, 0x522164ad, 0x162d09a4,   // de.ht.un_540 pl.un.un_800  lg.jw.ha_643 pl.sk.hr_433
  0x0100230b, 0x6b1f01ee, 0x0f000305, 0x31005313,   // ca.en.un_520 en.cy.ceb_422  nl.lv.un_330 ht.az.un_650
  0x063f0309, 0x040f1bad, 0x4a121804, 0x170410a9,   // nl.af.de_444 tr.lv.fi_643  ga.hu.yo_332 be.ru.sr_544
  // [0ba0]
  0x0d000905, 0x201308ec, 0x19230a07, 0x1c130955,   // hi.ne.un_330 no.et.sq_644  pt.ca.gl_432 hi.bh.mr_442
  0x32171614, 0x3f082707, 0x3b5231a4, 0x1a080b04,   // hr.sr.bs_666 gd.no.af_432  az.ha.so_433 es.no.tl_332
  0x3b321604, 0x351f5304, 0x181101a7, 0x1b3b350b,   // hr.bs.so_332 ht.cy.zu_332  en.ro.ga_532 zu.so.tr_542
  0x20002a12, 0x0c001107, 0x1a006b14, 0x182b53a0,   // mt.sq.un_640 ro.sv.un_420  ceb.tl.un_660 ht.vi.ga_322
  // [0bb0]
  0x643255ee, 0x5500641b, 0x063f0312, 0x68552507,   // rw.bs.lg_422 lg.rw.un_770  nl.af.de_654 eu.rw.ig_432
  0x04023f0c, 0x31003b0c, 0x063f030c, 0x200c2d07,   // af.da.fi_543 so.az.un_530  nl.af.de_543 sk.sv.sq_432
  0x06004a08, 0x026b55ad, 0x033f06ad, 0x100408a4,   // yo.de.un_430 rw.ceb.da_643  de.af.nl_643 uk.ru.be_433
  0x55003523, 0x112a2305, 0x64003b12, 0x0a071702,   // zu.rw.un_880 ca.mt.ro_333  so.lg.un_640 sr.bg.mk_222
  // [0bc0]
  0x1a313ba9, 0x20002807, 0x01521107, 0x071028a0,   // so.az.tl_544 sw.sq.un_420  ro.ha.en_432 sw.lt.it_322
  0x01040907, 0x0d001312, 0x2b001805, 0x09001f19,   // pl.fi.en_432 bh.ne.un_640  ga.vi.un_330 cy.pl.un_750
  0x06034aee, 0x23190a09, 0x09001f08, 0x04001713,   // yo.nl.de_422 pt.gl.ca_444  cy.pl.un_430 sr.ru.un_650
  0x27033f04, 0x0800110c, 0x0a171002, 0x0e00080c,   // af.nl.gd_332 ro.uk.un_530  be.sr.mk_222 no.is.un_530
  // [0bd0]
  0x12002122, 0x6800520b, 0x07170aa4, 0x0f1804a4,   // fa.ur.un_870 ha.ig.un_520  mk.sr.bg_433 fi.ga.lv_433
  0x3500641b, 0x01002507, 0x0a000805, 0x3f040507,   // lg.zu.un_770 eu.en.un_420  uk.mk.un_330 fr.fi.af_432
  0x13005204, 0x1c091311, 0x190b21a0, 0x17000808,   // ha.et.un_320 bh.hi.mr_653  jw.es.gl_322 uk.sr.un_430
  0x203525ad, 0x0c001112, 0x1c090daf, 0x21033f07,   // eu.zu.sq_643 ro.sv.un_640  ne.hi.mr_655 af.nl.jw_432
  // [0be0]
  0x17070a02, 0x3f112dee, 0x32162905, 0x0e190b02,   // mk.bg.sr_222 sk.ro.af_422  sl.hr.bs_333 es.gl.is_222
  0x040a08a7, 0x0d2d0912, 0x03090ba0, 0x190b1312,   // uk.mk.ru_532 pl.sk.cs_654  es.pl.nl_322 et.es.gl_654
  0x09290fa0, 0x3b2152a4, 0x32000607, 0x0a040708,   // lv.sl.pl_322 ha.jw.so_433  de.bs.un_420 bg.ru.mk_443
  0x03002104, 0x091c0d08, 0x00003b03, 0x35005502,   // jw.nl.un_320 ne.mr.hi_443  so.un.un_300 rw.zu.un_220
  // [0bf0]
  0x130e04a7, 0x10080a02, 0x21005304, 0x6b35280d,   // fi.is.et_532 mk.uk.be_222  ht.jw.un_320 sw.zu.ceb_554
  0x55122807, 0x211a3511, 0x53001104, 0x645528ad,   // sw.hu.rw_432 zu.tl.jw_653  ro.ht.un_320 sw.rw.lg_643
  0x06122355, 0x53000512, 0x6b4a1a60, 0x3b003112,   // ca.hu.de_442 fr.ht.un_640  tl.yo.ceb_664 az.so.un_640
  0x13000704, 0x0c082904, 0x310904a4, 0x0a0407af,   // it.et.un_320 sl.no.sv_332  fi.pl.az_433 bg.ru.mk_655

  // [0c00]
  0x02002104, 0x042010a4, 0x0912060c, 0x6b1f3f04,   // jw.da.un_320 lt.sq.fi_433  de.hu.pl_543 af.cy.ceb_332
  0x13000e08, 0x100f1a05, 0x3b351f12, 0x17081012,   // is.et.un_430 tl.lv.lt_333  cy.zu.so_654 be.uk.sr_654
  0x1e3b31a9, 0x211f5207, 0x1b002a08, 0x0b0a19ee,   // az.so.ms_544 ha.cy.jw_432  mt.tr.un_430 gl.pt.es_422
  0x090d1104, 0x0a041713, 0x11102daf, 0x5500520e,   // ro.cs.pl_332 sr.ru.mk_665  sk.lt.ro_655 ha.rw.un_550
  // [0c10]
  0x11000413, 0x0e002b12, 0x2b001c04, 0x0d091307,   // ru.ro.un_650 vi.is.un_640  id.vi.un_320 bh.hi.ne_432
  0x04170702, 0x20321604, 0x171613a4, 0x16100f05,   // bg.sr.ru_222 hr.bs.sq_332  et.hr.sr_433 lv.lt.hr_333
  0x0e0c0811, 0x0f002907, 0x16292007, 0x28251e07,   // no.sv.is_653 sl.lv.un_420  sq.sl.hr_432 ms.eu.sw_432
  0x00003f06, 0x0d3528a0, 0x00000a03, 0x09006412,   // af.un.un_400 sw.zu.cs_322  pt.un.un_300 lg.pl.un_640
  // [0c20]
  0x12001f07, 0x1f103555, 0x2d2911ee, 0x093f2104,   // cy.hu.un_420 zu.lt.cy_442  ro.sl.sk_422 jw.af.pl_332
  0x23001812, 0x3b3f35a7, 0x0400030e, 0x231b5507,   // ga.ca.un_640 zu.af.so_532  nl.fi.un_550 rw.tr.ca_432
  0x04005304, 0x13250707, 0x35642804, 0x31001b22,   // ht.fi.un_320 it.eu.et_432  sw.lg.zu_332 tr.az.un_870
  0x1f001e05, 0x522a28a4, 0x1e53050c, 0x1f001b14,   // ms.cy.un_330 sw.mt.ha_433  fr.ht.ms_543 tr.cy.un_660
  // [0c30]
  0x21000c0d, 0x0e000c0c, 0x1e1c2505, 0x06030ca0,   // sv.jw.un_540 sv.is.un_530  eu.id.ms_333 sv.nl.de_322
  0x163f0307, 0x17002913, 0x68211cad, 0x1f00011a,   // nl.af.hr_432 sl.sr.un_650  id.jw.ig_643 en.cy.un_760
  0x0f00251a, 0x091c130d, 0x17040713, 0x051b31ee,   // eu.lv.un_760 bh.mr.hi_554  bg.ru.sr_665 az.tr.fr_422
  0x10170a12, 0x011c13a0, 0x071101a4, 0x07006404,   // mk.sr.be_654 et.id.en_322  en.ro.it_433 lg.it.un_320
  // [0c40]
  0x031208ee, 0x1b253108, 0x53050613, 0x2a003b19,   // no.hu.nl_422 az.eu.tr_443  de.fr.ht_665 so.mt.un_750
  0x0e3f0305, 0x0a00180d, 0x094a28a0, 0x0d1c1312,   // nl.af.is_333 ga.pt.un_540  sw.yo.pl_322 bh.mr.ne_654
  0x0b000704, 0x29001607, 0x17110705, 0x3b52010b,   // it.es.un_320 hr.sl.un_420  bg.ro.sr_333 en.ha.so_542
  0x091c0da4, 0x1e1c0ea4, 0x170a0755, 0x12060c09,   // ne.mr.hi_433 is.id.ms_433  bg.mk.sr_442 sv.de.hu_444
  // [0c50]
  0x682813ec, 0x1c211f12, 0x03060c02, 0x1a3b0614,   // et.sw.ig_644 cy.jw.id_654  sv.de.nl_222 de.so.tl_666
  0x3b1325a7, 0x2800350e, 0x285564a0, 0x1a006b07,   // eu.et.so_532 zu.sw.un_550  lg.rw.sw_322 ceb.tl.un_420
  0x23002a19, 0x0a07110d, 0x29000f13, 0x0b0a23a0,   // mt.ca.un_750 ro.bg.mk_554  lv.sl.un_650 ca.pt.es_322
  0x081103ee, 0x68131b05, 0x17000f0b, 0x0c0e3f04,   // nl.ro.no_422 tr.et.ig_333  lv.sr.un_520 af.is.sv_332
  // [0c60]
  0x060713a0, 0x09130d12, 0x033f1f55, 0x12000702,   // et.it.de_322 ne.bh.hi_654  cy.af.nl_442 it.hu.un_220
  0x04000f08, 0x29000704, 0x0a00070e, 0x0d091ca4,   // lv.fi.un_430 it.sl.un_320  bg.mk.un_550 mr.hi.ne_433
  0x1f010604, 0x35001f04, 0x553521a0, 0x0a17070c,   // de.en.cy_332 cy.zu.un_320  jw.zu.rw_322 bg.sr.mk_543
  0x17000704, 0x06001f0d, 0x033f100b, 0x520c08a0,   // it.sr.un_320 cy.de.un_540  lt.af.nl_542 no.sv.ha_322
  // [0c70]
  0x01000e04, 0x3f001f14, 0x17060505, 0x100802a4,   // is.en.un_320 cy.af.un_660  fr.de.sr_333 da.no.lt_433
  0x0f082dee, 0x35006404, 0x131701a4, 0x64533f11,   // sk.no.lv_422 lg.zu.un_320  en.sr.et_433 af.ht.lg_653
  0x0a0810a0, 0x53000509, 0x21033f11, 0x21002304,   // be.uk.mk_322 fr.ht.un_440  af.nl.jw_653 ca.jw.un_320
  0x190b0aa9, 0x186e2aa9, 0x23005302, 0x6b0305ee,   // pt.es.gl_544 mt.hmn.ga_544  ht.ca.un_220 fr.nl.ceb_422
  // [0c80]
  0x0c006b07, 0x100411ec, 0x12000c09, 0x0d120e0c,   // ceb.sv.un_420 ro.ru.be_644  sv.hu.un_440 is.hu.cs_543
  0x0a071107, 0x53201ba4, 0x01000804, 0x1c000912,   // ro.bg.mk_432 tr.sq.ht_433  no.en.un_320 hi.mr.un_640
  0x18002b13, 0x321703a0, 0x00001f03, 0x11000411,   // vi.ga.un_650 nl.sr.bs_322  cy.un.un_300 fi.ro.un_630
  0x28000b04, 0x32082d07, 0x0d001b05, 0x3f00060c,   // es.sw.un_320 sk.no.bs_432  tr.cs.un_330 de.af.un_530
  // [0c90]
  0x12000104, 0x182735ee, 0x0e2d0aa9, 0x04682511,   // en.hu.un_320 zu.gd.ga_422  pt.sk.is_544 eu.ig.fi_653
  0x3f0603a4, 0x100820ee, 0x6b001a05, 0x1a134aa7,   // nl.de.af_433 sq.no.lt_422  tl.ceb.un_330 yo.et.tl_532
  0x35006812, 0x0a000108, 0x251e1c08, 0x1632175a,   // ig.zu.un_640 en.pt.un_430  id.ms.eu_443 sr.bs.hr_553
  0x111008a4, 0x11000a04, 0x060828a0, 0x202d0907,   // uk.be.ro_433 pt.ro.un_320  sw.no.de_322 pl.sk.sq_432
  // [0ca0]
  0x2d0d55a9, 0x00006e24, 0x05002312, 0x021018a0,   // rw.cs.sk_544 hmn.un.un_900  ca.fr.un_640 ga.lt.da_322
  0x2d0d090c, 0x53190a08, 0x11100804, 0x18211211,   // pl.cs.sk_543 pt.gl.ht_443  no.lt.ro_332 ur.fa.ar_653
  0x2864120c, 0x091c13a0, 0x321623a0, 0x271f1812,   // hu.lg.sw_543 bh.mr.hi_322  ca.hr.bs_322 ga.cy.gd_654
  0x32311b0b, 0x00000c15, 0x25282904, 0x31003b13,   // tr.az.bs_542 sv.un.un_700  sl.sw.eu_332 so.az.un_650
  // [0cb0]
  0x17003104, 0x17321608, 0x130d1c14, 0x21002007,   // az.sr.un_320 hr.bs.sr_443  mr.ne.bh_666 sq.jw.un_420
  0x311a2712, 0x1c091309, 0x08111304, 0x041827ad,   // gd.tl.az_654 bh.hi.mr_444  et.ro.no_332 gd.ga.fi_643
  0x17006e08, 0x1300030d, 0x4a000c07, 0x210c08af,   // hmn.sr.un_430 nl.et.un_540  sv.yo.un_420 no.sv.jw_655
  0x23001f1b, 0x04001319, 0x20231108, 0x1732160b,   // cy.ca.un_770 et.fi.un_750  ro.ca.sq_443 hr.bs.sr_542
  // [0cc0]
  0x00003b06, 0x2d0d0faf, 0x05000704, 0x28001f13,   // so.un.un_400 lv.cs.sk_655  it.fr.un_320 cy.sw.un_650
  0x1f6401a4, 0x1a006b05, 0x4a120e0c, 0x210a4aa4,   // en.lg.cy_433 ceb.tl.un_330  is.hu.yo_543 yo.pt.jw_433
  0x08100aa4, 0x2d2110a6, 0x041b13a0, 0x08291204,   // mk.be.uk_433 lt.jw.sk_521  et.tr.fi_322 hu.sl.no_332
  0x00001f01, 0x0c080ea0, 0x20000e12, 0x2d0d29a4,   // cy.un.un_200 is.no.sv_322  is.sq.un_640 sl.cs.sk_433
  // [0cd0]
  0x10171105, 0x6e006b05, 0x17001219, 0x235502ee,   // ro.sr.be_333 ceb.hmn.un_330  hu.sr.un_750 da.rw.ca_422
  0x1b002108, 0x0a1a0208, 0x182820a4, 0x061e1c05,   // jw.tr.un_430 da.tl.pt_443  sq.sw.ga_433 id.ms.de_333
  0x1f032507, 0x07005308, 0x1f3f020b, 0x0c00130d,   // eu.nl.cy_432 ht.it.un_430  da.af.cy_542 et.sv.un_540
  0x06080c0c, 0x07040a02, 0x08001007, 0x12111ba0,   // sv.no.de_543 mk.ru.bg_222  be.uk.un_420 tr.ro.hu_322
  // [0ce0]
  0x0e083507, 0x211c1e0c, 0x3b0812a4, 0x01005207,   // zu.no.is_432 ms.id.jw_543  hu.no.so_433 ha.en.un_420
  0x10051f0c, 0x11001807, 0x28003b07, 0x27003b0d,   // cy.fr.lt_543 ga.ro.un_420  so.sw.un_420 so.gd.un_540
  0x6b030ead, 0x121e1c09, 0x060e01a0, 0x31002704,   // is.nl.ceb_643 id.ms.hu_444  en.is.de_322 gd.az.un_320
  0x1e0d25ee, 0x28006b07, 0x033f25a0, 0x0e0306a4,   // eu.cs.ms_422 ceb.sw.un_420  eu.af.nl_322 de.nl.is_433
  // [0cf0]
  0x07351a07, 0x2a030613, 0x1c132755, 0x12002013,   // tl.zu.it_432 de.nl.mt_665  gd.et.id_442 sq.hu.un_650
  0x013f1a07, 0x29002d13, 0x641f120c, 0x00004a2d,   // tl.af.en_432 sk.sl.un_650  hu.cy.lg_543 yo.un.un_A00
  0x05005312, 0x3f000607, 0x6b033fee, 0x06000d05,   // ht.fr.un_640 de.af.un_420  af.nl.ceb_422 cs.de.un_330
  0x19002707, 0x2d0d29a9, 0x271203ee, 0x52001f11,   // gd.gl.un_420 sl.cs.sk_544  nl.hu.gd_422 cy.ha.un_630
  // [0d00]
  0x2d0d4aa4, 0x0d00130c, 0x23001a04, 0x351125a0,   // yo.cs.sk_433 bh.ne.un_530  tl.ca.un_320 eu.ro.zu_322
  0x035207ee, 0x0e1304ac, 0x08030607, 0x0f091255,   // it.ha.nl_422 fi.et.is_632  de.nl.no_432 hu.pl.lv_442
  0x0c080a05, 0x290a01a4, 0x111b2aad, 0x1c130908,   // pt.no.sv_333 en.pt.sl_433  mt.tr.ro_643 hi.bh.mr_443
  0x556421ec, 0x64001c05, 0x08120107, 0x55353fa0,   // jw.lg.rw_644 id.lg.un_330  en.hu.no_432 af.zu.rw_322
  // [0d10]
  0x3f072aa0, 0x0d091cad, 0x55063f02, 0x03061808,   // mt.it.af_322 mr.hi.ne_643  af.de.rw_222 ga.de.nl_443
  0x35001f07, 0x10080413, 0x311b1208, 0x1c003202,   // cy.zu.un_420 ru.uk.be_665  hu.tr.az_443 bs.id.un_220
  0x0e2d0d13, 0x251035a0, 0x1f6b010c, 0x1b3b04ad,   // cs.sk.is_665 zu.lt.eu_322  en.ceb.cy_543 fi.so.tr_643
  0x1a002307, 0x0c086ba0, 0x35682a07, 0x10552511,   // ca.tl.un_420 ceb.no.sv_322  mt.ig.zu_432 eu.rw.lt_653
  // [0d20]
  0x6b1b015a, 0x023506a4, 0x132718ad, 0x130e3fa0,   // en.tr.ceb_553 de.zu.da_433  ga.gd.et_643 af.is.et_322
  0x17070408, 0x28643b08, 0x211c1b07, 0x13102807,   // ru.bg.sr_443 so.lg.sw_443  tr.id.jw_432 sw.lt.et_432
  0x64003513, 0x0e001f1a, 0x06133fa9, 0x040807af,   // zu.lg.un_650 cy.is.un_760  af.et.de_544 bg.uk.ru_655
  0x020e1f04, 0x08002a12, 0x28352112, 0x07183fa0,   // cy.is.da_332 mt.no.un_640  jw.zu.sw_654 af.ga.it_322
  // [0d30]
  0x2a271808, 0x121b3112, 0x201e31ee, 0x4a005214,   // ga.gd.mt_443 az.tr.hu_654  az.ms.sq_422 ha.yo.un_660
  0x0800230e, 0x086828a4, 0x55281a08, 0x2d0d35ee,   // ca.no.un_550 sw.ig.no_433  tl.sw.rw_443 zu.cs.sk_422
  0x092a28a7, 0x171b3f07, 0x27011207, 0x32002a12,   // sw.mt.pl_532 af.tr.sr_432  hu.en.gd_432 mt.bs.un_640
  0x200f2a02, 0x1e001c09, 0x08070a07, 0x0d002d19,   // mt.lv.sq_222 id.ms.un_440  mk.bg.uk_432 sk.cs.un_750
  // [0d40]
  0x2a00310c, 0x121629a4, 0x040a1002, 0x2a002014,   // az.mt.un_530 sl.hr.hu_433  be.mk.ru_222 sq.mt.un_660
  0x3b312a0d, 0x185323a7, 0x0e00011a, 0x063f0407,   // mt.az.so_554 ca.ht.ga_532  en.is.un_760 fi.af.de_432
  0x041918ad, 0x081711ee, 0x31003204, 0x0c00060c,   // ga.gl.fi_643 ro.sr.uk_422  bs.az.un_320 de.sv.un_530
  0x0c001c04, 0x04170a02, 0x2b1f3507, 0x0d13290c,   // id.sv.un_320 mk.sr.ru_222  zu.cy.vi_432 sl.et.cs_543
  // [0d50]
  0x52091804, 0x27003112, 0x20003204, 0x3f000304,   // ga.pl.ha_332 az.gd.un_640  bs.sq.un_320 nl.af.un_320
  0x190b12af, 0x03053fa0, 0x202931ee, 0x64072811,   // hu.es.gl_655 af.fr.nl_322  az.sl.sq_422 sw.it.lg_653
  0x351e0d12, 0x08070405, 0x2964350c, 0x0e3109ad,   // cs.ms.zu_654 ru.bg.uk_333  zu.lg.sl_543 pl.az.is_643
  0x2a0b0ea0, 0x00001b0a, 0x28002104, 0x040717a4,   // is.es.mt_322 tr.un.un_500  jw.sw.un_320 sr.bg.ru_433
  // [0d60]
  0x55003202, 0x3f0e085a, 0x0700230d, 0x2d230a0c,   // bs.rw.un_220 no.is.af_553  ca.it.un_540 pt.ca.sk_543
  0x0a190b04, 0x2d0d09a6, 0x0c032902, 0x23000412,   // es.gl.pt_332 pl.cs.sk_521  sl.nl.sv_222 fi.ca.un_640
  0x07040aee, 0x554a1007, 0x0b00010c, 0x17090dee,   // mk.ru.bg_422 lt.yo.rw_432  en.es.un_530 cs.pl.sr_422
  0x0e0205a0, 0x0000170f, 0x0000040a, 0x0b001812,   // fr.da.is_322 sr.un.un_600  ru.un.un_500 ga.es.un_640
  // [0d70]
  0x12000e09, 0x02061bee, 0x6b001a12, 0x0a0807a4,   // is.hu.un_440 tr.de.da_422  tl.ceb.un_640 bg.uk.mk_433
  0x0e00530e, 0x1c13090e, 0x2d00180d, 0x03001313,   // ht.is.un_550 hi.bh.mr_555  ga.sk.un_540 et.nl.un_650
  0x1b062a07, 0x64002a13, 0x3500680c, 0x09000c04,   // mt.de.tr_432 mt.lg.un_650  ig.zu.un_530 sv.pl.un_320
  0x1b1e3507, 0x6b1a1fa4, 0x3f050307, 0x290c06ad,   // zu.ms.tr_432 cy.tl.ceb_433  nl.fr.af_432 de.sv.sl_643
  // [0d80]
  0x53001c02, 0x0500011a, 0x0700110c, 0x4a1a6ba0,   // id.ht.un_220 en.fr.un_760  ro.bg.un_530 ceb.tl.yo_322
  0x556428af, 0x0c002508, 0x25190b13, 0x1a006b0e,   // sw.lg.rw_655 eu.sv.un_430  es.gl.eu_665 ceb.tl.un_550
  0x1c000d1a, 0x05680107, 0x1b006b07, 0x35001014,   // ne.mr.un_760 en.ig.fr_432  ceb.tr.un_420 lt.zu.un_660
  0x010c18ee, 0x01003b07, 0x21041809, 0x53000707,   // ga.sv.en_422 so.en.un_420  ga.fi.jw_444 it.ht.un_420
  // [0d90]
  0x01001f13, 0x64325508, 0x050a23a9, 0x183527af,   // cy.en.un_650 rw.bs.lg_443  ca.pt.fr_544 gd.zu.ga_655
  0x10001107, 0x16000f07, 0x06351807, 0x0d2011ee,   // ro.be.un_420 lv.hr.un_420  ga.zu.de_432 ro.sq.cs_422
  0x0d1c0960, 0x08170a02, 0x07000a19, 0x04122807,   // hi.mr.ne_664 mk.sr.uk_222  mk.bg.un_750 sw.hu.fi_432
  0x2a525304, 0x4a172905, 0x2a072007, 0x19000707,   // ht.ha.mt_332 sl.sr.yo_333  sq.it.mt_432 it.gl.un_420
  // [0da0]
  0x351e10a0, 0x1a001e04, 0x52006b04, 0x102d110e,   // lt.ms.zu_322 ms.tl.un_320  ceb.ha.un_320 ro.sk.lt_555
  0x17000413, 0x2a1125a4, 0x280413a4, 0x27002819,   // ru.sr.un_650 eu.ro.mt_433  et.fi.sw_433 sw.gd.un_750
  0x0b0a19a0, 0x090d130c, 0x292028a7, 0x3f000408,   // gl.pt.es_322 bh.ne.hi_543  sw.sq.sl_532 fi.af.un_430
  0x25003113, 0x13000d0c, 0x19001804, 0x090d1307,   // az.eu.un_650 ne.bh.un_530  ga.gl.un_320 bh.ne.hi_432
  // [0db0]
  0x0d2d290b, 0x3b311aee, 0x20000104, 0x18001219,   // sl.sk.cs_542 tl.az.so_422  en.sq.un_320 ur.ar.un_750
  0x0d091c11, 0x3b1b1a07, 0x2d2928a4, 0x01001a04,   // mr.hi.ne_653 tl.tr.so_432  sw.sl.sk_433 tl.en.un_320
  0x0425280d, 0x116807ad, 0x281f6407, 0x21193502,   // sw.eu.fi_554 it.ig.ro_643  lg.cy.sw_432 zu.gl.jw_222
  0x04006b08, 0x192d0b07, 0x10531ba4, 0x2700252b,   // ceb.fi.un_430 es.sk.gl_432  tr.ht.lt_433 eu.gd.un_980
  // [0dc0]
  0x27001822, 0x12001904, 0x52001e07, 0x190b550b,   // ga.gd.un_870 gl.hu.un_320  ms.ha.un_420 rw.es.gl_542
  0x3f6428ee, 0x18071107, 0x351b31af, 0x31004a0c,   // sw.lg.af_422 ro.it.ga_432  az.tr.zu_655 yo.az.un_530
  0x012b1b04, 0x0f002504, 0x11001902, 0x531a6b5a,   // tr.vi.en_332 eu.lv.un_320  gl.ro.un_220 ceb.tl.ht_553
  0x060413a0, 0x130853ec, 0x536b1a55, 0x06001c02,   // et.fi.de_322 ht.no.et_644  tl.ceb.ht_442 id.de.un_220
  // [0dd0]
  0x2d0d0aec, 0x0704170d, 0x06001319, 0x080e06af,   // pt.cs.sk_644 sr.ru.bg_554  et.de.un_750 de.is.no_655
  0x28001b13, 0x320428ad, 0x0b2327a0, 0x27001902,   // tr.sw.un_650 sw.fi.bs_643  gd.ca.es_322 gl.gd.un_220
  0x29000d08, 0x530527a0, 0x1b2331ad, 0x23000b07,   // cs.sl.un_430 gd.fr.ht_322  az.ca.tr_643 es.ca.un_420
  0x09000d20, 0x356425ee, 0x2d0d3b08, 0x17162907,   // ne.hi.un_850 eu.lg.zu_422  so.cs.sk_443 sl.hr.sr_432
  // [0de0]
  0x21000504, 0x07100804, 0x120d2dec, 0x0c0413ec,   // fr.jw.un_320 uk.be.bg_332  sk.cs.hu_644 et.fi.sv_644
  0x6b000b07, 0x00005324, 0x0f006b04, 0x07080413,   // es.ceb.un_420 ht.un.un_900  ceb.lv.un_320 ru.uk.bg_665
  0x6800281a, 0x091b12a7, 0x04006e0b, 0x171632a9,   // sw.ig.un_760 hu.tr.pl_532  hmn.fi.un_520 bs.hr.sr_544
  0x21001220, 0x3b000108, 0x05000104, 0x21005302,   // ur.fa.un_850 en.so.un_430  en.fr.un_320 ht.jw.un_220
  // [0df0]
  0x32092904, 0x0d1c13ee, 0x3b2a07ad, 0x0c3f03ee,   // sl.pl.bs_332 bh.mr.ne_422  it.mt.so_643 nl.af.sv_422
  0x04071711, 0x07040aa9, 0x17000707, 0x35002808,   // sr.bg.ru_653 mk.ru.bg_544  bg.sr.un_420 sw.zu.un_430
  0x09112504, 0x170d29a0, 0x0408100d, 0x1e006e08,   // eu.ro.pl_332 sl.cs.sr_322  be.uk.ru_554 hmn.ms.un_430
  0x283555a6, 0x201304ee, 0x2b001702, 0x554a6408,   // rw.zu.sw_521 fi.et.sq_422  sr.vi.un_220 lg.yo.rw_443
  // [0e00]
  0x17292d55, 0x16001704, 0x211a3bee, 0x3f002102,   // sk.sl.sr_442 sr.hr.un_320  so.tl.jw_422 jw.af.un_220
  0x0e0208ec, 0x31005508, 0x190b0aee, 0x23000a0e,   // no.da.is_644 rw.az.un_430  pt.es.gl_422 pt.ca.un_550
  0x211a3b07, 0x1a004a04, 0x0e180a04, 0x0c080faf,   // so.tl.jw_432 yo.tl.un_320  pt.ga.is_332 lv.no.sv_655
  0x0b0d1907, 0x06003512, 0x64006b04, 0x01060804,   // gl.cs.es_432 zu.de.un_640  ceb.lg.un_320 no.de.en_332
  // [0e10]
  0x2d000b02, 0x4a2d0d08, 0x07001004, 0x55001602,   // es.sk.un_220 cs.sk.yo_443  be.bg.un_320 hr.rw.un_220
  0x0000112d, 0x046b2804, 0x25045307, 0x06001f12,   // ro.un.un_A00 sw.ceb.fi_332  ht.fi.eu_432 cy.de.un_640
  0x17000207, 0x1a0f1ba4, 0x17080aa4, 0x2a003109,   // da.sr.un_420 tr.lv.tl_433  mk.uk.sr_433 az.mt.un_440
  0x0b0a1902, 0x10000702, 0x12003202, 0x12000808,   // gl.pt.es_222 bg.be.un_220  bs.hu.un_220 no.hu.un_430
  // [0e20]
  0x12000a08, 0x05003502, 0x1300060c, 0x163528a7,   // pt.hu.un_430 zu.fr.un_220  de.et.un_530 sw.zu.hr_532
  0x284a2a12, 0x0100060d, 0x180e23a7, 0x04000704,   // mt.yo.sw_654 de.en.un_540  ca.is.ga_532 it.fi.un_320
  0x282a52ee, 0x2d5212a4, 0x35006807, 0x09310e04,   // ha.mt.sw_422 hu.ha.sk_433  ig.zu.un_420 is.az.pl_332
  0x041a13a4, 0x05004a04, 0x04003202, 0x083b0e07,   // et.tl.fi_433 yo.fr.un_320  bs.fi.un_220 is.so.no_432
  // [0e30]
  0x080c09a7, 0x0a171007, 0x01000612, 0x29211313,   // pl.sv.no_532 be.sr.mk_432  de.en.un_640 et.jw.sl_665
  0x12000e12, 0x1c1309af, 0x21080204, 0x17071104,   // is.hu.un_640 hi.bh.mr_655  da.no.jw_332 ro.bg.sr_332
  0x04003b12, 0x00003101, 0x1f0e18a6, 0x0000251c,   // so.fi.un_640 az.un.un_200  ga.is.cy_521 eu.un.un_800
  0x2a3f0ea4, 0x0f001707, 0x100a0708, 0x030e08a4,   // is.af.mt_433 sr.lv.un_420  bg.mk.be_443 no.is.nl_433
  // [0e40]
  0x09006b08, 0x21000513, 0x28295508, 0x0e2821a6,   // ceb.pl.un_430 fr.jw.un_650  rw.sl.sw_443 jw.sw.is_521
  0x3f001111, 0x121a0f07, 0x0b4a05af, 0x3f033baf,   // ro.af.un_630 lv.tl.hu_432  fr.yo.es_655 so.nl.af_655
  0x04081760, 0x103568ad, 0x1b522508, 0x0e031aee,   // sr.uk.ru_664 ig.zu.lt_643  eu.ha.tr_443 tl.nl.is_422
  0x2b0b23a0, 0x12182daf, 0x00001324, 0x100704af,   // ca.es.vi_322 sk.ga.hu_655  bh.un.un_900 ru.bg.be_655
  // [0e50]
  0x1c211304, 0x21000519, 0x12001112, 0x120a2304,   // et.jw.id_332 fr.jw.un_750  ro.hu.un_640 ca.pt.hu_332
  0x2a000713, 0x556b1aa0, 0x20001b14, 0x526b6808,   // it.mt.un_650 tl.ceb.rw_322  tr.sq.un_660 ig.ceb.ha_443
  0x2d001f19, 0x202a11a9, 0x13001a08, 0x291e080c,   // cy.sk.un_750 ro.mt.sq_544  tl.et.un_430 no.ms.sl_543
  0x04070a55, 0x0c001219, 0x3b003f19, 0x1c0752a9,   // mk.bg.ru_442 hu.sv.un_750  af.so.un_750 ha.it.id_544
  // [0e60]
  0x29000d14, 0x2d060107, 0x2d6e29af, 0x23190704,   // cs.sl.un_660 en.de.sk_432  sl.hmn.sk_655 it.gl.ca_332
  0x04071704, 0x3b1b1604, 0x055325a4, 0x13122507,   // sr.bg.ru_332 hr.tr.so_332  eu.ht.fr_433 eu.hu.et_432
  0x29090da9, 0x190b1aee, 0x64553512, 0x030b050c,   // cs.pl.sl_544 tl.es.gl_422  zu.rw.lg_654 fr.es.nl_543
  0x05002309, 0x1e1c2aee, 0x2b28350b, 0x286b1aee,   // ca.fr.un_440 mt.id.ms_422  zu.sw.vi_542 tl.ceb.sw_422
  // [0e70]
  0x051107a0, 0x2a002704, 0x091a55a0, 0x12136ba6,   // it.ro.fr_322 gd.mt.un_320  rw.tl.pl_322 ceb.et.hu_521
  0x1c0913a6, 0x3b1a6bad, 0x06002905, 0x1e1c2855,   // bh.hi.mr_521 ceb.tl.so_643  sl.de.un_330 sw.id.ms_442
  0x1300280d, 0x1f040707, 0x1e1f1ca0, 0x251c1fee,   // sw.et.un_540 it.fi.cy_432  id.cy.ms_322 cy.id.eu_422
  0x070a100e, 0x18005304, 0x52006808, 0x093f03a9,   // be.mk.bg_555 ht.ga.un_320  ig.ha.un_430 nl.af.pl_544
  // [0e80]
  0x0e002d12, 0x17311fad, 0x4a000714, 0x29285255,   // sk.is.un_640 cy.az.sr_643  it.yo.un_660 ha.sw.sl_442
  0x29025307, 0x0312250c, 0x19001813, 0x1a006b18,   // ht.da.sl_432 eu.hu.nl_543  ga.gl.un_650 ceb.tl.un_740
  0x27001807, 0x1b063107, 0x64281902, 0x6b081302,   // ga.gd.un_420 az.de.tr_432  gl.sw.lg_222 et.no.ceb_222
  0x32002813, 0x08022a0c, 0x0d091c12, 0x13002d12,   // sw.bs.un_650 mt.da.no_543  mr.hi.ne_654 sk.et.un_640
  // [0e90]
  0x27002a02, 0x194a0b0c, 0x0f292aa0, 0x1a683b0c,   // mt.gd.un_220 es.yo.gl_543  mt.sl.lv_322 so.ig.tl_543
  0x32043baf, 0x080a1007, 0x23000108, 0x12000d13,   // so.fi.bs_655 be.mk.uk_432  en.ca.un_430 cs.hu.un_650
  0x27201f04, 0x17001c02, 0x4a002102, 0x3f040304,   // cy.sq.gd_332 id.sr.un_220  jw.yo.un_220 nl.fi.af_332
  0x4a120b09, 0x2d002912, 0x095505a7, 0x55005313,   // es.hu.yo_444 sl.sk.un_640  fr.rw.pl_532 ht.rw.un_650
  // [0ea0]
  0x10081105, 0x321016a4, 0x2d0d29ec, 0x07000104,   // ro.uk.be_333 hr.lt.bs_433  sl.cs.sk_644 en.it.un_320
  0x0c005512, 0x3b000414, 0x25001f19, 0x521e1c13,   // rw.sv.un_640 fi.so.un_660  cy.eu.un_750 id.ms.ha_665
  0x070f0a08, 0x4a190a5a, 0x05001a04, 0x0e000c0e,   // pt.lv.it_443 pt.gl.yo_553  tl.fr.un_320 sv.is.un_550
  0x12000813, 0x53002312, 0x1708020d, 0x201217a0,   // no.hu.un_650 ca.ht.un_640  da.no.sr_554 sr.hu.sq_322
  // [0eb0]
  0x1c001e13, 0x11002013, 0x080702a6, 0x101704a7,   // ms.id.un_650 sq.ro.un_650  da.it.no_521 ru.sr.be_532
  0x1c004a05, 0x0d1c0908, 0x170a070b, 0x281155ee,   // yo.id.un_330 hi.mr.ne_443  bg.mk.sr_542 rw.ro.sw_422
  0x070105ee, 0x16003207, 0x3b1055a4, 0x55002702,   // fr.en.it_422 bs.hr.un_420  rw.lt.so_433 gd.rw.un_220
  0x050f5209, 0x120e180c, 0x292d0d09, 0x06001208,   // ha.lv.fr_444 ga.is.hu_543  cs.sk.sl_444 hu.de.un_430
  // [0ec0]
  0x0d2d35ad, 0x181301a7, 0x070411ee, 0x4a35640c,   // zu.sk.cs_643 en.et.ga_532  ro.ru.bg_422 lg.zu.yo_543
  0x3f1720a4, 0x101a350c, 0x1f3f0607, 0x1b6b35a4,   // sq.sr.af_433 zu.tl.lt_543  de.af.cy_432 zu.ceb.tr_433
  0x53033f07, 0x1b552155, 0x556435a7, 0x29171608,   // af.nl.ht_432 jw.rw.tr_442  zu.lg.rw_532 hr.sr.sl_443
  0x55003512, 0x0602010c, 0x03001e05, 0x0a002807,   // zu.rw.un_640 en.da.de_543  ms.nl.un_330 sw.pt.un_420
  // [0ed0]
  0x2d050aee, 0x21001e07, 0x171629af, 0x0c111602,   // pt.fr.sk_422 ms.jw.un_420  sl.hr.sr_655 hr.ro.sv_222
  0x2a045505, 0x17292da4, 0x32121ca0, 0x1127180e,   // rw.fi.mt_333 sk.sl.sr_433  id.hu.bs_322 ga.gd.ro_555
  0x311b1212, 0x17000d07, 0x1c090da4, 0x32645207,   // hu.tr.az_654 cs.sr.un_420  ne.hi.mr_433 ha.lg.bs_432
  0x10002911, 0x0e006404, 0x0e001808, 0x53003504,   // sl.lt.un_630 lg.is.un_320  ga.is.un_430 zu.ht.un_320
  // [0ee0]
  0x2a291605, 0x130f12af, 0x35006413, 0x2d3216a0,   // hr.sl.mt_333 hu.lv.et_655  lg.zu.un_650 hr.bs.sk_322
  0x06005204, 0x1a1b5304, 0x32002912, 0x0d0913ac,   // ha.de.un_320 ht.tr.tl_332  sl.bs.un_640 bh.hi.ne_632
  0x132a0455, 0x3217160d, 0x212320ac, 0x553521af,   // fi.mt.et_442 hr.sr.bs_554  sq.ca.jw_632 jw.zu.rw_655
  0x4a68350c, 0x1300201a, 0x10001904, 0x20162955,   // zu.ig.yo_543 sq.et.un_760  gl.lt.un_320 sl.hr.sq_442
  // [0ef0]
  0x08170a5a, 0x321f1baf, 0x13250504, 0x0d09130b,   // mk.sr.uk_553 tr.cy.bs_655  fr.eu.et_332 bh.hi.ne_542
  0x0500210b, 0x3100121a, 0x18011fad, 0x1b310e0d,   // jw.fr.un_520 hu.az.un_760  cy.en.ga_643 is.az.tr_554
  0x2118125a, 0x09112804, 0x4a0155a0, 0x21001e04,   // ur.ar.fa_553 sw.ro.pl_332  rw.en.yo_322 ms.jw.un_320
  0x2105230c, 0x20005205, 0x3b2a19a0, 0x283b01a4,   // ca.fr.jw_543 ha.sq.un_330  gl.mt.so_322 en.so.sw_433
  // [0f00]
  0x100f1707, 0x08041307, 0x250f0707, 0x2b00230d,   // sr.lv.lt_432 et.fi.no_432  it.lv.eu_432 ca.vi.un_540
  0x110128ad, 0x2d1309af, 0x00003f1c, 0x046b55a0,   // sw.en.ro_643 pl.et.sk_655  af.un.un_800 rw.ceb.fi_322
  0x29001e02, 0x53006b07, 0x6400521a, 0x0a0b19a4,   // ms.sl.un_220 ceb.ht.un_420  ha.lg.un_760 gl.es.pt_433
  0x07061f07, 0x090c1f11, 0x04170805, 0x10071707,   // cy.de.it_432 cy.sv.pl_653  uk.sr.ru_333 sr.bg.be_432
  // [0f10]
  0x00000315, 0x0602520c, 0x55683512, 0x3f232904,   // nl.un.un_700 ha.da.de_543  zu.ig.rw_654 sl.ca.af_332
  0x0b0d2da9, 0x19050ba0, 0x11000302, 0x0d3b2da7,   // sk.cs.es_544 es.fr.gl_322  nl.ro.un_220 sk.so.cs_532
  0x6e000605, 0x0c030807, 0x1e1c0605, 0x23001217,   // de.hmn.un_330 no.nl.sv_432  de.id.ms_333 hu.ca.un_730
  0x550e2105, 0x18000514, 0x525528af, 0x00001803,   // jw.is.rw_333 fr.ga.un_660  sw.rw.ha_655 ga.un.un_300
  // [0f20]
  0x040811a0, 0x1f000b05, 0x170711a6, 0x193513ee,   // ro.uk.ru_322 es.cy.un_330  ro.bg.sr_521 et.zu.gl_422
  0x52004a1a, 0x0b0111ee, 0x2d1f05a0, 0x17040aaf,   // yo.ha.un_760 ro.en.es_422  fr.cy.sk_322 mk.ru.sr_655
  0x0500530e, 0x1b132508, 0x111728a4, 0x32003f04,   // ht.fr.un_550 eu.et.tr_443  sw.sr.ro_433 af.bs.un_320
  0x1e003108, 0x00001724, 0x1c0d13a4, 0x041711a0,   // az.ms.un_430 sr.un.un_900  bh.ne.mr_433 ro.sr.ru_322
  // [0f30]
  0x1c0913ee, 0x3b5564ad, 0x1c6421a0, 0x1b006405,   // bh.hi.mr_422 lg.rw.so_643  jw.lg.id_322 lg.tr.un_330
  0x523b35af, 0x1e051ca0, 0x0c0908a4, 0x0b2d0d0d,   // zu.so.ha_655 id.fr.ms_322  no.pl.sv_433 cs.sk.es_554
  0x06643509, 0x023f6b02, 0x03006b05, 0x310f1baf,   // zu.lg.de_444 ceb.af.da_222  ceb.nl.un_330 tr.lv.az_655
  0x0b000a05, 0x00005503, 0x170811a0, 0x01091fee,   // pt.es.un_330 rw.un.un_300  ro.uk.sr_322 cy.pl.en_422
  // [0f40]
  0x35002812, 0x25231fa9, 0x05000304, 0x1100050e,   // sw.zu.un_640 cy.ca.eu_544  nl.fr.un_320 fr.ro.un_550
  0x08021fec, 0x06250107, 0x1a0e2155, 0x20251260,   // cy.da.no_644 en.eu.de_432  jw.is.tl_442 hu.eu.sq_664
  0x1707040c, 0x4a132507, 0x0400071a, 0x6b6808a4,   // ru.bg.sr_543 eu.et.yo_432  bg.ru.un_760 no.ig.ceb_433
  0x11000a0c, 0x1700101a, 0x3b231355, 0x02000604,   // pt.ro.un_530 be.sr.un_760  et.ca.so_442 de.da.un_320
  // [0f50]
  0x2d005304, 0x104a25a0, 0x05182711, 0x0e311ea0,   // ht.sk.un_320 eu.yo.lt_322  gd.ga.fr_653 ms.az.is_322
  0x31001904, 0x1b005204, 0x0e0803ac, 0x35060913,   // gl.az.un_320 ha.tr.un_320  nl.no.is_632 pl.de.zu_665
  0x23000819, 0x190b07a0, 0x3b130207, 0x043f0304,   // no.ca.un_750 it.es.gl_322  da.et.so_432 nl.af.fi_332
  0x122a1fa9, 0x3f021fec, 0x0a12195a, 0x2b006e08,   // cy.mt.hu_544 cy.da.af_644  gl.hu.pt_553 hmn.vi.un_430
  // [0f60]
  0x25005507, 0x32002807, 0x1c001a04, 0x190b10ee,   // rw.eu.un_420 sw.bs.un_420  tl.id.un_320 lt.es.gl_422
  0x11000e13, 0x64002819, 0x121b0f04, 0x0c1306ad,   // is.ro.un_650 sw.lg.un_750  lv.tr.hu_332 de.et.sv_643
  0x10000f19, 0x18284aa0, 0x1e002302, 0x1c1f0704,   // lv.lt.un_750 yo.sw.ga_322  ca.ms.un_220 it.cy.id_332
  0x644a35af, 0x09531107, 0x06003b12, 0x07041004,   // zu.yo.lg_655 ro.ht.pl_432  so.de.un_640 be.ru.bg_332
  // [0f70]
  0x0e3152a0, 0x02556ba0, 0x065221a6, 0x5300030d,   // ha.az.is_322 ceb.rw.da_322  jw.ha.de_521 nl.ht.un_540
  0x0400640d, 0x2d0d35a9, 0x09001013, 0x040817a4,   // lg.fi.un_540 zu.cs.sk_544  lt.pl.un_650 sr.uk.ru_433
  0x0a0710af, 0x04110713, 0x0800201a, 0x01005502,   // be.bg.mk_655 bg.ro.ru_665  sq.no.un_760 rw.en.un_220
  0x0d350408, 0x041011ad, 0x0408070e, 0x1e1c3fa4,   // fi.zu.cs_443 ro.be.ru_643  bg.uk.ru_555 af.id.ms_433
  // [0f80]
  0x100708a4, 0x0400101b, 0x1b3125ee, 0x102012a7,   // uk.bg.be_433 lt.fi.un_770  eu.az.tr_422 hu.sq.lt_532
  0x0a000712, 0x0e550a05, 0x1c06020d, 0x18004a04,   // bg.mk.un_640 pt.rw.is_333  da.de.id_554 yo.ga.un_320
  0x1c003105, 0x21171605, 0x27033f0d, 0x110b0a02,   // az.id.un_330 hr.sr.jw_333  af.nl.gd_554 pt.es.ro_222
  0x0c0601a6, 0x32160da4, 0x2d0a4aa0, 0x00004a01,   // en.de.sv_521 cs.hr.bs_433  yo.pt.sk_322 yo.un.un_200
  // [0f90]
  0x09556404, 0x280720ad, 0x1c090d11, 0x070410a7,   // lg.rw.pl_332 sq.it.sw_643  ne.hi.mr_653 be.ru.bg_532
  0x20001602, 0x29002808, 0x21352804, 0x201a2507,   // hr.sq.un_220 sw.sl.un_430  sw.zu.jw_332 eu.tl.sq_432
  0x08001702, 0x1304250b, 0x3b1b2807, 0x31556412,   // sr.no.un_220 eu.fi.et_542  sw.tr.so_432 lg.rw.az_654
  0x1a6b5308, 0x17100808, 0x2d001008, 0x32202904,   // ht.ceb.tl_443 uk.be.sr_443  lt.sk.un_430 sl.sq.bs_332
  // [0fa0]
  0x55001f14, 0x6800642a, 0x3f3b6b02, 0x1b1f31af,   // cy.rw.un_660 lg.ig.un_970  ceb.so.af_222 az.cy.tr_655
  0x12640404, 0x02080e04, 0x351b4a07, 0x06356404,   // fi.lg.hu_332 is.no.da_332  yo.tr.zu_432 lg.zu.de_332
  0x210e3504, 0x55351f0e, 0x55005311, 0x321b55a4,   // zu.is.jw_332 cy.zu.rw_555  ht.rw.un_630 rw.tr.bs_433
  0x32001008, 0x3f1303a4, 0x556435ec, 0x1b200605,   // lt.bs.un_430 nl.et.af_433  zu.lg.rw_644 de.sq.tr_333
  // [0fb0]
  0x1f10270c, 0x21001f1b, 0x103b31a4, 0x23000b04,   // gd.lt.cy_543 cy.jw.un_770  az.so.lt_433 es.ca.un_320
  0x0c103f04, 0x08001713, 0x110a0708, 0x31111b0c,   // af.lt.sv_332 sr.uk.un_650  bg.mk.ro_443 tr.ro.az_543
  0x32000304, 0x07040812, 0x033b3204, 0x351b55a0,   // nl.bs.un_320 uk.ru.bg_654  bs.so.nl_332 rw.tr.zu_322
  0x3f036405, 0x4a6b0704, 0x6b1a21a0, 0x35282507,   // lg.nl.af_333 it.ceb.yo_332  jw.tl.ceb_322 eu.sw.zu_432
  // [0fc0]
  0x21003b19, 0x25050d07, 0x4a000a05, 0x08001207,   // so.jw.un_750 cs.fr.eu_432  pt.yo.un_330 hu.no.un_420
  0x190b1105, 0x21201e09, 0x1c211e04, 0x06000b04,   // ro.es.gl_333 ms.sq.jw_444  ms.jw.id_332 es.de.un_320
  0x11532512, 0x16001902, 0x3b1b31a4, 0x110d55a0,   // eu.ht.ro_654 gl.hr.un_220  az.tr.so_433 rw.cs.ro_322
  0x35091fa7, 0x110a070c, 0x18091004, 0x3b000804,   // cy.pl.zu_532 it.pt.ro_543  lt.pl.ga_332 no.so.un_320
  // [0fd0]
  0x1f033fee, 0x5535640d, 0x010905ee, 0x29033fa4,   // af.nl.cy_422 lg.zu.rw_554  fr.pl.en_422 af.nl.sl_433
  0x1b0910a6, 0x171809ee, 0x1200280b, 0x136e28a4,   // lt.pl.tr_521 pl.ga.sr_422  sw.hu.un_520 sw.hmn.et_433
  0x122d0dad, 0x1b002019, 0x6428550c, 0x0a001007,   // cs.sk.hu_643 sq.tr.un_750  rw.sw.lg_543 be.mk.un_420
  0x2a00070c, 0x020e08a4, 0x08230ead, 0x6e003f13,   // it.mt.un_530 no.is.da_433  is.ca.no_643 af.hmn.un_650
  // [0fe0]
  0x02006412, 0x08021fa0, 0x194a0eaf, 0x18002702,   // lg.da.un_640 cy.da.no_322  is.yo.gl_655 gd.ga.un_220
  0x2a001704, 0x27532355, 0x31001a0e, 0x032105ee,   // sr.mt.un_320 ca.ht.gd_442  tl.az.un_550 fr.jw.nl_422
  0x32002d04, 0x11002005, 0x0800180e, 0x20003202,   // sk.bs.un_320 sq.ro.un_330  ga.no.un_550 bs.sq.un_220
  0x3f000d08, 0x04000913, 0x1c0621ee, 0x13091c14,   // cs.af.un_430 pl.fi.un_650  jw.de.id_422 mr.hi.bh_666
  // [0ff0]
  0x08040a05, 0x0d001304, 0x112320ee, 0x23530511,   // mk.ru.uk_333 bh.ne.un_320  sq.ca.ro_422 fr.ht.ca_653
  0x19230b07, 0x2d0a09ad, 0x08020605, 0x3f136404,   // es.ca.gl_432 pl.pt.sk_643  de.da.no_333 lg.et.af_332
  0x01000c04, 0x190a0ba4, 0x0d001914, 0x17001907,   // sv.en.un_320 es.pt.gl_433  gl.cs.un_660 gl.sr.un_420
  0x0825010c, 0x27050108, 0x08000202, 0x0f132004,   // en.eu.no_543 en.fr.gd_443  da.no.un_220 sq.et.lv_332

  // [1000]
  0x0d3f2a11, 0x12001b07, 0x17000712, 0x6b530507,   // mt.af.cs_653 tr.hu.un_420  bg.sr.un_640 fr.ht.ceb_432
  0x1a3f6bee, 0x0c003202, 0x06001313, 0x2d0d3f05,   // ceb.af.tl_422 bs.sv.un_220  et.de.un_650 af.cs.sk_333
  0x0d001c08, 0x12000a05, 0x311b110d, 0x122d0aa4,   // mr.ne.un_430 pt.hu.un_330  ro.tr.az_554 pt.sk.hu_433
  0x32002b08, 0x3f00290d, 0x291b0da0, 0x2d3129a0,   // vi.bs.un_430 sl.af.un_540  cs.tr.sl_322 sl.az.sk_322
  // [1010]
  0x171b0704, 0x251235a0, 0x1819010b, 0x0b005304,   // it.tr.sr_332 zu.hu.eu_322  en.gl.ga_542 ht.es.un_320
  0x0605010b, 0x4a2753a6, 0x06002505, 0x080c1f0d,   // en.fr.de_542 ht.gd.yo_521  eu.de.un_330 cy.sv.no_554
  0x31111baf, 0x17002907, 0x1b002519, 0x1b131f02,   // tr.ro.az_655 sl.sr.un_420  eu.tr.un_750 cy.et.tr_222
  0x060a04ad, 0x11001f07, 0x010a07ee, 0x0a003512,   // fi.pt.de_643 cy.ro.un_420  it.pt.en_422 zu.pt.un_640
  // [1020]
  0x28000707, 0x0b0a19a4, 0x03002107, 0x3b003521,   // it.sw.un_420 gl.pt.es_433  jw.nl.un_420 zu.so.un_860
  0x1c211108, 0x02006b08, 0x21000807, 0x112a0705,   // ro.jw.id_443 ceb.da.un_430  no.jw.un_420 it.mt.ro_333
  0x171011ad, 0x1b353b12, 0x11000d0d, 0x16001a04,   // ro.be.sr_643 so.zu.tr_654  cs.ro.un_540 tl.hr.un_320
  0x1b130414, 0x0c000e05, 0x52313508, 0x17321607,   // fi.et.tr_666 is.sv.un_330  zu.az.ha_443 hr.bs.sr_432
  // [1030]
  0x64000d12, 0x1a6b21ec, 0x551a2807, 0x09000204,   // cs.lg.un_640 jw.ceb.tl_644  sw.tl.rw_432 da.pl.un_320
  0x6800641a, 0x25001b05, 0x06010c02, 0x4a005313,   // lg.ig.un_760 tr.eu.un_330  sv.en.de_222 ht.yo.un_650
  0x3b3552a0, 0x12356408, 0x071704af, 0x035320ad,   // ha.zu.so_322 lg.zu.hu_443  ru.sr.bg_655 sq.ht.nl_643
  0x0000270f, 0x05000e04, 0x0410110d, 0x09355507,   // gd.un.un_600 is.fr.un_320  ro.be.ru_554 rw.zu.pl_432
  // [1040]
  0x356b2da0, 0x1a5552ee, 0x021b03a0, 0x17001008,   // sk.ceb.zu_322 ha.rw.tl_422  nl.tr.da_322 be.sr.un_430
  0x00001106, 0x17040a02, 0x120c0107, 0x3b00060e,   // ro.un.un_400 mk.ru.sr_222  en.sv.hu_432 de.so.un_550
  0x351e1c09, 0x18001204, 0x28005204, 0x1f001e07,   // id.ms.zu_444 ur.ar.un_320  ha.sw.un_320 ms.cy.un_420
  0x171629a9, 0x06000307, 0x0c0208ec, 0x190b06ed,   // sl.hr.sr_544 nl.de.un_420  no.da.sv_644 de.es.gl_622
  // [1050]
  0x13003207, 0x070f0107, 0x6b006418, 0x522a230e,   // bs.et.un_420 en.lv.it_432  lg.ceb.un_740 ca.mt.ha_555
  0x20311b12, 0x0d1c0911, 0x0e002304, 0x3b0f52ad,   // tr.az.sq_654 hi.mr.ne_653  ca.is.un_320 ha.lv.so_643
  0x53052d05, 0x0f1f5304, 0x121004af, 0x09131cad,   // sk.fr.ht_333 ht.cy.lv_332  fi.lt.hu_655 mr.bh.hi_643
  0x2d3f0d0d, 0x0d002902, 0x1c211ea0, 0x0b2308a4,   // cs.af.sk_554 sl.cs.un_220  ms.jw.id_322 no.ca.es_433
  // [1060]
  0x6b2135ad, 0x3f0106a7, 0x4a002107, 0x0a001904,   // zu.jw.ceb_643 de.en.af_532  jw.yo.un_420 gl.pt.un_320
  0x3b002019, 0x1c000d0e, 0x0c001b14, 0x111025a0,   // sq.so.un_750 ne.mr.un_550  tr.sv.un_660 eu.lt.ro_322
  0x18282b11, 0x0c080b02, 0x1f133b08, 0x35002513,   // vi.sw.ga_653 es.no.sv_222  so.et.cy_443 eu.zu.un_650
  0x5521285a, 0x07001107, 0x08023f09, 0x0c00100d,   // sw.jw.rw_553 ro.bg.un_420  af.da.no_444 lt.sv.un_540
  // [1070]
  0x080925a0, 0x13033f08, 0x11003512, 0x1c0d0905,   // eu.pl.no_322 af.nl.et_443  zu.ro.un_640 hi.ne.mr_333
  0x06001e04, 0x0a00111a, 0x07000513, 0x19051855,   // ms.de.un_320 ro.mk.un_760  fr.it.un_650 ga.fr.gl_442
  0x18000d05, 0x070501a4, 0x06001b12, 0x20001008,   // cs.ga.un_330 en.fr.it_433  tr.de.un_640 lt.sq.un_430
  0x12003107, 0x3b000712, 0x1255250c, 0x0b001112,   // az.hu.un_420 it.so.un_640  eu.rw.hu_543 ro.es.un_640
  // [1080]
  0x29001019, 0x1c003b0e, 0x02006b04, 0x01000605,   // lt.sl.un_750 so.id.un_550  ceb.da.un_320 de.en.un_330
  0x2d0d0fa0, 0x21291e04, 0x1a002102, 0x12003504,   // lv.cs.sk_322 ms.sl.jw_332  jw.tl.un_220 zu.hu.un_320
  0x071b0a02, 0x100705a0, 0x19002a02, 0x011f35a0,   // pt.tr.it_222 fr.it.lt_322  mt.gl.un_220 zu.cy.en_322
  0x2a2012ec, 0x1004170d, 0x111c55ee, 0x2d0d11ee,   // hu.sq.mt_644 sr.ru.be_554  rw.id.ro_422 ro.cs.sk_422
  // [1090]
  0x0c031311, 0x55002513, 0x161335ee, 0x0e5513ee,   // et.nl.sv_653 eu.rw.un_650  zu.et.hr_422 et.rw.is_422
  0x68002513, 0x52006e05, 0x040a0711, 0x07170a02,   // eu.ig.un_650 hmn.ha.un_330  bg.mk.ru_653 mk.sr.bg_222
  0x3f211c0d, 0x00002901, 0x6b1135a7, 0x18060111,   // id.jw.af_554 sl.un.un_200  zu.ro.ceb_532 en.de.ga_653
  0x2a2031ad, 0x55003505, 0x070311ee, 0x17002d08,   // az.sq.mt_643 zu.rw.un_330  ro.nl.it_422 sk.sr.un_430
  // [10a0]
  0x29000312, 0x282718ad, 0x0000120a, 0x31001b09,   // nl.sl.un_640 ga.gd.sw_643  ur.un.un_500 tr.az.un_440
  0x3f2903a0, 0x3b006402, 0x1f00641b, 0x20002919,   // nl.sl.af_322 lg.so.un_220  lg.cy.un_770 sl.sq.un_750
  0x04001f18, 0x04002504, 0x10000408, 0x012d35a0,   // cy.fi.un_740 eu.fi.un_320  ru.be.un_430 zu.sk.en_322
  0x080417a0, 0x04100808, 0x010a2b04, 0x350353ec,   // sr.ru.uk_322 uk.be.ru_443  vi.pt.en_332 ht.nl.zu_644
  // [10b0]
  0x27006e07, 0x4a201b07, 0x18033f12, 0x291b315a,   // hmn.gd.un_420 tr.sq.yo_432  af.nl.ga_654 az.tr.sl_553
  0x033f64ec, 0x0d1c13ec, 0x1c252112, 0x2d0d10af,   // lg.af.nl_644 bh.mr.ne_644  jw.eu.id_654 lt.cs.sk_655
  0x0817110e, 0x0e0401a0, 0x08001108, 0x1e180107,   // ro.sr.uk_555 en.fi.is_322  ro.uk.un_430 en.ga.ms_432
  0x0c000605, 0x1f5325ad, 0x080411a0, 0x1f002307,   // de.sv.un_330 eu.ht.cy_643  ro.ru.uk_322 ca.cy.un_420
  // [10c0]
  0x552901a4, 0x07170aec, 0x524a3ba4, 0x6b1f270c,   // en.sl.rw_433 mk.sr.bg_644  so.yo.ha_433 gd.cy.ceb_543
  0x0400080e, 0x17002905, 0x3b002b09, 0x0400050e,   // uk.ru.un_550 sl.sr.un_330  vi.so.un_440 fr.fi.un_550
  0x0d171307, 0x010208ee, 0x19230ba0, 0x25002113,   // et.sr.cs_432 no.da.en_422  es.ca.gl_322 jw.eu.un_650
  0x23001707, 0x25000a0c, 0x211b1307, 0x16001007,   // sr.ca.un_420 pt.eu.un_530  et.tr.jw_432 lt.hr.un_420
  // [10d0]
  0x3f4a0707, 0x00001224, 0x681b35a4, 0x190a1ba4,   // it.yo.af_432 ur.un.un_900  zu.tr.ig_433 tr.pt.gl_433
  0x1b645513, 0x13001805, 0x0100090c, 0x6b2321a9,   // rw.lg.tr_665 ga.et.un_330  pl.en.un_530 jw.ca.ceb_544
  0x0c05010c, 0x13050108, 0x17000a08, 0x5500211a,   // en.fr.sv_543 en.fr.et_443  mk.sr.un_430 jw.rw.un_760
  0x08020c09, 0x071710ec, 0x641b35ee, 0x6e002705,   // sv.da.no_444 be.sr.bg_644  zu.tr.lg_422 gd.hmn.un_330
  // [10e0]
  0x080e3104, 0x07000813, 0x051103a0, 0x3b181308,   // az.is.no_332 uk.bg.un_650  nl.ro.fr_322 et.ga.so_443
  0x12002302, 0x16002a05, 0x131204ec, 0x35171bee,   // ca.hu.un_220 mt.hr.un_330  fi.hu.et_644 tr.sr.zu_422
  0x046425ad, 0x18001211, 0x284a350b, 0x20001f02,   // eu.lg.fi_643 ur.ar.un_630  zu.yo.sw_542 cy.sq.un_220
  0x644a53ee, 0x17291607, 0x2d0c53a7, 0x18006b07,   // ht.yo.lg_422 hr.sl.sr_432  ht.sv.sk_532 ceb.ga.un_420
  // [10f0]
  0x1200230d, 0x061b31ee, 0x2d090da0, 0x10283507,   // ca.hu.un_540 az.tr.de_422  cs.pl.sk_322 zu.sw.lt_432
  0x3f202107, 0x32162902, 0x0a070455, 0x17111011,   // jw.sq.af_432 sl.hr.bs_222  ru.bg.mk_442 be.ro.sr_653
  0x6b060807, 0x080220a0, 0x18002519, 0x06080e08,   // no.de.ceb_432 sq.da.no_322  eu.ga.un_750 is.no.de_443
  0x1b133507, 0x0b0123a0, 0x095231a7, 0x030604ad,   // zu.et.tr_432 ca.en.es_322  az.ha.pl_532 fi.de.nl_643
  // [1100]
  0x0f002d0e, 0x1c0d0911, 0x18005302, 0x08000308,   // sk.lv.un_550 hi.ne.mr_653  ht.ga.un_220 nl.no.un_430
  0x21001c0e, 0x0e311baf, 0x04006409, 0x120e1809,   // id.jw.un_550 tr.az.is_655  lg.fi.un_440 ga.is.hu_444
  0x0f001704, 0x17000a12, 0x0607030e, 0x06020702,   // sr.lv.un_320 mk.sr.un_640  nl.it.de_555 it.da.de_222
  0x09121808, 0x6b1f01a0, 0x13043b60, 0x52003b04,   // ga.hu.pl_443 en.cy.ceb_322  so.fi.et_664 so.ha.un_320
  // [1110]
  0x683b08a4, 0x3b190a08, 0x1c0d0960, 0x53201ea0,   // no.so.ig_433 pt.gl.so_443  hi.ne.mr_664 ms.sq.ht_322
  0x08130412, 0x1e1c1ba4, 0x070a11a7, 0x04000a02,   // fi.et.no_654 tr.id.ms_433  ro.mk.bg_532 mk.ru.un_220
  0x0900060e, 0x05111002, 0x0a000704, 0x04001308,   // de.pl.un_550 lt.ro.fr_222  it.pt.un_320 et.fi.un_430
  0x523121a0, 0x556435ee, 0x041017a4, 0x10002d0e,   // jw.az.ha_322 zu.lg.rw_422  sr.be.ru_433 sk.lt.un_550
  // [1120]
  0x1e1b350c, 0x6b0d2012, 0x1a005204, 0x2513020c,   // zu.tr.ms_543 sq.cs.ceb_654  ha.tl.un_320 da.et.eu_543
  0x1f0e180e, 0x0a111714, 0x07000e07, 0x1b003b0e,   // ga.is.cy_555 sr.ro.mk_666  is.it.un_420 so.tr.un_550
  0x0c0225a7, 0x076b04ad, 0x21121107, 0x0100050c,   // eu.da.sv_532 fi.ceb.it_643  ro.hu.jw_432 fr.en.un_530
  0x0e000308, 0x0f00100e, 0x08070a12, 0x1e1a1b55,   // nl.is.un_430 lt.lv.un_550  mk.bg.uk_654 tr.tl.ms_442
  // [1130]
  0x08021f02, 0x11040a05, 0x0e001305, 0x13090dec,   // cy.da.no_222 mk.ru.ro_333  et.is.un_330 ne.hi.bh_644
  0x130a0855, 0x13002504, 0x0a0804a4, 0x0e000c07,   // no.pt.et_442 eu.et.un_320  ru.uk.mk_433 sv.is.un_420
  0x07001704, 0x1f001905, 0x35001e04, 0x4a08020d,   // sr.bg.un_320 gl.cy.un_330  ms.zu.un_320 da.no.yo_554
  0x1008170c, 0x23190a02, 0x23000a05, 0x0928550c,   // sr.uk.be_543 pt.gl.ca_222  pt.ca.un_330 rw.sw.pl_543
  // [1140]
  0x550120ee, 0x21005207, 0x20001704, 0x64006b02,   // sq.en.rw_422 ha.jw.un_420  sr.sq.un_320 ceb.lg.un_220
  0x6e003b12, 0x11070aa4, 0x21043f07, 0x09001f04,   // so.hmn.un_640 mk.bg.ro_433  af.fi.jw_432 cy.pl.un_320
  0x3b3135a4, 0x3b0802a4, 0x1c1128ac, 0x0a0411ee,   // zu.az.so_433 da.no.so_433  sw.ro.id_632 ro.ru.mk_422
  0x0000061c, 0x03002a0e, 0x090d13ec, 0x28003502,   // de.un.un_800 mt.nl.un_550  bh.ne.hi_644 zu.sw.un_220
  // [1150]
  0x2a523bee, 0x0a000718, 0x09003508, 0x033b680c,   // so.ha.mt_422 bg.mk.un_740  zu.pl.un_430 ig.so.nl_543
  0x1c1b3f07, 0x07640ea4, 0x040a0705, 0x03061804,   // af.tr.id_432 is.lg.it_433  bg.mk.ru_333 ga.de.nl_332
  0x200f12a4, 0x321729a0, 0x3f2a0908, 0x0c002a04,   // hu.lv.sq_433 sl.sr.bs_322  pl.mt.af_443 mt.sv.un_320
  0x2a006b0d, 0x160908a0, 0x20000407, 0x1e006b04,   // ceb.mt.un_540 no.pl.hr_322  fi.sq.un_420 ceb.ms.un_320
  // [1160]
  0x00001c1c, 0x556452a7, 0x211e5255, 0x3f271a05,   // mr.un.un_800 ha.lg.rw_532  ha.ms.jw_442 tl.gd.af_333
  0x2d0d21ec, 0x2a32020c, 0x1c211e07, 0x093f13a4,   // jw.cs.sk_644 da.bs.mt_543  ms.jw.id_432 et.af.pl_433
  0x25000614, 0x2a1e28ac, 0x1a0e07a7, 0x03000608,   // de.eu.un_660 sw.ms.mt_632  it.is.tl_532 de.nl.un_430
  0x0a170713, 0x0b001007, 0x09553509, 0x55002814,   // bg.sr.mk_665 lt.es.un_420  zu.rw.pl_444 sw.rw.un_660
  // [1170]
  0x041f0dad, 0x214a1aee, 0x55001112, 0x64000c05,   // cs.cy.fi_643 tl.yo.jw_422  ro.rw.un_640 sv.lg.un_330
  0x3f2a0607, 0x6b0325ee, 0x1c0d09ec, 0x1200070e,   // de.mt.af_432 eu.nl.ceb_422  hi.ne.mr_644 it.hu.un_550
  0x23180b02, 0x3f0713ee, 0x68006b0d, 0x0621030c,   // es.ga.ca_222 et.it.af_422  ceb.ig.un_540 nl.jw.de_543
  0x4a000e19, 0x09001c12, 0x0a08170c, 0x52002a04,   // is.yo.un_750 mr.hi.un_640  sr.uk.mk_543 mt.ha.un_320
  // [1180]
  0x3f001f07, 0x092a0fec, 0x13033f12, 0x13283b04,   // cy.af.un_420 lv.mt.pl_644  af.nl.et_654 so.sw.et_332
  0x31550fa4, 0x21286455, 0x311b2505, 0x64003b0e,   // lv.rw.az_433 lg.sw.jw_442  eu.tr.az_333 so.lg.un_550
  0x033f1304, 0x2d0d19a0, 0x12001f04, 0x1c1221ee,   // et.af.nl_332 gl.cs.sk_322  cy.hu.un_320 jw.hu.id_422
  0x190b0a14, 0x2a2b4aa0, 0x021f0812, 0x082d0d08,   // pt.es.gl_666 yo.vi.mt_322  no.cy.da_654 cs.sk.no_443
  // [1190]
  0x35093f0c, 0x090f1004, 0x29003202, 0x0d1c13a7,   // af.pl.zu_543 lt.lv.pl_332  bs.sl.un_220 bh.mr.ne_532
  0x1c1a5207, 0x040d09a6, 0x04001107, 0x6b3b2b07,   // ha.tl.id_432 pl.cs.fi_521  ro.ru.un_420 vi.so.ceb_432
  0x131b0407, 0x070b2312, 0x283b640c, 0x08020309,   // fi.tr.et_432 ca.es.it_654  lg.so.sw_543 nl.da.no_444
  0x0a000c0c, 0x190b01a4, 0x6e356407, 0x3f130313,   // sv.pt.un_530 en.es.gl_433  lg.zu.hmn_432 nl.et.af_665
  // [11a0]
  0x1b5312a4, 0x5500280d, 0x4a3564ad, 0x683f1307,   // hu.ht.tr_433 sw.rw.un_540  lg.zu.yo_643 et.af.ig_432
  0x0c001c02, 0x0d120c02, 0x103b07a0, 0x09130d08,   // id.sv.un_220 sv.hu.cs_222  it.so.lt_322 ne.bh.hi_443
  0x100417af, 0x214a64ee, 0x1b2035ee, 0x686b1a0d,   // sr.ru.be_655 lg.yo.jw_422  zu.sq.tr_422 tl.ceb.ig_554
  0x2a315207, 0x12050807, 0x4a0f10a4, 0x27181f55,   // ha.az.mt_432 no.fr.hu_432  lt.lv.yo_433 cy.ga.gd_442
  // [11b0]
  0x4a00680c, 0x050408a0, 0x212d0d5a, 0x3b002a02,   // ig.yo.un_530 no.fi.fr_322  cs.sk.jw_553 mt.so.un_220
  0x06003f12, 0x29001602, 0x1a003504, 0x0a11170c,   // af.de.un_640 hr.sl.un_220  zu.tl.un_320 sr.ro.mk_543
  0x55311ba4, 0x0b07205a, 0x0b6e2804, 0x28000b02,   // tr.az.rw_433 sq.it.es_553  sw.hmn.es_332 es.sw.un_220
  0x3b000702, 0x1a005519, 0x12000d11, 0x080e2004,   // it.so.un_220 rw.tl.un_750  cs.hu.un_630 sq.is.no_332
  // [11c0]
  0x19002318, 0x21002b04, 0x2700011a, 0x3f6b25ec,   // ca.gl.un_740 vi.jw.un_320  en.gd.un_760 eu.ceb.af_644
  0x04081f11, 0x04002013, 0x11002809, 0x64003504,   // cy.no.fi_653 sq.fi.un_650  sw.ro.un_440 zu.lg.un_320
  0x2000290c, 0x0d000902, 0x112825ad, 0x1f00041a,   // sl.sq.un_530 hi.ne.un_220  eu.sw.ro_643 fi.cy.un_760
  0x131204a7, 0x3b554aa0, 0x06000c02, 0x3f3564ad,   // fi.hu.et_532 yo.rw.so_322  sv.de.un_220 lg.zu.af_643
  // [11d0]
  0x0c2512a7, 0x6b2a1255, 0x6b4a1a04, 0x32643ba4,   // hu.eu.sv_532 hu.mt.ceb_442  tl.yo.ceb_332 so.lg.bs_433
  0x55296404, 0x4a3b640c, 0x06033f13, 0x0d291107,   // lg.sl.rw_332 lg.so.yo_543  af.nl.de_665 ro.sl.cs_432
  0x16002513, 0x11003b17, 0x64005312, 0x53320504,   // eu.hr.un_650 so.ro.un_730  ht.lg.un_640 fr.bs.ht_332
  0x12000e07, 0x17290307, 0x0a000702, 0x02000e12,   // is.hu.un_420 nl.sl.sr_432  bg.mk.un_220 is.da.un_640
  // [11e0]
  0x2a006b07, 0x12002508, 0x080a11a6, 0x4a000d13,   // ceb.mt.un_420 eu.hu.un_430  ro.mk.uk_521 cs.yo.un_650
  0x130c02a0, 0x0a070805, 0x2300010c, 0x1c00090c,   // da.sv.et_322 uk.bg.mk_333  en.ca.un_530 hi.mr.un_530
  0x16000c04, 0x2d12640c, 0x3f00020c, 0x32002702,   // sv.hr.un_320 lg.hu.sk_543  da.af.un_530 gd.bs.un_220
  0x093b1fee, 0x5300250e, 0x1a1225a0, 0x0d002105,   // cy.so.pl_422 eu.ht.un_550  eu.hu.tl_322 jw.cs.un_330
  // [11f0]
  0x3b3f03a7, 0x3f003b04, 0x0d0e18ad, 0x20006804,   // nl.af.so_532 so.af.un_320  ga.is.cs_643 ig.sq.un_320
  0x52003509, 0x1312010c, 0x07000119, 0x3f2d0da4,   // zu.ha.un_440 en.hu.et_543  en.it.un_750 cs.sk.af_433
  0x2b005204, 0x0d0913ad, 0x190b0a05, 0x6409355a,   // ha.vi.un_320 bh.hi.ne_643  pt.es.gl_333 zu.pl.lg_553
  0x110623ec, 0x1c0310a7, 0x28181fac, 0x040e6b07,   // ca.de.ro_644 lt.nl.id_532  cy.ga.sw_632 ceb.is.fi_432
  // [1200]
  0x4a00320d, 0x1f3f0114, 0x040511a7, 0x11292d07,   // bs.yo.un_540 en.af.cy_666  ro.fr.fi_532 sk.sl.ro_432
  0x0d0913ec, 0x230b0705, 0x2a1a11a4, 0x05202704,   // bh.hi.ne_644 it.es.ca_333  ro.tl.mt_433 gd.sq.fr_332
  0x53001b1b, 0x20002108, 0x2700130e, 0x35556ba0,   // tr.ht.un_770 jw.sq.un_430  et.gd.un_550 ceb.rw.zu_322
  0x3b060112, 0x03210fee, 0x1a552104, 0x3b000704,   // en.de.so_654 lv.jw.nl_422  jw.rw.tl_332 it.so.un_320
  // [1210]
  0x25681804, 0x311b6b0c, 0x04131aa0, 0x644a55ec,   // ga.ig.eu_332 ceb.tr.az_543  tl.et.fi_322 rw.yo.lg_644
  0x1f002514, 0x04000a18, 0x1b080c0d, 0x520220ee,   // eu.cy.un_660 mk.ru.un_740  sv.no.tr_554 sq.da.ha_422
  0x2a092da0, 0x1100071a, 0x1f051107, 0x112107a0,   // sk.pl.mt_322 bg.ro.un_760  ro.fr.cy_432 it.jw.ro_322
  0x2527010b, 0x04002d12, 0x23000704, 0x0c251a02,   // en.gd.eu_542 sk.fi.un_640  it.ca.un_320 tl.eu.sv_222
  // [1220]
  0x0800060c, 0x0c3f0dee, 0x27000b08, 0x070b0a05,   // de.no.un_530 cs.af.sv_422  es.gd.un_430 pt.es.it_333
  0x042d0dad, 0x3b001e02, 0x0e111307, 0x056b1a0c,   // cs.sk.fi_643 ms.so.un_220  et.ro.is_432 tl.ceb.fr_543
  0x07080107, 0x20312aee, 0x060103a7, 0x080235ee,   // en.no.it_432 mt.az.sq_422  nl.en.de_532 zu.da.no_422
  0x64001218, 0x190b13a4, 0x0d1c1308, 0x0a041708,   // hu.lg.un_740 et.es.gl_433  bh.mr.ne_443 sr.ru.mk_443
  // [1230]
  0x10000504, 0x29211f04, 0x20250107, 0x036b0aee,   // fr.lt.un_320 cy.jw.sl_332  en.eu.sq_432 pt.ceb.nl_422
  0x64003202, 0x0f6e060b, 0x050b23a0, 0x3b1b0107,   // bs.lg.un_220 de.hmn.lv_542  ca.es.fr_322 en.tr.so_432
  0x251c28ee, 0x00004a1c, 0x09131c11, 0x0c1f12a4,   // sw.id.eu_422 yo.un.un_800  mr.bh.hi_653 hu.cy.sv_433
  0x08020ea4, 0x52006419, 0x25005304, 0x1225040c,   // is.da.no_433 lg.ha.un_750  ht.eu.un_320 fi.eu.hu_543
  // [1240]
  0x53000914, 0x12002a04, 0x35000a04, 0x0f060111,   // pl.ht.un_660 mt.hu.un_320  pt.zu.un_320 en.de.lv_653
  0x1c0d0912, 0x236b5302, 0x2d122bad, 0x170a0805,   // hi.ne.mr_654 ht.ceb.ca_222  vi.hu.sk_643 uk.mk.sr_333
  0x1c00130b, 0x2a002504, 0x1c130960, 0x17110a12,   // bh.mr.un_520 eu.mt.un_320  hi.bh.mr_664 mk.ro.sr_654
  0x100a2d05, 0x0a000d04, 0x06130c08, 0x533b010b,   // sk.pt.lt_333 cs.pt.un_320  sv.et.de_443 en.so.ht_542
  // [1250]
  0x09080da0, 0x0a171013, 0x08005212, 0x131c0908,   // cs.no.pl_322 be.sr.mk_665  ha.no.un_640 hi.mr.bh_443
  0x0a000413, 0x07001713, 0x06000e07, 0x1e1c2107,   // ru.mk.un_650 sr.bg.un_650  is.de.un_420 jw.id.ms_432
  0x3b006e07, 0x0e003f04, 0x2a003b0d, 0x1831250c,   // hmn.so.un_420 af.is.un_320  so.mt.un_540 eu.az.ga_543
  0x18001012, 0x0c083f04, 0x2a001a07, 0x6b6435a7,   // lt.ga.un_640 af.no.sv_332  tl.mt.un_420 zu.lg.ceb_532
  // [1260]
  0x07292da4, 0x12530aa0, 0x11000304, 0x081b2507,   // sk.sl.it_433 pt.ht.hu_322  nl.ro.un_320 eu.tr.no_432
  0x1118270c, 0x313f5507, 0x1e044aa0, 0x27181ea0,   // gd.ga.ro_543 rw.af.az_432  yo.fi.ms_322 ms.ga.gd_322
  0x01006b07, 0x18092da0, 0x1e311b08, 0x04062804,   // ceb.en.un_420 sk.pl.ga_322  tr.az.ms_443 sw.de.fi_332
  0x06002704, 0x03062702, 0x0e311b05, 0x091c1307,   // gd.de.un_320 gd.de.nl_222  tr.az.is_333 bh.mr.hi_432
  // [1270]
  0x1c033f11, 0x042013ad, 0x1e2031a7, 0x2500110c,   // af.nl.id_653 et.sq.fi_643  az.sq.ms_532 ro.eu.un_530
  0x11042808, 0x0a081711, 0x062a0711, 0x00001e15,   // sw.fi.ro_443 sr.uk.mk_653  it.mt.de_653 ms.un.un_700
  0x20000704, 0x64683504, 0x07002008, 0x20000412,   // it.sq.un_320 zu.ig.lg_332  sq.it.un_430 fi.sq.un_640
  0x1a043bac, 0x0c1f07ee, 0x091c13a4, 0x090c1004,   // so.fi.tl_632 it.cy.sv_422  bh.mr.hi_433 lt.sv.pl_332
  // [1280]
  0x52004a07, 0x0a003b0d, 0x32160bee, 0x25230407,   // yo.ha.un_420 so.pt.un_540  es.hr.bs_422 fi.ca.eu_432
  0x0b002305, 0x1e311b12, 0x21000704, 0x0f1001a9,   // ca.es.un_330 tr.az.ms_654  it.jw.un_320 en.lt.lv_544
  0x0e1812af, 0x1a5201a0, 0x12002d0e, 0x1c0d090b,   // hu.ga.is_655 en.ha.tl_322  sk.hu.un_550 hi.ne.mr_542
  0x2b002707, 0x1b5209a4, 0x0000231c, 0x070817a4,   // gd.vi.un_420 pl.ha.tr_433  ca.un.un_800 sr.uk.bg_433
  // [1290]
  0x0c1a35ee, 0x3b281aaf, 0x3b000a04, 0x3f1b35a0,   // zu.tl.sv_422 tl.sw.so_655  pt.so.un_320 zu.tr.af_322
  0x11003508, 0x1a00551b, 0x0f001c02, 0x09002909,   // zu.ro.un_430 rw.tl.un_770  id.lv.un_220 sl.pl.un_440
  0x2d003f04, 0x25060fa0, 0x1c6b4aee, 0x1704110c,   // af.sk.un_320 lv.de.eu_322  yo.ceb.id_422 ro.ru.sr_543
  0x07000b04, 0x2d0d3fa0, 0x09002904, 0x3b202805,   // es.it.un_320 af.cs.sk_322  sl.pl.un_320 sw.sq.so_333
  // [12a0]
  0x13100f0c, 0x04071012, 0x1f643b12, 0x1f092d04,   // lv.lt.et_543 be.bg.ru_654  so.lg.cy_654 sk.pl.cy_332
  0x31001902, 0x322d2aee, 0x64350312, 0x081104a4,   // gl.az.un_220 mt.sk.bs_422  nl.zu.lg_654 ru.ro.uk_433
  0x0c2106ee, 0x2d001113, 0x0d002012, 0x11002d0c,   // de.jw.sv_422 ro.sk.un_650  sq.cs.un_640 sk.ro.un_530
  0x5300070e, 0x04001719, 0x16000d0c, 0x0c08230d,   // it.ht.un_550 sr.ru.un_750  cs.hr.un_530 ca.no.sv_554
  // [12b0]
  0x3b641aa0, 0x060c0204, 0x1f00070e, 0x0d001602,   // tl.lg.so_322 da.sv.de_332  it.cy.un_550 hr.cs.un_220
  0x6e001313, 0x0700550d, 0x190b23a4, 0x07200fee,   // et.hmn.un_650 rw.it.un_540  ca.es.gl_433 lv.sq.it_422
  0x285535ec, 0x28521ea0, 0x64073504, 0x2800550c,   // zu.rw.sw_644 ms.ha.sw_322  zu.it.lg_332 rw.sw.un_530
  0x21001312, 0x0923110c, 0x0500210d, 0x52071105,   // et.jw.un_640 ro.ca.pl_543  jw.fr.un_540 ro.it.ha_333
  // [12c0]
  0x1a1c2507, 0x10001a04, 0x05005204, 0x12072807,   // eu.id.tl_432 tl.lt.un_320  ha.fr.un_320 sw.it.hu_432
  0x00001a24, 0x35644a0c, 0x121e3bad, 0x35003b1b,   // tl.un.un_900 yo.lg.zu_543  so.ms.hu_643 so.zu.un_770
  0x55006b05, 0x53071b04, 0x31110f07, 0x32001104,   // ceb.rw.un_330 tr.it.ht_332  lv.ro.az_432 ro.bs.un_320
  0x6b002104, 0x0c3f030c, 0x0400290e, 0x08000f12,   // jw.ceb.un_320 nl.af.sv_543  sl.fi.un_550 lv.no.un_640
  // [12d0]
  0x0a005302, 0x1e1c28ac, 0x1e215202, 0x2319010b,   // ht.pt.un_220 sw.id.ms_632  ha.jw.ms_222 en.gl.ca_542
  0x00001801, 0x0800040e, 0x3f000c04, 0x2d1f0dad,   // ga.un.un_200 ru.uk.un_550  sv.af.un_320 cs.cy.sk_643
  0x286435a7, 0x19004a04, 0x213f03ee, 0x0d180608,   // zu.lg.sw_532 yo.gl.un_320  nl.af.jw_422 de.ga.cs_443
  0x2d006e07, 0x2d000d02, 0x13000907, 0x100835ee,   // hmn.sk.un_420 cs.sk.un_220  hi.bh.un_420 zu.no.lt_422
  // [12e0]
  0x04171012, 0x25293b07, 0x065513a7, 0x231b3ba0,   // be.sr.ru_654 so.sl.eu_432  et.rw.de_532 so.tr.ca_322
  0x0c002a0e, 0x11000512, 0x01640f07, 0x043b1312,   // mt.sv.un_550 fr.ro.un_640  lv.lg.en_432 et.so.fi_654
  0x18273512, 0x6b1a01a9, 0x015535a0, 0x1b061213,   // zu.gd.ga_654 en.tl.ceb_544  zu.rw.en_322 hu.de.tr_665
  0x530428ad, 0x121735a0, 0x2b003505, 0x13640412,   // sw.fi.ht_643 zu.sr.hu_322  zu.vi.un_330 fi.lg.et_654
  // [12f0]
  0x043b6404, 0x121b0cee, 0x6e005512, 0x2b5511a0,   // lg.so.fi_332 sv.tr.hu_422  rw.hmn.un_640 ro.rw.vi_322
  0x1e002102, 0x0e000c04, 0x1e1c5209, 0x25001b13,   // jw.ms.un_220 sv.is.un_320  ha.id.ms_444 tr.eu.un_650
  0x2000211a, 0x253b2a0c, 0x2d0d2b0c, 0x3f000311,   // jw.sq.un_760 mt.so.eu_543  vi.cs.sk_543 nl.af.un_630
  0x0c081f05, 0x211b28ee, 0x293113a4, 0x17000f04,   // cy.no.sv_333 sw.tr.jw_422  et.az.sl_433 lv.sr.un_320
  // [1300]
  0x211628ee, 0x53280307, 0x110504a4, 0x13000d1a,   // sw.hr.jw_422 nl.sw.ht_432  fi.fr.ro_433 ne.bh.un_760
  0x1a00641a, 0x0c0413a0, 0x060c05a4, 0x023531a4,   // lg.tl.un_760 et.fi.sv_322  fr.sv.de_433 az.zu.da_433
  0x03003f07, 0x52351107, 0x1b001304, 0x1c005219,   // af.nl.un_420 ro.zu.ha_432  et.tr.un_320 ha.id.un_750
  0x11130f08, 0x070103a0, 0x0b002704, 0x2d000f0e,   // lv.et.ro_443 nl.en.it_322  gd.es.un_320 lv.sk.un_550
  // [1310]
  0x09003f0d, 0x2a3b3108, 0x21001704, 0x0d001113,   // af.pl.un_540 az.so.mt_443  sr.jw.un_320 ro.cs.un_650
  0x6404520c, 0x231901a4, 0x354a3ba0, 0x08131a0c,   // ha.fi.lg_543 en.gl.ca_433  so.yo.zu_322 tl.et.no_543
  0x2d070907, 0x1a000119, 0x310e09ad, 0x3f000613,   // pl.it.sk_432 en.tl.un_750  pl.is.az_643 de.af.un_650
  0x01002104, 0x190b2502, 0x1a2911a0, 0x0e080ca9,   // jw.en.un_320 eu.es.gl_222  ro.sl.tl_322 sv.no.is_544
  // [1320]
  0x2d001902, 0x1f2a5304, 0x0d00110d, 0x041355ee,   // gl.sk.un_220 ht.mt.cy_332  ro.cs.un_540 rw.et.fi_422
  0x0d005208, 0x2a200e07, 0x1c641ea4, 0x0a002d13,   // ha.cs.un_430 is.sq.mt_432  ms.lg.id_433 sk.pt.un_650
  0x200413a7, 0x29090fad, 0x090e29a4, 0x2b005507,   // et.fi.sq_532 lv.pl.sl_643  sl.is.pl_433 rw.vi.un_420
  0x07112507, 0x2a0413af, 0x211b04a4, 0x21001c12,   // eu.ro.it_432 et.fi.mt_655  fi.tr.jw_433 id.jw.un_640
  // [1330]
  0x29001014, 0x21002013, 0x311a06a6, 0x52002312,   // lt.sl.un_660 sq.jw.un_650  de.tl.az_521 ca.ha.un_640
  0x020c0811, 0x0b002312, 0x190b23ec, 0x2a060708,   // no.sv.da_653 ca.es.un_640  ca.es.gl_644 it.de.mt_443
  0x0f002911, 0x102d0d0d, 0x3f031305, 0x2a3b3112,   // sl.lv.un_630 cs.sk.lt_554  et.nl.af_333 az.so.mt_654
  0x00000203, 0x55005204, 0x1b002304, 0x040811ad,   // da.un.un_300 ha.rw.un_320  ca.tr.un_320 ro.uk.ru_643
  // [1340]
  0x07000402, 0x13042805, 0x04001708, 0x110a23a4,   // ru.bg.un_220 sw.fi.et_333  sr.ru.un_430 ca.pt.ro_433
  0x1b004a04, 0x25001902, 0x13005302, 0x31001b05,   // yo.tr.un_320 gl.eu.un_220  ht.et.un_220 tr.az.un_330
  0x21083fee, 0x1f000d04, 0x00001203, 0x07041f12,   // af.no.jw_422 cs.cy.un_320  ur.un.un_300 cy.fi.it_654
  0x17293b04, 0x01556407, 0x04251f5a, 0x13001107,   // so.sl.sr_332 lg.rw.en_432  cy.eu.fi_553 ro.et.un_420
  // [1350]
  0x3500520e, 0x180a2bec, 0x182d4a0c, 0x251e3b07,   // ha.zu.un_550 vi.pt.ga_644  yo.sk.ga_543 so.ms.eu_432
  0x290813ee, 0x53001e04, 0x1c002102, 0x53001307,   // et.no.sl_422 ms.ht.un_320  jw.id.un_220 et.ht.un_420
  0x080411a6, 0x351a5505, 0x52160dee, 0x1c0d09a4,   // ro.ru.uk_521 rw.tl.zu_333  cs.hr.ha_422 hi.ne.mr_433
  0x17100805, 0x11003b0c, 0x285564a6, 0x04000c07,   // uk.be.sr_333 so.ro.un_530  lg.rw.sw_521 sv.fi.un_420
  // [1360]
  0x55001c08, 0x07004a07, 0x193b25ec, 0x4a35520c,   // id.rw.un_430 yo.it.un_420  eu.so.gl_644 ha.zu.yo_543
  0x0c0813ee, 0x6b12350d, 0x11350704, 0x0e000b02,   // et.no.sv_422 zu.hu.ceb_554  it.zu.ro_332 es.is.un_220
  0x3f036407, 0x3b001902, 0x101c3bad, 0x2d0c0812,   // lg.nl.af_432 gl.so.un_220  so.id.lt_643 no.sv.sk_654
  0x10081a0c, 0x2d0d1602, 0x294a6407, 0x1c00520d,   // tl.no.lt_543 hr.cs.sk_222  lg.yo.sl_432 ha.id.un_540
  // [1370]
  0x020752a4, 0x17070dee, 0x09000114, 0x0c083502,   // ha.it.da_433 cs.it.sr_422  en.pl.un_660 zu.no.sv_222
  0x2110350e, 0x31281b07, 0x19006b04, 0x250b19ee,   // zu.lt.jw_555 tr.sw.az_432  ceb.gl.un_320 gl.es.eu_422
  0x0523010c, 0x0a10170c, 0x0410170d, 0x3f120305,   // en.ca.fr_543 sr.be.mk_543  sr.be.ru_554 nl.hu.af_333
  0x4a005305, 0x102328a0, 0x18000613, 0x643f35a0,   // ht.yo.un_330 sw.ca.lt_322  de.ga.un_650 zu.af.lg_322
  // [1380]
  0x040811a9, 0x28003f04, 0x073b2304, 0x03001004,   // ro.uk.ru_544 af.sw.un_320  ca.so.it_332 lt.nl.un_320
  0x080e1f11, 0x03000613, 0x17070413, 0x23005504,   // cy.is.no_653 de.nl.un_650  ru.bg.sr_665 rw.ca.un_320
  0x081827ad, 0x130435ee, 0x0e00121a, 0x0d001902,   // gd.ga.no_643 zu.fi.et_422  hu.is.un_760 gl.cs.un_220
  0x190118a0, 0x182b1aa0, 0x00001201, 0x13552805,   // ga.en.gl_322 tl.vi.ga_322  ur.un.un_200 sw.rw.et_333
  // [1390]
  0x29001b0c, 0x17001111, 0x3f0364ec, 0x0c000608,   // tr.sl.un_530 ro.sr.un_630  lg.nl.af_644 de.sv.un_430
  0x0a00530b, 0x64210412, 0x23120507, 0x12000513,   // ht.pt.un_520 fi.jw.lg_654  fr.hu.ca_432 fr.hu.un_650
  0x251120a4, 0x080f13a4, 0x0c2311af, 0x0b10280c,   // sq.ro.eu_433 et.lv.no_433  ro.ca.sv_655 sw.lt.es_543
  0x0a113b07, 0x3500551a, 0x2d0d0fa4, 0x0b02080b,   // so.ro.pt_432 rw.zu.un_760  lv.cs.sk_433 no.da.es_542
  // [13a0]
  0x0420250c, 0x0c1308ec, 0x0c000613, 0x0f000914,   // eu.sq.fi_543 no.et.sv_644  de.sv.un_650 pl.lv.un_660
  0x08132907, 0x12001312, 0x0c030aa0, 0x060401a4,   // sl.et.no_432 et.hu.un_640  pt.nl.sv_322 en.fi.de_433
  0x55001313, 0x0f3b13ec, 0x0d091c0c, 0x182725a6,   // et.rw.un_650 et.so.lv_644  mr.hi.ne_543 eu.gd.ga_521
  0x0f002704, 0x131a04a0, 0x071104af, 0x126b1a08,   // gd.lv.un_320 fi.tl.et_322  ru.ro.bg_655 tl.ceb.hu_443
  // [13b0]
  0x0a001004, 0x04003b04, 0x29061fa0, 0x53110ca0,   // be.mk.un_320 so.fi.un_320  cy.de.sl_322 sv.ro.ht_322
  0x2b001818, 0x645235ee, 0x126b13ee, 0x1f001105,   // ga.vi.un_740 zu.ha.lg_422  et.ceb.hu_422 ro.cy.un_330
  0x29000f18, 0x292d0f07, 0x201b1f07, 0x045305ee,   // lv.sl.un_740 lv.sk.sl_432  cy.tr.sq_432 fr.ht.fi_422
  0x523b2109, 0x12000c04, 0x531925a0, 0x0800680c,   // jw.so.ha_444 sv.hu.un_320  eu.gl.ht_322 ig.no.un_530
  // [13c0]
  0x06000412, 0x033b3fa9, 0x070417af, 0x07005304,   // fi.de.un_640 af.so.nl_544  sr.ru.bg_655 ht.it.un_320
  0x52001e02, 0x4a000b04, 0x03083fee, 0x00002803,   // ms.ha.un_220 es.yo.un_320  af.no.nl_422 sw.un.un_300
  0x25002104, 0x190b0a09, 0x31003518, 0x28122511,   // jw.eu.un_320 pt.es.gl_444  zu.az.un_740 eu.hu.sw_653
  0x10080faf, 0x6b002807, 0x3b6453ec, 0x352a55af,   // lv.no.lt_655 sw.ceb.un_420  ht.lg.so_644 rw.mt.zu_655
  // [13d0]
  0x643552a7, 0x1e292d07, 0x2a55640c, 0x2d002a08,   // ha.zu.lg_532 sk.sl.ms_432  lg.rw.mt_543 mt.sk.un_430
  0x0d2d090d, 0x06003505, 0x21525513, 0x04005309,   // pl.sk.cs_554 zu.de.un_330  rw.ha.jw_665 ht.fi.un_440
  0x18000a0d, 0x0d005302, 0x08131b04, 0x2a0112ee,   // pt.ga.un_540 ht.cs.un_220  tr.et.no_332 hu.en.mt_422
  0x0d00050e, 0x23132aa0, 0x0a001702, 0x10000e14,   // fr.cs.un_550 mt.et.ca_322  sr.mk.un_220 is.lt.un_660
  // [13e0]
  0x06000804, 0x023f0807, 0x02000e04, 0x1c130dec,   // no.de.un_320 no.af.da_432  is.da.un_320 ne.bh.mr_644
  0x011205ee, 0x1008020d, 0x010705a0, 0x13091cec,   // fr.hu.en_422 da.no.lt_554  fr.it.en_322 mr.hi.bh_644
  0x00000501, 0x2a000808, 0x060302a0, 0x1f002a07,   // fr.un.un_200 no.mt.un_430  da.nl.de_322 mt.cy.un_420
  0x10080260, 0x0508020e, 0x0100530c, 0x01002a04,   // da.no.lt_664 da.no.fr_555  ht.en.un_530 mt.en.un_320
  // [13f0]
  0x0e000814, 0x0d252dad, 0x133f1b07, 0x535564af,   // no.is.un_660 sk.eu.cs_643  tr.af.et_432 lg.rw.ht_655
  0x18000511, 0x1000250d, 0x132308a4, 0x3b1f1ba7,   // fr.ga.un_630 eu.lt.un_540  no.ca.et_433 tr.cy.so_532
  0x2a641fad, 0x10001702, 0x05002504, 0x04002104,   // cy.lg.mt_643 sr.lt.un_220  eu.fr.un_320 jw.fi.un_320
  0x070804a4, 0x1f6428ad, 0x3f060f07, 0x2d120d09,   // ru.uk.bg_433 sw.lg.cy_643  lv.de.af_432 cs.hu.sk_444

  // [1400]
  0x03250605, 0x2d006b07, 0x5300101a, 0x0c001908,   // de.eu.nl_333 ceb.sk.un_420  lt.ht.un_760 gl.sv.un_430
  0x06000113, 0x2d00060e, 0x08001304, 0x28002512,   // en.de.un_650 de.sk.un_550  et.no.un_320 eu.sw.un_640
  0x55001704, 0x53002120, 0x4a001012, 0x100613a0,   // sr.rw.un_320 jw.ht.un_850  lt.yo.un_640 et.de.lt_322
  0x3f0327a4, 0x1b002504, 0x0a001e04, 0x133f0e07,   // gd.nl.af_433 eu.tr.un_320  ms.pt.un_320 is.af.et_432
  // [1410]
  0x081b1faf, 0x1c1e2807, 0x1b00310c, 0x18205307,   // cy.tr.no_655 sw.ms.id_432  az.tr.un_530 ht.sq.ga_432
  0x1c0913ad, 0x522d5309, 0x530f0107, 0x0a002108,   // bh.hi.mr_643 ht.sk.ha_444  en.lv.ht_432 jw.pt.un_430
  0x05000118, 0x6b005512, 0x01311ba0, 0x0e080204,   // en.fr.un_740 rw.ceb.un_640  tr.az.en_322 da.no.is_332
  0x31112dee, 0x00000d06, 0x4a00180d, 0x103f35a7,   // sk.ro.az_422 ne.un.un_400  ga.yo.un_540 zu.af.lt_532
  // [1420]
  0x0c001305, 0x0b28100c, 0x11000813, 0x1c0d13a0,   // et.sv.un_330 lt.sw.es_543  uk.ro.un_650 bh.ne.mr_322
  0x283b1b08, 0x18194aee, 0x21685507, 0x131123ee,   // tr.so.sw_443 yo.gl.ga_422  rw.ig.jw_432 ca.ro.et_422
  0x520435ee, 0x041710a0, 0x1e1c13ee, 0x0c060202,   // zu.fi.ha_422 be.sr.ru_322  et.id.ms_422 da.de.sv_222
  0x4a002b14, 0x52003513, 0x3b041304, 0x23001104,   // vi.yo.un_660 zu.ha.un_650  et.fi.so_332 ro.ca.un_320
  // [1430]
  0x5506520c, 0x4a072ba4, 0x0e1b3112, 0x12032a04,   // ha.de.rw_543 vi.it.yo_433  az.tr.is_654 mt.nl.hu_332
  0x0c003f0d, 0x4a6407ee, 0x27091809, 0x1105070d,   // af.sv.un_540 it.lg.yo_422  ga.pl.gd_444 it.fr.ro_554
  0x09001f13, 0x3b310b04, 0x092d0d0d, 0x0e100c04,   // cy.pl.un_650 es.az.so_332  cs.sk.pl_554 sv.lt.is_332
  0x3f030112, 0x03000509, 0x4a6b1a11, 0x01002504,   // en.nl.af_654 fr.nl.un_440  tl.ceb.yo_653 eu.en.un_320
  // [1440]
  0x07080a0c, 0x1c001e0c, 0x0f100c08, 0x6418010c,   // mk.uk.bg_543 ms.id.un_530  sv.lt.lv_443 en.ga.lg_543
  0x170408a7, 0x0d001702, 0x0e001013, 0x00001806,   // uk.ru.sr_532 sr.cs.un_220  lt.is.un_650 ga.un.un_400
  0x0f002104, 0x06286ba4, 0x1a6b4a13, 0x13043b07,   // jw.lv.un_320 ceb.sw.de_433  yo.ceb.tl_665 so.fi.et_432
  0x35003b04, 0x25000714, 0x2b003f08, 0x0e3b095a,   // so.zu.un_320 it.eu.un_660  af.vi.un_430 pl.so.is_553
  // [1450]
  0x0d1c0912, 0x2d110d0c, 0x020106ee, 0x11071709,   // hi.mr.ne_654 cs.ro.sk_543  de.en.da_422 sr.bg.ro_444
  0x100d0412, 0x230825a0, 0x251104ec, 0x1e3b350c,   // fi.cs.lt_654 eu.no.ca_322  fi.ro.eu_644 zu.so.ms_543
  0x17001018, 0x293510a4, 0x11001b0e, 0x11001f05,   // be.sr.un_740 lt.zu.sl_433  tr.ro.un_550 cy.ro.un_330
  0x0d072807, 0x35556404, 0x25046805, 0x192107a6,   // sw.it.cs_432 lg.rw.zu_332  ig.fi.eu_333 it.jw.gl_521
  // [1460]
  0x04002519, 0x52213508, 0x35001219, 0x102106a6,   // eu.fi.un_750 zu.jw.ha_443  hu.zu.un_750 de.jw.lt_521
  0x16003507, 0x552864a9, 0x0d13095a, 0x1e1c0909,   // zu.hr.un_420 lg.sw.rw_544  hi.bh.ne_553 pl.id.ms_444
  0x041b0faf, 0x2a06010c, 0x0625350c, 0x082b03a7,   // lv.tr.fi_655 en.de.mt_543  zu.eu.de_543 nl.vi.no_532
  0x3f0f0907, 0x4a311b12, 0x16001e04, 0x1b5311ee,   // pl.lv.af_432 tr.az.yo_654  ms.hr.un_320 ro.ht.tr_422
  // [1470]
  0x292d3b0e, 0x00000d01, 0x3b0f1ea4, 0x041320a9,   // so.sk.sl_555 ne.un.un_200  ms.lv.so_433 sq.et.fi_544
  0x16000407, 0x0a102d55, 0x190b35ee, 0x07000304,   // fi.hr.un_420 sk.lt.pt_442  zu.es.gl_422 nl.it.un_320
  0x100a0407, 0x04000a12, 0x3f002a0c, 0x64551ba4,   // ru.mk.be_432 mk.ru.un_640  mt.af.un_530 tr.rw.lg_433
  0x6e003519, 0x06006404, 0x1c13090d, 0x110b25a0,   // zu.hmn.un_750 lg.de.un_320  hi.bh.mr_554 eu.es.ro_322
  // [1480]
  0x18003507, 0x010535a0, 0x2d290d12, 0x05003b0d,   // zu.ga.un_420 zu.fr.en_322  cs.sl.sk_654 so.fr.un_540
  0x350928ee, 0x026e1804, 0x552305a7, 0x29230202,   // sw.pl.zu_422 ga.hmn.da_332  fr.ca.rw_532 da.ca.sl_222
  0x0200180d, 0x16000f12, 0x64006b0d, 0x3b005505,   // ga.da.un_540 lv.hr.un_640  ceb.lg.un_540 rw.so.un_330
  0x07006409, 0x0a2718ec, 0x28000414, 0x09000d0c,   // lg.it.un_440 ga.gd.pt_644  fi.sw.un_660 ne.hi.un_530
  // [1490]
  0x01001802, 0x172129a7, 0x060e08ee, 0x03001b12,   // ga.en.un_220 sl.jw.sr_532  no.is.de_422 tr.nl.un_640
  0x3b6835a9, 0x1a6b0807, 0x290d100e, 0x040a10ad,   // zu.ig.so_544 no.ceb.tl_432  lt.cs.sl_555 be.mk.ru_643
  0x106b1b07, 0x25230307, 0x07002a04, 0x4a00230e,   // tr.ceb.lt_432 nl.ca.eu_432  mt.it.un_320 ca.yo.un_550
  0x1b001108, 0x1c2113a6, 0x31000a0e, 0x0d131c11,   // ro.tr.un_430 et.jw.id_521  pt.az.un_550 mr.bh.ne_653
  // [14a0]
  0x20002a02, 0x3b002712, 0x01045507, 0x2d0d1ca0,   // mt.sq.un_220 gd.so.un_640  rw.fi.en_432 id.cs.sk_322
  0x2b001104, 0x21003f0d, 0x2300050d, 0x091b31a4,   // ro.vi.un_320 af.jw.un_540  fr.ca.un_540 az.tr.pl_433
  0x0c000304, 0x28000c0e, 0x08001104, 0x1253200d,   // nl.sv.un_320 sv.sw.un_550  ro.uk.un_320 sq.ht.hu_554
  0x1c091307, 0x1e001902, 0x0b0a0fec, 0x2b2d3b04,   // bh.hi.mr_432 gl.ms.un_220  lv.pt.es_644 so.sk.vi_332
  // [14b0]
  0x070417ee, 0x1c1309a9, 0x00000206, 0x12002704,   // sr.ru.bg_422 hi.bh.mr_544  da.un.un_400 gd.hu.un_320
  0x35006409, 0x6b192507, 0x55006405, 0x0000640a,   // lg.zu.un_440 eu.gl.ceb_432  lg.rw.un_330 lg.un.un_500
  0x643b0e05, 0x10003b07, 0x322817a4, 0x0a00120b,   // is.so.lg_333 so.lt.un_420  sr.sw.bs_433 hu.pt.un_520
  0x3552280c, 0x2b031ea0, 0x1b000c04, 0x06003f02,   // sw.ha.zu_543 ms.nl.vi_322  sv.tr.un_320 af.de.un_220
  // [14c0]
  0x643521a6, 0x0a0f1004, 0x55281212, 0x23001605,   // jw.zu.lg_521 lt.lv.pt_332  hu.sw.rw_654 hr.ca.un_330
  0x032b16a0, 0x35000f12, 0x1c0d1307, 0x3f030c08,   // hr.vi.nl_322 lv.zu.un_640  bh.ne.mr_432 sv.nl.af_443
  0x253b31ee, 0x3b0653ec, 0x20061b07, 0x32003505,   // az.so.eu_422 ht.de.so_644  tr.de.sq_432 zu.bs.un_330
  0x18131f55, 0x53000507, 0x0417080e, 0x3f00070b,   // cy.et.ga_442 fr.ht.un_420  uk.sr.ru_555 it.af.un_520
  // [14d0]
  0x01002707, 0x02060ca0, 0x10001707, 0x16002d04,   // gd.en.un_420 sv.de.da_322  sr.be.un_420 sk.hr.un_320
  0x190b1fa4, 0x642835a0, 0x12352004, 0x28001c04,   // cy.es.gl_433 zu.sw.lg_322  sq.zu.hu_332 id.sw.un_320
  0x2a1e2107, 0x01002702, 0x03133fa9, 0x2a311e08,   // jw.ms.mt_432 gd.en.un_220  af.et.nl_544 ms.az.mt_443
  0x130408af, 0x213b28ee, 0x1f3553a0, 0x53352804,   // no.fi.et_655 sw.so.jw_422  ht.zu.cy_322 sw.zu.ht_332
  // [14e0]
  0x1e1c13a0, 0x180128a6, 0x3f210360, 0x6b5301a4,   // et.id.ms_322 sw.en.ga_521  nl.jw.af_664 en.ht.ceb_433
  0x11005507, 0x0d091c0e, 0x32122904, 0x2000310e,   // rw.ro.un_420 mr.hi.ne_555  sl.hu.bs_332 az.sq.un_550
  0x0b005302, 0x11072aa4, 0x211e0eee, 0x10170808,   // ht.es.un_220 mt.it.ro_433  is.ms.jw_422 uk.sr.be_443
  0x29002d05, 0x06000e13, 0x12002702, 0x1b1120ad,   // sk.sl.un_330 is.de.un_650  gd.hu.un_220 sq.ro.tr_643
  // [14f0]
  0x030608a4, 0x1a003f07, 0x06001f07, 0x3b081a12,   // no.de.nl_433 af.tl.un_420  cy.de.un_420 tl.no.so_654
  0x08006b05, 0x12002019, 0x18270304, 0x080e02ee,   // ceb.no.un_330 sq.hu.un_750  nl.gd.ga_332 da.is.no_422
  0x00002a24, 0x273f0360, 0x551264ec, 0x06002312,   // mt.un.un_900 nl.af.gd_664  lg.hu.rw_644 ca.de.un_640
  0x050318a0, 0x68004a09, 0x020c2912, 0x1e1c2aa0,   // ga.nl.fr_322 yo.ig.un_440  sl.sv.da_654 mt.id.ms_322
  // [1500]
  0x07002718, 0x101127a0, 0x210468ad, 0x1c270712,   // gd.it.un_740 gd.ro.lt_322  ig.fi.jw_643 it.gd.id_654
  0x55001e02, 0x1000040b, 0x234a18ee, 0x290c1807,   // ms.rw.un_220 ru.be.un_520  ga.yo.ca_422 ga.sv.sl_432
  0x2d0d04ec, 0x0f001e07, 0x2a000d1a, 0x13060f07,   // fi.cs.sk_644 ms.lv.un_420  cs.mt.un_760 lv.de.et_432
  0x4a101f04, 0x1b130507, 0x031c23a0, 0x2a00180d,   // cy.lt.yo_332 fr.et.tr_432  ca.id.nl_322 ga.mt.un_540
  // [1510]
  0x12003b0d, 0x4a0d2d12, 0x0a001714, 0x0b000304,   // so.hu.un_540 sk.cs.yo_654  sr.mk.un_660 nl.es.un_320
  0x0600270c, 0x0f1001a4, 0x3b002914, 0x31002907,   // gd.de.un_530 en.lt.lv_433  sl.so.un_660 sl.az.un_420
  0x00006b1c, 0x530f28ac, 0x10001121, 0x1f001902,   // ceb.un.un_800 sw.lv.ht_632  ro.be.un_860 gl.cy.un_220
  0x2900200d, 0x0e1301a4, 0x17002505, 0x643501a0,   // sq.sl.un_540 en.et.is_433  eu.sr.un_330 en.zu.lg_322
  // [1520]
  0x29003204, 0x07170a0e, 0x285231af, 0x2a000304,   // bs.sl.un_320 mk.sr.bg_555  az.ha.sw_655 nl.mt.un_320
  0x131c0955, 0x0d092d07, 0x20003508, 0x120f11a7,   // hi.mr.bh_442 sk.pl.cs_432  zu.sq.un_430 ro.lv.hu_532
  0x6b002705, 0x03010aa0, 0x20001213, 0x21003b13,   // gd.ceb.un_330 pt.en.nl_322  hu.sq.un_650 so.jw.un_650
  0x1e000e04, 0x530406a0, 0x2a001819, 0x031b31a0,   // is.ms.un_320 de.fi.ht_322  ga.mt.un_750 az.tr.nl_322
  // [1530]
  0x090d1c0c, 0x28100aa4, 0x6b0e25a4, 0x645503ec,   // mr.ne.hi_543 pt.lt.sw_433  eu.is.ceb_433 nl.rw.lg_644
  0x3f6435ee, 0x190b0a55, 0x25001a02, 0x07080404,   // zu.lg.af_422 pt.es.gl_442  tl.eu.un_220 ru.uk.bg_332
  0x0a000411, 0x6b191fa7, 0x4a6855ec, 0x10070aec,   // ru.mk.un_630 cy.gl.ceb_532  rw.ig.yo_644 mk.bg.be_644
  0x230b0a0d, 0x17000908, 0x12000918, 0x0900030d,   // pt.es.ca_554 pl.sr.un_430  pl.hu.un_740 nl.pl.un_540
  // [1540]
  0x10000f04, 0x35031f0c, 0x0900290d, 0x29003504,   // lv.lt.un_320 cy.nl.zu_543  sl.pl.un_540 zu.sl.un_320
  0x12192da0, 0x1a6b640c, 0x0b190a04, 0x04003107,   // sk.gl.hu_322 lg.ceb.tl_543  pt.gl.es_332 az.fi.un_420
  0x0f003505, 0x10352ba7, 0x6800551b, 0x1f271812,   // zu.lv.un_330 vi.zu.lt_532  rw.ig.un_770 ga.gd.cy_654
  0x271b0fee, 0x13523ba9, 0x11003b04, 0x0e002104,   // lv.tr.gd_422 so.ha.et_544  so.ro.un_320 jw.is.un_320
  // [1550]
  0x200c3107, 0x282a01a4, 0x0f1801a4, 0x1b202aa0,   // az.sv.sq_432 en.mt.sw_433  en.ga.lv_433 mt.sq.tr_322
  0x10530c04, 0x18000c04, 0x03000702, 0x1a6b130e,   // sv.ht.lt_332 sv.ga.un_320  it.nl.un_220 et.ceb.tl_555
  0x0c0806af, 0x2d0d1702, 0x1e1c52a0, 0x11001721,   // de.no.sv_655 sr.cs.sk_222  ha.id.ms_322 sr.ro.un_860
  0x080206ee, 0x0e1f27ad, 0x16003104, 0x12002a0c,   // de.da.no_422 gd.cy.is_643  az.hr.un_320 mt.hu.un_530
  // [1560]
  0x23000a13, 0x16180704, 0x21000e07, 0x0200200c,   // pt.ca.un_650 it.ga.hr_332  is.jw.un_420 sq.da.un_530
  0x322052a0, 0x230511a0, 0x3f000f19, 0x190b230c,   // ha.sq.bs_322 ro.fr.ca_322  lv.af.un_750 ca.es.gl_543
  0x190a2302, 0x19131b04, 0x32173107, 0x282a18a4,   // ca.pt.gl_222 tr.et.gl_332  az.sr.bs_432 ga.mt.sw_433
  0x07000505, 0x12000309, 0x3f2003ee, 0x321816ee,   // fr.it.un_330 nl.hu.un_440  nl.sq.af_422 hr.ga.bs_422
  // [1570]
  0x0e000305, 0x100523ee, 0x0a351b07, 0x20000b09,   // nl.is.un_330 ca.fr.lt_422  tr.zu.pt_432 es.sq.un_440
  0x081004a9, 0x182701ad, 0x2d0d07a0, 0x2718110e,   // ru.be.uk_544 en.gd.ga_643  it.cs.sk_322 ro.ga.gd_555
  0x27000120, 0x182725a4, 0x29083f04, 0x0f0925ee,   // en.gd.un_850 eu.gd.ga_433  af.no.sl_332 eu.pl.lv_422
  0x1a2528a0, 0x2d000e12, 0x16094a02, 0x08554aa0,   // sw.eu.tl_322 is.sk.un_640  yo.pl.hr_222 yo.rw.no_322
  // [1580]
  0x230b07ee, 0x1c0921ad, 0x0e1b31a4, 0x086e1a07,   // it.es.ca_422 jw.pl.id_643  az.tr.is_433 tl.hmn.no_432
  0x0e033f0e, 0x111310a0, 0x09002512, 0x6b6401ec,   // af.nl.is_555 lt.et.ro_322  eu.pl.un_640 en.lg.ceb_644
  0x0a101104, 0x01005302, 0x522d0daf, 0x1e250d14,   // ro.lt.pt_332 ht.en.un_220  cs.sk.ha_655 cs.eu.ms_666
  0x1e001a07, 0x2d0d25a0, 0x18270a07, 0x2a0c64a0,   // tl.ms.un_420 eu.cs.sk_322  pt.gd.ga_432 lg.sv.mt_322
  // [1590]
  0x2d001b13, 0x3f001314, 0x1a003107, 0x10000804,   // tr.sk.un_650 et.af.un_660  az.tl.un_420 no.lt.un_320
  0x0f001b07, 0x042a0ca0, 0x19550a04, 0x1f041012,   // tr.lv.un_420 sv.mt.fi_322  pt.rw.gl_332 lt.fi.cy_654
  0x3b002a04, 0x07012807, 0x0c000704, 0x31230555,   // mt.so.un_320 sw.en.it_432  it.sv.un_320 fr.ca.az_442
  0x101729ec, 0x0c000213, 0x31102805, 0x03001b08,   // sl.sr.lt_644 da.sv.un_650  sw.lt.az_333 tr.nl.un_430
  // [15a0]
  0x322916ee, 0x282d0dac, 0x0a642807, 0x556b6405,   // hr.sl.bs_422 cs.sk.sw_632  sw.lg.pt_432 lg.ceb.rw_333
  0x080c27a0, 0x080210a0, 0x64005202, 0x0b0a6402,   // gd.sv.no_322 lt.da.no_322  ha.lg.un_220 lg.pt.es_222
  0x17001e02, 0x032d3ba0, 0x32000d05, 0x21006b11,   // ms.sr.un_220 so.sk.nl_322  cs.bs.un_330 ceb.jw.un_630
  0x051901a4, 0x25006413, 0x31000513, 0x06121007,   // en.gl.fr_433 lg.eu.un_650  fr.az.un_650 lt.hu.de_432
  // [15b0]
  0x061204ad, 0x680e0604, 0x17001e08, 0x0d002908,   // fi.hu.de_643 de.is.ig_332  ms.sr.un_430 sl.cs.un_430
  0x293b1304, 0x00000201, 0x1f27010c, 0x0c686b07,   // et.so.sl_332 da.un.un_200  en.gd.cy_543 ceb.ig.sv_432
  0x2b4a1e07, 0x0c001b12, 0x05102504, 0x0d002918,   // ms.yo.vi_432 tr.sv.un_640  eu.lt.fr_332 sl.cs.un_740
  0x25002814, 0x09005304, 0x17000814, 0x0a00250d,   // sw.eu.un_660 ht.pl.un_320  uk.sr.un_660 eu.pt.un_540
  // [15c0]
  0x20000c12, 0x09003504, 0x21276807, 0x313b1ba4,   // sv.sq.un_640 zu.pl.un_320  ig.gd.jw_432 tr.so.az_433
  0x08060204, 0x21001f07, 0x0e1f53a0, 0x3b001313,   // da.de.no_332 cy.jw.un_420  ht.cy.is_322 et.so.un_650
  0x213b55a7, 0x35000307, 0x4a006407, 0x08001707,   // rw.so.jw_532 nl.zu.un_420  lg.yo.un_420 sr.uk.un_420
  0x080203a0, 0x3b0907a0, 0x1700350b, 0x23002012,   // nl.da.no_322 it.pl.so_322  zu.sr.un_520 sq.ca.un_640
  // [15d0]
  0x2d040da0, 0x020520ad, 0x13080407, 0x1f1b25ee,   // cs.fi.sk_322 sq.fr.da_643  fi.no.et_432 eu.tr.cy_422
  0x20000119, 0x0c080604, 0x162d35a4, 0x29001c08,   // en.sq.un_750 de.no.sv_332  zu.sk.hr_433 id.sl.un_430
  0x020c1805, 0x17163210, 0x556b1c0b, 0x2d0d27a0,   // ga.sv.da_333 bs.hr.sr_642  id.ceb.rw_542 gd.cs.sk_322
  0x0f060107, 0x0e12180b, 0x02005502, 0x3b1029ee,   // en.de.lv_432 ga.hu.is_542  rw.da.un_220 sl.lt.so_422
  // [15e0]
  0x29133b12, 0x1e0c1b04, 0x17115504, 0x1a006408,   // so.et.sl_654 tr.sv.ms_332  rw.ro.sr_332 lg.tl.un_430
  0x190a08af, 0x100a0713, 0x0c5208af, 0x530852a0,   // no.pt.gl_655 bg.mk.be_665  no.ha.sv_655 ha.no.ht_322
  0x100a170c, 0x03061bee, 0x08170a14, 0x0411250c,   // sr.mk.be_543 tr.de.nl_422  mk.sr.uk_666 eu.ro.fi_543
  0x066e0fee, 0x16001104, 0x6e006405, 0x172d0d09,   // lv.hmn.de_422 ro.hr.un_320  lg.hmn.un_330 cs.sk.sr_444
  // [15f0]
  0x11100a0c, 0x16321707, 0x52532112, 0x050701a4,   // mk.be.ro_543 sr.bs.hr_432  jw.ht.ha_654 en.it.fr_433
  0x06002a12, 0x0e101208, 0x3f002305, 0x23005304,   // mt.de.un_640 hu.lt.is_443  ca.af.un_330 ht.ca.un_320
  0x31201b05, 0x170708af, 0x0c001318, 0x06002702,   // tr.sq.az_333 uk.bg.sr_655  et.sv.un_740 gd.de.un_220
  0x100304a4, 0x6b001c07, 0x0527040c, 0x202a3160,   // fi.nl.lt_433 id.ceb.un_420  fi.gd.fr_543 az.mt.sq_664
  // [1600]
  0x040e1005, 0x1a3f01a7, 0x53000808, 0x35006b12,   // lt.is.fi_333 en.af.tl_532  no.ht.un_430 ceb.zu.un_640
  0x0e002102, 0x3f0329a0, 0x0d103f07, 0x01002304,   // jw.is.un_220 sl.nl.af_322  af.lt.cs_432 ca.en.un_320
  0x2a001a02, 0x0f106ea7, 0x3b00311a, 0x0b55530c,   // tl.mt.un_220 hmn.lt.lv_532  az.so.un_760 ht.rw.es_543
  0x07000913, 0x190b12ec, 0x19122d55, 0x0a0804ad,   // pl.it.un_650 hu.es.gl_644  sk.hu.gl_442 ru.uk.mk_643
  // [1610]
  0x32002107, 0x2d001802, 0x0c2a20a4, 0x1100101b,   // jw.bs.un_420 ga.sk.un_220  sq.mt.sv_433 be.ro.un_770
  0x07284a04, 0x23001902, 0x052a1307, 0x11006407,   // yo.sw.it_332 gl.ca.un_220  et.mt.fr_432 lg.ro.un_420
  0x0f131004, 0x03023f02, 0x1a6b6408, 0x0c2a0408,   // lt.et.lv_332 af.da.nl_222  lg.ceb.tl_443 fi.mt.sv_443
  0x1e1b5302, 0x25040c0b, 0x2d004a09, 0x0f1310a4,   // ht.tr.ms_222 sv.fi.eu_542  yo.sk.un_440 lt.et.lv_433
  // [1620]
  0x10080ead, 0x0b680611, 0x0e100f0d, 0x231f0560,   // is.no.lt_643 de.ig.es_653  lv.lt.is_554 fr.cy.ca_664
  0x041110af, 0x111807a0, 0x0d00050c, 0x1b001707,   // be.ro.ru_655 it.ga.ro_322  fr.cs.un_530 sr.tr.un_420
  0x190113a0, 0x0a000512, 0x292d0d60, 0x1e1c2014,   // et.en.gl_322 fr.pt.un_640  cs.sk.sl_664 sq.id.ms_666
  0x551f1012, 0x08020eee, 0x52000507, 0x29002d0d,   // lt.cy.rw_654 is.da.no_422  fr.ha.un_420 sk.sl.un_540
  // [1630]
  0x0d202da0, 0x00003106, 0x3f211007, 0x315564ee,   // sk.sq.cs_322 az.un.un_400  lt.jw.af_432 lg.rw.az_422
  0x0c0213ec, 0x64000c07, 0x25005207, 0x3b0e04ad,   // et.da.sv_644 sv.lg.un_420  ha.eu.un_420 fi.is.so_643
  0x3f530405, 0x180306ec, 0x21053ba0, 0x0c0802ee,   // fi.ht.af_333 de.nl.ga_644  so.fr.jw_322 da.no.sv_422
  0x190a0b0e, 0x6e000313, 0x170407a4, 0x356b1aec,   // es.pt.gl_555 nl.hmn.un_650  bg.ru.sr_433 tl.ceb.zu_644
  // [1640]
  0x13003504, 0x6e00011a, 0x52004a04, 0x3100530d,   // zu.et.un_320 en.hmn.un_760  yo.ha.un_320 ht.az.un_540
  0x1731100e, 0x1b643512, 0x2d0d23ee, 0x07001f13,   // lt.az.sr_555 zu.lg.tr_654  ca.cs.sk_422 cy.it.un_650
  0x55002519, 0x0a005304, 0x09000f0e, 0x04080a0d,   // eu.rw.un_750 ht.pt.un_320  lv.pl.un_550 mk.uk.ru_554
  0x2d0d19ee, 0x4a5552ad, 0x040c1307, 0x28001e02,   // gl.cs.sk_422 ha.rw.yo_643  et.sv.fi_432 ms.sw.un_220
  // [1650]
  0x64002104, 0x2a006813, 0x2800110d, 0x4a1f53ee,   // jw.lg.un_320 ig.mt.un_650  ro.sw.un_540 ht.cy.yo_422
  0x09070da0, 0x6b001a07, 0x3f031a0c, 0x0d002912,   // cs.it.pl_322 tl.ceb.un_420  tl.nl.af_543 sl.cs.un_640
  0x3f031fac, 0x0c0f0804, 0x03002512, 0x352368ee,   // cy.nl.af_632 no.lv.sv_332  eu.nl.un_640 ig.ca.zu_422
  0x066b0c08, 0x0f0e23a4, 0x0e001c04, 0x17003208,   // sv.ceb.de_443 ca.is.lv_433  id.is.un_320 bs.sr.un_430
  // [1660]
  0x6804130d, 0x08230ca0, 0x3b000412, 0x55001a02,   // et.fi.ig_554 sv.ca.no_322  fi.so.un_640 tl.rw.un_220
  0x09280107, 0x64002814, 0x523b28a0, 0x0e4a52ac,   // en.sw.pl_432 sw.lg.un_660  sw.so.ha_322 ha.yo.is_632
  0x070d1ba0, 0x354a6413, 0x351a1309, 0x0a002309,   // tr.cs.it_322 lg.yo.zu_665  et.tl.zu_444 ca.pt.un_440
  0x31006e07, 0x132006ad, 0x02005309, 0x35001e02,   // hmn.az.un_420 de.sq.et_643  ht.da.un_440 ms.zu.un_220
  // [1670]
  0x311206ee, 0x13045207, 0x052755a0, 0x09005207,   // de.hu.az_422 ha.fi.et_432  rw.gd.fr_322 ha.pl.un_420
  0x13002702, 0x10002d0c, 0x281f5507, 0x133b04ec,   // gd.et.un_220 sk.lt.un_530  rw.cy.sw_432 fi.so.et_644
  0x686b3ba4, 0x3f031f0e, 0x1f1806a0, 0x642555af,   // so.ceb.ig_433 cy.nl.af_555  de.ga.cy_322 rw.eu.lg_655
  0x0a001112, 0x23131b13, 0x3f072aee, 0x060e1307,   // ro.mk.un_640 tr.et.ca_665  mt.it.af_422 et.is.de_432
  // [1680]
  0x6b6835a0, 0x18000b08, 0x6400280e, 0x06000704,   // zu.ig.ceb_322 es.ga.un_430  sw.lg.un_550 it.de.un_320
  0x100a21a0, 0x0d2a21a0, 0x082519ee, 0x0a5311af,   // jw.pt.lt_322 jw.mt.cs_322  gl.eu.no_422 ro.ht.pt_655
  0x551b3bee, 0x060c040c, 0x10000a05, 0x0e200dad,   // so.tr.rw_422 fi.sv.de_543  mk.be.un_330 cs.sq.is_643
  0x1f6828ad, 0x0600081a, 0x52003113, 0x06002a0c,   // sw.ig.cy_643 no.de.un_760  az.ha.un_650 mt.de.un_530
  // [1690]
  0x071710a0, 0x0a0e28a0, 0x08062aa0, 0x17005202,   // be.sr.bg_322 sw.is.pt_322  mt.de.no_322 ha.sr.un_220
  0x08191f0c, 0x1a006e07, 0x18001904, 0x0c002104,   // cy.gl.no_543 hmn.tl.un_420  gl.ga.un_320 jw.sv.un_320
  0x08020ca6, 0x3b520f12, 0x52551307, 0x190b0a5a,   // sv.da.no_521 lv.ha.so_654  et.rw.ha_432 pt.es.gl_553
  0x2a00041b, 0x106b030b, 0x100501a4, 0x071827ac,   // fi.mt.un_770 nl.ceb.lt_542  en.fr.lt_433 gd.ga.it_632
  // [16a0]
  0x1e1c3b05, 0x190b21a9, 0x53002804, 0x13000d02,   // so.id.ms_333 jw.es.gl_544  sw.ht.un_320 ne.bh.un_220
  0x11005505, 0x04000b05, 0x041108a4, 0x1f682a04,   // rw.ro.un_330 es.fi.un_330  uk.ro.ru_433 mt.ig.cy_332
  0x133f03a9, 0x101b0907, 0x13255504, 0x10170fa4,   // nl.af.et_544 pl.tr.lt_432  rw.eu.et_332 lv.sr.lt_433
  0x0f2155a7, 0x3217160c, 0x1c1b1ea7, 0x292d09a4,   // rw.jw.lv_532 hr.sr.bs_543  ms.tr.id_532 pl.sk.sl_433
  // [16b0]
  0x27251311, 0x21280fa7, 0x6b000413, 0x09001107,   // et.eu.gd_653 lv.sw.jw_532  fi.ceb.un_650 ro.pl.un_420
  0x32003b07, 0x1c1309ad, 0x17520f04, 0x1a046b0c,   // so.bs.un_420 hi.bh.mr_643  lv.ha.sr_332 ceb.fi.tl_543
  0x106b1a09, 0x012b35a7, 0x3f030202, 0x0d292d55,   // tl.ceb.lt_444 zu.vi.en_532  da.nl.af_222 sk.sl.cs_442
  0x553f0504, 0x35000c04, 0x01006404, 0x06080c09,   // fr.af.rw_332 sv.zu.un_320  lg.en.un_320 sv.no.de_444
  // [16c0]
  0x533f1aee, 0x100f32a0, 0x3132110c, 0x1f001214,   // tl.af.ht_422 bs.lv.lt_322  ro.bs.az_543 hu.cy.un_660
  0x132a23a4, 0x6b002112, 0x35002012, 0x12002908,   // ca.mt.et_433 jw.ceb.un_640  sq.zu.un_640 sl.hu.un_430
  0x3b521f07, 0x04354a0b, 0x3b000420, 0x11250512,   // cy.ha.so_432 yo.zu.fi_542  fi.so.un_850 fr.eu.ro_654
  0x08003f07, 0x64002112, 0x180827ad, 0x283f1aa4,   // af.no.un_420 jw.lg.un_640  gd.no.ga_643 tl.af.sw_433
  // [16d0]
  0x4a5564ad, 0x1c0913ac, 0x08020aa0, 0x090a2daf,   // lg.rw.yo_643 bh.hi.mr_632  pt.da.no_322 sk.pt.pl_655
  0x32290da6, 0x0c550704, 0x0b000104, 0x1c002908,   // cs.sl.bs_521 it.rw.sv_332  en.es.un_320 sl.id.un_430
  0x4a00520c, 0x1b002812, 0x4a3b1a0c, 0x07230105,   // ha.yo.un_530 sw.tr.un_640  tl.so.yo_543 en.ca.it_333
  0x190b01a0, 0x32172909, 0x64063fa6, 0x0e2155a4,   // en.es.gl_322 sl.sr.bs_444  af.de.lg_521 rw.jw.is_433
  // [16e0]
  0x27004a1a, 0x535231a7, 0x0a002a07, 0x175311ee,   // yo.gd.un_760 az.ha.ht_532  mt.pt.un_420 ro.ht.sr_422
  0x2900091a, 0x3b252702, 0x182728a6, 0x0c080607,   // pl.sl.un_760 gd.eu.so_222  sw.gd.ga_521 de.no.sv_432
  0x28356402, 0x1900230c, 0x0f1e2707, 0x281335ee,   // lg.zu.sw_222 ca.gl.un_530  gd.ms.lv_432 zu.et.sw_422
  0x10070a0e, 0x1c216404, 0x1e1c6bee, 0x0d00210d,   // mk.bg.be_555 lg.jw.id_332  ceb.id.ms_422 jw.cs.un_540
  // [16f0]
  0x00000901, 0x06132aa6, 0x131223a7, 0x0d2d0c04,   // hi.un.un_200 mt.et.de_521  ca.hu.et_532 sv.sk.cs_332
  0x10001104, 0x172104ee, 0x321709ec, 0x163211a9,   // ro.lt.un_320 fi.jw.sr_422  pl.sr.bs_644 ro.bs.hr_544
  0x13023f0c, 0x080e2aa6, 0x0a0e1255, 0x35002507,   // af.da.et_543 mt.is.no_521  hu.is.pt_442 eu.zu.un_420
  0x040108ad, 0x1c0d09a7, 0x0c4a53a9, 0x12190512,   // no.en.fi_643 hi.ne.mr_532  ht.yo.sv_544 fr.gl.hu_654
  // [1700]
  0x170a0812, 0x12532504, 0x100407af, 0x1b005304,   // uk.mk.sr_654 eu.ht.hu_332  bg.ru.be_655 ht.tr.un_320
  0x0c0413a9, 0x041327a0, 0x0d1c13a0, 0x32170fa0,   // et.fi.sv_544 gd.et.fi_322  bh.mr.ne_322 lv.sr.bs_322
  0x1300090b, 0x20002a0c, 0x09130407, 0x210631a0,   // hi.bh.un_520 mt.sq.un_530  fi.et.pl_432 az.de.jw_322
  0x13000c04, 0x18005212, 0x1b080305, 0x062704af,   // sv.et.un_320 ha.ga.un_640  nl.no.tr_333 fi.gd.de_655
  // [1710]
  0x13172902, 0x0b002805, 0x0b2d3107, 0x031f08a0,   // sl.sr.et_222 sw.es.un_330  az.sk.es_432 no.cy.nl_322
  0x08102004, 0x31001a02, 0x6400682a, 0x0e1f1209,   // sq.lt.no_332 tl.az.un_220  ig.lg.un_970 hu.cy.is_444
  0x1c6452a0, 0x1f001907, 0x1f0818ee, 0x1b005312,   // ha.lg.id_322 gl.cy.un_420  ga.no.cy_422 ht.tr.un_640
  0x1f1012af, 0x020c08a4, 0x04201305, 0x3f3b1fa4,   // hu.lt.cy_655 no.sv.da_433  et.sq.fi_333 cy.so.af_433
  // [1720]
  0x2a041205, 0x0b1905ee, 0x3b1e21a0, 0x0f000b07,   // hu.fi.mt_333 fr.gl.es_422  jw.ms.so_322 es.lv.un_420
  0x02001302, 0x4a3555ee, 0x2000280d, 0x080209ec,   // et.da.un_220 rw.zu.yo_422  sw.sq.un_540 pl.da.no_644
  0x2700110c, 0x04080205, 0x35006402, 0x20103fec,   // ro.gd.un_530 da.no.fi_333  lg.zu.un_220 af.lt.sq_644
  0x0d001907, 0x2d0d20a0, 0x170a0807, 0x01002807,   // gl.cs.un_420 sq.cs.sk_322  uk.mk.sr_432 sw.en.un_420
  // [1730]
  0x184a2b08, 0x171629a4, 0x28090455, 0x1c09130b,   // vi.yo.ga_443 sl.hr.sr_433  fi.pl.sw_442 bh.hi.mr_542
  0x021b0ea4, 0x091710a0, 0x0e1801ee, 0x01001804,   // is.tr.da_433 lt.sr.pl_322  en.ga.is_422 ga.en.un_320
  0x351b3b0c, 0x061e1bee, 0x201b10a0, 0x10001f0c,   // so.tr.zu_543 tr.ms.de_422  lt.tr.sq_322 cy.lt.un_530
  0x071711ee, 0x07100404, 0x35025511, 0x06002305,   // ro.sr.bg_422 fi.lt.it_332  rw.da.zu_653 ca.de.un_330
  // [1740]
  0x6e6b6804, 0x0400070c, 0x1f00120b, 0x64525505,   // ig.ceb.hmn_332 bg.ru.un_530  hu.cy.un_520 rw.ha.lg_333
  0x060e05ee, 0x2d2920ee, 0x101f25ad, 0x13001007,   // fr.is.de_422 sq.sl.sk_422  eu.cy.lt_643 lt.et.un_420
  0x64001f1a, 0x55283b04, 0x0c252a04, 0x13642805,   // cy.lg.un_760 so.sw.rw_332  mt.eu.sv_332 sw.lg.et_333
  0x1f0d31ee, 0x01002d04, 0x21000a07, 0x28001804,   // az.cs.cy_422 sk.en.un_320  pt.jw.un_420 ga.sw.un_320
  // [1750]
  0x3b270e02, 0x166b10ad, 0x080c130e, 0x31190a12,   // is.gd.so_222 lt.ceb.hr_643  et.sv.no_555 pt.gl.az_654
  0x0c011bee, 0x13314a04, 0x08025302, 0x020908ee,   // tr.en.sv_422 yo.az.et_332  ht.da.no_222 no.pl.da_422
  0x033f0709, 0x1e683504, 0x031f0dac, 0x352031a4,   // it.af.nl_444 zu.ig.ms_332  cs.cy.nl_632 az.sq.zu_433
  0x076b0a04, 0x10003f04, 0x23001f04, 0x3f6b1a0d,   // pt.ceb.it_332 af.lt.un_320  cy.ca.un_320 tl.ceb.af_554
  // [1760]
  0x28216813, 0x19050108, 0x13001b19, 0x3553310c,   // ig.jw.sw_665 en.fr.gl_443  tr.et.un_750 az.ht.zu_543
  0x2100030c, 0x122d18ee, 0x27000708, 0x53523507,   // nl.jw.un_530 ga.sk.hu_422  it.gd.un_430 zu.ha.ht_432
  0x11310704, 0x05033f0d, 0x6b00550d, 0x1c211e11,   // it.az.ro_332 af.nl.fr_554  rw.ceb.un_540 ms.jw.id_653
  0x06006b12, 0x09000308, 0x0f000308, 0x553564ad,   // ceb.de.un_640 nl.pl.un_430  nl.lv.un_430 lg.zu.rw_643
  // [1770]
  0x25000308, 0x52200a13, 0x16133fa0, 0x2a002012,   // nl.eu.un_430 pt.sq.ha_665  af.et.hr_322 sq.mt.un_640
  0x081309af, 0x13091c12, 0x042835ee, 0x553508a4,   // pl.et.no_655 mr.hi.bh_654  zu.sw.fi_422 no.zu.rw_433
  0x20000b04, 0x190910a0, 0x080f2d07, 0x13003f0d,   // es.sq.un_320 lt.pl.gl_322  sk.lv.no_432 af.et.un_540
  0x0f001b12, 0x3b000907, 0x11000702, 0x1c090d05,   // tr.lv.un_640 pl.so.un_420  it.ro.un_220 ne.hi.mr_333
  // [1780]
  0x1c0d13ec, 0x2300120d, 0x16093502, 0x0c030804,   // bh.ne.mr_644 hu.ca.un_540  zu.pl.hr_222 no.nl.sv_332
  0x03001f12, 0x1f0103a0, 0x061064a0, 0x18000b04,   // cy.nl.un_640 nl.en.cy_322  lg.lt.de_322 es.ga.un_320
  0x53680dec, 0x2d001019, 0x05000412, 0x3f1a2807,   // cs.ig.ht_644 lt.sk.un_750  fi.fr.un_640 sw.tl.af_432
  0x3f0c0fa0, 0x283b64ec, 0x3b003105, 0x17291007,   // lv.sv.af_322 lg.so.sw_644  az.so.un_330 lt.sl.sr_432
  // [1790]
  0x100904a6, 0x55002808, 0x3b212708, 0x2900550c,   // fi.pl.lt_521 sw.rw.un_430  gd.jw.so_443 rw.sl.un_530
  0x01212d07, 0x35006b08, 0x64000705, 0x4a250408,   // sk.jw.en_432 ceb.zu.un_430  it.lg.un_330 fi.eu.yo_443
  0x1a645502, 0x205528ee, 0x28003112, 0x0e002111,   // rw.lg.tl_222 sw.rw.sq_422  az.sw.un_640 jw.is.un_630
  0x0a286855, 0x096864ee, 0x12291307, 0x1125010c,   // ig.sw.pt_442 lg.ig.pl_422  et.sl.hu_432 en.eu.ro_543
  // [17a0]
  0x20000e02, 0x05120da0, 0x04003f0e, 0x190b2505,   // is.sq.un_220 cs.hu.fr_322  af.fi.un_550 eu.es.gl_333
  0x53055507, 0x21005202, 0x1e003b0e, 0x08020305,   // rw.fr.ht_432 ha.jw.un_220  so.ms.un_550 nl.da.no_333
  0x4a3f1b04, 0x3100030d, 0x35003b19, 0x18004a12,   // tr.af.yo_332 nl.az.un_540  so.zu.un_750 yo.ga.un_640
  0x6e000613, 0x04001702, 0x1b3111af, 0x1b1a530c,   // de.hmn.un_650 sr.ru.un_220  ro.az.tr_655 ht.tl.tr_543
  // [17b0]
  0x1b0405a7, 0x25002705, 0x03002019, 0x53001012,   // fr.fi.tr_532 gd.eu.un_330  sq.nl.un_750 lt.ht.un_640
  0x53101bad, 0x00002b06, 0x0a1108a4, 0x160c13ad,   // tr.lt.ht_643 vi.un.un_400  uk.ro.mk_433 et.sv.hr_643
  0x1f533fa0, 0x176813ee, 0x2d0d0e05, 0x1b000104,   // af.ht.cy_322 et.ig.sr_422  is.cs.sk_333 en.tr.un_320
  0x1b0131ee, 0x2b001f07, 0x0c0e0813, 0x3b00280c,   // az.en.tr_422 cy.vi.un_420  no.is.sv_665 sw.so.un_530
  // [17c0]
  0x0e6452a0, 0x3b1f53a0, 0x35005308, 0x1635030c,   // ha.lg.is_322 ht.cy.so_322  ht.zu.un_430 nl.zu.hr_543
  0x2a001e02, 0x1e005504, 0x3f0625a0, 0x17160aa0,   // ms.mt.un_220 rw.ms.un_320  eu.de.af_322 pt.hr.sr_322
  0x19000108, 0x53000309, 0x172d29a6, 0x03310fa0,   // en.gl.un_430 nl.ht.un_440  sl.sk.sr_521 lv.az.nl_322
  0x1e121b0c, 0x290d53a0, 0x051106a9, 0x05131b04,   // tr.hu.ms_543 ht.cs.sl_322  de.ro.fr_544 tr.et.fr_332
  // [17d0]
  0x0a530107, 0x18002512, 0x03271805, 0x080204ee,   // en.ht.pt_432 eu.ga.un_640  ga.gd.nl_333 fi.da.no_422
  0x080203ee, 0x12000412, 0x28041aa0, 0x2a001702,   // nl.da.no_422 fi.hu.un_640  tl.fi.sw_322 sr.mt.un_220
  0x19070a07, 0x1c2a21a0, 0x314a1b05, 0x071908a0,   // pt.it.gl_432 jw.mt.id_322  tr.yo.az_333 no.gl.it_322
  0x03003b0c, 0x070811ee, 0x2d2b0907, 0x28001c02,   // so.nl.un_530 ro.uk.bg_422  pl.vi.sk_432 id.sw.un_220
  // [17e0]
  0x031304a0, 0x0900120e, 0x0a0804a0, 0x0700040e,   // fi.et.nl_322 hu.pl.un_550  ru.uk.mk_322 ru.bg.un_550
  0x324a09a6, 0x0a1304a4, 0x09006e07, 0x64002a07,   // pl.yo.bs_521 fi.et.pt_433  hmn.pl.un_420 mt.lg.un_420
  0x0c001212, 0x20002904, 0x0e130cee, 0x1f003b08,   // hu.sv.un_640 sl.sq.un_320  sv.et.is_422 so.cy.un_430
  0x0c000a08, 0x1e005208, 0x6e002013, 0x0700170e,   // pt.sv.un_430 ha.ms.un_430  sq.hmn.un_650 sr.bg.un_550
  // [17f0]
  0x1c1321a0, 0x27162a0c, 0x0d1c095a, 0x0b0c13af,   // jw.et.id_322 mt.hr.gd_543  hi.mr.ne_553 et.sv.es_655
  0x06080302, 0x083f02a0, 0x016b2dad, 0x2a5303a7,   // nl.no.de_222 da.af.no_322  sk.ceb.en_643 nl.ht.mt_532
  0x55213512, 0x5321290c, 0x1c0d09ad, 0x190b0aec,   // zu.jw.rw_654 sl.jw.ht_543  hi.ne.mr_643 pt.es.gl_644
  0x64090eee, 0x02123fee, 0x0a000d13, 0x1e1c1a0c,   // is.pl.lg_422 af.hu.da_422  cs.pt.un_650 tl.id.ms_543

  // [1800]
  0x03060aa0, 0x1c002b05, 0x0e030807, 0x122d1304,   // pt.de.nl_322 vi.id.un_330  no.nl.is_432 et.sk.hu_332
  0x080235a4, 0x5500350c, 0x25000b02, 0x0403270b,   // zu.da.no_433 zu.rw.un_530  es.eu.un_220 gd.nl.fi_542
  0x5300081a, 0x64001a09, 0x0b01110c, 0x4a21100c,   // no.ht.un_760 tl.lg.un_440  ro.en.es_543 lt.jw.yo_543
  0x0c1925a7, 0x270b3bee, 0x10003202, 0x20002105,   // eu.gl.sv_532 so.es.gd_422  bs.lt.un_220 jw.sq.un_330
  // [1810]
  0x1200110e, 0x0b0a23ee, 0x02001704, 0x033f3b0c,   // ro.hu.un_550 ca.pt.es_422  sr.da.un_320 so.af.nl_543
  0x1f28520c, 0x3f001c02, 0x3f006b07, 0x2b002004,   // ha.sw.cy_543 id.af.un_220  ceb.af.un_420 sq.vi.un_320
  0x5200211a, 0x2a005202, 0x18001202, 0x201209ec,   // jw.ha.un_760 ha.mt.un_220  ur.ar.un_220 pl.hu.sq_644
  0x18000912, 0x531b55ee, 0x641b3102, 0x1e0a05a9,   // pl.ga.un_640 rw.tr.ht_422  az.tr.lg_222 fr.pt.ms_544
  // [1820]
  0x09083bac, 0x09002702, 0x033f0ea0, 0x093b2d0c,   // so.no.pl_632 gd.pl.un_220  is.af.nl_322 sk.so.pl_543
  0x0e080260, 0x2d0d180e, 0x04000702, 0x3f00110d,   // da.no.is_664 ga.cs.sk_555  it.fi.un_220 ro.af.un_540
  0x29131fa0, 0x0c1f1055, 0x1000230d, 0x04001b13,   // cy.et.sl_322 lt.cy.sv_442  ca.lt.un_540 tr.fi.un_650
  0x0a005202, 0x524a3ba0, 0x270f5507, 0x251c53ec,   // ha.pt.un_220 so.yo.ha_322  rw.lv.gd_432 ht.id.eu_644
  // [1830]
  0x4a005302, 0x0400020c, 0x130f2d07, 0x0a001e02,   // ht.yo.un_220 da.fi.un_530  sk.lv.et_432 ms.pt.un_220
  0x27002b0e, 0x0a001002, 0x296435ee, 0x06001a0b,   // vi.gd.un_550 be.mk.un_220  zu.lg.sl_422 tl.de.un_520
  0x12002711, 0x03353f05, 0x122d2007, 0x1b001602,   // gd.hu.un_630 af.zu.nl_333  sq.sk.hu_432 hr.tr.un_220
  0x04000911, 0x35135504, 0x35005304, 0x53003118,   // pl.fi.un_630 rw.et.zu_332  ht.zu.un_320 az.ht.un_740
  // [1840]
  0x2b001604, 0x25005512, 0x35252807, 0x35000108,   // hr.vi.un_320 rw.eu.un_640  sw.eu.zu_432 en.zu.un_430
  0x53001602, 0x3f000e13, 0x0b6452a0, 0x6b001e0d,   // hr.ht.un_220 is.af.un_650  ha.lg.es_322 ms.ceb.un_540
  0x06130c02, 0x123f1aa0, 0x5568250c, 0x2a1206ee,   // sv.et.de_222 tl.af.hu_322  eu.ig.rw_543 de.hu.mt_422
  0x06000818, 0x0c001a0c, 0x20000804, 0x6b1a28a0,   // no.de.un_740 tl.sv.un_530  no.sq.un_320 sw.tl.ceb_322
  // [1850]
  0x29000d04, 0x08001807, 0x05001907, 0x2000081a,   // cs.sl.un_320 ga.no.un_420  gl.fr.un_420 no.sq.un_760
  0x02090807, 0x192b1b07, 0x6800280e, 0x0f000b04,   // no.pl.da_432 tr.vi.gl_432  sw.ig.un_550 es.lv.un_320
  0x0d102d07, 0x23200aaf, 0x2a00680d, 0x0c0306a0,   // sk.lt.cs_432 pt.sq.ca_655  ig.mt.un_540 de.nl.sv_322
  0x0407100c, 0x06040307, 0x02042704, 0x00003524,   // be.bg.ru_543 nl.fi.de_432  gd.fi.da_332 zu.un.un_900
  // [1860]
  0x13640405, 0x20355205, 0x28355507, 0x310f55af,   // fi.lg.et_333 ha.zu.sq_333  rw.zu.sw_432 rw.lv.az_655
  0x28006807, 0x04001812, 0x1f000614, 0x35273b02,   // ig.sw.un_420 ga.fi.un_640  de.cy.un_660 so.gd.zu_222
  0x1208020d, 0x64352aaf, 0x2d001602, 0x016b05a9,   // da.no.hu_554 mt.zu.lg_655  hr.sk.un_220 fr.ceb.en_544
  0x12001007, 0x68003108, 0x10001605, 0x1a6b53af,   // lt.hu.un_420 az.ig.un_430  hr.lt.un_330 ht.ceb.tl_655
  // [1870]
  0x530f1005, 0x25001304, 0x3100200d, 0x033555ac,   // lt.lv.ht_333 et.eu.un_320  sq.az.un_540 rw.zu.nl_632
  0x2a350655, 0x090306a7, 0x08170414, 0x0f1113ad,   // de.zu.mt_442 de.nl.pl_532  ru.sr.uk_666 et.ro.lv_643
  0x112b0704, 0x050a1104, 0x160513a0, 0x0d110505,   // it.vi.ro_332 ro.pt.fr_332  et.fr.hr_322 fr.ro.cs_333
  0x11102307, 0x16002104, 0x311b35ee, 0x1b312a12,   // ca.lt.ro_432 jw.hr.un_320  zu.tr.az_422 mt.az.tr_654
  // [1880]
  0x25132107, 0x04000d12, 0x11000713, 0x64000919,   // jw.et.eu_432 cs.fi.un_640  it.ro.un_650 pl.lg.un_750
  0x1f120302, 0x212513af, 0x13006414, 0x200a230c,   // nl.hu.cy_222 et.eu.jw_655  lg.et.un_660 ca.pt.sq_543
  0x1b315502, 0x350413ee, 0x2d001907, 0x122305a0,   // rw.az.tr_222 et.fi.zu_422  gl.sk.un_420 fr.ca.hu_322
  0x13000d14, 0x20002305, 0x3b001a0c, 0x3f033b0d,   // ne.bh.un_660 ca.sq.un_330  tl.so.un_530 so.nl.af_554
  // [1890]
  0x23000507, 0x25355512, 0x0a0411a0, 0x6b000b04,   // fr.ca.un_420 rw.zu.eu_654  ro.ru.mk_322 es.ceb.un_320
  0x253528a7, 0x1c0d0908, 0x2b00050d, 0x211e3b04,   // sw.zu.eu_532 hi.ne.mr_443  fr.vi.un_540 so.ms.jw_332
  0x071318a9, 0x111255a6, 0x11001f0e, 0x53641211,   // ga.et.it_544 rw.hu.ro_521  cy.ro.un_550 hu.lg.ht_653
  0x231807a0, 0x4a006421, 0x4a5564a7, 0x32351b04,   // it.ga.ca_322 lg.yo.un_860  lg.rw.yo_532 tr.zu.bs_332
  // [18a0]
  0x321355a0, 0x55281a04, 0x18270660, 0x09000305,   // rw.et.bs_322 tl.sw.rw_332  de.gd.ga_664 nl.pl.un_330
  0x1e351c07, 0x3f0c02ee, 0x070410af, 0x281b55ec,   // id.zu.ms_432 da.sv.af_422  be.ru.bg_655 rw.tr.sw_644
  0x55000e07, 0x13020d0c, 0x10002712, 0x3f03010c,   // is.rw.un_420 cs.da.et_543  gd.lt.un_640 en.nl.af_543
  0x020c0812, 0x190b25a9, 0x090d050d, 0x01000d04,   // no.sv.da_654 eu.es.gl_544  fr.cs.pl_554 cs.en.un_320
  // [18b0]
  0x190a0d05, 0x08101fad, 0x311b11ac, 0x01001a02,   // cs.pt.gl_333 cy.lt.no_643  ro.tr.az_632 tl.en.un_220
  0x016b04ee, 0x352864ad, 0x131a3512, 0x4a1e0fa0,   // fi.ceb.en_422 lg.sw.zu_643  zu.tl.et_654 lv.ms.yo_322
  0x170713a0, 0x232520a0, 0x0f000607, 0x0f000108,   // et.it.sr_322 sq.eu.ca_322  de.lv.un_420 en.lv.un_430
  0x121b13a9, 0x080206a0, 0x3b350e07, 0x35002805,   // et.tr.hu_544 de.da.no_322  is.zu.so_432 sw.zu.un_330
  // [18c0]
  0x07000507, 0x06040e0c, 0x6b0401ee, 0x2d100d12,   // fr.it.un_420 is.fi.de_543  en.fi.ceb_422 cs.lt.sk_654
  0x0c1b0407, 0x061f2304, 0x27004a05, 0x08005302,   // fi.tr.sv_432 ca.cy.de_332  yo.gd.un_330 ht.no.un_220
  0x4a000504, 0x07002708, 0x353b55a9, 0x29321609,   // fr.yo.un_320 gd.it.un_430  rw.so.zu_544 hr.bs.sl_444
  0x19003b13, 0x07002a13, 0x073b1f04, 0x0000041c,   // so.gl.un_650 mt.it.un_650  cy.so.it_332 fi.un.un_800
  // [18d0]
  0x16002a07, 0x16002807, 0x313b1208, 0x071305a4,   // mt.hr.un_420 sw.hr.un_420  hu.so.az_443 fr.et.it_433
  0x35554aec, 0x0c001702, 0x53001a09, 0x21001108,   // yo.rw.zu_644 sr.sv.un_220  tl.ht.un_440 ro.jw.un_430
  0x12005219, 0x0c0304ee, 0x06000e05, 0x080c02a9,   // ha.hu.un_750 fi.nl.sv_422  is.de.un_330 da.sv.no_544
  0x0f002b0e, 0x0c311b12, 0x190b0aa4, 0x17001a04,   // vi.lv.un_550 tr.az.sv_654  pt.es.gl_433 tl.sr.un_320
  // [18e0]
  0x09000702, 0x29001a04, 0x641b5505, 0x4a1a6b08,   // it.pl.un_220 tl.sl.un_320  rw.tr.lg_333 ceb.tl.yo_443
  0x313b21a4, 0x3f005513, 0x03010602, 0x093f0f08,   // jw.so.az_433 rw.af.un_650  de.en.nl_222 lv.af.pl_443
  0x0c003f04, 0x08170712, 0x00002724, 0x6b000612,   // af.sv.un_320 bg.sr.uk_654  gd.un.un_900 de.ceb.un_640
  0x6b041fa7, 0x556828ad, 0x1b001213, 0x18280a0c,   // cy.fi.ceb_532 sw.ig.rw_643  hu.tr.un_650 pt.sw.ga_543
  // [18f0]
  0x1e1f1207, 0x53001e02, 0x32163f07, 0x100c0814,   // hu.cy.ms_432 ms.ht.un_220  af.hr.bs_432 no.sv.lt_666
  0x080c020c, 0x686b01a4, 0x0e001318, 0x17322055,   // da.sv.no_543 en.ceb.ig_433  et.is.un_740 sq.bs.sr_442
  0x1a130f07, 0x0a64040c, 0x0b643ba0, 0x10550504,   // lv.et.tl_432 fi.lg.pt_543  so.lg.es_322 fr.rw.lt_332
  0x6b1a5507, 0x051813a7, 0x04131012, 0x0e001214,   // rw.tl.ceb_432 et.ga.fr_532  lt.et.fi_654 hu.is.un_660
  // [1900]
  0x6e000413, 0x0e1001a4, 0x080e1002, 0x551c05ee,   // fi.hmn.un_650 en.lt.is_433  lt.is.no_222 fr.id.rw_422
  0x2d0d290c, 0x2d000704, 0x53130407, 0x25002d08,   // sl.cs.sk_543 it.sk.un_320  fi.et.ht_432 sk.eu.un_430
  0x06182d07, 0x21272807, 0x04000e0e, 0x322916a0,   // sk.ga.de_432 sw.gd.jw_432  is.fi.un_550 hr.sl.bs_322
  0x02080c5a, 0x11522807, 0x2d0d0ea9, 0x0200270c,   // sv.no.da_553 sw.ha.ro_432  is.cs.sk_544 gd.da.un_530
  // [1910]
  0x19250ba9, 0x1c000412, 0x21064a04, 0x04182804,   // es.eu.gl_544 fi.id.un_640  yo.de.jw_332 sw.ga.fi_332
  0x11081208, 0x2d090d07, 0x112055ee, 0x554a13ee,   // hu.no.ro_443 cs.pl.sk_432  rw.sq.ro_422 et.yo.rw_422
  0x311b2012, 0x02001819, 0x020608a6, 0x013527a0,   // sq.tr.az_654 ga.da.un_750  no.de.da_521 gd.zu.en_322
  0x13000d07, 0x1a003202, 0x1000251a, 0x0c050608,   // ne.bh.un_420 bs.tl.un_220  eu.lt.un_760 de.fr.sv_443
  // [1920]
  0x18272dad, 0x1f002d12, 0x0d001212, 0x351055ee,   // sk.gd.ga_643 sk.cy.un_640  hu.cs.un_640 rw.lt.zu_422
  0x1a6b3b60, 0x311b640c, 0x321827a9, 0x0c001a02,   // so.ceb.tl_664 lg.tr.az_543  gd.ga.bs_544 tl.sv.un_220
  0x181f2760, 0x1b003102, 0x130304a4, 0x08000319,   // gd.cy.ga_664 az.tr.un_220  fi.nl.et_433 nl.no.un_750
  0x3f00050e, 0x3f5505a0, 0x0a001213, 0x3f005312,   // fr.af.un_550 fr.rw.af_322  hu.pt.un_650 ht.af.un_640
  // [1930]
  0x64354aa4, 0x0705550c, 0x0a001120, 0x07111f02,   // yo.zu.lg_433 rw.fr.it_543  ro.mk.un_850 cy.ro.it_222
  0x4a1b2807, 0x0e001902, 0x6428520c, 0x23191fac,   // sw.tr.yo_432 gl.is.un_220  ha.sw.lg_543 cy.gl.ca_632
  0x35121307, 0x192b07a0, 0x1a002d08, 0x5300230d,   // et.hu.zu_432 it.vi.gl_322  sk.tl.un_430 ca.ht.un_540
  0x0c060412, 0x27001804, 0x18112707, 0x2d0d20a4,   // fi.de.sv_654 ga.gd.un_320  gd.ro.ga_432 sq.cs.sk_433
  // [1940]
  0x28292d07, 0x0d1f31a4, 0x53003513, 0x2b006809,   // sk.sl.sw_432 az.cy.cs_433  zu.ht.un_650 ig.vi.un_440
  0x160f2904, 0x2d0d12ee, 0x01001302, 0x0e000a04,   // sl.lv.hr_332 hu.cs.sk_422  et.en.un_220 pt.is.un_320
  0x04000e0c, 0x190a3ba0, 0x1a6e1f12, 0x20132aad,   // is.fi.un_530 so.pt.gl_322  cy.hmn.tl_654 mt.et.sq_643
  0x0c082a04, 0x21643108, 0x1716320c, 0x285304a4,   // mt.no.sv_332 az.lg.jw_443  bs.hr.sr_543 fi.ht.sw_433
  // [1950]
  0x1c1e3b07, 0x31000807, 0x100804a4, 0x11005302,   // so.ms.id_432 no.az.un_420  ru.uk.be_433 ht.ro.un_220
  0x05520aec, 0x2b000a07, 0x2a3b03a0, 0x211c0602,   // pt.ha.fr_644 pt.vi.un_420  nl.so.mt_322 de.id.jw_222
  0x28182a05, 0x062b0aa0, 0x551f520b, 0x3b6b3508,   // mt.ga.sw_333 pt.vi.de_322  ha.cy.rw_542 zu.ceb.so_443
  0x080c0207, 0x0e000207, 0x0500180c, 0x12000407,   // da.sv.no_432 da.is.un_420  ga.fr.un_530 fi.hu.un_420
  // [1960]
  0x270e1812, 0x131f6ba4, 0x0c003118, 0x21001a02,   // ga.is.gd_654 ceb.cy.et_433  az.sv.un_740 tl.jw.un_220
  0x29000e1a, 0x25006b0d, 0x1a280107, 0x3b132aa0,   // is.sl.un_760 ceb.eu.un_540  en.sw.tl_432 mt.et.so_322
  0x556b3b07, 0x1f00271a, 0x6428210c, 0x232507a7,   // so.ceb.rw_432 gd.cy.un_760  jw.sw.lg_543 it.eu.ca_532
  0x070511a4, 0x1b003202, 0x1c090d0c, 0x100b0f55,   // ro.fr.it_433 bs.tr.un_220  ne.hi.mr_543 lv.es.lt_442
  // [1970]
  0x020a0807, 0x08020ca9, 0x00000603, 0x55004a0c,   // no.pt.da_432 sv.da.no_544  de.un.un_300 yo.rw.un_530
  0x07003b05, 0x29125504, 0x320c13ee, 0x1c521eee,   // so.it.un_330 rw.hu.sl_332  et.sv.bs_422 ms.ha.id_422
  0x210b0507, 0x3f080ca0, 0x0a0d180c, 0x04133b11,   // fr.es.jw_432 sv.no.af_322  ga.cs.pt_543 so.et.fi_653
  0x0f000804, 0x3b00550d, 0x0700180d, 0x2155280d,   // no.lv.un_320 rw.so.un_540  ga.it.un_540 sw.rw.jw_554
  // [1980]
  0x4a0a050c, 0x18003f07, 0x07002108, 0x52355513,   // fr.pt.yo_543 af.ga.un_420  jw.it.un_430 rw.zu.ha_665
  0x0f2935af, 0x11552507, 0x2a313ba4, 0x0c000802,   // zu.sl.lv_655 eu.rw.ro_432  so.az.mt_433 no.sv.un_220
  0x53006b04, 0x1a006b02, 0x3b002707, 0x0c000a05,   // ceb.ht.un_320 ceb.tl.un_220  gd.so.un_420 pt.sv.un_330
  0x0a0810af, 0x4a295207, 0x10251111, 0x4a253104,   // be.uk.mk_655 ha.sl.yo_432  ro.eu.lt_653 az.eu.yo_332
  // [1990]
  0x21110807, 0x10080a12, 0x050429a0, 0x3f0510ee,   // no.ro.jw_432 mk.uk.be_654  sl.fi.fr_322 lt.fr.af_422
  0x3b6413a4, 0x043b1a08, 0x6b281e07, 0x55000704,   // et.lg.so_433 tl.so.fi_443  ms.sw.ceb_432 it.rw.un_320
  0x321617af, 0x256455a4, 0x2100100b, 0x19005204,   // sr.hr.bs_655 rw.lg.eu_433  lt.jw.un_520 ha.gl.un_320
  0x033f20ac, 0x1f000a0d, 0x121f050d, 0x1710110c,   // sq.af.nl_632 pt.cy.un_540  fr.cy.hu_554 ro.be.sr_543
  // [19a0]
  0x25283507, 0x25001907, 0x05002007, 0x290a0f04,   // zu.sw.eu_432 gl.eu.un_420  sq.fr.un_420 lv.pt.sl_332
  0x120a05a0, 0x643555af, 0x0200230e, 0x13090dad,   // fr.pt.hu_322 rw.zu.lg_655  ca.da.un_550 ne.hi.bh_643
  0x2100180e, 0x190c010b, 0x290916a4, 0x192025a0,   // ar.fa.un_550 en.sv.gl_542  hr.pl.sl_433 eu.sq.gl_322
  0x552528a0, 0x10080404, 0x04001304, 0x112307ee,   // sw.eu.rw_322 ru.uk.be_332  et.fi.un_320 it.ca.ro_422
  // [19b0]
  0x091c1308, 0x0d0311a4, 0x2d005204, 0x21132aa4,   // bh.mr.hi_443 ro.nl.cs_433  ha.sk.un_320 mt.et.jw_433
  0x1c121ea9, 0x0a001104, 0x0811100e, 0x1b00180e,   // ms.hu.id_544 ro.mk.un_320  be.ro.uk_555 ga.tr.un_550
  0x271f6402, 0x09642507, 0x031b06a0, 0x0813040e,   // lg.cy.gd_222 eu.lg.pl_432  de.tr.nl_322 fi.et.no_555
  0x21003f08, 0x010a1eee, 0x350c6ea7, 0x551225a9,   // af.jw.un_430 ms.pt.en_422  hmn.sv.zu_532 eu.hu.rw_544
  // [19c0]
  0x0c13230c, 0x08000407, 0x32162aa4, 0x171610a4,   // ca.et.sv_543 ru.uk.un_420  mt.hr.bs_433 lt.hr.sr_433
  0x0d32160d, 0x00001b06, 0x535564a0, 0x552035ac,   // hr.bs.cs_554 tr.un.un_400  lg.rw.ht_322 zu.sq.rw_632
  0x2d00250c, 0x0f103104, 0x310e3b55, 0x3f031307,   // eu.sk.un_530 az.lt.lv_332  so.is.az_442 et.nl.af_432
  0x2d0d640c, 0x2500180d, 0x3f270407, 0x033f020d,   // lg.cs.sk_543 ga.eu.un_540  fi.gd.af_432 da.af.nl_554
  // [19d0]
  0x3b002705, 0x10002704, 0x18000702, 0x0e000612,   // gd.so.un_330 gd.lt.un_320  it.ga.un_220 de.is.un_640
  0x25101fec, 0x280a070c, 0x2d041205, 0x6b006407,   // cy.lt.eu_644 it.pt.sw_543  hu.fi.sk_333 lg.ceb.un_420
  0x53355555, 0x06002012, 0x230504ee, 0x12001c02,   // rw.zu.ht_442 sq.de.un_640  fi.fr.ca_422 id.hu.un_220
  0x08002702, 0x1f001a02, 0x1c3f030c, 0x55352812,   // gd.no.un_220 tl.cy.un_220  nl.af.id_543 sw.zu.rw_654
  // [19e0]
  0x1218270c, 0x19002508, 0x03080604, 0x0a2b0ca0,   // gd.ga.hu_543 eu.gl.un_430  de.no.nl_332 sv.vi.pt_322
  0x0d005308, 0x27000812, 0x6b1a1c07, 0x1e1f1012,   // ht.cs.un_430 no.gd.un_640  id.tl.ceb_432 lt.cy.ms_654
  0x20006b04, 0x55006421, 0x1f002702, 0x12000304,   // ceb.sq.un_320 lg.rw.un_860  gd.cy.un_220 nl.hu.un_320
  0x0b0a0605, 0x080711ad, 0x35646807, 0x19002d07,   // de.pt.es_333 ro.bg.uk_643  ig.lg.zu_432 sk.gl.un_420
  // [19f0]
  0x1a5564a0, 0x3f3b0307, 0x55001c02, 0x1c002304,   // lg.rw.tl_322 nl.so.af_432  id.rw.un_220 ca.id.un_320
  0x2d0d2909, 0x211c0aa0, 0x1e1c520c, 0x35000707,   // sl.cs.sk_444 pt.id.jw_322  ha.id.ms_543 it.zu.un_420
  0x080c05a0, 0x0e001812, 0x131f01ad, 0x3f1f0955,   // fr.sv.no_322 ga.is.un_640  en.cy.et_643 pl.cy.af_442
  0x55006412, 0x25001e02, 0x020c080c, 0x21003505,   // lg.rw.un_640 ms.eu.un_220  no.sv.da_543 zu.jw.un_330
  // [1a00]
  0x1a350807, 0x03000813, 0x03002504, 0x08022305,   // no.zu.tl_432 no.nl.un_650  eu.nl.un_320 ca.da.no_333
  0x0d1c09ac, 0x210555a0, 0x53000414, 0x0f3f5509,   // hi.mr.ne_632 rw.fr.jw_322  fi.ht.un_660 rw.af.lv_444
  0x0d292da4, 0x1e1c20a9, 0x25000705, 0x01352da0,   // sk.sl.cs_433 sq.id.ms_544  it.eu.un_330 sk.zu.en_322
  0x21231702, 0x3f000413, 0x2a00030b, 0x02071fee,   // sr.ca.jw_222 fi.af.un_650  nl.mt.un_520 cy.it.da_422
  // [1a10]
  0x070a05ee, 0x07001a04, 0x3b002804, 0x1c090d0d,   // fr.pt.it_422 tl.it.un_320  sw.so.un_320 ne.hi.mr_554
  0x29005302, 0x52103b04, 0x19002813, 0x0c1810a6,   // ht.sl.un_220 so.lt.ha_332  sw.gl.un_650 lt.ga.sv_521
  0x64006807, 0x3f000505, 0x04111007, 0x28001305,   // ig.lg.un_420 fr.af.un_330  be.ro.ru_432 et.sw.un_330
  0x0c2128ee, 0x182827a7, 0x12000a02, 0x1f645212,   // sw.jw.sv_422 gd.sw.ga_532  pt.hu.un_220 ha.lg.cy_654
  // [1a20]
  0x1f212509, 0x033f0605, 0x4a001213, 0x645568ee,   // eu.jw.cy_444 de.af.nl_333  hu.yo.un_650 ig.rw.lg_422
  0x20291304, 0x2b001a02, 0x3f125302, 0x280c200c,   // et.sl.sq_332 tl.vi.un_220  ht.hu.af_222 sq.sv.sw_543
  0x16000104, 0x12320d07, 0x04276404, 0x1a005304,   // en.hr.un_320 cs.bs.hu_432  lg.gd.fi_332 ht.tl.un_320
  0x13001b0e, 0x07001f0e, 0x3200290c, 0x08001f07,   // tr.et.un_550 cy.it.un_550  sl.bs.un_530 cy.no.un_420
  // [1a30]
  0x521e11a0, 0x2a00280c, 0x230c55a0, 0x3b030407,   // ro.ms.ha_322 sw.mt.un_530  rw.sv.ca_322 fi.nl.so_432
  0x2a2507af, 0x04003b0d, 0x0200050d, 0x1f002012,   // it.eu.mt_655 so.fi.un_540  fr.da.un_540 sq.cy.un_640
  0x062701ad, 0x0e040fa0, 0x03310208, 0x180205a0,   // en.gd.de_643 lv.fi.is_322  da.az.nl_443 fr.da.ga_322
  0x10000607, 0x25003f04, 0x3f0802ee, 0x2d0d1302,   // de.lt.un_420 af.eu.un_320  da.no.af_422 et.cs.sk_222
  // [1a40]
  0x292d1702, 0x0b0a0702, 0x08020c05, 0x10004a04,   // sr.sk.sl_222 it.pt.es_222  sv.da.no_333 yo.lt.un_320
  0x0f10050b, 0x101b13ee, 0x3f023b02, 0x1100250d,   // fr.lt.lv_542 et.tr.lt_422  so.da.af_222 eu.ro.un_540
  0x050110ee, 0x071911a0, 0x53253504, 0x0d003b04,   // lt.en.fr_422 ro.gl.it_322  zu.eu.ht_332 so.cs.un_320
  0x09030107, 0x12211008, 0x0e2910ee, 0x1e000f07,   // en.nl.pl_432 lt.jw.hu_443  lt.sl.is_422 lv.ms.un_420
  // [1a50]
  0x17000205, 0x0c1304a4, 0x3f03130e, 0x12000804,   // da.sr.un_330 fi.et.sv_433  et.nl.af_555 no.hu.un_320
  0x130f10a4, 0x0f002312, 0x1c090d09, 0x07170812,   // lt.lv.et_433 ca.lv.un_640  ne.hi.mr_444 uk.sr.bg_654
  0x64001a02, 0x55642804, 0x090d1ca0, 0x29101602,   // tl.lg.un_220 sw.lg.rw_332  mr.ne.hi_322 hr.lt.sl_222
  0x522a0607, 0x061b08af, 0x31005204, 0x27002d13,   // de.mt.ha_432 no.tr.de_655  ha.az.un_320 sk.gd.un_650
  // [1a60]
  0x31290fec, 0x190b2305, 0x250f1007, 0x10042807,   // lv.sl.az_644 ca.es.gl_333  lt.lv.eu_432 sw.fi.lt_432
  0x11000b02, 0x2b001e02, 0x110509ee, 0x64001704,   // es.ro.un_220 ms.vi.un_220  pl.fr.ro_422 sr.lg.un_320
  0x0e5308a0, 0x1e1c0ca0, 0x232a1355, 0x68526407,   // no.ht.is_322 sv.id.ms_322  et.mt.ca_442 lg.ha.ig_432
  0x192312a7, 0x272018ad, 0x0f130e12, 0x25000808,   // hu.ca.gl_532 ga.sq.gd_643  is.et.lv_654 no.eu.un_430
  // [1a70]
  0x2a000419, 0x02003512, 0x120429a0, 0x5229280e,   // fi.mt.un_750 zu.da.un_640  sl.fi.hu_322 sw.sl.ha_555
  0x13000b02, 0x0b072d5a, 0x0c001605, 0x190a23a0,   // es.et.un_220 sk.it.es_553  hr.sv.un_330 ca.pt.gl_322
  0x01000302, 0x2500230b, 0x11552804, 0x3217280c,   // nl.en.un_220 ca.eu.un_520  sw.rw.ro_332 sw.sr.bs_543
  0x02001209, 0x121a28a0, 0x190a230c, 0x250929ee,   // hu.da.un_440 sw.tl.hu_322  ca.pt.gl_543 sl.pl.eu_422
  // [1a80]
  0x201f0304, 0x130e28a4, 0x53000e0b, 0x00000103,   // nl.cy.sq_332 sw.is.et_433  is.ht.un_520 en.un.un_300
  0x2700100d, 0x350e2814, 0x1a280705, 0x170c5302,   // lt.gd.un_540 sw.is.zu_666  it.sw.tl_333 ht.sv.sr_222
  0x6b000508, 0x1f1a6bad, 0x10133fec, 0x6b003f0d,   // fr.ceb.un_430 ceb.tl.cy_643  af.et.lt_644 af.ceb.un_540
  0x190b2dee, 0x0a006e07, 0x03001105, 0x2d0d0a09,   // sk.es.gl_422 hmn.pt.un_420  ro.nl.un_330 pt.cs.sk_444
  // [1a90]
  0x12292307, 0x0d131c08, 0x32170da0, 0x0c002704,   // ca.sl.hu_432 mr.bh.ne_443  cs.sr.bs_322 gd.sv.un_320
  0x0f350d55, 0x016b3ba0, 0x27090107, 0x09002d04,   // cs.zu.lv_442 so.ceb.en_322  en.pl.gd_432 sk.pl.un_320
  0x0508210c, 0x18000a02, 0x134a35a0, 0x0e080ca0,   // jw.no.fr_543 pt.ga.un_220  zu.yo.et_322 sv.no.is_322
  0x0e121ba9, 0x03280f0b, 0x29162d5a, 0x4a1a5505,   // tr.hu.is_544 lv.sw.nl_542  sk.hr.sl_553 rw.tl.yo_333
  // [1aa0]
  0x2d0d29ee, 0x13000604, 0x6b006809, 0x08000a12,   // sl.cs.sk_422 de.et.un_320  ig.ceb.un_440 mk.uk.un_640
  0x1b000c13, 0x1c3521ad, 0x040625ac, 0x3b003508,   // sv.tr.un_650 jw.zu.id_643  eu.de.fi_632 zu.so.un_430
  0x2d0d050e, 0x09000809, 0x17003504, 0x6b0820ee,   // fr.cs.sk_555 no.pl.un_440  zu.sr.un_320 sq.no.ceb_422
  0x08001a0d, 0x64002804, 0x4a522908, 0x2a005212,   // tl.no.un_540 sw.lg.un_320  sl.ha.yo_443 ha.mt.un_640
  // [1ab0]
  0x16003502, 0x023106a0, 0x190b1ba0, 0x12000613,   // zu.hr.un_220 de.az.da_322  tr.es.gl_322 de.hu.un_650
  0x1b000414, 0x29161309, 0x0c002302, 0x100d2812,   // fi.tr.un_660 et.hr.sl_444  ca.sv.un_220 sw.cs.lt_654
  0x100e1fee, 0x18000709, 0x01000b02, 0x1100130c,   // cy.is.lt_422 it.ga.un_440  es.en.un_220 et.ro.un_530
  0x0c1308a7, 0x07001207, 0x0d2911af, 0x55002013,   // no.et.sv_532 hu.it.un_420  ro.sl.cs_655 sq.rw.un_650
  // [1ac0]
  0x3f003b13, 0x00001e0f, 0x070804ad, 0x133552ad,   // so.af.un_650 ms.un.un_600  ru.uk.bg_643 ha.zu.et_643
  0x0d130960, 0x2a006404, 0x16000404, 0x55000611,   // hi.bh.ne_664 lg.mt.un_320  fi.hr.un_320 de.rw.un_630
  0x35280604, 0x0e000604, 0x080217a0, 0x18000d13,   // de.sw.zu_332 de.is.un_320  sr.da.no_322 cs.ga.un_650
  0x553f0604, 0x0a005207, 0x11051b11, 0x1e1c04ee,   // de.af.rw_332 ha.pt.un_420  tr.fr.ro_653 fi.id.ms_422
  // [1ad0]
  0x1f002304, 0x20060ea0, 0x05291111, 0x3100180e,   // ca.cy.un_320 is.de.sq_322  ro.sl.fr_653 ga.az.un_550
  0x0e2708af, 0x313b1807, 0x17000304, 0x321710ee,   // no.gd.is_655 ga.so.az_432  nl.sr.un_320 lt.sr.bs_422
  0x130d0960, 0x20082aa0, 0x4a006809, 0x1e552aa0,   // hi.ne.bh_664 mt.no.sq_322  ig.yo.un_440 mt.rw.ms_322
  0x1f1302a0, 0x03001112, 0x2a006b04, 0x292a0713,   // da.et.cy_322 ro.nl.un_640  ceb.mt.un_320 it.mt.sl_665
  // [1ae0]
  0x25210604, 0x131108a4, 0x20030807, 0x04033fa6,   // de.jw.eu_332 no.ro.et_433  no.nl.sq_432 af.nl.fi_521
  0x011f3fa0, 0x6b183b05, 0x28003b04, 0x1f000919,   // af.cy.en_322 so.ga.ceb_333  so.sw.un_320 pl.cy.un_750
  0x550e3504, 0x070c0407, 0x35000e05, 0x13002818,   // zu.is.rw_332 fi.sv.it_432  is.zu.un_330 sw.et.un_740
  0x074a53a0, 0x21006412, 0x2d000912, 0x17000d04,   // ht.yo.it_322 lg.jw.un_640  pl.sk.un_640 cs.sr.un_320
  // [1af0]
  0x281f20ee, 0x1000070e, 0x6e6b13ec, 0x2a6b280c,   // sq.cy.sw_422 bg.be.un_550  et.ceb.hmn_644 sw.ceb.mt_543
  0x524a6b04, 0x0c060e0e, 0x1b002d14, 0x1e1b0fa0,   // ceb.yo.ha_332 is.de.sv_555  sk.tr.un_660 lv.tr.ms_322
  0x31061b0e, 0x20001702, 0x09100207, 0x130e2508,   // tr.de.az_555 sr.sq.un_220  da.lt.pl_432 eu.is.et_443
  0x31002118, 0x32281609, 0x281c1eee, 0x0a190b55,   // jw.az.un_740 hr.sw.bs_444  ms.id.sw_422 es.gl.pt_442
  // [1b00]
  0x6b252aad, 0x070a17ac, 0x0e6435ad, 0x21202507,   // mt.eu.ceb_643 sr.mk.bg_632  zu.lg.is_643 eu.sq.jw_432
  0x0f2d3f13, 0x031f01ec, 0x1800050e, 0x09000607,   // af.sk.lv_665 en.cy.nl_644  fr.ga.un_550 de.pl.un_420
  0x1300011a, 0x08002a02, 0x0c005504, 0x181364a0,   // en.et.un_760 mt.no.un_220  rw.sv.un_320 lg.et.ga_322
  0x182768a0, 0x1c002a0d, 0x08020e05, 0x191f28ee,   // ig.gd.ga_322 mt.id.un_540  is.da.no_333 sw.cy.gl_422
  // [1b10]
  0x01230f0d, 0x171108a4, 0x03003b04, 0x10006407,   // lv.ca.en_554 uk.ro.sr_433  so.nl.un_320 lg.lt.un_420
  0x1b002105, 0x3f03060e, 0x1e1c5505, 0x3b006b18,   // jw.tr.un_330 de.nl.af_555  rw.id.ms_333 ceb.so.un_740
  0x2112180c, 0x5328090c, 0x1701080b, 0x20095504,   // ar.ur.fa_543 pl.sw.ht_543  no.en.sr_542 rw.pl.sq_332
  0x04003512, 0x3f00011a, 0x12000302, 0x1c1e2112,   // zu.fi.un_640 en.af.un_760  nl.hu.un_220 jw.ms.id_654
  // [1b20]
  0x1b001a07, 0x0f005204, 0x080205ee, 0x041c1eee,   // tl.tr.un_420 ha.lv.un_320  fr.da.no_422 ms.id.fi_422
  0x55641105, 0x060910ad, 0x4a002112, 0x3f1807a0,   // ro.lg.rw_333 lt.pl.de_643  jw.yo.un_640 it.ga.af_322
  0x01001104, 0x1c0b27ee, 0x285535a0, 0x0f100c0b,   // ro.en.un_320 gd.es.id_422  zu.rw.sw_322 sv.lt.lv_542
  0x131c0912, 0x282535a7, 0x13090dac, 0x23001314,   // hi.mr.bh_654 zu.eu.sw_532  ne.hi.bh_632 et.ca.un_660
  // [1b30]
  0x016435ad, 0x1b005302, 0x3b0955ee, 0x3b1a1ba0,   // zu.lg.en_643 ht.tr.un_220  rw.pl.so_422 tr.tl.so_322
  0x13003b0e, 0x5568640d, 0x10005204, 0x55210802,   // so.et.un_550 lg.ig.rw_554  ha.lt.un_320 no.jw.rw_222
  0x0d001e04, 0x0809040c, 0x6b000705, 0x23250107,   // ms.cs.un_320 fi.pl.no_543  it.ceb.un_330 en.eu.ca_432
  0x131c09ac, 0x00000e01, 0x08130e11, 0x1a002807,   // hi.mr.bh_632 is.un.un_200  is.et.no_653 sw.tl.un_420
  // [1b40]
  0x1c351e07, 0x282129ec, 0x4a291212, 0x0f001008,   // ms.zu.id_432 sl.jw.sw_644  hu.sl.yo_654 lt.lv.un_430
  0x0a23350c, 0x1300640e, 0x191711ee, 0x070a11af,   // zu.ca.pt_543 lg.et.un_550  ro.sr.gl_422 ro.mk.bg_655
  0x170d1607, 0x1c130d08, 0x130e0f12, 0x03233f04,   // hr.cs.sr_432 ne.bh.mr_443  lv.is.et_654 af.ca.nl_332
  0x0b000702, 0x05001807, 0x1c121aa6, 0x05530d12,   // it.es.un_220 ga.fr.un_420  tl.hu.id_521 cs.ht.fr_654
  // [1b50]
  0x1a00550e, 0x18000e13, 0x0c5564ac, 0x121a6ba9,   // rw.tl.un_550 is.ga.un_650  lg.rw.sv_632 ceb.tl.hu_544
  0x11005519, 0x35645313, 0x0f28130d, 0x254a2a08,   // rw.ro.un_750 ht.lg.zu_665  et.sw.lv_554 mt.yo.eu_443
  0x020804ad, 0x053f23a4, 0x1c130913, 0x1f006b04,   // fi.no.da_643 ca.af.fr_433  hi.bh.mr_665 ceb.cy.un_320
  0x643507a0, 0x1b311307, 0x2a00230c, 0x0c3564ee,   // it.zu.lg_322 et.az.tr_432  ca.mt.un_530 lg.zu.sv_422
  // [1b60]
  0x2a0609ac, 0x3f001f12, 0x0b0a11a9, 0x28645512,   // pl.de.mt_632 cy.af.un_640  ro.pt.es_544 rw.lg.sw_654
  0x0f1032a0, 0x0a180707, 0x6b012ba4, 0x55002104,   // bs.lt.lv_322 it.ga.pt_432  vi.en.ceb_433 jw.rw.un_320
  0x05001b12, 0x180413ee, 0x53002521, 0x0300020e,   // tr.fr.un_640 et.fi.ga_422  eu.ht.un_860 da.nl.un_550
  0x09013fee, 0x4a686b07, 0x01000f05, 0x32101307,   // af.en.pl_422 ceb.ig.yo_432  lv.en.un_330 et.lt.bs_432
  // [1b70]
  0x023b3f5a, 0x1b133113, 0x03022d07, 0x0b0a11ee,   // af.so.da_553 az.et.tr_665  sk.da.nl_432 ro.pt.es_422
  0x133b0607, 0x536e05a0, 0x10001602, 0x200725a0,   // de.so.et_432 fr.hmn.ht_322  hr.lt.un_220 eu.it.sq_322
  0x11002704, 0x01002812, 0x133127ee, 0x13522807,   // gd.ro.un_320 sw.en.un_640  gd.az.et_422 sw.ha.et_432
  0x06000504, 0x3b0b28a9, 0x0a0417ec, 0x19120aa6,   // fr.de.un_320 sw.es.so_544  sr.ru.mk_644 pt.hu.gl_521
  // [1b80]
  0x13090d5a, 0x531b28af, 0x12001e0d, 0x0000160f,   // ne.hi.bh_553 sw.tr.ht_655  ms.hu.un_540 hr.un.un_600
  0x016b18a0, 0x00001824, 0x07001c04, 0x081110a4,   // ga.ceb.en_322 ar.un.un_900  id.it.un_320 be.ro.uk_433
  0x1c211e0c, 0x2b001f19, 0x00000406, 0x4a001a14,   // ms.jw.id_543 cy.vi.un_750  fi.un.un_400 tl.yo.un_660
  0x28352702, 0x17000407, 0x1a4a25a7, 0x20001a02,   // gd.zu.sw_222 ru.sr.un_420  eu.yo.tl_532 tl.sq.un_220
  // [1b90]
  0x0c1b31a0, 0x211120a7, 0x1c2120ad, 0x20102aee,   // az.tr.sv_322 sq.ro.jw_532  sq.jw.id_643 mt.lt.sq_422
  0x2500280d, 0x28002507, 0x230a07ee, 0x0e202b05,   // sw.eu.un_540 eu.sw.un_420  it.pt.ca_422 vi.sq.is_333
  0x0a001f04, 0x082103a0, 0x20002102, 0x00006803,   // cy.pt.un_320 nl.jw.no_322  jw.sq.un_220 ig.un.un_300
  0x2d000302, 0x0d130912, 0x0e085202, 0x2300011a,   // nl.sk.un_220 hi.bh.ne_654  ha.no.is_222 en.ca.un_760
  // [1ba0]
  0x096813a0, 0x232701ad, 0x092d3b12, 0x23030108,   // et.ig.pl_322 en.gd.ca_643  so.sk.pl_654 en.nl.ca_443
  0x19000c04, 0x23271fee, 0x20002a08, 0x01212302,   // sv.gl.un_320 cy.gd.ca_422  mt.sq.un_430 ca.jw.en_222
  0x684a28a0, 0x1b64310e, 0x05000613, 0x28003b13,   // sw.yo.ig_322 az.lg.tr_555  de.fr.un_650 so.sw.un_650
  0x35312aa0, 0x13000508, 0x28251f02, 0x32553502,   // mt.az.zu_322 fr.et.un_430  cy.eu.sw_222 zu.rw.bs_222
  // [1bb0]
  0x0e000c02, 0x211e1cad, 0x05233faf, 0x29003f08,   // sv.is.un_220 id.ms.jw_643  af.ca.fr_655 af.sl.un_430
  0x130823af, 0x0c060808, 0x080210a4, 0x1b002102,   // ca.no.et_655 no.de.sv_443  lt.da.no_433 jw.tr.un_220
  0x1c2105a9, 0x080213ee, 0x0d001104, 0x08120607,   // fr.jw.id_544 et.da.no_422  ro.cs.un_320 de.hu.no_432
  0x3b2052ee, 0x55000502, 0x20000f12, 0x01000a04,   // ha.sq.so_422 fr.rw.un_220  lv.sq.un_640 pt.en.un_320
  // [1bc0]
  0x2d0d1f07, 0x072a0aa4, 0x1b2b0b09, 0x13001a02,   // cy.cs.sk_432 pt.mt.it_433  es.vi.tr_444 tl.et.un_220
  0x1c0d09ee, 0x0c6b64a0, 0x1011080c, 0x081b0507,   // hi.ne.mr_422 lg.ceb.sv_322  no.ro.lt_543 fr.tr.no_432
  0x2d000e0d, 0x01001c04, 0x64051fee, 0x3b0519a0,   // is.sk.un_540 id.en.un_320  cy.fr.lg_422 gl.fr.so_322
  0x010c20a7, 0x1c002a02, 0x3f021fa9, 0x03000e04,   // sq.sv.en_532 mt.id.un_220  cy.da.af_544 is.nl.un_320
  // [1bd0]
  0x031a3f04, 0x3f002005, 0x233f13ee, 0x0a00230c,   // af.tl.nl_332 sq.af.un_330  et.af.ca_422 ca.pt.un_530
  0x282135ec, 0x2b535507, 0x2800640e, 0x35003b12,   // zu.jw.sw_644 rw.ht.vi_432  lg.sw.un_550 so.zu.un_640
  0x1732160d, 0x2d003207, 0x3f035205, 0x0e001a02,   // hr.bs.sr_554 bs.sk.un_420  ha.nl.af_333 tl.is.un_220
  0x21002502, 0x0c133fa0, 0x354a1ca0, 0x070a0813,   // eu.jw.un_220 af.et.sv_322  id.yo.zu_322 uk.mk.bg_665
  // [1be0]
  0x322a17a0, 0x1b5225ad, 0x20005302, 0x062a08ec,   // sr.mt.bs_322 eu.ha.tr_643  ht.sq.un_220 no.mt.de_644
  0x3b2008ee, 0x6400210e, 0x0d162d0c, 0x521a6bad,   // no.sq.so_422 jw.lg.un_550  sk.hr.cs_543 ceb.tl.ha_643
  0x03001604, 0x06002808, 0x12001b05, 0x060c0813,   // hr.nl.un_320 sw.de.un_430  tr.hu.un_330 no.sv.de_665
  0x293f2d05, 0x21000307, 0x1f006414, 0x16296eee,   // sk.af.sl_333 nl.jw.un_420  lg.cy.un_660 hmn.sl.hr_422
  // [1bf0]
  0x210b02a0, 0x53000702, 0x13072da7, 0x1a6b52ec,   // da.es.jw_322 it.ht.un_220  sk.it.et_532 ha.ceb.tl_644
  0x03021f04, 0x04002904, 0x080c2aa9, 0x64551a0c,   // cy.da.nl_332 sl.fi.un_320  mt.sv.no_544 tl.rw.lg_543
  0x4a520c07, 0x55002914, 0x062009a4, 0x190a1214,   // sv.ha.yo_432 sl.rw.un_660  pl.sq.de_433 hu.pt.gl_666
  0x2100270b, 0x321e5309, 0x351255a0, 0x1c090d08,   // gd.jw.un_520 ht.ms.bs_444  rw.hu.zu_322 ne.hi.mr_443

  // [1c00]
  0x52004a02, 0x3500131a, 0x554a2904, 0x28000408,   // yo.ha.un_220 et.zu.un_760  sl.yo.rw_332 fi.sw.un_430
  0x171606a0, 0x1c091312, 0x125320ad, 0x08021205,   // de.hr.sr_322 bh.hi.mr_654  sq.ht.hu_643 hu.da.no_333
  0x55355213, 0x201605a0, 0x4a00290e, 0x20004a0d,   // ha.zu.rw_665 fr.hr.sq_322  sl.yo.un_550 yo.sq.un_540
  0x29005313, 0x20113502, 0x0c1a120c, 0x170b29a0,   // ht.sl.un_650 zu.ro.sq_222  hu.tl.sv_543 sl.es.sr_322
  // [1c10]
  0x3b31270d, 0x1e1c28a0, 0x64000808, 0x290f1104,   // gd.az.so_554 sw.id.ms_322  no.lg.un_430 ro.lv.sl_332
  0x08642711, 0x0718270c, 0x0d000e11, 0x1329040c,   // gd.lg.no_653 gd.ga.it_543  is.cs.un_630 fi.sl.et_543
  0x12090804, 0x101f180c, 0x08021fee, 0x321653ee,   // no.pl.hu_332 ga.cy.lt_543  cy.da.no_422 ht.hr.bs_422
  0x29000a12, 0x01000607, 0x01002302, 0x1f012bee,   // pt.sl.un_640 de.en.un_420  ca.en.un_220 vi.en.cy_422
  // [1c20]
  0x16290908, 0x0f005214, 0x13002007, 0x01072302,   // pl.sl.hr_443 ha.lv.un_660  sq.et.un_420 ca.it.en_222
  0x19001818, 0x135535ee, 0x20001e02, 0x3b001309,   // ga.gl.un_740 zu.rw.et_422  ms.sq.un_220 et.so.un_440
  0x12211ca0, 0x2d0d3202, 0x03080ca0, 0x1c3216a0,   // id.jw.hu_322 bs.cs.sk_222  sv.no.nl_322 hr.bs.id_322
  0x1a3b28ee, 0x016b09ee, 0x11001013, 0x3f030107,   // sw.so.tl_422 pl.ceb.en_422  be.ro.un_650 en.nl.af_432
  // [1c30]
  0x18002309, 0x200e18ee, 0x10000c07, 0x12006e08,   // ca.ga.un_440 ga.is.sq_422  sv.lt.un_420 hmn.hu.un_430
  0x042d0faf, 0x1000171a, 0x28001e0d, 0x091c1355,   // lv.sk.fi_655 sr.be.un_760  ms.sw.un_540 bh.mr.hi_442
  0x11201804, 0x68002013, 0x02080c04, 0x290d2aa0,   // ga.sq.ro_332 sq.ig.un_650  sv.no.da_332 mt.cs.sl_322
  0x2a000919, 0x20001f12, 0x0d091c55, 0x0a000304,   // pl.mt.un_750 cy.sq.un_640  mr.hi.ne_442 nl.pt.un_320
  // [1c40]
  0x030c0202, 0x210c35a0, 0x13001c04, 0x64043baf,   // da.sv.nl_222 zu.sv.jw_322  mr.bh.un_320 so.fi.lg_655
  0x0b1853ee, 0x556413af, 0x132921a0, 0x2a000704,   // ht.ga.es_422 et.lg.rw_655  jw.sl.et_322 it.mt.un_320
  0x1a101304, 0x180403a0, 0x1b6b0f04, 0x1707080c,   // et.lt.tl_332 nl.fi.ga_322  lv.ceb.tr_332 uk.bg.sr_543
  0x2d090d0d, 0x32000707, 0x31001704, 0x0c093ba0,   // cs.pl.sk_554 it.bs.un_420  sr.az.un_320 so.pl.sv_322
  // [1c50]
  0x0c0e3155, 0x1a683512, 0x091c1311, 0x23002104,   // az.is.sv_442 zu.ig.tl_654  bh.mr.hi_653 jw.ca.un_320
  0x1210010c, 0x2d0d3fa9, 0x25001013, 0x0a00170e,   // en.lt.hu_543 af.cs.sk_544  lt.eu.un_650 sr.mk.un_550
  0x06350e07, 0x080210ee, 0x0d022dec, 0x0b000c07,   // is.zu.de_432 lt.da.no_422  sk.da.cs_644 sv.es.un_420
  0x1e683b07, 0x023531a0, 0x09002107, 0x1a5535a4,   // so.ig.ms_432 az.zu.da_322  jw.pl.un_420 zu.rw.tl_433
  // [1c60]
  0x4a6e2804, 0x200f350c, 0x0e000104, 0x102835ad,   // sw.hmn.yo_332 zu.lv.sq_543  en.is.un_320 zu.sw.lt_643
  0x1e1c1a05, 0x55233b05, 0x120b0e0c, 0x0000320a,   // tl.id.ms_333 so.ca.rw_333  is.es.hu_543 bs.un.un_500
  0x31002007, 0x1b003509, 0x4a532907, 0x1a003b08,   // sq.az.un_420 zu.tr.un_440  sl.ht.yo_432 so.tl.un_430
  0x1e6b5305, 0x3b000d11, 0x04002812, 0x12643f04,   // ht.ceb.ms_333 cs.so.un_630  sw.fi.un_640 af.lg.hu_332
  // [1c70]
  0x11080405, 0x3f0e03af, 0x0a006b04, 0x082a0aa4,   // ru.uk.ro_333 nl.is.af_655  ceb.pt.un_320 pt.mt.no_433
  0x311a6b12, 0x53000d13, 0x04132dee, 0x0f6425ad,   // ceb.tl.az_654 cs.ht.un_650  sk.et.fi_422 eu.lg.lv_643
  0x1300110e, 0x102729ad, 0x13091cad, 0x08000302,   // ro.et.un_550 sl.gd.lt_643  mr.hi.bh_643 nl.no.un_220
  0x02001702, 0x29111604, 0x09101f08, 0x28005302,   // sr.da.un_220 hr.ro.sl_332  cy.lt.pl_443 ht.sw.un_220
  // [1c80]
  0x1e1c3fec, 0x646823a4, 0x0a002704, 0x13020fee,   // af.id.ms_644 ca.ig.lg_433  gd.pt.un_320 lv.da.et_422
  0x2100520e, 0x4a006402, 0x060c0e12, 0x08100302,   // ha.jw.un_550 lg.yo.un_220  is.sv.de_654 nl.lt.no_222
  0x050d53a0, 0x1c0d130c, 0x080c020d, 0x100807af,   // ht.cs.fr_322 bh.ne.mr_543  da.sv.no_554 bg.uk.be_655
  0x0a000b04, 0x1312110c, 0x23002721, 0x09030604,   // es.pt.un_320 ro.hu.et_543  gd.ca.un_860 de.nl.pl_332
  // [1c90]
  0x032d17a4, 0x033f6407, 0x0f1009a7, 0x686428ad,   // sr.sk.nl_433 lg.af.nl_432  pl.lt.lv_532 sw.lg.ig_643
  0x20001018, 0x066b03ee, 0x21081ca0, 0x1e100405,   // lt.sq.un_740 nl.ceb.de_422  id.no.jw_322 fi.lt.ms_333
  0x53000104, 0x016b0807, 0x050b1107, 0x07050aa9,   // en.ht.un_320 no.ceb.en_432  ro.es.fr_432 pt.fr.it_544
  0x3b001008, 0x01182004, 0x32002907, 0x01213ba0,   // lt.so.un_430 sq.ga.en_332  sl.bs.un_420 so.jw.en_322
  // [1ca0]
  0x3b003504, 0x35000d08, 0x1c130daf, 0x2d0d1005,   // zu.so.un_320 cs.zu.un_430  ne.bh.mr_655 lt.cs.sk_333
  0x52532705, 0x21282704, 0x27122802, 0x01000704,   // gd.ht.ha_333 gd.sw.jw_332  sw.hu.gd_222 it.en.un_320
  0x6b072da0, 0x08005307, 0x040605ac, 0x1f000813,   // sk.it.ceb_322 ht.no.un_420  fr.de.fi_632 no.cy.un_650
  0x0b192da4, 0x0a1b05ee, 0x012311ad, 0x6855530e,   // sk.gl.es_433 fr.tr.pt_422  ro.ca.en_643 ht.rw.ig_555
  // [1cb0]
  0x283f3504, 0x1a005214, 0x08000404, 0x09006402,   // zu.af.sw_332 ha.tl.un_660  ru.uk.un_320 lg.pl.un_220
  0x3f030605, 0x3b1a0ba0, 0x5308230c, 0x68000f09,   // de.nl.af_333 es.tl.so_322  ca.no.ht_543 lv.ig.un_440
  0x190f0b0c, 0x1a002113, 0x07006419, 0x23052da4,   // es.lv.gl_543 jw.tl.un_650  lg.it.un_750 sk.fr.ca_433
  0x042b200c, 0x0d2510ec, 0x686e0f55, 0x6b3555ad,   // sq.vi.fi_543 lt.eu.cs_644  lv.hmn.ig_442 rw.zu.ceb_643
  // [1cc0]
  0x1100171b, 0x190b07af, 0x033f530d, 0x17000a02,   // sr.ro.un_770 it.es.gl_655  ht.af.nl_554 mk.sr.un_220
  0x2500020e, 0x32160e04, 0x321729ad, 0x1a006812,   // da.eu.un_550 is.hr.bs_332  sl.sr.bs_643 ig.tl.un_640
  0x01070907, 0x060107ee, 0x275313af, 0x1f001812,   // pl.it.en_432 it.en.de_422  et.ht.gd_655 ga.cy.un_640
  0x27203b5a, 0x35006421, 0x64000407, 0x2d0d25ec,   // so.sq.gd_553 lg.zu.un_860  fi.lg.un_420 eu.cs.sk_644
  // [1cd0]
  0x130e10a7, 0x29001c04, 0x291664a0, 0x350b64a0,   // lt.is.et_532 id.sl.un_320  lg.hr.sl_322 lg.es.zu_322
  0x0e003b19, 0x08020eaf, 0x10001305, 0x1e1c12a4,   // so.is.un_750 is.da.no_655  et.lt.un_330 hu.id.ms_433
  0x3b4a3fee, 0x07006412, 0x10170812, 0x64001312,   // af.yo.so_422 lg.it.un_640  uk.sr.be_654 et.lg.un_640
  0x10292a04, 0x27003204, 0x3b6b5507, 0x2511050e,   // mt.sl.lt_332 bs.gd.un_320  rw.ceb.so_432 fr.ro.eu_555
  // [1ce0]
  0x1b4a550b, 0x550529a7, 0x2b0e55a0, 0x0d2a2d07,   // rw.yo.tr_542 sl.fr.rw_532  rw.is.vi_322 sk.mt.cs_432
  0x07250604, 0x11550b02, 0x201b2da0, 0x526401a4,   // de.eu.it_332 es.rw.ro_222  sk.tr.sq_322 en.lg.ha_433
  0x0c00640d, 0x3f0603ec, 0x16002507, 0x196e0a07,   // lg.sv.un_540 nl.de.af_644  eu.hr.un_420 pt.hmn.gl_432
  0x3b001318, 0x3217200c, 0x061b0302, 0x1e1c0805,   // et.so.un_740 sq.sr.bs_543  nl.tr.de_222 no.id.ms_333
  // [1cf0]
  0x285552ad, 0x08020cac, 0x1b0a0407, 0x321625ee,   // ha.rw.sw_643 sv.da.no_632  fi.pt.tr_432 eu.hr.bs_422
  0x0305530c, 0x4a1a5507, 0x100e02a6, 0x190b0aaf,   // ht.fr.nl_543 rw.tl.yo_432  da.is.lt_521 pt.es.gl_655
  0x1e001108, 0x130e0814, 0x2d0d0fa9, 0x32000e0b,   // ro.ms.un_430 no.is.et_666  lv.cs.sk_544 is.bs.un_520
  0x021a25a0, 0x11001005, 0x28532102, 0x11003504,   // eu.tl.da_322 be.ro.un_330  jw.ht.sw_222 zu.ro.un_320
  // [1d00]
  0x2d290d05, 0x6b0901ec, 0x1f00060e, 0x3f271f02,   // cs.sl.sk_333 en.pl.ceb_644  de.cy.un_550 cy.gd.af_222
  0x310e1b13, 0x321c64a0, 0x64000b02, 0x08006b07,   // tr.is.az_665 lg.id.bs_322  es.lg.un_220 ceb.no.un_420
  0x040e13a4, 0x19250b0c, 0x311b0505, 0x091f05a4,   // et.is.fi_433 es.eu.gl_543  fr.tr.az_333 fr.cy.pl_433
  0x09130d60, 0x09040555, 0x28552504, 0x1f006407,   // ne.bh.hi_664 fr.fi.pl_442  eu.rw.sw_332 lg.cy.un_420
  // [1d10]
  0x0f00130d, 0x6b000805, 0x171632a6, 0x64522aa9,   // et.lv.un_540 no.ceb.un_330  bs.hr.sr_521 mt.ha.lg_544
  0x215329ee, 0x1b550f11, 0x080211a6, 0x0f272512,   // sl.ht.jw_422 lv.rw.tr_653  ro.da.no_521 eu.gd.lv_654
  0x0e070807, 0x021b0808, 0x1a213b04, 0x29000b02,   // no.it.is_432 no.tr.da_443  so.jw.tl_332 es.sl.un_220
  0x0d0c1307, 0x04003113, 0x321753a0, 0x3f1a09a4,   // et.sv.cs_432 az.fi.un_650  ht.sr.bs_322 pl.tl.af_433
  // [1d20]
  0x351e2007, 0x183b2760, 0x35000804, 0x2a55530c,   // sq.ms.zu_432 gd.so.ga_664  no.zu.un_320 ht.rw.mt_543
  0x13005219, 0x18170ba0, 0x122508a0, 0x09005302,   // ha.et.un_750 es.sr.ga_322  no.eu.hu_322 ht.pl.un_220
  0x1f00210c, 0x06172007, 0x0b183102, 0x0a003b04,   // jw.cy.un_530 sq.sr.de_432  az.ga.es_222 so.pt.un_320
  0x25060fad, 0x080c0e02, 0x270e3bee, 0x2800270c,   // lv.de.eu_643 is.sv.no_222  so.is.gd_422 gd.sw.un_530
  // [1d30]
  0x1b2801a7, 0x29122d0c, 0x52280e08, 0x2517270c,   // en.sw.tr_532 sk.hu.sl_543  is.sw.ha_443 gd.sr.eu_543
  0x2d170d09, 0x6e2d1255, 0x01132855, 0x06030107,   // cs.sr.sk_444 hu.sk.hmn_442  sw.et.en_442 en.nl.de_432
  0x1e1c32a0, 0x09000108, 0x04070aa7, 0x28003f13,   // bs.id.ms_322 en.pl.un_430  mk.bg.ru_532 af.sw.un_650
  0x0b003505, 0x27001108, 0x10000104, 0x1e1c3ba9,   // zu.es.un_330 ro.gd.un_430  en.lt.un_320 so.id.ms_544
  // [1d40]
  0x312125ad, 0x0b2319a0, 0x09002a02, 0x011927a0,   // eu.jw.az_643 gl.ca.es_322  mt.pl.un_220 gd.gl.en_322
  0x0f1e35a0, 0x091c13ec, 0x3b280404, 0x04001e07,   // zu.ms.lv_322 bh.mr.hi_644  fi.sw.so_332 ms.fi.un_420
  0x293216a6, 0x090d1312, 0x1f003b1a, 0x1e1c35ee,   // hr.bs.sl_521 bh.ne.hi_654  so.cy.un_760 zu.id.ms_422
  0x20311c02, 0x3f3509a4, 0x09002304, 0x1c13090c,   // id.az.sq_222 pl.zu.af_433  ca.pl.un_320 hi.bh.mr_543
  // [1d50]
  0x271a1811, 0x2100060c, 0x130435a0, 0x19002b13,   // ga.tl.gd_653 de.jw.un_530  zu.fi.et_322 vi.gl.un_650
  0x190407ee, 0x64251ea0, 0x16122055, 0x31081ba4,   // it.fi.gl_422 ms.eu.lg_322  sq.hu.hr_442 tr.no.az_433
  0x1c645507, 0x64070407, 0x101352ad, 0x1a002913,   // rw.lg.id_432 fi.it.lg_432  ha.et.lt_643 sl.tl.un_650
  0x2d0d21a4, 0x3b522860, 0x35001814, 0x0c001602,   // jw.cs.sk_433 sw.ha.so_664  ga.zu.un_660 hr.sv.un_220
  // [1d60]
  0x08023fa4, 0x06106ba0, 0x20322aee, 0x3f001a12,   // af.da.no_433 ceb.lt.de_322  mt.bs.sq_422 tl.af.un_640
  0x322b16a0, 0x010335a0, 0x552164a0, 0x080b0a02,   // hr.vi.bs_322 zu.nl.en_322  lg.jw.rw_322 pt.es.no_222
  0x09320f04, 0x0820030c, 0x0d1c090c, 0x64532007,   // lv.bs.pl_332 nl.sq.no_543  hi.mr.ne_543 sq.ht.lg_432
  0x550728ee, 0x013f1aa0, 0x286429ee, 0x21002018,   // sw.it.rw_422 tl.af.en_322  sl.lg.sw_422 sq.jw.un_740
  // [1d70]
  0x17002007, 0x121009a4, 0x35532808, 0x061b3f12,   // sq.sr.un_420 pl.lt.hu_433  sw.ht.zu_443 af.tr.de_654
  0x643f55ec, 0x1e006412, 0x1c130909, 0x1b0a28a0,   // rw.af.lg_644 lg.ms.un_640  hi.bh.mr_444 sw.pt.tr_322
  0x08002102, 0x210b2055, 0x0a2d0d13, 0x35551aa4,   // jw.no.un_220 sq.es.jw_442  cs.sk.pt_665 tl.rw.zu_433
  0x19002a07, 0x0300010b, 0x02001308, 0x086410a7,   // mt.gl.un_420 en.nl.un_520  et.da.un_430 lt.lg.no_532
  // [1d80]
  0x354a0408, 0x2a000c04, 0x046410ee, 0x28133b07,   // fi.yo.zu_443 sv.mt.un_320  lt.lg.fi_422 so.et.sw_432
  0x21000302, 0x04000804, 0x05001214, 0x25005214,   // nl.jw.un_220 no.fi.un_320  hu.fr.un_660 ha.eu.un_660
  0x10040a0e, 0x18000412, 0x282164a4, 0x032a3ba0,   // mk.ru.be_555 fi.ga.un_640  lg.jw.sw_433 so.mt.nl_322
  0x3f271607, 0x321701a4, 0x2a0728ac, 0x29000914,   // hr.gd.af_432 en.sr.bs_433  sw.it.mt_632 pl.sl.un_660
  // [1d90]
  0x52006402, 0x52001118, 0x08023f07, 0x011911ee,   // lg.ha.un_220 ro.ha.un_740  af.da.no_432 ro.gl.en_422
  0x0d092d0c, 0x041213a0, 0x6b13010c, 0x050701a6,   // sk.pl.cs_543 et.hu.fi_322  en.et.ceb_543 en.it.fr_521
  0x35005302, 0x2b001112, 0x1a0401a0, 0x6b0501ad,   // ht.zu.un_220 ro.vi.un_640  en.fi.tl_322 en.fr.ceb_643
  0x3f00091a, 0x6b005505, 0x28001a02, 0x03001702,   // pl.af.un_760 rw.ceb.un_330  tl.sw.un_220 sr.nl.un_220
  // [1da0]
  0x17002911, 0x11002813, 0x081323ee, 0x16005504,   // sl.sr.un_630 sw.ro.un_650  ca.et.no_422 rw.hr.un_320
  0x32001e02, 0x0700130d, 0x256b4aad, 0x020c08a7,   // ms.bs.un_220 et.it.un_540  yo.ceb.eu_643 no.sv.da_532
  0x161e32a0, 0x0900280e, 0x1827130c, 0x132a3504,   // bs.ms.hr_322 sw.pl.un_550  et.gd.ga_543 zu.mt.et_332
  0x12002b18, 0x120420af, 0x52006e07, 0x2d0d3502,   // vi.hu.un_740 sq.fi.hu_655  hmn.ha.un_420 zu.cs.sk_222
  // [1db0]
  0x063f21ee, 0x5500091a, 0x55353f13, 0x55040112,   // jw.af.de_422 pl.rw.un_760  af.zu.rw_665 en.fi.rw_654
  0x1b230aec, 0x52250608, 0x23000104, 0x055316a0,   // pt.ca.tr_644 de.eu.ha_443  en.ca.un_320 hr.ht.fr_322
  0x0d2d05af, 0x17003204, 0x25211007, 0x0e002a09,   // fr.sk.cs_655 bs.sr.un_320  lt.jw.eu_432 mt.is.un_440
  0x0e2a3bee, 0x522a0502, 0x190a2502, 0x11000614,   // so.mt.is_422 fr.mt.ha_222  eu.pt.gl_222 de.ro.un_660
  // [1dc0]
  0x2a001909, 0x112705ee, 0x1f000d11, 0x642a10af,   // gl.mt.un_440 fr.gd.ro_422  cs.cy.un_630 lt.mt.lg_655
  0x32212aa0, 0x3b005202, 0x0b00120b, 0x01091b07,   // mt.jw.bs_322 ha.so.un_220  hu.es.un_520 tr.pl.en_432
  0x1b311fec, 0x102d20ee, 0x0b010aee, 0x03083f02,   // cy.az.tr_644 sq.sk.lt_422  pt.en.es_422 af.no.nl_222
  0x0f101e04, 0x55351104, 0x06043f02, 0x0a3504a6,   // ms.lt.lv_332 ro.zu.rw_332  af.fi.de_222 fi.zu.pt_521
  // [1dd0]
  0x21005313, 0x190b0702, 0x321720ee, 0x352164a6,   // ht.jw.un_650 it.es.gl_222  sq.sr.bs_422 lg.jw.zu_521
  0x06090112, 0x133f6408, 0x1c1309a4, 0x1b006418,   // en.pl.de_654 lg.af.et_443  hi.bh.mr_433 lg.tr.un_740
  0x3f643ba9, 0x1c005307, 0x29005204, 0x1e2835ac,   // so.lg.af_544 ht.id.un_420  ha.sl.un_320 zu.sw.ms_632
  0x6b1a08a0, 0x3f210604, 0x130c08ec, 0x05003b02,   // no.tl.ceb_322 de.jw.af_332  no.sv.et_644 so.fr.un_220
  // [1de0]
  0x131b04ec, 0x130420ad, 0x0e004a07, 0x1e1c1602,   // fi.tr.et_644 sq.fi.et_643  yo.is.un_420 hr.id.ms_222
  0x1b000508, 0x1b00040d, 0x2a0407ee, 0x233f530d,   // fr.tr.un_430 fi.tr.un_540  it.fi.mt_422 ht.af.ca_554
  0x230b25a4, 0x6b211005, 0x190528a4, 0x19050a55,   // eu.es.ca_433 lt.jw.ceb_333  sw.fr.gl_433 pt.fr.gl_442
  0x53021ea0, 0x20551107, 0x16112007, 0x283b18a0,   // ms.da.ht_322 ro.rw.sq_432  sq.ro.hr_432 ga.so.sw_322
  // [1df0]
  0x0600530c, 0x1b005512, 0x0d165307, 0x16001c07,   // ht.de.un_530 rw.tr.un_640  ht.hr.cs_432 id.hr.un_420
  0x27182b04, 0x13000404, 0x2a0c0408, 0x25133bee,   // vi.ga.gd_332 fi.et.un_320  fi.sv.mt_443 so.et.eu_422
  0x3b005304, 0x162911a4, 0x12000d08, 0x1c001212,   // ht.so.un_320 ro.sl.hr_433  cs.hu.un_430 hu.id.un_640
  0x3b684aee, 0x082505ad, 0x0c003b14, 0x051f52a9,   // yo.ig.so_422 fr.eu.no_643  so.sv.un_660 ha.cy.fr_544
  // [1e00]
  0x1f000512, 0x2a0406a9, 0x0c000108, 0x11003f07,   // fr.cy.un_640 de.fi.mt_544  en.sv.un_430 af.ro.un_420
  0x00001915, 0x0c521fa4, 0x19110a0d, 0x0a002018,   // gl.un.un_700 cy.ha.sv_433  pt.ro.gl_554 sq.pt.un_740
  0x0e1923ee, 0x2d2004af, 0x27315211, 0x06001707,   // ca.gl.is_422 fi.sq.sk_655  ha.az.gd_653 sr.de.un_420
  0x12203f09, 0x3b003f07, 0x316b0ead, 0x311b520e,   // af.sq.hu_444 af.so.un_420  is.ceb.az_643 ha.tr.az_555
  // [1e10]
  0x1e1c55a4, 0x0e005204, 0x10132509, 0x28004a0c,   // rw.id.ms_433 ha.is.un_320  eu.et.lt_444 yo.sw.un_530
  0x2a183b0b, 0x11000f12, 0x07181f12, 0x2d0d21a0,   // so.ga.mt_542 lv.ro.un_640  cy.ga.it_654 jw.cs.sk_322
  0x1b1606a4, 0x20522812, 0x014a29a7, 0x3b000e13,   // de.hr.tr_433 sw.ha.sq_654  sl.yo.en_532 is.so.un_650
  0x1c002504, 0x3f001812, 0x2a1a21a4, 0x08111714,   // eu.id.un_320 ga.af.un_640  jw.tl.mt_433 sr.ro.uk_666
  // [1e20]
  0x53214a55, 0x27006e18, 0x00001b01, 0x642506ad,   // yo.jw.ht_442 hmn.gd.un_740  tr.un.un_200 de.eu.lg_643
  0x0603250c, 0x06001813, 0x1306020d, 0x1e002a04,   // eu.nl.de_543 ga.de.un_650  da.de.et_554 mt.ms.un_320
  0x3b2501a0, 0x17080a13, 0x55001f12, 0x0c101f07,   // en.eu.so_322 mk.uk.sr_665  cy.rw.un_640 cy.lt.sv_432
  0x3f1b08a7, 0x13091c09, 0x0e282102, 0x190b0605,   // no.tr.af_532 mr.hi.bh_444  jw.sw.is_222 de.es.gl_333
  // [1e30]
  0x1a6b5507, 0x2d005504, 0x35006b04, 0x11003202,   // rw.ceb.tl_432 rw.sk.un_320  ceb.zu.un_320 bs.ro.un_220
  0x28553b5a, 0x0607250d, 0x1b2053a9, 0x286b310c,   // so.rw.sw_553 eu.it.de_554  ht.sq.tr_544 az.ceb.sw_543
  0x35091a07, 0x1632170c, 0x28001102, 0x12003f02,   // tl.pl.zu_432 sr.bs.hr_543  ro.sw.un_220 af.hu.un_220
  0x534a5507, 0x1b1112a4, 0x28006404, 0x530f05a0,   // rw.yo.ht_432 hu.ro.tr_433  lg.sw.un_320 fr.lv.ht_322
  // [1e40]
  0x25640c02, 0x190b1005, 0x07000112, 0x2a001904,   // sv.lg.eu_222 lt.es.gl_333  en.it.un_640 gl.mt.un_320
  0x0f1b2907, 0x071104a4, 0x130d0908, 0x072a1105,   // sl.tr.lv_432 ru.ro.bg_433  hi.ne.bh_443 ro.mt.it_333
  0x05000a0d, 0x201b29ec, 0x52001b09, 0x0f2512ad,   // pt.fr.un_540 sl.tr.sq_644  tr.ha.un_440 hu.eu.lv_643
  0x0c1b28ee, 0x0e00270d, 0x52002721, 0x2a351207,   // sw.tr.sv_422 gd.is.un_540  gd.ha.un_860 hu.zu.mt_432
  // [1e50]
  0x17080a05, 0x0a002b19, 0x100504a0, 0x0600130d,   // mk.uk.sr_333 vi.pt.un_750  fi.fr.lt_322 et.de.un_540
  0x27000e18, 0x322035a0, 0x3b003f13, 0x1209250b,   // is.gd.un_740 zu.sq.bs_322  af.so.un_650 eu.pl.hu_542
  0x520612ec, 0x0b0a23a9, 0x012b12a6, 0x3b001802,   // hu.de.ha_644 ca.pt.es_544  hu.vi.en_521 ga.so.un_220
  0x12001604, 0x13041ba4, 0x17160205, 0x52283508,   // hr.hu.un_320 tr.fi.et_433  da.hr.sr_333 zu.sw.ha_443
  // [1e60]
  0x1a0c0e07, 0x52000704, 0x0d1c09a7, 0x321629a9,   // is.sv.tl_432 it.ha.un_320  hi.mr.ne_532 sl.hr.bs_544
  0x1a001319, 0x190a2709, 0x05061005, 0x1f000c0d,   // et.tl.un_750 gd.pt.gl_444  lt.de.fr_333 sv.cy.un_540
  0x09002105, 0x5235550b, 0x0a190b07, 0x2d0d05a0,   // jw.pl.un_330 rw.zu.ha_542  es.gl.pt_432 fr.cs.sk_322
  0x2900520c, 0x1f000507, 0x05002904, 0x3b1252ee,   // ha.sl.un_530 fr.cy.un_420  sl.fr.un_320 ha.hu.so_422
  // [1e70]
  0x033f2804, 0x2d0d1609, 0x35002d08, 0x071004af,   // sw.af.nl_332 hr.cs.sk_444  sk.zu.un_430 fi.lt.it_655
  0x1e005304, 0x2d0d290e, 0x2500520e, 0x27000b04,   // ht.ms.un_320 sl.cs.sk_555  ha.eu.un_550 es.gd.un_320
  0x3f000a12, 0x10640f13, 0x19006405, 0x2d0920a9,   // pt.af.un_640 lv.lg.lt_665  lg.gl.un_330 sq.pl.sk_544
  0x0d280307, 0x3f006e04, 0x093f08a4, 0x20003518,   // nl.sw.cs_432 hmn.af.un_320  no.af.pl_433 zu.sq.un_740
  // [1e80]
  0x18001f04, 0x532a0a12, 0x27000619, 0x06002119,   // cy.ga.un_320 pt.mt.ht_654  de.gd.un_750 jw.de.un_750
  0x2a5264ad, 0x03092507, 0x21006b04, 0x28130107,   // lg.ha.mt_643 eu.pl.nl_432  ceb.jw.un_320 en.et.sw_432
  0x3f00640b, 0x0b522112, 0x0a000814, 0x0000281c,   // lg.af.un_520 jw.ha.es_654  uk.mk.un_660 sw.un.un_800
  0x5300640d, 0x641a3ba7, 0x0e003202, 0x0c1f1a0d,   // lg.ht.un_540 so.tl.lg_532  bs.is.un_220 tl.cy.sv_554
  // [1e90]
  0x190b13af, 0x28532055, 0x19050a07, 0x2b1f0611,   // et.es.gl_655 sq.ht.sw_442  pt.fr.gl_432 de.cy.vi_653
  0x112308ad, 0x0400010c, 0x08000a02, 0x230605af,   // no.ca.ro_643 en.fi.un_530  mk.uk.un_220 fr.de.ca_655
  0x172d0907, 0x042a1baf, 0x0b002512, 0x01250605,   // pl.sk.sr_432 tr.mt.fi_655  eu.es.un_640 de.eu.en_333
  0x321711a0, 0x6b3f2a07, 0x1c2501a0, 0x010d1f04,   // ro.sr.bs_322 mt.af.ceb_432  en.eu.id_322 cy.cs.en_332
  // [1ea0]
  0x1e006804, 0x20006e05, 0x4a2827a0, 0x25002a12,   // ig.ms.un_320 hmn.sq.un_330  gd.sw.yo_322 mt.eu.un_640
  0x082b0107, 0x13352108, 0x35005513, 0x0e000820,   // en.vi.no_432 jw.zu.et_443  rw.zu.un_650 no.is.un_850
  0x0400011a, 0x29320ca0, 0x0b110707, 0x0c000e13,   // en.fi.un_760 sv.bs.sl_322  it.ro.es_432 is.sv.un_650
  0x2d000a13, 0x211c0c07, 0x6e686b04, 0x0f6b02ec,   // pt.sk.un_650 sv.id.jw_432  ceb.ig.hmn_332 da.ceb.lv_644
  // [1eb0]
  0x3f0301a0, 0x4a535511, 0x4a0e2d07, 0x0a001022,   // en.nl.af_322 rw.ht.yo_653  sk.is.yo_432 be.mk.un_870
  0x28524a09, 0x100f1304, 0x6b1827ad, 0x311e2dad,   // yo.ha.sw_444 et.lv.lt_332  gd.ga.ceb_643 sk.ms.az_643
  0x27090804, 0x13003514, 0x1f3b2107, 0x6b6807a0,   // no.pl.gd_332 zu.et.un_660  jw.so.cy_432 it.ig.ceb_322
  0x182a2d11, 0x06001a08, 0x55003b1b, 0x08020eec,   // sk.mt.ga_653 tl.de.un_430  so.rw.un_770 is.da.no_644
  // [1ec0]
  0x0c253b04, 0x0e0a0ca4, 0x530c6b02, 0x535213ad,   // so.eu.sv_332 sv.pt.is_433  ceb.sv.ht_222 et.ha.ht_643
  0x29002d07, 0x27093b04, 0x271801af, 0x0a29230b,   // sk.sl.un_420 so.pl.gd_332  en.ga.gd_655 ca.sl.pt_542
  0x0b002505, 0x6400530e, 0x1e53100c, 0x11081013,   // eu.es.un_330 ht.lg.un_550  lt.ht.ms_543 be.uk.ro_665
  0x06021f07, 0x35001b0d, 0x190b11a4, 0x2a002908,   // cy.da.de_432 tr.zu.un_540  ro.es.gl_433 sl.mt.un_430
  // [1ed0]
  0x183552a0, 0x1e211c07, 0x013f2804, 0x101b2d07,   // ha.zu.ga_322 id.jw.ms_432  sw.af.en_332 sk.tr.lt_432
  0x1c211f04, 0x1c002d08, 0x12002d0c, 0x1b685204,   // cy.jw.id_332 sk.id.un_430  sk.hu.un_530 ha.ig.tr_332
  0x130f1004, 0x6b681aad, 0x091f1804, 0x2d00530c,   // lt.lv.et_332 tl.ig.ceb_643  ga.cy.pl_332 ht.sk.un_530
  0x0e280607, 0x091355ee, 0x0b523b0c, 0x3f00030b,   // de.sw.is_432 rw.et.pl_422  so.ha.es_543 nl.af.un_520
  // [1ee0]
  0x553506a4, 0x01001f0c, 0x1f2d0d0e, 0x0c0f050e,   // de.zu.rw_433 cy.en.un_530  cs.sk.cy_555 fr.lv.sv_555
  0x2a000e1a, 0x08021702, 0x18006414, 0x1e1c07ee,   // is.mt.un_760 sr.da.no_222  lg.ga.un_660 it.id.ms_422
  0x213f0313, 0x2900100c, 0x321620ec, 0x3b001f12,   // nl.af.jw_665 lt.sl.un_530  sq.hr.bs_644 cy.so.un_640
  0x08000104, 0x0e2a0c11, 0x20030107, 0x355513af,   // en.no.un_320 sv.mt.is_653  en.nl.sq_432 et.rw.zu_655
  // [1ef0]
  0x1a214a04, 0x0e003504, 0x08023107, 0x32290f07,   // yo.jw.tl_332 zu.is.un_320  az.da.no_432 lv.sl.bs_432
  0x190b230e, 0x03002904, 0x090c530c, 0x011a5302,   // ca.es.gl_555 sl.nl.un_320  ht.sv.pl_543 ht.tl.en_222
  0x113b0405, 0x250928a7, 0x0a05010c, 0x552a1b08,   // fi.so.ro_333 sw.pl.eu_532  en.fr.pt_543 tr.mt.rw_443
  0x19005309, 0x02252805, 0x2700230c, 0x3f1129a0,   // ht.gl.un_440 sw.eu.da_333  ca.gd.un_530 sl.ro.af_322
  // [1f00]
  0x070f0a04, 0x2a0e110c, 0x23010e09, 0x27180407,   // pt.lv.it_332 ro.is.mt_543  is.en.ca_444 fi.ga.gd_432
  0x1b002912, 0x080211a0, 0x20000512, 0x64203504,   // sl.tr.un_640 ro.da.no_322  fr.sq.un_640 zu.sq.lg_332
  0x1e1c52ec, 0x2300030e, 0x092d0dee, 0x0a000e13,   // ha.id.ms_644 nl.ca.un_550  cs.sk.pl_422 is.pt.un_650
  0x211c3bec, 0x2a006402, 0x25001107, 0x4a000414,   // so.id.jw_644 lg.mt.un_220  ro.eu.un_420 fi.yo.un_660
  // [1f10]
  0x1f050ca0, 0x3b002102, 0x643b1b07, 0x132d0855,   // sv.fr.cy_322 jw.so.un_220  tr.so.lg_432 no.sk.et_442
  0x27003513, 0x12080eaf, 0x32642a04, 0x172d20ee,   // zu.gd.un_650 is.no.hu_655  mt.lg.bs_332 sq.sk.sr_422
  0x052d2b12, 0x190b2da7, 0x2a210fee, 0x1e1c0c05,   // vi.sk.fr_654 sk.es.gl_532  lv.jw.mt_422 sv.id.ms_333
  0x1c001a02, 0x2d0d0502, 0x06002d0e, 0x35001c02,   // tl.id.un_220 fr.cs.sk_222  sk.de.un_550 id.zu.un_220
  // [1f20]
  0x1f1827af, 0x25070908, 0x081c6ba0, 0x020806ad,   // gd.ga.cy_655 pl.it.eu_443  ceb.id.no_322 de.no.da_643
  0x11002702, 0x29040d08, 0x130428a7, 0x08100a14,   // gd.ro.un_220 cs.fi.sl_443  sw.fi.et_532 mk.be.uk_666
  0x06000104, 0x0a000604, 0x21000104, 0x52004a14,   // en.de.un_320 de.pt.un_320  en.jw.un_320 yo.ha.un_660
  0x09131c12, 0x180127ec, 0x23006e19, 0x4a013502,   // mr.bh.hi_654 gd.en.ga_644  hmn.ca.un_750 zu.en.yo_222
  // [1f30]
  0x21002010, 0x1b2b250c, 0x101a040c, 0x07520ca0,   // sq.jw.un_620 eu.vi.tr_543  fi.tl.lt_543 sv.ha.it_322
  0x23006e0c, 0x0b00250c, 0x02004a04, 0x3f001705,   // hmn.ca.un_530 eu.es.un_530  yo.da.un_320 sr.af.un_330
  0x09133bee, 0x1f042014, 0x17164aa0, 0x07235207,   // so.et.pl_422 sq.fi.cy_666  yo.hr.sr_322 ha.ca.it_432
  0x086e06ad, 0x04000104, 0x293f3504, 0x52001a23,   // de.hmn.no_643 en.fi.un_320  zu.af.sl_332 tl.ha.un_880
  // [1f40]
  0x231929ee, 0x11001704, 0x53212312, 0x13172004,   // sl.gl.ca_422 sr.ro.un_320  ca.jw.ht_654 sq.sr.et_332
  0x3b353105, 0x02252a07, 0x17003b07, 0x3b002112,   // az.zu.so_333 mt.eu.da_432  so.sr.un_420 jw.so.un_640
  0x6b001b12, 0x0d292d07, 0x52001c02, 0x07102d02,   // tr.ceb.un_640 sk.sl.cs_432  id.ha.un_220 sk.lt.it_222
  0x08023fa0, 0x0c005202, 0x11133b07, 0x0c002d04,   // af.da.no_322 ha.sv.un_220  so.et.ro_432 sk.sv.un_320
  // [1f50]
  0x03000e12, 0x081031ee, 0x08001a04, 0x0f06120d,   // is.nl.un_640 az.lt.no_422  tl.no.un_320 hu.de.lv_554
  0x2d000b07, 0x08020405, 0x07001018, 0x3b002a19,   // es.sk.un_420 fi.da.no_333  be.bg.un_740 mt.so.un_750
  0x04000614, 0x20003b13, 0x08003205, 0x0c001905,   // de.fi.un_660 so.sq.un_650  bs.no.un_330 gl.sv.un_330
  0x04035504, 0x1c0913a9, 0x0d2d1260, 0x182720ad,   // rw.nl.fi_332 bh.hi.mr_544  hu.sk.cs_664 sq.gd.ga_643
  // [1f60]
  0x0b002302, 0x31001c02, 0x06233fad, 0x090d010c,   // ca.es.un_220 id.az.un_220  af.ca.de_643 en.cs.pl_543
  0x1c1e2b12, 0x062305a0, 0x0e1f6bee, 0x311b0807,   // vi.ms.id_654 fr.ca.de_322  ceb.cy.is_422 no.tr.az_432
  0x0d2d09a7, 0x68002d07, 0x2d0d12ec, 0x1e2721a0,   // pl.sk.cs_532 sk.ig.un_420  hu.cs.sk_644 jw.gd.ms_322
  0x21273bac, 0x20002b0c, 0x21181107, 0x01000c02,   // so.gd.jw_632 vi.sq.un_530  ro.ga.jw_432 sv.en.un_220
  // [1f70]
  0x2d0d1ba0, 0x29682dec, 0x3f001107, 0x08003b19,   // tr.cs.sk_322 sk.ig.sl_644  ro.af.un_420 so.no.un_750
  0x122d0a04, 0x0b002a05, 0x23556407, 0x13000304,   // pt.sk.hu_332 mt.es.un_330  lg.rw.ca_432 nl.et.un_320
  0x4a001908, 0x1103130c, 0x0a00080c, 0x0b003f11,   // gl.yo.un_430 et.nl.ro_543  uk.mk.un_530 af.es.un_630
  0x32201702, 0x2d0d28a6, 0x12006b04, 0x171209ee,   // sr.sq.bs_222 sw.cs.sk_521  ceb.hu.un_320 pl.hu.sr_422
  // [1f80]
  0x0c6b25a0, 0x02002102, 0x1e1306ee, 0x13000e04,   // eu.ceb.sv_322 jw.da.un_220  de.et.ms_422 is.et.un_320
  0x322813ad, 0x190b0a0c, 0x0c271802, 0x11000a1a,   // et.sw.bs_643 pt.es.gl_543  ga.gd.sv_222 mk.ro.un_760
  0x283525a9, 0x0e081bad, 0x6864350c, 0x04000a0b,   // eu.zu.sw_544 tr.no.is_643  zu.lg.ig_543 mk.ru.un_520
  0x072a1212, 0x52001704, 0x190b25a0, 0x2a0812ad,   // hu.mt.it_654 sr.ha.un_320  eu.es.gl_322 hu.no.mt_643
  // [1f90]
  0x27002105, 0x190527ad, 0x1f002b19, 0x35005207,   // jw.gd.un_330 gd.fr.gl_643  vi.cy.un_750 ha.zu.un_420
  0x1e1c20ec, 0x0d0f5508, 0x55005212, 0x23001f18,   // sq.id.ms_644 rw.lv.cs_443  ha.rw.un_640 cy.ca.un_740
  0x1100230c, 0x015255a0, 0x0e004a1a, 0x203b0607,   // ca.ro.un_530 rw.ha.en_322  yo.is.un_760 de.so.sq_432
  0x1b000704, 0x25040604, 0x025364ee, 0x35296ba0,   // it.tr.un_320 de.fi.eu_332  lg.ht.da_422 ceb.sl.zu_322
  // [1fa0] --- double_langprob_start=1fac ---
  0x04093bee, 0x2d160d0d, 0x25006402, 0x31000f18,   // so.pl.fi_422 cs.hr.sk_554  lg.eu.un_220 lv.az.un_740
  0x18003514, 0x011809a4, 0x01003f02, 0x042810a0,   // zu.ga.un_660 pl.ga.en_433  af.en.un_220 lt.sw.fi_322
  0x1f1b3fa4, 0x0e133f04, 0x1c006b04, 0x1f1809a4,   // af.tr.cy_433 af.et.is_332  ceb.id.un_320 pl.ga.cy_433
                                                    //
  };

//  COMPILE_ASSERT(8108 <= 8192, k_indirectbits_too_small);

extern const CLD2TableSummary kQuad_obj2 = {
  kQuadChrome0122_16_2,
  kQuadChrome0122_16_2Ind,
  kQuadChrome0122_16_2SizeOne,
  kQuadChrome0122_16_2Size,
  kQuadChrome0122_16_2KeyMask,
  kQuadChrome0122_16BuildDate,
  kQuadChrome0122_16RecognizedLangScripts,
};

}       // End namespace CLD2

// End of generated tables
